#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#ifdef _MSC_VER
#pragma optimize("", off)
#elif defined(__clang__)
#pragma clang optimize off
#elif defined(__GNUC__)
#pragma GCC optimize ("O0")
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 8441
#define LARGE_STATE_COUNT 2395
#define SYMBOL_COUNT 531
#define ALIAS_COUNT 5
#define TOKEN_COUNT 218
#define EXTERNAL_TOKEN_COUNT 2
#define FIELD_COUNT 50
#define MAX_ALIAS_SEQUENCE_LENGTH 9
#define PRODUCTION_ID_COUNT 217

enum ts_symbol_identifiers {
  sym_identifier = 1,
  aux_sym_preproc_include_token1 = 2,
  aux_sym_preproc_include_token2 = 3,
  aux_sym_preproc_def_token1 = 4,
  anon_sym_LPAREN = 5,
  anon_sym_DOT_DOT_DOT = 6,
  anon_sym_COMMA = 7,
  anon_sym_RPAREN = 8,
  aux_sym_preproc_if_token1 = 9,
  anon_sym_LF = 10,
  aux_sym_preproc_if_token2 = 11,
  aux_sym_preproc_ifdef_token1 = 12,
  aux_sym_preproc_ifdef_token2 = 13,
  aux_sym_preproc_else_token1 = 14,
  aux_sym_preproc_elif_token1 = 15,
  aux_sym_preproc_elifdef_token1 = 16,
  aux_sym_preproc_elifdef_token2 = 17,
  sym_preproc_arg = 18,
  sym_preproc_directive = 19,
  anon_sym_LPAREN2 = 20,
  anon_sym_defined = 21,
  anon_sym_BANG = 22,
  anon_sym_TILDE = 23,
  anon_sym_DASH = 24,
  anon_sym_PLUS = 25,
  anon_sym_STAR = 26,
  anon_sym_SLASH = 27,
  anon_sym_PERCENT = 28,
  anon_sym_PIPE_PIPE = 29,
  anon_sym_AMP_AMP = 30,
  anon_sym_PIPE = 31,
  anon_sym_CARET = 32,
  anon_sym_AMP = 33,
  anon_sym_EQ_EQ = 34,
  anon_sym_BANG_EQ = 35,
  anon_sym_GT = 36,
  anon_sym_GT_EQ = 37,
  anon_sym_LT_EQ = 38,
  anon_sym_LT = 39,
  anon_sym_LT_LT = 40,
  anon_sym_GT_GT = 41,
  anon_sym_SEMI = 42,
  anon_sym___extension__ = 43,
  anon_sym_typedef = 44,
  anon_sym_extern = 45,
  anon_sym___attribute__ = 46,
  anon_sym_COLON_COLON = 47,
  anon_sym_LBRACK_LBRACK = 48,
  anon_sym_RBRACK_RBRACK = 49,
  anon_sym___declspec = 50,
  anon_sym___based = 51,
  anon_sym___cdecl = 52,
  anon_sym___clrcall = 53,
  anon_sym___stdcall = 54,
  anon_sym___fastcall = 55,
  anon_sym___thiscall = 56,
  anon_sym___vectorcall = 57,
  sym_ms_restrict_modifier = 58,
  sym_ms_unsigned_ptr_modifier = 59,
  sym_ms_signed_ptr_modifier = 60,
  anon_sym__unaligned = 61,
  anon_sym___unaligned = 62,
  anon_sym_LBRACE = 63,
  anon_sym_RBRACE = 64,
  anon_sym_signed = 65,
  anon_sym_unsigned = 66,
  anon_sym_long = 67,
  anon_sym_short = 68,
  anon_sym_LBRACK = 69,
  anon_sym_RBRACK = 70,
  anon_sym_EQ = 71,
  anon_sym_static = 72,
  anon_sym_register = 73,
  anon_sym_inline = 74,
  anon_sym___inline = 75,
  anon_sym___inline__ = 76,
  anon_sym___forceinline = 77,
  anon_sym_thread_local = 78,
  anon_sym___thread = 79,
  anon_sym_const = 80,
  anon_sym_constexpr = 81,
  anon_sym_volatile = 82,
  anon_sym_restrict = 83,
  anon_sym___restrict__ = 84,
  anon_sym__Atomic = 85,
  anon_sym__Noreturn = 86,
  anon_sym_noreturn = 87,
  anon_sym_mutable = 88,
  anon_sym_constinit = 89,
  anon_sym_consteval = 90,
  anon_sym_PROGMEM = 91,
  aux_sym_primitive_type_token1 = 92,
  anon_sym_byte = 93,
  anon_sym_word = 94,
  anon_sym_enum = 95,
  anon_sym_class = 96,
  anon_sym_struct = 97,
  anon_sym_union = 98,
  anon_sym_COLON = 99,
  anon_sym_if = 100,
  anon_sym_else = 101,
  anon_sym_switch = 102,
  anon_sym_case = 103,
  anon_sym_default = 104,
  anon_sym_while = 105,
  anon_sym_do = 106,
  anon_sym_for = 107,
  anon_sym_return = 108,
  anon_sym_break = 109,
  anon_sym_continue = 110,
  anon_sym_goto = 111,
  anon_sym___try = 112,
  anon_sym___except = 113,
  anon_sym___finally = 114,
  anon_sym___leave = 115,
  anon_sym_QMARK = 116,
  anon_sym_STAR_EQ = 117,
  anon_sym_SLASH_EQ = 118,
  anon_sym_PERCENT_EQ = 119,
  anon_sym_PLUS_EQ = 120,
  anon_sym_DASH_EQ = 121,
  anon_sym_LT_LT_EQ = 122,
  anon_sym_GT_GT_EQ = 123,
  anon_sym_AMP_EQ = 124,
  anon_sym_CARET_EQ = 125,
  anon_sym_PIPE_EQ = 126,
  anon_sym_and_eq = 127,
  anon_sym_or_eq = 128,
  anon_sym_xor_eq = 129,
  anon_sym_not = 130,
  anon_sym_compl = 131,
  anon_sym_LT_EQ_GT = 132,
  anon_sym_or = 133,
  anon_sym_and = 134,
  anon_sym_bitor = 135,
  anon_sym_xor = 136,
  anon_sym_bitand = 137,
  anon_sym_not_eq = 138,
  anon_sym_DASH_DASH = 139,
  anon_sym_PLUS_PLUS = 140,
  anon_sym_sizeof = 141,
  anon_sym___alignof__ = 142,
  anon_sym___alignof = 143,
  anon_sym__alignof = 144,
  anon_sym_alignof = 145,
  anon_sym__Alignof = 146,
  anon_sym_offsetof = 147,
  anon_sym__Generic = 148,
  anon_sym_asm = 149,
  anon_sym___asm__ = 150,
  anon_sym_DOT = 151,
  anon_sym_DOT_STAR = 152,
  anon_sym_DASH_GT = 153,
  aux_sym_number_literal_token1 = 154,
  aux_sym_number_literal_token2 = 155,
  anon_sym_L_SQUOTE = 156,
  anon_sym_u_SQUOTE = 157,
  anon_sym_U_SQUOTE = 158,
  anon_sym_u8_SQUOTE = 159,
  anon_sym_SQUOTE = 160,
  aux_sym_char_literal_token1 = 161,
  anon_sym_L_DQUOTE = 162,
  anon_sym_u_DQUOTE = 163,
  anon_sym_U_DQUOTE = 164,
  anon_sym_u8_DQUOTE = 165,
  anon_sym_DQUOTE = 166,
  aux_sym_string_literal_token1 = 167,
  sym_escape_sequence = 168,
  sym_system_lib_string = 169,
  sym_true = 170,
  sym_false = 171,
  anon_sym_NULL = 172,
  anon_sym_nullptr = 173,
  sym_comment = 174,
  sym_auto = 175,
  anon_sym_decltype = 176,
  anon_sym_final = 177,
  anon_sym_override = 178,
  anon_sym_virtual = 179,
  anon_sym_alignas = 180,
  anon_sym_explicit = 181,
  anon_sym_typename = 182,
  anon_sym_template = 183,
  anon_sym_GT2 = 184,
  anon_sym_operator = 185,
  anon_sym_try = 186,
  anon_sym_delete = 187,
  anon_sym_0 = 188,
  anon_sym_friend = 189,
  anon_sym_public = 190,
  anon_sym_private = 191,
  anon_sym_protected = 192,
  anon_sym_noexcept = 193,
  anon_sym_throw = 194,
  anon_sym_namespace = 195,
  anon_sym_using = 196,
  anon_sym_static_assert = 197,
  anon_sym_concept = 198,
  anon_sym_co_return = 199,
  anon_sym_co_yield = 200,
  anon_sym_catch = 201,
  anon_sym_R_DQUOTE = 202,
  anon_sym_LR_DQUOTE = 203,
  anon_sym_uR_DQUOTE = 204,
  anon_sym_UR_DQUOTE = 205,
  anon_sym_u8R_DQUOTE = 206,
  anon_sym_co_await = 207,
  anon_sym_new = 208,
  anon_sym_requires = 209,
  anon_sym_DASH_GT_STAR = 210,
  anon_sym_LPAREN_RPAREN = 211,
  anon_sym_LBRACK_RBRACK = 212,
  anon_sym_DQUOTE_DQUOTE = 213,
  sym_this = 214,
  sym_literal_suffix = 215,
  sym_raw_string_delimiter = 216,
  sym_raw_string_content = 217,
  sym_translation_unit = 218,
  sym_preproc_include = 219,
  sym_preproc_def = 220,
  sym_preproc_function_def = 221,
  sym_preproc_params = 222,
  sym_preproc_call = 223,
  sym_preproc_if = 224,
  sym_preproc_ifdef = 225,
  sym_preproc_else = 226,
  sym_preproc_elif = 227,
  sym_preproc_elifdef = 228,
  sym_preproc_if_in_field_declaration_list = 229,
  sym_preproc_ifdef_in_field_declaration_list = 230,
  sym_preproc_else_in_field_declaration_list = 231,
  sym_preproc_elif_in_field_declaration_list = 232,
  sym_preproc_elifdef_in_field_declaration_list = 233,
  sym_preproc_if_in_enumerator_list = 234,
  sym_preproc_ifdef_in_enumerator_list = 235,
  sym_preproc_else_in_enumerator_list = 236,
  sym_preproc_elif_in_enumerator_list = 237,
  sym_preproc_elifdef_in_enumerator_list = 238,
  sym_preproc_if_in_enumerator_list_no_comma = 239,
  sym_preproc_ifdef_in_enumerator_list_no_comma = 240,
  sym_preproc_else_in_enumerator_list_no_comma = 241,
  sym_preproc_elif_in_enumerator_list_no_comma = 242,
  sym_preproc_elifdef_in_enumerator_list_no_comma = 243,
  sym__preproc_expression = 244,
  sym_preproc_parenthesized_expression = 245,
  sym_preproc_defined = 246,
  sym_preproc_unary_expression = 247,
  sym_preproc_call_expression = 248,
  sym_preproc_argument_list = 249,
  sym_preproc_binary_expression = 250,
  sym_function_definition = 251,
  sym_declaration = 252,
  sym_type_definition = 253,
  sym__type_definition_type = 254,
  sym__type_definition_declarators = 255,
  sym__declaration_modifiers = 256,
  sym__declaration_specifiers = 257,
  sym_linkage_specification = 258,
  sym_attribute_specifier = 259,
  sym_attribute = 260,
  sym_attribute_declaration = 261,
  sym_ms_declspec_modifier = 262,
  sym_ms_based_modifier = 263,
  sym_ms_call_modifier = 264,
  sym_ms_unaligned_ptr_modifier = 265,
  sym_ms_pointer_modifier = 266,
  sym_declaration_list = 267,
  sym__declarator = 268,
  sym__field_declarator = 269,
  sym__type_declarator = 270,
  sym__abstract_declarator = 271,
  sym_parenthesized_declarator = 272,
  sym_parenthesized_field_declarator = 273,
  sym_parenthesized_type_declarator = 274,
  sym_abstract_parenthesized_declarator = 275,
  sym_attributed_declarator = 276,
  sym_attributed_field_declarator = 277,
  sym_attributed_type_declarator = 278,
  sym_pointer_declarator = 279,
  sym_pointer_field_declarator = 280,
  sym_pointer_type_declarator = 281,
  sym_abstract_pointer_declarator = 282,
  sym_function_declarator = 283,
  sym_function_field_declarator = 284,
  sym_function_type_declarator = 285,
  sym_abstract_function_declarator = 286,
  sym_array_declarator = 287,
  sym_array_field_declarator = 288,
  sym_array_type_declarator = 289,
  sym_abstract_array_declarator = 290,
  sym_init_declarator = 291,
  sym_compound_statement = 292,
  sym_storage_class_specifier = 293,
  sym_type_qualifier = 294,
  sym__type_specifier = 295,
  sym_sized_type_specifier = 296,
  sym_primitive_type = 297,
  sym_enum_specifier = 298,
  sym_enumerator_list = 299,
  sym_struct_specifier = 300,
  sym_union_specifier = 301,
  sym_field_declaration_list = 302,
  sym__field_declaration_list_item = 303,
  sym_field_declaration = 304,
  sym_bitfield_clause = 305,
  sym_enumerator = 306,
  sym_parameter_list = 307,
  sym_parameter_declaration = 308,
  sym_attributed_statement = 309,
  sym_labeled_statement = 310,
  sym__top_level_expression_statement = 311,
  sym_expression_statement = 312,
  sym_if_statement = 313,
  sym_else_clause = 314,
  sym_switch_statement = 315,
  sym_case_statement = 316,
  sym_while_statement = 317,
  sym_do_statement = 318,
  sym_for_statement = 319,
  sym__for_statement_body = 320,
  sym_return_statement = 321,
  sym_break_statement = 322,
  sym_continue_statement = 323,
  sym_goto_statement = 324,
  sym_seh_try_statement = 325,
  sym_seh_except_clause = 326,
  sym_seh_finally_clause = 327,
  sym_seh_leave_statement = 328,
  sym__expression = 329,
  sym__expression_not_binary = 330,
  sym__string = 331,
  sym_comma_expression = 332,
  sym_conditional_expression = 333,
  sym_assignment_expression = 334,
  sym_pointer_expression = 335,
  sym_unary_expression = 336,
  sym_binary_expression = 337,
  sym_update_expression = 338,
  sym_cast_expression = 339,
  sym_type_descriptor = 340,
  sym_sizeof_expression = 341,
  sym_alignof_expression = 342,
  sym_offsetof_expression = 343,
  sym_generic_expression = 344,
  sym_subscript_expression = 345,
  sym_call_expression = 346,
  sym_gnu_asm_expression = 347,
  sym_gnu_asm_qualifier = 348,
  sym_gnu_asm_output_operand_list = 349,
  sym_gnu_asm_output_operand = 350,
  sym_gnu_asm_input_operand_list = 351,
  sym_gnu_asm_input_operand = 352,
  sym_gnu_asm_clobber_list = 353,
  sym_gnu_asm_goto_list = 354,
  sym_argument_list = 355,
  sym_field_expression = 356,
  sym_compound_literal_expression = 357,
  sym_parenthesized_expression = 358,
  sym_initializer_list = 359,
  sym_initializer_pair = 360,
  sym_subscript_designator = 361,
  sym_subscript_range_designator = 362,
  sym_field_designator = 363,
  sym_number_literal = 364,
  sym_char_literal = 365,
  sym_concatenated_string = 366,
  sym_string_literal = 367,
  sym_null = 368,
  sym__empty_declaration = 369,
  sym_placeholder_type_specifier = 370,
  sym_decltype_auto = 371,
  sym_decltype = 372,
  sym__class_declaration = 373,
  sym__class_declaration_item = 374,
  sym_class_specifier = 375,
  sym__class_name = 376,
  sym_virtual_specifier = 377,
  sym_virtual = 378,
  sym_alignas_specifier = 379,
  sym_explicit_function_specifier = 380,
  sym_base_class_clause = 381,
  sym__enum_base_clause = 382,
  sym_dependent_type = 383,
  sym_template_declaration = 384,
  sym_template_instantiation = 385,
  sym_template_parameter_list = 386,
  sym_type_parameter_declaration = 387,
  sym_variadic_type_parameter_declaration = 388,
  sym_optional_type_parameter_declaration = 389,
  sym_template_template_parameter_declaration = 390,
  sym_optional_parameter_declaration = 391,
  sym_variadic_parameter_declaration = 392,
  sym_variadic_declarator = 393,
  sym_variadic_reference_declarator = 394,
  sym_operator_cast = 395,
  sym_field_initializer_list = 396,
  sym_field_initializer = 397,
  sym_inline_method_definition = 398,
  sym__constructor_specifiers = 399,
  sym_operator_cast_definition = 400,
  sym_operator_cast_declaration = 401,
  sym_constructor_try_statement = 402,
  sym_constructor_or_destructor_definition = 403,
  sym_constructor_or_destructor_declaration = 404,
  sym_default_method_clause = 405,
  sym_delete_method_clause = 406,
  sym_pure_virtual_clause = 407,
  sym_friend_declaration = 408,
  sym_access_specifier = 409,
  sym_reference_declarator = 410,
  sym_reference_field_declarator = 411,
  sym_reference_type_declarator = 412,
  sym_abstract_reference_declarator = 413,
  sym_structured_binding_declarator = 414,
  sym_ref_qualifier = 415,
  sym__function_declarator_seq = 416,
  sym__function_attributes_start = 417,
  sym__function_exception_specification = 418,
  sym__function_attributes_end = 419,
  sym__function_postfix = 420,
  sym_trailing_return_type = 421,
  sym_noexcept = 422,
  sym_throw_specifier = 423,
  sym_template_type = 424,
  sym_template_method = 425,
  sym_template_function = 426,
  sym_template_argument_list = 427,
  sym_namespace_definition = 428,
  sym_namespace_alias_definition = 429,
  sym__namespace_specifier = 430,
  sym_nested_namespace_specifier = 431,
  sym_using_declaration = 432,
  sym_alias_declaration = 433,
  sym_static_assert_declaration = 434,
  sym_concept_definition = 435,
  sym_for_range_loop = 436,
  sym__for_range_loop_body = 437,
  sym_init_statement = 438,
  sym_condition_clause = 439,
  sym_condition_declaration = 440,
  sym_co_return_statement = 441,
  sym_co_yield_statement = 442,
  sym_throw_statement = 443,
  sym_try_statement = 444,
  sym_catch_clause = 445,
  sym_raw_string_literal = 446,
  sym_subscript_argument_list = 447,
  sym_co_await_expression = 448,
  sym_new_expression = 449,
  sym_new_declarator = 450,
  sym_delete_expression = 451,
  sym_type_requirement = 452,
  sym_compound_requirement = 453,
  sym__requirement = 454,
  sym_requirement_seq = 455,
  sym_constraint_conjunction = 456,
  sym_constraint_disjunction = 457,
  sym__requirement_clause_constraint = 458,
  sym_requires_clause = 459,
  sym_requires_parameter_list = 460,
  sym_requires_expression = 461,
  sym_lambda_expression = 462,
  sym_lambda_capture_specifier = 463,
  sym_lambda_default_capture = 464,
  sym__fold_operator = 465,
  sym__binary_fold_operator = 466,
  sym__unary_left_fold = 467,
  sym__unary_right_fold = 468,
  sym__binary_fold = 469,
  sym_fold_expression = 470,
  sym_parameter_pack_expansion = 471,
  sym_type_parameter_pack_expansion = 472,
  sym_destructor_name = 473,
  sym_dependent_identifier = 474,
  sym_dependent_field_identifier = 475,
  sym_dependent_type_identifier = 476,
  sym__scope_resolution = 477,
  sym_qualified_field_identifier = 478,
  sym_qualified_identifier = 479,
  sym_qualified_type_identifier = 480,
  sym_qualified_operator_cast_identifier = 481,
  sym__assignment_expression_lhs = 482,
  sym_operator_name = 483,
  sym_user_defined_literal = 484,
  aux_sym_translation_unit_repeat1 = 485,
  aux_sym_preproc_params_repeat1 = 486,
  aux_sym_preproc_if_repeat1 = 487,
  aux_sym_preproc_if_in_field_declaration_list_repeat1 = 488,
  aux_sym_preproc_if_in_enumerator_list_repeat1 = 489,
  aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1 = 490,
  aux_sym_preproc_argument_list_repeat1 = 491,
  aux_sym_declaration_repeat1 = 492,
  aux_sym_type_definition_repeat1 = 493,
  aux_sym__type_definition_type_repeat1 = 494,
  aux_sym__type_definition_declarators_repeat1 = 495,
  aux_sym__declaration_specifiers_repeat1 = 496,
  aux_sym_attribute_declaration_repeat1 = 497,
  aux_sym_attributed_declarator_repeat1 = 498,
  aux_sym_pointer_declarator_repeat1 = 499,
  aux_sym_sized_type_specifier_repeat1 = 500,
  aux_sym_enumerator_list_repeat1 = 501,
  aux_sym_field_declaration_repeat1 = 502,
  aux_sym_parameter_list_repeat1 = 503,
  aux_sym_case_statement_repeat1 = 504,
  aux_sym_generic_expression_repeat1 = 505,
  aux_sym_gnu_asm_expression_repeat1 = 506,
  aux_sym_gnu_asm_output_operand_list_repeat1 = 507,
  aux_sym_gnu_asm_input_operand_list_repeat1 = 508,
  aux_sym_gnu_asm_clobber_list_repeat1 = 509,
  aux_sym_gnu_asm_goto_list_repeat1 = 510,
  aux_sym_argument_list_repeat1 = 511,
  aux_sym_initializer_list_repeat1 = 512,
  aux_sym_initializer_pair_repeat1 = 513,
  aux_sym_char_literal_repeat1 = 514,
  aux_sym_concatenated_string_repeat1 = 515,
  aux_sym_string_literal_repeat1 = 516,
  aux_sym__class_declaration_repeat1 = 517,
  aux_sym_base_class_clause_repeat1 = 518,
  aux_sym_template_parameter_list_repeat1 = 519,
  aux_sym_field_initializer_list_repeat1 = 520,
  aux_sym_operator_cast_definition_repeat1 = 521,
  aux_sym_constructor_try_statement_repeat1 = 522,
  aux_sym_structured_binding_declarator_repeat1 = 523,
  aux_sym__function_postfix_repeat1 = 524,
  aux_sym_throw_specifier_repeat1 = 525,
  aux_sym_template_argument_list_repeat1 = 526,
  aux_sym_subscript_argument_list_repeat1 = 527,
  aux_sym_requirement_seq_repeat1 = 528,
  aux_sym_requires_parameter_list_repeat1 = 529,
  aux_sym_lambda_capture_specifier_repeat1 = 530,
  alias_sym_field_identifier = 531,
  alias_sym_namespace_identifier = 532,
  alias_sym_simple_requirement = 533,
  alias_sym_statement_identifier = 534,
  alias_sym_type_identifier = 535,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [aux_sym_preproc_include_token1] = "#include",
  [aux_sym_preproc_include_token2] = "preproc_include_token2",
  [aux_sym_preproc_def_token1] = "#define",
  [anon_sym_LPAREN] = "(",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_COMMA] = ",",
  [anon_sym_RPAREN] = ")",
  [aux_sym_preproc_if_token1] = "#if",
  [anon_sym_LF] = "\n",
  [aux_sym_preproc_if_token2] = "#endif",
  [aux_sym_preproc_ifdef_token1] = "#ifdef",
  [aux_sym_preproc_ifdef_token2] = "#ifndef",
  [aux_sym_preproc_else_token1] = "#else",
  [aux_sym_preproc_elif_token1] = "#elif",
  [aux_sym_preproc_elifdef_token1] = "#elifdef",
  [aux_sym_preproc_elifdef_token2] = "#elifndef",
  [sym_preproc_arg] = "preproc_arg",
  [sym_preproc_directive] = "preproc_directive",
  [anon_sym_LPAREN2] = "(",
  [anon_sym_defined] = "defined",
  [anon_sym_BANG] = "!",
  [anon_sym_TILDE] = "~",
  [anon_sym_DASH] = "-",
  [anon_sym_PLUS] = "+",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE] = "|",
  [anon_sym_CARET] = "^",
  [anon_sym_AMP] = "&",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_GT] = ">",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_LT] = "<",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_SEMI] = ";",
  [anon_sym___extension__] = "__extension__",
  [anon_sym_typedef] = "typedef",
  [anon_sym_extern] = "extern",
  [anon_sym___attribute__] = "__attribute__",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_LBRACK_LBRACK] = "[[",
  [anon_sym_RBRACK_RBRACK] = "]]",
  [anon_sym___declspec] = "__declspec",
  [anon_sym___based] = "__based",
  [anon_sym___cdecl] = "__cdecl",
  [anon_sym___clrcall] = "__clrcall",
  [anon_sym___stdcall] = "__stdcall",
  [anon_sym___fastcall] = "__fastcall",
  [anon_sym___thiscall] = "__thiscall",
  [anon_sym___vectorcall] = "__vectorcall",
  [sym_ms_restrict_modifier] = "ms_restrict_modifier",
  [sym_ms_unsigned_ptr_modifier] = "ms_unsigned_ptr_modifier",
  [sym_ms_signed_ptr_modifier] = "ms_signed_ptr_modifier",
  [anon_sym__unaligned] = "_unaligned",
  [anon_sym___unaligned] = "__unaligned",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_signed] = "signed",
  [anon_sym_unsigned] = "unsigned",
  [anon_sym_long] = "long",
  [anon_sym_short] = "short",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_EQ] = "=",
  [anon_sym_static] = "static",
  [anon_sym_register] = "register",
  [anon_sym_inline] = "inline",
  [anon_sym___inline] = "__inline",
  [anon_sym___inline__] = "__inline__",
  [anon_sym___forceinline] = "__forceinline",
  [anon_sym_thread_local] = "thread_local",
  [anon_sym___thread] = "__thread",
  [anon_sym_const] = "const",
  [anon_sym_constexpr] = "constexpr",
  [anon_sym_volatile] = "volatile",
  [anon_sym_restrict] = "restrict",
  [anon_sym___restrict__] = "__restrict__",
  [anon_sym__Atomic] = "_Atomic",
  [anon_sym__Noreturn] = "_Noreturn",
  [anon_sym_noreturn] = "noreturn",
  [anon_sym_mutable] = "mutable",
  [anon_sym_constinit] = "constinit",
  [anon_sym_consteval] = "consteval",
  [anon_sym_PROGMEM] = "PROGMEM",
  [aux_sym_primitive_type_token1] = "primitive_type_token1",
  [anon_sym_byte] = "byte",
  [anon_sym_word] = "word",
  [anon_sym_enum] = "enum",
  [anon_sym_class] = "class",
  [anon_sym_struct] = "struct",
  [anon_sym_union] = "union",
  [anon_sym_COLON] = ":",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [anon_sym_switch] = "switch",
  [anon_sym_case] = "case",
  [anon_sym_default] = "default",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_for] = "for",
  [anon_sym_return] = "return",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_goto] = "goto",
  [anon_sym___try] = "__try",
  [anon_sym___except] = "__except",
  [anon_sym___finally] = "__finally",
  [anon_sym___leave] = "__leave",
  [anon_sym_QMARK] = "\?",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_and_eq] = "and_eq",
  [anon_sym_or_eq] = "or_eq",
  [anon_sym_xor_eq] = "xor_eq",
  [anon_sym_not] = "not",
  [anon_sym_compl] = "compl",
  [anon_sym_LT_EQ_GT] = "<=>",
  [anon_sym_or] = "or",
  [anon_sym_and] = "and",
  [anon_sym_bitor] = "bitor",
  [anon_sym_xor] = "xor",
  [anon_sym_bitand] = "bitand",
  [anon_sym_not_eq] = "not_eq",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_sizeof] = "sizeof",
  [anon_sym___alignof__] = "__alignof__",
  [anon_sym___alignof] = "__alignof",
  [anon_sym__alignof] = "_alignof",
  [anon_sym_alignof] = "alignof",
  [anon_sym__Alignof] = "_Alignof",
  [anon_sym_offsetof] = "offsetof",
  [anon_sym__Generic] = "_Generic",
  [anon_sym_asm] = "asm",
  [anon_sym___asm__] = "__asm__",
  [anon_sym_DOT] = ".",
  [anon_sym_DOT_STAR] = ".*",
  [anon_sym_DASH_GT] = "->",
  [aux_sym_number_literal_token1] = "number_literal_token1",
  [aux_sym_number_literal_token2] = "number_literal_token2",
  [anon_sym_L_SQUOTE] = "L'",
  [anon_sym_u_SQUOTE] = "u'",
  [anon_sym_U_SQUOTE] = "U'",
  [anon_sym_u8_SQUOTE] = "u8'",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_char_literal_token1] = "character",
  [anon_sym_L_DQUOTE] = "L\"",
  [anon_sym_u_DQUOTE] = "u\"",
  [anon_sym_U_DQUOTE] = "U\"",
  [anon_sym_u8_DQUOTE] = "u8\"",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_string_literal_token1] = "string_content",
  [sym_escape_sequence] = "escape_sequence",
  [sym_system_lib_string] = "system_lib_string",
  [sym_true] = "true",
  [sym_false] = "false",
  [anon_sym_NULL] = "NULL",
  [anon_sym_nullptr] = "nullptr",
  [sym_comment] = "comment",
  [sym_auto] = "auto",
  [anon_sym_decltype] = "decltype",
  [anon_sym_final] = "final",
  [anon_sym_override] = "override",
  [anon_sym_virtual] = "virtual",
  [anon_sym_alignas] = "alignas",
  [anon_sym_explicit] = "explicit",
  [anon_sym_typename] = "typename",
  [anon_sym_template] = "template",
  [anon_sym_GT2] = ">",
  [anon_sym_operator] = "operator",
  [anon_sym_try] = "try",
  [anon_sym_delete] = "delete",
  [anon_sym_0] = "0",
  [anon_sym_friend] = "friend",
  [anon_sym_public] = "public",
  [anon_sym_private] = "private",
  [anon_sym_protected] = "protected",
  [anon_sym_noexcept] = "noexcept",
  [anon_sym_throw] = "throw",
  [anon_sym_namespace] = "namespace",
  [anon_sym_using] = "using",
  [anon_sym_static_assert] = "static_assert",
  [anon_sym_concept] = "concept",
  [anon_sym_co_return] = "co_return",
  [anon_sym_co_yield] = "co_yield",
  [anon_sym_catch] = "catch",
  [anon_sym_R_DQUOTE] = "R\"",
  [anon_sym_LR_DQUOTE] = "LR\"",
  [anon_sym_uR_DQUOTE] = "uR\"",
  [anon_sym_UR_DQUOTE] = "UR\"",
  [anon_sym_u8R_DQUOTE] = "u8R\"",
  [anon_sym_co_await] = "co_await",
  [anon_sym_new] = "new",
  [anon_sym_requires] = "requires",
  [anon_sym_DASH_GT_STAR] = "->*",
  [anon_sym_LPAREN_RPAREN] = "()",
  [anon_sym_LBRACK_RBRACK] = "[]",
  [anon_sym_DQUOTE_DQUOTE] = "\"\"",
  [sym_this] = "this",
  [sym_literal_suffix] = "literal_suffix",
  [sym_raw_string_delimiter] = "raw_string_delimiter",
  [sym_raw_string_content] = "raw_string_content",
  [sym_translation_unit] = "translation_unit",
  [sym_preproc_include] = "preproc_include",
  [sym_preproc_def] = "preproc_def",
  [sym_preproc_function_def] = "preproc_function_def",
  [sym_preproc_params] = "preproc_params",
  [sym_preproc_call] = "preproc_call",
  [sym_preproc_if] = "preproc_if",
  [sym_preproc_ifdef] = "preproc_ifdef",
  [sym_preproc_else] = "preproc_else",
  [sym_preproc_elif] = "preproc_elif",
  [sym_preproc_elifdef] = "preproc_elifdef",
  [sym_preproc_if_in_field_declaration_list] = "preproc_if",
  [sym_preproc_ifdef_in_field_declaration_list] = "preproc_ifdef",
  [sym_preproc_else_in_field_declaration_list] = "preproc_else",
  [sym_preproc_elif_in_field_declaration_list] = "preproc_elif",
  [sym_preproc_elifdef_in_field_declaration_list] = "preproc_elifdef",
  [sym_preproc_if_in_enumerator_list] = "preproc_if",
  [sym_preproc_ifdef_in_enumerator_list] = "preproc_ifdef",
  [sym_preproc_else_in_enumerator_list] = "preproc_else",
  [sym_preproc_elif_in_enumerator_list] = "preproc_elif",
  [sym_preproc_elifdef_in_enumerator_list] = "preproc_elifdef",
  [sym_preproc_if_in_enumerator_list_no_comma] = "preproc_if",
  [sym_preproc_ifdef_in_enumerator_list_no_comma] = "preproc_ifdef",
  [sym_preproc_else_in_enumerator_list_no_comma] = "preproc_else",
  [sym_preproc_elif_in_enumerator_list_no_comma] = "preproc_elif",
  [sym_preproc_elifdef_in_enumerator_list_no_comma] = "preproc_elifdef",
  [sym__preproc_expression] = "_preproc_expression",
  [sym_preproc_parenthesized_expression] = "parenthesized_expression",
  [sym_preproc_defined] = "preproc_defined",
  [sym_preproc_unary_expression] = "unary_expression",
  [sym_preproc_call_expression] = "call_expression",
  [sym_preproc_argument_list] = "argument_list",
  [sym_preproc_binary_expression] = "binary_expression",
  [sym_function_definition] = "function_definition",
  [sym_declaration] = "declaration",
  [sym_type_definition] = "type_definition",
  [sym__type_definition_type] = "_type_definition_type",
  [sym__type_definition_declarators] = "_type_definition_declarators",
  [sym__declaration_modifiers] = "_declaration_modifiers",
  [sym__declaration_specifiers] = "_declaration_specifiers",
  [sym_linkage_specification] = "linkage_specification",
  [sym_attribute_specifier] = "attribute_specifier",
  [sym_attribute] = "attribute",
  [sym_attribute_declaration] = "attribute_declaration",
  [sym_ms_declspec_modifier] = "ms_declspec_modifier",
  [sym_ms_based_modifier] = "ms_based_modifier",
  [sym_ms_call_modifier] = "ms_call_modifier",
  [sym_ms_unaligned_ptr_modifier] = "ms_unaligned_ptr_modifier",
  [sym_ms_pointer_modifier] = "ms_pointer_modifier",
  [sym_declaration_list] = "declaration_list",
  [sym__declarator] = "_declarator",
  [sym__field_declarator] = "_field_declarator",
  [sym__type_declarator] = "_type_declarator",
  [sym__abstract_declarator] = "_abstract_declarator",
  [sym_parenthesized_declarator] = "parenthesized_declarator",
  [sym_parenthesized_field_declarator] = "parenthesized_declarator",
  [sym_parenthesized_type_declarator] = "parenthesized_declarator",
  [sym_abstract_parenthesized_declarator] = "abstract_parenthesized_declarator",
  [sym_attributed_declarator] = "attributed_declarator",
  [sym_attributed_field_declarator] = "attributed_declarator",
  [sym_attributed_type_declarator] = "attributed_declarator",
  [sym_pointer_declarator] = "pointer_declarator",
  [sym_pointer_field_declarator] = "pointer_declarator",
  [sym_pointer_type_declarator] = "pointer_type_declarator",
  [sym_abstract_pointer_declarator] = "abstract_pointer_declarator",
  [sym_function_declarator] = "function_declarator",
  [sym_function_field_declarator] = "function_declarator",
  [sym_function_type_declarator] = "function_declarator",
  [sym_abstract_function_declarator] = "abstract_function_declarator",
  [sym_array_declarator] = "array_declarator",
  [sym_array_field_declarator] = "array_declarator",
  [sym_array_type_declarator] = "array_declarator",
  [sym_abstract_array_declarator] = "abstract_array_declarator",
  [sym_init_declarator] = "init_declarator",
  [sym_compound_statement] = "compound_statement",
  [sym_storage_class_specifier] = "storage_class_specifier",
  [sym_type_qualifier] = "type_qualifier",
  [sym__type_specifier] = "_type_specifier",
  [sym_sized_type_specifier] = "sized_type_specifier",
  [sym_primitive_type] = "primitive_type",
  [sym_enum_specifier] = "enum_specifier",
  [sym_enumerator_list] = "enumerator_list",
  [sym_struct_specifier] = "struct_specifier",
  [sym_union_specifier] = "union_specifier",
  [sym_field_declaration_list] = "field_declaration_list",
  [sym__field_declaration_list_item] = "_field_declaration_list_item",
  [sym_field_declaration] = "field_declaration",
  [sym_bitfield_clause] = "bitfield_clause",
  [sym_enumerator] = "enumerator",
  [sym_parameter_list] = "parameter_list",
  [sym_parameter_declaration] = "parameter_declaration",
  [sym_attributed_statement] = "attributed_statement",
  [sym_labeled_statement] = "labeled_statement",
  [sym__top_level_expression_statement] = "expression_statement",
  [sym_expression_statement] = "expression_statement",
  [sym_if_statement] = "if_statement",
  [sym_else_clause] = "else_clause",
  [sym_switch_statement] = "switch_statement",
  [sym_case_statement] = "case_statement",
  [sym_while_statement] = "while_statement",
  [sym_do_statement] = "do_statement",
  [sym_for_statement] = "for_statement",
  [sym__for_statement_body] = "_for_statement_body",
  [sym_return_statement] = "return_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_goto_statement] = "goto_statement",
  [sym_seh_try_statement] = "seh_try_statement",
  [sym_seh_except_clause] = "seh_except_clause",
  [sym_seh_finally_clause] = "seh_finally_clause",
  [sym_seh_leave_statement] = "seh_leave_statement",
  [sym__expression] = "_expression",
  [sym__expression_not_binary] = "_expression_not_binary",
  [sym__string] = "_string",
  [sym_comma_expression] = "comma_expression",
  [sym_conditional_expression] = "conditional_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_pointer_expression] = "pointer_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_update_expression] = "update_expression",
  [sym_cast_expression] = "cast_expression",
  [sym_type_descriptor] = "type_descriptor",
  [sym_sizeof_expression] = "sizeof_expression",
  [sym_alignof_expression] = "alignof_expression",
  [sym_offsetof_expression] = "offsetof_expression",
  [sym_generic_expression] = "generic_expression",
  [sym_subscript_expression] = "subscript_expression",
  [sym_call_expression] = "call_expression",
  [sym_gnu_asm_expression] = "gnu_asm_expression",
  [sym_gnu_asm_qualifier] = "gnu_asm_qualifier",
  [sym_gnu_asm_output_operand_list] = "gnu_asm_output_operand_list",
  [sym_gnu_asm_output_operand] = "gnu_asm_output_operand",
  [sym_gnu_asm_input_operand_list] = "gnu_asm_input_operand_list",
  [sym_gnu_asm_input_operand] = "gnu_asm_input_operand",
  [sym_gnu_asm_clobber_list] = "gnu_asm_clobber_list",
  [sym_gnu_asm_goto_list] = "gnu_asm_goto_list",
  [sym_argument_list] = "argument_list",
  [sym_field_expression] = "field_expression",
  [sym_compound_literal_expression] = "compound_literal_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_initializer_list] = "initializer_list",
  [sym_initializer_pair] = "initializer_pair",
  [sym_subscript_designator] = "subscript_designator",
  [sym_subscript_range_designator] = "subscript_range_designator",
  [sym_field_designator] = "field_designator",
  [sym_number_literal] = "number_literal",
  [sym_char_literal] = "char_literal",
  [sym_concatenated_string] = "concatenated_string",
  [sym_string_literal] = "string_literal",
  [sym_null] = "null",
  [sym__empty_declaration] = "_empty_declaration",
  [sym_placeholder_type_specifier] = "placeholder_type_specifier",
  [sym_decltype_auto] = "decltype",
  [sym_decltype] = "decltype",
  [sym__class_declaration] = "_class_declaration",
  [sym__class_declaration_item] = "_class_declaration_item",
  [sym_class_specifier] = "class_specifier",
  [sym__class_name] = "_class_name",
  [sym_virtual_specifier] = "virtual_specifier",
  [sym_virtual] = "virtual",
  [sym_alignas_specifier] = "alignas_specifier",
  [sym_explicit_function_specifier] = "explicit_function_specifier",
  [sym_base_class_clause] = "base_class_clause",
  [sym__enum_base_clause] = "_enum_base_clause",
  [sym_dependent_type] = "dependent_type",
  [sym_template_declaration] = "template_declaration",
  [sym_template_instantiation] = "template_instantiation",
  [sym_template_parameter_list] = "template_parameter_list",
  [sym_type_parameter_declaration] = "type_parameter_declaration",
  [sym_variadic_type_parameter_declaration] = "variadic_type_parameter_declaration",
  [sym_optional_type_parameter_declaration] = "optional_type_parameter_declaration",
  [sym_template_template_parameter_declaration] = "template_template_parameter_declaration",
  [sym_optional_parameter_declaration] = "optional_parameter_declaration",
  [sym_variadic_parameter_declaration] = "variadic_parameter_declaration",
  [sym_variadic_declarator] = "variadic_declarator",
  [sym_variadic_reference_declarator] = "reference_declarator",
  [sym_operator_cast] = "operator_cast",
  [sym_field_initializer_list] = "field_initializer_list",
  [sym_field_initializer] = "field_initializer",
  [sym_inline_method_definition] = "function_definition",
  [sym__constructor_specifiers] = "_constructor_specifiers",
  [sym_operator_cast_definition] = "function_definition",
  [sym_operator_cast_declaration] = "declaration",
  [sym_constructor_try_statement] = "try_statement",
  [sym_constructor_or_destructor_definition] = "function_definition",
  [sym_constructor_or_destructor_declaration] = "declaration",
  [sym_default_method_clause] = "default_method_clause",
  [sym_delete_method_clause] = "delete_method_clause",
  [sym_pure_virtual_clause] = "pure_virtual_clause",
  [sym_friend_declaration] = "friend_declaration",
  [sym_access_specifier] = "access_specifier",
  [sym_reference_declarator] = "reference_declarator",
  [sym_reference_field_declarator] = "reference_declarator",
  [sym_reference_type_declarator] = "reference_declarator",
  [sym_abstract_reference_declarator] = "abstract_reference_declarator",
  [sym_structured_binding_declarator] = "structured_binding_declarator",
  [sym_ref_qualifier] = "ref_qualifier",
  [sym__function_declarator_seq] = "_function_declarator_seq",
  [sym__function_attributes_start] = "_function_attributes_start",
  [sym__function_exception_specification] = "_function_exception_specification",
  [sym__function_attributes_end] = "_function_attributes_end",
  [sym__function_postfix] = "_function_postfix",
  [sym_trailing_return_type] = "trailing_return_type",
  [sym_noexcept] = "noexcept",
  [sym_throw_specifier] = "throw_specifier",
  [sym_template_type] = "template_type",
  [sym_template_method] = "template_method",
  [sym_template_function] = "template_function",
  [sym_template_argument_list] = "template_argument_list",
  [sym_namespace_definition] = "namespace_definition",
  [sym_namespace_alias_definition] = "namespace_alias_definition",
  [sym__namespace_specifier] = "_namespace_specifier",
  [sym_nested_namespace_specifier] = "nested_namespace_specifier",
  [sym_using_declaration] = "using_declaration",
  [sym_alias_declaration] = "alias_declaration",
  [sym_static_assert_declaration] = "static_assert_declaration",
  [sym_concept_definition] = "concept_definition",
  [sym_for_range_loop] = "for_range_loop",
  [sym__for_range_loop_body] = "_for_range_loop_body",
  [sym_init_statement] = "init_statement",
  [sym_condition_clause] = "condition_clause",
  [sym_condition_declaration] = "declaration",
  [sym_co_return_statement] = "co_return_statement",
  [sym_co_yield_statement] = "co_yield_statement",
  [sym_throw_statement] = "throw_statement",
  [sym_try_statement] = "try_statement",
  [sym_catch_clause] = "catch_clause",
  [sym_raw_string_literal] = "raw_string_literal",
  [sym_subscript_argument_list] = "subscript_argument_list",
  [sym_co_await_expression] = "co_await_expression",
  [sym_new_expression] = "new_expression",
  [sym_new_declarator] = "new_declarator",
  [sym_delete_expression] = "delete_expression",
  [sym_type_requirement] = "type_requirement",
  [sym_compound_requirement] = "compound_requirement",
  [sym__requirement] = "_requirement",
  [sym_requirement_seq] = "requirement_seq",
  [sym_constraint_conjunction] = "constraint_conjunction",
  [sym_constraint_disjunction] = "constraint_disjunction",
  [sym__requirement_clause_constraint] = "_requirement_clause_constraint",
  [sym_requires_clause] = "requires_clause",
  [sym_requires_parameter_list] = "parameter_list",
  [sym_requires_expression] = "requires_expression",
  [sym_lambda_expression] = "lambda_expression",
  [sym_lambda_capture_specifier] = "lambda_capture_specifier",
  [sym_lambda_default_capture] = "lambda_default_capture",
  [sym__fold_operator] = "_fold_operator",
  [sym__binary_fold_operator] = "_binary_fold_operator",
  [sym__unary_left_fold] = "_unary_left_fold",
  [sym__unary_right_fold] = "_unary_right_fold",
  [sym__binary_fold] = "_binary_fold",
  [sym_fold_expression] = "fold_expression",
  [sym_parameter_pack_expansion] = "parameter_pack_expansion",
  [sym_type_parameter_pack_expansion] = "parameter_pack_expansion",
  [sym_destructor_name] = "destructor_name",
  [sym_dependent_identifier] = "dependent_name",
  [sym_dependent_field_identifier] = "dependent_name",
  [sym_dependent_type_identifier] = "dependent_name",
  [sym__scope_resolution] = "_scope_resolution",
  [sym_qualified_field_identifier] = "qualified_identifier",
  [sym_qualified_identifier] = "qualified_identifier",
  [sym_qualified_type_identifier] = "qualified_identifier",
  [sym_qualified_operator_cast_identifier] = "qualified_identifier",
  [sym__assignment_expression_lhs] = "assignment_expression",
  [sym_operator_name] = "operator_name",
  [sym_user_defined_literal] = "user_defined_literal",
  [aux_sym_translation_unit_repeat1] = "translation_unit_repeat1",
  [aux_sym_preproc_params_repeat1] = "preproc_params_repeat1",
  [aux_sym_preproc_if_repeat1] = "preproc_if_repeat1",
  [aux_sym_preproc_if_in_field_declaration_list_repeat1] = "preproc_if_in_field_declaration_list_repeat1",
  [aux_sym_preproc_if_in_enumerator_list_repeat1] = "preproc_if_in_enumerator_list_repeat1",
  [aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1] = "preproc_if_in_enumerator_list_no_comma_repeat1",
  [aux_sym_preproc_argument_list_repeat1] = "preproc_argument_list_repeat1",
  [aux_sym_declaration_repeat1] = "declaration_repeat1",
  [aux_sym_type_definition_repeat1] = "type_definition_repeat1",
  [aux_sym__type_definition_type_repeat1] = "_type_definition_type_repeat1",
  [aux_sym__type_definition_declarators_repeat1] = "_type_definition_declarators_repeat1",
  [aux_sym__declaration_specifiers_repeat1] = "_declaration_specifiers_repeat1",
  [aux_sym_attribute_declaration_repeat1] = "attribute_declaration_repeat1",
  [aux_sym_attributed_declarator_repeat1] = "attributed_declarator_repeat1",
  [aux_sym_pointer_declarator_repeat1] = "pointer_declarator_repeat1",
  [aux_sym_sized_type_specifier_repeat1] = "sized_type_specifier_repeat1",
  [aux_sym_enumerator_list_repeat1] = "enumerator_list_repeat1",
  [aux_sym_field_declaration_repeat1] = "field_declaration_repeat1",
  [aux_sym_parameter_list_repeat1] = "parameter_list_repeat1",
  [aux_sym_case_statement_repeat1] = "case_statement_repeat1",
  [aux_sym_generic_expression_repeat1] = "generic_expression_repeat1",
  [aux_sym_gnu_asm_expression_repeat1] = "gnu_asm_expression_repeat1",
  [aux_sym_gnu_asm_output_operand_list_repeat1] = "gnu_asm_output_operand_list_repeat1",
  [aux_sym_gnu_asm_input_operand_list_repeat1] = "gnu_asm_input_operand_list_repeat1",
  [aux_sym_gnu_asm_clobber_list_repeat1] = "gnu_asm_clobber_list_repeat1",
  [aux_sym_gnu_asm_goto_list_repeat1] = "gnu_asm_goto_list_repeat1",
  [aux_sym_argument_list_repeat1] = "argument_list_repeat1",
  [aux_sym_initializer_list_repeat1] = "initializer_list_repeat1",
  [aux_sym_initializer_pair_repeat1] = "initializer_pair_repeat1",
  [aux_sym_char_literal_repeat1] = "char_literal_repeat1",
  [aux_sym_concatenated_string_repeat1] = "concatenated_string_repeat1",
  [aux_sym_string_literal_repeat1] = "string_literal_repeat1",
  [aux_sym__class_declaration_repeat1] = "_class_declaration_repeat1",
  [aux_sym_base_class_clause_repeat1] = "base_class_clause_repeat1",
  [aux_sym_template_parameter_list_repeat1] = "template_parameter_list_repeat1",
  [aux_sym_field_initializer_list_repeat1] = "field_initializer_list_repeat1",
  [aux_sym_operator_cast_definition_repeat1] = "operator_cast_definition_repeat1",
  [aux_sym_constructor_try_statement_repeat1] = "constructor_try_statement_repeat1",
  [aux_sym_structured_binding_declarator_repeat1] = "structured_binding_declarator_repeat1",
  [aux_sym__function_postfix_repeat1] = "_function_postfix_repeat1",
  [aux_sym_throw_specifier_repeat1] = "throw_specifier_repeat1",
  [aux_sym_template_argument_list_repeat1] = "template_argument_list_repeat1",
  [aux_sym_subscript_argument_list_repeat1] = "subscript_argument_list_repeat1",
  [aux_sym_requirement_seq_repeat1] = "requirement_seq_repeat1",
  [aux_sym_requires_parameter_list_repeat1] = "requires_parameter_list_repeat1",
  [aux_sym_lambda_capture_specifier_repeat1] = "lambda_capture_specifier_repeat1",
  [alias_sym_field_identifier] = "field_identifier",
  [alias_sym_namespace_identifier] = "namespace_identifier",
  [alias_sym_simple_requirement] = "simple_requirement",
  [alias_sym_statement_identifier] = "statement_identifier",
  [alias_sym_type_identifier] = "type_identifier",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [aux_sym_preproc_include_token1] = aux_sym_preproc_include_token1,
  [aux_sym_preproc_include_token2] = aux_sym_preproc_include_token2,
  [aux_sym_preproc_def_token1] = aux_sym_preproc_def_token1,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [aux_sym_preproc_if_token1] = aux_sym_preproc_if_token1,
  [anon_sym_LF] = anon_sym_LF,
  [aux_sym_preproc_if_token2] = aux_sym_preproc_if_token2,
  [aux_sym_preproc_ifdef_token1] = aux_sym_preproc_ifdef_token1,
  [aux_sym_preproc_ifdef_token2] = aux_sym_preproc_ifdef_token2,
  [aux_sym_preproc_else_token1] = aux_sym_preproc_else_token1,
  [aux_sym_preproc_elif_token1] = aux_sym_preproc_elif_token1,
  [aux_sym_preproc_elifdef_token1] = aux_sym_preproc_elifdef_token1,
  [aux_sym_preproc_elifdef_token2] = aux_sym_preproc_elifdef_token2,
  [sym_preproc_arg] = sym_preproc_arg,
  [sym_preproc_directive] = sym_preproc_directive,
  [anon_sym_LPAREN2] = anon_sym_LPAREN,
  [anon_sym_defined] = anon_sym_defined,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym___extension__] = anon_sym___extension__,
  [anon_sym_typedef] = anon_sym_typedef,
  [anon_sym_extern] = anon_sym_extern,
  [anon_sym___attribute__] = anon_sym___attribute__,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_LBRACK_LBRACK] = anon_sym_LBRACK_LBRACK,
  [anon_sym_RBRACK_RBRACK] = anon_sym_RBRACK_RBRACK,
  [anon_sym___declspec] = anon_sym___declspec,
  [anon_sym___based] = anon_sym___based,
  [anon_sym___cdecl] = anon_sym___cdecl,
  [anon_sym___clrcall] = anon_sym___clrcall,
  [anon_sym___stdcall] = anon_sym___stdcall,
  [anon_sym___fastcall] = anon_sym___fastcall,
  [anon_sym___thiscall] = anon_sym___thiscall,
  [anon_sym___vectorcall] = anon_sym___vectorcall,
  [sym_ms_restrict_modifier] = sym_ms_restrict_modifier,
  [sym_ms_unsigned_ptr_modifier] = sym_ms_unsigned_ptr_modifier,
  [sym_ms_signed_ptr_modifier] = sym_ms_signed_ptr_modifier,
  [anon_sym__unaligned] = anon_sym__unaligned,
  [anon_sym___unaligned] = anon_sym___unaligned,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_signed] = anon_sym_signed,
  [anon_sym_unsigned] = anon_sym_unsigned,
  [anon_sym_long] = anon_sym_long,
  [anon_sym_short] = anon_sym_short,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_register] = anon_sym_register,
  [anon_sym_inline] = anon_sym_inline,
  [anon_sym___inline] = anon_sym___inline,
  [anon_sym___inline__] = anon_sym___inline__,
  [anon_sym___forceinline] = anon_sym___forceinline,
  [anon_sym_thread_local] = anon_sym_thread_local,
  [anon_sym___thread] = anon_sym___thread,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_constexpr] = anon_sym_constexpr,
  [anon_sym_volatile] = anon_sym_volatile,
  [anon_sym_restrict] = anon_sym_restrict,
  [anon_sym___restrict__] = anon_sym___restrict__,
  [anon_sym__Atomic] = anon_sym__Atomic,
  [anon_sym__Noreturn] = anon_sym__Noreturn,
  [anon_sym_noreturn] = anon_sym_noreturn,
  [anon_sym_mutable] = anon_sym_mutable,
  [anon_sym_constinit] = anon_sym_constinit,
  [anon_sym_consteval] = anon_sym_consteval,
  [anon_sym_PROGMEM] = anon_sym_PROGMEM,
  [aux_sym_primitive_type_token1] = aux_sym_primitive_type_token1,
  [anon_sym_byte] = anon_sym_byte,
  [anon_sym_word] = anon_sym_word,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_struct] = anon_sym_struct,
  [anon_sym_union] = anon_sym_union,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_goto] = anon_sym_goto,
  [anon_sym___try] = anon_sym___try,
  [anon_sym___except] = anon_sym___except,
  [anon_sym___finally] = anon_sym___finally,
  [anon_sym___leave] = anon_sym___leave,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_and_eq] = anon_sym_and_eq,
  [anon_sym_or_eq] = anon_sym_or_eq,
  [anon_sym_xor_eq] = anon_sym_xor_eq,
  [anon_sym_not] = anon_sym_not,
  [anon_sym_compl] = anon_sym_compl,
  [anon_sym_LT_EQ_GT] = anon_sym_LT_EQ_GT,
  [anon_sym_or] = anon_sym_or,
  [anon_sym_and] = anon_sym_and,
  [anon_sym_bitor] = anon_sym_bitor,
  [anon_sym_xor] = anon_sym_xor,
  [anon_sym_bitand] = anon_sym_bitand,
  [anon_sym_not_eq] = anon_sym_not_eq,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_sizeof] = anon_sym_sizeof,
  [anon_sym___alignof__] = anon_sym___alignof__,
  [anon_sym___alignof] = anon_sym___alignof,
  [anon_sym__alignof] = anon_sym__alignof,
  [anon_sym_alignof] = anon_sym_alignof,
  [anon_sym__Alignof] = anon_sym__Alignof,
  [anon_sym_offsetof] = anon_sym_offsetof,
  [anon_sym__Generic] = anon_sym__Generic,
  [anon_sym_asm] = anon_sym_asm,
  [anon_sym___asm__] = anon_sym___asm__,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_DOT_STAR] = anon_sym_DOT_STAR,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [aux_sym_number_literal_token1] = aux_sym_number_literal_token1,
  [aux_sym_number_literal_token2] = aux_sym_number_literal_token2,
  [anon_sym_L_SQUOTE] = anon_sym_L_SQUOTE,
  [anon_sym_u_SQUOTE] = anon_sym_u_SQUOTE,
  [anon_sym_U_SQUOTE] = anon_sym_U_SQUOTE,
  [anon_sym_u8_SQUOTE] = anon_sym_u8_SQUOTE,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym_char_literal_token1] = aux_sym_char_literal_token1,
  [anon_sym_L_DQUOTE] = anon_sym_L_DQUOTE,
  [anon_sym_u_DQUOTE] = anon_sym_u_DQUOTE,
  [anon_sym_U_DQUOTE] = anon_sym_U_DQUOTE,
  [anon_sym_u8_DQUOTE] = anon_sym_u8_DQUOTE,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_string_literal_token1] = aux_sym_string_literal_token1,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_system_lib_string] = sym_system_lib_string,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [anon_sym_NULL] = anon_sym_NULL,
  [anon_sym_nullptr] = anon_sym_nullptr,
  [sym_comment] = sym_comment,
  [sym_auto] = sym_auto,
  [anon_sym_decltype] = anon_sym_decltype,
  [anon_sym_final] = anon_sym_final,
  [anon_sym_override] = anon_sym_override,
  [anon_sym_virtual] = anon_sym_virtual,
  [anon_sym_alignas] = anon_sym_alignas,
  [anon_sym_explicit] = anon_sym_explicit,
  [anon_sym_typename] = anon_sym_typename,
  [anon_sym_template] = anon_sym_template,
  [anon_sym_GT2] = anon_sym_GT,
  [anon_sym_operator] = anon_sym_operator,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_delete] = anon_sym_delete,
  [anon_sym_0] = anon_sym_0,
  [anon_sym_friend] = anon_sym_friend,
  [anon_sym_public] = anon_sym_public,
  [anon_sym_private] = anon_sym_private,
  [anon_sym_protected] = anon_sym_protected,
  [anon_sym_noexcept] = anon_sym_noexcept,
  [anon_sym_throw] = anon_sym_throw,
  [anon_sym_namespace] = anon_sym_namespace,
  [anon_sym_using] = anon_sym_using,
  [anon_sym_static_assert] = anon_sym_static_assert,
  [anon_sym_concept] = anon_sym_concept,
  [anon_sym_co_return] = anon_sym_co_return,
  [anon_sym_co_yield] = anon_sym_co_yield,
  [anon_sym_catch] = anon_sym_catch,
  [anon_sym_R_DQUOTE] = anon_sym_R_DQUOTE,
  [anon_sym_LR_DQUOTE] = anon_sym_LR_DQUOTE,
  [anon_sym_uR_DQUOTE] = anon_sym_uR_DQUOTE,
  [anon_sym_UR_DQUOTE] = anon_sym_UR_DQUOTE,
  [anon_sym_u8R_DQUOTE] = anon_sym_u8R_DQUOTE,
  [anon_sym_co_await] = anon_sym_co_await,
  [anon_sym_new] = anon_sym_new,
  [anon_sym_requires] = anon_sym_requires,
  [anon_sym_DASH_GT_STAR] = anon_sym_DASH_GT_STAR,
  [anon_sym_LPAREN_RPAREN] = anon_sym_LPAREN_RPAREN,
  [anon_sym_LBRACK_RBRACK] = anon_sym_LBRACK_RBRACK,
  [anon_sym_DQUOTE_DQUOTE] = anon_sym_DQUOTE_DQUOTE,
  [sym_this] = sym_this,
  [sym_literal_suffix] = sym_literal_suffix,
  [sym_raw_string_delimiter] = sym_raw_string_delimiter,
  [sym_raw_string_content] = sym_raw_string_content,
  [sym_translation_unit] = sym_translation_unit,
  [sym_preproc_include] = sym_preproc_include,
  [sym_preproc_def] = sym_preproc_def,
  [sym_preproc_function_def] = sym_preproc_function_def,
  [sym_preproc_params] = sym_preproc_params,
  [sym_preproc_call] = sym_preproc_call,
  [sym_preproc_if] = sym_preproc_if,
  [sym_preproc_ifdef] = sym_preproc_ifdef,
  [sym_preproc_else] = sym_preproc_else,
  [sym_preproc_elif] = sym_preproc_elif,
  [sym_preproc_elifdef] = sym_preproc_elifdef,
  [sym_preproc_if_in_field_declaration_list] = sym_preproc_if,
  [sym_preproc_ifdef_in_field_declaration_list] = sym_preproc_ifdef,
  [sym_preproc_else_in_field_declaration_list] = sym_preproc_else,
  [sym_preproc_elif_in_field_declaration_list] = sym_preproc_elif,
  [sym_preproc_elifdef_in_field_declaration_list] = sym_preproc_elifdef,
  [sym_preproc_if_in_enumerator_list] = sym_preproc_if,
  [sym_preproc_ifdef_in_enumerator_list] = sym_preproc_ifdef,
  [sym_preproc_else_in_enumerator_list] = sym_preproc_else,
  [sym_preproc_elif_in_enumerator_list] = sym_preproc_elif,
  [sym_preproc_elifdef_in_enumerator_list] = sym_preproc_elifdef,
  [sym_preproc_if_in_enumerator_list_no_comma] = sym_preproc_if,
  [sym_preproc_ifdef_in_enumerator_list_no_comma] = sym_preproc_ifdef,
  [sym_preproc_else_in_enumerator_list_no_comma] = sym_preproc_else,
  [sym_preproc_elif_in_enumerator_list_no_comma] = sym_preproc_elif,
  [sym_preproc_elifdef_in_enumerator_list_no_comma] = sym_preproc_elifdef,
  [sym__preproc_expression] = sym__preproc_expression,
  [sym_preproc_parenthesized_expression] = sym_parenthesized_expression,
  [sym_preproc_defined] = sym_preproc_defined,
  [sym_preproc_unary_expression] = sym_unary_expression,
  [sym_preproc_call_expression] = sym_call_expression,
  [sym_preproc_argument_list] = sym_argument_list,
  [sym_preproc_binary_expression] = sym_binary_expression,
  [sym_function_definition] = sym_function_definition,
  [sym_declaration] = sym_declaration,
  [sym_type_definition] = sym_type_definition,
  [sym__type_definition_type] = sym__type_definition_type,
  [sym__type_definition_declarators] = sym__type_definition_declarators,
  [sym__declaration_modifiers] = sym__declaration_modifiers,
  [sym__declaration_specifiers] = sym__declaration_specifiers,
  [sym_linkage_specification] = sym_linkage_specification,
  [sym_attribute_specifier] = sym_attribute_specifier,
  [sym_attribute] = sym_attribute,
  [sym_attribute_declaration] = sym_attribute_declaration,
  [sym_ms_declspec_modifier] = sym_ms_declspec_modifier,
  [sym_ms_based_modifier] = sym_ms_based_modifier,
  [sym_ms_call_modifier] = sym_ms_call_modifier,
  [sym_ms_unaligned_ptr_modifier] = sym_ms_unaligned_ptr_modifier,
  [sym_ms_pointer_modifier] = sym_ms_pointer_modifier,
  [sym_declaration_list] = sym_declaration_list,
  [sym__declarator] = sym__declarator,
  [sym__field_declarator] = sym__field_declarator,
  [sym__type_declarator] = sym__type_declarator,
  [sym__abstract_declarator] = sym__abstract_declarator,
  [sym_parenthesized_declarator] = sym_parenthesized_declarator,
  [sym_parenthesized_field_declarator] = sym_parenthesized_declarator,
  [sym_parenthesized_type_declarator] = sym_parenthesized_declarator,
  [sym_abstract_parenthesized_declarator] = sym_abstract_parenthesized_declarator,
  [sym_attributed_declarator] = sym_attributed_declarator,
  [sym_attributed_field_declarator] = sym_attributed_declarator,
  [sym_attributed_type_declarator] = sym_attributed_declarator,
  [sym_pointer_declarator] = sym_pointer_declarator,
  [sym_pointer_field_declarator] = sym_pointer_declarator,
  [sym_pointer_type_declarator] = sym_pointer_type_declarator,
  [sym_abstract_pointer_declarator] = sym_abstract_pointer_declarator,
  [sym_function_declarator] = sym_function_declarator,
  [sym_function_field_declarator] = sym_function_declarator,
  [sym_function_type_declarator] = sym_function_declarator,
  [sym_abstract_function_declarator] = sym_abstract_function_declarator,
  [sym_array_declarator] = sym_array_declarator,
  [sym_array_field_declarator] = sym_array_declarator,
  [sym_array_type_declarator] = sym_array_declarator,
  [sym_abstract_array_declarator] = sym_abstract_array_declarator,
  [sym_init_declarator] = sym_init_declarator,
  [sym_compound_statement] = sym_compound_statement,
  [sym_storage_class_specifier] = sym_storage_class_specifier,
  [sym_type_qualifier] = sym_type_qualifier,
  [sym__type_specifier] = sym__type_specifier,
  [sym_sized_type_specifier] = sym_sized_type_specifier,
  [sym_primitive_type] = sym_primitive_type,
  [sym_enum_specifier] = sym_enum_specifier,
  [sym_enumerator_list] = sym_enumerator_list,
  [sym_struct_specifier] = sym_struct_specifier,
  [sym_union_specifier] = sym_union_specifier,
  [sym_field_declaration_list] = sym_field_declaration_list,
  [sym__field_declaration_list_item] = sym__field_declaration_list_item,
  [sym_field_declaration] = sym_field_declaration,
  [sym_bitfield_clause] = sym_bitfield_clause,
  [sym_enumerator] = sym_enumerator,
  [sym_parameter_list] = sym_parameter_list,
  [sym_parameter_declaration] = sym_parameter_declaration,
  [sym_attributed_statement] = sym_attributed_statement,
  [sym_labeled_statement] = sym_labeled_statement,
  [sym__top_level_expression_statement] = sym_expression_statement,
  [sym_expression_statement] = sym_expression_statement,
  [sym_if_statement] = sym_if_statement,
  [sym_else_clause] = sym_else_clause,
  [sym_switch_statement] = sym_switch_statement,
  [sym_case_statement] = sym_case_statement,
  [sym_while_statement] = sym_while_statement,
  [sym_do_statement] = sym_do_statement,
  [sym_for_statement] = sym_for_statement,
  [sym__for_statement_body] = sym__for_statement_body,
  [sym_return_statement] = sym_return_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_goto_statement] = sym_goto_statement,
  [sym_seh_try_statement] = sym_seh_try_statement,
  [sym_seh_except_clause] = sym_seh_except_clause,
  [sym_seh_finally_clause] = sym_seh_finally_clause,
  [sym_seh_leave_statement] = sym_seh_leave_statement,
  [sym__expression] = sym__expression,
  [sym__expression_not_binary] = sym__expression_not_binary,
  [sym__string] = sym__string,
  [sym_comma_expression] = sym_comma_expression,
  [sym_conditional_expression] = sym_conditional_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym_pointer_expression] = sym_pointer_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_update_expression] = sym_update_expression,
  [sym_cast_expression] = sym_cast_expression,
  [sym_type_descriptor] = sym_type_descriptor,
  [sym_sizeof_expression] = sym_sizeof_expression,
  [sym_alignof_expression] = sym_alignof_expression,
  [sym_offsetof_expression] = sym_offsetof_expression,
  [sym_generic_expression] = sym_generic_expression,
  [sym_subscript_expression] = sym_subscript_expression,
  [sym_call_expression] = sym_call_expression,
  [sym_gnu_asm_expression] = sym_gnu_asm_expression,
  [sym_gnu_asm_qualifier] = sym_gnu_asm_qualifier,
  [sym_gnu_asm_output_operand_list] = sym_gnu_asm_output_operand_list,
  [sym_gnu_asm_output_operand] = sym_gnu_asm_output_operand,
  [sym_gnu_asm_input_operand_list] = sym_gnu_asm_input_operand_list,
  [sym_gnu_asm_input_operand] = sym_gnu_asm_input_operand,
  [sym_gnu_asm_clobber_list] = sym_gnu_asm_clobber_list,
  [sym_gnu_asm_goto_list] = sym_gnu_asm_goto_list,
  [sym_argument_list] = sym_argument_list,
  [sym_field_expression] = sym_field_expression,
  [sym_compound_literal_expression] = sym_compound_literal_expression,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_initializer_list] = sym_initializer_list,
  [sym_initializer_pair] = sym_initializer_pair,
  [sym_subscript_designator] = sym_subscript_designator,
  [sym_subscript_range_designator] = sym_subscript_range_designator,
  [sym_field_designator] = sym_field_designator,
  [sym_number_literal] = sym_number_literal,
  [sym_char_literal] = sym_char_literal,
  [sym_concatenated_string] = sym_concatenated_string,
  [sym_string_literal] = sym_string_literal,
  [sym_null] = sym_null,
  [sym__empty_declaration] = sym__empty_declaration,
  [sym_placeholder_type_specifier] = sym_placeholder_type_specifier,
  [sym_decltype_auto] = sym_decltype,
  [sym_decltype] = sym_decltype,
  [sym__class_declaration] = sym__class_declaration,
  [sym__class_declaration_item] = sym__class_declaration_item,
  [sym_class_specifier] = sym_class_specifier,
  [sym__class_name] = sym__class_name,
  [sym_virtual_specifier] = sym_virtual_specifier,
  [sym_virtual] = sym_virtual,
  [sym_alignas_specifier] = sym_alignas_specifier,
  [sym_explicit_function_specifier] = sym_explicit_function_specifier,
  [sym_base_class_clause] = sym_base_class_clause,
  [sym__enum_base_clause] = sym__enum_base_clause,
  [sym_dependent_type] = sym_dependent_type,
  [sym_template_declaration] = sym_template_declaration,
  [sym_template_instantiation] = sym_template_instantiation,
  [sym_template_parameter_list] = sym_template_parameter_list,
  [sym_type_parameter_declaration] = sym_type_parameter_declaration,
  [sym_variadic_type_parameter_declaration] = sym_variadic_type_parameter_declaration,
  [sym_optional_type_parameter_declaration] = sym_optional_type_parameter_declaration,
  [sym_template_template_parameter_declaration] = sym_template_template_parameter_declaration,
  [sym_optional_parameter_declaration] = sym_optional_parameter_declaration,
  [sym_variadic_parameter_declaration] = sym_variadic_parameter_declaration,
  [sym_variadic_declarator] = sym_variadic_declarator,
  [sym_variadic_reference_declarator] = sym_reference_declarator,
  [sym_operator_cast] = sym_operator_cast,
  [sym_field_initializer_list] = sym_field_initializer_list,
  [sym_field_initializer] = sym_field_initializer,
  [sym_inline_method_definition] = sym_function_definition,
  [sym__constructor_specifiers] = sym__constructor_specifiers,
  [sym_operator_cast_definition] = sym_function_definition,
  [sym_operator_cast_declaration] = sym_declaration,
  [sym_constructor_try_statement] = sym_try_statement,
  [sym_constructor_or_destructor_definition] = sym_function_definition,
  [sym_constructor_or_destructor_declaration] = sym_declaration,
  [sym_default_method_clause] = sym_default_method_clause,
  [sym_delete_method_clause] = sym_delete_method_clause,
  [sym_pure_virtual_clause] = sym_pure_virtual_clause,
  [sym_friend_declaration] = sym_friend_declaration,
  [sym_access_specifier] = sym_access_specifier,
  [sym_reference_declarator] = sym_reference_declarator,
  [sym_reference_field_declarator] = sym_reference_declarator,
  [sym_reference_type_declarator] = sym_reference_declarator,
  [sym_abstract_reference_declarator] = sym_abstract_reference_declarator,
  [sym_structured_binding_declarator] = sym_structured_binding_declarator,
  [sym_ref_qualifier] = sym_ref_qualifier,
  [sym__function_declarator_seq] = sym__function_declarator_seq,
  [sym__function_attributes_start] = sym__function_attributes_start,
  [sym__function_exception_specification] = sym__function_exception_specification,
  [sym__function_attributes_end] = sym__function_attributes_end,
  [sym__function_postfix] = sym__function_postfix,
  [sym_trailing_return_type] = sym_trailing_return_type,
  [sym_noexcept] = sym_noexcept,
  [sym_throw_specifier] = sym_throw_specifier,
  [sym_template_type] = sym_template_type,
  [sym_template_method] = sym_template_method,
  [sym_template_function] = sym_template_function,
  [sym_template_argument_list] = sym_template_argument_list,
  [sym_namespace_definition] = sym_namespace_definition,
  [sym_namespace_alias_definition] = sym_namespace_alias_definition,
  [sym__namespace_specifier] = sym__namespace_specifier,
  [sym_nested_namespace_specifier] = sym_nested_namespace_specifier,
  [sym_using_declaration] = sym_using_declaration,
  [sym_alias_declaration] = sym_alias_declaration,
  [sym_static_assert_declaration] = sym_static_assert_declaration,
  [sym_concept_definition] = sym_concept_definition,
  [sym_for_range_loop] = sym_for_range_loop,
  [sym__for_range_loop_body] = sym__for_range_loop_body,
  [sym_init_statement] = sym_init_statement,
  [sym_condition_clause] = sym_condition_clause,
  [sym_condition_declaration] = sym_declaration,
  [sym_co_return_statement] = sym_co_return_statement,
  [sym_co_yield_statement] = sym_co_yield_statement,
  [sym_throw_statement] = sym_throw_statement,
  [sym_try_statement] = sym_try_statement,
  [sym_catch_clause] = sym_catch_clause,
  [sym_raw_string_literal] = sym_raw_string_literal,
  [sym_subscript_argument_list] = sym_subscript_argument_list,
  [sym_co_await_expression] = sym_co_await_expression,
  [sym_new_expression] = sym_new_expression,
  [sym_new_declarator] = sym_new_declarator,
  [sym_delete_expression] = sym_delete_expression,
  [sym_type_requirement] = sym_type_requirement,
  [sym_compound_requirement] = sym_compound_requirement,
  [sym__requirement] = sym__requirement,
  [sym_requirement_seq] = sym_requirement_seq,
  [sym_constraint_conjunction] = sym_constraint_conjunction,
  [sym_constraint_disjunction] = sym_constraint_disjunction,
  [sym__requirement_clause_constraint] = sym__requirement_clause_constraint,
  [sym_requires_clause] = sym_requires_clause,
  [sym_requires_parameter_list] = sym_parameter_list,
  [sym_requires_expression] = sym_requires_expression,
  [sym_lambda_expression] = sym_lambda_expression,
  [sym_lambda_capture_specifier] = sym_lambda_capture_specifier,
  [sym_lambda_default_capture] = sym_lambda_default_capture,
  [sym__fold_operator] = sym__fold_operator,
  [sym__binary_fold_operator] = sym__binary_fold_operator,
  [sym__unary_left_fold] = sym__unary_left_fold,
  [sym__unary_right_fold] = sym__unary_right_fold,
  [sym__binary_fold] = sym__binary_fold,
  [sym_fold_expression] = sym_fold_expression,
  [sym_parameter_pack_expansion] = sym_parameter_pack_expansion,
  [sym_type_parameter_pack_expansion] = sym_parameter_pack_expansion,
  [sym_destructor_name] = sym_destructor_name,
  [sym_dependent_identifier] = sym_dependent_identifier,
  [sym_dependent_field_identifier] = sym_dependent_identifier,
  [sym_dependent_type_identifier] = sym_dependent_identifier,
  [sym__scope_resolution] = sym__scope_resolution,
  [sym_qualified_field_identifier] = sym_qualified_identifier,
  [sym_qualified_identifier] = sym_qualified_identifier,
  [sym_qualified_type_identifier] = sym_qualified_identifier,
  [sym_qualified_operator_cast_identifier] = sym_qualified_identifier,
  [sym__assignment_expression_lhs] = sym_assignment_expression,
  [sym_operator_name] = sym_operator_name,
  [sym_user_defined_literal] = sym_user_defined_literal,
  [aux_sym_translation_unit_repeat1] = aux_sym_translation_unit_repeat1,
  [aux_sym_preproc_params_repeat1] = aux_sym_preproc_params_repeat1,
  [aux_sym_preproc_if_repeat1] = aux_sym_preproc_if_repeat1,
  [aux_sym_preproc_if_in_field_declaration_list_repeat1] = aux_sym_preproc_if_in_field_declaration_list_repeat1,
  [aux_sym_preproc_if_in_enumerator_list_repeat1] = aux_sym_preproc_if_in_enumerator_list_repeat1,
  [aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1] = aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
  [aux_sym_preproc_argument_list_repeat1] = aux_sym_preproc_argument_list_repeat1,
  [aux_sym_declaration_repeat1] = aux_sym_declaration_repeat1,
  [aux_sym_type_definition_repeat1] = aux_sym_type_definition_repeat1,
  [aux_sym__type_definition_type_repeat1] = aux_sym__type_definition_type_repeat1,
  [aux_sym__type_definition_declarators_repeat1] = aux_sym__type_definition_declarators_repeat1,
  [aux_sym__declaration_specifiers_repeat1] = aux_sym__declaration_specifiers_repeat1,
  [aux_sym_attribute_declaration_repeat1] = aux_sym_attribute_declaration_repeat1,
  [aux_sym_attributed_declarator_repeat1] = aux_sym_attributed_declarator_repeat1,
  [aux_sym_pointer_declarator_repeat1] = aux_sym_pointer_declarator_repeat1,
  [aux_sym_sized_type_specifier_repeat1] = aux_sym_sized_type_specifier_repeat1,
  [aux_sym_enumerator_list_repeat1] = aux_sym_enumerator_list_repeat1,
  [aux_sym_field_declaration_repeat1] = aux_sym_field_declaration_repeat1,
  [aux_sym_parameter_list_repeat1] = aux_sym_parameter_list_repeat1,
  [aux_sym_case_statement_repeat1] = aux_sym_case_statement_repeat1,
  [aux_sym_generic_expression_repeat1] = aux_sym_generic_expression_repeat1,
  [aux_sym_gnu_asm_expression_repeat1] = aux_sym_gnu_asm_expression_repeat1,
  [aux_sym_gnu_asm_output_operand_list_repeat1] = aux_sym_gnu_asm_output_operand_list_repeat1,
  [aux_sym_gnu_asm_input_operand_list_repeat1] = aux_sym_gnu_asm_input_operand_list_repeat1,
  [aux_sym_gnu_asm_clobber_list_repeat1] = aux_sym_gnu_asm_clobber_list_repeat1,
  [aux_sym_gnu_asm_goto_list_repeat1] = aux_sym_gnu_asm_goto_list_repeat1,
  [aux_sym_argument_list_repeat1] = aux_sym_argument_list_repeat1,
  [aux_sym_initializer_list_repeat1] = aux_sym_initializer_list_repeat1,
  [aux_sym_initializer_pair_repeat1] = aux_sym_initializer_pair_repeat1,
  [aux_sym_char_literal_repeat1] = aux_sym_char_literal_repeat1,
  [aux_sym_concatenated_string_repeat1] = aux_sym_concatenated_string_repeat1,
  [aux_sym_string_literal_repeat1] = aux_sym_string_literal_repeat1,
  [aux_sym__class_declaration_repeat1] = aux_sym__class_declaration_repeat1,
  [aux_sym_base_class_clause_repeat1] = aux_sym_base_class_clause_repeat1,
  [aux_sym_template_parameter_list_repeat1] = aux_sym_template_parameter_list_repeat1,
  [aux_sym_field_initializer_list_repeat1] = aux_sym_field_initializer_list_repeat1,
  [aux_sym_operator_cast_definition_repeat1] = aux_sym_operator_cast_definition_repeat1,
  [aux_sym_constructor_try_statement_repeat1] = aux_sym_constructor_try_statement_repeat1,
  [aux_sym_structured_binding_declarator_repeat1] = aux_sym_structured_binding_declarator_repeat1,
  [aux_sym__function_postfix_repeat1] = aux_sym__function_postfix_repeat1,
  [aux_sym_throw_specifier_repeat1] = aux_sym_throw_specifier_repeat1,
  [aux_sym_template_argument_list_repeat1] = aux_sym_template_argument_list_repeat1,
  [aux_sym_subscript_argument_list_repeat1] = aux_sym_subscript_argument_list_repeat1,
  [aux_sym_requirement_seq_repeat1] = aux_sym_requirement_seq_repeat1,
  [aux_sym_requires_parameter_list_repeat1] = aux_sym_requires_parameter_list_repeat1,
  [aux_sym_lambda_capture_specifier_repeat1] = aux_sym_lambda_capture_specifier_repeat1,
  [alias_sym_field_identifier] = alias_sym_field_identifier,
  [alias_sym_namespace_identifier] = alias_sym_namespace_identifier,
  [alias_sym_simple_requirement] = alias_sym_simple_requirement,
  [alias_sym_statement_identifier] = alias_sym_statement_identifier,
  [alias_sym_type_identifier] = alias_sym_type_identifier,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_preproc_include_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_include_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_def_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_if_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_if_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_ifdef_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_ifdef_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_else_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_elif_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_elifdef_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_elifdef_token2] = {
    .visible = true,
    .named = false,
  },
  [sym_preproc_arg] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_directive] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defined] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___extension__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typedef] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extern] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___attribute__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___declspec] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___based] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___cdecl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___clrcall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___stdcall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___fastcall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___thiscall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___vectorcall] = {
    .visible = true,
    .named = false,
  },
  [sym_ms_restrict_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_unsigned_ptr_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_signed_ptr_modifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym__unaligned] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___unaligned] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_signed] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsigned] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_long] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_short] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_register] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inline] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___inline] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___inline__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___forceinline] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_thread_local] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___thread] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_constexpr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_volatile] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_restrict] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___restrict__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Atomic] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Noreturn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_noreturn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mutable] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_constinit] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_consteval] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PROGMEM] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_primitive_type_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_byte] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_word] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_struct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_union] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_goto] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___except] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___leave] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and_eq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or_eq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_xor_eq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_compl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bitor] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_xor] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bitand] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not_eq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sizeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___alignof__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___alignof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__alignof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_alignof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Alignof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_offsetof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Generic] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_asm] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___asm__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_number_literal_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_number_literal_token2] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_L_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_U_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u8_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_char_literal_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_L_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_U_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u8_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_literal_token1] = {
    .visible = true,
    .named = true,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_system_lib_string] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_NULL] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nullptr] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_auto] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_decltype] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_final] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_override] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_virtual] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_alignas] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_explicit] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typename] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_template] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_operator] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_delete] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_0] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_friend] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_public] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_protected] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_noexcept] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_namespace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_using] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static_assert] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_concept] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_co_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_co_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_R_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LR_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uR_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_UR_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u8R_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_co_await] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_requires] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [sym_this] = {
    .visible = true,
    .named = true,
  },
  [sym_literal_suffix] = {
    .visible = true,
    .named = true,
  },
  [sym_raw_string_delimiter] = {
    .visible = true,
    .named = true,
  },
  [sym_raw_string_content] = {
    .visible = true,
    .named = true,
  },
  [sym_translation_unit] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_include] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_def] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_function_def] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_params] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_call] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elifdef] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elifdef_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef_in_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif_in_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elifdef_in_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_enumerator_list_no_comma] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef_in_enumerator_list_no_comma] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_enumerator_list_no_comma] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif_in_enumerator_list_no_comma] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elifdef_in_enumerator_list_no_comma] = {
    .visible = true,
    .named = true,
  },
  [sym__preproc_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_preproc_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_defined] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_type_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__type_definition_type] = {
    .visible = false,
    .named = true,
  },
  [sym__type_definition_declarators] = {
    .visible = false,
    .named = true,
  },
  [sym__declaration_modifiers] = {
    .visible = false,
    .named = true,
  },
  [sym__declaration_specifiers] = {
    .visible = false,
    .named = true,
  },
  [sym_linkage_specification] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_declspec_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_based_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_call_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_unaligned_ptr_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_pointer_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym__declarator] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__field_declarator] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__type_declarator] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__abstract_declarator] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_parenthesized_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_parenthesized_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_attributed_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_attributed_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_attributed_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_pointer_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_function_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_function_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_array_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_array_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_array_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_init_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_storage_class_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_type_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym__type_specifier] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_sized_type_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_primitive_type] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_union_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym__field_declaration_list_item] = {
    .visible = false,
    .named = true,
  },
  [sym_field_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_bitfield_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_enumerator] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_attributed_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__top_level_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_case_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__for_statement_body] = {
    .visible = false,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_goto_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_seh_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_seh_except_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_seh_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_seh_leave_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__expression_not_binary] = {
    .visible = false,
    .named = true,
  },
  [sym__string] = {
    .visible = false,
    .named = true,
  },
  [sym_comma_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_cast_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_descriptor] = {
    .visible = true,
    .named = true,
  },
  [sym_sizeof_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_alignof_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_offsetof_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_output_operand_list] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_output_operand] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_input_operand_list] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_input_operand] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_clobber_list] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_goto_list] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_field_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_literal_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_initializer_list] = {
    .visible = true,
    .named = true,
  },
  [sym_initializer_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_designator] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_range_designator] = {
    .visible = true,
    .named = true,
  },
  [sym_field_designator] = {
    .visible = true,
    .named = true,
  },
  [sym_number_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_char_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_concatenated_string] = {
    .visible = true,
    .named = true,
  },
  [sym_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym__empty_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_placeholder_type_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_decltype_auto] = {
    .visible = true,
    .named = true,
  },
  [sym_decltype] = {
    .visible = true,
    .named = true,
  },
  [sym__class_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym__class_declaration_item] = {
    .visible = false,
    .named = true,
  },
  [sym_class_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym__class_name] = {
    .visible = false,
    .named = true,
  },
  [sym_virtual_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_virtual] = {
    .visible = true,
    .named = true,
  },
  [sym_alignas_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_explicit_function_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_base_class_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__enum_base_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_dependent_type] = {
    .visible = true,
    .named = true,
  },
  [sym_template_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_template_instantiation] = {
    .visible = true,
    .named = true,
  },
  [sym_template_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_type_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_type_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_template_template_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_reference_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_operator_cast] = {
    .visible = true,
    .named = true,
  },
  [sym_field_initializer_list] = {
    .visible = true,
    .named = true,
  },
  [sym_field_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_inline_method_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__constructor_specifiers] = {
    .visible = false,
    .named = true,
  },
  [sym_operator_cast_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_operator_cast_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_or_destructor_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_or_destructor_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_default_method_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_delete_method_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_pure_virtual_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_friend_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_access_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_reference_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_reference_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_reference_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_reference_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_structured_binding_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_ref_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym__function_declarator_seq] = {
    .visible = false,
    .named = true,
  },
  [sym__function_attributes_start] = {
    .visible = false,
    .named = true,
  },
  [sym__function_exception_specification] = {
    .visible = false,
    .named = true,
  },
  [sym__function_attributes_end] = {
    .visible = false,
    .named = true,
  },
  [sym__function_postfix] = {
    .visible = false,
    .named = true,
  },
  [sym_trailing_return_type] = {
    .visible = true,
    .named = true,
  },
  [sym_noexcept] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_template_type] = {
    .visible = true,
    .named = true,
  },
  [sym_template_method] = {
    .visible = true,
    .named = true,
  },
  [sym_template_function] = {
    .visible = true,
    .named = true,
  },
  [sym_template_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_alias_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__namespace_specifier] = {
    .visible = false,
    .named = true,
  },
  [sym_nested_namespace_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_using_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_alias_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_static_assert_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_concept_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_for_range_loop] = {
    .visible = true,
    .named = true,
  },
  [sym__for_range_loop_body] = {
    .visible = false,
    .named = true,
  },
  [sym_init_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_condition_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_condition_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_co_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_co_yield_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_raw_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_co_await_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_delete_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_requirement] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_requirement] = {
    .visible = true,
    .named = true,
  },
  [sym__requirement] = {
    .visible = false,
    .named = true,
  },
  [sym_requirement_seq] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint_conjunction] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint_disjunction] = {
    .visible = true,
    .named = true,
  },
  [sym__requirement_clause_constraint] = {
    .visible = false,
    .named = true,
  },
  [sym_requires_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_requires_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_requires_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_capture_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_default_capture] = {
    .visible = true,
    .named = true,
  },
  [sym__fold_operator] = {
    .visible = false,
    .named = true,
  },
  [sym__binary_fold_operator] = {
    .visible = false,
    .named = true,
  },
  [sym__unary_left_fold] = {
    .visible = false,
    .named = true,
  },
  [sym__unary_right_fold] = {
    .visible = false,
    .named = true,
  },
  [sym__binary_fold] = {
    .visible = false,
    .named = true,
  },
  [sym_fold_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_pack_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter_pack_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_destructor_name] = {
    .visible = true,
    .named = true,
  },
  [sym_dependent_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_dependent_field_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_dependent_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym__scope_resolution] = {
    .visible = false,
    .named = true,
  },
  [sym_qualified_field_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_qualified_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_qualified_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_qualified_operator_cast_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym__assignment_expression_lhs] = {
    .visible = true,
    .named = true,
  },
  [sym_operator_name] = {
    .visible = true,
    .named = true,
  },
  [sym_user_defined_literal] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_translation_unit_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_params_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_in_field_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_in_enumerator_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__type_definition_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__type_definition_declarators_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__declaration_specifiers_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_attribute_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_attributed_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pointer_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_sized_type_specifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enumerator_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_generic_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_output_operand_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_input_operand_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_clobber_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_goto_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_initializer_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_initializer_pair_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_char_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concatenated_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__class_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_base_class_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_initializer_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_operator_cast_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_constructor_try_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_structured_binding_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__function_postfix_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_throw_specifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_subscript_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_requirement_seq_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_requires_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_lambda_capture_specifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_field_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_namespace_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_simple_requirement] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_statement_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_alternative = 1,
  field_argument = 2,
  field_arguments = 3,
  field_assembly_code = 4,
  field_base = 5,
  field_body = 6,
  field_captures = 7,
  field_clobbers = 8,
  field_condition = 9,
  field_consequence = 10,
  field_constraint = 11,
  field_declarator = 12,
  field_default_type = 13,
  field_default_value = 14,
  field_delimiter = 15,
  field_designator = 16,
  field_directive = 17,
  field_end = 18,
  field_field = 19,
  field_filter = 20,
  field_function = 21,
  field_goto_labels = 22,
  field_indices = 23,
  field_initializer = 24,
  field_input_operands = 25,
  field_label = 26,
  field_left = 27,
  field_length = 28,
  field_member = 29,
  field_message = 30,
  field_name = 31,
  field_operand = 32,
  field_operator = 33,
  field_output_operands = 34,
  field_parameters = 35,
  field_path = 36,
  field_pattern = 37,
  field_placement = 38,
  field_prefix = 39,
  field_register = 40,
  field_requirements = 41,
  field_right = 42,
  field_scope = 43,
  field_size = 44,
  field_start = 45,
  field_symbol = 46,
  field_template_parameters = 47,
  field_type = 48,
  field_update = 49,
  field_value = 50,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_assembly_code] = "assembly_code",
  [field_base] = "base",
  [field_body] = "body",
  [field_captures] = "captures",
  [field_clobbers] = "clobbers",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_constraint] = "constraint",
  [field_declarator] = "declarator",
  [field_default_type] = "default_type",
  [field_default_value] = "default_value",
  [field_delimiter] = "delimiter",
  [field_designator] = "designator",
  [field_directive] = "directive",
  [field_end] = "end",
  [field_field] = "field",
  [field_filter] = "filter",
  [field_function] = "function",
  [field_goto_labels] = "goto_labels",
  [field_indices] = "indices",
  [field_initializer] = "initializer",
  [field_input_operands] = "input_operands",
  [field_label] = "label",
  [field_left] = "left",
  [field_length] = "length",
  [field_member] = "member",
  [field_message] = "message",
  [field_name] = "name",
  [field_operand] = "operand",
  [field_operator] = "operator",
  [field_output_operands] = "output_operands",
  [field_parameters] = "parameters",
  [field_path] = "path",
  [field_pattern] = "pattern",
  [field_placement] = "placement",
  [field_prefix] = "prefix",
  [field_register] = "register",
  [field_requirements] = "requirements",
  [field_right] = "right",
  [field_scope] = "scope",
  [field_size] = "size",
  [field_start] = "start",
  [field_symbol] = "symbol",
  [field_template_parameters] = "template_parameters",
  [field_type] = "type",
  [field_update] = "update",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [2] = {.index = 0, .length = 1},
  [3] = {.index = 1, .length = 1},
  [4] = {.index = 2, .length = 2},
  [5] = {.index = 4, .length = 1},
  [6] = {.index = 5, .length = 1},
  [7] = {.index = 6, .length = 1},
  [8] = {.index = 7, .length = 1},
  [9] = {.index = 8, .length = 1},
  [10] = {.index = 9, .length = 2},
  [11] = {.index = 11, .length = 2},
  [12] = {.index = 13, .length = 1},
  [13] = {.index = 14, .length = 1},
  [14] = {.index = 15, .length = 2},
  [15] = {.index = 15, .length = 2},
  [16] = {.index = 0, .length = 1},
  [18] = {.index = 17, .length = 1},
  [19] = {.index = 18, .length = 1},
  [20] = {.index = 19, .length = 1},
  [21] = {.index = 20, .length = 1},
  [22] = {.index = 21, .length = 2},
  [23] = {.index = 23, .length = 2},
  [24] = {.index = 25, .length = 1},
  [25] = {.index = 26, .length = 1},
  [26] = {.index = 27, .length = 2},
  [27] = {.index = 29, .length = 2},
  [28] = {.index = 31, .length = 1},
  [29] = {.index = 32, .length = 2},
  [30] = {.index = 34, .length = 2},
  [31] = {.index = 14, .length = 1},
  [32] = {.index = 36, .length = 2},
  [33] = {.index = 38, .length = 1},
  [34] = {.index = 39, .length = 2},
  [35] = {.index = 39, .length = 2},
  [36] = {.index = 17, .length = 1},
  [37] = {.index = 41, .length = 1},
  [38] = {.index = 42, .length = 2},
  [39] = {.index = 44, .length = 2},
  [40] = {.index = 46, .length = 3},
  [41] = {.index = 49, .length = 1},
  [44] = {.index = 50, .length = 2},
  [45] = {.index = 52, .length = 1},
  [46] = {.index = 53, .length = 1},
  [47] = {.index = 54, .length = 1},
  [48] = {.index = 55, .length = 2},
  [49] = {.index = 57, .length = 2},
  [50] = {.index = 59, .length = 2},
  [51] = {.index = 61, .length = 2},
  [52] = {.index = 63, .length = 2},
  [53] = {.index = 65, .length = 1},
  [54] = {.index = 66, .length = 3},
  [55] = {.index = 69, .length = 1},
  [56] = {.index = 70, .length = 1},
  [57] = {.index = 71, .length = 1},
  [58] = {.index = 72, .length = 2},
  [60] = {.index = 55, .length = 2},
  [61] = {.index = 74, .length = 2},
  [62] = {.index = 76, .length = 2},
  [63] = {.index = 78, .length = 2},
  [65] = {.index = 80, .length = 2},
  [66] = {.index = 82, .length = 2},
  [67] = {.index = 84, .length = 3},
  [68] = {.index = 87, .length = 2},
  [69] = {.index = 89, .length = 2},
  [70] = {.index = 91, .length = 3},
  [71] = {.index = 91, .length = 3},
  [72] = {.index = 94, .length = 3},
  [73] = {.index = 97, .length = 3},
  [74] = {.index = 100, .length = 3},
  [75] = {.index = 103, .length = 2},
  [76] = {.index = 105, .length = 2},
  [77] = {.index = 107, .length = 2},
  [78] = {.index = 109, .length = 1},
  [79] = {.index = 110, .length = 2},
  [80] = {.index = 112, .length = 2},
  [81] = {.index = 114, .length = 2},
  [82] = {.index = 116, .length = 3},
  [83] = {.index = 119, .length = 2},
  [84] = {.index = 121, .length = 1},
  [85] = {.index = 122, .length = 2},
  [86] = {.index = 124, .length = 2},
  [87] = {.index = 126, .length = 2},
  [88] = {.index = 128, .length = 2},
  [89] = {.index = 130, .length = 2},
  [90] = {.index = 132, .length = 2},
  [91] = {.index = 134, .length = 2},
  [92] = {.index = 136, .length = 2},
  [93] = {.index = 138, .length = 1},
  [94] = {.index = 136, .length = 2},
  [95] = {.index = 139, .length = 2},
  [96] = {.index = 141, .length = 1},
  [97] = {.index = 141, .length = 1},
  [98] = {.index = 142, .length = 3},
  [100] = {.index = 145, .length = 2},
  [101] = {.index = 147, .length = 2},
  [102] = {.index = 149, .length = 2},
  [103] = {.index = 151, .length = 3},
  [104] = {.index = 154, .length = 1},
  [106] = {.index = 155, .length = 1},
  [108] = {.index = 156, .length = 3},
  [109] = {.index = 159, .length = 3},
  [110] = {.index = 162, .length = 3},
  [111] = {.index = 165, .length = 3},
  [112] = {.index = 168, .length = 2},
  [113] = {.index = 170, .length = 3},
  [114] = {.index = 173, .length = 3},
  [115] = {.index = 176, .length = 2},
  [116] = {.index = 178, .length = 3},
  [117] = {.index = 181, .length = 2},
  [118] = {.index = 15, .length = 2},
  [119] = {.index = 39, .length = 2},
  [120] = {.index = 183, .length = 2},
  [121] = {.index = 185, .length = 2},
  [122] = {.index = 187, .length = 1},
  [123] = {.index = 188, .length = 4},
  [124] = {.index = 192, .length = 4},
  [125] = {.index = 196, .length = 2},
  [126] = {.index = 198, .length = 3},
  [127] = {.index = 201, .length = 2},
  [128] = {.index = 203, .length = 2},
  [129] = {.index = 205, .length = 1},
  [130] = {.index = 206, .length = 2},
  [131] = {.index = 208, .length = 2},
  [132] = {.index = 210, .length = 3},
  [133] = {.index = 213, .length = 3},
  [134] = {.index = 216, .length = 3},
  [135] = {.index = 219, .length = 2},
  [136] = {.index = 219, .length = 2},
  [137] = {.index = 221, .length = 2},
  [138] = {.index = 223, .length = 3},
  [139] = {.index = 226, .length = 2},
  [140] = {.index = 228, .length = 2},
  [141] = {.index = 230, .length = 3},
  [142] = {.index = 233, .length = 2},
  [143] = {.index = 235, .length = 3},
  [144] = {.index = 238, .length = 2},
  [145] = {.index = 240, .length = 1},
  [146] = {.index = 241, .length = 2},
  [147] = {.index = 243, .length = 2},
  [148] = {.index = 245, .length = 4},
  [149] = {.index = 249, .length = 5},
  [150] = {.index = 254, .length = 2},
  [151] = {.index = 254, .length = 2},
  [152] = {.index = 256, .length = 1},
  [153] = {.index = 257, .length = 1},
  [154] = {.index = 258, .length = 2},
  [155] = {.index = 260, .length = 1},
  [157] = {.index = 261, .length = 1},
  [158] = {.index = 262, .length = 2},
  [159] = {.index = 264, .length = 2},
  [160] = {.index = 7, .length = 1},
  [161] = {.index = 7, .length = 1},
  [162] = {.index = 266, .length = 2},
  [163] = {.index = 268, .length = 1},
  [164] = {.index = 269, .length = 1},
  [165] = {.index = 270, .length = 4},
  [166] = {.index = 274, .length = 2},
  [167] = {.index = 276, .length = 4},
  [168] = {.index = 280, .length = 1},
  [169] = {.index = 281, .length = 3},
  [170] = {.index = 284, .length = 2},
  [171] = {.index = 286, .length = 3},
  [172] = {.index = 289, .length = 1},
  [173] = {.index = 290, .length = 5},
  [174] = {.index = 295, .length = 2},
  [175] = {.index = 297, .length = 2},
  [176] = {.index = 299, .length = 4},
  [177] = {.index = 303, .length = 2},
  [178] = {.index = 305, .length = 3},
  [179] = {.index = 308, .length = 4},
  [180] = {.index = 312, .length = 4},
  [181] = {.index = 316, .length = 3},
  [182] = {.index = 319, .length = 2},
  [183] = {.index = 321, .length = 3},
  [184] = {.index = 324, .length = 3},
  [185] = {.index = 327, .length = 2},
  [186] = {.index = 329, .length = 2},
  [187] = {.index = 331, .length = 2},
  [188] = {.index = 333, .length = 2},
  [189] = {.index = 335, .length = 3},
  [190] = {.index = 338, .length = 2},
  [191] = {.index = 340, .length = 2},
  [192] = {.index = 342, .length = 3},
  [193] = {.index = 345, .length = 2},
  [194] = {.index = 347, .length = 2},
  [195] = {.index = 349, .length = 4},
  [196] = {.index = 353, .length = 5},
  [197] = {.index = 358, .length = 3},
  [198] = {.index = 361, .length = 4},
  [199] = {.index = 365, .length = 2},
  [200] = {.index = 367, .length = 2},
  [201] = {.index = 369, .length = 1},
  [202] = {.index = 370, .length = 4},
  [203] = {.index = 374, .length = 3},
  [204] = {.index = 377, .length = 2},
  [205] = {.index = 379, .length = 1},
  [206] = {.index = 380, .length = 5},
  [207] = {.index = 385, .length = 2},
  [208] = {.index = 387, .length = 2},
  [209] = {.index = 65, .length = 1},
  [210] = {.index = 389, .length = 5},
  [211] = {.index = 394, .length = 4},
  [212] = {.index = 398, .length = 2},
  [213] = {.index = 400, .length = 2},
  [214] = {.index = 402, .length = 5},
  [215] = {.index = 407, .length = 2},
  [216] = {.index = 409, .length = 3},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_type, 0},
  [1] =
    {field_directive, 0},
  [2] =
    {field_argument, 1},
    {field_operator, 0},
  [4] =
    {field_declarator, 1},
  [5] =
    {field_name, 0},
  [6] =
    {field_body, 1},
  [7] =
    {field_name, 1},
  [8] =
    {field_body, 0},
  [9] =
    {field_body, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [11] =
    {field_body, 0, .inherited = true},
    {field_name, 0, .inherited = true},
  [13] =
    {field_value, 1},
  [14] =
    {field_scope, 0},
  [15] =
    {field_arguments, 1},
    {field_name, 0},
  [17] =
    {field_type, 1},
  [18] =
    {field_requirements, 1},
  [19] =
    {field_constraint, 1},
  [20] =
    {field_parameters, 0},
  [21] =
    {field_declarator, 0},
    {field_parameters, 1, .inherited = true},
  [23] =
    {field_body, 1},
    {field_declarator, 0},
  [25] =
    {field_declarator, 0},
  [26] =
    {field_constraint, 0},
  [27] =
    {field_arguments, 1},
    {field_function, 0},
  [29] =
    {field_type, 0},
    {field_value, 1},
  [31] =
    {field_pattern, 0},
  [32] =
    {field_argument, 0},
    {field_operator, 1},
  [34] =
    {field_argument, 0},
    {field_indices, 1},
  [36] =
    {field_body, 1},
    {field_captures, 0},
  [38] =
    {field_parameters, 0, .inherited = true},
  [39] =
    {field_name, 1},
    {field_scope, 0, .inherited = true},
  [41] =
    {field_path, 1},
  [42] =
    {field_argument, 1},
    {field_directive, 0},
  [44] =
    {field_declarator, 1},
    {field_type, 0},
  [46] =
    {field_left, 1, .inherited = true},
    {field_operator, 1, .inherited = true},
    {field_right, 1, .inherited = true},
  [49] =
    {field_declarator, 2},
  [50] =
    {field_body, 2},
    {field_value, 1},
  [52] =
    {field_type, 2},
  [53] =
    {field_body, 2},
  [54] =
    {field_name, 2},
  [55] =
    {field_body, 2},
    {field_name, 1},
  [57] =
    {field_base, 2, .inherited = true},
    {field_name, 1},
  [59] =
    {field_body, 1},
    {field_name, 0},
  [61] =
    {field_condition, 1},
    {field_consequence, 2},
  [63] =
    {field_body, 2},
    {field_condition, 1},
  [65] =
    {field_label, 1},
  [66] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [69] =
    {field_label, 0},
  [70] =
    {field_type, 0, .inherited = true},
  [71] =
    {field_parameters, 1},
  [72] =
    {field_declarator, 2},
    {field_type, 1, .inherited = true},
  [74] =
    {field_arguments, 2},
    {field_type, 1},
  [76] =
    {field_declarator, 2},
    {field_type, 1},
  [78] =
    {field_placement, 1},
    {field_type, 2},
  [80] =
    {field_parameters, 1},
    {field_requirements, 2},
  [82] =
    {field_declarator, 1},
    {field_type, 0, .inherited = true},
  [84] =
    {field_body, 2},
    {field_declarator, 1},
    {field_type, 0, .inherited = true},
  [87] =
    {field_declarator, 0},
    {field_value, 1},
  [89] =
    {field_body, 2},
    {field_declarator, 0},
  [91] =
    {field_argument, 0},
    {field_field, 2},
    {field_operator, 1},
  [94] =
    {field_body, 2},
    {field_captures, 0},
    {field_declarator, 1},
  [97] =
    {field_body, 2},
    {field_captures, 0},
    {field_template_parameters, 1},
  [100] =
    {field_name, 1},
    {field_name, 2},
    {field_scope, 0, .inherited = true},
  [103] =
    {field_body, 2},
    {field_declarator, 1},
  [105] =
    {field_name, 1},
    {field_value, 2},
  [107] =
    {field_name, 1},
    {field_parameters, 2},
  [109] =
    {field_condition, 1},
  [110] =
    {field_alternative, 2},
    {field_name, 1},
  [112] =
    {field_declarator, 2},
    {field_type, 0},
  [114] =
    {field_left, 0},
    {field_right, 2},
  [116] =
    {field_left, 0},
    {field_operator, 1, .inherited = true},
    {field_right, 2},
  [119] =
    {field_type, 1},
    {field_value, 3},
  [121] =
    {field_declarator, 3},
  [122] =
    {field_declarator, 2, .inherited = true},
    {field_type, 1, .inherited = true},
  [124] =
    {field_declarator, 0},
    {field_parameters, 1},
  [126] =
    {field_declarator, 0},
    {field_declarator, 1, .inherited = true},
  [128] =
    {field_arguments, 3},
    {field_type, 2},
  [130] =
    {field_declarator, 3},
    {field_type, 2},
  [132] =
    {field_placement, 2},
    {field_type, 3},
  [134] =
    {field_name, 2},
    {field_prefix, 0},
  [136] =
    {field_body, 3},
    {field_name, 2},
  [138] =
    {field_body, 3},
  [139] =
    {field_base, 3, .inherited = true},
    {field_name, 2},
  [141] =
    {field_base, 1},
  [142] =
    {field_base, 2, .inherited = true},
    {field_body, 3},
    {field_name, 1},
  [145] =
    {field_body, 2, .inherited = true},
    {field_name, 2, .inherited = true},
  [147] =
    {field_body, 2},
    {field_name, 0},
  [149] =
    {field_condition, 2},
    {field_consequence, 3},
  [151] =
    {field_alternative, 3},
    {field_condition, 1},
    {field_consequence, 2},
  [154] =
    {field_initializer, 0},
  [155] =
    {field_assembly_code, 2},
  [156] =
    {field_arguments, 3},
    {field_declarator, 2},
    {field_type, 1},
  [159] =
    {field_arguments, 3},
    {field_placement, 1},
    {field_type, 2},
  [162] =
    {field_declarator, 3},
    {field_placement, 1},
    {field_type, 2},
  [165] =
    {field_body, 3},
    {field_declarator, 2},
    {field_type, 0, .inherited = true},
  [168] =
    {field_declarator, 0},
    {field_value, 2},
  [170] =
    {field_declarator, 1},
    {field_declarator, 2},
    {field_type, 0, .inherited = true},
  [173] =
    {field_declarator, 1},
    {field_declarator, 2, .inherited = true},
    {field_type, 0, .inherited = true},
  [176] =
    {field_declarator, 0, .inherited = true},
    {field_declarator, 1, .inherited = true},
  [178] =
    {field_body, 3},
    {field_declarator, 2},
    {field_type, 1, .inherited = true},
  [181] =
    {field_declarator, 0},
    {field_size, 2},
  [183] =
    {field_alternative, 3},
    {field_condition, 0},
  [185] =
    {field_declarator, 0},
    {field_default_value, 2},
  [187] =
    {field_size, 1},
  [188] =
    {field_body, 3},
    {field_captures, 0},
    {field_declarator, 2},
    {field_template_parameters, 1},
  [192] =
    {field_body, 3},
    {field_captures, 0},
    {field_constraint, 2},
    {field_template_parameters, 1},
  [196] =
    {field_body, 3},
    {field_declarator, 1},
  [198] =
    {field_name, 1},
    {field_parameters, 2},
    {field_value, 3},
  [201] =
    {field_alternative, 3},
    {field_condition, 1},
  [203] =
    {field_alternative, 3},
    {field_name, 1},
  [205] =
    {field_operator, 0},
  [206] =
    {field_declarator, 3},
    {field_type, 1},
  [208] =
    {field_declarator, 3, .inherited = true},
    {field_type, 2, .inherited = true},
  [210] =
    {field_arguments, 4},
    {field_declarator, 3},
    {field_type, 2},
  [213] =
    {field_arguments, 4},
    {field_placement, 2},
    {field_type, 3},
  [216] =
    {field_declarator, 4},
    {field_placement, 2},
    {field_type, 3},
  [219] =
    {field_body, 4},
    {field_name, 3},
  [221] =
    {field_name, 0},
    {field_value, 2},
  [223] =
    {field_base, 3, .inherited = true},
    {field_body, 4},
    {field_name, 2},
  [226] =
    {field_body, 3},
    {field_name, 0},
  [228] =
    {field_body, 3, .inherited = true},
    {field_name, 3, .inherited = true},
  [230] =
    {field_declarator, 1},
    {field_type, 0, .inherited = true},
    {field_value, 2},
  [233] =
    {field_initializer, 1},
    {field_value, 2},
  [235] =
    {field_alternative, 4},
    {field_condition, 2},
    {field_consequence, 3},
  [238] =
    {field_body, 1},
    {field_condition, 3},
  [240] =
    {field_update, 2},
  [241] =
    {field_initializer, 0},
    {field_update, 2},
  [243] =
    {field_condition, 1},
    {field_initializer, 0},
  [245] =
    {field_body, 4},
    {field_condition, 2, .inherited = true},
    {field_initializer, 2, .inherited = true},
    {field_update, 2, .inherited = true},
  [249] =
    {field_body, 4},
    {field_declarator, 2, .inherited = true},
    {field_initializer, 2, .inherited = true},
    {field_right, 2, .inherited = true},
    {field_type, 2, .inherited = true},
  [254] =
    {field_designator, 0},
    {field_value, 2},
  [256] =
    {field_value, 3},
  [257] =
    {field_operand, 1},
  [258] =
    {field_assembly_code, 2},
    {field_output_operands, 3},
  [260] =
    {field_assembly_code, 3},
  [261] =
    {field_default_type, 2},
  [262] =
    {field_default_value, 2},
    {field_type, 0, .inherited = true},
  [264] =
    {field_body, 2},
    {field_parameters, 1},
  [266] =
    {field_name, 1},
    {field_type, 3},
  [268] =
    {field_condition, 2},
  [269] =
    {field_length, 1},
  [270] =
    {field_arguments, 4},
    {field_declarator, 3},
    {field_placement, 1},
    {field_type, 2},
  [274] =
    {field_declarator, 1},
    {field_declarator, 2},
  [276] =
    {field_declarator, 1},
    {field_declarator, 2},
    {field_declarator, 3, .inherited = true},
    {field_type, 0, .inherited = true},
  [280] =
    {field_declarator, 4},
  [281] =
    {field_body, 4},
    {field_declarator, 3},
    {field_type, 1, .inherited = true},
  [284] =
    {field_declarator, 0},
    {field_size, 3},
  [286] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [289] =
    {field_size, 2},
  [290] =
    {field_body, 4},
    {field_captures, 0},
    {field_constraint, 2},
    {field_declarator, 3},
    {field_template_parameters, 1},
  [295] =
    {field_declarator, 1},
    {field_default_value, 3},
  [297] =
    {field_alternative, 4},
    {field_condition, 1},
  [299] =
    {field_arguments, 5},
    {field_declarator, 4},
    {field_placement, 2},
    {field_type, 3},
  [303] =
    {field_body, 2},
    {field_filter, 1},
  [305] =
    {field_declarator, 1},
    {field_default_value, 2},
    {field_type, 0, .inherited = true},
  [308] =
    {field_declarator, 1},
    {field_declarator, 2, .inherited = true},
    {field_default_value, 2, .inherited = true},
    {field_type, 0, .inherited = true},
  [312] =
    {field_declarator, 0, .inherited = true},
    {field_declarator, 1, .inherited = true},
    {field_default_value, 0, .inherited = true},
    {field_default_value, 1, .inherited = true},
  [316] =
    {field_declarator, 1},
    {field_type, 0, .inherited = true},
    {field_value, 3},
  [319] =
    {field_condition, 1},
    {field_update, 3},
  [321] =
    {field_condition, 1},
    {field_initializer, 0},
    {field_update, 3},
  [324] =
    {field_declarator, 1},
    {field_right, 3},
    {field_type, 0, .inherited = true},
  [327] =
    {field_initializer, 0},
    {field_update, 3},
  [329] =
    {field_condition, 2},
    {field_initializer, 0},
  [331] =
    {field_member, 4},
    {field_type, 2},
  [333] =
    {field_operand, 1},
    {field_operand, 2, .inherited = true},
  [335] =
    {field_assembly_code, 2},
    {field_input_operands, 4},
    {field_output_operands, 3},
  [338] =
    {field_assembly_code, 3},
    {field_output_operands, 4},
  [340] =
    {field_default_type, 3},
    {field_name, 1},
  [342] =
    {field_declarator, 1},
    {field_default_value, 3},
    {field_type, 0, .inherited = true},
  [345] =
    {field_name, 1},
    {field_type, 4},
  [347] =
    {field_declarator, 1},
    {field_default_value, 2},
  [349] =
    {field_declarator, 1},
    {field_declarator, 3, .inherited = true},
    {field_default_value, 3, .inherited = true},
    {field_type, 0, .inherited = true},
  [353] =
    {field_declarator, 1},
    {field_declarator, 3, .inherited = true},
    {field_default_value, 2},
    {field_default_value, 3, .inherited = true},
    {field_type, 0, .inherited = true},
  [358] =
    {field_condition, 2},
    {field_initializer, 0},
    {field_update, 4},
  [361] =
    {field_declarator, 2},
    {field_initializer, 0},
    {field_right, 4},
    {field_type, 1, .inherited = true},
  [365] =
    {field_end, 3},
    {field_start, 1},
  [367] =
    {field_operand, 0, .inherited = true},
    {field_operand, 1, .inherited = true},
  [369] =
    {field_register, 1},
  [370] =
    {field_assembly_code, 2},
    {field_clobbers, 5},
    {field_input_operands, 4},
    {field_output_operands, 3},
  [374] =
    {field_assembly_code, 3},
    {field_input_operands, 5},
    {field_output_operands, 4},
  [377] =
    {field_condition, 2},
    {field_message, 4},
  [379] =
    {field_delimiter, 1},
  [380] =
    {field_declarator, 1},
    {field_declarator, 4, .inherited = true},
    {field_default_value, 3},
    {field_default_value, 4, .inherited = true},
    {field_type, 0, .inherited = true},
  [385] =
    {field_constraint, 0},
    {field_value, 2},
  [387] =
    {field_register, 1},
    {field_register, 2, .inherited = true},
  [389] =
    {field_assembly_code, 2},
    {field_clobbers, 5},
    {field_goto_labels, 6},
    {field_input_operands, 4},
    {field_output_operands, 3},
  [394] =
    {field_assembly_code, 3},
    {field_clobbers, 6},
    {field_input_operands, 5},
    {field_output_operands, 4},
  [398] =
    {field_register, 0, .inherited = true},
    {field_register, 1, .inherited = true},
  [400] =
    {field_label, 1},
    {field_label, 2, .inherited = true},
  [402] =
    {field_assembly_code, 3},
    {field_clobbers, 6},
    {field_goto_labels, 7},
    {field_input_operands, 5},
    {field_output_operands, 4},
  [407] =
    {field_label, 0, .inherited = true},
    {field_label, 1, .inherited = true},
  [409] =
    {field_constraint, 3},
    {field_symbol, 1},
    {field_value, 5},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = alias_sym_type_identifier,
  },
  [13] = {
    [0] = alias_sym_namespace_identifier,
  },
  [14] = {
    [0] = alias_sym_type_identifier,
  },
  [16] = {
    [0] = alias_sym_type_identifier,
  },
  [17] = {
    [0] = alias_sym_namespace_identifier,
  },
  [35] = {
    [1] = alias_sym_type_identifier,
  },
  [36] = {
    [1] = alias_sym_type_identifier,
  },
  [42] = {
    [0] = sym_primitive_type,
  },
  [43] = {
    [0] = sym_pointer_declarator,
  },
  [53] = {
    [1] = alias_sym_statement_identifier,
  },
  [55] = {
    [0] = alias_sym_statement_identifier,
  },
  [59] = {
    [1] = alias_sym_namespace_identifier,
  },
  [60] = {
    [1] = alias_sym_namespace_identifier,
  },
  [64] = {
    [0] = alias_sym_simple_requirement,
  },
  [70] = {
    [2] = alias_sym_field_identifier,
  },
  [92] = {
    [2] = alias_sym_namespace_identifier,
  },
  [96] = {
    [1] = alias_sym_type_identifier,
  },
  [99] = {
    [0] = alias_sym_field_identifier,
  },
  [105] = {
    [1] = alias_sym_field_identifier,
  },
  [107] = {
    [1] = alias_sym_type_identifier,
  },
  [118] = {
    [0] = alias_sym_field_identifier,
  },
  [119] = {
    [1] = alias_sym_field_identifier,
  },
  [135] = {
    [3] = alias_sym_namespace_identifier,
  },
  [150] = {
    [0] = alias_sym_field_identifier,
  },
  [156] = {
    [2] = alias_sym_type_identifier,
  },
  [160] = {
    [1] = alias_sym_namespace_identifier,
    [3] = alias_sym_namespace_identifier,
  },
  [161] = {
    [1] = alias_sym_namespace_identifier,
  },
  [162] = {
    [1] = alias_sym_type_identifier,
  },
  [187] = {
    [4] = alias_sym_field_identifier,
  },
  [191] = {
    [1] = alias_sym_type_identifier,
  },
  [193] = {
    [1] = alias_sym_type_identifier,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym_pointer_type_declarator, 2,
    sym_pointer_type_declarator,
    sym_pointer_declarator,
  sym_expression_statement, 2,
    sym_expression_statement,
    alias_sym_simple_requirement,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 2,
  [4] = 2,
  [5] = 2,
  [6] = 2,
  [7] = 2,
  [8] = 2,
  [9] = 2,
  [10] = 2,
  [11] = 2,
  [12] = 2,
  [13] = 13,
  [14] = 14,
  [15] = 15,
  [16] = 13,
  [17] = 13,
  [18] = 14,
  [19] = 19,
  [20] = 19,
  [21] = 21,
  [22] = 14,
  [23] = 23,
  [24] = 14,
  [25] = 19,
  [26] = 21,
  [27] = 21,
  [28] = 28,
  [29] = 21,
  [30] = 19,
  [31] = 31,
  [32] = 13,
  [33] = 33,
  [34] = 34,
  [35] = 35,
  [36] = 34,
  [37] = 35,
  [38] = 35,
  [39] = 34,
  [40] = 35,
  [41] = 35,
  [42] = 34,
  [43] = 35,
  [44] = 44,
  [45] = 34,
  [46] = 44,
  [47] = 44,
  [48] = 35,
  [49] = 34,
  [50] = 35,
  [51] = 51,
  [52] = 34,
  [53] = 53,
  [54] = 33,
  [55] = 35,
  [56] = 34,
  [57] = 35,
  [58] = 34,
  [59] = 34,
  [60] = 35,
  [61] = 35,
  [62] = 53,
  [63] = 44,
  [64] = 34,
  [65] = 34,
  [66] = 33,
  [67] = 67,
  [68] = 34,
  [69] = 34,
  [70] = 34,
  [71] = 35,
  [72] = 53,
  [73] = 35,
  [74] = 35,
  [75] = 53,
  [76] = 34,
  [77] = 35,
  [78] = 34,
  [79] = 35,
  [80] = 80,
  [81] = 81,
  [82] = 82,
  [83] = 83,
  [84] = 84,
  [85] = 85,
  [86] = 86,
  [87] = 86,
  [88] = 84,
  [89] = 83,
  [90] = 82,
  [91] = 85,
  [92] = 84,
  [93] = 86,
  [94] = 84,
  [95] = 82,
  [96] = 83,
  [97] = 82,
  [98] = 86,
  [99] = 85,
  [100] = 83,
  [101] = 85,
  [102] = 83,
  [103] = 84,
  [104] = 85,
  [105] = 82,
  [106] = 86,
  [107] = 107,
  [108] = 107,
  [109] = 107,
  [110] = 107,
  [111] = 107,
  [112] = 107,
  [113] = 113,
  [114] = 114,
  [115] = 114,
  [116] = 114,
  [117] = 117,
  [118] = 114,
  [119] = 114,
  [120] = 114,
  [121] = 121,
  [122] = 121,
  [123] = 121,
  [124] = 124,
  [125] = 125,
  [126] = 125,
  [127] = 127,
  [128] = 128,
  [129] = 129,
  [130] = 125,
  [131] = 125,
  [132] = 132,
  [133] = 133,
  [134] = 133,
  [135] = 135,
  [136] = 136,
  [137] = 137,
  [138] = 138,
  [139] = 132,
  [140] = 137,
  [141] = 136,
  [142] = 142,
  [143] = 133,
  [144] = 125,
  [145] = 137,
  [146] = 142,
  [147] = 142,
  [148] = 135,
  [149] = 149,
  [150] = 132,
  [151] = 151,
  [152] = 151,
  [153] = 138,
  [154] = 142,
  [155] = 138,
  [156] = 125,
  [157] = 157,
  [158] = 133,
  [159] = 151,
  [160] = 138,
  [161] = 135,
  [162] = 135,
  [163] = 137,
  [164] = 142,
  [165] = 157,
  [166] = 151,
  [167] = 133,
  [168] = 132,
  [169] = 149,
  [170] = 157,
  [171] = 136,
  [172] = 157,
  [173] = 157,
  [174] = 149,
  [175] = 136,
  [176] = 157,
  [177] = 149,
  [178] = 136,
  [179] = 151,
  [180] = 132,
  [181] = 133,
  [182] = 132,
  [183] = 138,
  [184] = 135,
  [185] = 149,
  [186] = 137,
  [187] = 136,
  [188] = 135,
  [189] = 138,
  [190] = 151,
  [191] = 137,
  [192] = 149,
  [193] = 193,
  [194] = 193,
  [195] = 193,
  [196] = 193,
  [197] = 197,
  [198] = 197,
  [199] = 193,
  [200] = 193,
  [201] = 193,
  [202] = 193,
  [203] = 197,
  [204] = 197,
  [205] = 193,
  [206] = 197,
  [207] = 197,
  [208] = 197,
  [209] = 197,
  [210] = 197,
  [211] = 125,
  [212] = 197,
  [213] = 197,
  [214] = 193,
  [215] = 197,
  [216] = 193,
  [217] = 193,
  [218] = 193,
  [219] = 197,
  [220] = 220,
  [221] = 221,
  [222] = 222,
  [223] = 223,
  [224] = 224,
  [225] = 225,
  [226] = 128,
  [227] = 227,
  [228] = 127,
  [229] = 229,
  [230] = 230,
  [231] = 231,
  [232] = 232,
  [233] = 233,
  [234] = 234,
  [235] = 235,
  [236] = 232,
  [237] = 232,
  [238] = 238,
  [239] = 239,
  [240] = 240,
  [241] = 241,
  [242] = 232,
  [243] = 243,
  [244] = 244,
  [245] = 245,
  [246] = 246,
  [247] = 247,
  [248] = 248,
  [249] = 249,
  [250] = 250,
  [251] = 251,
  [252] = 252,
  [253] = 232,
  [254] = 254,
  [255] = 255,
  [256] = 256,
  [257] = 257,
  [258] = 258,
  [259] = 259,
  [260] = 260,
  [261] = 261,
  [262] = 262,
  [263] = 263,
  [264] = 264,
  [265] = 265,
  [266] = 266,
  [267] = 267,
  [268] = 232,
  [269] = 269,
  [270] = 270,
  [271] = 271,
  [272] = 272,
  [273] = 273,
  [274] = 274,
  [275] = 275,
  [276] = 276,
  [277] = 277,
  [278] = 278,
  [279] = 279,
  [280] = 280,
  [281] = 281,
  [282] = 282,
  [283] = 283,
  [284] = 284,
  [285] = 232,
  [286] = 286,
  [287] = 287,
  [288] = 288,
  [289] = 289,
  [290] = 290,
  [291] = 232,
  [292] = 292,
  [293] = 293,
  [294] = 232,
  [295] = 295,
  [296] = 296,
  [297] = 297,
  [298] = 298,
  [299] = 299,
  [300] = 300,
  [301] = 301,
  [302] = 302,
  [303] = 303,
  [304] = 304,
  [305] = 305,
  [306] = 306,
  [307] = 232,
  [308] = 308,
  [309] = 309,
  [310] = 310,
  [311] = 232,
  [312] = 312,
  [313] = 313,
  [314] = 314,
  [315] = 315,
  [316] = 232,
  [317] = 317,
  [318] = 318,
  [319] = 232,
  [320] = 232,
  [321] = 321,
  [322] = 232,
  [323] = 232,
  [324] = 232,
  [325] = 325,
  [326] = 326,
  [327] = 327,
  [328] = 328,
  [329] = 329,
  [330] = 330,
  [331] = 331,
  [332] = 332,
  [333] = 333,
  [334] = 334,
  [335] = 335,
  [336] = 221,
  [337] = 337,
  [338] = 338,
  [339] = 339,
  [340] = 340,
  [341] = 341,
  [342] = 342,
  [343] = 343,
  [344] = 221,
  [345] = 345,
  [346] = 346,
  [347] = 347,
  [348] = 348,
  [349] = 345,
  [350] = 350,
  [351] = 351,
  [352] = 352,
  [353] = 353,
  [354] = 354,
  [355] = 355,
  [356] = 221,
  [357] = 332,
  [358] = 358,
  [359] = 359,
  [360] = 360,
  [361] = 361,
  [362] = 362,
  [363] = 363,
  [364] = 364,
  [365] = 365,
  [366] = 366,
  [367] = 363,
  [368] = 220,
  [369] = 369,
  [370] = 332,
  [371] = 371,
  [372] = 372,
  [373] = 373,
  [374] = 374,
  [375] = 375,
  [376] = 376,
  [377] = 377,
  [378] = 378,
  [379] = 379,
  [380] = 380,
  [381] = 381,
  [382] = 382,
  [383] = 383,
  [384] = 384,
  [385] = 385,
  [386] = 386,
  [387] = 387,
  [388] = 388,
  [389] = 363,
  [390] = 390,
  [391] = 391,
  [392] = 392,
  [393] = 393,
  [394] = 394,
  [395] = 220,
  [396] = 396,
  [397] = 397,
  [398] = 358,
  [399] = 399,
  [400] = 400,
  [401] = 348,
  [402] = 220,
  [403] = 403,
  [404] = 404,
  [405] = 405,
  [406] = 406,
  [407] = 407,
  [408] = 408,
  [409] = 348,
  [410] = 410,
  [411] = 411,
  [412] = 412,
  [413] = 413,
  [414] = 414,
  [415] = 415,
  [416] = 416,
  [417] = 358,
  [418] = 418,
  [419] = 419,
  [420] = 420,
  [421] = 222,
  [422] = 222,
  [423] = 223,
  [424] = 223,
  [425] = 227,
  [426] = 127,
  [427] = 224,
  [428] = 224,
  [429] = 128,
  [430] = 224,
  [431] = 127,
  [432] = 229,
  [433] = 229,
  [434] = 227,
  [435] = 229,
  [436] = 128,
  [437] = 227,
  [438] = 308,
  [439] = 274,
  [440] = 261,
  [441] = 315,
  [442] = 125,
  [443] = 303,
  [444] = 264,
  [445] = 315,
  [446] = 259,
  [447] = 318,
  [448] = 318,
  [449] = 260,
  [450] = 303,
  [451] = 257,
  [452] = 304,
  [453] = 309,
  [454] = 312,
  [455] = 313,
  [456] = 269,
  [457] = 305,
  [458] = 308,
  [459] = 256,
  [460] = 263,
  [461] = 241,
  [462] = 255,
  [463] = 306,
  [464] = 302,
  [465] = 298,
  [466] = 243,
  [467] = 244,
  [468] = 245,
  [469] = 254,
  [470] = 246,
  [471] = 301,
  [472] = 248,
  [473] = 317,
  [474] = 300,
  [475] = 325,
  [476] = 270,
  [477] = 233,
  [478] = 321,
  [479] = 255,
  [480] = 298,
  [481] = 241,
  [482] = 252,
  [483] = 272,
  [484] = 299,
  [485] = 243,
  [486] = 273,
  [487] = 251,
  [488] = 244,
  [489] = 245,
  [490] = 274,
  [491] = 246,
  [492] = 262,
  [493] = 248,
  [494] = 295,
  [495] = 255,
  [496] = 293,
  [497] = 310,
  [498] = 287,
  [499] = 265,
  [500] = 266,
  [501] = 250,
  [502] = 262,
  [503] = 249,
  [504] = 263,
  [505] = 267,
  [506] = 271,
  [507] = 275,
  [508] = 262,
  [509] = 247,
  [510] = 278,
  [511] = 263,
  [512] = 321,
  [513] = 233,
  [514] = 309,
  [515] = 283,
  [516] = 289,
  [517] = 284,
  [518] = 286,
  [519] = 265,
  [520] = 266,
  [521] = 267,
  [522] = 271,
  [523] = 275,
  [524] = 278,
  [525] = 283,
  [526] = 305,
  [527] = 284,
  [528] = 276,
  [529] = 277,
  [530] = 286,
  [531] = 279,
  [532] = 280,
  [533] = 289,
  [534] = 325,
  [535] = 300,
  [536] = 309,
  [537] = 310,
  [538] = 281,
  [539] = 305,
  [540] = 310,
  [541] = 541,
  [542] = 317,
  [543] = 314,
  [544] = 235,
  [545] = 317,
  [546] = 325,
  [547] = 233,
  [548] = 240,
  [549] = 321,
  [550] = 304,
  [551] = 258,
  [552] = 318,
  [553] = 315,
  [554] = 314,
  [555] = 248,
  [556] = 313,
  [557] = 312,
  [558] = 308,
  [559] = 306,
  [560] = 282,
  [561] = 302,
  [562] = 314,
  [563] = 301,
  [564] = 300,
  [565] = 299,
  [566] = 313,
  [567] = 295,
  [568] = 246,
  [569] = 312,
  [570] = 265,
  [571] = 239,
  [572] = 288,
  [573] = 293,
  [574] = 306,
  [575] = 266,
  [576] = 302,
  [577] = 301,
  [578] = 290,
  [579] = 299,
  [580] = 287,
  [581] = 295,
  [582] = 293,
  [583] = 287,
  [584] = 235,
  [585] = 234,
  [586] = 238,
  [587] = 290,
  [588] = 235,
  [589] = 239,
  [590] = 292,
  [591] = 240,
  [592] = 247,
  [593] = 267,
  [594] = 271,
  [595] = 249,
  [596] = 250,
  [597] = 251,
  [598] = 238,
  [599] = 252,
  [600] = 254,
  [601] = 256,
  [602] = 234,
  [603] = 257,
  [604] = 258,
  [605] = 259,
  [606] = 260,
  [607] = 261,
  [608] = 264,
  [609] = 269,
  [610] = 270,
  [611] = 296,
  [612] = 272,
  [613] = 273,
  [614] = 245,
  [615] = 275,
  [616] = 238,
  [617] = 244,
  [618] = 297,
  [619] = 239,
  [620] = 274,
  [621] = 240,
  [622] = 247,
  [623] = 276,
  [624] = 249,
  [625] = 250,
  [626] = 304,
  [627] = 303,
  [628] = 251,
  [629] = 252,
  [630] = 297,
  [631] = 234,
  [632] = 254,
  [633] = 256,
  [634] = 243,
  [635] = 257,
  [636] = 258,
  [637] = 277,
  [638] = 279,
  [639] = 278,
  [640] = 289,
  [641] = 280,
  [642] = 281,
  [643] = 259,
  [644] = 282,
  [645] = 298,
  [646] = 260,
  [647] = 261,
  [648] = 286,
  [649] = 296,
  [650] = 264,
  [651] = 292,
  [652] = 269,
  [653] = 270,
  [654] = 288,
  [655] = 272,
  [656] = 297,
  [657] = 283,
  [658] = 284,
  [659] = 273,
  [660] = 296,
  [661] = 292,
  [662] = 290,
  [663] = 288,
  [664] = 282,
  [665] = 281,
  [666] = 280,
  [667] = 279,
  [668] = 277,
  [669] = 276,
  [670] = 241,
  [671] = 377,
  [672] = 416,
  [673] = 359,
  [674] = 371,
  [675] = 416,
  [676] = 394,
  [677] = 374,
  [678] = 393,
  [679] = 392,
  [680] = 415,
  [681] = 347,
  [682] = 391,
  [683] = 391,
  [684] = 382,
  [685] = 396,
  [686] = 390,
  [687] = 414,
  [688] = 387,
  [689] = 386,
  [690] = 334,
  [691] = 420,
  [692] = 384,
  [693] = 347,
  [694] = 374,
  [695] = 377,
  [696] = 364,
  [697] = 381,
  [698] = 373,
  [699] = 382,
  [700] = 371,
  [701] = 383,
  [702] = 385,
  [703] = 388,
  [704] = 415,
  [705] = 396,
  [706] = 369,
  [707] = 419,
  [708] = 361,
  [709] = 399,
  [710] = 360,
  [711] = 355,
  [712] = 354,
  [713] = 353,
  [714] = 394,
  [715] = 340,
  [716] = 413,
  [717] = 305,
  [718] = 361,
  [719] = 360,
  [720] = 339,
  [721] = 414,
  [722] = 418,
  [723] = 352,
  [724] = 350,
  [725] = 420,
  [726] = 346,
  [727] = 355,
  [728] = 354,
  [729] = 353,
  [730] = 393,
  [731] = 352,
  [732] = 350,
  [733] = 411,
  [734] = 390,
  [735] = 346,
  [736] = 373,
  [737] = 343,
  [738] = 343,
  [739] = 342,
  [740] = 341,
  [741] = 387,
  [742] = 386,
  [743] = 342,
  [744] = 341,
  [745] = 330,
  [746] = 340,
  [747] = 339,
  [748] = 329,
  [749] = 408,
  [750] = 338,
  [751] = 330,
  [752] = 329,
  [753] = 328,
  [754] = 408,
  [755] = 334,
  [756] = 326,
  [757] = 327,
  [758] = 337,
  [759] = 338,
  [760] = 328,
  [761] = 223,
  [762] = 392,
  [763] = 337,
  [764] = 359,
  [765] = 362,
  [766] = 419,
  [767] = 375,
  [768] = 376,
  [769] = 378,
  [770] = 379,
  [771] = 351,
  [772] = 397,
  [773] = 362,
  [774] = 403,
  [775] = 388,
  [776] = 365,
  [777] = 384,
  [778] = 366,
  [779] = 407,
  [780] = 365,
  [781] = 222,
  [782] = 412,
  [783] = 406,
  [784] = 366,
  [785] = 404,
  [786] = 413,
  [787] = 412,
  [788] = 364,
  [789] = 381,
  [790] = 369,
  [791] = 372,
  [792] = 380,
  [793] = 383,
  [794] = 385,
  [795] = 380,
  [796] = 411,
  [797] = 375,
  [798] = 376,
  [799] = 378,
  [800] = 399,
  [801] = 379,
  [802] = 418,
  [803] = 326,
  [804] = 327,
  [805] = 351,
  [806] = 397,
  [807] = 403,
  [808] = 407,
  [809] = 406,
  [810] = 404,
  [811] = 372,
  [812] = 334,
  [813] = 125,
  [814] = 418,
  [815] = 397,
  [816] = 350,
  [817] = 403,
  [818] = 364,
  [819] = 125,
  [820] = 820,
  [821] = 392,
  [822] = 394,
  [823] = 360,
  [824] = 396,
  [825] = 377,
  [826] = 369,
  [827] = 372,
  [828] = 373,
  [829] = 829,
  [830] = 393,
  [831] = 355,
  [832] = 380,
  [833] = 330,
  [834] = 834,
  [835] = 375,
  [836] = 414,
  [837] = 834,
  [838] = 820,
  [839] = 839,
  [840] = 834,
  [841] = 376,
  [842] = 834,
  [843] = 834,
  [844] = 378,
  [845] = 820,
  [846] = 379,
  [847] = 541,
  [848] = 351,
  [849] = 384,
  [850] = 388,
  [851] = 407,
  [852] = 327,
  [853] = 328,
  [854] = 820,
  [855] = 346,
  [856] = 411,
  [857] = 326,
  [858] = 834,
  [859] = 125,
  [860] = 352,
  [861] = 820,
  [862] = 419,
  [863] = 820,
  [864] = 387,
  [865] = 404,
  [866] = 866,
  [867] = 867,
  [868] = 406,
  [869] = 374,
  [870] = 337,
  [871] = 353,
  [872] = 371,
  [873] = 391,
  [874] = 390,
  [875] = 361,
  [876] = 876,
  [877] = 339,
  [878] = 125,
  [879] = 340,
  [880] = 382,
  [881] = 415,
  [882] = 343,
  [883] = 541,
  [884] = 416,
  [885] = 342,
  [886] = 347,
  [887] = 834,
  [888] = 408,
  [889] = 341,
  [890] = 890,
  [891] = 386,
  [892] = 820,
  [893] = 820,
  [894] = 834,
  [895] = 338,
  [896] = 366,
  [897] = 329,
  [898] = 365,
  [899] = 383,
  [900] = 362,
  [901] = 125,
  [902] = 834,
  [903] = 903,
  [904] = 820,
  [905] = 359,
  [906] = 385,
  [907] = 413,
  [908] = 412,
  [909] = 381,
  [910] = 399,
  [911] = 820,
  [912] = 834,
  [913] = 354,
  [914] = 420,
  [915] = 915,
  [916] = 916,
  [917] = 916,
  [918] = 918,
  [919] = 918,
  [920] = 918,
  [921] = 918,
  [922] = 918,
  [923] = 918,
  [924] = 918,
  [925] = 925,
  [926] = 926,
  [927] = 927,
  [928] = 927,
  [929] = 927,
  [930] = 927,
  [931] = 927,
  [932] = 927,
  [933] = 927,
  [934] = 934,
  [935] = 935,
  [936] = 935,
  [937] = 935,
  [938] = 938,
  [939] = 939,
  [940] = 935,
  [941] = 941,
  [942] = 942,
  [943] = 939,
  [944] = 944,
  [945] = 939,
  [946] = 946,
  [947] = 947,
  [948] = 944,
  [949] = 949,
  [950] = 934,
  [951] = 951,
  [952] = 939,
  [953] = 941,
  [954] = 942,
  [955] = 955,
  [956] = 220,
  [957] = 957,
  [958] = 221,
  [959] = 957,
  [960] = 128,
  [961] = 227,
  [962] = 127,
  [963] = 963,
  [964] = 224,
  [965] = 229,
  [966] = 246,
  [967] = 234,
  [968] = 272,
  [969] = 273,
  [970] = 274,
  [971] = 250,
  [972] = 251,
  [973] = 955,
  [974] = 276,
  [975] = 277,
  [976] = 279,
  [977] = 280,
  [978] = 281,
  [979] = 282,
  [980] = 238,
  [981] = 288,
  [982] = 290,
  [983] = 292,
  [984] = 296,
  [985] = 297,
  [986] = 295,
  [987] = 252,
  [988] = 239,
  [989] = 254,
  [990] = 256,
  [991] = 257,
  [992] = 258,
  [993] = 259,
  [994] = 303,
  [995] = 240,
  [996] = 247,
  [997] = 304,
  [998] = 260,
  [999] = 261,
  [1000] = 241,
  [1001] = 249,
  [1002] = 235,
  [1003] = 293,
  [1004] = 264,
  [1005] = 269,
  [1006] = 1006,
  [1007] = 287,
  [1008] = 1008,
  [1009] = 270,
  [1010] = 262,
  [1011] = 299,
  [1012] = 301,
  [1013] = 302,
  [1014] = 263,
  [1015] = 306,
  [1016] = 308,
  [1017] = 312,
  [1018] = 313,
  [1019] = 314,
  [1020] = 315,
  [1021] = 318,
  [1022] = 300,
  [1023] = 317,
  [1024] = 310,
  [1025] = 309,
  [1026] = 284,
  [1027] = 283,
  [1028] = 278,
  [1029] = 275,
  [1030] = 271,
  [1031] = 267,
  [1032] = 286,
  [1033] = 1008,
  [1034] = 289,
  [1035] = 266,
  [1036] = 265,
  [1037] = 925,
  [1038] = 1008,
  [1039] = 255,
  [1040] = 248,
  [1041] = 245,
  [1042] = 244,
  [1043] = 243,
  [1044] = 325,
  [1045] = 298,
  [1046] = 233,
  [1047] = 321,
  [1048] = 926,
  [1049] = 1049,
  [1050] = 1050,
  [1051] = 1049,
  [1052] = 1052,
  [1053] = 1049,
  [1054] = 1050,
  [1055] = 1050,
  [1056] = 1008,
  [1057] = 1052,
  [1058] = 1052,
  [1059] = 1052,
  [1060] = 1049,
  [1061] = 1052,
  [1062] = 1050,
  [1063] = 1052,
  [1064] = 1049,
  [1065] = 1049,
  [1066] = 1052,
  [1067] = 1050,
  [1068] = 1049,
  [1069] = 1052,
  [1070] = 1049,
  [1071] = 1050,
  [1072] = 1052,
  [1073] = 1073,
  [1074] = 1049,
  [1075] = 1075,
  [1076] = 1076,
  [1077] = 1076,
  [1078] = 1078,
  [1079] = 1078,
  [1080] = 1078,
  [1081] = 1076,
  [1082] = 1078,
  [1083] = 1076,
  [1084] = 1078,
  [1085] = 1076,
  [1086] = 1076,
  [1087] = 1078,
  [1088] = 1088,
  [1089] = 1089,
  [1090] = 1089,
  [1091] = 1089,
  [1092] = 1089,
  [1093] = 1089,
  [1094] = 1094,
  [1095] = 1089,
  [1096] = 1089,
  [1097] = 1097,
  [1098] = 1094,
  [1099] = 1097,
  [1100] = 1097,
  [1101] = 1097,
  [1102] = 1097,
  [1103] = 1103,
  [1104] = 1104,
  [1105] = 1104,
  [1106] = 1106,
  [1107] = 1103,
  [1108] = 1106,
  [1109] = 1104,
  [1110] = 1104,
  [1111] = 1106,
  [1112] = 1094,
  [1113] = 1106,
  [1114] = 1104,
  [1115] = 1104,
  [1116] = 1104,
  [1117] = 1104,
  [1118] = 1104,
  [1119] = 1119,
  [1120] = 1106,
  [1121] = 1103,
  [1122] = 1122,
  [1123] = 1123,
  [1124] = 1122,
  [1125] = 1125,
  [1126] = 1125,
  [1127] = 1127,
  [1128] = 1128,
  [1129] = 1127,
  [1130] = 1127,
  [1131] = 1125,
  [1132] = 1122,
  [1133] = 1128,
  [1134] = 1134,
  [1135] = 1135,
  [1136] = 1122,
  [1137] = 1127,
  [1138] = 1122,
  [1139] = 1128,
  [1140] = 1127,
  [1141] = 1122,
  [1142] = 1128,
  [1143] = 1122,
  [1144] = 1128,
  [1145] = 1122,
  [1146] = 1127,
  [1147] = 1125,
  [1148] = 1122,
  [1149] = 1128,
  [1150] = 1127,
  [1151] = 1151,
  [1152] = 1128,
  [1153] = 1127,
  [1154] = 1127,
  [1155] = 1128,
  [1156] = 1125,
  [1157] = 1157,
  [1158] = 1128,
  [1159] = 1122,
  [1160] = 1128,
  [1161] = 1127,
  [1162] = 1125,
  [1163] = 1125,
  [1164] = 1125,
  [1165] = 1128,
  [1166] = 1122,
  [1167] = 1122,
  [1168] = 1125,
  [1169] = 1125,
  [1170] = 1170,
  [1171] = 1171,
  [1172] = 1157,
  [1173] = 1173,
  [1174] = 1174,
  [1175] = 1175,
  [1176] = 1176,
  [1177] = 1177,
  [1178] = 1178,
  [1179] = 1179,
  [1180] = 1180,
  [1181] = 1181,
  [1182] = 1125,
  [1183] = 1127,
  [1184] = 1125,
  [1185] = 1128,
  [1186] = 1128,
  [1187] = 1127,
  [1188] = 1122,
  [1189] = 1125,
  [1190] = 1127,
  [1191] = 1157,
  [1192] = 1192,
  [1193] = 1193,
  [1194] = 1193,
  [1195] = 1195,
  [1196] = 1196,
  [1197] = 1197,
  [1198] = 1198,
  [1199] = 1193,
  [1200] = 1200,
  [1201] = 1195,
  [1202] = 1192,
  [1203] = 1192,
  [1204] = 1195,
  [1205] = 1205,
  [1206] = 1206,
  [1207] = 1207,
  [1208] = 1193,
  [1209] = 1209,
  [1210] = 1193,
  [1211] = 1211,
  [1212] = 1212,
  [1213] = 1192,
  [1214] = 1193,
  [1215] = 1215,
  [1216] = 1216,
  [1217] = 1192,
  [1218] = 1218,
  [1219] = 1192,
  [1220] = 1192,
  [1221] = 1195,
  [1222] = 1193,
  [1223] = 1193,
  [1224] = 1195,
  [1225] = 1192,
  [1226] = 1226,
  [1227] = 1192,
  [1228] = 1193,
  [1229] = 1192,
  [1230] = 1230,
  [1231] = 1193,
  [1232] = 1232,
  [1233] = 1233,
  [1234] = 1193,
  [1235] = 1195,
  [1236] = 1192,
  [1237] = 1192,
  [1238] = 1195,
  [1239] = 1193,
  [1240] = 1193,
  [1241] = 1192,
  [1242] = 1242,
  [1243] = 1243,
  [1244] = 1244,
  [1245] = 1245,
  [1246] = 1246,
  [1247] = 1247,
  [1248] = 1248,
  [1249] = 1249,
  [1250] = 1250,
  [1251] = 1243,
  [1252] = 1252,
  [1253] = 1253,
  [1254] = 1254,
  [1255] = 1255,
  [1256] = 1256,
  [1257] = 1257,
  [1258] = 1256,
  [1259] = 1255,
  [1260] = 1256,
  [1261] = 1261,
  [1262] = 1262,
  [1263] = 1263,
  [1264] = 1264,
  [1265] = 1265,
  [1266] = 1266,
  [1267] = 1256,
  [1268] = 1268,
  [1269] = 1269,
  [1270] = 1270,
  [1271] = 1271,
  [1272] = 1272,
  [1273] = 1273,
  [1274] = 1274,
  [1275] = 1275,
  [1276] = 1276,
  [1277] = 1277,
  [1278] = 1278,
  [1279] = 1279,
  [1280] = 1247,
  [1281] = 1281,
  [1282] = 1282,
  [1283] = 1283,
  [1284] = 1284,
  [1285] = 1285,
  [1286] = 1286,
  [1287] = 1243,
  [1288] = 1256,
  [1289] = 1256,
  [1290] = 1245,
  [1291] = 1243,
  [1292] = 1256,
  [1293] = 1256,
  [1294] = 1256,
  [1295] = 1243,
  [1296] = 1261,
  [1297] = 1262,
  [1298] = 1263,
  [1299] = 1264,
  [1300] = 1265,
  [1301] = 1266,
  [1302] = 1268,
  [1303] = 1269,
  [1304] = 1270,
  [1305] = 1271,
  [1306] = 1272,
  [1307] = 1273,
  [1308] = 1274,
  [1309] = 1275,
  [1310] = 1276,
  [1311] = 1277,
  [1312] = 1249,
  [1313] = 1278,
  [1314] = 1249,
  [1315] = 1279,
  [1316] = 1281,
  [1317] = 1282,
  [1318] = 1283,
  [1319] = 1284,
  [1320] = 1285,
  [1321] = 1286,
  [1322] = 1248,
  [1323] = 1250,
  [1324] = 1243,
  [1325] = 1243,
  [1326] = 1250,
  [1327] = 1248,
  [1328] = 1328,
  [1329] = 1243,
  [1330] = 1243,
  [1331] = 1256,
  [1332] = 1249,
  [1333] = 1247,
  [1334] = 1253,
  [1335] = 1252,
  [1336] = 1252,
  [1337] = 1337,
  [1338] = 1248,
  [1339] = 1250,
  [1340] = 1243,
  [1341] = 1247,
  [1342] = 1243,
  [1343] = 1254,
  [1344] = 1250,
  [1345] = 1248,
  [1346] = 1246,
  [1347] = 1243,
  [1348] = 1243,
  [1349] = 1349,
  [1350] = 1350,
  [1351] = 1350,
  [1352] = 1352,
  [1353] = 1353,
  [1354] = 1354,
  [1355] = 1355,
  [1356] = 1356,
  [1357] = 1357,
  [1358] = 1358,
  [1359] = 1359,
  [1360] = 1354,
  [1361] = 1361,
  [1362] = 1350,
  [1363] = 1353,
  [1364] = 1364,
  [1365] = 1365,
  [1366] = 1366,
  [1367] = 1367,
  [1368] = 1368,
  [1369] = 1369,
  [1370] = 1370,
  [1371] = 1371,
  [1372] = 1366,
  [1373] = 1373,
  [1374] = 1374,
  [1375] = 1375,
  [1376] = 1371,
  [1377] = 1377,
  [1378] = 1367,
  [1379] = 1379,
  [1380] = 1380,
  [1381] = 1381,
  [1382] = 1382,
  [1383] = 1381,
  [1384] = 1358,
  [1385] = 1367,
  [1386] = 1366,
  [1387] = 1381,
  [1388] = 1367,
  [1389] = 1389,
  [1390] = 1390,
  [1391] = 1391,
  [1392] = 1392,
  [1393] = 1393,
  [1394] = 1394,
  [1395] = 1391,
  [1396] = 1390,
  [1397] = 1394,
  [1398] = 1393,
  [1399] = 1392,
  [1400] = 1400,
  [1401] = 1389,
  [1402] = 1355,
  [1403] = 1370,
  [1404] = 1367,
  [1405] = 1405,
  [1406] = 1406,
  [1407] = 1352,
  [1408] = 1371,
  [1409] = 1409,
  [1410] = 1357,
  [1411] = 1381,
  [1412] = 1406,
  [1413] = 1369,
  [1414] = 1368,
  [1415] = 1381,
  [1416] = 1394,
  [1417] = 1392,
  [1418] = 1418,
  [1419] = 1393,
  [1420] = 1420,
  [1421] = 1394,
  [1422] = 1364,
  [1423] = 1379,
  [1424] = 1391,
  [1425] = 1406,
  [1426] = 1366,
  [1427] = 1367,
  [1428] = 1368,
  [1429] = 1380,
  [1430] = 1420,
  [1431] = 1356,
  [1432] = 1432,
  [1433] = 1418,
  [1434] = 1390,
  [1435] = 1355,
  [1436] = 1350,
  [1437] = 1361,
  [1438] = 1438,
  [1439] = 1438,
  [1440] = 1352,
  [1441] = 1356,
  [1442] = 1369,
  [1443] = 1370,
  [1444] = 1389,
  [1445] = 1366,
  [1446] = 1392,
  [1447] = 1357,
  [1448] = 1393,
  [1449] = 1394,
  [1450] = 1371,
  [1451] = 1391,
  [1452] = 1353,
  [1453] = 1354,
  [1454] = 1389,
  [1455] = 1358,
  [1456] = 1354,
  [1457] = 1370,
  [1458] = 1353,
  [1459] = 1369,
  [1460] = 1367,
  [1461] = 1352,
  [1462] = 1405,
  [1463] = 1353,
  [1464] = 1354,
  [1465] = 1367,
  [1466] = 1368,
  [1467] = 1354,
  [1468] = 1354,
  [1469] = 1350,
  [1470] = 1381,
  [1471] = 1366,
  [1472] = 1371,
  [1473] = 1367,
  [1474] = 1354,
  [1475] = 1418,
  [1476] = 1381,
  [1477] = 1353,
  [1478] = 1350,
  [1479] = 1364,
  [1480] = 1368,
  [1481] = 1369,
  [1482] = 1350,
  [1483] = 1352,
  [1484] = 1353,
  [1485] = 1354,
  [1486] = 1353,
  [1487] = 1370,
  [1488] = 1389,
  [1489] = 1390,
  [1490] = 1391,
  [1491] = 1394,
  [1492] = 1392,
  [1493] = 1352,
  [1494] = 1390,
  [1495] = 1389,
  [1496] = 1355,
  [1497] = 1370,
  [1498] = 1352,
  [1499] = 1406,
  [1500] = 1364,
  [1501] = 1353,
  [1502] = 1368,
  [1503] = 1369,
  [1504] = 1370,
  [1505] = 1389,
  [1506] = 1367,
  [1507] = 1390,
  [1508] = 1350,
  [1509] = 1391,
  [1510] = 1394,
  [1511] = 1369,
  [1512] = 1390,
  [1513] = 1381,
  [1514] = 1393,
  [1515] = 1364,
  [1516] = 1350,
  [1517] = 1392,
  [1518] = 1392,
  [1519] = 1367,
  [1520] = 1352,
  [1521] = 1353,
  [1522] = 1354,
  [1523] = 1393,
  [1524] = 1394,
  [1525] = 1391,
  [1526] = 1364,
  [1527] = 1368,
  [1528] = 1391,
  [1529] = 1390,
  [1530] = 1364,
  [1531] = 1368,
  [1532] = 1364,
  [1533] = 1389,
  [1534] = 1366,
  [1535] = 1370,
  [1536] = 1536,
  [1537] = 1370,
  [1538] = 1389,
  [1539] = 1371,
  [1540] = 1390,
  [1541] = 1366,
  [1542] = 1369,
  [1543] = 1391,
  [1544] = 1420,
  [1545] = 1368,
  [1546] = 1364,
  [1547] = 1366,
  [1548] = 1418,
  [1549] = 1394,
  [1550] = 1364,
  [1551] = 1393,
  [1552] = 1359,
  [1553] = 1405,
  [1554] = 1368,
  [1555] = 1377,
  [1556] = 1392,
  [1557] = 1381,
  [1558] = 1369,
  [1559] = 1358,
  [1560] = 1370,
  [1561] = 1371,
  [1562] = 1420,
  [1563] = 1369,
  [1564] = 1389,
  [1565] = 1352,
  [1566] = 1566,
  [1567] = 1361,
  [1568] = 1350,
  [1569] = 1566,
  [1570] = 1356,
  [1571] = 1566,
  [1572] = 1390,
  [1573] = 1364,
  [1574] = 1352,
  [1575] = 1438,
  [1576] = 1353,
  [1577] = 1354,
  [1578] = 1368,
  [1579] = 1369,
  [1580] = 1370,
  [1581] = 1566,
  [1582] = 1354,
  [1583] = 1353,
  [1584] = 1438,
  [1585] = 1352,
  [1586] = 1361,
  [1587] = 1350,
  [1588] = 1389,
  [1589] = 1390,
  [1590] = 1566,
  [1591] = 1405,
  [1592] = 1391,
  [1593] = 1355,
  [1594] = 1594,
  [1595] = 1595,
  [1596] = 1381,
  [1597] = 1393,
  [1598] = 1400,
  [1599] = 1599,
  [1600] = 1357,
  [1601] = 1394,
  [1602] = 1393,
  [1603] = 1393,
  [1604] = 1366,
  [1605] = 1371,
  [1606] = 1392,
  [1607] = 1607,
  [1608] = 1367,
  [1609] = 1391,
  [1610] = 1566,
  [1611] = 1611,
  [1612] = 1356,
  [1613] = 1371,
  [1614] = 1438,
  [1615] = 1394,
  [1616] = 1393,
  [1617] = 1366,
  [1618] = 1371,
  [1619] = 1361,
  [1620] = 1392,
  [1621] = 1566,
  [1622] = 1420,
  [1623] = 1438,
  [1624] = 1381,
  [1625] = 1356,
  [1626] = 1392,
  [1627] = 1393,
  [1628] = 1394,
  [1629] = 1357,
  [1630] = 1391,
  [1631] = 1390,
  [1632] = 1389,
  [1633] = 1370,
  [1634] = 1369,
  [1635] = 1368,
  [1636] = 1352,
  [1637] = 1405,
  [1638] = 1364,
  [1639] = 1350,
  [1640] = 1358,
  [1641] = 1420,
  [1642] = 1405,
  [1643] = 1361,
  [1644] = 1354,
  [1645] = 1353,
  [1646] = 1358,
  [1647] = 1406,
  [1648] = 1352,
  [1649] = 1418,
  [1650] = 1371,
  [1651] = 1358,
  [1652] = 1652,
  [1653] = 1361,
  [1654] = 1355,
  [1655] = 1371,
  [1656] = 1652,
  [1657] = 1657,
  [1658] = 1366,
  [1659] = 1357,
  [1660] = 1381,
  [1661] = 1366,
  [1662] = 1438,
  [1663] = 1652,
  [1664] = 1350,
  [1665] = 1364,
  [1666] = 1368,
  [1667] = 1371,
  [1668] = 1369,
  [1669] = 1370,
  [1670] = 1389,
  [1671] = 1390,
  [1672] = 1391,
  [1673] = 1367,
  [1674] = 1394,
  [1675] = 1393,
  [1676] = 1392,
  [1677] = 1392,
  [1678] = 1381,
  [1679] = 1356,
  [1680] = 1680,
  [1681] = 1680,
  [1682] = 1682,
  [1683] = 1683,
  [1684] = 1684,
  [1685] = 1685,
  [1686] = 1686,
  [1687] = 1687,
  [1688] = 1688,
  [1689] = 1689,
  [1690] = 1690,
  [1691] = 1691,
  [1692] = 1691,
  [1693] = 1691,
  [1694] = 1691,
  [1695] = 373,
  [1696] = 1696,
  [1697] = 392,
  [1698] = 1683,
  [1699] = 1683,
  [1700] = 1682,
  [1701] = 1683,
  [1702] = 1689,
  [1703] = 1688,
  [1704] = 1686,
  [1705] = 1687,
  [1706] = 1685,
  [1707] = 1684,
  [1708] = 1708,
  [1709] = 1690,
  [1710] = 1690,
  [1711] = 1685,
  [1712] = 1690,
  [1713] = 1686,
  [1714] = 1684,
  [1715] = 1094,
  [1716] = 1682,
  [1717] = 1687,
  [1718] = 1688,
  [1719] = 1689,
  [1720] = 1094,
  [1721] = 1684,
  [1722] = 1682,
  [1723] = 1689,
  [1724] = 1687,
  [1725] = 1688,
  [1726] = 1690,
  [1727] = 1685,
  [1728] = 1686,
  [1729] = 1729,
  [1730] = 1729,
  [1731] = 1729,
  [1732] = 1729,
  [1733] = 1733,
  [1734] = 1733,
  [1735] = 1733,
  [1736] = 1733,
  [1737] = 1733,
  [1738] = 1733,
  [1739] = 1733,
  [1740] = 1690,
  [1741] = 1741,
  [1742] = 1742,
  [1743] = 1742,
  [1744] = 1744,
  [1745] = 1745,
  [1746] = 1746,
  [1747] = 1747,
  [1748] = 1748,
  [1749] = 1749,
  [1750] = 1750,
  [1751] = 1751,
  [1752] = 1752,
  [1753] = 1753,
  [1754] = 1754,
  [1755] = 1755,
  [1756] = 1756,
  [1757] = 1757,
  [1758] = 1758,
  [1759] = 1759,
  [1760] = 1760,
  [1761] = 1761,
  [1762] = 1761,
  [1763] = 1763,
  [1764] = 1761,
  [1765] = 1761,
  [1766] = 1766,
  [1767] = 1767,
  [1768] = 1768,
  [1769] = 1769,
  [1770] = 1770,
  [1771] = 1771,
  [1772] = 1772,
  [1773] = 221,
  [1774] = 223,
  [1775] = 1775,
  [1776] = 222,
  [1777] = 1690,
  [1778] = 220,
  [1779] = 1690,
  [1780] = 1685,
  [1781] = 1687,
  [1782] = 1767,
  [1783] = 1686,
  [1784] = 1682,
  [1785] = 305,
  [1786] = 1688,
  [1787] = 1689,
  [1788] = 127,
  [1789] = 1684,
  [1790] = 128,
  [1791] = 305,
  [1792] = 1792,
  [1793] = 350,
  [1794] = 1794,
  [1795] = 1687,
  [1796] = 229,
  [1797] = 397,
  [1798] = 1688,
  [1799] = 1799,
  [1800] = 1689,
  [1801] = 1686,
  [1802] = 1685,
  [1803] = 1803,
  [1804] = 1804,
  [1805] = 1684,
  [1806] = 1682,
  [1807] = 364,
  [1808] = 403,
  [1809] = 375,
  [1810] = 334,
  [1811] = 1811,
  [1812] = 289,
  [1813] = 1811,
  [1814] = 371,
  [1815] = 1811,
  [1816] = 374,
  [1817] = 903,
  [1818] = 373,
  [1819] = 303,
  [1820] = 386,
  [1821] = 387,
  [1822] = 390,
  [1823] = 391,
  [1824] = 392,
  [1825] = 1825,
  [1826] = 1826,
  [1827] = 1827,
  [1828] = 1690,
  [1829] = 1829,
  [1830] = 352,
  [1831] = 315,
  [1832] = 1682,
  [1833] = 866,
  [1834] = 1760,
  [1835] = 346,
  [1836] = 867,
  [1837] = 1837,
  [1838] = 1811,
  [1839] = 298,
  [1840] = 343,
  [1841] = 1841,
  [1842] = 1842,
  [1843] = 342,
  [1844] = 341,
  [1845] = 1845,
  [1846] = 1846,
  [1847] = 1847,
  [1848] = 340,
  [1849] = 1846,
  [1850] = 1846,
  [1851] = 339,
  [1852] = 1846,
  [1853] = 330,
  [1854] = 329,
  [1855] = 1855,
  [1856] = 1846,
  [1857] = 1846,
  [1858] = 328,
  [1859] = 337,
  [1860] = 1860,
  [1861] = 1861,
  [1862] = 321,
  [1863] = 1683,
  [1864] = 309,
  [1865] = 1865,
  [1866] = 1866,
  [1867] = 233,
  [1868] = 384,
  [1869] = 1869,
  [1870] = 388,
  [1871] = 325,
  [1872] = 1872,
  [1873] = 286,
  [1874] = 1874,
  [1875] = 1685,
  [1876] = 1876,
  [1877] = 318,
  [1878] = 376,
  [1879] = 378,
  [1880] = 1687,
  [1881] = 379,
  [1882] = 351,
  [1883] = 1688,
  [1884] = 1689,
  [1885] = 415,
  [1886] = 416,
  [1887] = 1866,
  [1888] = 1866,
  [1889] = 876,
  [1890] = 404,
  [1891] = 406,
  [1892] = 1811,
  [1893] = 407,
  [1894] = 412,
  [1895] = 418,
  [1896] = 1896,
  [1897] = 399,
  [1898] = 1898,
  [1899] = 385,
  [1900] = 1866,
  [1901] = 1901,
  [1902] = 359,
  [1903] = 1811,
  [1904] = 1904,
  [1905] = 1905,
  [1906] = 1906,
  [1907] = 1907,
  [1908] = 1908,
  [1909] = 1909,
  [1910] = 1910,
  [1911] = 1911,
  [1912] = 1912,
  [1913] = 1684,
  [1914] = 1914,
  [1915] = 1915,
  [1916] = 1916,
  [1917] = 1917,
  [1918] = 1918,
  [1919] = 1919,
  [1920] = 1920,
  [1921] = 1921,
  [1922] = 1922,
  [1923] = 383,
  [1924] = 1924,
  [1925] = 1846,
  [1926] = 382,
  [1927] = 381,
  [1928] = 1686,
  [1929] = 1929,
  [1930] = 1811,
  [1931] = 1931,
  [1932] = 1932,
  [1933] = 1933,
  [1934] = 1934,
  [1935] = 1935,
  [1936] = 1936,
  [1937] = 221,
  [1938] = 1938,
  [1939] = 1939,
  [1940] = 1940,
  [1941] = 1941,
  [1942] = 1942,
  [1943] = 1943,
  [1944] = 1944,
  [1945] = 1945,
  [1946] = 1946,
  [1947] = 1947,
  [1948] = 1948,
  [1949] = 1949,
  [1950] = 1950,
  [1951] = 1951,
  [1952] = 220,
  [1953] = 1953,
  [1954] = 1954,
  [1955] = 1955,
  [1956] = 1956,
  [1957] = 1957,
  [1958] = 1958,
  [1959] = 1959,
  [1960] = 1960,
  [1961] = 1961,
  [1962] = 1962,
  [1963] = 1963,
  [1964] = 1961,
  [1965] = 1965,
  [1966] = 1966,
  [1967] = 1961,
  [1968] = 1968,
  [1969] = 1969,
  [1970] = 223,
  [1971] = 1971,
  [1972] = 1971,
  [1973] = 1973,
  [1974] = 1974,
  [1975] = 1975,
  [1976] = 1683,
  [1977] = 222,
  [1978] = 1978,
  [1979] = 1979,
  [1980] = 1980,
  [1981] = 1981,
  [1982] = 1982,
  [1983] = 1961,
  [1984] = 1984,
  [1985] = 220,
  [1986] = 1986,
  [1987] = 1987,
  [1988] = 1988,
  [1989] = 221,
  [1990] = 1990,
  [1991] = 222,
  [1992] = 223,
  [1993] = 305,
  [1994] = 1957,
  [1995] = 1995,
  [1996] = 1898,
  [1997] = 1997,
  [1998] = 1998,
  [1999] = 305,
  [2000] = 128,
  [2001] = 127,
  [2002] = 1690,
  [2003] = 1898,
  [2004] = 2004,
  [2005] = 305,
  [2006] = 305,
  [2007] = 1683,
  [2008] = 2008,
  [2009] = 127,
  [2010] = 2010,
  [2011] = 128,
  [2012] = 2012,
  [2013] = 2013,
  [2014] = 1995,
  [2015] = 397,
  [2016] = 2016,
  [2017] = 1741,
  [2018] = 1896,
  [2019] = 1688,
  [2020] = 1686,
  [2021] = 350,
  [2022] = 1687,
  [2023] = 1685,
  [2024] = 2008,
  [2025] = 1684,
  [2026] = 1767,
  [2027] = 229,
  [2028] = 1974,
  [2029] = 2029,
  [2030] = 1741,
  [2031] = 364,
  [2032] = 403,
  [2033] = 1690,
  [2034] = 1869,
  [2035] = 1682,
  [2036] = 403,
  [2037] = 2037,
  [2038] = 1865,
  [2039] = 1760,
  [2040] = 2040,
  [2041] = 2040,
  [2042] = 1689,
  [2043] = 2040,
  [2044] = 1974,
  [2045] = 229,
  [2046] = 1998,
  [2047] = 2029,
  [2048] = 1997,
  [2049] = 397,
  [2050] = 350,
  [2051] = 1901,
  [2052] = 364,
  [2053] = 1920,
  [2054] = 318,
  [2055] = 399,
  [2056] = 903,
  [2057] = 2016,
  [2058] = 374,
  [2059] = 407,
  [2060] = 1919,
  [2061] = 418,
  [2062] = 1918,
  [2063] = 1917,
  [2064] = 1916,
  [2065] = 412,
  [2066] = 1915,
  [2067] = 390,
  [2068] = 387,
  [2069] = 1914,
  [2070] = 386,
  [2071] = 371,
  [2072] = 373,
  [2073] = 359,
  [2074] = 391,
  [2075] = 1841,
  [2076] = 303,
  [2077] = 374,
  [2078] = 903,
  [2079] = 1770,
  [2080] = 2080,
  [2081] = 321,
  [2082] = 391,
  [2083] = 392,
  [2084] = 1760,
  [2085] = 233,
  [2086] = 371,
  [2087] = 325,
  [2088] = 2088,
  [2089] = 382,
  [2090] = 416,
  [2091] = 415,
  [2092] = 2016,
  [2093] = 2080,
  [2094] = 384,
  [2095] = 352,
  [2096] = 1825,
  [2097] = 1826,
  [2098] = 866,
  [2099] = 346,
  [2100] = 867,
  [2101] = 298,
  [2102] = 876,
  [2103] = 1924,
  [2104] = 385,
  [2105] = 1760,
  [2106] = 383,
  [2107] = 418,
  [2108] = 399,
  [2109] = 343,
  [2110] = 382,
  [2111] = 342,
  [2112] = 381,
  [2113] = 1825,
  [2114] = 1987,
  [2115] = 2115,
  [2116] = 1770,
  [2117] = 1920,
  [2118] = 1772,
  [2119] = 341,
  [2120] = 1772,
  [2121] = 385,
  [2122] = 383,
  [2123] = 340,
  [2124] = 339,
  [2125] = 315,
  [2126] = 352,
  [2127] = 866,
  [2128] = 330,
  [2129] = 329,
  [2130] = 1760,
  [2131] = 346,
  [2132] = 1922,
  [2133] = 373,
  [2134] = 412,
  [2135] = 406,
  [2136] = 404,
  [2137] = 2016,
  [2138] = 867,
  [2139] = 343,
  [2140] = 342,
  [2141] = 407,
  [2142] = 318,
  [2143] = 351,
  [2144] = 315,
  [2145] = 381,
  [2146] = 379,
  [2147] = 1841,
  [2148] = 1842,
  [2149] = 406,
  [2150] = 404,
  [2151] = 1845,
  [2152] = 1847,
  [2153] = 1860,
  [2154] = 1861,
  [2155] = 378,
  [2156] = 1872,
  [2157] = 1876,
  [2158] = 376,
  [2159] = 341,
  [2160] = 375,
  [2161] = 328,
  [2162] = 337,
  [2163] = 388,
  [2164] = 1898,
  [2165] = 328,
  [2166] = 334,
  [2167] = 337,
  [2168] = 1904,
  [2169] = 1905,
  [2170] = 1921,
  [2171] = 303,
  [2172] = 2016,
  [2173] = 1826,
  [2174] = 1906,
  [2175] = 1907,
  [2176] = 388,
  [2177] = 359,
  [2178] = 1842,
  [2179] = 876,
  [2180] = 1908,
  [2181] = 329,
  [2182] = 298,
  [2183] = 330,
  [2184] = 392,
  [2185] = 1845,
  [2186] = 386,
  [2187] = 384,
  [2188] = 387,
  [2189] = 334,
  [2190] = 2016,
  [2191] = 339,
  [2192] = 390,
  [2193] = 1909,
  [2194] = 1912,
  [2195] = 309,
  [2196] = 1950,
  [2197] = 1847,
  [2198] = 340,
  [2199] = 1860,
  [2200] = 1861,
  [2201] = 415,
  [2202] = 1929,
  [2203] = 351,
  [2204] = 1904,
  [2205] = 1905,
  [2206] = 1771,
  [2207] = 1906,
  [2208] = 1907,
  [2209] = 1933,
  [2210] = 321,
  [2211] = 1908,
  [2212] = 1910,
  [2213] = 1909,
  [2214] = 1910,
  [2215] = 1911,
  [2216] = 1912,
  [2217] = 286,
  [2218] = 1914,
  [2219] = 233,
  [2220] = 325,
  [2221] = 1915,
  [2222] = 1916,
  [2223] = 309,
  [2224] = 1917,
  [2225] = 1918,
  [2226] = 1872,
  [2227] = 1919,
  [2228] = 1921,
  [2229] = 1922,
  [2230] = 1924,
  [2231] = 379,
  [2232] = 1911,
  [2233] = 2233,
  [2234] = 378,
  [2235] = 1760,
  [2236] = 289,
  [2237] = 1929,
  [2238] = 1933,
  [2239] = 1934,
  [2240] = 1936,
  [2241] = 289,
  [2242] = 1876,
  [2243] = 1931,
  [2244] = 1935,
  [2245] = 1932,
  [2246] = 1931,
  [2247] = 1934,
  [2248] = 1771,
  [2249] = 1936,
  [2250] = 286,
  [2251] = 416,
  [2252] = 2252,
  [2253] = 375,
  [2254] = 1932,
  [2255] = 376,
  [2256] = 1935,
  [2257] = 1865,
  [2258] = 1772,
  [2259] = 1987,
  [2260] = 1794,
  [2261] = 2261,
  [2262] = 2262,
  [2263] = 1898,
  [2264] = 128,
  [2265] = 1760,
  [2266] = 2266,
  [2267] = 2267,
  [2268] = 2268,
  [2269] = 2269,
  [2270] = 2270,
  [2271] = 2271,
  [2272] = 2272,
  [2273] = 1804,
  [2274] = 2274,
  [2275] = 2275,
  [2276] = 2115,
  [2277] = 2277,
  [2278] = 2278,
  [2279] = 1792,
  [2280] = 2280,
  [2281] = 2281,
  [2282] = 1869,
  [2283] = 2283,
  [2284] = 1896,
  [2285] = 1974,
  [2286] = 1687,
  [2287] = 1688,
  [2288] = 1689,
  [2289] = 2289,
  [2290] = 1874,
  [2291] = 1770,
  [2292] = 1760,
  [2293] = 2293,
  [2294] = 1686,
  [2295] = 2295,
  [2296] = 2296,
  [2297] = 2297,
  [2298] = 1685,
  [2299] = 2299,
  [2300] = 2300,
  [2301] = 2301,
  [2302] = 2302,
  [2303] = 1684,
  [2304] = 2304,
  [2305] = 1901,
  [2306] = 1767,
  [2307] = 1771,
  [2308] = 2308,
  [2309] = 1760,
  [2310] = 1803,
  [2311] = 2311,
  [2312] = 1760,
  [2313] = 1829,
  [2314] = 127,
  [2315] = 1682,
  [2316] = 1827,
  [2317] = 2301,
  [2318] = 1954,
  [2319] = 1978,
  [2320] = 1969,
  [2321] = 1949,
  [2322] = 2322,
  [2323] = 1953,
  [2324] = 1955,
  [2325] = 2325,
  [2326] = 1975,
  [2327] = 1767,
  [2328] = 2328,
  [2329] = 1944,
  [2330] = 925,
  [2331] = 1958,
  [2332] = 2274,
  [2333] = 1683,
  [2334] = 1959,
  [2335] = 1767,
  [2336] = 1946,
  [2337] = 1951,
  [2338] = 2280,
  [2339] = 1943,
  [2340] = 2340,
  [2341] = 1950,
  [2342] = 2342,
  [2343] = 1997,
  [2344] = 1960,
  [2345] = 926,
  [2346] = 1940,
  [2347] = 2347,
  [2348] = 1998,
  [2349] = 2349,
  [2350] = 2350,
  [2351] = 1988,
  [2352] = 1939,
  [2353] = 1966,
  [2354] = 1938,
  [2355] = 2355,
  [2356] = 2356,
  [2357] = 1855,
  [2358] = 1941,
  [2359] = 2359,
  [2360] = 1968,
  [2361] = 2361,
  [2362] = 2272,
  [2363] = 1945,
  [2364] = 1962,
  [2365] = 1974,
  [2366] = 2366,
  [2367] = 2367,
  [2368] = 2368,
  [2369] = 1956,
  [2370] = 1947,
  [2371] = 1948,
  [2372] = 2372,
  [2373] = 1942,
  [2374] = 2374,
  [2375] = 2375,
  [2376] = 2278,
  [2377] = 1898,
  [2378] = 1963,
  [2379] = 1973,
  [2380] = 1990,
  [2381] = 2269,
  [2382] = 1979,
  [2383] = 1982,
  [2384] = 1984,
  [2385] = 2262,
  [2386] = 1986,
  [2387] = 1981,
  [2388] = 1965,
  [2389] = 1997,
  [2390] = 1998,
  [2391] = 2270,
  [2392] = 2233,
  [2393] = 1980,
  [2394] = 2394,
  [2395] = 1690,
  [2396] = 2396,
  [2397] = 2272,
  [2398] = 2270,
  [2399] = 1772,
  [2400] = 2400,
  [2401] = 1804,
  [2402] = 2402,
  [2403] = 1987,
  [2404] = 1803,
  [2405] = 1770,
  [2406] = 2293,
  [2407] = 1803,
  [2408] = 1869,
  [2409] = 1804,
  [2410] = 2269,
  [2411] = 1792,
  [2412] = 1794,
  [2413] = 2280,
  [2414] = 2274,
  [2415] = 2415,
  [2416] = 1794,
  [2417] = 1957,
  [2418] = 2418,
  [2419] = 1998,
  [2420] = 1792,
  [2421] = 1901,
  [2422] = 1865,
  [2423] = 2278,
  [2424] = 2424,
  [2425] = 2262,
  [2426] = 1974,
  [2427] = 1771,
  [2428] = 2428,
  [2429] = 2293,
  [2430] = 1997,
  [2431] = 1767,
  [2432] = 2432,
  [2433] = 1896,
  [2434] = 2434,
  [2435] = 1898,
  [2436] = 1803,
  [2437] = 2437,
  [2438] = 2322,
  [2439] = 2439,
  [2440] = 2440,
  [2441] = 2441,
  [2442] = 2252,
  [2443] = 1792,
  [2444] = 1804,
  [2445] = 1794,
  [2446] = 925,
  [2447] = 2447,
  [2448] = 2448,
  [2449] = 2449,
  [2450] = 2347,
  [2451] = 2451,
  [2452] = 2452,
  [2453] = 2453,
  [2454] = 2322,
  [2455] = 2455,
  [2456] = 1794,
  [2457] = 2115,
  [2458] = 2458,
  [2459] = 926,
  [2460] = 1803,
  [2461] = 1804,
  [2462] = 2462,
  [2463] = 2463,
  [2464] = 2464,
  [2465] = 1792,
  [2466] = 1803,
  [2467] = 2467,
  [2468] = 1792,
  [2469] = 2347,
  [2470] = 1804,
  [2471] = 2471,
  [2472] = 2472,
  [2473] = 2473,
  [2474] = 2474,
  [2475] = 1957,
  [2476] = 2088,
  [2477] = 1898,
  [2478] = 1855,
  [2479] = 2479,
  [2480] = 2480,
  [2481] = 1794,
  [2482] = 2482,
  [2483] = 2347,
  [2484] = 2301,
  [2485] = 1753,
  [2486] = 1755,
  [2487] = 1756,
  [2488] = 2488,
  [2489] = 2396,
  [2490] = 2490,
  [2491] = 2491,
  [2492] = 2492,
  [2493] = 2493,
  [2494] = 2494,
  [2495] = 1792,
  [2496] = 2496,
  [2497] = 1998,
  [2498] = 1997,
  [2499] = 2499,
  [2500] = 2500,
  [2501] = 1804,
  [2502] = 2502,
  [2503] = 2503,
  [2504] = 2504,
  [2505] = 2505,
  [2506] = 1754,
  [2507] = 1744,
  [2508] = 1748,
  [2509] = 1752,
  [2510] = 2261,
  [2511] = 2297,
  [2512] = 2271,
  [2513] = 1759,
  [2514] = 1751,
  [2515] = 2272,
  [2516] = 2516,
  [2517] = 2517,
  [2518] = 2270,
  [2519] = 2519,
  [2520] = 2520,
  [2521] = 2521,
  [2522] = 2283,
  [2523] = 1974,
  [2524] = 2524,
  [2525] = 2525,
  [2526] = 2526,
  [2527] = 2527,
  [2528] = 2302,
  [2529] = 1803,
  [2530] = 2308,
  [2531] = 2281,
  [2532] = 2268,
  [2533] = 2266,
  [2534] = 2322,
  [2535] = 2262,
  [2536] = 127,
  [2537] = 2269,
  [2538] = 2008,
  [2539] = 2539,
  [2540] = 2540,
  [2541] = 2541,
  [2542] = 2542,
  [2543] = 2543,
  [2544] = 2544,
  [2545] = 2278,
  [2546] = 1855,
  [2547] = 2547,
  [2548] = 2548,
  [2549] = 2549,
  [2550] = 1749,
  [2551] = 2551,
  [2552] = 2552,
  [2553] = 2553,
  [2554] = 2554,
  [2555] = 1767,
  [2556] = 1995,
  [2557] = 2434,
  [2558] = 2558,
  [2559] = 2559,
  [2560] = 2560,
  [2561] = 1855,
  [2562] = 2562,
  [2563] = 2563,
  [2564] = 1794,
  [2565] = 2565,
  [2566] = 1974,
  [2567] = 2567,
  [2568] = 1747,
  [2569] = 2115,
  [2570] = 2570,
  [2571] = 1746,
  [2572] = 128,
  [2573] = 2573,
  [2574] = 2574,
  [2575] = 2299,
  [2576] = 2576,
  [2577] = 2577,
  [2578] = 2296,
  [2579] = 2579,
  [2580] = 2580,
  [2581] = 2581,
  [2582] = 2582,
  [2583] = 2583,
  [2584] = 2304,
  [2585] = 1758,
  [2586] = 2586,
  [2587] = 1757,
  [2588] = 1745,
  [2589] = 2275,
  [2590] = 2590,
  [2591] = 2280,
  [2592] = 2274,
  [2593] = 2593,
  [2594] = 2300,
  [2595] = 2269,
  [2596] = 1855,
  [2597] = 1957,
  [2598] = 1792,
  [2599] = 2301,
  [2600] = 1771,
  [2601] = 1995,
  [2602] = 1827,
  [2603] = 1803,
  [2604] = 1794,
  [2605] = 2262,
  [2606] = 2280,
  [2607] = 2274,
  [2608] = 2008,
  [2609] = 1804,
  [2610] = 2610,
  [2611] = 2611,
  [2612] = 2293,
  [2613] = 2278,
  [2614] = 1829,
  [2615] = 2272,
  [2616] = 2616,
  [2617] = 1770,
  [2618] = 1874,
  [2619] = 1772,
  [2620] = 2270,
  [2621] = 2115,
  [2622] = 1686,
  [2623] = 1968,
  [2624] = 2270,
  [2625] = 1958,
  [2626] = 1741,
  [2627] = 1938,
  [2628] = 1975,
  [2629] = 1990,
  [2630] = 2630,
  [2631] = 2293,
  [2632] = 1943,
  [2633] = 1941,
  [2634] = 1946,
  [2635] = 2262,
  [2636] = 2269,
  [2637] = 1945,
  [2638] = 2280,
  [2639] = 241,
  [2640] = 1944,
  [2641] = 2641,
  [2642] = 2642,
  [2643] = 2643,
  [2644] = 1687,
  [2645] = 2645,
  [2646] = 2646,
  [2647] = 1688,
  [2648] = 2643,
  [2649] = 1956,
  [2650] = 1689,
  [2651] = 1979,
  [2652] = 1948,
  [2653] = 1963,
  [2654] = 1980,
  [2655] = 1988,
  [2656] = 1965,
  [2657] = 1978,
  [2658] = 1962,
  [2659] = 1855,
  [2660] = 2272,
  [2661] = 1792,
  [2662] = 2643,
  [2663] = 1981,
  [2664] = 2664,
  [2665] = 1940,
  [2666] = 1685,
  [2667] = 1959,
  [2668] = 1955,
  [2669] = 1953,
  [2670] = 1960,
  [2671] = 1865,
  [2672] = 1869,
  [2673] = 2274,
  [2674] = 1684,
  [2675] = 1987,
  [2676] = 1954,
  [2677] = 1942,
  [2678] = 1803,
  [2679] = 1995,
  [2680] = 1949,
  [2681] = 1682,
  [2682] = 1939,
  [2683] = 1901,
  [2684] = 1982,
  [2685] = 2396,
  [2686] = 1957,
  [2687] = 1973,
  [2688] = 1741,
  [2689] = 2008,
  [2690] = 1984,
  [2691] = 1951,
  [2692] = 1901,
  [2693] = 2434,
  [2694] = 2115,
  [2695] = 1966,
  [2696] = 1896,
  [2697] = 1986,
  [2698] = 1896,
  [2699] = 1869,
  [2700] = 263,
  [2701] = 1865,
  [2702] = 2278,
  [2703] = 1947,
  [2704] = 1794,
  [2705] = 1969,
  [2706] = 1804,
  [2707] = 2643,
  [2708] = 1869,
  [2709] = 1689,
  [2710] = 2088,
  [2711] = 1987,
  [2712] = 2252,
  [2713] = 2434,
  [2714] = 1684,
  [2715] = 2013,
  [2716] = 2269,
  [2717] = 2590,
  [2718] = 1685,
  [2719] = 1741,
  [2720] = 2396,
  [2721] = 1865,
  [2722] = 1686,
  [2723] = 1767,
  [2724] = 1741,
  [2725] = 2274,
  [2726] = 2499,
  [2727] = 1682,
  [2728] = 2262,
  [2729] = 2272,
  [2730] = 2278,
  [2731] = 2010,
  [2732] = 2521,
  [2733] = 1896,
  [2734] = 2012,
  [2735] = 1896,
  [2736] = 1741,
  [2737] = 2270,
  [2738] = 2004,
  [2739] = 1901,
  [2740] = 1687,
  [2741] = 2280,
  [2742] = 2301,
  [2743] = 1901,
  [2744] = 1865,
  [2745] = 2519,
  [2746] = 1869,
  [2747] = 2293,
  [2748] = 1688,
  [2749] = 1957,
  [2750] = 2750,
  [2751] = 2751,
  [2752] = 1987,
  [2753] = 2013,
  [2754] = 2750,
  [2755] = 2296,
  [2756] = 1804,
  [2757] = 2004,
  [2758] = 2262,
  [2759] = 2750,
  [2760] = 2300,
  [2761] = 2268,
  [2762] = 2266,
  [2763] = 2763,
  [2764] = 1687,
  [2765] = 2270,
  [2766] = 1995,
  [2767] = 1688,
  [2768] = 2272,
  [2769] = 2304,
  [2770] = 1689,
  [2771] = 2771,
  [2772] = 2302,
  [2773] = 2773,
  [2774] = 2010,
  [2775] = 2775,
  [2776] = 2776,
  [2777] = 2777,
  [2778] = 2778,
  [2779] = 2271,
  [2780] = 2269,
  [2781] = 1682,
  [2782] = 2750,
  [2783] = 2299,
  [2784] = 1803,
  [2785] = 2088,
  [2786] = 1987,
  [2787] = 2787,
  [2788] = 2788,
  [2789] = 2789,
  [2790] = 2750,
  [2791] = 2791,
  [2792] = 2792,
  [2793] = 1794,
  [2794] = 2750,
  [2795] = 1684,
  [2796] = 2012,
  [2797] = 2308,
  [2798] = 1792,
  [2799] = 1685,
  [2800] = 1686,
  [2801] = 2283,
  [2802] = 2008,
  [2803] = 2281,
  [2804] = 2750,
  [2805] = 2293,
  [2806] = 2278,
  [2807] = 2807,
  [2808] = 2808,
  [2809] = 2809,
  [2810] = 2810,
  [2811] = 2274,
  [2812] = 2280,
  [2813] = 2261,
  [2814] = 2252,
  [2815] = 1950,
  [2816] = 2816,
  [2817] = 2293,
  [2818] = 1938,
  [2819] = 1869,
  [2820] = 1865,
  [2821] = 2821,
  [2822] = 2252,
  [2823] = 1682,
  [2824] = 1685,
  [2825] = 2233,
  [2826] = 1686,
  [2827] = 1689,
  [2828] = 1948,
  [2829] = 1688,
  [2830] = 1687,
  [2831] = 2831,
  [2832] = 2832,
  [2833] = 2283,
  [2834] = 2281,
  [2835] = 2582,
  [2836] = 1951,
  [2837] = 2088,
  [2838] = 2268,
  [2839] = 1829,
  [2840] = 2261,
  [2841] = 2266,
  [2842] = 2434,
  [2843] = 1741,
  [2844] = 2844,
  [2845] = 2845,
  [2846] = 2488,
  [2847] = 2300,
  [2848] = 2271,
  [2849] = 1896,
  [2850] = 2490,
  [2851] = 2491,
  [2852] = 1979,
  [2853] = 2396,
  [2854] = 1690,
  [2855] = 1898,
  [2856] = 2299,
  [2857] = 1901,
  [2858] = 1957,
  [2859] = 2859,
  [2860] = 2860,
  [2861] = 2296,
  [2862] = 1958,
  [2863] = 2496,
  [2864] = 2304,
  [2865] = 2492,
  [2866] = 1962,
  [2867] = 1684,
  [2868] = 1874,
  [2869] = 2302,
  [2870] = 1827,
  [2871] = 2494,
  [2872] = 2308,
  [2873] = 1827,
  [2874] = 2874,
  [2875] = 2271,
  [2876] = 2876,
  [2877] = 2295,
  [2878] = 2876,
  [2879] = 1960,
  [2880] = 2267,
  [2881] = 2088,
  [2882] = 2233,
  [2883] = 1975,
  [2884] = 2004,
  [2885] = 2261,
  [2886] = 2876,
  [2887] = 1874,
  [2888] = 2845,
  [2889] = 2302,
  [2890] = 1968,
  [2891] = 1958,
  [2892] = 2831,
  [2893] = 2308,
  [2894] = 2894,
  [2895] = 1941,
  [2896] = 1945,
  [2897] = 2876,
  [2898] = 2832,
  [2899] = 1982,
  [2900] = 1963,
  [2901] = 2300,
  [2902] = 2902,
  [2903] = 2807,
  [2904] = 2773,
  [2905] = 2013,
  [2906] = 2860,
  [2907] = 2792,
  [2908] = 1944,
  [2909] = 2810,
  [2910] = 2809,
  [2911] = 1947,
  [2912] = 2876,
  [2913] = 2776,
  [2914] = 1956,
  [2915] = 2299,
  [2916] = 2763,
  [2917] = 2777,
  [2918] = 1948,
  [2919] = 1987,
  [2920] = 2304,
  [2921] = 2778,
  [2922] = 2751,
  [2923] = 2787,
  [2924] = 1946,
  [2925] = 1943,
  [2926] = 2788,
  [2927] = 2894,
  [2928] = 2789,
  [2929] = 2311,
  [2930] = 2283,
  [2931] = 2808,
  [2932] = 1683,
  [2933] = 1973,
  [2934] = 1984,
  [2935] = 1990,
  [2936] = 2277,
  [2937] = 1986,
  [2938] = 1965,
  [2939] = 1954,
  [2940] = 2012,
  [2941] = 2289,
  [2942] = 1938,
  [2943] = 1978,
  [2944] = 1981,
  [2945] = 1829,
  [2946] = 2281,
  [2947] = 1950,
  [2948] = 1940,
  [2949] = 2296,
  [2950] = 2876,
  [2951] = 1988,
  [2952] = 1969,
  [2953] = 1980,
  [2954] = 1951,
  [2955] = 1974,
  [2956] = 1939,
  [2957] = 1979,
  [2958] = 2876,
  [2959] = 1959,
  [2960] = 2894,
  [2961] = 2961,
  [2962] = 2010,
  [2963] = 1962,
  [2964] = 1955,
  [2965] = 1953,
  [2966] = 2252,
  [2967] = 1683,
  [2968] = 1942,
  [2969] = 1966,
  [2970] = 2268,
  [2971] = 1949,
  [2972] = 2791,
  [2973] = 2771,
  [2974] = 2775,
  [2975] = 2266,
  [2976] = 1978,
  [2977] = 1975,
  [2978] = 2978,
  [2979] = 2394,
  [2980] = 1946,
  [2981] = 1874,
  [2982] = 2267,
  [2983] = 2983,
  [2984] = 1898,
  [2985] = 2859,
  [2986] = 2986,
  [2987] = 1938,
  [2988] = 1829,
  [2989] = 1943,
  [2990] = 1982,
  [2991] = 1984,
  [2992] = 1690,
  [2993] = 1954,
  [2994] = 1956,
  [2995] = 2995,
  [2996] = 1981,
  [2997] = 1827,
  [2998] = 1949,
  [2999] = 2978,
  [3000] = 1986,
  [3001] = 1940,
  [3002] = 2983,
  [3003] = 2311,
  [3004] = 1939,
  [3005] = 1966,
  [3006] = 1947,
  [3007] = 1973,
  [3008] = 2978,
  [3009] = 2233,
  [3010] = 1941,
  [3011] = 1945,
  [3012] = 1980,
  [3013] = 2844,
  [3014] = 1988,
  [3015] = 2978,
  [3016] = 2978,
  [3017] = 1948,
  [3018] = 1944,
  [3019] = 2289,
  [3020] = 1960,
  [3021] = 2355,
  [3022] = 2295,
  [3023] = 2277,
  [3024] = 1950,
  [3025] = 2983,
  [3026] = 1998,
  [3027] = 2978,
  [3028] = 1990,
  [3029] = 2115,
  [3030] = 2983,
  [3031] = 2859,
  [3032] = 3032,
  [3033] = 2844,
  [3034] = 1997,
  [3035] = 2995,
  [3036] = 2328,
  [3037] = 2350,
  [3038] = 2301,
  [3039] = 1951,
  [3040] = 2983,
  [3041] = 1942,
  [3042] = 1979,
  [3043] = 2252,
  [3044] = 1969,
  [3045] = 1968,
  [3046] = 2088,
  [3047] = 2995,
  [3048] = 2978,
  [3049] = 2995,
  [3050] = 2375,
  [3051] = 1683,
  [3052] = 2983,
  [3053] = 1965,
  [3054] = 1963,
  [3055] = 2374,
  [3056] = 1958,
  [3057] = 1962,
  [3058] = 1955,
  [3059] = 1953,
  [3060] = 1959,
  [3061] = 2300,
  [3062] = 2789,
  [3063] = 2792,
  [3064] = 2464,
  [3065] = 1947,
  [3066] = 1944,
  [3067] = 2304,
  [3068] = 1690,
  [3069] = 1683,
  [3070] = 2452,
  [3071] = 2299,
  [3072] = 2807,
  [3073] = 926,
  [3074] = 2447,
  [3075] = 2447,
  [3076] = 2394,
  [3077] = 2452,
  [3078] = 2437,
  [3079] = 2261,
  [3080] = 1987,
  [3081] = 1995,
  [3082] = 1945,
  [3083] = 2424,
  [3084] = 2308,
  [3085] = 1941,
  [3086] = 2807,
  [3087] = 2302,
  [3088] = 1988,
  [3089] = 2821,
  [3090] = 2233,
  [3091] = 2775,
  [3092] = 2299,
  [3093] = 2810,
  [3094] = 1966,
  [3095] = 1939,
  [3096] = 2778,
  [3097] = 1940,
  [3098] = 1978,
  [3099] = 1943,
  [3100] = 1955,
  [3101] = 1946,
  [3102] = 1980,
  [3103] = 1953,
  [3104] = 2809,
  [3105] = 2283,
  [3106] = 2266,
  [3107] = 2281,
  [3108] = 2776,
  [3109] = 1949,
  [3110] = 2463,
  [3111] = 2268,
  [3112] = 2304,
  [3113] = 2271,
  [3114] = 1981,
  [3115] = 1942,
  [3116] = 2268,
  [3117] = 2791,
  [3118] = 2266,
  [3119] = 2328,
  [3120] = 2773,
  [3121] = 2777,
  [3122] = 1986,
  [3123] = 1690,
  [3124] = 2374,
  [3125] = 2616,
  [3126] = 2355,
  [3127] = 2462,
  [3128] = 3128,
  [3129] = 2808,
  [3130] = 925,
  [3131] = 2816,
  [3132] = 2788,
  [3133] = 1982,
  [3134] = 2452,
  [3135] = 2281,
  [3136] = 2771,
  [3137] = 2874,
  [3138] = 2375,
  [3139] = 2751,
  [3140] = 2787,
  [3141] = 2788,
  [3142] = 2789,
  [3143] = 2283,
  [3144] = 2441,
  [3145] = 2808,
  [3146] = 2452,
  [3147] = 1954,
  [3148] = 1956,
  [3149] = 2440,
  [3150] = 3150,
  [3151] = 1959,
  [3152] = 1960,
  [3153] = 2008,
  [3154] = 1963,
  [3155] = 2777,
  [3156] = 1965,
  [3157] = 2479,
  [3158] = 2792,
  [3159] = 2787,
  [3160] = 2751,
  [3161] = 2778,
  [3162] = 1984,
  [3163] = 2261,
  [3164] = 2271,
  [3165] = 1950,
  [3166] = 2302,
  [3167] = 1968,
  [3168] = 1969,
  [3169] = 1997,
  [3170] = 2308,
  [3171] = 2763,
  [3172] = 2771,
  [3173] = 2773,
  [3174] = 2418,
  [3175] = 2775,
  [3176] = 2776,
  [3177] = 2763,
  [3178] = 1998,
  [3179] = 2296,
  [3180] = 1975,
  [3181] = 2844,
  [3182] = 2809,
  [3183] = 2810,
  [3184] = 1990,
  [3185] = 2859,
  [3186] = 2296,
  [3187] = 1973,
  [3188] = 2350,
  [3189] = 1974,
  [3190] = 2428,
  [3191] = 2791,
  [3192] = 2300,
  [3193] = 1979,
  [3194] = 2773,
  [3195] = 3195,
  [3196] = 2775,
  [3197] = 2845,
  [3198] = 2452,
  [3199] = 2464,
  [3200] = 2418,
  [3201] = 3201,
  [3202] = 2810,
  [3203] = 3195,
  [3204] = 1771,
  [3205] = 3128,
  [3206] = 3201,
  [3207] = 3207,
  [3208] = 3208,
  [3209] = 2808,
  [3210] = 2549,
  [3211] = 3211,
  [3212] = 3195,
  [3213] = 2809,
  [3214] = 2441,
  [3215] = 2789,
  [3216] = 2788,
  [3217] = 2771,
  [3218] = 2763,
  [3219] = 2787,
  [3220] = 2751,
  [3221] = 2778,
  [3222] = 1827,
  [3223] = 2777,
  [3224] = 2776,
  [3225] = 2809,
  [3226] = 2366,
  [3227] = 2810,
  [3228] = 2361,
  [3229] = 2359,
  [3230] = 3230,
  [3231] = 3231,
  [3232] = 2452,
  [3233] = 1962,
  [3234] = 2961,
  [3235] = 1958,
  [3236] = 2776,
  [3237] = 2832,
  [3238] = 2451,
  [3239] = 3211,
  [3240] = 1951,
  [3241] = 2777,
  [3242] = 3242,
  [3243] = 2439,
  [3244] = 3211,
  [3245] = 2464,
  [3246] = 2763,
  [3247] = 3208,
  [3248] = 2791,
  [3249] = 3249,
  [3250] = 3195,
  [3251] = 2778,
  [3252] = 3195,
  [3253] = 2751,
  [3254] = 2428,
  [3255] = 3255,
  [3256] = 3255,
  [3257] = 1772,
  [3258] = 3195,
  [3259] = 2787,
  [3260] = 2233,
  [3261] = 925,
  [3262] = 2396,
  [3263] = 3231,
  [3264] = 2372,
  [3265] = 2452,
  [3266] = 2340,
  [3267] = 3255,
  [3268] = 2368,
  [3269] = 3255,
  [3270] = 2367,
  [3271] = 3201,
  [3272] = 2788,
  [3273] = 3255,
  [3274] = 2789,
  [3275] = 3231,
  [3276] = 3201,
  [3277] = 2860,
  [3278] = 2441,
  [3279] = 2549,
  [3280] = 2349,
  [3281] = 2808,
  [3282] = 3195,
  [3283] = 2325,
  [3284] = 1971,
  [3285] = 2791,
  [3286] = 2860,
  [3287] = 2440,
  [3288] = 3231,
  [3289] = 2115,
  [3290] = 3242,
  [3291] = 3211,
  [3292] = 2832,
  [3293] = 2424,
  [3294] = 2630,
  [3295] = 2792,
  [3296] = 2493,
  [3297] = 3231,
  [3298] = 2458,
  [3299] = 2472,
  [3300] = 2792,
  [3301] = 2771,
  [3302] = 2415,
  [3303] = 1938,
  [3304] = 1770,
  [3305] = 2434,
  [3306] = 3211,
  [3307] = 2831,
  [3308] = 2831,
  [3309] = 3255,
  [3310] = 3208,
  [3311] = 1957,
  [3312] = 3201,
  [3313] = 2452,
  [3314] = 2479,
  [3315] = 1948,
  [3316] = 1855,
  [3317] = 2479,
  [3318] = 2440,
  [3319] = 2463,
  [3320] = 2493,
  [3321] = 3211,
  [3322] = 2462,
  [3323] = 2807,
  [3324] = 2301,
  [3325] = 3325,
  [3326] = 2775,
  [3327] = 2845,
  [3328] = 2463,
  [3329] = 2447,
  [3330] = 2462,
  [3331] = 2553,
  [3332] = 2356,
  [3333] = 2437,
  [3334] = 2496,
  [3335] = 2807,
  [3336] = 3195,
  [3337] = 2437,
  [3338] = 2582,
  [3339] = 2494,
  [3340] = 3201,
  [3341] = 1874,
  [3342] = 926,
  [3343] = 3325,
  [3344] = 2488,
  [3345] = 2342,
  [3346] = 2490,
  [3347] = 1690,
  [3348] = 2491,
  [3349] = 2492,
  [3350] = 1829,
  [3351] = 2773,
  [3352] = 3195,
  [3353] = 2553,
  [3354] = 3231,
  [3355] = 2496,
  [3356] = 2115,
  [3357] = 2567,
  [3358] = 128,
  [3359] = 2356,
  [3360] = 3325,
  [3361] = 2521,
  [3362] = 2526,
  [3363] = 2574,
  [3364] = 2570,
  [3365] = 2552,
  [3366] = 2493,
  [3367] = 2500,
  [3368] = 2503,
  [3369] = 2504,
  [3370] = 1755,
  [3371] = 1973,
  [3372] = 2560,
  [3373] = 1990,
  [3374] = 2961,
  [3375] = 1749,
  [3376] = 3325,
  [3377] = 1752,
  [3378] = 1756,
  [3379] = 2372,
  [3380] = 2458,
  [3381] = 2233,
  [3382] = 1758,
  [3383] = 1757,
  [3384] = 127,
  [3385] = 2340,
  [3386] = 1942,
  [3387] = 1949,
  [3388] = 1953,
  [3389] = 1955,
  [3390] = 2368,
  [3391] = 2367,
  [3392] = 2527,
  [3393] = 1758,
  [3394] = 1803,
  [3395] = 2525,
  [3396] = 1770,
  [3397] = 1804,
  [3398] = 2524,
  [3399] = 2563,
  [3400] = 1756,
  [3401] = 1757,
  [3402] = 2272,
  [3403] = 1794,
  [3404] = 2517,
  [3405] = 2270,
  [3406] = 2516,
  [3407] = 1751,
  [3408] = 1751,
  [3409] = 1988,
  [3410] = 1759,
  [3411] = 2361,
  [3412] = 2297,
  [3413] = 1745,
  [3414] = 1752,
  [3415] = 2831,
  [3416] = 2832,
  [3417] = 1792,
  [3418] = 1753,
  [3419] = 2488,
  [3420] = 2553,
  [3421] = 2490,
  [3422] = 2491,
  [3423] = 2492,
  [3424] = 2280,
  [3425] = 2494,
  [3426] = 2274,
  [3427] = 2262,
  [3428] = 2447,
  [3429] = 2453,
  [3430] = 2449,
  [3431] = 2269,
  [3432] = 2448,
  [3433] = 1947,
  [3434] = 2860,
  [3435] = 1944,
  [3436] = 2471,
  [3437] = 2541,
  [3438] = 1855,
  [3439] = 127,
  [3440] = 2961,
  [3441] = 2359,
  [3442] = 2455,
  [3443] = 2293,
  [3444] = 2301,
  [3445] = 1755,
  [3446] = 2366,
  [3447] = 2474,
  [3448] = 1753,
  [3449] = 2342,
  [3450] = 2586,
  [3451] = 128,
  [3452] = 2519,
  [3453] = 2549,
  [3454] = 2505,
  [3455] = 1945,
  [3456] = 2502,
  [3457] = 1941,
  [3458] = 3458,
  [3459] = 2472,
  [3460] = 1950,
  [3461] = 1966,
  [3462] = 1939,
  [3463] = 1940,
  [3464] = 2278,
  [3465] = 2452,
  [3466] = 1943,
  [3467] = 1746,
  [3468] = 1946,
  [3469] = 1747,
  [3470] = 2565,
  [3471] = 2452,
  [3472] = 1754,
  [3473] = 1995,
  [3474] = 1744,
  [3475] = 1748,
  [3476] = 925,
  [3477] = 2467,
  [3478] = 1794,
  [3479] = 1746,
  [3480] = 1745,
  [3481] = 1747,
  [3482] = 1754,
  [3483] = 1771,
  [3484] = 2593,
  [3485] = 2539,
  [3486] = 1978,
  [3487] = 1980,
  [3488] = 2583,
  [3489] = 1981,
  [3490] = 1986,
  [3491] = 1984,
  [3492] = 1982,
  [3493] = 2482,
  [3494] = 2350,
  [3495] = 2355,
  [3496] = 2301,
  [3497] = 2542,
  [3498] = 3498,
  [3499] = 2543,
  [3500] = 2548,
  [3501] = 2581,
  [3502] = 2580,
  [3503] = 2579,
  [3504] = 1744,
  [3505] = 1748,
  [3506] = 2544,
  [3507] = 2547,
  [3508] = 2590,
  [3509] = 2540,
  [3510] = 1957,
  [3511] = 2845,
  [3512] = 1759,
  [3513] = 2576,
  [3514] = 2439,
  [3515] = 2394,
  [3516] = 2325,
  [3517] = 2349,
  [3518] = 1975,
  [3519] = 1772,
  [3520] = 1749,
  [3521] = 926,
  [3522] = 2275,
  [3523] = 2415,
  [3524] = 1969,
  [3525] = 1968,
  [3526] = 2520,
  [3527] = 2582,
  [3528] = 2577,
  [3529] = 2573,
  [3530] = 1803,
  [3531] = 1965,
  [3532] = 1963,
  [3533] = 2499,
  [3534] = 3032,
  [3535] = 1960,
  [3536] = 1959,
  [3537] = 2551,
  [3538] = 2451,
  [3539] = 2008,
  [3540] = 2562,
  [3541] = 2375,
  [3542] = 2559,
  [3543] = 2558,
  [3544] = 2554,
  [3545] = 2452,
  [3546] = 1954,
  [3547] = 1956,
  [3548] = 2453,
  [3549] = 1752,
  [3550] = 2567,
  [3551] = 2582,
  [3552] = 2467,
  [3553] = 2496,
  [3554] = 1749,
  [3555] = 2474,
  [3556] = 2494,
  [3557] = 2464,
  [3558] = 2492,
  [3559] = 2491,
  [3560] = 2270,
  [3561] = 1758,
  [3562] = 2547,
  [3563] = 2490,
  [3564] = 2560,
  [3565] = 2488,
  [3566] = 2482,
  [3567] = 2297,
  [3568] = 1756,
  [3569] = 3325,
  [3570] = 2554,
  [3571] = 1757,
  [3572] = 2558,
  [3573] = 2590,
  [3574] = 2552,
  [3575] = 2539,
  [3576] = 2449,
  [3577] = 2570,
  [3578] = 2574,
  [3579] = 2810,
  [3580] = 2262,
  [3581] = 2809,
  [3582] = 2448,
  [3583] = 2776,
  [3584] = 1745,
  [3585] = 2775,
  [3586] = 2521,
  [3587] = 2777,
  [3588] = 2479,
  [3589] = 2778,
  [3590] = 2751,
  [3591] = 2541,
  [3592] = 2504,
  [3593] = 2455,
  [3594] = 2503,
  [3595] = 127,
  [3596] = 2787,
  [3597] = 2500,
  [3598] = 2788,
  [3599] = 2789,
  [3600] = 2579,
  [3601] = 2441,
  [3602] = 2808,
  [3603] = 2272,
  [3604] = 1767,
  [3605] = 2559,
  [3606] = 2583,
  [3607] = 2471,
  [3608] = 2463,
  [3609] = 2773,
  [3610] = 2269,
  [3611] = 2961,
  [3612] = 1682,
  [3613] = 2462,
  [3614] = 1690,
  [3615] = 2275,
  [3616] = 3616,
  [3617] = 3325,
  [3618] = 3618,
  [3619] = 1746,
  [3620] = 2771,
  [3621] = 2562,
  [3622] = 2280,
  [3623] = 2807,
  [3624] = 1747,
  [3625] = 2493,
  [3626] = 2573,
  [3627] = 3325,
  [3628] = 2437,
  [3629] = 2577,
  [3630] = 3325,
  [3631] = 2396,
  [3632] = 2565,
  [3633] = 2580,
  [3634] = 1759,
  [3635] = 2516,
  [3636] = 2517,
  [3637] = 2520,
  [3638] = 3325,
  [3639] = 128,
  [3640] = 1997,
  [3641] = 1998,
  [3642] = 2540,
  [3643] = 2581,
  [3644] = 2519,
  [3645] = 2553,
  [3646] = 1754,
  [3647] = 2593,
  [3648] = 1744,
  [3649] = 2524,
  [3650] = 1748,
  [3651] = 2791,
  [3652] = 2548,
  [3653] = 2008,
  [3654] = 2792,
  [3655] = 3655,
  [3656] = 2502,
  [3657] = 3325,
  [3658] = 2763,
  [3659] = 2543,
  [3660] = 2527,
  [3661] = 2274,
  [3662] = 2544,
  [3663] = 2961,
  [3664] = 2008,
  [3665] = 2434,
  [3666] = 3325,
  [3667] = 2549,
  [3668] = 2278,
  [3669] = 1751,
  [3670] = 1995,
  [3671] = 2542,
  [3672] = 2551,
  [3673] = 2499,
  [3674] = 2525,
  [3675] = 2505,
  [3676] = 2563,
  [3677] = 1684,
  [3678] = 3325,
  [3679] = 2961,
  [3680] = 1685,
  [3681] = 1995,
  [3682] = 1686,
  [3683] = 1689,
  [3684] = 1688,
  [3685] = 1687,
  [3686] = 2586,
  [3687] = 2576,
  [3688] = 2526,
  [3689] = 1755,
  [3690] = 2428,
  [3691] = 1753,
  [3692] = 2428,
  [3693] = 3693,
  [3694] = 3694,
  [3695] = 3695,
  [3696] = 3696,
  [3697] = 3697,
  [3698] = 3325,
  [3699] = 3699,
  [3700] = 3697,
  [3701] = 1792,
  [3702] = 3702,
  [3703] = 3697,
  [3704] = 1804,
  [3705] = 3693,
  [3706] = 3702,
  [3707] = 1997,
  [3708] = 3697,
  [3709] = 1998,
  [3710] = 1687,
  [3711] = 3711,
  [3712] = 3697,
  [3713] = 3695,
  [3714] = 3702,
  [3715] = 3695,
  [3716] = 1688,
  [3717] = 3702,
  [3718] = 3702,
  [3719] = 2439,
  [3720] = 3697,
  [3721] = 3702,
  [3722] = 1689,
  [3723] = 1690,
  [3724] = 3711,
  [3725] = 1686,
  [3726] = 3694,
  [3727] = 3727,
  [3728] = 3728,
  [3729] = 3728,
  [3730] = 3728,
  [3731] = 1685,
  [3732] = 2845,
  [3733] = 3697,
  [3734] = 2434,
  [3735] = 3735,
  [3736] = 3695,
  [3737] = 3702,
  [3738] = 3702,
  [3739] = 3693,
  [3740] = 3711,
  [3741] = 2860,
  [3742] = 2301,
  [3743] = 3699,
  [3744] = 2396,
  [3745] = 3325,
  [3746] = 3728,
  [3747] = 1684,
  [3748] = 3728,
  [3749] = 3711,
  [3750] = 1682,
  [3751] = 3702,
  [3752] = 3695,
  [3753] = 2293,
  [3754] = 3694,
  [3755] = 1683,
  [3756] = 3711,
  [3757] = 3699,
  [3758] = 3693,
  [3759] = 3325,
  [3760] = 3711,
  [3761] = 3699,
  [3762] = 3695,
  [3763] = 1865,
  [3764] = 3695,
  [3765] = 3694,
  [3766] = 3693,
  [3767] = 3697,
  [3768] = 3697,
  [3769] = 3694,
  [3770] = 3694,
  [3771] = 1869,
  [3772] = 3693,
  [3773] = 2831,
  [3774] = 1803,
  [3775] = 3695,
  [3776] = 3699,
  [3777] = 1896,
  [3778] = 3694,
  [3779] = 3695,
  [3780] = 1901,
  [3781] = 2832,
  [3782] = 3697,
  [3783] = 3697,
  [3784] = 3325,
  [3785] = 3699,
  [3786] = 3693,
  [3787] = 3694,
  [3788] = 3694,
  [3789] = 3693,
  [3790] = 1957,
  [3791] = 3728,
  [3792] = 3697,
  [3793] = 3693,
  [3794] = 1794,
  [3795] = 2463,
  [3796] = 2297,
  [3797] = 2593,
  [3798] = 2579,
  [3799] = 3799,
  [3800] = 2580,
  [3801] = 2275,
  [3802] = 2544,
  [3803] = 1987,
  [3804] = 2252,
  [3805] = 2581,
  [3806] = 2008,
  [3807] = 3799,
  [3808] = 1803,
  [3809] = 2577,
  [3810] = 3799,
  [3811] = 2573,
  [3812] = 2004,
  [3813] = 2562,
  [3814] = 2559,
  [3815] = 2558,
  [3816] = 3032,
  [3817] = 2554,
  [3818] = 1792,
  [3819] = 2012,
  [3820] = 2583,
  [3821] = 3799,
  [3822] = 2519,
  [3823] = 2551,
  [3824] = 1804,
  [3825] = 1749,
  [3826] = 3325,
  [3827] = 2547,
  [3828] = 1792,
  [3829] = 1804,
  [3830] = 3325,
  [3831] = 2543,
  [3832] = 2542,
  [3833] = 2482,
  [3834] = 2539,
  [3835] = 3799,
  [3836] = 2520,
  [3837] = 2010,
  [3838] = 2439,
  [3839] = 2088,
  [3840] = 1745,
  [3841] = 2574,
  [3842] = 3799,
  [3843] = 2570,
  [3844] = 3799,
  [3845] = 1752,
  [3846] = 1794,
  [3847] = 1751,
  [3848] = 2552,
  [3849] = 1995,
  [3850] = 1756,
  [3851] = 3799,
  [3852] = 3799,
  [3853] = 1754,
  [3854] = 1744,
  [3855] = 1748,
  [3856] = 2590,
  [3857] = 2502,
  [3858] = 2505,
  [3859] = 2521,
  [3860] = 2462,
  [3861] = 2539,
  [3862] = 1794,
  [3863] = 1753,
  [3864] = 1755,
  [3865] = 128,
  [3866] = 2540,
  [3867] = 3799,
  [3868] = 2464,
  [3869] = 2544,
  [3870] = 2548,
  [3871] = 3871,
  [3872] = 1759,
  [3873] = 3799,
  [3874] = 2516,
  [3875] = 2517,
  [3876] = 2565,
  [3877] = 1747,
  [3878] = 2524,
  [3879] = 2525,
  [3880] = 1746,
  [3881] = 2527,
  [3882] = 127,
  [3883] = 3799,
  [3884] = 3799,
  [3885] = 2441,
  [3886] = 2554,
  [3887] = 3799,
  [3888] = 1803,
  [3889] = 2499,
  [3890] = 2560,
  [3891] = 2013,
  [3892] = 2527,
  [3893] = 1757,
  [3894] = 1758,
  [3895] = 2479,
  [3896] = 2567,
  [3897] = 2437,
  [3898] = 2552,
  [3899] = 3899,
  [3900] = 2308,
  [3901] = 3899,
  [3902] = 2502,
  [3903] = 1794,
  [3904] = 2579,
  [3905] = 2567,
  [3906] = 2542,
  [3907] = 2558,
  [3908] = 1804,
  [3909] = 3909,
  [3910] = 1792,
  [3911] = 2271,
  [3912] = 2525,
  [3913] = 2577,
  [3914] = 2580,
  [3915] = 2524,
  [3916] = 2088,
  [3917] = 1690,
  [3918] = 2299,
  [3919] = 2300,
  [3920] = 2581,
  [3921] = 2302,
  [3922] = 2565,
  [3923] = 2559,
  [3924] = 2304,
  [3925] = 2505,
  [3926] = 2482,
  [3927] = 2543,
  [3928] = 2573,
  [3929] = 2583,
  [3930] = 3930,
  [3931] = 2540,
  [3932] = 3899,
  [3933] = 2548,
  [3934] = 2560,
  [3935] = 2296,
  [3936] = 2283,
  [3937] = 3937,
  [3938] = 2252,
  [3939] = 1803,
  [3940] = 2593,
  [3941] = 2551,
  [3942] = 2574,
  [3943] = 2562,
  [3944] = 2115,
  [3945] = 3230,
  [3946] = 2281,
  [3947] = 2570,
  [3948] = 3207,
  [3949] = 2547,
  [3950] = 2520,
  [3951] = 2261,
  [3952] = 2516,
  [3953] = 3937,
  [3954] = 2517,
  [3955] = 2434,
  [3956] = 2268,
  [3957] = 2266,
  [3958] = 3937,
  [3959] = 2396,
  [3960] = 2304,
  [3961] = 2355,
  [3962] = 2299,
  [3963] = 3032,
  [3964] = 3325,
  [3965] = 2013,
  [3966] = 3899,
  [3967] = 2301,
  [3968] = 2350,
  [3969] = 2296,
  [3970] = 3325,
  [3971] = 2261,
  [3972] = 2394,
  [3973] = 2010,
  [3974] = 2271,
  [3975] = 2283,
  [3976] = 2308,
  [3977] = 2281,
  [3978] = 2300,
  [3979] = 2268,
  [3980] = 3325,
  [3981] = 2375,
  [3982] = 3325,
  [3983] = 2004,
  [3984] = 2302,
  [3985] = 1683,
  [3986] = 2266,
  [3987] = 3937,
  [3988] = 2012,
  [3989] = 1938,
  [3990] = 3990,
  [3991] = 3991,
  [3992] = 3899,
  [3993] = 1690,
  [3994] = 3991,
  [3995] = 3991,
  [3996] = 2008,
  [3997] = 3997,
  [3998] = 2434,
  [3999] = 3991,
  [4000] = 3997,
  [4001] = 3997,
  [4002] = 1855,
  [4003] = 4003,
  [4004] = 3990,
  [4005] = 3899,
  [4006] = 4003,
  [4007] = 2978,
  [4008] = 1979,
  [4009] = 3990,
  [4010] = 3997,
  [4011] = 3991,
  [4012] = 3991,
  [4013] = 1829,
  [4014] = 3937,
  [4015] = 3990,
  [4016] = 3997,
  [4017] = 1827,
  [4018] = 4003,
  [4019] = 1962,
  [4020] = 4003,
  [4021] = 1948,
  [4022] = 1958,
  [4023] = 3991,
  [4024] = 3990,
  [4025] = 3990,
  [4026] = 4003,
  [4027] = 1874,
  [4028] = 1951,
  [4029] = 3990,
  [4030] = 4003,
  [4031] = 2396,
  [4032] = 2978,
  [4033] = 3997,
  [4034] = 3997,
  [4035] = 4003,
  [4036] = 1995,
  [4037] = 3937,
  [4038] = 1945,
  [4039] = 1975,
  [4040] = 373,
  [4041] = 4041,
  [4042] = 2012,
  [4043] = 4043,
  [4044] = 1978,
  [4045] = 4045,
  [4046] = 4045,
  [4047] = 3899,
  [4048] = 4045,
  [4049] = 1944,
  [4050] = 1947,
  [4051] = 4045,
  [4052] = 2480,
  [4053] = 4045,
  [4054] = 4041,
  [4055] = 4045,
  [4056] = 4043,
  [4057] = 1973,
  [4058] = 4041,
  [4059] = 309,
  [4060] = 1946,
  [4061] = 1943,
  [4062] = 2473,
  [4063] = 4043,
  [4064] = 2013,
  [4065] = 4041,
  [4066] = 1940,
  [4067] = 1939,
  [4068] = 1966,
  [4069] = 3937,
  [4070] = 1990,
  [4071] = 1956,
  [4072] = 1941,
  [4073] = 2434,
  [4074] = 303,
  [4075] = 2010,
  [4076] = 4043,
  [4077] = 2396,
  [4078] = 4041,
  [4079] = 1959,
  [4080] = 1960,
  [4081] = 1696,
  [4082] = 1980,
  [4083] = 4043,
  [4084] = 1981,
  [4085] = 2004,
  [4086] = 1963,
  [4087] = 1986,
  [4088] = 1988,
  [4089] = 1965,
  [4090] = 1968,
  [4091] = 318,
  [4092] = 315,
  [4093] = 1984,
  [4094] = 1969,
  [4095] = 1942,
  [4096] = 392,
  [4097] = 1954,
  [4098] = 4041,
  [4099] = 1949,
  [4100] = 3616,
  [4101] = 4043,
  [4102] = 1955,
  [4103] = 1982,
  [4104] = 1953,
  [4105] = 1898,
  [4106] = 2808,
  [4107] = 4107,
  [4108] = 2809,
  [4109] = 2004,
  [4110] = 2010,
  [4111] = 2777,
  [4112] = 2788,
  [4113] = 2787,
  [4114] = 3899,
  [4115] = 2807,
  [4116] = 2751,
  [4117] = 2590,
  [4118] = 4118,
  [4119] = 2778,
  [4120] = 2521,
  [4121] = 2789,
  [4122] = 2519,
  [4123] = 2792,
  [4124] = 1683,
  [4125] = 3937,
  [4126] = 2763,
  [4127] = 2771,
  [4128] = 2773,
  [4129] = 2775,
  [4130] = 2810,
  [4131] = 2791,
  [4132] = 2776,
  [4133] = 2013,
  [4134] = 4118,
  [4135] = 2012,
  [4136] = 4136,
  [4137] = 2499,
  [4138] = 4138,
  [4139] = 1767,
  [4140] = 2434,
  [4141] = 4141,
  [4142] = 2355,
  [4143] = 4141,
  [4144] = 2350,
  [4145] = 2860,
  [4146] = 3937,
  [4147] = 4141,
  [4148] = 2845,
  [4149] = 2832,
  [4150] = 2831,
  [4151] = 4138,
  [4152] = 2375,
  [4153] = 4138,
  [4154] = 3899,
  [4155] = 2394,
  [4156] = 1974,
  [4157] = 2396,
  [4158] = 3930,
  [4159] = 1898,
  [4160] = 2610,
  [4161] = 2616,
  [4162] = 2301,
  [4163] = 4163,
  [4164] = 2845,
  [4165] = 4138,
  [4166] = 2860,
  [4167] = 1995,
  [4168] = 2275,
  [4169] = 3899,
  [4170] = 2275,
  [4171] = 2611,
  [4172] = 2297,
  [4173] = 2008,
  [4174] = 2832,
  [4175] = 2831,
  [4176] = 1683,
  [4177] = 3937,
  [4178] = 4178,
  [4179] = 4163,
  [4180] = 2301,
  [4181] = 4181,
  [4182] = 4141,
  [4183] = 4163,
  [4184] = 2297,
  [4185] = 2115,
  [4186] = 3909,
  [4187] = 2777,
  [4188] = 4188,
  [4189] = 4189,
  [4190] = 2778,
  [4191] = 4138,
  [4192] = 1974,
  [4193] = 2791,
  [4194] = 4189,
  [4195] = 2789,
  [4196] = 3937,
  [4197] = 3899,
  [4198] = 2776,
  [4199] = 4199,
  [4200] = 2775,
  [4201] = 2809,
  [4202] = 2810,
  [4203] = 2808,
  [4204] = 4204,
  [4205] = 4205,
  [4206] = 2788,
  [4207] = 3899,
  [4208] = 2773,
  [4209] = 4204,
  [4210] = 4210,
  [4211] = 2807,
  [4212] = 3937,
  [4213] = 2787,
  [4214] = 4214,
  [4215] = 2751,
  [4216] = 2771,
  [4217] = 2763,
  [4218] = 4141,
  [4219] = 2792,
  [4220] = 4188,
  [4221] = 1767,
  [4222] = 4141,
  [4223] = 4223,
  [4224] = 4199,
  [4225] = 4138,
  [4226] = 128,
  [4227] = 1759,
  [4228] = 4228,
  [4229] = 4229,
  [4230] = 4230,
  [4231] = 4178,
  [4232] = 4228,
  [4233] = 2773,
  [4234] = 2807,
  [4235] = 4235,
  [4236] = 4236,
  [4237] = 4237,
  [4238] = 2771,
  [4239] = 4239,
  [4240] = 4240,
  [4241] = 4241,
  [4242] = 4239,
  [4243] = 4243,
  [4244] = 2775,
  [4245] = 4230,
  [4246] = 4237,
  [4247] = 4247,
  [4248] = 4240,
  [4249] = 4249,
  [4250] = 4250,
  [4251] = 4251,
  [4252] = 3937,
  [4253] = 4253,
  [4254] = 4230,
  [4255] = 4178,
  [4256] = 4256,
  [4257] = 4257,
  [4258] = 4240,
  [4259] = 4259,
  [4260] = 4229,
  [4261] = 4247,
  [4262] = 4228,
  [4263] = 4247,
  [4264] = 2810,
  [4265] = 4141,
  [4266] = 4229,
  [4267] = 2763,
  [4268] = 2809,
  [4269] = 2776,
  [4270] = 2777,
  [4271] = 1690,
  [4272] = 2778,
  [4273] = 2751,
  [4274] = 2787,
  [4275] = 2788,
  [4276] = 2789,
  [4277] = 4240,
  [4278] = 4278,
  [4279] = 4243,
  [4280] = 4257,
  [4281] = 2808,
  [4282] = 4229,
  [4283] = 4283,
  [4284] = 4237,
  [4285] = 1749,
  [4286] = 4240,
  [4287] = 4247,
  [4288] = 4240,
  [4289] = 4228,
  [4290] = 1745,
  [4291] = 4228,
  [4292] = 4230,
  [4293] = 2115,
  [4294] = 2791,
  [4295] = 4229,
  [4296] = 4240,
  [4297] = 1756,
  [4298] = 4298,
  [4299] = 4230,
  [4300] = 1754,
  [4301] = 4228,
  [4302] = 4240,
  [4303] = 4240,
  [4304] = 1744,
  [4305] = 4239,
  [4306] = 1748,
  [4307] = 4181,
  [4308] = 4228,
  [4309] = 4138,
  [4310] = 3899,
  [4311] = 2792,
  [4312] = 4247,
  [4313] = 4240,
  [4314] = 127,
  [4315] = 3937,
  [4316] = 2350,
  [4317] = 1747,
  [4318] = 2355,
  [4319] = 1746,
  [4320] = 3899,
  [4321] = 4247,
  [4322] = 1753,
  [4323] = 1755,
  [4324] = 4240,
  [4325] = 4240,
  [4326] = 4230,
  [4327] = 4240,
  [4328] = 4229,
  [4329] = 4240,
  [4330] = 1752,
  [4331] = 4241,
  [4332] = 4241,
  [4333] = 4243,
  [4334] = 4240,
  [4335] = 4240,
  [4336] = 1751,
  [4337] = 2394,
  [4338] = 4240,
  [4339] = 4257,
  [4340] = 2375,
  [4341] = 4229,
  [4342] = 1758,
  [4343] = 1757,
  [4344] = 2810,
  [4345] = 4345,
  [4346] = 2396,
  [4347] = 2464,
  [4348] = 4348,
  [4349] = 2809,
  [4350] = 4239,
  [4351] = 4351,
  [4352] = 2832,
  [4353] = 2775,
  [4354] = 2776,
  [4355] = 4355,
  [4356] = 4356,
  [4357] = 2777,
  [4358] = 4358,
  [4359] = 2778,
  [4360] = 2751,
  [4361] = 2278,
  [4362] = 2787,
  [4363] = 4363,
  [4364] = 2831,
  [4365] = 4365,
  [4366] = 4366,
  [4367] = 4356,
  [4368] = 4368,
  [4369] = 4366,
  [4370] = 2773,
  [4371] = 2788,
  [4372] = 2789,
  [4373] = 2441,
  [4374] = 2808,
  [4375] = 4241,
  [4376] = 4356,
  [4377] = 2778,
  [4378] = 2771,
  [4379] = 1690,
  [4380] = 4356,
  [4381] = 2792,
  [4382] = 2791,
  [4383] = 2808,
  [4384] = 4384,
  [4385] = 4385,
  [4386] = 2789,
  [4387] = 4356,
  [4388] = 2788,
  [4389] = 2787,
  [4390] = 1995,
  [4391] = 2751,
  [4392] = 2777,
  [4393] = 4393,
  [4394] = 2776,
  [4395] = 2791,
  [4396] = 2008,
  [4397] = 4397,
  [4398] = 4237,
  [4399] = 2809,
  [4400] = 2792,
  [4401] = 4368,
  [4402] = 2810,
  [4403] = 2775,
  [4404] = 2773,
  [4405] = 4138,
  [4406] = 2274,
  [4407] = 2771,
  [4408] = 2763,
  [4409] = 2771,
  [4410] = 4410,
  [4411] = 2280,
  [4412] = 4178,
  [4413] = 2434,
  [4414] = 2773,
  [4415] = 2763,
  [4416] = 2792,
  [4417] = 4141,
  [4418] = 4351,
  [4419] = 2807,
  [4420] = 4420,
  [4421] = 2437,
  [4422] = 2428,
  [4423] = 2807,
  [4424] = 1799,
  [4425] = 2763,
  [4426] = 2462,
  [4427] = 2775,
  [4428] = 4243,
  [4429] = 2463,
  [4430] = 4365,
  [4431] = 4420,
  [4432] = 4363,
  [4433] = 4420,
  [4434] = 2845,
  [4435] = 4435,
  [4436] = 4436,
  [4437] = 2479,
  [4438] = 2463,
  [4439] = 2462,
  [4440] = 2437,
  [4441] = 4356,
  [4442] = 2479,
  [4443] = 4443,
  [4444] = 2860,
  [4445] = 4356,
  [4446] = 4356,
  [4447] = 4420,
  [4448] = 4351,
  [4449] = 4366,
  [4450] = 4356,
  [4451] = 4298,
  [4452] = 4452,
  [4453] = 4453,
  [4454] = 4454,
  [4455] = 4420,
  [4456] = 2293,
  [4457] = 4457,
  [4458] = 4107,
  [4459] = 2810,
  [4460] = 2809,
  [4461] = 4356,
  [4462] = 2776,
  [4463] = 2777,
  [4464] = 2778,
  [4465] = 2751,
  [4466] = 2787,
  [4467] = 2441,
  [4468] = 2301,
  [4469] = 4356,
  [4470] = 4470,
  [4471] = 2269,
  [4472] = 2788,
  [4473] = 2789,
  [4474] = 4356,
  [4475] = 2262,
  [4476] = 4420,
  [4477] = 3242,
  [4478] = 4366,
  [4479] = 4479,
  [4480] = 2270,
  [4481] = 2272,
  [4482] = 4482,
  [4483] = 4351,
  [4484] = 2807,
  [4485] = 2808,
  [4486] = 4486,
  [4487] = 4366,
  [4488] = 4488,
  [4489] = 2464,
  [4490] = 4356,
  [4491] = 4366,
  [4492] = 4351,
  [4493] = 4366,
  [4494] = 2791,
  [4495] = 4495,
  [4496] = 4496,
  [4497] = 4497,
  [4498] = 4498,
  [4499] = 4499,
  [4500] = 4500,
  [4501] = 4501,
  [4502] = 4237,
  [4503] = 4495,
  [4504] = 4504,
  [4505] = 4496,
  [4506] = 4506,
  [4507] = 4507,
  [4508] = 4508,
  [4509] = 4509,
  [4510] = 4510,
  [4511] = 4511,
  [4512] = 4512,
  [4513] = 4513,
  [4514] = 4504,
  [4515] = 4515,
  [4516] = 4516,
  [4517] = 4507,
  [4518] = 4241,
  [4519] = 4519,
  [4520] = 4511,
  [4521] = 4521,
  [4522] = 4495,
  [4523] = 4498,
  [4524] = 4524,
  [4525] = 4239,
  [4526] = 3899,
  [4527] = 3937,
  [4528] = 4507,
  [4529] = 4529,
  [4530] = 4243,
  [4531] = 1855,
  [4532] = 4532,
  [4533] = 4507,
  [4534] = 4534,
  [4535] = 4496,
  [4536] = 4506,
  [4537] = 4537,
  [4538] = 4538,
  [4539] = 4509,
  [4540] = 4508,
  [4541] = 4516,
  [4542] = 4501,
  [4543] = 4506,
  [4544] = 4504,
  [4545] = 1957,
  [4546] = 4500,
  [4547] = 4547,
  [4548] = 4510,
  [4549] = 2439,
  [4550] = 4241,
  [4551] = 4507,
  [4552] = 4510,
  [4553] = 4553,
  [4554] = 4515,
  [4555] = 4555,
  [4556] = 4510,
  [4557] = 4534,
  [4558] = 4516,
  [4559] = 4511,
  [4560] = 4498,
  [4561] = 4524,
  [4562] = 4524,
  [4563] = 4141,
  [4564] = 4534,
  [4565] = 2831,
  [4566] = 4534,
  [4567] = 4500,
  [4568] = 4507,
  [4569] = 4516,
  [4570] = 4570,
  [4571] = 4534,
  [4572] = 4506,
  [4573] = 2832,
  [4574] = 4243,
  [4575] = 4509,
  [4576] = 4508,
  [4577] = 4501,
  [4578] = 4501,
  [4579] = 4579,
  [4580] = 4496,
  [4581] = 4501,
  [4582] = 4582,
  [4583] = 4582,
  [4584] = 4582,
  [4585] = 4582,
  [4586] = 4509,
  [4587] = 4506,
  [4588] = 4496,
  [4589] = 4582,
  [4590] = 4504,
  [4591] = 4591,
  [4592] = 4592,
  [4593] = 4534,
  [4594] = 2860,
  [4595] = 2845,
  [4596] = 4496,
  [4597] = 4504,
  [4598] = 4534,
  [4599] = 4599,
  [4600] = 4511,
  [4601] = 4582,
  [4602] = 4516,
  [4603] = 4603,
  [4604] = 4504,
  [4605] = 4534,
  [4606] = 4509,
  [4607] = 4508,
  [4608] = 4501,
  [4609] = 4508,
  [4610] = 4138,
  [4611] = 4509,
  [4612] = 4516,
  [4613] = 4507,
  [4614] = 4239,
  [4615] = 4506,
  [4616] = 4616,
  [4617] = 4534,
  [4618] = 2115,
  [4619] = 4500,
  [4620] = 4501,
  [4621] = 4591,
  [4622] = 4592,
  [4623] = 4495,
  [4624] = 4506,
  [4625] = 4524,
  [4626] = 4498,
  [4627] = 4599,
  [4628] = 1799,
  [4629] = 1855,
  [4630] = 4630,
  [4631] = 4513,
  [4632] = 4495,
  [4633] = 4633,
  [4634] = 4498,
  [4635] = 4635,
  [4636] = 4504,
  [4637] = 4516,
  [4638] = 4496,
  [4639] = 4508,
  [4640] = 4640,
  [4641] = 4509,
  [4642] = 4642,
  [4643] = 4643,
  [4644] = 4511,
  [4645] = 4524,
  [4646] = 4237,
  [4647] = 2280,
  [4648] = 2520,
  [4649] = 4241,
  [4650] = 1799,
  [4651] = 2544,
  [4652] = 2548,
  [4653] = 2565,
  [4654] = 2275,
  [4655] = 2458,
  [4656] = 4656,
  [4657] = 2472,
  [4658] = 2115,
  [4659] = 4659,
  [4660] = 2567,
  [4661] = 2560,
  [4662] = 1995,
  [4663] = 2527,
  [4664] = 2525,
  [4665] = 4665,
  [4666] = 4237,
  [4667] = 4138,
  [4668] = 2524,
  [4669] = 2517,
  [4670] = 4659,
  [4671] = 2516,
  [4672] = 2297,
  [4673] = 2552,
  [4674] = 2451,
  [4675] = 1971,
  [4676] = 2590,
  [4677] = 2505,
  [4678] = 4141,
  [4679] = 2502,
  [4680] = 4659,
  [4681] = 1741,
  [4682] = 1687,
  [4683] = 1688,
  [4684] = 1689,
  [4685] = 1686,
  [4686] = 1685,
  [4687] = 1684,
  [4688] = 1682,
  [4689] = 2482,
  [4690] = 2542,
  [4691] = 2543,
  [4692] = 2547,
  [4693] = 2519,
  [4694] = 2551,
  [4695] = 2554,
  [4696] = 2558,
  [4697] = 1901,
  [4698] = 2539,
  [4699] = 2570,
  [4700] = 2562,
  [4701] = 2521,
  [4702] = 4659,
  [4703] = 2574,
  [4704] = 2573,
  [4705] = 2577,
  [4706] = 2579,
  [4707] = 2580,
  [4708] = 1865,
  [4709] = 1869,
  [4710] = 2581,
  [4711] = 2583,
  [4712] = 2593,
  [4713] = 2301,
  [4714] = 1896,
  [4715] = 2540,
  [4716] = 2278,
  [4717] = 2274,
  [4718] = 4718,
  [4719] = 4659,
  [4720] = 4659,
  [4721] = 2559,
  [4722] = 2499,
  [4723] = 2272,
  [4724] = 4656,
  [4725] = 2270,
  [4726] = 2262,
  [4727] = 1855,
  [4728] = 1950,
  [4729] = 2269,
  [4730] = 4239,
  [4731] = 2396,
  [4732] = 4243,
  [4733] = 2434,
  [4734] = 4659,
  [4735] = 2008,
  [4736] = 4736,
  [4737] = 4239,
  [4738] = 4738,
  [4739] = 1995,
  [4740] = 4237,
  [4741] = 4519,
  [4742] = 1995,
  [4743] = 2088,
  [4744] = 4138,
  [4745] = 4736,
  [4746] = 4738,
  [4747] = 4736,
  [4748] = 4738,
  [4749] = 4738,
  [4750] = 4736,
  [4751] = 2396,
  [4752] = 2252,
  [4753] = 4141,
  [4754] = 4656,
  [4755] = 4656,
  [4756] = 2008,
  [4757] = 4738,
  [4758] = 1987,
  [4759] = 4738,
  [4760] = 4738,
  [4761] = 4243,
  [4762] = 4640,
  [4763] = 2434,
  [4764] = 4643,
  [4765] = 4736,
  [4766] = 4738,
  [4767] = 4738,
  [4768] = 2293,
  [4769] = 4736,
  [4770] = 4736,
  [4771] = 4241,
  [4772] = 2008,
  [4773] = 1957,
  [4774] = 4774,
  [4775] = 4736,
  [4776] = 4736,
  [4777] = 4239,
  [4778] = 2296,
  [4779] = 2268,
  [4780] = 4141,
  [4781] = 2308,
  [4782] = 2301,
  [4783] = 2266,
  [4784] = 2300,
  [4785] = 2302,
  [4786] = 4656,
  [4787] = 4656,
  [4788] = 4656,
  [4789] = 4656,
  [4790] = 2271,
  [4791] = 4656,
  [4792] = 4656,
  [4793] = 4237,
  [4794] = 4138,
  [4795] = 4656,
  [4796] = 2299,
  [4797] = 2304,
  [4798] = 4656,
  [4799] = 2396,
  [4800] = 2115,
  [4801] = 4138,
  [4802] = 1971,
  [4803] = 4243,
  [4804] = 4141,
  [4805] = 1829,
  [4806] = 2434,
  [4807] = 2283,
  [4808] = 4241,
  [4809] = 2281,
  [4810] = 2261,
  [4811] = 1956,
  [4812] = 4812,
  [4813] = 4813,
  [4814] = 1978,
  [4815] = 1980,
  [4816] = 1951,
  [4817] = 4813,
  [4818] = 1954,
  [4819] = 4813,
  [4820] = 4820,
  [4821] = 4821,
  [4822] = 4813,
  [4823] = 4823,
  [4824] = 1958,
  [4825] = 4823,
  [4826] = 1959,
  [4827] = 4813,
  [4828] = 4828,
  [4829] = 4813,
  [4830] = 2301,
  [4831] = 1960,
  [4832] = 4820,
  [4833] = 1962,
  [4834] = 1963,
  [4835] = 1965,
  [4836] = 1946,
  [4837] = 1943,
  [4838] = 4813,
  [4839] = 4820,
  [4840] = 4823,
  [4841] = 1968,
  [4842] = 4237,
  [4843] = 4823,
  [4844] = 1981,
  [4845] = 1940,
  [4846] = 1986,
  [4847] = 4823,
  [4848] = 4848,
  [4849] = 1984,
  [4850] = 4239,
  [4851] = 4241,
  [4852] = 1982,
  [4853] = 4813,
  [4854] = 4820,
  [4855] = 1979,
  [4856] = 4243,
  [4857] = 4828,
  [4858] = 4813,
  [4859] = 4821,
  [4860] = 4820,
  [4861] = 4813,
  [4862] = 1944,
  [4863] = 2088,
  [4864] = 4820,
  [4865] = 4865,
  [4866] = 4813,
  [4867] = 4813,
  [4868] = 4820,
  [4869] = 4869,
  [4870] = 1947,
  [4871] = 4813,
  [4872] = 4820,
  [4873] = 1973,
  [4874] = 4813,
  [4875] = 4813,
  [4876] = 1990,
  [4877] = 4820,
  [4878] = 1969,
  [4879] = 1942,
  [4880] = 4823,
  [4881] = 1949,
  [4882] = 4656,
  [4883] = 2252,
  [4884] = 4656,
  [4885] = 1953,
  [4886] = 4823,
  [4887] = 4823,
  [4888] = 1955,
  [4889] = 4823,
  [4890] = 1975,
  [4891] = 4656,
  [4892] = 4813,
  [4893] = 4813,
  [4894] = 1988,
  [4895] = 1948,
  [4896] = 1945,
  [4897] = 4813,
  [4898] = 4813,
  [4899] = 1941,
  [4900] = 1938,
  [4901] = 4656,
  [4902] = 1966,
  [4903] = 1939,
  [4904] = 2266,
  [4905] = 2308,
  [4906] = 4138,
  [4907] = 4907,
  [4908] = 1898,
  [4909] = 4909,
  [4910] = 2299,
  [4911] = 2434,
  [4912] = 4828,
  [4913] = 2396,
  [4914] = 2304,
  [4915] = 2283,
  [4916] = 4916,
  [4917] = 2434,
  [4918] = 2281,
  [4919] = 4243,
  [4920] = 4241,
  [4921] = 4241,
  [4922] = 4916,
  [4923] = 4239,
  [4924] = 4237,
  [4925] = 4821,
  [4926] = 2268,
  [4927] = 4821,
  [4928] = 2261,
  [4929] = 2271,
  [4930] = 4141,
  [4931] = 4656,
  [4932] = 4237,
  [4933] = 2296,
  [4934] = 4907,
  [4935] = 4656,
  [4936] = 2252,
  [4937] = 2302,
  [4938] = 2300,
  [4939] = 2088,
  [4940] = 2396,
  [4941] = 2301,
  [4942] = 4828,
  [4943] = 4909,
  [4944] = 1962,
  [4945] = 4821,
  [4946] = 4821,
  [4947] = 4828,
  [4948] = 4828,
  [4949] = 2262,
  [4950] = 1974,
  [4951] = 1874,
  [4952] = 2272,
  [4953] = 2270,
  [4954] = 4821,
  [4955] = 4243,
  [4956] = 2269,
  [4957] = 4828,
  [4958] = 4821,
  [4959] = 1827,
  [4960] = 4828,
  [4961] = 4241,
  [4962] = 2280,
  [4963] = 2630,
  [4964] = 2274,
  [4965] = 4965,
  [4966] = 4237,
  [4967] = 1979,
  [4968] = 1799,
  [4969] = 1829,
  [4970] = 2278,
  [4971] = 1948,
  [4972] = 1799,
  [4973] = 4821,
  [4974] = 4828,
  [4975] = 1938,
  [4976] = 4828,
  [4977] = 4828,
  [4978] = 4821,
  [4979] = 4243,
  [4980] = 4828,
  [4981] = 4981,
  [4982] = 4239,
  [4983] = 1951,
  [4984] = 4821,
  [4985] = 1958,
  [4986] = 4241,
  [4987] = 4237,
  [4988] = 4239,
  [4989] = 4821,
  [4990] = 1943,
  [4991] = 2304,
  [4992] = 1960,
  [4993] = 1959,
  [4994] = 4994,
  [4995] = 1956,
  [4996] = 1954,
  [4997] = 1950,
  [4998] = 4828,
  [4999] = 4656,
  [5000] = 4821,
  [5001] = 1946,
  [5002] = 3616,
  [5003] = 1940,
  [5004] = 1939,
  [5005] = 1966,
  [5006] = 2296,
  [5007] = 4828,
  [5008] = 1963,
  [5009] = 1965,
  [5010] = 1941,
  [5011] = 1945,
  [5012] = 1968,
  [5013] = 4656,
  [5014] = 1969,
  [5015] = 2299,
  [5016] = 1988,
  [5017] = 1975,
  [5018] = 1955,
  [5019] = 1953,
  [5020] = 1949,
  [5021] = 1942,
  [5022] = 4656,
  [5023] = 4821,
  [5024] = 4656,
  [5025] = 4821,
  [5026] = 1982,
  [5027] = 1990,
  [5028] = 1973,
  [5029] = 5029,
  [5030] = 5030,
  [5031] = 5030,
  [5032] = 5032,
  [5033] = 1984,
  [5034] = 5030,
  [5035] = 2283,
  [5036] = 2281,
  [5037] = 1986,
  [5038] = 1981,
  [5039] = 5030,
  [5040] = 4821,
  [5041] = 2434,
  [5042] = 2268,
  [5043] = 2266,
  [5044] = 1980,
  [5045] = 1978,
  [5046] = 5030,
  [5047] = 4828,
  [5048] = 1944,
  [5049] = 2396,
  [5050] = 2261,
  [5051] = 1947,
  [5052] = 2271,
  [5053] = 2302,
  [5054] = 4828,
  [5055] = 2308,
  [5056] = 2300,
  [5057] = 2233,
  [5058] = 5058,
  [5059] = 5059,
  [5060] = 5060,
  [5061] = 5061,
  [5062] = 5062,
  [5063] = 5063,
  [5064] = 5062,
  [5065] = 5065,
  [5066] = 5058,
  [5067] = 4828,
  [5068] = 5068,
  [5069] = 5069,
  [5070] = 5060,
  [5071] = 5061,
  [5072] = 5059,
  [5073] = 5058,
  [5074] = 4821,
  [5075] = 5065,
  [5076] = 5059,
  [5077] = 5077,
  [5078] = 4243,
  [5079] = 5063,
  [5080] = 5062,
  [5081] = 5063,
  [5082] = 5059,
  [5083] = 5058,
  [5084] = 5065,
  [5085] = 4237,
  [5086] = 4241,
  [5087] = 5087,
  [5088] = 4239,
  [5089] = 2630,
  [5090] = 5062,
  [5091] = 5068,
  [5092] = 5063,
  [5093] = 5069,
  [5094] = 5060,
  [5095] = 5061,
  [5096] = 5062,
  [5097] = 5077,
  [5098] = 5065,
  [5099] = 5058,
  [5100] = 5059,
  [5101] = 5065,
  [5102] = 5068,
  [5103] = 4828,
  [5104] = 5061,
  [5105] = 5060,
  [5106] = 5058,
  [5107] = 5063,
  [5108] = 4821,
  [5109] = 5065,
  [5110] = 5058,
  [5111] = 5059,
  [5112] = 5069,
  [5113] = 5065,
  [5114] = 5058,
  [5115] = 5068,
  [5116] = 5059,
  [5117] = 5069,
  [5118] = 5060,
  [5119] = 5061,
  [5120] = 5059,
  [5121] = 5065,
  [5122] = 5062,
  [5123] = 5087,
  [5124] = 5058,
  [5125] = 5059,
  [5126] = 5063,
  [5127] = 5065,
  [5128] = 5077,
  [5129] = 5058,
  [5130] = 5130,
  [5131] = 5059,
  [5132] = 5065,
  [5133] = 5058,
  [5134] = 5059,
  [5135] = 5065,
  [5136] = 5068,
  [5137] = 5058,
  [5138] = 5068,
  [5139] = 5059,
  [5140] = 5059,
  [5141] = 5058,
  [5142] = 5065,
  [5143] = 5065,
  [5144] = 5059,
  [5145] = 5065,
  [5146] = 5058,
  [5147] = 5059,
  [5148] = 5077,
  [5149] = 5065,
  [5150] = 2293,
  [5151] = 5063,
  [5152] = 5058,
  [5153] = 5087,
  [5154] = 5059,
  [5155] = 5058,
  [5156] = 5065,
  [5157] = 5157,
  [5158] = 5059,
  [5159] = 5159,
  [5160] = 5062,
  [5161] = 5061,
  [5162] = 5069,
  [5163] = 5059,
  [5164] = 5058,
  [5165] = 5065,
  [5166] = 5087,
  [5167] = 5058,
  [5168] = 5065,
  [5169] = 5069,
  [5170] = 5061,
  [5171] = 5069,
  [5172] = 5060,
  [5173] = 5060,
  [5174] = 5174,
  [5175] = 5175,
  [5176] = 5175,
  [5177] = 5174,
  [5178] = 5175,
  [5179] = 5175,
  [5180] = 5175,
  [5181] = 5175,
  [5182] = 5175,
  [5183] = 5175,
  [5184] = 5175,
  [5185] = 5175,
  [5186] = 5175,
  [5187] = 5187,
  [5188] = 5175,
  [5189] = 5189,
  [5190] = 5175,
  [5191] = 5175,
  [5192] = 2328,
  [5193] = 5193,
  [5194] = 5175,
  [5195] = 5195,
  [5196] = 5175,
  [5197] = 5175,
  [5198] = 5189,
  [5199] = 5175,
  [5200] = 5187,
  [5201] = 3909,
  [5202] = 4821,
  [5203] = 5189,
  [5204] = 4828,
  [5205] = 4828,
  [5206] = 4828,
  [5207] = 4821,
  [5208] = 5174,
  [5209] = 3930,
  [5210] = 5187,
  [5211] = 4821,
  [5212] = 5189,
  [5213] = 4828,
  [5214] = 4821,
  [5215] = 5174,
  [5216] = 5187,
  [5217] = 5187,
  [5218] = 5189,
  [5219] = 5174,
  [5220] = 5174,
  [5221] = 5189,
  [5222] = 5187,
  [5223] = 5189,
  [5224] = 5189,
  [5225] = 5174,
  [5226] = 5187,
  [5227] = 5187,
  [5228] = 3230,
  [5229] = 5174,
  [5230] = 5189,
  [5231] = 5189,
  [5232] = 5174,
  [5233] = 5187,
  [5234] = 5174,
  [5235] = 5174,
  [5236] = 5187,
  [5237] = 5189,
  [5238] = 5187,
  [5239] = 5174,
  [5240] = 5189,
  [5241] = 5187,
  [5242] = 5174,
  [5243] = 5189,
  [5244] = 5187,
  [5245] = 5174,
  [5246] = 5187,
  [5247] = 5189,
  [5248] = 5189,
  [5249] = 5249,
  [5250] = 5174,
  [5251] = 5249,
  [5252] = 5249,
  [5253] = 3207,
  [5254] = 5174,
  [5255] = 5187,
  [5256] = 5249,
  [5257] = 5187,
  [5258] = 5189,
  [5259] = 5249,
  [5260] = 5249,
  [5261] = 5249,
  [5262] = 5262,
  [5263] = 1799,
  [5264] = 5189,
  [5265] = 5262,
  [5266] = 5187,
  [5267] = 5174,
  [5268] = 5262,
  [5269] = 5189,
  [5270] = 5270,
  [5271] = 5187,
  [5272] = 5174,
  [5273] = 5273,
  [5274] = 5274,
  [5275] = 5275,
  [5276] = 5274,
  [5277] = 5275,
  [5278] = 5274,
  [5279] = 5262,
  [5280] = 5274,
  [5281] = 5275,
  [5282] = 5275,
  [5283] = 5273,
  [5284] = 5275,
  [5285] = 5274,
  [5286] = 5274,
  [5287] = 5273,
  [5288] = 5275,
  [5289] = 5275,
  [5290] = 5274,
  [5291] = 5291,
  [5292] = 5274,
  [5293] = 5275,
  [5294] = 5274,
  [5295] = 5291,
  [5296] = 5275,
  [5297] = 5291,
  [5298] = 5298,
  [5299] = 5299,
  [5300] = 5300,
  [5301] = 5301,
  [5302] = 5302,
  [5303] = 5303,
  [5304] = 5304,
  [5305] = 5305,
  [5306] = 5306,
  [5307] = 5304,
  [5308] = 5305,
  [5309] = 5309,
  [5310] = 5310,
  [5311] = 5304,
  [5312] = 5300,
  [5313] = 5313,
  [5314] = 5314,
  [5315] = 5300,
  [5316] = 5306,
  [5317] = 5305,
  [5318] = 5306,
  [5319] = 5305,
  [5320] = 5320,
  [5321] = 5189,
  [5322] = 5301,
  [5323] = 5323,
  [5324] = 5324,
  [5325] = 5262,
  [5326] = 5304,
  [5327] = 5327,
  [5328] = 5187,
  [5329] = 5306,
  [5330] = 5305,
  [5331] = 5306,
  [5332] = 5306,
  [5333] = 5305,
  [5334] = 5324,
  [5335] = 5304,
  [5336] = 5305,
  [5337] = 5320,
  [5338] = 5338,
  [5339] = 5339,
  [5340] = 5327,
  [5341] = 5314,
  [5342] = 5327,
  [5343] = 1971,
  [5344] = 5301,
  [5345] = 5174,
  [5346] = 5305,
  [5347] = 5305,
  [5348] = 5300,
  [5349] = 5306,
  [5350] = 5306,
  [5351] = 5300,
  [5352] = 5305,
  [5353] = 5306,
  [5354] = 5320,
  [5355] = 5306,
  [5356] = 5189,
  [5357] = 5187,
  [5358] = 5174,
  [5359] = 5306,
  [5360] = 5305,
  [5361] = 5306,
  [5362] = 5304,
  [5363] = 5306,
  [5364] = 5305,
  [5365] = 5304,
  [5366] = 5305,
  [5367] = 5367,
  [5368] = 5368,
  [5369] = 5369,
  [5370] = 5300,
  [5371] = 5320,
  [5372] = 5306,
  [5373] = 5373,
  [5374] = 5374,
  [5375] = 5305,
  [5376] = 5376,
  [5377] = 5304,
  [5378] = 5306,
  [5379] = 5314,
  [5380] = 5174,
  [5381] = 5381,
  [5382] = 5382,
  [5383] = 5383,
  [5384] = 5299,
  [5385] = 5300,
  [5386] = 5189,
  [5387] = 5187,
  [5388] = 5388,
  [5389] = 5323,
  [5390] = 5174,
  [5391] = 5391,
  [5392] = 5388,
  [5393] = 5187,
  [5394] = 5305,
  [5395] = 5395,
  [5396] = 5368,
  [5397] = 5305,
  [5398] = 5189,
  [5399] = 5306,
  [5400] = 5373,
  [5401] = 5374,
  [5402] = 5376,
  [5403] = 5381,
  [5404] = 5382,
  [5405] = 5405,
  [5406] = 5383,
  [5407] = 5298,
  [5408] = 5262,
  [5409] = 5327,
  [5410] = 5304,
  [5411] = 5411,
  [5412] = 5412,
  [5413] = 5411,
  [5414] = 5414,
  [5415] = 5415,
  [5416] = 5415,
  [5417] = 5417,
  [5418] = 5417,
  [5419] = 5414,
  [5420] = 5414,
  [5421] = 5412,
  [5422] = 5411,
  [5423] = 5412,
  [5424] = 5411,
  [5425] = 5414,
  [5426] = 5411,
  [5427] = 5417,
  [5428] = 5415,
  [5429] = 5417,
  [5430] = 5430,
  [5431] = 5412,
  [5432] = 5412,
  [5433] = 5411,
  [5434] = 5417,
  [5435] = 5414,
  [5436] = 5415,
  [5437] = 5414,
  [5438] = 5415,
  [5439] = 5415,
  [5440] = 5417,
  [5441] = 5414,
  [5442] = 5262,
  [5443] = 5417,
  [5444] = 5415,
  [5445] = 5412,
  [5446] = 5414,
  [5447] = 5447,
  [5448] = 5414,
  [5449] = 5414,
  [5450] = 5417,
  [5451] = 5412,
  [5452] = 5411,
  [5453] = 5415,
  [5454] = 5417,
  [5455] = 5415,
  [5456] = 5415,
  [5457] = 5415,
  [5458] = 5411,
  [5459] = 5417,
  [5460] = 5417,
  [5461] = 5447,
  [5462] = 5414,
  [5463] = 5417,
  [5464] = 5414,
  [5465] = 5412,
  [5466] = 5466,
  [5467] = 5417,
  [5468] = 5412,
  [5469] = 5417,
  [5470] = 5414,
  [5471] = 5414,
  [5472] = 5414,
  [5473] = 5412,
  [5474] = 5415,
  [5475] = 5411,
  [5476] = 5411,
  [5477] = 5417,
  [5478] = 5414,
  [5479] = 5447,
  [5480] = 5412,
  [5481] = 5415,
  [5482] = 5417,
  [5483] = 5415,
  [5484] = 5417,
  [5485] = 5411,
  [5486] = 5412,
  [5487] = 5411,
  [5488] = 5412,
  [5489] = 5411,
  [5490] = 5412,
  [5491] = 5405,
  [5492] = 5412,
  [5493] = 5415,
  [5494] = 5412,
  [5495] = 5415,
  [5496] = 5417,
  [5497] = 5414,
  [5498] = 5411,
  [5499] = 5412,
  [5500] = 5412,
  [5501] = 5411,
  [5502] = 5411,
  [5503] = 5415,
  [5504] = 5411,
  [5505] = 5415,
  [5506] = 5411,
  [5507] = 5414,
  [5508] = 5508,
  [5509] = 5509,
  [5510] = 2860,
  [5511] = 5511,
  [5512] = 5512,
  [5513] = 5512,
  [5514] = 5514,
  [5515] = 5515,
  [5516] = 5512,
  [5517] = 5508,
  [5518] = 5518,
  [5519] = 5512,
  [5520] = 5512,
  [5521] = 5508,
  [5522] = 5512,
  [5523] = 5512,
  [5524] = 5524,
  [5525] = 5525,
  [5526] = 5508,
  [5527] = 5527,
  [5528] = 5391,
  [5529] = 5508,
  [5530] = 5530,
  [5531] = 5531,
  [5532] = 5262,
  [5533] = 5395,
  [5534] = 5534,
  [5535] = 5512,
  [5536] = 5531,
  [5537] = 5537,
  [5538] = 5512,
  [5539] = 5512,
  [5540] = 5540,
  [5541] = 5512,
  [5542] = 5542,
  [5543] = 5531,
  [5544] = 5544,
  [5545] = 5508,
  [5546] = 5546,
  [5547] = 5547,
  [5548] = 5508,
  [5549] = 5549,
  [5550] = 5550,
  [5551] = 5551,
  [5552] = 5512,
  [5553] = 2845,
  [5554] = 5512,
  [5555] = 5555,
  [5556] = 5555,
  [5557] = 5557,
  [5558] = 5558,
  [5559] = 5559,
  [5560] = 5557,
  [5561] = 1748,
  [5562] = 1744,
  [5563] = 5563,
  [5564] = 5564,
  [5565] = 1754,
  [5566] = 1756,
  [5567] = 5567,
  [5568] = 5555,
  [5569] = 1745,
  [5570] = 5570,
  [5571] = 5571,
  [5572] = 5572,
  [5573] = 5573,
  [5574] = 5574,
  [5575] = 5575,
  [5576] = 5555,
  [5577] = 5577,
  [5578] = 5564,
  [5579] = 5558,
  [5580] = 5580,
  [5581] = 1752,
  [5582] = 5582,
  [5583] = 5572,
  [5584] = 5555,
  [5585] = 5585,
  [5586] = 5577,
  [5587] = 1747,
  [5588] = 5580,
  [5589] = 5570,
  [5590] = 5574,
  [5591] = 5577,
  [5592] = 5555,
  [5593] = 5582,
  [5594] = 5577,
  [5595] = 5567,
  [5596] = 5596,
  [5597] = 5555,
  [5598] = 5580,
  [5599] = 5599,
  [5600] = 5558,
  [5601] = 1749,
  [5602] = 5582,
  [5603] = 5585,
  [5604] = 5604,
  [5605] = 5540,
  [5606] = 5570,
  [5607] = 2845,
  [5608] = 5572,
  [5609] = 5547,
  [5610] = 5585,
  [5611] = 5611,
  [5612] = 5585,
  [5613] = 5527,
  [5614] = 5614,
  [5615] = 1746,
  [5616] = 5616,
  [5617] = 5555,
  [5618] = 2297,
  [5619] = 5567,
  [5620] = 5567,
  [5621] = 5570,
  [5622] = 5622,
  [5623] = 5616,
  [5624] = 1753,
  [5625] = 5580,
  [5626] = 5616,
  [5627] = 5546,
  [5628] = 5555,
  [5629] = 5574,
  [5630] = 5630,
  [5631] = 5542,
  [5632] = 5580,
  [5633] = 5555,
  [5634] = 5580,
  [5635] = 5577,
  [5636] = 5262,
  [5637] = 5555,
  [5638] = 2275,
  [5639] = 127,
  [5640] = 5570,
  [5641] = 5555,
  [5642] = 5555,
  [5643] = 5572,
  [5644] = 5644,
  [5645] = 5544,
  [5646] = 128,
  [5647] = 5557,
  [5648] = 5648,
  [5649] = 5555,
  [5650] = 1759,
  [5651] = 1755,
  [5652] = 5564,
  [5653] = 5551,
  [5654] = 5564,
  [5655] = 5555,
  [5656] = 5550,
  [5657] = 5567,
  [5658] = 5658,
  [5659] = 5659,
  [5660] = 5660,
  [5661] = 5661,
  [5662] = 1751,
  [5663] = 5567,
  [5664] = 5664,
  [5665] = 5570,
  [5666] = 5555,
  [5667] = 5661,
  [5668] = 5549,
  [5669] = 5558,
  [5670] = 5616,
  [5671] = 5585,
  [5672] = 5524,
  [5673] = 2297,
  [5674] = 5534,
  [5675] = 5514,
  [5676] = 5574,
  [5677] = 5530,
  [5678] = 1757,
  [5679] = 5679,
  [5680] = 5518,
  [5681] = 1758,
  [5682] = 5682,
  [5683] = 5683,
  [5684] = 5684,
  [5685] = 5557,
  [5686] = 5525,
  [5687] = 5509,
  [5688] = 2275,
  [5689] = 5515,
  [5690] = 5511,
  [5691] = 5555,
  [5692] = 5555,
  [5693] = 2860,
  [5694] = 5577,
  [5695] = 5585,
  [5696] = 5580,
  [5697] = 5580,
  [5698] = 5570,
  [5699] = 5611,
  [5700] = 5577,
  [5701] = 5567,
  [5702] = 5679,
  [5703] = 5577,
  [5704] = 5570,
  [5705] = 2328,
  [5706] = 5567,
  [5707] = 5262,
  [5708] = 5708,
  [5709] = 5571,
  [5710] = 5710,
  [5711] = 5711,
  [5712] = 5712,
  [5713] = 5570,
  [5714] = 5262,
  [5715] = 5712,
  [5716] = 5716,
  [5717] = 5567,
  [5718] = 5567,
  [5719] = 5719,
  [5720] = 5570,
  [5721] = 5580,
  [5722] = 5722,
  [5723] = 5723,
  [5724] = 5577,
  [5725] = 5723,
  [5726] = 5726,
  [5727] = 5727,
  [5728] = 5567,
  [5729] = 5729,
  [5730] = 5712,
  [5731] = 5731,
  [5732] = 5580,
  [5733] = 5733,
  [5734] = 5570,
  [5735] = 1995,
  [5736] = 5723,
  [5737] = 5712,
  [5738] = 5580,
  [5739] = 5577,
  [5740] = 5740,
  [5741] = 5723,
  [5742] = 5712,
  [5743] = 5710,
  [5744] = 5744,
  [5745] = 5567,
  [5746] = 5746,
  [5747] = 5747,
  [5748] = 5723,
  [5749] = 2008,
  [5750] = 5710,
  [5751] = 5751,
  [5752] = 5712,
  [5753] = 5577,
  [5754] = 5723,
  [5755] = 5723,
  [5756] = 5756,
  [5757] = 5712,
  [5758] = 5758,
  [5759] = 5759,
  [5760] = 5760,
  [5761] = 5723,
  [5762] = 5712,
  [5763] = 5710,
  [5764] = 5262,
  [5765] = 5756,
  [5766] = 5712,
  [5767] = 5580,
  [5768] = 5723,
  [5769] = 5712,
  [5770] = 1772,
  [5771] = 5771,
  [5772] = 5772,
  [5773] = 5710,
  [5774] = 5723,
  [5775] = 5775,
  [5776] = 1771,
  [5777] = 5570,
  [5778] = 5778,
  [5779] = 5577,
  [5780] = 5780,
  [5781] = 5781,
  [5782] = 1770,
  [5783] = 5783,
  [5784] = 5784,
  [5785] = 5558,
  [5786] = 1757,
  [5787] = 5658,
  [5788] = 1758,
  [5789] = 5262,
  [5790] = 128,
  [5791] = 1746,
  [5792] = 5572,
  [5793] = 5567,
  [5794] = 5564,
  [5795] = 127,
  [5796] = 5796,
  [5797] = 1747,
  [5798] = 1756,
  [5799] = 5570,
  [5800] = 5659,
  [5801] = 5262,
  [5802] = 5577,
  [5803] = 926,
  [5804] = 925,
  [5805] = 5567,
  [5806] = 5570,
  [5807] = 2447,
  [5808] = 5580,
  [5809] = 1751,
  [5810] = 5810,
  [5811] = 5557,
  [5812] = 5574,
  [5813] = 5813,
  [5814] = 2297,
  [5815] = 1759,
  [5816] = 5580,
  [5817] = 5557,
  [5818] = 1748,
  [5819] = 1752,
  [5820] = 5558,
  [5821] = 5821,
  [5822] = 5564,
  [5823] = 5572,
  [5824] = 1749,
  [5825] = 1744,
  [5826] = 1754,
  [5827] = 5577,
  [5828] = 1745,
  [5829] = 2275,
  [5830] = 1755,
  [5831] = 1753,
  [5832] = 5574,
  [5833] = 5833,
  [5834] = 5834,
  [5835] = 2277,
  [5836] = 2553,
  [5837] = 2267,
  [5838] = 5838,
  [5839] = 2311,
  [5840] = 5838,
  [5841] = 5841,
  [5842] = 5841,
  [5843] = 5567,
  [5844] = 2295,
  [5845] = 5838,
  [5846] = 5846,
  [5847] = 2289,
  [5848] = 5841,
  [5849] = 5849,
  [5850] = 5841,
  [5851] = 5841,
  [5852] = 5570,
  [5853] = 5846,
  [5854] = 5849,
  [5855] = 5846,
  [5856] = 5856,
  [5857] = 5841,
  [5858] = 5849,
  [5859] = 5859,
  [5860] = 5860,
  [5861] = 5861,
  [5862] = 5862,
  [5863] = 5863,
  [5864] = 5580,
  [5865] = 5865,
  [5866] = 5866,
  [5867] = 5867,
  [5868] = 5868,
  [5869] = 2452,
  [5870] = 5846,
  [5871] = 5849,
  [5872] = 5849,
  [5873] = 5567,
  [5874] = 5874,
  [5875] = 5846,
  [5876] = 5570,
  [5877] = 5841,
  [5878] = 5841,
  [5879] = 5846,
  [5880] = 5577,
  [5881] = 2549,
  [5882] = 5849,
  [5883] = 5883,
  [5884] = 5849,
  [5885] = 5580,
  [5886] = 2328,
  [5887] = 5841,
  [5888] = 5846,
  [5889] = 5577,
  [5890] = 5863,
  [5891] = 5891,
  [5892] = 5866,
  [5893] = 5862,
  [5894] = 5867,
  [5895] = 5841,
  [5896] = 5868,
  [5897] = 5861,
  [5898] = 5860,
  [5899] = 5860,
  [5900] = 5838,
  [5901] = 5901,
  [5902] = 5868,
  [5903] = 5867,
  [5904] = 5861,
  [5905] = 5866,
  [5906] = 5865,
  [5907] = 5862,
  [5908] = 5863,
  [5909] = 5865,
  [5910] = 5775,
  [5911] = 5778,
  [5912] = 5574,
  [5913] = 5913,
  [5914] = 5574,
  [5915] = 5783,
  [5916] = 5780,
  [5917] = 1690,
  [5918] = 5572,
  [5919] = 5557,
  [5920] = 5558,
  [5921] = 5564,
  [5922] = 5572,
  [5923] = 5558,
  [5924] = 5557,
  [5925] = 5925,
  [5926] = 5926,
  [5927] = 5927,
  [5928] = 5781,
  [5929] = 5759,
  [5930] = 5930,
  [5931] = 5746,
  [5932] = 5744,
  [5933] = 5577,
  [5934] = 5580,
  [5935] = 5868,
  [5936] = 5570,
  [5937] = 5567,
  [5938] = 5867,
  [5939] = 5866,
  [5940] = 5733,
  [5941] = 5941,
  [5942] = 5930,
  [5943] = 5577,
  [5944] = 2297,
  [5945] = 5580,
  [5946] = 5570,
  [5947] = 5567,
  [5948] = 5731,
  [5949] = 5865,
  [5950] = 5863,
  [5951] = 5930,
  [5952] = 5926,
  [5953] = 5862,
  [5954] = 5926,
  [5955] = 5861,
  [5956] = 5557,
  [5957] = 5941,
  [5958] = 5574,
  [5959] = 5959,
  [5960] = 5716,
  [5961] = 5930,
  [5962] = 5959,
  [5963] = 5926,
  [5964] = 5564,
  [5965] = 5860,
  [5966] = 5959,
  [5967] = 5967,
  [5968] = 5968,
  [5969] = 2275,
  [5970] = 1794,
  [5971] = 5926,
  [5972] = 1803,
  [5973] = 5784,
  [5974] = 5930,
  [5975] = 5558,
  [5976] = 5941,
  [5977] = 5574,
  [5978] = 5978,
  [5979] = 5564,
  [5980] = 5980,
  [5981] = 5926,
  [5982] = 5926,
  [5983] = 5557,
  [5984] = 5926,
  [5985] = 5926,
  [5986] = 5558,
  [5987] = 5564,
  [5988] = 5572,
  [5989] = 5719,
  [5990] = 5726,
  [5991] = 5727,
  [5992] = 5926,
  [5993] = 2275,
  [5994] = 5926,
  [5995] = 2297,
  [5996] = 5926,
  [5997] = 5930,
  [5998] = 5760,
  [5999] = 5740,
  [6000] = 5926,
  [6001] = 5572,
  [6002] = 6002,
  [6003] = 5747,
  [6004] = 5926,
  [6005] = 5771,
  [6006] = 6006,
  [6007] = 5959,
  [6008] = 5926,
  [6009] = 6009,
  [6010] = 5959,
  [6011] = 5926,
  [6012] = 6012,
  [6013] = 5925,
  [6014] = 5959,
  [6015] = 5941,
  [6016] = 5926,
  [6017] = 6017,
  [6018] = 5941,
  [6019] = 5262,
  [6020] = 5941,
  [6021] = 2374,
  [6022] = 5927,
  [6023] = 5941,
  [6024] = 5926,
  [6025] = 5926,
  [6026] = 1792,
  [6027] = 5967,
  [6028] = 5930,
  [6029] = 6029,
  [6030] = 5959,
  [6031] = 5711,
  [6032] = 6032,
  [6033] = 1804,
  [6034] = 6034,
  [6035] = 5772,
  [6036] = 6032,
  [6037] = 5968,
  [6038] = 2295,
  [6039] = 6039,
  [6040] = 6040,
  [6041] = 5868,
  [6042] = 6042,
  [6043] = 6043,
  [6044] = 2277,
  [6045] = 6042,
  [6046] = 2491,
  [6047] = 2311,
  [6048] = 6048,
  [6049] = 6049,
  [6050] = 2492,
  [6051] = 6051,
  [6052] = 2289,
  [6053] = 2494,
  [6054] = 2356,
  [6055] = 6055,
  [6056] = 5867,
  [6057] = 6040,
  [6058] = 6058,
  [6059] = 6059,
  [6060] = 5863,
  [6061] = 6058,
  [6062] = 5577,
  [6063] = 5860,
  [6064] = 5580,
  [6065] = 2496,
  [6066] = 6066,
  [6067] = 6043,
  [6068] = 2359,
  [6069] = 5570,
  [6070] = 2361,
  [6071] = 5567,
  [6072] = 5865,
  [6073] = 2366,
  [6074] = 6043,
  [6075] = 6055,
  [6076] = 6066,
  [6077] = 5577,
  [6078] = 6078,
  [6079] = 5580,
  [6080] = 6042,
  [6081] = 5570,
  [6082] = 5567,
  [6083] = 6040,
  [6084] = 6043,
  [6085] = 6085,
  [6086] = 2267,
  [6087] = 6055,
  [6088] = 6066,
  [6089] = 6055,
  [6090] = 5861,
  [6091] = 6055,
  [6092] = 5862,
  [6093] = 6042,
  [6094] = 6094,
  [6095] = 5866,
  [6096] = 6058,
  [6097] = 6043,
  [6098] = 6098,
  [6099] = 6099,
  [6100] = 5868,
  [6101] = 6055,
  [6102] = 5867,
  [6103] = 2349,
  [6104] = 6042,
  [6105] = 2325,
  [6106] = 6042,
  [6107] = 2490,
  [6108] = 5866,
  [6109] = 2367,
  [6110] = 2368,
  [6111] = 2340,
  [6112] = 6043,
  [6113] = 5865,
  [6114] = 6055,
  [6115] = 5863,
  [6116] = 2372,
  [6117] = 5862,
  [6118] = 2582,
  [6119] = 5861,
  [6120] = 2488,
  [6121] = 6042,
  [6122] = 6122,
  [6123] = 6123,
  [6124] = 6055,
  [6125] = 6125,
  [6126] = 6042,
  [6127] = 2342,
  [6128] = 6128,
  [6129] = 6058,
  [6130] = 6042,
  [6131] = 6040,
  [6132] = 6043,
  [6133] = 6040,
  [6134] = 2493,
  [6135] = 6055,
  [6136] = 5860,
  [6137] = 6055,
  [6138] = 6066,
  [6139] = 6122,
  [6140] = 6042,
  [6141] = 5967,
  [6142] = 6142,
  [6143] = 6143,
  [6144] = 5557,
  [6145] = 6142,
  [6146] = 2277,
  [6147] = 5558,
  [6148] = 2275,
  [6149] = 6032,
  [6150] = 5968,
  [6151] = 6151,
  [6152] = 6142,
  [6153] = 6142,
  [6154] = 6142,
  [6155] = 6029,
  [6156] = 6142,
  [6157] = 5564,
  [6158] = 6142,
  [6159] = 2267,
  [6160] = 2289,
  [6161] = 6142,
  [6162] = 5567,
  [6163] = 6163,
  [6164] = 6142,
  [6165] = 5574,
  [6166] = 2311,
  [6167] = 5925,
  [6168] = 6142,
  [6169] = 5572,
  [6170] = 2374,
  [6171] = 5572,
  [6172] = 5570,
  [6173] = 3735,
  [6174] = 5567,
  [6175] = 5564,
  [6176] = 5868,
  [6177] = 5580,
  [6178] = 5558,
  [6179] = 6179,
  [6180] = 5867,
  [6181] = 6181,
  [6182] = 6142,
  [6183] = 6142,
  [6184] = 5866,
  [6185] = 6142,
  [6186] = 5865,
  [6187] = 6142,
  [6188] = 6142,
  [6189] = 6189,
  [6190] = 6190,
  [6191] = 5577,
  [6192] = 5570,
  [6193] = 5863,
  [6194] = 5862,
  [6195] = 5861,
  [6196] = 2297,
  [6197] = 5860,
  [6198] = 5557,
  [6199] = 5927,
  [6200] = 6142,
  [6201] = 6201,
  [6202] = 6142,
  [6203] = 5580,
  [6204] = 6142,
  [6205] = 5574,
  [6206] = 6142,
  [6207] = 2295,
  [6208] = 5577,
  [6209] = 6209,
  [6210] = 6210,
  [6211] = 5557,
  [6212] = 5861,
  [6213] = 6213,
  [6214] = 6214,
  [6215] = 6215,
  [6216] = 6216,
  [6217] = 6209,
  [6218] = 6218,
  [6219] = 6219,
  [6220] = 6032,
  [6221] = 5967,
  [6222] = 6222,
  [6223] = 5868,
  [6224] = 6209,
  [6225] = 5558,
  [6226] = 6215,
  [6227] = 6227,
  [6228] = 6218,
  [6229] = 5564,
  [6230] = 5572,
  [6231] = 6231,
  [6232] = 5867,
  [6233] = 5572,
  [6234] = 6218,
  [6235] = 6215,
  [6236] = 5564,
  [6237] = 5558,
  [6238] = 6238,
  [6239] = 6239,
  [6240] = 5862,
  [6241] = 6241,
  [6242] = 5865,
  [6243] = 2374,
  [6244] = 6215,
  [6245] = 5557,
  [6246] = 6246,
  [6247] = 6209,
  [6248] = 5574,
  [6249] = 5574,
  [6250] = 6250,
  [6251] = 6251,
  [6252] = 5863,
  [6253] = 6253,
  [6254] = 5927,
  [6255] = 6255,
  [6256] = 6218,
  [6257] = 2471,
  [6258] = 6209,
  [6259] = 2275,
  [6260] = 6215,
  [6261] = 5868,
  [6262] = 6251,
  [6263] = 6251,
  [6264] = 6264,
  [6265] = 6265,
  [6266] = 6209,
  [6267] = 6251,
  [6268] = 6268,
  [6269] = 6251,
  [6270] = 6270,
  [6271] = 6271,
  [6272] = 6272,
  [6273] = 6273,
  [6274] = 6274,
  [6275] = 6275,
  [6276] = 6215,
  [6277] = 5860,
  [6278] = 6215,
  [6279] = 5968,
  [6280] = 6218,
  [6281] = 5866,
  [6282] = 6209,
  [6283] = 5862,
  [6284] = 5925,
  [6285] = 5861,
  [6286] = 6218,
  [6287] = 5866,
  [6288] = 6251,
  [6289] = 6218,
  [6290] = 6251,
  [6291] = 2297,
  [6292] = 6292,
  [6293] = 6293,
  [6294] = 6293,
  [6295] = 6293,
  [6296] = 5860,
  [6297] = 5861,
  [6298] = 5862,
  [6299] = 1682,
  [6300] = 1685,
  [6301] = 6293,
  [6302] = 5863,
  [6303] = 6293,
  [6304] = 5865,
  [6305] = 6292,
  [6306] = 6306,
  [6307] = 6293,
  [6308] = 1687,
  [6309] = 5866,
  [6310] = 5867,
  [6311] = 5868,
  [6312] = 1688,
  [6313] = 6313,
  [6314] = 6314,
  [6315] = 6315,
  [6316] = 1689,
  [6317] = 6293,
  [6318] = 6318,
  [6319] = 6293,
  [6320] = 6293,
  [6321] = 6321,
  [6322] = 6293,
  [6323] = 1686,
  [6324] = 6293,
  [6325] = 6325,
  [6326] = 1684,
  [6327] = 6293,
  [6328] = 6293,
  [6329] = 6329,
  [6330] = 6330,
  [6331] = 6331,
  [6332] = 6332,
  [6333] = 6333,
  [6334] = 6334,
  [6335] = 6331,
  [6336] = 6333,
  [6337] = 6333,
  [6338] = 6338,
  [6339] = 6333,
  [6340] = 6338,
  [6341] = 2275,
  [6342] = 6333,
  [6343] = 6332,
  [6344] = 5821,
  [6345] = 5860,
  [6346] = 6333,
  [6347] = 5861,
  [6348] = 6333,
  [6349] = 6333,
  [6350] = 6332,
  [6351] = 5862,
  [6352] = 5863,
  [6353] = 6331,
  [6354] = 5865,
  [6355] = 6333,
  [6356] = 6333,
  [6357] = 6332,
  [6358] = 6333,
  [6359] = 2297,
  [6360] = 6338,
  [6361] = 6333,
  [6362] = 5796,
  [6363] = 6332,
  [6364] = 6334,
  [6365] = 6333,
  [6366] = 5866,
  [6367] = 6333,
  [6368] = 6333,
  [6369] = 6331,
  [6370] = 5867,
  [6371] = 6333,
  [6372] = 5868,
  [6373] = 6333,
  [6374] = 6338,
  [6375] = 6334,
  [6376] = 6333,
  [6377] = 6333,
  [6378] = 6378,
  [6379] = 6332,
  [6380] = 6333,
  [6381] = 6334,
  [6382] = 6382,
  [6383] = 6333,
  [6384] = 6332,
  [6385] = 5868,
  [6386] = 6386,
  [6387] = 5862,
  [6388] = 6388,
  [6389] = 6389,
  [6390] = 6390,
  [6391] = 6391,
  [6392] = 5861,
  [6393] = 6393,
  [6394] = 5863,
  [6395] = 5865,
  [6396] = 6396,
  [6397] = 6397,
  [6398] = 6398,
  [6399] = 2452,
  [6400] = 6397,
  [6401] = 6393,
  [6402] = 5796,
  [6403] = 5980,
  [6404] = 5978,
  [6405] = 6405,
  [6406] = 6397,
  [6407] = 6407,
  [6408] = 6393,
  [6409] = 5967,
  [6410] = 6006,
  [6411] = 5866,
  [6412] = 6412,
  [6413] = 5867,
  [6414] = 5968,
  [6415] = 6393,
  [6416] = 5927,
  [6417] = 5860,
  [6418] = 5925,
  [6419] = 6012,
  [6420] = 5821,
  [6421] = 5913,
  [6422] = 6386,
  [6423] = 6393,
  [6424] = 6393,
  [6425] = 6386,
  [6426] = 6426,
  [6427] = 6427,
  [6428] = 6393,
  [6429] = 6429,
  [6430] = 6386,
  [6431] = 6032,
  [6432] = 6397,
  [6433] = 6433,
  [6434] = 6434,
  [6435] = 5866,
  [6436] = 5865,
  [6437] = 5860,
  [6438] = 6438,
  [6439] = 5863,
  [6440] = 2402,
  [6441] = 2267,
  [6442] = 6434,
  [6443] = 5867,
  [6444] = 6444,
  [6445] = 6445,
  [6446] = 6444,
  [6447] = 2295,
  [6448] = 6448,
  [6449] = 5868,
  [6450] = 6444,
  [6451] = 6434,
  [6452] = 2400,
  [6453] = 6453,
  [6454] = 6445,
  [6455] = 6455,
  [6456] = 5860,
  [6457] = 2277,
  [6458] = 6445,
  [6459] = 6459,
  [6460] = 6460,
  [6461] = 6461,
  [6462] = 6462,
  [6463] = 6434,
  [6464] = 5863,
  [6465] = 5861,
  [6466] = 5862,
  [6467] = 2432,
  [6468] = 6468,
  [6469] = 6448,
  [6470] = 5866,
  [6471] = 6448,
  [6472] = 5868,
  [6473] = 6448,
  [6474] = 2289,
  [6475] = 2452,
  [6476] = 6476,
  [6477] = 6444,
  [6478] = 5865,
  [6479] = 5867,
  [6480] = 6445,
  [6481] = 5861,
  [6482] = 5862,
  [6483] = 6483,
  [6484] = 2311,
  [6485] = 6485,
  [6486] = 6486,
  [6487] = 2374,
  [6488] = 6488,
  [6489] = 6489,
  [6490] = 6490,
  [6491] = 6491,
  [6492] = 6492,
  [6493] = 6493,
  [6494] = 6494,
  [6495] = 6201,
  [6496] = 6496,
  [6497] = 2452,
  [6498] = 6493,
  [6499] = 6499,
  [6500] = 6486,
  [6501] = 6499,
  [6502] = 6502,
  [6503] = 6163,
  [6504] = 6504,
  [6505] = 6494,
  [6506] = 6493,
  [6507] = 6507,
  [6508] = 6493,
  [6509] = 6509,
  [6510] = 6494,
  [6511] = 6511,
  [6512] = 6494,
  [6513] = 6494,
  [6514] = 2452,
  [6515] = 6486,
  [6516] = 6499,
  [6517] = 6494,
  [6518] = 6518,
  [6519] = 6486,
  [6520] = 6520,
  [6521] = 6486,
  [6522] = 6518,
  [6523] = 6486,
  [6524] = 6499,
  [6525] = 6181,
  [6526] = 6499,
  [6527] = 6527,
  [6528] = 6493,
  [6529] = 6509,
  [6530] = 6530,
  [6531] = 6499,
  [6532] = 6493,
  [6533] = 6533,
  [6534] = 6486,
  [6535] = 6499,
  [6536] = 6494,
  [6537] = 6493,
  [6538] = 6538,
  [6539] = 6539,
  [6540] = 6540,
  [6541] = 6541,
  [6542] = 6542,
  [6543] = 6543,
  [6544] = 6544,
  [6545] = 6542,
  [6546] = 2452,
  [6547] = 6547,
  [6548] = 6548,
  [6549] = 5860,
  [6550] = 6541,
  [6551] = 6551,
  [6552] = 6551,
  [6553] = 6553,
  [6554] = 6554,
  [6555] = 6555,
  [6556] = 6551,
  [6557] = 6557,
  [6558] = 2418,
  [6559] = 6559,
  [6560] = 5861,
  [6561] = 5862,
  [6562] = 6540,
  [6563] = 5863,
  [6564] = 5865,
  [6565] = 6565,
  [6566] = 6548,
  [6567] = 6567,
  [6568] = 6551,
  [6569] = 6554,
  [6570] = 6567,
  [6571] = 6547,
  [6572] = 5866,
  [6573] = 5867,
  [6574] = 2452,
  [6575] = 5868,
  [6576] = 6551,
  [6577] = 6557,
  [6578] = 6578,
  [6579] = 6541,
  [6580] = 6580,
  [6581] = 6581,
  [6582] = 6544,
  [6583] = 6547,
  [6584] = 6584,
  [6585] = 6544,
  [6586] = 6557,
  [6587] = 6548,
  [6588] = 6539,
  [6589] = 6538,
  [6590] = 6540,
  [6591] = 6591,
  [6592] = 6559,
  [6593] = 6539,
  [6594] = 6544,
  [6595] = 6538,
  [6596] = 6567,
  [6597] = 6597,
  [6598] = 6597,
  [6599] = 6599,
  [6600] = 6600,
  [6601] = 6601,
  [6602] = 6602,
  [6603] = 6603,
  [6604] = 6604,
  [6605] = 6605,
  [6606] = 6606,
  [6607] = 6607,
  [6608] = 6608,
  [6609] = 6600,
  [6610] = 6601,
  [6611] = 6611,
  [6612] = 6612,
  [6613] = 6613,
  [6614] = 6614,
  [6615] = 6615,
  [6616] = 6616,
  [6617] = 6600,
  [6618] = 6618,
  [6619] = 6611,
  [6620] = 6620,
  [6621] = 6621,
  [6622] = 6622,
  [6623] = 6602,
  [6624] = 6624,
  [6625] = 6614,
  [6626] = 6613,
  [6627] = 6611,
  [6628] = 6628,
  [6629] = 6601,
  [6630] = 6622,
  [6631] = 6620,
  [6632] = 6632,
  [6633] = 6615,
  [6634] = 6634,
  [6635] = 6635,
  [6636] = 6635,
  [6637] = 6605,
  [6638] = 6599,
  [6639] = 6612,
  [6640] = 6615,
  [6641] = 6641,
  [6642] = 6612,
  [6643] = 6611,
  [6644] = 6615,
  [6645] = 6634,
  [6646] = 6614,
  [6647] = 6602,
  [6648] = 6612,
  [6649] = 6612,
  [6650] = 6650,
  [6651] = 6611,
  [6652] = 6615,
  [6653] = 6612,
  [6654] = 6654,
  [6655] = 6600,
  [6656] = 6616,
  [6657] = 6611,
  [6658] = 6615,
  [6659] = 6634,
  [6660] = 6611,
  [6661] = 6601,
  [6662] = 6641,
  [6663] = 6615,
  [6664] = 6615,
  [6665] = 6634,
  [6666] = 6612,
  [6667] = 6635,
  [6668] = 6603,
  [6669] = 6613,
  [6670] = 6599,
  [6671] = 6611,
  [6672] = 6615,
  [6673] = 6603,
  [6674] = 6614,
  [6675] = 6606,
  [6676] = 6676,
  [6677] = 6612,
  [6678] = 6678,
  [6679] = 6679,
  [6680] = 6679,
  [6681] = 6611,
  [6682] = 6603,
  [6683] = 6616,
  [6684] = 6615,
  [6685] = 6600,
  [6686] = 6605,
  [6687] = 6602,
  [6688] = 6612,
  [6689] = 6612,
  [6690] = 6611,
  [6691] = 6603,
  [6692] = 6601,
  [6693] = 6615,
  [6694] = 6616,
  [6695] = 6624,
  [6696] = 6603,
  [6697] = 6697,
  [6698] = 6641,
  [6699] = 6607,
  [6700] = 6634,
  [6701] = 6701,
  [6702] = 6702,
  [6703] = 6612,
  [6704] = 6641,
  [6705] = 6705,
  [6706] = 6601,
  [6707] = 6607,
  [6708] = 6611,
  [6709] = 6709,
  [6710] = 6612,
  [6711] = 6624,
  [6712] = 6603,
  [6713] = 6624,
  [6714] = 6635,
  [6715] = 6615,
  [6716] = 6635,
  [6717] = 6616,
  [6718] = 6620,
  [6719] = 6600,
  [6720] = 6720,
  [6721] = 6679,
  [6722] = 6612,
  [6723] = 6602,
  [6724] = 6601,
  [6725] = 6624,
  [6726] = 5821,
  [6727] = 6679,
  [6728] = 6728,
  [6729] = 6729,
  [6730] = 6641,
  [6731] = 6604,
  [6732] = 6600,
  [6733] = 6612,
  [6734] = 6607,
  [6735] = 6624,
  [6736] = 6620,
  [6737] = 6616,
  [6738] = 6615,
  [6739] = 6611,
  [6740] = 6740,
  [6741] = 6603,
  [6742] = 6622,
  [6743] = 6599,
  [6744] = 6604,
  [6745] = 6620,
  [6746] = 6746,
  [6747] = 6608,
  [6748] = 6605,
  [6749] = 6749,
  [6750] = 6615,
  [6751] = 6616,
  [6752] = 6611,
  [6753] = 6604,
  [6754] = 6624,
  [6755] = 6624,
  [6756] = 6607,
  [6757] = 6608,
  [6758] = 6604,
  [6759] = 6608,
  [6760] = 6679,
  [6761] = 6641,
  [6762] = 6612,
  [6763] = 6620,
  [6764] = 6641,
  [6765] = 6612,
  [6766] = 6608,
  [6767] = 6614,
  [6768] = 6602,
  [6769] = 6620,
  [6770] = 6622,
  [6771] = 6608,
  [6772] = 6622,
  [6773] = 6773,
  [6774] = 6603,
  [6775] = 6634,
  [6776] = 6641,
  [6777] = 6599,
  [6778] = 6605,
  [6779] = 6606,
  [6780] = 6611,
  [6781] = 6620,
  [6782] = 6616,
  [6783] = 6614,
  [6784] = 6611,
  [6785] = 6614,
  [6786] = 6603,
  [6787] = 6615,
  [6788] = 6615,
  [6789] = 6615,
  [6790] = 6679,
  [6791] = 6604,
  [6792] = 6608,
  [6793] = 6616,
  [6794] = 6611,
  [6795] = 6615,
  [6796] = 6616,
  [6797] = 6624,
  [6798] = 6616,
  [6799] = 6602,
  [6800] = 6605,
  [6801] = 6801,
  [6802] = 6620,
  [6803] = 6612,
  [6804] = 6804,
  [6805] = 6612,
  [6806] = 6605,
  [6807] = 6599,
  [6808] = 6612,
  [6809] = 6622,
  [6810] = 6603,
  [6811] = 6811,
  [6812] = 6605,
  [6813] = 6624,
  [6814] = 6607,
  [6815] = 6602,
  [6816] = 6816,
  [6817] = 6679,
  [6818] = 6604,
  [6819] = 6819,
  [6820] = 6634,
  [6821] = 6641,
  [6822] = 6599,
  [6823] = 6679,
  [6824] = 6605,
  [6825] = 6624,
  [6826] = 6599,
  [6827] = 6620,
  [6828] = 6641,
  [6829] = 6829,
  [6830] = 6634,
  [6831] = 6613,
  [6832] = 6832,
  [6833] = 6833,
  [6834] = 6611,
  [6835] = 6599,
  [6836] = 6603,
  [6837] = 6622,
  [6838] = 6604,
  [6839] = 6635,
  [6840] = 6679,
  [6841] = 6602,
  [6842] = 6604,
  [6843] = 6843,
  [6844] = 6622,
  [6845] = 6845,
  [6846] = 6622,
  [6847] = 6634,
  [6848] = 6613,
  [6849] = 6608,
  [6850] = 6608,
  [6851] = 6604,
  [6852] = 6615,
  [6853] = 6613,
  [6854] = 6616,
  [6855] = 6624,
  [6856] = 6606,
  [6857] = 6857,
  [6858] = 6635,
  [6859] = 6859,
  [6860] = 6860,
  [6861] = 6861,
  [6862] = 6862,
  [6863] = 6863,
  [6864] = 6864,
  [6865] = 6865,
  [6866] = 6866,
  [6867] = 6867,
  [6868] = 6868,
  [6869] = 6869,
  [6870] = 6870,
  [6871] = 6871,
  [6872] = 6872,
  [6873] = 6873,
  [6874] = 6874,
  [6875] = 6875,
  [6876] = 6876,
  [6877] = 6877,
  [6878] = 6878,
  [6879] = 6879,
  [6880] = 6880,
  [6881] = 6881,
  [6882] = 6881,
  [6883] = 6883,
  [6884] = 6866,
  [6885] = 6885,
  [6886] = 6886,
  [6887] = 6887,
  [6888] = 6867,
  [6889] = 6889,
  [6890] = 6887,
  [6891] = 6891,
  [6892] = 6875,
  [6893] = 6893,
  [6894] = 6894,
  [6895] = 6895,
  [6896] = 6896,
  [6897] = 6897,
  [6898] = 6871,
  [6899] = 6899,
  [6900] = 6900,
  [6901] = 6871,
  [6902] = 6902,
  [6903] = 6903,
  [6904] = 6904,
  [6905] = 6893,
  [6906] = 6896,
  [6907] = 6907,
  [6908] = 6908,
  [6909] = 6909,
  [6910] = 6895,
  [6911] = 6895,
  [6912] = 6865,
  [6913] = 6861,
  [6914] = 6876,
  [6915] = 6893,
  [6916] = 6896,
  [6917] = 6899,
  [6918] = 6918,
  [6919] = 6919,
  [6920] = 6869,
  [6921] = 6921,
  [6922] = 6922,
  [6923] = 6923,
  [6924] = 6924,
  [6925] = 224,
  [6926] = 6889,
  [6927] = 6927,
  [6928] = 6928,
  [6929] = 6929,
  [6930] = 6930,
  [6931] = 6872,
  [6932] = 6932,
  [6933] = 6933,
  [6934] = 6923,
  [6935] = 6868,
  [6936] = 6936,
  [6937] = 6928,
  [6938] = 6929,
  [6939] = 6939,
  [6940] = 6930,
  [6941] = 6930,
  [6942] = 6909,
  [6943] = 6895,
  [6944] = 6944,
  [6945] = 6929,
  [6946] = 6864,
  [6947] = 6928,
  [6948] = 6948,
  [6949] = 6933,
  [6950] = 6932,
  [6951] = 6918,
  [6952] = 6908,
  [6953] = 6904,
  [6954] = 6899,
  [6955] = 6864,
  [6956] = 6896,
  [6957] = 6893,
  [6958] = 6958,
  [6959] = 6897,
  [6960] = 6923,
  [6961] = 6894,
  [6962] = 6962,
  [6963] = 6922,
  [6964] = 6964,
  [6965] = 6889,
  [6966] = 6966,
  [6967] = 6932,
  [6968] = 6933,
  [6969] = 6928,
  [6970] = 6929,
  [6971] = 6909,
  [6972] = 6972,
  [6973] = 6869,
  [6974] = 6876,
  [6975] = 6930,
  [6976] = 6868,
  [6977] = 6923,
  [6978] = 6972,
  [6979] = 6899,
  [6980] = 6972,
  [6981] = 6875,
  [6982] = 6922,
  [6983] = 6896,
  [6984] = 6872,
  [6985] = 6876,
  [6986] = 6876,
  [6987] = 6887,
  [6988] = 2452,
  [6989] = 6893,
  [6990] = 6861,
  [6991] = 6932,
  [6992] = 6865,
  [6993] = 6908,
  [6994] = 6964,
  [6995] = 6869,
  [6996] = 6922,
  [6997] = 6895,
  [6998] = 6962,
  [6999] = 6933,
  [7000] = 6894,
  [7001] = 6923,
  [7002] = 6893,
  [7003] = 6904,
  [7004] = 6896,
  [7005] = 7005,
  [7006] = 6895,
  [7007] = 6928,
  [7008] = 6887,
  [7009] = 7009,
  [7010] = 6899,
  [7011] = 6894,
  [7012] = 6928,
  [7013] = 6929,
  [7014] = 6930,
  [7015] = 6966,
  [7016] = 6877,
  [7017] = 6903,
  [7018] = 6899,
  [7019] = 6863,
  [7020] = 6918,
  [7021] = 6895,
  [7022] = 6929,
  [7023] = 6866,
  [7024] = 6964,
  [7025] = 7025,
  [7026] = 6865,
  [7027] = 6922,
  [7028] = 7028,
  [7029] = 6873,
  [7030] = 6930,
  [7031] = 6877,
  [7032] = 6930,
  [7033] = 6929,
  [7034] = 7034,
  [7035] = 6871,
  [7036] = 6897,
  [7037] = 6928,
  [7038] = 6887,
  [7039] = 7039,
  [7040] = 6866,
  [7041] = 6909,
  [7042] = 7042,
  [7043] = 7043,
  [7044] = 7044,
  [7045] = 6933,
  [7046] = 7046,
  [7047] = 6875,
  [7048] = 6908,
  [7049] = 6932,
  [7050] = 7050,
  [7051] = 6867,
  [7052] = 7052,
  [7053] = 6869,
  [7054] = 6904,
  [7055] = 6889,
  [7056] = 6875,
  [7057] = 6927,
  [7058] = 6864,
  [7059] = 6904,
  [7060] = 6861,
  [7061] = 6868,
  [7062] = 6872,
  [7063] = 6881,
  [7064] = 7064,
  [7065] = 6966,
  [7066] = 6872,
  [7067] = 6894,
  [7068] = 227,
  [7069] = 6864,
  [7070] = 6881,
  [7071] = 6895,
  [7072] = 7072,
  [7073] = 6909,
  [7074] = 7074,
  [7075] = 7075,
  [7076] = 7076,
  [7077] = 6966,
  [7078] = 6875,
  [7079] = 6863,
  [7080] = 6927,
  [7081] = 6928,
  [7082] = 6929,
  [7083] = 6930,
  [7084] = 6904,
  [7085] = 7085,
  [7086] = 7086,
  [7087] = 6908,
  [7088] = 6944,
  [7089] = 6872,
  [7090] = 6865,
  [7091] = 6894,
  [7092] = 6881,
  [7093] = 6867,
  [7094] = 6861,
  [7095] = 7095,
  [7096] = 7009,
  [7097] = 6966,
  [7098] = 6867,
  [7099] = 6876,
  [7100] = 6875,
  [7101] = 6875,
  [7102] = 6962,
  [7103] = 7103,
  [7104] = 6868,
  [7105] = 7105,
  [7106] = 6895,
  [7107] = 6928,
  [7108] = 6929,
  [7109] = 6930,
  [7110] = 6871,
  [7111] = 6867,
  [7112] = 6922,
  [7113] = 6877,
  [7114] = 7114,
  [7115] = 7009,
  [7116] = 7116,
  [7117] = 6962,
  [7118] = 6863,
  [7119] = 6881,
  [7120] = 7120,
  [7121] = 6923,
  [7122] = 6877,
  [7123] = 7123,
  [7124] = 6923,
  [7125] = 6875,
  [7126] = 6866,
  [7127] = 6873,
  [7128] = 6897,
  [7129] = 6895,
  [7130] = 6928,
  [7131] = 6929,
  [7132] = 6930,
  [7133] = 6865,
  [7134] = 6871,
  [7135] = 6887,
  [7136] = 6863,
  [7137] = 6895,
  [7138] = 7138,
  [7139] = 6966,
  [7140] = 7140,
  [7141] = 6864,
  [7142] = 6875,
  [7143] = 7143,
  [7144] = 6875,
  [7145] = 7145,
  [7146] = 7146,
  [7147] = 6875,
  [7148] = 6398,
  [7149] = 7149,
  [7150] = 7150,
  [7151] = 6895,
  [7152] = 6928,
  [7153] = 6929,
  [7154] = 6930,
  [7155] = 7155,
  [7156] = 6930,
  [7157] = 7157,
  [7158] = 6875,
  [7159] = 6894,
  [7160] = 7160,
  [7161] = 7161,
  [7162] = 7162,
  [7163] = 6929,
  [7164] = 6928,
  [7165] = 6904,
  [7166] = 6908,
  [7167] = 6872,
  [7168] = 6875,
  [7169] = 6933,
  [7170] = 6871,
  [7171] = 7171,
  [7172] = 6895,
  [7173] = 6928,
  [7174] = 6929,
  [7175] = 6930,
  [7176] = 6877,
  [7177] = 6932,
  [7178] = 7009,
  [7179] = 6865,
  [7180] = 6861,
  [7181] = 6893,
  [7182] = 6863,
  [7183] = 7183,
  [7184] = 7184,
  [7185] = 7185,
  [7186] = 6876,
  [7187] = 6922,
  [7188] = 6867,
  [7189] = 6875,
  [7190] = 6896,
  [7191] = 6923,
  [7192] = 6895,
  [7193] = 6928,
  [7194] = 6929,
  [7195] = 6930,
  [7196] = 7196,
  [7197] = 7197,
  [7198] = 6899,
  [7199] = 6908,
  [7200] = 7200,
  [7201] = 6872,
  [7202] = 6889,
  [7203] = 7203,
  [7204] = 6868,
  [7205] = 6866,
  [7206] = 6930,
  [7207] = 6929,
  [7208] = 6887,
  [7209] = 6875,
  [7210] = 6895,
  [7211] = 6928,
  [7212] = 6895,
  [7213] = 6928,
  [7214] = 6929,
  [7215] = 6930,
  [7216] = 7216,
  [7217] = 7217,
  [7218] = 6881,
  [7219] = 6933,
  [7220] = 6932,
  [7221] = 7221,
  [7222] = 6893,
  [7223] = 6863,
  [7224] = 6889,
  [7225] = 6896,
  [7226] = 6899,
  [7227] = 6881,
  [7228] = 7228,
  [7229] = 6875,
  [7230] = 6918,
  [7231] = 7231,
  [7232] = 6895,
  [7233] = 6928,
  [7234] = 6929,
  [7235] = 6930,
  [7236] = 7236,
  [7237] = 6873,
  [7238] = 6877,
  [7239] = 6909,
  [7240] = 6871,
  [7241] = 6875,
  [7242] = 6864,
  [7243] = 6909,
  [7244] = 7244,
  [7245] = 6875,
  [7246] = 6867,
  [7247] = 6868,
  [7248] = 6868,
  [7249] = 6868,
  [7250] = 6861,
  [7251] = 6869,
  [7252] = 6868,
  [7253] = 6868,
  [7254] = 6875,
  [7255] = 6868,
  [7256] = 7256,
  [7257] = 7257,
  [7258] = 7258,
  [7259] = 7259,
  [7260] = 7260,
  [7261] = 7261,
  [7262] = 7258,
  [7263] = 7263,
  [7264] = 7264,
  [7265] = 7265,
  [7266] = 7266,
  [7267] = 7258,
  [7268] = 7268,
  [7269] = 7268,
  [7270] = 7270,
  [7271] = 7265,
  [7272] = 7266,
  [7273] = 7273,
  [7274] = 7274,
  [7275] = 7275,
  [7276] = 7257,
  [7277] = 7277,
  [7278] = 7278,
  [7279] = 7279,
  [7280] = 7280,
  [7281] = 7281,
  [7282] = 7277,
  [7283] = 7264,
  [7284] = 7284,
  [7285] = 7285,
  [7286] = 7258,
  [7287] = 7265,
  [7288] = 7288,
  [7289] = 7289,
  [7290] = 7285,
  [7291] = 7291,
  [7292] = 7281,
  [7293] = 7293,
  [7294] = 7257,
  [7295] = 7257,
  [7296] = 7296,
  [7297] = 7293,
  [7298] = 7258,
  [7299] = 7299,
  [7300] = 7268,
  [7301] = 7301,
  [7302] = 7266,
  [7303] = 7303,
  [7304] = 7304,
  [7305] = 7305,
  [7306] = 7296,
  [7307] = 7307,
  [7308] = 7280,
  [7309] = 7309,
  [7310] = 7310,
  [7311] = 7311,
  [7312] = 7312,
  [7313] = 7313,
  [7314] = 7314,
  [7315] = 7257,
  [7316] = 7316,
  [7317] = 7257,
  [7318] = 7318,
  [7319] = 7278,
  [7320] = 7280,
  [7321] = 7321,
  [7322] = 7313,
  [7323] = 7303,
  [7324] = 7324,
  [7325] = 7275,
  [7326] = 7326,
  [7327] = 7257,
  [7328] = 7260,
  [7329] = 7264,
  [7330] = 7330,
  [7331] = 7279,
  [7332] = 7312,
  [7333] = 7277,
  [7334] = 7288,
  [7335] = 7335,
  [7336] = 7336,
  [7337] = 7337,
  [7338] = 7338,
  [7339] = 7339,
  [7340] = 7310,
  [7341] = 7289,
  [7342] = 7270,
  [7343] = 7275,
  [7344] = 7305,
  [7345] = 7258,
  [7346] = 7312,
  [7347] = 7347,
  [7348] = 7348,
  [7349] = 7285,
  [7350] = 7281,
  [7351] = 7296,
  [7352] = 7307,
  [7353] = 7264,
  [7354] = 7268,
  [7355] = 7288,
  [7356] = 7356,
  [7357] = 7357,
  [7358] = 7358,
  [7359] = 7266,
  [7360] = 7260,
  [7361] = 7361,
  [7362] = 7362,
  [7363] = 7257,
  [7364] = 7280,
  [7365] = 7313,
  [7366] = 7312,
  [7367] = 7257,
  [7368] = 7278,
  [7369] = 7316,
  [7370] = 7278,
  [7371] = 7293,
  [7372] = 7311,
  [7373] = 7275,
  [7374] = 7305,
  [7375] = 7279,
  [7376] = 7376,
  [7377] = 7260,
  [7378] = 7307,
  [7379] = 7260,
  [7380] = 7264,
  [7381] = 7307,
  [7382] = 7270,
  [7383] = 7279,
  [7384] = 7347,
  [7385] = 7275,
  [7386] = 7310,
  [7387] = 7330,
  [7388] = 7316,
  [7389] = 7303,
  [7390] = 7270,
  [7391] = 7391,
  [7392] = 7307,
  [7393] = 7293,
  [7394] = 7293,
  [7395] = 7270,
  [7396] = 7396,
  [7397] = 7310,
  [7398] = 7281,
  [7399] = 7310,
  [7400] = 7278,
  [7401] = 7288,
  [7402] = 7284,
  [7403] = 7285,
  [7404] = 7258,
  [7405] = 7265,
  [7406] = 7263,
  [7407] = 7310,
  [7408] = 7270,
  [7409] = 7268,
  [7410] = 7410,
  [7411] = 7316,
  [7412] = 7312,
  [7413] = 7261,
  [7414] = 7280,
  [7415] = 7266,
  [7416] = 7277,
  [7417] = 7417,
  [7418] = 7257,
  [7419] = 7260,
  [7420] = 7275,
  [7421] = 7307,
  [7422] = 7422,
  [7423] = 7280,
  [7424] = 7257,
  [7425] = 7279,
  [7426] = 7289,
  [7427] = 7316,
  [7428] = 7347,
  [7429] = 7279,
  [7430] = 7278,
  [7431] = 7284,
  [7432] = 7305,
  [7433] = 7296,
  [7434] = 7357,
  [7435] = 7279,
  [7436] = 7264,
  [7437] = 7257,
  [7438] = 7307,
  [7439] = 7347,
  [7440] = 7339,
  [7441] = 7281,
  [7442] = 7357,
  [7443] = 7362,
  [7444] = 7339,
  [7445] = 7339,
  [7446] = 7446,
  [7447] = 7270,
  [7448] = 7303,
  [7449] = 7307,
  [7450] = 7310,
  [7451] = 7296,
  [7452] = 7330,
  [7453] = 7285,
  [7454] = 7258,
  [7455] = 7339,
  [7456] = 7456,
  [7457] = 7293,
  [7458] = 7458,
  [7459] = 7279,
  [7460] = 7281,
  [7461] = 7339,
  [7462] = 7462,
  [7463] = 7463,
  [7464] = 7357,
  [7465] = 7310,
  [7466] = 7270,
  [7467] = 7279,
  [7468] = 7268,
  [7469] = 7311,
  [7470] = 7311,
  [7471] = 7312,
  [7472] = 7263,
  [7473] = 7313,
  [7474] = 7362,
  [7475] = 7257,
  [7476] = 7258,
  [7477] = 7312,
  [7478] = 7279,
  [7479] = 7260,
  [7480] = 7263,
  [7481] = 7261,
  [7482] = 7303,
  [7483] = 7483,
  [7484] = 7307,
  [7485] = 7311,
  [7486] = 7270,
  [7487] = 7307,
  [7488] = 7310,
  [7489] = 7293,
  [7490] = 7266,
  [7491] = 7491,
  [7492] = 7257,
  [7493] = 7493,
  [7494] = 7362,
  [7495] = 7495,
  [7496] = 7496,
  [7497] = 7265,
  [7498] = 7279,
  [7499] = 7293,
  [7500] = 7279,
  [7501] = 7337,
  [7502] = 2524,
  [7503] = 7279,
  [7504] = 7281,
  [7505] = 7357,
  [7506] = 7277,
  [7507] = 7281,
  [7508] = 7284,
  [7509] = 7330,
  [7510] = 7303,
  [7511] = 7293,
  [7512] = 2542,
  [7513] = 7513,
  [7514] = 2543,
  [7515] = 7265,
  [7516] = 7483,
  [7517] = 7357,
  [7518] = 7303,
  [7519] = 7519,
  [7520] = 7268,
  [7521] = 7483,
  [7522] = 7279,
  [7523] = 7263,
  [7524] = 7303,
  [7525] = 7293,
  [7526] = 7257,
  [7527] = 7307,
  [7528] = 7483,
  [7529] = 7284,
  [7530] = 7281,
  [7531] = 7293,
  [7532] = 7261,
  [7533] = 2559,
  [7534] = 7483,
  [7535] = 7305,
  [7536] = 7316,
  [7537] = 7278,
  [7538] = 7265,
  [7539] = 7280,
  [7540] = 2562,
  [7541] = 7310,
  [7542] = 7270,
  [7543] = 7483,
  [7544] = 7312,
  [7545] = 7545,
  [7546] = 7546,
  [7547] = 7312,
  [7548] = 7293,
  [7549] = 7549,
  [7550] = 7266,
  [7551] = 7483,
  [7552] = 7257,
  [7553] = 7483,
  [7554] = 7258,
  [7555] = 7285,
  [7556] = 7296,
  [7557] = 7260,
  [7558] = 7281,
  [7559] = 7289,
  [7560] = 7483,
  [7561] = 7279,
  [7562] = 7310,
  [7563] = 7270,
  [7564] = 7270,
  [7565] = 7310,
  [7566] = 7483,
  [7567] = 7312,
  [7568] = 7568,
  [7569] = 7307,
  [7570] = 7483,
  [7571] = 7483,
  [7572] = 7483,
  [7573] = 7483,
  [7574] = 7277,
  [7575] = 7483,
  [7576] = 7266,
  [7577] = 7483,
  [7578] = 7483,
  [7579] = 7261,
  [7580] = 7347,
  [7581] = 7263,
  [7582] = 7311,
  [7583] = 2573,
  [7584] = 7275,
  [7585] = 2577,
  [7586] = 7268,
  [7587] = 2580,
  [7588] = 7588,
  [7589] = 2581,
  [7590] = 2593,
  [7591] = 7260,
  [7592] = 7264,
  [7593] = 7279,
  [7594] = 7339,
  [7595] = 7264,
  [7596] = 7596,
  [7597] = 7597,
  [7598] = 7598,
  [7599] = 7599,
  [7600] = 7600,
  [7601] = 7601,
  [7602] = 7602,
  [7603] = 7603,
  [7604] = 7604,
  [7605] = 7605,
  [7606] = 7606,
  [7607] = 7607,
  [7608] = 7608,
  [7609] = 7609,
  [7610] = 7610,
  [7611] = 7611,
  [7612] = 7612,
  [7613] = 7613,
  [7614] = 7614,
  [7615] = 7615,
  [7616] = 7616,
  [7617] = 7617,
  [7618] = 7618,
  [7619] = 7603,
  [7620] = 7620,
  [7621] = 7621,
  [7622] = 7601,
  [7623] = 7599,
  [7624] = 7624,
  [7625] = 7625,
  [7626] = 7611,
  [7627] = 7615,
  [7628] = 7628,
  [7629] = 7629,
  [7630] = 7630,
  [7631] = 7613,
  [7632] = 7632,
  [7633] = 7609,
  [7634] = 7634,
  [7635] = 7635,
  [7636] = 7636,
  [7637] = 7637,
  [7638] = 7638,
  [7639] = 7639,
  [7640] = 7640,
  [7641] = 7641,
  [7642] = 7642,
  [7643] = 7643,
  [7644] = 7644,
  [7645] = 7645,
  [7646] = 7646,
  [7647] = 7647,
  [7648] = 7648,
  [7649] = 7649,
  [7650] = 7650,
  [7651] = 7651,
  [7652] = 7644,
  [7653] = 7653,
  [7654] = 7654,
  [7655] = 7655,
  [7656] = 7656,
  [7657] = 7657,
  [7658] = 7646,
  [7659] = 7656,
  [7660] = 7648,
  [7661] = 7661,
  [7662] = 7662,
  [7663] = 7613,
  [7664] = 7636,
  [7665] = 7665,
  [7666] = 7645,
  [7667] = 7667,
  [7668] = 7642,
  [7669] = 7669,
  [7670] = 7600,
  [7671] = 7671,
  [7672] = 7672,
  [7673] = 7673,
  [7674] = 7674,
  [7675] = 7602,
  [7676] = 7625,
  [7677] = 7657,
  [7678] = 7678,
  [7679] = 7679,
  [7680] = 7605,
  [7681] = 7606,
  [7682] = 7613,
  [7683] = 7683,
  [7684] = 7684,
  [7685] = 7685,
  [7686] = 7661,
  [7687] = 7639,
  [7688] = 7688,
  [7689] = 7672,
  [7690] = 7608,
  [7691] = 7673,
  [7692] = 7604,
  [7693] = 7674,
  [7694] = 7694,
  [7695] = 5527,
  [7696] = 7696,
  [7697] = 7612,
  [7698] = 7698,
  [7699] = 7671,
  [7700] = 7667,
  [7701] = 7688,
  [7702] = 7702,
  [7703] = 7667,
  [7704] = 7704,
  [7705] = 7705,
  [7706] = 7706,
  [7707] = 7599,
  [7708] = 7705,
  [7709] = 7601,
  [7710] = 7710,
  [7711] = 7711,
  [7712] = 7628,
  [7713] = 7713,
  [7714] = 7646,
  [7715] = 7715,
  [7716] = 7716,
  [7717] = 7620,
  [7718] = 7614,
  [7719] = 7719,
  [7720] = 7720,
  [7721] = 1794,
  [7722] = 7696,
  [7723] = 7723,
  [7724] = 7698,
  [7725] = 7611,
  [7726] = 7615,
  [7727] = 7628,
  [7728] = 7642,
  [7729] = 7729,
  [7730] = 7644,
  [7731] = 7603,
  [7732] = 7615,
  [7733] = 7733,
  [7734] = 7609,
  [7735] = 7611,
  [7736] = 7645,
  [7737] = 7737,
  [7738] = 7738,
  [7739] = 7739,
  [7740] = 7694,
  [7741] = 7599,
  [7742] = 7742,
  [7743] = 7601,
  [7744] = 7744,
  [7745] = 7745,
  [7746] = 7647,
  [7747] = 7603,
  [7748] = 7748,
  [7749] = 7685,
  [7750] = 7653,
  [7751] = 7683,
  [7752] = 7655,
  [7753] = 7648,
  [7754] = 7754,
  [7755] = 7679,
  [7756] = 7642,
  [7757] = 7644,
  [7758] = 7678,
  [7759] = 7656,
  [7760] = 7605,
  [7761] = 7615,
  [7762] = 7667,
  [7763] = 7655,
  [7764] = 7611,
  [7765] = 7608,
  [7766] = 7653,
  [7767] = 7767,
  [7768] = 7706,
  [7769] = 7769,
  [7770] = 7617,
  [7771] = 7612,
  [7772] = 7665,
  [7773] = 7773,
  [7774] = 7704,
  [7775] = 7775,
  [7776] = 7649,
  [7777] = 7777,
  [7778] = 7647,
  [7779] = 7648,
  [7780] = 7688,
  [7781] = 7618,
  [7782] = 7696,
  [7783] = 7783,
  [7784] = 7784,
  [7785] = 7620,
  [7786] = 7786,
  [7787] = 7720,
  [7788] = 7788,
  [7789] = 7698,
  [7790] = 7704,
  [7791] = 7656,
  [7792] = 7628,
  [7793] = 7629,
  [7794] = 7794,
  [7795] = 7795,
  [7796] = 7796,
  [7797] = 7797,
  [7798] = 7609,
  [7799] = 7799,
  [7800] = 7625,
  [7801] = 7706,
  [7802] = 7720,
  [7803] = 7645,
  [7804] = 7604,
  [7805] = 5524,
  [7806] = 7806,
  [7807] = 7647,
  [7808] = 7639,
  [7809] = 7618,
  [7810] = 7653,
  [7811] = 7811,
  [7812] = 7655,
  [7813] = 6584,
  [7814] = 7605,
  [7815] = 7617,
  [7816] = 7614,
  [7817] = 7609,
  [7818] = 7636,
  [7819] = 7635,
  [7820] = 7634,
  [7821] = 7612,
  [7822] = 7628,
  [7823] = 7624,
  [7824] = 7615,
  [7825] = 7611,
  [7826] = 7604,
  [7827] = 7624,
  [7828] = 7828,
  [7829] = 7603,
  [7830] = 7601,
  [7831] = 7614,
  [7832] = 7599,
  [7833] = 7674,
  [7834] = 7620,
  [7835] = 7673,
  [7836] = 7672,
  [7837] = 7604,
  [7838] = 7630,
  [7839] = 7688,
  [7840] = 7628,
  [7841] = 7841,
  [7842] = 7842,
  [7843] = 7646,
  [7844] = 7844,
  [7845] = 7773,
  [7846] = 7609,
  [7847] = 7621,
  [7848] = 7613,
  [7849] = 7849,
  [7850] = 7850,
  [7851] = 7851,
  [7852] = 7852,
  [7853] = 7853,
  [7854] = 7854,
  [7855] = 7647,
  [7856] = 7661,
  [7857] = 7620,
  [7858] = 7653,
  [7859] = 7859,
  [7860] = 7655,
  [7861] = 7861,
  [7862] = 7605,
  [7863] = 7863,
  [7864] = 7864,
  [7865] = 7865,
  [7866] = 7866,
  [7867] = 7657,
  [7868] = 7696,
  [7869] = 7869,
  [7870] = 7870,
  [7871] = 7871,
  [7872] = 7600,
  [7873] = 7873,
  [7874] = 7602,
  [7875] = 7875,
  [7876] = 7642,
  [7877] = 7620,
  [7878] = 7878,
  [7879] = 7738,
  [7880] = 7880,
  [7881] = 7881,
  [7882] = 1803,
  [7883] = 7883,
  [7884] = 7884,
  [7885] = 7828,
  [7886] = 7609,
  [7887] = 7887,
  [7888] = 7888,
  [7889] = 7645,
  [7890] = 7617,
  [7891] = 7891,
  [7892] = 7892,
  [7893] = 7893,
  [7894] = 7612,
  [7895] = 7653,
  [7896] = 7896,
  [7897] = 7655,
  [7898] = 7898,
  [7899] = 7899,
  [7900] = 7648,
  [7901] = 7618,
  [7902] = 7902,
  [7903] = 7903,
  [7904] = 7620,
  [7905] = 7905,
  [7906] = 7906,
  [7907] = 7621,
  [7908] = 7609,
  [7909] = 7614,
  [7910] = 7910,
  [7911] = 7655,
  [7912] = 7608,
  [7913] = 7634,
  [7914] = 7914,
  [7915] = 7636,
  [7916] = 7620,
  [7917] = 7917,
  [7918] = 7918,
  [7919] = 7609,
  [7920] = 7920,
  [7921] = 7655,
  [7922] = 7679,
  [7923] = 7629,
  [7924] = 7842,
  [7925] = 7620,
  [7926] = 7609,
  [7927] = 7655,
  [7928] = 7928,
  [7929] = 7609,
  [7930] = 7655,
  [7931] = 7931,
  [7932] = 7609,
  [7933] = 7655,
  [7934] = 7609,
  [7935] = 7655,
  [7936] = 7609,
  [7937] = 7655,
  [7938] = 7609,
  [7939] = 7655,
  [7940] = 7609,
  [7941] = 7655,
  [7942] = 7609,
  [7943] = 7655,
  [7944] = 7685,
  [7945] = 7606,
  [7946] = 7605,
  [7947] = 7947,
  [7948] = 7656,
  [7949] = 7949,
  [7950] = 7950,
  [7951] = 7656,
  [7952] = 7952,
  [7953] = 7953,
  [7954] = 7648,
  [7955] = 7955,
  [7956] = 7956,
  [7957] = 7674,
  [7958] = 7636,
  [7959] = 7959,
  [7960] = 7625,
  [7961] = 7685,
  [7962] = 7645,
  [7963] = 7963,
  [7964] = 7644,
  [7965] = 7642,
  [7966] = 7966,
  [7967] = 7602,
  [7968] = 7688,
  [7969] = 7674,
  [7970] = 7600,
  [7971] = 7971,
  [7972] = 7972,
  [7973] = 7973,
  [7974] = 7974,
  [7975] = 7975,
  [7976] = 7976,
  [7977] = 7738,
  [7978] = 7978,
  [7979] = 7979,
  [7980] = 7980,
  [7981] = 7661,
  [7982] = 7636,
  [7983] = 7618,
  [7984] = 7634,
  [7985] = 7706,
  [7986] = 7629,
  [7987] = 7987,
  [7988] = 7688,
  [7989] = 7613,
  [7990] = 7621,
  [7991] = 7646,
  [7992] = 7640,
  [7993] = 7769,
  [7994] = 7601,
  [7995] = 7702,
  [7996] = 7674,
  [7997] = 7997,
  [7998] = 7641,
  [7999] = 7599,
  [8000] = 7656,
  [8001] = 7601,
  [8002] = 8002,
  [8003] = 8003,
  [8004] = 7672,
  [8005] = 7673,
  [8006] = 7603,
  [8007] = 7674,
  [8008] = 8008,
  [8009] = 7688,
  [8010] = 7617,
  [8011] = 7674,
  [8012] = 8012,
  [8013] = 8013,
  [8014] = 8014,
  [8015] = 8015,
  [8016] = 5546,
  [8017] = 7892,
  [8018] = 7604,
  [8019] = 7646,
  [8020] = 8020,
  [8021] = 7696,
  [8022] = 8022,
  [8023] = 7688,
  [8024] = 7674,
  [8025] = 7698,
  [8026] = 7698,
  [8027] = 7649,
  [8028] = 7651,
  [8029] = 7614,
  [8030] = 7653,
  [8031] = 7655,
  [8032] = 8032,
  [8033] = 8033,
  [8034] = 7667,
  [8035] = 7738,
  [8036] = 8036,
  [8037] = 7665,
  [8038] = 7688,
  [8039] = 7617,
  [8040] = 8040,
  [8041] = 7618,
  [8042] = 7704,
  [8043] = 8043,
  [8044] = 7644,
  [8045] = 8045,
  [8046] = 7688,
  [8047] = 8047,
  [8048] = 7678,
  [8049] = 7679,
  [8050] = 7683,
  [8051] = 7777,
  [8052] = 7713,
  [8053] = 7706,
  [8054] = 8054,
  [8055] = 7640,
  [8056] = 8056,
  [8057] = 8057,
  [8058] = 7618,
  [8059] = 8059,
  [8060] = 8060,
  [8061] = 7694,
  [8062] = 8062,
  [8063] = 7625,
  [8064] = 7705,
  [8065] = 8065,
  [8066] = 7688,
  [8067] = 7674,
  [8068] = 7641,
  [8069] = 7674,
  [8070] = 7620,
  [8071] = 8012,
  [8072] = 7673,
  [8073] = 7629,
  [8074] = 7672,
  [8075] = 7796,
  [8076] = 7646,
  [8077] = 8077,
  [8078] = 7794,
  [8079] = 7602,
  [8080] = 7688,
  [8081] = 7674,
  [8082] = 8082,
  [8083] = 7640,
  [8084] = 7641,
  [8085] = 7979,
  [8086] = 7600,
  [8087] = 8087,
  [8088] = 7598,
  [8089] = 7630,
  [8090] = 7711,
  [8091] = 7978,
  [8092] = 7625,
  [8093] = 7784,
  [8094] = 8094,
  [8095] = 7694,
  [8096] = 7657,
  [8097] = 7685,
  [8098] = 7683,
  [8099] = 7679,
  [8100] = 8100,
  [8101] = 7678,
  [8102] = 7688,
  [8103] = 7674,
  [8104] = 7649,
  [8105] = 7602,
  [8106] = 7601,
  [8107] = 8107,
  [8108] = 7656,
  [8109] = 7651,
  [8110] = 8110,
  [8111] = 7648,
  [8112] = 7646,
  [8113] = 7601,
  [8114] = 7625,
  [8115] = 7629,
  [8116] = 7716,
  [8117] = 7604,
  [8118] = 7614,
  [8119] = 8119,
  [8120] = 7665,
  [8121] = 7661,
  [8122] = 7678,
  [8123] = 7679,
  [8124] = 7683,
  [8125] = 7685,
  [8126] = 7649,
  [8127] = 7973,
  [8128] = 7947,
  [8129] = 7950,
  [8130] = 7953,
  [8131] = 7786,
  [8132] = 7955,
  [8133] = 7640,
  [8134] = 7685,
  [8135] = 7641,
  [8136] = 7971,
  [8137] = 7971,
  [8138] = 7617,
  [8139] = 7973,
  [8140] = 7694,
  [8141] = 7614,
  [8142] = 8142,
  [8143] = 7978,
  [8144] = 7979,
  [8145] = 7685,
  [8146] = 7601,
  [8147] = 7702,
  [8148] = 7651,
  [8149] = 8077,
  [8150] = 7788,
  [8151] = 8012,
  [8152] = 7892,
  [8153] = 8153,
  [8154] = 8154,
  [8155] = 7947,
  [8156] = 7953,
  [8157] = 5547,
  [8158] = 7955,
  [8159] = 7604,
  [8160] = 7688,
  [8161] = 7971,
  [8162] = 7698,
  [8163] = 7973,
  [8164] = 8164,
  [8165] = 7601,
  [8166] = 7978,
  [8167] = 7979,
  [8168] = 7702,
  [8169] = 7674,
  [8170] = 7672,
  [8171] = 7602,
  [8172] = 8012,
  [8173] = 7892,
  [8174] = 7711,
  [8175] = 7947,
  [8176] = 7953,
  [8177] = 7713,
  [8178] = 7955,
  [8179] = 7786,
  [8180] = 7685,
  [8181] = 7971,
  [8182] = 7973,
  [8183] = 7716,
  [8184] = 7630,
  [8185] = 7978,
  [8186] = 7979,
  [8187] = 7702,
  [8188] = 7672,
  [8189] = 7673,
  [8190] = 8190,
  [8191] = 8012,
  [8192] = 7892,
  [8193] = 7674,
  [8194] = 7947,
  [8195] = 7953,
  [8196] = 7716,
  [8197] = 7955,
  [8198] = 7656,
  [8199] = 7602,
  [8200] = 7973,
  [8201] = 8201,
  [8202] = 7648,
  [8203] = 7978,
  [8204] = 7979,
  [8205] = 7702,
  [8206] = 8206,
  [8207] = 8077,
  [8208] = 7646,
  [8209] = 8012,
  [8210] = 7892,
  [8211] = 7649,
  [8212] = 7947,
  [8213] = 7613,
  [8214] = 7955,
  [8215] = 7651,
  [8216] = 7601,
  [8217] = 7683,
  [8218] = 8218,
  [8219] = 7978,
  [8220] = 7979,
  [8221] = 7604,
  [8222] = 8222,
  [8223] = 8223,
  [8224] = 8012,
  [8225] = 7881,
  [8226] = 7947,
  [8227] = 7955,
  [8228] = 7600,
  [8229] = 7979,
  [8230] = 8230,
  [8231] = 8231,
  [8232] = 8012,
  [8233] = 8233,
  [8234] = 7947,
  [8235] = 7955,
  [8236] = 8236,
  [8237] = 7979,
  [8238] = 8238,
  [8239] = 8012,
  [8240] = 7947,
  [8241] = 7955,
  [8242] = 7979,
  [8243] = 8012,
  [8244] = 7979,
  [8245] = 8012,
  [8246] = 7979,
  [8247] = 8012,
  [8248] = 7979,
  [8249] = 8012,
  [8250] = 7979,
  [8251] = 8012,
  [8252] = 7979,
  [8253] = 8012,
  [8254] = 7979,
  [8255] = 8012,
  [8256] = 7979,
  [8257] = 8012,
  [8258] = 7614,
  [8259] = 7704,
  [8260] = 7950,
  [8261] = 8261,
  [8262] = 8262,
  [8263] = 7713,
  [8264] = 8264,
  [8265] = 8265,
  [8266] = 7639,
  [8267] = 8267,
  [8268] = 7642,
  [8269] = 7737,
  [8270] = 7711,
  [8271] = 7644,
  [8272] = 7739,
  [8273] = 8273,
  [8274] = 8274,
  [8275] = 7598,
  [8276] = 7645,
  [8277] = 7769,
  [8278] = 7610,
  [8279] = 7648,
  [8280] = 7665,
  [8281] = 7671,
  [8282] = 7742,
  [8283] = 8283,
  [8284] = 8284,
  [8285] = 8047,
  [8286] = 7745,
  [8287] = 7678,
  [8288] = 7679,
  [8289] = 7683,
  [8290] = 8290,
  [8291] = 8054,
  [8292] = 7783,
  [8293] = 7706,
  [8294] = 7647,
  [8295] = 7656,
  [8296] = 7694,
  [8297] = 7796,
  [8298] = 7794,
  [8299] = 7636,
  [8300] = 7704,
  [8301] = 7685,
  [8302] = 7678,
  [8303] = 7754,
  [8304] = 7788,
  [8305] = 7679,
  [8306] = 8077,
  [8307] = 7683,
  [8308] = 7656,
  [8309] = 7696,
  [8310] = 7784,
  [8311] = 7777,
  [8312] = 7685,
  [8313] = 7773,
  [8314] = 7688,
  [8315] = 7667,
  [8316] = 7661,
  [8317] = 7602,
  [8318] = 7612,
  [8319] = 7754,
  [8320] = 8320,
  [8321] = 7600,
  [8322] = 8322,
  [8323] = 8323,
  [8324] = 8262,
  [8325] = 8261,
  [8326] = 7745,
  [8327] = 7742,
  [8328] = 8328,
  [8329] = 7688,
  [8330] = 7698,
  [8331] = 7956,
  [8332] = 7955,
  [8333] = 7739,
  [8334] = 7672,
  [8335] = 7737,
  [8336] = 8336,
  [8337] = 7656,
  [8338] = 8338,
  [8339] = 7953,
  [8340] = 7950,
  [8341] = 8261,
  [8342] = 8262,
  [8343] = 7673,
  [8344] = 7608,
  [8345] = 7711,
  [8346] = 7769,
  [8347] = 7610,
  [8348] = 7713,
  [8349] = 7950,
  [8350] = 7674,
  [8351] = 7950,
  [8352] = 8261,
  [8353] = 8262,
  [8354] = 7672,
  [8355] = 7716,
  [8356] = 7769,
  [8357] = 7610,
  [8358] = 7602,
  [8359] = 7674,
  [8360] = 7656,
  [8361] = 8261,
  [8362] = 8262,
  [8363] = 7648,
  [8364] = 7646,
  [8365] = 7769,
  [8366] = 7610,
  [8367] = 7698,
  [8368] = 7698,
  [8369] = 8261,
  [8370] = 8262,
  [8371] = 7601,
  [8372] = 7667,
  [8373] = 7769,
  [8374] = 7610,
  [8375] = 7949,
  [8376] = 7604,
  [8377] = 8261,
  [8378] = 8262,
  [8379] = 7704,
  [8380] = 7769,
  [8381] = 7610,
  [8382] = 7614,
  [8383] = 7706,
  [8384] = 7769,
  [8385] = 7610,
  [8386] = 7947,
  [8387] = 7665,
  [8388] = 7610,
  [8389] = 7694,
  [8390] = 7610,
  [8391] = 8391,
  [8392] = 7610,
  [8393] = 8393,
  [8394] = 7610,
  [8395] = 8395,
  [8396] = 7610,
  [8397] = 8047,
  [8398] = 7610,
  [8399] = 7678,
  [8400] = 7610,
  [8401] = 7657,
  [8402] = 7610,
  [8403] = 8054,
  [8404] = 7610,
  [8405] = 8338,
  [8406] = 8087,
  [8407] = 7688,
  [8408] = 8338,
  [8409] = 8087,
  [8410] = 8410,
  [8411] = 8338,
  [8412] = 8087,
  [8413] = 8413,
  [8414] = 8338,
  [8415] = 8087,
  [8416] = 7685,
  [8417] = 8338,
  [8418] = 8087,
  [8419] = 7678,
  [8420] = 8087,
  [8421] = 8087,
  [8422] = 8087,
  [8423] = 8087,
  [8424] = 8087,
  [8425] = 8087,
  [8426] = 8087,
  [8427] = 8087,
  [8428] = 8087,
  [8429] = 8087,
  [8430] = 8087,
  [8431] = 7679,
  [8432] = 7683,
  [8433] = 7606,
  [8434] = 7685,
  [8435] = 7605,
  [8436] = 8336,
  [8437] = 8336,
  [8438] = 8336,
  [8439] = 8336,
  [8440] = 8336,
};

static TSCharacterRange sym_identifier_character_set_1[] = {
  {'$', '$'}, {'A', 'Z'}, {'\\', '\\'}, {'_', '_'}, {'a', 'z'}, {0xaa, 0xaa}, {0xb5, 0xb5}, {0xba, 0xba},
  {0xc0, 0xd6}, {0xd8, 0xf6}, {0xf8, 0x2c1}, {0x2c6, 0x2d1}, {0x2e0, 0x2e4}, {0x2ec, 0x2ec}, {0x2ee, 0x2ee}, {0x370, 0x374},
  {0x376, 0x377}, {0x37b, 0x37d}, {0x37f, 0x37f}, {0x386, 0x386}, {0x388, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1}, {0x3a3, 0x3f5},
  {0x3f7, 0x481}, {0x48a, 0x52f}, {0x531, 0x556}, {0x559, 0x559}, {0x560, 0x588}, {0x5d0, 0x5ea}, {0x5ef, 0x5f2}, {0x620, 0x64a},
  {0x66e, 0x66f}, {0x671, 0x6d3}, {0x6d5, 0x6d5}, {0x6e5, 0x6e6}, {0x6ee, 0x6ef}, {0x6fa, 0x6fc}, {0x6ff, 0x6ff}, {0x710, 0x710},
  {0x712, 0x72f}, {0x74d, 0x7a5}, {0x7b1, 0x7b1}, {0x7ca, 0x7ea}, {0x7f4, 0x7f5}, {0x7fa, 0x7fa}, {0x800, 0x815}, {0x81a, 0x81a},
  {0x824, 0x824}, {0x828, 0x828}, {0x840, 0x858}, {0x860, 0x86a}, {0x870, 0x887}, {0x889, 0x88e}, {0x8a0, 0x8c9}, {0x904, 0x939},
  {0x93d, 0x93d}, {0x950, 0x950}, {0x958, 0x961}, {0x971, 0x980}, {0x985, 0x98c}, {0x98f, 0x990}, {0x993, 0x9a8}, {0x9aa, 0x9b0},
  {0x9b2, 0x9b2}, {0x9b6, 0x9b9}, {0x9bd, 0x9bd}, {0x9ce, 0x9ce}, {0x9dc, 0x9dd}, {0x9df, 0x9e1}, {0x9f0, 0x9f1}, {0x9fc, 0x9fc},
  {0xa05, 0xa0a}, {0xa0f, 0xa10}, {0xa13, 0xa28}, {0xa2a, 0xa30}, {0xa32, 0xa33}, {0xa35, 0xa36}, {0xa38, 0xa39}, {0xa59, 0xa5c},
  {0xa5e, 0xa5e}, {0xa72, 0xa74}, {0xa85, 0xa8d}, {0xa8f, 0xa91}, {0xa93, 0xaa8}, {0xaaa, 0xab0}, {0xab2, 0xab3}, {0xab5, 0xab9},
  {0xabd, 0xabd}, {0xad0, 0xad0}, {0xae0, 0xae1}, {0xaf9, 0xaf9}, {0xb05, 0xb0c}, {0xb0f, 0xb10}, {0xb13, 0xb28}, {0xb2a, 0xb30},
  {0xb32, 0xb33}, {0xb35, 0xb39}, {0xb3d, 0xb3d}, {0xb5c, 0xb5d}, {0xb5f, 0xb61}, {0xb71, 0xb71}, {0xb83, 0xb83}, {0xb85, 0xb8a},
  {0xb8e, 0xb90}, {0xb92, 0xb95}, {0xb99, 0xb9a}, {0xb9c, 0xb9c}, {0xb9e, 0xb9f}, {0xba3, 0xba4}, {0xba8, 0xbaa}, {0xbae, 0xbb9},
  {0xbd0, 0xbd0}, {0xc05, 0xc0c}, {0xc0e, 0xc10}, {0xc12, 0xc28}, {0xc2a, 0xc39}, {0xc3d, 0xc3d}, {0xc58, 0xc5a}, {0xc5d, 0xc5d},
  {0xc60, 0xc61}, {0xc80, 0xc80}, {0xc85, 0xc8c}, {0xc8e, 0xc90}, {0xc92, 0xca8}, {0xcaa, 0xcb3}, {0xcb5, 0xcb9}, {0xcbd, 0xcbd},
  {0xcdd, 0xcde}, {0xce0, 0xce1}, {0xcf1, 0xcf2}, {0xd04, 0xd0c}, {0xd0e, 0xd10}, {0xd12, 0xd3a}, {0xd3d, 0xd3d}, {0xd4e, 0xd4e},
  {0xd54, 0xd56}, {0xd5f, 0xd61}, {0xd7a, 0xd7f}, {0xd85, 0xd96}, {0xd9a, 0xdb1}, {0xdb3, 0xdbb}, {0xdbd, 0xdbd}, {0xdc0, 0xdc6},
  {0xe01, 0xe30}, {0xe32, 0xe32}, {0xe40, 0xe46}, {0xe81, 0xe82}, {0xe84, 0xe84}, {0xe86, 0xe8a}, {0xe8c, 0xea3}, {0xea5, 0xea5},
  {0xea7, 0xeb0}, {0xeb2, 0xeb2}, {0xebd, 0xebd}, {0xec0, 0xec4}, {0xec6, 0xec6}, {0xedc, 0xedf}, {0xf00, 0xf00}, {0xf40, 0xf47},
  {0xf49, 0xf6c}, {0xf88, 0xf8c}, {0x1000, 0x102a}, {0x103f, 0x103f}, {0x1050, 0x1055}, {0x105a, 0x105d}, {0x1061, 0x1061}, {0x1065, 0x1066},
  {0x106e, 0x1070}, {0x1075, 0x1081}, {0x108e, 0x108e}, {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fc, 0x1248},
  {0x124a, 0x124d}, {0x1250, 0x1256}, {0x1258, 0x1258}, {0x125a, 0x125d}, {0x1260, 0x1288}, {0x128a, 0x128d}, {0x1290, 0x12b0}, {0x12b2, 0x12b5},
  {0x12b8, 0x12be}, {0x12c0, 0x12c0}, {0x12c2, 0x12c5}, {0x12c8, 0x12d6}, {0x12d8, 0x1310}, {0x1312, 0x1315}, {0x1318, 0x135a}, {0x1380, 0x138f},
  {0x13a0, 0x13f5}, {0x13f8, 0x13fd}, {0x1401, 0x166c}, {0x166f, 0x167f}, {0x1681, 0x169a}, {0x16a0, 0x16ea}, {0x16ee, 0x16f8}, {0x1700, 0x1711},
  {0x171f, 0x1731}, {0x1740, 0x1751}, {0x1760, 0x176c}, {0x176e, 0x1770}, {0x1780, 0x17b3}, {0x17d7, 0x17d7}, {0x17dc, 0x17dc}, {0x1820, 0x1878},
  {0x1880, 0x18a8}, {0x18aa, 0x18aa}, {0x18b0, 0x18f5}, {0x1900, 0x191e}, {0x1950, 0x196d}, {0x1970, 0x1974}, {0x1980, 0x19ab}, {0x19b0, 0x19c9},
  {0x1a00, 0x1a16}, {0x1a20, 0x1a54}, {0x1aa7, 0x1aa7}, {0x1b05, 0x1b33}, {0x1b45, 0x1b4c}, {0x1b83, 0x1ba0}, {0x1bae, 0x1baf}, {0x1bba, 0x1be5},
  {0x1c00, 0x1c23}, {0x1c4d, 0x1c4f}, {0x1c5a, 0x1c7d}, {0x1c80, 0x1c88}, {0x1c90, 0x1cba}, {0x1cbd, 0x1cbf}, {0x1ce9, 0x1cec}, {0x1cee, 0x1cf3},
  {0x1cf5, 0x1cf6}, {0x1cfa, 0x1cfa}, {0x1d00, 0x1dbf}, {0x1e00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57},
  {0x1f59, 0x1f59}, {0x1f5b, 0x1f5b}, {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d}, {0x1f80, 0x1fb4}, {0x1fb6, 0x1fbc}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4},
  {0x1fc6, 0x1fcc}, {0x1fd0, 0x1fd3}, {0x1fd6, 0x1fdb}, {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffc}, {0x2071, 0x2071}, {0x207f, 0x207f},
  {0x2090, 0x209c}, {0x2102, 0x2102}, {0x2107, 0x2107}, {0x210a, 0x2113}, {0x2115, 0x2115}, {0x2118, 0x211d}, {0x2124, 0x2124}, {0x2126, 0x2126},
  {0x2128, 0x2128}, {0x212a, 0x2139}, {0x213c, 0x213f}, {0x2145, 0x2149}, {0x214e, 0x214e}, {0x2160, 0x2188}, {0x2c00, 0x2ce4}, {0x2ceb, 0x2cee},
  {0x2cf2, 0x2cf3}, {0x2d00, 0x2d25}, {0x2d27, 0x2d27}, {0x2d2d, 0x2d2d}, {0x2d30, 0x2d67}, {0x2d6f, 0x2d6f}, {0x2d80, 0x2d96}, {0x2da0, 0x2da6},
  {0x2da8, 0x2dae}, {0x2db0, 0x2db6}, {0x2db8, 0x2dbe}, {0x2dc0, 0x2dc6}, {0x2dc8, 0x2dce}, {0x2dd0, 0x2dd6}, {0x2dd8, 0x2dde}, {0x3005, 0x3007},
  {0x3021, 0x3029}, {0x3031, 0x3035}, {0x3038, 0x303c}, {0x3041, 0x3096}, {0x309d, 0x309f}, {0x30a1, 0x30fa}, {0x30fc, 0x30ff}, {0x3105, 0x312f},
  {0x3131, 0x318e}, {0x31a0, 0x31bf}, {0x31f0, 0x31ff}, {0x3400, 0x4dbf}, {0x4e00, 0xa48c}, {0xa4d0, 0xa4fd}, {0xa500, 0xa60c}, {0xa610, 0xa61f},
  {0xa62a, 0xa62b}, {0xa640, 0xa66e}, {0xa67f, 0xa69d}, {0xa6a0, 0xa6ef}, {0xa717, 0xa71f}, {0xa722, 0xa788}, {0xa78b, 0xa7ca}, {0xa7d0, 0xa7d1},
  {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9}, {0xa7f2, 0xa801}, {0xa803, 0xa805}, {0xa807, 0xa80a}, {0xa80c, 0xa822}, {0xa840, 0xa873}, {0xa882, 0xa8b3},
  {0xa8f2, 0xa8f7}, {0xa8fb, 0xa8fb}, {0xa8fd, 0xa8fe}, {0xa90a, 0xa925}, {0xa930, 0xa946}, {0xa960, 0xa97c}, {0xa984, 0xa9b2}, {0xa9cf, 0xa9cf},
  {0xa9e0, 0xa9e4}, {0xa9e6, 0xa9ef}, {0xa9fa, 0xa9fe}, {0xaa00, 0xaa28}, {0xaa40, 0xaa42}, {0xaa44, 0xaa4b}, {0xaa60, 0xaa76}, {0xaa7a, 0xaa7a},
  {0xaa7e, 0xaaaf}, {0xaab1, 0xaab1}, {0xaab5, 0xaab6}, {0xaab9, 0xaabd}, {0xaac0, 0xaac0}, {0xaac2, 0xaac2}, {0xaadb, 0xaadd}, {0xaae0, 0xaaea},
  {0xaaf2, 0xaaf4}, {0xab01, 0xab06}, {0xab09, 0xab0e}, {0xab11, 0xab16}, {0xab20, 0xab26}, {0xab28, 0xab2e}, {0xab30, 0xab5a}, {0xab5c, 0xab69},
  {0xab70, 0xabe2}, {0xac00, 0xd7a3}, {0xd7b0, 0xd7c6}, {0xd7cb, 0xd7fb}, {0xf900, 0xfa6d}, {0xfa70, 0xfad9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17},
  {0xfb1d, 0xfb1d}, {0xfb1f, 0xfb28}, {0xfb2a, 0xfb36}, {0xfb38, 0xfb3c}, {0xfb3e, 0xfb3e}, {0xfb40, 0xfb41}, {0xfb43, 0xfb44}, {0xfb46, 0xfbb1},
  {0xfbd3, 0xfc5d}, {0xfc64, 0xfd3d}, {0xfd50, 0xfd8f}, {0xfd92, 0xfdc7}, {0xfdf0, 0xfdf9}, {0xfe71, 0xfe71}, {0xfe73, 0xfe73}, {0xfe77, 0xfe77},
  {0xfe79, 0xfe79}, {0xfe7b, 0xfe7b}, {0xfe7d, 0xfe7d}, {0xfe7f, 0xfefc}, {0xff21, 0xff3a}, {0xff41, 0xff5a}, {0xff66, 0xff9d}, {0xffa0, 0xffbe},
  {0xffc2, 0xffc7}, {0xffca, 0xffcf}, {0xffd2, 0xffd7}, {0xffda, 0xffdc}, {0x10000, 0x1000b}, {0x1000d, 0x10026}, {0x10028, 0x1003a}, {0x1003c, 0x1003d},
  {0x1003f, 0x1004d}, {0x10050, 0x1005d}, {0x10080, 0x100fa}, {0x10140, 0x10174}, {0x10280, 0x1029c}, {0x102a0, 0x102d0}, {0x10300, 0x1031f}, {0x1032d, 0x1034a},
  {0x10350, 0x10375}, {0x10380, 0x1039d}, {0x103a0, 0x103c3}, {0x103c8, 0x103cf}, {0x103d1, 0x103d5}, {0x10400, 0x1049d}, {0x104b0, 0x104d3}, {0x104d8, 0x104fb},
  {0x10500, 0x10527}, {0x10530, 0x10563}, {0x10570, 0x1057a}, {0x1057c, 0x1058a}, {0x1058c, 0x10592}, {0x10594, 0x10595}, {0x10597, 0x105a1}, {0x105a3, 0x105b1},
  {0x105b3, 0x105b9}, {0x105bb, 0x105bc}, {0x10600, 0x10736}, {0x10740, 0x10755}, {0x10760, 0x10767}, {0x10780, 0x10785}, {0x10787, 0x107b0}, {0x107b2, 0x107ba},
  {0x10800, 0x10805}, {0x10808, 0x10808}, {0x1080a, 0x10835}, {0x10837, 0x10838}, {0x1083c, 0x1083c}, {0x1083f, 0x10855}, {0x10860, 0x10876}, {0x10880, 0x1089e},
  {0x108e0, 0x108f2}, {0x108f4, 0x108f5}, {0x10900, 0x10915}, {0x10920, 0x10939}, {0x10980, 0x109b7}, {0x109be, 0x109bf}, {0x10a00, 0x10a00}, {0x10a10, 0x10a13},
  {0x10a15, 0x10a17}, {0x10a19, 0x10a35}, {0x10a60, 0x10a7c}, {0x10a80, 0x10a9c}, {0x10ac0, 0x10ac7}, {0x10ac9, 0x10ae4}, {0x10b00, 0x10b35}, {0x10b40, 0x10b55},
  {0x10b60, 0x10b72}, {0x10b80, 0x10b91}, {0x10c00, 0x10c48}, {0x10c80, 0x10cb2}, {0x10cc0, 0x10cf2}, {0x10d00, 0x10d23}, {0x10e80, 0x10ea9}, {0x10eb0, 0x10eb1},
  {0x10f00, 0x10f1c}, {0x10f27, 0x10f27}, {0x10f30, 0x10f45}, {0x10f70, 0x10f81}, {0x10fb0, 0x10fc4}, {0x10fe0, 0x10ff6}, {0x11003, 0x11037}, {0x11071, 0x11072},
  {0x11075, 0x11075}, {0x11083, 0x110af}, {0x110d0, 0x110e8}, {0x11103, 0x11126}, {0x11144, 0x11144}, {0x11147, 0x11147}, {0x11150, 0x11172}, {0x11176, 0x11176},
  {0x11183, 0x111b2}, {0x111c1, 0x111c4}, {0x111da, 0x111da}, {0x111dc, 0x111dc}, {0x11200, 0x11211}, {0x11213, 0x1122b}, {0x11280, 0x11286}, {0x11288, 0x11288},
  {0x1128a, 0x1128d}, {0x1128f, 0x1129d}, {0x1129f, 0x112a8}, {0x112b0, 0x112de}, {0x11305, 0x1130c}, {0x1130f, 0x11310}, {0x11313, 0x11328}, {0x1132a, 0x11330},
  {0x11332, 0x11333}, {0x11335, 0x11339}, {0x1133d, 0x1133d}, {0x11350, 0x11350}, {0x1135d, 0x11361}, {0x11400, 0x11434}, {0x11447, 0x1144a}, {0x1145f, 0x11461},
  {0x11480, 0x114af}, {0x114c4, 0x114c5}, {0x114c7, 0x114c7}, {0x11580, 0x115ae}, {0x115d8, 0x115db}, {0x11600, 0x1162f}, {0x11644, 0x11644}, {0x11680, 0x116aa},
  {0x116b8, 0x116b8}, {0x11700, 0x1171a}, {0x11740, 0x11746}, {0x11800, 0x1182b}, {0x118a0, 0x118df}, {0x118ff, 0x11906}, {0x11909, 0x11909}, {0x1190c, 0x11913},
  {0x11915, 0x11916}, {0x11918, 0x1192f}, {0x1193f, 0x1193f}, {0x11941, 0x11941}, {0x119a0, 0x119a7}, {0x119aa, 0x119d0}, {0x119e1, 0x119e1}, {0x119e3, 0x119e3},
  {0x11a00, 0x11a00}, {0x11a0b, 0x11a32}, {0x11a3a, 0x11a3a}, {0x11a50, 0x11a50}, {0x11a5c, 0x11a89}, {0x11a9d, 0x11a9d}, {0x11ab0, 0x11af8}, {0x11c00, 0x11c08},
  {0x11c0a, 0x11c2e}, {0x11c40, 0x11c40}, {0x11c72, 0x11c8f}, {0x11d00, 0x11d06}, {0x11d08, 0x11d09}, {0x11d0b, 0x11d30}, {0x11d46, 0x11d46}, {0x11d60, 0x11d65},
  {0x11d67, 0x11d68}, {0x11d6a, 0x11d89}, {0x11d98, 0x11d98}, {0x11ee0, 0x11ef2}, {0x11fb0, 0x11fb0}, {0x12000, 0x12399}, {0x12400, 0x1246e}, {0x12480, 0x12543},
  {0x12f90, 0x12ff0}, {0x13000, 0x1342e}, {0x14400, 0x14646}, {0x16800, 0x16a38}, {0x16a40, 0x16a5e}, {0x16a70, 0x16abe}, {0x16ad0, 0x16aed}, {0x16b00, 0x16b2f},
  {0x16b40, 0x16b43}, {0x16b63, 0x16b77}, {0x16b7d, 0x16b8f}, {0x16e40, 0x16e7f}, {0x16f00, 0x16f4a}, {0x16f50, 0x16f50}, {0x16f93, 0x16f9f}, {0x16fe0, 0x16fe1},
  {0x16fe3, 0x16fe3}, {0x17000, 0x187f7}, {0x18800, 0x18cd5}, {0x18d00, 0x18d08}, {0x1aff0, 0x1aff3}, {0x1aff5, 0x1affb}, {0x1affd, 0x1affe}, {0x1b000, 0x1b122},
  {0x1b150, 0x1b152}, {0x1b164, 0x1b167}, {0x1b170, 0x1b2fb}, {0x1bc00, 0x1bc6a}, {0x1bc70, 0x1bc7c}, {0x1bc80, 0x1bc88}, {0x1bc90, 0x1bc99}, {0x1d400, 0x1d454},
  {0x1d456, 0x1d49c}, {0x1d49e, 0x1d49f}, {0x1d4a2, 0x1d4a2}, {0x1d4a5, 0x1d4a6}, {0x1d4a9, 0x1d4ac}, {0x1d4ae, 0x1d4b9}, {0x1d4bb, 0x1d4bb}, {0x1d4bd, 0x1d4c3},
  {0x1d4c5, 0x1d505}, {0x1d507, 0x1d50a}, {0x1d50d, 0x1d514}, {0x1d516, 0x1d51c}, {0x1d51e, 0x1d539}, {0x1d53b, 0x1d53e}, {0x1d540, 0x1d544}, {0x1d546, 0x1d546},
  {0x1d54a, 0x1d550}, {0x1d552, 0x1d6a5}, {0x1d6a8, 0x1d6c0}, {0x1d6c2, 0x1d6da}, {0x1d6dc, 0x1d6fa}, {0x1d6fc, 0x1d714}, {0x1d716, 0x1d734}, {0x1d736, 0x1d74e},
  {0x1d750, 0x1d76e}, {0x1d770, 0x1d788}, {0x1d78a, 0x1d7a8}, {0x1d7aa, 0x1d7c2}, {0x1d7c4, 0x1d7cb}, {0x1df00, 0x1df1e}, {0x1e100, 0x1e12c}, {0x1e137, 0x1e13d},
  {0x1e14e, 0x1e14e}, {0x1e290, 0x1e2ad}, {0x1e2c0, 0x1e2eb}, {0x1e7e0, 0x1e7e6}, {0x1e7e8, 0x1e7eb}, {0x1e7ed, 0x1e7ee}, {0x1e7f0, 0x1e7fe}, {0x1e800, 0x1e8c4},
  {0x1e900, 0x1e943}, {0x1e94b, 0x1e94b}, {0x1ee00, 0x1ee03}, {0x1ee05, 0x1ee1f}, {0x1ee21, 0x1ee22}, {0x1ee24, 0x1ee24}, {0x1ee27, 0x1ee27}, {0x1ee29, 0x1ee32},
  {0x1ee34, 0x1ee37}, {0x1ee39, 0x1ee39}, {0x1ee3b, 0x1ee3b}, {0x1ee42, 0x1ee42}, {0x1ee47, 0x1ee47}, {0x1ee49, 0x1ee49}, {0x1ee4b, 0x1ee4b}, {0x1ee4d, 0x1ee4f},
  {0x1ee51, 0x1ee52}, {0x1ee54, 0x1ee54}, {0x1ee57, 0x1ee57}, {0x1ee59, 0x1ee59}, {0x1ee5b, 0x1ee5b}, {0x1ee5d, 0x1ee5d}, {0x1ee5f, 0x1ee5f}, {0x1ee61, 0x1ee62},
  {0x1ee64, 0x1ee64}, {0x1ee67, 0x1ee6a}, {0x1ee6c, 0x1ee72}, {0x1ee74, 0x1ee77}, {0x1ee79, 0x1ee7c}, {0x1ee7e, 0x1ee7e}, {0x1ee80, 0x1ee89}, {0x1ee8b, 0x1ee9b},
  {0x1eea1, 0x1eea3}, {0x1eea5, 0x1eea9}, {0x1eeab, 0x1eebb}, {0x20000, 0x2a6df}, {0x2a700, 0x2b738}, {0x2b740, 0x2b81d}, {0x2b820, 0x2cea1}, {0x2ceb0, 0x2ebe0},
  {0x2f800, 0x2fa1d}, {0x30000, 0x3134a},
};

static TSCharacterRange sym_identifier_character_set_2[] = {
  {'$', '$'}, {'0', '9'}, {'A', 'Z'}, {'\\', '\\'}, {'_', '_'}, {'a', 'z'}, {0xaa, 0xaa}, {0xb5, 0xb5},
  {0xb7, 0xb7}, {0xba, 0xba}, {0xc0, 0xd6}, {0xd8, 0xf6}, {0xf8, 0x2c1}, {0x2c6, 0x2d1}, {0x2e0, 0x2e4}, {0x2ec, 0x2ec},
  {0x2ee, 0x2ee}, {0x300, 0x374}, {0x376, 0x377}, {0x37b, 0x37d}, {0x37f, 0x37f}, {0x386, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1},
  {0x3a3, 0x3f5}, {0x3f7, 0x481}, {0x483, 0x487}, {0x48a, 0x52f}, {0x531, 0x556}, {0x559, 0x559}, {0x560, 0x588}, {0x591, 0x5bd},
  {0x5bf, 0x5bf}, {0x5c1, 0x5c2}, {0x5c4, 0x5c5}, {0x5c7, 0x5c7}, {0x5d0, 0x5ea}, {0x5ef, 0x5f2}, {0x610, 0x61a}, {0x620, 0x669},
  {0x66e, 0x6d3}, {0x6d5, 0x6dc}, {0x6df, 0x6e8}, {0x6ea, 0x6fc}, {0x6ff, 0x6ff}, {0x710, 0x74a}, {0x74d, 0x7b1}, {0x7c0, 0x7f5},
  {0x7fa, 0x7fa}, {0x7fd, 0x7fd}, {0x800, 0x82d}, {0x840, 0x85b}, {0x860, 0x86a}, {0x870, 0x887}, {0x889, 0x88e}, {0x898, 0x8e1},
  {0x8e3, 0x963}, {0x966, 0x96f}, {0x971, 0x983}, {0x985, 0x98c}, {0x98f, 0x990}, {0x993, 0x9a8}, {0x9aa, 0x9b0}, {0x9b2, 0x9b2},
  {0x9b6, 0x9b9}, {0x9bc, 0x9c4}, {0x9c7, 0x9c8}, {0x9cb, 0x9ce}, {0x9d7, 0x9d7}, {0x9dc, 0x9dd}, {0x9df, 0x9e3}, {0x9e6, 0x9f1},
  {0x9fc, 0x9fc}, {0x9fe, 0x9fe}, {0xa01, 0xa03}, {0xa05, 0xa0a}, {0xa0f, 0xa10}, {0xa13, 0xa28}, {0xa2a, 0xa30}, {0xa32, 0xa33},
  {0xa35, 0xa36}, {0xa38, 0xa39}, {0xa3c, 0xa3c}, {0xa3e, 0xa42}, {0xa47, 0xa48}, {0xa4b, 0xa4d}, {0xa51, 0xa51}, {0xa59, 0xa5c},
  {0xa5e, 0xa5e}, {0xa66, 0xa75}, {0xa81, 0xa83}, {0xa85, 0xa8d}, {0xa8f, 0xa91}, {0xa93, 0xaa8}, {0xaaa, 0xab0}, {0xab2, 0xab3},
  {0xab5, 0xab9}, {0xabc, 0xac5}, {0xac7, 0xac9}, {0xacb, 0xacd}, {0xad0, 0xad0}, {0xae0, 0xae3}, {0xae6, 0xaef}, {0xaf9, 0xaff},
  {0xb01, 0xb03}, {0xb05, 0xb0c}, {0xb0f, 0xb10}, {0xb13, 0xb28}, {0xb2a, 0xb30}, {0xb32, 0xb33}, {0xb35, 0xb39}, {0xb3c, 0xb44},
  {0xb47, 0xb48}, {0xb4b, 0xb4d}, {0xb55, 0xb57}, {0xb5c, 0xb5d}, {0xb5f, 0xb63}, {0xb66, 0xb6f}, {0xb71, 0xb71}, {0xb82, 0xb83},
  {0xb85, 0xb8a}, {0xb8e, 0xb90}, {0xb92, 0xb95}, {0xb99, 0xb9a}, {0xb9c, 0xb9c}, {0xb9e, 0xb9f}, {0xba3, 0xba4}, {0xba8, 0xbaa},
  {0xbae, 0xbb9}, {0xbbe, 0xbc2}, {0xbc6, 0xbc8}, {0xbca, 0xbcd}, {0xbd0, 0xbd0}, {0xbd7, 0xbd7}, {0xbe6, 0xbef}, {0xc00, 0xc0c},
  {0xc0e, 0xc10}, {0xc12, 0xc28}, {0xc2a, 0xc39}, {0xc3c, 0xc44}, {0xc46, 0xc48}, {0xc4a, 0xc4d}, {0xc55, 0xc56}, {0xc58, 0xc5a},
  {0xc5d, 0xc5d}, {0xc60, 0xc63}, {0xc66, 0xc6f}, {0xc80, 0xc83}, {0xc85, 0xc8c}, {0xc8e, 0xc90}, {0xc92, 0xca8}, {0xcaa, 0xcb3},
  {0xcb5, 0xcb9}, {0xcbc, 0xcc4}, {0xcc6, 0xcc8}, {0xcca, 0xccd}, {0xcd5, 0xcd6}, {0xcdd, 0xcde}, {0xce0, 0xce3}, {0xce6, 0xcef},
  {0xcf1, 0xcf2}, {0xd00, 0xd0c}, {0xd0e, 0xd10}, {0xd12, 0xd44}, {0xd46, 0xd48}, {0xd4a, 0xd4e}, {0xd54, 0xd57}, {0xd5f, 0xd63},
  {0xd66, 0xd6f}, {0xd7a, 0xd7f}, {0xd81, 0xd83}, {0xd85, 0xd96}, {0xd9a, 0xdb1}, {0xdb3, 0xdbb}, {0xdbd, 0xdbd}, {0xdc0, 0xdc6},
  {0xdca, 0xdca}, {0xdcf, 0xdd4}, {0xdd6, 0xdd6}, {0xdd8, 0xddf}, {0xde6, 0xdef}, {0xdf2, 0xdf3}, {0xe01, 0xe3a}, {0xe40, 0xe4e},
  {0xe50, 0xe59}, {0xe81, 0xe82}, {0xe84, 0xe84}, {0xe86, 0xe8a}, {0xe8c, 0xea3}, {0xea5, 0xea5}, {0xea7, 0xebd}, {0xec0, 0xec4},
  {0xec6, 0xec6}, {0xec8, 0xecd}, {0xed0, 0xed9}, {0xedc, 0xedf}, {0xf00, 0xf00}, {0xf18, 0xf19}, {0xf20, 0xf29}, {0xf35, 0xf35},
  {0xf37, 0xf37}, {0xf39, 0xf39}, {0xf3e, 0xf47}, {0xf49, 0xf6c}, {0xf71, 0xf84}, {0xf86, 0xf97}, {0xf99, 0xfbc}, {0xfc6, 0xfc6},
  {0x1000, 0x1049}, {0x1050, 0x109d}, {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fc, 0x1248}, {0x124a, 0x124d},
  {0x1250, 0x1256}, {0x1258, 0x1258}, {0x125a, 0x125d}, {0x1260, 0x1288}, {0x128a, 0x128d}, {0x1290, 0x12b0}, {0x12b2, 0x12b5}, {0x12b8, 0x12be},
  {0x12c0, 0x12c0}, {0x12c2, 0x12c5}, {0x12c8, 0x12d6}, {0x12d8, 0x1310}, {0x1312, 0x1315}, {0x1318, 0x135a}, {0x135d, 0x135f}, {0x1369, 0x1371},
  {0x1380, 0x138f}, {0x13a0, 0x13f5}, {0x13f8, 0x13fd}, {0x1401, 0x166c}, {0x166f, 0x167f}, {0x1681, 0x169a}, {0x16a0, 0x16ea}, {0x16ee, 0x16f8},
  {0x1700, 0x1715}, {0x171f, 0x1734}, {0x1740, 0x1753}, {0x1760, 0x176c}, {0x176e, 0x1770}, {0x1772, 0x1773}, {0x1780, 0x17d3}, {0x17d7, 0x17d7},
  {0x17dc, 0x17dd}, {0x17e0, 0x17e9}, {0x180b, 0x180d}, {0x180f, 0x1819}, {0x1820, 0x1878}, {0x1880, 0x18aa}, {0x18b0, 0x18f5}, {0x1900, 0x191e},
  {0x1920, 0x192b}, {0x1930, 0x193b}, {0x1946, 0x196d}, {0x1970, 0x1974}, {0x1980, 0x19ab}, {0x19b0, 0x19c9}, {0x19d0, 0x19da}, {0x1a00, 0x1a1b},
  {0x1a20, 0x1a5e}, {0x1a60, 0x1a7c}, {0x1a7f, 0x1a89}, {0x1a90, 0x1a99}, {0x1aa7, 0x1aa7}, {0x1ab0, 0x1abd}, {0x1abf, 0x1ace}, {0x1b00, 0x1b4c},
  {0x1b50, 0x1b59}, {0x1b6b, 0x1b73}, {0x1b80, 0x1bf3}, {0x1c00, 0x1c37}, {0x1c40, 0x1c49}, {0x1c4d, 0x1c7d}, {0x1c80, 0x1c88}, {0x1c90, 0x1cba},
  {0x1cbd, 0x1cbf}, {0x1cd0, 0x1cd2}, {0x1cd4, 0x1cfa}, {0x1d00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57},
  {0x1f59, 0x1f59}, {0x1f5b, 0x1f5b}, {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d}, {0x1f80, 0x1fb4}, {0x1fb6, 0x1fbc}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4},
  {0x1fc6, 0x1fcc}, {0x1fd0, 0x1fd3}, {0x1fd6, 0x1fdb}, {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffc}, {0x203f, 0x2040}, {0x2054, 0x2054},
  {0x2071, 0x2071}, {0x207f, 0x207f}, {0x2090, 0x209c}, {0x20d0, 0x20dc}, {0x20e1, 0x20e1}, {0x20e5, 0x20f0}, {0x2102, 0x2102}, {0x2107, 0x2107},
  {0x210a, 0x2113}, {0x2115, 0x2115}, {0x2118, 0x211d}, {0x2124, 0x2124}, {0x2126, 0x2126}, {0x2128, 0x2128}, {0x212a, 0x2139}, {0x213c, 0x213f},
  {0x2145, 0x2149}, {0x214e, 0x214e}, {0x2160, 0x2188}, {0x2c00, 0x2ce4}, {0x2ceb, 0x2cf3}, {0x2d00, 0x2d25}, {0x2d27, 0x2d27}, {0x2d2d, 0x2d2d},
  {0x2d30, 0x2d67}, {0x2d6f, 0x2d6f}, {0x2d7f, 0x2d96}, {0x2da0, 0x2da6}, {0x2da8, 0x2dae}, {0x2db0, 0x2db6}, {0x2db8, 0x2dbe}, {0x2dc0, 0x2dc6},
  {0x2dc8, 0x2dce}, {0x2dd0, 0x2dd6}, {0x2dd8, 0x2dde}, {0x2de0, 0x2dff}, {0x3005, 0x3007}, {0x3021, 0x302f}, {0x3031, 0x3035}, {0x3038, 0x303c},
  {0x3041, 0x3096}, {0x3099, 0x309a}, {0x309d, 0x309f}, {0x30a1, 0x30fa}, {0x30fc, 0x30ff}, {0x3105, 0x312f}, {0x3131, 0x318e}, {0x31a0, 0x31bf},
  {0x31f0, 0x31ff}, {0x3400, 0x4dbf}, {0x4e00, 0xa48c}, {0xa4d0, 0xa4fd}, {0xa500, 0xa60c}, {0xa610, 0xa62b}, {0xa640, 0xa66f}, {0xa674, 0xa67d},
  {0xa67f, 0xa6f1}, {0xa717, 0xa71f}, {0xa722, 0xa788}, {0xa78b, 0xa7ca}, {0xa7d0, 0xa7d1}, {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9}, {0xa7f2, 0xa827},
  {0xa82c, 0xa82c}, {0xa840, 0xa873}, {0xa880, 0xa8c5}, {0xa8d0, 0xa8d9}, {0xa8e0, 0xa8f7}, {0xa8fb, 0xa8fb}, {0xa8fd, 0xa92d}, {0xa930, 0xa953},
  {0xa960, 0xa97c}, {0xa980, 0xa9c0}, {0xa9cf, 0xa9d9}, {0xa9e0, 0xa9fe}, {0xaa00, 0xaa36}, {0xaa40, 0xaa4d}, {0xaa50, 0xaa59}, {0xaa60, 0xaa76},
  {0xaa7a, 0xaac2}, {0xaadb, 0xaadd}, {0xaae0, 0xaaef}, {0xaaf2, 0xaaf6}, {0xab01, 0xab06}, {0xab09, 0xab0e}, {0xab11, 0xab16}, {0xab20, 0xab26},
  {0xab28, 0xab2e}, {0xab30, 0xab5a}, {0xab5c, 0xab69}, {0xab70, 0xabea}, {0xabec, 0xabed}, {0xabf0, 0xabf9}, {0xac00, 0xd7a3}, {0xd7b0, 0xd7c6},
  {0xd7cb, 0xd7fb}, {0xf900, 0xfa6d}, {0xfa70, 0xfad9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17}, {0xfb1d, 0xfb28}, {0xfb2a, 0xfb36}, {0xfb38, 0xfb3c},
  {0xfb3e, 0xfb3e}, {0xfb40, 0xfb41}, {0xfb43, 0xfb44}, {0xfb46, 0xfbb1}, {0xfbd3, 0xfc5d}, {0xfc64, 0xfd3d}, {0xfd50, 0xfd8f}, {0xfd92, 0xfdc7},
  {0xfdf0, 0xfdf9}, {0xfe00, 0xfe0f}, {0xfe20, 0xfe2f}, {0xfe33, 0xfe34}, {0xfe4d, 0xfe4f}, {0xfe71, 0xfe71}, {0xfe73, 0xfe73}, {0xfe77, 0xfe77},
  {0xfe79, 0xfe79}, {0xfe7b, 0xfe7b}, {0xfe7d, 0xfe7d}, {0xfe7f, 0xfefc}, {0xff10, 0xff19}, {0xff21, 0xff3a}, {0xff3f, 0xff3f}, {0xff41, 0xff5a},
  {0xff66, 0xffbe}, {0xffc2, 0xffc7}, {0xffca, 0xffcf}, {0xffd2, 0xffd7}, {0xffda, 0xffdc}, {0x10000, 0x1000b}, {0x1000d, 0x10026}, {0x10028, 0x1003a},
  {0x1003c, 0x1003d}, {0x1003f, 0x1004d}, {0x10050, 0x1005d}, {0x10080, 0x100fa}, {0x10140, 0x10174}, {0x101fd, 0x101fd}, {0x10280, 0x1029c}, {0x102a0, 0x102d0},
  {0x102e0, 0x102e0}, {0x10300, 0x1031f}, {0x1032d, 0x1034a}, {0x10350, 0x1037a}, {0x10380, 0x1039d}, {0x103a0, 0x103c3}, {0x103c8, 0x103cf}, {0x103d1, 0x103d5},
  {0x10400, 0x1049d}, {0x104a0, 0x104a9}, {0x104b0, 0x104d3}, {0x104d8, 0x104fb}, {0x10500, 0x10527}, {0x10530, 0x10563}, {0x10570, 0x1057a}, {0x1057c, 0x1058a},
  {0x1058c, 0x10592}, {0x10594, 0x10595}, {0x10597, 0x105a1}, {0x105a3, 0x105b1}, {0x105b3, 0x105b9}, {0x105bb, 0x105bc}, {0x10600, 0x10736}, {0x10740, 0x10755},
  {0x10760, 0x10767}, {0x10780, 0x10785}, {0x10787, 0x107b0}, {0x107b2, 0x107ba}, {0x10800, 0x10805}, {0x10808, 0x10808}, {0x1080a, 0x10835}, {0x10837, 0x10838},
  {0x1083c, 0x1083c}, {0x1083f, 0x10855}, {0x10860, 0x10876}, {0x10880, 0x1089e}, {0x108e0, 0x108f2}, {0x108f4, 0x108f5}, {0x10900, 0x10915}, {0x10920, 0x10939},
  {0x10980, 0x109b7}, {0x109be, 0x109bf}, {0x10a00, 0x10a03}, {0x10a05, 0x10a06}, {0x10a0c, 0x10a13}, {0x10a15, 0x10a17}, {0x10a19, 0x10a35}, {0x10a38, 0x10a3a},
  {0x10a3f, 0x10a3f}, {0x10a60, 0x10a7c}, {0x10a80, 0x10a9c}, {0x10ac0, 0x10ac7}, {0x10ac9, 0x10ae6}, {0x10b00, 0x10b35}, {0x10b40, 0x10b55}, {0x10b60, 0x10b72},
  {0x10b80, 0x10b91}, {0x10c00, 0x10c48}, {0x10c80, 0x10cb2}, {0x10cc0, 0x10cf2}, {0x10d00, 0x10d27}, {0x10d30, 0x10d39}, {0x10e80, 0x10ea9}, {0x10eab, 0x10eac},
  {0x10eb0, 0x10eb1}, {0x10f00, 0x10f1c}, {0x10f27, 0x10f27}, {0x10f30, 0x10f50}, {0x10f70, 0x10f85}, {0x10fb0, 0x10fc4}, {0x10fe0, 0x10ff6}, {0x11000, 0x11046},
  {0x11066, 0x11075}, {0x1107f, 0x110ba}, {0x110c2, 0x110c2}, {0x110d0, 0x110e8}, {0x110f0, 0x110f9}, {0x11100, 0x11134}, {0x11136, 0x1113f}, {0x11144, 0x11147},
  {0x11150, 0x11173}, {0x11176, 0x11176}, {0x11180, 0x111c4}, {0x111c9, 0x111cc}, {0x111ce, 0x111da}, {0x111dc, 0x111dc}, {0x11200, 0x11211}, {0x11213, 0x11237},
  {0x1123e, 0x1123e}, {0x11280, 0x11286}, {0x11288, 0x11288}, {0x1128a, 0x1128d}, {0x1128f, 0x1129d}, {0x1129f, 0x112a8}, {0x112b0, 0x112ea}, {0x112f0, 0x112f9},
  {0x11300, 0x11303}, {0x11305, 0x1130c}, {0x1130f, 0x11310}, {0x11313, 0x11328}, {0x1132a, 0x11330}, {0x11332, 0x11333}, {0x11335, 0x11339}, {0x1133b, 0x11344},
  {0x11347, 0x11348}, {0x1134b, 0x1134d}, {0x11350, 0x11350}, {0x11357, 0x11357}, {0x1135d, 0x11363}, {0x11366, 0x1136c}, {0x11370, 0x11374}, {0x11400, 0x1144a},
  {0x11450, 0x11459}, {0x1145e, 0x11461}, {0x11480, 0x114c5}, {0x114c7, 0x114c7}, {0x114d0, 0x114d9}, {0x11580, 0x115b5}, {0x115b8, 0x115c0}, {0x115d8, 0x115dd},
  {0x11600, 0x11640}, {0x11644, 0x11644}, {0x11650, 0x11659}, {0x11680, 0x116b8}, {0x116c0, 0x116c9}, {0x11700, 0x1171a}, {0x1171d, 0x1172b}, {0x11730, 0x11739},
  {0x11740, 0x11746}, {0x11800, 0x1183a}, {0x118a0, 0x118e9}, {0x118ff, 0x11906}, {0x11909, 0x11909}, {0x1190c, 0x11913}, {0x11915, 0x11916}, {0x11918, 0x11935},
  {0x11937, 0x11938}, {0x1193b, 0x11943}, {0x11950, 0x11959}, {0x119a0, 0x119a7}, {0x119aa, 0x119d7}, {0x119da, 0x119e1}, {0x119e3, 0x119e4}, {0x11a00, 0x11a3e},
  {0x11a47, 0x11a47}, {0x11a50, 0x11a99}, {0x11a9d, 0x11a9d}, {0x11ab0, 0x11af8}, {0x11c00, 0x11c08}, {0x11c0a, 0x11c36}, {0x11c38, 0x11c40}, {0x11c50, 0x11c59},
  {0x11c72, 0x11c8f}, {0x11c92, 0x11ca7}, {0x11ca9, 0x11cb6}, {0x11d00, 0x11d06}, {0x11d08, 0x11d09}, {0x11d0b, 0x11d36}, {0x11d3a, 0x11d3a}, {0x11d3c, 0x11d3d},
  {0x11d3f, 0x11d47}, {0x11d50, 0x11d59}, {0x11d60, 0x11d65}, {0x11d67, 0x11d68}, {0x11d6a, 0x11d8e}, {0x11d90, 0x11d91}, {0x11d93, 0x11d98}, {0x11da0, 0x11da9},
  {0x11ee0, 0x11ef6}, {0x11fb0, 0x11fb0}, {0x12000, 0x12399}, {0x12400, 0x1246e}, {0x12480, 0x12543}, {0x12f90, 0x12ff0}, {0x13000, 0x1342e}, {0x14400, 0x14646},
  {0x16800, 0x16a38}, {0x16a40, 0x16a5e}, {0x16a60, 0x16a69}, {0x16a70, 0x16abe}, {0x16ac0, 0x16ac9}, {0x16ad0, 0x16aed}, {0x16af0, 0x16af4}, {0x16b00, 0x16b36},
  {0x16b40, 0x16b43}, {0x16b50, 0x16b59}, {0x16b63, 0x16b77}, {0x16b7d, 0x16b8f}, {0x16e40, 0x16e7f}, {0x16f00, 0x16f4a}, {0x16f4f, 0x16f87}, {0x16f8f, 0x16f9f},
  {0x16fe0, 0x16fe1}, {0x16fe3, 0x16fe4}, {0x16ff0, 0x16ff1}, {0x17000, 0x187f7}, {0x18800, 0x18cd5}, {0x18d00, 0x18d08}, {0x1aff0, 0x1aff3}, {0x1aff5, 0x1affb},
  {0x1affd, 0x1affe}, {0x1b000, 0x1b122}, {0x1b150, 0x1b152}, {0x1b164, 0x1b167}, {0x1b170, 0x1b2fb}, {0x1bc00, 0x1bc6a}, {0x1bc70, 0x1bc7c}, {0x1bc80, 0x1bc88},
  {0x1bc90, 0x1bc99}, {0x1bc9d, 0x1bc9e}, {0x1cf00, 0x1cf2d}, {0x1cf30, 0x1cf46}, {0x1d165, 0x1d169}, {0x1d16d, 0x1d172}, {0x1d17b, 0x1d182}, {0x1d185, 0x1d18b},
  {0x1d1aa, 0x1d1ad}, {0x1d242, 0x1d244}, {0x1d400, 0x1d454}, {0x1d456, 0x1d49c}, {0x1d49e, 0x1d49f}, {0x1d4a2, 0x1d4a2}, {0x1d4a5, 0x1d4a6}, {0x1d4a9, 0x1d4ac},
  {0x1d4ae, 0x1d4b9}, {0x1d4bb, 0x1d4bb}, {0x1d4bd, 0x1d4c3}, {0x1d4c5, 0x1d505}, {0x1d507, 0x1d50a}, {0x1d50d, 0x1d514}, {0x1d516, 0x1d51c}, {0x1d51e, 0x1d539},
  {0x1d53b, 0x1d53e}, {0x1d540, 0x1d544}, {0x1d546, 0x1d546}, {0x1d54a, 0x1d550}, {0x1d552, 0x1d6a5}, {0x1d6a8, 0x1d6c0}, {0x1d6c2, 0x1d6da}, {0x1d6dc, 0x1d6fa},
  {0x1d6fc, 0x1d714}, {0x1d716, 0x1d734}, {0x1d736, 0x1d74e}, {0x1d750, 0x1d76e}, {0x1d770, 0x1d788}, {0x1d78a, 0x1d7a8}, {0x1d7aa, 0x1d7c2}, {0x1d7c4, 0x1d7cb},
  {0x1d7ce, 0x1d7ff}, {0x1da00, 0x1da36}, {0x1da3b, 0x1da6c}, {0x1da75, 0x1da75}, {0x1da84, 0x1da84}, {0x1da9b, 0x1da9f}, {0x1daa1, 0x1daaf}, {0x1df00, 0x1df1e},
  {0x1e000, 0x1e006}, {0x1e008, 0x1e018}, {0x1e01b, 0x1e021}, {0x1e023, 0x1e024}, {0x1e026, 0x1e02a}, {0x1e100, 0x1e12c}, {0x1e130, 0x1e13d}, {0x1e140, 0x1e149},
  {0x1e14e, 0x1e14e}, {0x1e290, 0x1e2ae}, {0x1e2c0, 0x1e2f9}, {0x1e7e0, 0x1e7e6}, {0x1e7e8, 0x1e7eb}, {0x1e7ed, 0x1e7ee}, {0x1e7f0, 0x1e7fe}, {0x1e800, 0x1e8c4},
  {0x1e8d0, 0x1e8d6}, {0x1e900, 0x1e94b}, {0x1e950, 0x1e959}, {0x1ee00, 0x1ee03}, {0x1ee05, 0x1ee1f}, {0x1ee21, 0x1ee22}, {0x1ee24, 0x1ee24}, {0x1ee27, 0x1ee27},
  {0x1ee29, 0x1ee32}, {0x1ee34, 0x1ee37}, {0x1ee39, 0x1ee39}, {0x1ee3b, 0x1ee3b}, {0x1ee42, 0x1ee42}, {0x1ee47, 0x1ee47}, {0x1ee49, 0x1ee49}, {0x1ee4b, 0x1ee4b},
  {0x1ee4d, 0x1ee4f}, {0x1ee51, 0x1ee52}, {0x1ee54, 0x1ee54}, {0x1ee57, 0x1ee57}, {0x1ee59, 0x1ee59}, {0x1ee5b, 0x1ee5b}, {0x1ee5d, 0x1ee5d}, {0x1ee5f, 0x1ee5f},
  {0x1ee61, 0x1ee62}, {0x1ee64, 0x1ee64}, {0x1ee67, 0x1ee6a}, {0x1ee6c, 0x1ee72}, {0x1ee74, 0x1ee77}, {0x1ee79, 0x1ee7c}, {0x1ee7e, 0x1ee7e}, {0x1ee80, 0x1ee89},
  {0x1ee8b, 0x1ee9b}, {0x1eea1, 0x1eea3}, {0x1eea5, 0x1eea9}, {0x1eeab, 0x1eebb}, {0x1fbf0, 0x1fbf9}, {0x20000, 0x2a6df}, {0x2a700, 0x2b738}, {0x2b740, 0x2b81d},
  {0x2b820, 0x2cea1}, {0x2ceb0, 0x2ebe0}, {0x2f800, 0x2fa1d}, {0x30000, 0x3134a}, {0xe0100, 0xe01ef},
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(336);
      ADVANCE_MAP(
        '!', 403,
        '"', 530,
        '#', 283,
        '%', 427,
        '&', 437,
        '\'', 521,
        '(', 340,
        ')', 343,
        '*', 423,
        '+', 417,
        ',', 342,
        '-', 406,
        '.', 487,
        '/', 425,
        '0', 646,
        ':', 471,
        ';', 455,
        '<', 447,
        '=', 467,
        '>', 644,
        '?', 472,
        'B', 633,
        'F', 570,
        'L', 544,
        'R', 547,
        'T', 574,
        'U', 548,
        '[', 463,
        '\\', 2,
        ']', 465,
        '^', 434,
        'b', 616,
        'c', 595,
        'd', 612,
        'f', 579,
        'i', 609,
        'm', 581,
        'n', 629,
        'p', 626,
        's', 596,
        't', 621,
        'u', 551,
        'v', 613,
        '{', 459,
        '|', 431,
        '}', 460,
        '~', 404,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(334);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(161);
      END_STATE();
    case 2:
      if (lookahead == '\n') SKIP(161);
      if (lookahead == '\r') SKIP(1);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 3:
      if (lookahead == '\n') SKIP(170);
      END_STATE();
    case 4:
      if (lookahead == '\n') SKIP(170);
      if (lookahead == '\r') SKIP(3);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 5:
      if (lookahead == '\n') SKIP(169);
      END_STATE();
    case 6:
      if (lookahead == '\n') SKIP(169);
      if (lookahead == '\r') SKIP(5);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 7:
      if (lookahead == '\n') SKIP(172);
      END_STATE();
    case 8:
      if (lookahead == '\n') SKIP(172);
      if (lookahead == '\r') SKIP(7);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 9:
      if (lookahead == '\n') SKIP(171);
      END_STATE();
    case 10:
      if (lookahead == '\n') SKIP(171);
      if (lookahead == '\r') SKIP(9);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 11:
      if (lookahead == '\n') SKIP(173);
      END_STATE();
    case 12:
      if (lookahead == '\n') SKIP(173);
      if (lookahead == '\r') SKIP(11);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 13:
      if (lookahead == '\n') SKIP(164);
      END_STATE();
    case 14:
      if (lookahead == '\n') SKIP(164);
      if (lookahead == '\r') SKIP(13);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 15:
      if (lookahead == '\n') SKIP(165);
      END_STATE();
    case 16:
      if (lookahead == '\n') SKIP(165);
      if (lookahead == '\r') SKIP(15);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 17:
      if (lookahead == '\n') SKIP(174);
      END_STATE();
    case 18:
      if (lookahead == '\n') SKIP(174);
      if (lookahead == '\r') SKIP(17);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 19:
      if (lookahead == '\n') SKIP(237);
      END_STATE();
    case 20:
      if (lookahead == '\n') SKIP(237);
      if (lookahead == '\r') SKIP(19);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 21:
      if (lookahead == '\n') SKIP(193);
      END_STATE();
    case 22:
      if (lookahead == '\n') SKIP(193);
      if (lookahead == '\r') SKIP(21);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 23:
      if (lookahead == '\n') SKIP(238);
      END_STATE();
    case 24:
      if (lookahead == '\n') SKIP(238);
      if (lookahead == '\r') SKIP(23);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 25:
      if (lookahead == '\n') SKIP(167);
      END_STATE();
    case 26:
      if (lookahead == '\n') SKIP(167);
      if (lookahead == '\r') SKIP(25);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 27:
      if (lookahead == '\n') SKIP(186);
      END_STATE();
    case 28:
      if (lookahead == '\n') SKIP(186);
      if (lookahead == '\r') SKIP(27);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 29:
      if (lookahead == '\n') SKIP(182);
      END_STATE();
    case 30:
      if (lookahead == '\n') SKIP(182);
      if (lookahead == '\r') SKIP(29);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 31:
      if (lookahead == '\n') SKIP(175);
      END_STATE();
    case 32:
      if (lookahead == '\n') SKIP(175);
      if (lookahead == '\r') SKIP(31);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 33:
      if (lookahead == '\n') SKIP(194);
      END_STATE();
    case 34:
      if (lookahead == '\n') SKIP(194);
      if (lookahead == '\r') SKIP(33);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 35:
      if (lookahead == '\n') SKIP(192);
      END_STATE();
    case 36:
      if (lookahead == '\n') SKIP(192);
      if (lookahead == '\r') SKIP(35);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 37:
      if (lookahead == '\n') SKIP(223);
      END_STATE();
    case 38:
      if (lookahead == '\n') SKIP(223);
      if (lookahead == '\r') SKIP(37);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 39:
      if (lookahead == '\n') SKIP(183);
      END_STATE();
    case 40:
      if (lookahead == '\n') SKIP(183);
      if (lookahead == '\r') SKIP(39);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 41:
      if (lookahead == '\n') SKIP(187);
      END_STATE();
    case 42:
      if (lookahead == '\n') SKIP(187);
      if (lookahead == '\r') SKIP(41);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 43:
      if (lookahead == '\n') SKIP(177);
      END_STATE();
    case 44:
      if (lookahead == '\n') SKIP(177);
      if (lookahead == '\r') SKIP(43);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 45:
      if (lookahead == '\n') SKIP(203);
      END_STATE();
    case 46:
      if (lookahead == '\n') SKIP(203);
      if (lookahead == '\r') SKIP(45);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 47:
      if (lookahead == '\n') SKIP(178);
      END_STATE();
    case 48:
      if (lookahead == '\n') SKIP(178);
      if (lookahead == '\r') SKIP(47);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 49:
      if (lookahead == '\n') SKIP(207);
      END_STATE();
    case 50:
      if (lookahead == '\n') SKIP(207);
      if (lookahead == '\r') SKIP(49);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 51:
      if (lookahead == '\n') SKIP(224);
      END_STATE();
    case 52:
      if (lookahead == '\n') SKIP(224);
      if (lookahead == '\r') SKIP(51);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 53:
      if (lookahead == '\n') SKIP(198);
      END_STATE();
    case 54:
      if (lookahead == '\n') SKIP(198);
      if (lookahead == '\r') SKIP(53);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 55:
      if (lookahead == '\n') SKIP(202);
      END_STATE();
    case 56:
      if (lookahead == '\n') SKIP(202);
      if (lookahead == '\r') SKIP(55);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 57:
      if (lookahead == '\n') SKIP(184);
      END_STATE();
    case 58:
      if (lookahead == '\n') SKIP(184);
      if (lookahead == '\r') SKIP(57);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 59:
      if (lookahead == '\n') SKIP(228);
      END_STATE();
    case 60:
      if (lookahead == '\n') SKIP(228);
      if (lookahead == '\r') SKIP(59);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 61:
      if (lookahead == '\n') SKIP(188);
      END_STATE();
    case 62:
      if (lookahead == '\n') SKIP(188);
      if (lookahead == '\r') SKIP(61);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 63:
      if (lookahead == '\n') SKIP(210);
      END_STATE();
    case 64:
      if (lookahead == '\n') SKIP(210);
      if (lookahead == '\r') SKIP(63);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 65:
      if (lookahead == '\n') SKIP(236);
      END_STATE();
    case 66:
      if (lookahead == '\n') SKIP(236);
      if (lookahead == '\r') SKIP(65);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 67:
      if (lookahead == '\n') SKIP(239);
      END_STATE();
    case 68:
      if (lookahead == '\n') SKIP(239);
      if (lookahead == '\r') SKIP(67);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 69:
      if (lookahead == '\n') SKIP(201);
      END_STATE();
    case 70:
      if (lookahead == '\n') SKIP(201);
      if (lookahead == '\r') SKIP(69);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 71:
      if (lookahead == '\n') SKIP(208);
      END_STATE();
    case 72:
      if (lookahead == '\n') SKIP(208);
      if (lookahead == '\r') SKIP(71);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 73:
      if (lookahead == '\n') SKIP(227);
      END_STATE();
    case 74:
      if (lookahead == '\n') SKIP(227);
      if (lookahead == '\r') SKIP(73);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 75:
      if (lookahead == '\n') SKIP(231);
      END_STATE();
    case 76:
      if (lookahead == '\n') SKIP(231);
      if (lookahead == '\r') SKIP(75);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 77:
      if (lookahead == '\n') SKIP(242);
      END_STATE();
    case 78:
      if (lookahead == '\n') SKIP(242);
      if (lookahead == '\r') SKIP(77);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 79:
      if (lookahead == '\n') SKIP(217);
      END_STATE();
    case 80:
      if (lookahead == '\n') SKIP(217);
      if (lookahead == '\r') SKIP(79);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 81:
      if (lookahead == '\n') SKIP(168);
      END_STATE();
    case 82:
      if (lookahead == '\n') SKIP(168);
      if (lookahead == '\r') SKIP(81);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 83:
      if (lookahead == '\n') SKIP(209);
      END_STATE();
    case 84:
      if (lookahead == '\n') SKIP(209);
      if (lookahead == '\r') SKIP(83);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 85:
      if (lookahead == '\n') SKIP(216);
      END_STATE();
    case 86:
      if (lookahead == '\n') SKIP(216);
      if (lookahead == '\r') SKIP(85);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 87:
      if (lookahead == '\n') SKIP(240);
      END_STATE();
    case 88:
      if (lookahead == '\n') SKIP(240);
      if (lookahead == '\r') SKIP(87);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 89:
      if (lookahead == '\n') SKIP(243);
      END_STATE();
    case 90:
      if (lookahead == '\n') SKIP(243);
      if (lookahead == '\r') SKIP(89);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 91:
      if (lookahead == '\n') SKIP(222);
      END_STATE();
    case 92:
      if (lookahead == '\n') SKIP(222);
      if (lookahead == '\r') SKIP(91);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 93:
      if (lookahead == '\n') SKIP(241);
      END_STATE();
    case 94:
      if (lookahead == '\n') SKIP(241);
      if (lookahead == '\r') SKIP(93);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 95:
      if (lookahead == '\n') SKIP(248);
      END_STATE();
    case 96:
      if (lookahead == '\n') SKIP(248);
      if (lookahead == '\r') SKIP(95);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 97:
      if (lookahead == '\n') SKIP(176);
      END_STATE();
    case 98:
      if (lookahead == '\n') SKIP(176);
      if (lookahead == '\r') SKIP(97);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 99:
      if (lookahead == '\n') SKIP(101);
      END_STATE();
    case 100:
      if (lookahead == '\n') SKIP(101);
      if (lookahead == '\r') SKIP(99);
      END_STATE();
    case 101:
      ADVANCE_MAP(
        '\n', 345,
        '!', 270,
        '%', 426,
        '&', 436,
        '(', 401,
        '*', 422,
        '+', 415,
        '-', 405,
        '/', 424,
        '<', 450,
        '=', 271,
        '>', 441,
      );
      if (lookahead == '\\') SKIP(100);
      if (lookahead == '^') ADVANCE(433);
      if (lookahead == '|') ADVANCE(432);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(101);
      END_STATE();
    case 102:
      if (lookahead == '\n') SKIP(232);
      END_STATE();
    case 103:
      if (lookahead == '\n') SKIP(232);
      if (lookahead == '\r') SKIP(102);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 104:
      if (lookahead == '\n') SKIP(247);
      END_STATE();
    case 105:
      if (lookahead == '\n') SKIP(247);
      if (lookahead == '\r') SKIP(104);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 106:
      if (lookahead == '\n') SKIP(233);
      END_STATE();
    case 107:
      if (lookahead == '\n') SKIP(233);
      if (lookahead == '\r') SKIP(106);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 108:
      if (lookahead == '\n') SKIP(234);
      if (lookahead == '"') ADVANCE(530);
      if (lookahead == '/') ADVANCE(531);
      if (lookahead == '\\') ADVANCE(109);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(534);
      if (lookahead != 0) ADVANCE(535);
      END_STATE();
    case 109:
      if (lookahead == '\n') ADVANCE(537);
      if (lookahead == '\r') ADVANCE(536);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      if (lookahead == 'x') ADVANCE(320);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(539);
      if (lookahead != 0) ADVANCE(536);
      END_STATE();
    case 110:
      if (lookahead == '\n') SKIP(244);
      if (lookahead == '\'') ADVANCE(521);
      if (lookahead == '/') ADVANCE(524);
      if (lookahead == '\\') ADVANCE(523);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(525);
      if (lookahead != 0) ADVANCE(522);
      END_STATE();
    case 111:
      if (lookahead == '\n') ADVANCE(338);
      if (lookahead == '\r') ADVANCE(115);
      if (lookahead == '(') ADVANCE(340);
      if (lookahead == '/') ADVANCE(366);
      if (lookahead == '\\') ADVANCE(361);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(261);
      if (lookahead != 0) ADVANCE(368);
      END_STATE();
    case 112:
      if (lookahead == '\n') ADVANCE(338);
      if (lookahead == '\r') ADVANCE(115);
      if (lookahead == '/') ADVANCE(366);
      if (lookahead == '\\') ADVANCE(361);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(261);
      if (lookahead != 0) ADVANCE(368);
      END_STATE();
    case 113:
      if (lookahead == '\n') ADVANCE(338);
      if (lookahead == '\r') ADVANCE(114);
      if (lookahead == '(') ADVANCE(401);
      if (lookahead == '/') ADVANCE(252);
      if (lookahead == '\\') SKIP(117);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(249);
      END_STATE();
    case 114:
      if (lookahead == '\n') ADVANCE(338);
      if (lookahead == '(') ADVANCE(401);
      if (lookahead == '/') ADVANCE(252);
      if (lookahead == '\\') SKIP(117);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(249);
      END_STATE();
    case 115:
      if (lookahead == '\n') ADVANCE(338);
      if (lookahead == '/') ADVANCE(366);
      if (lookahead == '\\') ADVANCE(361);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(261);
      if (lookahead != 0) ADVANCE(368);
      END_STATE();
    case 116:
      if (lookahead == '\n') SKIP(249);
      END_STATE();
    case 117:
      if (lookahead == '\n') SKIP(249);
      if (lookahead == '\r') SKIP(116);
      END_STATE();
    case 118:
      if (lookahead == '\n') SKIP(162);
      END_STATE();
    case 119:
      if (lookahead == '\n') SKIP(162);
      if (lookahead == '\r') SKIP(118);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 120:
      if (lookahead == '\n') SKIP(166);
      END_STATE();
    case 121:
      if (lookahead == '\n') SKIP(166);
      if (lookahead == '\r') SKIP(120);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 122:
      if (lookahead == '\n') SKIP(197);
      END_STATE();
    case 123:
      if (lookahead == '\n') SKIP(197);
      if (lookahead == '\r') SKIP(122);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 124:
      if (lookahead == '\n') SKIP(180);
      END_STATE();
    case 125:
      if (lookahead == '\n') SKIP(180);
      if (lookahead == '\r') SKIP(124);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 126:
      if (lookahead == '\n') SKIP(214);
      END_STATE();
    case 127:
      if (lookahead == '\n') SKIP(214);
      if (lookahead == '\r') SKIP(126);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 128:
      if (lookahead == '\n') SKIP(225);
      END_STATE();
    case 129:
      if (lookahead == '\n') SKIP(225);
      if (lookahead == '\r') SKIP(128);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 130:
      if (lookahead == '\n') SKIP(195);
      END_STATE();
    case 131:
      if (lookahead == '\n') SKIP(195);
      if (lookahead == '\r') SKIP(130);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 132:
      if (lookahead == '\n') SKIP(218);
      END_STATE();
    case 133:
      if (lookahead == '\n') SKIP(218);
      if (lookahead == '\r') SKIP(132);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 134:
      if (lookahead == '\n') SKIP(190);
      END_STATE();
    case 135:
      if (lookahead == '\n') SKIP(190);
      if (lookahead == '\r') SKIP(134);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 136:
      if (lookahead == '\n') SKIP(200);
      END_STATE();
    case 137:
      if (lookahead == '\n') SKIP(200);
      if (lookahead == '\r') SKIP(136);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 138:
      if (lookahead == '\n') SKIP(215);
      END_STATE();
    case 139:
      if (lookahead == '\n') SKIP(215);
      if (lookahead == '\r') SKIP(138);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 140:
      if (lookahead == '\n') SKIP(220);
      END_STATE();
    case 141:
      if (lookahead == '\n') SKIP(220);
      if (lookahead == '\r') SKIP(140);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 142:
      if (lookahead == '\n') SKIP(212);
      END_STATE();
    case 143:
      if (lookahead == '\n') SKIP(212);
      if (lookahead == '\r') SKIP(142);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 144:
      if (lookahead == '\n') SKIP(163);
      END_STATE();
    case 145:
      if (lookahead == '\n') SKIP(163);
      if (lookahead == '\r') SKIP(144);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 146:
      if (lookahead == '\n') SKIP(204);
      END_STATE();
    case 147:
      if (lookahead == '\n') SKIP(204);
      if (lookahead == '\r') SKIP(146);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 148:
      if (lookahead == '\n') SKIP(206);
      END_STATE();
    case 149:
      if (lookahead == '\n') SKIP(206);
      if (lookahead == '\r') SKIP(148);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 150:
      if (lookahead == '\n') SKIP(226);
      END_STATE();
    case 151:
      if (lookahead == '\n') SKIP(226);
      if (lookahead == '\r') SKIP(150);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 152:
      if (lookahead == '\n') SKIP(221);
      END_STATE();
    case 153:
      if (lookahead == '\n') SKIP(221);
      if (lookahead == '\r') SKIP(152);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 154:
      if (lookahead == '\n') SKIP(213);
      END_STATE();
    case 155:
      if (lookahead == '\n') SKIP(213);
      if (lookahead == '\r') SKIP(154);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 156:
      if (lookahead == '\n') SKIP(196);
      END_STATE();
    case 157:
      if (lookahead == '\n') SKIP(196);
      if (lookahead == '\r') SKIP(156);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 158:
      if (lookahead == '\n') SKIP(230);
      END_STATE();
    case 159:
      if (lookahead == '\n') SKIP(230);
      if (lookahead == '\r') SKIP(158);
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 160:
      if (lookahead == '\r') ADVANCE(643);
      if (lookahead == '\\') ADVANCE(637);
      if (lookahead != 0) ADVANCE(642);
      END_STATE();
    case 161:
      ADVANCE_MAP(
        '!', 403,
        '"', 530,
        '#', 283,
        '%', 427,
        '&', 437,
        '\'', 521,
        '(', 401,
        ')', 343,
        '*', 423,
        '+', 417,
        ',', 342,
        '-', 406,
        '.', 487,
        '/', 425,
        '0', 646,
        ':', 471,
        ';', 455,
        '<', 447,
        '=', 467,
        '>', 644,
        '?', 472,
        'B', 633,
        'F', 570,
        'L', 544,
        'R', 547,
        'T', 574,
        'U', 548,
        '[', 463,
        '\\', 2,
        ']', 465,
        '^', 434,
        'b', 616,
        'c', 595,
        'd', 612,
        'f', 579,
        'i', 609,
        'm', 581,
        'n', 629,
        'p', 626,
        's', 596,
        't', 621,
        'u', 551,
        'v', 613,
        '{', 459,
        '|', 431,
        '}', 460,
        '~', 404,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(161);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 162:
      ADVANCE_MAP(
        '!', 403,
        '"', 530,
        '#', 292,
        '%', 427,
        '&', 437,
        '\'', 521,
        '(', 401,
        ')', 343,
        '*', 423,
        '+', 417,
        ',', 342,
        '-', 407,
        '.', 487,
        '/', 425,
        '0', 495,
        ':', 471,
        ';', 455,
        '<', 447,
        '=', 467,
        '>', 442,
        '?', 472,
        'B', 633,
        'F', 570,
        'L', 544,
        'R', 547,
        'T', 574,
        'U', 548,
        '[', 461,
        '\\', 119,
        ']', 465,
        '^', 434,
        'b', 616,
        'c', 595,
        'd', 612,
        'f', 579,
        'i', 609,
        'm', 581,
        'n', 629,
        'p', 626,
        's', 596,
        't', 621,
        'u', 551,
        'v', 613,
        '{', 459,
        '|', 431,
        '}', 460,
        '~', 404,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(162);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 163:
      ADVANCE_MAP(
        '!', 403,
        '"', 530,
        '#', 292,
        '%', 426,
        '&', 436,
        '\'', 521,
        '(', 401,
        ')', 343,
        '*', 422,
        '+', 418,
        ',', 342,
        '-', 408,
        '.', 487,
        '/', 424,
        '0', 495,
        ':', 471,
        ';', 455,
        '<', 449,
        '=', 271,
        '>', 441,
        '?', 472,
        'B', 633,
        'F', 570,
        'L', 544,
        'R', 547,
        'T', 574,
        'U', 548,
        '[', 461,
        '\\', 145,
        ']', 465,
        '^', 433,
        'b', 616,
        'c', 595,
        'd', 612,
        'f', 579,
        'i', 609,
        'm', 581,
        'n', 629,
        'p', 626,
        's', 596,
        't', 621,
        'u', 551,
        'v', 613,
        '{', 459,
        '|', 432,
        '}', 460,
        '~', 404,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(163);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 164:
      ADVANCE_MAP(
        '!', 403,
        '"', 530,
        '%', 427,
        '&', 437,
        '\'', 521,
        '(', 401,
        ')', 343,
        '*', 423,
        '+', 417,
        ',', 342,
        '-', 406,
        '.', 487,
        '/', 425,
        '0', 495,
        ':', 268,
        '<', 447,
        '=', 467,
        '>', 442,
        '?', 472,
        'B', 633,
        'F', 570,
        'L', 544,
        'R', 547,
        'T', 574,
        'U', 548,
        '[', 461,
        '\\', 14,
        '^', 434,
        'b', 616,
        'c', 595,
        'd', 612,
        'f', 579,
        'i', 609,
        'm', 581,
        'n', 629,
        'p', 626,
        's', 596,
        't', 621,
        'u', 551,
        'v', 613,
        '{', 459,
        '|', 431,
        '~', 404,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(164);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 165:
      ADVANCE_MAP(
        '!', 403,
        '"', 530,
        '%', 427,
        '&', 437,
        '\'', 521,
        '(', 401,
        '*', 423,
        '+', 417,
        ',', 342,
        '-', 407,
        '.', 487,
        '/', 425,
        '0', 495,
        ':', 268,
        '<', 447,
        '=', 467,
        '>', 644,
        '?', 472,
        'B', 633,
        'F', 570,
        'L', 544,
        'R', 547,
        'T', 574,
        'U', 548,
        '[', 461,
        '\\', 16,
        '^', 434,
        'b', 616,
        'c', 595,
        'd', 612,
        'f', 579,
        'i', 609,
        'm', 581,
        'n', 629,
        'p', 626,
        's', 596,
        't', 621,
        'u', 551,
        'v', 613,
        '{', 459,
        '|', 431,
        '~', 404,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(165);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 166:
      ADVANCE_MAP(
        '!', 403,
        '"', 530,
        '%', 426,
        '&', 436,
        '\'', 521,
        '(', 401,
        '*', 422,
        '+', 418,
        ',', 342,
        '-', 408,
        '.', 487,
        '/', 424,
        '0', 495,
        ':', 268,
        '<', 449,
        '=', 271,
        '>', 644,
        '?', 472,
        'B', 633,
        'F', 570,
        'L', 544,
        'R', 547,
        'T', 574,
        'U', 548,
        '[', 461,
        '\\', 121,
        '^', 433,
        'b', 616,
        'c', 595,
        'd', 612,
        'f', 579,
        'i', 609,
        'm', 581,
        'n', 629,
        'p', 626,
        's', 596,
        't', 621,
        'u', 551,
        'v', 613,
        '{', 459,
        '|', 432,
        '~', 404,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(166);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 167:
      ADVANCE_MAP(
        '!', 403,
        '"', 235,
        '%', 427,
        '&', 437,
        '(', 250,
        '*', 423,
        '+', 419,
        ',', 342,
        '-', 410,
        '/', 425,
        ':', 268,
        '<', 447,
        '=', 467,
        '>', 442,
        '[', 280,
        '\\', 26,
        '^', 434,
        'b', 616,
        'c', 595,
        'd', 612,
        'f', 608,
        'i', 609,
        'm', 581,
        'n', 629,
        'p', 626,
        's', 596,
        'u', 601,
        'v', 613,
        '|', 431,
        '~', 404,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(167);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 168:
      ADVANCE_MAP(
        '!', 403,
        '"', 235,
        '%', 427,
        '&', 437,
        '(', 250,
        '*', 423,
        '+', 419,
        ',', 342,
        '-', 410,
        '/', 425,
        '<', 447,
        '=', 467,
        '>', 442,
        '[', 281,
        '\\', 82,
        '^', 434,
        '|', 431,
        '~', 404,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(168);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 169:
      ADVANCE_MAP(
        '!', 402,
        '"', 530,
        '#', 283,
        '&', 436,
        '\'', 521,
        '(', 401,
        '*', 422,
        '+', 418,
        ',', 342,
        '-', 409,
        '.', 312,
        '/', 252,
        '0', 495,
        ':', 268,
        ';', 455,
        '<', 269,
        '>', 272,
        'B', 633,
        'F', 570,
        'L', 544,
        'R', 547,
        'T', 574,
        'U', 548,
        '[', 462,
        '\\', 6,
        'b', 616,
        'c', 595,
        'd', 612,
        'f', 579,
        'i', 609,
        'm', 581,
        'n', 629,
        'p', 626,
        's', 596,
        't', 621,
        'u', 551,
        'v', 613,
        '{', 459,
        '|', 430,
        '~', 404,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(169);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 170:
      ADVANCE_MAP(
        '!', 402,
        '"', 530,
        '#', 287,
        '%', 426,
        '&', 436,
        '\'', 521,
        '(', 401,
        ')', 343,
        '*', 422,
        '+', 418,
        ',', 342,
        '-', 409,
        '.', 489,
        '/', 424,
        '0', 495,
        ':', 471,
        ';', 455,
        '<', 446,
        '=', 466,
        '>', 644,
        'B', 633,
        'F', 570,
        'L', 544,
        'R', 547,
        'T', 574,
        'U', 548,
        '[', 462,
        '\\', 4,
        ']', 282,
        '^', 433,
        'b', 616,
        'c', 595,
        'd', 612,
        'f', 579,
        'i', 609,
        'm', 581,
        'n', 629,
        'p', 626,
        's', 596,
        't', 621,
        'u', 551,
        'v', 613,
        '{', 459,
        '|', 306,
        '}', 460,
        '~', 404,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(170);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 171:
      ADVANCE_MAP(
        '!', 402,
        '"', 530,
        '#', 291,
        '&', 435,
        '\'', 521,
        '(', 401,
        ')', 343,
        '*', 422,
        '+', 418,
        '-', 409,
        '.', 258,
        '/', 252,
        '0', 495,
        ':', 268,
        ';', 455,
        '>', 440,
        'B', 633,
        'F', 570,
        'L', 544,
        'R', 547,
        'T', 574,
        'U', 548,
        '[', 462,
        '\\', 10,
        'b', 616,
        'c', 595,
        'd', 612,
        'f', 579,
        'i', 609,
        'm', 581,
        'n', 629,
        'p', 626,
        's', 596,
        't', 621,
        'u', 551,
        'v', 613,
        '{', 459,
        '~', 404,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(171);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 172:
      ADVANCE_MAP(
        '!', 402,
        '"', 530,
        '#', 285,
        '&', 436,
        '\'', 521,
        '(', 401,
        '*', 422,
        '+', 418,
        ',', 342,
        '-', 409,
        '.', 312,
        '/', 252,
        '0', 495,
        ':', 268,
        ';', 455,
        '>', 274,
        'B', 633,
        'F', 570,
        'L', 544,
        'R', 547,
        'T', 574,
        'U', 548,
        '[', 462,
        '\\', 8,
        'b', 616,
        'c', 595,
        'd', 612,
        'f', 579,
        'i', 609,
        'm', 581,
        'n', 629,
        'p', 626,
        's', 596,
        't', 621,
        'u', 551,
        'v', 613,
        '{', 459,
        '~', 404,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(172);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 173:
      ADVANCE_MAP(
        '!', 402,
        '"', 530,
        '&', 436,
        '\'', 521,
        '(', 401,
        ')', 343,
        '*', 422,
        '+', 418,
        ',', 342,
        '-', 409,
        '.', 488,
        '/', 252,
        '0', 495,
        ':', 268,
        ';', 455,
        '<', 446,
        '=', 466,
        '>', 644,
        'B', 633,
        'F', 570,
        'L', 544,
        'R', 547,
        'T', 574,
        'U', 548,
        '[', 461,
        '\\', 12,
        'b', 616,
        'c', 595,
        'd', 612,
        'f', 579,
        'i', 609,
        'm', 581,
        'n', 629,
        'p', 626,
        's', 596,
        't', 621,
        'u', 551,
        'v', 613,
        '{', 459,
        '~', 404,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(173);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 174:
      ADVANCE_MAP(
        '!', 402,
        '"', 530,
        '&', 435,
        '\'', 521,
        '(', 401,
        ')', 343,
        '*', 422,
        '+', 418,
        ',', 342,
        '-', 409,
        '.', 488,
        '/', 252,
        '0', 495,
        ':', 471,
        ';', 455,
        '<', 446,
        '=', 466,
        '>', 644,
        'B', 633,
        'F', 570,
        'L', 544,
        'R', 547,
        'T', 574,
        'U', 548,
        '[', 461,
        '\\', 18,
        ']', 465,
        'b', 616,
        'c', 595,
        'd', 612,
        'f', 579,
        'i', 609,
        'm', 581,
        'n', 629,
        'p', 626,
        's', 596,
        't', 621,
        'u', 551,
        'v', 613,
        '{', 459,
        '}', 460,
        '~', 404,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(174);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 175:
      ADVANCE_MAP(
        '!', 402,
        '"', 530,
        '&', 435,
        '\'', 521,
        '(', 401,
        '*', 422,
        '+', 418,
        '-', 409,
        '.', 312,
        '/', 252,
        '0', 646,
        ':', 268,
        'B', 633,
        'F', 570,
        'L', 544,
        'R', 547,
        'T', 574,
        'U', 548,
        '[', 461,
        '\\', 32,
        'b', 616,
        'c', 595,
        'd', 612,
        'f', 579,
        'i', 609,
        'm', 581,
        'n', 629,
        'p', 626,
        's', 596,
        't', 621,
        'u', 551,
        'v', 613,
        '{', 459,
        '~', 404,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(175);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 176:
      ADVANCE_MAP(
        '!', 402,
        '\'', 521,
        '(', 401,
        ')', 343,
        '+', 420,
        '-', 413,
        '.', 312,
        '/', 252,
        '0', 495,
        'B', 633,
        'L', 562,
        'U', 563,
        '\\', 98,
        'u', 564,
        '~', 404,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(176);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 177:
      ADVANCE_MAP(
        '!', 270,
        '"', 530,
        '#', 292,
        '%', 427,
        '&', 437,
        '(', 401,
        ')', 343,
        '*', 423,
        '+', 419,
        ',', 342,
        '-', 411,
        '.', 486,
        '/', 425,
        ':', 471,
        ';', 455,
        '<', 447,
        '=', 467,
        '>', 442,
        '?', 472,
        'L', 545,
        'R', 547,
        'U', 549,
        '[', 461,
        '\\', 44,
        ']', 465,
        '^', 434,
        'u', 552,
        '{', 459,
        '|', 431,
        '}', 460,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(177);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 178:
      ADVANCE_MAP(
        '!', 270,
        '"', 530,
        '#', 292,
        '%', 427,
        '&', 437,
        '(', 401,
        ')', 343,
        '*', 423,
        '+', 419,
        ',', 342,
        '-', 411,
        '.', 486,
        '/', 425,
        ':', 470,
        ';', 455,
        '<', 447,
        '=', 467,
        '>', 442,
        '?', 472,
        'L', 545,
        'R', 547,
        'U', 549,
        '[', 461,
        '\\', 48,
        ']', 465,
        '^', 434,
        'u', 552,
        '|', 431,
        '}', 460,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(178);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 179:
      ADVANCE_MAP(
        '!', 270,
        '"', 530,
        '#', 292,
        '%', 427,
        '&', 437,
        '(', 401,
        ')', 343,
        '*', 423,
        '+', 419,
        ',', 342,
        '-', 411,
        '.', 486,
        '/', 425,
        ':', 470,
        ';', 455,
        '<', 447,
        '=', 467,
        '>', 442,
        '?', 472,
        'L', 656,
        'R', 657,
        'U', 658,
        '[', 461,
        '\\', 48,
        ']', 465,
        '^', 434,
        'u', 659,
        '|', 431,
        '}', 460,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(178);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 180:
      ADVANCE_MAP(
        '!', 270,
        '"', 530,
        '#', 292,
        '%', 426,
        '&', 436,
        '(', 401,
        ')', 343,
        '*', 422,
        '+', 416,
        ',', 342,
        '-', 412,
        '.', 486,
        '/', 424,
        ':', 470,
        ';', 455,
        '<', 449,
        '=', 271,
        '>', 441,
        '?', 472,
        'L', 545,
        'R', 547,
        'U', 549,
        '[', 461,
        '\\', 125,
        ']', 465,
        '^', 433,
        'u', 552,
        '|', 432,
        '}', 460,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(180);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 181:
      ADVANCE_MAP(
        '!', 270,
        '"', 530,
        '#', 292,
        '%', 426,
        '&', 436,
        '(', 401,
        ')', 343,
        '*', 422,
        '+', 416,
        ',', 342,
        '-', 412,
        '.', 486,
        '/', 424,
        ':', 470,
        ';', 455,
        '<', 449,
        '=', 271,
        '>', 441,
        '?', 472,
        'L', 656,
        'R', 657,
        'U', 658,
        '[', 461,
        '\\', 125,
        ']', 465,
        '^', 433,
        'u', 659,
        '|', 432,
        '}', 460,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(180);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 182:
      ADVANCE_MAP(
        '!', 270,
        '"', 530,
        '%', 427,
        '&', 437,
        '(', 401,
        ')', 343,
        '*', 423,
        '+', 419,
        ',', 342,
        '-', 410,
        '.', 486,
        '/', 425,
        ':', 268,
        '<', 447,
        '=', 467,
        '>', 442,
        '?', 472,
        'L', 545,
        'R', 547,
        'U', 549,
        '[', 462,
        '\\', 30,
        '^', 434,
        'u', 552,
        '{', 459,
        '|', 431,
        '~', 404,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(182);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 183:
      ADVANCE_MAP(
        '!', 270,
        '"', 530,
        '%', 427,
        '&', 437,
        '(', 401,
        ')', 343,
        '*', 423,
        '+', 419,
        ',', 342,
        '-', 410,
        '.', 486,
        '/', 425,
        ':', 268,
        '<', 447,
        '=', 467,
        '>', 442,
        '?', 472,
        'L', 545,
        'R', 547,
        'U', 549,
        '[', 461,
        '\\', 40,
        '^', 434,
        'u', 552,
        '{', 459,
        '|', 431,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(183);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 184:
      ADVANCE_MAP(
        '!', 270,
        '"', 530,
        '%', 427,
        '&', 437,
        '(', 401,
        ')', 343,
        '*', 423,
        '+', 419,
        ',', 342,
        '-', 410,
        '.', 486,
        '/', 425,
        '<', 447,
        '=', 467,
        '>', 442,
        '?', 472,
        'L', 545,
        'R', 547,
        'U', 549,
        '[', 461,
        '\\', 58,
        '^', 434,
        'u', 552,
        '|', 431,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(184);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 185:
      ADVANCE_MAP(
        '!', 270,
        '"', 530,
        '%', 427,
        '&', 437,
        '(', 401,
        ')', 343,
        '*', 423,
        '+', 419,
        ',', 342,
        '-', 410,
        '.', 486,
        '/', 425,
        '<', 447,
        '=', 467,
        '>', 442,
        '?', 472,
        'L', 656,
        'R', 657,
        'U', 658,
        '[', 461,
        '\\', 58,
        '^', 434,
        'u', 659,
        '|', 431,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(184);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 186:
      ADVANCE_MAP(
        '!', 270,
        '"', 530,
        '%', 427,
        '&', 437,
        '(', 401,
        ')', 343,
        '*', 423,
        '+', 419,
        ',', 342,
        '-', 411,
        '.', 486,
        '/', 425,
        ':', 471,
        ';', 455,
        '<', 447,
        '=', 467,
        '>', 442,
        '?', 472,
        'L', 545,
        'R', 547,
        'U', 549,
        '[', 462,
        '\\', 28,
        '^', 434,
        'u', 552,
        '{', 459,
        '|', 431,
        '}', 460,
        '~', 404,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(186);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 187:
      ADVANCE_MAP(
        '!', 270,
        '"', 530,
        '%', 427,
        '&', 437,
        '(', 401,
        '*', 423,
        '+', 419,
        ',', 342,
        '-', 411,
        '.', 486,
        '/', 425,
        ':', 268,
        '<', 447,
        '=', 467,
        '>', 644,
        '?', 472,
        'L', 545,
        'R', 547,
        'U', 549,
        '[', 461,
        '\\', 42,
        '^', 434,
        'u', 552,
        '{', 459,
        '|', 431,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(187);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 188:
      ADVANCE_MAP(
        '!', 270,
        '"', 530,
        '%', 427,
        '&', 437,
        '(', 401,
        '*', 423,
        '+', 419,
        ',', 342,
        '-', 411,
        '.', 486,
        '/', 425,
        '<', 447,
        '=', 467,
        '>', 644,
        '?', 472,
        'L', 545,
        'R', 547,
        'U', 549,
        '[', 461,
        '\\', 62,
        '^', 434,
        'u', 552,
        '|', 431,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(188);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 189:
      ADVANCE_MAP(
        '!', 270,
        '"', 530,
        '%', 427,
        '&', 437,
        '(', 401,
        '*', 423,
        '+', 419,
        ',', 342,
        '-', 411,
        '.', 486,
        '/', 425,
        '<', 447,
        '=', 467,
        '>', 644,
        '?', 472,
        'L', 656,
        'R', 657,
        'U', 658,
        '[', 461,
        '\\', 62,
        '^', 434,
        'u', 659,
        '|', 431,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(188);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 190:
      ADVANCE_MAP(
        '!', 270,
        '"', 530,
        '%', 426,
        '&', 436,
        '(', 401,
        '*', 422,
        '+', 416,
        ',', 342,
        '-', 412,
        '.', 486,
        '/', 424,
        '<', 449,
        '=', 271,
        '>', 644,
        '?', 472,
        'L', 545,
        'R', 547,
        'U', 549,
        '[', 461,
        '\\', 135,
        '^', 433,
        'u', 552,
        '|', 432,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(190);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 191:
      ADVANCE_MAP(
        '!', 270,
        '"', 530,
        '%', 426,
        '&', 436,
        '(', 401,
        '*', 422,
        '+', 416,
        ',', 342,
        '-', 412,
        '.', 486,
        '/', 424,
        '<', 449,
        '=', 271,
        '>', 644,
        '?', 472,
        'L', 656,
        'R', 657,
        'U', 658,
        '[', 461,
        '\\', 135,
        '^', 433,
        'u', 659,
        '|', 432,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(190);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 192:
      ADVANCE_MAP(
        '!', 270,
        '#', 303,
        '%', 427,
        '&', 437,
        '(', 401,
        ')', 343,
        '*', 423,
        '+', 419,
        ',', 342,
        '-', 410,
        '.', 486,
        '/', 425,
        ':', 268,
        ';', 455,
        '<', 447,
        '=', 467,
        '>', 442,
        '?', 472,
        '[', 462,
        '\\', 36,
        '^', 434,
        '{', 459,
        '|', 431,
        '}', 460,
        '~', 404,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(192);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 193:
      ADVANCE_MAP(
        '!', 270,
        '#', 288,
        '%', 426,
        '&', 436,
        '(', 401,
        ')', 343,
        '*', 422,
        '+', 415,
        ',', 342,
        '-', 405,
        '/', 424,
        ':', 268,
        ';', 455,
        '<', 450,
        '=', 271,
        '>', 441,
        '[', 462,
        '\\', 22,
        '^', 433,
        'b', 616,
        'c', 595,
        'd', 612,
        'f', 608,
        'i', 609,
        'm', 581,
        'n', 629,
        'p', 626,
        's', 596,
        'u', 601,
        'v', 613,
        '|', 432,
        '}', 460,
        '~', 404,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(193);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 194:
      ADVANCE_MAP(
        '!', 270,
        '#', 292,
        '%', 427,
        '&', 437,
        '(', 401,
        ')', 343,
        '*', 423,
        '+', 419,
        ',', 342,
        '-', 411,
        '.', 486,
        '/', 425,
        '0', 645,
        ':', 471,
        ';', 455,
        '<', 447,
        '=', 467,
        '>', 442,
        '?', 472,
        '[', 462,
        '\\', 34,
        '^', 434,
        '{', 459,
        '|', 431,
        '}', 460,
        '~', 404,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(194);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 195:
      ADVANCE_MAP(
        '!', 270,
        '#', 292,
        '%', 427,
        '&', 437,
        '(', 401,
        ')', 343,
        '*', 423,
        '+', 419,
        ',', 342,
        '-', 411,
        '.', 486,
        '/', 425,
        ':', 471,
        ';', 455,
        '<', 447,
        '=', 467,
        '>', 442,
        '?', 472,
        '[', 461,
        '\\', 131,
        ']', 465,
        '^', 434,
        '{', 459,
        '|', 431,
        '}', 460,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(195);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 196:
      ADVANCE_MAP(
        '!', 270,
        '#', 292,
        '%', 427,
        '&', 437,
        '(', 401,
        ')', 343,
        '*', 423,
        '+', 419,
        ',', 342,
        '-', 411,
        '.', 486,
        '/', 425,
        ':', 470,
        ';', 455,
        '<', 447,
        '=', 467,
        '>', 442,
        '?', 472,
        '[', 462,
        '\\', 157,
        ']', 465,
        '^', 434,
        '{', 459,
        '|', 431,
        '}', 460,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(196);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 197:
      ADVANCE_MAP(
        '!', 270,
        '#', 292,
        '%', 427,
        '&', 437,
        '(', 401,
        ')', 343,
        '*', 423,
        '+', 419,
        ',', 342,
        '-', 411,
        '.', 486,
        '/', 425,
        ':', 470,
        ';', 455,
        '<', 447,
        '=', 467,
        '>', 442,
        '?', 472,
        '[', 461,
        '\\', 123,
        ']', 465,
        '^', 434,
        'b', 616,
        'c', 595,
        'd', 612,
        'f', 608,
        'i', 609,
        'm', 581,
        'n', 629,
        'p', 626,
        's', 596,
        'u', 601,
        'v', 613,
        '{', 459,
        '|', 431,
        '}', 460,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(197);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 198:
      ADVANCE_MAP(
        '!', 270,
        '#', 292,
        '%', 427,
        '&', 437,
        '(', 401,
        ')', 343,
        '*', 423,
        '+', 419,
        ',', 342,
        '-', 411,
        '.', 486,
        '/', 425,
        ':', 470,
        ';', 455,
        '<', 447,
        '=', 467,
        '>', 442,
        '?', 472,
        '[', 461,
        '\\', 54,
        ']', 465,
        '^', 434,
        '{', 459,
        '|', 431,
        '}', 460,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(198);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 199:
      ADVANCE_MAP(
        '!', 270,
        '#', 292,
        '%', 427,
        '&', 437,
        '(', 401,
        ')', 343,
        '*', 423,
        '+', 419,
        ',', 342,
        '-', 411,
        '.', 486,
        '/', 425,
        ':', 470,
        ';', 455,
        '<', 447,
        '=', 467,
        '>', 442,
        '?', 472,
        '[', 461,
        '\\', 137,
        ']', 465,
        '^', 434,
        '|', 431,
        '}', 460,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(200);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 200:
      ADVANCE_MAP(
        '!', 270,
        '#', 292,
        '%', 427,
        '&', 437,
        '(', 401,
        ')', 343,
        '*', 423,
        '+', 419,
        ',', 342,
        '-', 411,
        '.', 486,
        '/', 425,
        ':', 470,
        ';', 455,
        '<', 447,
        '=', 467,
        '>', 442,
        '?', 472,
        '[', 461,
        '\\', 137,
        ']', 465,
        '^', 434,
        '|', 431,
        '}', 460,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(200);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 201:
      ADVANCE_MAP(
        '!', 270,
        '#', 292,
        '%', 427,
        '&', 437,
        '(', 401,
        ')', 343,
        '*', 423,
        '+', 419,
        ',', 342,
        '-', 411,
        '.', 486,
        '/', 425,
        ':', 470,
        ';', 455,
        '<', 447,
        '=', 467,
        '>', 442,
        '?', 472,
        '[', 464,
        '\\', 70,
        ']', 465,
        '^', 434,
        '|', 431,
        '}', 460,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(201);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 202:
      ADVANCE_MAP(
        '!', 270,
        '#', 292,
        '%', 426,
        '&', 436,
        '(', 401,
        ')', 343,
        '*', 422,
        '+', 416,
        ',', 342,
        '-', 412,
        '.', 486,
        '/', 424,
        ':', 471,
        ';', 455,
        '<', 449,
        '=', 271,
        '>', 441,
        '?', 472,
        '[', 461,
        '\\', 56,
        ']', 465,
        '^', 433,
        '{', 459,
        '|', 432,
        '}', 460,
        '~', 404,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(202);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 203:
      ADVANCE_MAP(
        '!', 270,
        '#', 292,
        '%', 426,
        '&', 436,
        '(', 401,
        ')', 343,
        '*', 422,
        '+', 416,
        ',', 342,
        '-', 412,
        '.', 486,
        '/', 424,
        ':', 470,
        ';', 455,
        '<', 449,
        '=', 271,
        '>', 441,
        '?', 472,
        '[', 461,
        '\\', 46,
        ']', 465,
        '^', 433,
        'b', 616,
        'c', 595,
        'd', 612,
        'f', 608,
        'i', 609,
        'm', 581,
        'n', 629,
        'p', 626,
        's', 596,
        'u', 601,
        'v', 613,
        '{', 459,
        '|', 432,
        '}', 460,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(203);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 204:
      ADVANCE_MAP(
        '!', 270,
        '#', 292,
        '%', 426,
        '&', 436,
        '(', 401,
        ')', 343,
        '*', 422,
        '+', 416,
        ',', 342,
        '-', 412,
        '.', 486,
        '/', 424,
        ':', 470,
        ';', 455,
        '<', 449,
        '=', 271,
        '>', 441,
        '?', 472,
        '[', 461,
        '\\', 147,
        ']', 465,
        '^', 433,
        '{', 459,
        '|', 432,
        '}', 460,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(204);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 205:
      ADVANCE_MAP(
        '!', 270,
        '#', 292,
        '%', 426,
        '&', 436,
        '(', 401,
        ')', 343,
        '*', 422,
        '+', 416,
        ',', 342,
        '-', 412,
        '.', 486,
        '/', 424,
        ':', 470,
        ';', 455,
        '<', 449,
        '=', 271,
        '>', 441,
        '?', 472,
        '[', 461,
        '\\', 149,
        ']', 465,
        '^', 433,
        '|', 432,
        '}', 460,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(206);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 206:
      ADVANCE_MAP(
        '!', 270,
        '#', 292,
        '%', 426,
        '&', 436,
        '(', 401,
        ')', 343,
        '*', 422,
        '+', 416,
        ',', 342,
        '-', 412,
        '.', 486,
        '/', 424,
        ':', 470,
        ';', 455,
        '<', 449,
        '=', 271,
        '>', 441,
        '?', 472,
        '[', 461,
        '\\', 149,
        ']', 465,
        '^', 433,
        '|', 432,
        '}', 460,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(206);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 207:
      ADVANCE_MAP(
        '!', 270,
        '%', 427,
        '&', 437,
        '(', 401,
        ')', 343,
        '*', 423,
        '+', 419,
        ',', 342,
        '-', 410,
        '.', 486,
        '/', 425,
        ':', 471,
        ';', 455,
        '<', 447,
        '=', 467,
        '>', 442,
        '?', 472,
        '[', 461,
        '\\', 50,
        '^', 434,
        '{', 459,
        '|', 431,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(207);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 208:
      ADVANCE_MAP(
        '!', 270,
        '%', 427,
        '&', 437,
        '(', 401,
        ')', 343,
        '*', 423,
        '+', 419,
        ',', 342,
        '-', 410,
        '.', 486,
        '/', 425,
        ':', 470,
        '<', 447,
        '=', 467,
        '>', 442,
        '?', 472,
        '[', 461,
        '\\', 72,
        '^', 434,
        '{', 459,
        '|', 431,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(208);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 209:
      ADVANCE_MAP(
        '!', 270,
        '%', 427,
        '&', 437,
        '(', 401,
        ')', 343,
        '*', 423,
        '+', 419,
        ',', 342,
        '-', 410,
        '.', 486,
        '/', 425,
        '<', 447,
        '=', 467,
        '>', 442,
        '?', 472,
        '[', 463,
        '\\', 84,
        '^', 434,
        '|', 431,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(209);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 210:
      ADVANCE_MAP(
        '!', 270,
        '%', 427,
        '&', 437,
        '(', 401,
        ')', 343,
        '*', 423,
        '+', 419,
        ',', 342,
        '-', 410,
        '.', 486,
        '/', 425,
        '<', 447,
        '=', 467,
        '>', 442,
        '?', 472,
        '[', 461,
        '\\', 64,
        '^', 434,
        'b', 616,
        'c', 595,
        'd', 612,
        'f', 608,
        'i', 609,
        'm', 581,
        'n', 629,
        'p', 626,
        's', 596,
        'u', 601,
        'v', 613,
        '{', 459,
        '|', 431,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(210);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 211:
      ADVANCE_MAP(
        '!', 270,
        '%', 427,
        '&', 437,
        '(', 401,
        ')', 343,
        '*', 423,
        '+', 419,
        ',', 342,
        '-', 410,
        '.', 486,
        '/', 425,
        '<', 447,
        '=', 467,
        '>', 442,
        '?', 472,
        '[', 461,
        '\\', 143,
        '^', 434,
        '|', 431,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(212);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 212:
      ADVANCE_MAP(
        '!', 270,
        '%', 427,
        '&', 437,
        '(', 401,
        ')', 343,
        '*', 423,
        '+', 419,
        ',', 342,
        '-', 410,
        '.', 486,
        '/', 425,
        '<', 447,
        '=', 467,
        '>', 442,
        '?', 472,
        '[', 461,
        '\\', 143,
        '^', 434,
        '|', 431,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(212);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 213:
      ADVANCE_MAP(
        '!', 270,
        '%', 427,
        '&', 437,
        '(', 401,
        ')', 343,
        '*', 423,
        '+', 419,
        ',', 342,
        '-', 410,
        '.', 486,
        '/', 425,
        '<', 447,
        '=', 467,
        '>', 442,
        '?', 472,
        '[', 464,
        '\\', 155,
        '^', 434,
        '|', 431,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(213);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 214:
      ADVANCE_MAP(
        '!', 270,
        '%', 427,
        '&', 437,
        '(', 401,
        ')', 343,
        '*', 423,
        '+', 419,
        ',', 342,
        '-', 411,
        '.', 486,
        '/', 425,
        ':', 471,
        ';', 455,
        '<', 447,
        '=', 467,
        '>', 644,
        '?', 472,
        '[', 461,
        '\\', 127,
        '^', 434,
        '{', 459,
        '|', 431,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(214);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 215:
      ADVANCE_MAP(
        '!', 270,
        '%', 427,
        '&', 437,
        '(', 401,
        '*', 423,
        '+', 419,
        ',', 342,
        '-', 411,
        '.', 486,
        '/', 425,
        ':', 470,
        '<', 447,
        '=', 467,
        '>', 644,
        '?', 472,
        '[', 461,
        '\\', 139,
        '^', 434,
        '{', 459,
        '|', 431,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(215);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 216:
      ADVANCE_MAP(
        '!', 270,
        '%', 427,
        '&', 437,
        '(', 401,
        '*', 423,
        '+', 419,
        ',', 342,
        '-', 411,
        '.', 486,
        '/', 425,
        ';', 455,
        '<', 447,
        '=', 467,
        '>', 442,
        '?', 472,
        '[', 463,
        '\\', 86,
        '^', 434,
        '|', 431,
        '}', 460,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(216);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 217:
      ADVANCE_MAP(
        '!', 270,
        '%', 427,
        '&', 437,
        '(', 401,
        '*', 423,
        '+', 419,
        ',', 342,
        '-', 411,
        '.', 486,
        '/', 425,
        '<', 447,
        '=', 467,
        '>', 644,
        '?', 472,
        '[', 462,
        '\\', 80,
        '^', 434,
        '|', 431,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(217);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 218:
      ADVANCE_MAP(
        '!', 270,
        '%', 427,
        '&', 437,
        '(', 401,
        '*', 423,
        '+', 419,
        ',', 342,
        '-', 411,
        '.', 486,
        '/', 425,
        '<', 447,
        '=', 467,
        '>', 644,
        '?', 472,
        '[', 461,
        '\\', 133,
        '^', 434,
        'b', 616,
        'c', 595,
        'd', 612,
        'f', 608,
        'i', 609,
        'm', 581,
        'n', 629,
        'p', 626,
        's', 596,
        'u', 601,
        'v', 613,
        '{', 459,
        '|', 431,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(218);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 219:
      ADVANCE_MAP(
        '!', 270,
        '%', 427,
        '&', 437,
        '(', 401,
        '*', 423,
        '+', 419,
        ',', 342,
        '-', 411,
        '.', 486,
        '/', 425,
        '<', 447,
        '=', 467,
        '>', 644,
        '?', 472,
        '[', 461,
        '\\', 141,
        '^', 434,
        '|', 431,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(220);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 220:
      ADVANCE_MAP(
        '!', 270,
        '%', 427,
        '&', 437,
        '(', 401,
        '*', 423,
        '+', 419,
        ',', 342,
        '-', 411,
        '.', 486,
        '/', 425,
        '<', 447,
        '=', 467,
        '>', 644,
        '?', 472,
        '[', 461,
        '\\', 141,
        '^', 434,
        '|', 431,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(220);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 221:
      ADVANCE_MAP(
        '!', 270,
        '%', 427,
        '&', 437,
        '(', 401,
        '*', 423,
        '+', 419,
        ',', 342,
        '-', 411,
        '.', 486,
        '/', 425,
        '<', 447,
        '=', 467,
        '>', 644,
        '?', 472,
        '[', 464,
        '\\', 153,
        '^', 434,
        '|', 431,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(221);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 222:
      ADVANCE_MAP(
        '!', 270,
        '%', 427,
        '&', 437,
        '*', 423,
        '+', 421,
        ',', 342,
        '-', 414,
        '.', 251,
        '/', 425,
        '<', 448,
        '=', 467,
        '>', 442,
        '\\', 92,
        '^', 434,
        '|', 431,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(222);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 223:
      ADVANCE_MAP(
        '!', 270,
        '%', 426,
        '&', 436,
        '(', 401,
        ')', 343,
        '*', 422,
        '+', 416,
        ',', 342,
        '-', 412,
        '.', 486,
        '/', 424,
        ':', 471,
        ';', 455,
        '<', 449,
        '=', 467,
        '>', 441,
        '?', 472,
        '[', 462,
        '\\', 38,
        '^', 433,
        '{', 459,
        '|', 432,
        '}', 460,
        '~', 404,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(223);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 224:
      ADVANCE_MAP(
        '!', 270,
        '%', 426,
        '&', 436,
        '(', 401,
        ')', 343,
        '*', 422,
        '+', 416,
        ',', 342,
        '-', 412,
        '.', 486,
        '/', 424,
        ':', 471,
        ';', 455,
        '<', 449,
        '=', 271,
        '>', 441,
        '?', 472,
        '[', 461,
        '\\', 52,
        ']', 465,
        '^', 433,
        'b', 616,
        'c', 595,
        'd', 612,
        'f', 608,
        'i', 609,
        'm', 581,
        'n', 629,
        'p', 626,
        's', 596,
        'u', 601,
        'v', 613,
        '{', 459,
        '|', 432,
        '}', 460,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(224);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 225:
      ADVANCE_MAP(
        '!', 270,
        '%', 426,
        '&', 436,
        '(', 401,
        ')', 343,
        '*', 422,
        '+', 416,
        ',', 342,
        '-', 412,
        '.', 486,
        '/', 424,
        ':', 268,
        ';', 455,
        '<', 449,
        '=', 271,
        '>', 441,
        '?', 472,
        '[', 461,
        '\\', 129,
        ']', 282,
        '^', 433,
        'b', 616,
        'c', 595,
        'd', 612,
        'f', 608,
        'i', 609,
        'm', 581,
        'n', 629,
        'p', 626,
        's', 596,
        'u', 601,
        'v', 613,
        '{', 459,
        '|', 432,
        '}', 460,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(225);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 226:
      ADVANCE_MAP(
        '!', 270,
        '%', 426,
        '&', 436,
        '(', 401,
        '*', 422,
        '+', 416,
        ',', 342,
        '-', 412,
        '.', 486,
        '/', 424,
        ':', 471,
        '<', 449,
        '=', 271,
        '>', 644,
        '?', 472,
        '[', 461,
        '\\', 151,
        '^', 433,
        '{', 459,
        '|', 432,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(226);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 227:
      ADVANCE_MAP(
        '!', 270,
        '%', 426,
        '&', 436,
        '(', 401,
        '*', 422,
        '+', 416,
        ',', 342,
        '-', 412,
        '.', 486,
        '/', 424,
        ':', 470,
        '<', 449,
        '=', 271,
        '>', 644,
        '?', 472,
        '[', 461,
        '\\', 74,
        '^', 433,
        '{', 459,
        '|', 432,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(227);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 228:
      ADVANCE_MAP(
        '!', 270,
        '%', 426,
        '&', 436,
        '(', 401,
        '*', 422,
        '+', 416,
        ',', 342,
        '-', 412,
        '.', 486,
        '/', 424,
        '<', 449,
        '=', 271,
        '>', 644,
        '?', 472,
        '[', 461,
        '\\', 60,
        '^', 433,
        'b', 616,
        'c', 595,
        'd', 612,
        'f', 608,
        'i', 609,
        'm', 581,
        'n', 629,
        'p', 626,
        's', 596,
        'u', 601,
        'v', 613,
        '{', 459,
        '|', 432,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(228);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 229:
      ADVANCE_MAP(
        '!', 270,
        '%', 426,
        '&', 436,
        '(', 401,
        '*', 422,
        '+', 416,
        ',', 342,
        '-', 412,
        '.', 486,
        '/', 424,
        '<', 449,
        '=', 271,
        '>', 644,
        '?', 472,
        '[', 461,
        '\\', 159,
        '^', 433,
        '|', 432,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(230);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 230:
      ADVANCE_MAP(
        '!', 270,
        '%', 426,
        '&', 436,
        '(', 401,
        '*', 422,
        '+', 416,
        ',', 342,
        '-', 412,
        '.', 486,
        '/', 424,
        '<', 449,
        '=', 271,
        '>', 644,
        '?', 472,
        '[', 461,
        '\\', 159,
        '^', 433,
        '|', 432,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(230);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 231:
      ADVANCE_MAP(
        '"', 530,
        '&', 436,
        '(', 401,
        '*', 422,
        '/', 252,
        ':', 268,
        'L', 546,
        'U', 550,
        '[', 462,
        '\\', 76,
        'b', 616,
        'c', 595,
        'd', 612,
        'f', 608,
        'i', 609,
        'm', 581,
        'n', 629,
        'p', 626,
        's', 596,
        'u', 553,
        'v', 613,
        '~', 404,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(231);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 232:
      ADVANCE_MAP(
        '"', 530,
        ')', 343,
        ',', 342,
        '/', 252,
        ':', 470,
        'L', 545,
        'R', 547,
        'U', 549,
        '\\', 103,
        'u', 552,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(232);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 233:
      if (lookahead == '"') ADVANCE(530);
      if (lookahead == '/') ADVANCE(252);
      if (lookahead == '<') ADVANCE(276);
      if (lookahead == 'L') ADVANCE(546);
      if (lookahead == 'U') ADVANCE(550);
      if (lookahead == '\\') ADVANCE(107);
      if (lookahead == 'u') ADVANCE(554);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(233);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 234:
      if (lookahead == '"') ADVANCE(530);
      if (lookahead == '/') ADVANCE(252);
      if (lookahead == '\\') ADVANCE(109);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(234);
      END_STATE();
    case 235:
      if (lookahead == '"') ADVANCE(655);
      END_STATE();
    case 236:
      ADVANCE_MAP(
        '#', 292,
        '&', 436,
        '(', 401,
        ')', 343,
        '*', 422,
        ',', 342,
        '-', 275,
        '.', 257,
        '/', 252,
        ':', 471,
        ';', 455,
        '<', 446,
        '=', 466,
        '>', 644,
        '[', 461,
        '\\', 66,
        '{', 459,
        '|', 306,
        '~', 404,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(236);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 237:
      ADVANCE_MAP(
        '#', 284,
        '&', 436,
        '(', 401,
        ')', 343,
        '*', 422,
        '+', 415,
        ',', 342,
        '-', 275,
        '.', 257,
        '/', 252,
        ':', 471,
        ';', 455,
        '<', 446,
        '=', 466,
        '>', 644,
        '[', 462,
        '\\', 20,
        'b', 616,
        'c', 595,
        'd', 612,
        'f', 608,
        'i', 609,
        'm', 581,
        'n', 629,
        'p', 626,
        's', 596,
        'u', 601,
        'v', 613,
        '{', 459,
        '|', 306,
        '~', 404,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(237);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 238:
      ADVANCE_MAP(
        '#', 286,
        '&', 436,
        '(', 401,
        '*', 422,
        ',', 342,
        '/', 252,
        ':', 268,
        ';', 455,
        '[', 462,
        '\\', 24,
        'b', 616,
        'c', 595,
        'd', 612,
        'f', 608,
        'i', 609,
        'm', 581,
        'n', 629,
        'p', 626,
        's', 596,
        'u', 601,
        'v', 613,
        '~', 404,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(238);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 239:
      ADVANCE_MAP(
        '&', 436,
        '(', 401,
        ')', 343,
        '*', 422,
        ',', 342,
        '-', 275,
        '.', 257,
        '/', 252,
        ':', 471,
        ';', 455,
        '<', 446,
        '=', 466,
        '>', 644,
        '[', 462,
        '\\', 68,
        '{', 459,
        '|', 306,
        '~', 404,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(239);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 240:
      ADVANCE_MAP(
        '&', 436,
        '(', 401,
        ')', 343,
        '*', 422,
        ',', 342,
        '-', 275,
        '.', 257,
        '/', 252,
        ':', 470,
        ';', 455,
        '<', 446,
        '=', 466,
        '>', 644,
        '[', 462,
        '\\', 88,
        '{', 459,
        '|', 306,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(240);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 241:
      ADVANCE_MAP(
        '&', 436,
        '(', 401,
        ')', 343,
        '*', 422,
        ',', 342,
        '.', 257,
        '/', 252,
        ':', 470,
        ';', 455,
        '=', 466,
        '>', 644,
        '[', 461,
        '\\', 94,
        '{', 459,
        '|', 306,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(241);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 242:
      ADVANCE_MAP(
        '&', 436,
        '(', 401,
        ')', 343,
        '*', 422,
        ',', 342,
        '/', 252,
        ':', 470,
        ';', 455,
        '<', 446,
        '=', 466,
        '>', 644,
        '[', 462,
        '\\', 78,
        'b', 616,
        'c', 595,
        'd', 612,
        'f', 608,
        'i', 609,
        'm', 581,
        'n', 629,
        'p', 626,
        's', 596,
        'u', 601,
        'v', 613,
        '{', 459,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(242);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 243:
      ADVANCE_MAP(
        '&', 436,
        '(', 401,
        ')', 343,
        '*', 422,
        ',', 342,
        '/', 252,
        ';', 455,
        '=', 466,
        '>', 644,
        '[', 461,
        '\\', 90,
        'b', 616,
        'c', 595,
        'd', 612,
        'f', 608,
        'i', 609,
        'm', 581,
        'n', 629,
        'p', 626,
        's', 596,
        'u', 601,
        'v', 613,
        '{', 459,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(243);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 244:
      if (lookahead == '\'') ADVANCE(521);
      if (lookahead == '/') ADVANCE(252);
      if (lookahead == '\\') ADVANCE(109);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(244);
      END_STATE();
    case 245:
      if (lookahead == '\'') ADVANCE(317);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(307);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(245);
      END_STATE();
    case 246:
      if (lookahead == '\'') ADVANCE(313);
      if (lookahead == '.') ADVANCE(502);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(307);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(246);
      END_STATE();
    case 247:
      ADVANCE_MAP(
        '(', 401,
        ')', 343,
        ',', 342,
        '/', 252,
        ':', 470,
        ';', 455,
        '<', 446,
        '=', 466,
        '>', 644,
        '[', 463,
        '\\', 105,
        '{', 459,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(247);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 248:
      ADVANCE_MAP(
        '(', 401,
        '/', 252,
        ':', 268,
        'F', 570,
        'T', 574,
        '[', 461,
        '\\', 96,
        'f', 580,
        't', 621,
        '{', 459,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(248);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 249:
      if (lookahead == '(') ADVANCE(401);
      if (lookahead == '/') ADVANCE(252);
      if (lookahead == '\\') SKIP(117);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(249);
      END_STATE();
    case 250:
      if (lookahead == ')') ADVANCE(653);
      END_STATE();
    case 251:
      if (lookahead == '*') ADVANCE(490);
      END_STATE();
    case 252:
      if (lookahead == '*') ADVANCE(255);
      if (lookahead == '/') ADVANCE(642);
      END_STATE();
    case 253:
      if (lookahead == '*') ADVANCE(652);
      END_STATE();
    case 254:
      if (lookahead == '*') ADVANCE(254);
      if (lookahead == '/') ADVANCE(635);
      if (lookahead != 0) ADVANCE(255);
      END_STATE();
    case 255:
      if (lookahead == '*') ADVANCE(254);
      if (lookahead != 0) ADVANCE(255);
      END_STATE();
    case 256:
      if (lookahead == '*') ADVANCE(254);
      if (lookahead != 0) ADVANCE(359);
      END_STATE();
    case 257:
      if (lookahead == '.') ADVANCE(259);
      END_STATE();
    case 258:
      if (lookahead == '.') ADVANCE(259);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(494);
      END_STATE();
    case 259:
      if (lookahead == '.') ADVANCE(341);
      END_STATE();
    case 260:
      if (lookahead == '.') ADVANCE(317);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(500);
      END_STATE();
    case 261:
      if (lookahead == '/') ADVANCE(366);
      if (lookahead == '\\') ADVANCE(361);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(261);
      if (lookahead != 0) ADVANCE(368);
      END_STATE();
    case 262:
      if (lookahead == '1') ADVANCE(266);
      END_STATE();
    case 263:
      if (lookahead == '2') ADVANCE(493);
      END_STATE();
    case 264:
      if (lookahead == '2') ADVANCE(267);
      if (lookahead == '6') ADVANCE(493);
      END_STATE();
    case 265:
      if (lookahead == '4') ADVANCE(493);
      END_STATE();
    case 266:
      if (lookahead == '6') ADVANCE(493);
      END_STATE();
    case 267:
      if (lookahead == '8') ADVANCE(493);
      END_STATE();
    case 268:
      if (lookahead == ':') ADVANCE(456);
      END_STATE();
    case 269:
      if (lookahead == '<') ADVANCE(451);
      if (lookahead == '=') ADVANCE(444);
      END_STATE();
    case 270:
      if (lookahead == '=') ADVANCE(439);
      END_STATE();
    case 271:
      if (lookahead == '=') ADVANCE(438);
      END_STATE();
    case 272:
      if (lookahead == '=') ADVANCE(443);
      if (lookahead == '>') ADVANCE(453);
      END_STATE();
    case 273:
      if (lookahead == '=') ADVANCE(479);
      END_STATE();
    case 274:
      if (lookahead == '>') ADVANCE(273);
      END_STATE();
    case 275:
      if (lookahead == '>') ADVANCE(491);
      END_STATE();
    case 276:
      if (lookahead == '>') ADVANCE(540);
      if (lookahead == '\\') ADVANCE(277);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(276);
      END_STATE();
    case 277:
      if (lookahead == '>') ADVANCE(541);
      if (lookahead == '\\') ADVANCE(277);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(276);
      END_STATE();
    case 278:
      if (lookahead == 'F') ADVANCE(262);
      END_STATE();
    case 279:
      if (lookahead == 'U') ADVANCE(331);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 280:
      if (lookahead == '[') ADVANCE(457);
      if (lookahead == ']') ADVANCE(654);
      END_STATE();
    case 281:
      if (lookahead == ']') ADVANCE(654);
      END_STATE();
    case 282:
      if (lookahead == ']') ADVANCE(458);
      END_STATE();
    case 283:
      if (lookahead == 'd') ADVANCE(375);
      if (lookahead == 'e') ADVANCE(395);
      if (lookahead == 'i') ADVANCE(383);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(283);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(400);
      END_STATE();
    case 284:
      if (lookahead == 'd') ADVANCE(375);
      if (lookahead == 'e') ADVANCE(395);
      if (lookahead == 'i') ADVANCE(384);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(284);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(400);
      END_STATE();
    case 285:
      if (lookahead == 'd') ADVANCE(375);
      if (lookahead == 'e') ADVANCE(397);
      if (lookahead == 'i') ADVANCE(383);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(285);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(400);
      END_STATE();
    case 286:
      if (lookahead == 'd') ADVANCE(375);
      if (lookahead == 'e') ADVANCE(397);
      if (lookahead == 'i') ADVANCE(384);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(286);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(400);
      END_STATE();
    case 287:
      if (lookahead == 'd') ADVANCE(375);
      if (lookahead == 'i') ADVANCE(383);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(287);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(400);
      END_STATE();
    case 288:
      if (lookahead == 'd') ADVANCE(375);
      if (lookahead == 'i') ADVANCE(384);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(288);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(400);
      END_STATE();
    case 289:
      if (lookahead == 'd') ADVANCE(301);
      END_STATE();
    case 290:
      if (lookahead == 'd') ADVANCE(295);
      END_STATE();
    case 291:
      if (lookahead == 'e') ADVANCE(305);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(291);
      END_STATE();
    case 292:
      if (lookahead == 'e') ADVANCE(304);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(292);
      END_STATE();
    case 293:
      if (lookahead == 'e') ADVANCE(350);
      END_STATE();
    case 294:
      if (lookahead == 'e') ADVANCE(299);
      END_STATE();
    case 295:
      if (lookahead == 'e') ADVANCE(300);
      END_STATE();
    case 296:
      if (lookahead == 'f') ADVANCE(262);
      END_STATE();
    case 297:
      if (lookahead == 'f') ADVANCE(346);
      END_STATE();
    case 298:
      if (lookahead == 'f') ADVANCE(352);
      END_STATE();
    case 299:
      if (lookahead == 'f') ADVANCE(354);
      END_STATE();
    case 300:
      if (lookahead == 'f') ADVANCE(356);
      END_STATE();
    case 301:
      if (lookahead == 'i') ADVANCE(297);
      END_STATE();
    case 302:
      if (lookahead == 'i') ADVANCE(298);
      if (lookahead == 's') ADVANCE(293);
      END_STATE();
    case 303:
      if (lookahead == 'i') ADVANCE(384);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(303);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(400);
      END_STATE();
    case 304:
      if (lookahead == 'l') ADVANCE(302);
      if (lookahead == 'n') ADVANCE(289);
      END_STATE();
    case 305:
      if (lookahead == 'n') ADVANCE(289);
      END_STATE();
    case 306:
      if (lookahead == '|') ADVANCE(428);
      END_STATE();
    case 307:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(314);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(499);
      END_STATE();
    case 308:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(307);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(245);
      END_STATE();
    case 309:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(497);
      END_STATE();
    case 310:
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(246);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(496);
      END_STATE();
    case 311:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(498);
      END_STATE();
    case 312:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(494);
      END_STATE();
    case 313:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(246);
      END_STATE();
    case 314:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(499);
      END_STATE();
    case 315:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(634);
      END_STATE();
    case 316:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(500);
      END_STATE();
    case 317:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(245);
      END_STATE();
    case 318:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(536);
      END_STATE();
    case 319:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(315);
      END_STATE();
    case 320:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(318);
      END_STATE();
    case 321:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(319);
      END_STATE();
    case 322:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(320);
      END_STATE();
    case 323:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(321);
      END_STATE();
    case 324:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(322);
      END_STATE();
    case 325:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(323);
      END_STATE();
    case 326:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(324);
      END_STATE();
    case 327:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(325);
      END_STATE();
    case 328:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(326);
      END_STATE();
    case 329:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(327);
      END_STATE();
    case 330:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(328);
      END_STATE();
    case 331:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(329);
      END_STATE();
    case 332:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(330);
      END_STATE();
    case 333:
      if (lookahead != 0 &&
          lookahead != '*') ADVANCE(368);
      END_STATE();
    case 334:
      if (eof) ADVANCE(336);
      ADVANCE_MAP(
        '!', 403,
        '"', 530,
        '#', 283,
        '%', 427,
        '&', 437,
        '\'', 521,
        '(', 401,
        ')', 343,
        '*', 423,
        '+', 417,
        ',', 342,
        '-', 406,
        '.', 487,
        '/', 425,
        '0', 646,
        ':', 471,
        ';', 455,
        '<', 447,
        '=', 467,
        '>', 644,
        '?', 472,
        'B', 633,
        'F', 570,
        'L', 544,
        'R', 547,
        'T', 574,
        'U', 548,
        '[', 463,
        '\\', 2,
        ']', 465,
        '^', 434,
        'b', 616,
        'c', 595,
        'd', 612,
        'f', 579,
        'i', 609,
        'm', 581,
        'n', 629,
        'p', 626,
        's', 596,
        't', 621,
        'u', 551,
        'v', 613,
        '{', 459,
        '|', 431,
        '}', 460,
        '~', 404,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(334);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 335:
      if (eof) ADVANCE(336);
      ADVANCE_MAP(
        '!', 402,
        '"', 530,
        '#', 287,
        '%', 426,
        '&', 436,
        '\'', 521,
        '(', 401,
        ')', 343,
        '*', 422,
        '+', 418,
        ',', 342,
        '-', 409,
        '.', 489,
        '/', 424,
        '0', 495,
        ':', 471,
        ';', 455,
        '<', 446,
        '=', 466,
        '>', 644,
        'B', 633,
        'F', 570,
        'L', 544,
        'R', 547,
        'T', 574,
        'U', 548,
        '[', 462,
        '\\', 4,
        ']', 282,
        '^', 433,
        'b', 616,
        'c', 595,
        'd', 612,
        'f', 579,
        'i', 609,
        'm', 581,
        'n', 629,
        'p', 626,
        's', 596,
        't', 621,
        'u', 551,
        'v', 613,
        '{', 459,
        '|', 306,
        '}', 460,
        '~', 404,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(335);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(634);
      END_STATE();
    case 336:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 337:
      ACCEPT_TOKEN(aux_sym_preproc_include_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(400);
      END_STATE();
    case 338:
      ACCEPT_TOKEN(aux_sym_preproc_include_token2);
      END_STATE();
    case 339:
      ACCEPT_TOKEN(aux_sym_preproc_def_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(400);
      END_STATE();
    case 340:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 341:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 342:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 343:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 344:
      ACCEPT_TOKEN(aux_sym_preproc_if_token1);
      if (lookahead == 'd') ADVANCE(379);
      if (lookahead == 'n') ADVANCE(373);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(400);
      END_STATE();
    case 345:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n') ADVANCE(345);
      END_STATE();
    case 346:
      ACCEPT_TOKEN(aux_sym_preproc_if_token2);
      END_STATE();
    case 347:
      ACCEPT_TOKEN(aux_sym_preproc_if_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(400);
      END_STATE();
    case 348:
      ACCEPT_TOKEN(aux_sym_preproc_ifdef_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(400);
      END_STATE();
    case 349:
      ACCEPT_TOKEN(aux_sym_preproc_ifdef_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(400);
      END_STATE();
    case 350:
      ACCEPT_TOKEN(aux_sym_preproc_else_token1);
      END_STATE();
    case 351:
      ACCEPT_TOKEN(aux_sym_preproc_else_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(400);
      END_STATE();
    case 352:
      ACCEPT_TOKEN(aux_sym_preproc_elif_token1);
      if (lookahead == 'd') ADVANCE(294);
      if (lookahead == 'n') ADVANCE(290);
      END_STATE();
    case 353:
      ACCEPT_TOKEN(aux_sym_preproc_elif_token1);
      if (lookahead == 'd') ADVANCE(381);
      if (lookahead == 'n') ADVANCE(374);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(400);
      END_STATE();
    case 354:
      ACCEPT_TOKEN(aux_sym_preproc_elifdef_token1);
      END_STATE();
    case 355:
      ACCEPT_TOKEN(aux_sym_preproc_elifdef_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(400);
      END_STATE();
    case 356:
      ACCEPT_TOKEN(aux_sym_preproc_elifdef_token2);
      END_STATE();
    case 357:
      ACCEPT_TOKEN(aux_sym_preproc_elifdef_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(400);
      END_STATE();
    case 358:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') ADVANCE(255);
      if (lookahead == '*') ADVANCE(358);
      if (lookahead == '/') ADVANCE(635);
      if (lookahead == '\\') ADVANCE(364);
      if (lookahead != 0) ADVANCE(359);
      END_STATE();
    case 359:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') ADVANCE(255);
      if (lookahead == '*') ADVANCE(358);
      if (lookahead == '/') ADVANCE(256);
      if (lookahead == '\\') ADVANCE(364);
      if (lookahead != 0) ADVANCE(359);
      END_STATE();
    case 360:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') ADVANCE(642);
      if (lookahead == '\r') ADVANCE(636);
      if (lookahead == '/') ADVANCE(639);
      if (lookahead == '\\') ADVANCE(638);
      if (lookahead != 0) ADVANCE(640);
      END_STATE();
    case 361:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') SKIP(261);
      if (lookahead == '\r') ADVANCE(362);
      if (lookahead == '/') ADVANCE(333);
      if (lookahead == '\\') ADVANCE(363);
      if (lookahead != 0) ADVANCE(368);
      END_STATE();
    case 362:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') SKIP(261);
      if (lookahead == '/') ADVANCE(333);
      if (lookahead == '\\') ADVANCE(363);
      if (lookahead != 0) ADVANCE(368);
      END_STATE();
    case 363:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\r') ADVANCE(369);
      if (lookahead == '/') ADVANCE(333);
      if (lookahead == '\\') ADVANCE(363);
      if (lookahead != 0) ADVANCE(368);
      END_STATE();
    case 364:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\r') ADVANCE(367);
      if (lookahead == '*') ADVANCE(358);
      if (lookahead == '/') ADVANCE(256);
      if (lookahead == '\\') ADVANCE(364);
      if (lookahead != 0) ADVANCE(359);
      END_STATE();
    case 365:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\r') ADVANCE(641);
      if (lookahead == '/') ADVANCE(639);
      if (lookahead == '\\') ADVANCE(638);
      if (lookahead != 0) ADVANCE(640);
      END_STATE();
    case 366:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '*') ADVANCE(359);
      if (lookahead == '/') ADVANCE(639);
      if (lookahead == '\\') ADVANCE(363);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(368);
      END_STATE();
    case 367:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '*') ADVANCE(358);
      if (lookahead == '/') ADVANCE(256);
      if (lookahead == '\\') ADVANCE(364);
      if (lookahead != 0) ADVANCE(359);
      END_STATE();
    case 368:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(333);
      if (lookahead == '\\') ADVANCE(363);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(368);
      END_STATE();
    case 369:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(333);
      if (lookahead == '\\') ADVANCE(363);
      if (lookahead != 0) ADVANCE(368);
      END_STATE();
    case 370:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'c') ADVANCE(396);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(400);
      END_STATE();
    case 371:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd') ADVANCE(394);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(400);
      END_STATE();
    case 372:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd') ADVANCE(378);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(400);
      END_STATE();
    case 373:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd') ADVANCE(380);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(400);
      END_STATE();
    case 374:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd') ADVANCE(382);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(400);
      END_STATE();
    case 375:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(385);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(400);
      END_STATE();
    case 376:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(351);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(400);
      END_STATE();
    case 377:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(339);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(400);
      END_STATE();
    case 378:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(337);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(400);
      END_STATE();
    case 379:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(388);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(400);
      END_STATE();
    case 380:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(389);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(400);
      END_STATE();
    case 381:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(390);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(400);
      END_STATE();
    case 382:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(391);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(400);
      END_STATE();
    case 383:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(344);
      if (lookahead == 'n') ADVANCE(370);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(400);
      END_STATE();
    case 384:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(344);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(400);
      END_STATE();
    case 385:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(392);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(400);
      END_STATE();
    case 386:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(353);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(400);
      END_STATE();
    case 387:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(347);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(400);
      END_STATE();
    case 388:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(348);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(400);
      END_STATE();
    case 389:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(349);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(400);
      END_STATE();
    case 390:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(355);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(400);
      END_STATE();
    case 391:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(357);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(400);
      END_STATE();
    case 392:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i') ADVANCE(398);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(400);
      END_STATE();
    case 393:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i') ADVANCE(386);
      if (lookahead == 's') ADVANCE(376);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(400);
      END_STATE();
    case 394:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i') ADVANCE(387);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(400);
      END_STATE();
    case 395:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'l') ADVANCE(393);
      if (lookahead == 'n') ADVANCE(371);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(400);
      END_STATE();
    case 396:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'l') ADVANCE(399);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(400);
      END_STATE();
    case 397:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'n') ADVANCE(371);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(400);
      END_STATE();
    case 398:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'n') ADVANCE(377);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(400);
      END_STATE();
    case 399:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'u') ADVANCE(372);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(400);
      END_STATE();
    case 400:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(400);
      END_STATE();
    case 401:
      ACCEPT_TOKEN(anon_sym_LPAREN2);
      END_STATE();
    case 402:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 403:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(439);
      END_STATE();
    case 404:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 405:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 406:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(484);
      if (lookahead == '.') ADVANCE(312);
      if (lookahead == '0') ADVANCE(495);
      if (lookahead == '=') ADVANCE(477);
      if (lookahead == '>') ADVANCE(492);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      END_STATE();
    case 407:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(484);
      if (lookahead == '.') ADVANCE(312);
      if (lookahead == '0') ADVANCE(495);
      if (lookahead == '=') ADVANCE(477);
      if (lookahead == '>') ADVANCE(491);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      END_STATE();
    case 408:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(484);
      if (lookahead == '.') ADVANCE(312);
      if (lookahead == '0') ADVANCE(495);
      if (lookahead == '>') ADVANCE(491);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      END_STATE();
    case 409:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(484);
      if (lookahead == '.') ADVANCE(312);
      if (lookahead == '0') ADVANCE(495);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      END_STATE();
    case 410:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(484);
      if (lookahead == '=') ADVANCE(477);
      if (lookahead == '>') ADVANCE(492);
      END_STATE();
    case 411:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(484);
      if (lookahead == '=') ADVANCE(477);
      if (lookahead == '>') ADVANCE(491);
      END_STATE();
    case 412:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(484);
      if (lookahead == '>') ADVANCE(491);
      END_STATE();
    case 413:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '.') ADVANCE(312);
      if (lookahead == '0') ADVANCE(495);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      END_STATE();
    case 414:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=') ADVANCE(477);
      if (lookahead == '>') ADVANCE(253);
      END_STATE();
    case 415:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 416:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(485);
      END_STATE();
    case 417:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(485);
      if (lookahead == '.') ADVANCE(312);
      if (lookahead == '0') ADVANCE(495);
      if (lookahead == '=') ADVANCE(476);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      END_STATE();
    case 418:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(485);
      if (lookahead == '.') ADVANCE(312);
      if (lookahead == '0') ADVANCE(495);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      END_STATE();
    case 419:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(485);
      if (lookahead == '=') ADVANCE(476);
      END_STATE();
    case 420:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '.') ADVANCE(312);
      if (lookahead == '0') ADVANCE(495);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      END_STATE();
    case 421:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=') ADVANCE(476);
      END_STATE();
    case 422:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 423:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '=') ADVANCE(473);
      END_STATE();
    case 424:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(255);
      if (lookahead == '/') ADVANCE(642);
      END_STATE();
    case 425:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(255);
      if (lookahead == '/') ADVANCE(642);
      if (lookahead == '=') ADVANCE(474);
      END_STATE();
    case 426:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 427:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(475);
      END_STATE();
    case 428:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 429:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 430:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 431:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(482);
      if (lookahead == '|') ADVANCE(428);
      END_STATE();
    case 432:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(428);
      END_STATE();
    case 433:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 434:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(481);
      END_STATE();
    case 435:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 436:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(429);
      END_STATE();
    case 437:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(429);
      if (lookahead == '=') ADVANCE(480);
      END_STATE();
    case 438:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 439:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 440:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 441:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(443);
      if (lookahead == '>') ADVANCE(453);
      END_STATE();
    case 442:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(443);
      if (lookahead == '>') ADVANCE(454);
      END_STATE();
    case 443:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 444:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 445:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      if (lookahead == '>') ADVANCE(483);
      END_STATE();
    case 446:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 447:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(452);
      if (lookahead == '=') ADVANCE(445);
      END_STATE();
    case 448:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(452);
      if (lookahead == '=') ADVANCE(444);
      END_STATE();
    case 449:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(451);
      if (lookahead == '=') ADVANCE(445);
      END_STATE();
    case 450:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(451);
      if (lookahead == '=') ADVANCE(444);
      END_STATE();
    case 451:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 452:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(478);
      END_STATE();
    case 453:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 454:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(479);
      END_STATE();
    case 455:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 456:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 457:
      ACCEPT_TOKEN(anon_sym_LBRACK_LBRACK);
      END_STATE();
    case 458:
      ACCEPT_TOKEN(anon_sym_RBRACK_RBRACK);
      END_STATE();
    case 459:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 460:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 461:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 462:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == '[') ADVANCE(457);
      END_STATE();
    case 463:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == '[') ADVANCE(457);
      if (lookahead == ']') ADVANCE(654);
      END_STATE();
    case 464:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == ']') ADVANCE(654);
      END_STATE();
    case 465:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 466:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 467:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(438);
      END_STATE();
    case 468:
      ACCEPT_TOKEN(aux_sym_primitive_type_token1);
      if (lookahead == '1') ADVANCE(569);
      if (lookahead == '3') ADVANCE(567);
      if (lookahead == '6') ADVANCE(568);
      if (lookahead == '8') ADVANCE(578);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'p') ADVANCE(627);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 469:
      ACCEPT_TOKEN(aux_sym_primitive_type_token1);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 470:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 471:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(456);
      END_STATE();
    case 472:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 473:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 474:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 475:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 476:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 477:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 478:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 479:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 480:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 481:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 482:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 483:
      ACCEPT_TOKEN(anon_sym_LT_EQ_GT);
      END_STATE();
    case 484:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 485:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 486:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '*') ADVANCE(490);
      if (lookahead == '.') ADVANCE(259);
      END_STATE();
    case 487:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '*') ADVANCE(490);
      if (lookahead == '.') ADVANCE(259);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(494);
      END_STATE();
    case 488:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(259);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(494);
      END_STATE();
    case 489:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(494);
      END_STATE();
    case 490:
      ACCEPT_TOKEN(anon_sym_DOT_STAR);
      END_STATE();
    case 491:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 492:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      if (lookahead == '*') ADVANCE(652);
      END_STATE();
    case 493:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      END_STATE();
    case 494:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      ADVANCE_MAP(
        '\'', 312,
        'B', 278,
        'b', 296,
        'E', 307,
        'e', 307,
        'F', 501,
        'f', 501,
        'L', 493,
        'l', 493,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(494);
      END_STATE();
    case 495:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      ADVANCE_MAP(
        '\'', 310,
        '.', 502,
        'L', 503,
        'l', 506,
        'B', 309,
        'b', 309,
        'E', 307,
        'e', 307,
        'U', 505,
        'u', 505,
        'X', 260,
        'x', 260,
        'Z', 508,
        'z', 508,
        '8', 246,
        '9', 246,
      );
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(496);
      END_STATE();
    case 496:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      ADVANCE_MAP(
        '\'', 310,
        '.', 502,
        'L', 503,
        'l', 506,
        'E', 307,
        'e', 307,
        'U', 505,
        'u', 505,
        'Z', 508,
        'z', 508,
        '8', 246,
        '9', 246,
      );
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(496);
      END_STATE();
    case 497:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      ADVANCE_MAP(
        '\'', 309,
        'L', 503,
        'l', 506,
        'U', 505,
        'u', 505,
        'Z', 508,
        'z', 508,
        '0', 497,
        '1', 497,
      );
      END_STATE();
    case 498:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      ADVANCE_MAP(
        '\'', 311,
        '.', 502,
        'L', 503,
        'l', 506,
        'E', 307,
        'e', 307,
        'U', 505,
        'u', 505,
        'Z', 508,
        'z', 508,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(498);
      END_STATE();
    case 499:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      if (lookahead == '\'') ADVANCE(314);
      if (lookahead == 'B') ADVANCE(278);
      if (lookahead == 'b') ADVANCE(296);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(501);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(493);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(499);
      END_STATE();
    case 500:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      ADVANCE_MAP(
        '\'', 316,
        '.', 308,
        'L', 503,
        'l', 506,
        'P', 307,
        'p', 307,
        'U', 505,
        'u', 505,
        'Z', 508,
        'z', 508,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(500);
      END_STATE();
    case 501:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      if (lookahead == '1') ADVANCE(264);
      if (lookahead == '3') ADVANCE(263);
      if (lookahead == '6') ADVANCE(265);
      END_STATE();
    case 502:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      ADVANCE_MAP(
        'B', 278,
        'b', 296,
        'E', 307,
        'e', 307,
        'F', 501,
        'f', 501,
        'L', 493,
        'l', 493,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(494);
      END_STATE();
    case 503:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      if (lookahead == 'L') ADVANCE(508);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(493);
      END_STATE();
    case 504:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      if (lookahead == 'L') ADVANCE(493);
      END_STATE();
    case 505:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      if (lookahead == 'L') ADVANCE(504);
      if (lookahead == 'l') ADVANCE(507);
      if (lookahead == 'Z' ||
          lookahead == 'z') ADVANCE(493);
      END_STATE();
    case 506:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      if (lookahead == 'l') ADVANCE(508);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(493);
      END_STATE();
    case 507:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      if (lookahead == 'l') ADVANCE(493);
      END_STATE();
    case 508:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(493);
      END_STATE();
    case 509:
      ACCEPT_TOKEN(aux_sym_number_literal_token2);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(516);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 510:
      ACCEPT_TOKEN(aux_sym_number_literal_token2);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(509);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 511:
      ACCEPT_TOKEN(aux_sym_number_literal_token2);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(510);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 512:
      ACCEPT_TOKEN(aux_sym_number_literal_token2);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(511);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 513:
      ACCEPT_TOKEN(aux_sym_number_literal_token2);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(512);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 514:
      ACCEPT_TOKEN(aux_sym_number_literal_token2);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(513);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 515:
      ACCEPT_TOKEN(aux_sym_number_literal_token2);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(514);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 516:
      ACCEPT_TOKEN(aux_sym_number_literal_token2);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 517:
      ACCEPT_TOKEN(anon_sym_L_SQUOTE);
      END_STATE();
    case 518:
      ACCEPT_TOKEN(anon_sym_u_SQUOTE);
      END_STATE();
    case 519:
      ACCEPT_TOKEN(anon_sym_U_SQUOTE);
      END_STATE();
    case 520:
      ACCEPT_TOKEN(anon_sym_u8_SQUOTE);
      END_STATE();
    case 521:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 522:
      ACCEPT_TOKEN(aux_sym_char_literal_token1);
      END_STATE();
    case 523:
      ACCEPT_TOKEN(aux_sym_char_literal_token1);
      if (lookahead == '\n') ADVANCE(537);
      if (lookahead == '\r') ADVANCE(536);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      if (lookahead == 'x') ADVANCE(320);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(539);
      if (lookahead != 0) ADVANCE(536);
      END_STATE();
    case 524:
      ACCEPT_TOKEN(aux_sym_char_literal_token1);
      if (lookahead == '*') ADVANCE(255);
      if (lookahead == '/') ADVANCE(642);
      END_STATE();
    case 525:
      ACCEPT_TOKEN(aux_sym_char_literal_token1);
      if (lookahead == '\\') ADVANCE(109);
      END_STATE();
    case 526:
      ACCEPT_TOKEN(anon_sym_L_DQUOTE);
      END_STATE();
    case 527:
      ACCEPT_TOKEN(anon_sym_u_DQUOTE);
      END_STATE();
    case 528:
      ACCEPT_TOKEN(anon_sym_U_DQUOTE);
      END_STATE();
    case 529:
      ACCEPT_TOKEN(anon_sym_u8_DQUOTE);
      END_STATE();
    case 530:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 531:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead == '*') ADVANCE(533);
      if (lookahead == '/') ADVANCE(535);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(535);
      END_STATE();
    case 532:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead == '*') ADVANCE(532);
      if (lookahead == '/') ADVANCE(535);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(533);
      END_STATE();
    case 533:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead == '*') ADVANCE(532);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(533);
      END_STATE();
    case 534:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead == '/') ADVANCE(531);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(534);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(535);
      END_STATE();
    case 535:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(535);
      END_STATE();
    case 536:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 537:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(109);
      END_STATE();
    case 538:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(536);
      END_STATE();
    case 539:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(538);
      END_STATE();
    case 540:
      ACCEPT_TOKEN(sym_system_lib_string);
      END_STATE();
    case 541:
      ACCEPT_TOKEN(sym_system_lib_string);
      if (lookahead == '>') ADVANCE(540);
      if (lookahead == '\\') ADVANCE(277);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(276);
      END_STATE();
    case 542:
      ACCEPT_TOKEN(sym_true);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 543:
      ACCEPT_TOKEN(sym_false);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 544:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(526);
      if (lookahead == '\'') ADVANCE(517);
      if (lookahead == 'R') ADVANCE(555);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 545:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(526);
      if (lookahead == 'R') ADVANCE(555);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 546:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(526);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 547:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(647);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 548:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(528);
      if (lookahead == '\'') ADVANCE(519);
      if (lookahead == 'R') ADVANCE(556);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 549:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(528);
      if (lookahead == 'R') ADVANCE(556);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 550:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(528);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 551:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(527);
      if (lookahead == '\'') ADVANCE(518);
      if (lookahead == '8') ADVANCE(557);
      if (lookahead == 'R') ADVANCE(560);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'i') ADVANCE(611);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 552:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(527);
      if (lookahead == '8') ADVANCE(558);
      if (lookahead == 'R') ADVANCE(560);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 553:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(527);
      if (lookahead == '8') ADVANCE(559);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'i') ADVANCE(611);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 554:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(527);
      if (lookahead == '8') ADVANCE(559);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 555:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(648);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 556:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(650);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 557:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(529);
      if (lookahead == '\'') ADVANCE(520);
      if (lookahead == 'R') ADVANCE(561);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 558:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(529);
      if (lookahead == 'R') ADVANCE(561);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 559:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(529);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 560:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(649);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 561:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(651);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 562:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\'') ADVANCE(517);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 563:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\'') ADVANCE(519);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 564:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\'') ADVANCE(518);
      if (lookahead == '8') ADVANCE(565);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 565:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\'') ADVANCE(520);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 566:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '1') ADVANCE(569);
      if (lookahead == '3') ADVANCE(567);
      if (lookahead == '6') ADVANCE(568);
      if (lookahead == '8') ADVANCE(578);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'p') ADVANCE(627);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 567:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '2') ADVANCE(578);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 568:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '4') ADVANCE(578);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 569:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '6') ADVANCE(578);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 570:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'A') ADVANCE(573);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 571:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'E') ADVANCE(542);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 572:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'E') ADVANCE(543);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 573:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'L') ADVANCE(575);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 574:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'R') ADVANCE(576);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 575:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'S') ADVANCE(572);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 576:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'U') ADVANCE(571);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 577:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == '_') ADVANCE(584);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 578:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == '_') ADVANCE(624);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 579:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'a') ADVANCE(602);
      if (lookahead == 'l') ADVANCE(614);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 580:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'a') ADVANCE(602);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 581:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'a') ADVANCE(631);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 582:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'a') ADVANCE(618);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 583:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'a') ADVANCE(624);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 584:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'a') ADVANCE(606);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 585:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'b') ADVANCE(607);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 586:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'd') ADVANCE(469);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 587:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'd') ADVANCE(598);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 588:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'e') ADVANCE(542);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 589:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'e') ADVANCE(469);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 590:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'e') ADVANCE(543);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 591:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'e') ADVANCE(578);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 592:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'f') ADVANCE(578);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 593:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'f') ADVANCE(592);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 594:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'g') ADVANCE(610);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 595:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'h') ADVANCE(582);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 596:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'i') ADVANCE(632);
      if (lookahead == 's') ADVANCE(597);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 597:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'i') ADVANCE(632);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 598:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'i') ADVANCE(593);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 599:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'i') ADVANCE(594);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 600:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'i') ADVANCE(586);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 601:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'i') ADVANCE(611);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 602:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'l') ADVANCE(622);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 603:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'l') ADVANCE(469);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 604:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'l') ADVANCE(617);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 605:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'l') ADVANCE(604);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 606:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'l') ADVANCE(599);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 607:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'l') ADVANCE(589);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 608:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'l') ADVANCE(614);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 609:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'n') ADVANCE(623);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 610:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'n') ADVANCE(578);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 611:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'n') ADVANCE(625);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 612:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'o') ADVANCE(628);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 613:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'o') ADVANCE(600);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 614:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'o') ADVANCE(583);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 615:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'o') ADVANCE(603);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 616:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'o') ADVANCE(615);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 617:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'p') ADVANCE(627);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 618:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'r') ADVANCE(468);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 619:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'r') ADVANCE(587);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 620:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'r') ADVANCE(578);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 621:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'r') ADVANCE(630);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 622:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 's') ADVANCE(590);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 623:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 't') ADVANCE(468);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 624:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 't') ADVANCE(469);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 625:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 't') ADVANCE(566);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 626:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 't') ADVANCE(619);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 627:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 't') ADVANCE(620);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 628:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'u') ADVANCE(585);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 629:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'u') ADVANCE(605);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 630:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'u') ADVANCE(588);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 631:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'x') ADVANCE(577);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 632:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'z') ADVANCE(591);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 633:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(515);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 634:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 635:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 636:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\n') ADVANCE(642);
      if (lookahead == '/') ADVANCE(639);
      if (lookahead == '\\') ADVANCE(365);
      if (lookahead != 0) ADVANCE(640);
      END_STATE();
    case 637:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\r') ADVANCE(643);
      if (lookahead == '\\') ADVANCE(637);
      if (lookahead != 0) ADVANCE(642);
      END_STATE();
    case 638:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\r') ADVANCE(641);
      if (lookahead == '/') ADVANCE(639);
      if (lookahead == '\\') ADVANCE(638);
      if (lookahead != 0) ADVANCE(640);
      END_STATE();
    case 639:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '*') ADVANCE(642);
      if (lookahead == '\\') ADVANCE(360);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(640);
      END_STATE();
    case 640:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '/') ADVANCE(639);
      if (lookahead == '\\') ADVANCE(365);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(640);
      END_STATE();
    case 641:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '/') ADVANCE(639);
      if (lookahead == '\\') ADVANCE(365);
      if (lookahead != 0) ADVANCE(640);
      END_STATE();
    case 642:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\\') ADVANCE(160);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(642);
      END_STATE();
    case 643:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\\') ADVANCE(160);
      if (lookahead != 0) ADVANCE(642);
      END_STATE();
    case 644:
      ACCEPT_TOKEN(anon_sym_GT2);
      END_STATE();
    case 645:
      ACCEPT_TOKEN(anon_sym_0);
      END_STATE();
    case 646:
      ACCEPT_TOKEN(anon_sym_0);
      ADVANCE_MAP(
        '\'', 310,
        '.', 502,
        'L', 503,
        'l', 506,
        'B', 309,
        'b', 309,
        'E', 307,
        'e', 307,
        'U', 505,
        'u', 505,
        'X', 260,
        'x', 260,
        'Z', 508,
        'z', 508,
        '8', 246,
        '9', 246,
      );
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(496);
      END_STATE();
    case 647:
      ACCEPT_TOKEN(anon_sym_R_DQUOTE);
      END_STATE();
    case 648:
      ACCEPT_TOKEN(anon_sym_LR_DQUOTE);
      END_STATE();
    case 649:
      ACCEPT_TOKEN(anon_sym_uR_DQUOTE);
      END_STATE();
    case 650:
      ACCEPT_TOKEN(anon_sym_UR_DQUOTE);
      END_STATE();
    case 651:
      ACCEPT_TOKEN(anon_sym_u8R_DQUOTE);
      END_STATE();
    case 652:
      ACCEPT_TOKEN(anon_sym_DASH_GT_STAR);
      END_STATE();
    case 653:
      ACCEPT_TOKEN(anon_sym_LPAREN_RPAREN);
      END_STATE();
    case 654:
      ACCEPT_TOKEN(anon_sym_LBRACK_RBRACK);
      END_STATE();
    case 655:
      ACCEPT_TOKEN(anon_sym_DQUOTE_DQUOTE);
      END_STATE();
    case 656:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(526);
      if (lookahead == 'R') ADVANCE(660);
      if (lookahead == '\\') ADVANCE(279);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 657:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(647);
      if (lookahead == '\\') ADVANCE(279);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 658:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(528);
      if (lookahead == 'R') ADVANCE(661);
      if (lookahead == '\\') ADVANCE(279);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 659:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(527);
      if (lookahead == '8') ADVANCE(662);
      if (lookahead == 'R') ADVANCE(663);
      if (lookahead == '\\') ADVANCE(279);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 660:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(648);
      if (lookahead == '\\') ADVANCE(279);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 661:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(650);
      if (lookahead == '\\') ADVANCE(279);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 662:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(529);
      if (lookahead == 'R') ADVANCE(664);
      if (lookahead == '\\') ADVANCE(279);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 663:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(649);
      if (lookahead == '\\') ADVANCE(279);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 664:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(651);
      if (lookahead == '\\') ADVANCE(279);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    case 665:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '\\') ADVANCE(279);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(634);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'N') ADVANCE(1);
      if (lookahead == 'P') ADVANCE(2);
      if (lookahead == '\\') SKIP(3);
      if (lookahead == '_') ADVANCE(4);
      if (lookahead == 'a') ADVANCE(5);
      if (lookahead == 'b') ADVANCE(6);
      if (lookahead == 'c') ADVANCE(7);
      if (lookahead == 'd') ADVANCE(8);
      if (lookahead == 'e') ADVANCE(9);
      if (lookahead == 'f') ADVANCE(10);
      if (lookahead == 'g') ADVANCE(11);
      if (lookahead == 'i') ADVANCE(12);
      if (lookahead == 'l') ADVANCE(13);
      if (lookahead == 'm') ADVANCE(14);
      if (lookahead == 'n') ADVANCE(15);
      if (lookahead == 'o') ADVANCE(16);
      if (lookahead == 'p') ADVANCE(17);
      if (lookahead == 'r') ADVANCE(18);
      if (lookahead == 's') ADVANCE(19);
      if (lookahead == 't') ADVANCE(20);
      if (lookahead == 'u') ADVANCE(21);
      if (lookahead == 'v') ADVANCE(22);
      if (lookahead == 'w') ADVANCE(23);
      if (lookahead == 'x') ADVANCE(24);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(0);
      END_STATE();
    case 1:
      if (lookahead == 'U') ADVANCE(25);
      END_STATE();
    case 2:
      if (lookahead == 'R') ADVANCE(26);
      END_STATE();
    case 3:
      if (lookahead == '\n') SKIP(0);
      if (lookahead == '\r') SKIP(27);
      END_STATE();
    case 4:
      if (lookahead == 'A') ADVANCE(28);
      if (lookahead == 'G') ADVANCE(29);
      if (lookahead == 'N') ADVANCE(30);
      if (lookahead == '_') ADVANCE(31);
      if (lookahead == 'a') ADVANCE(32);
      if (lookahead == 'u') ADVANCE(33);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(34);
      if (lookahead == 'n') ADVANCE(35);
      if (lookahead == 's') ADVANCE(36);
      if (lookahead == 'u') ADVANCE(37);
      END_STATE();
    case 6:
      if (lookahead == 'i') ADVANCE(38);
      if (lookahead == 'r') ADVANCE(39);
      if (lookahead == 'y') ADVANCE(40);
      END_STATE();
    case 7:
      if (lookahead == 'a') ADVANCE(41);
      if (lookahead == 'l') ADVANCE(42);
      if (lookahead == 'o') ADVANCE(43);
      END_STATE();
    case 8:
      if (lookahead == 'e') ADVANCE(44);
      if (lookahead == 'o') ADVANCE(45);
      END_STATE();
    case 9:
      if (lookahead == 'l') ADVANCE(46);
      if (lookahead == 'n') ADVANCE(47);
      if (lookahead == 'x') ADVANCE(48);
      END_STATE();
    case 10:
      if (lookahead == 'i') ADVANCE(49);
      if (lookahead == 'o') ADVANCE(50);
      if (lookahead == 'r') ADVANCE(51);
      END_STATE();
    case 11:
      if (lookahead == 'o') ADVANCE(52);
      END_STATE();
    case 12:
      if (lookahead == 'f') ADVANCE(53);
      if (lookahead == 'n') ADVANCE(54);
      END_STATE();
    case 13:
      if (lookahead == 'o') ADVANCE(55);
      END_STATE();
    case 14:
      if (lookahead == 'u') ADVANCE(56);
      END_STATE();
    case 15:
      if (lookahead == 'a') ADVANCE(57);
      if (lookahead == 'e') ADVANCE(58);
      if (lookahead == 'o') ADVANCE(59);
      if (lookahead == 'u') ADVANCE(60);
      END_STATE();
    case 16:
      if (lookahead == 'f') ADVANCE(61);
      if (lookahead == 'p') ADVANCE(62);
      if (lookahead == 'r') ADVANCE(63);
      if (lookahead == 'v') ADVANCE(64);
      END_STATE();
    case 17:
      if (lookahead == 'r') ADVANCE(65);
      if (lookahead == 'u') ADVANCE(66);
      END_STATE();
    case 18:
      if (lookahead == 'e') ADVANCE(67);
      END_STATE();
    case 19:
      if (lookahead == 'h') ADVANCE(68);
      if (lookahead == 'i') ADVANCE(69);
      if (lookahead == 't') ADVANCE(70);
      if (lookahead == 'w') ADVANCE(71);
      END_STATE();
    case 20:
      if (lookahead == 'e') ADVANCE(72);
      if (lookahead == 'h') ADVANCE(73);
      if (lookahead == 'r') ADVANCE(74);
      if (lookahead == 'y') ADVANCE(75);
      END_STATE();
    case 21:
      if (lookahead == 'n') ADVANCE(76);
      if (lookahead == 's') ADVANCE(77);
      END_STATE();
    case 22:
      if (lookahead == 'i') ADVANCE(78);
      if (lookahead == 'o') ADVANCE(79);
      END_STATE();
    case 23:
      if (lookahead == 'h') ADVANCE(80);
      if (lookahead == 'o') ADVANCE(81);
      END_STATE();
    case 24:
      if (lookahead == 'o') ADVANCE(82);
      END_STATE();
    case 25:
      if (lookahead == 'L') ADVANCE(83);
      END_STATE();
    case 26:
      if (lookahead == 'O') ADVANCE(84);
      END_STATE();
    case 27:
      if (lookahead == '\n') SKIP(0);
      END_STATE();
    case 28:
      if (lookahead == 'l') ADVANCE(85);
      if (lookahead == 't') ADVANCE(86);
      END_STATE();
    case 29:
      if (lookahead == 'e') ADVANCE(87);
      END_STATE();
    case 30:
      if (lookahead == 'o') ADVANCE(88);
      END_STATE();
    case 31:
      ADVANCE_MAP(
        'a', 89,
        'b', 90,
        'c', 91,
        'd', 92,
        'e', 93,
        'f', 94,
        'i', 95,
        'l', 96,
        'r', 97,
        's', 98,
        't', 99,
        'u', 100,
        'v', 101,
      );
      END_STATE();
    case 32:
      if (lookahead == 'l') ADVANCE(102);
      END_STATE();
    case 33:
      if (lookahead == 'n') ADVANCE(103);
      END_STATE();
    case 34:
      if (lookahead == 'i') ADVANCE(104);
      END_STATE();
    case 35:
      if (lookahead == 'd') ADVANCE(105);
      END_STATE();
    case 36:
      if (lookahead == 'm') ADVANCE(106);
      END_STATE();
    case 37:
      if (lookahead == 't') ADVANCE(107);
      END_STATE();
    case 38:
      if (lookahead == 't') ADVANCE(108);
      END_STATE();
    case 39:
      if (lookahead == 'e') ADVANCE(109);
      END_STATE();
    case 40:
      if (lookahead == 't') ADVANCE(110);
      END_STATE();
    case 41:
      if (lookahead == 's') ADVANCE(111);
      if (lookahead == 't') ADVANCE(112);
      END_STATE();
    case 42:
      if (lookahead == 'a') ADVANCE(113);
      END_STATE();
    case 43:
      if (lookahead == '_') ADVANCE(114);
      if (lookahead == 'm') ADVANCE(115);
      if (lookahead == 'n') ADVANCE(116);
      END_STATE();
    case 44:
      if (lookahead == 'c') ADVANCE(117);
      if (lookahead == 'f') ADVANCE(118);
      if (lookahead == 'l') ADVANCE(119);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 46:
      if (lookahead == 's') ADVANCE(120);
      END_STATE();
    case 47:
      if (lookahead == 'u') ADVANCE(121);
      END_STATE();
    case 48:
      if (lookahead == 'p') ADVANCE(122);
      if (lookahead == 't') ADVANCE(123);
      END_STATE();
    case 49:
      if (lookahead == 'n') ADVANCE(124);
      END_STATE();
    case 50:
      if (lookahead == 'r') ADVANCE(125);
      END_STATE();
    case 51:
      if (lookahead == 'i') ADVANCE(126);
      END_STATE();
    case 52:
      if (lookahead == 't') ADVANCE(127);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 54:
      if (lookahead == 'l') ADVANCE(128);
      END_STATE();
    case 55:
      if (lookahead == 'n') ADVANCE(129);
      END_STATE();
    case 56:
      if (lookahead == 't') ADVANCE(130);
      END_STATE();
    case 57:
      if (lookahead == 'm') ADVANCE(131);
      END_STATE();
    case 58:
      if (lookahead == 'w') ADVANCE(132);
      END_STATE();
    case 59:
      if (lookahead == 'e') ADVANCE(133);
      if (lookahead == 'r') ADVANCE(134);
      if (lookahead == 't') ADVANCE(135);
      END_STATE();
    case 60:
      if (lookahead == 'l') ADVANCE(136);
      END_STATE();
    case 61:
      if (lookahead == 'f') ADVANCE(137);
      END_STATE();
    case 62:
      if (lookahead == 'e') ADVANCE(138);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_or);
      if (lookahead == '_') ADVANCE(139);
      END_STATE();
    case 64:
      if (lookahead == 'e') ADVANCE(140);
      END_STATE();
    case 65:
      if (lookahead == 'i') ADVANCE(141);
      if (lookahead == 'o') ADVANCE(142);
      END_STATE();
    case 66:
      if (lookahead == 'b') ADVANCE(143);
      END_STATE();
    case 67:
      if (lookahead == 'g') ADVANCE(144);
      if (lookahead == 'q') ADVANCE(145);
      if (lookahead == 's') ADVANCE(146);
      if (lookahead == 't') ADVANCE(147);
      END_STATE();
    case 68:
      if (lookahead == 'o') ADVANCE(148);
      END_STATE();
    case 69:
      if (lookahead == 'g') ADVANCE(149);
      if (lookahead == 'z') ADVANCE(150);
      END_STATE();
    case 70:
      if (lookahead == 'a') ADVANCE(151);
      if (lookahead == 'r') ADVANCE(152);
      END_STATE();
    case 71:
      if (lookahead == 'i') ADVANCE(153);
      END_STATE();
    case 72:
      if (lookahead == 'm') ADVANCE(154);
      END_STATE();
    case 73:
      if (lookahead == 'i') ADVANCE(155);
      if (lookahead == 'r') ADVANCE(156);
      END_STATE();
    case 74:
      if (lookahead == 'y') ADVANCE(157);
      END_STATE();
    case 75:
      if (lookahead == 'p') ADVANCE(158);
      END_STATE();
    case 76:
      if (lookahead == 'i') ADVANCE(159);
      if (lookahead == 's') ADVANCE(160);
      END_STATE();
    case 77:
      if (lookahead == 'i') ADVANCE(161);
      END_STATE();
    case 78:
      if (lookahead == 'r') ADVANCE(162);
      END_STATE();
    case 79:
      if (lookahead == 'l') ADVANCE(163);
      END_STATE();
    case 80:
      if (lookahead == 'i') ADVANCE(164);
      END_STATE();
    case 81:
      if (lookahead == 'r') ADVANCE(165);
      END_STATE();
    case 82:
      if (lookahead == 'r') ADVANCE(166);
      END_STATE();
    case 83:
      if (lookahead == 'L') ADVANCE(167);
      END_STATE();
    case 84:
      if (lookahead == 'G') ADVANCE(168);
      END_STATE();
    case 85:
      if (lookahead == 'i') ADVANCE(169);
      END_STATE();
    case 86:
      if (lookahead == 'o') ADVANCE(170);
      END_STATE();
    case 87:
      if (lookahead == 'n') ADVANCE(171);
      END_STATE();
    case 88:
      if (lookahead == 'r') ADVANCE(172);
      END_STATE();
    case 89:
      if (lookahead == 'l') ADVANCE(173);
      if (lookahead == 's') ADVANCE(174);
      if (lookahead == 't') ADVANCE(175);
      END_STATE();
    case 90:
      if (lookahead == 'a') ADVANCE(176);
      END_STATE();
    case 91:
      if (lookahead == 'd') ADVANCE(177);
      if (lookahead == 'l') ADVANCE(178);
      END_STATE();
    case 92:
      if (lookahead == 'e') ADVANCE(179);
      END_STATE();
    case 93:
      if (lookahead == 'x') ADVANCE(180);
      END_STATE();
    case 94:
      if (lookahead == 'a') ADVANCE(181);
      if (lookahead == 'i') ADVANCE(182);
      if (lookahead == 'o') ADVANCE(183);
      END_STATE();
    case 95:
      if (lookahead == 'n') ADVANCE(184);
      END_STATE();
    case 96:
      if (lookahead == 'e') ADVANCE(185);
      END_STATE();
    case 97:
      if (lookahead == 'e') ADVANCE(186);
      END_STATE();
    case 98:
      if (lookahead == 'p') ADVANCE(187);
      if (lookahead == 't') ADVANCE(188);
      END_STATE();
    case 99:
      if (lookahead == 'h') ADVANCE(189);
      if (lookahead == 'r') ADVANCE(190);
      END_STATE();
    case 100:
      if (lookahead == 'n') ADVANCE(191);
      if (lookahead == 'p') ADVANCE(192);
      END_STATE();
    case 101:
      if (lookahead == 'e') ADVANCE(193);
      END_STATE();
    case 102:
      if (lookahead == 'i') ADVANCE(194);
      END_STATE();
    case 103:
      if (lookahead == 'a') ADVANCE(195);
      END_STATE();
    case 104:
      if (lookahead == 'g') ADVANCE(196);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_and);
      if (lookahead == '_') ADVANCE(197);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_asm);
      END_STATE();
    case 107:
      if (lookahead == 'o') ADVANCE(198);
      END_STATE();
    case 108:
      if (lookahead == 'a') ADVANCE(199);
      if (lookahead == 'o') ADVANCE(200);
      END_STATE();
    case 109:
      if (lookahead == 'a') ADVANCE(201);
      END_STATE();
    case 110:
      if (lookahead == 'e') ADVANCE(202);
      END_STATE();
    case 111:
      if (lookahead == 'e') ADVANCE(203);
      END_STATE();
    case 112:
      if (lookahead == 'c') ADVANCE(204);
      END_STATE();
    case 113:
      if (lookahead == 's') ADVANCE(205);
      END_STATE();
    case 114:
      if (lookahead == 'a') ADVANCE(206);
      if (lookahead == 'r') ADVANCE(207);
      if (lookahead == 'y') ADVANCE(208);
      END_STATE();
    case 115:
      if (lookahead == 'p') ADVANCE(209);
      END_STATE();
    case 116:
      if (lookahead == 'c') ADVANCE(210);
      if (lookahead == 's') ADVANCE(211);
      if (lookahead == 't') ADVANCE(212);
      END_STATE();
    case 117:
      if (lookahead == 'l') ADVANCE(213);
      END_STATE();
    case 118:
      if (lookahead == 'a') ADVANCE(214);
      if (lookahead == 'i') ADVANCE(215);
      END_STATE();
    case 119:
      if (lookahead == 'e') ADVANCE(216);
      END_STATE();
    case 120:
      if (lookahead == 'e') ADVANCE(217);
      END_STATE();
    case 121:
      if (lookahead == 'm') ADVANCE(218);
      END_STATE();
    case 122:
      if (lookahead == 'l') ADVANCE(219);
      END_STATE();
    case 123:
      if (lookahead == 'e') ADVANCE(220);
      END_STATE();
    case 124:
      if (lookahead == 'a') ADVANCE(221);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 126:
      if (lookahead == 'e') ADVANCE(222);
      END_STATE();
    case 127:
      if (lookahead == 'o') ADVANCE(223);
      END_STATE();
    case 128:
      if (lookahead == 'i') ADVANCE(224);
      END_STATE();
    case 129:
      if (lookahead == 'g') ADVANCE(225);
      END_STATE();
    case 130:
      if (lookahead == 'a') ADVANCE(226);
      END_STATE();
    case 131:
      if (lookahead == 'e') ADVANCE(227);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 133:
      if (lookahead == 'x') ADVANCE(228);
      END_STATE();
    case 134:
      if (lookahead == 'e') ADVANCE(229);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_not);
      if (lookahead == '_') ADVANCE(230);
      END_STATE();
    case 136:
      if (lookahead == 'l') ADVANCE(231);
      END_STATE();
    case 137:
      if (lookahead == 's') ADVANCE(232);
      END_STATE();
    case 138:
      if (lookahead == 'r') ADVANCE(233);
      END_STATE();
    case 139:
      if (lookahead == 'e') ADVANCE(234);
      END_STATE();
    case 140:
      if (lookahead == 'r') ADVANCE(235);
      END_STATE();
    case 141:
      if (lookahead == 'v') ADVANCE(236);
      END_STATE();
    case 142:
      if (lookahead == 't') ADVANCE(237);
      END_STATE();
    case 143:
      if (lookahead == 'l') ADVANCE(238);
      END_STATE();
    case 144:
      if (lookahead == 'i') ADVANCE(239);
      END_STATE();
    case 145:
      if (lookahead == 'u') ADVANCE(240);
      END_STATE();
    case 146:
      if (lookahead == 't') ADVANCE(241);
      END_STATE();
    case 147:
      if (lookahead == 'u') ADVANCE(242);
      END_STATE();
    case 148:
      if (lookahead == 'r') ADVANCE(243);
      END_STATE();
    case 149:
      if (lookahead == 'n') ADVANCE(244);
      END_STATE();
    case 150:
      if (lookahead == 'e') ADVANCE(245);
      END_STATE();
    case 151:
      if (lookahead == 't') ADVANCE(246);
      END_STATE();
    case 152:
      if (lookahead == 'u') ADVANCE(247);
      END_STATE();
    case 153:
      if (lookahead == 't') ADVANCE(248);
      END_STATE();
    case 154:
      if (lookahead == 'p') ADVANCE(249);
      END_STATE();
    case 155:
      if (lookahead == 's') ADVANCE(250);
      END_STATE();
    case 156:
      if (lookahead == 'e') ADVANCE(251);
      if (lookahead == 'o') ADVANCE(252);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 158:
      if (lookahead == 'e') ADVANCE(253);
      END_STATE();
    case 159:
      if (lookahead == 'o') ADVANCE(254);
      END_STATE();
    case 160:
      if (lookahead == 'i') ADVANCE(255);
      END_STATE();
    case 161:
      if (lookahead == 'n') ADVANCE(256);
      END_STATE();
    case 162:
      if (lookahead == 't') ADVANCE(257);
      END_STATE();
    case 163:
      if (lookahead == 'a') ADVANCE(258);
      END_STATE();
    case 164:
      if (lookahead == 'l') ADVANCE(259);
      END_STATE();
    case 165:
      if (lookahead == 'd') ADVANCE(260);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_xor);
      if (lookahead == '_') ADVANCE(261);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_NULL);
      END_STATE();
    case 168:
      if (lookahead == 'M') ADVANCE(262);
      END_STATE();
    case 169:
      if (lookahead == 'g') ADVANCE(263);
      END_STATE();
    case 170:
      if (lookahead == 'm') ADVANCE(264);
      END_STATE();
    case 171:
      if (lookahead == 'e') ADVANCE(265);
      END_STATE();
    case 172:
      if (lookahead == 'e') ADVANCE(266);
      END_STATE();
    case 173:
      if (lookahead == 'i') ADVANCE(267);
      END_STATE();
    case 174:
      if (lookahead == 'm') ADVANCE(268);
      END_STATE();
    case 175:
      if (lookahead == 't') ADVANCE(269);
      END_STATE();
    case 176:
      if (lookahead == 's') ADVANCE(270);
      END_STATE();
    case 177:
      if (lookahead == 'e') ADVANCE(271);
      END_STATE();
    case 178:
      if (lookahead == 'r') ADVANCE(272);
      END_STATE();
    case 179:
      if (lookahead == 'c') ADVANCE(273);
      END_STATE();
    case 180:
      if (lookahead == 'c') ADVANCE(274);
      if (lookahead == 't') ADVANCE(275);
      END_STATE();
    case 181:
      if (lookahead == 's') ADVANCE(276);
      END_STATE();
    case 182:
      if (lookahead == 'n') ADVANCE(277);
      END_STATE();
    case 183:
      if (lookahead == 'r') ADVANCE(278);
      END_STATE();
    case 184:
      if (lookahead == 'l') ADVANCE(279);
      END_STATE();
    case 185:
      if (lookahead == 'a') ADVANCE(280);
      END_STATE();
    case 186:
      if (lookahead == 's') ADVANCE(281);
      END_STATE();
    case 187:
      if (lookahead == 't') ADVANCE(282);
      END_STATE();
    case 188:
      if (lookahead == 'd') ADVANCE(283);
      END_STATE();
    case 189:
      if (lookahead == 'i') ADVANCE(284);
      if (lookahead == 'r') ADVANCE(285);
      END_STATE();
    case 190:
      if (lookahead == 'y') ADVANCE(286);
      END_STATE();
    case 191:
      if (lookahead == 'a') ADVANCE(287);
      END_STATE();
    case 192:
      if (lookahead == 't') ADVANCE(288);
      END_STATE();
    case 193:
      if (lookahead == 'c') ADVANCE(289);
      END_STATE();
    case 194:
      if (lookahead == 'g') ADVANCE(290);
      END_STATE();
    case 195:
      if (lookahead == 'l') ADVANCE(291);
      END_STATE();
    case 196:
      if (lookahead == 'n') ADVANCE(292);
      END_STATE();
    case 197:
      if (lookahead == 'e') ADVANCE(293);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(sym_auto);
      END_STATE();
    case 199:
      if (lookahead == 'n') ADVANCE(294);
      END_STATE();
    case 200:
      if (lookahead == 'r') ADVANCE(295);
      END_STATE();
    case 201:
      if (lookahead == 'k') ADVANCE(296);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(anon_sym_byte);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 204:
      if (lookahead == 'h') ADVANCE(297);
      END_STATE();
    case 205:
      if (lookahead == 's') ADVANCE(298);
      END_STATE();
    case 206:
      if (lookahead == 'w') ADVANCE(299);
      END_STATE();
    case 207:
      if (lookahead == 'e') ADVANCE(300);
      END_STATE();
    case 208:
      if (lookahead == 'i') ADVANCE(301);
      END_STATE();
    case 209:
      if (lookahead == 'l') ADVANCE(302);
      END_STATE();
    case 210:
      if (lookahead == 'e') ADVANCE(303);
      END_STATE();
    case 211:
      if (lookahead == 't') ADVANCE(304);
      END_STATE();
    case 212:
      if (lookahead == 'i') ADVANCE(305);
      END_STATE();
    case 213:
      if (lookahead == 't') ADVANCE(306);
      END_STATE();
    case 214:
      if (lookahead == 'u') ADVANCE(307);
      END_STATE();
    case 215:
      if (lookahead == 'n') ADVANCE(308);
      END_STATE();
    case 216:
      if (lookahead == 't') ADVANCE(309);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 219:
      if (lookahead == 'i') ADVANCE(310);
      END_STATE();
    case 220:
      if (lookahead == 'r') ADVANCE(311);
      END_STATE();
    case 221:
      if (lookahead == 'l') ADVANCE(312);
      END_STATE();
    case 222:
      if (lookahead == 'n') ADVANCE(313);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(anon_sym_goto);
      END_STATE();
    case 224:
      if (lookahead == 'n') ADVANCE(314);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(anon_sym_long);
      END_STATE();
    case 226:
      if (lookahead == 'b') ADVANCE(315);
      END_STATE();
    case 227:
      if (lookahead == 's') ADVANCE(316);
      END_STATE();
    case 228:
      if (lookahead == 'c') ADVANCE(317);
      END_STATE();
    case 229:
      if (lookahead == 't') ADVANCE(318);
      END_STATE();
    case 230:
      if (lookahead == 'e') ADVANCE(319);
      END_STATE();
    case 231:
      if (lookahead == 'p') ADVANCE(320);
      END_STATE();
    case 232:
      if (lookahead == 'e') ADVANCE(321);
      END_STATE();
    case 233:
      if (lookahead == 'a') ADVANCE(322);
      END_STATE();
    case 234:
      if (lookahead == 'q') ADVANCE(323);
      END_STATE();
    case 235:
      if (lookahead == 'r') ADVANCE(324);
      END_STATE();
    case 236:
      if (lookahead == 'a') ADVANCE(325);
      END_STATE();
    case 237:
      if (lookahead == 'e') ADVANCE(326);
      END_STATE();
    case 238:
      if (lookahead == 'i') ADVANCE(327);
      END_STATE();
    case 239:
      if (lookahead == 's') ADVANCE(328);
      END_STATE();
    case 240:
      if (lookahead == 'i') ADVANCE(329);
      END_STATE();
    case 241:
      if (lookahead == 'r') ADVANCE(330);
      END_STATE();
    case 242:
      if (lookahead == 'r') ADVANCE(331);
      END_STATE();
    case 243:
      if (lookahead == 't') ADVANCE(332);
      END_STATE();
    case 244:
      if (lookahead == 'e') ADVANCE(333);
      END_STATE();
    case 245:
      if (lookahead == 'o') ADVANCE(334);
      END_STATE();
    case 246:
      if (lookahead == 'i') ADVANCE(335);
      END_STATE();
    case 247:
      if (lookahead == 'c') ADVANCE(336);
      END_STATE();
    case 248:
      if (lookahead == 'c') ADVANCE(337);
      END_STATE();
    case 249:
      if (lookahead == 'l') ADVANCE(338);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(sym_this);
      END_STATE();
    case 251:
      if (lookahead == 'a') ADVANCE(339);
      END_STATE();
    case 252:
      if (lookahead == 'w') ADVANCE(340);
      END_STATE();
    case 253:
      if (lookahead == 'd') ADVANCE(341);
      if (lookahead == 'n') ADVANCE(342);
      END_STATE();
    case 254:
      if (lookahead == 'n') ADVANCE(343);
      END_STATE();
    case 255:
      if (lookahead == 'g') ADVANCE(344);
      END_STATE();
    case 256:
      if (lookahead == 'g') ADVANCE(345);
      END_STATE();
    case 257:
      if (lookahead == 'u') ADVANCE(346);
      END_STATE();
    case 258:
      if (lookahead == 't') ADVANCE(347);
      END_STATE();
    case 259:
      if (lookahead == 'e') ADVANCE(348);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(anon_sym_word);
      END_STATE();
    case 261:
      if (lookahead == 'e') ADVANCE(349);
      END_STATE();
    case 262:
      if (lookahead == 'E') ADVANCE(350);
      END_STATE();
    case 263:
      if (lookahead == 'n') ADVANCE(351);
      END_STATE();
    case 264:
      if (lookahead == 'i') ADVANCE(352);
      END_STATE();
    case 265:
      if (lookahead == 'r') ADVANCE(353);
      END_STATE();
    case 266:
      if (lookahead == 't') ADVANCE(354);
      END_STATE();
    case 267:
      if (lookahead == 'g') ADVANCE(355);
      END_STATE();
    case 268:
      if (lookahead == '_') ADVANCE(356);
      END_STATE();
    case 269:
      if (lookahead == 'r') ADVANCE(357);
      END_STATE();
    case 270:
      if (lookahead == 'e') ADVANCE(358);
      END_STATE();
    case 271:
      if (lookahead == 'c') ADVANCE(359);
      END_STATE();
    case 272:
      if (lookahead == 'c') ADVANCE(360);
      END_STATE();
    case 273:
      if (lookahead == 'l') ADVANCE(361);
      END_STATE();
    case 274:
      if (lookahead == 'e') ADVANCE(362);
      END_STATE();
    case 275:
      if (lookahead == 'e') ADVANCE(363);
      END_STATE();
    case 276:
      if (lookahead == 't') ADVANCE(364);
      END_STATE();
    case 277:
      if (lookahead == 'a') ADVANCE(365);
      END_STATE();
    case 278:
      if (lookahead == 'c') ADVANCE(366);
      END_STATE();
    case 279:
      if (lookahead == 'i') ADVANCE(367);
      END_STATE();
    case 280:
      if (lookahead == 'v') ADVANCE(368);
      END_STATE();
    case 281:
      if (lookahead == 't') ADVANCE(369);
      END_STATE();
    case 282:
      if (lookahead == 'r') ADVANCE(370);
      END_STATE();
    case 283:
      if (lookahead == 'c') ADVANCE(371);
      END_STATE();
    case 284:
      if (lookahead == 's') ADVANCE(372);
      END_STATE();
    case 285:
      if (lookahead == 'e') ADVANCE(373);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(anon_sym___try);
      END_STATE();
    case 287:
      if (lookahead == 'l') ADVANCE(374);
      END_STATE();
    case 288:
      if (lookahead == 'r') ADVANCE(375);
      END_STATE();
    case 289:
      if (lookahead == 't') ADVANCE(376);
      END_STATE();
    case 290:
      if (lookahead == 'n') ADVANCE(377);
      END_STATE();
    case 291:
      if (lookahead == 'i') ADVANCE(378);
      END_STATE();
    case 292:
      if (lookahead == 'a') ADVANCE(379);
      if (lookahead == 'o') ADVANCE(380);
      END_STATE();
    case 293:
      if (lookahead == 'q') ADVANCE(381);
      END_STATE();
    case 294:
      if (lookahead == 'd') ADVANCE(382);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(anon_sym_bitor);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 297:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 298:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 299:
      if (lookahead == 'a') ADVANCE(383);
      END_STATE();
    case 300:
      if (lookahead == 't') ADVANCE(384);
      END_STATE();
    case 301:
      if (lookahead == 'e') ADVANCE(385);
      END_STATE();
    case 302:
      ACCEPT_TOKEN(anon_sym_compl);
      END_STATE();
    case 303:
      if (lookahead == 'p') ADVANCE(386);
      END_STATE();
    case 304:
      ACCEPT_TOKEN(anon_sym_const);
      if (lookahead == 'e') ADVANCE(387);
      if (lookahead == 'i') ADVANCE(388);
      END_STATE();
    case 305:
      if (lookahead == 'n') ADVANCE(389);
      END_STATE();
    case 306:
      if (lookahead == 'y') ADVANCE(390);
      END_STATE();
    case 307:
      if (lookahead == 'l') ADVANCE(391);
      END_STATE();
    case 308:
      if (lookahead == 'e') ADVANCE(392);
      END_STATE();
    case 309:
      if (lookahead == 'e') ADVANCE(393);
      END_STATE();
    case 310:
      if (lookahead == 'c') ADVANCE(394);
      END_STATE();
    case 311:
      if (lookahead == 'n') ADVANCE(395);
      END_STATE();
    case 312:
      ACCEPT_TOKEN(anon_sym_final);
      END_STATE();
    case 313:
      if (lookahead == 'd') ADVANCE(396);
      END_STATE();
    case 314:
      if (lookahead == 'e') ADVANCE(397);
      END_STATE();
    case 315:
      if (lookahead == 'l') ADVANCE(398);
      END_STATE();
    case 316:
      if (lookahead == 'p') ADVANCE(399);
      END_STATE();
    case 317:
      if (lookahead == 'e') ADVANCE(400);
      END_STATE();
    case 318:
      if (lookahead == 'u') ADVANCE(401);
      END_STATE();
    case 319:
      if (lookahead == 'q') ADVANCE(402);
      END_STATE();
    case 320:
      if (lookahead == 't') ADVANCE(403);
      END_STATE();
    case 321:
      if (lookahead == 't') ADVANCE(404);
      END_STATE();
    case 322:
      if (lookahead == 't') ADVANCE(405);
      END_STATE();
    case 323:
      ACCEPT_TOKEN(anon_sym_or_eq);
      END_STATE();
    case 324:
      if (lookahead == 'i') ADVANCE(406);
      END_STATE();
    case 325:
      if (lookahead == 't') ADVANCE(407);
      END_STATE();
    case 326:
      if (lookahead == 'c') ADVANCE(408);
      END_STATE();
    case 327:
      if (lookahead == 'c') ADVANCE(409);
      END_STATE();
    case 328:
      if (lookahead == 't') ADVANCE(410);
      END_STATE();
    case 329:
      if (lookahead == 'r') ADVANCE(411);
      END_STATE();
    case 330:
      if (lookahead == 'i') ADVANCE(412);
      END_STATE();
    case 331:
      if (lookahead == 'n') ADVANCE(413);
      END_STATE();
    case 332:
      ACCEPT_TOKEN(anon_sym_short);
      END_STATE();
    case 333:
      if (lookahead == 'd') ADVANCE(414);
      END_STATE();
    case 334:
      if (lookahead == 'f') ADVANCE(415);
      END_STATE();
    case 335:
      if (lookahead == 'c') ADVANCE(416);
      END_STATE();
    case 336:
      if (lookahead == 't') ADVANCE(417);
      END_STATE();
    case 337:
      if (lookahead == 'h') ADVANCE(418);
      END_STATE();
    case 338:
      if (lookahead == 'a') ADVANCE(419);
      END_STATE();
    case 339:
      if (lookahead == 'd') ADVANCE(420);
      END_STATE();
    case 340:
      ACCEPT_TOKEN(anon_sym_throw);
      END_STATE();
    case 341:
      if (lookahead == 'e') ADVANCE(421);
      END_STATE();
    case 342:
      if (lookahead == 'a') ADVANCE(422);
      END_STATE();
    case 343:
      ACCEPT_TOKEN(anon_sym_union);
      END_STATE();
    case 344:
      if (lookahead == 'n') ADVANCE(423);
      END_STATE();
    case 345:
      ACCEPT_TOKEN(anon_sym_using);
      END_STATE();
    case 346:
      if (lookahead == 'a') ADVANCE(424);
      END_STATE();
    case 347:
      if (lookahead == 'i') ADVANCE(425);
      END_STATE();
    case 348:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 349:
      if (lookahead == 'q') ADVANCE(426);
      END_STATE();
    case 350:
      if (lookahead == 'M') ADVANCE(427);
      END_STATE();
    case 351:
      if (lookahead == 'o') ADVANCE(428);
      END_STATE();
    case 352:
      if (lookahead == 'c') ADVANCE(429);
      END_STATE();
    case 353:
      if (lookahead == 'i') ADVANCE(430);
      END_STATE();
    case 354:
      if (lookahead == 'u') ADVANCE(431);
      END_STATE();
    case 355:
      if (lookahead == 'n') ADVANCE(432);
      END_STATE();
    case 356:
      if (lookahead == '_') ADVANCE(433);
      END_STATE();
    case 357:
      if (lookahead == 'i') ADVANCE(434);
      END_STATE();
    case 358:
      if (lookahead == 'd') ADVANCE(435);
      END_STATE();
    case 359:
      if (lookahead == 'l') ADVANCE(436);
      END_STATE();
    case 360:
      if (lookahead == 'a') ADVANCE(437);
      END_STATE();
    case 361:
      if (lookahead == 's') ADVANCE(438);
      END_STATE();
    case 362:
      if (lookahead == 'p') ADVANCE(439);
      END_STATE();
    case 363:
      if (lookahead == 'n') ADVANCE(440);
      END_STATE();
    case 364:
      if (lookahead == 'c') ADVANCE(441);
      END_STATE();
    case 365:
      if (lookahead == 'l') ADVANCE(442);
      END_STATE();
    case 366:
      if (lookahead == 'e') ADVANCE(443);
      END_STATE();
    case 367:
      if (lookahead == 'n') ADVANCE(444);
      END_STATE();
    case 368:
      if (lookahead == 'e') ADVANCE(445);
      END_STATE();
    case 369:
      if (lookahead == 'r') ADVANCE(446);
      END_STATE();
    case 370:
      ACCEPT_TOKEN(sym_ms_signed_ptr_modifier);
      END_STATE();
    case 371:
      if (lookahead == 'a') ADVANCE(447);
      END_STATE();
    case 372:
      if (lookahead == 'c') ADVANCE(448);
      END_STATE();
    case 373:
      if (lookahead == 'a') ADVANCE(449);
      END_STATE();
    case 374:
      if (lookahead == 'i') ADVANCE(450);
      END_STATE();
    case 375:
      ACCEPT_TOKEN(sym_ms_unsigned_ptr_modifier);
      END_STATE();
    case 376:
      if (lookahead == 'o') ADVANCE(451);
      END_STATE();
    case 377:
      if (lookahead == 'o') ADVANCE(452);
      END_STATE();
    case 378:
      if (lookahead == 'g') ADVANCE(453);
      END_STATE();
    case 379:
      if (lookahead == 's') ADVANCE(454);
      END_STATE();
    case 380:
      if (lookahead == 'f') ADVANCE(455);
      END_STATE();
    case 381:
      ACCEPT_TOKEN(anon_sym_and_eq);
      END_STATE();
    case 382:
      ACCEPT_TOKEN(anon_sym_bitand);
      END_STATE();
    case 383:
      if (lookahead == 'i') ADVANCE(456);
      END_STATE();
    case 384:
      if (lookahead == 'u') ADVANCE(457);
      END_STATE();
    case 385:
      if (lookahead == 'l') ADVANCE(458);
      END_STATE();
    case 386:
      if (lookahead == 't') ADVANCE(459);
      END_STATE();
    case 387:
      if (lookahead == 'v') ADVANCE(460);
      if (lookahead == 'x') ADVANCE(461);
      END_STATE();
    case 388:
      if (lookahead == 'n') ADVANCE(462);
      END_STATE();
    case 389:
      if (lookahead == 'u') ADVANCE(463);
      END_STATE();
    case 390:
      if (lookahead == 'p') ADVANCE(464);
      END_STATE();
    case 391:
      if (lookahead == 't') ADVANCE(465);
      END_STATE();
    case 392:
      if (lookahead == 'd') ADVANCE(466);
      END_STATE();
    case 393:
      ACCEPT_TOKEN(anon_sym_delete);
      END_STATE();
    case 394:
      if (lookahead == 'i') ADVANCE(467);
      END_STATE();
    case 395:
      ACCEPT_TOKEN(anon_sym_extern);
      END_STATE();
    case 396:
      ACCEPT_TOKEN(anon_sym_friend);
      END_STATE();
    case 397:
      ACCEPT_TOKEN(anon_sym_inline);
      END_STATE();
    case 398:
      if (lookahead == 'e') ADVANCE(468);
      END_STATE();
    case 399:
      if (lookahead == 'a') ADVANCE(469);
      END_STATE();
    case 400:
      if (lookahead == 'p') ADVANCE(470);
      END_STATE();
    case 401:
      if (lookahead == 'r') ADVANCE(471);
      END_STATE();
    case 402:
      ACCEPT_TOKEN(anon_sym_not_eq);
      END_STATE();
    case 403:
      if (lookahead == 'r') ADVANCE(472);
      END_STATE();
    case 404:
      if (lookahead == 'o') ADVANCE(473);
      END_STATE();
    case 405:
      if (lookahead == 'o') ADVANCE(474);
      END_STATE();
    case 406:
      if (lookahead == 'd') ADVANCE(475);
      END_STATE();
    case 407:
      if (lookahead == 'e') ADVANCE(476);
      END_STATE();
    case 408:
      if (lookahead == 't') ADVANCE(477);
      END_STATE();
    case 409:
      ACCEPT_TOKEN(anon_sym_public);
      END_STATE();
    case 410:
      if (lookahead == 'e') ADVANCE(478);
      END_STATE();
    case 411:
      if (lookahead == 'e') ADVANCE(479);
      END_STATE();
    case 412:
      if (lookahead == 'c') ADVANCE(480);
      END_STATE();
    case 413:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 414:
      ACCEPT_TOKEN(anon_sym_signed);
      END_STATE();
    case 415:
      ACCEPT_TOKEN(anon_sym_sizeof);
      END_STATE();
    case 416:
      ACCEPT_TOKEN(anon_sym_static);
      if (lookahead == '_') ADVANCE(481);
      END_STATE();
    case 417:
      ACCEPT_TOKEN(anon_sym_struct);
      END_STATE();
    case 418:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 419:
      if (lookahead == 't') ADVANCE(482);
      END_STATE();
    case 420:
      if (lookahead == '_') ADVANCE(483);
      END_STATE();
    case 421:
      if (lookahead == 'f') ADVANCE(484);
      END_STATE();
    case 422:
      if (lookahead == 'm') ADVANCE(485);
      END_STATE();
    case 423:
      if (lookahead == 'e') ADVANCE(486);
      END_STATE();
    case 424:
      if (lookahead == 'l') ADVANCE(487);
      END_STATE();
    case 425:
      if (lookahead == 'l') ADVANCE(488);
      END_STATE();
    case 426:
      ACCEPT_TOKEN(anon_sym_xor_eq);
      END_STATE();
    case 427:
      ACCEPT_TOKEN(anon_sym_PROGMEM);
      END_STATE();
    case 428:
      if (lookahead == 'f') ADVANCE(489);
      END_STATE();
    case 429:
      ACCEPT_TOKEN(anon_sym__Atomic);
      END_STATE();
    case 430:
      if (lookahead == 'c') ADVANCE(490);
      END_STATE();
    case 431:
      if (lookahead == 'r') ADVANCE(491);
      END_STATE();
    case 432:
      if (lookahead == 'o') ADVANCE(492);
      END_STATE();
    case 433:
      ACCEPT_TOKEN(anon_sym___asm__);
      END_STATE();
    case 434:
      if (lookahead == 'b') ADVANCE(493);
      END_STATE();
    case 435:
      ACCEPT_TOKEN(anon_sym___based);
      END_STATE();
    case 436:
      ACCEPT_TOKEN(anon_sym___cdecl);
      END_STATE();
    case 437:
      if (lookahead == 'l') ADVANCE(494);
      END_STATE();
    case 438:
      if (lookahead == 'p') ADVANCE(495);
      END_STATE();
    case 439:
      if (lookahead == 't') ADVANCE(496);
      END_STATE();
    case 440:
      if (lookahead == 's') ADVANCE(497);
      END_STATE();
    case 441:
      if (lookahead == 'a') ADVANCE(498);
      END_STATE();
    case 442:
      if (lookahead == 'l') ADVANCE(499);
      END_STATE();
    case 443:
      if (lookahead == 'i') ADVANCE(500);
      END_STATE();
    case 444:
      if (lookahead == 'e') ADVANCE(501);
      END_STATE();
    case 445:
      ACCEPT_TOKEN(anon_sym___leave);
      END_STATE();
    case 446:
      if (lookahead == 'i') ADVANCE(502);
      END_STATE();
    case 447:
      if (lookahead == 'l') ADVANCE(503);
      END_STATE();
    case 448:
      if (lookahead == 'a') ADVANCE(504);
      END_STATE();
    case 449:
      if (lookahead == 'd') ADVANCE(505);
      END_STATE();
    case 450:
      if (lookahead == 'g') ADVANCE(506);
      END_STATE();
    case 451:
      if (lookahead == 'r') ADVANCE(507);
      END_STATE();
    case 452:
      if (lookahead == 'f') ADVANCE(508);
      END_STATE();
    case 453:
      if (lookahead == 'n') ADVANCE(509);
      END_STATE();
    case 454:
      ACCEPT_TOKEN(anon_sym_alignas);
      END_STATE();
    case 455:
      ACCEPT_TOKEN(anon_sym_alignof);
      END_STATE();
    case 456:
      if (lookahead == 't') ADVANCE(510);
      END_STATE();
    case 457:
      if (lookahead == 'r') ADVANCE(511);
      END_STATE();
    case 458:
      if (lookahead == 'd') ADVANCE(512);
      END_STATE();
    case 459:
      ACCEPT_TOKEN(anon_sym_concept);
      END_STATE();
    case 460:
      if (lookahead == 'a') ADVANCE(513);
      END_STATE();
    case 461:
      if (lookahead == 'p') ADVANCE(514);
      END_STATE();
    case 462:
      if (lookahead == 'i') ADVANCE(515);
      END_STATE();
    case 463:
      if (lookahead == 'e') ADVANCE(516);
      END_STATE();
    case 464:
      if (lookahead == 'e') ADVANCE(517);
      END_STATE();
    case 465:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 466:
      ACCEPT_TOKEN(anon_sym_defined);
      END_STATE();
    case 467:
      if (lookahead == 't') ADVANCE(518);
      END_STATE();
    case 468:
      ACCEPT_TOKEN(anon_sym_mutable);
      END_STATE();
    case 469:
      if (lookahead == 'c') ADVANCE(519);
      END_STATE();
    case 470:
      if (lookahead == 't') ADVANCE(520);
      END_STATE();
    case 471:
      if (lookahead == 'n') ADVANCE(521);
      END_STATE();
    case 472:
      ACCEPT_TOKEN(anon_sym_nullptr);
      END_STATE();
    case 473:
      if (lookahead == 'f') ADVANCE(522);
      END_STATE();
    case 474:
      if (lookahead == 'r') ADVANCE(523);
      END_STATE();
    case 475:
      if (lookahead == 'e') ADVANCE(524);
      END_STATE();
    case 476:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 477:
      if (lookahead == 'e') ADVANCE(525);
      END_STATE();
    case 478:
      if (lookahead == 'r') ADVANCE(526);
      END_STATE();
    case 479:
      if (lookahead == 's') ADVANCE(527);
      END_STATE();
    case 480:
      if (lookahead == 't') ADVANCE(528);
      END_STATE();
    case 481:
      if (lookahead == 'a') ADVANCE(529);
      END_STATE();
    case 482:
      if (lookahead == 'e') ADVANCE(530);
      END_STATE();
    case 483:
      if (lookahead == 'l') ADVANCE(531);
      END_STATE();
    case 484:
      ACCEPT_TOKEN(anon_sym_typedef);
      END_STATE();
    case 485:
      if (lookahead == 'e') ADVANCE(532);
      END_STATE();
    case 486:
      if (lookahead == 'd') ADVANCE(533);
      END_STATE();
    case 487:
      ACCEPT_TOKEN(anon_sym_virtual);
      END_STATE();
    case 488:
      if (lookahead == 'e') ADVANCE(534);
      END_STATE();
    case 489:
      ACCEPT_TOKEN(anon_sym__Alignof);
      END_STATE();
    case 490:
      ACCEPT_TOKEN(anon_sym__Generic);
      END_STATE();
    case 491:
      if (lookahead == 'n') ADVANCE(535);
      END_STATE();
    case 492:
      if (lookahead == 'f') ADVANCE(536);
      END_STATE();
    case 493:
      if (lookahead == 'u') ADVANCE(537);
      END_STATE();
    case 494:
      if (lookahead == 'l') ADVANCE(538);
      END_STATE();
    case 495:
      if (lookahead == 'e') ADVANCE(539);
      END_STATE();
    case 496:
      ACCEPT_TOKEN(anon_sym___except);
      END_STATE();
    case 497:
      if (lookahead == 'i') ADVANCE(540);
      END_STATE();
    case 498:
      if (lookahead == 'l') ADVANCE(541);
      END_STATE();
    case 499:
      if (lookahead == 'y') ADVANCE(542);
      END_STATE();
    case 500:
      if (lookahead == 'n') ADVANCE(543);
      END_STATE();
    case 501:
      ACCEPT_TOKEN(anon_sym___inline);
      if (lookahead == '_') ADVANCE(544);
      END_STATE();
    case 502:
      if (lookahead == 'c') ADVANCE(545);
      END_STATE();
    case 503:
      if (lookahead == 'l') ADVANCE(546);
      END_STATE();
    case 504:
      if (lookahead == 'l') ADVANCE(547);
      END_STATE();
    case 505:
      ACCEPT_TOKEN(anon_sym___thread);
      END_STATE();
    case 506:
      if (lookahead == 'n') ADVANCE(548);
      END_STATE();
    case 507:
      if (lookahead == 'c') ADVANCE(549);
      END_STATE();
    case 508:
      ACCEPT_TOKEN(anon_sym__alignof);
      END_STATE();
    case 509:
      if (lookahead == 'e') ADVANCE(550);
      END_STATE();
    case 510:
      ACCEPT_TOKEN(anon_sym_co_await);
      END_STATE();
    case 511:
      if (lookahead == 'n') ADVANCE(551);
      END_STATE();
    case 512:
      ACCEPT_TOKEN(anon_sym_co_yield);
      END_STATE();
    case 513:
      if (lookahead == 'l') ADVANCE(552);
      END_STATE();
    case 514:
      if (lookahead == 'r') ADVANCE(553);
      END_STATE();
    case 515:
      if (lookahead == 't') ADVANCE(554);
      END_STATE();
    case 516:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 517:
      ACCEPT_TOKEN(anon_sym_decltype);
      END_STATE();
    case 518:
      ACCEPT_TOKEN(anon_sym_explicit);
      END_STATE();
    case 519:
      if (lookahead == 'e') ADVANCE(555);
      END_STATE();
    case 520:
      ACCEPT_TOKEN(anon_sym_noexcept);
      END_STATE();
    case 521:
      ACCEPT_TOKEN(anon_sym_noreturn);
      END_STATE();
    case 522:
      ACCEPT_TOKEN(anon_sym_offsetof);
      END_STATE();
    case 523:
      ACCEPT_TOKEN(anon_sym_operator);
      END_STATE();
    case 524:
      ACCEPT_TOKEN(anon_sym_override);
      END_STATE();
    case 525:
      if (lookahead == 'd') ADVANCE(556);
      END_STATE();
    case 526:
      ACCEPT_TOKEN(anon_sym_register);
      END_STATE();
    case 527:
      ACCEPT_TOKEN(anon_sym_requires);
      END_STATE();
    case 528:
      ACCEPT_TOKEN(anon_sym_restrict);
      END_STATE();
    case 529:
      if (lookahead == 's') ADVANCE(557);
      END_STATE();
    case 530:
      ACCEPT_TOKEN(anon_sym_template);
      END_STATE();
    case 531:
      if (lookahead == 'o') ADVANCE(558);
      END_STATE();
    case 532:
      ACCEPT_TOKEN(anon_sym_typename);
      END_STATE();
    case 533:
      ACCEPT_TOKEN(anon_sym_unsigned);
      END_STATE();
    case 534:
      ACCEPT_TOKEN(anon_sym_volatile);
      END_STATE();
    case 535:
      ACCEPT_TOKEN(anon_sym__Noreturn);
      END_STATE();
    case 536:
      ACCEPT_TOKEN(anon_sym___alignof);
      if (lookahead == '_') ADVANCE(559);
      END_STATE();
    case 537:
      if (lookahead == 't') ADVANCE(560);
      END_STATE();
    case 538:
      ACCEPT_TOKEN(anon_sym___clrcall);
      END_STATE();
    case 539:
      if (lookahead == 'c') ADVANCE(561);
      END_STATE();
    case 540:
      if (lookahead == 'o') ADVANCE(562);
      END_STATE();
    case 541:
      if (lookahead == 'l') ADVANCE(563);
      END_STATE();
    case 542:
      ACCEPT_TOKEN(anon_sym___finally);
      END_STATE();
    case 543:
      if (lookahead == 'l') ADVANCE(564);
      END_STATE();
    case 544:
      if (lookahead == '_') ADVANCE(565);
      END_STATE();
    case 545:
      if (lookahead == 't') ADVANCE(566);
      END_STATE();
    case 546:
      ACCEPT_TOKEN(anon_sym___stdcall);
      END_STATE();
    case 547:
      if (lookahead == 'l') ADVANCE(567);
      END_STATE();
    case 548:
      if (lookahead == 'e') ADVANCE(568);
      END_STATE();
    case 549:
      if (lookahead == 'a') ADVANCE(569);
      END_STATE();
    case 550:
      if (lookahead == 'd') ADVANCE(570);
      END_STATE();
    case 551:
      ACCEPT_TOKEN(anon_sym_co_return);
      END_STATE();
    case 552:
      ACCEPT_TOKEN(anon_sym_consteval);
      END_STATE();
    case 553:
      ACCEPT_TOKEN(anon_sym_constexpr);
      END_STATE();
    case 554:
      ACCEPT_TOKEN(anon_sym_constinit);
      END_STATE();
    case 555:
      ACCEPT_TOKEN(anon_sym_namespace);
      END_STATE();
    case 556:
      ACCEPT_TOKEN(anon_sym_protected);
      END_STATE();
    case 557:
      if (lookahead == 's') ADVANCE(571);
      END_STATE();
    case 558:
      if (lookahead == 'c') ADVANCE(572);
      END_STATE();
    case 559:
      if (lookahead == '_') ADVANCE(573);
      END_STATE();
    case 560:
      if (lookahead == 'e') ADVANCE(574);
      END_STATE();
    case 561:
      ACCEPT_TOKEN(anon_sym___declspec);
      END_STATE();
    case 562:
      if (lookahead == 'n') ADVANCE(575);
      END_STATE();
    case 563:
      ACCEPT_TOKEN(anon_sym___fastcall);
      END_STATE();
    case 564:
      if (lookahead == 'i') ADVANCE(576);
      END_STATE();
    case 565:
      ACCEPT_TOKEN(anon_sym___inline__);
      END_STATE();
    case 566:
      ACCEPT_TOKEN(sym_ms_restrict_modifier);
      if (lookahead == '_') ADVANCE(577);
      END_STATE();
    case 567:
      ACCEPT_TOKEN(anon_sym___thiscall);
      END_STATE();
    case 568:
      if (lookahead == 'd') ADVANCE(578);
      END_STATE();
    case 569:
      if (lookahead == 'l') ADVANCE(579);
      END_STATE();
    case 570:
      ACCEPT_TOKEN(anon_sym__unaligned);
      END_STATE();
    case 571:
      if (lookahead == 'e') ADVANCE(580);
      END_STATE();
    case 572:
      if (lookahead == 'a') ADVANCE(581);
      END_STATE();
    case 573:
      ACCEPT_TOKEN(anon_sym___alignof__);
      END_STATE();
    case 574:
      if (lookahead == '_') ADVANCE(582);
      END_STATE();
    case 575:
      if (lookahead == '_') ADVANCE(583);
      END_STATE();
    case 576:
      if (lookahead == 'n') ADVANCE(584);
      END_STATE();
    case 577:
      if (lookahead == '_') ADVANCE(585);
      END_STATE();
    case 578:
      ACCEPT_TOKEN(anon_sym___unaligned);
      END_STATE();
    case 579:
      if (lookahead == 'l') ADVANCE(586);
      END_STATE();
    case 580:
      if (lookahead == 'r') ADVANCE(587);
      END_STATE();
    case 581:
      if (lookahead == 'l') ADVANCE(588);
      END_STATE();
    case 582:
      if (lookahead == '_') ADVANCE(589);
      END_STATE();
    case 583:
      if (lookahead == '_') ADVANCE(590);
      END_STATE();
    case 584:
      if (lookahead == 'e') ADVANCE(591);
      END_STATE();
    case 585:
      ACCEPT_TOKEN(anon_sym___restrict__);
      END_STATE();
    case 586:
      ACCEPT_TOKEN(anon_sym___vectorcall);
      END_STATE();
    case 587:
      if (lookahead == 't') ADVANCE(592);
      END_STATE();
    case 588:
      ACCEPT_TOKEN(anon_sym_thread_local);
      END_STATE();
    case 589:
      ACCEPT_TOKEN(anon_sym___attribute__);
      END_STATE();
    case 590:
      ACCEPT_TOKEN(anon_sym___extension__);
      END_STATE();
    case 591:
      ACCEPT_TOKEN(anon_sym___forceinline);
      END_STATE();
    case 592:
      ACCEPT_TOKEN(anon_sym_static_assert);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 335},
  [2] = {.lex_state = 335},
  [3] = {.lex_state = 335},
  [4] = {.lex_state = 335},
  [5] = {.lex_state = 335},
  [6] = {.lex_state = 335},
  [7] = {.lex_state = 335},
  [8] = {.lex_state = 335},
  [9] = {.lex_state = 335},
  [10] = {.lex_state = 335},
  [11] = {.lex_state = 335},
  [12] = {.lex_state = 335},
  [13] = {.lex_state = 169},
  [14] = {.lex_state = 169},
  [15] = {.lex_state = 169},
  [16] = {.lex_state = 169},
  [17] = {.lex_state = 169},
  [18] = {.lex_state = 169},
  [19] = {.lex_state = 169},
  [20] = {.lex_state = 169},
  [21] = {.lex_state = 169},
  [22] = {.lex_state = 169},
  [23] = {.lex_state = 169},
  [24] = {.lex_state = 169},
  [25] = {.lex_state = 169},
  [26] = {.lex_state = 169},
  [27] = {.lex_state = 169},
  [28] = {.lex_state = 169},
  [29] = {.lex_state = 169},
  [30] = {.lex_state = 169},
  [31] = {.lex_state = 169},
  [32] = {.lex_state = 169},
  [33] = {.lex_state = 169},
  [34] = {.lex_state = 335},
  [35] = {.lex_state = 335},
  [36] = {.lex_state = 335},
  [37] = {.lex_state = 335},
  [38] = {.lex_state = 335},
  [39] = {.lex_state = 335},
  [40] = {.lex_state = 335},
  [41] = {.lex_state = 335},
  [42] = {.lex_state = 335},
  [43] = {.lex_state = 335},
  [44] = {.lex_state = 335},
  [45] = {.lex_state = 335},
  [46] = {.lex_state = 335},
  [47] = {.lex_state = 335},
  [48] = {.lex_state = 335},
  [49] = {.lex_state = 335},
  [50] = {.lex_state = 335},
  [51] = {.lex_state = 172},
  [52] = {.lex_state = 335},
  [53] = {.lex_state = 335},
  [54] = {.lex_state = 335},
  [55] = {.lex_state = 335},
  [56] = {.lex_state = 335},
  [57] = {.lex_state = 335},
  [58] = {.lex_state = 335},
  [59] = {.lex_state = 335},
  [60] = {.lex_state = 335},
  [61] = {.lex_state = 335},
  [62] = {.lex_state = 335},
  [63] = {.lex_state = 335},
  [64] = {.lex_state = 335},
  [65] = {.lex_state = 335},
  [66] = {.lex_state = 172},
  [67] = {.lex_state = 172},
  [68] = {.lex_state = 335},
  [69] = {.lex_state = 335},
  [70] = {.lex_state = 335},
  [71] = {.lex_state = 335},
  [72] = {.lex_state = 335},
  [73] = {.lex_state = 335},
  [74] = {.lex_state = 335},
  [75] = {.lex_state = 335},
  [76] = {.lex_state = 335},
  [77] = {.lex_state = 335},
  [78] = {.lex_state = 335},
  [79] = {.lex_state = 335},
  [80] = {.lex_state = 335},
  [81] = {.lex_state = 335},
  [82] = {.lex_state = 169},
  [83] = {.lex_state = 169},
  [84] = {.lex_state = 169},
  [85] = {.lex_state = 169},
  [86] = {.lex_state = 169},
  [87] = {.lex_state = 335},
  [88] = {.lex_state = 335},
  [89] = {.lex_state = 172},
  [90] = {.lex_state = 172},
  [91] = {.lex_state = 335},
  [92] = {.lex_state = 335},
  [93] = {.lex_state = 172},
  [94] = {.lex_state = 172},
  [95] = {.lex_state = 335},
  [96] = {.lex_state = 335},
  [97] = {.lex_state = 335},
  [98] = {.lex_state = 335},
  [99] = {.lex_state = 172},
  [100] = {.lex_state = 335},
  [101] = {.lex_state = 335},
  [102] = {.lex_state = 171},
  [103] = {.lex_state = 171},
  [104] = {.lex_state = 171},
  [105] = {.lex_state = 171},
  [106] = {.lex_state = 171},
  [107] = {.lex_state = 171},
  [108] = {.lex_state = 171},
  [109] = {.lex_state = 171},
  [110] = {.lex_state = 171},
  [111] = {.lex_state = 171},
  [112] = {.lex_state = 171},
  [113] = {.lex_state = 171},
  [114] = {.lex_state = 171},
  [115] = {.lex_state = 171},
  [116] = {.lex_state = 171},
  [117] = {.lex_state = 171},
  [118] = {.lex_state = 171},
  [119] = {.lex_state = 171},
  [120] = {.lex_state = 171},
  [121] = {.lex_state = 173},
  [122] = {.lex_state = 173},
  [123] = {.lex_state = 173},
  [124] = {.lex_state = 171},
  [125] = {.lex_state = 162},
  [126] = {.lex_state = 162},
  [127] = {.lex_state = 335},
  [128] = {.lex_state = 335},
  [129] = {.lex_state = 171},
  [130] = {.lex_state = 164},
  [131] = {.lex_state = 162},
  [132] = {.lex_state = 171},
  [133] = {.lex_state = 171},
  [134] = {.lex_state = 171},
  [135] = {.lex_state = 171},
  [136] = {.lex_state = 171},
  [137] = {.lex_state = 171},
  [138] = {.lex_state = 171},
  [139] = {.lex_state = 171},
  [140] = {.lex_state = 171},
  [141] = {.lex_state = 171},
  [142] = {.lex_state = 171},
  [143] = {.lex_state = 171},
  [144] = {.lex_state = 162},
  [145] = {.lex_state = 171},
  [146] = {.lex_state = 171},
  [147] = {.lex_state = 171},
  [148] = {.lex_state = 171},
  [149] = {.lex_state = 171},
  [150] = {.lex_state = 171},
  [151] = {.lex_state = 171},
  [152] = {.lex_state = 171},
  [153] = {.lex_state = 171},
  [154] = {.lex_state = 171},
  [155] = {.lex_state = 171},
  [156] = {.lex_state = 165},
  [157] = {.lex_state = 171},
  [158] = {.lex_state = 171},
  [159] = {.lex_state = 171},
  [160] = {.lex_state = 171},
  [161] = {.lex_state = 171},
  [162] = {.lex_state = 171},
  [163] = {.lex_state = 171},
  [164] = {.lex_state = 171},
  [165] = {.lex_state = 171},
  [166] = {.lex_state = 171},
  [167] = {.lex_state = 171},
  [168] = {.lex_state = 171},
  [169] = {.lex_state = 171},
  [170] = {.lex_state = 171},
  [171] = {.lex_state = 171},
  [172] = {.lex_state = 171},
  [173] = {.lex_state = 171},
  [174] = {.lex_state = 171},
  [175] = {.lex_state = 171},
  [176] = {.lex_state = 171},
  [177] = {.lex_state = 171},
  [178] = {.lex_state = 171},
  [179] = {.lex_state = 171},
  [180] = {.lex_state = 171},
  [181] = {.lex_state = 171},
  [182] = {.lex_state = 171},
  [183] = {.lex_state = 171},
  [184] = {.lex_state = 171},
  [185] = {.lex_state = 171},
  [186] = {.lex_state = 171},
  [187] = {.lex_state = 171},
  [188] = {.lex_state = 171},
  [189] = {.lex_state = 171},
  [190] = {.lex_state = 171},
  [191] = {.lex_state = 171},
  [192] = {.lex_state = 171},
  [193] = {.lex_state = 174},
  [194] = {.lex_state = 174},
  [195] = {.lex_state = 174},
  [196] = {.lex_state = 174},
  [197] = {.lex_state = 174},
  [198] = {.lex_state = 174},
  [199] = {.lex_state = 174},
  [200] = {.lex_state = 174},
  [201] = {.lex_state = 174},
  [202] = {.lex_state = 174},
  [203] = {.lex_state = 174},
  [204] = {.lex_state = 174},
  [205] = {.lex_state = 174},
  [206] = {.lex_state = 174},
  [207] = {.lex_state = 174},
  [208] = {.lex_state = 174},
  [209] = {.lex_state = 174},
  [210] = {.lex_state = 174},
  [211] = {.lex_state = 164},
  [212] = {.lex_state = 174},
  [213] = {.lex_state = 174},
  [214] = {.lex_state = 174},
  [215] = {.lex_state = 174},
  [216] = {.lex_state = 174},
  [217] = {.lex_state = 174},
  [218] = {.lex_state = 174},
  [219] = {.lex_state = 174},
  [220] = {.lex_state = 169},
  [221] = {.lex_state = 169},
  [222] = {.lex_state = 169},
  [223] = {.lex_state = 169},
  [224] = {.lex_state = 169},
  [225] = {.lex_state = 171},
  [226] = {.lex_state = 169},
  [227] = {.lex_state = 169},
  [228] = {.lex_state = 169},
  [229] = {.lex_state = 169},
  [230] = {.lex_state = 171},
  [231] = {.lex_state = 171},
  [232] = {.lex_state = 174},
  [233] = {.lex_state = 169},
  [234] = {.lex_state = 169},
  [235] = {.lex_state = 169},
  [236] = {.lex_state = 174},
  [237] = {.lex_state = 174},
  [238] = {.lex_state = 169},
  [239] = {.lex_state = 169},
  [240] = {.lex_state = 169},
  [241] = {.lex_state = 169},
  [242] = {.lex_state = 174},
  [243] = {.lex_state = 169},
  [244] = {.lex_state = 169},
  [245] = {.lex_state = 169},
  [246] = {.lex_state = 169},
  [247] = {.lex_state = 169},
  [248] = {.lex_state = 169},
  [249] = {.lex_state = 169},
  [250] = {.lex_state = 169},
  [251] = {.lex_state = 169},
  [252] = {.lex_state = 169},
  [253] = {.lex_state = 174},
  [254] = {.lex_state = 169},
  [255] = {.lex_state = 169},
  [256] = {.lex_state = 169},
  [257] = {.lex_state = 169},
  [258] = {.lex_state = 169},
  [259] = {.lex_state = 169},
  [260] = {.lex_state = 169},
  [261] = {.lex_state = 169},
  [262] = {.lex_state = 169},
  [263] = {.lex_state = 169},
  [264] = {.lex_state = 169},
  [265] = {.lex_state = 169},
  [266] = {.lex_state = 169},
  [267] = {.lex_state = 169},
  [268] = {.lex_state = 174},
  [269] = {.lex_state = 169},
  [270] = {.lex_state = 169},
  [271] = {.lex_state = 169},
  [272] = {.lex_state = 169},
  [273] = {.lex_state = 169},
  [274] = {.lex_state = 169},
  [275] = {.lex_state = 169},
  [276] = {.lex_state = 169},
  [277] = {.lex_state = 169},
  [278] = {.lex_state = 169},
  [279] = {.lex_state = 169},
  [280] = {.lex_state = 169},
  [281] = {.lex_state = 169},
  [282] = {.lex_state = 169},
  [283] = {.lex_state = 169},
  [284] = {.lex_state = 169},
  [285] = {.lex_state = 174},
  [286] = {.lex_state = 169},
  [287] = {.lex_state = 169},
  [288] = {.lex_state = 169},
  [289] = {.lex_state = 169},
  [290] = {.lex_state = 169},
  [291] = {.lex_state = 174},
  [292] = {.lex_state = 169},
  [293] = {.lex_state = 169},
  [294] = {.lex_state = 174},
  [295] = {.lex_state = 169},
  [296] = {.lex_state = 169},
  [297] = {.lex_state = 169},
  [298] = {.lex_state = 169},
  [299] = {.lex_state = 169},
  [300] = {.lex_state = 169},
  [301] = {.lex_state = 169},
  [302] = {.lex_state = 169},
  [303] = {.lex_state = 169},
  [304] = {.lex_state = 169},
  [305] = {.lex_state = 169},
  [306] = {.lex_state = 169},
  [307] = {.lex_state = 174},
  [308] = {.lex_state = 169},
  [309] = {.lex_state = 169},
  [310] = {.lex_state = 169},
  [311] = {.lex_state = 174},
  [312] = {.lex_state = 169},
  [313] = {.lex_state = 169},
  [314] = {.lex_state = 169},
  [315] = {.lex_state = 169},
  [316] = {.lex_state = 174},
  [317] = {.lex_state = 169},
  [318] = {.lex_state = 169},
  [319] = {.lex_state = 174},
  [320] = {.lex_state = 174},
  [321] = {.lex_state = 169},
  [322] = {.lex_state = 174},
  [323] = {.lex_state = 174},
  [324] = {.lex_state = 174},
  [325] = {.lex_state = 169},
  [326] = {.lex_state = 169},
  [327] = {.lex_state = 169},
  [328] = {.lex_state = 169},
  [329] = {.lex_state = 169},
  [330] = {.lex_state = 169},
  [331] = {.lex_state = 171},
  [332] = {.lex_state = 237},
  [333] = {.lex_state = 174},
  [334] = {.lex_state = 169},
  [335] = {.lex_state = 237},
  [336] = {.lex_state = 172},
  [337] = {.lex_state = 169},
  [338] = {.lex_state = 169},
  [339] = {.lex_state = 169},
  [340] = {.lex_state = 169},
  [341] = {.lex_state = 169},
  [342] = {.lex_state = 169},
  [343] = {.lex_state = 169},
  [344] = {.lex_state = 335},
  [345] = {.lex_state = 173},
  [346] = {.lex_state = 169},
  [347] = {.lex_state = 169},
  [348] = {.lex_state = 237},
  [349] = {.lex_state = 173},
  [350] = {.lex_state = 169},
  [351] = {.lex_state = 169},
  [352] = {.lex_state = 169},
  [353] = {.lex_state = 169},
  [354] = {.lex_state = 169},
  [355] = {.lex_state = 169},
  [356] = {.lex_state = 335},
  [357] = {.lex_state = 237},
  [358] = {.lex_state = 237},
  [359] = {.lex_state = 169},
  [360] = {.lex_state = 169},
  [361] = {.lex_state = 169},
  [362] = {.lex_state = 169},
  [363] = {.lex_state = 237},
  [364] = {.lex_state = 169},
  [365] = {.lex_state = 169},
  [366] = {.lex_state = 169},
  [367] = {.lex_state = 237},
  [368] = {.lex_state = 335},
  [369] = {.lex_state = 169},
  [370] = {.lex_state = 237},
  [371] = {.lex_state = 169},
  [372] = {.lex_state = 169},
  [373] = {.lex_state = 169},
  [374] = {.lex_state = 169},
  [375] = {.lex_state = 169},
  [376] = {.lex_state = 169},
  [377] = {.lex_state = 169},
  [378] = {.lex_state = 169},
  [379] = {.lex_state = 169},
  [380] = {.lex_state = 169},
  [381] = {.lex_state = 169},
  [382] = {.lex_state = 169},
  [383] = {.lex_state = 169},
  [384] = {.lex_state = 169},
  [385] = {.lex_state = 169},
  [386] = {.lex_state = 169},
  [387] = {.lex_state = 169},
  [388] = {.lex_state = 169},
  [389] = {.lex_state = 237},
  [390] = {.lex_state = 169},
  [391] = {.lex_state = 169},
  [392] = {.lex_state = 169},
  [393] = {.lex_state = 169},
  [394] = {.lex_state = 169},
  [395] = {.lex_state = 335},
  [396] = {.lex_state = 169},
  [397] = {.lex_state = 169},
  [398] = {.lex_state = 237},
  [399] = {.lex_state = 169},
  [400] = {.lex_state = 237},
  [401] = {.lex_state = 237},
  [402] = {.lex_state = 172},
  [403] = {.lex_state = 169},
  [404] = {.lex_state = 169},
  [405] = {.lex_state = 237},
  [406] = {.lex_state = 169},
  [407] = {.lex_state = 169},
  [408] = {.lex_state = 169},
  [409] = {.lex_state = 237},
  [410] = {.lex_state = 237},
  [411] = {.lex_state = 169},
  [412] = {.lex_state = 169},
  [413] = {.lex_state = 169},
  [414] = {.lex_state = 169},
  [415] = {.lex_state = 169},
  [416] = {.lex_state = 169},
  [417] = {.lex_state = 237},
  [418] = {.lex_state = 169},
  [419] = {.lex_state = 169},
  [420] = {.lex_state = 169},
  [421] = {.lex_state = 172},
  [422] = {.lex_state = 335},
  [423] = {.lex_state = 172},
  [424] = {.lex_state = 335},
  [425] = {.lex_state = 335},
  [426] = {.lex_state = 335},
  [427] = {.lex_state = 335},
  [428] = {.lex_state = 172},
  [429] = {.lex_state = 172},
  [430] = {.lex_state = 335},
  [431] = {.lex_state = 172},
  [432] = {.lex_state = 335},
  [433] = {.lex_state = 172},
  [434] = {.lex_state = 335},
  [435] = {.lex_state = 335},
  [436] = {.lex_state = 335},
  [437] = {.lex_state = 172},
  [438] = {.lex_state = 172},
  [439] = {.lex_state = 335},
  [440] = {.lex_state = 335},
  [441] = {.lex_state = 335},
  [442] = {.lex_state = 163},
  [443] = {.lex_state = 172},
  [444] = {.lex_state = 335},
  [445] = {.lex_state = 172},
  [446] = {.lex_state = 335},
  [447] = {.lex_state = 335},
  [448] = {.lex_state = 172},
  [449] = {.lex_state = 335},
  [450] = {.lex_state = 335},
  [451] = {.lex_state = 335},
  [452] = {.lex_state = 335},
  [453] = {.lex_state = 172},
  [454] = {.lex_state = 335},
  [455] = {.lex_state = 335},
  [456] = {.lex_state = 335},
  [457] = {.lex_state = 172},
  [458] = {.lex_state = 335},
  [459] = {.lex_state = 335},
  [460] = {.lex_state = 172},
  [461] = {.lex_state = 172},
  [462] = {.lex_state = 335},
  [463] = {.lex_state = 335},
  [464] = {.lex_state = 335},
  [465] = {.lex_state = 172},
  [466] = {.lex_state = 172},
  [467] = {.lex_state = 172},
  [468] = {.lex_state = 172},
  [469] = {.lex_state = 335},
  [470] = {.lex_state = 172},
  [471] = {.lex_state = 335},
  [472] = {.lex_state = 172},
  [473] = {.lex_state = 335},
  [474] = {.lex_state = 335},
  [475] = {.lex_state = 335},
  [476] = {.lex_state = 335},
  [477] = {.lex_state = 335},
  [478] = {.lex_state = 335},
  [479] = {.lex_state = 172},
  [480] = {.lex_state = 335},
  [481] = {.lex_state = 335},
  [482] = {.lex_state = 335},
  [483] = {.lex_state = 335},
  [484] = {.lex_state = 335},
  [485] = {.lex_state = 335},
  [486] = {.lex_state = 335},
  [487] = {.lex_state = 335},
  [488] = {.lex_state = 335},
  [489] = {.lex_state = 335},
  [490] = {.lex_state = 335},
  [491] = {.lex_state = 335},
  [492] = {.lex_state = 172},
  [493] = {.lex_state = 335},
  [494] = {.lex_state = 335},
  [495] = {.lex_state = 335},
  [496] = {.lex_state = 335},
  [497] = {.lex_state = 335},
  [498] = {.lex_state = 335},
  [499] = {.lex_state = 172},
  [500] = {.lex_state = 172},
  [501] = {.lex_state = 335},
  [502] = {.lex_state = 335},
  [503] = {.lex_state = 335},
  [504] = {.lex_state = 335},
  [505] = {.lex_state = 172},
  [506] = {.lex_state = 172},
  [507] = {.lex_state = 172},
  [508] = {.lex_state = 335},
  [509] = {.lex_state = 335},
  [510] = {.lex_state = 172},
  [511] = {.lex_state = 335},
  [512] = {.lex_state = 172},
  [513] = {.lex_state = 172},
  [514] = {.lex_state = 335},
  [515] = {.lex_state = 172},
  [516] = {.lex_state = 172},
  [517] = {.lex_state = 172},
  [518] = {.lex_state = 172},
  [519] = {.lex_state = 335},
  [520] = {.lex_state = 335},
  [521] = {.lex_state = 335},
  [522] = {.lex_state = 335},
  [523] = {.lex_state = 335},
  [524] = {.lex_state = 335},
  [525] = {.lex_state = 335},
  [526] = {.lex_state = 335},
  [527] = {.lex_state = 335},
  [528] = {.lex_state = 335},
  [529] = {.lex_state = 335},
  [530] = {.lex_state = 335},
  [531] = {.lex_state = 335},
  [532] = {.lex_state = 335},
  [533] = {.lex_state = 335},
  [534] = {.lex_state = 172},
  [535] = {.lex_state = 172},
  [536] = {.lex_state = 335},
  [537] = {.lex_state = 172},
  [538] = {.lex_state = 335},
  [539] = {.lex_state = 335},
  [540] = {.lex_state = 335},
  [541] = {.lex_state = 237},
  [542] = {.lex_state = 335},
  [543] = {.lex_state = 335},
  [544] = {.lex_state = 335},
  [545] = {.lex_state = 172},
  [546] = {.lex_state = 335},
  [547] = {.lex_state = 335},
  [548] = {.lex_state = 335},
  [549] = {.lex_state = 335},
  [550] = {.lex_state = 172},
  [551] = {.lex_state = 335},
  [552] = {.lex_state = 335},
  [553] = {.lex_state = 335},
  [554] = {.lex_state = 335},
  [555] = {.lex_state = 335},
  [556] = {.lex_state = 335},
  [557] = {.lex_state = 335},
  [558] = {.lex_state = 335},
  [559] = {.lex_state = 335},
  [560] = {.lex_state = 335},
  [561] = {.lex_state = 335},
  [562] = {.lex_state = 172},
  [563] = {.lex_state = 335},
  [564] = {.lex_state = 335},
  [565] = {.lex_state = 335},
  [566] = {.lex_state = 172},
  [567] = {.lex_state = 335},
  [568] = {.lex_state = 335},
  [569] = {.lex_state = 172},
  [570] = {.lex_state = 335},
  [571] = {.lex_state = 335},
  [572] = {.lex_state = 335},
  [573] = {.lex_state = 335},
  [574] = {.lex_state = 172},
  [575] = {.lex_state = 335},
  [576] = {.lex_state = 172},
  [577] = {.lex_state = 172},
  [578] = {.lex_state = 172},
  [579] = {.lex_state = 172},
  [580] = {.lex_state = 335},
  [581] = {.lex_state = 172},
  [582] = {.lex_state = 172},
  [583] = {.lex_state = 172},
  [584] = {.lex_state = 172},
  [585] = {.lex_state = 172},
  [586] = {.lex_state = 172},
  [587] = {.lex_state = 335},
  [588] = {.lex_state = 335},
  [589] = {.lex_state = 172},
  [590] = {.lex_state = 335},
  [591] = {.lex_state = 172},
  [592] = {.lex_state = 172},
  [593] = {.lex_state = 335},
  [594] = {.lex_state = 335},
  [595] = {.lex_state = 172},
  [596] = {.lex_state = 172},
  [597] = {.lex_state = 172},
  [598] = {.lex_state = 335},
  [599] = {.lex_state = 172},
  [600] = {.lex_state = 172},
  [601] = {.lex_state = 172},
  [602] = {.lex_state = 335},
  [603] = {.lex_state = 172},
  [604] = {.lex_state = 172},
  [605] = {.lex_state = 172},
  [606] = {.lex_state = 172},
  [607] = {.lex_state = 172},
  [608] = {.lex_state = 172},
  [609] = {.lex_state = 172},
  [610] = {.lex_state = 172},
  [611] = {.lex_state = 335},
  [612] = {.lex_state = 172},
  [613] = {.lex_state = 172},
  [614] = {.lex_state = 335},
  [615] = {.lex_state = 335},
  [616] = {.lex_state = 335},
  [617] = {.lex_state = 335},
  [618] = {.lex_state = 335},
  [619] = {.lex_state = 335},
  [620] = {.lex_state = 172},
  [621] = {.lex_state = 335},
  [622] = {.lex_state = 335},
  [623] = {.lex_state = 172},
  [624] = {.lex_state = 335},
  [625] = {.lex_state = 335},
  [626] = {.lex_state = 335},
  [627] = {.lex_state = 335},
  [628] = {.lex_state = 335},
  [629] = {.lex_state = 335},
  [630] = {.lex_state = 172},
  [631] = {.lex_state = 335},
  [632] = {.lex_state = 335},
  [633] = {.lex_state = 335},
  [634] = {.lex_state = 335},
  [635] = {.lex_state = 335},
  [636] = {.lex_state = 335},
  [637] = {.lex_state = 172},
  [638] = {.lex_state = 172},
  [639] = {.lex_state = 335},
  [640] = {.lex_state = 335},
  [641] = {.lex_state = 172},
  [642] = {.lex_state = 172},
  [643] = {.lex_state = 335},
  [644] = {.lex_state = 172},
  [645] = {.lex_state = 335},
  [646] = {.lex_state = 335},
  [647] = {.lex_state = 335},
  [648] = {.lex_state = 335},
  [649] = {.lex_state = 172},
  [650] = {.lex_state = 335},
  [651] = {.lex_state = 172},
  [652] = {.lex_state = 335},
  [653] = {.lex_state = 335},
  [654] = {.lex_state = 172},
  [655] = {.lex_state = 335},
  [656] = {.lex_state = 335},
  [657] = {.lex_state = 335},
  [658] = {.lex_state = 335},
  [659] = {.lex_state = 335},
  [660] = {.lex_state = 335},
  [661] = {.lex_state = 335},
  [662] = {.lex_state = 335},
  [663] = {.lex_state = 335},
  [664] = {.lex_state = 335},
  [665] = {.lex_state = 335},
  [666] = {.lex_state = 335},
  [667] = {.lex_state = 335},
  [668] = {.lex_state = 335},
  [669] = {.lex_state = 335},
  [670] = {.lex_state = 335},
  [671] = {.lex_state = 172},
  [672] = {.lex_state = 172},
  [673] = {.lex_state = 335},
  [674] = {.lex_state = 172},
  [675] = {.lex_state = 335},
  [676] = {.lex_state = 335},
  [677] = {.lex_state = 172},
  [678] = {.lex_state = 335},
  [679] = {.lex_state = 335},
  [680] = {.lex_state = 335},
  [681] = {.lex_state = 172},
  [682] = {.lex_state = 172},
  [683] = {.lex_state = 335},
  [684] = {.lex_state = 172},
  [685] = {.lex_state = 172},
  [686] = {.lex_state = 335},
  [687] = {.lex_state = 172},
  [688] = {.lex_state = 335},
  [689] = {.lex_state = 335},
  [690] = {.lex_state = 335},
  [691] = {.lex_state = 172},
  [692] = {.lex_state = 172},
  [693] = {.lex_state = 335},
  [694] = {.lex_state = 335},
  [695] = {.lex_state = 335},
  [696] = {.lex_state = 335},
  [697] = {.lex_state = 335},
  [698] = {.lex_state = 335},
  [699] = {.lex_state = 335},
  [700] = {.lex_state = 335},
  [701] = {.lex_state = 335},
  [702] = {.lex_state = 335},
  [703] = {.lex_state = 172},
  [704] = {.lex_state = 172},
  [705] = {.lex_state = 335},
  [706] = {.lex_state = 172},
  [707] = {.lex_state = 172},
  [708] = {.lex_state = 172},
  [709] = {.lex_state = 335},
  [710] = {.lex_state = 172},
  [711] = {.lex_state = 172},
  [712] = {.lex_state = 172},
  [713] = {.lex_state = 172},
  [714] = {.lex_state = 172},
  [715] = {.lex_state = 172},
  [716] = {.lex_state = 172},
  [717] = {.lex_state = 335},
  [718] = {.lex_state = 335},
  [719] = {.lex_state = 335},
  [720] = {.lex_state = 172},
  [721] = {.lex_state = 335},
  [722] = {.lex_state = 335},
  [723] = {.lex_state = 172},
  [724] = {.lex_state = 172},
  [725] = {.lex_state = 335},
  [726] = {.lex_state = 172},
  [727] = {.lex_state = 335},
  [728] = {.lex_state = 335},
  [729] = {.lex_state = 335},
  [730] = {.lex_state = 172},
  [731] = {.lex_state = 335},
  [732] = {.lex_state = 335},
  [733] = {.lex_state = 172},
  [734] = {.lex_state = 172},
  [735] = {.lex_state = 335},
  [736] = {.lex_state = 172},
  [737] = {.lex_state = 335},
  [738] = {.lex_state = 172},
  [739] = {.lex_state = 335},
  [740] = {.lex_state = 335},
  [741] = {.lex_state = 172},
  [742] = {.lex_state = 172},
  [743] = {.lex_state = 172},
  [744] = {.lex_state = 172},
  [745] = {.lex_state = 172},
  [746] = {.lex_state = 335},
  [747] = {.lex_state = 335},
  [748] = {.lex_state = 172},
  [749] = {.lex_state = 172},
  [750] = {.lex_state = 172},
  [751] = {.lex_state = 335},
  [752] = {.lex_state = 335},
  [753] = {.lex_state = 335},
  [754] = {.lex_state = 335},
  [755] = {.lex_state = 172},
  [756] = {.lex_state = 172},
  [757] = {.lex_state = 172},
  [758] = {.lex_state = 335},
  [759] = {.lex_state = 335},
  [760] = {.lex_state = 172},
  [761] = {.lex_state = 335},
  [762] = {.lex_state = 172},
  [763] = {.lex_state = 172},
  [764] = {.lex_state = 172},
  [765] = {.lex_state = 172},
  [766] = {.lex_state = 335},
  [767] = {.lex_state = 172},
  [768] = {.lex_state = 172},
  [769] = {.lex_state = 172},
  [770] = {.lex_state = 172},
  [771] = {.lex_state = 172},
  [772] = {.lex_state = 172},
  [773] = {.lex_state = 335},
  [774] = {.lex_state = 172},
  [775] = {.lex_state = 335},
  [776] = {.lex_state = 335},
  [777] = {.lex_state = 335},
  [778] = {.lex_state = 335},
  [779] = {.lex_state = 172},
  [780] = {.lex_state = 172},
  [781] = {.lex_state = 335},
  [782] = {.lex_state = 172},
  [783] = {.lex_state = 172},
  [784] = {.lex_state = 172},
  [785] = {.lex_state = 172},
  [786] = {.lex_state = 335},
  [787] = {.lex_state = 335},
  [788] = {.lex_state = 172},
  [789] = {.lex_state = 172},
  [790] = {.lex_state = 335},
  [791] = {.lex_state = 335},
  [792] = {.lex_state = 172},
  [793] = {.lex_state = 172},
  [794] = {.lex_state = 172},
  [795] = {.lex_state = 335},
  [796] = {.lex_state = 335},
  [797] = {.lex_state = 335},
  [798] = {.lex_state = 335},
  [799] = {.lex_state = 335},
  [800] = {.lex_state = 172},
  [801] = {.lex_state = 335},
  [802] = {.lex_state = 172},
  [803] = {.lex_state = 335},
  [804] = {.lex_state = 335},
  [805] = {.lex_state = 335},
  [806] = {.lex_state = 335},
  [807] = {.lex_state = 335},
  [808] = {.lex_state = 335},
  [809] = {.lex_state = 335},
  [810] = {.lex_state = 335},
  [811] = {.lex_state = 172},
  [812] = {.lex_state = 335},
  [813] = {.lex_state = 163},
  [814] = {.lex_state = 335},
  [815] = {.lex_state = 335},
  [816] = {.lex_state = 335},
  [817] = {.lex_state = 335},
  [818] = {.lex_state = 335},
  [819] = {.lex_state = 163},
  [820] = {.lex_state = 193},
  [821] = {.lex_state = 335},
  [822] = {.lex_state = 335},
  [823] = {.lex_state = 335},
  [824] = {.lex_state = 335},
  [825] = {.lex_state = 335},
  [826] = {.lex_state = 335},
  [827] = {.lex_state = 335},
  [828] = {.lex_state = 335},
  [829] = {.lex_state = 238},
  [830] = {.lex_state = 335},
  [831] = {.lex_state = 335},
  [832] = {.lex_state = 335},
  [833] = {.lex_state = 335},
  [834] = {.lex_state = 193},
  [835] = {.lex_state = 335},
  [836] = {.lex_state = 335},
  [837] = {.lex_state = 193},
  [838] = {.lex_state = 193},
  [839] = {.lex_state = 238},
  [840] = {.lex_state = 193},
  [841] = {.lex_state = 335},
  [842] = {.lex_state = 193},
  [843] = {.lex_state = 193},
  [844] = {.lex_state = 335},
  [845] = {.lex_state = 193},
  [846] = {.lex_state = 335},
  [847] = {.lex_state = 238},
  [848] = {.lex_state = 335},
  [849] = {.lex_state = 335},
  [850] = {.lex_state = 335},
  [851] = {.lex_state = 335},
  [852] = {.lex_state = 335},
  [853] = {.lex_state = 335},
  [854] = {.lex_state = 193},
  [855] = {.lex_state = 335},
  [856] = {.lex_state = 335},
  [857] = {.lex_state = 335},
  [858] = {.lex_state = 193},
  [859] = {.lex_state = 166},
  [860] = {.lex_state = 335},
  [861] = {.lex_state = 193},
  [862] = {.lex_state = 335},
  [863] = {.lex_state = 193},
  [864] = {.lex_state = 335},
  [865] = {.lex_state = 335},
  [866] = {.lex_state = 335},
  [867] = {.lex_state = 335},
  [868] = {.lex_state = 335},
  [869] = {.lex_state = 335},
  [870] = {.lex_state = 335},
  [871] = {.lex_state = 335},
  [872] = {.lex_state = 335},
  [873] = {.lex_state = 335},
  [874] = {.lex_state = 335},
  [875] = {.lex_state = 335},
  [876] = {.lex_state = 335},
  [877] = {.lex_state = 335},
  [878] = {.lex_state = 163},
  [879] = {.lex_state = 335},
  [880] = {.lex_state = 335},
  [881] = {.lex_state = 335},
  [882] = {.lex_state = 335},
  [883] = {.lex_state = 193},
  [884] = {.lex_state = 335},
  [885] = {.lex_state = 335},
  [886] = {.lex_state = 335},
  [887] = {.lex_state = 193},
  [888] = {.lex_state = 335},
  [889] = {.lex_state = 335},
  [890] = {.lex_state = 335},
  [891] = {.lex_state = 335},
  [892] = {.lex_state = 193},
  [893] = {.lex_state = 193},
  [894] = {.lex_state = 193},
  [895] = {.lex_state = 335},
  [896] = {.lex_state = 335},
  [897] = {.lex_state = 335},
  [898] = {.lex_state = 335},
  [899] = {.lex_state = 335},
  [900] = {.lex_state = 335},
  [901] = {.lex_state = 163},
  [902] = {.lex_state = 193},
  [903] = {.lex_state = 335},
  [904] = {.lex_state = 193},
  [905] = {.lex_state = 335},
  [906] = {.lex_state = 335},
  [907] = {.lex_state = 335},
  [908] = {.lex_state = 335},
  [909] = {.lex_state = 335},
  [910] = {.lex_state = 335},
  [911] = {.lex_state = 193},
  [912] = {.lex_state = 193},
  [913] = {.lex_state = 335},
  [914] = {.lex_state = 335},
  [915] = {.lex_state = 163},
  [916] = {.lex_state = 167},
  [917] = {.lex_state = 167},
  [918] = {.lex_state = 237},
  [919] = {.lex_state = 237},
  [920] = {.lex_state = 237},
  [921] = {.lex_state = 237},
  [922] = {.lex_state = 237},
  [923] = {.lex_state = 237},
  [924] = {.lex_state = 237},
  [925] = {.lex_state = 335},
  [926] = {.lex_state = 335},
  [927] = {.lex_state = 237},
  [928] = {.lex_state = 237},
  [929] = {.lex_state = 237},
  [930] = {.lex_state = 237},
  [931] = {.lex_state = 237},
  [932] = {.lex_state = 237},
  [933] = {.lex_state = 237},
  [934] = {.lex_state = 174},
  [935] = {.lex_state = 174},
  [936] = {.lex_state = 174},
  [937] = {.lex_state = 174},
  [938] = {.lex_state = 174},
  [939] = {.lex_state = 174},
  [940] = {.lex_state = 174},
  [941] = {.lex_state = 174},
  [942] = {.lex_state = 174},
  [943] = {.lex_state = 174},
  [944] = {.lex_state = 174},
  [945] = {.lex_state = 174},
  [946] = {.lex_state = 174},
  [947] = {.lex_state = 174},
  [948] = {.lex_state = 174},
  [949] = {.lex_state = 174},
  [950] = {.lex_state = 174},
  [951] = {.lex_state = 174},
  [952] = {.lex_state = 174},
  [953] = {.lex_state = 174},
  [954] = {.lex_state = 174},
  [955] = {.lex_state = 335},
  [956] = {.lex_state = 171},
  [957] = {.lex_state = 173},
  [958] = {.lex_state = 171},
  [959] = {.lex_state = 173},
  [960] = {.lex_state = 171},
  [961] = {.lex_state = 171},
  [962] = {.lex_state = 171},
  [963] = {.lex_state = 186},
  [964] = {.lex_state = 171},
  [965] = {.lex_state = 171},
  [966] = {.lex_state = 171},
  [967] = {.lex_state = 171},
  [968] = {.lex_state = 171},
  [969] = {.lex_state = 171},
  [970] = {.lex_state = 171},
  [971] = {.lex_state = 171},
  [972] = {.lex_state = 171},
  [973] = {.lex_state = 171},
  [974] = {.lex_state = 171},
  [975] = {.lex_state = 171},
  [976] = {.lex_state = 171},
  [977] = {.lex_state = 171},
  [978] = {.lex_state = 171},
  [979] = {.lex_state = 171},
  [980] = {.lex_state = 171},
  [981] = {.lex_state = 171},
  [982] = {.lex_state = 171},
  [983] = {.lex_state = 171},
  [984] = {.lex_state = 171},
  [985] = {.lex_state = 171},
  [986] = {.lex_state = 171},
  [987] = {.lex_state = 171},
  [988] = {.lex_state = 171},
  [989] = {.lex_state = 171},
  [990] = {.lex_state = 171},
  [991] = {.lex_state = 171},
  [992] = {.lex_state = 171},
  [993] = {.lex_state = 171},
  [994] = {.lex_state = 171},
  [995] = {.lex_state = 171},
  [996] = {.lex_state = 171},
  [997] = {.lex_state = 171},
  [998] = {.lex_state = 171},
  [999] = {.lex_state = 171},
  [1000] = {.lex_state = 171},
  [1001] = {.lex_state = 171},
  [1002] = {.lex_state = 171},
  [1003] = {.lex_state = 171},
  [1004] = {.lex_state = 171},
  [1005] = {.lex_state = 171},
  [1006] = {.lex_state = 237},
  [1007] = {.lex_state = 171},
  [1008] = {.lex_state = 186},
  [1009] = {.lex_state = 171},
  [1010] = {.lex_state = 171},
  [1011] = {.lex_state = 171},
  [1012] = {.lex_state = 171},
  [1013] = {.lex_state = 171},
  [1014] = {.lex_state = 171},
  [1015] = {.lex_state = 171},
  [1016] = {.lex_state = 171},
  [1017] = {.lex_state = 171},
  [1018] = {.lex_state = 171},
  [1019] = {.lex_state = 171},
  [1020] = {.lex_state = 171},
  [1021] = {.lex_state = 171},
  [1022] = {.lex_state = 171},
  [1023] = {.lex_state = 171},
  [1024] = {.lex_state = 171},
  [1025] = {.lex_state = 171},
  [1026] = {.lex_state = 171},
  [1027] = {.lex_state = 171},
  [1028] = {.lex_state = 171},
  [1029] = {.lex_state = 171},
  [1030] = {.lex_state = 171},
  [1031] = {.lex_state = 171},
  [1032] = {.lex_state = 171},
  [1033] = {.lex_state = 186},
  [1034] = {.lex_state = 171},
  [1035] = {.lex_state = 171},
  [1036] = {.lex_state = 171},
  [1037] = {.lex_state = 171},
  [1038] = {.lex_state = 186},
  [1039] = {.lex_state = 171},
  [1040] = {.lex_state = 171},
  [1041] = {.lex_state = 171},
  [1042] = {.lex_state = 171},
  [1043] = {.lex_state = 171},
  [1044] = {.lex_state = 171},
  [1045] = {.lex_state = 171},
  [1046] = {.lex_state = 171},
  [1047] = {.lex_state = 171},
  [1048] = {.lex_state = 171},
  [1049] = {.lex_state = 174},
  [1050] = {.lex_state = 174},
  [1051] = {.lex_state = 174},
  [1052] = {.lex_state = 174},
  [1053] = {.lex_state = 174},
  [1054] = {.lex_state = 174},
  [1055] = {.lex_state = 174},
  [1056] = {.lex_state = 186},
  [1057] = {.lex_state = 174},
  [1058] = {.lex_state = 174},
  [1059] = {.lex_state = 174},
  [1060] = {.lex_state = 174},
  [1061] = {.lex_state = 174},
  [1062] = {.lex_state = 174},
  [1063] = {.lex_state = 174},
  [1064] = {.lex_state = 174},
  [1065] = {.lex_state = 174},
  [1066] = {.lex_state = 174},
  [1067] = {.lex_state = 174},
  [1068] = {.lex_state = 174},
  [1069] = {.lex_state = 174},
  [1070] = {.lex_state = 174},
  [1071] = {.lex_state = 174},
  [1072] = {.lex_state = 174},
  [1073] = {.lex_state = 174},
  [1074] = {.lex_state = 174},
  [1075] = {.lex_state = 174},
  [1076] = {.lex_state = 174},
  [1077] = {.lex_state = 174},
  [1078] = {.lex_state = 174},
  [1079] = {.lex_state = 174},
  [1080] = {.lex_state = 174},
  [1081] = {.lex_state = 174},
  [1082] = {.lex_state = 174},
  [1083] = {.lex_state = 174},
  [1084] = {.lex_state = 174},
  [1085] = {.lex_state = 174},
  [1086] = {.lex_state = 174},
  [1087] = {.lex_state = 174},
  [1088] = {.lex_state = 174},
  [1089] = {.lex_state = 174},
  [1090] = {.lex_state = 174},
  [1091] = {.lex_state = 174},
  [1092] = {.lex_state = 174},
  [1093] = {.lex_state = 174},
  [1094] = {.lex_state = 186},
  [1095] = {.lex_state = 174},
  [1096] = {.lex_state = 174},
  [1097] = {.lex_state = 186},
  [1098] = {.lex_state = 182},
  [1099] = {.lex_state = 186},
  [1100] = {.lex_state = 186},
  [1101] = {.lex_state = 186},
  [1102] = {.lex_state = 186},
  [1103] = {.lex_state = 175},
  [1104] = {.lex_state = 174},
  [1105] = {.lex_state = 174},
  [1106] = {.lex_state = 174},
  [1107] = {.lex_state = 175},
  [1108] = {.lex_state = 174},
  [1109] = {.lex_state = 174},
  [1110] = {.lex_state = 174},
  [1111] = {.lex_state = 174},
  [1112] = {.lex_state = 186},
  [1113] = {.lex_state = 174},
  [1114] = {.lex_state = 174},
  [1115] = {.lex_state = 174},
  [1116] = {.lex_state = 174},
  [1117] = {.lex_state = 174},
  [1118] = {.lex_state = 174},
  [1119] = {.lex_state = 174},
  [1120] = {.lex_state = 174},
  [1121] = {.lex_state = 175},
  [1122] = {.lex_state = 173},
  [1123] = {.lex_state = 174},
  [1124] = {.lex_state = 173},
  [1125] = {.lex_state = 174},
  [1126] = {.lex_state = 174},
  [1127] = {.lex_state = 173},
  [1128] = {.lex_state = 174},
  [1129] = {.lex_state = 173},
  [1130] = {.lex_state = 173},
  [1131] = {.lex_state = 174},
  [1132] = {.lex_state = 173},
  [1133] = {.lex_state = 174},
  [1134] = {.lex_state = 174},
  [1135] = {.lex_state = 174},
  [1136] = {.lex_state = 173},
  [1137] = {.lex_state = 173},
  [1138] = {.lex_state = 173},
  [1139] = {.lex_state = 174},
  [1140] = {.lex_state = 173},
  [1141] = {.lex_state = 173},
  [1142] = {.lex_state = 174},
  [1143] = {.lex_state = 173},
  [1144] = {.lex_state = 174},
  [1145] = {.lex_state = 173},
  [1146] = {.lex_state = 173},
  [1147] = {.lex_state = 174},
  [1148] = {.lex_state = 173},
  [1149] = {.lex_state = 174},
  [1150] = {.lex_state = 173},
  [1151] = {.lex_state = 174},
  [1152] = {.lex_state = 174},
  [1153] = {.lex_state = 173},
  [1154] = {.lex_state = 173},
  [1155] = {.lex_state = 174},
  [1156] = {.lex_state = 174},
  [1157] = {.lex_state = 174},
  [1158] = {.lex_state = 174},
  [1159] = {.lex_state = 173},
  [1160] = {.lex_state = 174},
  [1161] = {.lex_state = 173},
  [1162] = {.lex_state = 174},
  [1163] = {.lex_state = 174},
  [1164] = {.lex_state = 174},
  [1165] = {.lex_state = 174},
  [1166] = {.lex_state = 173},
  [1167] = {.lex_state = 173},
  [1168] = {.lex_state = 174},
  [1169] = {.lex_state = 174},
  [1170] = {.lex_state = 174},
  [1171] = {.lex_state = 174},
  [1172] = {.lex_state = 174},
  [1173] = {.lex_state = 174},
  [1174] = {.lex_state = 174},
  [1175] = {.lex_state = 174},
  [1176] = {.lex_state = 174},
  [1177] = {.lex_state = 174},
  [1178] = {.lex_state = 174},
  [1179] = {.lex_state = 174},
  [1180] = {.lex_state = 174},
  [1181] = {.lex_state = 174},
  [1182] = {.lex_state = 174},
  [1183] = {.lex_state = 173},
  [1184] = {.lex_state = 174},
  [1185] = {.lex_state = 174},
  [1186] = {.lex_state = 174},
  [1187] = {.lex_state = 173},
  [1188] = {.lex_state = 173},
  [1189] = {.lex_state = 174},
  [1190] = {.lex_state = 173},
  [1191] = {.lex_state = 174},
  [1192] = {.lex_state = 174},
  [1193] = {.lex_state = 174},
  [1194] = {.lex_state = 174},
  [1195] = {.lex_state = 174},
  [1196] = {.lex_state = 174},
  [1197] = {.lex_state = 174},
  [1198] = {.lex_state = 174},
  [1199] = {.lex_state = 174},
  [1200] = {.lex_state = 174},
  [1201] = {.lex_state = 174},
  [1202] = {.lex_state = 174},
  [1203] = {.lex_state = 174},
  [1204] = {.lex_state = 174},
  [1205] = {.lex_state = 174},
  [1206] = {.lex_state = 174},
  [1207] = {.lex_state = 174},
  [1208] = {.lex_state = 174},
  [1209] = {.lex_state = 174},
  [1210] = {.lex_state = 174},
  [1211] = {.lex_state = 174},
  [1212] = {.lex_state = 174},
  [1213] = {.lex_state = 174},
  [1214] = {.lex_state = 174},
  [1215] = {.lex_state = 174},
  [1216] = {.lex_state = 174},
  [1217] = {.lex_state = 174},
  [1218] = {.lex_state = 174},
  [1219] = {.lex_state = 174},
  [1220] = {.lex_state = 174},
  [1221] = {.lex_state = 174},
  [1222] = {.lex_state = 174},
  [1223] = {.lex_state = 174},
  [1224] = {.lex_state = 174},
  [1225] = {.lex_state = 174},
  [1226] = {.lex_state = 174},
  [1227] = {.lex_state = 174},
  [1228] = {.lex_state = 174},
  [1229] = {.lex_state = 174},
  [1230] = {.lex_state = 174},
  [1231] = {.lex_state = 174},
  [1232] = {.lex_state = 174},
  [1233] = {.lex_state = 174},
  [1234] = {.lex_state = 174},
  [1235] = {.lex_state = 174},
  [1236] = {.lex_state = 174},
  [1237] = {.lex_state = 174},
  [1238] = {.lex_state = 174},
  [1239] = {.lex_state = 174},
  [1240] = {.lex_state = 174},
  [1241] = {.lex_state = 174},
  [1242] = {.lex_state = 174},
  [1243] = {.lex_state = 174},
  [1244] = {.lex_state = 174},
  [1245] = {.lex_state = 174},
  [1246] = {.lex_state = 174},
  [1247] = {.lex_state = 174},
  [1248] = {.lex_state = 174},
  [1249] = {.lex_state = 174},
  [1250] = {.lex_state = 174},
  [1251] = {.lex_state = 174},
  [1252] = {.lex_state = 174},
  [1253] = {.lex_state = 174},
  [1254] = {.lex_state = 174},
  [1255] = {.lex_state = 174},
  [1256] = {.lex_state = 174},
  [1257] = {.lex_state = 174},
  [1258] = {.lex_state = 174},
  [1259] = {.lex_state = 174},
  [1260] = {.lex_state = 174},
  [1261] = {.lex_state = 174},
  [1262] = {.lex_state = 174},
  [1263] = {.lex_state = 174},
  [1264] = {.lex_state = 174},
  [1265] = {.lex_state = 174},
  [1266] = {.lex_state = 174},
  [1267] = {.lex_state = 174},
  [1268] = {.lex_state = 174},
  [1269] = {.lex_state = 174},
  [1270] = {.lex_state = 174},
  [1271] = {.lex_state = 174},
  [1272] = {.lex_state = 174},
  [1273] = {.lex_state = 174},
  [1274] = {.lex_state = 174},
  [1275] = {.lex_state = 174},
  [1276] = {.lex_state = 174},
  [1277] = {.lex_state = 174},
  [1278] = {.lex_state = 174},
  [1279] = {.lex_state = 174},
  [1280] = {.lex_state = 174},
  [1281] = {.lex_state = 174},
  [1282] = {.lex_state = 174},
  [1283] = {.lex_state = 174},
  [1284] = {.lex_state = 174},
  [1285] = {.lex_state = 174},
  [1286] = {.lex_state = 174},
  [1287] = {.lex_state = 174},
  [1288] = {.lex_state = 174},
  [1289] = {.lex_state = 174},
  [1290] = {.lex_state = 174},
  [1291] = {.lex_state = 174},
  [1292] = {.lex_state = 174},
  [1293] = {.lex_state = 174},
  [1294] = {.lex_state = 174},
  [1295] = {.lex_state = 174},
  [1296] = {.lex_state = 174},
  [1297] = {.lex_state = 174},
  [1298] = {.lex_state = 174},
  [1299] = {.lex_state = 174},
  [1300] = {.lex_state = 174},
  [1301] = {.lex_state = 174},
  [1302] = {.lex_state = 174},
  [1303] = {.lex_state = 174},
  [1304] = {.lex_state = 174},
  [1305] = {.lex_state = 174},
  [1306] = {.lex_state = 174},
  [1307] = {.lex_state = 174},
  [1308] = {.lex_state = 174},
  [1309] = {.lex_state = 174},
  [1310] = {.lex_state = 174},
  [1311] = {.lex_state = 174},
  [1312] = {.lex_state = 174},
  [1313] = {.lex_state = 174},
  [1314] = {.lex_state = 174},
  [1315] = {.lex_state = 174},
  [1316] = {.lex_state = 174},
  [1317] = {.lex_state = 174},
  [1318] = {.lex_state = 174},
  [1319] = {.lex_state = 174},
  [1320] = {.lex_state = 174},
  [1321] = {.lex_state = 174},
  [1322] = {.lex_state = 174},
  [1323] = {.lex_state = 174},
  [1324] = {.lex_state = 174},
  [1325] = {.lex_state = 174},
  [1326] = {.lex_state = 174},
  [1327] = {.lex_state = 174},
  [1328] = {.lex_state = 174},
  [1329] = {.lex_state = 174},
  [1330] = {.lex_state = 174},
  [1331] = {.lex_state = 174},
  [1332] = {.lex_state = 174},
  [1333] = {.lex_state = 174},
  [1334] = {.lex_state = 174},
  [1335] = {.lex_state = 174},
  [1336] = {.lex_state = 174},
  [1337] = {.lex_state = 174},
  [1338] = {.lex_state = 174},
  [1339] = {.lex_state = 174},
  [1340] = {.lex_state = 174},
  [1341] = {.lex_state = 174},
  [1342] = {.lex_state = 174},
  [1343] = {.lex_state = 174},
  [1344] = {.lex_state = 174},
  [1345] = {.lex_state = 174},
  [1346] = {.lex_state = 174},
  [1347] = {.lex_state = 174},
  [1348] = {.lex_state = 174},
  [1349] = {.lex_state = 174},
  [1350] = {.lex_state = 174},
  [1351] = {.lex_state = 174},
  [1352] = {.lex_state = 174},
  [1353] = {.lex_state = 174},
  [1354] = {.lex_state = 174},
  [1355] = {.lex_state = 174},
  [1356] = {.lex_state = 174},
  [1357] = {.lex_state = 174},
  [1358] = {.lex_state = 174},
  [1359] = {.lex_state = 174},
  [1360] = {.lex_state = 174},
  [1361] = {.lex_state = 174},
  [1362] = {.lex_state = 174},
  [1363] = {.lex_state = 174},
  [1364] = {.lex_state = 174},
  [1365] = {.lex_state = 174},
  [1366] = {.lex_state = 174},
  [1367] = {.lex_state = 174},
  [1368] = {.lex_state = 174},
  [1369] = {.lex_state = 174},
  [1370] = {.lex_state = 174},
  [1371] = {.lex_state = 174},
  [1372] = {.lex_state = 174},
  [1373] = {.lex_state = 174},
  [1374] = {.lex_state = 174},
  [1375] = {.lex_state = 174},
  [1376] = {.lex_state = 174},
  [1377] = {.lex_state = 174},
  [1378] = {.lex_state = 174},
  [1379] = {.lex_state = 174},
  [1380] = {.lex_state = 174},
  [1381] = {.lex_state = 174},
  [1382] = {.lex_state = 174},
  [1383] = {.lex_state = 174},
  [1384] = {.lex_state = 174},
  [1385] = {.lex_state = 174},
  [1386] = {.lex_state = 174},
  [1387] = {.lex_state = 174},
  [1388] = {.lex_state = 174},
  [1389] = {.lex_state = 174},
  [1390] = {.lex_state = 174},
  [1391] = {.lex_state = 174},
  [1392] = {.lex_state = 174},
  [1393] = {.lex_state = 174},
  [1394] = {.lex_state = 174},
  [1395] = {.lex_state = 174},
  [1396] = {.lex_state = 174},
  [1397] = {.lex_state = 174},
  [1398] = {.lex_state = 174},
  [1399] = {.lex_state = 174},
  [1400] = {.lex_state = 174},
  [1401] = {.lex_state = 174},
  [1402] = {.lex_state = 174},
  [1403] = {.lex_state = 174},
  [1404] = {.lex_state = 174},
  [1405] = {.lex_state = 174},
  [1406] = {.lex_state = 174},
  [1407] = {.lex_state = 174},
  [1408] = {.lex_state = 174},
  [1409] = {.lex_state = 174},
  [1410] = {.lex_state = 174},
  [1411] = {.lex_state = 174},
  [1412] = {.lex_state = 174},
  [1413] = {.lex_state = 174},
  [1414] = {.lex_state = 174},
  [1415] = {.lex_state = 174},
  [1416] = {.lex_state = 174},
  [1417] = {.lex_state = 174},
  [1418] = {.lex_state = 174},
  [1419] = {.lex_state = 174},
  [1420] = {.lex_state = 174},
  [1421] = {.lex_state = 174},
  [1422] = {.lex_state = 174},
  [1423] = {.lex_state = 174},
  [1424] = {.lex_state = 174},
  [1425] = {.lex_state = 174},
  [1426] = {.lex_state = 174},
  [1427] = {.lex_state = 174},
  [1428] = {.lex_state = 174},
  [1429] = {.lex_state = 174},
  [1430] = {.lex_state = 174},
  [1431] = {.lex_state = 174},
  [1432] = {.lex_state = 174},
  [1433] = {.lex_state = 174},
  [1434] = {.lex_state = 174},
  [1435] = {.lex_state = 174},
  [1436] = {.lex_state = 174},
  [1437] = {.lex_state = 174},
  [1438] = {.lex_state = 174},
  [1439] = {.lex_state = 174},
  [1440] = {.lex_state = 174},
  [1441] = {.lex_state = 174},
  [1442] = {.lex_state = 174},
  [1443] = {.lex_state = 174},
  [1444] = {.lex_state = 174},
  [1445] = {.lex_state = 174},
  [1446] = {.lex_state = 174},
  [1447] = {.lex_state = 174},
  [1448] = {.lex_state = 174},
  [1449] = {.lex_state = 174},
  [1450] = {.lex_state = 174},
  [1451] = {.lex_state = 174},
  [1452] = {.lex_state = 174},
  [1453] = {.lex_state = 174},
  [1454] = {.lex_state = 174},
  [1455] = {.lex_state = 174},
  [1456] = {.lex_state = 174},
  [1457] = {.lex_state = 174},
  [1458] = {.lex_state = 174},
  [1459] = {.lex_state = 174},
  [1460] = {.lex_state = 174},
  [1461] = {.lex_state = 174},
  [1462] = {.lex_state = 174},
  [1463] = {.lex_state = 174},
  [1464] = {.lex_state = 174},
  [1465] = {.lex_state = 174},
  [1466] = {.lex_state = 174},
  [1467] = {.lex_state = 174},
  [1468] = {.lex_state = 174},
  [1469] = {.lex_state = 174},
  [1470] = {.lex_state = 174},
  [1471] = {.lex_state = 174},
  [1472] = {.lex_state = 174},
  [1473] = {.lex_state = 174},
  [1474] = {.lex_state = 174},
  [1475] = {.lex_state = 174},
  [1476] = {.lex_state = 174},
  [1477] = {.lex_state = 174},
  [1478] = {.lex_state = 174},
  [1479] = {.lex_state = 174},
  [1480] = {.lex_state = 174},
  [1481] = {.lex_state = 174},
  [1482] = {.lex_state = 174},
  [1483] = {.lex_state = 174},
  [1484] = {.lex_state = 174},
  [1485] = {.lex_state = 174},
  [1486] = {.lex_state = 174},
  [1487] = {.lex_state = 174},
  [1488] = {.lex_state = 174},
  [1489] = {.lex_state = 174},
  [1490] = {.lex_state = 174},
  [1491] = {.lex_state = 174},
  [1492] = {.lex_state = 174},
  [1493] = {.lex_state = 174},
  [1494] = {.lex_state = 174},
  [1495] = {.lex_state = 174},
  [1496] = {.lex_state = 174},
  [1497] = {.lex_state = 174},
  [1498] = {.lex_state = 174},
  [1499] = {.lex_state = 174},
  [1500] = {.lex_state = 174},
  [1501] = {.lex_state = 174},
  [1502] = {.lex_state = 174},
  [1503] = {.lex_state = 174},
  [1504] = {.lex_state = 174},
  [1505] = {.lex_state = 174},
  [1506] = {.lex_state = 174},
  [1507] = {.lex_state = 174},
  [1508] = {.lex_state = 174},
  [1509] = {.lex_state = 174},
  [1510] = {.lex_state = 174},
  [1511] = {.lex_state = 174},
  [1512] = {.lex_state = 174},
  [1513] = {.lex_state = 174},
  [1514] = {.lex_state = 174},
  [1515] = {.lex_state = 174},
  [1516] = {.lex_state = 174},
  [1517] = {.lex_state = 174},
  [1518] = {.lex_state = 174},
  [1519] = {.lex_state = 174},
  [1520] = {.lex_state = 174},
  [1521] = {.lex_state = 174},
  [1522] = {.lex_state = 174},
  [1523] = {.lex_state = 174},
  [1524] = {.lex_state = 174},
  [1525] = {.lex_state = 174},
  [1526] = {.lex_state = 174},
  [1527] = {.lex_state = 174},
  [1528] = {.lex_state = 174},
  [1529] = {.lex_state = 174},
  [1530] = {.lex_state = 174},
  [1531] = {.lex_state = 174},
  [1532] = {.lex_state = 174},
  [1533] = {.lex_state = 174},
  [1534] = {.lex_state = 174},
  [1535] = {.lex_state = 174},
  [1536] = {.lex_state = 174},
  [1537] = {.lex_state = 174},
  [1538] = {.lex_state = 174},
  [1539] = {.lex_state = 174},
  [1540] = {.lex_state = 174},
  [1541] = {.lex_state = 174},
  [1542] = {.lex_state = 174},
  [1543] = {.lex_state = 174},
  [1544] = {.lex_state = 174},
  [1545] = {.lex_state = 174},
  [1546] = {.lex_state = 174},
  [1547] = {.lex_state = 174},
  [1548] = {.lex_state = 174},
  [1549] = {.lex_state = 174},
  [1550] = {.lex_state = 174},
  [1551] = {.lex_state = 174},
  [1552] = {.lex_state = 174},
  [1553] = {.lex_state = 174},
  [1554] = {.lex_state = 174},
  [1555] = {.lex_state = 174},
  [1556] = {.lex_state = 174},
  [1557] = {.lex_state = 174},
  [1558] = {.lex_state = 174},
  [1559] = {.lex_state = 174},
  [1560] = {.lex_state = 174},
  [1561] = {.lex_state = 174},
  [1562] = {.lex_state = 174},
  [1563] = {.lex_state = 174},
  [1564] = {.lex_state = 174},
  [1565] = {.lex_state = 174},
  [1566] = {.lex_state = 174},
  [1567] = {.lex_state = 174},
  [1568] = {.lex_state = 174},
  [1569] = {.lex_state = 174},
  [1570] = {.lex_state = 174},
  [1571] = {.lex_state = 174},
  [1572] = {.lex_state = 174},
  [1573] = {.lex_state = 174},
  [1574] = {.lex_state = 174},
  [1575] = {.lex_state = 174},
  [1576] = {.lex_state = 174},
  [1577] = {.lex_state = 174},
  [1578] = {.lex_state = 174},
  [1579] = {.lex_state = 174},
  [1580] = {.lex_state = 174},
  [1581] = {.lex_state = 174},
  [1582] = {.lex_state = 174},
  [1583] = {.lex_state = 174},
  [1584] = {.lex_state = 174},
  [1585] = {.lex_state = 174},
  [1586] = {.lex_state = 174},
  [1587] = {.lex_state = 174},
  [1588] = {.lex_state = 174},
  [1589] = {.lex_state = 174},
  [1590] = {.lex_state = 174},
  [1591] = {.lex_state = 174},
  [1592] = {.lex_state = 174},
  [1593] = {.lex_state = 174},
  [1594] = {.lex_state = 174},
  [1595] = {.lex_state = 174},
  [1596] = {.lex_state = 174},
  [1597] = {.lex_state = 174},
  [1598] = {.lex_state = 174},
  [1599] = {.lex_state = 174},
  [1600] = {.lex_state = 174},
  [1601] = {.lex_state = 174},
  [1602] = {.lex_state = 174},
  [1603] = {.lex_state = 174},
  [1604] = {.lex_state = 174},
  [1605] = {.lex_state = 174},
  [1606] = {.lex_state = 174},
  [1607] = {.lex_state = 174},
  [1608] = {.lex_state = 174},
  [1609] = {.lex_state = 174},
  [1610] = {.lex_state = 174},
  [1611] = {.lex_state = 174},
  [1612] = {.lex_state = 174},
  [1613] = {.lex_state = 174},
  [1614] = {.lex_state = 174},
  [1615] = {.lex_state = 174},
  [1616] = {.lex_state = 174},
  [1617] = {.lex_state = 174},
  [1618] = {.lex_state = 174},
  [1619] = {.lex_state = 174},
  [1620] = {.lex_state = 174},
  [1621] = {.lex_state = 174},
  [1622] = {.lex_state = 174},
  [1623] = {.lex_state = 174},
  [1624] = {.lex_state = 174},
  [1625] = {.lex_state = 174},
  [1626] = {.lex_state = 174},
  [1627] = {.lex_state = 174},
  [1628] = {.lex_state = 174},
  [1629] = {.lex_state = 174},
  [1630] = {.lex_state = 174},
  [1631] = {.lex_state = 174},
  [1632] = {.lex_state = 174},
  [1633] = {.lex_state = 174},
  [1634] = {.lex_state = 174},
  [1635] = {.lex_state = 174},
  [1636] = {.lex_state = 174},
  [1637] = {.lex_state = 174},
  [1638] = {.lex_state = 174},
  [1639] = {.lex_state = 174},
  [1640] = {.lex_state = 174},
  [1641] = {.lex_state = 174},
  [1642] = {.lex_state = 174},
  [1643] = {.lex_state = 174},
  [1644] = {.lex_state = 174},
  [1645] = {.lex_state = 174},
  [1646] = {.lex_state = 174},
  [1647] = {.lex_state = 174},
  [1648] = {.lex_state = 174},
  [1649] = {.lex_state = 174},
  [1650] = {.lex_state = 174},
  [1651] = {.lex_state = 174},
  [1652] = {.lex_state = 174},
  [1653] = {.lex_state = 174},
  [1654] = {.lex_state = 174},
  [1655] = {.lex_state = 174},
  [1656] = {.lex_state = 174},
  [1657] = {.lex_state = 174},
  [1658] = {.lex_state = 174},
  [1659] = {.lex_state = 174},
  [1660] = {.lex_state = 174},
  [1661] = {.lex_state = 174},
  [1662] = {.lex_state = 174},
  [1663] = {.lex_state = 174},
  [1664] = {.lex_state = 174},
  [1665] = {.lex_state = 174},
  [1666] = {.lex_state = 174},
  [1667] = {.lex_state = 174},
  [1668] = {.lex_state = 174},
  [1669] = {.lex_state = 174},
  [1670] = {.lex_state = 174},
  [1671] = {.lex_state = 174},
  [1672] = {.lex_state = 174},
  [1673] = {.lex_state = 174},
  [1674] = {.lex_state = 174},
  [1675] = {.lex_state = 174},
  [1676] = {.lex_state = 174},
  [1677] = {.lex_state = 174},
  [1678] = {.lex_state = 174},
  [1679] = {.lex_state = 174},
  [1680] = {.lex_state = 237},
  [1681] = {.lex_state = 237},
  [1682] = {.lex_state = 194},
  [1683] = {.lex_state = 194},
  [1684] = {.lex_state = 194},
  [1685] = {.lex_state = 194},
  [1686] = {.lex_state = 194},
  [1687] = {.lex_state = 194},
  [1688] = {.lex_state = 194},
  [1689] = {.lex_state = 194},
  [1690] = {.lex_state = 194},
  [1691] = {.lex_state = 237},
  [1692] = {.lex_state = 237},
  [1693] = {.lex_state = 237},
  [1694] = {.lex_state = 237},
  [1695] = {.lex_state = 171},
  [1696] = {.lex_state = 171},
  [1697] = {.lex_state = 171},
  [1698] = {.lex_state = 192},
  [1699] = {.lex_state = 194},
  [1700] = {.lex_state = 192},
  [1701] = {.lex_state = 194},
  [1702] = {.lex_state = 192},
  [1703] = {.lex_state = 192},
  [1704] = {.lex_state = 192},
  [1705] = {.lex_state = 192},
  [1706] = {.lex_state = 192},
  [1707] = {.lex_state = 192},
  [1708] = {.lex_state = 182},
  [1709] = {.lex_state = 194},
  [1710] = {.lex_state = 192},
  [1711] = {.lex_state = 223},
  [1712] = {.lex_state = 194},
  [1713] = {.lex_state = 223},
  [1714] = {.lex_state = 223},
  [1715] = {.lex_state = 183},
  [1716] = {.lex_state = 223},
  [1717] = {.lex_state = 223},
  [1718] = {.lex_state = 223},
  [1719] = {.lex_state = 223},
  [1720] = {.lex_state = 187},
  [1721] = {.lex_state = 192},
  [1722] = {.lex_state = 192},
  [1723] = {.lex_state = 192},
  [1724] = {.lex_state = 192},
  [1725] = {.lex_state = 192},
  [1726] = {.lex_state = 192},
  [1727] = {.lex_state = 192},
  [1728] = {.lex_state = 192},
  [1729] = {.lex_state = 237},
  [1730] = {.lex_state = 237},
  [1731] = {.lex_state = 237},
  [1732] = {.lex_state = 237},
  [1733] = {.lex_state = 237},
  [1734] = {.lex_state = 237},
  [1735] = {.lex_state = 237},
  [1736] = {.lex_state = 237},
  [1737] = {.lex_state = 237},
  [1738] = {.lex_state = 237},
  [1739] = {.lex_state = 237},
  [1740] = {.lex_state = 223},
  [1741] = {.lex_state = 237},
  [1742] = {.lex_state = 237},
  [1743] = {.lex_state = 237},
  [1744] = {.lex_state = 237},
  [1745] = {.lex_state = 237},
  [1746] = {.lex_state = 237},
  [1747] = {.lex_state = 237},
  [1748] = {.lex_state = 237},
  [1749] = {.lex_state = 237},
  [1750] = {.lex_state = 237},
  [1751] = {.lex_state = 237},
  [1752] = {.lex_state = 237},
  [1753] = {.lex_state = 237},
  [1754] = {.lex_state = 237},
  [1755] = {.lex_state = 237},
  [1756] = {.lex_state = 237},
  [1757] = {.lex_state = 237},
  [1758] = {.lex_state = 237},
  [1759] = {.lex_state = 237},
  [1760] = {.lex_state = 177},
  [1761] = {.lex_state = 237},
  [1762] = {.lex_state = 237},
  [1763] = {.lex_state = 171},
  [1764] = {.lex_state = 237},
  [1765] = {.lex_state = 237},
  [1766] = {.lex_state = 171},
  [1767] = {.lex_state = 203},
  [1768] = {.lex_state = 237},
  [1769] = {.lex_state = 237},
  [1770] = {.lex_state = 179},
  [1771] = {.lex_state = 179},
  [1772] = {.lex_state = 179},
  [1773] = {.lex_state = 237},
  [1774] = {.lex_state = 237},
  [1775] = {.lex_state = 237},
  [1776] = {.lex_state = 237},
  [1777] = {.lex_state = 223},
  [1778] = {.lex_state = 237},
  [1779] = {.lex_state = 223},
  [1780] = {.lex_state = 207},
  [1781] = {.lex_state = 207},
  [1782] = {.lex_state = 197},
  [1783] = {.lex_state = 207},
  [1784] = {.lex_state = 207},
  [1785] = {.lex_state = 237},
  [1786] = {.lex_state = 207},
  [1787] = {.lex_state = 207},
  [1788] = {.lex_state = 237},
  [1789] = {.lex_state = 207},
  [1790] = {.lex_state = 237},
  [1791] = {.lex_state = 237},
  [1792] = {.lex_state = 179},
  [1793] = {.lex_state = 237},
  [1794] = {.lex_state = 179},
  [1795] = {.lex_state = 214},
  [1796] = {.lex_state = 237},
  [1797] = {.lex_state = 237},
  [1798] = {.lex_state = 214},
  [1799] = {.lex_state = 174},
  [1800] = {.lex_state = 214},
  [1801] = {.lex_state = 214},
  [1802] = {.lex_state = 214},
  [1803] = {.lex_state = 179},
  [1804] = {.lex_state = 179},
  [1805] = {.lex_state = 214},
  [1806] = {.lex_state = 214},
  [1807] = {.lex_state = 237},
  [1808] = {.lex_state = 237},
  [1809] = {.lex_state = 237},
  [1810] = {.lex_state = 237},
  [1811] = {.lex_state = 223},
  [1812] = {.lex_state = 237},
  [1813] = {.lex_state = 223},
  [1814] = {.lex_state = 237},
  [1815] = {.lex_state = 223},
  [1816] = {.lex_state = 237},
  [1817] = {.lex_state = 237},
  [1818] = {.lex_state = 237},
  [1819] = {.lex_state = 237},
  [1820] = {.lex_state = 237},
  [1821] = {.lex_state = 237},
  [1822] = {.lex_state = 237},
  [1823] = {.lex_state = 237},
  [1824] = {.lex_state = 237},
  [1825] = {.lex_state = 237},
  [1826] = {.lex_state = 237},
  [1827] = {.lex_state = 224},
  [1828] = {.lex_state = 192},
  [1829] = {.lex_state = 203},
  [1830] = {.lex_state = 237},
  [1831] = {.lex_state = 237},
  [1832] = {.lex_state = 224},
  [1833] = {.lex_state = 237},
  [1834] = {.lex_state = 177},
  [1835] = {.lex_state = 237},
  [1836] = {.lex_state = 237},
  [1837] = {.lex_state = 237},
  [1838] = {.lex_state = 223},
  [1839] = {.lex_state = 237},
  [1840] = {.lex_state = 237},
  [1841] = {.lex_state = 237},
  [1842] = {.lex_state = 237},
  [1843] = {.lex_state = 237},
  [1844] = {.lex_state = 237},
  [1845] = {.lex_state = 237},
  [1846] = {.lex_state = 237},
  [1847] = {.lex_state = 237},
  [1848] = {.lex_state = 237},
  [1849] = {.lex_state = 237},
  [1850] = {.lex_state = 237},
  [1851] = {.lex_state = 237},
  [1852] = {.lex_state = 237},
  [1853] = {.lex_state = 237},
  [1854] = {.lex_state = 237},
  [1855] = {.lex_state = 198},
  [1856] = {.lex_state = 237},
  [1857] = {.lex_state = 237},
  [1858] = {.lex_state = 237},
  [1859] = {.lex_state = 237},
  [1860] = {.lex_state = 237},
  [1861] = {.lex_state = 237},
  [1862] = {.lex_state = 237},
  [1863] = {.lex_state = 192},
  [1864] = {.lex_state = 237},
  [1865] = {.lex_state = 224},
  [1866] = {.lex_state = 223},
  [1867] = {.lex_state = 237},
  [1868] = {.lex_state = 237},
  [1869] = {.lex_state = 224},
  [1870] = {.lex_state = 237},
  [1871] = {.lex_state = 237},
  [1872] = {.lex_state = 237},
  [1873] = {.lex_state = 237},
  [1874] = {.lex_state = 224},
  [1875] = {.lex_state = 224},
  [1876] = {.lex_state = 237},
  [1877] = {.lex_state = 237},
  [1878] = {.lex_state = 237},
  [1879] = {.lex_state = 237},
  [1880] = {.lex_state = 224},
  [1881] = {.lex_state = 237},
  [1882] = {.lex_state = 237},
  [1883] = {.lex_state = 224},
  [1884] = {.lex_state = 224},
  [1885] = {.lex_state = 237},
  [1886] = {.lex_state = 237},
  [1887] = {.lex_state = 223},
  [1888] = {.lex_state = 223},
  [1889] = {.lex_state = 237},
  [1890] = {.lex_state = 237},
  [1891] = {.lex_state = 237},
  [1892] = {.lex_state = 223},
  [1893] = {.lex_state = 237},
  [1894] = {.lex_state = 237},
  [1895] = {.lex_state = 237},
  [1896] = {.lex_state = 224},
  [1897] = {.lex_state = 237},
  [1898] = {.lex_state = 203},
  [1899] = {.lex_state = 237},
  [1900] = {.lex_state = 223},
  [1901] = {.lex_state = 224},
  [1902] = {.lex_state = 237},
  [1903] = {.lex_state = 223},
  [1904] = {.lex_state = 237},
  [1905] = {.lex_state = 237},
  [1906] = {.lex_state = 237},
  [1907] = {.lex_state = 237},
  [1908] = {.lex_state = 237},
  [1909] = {.lex_state = 237},
  [1910] = {.lex_state = 237},
  [1911] = {.lex_state = 237},
  [1912] = {.lex_state = 237},
  [1913] = {.lex_state = 224},
  [1914] = {.lex_state = 237},
  [1915] = {.lex_state = 237},
  [1916] = {.lex_state = 237},
  [1917] = {.lex_state = 237},
  [1918] = {.lex_state = 237},
  [1919] = {.lex_state = 237},
  [1920] = {.lex_state = 237},
  [1921] = {.lex_state = 237},
  [1922] = {.lex_state = 237},
  [1923] = {.lex_state = 237},
  [1924] = {.lex_state = 237},
  [1925] = {.lex_state = 237},
  [1926] = {.lex_state = 237},
  [1927] = {.lex_state = 237},
  [1928] = {.lex_state = 224},
  [1929] = {.lex_state = 237},
  [1930] = {.lex_state = 223},
  [1931] = {.lex_state = 237},
  [1932] = {.lex_state = 237},
  [1933] = {.lex_state = 237},
  [1934] = {.lex_state = 237},
  [1935] = {.lex_state = 237},
  [1936] = {.lex_state = 237},
  [1937] = {.lex_state = 193},
  [1938] = {.lex_state = 203},
  [1939] = {.lex_state = 203},
  [1940] = {.lex_state = 203},
  [1941] = {.lex_state = 203},
  [1942] = {.lex_state = 203},
  [1943] = {.lex_state = 203},
  [1944] = {.lex_state = 203},
  [1945] = {.lex_state = 203},
  [1946] = {.lex_state = 203},
  [1947] = {.lex_state = 203},
  [1948] = {.lex_state = 203},
  [1949] = {.lex_state = 203},
  [1950] = {.lex_state = 237},
  [1951] = {.lex_state = 203},
  [1952] = {.lex_state = 238},
  [1953] = {.lex_state = 203},
  [1954] = {.lex_state = 203},
  [1955] = {.lex_state = 203},
  [1956] = {.lex_state = 203},
  [1957] = {.lex_state = 203},
  [1958] = {.lex_state = 203},
  [1959] = {.lex_state = 203},
  [1960] = {.lex_state = 203},
  [1961] = {.lex_state = 237},
  [1962] = {.lex_state = 203},
  [1963] = {.lex_state = 203},
  [1964] = {.lex_state = 237},
  [1965] = {.lex_state = 203},
  [1966] = {.lex_state = 203},
  [1967] = {.lex_state = 237},
  [1968] = {.lex_state = 203},
  [1969] = {.lex_state = 203},
  [1970] = {.lex_state = 238},
  [1971] = {.lex_state = 237},
  [1972] = {.lex_state = 174},
  [1973] = {.lex_state = 203},
  [1974] = {.lex_state = 203},
  [1975] = {.lex_state = 203},
  [1976] = {.lex_state = 207},
  [1977] = {.lex_state = 238},
  [1978] = {.lex_state = 203},
  [1979] = {.lex_state = 203},
  [1980] = {.lex_state = 203},
  [1981] = {.lex_state = 203},
  [1982] = {.lex_state = 203},
  [1983] = {.lex_state = 237},
  [1984] = {.lex_state = 203},
  [1985] = {.lex_state = 193},
  [1986] = {.lex_state = 203},
  [1987] = {.lex_state = 203},
  [1988] = {.lex_state = 203},
  [1989] = {.lex_state = 238},
  [1990] = {.lex_state = 203},
  [1991] = {.lex_state = 193},
  [1992] = {.lex_state = 193},
  [1993] = {.lex_state = 193},
  [1994] = {.lex_state = 198},
  [1995] = {.lex_state = 195},
  [1996] = {.lex_state = 197},
  [1997] = {.lex_state = 179},
  [1998] = {.lex_state = 179},
  [1999] = {.lex_state = 238},
  [2000] = {.lex_state = 238},
  [2001] = {.lex_state = 238},
  [2002] = {.lex_state = 207},
  [2003] = {.lex_state = 197},
  [2004] = {.lex_state = 198},
  [2005] = {.lex_state = 193},
  [2006] = {.lex_state = 238},
  [2007] = {.lex_state = 214},
  [2008] = {.lex_state = 195},
  [2009] = {.lex_state = 193},
  [2010] = {.lex_state = 198},
  [2011] = {.lex_state = 193},
  [2012] = {.lex_state = 198},
  [2013] = {.lex_state = 198},
  [2014] = {.lex_state = 237},
  [2015] = {.lex_state = 238},
  [2016] = {.lex_state = 177},
  [2017] = {.lex_state = 195},
  [2018] = {.lex_state = 195},
  [2019] = {.lex_state = 195},
  [2020] = {.lex_state = 195},
  [2021] = {.lex_state = 238},
  [2022] = {.lex_state = 195},
  [2023] = {.lex_state = 195},
  [2024] = {.lex_state = 237},
  [2025] = {.lex_state = 195},
  [2026] = {.lex_state = 237},
  [2027] = {.lex_state = 238},
  [2028] = {.lex_state = 197},
  [2029] = {.lex_state = 182},
  [2030] = {.lex_state = 202},
  [2031] = {.lex_state = 238},
  [2032] = {.lex_state = 238},
  [2033] = {.lex_state = 214},
  [2034] = {.lex_state = 195},
  [2035] = {.lex_state = 195},
  [2036] = {.lex_state = 193},
  [2037] = {.lex_state = 177},
  [2038] = {.lex_state = 195},
  [2039] = {.lex_state = 177},
  [2040] = {.lex_state = 186},
  [2041] = {.lex_state = 186},
  [2042] = {.lex_state = 195},
  [2043] = {.lex_state = 182},
  [2044] = {.lex_state = 197},
  [2045] = {.lex_state = 193},
  [2046] = {.lex_state = 179},
  [2047] = {.lex_state = 186},
  [2048] = {.lex_state = 179},
  [2049] = {.lex_state = 193},
  [2050] = {.lex_state = 193},
  [2051] = {.lex_state = 195},
  [2052] = {.lex_state = 193},
  [2053] = {.lex_state = 238},
  [2054] = {.lex_state = 193},
  [2055] = {.lex_state = 238},
  [2056] = {.lex_state = 238},
  [2057] = {.lex_state = 177},
  [2058] = {.lex_state = 238},
  [2059] = {.lex_state = 193},
  [2060] = {.lex_state = 193},
  [2061] = {.lex_state = 238},
  [2062] = {.lex_state = 193},
  [2063] = {.lex_state = 193},
  [2064] = {.lex_state = 193},
  [2065] = {.lex_state = 193},
  [2066] = {.lex_state = 193},
  [2067] = {.lex_state = 238},
  [2068] = {.lex_state = 238},
  [2069] = {.lex_state = 193},
  [2070] = {.lex_state = 238},
  [2071] = {.lex_state = 193},
  [2072] = {.lex_state = 193},
  [2073] = {.lex_state = 238},
  [2074] = {.lex_state = 238},
  [2075] = {.lex_state = 193},
  [2076] = {.lex_state = 193},
  [2077] = {.lex_state = 193},
  [2078] = {.lex_state = 193},
  [2079] = {.lex_state = 185},
  [2080] = {.lex_state = 177},
  [2081] = {.lex_state = 193},
  [2082] = {.lex_state = 193},
  [2083] = {.lex_state = 193},
  [2084] = {.lex_state = 177},
  [2085] = {.lex_state = 193},
  [2086] = {.lex_state = 238},
  [2087] = {.lex_state = 193},
  [2088] = {.lex_state = 198},
  [2089] = {.lex_state = 193},
  [2090] = {.lex_state = 238},
  [2091] = {.lex_state = 238},
  [2092] = {.lex_state = 177},
  [2093] = {.lex_state = 177},
  [2094] = {.lex_state = 193},
  [2095] = {.lex_state = 238},
  [2096] = {.lex_state = 238},
  [2097] = {.lex_state = 238},
  [2098] = {.lex_state = 238},
  [2099] = {.lex_state = 238},
  [2100] = {.lex_state = 238},
  [2101] = {.lex_state = 193},
  [2102] = {.lex_state = 193},
  [2103] = {.lex_state = 193},
  [2104] = {.lex_state = 238},
  [2105] = {.lex_state = 183},
  [2106] = {.lex_state = 238},
  [2107] = {.lex_state = 193},
  [2108] = {.lex_state = 193},
  [2109] = {.lex_state = 238},
  [2110] = {.lex_state = 238},
  [2111] = {.lex_state = 238},
  [2112] = {.lex_state = 238},
  [2113] = {.lex_state = 193},
  [2114] = {.lex_state = 198},
  [2115] = {.lex_state = 195},
  [2116] = {.lex_state = 179},
  [2117] = {.lex_state = 193},
  [2118] = {.lex_state = 185},
  [2119] = {.lex_state = 238},
  [2120] = {.lex_state = 179},
  [2121] = {.lex_state = 193},
  [2122] = {.lex_state = 193},
  [2123] = {.lex_state = 238},
  [2124] = {.lex_state = 238},
  [2125] = {.lex_state = 193},
  [2126] = {.lex_state = 193},
  [2127] = {.lex_state = 193},
  [2128] = {.lex_state = 238},
  [2129] = {.lex_state = 238},
  [2130] = {.lex_state = 183},
  [2131] = {.lex_state = 193},
  [2132] = {.lex_state = 193},
  [2133] = {.lex_state = 238},
  [2134] = {.lex_state = 238},
  [2135] = {.lex_state = 193},
  [2136] = {.lex_state = 193},
  [2137] = {.lex_state = 177},
  [2138] = {.lex_state = 193},
  [2139] = {.lex_state = 193},
  [2140] = {.lex_state = 193},
  [2141] = {.lex_state = 238},
  [2142] = {.lex_state = 238},
  [2143] = {.lex_state = 193},
  [2144] = {.lex_state = 238},
  [2145] = {.lex_state = 193},
  [2146] = {.lex_state = 193},
  [2147] = {.lex_state = 238},
  [2148] = {.lex_state = 238},
  [2149] = {.lex_state = 238},
  [2150] = {.lex_state = 238},
  [2151] = {.lex_state = 238},
  [2152] = {.lex_state = 238},
  [2153] = {.lex_state = 238},
  [2154] = {.lex_state = 238},
  [2155] = {.lex_state = 193},
  [2156] = {.lex_state = 238},
  [2157] = {.lex_state = 238},
  [2158] = {.lex_state = 193},
  [2159] = {.lex_state = 193},
  [2160] = {.lex_state = 193},
  [2161] = {.lex_state = 238},
  [2162] = {.lex_state = 238},
  [2163] = {.lex_state = 193},
  [2164] = {.lex_state = 228},
  [2165] = {.lex_state = 193},
  [2166] = {.lex_state = 238},
  [2167] = {.lex_state = 193},
  [2168] = {.lex_state = 193},
  [2169] = {.lex_state = 193},
  [2170] = {.lex_state = 193},
  [2171] = {.lex_state = 238},
  [2172] = {.lex_state = 177},
  [2173] = {.lex_state = 193},
  [2174] = {.lex_state = 193},
  [2175] = {.lex_state = 193},
  [2176] = {.lex_state = 238},
  [2177] = {.lex_state = 193},
  [2178] = {.lex_state = 193},
  [2179] = {.lex_state = 238},
  [2180] = {.lex_state = 193},
  [2181] = {.lex_state = 193},
  [2182] = {.lex_state = 238},
  [2183] = {.lex_state = 193},
  [2184] = {.lex_state = 238},
  [2185] = {.lex_state = 193},
  [2186] = {.lex_state = 193},
  [2187] = {.lex_state = 238},
  [2188] = {.lex_state = 193},
  [2189] = {.lex_state = 193},
  [2190] = {.lex_state = 177},
  [2191] = {.lex_state = 193},
  [2192] = {.lex_state = 193},
  [2193] = {.lex_state = 193},
  [2194] = {.lex_state = 193},
  [2195] = {.lex_state = 193},
  [2196] = {.lex_state = 204},
  [2197] = {.lex_state = 193},
  [2198] = {.lex_state = 193},
  [2199] = {.lex_state = 193},
  [2200] = {.lex_state = 193},
  [2201] = {.lex_state = 193},
  [2202] = {.lex_state = 193},
  [2203] = {.lex_state = 238},
  [2204] = {.lex_state = 238},
  [2205] = {.lex_state = 238},
  [2206] = {.lex_state = 179},
  [2207] = {.lex_state = 238},
  [2208] = {.lex_state = 238},
  [2209] = {.lex_state = 193},
  [2210] = {.lex_state = 238},
  [2211] = {.lex_state = 238},
  [2212] = {.lex_state = 193},
  [2213] = {.lex_state = 238},
  [2214] = {.lex_state = 238},
  [2215] = {.lex_state = 238},
  [2216] = {.lex_state = 238},
  [2217] = {.lex_state = 238},
  [2218] = {.lex_state = 238},
  [2219] = {.lex_state = 238},
  [2220] = {.lex_state = 238},
  [2221] = {.lex_state = 238},
  [2222] = {.lex_state = 238},
  [2223] = {.lex_state = 238},
  [2224] = {.lex_state = 238},
  [2225] = {.lex_state = 238},
  [2226] = {.lex_state = 193},
  [2227] = {.lex_state = 238},
  [2228] = {.lex_state = 238},
  [2229] = {.lex_state = 238},
  [2230] = {.lex_state = 238},
  [2231] = {.lex_state = 238},
  [2232] = {.lex_state = 193},
  [2233] = {.lex_state = 204},
  [2234] = {.lex_state = 238},
  [2235] = {.lex_state = 177},
  [2236] = {.lex_state = 238},
  [2237] = {.lex_state = 238},
  [2238] = {.lex_state = 238},
  [2239] = {.lex_state = 238},
  [2240] = {.lex_state = 238},
  [2241] = {.lex_state = 193},
  [2242] = {.lex_state = 193},
  [2243] = {.lex_state = 193},
  [2244] = {.lex_state = 238},
  [2245] = {.lex_state = 238},
  [2246] = {.lex_state = 238},
  [2247] = {.lex_state = 193},
  [2248] = {.lex_state = 185},
  [2249] = {.lex_state = 193},
  [2250] = {.lex_state = 193},
  [2251] = {.lex_state = 193},
  [2252] = {.lex_state = 198},
  [2253] = {.lex_state = 238},
  [2254] = {.lex_state = 193},
  [2255] = {.lex_state = 238},
  [2256] = {.lex_state = 193},
  [2257] = {.lex_state = 237},
  [2258] = {.lex_state = 189},
  [2259] = {.lex_state = 237},
  [2260] = {.lex_state = 179},
  [2261] = {.lex_state = 198},
  [2262] = {.lex_state = 204},
  [2263] = {.lex_state = 210},
  [2264] = {.lex_state = 237},
  [2265] = {.lex_state = 187},
  [2266] = {.lex_state = 198},
  [2267] = {.lex_state = 196},
  [2268] = {.lex_state = 198},
  [2269] = {.lex_state = 204},
  [2270] = {.lex_state = 204},
  [2271] = {.lex_state = 198},
  [2272] = {.lex_state = 204},
  [2273] = {.lex_state = 179},
  [2274] = {.lex_state = 204},
  [2275] = {.lex_state = 237},
  [2276] = {.lex_state = 195},
  [2277] = {.lex_state = 196},
  [2278] = {.lex_state = 204},
  [2279] = {.lex_state = 179},
  [2280] = {.lex_state = 204},
  [2281] = {.lex_state = 198},
  [2282] = {.lex_state = 237},
  [2283] = {.lex_state = 198},
  [2284] = {.lex_state = 237},
  [2285] = {.lex_state = 228},
  [2286] = {.lex_state = 237},
  [2287] = {.lex_state = 237},
  [2288] = {.lex_state = 237},
  [2289] = {.lex_state = 196},
  [2290] = {.lex_state = 195},
  [2291] = {.lex_state = 189},
  [2292] = {.lex_state = 187},
  [2293] = {.lex_state = 204},
  [2294] = {.lex_state = 237},
  [2295] = {.lex_state = 196},
  [2296] = {.lex_state = 198},
  [2297] = {.lex_state = 237},
  [2298] = {.lex_state = 237},
  [2299] = {.lex_state = 198},
  [2300] = {.lex_state = 198},
  [2301] = {.lex_state = 195},
  [2302] = {.lex_state = 198},
  [2303] = {.lex_state = 237},
  [2304] = {.lex_state = 198},
  [2305] = {.lex_state = 237},
  [2306] = {.lex_state = 228},
  [2307] = {.lex_state = 189},
  [2308] = {.lex_state = 198},
  [2309] = {.lex_state = 177},
  [2310] = {.lex_state = 179},
  [2311] = {.lex_state = 196},
  [2312] = {.lex_state = 177},
  [2313] = {.lex_state = 198},
  [2314] = {.lex_state = 237},
  [2315] = {.lex_state = 237},
  [2316] = {.lex_state = 195},
  [2317] = {.lex_state = 195},
  [2318] = {.lex_state = 198},
  [2319] = {.lex_state = 198},
  [2320] = {.lex_state = 198},
  [2321] = {.lex_state = 198},
  [2322] = {.lex_state = 236},
  [2323] = {.lex_state = 198},
  [2324] = {.lex_state = 198},
  [2325] = {.lex_state = 196},
  [2326] = {.lex_state = 198},
  [2327] = {.lex_state = 210},
  [2328] = {.lex_state = 196},
  [2329] = {.lex_state = 198},
  [2330] = {.lex_state = 239},
  [2331] = {.lex_state = 198},
  [2332] = {.lex_state = 198},
  [2333] = {.lex_state = 195},
  [2334] = {.lex_state = 198},
  [2335] = {.lex_state = 198},
  [2336] = {.lex_state = 198},
  [2337] = {.lex_state = 198},
  [2338] = {.lex_state = 198},
  [2339] = {.lex_state = 198},
  [2340] = {.lex_state = 196},
  [2341] = {.lex_state = 198},
  [2342] = {.lex_state = 196},
  [2343] = {.lex_state = 179},
  [2344] = {.lex_state = 198},
  [2345] = {.lex_state = 239},
  [2346] = {.lex_state = 198},
  [2347] = {.lex_state = 236},
  [2348] = {.lex_state = 179},
  [2349] = {.lex_state = 196},
  [2350] = {.lex_state = 198},
  [2351] = {.lex_state = 198},
  [2352] = {.lex_state = 198},
  [2353] = {.lex_state = 198},
  [2354] = {.lex_state = 198},
  [2355] = {.lex_state = 198},
  [2356] = {.lex_state = 196},
  [2357] = {.lex_state = 204},
  [2358] = {.lex_state = 198},
  [2359] = {.lex_state = 196},
  [2360] = {.lex_state = 198},
  [2361] = {.lex_state = 196},
  [2362] = {.lex_state = 198},
  [2363] = {.lex_state = 198},
  [2364] = {.lex_state = 198},
  [2365] = {.lex_state = 210},
  [2366] = {.lex_state = 196},
  [2367] = {.lex_state = 196},
  [2368] = {.lex_state = 196},
  [2369] = {.lex_state = 198},
  [2370] = {.lex_state = 198},
  [2371] = {.lex_state = 198},
  [2372] = {.lex_state = 196},
  [2373] = {.lex_state = 198},
  [2374] = {.lex_state = 196},
  [2375] = {.lex_state = 198},
  [2376] = {.lex_state = 198},
  [2377] = {.lex_state = 218},
  [2378] = {.lex_state = 198},
  [2379] = {.lex_state = 198},
  [2380] = {.lex_state = 198},
  [2381] = {.lex_state = 198},
  [2382] = {.lex_state = 198},
  [2383] = {.lex_state = 198},
  [2384] = {.lex_state = 198},
  [2385] = {.lex_state = 198},
  [2386] = {.lex_state = 198},
  [2387] = {.lex_state = 198},
  [2388] = {.lex_state = 198},
  [2389] = {.lex_state = 185},
  [2390] = {.lex_state = 185},
  [2391] = {.lex_state = 198},
  [2392] = {.lex_state = 198},
  [2393] = {.lex_state = 198},
  [2394] = {.lex_state = 198},
  [2395] = {.lex_state = 195},
  [2396] = {.lex_state = 198},
  [2397] = {.lex_state = 198},
  [2398] = {.lex_state = 198},
  [2399] = {.lex_state = 185},
  [2400] = {.lex_state = 237},
  [2401] = {.lex_state = 185},
  [2402] = {.lex_state = 237},
  [2403] = {.lex_state = 239},
  [2404] = {.lex_state = 179},
  [2405] = {.lex_state = 185},
  [2406] = {.lex_state = 198},
  [2407] = {.lex_state = 185},
  [2408] = {.lex_state = 239},
  [2409] = {.lex_state = 179},
  [2410] = {.lex_state = 198},
  [2411] = {.lex_state = 179},
  [2412] = {.lex_state = 179},
  [2413] = {.lex_state = 198},
  [2414] = {.lex_state = 198},
  [2415] = {.lex_state = 195},
  [2416] = {.lex_state = 185},
  [2417] = {.lex_state = 239},
  [2418] = {.lex_state = 195},
  [2419] = {.lex_state = 189},
  [2420] = {.lex_state = 185},
  [2421] = {.lex_state = 239},
  [2422] = {.lex_state = 239},
  [2423] = {.lex_state = 198},
  [2424] = {.lex_state = 195},
  [2425] = {.lex_state = 198},
  [2426] = {.lex_state = 218},
  [2427] = {.lex_state = 185},
  [2428] = {.lex_state = 198},
  [2429] = {.lex_state = 198},
  [2430] = {.lex_state = 189},
  [2431] = {.lex_state = 218},
  [2432] = {.lex_state = 237},
  [2433] = {.lex_state = 239},
  [2434] = {.lex_state = 198},
  [2435] = {.lex_state = 237},
  [2436] = {.lex_state = 189},
  [2437] = {.lex_state = 198},
  [2438] = {.lex_state = 236},
  [2439] = {.lex_state = 198},
  [2440] = {.lex_state = 198},
  [2441] = {.lex_state = 198},
  [2442] = {.lex_state = 204},
  [2443] = {.lex_state = 185},
  [2444] = {.lex_state = 185},
  [2445] = {.lex_state = 179},
  [2446] = {.lex_state = 196},
  [2447] = {.lex_state = 201},
  [2448] = {.lex_state = 198},
  [2449] = {.lex_state = 198},
  [2450] = {.lex_state = 202},
  [2451] = {.lex_state = 196},
  [2452] = {.lex_state = 198},
  [2453] = {.lex_state = 198},
  [2454] = {.lex_state = 202},
  [2455] = {.lex_state = 198},
  [2456] = {.lex_state = 189},
  [2457] = {.lex_state = 207},
  [2458] = {.lex_state = 196},
  [2459] = {.lex_state = 196},
  [2460] = {.lex_state = 185},
  [2461] = {.lex_state = 189},
  [2462] = {.lex_state = 198},
  [2463] = {.lex_state = 198},
  [2464] = {.lex_state = 198},
  [2465] = {.lex_state = 189},
  [2466] = {.lex_state = 179},
  [2467] = {.lex_state = 198},
  [2468] = {.lex_state = 179},
  [2469] = {.lex_state = 236},
  [2470] = {.lex_state = 179},
  [2471] = {.lex_state = 198},
  [2472] = {.lex_state = 196},
  [2473] = {.lex_state = 239},
  [2474] = {.lex_state = 198},
  [2475] = {.lex_state = 196},
  [2476] = {.lex_state = 204},
  [2477] = {.lex_state = 210},
  [2478] = {.lex_state = 208},
  [2479] = {.lex_state = 198},
  [2480] = {.lex_state = 239},
  [2481] = {.lex_state = 185},
  [2482] = {.lex_state = 198},
  [2483] = {.lex_state = 202},
  [2484] = {.lex_state = 207},
  [2485] = {.lex_state = 198},
  [2486] = {.lex_state = 198},
  [2487] = {.lex_state = 198},
  [2488] = {.lex_state = 198},
  [2489] = {.lex_state = 198},
  [2490] = {.lex_state = 198},
  [2491] = {.lex_state = 198},
  [2492] = {.lex_state = 198},
  [2493] = {.lex_state = 198},
  [2494] = {.lex_state = 198},
  [2495] = {.lex_state = 189},
  [2496] = {.lex_state = 198},
  [2497] = {.lex_state = 185},
  [2498] = {.lex_state = 185},
  [2499] = {.lex_state = 198},
  [2500] = {.lex_state = 198},
  [2501] = {.lex_state = 189},
  [2502] = {.lex_state = 198},
  [2503] = {.lex_state = 198},
  [2504] = {.lex_state = 198},
  [2505] = {.lex_state = 198},
  [2506] = {.lex_state = 198},
  [2507] = {.lex_state = 198},
  [2508] = {.lex_state = 198},
  [2509] = {.lex_state = 198},
  [2510] = {.lex_state = 204},
  [2511] = {.lex_state = 198},
  [2512] = {.lex_state = 204},
  [2513] = {.lex_state = 198},
  [2514] = {.lex_state = 198},
  [2515] = {.lex_state = 227},
  [2516] = {.lex_state = 198},
  [2517] = {.lex_state = 198},
  [2518] = {.lex_state = 227},
  [2519] = {.lex_state = 198},
  [2520] = {.lex_state = 198},
  [2521] = {.lex_state = 198},
  [2522] = {.lex_state = 204},
  [2523] = {.lex_state = 210},
  [2524] = {.lex_state = 198},
  [2525] = {.lex_state = 198},
  [2526] = {.lex_state = 198},
  [2527] = {.lex_state = 198},
  [2528] = {.lex_state = 204},
  [2529] = {.lex_state = 189},
  [2530] = {.lex_state = 204},
  [2531] = {.lex_state = 204},
  [2532] = {.lex_state = 204},
  [2533] = {.lex_state = 204},
  [2534] = {.lex_state = 202},
  [2535] = {.lex_state = 227},
  [2536] = {.lex_state = 198},
  [2537] = {.lex_state = 227},
  [2538] = {.lex_state = 174},
  [2539] = {.lex_state = 198},
  [2540] = {.lex_state = 198},
  [2541] = {.lex_state = 198},
  [2542] = {.lex_state = 198},
  [2543] = {.lex_state = 198},
  [2544] = {.lex_state = 198},
  [2545] = {.lex_state = 227},
  [2546] = {.lex_state = 227},
  [2547] = {.lex_state = 198},
  [2548] = {.lex_state = 198},
  [2549] = {.lex_state = 198},
  [2550] = {.lex_state = 198},
  [2551] = {.lex_state = 198},
  [2552] = {.lex_state = 198},
  [2553] = {.lex_state = 198},
  [2554] = {.lex_state = 198},
  [2555] = {.lex_state = 210},
  [2556] = {.lex_state = 174},
  [2557] = {.lex_state = 198},
  [2558] = {.lex_state = 198},
  [2559] = {.lex_state = 198},
  [2560] = {.lex_state = 198},
  [2561] = {.lex_state = 215},
  [2562] = {.lex_state = 198},
  [2563] = {.lex_state = 198},
  [2564] = {.lex_state = 189},
  [2565] = {.lex_state = 198},
  [2566] = {.lex_state = 237},
  [2567] = {.lex_state = 198},
  [2568] = {.lex_state = 198},
  [2569] = {.lex_state = 214},
  [2570] = {.lex_state = 198},
  [2571] = {.lex_state = 198},
  [2572] = {.lex_state = 198},
  [2573] = {.lex_state = 198},
  [2574] = {.lex_state = 198},
  [2575] = {.lex_state = 204},
  [2576] = {.lex_state = 198},
  [2577] = {.lex_state = 198},
  [2578] = {.lex_state = 204},
  [2579] = {.lex_state = 198},
  [2580] = {.lex_state = 198},
  [2581] = {.lex_state = 198},
  [2582] = {.lex_state = 198},
  [2583] = {.lex_state = 198},
  [2584] = {.lex_state = 204},
  [2585] = {.lex_state = 198},
  [2586] = {.lex_state = 198},
  [2587] = {.lex_state = 198},
  [2588] = {.lex_state = 198},
  [2589] = {.lex_state = 198},
  [2590] = {.lex_state = 198},
  [2591] = {.lex_state = 227},
  [2592] = {.lex_state = 227},
  [2593] = {.lex_state = 198},
  [2594] = {.lex_state = 204},
  [2595] = {.lex_state = 207},
  [2596] = {.lex_state = 239},
  [2597] = {.lex_state = 227},
  [2598] = {.lex_state = 185},
  [2599] = {.lex_state = 214},
  [2600] = {.lex_state = 181},
  [2601] = {.lex_state = 207},
  [2602] = {.lex_state = 239},
  [2603] = {.lex_state = 185},
  [2604] = {.lex_state = 185},
  [2605] = {.lex_state = 207},
  [2606] = {.lex_state = 207},
  [2607] = {.lex_state = 207},
  [2608] = {.lex_state = 207},
  [2609] = {.lex_state = 185},
  [2610] = {.lex_state = 239},
  [2611] = {.lex_state = 239},
  [2612] = {.lex_state = 227},
  [2613] = {.lex_state = 207},
  [2614] = {.lex_state = 239},
  [2615] = {.lex_state = 207},
  [2616] = {.lex_state = 239},
  [2617] = {.lex_state = 181},
  [2618] = {.lex_state = 239},
  [2619] = {.lex_state = 181},
  [2620] = {.lex_state = 207},
  [2621] = {.lex_state = 239},
  [2622] = {.lex_state = 174},
  [2623] = {.lex_state = 239},
  [2624] = {.lex_state = 214},
  [2625] = {.lex_state = 239},
  [2626] = {.lex_state = 174},
  [2627] = {.lex_state = 239},
  [2628] = {.lex_state = 239},
  [2629] = {.lex_state = 239},
  [2630] = {.lex_state = 239},
  [2631] = {.lex_state = 207},
  [2632] = {.lex_state = 239},
  [2633] = {.lex_state = 239},
  [2634] = {.lex_state = 239},
  [2635] = {.lex_state = 214},
  [2636] = {.lex_state = 214},
  [2637] = {.lex_state = 239},
  [2638] = {.lex_state = 214},
  [2639] = {.lex_state = 174},
  [2640] = {.lex_state = 239},
  [2641] = {.lex_state = 174},
  [2642] = {.lex_state = 174},
  [2643] = {.lex_state = 231},
  [2644] = {.lex_state = 174},
  [2645] = {.lex_state = 174},
  [2646] = {.lex_state = 174},
  [2647] = {.lex_state = 174},
  [2648] = {.lex_state = 231},
  [2649] = {.lex_state = 239},
  [2650] = {.lex_state = 174},
  [2651] = {.lex_state = 239},
  [2652] = {.lex_state = 239},
  [2653] = {.lex_state = 239},
  [2654] = {.lex_state = 239},
  [2655] = {.lex_state = 239},
  [2656] = {.lex_state = 239},
  [2657] = {.lex_state = 239},
  [2658] = {.lex_state = 239},
  [2659] = {.lex_state = 208},
  [2660] = {.lex_state = 214},
  [2661] = {.lex_state = 185},
  [2662] = {.lex_state = 231},
  [2663] = {.lex_state = 239},
  [2664] = {.lex_state = 174},
  [2665] = {.lex_state = 239},
  [2666] = {.lex_state = 174},
  [2667] = {.lex_state = 239},
  [2668] = {.lex_state = 239},
  [2669] = {.lex_state = 239},
  [2670] = {.lex_state = 239},
  [2671] = {.lex_state = 174},
  [2672] = {.lex_state = 174},
  [2673] = {.lex_state = 214},
  [2674] = {.lex_state = 174},
  [2675] = {.lex_state = 174},
  [2676] = {.lex_state = 239},
  [2677] = {.lex_state = 239},
  [2678] = {.lex_state = 185},
  [2679] = {.lex_state = 214},
  [2680] = {.lex_state = 239},
  [2681] = {.lex_state = 174},
  [2682] = {.lex_state = 239},
  [2683] = {.lex_state = 174},
  [2684] = {.lex_state = 239},
  [2685] = {.lex_state = 208},
  [2686] = {.lex_state = 207},
  [2687] = {.lex_state = 239},
  [2688] = {.lex_state = 207},
  [2689] = {.lex_state = 214},
  [2690] = {.lex_state = 239},
  [2691] = {.lex_state = 239},
  [2692] = {.lex_state = 207},
  [2693] = {.lex_state = 208},
  [2694] = {.lex_state = 207},
  [2695] = {.lex_state = 239},
  [2696] = {.lex_state = 207},
  [2697] = {.lex_state = 239},
  [2698] = {.lex_state = 174},
  [2699] = {.lex_state = 207},
  [2700] = {.lex_state = 174},
  [2701] = {.lex_state = 207},
  [2702] = {.lex_state = 214},
  [2703] = {.lex_state = 239},
  [2704] = {.lex_state = 185},
  [2705] = {.lex_state = 239},
  [2706] = {.lex_state = 185},
  [2707] = {.lex_state = 231},
  [2708] = {.lex_state = 226},
  [2709] = {.lex_state = 226},
  [2710] = {.lex_state = 227},
  [2711] = {.lex_state = 208},
  [2712] = {.lex_state = 227},
  [2713] = {.lex_state = 215},
  [2714] = {.lex_state = 226},
  [2715] = {.lex_state = 207},
  [2716] = {.lex_state = 239},
  [2717] = {.lex_state = 225},
  [2718] = {.lex_state = 226},
  [2719] = {.lex_state = 214},
  [2720] = {.lex_state = 215},
  [2721] = {.lex_state = 226},
  [2722] = {.lex_state = 226},
  [2723] = {.lex_state = 239},
  [2724] = {.lex_state = 226},
  [2725] = {.lex_state = 239},
  [2726] = {.lex_state = 225},
  [2727] = {.lex_state = 226},
  [2728] = {.lex_state = 239},
  [2729] = {.lex_state = 239},
  [2730] = {.lex_state = 239},
  [2731] = {.lex_state = 207},
  [2732] = {.lex_state = 225},
  [2733] = {.lex_state = 226},
  [2734] = {.lex_state = 207},
  [2735] = {.lex_state = 214},
  [2736] = {.lex_state = 207},
  [2737] = {.lex_state = 239},
  [2738] = {.lex_state = 207},
  [2739] = {.lex_state = 226},
  [2740] = {.lex_state = 226},
  [2741] = {.lex_state = 239},
  [2742] = {.lex_state = 207},
  [2743] = {.lex_state = 214},
  [2744] = {.lex_state = 214},
  [2745] = {.lex_state = 225},
  [2746] = {.lex_state = 214},
  [2747] = {.lex_state = 214},
  [2748] = {.lex_state = 226},
  [2749] = {.lex_state = 214},
  [2750] = {.lex_state = 223},
  [2751] = {.lex_state = 198},
  [2752] = {.lex_state = 227},
  [2753] = {.lex_state = 214},
  [2754] = {.lex_state = 223},
  [2755] = {.lex_state = 227},
  [2756] = {.lex_state = 181},
  [2757] = {.lex_state = 214},
  [2758] = {.lex_state = 207},
  [2759] = {.lex_state = 223},
  [2760] = {.lex_state = 227},
  [2761] = {.lex_state = 227},
  [2762] = {.lex_state = 227},
  [2763] = {.lex_state = 198},
  [2764] = {.lex_state = 239},
  [2765] = {.lex_state = 207},
  [2766] = {.lex_state = 207},
  [2767] = {.lex_state = 239},
  [2768] = {.lex_state = 207},
  [2769] = {.lex_state = 227},
  [2770] = {.lex_state = 239},
  [2771] = {.lex_state = 198},
  [2772] = {.lex_state = 227},
  [2773] = {.lex_state = 198},
  [2774] = {.lex_state = 214},
  [2775] = {.lex_state = 198},
  [2776] = {.lex_state = 198},
  [2777] = {.lex_state = 198},
  [2778] = {.lex_state = 198},
  [2779] = {.lex_state = 227},
  [2780] = {.lex_state = 207},
  [2781] = {.lex_state = 239},
  [2782] = {.lex_state = 223},
  [2783] = {.lex_state = 227},
  [2784] = {.lex_state = 181},
  [2785] = {.lex_state = 207},
  [2786] = {.lex_state = 215},
  [2787] = {.lex_state = 198},
  [2788] = {.lex_state = 198},
  [2789] = {.lex_state = 198},
  [2790] = {.lex_state = 223},
  [2791] = {.lex_state = 198},
  [2792] = {.lex_state = 198},
  [2793] = {.lex_state = 181},
  [2794] = {.lex_state = 223},
  [2795] = {.lex_state = 239},
  [2796] = {.lex_state = 214},
  [2797] = {.lex_state = 227},
  [2798] = {.lex_state = 181},
  [2799] = {.lex_state = 239},
  [2800] = {.lex_state = 239},
  [2801] = {.lex_state = 227},
  [2802] = {.lex_state = 207},
  [2803] = {.lex_state = 227},
  [2804] = {.lex_state = 223},
  [2805] = {.lex_state = 239},
  [2806] = {.lex_state = 207},
  [2807] = {.lex_state = 198},
  [2808] = {.lex_state = 198},
  [2809] = {.lex_state = 198},
  [2810] = {.lex_state = 198},
  [2811] = {.lex_state = 207},
  [2812] = {.lex_state = 207},
  [2813] = {.lex_state = 227},
  [2814] = {.lex_state = 207},
  [2815] = {.lex_state = 239},
  [2816] = {.lex_state = 239},
  [2817] = {.lex_state = 207},
  [2818] = {.lex_state = 227},
  [2819] = {.lex_state = 207},
  [2820] = {.lex_state = 207},
  [2821] = {.lex_state = 239},
  [2822] = {.lex_state = 214},
  [2823] = {.lex_state = 207},
  [2824] = {.lex_state = 207},
  [2825] = {.lex_state = 242},
  [2826] = {.lex_state = 207},
  [2827] = {.lex_state = 207},
  [2828] = {.lex_state = 227},
  [2829] = {.lex_state = 207},
  [2830] = {.lex_state = 207},
  [2831] = {.lex_state = 199},
  [2832] = {.lex_state = 199},
  [2833] = {.lex_state = 207},
  [2834] = {.lex_state = 207},
  [2835] = {.lex_state = 196},
  [2836] = {.lex_state = 227},
  [2837] = {.lex_state = 214},
  [2838] = {.lex_state = 207},
  [2839] = {.lex_state = 227},
  [2840] = {.lex_state = 207},
  [2841] = {.lex_state = 207},
  [2842] = {.lex_state = 208},
  [2843] = {.lex_state = 239},
  [2844] = {.lex_state = 236},
  [2845] = {.lex_state = 199},
  [2846] = {.lex_state = 196},
  [2847] = {.lex_state = 207},
  [2848] = {.lex_state = 207},
  [2849] = {.lex_state = 207},
  [2850] = {.lex_state = 196},
  [2851] = {.lex_state = 196},
  [2852] = {.lex_state = 227},
  [2853] = {.lex_state = 208},
  [2854] = {.lex_state = 194},
  [2855] = {.lex_state = 237},
  [2856] = {.lex_state = 207},
  [2857] = {.lex_state = 207},
  [2858] = {.lex_state = 207},
  [2859] = {.lex_state = 236},
  [2860] = {.lex_state = 199},
  [2861] = {.lex_state = 207},
  [2862] = {.lex_state = 227},
  [2863] = {.lex_state = 196},
  [2864] = {.lex_state = 207},
  [2865] = {.lex_state = 196},
  [2866] = {.lex_state = 227},
  [2867] = {.lex_state = 207},
  [2868] = {.lex_state = 226},
  [2869] = {.lex_state = 207},
  [2870] = {.lex_state = 226},
  [2871] = {.lex_state = 196},
  [2872] = {.lex_state = 207},
  [2873] = {.lex_state = 207},
  [2874] = {.lex_state = 239},
  [2875] = {.lex_state = 214},
  [2876] = {.lex_state = 223},
  [2877] = {.lex_state = 192},
  [2878] = {.lex_state = 223},
  [2879] = {.lex_state = 227},
  [2880] = {.lex_state = 192},
  [2881] = {.lex_state = 239},
  [2882] = {.lex_state = 227},
  [2883] = {.lex_state = 227},
  [2884] = {.lex_state = 207},
  [2885] = {.lex_state = 214},
  [2886] = {.lex_state = 223},
  [2887] = {.lex_state = 207},
  [2888] = {.lex_state = 199},
  [2889] = {.lex_state = 214},
  [2890] = {.lex_state = 227},
  [2891] = {.lex_state = 207},
  [2892] = {.lex_state = 199},
  [2893] = {.lex_state = 214},
  [2894] = {.lex_state = 207},
  [2895] = {.lex_state = 227},
  [2896] = {.lex_state = 227},
  [2897] = {.lex_state = 223},
  [2898] = {.lex_state = 199},
  [2899] = {.lex_state = 227},
  [2900] = {.lex_state = 227},
  [2901] = {.lex_state = 214},
  [2902] = {.lex_state = 174},
  [2903] = {.lex_state = 198},
  [2904] = {.lex_state = 198},
  [2905] = {.lex_state = 207},
  [2906] = {.lex_state = 199},
  [2907] = {.lex_state = 198},
  [2908] = {.lex_state = 227},
  [2909] = {.lex_state = 198},
  [2910] = {.lex_state = 198},
  [2911] = {.lex_state = 227},
  [2912] = {.lex_state = 223},
  [2913] = {.lex_state = 198},
  [2914] = {.lex_state = 227},
  [2915] = {.lex_state = 214},
  [2916] = {.lex_state = 198},
  [2917] = {.lex_state = 198},
  [2918] = {.lex_state = 207},
  [2919] = {.lex_state = 208},
  [2920] = {.lex_state = 214},
  [2921] = {.lex_state = 198},
  [2922] = {.lex_state = 198},
  [2923] = {.lex_state = 198},
  [2924] = {.lex_state = 227},
  [2925] = {.lex_state = 227},
  [2926] = {.lex_state = 198},
  [2927] = {.lex_state = 207},
  [2928] = {.lex_state = 198},
  [2929] = {.lex_state = 192},
  [2930] = {.lex_state = 214},
  [2931] = {.lex_state = 198},
  [2932] = {.lex_state = 192},
  [2933] = {.lex_state = 227},
  [2934] = {.lex_state = 227},
  [2935] = {.lex_state = 227},
  [2936] = {.lex_state = 192},
  [2937] = {.lex_state = 227},
  [2938] = {.lex_state = 227},
  [2939] = {.lex_state = 227},
  [2940] = {.lex_state = 207},
  [2941] = {.lex_state = 192},
  [2942] = {.lex_state = 207},
  [2943] = {.lex_state = 227},
  [2944] = {.lex_state = 227},
  [2945] = {.lex_state = 207},
  [2946] = {.lex_state = 214},
  [2947] = {.lex_state = 227},
  [2948] = {.lex_state = 227},
  [2949] = {.lex_state = 214},
  [2950] = {.lex_state = 223},
  [2951] = {.lex_state = 227},
  [2952] = {.lex_state = 227},
  [2953] = {.lex_state = 227},
  [2954] = {.lex_state = 207},
  [2955] = {.lex_state = 237},
  [2956] = {.lex_state = 227},
  [2957] = {.lex_state = 207},
  [2958] = {.lex_state = 223},
  [2959] = {.lex_state = 227},
  [2960] = {.lex_state = 207},
  [2961] = {.lex_state = 198},
  [2962] = {.lex_state = 207},
  [2963] = {.lex_state = 207},
  [2964] = {.lex_state = 227},
  [2965] = {.lex_state = 227},
  [2966] = {.lex_state = 239},
  [2967] = {.lex_state = 194},
  [2968] = {.lex_state = 227},
  [2969] = {.lex_state = 227},
  [2970] = {.lex_state = 214},
  [2971] = {.lex_state = 227},
  [2972] = {.lex_state = 198},
  [2973] = {.lex_state = 198},
  [2974] = {.lex_state = 198},
  [2975] = {.lex_state = 214},
  [2976] = {.lex_state = 207},
  [2977] = {.lex_state = 207},
  [2978] = {.lex_state = 237},
  [2979] = {.lex_state = 207},
  [2980] = {.lex_state = 207},
  [2981] = {.lex_state = 214},
  [2982] = {.lex_state = 217},
  [2983] = {.lex_state = 168},
  [2984] = {.lex_state = 203},
  [2985] = {.lex_state = 202},
  [2986] = {.lex_state = 239},
  [2987] = {.lex_state = 214},
  [2988] = {.lex_state = 214},
  [2989] = {.lex_state = 207},
  [2990] = {.lex_state = 207},
  [2991] = {.lex_state = 207},
  [2992] = {.lex_state = 192},
  [2993] = {.lex_state = 207},
  [2994] = {.lex_state = 207},
  [2995] = {.lex_state = 237},
  [2996] = {.lex_state = 207},
  [2997] = {.lex_state = 214},
  [2998] = {.lex_state = 207},
  [2999] = {.lex_state = 237},
  [3000] = {.lex_state = 207},
  [3001] = {.lex_state = 207},
  [3002] = {.lex_state = 168},
  [3003] = {.lex_state = 217},
  [3004] = {.lex_state = 207},
  [3005] = {.lex_state = 207},
  [3006] = {.lex_state = 207},
  [3007] = {.lex_state = 207},
  [3008] = {.lex_state = 237},
  [3009] = {.lex_state = 207},
  [3010] = {.lex_state = 207},
  [3011] = {.lex_state = 207},
  [3012] = {.lex_state = 207},
  [3013] = {.lex_state = 236},
  [3014] = {.lex_state = 207},
  [3015] = {.lex_state = 237},
  [3016] = {.lex_state = 237},
  [3017] = {.lex_state = 214},
  [3018] = {.lex_state = 207},
  [3019] = {.lex_state = 217},
  [3020] = {.lex_state = 207},
  [3021] = {.lex_state = 207},
  [3022] = {.lex_state = 217},
  [3023] = {.lex_state = 217},
  [3024] = {.lex_state = 207},
  [3025] = {.lex_state = 168},
  [3026] = {.lex_state = 181},
  [3027] = {.lex_state = 237},
  [3028] = {.lex_state = 207},
  [3029] = {.lex_state = 239},
  [3030] = {.lex_state = 168},
  [3031] = {.lex_state = 236},
  [3032] = {.lex_state = 239},
  [3033] = {.lex_state = 202},
  [3034] = {.lex_state = 181},
  [3035] = {.lex_state = 237},
  [3036] = {.lex_state = 192},
  [3037] = {.lex_state = 207},
  [3038] = {.lex_state = 239},
  [3039] = {.lex_state = 214},
  [3040] = {.lex_state = 168},
  [3041] = {.lex_state = 207},
  [3042] = {.lex_state = 214},
  [3043] = {.lex_state = 207},
  [3044] = {.lex_state = 207},
  [3045] = {.lex_state = 207},
  [3046] = {.lex_state = 207},
  [3047] = {.lex_state = 237},
  [3048] = {.lex_state = 237},
  [3049] = {.lex_state = 237},
  [3050] = {.lex_state = 207},
  [3051] = {.lex_state = 207},
  [3052] = {.lex_state = 168},
  [3053] = {.lex_state = 207},
  [3054] = {.lex_state = 207},
  [3055] = {.lex_state = 192},
  [3056] = {.lex_state = 214},
  [3057] = {.lex_state = 214},
  [3058] = {.lex_state = 207},
  [3059] = {.lex_state = 207},
  [3060] = {.lex_state = 207},
  [3061] = {.lex_state = 239},
  [3062] = {.lex_state = 198},
  [3063] = {.lex_state = 198},
  [3064] = {.lex_state = 207},
  [3065] = {.lex_state = 214},
  [3066] = {.lex_state = 214},
  [3067] = {.lex_state = 207},
  [3068] = {.lex_state = 226},
  [3069] = {.lex_state = 214},
  [3070] = {.lex_state = 192},
  [3071] = {.lex_state = 207},
  [3072] = {.lex_state = 198},
  [3073] = {.lex_state = 237},
  [3074] = {.lex_state = 209},
  [3075] = {.lex_state = 216},
  [3076] = {.lex_state = 214},
  [3077] = {.lex_state = 194},
  [3078] = {.lex_state = 207},
  [3079] = {.lex_state = 239},
  [3080] = {.lex_state = 240},
  [3081] = {.lex_state = 239},
  [3082] = {.lex_state = 214},
  [3083] = {.lex_state = 207},
  [3084] = {.lex_state = 239},
  [3085] = {.lex_state = 214},
  [3086] = {.lex_state = 207},
  [3087] = {.lex_state = 239},
  [3088] = {.lex_state = 214},
  [3089] = {.lex_state = 237},
  [3090] = {.lex_state = 214},
  [3091] = {.lex_state = 207},
  [3092] = {.lex_state = 239},
  [3093] = {.lex_state = 207},
  [3094] = {.lex_state = 214},
  [3095] = {.lex_state = 214},
  [3096] = {.lex_state = 207},
  [3097] = {.lex_state = 214},
  [3098] = {.lex_state = 214},
  [3099] = {.lex_state = 214},
  [3100] = {.lex_state = 214},
  [3101] = {.lex_state = 214},
  [3102] = {.lex_state = 214},
  [3103] = {.lex_state = 214},
  [3104] = {.lex_state = 207},
  [3105] = {.lex_state = 207},
  [3106] = {.lex_state = 239},
  [3107] = {.lex_state = 207},
  [3108] = {.lex_state = 207},
  [3109] = {.lex_state = 214},
  [3110] = {.lex_state = 207},
  [3111] = {.lex_state = 239},
  [3112] = {.lex_state = 239},
  [3113] = {.lex_state = 239},
  [3114] = {.lex_state = 214},
  [3115] = {.lex_state = 214},
  [3116] = {.lex_state = 207},
  [3117] = {.lex_state = 198},
  [3118] = {.lex_state = 207},
  [3119] = {.lex_state = 217},
  [3120] = {.lex_state = 207},
  [3121] = {.lex_state = 207},
  [3122] = {.lex_state = 214},
  [3123] = {.lex_state = 207},
  [3124] = {.lex_state = 217},
  [3125] = {.lex_state = 237},
  [3126] = {.lex_state = 214},
  [3127] = {.lex_state = 207},
  [3128] = {.lex_state = 237},
  [3129] = {.lex_state = 198},
  [3130] = {.lex_state = 237},
  [3131] = {.lex_state = 237},
  [3132] = {.lex_state = 198},
  [3133] = {.lex_state = 214},
  [3134] = {.lex_state = 192},
  [3135] = {.lex_state = 239},
  [3136] = {.lex_state = 207},
  [3137] = {.lex_state = 237},
  [3138] = {.lex_state = 214},
  [3139] = {.lex_state = 207},
  [3140] = {.lex_state = 207},
  [3141] = {.lex_state = 207},
  [3142] = {.lex_state = 207},
  [3143] = {.lex_state = 239},
  [3144] = {.lex_state = 207},
  [3145] = {.lex_state = 207},
  [3146] = {.lex_state = 194},
  [3147] = {.lex_state = 214},
  [3148] = {.lex_state = 214},
  [3149] = {.lex_state = 207},
  [3150] = {.lex_state = 237},
  [3151] = {.lex_state = 214},
  [3152] = {.lex_state = 214},
  [3153] = {.lex_state = 239},
  [3154] = {.lex_state = 214},
  [3155] = {.lex_state = 198},
  [3156] = {.lex_state = 214},
  [3157] = {.lex_state = 207},
  [3158] = {.lex_state = 207},
  [3159] = {.lex_state = 198},
  [3160] = {.lex_state = 198},
  [3161] = {.lex_state = 198},
  [3162] = {.lex_state = 214},
  [3163] = {.lex_state = 207},
  [3164] = {.lex_state = 207},
  [3165] = {.lex_state = 214},
  [3166] = {.lex_state = 207},
  [3167] = {.lex_state = 214},
  [3168] = {.lex_state = 214},
  [3169] = {.lex_state = 181},
  [3170] = {.lex_state = 207},
  [3171] = {.lex_state = 198},
  [3172] = {.lex_state = 198},
  [3173] = {.lex_state = 198},
  [3174] = {.lex_state = 207},
  [3175] = {.lex_state = 198},
  [3176] = {.lex_state = 198},
  [3177] = {.lex_state = 207},
  [3178] = {.lex_state = 181},
  [3179] = {.lex_state = 239},
  [3180] = {.lex_state = 214},
  [3181] = {.lex_state = 202},
  [3182] = {.lex_state = 198},
  [3183] = {.lex_state = 198},
  [3184] = {.lex_state = 214},
  [3185] = {.lex_state = 202},
  [3186] = {.lex_state = 207},
  [3187] = {.lex_state = 214},
  [3188] = {.lex_state = 214},
  [3189] = {.lex_state = 203},
  [3190] = {.lex_state = 207},
  [3191] = {.lex_state = 207},
  [3192] = {.lex_state = 207},
  [3193] = {.lex_state = 207},
  [3194] = {.lex_state = 198},
  [3195] = {.lex_state = 207},
  [3196] = {.lex_state = 198},
  [3197] = {.lex_state = 199},
  [3198] = {.lex_state = 198},
  [3199] = {.lex_state = 198},
  [3200] = {.lex_state = 214},
  [3201] = {.lex_state = 202},
  [3202] = {.lex_state = 198},
  [3203] = {.lex_state = 207},
  [3204] = {.lex_state = 181},
  [3205] = {.lex_state = 239},
  [3206] = {.lex_state = 202},
  [3207] = {.lex_state = 239},
  [3208] = {.lex_state = 194},
  [3209] = {.lex_state = 214},
  [3210] = {.lex_state = 192},
  [3211] = {.lex_state = 202},
  [3212] = {.lex_state = 207},
  [3213] = {.lex_state = 198},
  [3214] = {.lex_state = 214},
  [3215] = {.lex_state = 214},
  [3216] = {.lex_state = 214},
  [3217] = {.lex_state = 198},
  [3218] = {.lex_state = 198},
  [3219] = {.lex_state = 214},
  [3220] = {.lex_state = 214},
  [3221] = {.lex_state = 214},
  [3222] = {.lex_state = 207},
  [3223] = {.lex_state = 214},
  [3224] = {.lex_state = 214},
  [3225] = {.lex_state = 214},
  [3226] = {.lex_state = 192},
  [3227] = {.lex_state = 214},
  [3228] = {.lex_state = 192},
  [3229] = {.lex_state = 192},
  [3230] = {.lex_state = 239},
  [3231] = {.lex_state = 202},
  [3232] = {.lex_state = 207},
  [3233] = {.lex_state = 207},
  [3234] = {.lex_state = 198},
  [3235] = {.lex_state = 207},
  [3236] = {.lex_state = 198},
  [3237] = {.lex_state = 211},
  [3238] = {.lex_state = 192},
  [3239] = {.lex_state = 202},
  [3240] = {.lex_state = 207},
  [3241] = {.lex_state = 198},
  [3242] = {.lex_state = 192},
  [3243] = {.lex_state = 207},
  [3244] = {.lex_state = 202},
  [3245] = {.lex_state = 214},
  [3246] = {.lex_state = 214},
  [3247] = {.lex_state = 192},
  [3248] = {.lex_state = 214},
  [3249] = {.lex_state = 198},
  [3250] = {.lex_state = 207},
  [3251] = {.lex_state = 198},
  [3252] = {.lex_state = 207},
  [3253] = {.lex_state = 198},
  [3254] = {.lex_state = 214},
  [3255] = {.lex_state = 202},
  [3256] = {.lex_state = 202},
  [3257] = {.lex_state = 181},
  [3258] = {.lex_state = 207},
  [3259] = {.lex_state = 198},
  [3260] = {.lex_state = 239},
  [3261] = {.lex_state = 192},
  [3262] = {.lex_state = 223},
  [3263] = {.lex_state = 202},
  [3264] = {.lex_state = 192},
  [3265] = {.lex_state = 207},
  [3266] = {.lex_state = 192},
  [3267] = {.lex_state = 202},
  [3268] = {.lex_state = 192},
  [3269] = {.lex_state = 202},
  [3270] = {.lex_state = 192},
  [3271] = {.lex_state = 202},
  [3272] = {.lex_state = 198},
  [3273] = {.lex_state = 202},
  [3274] = {.lex_state = 198},
  [3275] = {.lex_state = 202},
  [3276] = {.lex_state = 202},
  [3277] = {.lex_state = 199},
  [3278] = {.lex_state = 198},
  [3279] = {.lex_state = 194},
  [3280] = {.lex_state = 192},
  [3281] = {.lex_state = 198},
  [3282] = {.lex_state = 207},
  [3283] = {.lex_state = 192},
  [3284] = {.lex_state = 239},
  [3285] = {.lex_state = 198},
  [3286] = {.lex_state = 211},
  [3287] = {.lex_state = 198},
  [3288] = {.lex_state = 202},
  [3289] = {.lex_state = 202},
  [3290] = {.lex_state = 194},
  [3291] = {.lex_state = 202},
  [3292] = {.lex_state = 199},
  [3293] = {.lex_state = 214},
  [3294] = {.lex_state = 239},
  [3295] = {.lex_state = 214},
  [3296] = {.lex_state = 192},
  [3297] = {.lex_state = 202},
  [3298] = {.lex_state = 192},
  [3299] = {.lex_state = 192},
  [3300] = {.lex_state = 198},
  [3301] = {.lex_state = 214},
  [3302] = {.lex_state = 207},
  [3303] = {.lex_state = 207},
  [3304] = {.lex_state = 181},
  [3305] = {.lex_state = 223},
  [3306] = {.lex_state = 202},
  [3307] = {.lex_state = 211},
  [3308] = {.lex_state = 199},
  [3309] = {.lex_state = 202},
  [3310] = {.lex_state = 194},
  [3311] = {.lex_state = 192},
  [3312] = {.lex_state = 202},
  [3313] = {.lex_state = 207},
  [3314] = {.lex_state = 198},
  [3315] = {.lex_state = 207},
  [3316] = {.lex_state = 204},
  [3317] = {.lex_state = 214},
  [3318] = {.lex_state = 214},
  [3319] = {.lex_state = 198},
  [3320] = {.lex_state = 194},
  [3321] = {.lex_state = 202},
  [3322] = {.lex_state = 198},
  [3323] = {.lex_state = 198},
  [3324] = {.lex_state = 239},
  [3325] = {.lex_state = 239},
  [3326] = {.lex_state = 214},
  [3327] = {.lex_state = 211},
  [3328] = {.lex_state = 214},
  [3329] = {.lex_state = 213},
  [3330] = {.lex_state = 214},
  [3331] = {.lex_state = 192},
  [3332] = {.lex_state = 192},
  [3333] = {.lex_state = 198},
  [3334] = {.lex_state = 192},
  [3335] = {.lex_state = 214},
  [3336] = {.lex_state = 207},
  [3337] = {.lex_state = 214},
  [3338] = {.lex_state = 192},
  [3339] = {.lex_state = 192},
  [3340] = {.lex_state = 202},
  [3341] = {.lex_state = 207},
  [3342] = {.lex_state = 192},
  [3343] = {.lex_state = 239},
  [3344] = {.lex_state = 192},
  [3345] = {.lex_state = 192},
  [3346] = {.lex_state = 192},
  [3347] = {.lex_state = 214},
  [3348] = {.lex_state = 192},
  [3349] = {.lex_state = 192},
  [3350] = {.lex_state = 207},
  [3351] = {.lex_state = 214},
  [3352] = {.lex_state = 207},
  [3353] = {.lex_state = 194},
  [3354] = {.lex_state = 202},
  [3355] = {.lex_state = 207},
  [3356] = {.lex_state = 202},
  [3357] = {.lex_state = 207},
  [3358] = {.lex_state = 204},
  [3359] = {.lex_state = 217},
  [3360] = {.lex_state = 240},
  [3361] = {.lex_state = 207},
  [3362] = {.lex_state = 207},
  [3363] = {.lex_state = 207},
  [3364] = {.lex_state = 207},
  [3365] = {.lex_state = 207},
  [3366] = {.lex_state = 207},
  [3367] = {.lex_state = 207},
  [3368] = {.lex_state = 207},
  [3369] = {.lex_state = 207},
  [3370] = {.lex_state = 204},
  [3371] = {.lex_state = 207},
  [3372] = {.lex_state = 207},
  [3373] = {.lex_state = 207},
  [3374] = {.lex_state = 207},
  [3375] = {.lex_state = 204},
  [3376] = {.lex_state = 240},
  [3377] = {.lex_state = 204},
  [3378] = {.lex_state = 207},
  [3379] = {.lex_state = 217},
  [3380] = {.lex_state = 217},
  [3381] = {.lex_state = 207},
  [3382] = {.lex_state = 207},
  [3383] = {.lex_state = 207},
  [3384] = {.lex_state = 207},
  [3385] = {.lex_state = 217},
  [3386] = {.lex_state = 207},
  [3387] = {.lex_state = 207},
  [3388] = {.lex_state = 207},
  [3389] = {.lex_state = 207},
  [3390] = {.lex_state = 217},
  [3391] = {.lex_state = 217},
  [3392] = {.lex_state = 207},
  [3393] = {.lex_state = 204},
  [3394] = {.lex_state = 237},
  [3395] = {.lex_state = 207},
  [3396] = {.lex_state = 191},
  [3397] = {.lex_state = 181},
  [3398] = {.lex_state = 207},
  [3399] = {.lex_state = 207},
  [3400] = {.lex_state = 204},
  [3401] = {.lex_state = 204},
  [3402] = {.lex_state = 239},
  [3403] = {.lex_state = 181},
  [3404] = {.lex_state = 207},
  [3405] = {.lex_state = 239},
  [3406] = {.lex_state = 207},
  [3407] = {.lex_state = 204},
  [3408] = {.lex_state = 207},
  [3409] = {.lex_state = 207},
  [3410] = {.lex_state = 207},
  [3411] = {.lex_state = 217},
  [3412] = {.lex_state = 207},
  [3413] = {.lex_state = 207},
  [3414] = {.lex_state = 207},
  [3415] = {.lex_state = 219},
  [3416] = {.lex_state = 219},
  [3417] = {.lex_state = 181},
  [3418] = {.lex_state = 204},
  [3419] = {.lex_state = 207},
  [3420] = {.lex_state = 207},
  [3421] = {.lex_state = 207},
  [3422] = {.lex_state = 207},
  [3423] = {.lex_state = 207},
  [3424] = {.lex_state = 239},
  [3425] = {.lex_state = 207},
  [3426] = {.lex_state = 239},
  [3427] = {.lex_state = 239},
  [3428] = {.lex_state = 221},
  [3429] = {.lex_state = 207},
  [3430] = {.lex_state = 207},
  [3431] = {.lex_state = 239},
  [3432] = {.lex_state = 207},
  [3433] = {.lex_state = 207},
  [3434] = {.lex_state = 219},
  [3435] = {.lex_state = 207},
  [3436] = {.lex_state = 207},
  [3437] = {.lex_state = 207},
  [3438] = {.lex_state = 240},
  [3439] = {.lex_state = 204},
  [3440] = {.lex_state = 198},
  [3441] = {.lex_state = 217},
  [3442] = {.lex_state = 207},
  [3443] = {.lex_state = 239},
  [3444] = {.lex_state = 202},
  [3445] = {.lex_state = 207},
  [3446] = {.lex_state = 217},
  [3447] = {.lex_state = 207},
  [3448] = {.lex_state = 207},
  [3449] = {.lex_state = 217},
  [3450] = {.lex_state = 207},
  [3451] = {.lex_state = 207},
  [3452] = {.lex_state = 207},
  [3453] = {.lex_state = 207},
  [3454] = {.lex_state = 207},
  [3455] = {.lex_state = 207},
  [3456] = {.lex_state = 207},
  [3457] = {.lex_state = 207},
  [3458] = {.lex_state = 223},
  [3459] = {.lex_state = 217},
  [3460] = {.lex_state = 207},
  [3461] = {.lex_state = 207},
  [3462] = {.lex_state = 207},
  [3463] = {.lex_state = 207},
  [3464] = {.lex_state = 239},
  [3465] = {.lex_state = 198},
  [3466] = {.lex_state = 207},
  [3467] = {.lex_state = 207},
  [3468] = {.lex_state = 207},
  [3469] = {.lex_state = 207},
  [3470] = {.lex_state = 207},
  [3471] = {.lex_state = 214},
  [3472] = {.lex_state = 207},
  [3473] = {.lex_state = 239},
  [3474] = {.lex_state = 207},
  [3475] = {.lex_state = 207},
  [3476] = {.lex_state = 217},
  [3477] = {.lex_state = 207},
  [3478] = {.lex_state = 237},
  [3479] = {.lex_state = 204},
  [3480] = {.lex_state = 204},
  [3481] = {.lex_state = 204},
  [3482] = {.lex_state = 204},
  [3483] = {.lex_state = 191},
  [3484] = {.lex_state = 207},
  [3485] = {.lex_state = 207},
  [3486] = {.lex_state = 207},
  [3487] = {.lex_state = 207},
  [3488] = {.lex_state = 207},
  [3489] = {.lex_state = 207},
  [3490] = {.lex_state = 207},
  [3491] = {.lex_state = 207},
  [3492] = {.lex_state = 207},
  [3493] = {.lex_state = 207},
  [3494] = {.lex_state = 207},
  [3495] = {.lex_state = 207},
  [3496] = {.lex_state = 202},
  [3497] = {.lex_state = 207},
  [3498] = {.lex_state = 239},
  [3499] = {.lex_state = 207},
  [3500] = {.lex_state = 207},
  [3501] = {.lex_state = 207},
  [3502] = {.lex_state = 207},
  [3503] = {.lex_state = 207},
  [3504] = {.lex_state = 204},
  [3505] = {.lex_state = 204},
  [3506] = {.lex_state = 207},
  [3507] = {.lex_state = 207},
  [3508] = {.lex_state = 207},
  [3509] = {.lex_state = 207},
  [3510] = {.lex_state = 217},
  [3511] = {.lex_state = 219},
  [3512] = {.lex_state = 204},
  [3513] = {.lex_state = 207},
  [3514] = {.lex_state = 214},
  [3515] = {.lex_state = 207},
  [3516] = {.lex_state = 217},
  [3517] = {.lex_state = 217},
  [3518] = {.lex_state = 207},
  [3519] = {.lex_state = 191},
  [3520] = {.lex_state = 207},
  [3521] = {.lex_state = 217},
  [3522] = {.lex_state = 207},
  [3523] = {.lex_state = 214},
  [3524] = {.lex_state = 207},
  [3525] = {.lex_state = 207},
  [3526] = {.lex_state = 207},
  [3527] = {.lex_state = 207},
  [3528] = {.lex_state = 207},
  [3529] = {.lex_state = 207},
  [3530] = {.lex_state = 181},
  [3531] = {.lex_state = 207},
  [3532] = {.lex_state = 207},
  [3533] = {.lex_state = 207},
  [3534] = {.lex_state = 239},
  [3535] = {.lex_state = 207},
  [3536] = {.lex_state = 207},
  [3537] = {.lex_state = 207},
  [3538] = {.lex_state = 217},
  [3539] = {.lex_state = 239},
  [3540] = {.lex_state = 207},
  [3541] = {.lex_state = 207},
  [3542] = {.lex_state = 207},
  [3543] = {.lex_state = 207},
  [3544] = {.lex_state = 207},
  [3545] = {.lex_state = 214},
  [3546] = {.lex_state = 207},
  [3547] = {.lex_state = 207},
  [3548] = {.lex_state = 214},
  [3549] = {.lex_state = 214},
  [3550] = {.lex_state = 214},
  [3551] = {.lex_state = 214},
  [3552] = {.lex_state = 214},
  [3553] = {.lex_state = 214},
  [3554] = {.lex_state = 214},
  [3555] = {.lex_state = 214},
  [3556] = {.lex_state = 214},
  [3557] = {.lex_state = 207},
  [3558] = {.lex_state = 214},
  [3559] = {.lex_state = 214},
  [3560] = {.lex_state = 202},
  [3561] = {.lex_state = 214},
  [3562] = {.lex_state = 214},
  [3563] = {.lex_state = 214},
  [3564] = {.lex_state = 214},
  [3565] = {.lex_state = 214},
  [3566] = {.lex_state = 214},
  [3567] = {.lex_state = 214},
  [3568] = {.lex_state = 214},
  [3569] = {.lex_state = 240},
  [3570] = {.lex_state = 214},
  [3571] = {.lex_state = 214},
  [3572] = {.lex_state = 214},
  [3573] = {.lex_state = 214},
  [3574] = {.lex_state = 214},
  [3575] = {.lex_state = 214},
  [3576] = {.lex_state = 214},
  [3577] = {.lex_state = 214},
  [3578] = {.lex_state = 214},
  [3579] = {.lex_state = 207},
  [3580] = {.lex_state = 202},
  [3581] = {.lex_state = 207},
  [3582] = {.lex_state = 214},
  [3583] = {.lex_state = 207},
  [3584] = {.lex_state = 214},
  [3585] = {.lex_state = 207},
  [3586] = {.lex_state = 214},
  [3587] = {.lex_state = 207},
  [3588] = {.lex_state = 207},
  [3589] = {.lex_state = 207},
  [3590] = {.lex_state = 207},
  [3591] = {.lex_state = 214},
  [3592] = {.lex_state = 214},
  [3593] = {.lex_state = 214},
  [3594] = {.lex_state = 214},
  [3595] = {.lex_state = 214},
  [3596] = {.lex_state = 207},
  [3597] = {.lex_state = 214},
  [3598] = {.lex_state = 207},
  [3599] = {.lex_state = 207},
  [3600] = {.lex_state = 214},
  [3601] = {.lex_state = 207},
  [3602] = {.lex_state = 207},
  [3603] = {.lex_state = 202},
  [3604] = {.lex_state = 202},
  [3605] = {.lex_state = 214},
  [3606] = {.lex_state = 214},
  [3607] = {.lex_state = 214},
  [3608] = {.lex_state = 207},
  [3609] = {.lex_state = 207},
  [3610] = {.lex_state = 202},
  [3611] = {.lex_state = 198},
  [3612] = {.lex_state = 198},
  [3613] = {.lex_state = 207},
  [3614] = {.lex_state = 207},
  [3615] = {.lex_state = 214},
  [3616] = {.lex_state = 242},
  [3617] = {.lex_state = 239},
  [3618] = {.lex_state = 239},
  [3619] = {.lex_state = 214},
  [3620] = {.lex_state = 207},
  [3621] = {.lex_state = 214},
  [3622] = {.lex_state = 202},
  [3623] = {.lex_state = 207},
  [3624] = {.lex_state = 214},
  [3625] = {.lex_state = 214},
  [3626] = {.lex_state = 214},
  [3627] = {.lex_state = 240},
  [3628] = {.lex_state = 207},
  [3629] = {.lex_state = 214},
  [3630] = {.lex_state = 239},
  [3631] = {.lex_state = 239},
  [3632] = {.lex_state = 214},
  [3633] = {.lex_state = 214},
  [3634] = {.lex_state = 214},
  [3635] = {.lex_state = 214},
  [3636] = {.lex_state = 214},
  [3637] = {.lex_state = 214},
  [3638] = {.lex_state = 240},
  [3639] = {.lex_state = 214},
  [3640] = {.lex_state = 181},
  [3641] = {.lex_state = 181},
  [3642] = {.lex_state = 214},
  [3643] = {.lex_state = 214},
  [3644] = {.lex_state = 214},
  [3645] = {.lex_state = 214},
  [3646] = {.lex_state = 214},
  [3647] = {.lex_state = 214},
  [3648] = {.lex_state = 214},
  [3649] = {.lex_state = 214},
  [3650] = {.lex_state = 214},
  [3651] = {.lex_state = 207},
  [3652] = {.lex_state = 214},
  [3653] = {.lex_state = 239},
  [3654] = {.lex_state = 207},
  [3655] = {.lex_state = 237},
  [3656] = {.lex_state = 214},
  [3657] = {.lex_state = 239},
  [3658] = {.lex_state = 207},
  [3659] = {.lex_state = 214},
  [3660] = {.lex_state = 214},
  [3661] = {.lex_state = 202},
  [3662] = {.lex_state = 214},
  [3663] = {.lex_state = 214},
  [3664] = {.lex_state = 202},
  [3665] = {.lex_state = 239},
  [3666] = {.lex_state = 239},
  [3667] = {.lex_state = 214},
  [3668] = {.lex_state = 202},
  [3669] = {.lex_state = 214},
  [3670] = {.lex_state = 202},
  [3671] = {.lex_state = 214},
  [3672] = {.lex_state = 214},
  [3673] = {.lex_state = 214},
  [3674] = {.lex_state = 214},
  [3675] = {.lex_state = 214},
  [3676] = {.lex_state = 214},
  [3677] = {.lex_state = 198},
  [3678] = {.lex_state = 240},
  [3679] = {.lex_state = 198},
  [3680] = {.lex_state = 198},
  [3681] = {.lex_state = 239},
  [3682] = {.lex_state = 198},
  [3683] = {.lex_state = 198},
  [3684] = {.lex_state = 198},
  [3685] = {.lex_state = 198},
  [3686] = {.lex_state = 214},
  [3687] = {.lex_state = 214},
  [3688] = {.lex_state = 214},
  [3689] = {.lex_state = 214},
  [3690] = {.lex_state = 207},
  [3691] = {.lex_state = 214},
  [3692] = {.lex_state = 204},
  [3693] = {.lex_state = 237},
  [3694] = {.lex_state = 237},
  [3695] = {.lex_state = 237},
  [3696] = {.lex_state = 237},
  [3697] = {.lex_state = 237},
  [3698] = {.lex_state = 223},
  [3699] = {.lex_state = 237},
  [3700] = {.lex_state = 237},
  [3701] = {.lex_state = 181},
  [3702] = {.lex_state = 237},
  [3703] = {.lex_state = 237},
  [3704] = {.lex_state = 181},
  [3705] = {.lex_state = 237},
  [3706] = {.lex_state = 237},
  [3707] = {.lex_state = 191},
  [3708] = {.lex_state = 237},
  [3709] = {.lex_state = 191},
  [3710] = {.lex_state = 202},
  [3711] = {.lex_state = 237},
  [3712] = {.lex_state = 237},
  [3713] = {.lex_state = 237},
  [3714] = {.lex_state = 237},
  [3715] = {.lex_state = 237},
  [3716] = {.lex_state = 202},
  [3717] = {.lex_state = 237},
  [3718] = {.lex_state = 237},
  [3719] = {.lex_state = 207},
  [3720] = {.lex_state = 237},
  [3721] = {.lex_state = 237},
  [3722] = {.lex_state = 202},
  [3723] = {.lex_state = 202},
  [3724] = {.lex_state = 237},
  [3725] = {.lex_state = 202},
  [3726] = {.lex_state = 237},
  [3727] = {.lex_state = 237},
  [3728] = {.lex_state = 237},
  [3729] = {.lex_state = 237},
  [3730] = {.lex_state = 237},
  [3731] = {.lex_state = 202},
  [3732] = {.lex_state = 211},
  [3733] = {.lex_state = 237},
  [3734] = {.lex_state = 204},
  [3735] = {.lex_state = 237},
  [3736] = {.lex_state = 237},
  [3737] = {.lex_state = 237},
  [3738] = {.lex_state = 237},
  [3739] = {.lex_state = 237},
  [3740] = {.lex_state = 237},
  [3741] = {.lex_state = 211},
  [3742] = {.lex_state = 239},
  [3743] = {.lex_state = 237},
  [3744] = {.lex_state = 204},
  [3745] = {.lex_state = 223},
  [3746] = {.lex_state = 237},
  [3747] = {.lex_state = 202},
  [3748] = {.lex_state = 237},
  [3749] = {.lex_state = 237},
  [3750] = {.lex_state = 202},
  [3751] = {.lex_state = 237},
  [3752] = {.lex_state = 237},
  [3753] = {.lex_state = 202},
  [3754] = {.lex_state = 237},
  [3755] = {.lex_state = 239},
  [3756] = {.lex_state = 237},
  [3757] = {.lex_state = 237},
  [3758] = {.lex_state = 237},
  [3759] = {.lex_state = 223},
  [3760] = {.lex_state = 237},
  [3761] = {.lex_state = 237},
  [3762] = {.lex_state = 237},
  [3763] = {.lex_state = 202},
  [3764] = {.lex_state = 237},
  [3765] = {.lex_state = 237},
  [3766] = {.lex_state = 237},
  [3767] = {.lex_state = 237},
  [3768] = {.lex_state = 237},
  [3769] = {.lex_state = 237},
  [3770] = {.lex_state = 237},
  [3771] = {.lex_state = 202},
  [3772] = {.lex_state = 237},
  [3773] = {.lex_state = 211},
  [3774] = {.lex_state = 181},
  [3775] = {.lex_state = 237},
  [3776] = {.lex_state = 237},
  [3777] = {.lex_state = 202},
  [3778] = {.lex_state = 237},
  [3779] = {.lex_state = 237},
  [3780] = {.lex_state = 202},
  [3781] = {.lex_state = 211},
  [3782] = {.lex_state = 237},
  [3783] = {.lex_state = 237},
  [3784] = {.lex_state = 223},
  [3785] = {.lex_state = 237},
  [3786] = {.lex_state = 237},
  [3787] = {.lex_state = 237},
  [3788] = {.lex_state = 237},
  [3789] = {.lex_state = 237},
  [3790] = {.lex_state = 202},
  [3791] = {.lex_state = 237},
  [3792] = {.lex_state = 237},
  [3793] = {.lex_state = 237},
  [3794] = {.lex_state = 181},
  [3795] = {.lex_state = 202},
  [3796] = {.lex_state = 207},
  [3797] = {.lex_state = 207},
  [3798] = {.lex_state = 207},
  [3799] = {.lex_state = 237},
  [3800] = {.lex_state = 207},
  [3801] = {.lex_state = 207},
  [3802] = {.lex_state = 204},
  [3803] = {.lex_state = 204},
  [3804] = {.lex_state = 239},
  [3805] = {.lex_state = 207},
  [3806] = {.lex_state = 202},
  [3807] = {.lex_state = 237},
  [3808] = {.lex_state = 181},
  [3809] = {.lex_state = 207},
  [3810] = {.lex_state = 237},
  [3811] = {.lex_state = 207},
  [3812] = {.lex_state = 202},
  [3813] = {.lex_state = 207},
  [3814] = {.lex_state = 207},
  [3815] = {.lex_state = 207},
  [3816] = {.lex_state = 239},
  [3817] = {.lex_state = 207},
  [3818] = {.lex_state = 181},
  [3819] = {.lex_state = 202},
  [3820] = {.lex_state = 207},
  [3821] = {.lex_state = 237},
  [3822] = {.lex_state = 207},
  [3823] = {.lex_state = 207},
  [3824] = {.lex_state = 181},
  [3825] = {.lex_state = 207},
  [3826] = {.lex_state = 239},
  [3827] = {.lex_state = 207},
  [3828] = {.lex_state = 191},
  [3829] = {.lex_state = 191},
  [3830] = {.lex_state = 239},
  [3831] = {.lex_state = 207},
  [3832] = {.lex_state = 207},
  [3833] = {.lex_state = 207},
  [3834] = {.lex_state = 207},
  [3835] = {.lex_state = 237},
  [3836] = {.lex_state = 207},
  [3837] = {.lex_state = 202},
  [3838] = {.lex_state = 204},
  [3839] = {.lex_state = 239},
  [3840] = {.lex_state = 207},
  [3841] = {.lex_state = 207},
  [3842] = {.lex_state = 237},
  [3843] = {.lex_state = 207},
  [3844] = {.lex_state = 237},
  [3845] = {.lex_state = 207},
  [3846] = {.lex_state = 181},
  [3847] = {.lex_state = 207},
  [3848] = {.lex_state = 207},
  [3849] = {.lex_state = 202},
  [3850] = {.lex_state = 207},
  [3851] = {.lex_state = 237},
  [3852] = {.lex_state = 237},
  [3853] = {.lex_state = 207},
  [3854] = {.lex_state = 207},
  [3855] = {.lex_state = 207},
  [3856] = {.lex_state = 207},
  [3857] = {.lex_state = 207},
  [3858] = {.lex_state = 207},
  [3859] = {.lex_state = 207},
  [3860] = {.lex_state = 202},
  [3861] = {.lex_state = 204},
  [3862] = {.lex_state = 191},
  [3863] = {.lex_state = 207},
  [3864] = {.lex_state = 207},
  [3865] = {.lex_state = 207},
  [3866] = {.lex_state = 207},
  [3867] = {.lex_state = 237},
  [3868] = {.lex_state = 202},
  [3869] = {.lex_state = 207},
  [3870] = {.lex_state = 207},
  [3871] = {.lex_state = 237},
  [3872] = {.lex_state = 207},
  [3873] = {.lex_state = 237},
  [3874] = {.lex_state = 207},
  [3875] = {.lex_state = 207},
  [3876] = {.lex_state = 207},
  [3877] = {.lex_state = 207},
  [3878] = {.lex_state = 207},
  [3879] = {.lex_state = 207},
  [3880] = {.lex_state = 207},
  [3881] = {.lex_state = 207},
  [3882] = {.lex_state = 207},
  [3883] = {.lex_state = 237},
  [3884] = {.lex_state = 237},
  [3885] = {.lex_state = 202},
  [3886] = {.lex_state = 204},
  [3887] = {.lex_state = 237},
  [3888] = {.lex_state = 191},
  [3889] = {.lex_state = 207},
  [3890] = {.lex_state = 207},
  [3891] = {.lex_state = 202},
  [3892] = {.lex_state = 204},
  [3893] = {.lex_state = 207},
  [3894] = {.lex_state = 207},
  [3895] = {.lex_state = 202},
  [3896] = {.lex_state = 207},
  [3897] = {.lex_state = 202},
  [3898] = {.lex_state = 204},
  [3899] = {.lex_state = 240},
  [3900] = {.lex_state = 239},
  [3901] = {.lex_state = 239},
  [3902] = {.lex_state = 204},
  [3903] = {.lex_state = 191},
  [3904] = {.lex_state = 204},
  [3905] = {.lex_state = 204},
  [3906] = {.lex_state = 204},
  [3907] = {.lex_state = 204},
  [3908] = {.lex_state = 191},
  [3909] = {.lex_state = 242},
  [3910] = {.lex_state = 191},
  [3911] = {.lex_state = 239},
  [3912] = {.lex_state = 204},
  [3913] = {.lex_state = 204},
  [3914] = {.lex_state = 204},
  [3915] = {.lex_state = 204},
  [3916] = {.lex_state = 202},
  [3917] = {.lex_state = 223},
  [3918] = {.lex_state = 239},
  [3919] = {.lex_state = 239},
  [3920] = {.lex_state = 204},
  [3921] = {.lex_state = 239},
  [3922] = {.lex_state = 204},
  [3923] = {.lex_state = 204},
  [3924] = {.lex_state = 239},
  [3925] = {.lex_state = 204},
  [3926] = {.lex_state = 204},
  [3927] = {.lex_state = 204},
  [3928] = {.lex_state = 204},
  [3929] = {.lex_state = 204},
  [3930] = {.lex_state = 242},
  [3931] = {.lex_state = 204},
  [3932] = {.lex_state = 240},
  [3933] = {.lex_state = 204},
  [3934] = {.lex_state = 204},
  [3935] = {.lex_state = 239},
  [3936] = {.lex_state = 239},
  [3937] = {.lex_state = 240},
  [3938] = {.lex_state = 202},
  [3939] = {.lex_state = 191},
  [3940] = {.lex_state = 204},
  [3941] = {.lex_state = 204},
  [3942] = {.lex_state = 204},
  [3943] = {.lex_state = 204},
  [3944] = {.lex_state = 226},
  [3945] = {.lex_state = 223},
  [3946] = {.lex_state = 239},
  [3947] = {.lex_state = 204},
  [3948] = {.lex_state = 223},
  [3949] = {.lex_state = 204},
  [3950] = {.lex_state = 204},
  [3951] = {.lex_state = 239},
  [3952] = {.lex_state = 204},
  [3953] = {.lex_state = 240},
  [3954] = {.lex_state = 204},
  [3955] = {.lex_state = 204},
  [3956] = {.lex_state = 239},
  [3957] = {.lex_state = 239},
  [3958] = {.lex_state = 239},
  [3959] = {.lex_state = 204},
  [3960] = {.lex_state = 202},
  [3961] = {.lex_state = 204},
  [3962] = {.lex_state = 202},
  [3963] = {.lex_state = 239},
  [3964] = {.lex_state = 240},
  [3965] = {.lex_state = 202},
  [3966] = {.lex_state = 236},
  [3967] = {.lex_state = 226},
  [3968] = {.lex_state = 204},
  [3969] = {.lex_state = 202},
  [3970] = {.lex_state = 240},
  [3971] = {.lex_state = 202},
  [3972] = {.lex_state = 204},
  [3973] = {.lex_state = 202},
  [3974] = {.lex_state = 202},
  [3975] = {.lex_state = 202},
  [3976] = {.lex_state = 202},
  [3977] = {.lex_state = 202},
  [3978] = {.lex_state = 202},
  [3979] = {.lex_state = 202},
  [3980] = {.lex_state = 240},
  [3981] = {.lex_state = 204},
  [3982] = {.lex_state = 240},
  [3983] = {.lex_state = 202},
  [3984] = {.lex_state = 202},
  [3985] = {.lex_state = 239},
  [3986] = {.lex_state = 202},
  [3987] = {.lex_state = 236},
  [3988] = {.lex_state = 202},
  [3989] = {.lex_state = 202},
  [3990] = {.lex_state = 237},
  [3991] = {.lex_state = 237},
  [3992] = {.lex_state = 240},
  [3993] = {.lex_state = 239},
  [3994] = {.lex_state = 237},
  [3995] = {.lex_state = 237},
  [3996] = {.lex_state = 226},
  [3997] = {.lex_state = 237},
  [3998] = {.lex_state = 240},
  [3999] = {.lex_state = 237},
  [4000] = {.lex_state = 237},
  [4001] = {.lex_state = 237},
  [4002] = {.lex_state = 240},
  [4003] = {.lex_state = 237},
  [4004] = {.lex_state = 237},
  [4005] = {.lex_state = 239},
  [4006] = {.lex_state = 237},
  [4007] = {.lex_state = 237},
  [4008] = {.lex_state = 202},
  [4009] = {.lex_state = 237},
  [4010] = {.lex_state = 237},
  [4011] = {.lex_state = 237},
  [4012] = {.lex_state = 237},
  [4013] = {.lex_state = 202},
  [4014] = {.lex_state = 240},
  [4015] = {.lex_state = 237},
  [4016] = {.lex_state = 237},
  [4017] = {.lex_state = 202},
  [4018] = {.lex_state = 237},
  [4019] = {.lex_state = 202},
  [4020] = {.lex_state = 237},
  [4021] = {.lex_state = 202},
  [4022] = {.lex_state = 202},
  [4023] = {.lex_state = 237},
  [4024] = {.lex_state = 237},
  [4025] = {.lex_state = 237},
  [4026] = {.lex_state = 237},
  [4027] = {.lex_state = 202},
  [4028] = {.lex_state = 202},
  [4029] = {.lex_state = 237},
  [4030] = {.lex_state = 237},
  [4031] = {.lex_state = 240},
  [4032] = {.lex_state = 237},
  [4033] = {.lex_state = 237},
  [4034] = {.lex_state = 237},
  [4035] = {.lex_state = 237},
  [4036] = {.lex_state = 226},
  [4037] = {.lex_state = 239},
  [4038] = {.lex_state = 202},
  [4039] = {.lex_state = 202},
  [4040] = {.lex_state = 237},
  [4041] = {.lex_state = 202},
  [4042] = {.lex_state = 204},
  [4043] = {.lex_state = 202},
  [4044] = {.lex_state = 202},
  [4045] = {.lex_state = 202},
  [4046] = {.lex_state = 202},
  [4047] = {.lex_state = 223},
  [4048] = {.lex_state = 202},
  [4049] = {.lex_state = 202},
  [4050] = {.lex_state = 202},
  [4051] = {.lex_state = 202},
  [4052] = {.lex_state = 223},
  [4053] = {.lex_state = 202},
  [4054] = {.lex_state = 202},
  [4055] = {.lex_state = 202},
  [4056] = {.lex_state = 202},
  [4057] = {.lex_state = 202},
  [4058] = {.lex_state = 202},
  [4059] = {.lex_state = 237},
  [4060] = {.lex_state = 202},
  [4061] = {.lex_state = 202},
  [4062] = {.lex_state = 223},
  [4063] = {.lex_state = 202},
  [4064] = {.lex_state = 204},
  [4065] = {.lex_state = 202},
  [4066] = {.lex_state = 202},
  [4067] = {.lex_state = 202},
  [4068] = {.lex_state = 202},
  [4069] = {.lex_state = 223},
  [4070] = {.lex_state = 202},
  [4071] = {.lex_state = 202},
  [4072] = {.lex_state = 202},
  [4073] = {.lex_state = 227},
  [4074] = {.lex_state = 237},
  [4075] = {.lex_state = 204},
  [4076] = {.lex_state = 202},
  [4077] = {.lex_state = 227},
  [4078] = {.lex_state = 202},
  [4079] = {.lex_state = 202},
  [4080] = {.lex_state = 202},
  [4081] = {.lex_state = 237},
  [4082] = {.lex_state = 202},
  [4083] = {.lex_state = 202},
  [4084] = {.lex_state = 202},
  [4085] = {.lex_state = 204},
  [4086] = {.lex_state = 202},
  [4087] = {.lex_state = 202},
  [4088] = {.lex_state = 202},
  [4089] = {.lex_state = 202},
  [4090] = {.lex_state = 202},
  [4091] = {.lex_state = 237},
  [4092] = {.lex_state = 237},
  [4093] = {.lex_state = 202},
  [4094] = {.lex_state = 202},
  [4095] = {.lex_state = 202},
  [4096] = {.lex_state = 237},
  [4097] = {.lex_state = 202},
  [4098] = {.lex_state = 202},
  [4099] = {.lex_state = 202},
  [4100] = {.lex_state = 236},
  [4101] = {.lex_state = 202},
  [4102] = {.lex_state = 202},
  [4103] = {.lex_state = 202},
  [4104] = {.lex_state = 202},
  [4105] = {.lex_state = 242},
  [4106] = {.lex_state = 202},
  [4107] = {.lex_state = 202},
  [4108] = {.lex_state = 202},
  [4109] = {.lex_state = 227},
  [4110] = {.lex_state = 227},
  [4111] = {.lex_state = 202},
  [4112] = {.lex_state = 202},
  [4113] = {.lex_state = 202},
  [4114] = {.lex_state = 202},
  [4115] = {.lex_state = 202},
  [4116] = {.lex_state = 202},
  [4117] = {.lex_state = 204},
  [4118] = {.lex_state = 236},
  [4119] = {.lex_state = 202},
  [4120] = {.lex_state = 204},
  [4121] = {.lex_state = 202},
  [4122] = {.lex_state = 204},
  [4123] = {.lex_state = 202},
  [4124] = {.lex_state = 239},
  [4125] = {.lex_state = 202},
  [4126] = {.lex_state = 202},
  [4127] = {.lex_state = 202},
  [4128] = {.lex_state = 202},
  [4129] = {.lex_state = 202},
  [4130] = {.lex_state = 202},
  [4131] = {.lex_state = 202},
  [4132] = {.lex_state = 202},
  [4133] = {.lex_state = 227},
  [4134] = {.lex_state = 236},
  [4135] = {.lex_state = 227},
  [4136] = {.lex_state = 236},
  [4137] = {.lex_state = 204},
  [4138] = {.lex_state = 240},
  [4139] = {.lex_state = 242},
  [4140] = {.lex_state = 240},
  [4141] = {.lex_state = 240},
  [4142] = {.lex_state = 202},
  [4143] = {.lex_state = 240},
  [4144] = {.lex_state = 202},
  [4145] = {.lex_state = 205},
  [4146] = {.lex_state = 236},
  [4147] = {.lex_state = 239},
  [4148] = {.lex_state = 205},
  [4149] = {.lex_state = 205},
  [4150] = {.lex_state = 205},
  [4151] = {.lex_state = 239},
  [4152] = {.lex_state = 202},
  [4153] = {.lex_state = 240},
  [4154] = {.lex_state = 236},
  [4155] = {.lex_state = 202},
  [4156] = {.lex_state = 242},
  [4157] = {.lex_state = 240},
  [4158] = {.lex_state = 236},
  [4159] = {.lex_state = 243},
  [4160] = {.lex_state = 223},
  [4161] = {.lex_state = 223},
  [4162] = {.lex_state = 239},
  [4163] = {.lex_state = 202},
  [4164] = {.lex_state = 205},
  [4165] = {.lex_state = 236},
  [4166] = {.lex_state = 205},
  [4167] = {.lex_state = 239},
  [4168] = {.lex_state = 202},
  [4169] = {.lex_state = 240},
  [4170] = {.lex_state = 204},
  [4171] = {.lex_state = 223},
  [4172] = {.lex_state = 202},
  [4173] = {.lex_state = 239},
  [4174] = {.lex_state = 205},
  [4175] = {.lex_state = 205},
  [4176] = {.lex_state = 239},
  [4177] = {.lex_state = 240},
  [4178] = {.lex_state = 236},
  [4179] = {.lex_state = 202},
  [4180] = {.lex_state = 239},
  [4181] = {.lex_state = 239},
  [4182] = {.lex_state = 236},
  [4183] = {.lex_state = 202},
  [4184] = {.lex_state = 204},
  [4185] = {.lex_state = 239},
  [4186] = {.lex_state = 236},
  [4187] = {.lex_state = 202},
  [4188] = {.lex_state = 223},
  [4189] = {.lex_state = 223},
  [4190] = {.lex_state = 202},
  [4191] = {.lex_state = 239},
  [4192] = {.lex_state = 243},
  [4193] = {.lex_state = 202},
  [4194] = {.lex_state = 223},
  [4195] = {.lex_state = 202},
  [4196] = {.lex_state = 204},
  [4197] = {.lex_state = 204},
  [4198] = {.lex_state = 202},
  [4199] = {.lex_state = 223},
  [4200] = {.lex_state = 202},
  [4201] = {.lex_state = 202},
  [4202] = {.lex_state = 202},
  [4203] = {.lex_state = 202},
  [4204] = {.lex_state = 223},
  [4205] = {.lex_state = 223},
  [4206] = {.lex_state = 202},
  [4207] = {.lex_state = 236},
  [4208] = {.lex_state = 202},
  [4209] = {.lex_state = 223},
  [4210] = {.lex_state = 223},
  [4211] = {.lex_state = 202},
  [4212] = {.lex_state = 236},
  [4213] = {.lex_state = 202},
  [4214] = {.lex_state = 223},
  [4215] = {.lex_state = 202},
  [4216] = {.lex_state = 202},
  [4217] = {.lex_state = 202},
  [4218] = {.lex_state = 240},
  [4219] = {.lex_state = 202},
  [4220] = {.lex_state = 223},
  [4221] = {.lex_state = 243},
  [4222] = {.lex_state = 239},
  [4223] = {.lex_state = 202},
  [4224] = {.lex_state = 223},
  [4225] = {.lex_state = 240},
  [4226] = {.lex_state = 227},
  [4227] = {.lex_state = 227},
  [4228] = {.lex_state = 202},
  [4229] = {.lex_state = 202},
  [4230] = {.lex_state = 202},
  [4231] = {.lex_state = 236},
  [4232] = {.lex_state = 202},
  [4233] = {.lex_state = 202},
  [4234] = {.lex_state = 202},
  [4235] = {.lex_state = 202},
  [4236] = {.lex_state = 202},
  [4237] = {.lex_state = 240},
  [4238] = {.lex_state = 202},
  [4239] = {.lex_state = 240},
  [4240] = {.lex_state = 227},
  [4241] = {.lex_state = 240},
  [4242] = {.lex_state = 239},
  [4243] = {.lex_state = 240},
  [4244] = {.lex_state = 202},
  [4245] = {.lex_state = 202},
  [4246] = {.lex_state = 239},
  [4247] = {.lex_state = 202},
  [4248] = {.lex_state = 227},
  [4249] = {.lex_state = 202},
  [4250] = {.lex_state = 202},
  [4251] = {.lex_state = 222},
  [4252] = {.lex_state = 202},
  [4253] = {.lex_state = 202},
  [4254] = {.lex_state = 202},
  [4255] = {.lex_state = 202},
  [4256] = {.lex_state = 202},
  [4257] = {.lex_state = 202},
  [4258] = {.lex_state = 227},
  [4259] = {.lex_state = 202},
  [4260] = {.lex_state = 202},
  [4261] = {.lex_state = 202},
  [4262] = {.lex_state = 202},
  [4263] = {.lex_state = 202},
  [4264] = {.lex_state = 202},
  [4265] = {.lex_state = 223},
  [4266] = {.lex_state = 202},
  [4267] = {.lex_state = 202},
  [4268] = {.lex_state = 202},
  [4269] = {.lex_state = 202},
  [4270] = {.lex_state = 202},
  [4271] = {.lex_state = 223},
  [4272] = {.lex_state = 202},
  [4273] = {.lex_state = 202},
  [4274] = {.lex_state = 202},
  [4275] = {.lex_state = 202},
  [4276] = {.lex_state = 202},
  [4277] = {.lex_state = 227},
  [4278] = {.lex_state = 202},
  [4279] = {.lex_state = 239},
  [4280] = {.lex_state = 202},
  [4281] = {.lex_state = 202},
  [4282] = {.lex_state = 202},
  [4283] = {.lex_state = 202},
  [4284] = {.lex_state = 240},
  [4285] = {.lex_state = 227},
  [4286] = {.lex_state = 227},
  [4287] = {.lex_state = 202},
  [4288] = {.lex_state = 227},
  [4289] = {.lex_state = 202},
  [4290] = {.lex_state = 227},
  [4291] = {.lex_state = 202},
  [4292] = {.lex_state = 202},
  [4293] = {.lex_state = 236},
  [4294] = {.lex_state = 202},
  [4295] = {.lex_state = 202},
  [4296] = {.lex_state = 227},
  [4297] = {.lex_state = 227},
  [4298] = {.lex_state = 202},
  [4299] = {.lex_state = 202},
  [4300] = {.lex_state = 227},
  [4301] = {.lex_state = 202},
  [4302] = {.lex_state = 227},
  [4303] = {.lex_state = 227},
  [4304] = {.lex_state = 227},
  [4305] = {.lex_state = 240},
  [4306] = {.lex_state = 227},
  [4307] = {.lex_state = 240},
  [4308] = {.lex_state = 202},
  [4309] = {.lex_state = 223},
  [4310] = {.lex_state = 236},
  [4311] = {.lex_state = 202},
  [4312] = {.lex_state = 202},
  [4313] = {.lex_state = 227},
  [4314] = {.lex_state = 227},
  [4315] = {.lex_state = 236},
  [4316] = {.lex_state = 227},
  [4317] = {.lex_state = 227},
  [4318] = {.lex_state = 227},
  [4319] = {.lex_state = 227},
  [4320] = {.lex_state = 202},
  [4321] = {.lex_state = 202},
  [4322] = {.lex_state = 227},
  [4323] = {.lex_state = 227},
  [4324] = {.lex_state = 227},
  [4325] = {.lex_state = 227},
  [4326] = {.lex_state = 202},
  [4327] = {.lex_state = 227},
  [4328] = {.lex_state = 202},
  [4329] = {.lex_state = 227},
  [4330] = {.lex_state = 227},
  [4331] = {.lex_state = 240},
  [4332] = {.lex_state = 239},
  [4333] = {.lex_state = 240},
  [4334] = {.lex_state = 227},
  [4335] = {.lex_state = 227},
  [4336] = {.lex_state = 227},
  [4337] = {.lex_state = 227},
  [4338] = {.lex_state = 227},
  [4339] = {.lex_state = 202},
  [4340] = {.lex_state = 227},
  [4341] = {.lex_state = 202},
  [4342] = {.lex_state = 227},
  [4343] = {.lex_state = 227},
  [4344] = {.lex_state = 227},
  [4345] = {.lex_state = 202},
  [4346] = {.lex_state = 240},
  [4347] = {.lex_state = 227},
  [4348] = {.lex_state = 202},
  [4349] = {.lex_state = 227},
  [4350] = {.lex_state = 236},
  [4351] = {.lex_state = 202},
  [4352] = {.lex_state = 205},
  [4353] = {.lex_state = 227},
  [4354] = {.lex_state = 227},
  [4355] = {.lex_state = 202},
  [4356] = {.lex_state = 204},
  [4357] = {.lex_state = 227},
  [4358] = {.lex_state = 202},
  [4359] = {.lex_state = 227},
  [4360] = {.lex_state = 227},
  [4361] = {.lex_state = 240},
  [4362] = {.lex_state = 227},
  [4363] = {.lex_state = 202},
  [4364] = {.lex_state = 205},
  [4365] = {.lex_state = 202},
  [4366] = {.lex_state = 202},
  [4367] = {.lex_state = 204},
  [4368] = {.lex_state = 202},
  [4369] = {.lex_state = 202},
  [4370] = {.lex_state = 227},
  [4371] = {.lex_state = 227},
  [4372] = {.lex_state = 227},
  [4373] = {.lex_state = 227},
  [4374] = {.lex_state = 227},
  [4375] = {.lex_state = 236},
  [4376] = {.lex_state = 204},
  [4377] = {.lex_state = 204},
  [4378] = {.lex_state = 227},
  [4379] = {.lex_state = 226},
  [4380] = {.lex_state = 204},
  [4381] = {.lex_state = 204},
  [4382] = {.lex_state = 204},
  [4383] = {.lex_state = 204},
  [4384] = {.lex_state = 227},
  [4385] = {.lex_state = 202},
  [4386] = {.lex_state = 204},
  [4387] = {.lex_state = 204},
  [4388] = {.lex_state = 204},
  [4389] = {.lex_state = 204},
  [4390] = {.lex_state = 236},
  [4391] = {.lex_state = 204},
  [4392] = {.lex_state = 204},
  [4393] = {.lex_state = 202},
  [4394] = {.lex_state = 204},
  [4395] = {.lex_state = 227},
  [4396] = {.lex_state = 236},
  [4397] = {.lex_state = 202},
  [4398] = {.lex_state = 236},
  [4399] = {.lex_state = 204},
  [4400] = {.lex_state = 227},
  [4401] = {.lex_state = 227},
  [4402] = {.lex_state = 204},
  [4403] = {.lex_state = 204},
  [4404] = {.lex_state = 204},
  [4405] = {.lex_state = 202},
  [4406] = {.lex_state = 240},
  [4407] = {.lex_state = 204},
  [4408] = {.lex_state = 202},
  [4409] = {.lex_state = 202},
  [4410] = {.lex_state = 202},
  [4411] = {.lex_state = 240},
  [4412] = {.lex_state = 202},
  [4413] = {.lex_state = 240},
  [4414] = {.lex_state = 202},
  [4415] = {.lex_state = 204},
  [4416] = {.lex_state = 202},
  [4417] = {.lex_state = 202},
  [4418] = {.lex_state = 202},
  [4419] = {.lex_state = 204},
  [4420] = {.lex_state = 202},
  [4421] = {.lex_state = 227},
  [4422] = {.lex_state = 227},
  [4423] = {.lex_state = 227},
  [4424] = {.lex_state = 239},
  [4425] = {.lex_state = 227},
  [4426] = {.lex_state = 227},
  [4427] = {.lex_state = 202},
  [4428] = {.lex_state = 236},
  [4429] = {.lex_state = 227},
  [4430] = {.lex_state = 227},
  [4431] = {.lex_state = 202},
  [4432] = {.lex_state = 227},
  [4433] = {.lex_state = 202},
  [4434] = {.lex_state = 205},
  [4435] = {.lex_state = 202},
  [4436] = {.lex_state = 202},
  [4437] = {.lex_state = 204},
  [4438] = {.lex_state = 204},
  [4439] = {.lex_state = 204},
  [4440] = {.lex_state = 204},
  [4441] = {.lex_state = 204},
  [4442] = {.lex_state = 227},
  [4443] = {.lex_state = 202},
  [4444] = {.lex_state = 205},
  [4445] = {.lex_state = 204},
  [4446] = {.lex_state = 204},
  [4447] = {.lex_state = 202},
  [4448] = {.lex_state = 202},
  [4449] = {.lex_state = 202},
  [4450] = {.lex_state = 204},
  [4451] = {.lex_state = 204},
  [4452] = {.lex_state = 202},
  [4453] = {.lex_state = 202},
  [4454] = {.lex_state = 202},
  [4455] = {.lex_state = 202},
  [4456] = {.lex_state = 240},
  [4457] = {.lex_state = 202},
  [4458] = {.lex_state = 202},
  [4459] = {.lex_state = 202},
  [4460] = {.lex_state = 202},
  [4461] = {.lex_state = 204},
  [4462] = {.lex_state = 202},
  [4463] = {.lex_state = 202},
  [4464] = {.lex_state = 202},
  [4465] = {.lex_state = 202},
  [4466] = {.lex_state = 202},
  [4467] = {.lex_state = 204},
  [4468] = {.lex_state = 236},
  [4469] = {.lex_state = 204},
  [4470] = {.lex_state = 202},
  [4471] = {.lex_state = 240},
  [4472] = {.lex_state = 202},
  [4473] = {.lex_state = 202},
  [4474] = {.lex_state = 204},
  [4475] = {.lex_state = 240},
  [4476] = {.lex_state = 202},
  [4477] = {.lex_state = 223},
  [4478] = {.lex_state = 202},
  [4479] = {.lex_state = 202},
  [4480] = {.lex_state = 240},
  [4481] = {.lex_state = 240},
  [4482] = {.lex_state = 202},
  [4483] = {.lex_state = 202},
  [4484] = {.lex_state = 202},
  [4485] = {.lex_state = 202},
  [4486] = {.lex_state = 202},
  [4487] = {.lex_state = 202},
  [4488] = {.lex_state = 202},
  [4489] = {.lex_state = 204},
  [4490] = {.lex_state = 204},
  [4491] = {.lex_state = 202},
  [4492] = {.lex_state = 202},
  [4493] = {.lex_state = 202},
  [4494] = {.lex_state = 202},
  [4495] = {.lex_state = 202},
  [4496] = {.lex_state = 237},
  [4497] = {.lex_state = 202},
  [4498] = {.lex_state = 202},
  [4499] = {.lex_state = 202},
  [4500] = {.lex_state = 202},
  [4501] = {.lex_state = 202},
  [4502] = {.lex_state = 239},
  [4503] = {.lex_state = 202},
  [4504] = {.lex_state = 237},
  [4505] = {.lex_state = 237},
  [4506] = {.lex_state = 202},
  [4507] = {.lex_state = 237},
  [4508] = {.lex_state = 202},
  [4509] = {.lex_state = 202},
  [4510] = {.lex_state = 202},
  [4511] = {.lex_state = 204},
  [4512] = {.lex_state = 202},
  [4513] = {.lex_state = 202},
  [4514] = {.lex_state = 237},
  [4515] = {.lex_state = 202},
  [4516] = {.lex_state = 202},
  [4517] = {.lex_state = 237},
  [4518] = {.lex_state = 240},
  [4519] = {.lex_state = 239},
  [4520] = {.lex_state = 204},
  [4521] = {.lex_state = 202},
  [4522] = {.lex_state = 202},
  [4523] = {.lex_state = 202},
  [4524] = {.lex_state = 202},
  [4525] = {.lex_state = 239},
  [4526] = {.lex_state = 204},
  [4527] = {.lex_state = 204},
  [4528] = {.lex_state = 237},
  [4529] = {.lex_state = 202},
  [4530] = {.lex_state = 240},
  [4531] = {.lex_state = 240},
  [4532] = {.lex_state = 202},
  [4533] = {.lex_state = 237},
  [4534] = {.lex_state = 202},
  [4535] = {.lex_state = 237},
  [4536] = {.lex_state = 202},
  [4537] = {.lex_state = 202},
  [4538] = {.lex_state = 202},
  [4539] = {.lex_state = 202},
  [4540] = {.lex_state = 202},
  [4541] = {.lex_state = 202},
  [4542] = {.lex_state = 202},
  [4543] = {.lex_state = 202},
  [4544] = {.lex_state = 237},
  [4545] = {.lex_state = 240},
  [4546] = {.lex_state = 202},
  [4547] = {.lex_state = 202},
  [4548] = {.lex_state = 202},
  [4549] = {.lex_state = 227},
  [4550] = {.lex_state = 239},
  [4551] = {.lex_state = 237},
  [4552] = {.lex_state = 202},
  [4553] = {.lex_state = 202},
  [4554] = {.lex_state = 202},
  [4555] = {.lex_state = 202},
  [4556] = {.lex_state = 202},
  [4557] = {.lex_state = 202},
  [4558] = {.lex_state = 202},
  [4559] = {.lex_state = 204},
  [4560] = {.lex_state = 202},
  [4561] = {.lex_state = 202},
  [4562] = {.lex_state = 202},
  [4563] = {.lex_state = 236},
  [4564] = {.lex_state = 202},
  [4565] = {.lex_state = 229},
  [4566] = {.lex_state = 202},
  [4567] = {.lex_state = 202},
  [4568] = {.lex_state = 237},
  [4569] = {.lex_state = 202},
  [4570] = {.lex_state = 202},
  [4571] = {.lex_state = 202},
  [4572] = {.lex_state = 202},
  [4573] = {.lex_state = 229},
  [4574] = {.lex_state = 239},
  [4575] = {.lex_state = 202},
  [4576] = {.lex_state = 202},
  [4577] = {.lex_state = 202},
  [4578] = {.lex_state = 202},
  [4579] = {.lex_state = 202},
  [4580] = {.lex_state = 237},
  [4581] = {.lex_state = 202},
  [4582] = {.lex_state = 202},
  [4583] = {.lex_state = 202},
  [4584] = {.lex_state = 202},
  [4585] = {.lex_state = 202},
  [4586] = {.lex_state = 202},
  [4587] = {.lex_state = 202},
  [4588] = {.lex_state = 237},
  [4589] = {.lex_state = 202},
  [4590] = {.lex_state = 237},
  [4591] = {.lex_state = 202},
  [4592] = {.lex_state = 202},
  [4593] = {.lex_state = 202},
  [4594] = {.lex_state = 229},
  [4595] = {.lex_state = 229},
  [4596] = {.lex_state = 237},
  [4597] = {.lex_state = 237},
  [4598] = {.lex_state = 202},
  [4599] = {.lex_state = 202},
  [4600] = {.lex_state = 204},
  [4601] = {.lex_state = 202},
  [4602] = {.lex_state = 202},
  [4603] = {.lex_state = 202},
  [4604] = {.lex_state = 237},
  [4605] = {.lex_state = 202},
  [4606] = {.lex_state = 202},
  [4607] = {.lex_state = 202},
  [4608] = {.lex_state = 202},
  [4609] = {.lex_state = 202},
  [4610] = {.lex_state = 236},
  [4611] = {.lex_state = 202},
  [4612] = {.lex_state = 202},
  [4613] = {.lex_state = 237},
  [4614] = {.lex_state = 240},
  [4615] = {.lex_state = 202},
  [4616] = {.lex_state = 202},
  [4617] = {.lex_state = 202},
  [4618] = {.lex_state = 236},
  [4619] = {.lex_state = 202},
  [4620] = {.lex_state = 202},
  [4621] = {.lex_state = 202},
  [4622] = {.lex_state = 202},
  [4623] = {.lex_state = 202},
  [4624] = {.lex_state = 202},
  [4625] = {.lex_state = 202},
  [4626] = {.lex_state = 202},
  [4627] = {.lex_state = 202},
  [4628] = {.lex_state = 237},
  [4629] = {.lex_state = 203},
  [4630] = {.lex_state = 202},
  [4631] = {.lex_state = 202},
  [4632] = {.lex_state = 202},
  [4633] = {.lex_state = 202},
  [4634] = {.lex_state = 202},
  [4635] = {.lex_state = 237},
  [4636] = {.lex_state = 237},
  [4637] = {.lex_state = 202},
  [4638] = {.lex_state = 237},
  [4639] = {.lex_state = 202},
  [4640] = {.lex_state = 239},
  [4641] = {.lex_state = 202},
  [4642] = {.lex_state = 202},
  [4643] = {.lex_state = 239},
  [4644] = {.lex_state = 204},
  [4645] = {.lex_state = 202},
  [4646] = {.lex_state = 240},
  [4647] = {.lex_state = 236},
  [4648] = {.lex_state = 227},
  [4649] = {.lex_state = 223},
  [4650] = {.lex_state = 240},
  [4651] = {.lex_state = 227},
  [4652] = {.lex_state = 227},
  [4653] = {.lex_state = 227},
  [4654] = {.lex_state = 227},
  [4655] = {.lex_state = 240},
  [4656] = {.lex_state = 239},
  [4657] = {.lex_state = 240},
  [4658] = {.lex_state = 236},
  [4659] = {.lex_state = 202},
  [4660] = {.lex_state = 227},
  [4661] = {.lex_state = 227},
  [4662] = {.lex_state = 237},
  [4663] = {.lex_state = 227},
  [4664] = {.lex_state = 227},
  [4665] = {.lex_state = 202},
  [4666] = {.lex_state = 223},
  [4667] = {.lex_state = 240},
  [4668] = {.lex_state = 227},
  [4669] = {.lex_state = 227},
  [4670] = {.lex_state = 202},
  [4671] = {.lex_state = 227},
  [4672] = {.lex_state = 227},
  [4673] = {.lex_state = 227},
  [4674] = {.lex_state = 240},
  [4675] = {.lex_state = 236},
  [4676] = {.lex_state = 227},
  [4677] = {.lex_state = 227},
  [4678] = {.lex_state = 240},
  [4679] = {.lex_state = 227},
  [4680] = {.lex_state = 202},
  [4681] = {.lex_state = 236},
  [4682] = {.lex_state = 236},
  [4683] = {.lex_state = 236},
  [4684] = {.lex_state = 236},
  [4685] = {.lex_state = 236},
  [4686] = {.lex_state = 236},
  [4687] = {.lex_state = 236},
  [4688] = {.lex_state = 236},
  [4689] = {.lex_state = 227},
  [4690] = {.lex_state = 227},
  [4691] = {.lex_state = 227},
  [4692] = {.lex_state = 227},
  [4693] = {.lex_state = 227},
  [4694] = {.lex_state = 227},
  [4695] = {.lex_state = 227},
  [4696] = {.lex_state = 227},
  [4697] = {.lex_state = 236},
  [4698] = {.lex_state = 227},
  [4699] = {.lex_state = 227},
  [4700] = {.lex_state = 227},
  [4701] = {.lex_state = 227},
  [4702] = {.lex_state = 202},
  [4703] = {.lex_state = 227},
  [4704] = {.lex_state = 227},
  [4705] = {.lex_state = 227},
  [4706] = {.lex_state = 227},
  [4707] = {.lex_state = 227},
  [4708] = {.lex_state = 236},
  [4709] = {.lex_state = 236},
  [4710] = {.lex_state = 227},
  [4711] = {.lex_state = 227},
  [4712] = {.lex_state = 227},
  [4713] = {.lex_state = 236},
  [4714] = {.lex_state = 236},
  [4715] = {.lex_state = 227},
  [4716] = {.lex_state = 236},
  [4717] = {.lex_state = 236},
  [4718] = {.lex_state = 202},
  [4719] = {.lex_state = 202},
  [4720] = {.lex_state = 202},
  [4721] = {.lex_state = 227},
  [4722] = {.lex_state = 227},
  [4723] = {.lex_state = 236},
  [4724] = {.lex_state = 239},
  [4725] = {.lex_state = 236},
  [4726] = {.lex_state = 236},
  [4727] = {.lex_state = 241},
  [4728] = {.lex_state = 240},
  [4729] = {.lex_state = 236},
  [4730] = {.lex_state = 223},
  [4731] = {.lex_state = 240},
  [4732] = {.lex_state = 223},
  [4733] = {.lex_state = 240},
  [4734] = {.lex_state = 202},
  [4735] = {.lex_state = 237},
  [4736] = {.lex_state = 237},
  [4737] = {.lex_state = 202},
  [4738] = {.lex_state = 237},
  [4739] = {.lex_state = 236},
  [4740] = {.lex_state = 202},
  [4741] = {.lex_state = 240},
  [4742] = {.lex_state = 236},
  [4743] = {.lex_state = 240},
  [4744] = {.lex_state = 204},
  [4745] = {.lex_state = 237},
  [4746] = {.lex_state = 237},
  [4747] = {.lex_state = 237},
  [4748] = {.lex_state = 237},
  [4749] = {.lex_state = 237},
  [4750] = {.lex_state = 237},
  [4751] = {.lex_state = 241},
  [4752] = {.lex_state = 240},
  [4753] = {.lex_state = 204},
  [4754] = {.lex_state = 240},
  [4755] = {.lex_state = 240},
  [4756] = {.lex_state = 236},
  [4757] = {.lex_state = 237},
  [4758] = {.lex_state = 241},
  [4759] = {.lex_state = 237},
  [4760] = {.lex_state = 237},
  [4761] = {.lex_state = 202},
  [4762] = {.lex_state = 240},
  [4763] = {.lex_state = 241},
  [4764] = {.lex_state = 240},
  [4765] = {.lex_state = 237},
  [4766] = {.lex_state = 237},
  [4767] = {.lex_state = 237},
  [4768] = {.lex_state = 236},
  [4769] = {.lex_state = 237},
  [4770] = {.lex_state = 237},
  [4771] = {.lex_state = 202},
  [4772] = {.lex_state = 236},
  [4773] = {.lex_state = 236},
  [4774] = {.lex_state = 202},
  [4775] = {.lex_state = 237},
  [4776] = {.lex_state = 237},
  [4777] = {.lex_state = 236},
  [4778] = {.lex_state = 240},
  [4779] = {.lex_state = 240},
  [4780] = {.lex_state = 236},
  [4781] = {.lex_state = 240},
  [4782] = {.lex_state = 236},
  [4783] = {.lex_state = 240},
  [4784] = {.lex_state = 240},
  [4785] = {.lex_state = 240},
  [4786] = {.lex_state = 240},
  [4787] = {.lex_state = 240},
  [4788] = {.lex_state = 239},
  [4789] = {.lex_state = 239},
  [4790] = {.lex_state = 240},
  [4791] = {.lex_state = 240},
  [4792] = {.lex_state = 239},
  [4793] = {.lex_state = 236},
  [4794] = {.lex_state = 202},
  [4795] = {.lex_state = 240},
  [4796] = {.lex_state = 240},
  [4797] = {.lex_state = 240},
  [4798] = {.lex_state = 239},
  [4799] = {.lex_state = 203},
  [4800] = {.lex_state = 237},
  [4801] = {.lex_state = 236},
  [4802] = {.lex_state = 240},
  [4803] = {.lex_state = 236},
  [4804] = {.lex_state = 202},
  [4805] = {.lex_state = 240},
  [4806] = {.lex_state = 203},
  [4807] = {.lex_state = 240},
  [4808] = {.lex_state = 236},
  [4809] = {.lex_state = 240},
  [4810] = {.lex_state = 240},
  [4811] = {.lex_state = 240},
  [4812] = {.lex_state = 237},
  [4813] = {.lex_state = 237},
  [4814] = {.lex_state = 240},
  [4815] = {.lex_state = 240},
  [4816] = {.lex_state = 240},
  [4817] = {.lex_state = 237},
  [4818] = {.lex_state = 240},
  [4819] = {.lex_state = 237},
  [4820] = {.lex_state = 237},
  [4821] = {.lex_state = 239},
  [4822] = {.lex_state = 237},
  [4823] = {.lex_state = 237},
  [4824] = {.lex_state = 240},
  [4825] = {.lex_state = 237},
  [4826] = {.lex_state = 240},
  [4827] = {.lex_state = 237},
  [4828] = {.lex_state = 239},
  [4829] = {.lex_state = 237},
  [4830] = {.lex_state = 239},
  [4831] = {.lex_state = 240},
  [4832] = {.lex_state = 237},
  [4833] = {.lex_state = 240},
  [4834] = {.lex_state = 240},
  [4835] = {.lex_state = 240},
  [4836] = {.lex_state = 240},
  [4837] = {.lex_state = 240},
  [4838] = {.lex_state = 237},
  [4839] = {.lex_state = 237},
  [4840] = {.lex_state = 237},
  [4841] = {.lex_state = 240},
  [4842] = {.lex_state = 240},
  [4843] = {.lex_state = 237},
  [4844] = {.lex_state = 240},
  [4845] = {.lex_state = 240},
  [4846] = {.lex_state = 240},
  [4847] = {.lex_state = 237},
  [4848] = {.lex_state = 240},
  [4849] = {.lex_state = 240},
  [4850] = {.lex_state = 240},
  [4851] = {.lex_state = 240},
  [4852] = {.lex_state = 240},
  [4853] = {.lex_state = 237},
  [4854] = {.lex_state = 237},
  [4855] = {.lex_state = 240},
  [4856] = {.lex_state = 240},
  [4857] = {.lex_state = 239},
  [4858] = {.lex_state = 237},
  [4859] = {.lex_state = 239},
  [4860] = {.lex_state = 237},
  [4861] = {.lex_state = 237},
  [4862] = {.lex_state = 240},
  [4863] = {.lex_state = 236},
  [4864] = {.lex_state = 237},
  [4865] = {.lex_state = 239},
  [4866] = {.lex_state = 237},
  [4867] = {.lex_state = 237},
  [4868] = {.lex_state = 237},
  [4869] = {.lex_state = 237},
  [4870] = {.lex_state = 240},
  [4871] = {.lex_state = 237},
  [4872] = {.lex_state = 237},
  [4873] = {.lex_state = 240},
  [4874] = {.lex_state = 237},
  [4875] = {.lex_state = 237},
  [4876] = {.lex_state = 240},
  [4877] = {.lex_state = 237},
  [4878] = {.lex_state = 240},
  [4879] = {.lex_state = 240},
  [4880] = {.lex_state = 237},
  [4881] = {.lex_state = 240},
  [4882] = {.lex_state = 223},
  [4883] = {.lex_state = 236},
  [4884] = {.lex_state = 223},
  [4885] = {.lex_state = 240},
  [4886] = {.lex_state = 237},
  [4887] = {.lex_state = 237},
  [4888] = {.lex_state = 240},
  [4889] = {.lex_state = 237},
  [4890] = {.lex_state = 240},
  [4891] = {.lex_state = 223},
  [4892] = {.lex_state = 237},
  [4893] = {.lex_state = 237},
  [4894] = {.lex_state = 240},
  [4895] = {.lex_state = 240},
  [4896] = {.lex_state = 240},
  [4897] = {.lex_state = 237},
  [4898] = {.lex_state = 237},
  [4899] = {.lex_state = 240},
  [4900] = {.lex_state = 240},
  [4901] = {.lex_state = 223},
  [4902] = {.lex_state = 240},
  [4903] = {.lex_state = 240},
  [4904] = {.lex_state = 236},
  [4905] = {.lex_state = 236},
  [4906] = {.lex_state = 204},
  [4907] = {.lex_state = 223},
  [4908] = {.lex_state = 237},
  [4909] = {.lex_state = 223},
  [4910] = {.lex_state = 236},
  [4911] = {.lex_state = 227},
  [4912] = {.lex_state = 240},
  [4913] = {.lex_state = 204},
  [4914] = {.lex_state = 236},
  [4915] = {.lex_state = 236},
  [4916] = {.lex_state = 223},
  [4917] = {.lex_state = 204},
  [4918] = {.lex_state = 236},
  [4919] = {.lex_state = 204},
  [4920] = {.lex_state = 236},
  [4921] = {.lex_state = 204},
  [4922] = {.lex_state = 223},
  [4923] = {.lex_state = 204},
  [4924] = {.lex_state = 204},
  [4925] = {.lex_state = 240},
  [4926] = {.lex_state = 236},
  [4927] = {.lex_state = 240},
  [4928] = {.lex_state = 236},
  [4929] = {.lex_state = 236},
  [4930] = {.lex_state = 204},
  [4931] = {.lex_state = 239},
  [4932] = {.lex_state = 236},
  [4933] = {.lex_state = 236},
  [4934] = {.lex_state = 223},
  [4935] = {.lex_state = 239},
  [4936] = {.lex_state = 237},
  [4937] = {.lex_state = 236},
  [4938] = {.lex_state = 236},
  [4939] = {.lex_state = 237},
  [4940] = {.lex_state = 227},
  [4941] = {.lex_state = 237},
  [4942] = {.lex_state = 240},
  [4943] = {.lex_state = 223},
  [4944] = {.lex_state = 236},
  [4945] = {.lex_state = 240},
  [4946] = {.lex_state = 239},
  [4947] = {.lex_state = 240},
  [4948] = {.lex_state = 239},
  [4949] = {.lex_state = 237},
  [4950] = {.lex_state = 237},
  [4951] = {.lex_state = 236},
  [4952] = {.lex_state = 237},
  [4953] = {.lex_state = 237},
  [4954] = {.lex_state = 240},
  [4955] = {.lex_state = 236},
  [4956] = {.lex_state = 237},
  [4957] = {.lex_state = 240},
  [4958] = {.lex_state = 240},
  [4959] = {.lex_state = 236},
  [4960] = {.lex_state = 240},
  [4961] = {.lex_state = 202},
  [4962] = {.lex_state = 237},
  [4963] = {.lex_state = 236},
  [4964] = {.lex_state = 237},
  [4965] = {.lex_state = 237},
  [4966] = {.lex_state = 202},
  [4967] = {.lex_state = 236},
  [4968] = {.lex_state = 236},
  [4969] = {.lex_state = 236},
  [4970] = {.lex_state = 237},
  [4971] = {.lex_state = 236},
  [4972] = {.lex_state = 236},
  [4973] = {.lex_state = 240},
  [4974] = {.lex_state = 240},
  [4975] = {.lex_state = 236},
  [4976] = {.lex_state = 239},
  [4977] = {.lex_state = 239},
  [4978] = {.lex_state = 239},
  [4979] = {.lex_state = 202},
  [4980] = {.lex_state = 239},
  [4981] = {.lex_state = 237},
  [4982] = {.lex_state = 236},
  [4983] = {.lex_state = 236},
  [4984] = {.lex_state = 239},
  [4985] = {.lex_state = 236},
  [4986] = {.lex_state = 236},
  [4987] = {.lex_state = 236},
  [4988] = {.lex_state = 202},
  [4989] = {.lex_state = 239},
  [4990] = {.lex_state = 236},
  [4991] = {.lex_state = 237},
  [4992] = {.lex_state = 236},
  [4993] = {.lex_state = 236},
  [4994] = {.lex_state = 202},
  [4995] = {.lex_state = 236},
  [4996] = {.lex_state = 236},
  [4997] = {.lex_state = 236},
  [4998] = {.lex_state = 194},
  [4999] = {.lex_state = 240},
  [5000] = {.lex_state = 194},
  [5001] = {.lex_state = 236},
  [5002] = {.lex_state = 204},
  [5003] = {.lex_state = 236},
  [5004] = {.lex_state = 236},
  [5005] = {.lex_state = 236},
  [5006] = {.lex_state = 237},
  [5007] = {.lex_state = 194},
  [5008] = {.lex_state = 236},
  [5009] = {.lex_state = 236},
  [5010] = {.lex_state = 236},
  [5011] = {.lex_state = 236},
  [5012] = {.lex_state = 236},
  [5013] = {.lex_state = 240},
  [5014] = {.lex_state = 236},
  [5015] = {.lex_state = 237},
  [5016] = {.lex_state = 236},
  [5017] = {.lex_state = 236},
  [5018] = {.lex_state = 236},
  [5019] = {.lex_state = 236},
  [5020] = {.lex_state = 236},
  [5021] = {.lex_state = 236},
  [5022] = {.lex_state = 240},
  [5023] = {.lex_state = 194},
  [5024] = {.lex_state = 240},
  [5025] = {.lex_state = 194},
  [5026] = {.lex_state = 236},
  [5027] = {.lex_state = 236},
  [5028] = {.lex_state = 236},
  [5029] = {.lex_state = 202},
  [5030] = {.lex_state = 202},
  [5031] = {.lex_state = 202},
  [5032] = {.lex_state = 202},
  [5033] = {.lex_state = 236},
  [5034] = {.lex_state = 202},
  [5035] = {.lex_state = 237},
  [5036] = {.lex_state = 237},
  [5037] = {.lex_state = 236},
  [5038] = {.lex_state = 236},
  [5039] = {.lex_state = 202},
  [5040] = {.lex_state = 194},
  [5041] = {.lex_state = 240},
  [5042] = {.lex_state = 237},
  [5043] = {.lex_state = 237},
  [5044] = {.lex_state = 236},
  [5045] = {.lex_state = 236},
  [5046] = {.lex_state = 202},
  [5047] = {.lex_state = 194},
  [5048] = {.lex_state = 236},
  [5049] = {.lex_state = 240},
  [5050] = {.lex_state = 237},
  [5051] = {.lex_state = 236},
  [5052] = {.lex_state = 237},
  [5053] = {.lex_state = 237},
  [5054] = {.lex_state = 194},
  [5055] = {.lex_state = 237},
  [5056] = {.lex_state = 237},
  [5057] = {.lex_state = 236},
  [5058] = {.lex_state = 194},
  [5059] = {.lex_state = 194},
  [5060] = {.lex_state = 194},
  [5061] = {.lex_state = 194},
  [5062] = {.lex_state = 202},
  [5063] = {.lex_state = 202},
  [5064] = {.lex_state = 202},
  [5065] = {.lex_state = 194},
  [5066] = {.lex_state = 194},
  [5067] = {.lex_state = 239},
  [5068] = {.lex_state = 202},
  [5069] = {.lex_state = 194},
  [5070] = {.lex_state = 194},
  [5071] = {.lex_state = 194},
  [5072] = {.lex_state = 194},
  [5073] = {.lex_state = 194},
  [5074] = {.lex_state = 239},
  [5075] = {.lex_state = 194},
  [5076] = {.lex_state = 194},
  [5077] = {.lex_state = 202},
  [5078] = {.lex_state = 204},
  [5079] = {.lex_state = 202},
  [5080] = {.lex_state = 202},
  [5081] = {.lex_state = 202},
  [5082] = {.lex_state = 194},
  [5083] = {.lex_state = 194},
  [5084] = {.lex_state = 194},
  [5085] = {.lex_state = 204},
  [5086] = {.lex_state = 204},
  [5087] = {.lex_state = 237},
  [5088] = {.lex_state = 204},
  [5089] = {.lex_state = 202},
  [5090] = {.lex_state = 202},
  [5091] = {.lex_state = 202},
  [5092] = {.lex_state = 202},
  [5093] = {.lex_state = 194},
  [5094] = {.lex_state = 194},
  [5095] = {.lex_state = 194},
  [5096] = {.lex_state = 202},
  [5097] = {.lex_state = 202},
  [5098] = {.lex_state = 194},
  [5099] = {.lex_state = 194},
  [5100] = {.lex_state = 194},
  [5101] = {.lex_state = 194},
  [5102] = {.lex_state = 202},
  [5103] = {.lex_state = 239},
  [5104] = {.lex_state = 194},
  [5105] = {.lex_state = 194},
  [5106] = {.lex_state = 194},
  [5107] = {.lex_state = 202},
  [5108] = {.lex_state = 239},
  [5109] = {.lex_state = 194},
  [5110] = {.lex_state = 194},
  [5111] = {.lex_state = 194},
  [5112] = {.lex_state = 194},
  [5113] = {.lex_state = 194},
  [5114] = {.lex_state = 194},
  [5115] = {.lex_state = 202},
  [5116] = {.lex_state = 194},
  [5117] = {.lex_state = 194},
  [5118] = {.lex_state = 194},
  [5119] = {.lex_state = 194},
  [5120] = {.lex_state = 194},
  [5121] = {.lex_state = 194},
  [5122] = {.lex_state = 202},
  [5123] = {.lex_state = 237},
  [5124] = {.lex_state = 194},
  [5125] = {.lex_state = 194},
  [5126] = {.lex_state = 202},
  [5127] = {.lex_state = 194},
  [5128] = {.lex_state = 202},
  [5129] = {.lex_state = 194},
  [5130] = {.lex_state = 202},
  [5131] = {.lex_state = 194},
  [5132] = {.lex_state = 194},
  [5133] = {.lex_state = 194},
  [5134] = {.lex_state = 194},
  [5135] = {.lex_state = 194},
  [5136] = {.lex_state = 202},
  [5137] = {.lex_state = 194},
  [5138] = {.lex_state = 202},
  [5139] = {.lex_state = 194},
  [5140] = {.lex_state = 194},
  [5141] = {.lex_state = 194},
  [5142] = {.lex_state = 194},
  [5143] = {.lex_state = 194},
  [5144] = {.lex_state = 194},
  [5145] = {.lex_state = 194},
  [5146] = {.lex_state = 194},
  [5147] = {.lex_state = 194},
  [5148] = {.lex_state = 202},
  [5149] = {.lex_state = 194},
  [5150] = {.lex_state = 237},
  [5151] = {.lex_state = 202},
  [5152] = {.lex_state = 194},
  [5153] = {.lex_state = 237},
  [5154] = {.lex_state = 194},
  [5155] = {.lex_state = 194},
  [5156] = {.lex_state = 194},
  [5157] = {.lex_state = 202},
  [5158] = {.lex_state = 194},
  [5159] = {.lex_state = 202},
  [5160] = {.lex_state = 202},
  [5161] = {.lex_state = 194},
  [5162] = {.lex_state = 194},
  [5163] = {.lex_state = 194},
  [5164] = {.lex_state = 194},
  [5165] = {.lex_state = 194},
  [5166] = {.lex_state = 237},
  [5167] = {.lex_state = 194},
  [5168] = {.lex_state = 194},
  [5169] = {.lex_state = 194},
  [5170] = {.lex_state = 194},
  [5171] = {.lex_state = 194},
  [5172] = {.lex_state = 194},
  [5173] = {.lex_state = 194},
  [5174] = {.lex_state = 239},
  [5175] = {.lex_state = 194},
  [5176] = {.lex_state = 194},
  [5177] = {.lex_state = 239},
  [5178] = {.lex_state = 194},
  [5179] = {.lex_state = 194},
  [5180] = {.lex_state = 194},
  [5181] = {.lex_state = 194},
  [5182] = {.lex_state = 194},
  [5183] = {.lex_state = 194},
  [5184] = {.lex_state = 194},
  [5185] = {.lex_state = 194},
  [5186] = {.lex_state = 194},
  [5187] = {.lex_state = 239},
  [5188] = {.lex_state = 194},
  [5189] = {.lex_state = 239},
  [5190] = {.lex_state = 194},
  [5191] = {.lex_state = 194},
  [5192] = {.lex_state = 239},
  [5193] = {.lex_state = 237},
  [5194] = {.lex_state = 194},
  [5195] = {.lex_state = 237},
  [5196] = {.lex_state = 194},
  [5197] = {.lex_state = 194},
  [5198] = {.lex_state = 239},
  [5199] = {.lex_state = 194},
  [5200] = {.lex_state = 239},
  [5201] = {.lex_state = 204},
  [5202] = {.lex_state = 196},
  [5203] = {.lex_state = 240},
  [5204] = {.lex_state = 196},
  [5205] = {.lex_state = 196},
  [5206] = {.lex_state = 196},
  [5207] = {.lex_state = 196},
  [5208] = {.lex_state = 240},
  [5209] = {.lex_state = 204},
  [5210] = {.lex_state = 240},
  [5211] = {.lex_state = 196},
  [5212] = {.lex_state = 240},
  [5213] = {.lex_state = 196},
  [5214] = {.lex_state = 196},
  [5215] = {.lex_state = 240},
  [5216] = {.lex_state = 240},
  [5217] = {.lex_state = 239},
  [5218] = {.lex_state = 239},
  [5219] = {.lex_state = 239},
  [5220] = {.lex_state = 240},
  [5221] = {.lex_state = 240},
  [5222] = {.lex_state = 240},
  [5223] = {.lex_state = 239},
  [5224] = {.lex_state = 239},
  [5225] = {.lex_state = 240},
  [5226] = {.lex_state = 240},
  [5227] = {.lex_state = 240},
  [5228] = {.lex_state = 236},
  [5229] = {.lex_state = 240},
  [5230] = {.lex_state = 240},
  [5231] = {.lex_state = 239},
  [5232] = {.lex_state = 240},
  [5233] = {.lex_state = 239},
  [5234] = {.lex_state = 239},
  [5235] = {.lex_state = 239},
  [5236] = {.lex_state = 239},
  [5237] = {.lex_state = 240},
  [5238] = {.lex_state = 240},
  [5239] = {.lex_state = 239},
  [5240] = {.lex_state = 240},
  [5241] = {.lex_state = 239},
  [5242] = {.lex_state = 194},
  [5243] = {.lex_state = 194},
  [5244] = {.lex_state = 194},
  [5245] = {.lex_state = 194},
  [5246] = {.lex_state = 194},
  [5247] = {.lex_state = 194},
  [5248] = {.lex_state = 194},
  [5249] = {.lex_state = 248},
  [5250] = {.lex_state = 194},
  [5251] = {.lex_state = 248},
  [5252] = {.lex_state = 248},
  [5253] = {.lex_state = 236},
  [5254] = {.lex_state = 194},
  [5255] = {.lex_state = 194},
  [5256] = {.lex_state = 248},
  [5257] = {.lex_state = 194},
  [5258] = {.lex_state = 194},
  [5259] = {.lex_state = 248},
  [5260] = {.lex_state = 248},
  [5261] = {.lex_state = 248},
  [5262] = {.lex_state = 240},
  [5263] = {.lex_state = 204},
  [5264] = {.lex_state = 239},
  [5265] = {.lex_state = 239},
  [5266] = {.lex_state = 239},
  [5267] = {.lex_state = 239},
  [5268] = {.lex_state = 240},
  [5269] = {.lex_state = 239},
  [5270] = {.lex_state = 223},
  [5271] = {.lex_state = 239},
  [5272] = {.lex_state = 239},
  [5273] = {.lex_state = 176},
  [5274] = {.lex_state = 237},
  [5275] = {.lex_state = 237},
  [5276] = {.lex_state = 237},
  [5277] = {.lex_state = 237},
  [5278] = {.lex_state = 237},
  [5279] = {.lex_state = 236},
  [5280] = {.lex_state = 237},
  [5281] = {.lex_state = 237},
  [5282] = {.lex_state = 237},
  [5283] = {.lex_state = 176},
  [5284] = {.lex_state = 237},
  [5285] = {.lex_state = 237},
  [5286] = {.lex_state = 237},
  [5287] = {.lex_state = 176},
  [5288] = {.lex_state = 237},
  [5289] = {.lex_state = 237},
  [5290] = {.lex_state = 237},
  [5291] = {.lex_state = 240},
  [5292] = {.lex_state = 237},
  [5293] = {.lex_state = 237},
  [5294] = {.lex_state = 237},
  [5295] = {.lex_state = 240},
  [5296] = {.lex_state = 237},
  [5297] = {.lex_state = 240},
  [5298] = {.lex_state = 176},
  [5299] = {.lex_state = 176},
  [5300] = {.lex_state = 237},
  [5301] = {.lex_state = 223},
  [5302] = {.lex_state = 176},
  [5303] = {.lex_state = 176},
  [5304] = {.lex_state = 248},
  [5305] = {.lex_state = 248},
  [5306] = {.lex_state = 248},
  [5307] = {.lex_state = 248},
  [5308] = {.lex_state = 248},
  [5309] = {.lex_state = 176},
  [5310] = {.lex_state = 176},
  [5311] = {.lex_state = 248},
  [5312] = {.lex_state = 237},
  [5313] = {.lex_state = 176},
  [5314] = {.lex_state = 176},
  [5315] = {.lex_state = 237},
  [5316] = {.lex_state = 248},
  [5317] = {.lex_state = 248},
  [5318] = {.lex_state = 248},
  [5319] = {.lex_state = 248},
  [5320] = {.lex_state = 237},
  [5321] = {.lex_state = 196},
  [5322] = {.lex_state = 223},
  [5323] = {.lex_state = 176},
  [5324] = {.lex_state = 176},
  [5325] = {.lex_state = 239},
  [5326] = {.lex_state = 248},
  [5327] = {.lex_state = 176},
  [5328] = {.lex_state = 196},
  [5329] = {.lex_state = 248},
  [5330] = {.lex_state = 248},
  [5331] = {.lex_state = 248},
  [5332] = {.lex_state = 248},
  [5333] = {.lex_state = 248},
  [5334] = {.lex_state = 176},
  [5335] = {.lex_state = 248},
  [5336] = {.lex_state = 248},
  [5337] = {.lex_state = 237},
  [5338] = {.lex_state = 176},
  [5339] = {.lex_state = 176},
  [5340] = {.lex_state = 176},
  [5341] = {.lex_state = 176},
  [5342] = {.lex_state = 176},
  [5343] = {.lex_state = 204},
  [5344] = {.lex_state = 223},
  [5345] = {.lex_state = 196},
  [5346] = {.lex_state = 248},
  [5347] = {.lex_state = 248},
  [5348] = {.lex_state = 237},
  [5349] = {.lex_state = 248},
  [5350] = {.lex_state = 248},
  [5351] = {.lex_state = 237},
  [5352] = {.lex_state = 248},
  [5353] = {.lex_state = 248},
  [5354] = {.lex_state = 237},
  [5355] = {.lex_state = 248},
  [5356] = {.lex_state = 196},
  [5357] = {.lex_state = 196},
  [5358] = {.lex_state = 196},
  [5359] = {.lex_state = 248},
  [5360] = {.lex_state = 248},
  [5361] = {.lex_state = 248},
  [5362] = {.lex_state = 248},
  [5363] = {.lex_state = 248},
  [5364] = {.lex_state = 248},
  [5365] = {.lex_state = 248},
  [5366] = {.lex_state = 248},
  [5367] = {.lex_state = 176},
  [5368] = {.lex_state = 176},
  [5369] = {.lex_state = 237},
  [5370] = {.lex_state = 237},
  [5371] = {.lex_state = 237},
  [5372] = {.lex_state = 248},
  [5373] = {.lex_state = 176},
  [5374] = {.lex_state = 176},
  [5375] = {.lex_state = 248},
  [5376] = {.lex_state = 176},
  [5377] = {.lex_state = 248},
  [5378] = {.lex_state = 248},
  [5379] = {.lex_state = 176},
  [5380] = {.lex_state = 196},
  [5381] = {.lex_state = 176},
  [5382] = {.lex_state = 176},
  [5383] = {.lex_state = 176},
  [5384] = {.lex_state = 176},
  [5385] = {.lex_state = 237},
  [5386] = {.lex_state = 196},
  [5387] = {.lex_state = 196},
  [5388] = {.lex_state = 176},
  [5389] = {.lex_state = 176},
  [5390] = {.lex_state = 196},
  [5391] = {.lex_state = 239},
  [5392] = {.lex_state = 176},
  [5393] = {.lex_state = 196},
  [5394] = {.lex_state = 248},
  [5395] = {.lex_state = 239},
  [5396] = {.lex_state = 176},
  [5397] = {.lex_state = 248},
  [5398] = {.lex_state = 196},
  [5399] = {.lex_state = 248},
  [5400] = {.lex_state = 176},
  [5401] = {.lex_state = 176},
  [5402] = {.lex_state = 176},
  [5403] = {.lex_state = 176},
  [5404] = {.lex_state = 176},
  [5405] = {.lex_state = 193},
  [5406] = {.lex_state = 176},
  [5407] = {.lex_state = 176},
  [5408] = {.lex_state = 240},
  [5409] = {.lex_state = 176},
  [5410] = {.lex_state = 248},
  [5411] = {.lex_state = 194},
  [5412] = {.lex_state = 194},
  [5413] = {.lex_state = 194},
  [5414] = {.lex_state = 194},
  [5415] = {.lex_state = 194},
  [5416] = {.lex_state = 194},
  [5417] = {.lex_state = 194},
  [5418] = {.lex_state = 194},
  [5419] = {.lex_state = 194},
  [5420] = {.lex_state = 194},
  [5421] = {.lex_state = 194},
  [5422] = {.lex_state = 194},
  [5423] = {.lex_state = 194},
  [5424] = {.lex_state = 194},
  [5425] = {.lex_state = 194},
  [5426] = {.lex_state = 194},
  [5427] = {.lex_state = 194},
  [5428] = {.lex_state = 194},
  [5429] = {.lex_state = 194},
  [5430] = {.lex_state = 223},
  [5431] = {.lex_state = 194},
  [5432] = {.lex_state = 194},
  [5433] = {.lex_state = 194},
  [5434] = {.lex_state = 194},
  [5435] = {.lex_state = 194},
  [5436] = {.lex_state = 194},
  [5437] = {.lex_state = 194},
  [5438] = {.lex_state = 194},
  [5439] = {.lex_state = 194},
  [5440] = {.lex_state = 194},
  [5441] = {.lex_state = 194},
  [5442] = {.lex_state = 223},
  [5443] = {.lex_state = 194},
  [5444] = {.lex_state = 194},
  [5445] = {.lex_state = 194},
  [5446] = {.lex_state = 194},
  [5447] = {.lex_state = 193},
  [5448] = {.lex_state = 194},
  [5449] = {.lex_state = 194},
  [5450] = {.lex_state = 194},
  [5451] = {.lex_state = 194},
  [5452] = {.lex_state = 194},
  [5453] = {.lex_state = 194},
  [5454] = {.lex_state = 194},
  [5455] = {.lex_state = 194},
  [5456] = {.lex_state = 194},
  [5457] = {.lex_state = 194},
  [5458] = {.lex_state = 194},
  [5459] = {.lex_state = 194},
  [5460] = {.lex_state = 194},
  [5461] = {.lex_state = 193},
  [5462] = {.lex_state = 194},
  [5463] = {.lex_state = 194},
  [5464] = {.lex_state = 194},
  [5465] = {.lex_state = 194},
  [5466] = {.lex_state = 240},
  [5467] = {.lex_state = 194},
  [5468] = {.lex_state = 194},
  [5469] = {.lex_state = 194},
  [5470] = {.lex_state = 194},
  [5471] = {.lex_state = 194},
  [5472] = {.lex_state = 194},
  [5473] = {.lex_state = 194},
  [5474] = {.lex_state = 194},
  [5475] = {.lex_state = 194},
  [5476] = {.lex_state = 194},
  [5477] = {.lex_state = 194},
  [5478] = {.lex_state = 194},
  [5479] = {.lex_state = 193},
  [5480] = {.lex_state = 194},
  [5481] = {.lex_state = 194},
  [5482] = {.lex_state = 194},
  [5483] = {.lex_state = 194},
  [5484] = {.lex_state = 194},
  [5485] = {.lex_state = 194},
  [5486] = {.lex_state = 194},
  [5487] = {.lex_state = 194},
  [5488] = {.lex_state = 194},
  [5489] = {.lex_state = 194},
  [5490] = {.lex_state = 194},
  [5491] = {.lex_state = 101},
  [5492] = {.lex_state = 194},
  [5493] = {.lex_state = 194},
  [5494] = {.lex_state = 194},
  [5495] = {.lex_state = 194},
  [5496] = {.lex_state = 194},
  [5497] = {.lex_state = 194},
  [5498] = {.lex_state = 194},
  [5499] = {.lex_state = 194},
  [5500] = {.lex_state = 194},
  [5501] = {.lex_state = 194},
  [5502] = {.lex_state = 194},
  [5503] = {.lex_state = 194},
  [5504] = {.lex_state = 194},
  [5505] = {.lex_state = 194},
  [5506] = {.lex_state = 194},
  [5507] = {.lex_state = 194},
  [5508] = {.lex_state = 239},
  [5509] = {.lex_state = 193},
  [5510] = {.lex_state = 193},
  [5511] = {.lex_state = 193},
  [5512] = {.lex_state = 223},
  [5513] = {.lex_state = 223},
  [5514] = {.lex_state = 193},
  [5515] = {.lex_state = 193},
  [5516] = {.lex_state = 223},
  [5517] = {.lex_state = 239},
  [5518] = {.lex_state = 193},
  [5519] = {.lex_state = 223},
  [5520] = {.lex_state = 223},
  [5521] = {.lex_state = 239},
  [5522] = {.lex_state = 223},
  [5523] = {.lex_state = 223},
  [5524] = {.lex_state = 193},
  [5525] = {.lex_state = 193},
  [5526] = {.lex_state = 239},
  [5527] = {.lex_state = 193},
  [5528] = {.lex_state = 240},
  [5529] = {.lex_state = 239},
  [5530] = {.lex_state = 193},
  [5531] = {.lex_state = 223},
  [5532] = {.lex_state = 202},
  [5533] = {.lex_state = 240},
  [5534] = {.lex_state = 193},
  [5535] = {.lex_state = 223},
  [5536] = {.lex_state = 223},
  [5537] = {.lex_state = 193},
  [5538] = {.lex_state = 223},
  [5539] = {.lex_state = 223},
  [5540] = {.lex_state = 193},
  [5541] = {.lex_state = 223},
  [5542] = {.lex_state = 193},
  [5543] = {.lex_state = 223},
  [5544] = {.lex_state = 193},
  [5545] = {.lex_state = 239},
  [5546] = {.lex_state = 193},
  [5547] = {.lex_state = 193},
  [5548] = {.lex_state = 239},
  [5549] = {.lex_state = 193},
  [5550] = {.lex_state = 193},
  [5551] = {.lex_state = 193},
  [5552] = {.lex_state = 223},
  [5553] = {.lex_state = 193},
  [5554] = {.lex_state = 223},
  [5555] = {.lex_state = 237},
  [5556] = {.lex_state = 237},
  [5557] = {.lex_state = 239},
  [5558] = {.lex_state = 239},
  [5559] = {.lex_state = 240},
  [5560] = {.lex_state = 239},
  [5561] = {.lex_state = 240},
  [5562] = {.lex_state = 240},
  [5563] = {.lex_state = 194},
  [5564] = {.lex_state = 239},
  [5565] = {.lex_state = 240},
  [5566] = {.lex_state = 240},
  [5567] = {.lex_state = 240},
  [5568] = {.lex_state = 237},
  [5569] = {.lex_state = 240},
  [5570] = {.lex_state = 240},
  [5571] = {.lex_state = 239},
  [5572] = {.lex_state = 239},
  [5573] = {.lex_state = 194},
  [5574] = {.lex_state = 239},
  [5575] = {.lex_state = 101},
  [5576] = {.lex_state = 237},
  [5577] = {.lex_state = 240},
  [5578] = {.lex_state = 239},
  [5579] = {.lex_state = 239},
  [5580] = {.lex_state = 239},
  [5581] = {.lex_state = 240},
  [5582] = {.lex_state = 101},
  [5583] = {.lex_state = 239},
  [5584] = {.lex_state = 237},
  [5585] = {.lex_state = 223},
  [5586] = {.lex_state = 240},
  [5587] = {.lex_state = 240},
  [5588] = {.lex_state = 240},
  [5589] = {.lex_state = 240},
  [5590] = {.lex_state = 239},
  [5591] = {.lex_state = 240},
  [5592] = {.lex_state = 237},
  [5593] = {.lex_state = 101},
  [5594] = {.lex_state = 240},
  [5595] = {.lex_state = 240},
  [5596] = {.lex_state = 240},
  [5597] = {.lex_state = 237},
  [5598] = {.lex_state = 240},
  [5599] = {.lex_state = 101},
  [5600] = {.lex_state = 240},
  [5601] = {.lex_state = 240},
  [5602] = {.lex_state = 101},
  [5603] = {.lex_state = 223},
  [5604] = {.lex_state = 240},
  [5605] = {.lex_state = 101},
  [5606] = {.lex_state = 240},
  [5607] = {.lex_state = 101},
  [5608] = {.lex_state = 240},
  [5609] = {.lex_state = 101},
  [5610] = {.lex_state = 223},
  [5611] = {.lex_state = 239},
  [5612] = {.lex_state = 223},
  [5613] = {.lex_state = 101},
  [5614] = {.lex_state = 101},
  [5615] = {.lex_state = 240},
  [5616] = {.lex_state = 101},
  [5617] = {.lex_state = 237},
  [5618] = {.lex_state = 240},
  [5619] = {.lex_state = 239},
  [5620] = {.lex_state = 240},
  [5621] = {.lex_state = 239},
  [5622] = {.lex_state = 194},
  [5623] = {.lex_state = 101},
  [5624] = {.lex_state = 240},
  [5625] = {.lex_state = 240},
  [5626] = {.lex_state = 101},
  [5627] = {.lex_state = 101},
  [5628] = {.lex_state = 237},
  [5629] = {.lex_state = 240},
  [5630] = {.lex_state = 101},
  [5631] = {.lex_state = 101},
  [5632] = {.lex_state = 240},
  [5633] = {.lex_state = 237},
  [5634] = {.lex_state = 239},
  [5635] = {.lex_state = 239},
  [5636] = {.lex_state = 236},
  [5637] = {.lex_state = 237},
  [5638] = {.lex_state = 239},
  [5639] = {.lex_state = 240},
  [5640] = {.lex_state = 240},
  [5641] = {.lex_state = 237},
  [5642] = {.lex_state = 237},
  [5643] = {.lex_state = 240},
  [5644] = {.lex_state = 101},
  [5645] = {.lex_state = 101},
  [5646] = {.lex_state = 240},
  [5647] = {.lex_state = 240},
  [5648] = {.lex_state = 101},
  [5649] = {.lex_state = 237},
  [5650] = {.lex_state = 240},
  [5651] = {.lex_state = 240},
  [5652] = {.lex_state = 240},
  [5653] = {.lex_state = 101},
  [5654] = {.lex_state = 240},
  [5655] = {.lex_state = 237},
  [5656] = {.lex_state = 101},
  [5657] = {.lex_state = 240},
  [5658] = {.lex_state = 240},
  [5659] = {.lex_state = 240},
  [5660] = {.lex_state = 194},
  [5661] = {.lex_state = 193},
  [5662] = {.lex_state = 240},
  [5663] = {.lex_state = 239},
  [5664] = {.lex_state = 240},
  [5665] = {.lex_state = 239},
  [5666] = {.lex_state = 237},
  [5667] = {.lex_state = 193},
  [5668] = {.lex_state = 101},
  [5669] = {.lex_state = 240},
  [5670] = {.lex_state = 101},
  [5671] = {.lex_state = 223},
  [5672] = {.lex_state = 101},
  [5673] = {.lex_state = 239},
  [5674] = {.lex_state = 101},
  [5675] = {.lex_state = 101},
  [5676] = {.lex_state = 240},
  [5677] = {.lex_state = 101},
  [5678] = {.lex_state = 240},
  [5679] = {.lex_state = 239},
  [5680] = {.lex_state = 101},
  [5681] = {.lex_state = 240},
  [5682] = {.lex_state = 240},
  [5683] = {.lex_state = 101},
  [5684] = {.lex_state = 240},
  [5685] = {.lex_state = 240},
  [5686] = {.lex_state = 101},
  [5687] = {.lex_state = 101},
  [5688] = {.lex_state = 240},
  [5689] = {.lex_state = 101},
  [5690] = {.lex_state = 101},
  [5691] = {.lex_state = 237},
  [5692] = {.lex_state = 237},
  [5693] = {.lex_state = 101},
  [5694] = {.lex_state = 239},
  [5695] = {.lex_state = 223},
  [5696] = {.lex_state = 236},
  [5697] = {.lex_state = 236},
  [5698] = {.lex_state = 236},
  [5699] = {.lex_state = 240},
  [5700] = {.lex_state = 236},
  [5701] = {.lex_state = 236},
  [5702] = {.lex_state = 240},
  [5703] = {.lex_state = 236},
  [5704] = {.lex_state = 236},
  [5705] = {.lex_state = 240},
  [5706] = {.lex_state = 236},
  [5707] = {.lex_state = 240},
  [5708] = {.lex_state = 240},
  [5709] = {.lex_state = 240},
  [5710] = {.lex_state = 239},
  [5711] = {.lex_state = 240},
  [5712] = {.lex_state = 202},
  [5713] = {.lex_state = 240},
  [5714] = {.lex_state = 236},
  [5715] = {.lex_state = 202},
  [5716] = {.lex_state = 240},
  [5717] = {.lex_state = 240},
  [5718] = {.lex_state = 239},
  [5719] = {.lex_state = 240},
  [5720] = {.lex_state = 239},
  [5721] = {.lex_state = 239},
  [5722] = {.lex_state = 223},
  [5723] = {.lex_state = 173},
  [5724] = {.lex_state = 239},
  [5725] = {.lex_state = 173},
  [5726] = {.lex_state = 240},
  [5727] = {.lex_state = 240},
  [5728] = {.lex_state = 239},
  [5729] = {.lex_state = 223},
  [5730] = {.lex_state = 202},
  [5731] = {.lex_state = 240},
  [5732] = {.lex_state = 240},
  [5733] = {.lex_state = 240},
  [5734] = {.lex_state = 239},
  [5735] = {.lex_state = 236},
  [5736] = {.lex_state = 173},
  [5737] = {.lex_state = 202},
  [5738] = {.lex_state = 239},
  [5739] = {.lex_state = 239},
  [5740] = {.lex_state = 240},
  [5741] = {.lex_state = 173},
  [5742] = {.lex_state = 202},
  [5743] = {.lex_state = 239},
  [5744] = {.lex_state = 240},
  [5745] = {.lex_state = 240},
  [5746] = {.lex_state = 240},
  [5747] = {.lex_state = 240},
  [5748] = {.lex_state = 173},
  [5749] = {.lex_state = 236},
  [5750] = {.lex_state = 239},
  [5751] = {.lex_state = 239},
  [5752] = {.lex_state = 202},
  [5753] = {.lex_state = 240},
  [5754] = {.lex_state = 173},
  [5755] = {.lex_state = 173},
  [5756] = {.lex_state = 223},
  [5757] = {.lex_state = 202},
  [5758] = {.lex_state = 232},
  [5759] = {.lex_state = 240},
  [5760] = {.lex_state = 240},
  [5761] = {.lex_state = 173},
  [5762] = {.lex_state = 202},
  [5763] = {.lex_state = 239},
  [5764] = {.lex_state = 204},
  [5765] = {.lex_state = 223},
  [5766] = {.lex_state = 202},
  [5767] = {.lex_state = 240},
  [5768] = {.lex_state = 173},
  [5769] = {.lex_state = 202},
  [5770] = {.lex_state = 232},
  [5771] = {.lex_state = 240},
  [5772] = {.lex_state = 240},
  [5773] = {.lex_state = 239},
  [5774] = {.lex_state = 173},
  [5775] = {.lex_state = 240},
  [5776] = {.lex_state = 232},
  [5777] = {.lex_state = 240},
  [5778] = {.lex_state = 240},
  [5779] = {.lex_state = 240},
  [5780] = {.lex_state = 240},
  [5781] = {.lex_state = 240},
  [5782] = {.lex_state = 232},
  [5783] = {.lex_state = 240},
  [5784] = {.lex_state = 240},
  [5785] = {.lex_state = 236},
  [5786] = {.lex_state = 236},
  [5787] = {.lex_state = 241},
  [5788] = {.lex_state = 236},
  [5789] = {.lex_state = 173},
  [5790] = {.lex_state = 236},
  [5791] = {.lex_state = 236},
  [5792] = {.lex_state = 236},
  [5793] = {.lex_state = 194},
  [5794] = {.lex_state = 236},
  [5795] = {.lex_state = 236},
  [5796] = {.lex_state = 239},
  [5797] = {.lex_state = 236},
  [5798] = {.lex_state = 236},
  [5799] = {.lex_state = 194},
  [5800] = {.lex_state = 241},
  [5801] = {.lex_state = 173},
  [5802] = {.lex_state = 194},
  [5803] = {.lex_state = 240},
  [5804] = {.lex_state = 240},
  [5805] = {.lex_state = 194},
  [5806] = {.lex_state = 194},
  [5807] = {.lex_state = 247},
  [5808] = {.lex_state = 194},
  [5809] = {.lex_state = 236},
  [5810] = {.lex_state = 194},
  [5811] = {.lex_state = 236},
  [5812] = {.lex_state = 236},
  [5813] = {.lex_state = 239},
  [5814] = {.lex_state = 236},
  [5815] = {.lex_state = 236},
  [5816] = {.lex_state = 194},
  [5817] = {.lex_state = 236},
  [5818] = {.lex_state = 236},
  [5819] = {.lex_state = 236},
  [5820] = {.lex_state = 236},
  [5821] = {.lex_state = 239},
  [5822] = {.lex_state = 236},
  [5823] = {.lex_state = 236},
  [5824] = {.lex_state = 236},
  [5825] = {.lex_state = 236},
  [5826] = {.lex_state = 236},
  [5827] = {.lex_state = 194},
  [5828] = {.lex_state = 236},
  [5829] = {.lex_state = 236},
  [5830] = {.lex_state = 236},
  [5831] = {.lex_state = 236},
  [5832] = {.lex_state = 236},
  [5833] = {.lex_state = 186},
  [5834] = {.lex_state = 194},
  [5835] = {.lex_state = 239},
  [5836] = {.lex_state = 240},
  [5837] = {.lex_state = 239},
  [5838] = {.lex_state = 194},
  [5839] = {.lex_state = 239},
  [5840] = {.lex_state = 194},
  [5841] = {.lex_state = 173},
  [5842] = {.lex_state = 173},
  [5843] = {.lex_state = 214},
  [5844] = {.lex_state = 239},
  [5845] = {.lex_state = 194},
  [5846] = {.lex_state = 186},
  [5847] = {.lex_state = 239},
  [5848] = {.lex_state = 173},
  [5849] = {.lex_state = 186},
  [5850] = {.lex_state = 173},
  [5851] = {.lex_state = 173},
  [5852] = {.lex_state = 214},
  [5853] = {.lex_state = 186},
  [5854] = {.lex_state = 186},
  [5855] = {.lex_state = 186},
  [5856] = {.lex_state = 194},
  [5857] = {.lex_state = 173},
  [5858] = {.lex_state = 186},
  [5859] = {.lex_state = 194},
  [5860] = {.lex_state = 240},
  [5861] = {.lex_state = 240},
  [5862] = {.lex_state = 240},
  [5863] = {.lex_state = 240},
  [5864] = {.lex_state = 214},
  [5865] = {.lex_state = 240},
  [5866] = {.lex_state = 240},
  [5867] = {.lex_state = 240},
  [5868] = {.lex_state = 240},
  [5869] = {.lex_state = 240},
  [5870] = {.lex_state = 186},
  [5871] = {.lex_state = 186},
  [5872] = {.lex_state = 186},
  [5873] = {.lex_state = 214},
  [5874] = {.lex_state = 179},
  [5875] = {.lex_state = 186},
  [5876] = {.lex_state = 214},
  [5877] = {.lex_state = 173},
  [5878] = {.lex_state = 173},
  [5879] = {.lex_state = 186},
  [5880] = {.lex_state = 214},
  [5881] = {.lex_state = 240},
  [5882] = {.lex_state = 186},
  [5883] = {.lex_state = 194},
  [5884] = {.lex_state = 186},
  [5885] = {.lex_state = 214},
  [5886] = {.lex_state = 239},
  [5887] = {.lex_state = 173},
  [5888] = {.lex_state = 186},
  [5889] = {.lex_state = 214},
  [5890] = {.lex_state = 240},
  [5891] = {.lex_state = 240},
  [5892] = {.lex_state = 239},
  [5893] = {.lex_state = 240},
  [5894] = {.lex_state = 239},
  [5895] = {.lex_state = 173},
  [5896] = {.lex_state = 239},
  [5897] = {.lex_state = 240},
  [5898] = {.lex_state = 239},
  [5899] = {.lex_state = 240},
  [5900] = {.lex_state = 194},
  [5901] = {.lex_state = 194},
  [5902] = {.lex_state = 240},
  [5903] = {.lex_state = 240},
  [5904] = {.lex_state = 239},
  [5905] = {.lex_state = 240},
  [5906] = {.lex_state = 240},
  [5907] = {.lex_state = 239},
  [5908] = {.lex_state = 239},
  [5909] = {.lex_state = 239},
  [5910] = {.lex_state = 241},
  [5911] = {.lex_state = 241},
  [5912] = {.lex_state = 198},
  [5913] = {.lex_state = 240},
  [5914] = {.lex_state = 194},
  [5915] = {.lex_state = 241},
  [5916] = {.lex_state = 241},
  [5917] = {.lex_state = 239},
  [5918] = {.lex_state = 198},
  [5919] = {.lex_state = 194},
  [5920] = {.lex_state = 194},
  [5921] = {.lex_state = 194},
  [5922] = {.lex_state = 194},
  [5923] = {.lex_state = 198},
  [5924] = {.lex_state = 198},
  [5925] = {.lex_state = 240},
  [5926] = {.lex_state = 194},
  [5927] = {.lex_state = 239},
  [5928] = {.lex_state = 241},
  [5929] = {.lex_state = 241},
  [5930] = {.lex_state = 186},
  [5931] = {.lex_state = 241},
  [5932] = {.lex_state = 241},
  [5933] = {.lex_state = 214},
  [5934] = {.lex_state = 214},
  [5935] = {.lex_state = 236},
  [5936] = {.lex_state = 214},
  [5937] = {.lex_state = 214},
  [5938] = {.lex_state = 236},
  [5939] = {.lex_state = 236},
  [5940] = {.lex_state = 241},
  [5941] = {.lex_state = 240},
  [5942] = {.lex_state = 186},
  [5943] = {.lex_state = 214},
  [5944] = {.lex_state = 198},
  [5945] = {.lex_state = 214},
  [5946] = {.lex_state = 214},
  [5947] = {.lex_state = 214},
  [5948] = {.lex_state = 241},
  [5949] = {.lex_state = 236},
  [5950] = {.lex_state = 236},
  [5951] = {.lex_state = 186},
  [5952] = {.lex_state = 194},
  [5953] = {.lex_state = 236},
  [5954] = {.lex_state = 194},
  [5955] = {.lex_state = 236},
  [5956] = {.lex_state = 198},
  [5957] = {.lex_state = 240},
  [5958] = {.lex_state = 198},
  [5959] = {.lex_state = 240},
  [5960] = {.lex_state = 241},
  [5961] = {.lex_state = 186},
  [5962] = {.lex_state = 240},
  [5963] = {.lex_state = 194},
  [5964] = {.lex_state = 198},
  [5965] = {.lex_state = 236},
  [5966] = {.lex_state = 240},
  [5967] = {.lex_state = 239},
  [5968] = {.lex_state = 239},
  [5969] = {.lex_state = 198},
  [5970] = {.lex_state = 232},
  [5971] = {.lex_state = 194},
  [5972] = {.lex_state = 232},
  [5973] = {.lex_state = 241},
  [5974] = {.lex_state = 186},
  [5975] = {.lex_state = 198},
  [5976] = {.lex_state = 240},
  [5977] = {.lex_state = 194},
  [5978] = {.lex_state = 240},
  [5979] = {.lex_state = 198},
  [5980] = {.lex_state = 240},
  [5981] = {.lex_state = 194},
  [5982] = {.lex_state = 194},
  [5983] = {.lex_state = 194},
  [5984] = {.lex_state = 194},
  [5985] = {.lex_state = 194},
  [5986] = {.lex_state = 194},
  [5987] = {.lex_state = 194},
  [5988] = {.lex_state = 194},
  [5989] = {.lex_state = 241},
  [5990] = {.lex_state = 241},
  [5991] = {.lex_state = 241},
  [5992] = {.lex_state = 194},
  [5993] = {.lex_state = 194},
  [5994] = {.lex_state = 194},
  [5995] = {.lex_state = 194},
  [5996] = {.lex_state = 194},
  [5997] = {.lex_state = 186},
  [5998] = {.lex_state = 241},
  [5999] = {.lex_state = 241},
  [6000] = {.lex_state = 194},
  [6001] = {.lex_state = 198},
  [6002] = {.lex_state = 194},
  [6003] = {.lex_state = 241},
  [6004] = {.lex_state = 194},
  [6005] = {.lex_state = 241},
  [6006] = {.lex_state = 240},
  [6007] = {.lex_state = 240},
  [6008] = {.lex_state = 194},
  [6009] = {.lex_state = 194},
  [6010] = {.lex_state = 240},
  [6011] = {.lex_state = 194},
  [6012] = {.lex_state = 240},
  [6013] = {.lex_state = 239},
  [6014] = {.lex_state = 240},
  [6015] = {.lex_state = 240},
  [6016] = {.lex_state = 194},
  [6017] = {.lex_state = 194},
  [6018] = {.lex_state = 240},
  [6019] = {.lex_state = 203},
  [6020] = {.lex_state = 240},
  [6021] = {.lex_state = 239},
  [6022] = {.lex_state = 240},
  [6023] = {.lex_state = 240},
  [6024] = {.lex_state = 194},
  [6025] = {.lex_state = 194},
  [6026] = {.lex_state = 232},
  [6027] = {.lex_state = 240},
  [6028] = {.lex_state = 186},
  [6029] = {.lex_state = 239},
  [6030] = {.lex_state = 240},
  [6031] = {.lex_state = 241},
  [6032] = {.lex_state = 239},
  [6033] = {.lex_state = 232},
  [6034] = {.lex_state = 194},
  [6035] = {.lex_state = 241},
  [6036] = {.lex_state = 240},
  [6037] = {.lex_state = 240},
  [6038] = {.lex_state = 240},
  [6039] = {.lex_state = 240},
  [6040] = {.lex_state = 194},
  [6041] = {.lex_state = 240},
  [6042] = {.lex_state = 192},
  [6043] = {.lex_state = 0},
  [6044] = {.lex_state = 240},
  [6045] = {.lex_state = 192},
  [6046] = {.lex_state = 240},
  [6047] = {.lex_state = 240},
  [6048] = {.lex_state = 194},
  [6049] = {.lex_state = 240},
  [6050] = {.lex_state = 240},
  [6051] = {.lex_state = 240},
  [6052] = {.lex_state = 240},
  [6053] = {.lex_state = 240},
  [6054] = {.lex_state = 240},
  [6055] = {.lex_state = 192},
  [6056] = {.lex_state = 240},
  [6057] = {.lex_state = 194},
  [6058] = {.lex_state = 240},
  [6059] = {.lex_state = 173},
  [6060] = {.lex_state = 240},
  [6061] = {.lex_state = 240},
  [6062] = {.lex_state = 196},
  [6063] = {.lex_state = 240},
  [6064] = {.lex_state = 196},
  [6065] = {.lex_state = 240},
  [6066] = {.lex_state = 240},
  [6067] = {.lex_state = 0},
  [6068] = {.lex_state = 240},
  [6069] = {.lex_state = 196},
  [6070] = {.lex_state = 240},
  [6071] = {.lex_state = 196},
  [6072] = {.lex_state = 240},
  [6073] = {.lex_state = 240},
  [6074] = {.lex_state = 0},
  [6075] = {.lex_state = 192},
  [6076] = {.lex_state = 240},
  [6077] = {.lex_state = 196},
  [6078] = {.lex_state = 194},
  [6079] = {.lex_state = 196},
  [6080] = {.lex_state = 192},
  [6081] = {.lex_state = 196},
  [6082] = {.lex_state = 196},
  [6083] = {.lex_state = 194},
  [6084] = {.lex_state = 0},
  [6085] = {.lex_state = 240},
  [6086] = {.lex_state = 240},
  [6087] = {.lex_state = 192},
  [6088] = {.lex_state = 240},
  [6089] = {.lex_state = 192},
  [6090] = {.lex_state = 240},
  [6091] = {.lex_state = 192},
  [6092] = {.lex_state = 240},
  [6093] = {.lex_state = 192},
  [6094] = {.lex_state = 240},
  [6095] = {.lex_state = 240},
  [6096] = {.lex_state = 240},
  [6097] = {.lex_state = 0},
  [6098] = {.lex_state = 240},
  [6099] = {.lex_state = 240},
  [6100] = {.lex_state = 239},
  [6101] = {.lex_state = 192},
  [6102] = {.lex_state = 239},
  [6103] = {.lex_state = 240},
  [6104] = {.lex_state = 192},
  [6105] = {.lex_state = 240},
  [6106] = {.lex_state = 192},
  [6107] = {.lex_state = 240},
  [6108] = {.lex_state = 239},
  [6109] = {.lex_state = 240},
  [6110] = {.lex_state = 240},
  [6111] = {.lex_state = 240},
  [6112] = {.lex_state = 0},
  [6113] = {.lex_state = 239},
  [6114] = {.lex_state = 192},
  [6115] = {.lex_state = 239},
  [6116] = {.lex_state = 240},
  [6117] = {.lex_state = 239},
  [6118] = {.lex_state = 240},
  [6119] = {.lex_state = 239},
  [6120] = {.lex_state = 240},
  [6121] = {.lex_state = 192},
  [6122] = {.lex_state = 173},
  [6123] = {.lex_state = 240},
  [6124] = {.lex_state = 192},
  [6125] = {.lex_state = 240},
  [6126] = {.lex_state = 192},
  [6127] = {.lex_state = 240},
  [6128] = {.lex_state = 240},
  [6129] = {.lex_state = 240},
  [6130] = {.lex_state = 192},
  [6131] = {.lex_state = 194},
  [6132] = {.lex_state = 0},
  [6133] = {.lex_state = 194},
  [6134] = {.lex_state = 240},
  [6135] = {.lex_state = 192},
  [6136] = {.lex_state = 239},
  [6137] = {.lex_state = 192},
  [6138] = {.lex_state = 240},
  [6139] = {.lex_state = 173},
  [6140] = {.lex_state = 192},
  [6141] = {.lex_state = 335},
  [6142] = {.lex_state = 194},
  [6143] = {.lex_state = 194},
  [6144] = {.lex_state = 214},
  [6145] = {.lex_state = 194},
  [6146] = {.lex_state = 194},
  [6147] = {.lex_state = 214},
  [6148] = {.lex_state = 214},
  [6149] = {.lex_state = 335},
  [6150] = {.lex_state = 335},
  [6151] = {.lex_state = 0},
  [6152] = {.lex_state = 194},
  [6153] = {.lex_state = 194},
  [6154] = {.lex_state = 194},
  [6155] = {.lex_state = 240},
  [6156] = {.lex_state = 194},
  [6157] = {.lex_state = 214},
  [6158] = {.lex_state = 194},
  [6159] = {.lex_state = 194},
  [6160] = {.lex_state = 194},
  [6161] = {.lex_state = 194},
  [6162] = {.lex_state = 198},
  [6163] = {.lex_state = 240},
  [6164] = {.lex_state = 194},
  [6165] = {.lex_state = 214},
  [6166] = {.lex_state = 194},
  [6167] = {.lex_state = 335},
  [6168] = {.lex_state = 194},
  [6169] = {.lex_state = 214},
  [6170] = {.lex_state = 240},
  [6171] = {.lex_state = 214},
  [6172] = {.lex_state = 198},
  [6173] = {.lex_state = 202},
  [6174] = {.lex_state = 198},
  [6175] = {.lex_state = 214},
  [6176] = {.lex_state = 194},
  [6177] = {.lex_state = 198},
  [6178] = {.lex_state = 214},
  [6179] = {.lex_state = 194},
  [6180] = {.lex_state = 194},
  [6181] = {.lex_state = 240},
  [6182] = {.lex_state = 194},
  [6183] = {.lex_state = 194},
  [6184] = {.lex_state = 194},
  [6185] = {.lex_state = 194},
  [6186] = {.lex_state = 194},
  [6187] = {.lex_state = 194},
  [6188] = {.lex_state = 194},
  [6189] = {.lex_state = 194},
  [6190] = {.lex_state = 194},
  [6191] = {.lex_state = 198},
  [6192] = {.lex_state = 198},
  [6193] = {.lex_state = 194},
  [6194] = {.lex_state = 194},
  [6195] = {.lex_state = 194},
  [6196] = {.lex_state = 214},
  [6197] = {.lex_state = 194},
  [6198] = {.lex_state = 214},
  [6199] = {.lex_state = 335},
  [6200] = {.lex_state = 194},
  [6201] = {.lex_state = 240},
  [6202] = {.lex_state = 194},
  [6203] = {.lex_state = 198},
  [6204] = {.lex_state = 194},
  [6205] = {.lex_state = 214},
  [6206] = {.lex_state = 194},
  [6207] = {.lex_state = 194},
  [6208] = {.lex_state = 198},
  [6209] = {.lex_state = 194},
  [6210] = {.lex_state = 194},
  [6211] = {.lex_state = 196},
  [6212] = {.lex_state = 207},
  [6213] = {.lex_state = 240},
  [6214] = {.lex_state = 240},
  [6215] = {.lex_state = 194},
  [6216] = {.lex_state = 240},
  [6217] = {.lex_state = 194},
  [6218] = {.lex_state = 194},
  [6219] = {.lex_state = 240},
  [6220] = {.lex_state = 194},
  [6221] = {.lex_state = 194},
  [6222] = {.lex_state = 194},
  [6223] = {.lex_state = 207},
  [6224] = {.lex_state = 194},
  [6225] = {.lex_state = 196},
  [6226] = {.lex_state = 194},
  [6227] = {.lex_state = 240},
  [6228] = {.lex_state = 194},
  [6229] = {.lex_state = 196},
  [6230] = {.lex_state = 196},
  [6231] = {.lex_state = 194},
  [6232] = {.lex_state = 207},
  [6233] = {.lex_state = 196},
  [6234] = {.lex_state = 194},
  [6235] = {.lex_state = 194},
  [6236] = {.lex_state = 196},
  [6237] = {.lex_state = 196},
  [6238] = {.lex_state = 240},
  [6239] = {.lex_state = 194},
  [6240] = {.lex_state = 207},
  [6241] = {.lex_state = 194},
  [6242] = {.lex_state = 207},
  [6243] = {.lex_state = 194},
  [6244] = {.lex_state = 194},
  [6245] = {.lex_state = 196},
  [6246] = {.lex_state = 194},
  [6247] = {.lex_state = 194},
  [6248] = {.lex_state = 196},
  [6249] = {.lex_state = 196},
  [6250] = {.lex_state = 240},
  [6251] = {.lex_state = 194},
  [6252] = {.lex_state = 207},
  [6253] = {.lex_state = 194},
  [6254] = {.lex_state = 194},
  [6255] = {.lex_state = 192},
  [6256] = {.lex_state = 194},
  [6257] = {.lex_state = 240},
  [6258] = {.lex_state = 194},
  [6259] = {.lex_state = 196},
  [6260] = {.lex_state = 194},
  [6261] = {.lex_state = 236},
  [6262] = {.lex_state = 194},
  [6263] = {.lex_state = 194},
  [6264] = {.lex_state = 194},
  [6265] = {.lex_state = 194},
  [6266] = {.lex_state = 194},
  [6267] = {.lex_state = 194},
  [6268] = {.lex_state = 194},
  [6269] = {.lex_state = 194},
  [6270] = {.lex_state = 194},
  [6271] = {.lex_state = 194},
  [6272] = {.lex_state = 194},
  [6273] = {.lex_state = 194},
  [6274] = {.lex_state = 240},
  [6275] = {.lex_state = 240},
  [6276] = {.lex_state = 194},
  [6277] = {.lex_state = 207},
  [6278] = {.lex_state = 194},
  [6279] = {.lex_state = 194},
  [6280] = {.lex_state = 194},
  [6281] = {.lex_state = 207},
  [6282] = {.lex_state = 194},
  [6283] = {.lex_state = 236},
  [6284] = {.lex_state = 194},
  [6285] = {.lex_state = 236},
  [6286] = {.lex_state = 194},
  [6287] = {.lex_state = 236},
  [6288] = {.lex_state = 194},
  [6289] = {.lex_state = 194},
  [6290] = {.lex_state = 194},
  [6291] = {.lex_state = 196},
  [6292] = {.lex_state = 335},
  [6293] = {.lex_state = 223},
  [6294] = {.lex_state = 223},
  [6295] = {.lex_state = 223},
  [6296] = {.lex_state = 214},
  [6297] = {.lex_state = 214},
  [6298] = {.lex_state = 214},
  [6299] = {.lex_state = 240},
  [6300] = {.lex_state = 240},
  [6301] = {.lex_state = 223},
  [6302] = {.lex_state = 214},
  [6303] = {.lex_state = 223},
  [6304] = {.lex_state = 214},
  [6305] = {.lex_state = 335},
  [6306] = {.lex_state = 194},
  [6307] = {.lex_state = 223},
  [6308] = {.lex_state = 240},
  [6309] = {.lex_state = 214},
  [6310] = {.lex_state = 214},
  [6311] = {.lex_state = 214},
  [6312] = {.lex_state = 240},
  [6313] = {.lex_state = 194},
  [6314] = {.lex_state = 335},
  [6315] = {.lex_state = 179},
  [6316] = {.lex_state = 240},
  [6317] = {.lex_state = 223},
  [6318] = {.lex_state = 194},
  [6319] = {.lex_state = 223},
  [6320] = {.lex_state = 223},
  [6321] = {.lex_state = 194},
  [6322] = {.lex_state = 223},
  [6323] = {.lex_state = 240},
  [6324] = {.lex_state = 223},
  [6325] = {.lex_state = 194},
  [6326] = {.lex_state = 240},
  [6327] = {.lex_state = 223},
  [6328] = {.lex_state = 223},
  [6329] = {.lex_state = 194},
  [6330] = {.lex_state = 179},
  [6331] = {.lex_state = 194},
  [6332] = {.lex_state = 194},
  [6333] = {.lex_state = 194},
  [6334] = {.lex_state = 194},
  [6335] = {.lex_state = 194},
  [6336] = {.lex_state = 194},
  [6337] = {.lex_state = 194},
  [6338] = {.lex_state = 233},
  [6339] = {.lex_state = 194},
  [6340] = {.lex_state = 233},
  [6341] = {.lex_state = 202},
  [6342] = {.lex_state = 194},
  [6343] = {.lex_state = 194},
  [6344] = {.lex_state = 335},
  [6345] = {.lex_state = 196},
  [6346] = {.lex_state = 194},
  [6347] = {.lex_state = 196},
  [6348] = {.lex_state = 194},
  [6349] = {.lex_state = 194},
  [6350] = {.lex_state = 194},
  [6351] = {.lex_state = 196},
  [6352] = {.lex_state = 196},
  [6353] = {.lex_state = 194},
  [6354] = {.lex_state = 196},
  [6355] = {.lex_state = 194},
  [6356] = {.lex_state = 194},
  [6357] = {.lex_state = 194},
  [6358] = {.lex_state = 194},
  [6359] = {.lex_state = 202},
  [6360] = {.lex_state = 233},
  [6361] = {.lex_state = 194},
  [6362] = {.lex_state = 335},
  [6363] = {.lex_state = 194},
  [6364] = {.lex_state = 194},
  [6365] = {.lex_state = 194},
  [6366] = {.lex_state = 196},
  [6367] = {.lex_state = 194},
  [6368] = {.lex_state = 194},
  [6369] = {.lex_state = 194},
  [6370] = {.lex_state = 196},
  [6371] = {.lex_state = 194},
  [6372] = {.lex_state = 196},
  [6373] = {.lex_state = 194},
  [6374] = {.lex_state = 233},
  [6375] = {.lex_state = 194},
  [6376] = {.lex_state = 194},
  [6377] = {.lex_state = 194},
  [6378] = {.lex_state = 194},
  [6379] = {.lex_state = 194},
  [6380] = {.lex_state = 194},
  [6381] = {.lex_state = 194},
  [6382] = {.lex_state = 173},
  [6383] = {.lex_state = 194},
  [6384] = {.lex_state = 194},
  [6385] = {.lex_state = 198},
  [6386] = {.lex_state = 335},
  [6387] = {.lex_state = 198},
  [6388] = {.lex_state = 223},
  [6389] = {.lex_state = 335},
  [6390] = {.lex_state = 194},
  [6391] = {.lex_state = 335},
  [6392] = {.lex_state = 198},
  [6393] = {.lex_state = 335},
  [6394] = {.lex_state = 198},
  [6395] = {.lex_state = 198},
  [6396] = {.lex_state = 173},
  [6397] = {.lex_state = 335},
  [6398] = {.lex_state = 236},
  [6399] = {.lex_state = 242},
  [6400] = {.lex_state = 335},
  [6401] = {.lex_state = 335},
  [6402] = {.lex_state = 239},
  [6403] = {.lex_state = 335},
  [6404] = {.lex_state = 335},
  [6405] = {.lex_state = 335},
  [6406] = {.lex_state = 335},
  [6407] = {.lex_state = 196},
  [6408] = {.lex_state = 335},
  [6409] = {.lex_state = 196},
  [6410] = {.lex_state = 335},
  [6411] = {.lex_state = 198},
  [6412] = {.lex_state = 223},
  [6413] = {.lex_state = 198},
  [6414] = {.lex_state = 196},
  [6415] = {.lex_state = 335},
  [6416] = {.lex_state = 196},
  [6417] = {.lex_state = 198},
  [6418] = {.lex_state = 196},
  [6419] = {.lex_state = 335},
  [6420] = {.lex_state = 239},
  [6421] = {.lex_state = 335},
  [6422] = {.lex_state = 335},
  [6423] = {.lex_state = 335},
  [6424] = {.lex_state = 335},
  [6425] = {.lex_state = 335},
  [6426] = {.lex_state = 194},
  [6427] = {.lex_state = 173},
  [6428] = {.lex_state = 335},
  [6429] = {.lex_state = 236},
  [6430] = {.lex_state = 335},
  [6431] = {.lex_state = 196},
  [6432] = {.lex_state = 335},
  [6433] = {.lex_state = 335},
  [6434] = {.lex_state = 335},
  [6435] = {.lex_state = 173},
  [6436] = {.lex_state = 173},
  [6437] = {.lex_state = 173},
  [6438] = {.lex_state = 335},
  [6439] = {.lex_state = 173},
  [6440] = {.lex_state = 202},
  [6441] = {.lex_state = 196},
  [6442] = {.lex_state = 335},
  [6443] = {.lex_state = 173},
  [6444] = {.lex_state = 194},
  [6445] = {.lex_state = 194},
  [6446] = {.lex_state = 194},
  [6447] = {.lex_state = 196},
  [6448] = {.lex_state = 335},
  [6449] = {.lex_state = 173},
  [6450] = {.lex_state = 194},
  [6451] = {.lex_state = 335},
  [6452] = {.lex_state = 202},
  [6453] = {.lex_state = 173},
  [6454] = {.lex_state = 194},
  [6455] = {.lex_state = 173},
  [6456] = {.lex_state = 173},
  [6457] = {.lex_state = 196},
  [6458] = {.lex_state = 194},
  [6459] = {.lex_state = 173},
  [6460] = {.lex_state = 194},
  [6461] = {.lex_state = 173},
  [6462] = {.lex_state = 173},
  [6463] = {.lex_state = 335},
  [6464] = {.lex_state = 173},
  [6465] = {.lex_state = 173},
  [6466] = {.lex_state = 173},
  [6467] = {.lex_state = 202},
  [6468] = {.lex_state = 173},
  [6469] = {.lex_state = 335},
  [6470] = {.lex_state = 173},
  [6471] = {.lex_state = 335},
  [6472] = {.lex_state = 173},
  [6473] = {.lex_state = 335},
  [6474] = {.lex_state = 196},
  [6475] = {.lex_state = 239},
  [6476] = {.lex_state = 173},
  [6477] = {.lex_state = 194},
  [6478] = {.lex_state = 173},
  [6479] = {.lex_state = 173},
  [6480] = {.lex_state = 194},
  [6481] = {.lex_state = 173},
  [6482] = {.lex_state = 173},
  [6483] = {.lex_state = 335},
  [6484] = {.lex_state = 196},
  [6485] = {.lex_state = 192},
  [6486] = {.lex_state = 194},
  [6487] = {.lex_state = 196},
  [6488] = {.lex_state = 0},
  [6489] = {.lex_state = 192},
  [6490] = {.lex_state = 192},
  [6491] = {.lex_state = 192},
  [6492] = {.lex_state = 194},
  [6493] = {.lex_state = 236},
  [6494] = {.lex_state = 236},
  [6495] = {.lex_state = 335},
  [6496] = {.lex_state = 192},
  [6497] = {.lex_state = 335},
  [6498] = {.lex_state = 236},
  [6499] = {.lex_state = 194},
  [6500] = {.lex_state = 194},
  [6501] = {.lex_state = 194},
  [6502] = {.lex_state = 192},
  [6503] = {.lex_state = 335},
  [6504] = {.lex_state = 0},
  [6505] = {.lex_state = 236},
  [6506] = {.lex_state = 236},
  [6507] = {.lex_state = 192},
  [6508] = {.lex_state = 236},
  [6509] = {.lex_state = 173},
  [6510] = {.lex_state = 236},
  [6511] = {.lex_state = 192},
  [6512] = {.lex_state = 236},
  [6513] = {.lex_state = 236},
  [6514] = {.lex_state = 335},
  [6515] = {.lex_state = 194},
  [6516] = {.lex_state = 194},
  [6517] = {.lex_state = 236},
  [6518] = {.lex_state = 194},
  [6519] = {.lex_state = 194},
  [6520] = {.lex_state = 194},
  [6521] = {.lex_state = 194},
  [6522] = {.lex_state = 194},
  [6523] = {.lex_state = 194},
  [6524] = {.lex_state = 194},
  [6525] = {.lex_state = 335},
  [6526] = {.lex_state = 194},
  [6527] = {.lex_state = 192},
  [6528] = {.lex_state = 236},
  [6529] = {.lex_state = 173},
  [6530] = {.lex_state = 192},
  [6531] = {.lex_state = 194},
  [6532] = {.lex_state = 236},
  [6533] = {.lex_state = 192},
  [6534] = {.lex_state = 194},
  [6535] = {.lex_state = 194},
  [6536] = {.lex_state = 236},
  [6537] = {.lex_state = 236},
  [6538] = {.lex_state = 194},
  [6539] = {.lex_state = 194},
  [6540] = {.lex_state = 194},
  [6541] = {.lex_state = 194},
  [6542] = {.lex_state = 173},
  [6543] = {.lex_state = 335},
  [6544] = {.lex_state = 194},
  [6545] = {.lex_state = 173},
  [6546] = {.lex_state = 335},
  [6547] = {.lex_state = 194},
  [6548] = {.lex_state = 194},
  [6549] = {.lex_state = 203},
  [6550] = {.lex_state = 194},
  [6551] = {.lex_state = 194},
  [6552] = {.lex_state = 194},
  [6553] = {.lex_state = 236},
  [6554] = {.lex_state = 173},
  [6555] = {.lex_state = 214},
  [6556] = {.lex_state = 194},
  [6557] = {.lex_state = 194},
  [6558] = {.lex_state = 335},
  [6559] = {.lex_state = 173},
  [6560] = {.lex_state = 203},
  [6561] = {.lex_state = 203},
  [6562] = {.lex_state = 194},
  [6563] = {.lex_state = 203},
  [6564] = {.lex_state = 203},
  [6565] = {.lex_state = 194},
  [6566] = {.lex_state = 194},
  [6567] = {.lex_state = 194},
  [6568] = {.lex_state = 194},
  [6569] = {.lex_state = 173},
  [6570] = {.lex_state = 194},
  [6571] = {.lex_state = 194},
  [6572] = {.lex_state = 203},
  [6573] = {.lex_state = 203},
  [6574] = {.lex_state = 335},
  [6575] = {.lex_state = 203},
  [6576] = {.lex_state = 194},
  [6577] = {.lex_state = 194},
  [6578] = {.lex_state = 214},
  [6579] = {.lex_state = 194},
  [6580] = {.lex_state = 194},
  [6581] = {.lex_state = 194},
  [6582] = {.lex_state = 194},
  [6583] = {.lex_state = 194},
  [6584] = {.lex_state = 194},
  [6585] = {.lex_state = 194},
  [6586] = {.lex_state = 194},
  [6587] = {.lex_state = 194},
  [6588] = {.lex_state = 194},
  [6589] = {.lex_state = 194},
  [6590] = {.lex_state = 194},
  [6591] = {.lex_state = 194},
  [6592] = {.lex_state = 173},
  [6593] = {.lex_state = 194},
  [6594] = {.lex_state = 194},
  [6595] = {.lex_state = 194},
  [6596] = {.lex_state = 194},
  [6597] = {.lex_state = 335},
  [6598] = {.lex_state = 335},
  [6599] = {.lex_state = 194},
  [6600] = {.lex_state = 203},
  [6601] = {.lex_state = 236},
  [6602] = {.lex_state = 335},
  [6603] = {.lex_state = 203},
  [6604] = {.lex_state = 173},
  [6605] = {.lex_state = 194},
  [6606] = {.lex_state = 335},
  [6607] = {.lex_state = 194},
  [6608] = {.lex_state = 335},
  [6609] = {.lex_state = 203},
  [6610] = {.lex_state = 236},
  [6611] = {.lex_state = 0},
  [6612] = {.lex_state = 108},
  [6613] = {.lex_state = 335},
  [6614] = {.lex_state = 335},
  [6615] = {.lex_state = 108},
  [6616] = {.lex_state = 110},
  [6617] = {.lex_state = 203},
  [6618] = {.lex_state = 236},
  [6619] = {.lex_state = 0},
  [6620] = {.lex_state = 173},
  [6621] = {.lex_state = 203},
  [6622] = {.lex_state = 335},
  [6623] = {.lex_state = 335},
  [6624] = {.lex_state = 203},
  [6625] = {.lex_state = 335},
  [6626] = {.lex_state = 335},
  [6627] = {.lex_state = 0},
  [6628] = {.lex_state = 203},
  [6629] = {.lex_state = 236},
  [6630] = {.lex_state = 335},
  [6631] = {.lex_state = 173},
  [6632] = {.lex_state = 110},
  [6633] = {.lex_state = 108},
  [6634] = {.lex_state = 194},
  [6635] = {.lex_state = 111},
  [6636] = {.lex_state = 111},
  [6637] = {.lex_state = 194},
  [6638] = {.lex_state = 194},
  [6639] = {.lex_state = 108},
  [6640] = {.lex_state = 108},
  [6641] = {.lex_state = 173},
  [6642] = {.lex_state = 108},
  [6643] = {.lex_state = 0},
  [6644] = {.lex_state = 108},
  [6645] = {.lex_state = 194},
  [6646] = {.lex_state = 335},
  [6647] = {.lex_state = 335},
  [6648] = {.lex_state = 108},
  [6649] = {.lex_state = 108},
  [6650] = {.lex_state = 194},
  [6651] = {.lex_state = 0},
  [6652] = {.lex_state = 108},
  [6653] = {.lex_state = 108},
  [6654] = {.lex_state = 203},
  [6655] = {.lex_state = 203},
  [6656] = {.lex_state = 110},
  [6657] = {.lex_state = 0},
  [6658] = {.lex_state = 108},
  [6659] = {.lex_state = 194},
  [6660] = {.lex_state = 0},
  [6661] = {.lex_state = 236},
  [6662] = {.lex_state = 173},
  [6663] = {.lex_state = 108},
  [6664] = {.lex_state = 108},
  [6665] = {.lex_state = 194},
  [6666] = {.lex_state = 108},
  [6667] = {.lex_state = 111},
  [6668] = {.lex_state = 203},
  [6669] = {.lex_state = 335},
  [6670] = {.lex_state = 194},
  [6671] = {.lex_state = 0},
  [6672] = {.lex_state = 108},
  [6673] = {.lex_state = 203},
  [6674] = {.lex_state = 335},
  [6675] = {.lex_state = 335},
  [6676] = {.lex_state = 0},
  [6677] = {.lex_state = 108},
  [6678] = {.lex_state = 203},
  [6679] = {.lex_state = 194},
  [6680] = {.lex_state = 194},
  [6681] = {.lex_state = 0},
  [6682] = {.lex_state = 203},
  [6683] = {.lex_state = 110},
  [6684] = {.lex_state = 108},
  [6685] = {.lex_state = 203},
  [6686] = {.lex_state = 194},
  [6687] = {.lex_state = 335},
  [6688] = {.lex_state = 108},
  [6689] = {.lex_state = 108},
  [6690] = {.lex_state = 0},
  [6691] = {.lex_state = 203},
  [6692] = {.lex_state = 236},
  [6693] = {.lex_state = 108},
  [6694] = {.lex_state = 110},
  [6695] = {.lex_state = 203},
  [6696] = {.lex_state = 203},
  [6697] = {.lex_state = 0},
  [6698] = {.lex_state = 173},
  [6699] = {.lex_state = 194},
  [6700] = {.lex_state = 194},
  [6701] = {.lex_state = 194},
  [6702] = {.lex_state = 194},
  [6703] = {.lex_state = 108},
  [6704] = {.lex_state = 173},
  [6705] = {.lex_state = 194},
  [6706] = {.lex_state = 236},
  [6707] = {.lex_state = 194},
  [6708] = {.lex_state = 0},
  [6709] = {.lex_state = 194},
  [6710] = {.lex_state = 108},
  [6711] = {.lex_state = 203},
  [6712] = {.lex_state = 203},
  [6713] = {.lex_state = 203},
  [6714] = {.lex_state = 111},
  [6715] = {.lex_state = 108},
  [6716] = {.lex_state = 111},
  [6717] = {.lex_state = 110},
  [6718] = {.lex_state = 173},
  [6719] = {.lex_state = 203},
  [6720] = {.lex_state = 335},
  [6721] = {.lex_state = 194},
  [6722] = {.lex_state = 108},
  [6723] = {.lex_state = 335},
  [6724] = {.lex_state = 236},
  [6725] = {.lex_state = 203},
  [6726] = {.lex_state = 335},
  [6727] = {.lex_state = 194},
  [6728] = {.lex_state = 108},
  [6729] = {.lex_state = 335},
  [6730] = {.lex_state = 173},
  [6731] = {.lex_state = 173},
  [6732] = {.lex_state = 203},
  [6733] = {.lex_state = 108},
  [6734] = {.lex_state = 194},
  [6735] = {.lex_state = 203},
  [6736] = {.lex_state = 173},
  [6737] = {.lex_state = 110},
  [6738] = {.lex_state = 108},
  [6739] = {.lex_state = 0},
  [6740] = {.lex_state = 194},
  [6741] = {.lex_state = 203},
  [6742] = {.lex_state = 335},
  [6743] = {.lex_state = 194},
  [6744] = {.lex_state = 173},
  [6745] = {.lex_state = 173},
  [6746] = {.lex_state = 214},
  [6747] = {.lex_state = 335},
  [6748] = {.lex_state = 194},
  [6749] = {.lex_state = 203},
  [6750] = {.lex_state = 108},
  [6751] = {.lex_state = 110},
  [6752] = {.lex_state = 0},
  [6753] = {.lex_state = 173},
  [6754] = {.lex_state = 203},
  [6755] = {.lex_state = 203},
  [6756] = {.lex_state = 194},
  [6757] = {.lex_state = 335},
  [6758] = {.lex_state = 173},
  [6759] = {.lex_state = 335},
  [6760] = {.lex_state = 194},
  [6761] = {.lex_state = 173},
  [6762] = {.lex_state = 108},
  [6763] = {.lex_state = 173},
  [6764] = {.lex_state = 173},
  [6765] = {.lex_state = 108},
  [6766] = {.lex_state = 335},
  [6767] = {.lex_state = 335},
  [6768] = {.lex_state = 335},
  [6769] = {.lex_state = 173},
  [6770] = {.lex_state = 335},
  [6771] = {.lex_state = 335},
  [6772] = {.lex_state = 335},
  [6773] = {.lex_state = 194},
  [6774] = {.lex_state = 203},
  [6775] = {.lex_state = 194},
  [6776] = {.lex_state = 173},
  [6777] = {.lex_state = 194},
  [6778] = {.lex_state = 194},
  [6779] = {.lex_state = 335},
  [6780] = {.lex_state = 0},
  [6781] = {.lex_state = 173},
  [6782] = {.lex_state = 110},
  [6783] = {.lex_state = 335},
  [6784] = {.lex_state = 0},
  [6785] = {.lex_state = 335},
  [6786] = {.lex_state = 203},
  [6787] = {.lex_state = 108},
  [6788] = {.lex_state = 108},
  [6789] = {.lex_state = 108},
  [6790] = {.lex_state = 194},
  [6791] = {.lex_state = 173},
  [6792] = {.lex_state = 335},
  [6793] = {.lex_state = 110},
  [6794] = {.lex_state = 0},
  [6795] = {.lex_state = 108},
  [6796] = {.lex_state = 110},
  [6797] = {.lex_state = 203},
  [6798] = {.lex_state = 110},
  [6799] = {.lex_state = 335},
  [6800] = {.lex_state = 194},
  [6801] = {.lex_state = 236},
  [6802] = {.lex_state = 173},
  [6803] = {.lex_state = 108},
  [6804] = {.lex_state = 203},
  [6805] = {.lex_state = 108},
  [6806] = {.lex_state = 194},
  [6807] = {.lex_state = 194},
  [6808] = {.lex_state = 108},
  [6809] = {.lex_state = 335},
  [6810] = {.lex_state = 203},
  [6811] = {.lex_state = 203},
  [6812] = {.lex_state = 194},
  [6813] = {.lex_state = 203},
  [6814] = {.lex_state = 194},
  [6815] = {.lex_state = 335},
  [6816] = {.lex_state = 194},
  [6817] = {.lex_state = 194},
  [6818] = {.lex_state = 173},
  [6819] = {.lex_state = 203},
  [6820] = {.lex_state = 194},
  [6821] = {.lex_state = 173},
  [6822] = {.lex_state = 194},
  [6823] = {.lex_state = 194},
  [6824] = {.lex_state = 194},
  [6825] = {.lex_state = 203},
  [6826] = {.lex_state = 194},
  [6827] = {.lex_state = 173},
  [6828] = {.lex_state = 173},
  [6829] = {.lex_state = 0},
  [6830] = {.lex_state = 194},
  [6831] = {.lex_state = 335},
  [6832] = {.lex_state = 236},
  [6833] = {.lex_state = 194},
  [6834] = {.lex_state = 0},
  [6835] = {.lex_state = 194},
  [6836] = {.lex_state = 203},
  [6837] = {.lex_state = 335},
  [6838] = {.lex_state = 173},
  [6839] = {.lex_state = 111},
  [6840] = {.lex_state = 194},
  [6841] = {.lex_state = 335},
  [6842] = {.lex_state = 173},
  [6843] = {.lex_state = 0},
  [6844] = {.lex_state = 335},
  [6845] = {.lex_state = 203},
  [6846] = {.lex_state = 335},
  [6847] = {.lex_state = 194},
  [6848] = {.lex_state = 335},
  [6849] = {.lex_state = 335},
  [6850] = {.lex_state = 335},
  [6851] = {.lex_state = 173},
  [6852] = {.lex_state = 108},
  [6853] = {.lex_state = 335},
  [6854] = {.lex_state = 110},
  [6855] = {.lex_state = 203},
  [6856] = {.lex_state = 335},
  [6857] = {.lex_state = 173},
  [6858] = {.lex_state = 111},
  [6859] = {.lex_state = 0},
  [6860] = {.lex_state = 173},
  [6861] = {.lex_state = 203},
  [6862] = {.lex_state = 0},
  [6863] = {.lex_state = 194},
  [6864] = {.lex_state = 0},
  [6865] = {.lex_state = 203},
  [6866] = {.lex_state = 0},
  [6867] = {.lex_state = 0},
  [6868] = {.lex_state = 110},
  [6869] = {.lex_state = 194},
  [6870] = {.lex_state = 0},
  [6871] = {.lex_state = 335},
  [6872] = {.lex_state = 335},
  [6873] = {.lex_state = 0},
  [6874] = {.lex_state = 0},
  [6875] = {.lex_state = 194},
  [6876] = {.lex_state = 0},
  [6877] = {.lex_state = 0},
  [6878] = {.lex_state = 0},
  [6879] = {.lex_state = 0},
  [6880] = {.lex_state = 0},
  [6881] = {.lex_state = 194},
  [6882] = {.lex_state = 194},
  [6883] = {.lex_state = 173},
  [6884] = {.lex_state = 0},
  [6885] = {.lex_state = 0},
  [6886] = {.lex_state = 173},
  [6887] = {.lex_state = 203},
  [6888] = {.lex_state = 0},
  [6889] = {.lex_state = 0},
  [6890] = {.lex_state = 203},
  [6891] = {.lex_state = 0},
  [6892] = {.lex_state = 194},
  [6893] = {.lex_state = 0},
  [6894] = {.lex_state = 203},
  [6895] = {.lex_state = 0},
  [6896] = {.lex_state = 0},
  [6897] = {.lex_state = 113},
  [6898] = {.lex_state = 335},
  [6899] = {.lex_state = 0},
  [6900] = {.lex_state = 0},
  [6901] = {.lex_state = 335},
  [6902] = {.lex_state = 0},
  [6903] = {.lex_state = 0},
  [6904] = {.lex_state = 203},
  [6905] = {.lex_state = 0},
  [6906] = {.lex_state = 0},
  [6907] = {.lex_state = 0},
  [6908] = {.lex_state = 203},
  [6909] = {.lex_state = 194},
  [6910] = {.lex_state = 0},
  [6911] = {.lex_state = 0},
  [6912] = {.lex_state = 203},
  [6913] = {.lex_state = 203},
  [6914] = {.lex_state = 0},
  [6915] = {.lex_state = 0},
  [6916] = {.lex_state = 0},
  [6917] = {.lex_state = 0},
  [6918] = {.lex_state = 0},
  [6919] = {.lex_state = 0},
  [6920] = {.lex_state = 194},
  [6921] = {.lex_state = 0},
  [6922] = {.lex_state = 194},
  [6923] = {.lex_state = 0},
  [6924] = {.lex_state = 0},
  [6925] = {.lex_state = 194},
  [6926] = {.lex_state = 0},
  [6927] = {.lex_state = 0},
  [6928] = {.lex_state = 0},
  [6929] = {.lex_state = 0},
  [6930] = {.lex_state = 0},
  [6931] = {.lex_state = 335},
  [6932] = {.lex_state = 203},
  [6933] = {.lex_state = 203},
  [6934] = {.lex_state = 0},
  [6935] = {.lex_state = 110},
  [6936] = {.lex_state = 0},
  [6937] = {.lex_state = 0},
  [6938] = {.lex_state = 0},
  [6939] = {.lex_state = 203},
  [6940] = {.lex_state = 0},
  [6941] = {.lex_state = 0},
  [6942] = {.lex_state = 194},
  [6943] = {.lex_state = 0},
  [6944] = {.lex_state = 0},
  [6945] = {.lex_state = 0},
  [6946] = {.lex_state = 0},
  [6947] = {.lex_state = 0},
  [6948] = {.lex_state = 0},
  [6949] = {.lex_state = 203},
  [6950] = {.lex_state = 203},
  [6951] = {.lex_state = 0},
  [6952] = {.lex_state = 203},
  [6953] = {.lex_state = 203},
  [6954] = {.lex_state = 0},
  [6955] = {.lex_state = 0},
  [6956] = {.lex_state = 0},
  [6957] = {.lex_state = 0},
  [6958] = {.lex_state = 162},
  [6959] = {.lex_state = 113},
  [6960] = {.lex_state = 0},
  [6961] = {.lex_state = 203},
  [6962] = {.lex_state = 0},
  [6963] = {.lex_state = 194},
  [6964] = {.lex_state = 0},
  [6965] = {.lex_state = 0},
  [6966] = {.lex_state = 0},
  [6967] = {.lex_state = 203},
  [6968] = {.lex_state = 203},
  [6969] = {.lex_state = 0},
  [6970] = {.lex_state = 0},
  [6971] = {.lex_state = 194},
  [6972] = {.lex_state = 0},
  [6973] = {.lex_state = 194},
  [6974] = {.lex_state = 0},
  [6975] = {.lex_state = 0},
  [6976] = {.lex_state = 110},
  [6977] = {.lex_state = 0},
  [6978] = {.lex_state = 0},
  [6979] = {.lex_state = 0},
  [6980] = {.lex_state = 0},
  [6981] = {.lex_state = 194},
  [6982] = {.lex_state = 194},
  [6983] = {.lex_state = 0},
  [6984] = {.lex_state = 335},
  [6985] = {.lex_state = 0},
  [6986] = {.lex_state = 0},
  [6987] = {.lex_state = 203},
  [6988] = {.lex_state = 335},
  [6989] = {.lex_state = 0},
  [6990] = {.lex_state = 203},
  [6991] = {.lex_state = 203},
  [6992] = {.lex_state = 203},
  [6993] = {.lex_state = 203},
  [6994] = {.lex_state = 0},
  [6995] = {.lex_state = 194},
  [6996] = {.lex_state = 194},
  [6997] = {.lex_state = 0},
  [6998] = {.lex_state = 0},
  [6999] = {.lex_state = 203},
  [7000] = {.lex_state = 203},
  [7001] = {.lex_state = 0},
  [7002] = {.lex_state = 0},
  [7003] = {.lex_state = 203},
  [7004] = {.lex_state = 0},
  [7005] = {.lex_state = 0},
  [7006] = {.lex_state = 0},
  [7007] = {.lex_state = 0},
  [7008] = {.lex_state = 203},
  [7009] = {.lex_state = 0},
  [7010] = {.lex_state = 0},
  [7011] = {.lex_state = 203},
  [7012] = {.lex_state = 0},
  [7013] = {.lex_state = 0},
  [7014] = {.lex_state = 0},
  [7015] = {.lex_state = 0},
  [7016] = {.lex_state = 0},
  [7017] = {.lex_state = 0},
  [7018] = {.lex_state = 0},
  [7019] = {.lex_state = 194},
  [7020] = {.lex_state = 0},
  [7021] = {.lex_state = 0},
  [7022] = {.lex_state = 0},
  [7023] = {.lex_state = 0},
  [7024] = {.lex_state = 0},
  [7025] = {.lex_state = 0},
  [7026] = {.lex_state = 203},
  [7027] = {.lex_state = 194},
  [7028] = {.lex_state = 0},
  [7029] = {.lex_state = 0},
  [7030] = {.lex_state = 0},
  [7031] = {.lex_state = 0},
  [7032] = {.lex_state = 0},
  [7033] = {.lex_state = 0},
  [7034] = {.lex_state = 214},
  [7035] = {.lex_state = 335},
  [7036] = {.lex_state = 113},
  [7037] = {.lex_state = 0},
  [7038] = {.lex_state = 203},
  [7039] = {.lex_state = 0},
  [7040] = {.lex_state = 0},
  [7041] = {.lex_state = 194},
  [7042] = {.lex_state = 0},
  [7043] = {.lex_state = 0},
  [7044] = {.lex_state = 0},
  [7045] = {.lex_state = 203},
  [7046] = {.lex_state = 0},
  [7047] = {.lex_state = 194},
  [7048] = {.lex_state = 203},
  [7049] = {.lex_state = 203},
  [7050] = {.lex_state = 0},
  [7051] = {.lex_state = 0},
  [7052] = {.lex_state = 0},
  [7053] = {.lex_state = 194},
  [7054] = {.lex_state = 203},
  [7055] = {.lex_state = 0},
  [7056] = {.lex_state = 194},
  [7057] = {.lex_state = 0},
  [7058] = {.lex_state = 0},
  [7059] = {.lex_state = 203},
  [7060] = {.lex_state = 203},
  [7061] = {.lex_state = 110},
  [7062] = {.lex_state = 335},
  [7063] = {.lex_state = 194},
  [7064] = {.lex_state = 0},
  [7065] = {.lex_state = 0},
  [7066] = {.lex_state = 335},
  [7067] = {.lex_state = 203},
  [7068] = {.lex_state = 194},
  [7069] = {.lex_state = 0},
  [7070] = {.lex_state = 194},
  [7071] = {.lex_state = 0},
  [7072] = {.lex_state = 0},
  [7073] = {.lex_state = 194},
  [7074] = {.lex_state = 335},
  [7075] = {.lex_state = 0},
  [7076] = {.lex_state = 0},
  [7077] = {.lex_state = 0},
  [7078] = {.lex_state = 194},
  [7079] = {.lex_state = 194},
  [7080] = {.lex_state = 0},
  [7081] = {.lex_state = 0},
  [7082] = {.lex_state = 0},
  [7083] = {.lex_state = 0},
  [7084] = {.lex_state = 203},
  [7085] = {.lex_state = 0},
  [7086] = {.lex_state = 0},
  [7087] = {.lex_state = 203},
  [7088] = {.lex_state = 0},
  [7089] = {.lex_state = 335},
  [7090] = {.lex_state = 203},
  [7091] = {.lex_state = 203},
  [7092] = {.lex_state = 194},
  [7093] = {.lex_state = 0},
  [7094] = {.lex_state = 203},
  [7095] = {.lex_state = 335},
  [7096] = {.lex_state = 0},
  [7097] = {.lex_state = 0},
  [7098] = {.lex_state = 0},
  [7099] = {.lex_state = 0},
  [7100] = {.lex_state = 194},
  [7101] = {.lex_state = 194},
  [7102] = {.lex_state = 0},
  [7103] = {.lex_state = 0},
  [7104] = {.lex_state = 110},
  [7105] = {.lex_state = 0},
  [7106] = {.lex_state = 0},
  [7107] = {.lex_state = 0},
  [7108] = {.lex_state = 0},
  [7109] = {.lex_state = 0},
  [7110] = {.lex_state = 335},
  [7111] = {.lex_state = 0},
  [7112] = {.lex_state = 194},
  [7113] = {.lex_state = 0},
  [7114] = {.lex_state = 194},
  [7115] = {.lex_state = 0},
  [7116] = {.lex_state = 0},
  [7117] = {.lex_state = 0},
  [7118] = {.lex_state = 194},
  [7119] = {.lex_state = 194},
  [7120] = {.lex_state = 0},
  [7121] = {.lex_state = 0},
  [7122] = {.lex_state = 0},
  [7123] = {.lex_state = 194},
  [7124] = {.lex_state = 0},
  [7125] = {.lex_state = 194},
  [7126] = {.lex_state = 0},
  [7127] = {.lex_state = 0},
  [7128] = {.lex_state = 113},
  [7129] = {.lex_state = 0},
  [7130] = {.lex_state = 0},
  [7131] = {.lex_state = 0},
  [7132] = {.lex_state = 0},
  [7133] = {.lex_state = 203},
  [7134] = {.lex_state = 335},
  [7135] = {.lex_state = 203},
  [7136] = {.lex_state = 194},
  [7137] = {.lex_state = 0},
  [7138] = {.lex_state = 0},
  [7139] = {.lex_state = 0},
  [7140] = {.lex_state = 0},
  [7141] = {.lex_state = 0},
  [7142] = {.lex_state = 194},
  [7143] = {.lex_state = 0},
  [7144] = {.lex_state = 194},
  [7145] = {.lex_state = 203},
  [7146] = {.lex_state = 194},
  [7147] = {.lex_state = 194},
  [7148] = {.lex_state = 335},
  [7149] = {.lex_state = 203},
  [7150] = {.lex_state = 0},
  [7151] = {.lex_state = 0},
  [7152] = {.lex_state = 0},
  [7153] = {.lex_state = 0},
  [7154] = {.lex_state = 0},
  [7155] = {.lex_state = 203},
  [7156] = {.lex_state = 0},
  [7157] = {.lex_state = 0},
  [7158] = {.lex_state = 194},
  [7159] = {.lex_state = 203},
  [7160] = {.lex_state = 203},
  [7161] = {.lex_state = 0},
  [7162] = {.lex_state = 203},
  [7163] = {.lex_state = 0},
  [7164] = {.lex_state = 0},
  [7165] = {.lex_state = 203},
  [7166] = {.lex_state = 203},
  [7167] = {.lex_state = 335},
  [7168] = {.lex_state = 194},
  [7169] = {.lex_state = 203},
  [7170] = {.lex_state = 335},
  [7171] = {.lex_state = 0},
  [7172] = {.lex_state = 0},
  [7173] = {.lex_state = 0},
  [7174] = {.lex_state = 0},
  [7175] = {.lex_state = 0},
  [7176] = {.lex_state = 0},
  [7177] = {.lex_state = 203},
  [7178] = {.lex_state = 0},
  [7179] = {.lex_state = 203},
  [7180] = {.lex_state = 203},
  [7181] = {.lex_state = 0},
  [7182] = {.lex_state = 194},
  [7183] = {.lex_state = 194},
  [7184] = {.lex_state = 0},
  [7185] = {.lex_state = 0},
  [7186] = {.lex_state = 0},
  [7187] = {.lex_state = 194},
  [7188] = {.lex_state = 0},
  [7189] = {.lex_state = 194},
  [7190] = {.lex_state = 0},
  [7191] = {.lex_state = 0},
  [7192] = {.lex_state = 0},
  [7193] = {.lex_state = 0},
  [7194] = {.lex_state = 0},
  [7195] = {.lex_state = 0},
  [7196] = {.lex_state = 0},
  [7197] = {.lex_state = 0},
  [7198] = {.lex_state = 0},
  [7199] = {.lex_state = 203},
  [7200] = {.lex_state = 0},
  [7201] = {.lex_state = 335},
  [7202] = {.lex_state = 0},
  [7203] = {.lex_state = 0},
  [7204] = {.lex_state = 110},
  [7205] = {.lex_state = 0},
  [7206] = {.lex_state = 0},
  [7207] = {.lex_state = 0},
  [7208] = {.lex_state = 203},
  [7209] = {.lex_state = 194},
  [7210] = {.lex_state = 0},
  [7211] = {.lex_state = 0},
  [7212] = {.lex_state = 0},
  [7213] = {.lex_state = 0},
  [7214] = {.lex_state = 0},
  [7215] = {.lex_state = 0},
  [7216] = {.lex_state = 0},
  [7217] = {.lex_state = 0},
  [7218] = {.lex_state = 194},
  [7219] = {.lex_state = 203},
  [7220] = {.lex_state = 203},
  [7221] = {.lex_state = 0},
  [7222] = {.lex_state = 0},
  [7223] = {.lex_state = 194},
  [7224] = {.lex_state = 0},
  [7225] = {.lex_state = 0},
  [7226] = {.lex_state = 0},
  [7227] = {.lex_state = 194},
  [7228] = {.lex_state = 203},
  [7229] = {.lex_state = 194},
  [7230] = {.lex_state = 0},
  [7231] = {.lex_state = 0},
  [7232] = {.lex_state = 0},
  [7233] = {.lex_state = 0},
  [7234] = {.lex_state = 0},
  [7235] = {.lex_state = 0},
  [7236] = {.lex_state = 203},
  [7237] = {.lex_state = 0},
  [7238] = {.lex_state = 0},
  [7239] = {.lex_state = 194},
  [7240] = {.lex_state = 335},
  [7241] = {.lex_state = 194},
  [7242] = {.lex_state = 0},
  [7243] = {.lex_state = 194},
  [7244] = {.lex_state = 0},
  [7245] = {.lex_state = 194},
  [7246] = {.lex_state = 0},
  [7247] = {.lex_state = 110},
  [7248] = {.lex_state = 110},
  [7249] = {.lex_state = 110},
  [7250] = {.lex_state = 203},
  [7251] = {.lex_state = 194},
  [7252] = {.lex_state = 110},
  [7253] = {.lex_state = 110},
  [7254] = {.lex_state = 194},
  [7255] = {.lex_state = 110},
  [7256] = {.lex_state = 0},
  [7257] = {.lex_state = 335},
  [7258] = {.lex_state = 335},
  [7259] = {.lex_state = 0},
  [7260] = {.lex_state = 0},
  [7261] = {.lex_state = 335},
  [7262] = {.lex_state = 335},
  [7263] = {.lex_state = 335},
  [7264] = {.lex_state = 335},
  [7265] = {.lex_state = 0},
  [7266] = {.lex_state = 194},
  [7267] = {.lex_state = 335},
  [7268] = {.lex_state = 0},
  [7269] = {.lex_state = 0},
  [7270] = {.lex_state = 0},
  [7271] = {.lex_state = 0},
  [7272] = {.lex_state = 194},
  [7273] = {.lex_state = 335},
  [7274] = {.lex_state = 194},
  [7275] = {.lex_state = 0},
  [7276] = {.lex_state = 335},
  [7277] = {.lex_state = 0},
  [7278] = {.lex_state = 0},
  [7279] = {.lex_state = 194},
  [7280] = {.lex_state = 112},
  [7281] = {.lex_state = 0},
  [7282] = {.lex_state = 0},
  [7283] = {.lex_state = 335},
  [7284] = {.lex_state = 335},
  [7285] = {.lex_state = 0},
  [7286] = {.lex_state = 335},
  [7287] = {.lex_state = 0},
  [7288] = {.lex_state = 0},
  [7289] = {.lex_state = 0},
  [7290] = {.lex_state = 0},
  [7291] = {.lex_state = 0},
  [7292] = {.lex_state = 0},
  [7293] = {.lex_state = 0},
  [7294] = {.lex_state = 335},
  [7295] = {.lex_state = 335},
  [7296] = {.lex_state = 335},
  [7297] = {.lex_state = 0},
  [7298] = {.lex_state = 335},
  [7299] = {.lex_state = 0},
  [7300] = {.lex_state = 0},
  [7301] = {.lex_state = 0},
  [7302] = {.lex_state = 194},
  [7303] = {.lex_state = 0},
  [7304] = {.lex_state = 0},
  [7305] = {.lex_state = 0},
  [7306] = {.lex_state = 335},
  [7307] = {.lex_state = 0},
  [7308] = {.lex_state = 112},
  [7309] = {.lex_state = 0},
  [7310] = {.lex_state = 0},
  [7311] = {.lex_state = 0},
  [7312] = {.lex_state = 0},
  [7313] = {.lex_state = 0},
  [7314] = {.lex_state = 0},
  [7315] = {.lex_state = 335},
  [7316] = {.lex_state = 335},
  [7317] = {.lex_state = 335},
  [7318] = {.lex_state = 0},
  [7319] = {.lex_state = 0},
  [7320] = {.lex_state = 112},
  [7321] = {.lex_state = 0},
  [7322] = {.lex_state = 0},
  [7323] = {.lex_state = 0},
  [7324] = {.lex_state = 0},
  [7325] = {.lex_state = 0},
  [7326] = {.lex_state = 0},
  [7327] = {.lex_state = 335},
  [7328] = {.lex_state = 0},
  [7329] = {.lex_state = 335},
  [7330] = {.lex_state = 0},
  [7331] = {.lex_state = 194},
  [7332] = {.lex_state = 0},
  [7333] = {.lex_state = 0},
  [7334] = {.lex_state = 0},
  [7335] = {.lex_state = 0},
  [7336] = {.lex_state = 0},
  [7337] = {.lex_state = 194},
  [7338] = {.lex_state = 0},
  [7339] = {.lex_state = 112},
  [7340] = {.lex_state = 0},
  [7341] = {.lex_state = 0},
  [7342] = {.lex_state = 0},
  [7343] = {.lex_state = 0},
  [7344] = {.lex_state = 0},
  [7345] = {.lex_state = 335},
  [7346] = {.lex_state = 0},
  [7347] = {.lex_state = 335},
  [7348] = {.lex_state = 0},
  [7349] = {.lex_state = 0},
  [7350] = {.lex_state = 0},
  [7351] = {.lex_state = 335},
  [7352] = {.lex_state = 0},
  [7353] = {.lex_state = 335},
  [7354] = {.lex_state = 0},
  [7355] = {.lex_state = 0},
  [7356] = {.lex_state = 0},
  [7357] = {.lex_state = 0},
  [7358] = {.lex_state = 112},
  [7359] = {.lex_state = 194},
  [7360] = {.lex_state = 0},
  [7361] = {.lex_state = 0},
  [7362] = {.lex_state = 335},
  [7363] = {.lex_state = 335},
  [7364] = {.lex_state = 112},
  [7365] = {.lex_state = 0},
  [7366] = {.lex_state = 0},
  [7367] = {.lex_state = 335},
  [7368] = {.lex_state = 0},
  [7369] = {.lex_state = 335},
  [7370] = {.lex_state = 0},
  [7371] = {.lex_state = 0},
  [7372] = {.lex_state = 0},
  [7373] = {.lex_state = 0},
  [7374] = {.lex_state = 0},
  [7375] = {.lex_state = 194},
  [7376] = {.lex_state = 0},
  [7377] = {.lex_state = 0},
  [7378] = {.lex_state = 0},
  [7379] = {.lex_state = 0},
  [7380] = {.lex_state = 335},
  [7381] = {.lex_state = 0},
  [7382] = {.lex_state = 0},
  [7383] = {.lex_state = 194},
  [7384] = {.lex_state = 335},
  [7385] = {.lex_state = 0},
  [7386] = {.lex_state = 0},
  [7387] = {.lex_state = 0},
  [7388] = {.lex_state = 335},
  [7389] = {.lex_state = 0},
  [7390] = {.lex_state = 0},
  [7391] = {.lex_state = 335},
  [7392] = {.lex_state = 0},
  [7393] = {.lex_state = 0},
  [7394] = {.lex_state = 0},
  [7395] = {.lex_state = 0},
  [7396] = {.lex_state = 0},
  [7397] = {.lex_state = 0},
  [7398] = {.lex_state = 0},
  [7399] = {.lex_state = 0},
  [7400] = {.lex_state = 0},
  [7401] = {.lex_state = 0},
  [7402] = {.lex_state = 335},
  [7403] = {.lex_state = 0},
  [7404] = {.lex_state = 335},
  [7405] = {.lex_state = 0},
  [7406] = {.lex_state = 335},
  [7407] = {.lex_state = 0},
  [7408] = {.lex_state = 0},
  [7409] = {.lex_state = 0},
  [7410] = {.lex_state = 0},
  [7411] = {.lex_state = 335},
  [7412] = {.lex_state = 0},
  [7413] = {.lex_state = 335},
  [7414] = {.lex_state = 112},
  [7415] = {.lex_state = 194},
  [7416] = {.lex_state = 0},
  [7417] = {.lex_state = 0},
  [7418] = {.lex_state = 335},
  [7419] = {.lex_state = 0},
  [7420] = {.lex_state = 0},
  [7421] = {.lex_state = 0},
  [7422] = {.lex_state = 0},
  [7423] = {.lex_state = 112},
  [7424] = {.lex_state = 335},
  [7425] = {.lex_state = 194},
  [7426] = {.lex_state = 0},
  [7427] = {.lex_state = 335},
  [7428] = {.lex_state = 335},
  [7429] = {.lex_state = 194},
  [7430] = {.lex_state = 0},
  [7431] = {.lex_state = 335},
  [7432] = {.lex_state = 0},
  [7433] = {.lex_state = 335},
  [7434] = {.lex_state = 0},
  [7435] = {.lex_state = 194},
  [7436] = {.lex_state = 335},
  [7437] = {.lex_state = 335},
  [7438] = {.lex_state = 0},
  [7439] = {.lex_state = 335},
  [7440] = {.lex_state = 112},
  [7441] = {.lex_state = 0},
  [7442] = {.lex_state = 0},
  [7443] = {.lex_state = 335},
  [7444] = {.lex_state = 112},
  [7445] = {.lex_state = 112},
  [7446] = {.lex_state = 0},
  [7447] = {.lex_state = 0},
  [7448] = {.lex_state = 0},
  [7449] = {.lex_state = 0},
  [7450] = {.lex_state = 0},
  [7451] = {.lex_state = 335},
  [7452] = {.lex_state = 0},
  [7453] = {.lex_state = 0},
  [7454] = {.lex_state = 335},
  [7455] = {.lex_state = 112},
  [7456] = {.lex_state = 0},
  [7457] = {.lex_state = 0},
  [7458] = {.lex_state = 112},
  [7459] = {.lex_state = 194},
  [7460] = {.lex_state = 0},
  [7461] = {.lex_state = 112},
  [7462] = {.lex_state = 0},
  [7463] = {.lex_state = 0},
  [7464] = {.lex_state = 0},
  [7465] = {.lex_state = 0},
  [7466] = {.lex_state = 0},
  [7467] = {.lex_state = 194},
  [7468] = {.lex_state = 0},
  [7469] = {.lex_state = 0},
  [7470] = {.lex_state = 0},
  [7471] = {.lex_state = 0},
  [7472] = {.lex_state = 335},
  [7473] = {.lex_state = 0},
  [7474] = {.lex_state = 335},
  [7475] = {.lex_state = 335},
  [7476] = {.lex_state = 335},
  [7477] = {.lex_state = 0},
  [7478] = {.lex_state = 194},
  [7479] = {.lex_state = 0},
  [7480] = {.lex_state = 335},
  [7481] = {.lex_state = 335},
  [7482] = {.lex_state = 0},
  [7483] = {.lex_state = 335, .external_lex_state = 2},
  [7484] = {.lex_state = 0},
  [7485] = {.lex_state = 0},
  [7486] = {.lex_state = 0},
  [7487] = {.lex_state = 0},
  [7488] = {.lex_state = 0},
  [7489] = {.lex_state = 0},
  [7490] = {.lex_state = 194},
  [7491] = {.lex_state = 0},
  [7492] = {.lex_state = 335},
  [7493] = {.lex_state = 194},
  [7494] = {.lex_state = 335},
  [7495] = {.lex_state = 194},
  [7496] = {.lex_state = 0},
  [7497] = {.lex_state = 0},
  [7498] = {.lex_state = 194},
  [7499] = {.lex_state = 0},
  [7500] = {.lex_state = 194},
  [7501] = {.lex_state = 194},
  [7502] = {.lex_state = 194},
  [7503] = {.lex_state = 194},
  [7504] = {.lex_state = 0},
  [7505] = {.lex_state = 0},
  [7506] = {.lex_state = 0},
  [7507] = {.lex_state = 0},
  [7508] = {.lex_state = 335},
  [7509] = {.lex_state = 0},
  [7510] = {.lex_state = 0},
  [7511] = {.lex_state = 0},
  [7512] = {.lex_state = 194},
  [7513] = {.lex_state = 112},
  [7514] = {.lex_state = 194},
  [7515] = {.lex_state = 0},
  [7516] = {.lex_state = 335, .external_lex_state = 2},
  [7517] = {.lex_state = 0},
  [7518] = {.lex_state = 0},
  [7519] = {.lex_state = 0},
  [7520] = {.lex_state = 0},
  [7521] = {.lex_state = 335, .external_lex_state = 2},
  [7522] = {.lex_state = 194},
  [7523] = {.lex_state = 335},
  [7524] = {.lex_state = 0},
  [7525] = {.lex_state = 0},
  [7526] = {.lex_state = 335},
  [7527] = {.lex_state = 0},
  [7528] = {.lex_state = 335, .external_lex_state = 2},
  [7529] = {.lex_state = 335},
  [7530] = {.lex_state = 0},
  [7531] = {.lex_state = 0},
  [7532] = {.lex_state = 335},
  [7533] = {.lex_state = 194},
  [7534] = {.lex_state = 335, .external_lex_state = 2},
  [7535] = {.lex_state = 0},
  [7536] = {.lex_state = 335},
  [7537] = {.lex_state = 0},
  [7538] = {.lex_state = 0},
  [7539] = {.lex_state = 112},
  [7540] = {.lex_state = 194},
  [7541] = {.lex_state = 0},
  [7542] = {.lex_state = 0},
  [7543] = {.lex_state = 335, .external_lex_state = 2},
  [7544] = {.lex_state = 0},
  [7545] = {.lex_state = 335},
  [7546] = {.lex_state = 0},
  [7547] = {.lex_state = 0},
  [7548] = {.lex_state = 0},
  [7549] = {.lex_state = 0},
  [7550] = {.lex_state = 194},
  [7551] = {.lex_state = 335, .external_lex_state = 2},
  [7552] = {.lex_state = 335},
  [7553] = {.lex_state = 335, .external_lex_state = 2},
  [7554] = {.lex_state = 335},
  [7555] = {.lex_state = 0},
  [7556] = {.lex_state = 335},
  [7557] = {.lex_state = 0},
  [7558] = {.lex_state = 0},
  [7559] = {.lex_state = 0},
  [7560] = {.lex_state = 335, .external_lex_state = 2},
  [7561] = {.lex_state = 194},
  [7562] = {.lex_state = 0},
  [7563] = {.lex_state = 0},
  [7564] = {.lex_state = 0},
  [7565] = {.lex_state = 0},
  [7566] = {.lex_state = 335, .external_lex_state = 2},
  [7567] = {.lex_state = 0},
  [7568] = {.lex_state = 335},
  [7569] = {.lex_state = 0},
  [7570] = {.lex_state = 335, .external_lex_state = 2},
  [7571] = {.lex_state = 335, .external_lex_state = 2},
  [7572] = {.lex_state = 335, .external_lex_state = 2},
  [7573] = {.lex_state = 335, .external_lex_state = 2},
  [7574] = {.lex_state = 0},
  [7575] = {.lex_state = 335, .external_lex_state = 2},
  [7576] = {.lex_state = 194},
  [7577] = {.lex_state = 335, .external_lex_state = 2},
  [7578] = {.lex_state = 335, .external_lex_state = 2},
  [7579] = {.lex_state = 335},
  [7580] = {.lex_state = 335},
  [7581] = {.lex_state = 335},
  [7582] = {.lex_state = 0},
  [7583] = {.lex_state = 194},
  [7584] = {.lex_state = 0},
  [7585] = {.lex_state = 194},
  [7586] = {.lex_state = 0},
  [7587] = {.lex_state = 194},
  [7588] = {.lex_state = 0},
  [7589] = {.lex_state = 194},
  [7590] = {.lex_state = 194},
  [7591] = {.lex_state = 0},
  [7592] = {.lex_state = 335},
  [7593] = {.lex_state = 194},
  [7594] = {.lex_state = 112},
  [7595] = {.lex_state = 335},
  [7596] = {.lex_state = 0},
  [7597] = {.lex_state = 0},
  [7598] = {.lex_state = 0},
  [7599] = {.lex_state = 0},
  [7600] = {.lex_state = 0},
  [7601] = {.lex_state = 0},
  [7602] = {.lex_state = 0},
  [7603] = {.lex_state = 0},
  [7604] = {.lex_state = 0},
  [7605] = {.lex_state = 194},
  [7606] = {.lex_state = 194},
  [7607] = {.lex_state = 0},
  [7608] = {.lex_state = 194},
  [7609] = {.lex_state = 0},
  [7610] = {.lex_state = 0, .external_lex_state = 3},
  [7611] = {.lex_state = 0},
  [7612] = {.lex_state = 335},
  [7613] = {.lex_state = 0},
  [7614] = {.lex_state = 0},
  [7615] = {.lex_state = 0},
  [7616] = {.lex_state = 0},
  [7617] = {.lex_state = 113},
  [7618] = {.lex_state = 335},
  [7619] = {.lex_state = 0},
  [7620] = {.lex_state = 335},
  [7621] = {.lex_state = 171},
  [7622] = {.lex_state = 0},
  [7623] = {.lex_state = 0},
  [7624] = {.lex_state = 194},
  [7625] = {.lex_state = 0},
  [7626] = {.lex_state = 0},
  [7627] = {.lex_state = 0},
  [7628] = {.lex_state = 194},
  [7629] = {.lex_state = 194},
  [7630] = {.lex_state = 0},
  [7631] = {.lex_state = 0},
  [7632] = {.lex_state = 194},
  [7633] = {.lex_state = 0},
  [7634] = {.lex_state = 171},
  [7635] = {.lex_state = 0},
  [7636] = {.lex_state = 113},
  [7637] = {.lex_state = 171},
  [7638] = {.lex_state = 171},
  [7639] = {.lex_state = 171},
  [7640] = {.lex_state = 0},
  [7641] = {.lex_state = 0},
  [7642] = {.lex_state = 0},
  [7643] = {.lex_state = 171},
  [7644] = {.lex_state = 0},
  [7645] = {.lex_state = 0},
  [7646] = {.lex_state = 0},
  [7647] = {.lex_state = 194},
  [7648] = {.lex_state = 194},
  [7649] = {.lex_state = 0},
  [7650] = {.lex_state = 194},
  [7651] = {.lex_state = 0},
  [7652] = {.lex_state = 0},
  [7653] = {.lex_state = 0},
  [7654] = {.lex_state = 0},
  [7655] = {.lex_state = 0, .external_lex_state = 2},
  [7656] = {.lex_state = 203},
  [7657] = {.lex_state = 0},
  [7658] = {.lex_state = 0},
  [7659] = {.lex_state = 203},
  [7660] = {.lex_state = 194},
  [7661] = {.lex_state = 0},
  [7662] = {.lex_state = 171},
  [7663] = {.lex_state = 0},
  [7664] = {.lex_state = 113},
  [7665] = {.lex_state = 194},
  [7666] = {.lex_state = 0},
  [7667] = {.lex_state = 0},
  [7668] = {.lex_state = 0},
  [7669] = {.lex_state = 194},
  [7670] = {.lex_state = 0},
  [7671] = {.lex_state = 171},
  [7672] = {.lex_state = 0},
  [7673] = {.lex_state = 0},
  [7674] = {.lex_state = 0},
  [7675] = {.lex_state = 0},
  [7676] = {.lex_state = 0},
  [7677] = {.lex_state = 0},
  [7678] = {.lex_state = 0},
  [7679] = {.lex_state = 0},
  [7680] = {.lex_state = 194},
  [7681] = {.lex_state = 194},
  [7682] = {.lex_state = 0},
  [7683] = {.lex_state = 0},
  [7684] = {.lex_state = 335},
  [7685] = {.lex_state = 0},
  [7686] = {.lex_state = 0},
  [7687] = {.lex_state = 171},
  [7688] = {.lex_state = 0},
  [7689] = {.lex_state = 0},
  [7690] = {.lex_state = 194},
  [7691] = {.lex_state = 0},
  [7692] = {.lex_state = 0},
  [7693] = {.lex_state = 0},
  [7694] = {.lex_state = 113},
  [7695] = {.lex_state = 113},
  [7696] = {.lex_state = 0},
  [7697] = {.lex_state = 335},
  [7698] = {.lex_state = 0},
  [7699] = {.lex_state = 171},
  [7700] = {.lex_state = 0},
  [7701] = {.lex_state = 0},
  [7702] = {.lex_state = 0},
  [7703] = {.lex_state = 0},
  [7704] = {.lex_state = 0},
  [7705] = {.lex_state = 0},
  [7706] = {.lex_state = 0},
  [7707] = {.lex_state = 0},
  [7708] = {.lex_state = 0},
  [7709] = {.lex_state = 0},
  [7710] = {.lex_state = 0},
  [7711] = {.lex_state = 0},
  [7712] = {.lex_state = 194},
  [7713] = {.lex_state = 0},
  [7714] = {.lex_state = 0},
  [7715] = {.lex_state = 171},
  [7716] = {.lex_state = 203},
  [7717] = {.lex_state = 335},
  [7718] = {.lex_state = 0},
  [7719] = {.lex_state = 0},
  [7720] = {.lex_state = 203},
  [7721] = {.lex_state = 113},
  [7722] = {.lex_state = 0},
  [7723] = {.lex_state = 194},
  [7724] = {.lex_state = 0},
  [7725] = {.lex_state = 0},
  [7726] = {.lex_state = 0},
  [7727] = {.lex_state = 194},
  [7728] = {.lex_state = 0},
  [7729] = {.lex_state = 171},
  [7730] = {.lex_state = 0},
  [7731] = {.lex_state = 0},
  [7732] = {.lex_state = 0},
  [7733] = {.lex_state = 0},
  [7734] = {.lex_state = 0},
  [7735] = {.lex_state = 0},
  [7736] = {.lex_state = 0},
  [7737] = {.lex_state = 171},
  [7738] = {.lex_state = 171},
  [7739] = {.lex_state = 171},
  [7740] = {.lex_state = 113},
  [7741] = {.lex_state = 0},
  [7742] = {.lex_state = 0},
  [7743] = {.lex_state = 0},
  [7744] = {.lex_state = 0},
  [7745] = {.lex_state = 0},
  [7746] = {.lex_state = 194},
  [7747] = {.lex_state = 0},
  [7748] = {.lex_state = 0},
  [7749] = {.lex_state = 0},
  [7750] = {.lex_state = 0},
  [7751] = {.lex_state = 0},
  [7752] = {.lex_state = 0, .external_lex_state = 2},
  [7753] = {.lex_state = 194},
  [7754] = {.lex_state = 0},
  [7755] = {.lex_state = 0},
  [7756] = {.lex_state = 0},
  [7757] = {.lex_state = 0},
  [7758] = {.lex_state = 0},
  [7759] = {.lex_state = 203},
  [7760] = {.lex_state = 194},
  [7761] = {.lex_state = 0},
  [7762] = {.lex_state = 0},
  [7763] = {.lex_state = 0, .external_lex_state = 2},
  [7764] = {.lex_state = 0},
  [7765] = {.lex_state = 194},
  [7766] = {.lex_state = 0},
  [7767] = {.lex_state = 171},
  [7768] = {.lex_state = 0},
  [7769] = {.lex_state = 194},
  [7770] = {.lex_state = 113},
  [7771] = {.lex_state = 335},
  [7772] = {.lex_state = 194},
  [7773] = {.lex_state = 171},
  [7774] = {.lex_state = 0},
  [7775] = {.lex_state = 171},
  [7776] = {.lex_state = 0},
  [7777] = {.lex_state = 0},
  [7778] = {.lex_state = 194},
  [7779] = {.lex_state = 194},
  [7780] = {.lex_state = 0},
  [7781] = {.lex_state = 335},
  [7782] = {.lex_state = 0},
  [7783] = {.lex_state = 335},
  [7784] = {.lex_state = 0},
  [7785] = {.lex_state = 335},
  [7786] = {.lex_state = 0},
  [7787] = {.lex_state = 203},
  [7788] = {.lex_state = 0},
  [7789] = {.lex_state = 0},
  [7790] = {.lex_state = 0},
  [7791] = {.lex_state = 203},
  [7792] = {.lex_state = 194},
  [7793] = {.lex_state = 194},
  [7794] = {.lex_state = 0},
  [7795] = {.lex_state = 0},
  [7796] = {.lex_state = 0},
  [7797] = {.lex_state = 0},
  [7798] = {.lex_state = 0},
  [7799] = {.lex_state = 0},
  [7800] = {.lex_state = 0},
  [7801] = {.lex_state = 0},
  [7802] = {.lex_state = 203},
  [7803] = {.lex_state = 0},
  [7804] = {.lex_state = 0},
  [7805] = {.lex_state = 113},
  [7806] = {.lex_state = 0},
  [7807] = {.lex_state = 194},
  [7808] = {.lex_state = 171},
  [7809] = {.lex_state = 335},
  [7810] = {.lex_state = 0},
  [7811] = {.lex_state = 0},
  [7812] = {.lex_state = 0, .external_lex_state = 2},
  [7813] = {.lex_state = 203},
  [7814] = {.lex_state = 194},
  [7815] = {.lex_state = 113},
  [7816] = {.lex_state = 0},
  [7817] = {.lex_state = 0},
  [7818] = {.lex_state = 113},
  [7819] = {.lex_state = 0},
  [7820] = {.lex_state = 171},
  [7821] = {.lex_state = 335},
  [7822] = {.lex_state = 194},
  [7823] = {.lex_state = 194},
  [7824] = {.lex_state = 0},
  [7825] = {.lex_state = 0},
  [7826] = {.lex_state = 0},
  [7827] = {.lex_state = 194},
  [7828] = {.lex_state = 0},
  [7829] = {.lex_state = 0},
  [7830] = {.lex_state = 0},
  [7831] = {.lex_state = 0},
  [7832] = {.lex_state = 0},
  [7833] = {.lex_state = 0},
  [7834] = {.lex_state = 335},
  [7835] = {.lex_state = 0},
  [7836] = {.lex_state = 0},
  [7837] = {.lex_state = 0},
  [7838] = {.lex_state = 0},
  [7839] = {.lex_state = 0},
  [7840] = {.lex_state = 194},
  [7841] = {.lex_state = 335},
  [7842] = {.lex_state = 194},
  [7843] = {.lex_state = 0},
  [7844] = {.lex_state = 194},
  [7845] = {.lex_state = 171},
  [7846] = {.lex_state = 0},
  [7847] = {.lex_state = 171},
  [7848] = {.lex_state = 0},
  [7849] = {.lex_state = 171},
  [7850] = {.lex_state = 0},
  [7851] = {.lex_state = 193},
  [7852] = {.lex_state = 237},
  [7853] = {.lex_state = 335},
  [7854] = {.lex_state = 335},
  [7855] = {.lex_state = 194},
  [7856] = {.lex_state = 0},
  [7857] = {.lex_state = 335},
  [7858] = {.lex_state = 0},
  [7859] = {.lex_state = 0},
  [7860] = {.lex_state = 0, .external_lex_state = 2},
  [7861] = {.lex_state = 335},
  [7862] = {.lex_state = 194},
  [7863] = {.lex_state = 0},
  [7864] = {.lex_state = 0},
  [7865] = {.lex_state = 0},
  [7866] = {.lex_state = 169},
  [7867] = {.lex_state = 0},
  [7868] = {.lex_state = 0},
  [7869] = {.lex_state = 335},
  [7870] = {.lex_state = 171},
  [7871] = {.lex_state = 0},
  [7872] = {.lex_state = 0},
  [7873] = {.lex_state = 194},
  [7874] = {.lex_state = 0},
  [7875] = {.lex_state = 0},
  [7876] = {.lex_state = 0},
  [7877] = {.lex_state = 335},
  [7878] = {.lex_state = 0},
  [7879] = {.lex_state = 171},
  [7880] = {.lex_state = 194},
  [7881] = {.lex_state = 194},
  [7882] = {.lex_state = 113},
  [7883] = {.lex_state = 169},
  [7884] = {.lex_state = 169},
  [7885] = {.lex_state = 0},
  [7886] = {.lex_state = 0},
  [7887] = {.lex_state = 335},
  [7888] = {.lex_state = 169},
  [7889] = {.lex_state = 0},
  [7890] = {.lex_state = 113},
  [7891] = {.lex_state = 169},
  [7892] = {.lex_state = 203},
  [7893] = {.lex_state = 335},
  [7894] = {.lex_state = 335},
  [7895] = {.lex_state = 0},
  [7896] = {.lex_state = 194},
  [7897] = {.lex_state = 0, .external_lex_state = 2},
  [7898] = {.lex_state = 335},
  [7899] = {.lex_state = 194},
  [7900] = {.lex_state = 194},
  [7901] = {.lex_state = 335},
  [7902] = {.lex_state = 0},
  [7903] = {.lex_state = 194},
  [7904] = {.lex_state = 335},
  [7905] = {.lex_state = 203},
  [7906] = {.lex_state = 0},
  [7907] = {.lex_state = 171},
  [7908] = {.lex_state = 0},
  [7909] = {.lex_state = 0},
  [7910] = {.lex_state = 335},
  [7911] = {.lex_state = 0, .external_lex_state = 2},
  [7912] = {.lex_state = 194},
  [7913] = {.lex_state = 171},
  [7914] = {.lex_state = 0},
  [7915] = {.lex_state = 113},
  [7916] = {.lex_state = 335},
  [7917] = {.lex_state = 171},
  [7918] = {.lex_state = 171},
  [7919] = {.lex_state = 0},
  [7920] = {.lex_state = 0},
  [7921] = {.lex_state = 0, .external_lex_state = 2},
  [7922] = {.lex_state = 0},
  [7923] = {.lex_state = 194},
  [7924] = {.lex_state = 194},
  [7925] = {.lex_state = 335},
  [7926] = {.lex_state = 0},
  [7927] = {.lex_state = 0, .external_lex_state = 2},
  [7928] = {.lex_state = 171},
  [7929] = {.lex_state = 0},
  [7930] = {.lex_state = 0, .external_lex_state = 2},
  [7931] = {.lex_state = 0},
  [7932] = {.lex_state = 0},
  [7933] = {.lex_state = 0, .external_lex_state = 2},
  [7934] = {.lex_state = 0},
  [7935] = {.lex_state = 0, .external_lex_state = 2},
  [7936] = {.lex_state = 0},
  [7937] = {.lex_state = 0, .external_lex_state = 2},
  [7938] = {.lex_state = 0},
  [7939] = {.lex_state = 0, .external_lex_state = 2},
  [7940] = {.lex_state = 0},
  [7941] = {.lex_state = 0, .external_lex_state = 2},
  [7942] = {.lex_state = 0},
  [7943] = {.lex_state = 0, .external_lex_state = 2},
  [7944] = {.lex_state = 0},
  [7945] = {.lex_state = 194},
  [7946] = {.lex_state = 194},
  [7947] = {.lex_state = 335},
  [7948] = {.lex_state = 203},
  [7949] = {.lex_state = 335},
  [7950] = {.lex_state = 335},
  [7951] = {.lex_state = 203},
  [7952] = {.lex_state = 0},
  [7953] = {.lex_state = 335},
  [7954] = {.lex_state = 194},
  [7955] = {.lex_state = 335},
  [7956] = {.lex_state = 335},
  [7957] = {.lex_state = 0},
  [7958] = {.lex_state = 113},
  [7959] = {.lex_state = 0},
  [7960] = {.lex_state = 0},
  [7961] = {.lex_state = 0},
  [7962] = {.lex_state = 0},
  [7963] = {.lex_state = 0},
  [7964] = {.lex_state = 0},
  [7965] = {.lex_state = 0},
  [7966] = {.lex_state = 0},
  [7967] = {.lex_state = 0},
  [7968] = {.lex_state = 0},
  [7969] = {.lex_state = 0},
  [7970] = {.lex_state = 0},
  [7971] = {.lex_state = 194},
  [7972] = {.lex_state = 0},
  [7973] = {.lex_state = 335},
  [7974] = {.lex_state = 172},
  [7975] = {.lex_state = 0},
  [7976] = {.lex_state = 0},
  [7977] = {.lex_state = 171},
  [7978] = {.lex_state = 335},
  [7979] = {.lex_state = 0, .external_lex_state = 3},
  [7980] = {.lex_state = 194},
  [7981] = {.lex_state = 0},
  [7982] = {.lex_state = 113},
  [7983] = {.lex_state = 335},
  [7984] = {.lex_state = 171},
  [7985] = {.lex_state = 0},
  [7986] = {.lex_state = 194},
  [7987] = {.lex_state = 0},
  [7988] = {.lex_state = 0},
  [7989] = {.lex_state = 0},
  [7990] = {.lex_state = 171},
  [7991] = {.lex_state = 0},
  [7992] = {.lex_state = 0},
  [7993] = {.lex_state = 194},
  [7994] = {.lex_state = 0},
  [7995] = {.lex_state = 0},
  [7996] = {.lex_state = 0},
  [7997] = {.lex_state = 0},
  [7998] = {.lex_state = 0},
  [7999] = {.lex_state = 0},
  [8000] = {.lex_state = 203},
  [8001] = {.lex_state = 0},
  [8002] = {.lex_state = 194},
  [8003] = {.lex_state = 194},
  [8004] = {.lex_state = 0},
  [8005] = {.lex_state = 0},
  [8006] = {.lex_state = 0},
  [8007] = {.lex_state = 0},
  [8008] = {.lex_state = 194},
  [8009] = {.lex_state = 0},
  [8010] = {.lex_state = 113},
  [8011] = {.lex_state = 0},
  [8012] = {.lex_state = 0},
  [8013] = {.lex_state = 194},
  [8014] = {.lex_state = 194},
  [8015] = {.lex_state = 194},
  [8016] = {.lex_state = 113},
  [8017] = {.lex_state = 203},
  [8018] = {.lex_state = 0},
  [8019] = {.lex_state = 0},
  [8020] = {.lex_state = 0},
  [8021] = {.lex_state = 0},
  [8022] = {.lex_state = 0},
  [8023] = {.lex_state = 0},
  [8024] = {.lex_state = 0},
  [8025] = {.lex_state = 0},
  [8026] = {.lex_state = 0},
  [8027] = {.lex_state = 0},
  [8028] = {.lex_state = 0},
  [8029] = {.lex_state = 0},
  [8030] = {.lex_state = 0},
  [8031] = {.lex_state = 0, .external_lex_state = 2},
  [8032] = {.lex_state = 0},
  [8033] = {.lex_state = 0},
  [8034] = {.lex_state = 0},
  [8035] = {.lex_state = 171},
  [8036] = {.lex_state = 0},
  [8037] = {.lex_state = 194},
  [8038] = {.lex_state = 0},
  [8039] = {.lex_state = 113},
  [8040] = {.lex_state = 0},
  [8041] = {.lex_state = 335},
  [8042] = {.lex_state = 0},
  [8043] = {.lex_state = 335},
  [8044] = {.lex_state = 0},
  [8045] = {.lex_state = 171},
  [8046] = {.lex_state = 0},
  [8047] = {.lex_state = 0},
  [8048] = {.lex_state = 0},
  [8049] = {.lex_state = 0},
  [8050] = {.lex_state = 0},
  [8051] = {.lex_state = 0},
  [8052] = {.lex_state = 0},
  [8053] = {.lex_state = 0},
  [8054] = {.lex_state = 0},
  [8055] = {.lex_state = 0},
  [8056] = {.lex_state = 0},
  [8057] = {.lex_state = 194},
  [8058] = {.lex_state = 335},
  [8059] = {.lex_state = 0},
  [8060] = {.lex_state = 0},
  [8061] = {.lex_state = 113},
  [8062] = {.lex_state = 0},
  [8063] = {.lex_state = 0},
  [8064] = {.lex_state = 0},
  [8065] = {.lex_state = 0},
  [8066] = {.lex_state = 0},
  [8067] = {.lex_state = 0},
  [8068] = {.lex_state = 0},
  [8069] = {.lex_state = 0},
  [8070] = {.lex_state = 335},
  [8071] = {.lex_state = 0},
  [8072] = {.lex_state = 0},
  [8073] = {.lex_state = 194},
  [8074] = {.lex_state = 0},
  [8075] = {.lex_state = 0},
  [8076] = {.lex_state = 0},
  [8077] = {.lex_state = 113},
  [8078] = {.lex_state = 0},
  [8079] = {.lex_state = 0},
  [8080] = {.lex_state = 0},
  [8081] = {.lex_state = 0},
  [8082] = {.lex_state = 194},
  [8083] = {.lex_state = 0},
  [8084] = {.lex_state = 0},
  [8085] = {.lex_state = 0, .external_lex_state = 3},
  [8086] = {.lex_state = 0},
  [8087] = {.lex_state = 335},
  [8088] = {.lex_state = 0},
  [8089] = {.lex_state = 0},
  [8090] = {.lex_state = 0},
  [8091] = {.lex_state = 335},
  [8092] = {.lex_state = 0},
  [8093] = {.lex_state = 0},
  [8094] = {.lex_state = 171},
  [8095] = {.lex_state = 113},
  [8096] = {.lex_state = 0},
  [8097] = {.lex_state = 0},
  [8098] = {.lex_state = 0},
  [8099] = {.lex_state = 0},
  [8100] = {.lex_state = 171},
  [8101] = {.lex_state = 0},
  [8102] = {.lex_state = 0},
  [8103] = {.lex_state = 0},
  [8104] = {.lex_state = 0},
  [8105] = {.lex_state = 0},
  [8106] = {.lex_state = 0},
  [8107] = {.lex_state = 0},
  [8108] = {.lex_state = 203},
  [8109] = {.lex_state = 0},
  [8110] = {.lex_state = 194},
  [8111] = {.lex_state = 194},
  [8112] = {.lex_state = 0},
  [8113] = {.lex_state = 0},
  [8114] = {.lex_state = 0},
  [8115] = {.lex_state = 194},
  [8116] = {.lex_state = 203},
  [8117] = {.lex_state = 0},
  [8118] = {.lex_state = 0},
  [8119] = {.lex_state = 171},
  [8120] = {.lex_state = 194},
  [8121] = {.lex_state = 0},
  [8122] = {.lex_state = 0},
  [8123] = {.lex_state = 0},
  [8124] = {.lex_state = 0},
  [8125] = {.lex_state = 0},
  [8126] = {.lex_state = 0},
  [8127] = {.lex_state = 335},
  [8128] = {.lex_state = 335},
  [8129] = {.lex_state = 335},
  [8130] = {.lex_state = 335},
  [8131] = {.lex_state = 0},
  [8132] = {.lex_state = 335},
  [8133] = {.lex_state = 0},
  [8134] = {.lex_state = 0},
  [8135] = {.lex_state = 0},
  [8136] = {.lex_state = 194},
  [8137] = {.lex_state = 194},
  [8138] = {.lex_state = 113},
  [8139] = {.lex_state = 335},
  [8140] = {.lex_state = 113},
  [8141] = {.lex_state = 0},
  [8142] = {.lex_state = 171},
  [8143] = {.lex_state = 335},
  [8144] = {.lex_state = 0, .external_lex_state = 3},
  [8145] = {.lex_state = 0},
  [8146] = {.lex_state = 0},
  [8147] = {.lex_state = 0},
  [8148] = {.lex_state = 0},
  [8149] = {.lex_state = 113},
  [8150] = {.lex_state = 0},
  [8151] = {.lex_state = 0},
  [8152] = {.lex_state = 203},
  [8153] = {.lex_state = 171},
  [8154] = {.lex_state = 171},
  [8155] = {.lex_state = 335},
  [8156] = {.lex_state = 335},
  [8157] = {.lex_state = 113},
  [8158] = {.lex_state = 335},
  [8159] = {.lex_state = 0},
  [8160] = {.lex_state = 0},
  [8161] = {.lex_state = 194},
  [8162] = {.lex_state = 0},
  [8163] = {.lex_state = 335},
  [8164] = {.lex_state = 171},
  [8165] = {.lex_state = 0},
  [8166] = {.lex_state = 335},
  [8167] = {.lex_state = 0, .external_lex_state = 3},
  [8168] = {.lex_state = 0},
  [8169] = {.lex_state = 0},
  [8170] = {.lex_state = 0},
  [8171] = {.lex_state = 0},
  [8172] = {.lex_state = 0},
  [8173] = {.lex_state = 203},
  [8174] = {.lex_state = 0},
  [8175] = {.lex_state = 335},
  [8176] = {.lex_state = 335},
  [8177] = {.lex_state = 0},
  [8178] = {.lex_state = 335},
  [8179] = {.lex_state = 0},
  [8180] = {.lex_state = 0},
  [8181] = {.lex_state = 194},
  [8182] = {.lex_state = 335},
  [8183] = {.lex_state = 203},
  [8184] = {.lex_state = 0},
  [8185] = {.lex_state = 335},
  [8186] = {.lex_state = 0, .external_lex_state = 3},
  [8187] = {.lex_state = 0},
  [8188] = {.lex_state = 0},
  [8189] = {.lex_state = 0},
  [8190] = {.lex_state = 171},
  [8191] = {.lex_state = 0},
  [8192] = {.lex_state = 203},
  [8193] = {.lex_state = 0},
  [8194] = {.lex_state = 335},
  [8195] = {.lex_state = 335},
  [8196] = {.lex_state = 203},
  [8197] = {.lex_state = 335},
  [8198] = {.lex_state = 203},
  [8199] = {.lex_state = 0},
  [8200] = {.lex_state = 335},
  [8201] = {.lex_state = 0},
  [8202] = {.lex_state = 194},
  [8203] = {.lex_state = 335},
  [8204] = {.lex_state = 0, .external_lex_state = 3},
  [8205] = {.lex_state = 0},
  [8206] = {.lex_state = 0},
  [8207] = {.lex_state = 113},
  [8208] = {.lex_state = 0},
  [8209] = {.lex_state = 0},
  [8210] = {.lex_state = 203},
  [8211] = {.lex_state = 0},
  [8212] = {.lex_state = 335},
  [8213] = {.lex_state = 0},
  [8214] = {.lex_state = 335},
  [8215] = {.lex_state = 0},
  [8216] = {.lex_state = 0},
  [8217] = {.lex_state = 0},
  [8218] = {.lex_state = 335},
  [8219] = {.lex_state = 335},
  [8220] = {.lex_state = 0, .external_lex_state = 3},
  [8221] = {.lex_state = 0},
  [8222] = {.lex_state = 171},
  [8223] = {.lex_state = 171},
  [8224] = {.lex_state = 0},
  [8225] = {.lex_state = 194},
  [8226] = {.lex_state = 335},
  [8227] = {.lex_state = 335},
  [8228] = {.lex_state = 0},
  [8229] = {.lex_state = 0, .external_lex_state = 3},
  [8230] = {.lex_state = 0},
  [8231] = {.lex_state = 194},
  [8232] = {.lex_state = 0},
  [8233] = {.lex_state = 171},
  [8234] = {.lex_state = 335},
  [8235] = {.lex_state = 335},
  [8236] = {.lex_state = 0},
  [8237] = {.lex_state = 0, .external_lex_state = 3},
  [8238] = {.lex_state = 0},
  [8239] = {.lex_state = 0},
  [8240] = {.lex_state = 335},
  [8241] = {.lex_state = 335},
  [8242] = {.lex_state = 0, .external_lex_state = 3},
  [8243] = {.lex_state = 0},
  [8244] = {.lex_state = 0, .external_lex_state = 3},
  [8245] = {.lex_state = 0},
  [8246] = {.lex_state = 0, .external_lex_state = 3},
  [8247] = {.lex_state = 0},
  [8248] = {.lex_state = 0, .external_lex_state = 3},
  [8249] = {.lex_state = 0},
  [8250] = {.lex_state = 0, .external_lex_state = 3},
  [8251] = {.lex_state = 0},
  [8252] = {.lex_state = 0, .external_lex_state = 3},
  [8253] = {.lex_state = 0},
  [8254] = {.lex_state = 0, .external_lex_state = 3},
  [8255] = {.lex_state = 0},
  [8256] = {.lex_state = 0, .external_lex_state = 3},
  [8257] = {.lex_state = 0},
  [8258] = {.lex_state = 0},
  [8259] = {.lex_state = 0},
  [8260] = {.lex_state = 335},
  [8261] = {.lex_state = 335},
  [8262] = {.lex_state = 194},
  [8263] = {.lex_state = 0},
  [8264] = {.lex_state = 194},
  [8265] = {.lex_state = 171},
  [8266] = {.lex_state = 171},
  [8267] = {.lex_state = 0},
  [8268] = {.lex_state = 0},
  [8269] = {.lex_state = 171},
  [8270] = {.lex_state = 0},
  [8271] = {.lex_state = 0},
  [8272] = {.lex_state = 171},
  [8273] = {.lex_state = 194},
  [8274] = {.lex_state = 0},
  [8275] = {.lex_state = 0},
  [8276] = {.lex_state = 0},
  [8277] = {.lex_state = 194},
  [8278] = {.lex_state = 0, .external_lex_state = 3},
  [8279] = {.lex_state = 194},
  [8280] = {.lex_state = 194},
  [8281] = {.lex_state = 171},
  [8282] = {.lex_state = 0},
  [8283] = {.lex_state = 0},
  [8284] = {.lex_state = 335},
  [8285] = {.lex_state = 0},
  [8286] = {.lex_state = 0},
  [8287] = {.lex_state = 0},
  [8288] = {.lex_state = 0},
  [8289] = {.lex_state = 0},
  [8290] = {.lex_state = 0},
  [8291] = {.lex_state = 0},
  [8292] = {.lex_state = 335},
  [8293] = {.lex_state = 0},
  [8294] = {.lex_state = 194},
  [8295] = {.lex_state = 203},
  [8296] = {.lex_state = 113},
  [8297] = {.lex_state = 0},
  [8298] = {.lex_state = 0},
  [8299] = {.lex_state = 113},
  [8300] = {.lex_state = 0},
  [8301] = {.lex_state = 0},
  [8302] = {.lex_state = 0},
  [8303] = {.lex_state = 0},
  [8304] = {.lex_state = 0},
  [8305] = {.lex_state = 0},
  [8306] = {.lex_state = 113},
  [8307] = {.lex_state = 0},
  [8308] = {.lex_state = 203},
  [8309] = {.lex_state = 0},
  [8310] = {.lex_state = 0},
  [8311] = {.lex_state = 0},
  [8312] = {.lex_state = 0},
  [8313] = {.lex_state = 171},
  [8314] = {.lex_state = 0},
  [8315] = {.lex_state = 0},
  [8316] = {.lex_state = 0},
  [8317] = {.lex_state = 0},
  [8318] = {.lex_state = 335},
  [8319] = {.lex_state = 0},
  [8320] = {.lex_state = 0},
  [8321] = {.lex_state = 0},
  [8322] = {.lex_state = 0},
  [8323] = {.lex_state = 0},
  [8324] = {.lex_state = 194},
  [8325] = {.lex_state = 335},
  [8326] = {.lex_state = 0},
  [8327] = {.lex_state = 0},
  [8328] = {.lex_state = 0},
  [8329] = {.lex_state = 0},
  [8330] = {.lex_state = 0},
  [8331] = {.lex_state = 335},
  [8332] = {.lex_state = 335},
  [8333] = {.lex_state = 171},
  [8334] = {.lex_state = 0},
  [8335] = {.lex_state = 171},
  [8336] = {.lex_state = 335},
  [8337] = {.lex_state = 203},
  [8338] = {.lex_state = 335},
  [8339] = {.lex_state = 335},
  [8340] = {.lex_state = 335},
  [8341] = {.lex_state = 335},
  [8342] = {.lex_state = 194},
  [8343] = {.lex_state = 0},
  [8344] = {.lex_state = 194},
  [8345] = {.lex_state = 0},
  [8346] = {.lex_state = 194},
  [8347] = {.lex_state = 0, .external_lex_state = 3},
  [8348] = {.lex_state = 0},
  [8349] = {.lex_state = 335},
  [8350] = {.lex_state = 0},
  [8351] = {.lex_state = 335},
  [8352] = {.lex_state = 335},
  [8353] = {.lex_state = 194},
  [8354] = {.lex_state = 0},
  [8355] = {.lex_state = 203},
  [8356] = {.lex_state = 194},
  [8357] = {.lex_state = 0, .external_lex_state = 3},
  [8358] = {.lex_state = 0},
  [8359] = {.lex_state = 0},
  [8360] = {.lex_state = 203},
  [8361] = {.lex_state = 335},
  [8362] = {.lex_state = 194},
  [8363] = {.lex_state = 194},
  [8364] = {.lex_state = 0},
  [8365] = {.lex_state = 194},
  [8366] = {.lex_state = 0, .external_lex_state = 3},
  [8367] = {.lex_state = 0},
  [8368] = {.lex_state = 0},
  [8369] = {.lex_state = 335},
  [8370] = {.lex_state = 194},
  [8371] = {.lex_state = 0},
  [8372] = {.lex_state = 0},
  [8373] = {.lex_state = 194},
  [8374] = {.lex_state = 0, .external_lex_state = 3},
  [8375] = {.lex_state = 335},
  [8376] = {.lex_state = 0},
  [8377] = {.lex_state = 335},
  [8378] = {.lex_state = 194},
  [8379] = {.lex_state = 0},
  [8380] = {.lex_state = 194},
  [8381] = {.lex_state = 0, .external_lex_state = 3},
  [8382] = {.lex_state = 0},
  [8383] = {.lex_state = 0},
  [8384] = {.lex_state = 194},
  [8385] = {.lex_state = 0, .external_lex_state = 3},
  [8386] = {.lex_state = 335},
  [8387] = {.lex_state = 194},
  [8388] = {.lex_state = 0, .external_lex_state = 3},
  [8389] = {.lex_state = 113},
  [8390] = {.lex_state = 0, .external_lex_state = 3},
  [8391] = {.lex_state = 0},
  [8392] = {.lex_state = 0, .external_lex_state = 3},
  [8393] = {.lex_state = 0},
  [8394] = {.lex_state = 0, .external_lex_state = 3},
  [8395] = {.lex_state = 0},
  [8396] = {.lex_state = 0, .external_lex_state = 3},
  [8397] = {.lex_state = 0},
  [8398] = {.lex_state = 0, .external_lex_state = 3},
  [8399] = {.lex_state = 0},
  [8400] = {.lex_state = 0, .external_lex_state = 3},
  [8401] = {.lex_state = 0},
  [8402] = {.lex_state = 0, .external_lex_state = 3},
  [8403] = {.lex_state = 0},
  [8404] = {.lex_state = 0, .external_lex_state = 3},
  [8405] = {.lex_state = 335},
  [8406] = {.lex_state = 335},
  [8407] = {.lex_state = 0},
  [8408] = {.lex_state = 335},
  [8409] = {.lex_state = 335},
  [8410] = {.lex_state = 0},
  [8411] = {.lex_state = 335},
  [8412] = {.lex_state = 335},
  [8413] = {.lex_state = 0},
  [8414] = {.lex_state = 335},
  [8415] = {.lex_state = 335},
  [8416] = {.lex_state = 0},
  [8417] = {.lex_state = 335},
  [8418] = {.lex_state = 335},
  [8419] = {.lex_state = 0},
  [8420] = {.lex_state = 335},
  [8421] = {.lex_state = 335},
  [8422] = {.lex_state = 335},
  [8423] = {.lex_state = 335},
  [8424] = {.lex_state = 335},
  [8425] = {.lex_state = 335},
  [8426] = {.lex_state = 335},
  [8427] = {.lex_state = 335},
  [8428] = {.lex_state = 335},
  [8429] = {.lex_state = 335},
  [8430] = {.lex_state = 335},
  [8431] = {.lex_state = 0},
  [8432] = {.lex_state = 0},
  [8433] = {.lex_state = 194},
  [8434] = {.lex_state = 0},
  [8435] = {.lex_state = 194},
  [8436] = {.lex_state = 335},
  [8437] = {.lex_state = 335},
  [8438] = {.lex_state = 335},
  [8439] = {.lex_state = 335},
  [8440] = {.lex_state = 335},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [aux_sym_preproc_include_token1] = ACTIONS(1),
    [aux_sym_preproc_def_token1] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [aux_sym_preproc_if_token1] = ACTIONS(1),
    [aux_sym_preproc_if_token2] = ACTIONS(1),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1),
    [aux_sym_preproc_else_token1] = ACTIONS(1),
    [aux_sym_preproc_elif_token1] = ACTIONS(1),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1),
    [sym_preproc_directive] = ACTIONS(1),
    [anon_sym_LPAREN2] = ACTIONS(1),
    [anon_sym_defined] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym___extension__] = ACTIONS(1),
    [anon_sym_typedef] = ACTIONS(1),
    [anon_sym_extern] = ACTIONS(1),
    [anon_sym___attribute__] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1),
    [anon_sym___declspec] = ACTIONS(1),
    [anon_sym___based] = ACTIONS(1),
    [anon_sym___cdecl] = ACTIONS(1),
    [anon_sym___clrcall] = ACTIONS(1),
    [anon_sym___stdcall] = ACTIONS(1),
    [anon_sym___fastcall] = ACTIONS(1),
    [anon_sym___thiscall] = ACTIONS(1),
    [anon_sym___vectorcall] = ACTIONS(1),
    [sym_ms_restrict_modifier] = ACTIONS(1),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(1),
    [sym_ms_signed_ptr_modifier] = ACTIONS(1),
    [anon_sym__unaligned] = ACTIONS(1),
    [anon_sym___unaligned] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_signed] = ACTIONS(1),
    [anon_sym_unsigned] = ACTIONS(1),
    [anon_sym_long] = ACTIONS(1),
    [anon_sym_short] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_register] = ACTIONS(1),
    [anon_sym_inline] = ACTIONS(1),
    [anon_sym___inline] = ACTIONS(1),
    [anon_sym___inline__] = ACTIONS(1),
    [anon_sym___forceinline] = ACTIONS(1),
    [anon_sym_thread_local] = ACTIONS(1),
    [anon_sym___thread] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_constexpr] = ACTIONS(1),
    [anon_sym_volatile] = ACTIONS(1),
    [anon_sym_restrict] = ACTIONS(1),
    [anon_sym___restrict__] = ACTIONS(1),
    [anon_sym__Atomic] = ACTIONS(1),
    [anon_sym__Noreturn] = ACTIONS(1),
    [anon_sym_noreturn] = ACTIONS(1),
    [anon_sym_mutable] = ACTIONS(1),
    [anon_sym_constinit] = ACTIONS(1),
    [anon_sym_consteval] = ACTIONS(1),
    [anon_sym_PROGMEM] = ACTIONS(1),
    [aux_sym_primitive_type_token1] = ACTIONS(1),
    [anon_sym_byte] = ACTIONS(1),
    [anon_sym_word] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_struct] = ACTIONS(1),
    [anon_sym_union] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_goto] = ACTIONS(1),
    [anon_sym___try] = ACTIONS(1),
    [anon_sym___except] = ACTIONS(1),
    [anon_sym___finally] = ACTIONS(1),
    [anon_sym___leave] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_and_eq] = ACTIONS(1),
    [anon_sym_or_eq] = ACTIONS(1),
    [anon_sym_xor_eq] = ACTIONS(1),
    [anon_sym_not] = ACTIONS(1),
    [anon_sym_compl] = ACTIONS(1),
    [anon_sym_LT_EQ_GT] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_bitor] = ACTIONS(1),
    [anon_sym_xor] = ACTIONS(1),
    [anon_sym_bitand] = ACTIONS(1),
    [anon_sym_not_eq] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_sizeof] = ACTIONS(1),
    [anon_sym___alignof__] = ACTIONS(1),
    [anon_sym___alignof] = ACTIONS(1),
    [anon_sym__alignof] = ACTIONS(1),
    [anon_sym_alignof] = ACTIONS(1),
    [anon_sym__Alignof] = ACTIONS(1),
    [anon_sym_offsetof] = ACTIONS(1),
    [anon_sym__Generic] = ACTIONS(1),
    [anon_sym_asm] = ACTIONS(1),
    [anon_sym___asm__] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_DOT_STAR] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [aux_sym_number_literal_token1] = ACTIONS(1),
    [aux_sym_number_literal_token2] = ACTIONS(1),
    [anon_sym_L_SQUOTE] = ACTIONS(1),
    [anon_sym_u_SQUOTE] = ACTIONS(1),
    [anon_sym_U_SQUOTE] = ACTIONS(1),
    [anon_sym_u8_SQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_L_DQUOTE] = ACTIONS(1),
    [anon_sym_u_DQUOTE] = ACTIONS(1),
    [anon_sym_U_DQUOTE] = ACTIONS(1),
    [anon_sym_u8_DQUOTE] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [anon_sym_NULL] = ACTIONS(1),
    [anon_sym_nullptr] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1),
    [anon_sym_decltype] = ACTIONS(1),
    [anon_sym_final] = ACTIONS(1),
    [anon_sym_override] = ACTIONS(1),
    [anon_sym_virtual] = ACTIONS(1),
    [anon_sym_alignas] = ACTIONS(1),
    [anon_sym_explicit] = ACTIONS(1),
    [anon_sym_typename] = ACTIONS(1),
    [anon_sym_template] = ACTIONS(1),
    [anon_sym_GT2] = ACTIONS(1),
    [anon_sym_operator] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_delete] = ACTIONS(1),
    [anon_sym_0] = ACTIONS(1),
    [anon_sym_friend] = ACTIONS(1),
    [anon_sym_public] = ACTIONS(1),
    [anon_sym_private] = ACTIONS(1),
    [anon_sym_protected] = ACTIONS(1),
    [anon_sym_noexcept] = ACTIONS(1),
    [anon_sym_throw] = ACTIONS(1),
    [anon_sym_namespace] = ACTIONS(1),
    [anon_sym_using] = ACTIONS(1),
    [anon_sym_static_assert] = ACTIONS(1),
    [anon_sym_concept] = ACTIONS(1),
    [anon_sym_co_return] = ACTIONS(1),
    [anon_sym_co_yield] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_R_DQUOTE] = ACTIONS(1),
    [anon_sym_LR_DQUOTE] = ACTIONS(1),
    [anon_sym_uR_DQUOTE] = ACTIONS(1),
    [anon_sym_UR_DQUOTE] = ACTIONS(1),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1),
    [anon_sym_co_await] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_requires] = ACTIONS(1),
    [anon_sym_DASH_GT_STAR] = ACTIONS(1),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(1),
    [sym_this] = ACTIONS(1),
    [sym_raw_string_delimiter] = ACTIONS(1),
    [sym_raw_string_content] = ACTIONS(1),
  },
  [1] = {
    [sym_translation_unit] = STATE(8320),
    [sym_preproc_include] = STATE(80),
    [sym_preproc_def] = STATE(80),
    [sym_preproc_function_def] = STATE(80),
    [sym_preproc_call] = STATE(80),
    [sym_preproc_if] = STATE(80),
    [sym_preproc_ifdef] = STATE(80),
    [sym_function_definition] = STATE(80),
    [sym_declaration] = STATE(80),
    [sym_type_definition] = STATE(80),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4612),
    [sym_linkage_specification] = STATE(80),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1846),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6096),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(80),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2794),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(80),
    [sym_labeled_statement] = STATE(80),
    [sym__top_level_expression_statement] = STATE(80),
    [sym_if_statement] = STATE(80),
    [sym_switch_statement] = STATE(80),
    [sym_case_statement] = STATE(80),
    [sym_while_statement] = STATE(80),
    [sym_do_statement] = STATE(80),
    [sym_for_statement] = STATE(80),
    [sym_return_statement] = STATE(80),
    [sym_break_statement] = STATE(80),
    [sym_continue_statement] = STATE(80),
    [sym_goto_statement] = STATE(80),
    [sym__expression] = STATE(4665),
    [sym__expression_not_binary] = STATE(4774),
    [sym__string] = STATE(4774),
    [sym_conditional_expression] = STATE(4774),
    [sym_assignment_expression] = STATE(4774),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(4774),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(4774),
    [sym_cast_expression] = STATE(4774),
    [sym_sizeof_expression] = STATE(4774),
    [sym_alignof_expression] = STATE(4774),
    [sym_offsetof_expression] = STATE(4774),
    [sym_generic_expression] = STATE(4774),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(4774),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(4774),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(4774),
    [sym__empty_declaration] = STATE(80),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1887),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(80),
    [sym_template_instantiation] = STATE(80),
    [sym_operator_cast] = STATE(6513),
    [sym__constructor_specifiers] = STATE(1887),
    [sym_operator_cast_definition] = STATE(80),
    [sym_operator_cast_declaration] = STATE(80),
    [sym_constructor_or_destructor_definition] = STATE(80),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(80),
    [sym_namespace_alias_definition] = STATE(80),
    [sym_using_declaration] = STATE(80),
    [sym_alias_declaration] = STATE(80),
    [sym_static_assert_declaration] = STATE(80),
    [sym_concept_definition] = STATE(80),
    [sym_for_range_loop] = STATE(80),
    [sym_co_return_statement] = STATE(80),
    [sym_co_yield_statement] = STATE(80),
    [sym_throw_statement] = STATE(80),
    [sym_try_statement] = STATE(80),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(4774),
    [sym_new_expression] = STATE(4774),
    [sym_delete_expression] = STATE(4774),
    [sym_requires_clause] = STATE(4774),
    [sym_requires_expression] = STATE(4774),
    [sym_lambda_expression] = STATE(4774),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(4774),
    [sym_parameter_pack_expansion] = STATE(4774),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6513),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_translation_unit_repeat1] = STATE(80),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(172),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1887),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [aux_sym_preproc_include_token1] = ACTIONS(9),
    [aux_sym_preproc_def_token1] = ACTIONS(11),
    [aux_sym_preproc_if_token1] = ACTIONS(13),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(15),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(15),
    [sym_preproc_directive] = ACTIONS(17),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym___extension__] = ACTIONS(33),
    [anon_sym_typedef] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(37),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_case] = ACTIONS(77),
    [anon_sym_default] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_do] = ACTIONS(83),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_return] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_goto] = ACTIONS(93),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(115),
    [sym_false] = ACTIONS(115),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(131),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(141),
    [anon_sym_using] = ACTIONS(143),
    [anon_sym_static_assert] = ACTIONS(145),
    [anon_sym_concept] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(115),
  },
  [2] = {
    [sym_preproc_include] = STATE(39),
    [sym_preproc_def] = STATE(39),
    [sym_preproc_function_def] = STATE(39),
    [sym_preproc_call] = STATE(39),
    [sym_preproc_if] = STATE(39),
    [sym_preproc_ifdef] = STATE(39),
    [sym_function_definition] = STATE(39),
    [sym_declaration] = STATE(39),
    [sym_type_definition] = STATE(39),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4541),
    [sym_linkage_specification] = STATE(39),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6129),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(39),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2759),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(39),
    [sym_labeled_statement] = STATE(39),
    [sym_expression_statement] = STATE(39),
    [sym_if_statement] = STATE(39),
    [sym_switch_statement] = STATE(39),
    [sym_case_statement] = STATE(39),
    [sym_while_statement] = STATE(39),
    [sym_do_statement] = STATE(39),
    [sym_for_statement] = STATE(39),
    [sym_return_statement] = STATE(39),
    [sym_break_statement] = STATE(39),
    [sym_continue_statement] = STATE(39),
    [sym_goto_statement] = STATE(39),
    [sym_seh_try_statement] = STATE(39),
    [sym_seh_leave_statement] = STATE(39),
    [sym__expression] = STATE(4223),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(7023),
    [sym_initializer_pair] = STATE(7023),
    [sym_subscript_designator] = STATE(6468),
    [sym_subscript_range_designator] = STATE(6468),
    [sym_field_designator] = STATE(6468),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(39),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1888),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(39),
    [sym_template_instantiation] = STATE(39),
    [sym_operator_cast] = STATE(6505),
    [sym__constructor_specifiers] = STATE(1888),
    [sym_operator_cast_definition] = STATE(39),
    [sym_operator_cast_declaration] = STATE(39),
    [sym_constructor_or_destructor_definition] = STATE(39),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(39),
    [sym_namespace_alias_definition] = STATE(39),
    [sym_using_declaration] = STATE(39),
    [sym_alias_declaration] = STATE(39),
    [sym_static_assert_declaration] = STATE(39),
    [sym_concept_definition] = STATE(39),
    [sym_for_range_loop] = STATE(39),
    [sym_co_return_statement] = STATE(39),
    [sym_co_yield_statement] = STATE(39),
    [sym_throw_statement] = STATE(39),
    [sym_try_statement] = STATE(39),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6505),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(39),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_initializer_pair_repeat1] = STATE(6468),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1888),
    [sym_identifier] = ACTIONS(161),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [anon_sym_COMMA] = ACTIONS(167),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(185),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [3] = {
    [sym_preproc_include] = STATE(58),
    [sym_preproc_def] = STATE(58),
    [sym_preproc_function_def] = STATE(58),
    [sym_preproc_call] = STATE(58),
    [sym_preproc_if] = STATE(58),
    [sym_preproc_ifdef] = STATE(58),
    [sym_function_definition] = STATE(58),
    [sym_declaration] = STATE(58),
    [sym_type_definition] = STATE(58),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4541),
    [sym_linkage_specification] = STATE(58),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6129),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(58),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2759),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(58),
    [sym_labeled_statement] = STATE(58),
    [sym_expression_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_case_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_return_statement] = STATE(58),
    [sym_break_statement] = STATE(58),
    [sym_continue_statement] = STATE(58),
    [sym_goto_statement] = STATE(58),
    [sym_seh_try_statement] = STATE(58),
    [sym_seh_leave_statement] = STATE(58),
    [sym__expression] = STATE(4223),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(7023),
    [sym_initializer_pair] = STATE(7023),
    [sym_subscript_designator] = STATE(6468),
    [sym_subscript_range_designator] = STATE(6468),
    [sym_field_designator] = STATE(6468),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(58),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1888),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(58),
    [sym_template_instantiation] = STATE(58),
    [sym_operator_cast] = STATE(6505),
    [sym__constructor_specifiers] = STATE(1888),
    [sym_operator_cast_definition] = STATE(58),
    [sym_operator_cast_declaration] = STATE(58),
    [sym_constructor_or_destructor_definition] = STATE(58),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(58),
    [sym_namespace_alias_definition] = STATE(58),
    [sym_using_declaration] = STATE(58),
    [sym_alias_declaration] = STATE(58),
    [sym_static_assert_declaration] = STATE(58),
    [sym_concept_definition] = STATE(58),
    [sym_for_range_loop] = STATE(58),
    [sym_co_return_statement] = STATE(58),
    [sym_co_yield_statement] = STATE(58),
    [sym_throw_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6505),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(58),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_initializer_pair_repeat1] = STATE(6468),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1888),
    [sym_identifier] = ACTIONS(161),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [anon_sym_COMMA] = ACTIONS(167),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(239),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [4] = {
    [sym_preproc_include] = STATE(69),
    [sym_preproc_def] = STATE(69),
    [sym_preproc_function_def] = STATE(69),
    [sym_preproc_call] = STATE(69),
    [sym_preproc_if] = STATE(69),
    [sym_preproc_ifdef] = STATE(69),
    [sym_function_definition] = STATE(69),
    [sym_declaration] = STATE(69),
    [sym_type_definition] = STATE(69),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4541),
    [sym_linkage_specification] = STATE(69),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6129),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(69),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2759),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(69),
    [sym_labeled_statement] = STATE(69),
    [sym_expression_statement] = STATE(69),
    [sym_if_statement] = STATE(69),
    [sym_switch_statement] = STATE(69),
    [sym_case_statement] = STATE(69),
    [sym_while_statement] = STATE(69),
    [sym_do_statement] = STATE(69),
    [sym_for_statement] = STATE(69),
    [sym_return_statement] = STATE(69),
    [sym_break_statement] = STATE(69),
    [sym_continue_statement] = STATE(69),
    [sym_goto_statement] = STATE(69),
    [sym_seh_try_statement] = STATE(69),
    [sym_seh_leave_statement] = STATE(69),
    [sym__expression] = STATE(4223),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(7023),
    [sym_initializer_pair] = STATE(7023),
    [sym_subscript_designator] = STATE(6468),
    [sym_subscript_range_designator] = STATE(6468),
    [sym_field_designator] = STATE(6468),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(69),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1888),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(69),
    [sym_template_instantiation] = STATE(69),
    [sym_operator_cast] = STATE(6505),
    [sym__constructor_specifiers] = STATE(1888),
    [sym_operator_cast_definition] = STATE(69),
    [sym_operator_cast_declaration] = STATE(69),
    [sym_constructor_or_destructor_definition] = STATE(69),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(69),
    [sym_namespace_alias_definition] = STATE(69),
    [sym_using_declaration] = STATE(69),
    [sym_alias_declaration] = STATE(69),
    [sym_static_assert_declaration] = STATE(69),
    [sym_concept_definition] = STATE(69),
    [sym_for_range_loop] = STATE(69),
    [sym_co_return_statement] = STATE(69),
    [sym_co_yield_statement] = STATE(69),
    [sym_throw_statement] = STATE(69),
    [sym_try_statement] = STATE(69),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6505),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(69),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_initializer_pair_repeat1] = STATE(6468),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1888),
    [sym_identifier] = ACTIONS(161),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [anon_sym_COMMA] = ACTIONS(167),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(241),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [5] = {
    [sym_preproc_include] = STATE(56),
    [sym_preproc_def] = STATE(56),
    [sym_preproc_function_def] = STATE(56),
    [sym_preproc_call] = STATE(56),
    [sym_preproc_if] = STATE(56),
    [sym_preproc_ifdef] = STATE(56),
    [sym_function_definition] = STATE(56),
    [sym_declaration] = STATE(56),
    [sym_type_definition] = STATE(56),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4541),
    [sym_linkage_specification] = STATE(56),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6129),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(56),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2759),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(56),
    [sym_labeled_statement] = STATE(56),
    [sym_expression_statement] = STATE(56),
    [sym_if_statement] = STATE(56),
    [sym_switch_statement] = STATE(56),
    [sym_case_statement] = STATE(56),
    [sym_while_statement] = STATE(56),
    [sym_do_statement] = STATE(56),
    [sym_for_statement] = STATE(56),
    [sym_return_statement] = STATE(56),
    [sym_break_statement] = STATE(56),
    [sym_continue_statement] = STATE(56),
    [sym_goto_statement] = STATE(56),
    [sym_seh_try_statement] = STATE(56),
    [sym_seh_leave_statement] = STATE(56),
    [sym__expression] = STATE(4223),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(7023),
    [sym_initializer_pair] = STATE(7023),
    [sym_subscript_designator] = STATE(6468),
    [sym_subscript_range_designator] = STATE(6468),
    [sym_field_designator] = STATE(6468),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(56),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1888),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(56),
    [sym_template_instantiation] = STATE(56),
    [sym_operator_cast] = STATE(6505),
    [sym__constructor_specifiers] = STATE(1888),
    [sym_operator_cast_definition] = STATE(56),
    [sym_operator_cast_declaration] = STATE(56),
    [sym_constructor_or_destructor_definition] = STATE(56),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(56),
    [sym_namespace_alias_definition] = STATE(56),
    [sym_using_declaration] = STATE(56),
    [sym_alias_declaration] = STATE(56),
    [sym_static_assert_declaration] = STATE(56),
    [sym_concept_definition] = STATE(56),
    [sym_for_range_loop] = STATE(56),
    [sym_co_return_statement] = STATE(56),
    [sym_co_yield_statement] = STATE(56),
    [sym_throw_statement] = STATE(56),
    [sym_try_statement] = STATE(56),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6505),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(56),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_initializer_pair_repeat1] = STATE(6468),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1888),
    [sym_identifier] = ACTIONS(161),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [anon_sym_COMMA] = ACTIONS(167),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(243),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [6] = {
    [sym_preproc_include] = STATE(39),
    [sym_preproc_def] = STATE(39),
    [sym_preproc_function_def] = STATE(39),
    [sym_preproc_call] = STATE(39),
    [sym_preproc_if] = STATE(39),
    [sym_preproc_ifdef] = STATE(39),
    [sym_function_definition] = STATE(39),
    [sym_declaration] = STATE(39),
    [sym_type_definition] = STATE(39),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4541),
    [sym_linkage_specification] = STATE(39),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6129),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(39),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2759),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(39),
    [sym_labeled_statement] = STATE(39),
    [sym_expression_statement] = STATE(39),
    [sym_if_statement] = STATE(39),
    [sym_switch_statement] = STATE(39),
    [sym_case_statement] = STATE(39),
    [sym_while_statement] = STATE(39),
    [sym_do_statement] = STATE(39),
    [sym_for_statement] = STATE(39),
    [sym_return_statement] = STATE(39),
    [sym_break_statement] = STATE(39),
    [sym_continue_statement] = STATE(39),
    [sym_goto_statement] = STATE(39),
    [sym_seh_try_statement] = STATE(39),
    [sym_seh_leave_statement] = STATE(39),
    [sym__expression] = STATE(4223),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(7023),
    [sym_initializer_pair] = STATE(7023),
    [sym_subscript_designator] = STATE(6468),
    [sym_subscript_range_designator] = STATE(6468),
    [sym_field_designator] = STATE(6468),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(39),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1888),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(39),
    [sym_template_instantiation] = STATE(39),
    [sym_operator_cast] = STATE(6505),
    [sym__constructor_specifiers] = STATE(1888),
    [sym_operator_cast_definition] = STATE(39),
    [sym_operator_cast_declaration] = STATE(39),
    [sym_constructor_or_destructor_definition] = STATE(39),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(39),
    [sym_namespace_alias_definition] = STATE(39),
    [sym_using_declaration] = STATE(39),
    [sym_alias_declaration] = STATE(39),
    [sym_static_assert_declaration] = STATE(39),
    [sym_concept_definition] = STATE(39),
    [sym_for_range_loop] = STATE(39),
    [sym_co_return_statement] = STATE(39),
    [sym_co_yield_statement] = STATE(39),
    [sym_throw_statement] = STATE(39),
    [sym_try_statement] = STATE(39),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6505),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(39),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_initializer_pair_repeat1] = STATE(6468),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1888),
    [sym_identifier] = ACTIONS(161),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [anon_sym_COMMA] = ACTIONS(167),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(245),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [7] = {
    [sym_preproc_include] = STATE(49),
    [sym_preproc_def] = STATE(49),
    [sym_preproc_function_def] = STATE(49),
    [sym_preproc_call] = STATE(49),
    [sym_preproc_if] = STATE(49),
    [sym_preproc_ifdef] = STATE(49),
    [sym_function_definition] = STATE(49),
    [sym_declaration] = STATE(49),
    [sym_type_definition] = STATE(49),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4541),
    [sym_linkage_specification] = STATE(49),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6129),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(49),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2759),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(49),
    [sym_labeled_statement] = STATE(49),
    [sym_expression_statement] = STATE(49),
    [sym_if_statement] = STATE(49),
    [sym_switch_statement] = STATE(49),
    [sym_case_statement] = STATE(49),
    [sym_while_statement] = STATE(49),
    [sym_do_statement] = STATE(49),
    [sym_for_statement] = STATE(49),
    [sym_return_statement] = STATE(49),
    [sym_break_statement] = STATE(49),
    [sym_continue_statement] = STATE(49),
    [sym_goto_statement] = STATE(49),
    [sym_seh_try_statement] = STATE(49),
    [sym_seh_leave_statement] = STATE(49),
    [sym__expression] = STATE(4223),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(7023),
    [sym_initializer_pair] = STATE(7023),
    [sym_subscript_designator] = STATE(6468),
    [sym_subscript_range_designator] = STATE(6468),
    [sym_field_designator] = STATE(6468),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(49),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1888),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(49),
    [sym_template_instantiation] = STATE(49),
    [sym_operator_cast] = STATE(6505),
    [sym__constructor_specifiers] = STATE(1888),
    [sym_operator_cast_definition] = STATE(49),
    [sym_operator_cast_declaration] = STATE(49),
    [sym_constructor_or_destructor_definition] = STATE(49),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(49),
    [sym_namespace_alias_definition] = STATE(49),
    [sym_using_declaration] = STATE(49),
    [sym_alias_declaration] = STATE(49),
    [sym_static_assert_declaration] = STATE(49),
    [sym_concept_definition] = STATE(49),
    [sym_for_range_loop] = STATE(49),
    [sym_co_return_statement] = STATE(49),
    [sym_co_yield_statement] = STATE(49),
    [sym_throw_statement] = STATE(49),
    [sym_try_statement] = STATE(49),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6505),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(49),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_initializer_pair_repeat1] = STATE(6468),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1888),
    [sym_identifier] = ACTIONS(161),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [anon_sym_COMMA] = ACTIONS(167),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(247),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [8] = {
    [sym_preproc_include] = STATE(56),
    [sym_preproc_def] = STATE(56),
    [sym_preproc_function_def] = STATE(56),
    [sym_preproc_call] = STATE(56),
    [sym_preproc_if] = STATE(56),
    [sym_preproc_ifdef] = STATE(56),
    [sym_function_definition] = STATE(56),
    [sym_declaration] = STATE(56),
    [sym_type_definition] = STATE(56),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4541),
    [sym_linkage_specification] = STATE(56),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6129),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(56),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2759),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(56),
    [sym_labeled_statement] = STATE(56),
    [sym_expression_statement] = STATE(56),
    [sym_if_statement] = STATE(56),
    [sym_switch_statement] = STATE(56),
    [sym_case_statement] = STATE(56),
    [sym_while_statement] = STATE(56),
    [sym_do_statement] = STATE(56),
    [sym_for_statement] = STATE(56),
    [sym_return_statement] = STATE(56),
    [sym_break_statement] = STATE(56),
    [sym_continue_statement] = STATE(56),
    [sym_goto_statement] = STATE(56),
    [sym_seh_try_statement] = STATE(56),
    [sym_seh_leave_statement] = STATE(56),
    [sym__expression] = STATE(4223),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(7023),
    [sym_initializer_pair] = STATE(7023),
    [sym_subscript_designator] = STATE(6468),
    [sym_subscript_range_designator] = STATE(6468),
    [sym_field_designator] = STATE(6468),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(56),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1888),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(56),
    [sym_template_instantiation] = STATE(56),
    [sym_operator_cast] = STATE(6505),
    [sym__constructor_specifiers] = STATE(1888),
    [sym_operator_cast_definition] = STATE(56),
    [sym_operator_cast_declaration] = STATE(56),
    [sym_constructor_or_destructor_definition] = STATE(56),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(56),
    [sym_namespace_alias_definition] = STATE(56),
    [sym_using_declaration] = STATE(56),
    [sym_alias_declaration] = STATE(56),
    [sym_static_assert_declaration] = STATE(56),
    [sym_concept_definition] = STATE(56),
    [sym_for_range_loop] = STATE(56),
    [sym_co_return_statement] = STATE(56),
    [sym_co_yield_statement] = STATE(56),
    [sym_throw_statement] = STATE(56),
    [sym_try_statement] = STATE(56),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6505),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(56),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_initializer_pair_repeat1] = STATE(6468),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1888),
    [sym_identifier] = ACTIONS(161),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [anon_sym_COMMA] = ACTIONS(167),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(249),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [9] = {
    [sym_preproc_include] = STATE(49),
    [sym_preproc_def] = STATE(49),
    [sym_preproc_function_def] = STATE(49),
    [sym_preproc_call] = STATE(49),
    [sym_preproc_if] = STATE(49),
    [sym_preproc_ifdef] = STATE(49),
    [sym_function_definition] = STATE(49),
    [sym_declaration] = STATE(49),
    [sym_type_definition] = STATE(49),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4541),
    [sym_linkage_specification] = STATE(49),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6129),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(49),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2759),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(49),
    [sym_labeled_statement] = STATE(49),
    [sym_expression_statement] = STATE(49),
    [sym_if_statement] = STATE(49),
    [sym_switch_statement] = STATE(49),
    [sym_case_statement] = STATE(49),
    [sym_while_statement] = STATE(49),
    [sym_do_statement] = STATE(49),
    [sym_for_statement] = STATE(49),
    [sym_return_statement] = STATE(49),
    [sym_break_statement] = STATE(49),
    [sym_continue_statement] = STATE(49),
    [sym_goto_statement] = STATE(49),
    [sym_seh_try_statement] = STATE(49),
    [sym_seh_leave_statement] = STATE(49),
    [sym__expression] = STATE(4223),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(7023),
    [sym_initializer_pair] = STATE(7023),
    [sym_subscript_designator] = STATE(6468),
    [sym_subscript_range_designator] = STATE(6468),
    [sym_field_designator] = STATE(6468),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(49),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1888),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(49),
    [sym_template_instantiation] = STATE(49),
    [sym_operator_cast] = STATE(6505),
    [sym__constructor_specifiers] = STATE(1888),
    [sym_operator_cast_definition] = STATE(49),
    [sym_operator_cast_declaration] = STATE(49),
    [sym_constructor_or_destructor_definition] = STATE(49),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(49),
    [sym_namespace_alias_definition] = STATE(49),
    [sym_using_declaration] = STATE(49),
    [sym_alias_declaration] = STATE(49),
    [sym_static_assert_declaration] = STATE(49),
    [sym_concept_definition] = STATE(49),
    [sym_for_range_loop] = STATE(49),
    [sym_co_return_statement] = STATE(49),
    [sym_co_yield_statement] = STATE(49),
    [sym_throw_statement] = STATE(49),
    [sym_try_statement] = STATE(49),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6505),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(49),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_initializer_pair_repeat1] = STATE(6468),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1888),
    [sym_identifier] = ACTIONS(161),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [anon_sym_COMMA] = ACTIONS(167),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(251),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [10] = {
    [sym_preproc_include] = STATE(69),
    [sym_preproc_def] = STATE(69),
    [sym_preproc_function_def] = STATE(69),
    [sym_preproc_call] = STATE(69),
    [sym_preproc_if] = STATE(69),
    [sym_preproc_ifdef] = STATE(69),
    [sym_function_definition] = STATE(69),
    [sym_declaration] = STATE(69),
    [sym_type_definition] = STATE(69),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4541),
    [sym_linkage_specification] = STATE(69),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6129),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(69),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2759),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(69),
    [sym_labeled_statement] = STATE(69),
    [sym_expression_statement] = STATE(69),
    [sym_if_statement] = STATE(69),
    [sym_switch_statement] = STATE(69),
    [sym_case_statement] = STATE(69),
    [sym_while_statement] = STATE(69),
    [sym_do_statement] = STATE(69),
    [sym_for_statement] = STATE(69),
    [sym_return_statement] = STATE(69),
    [sym_break_statement] = STATE(69),
    [sym_continue_statement] = STATE(69),
    [sym_goto_statement] = STATE(69),
    [sym_seh_try_statement] = STATE(69),
    [sym_seh_leave_statement] = STATE(69),
    [sym__expression] = STATE(4223),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(7023),
    [sym_initializer_pair] = STATE(7023),
    [sym_subscript_designator] = STATE(6468),
    [sym_subscript_range_designator] = STATE(6468),
    [sym_field_designator] = STATE(6468),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(69),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1888),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(69),
    [sym_template_instantiation] = STATE(69),
    [sym_operator_cast] = STATE(6505),
    [sym__constructor_specifiers] = STATE(1888),
    [sym_operator_cast_definition] = STATE(69),
    [sym_operator_cast_declaration] = STATE(69),
    [sym_constructor_or_destructor_definition] = STATE(69),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(69),
    [sym_namespace_alias_definition] = STATE(69),
    [sym_using_declaration] = STATE(69),
    [sym_alias_declaration] = STATE(69),
    [sym_static_assert_declaration] = STATE(69),
    [sym_concept_definition] = STATE(69),
    [sym_for_range_loop] = STATE(69),
    [sym_co_return_statement] = STATE(69),
    [sym_co_yield_statement] = STATE(69),
    [sym_throw_statement] = STATE(69),
    [sym_try_statement] = STATE(69),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6505),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(69),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_initializer_pair_repeat1] = STATE(6468),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1888),
    [sym_identifier] = ACTIONS(161),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [anon_sym_COMMA] = ACTIONS(167),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(253),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [11] = {
    [sym_preproc_include] = STATE(65),
    [sym_preproc_def] = STATE(65),
    [sym_preproc_function_def] = STATE(65),
    [sym_preproc_call] = STATE(65),
    [sym_preproc_if] = STATE(65),
    [sym_preproc_ifdef] = STATE(65),
    [sym_function_definition] = STATE(65),
    [sym_declaration] = STATE(65),
    [sym_type_definition] = STATE(65),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4541),
    [sym_linkage_specification] = STATE(65),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6129),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(65),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2759),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(65),
    [sym_labeled_statement] = STATE(65),
    [sym_expression_statement] = STATE(65),
    [sym_if_statement] = STATE(65),
    [sym_switch_statement] = STATE(65),
    [sym_case_statement] = STATE(65),
    [sym_while_statement] = STATE(65),
    [sym_do_statement] = STATE(65),
    [sym_for_statement] = STATE(65),
    [sym_return_statement] = STATE(65),
    [sym_break_statement] = STATE(65),
    [sym_continue_statement] = STATE(65),
    [sym_goto_statement] = STATE(65),
    [sym_seh_try_statement] = STATE(65),
    [sym_seh_leave_statement] = STATE(65),
    [sym__expression] = STATE(4223),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(7023),
    [sym_initializer_pair] = STATE(7023),
    [sym_subscript_designator] = STATE(6468),
    [sym_subscript_range_designator] = STATE(6468),
    [sym_field_designator] = STATE(6468),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(65),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1888),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(65),
    [sym_template_instantiation] = STATE(65),
    [sym_operator_cast] = STATE(6505),
    [sym__constructor_specifiers] = STATE(1888),
    [sym_operator_cast_definition] = STATE(65),
    [sym_operator_cast_declaration] = STATE(65),
    [sym_constructor_or_destructor_definition] = STATE(65),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(65),
    [sym_namespace_alias_definition] = STATE(65),
    [sym_using_declaration] = STATE(65),
    [sym_alias_declaration] = STATE(65),
    [sym_static_assert_declaration] = STATE(65),
    [sym_concept_definition] = STATE(65),
    [sym_for_range_loop] = STATE(65),
    [sym_co_return_statement] = STATE(65),
    [sym_co_yield_statement] = STATE(65),
    [sym_throw_statement] = STATE(65),
    [sym_try_statement] = STATE(65),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6505),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(65),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_initializer_pair_repeat1] = STATE(6468),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1888),
    [sym_identifier] = ACTIONS(161),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [anon_sym_COMMA] = ACTIONS(167),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(255),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [12] = {
    [sym_preproc_include] = STATE(64),
    [sym_preproc_def] = STATE(64),
    [sym_preproc_function_def] = STATE(64),
    [sym_preproc_call] = STATE(64),
    [sym_preproc_if] = STATE(64),
    [sym_preproc_ifdef] = STATE(64),
    [sym_function_definition] = STATE(64),
    [sym_declaration] = STATE(64),
    [sym_type_definition] = STATE(64),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4541),
    [sym_linkage_specification] = STATE(64),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6129),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(64),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2759),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(64),
    [sym_labeled_statement] = STATE(64),
    [sym_expression_statement] = STATE(64),
    [sym_if_statement] = STATE(64),
    [sym_switch_statement] = STATE(64),
    [sym_case_statement] = STATE(64),
    [sym_while_statement] = STATE(64),
    [sym_do_statement] = STATE(64),
    [sym_for_statement] = STATE(64),
    [sym_return_statement] = STATE(64),
    [sym_break_statement] = STATE(64),
    [sym_continue_statement] = STATE(64),
    [sym_goto_statement] = STATE(64),
    [sym_seh_try_statement] = STATE(64),
    [sym_seh_leave_statement] = STATE(64),
    [sym__expression] = STATE(4223),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(7023),
    [sym_initializer_pair] = STATE(7023),
    [sym_subscript_designator] = STATE(6468),
    [sym_subscript_range_designator] = STATE(6468),
    [sym_field_designator] = STATE(6468),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(64),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1888),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(64),
    [sym_template_instantiation] = STATE(64),
    [sym_operator_cast] = STATE(6505),
    [sym__constructor_specifiers] = STATE(1888),
    [sym_operator_cast_definition] = STATE(64),
    [sym_operator_cast_declaration] = STATE(64),
    [sym_constructor_or_destructor_definition] = STATE(64),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(64),
    [sym_namespace_alias_definition] = STATE(64),
    [sym_using_declaration] = STATE(64),
    [sym_alias_declaration] = STATE(64),
    [sym_static_assert_declaration] = STATE(64),
    [sym_concept_definition] = STATE(64),
    [sym_for_range_loop] = STATE(64),
    [sym_co_return_statement] = STATE(64),
    [sym_co_yield_statement] = STATE(64),
    [sym_throw_statement] = STATE(64),
    [sym_try_statement] = STATE(64),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6505),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(64),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_initializer_pair_repeat1] = STATE(6468),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1888),
    [sym_identifier] = ACTIONS(161),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [anon_sym_COMMA] = ACTIONS(167),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(257),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [13] = {
    [sym_preproc_include] = STATE(33),
    [sym_preproc_def] = STATE(33),
    [sym_preproc_function_def] = STATE(33),
    [sym_preproc_call] = STATE(33),
    [sym_preproc_if] = STATE(33),
    [sym_preproc_ifdef] = STATE(33),
    [sym_preproc_else] = STATE(7907),
    [sym_preproc_elif] = STATE(7907),
    [sym_preproc_elifdef] = STATE(7907),
    [sym_function_definition] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_type_definition] = STATE(33),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4637),
    [sym_linkage_specification] = STATE(33),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1849),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6061),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(33),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2782),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(33),
    [sym_labeled_statement] = STATE(33),
    [sym_expression_statement] = STATE(33),
    [sym_if_statement] = STATE(33),
    [sym_switch_statement] = STATE(33),
    [sym_case_statement] = STATE(33),
    [sym_while_statement] = STATE(33),
    [sym_do_statement] = STATE(33),
    [sym_for_statement] = STATE(33),
    [sym_return_statement] = STATE(33),
    [sym_break_statement] = STATE(33),
    [sym_continue_statement] = STATE(33),
    [sym_goto_statement] = STATE(33),
    [sym_seh_try_statement] = STATE(33),
    [sym_seh_leave_statement] = STATE(33),
    [sym__expression] = STATE(4420),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8126),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(33),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1900),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(33),
    [sym_template_instantiation] = STATE(33),
    [sym_operator_cast] = STATE(6494),
    [sym__constructor_specifiers] = STATE(1900),
    [sym_operator_cast_definition] = STATE(33),
    [sym_operator_cast_declaration] = STATE(33),
    [sym_constructor_or_destructor_definition] = STATE(33),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(33),
    [sym_namespace_alias_definition] = STATE(33),
    [sym_using_declaration] = STATE(33),
    [sym_alias_declaration] = STATE(33),
    [sym_static_assert_declaration] = STATE(33),
    [sym_concept_definition] = STATE(33),
    [sym_for_range_loop] = STATE(33),
    [sym_co_return_statement] = STATE(33),
    [sym_co_yield_statement] = STATE(33),
    [sym_throw_statement] = STATE(33),
    [sym_try_statement] = STATE(33),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6494),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(33),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(176),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1900),
    [sym_identifier] = ACTIONS(259),
    [aux_sym_preproc_include_token1] = ACTIONS(261),
    [aux_sym_preproc_def_token1] = ACTIONS(263),
    [aux_sym_preproc_if_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token2] = ACTIONS(267),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(269),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(269),
    [aux_sym_preproc_else_token1] = ACTIONS(271),
    [aux_sym_preproc_elif_token1] = ACTIONS(273),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(275),
    [sym_preproc_directive] = ACTIONS(277),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(279),
    [anon_sym___extension__] = ACTIONS(281),
    [anon_sym_typedef] = ACTIONS(283),
    [anon_sym_extern] = ACTIONS(285),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(287),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(289),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(291),
    [anon_sym_switch] = ACTIONS(293),
    [anon_sym_case] = ACTIONS(295),
    [anon_sym_default] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(301),
    [anon_sym_for] = ACTIONS(303),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_break] = ACTIONS(307),
    [anon_sym_continue] = ACTIONS(309),
    [anon_sym_goto] = ACTIONS(311),
    [anon_sym___try] = ACTIONS(313),
    [anon_sym___leave] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(317),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(319),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(321),
    [anon_sym_namespace] = ACTIONS(323),
    [anon_sym_using] = ACTIONS(325),
    [anon_sym_static_assert] = ACTIONS(327),
    [anon_sym_concept] = ACTIONS(329),
    [anon_sym_co_return] = ACTIONS(331),
    [anon_sym_co_yield] = ACTIONS(333),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [14] = {
    [sym_preproc_include] = STATE(30),
    [sym_preproc_def] = STATE(30),
    [sym_preproc_function_def] = STATE(30),
    [sym_preproc_call] = STATE(30),
    [sym_preproc_if] = STATE(30),
    [sym_preproc_ifdef] = STATE(30),
    [sym_preproc_else] = STATE(7984),
    [sym_preproc_elif] = STATE(7984),
    [sym_preproc_elifdef] = STATE(7984),
    [sym_function_definition] = STATE(30),
    [sym_declaration] = STATE(30),
    [sym_type_definition] = STATE(30),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4637),
    [sym_linkage_specification] = STATE(30),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1849),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6061),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(30),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2782),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(30),
    [sym_labeled_statement] = STATE(30),
    [sym_expression_statement] = STATE(30),
    [sym_if_statement] = STATE(30),
    [sym_switch_statement] = STATE(30),
    [sym_case_statement] = STATE(30),
    [sym_while_statement] = STATE(30),
    [sym_do_statement] = STATE(30),
    [sym_for_statement] = STATE(30),
    [sym_return_statement] = STATE(30),
    [sym_break_statement] = STATE(30),
    [sym_continue_statement] = STATE(30),
    [sym_goto_statement] = STATE(30),
    [sym_seh_try_statement] = STATE(30),
    [sym_seh_leave_statement] = STATE(30),
    [sym__expression] = STATE(4420),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8126),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(30),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1900),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(30),
    [sym_template_instantiation] = STATE(30),
    [sym_operator_cast] = STATE(6494),
    [sym__constructor_specifiers] = STATE(1900),
    [sym_operator_cast_definition] = STATE(30),
    [sym_operator_cast_declaration] = STATE(30),
    [sym_constructor_or_destructor_definition] = STATE(30),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(30),
    [sym_namespace_alias_definition] = STATE(30),
    [sym_using_declaration] = STATE(30),
    [sym_alias_declaration] = STATE(30),
    [sym_static_assert_declaration] = STATE(30),
    [sym_concept_definition] = STATE(30),
    [sym_for_range_loop] = STATE(30),
    [sym_co_return_statement] = STATE(30),
    [sym_co_yield_statement] = STATE(30),
    [sym_throw_statement] = STATE(30),
    [sym_try_statement] = STATE(30),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6494),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(30),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(176),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1900),
    [sym_identifier] = ACTIONS(259),
    [aux_sym_preproc_include_token1] = ACTIONS(261),
    [aux_sym_preproc_def_token1] = ACTIONS(263),
    [aux_sym_preproc_if_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token2] = ACTIONS(335),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(269),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(269),
    [aux_sym_preproc_else_token1] = ACTIONS(271),
    [aux_sym_preproc_elif_token1] = ACTIONS(273),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(275),
    [sym_preproc_directive] = ACTIONS(277),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(279),
    [anon_sym___extension__] = ACTIONS(281),
    [anon_sym_typedef] = ACTIONS(283),
    [anon_sym_extern] = ACTIONS(285),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(287),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(289),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(291),
    [anon_sym_switch] = ACTIONS(293),
    [anon_sym_case] = ACTIONS(295),
    [anon_sym_default] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(301),
    [anon_sym_for] = ACTIONS(303),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_break] = ACTIONS(307),
    [anon_sym_continue] = ACTIONS(309),
    [anon_sym_goto] = ACTIONS(311),
    [anon_sym___try] = ACTIONS(313),
    [anon_sym___leave] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(317),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(319),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(321),
    [anon_sym_namespace] = ACTIONS(323),
    [anon_sym_using] = ACTIONS(325),
    [anon_sym_static_assert] = ACTIONS(327),
    [anon_sym_concept] = ACTIONS(329),
    [anon_sym_co_return] = ACTIONS(331),
    [anon_sym_co_yield] = ACTIONS(333),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [15] = {
    [sym_preproc_include] = STATE(33),
    [sym_preproc_def] = STATE(33),
    [sym_preproc_function_def] = STATE(33),
    [sym_preproc_call] = STATE(33),
    [sym_preproc_if] = STATE(33),
    [sym_preproc_ifdef] = STATE(33),
    [sym_preproc_else] = STATE(7662),
    [sym_preproc_elif] = STATE(7662),
    [sym_preproc_elifdef] = STATE(7662),
    [sym_function_definition] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_type_definition] = STATE(33),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4637),
    [sym_linkage_specification] = STATE(33),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1849),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6061),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(33),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2782),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(33),
    [sym_labeled_statement] = STATE(33),
    [sym_expression_statement] = STATE(33),
    [sym_if_statement] = STATE(33),
    [sym_switch_statement] = STATE(33),
    [sym_case_statement] = STATE(33),
    [sym_while_statement] = STATE(33),
    [sym_do_statement] = STATE(33),
    [sym_for_statement] = STATE(33),
    [sym_return_statement] = STATE(33),
    [sym_break_statement] = STATE(33),
    [sym_continue_statement] = STATE(33),
    [sym_goto_statement] = STATE(33),
    [sym_seh_try_statement] = STATE(33),
    [sym_seh_leave_statement] = STATE(33),
    [sym__expression] = STATE(4420),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8126),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(33),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1900),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(33),
    [sym_template_instantiation] = STATE(33),
    [sym_operator_cast] = STATE(6494),
    [sym__constructor_specifiers] = STATE(1900),
    [sym_operator_cast_definition] = STATE(33),
    [sym_operator_cast_declaration] = STATE(33),
    [sym_constructor_or_destructor_definition] = STATE(33),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(33),
    [sym_namespace_alias_definition] = STATE(33),
    [sym_using_declaration] = STATE(33),
    [sym_alias_declaration] = STATE(33),
    [sym_static_assert_declaration] = STATE(33),
    [sym_concept_definition] = STATE(33),
    [sym_for_range_loop] = STATE(33),
    [sym_co_return_statement] = STATE(33),
    [sym_co_yield_statement] = STATE(33),
    [sym_throw_statement] = STATE(33),
    [sym_try_statement] = STATE(33),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6494),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(33),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(176),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1900),
    [sym_identifier] = ACTIONS(259),
    [aux_sym_preproc_include_token1] = ACTIONS(261),
    [aux_sym_preproc_def_token1] = ACTIONS(263),
    [aux_sym_preproc_if_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token2] = ACTIONS(337),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(269),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(269),
    [aux_sym_preproc_else_token1] = ACTIONS(271),
    [aux_sym_preproc_elif_token1] = ACTIONS(273),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(275),
    [sym_preproc_directive] = ACTIONS(277),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(279),
    [anon_sym___extension__] = ACTIONS(281),
    [anon_sym_typedef] = ACTIONS(283),
    [anon_sym_extern] = ACTIONS(285),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(287),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(289),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(291),
    [anon_sym_switch] = ACTIONS(293),
    [anon_sym_case] = ACTIONS(295),
    [anon_sym_default] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(301),
    [anon_sym_for] = ACTIONS(303),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_break] = ACTIONS(307),
    [anon_sym_continue] = ACTIONS(309),
    [anon_sym_goto] = ACTIONS(311),
    [anon_sym___try] = ACTIONS(313),
    [anon_sym___leave] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(317),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(319),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(321),
    [anon_sym_namespace] = ACTIONS(323),
    [anon_sym_using] = ACTIONS(325),
    [anon_sym_static_assert] = ACTIONS(327),
    [anon_sym_concept] = ACTIONS(329),
    [anon_sym_co_return] = ACTIONS(331),
    [anon_sym_co_yield] = ACTIONS(333),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [16] = {
    [sym_preproc_include] = STATE(33),
    [sym_preproc_def] = STATE(33),
    [sym_preproc_function_def] = STATE(33),
    [sym_preproc_call] = STATE(33),
    [sym_preproc_if] = STATE(33),
    [sym_preproc_ifdef] = STATE(33),
    [sym_preproc_else] = STATE(7847),
    [sym_preproc_elif] = STATE(7847),
    [sym_preproc_elifdef] = STATE(7847),
    [sym_function_definition] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_type_definition] = STATE(33),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4637),
    [sym_linkage_specification] = STATE(33),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1849),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6061),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(33),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2782),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(33),
    [sym_labeled_statement] = STATE(33),
    [sym_expression_statement] = STATE(33),
    [sym_if_statement] = STATE(33),
    [sym_switch_statement] = STATE(33),
    [sym_case_statement] = STATE(33),
    [sym_while_statement] = STATE(33),
    [sym_do_statement] = STATE(33),
    [sym_for_statement] = STATE(33),
    [sym_return_statement] = STATE(33),
    [sym_break_statement] = STATE(33),
    [sym_continue_statement] = STATE(33),
    [sym_goto_statement] = STATE(33),
    [sym_seh_try_statement] = STATE(33),
    [sym_seh_leave_statement] = STATE(33),
    [sym__expression] = STATE(4420),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8126),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(33),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1900),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(33),
    [sym_template_instantiation] = STATE(33),
    [sym_operator_cast] = STATE(6494),
    [sym__constructor_specifiers] = STATE(1900),
    [sym_operator_cast_definition] = STATE(33),
    [sym_operator_cast_declaration] = STATE(33),
    [sym_constructor_or_destructor_definition] = STATE(33),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(33),
    [sym_namespace_alias_definition] = STATE(33),
    [sym_using_declaration] = STATE(33),
    [sym_alias_declaration] = STATE(33),
    [sym_static_assert_declaration] = STATE(33),
    [sym_concept_definition] = STATE(33),
    [sym_for_range_loop] = STATE(33),
    [sym_co_return_statement] = STATE(33),
    [sym_co_yield_statement] = STATE(33),
    [sym_throw_statement] = STATE(33),
    [sym_try_statement] = STATE(33),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6494),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(33),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(176),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1900),
    [sym_identifier] = ACTIONS(259),
    [aux_sym_preproc_include_token1] = ACTIONS(261),
    [aux_sym_preproc_def_token1] = ACTIONS(263),
    [aux_sym_preproc_if_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token2] = ACTIONS(339),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(269),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(269),
    [aux_sym_preproc_else_token1] = ACTIONS(271),
    [aux_sym_preproc_elif_token1] = ACTIONS(273),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(275),
    [sym_preproc_directive] = ACTIONS(277),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(279),
    [anon_sym___extension__] = ACTIONS(281),
    [anon_sym_typedef] = ACTIONS(283),
    [anon_sym_extern] = ACTIONS(285),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(287),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(289),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(291),
    [anon_sym_switch] = ACTIONS(293),
    [anon_sym_case] = ACTIONS(295),
    [anon_sym_default] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(301),
    [anon_sym_for] = ACTIONS(303),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_break] = ACTIONS(307),
    [anon_sym_continue] = ACTIONS(309),
    [anon_sym_goto] = ACTIONS(311),
    [anon_sym___try] = ACTIONS(313),
    [anon_sym___leave] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(317),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(319),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(321),
    [anon_sym_namespace] = ACTIONS(323),
    [anon_sym_using] = ACTIONS(325),
    [anon_sym_static_assert] = ACTIONS(327),
    [anon_sym_concept] = ACTIONS(329),
    [anon_sym_co_return] = ACTIONS(331),
    [anon_sym_co_yield] = ACTIONS(333),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [17] = {
    [sym_preproc_include] = STATE(33),
    [sym_preproc_def] = STATE(33),
    [sym_preproc_function_def] = STATE(33),
    [sym_preproc_call] = STATE(33),
    [sym_preproc_if] = STATE(33),
    [sym_preproc_ifdef] = STATE(33),
    [sym_preproc_else] = STATE(7621),
    [sym_preproc_elif] = STATE(7621),
    [sym_preproc_elifdef] = STATE(7621),
    [sym_function_definition] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_type_definition] = STATE(33),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4637),
    [sym_linkage_specification] = STATE(33),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1849),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6061),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(33),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2782),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(33),
    [sym_labeled_statement] = STATE(33),
    [sym_expression_statement] = STATE(33),
    [sym_if_statement] = STATE(33),
    [sym_switch_statement] = STATE(33),
    [sym_case_statement] = STATE(33),
    [sym_while_statement] = STATE(33),
    [sym_do_statement] = STATE(33),
    [sym_for_statement] = STATE(33),
    [sym_return_statement] = STATE(33),
    [sym_break_statement] = STATE(33),
    [sym_continue_statement] = STATE(33),
    [sym_goto_statement] = STATE(33),
    [sym_seh_try_statement] = STATE(33),
    [sym_seh_leave_statement] = STATE(33),
    [sym__expression] = STATE(4420),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8126),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(33),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1900),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(33),
    [sym_template_instantiation] = STATE(33),
    [sym_operator_cast] = STATE(6494),
    [sym__constructor_specifiers] = STATE(1900),
    [sym_operator_cast_definition] = STATE(33),
    [sym_operator_cast_declaration] = STATE(33),
    [sym_constructor_or_destructor_definition] = STATE(33),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(33),
    [sym_namespace_alias_definition] = STATE(33),
    [sym_using_declaration] = STATE(33),
    [sym_alias_declaration] = STATE(33),
    [sym_static_assert_declaration] = STATE(33),
    [sym_concept_definition] = STATE(33),
    [sym_for_range_loop] = STATE(33),
    [sym_co_return_statement] = STATE(33),
    [sym_co_yield_statement] = STATE(33),
    [sym_throw_statement] = STATE(33),
    [sym_try_statement] = STATE(33),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6494),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(33),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(176),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1900),
    [sym_identifier] = ACTIONS(259),
    [aux_sym_preproc_include_token1] = ACTIONS(261),
    [aux_sym_preproc_def_token1] = ACTIONS(263),
    [aux_sym_preproc_if_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token2] = ACTIONS(341),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(269),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(269),
    [aux_sym_preproc_else_token1] = ACTIONS(271),
    [aux_sym_preproc_elif_token1] = ACTIONS(273),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(275),
    [sym_preproc_directive] = ACTIONS(277),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(279),
    [anon_sym___extension__] = ACTIONS(281),
    [anon_sym_typedef] = ACTIONS(283),
    [anon_sym_extern] = ACTIONS(285),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(287),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(289),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(291),
    [anon_sym_switch] = ACTIONS(293),
    [anon_sym_case] = ACTIONS(295),
    [anon_sym_default] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(301),
    [anon_sym_for] = ACTIONS(303),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_break] = ACTIONS(307),
    [anon_sym_continue] = ACTIONS(309),
    [anon_sym_goto] = ACTIONS(311),
    [anon_sym___try] = ACTIONS(313),
    [anon_sym___leave] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(317),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(319),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(321),
    [anon_sym_namespace] = ACTIONS(323),
    [anon_sym_using] = ACTIONS(325),
    [anon_sym_static_assert] = ACTIONS(327),
    [anon_sym_concept] = ACTIONS(329),
    [anon_sym_co_return] = ACTIONS(331),
    [anon_sym_co_yield] = ACTIONS(333),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [18] = {
    [sym_preproc_include] = STATE(25),
    [sym_preproc_def] = STATE(25),
    [sym_preproc_function_def] = STATE(25),
    [sym_preproc_call] = STATE(25),
    [sym_preproc_if] = STATE(25),
    [sym_preproc_ifdef] = STATE(25),
    [sym_preproc_else] = STATE(7820),
    [sym_preproc_elif] = STATE(7820),
    [sym_preproc_elifdef] = STATE(7820),
    [sym_function_definition] = STATE(25),
    [sym_declaration] = STATE(25),
    [sym_type_definition] = STATE(25),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4637),
    [sym_linkage_specification] = STATE(25),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1849),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6061),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(25),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2782),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(25),
    [sym_labeled_statement] = STATE(25),
    [sym_expression_statement] = STATE(25),
    [sym_if_statement] = STATE(25),
    [sym_switch_statement] = STATE(25),
    [sym_case_statement] = STATE(25),
    [sym_while_statement] = STATE(25),
    [sym_do_statement] = STATE(25),
    [sym_for_statement] = STATE(25),
    [sym_return_statement] = STATE(25),
    [sym_break_statement] = STATE(25),
    [sym_continue_statement] = STATE(25),
    [sym_goto_statement] = STATE(25),
    [sym_seh_try_statement] = STATE(25),
    [sym_seh_leave_statement] = STATE(25),
    [sym__expression] = STATE(4420),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8126),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(25),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1900),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(25),
    [sym_template_instantiation] = STATE(25),
    [sym_operator_cast] = STATE(6494),
    [sym__constructor_specifiers] = STATE(1900),
    [sym_operator_cast_definition] = STATE(25),
    [sym_operator_cast_declaration] = STATE(25),
    [sym_constructor_or_destructor_definition] = STATE(25),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(25),
    [sym_namespace_alias_definition] = STATE(25),
    [sym_using_declaration] = STATE(25),
    [sym_alias_declaration] = STATE(25),
    [sym_static_assert_declaration] = STATE(25),
    [sym_concept_definition] = STATE(25),
    [sym_for_range_loop] = STATE(25),
    [sym_co_return_statement] = STATE(25),
    [sym_co_yield_statement] = STATE(25),
    [sym_throw_statement] = STATE(25),
    [sym_try_statement] = STATE(25),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6494),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(25),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(176),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1900),
    [sym_identifier] = ACTIONS(259),
    [aux_sym_preproc_include_token1] = ACTIONS(261),
    [aux_sym_preproc_def_token1] = ACTIONS(263),
    [aux_sym_preproc_if_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token2] = ACTIONS(343),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(269),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(269),
    [aux_sym_preproc_else_token1] = ACTIONS(271),
    [aux_sym_preproc_elif_token1] = ACTIONS(273),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(275),
    [sym_preproc_directive] = ACTIONS(277),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(279),
    [anon_sym___extension__] = ACTIONS(281),
    [anon_sym_typedef] = ACTIONS(283),
    [anon_sym_extern] = ACTIONS(285),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(287),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(289),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(291),
    [anon_sym_switch] = ACTIONS(293),
    [anon_sym_case] = ACTIONS(295),
    [anon_sym_default] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(301),
    [anon_sym_for] = ACTIONS(303),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_break] = ACTIONS(307),
    [anon_sym_continue] = ACTIONS(309),
    [anon_sym_goto] = ACTIONS(311),
    [anon_sym___try] = ACTIONS(313),
    [anon_sym___leave] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(317),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(319),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(321),
    [anon_sym_namespace] = ACTIONS(323),
    [anon_sym_using] = ACTIONS(325),
    [anon_sym_static_assert] = ACTIONS(327),
    [anon_sym_concept] = ACTIONS(329),
    [anon_sym_co_return] = ACTIONS(331),
    [anon_sym_co_yield] = ACTIONS(333),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [19] = {
    [sym_preproc_include] = STATE(33),
    [sym_preproc_def] = STATE(33),
    [sym_preproc_function_def] = STATE(33),
    [sym_preproc_call] = STATE(33),
    [sym_preproc_if] = STATE(33),
    [sym_preproc_ifdef] = STATE(33),
    [sym_preproc_else] = STATE(7808),
    [sym_preproc_elif] = STATE(7808),
    [sym_preproc_elifdef] = STATE(7808),
    [sym_function_definition] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_type_definition] = STATE(33),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4637),
    [sym_linkage_specification] = STATE(33),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1849),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6061),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(33),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2782),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(33),
    [sym_labeled_statement] = STATE(33),
    [sym_expression_statement] = STATE(33),
    [sym_if_statement] = STATE(33),
    [sym_switch_statement] = STATE(33),
    [sym_case_statement] = STATE(33),
    [sym_while_statement] = STATE(33),
    [sym_do_statement] = STATE(33),
    [sym_for_statement] = STATE(33),
    [sym_return_statement] = STATE(33),
    [sym_break_statement] = STATE(33),
    [sym_continue_statement] = STATE(33),
    [sym_goto_statement] = STATE(33),
    [sym_seh_try_statement] = STATE(33),
    [sym_seh_leave_statement] = STATE(33),
    [sym__expression] = STATE(4420),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8126),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(33),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1900),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(33),
    [sym_template_instantiation] = STATE(33),
    [sym_operator_cast] = STATE(6494),
    [sym__constructor_specifiers] = STATE(1900),
    [sym_operator_cast_definition] = STATE(33),
    [sym_operator_cast_declaration] = STATE(33),
    [sym_constructor_or_destructor_definition] = STATE(33),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(33),
    [sym_namespace_alias_definition] = STATE(33),
    [sym_using_declaration] = STATE(33),
    [sym_alias_declaration] = STATE(33),
    [sym_static_assert_declaration] = STATE(33),
    [sym_concept_definition] = STATE(33),
    [sym_for_range_loop] = STATE(33),
    [sym_co_return_statement] = STATE(33),
    [sym_co_yield_statement] = STATE(33),
    [sym_throw_statement] = STATE(33),
    [sym_try_statement] = STATE(33),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6494),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(33),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(176),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1900),
    [sym_identifier] = ACTIONS(259),
    [aux_sym_preproc_include_token1] = ACTIONS(261),
    [aux_sym_preproc_def_token1] = ACTIONS(263),
    [aux_sym_preproc_if_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token2] = ACTIONS(345),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(269),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(269),
    [aux_sym_preproc_else_token1] = ACTIONS(271),
    [aux_sym_preproc_elif_token1] = ACTIONS(273),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(275),
    [sym_preproc_directive] = ACTIONS(277),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(279),
    [anon_sym___extension__] = ACTIONS(281),
    [anon_sym_typedef] = ACTIONS(283),
    [anon_sym_extern] = ACTIONS(285),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(287),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(289),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(291),
    [anon_sym_switch] = ACTIONS(293),
    [anon_sym_case] = ACTIONS(295),
    [anon_sym_default] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(301),
    [anon_sym_for] = ACTIONS(303),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_break] = ACTIONS(307),
    [anon_sym_continue] = ACTIONS(309),
    [anon_sym_goto] = ACTIONS(311),
    [anon_sym___try] = ACTIONS(313),
    [anon_sym___leave] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(317),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(319),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(321),
    [anon_sym_namespace] = ACTIONS(323),
    [anon_sym_using] = ACTIONS(325),
    [anon_sym_static_assert] = ACTIONS(327),
    [anon_sym_concept] = ACTIONS(329),
    [anon_sym_co_return] = ACTIONS(331),
    [anon_sym_co_yield] = ACTIONS(333),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [20] = {
    [sym_preproc_include] = STATE(33),
    [sym_preproc_def] = STATE(33),
    [sym_preproc_function_def] = STATE(33),
    [sym_preproc_call] = STATE(33),
    [sym_preproc_if] = STATE(33),
    [sym_preproc_ifdef] = STATE(33),
    [sym_preproc_else] = STATE(7687),
    [sym_preproc_elif] = STATE(7687),
    [sym_preproc_elifdef] = STATE(7687),
    [sym_function_definition] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_type_definition] = STATE(33),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4637),
    [sym_linkage_specification] = STATE(33),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1849),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6061),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(33),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2782),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(33),
    [sym_labeled_statement] = STATE(33),
    [sym_expression_statement] = STATE(33),
    [sym_if_statement] = STATE(33),
    [sym_switch_statement] = STATE(33),
    [sym_case_statement] = STATE(33),
    [sym_while_statement] = STATE(33),
    [sym_do_statement] = STATE(33),
    [sym_for_statement] = STATE(33),
    [sym_return_statement] = STATE(33),
    [sym_break_statement] = STATE(33),
    [sym_continue_statement] = STATE(33),
    [sym_goto_statement] = STATE(33),
    [sym_seh_try_statement] = STATE(33),
    [sym_seh_leave_statement] = STATE(33),
    [sym__expression] = STATE(4420),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8126),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(33),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1900),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(33),
    [sym_template_instantiation] = STATE(33),
    [sym_operator_cast] = STATE(6494),
    [sym__constructor_specifiers] = STATE(1900),
    [sym_operator_cast_definition] = STATE(33),
    [sym_operator_cast_declaration] = STATE(33),
    [sym_constructor_or_destructor_definition] = STATE(33),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(33),
    [sym_namespace_alias_definition] = STATE(33),
    [sym_using_declaration] = STATE(33),
    [sym_alias_declaration] = STATE(33),
    [sym_static_assert_declaration] = STATE(33),
    [sym_concept_definition] = STATE(33),
    [sym_for_range_loop] = STATE(33),
    [sym_co_return_statement] = STATE(33),
    [sym_co_yield_statement] = STATE(33),
    [sym_throw_statement] = STATE(33),
    [sym_try_statement] = STATE(33),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6494),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(33),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(176),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1900),
    [sym_identifier] = ACTIONS(259),
    [aux_sym_preproc_include_token1] = ACTIONS(261),
    [aux_sym_preproc_def_token1] = ACTIONS(263),
    [aux_sym_preproc_if_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token2] = ACTIONS(347),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(269),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(269),
    [aux_sym_preproc_else_token1] = ACTIONS(271),
    [aux_sym_preproc_elif_token1] = ACTIONS(273),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(275),
    [sym_preproc_directive] = ACTIONS(277),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(279),
    [anon_sym___extension__] = ACTIONS(281),
    [anon_sym_typedef] = ACTIONS(283),
    [anon_sym_extern] = ACTIONS(285),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(287),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(289),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(291),
    [anon_sym_switch] = ACTIONS(293),
    [anon_sym_case] = ACTIONS(295),
    [anon_sym_default] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(301),
    [anon_sym_for] = ACTIONS(303),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_break] = ACTIONS(307),
    [anon_sym_continue] = ACTIONS(309),
    [anon_sym_goto] = ACTIONS(311),
    [anon_sym___try] = ACTIONS(313),
    [anon_sym___leave] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(317),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(319),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(321),
    [anon_sym_namespace] = ACTIONS(323),
    [anon_sym_using] = ACTIONS(325),
    [anon_sym_static_assert] = ACTIONS(327),
    [anon_sym_concept] = ACTIONS(329),
    [anon_sym_co_return] = ACTIONS(331),
    [anon_sym_co_yield] = ACTIONS(333),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [21] = {
    [sym_preproc_include] = STATE(32),
    [sym_preproc_def] = STATE(32),
    [sym_preproc_function_def] = STATE(32),
    [sym_preproc_call] = STATE(32),
    [sym_preproc_if] = STATE(32),
    [sym_preproc_ifdef] = STATE(32),
    [sym_preproc_else] = STATE(7738),
    [sym_preproc_elif] = STATE(7738),
    [sym_preproc_elifdef] = STATE(7738),
    [sym_function_definition] = STATE(32),
    [sym_declaration] = STATE(32),
    [sym_type_definition] = STATE(32),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4637),
    [sym_linkage_specification] = STATE(32),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1849),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6061),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(32),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2782),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(32),
    [sym_labeled_statement] = STATE(32),
    [sym_expression_statement] = STATE(32),
    [sym_if_statement] = STATE(32),
    [sym_switch_statement] = STATE(32),
    [sym_case_statement] = STATE(32),
    [sym_while_statement] = STATE(32),
    [sym_do_statement] = STATE(32),
    [sym_for_statement] = STATE(32),
    [sym_return_statement] = STATE(32),
    [sym_break_statement] = STATE(32),
    [sym_continue_statement] = STATE(32),
    [sym_goto_statement] = STATE(32),
    [sym_seh_try_statement] = STATE(32),
    [sym_seh_leave_statement] = STATE(32),
    [sym__expression] = STATE(4420),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8126),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(32),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1900),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(32),
    [sym_template_instantiation] = STATE(32),
    [sym_operator_cast] = STATE(6494),
    [sym__constructor_specifiers] = STATE(1900),
    [sym_operator_cast_definition] = STATE(32),
    [sym_operator_cast_declaration] = STATE(32),
    [sym_constructor_or_destructor_definition] = STATE(32),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(32),
    [sym_namespace_alias_definition] = STATE(32),
    [sym_using_declaration] = STATE(32),
    [sym_alias_declaration] = STATE(32),
    [sym_static_assert_declaration] = STATE(32),
    [sym_concept_definition] = STATE(32),
    [sym_for_range_loop] = STATE(32),
    [sym_co_return_statement] = STATE(32),
    [sym_co_yield_statement] = STATE(32),
    [sym_throw_statement] = STATE(32),
    [sym_try_statement] = STATE(32),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6494),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(32),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(176),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1900),
    [sym_identifier] = ACTIONS(259),
    [aux_sym_preproc_include_token1] = ACTIONS(261),
    [aux_sym_preproc_def_token1] = ACTIONS(263),
    [aux_sym_preproc_if_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token2] = ACTIONS(349),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(269),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(269),
    [aux_sym_preproc_else_token1] = ACTIONS(271),
    [aux_sym_preproc_elif_token1] = ACTIONS(273),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(275),
    [sym_preproc_directive] = ACTIONS(277),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(279),
    [anon_sym___extension__] = ACTIONS(281),
    [anon_sym_typedef] = ACTIONS(283),
    [anon_sym_extern] = ACTIONS(285),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(287),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(289),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(291),
    [anon_sym_switch] = ACTIONS(293),
    [anon_sym_case] = ACTIONS(295),
    [anon_sym_default] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(301),
    [anon_sym_for] = ACTIONS(303),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_break] = ACTIONS(307),
    [anon_sym_continue] = ACTIONS(309),
    [anon_sym_goto] = ACTIONS(311),
    [anon_sym___try] = ACTIONS(313),
    [anon_sym___leave] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(317),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(319),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(321),
    [anon_sym_namespace] = ACTIONS(323),
    [anon_sym_using] = ACTIONS(325),
    [anon_sym_static_assert] = ACTIONS(327),
    [anon_sym_concept] = ACTIONS(329),
    [anon_sym_co_return] = ACTIONS(331),
    [anon_sym_co_yield] = ACTIONS(333),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [22] = {
    [sym_preproc_include] = STATE(20),
    [sym_preproc_def] = STATE(20),
    [sym_preproc_function_def] = STATE(20),
    [sym_preproc_call] = STATE(20),
    [sym_preproc_if] = STATE(20),
    [sym_preproc_ifdef] = STATE(20),
    [sym_preproc_else] = STATE(7634),
    [sym_preproc_elif] = STATE(7634),
    [sym_preproc_elifdef] = STATE(7634),
    [sym_function_definition] = STATE(20),
    [sym_declaration] = STATE(20),
    [sym_type_definition] = STATE(20),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4637),
    [sym_linkage_specification] = STATE(20),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1849),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6061),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(20),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2782),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(20),
    [sym_labeled_statement] = STATE(20),
    [sym_expression_statement] = STATE(20),
    [sym_if_statement] = STATE(20),
    [sym_switch_statement] = STATE(20),
    [sym_case_statement] = STATE(20),
    [sym_while_statement] = STATE(20),
    [sym_do_statement] = STATE(20),
    [sym_for_statement] = STATE(20),
    [sym_return_statement] = STATE(20),
    [sym_break_statement] = STATE(20),
    [sym_continue_statement] = STATE(20),
    [sym_goto_statement] = STATE(20),
    [sym_seh_try_statement] = STATE(20),
    [sym_seh_leave_statement] = STATE(20),
    [sym__expression] = STATE(4420),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8126),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(20),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1900),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(20),
    [sym_template_instantiation] = STATE(20),
    [sym_operator_cast] = STATE(6494),
    [sym__constructor_specifiers] = STATE(1900),
    [sym_operator_cast_definition] = STATE(20),
    [sym_operator_cast_declaration] = STATE(20),
    [sym_constructor_or_destructor_definition] = STATE(20),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(20),
    [sym_namespace_alias_definition] = STATE(20),
    [sym_using_declaration] = STATE(20),
    [sym_alias_declaration] = STATE(20),
    [sym_static_assert_declaration] = STATE(20),
    [sym_concept_definition] = STATE(20),
    [sym_for_range_loop] = STATE(20),
    [sym_co_return_statement] = STATE(20),
    [sym_co_yield_statement] = STATE(20),
    [sym_throw_statement] = STATE(20),
    [sym_try_statement] = STATE(20),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6494),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(20),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(176),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1900),
    [sym_identifier] = ACTIONS(259),
    [aux_sym_preproc_include_token1] = ACTIONS(261),
    [aux_sym_preproc_def_token1] = ACTIONS(263),
    [aux_sym_preproc_if_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token2] = ACTIONS(351),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(269),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(269),
    [aux_sym_preproc_else_token1] = ACTIONS(271),
    [aux_sym_preproc_elif_token1] = ACTIONS(273),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(275),
    [sym_preproc_directive] = ACTIONS(277),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(279),
    [anon_sym___extension__] = ACTIONS(281),
    [anon_sym_typedef] = ACTIONS(283),
    [anon_sym_extern] = ACTIONS(285),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(287),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(289),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(291),
    [anon_sym_switch] = ACTIONS(293),
    [anon_sym_case] = ACTIONS(295),
    [anon_sym_default] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(301),
    [anon_sym_for] = ACTIONS(303),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_break] = ACTIONS(307),
    [anon_sym_continue] = ACTIONS(309),
    [anon_sym_goto] = ACTIONS(311),
    [anon_sym___try] = ACTIONS(313),
    [anon_sym___leave] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(317),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(319),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(321),
    [anon_sym_namespace] = ACTIONS(323),
    [anon_sym_using] = ACTIONS(325),
    [anon_sym_static_assert] = ACTIONS(327),
    [anon_sym_concept] = ACTIONS(329),
    [anon_sym_co_return] = ACTIONS(331),
    [anon_sym_co_yield] = ACTIONS(333),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [23] = {
    [sym_preproc_include] = STATE(28),
    [sym_preproc_def] = STATE(28),
    [sym_preproc_function_def] = STATE(28),
    [sym_preproc_call] = STATE(28),
    [sym_preproc_if] = STATE(28),
    [sym_preproc_ifdef] = STATE(28),
    [sym_preproc_else] = STATE(7637),
    [sym_preproc_elif] = STATE(7637),
    [sym_preproc_elifdef] = STATE(7637),
    [sym_function_definition] = STATE(28),
    [sym_declaration] = STATE(28),
    [sym_type_definition] = STATE(28),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4637),
    [sym_linkage_specification] = STATE(28),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1849),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6061),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(28),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2782),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(28),
    [sym_labeled_statement] = STATE(28),
    [sym_expression_statement] = STATE(28),
    [sym_if_statement] = STATE(28),
    [sym_switch_statement] = STATE(28),
    [sym_case_statement] = STATE(28),
    [sym_while_statement] = STATE(28),
    [sym_do_statement] = STATE(28),
    [sym_for_statement] = STATE(28),
    [sym_return_statement] = STATE(28),
    [sym_break_statement] = STATE(28),
    [sym_continue_statement] = STATE(28),
    [sym_goto_statement] = STATE(28),
    [sym_seh_try_statement] = STATE(28),
    [sym_seh_leave_statement] = STATE(28),
    [sym__expression] = STATE(4420),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8126),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(28),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1900),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(28),
    [sym_template_instantiation] = STATE(28),
    [sym_operator_cast] = STATE(6494),
    [sym__constructor_specifiers] = STATE(1900),
    [sym_operator_cast_definition] = STATE(28),
    [sym_operator_cast_declaration] = STATE(28),
    [sym_constructor_or_destructor_definition] = STATE(28),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(28),
    [sym_namespace_alias_definition] = STATE(28),
    [sym_using_declaration] = STATE(28),
    [sym_alias_declaration] = STATE(28),
    [sym_static_assert_declaration] = STATE(28),
    [sym_concept_definition] = STATE(28),
    [sym_for_range_loop] = STATE(28),
    [sym_co_return_statement] = STATE(28),
    [sym_co_yield_statement] = STATE(28),
    [sym_throw_statement] = STATE(28),
    [sym_try_statement] = STATE(28),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6494),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(28),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(176),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1900),
    [sym_identifier] = ACTIONS(259),
    [aux_sym_preproc_include_token1] = ACTIONS(261),
    [aux_sym_preproc_def_token1] = ACTIONS(263),
    [aux_sym_preproc_if_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token2] = ACTIONS(353),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(269),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(269),
    [aux_sym_preproc_else_token1] = ACTIONS(271),
    [aux_sym_preproc_elif_token1] = ACTIONS(273),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(275),
    [sym_preproc_directive] = ACTIONS(277),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(279),
    [anon_sym___extension__] = ACTIONS(281),
    [anon_sym_typedef] = ACTIONS(283),
    [anon_sym_extern] = ACTIONS(285),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(287),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(289),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(291),
    [anon_sym_switch] = ACTIONS(293),
    [anon_sym_case] = ACTIONS(295),
    [anon_sym_default] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(301),
    [anon_sym_for] = ACTIONS(303),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_break] = ACTIONS(307),
    [anon_sym_continue] = ACTIONS(309),
    [anon_sym_goto] = ACTIONS(311),
    [anon_sym___try] = ACTIONS(313),
    [anon_sym___leave] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(317),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(319),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(321),
    [anon_sym_namespace] = ACTIONS(323),
    [anon_sym_using] = ACTIONS(325),
    [anon_sym_static_assert] = ACTIONS(327),
    [anon_sym_concept] = ACTIONS(329),
    [anon_sym_co_return] = ACTIONS(331),
    [anon_sym_co_yield] = ACTIONS(333),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [24] = {
    [sym_preproc_include] = STATE(19),
    [sym_preproc_def] = STATE(19),
    [sym_preproc_function_def] = STATE(19),
    [sym_preproc_call] = STATE(19),
    [sym_preproc_if] = STATE(19),
    [sym_preproc_ifdef] = STATE(19),
    [sym_preproc_else] = STATE(7913),
    [sym_preproc_elif] = STATE(7913),
    [sym_preproc_elifdef] = STATE(7913),
    [sym_function_definition] = STATE(19),
    [sym_declaration] = STATE(19),
    [sym_type_definition] = STATE(19),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4637),
    [sym_linkage_specification] = STATE(19),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1849),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6061),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(19),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2782),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(19),
    [sym_labeled_statement] = STATE(19),
    [sym_expression_statement] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_switch_statement] = STATE(19),
    [sym_case_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_do_statement] = STATE(19),
    [sym_for_statement] = STATE(19),
    [sym_return_statement] = STATE(19),
    [sym_break_statement] = STATE(19),
    [sym_continue_statement] = STATE(19),
    [sym_goto_statement] = STATE(19),
    [sym_seh_try_statement] = STATE(19),
    [sym_seh_leave_statement] = STATE(19),
    [sym__expression] = STATE(4420),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8126),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(19),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1900),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(19),
    [sym_template_instantiation] = STATE(19),
    [sym_operator_cast] = STATE(6494),
    [sym__constructor_specifiers] = STATE(1900),
    [sym_operator_cast_definition] = STATE(19),
    [sym_operator_cast_declaration] = STATE(19),
    [sym_constructor_or_destructor_definition] = STATE(19),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(19),
    [sym_namespace_alias_definition] = STATE(19),
    [sym_using_declaration] = STATE(19),
    [sym_alias_declaration] = STATE(19),
    [sym_static_assert_declaration] = STATE(19),
    [sym_concept_definition] = STATE(19),
    [sym_for_range_loop] = STATE(19),
    [sym_co_return_statement] = STATE(19),
    [sym_co_yield_statement] = STATE(19),
    [sym_throw_statement] = STATE(19),
    [sym_try_statement] = STATE(19),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6494),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(19),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(176),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1900),
    [sym_identifier] = ACTIONS(259),
    [aux_sym_preproc_include_token1] = ACTIONS(261),
    [aux_sym_preproc_def_token1] = ACTIONS(263),
    [aux_sym_preproc_if_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token2] = ACTIONS(355),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(269),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(269),
    [aux_sym_preproc_else_token1] = ACTIONS(271),
    [aux_sym_preproc_elif_token1] = ACTIONS(273),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(275),
    [sym_preproc_directive] = ACTIONS(277),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(279),
    [anon_sym___extension__] = ACTIONS(281),
    [anon_sym_typedef] = ACTIONS(283),
    [anon_sym_extern] = ACTIONS(285),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(287),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(289),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(291),
    [anon_sym_switch] = ACTIONS(293),
    [anon_sym_case] = ACTIONS(295),
    [anon_sym_default] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(301),
    [anon_sym_for] = ACTIONS(303),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_break] = ACTIONS(307),
    [anon_sym_continue] = ACTIONS(309),
    [anon_sym_goto] = ACTIONS(311),
    [anon_sym___try] = ACTIONS(313),
    [anon_sym___leave] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(317),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(319),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(321),
    [anon_sym_namespace] = ACTIONS(323),
    [anon_sym_using] = ACTIONS(325),
    [anon_sym_static_assert] = ACTIONS(327),
    [anon_sym_concept] = ACTIONS(329),
    [anon_sym_co_return] = ACTIONS(331),
    [anon_sym_co_yield] = ACTIONS(333),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [25] = {
    [sym_preproc_include] = STATE(33),
    [sym_preproc_def] = STATE(33),
    [sym_preproc_function_def] = STATE(33),
    [sym_preproc_call] = STATE(33),
    [sym_preproc_if] = STATE(33),
    [sym_preproc_ifdef] = STATE(33),
    [sym_preproc_else] = STATE(7639),
    [sym_preproc_elif] = STATE(7639),
    [sym_preproc_elifdef] = STATE(7639),
    [sym_function_definition] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_type_definition] = STATE(33),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4637),
    [sym_linkage_specification] = STATE(33),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1849),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6061),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(33),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2782),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(33),
    [sym_labeled_statement] = STATE(33),
    [sym_expression_statement] = STATE(33),
    [sym_if_statement] = STATE(33),
    [sym_switch_statement] = STATE(33),
    [sym_case_statement] = STATE(33),
    [sym_while_statement] = STATE(33),
    [sym_do_statement] = STATE(33),
    [sym_for_statement] = STATE(33),
    [sym_return_statement] = STATE(33),
    [sym_break_statement] = STATE(33),
    [sym_continue_statement] = STATE(33),
    [sym_goto_statement] = STATE(33),
    [sym_seh_try_statement] = STATE(33),
    [sym_seh_leave_statement] = STATE(33),
    [sym__expression] = STATE(4420),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8126),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(33),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1900),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(33),
    [sym_template_instantiation] = STATE(33),
    [sym_operator_cast] = STATE(6494),
    [sym__constructor_specifiers] = STATE(1900),
    [sym_operator_cast_definition] = STATE(33),
    [sym_operator_cast_declaration] = STATE(33),
    [sym_constructor_or_destructor_definition] = STATE(33),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(33),
    [sym_namespace_alias_definition] = STATE(33),
    [sym_using_declaration] = STATE(33),
    [sym_alias_declaration] = STATE(33),
    [sym_static_assert_declaration] = STATE(33),
    [sym_concept_definition] = STATE(33),
    [sym_for_range_loop] = STATE(33),
    [sym_co_return_statement] = STATE(33),
    [sym_co_yield_statement] = STATE(33),
    [sym_throw_statement] = STATE(33),
    [sym_try_statement] = STATE(33),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6494),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(33),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(176),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1900),
    [sym_identifier] = ACTIONS(259),
    [aux_sym_preproc_include_token1] = ACTIONS(261),
    [aux_sym_preproc_def_token1] = ACTIONS(263),
    [aux_sym_preproc_if_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token2] = ACTIONS(357),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(269),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(269),
    [aux_sym_preproc_else_token1] = ACTIONS(271),
    [aux_sym_preproc_elif_token1] = ACTIONS(273),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(275),
    [sym_preproc_directive] = ACTIONS(277),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(279),
    [anon_sym___extension__] = ACTIONS(281),
    [anon_sym_typedef] = ACTIONS(283),
    [anon_sym_extern] = ACTIONS(285),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(287),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(289),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(291),
    [anon_sym_switch] = ACTIONS(293),
    [anon_sym_case] = ACTIONS(295),
    [anon_sym_default] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(301),
    [anon_sym_for] = ACTIONS(303),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_break] = ACTIONS(307),
    [anon_sym_continue] = ACTIONS(309),
    [anon_sym_goto] = ACTIONS(311),
    [anon_sym___try] = ACTIONS(313),
    [anon_sym___leave] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(317),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(319),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(321),
    [anon_sym_namespace] = ACTIONS(323),
    [anon_sym_using] = ACTIONS(325),
    [anon_sym_static_assert] = ACTIONS(327),
    [anon_sym_concept] = ACTIONS(329),
    [anon_sym_co_return] = ACTIONS(331),
    [anon_sym_co_yield] = ACTIONS(333),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [26] = {
    [sym_preproc_include] = STATE(17),
    [sym_preproc_def] = STATE(17),
    [sym_preproc_function_def] = STATE(17),
    [sym_preproc_call] = STATE(17),
    [sym_preproc_if] = STATE(17),
    [sym_preproc_ifdef] = STATE(17),
    [sym_preproc_else] = STATE(7879),
    [sym_preproc_elif] = STATE(7879),
    [sym_preproc_elifdef] = STATE(7879),
    [sym_function_definition] = STATE(17),
    [sym_declaration] = STATE(17),
    [sym_type_definition] = STATE(17),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4637),
    [sym_linkage_specification] = STATE(17),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1849),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6061),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(17),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2782),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(17),
    [sym_labeled_statement] = STATE(17),
    [sym_expression_statement] = STATE(17),
    [sym_if_statement] = STATE(17),
    [sym_switch_statement] = STATE(17),
    [sym_case_statement] = STATE(17),
    [sym_while_statement] = STATE(17),
    [sym_do_statement] = STATE(17),
    [sym_for_statement] = STATE(17),
    [sym_return_statement] = STATE(17),
    [sym_break_statement] = STATE(17),
    [sym_continue_statement] = STATE(17),
    [sym_goto_statement] = STATE(17),
    [sym_seh_try_statement] = STATE(17),
    [sym_seh_leave_statement] = STATE(17),
    [sym__expression] = STATE(4420),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8126),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(17),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1900),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(17),
    [sym_template_instantiation] = STATE(17),
    [sym_operator_cast] = STATE(6494),
    [sym__constructor_specifiers] = STATE(1900),
    [sym_operator_cast_definition] = STATE(17),
    [sym_operator_cast_declaration] = STATE(17),
    [sym_constructor_or_destructor_definition] = STATE(17),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(17),
    [sym_namespace_alias_definition] = STATE(17),
    [sym_using_declaration] = STATE(17),
    [sym_alias_declaration] = STATE(17),
    [sym_static_assert_declaration] = STATE(17),
    [sym_concept_definition] = STATE(17),
    [sym_for_range_loop] = STATE(17),
    [sym_co_return_statement] = STATE(17),
    [sym_co_yield_statement] = STATE(17),
    [sym_throw_statement] = STATE(17),
    [sym_try_statement] = STATE(17),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6494),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(17),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(176),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1900),
    [sym_identifier] = ACTIONS(259),
    [aux_sym_preproc_include_token1] = ACTIONS(261),
    [aux_sym_preproc_def_token1] = ACTIONS(263),
    [aux_sym_preproc_if_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token2] = ACTIONS(359),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(269),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(269),
    [aux_sym_preproc_else_token1] = ACTIONS(271),
    [aux_sym_preproc_elif_token1] = ACTIONS(273),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(275),
    [sym_preproc_directive] = ACTIONS(277),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(279),
    [anon_sym___extension__] = ACTIONS(281),
    [anon_sym_typedef] = ACTIONS(283),
    [anon_sym_extern] = ACTIONS(285),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(287),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(289),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(291),
    [anon_sym_switch] = ACTIONS(293),
    [anon_sym_case] = ACTIONS(295),
    [anon_sym_default] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(301),
    [anon_sym_for] = ACTIONS(303),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_break] = ACTIONS(307),
    [anon_sym_continue] = ACTIONS(309),
    [anon_sym_goto] = ACTIONS(311),
    [anon_sym___try] = ACTIONS(313),
    [anon_sym___leave] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(317),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(319),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(321),
    [anon_sym_namespace] = ACTIONS(323),
    [anon_sym_using] = ACTIONS(325),
    [anon_sym_static_assert] = ACTIONS(327),
    [anon_sym_concept] = ACTIONS(329),
    [anon_sym_co_return] = ACTIONS(331),
    [anon_sym_co_yield] = ACTIONS(333),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [27] = {
    [sym_preproc_include] = STATE(16),
    [sym_preproc_def] = STATE(16),
    [sym_preproc_function_def] = STATE(16),
    [sym_preproc_call] = STATE(16),
    [sym_preproc_if] = STATE(16),
    [sym_preproc_ifdef] = STATE(16),
    [sym_preproc_else] = STATE(7977),
    [sym_preproc_elif] = STATE(7977),
    [sym_preproc_elifdef] = STATE(7977),
    [sym_function_definition] = STATE(16),
    [sym_declaration] = STATE(16),
    [sym_type_definition] = STATE(16),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4637),
    [sym_linkage_specification] = STATE(16),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1849),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6061),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(16),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2782),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(16),
    [sym_labeled_statement] = STATE(16),
    [sym_expression_statement] = STATE(16),
    [sym_if_statement] = STATE(16),
    [sym_switch_statement] = STATE(16),
    [sym_case_statement] = STATE(16),
    [sym_while_statement] = STATE(16),
    [sym_do_statement] = STATE(16),
    [sym_for_statement] = STATE(16),
    [sym_return_statement] = STATE(16),
    [sym_break_statement] = STATE(16),
    [sym_continue_statement] = STATE(16),
    [sym_goto_statement] = STATE(16),
    [sym_seh_try_statement] = STATE(16),
    [sym_seh_leave_statement] = STATE(16),
    [sym__expression] = STATE(4420),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8126),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(16),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1900),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(16),
    [sym_template_instantiation] = STATE(16),
    [sym_operator_cast] = STATE(6494),
    [sym__constructor_specifiers] = STATE(1900),
    [sym_operator_cast_definition] = STATE(16),
    [sym_operator_cast_declaration] = STATE(16),
    [sym_constructor_or_destructor_definition] = STATE(16),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(16),
    [sym_namespace_alias_definition] = STATE(16),
    [sym_using_declaration] = STATE(16),
    [sym_alias_declaration] = STATE(16),
    [sym_static_assert_declaration] = STATE(16),
    [sym_concept_definition] = STATE(16),
    [sym_for_range_loop] = STATE(16),
    [sym_co_return_statement] = STATE(16),
    [sym_co_yield_statement] = STATE(16),
    [sym_throw_statement] = STATE(16),
    [sym_try_statement] = STATE(16),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6494),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(16),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(176),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1900),
    [sym_identifier] = ACTIONS(259),
    [aux_sym_preproc_include_token1] = ACTIONS(261),
    [aux_sym_preproc_def_token1] = ACTIONS(263),
    [aux_sym_preproc_if_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token2] = ACTIONS(361),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(269),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(269),
    [aux_sym_preproc_else_token1] = ACTIONS(271),
    [aux_sym_preproc_elif_token1] = ACTIONS(273),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(275),
    [sym_preproc_directive] = ACTIONS(277),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(279),
    [anon_sym___extension__] = ACTIONS(281),
    [anon_sym_typedef] = ACTIONS(283),
    [anon_sym_extern] = ACTIONS(285),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(287),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(289),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(291),
    [anon_sym_switch] = ACTIONS(293),
    [anon_sym_case] = ACTIONS(295),
    [anon_sym_default] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(301),
    [anon_sym_for] = ACTIONS(303),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_break] = ACTIONS(307),
    [anon_sym_continue] = ACTIONS(309),
    [anon_sym_goto] = ACTIONS(311),
    [anon_sym___try] = ACTIONS(313),
    [anon_sym___leave] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(317),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(319),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(321),
    [anon_sym_namespace] = ACTIONS(323),
    [anon_sym_using] = ACTIONS(325),
    [anon_sym_static_assert] = ACTIONS(327),
    [anon_sym_concept] = ACTIONS(329),
    [anon_sym_co_return] = ACTIONS(331),
    [anon_sym_co_yield] = ACTIONS(333),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [28] = {
    [sym_preproc_include] = STATE(33),
    [sym_preproc_def] = STATE(33),
    [sym_preproc_function_def] = STATE(33),
    [sym_preproc_call] = STATE(33),
    [sym_preproc_if] = STATE(33),
    [sym_preproc_ifdef] = STATE(33),
    [sym_preproc_else] = STATE(8190),
    [sym_preproc_elif] = STATE(8190),
    [sym_preproc_elifdef] = STATE(8190),
    [sym_function_definition] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_type_definition] = STATE(33),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4637),
    [sym_linkage_specification] = STATE(33),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1849),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6061),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(33),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2782),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(33),
    [sym_labeled_statement] = STATE(33),
    [sym_expression_statement] = STATE(33),
    [sym_if_statement] = STATE(33),
    [sym_switch_statement] = STATE(33),
    [sym_case_statement] = STATE(33),
    [sym_while_statement] = STATE(33),
    [sym_do_statement] = STATE(33),
    [sym_for_statement] = STATE(33),
    [sym_return_statement] = STATE(33),
    [sym_break_statement] = STATE(33),
    [sym_continue_statement] = STATE(33),
    [sym_goto_statement] = STATE(33),
    [sym_seh_try_statement] = STATE(33),
    [sym_seh_leave_statement] = STATE(33),
    [sym__expression] = STATE(4420),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8126),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(33),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1900),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(33),
    [sym_template_instantiation] = STATE(33),
    [sym_operator_cast] = STATE(6494),
    [sym__constructor_specifiers] = STATE(1900),
    [sym_operator_cast_definition] = STATE(33),
    [sym_operator_cast_declaration] = STATE(33),
    [sym_constructor_or_destructor_definition] = STATE(33),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(33),
    [sym_namespace_alias_definition] = STATE(33),
    [sym_using_declaration] = STATE(33),
    [sym_alias_declaration] = STATE(33),
    [sym_static_assert_declaration] = STATE(33),
    [sym_concept_definition] = STATE(33),
    [sym_for_range_loop] = STATE(33),
    [sym_co_return_statement] = STATE(33),
    [sym_co_yield_statement] = STATE(33),
    [sym_throw_statement] = STATE(33),
    [sym_try_statement] = STATE(33),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6494),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(33),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(176),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1900),
    [sym_identifier] = ACTIONS(259),
    [aux_sym_preproc_include_token1] = ACTIONS(261),
    [aux_sym_preproc_def_token1] = ACTIONS(263),
    [aux_sym_preproc_if_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token2] = ACTIONS(363),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(269),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(269),
    [aux_sym_preproc_else_token1] = ACTIONS(271),
    [aux_sym_preproc_elif_token1] = ACTIONS(273),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(275),
    [sym_preproc_directive] = ACTIONS(277),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(279),
    [anon_sym___extension__] = ACTIONS(281),
    [anon_sym_typedef] = ACTIONS(283),
    [anon_sym_extern] = ACTIONS(285),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(287),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(289),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(291),
    [anon_sym_switch] = ACTIONS(293),
    [anon_sym_case] = ACTIONS(295),
    [anon_sym_default] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(301),
    [anon_sym_for] = ACTIONS(303),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_break] = ACTIONS(307),
    [anon_sym_continue] = ACTIONS(309),
    [anon_sym_goto] = ACTIONS(311),
    [anon_sym___try] = ACTIONS(313),
    [anon_sym___leave] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(317),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(319),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(321),
    [anon_sym_namespace] = ACTIONS(323),
    [anon_sym_using] = ACTIONS(325),
    [anon_sym_static_assert] = ACTIONS(327),
    [anon_sym_concept] = ACTIONS(329),
    [anon_sym_co_return] = ACTIONS(331),
    [anon_sym_co_yield] = ACTIONS(333),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [29] = {
    [sym_preproc_include] = STATE(13),
    [sym_preproc_def] = STATE(13),
    [sym_preproc_function_def] = STATE(13),
    [sym_preproc_call] = STATE(13),
    [sym_preproc_if] = STATE(13),
    [sym_preproc_ifdef] = STATE(13),
    [sym_preproc_else] = STATE(8035),
    [sym_preproc_elif] = STATE(8035),
    [sym_preproc_elifdef] = STATE(8035),
    [sym_function_definition] = STATE(13),
    [sym_declaration] = STATE(13),
    [sym_type_definition] = STATE(13),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4637),
    [sym_linkage_specification] = STATE(13),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1849),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6061),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(13),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2782),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(13),
    [sym_labeled_statement] = STATE(13),
    [sym_expression_statement] = STATE(13),
    [sym_if_statement] = STATE(13),
    [sym_switch_statement] = STATE(13),
    [sym_case_statement] = STATE(13),
    [sym_while_statement] = STATE(13),
    [sym_do_statement] = STATE(13),
    [sym_for_statement] = STATE(13),
    [sym_return_statement] = STATE(13),
    [sym_break_statement] = STATE(13),
    [sym_continue_statement] = STATE(13),
    [sym_goto_statement] = STATE(13),
    [sym_seh_try_statement] = STATE(13),
    [sym_seh_leave_statement] = STATE(13),
    [sym__expression] = STATE(4420),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8126),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(13),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1900),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(13),
    [sym_template_instantiation] = STATE(13),
    [sym_operator_cast] = STATE(6494),
    [sym__constructor_specifiers] = STATE(1900),
    [sym_operator_cast_definition] = STATE(13),
    [sym_operator_cast_declaration] = STATE(13),
    [sym_constructor_or_destructor_definition] = STATE(13),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(13),
    [sym_namespace_alias_definition] = STATE(13),
    [sym_using_declaration] = STATE(13),
    [sym_alias_declaration] = STATE(13),
    [sym_static_assert_declaration] = STATE(13),
    [sym_concept_definition] = STATE(13),
    [sym_for_range_loop] = STATE(13),
    [sym_co_return_statement] = STATE(13),
    [sym_co_yield_statement] = STATE(13),
    [sym_throw_statement] = STATE(13),
    [sym_try_statement] = STATE(13),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6494),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(13),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(176),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1900),
    [sym_identifier] = ACTIONS(259),
    [aux_sym_preproc_include_token1] = ACTIONS(261),
    [aux_sym_preproc_def_token1] = ACTIONS(263),
    [aux_sym_preproc_if_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token2] = ACTIONS(365),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(269),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(269),
    [aux_sym_preproc_else_token1] = ACTIONS(271),
    [aux_sym_preproc_elif_token1] = ACTIONS(273),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(275),
    [sym_preproc_directive] = ACTIONS(277),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(279),
    [anon_sym___extension__] = ACTIONS(281),
    [anon_sym_typedef] = ACTIONS(283),
    [anon_sym_extern] = ACTIONS(285),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(287),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(289),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(291),
    [anon_sym_switch] = ACTIONS(293),
    [anon_sym_case] = ACTIONS(295),
    [anon_sym_default] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(301),
    [anon_sym_for] = ACTIONS(303),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_break] = ACTIONS(307),
    [anon_sym_continue] = ACTIONS(309),
    [anon_sym_goto] = ACTIONS(311),
    [anon_sym___try] = ACTIONS(313),
    [anon_sym___leave] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(317),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(319),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(321),
    [anon_sym_namespace] = ACTIONS(323),
    [anon_sym_using] = ACTIONS(325),
    [anon_sym_static_assert] = ACTIONS(327),
    [anon_sym_concept] = ACTIONS(329),
    [anon_sym_co_return] = ACTIONS(331),
    [anon_sym_co_yield] = ACTIONS(333),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [30] = {
    [sym_preproc_include] = STATE(33),
    [sym_preproc_def] = STATE(33),
    [sym_preproc_function_def] = STATE(33),
    [sym_preproc_call] = STATE(33),
    [sym_preproc_if] = STATE(33),
    [sym_preproc_ifdef] = STATE(33),
    [sym_preproc_else] = STATE(8266),
    [sym_preproc_elif] = STATE(8266),
    [sym_preproc_elifdef] = STATE(8266),
    [sym_function_definition] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_type_definition] = STATE(33),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4637),
    [sym_linkage_specification] = STATE(33),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1849),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6061),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(33),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2782),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(33),
    [sym_labeled_statement] = STATE(33),
    [sym_expression_statement] = STATE(33),
    [sym_if_statement] = STATE(33),
    [sym_switch_statement] = STATE(33),
    [sym_case_statement] = STATE(33),
    [sym_while_statement] = STATE(33),
    [sym_do_statement] = STATE(33),
    [sym_for_statement] = STATE(33),
    [sym_return_statement] = STATE(33),
    [sym_break_statement] = STATE(33),
    [sym_continue_statement] = STATE(33),
    [sym_goto_statement] = STATE(33),
    [sym_seh_try_statement] = STATE(33),
    [sym_seh_leave_statement] = STATE(33),
    [sym__expression] = STATE(4420),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8126),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(33),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1900),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(33),
    [sym_template_instantiation] = STATE(33),
    [sym_operator_cast] = STATE(6494),
    [sym__constructor_specifiers] = STATE(1900),
    [sym_operator_cast_definition] = STATE(33),
    [sym_operator_cast_declaration] = STATE(33),
    [sym_constructor_or_destructor_definition] = STATE(33),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(33),
    [sym_namespace_alias_definition] = STATE(33),
    [sym_using_declaration] = STATE(33),
    [sym_alias_declaration] = STATE(33),
    [sym_static_assert_declaration] = STATE(33),
    [sym_concept_definition] = STATE(33),
    [sym_for_range_loop] = STATE(33),
    [sym_co_return_statement] = STATE(33),
    [sym_co_yield_statement] = STATE(33),
    [sym_throw_statement] = STATE(33),
    [sym_try_statement] = STATE(33),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6494),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(33),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(176),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1900),
    [sym_identifier] = ACTIONS(259),
    [aux_sym_preproc_include_token1] = ACTIONS(261),
    [aux_sym_preproc_def_token1] = ACTIONS(263),
    [aux_sym_preproc_if_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token2] = ACTIONS(367),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(269),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(269),
    [aux_sym_preproc_else_token1] = ACTIONS(271),
    [aux_sym_preproc_elif_token1] = ACTIONS(273),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(275),
    [sym_preproc_directive] = ACTIONS(277),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(279),
    [anon_sym___extension__] = ACTIONS(281),
    [anon_sym_typedef] = ACTIONS(283),
    [anon_sym_extern] = ACTIONS(285),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(287),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(289),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(291),
    [anon_sym_switch] = ACTIONS(293),
    [anon_sym_case] = ACTIONS(295),
    [anon_sym_default] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(301),
    [anon_sym_for] = ACTIONS(303),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_break] = ACTIONS(307),
    [anon_sym_continue] = ACTIONS(309),
    [anon_sym_goto] = ACTIONS(311),
    [anon_sym___try] = ACTIONS(313),
    [anon_sym___leave] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(317),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(319),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(321),
    [anon_sym_namespace] = ACTIONS(323),
    [anon_sym_using] = ACTIONS(325),
    [anon_sym_static_assert] = ACTIONS(327),
    [anon_sym_concept] = ACTIONS(329),
    [anon_sym_co_return] = ACTIONS(331),
    [anon_sym_co_yield] = ACTIONS(333),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [31] = {
    [sym_preproc_include] = STATE(15),
    [sym_preproc_def] = STATE(15),
    [sym_preproc_function_def] = STATE(15),
    [sym_preproc_call] = STATE(15),
    [sym_preproc_if] = STATE(15),
    [sym_preproc_ifdef] = STATE(15),
    [sym_preproc_else] = STATE(8164),
    [sym_preproc_elif] = STATE(8164),
    [sym_preproc_elifdef] = STATE(8164),
    [sym_function_definition] = STATE(15),
    [sym_declaration] = STATE(15),
    [sym_type_definition] = STATE(15),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4637),
    [sym_linkage_specification] = STATE(15),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1849),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6061),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(15),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2782),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(15),
    [sym_labeled_statement] = STATE(15),
    [sym_expression_statement] = STATE(15),
    [sym_if_statement] = STATE(15),
    [sym_switch_statement] = STATE(15),
    [sym_case_statement] = STATE(15),
    [sym_while_statement] = STATE(15),
    [sym_do_statement] = STATE(15),
    [sym_for_statement] = STATE(15),
    [sym_return_statement] = STATE(15),
    [sym_break_statement] = STATE(15),
    [sym_continue_statement] = STATE(15),
    [sym_goto_statement] = STATE(15),
    [sym_seh_try_statement] = STATE(15),
    [sym_seh_leave_statement] = STATE(15),
    [sym__expression] = STATE(4420),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8126),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(15),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1900),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(15),
    [sym_template_instantiation] = STATE(15),
    [sym_operator_cast] = STATE(6494),
    [sym__constructor_specifiers] = STATE(1900),
    [sym_operator_cast_definition] = STATE(15),
    [sym_operator_cast_declaration] = STATE(15),
    [sym_constructor_or_destructor_definition] = STATE(15),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(15),
    [sym_namespace_alias_definition] = STATE(15),
    [sym_using_declaration] = STATE(15),
    [sym_alias_declaration] = STATE(15),
    [sym_static_assert_declaration] = STATE(15),
    [sym_concept_definition] = STATE(15),
    [sym_for_range_loop] = STATE(15),
    [sym_co_return_statement] = STATE(15),
    [sym_co_yield_statement] = STATE(15),
    [sym_throw_statement] = STATE(15),
    [sym_try_statement] = STATE(15),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6494),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(15),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(176),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1900),
    [sym_identifier] = ACTIONS(259),
    [aux_sym_preproc_include_token1] = ACTIONS(261),
    [aux_sym_preproc_def_token1] = ACTIONS(263),
    [aux_sym_preproc_if_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token2] = ACTIONS(369),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(269),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(269),
    [aux_sym_preproc_else_token1] = ACTIONS(271),
    [aux_sym_preproc_elif_token1] = ACTIONS(273),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(275),
    [sym_preproc_directive] = ACTIONS(277),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(279),
    [anon_sym___extension__] = ACTIONS(281),
    [anon_sym_typedef] = ACTIONS(283),
    [anon_sym_extern] = ACTIONS(285),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(287),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(289),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(291),
    [anon_sym_switch] = ACTIONS(293),
    [anon_sym_case] = ACTIONS(295),
    [anon_sym_default] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(301),
    [anon_sym_for] = ACTIONS(303),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_break] = ACTIONS(307),
    [anon_sym_continue] = ACTIONS(309),
    [anon_sym_goto] = ACTIONS(311),
    [anon_sym___try] = ACTIONS(313),
    [anon_sym___leave] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(317),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(319),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(321),
    [anon_sym_namespace] = ACTIONS(323),
    [anon_sym_using] = ACTIONS(325),
    [anon_sym_static_assert] = ACTIONS(327),
    [anon_sym_concept] = ACTIONS(329),
    [anon_sym_co_return] = ACTIONS(331),
    [anon_sym_co_yield] = ACTIONS(333),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [32] = {
    [sym_preproc_include] = STATE(33),
    [sym_preproc_def] = STATE(33),
    [sym_preproc_function_def] = STATE(33),
    [sym_preproc_call] = STATE(33),
    [sym_preproc_if] = STATE(33),
    [sym_preproc_ifdef] = STATE(33),
    [sym_preproc_else] = STATE(7990),
    [sym_preproc_elif] = STATE(7990),
    [sym_preproc_elifdef] = STATE(7990),
    [sym_function_definition] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_type_definition] = STATE(33),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4637),
    [sym_linkage_specification] = STATE(33),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1849),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6061),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(33),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2782),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(33),
    [sym_labeled_statement] = STATE(33),
    [sym_expression_statement] = STATE(33),
    [sym_if_statement] = STATE(33),
    [sym_switch_statement] = STATE(33),
    [sym_case_statement] = STATE(33),
    [sym_while_statement] = STATE(33),
    [sym_do_statement] = STATE(33),
    [sym_for_statement] = STATE(33),
    [sym_return_statement] = STATE(33),
    [sym_break_statement] = STATE(33),
    [sym_continue_statement] = STATE(33),
    [sym_goto_statement] = STATE(33),
    [sym_seh_try_statement] = STATE(33),
    [sym_seh_leave_statement] = STATE(33),
    [sym__expression] = STATE(4420),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8126),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(33),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1900),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(33),
    [sym_template_instantiation] = STATE(33),
    [sym_operator_cast] = STATE(6494),
    [sym__constructor_specifiers] = STATE(1900),
    [sym_operator_cast_definition] = STATE(33),
    [sym_operator_cast_declaration] = STATE(33),
    [sym_constructor_or_destructor_definition] = STATE(33),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(33),
    [sym_namespace_alias_definition] = STATE(33),
    [sym_using_declaration] = STATE(33),
    [sym_alias_declaration] = STATE(33),
    [sym_static_assert_declaration] = STATE(33),
    [sym_concept_definition] = STATE(33),
    [sym_for_range_loop] = STATE(33),
    [sym_co_return_statement] = STATE(33),
    [sym_co_yield_statement] = STATE(33),
    [sym_throw_statement] = STATE(33),
    [sym_try_statement] = STATE(33),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6494),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(33),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(176),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1900),
    [sym_identifier] = ACTIONS(259),
    [aux_sym_preproc_include_token1] = ACTIONS(261),
    [aux_sym_preproc_def_token1] = ACTIONS(263),
    [aux_sym_preproc_if_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token2] = ACTIONS(371),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(269),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(269),
    [aux_sym_preproc_else_token1] = ACTIONS(271),
    [aux_sym_preproc_elif_token1] = ACTIONS(273),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(275),
    [sym_preproc_directive] = ACTIONS(277),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(279),
    [anon_sym___extension__] = ACTIONS(281),
    [anon_sym_typedef] = ACTIONS(283),
    [anon_sym_extern] = ACTIONS(285),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(287),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(289),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(291),
    [anon_sym_switch] = ACTIONS(293),
    [anon_sym_case] = ACTIONS(295),
    [anon_sym_default] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(301),
    [anon_sym_for] = ACTIONS(303),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_break] = ACTIONS(307),
    [anon_sym_continue] = ACTIONS(309),
    [anon_sym_goto] = ACTIONS(311),
    [anon_sym___try] = ACTIONS(313),
    [anon_sym___leave] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(317),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(319),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(321),
    [anon_sym_namespace] = ACTIONS(323),
    [anon_sym_using] = ACTIONS(325),
    [anon_sym_static_assert] = ACTIONS(327),
    [anon_sym_concept] = ACTIONS(329),
    [anon_sym_co_return] = ACTIONS(331),
    [anon_sym_co_yield] = ACTIONS(333),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [33] = {
    [sym_preproc_include] = STATE(33),
    [sym_preproc_def] = STATE(33),
    [sym_preproc_function_def] = STATE(33),
    [sym_preproc_call] = STATE(33),
    [sym_preproc_if] = STATE(33),
    [sym_preproc_ifdef] = STATE(33),
    [sym_function_definition] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_type_definition] = STATE(33),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4637),
    [sym_linkage_specification] = STATE(33),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1849),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6061),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(33),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2782),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(33),
    [sym_labeled_statement] = STATE(33),
    [sym_expression_statement] = STATE(33),
    [sym_if_statement] = STATE(33),
    [sym_switch_statement] = STATE(33),
    [sym_case_statement] = STATE(33),
    [sym_while_statement] = STATE(33),
    [sym_do_statement] = STATE(33),
    [sym_for_statement] = STATE(33),
    [sym_return_statement] = STATE(33),
    [sym_break_statement] = STATE(33),
    [sym_continue_statement] = STATE(33),
    [sym_goto_statement] = STATE(33),
    [sym_seh_try_statement] = STATE(33),
    [sym_seh_leave_statement] = STATE(33),
    [sym__expression] = STATE(4420),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8126),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(33),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1900),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(33),
    [sym_template_instantiation] = STATE(33),
    [sym_operator_cast] = STATE(6494),
    [sym__constructor_specifiers] = STATE(1900),
    [sym_operator_cast_definition] = STATE(33),
    [sym_operator_cast_declaration] = STATE(33),
    [sym_constructor_or_destructor_definition] = STATE(33),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(33),
    [sym_namespace_alias_definition] = STATE(33),
    [sym_using_declaration] = STATE(33),
    [sym_alias_declaration] = STATE(33),
    [sym_static_assert_declaration] = STATE(33),
    [sym_concept_definition] = STATE(33),
    [sym_for_range_loop] = STATE(33),
    [sym_co_return_statement] = STATE(33),
    [sym_co_yield_statement] = STATE(33),
    [sym_throw_statement] = STATE(33),
    [sym_try_statement] = STATE(33),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6494),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(33),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(176),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1900),
    [sym_identifier] = ACTIONS(373),
    [aux_sym_preproc_include_token1] = ACTIONS(376),
    [aux_sym_preproc_def_token1] = ACTIONS(379),
    [aux_sym_preproc_if_token1] = ACTIONS(382),
    [aux_sym_preproc_if_token2] = ACTIONS(385),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(387),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(387),
    [aux_sym_preproc_else_token1] = ACTIONS(385),
    [aux_sym_preproc_elif_token1] = ACTIONS(385),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(385),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(385),
    [sym_preproc_directive] = ACTIONS(390),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_BANG] = ACTIONS(396),
    [anon_sym_TILDE] = ACTIONS(399),
    [anon_sym_DASH] = ACTIONS(402),
    [anon_sym_PLUS] = ACTIONS(402),
    [anon_sym_STAR] = ACTIONS(405),
    [anon_sym_AMP_AMP] = ACTIONS(408),
    [anon_sym_AMP] = ACTIONS(411),
    [anon_sym_SEMI] = ACTIONS(414),
    [anon_sym___extension__] = ACTIONS(417),
    [anon_sym_typedef] = ACTIONS(420),
    [anon_sym_extern] = ACTIONS(423),
    [anon_sym___attribute__] = ACTIONS(426),
    [anon_sym_COLON_COLON] = ACTIONS(429),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(432),
    [anon_sym___declspec] = ACTIONS(435),
    [anon_sym___based] = ACTIONS(438),
    [anon_sym___cdecl] = ACTIONS(441),
    [anon_sym___clrcall] = ACTIONS(441),
    [anon_sym___stdcall] = ACTIONS(441),
    [anon_sym___fastcall] = ACTIONS(441),
    [anon_sym___thiscall] = ACTIONS(441),
    [anon_sym___vectorcall] = ACTIONS(441),
    [anon_sym_LBRACE] = ACTIONS(444),
    [anon_sym_signed] = ACTIONS(447),
    [anon_sym_unsigned] = ACTIONS(447),
    [anon_sym_long] = ACTIONS(447),
    [anon_sym_short] = ACTIONS(447),
    [anon_sym_LBRACK] = ACTIONS(450),
    [anon_sym_static] = ACTIONS(453),
    [anon_sym_register] = ACTIONS(453),
    [anon_sym_inline] = ACTIONS(456),
    [anon_sym___inline] = ACTIONS(453),
    [anon_sym___inline__] = ACTIONS(453),
    [anon_sym___forceinline] = ACTIONS(453),
    [anon_sym_thread_local] = ACTIONS(453),
    [anon_sym___thread] = ACTIONS(453),
    [anon_sym_const] = ACTIONS(459),
    [anon_sym_constexpr] = ACTIONS(459),
    [anon_sym_volatile] = ACTIONS(459),
    [anon_sym_restrict] = ACTIONS(459),
    [anon_sym___restrict__] = ACTIONS(459),
    [anon_sym__Atomic] = ACTIONS(459),
    [anon_sym__Noreturn] = ACTIONS(459),
    [anon_sym_noreturn] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(459),
    [anon_sym_constinit] = ACTIONS(459),
    [anon_sym_consteval] = ACTIONS(459),
    [anon_sym_PROGMEM] = ACTIONS(459),
    [aux_sym_primitive_type_token1] = ACTIONS(462),
    [anon_sym_byte] = ACTIONS(462),
    [anon_sym_word] = ACTIONS(462),
    [anon_sym_enum] = ACTIONS(465),
    [anon_sym_class] = ACTIONS(468),
    [anon_sym_struct] = ACTIONS(471),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_if] = ACTIONS(477),
    [anon_sym_switch] = ACTIONS(480),
    [anon_sym_case] = ACTIONS(483),
    [anon_sym_default] = ACTIONS(486),
    [anon_sym_while] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(492),
    [anon_sym_for] = ACTIONS(495),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_break] = ACTIONS(501),
    [anon_sym_continue] = ACTIONS(504),
    [anon_sym_goto] = ACTIONS(507),
    [anon_sym___try] = ACTIONS(510),
    [anon_sym___leave] = ACTIONS(513),
    [anon_sym_not] = ACTIONS(402),
    [anon_sym_compl] = ACTIONS(402),
    [anon_sym_DASH_DASH] = ACTIONS(516),
    [anon_sym_PLUS_PLUS] = ACTIONS(516),
    [anon_sym_sizeof] = ACTIONS(519),
    [anon_sym___alignof__] = ACTIONS(522),
    [anon_sym___alignof] = ACTIONS(522),
    [anon_sym__alignof] = ACTIONS(522),
    [anon_sym_alignof] = ACTIONS(522),
    [anon_sym__Alignof] = ACTIONS(522),
    [anon_sym_offsetof] = ACTIONS(525),
    [anon_sym__Generic] = ACTIONS(528),
    [anon_sym_asm] = ACTIONS(531),
    [anon_sym___asm__] = ACTIONS(531),
    [aux_sym_number_literal_token1] = ACTIONS(534),
    [aux_sym_number_literal_token2] = ACTIONS(537),
    [anon_sym_L_SQUOTE] = ACTIONS(540),
    [anon_sym_u_SQUOTE] = ACTIONS(540),
    [anon_sym_U_SQUOTE] = ACTIONS(540),
    [anon_sym_u8_SQUOTE] = ACTIONS(540),
    [anon_sym_SQUOTE] = ACTIONS(540),
    [anon_sym_L_DQUOTE] = ACTIONS(543),
    [anon_sym_u_DQUOTE] = ACTIONS(543),
    [anon_sym_U_DQUOTE] = ACTIONS(543),
    [anon_sym_u8_DQUOTE] = ACTIONS(543),
    [anon_sym_DQUOTE] = ACTIONS(543),
    [sym_true] = ACTIONS(546),
    [sym_false] = ACTIONS(546),
    [anon_sym_NULL] = ACTIONS(549),
    [anon_sym_nullptr] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(552),
    [anon_sym_decltype] = ACTIONS(555),
    [anon_sym_virtual] = ACTIONS(558),
    [anon_sym_alignas] = ACTIONS(561),
    [anon_sym_explicit] = ACTIONS(564),
    [anon_sym_typename] = ACTIONS(567),
    [anon_sym_template] = ACTIONS(570),
    [anon_sym_operator] = ACTIONS(573),
    [anon_sym_try] = ACTIONS(576),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_throw] = ACTIONS(582),
    [anon_sym_namespace] = ACTIONS(585),
    [anon_sym_using] = ACTIONS(588),
    [anon_sym_static_assert] = ACTIONS(591),
    [anon_sym_concept] = ACTIONS(594),
    [anon_sym_co_return] = ACTIONS(597),
    [anon_sym_co_yield] = ACTIONS(600),
    [anon_sym_R_DQUOTE] = ACTIONS(603),
    [anon_sym_LR_DQUOTE] = ACTIONS(603),
    [anon_sym_uR_DQUOTE] = ACTIONS(603),
    [anon_sym_UR_DQUOTE] = ACTIONS(603),
    [anon_sym_u8R_DQUOTE] = ACTIONS(603),
    [anon_sym_co_await] = ACTIONS(606),
    [anon_sym_new] = ACTIONS(609),
    [anon_sym_requires] = ACTIONS(612),
    [sym_this] = ACTIONS(546),
  },
  [34] = {
    [sym_preproc_include] = STATE(54),
    [sym_preproc_def] = STATE(54),
    [sym_preproc_function_def] = STATE(54),
    [sym_preproc_call] = STATE(54),
    [sym_preproc_if] = STATE(54),
    [sym_preproc_ifdef] = STATE(54),
    [sym_function_definition] = STATE(54),
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4541),
    [sym_linkage_specification] = STATE(54),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6129),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(54),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2759),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(54),
    [sym_labeled_statement] = STATE(54),
    [sym_expression_statement] = STATE(54),
    [sym_if_statement] = STATE(54),
    [sym_switch_statement] = STATE(54),
    [sym_case_statement] = STATE(54),
    [sym_while_statement] = STATE(54),
    [sym_do_statement] = STATE(54),
    [sym_for_statement] = STATE(54),
    [sym_return_statement] = STATE(54),
    [sym_break_statement] = STATE(54),
    [sym_continue_statement] = STATE(54),
    [sym_goto_statement] = STATE(54),
    [sym_seh_try_statement] = STATE(54),
    [sym_seh_leave_statement] = STATE(54),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(54),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1888),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(54),
    [sym_template_instantiation] = STATE(54),
    [sym_operator_cast] = STATE(6505),
    [sym__constructor_specifiers] = STATE(1888),
    [sym_operator_cast_definition] = STATE(54),
    [sym_operator_cast_declaration] = STATE(54),
    [sym_constructor_or_destructor_definition] = STATE(54),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(54),
    [sym_namespace_alias_definition] = STATE(54),
    [sym_using_declaration] = STATE(54),
    [sym_alias_declaration] = STATE(54),
    [sym_static_assert_declaration] = STATE(54),
    [sym_concept_definition] = STATE(54),
    [sym_for_range_loop] = STATE(54),
    [sym_co_return_statement] = STATE(54),
    [sym_co_yield_statement] = STATE(54),
    [sym_throw_statement] = STATE(54),
    [sym_try_statement] = STATE(54),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6505),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(54),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1888),
    [sym_identifier] = ACTIONS(615),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(619),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [35] = {
    [sym_preproc_include] = STATE(70),
    [sym_preproc_def] = STATE(70),
    [sym_preproc_function_def] = STATE(70),
    [sym_preproc_call] = STATE(70),
    [sym_preproc_if] = STATE(70),
    [sym_preproc_ifdef] = STATE(70),
    [sym_function_definition] = STATE(70),
    [sym_declaration] = STATE(70),
    [sym_type_definition] = STATE(70),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4541),
    [sym_linkage_specification] = STATE(70),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6129),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(70),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2759),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(70),
    [sym_labeled_statement] = STATE(70),
    [sym_expression_statement] = STATE(70),
    [sym_if_statement] = STATE(70),
    [sym_switch_statement] = STATE(70),
    [sym_case_statement] = STATE(70),
    [sym_while_statement] = STATE(70),
    [sym_do_statement] = STATE(70),
    [sym_for_statement] = STATE(70),
    [sym_return_statement] = STATE(70),
    [sym_break_statement] = STATE(70),
    [sym_continue_statement] = STATE(70),
    [sym_goto_statement] = STATE(70),
    [sym_seh_try_statement] = STATE(70),
    [sym_seh_leave_statement] = STATE(70),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(70),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1888),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(70),
    [sym_template_instantiation] = STATE(70),
    [sym_operator_cast] = STATE(6505),
    [sym__constructor_specifiers] = STATE(1888),
    [sym_operator_cast_definition] = STATE(70),
    [sym_operator_cast_declaration] = STATE(70),
    [sym_constructor_or_destructor_definition] = STATE(70),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(70),
    [sym_namespace_alias_definition] = STATE(70),
    [sym_using_declaration] = STATE(70),
    [sym_alias_declaration] = STATE(70),
    [sym_static_assert_declaration] = STATE(70),
    [sym_concept_definition] = STATE(70),
    [sym_for_range_loop] = STATE(70),
    [sym_co_return_statement] = STATE(70),
    [sym_co_yield_statement] = STATE(70),
    [sym_throw_statement] = STATE(70),
    [sym_try_statement] = STATE(70),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6505),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(70),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1888),
    [sym_identifier] = ACTIONS(615),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(621),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [36] = {
    [sym_preproc_include] = STATE(54),
    [sym_preproc_def] = STATE(54),
    [sym_preproc_function_def] = STATE(54),
    [sym_preproc_call] = STATE(54),
    [sym_preproc_if] = STATE(54),
    [sym_preproc_ifdef] = STATE(54),
    [sym_function_definition] = STATE(54),
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4541),
    [sym_linkage_specification] = STATE(54),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6129),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(54),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2759),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(54),
    [sym_labeled_statement] = STATE(54),
    [sym_expression_statement] = STATE(54),
    [sym_if_statement] = STATE(54),
    [sym_switch_statement] = STATE(54),
    [sym_case_statement] = STATE(54),
    [sym_while_statement] = STATE(54),
    [sym_do_statement] = STATE(54),
    [sym_for_statement] = STATE(54),
    [sym_return_statement] = STATE(54),
    [sym_break_statement] = STATE(54),
    [sym_continue_statement] = STATE(54),
    [sym_goto_statement] = STATE(54),
    [sym_seh_try_statement] = STATE(54),
    [sym_seh_leave_statement] = STATE(54),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(54),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1888),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(54),
    [sym_template_instantiation] = STATE(54),
    [sym_operator_cast] = STATE(6505),
    [sym__constructor_specifiers] = STATE(1888),
    [sym_operator_cast_definition] = STATE(54),
    [sym_operator_cast_declaration] = STATE(54),
    [sym_constructor_or_destructor_definition] = STATE(54),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(54),
    [sym_namespace_alias_definition] = STATE(54),
    [sym_using_declaration] = STATE(54),
    [sym_alias_declaration] = STATE(54),
    [sym_static_assert_declaration] = STATE(54),
    [sym_concept_definition] = STATE(54),
    [sym_for_range_loop] = STATE(54),
    [sym_co_return_statement] = STATE(54),
    [sym_co_yield_statement] = STATE(54),
    [sym_throw_statement] = STATE(54),
    [sym_try_statement] = STATE(54),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6505),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(54),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1888),
    [sym_identifier] = ACTIONS(615),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(623),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [37] = {
    [sym_preproc_include] = STATE(65),
    [sym_preproc_def] = STATE(65),
    [sym_preproc_function_def] = STATE(65),
    [sym_preproc_call] = STATE(65),
    [sym_preproc_if] = STATE(65),
    [sym_preproc_ifdef] = STATE(65),
    [sym_function_definition] = STATE(65),
    [sym_declaration] = STATE(65),
    [sym_type_definition] = STATE(65),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4541),
    [sym_linkage_specification] = STATE(65),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6129),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(65),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2759),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(65),
    [sym_labeled_statement] = STATE(65),
    [sym_expression_statement] = STATE(65),
    [sym_if_statement] = STATE(65),
    [sym_switch_statement] = STATE(65),
    [sym_case_statement] = STATE(65),
    [sym_while_statement] = STATE(65),
    [sym_do_statement] = STATE(65),
    [sym_for_statement] = STATE(65),
    [sym_return_statement] = STATE(65),
    [sym_break_statement] = STATE(65),
    [sym_continue_statement] = STATE(65),
    [sym_goto_statement] = STATE(65),
    [sym_seh_try_statement] = STATE(65),
    [sym_seh_leave_statement] = STATE(65),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(65),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1888),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(65),
    [sym_template_instantiation] = STATE(65),
    [sym_operator_cast] = STATE(6505),
    [sym__constructor_specifiers] = STATE(1888),
    [sym_operator_cast_definition] = STATE(65),
    [sym_operator_cast_declaration] = STATE(65),
    [sym_constructor_or_destructor_definition] = STATE(65),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(65),
    [sym_namespace_alias_definition] = STATE(65),
    [sym_using_declaration] = STATE(65),
    [sym_alias_declaration] = STATE(65),
    [sym_static_assert_declaration] = STATE(65),
    [sym_concept_definition] = STATE(65),
    [sym_for_range_loop] = STATE(65),
    [sym_co_return_statement] = STATE(65),
    [sym_co_yield_statement] = STATE(65),
    [sym_throw_statement] = STATE(65),
    [sym_try_statement] = STATE(65),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6505),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(65),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1888),
    [sym_identifier] = ACTIONS(615),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(625),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [38] = {
    [sym_preproc_include] = STATE(34),
    [sym_preproc_def] = STATE(34),
    [sym_preproc_function_def] = STATE(34),
    [sym_preproc_call] = STATE(34),
    [sym_preproc_if] = STATE(34),
    [sym_preproc_ifdef] = STATE(34),
    [sym_function_definition] = STATE(34),
    [sym_declaration] = STATE(34),
    [sym_type_definition] = STATE(34),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4541),
    [sym_linkage_specification] = STATE(34),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6129),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(34),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2759),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(34),
    [sym_labeled_statement] = STATE(34),
    [sym_expression_statement] = STATE(34),
    [sym_if_statement] = STATE(34),
    [sym_switch_statement] = STATE(34),
    [sym_case_statement] = STATE(34),
    [sym_while_statement] = STATE(34),
    [sym_do_statement] = STATE(34),
    [sym_for_statement] = STATE(34),
    [sym_return_statement] = STATE(34),
    [sym_break_statement] = STATE(34),
    [sym_continue_statement] = STATE(34),
    [sym_goto_statement] = STATE(34),
    [sym_seh_try_statement] = STATE(34),
    [sym_seh_leave_statement] = STATE(34),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(34),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1888),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(34),
    [sym_template_instantiation] = STATE(34),
    [sym_operator_cast] = STATE(6505),
    [sym__constructor_specifiers] = STATE(1888),
    [sym_operator_cast_definition] = STATE(34),
    [sym_operator_cast_declaration] = STATE(34),
    [sym_constructor_or_destructor_definition] = STATE(34),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(34),
    [sym_namespace_alias_definition] = STATE(34),
    [sym_using_declaration] = STATE(34),
    [sym_alias_declaration] = STATE(34),
    [sym_static_assert_declaration] = STATE(34),
    [sym_concept_definition] = STATE(34),
    [sym_for_range_loop] = STATE(34),
    [sym_co_return_statement] = STATE(34),
    [sym_co_yield_statement] = STATE(34),
    [sym_throw_statement] = STATE(34),
    [sym_try_statement] = STATE(34),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6505),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(34),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1888),
    [sym_identifier] = ACTIONS(615),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(627),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [39] = {
    [sym_preproc_include] = STATE(54),
    [sym_preproc_def] = STATE(54),
    [sym_preproc_function_def] = STATE(54),
    [sym_preproc_call] = STATE(54),
    [sym_preproc_if] = STATE(54),
    [sym_preproc_ifdef] = STATE(54),
    [sym_function_definition] = STATE(54),
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4541),
    [sym_linkage_specification] = STATE(54),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6129),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(54),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2759),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(54),
    [sym_labeled_statement] = STATE(54),
    [sym_expression_statement] = STATE(54),
    [sym_if_statement] = STATE(54),
    [sym_switch_statement] = STATE(54),
    [sym_case_statement] = STATE(54),
    [sym_while_statement] = STATE(54),
    [sym_do_statement] = STATE(54),
    [sym_for_statement] = STATE(54),
    [sym_return_statement] = STATE(54),
    [sym_break_statement] = STATE(54),
    [sym_continue_statement] = STATE(54),
    [sym_goto_statement] = STATE(54),
    [sym_seh_try_statement] = STATE(54),
    [sym_seh_leave_statement] = STATE(54),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(54),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1888),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(54),
    [sym_template_instantiation] = STATE(54),
    [sym_operator_cast] = STATE(6505),
    [sym__constructor_specifiers] = STATE(1888),
    [sym_operator_cast_definition] = STATE(54),
    [sym_operator_cast_declaration] = STATE(54),
    [sym_constructor_or_destructor_definition] = STATE(54),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(54),
    [sym_namespace_alias_definition] = STATE(54),
    [sym_using_declaration] = STATE(54),
    [sym_alias_declaration] = STATE(54),
    [sym_static_assert_declaration] = STATE(54),
    [sym_concept_definition] = STATE(54),
    [sym_for_range_loop] = STATE(54),
    [sym_co_return_statement] = STATE(54),
    [sym_co_yield_statement] = STATE(54),
    [sym_throw_statement] = STATE(54),
    [sym_try_statement] = STATE(54),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6505),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(54),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1888),
    [sym_identifier] = ACTIONS(615),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(629),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [40] = {
    [sym_preproc_include] = STATE(39),
    [sym_preproc_def] = STATE(39),
    [sym_preproc_function_def] = STATE(39),
    [sym_preproc_call] = STATE(39),
    [sym_preproc_if] = STATE(39),
    [sym_preproc_ifdef] = STATE(39),
    [sym_function_definition] = STATE(39),
    [sym_declaration] = STATE(39),
    [sym_type_definition] = STATE(39),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4541),
    [sym_linkage_specification] = STATE(39),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6129),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(39),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2759),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(39),
    [sym_labeled_statement] = STATE(39),
    [sym_expression_statement] = STATE(39),
    [sym_if_statement] = STATE(39),
    [sym_switch_statement] = STATE(39),
    [sym_case_statement] = STATE(39),
    [sym_while_statement] = STATE(39),
    [sym_do_statement] = STATE(39),
    [sym_for_statement] = STATE(39),
    [sym_return_statement] = STATE(39),
    [sym_break_statement] = STATE(39),
    [sym_continue_statement] = STATE(39),
    [sym_goto_statement] = STATE(39),
    [sym_seh_try_statement] = STATE(39),
    [sym_seh_leave_statement] = STATE(39),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(39),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1888),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(39),
    [sym_template_instantiation] = STATE(39),
    [sym_operator_cast] = STATE(6505),
    [sym__constructor_specifiers] = STATE(1888),
    [sym_operator_cast_definition] = STATE(39),
    [sym_operator_cast_declaration] = STATE(39),
    [sym_constructor_or_destructor_definition] = STATE(39),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(39),
    [sym_namespace_alias_definition] = STATE(39),
    [sym_using_declaration] = STATE(39),
    [sym_alias_declaration] = STATE(39),
    [sym_static_assert_declaration] = STATE(39),
    [sym_concept_definition] = STATE(39),
    [sym_for_range_loop] = STATE(39),
    [sym_co_return_statement] = STATE(39),
    [sym_co_yield_statement] = STATE(39),
    [sym_throw_statement] = STATE(39),
    [sym_try_statement] = STATE(39),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6505),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(39),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1888),
    [sym_identifier] = ACTIONS(615),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(631),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [41] = {
    [sym_preproc_include] = STATE(49),
    [sym_preproc_def] = STATE(49),
    [sym_preproc_function_def] = STATE(49),
    [sym_preproc_call] = STATE(49),
    [sym_preproc_if] = STATE(49),
    [sym_preproc_ifdef] = STATE(49),
    [sym_function_definition] = STATE(49),
    [sym_declaration] = STATE(49),
    [sym_type_definition] = STATE(49),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4541),
    [sym_linkage_specification] = STATE(49),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6129),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(49),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2759),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(49),
    [sym_labeled_statement] = STATE(49),
    [sym_expression_statement] = STATE(49),
    [sym_if_statement] = STATE(49),
    [sym_switch_statement] = STATE(49),
    [sym_case_statement] = STATE(49),
    [sym_while_statement] = STATE(49),
    [sym_do_statement] = STATE(49),
    [sym_for_statement] = STATE(49),
    [sym_return_statement] = STATE(49),
    [sym_break_statement] = STATE(49),
    [sym_continue_statement] = STATE(49),
    [sym_goto_statement] = STATE(49),
    [sym_seh_try_statement] = STATE(49),
    [sym_seh_leave_statement] = STATE(49),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(49),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1888),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(49),
    [sym_template_instantiation] = STATE(49),
    [sym_operator_cast] = STATE(6505),
    [sym__constructor_specifiers] = STATE(1888),
    [sym_operator_cast_definition] = STATE(49),
    [sym_operator_cast_declaration] = STATE(49),
    [sym_constructor_or_destructor_definition] = STATE(49),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(49),
    [sym_namespace_alias_definition] = STATE(49),
    [sym_using_declaration] = STATE(49),
    [sym_alias_declaration] = STATE(49),
    [sym_static_assert_declaration] = STATE(49),
    [sym_concept_definition] = STATE(49),
    [sym_for_range_loop] = STATE(49),
    [sym_co_return_statement] = STATE(49),
    [sym_co_yield_statement] = STATE(49),
    [sym_throw_statement] = STATE(49),
    [sym_try_statement] = STATE(49),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6505),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(49),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1888),
    [sym_identifier] = ACTIONS(615),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(633),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [42] = {
    [sym_preproc_include] = STATE(54),
    [sym_preproc_def] = STATE(54),
    [sym_preproc_function_def] = STATE(54),
    [sym_preproc_call] = STATE(54),
    [sym_preproc_if] = STATE(54),
    [sym_preproc_ifdef] = STATE(54),
    [sym_function_definition] = STATE(54),
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4541),
    [sym_linkage_specification] = STATE(54),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6129),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(54),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2759),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(54),
    [sym_labeled_statement] = STATE(54),
    [sym_expression_statement] = STATE(54),
    [sym_if_statement] = STATE(54),
    [sym_switch_statement] = STATE(54),
    [sym_case_statement] = STATE(54),
    [sym_while_statement] = STATE(54),
    [sym_do_statement] = STATE(54),
    [sym_for_statement] = STATE(54),
    [sym_return_statement] = STATE(54),
    [sym_break_statement] = STATE(54),
    [sym_continue_statement] = STATE(54),
    [sym_goto_statement] = STATE(54),
    [sym_seh_try_statement] = STATE(54),
    [sym_seh_leave_statement] = STATE(54),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(54),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1888),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(54),
    [sym_template_instantiation] = STATE(54),
    [sym_operator_cast] = STATE(6505),
    [sym__constructor_specifiers] = STATE(1888),
    [sym_operator_cast_definition] = STATE(54),
    [sym_operator_cast_declaration] = STATE(54),
    [sym_constructor_or_destructor_definition] = STATE(54),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(54),
    [sym_namespace_alias_definition] = STATE(54),
    [sym_using_declaration] = STATE(54),
    [sym_alias_declaration] = STATE(54),
    [sym_static_assert_declaration] = STATE(54),
    [sym_concept_definition] = STATE(54),
    [sym_for_range_loop] = STATE(54),
    [sym_co_return_statement] = STATE(54),
    [sym_co_yield_statement] = STATE(54),
    [sym_throw_statement] = STATE(54),
    [sym_try_statement] = STATE(54),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6505),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(54),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1888),
    [sym_identifier] = ACTIONS(615),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(635),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [43] = {
    [sym_preproc_include] = STATE(42),
    [sym_preproc_def] = STATE(42),
    [sym_preproc_function_def] = STATE(42),
    [sym_preproc_call] = STATE(42),
    [sym_preproc_if] = STATE(42),
    [sym_preproc_ifdef] = STATE(42),
    [sym_function_definition] = STATE(42),
    [sym_declaration] = STATE(42),
    [sym_type_definition] = STATE(42),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4541),
    [sym_linkage_specification] = STATE(42),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6129),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(42),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2759),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(42),
    [sym_labeled_statement] = STATE(42),
    [sym_expression_statement] = STATE(42),
    [sym_if_statement] = STATE(42),
    [sym_switch_statement] = STATE(42),
    [sym_case_statement] = STATE(42),
    [sym_while_statement] = STATE(42),
    [sym_do_statement] = STATE(42),
    [sym_for_statement] = STATE(42),
    [sym_return_statement] = STATE(42),
    [sym_break_statement] = STATE(42),
    [sym_continue_statement] = STATE(42),
    [sym_goto_statement] = STATE(42),
    [sym_seh_try_statement] = STATE(42),
    [sym_seh_leave_statement] = STATE(42),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(42),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1888),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(42),
    [sym_template_instantiation] = STATE(42),
    [sym_operator_cast] = STATE(6505),
    [sym__constructor_specifiers] = STATE(1888),
    [sym_operator_cast_definition] = STATE(42),
    [sym_operator_cast_declaration] = STATE(42),
    [sym_constructor_or_destructor_definition] = STATE(42),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(42),
    [sym_namespace_alias_definition] = STATE(42),
    [sym_using_declaration] = STATE(42),
    [sym_alias_declaration] = STATE(42),
    [sym_static_assert_declaration] = STATE(42),
    [sym_concept_definition] = STATE(42),
    [sym_for_range_loop] = STATE(42),
    [sym_co_return_statement] = STATE(42),
    [sym_co_yield_statement] = STATE(42),
    [sym_throw_statement] = STATE(42),
    [sym_try_statement] = STATE(42),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6505),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(42),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1888),
    [sym_identifier] = ACTIONS(615),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(637),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [44] = {
    [sym_preproc_include] = STATE(54),
    [sym_preproc_def] = STATE(54),
    [sym_preproc_function_def] = STATE(54),
    [sym_preproc_call] = STATE(54),
    [sym_preproc_if] = STATE(54),
    [sym_preproc_ifdef] = STATE(54),
    [sym_function_definition] = STATE(54),
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4541),
    [sym_linkage_specification] = STATE(54),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6129),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(54),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2759),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(54),
    [sym_labeled_statement] = STATE(54),
    [sym_expression_statement] = STATE(54),
    [sym_if_statement] = STATE(54),
    [sym_switch_statement] = STATE(54),
    [sym_case_statement] = STATE(54),
    [sym_while_statement] = STATE(54),
    [sym_do_statement] = STATE(54),
    [sym_for_statement] = STATE(54),
    [sym_return_statement] = STATE(54),
    [sym_break_statement] = STATE(54),
    [sym_continue_statement] = STATE(54),
    [sym_goto_statement] = STATE(54),
    [sym_seh_try_statement] = STATE(54),
    [sym_seh_leave_statement] = STATE(54),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(54),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1888),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(54),
    [sym_template_instantiation] = STATE(54),
    [sym_operator_cast] = STATE(6505),
    [sym__constructor_specifiers] = STATE(1888),
    [sym_operator_cast_definition] = STATE(54),
    [sym_operator_cast_declaration] = STATE(54),
    [sym_constructor_or_destructor_definition] = STATE(54),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(54),
    [sym_namespace_alias_definition] = STATE(54),
    [sym_using_declaration] = STATE(54),
    [sym_alias_declaration] = STATE(54),
    [sym_static_assert_declaration] = STATE(54),
    [sym_concept_definition] = STATE(54),
    [sym_for_range_loop] = STATE(54),
    [sym_co_return_statement] = STATE(54),
    [sym_co_yield_statement] = STATE(54),
    [sym_throw_statement] = STATE(54),
    [sym_try_statement] = STATE(54),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6505),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(54),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1888),
    [sym_identifier] = ACTIONS(615),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(639),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [45] = {
    [sym_preproc_include] = STATE(54),
    [sym_preproc_def] = STATE(54),
    [sym_preproc_function_def] = STATE(54),
    [sym_preproc_call] = STATE(54),
    [sym_preproc_if] = STATE(54),
    [sym_preproc_ifdef] = STATE(54),
    [sym_function_definition] = STATE(54),
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4541),
    [sym_linkage_specification] = STATE(54),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6129),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(54),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2759),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(54),
    [sym_labeled_statement] = STATE(54),
    [sym_expression_statement] = STATE(54),
    [sym_if_statement] = STATE(54),
    [sym_switch_statement] = STATE(54),
    [sym_case_statement] = STATE(54),
    [sym_while_statement] = STATE(54),
    [sym_do_statement] = STATE(54),
    [sym_for_statement] = STATE(54),
    [sym_return_statement] = STATE(54),
    [sym_break_statement] = STATE(54),
    [sym_continue_statement] = STATE(54),
    [sym_goto_statement] = STATE(54),
    [sym_seh_try_statement] = STATE(54),
    [sym_seh_leave_statement] = STATE(54),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(54),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1888),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(54),
    [sym_template_instantiation] = STATE(54),
    [sym_operator_cast] = STATE(6505),
    [sym__constructor_specifiers] = STATE(1888),
    [sym_operator_cast_definition] = STATE(54),
    [sym_operator_cast_declaration] = STATE(54),
    [sym_constructor_or_destructor_definition] = STATE(54),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(54),
    [sym_namespace_alias_definition] = STATE(54),
    [sym_using_declaration] = STATE(54),
    [sym_alias_declaration] = STATE(54),
    [sym_static_assert_declaration] = STATE(54),
    [sym_concept_definition] = STATE(54),
    [sym_for_range_loop] = STATE(54),
    [sym_co_return_statement] = STATE(54),
    [sym_co_yield_statement] = STATE(54),
    [sym_throw_statement] = STATE(54),
    [sym_try_statement] = STATE(54),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6505),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(54),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1888),
    [sym_identifier] = ACTIONS(615),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(641),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [46] = {
    [sym_preproc_include] = STATE(54),
    [sym_preproc_def] = STATE(54),
    [sym_preproc_function_def] = STATE(54),
    [sym_preproc_call] = STATE(54),
    [sym_preproc_if] = STATE(54),
    [sym_preproc_ifdef] = STATE(54),
    [sym_function_definition] = STATE(54),
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4541),
    [sym_linkage_specification] = STATE(54),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6129),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(54),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2759),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(54),
    [sym_labeled_statement] = STATE(54),
    [sym_expression_statement] = STATE(54),
    [sym_if_statement] = STATE(54),
    [sym_switch_statement] = STATE(54),
    [sym_case_statement] = STATE(54),
    [sym_while_statement] = STATE(54),
    [sym_do_statement] = STATE(54),
    [sym_for_statement] = STATE(54),
    [sym_return_statement] = STATE(54),
    [sym_break_statement] = STATE(54),
    [sym_continue_statement] = STATE(54),
    [sym_goto_statement] = STATE(54),
    [sym_seh_try_statement] = STATE(54),
    [sym_seh_leave_statement] = STATE(54),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(54),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1888),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(54),
    [sym_template_instantiation] = STATE(54),
    [sym_operator_cast] = STATE(6505),
    [sym__constructor_specifiers] = STATE(1888),
    [sym_operator_cast_definition] = STATE(54),
    [sym_operator_cast_declaration] = STATE(54),
    [sym_constructor_or_destructor_definition] = STATE(54),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(54),
    [sym_namespace_alias_definition] = STATE(54),
    [sym_using_declaration] = STATE(54),
    [sym_alias_declaration] = STATE(54),
    [sym_static_assert_declaration] = STATE(54),
    [sym_concept_definition] = STATE(54),
    [sym_for_range_loop] = STATE(54),
    [sym_co_return_statement] = STATE(54),
    [sym_co_yield_statement] = STATE(54),
    [sym_throw_statement] = STATE(54),
    [sym_try_statement] = STATE(54),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6505),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(54),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1888),
    [sym_identifier] = ACTIONS(615),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(643),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [47] = {
    [sym_preproc_include] = STATE(54),
    [sym_preproc_def] = STATE(54),
    [sym_preproc_function_def] = STATE(54),
    [sym_preproc_call] = STATE(54),
    [sym_preproc_if] = STATE(54),
    [sym_preproc_ifdef] = STATE(54),
    [sym_function_definition] = STATE(54),
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4541),
    [sym_linkage_specification] = STATE(54),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6129),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(54),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2759),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(54),
    [sym_labeled_statement] = STATE(54),
    [sym_expression_statement] = STATE(54),
    [sym_if_statement] = STATE(54),
    [sym_switch_statement] = STATE(54),
    [sym_case_statement] = STATE(54),
    [sym_while_statement] = STATE(54),
    [sym_do_statement] = STATE(54),
    [sym_for_statement] = STATE(54),
    [sym_return_statement] = STATE(54),
    [sym_break_statement] = STATE(54),
    [sym_continue_statement] = STATE(54),
    [sym_goto_statement] = STATE(54),
    [sym_seh_try_statement] = STATE(54),
    [sym_seh_leave_statement] = STATE(54),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(54),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1888),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(54),
    [sym_template_instantiation] = STATE(54),
    [sym_operator_cast] = STATE(6505),
    [sym__constructor_specifiers] = STATE(1888),
    [sym_operator_cast_definition] = STATE(54),
    [sym_operator_cast_declaration] = STATE(54),
    [sym_constructor_or_destructor_definition] = STATE(54),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(54),
    [sym_namespace_alias_definition] = STATE(54),
    [sym_using_declaration] = STATE(54),
    [sym_alias_declaration] = STATE(54),
    [sym_static_assert_declaration] = STATE(54),
    [sym_concept_definition] = STATE(54),
    [sym_for_range_loop] = STATE(54),
    [sym_co_return_statement] = STATE(54),
    [sym_co_yield_statement] = STATE(54),
    [sym_throw_statement] = STATE(54),
    [sym_try_statement] = STATE(54),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6505),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(54),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1888),
    [sym_identifier] = ACTIONS(615),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(645),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [48] = {
    [sym_preproc_include] = STATE(36),
    [sym_preproc_def] = STATE(36),
    [sym_preproc_function_def] = STATE(36),
    [sym_preproc_call] = STATE(36),
    [sym_preproc_if] = STATE(36),
    [sym_preproc_ifdef] = STATE(36),
    [sym_function_definition] = STATE(36),
    [sym_declaration] = STATE(36),
    [sym_type_definition] = STATE(36),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4541),
    [sym_linkage_specification] = STATE(36),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6129),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(36),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2759),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(36),
    [sym_labeled_statement] = STATE(36),
    [sym_expression_statement] = STATE(36),
    [sym_if_statement] = STATE(36),
    [sym_switch_statement] = STATE(36),
    [sym_case_statement] = STATE(36),
    [sym_while_statement] = STATE(36),
    [sym_do_statement] = STATE(36),
    [sym_for_statement] = STATE(36),
    [sym_return_statement] = STATE(36),
    [sym_break_statement] = STATE(36),
    [sym_continue_statement] = STATE(36),
    [sym_goto_statement] = STATE(36),
    [sym_seh_try_statement] = STATE(36),
    [sym_seh_leave_statement] = STATE(36),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(36),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1888),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(36),
    [sym_template_instantiation] = STATE(36),
    [sym_operator_cast] = STATE(6505),
    [sym__constructor_specifiers] = STATE(1888),
    [sym_operator_cast_definition] = STATE(36),
    [sym_operator_cast_declaration] = STATE(36),
    [sym_constructor_or_destructor_definition] = STATE(36),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(36),
    [sym_namespace_alias_definition] = STATE(36),
    [sym_using_declaration] = STATE(36),
    [sym_alias_declaration] = STATE(36),
    [sym_static_assert_declaration] = STATE(36),
    [sym_concept_definition] = STATE(36),
    [sym_for_range_loop] = STATE(36),
    [sym_co_return_statement] = STATE(36),
    [sym_co_yield_statement] = STATE(36),
    [sym_throw_statement] = STATE(36),
    [sym_try_statement] = STATE(36),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6505),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(36),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1888),
    [sym_identifier] = ACTIONS(615),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(647),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [49] = {
    [sym_preproc_include] = STATE(54),
    [sym_preproc_def] = STATE(54),
    [sym_preproc_function_def] = STATE(54),
    [sym_preproc_call] = STATE(54),
    [sym_preproc_if] = STATE(54),
    [sym_preproc_ifdef] = STATE(54),
    [sym_function_definition] = STATE(54),
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4541),
    [sym_linkage_specification] = STATE(54),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6129),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(54),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2759),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(54),
    [sym_labeled_statement] = STATE(54),
    [sym_expression_statement] = STATE(54),
    [sym_if_statement] = STATE(54),
    [sym_switch_statement] = STATE(54),
    [sym_case_statement] = STATE(54),
    [sym_while_statement] = STATE(54),
    [sym_do_statement] = STATE(54),
    [sym_for_statement] = STATE(54),
    [sym_return_statement] = STATE(54),
    [sym_break_statement] = STATE(54),
    [sym_continue_statement] = STATE(54),
    [sym_goto_statement] = STATE(54),
    [sym_seh_try_statement] = STATE(54),
    [sym_seh_leave_statement] = STATE(54),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(54),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1888),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(54),
    [sym_template_instantiation] = STATE(54),
    [sym_operator_cast] = STATE(6505),
    [sym__constructor_specifiers] = STATE(1888),
    [sym_operator_cast_definition] = STATE(54),
    [sym_operator_cast_declaration] = STATE(54),
    [sym_constructor_or_destructor_definition] = STATE(54),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(54),
    [sym_namespace_alias_definition] = STATE(54),
    [sym_using_declaration] = STATE(54),
    [sym_alias_declaration] = STATE(54),
    [sym_static_assert_declaration] = STATE(54),
    [sym_concept_definition] = STATE(54),
    [sym_for_range_loop] = STATE(54),
    [sym_co_return_statement] = STATE(54),
    [sym_co_yield_statement] = STATE(54),
    [sym_throw_statement] = STATE(54),
    [sym_try_statement] = STATE(54),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6505),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(54),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1888),
    [sym_identifier] = ACTIONS(615),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(649),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [50] = {
    [sym_preproc_include] = STATE(45),
    [sym_preproc_def] = STATE(45),
    [sym_preproc_function_def] = STATE(45),
    [sym_preproc_call] = STATE(45),
    [sym_preproc_if] = STATE(45),
    [sym_preproc_ifdef] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_declaration] = STATE(45),
    [sym_type_definition] = STATE(45),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4541),
    [sym_linkage_specification] = STATE(45),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6129),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(45),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2759),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(45),
    [sym_labeled_statement] = STATE(45),
    [sym_expression_statement] = STATE(45),
    [sym_if_statement] = STATE(45),
    [sym_switch_statement] = STATE(45),
    [sym_case_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_do_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_return_statement] = STATE(45),
    [sym_break_statement] = STATE(45),
    [sym_continue_statement] = STATE(45),
    [sym_goto_statement] = STATE(45),
    [sym_seh_try_statement] = STATE(45),
    [sym_seh_leave_statement] = STATE(45),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(45),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1888),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(45),
    [sym_template_instantiation] = STATE(45),
    [sym_operator_cast] = STATE(6505),
    [sym__constructor_specifiers] = STATE(1888),
    [sym_operator_cast_definition] = STATE(45),
    [sym_operator_cast_declaration] = STATE(45),
    [sym_constructor_or_destructor_definition] = STATE(45),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(45),
    [sym_namespace_alias_definition] = STATE(45),
    [sym_using_declaration] = STATE(45),
    [sym_alias_declaration] = STATE(45),
    [sym_static_assert_declaration] = STATE(45),
    [sym_concept_definition] = STATE(45),
    [sym_for_range_loop] = STATE(45),
    [sym_co_return_statement] = STATE(45),
    [sym_co_yield_statement] = STATE(45),
    [sym_throw_statement] = STATE(45),
    [sym_try_statement] = STATE(45),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6505),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(45),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1888),
    [sym_identifier] = ACTIONS(615),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(651),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [51] = {
    [sym_preproc_include] = STATE(67),
    [sym_preproc_def] = STATE(67),
    [sym_preproc_function_def] = STATE(67),
    [sym_preproc_call] = STATE(67),
    [sym_preproc_if] = STATE(67),
    [sym_preproc_ifdef] = STATE(67),
    [sym_function_definition] = STATE(67),
    [sym_declaration] = STATE(67),
    [sym_type_definition] = STATE(67),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4602),
    [sym_linkage_specification] = STATE(67),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1850),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6058),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(67),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2750),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(67),
    [sym_labeled_statement] = STATE(67),
    [sym_expression_statement] = STATE(67),
    [sym_if_statement] = STATE(67),
    [sym_switch_statement] = STATE(67),
    [sym_case_statement] = STATE(67),
    [sym_while_statement] = STATE(67),
    [sym_do_statement] = STATE(67),
    [sym_for_statement] = STATE(67),
    [sym_return_statement] = STATE(67),
    [sym_break_statement] = STATE(67),
    [sym_continue_statement] = STATE(67),
    [sym_goto_statement] = STATE(67),
    [sym_seh_try_statement] = STATE(67),
    [sym_seh_leave_statement] = STATE(67),
    [sym__expression] = STATE(4455),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(7649),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(67),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1866),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(67),
    [sym_template_instantiation] = STATE(67),
    [sym_operator_cast] = STATE(6517),
    [sym__constructor_specifiers] = STATE(1866),
    [sym_operator_cast_definition] = STATE(67),
    [sym_operator_cast_declaration] = STATE(67),
    [sym_constructor_or_destructor_definition] = STATE(67),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(67),
    [sym_namespace_alias_definition] = STATE(67),
    [sym_using_declaration] = STATE(67),
    [sym_alias_declaration] = STATE(67),
    [sym_static_assert_declaration] = STATE(67),
    [sym_concept_definition] = STATE(67),
    [sym_for_range_loop] = STATE(67),
    [sym_co_return_statement] = STATE(67),
    [sym_co_yield_statement] = STATE(67),
    [sym_throw_statement] = STATE(67),
    [sym_try_statement] = STATE(67),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6517),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(67),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(173),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1866),
    [sym_identifier] = ACTIONS(653),
    [aux_sym_preproc_include_token1] = ACTIONS(655),
    [aux_sym_preproc_def_token1] = ACTIONS(657),
    [aux_sym_preproc_if_token1] = ACTIONS(659),
    [aux_sym_preproc_if_token2] = ACTIONS(661),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(663),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(663),
    [sym_preproc_directive] = ACTIONS(665),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym___extension__] = ACTIONS(669),
    [anon_sym_typedef] = ACTIONS(671),
    [anon_sym_extern] = ACTIONS(673),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(675),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(677),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(679),
    [anon_sym_switch] = ACTIONS(681),
    [anon_sym_case] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_while] = ACTIONS(687),
    [anon_sym_do] = ACTIONS(689),
    [anon_sym_for] = ACTIONS(691),
    [anon_sym_return] = ACTIONS(693),
    [anon_sym_break] = ACTIONS(695),
    [anon_sym_continue] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym___try] = ACTIONS(701),
    [anon_sym___leave] = ACTIONS(703),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(705),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(707),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(709),
    [anon_sym_namespace] = ACTIONS(711),
    [anon_sym_using] = ACTIONS(713),
    [anon_sym_static_assert] = ACTIONS(715),
    [anon_sym_concept] = ACTIONS(717),
    [anon_sym_co_return] = ACTIONS(719),
    [anon_sym_co_yield] = ACTIONS(721),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [52] = {
    [sym_preproc_include] = STATE(54),
    [sym_preproc_def] = STATE(54),
    [sym_preproc_function_def] = STATE(54),
    [sym_preproc_call] = STATE(54),
    [sym_preproc_if] = STATE(54),
    [sym_preproc_ifdef] = STATE(54),
    [sym_function_definition] = STATE(54),
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4541),
    [sym_linkage_specification] = STATE(54),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6129),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(54),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2759),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(54),
    [sym_labeled_statement] = STATE(54),
    [sym_expression_statement] = STATE(54),
    [sym_if_statement] = STATE(54),
    [sym_switch_statement] = STATE(54),
    [sym_case_statement] = STATE(54),
    [sym_while_statement] = STATE(54),
    [sym_do_statement] = STATE(54),
    [sym_for_statement] = STATE(54),
    [sym_return_statement] = STATE(54),
    [sym_break_statement] = STATE(54),
    [sym_continue_statement] = STATE(54),
    [sym_goto_statement] = STATE(54),
    [sym_seh_try_statement] = STATE(54),
    [sym_seh_leave_statement] = STATE(54),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(54),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1888),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(54),
    [sym_template_instantiation] = STATE(54),
    [sym_operator_cast] = STATE(6505),
    [sym__constructor_specifiers] = STATE(1888),
    [sym_operator_cast_definition] = STATE(54),
    [sym_operator_cast_declaration] = STATE(54),
    [sym_constructor_or_destructor_definition] = STATE(54),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(54),
    [sym_namespace_alias_definition] = STATE(54),
    [sym_using_declaration] = STATE(54),
    [sym_alias_declaration] = STATE(54),
    [sym_static_assert_declaration] = STATE(54),
    [sym_concept_definition] = STATE(54),
    [sym_for_range_loop] = STATE(54),
    [sym_co_return_statement] = STATE(54),
    [sym_co_yield_statement] = STATE(54),
    [sym_throw_statement] = STATE(54),
    [sym_try_statement] = STATE(54),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6505),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(54),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1888),
    [sym_identifier] = ACTIONS(615),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(723),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [53] = {
    [sym_preproc_include] = STATE(44),
    [sym_preproc_def] = STATE(44),
    [sym_preproc_function_def] = STATE(44),
    [sym_preproc_call] = STATE(44),
    [sym_preproc_if] = STATE(44),
    [sym_preproc_ifdef] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_declaration] = STATE(44),
    [sym_type_definition] = STATE(44),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4541),
    [sym_linkage_specification] = STATE(44),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6129),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(44),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2759),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(44),
    [sym_labeled_statement] = STATE(44),
    [sym_expression_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_switch_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_while_statement] = STATE(44),
    [sym_do_statement] = STATE(44),
    [sym_for_statement] = STATE(44),
    [sym_return_statement] = STATE(44),
    [sym_break_statement] = STATE(44),
    [sym_continue_statement] = STATE(44),
    [sym_goto_statement] = STATE(44),
    [sym_seh_try_statement] = STATE(44),
    [sym_seh_leave_statement] = STATE(44),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(44),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1888),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(44),
    [sym_template_instantiation] = STATE(44),
    [sym_operator_cast] = STATE(6505),
    [sym__constructor_specifiers] = STATE(1888),
    [sym_operator_cast_definition] = STATE(44),
    [sym_operator_cast_declaration] = STATE(44),
    [sym_constructor_or_destructor_definition] = STATE(44),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(44),
    [sym_namespace_alias_definition] = STATE(44),
    [sym_using_declaration] = STATE(44),
    [sym_alias_declaration] = STATE(44),
    [sym_static_assert_declaration] = STATE(44),
    [sym_concept_definition] = STATE(44),
    [sym_for_range_loop] = STATE(44),
    [sym_co_return_statement] = STATE(44),
    [sym_co_yield_statement] = STATE(44),
    [sym_throw_statement] = STATE(44),
    [sym_try_statement] = STATE(44),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6505),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(44),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1888),
    [sym_identifier] = ACTIONS(615),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(725),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [54] = {
    [sym_preproc_include] = STATE(54),
    [sym_preproc_def] = STATE(54),
    [sym_preproc_function_def] = STATE(54),
    [sym_preproc_call] = STATE(54),
    [sym_preproc_if] = STATE(54),
    [sym_preproc_ifdef] = STATE(54),
    [sym_function_definition] = STATE(54),
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4541),
    [sym_linkage_specification] = STATE(54),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6129),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(54),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2759),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(54),
    [sym_labeled_statement] = STATE(54),
    [sym_expression_statement] = STATE(54),
    [sym_if_statement] = STATE(54),
    [sym_switch_statement] = STATE(54),
    [sym_case_statement] = STATE(54),
    [sym_while_statement] = STATE(54),
    [sym_do_statement] = STATE(54),
    [sym_for_statement] = STATE(54),
    [sym_return_statement] = STATE(54),
    [sym_break_statement] = STATE(54),
    [sym_continue_statement] = STATE(54),
    [sym_goto_statement] = STATE(54),
    [sym_seh_try_statement] = STATE(54),
    [sym_seh_leave_statement] = STATE(54),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(54),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1888),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(54),
    [sym_template_instantiation] = STATE(54),
    [sym_operator_cast] = STATE(6505),
    [sym__constructor_specifiers] = STATE(1888),
    [sym_operator_cast_definition] = STATE(54),
    [sym_operator_cast_declaration] = STATE(54),
    [sym_constructor_or_destructor_definition] = STATE(54),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(54),
    [sym_namespace_alias_definition] = STATE(54),
    [sym_using_declaration] = STATE(54),
    [sym_alias_declaration] = STATE(54),
    [sym_static_assert_declaration] = STATE(54),
    [sym_concept_definition] = STATE(54),
    [sym_for_range_loop] = STATE(54),
    [sym_co_return_statement] = STATE(54),
    [sym_co_yield_statement] = STATE(54),
    [sym_throw_statement] = STATE(54),
    [sym_try_statement] = STATE(54),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6505),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(54),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1888),
    [sym_identifier] = ACTIONS(727),
    [aux_sym_preproc_include_token1] = ACTIONS(730),
    [aux_sym_preproc_def_token1] = ACTIONS(733),
    [aux_sym_preproc_if_token1] = ACTIONS(736),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(739),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(739),
    [sym_preproc_directive] = ACTIONS(742),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_BANG] = ACTIONS(396),
    [anon_sym_TILDE] = ACTIONS(399),
    [anon_sym_DASH] = ACTIONS(402),
    [anon_sym_PLUS] = ACTIONS(402),
    [anon_sym_STAR] = ACTIONS(405),
    [anon_sym_AMP_AMP] = ACTIONS(408),
    [anon_sym_AMP] = ACTIONS(411),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym___extension__] = ACTIONS(748),
    [anon_sym_typedef] = ACTIONS(751),
    [anon_sym_extern] = ACTIONS(754),
    [anon_sym___attribute__] = ACTIONS(426),
    [anon_sym_COLON_COLON] = ACTIONS(429),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(432),
    [anon_sym___declspec] = ACTIONS(435),
    [anon_sym___based] = ACTIONS(438),
    [anon_sym___cdecl] = ACTIONS(441),
    [anon_sym___clrcall] = ACTIONS(441),
    [anon_sym___stdcall] = ACTIONS(441),
    [anon_sym___fastcall] = ACTIONS(441),
    [anon_sym___thiscall] = ACTIONS(441),
    [anon_sym___vectorcall] = ACTIONS(441),
    [anon_sym_LBRACE] = ACTIONS(757),
    [anon_sym_RBRACE] = ACTIONS(760),
    [anon_sym_signed] = ACTIONS(447),
    [anon_sym_unsigned] = ACTIONS(447),
    [anon_sym_long] = ACTIONS(447),
    [anon_sym_short] = ACTIONS(447),
    [anon_sym_LBRACK] = ACTIONS(450),
    [anon_sym_static] = ACTIONS(453),
    [anon_sym_register] = ACTIONS(453),
    [anon_sym_inline] = ACTIONS(762),
    [anon_sym___inline] = ACTIONS(453),
    [anon_sym___inline__] = ACTIONS(453),
    [anon_sym___forceinline] = ACTIONS(453),
    [anon_sym_thread_local] = ACTIONS(453),
    [anon_sym___thread] = ACTIONS(453),
    [anon_sym_const] = ACTIONS(459),
    [anon_sym_constexpr] = ACTIONS(459),
    [anon_sym_volatile] = ACTIONS(459),
    [anon_sym_restrict] = ACTIONS(459),
    [anon_sym___restrict__] = ACTIONS(459),
    [anon_sym__Atomic] = ACTIONS(459),
    [anon_sym__Noreturn] = ACTIONS(459),
    [anon_sym_noreturn] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(459),
    [anon_sym_constinit] = ACTIONS(459),
    [anon_sym_consteval] = ACTIONS(459),
    [anon_sym_PROGMEM] = ACTIONS(459),
    [aux_sym_primitive_type_token1] = ACTIONS(462),
    [anon_sym_byte] = ACTIONS(462),
    [anon_sym_word] = ACTIONS(462),
    [anon_sym_enum] = ACTIONS(465),
    [anon_sym_class] = ACTIONS(468),
    [anon_sym_struct] = ACTIONS(471),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_if] = ACTIONS(765),
    [anon_sym_switch] = ACTIONS(768),
    [anon_sym_case] = ACTIONS(771),
    [anon_sym_default] = ACTIONS(774),
    [anon_sym_while] = ACTIONS(777),
    [anon_sym_do] = ACTIONS(780),
    [anon_sym_for] = ACTIONS(783),
    [anon_sym_return] = ACTIONS(786),
    [anon_sym_break] = ACTIONS(789),
    [anon_sym_continue] = ACTIONS(792),
    [anon_sym_goto] = ACTIONS(795),
    [anon_sym___try] = ACTIONS(798),
    [anon_sym___leave] = ACTIONS(801),
    [anon_sym_not] = ACTIONS(402),
    [anon_sym_compl] = ACTIONS(402),
    [anon_sym_DASH_DASH] = ACTIONS(516),
    [anon_sym_PLUS_PLUS] = ACTIONS(516),
    [anon_sym_sizeof] = ACTIONS(519),
    [anon_sym___alignof__] = ACTIONS(522),
    [anon_sym___alignof] = ACTIONS(522),
    [anon_sym__alignof] = ACTIONS(522),
    [anon_sym_alignof] = ACTIONS(522),
    [anon_sym__Alignof] = ACTIONS(522),
    [anon_sym_offsetof] = ACTIONS(525),
    [anon_sym__Generic] = ACTIONS(528),
    [anon_sym_asm] = ACTIONS(531),
    [anon_sym___asm__] = ACTIONS(531),
    [aux_sym_number_literal_token1] = ACTIONS(534),
    [aux_sym_number_literal_token2] = ACTIONS(537),
    [anon_sym_L_SQUOTE] = ACTIONS(540),
    [anon_sym_u_SQUOTE] = ACTIONS(540),
    [anon_sym_U_SQUOTE] = ACTIONS(540),
    [anon_sym_u8_SQUOTE] = ACTIONS(540),
    [anon_sym_SQUOTE] = ACTIONS(540),
    [anon_sym_L_DQUOTE] = ACTIONS(543),
    [anon_sym_u_DQUOTE] = ACTIONS(543),
    [anon_sym_U_DQUOTE] = ACTIONS(543),
    [anon_sym_u8_DQUOTE] = ACTIONS(543),
    [anon_sym_DQUOTE] = ACTIONS(543),
    [sym_true] = ACTIONS(546),
    [sym_false] = ACTIONS(546),
    [anon_sym_NULL] = ACTIONS(549),
    [anon_sym_nullptr] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(552),
    [anon_sym_decltype] = ACTIONS(555),
    [anon_sym_virtual] = ACTIONS(558),
    [anon_sym_alignas] = ACTIONS(561),
    [anon_sym_explicit] = ACTIONS(564),
    [anon_sym_typename] = ACTIONS(567),
    [anon_sym_template] = ACTIONS(804),
    [anon_sym_operator] = ACTIONS(573),
    [anon_sym_try] = ACTIONS(807),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_throw] = ACTIONS(810),
    [anon_sym_namespace] = ACTIONS(813),
    [anon_sym_using] = ACTIONS(816),
    [anon_sym_static_assert] = ACTIONS(819),
    [anon_sym_concept] = ACTIONS(822),
    [anon_sym_co_return] = ACTIONS(825),
    [anon_sym_co_yield] = ACTIONS(828),
    [anon_sym_R_DQUOTE] = ACTIONS(603),
    [anon_sym_LR_DQUOTE] = ACTIONS(603),
    [anon_sym_uR_DQUOTE] = ACTIONS(603),
    [anon_sym_UR_DQUOTE] = ACTIONS(603),
    [anon_sym_u8R_DQUOTE] = ACTIONS(603),
    [anon_sym_co_await] = ACTIONS(606),
    [anon_sym_new] = ACTIONS(609),
    [anon_sym_requires] = ACTIONS(612),
    [sym_this] = ACTIONS(546),
  },
  [55] = {
    [sym_preproc_include] = STATE(52),
    [sym_preproc_def] = STATE(52),
    [sym_preproc_function_def] = STATE(52),
    [sym_preproc_call] = STATE(52),
    [sym_preproc_if] = STATE(52),
    [sym_preproc_ifdef] = STATE(52),
    [sym_function_definition] = STATE(52),
    [sym_declaration] = STATE(52),
    [sym_type_definition] = STATE(52),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4541),
    [sym_linkage_specification] = STATE(52),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6129),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(52),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2759),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(52),
    [sym_labeled_statement] = STATE(52),
    [sym_expression_statement] = STATE(52),
    [sym_if_statement] = STATE(52),
    [sym_switch_statement] = STATE(52),
    [sym_case_statement] = STATE(52),
    [sym_while_statement] = STATE(52),
    [sym_do_statement] = STATE(52),
    [sym_for_statement] = STATE(52),
    [sym_return_statement] = STATE(52),
    [sym_break_statement] = STATE(52),
    [sym_continue_statement] = STATE(52),
    [sym_goto_statement] = STATE(52),
    [sym_seh_try_statement] = STATE(52),
    [sym_seh_leave_statement] = STATE(52),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(52),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1888),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(52),
    [sym_template_instantiation] = STATE(52),
    [sym_operator_cast] = STATE(6505),
    [sym__constructor_specifiers] = STATE(1888),
    [sym_operator_cast_definition] = STATE(52),
    [sym_operator_cast_declaration] = STATE(52),
    [sym_constructor_or_destructor_definition] = STATE(52),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(52),
    [sym_namespace_alias_definition] = STATE(52),
    [sym_using_declaration] = STATE(52),
    [sym_alias_declaration] = STATE(52),
    [sym_static_assert_declaration] = STATE(52),
    [sym_concept_definition] = STATE(52),
    [sym_for_range_loop] = STATE(52),
    [sym_co_return_statement] = STATE(52),
    [sym_co_yield_statement] = STATE(52),
    [sym_throw_statement] = STATE(52),
    [sym_try_statement] = STATE(52),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6505),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(52),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1888),
    [sym_identifier] = ACTIONS(615),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(831),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [56] = {
    [sym_preproc_include] = STATE(54),
    [sym_preproc_def] = STATE(54),
    [sym_preproc_function_def] = STATE(54),
    [sym_preproc_call] = STATE(54),
    [sym_preproc_if] = STATE(54),
    [sym_preproc_ifdef] = STATE(54),
    [sym_function_definition] = STATE(54),
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4541),
    [sym_linkage_specification] = STATE(54),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6129),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(54),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2759),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(54),
    [sym_labeled_statement] = STATE(54),
    [sym_expression_statement] = STATE(54),
    [sym_if_statement] = STATE(54),
    [sym_switch_statement] = STATE(54),
    [sym_case_statement] = STATE(54),
    [sym_while_statement] = STATE(54),
    [sym_do_statement] = STATE(54),
    [sym_for_statement] = STATE(54),
    [sym_return_statement] = STATE(54),
    [sym_break_statement] = STATE(54),
    [sym_continue_statement] = STATE(54),
    [sym_goto_statement] = STATE(54),
    [sym_seh_try_statement] = STATE(54),
    [sym_seh_leave_statement] = STATE(54),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(54),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1888),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(54),
    [sym_template_instantiation] = STATE(54),
    [sym_operator_cast] = STATE(6505),
    [sym__constructor_specifiers] = STATE(1888),
    [sym_operator_cast_definition] = STATE(54),
    [sym_operator_cast_declaration] = STATE(54),
    [sym_constructor_or_destructor_definition] = STATE(54),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(54),
    [sym_namespace_alias_definition] = STATE(54),
    [sym_using_declaration] = STATE(54),
    [sym_alias_declaration] = STATE(54),
    [sym_static_assert_declaration] = STATE(54),
    [sym_concept_definition] = STATE(54),
    [sym_for_range_loop] = STATE(54),
    [sym_co_return_statement] = STATE(54),
    [sym_co_yield_statement] = STATE(54),
    [sym_throw_statement] = STATE(54),
    [sym_try_statement] = STATE(54),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6505),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(54),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1888),
    [sym_identifier] = ACTIONS(615),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(833),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [57] = {
    [sym_preproc_include] = STATE(69),
    [sym_preproc_def] = STATE(69),
    [sym_preproc_function_def] = STATE(69),
    [sym_preproc_call] = STATE(69),
    [sym_preproc_if] = STATE(69),
    [sym_preproc_ifdef] = STATE(69),
    [sym_function_definition] = STATE(69),
    [sym_declaration] = STATE(69),
    [sym_type_definition] = STATE(69),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4541),
    [sym_linkage_specification] = STATE(69),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6129),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(69),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2759),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(69),
    [sym_labeled_statement] = STATE(69),
    [sym_expression_statement] = STATE(69),
    [sym_if_statement] = STATE(69),
    [sym_switch_statement] = STATE(69),
    [sym_case_statement] = STATE(69),
    [sym_while_statement] = STATE(69),
    [sym_do_statement] = STATE(69),
    [sym_for_statement] = STATE(69),
    [sym_return_statement] = STATE(69),
    [sym_break_statement] = STATE(69),
    [sym_continue_statement] = STATE(69),
    [sym_goto_statement] = STATE(69),
    [sym_seh_try_statement] = STATE(69),
    [sym_seh_leave_statement] = STATE(69),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(69),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1888),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(69),
    [sym_template_instantiation] = STATE(69),
    [sym_operator_cast] = STATE(6505),
    [sym__constructor_specifiers] = STATE(1888),
    [sym_operator_cast_definition] = STATE(69),
    [sym_operator_cast_declaration] = STATE(69),
    [sym_constructor_or_destructor_definition] = STATE(69),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(69),
    [sym_namespace_alias_definition] = STATE(69),
    [sym_using_declaration] = STATE(69),
    [sym_alias_declaration] = STATE(69),
    [sym_static_assert_declaration] = STATE(69),
    [sym_concept_definition] = STATE(69),
    [sym_for_range_loop] = STATE(69),
    [sym_co_return_statement] = STATE(69),
    [sym_co_yield_statement] = STATE(69),
    [sym_throw_statement] = STATE(69),
    [sym_try_statement] = STATE(69),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6505),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(69),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1888),
    [sym_identifier] = ACTIONS(615),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(835),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [58] = {
    [sym_preproc_include] = STATE(54),
    [sym_preproc_def] = STATE(54),
    [sym_preproc_function_def] = STATE(54),
    [sym_preproc_call] = STATE(54),
    [sym_preproc_if] = STATE(54),
    [sym_preproc_ifdef] = STATE(54),
    [sym_function_definition] = STATE(54),
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4541),
    [sym_linkage_specification] = STATE(54),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6129),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(54),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2759),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(54),
    [sym_labeled_statement] = STATE(54),
    [sym_expression_statement] = STATE(54),
    [sym_if_statement] = STATE(54),
    [sym_switch_statement] = STATE(54),
    [sym_case_statement] = STATE(54),
    [sym_while_statement] = STATE(54),
    [sym_do_statement] = STATE(54),
    [sym_for_statement] = STATE(54),
    [sym_return_statement] = STATE(54),
    [sym_break_statement] = STATE(54),
    [sym_continue_statement] = STATE(54),
    [sym_goto_statement] = STATE(54),
    [sym_seh_try_statement] = STATE(54),
    [sym_seh_leave_statement] = STATE(54),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(54),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1888),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(54),
    [sym_template_instantiation] = STATE(54),
    [sym_operator_cast] = STATE(6505),
    [sym__constructor_specifiers] = STATE(1888),
    [sym_operator_cast_definition] = STATE(54),
    [sym_operator_cast_declaration] = STATE(54),
    [sym_constructor_or_destructor_definition] = STATE(54),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(54),
    [sym_namespace_alias_definition] = STATE(54),
    [sym_using_declaration] = STATE(54),
    [sym_alias_declaration] = STATE(54),
    [sym_static_assert_declaration] = STATE(54),
    [sym_concept_definition] = STATE(54),
    [sym_for_range_loop] = STATE(54),
    [sym_co_return_statement] = STATE(54),
    [sym_co_yield_statement] = STATE(54),
    [sym_throw_statement] = STATE(54),
    [sym_try_statement] = STATE(54),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6505),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(54),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1888),
    [sym_identifier] = ACTIONS(615),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(837),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [59] = {
    [sym_preproc_include] = STATE(54),
    [sym_preproc_def] = STATE(54),
    [sym_preproc_function_def] = STATE(54),
    [sym_preproc_call] = STATE(54),
    [sym_preproc_if] = STATE(54),
    [sym_preproc_ifdef] = STATE(54),
    [sym_function_definition] = STATE(54),
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4541),
    [sym_linkage_specification] = STATE(54),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6129),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(54),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2759),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(54),
    [sym_labeled_statement] = STATE(54),
    [sym_expression_statement] = STATE(54),
    [sym_if_statement] = STATE(54),
    [sym_switch_statement] = STATE(54),
    [sym_case_statement] = STATE(54),
    [sym_while_statement] = STATE(54),
    [sym_do_statement] = STATE(54),
    [sym_for_statement] = STATE(54),
    [sym_return_statement] = STATE(54),
    [sym_break_statement] = STATE(54),
    [sym_continue_statement] = STATE(54),
    [sym_goto_statement] = STATE(54),
    [sym_seh_try_statement] = STATE(54),
    [sym_seh_leave_statement] = STATE(54),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(54),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1888),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(54),
    [sym_template_instantiation] = STATE(54),
    [sym_operator_cast] = STATE(6505),
    [sym__constructor_specifiers] = STATE(1888),
    [sym_operator_cast_definition] = STATE(54),
    [sym_operator_cast_declaration] = STATE(54),
    [sym_constructor_or_destructor_definition] = STATE(54),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(54),
    [sym_namespace_alias_definition] = STATE(54),
    [sym_using_declaration] = STATE(54),
    [sym_alias_declaration] = STATE(54),
    [sym_static_assert_declaration] = STATE(54),
    [sym_concept_definition] = STATE(54),
    [sym_for_range_loop] = STATE(54),
    [sym_co_return_statement] = STATE(54),
    [sym_co_yield_statement] = STATE(54),
    [sym_throw_statement] = STATE(54),
    [sym_try_statement] = STATE(54),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6505),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(54),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1888),
    [sym_identifier] = ACTIONS(615),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(839),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [60] = {
    [sym_preproc_include] = STATE(59),
    [sym_preproc_def] = STATE(59),
    [sym_preproc_function_def] = STATE(59),
    [sym_preproc_call] = STATE(59),
    [sym_preproc_if] = STATE(59),
    [sym_preproc_ifdef] = STATE(59),
    [sym_function_definition] = STATE(59),
    [sym_declaration] = STATE(59),
    [sym_type_definition] = STATE(59),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4541),
    [sym_linkage_specification] = STATE(59),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6129),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(59),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2759),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(59),
    [sym_labeled_statement] = STATE(59),
    [sym_expression_statement] = STATE(59),
    [sym_if_statement] = STATE(59),
    [sym_switch_statement] = STATE(59),
    [sym_case_statement] = STATE(59),
    [sym_while_statement] = STATE(59),
    [sym_do_statement] = STATE(59),
    [sym_for_statement] = STATE(59),
    [sym_return_statement] = STATE(59),
    [sym_break_statement] = STATE(59),
    [sym_continue_statement] = STATE(59),
    [sym_goto_statement] = STATE(59),
    [sym_seh_try_statement] = STATE(59),
    [sym_seh_leave_statement] = STATE(59),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(59),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1888),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(59),
    [sym_template_instantiation] = STATE(59),
    [sym_operator_cast] = STATE(6505),
    [sym__constructor_specifiers] = STATE(1888),
    [sym_operator_cast_definition] = STATE(59),
    [sym_operator_cast_declaration] = STATE(59),
    [sym_constructor_or_destructor_definition] = STATE(59),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(59),
    [sym_namespace_alias_definition] = STATE(59),
    [sym_using_declaration] = STATE(59),
    [sym_alias_declaration] = STATE(59),
    [sym_static_assert_declaration] = STATE(59),
    [sym_concept_definition] = STATE(59),
    [sym_for_range_loop] = STATE(59),
    [sym_co_return_statement] = STATE(59),
    [sym_co_yield_statement] = STATE(59),
    [sym_throw_statement] = STATE(59),
    [sym_try_statement] = STATE(59),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6505),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(59),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1888),
    [sym_identifier] = ACTIONS(615),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(841),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [61] = {
    [sym_preproc_include] = STATE(76),
    [sym_preproc_def] = STATE(76),
    [sym_preproc_function_def] = STATE(76),
    [sym_preproc_call] = STATE(76),
    [sym_preproc_if] = STATE(76),
    [sym_preproc_ifdef] = STATE(76),
    [sym_function_definition] = STATE(76),
    [sym_declaration] = STATE(76),
    [sym_type_definition] = STATE(76),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4541),
    [sym_linkage_specification] = STATE(76),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6129),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(76),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2759),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(76),
    [sym_labeled_statement] = STATE(76),
    [sym_expression_statement] = STATE(76),
    [sym_if_statement] = STATE(76),
    [sym_switch_statement] = STATE(76),
    [sym_case_statement] = STATE(76),
    [sym_while_statement] = STATE(76),
    [sym_do_statement] = STATE(76),
    [sym_for_statement] = STATE(76),
    [sym_return_statement] = STATE(76),
    [sym_break_statement] = STATE(76),
    [sym_continue_statement] = STATE(76),
    [sym_goto_statement] = STATE(76),
    [sym_seh_try_statement] = STATE(76),
    [sym_seh_leave_statement] = STATE(76),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(76),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1888),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(76),
    [sym_template_instantiation] = STATE(76),
    [sym_operator_cast] = STATE(6505),
    [sym__constructor_specifiers] = STATE(1888),
    [sym_operator_cast_definition] = STATE(76),
    [sym_operator_cast_declaration] = STATE(76),
    [sym_constructor_or_destructor_definition] = STATE(76),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(76),
    [sym_namespace_alias_definition] = STATE(76),
    [sym_using_declaration] = STATE(76),
    [sym_alias_declaration] = STATE(76),
    [sym_static_assert_declaration] = STATE(76),
    [sym_concept_definition] = STATE(76),
    [sym_for_range_loop] = STATE(76),
    [sym_co_return_statement] = STATE(76),
    [sym_co_yield_statement] = STATE(76),
    [sym_throw_statement] = STATE(76),
    [sym_try_statement] = STATE(76),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6505),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(76),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1888),
    [sym_identifier] = ACTIONS(615),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(843),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [62] = {
    [sym_preproc_include] = STATE(46),
    [sym_preproc_def] = STATE(46),
    [sym_preproc_function_def] = STATE(46),
    [sym_preproc_call] = STATE(46),
    [sym_preproc_if] = STATE(46),
    [sym_preproc_ifdef] = STATE(46),
    [sym_function_definition] = STATE(46),
    [sym_declaration] = STATE(46),
    [sym_type_definition] = STATE(46),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4541),
    [sym_linkage_specification] = STATE(46),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6129),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(46),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2759),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(46),
    [sym_labeled_statement] = STATE(46),
    [sym_expression_statement] = STATE(46),
    [sym_if_statement] = STATE(46),
    [sym_switch_statement] = STATE(46),
    [sym_case_statement] = STATE(46),
    [sym_while_statement] = STATE(46),
    [sym_do_statement] = STATE(46),
    [sym_for_statement] = STATE(46),
    [sym_return_statement] = STATE(46),
    [sym_break_statement] = STATE(46),
    [sym_continue_statement] = STATE(46),
    [sym_goto_statement] = STATE(46),
    [sym_seh_try_statement] = STATE(46),
    [sym_seh_leave_statement] = STATE(46),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(46),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1888),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(46),
    [sym_template_instantiation] = STATE(46),
    [sym_operator_cast] = STATE(6505),
    [sym__constructor_specifiers] = STATE(1888),
    [sym_operator_cast_definition] = STATE(46),
    [sym_operator_cast_declaration] = STATE(46),
    [sym_constructor_or_destructor_definition] = STATE(46),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(46),
    [sym_namespace_alias_definition] = STATE(46),
    [sym_using_declaration] = STATE(46),
    [sym_alias_declaration] = STATE(46),
    [sym_static_assert_declaration] = STATE(46),
    [sym_concept_definition] = STATE(46),
    [sym_for_range_loop] = STATE(46),
    [sym_co_return_statement] = STATE(46),
    [sym_co_yield_statement] = STATE(46),
    [sym_throw_statement] = STATE(46),
    [sym_try_statement] = STATE(46),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6505),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(46),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1888),
    [sym_identifier] = ACTIONS(615),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(845),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [63] = {
    [sym_preproc_include] = STATE(54),
    [sym_preproc_def] = STATE(54),
    [sym_preproc_function_def] = STATE(54),
    [sym_preproc_call] = STATE(54),
    [sym_preproc_if] = STATE(54),
    [sym_preproc_ifdef] = STATE(54),
    [sym_function_definition] = STATE(54),
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4541),
    [sym_linkage_specification] = STATE(54),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6129),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(54),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2759),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(54),
    [sym_labeled_statement] = STATE(54),
    [sym_expression_statement] = STATE(54),
    [sym_if_statement] = STATE(54),
    [sym_switch_statement] = STATE(54),
    [sym_case_statement] = STATE(54),
    [sym_while_statement] = STATE(54),
    [sym_do_statement] = STATE(54),
    [sym_for_statement] = STATE(54),
    [sym_return_statement] = STATE(54),
    [sym_break_statement] = STATE(54),
    [sym_continue_statement] = STATE(54),
    [sym_goto_statement] = STATE(54),
    [sym_seh_try_statement] = STATE(54),
    [sym_seh_leave_statement] = STATE(54),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(54),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1888),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(54),
    [sym_template_instantiation] = STATE(54),
    [sym_operator_cast] = STATE(6505),
    [sym__constructor_specifiers] = STATE(1888),
    [sym_operator_cast_definition] = STATE(54),
    [sym_operator_cast_declaration] = STATE(54),
    [sym_constructor_or_destructor_definition] = STATE(54),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(54),
    [sym_namespace_alias_definition] = STATE(54),
    [sym_using_declaration] = STATE(54),
    [sym_alias_declaration] = STATE(54),
    [sym_static_assert_declaration] = STATE(54),
    [sym_concept_definition] = STATE(54),
    [sym_for_range_loop] = STATE(54),
    [sym_co_return_statement] = STATE(54),
    [sym_co_yield_statement] = STATE(54),
    [sym_throw_statement] = STATE(54),
    [sym_try_statement] = STATE(54),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6505),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(54),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1888),
    [sym_identifier] = ACTIONS(615),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(847),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [64] = {
    [sym_preproc_include] = STATE(54),
    [sym_preproc_def] = STATE(54),
    [sym_preproc_function_def] = STATE(54),
    [sym_preproc_call] = STATE(54),
    [sym_preproc_if] = STATE(54),
    [sym_preproc_ifdef] = STATE(54),
    [sym_function_definition] = STATE(54),
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4541),
    [sym_linkage_specification] = STATE(54),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6129),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(54),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2759),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(54),
    [sym_labeled_statement] = STATE(54),
    [sym_expression_statement] = STATE(54),
    [sym_if_statement] = STATE(54),
    [sym_switch_statement] = STATE(54),
    [sym_case_statement] = STATE(54),
    [sym_while_statement] = STATE(54),
    [sym_do_statement] = STATE(54),
    [sym_for_statement] = STATE(54),
    [sym_return_statement] = STATE(54),
    [sym_break_statement] = STATE(54),
    [sym_continue_statement] = STATE(54),
    [sym_goto_statement] = STATE(54),
    [sym_seh_try_statement] = STATE(54),
    [sym_seh_leave_statement] = STATE(54),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(54),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1888),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(54),
    [sym_template_instantiation] = STATE(54),
    [sym_operator_cast] = STATE(6505),
    [sym__constructor_specifiers] = STATE(1888),
    [sym_operator_cast_definition] = STATE(54),
    [sym_operator_cast_declaration] = STATE(54),
    [sym_constructor_or_destructor_definition] = STATE(54),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(54),
    [sym_namespace_alias_definition] = STATE(54),
    [sym_using_declaration] = STATE(54),
    [sym_alias_declaration] = STATE(54),
    [sym_static_assert_declaration] = STATE(54),
    [sym_concept_definition] = STATE(54),
    [sym_for_range_loop] = STATE(54),
    [sym_co_return_statement] = STATE(54),
    [sym_co_yield_statement] = STATE(54),
    [sym_throw_statement] = STATE(54),
    [sym_try_statement] = STATE(54),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6505),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(54),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1888),
    [sym_identifier] = ACTIONS(615),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(849),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [65] = {
    [sym_preproc_include] = STATE(54),
    [sym_preproc_def] = STATE(54),
    [sym_preproc_function_def] = STATE(54),
    [sym_preproc_call] = STATE(54),
    [sym_preproc_if] = STATE(54),
    [sym_preproc_ifdef] = STATE(54),
    [sym_function_definition] = STATE(54),
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4541),
    [sym_linkage_specification] = STATE(54),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6129),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(54),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2759),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(54),
    [sym_labeled_statement] = STATE(54),
    [sym_expression_statement] = STATE(54),
    [sym_if_statement] = STATE(54),
    [sym_switch_statement] = STATE(54),
    [sym_case_statement] = STATE(54),
    [sym_while_statement] = STATE(54),
    [sym_do_statement] = STATE(54),
    [sym_for_statement] = STATE(54),
    [sym_return_statement] = STATE(54),
    [sym_break_statement] = STATE(54),
    [sym_continue_statement] = STATE(54),
    [sym_goto_statement] = STATE(54),
    [sym_seh_try_statement] = STATE(54),
    [sym_seh_leave_statement] = STATE(54),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(54),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1888),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(54),
    [sym_template_instantiation] = STATE(54),
    [sym_operator_cast] = STATE(6505),
    [sym__constructor_specifiers] = STATE(1888),
    [sym_operator_cast_definition] = STATE(54),
    [sym_operator_cast_declaration] = STATE(54),
    [sym_constructor_or_destructor_definition] = STATE(54),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(54),
    [sym_namespace_alias_definition] = STATE(54),
    [sym_using_declaration] = STATE(54),
    [sym_alias_declaration] = STATE(54),
    [sym_static_assert_declaration] = STATE(54),
    [sym_concept_definition] = STATE(54),
    [sym_for_range_loop] = STATE(54),
    [sym_co_return_statement] = STATE(54),
    [sym_co_yield_statement] = STATE(54),
    [sym_throw_statement] = STATE(54),
    [sym_try_statement] = STATE(54),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6505),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(54),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1888),
    [sym_identifier] = ACTIONS(615),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(851),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [66] = {
    [sym_preproc_include] = STATE(66),
    [sym_preproc_def] = STATE(66),
    [sym_preproc_function_def] = STATE(66),
    [sym_preproc_call] = STATE(66),
    [sym_preproc_if] = STATE(66),
    [sym_preproc_ifdef] = STATE(66),
    [sym_function_definition] = STATE(66),
    [sym_declaration] = STATE(66),
    [sym_type_definition] = STATE(66),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4602),
    [sym_linkage_specification] = STATE(66),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1850),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6058),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(66),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2750),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(66),
    [sym_labeled_statement] = STATE(66),
    [sym_expression_statement] = STATE(66),
    [sym_if_statement] = STATE(66),
    [sym_switch_statement] = STATE(66),
    [sym_case_statement] = STATE(66),
    [sym_while_statement] = STATE(66),
    [sym_do_statement] = STATE(66),
    [sym_for_statement] = STATE(66),
    [sym_return_statement] = STATE(66),
    [sym_break_statement] = STATE(66),
    [sym_continue_statement] = STATE(66),
    [sym_goto_statement] = STATE(66),
    [sym_seh_try_statement] = STATE(66),
    [sym_seh_leave_statement] = STATE(66),
    [sym__expression] = STATE(4455),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(7649),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(66),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1866),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(66),
    [sym_template_instantiation] = STATE(66),
    [sym_operator_cast] = STATE(6517),
    [sym__constructor_specifiers] = STATE(1866),
    [sym_operator_cast_definition] = STATE(66),
    [sym_operator_cast_declaration] = STATE(66),
    [sym_constructor_or_destructor_definition] = STATE(66),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(66),
    [sym_namespace_alias_definition] = STATE(66),
    [sym_using_declaration] = STATE(66),
    [sym_alias_declaration] = STATE(66),
    [sym_static_assert_declaration] = STATE(66),
    [sym_concept_definition] = STATE(66),
    [sym_for_range_loop] = STATE(66),
    [sym_co_return_statement] = STATE(66),
    [sym_co_yield_statement] = STATE(66),
    [sym_throw_statement] = STATE(66),
    [sym_try_statement] = STATE(66),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6517),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(66),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(173),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1866),
    [sym_identifier] = ACTIONS(853),
    [aux_sym_preproc_include_token1] = ACTIONS(856),
    [aux_sym_preproc_def_token1] = ACTIONS(859),
    [aux_sym_preproc_if_token1] = ACTIONS(862),
    [aux_sym_preproc_if_token2] = ACTIONS(385),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(865),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(865),
    [sym_preproc_directive] = ACTIONS(868),
    [anon_sym_LPAREN2] = ACTIONS(393),
    [anon_sym_BANG] = ACTIONS(396),
    [anon_sym_TILDE] = ACTIONS(399),
    [anon_sym_DASH] = ACTIONS(402),
    [anon_sym_PLUS] = ACTIONS(402),
    [anon_sym_STAR] = ACTIONS(405),
    [anon_sym_AMP_AMP] = ACTIONS(408),
    [anon_sym_AMP] = ACTIONS(411),
    [anon_sym_SEMI] = ACTIONS(871),
    [anon_sym___extension__] = ACTIONS(874),
    [anon_sym_typedef] = ACTIONS(877),
    [anon_sym_extern] = ACTIONS(880),
    [anon_sym___attribute__] = ACTIONS(426),
    [anon_sym_COLON_COLON] = ACTIONS(429),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(432),
    [anon_sym___declspec] = ACTIONS(435),
    [anon_sym___based] = ACTIONS(438),
    [anon_sym___cdecl] = ACTIONS(441),
    [anon_sym___clrcall] = ACTIONS(441),
    [anon_sym___stdcall] = ACTIONS(441),
    [anon_sym___fastcall] = ACTIONS(441),
    [anon_sym___thiscall] = ACTIONS(441),
    [anon_sym___vectorcall] = ACTIONS(441),
    [anon_sym_LBRACE] = ACTIONS(883),
    [anon_sym_signed] = ACTIONS(447),
    [anon_sym_unsigned] = ACTIONS(447),
    [anon_sym_long] = ACTIONS(447),
    [anon_sym_short] = ACTIONS(447),
    [anon_sym_LBRACK] = ACTIONS(450),
    [anon_sym_static] = ACTIONS(453),
    [anon_sym_register] = ACTIONS(453),
    [anon_sym_inline] = ACTIONS(886),
    [anon_sym___inline] = ACTIONS(453),
    [anon_sym___inline__] = ACTIONS(453),
    [anon_sym___forceinline] = ACTIONS(453),
    [anon_sym_thread_local] = ACTIONS(453),
    [anon_sym___thread] = ACTIONS(453),
    [anon_sym_const] = ACTIONS(459),
    [anon_sym_constexpr] = ACTIONS(459),
    [anon_sym_volatile] = ACTIONS(459),
    [anon_sym_restrict] = ACTIONS(459),
    [anon_sym___restrict__] = ACTIONS(459),
    [anon_sym__Atomic] = ACTIONS(459),
    [anon_sym__Noreturn] = ACTIONS(459),
    [anon_sym_noreturn] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(459),
    [anon_sym_constinit] = ACTIONS(459),
    [anon_sym_consteval] = ACTIONS(459),
    [anon_sym_PROGMEM] = ACTIONS(459),
    [aux_sym_primitive_type_token1] = ACTIONS(462),
    [anon_sym_byte] = ACTIONS(462),
    [anon_sym_word] = ACTIONS(462),
    [anon_sym_enum] = ACTIONS(465),
    [anon_sym_class] = ACTIONS(468),
    [anon_sym_struct] = ACTIONS(471),
    [anon_sym_union] = ACTIONS(474),
    [anon_sym_if] = ACTIONS(889),
    [anon_sym_switch] = ACTIONS(892),
    [anon_sym_case] = ACTIONS(895),
    [anon_sym_default] = ACTIONS(898),
    [anon_sym_while] = ACTIONS(901),
    [anon_sym_do] = ACTIONS(904),
    [anon_sym_for] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(910),
    [anon_sym_break] = ACTIONS(913),
    [anon_sym_continue] = ACTIONS(916),
    [anon_sym_goto] = ACTIONS(919),
    [anon_sym___try] = ACTIONS(922),
    [anon_sym___leave] = ACTIONS(925),
    [anon_sym_not] = ACTIONS(402),
    [anon_sym_compl] = ACTIONS(402),
    [anon_sym_DASH_DASH] = ACTIONS(516),
    [anon_sym_PLUS_PLUS] = ACTIONS(516),
    [anon_sym_sizeof] = ACTIONS(519),
    [anon_sym___alignof__] = ACTIONS(522),
    [anon_sym___alignof] = ACTIONS(522),
    [anon_sym__alignof] = ACTIONS(522),
    [anon_sym_alignof] = ACTIONS(522),
    [anon_sym__Alignof] = ACTIONS(522),
    [anon_sym_offsetof] = ACTIONS(525),
    [anon_sym__Generic] = ACTIONS(528),
    [anon_sym_asm] = ACTIONS(531),
    [anon_sym___asm__] = ACTIONS(531),
    [aux_sym_number_literal_token1] = ACTIONS(534),
    [aux_sym_number_literal_token2] = ACTIONS(537),
    [anon_sym_L_SQUOTE] = ACTIONS(540),
    [anon_sym_u_SQUOTE] = ACTIONS(540),
    [anon_sym_U_SQUOTE] = ACTIONS(540),
    [anon_sym_u8_SQUOTE] = ACTIONS(540),
    [anon_sym_SQUOTE] = ACTIONS(540),
    [anon_sym_L_DQUOTE] = ACTIONS(543),
    [anon_sym_u_DQUOTE] = ACTIONS(543),
    [anon_sym_U_DQUOTE] = ACTIONS(543),
    [anon_sym_u8_DQUOTE] = ACTIONS(543),
    [anon_sym_DQUOTE] = ACTIONS(543),
    [sym_true] = ACTIONS(546),
    [sym_false] = ACTIONS(546),
    [anon_sym_NULL] = ACTIONS(549),
    [anon_sym_nullptr] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(552),
    [anon_sym_decltype] = ACTIONS(555),
    [anon_sym_virtual] = ACTIONS(558),
    [anon_sym_alignas] = ACTIONS(561),
    [anon_sym_explicit] = ACTIONS(564),
    [anon_sym_typename] = ACTIONS(567),
    [anon_sym_template] = ACTIONS(928),
    [anon_sym_operator] = ACTIONS(573),
    [anon_sym_try] = ACTIONS(931),
    [anon_sym_delete] = ACTIONS(579),
    [anon_sym_throw] = ACTIONS(934),
    [anon_sym_namespace] = ACTIONS(937),
    [anon_sym_using] = ACTIONS(940),
    [anon_sym_static_assert] = ACTIONS(943),
    [anon_sym_concept] = ACTIONS(946),
    [anon_sym_co_return] = ACTIONS(949),
    [anon_sym_co_yield] = ACTIONS(952),
    [anon_sym_R_DQUOTE] = ACTIONS(603),
    [anon_sym_LR_DQUOTE] = ACTIONS(603),
    [anon_sym_uR_DQUOTE] = ACTIONS(603),
    [anon_sym_UR_DQUOTE] = ACTIONS(603),
    [anon_sym_u8R_DQUOTE] = ACTIONS(603),
    [anon_sym_co_await] = ACTIONS(606),
    [anon_sym_new] = ACTIONS(609),
    [anon_sym_requires] = ACTIONS(612),
    [sym_this] = ACTIONS(546),
  },
  [67] = {
    [sym_preproc_include] = STATE(66),
    [sym_preproc_def] = STATE(66),
    [sym_preproc_function_def] = STATE(66),
    [sym_preproc_call] = STATE(66),
    [sym_preproc_if] = STATE(66),
    [sym_preproc_ifdef] = STATE(66),
    [sym_function_definition] = STATE(66),
    [sym_declaration] = STATE(66),
    [sym_type_definition] = STATE(66),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4602),
    [sym_linkage_specification] = STATE(66),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1850),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6058),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(66),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2750),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(66),
    [sym_labeled_statement] = STATE(66),
    [sym_expression_statement] = STATE(66),
    [sym_if_statement] = STATE(66),
    [sym_switch_statement] = STATE(66),
    [sym_case_statement] = STATE(66),
    [sym_while_statement] = STATE(66),
    [sym_do_statement] = STATE(66),
    [sym_for_statement] = STATE(66),
    [sym_return_statement] = STATE(66),
    [sym_break_statement] = STATE(66),
    [sym_continue_statement] = STATE(66),
    [sym_goto_statement] = STATE(66),
    [sym_seh_try_statement] = STATE(66),
    [sym_seh_leave_statement] = STATE(66),
    [sym__expression] = STATE(4455),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(7649),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(66),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1866),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(66),
    [sym_template_instantiation] = STATE(66),
    [sym_operator_cast] = STATE(6517),
    [sym__constructor_specifiers] = STATE(1866),
    [sym_operator_cast_definition] = STATE(66),
    [sym_operator_cast_declaration] = STATE(66),
    [sym_constructor_or_destructor_definition] = STATE(66),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(66),
    [sym_namespace_alias_definition] = STATE(66),
    [sym_using_declaration] = STATE(66),
    [sym_alias_declaration] = STATE(66),
    [sym_static_assert_declaration] = STATE(66),
    [sym_concept_definition] = STATE(66),
    [sym_for_range_loop] = STATE(66),
    [sym_co_return_statement] = STATE(66),
    [sym_co_yield_statement] = STATE(66),
    [sym_throw_statement] = STATE(66),
    [sym_try_statement] = STATE(66),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6517),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(66),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(173),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1866),
    [sym_identifier] = ACTIONS(653),
    [aux_sym_preproc_include_token1] = ACTIONS(655),
    [aux_sym_preproc_def_token1] = ACTIONS(657),
    [aux_sym_preproc_if_token1] = ACTIONS(659),
    [aux_sym_preproc_if_token2] = ACTIONS(955),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(663),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(663),
    [sym_preproc_directive] = ACTIONS(665),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym___extension__] = ACTIONS(669),
    [anon_sym_typedef] = ACTIONS(671),
    [anon_sym_extern] = ACTIONS(673),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(675),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(677),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(679),
    [anon_sym_switch] = ACTIONS(681),
    [anon_sym_case] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_while] = ACTIONS(687),
    [anon_sym_do] = ACTIONS(689),
    [anon_sym_for] = ACTIONS(691),
    [anon_sym_return] = ACTIONS(693),
    [anon_sym_break] = ACTIONS(695),
    [anon_sym_continue] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym___try] = ACTIONS(701),
    [anon_sym___leave] = ACTIONS(703),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(705),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(707),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(709),
    [anon_sym_namespace] = ACTIONS(711),
    [anon_sym_using] = ACTIONS(713),
    [anon_sym_static_assert] = ACTIONS(715),
    [anon_sym_concept] = ACTIONS(717),
    [anon_sym_co_return] = ACTIONS(719),
    [anon_sym_co_yield] = ACTIONS(721),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [68] = {
    [sym_preproc_include] = STATE(54),
    [sym_preproc_def] = STATE(54),
    [sym_preproc_function_def] = STATE(54),
    [sym_preproc_call] = STATE(54),
    [sym_preproc_if] = STATE(54),
    [sym_preproc_ifdef] = STATE(54),
    [sym_function_definition] = STATE(54),
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4541),
    [sym_linkage_specification] = STATE(54),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6129),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(54),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2759),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(54),
    [sym_labeled_statement] = STATE(54),
    [sym_expression_statement] = STATE(54),
    [sym_if_statement] = STATE(54),
    [sym_switch_statement] = STATE(54),
    [sym_case_statement] = STATE(54),
    [sym_while_statement] = STATE(54),
    [sym_do_statement] = STATE(54),
    [sym_for_statement] = STATE(54),
    [sym_return_statement] = STATE(54),
    [sym_break_statement] = STATE(54),
    [sym_continue_statement] = STATE(54),
    [sym_goto_statement] = STATE(54),
    [sym_seh_try_statement] = STATE(54),
    [sym_seh_leave_statement] = STATE(54),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(54),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1888),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(54),
    [sym_template_instantiation] = STATE(54),
    [sym_operator_cast] = STATE(6505),
    [sym__constructor_specifiers] = STATE(1888),
    [sym_operator_cast_definition] = STATE(54),
    [sym_operator_cast_declaration] = STATE(54),
    [sym_constructor_or_destructor_definition] = STATE(54),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(54),
    [sym_namespace_alias_definition] = STATE(54),
    [sym_using_declaration] = STATE(54),
    [sym_alias_declaration] = STATE(54),
    [sym_static_assert_declaration] = STATE(54),
    [sym_concept_definition] = STATE(54),
    [sym_for_range_loop] = STATE(54),
    [sym_co_return_statement] = STATE(54),
    [sym_co_yield_statement] = STATE(54),
    [sym_throw_statement] = STATE(54),
    [sym_try_statement] = STATE(54),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6505),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(54),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1888),
    [sym_identifier] = ACTIONS(615),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(957),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [69] = {
    [sym_preproc_include] = STATE(54),
    [sym_preproc_def] = STATE(54),
    [sym_preproc_function_def] = STATE(54),
    [sym_preproc_call] = STATE(54),
    [sym_preproc_if] = STATE(54),
    [sym_preproc_ifdef] = STATE(54),
    [sym_function_definition] = STATE(54),
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4541),
    [sym_linkage_specification] = STATE(54),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6129),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(54),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2759),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(54),
    [sym_labeled_statement] = STATE(54),
    [sym_expression_statement] = STATE(54),
    [sym_if_statement] = STATE(54),
    [sym_switch_statement] = STATE(54),
    [sym_case_statement] = STATE(54),
    [sym_while_statement] = STATE(54),
    [sym_do_statement] = STATE(54),
    [sym_for_statement] = STATE(54),
    [sym_return_statement] = STATE(54),
    [sym_break_statement] = STATE(54),
    [sym_continue_statement] = STATE(54),
    [sym_goto_statement] = STATE(54),
    [sym_seh_try_statement] = STATE(54),
    [sym_seh_leave_statement] = STATE(54),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(54),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1888),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(54),
    [sym_template_instantiation] = STATE(54),
    [sym_operator_cast] = STATE(6505),
    [sym__constructor_specifiers] = STATE(1888),
    [sym_operator_cast_definition] = STATE(54),
    [sym_operator_cast_declaration] = STATE(54),
    [sym_constructor_or_destructor_definition] = STATE(54),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(54),
    [sym_namespace_alias_definition] = STATE(54),
    [sym_using_declaration] = STATE(54),
    [sym_alias_declaration] = STATE(54),
    [sym_static_assert_declaration] = STATE(54),
    [sym_concept_definition] = STATE(54),
    [sym_for_range_loop] = STATE(54),
    [sym_co_return_statement] = STATE(54),
    [sym_co_yield_statement] = STATE(54),
    [sym_throw_statement] = STATE(54),
    [sym_try_statement] = STATE(54),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6505),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(54),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1888),
    [sym_identifier] = ACTIONS(615),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(959),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [70] = {
    [sym_preproc_include] = STATE(54),
    [sym_preproc_def] = STATE(54),
    [sym_preproc_function_def] = STATE(54),
    [sym_preproc_call] = STATE(54),
    [sym_preproc_if] = STATE(54),
    [sym_preproc_ifdef] = STATE(54),
    [sym_function_definition] = STATE(54),
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4541),
    [sym_linkage_specification] = STATE(54),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6129),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(54),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2759),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(54),
    [sym_labeled_statement] = STATE(54),
    [sym_expression_statement] = STATE(54),
    [sym_if_statement] = STATE(54),
    [sym_switch_statement] = STATE(54),
    [sym_case_statement] = STATE(54),
    [sym_while_statement] = STATE(54),
    [sym_do_statement] = STATE(54),
    [sym_for_statement] = STATE(54),
    [sym_return_statement] = STATE(54),
    [sym_break_statement] = STATE(54),
    [sym_continue_statement] = STATE(54),
    [sym_goto_statement] = STATE(54),
    [sym_seh_try_statement] = STATE(54),
    [sym_seh_leave_statement] = STATE(54),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(54),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1888),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(54),
    [sym_template_instantiation] = STATE(54),
    [sym_operator_cast] = STATE(6505),
    [sym__constructor_specifiers] = STATE(1888),
    [sym_operator_cast_definition] = STATE(54),
    [sym_operator_cast_declaration] = STATE(54),
    [sym_constructor_or_destructor_definition] = STATE(54),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(54),
    [sym_namespace_alias_definition] = STATE(54),
    [sym_using_declaration] = STATE(54),
    [sym_alias_declaration] = STATE(54),
    [sym_static_assert_declaration] = STATE(54),
    [sym_concept_definition] = STATE(54),
    [sym_for_range_loop] = STATE(54),
    [sym_co_return_statement] = STATE(54),
    [sym_co_yield_statement] = STATE(54),
    [sym_throw_statement] = STATE(54),
    [sym_try_statement] = STATE(54),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6505),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(54),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1888),
    [sym_identifier] = ACTIONS(615),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(961),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [71] = {
    [sym_preproc_include] = STATE(78),
    [sym_preproc_def] = STATE(78),
    [sym_preproc_function_def] = STATE(78),
    [sym_preproc_call] = STATE(78),
    [sym_preproc_if] = STATE(78),
    [sym_preproc_ifdef] = STATE(78),
    [sym_function_definition] = STATE(78),
    [sym_declaration] = STATE(78),
    [sym_type_definition] = STATE(78),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4541),
    [sym_linkage_specification] = STATE(78),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6129),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(78),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2759),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(78),
    [sym_labeled_statement] = STATE(78),
    [sym_expression_statement] = STATE(78),
    [sym_if_statement] = STATE(78),
    [sym_switch_statement] = STATE(78),
    [sym_case_statement] = STATE(78),
    [sym_while_statement] = STATE(78),
    [sym_do_statement] = STATE(78),
    [sym_for_statement] = STATE(78),
    [sym_return_statement] = STATE(78),
    [sym_break_statement] = STATE(78),
    [sym_continue_statement] = STATE(78),
    [sym_goto_statement] = STATE(78),
    [sym_seh_try_statement] = STATE(78),
    [sym_seh_leave_statement] = STATE(78),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(78),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1888),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(78),
    [sym_template_instantiation] = STATE(78),
    [sym_operator_cast] = STATE(6505),
    [sym__constructor_specifiers] = STATE(1888),
    [sym_operator_cast_definition] = STATE(78),
    [sym_operator_cast_declaration] = STATE(78),
    [sym_constructor_or_destructor_definition] = STATE(78),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(78),
    [sym_namespace_alias_definition] = STATE(78),
    [sym_using_declaration] = STATE(78),
    [sym_alias_declaration] = STATE(78),
    [sym_static_assert_declaration] = STATE(78),
    [sym_concept_definition] = STATE(78),
    [sym_for_range_loop] = STATE(78),
    [sym_co_return_statement] = STATE(78),
    [sym_co_yield_statement] = STATE(78),
    [sym_throw_statement] = STATE(78),
    [sym_try_statement] = STATE(78),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6505),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(78),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1888),
    [sym_identifier] = ACTIONS(615),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(963),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [72] = {
    [sym_preproc_include] = STATE(63),
    [sym_preproc_def] = STATE(63),
    [sym_preproc_function_def] = STATE(63),
    [sym_preproc_call] = STATE(63),
    [sym_preproc_if] = STATE(63),
    [sym_preproc_ifdef] = STATE(63),
    [sym_function_definition] = STATE(63),
    [sym_declaration] = STATE(63),
    [sym_type_definition] = STATE(63),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4541),
    [sym_linkage_specification] = STATE(63),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6129),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(63),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2759),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(63),
    [sym_labeled_statement] = STATE(63),
    [sym_expression_statement] = STATE(63),
    [sym_if_statement] = STATE(63),
    [sym_switch_statement] = STATE(63),
    [sym_case_statement] = STATE(63),
    [sym_while_statement] = STATE(63),
    [sym_do_statement] = STATE(63),
    [sym_for_statement] = STATE(63),
    [sym_return_statement] = STATE(63),
    [sym_break_statement] = STATE(63),
    [sym_continue_statement] = STATE(63),
    [sym_goto_statement] = STATE(63),
    [sym_seh_try_statement] = STATE(63),
    [sym_seh_leave_statement] = STATE(63),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(63),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1888),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(63),
    [sym_template_instantiation] = STATE(63),
    [sym_operator_cast] = STATE(6505),
    [sym__constructor_specifiers] = STATE(1888),
    [sym_operator_cast_definition] = STATE(63),
    [sym_operator_cast_declaration] = STATE(63),
    [sym_constructor_or_destructor_definition] = STATE(63),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(63),
    [sym_namespace_alias_definition] = STATE(63),
    [sym_using_declaration] = STATE(63),
    [sym_alias_declaration] = STATE(63),
    [sym_static_assert_declaration] = STATE(63),
    [sym_concept_definition] = STATE(63),
    [sym_for_range_loop] = STATE(63),
    [sym_co_return_statement] = STATE(63),
    [sym_co_yield_statement] = STATE(63),
    [sym_throw_statement] = STATE(63),
    [sym_try_statement] = STATE(63),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6505),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(63),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1888),
    [sym_identifier] = ACTIONS(615),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(965),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [73] = {
    [sym_preproc_include] = STATE(58),
    [sym_preproc_def] = STATE(58),
    [sym_preproc_function_def] = STATE(58),
    [sym_preproc_call] = STATE(58),
    [sym_preproc_if] = STATE(58),
    [sym_preproc_ifdef] = STATE(58),
    [sym_function_definition] = STATE(58),
    [sym_declaration] = STATE(58),
    [sym_type_definition] = STATE(58),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4541),
    [sym_linkage_specification] = STATE(58),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6129),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(58),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2759),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(58),
    [sym_labeled_statement] = STATE(58),
    [sym_expression_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_case_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_return_statement] = STATE(58),
    [sym_break_statement] = STATE(58),
    [sym_continue_statement] = STATE(58),
    [sym_goto_statement] = STATE(58),
    [sym_seh_try_statement] = STATE(58),
    [sym_seh_leave_statement] = STATE(58),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(58),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1888),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(58),
    [sym_template_instantiation] = STATE(58),
    [sym_operator_cast] = STATE(6505),
    [sym__constructor_specifiers] = STATE(1888),
    [sym_operator_cast_definition] = STATE(58),
    [sym_operator_cast_declaration] = STATE(58),
    [sym_constructor_or_destructor_definition] = STATE(58),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(58),
    [sym_namespace_alias_definition] = STATE(58),
    [sym_using_declaration] = STATE(58),
    [sym_alias_declaration] = STATE(58),
    [sym_static_assert_declaration] = STATE(58),
    [sym_concept_definition] = STATE(58),
    [sym_for_range_loop] = STATE(58),
    [sym_co_return_statement] = STATE(58),
    [sym_co_yield_statement] = STATE(58),
    [sym_throw_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6505),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(58),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1888),
    [sym_identifier] = ACTIONS(615),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(967),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [74] = {
    [sym_preproc_include] = STATE(56),
    [sym_preproc_def] = STATE(56),
    [sym_preproc_function_def] = STATE(56),
    [sym_preproc_call] = STATE(56),
    [sym_preproc_if] = STATE(56),
    [sym_preproc_ifdef] = STATE(56),
    [sym_function_definition] = STATE(56),
    [sym_declaration] = STATE(56),
    [sym_type_definition] = STATE(56),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4541),
    [sym_linkage_specification] = STATE(56),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6129),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(56),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2759),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(56),
    [sym_labeled_statement] = STATE(56),
    [sym_expression_statement] = STATE(56),
    [sym_if_statement] = STATE(56),
    [sym_switch_statement] = STATE(56),
    [sym_case_statement] = STATE(56),
    [sym_while_statement] = STATE(56),
    [sym_do_statement] = STATE(56),
    [sym_for_statement] = STATE(56),
    [sym_return_statement] = STATE(56),
    [sym_break_statement] = STATE(56),
    [sym_continue_statement] = STATE(56),
    [sym_goto_statement] = STATE(56),
    [sym_seh_try_statement] = STATE(56),
    [sym_seh_leave_statement] = STATE(56),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(56),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1888),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(56),
    [sym_template_instantiation] = STATE(56),
    [sym_operator_cast] = STATE(6505),
    [sym__constructor_specifiers] = STATE(1888),
    [sym_operator_cast_definition] = STATE(56),
    [sym_operator_cast_declaration] = STATE(56),
    [sym_constructor_or_destructor_definition] = STATE(56),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(56),
    [sym_namespace_alias_definition] = STATE(56),
    [sym_using_declaration] = STATE(56),
    [sym_alias_declaration] = STATE(56),
    [sym_static_assert_declaration] = STATE(56),
    [sym_concept_definition] = STATE(56),
    [sym_for_range_loop] = STATE(56),
    [sym_co_return_statement] = STATE(56),
    [sym_co_yield_statement] = STATE(56),
    [sym_throw_statement] = STATE(56),
    [sym_try_statement] = STATE(56),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6505),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(56),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1888),
    [sym_identifier] = ACTIONS(615),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(969),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [75] = {
    [sym_preproc_include] = STATE(47),
    [sym_preproc_def] = STATE(47),
    [sym_preproc_function_def] = STATE(47),
    [sym_preproc_call] = STATE(47),
    [sym_preproc_if] = STATE(47),
    [sym_preproc_ifdef] = STATE(47),
    [sym_function_definition] = STATE(47),
    [sym_declaration] = STATE(47),
    [sym_type_definition] = STATE(47),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4541),
    [sym_linkage_specification] = STATE(47),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6129),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(47),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2759),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(47),
    [sym_labeled_statement] = STATE(47),
    [sym_expression_statement] = STATE(47),
    [sym_if_statement] = STATE(47),
    [sym_switch_statement] = STATE(47),
    [sym_case_statement] = STATE(47),
    [sym_while_statement] = STATE(47),
    [sym_do_statement] = STATE(47),
    [sym_for_statement] = STATE(47),
    [sym_return_statement] = STATE(47),
    [sym_break_statement] = STATE(47),
    [sym_continue_statement] = STATE(47),
    [sym_goto_statement] = STATE(47),
    [sym_seh_try_statement] = STATE(47),
    [sym_seh_leave_statement] = STATE(47),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(47),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1888),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(47),
    [sym_template_instantiation] = STATE(47),
    [sym_operator_cast] = STATE(6505),
    [sym__constructor_specifiers] = STATE(1888),
    [sym_operator_cast_definition] = STATE(47),
    [sym_operator_cast_declaration] = STATE(47),
    [sym_constructor_or_destructor_definition] = STATE(47),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(47),
    [sym_namespace_alias_definition] = STATE(47),
    [sym_using_declaration] = STATE(47),
    [sym_alias_declaration] = STATE(47),
    [sym_static_assert_declaration] = STATE(47),
    [sym_concept_definition] = STATE(47),
    [sym_for_range_loop] = STATE(47),
    [sym_co_return_statement] = STATE(47),
    [sym_co_yield_statement] = STATE(47),
    [sym_throw_statement] = STATE(47),
    [sym_try_statement] = STATE(47),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6505),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(47),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1888),
    [sym_identifier] = ACTIONS(615),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(971),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [76] = {
    [sym_preproc_include] = STATE(54),
    [sym_preproc_def] = STATE(54),
    [sym_preproc_function_def] = STATE(54),
    [sym_preproc_call] = STATE(54),
    [sym_preproc_if] = STATE(54),
    [sym_preproc_ifdef] = STATE(54),
    [sym_function_definition] = STATE(54),
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4541),
    [sym_linkage_specification] = STATE(54),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6129),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(54),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2759),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(54),
    [sym_labeled_statement] = STATE(54),
    [sym_expression_statement] = STATE(54),
    [sym_if_statement] = STATE(54),
    [sym_switch_statement] = STATE(54),
    [sym_case_statement] = STATE(54),
    [sym_while_statement] = STATE(54),
    [sym_do_statement] = STATE(54),
    [sym_for_statement] = STATE(54),
    [sym_return_statement] = STATE(54),
    [sym_break_statement] = STATE(54),
    [sym_continue_statement] = STATE(54),
    [sym_goto_statement] = STATE(54),
    [sym_seh_try_statement] = STATE(54),
    [sym_seh_leave_statement] = STATE(54),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(54),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1888),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(54),
    [sym_template_instantiation] = STATE(54),
    [sym_operator_cast] = STATE(6505),
    [sym__constructor_specifiers] = STATE(1888),
    [sym_operator_cast_definition] = STATE(54),
    [sym_operator_cast_declaration] = STATE(54),
    [sym_constructor_or_destructor_definition] = STATE(54),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(54),
    [sym_namespace_alias_definition] = STATE(54),
    [sym_using_declaration] = STATE(54),
    [sym_alias_declaration] = STATE(54),
    [sym_static_assert_declaration] = STATE(54),
    [sym_concept_definition] = STATE(54),
    [sym_for_range_loop] = STATE(54),
    [sym_co_return_statement] = STATE(54),
    [sym_co_yield_statement] = STATE(54),
    [sym_throw_statement] = STATE(54),
    [sym_try_statement] = STATE(54),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6505),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(54),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1888),
    [sym_identifier] = ACTIONS(615),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(973),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [77] = {
    [sym_preproc_include] = STATE(64),
    [sym_preproc_def] = STATE(64),
    [sym_preproc_function_def] = STATE(64),
    [sym_preproc_call] = STATE(64),
    [sym_preproc_if] = STATE(64),
    [sym_preproc_ifdef] = STATE(64),
    [sym_function_definition] = STATE(64),
    [sym_declaration] = STATE(64),
    [sym_type_definition] = STATE(64),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4541),
    [sym_linkage_specification] = STATE(64),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6129),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(64),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2759),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(64),
    [sym_labeled_statement] = STATE(64),
    [sym_expression_statement] = STATE(64),
    [sym_if_statement] = STATE(64),
    [sym_switch_statement] = STATE(64),
    [sym_case_statement] = STATE(64),
    [sym_while_statement] = STATE(64),
    [sym_do_statement] = STATE(64),
    [sym_for_statement] = STATE(64),
    [sym_return_statement] = STATE(64),
    [sym_break_statement] = STATE(64),
    [sym_continue_statement] = STATE(64),
    [sym_goto_statement] = STATE(64),
    [sym_seh_try_statement] = STATE(64),
    [sym_seh_leave_statement] = STATE(64),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(64),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1888),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(64),
    [sym_template_instantiation] = STATE(64),
    [sym_operator_cast] = STATE(6505),
    [sym__constructor_specifiers] = STATE(1888),
    [sym_operator_cast_definition] = STATE(64),
    [sym_operator_cast_declaration] = STATE(64),
    [sym_constructor_or_destructor_definition] = STATE(64),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(64),
    [sym_namespace_alias_definition] = STATE(64),
    [sym_using_declaration] = STATE(64),
    [sym_alias_declaration] = STATE(64),
    [sym_static_assert_declaration] = STATE(64),
    [sym_concept_definition] = STATE(64),
    [sym_for_range_loop] = STATE(64),
    [sym_co_return_statement] = STATE(64),
    [sym_co_yield_statement] = STATE(64),
    [sym_throw_statement] = STATE(64),
    [sym_try_statement] = STATE(64),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6505),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(64),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1888),
    [sym_identifier] = ACTIONS(615),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(975),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [78] = {
    [sym_preproc_include] = STATE(54),
    [sym_preproc_def] = STATE(54),
    [sym_preproc_function_def] = STATE(54),
    [sym_preproc_call] = STATE(54),
    [sym_preproc_if] = STATE(54),
    [sym_preproc_ifdef] = STATE(54),
    [sym_function_definition] = STATE(54),
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4541),
    [sym_linkage_specification] = STATE(54),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6129),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(54),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2759),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(54),
    [sym_labeled_statement] = STATE(54),
    [sym_expression_statement] = STATE(54),
    [sym_if_statement] = STATE(54),
    [sym_switch_statement] = STATE(54),
    [sym_case_statement] = STATE(54),
    [sym_while_statement] = STATE(54),
    [sym_do_statement] = STATE(54),
    [sym_for_statement] = STATE(54),
    [sym_return_statement] = STATE(54),
    [sym_break_statement] = STATE(54),
    [sym_continue_statement] = STATE(54),
    [sym_goto_statement] = STATE(54),
    [sym_seh_try_statement] = STATE(54),
    [sym_seh_leave_statement] = STATE(54),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(54),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1888),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(54),
    [sym_template_instantiation] = STATE(54),
    [sym_operator_cast] = STATE(6505),
    [sym__constructor_specifiers] = STATE(1888),
    [sym_operator_cast_definition] = STATE(54),
    [sym_operator_cast_declaration] = STATE(54),
    [sym_constructor_or_destructor_definition] = STATE(54),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(54),
    [sym_namespace_alias_definition] = STATE(54),
    [sym_using_declaration] = STATE(54),
    [sym_alias_declaration] = STATE(54),
    [sym_static_assert_declaration] = STATE(54),
    [sym_concept_definition] = STATE(54),
    [sym_for_range_loop] = STATE(54),
    [sym_co_return_statement] = STATE(54),
    [sym_co_yield_statement] = STATE(54),
    [sym_throw_statement] = STATE(54),
    [sym_try_statement] = STATE(54),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6505),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(54),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1888),
    [sym_identifier] = ACTIONS(615),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(977),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [79] = {
    [sym_preproc_include] = STATE(68),
    [sym_preproc_def] = STATE(68),
    [sym_preproc_function_def] = STATE(68),
    [sym_preproc_call] = STATE(68),
    [sym_preproc_if] = STATE(68),
    [sym_preproc_ifdef] = STATE(68),
    [sym_function_definition] = STATE(68),
    [sym_declaration] = STATE(68),
    [sym_type_definition] = STATE(68),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4541),
    [sym_linkage_specification] = STATE(68),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6129),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(68),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2759),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(68),
    [sym_labeled_statement] = STATE(68),
    [sym_expression_statement] = STATE(68),
    [sym_if_statement] = STATE(68),
    [sym_switch_statement] = STATE(68),
    [sym_case_statement] = STATE(68),
    [sym_while_statement] = STATE(68),
    [sym_do_statement] = STATE(68),
    [sym_for_statement] = STATE(68),
    [sym_return_statement] = STATE(68),
    [sym_break_statement] = STATE(68),
    [sym_continue_statement] = STATE(68),
    [sym_goto_statement] = STATE(68),
    [sym_seh_try_statement] = STATE(68),
    [sym_seh_leave_statement] = STATE(68),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym__empty_declaration] = STATE(68),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1888),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(68),
    [sym_template_instantiation] = STATE(68),
    [sym_operator_cast] = STATE(6505),
    [sym__constructor_specifiers] = STATE(1888),
    [sym_operator_cast_definition] = STATE(68),
    [sym_operator_cast_declaration] = STATE(68),
    [sym_constructor_or_destructor_definition] = STATE(68),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(68),
    [sym_namespace_alias_definition] = STATE(68),
    [sym_using_declaration] = STATE(68),
    [sym_alias_declaration] = STATE(68),
    [sym_static_assert_declaration] = STATE(68),
    [sym_concept_definition] = STATE(68),
    [sym_for_range_loop] = STATE(68),
    [sym_co_return_statement] = STATE(68),
    [sym_co_yield_statement] = STATE(68),
    [sym_throw_statement] = STATE(68),
    [sym_try_statement] = STATE(68),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6505),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_preproc_if_repeat1] = STATE(68),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1888),
    [sym_identifier] = ACTIONS(615),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(979),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(221),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_using] = ACTIONS(229),
    [anon_sym_static_assert] = ACTIONS(231),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [80] = {
    [sym_preproc_include] = STATE(81),
    [sym_preproc_def] = STATE(81),
    [sym_preproc_function_def] = STATE(81),
    [sym_preproc_call] = STATE(81),
    [sym_preproc_if] = STATE(81),
    [sym_preproc_ifdef] = STATE(81),
    [sym_function_definition] = STATE(81),
    [sym_declaration] = STATE(81),
    [sym_type_definition] = STATE(81),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4612),
    [sym_linkage_specification] = STATE(81),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1846),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6096),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(81),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2794),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(81),
    [sym_labeled_statement] = STATE(81),
    [sym__top_level_expression_statement] = STATE(81),
    [sym_if_statement] = STATE(81),
    [sym_switch_statement] = STATE(81),
    [sym_case_statement] = STATE(81),
    [sym_while_statement] = STATE(81),
    [sym_do_statement] = STATE(81),
    [sym_for_statement] = STATE(81),
    [sym_return_statement] = STATE(81),
    [sym_break_statement] = STATE(81),
    [sym_continue_statement] = STATE(81),
    [sym_goto_statement] = STATE(81),
    [sym__expression] = STATE(4665),
    [sym__expression_not_binary] = STATE(4774),
    [sym__string] = STATE(4774),
    [sym_conditional_expression] = STATE(4774),
    [sym_assignment_expression] = STATE(4774),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(4774),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(4774),
    [sym_cast_expression] = STATE(4774),
    [sym_sizeof_expression] = STATE(4774),
    [sym_alignof_expression] = STATE(4774),
    [sym_offsetof_expression] = STATE(4774),
    [sym_generic_expression] = STATE(4774),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(4774),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(4774),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(4774),
    [sym__empty_declaration] = STATE(81),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1887),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(81),
    [sym_template_instantiation] = STATE(81),
    [sym_operator_cast] = STATE(6513),
    [sym__constructor_specifiers] = STATE(1887),
    [sym_operator_cast_definition] = STATE(81),
    [sym_operator_cast_declaration] = STATE(81),
    [sym_constructor_or_destructor_definition] = STATE(81),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(81),
    [sym_namespace_alias_definition] = STATE(81),
    [sym_using_declaration] = STATE(81),
    [sym_alias_declaration] = STATE(81),
    [sym_static_assert_declaration] = STATE(81),
    [sym_concept_definition] = STATE(81),
    [sym_for_range_loop] = STATE(81),
    [sym_co_return_statement] = STATE(81),
    [sym_co_yield_statement] = STATE(81),
    [sym_throw_statement] = STATE(81),
    [sym_try_statement] = STATE(81),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(4774),
    [sym_new_expression] = STATE(4774),
    [sym_delete_expression] = STATE(4774),
    [sym_requires_clause] = STATE(4774),
    [sym_requires_expression] = STATE(4774),
    [sym_lambda_expression] = STATE(4774),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(4774),
    [sym_parameter_pack_expansion] = STATE(4774),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6513),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_translation_unit_repeat1] = STATE(81),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(172),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1887),
    [ts_builtin_sym_end] = ACTIONS(981),
    [sym_identifier] = ACTIONS(7),
    [aux_sym_preproc_include_token1] = ACTIONS(9),
    [aux_sym_preproc_def_token1] = ACTIONS(11),
    [aux_sym_preproc_if_token1] = ACTIONS(13),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(15),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(15),
    [sym_preproc_directive] = ACTIONS(17),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym___extension__] = ACTIONS(33),
    [anon_sym_typedef] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(37),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(43),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_case] = ACTIONS(77),
    [anon_sym_default] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_do] = ACTIONS(83),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_return] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_goto] = ACTIONS(93),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(115),
    [sym_false] = ACTIONS(115),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(131),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(141),
    [anon_sym_using] = ACTIONS(143),
    [anon_sym_static_assert] = ACTIONS(145),
    [anon_sym_concept] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(115),
  },
  [81] = {
    [sym_preproc_include] = STATE(81),
    [sym_preproc_def] = STATE(81),
    [sym_preproc_function_def] = STATE(81),
    [sym_preproc_call] = STATE(81),
    [sym_preproc_if] = STATE(81),
    [sym_preproc_ifdef] = STATE(81),
    [sym_function_definition] = STATE(81),
    [sym_declaration] = STATE(81),
    [sym_type_definition] = STATE(81),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4612),
    [sym_linkage_specification] = STATE(81),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(955),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1846),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6096),
    [sym_array_declarator] = STATE(6098),
    [sym_compound_statement] = STATE(81),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2794),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(81),
    [sym_labeled_statement] = STATE(81),
    [sym__top_level_expression_statement] = STATE(81),
    [sym_if_statement] = STATE(81),
    [sym_switch_statement] = STATE(81),
    [sym_case_statement] = STATE(81),
    [sym_while_statement] = STATE(81),
    [sym_do_statement] = STATE(81),
    [sym_for_statement] = STATE(81),
    [sym_return_statement] = STATE(81),
    [sym_break_statement] = STATE(81),
    [sym_continue_statement] = STATE(81),
    [sym_goto_statement] = STATE(81),
    [sym__expression] = STATE(4665),
    [sym__expression_not_binary] = STATE(4774),
    [sym__string] = STATE(4774),
    [sym_conditional_expression] = STATE(4774),
    [sym_assignment_expression] = STATE(4774),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(4774),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(4774),
    [sym_cast_expression] = STATE(4774),
    [sym_sizeof_expression] = STATE(4774),
    [sym_alignof_expression] = STATE(4774),
    [sym_offsetof_expression] = STATE(4774),
    [sym_generic_expression] = STATE(4774),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(4774),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(4774),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(4774),
    [sym__empty_declaration] = STATE(81),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1887),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(81),
    [sym_template_instantiation] = STATE(81),
    [sym_operator_cast] = STATE(6513),
    [sym__constructor_specifiers] = STATE(1887),
    [sym_operator_cast_definition] = STATE(81),
    [sym_operator_cast_declaration] = STATE(81),
    [sym_constructor_or_destructor_definition] = STATE(81),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(4477),
    [sym_namespace_definition] = STATE(81),
    [sym_namespace_alias_definition] = STATE(81),
    [sym_using_declaration] = STATE(81),
    [sym_alias_declaration] = STATE(81),
    [sym_static_assert_declaration] = STATE(81),
    [sym_concept_definition] = STATE(81),
    [sym_for_range_loop] = STATE(81),
    [sym_co_return_statement] = STATE(81),
    [sym_co_yield_statement] = STATE(81),
    [sym_throw_statement] = STATE(81),
    [sym_try_statement] = STATE(81),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(4774),
    [sym_new_expression] = STATE(4774),
    [sym_delete_expression] = STATE(4774),
    [sym_requires_clause] = STATE(4774),
    [sym_requires_expression] = STATE(4774),
    [sym_lambda_expression] = STATE(4774),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(4774),
    [sym_parameter_pack_expansion] = STATE(4774),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5322),
    [sym_qualified_identifier] = STATE(3208),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_qualified_operator_cast_identifier] = STATE(6513),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_translation_unit_repeat1] = STATE(81),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(172),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1887),
    [ts_builtin_sym_end] = ACTIONS(983),
    [sym_identifier] = ACTIONS(985),
    [aux_sym_preproc_include_token1] = ACTIONS(988),
    [aux_sym_preproc_def_token1] = ACTIONS(991),
    [aux_sym_preproc_if_token1] = ACTIONS(994),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(997),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(997),
    [sym_preproc_directive] = ACTIONS(1000),
    [anon_sym_LPAREN2] = ACTIONS(1003),
    [anon_sym_BANG] = ACTIONS(1006),
    [anon_sym_TILDE] = ACTIONS(1009),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_STAR] = ACTIONS(1015),
    [anon_sym_AMP_AMP] = ACTIONS(1018),
    [anon_sym_AMP] = ACTIONS(1021),
    [anon_sym___extension__] = ACTIONS(1024),
    [anon_sym_typedef] = ACTIONS(1027),
    [anon_sym_extern] = ACTIONS(1030),
    [anon_sym___attribute__] = ACTIONS(1033),
    [anon_sym_COLON_COLON] = ACTIONS(1036),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1039),
    [anon_sym___declspec] = ACTIONS(1042),
    [anon_sym___based] = ACTIONS(1045),
    [anon_sym___cdecl] = ACTIONS(1048),
    [anon_sym___clrcall] = ACTIONS(1048),
    [anon_sym___stdcall] = ACTIONS(1048),
    [anon_sym___fastcall] = ACTIONS(1048),
    [anon_sym___thiscall] = ACTIONS(1048),
    [anon_sym___vectorcall] = ACTIONS(1048),
    [anon_sym_LBRACE] = ACTIONS(1051),
    [anon_sym_signed] = ACTIONS(1054),
    [anon_sym_unsigned] = ACTIONS(1054),
    [anon_sym_long] = ACTIONS(1054),
    [anon_sym_short] = ACTIONS(1054),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_static] = ACTIONS(1060),
    [anon_sym_register] = ACTIONS(1060),
    [anon_sym_inline] = ACTIONS(1063),
    [anon_sym___inline] = ACTIONS(1060),
    [anon_sym___inline__] = ACTIONS(1060),
    [anon_sym___forceinline] = ACTIONS(1060),
    [anon_sym_thread_local] = ACTIONS(1060),
    [anon_sym___thread] = ACTIONS(1060),
    [anon_sym_const] = ACTIONS(1066),
    [anon_sym_constexpr] = ACTIONS(1066),
    [anon_sym_volatile] = ACTIONS(1066),
    [anon_sym_restrict] = ACTIONS(1066),
    [anon_sym___restrict__] = ACTIONS(1066),
    [anon_sym__Atomic] = ACTIONS(1066),
    [anon_sym__Noreturn] = ACTIONS(1066),
    [anon_sym_noreturn] = ACTIONS(1066),
    [anon_sym_mutable] = ACTIONS(1066),
    [anon_sym_constinit] = ACTIONS(1066),
    [anon_sym_consteval] = ACTIONS(1066),
    [anon_sym_PROGMEM] = ACTIONS(1066),
    [aux_sym_primitive_type_token1] = ACTIONS(1069),
    [anon_sym_byte] = ACTIONS(1069),
    [anon_sym_word] = ACTIONS(1069),
    [anon_sym_enum] = ACTIONS(1072),
    [anon_sym_class] = ACTIONS(1075),
    [anon_sym_struct] = ACTIONS(1078),
    [anon_sym_union] = ACTIONS(1081),
    [anon_sym_if] = ACTIONS(1084),
    [anon_sym_switch] = ACTIONS(1087),
    [anon_sym_case] = ACTIONS(1090),
    [anon_sym_default] = ACTIONS(1093),
    [anon_sym_while] = ACTIONS(1096),
    [anon_sym_do] = ACTIONS(1099),
    [anon_sym_for] = ACTIONS(1102),
    [anon_sym_return] = ACTIONS(1105),
    [anon_sym_break] = ACTIONS(1108),
    [anon_sym_continue] = ACTIONS(1111),
    [anon_sym_goto] = ACTIONS(1114),
    [anon_sym_not] = ACTIONS(1012),
    [anon_sym_compl] = ACTIONS(1012),
    [anon_sym_DASH_DASH] = ACTIONS(1117),
    [anon_sym_PLUS_PLUS] = ACTIONS(1117),
    [anon_sym_sizeof] = ACTIONS(1120),
    [anon_sym___alignof__] = ACTIONS(1123),
    [anon_sym___alignof] = ACTIONS(1123),
    [anon_sym__alignof] = ACTIONS(1123),
    [anon_sym_alignof] = ACTIONS(1123),
    [anon_sym__Alignof] = ACTIONS(1123),
    [anon_sym_offsetof] = ACTIONS(1126),
    [anon_sym__Generic] = ACTIONS(1129),
    [anon_sym_asm] = ACTIONS(1132),
    [anon_sym___asm__] = ACTIONS(1132),
    [aux_sym_number_literal_token1] = ACTIONS(1135),
    [aux_sym_number_literal_token2] = ACTIONS(1138),
    [anon_sym_L_SQUOTE] = ACTIONS(1141),
    [anon_sym_u_SQUOTE] = ACTIONS(1141),
    [anon_sym_U_SQUOTE] = ACTIONS(1141),
    [anon_sym_u8_SQUOTE] = ACTIONS(1141),
    [anon_sym_SQUOTE] = ACTIONS(1141),
    [anon_sym_L_DQUOTE] = ACTIONS(1144),
    [anon_sym_u_DQUOTE] = ACTIONS(1144),
    [anon_sym_U_DQUOTE] = ACTIONS(1144),
    [anon_sym_u8_DQUOTE] = ACTIONS(1144),
    [anon_sym_DQUOTE] = ACTIONS(1144),
    [sym_true] = ACTIONS(1147),
    [sym_false] = ACTIONS(1147),
    [anon_sym_NULL] = ACTIONS(1150),
    [anon_sym_nullptr] = ACTIONS(1150),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1153),
    [anon_sym_decltype] = ACTIONS(1156),
    [anon_sym_virtual] = ACTIONS(1159),
    [anon_sym_alignas] = ACTIONS(1162),
    [anon_sym_explicit] = ACTIONS(1165),
    [anon_sym_typename] = ACTIONS(1168),
    [anon_sym_template] = ACTIONS(1171),
    [anon_sym_operator] = ACTIONS(1174),
    [anon_sym_try] = ACTIONS(1177),
    [anon_sym_delete] = ACTIONS(1180),
    [anon_sym_throw] = ACTIONS(1183),
    [anon_sym_namespace] = ACTIONS(1186),
    [anon_sym_using] = ACTIONS(1189),
    [anon_sym_static_assert] = ACTIONS(1192),
    [anon_sym_concept] = ACTIONS(1195),
    [anon_sym_co_return] = ACTIONS(1198),
    [anon_sym_co_yield] = ACTIONS(1201),
    [anon_sym_R_DQUOTE] = ACTIONS(1204),
    [anon_sym_LR_DQUOTE] = ACTIONS(1204),
    [anon_sym_uR_DQUOTE] = ACTIONS(1204),
    [anon_sym_UR_DQUOTE] = ACTIONS(1204),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1204),
    [anon_sym_co_await] = ACTIONS(1207),
    [anon_sym_new] = ACTIONS(1210),
    [anon_sym_requires] = ACTIONS(1213),
    [sym_this] = ACTIONS(1147),
  },
  [82] = {
    [sym_declaration] = STATE(82),
    [sym_type_definition] = STATE(82),
    [sym__declaration_modifiers] = STATE(1964),
    [sym__declaration_specifiers] = STATE(5046),
    [sym_attribute_specifier] = STATE(1964),
    [sym_attribute_declaration] = STATE(973),
    [sym_ms_declspec_modifier] = STATE(1964),
    [sym_compound_statement] = STATE(82),
    [sym_storage_class_specifier] = STATE(1964),
    [sym_type_qualifier] = STATE(1964),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(82),
    [sym_labeled_statement] = STATE(82),
    [sym_expression_statement] = STATE(82),
    [sym_if_statement] = STATE(82),
    [sym_switch_statement] = STATE(82),
    [sym_while_statement] = STATE(82),
    [sym_do_statement] = STATE(82),
    [sym_for_statement] = STATE(82),
    [sym_return_statement] = STATE(82),
    [sym_break_statement] = STATE(82),
    [sym_continue_statement] = STATE(82),
    [sym_goto_statement] = STATE(82),
    [sym_seh_try_statement] = STATE(82),
    [sym_seh_leave_statement] = STATE(82),
    [sym__expression] = STATE(4420),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8126),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(1964),
    [sym_alignas_specifier] = STATE(1964),
    [sym_dependent_type] = STATE(2629),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(82),
    [sym_co_return_statement] = STATE(82),
    [sym_co_yield_statement] = STATE(82),
    [sym_throw_statement] = STATE(82),
    [sym_try_statement] = STATE(82),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5552),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(176),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_case_statement_repeat1] = STATE(82),
    [sym_identifier] = ACTIONS(1216),
    [aux_sym_preproc_include_token1] = ACTIONS(1219),
    [aux_sym_preproc_def_token1] = ACTIONS(1219),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_if_token2] = ACTIONS(1219),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1219),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1219),
    [aux_sym_preproc_else_token1] = ACTIONS(1219),
    [aux_sym_preproc_elif_token1] = ACTIONS(1219),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1219),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1219),
    [sym_preproc_directive] = ACTIONS(1219),
    [anon_sym_LPAREN2] = ACTIONS(1221),
    [anon_sym_BANG] = ACTIONS(1224),
    [anon_sym_TILDE] = ACTIONS(1224),
    [anon_sym_DASH] = ACTIONS(1227),
    [anon_sym_PLUS] = ACTIONS(1227),
    [anon_sym_STAR] = ACTIONS(1230),
    [anon_sym_AMP_AMP] = ACTIONS(1233),
    [anon_sym_AMP] = ACTIONS(1235),
    [anon_sym_SEMI] = ACTIONS(1238),
    [anon_sym___extension__] = ACTIONS(1241),
    [anon_sym_typedef] = ACTIONS(1244),
    [anon_sym_extern] = ACTIONS(1247),
    [anon_sym___attribute__] = ACTIONS(1250),
    [anon_sym_COLON_COLON] = ACTIONS(1253),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1256),
    [anon_sym___declspec] = ACTIONS(1259),
    [anon_sym___based] = ACTIONS(1219),
    [anon_sym___cdecl] = ACTIONS(1219),
    [anon_sym___clrcall] = ACTIONS(1219),
    [anon_sym___stdcall] = ACTIONS(1219),
    [anon_sym___fastcall] = ACTIONS(1219),
    [anon_sym___thiscall] = ACTIONS(1219),
    [anon_sym___vectorcall] = ACTIONS(1219),
    [anon_sym_LBRACE] = ACTIONS(1262),
    [anon_sym_signed] = ACTIONS(1265),
    [anon_sym_unsigned] = ACTIONS(1265),
    [anon_sym_long] = ACTIONS(1265),
    [anon_sym_short] = ACTIONS(1265),
    [anon_sym_LBRACK] = ACTIONS(1268),
    [anon_sym_static] = ACTIONS(1247),
    [anon_sym_register] = ACTIONS(1247),
    [anon_sym_inline] = ACTIONS(1247),
    [anon_sym___inline] = ACTIONS(1247),
    [anon_sym___inline__] = ACTIONS(1247),
    [anon_sym___forceinline] = ACTIONS(1247),
    [anon_sym_thread_local] = ACTIONS(1247),
    [anon_sym___thread] = ACTIONS(1247),
    [anon_sym_const] = ACTIONS(1271),
    [anon_sym_constexpr] = ACTIONS(1271),
    [anon_sym_volatile] = ACTIONS(1271),
    [anon_sym_restrict] = ACTIONS(1271),
    [anon_sym___restrict__] = ACTIONS(1271),
    [anon_sym__Atomic] = ACTIONS(1271),
    [anon_sym__Noreturn] = ACTIONS(1271),
    [anon_sym_noreturn] = ACTIONS(1271),
    [anon_sym_mutable] = ACTIONS(1271),
    [anon_sym_constinit] = ACTIONS(1271),
    [anon_sym_consteval] = ACTIONS(1271),
    [anon_sym_PROGMEM] = ACTIONS(1271),
    [aux_sym_primitive_type_token1] = ACTIONS(1274),
    [anon_sym_byte] = ACTIONS(1274),
    [anon_sym_word] = ACTIONS(1274),
    [anon_sym_enum] = ACTIONS(1277),
    [anon_sym_class] = ACTIONS(1280),
    [anon_sym_struct] = ACTIONS(1283),
    [anon_sym_union] = ACTIONS(1286),
    [anon_sym_if] = ACTIONS(1289),
    [anon_sym_else] = ACTIONS(1219),
    [anon_sym_switch] = ACTIONS(1292),
    [anon_sym_case] = ACTIONS(1219),
    [anon_sym_default] = ACTIONS(1219),
    [anon_sym_while] = ACTIONS(1295),
    [anon_sym_do] = ACTIONS(1298),
    [anon_sym_for] = ACTIONS(1301),
    [anon_sym_return] = ACTIONS(1304),
    [anon_sym_break] = ACTIONS(1307),
    [anon_sym_continue] = ACTIONS(1310),
    [anon_sym_goto] = ACTIONS(1313),
    [anon_sym___try] = ACTIONS(1316),
    [anon_sym___leave] = ACTIONS(1319),
    [anon_sym_not] = ACTIONS(1227),
    [anon_sym_compl] = ACTIONS(1227),
    [anon_sym_DASH_DASH] = ACTIONS(1322),
    [anon_sym_PLUS_PLUS] = ACTIONS(1322),
    [anon_sym_sizeof] = ACTIONS(1325),
    [anon_sym___alignof__] = ACTIONS(1328),
    [anon_sym___alignof] = ACTIONS(1328),
    [anon_sym__alignof] = ACTIONS(1328),
    [anon_sym_alignof] = ACTIONS(1328),
    [anon_sym__Alignof] = ACTIONS(1328),
    [anon_sym_offsetof] = ACTIONS(1331),
    [anon_sym__Generic] = ACTIONS(1334),
    [anon_sym_asm] = ACTIONS(1337),
    [anon_sym___asm__] = ACTIONS(1337),
    [aux_sym_number_literal_token1] = ACTIONS(1340),
    [aux_sym_number_literal_token2] = ACTIONS(1343),
    [anon_sym_L_SQUOTE] = ACTIONS(1346),
    [anon_sym_u_SQUOTE] = ACTIONS(1346),
    [anon_sym_U_SQUOTE] = ACTIONS(1346),
    [anon_sym_u8_SQUOTE] = ACTIONS(1346),
    [anon_sym_SQUOTE] = ACTIONS(1346),
    [anon_sym_L_DQUOTE] = ACTIONS(1349),
    [anon_sym_u_DQUOTE] = ACTIONS(1349),
    [anon_sym_U_DQUOTE] = ACTIONS(1349),
    [anon_sym_u8_DQUOTE] = ACTIONS(1349),
    [anon_sym_DQUOTE] = ACTIONS(1349),
    [sym_true] = ACTIONS(1352),
    [sym_false] = ACTIONS(1352),
    [anon_sym_NULL] = ACTIONS(1355),
    [anon_sym_nullptr] = ACTIONS(1355),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1358),
    [anon_sym_decltype] = ACTIONS(1361),
    [anon_sym_virtual] = ACTIONS(1364),
    [anon_sym_alignas] = ACTIONS(1367),
    [anon_sym_explicit] = ACTIONS(1219),
    [anon_sym_typename] = ACTIONS(1370),
    [anon_sym_template] = ACTIONS(1373),
    [anon_sym_operator] = ACTIONS(1219),
    [anon_sym_try] = ACTIONS(1376),
    [anon_sym_delete] = ACTIONS(1379),
    [anon_sym_throw] = ACTIONS(1382),
    [anon_sym_namespace] = ACTIONS(1219),
    [anon_sym_using] = ACTIONS(1219),
    [anon_sym_static_assert] = ACTIONS(1219),
    [anon_sym_concept] = ACTIONS(1219),
    [anon_sym_co_return] = ACTIONS(1385),
    [anon_sym_co_yield] = ACTIONS(1388),
    [anon_sym_R_DQUOTE] = ACTIONS(1391),
    [anon_sym_LR_DQUOTE] = ACTIONS(1391),
    [anon_sym_uR_DQUOTE] = ACTIONS(1391),
    [anon_sym_UR_DQUOTE] = ACTIONS(1391),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1391),
    [anon_sym_co_await] = ACTIONS(1394),
    [anon_sym_new] = ACTIONS(1397),
    [anon_sym_requires] = ACTIONS(1400),
    [sym_this] = ACTIONS(1352),
  },
  [83] = {
    [sym_declaration] = STATE(82),
    [sym_type_definition] = STATE(82),
    [sym__declaration_modifiers] = STATE(1964),
    [sym__declaration_specifiers] = STATE(5046),
    [sym_attribute_specifier] = STATE(1964),
    [sym_attribute_declaration] = STATE(973),
    [sym_ms_declspec_modifier] = STATE(1964),
    [sym_compound_statement] = STATE(82),
    [sym_storage_class_specifier] = STATE(1964),
    [sym_type_qualifier] = STATE(1964),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(82),
    [sym_labeled_statement] = STATE(82),
    [sym_expression_statement] = STATE(82),
    [sym_if_statement] = STATE(82),
    [sym_switch_statement] = STATE(82),
    [sym_while_statement] = STATE(82),
    [sym_do_statement] = STATE(82),
    [sym_for_statement] = STATE(82),
    [sym_return_statement] = STATE(82),
    [sym_break_statement] = STATE(82),
    [sym_continue_statement] = STATE(82),
    [sym_goto_statement] = STATE(82),
    [sym_seh_try_statement] = STATE(82),
    [sym_seh_leave_statement] = STATE(82),
    [sym__expression] = STATE(4420),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8126),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(1964),
    [sym_alignas_specifier] = STATE(1964),
    [sym_dependent_type] = STATE(2629),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(82),
    [sym_co_return_statement] = STATE(82),
    [sym_co_yield_statement] = STATE(82),
    [sym_throw_statement] = STATE(82),
    [sym_try_statement] = STATE(82),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5552),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(176),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_case_statement_repeat1] = STATE(82),
    [sym_identifier] = ACTIONS(1403),
    [aux_sym_preproc_include_token1] = ACTIONS(1405),
    [aux_sym_preproc_def_token1] = ACTIONS(1405),
    [aux_sym_preproc_if_token1] = ACTIONS(1405),
    [aux_sym_preproc_if_token2] = ACTIONS(1405),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1405),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1405),
    [aux_sym_preproc_else_token1] = ACTIONS(1405),
    [aux_sym_preproc_elif_token1] = ACTIONS(1405),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1405),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1405),
    [sym_preproc_directive] = ACTIONS(1405),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1411),
    [anon_sym_AMP] = ACTIONS(1413),
    [anon_sym_SEMI] = ACTIONS(279),
    [anon_sym___extension__] = ACTIONS(281),
    [anon_sym_typedef] = ACTIONS(283),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(1405),
    [anon_sym___cdecl] = ACTIONS(1405),
    [anon_sym___clrcall] = ACTIONS(1405),
    [anon_sym___stdcall] = ACTIONS(1405),
    [anon_sym___fastcall] = ACTIONS(1405),
    [anon_sym___thiscall] = ACTIONS(1405),
    [anon_sym___vectorcall] = ACTIONS(1405),
    [anon_sym_LBRACE] = ACTIONS(287),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(291),
    [anon_sym_else] = ACTIONS(1405),
    [anon_sym_switch] = ACTIONS(293),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_default] = ACTIONS(1405),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(301),
    [anon_sym_for] = ACTIONS(303),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_break] = ACTIONS(307),
    [anon_sym_continue] = ACTIONS(309),
    [anon_sym_goto] = ACTIONS(311),
    [anon_sym___try] = ACTIONS(313),
    [anon_sym___leave] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(1405),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_operator] = ACTIONS(1405),
    [anon_sym_try] = ACTIONS(319),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(321),
    [anon_sym_namespace] = ACTIONS(1405),
    [anon_sym_using] = ACTIONS(1405),
    [anon_sym_static_assert] = ACTIONS(1405),
    [anon_sym_concept] = ACTIONS(1405),
    [anon_sym_co_return] = ACTIONS(331),
    [anon_sym_co_yield] = ACTIONS(333),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [84] = {
    [sym_declaration] = STATE(82),
    [sym_type_definition] = STATE(82),
    [sym__declaration_modifiers] = STATE(1964),
    [sym__declaration_specifiers] = STATE(5046),
    [sym_attribute_specifier] = STATE(1964),
    [sym_attribute_declaration] = STATE(973),
    [sym_ms_declspec_modifier] = STATE(1964),
    [sym_compound_statement] = STATE(82),
    [sym_storage_class_specifier] = STATE(1964),
    [sym_type_qualifier] = STATE(1964),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(82),
    [sym_labeled_statement] = STATE(82),
    [sym_expression_statement] = STATE(82),
    [sym_if_statement] = STATE(82),
    [sym_switch_statement] = STATE(82),
    [sym_while_statement] = STATE(82),
    [sym_do_statement] = STATE(82),
    [sym_for_statement] = STATE(82),
    [sym_return_statement] = STATE(82),
    [sym_break_statement] = STATE(82),
    [sym_continue_statement] = STATE(82),
    [sym_goto_statement] = STATE(82),
    [sym_seh_try_statement] = STATE(82),
    [sym_seh_leave_statement] = STATE(82),
    [sym__expression] = STATE(4420),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8126),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(1964),
    [sym_alignas_specifier] = STATE(1964),
    [sym_dependent_type] = STATE(2629),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(82),
    [sym_co_return_statement] = STATE(82),
    [sym_co_yield_statement] = STATE(82),
    [sym_throw_statement] = STATE(82),
    [sym_try_statement] = STATE(82),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5552),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(176),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_case_statement_repeat1] = STATE(82),
    [sym_identifier] = ACTIONS(1403),
    [aux_sym_preproc_include_token1] = ACTIONS(1421),
    [aux_sym_preproc_def_token1] = ACTIONS(1421),
    [aux_sym_preproc_if_token1] = ACTIONS(1421),
    [aux_sym_preproc_if_token2] = ACTIONS(1421),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1421),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1421),
    [aux_sym_preproc_else_token1] = ACTIONS(1421),
    [aux_sym_preproc_elif_token1] = ACTIONS(1421),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1421),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1421),
    [sym_preproc_directive] = ACTIONS(1421),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1423),
    [anon_sym_AMP] = ACTIONS(1413),
    [anon_sym_SEMI] = ACTIONS(279),
    [anon_sym___extension__] = ACTIONS(281),
    [anon_sym_typedef] = ACTIONS(283),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(1421),
    [anon_sym___cdecl] = ACTIONS(1421),
    [anon_sym___clrcall] = ACTIONS(1421),
    [anon_sym___stdcall] = ACTIONS(1421),
    [anon_sym___fastcall] = ACTIONS(1421),
    [anon_sym___thiscall] = ACTIONS(1421),
    [anon_sym___vectorcall] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(287),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(291),
    [anon_sym_else] = ACTIONS(1421),
    [anon_sym_switch] = ACTIONS(293),
    [anon_sym_case] = ACTIONS(1421),
    [anon_sym_default] = ACTIONS(1421),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(301),
    [anon_sym_for] = ACTIONS(303),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_break] = ACTIONS(307),
    [anon_sym_continue] = ACTIONS(309),
    [anon_sym_goto] = ACTIONS(311),
    [anon_sym___try] = ACTIONS(313),
    [anon_sym___leave] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(1421),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_operator] = ACTIONS(1421),
    [anon_sym_try] = ACTIONS(319),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(321),
    [anon_sym_namespace] = ACTIONS(1421),
    [anon_sym_using] = ACTIONS(1421),
    [anon_sym_static_assert] = ACTIONS(1421),
    [anon_sym_concept] = ACTIONS(1421),
    [anon_sym_co_return] = ACTIONS(331),
    [anon_sym_co_yield] = ACTIONS(333),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [85] = {
    [sym_declaration] = STATE(83),
    [sym_type_definition] = STATE(83),
    [sym__declaration_modifiers] = STATE(1964),
    [sym__declaration_specifiers] = STATE(5046),
    [sym_attribute_specifier] = STATE(1964),
    [sym_attribute_declaration] = STATE(973),
    [sym_ms_declspec_modifier] = STATE(1964),
    [sym_compound_statement] = STATE(83),
    [sym_storage_class_specifier] = STATE(1964),
    [sym_type_qualifier] = STATE(1964),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(83),
    [sym_labeled_statement] = STATE(83),
    [sym_expression_statement] = STATE(83),
    [sym_if_statement] = STATE(83),
    [sym_switch_statement] = STATE(83),
    [sym_while_statement] = STATE(83),
    [sym_do_statement] = STATE(83),
    [sym_for_statement] = STATE(83),
    [sym_return_statement] = STATE(83),
    [sym_break_statement] = STATE(83),
    [sym_continue_statement] = STATE(83),
    [sym_goto_statement] = STATE(83),
    [sym_seh_try_statement] = STATE(83),
    [sym_seh_leave_statement] = STATE(83),
    [sym__expression] = STATE(4420),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8126),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(1964),
    [sym_alignas_specifier] = STATE(1964),
    [sym_dependent_type] = STATE(2629),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(83),
    [sym_co_return_statement] = STATE(83),
    [sym_co_yield_statement] = STATE(83),
    [sym_throw_statement] = STATE(83),
    [sym_try_statement] = STATE(83),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5552),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(176),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_case_statement_repeat1] = STATE(83),
    [sym_identifier] = ACTIONS(1403),
    [aux_sym_preproc_include_token1] = ACTIONS(1425),
    [aux_sym_preproc_def_token1] = ACTIONS(1425),
    [aux_sym_preproc_if_token1] = ACTIONS(1425),
    [aux_sym_preproc_if_token2] = ACTIONS(1425),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1425),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1425),
    [aux_sym_preproc_else_token1] = ACTIONS(1425),
    [aux_sym_preproc_elif_token1] = ACTIONS(1425),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1425),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1425),
    [sym_preproc_directive] = ACTIONS(1425),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1427),
    [anon_sym_AMP] = ACTIONS(1413),
    [anon_sym_SEMI] = ACTIONS(279),
    [anon_sym___extension__] = ACTIONS(281),
    [anon_sym_typedef] = ACTIONS(283),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(1425),
    [anon_sym___cdecl] = ACTIONS(1425),
    [anon_sym___clrcall] = ACTIONS(1425),
    [anon_sym___stdcall] = ACTIONS(1425),
    [anon_sym___fastcall] = ACTIONS(1425),
    [anon_sym___thiscall] = ACTIONS(1425),
    [anon_sym___vectorcall] = ACTIONS(1425),
    [anon_sym_LBRACE] = ACTIONS(287),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(291),
    [anon_sym_else] = ACTIONS(1425),
    [anon_sym_switch] = ACTIONS(293),
    [anon_sym_case] = ACTIONS(1425),
    [anon_sym_default] = ACTIONS(1425),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(301),
    [anon_sym_for] = ACTIONS(303),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_break] = ACTIONS(307),
    [anon_sym_continue] = ACTIONS(309),
    [anon_sym_goto] = ACTIONS(311),
    [anon_sym___try] = ACTIONS(313),
    [anon_sym___leave] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(1425),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_operator] = ACTIONS(1425),
    [anon_sym_try] = ACTIONS(319),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(321),
    [anon_sym_namespace] = ACTIONS(1425),
    [anon_sym_using] = ACTIONS(1425),
    [anon_sym_static_assert] = ACTIONS(1425),
    [anon_sym_concept] = ACTIONS(1425),
    [anon_sym_co_return] = ACTIONS(331),
    [anon_sym_co_yield] = ACTIONS(333),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [86] = {
    [sym_declaration] = STATE(84),
    [sym_type_definition] = STATE(84),
    [sym__declaration_modifiers] = STATE(1964),
    [sym__declaration_specifiers] = STATE(5046),
    [sym_attribute_specifier] = STATE(1964),
    [sym_attribute_declaration] = STATE(973),
    [sym_ms_declspec_modifier] = STATE(1964),
    [sym_compound_statement] = STATE(84),
    [sym_storage_class_specifier] = STATE(1964),
    [sym_type_qualifier] = STATE(1964),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(84),
    [sym_labeled_statement] = STATE(84),
    [sym_expression_statement] = STATE(84),
    [sym_if_statement] = STATE(84),
    [sym_switch_statement] = STATE(84),
    [sym_while_statement] = STATE(84),
    [sym_do_statement] = STATE(84),
    [sym_for_statement] = STATE(84),
    [sym_return_statement] = STATE(84),
    [sym_break_statement] = STATE(84),
    [sym_continue_statement] = STATE(84),
    [sym_goto_statement] = STATE(84),
    [sym_seh_try_statement] = STATE(84),
    [sym_seh_leave_statement] = STATE(84),
    [sym__expression] = STATE(4420),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8126),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(1964),
    [sym_alignas_specifier] = STATE(1964),
    [sym_dependent_type] = STATE(2629),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(84),
    [sym_co_return_statement] = STATE(84),
    [sym_co_yield_statement] = STATE(84),
    [sym_throw_statement] = STATE(84),
    [sym_try_statement] = STATE(84),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5552),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(176),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_case_statement_repeat1] = STATE(84),
    [sym_identifier] = ACTIONS(1403),
    [aux_sym_preproc_include_token1] = ACTIONS(1429),
    [aux_sym_preproc_def_token1] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1429),
    [aux_sym_preproc_if_token2] = ACTIONS(1429),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1429),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1429),
    [aux_sym_preproc_else_token1] = ACTIONS(1429),
    [aux_sym_preproc_elif_token1] = ACTIONS(1429),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1429),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1429),
    [sym_preproc_directive] = ACTIONS(1429),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1431),
    [anon_sym_AMP] = ACTIONS(1413),
    [anon_sym_SEMI] = ACTIONS(279),
    [anon_sym___extension__] = ACTIONS(281),
    [anon_sym_typedef] = ACTIONS(283),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(1429),
    [anon_sym___cdecl] = ACTIONS(1429),
    [anon_sym___clrcall] = ACTIONS(1429),
    [anon_sym___stdcall] = ACTIONS(1429),
    [anon_sym___fastcall] = ACTIONS(1429),
    [anon_sym___thiscall] = ACTIONS(1429),
    [anon_sym___vectorcall] = ACTIONS(1429),
    [anon_sym_LBRACE] = ACTIONS(287),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(291),
    [anon_sym_else] = ACTIONS(1429),
    [anon_sym_switch] = ACTIONS(293),
    [anon_sym_case] = ACTIONS(1429),
    [anon_sym_default] = ACTIONS(1429),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(301),
    [anon_sym_for] = ACTIONS(303),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_break] = ACTIONS(307),
    [anon_sym_continue] = ACTIONS(309),
    [anon_sym_goto] = ACTIONS(311),
    [anon_sym___try] = ACTIONS(313),
    [anon_sym___leave] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(1429),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_operator] = ACTIONS(1429),
    [anon_sym_try] = ACTIONS(319),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(321),
    [anon_sym_namespace] = ACTIONS(1429),
    [anon_sym_using] = ACTIONS(1429),
    [anon_sym_static_assert] = ACTIONS(1429),
    [anon_sym_concept] = ACTIONS(1429),
    [anon_sym_co_return] = ACTIONS(331),
    [anon_sym_co_yield] = ACTIONS(333),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [87] = {
    [sym_declaration] = STATE(88),
    [sym_type_definition] = STATE(88),
    [sym__declaration_modifiers] = STATE(1964),
    [sym__declaration_specifiers] = STATE(5030),
    [sym_attribute_specifier] = STATE(1964),
    [sym_attribute_declaration] = STATE(973),
    [sym_ms_declspec_modifier] = STATE(1964),
    [sym_compound_statement] = STATE(88),
    [sym_storage_class_specifier] = STATE(1964),
    [sym_type_qualifier] = STATE(1964),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(88),
    [sym_labeled_statement] = STATE(88),
    [sym_expression_statement] = STATE(88),
    [sym_if_statement] = STATE(88),
    [sym_switch_statement] = STATE(88),
    [sym_while_statement] = STATE(88),
    [sym_do_statement] = STATE(88),
    [sym_for_statement] = STATE(88),
    [sym_return_statement] = STATE(88),
    [sym_break_statement] = STATE(88),
    [sym_continue_statement] = STATE(88),
    [sym_goto_statement] = STATE(88),
    [sym_seh_try_statement] = STATE(88),
    [sym_seh_leave_statement] = STATE(88),
    [sym__expression] = STATE(4447),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8027),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(1964),
    [sym_alignas_specifier] = STATE(1964),
    [sym_dependent_type] = STATE(2629),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(88),
    [sym_co_return_statement] = STATE(88),
    [sym_co_yield_statement] = STATE(88),
    [sym_throw_statement] = STATE(88),
    [sym_try_statement] = STATE(88),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5552),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(172),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_case_statement_repeat1] = STATE(88),
    [ts_builtin_sym_end] = ACTIONS(1431),
    [sym_identifier] = ACTIONS(1433),
    [aux_sym_preproc_include_token1] = ACTIONS(1429),
    [aux_sym_preproc_def_token1] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1429),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1429),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1429),
    [sym_preproc_directive] = ACTIONS(1429),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1431),
    [anon_sym_AMP] = ACTIONS(1413),
    [anon_sym_SEMI] = ACTIONS(1435),
    [anon_sym___extension__] = ACTIONS(33),
    [anon_sym_typedef] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(1429),
    [anon_sym___cdecl] = ACTIONS(1429),
    [anon_sym___clrcall] = ACTIONS(1429),
    [anon_sym___stdcall] = ACTIONS(1429),
    [anon_sym___fastcall] = ACTIONS(1429),
    [anon_sym___thiscall] = ACTIONS(1429),
    [anon_sym___vectorcall] = ACTIONS(1429),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(73),
    [anon_sym_else] = ACTIONS(1429),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_case] = ACTIONS(1429),
    [anon_sym_default] = ACTIONS(1429),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_do] = ACTIONS(83),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_return] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_goto] = ACTIONS(93),
    [anon_sym___try] = ACTIONS(1437),
    [anon_sym___leave] = ACTIONS(1439),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(1429),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_operator] = ACTIONS(1429),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(1429),
    [anon_sym_using] = ACTIONS(1429),
    [anon_sym_static_assert] = ACTIONS(1429),
    [anon_sym_concept] = ACTIONS(1429),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [88] = {
    [sym_declaration] = STATE(95),
    [sym_type_definition] = STATE(95),
    [sym__declaration_modifiers] = STATE(1964),
    [sym__declaration_specifiers] = STATE(5030),
    [sym_attribute_specifier] = STATE(1964),
    [sym_attribute_declaration] = STATE(973),
    [sym_ms_declspec_modifier] = STATE(1964),
    [sym_compound_statement] = STATE(95),
    [sym_storage_class_specifier] = STATE(1964),
    [sym_type_qualifier] = STATE(1964),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(95),
    [sym_labeled_statement] = STATE(95),
    [sym_expression_statement] = STATE(95),
    [sym_if_statement] = STATE(95),
    [sym_switch_statement] = STATE(95),
    [sym_while_statement] = STATE(95),
    [sym_do_statement] = STATE(95),
    [sym_for_statement] = STATE(95),
    [sym_return_statement] = STATE(95),
    [sym_break_statement] = STATE(95),
    [sym_continue_statement] = STATE(95),
    [sym_goto_statement] = STATE(95),
    [sym_seh_try_statement] = STATE(95),
    [sym_seh_leave_statement] = STATE(95),
    [sym__expression] = STATE(4447),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8027),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(1964),
    [sym_alignas_specifier] = STATE(1964),
    [sym_dependent_type] = STATE(2629),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(95),
    [sym_co_return_statement] = STATE(95),
    [sym_co_yield_statement] = STATE(95),
    [sym_throw_statement] = STATE(95),
    [sym_try_statement] = STATE(95),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5552),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(172),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_case_statement_repeat1] = STATE(95),
    [ts_builtin_sym_end] = ACTIONS(1423),
    [sym_identifier] = ACTIONS(1433),
    [aux_sym_preproc_include_token1] = ACTIONS(1421),
    [aux_sym_preproc_def_token1] = ACTIONS(1421),
    [aux_sym_preproc_if_token1] = ACTIONS(1421),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1421),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1421),
    [sym_preproc_directive] = ACTIONS(1421),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1423),
    [anon_sym_AMP] = ACTIONS(1413),
    [anon_sym_SEMI] = ACTIONS(1435),
    [anon_sym___extension__] = ACTIONS(33),
    [anon_sym_typedef] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(1421),
    [anon_sym___cdecl] = ACTIONS(1421),
    [anon_sym___clrcall] = ACTIONS(1421),
    [anon_sym___stdcall] = ACTIONS(1421),
    [anon_sym___fastcall] = ACTIONS(1421),
    [anon_sym___thiscall] = ACTIONS(1421),
    [anon_sym___vectorcall] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(73),
    [anon_sym_else] = ACTIONS(1421),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_case] = ACTIONS(1421),
    [anon_sym_default] = ACTIONS(1421),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_do] = ACTIONS(83),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_return] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_goto] = ACTIONS(93),
    [anon_sym___try] = ACTIONS(1437),
    [anon_sym___leave] = ACTIONS(1439),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(1421),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_operator] = ACTIONS(1421),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(1421),
    [anon_sym_using] = ACTIONS(1421),
    [anon_sym_static_assert] = ACTIONS(1421),
    [anon_sym_concept] = ACTIONS(1421),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [89] = {
    [sym_declaration] = STATE(90),
    [sym_type_definition] = STATE(90),
    [sym__declaration_modifiers] = STATE(1964),
    [sym__declaration_specifiers] = STATE(5034),
    [sym_attribute_specifier] = STATE(1964),
    [sym_attribute_declaration] = STATE(973),
    [sym_ms_declspec_modifier] = STATE(1964),
    [sym_compound_statement] = STATE(90),
    [sym_storage_class_specifier] = STATE(1964),
    [sym_type_qualifier] = STATE(1964),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(90),
    [sym_labeled_statement] = STATE(90),
    [sym_expression_statement] = STATE(90),
    [sym_if_statement] = STATE(90),
    [sym_switch_statement] = STATE(90),
    [sym_while_statement] = STATE(90),
    [sym_do_statement] = STATE(90),
    [sym_for_statement] = STATE(90),
    [sym_return_statement] = STATE(90),
    [sym_break_statement] = STATE(90),
    [sym_continue_statement] = STATE(90),
    [sym_goto_statement] = STATE(90),
    [sym_seh_try_statement] = STATE(90),
    [sym_seh_leave_statement] = STATE(90),
    [sym__expression] = STATE(4455),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(7649),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(1964),
    [sym_alignas_specifier] = STATE(1964),
    [sym_dependent_type] = STATE(2629),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(90),
    [sym_co_return_statement] = STATE(90),
    [sym_co_yield_statement] = STATE(90),
    [sym_throw_statement] = STATE(90),
    [sym_try_statement] = STATE(90),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5552),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(173),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_case_statement_repeat1] = STATE(90),
    [sym_identifier] = ACTIONS(1441),
    [aux_sym_preproc_include_token1] = ACTIONS(1405),
    [aux_sym_preproc_def_token1] = ACTIONS(1405),
    [aux_sym_preproc_if_token1] = ACTIONS(1405),
    [aux_sym_preproc_if_token2] = ACTIONS(1405),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1405),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1405),
    [sym_preproc_directive] = ACTIONS(1405),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1411),
    [anon_sym_AMP] = ACTIONS(1413),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym___extension__] = ACTIONS(669),
    [anon_sym_typedef] = ACTIONS(671),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(1405),
    [anon_sym___cdecl] = ACTIONS(1405),
    [anon_sym___clrcall] = ACTIONS(1405),
    [anon_sym___stdcall] = ACTIONS(1405),
    [anon_sym___fastcall] = ACTIONS(1405),
    [anon_sym___thiscall] = ACTIONS(1405),
    [anon_sym___vectorcall] = ACTIONS(1405),
    [anon_sym_LBRACE] = ACTIONS(675),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(679),
    [anon_sym_else] = ACTIONS(1405),
    [anon_sym_switch] = ACTIONS(681),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_default] = ACTIONS(1405),
    [anon_sym_while] = ACTIONS(687),
    [anon_sym_do] = ACTIONS(689),
    [anon_sym_for] = ACTIONS(691),
    [anon_sym_return] = ACTIONS(693),
    [anon_sym_break] = ACTIONS(695),
    [anon_sym_continue] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym___try] = ACTIONS(701),
    [anon_sym___leave] = ACTIONS(703),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(1405),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_operator] = ACTIONS(1405),
    [anon_sym_try] = ACTIONS(707),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(709),
    [anon_sym_namespace] = ACTIONS(1405),
    [anon_sym_using] = ACTIONS(1405),
    [anon_sym_static_assert] = ACTIONS(1405),
    [anon_sym_concept] = ACTIONS(1405),
    [anon_sym_co_return] = ACTIONS(719),
    [anon_sym_co_yield] = ACTIONS(721),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [90] = {
    [sym_declaration] = STATE(90),
    [sym_type_definition] = STATE(90),
    [sym__declaration_modifiers] = STATE(1964),
    [sym__declaration_specifiers] = STATE(5034),
    [sym_attribute_specifier] = STATE(1964),
    [sym_attribute_declaration] = STATE(973),
    [sym_ms_declspec_modifier] = STATE(1964),
    [sym_compound_statement] = STATE(90),
    [sym_storage_class_specifier] = STATE(1964),
    [sym_type_qualifier] = STATE(1964),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(90),
    [sym_labeled_statement] = STATE(90),
    [sym_expression_statement] = STATE(90),
    [sym_if_statement] = STATE(90),
    [sym_switch_statement] = STATE(90),
    [sym_while_statement] = STATE(90),
    [sym_do_statement] = STATE(90),
    [sym_for_statement] = STATE(90),
    [sym_return_statement] = STATE(90),
    [sym_break_statement] = STATE(90),
    [sym_continue_statement] = STATE(90),
    [sym_goto_statement] = STATE(90),
    [sym_seh_try_statement] = STATE(90),
    [sym_seh_leave_statement] = STATE(90),
    [sym__expression] = STATE(4455),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(7649),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(1964),
    [sym_alignas_specifier] = STATE(1964),
    [sym_dependent_type] = STATE(2629),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(90),
    [sym_co_return_statement] = STATE(90),
    [sym_co_yield_statement] = STATE(90),
    [sym_throw_statement] = STATE(90),
    [sym_try_statement] = STATE(90),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5552),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(173),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_case_statement_repeat1] = STATE(90),
    [sym_identifier] = ACTIONS(1443),
    [aux_sym_preproc_include_token1] = ACTIONS(1219),
    [aux_sym_preproc_def_token1] = ACTIONS(1219),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_if_token2] = ACTIONS(1219),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1219),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1219),
    [sym_preproc_directive] = ACTIONS(1219),
    [anon_sym_LPAREN2] = ACTIONS(1221),
    [anon_sym_BANG] = ACTIONS(1224),
    [anon_sym_TILDE] = ACTIONS(1224),
    [anon_sym_DASH] = ACTIONS(1227),
    [anon_sym_PLUS] = ACTIONS(1227),
    [anon_sym_STAR] = ACTIONS(1230),
    [anon_sym_AMP_AMP] = ACTIONS(1233),
    [anon_sym_AMP] = ACTIONS(1235),
    [anon_sym_SEMI] = ACTIONS(1446),
    [anon_sym___extension__] = ACTIONS(1449),
    [anon_sym_typedef] = ACTIONS(1452),
    [anon_sym_extern] = ACTIONS(1247),
    [anon_sym___attribute__] = ACTIONS(1250),
    [anon_sym_COLON_COLON] = ACTIONS(1253),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1256),
    [anon_sym___declspec] = ACTIONS(1259),
    [anon_sym___based] = ACTIONS(1219),
    [anon_sym___cdecl] = ACTIONS(1219),
    [anon_sym___clrcall] = ACTIONS(1219),
    [anon_sym___stdcall] = ACTIONS(1219),
    [anon_sym___fastcall] = ACTIONS(1219),
    [anon_sym___thiscall] = ACTIONS(1219),
    [anon_sym___vectorcall] = ACTIONS(1219),
    [anon_sym_LBRACE] = ACTIONS(1455),
    [anon_sym_signed] = ACTIONS(1265),
    [anon_sym_unsigned] = ACTIONS(1265),
    [anon_sym_long] = ACTIONS(1265),
    [anon_sym_short] = ACTIONS(1265),
    [anon_sym_LBRACK] = ACTIONS(1268),
    [anon_sym_static] = ACTIONS(1247),
    [anon_sym_register] = ACTIONS(1247),
    [anon_sym_inline] = ACTIONS(1247),
    [anon_sym___inline] = ACTIONS(1247),
    [anon_sym___inline__] = ACTIONS(1247),
    [anon_sym___forceinline] = ACTIONS(1247),
    [anon_sym_thread_local] = ACTIONS(1247),
    [anon_sym___thread] = ACTIONS(1247),
    [anon_sym_const] = ACTIONS(1271),
    [anon_sym_constexpr] = ACTIONS(1271),
    [anon_sym_volatile] = ACTIONS(1271),
    [anon_sym_restrict] = ACTIONS(1271),
    [anon_sym___restrict__] = ACTIONS(1271),
    [anon_sym__Atomic] = ACTIONS(1271),
    [anon_sym__Noreturn] = ACTIONS(1271),
    [anon_sym_noreturn] = ACTIONS(1271),
    [anon_sym_mutable] = ACTIONS(1271),
    [anon_sym_constinit] = ACTIONS(1271),
    [anon_sym_consteval] = ACTIONS(1271),
    [anon_sym_PROGMEM] = ACTIONS(1271),
    [aux_sym_primitive_type_token1] = ACTIONS(1274),
    [anon_sym_byte] = ACTIONS(1274),
    [anon_sym_word] = ACTIONS(1274),
    [anon_sym_enum] = ACTIONS(1277),
    [anon_sym_class] = ACTIONS(1280),
    [anon_sym_struct] = ACTIONS(1283),
    [anon_sym_union] = ACTIONS(1286),
    [anon_sym_if] = ACTIONS(1458),
    [anon_sym_else] = ACTIONS(1219),
    [anon_sym_switch] = ACTIONS(1461),
    [anon_sym_case] = ACTIONS(1219),
    [anon_sym_default] = ACTIONS(1219),
    [anon_sym_while] = ACTIONS(1464),
    [anon_sym_do] = ACTIONS(1467),
    [anon_sym_for] = ACTIONS(1470),
    [anon_sym_return] = ACTIONS(1473),
    [anon_sym_break] = ACTIONS(1476),
    [anon_sym_continue] = ACTIONS(1479),
    [anon_sym_goto] = ACTIONS(1482),
    [anon_sym___try] = ACTIONS(1485),
    [anon_sym___leave] = ACTIONS(1488),
    [anon_sym_not] = ACTIONS(1227),
    [anon_sym_compl] = ACTIONS(1227),
    [anon_sym_DASH_DASH] = ACTIONS(1322),
    [anon_sym_PLUS_PLUS] = ACTIONS(1322),
    [anon_sym_sizeof] = ACTIONS(1325),
    [anon_sym___alignof__] = ACTIONS(1328),
    [anon_sym___alignof] = ACTIONS(1328),
    [anon_sym__alignof] = ACTIONS(1328),
    [anon_sym_alignof] = ACTIONS(1328),
    [anon_sym__Alignof] = ACTIONS(1328),
    [anon_sym_offsetof] = ACTIONS(1331),
    [anon_sym__Generic] = ACTIONS(1334),
    [anon_sym_asm] = ACTIONS(1337),
    [anon_sym___asm__] = ACTIONS(1337),
    [aux_sym_number_literal_token1] = ACTIONS(1340),
    [aux_sym_number_literal_token2] = ACTIONS(1343),
    [anon_sym_L_SQUOTE] = ACTIONS(1346),
    [anon_sym_u_SQUOTE] = ACTIONS(1346),
    [anon_sym_U_SQUOTE] = ACTIONS(1346),
    [anon_sym_u8_SQUOTE] = ACTIONS(1346),
    [anon_sym_SQUOTE] = ACTIONS(1346),
    [anon_sym_L_DQUOTE] = ACTIONS(1349),
    [anon_sym_u_DQUOTE] = ACTIONS(1349),
    [anon_sym_U_DQUOTE] = ACTIONS(1349),
    [anon_sym_u8_DQUOTE] = ACTIONS(1349),
    [anon_sym_DQUOTE] = ACTIONS(1349),
    [sym_true] = ACTIONS(1352),
    [sym_false] = ACTIONS(1352),
    [anon_sym_NULL] = ACTIONS(1355),
    [anon_sym_nullptr] = ACTIONS(1355),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1358),
    [anon_sym_decltype] = ACTIONS(1361),
    [anon_sym_virtual] = ACTIONS(1364),
    [anon_sym_alignas] = ACTIONS(1367),
    [anon_sym_explicit] = ACTIONS(1219),
    [anon_sym_typename] = ACTIONS(1370),
    [anon_sym_template] = ACTIONS(1373),
    [anon_sym_operator] = ACTIONS(1219),
    [anon_sym_try] = ACTIONS(1491),
    [anon_sym_delete] = ACTIONS(1379),
    [anon_sym_throw] = ACTIONS(1494),
    [anon_sym_namespace] = ACTIONS(1219),
    [anon_sym_using] = ACTIONS(1219),
    [anon_sym_static_assert] = ACTIONS(1219),
    [anon_sym_concept] = ACTIONS(1219),
    [anon_sym_co_return] = ACTIONS(1497),
    [anon_sym_co_yield] = ACTIONS(1500),
    [anon_sym_R_DQUOTE] = ACTIONS(1391),
    [anon_sym_LR_DQUOTE] = ACTIONS(1391),
    [anon_sym_uR_DQUOTE] = ACTIONS(1391),
    [anon_sym_UR_DQUOTE] = ACTIONS(1391),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1391),
    [anon_sym_co_await] = ACTIONS(1394),
    [anon_sym_new] = ACTIONS(1397),
    [anon_sym_requires] = ACTIONS(1400),
    [sym_this] = ACTIONS(1352),
  },
  [91] = {
    [sym_declaration] = STATE(100),
    [sym_type_definition] = STATE(100),
    [sym__declaration_modifiers] = STATE(1964),
    [sym__declaration_specifiers] = STATE(5031),
    [sym_attribute_specifier] = STATE(1964),
    [sym_attribute_declaration] = STATE(973),
    [sym_ms_declspec_modifier] = STATE(1964),
    [sym_compound_statement] = STATE(100),
    [sym_storage_class_specifier] = STATE(1964),
    [sym_type_qualifier] = STATE(1964),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(100),
    [sym_labeled_statement] = STATE(100),
    [sym_expression_statement] = STATE(100),
    [sym_if_statement] = STATE(100),
    [sym_switch_statement] = STATE(100),
    [sym_while_statement] = STATE(100),
    [sym_do_statement] = STATE(100),
    [sym_for_statement] = STATE(100),
    [sym_return_statement] = STATE(100),
    [sym_break_statement] = STATE(100),
    [sym_continue_statement] = STATE(100),
    [sym_goto_statement] = STATE(100),
    [sym_seh_try_statement] = STATE(100),
    [sym_seh_leave_statement] = STATE(100),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(1964),
    [sym_alignas_specifier] = STATE(1964),
    [sym_dependent_type] = STATE(2629),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(100),
    [sym_co_return_statement] = STATE(100),
    [sym_co_yield_statement] = STATE(100),
    [sym_throw_statement] = STATE(100),
    [sym_try_statement] = STATE(100),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5552),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_case_statement_repeat1] = STATE(100),
    [sym_identifier] = ACTIONS(1503),
    [aux_sym_preproc_include_token1] = ACTIONS(1425),
    [aux_sym_preproc_def_token1] = ACTIONS(1425),
    [aux_sym_preproc_if_token1] = ACTIONS(1425),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1425),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1425),
    [sym_preproc_directive] = ACTIONS(1425),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1427),
    [anon_sym_AMP] = ACTIONS(1413),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(1425),
    [anon_sym___cdecl] = ACTIONS(1425),
    [anon_sym___clrcall] = ACTIONS(1425),
    [anon_sym___stdcall] = ACTIONS(1425),
    [anon_sym___fastcall] = ACTIONS(1425),
    [anon_sym___thiscall] = ACTIONS(1425),
    [anon_sym___vectorcall] = ACTIONS(1425),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(1427),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_else] = ACTIONS(1425),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(1425),
    [anon_sym_default] = ACTIONS(1425),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(1425),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_operator] = ACTIONS(1425),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(1425),
    [anon_sym_using] = ACTIONS(1425),
    [anon_sym_static_assert] = ACTIONS(1425),
    [anon_sym_concept] = ACTIONS(1425),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [92] = {
    [sym_declaration] = STATE(97),
    [sym_type_definition] = STATE(97),
    [sym__declaration_modifiers] = STATE(1964),
    [sym__declaration_specifiers] = STATE(5031),
    [sym_attribute_specifier] = STATE(1964),
    [sym_attribute_declaration] = STATE(973),
    [sym_ms_declspec_modifier] = STATE(1964),
    [sym_compound_statement] = STATE(97),
    [sym_storage_class_specifier] = STATE(1964),
    [sym_type_qualifier] = STATE(1964),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(97),
    [sym_labeled_statement] = STATE(97),
    [sym_expression_statement] = STATE(97),
    [sym_if_statement] = STATE(97),
    [sym_switch_statement] = STATE(97),
    [sym_while_statement] = STATE(97),
    [sym_do_statement] = STATE(97),
    [sym_for_statement] = STATE(97),
    [sym_return_statement] = STATE(97),
    [sym_break_statement] = STATE(97),
    [sym_continue_statement] = STATE(97),
    [sym_goto_statement] = STATE(97),
    [sym_seh_try_statement] = STATE(97),
    [sym_seh_leave_statement] = STATE(97),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(1964),
    [sym_alignas_specifier] = STATE(1964),
    [sym_dependent_type] = STATE(2629),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(97),
    [sym_co_return_statement] = STATE(97),
    [sym_co_yield_statement] = STATE(97),
    [sym_throw_statement] = STATE(97),
    [sym_try_statement] = STATE(97),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5552),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_case_statement_repeat1] = STATE(97),
    [sym_identifier] = ACTIONS(1503),
    [aux_sym_preproc_include_token1] = ACTIONS(1421),
    [aux_sym_preproc_def_token1] = ACTIONS(1421),
    [aux_sym_preproc_if_token1] = ACTIONS(1421),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1421),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1421),
    [sym_preproc_directive] = ACTIONS(1421),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1423),
    [anon_sym_AMP] = ACTIONS(1413),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(1421),
    [anon_sym___cdecl] = ACTIONS(1421),
    [anon_sym___clrcall] = ACTIONS(1421),
    [anon_sym___stdcall] = ACTIONS(1421),
    [anon_sym___fastcall] = ACTIONS(1421),
    [anon_sym___thiscall] = ACTIONS(1421),
    [anon_sym___vectorcall] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(1423),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_else] = ACTIONS(1421),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(1421),
    [anon_sym_default] = ACTIONS(1421),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(1421),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_operator] = ACTIONS(1421),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(1421),
    [anon_sym_using] = ACTIONS(1421),
    [anon_sym_static_assert] = ACTIONS(1421),
    [anon_sym_concept] = ACTIONS(1421),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [93] = {
    [sym_declaration] = STATE(94),
    [sym_type_definition] = STATE(94),
    [sym__declaration_modifiers] = STATE(1964),
    [sym__declaration_specifiers] = STATE(5034),
    [sym_attribute_specifier] = STATE(1964),
    [sym_attribute_declaration] = STATE(973),
    [sym_ms_declspec_modifier] = STATE(1964),
    [sym_compound_statement] = STATE(94),
    [sym_storage_class_specifier] = STATE(1964),
    [sym_type_qualifier] = STATE(1964),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(94),
    [sym_labeled_statement] = STATE(94),
    [sym_expression_statement] = STATE(94),
    [sym_if_statement] = STATE(94),
    [sym_switch_statement] = STATE(94),
    [sym_while_statement] = STATE(94),
    [sym_do_statement] = STATE(94),
    [sym_for_statement] = STATE(94),
    [sym_return_statement] = STATE(94),
    [sym_break_statement] = STATE(94),
    [sym_continue_statement] = STATE(94),
    [sym_goto_statement] = STATE(94),
    [sym_seh_try_statement] = STATE(94),
    [sym_seh_leave_statement] = STATE(94),
    [sym__expression] = STATE(4455),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(7649),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(1964),
    [sym_alignas_specifier] = STATE(1964),
    [sym_dependent_type] = STATE(2629),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(94),
    [sym_co_return_statement] = STATE(94),
    [sym_co_yield_statement] = STATE(94),
    [sym_throw_statement] = STATE(94),
    [sym_try_statement] = STATE(94),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5552),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(173),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_case_statement_repeat1] = STATE(94),
    [sym_identifier] = ACTIONS(1441),
    [aux_sym_preproc_include_token1] = ACTIONS(1429),
    [aux_sym_preproc_def_token1] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1429),
    [aux_sym_preproc_if_token2] = ACTIONS(1429),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1429),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1429),
    [sym_preproc_directive] = ACTIONS(1429),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1431),
    [anon_sym_AMP] = ACTIONS(1413),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym___extension__] = ACTIONS(669),
    [anon_sym_typedef] = ACTIONS(671),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(1429),
    [anon_sym___cdecl] = ACTIONS(1429),
    [anon_sym___clrcall] = ACTIONS(1429),
    [anon_sym___stdcall] = ACTIONS(1429),
    [anon_sym___fastcall] = ACTIONS(1429),
    [anon_sym___thiscall] = ACTIONS(1429),
    [anon_sym___vectorcall] = ACTIONS(1429),
    [anon_sym_LBRACE] = ACTIONS(675),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(679),
    [anon_sym_else] = ACTIONS(1429),
    [anon_sym_switch] = ACTIONS(681),
    [anon_sym_case] = ACTIONS(1429),
    [anon_sym_default] = ACTIONS(1429),
    [anon_sym_while] = ACTIONS(687),
    [anon_sym_do] = ACTIONS(689),
    [anon_sym_for] = ACTIONS(691),
    [anon_sym_return] = ACTIONS(693),
    [anon_sym_break] = ACTIONS(695),
    [anon_sym_continue] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym___try] = ACTIONS(701),
    [anon_sym___leave] = ACTIONS(703),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(1429),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_operator] = ACTIONS(1429),
    [anon_sym_try] = ACTIONS(707),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(709),
    [anon_sym_namespace] = ACTIONS(1429),
    [anon_sym_using] = ACTIONS(1429),
    [anon_sym_static_assert] = ACTIONS(1429),
    [anon_sym_concept] = ACTIONS(1429),
    [anon_sym_co_return] = ACTIONS(719),
    [anon_sym_co_yield] = ACTIONS(721),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [94] = {
    [sym_declaration] = STATE(90),
    [sym_type_definition] = STATE(90),
    [sym__declaration_modifiers] = STATE(1964),
    [sym__declaration_specifiers] = STATE(5034),
    [sym_attribute_specifier] = STATE(1964),
    [sym_attribute_declaration] = STATE(973),
    [sym_ms_declspec_modifier] = STATE(1964),
    [sym_compound_statement] = STATE(90),
    [sym_storage_class_specifier] = STATE(1964),
    [sym_type_qualifier] = STATE(1964),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(90),
    [sym_labeled_statement] = STATE(90),
    [sym_expression_statement] = STATE(90),
    [sym_if_statement] = STATE(90),
    [sym_switch_statement] = STATE(90),
    [sym_while_statement] = STATE(90),
    [sym_do_statement] = STATE(90),
    [sym_for_statement] = STATE(90),
    [sym_return_statement] = STATE(90),
    [sym_break_statement] = STATE(90),
    [sym_continue_statement] = STATE(90),
    [sym_goto_statement] = STATE(90),
    [sym_seh_try_statement] = STATE(90),
    [sym_seh_leave_statement] = STATE(90),
    [sym__expression] = STATE(4455),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(7649),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(1964),
    [sym_alignas_specifier] = STATE(1964),
    [sym_dependent_type] = STATE(2629),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(90),
    [sym_co_return_statement] = STATE(90),
    [sym_co_yield_statement] = STATE(90),
    [sym_throw_statement] = STATE(90),
    [sym_try_statement] = STATE(90),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5552),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(173),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_case_statement_repeat1] = STATE(90),
    [sym_identifier] = ACTIONS(1441),
    [aux_sym_preproc_include_token1] = ACTIONS(1421),
    [aux_sym_preproc_def_token1] = ACTIONS(1421),
    [aux_sym_preproc_if_token1] = ACTIONS(1421),
    [aux_sym_preproc_if_token2] = ACTIONS(1421),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1421),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1421),
    [sym_preproc_directive] = ACTIONS(1421),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1423),
    [anon_sym_AMP] = ACTIONS(1413),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym___extension__] = ACTIONS(669),
    [anon_sym_typedef] = ACTIONS(671),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(1421),
    [anon_sym___cdecl] = ACTIONS(1421),
    [anon_sym___clrcall] = ACTIONS(1421),
    [anon_sym___stdcall] = ACTIONS(1421),
    [anon_sym___fastcall] = ACTIONS(1421),
    [anon_sym___thiscall] = ACTIONS(1421),
    [anon_sym___vectorcall] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(675),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(679),
    [anon_sym_else] = ACTIONS(1421),
    [anon_sym_switch] = ACTIONS(681),
    [anon_sym_case] = ACTIONS(1421),
    [anon_sym_default] = ACTIONS(1421),
    [anon_sym_while] = ACTIONS(687),
    [anon_sym_do] = ACTIONS(689),
    [anon_sym_for] = ACTIONS(691),
    [anon_sym_return] = ACTIONS(693),
    [anon_sym_break] = ACTIONS(695),
    [anon_sym_continue] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym___try] = ACTIONS(701),
    [anon_sym___leave] = ACTIONS(703),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(1421),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_operator] = ACTIONS(1421),
    [anon_sym_try] = ACTIONS(707),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(709),
    [anon_sym_namespace] = ACTIONS(1421),
    [anon_sym_using] = ACTIONS(1421),
    [anon_sym_static_assert] = ACTIONS(1421),
    [anon_sym_concept] = ACTIONS(1421),
    [anon_sym_co_return] = ACTIONS(719),
    [anon_sym_co_yield] = ACTIONS(721),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [95] = {
    [sym_declaration] = STATE(95),
    [sym_type_definition] = STATE(95),
    [sym__declaration_modifiers] = STATE(1964),
    [sym__declaration_specifiers] = STATE(5030),
    [sym_attribute_specifier] = STATE(1964),
    [sym_attribute_declaration] = STATE(973),
    [sym_ms_declspec_modifier] = STATE(1964),
    [sym_compound_statement] = STATE(95),
    [sym_storage_class_specifier] = STATE(1964),
    [sym_type_qualifier] = STATE(1964),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(95),
    [sym_labeled_statement] = STATE(95),
    [sym_expression_statement] = STATE(95),
    [sym_if_statement] = STATE(95),
    [sym_switch_statement] = STATE(95),
    [sym_while_statement] = STATE(95),
    [sym_do_statement] = STATE(95),
    [sym_for_statement] = STATE(95),
    [sym_return_statement] = STATE(95),
    [sym_break_statement] = STATE(95),
    [sym_continue_statement] = STATE(95),
    [sym_goto_statement] = STATE(95),
    [sym_seh_try_statement] = STATE(95),
    [sym_seh_leave_statement] = STATE(95),
    [sym__expression] = STATE(4447),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8027),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(1964),
    [sym_alignas_specifier] = STATE(1964),
    [sym_dependent_type] = STATE(2629),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(95),
    [sym_co_return_statement] = STATE(95),
    [sym_co_yield_statement] = STATE(95),
    [sym_throw_statement] = STATE(95),
    [sym_try_statement] = STATE(95),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5552),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(172),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_case_statement_repeat1] = STATE(95),
    [ts_builtin_sym_end] = ACTIONS(1233),
    [sym_identifier] = ACTIONS(1505),
    [aux_sym_preproc_include_token1] = ACTIONS(1219),
    [aux_sym_preproc_def_token1] = ACTIONS(1219),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1219),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1219),
    [sym_preproc_directive] = ACTIONS(1219),
    [anon_sym_LPAREN2] = ACTIONS(1221),
    [anon_sym_BANG] = ACTIONS(1224),
    [anon_sym_TILDE] = ACTIONS(1224),
    [anon_sym_DASH] = ACTIONS(1227),
    [anon_sym_PLUS] = ACTIONS(1227),
    [anon_sym_STAR] = ACTIONS(1230),
    [anon_sym_AMP_AMP] = ACTIONS(1233),
    [anon_sym_AMP] = ACTIONS(1235),
    [anon_sym_SEMI] = ACTIONS(1508),
    [anon_sym___extension__] = ACTIONS(1511),
    [anon_sym_typedef] = ACTIONS(1514),
    [anon_sym_extern] = ACTIONS(1247),
    [anon_sym___attribute__] = ACTIONS(1250),
    [anon_sym_COLON_COLON] = ACTIONS(1253),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1256),
    [anon_sym___declspec] = ACTIONS(1259),
    [anon_sym___based] = ACTIONS(1219),
    [anon_sym___cdecl] = ACTIONS(1219),
    [anon_sym___clrcall] = ACTIONS(1219),
    [anon_sym___stdcall] = ACTIONS(1219),
    [anon_sym___fastcall] = ACTIONS(1219),
    [anon_sym___thiscall] = ACTIONS(1219),
    [anon_sym___vectorcall] = ACTIONS(1219),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_signed] = ACTIONS(1265),
    [anon_sym_unsigned] = ACTIONS(1265),
    [anon_sym_long] = ACTIONS(1265),
    [anon_sym_short] = ACTIONS(1265),
    [anon_sym_LBRACK] = ACTIONS(1268),
    [anon_sym_static] = ACTIONS(1247),
    [anon_sym_register] = ACTIONS(1247),
    [anon_sym_inline] = ACTIONS(1247),
    [anon_sym___inline] = ACTIONS(1247),
    [anon_sym___inline__] = ACTIONS(1247),
    [anon_sym___forceinline] = ACTIONS(1247),
    [anon_sym_thread_local] = ACTIONS(1247),
    [anon_sym___thread] = ACTIONS(1247),
    [anon_sym_const] = ACTIONS(1271),
    [anon_sym_constexpr] = ACTIONS(1271),
    [anon_sym_volatile] = ACTIONS(1271),
    [anon_sym_restrict] = ACTIONS(1271),
    [anon_sym___restrict__] = ACTIONS(1271),
    [anon_sym__Atomic] = ACTIONS(1271),
    [anon_sym__Noreturn] = ACTIONS(1271),
    [anon_sym_noreturn] = ACTIONS(1271),
    [anon_sym_mutable] = ACTIONS(1271),
    [anon_sym_constinit] = ACTIONS(1271),
    [anon_sym_consteval] = ACTIONS(1271),
    [anon_sym_PROGMEM] = ACTIONS(1271),
    [aux_sym_primitive_type_token1] = ACTIONS(1274),
    [anon_sym_byte] = ACTIONS(1274),
    [anon_sym_word] = ACTIONS(1274),
    [anon_sym_enum] = ACTIONS(1277),
    [anon_sym_class] = ACTIONS(1280),
    [anon_sym_struct] = ACTIONS(1283),
    [anon_sym_union] = ACTIONS(1286),
    [anon_sym_if] = ACTIONS(1520),
    [anon_sym_else] = ACTIONS(1219),
    [anon_sym_switch] = ACTIONS(1523),
    [anon_sym_case] = ACTIONS(1219),
    [anon_sym_default] = ACTIONS(1219),
    [anon_sym_while] = ACTIONS(1526),
    [anon_sym_do] = ACTIONS(1529),
    [anon_sym_for] = ACTIONS(1532),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1538),
    [anon_sym_continue] = ACTIONS(1541),
    [anon_sym_goto] = ACTIONS(1544),
    [anon_sym___try] = ACTIONS(1547),
    [anon_sym___leave] = ACTIONS(1550),
    [anon_sym_not] = ACTIONS(1227),
    [anon_sym_compl] = ACTIONS(1227),
    [anon_sym_DASH_DASH] = ACTIONS(1322),
    [anon_sym_PLUS_PLUS] = ACTIONS(1322),
    [anon_sym_sizeof] = ACTIONS(1325),
    [anon_sym___alignof__] = ACTIONS(1328),
    [anon_sym___alignof] = ACTIONS(1328),
    [anon_sym__alignof] = ACTIONS(1328),
    [anon_sym_alignof] = ACTIONS(1328),
    [anon_sym__Alignof] = ACTIONS(1328),
    [anon_sym_offsetof] = ACTIONS(1331),
    [anon_sym__Generic] = ACTIONS(1334),
    [anon_sym_asm] = ACTIONS(1337),
    [anon_sym___asm__] = ACTIONS(1337),
    [aux_sym_number_literal_token1] = ACTIONS(1340),
    [aux_sym_number_literal_token2] = ACTIONS(1343),
    [anon_sym_L_SQUOTE] = ACTIONS(1346),
    [anon_sym_u_SQUOTE] = ACTIONS(1346),
    [anon_sym_U_SQUOTE] = ACTIONS(1346),
    [anon_sym_u8_SQUOTE] = ACTIONS(1346),
    [anon_sym_SQUOTE] = ACTIONS(1346),
    [anon_sym_L_DQUOTE] = ACTIONS(1349),
    [anon_sym_u_DQUOTE] = ACTIONS(1349),
    [anon_sym_U_DQUOTE] = ACTIONS(1349),
    [anon_sym_u8_DQUOTE] = ACTIONS(1349),
    [anon_sym_DQUOTE] = ACTIONS(1349),
    [sym_true] = ACTIONS(1352),
    [sym_false] = ACTIONS(1352),
    [anon_sym_NULL] = ACTIONS(1355),
    [anon_sym_nullptr] = ACTIONS(1355),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1358),
    [anon_sym_decltype] = ACTIONS(1361),
    [anon_sym_virtual] = ACTIONS(1364),
    [anon_sym_alignas] = ACTIONS(1367),
    [anon_sym_explicit] = ACTIONS(1219),
    [anon_sym_typename] = ACTIONS(1370),
    [anon_sym_template] = ACTIONS(1373),
    [anon_sym_operator] = ACTIONS(1219),
    [anon_sym_try] = ACTIONS(1553),
    [anon_sym_delete] = ACTIONS(1379),
    [anon_sym_throw] = ACTIONS(1556),
    [anon_sym_namespace] = ACTIONS(1219),
    [anon_sym_using] = ACTIONS(1219),
    [anon_sym_static_assert] = ACTIONS(1219),
    [anon_sym_concept] = ACTIONS(1219),
    [anon_sym_co_return] = ACTIONS(1559),
    [anon_sym_co_yield] = ACTIONS(1562),
    [anon_sym_R_DQUOTE] = ACTIONS(1391),
    [anon_sym_LR_DQUOTE] = ACTIONS(1391),
    [anon_sym_uR_DQUOTE] = ACTIONS(1391),
    [anon_sym_UR_DQUOTE] = ACTIONS(1391),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1391),
    [anon_sym_co_await] = ACTIONS(1394),
    [anon_sym_new] = ACTIONS(1397),
    [anon_sym_requires] = ACTIONS(1400),
    [sym_this] = ACTIONS(1352),
  },
  [96] = {
    [sym_declaration] = STATE(95),
    [sym_type_definition] = STATE(95),
    [sym__declaration_modifiers] = STATE(1964),
    [sym__declaration_specifiers] = STATE(5030),
    [sym_attribute_specifier] = STATE(1964),
    [sym_attribute_declaration] = STATE(973),
    [sym_ms_declspec_modifier] = STATE(1964),
    [sym_compound_statement] = STATE(95),
    [sym_storage_class_specifier] = STATE(1964),
    [sym_type_qualifier] = STATE(1964),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(95),
    [sym_labeled_statement] = STATE(95),
    [sym_expression_statement] = STATE(95),
    [sym_if_statement] = STATE(95),
    [sym_switch_statement] = STATE(95),
    [sym_while_statement] = STATE(95),
    [sym_do_statement] = STATE(95),
    [sym_for_statement] = STATE(95),
    [sym_return_statement] = STATE(95),
    [sym_break_statement] = STATE(95),
    [sym_continue_statement] = STATE(95),
    [sym_goto_statement] = STATE(95),
    [sym_seh_try_statement] = STATE(95),
    [sym_seh_leave_statement] = STATE(95),
    [sym__expression] = STATE(4447),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8027),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(1964),
    [sym_alignas_specifier] = STATE(1964),
    [sym_dependent_type] = STATE(2629),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(95),
    [sym_co_return_statement] = STATE(95),
    [sym_co_yield_statement] = STATE(95),
    [sym_throw_statement] = STATE(95),
    [sym_try_statement] = STATE(95),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5552),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(172),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_case_statement_repeat1] = STATE(95),
    [ts_builtin_sym_end] = ACTIONS(1411),
    [sym_identifier] = ACTIONS(1433),
    [aux_sym_preproc_include_token1] = ACTIONS(1405),
    [aux_sym_preproc_def_token1] = ACTIONS(1405),
    [aux_sym_preproc_if_token1] = ACTIONS(1405),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1405),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1405),
    [sym_preproc_directive] = ACTIONS(1405),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1411),
    [anon_sym_AMP] = ACTIONS(1413),
    [anon_sym_SEMI] = ACTIONS(1435),
    [anon_sym___extension__] = ACTIONS(33),
    [anon_sym_typedef] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(1405),
    [anon_sym___cdecl] = ACTIONS(1405),
    [anon_sym___clrcall] = ACTIONS(1405),
    [anon_sym___stdcall] = ACTIONS(1405),
    [anon_sym___fastcall] = ACTIONS(1405),
    [anon_sym___thiscall] = ACTIONS(1405),
    [anon_sym___vectorcall] = ACTIONS(1405),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(73),
    [anon_sym_else] = ACTIONS(1405),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_default] = ACTIONS(1405),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_do] = ACTIONS(83),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_return] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_goto] = ACTIONS(93),
    [anon_sym___try] = ACTIONS(1437),
    [anon_sym___leave] = ACTIONS(1439),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(1405),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_operator] = ACTIONS(1405),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(1405),
    [anon_sym_using] = ACTIONS(1405),
    [anon_sym_static_assert] = ACTIONS(1405),
    [anon_sym_concept] = ACTIONS(1405),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [97] = {
    [sym_declaration] = STATE(97),
    [sym_type_definition] = STATE(97),
    [sym__declaration_modifiers] = STATE(1964),
    [sym__declaration_specifiers] = STATE(5031),
    [sym_attribute_specifier] = STATE(1964),
    [sym_attribute_declaration] = STATE(973),
    [sym_ms_declspec_modifier] = STATE(1964),
    [sym_compound_statement] = STATE(97),
    [sym_storage_class_specifier] = STATE(1964),
    [sym_type_qualifier] = STATE(1964),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(97),
    [sym_labeled_statement] = STATE(97),
    [sym_expression_statement] = STATE(97),
    [sym_if_statement] = STATE(97),
    [sym_switch_statement] = STATE(97),
    [sym_while_statement] = STATE(97),
    [sym_do_statement] = STATE(97),
    [sym_for_statement] = STATE(97),
    [sym_return_statement] = STATE(97),
    [sym_break_statement] = STATE(97),
    [sym_continue_statement] = STATE(97),
    [sym_goto_statement] = STATE(97),
    [sym_seh_try_statement] = STATE(97),
    [sym_seh_leave_statement] = STATE(97),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(1964),
    [sym_alignas_specifier] = STATE(1964),
    [sym_dependent_type] = STATE(2629),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(97),
    [sym_co_return_statement] = STATE(97),
    [sym_co_yield_statement] = STATE(97),
    [sym_throw_statement] = STATE(97),
    [sym_try_statement] = STATE(97),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5552),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_case_statement_repeat1] = STATE(97),
    [sym_identifier] = ACTIONS(1565),
    [aux_sym_preproc_include_token1] = ACTIONS(1219),
    [aux_sym_preproc_def_token1] = ACTIONS(1219),
    [aux_sym_preproc_if_token1] = ACTIONS(1219),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1219),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1219),
    [sym_preproc_directive] = ACTIONS(1219),
    [anon_sym_LPAREN2] = ACTIONS(1221),
    [anon_sym_BANG] = ACTIONS(1224),
    [anon_sym_TILDE] = ACTIONS(1224),
    [anon_sym_DASH] = ACTIONS(1227),
    [anon_sym_PLUS] = ACTIONS(1227),
    [anon_sym_STAR] = ACTIONS(1230),
    [anon_sym_AMP_AMP] = ACTIONS(1233),
    [anon_sym_AMP] = ACTIONS(1235),
    [anon_sym_SEMI] = ACTIONS(1568),
    [anon_sym___extension__] = ACTIONS(1571),
    [anon_sym_typedef] = ACTIONS(1574),
    [anon_sym_extern] = ACTIONS(1247),
    [anon_sym___attribute__] = ACTIONS(1250),
    [anon_sym_COLON_COLON] = ACTIONS(1253),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1256),
    [anon_sym___declspec] = ACTIONS(1259),
    [anon_sym___based] = ACTIONS(1219),
    [anon_sym___cdecl] = ACTIONS(1219),
    [anon_sym___clrcall] = ACTIONS(1219),
    [anon_sym___stdcall] = ACTIONS(1219),
    [anon_sym___fastcall] = ACTIONS(1219),
    [anon_sym___thiscall] = ACTIONS(1219),
    [anon_sym___vectorcall] = ACTIONS(1219),
    [anon_sym_LBRACE] = ACTIONS(1577),
    [anon_sym_RBRACE] = ACTIONS(1233),
    [anon_sym_signed] = ACTIONS(1265),
    [anon_sym_unsigned] = ACTIONS(1265),
    [anon_sym_long] = ACTIONS(1265),
    [anon_sym_short] = ACTIONS(1265),
    [anon_sym_LBRACK] = ACTIONS(1268),
    [anon_sym_static] = ACTIONS(1247),
    [anon_sym_register] = ACTIONS(1247),
    [anon_sym_inline] = ACTIONS(1247),
    [anon_sym___inline] = ACTIONS(1247),
    [anon_sym___inline__] = ACTIONS(1247),
    [anon_sym___forceinline] = ACTIONS(1247),
    [anon_sym_thread_local] = ACTIONS(1247),
    [anon_sym___thread] = ACTIONS(1247),
    [anon_sym_const] = ACTIONS(1271),
    [anon_sym_constexpr] = ACTIONS(1271),
    [anon_sym_volatile] = ACTIONS(1271),
    [anon_sym_restrict] = ACTIONS(1271),
    [anon_sym___restrict__] = ACTIONS(1271),
    [anon_sym__Atomic] = ACTIONS(1271),
    [anon_sym__Noreturn] = ACTIONS(1271),
    [anon_sym_noreturn] = ACTIONS(1271),
    [anon_sym_mutable] = ACTIONS(1271),
    [anon_sym_constinit] = ACTIONS(1271),
    [anon_sym_consteval] = ACTIONS(1271),
    [anon_sym_PROGMEM] = ACTIONS(1271),
    [aux_sym_primitive_type_token1] = ACTIONS(1274),
    [anon_sym_byte] = ACTIONS(1274),
    [anon_sym_word] = ACTIONS(1274),
    [anon_sym_enum] = ACTIONS(1277),
    [anon_sym_class] = ACTIONS(1280),
    [anon_sym_struct] = ACTIONS(1283),
    [anon_sym_union] = ACTIONS(1286),
    [anon_sym_if] = ACTIONS(1580),
    [anon_sym_else] = ACTIONS(1219),
    [anon_sym_switch] = ACTIONS(1583),
    [anon_sym_case] = ACTIONS(1219),
    [anon_sym_default] = ACTIONS(1219),
    [anon_sym_while] = ACTIONS(1586),
    [anon_sym_do] = ACTIONS(1589),
    [anon_sym_for] = ACTIONS(1592),
    [anon_sym_return] = ACTIONS(1595),
    [anon_sym_break] = ACTIONS(1598),
    [anon_sym_continue] = ACTIONS(1601),
    [anon_sym_goto] = ACTIONS(1604),
    [anon_sym___try] = ACTIONS(1607),
    [anon_sym___leave] = ACTIONS(1610),
    [anon_sym_not] = ACTIONS(1227),
    [anon_sym_compl] = ACTIONS(1227),
    [anon_sym_DASH_DASH] = ACTIONS(1322),
    [anon_sym_PLUS_PLUS] = ACTIONS(1322),
    [anon_sym_sizeof] = ACTIONS(1325),
    [anon_sym___alignof__] = ACTIONS(1328),
    [anon_sym___alignof] = ACTIONS(1328),
    [anon_sym__alignof] = ACTIONS(1328),
    [anon_sym_alignof] = ACTIONS(1328),
    [anon_sym__Alignof] = ACTIONS(1328),
    [anon_sym_offsetof] = ACTIONS(1331),
    [anon_sym__Generic] = ACTIONS(1334),
    [anon_sym_asm] = ACTIONS(1337),
    [anon_sym___asm__] = ACTIONS(1337),
    [aux_sym_number_literal_token1] = ACTIONS(1340),
    [aux_sym_number_literal_token2] = ACTIONS(1343),
    [anon_sym_L_SQUOTE] = ACTIONS(1346),
    [anon_sym_u_SQUOTE] = ACTIONS(1346),
    [anon_sym_U_SQUOTE] = ACTIONS(1346),
    [anon_sym_u8_SQUOTE] = ACTIONS(1346),
    [anon_sym_SQUOTE] = ACTIONS(1346),
    [anon_sym_L_DQUOTE] = ACTIONS(1349),
    [anon_sym_u_DQUOTE] = ACTIONS(1349),
    [anon_sym_U_DQUOTE] = ACTIONS(1349),
    [anon_sym_u8_DQUOTE] = ACTIONS(1349),
    [anon_sym_DQUOTE] = ACTIONS(1349),
    [sym_true] = ACTIONS(1352),
    [sym_false] = ACTIONS(1352),
    [anon_sym_NULL] = ACTIONS(1355),
    [anon_sym_nullptr] = ACTIONS(1355),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1358),
    [anon_sym_decltype] = ACTIONS(1361),
    [anon_sym_virtual] = ACTIONS(1364),
    [anon_sym_alignas] = ACTIONS(1367),
    [anon_sym_explicit] = ACTIONS(1219),
    [anon_sym_typename] = ACTIONS(1370),
    [anon_sym_template] = ACTIONS(1373),
    [anon_sym_operator] = ACTIONS(1219),
    [anon_sym_try] = ACTIONS(1613),
    [anon_sym_delete] = ACTIONS(1379),
    [anon_sym_throw] = ACTIONS(1616),
    [anon_sym_namespace] = ACTIONS(1219),
    [anon_sym_using] = ACTIONS(1219),
    [anon_sym_static_assert] = ACTIONS(1219),
    [anon_sym_concept] = ACTIONS(1219),
    [anon_sym_co_return] = ACTIONS(1619),
    [anon_sym_co_yield] = ACTIONS(1622),
    [anon_sym_R_DQUOTE] = ACTIONS(1391),
    [anon_sym_LR_DQUOTE] = ACTIONS(1391),
    [anon_sym_uR_DQUOTE] = ACTIONS(1391),
    [anon_sym_UR_DQUOTE] = ACTIONS(1391),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1391),
    [anon_sym_co_await] = ACTIONS(1394),
    [anon_sym_new] = ACTIONS(1397),
    [anon_sym_requires] = ACTIONS(1400),
    [sym_this] = ACTIONS(1352),
  },
  [98] = {
    [sym_declaration] = STATE(92),
    [sym_type_definition] = STATE(92),
    [sym__declaration_modifiers] = STATE(1964),
    [sym__declaration_specifiers] = STATE(5031),
    [sym_attribute_specifier] = STATE(1964),
    [sym_attribute_declaration] = STATE(973),
    [sym_ms_declspec_modifier] = STATE(1964),
    [sym_compound_statement] = STATE(92),
    [sym_storage_class_specifier] = STATE(1964),
    [sym_type_qualifier] = STATE(1964),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(92),
    [sym_labeled_statement] = STATE(92),
    [sym_expression_statement] = STATE(92),
    [sym_if_statement] = STATE(92),
    [sym_switch_statement] = STATE(92),
    [sym_while_statement] = STATE(92),
    [sym_do_statement] = STATE(92),
    [sym_for_statement] = STATE(92),
    [sym_return_statement] = STATE(92),
    [sym_break_statement] = STATE(92),
    [sym_continue_statement] = STATE(92),
    [sym_goto_statement] = STATE(92),
    [sym_seh_try_statement] = STATE(92),
    [sym_seh_leave_statement] = STATE(92),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(1964),
    [sym_alignas_specifier] = STATE(1964),
    [sym_dependent_type] = STATE(2629),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(92),
    [sym_co_return_statement] = STATE(92),
    [sym_co_yield_statement] = STATE(92),
    [sym_throw_statement] = STATE(92),
    [sym_try_statement] = STATE(92),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5552),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_case_statement_repeat1] = STATE(92),
    [sym_identifier] = ACTIONS(1503),
    [aux_sym_preproc_include_token1] = ACTIONS(1429),
    [aux_sym_preproc_def_token1] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1429),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1429),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1429),
    [sym_preproc_directive] = ACTIONS(1429),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1431),
    [anon_sym_AMP] = ACTIONS(1413),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(1429),
    [anon_sym___cdecl] = ACTIONS(1429),
    [anon_sym___clrcall] = ACTIONS(1429),
    [anon_sym___stdcall] = ACTIONS(1429),
    [anon_sym___fastcall] = ACTIONS(1429),
    [anon_sym___thiscall] = ACTIONS(1429),
    [anon_sym___vectorcall] = ACTIONS(1429),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(1431),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_else] = ACTIONS(1429),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(1429),
    [anon_sym_default] = ACTIONS(1429),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(1429),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_operator] = ACTIONS(1429),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(1429),
    [anon_sym_using] = ACTIONS(1429),
    [anon_sym_static_assert] = ACTIONS(1429),
    [anon_sym_concept] = ACTIONS(1429),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [99] = {
    [sym_declaration] = STATE(89),
    [sym_type_definition] = STATE(89),
    [sym__declaration_modifiers] = STATE(1964),
    [sym__declaration_specifiers] = STATE(5034),
    [sym_attribute_specifier] = STATE(1964),
    [sym_attribute_declaration] = STATE(973),
    [sym_ms_declspec_modifier] = STATE(1964),
    [sym_compound_statement] = STATE(89),
    [sym_storage_class_specifier] = STATE(1964),
    [sym_type_qualifier] = STATE(1964),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(89),
    [sym_labeled_statement] = STATE(89),
    [sym_expression_statement] = STATE(89),
    [sym_if_statement] = STATE(89),
    [sym_switch_statement] = STATE(89),
    [sym_while_statement] = STATE(89),
    [sym_do_statement] = STATE(89),
    [sym_for_statement] = STATE(89),
    [sym_return_statement] = STATE(89),
    [sym_break_statement] = STATE(89),
    [sym_continue_statement] = STATE(89),
    [sym_goto_statement] = STATE(89),
    [sym_seh_try_statement] = STATE(89),
    [sym_seh_leave_statement] = STATE(89),
    [sym__expression] = STATE(4455),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(7649),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(1964),
    [sym_alignas_specifier] = STATE(1964),
    [sym_dependent_type] = STATE(2629),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(89),
    [sym_co_return_statement] = STATE(89),
    [sym_co_yield_statement] = STATE(89),
    [sym_throw_statement] = STATE(89),
    [sym_try_statement] = STATE(89),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5552),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(173),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_case_statement_repeat1] = STATE(89),
    [sym_identifier] = ACTIONS(1441),
    [aux_sym_preproc_include_token1] = ACTIONS(1425),
    [aux_sym_preproc_def_token1] = ACTIONS(1425),
    [aux_sym_preproc_if_token1] = ACTIONS(1425),
    [aux_sym_preproc_if_token2] = ACTIONS(1425),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1425),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1425),
    [sym_preproc_directive] = ACTIONS(1425),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1427),
    [anon_sym_AMP] = ACTIONS(1413),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym___extension__] = ACTIONS(669),
    [anon_sym_typedef] = ACTIONS(671),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(1425),
    [anon_sym___cdecl] = ACTIONS(1425),
    [anon_sym___clrcall] = ACTIONS(1425),
    [anon_sym___stdcall] = ACTIONS(1425),
    [anon_sym___fastcall] = ACTIONS(1425),
    [anon_sym___thiscall] = ACTIONS(1425),
    [anon_sym___vectorcall] = ACTIONS(1425),
    [anon_sym_LBRACE] = ACTIONS(675),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(679),
    [anon_sym_else] = ACTIONS(1425),
    [anon_sym_switch] = ACTIONS(681),
    [anon_sym_case] = ACTIONS(1425),
    [anon_sym_default] = ACTIONS(1425),
    [anon_sym_while] = ACTIONS(687),
    [anon_sym_do] = ACTIONS(689),
    [anon_sym_for] = ACTIONS(691),
    [anon_sym_return] = ACTIONS(693),
    [anon_sym_break] = ACTIONS(695),
    [anon_sym_continue] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym___try] = ACTIONS(701),
    [anon_sym___leave] = ACTIONS(703),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(1425),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_operator] = ACTIONS(1425),
    [anon_sym_try] = ACTIONS(707),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(709),
    [anon_sym_namespace] = ACTIONS(1425),
    [anon_sym_using] = ACTIONS(1425),
    [anon_sym_static_assert] = ACTIONS(1425),
    [anon_sym_concept] = ACTIONS(1425),
    [anon_sym_co_return] = ACTIONS(719),
    [anon_sym_co_yield] = ACTIONS(721),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [100] = {
    [sym_declaration] = STATE(97),
    [sym_type_definition] = STATE(97),
    [sym__declaration_modifiers] = STATE(1964),
    [sym__declaration_specifiers] = STATE(5031),
    [sym_attribute_specifier] = STATE(1964),
    [sym_attribute_declaration] = STATE(973),
    [sym_ms_declspec_modifier] = STATE(1964),
    [sym_compound_statement] = STATE(97),
    [sym_storage_class_specifier] = STATE(1964),
    [sym_type_qualifier] = STATE(1964),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(97),
    [sym_labeled_statement] = STATE(97),
    [sym_expression_statement] = STATE(97),
    [sym_if_statement] = STATE(97),
    [sym_switch_statement] = STATE(97),
    [sym_while_statement] = STATE(97),
    [sym_do_statement] = STATE(97),
    [sym_for_statement] = STATE(97),
    [sym_return_statement] = STATE(97),
    [sym_break_statement] = STATE(97),
    [sym_continue_statement] = STATE(97),
    [sym_goto_statement] = STATE(97),
    [sym_seh_try_statement] = STATE(97),
    [sym_seh_leave_statement] = STATE(97),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(1964),
    [sym_alignas_specifier] = STATE(1964),
    [sym_dependent_type] = STATE(2629),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(97),
    [sym_co_return_statement] = STATE(97),
    [sym_co_yield_statement] = STATE(97),
    [sym_throw_statement] = STATE(97),
    [sym_try_statement] = STATE(97),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5552),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_case_statement_repeat1] = STATE(97),
    [sym_identifier] = ACTIONS(1503),
    [aux_sym_preproc_include_token1] = ACTIONS(1405),
    [aux_sym_preproc_def_token1] = ACTIONS(1405),
    [aux_sym_preproc_if_token1] = ACTIONS(1405),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1405),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1405),
    [sym_preproc_directive] = ACTIONS(1405),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1411),
    [anon_sym_AMP] = ACTIONS(1413),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(1405),
    [anon_sym___cdecl] = ACTIONS(1405),
    [anon_sym___clrcall] = ACTIONS(1405),
    [anon_sym___stdcall] = ACTIONS(1405),
    [anon_sym___fastcall] = ACTIONS(1405),
    [anon_sym___thiscall] = ACTIONS(1405),
    [anon_sym___vectorcall] = ACTIONS(1405),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(1411),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_else] = ACTIONS(1405),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_default] = ACTIONS(1405),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(1405),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_operator] = ACTIONS(1405),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(1405),
    [anon_sym_using] = ACTIONS(1405),
    [anon_sym_static_assert] = ACTIONS(1405),
    [anon_sym_concept] = ACTIONS(1405),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [101] = {
    [sym_declaration] = STATE(96),
    [sym_type_definition] = STATE(96),
    [sym__declaration_modifiers] = STATE(1964),
    [sym__declaration_specifiers] = STATE(5030),
    [sym_attribute_specifier] = STATE(1964),
    [sym_attribute_declaration] = STATE(973),
    [sym_ms_declspec_modifier] = STATE(1964),
    [sym_compound_statement] = STATE(96),
    [sym_storage_class_specifier] = STATE(1964),
    [sym_type_qualifier] = STATE(1964),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(96),
    [sym_labeled_statement] = STATE(96),
    [sym_expression_statement] = STATE(96),
    [sym_if_statement] = STATE(96),
    [sym_switch_statement] = STATE(96),
    [sym_while_statement] = STATE(96),
    [sym_do_statement] = STATE(96),
    [sym_for_statement] = STATE(96),
    [sym_return_statement] = STATE(96),
    [sym_break_statement] = STATE(96),
    [sym_continue_statement] = STATE(96),
    [sym_goto_statement] = STATE(96),
    [sym_seh_try_statement] = STATE(96),
    [sym_seh_leave_statement] = STATE(96),
    [sym__expression] = STATE(4447),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8027),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(1964),
    [sym_alignas_specifier] = STATE(1964),
    [sym_dependent_type] = STATE(2629),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(96),
    [sym_co_return_statement] = STATE(96),
    [sym_co_yield_statement] = STATE(96),
    [sym_throw_statement] = STATE(96),
    [sym_try_statement] = STATE(96),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5552),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(172),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_case_statement_repeat1] = STATE(96),
    [ts_builtin_sym_end] = ACTIONS(1427),
    [sym_identifier] = ACTIONS(1433),
    [aux_sym_preproc_include_token1] = ACTIONS(1425),
    [aux_sym_preproc_def_token1] = ACTIONS(1425),
    [aux_sym_preproc_if_token1] = ACTIONS(1425),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1425),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1425),
    [sym_preproc_directive] = ACTIONS(1425),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP_AMP] = ACTIONS(1427),
    [anon_sym_AMP] = ACTIONS(1413),
    [anon_sym_SEMI] = ACTIONS(1435),
    [anon_sym___extension__] = ACTIONS(33),
    [anon_sym_typedef] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(1425),
    [anon_sym___cdecl] = ACTIONS(1425),
    [anon_sym___clrcall] = ACTIONS(1425),
    [anon_sym___stdcall] = ACTIONS(1425),
    [anon_sym___fastcall] = ACTIONS(1425),
    [anon_sym___thiscall] = ACTIONS(1425),
    [anon_sym___vectorcall] = ACTIONS(1425),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(73),
    [anon_sym_else] = ACTIONS(1425),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_case] = ACTIONS(1425),
    [anon_sym_default] = ACTIONS(1425),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_do] = ACTIONS(83),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_return] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_goto] = ACTIONS(93),
    [anon_sym___try] = ACTIONS(1437),
    [anon_sym___leave] = ACTIONS(1439),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(1425),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_operator] = ACTIONS(1425),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(1425),
    [anon_sym_using] = ACTIONS(1425),
    [anon_sym_static_assert] = ACTIONS(1425),
    [anon_sym_concept] = ACTIONS(1425),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [102] = {
    [sym_declaration] = STATE(105),
    [sym_type_definition] = STATE(105),
    [sym__declaration_modifiers] = STATE(1964),
    [sym__declaration_specifiers] = STATE(5039),
    [sym_attribute_specifier] = STATE(1964),
    [sym_attribute_declaration] = STATE(973),
    [sym_ms_declspec_modifier] = STATE(1964),
    [sym_compound_statement] = STATE(105),
    [sym_storage_class_specifier] = STATE(1964),
    [sym_type_qualifier] = STATE(1964),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(105),
    [sym_labeled_statement] = STATE(105),
    [sym_expression_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_switch_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_do_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_return_statement] = STATE(105),
    [sym_break_statement] = STATE(105),
    [sym_continue_statement] = STATE(105),
    [sym_goto_statement] = STATE(105),
    [sym_seh_try_statement] = STATE(105),
    [sym_seh_leave_statement] = STATE(105),
    [sym__expression] = STATE(4433),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(7776),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(1964),
    [sym_alignas_specifier] = STATE(1964),
    [sym_dependent_type] = STATE(2629),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(105),
    [sym_co_return_statement] = STATE(105),
    [sym_co_yield_statement] = STATE(105),
    [sym_throw_statement] = STATE(105),
    [sym_try_statement] = STATE(105),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5552),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(157),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_case_statement_repeat1] = STATE(105),
    [sym_identifier] = ACTIONS(1625),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym___extension__] = ACTIONS(1629),
    [anon_sym_typedef] = ACTIONS(1631),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(1633),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(1635),
    [anon_sym_else] = ACTIONS(1405),
    [anon_sym_switch] = ACTIONS(1637),
    [anon_sym_while] = ACTIONS(1639),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_for] = ACTIONS(1643),
    [anon_sym_return] = ACTIONS(1645),
    [anon_sym_break] = ACTIONS(1647),
    [anon_sym_continue] = ACTIONS(1649),
    [anon_sym_goto] = ACTIONS(1651),
    [anon_sym___try] = ACTIONS(1653),
    [anon_sym___leave] = ACTIONS(1655),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_try] = ACTIONS(1657),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(1659),
    [anon_sym_co_return] = ACTIONS(1661),
    [anon_sym_co_yield] = ACTIONS(1663),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [103] = {
    [sym_declaration] = STATE(105),
    [sym_type_definition] = STATE(105),
    [sym__declaration_modifiers] = STATE(1964),
    [sym__declaration_specifiers] = STATE(5039),
    [sym_attribute_specifier] = STATE(1964),
    [sym_attribute_declaration] = STATE(973),
    [sym_ms_declspec_modifier] = STATE(1964),
    [sym_compound_statement] = STATE(105),
    [sym_storage_class_specifier] = STATE(1964),
    [sym_type_qualifier] = STATE(1964),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(105),
    [sym_labeled_statement] = STATE(105),
    [sym_expression_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_switch_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_do_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_return_statement] = STATE(105),
    [sym_break_statement] = STATE(105),
    [sym_continue_statement] = STATE(105),
    [sym_goto_statement] = STATE(105),
    [sym_seh_try_statement] = STATE(105),
    [sym_seh_leave_statement] = STATE(105),
    [sym__expression] = STATE(4433),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(7776),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(1964),
    [sym_alignas_specifier] = STATE(1964),
    [sym_dependent_type] = STATE(2629),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(105),
    [sym_co_return_statement] = STATE(105),
    [sym_co_yield_statement] = STATE(105),
    [sym_throw_statement] = STATE(105),
    [sym_try_statement] = STATE(105),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5552),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(157),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_case_statement_repeat1] = STATE(105),
    [sym_identifier] = ACTIONS(1625),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym___extension__] = ACTIONS(1629),
    [anon_sym_typedef] = ACTIONS(1631),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(1633),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(1635),
    [anon_sym_else] = ACTIONS(1421),
    [anon_sym_switch] = ACTIONS(1637),
    [anon_sym_while] = ACTIONS(1639),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_for] = ACTIONS(1643),
    [anon_sym_return] = ACTIONS(1645),
    [anon_sym_break] = ACTIONS(1647),
    [anon_sym_continue] = ACTIONS(1649),
    [anon_sym_goto] = ACTIONS(1651),
    [anon_sym___try] = ACTIONS(1653),
    [anon_sym___leave] = ACTIONS(1655),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_try] = ACTIONS(1657),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(1659),
    [anon_sym_co_return] = ACTIONS(1661),
    [anon_sym_co_yield] = ACTIONS(1663),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [104] = {
    [sym_declaration] = STATE(102),
    [sym_type_definition] = STATE(102),
    [sym__declaration_modifiers] = STATE(1964),
    [sym__declaration_specifiers] = STATE(5039),
    [sym_attribute_specifier] = STATE(1964),
    [sym_attribute_declaration] = STATE(973),
    [sym_ms_declspec_modifier] = STATE(1964),
    [sym_compound_statement] = STATE(102),
    [sym_storage_class_specifier] = STATE(1964),
    [sym_type_qualifier] = STATE(1964),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(102),
    [sym_labeled_statement] = STATE(102),
    [sym_expression_statement] = STATE(102),
    [sym_if_statement] = STATE(102),
    [sym_switch_statement] = STATE(102),
    [sym_while_statement] = STATE(102),
    [sym_do_statement] = STATE(102),
    [sym_for_statement] = STATE(102),
    [sym_return_statement] = STATE(102),
    [sym_break_statement] = STATE(102),
    [sym_continue_statement] = STATE(102),
    [sym_goto_statement] = STATE(102),
    [sym_seh_try_statement] = STATE(102),
    [sym_seh_leave_statement] = STATE(102),
    [sym__expression] = STATE(4433),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(7776),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(1964),
    [sym_alignas_specifier] = STATE(1964),
    [sym_dependent_type] = STATE(2629),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(102),
    [sym_co_return_statement] = STATE(102),
    [sym_co_yield_statement] = STATE(102),
    [sym_throw_statement] = STATE(102),
    [sym_try_statement] = STATE(102),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5552),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(157),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_case_statement_repeat1] = STATE(102),
    [sym_identifier] = ACTIONS(1625),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym___extension__] = ACTIONS(1629),
    [anon_sym_typedef] = ACTIONS(1631),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(1633),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(1635),
    [anon_sym_else] = ACTIONS(1425),
    [anon_sym_switch] = ACTIONS(1637),
    [anon_sym_while] = ACTIONS(1639),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_for] = ACTIONS(1643),
    [anon_sym_return] = ACTIONS(1645),
    [anon_sym_break] = ACTIONS(1647),
    [anon_sym_continue] = ACTIONS(1649),
    [anon_sym_goto] = ACTIONS(1651),
    [anon_sym___try] = ACTIONS(1653),
    [anon_sym___leave] = ACTIONS(1655),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_try] = ACTIONS(1657),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(1659),
    [anon_sym_co_return] = ACTIONS(1661),
    [anon_sym_co_yield] = ACTIONS(1663),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [105] = {
    [sym_declaration] = STATE(105),
    [sym_type_definition] = STATE(105),
    [sym__declaration_modifiers] = STATE(1964),
    [sym__declaration_specifiers] = STATE(5039),
    [sym_attribute_specifier] = STATE(1964),
    [sym_attribute_declaration] = STATE(973),
    [sym_ms_declspec_modifier] = STATE(1964),
    [sym_compound_statement] = STATE(105),
    [sym_storage_class_specifier] = STATE(1964),
    [sym_type_qualifier] = STATE(1964),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(105),
    [sym_labeled_statement] = STATE(105),
    [sym_expression_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_switch_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_do_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_return_statement] = STATE(105),
    [sym_break_statement] = STATE(105),
    [sym_continue_statement] = STATE(105),
    [sym_goto_statement] = STATE(105),
    [sym_seh_try_statement] = STATE(105),
    [sym_seh_leave_statement] = STATE(105),
    [sym__expression] = STATE(4433),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(7776),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(1964),
    [sym_alignas_specifier] = STATE(1964),
    [sym_dependent_type] = STATE(2629),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(105),
    [sym_co_return_statement] = STATE(105),
    [sym_co_yield_statement] = STATE(105),
    [sym_throw_statement] = STATE(105),
    [sym_try_statement] = STATE(105),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5552),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(157),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_case_statement_repeat1] = STATE(105),
    [sym_identifier] = ACTIONS(1665),
    [anon_sym_LPAREN2] = ACTIONS(1221),
    [anon_sym_BANG] = ACTIONS(1224),
    [anon_sym_TILDE] = ACTIONS(1224),
    [anon_sym_DASH] = ACTIONS(1227),
    [anon_sym_PLUS] = ACTIONS(1227),
    [anon_sym_STAR] = ACTIONS(1230),
    [anon_sym_AMP] = ACTIONS(1230),
    [anon_sym_SEMI] = ACTIONS(1668),
    [anon_sym___extension__] = ACTIONS(1671),
    [anon_sym_typedef] = ACTIONS(1674),
    [anon_sym_extern] = ACTIONS(1247),
    [anon_sym___attribute__] = ACTIONS(1250),
    [anon_sym_COLON_COLON] = ACTIONS(1253),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1256),
    [anon_sym___declspec] = ACTIONS(1259),
    [anon_sym_LBRACE] = ACTIONS(1677),
    [anon_sym_signed] = ACTIONS(1265),
    [anon_sym_unsigned] = ACTIONS(1265),
    [anon_sym_long] = ACTIONS(1265),
    [anon_sym_short] = ACTIONS(1265),
    [anon_sym_LBRACK] = ACTIONS(1268),
    [anon_sym_static] = ACTIONS(1247),
    [anon_sym_register] = ACTIONS(1247),
    [anon_sym_inline] = ACTIONS(1247),
    [anon_sym___inline] = ACTIONS(1247),
    [anon_sym___inline__] = ACTIONS(1247),
    [anon_sym___forceinline] = ACTIONS(1247),
    [anon_sym_thread_local] = ACTIONS(1247),
    [anon_sym___thread] = ACTIONS(1247),
    [anon_sym_const] = ACTIONS(1271),
    [anon_sym_constexpr] = ACTIONS(1271),
    [anon_sym_volatile] = ACTIONS(1271),
    [anon_sym_restrict] = ACTIONS(1271),
    [anon_sym___restrict__] = ACTIONS(1271),
    [anon_sym__Atomic] = ACTIONS(1271),
    [anon_sym__Noreturn] = ACTIONS(1271),
    [anon_sym_noreturn] = ACTIONS(1271),
    [anon_sym_mutable] = ACTIONS(1271),
    [anon_sym_constinit] = ACTIONS(1271),
    [anon_sym_consteval] = ACTIONS(1271),
    [anon_sym_PROGMEM] = ACTIONS(1271),
    [aux_sym_primitive_type_token1] = ACTIONS(1274),
    [anon_sym_byte] = ACTIONS(1274),
    [anon_sym_word] = ACTIONS(1274),
    [anon_sym_enum] = ACTIONS(1277),
    [anon_sym_class] = ACTIONS(1280),
    [anon_sym_struct] = ACTIONS(1283),
    [anon_sym_union] = ACTIONS(1286),
    [anon_sym_if] = ACTIONS(1680),
    [anon_sym_else] = ACTIONS(1219),
    [anon_sym_switch] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1686),
    [anon_sym_do] = ACTIONS(1689),
    [anon_sym_for] = ACTIONS(1692),
    [anon_sym_return] = ACTIONS(1695),
    [anon_sym_break] = ACTIONS(1698),
    [anon_sym_continue] = ACTIONS(1701),
    [anon_sym_goto] = ACTIONS(1704),
    [anon_sym___try] = ACTIONS(1707),
    [anon_sym___leave] = ACTIONS(1710),
    [anon_sym_not] = ACTIONS(1227),
    [anon_sym_compl] = ACTIONS(1227),
    [anon_sym_DASH_DASH] = ACTIONS(1322),
    [anon_sym_PLUS_PLUS] = ACTIONS(1322),
    [anon_sym_sizeof] = ACTIONS(1325),
    [anon_sym___alignof__] = ACTIONS(1328),
    [anon_sym___alignof] = ACTIONS(1328),
    [anon_sym__alignof] = ACTIONS(1328),
    [anon_sym_alignof] = ACTIONS(1328),
    [anon_sym__Alignof] = ACTIONS(1328),
    [anon_sym_offsetof] = ACTIONS(1331),
    [anon_sym__Generic] = ACTIONS(1334),
    [anon_sym_asm] = ACTIONS(1337),
    [anon_sym___asm__] = ACTIONS(1337),
    [aux_sym_number_literal_token1] = ACTIONS(1340),
    [aux_sym_number_literal_token2] = ACTIONS(1343),
    [anon_sym_L_SQUOTE] = ACTIONS(1346),
    [anon_sym_u_SQUOTE] = ACTIONS(1346),
    [anon_sym_U_SQUOTE] = ACTIONS(1346),
    [anon_sym_u8_SQUOTE] = ACTIONS(1346),
    [anon_sym_SQUOTE] = ACTIONS(1346),
    [anon_sym_L_DQUOTE] = ACTIONS(1349),
    [anon_sym_u_DQUOTE] = ACTIONS(1349),
    [anon_sym_U_DQUOTE] = ACTIONS(1349),
    [anon_sym_u8_DQUOTE] = ACTIONS(1349),
    [anon_sym_DQUOTE] = ACTIONS(1349),
    [sym_true] = ACTIONS(1352),
    [sym_false] = ACTIONS(1352),
    [anon_sym_NULL] = ACTIONS(1355),
    [anon_sym_nullptr] = ACTIONS(1355),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1358),
    [anon_sym_decltype] = ACTIONS(1361),
    [anon_sym_virtual] = ACTIONS(1364),
    [anon_sym_alignas] = ACTIONS(1367),
    [anon_sym_typename] = ACTIONS(1370),
    [anon_sym_template] = ACTIONS(1373),
    [anon_sym_try] = ACTIONS(1713),
    [anon_sym_delete] = ACTIONS(1379),
    [anon_sym_throw] = ACTIONS(1716),
    [anon_sym_co_return] = ACTIONS(1719),
    [anon_sym_co_yield] = ACTIONS(1722),
    [anon_sym_R_DQUOTE] = ACTIONS(1391),
    [anon_sym_LR_DQUOTE] = ACTIONS(1391),
    [anon_sym_uR_DQUOTE] = ACTIONS(1391),
    [anon_sym_UR_DQUOTE] = ACTIONS(1391),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1391),
    [anon_sym_co_await] = ACTIONS(1394),
    [anon_sym_new] = ACTIONS(1397),
    [anon_sym_requires] = ACTIONS(1400),
    [sym_this] = ACTIONS(1352),
  },
  [106] = {
    [sym_declaration] = STATE(103),
    [sym_type_definition] = STATE(103),
    [sym__declaration_modifiers] = STATE(1964),
    [sym__declaration_specifiers] = STATE(5039),
    [sym_attribute_specifier] = STATE(1964),
    [sym_attribute_declaration] = STATE(973),
    [sym_ms_declspec_modifier] = STATE(1964),
    [sym_compound_statement] = STATE(103),
    [sym_storage_class_specifier] = STATE(1964),
    [sym_type_qualifier] = STATE(1964),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_attributed_statement] = STATE(103),
    [sym_labeled_statement] = STATE(103),
    [sym_expression_statement] = STATE(103),
    [sym_if_statement] = STATE(103),
    [sym_switch_statement] = STATE(103),
    [sym_while_statement] = STATE(103),
    [sym_do_statement] = STATE(103),
    [sym_for_statement] = STATE(103),
    [sym_return_statement] = STATE(103),
    [sym_break_statement] = STATE(103),
    [sym_continue_statement] = STATE(103),
    [sym_goto_statement] = STATE(103),
    [sym_seh_try_statement] = STATE(103),
    [sym_seh_leave_statement] = STATE(103),
    [sym__expression] = STATE(4433),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(7776),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(1964),
    [sym_alignas_specifier] = STATE(1964),
    [sym_dependent_type] = STATE(2629),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(103),
    [sym_co_return_statement] = STATE(103),
    [sym_co_yield_statement] = STATE(103),
    [sym_throw_statement] = STATE(103),
    [sym_try_statement] = STATE(103),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5552),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_attributed_declarator_repeat1] = STATE(157),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_case_statement_repeat1] = STATE(103),
    [sym_identifier] = ACTIONS(1625),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym___extension__] = ACTIONS(1629),
    [anon_sym_typedef] = ACTIONS(1631),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(1633),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(1635),
    [anon_sym_else] = ACTIONS(1429),
    [anon_sym_switch] = ACTIONS(1637),
    [anon_sym_while] = ACTIONS(1639),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_for] = ACTIONS(1643),
    [anon_sym_return] = ACTIONS(1645),
    [anon_sym_break] = ACTIONS(1647),
    [anon_sym_continue] = ACTIONS(1649),
    [anon_sym_goto] = ACTIONS(1651),
    [anon_sym___try] = ACTIONS(1653),
    [anon_sym___leave] = ACTIONS(1655),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_try] = ACTIONS(1657),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(1659),
    [anon_sym_co_return] = ACTIONS(1661),
    [anon_sym_co_yield] = ACTIONS(1663),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [107] = {
    [sym_declaration] = STATE(230),
    [sym_type_definition] = STATE(4081),
    [sym__declaration_modifiers] = STATE(1964),
    [sym__declaration_specifiers] = STATE(5029),
    [sym_attribute_specifier] = STATE(1964),
    [sym_attribute_declaration] = STATE(1964),
    [sym_ms_declspec_modifier] = STATE(1964),
    [sym_storage_class_specifier] = STATE(1964),
    [sym_type_qualifier] = STATE(1964),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_expression_statement] = STATE(4081),
    [sym__for_statement_body] = STATE(7626),
    [sym__expression] = STATE(4457),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(7733),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(1964),
    [sym_alignas_specifier] = STATE(1964),
    [sym_dependent_type] = STATE(2629),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(3950),
    [sym_alias_declaration] = STATE(4081),
    [sym__for_range_loop_body] = STATE(7627),
    [sym_init_statement] = STATE(1837),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5552),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [sym_identifier] = ACTIONS(1725),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1727),
    [anon_sym___extension__] = ACTIONS(1729),
    [anon_sym_typedef] = ACTIONS(1731),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(1735),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [108] = {
    [sym_declaration] = STATE(230),
    [sym_type_definition] = STATE(4081),
    [sym__declaration_modifiers] = STATE(1964),
    [sym__declaration_specifiers] = STATE(5029),
    [sym_attribute_specifier] = STATE(1964),
    [sym_attribute_declaration] = STATE(1964),
    [sym_ms_declspec_modifier] = STATE(1964),
    [sym_storage_class_specifier] = STATE(1964),
    [sym_type_qualifier] = STATE(1964),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_expression_statement] = STATE(4081),
    [sym__for_statement_body] = STATE(7825),
    [sym__expression] = STATE(4457),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(7733),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(1964),
    [sym_alignas_specifier] = STATE(1964),
    [sym_dependent_type] = STATE(2629),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(3950),
    [sym_alias_declaration] = STATE(4081),
    [sym__for_range_loop_body] = STATE(7824),
    [sym_init_statement] = STATE(1837),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5552),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [sym_identifier] = ACTIONS(1725),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1727),
    [anon_sym___extension__] = ACTIONS(1729),
    [anon_sym_typedef] = ACTIONS(1731),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(1735),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [109] = {
    [sym_declaration] = STATE(230),
    [sym_type_definition] = STATE(4081),
    [sym__declaration_modifiers] = STATE(1964),
    [sym__declaration_specifiers] = STATE(5029),
    [sym_attribute_specifier] = STATE(1964),
    [sym_attribute_declaration] = STATE(1964),
    [sym_ms_declspec_modifier] = STATE(1964),
    [sym_storage_class_specifier] = STATE(1964),
    [sym_type_qualifier] = STATE(1964),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_expression_statement] = STATE(4081),
    [sym__for_statement_body] = STATE(7735),
    [sym__expression] = STATE(4457),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(7733),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(1964),
    [sym_alignas_specifier] = STATE(1964),
    [sym_dependent_type] = STATE(2629),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(3950),
    [sym_alias_declaration] = STATE(4081),
    [sym__for_range_loop_body] = STATE(7732),
    [sym_init_statement] = STATE(1837),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5552),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [sym_identifier] = ACTIONS(1725),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1727),
    [anon_sym___extension__] = ACTIONS(1729),
    [anon_sym_typedef] = ACTIONS(1731),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(1735),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [110] = {
    [sym_declaration] = STATE(230),
    [sym_type_definition] = STATE(4081),
    [sym__declaration_modifiers] = STATE(1964),
    [sym__declaration_specifiers] = STATE(5029),
    [sym_attribute_specifier] = STATE(1964),
    [sym_attribute_declaration] = STATE(1964),
    [sym_ms_declspec_modifier] = STATE(1964),
    [sym_storage_class_specifier] = STATE(1964),
    [sym_type_qualifier] = STATE(1964),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_expression_statement] = STATE(4081),
    [sym__for_statement_body] = STATE(7725),
    [sym__expression] = STATE(4457),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(7733),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(1964),
    [sym_alignas_specifier] = STATE(1964),
    [sym_dependent_type] = STATE(2629),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(3950),
    [sym_alias_declaration] = STATE(4081),
    [sym__for_range_loop_body] = STATE(7726),
    [sym_init_statement] = STATE(1837),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5552),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [sym_identifier] = ACTIONS(1725),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1727),
    [anon_sym___extension__] = ACTIONS(1729),
    [anon_sym_typedef] = ACTIONS(1731),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(1735),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [111] = {
    [sym_declaration] = STATE(230),
    [sym_type_definition] = STATE(4081),
    [sym__declaration_modifiers] = STATE(1964),
    [sym__declaration_specifiers] = STATE(5029),
    [sym_attribute_specifier] = STATE(1964),
    [sym_attribute_declaration] = STATE(1964),
    [sym_ms_declspec_modifier] = STATE(1964),
    [sym_storage_class_specifier] = STATE(1964),
    [sym_type_qualifier] = STATE(1964),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_expression_statement] = STATE(4081),
    [sym__for_statement_body] = STATE(7764),
    [sym__expression] = STATE(4457),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(7733),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(1964),
    [sym_alignas_specifier] = STATE(1964),
    [sym_dependent_type] = STATE(2629),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(3950),
    [sym_alias_declaration] = STATE(4081),
    [sym__for_range_loop_body] = STATE(7761),
    [sym_init_statement] = STATE(1837),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5552),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [sym_identifier] = ACTIONS(1725),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1727),
    [anon_sym___extension__] = ACTIONS(1729),
    [anon_sym_typedef] = ACTIONS(1731),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(1735),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [112] = {
    [sym_declaration] = STATE(230),
    [sym_type_definition] = STATE(4081),
    [sym__declaration_modifiers] = STATE(1964),
    [sym__declaration_specifiers] = STATE(5029),
    [sym_attribute_specifier] = STATE(1964),
    [sym_attribute_declaration] = STATE(1964),
    [sym_ms_declspec_modifier] = STATE(1964),
    [sym_storage_class_specifier] = STATE(1964),
    [sym_type_qualifier] = STATE(1964),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_expression_statement] = STATE(4081),
    [sym__for_statement_body] = STATE(7611),
    [sym__expression] = STATE(4457),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(7733),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(1964),
    [sym_alignas_specifier] = STATE(1964),
    [sym_dependent_type] = STATE(2629),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(3950),
    [sym_alias_declaration] = STATE(4081),
    [sym__for_range_loop_body] = STATE(7615),
    [sym_init_statement] = STATE(1837),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5552),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [sym_identifier] = ACTIONS(1725),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1727),
    [anon_sym___extension__] = ACTIONS(1729),
    [anon_sym_typedef] = ACTIONS(1731),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(1735),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [113] = {
    [sym_declaration] = STATE(1696),
    [sym_type_definition] = STATE(1696),
    [sym__declaration_modifiers] = STATE(1964),
    [sym__declaration_specifiers] = STATE(5032),
    [sym_attribute_specifier] = STATE(1964),
    [sym_attribute_declaration] = STATE(1964),
    [sym_ms_declspec_modifier] = STATE(1964),
    [sym_storage_class_specifier] = STATE(1964),
    [sym_type_qualifier] = STATE(1964),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_expression_statement] = STATE(1696),
    [sym__expression] = STATE(4253),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(7422),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(1964),
    [sym_alignas_specifier] = STATE(1964),
    [sym_dependent_type] = STATE(2629),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(3950),
    [sym_alias_declaration] = STATE(1696),
    [sym_init_statement] = STATE(124),
    [sym_condition_declaration] = STATE(7748),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5552),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [sym_identifier] = ACTIONS(1725),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym___extension__] = ACTIONS(1629),
    [anon_sym_typedef] = ACTIONS(1631),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(1737),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [114] = {
    [sym__declaration_modifiers] = STATE(1967),
    [sym__declaration_specifiers] = STATE(4118),
    [sym_attribute_specifier] = STATE(1967),
    [sym_attribute_declaration] = STATE(1967),
    [sym_ms_declspec_modifier] = STATE(1967),
    [sym_storage_class_specifier] = STATE(1967),
    [sym_type_qualifier] = STATE(1967),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(3294),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_parameter_declaration] = STATE(6870),
    [sym__expression] = STATE(3252),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7464),
    [sym_virtual] = STATE(1967),
    [sym_alignas_specifier] = STATE(1967),
    [sym_dependent_type] = STATE(2629),
    [sym_optional_parameter_declaration] = STATE(6870),
    [sym_variadic_parameter_declaration] = STATE(6870),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym__unary_left_fold] = STATE(7751),
    [sym__unary_right_fold] = STATE(7755),
    [sym__binary_fold] = STATE(7758),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5519),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_user_defined_literal] = STATE(3374),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1967),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [sym_identifier] = ACTIONS(1739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1741),
    [anon_sym_RPAREN] = ACTIONS(1743),
    [anon_sym_LPAREN2] = ACTIONS(1745),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(1755),
    [anon_sym_class] = ACTIONS(1757),
    [anon_sym_struct] = ACTIONS(1759),
    [anon_sym_union] = ACTIONS(1761),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(1787),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [115] = {
    [sym__declaration_modifiers] = STATE(1967),
    [sym__declaration_specifiers] = STATE(4118),
    [sym_attribute_specifier] = STATE(1967),
    [sym_attribute_declaration] = STATE(1967),
    [sym_ms_declspec_modifier] = STATE(1967),
    [sym_storage_class_specifier] = STATE(1967),
    [sym_type_qualifier] = STATE(1967),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(3294),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_parameter_declaration] = STATE(6870),
    [sym__expression] = STATE(3250),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7464),
    [sym_virtual] = STATE(1967),
    [sym_alignas_specifier] = STATE(1967),
    [sym_dependent_type] = STATE(2629),
    [sym_optional_parameter_declaration] = STATE(6870),
    [sym_variadic_parameter_declaration] = STATE(6870),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym__unary_left_fold] = STATE(8124),
    [sym__unary_right_fold] = STATE(8123),
    [sym__binary_fold] = STATE(8122),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5519),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_user_defined_literal] = STATE(3374),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1967),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [sym_identifier] = ACTIONS(1739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1741),
    [anon_sym_RPAREN] = ACTIONS(1743),
    [anon_sym_LPAREN2] = ACTIONS(1745),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(1755),
    [anon_sym_class] = ACTIONS(1757),
    [anon_sym_struct] = ACTIONS(1759),
    [anon_sym_union] = ACTIONS(1761),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(1787),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [116] = {
    [sym__declaration_modifiers] = STATE(1967),
    [sym__declaration_specifiers] = STATE(4118),
    [sym_attribute_specifier] = STATE(1967),
    [sym_attribute_declaration] = STATE(1967),
    [sym_ms_declspec_modifier] = STATE(1967),
    [sym_storage_class_specifier] = STATE(1967),
    [sym_type_qualifier] = STATE(1967),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(3294),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_parameter_declaration] = STATE(6870),
    [sym__expression] = STATE(3195),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7464),
    [sym_virtual] = STATE(1967),
    [sym_alignas_specifier] = STATE(1967),
    [sym_dependent_type] = STATE(2629),
    [sym_optional_parameter_declaration] = STATE(6870),
    [sym_variadic_parameter_declaration] = STATE(6870),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym__unary_left_fold] = STATE(7683),
    [sym__unary_right_fold] = STATE(7679),
    [sym__binary_fold] = STATE(7678),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5519),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_user_defined_literal] = STATE(3374),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1967),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [sym_identifier] = ACTIONS(1739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1741),
    [anon_sym_RPAREN] = ACTIONS(1743),
    [anon_sym_LPAREN2] = ACTIONS(1745),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(1755),
    [anon_sym_class] = ACTIONS(1757),
    [anon_sym_struct] = ACTIONS(1759),
    [anon_sym_union] = ACTIONS(1761),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(1787),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [117] = {
    [sym__declaration_modifiers] = STATE(1967),
    [sym__declaration_specifiers] = STATE(4118),
    [sym_attribute_specifier] = STATE(1967),
    [sym_attribute_declaration] = STATE(1967),
    [sym_ms_declspec_modifier] = STATE(1967),
    [sym_compound_statement] = STATE(7238),
    [sym_storage_class_specifier] = STATE(1967),
    [sym_type_qualifier] = STATE(1967),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_parameter_declaration] = STATE(6918),
    [sym__expression] = STATE(4232),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(7238),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(1967),
    [sym_alignas_specifier] = STATE(1967),
    [sym_dependent_type] = STATE(2629),
    [sym_optional_parameter_declaration] = STATE(6918),
    [sym_variadic_parameter_declaration] = STATE(6918),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5513),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1967),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [sym_identifier] = ACTIONS(1799),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1801),
    [anon_sym_RPAREN] = ACTIONS(1803),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym___extension__] = ACTIONS(1805),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(1807),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(1755),
    [anon_sym_class] = ACTIONS(1757),
    [anon_sym_struct] = ACTIONS(1759),
    [anon_sym_union] = ACTIONS(1761),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(1787),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [118] = {
    [sym__declaration_modifiers] = STATE(1967),
    [sym__declaration_specifiers] = STATE(4118),
    [sym_attribute_specifier] = STATE(1967),
    [sym_attribute_declaration] = STATE(1967),
    [sym_ms_declspec_modifier] = STATE(1967),
    [sym_storage_class_specifier] = STATE(1967),
    [sym_type_qualifier] = STATE(1967),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(3294),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_parameter_declaration] = STATE(6870),
    [sym__expression] = STATE(3203),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7464),
    [sym_virtual] = STATE(1967),
    [sym_alignas_specifier] = STATE(1967),
    [sym_dependent_type] = STATE(2629),
    [sym_optional_parameter_declaration] = STATE(6870),
    [sym_variadic_parameter_declaration] = STATE(6870),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym__unary_left_fold] = STATE(8289),
    [sym__unary_right_fold] = STATE(8288),
    [sym__binary_fold] = STATE(8287),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5519),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_user_defined_literal] = STATE(3374),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1967),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [sym_identifier] = ACTIONS(1739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1741),
    [anon_sym_RPAREN] = ACTIONS(1743),
    [anon_sym_LPAREN2] = ACTIONS(1745),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(1755),
    [anon_sym_class] = ACTIONS(1757),
    [anon_sym_struct] = ACTIONS(1759),
    [anon_sym_union] = ACTIONS(1761),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(1787),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [119] = {
    [sym__declaration_modifiers] = STATE(1967),
    [sym__declaration_specifiers] = STATE(4118),
    [sym_attribute_specifier] = STATE(1967),
    [sym_attribute_declaration] = STATE(1967),
    [sym_ms_declspec_modifier] = STATE(1967),
    [sym_storage_class_specifier] = STATE(1967),
    [sym_type_qualifier] = STATE(1967),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(3294),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_parameter_declaration] = STATE(6870),
    [sym__expression] = STATE(3212),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7464),
    [sym_virtual] = STATE(1967),
    [sym_alignas_specifier] = STATE(1967),
    [sym_dependent_type] = STATE(2629),
    [sym_optional_parameter_declaration] = STATE(6870),
    [sym_variadic_parameter_declaration] = STATE(6870),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym__unary_left_fold] = STATE(8050),
    [sym__unary_right_fold] = STATE(8049),
    [sym__binary_fold] = STATE(8048),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5519),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_user_defined_literal] = STATE(3374),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1967),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [sym_identifier] = ACTIONS(1739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1741),
    [anon_sym_RPAREN] = ACTIONS(1743),
    [anon_sym_LPAREN2] = ACTIONS(1745),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(1755),
    [anon_sym_class] = ACTIONS(1757),
    [anon_sym_struct] = ACTIONS(1759),
    [anon_sym_union] = ACTIONS(1761),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(1787),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [120] = {
    [sym__declaration_modifiers] = STATE(1967),
    [sym__declaration_specifiers] = STATE(4118),
    [sym_attribute_specifier] = STATE(1967),
    [sym_attribute_declaration] = STATE(1967),
    [sym_ms_declspec_modifier] = STATE(1967),
    [sym_storage_class_specifier] = STATE(1967),
    [sym_type_qualifier] = STATE(1967),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(3294),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_parameter_declaration] = STATE(6870),
    [sym__expression] = STATE(3352),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7464),
    [sym_virtual] = STATE(1967),
    [sym_alignas_specifier] = STATE(1967),
    [sym_dependent_type] = STATE(2629),
    [sym_optional_parameter_declaration] = STATE(6870),
    [sym_variadic_parameter_declaration] = STATE(6870),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym__unary_left_fold] = STATE(8307),
    [sym__unary_right_fold] = STATE(7922),
    [sym__binary_fold] = STATE(8399),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5519),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_user_defined_literal] = STATE(3374),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1967),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [sym_identifier] = ACTIONS(1739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1741),
    [anon_sym_RPAREN] = ACTIONS(1743),
    [anon_sym_LPAREN2] = ACTIONS(1745),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(1755),
    [anon_sym_class] = ACTIONS(1757),
    [anon_sym_struct] = ACTIONS(1759),
    [anon_sym_union] = ACTIONS(1761),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(1787),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [121] = {
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(5130),
    [sym__declarator] = STATE(6389),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6098),
    [sym_array_declarator] = STATE(6098),
    [sym_type_qualifier] = STATE(3883),
    [sym__type_specifier] = STATE(4794),
    [sym_sized_type_specifier] = STATE(1990),
    [sym_primitive_type] = STATE(5089),
    [sym_enum_specifier] = STATE(1990),
    [sym_struct_specifier] = STATE(1990),
    [sym_union_specifier] = STATE(1990),
    [sym__expression] = STATE(2894),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_comma_expression] = STATE(8054),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_type_descriptor] = STATE(7944),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_placeholder_type_specifier] = STATE(1990),
    [sym_decltype_auto] = STATE(1973),
    [sym_decltype] = STATE(1874),
    [sym_class_specifier] = STATE(1990),
    [sym__class_name] = STATE(7357),
    [sym_dependent_type] = STATE(1990),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(5228),
    [sym_template_function] = STATE(3242),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym__unary_left_fold] = STATE(8050),
    [sym__unary_right_fold] = STATE(8049),
    [sym__binary_fold] = STATE(8048),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5520),
    [sym_qualified_identifier] = STATE(3247),
    [sym_qualified_type_identifier] = STATE(5253),
    [sym__assignment_expression_lhs] = STATE(8047),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3526),
    [aux_sym__type_definition_type_repeat1] = STATE(3883),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1898),
    [sym_identifier] = ACTIONS(1809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1741),
    [anon_sym_LPAREN2] = ACTIONS(1811),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1815),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(1821),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(1825),
    [anon_sym___clrcall] = ACTIONS(1825),
    [anon_sym___stdcall] = ACTIONS(1825),
    [anon_sym___fastcall] = ACTIONS(1825),
    [anon_sym___thiscall] = ACTIONS(1825),
    [anon_sym___vectorcall] = ACTIONS(1825),
    [anon_sym_signed] = ACTIONS(1827),
    [anon_sym_unsigned] = ACTIONS(1827),
    [anon_sym_long] = ACTIONS(1827),
    [anon_sym_short] = ACTIONS(1827),
    [anon_sym_LBRACK] = ACTIONS(1829),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(1831),
    [anon_sym_byte] = ACTIONS(1831),
    [anon_sym_word] = ACTIONS(1831),
    [anon_sym_enum] = ACTIONS(1833),
    [anon_sym_class] = ACTIONS(1835),
    [anon_sym_struct] = ACTIONS(1837),
    [anon_sym_union] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1865),
    [anon_sym_decltype] = ACTIONS(1867),
    [anon_sym_typename] = ACTIONS(1869),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_operator] = ACTIONS(1871),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [122] = {
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(5130),
    [sym__declarator] = STATE(6389),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6098),
    [sym_array_declarator] = STATE(6098),
    [sym_type_qualifier] = STATE(3883),
    [sym__type_specifier] = STATE(4794),
    [sym_sized_type_specifier] = STATE(1990),
    [sym_primitive_type] = STATE(5089),
    [sym_enum_specifier] = STATE(1990),
    [sym_struct_specifier] = STATE(1990),
    [sym_union_specifier] = STATE(1990),
    [sym__expression] = STATE(2960),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_comma_expression] = STATE(8291),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_type_descriptor] = STATE(8180),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_placeholder_type_specifier] = STATE(1990),
    [sym_decltype_auto] = STATE(1973),
    [sym_decltype] = STATE(1874),
    [sym_class_specifier] = STATE(1990),
    [sym__class_name] = STATE(7357),
    [sym_dependent_type] = STATE(1990),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(5228),
    [sym_template_function] = STATE(3242),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym__unary_left_fold] = STATE(8289),
    [sym__unary_right_fold] = STATE(8288),
    [sym__binary_fold] = STATE(8287),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5520),
    [sym_qualified_identifier] = STATE(3247),
    [sym_qualified_type_identifier] = STATE(5253),
    [sym__assignment_expression_lhs] = STATE(8285),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3526),
    [aux_sym__type_definition_type_repeat1] = STATE(3883),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1898),
    [sym_identifier] = ACTIONS(1809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1741),
    [anon_sym_LPAREN2] = ACTIONS(1811),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1815),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(1821),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(1825),
    [anon_sym___clrcall] = ACTIONS(1825),
    [anon_sym___stdcall] = ACTIONS(1825),
    [anon_sym___fastcall] = ACTIONS(1825),
    [anon_sym___thiscall] = ACTIONS(1825),
    [anon_sym___vectorcall] = ACTIONS(1825),
    [anon_sym_signed] = ACTIONS(1827),
    [anon_sym_unsigned] = ACTIONS(1827),
    [anon_sym_long] = ACTIONS(1827),
    [anon_sym_short] = ACTIONS(1827),
    [anon_sym_LBRACK] = ACTIONS(1829),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(1831),
    [anon_sym_byte] = ACTIONS(1831),
    [anon_sym_word] = ACTIONS(1831),
    [anon_sym_enum] = ACTIONS(1833),
    [anon_sym_class] = ACTIONS(1835),
    [anon_sym_struct] = ACTIONS(1837),
    [anon_sym_union] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1865),
    [anon_sym_decltype] = ACTIONS(1867),
    [anon_sym_typename] = ACTIONS(1869),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_operator] = ACTIONS(1871),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [123] = {
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(5130),
    [sym__declarator] = STATE(6389),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6098),
    [sym_array_declarator] = STATE(6098),
    [sym_type_qualifier] = STATE(3883),
    [sym__type_specifier] = STATE(4794),
    [sym_sized_type_specifier] = STATE(1990),
    [sym_primitive_type] = STATE(5089),
    [sym_enum_specifier] = STATE(1990),
    [sym_struct_specifier] = STATE(1990),
    [sym_union_specifier] = STATE(1990),
    [sym__expression] = STATE(2960),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_comma_expression] = STATE(8291),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_type_descriptor] = STATE(8416),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_placeholder_type_specifier] = STATE(1990),
    [sym_decltype_auto] = STATE(1973),
    [sym_decltype] = STATE(1874),
    [sym_class_specifier] = STATE(1990),
    [sym__class_name] = STATE(7357),
    [sym_dependent_type] = STATE(1990),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(5228),
    [sym_template_function] = STATE(3242),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym__unary_left_fold] = STATE(8307),
    [sym__unary_right_fold] = STATE(7922),
    [sym__binary_fold] = STATE(8399),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5520),
    [sym_qualified_identifier] = STATE(3247),
    [sym_qualified_type_identifier] = STATE(5253),
    [sym__assignment_expression_lhs] = STATE(8285),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3526),
    [aux_sym__type_definition_type_repeat1] = STATE(3883),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1898),
    [sym_identifier] = ACTIONS(1809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1741),
    [anon_sym_LPAREN2] = ACTIONS(1811),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1815),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(1821),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(1825),
    [anon_sym___clrcall] = ACTIONS(1825),
    [anon_sym___stdcall] = ACTIONS(1825),
    [anon_sym___fastcall] = ACTIONS(1825),
    [anon_sym___thiscall] = ACTIONS(1825),
    [anon_sym___vectorcall] = ACTIONS(1825),
    [anon_sym_signed] = ACTIONS(1827),
    [anon_sym_unsigned] = ACTIONS(1827),
    [anon_sym_long] = ACTIONS(1827),
    [anon_sym_short] = ACTIONS(1827),
    [anon_sym_LBRACK] = ACTIONS(1829),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(1831),
    [anon_sym_byte] = ACTIONS(1831),
    [anon_sym_word] = ACTIONS(1831),
    [anon_sym_enum] = ACTIONS(1833),
    [anon_sym_class] = ACTIONS(1835),
    [anon_sym_struct] = ACTIONS(1837),
    [anon_sym_union] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1865),
    [anon_sym_decltype] = ACTIONS(1867),
    [anon_sym_typename] = ACTIONS(1869),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_operator] = ACTIONS(1871),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [124] = {
    [sym__declaration_modifiers] = STATE(1964),
    [sym__declaration_specifiers] = STATE(5159),
    [sym_attribute_specifier] = STATE(1964),
    [sym_attribute_declaration] = STATE(1964),
    [sym_ms_declspec_modifier] = STATE(1964),
    [sym_storage_class_specifier] = STATE(1964),
    [sym_type_qualifier] = STATE(1964),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2630),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym__expression] = STATE(4385),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8391),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7505),
    [sym_virtual] = STATE(1964),
    [sym_alignas_specifier] = STATE(1964),
    [sym_dependent_type] = STATE(2629),
    [sym_template_type] = STATE(3230),
    [sym_template_function] = STATE(3950),
    [sym_condition_declaration] = STATE(8391),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5552),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(3207),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [sym_identifier] = ACTIONS(1725),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [125] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2464),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_initializer_list] = STATE(2567),
    [sym_number_literal] = STATE(2832),
    [sym_char_literal] = STATE(2832),
    [sym_concatenated_string] = STATE(2831),
    [sym_string_literal] = STATE(1997),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(1998),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1883),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1885),
    [anon_sym_COMMA] = ACTIONS(1885),
    [aux_sym_preproc_if_token2] = ACTIONS(1885),
    [aux_sym_preproc_else_token1] = ACTIONS(1885),
    [aux_sym_preproc_elif_token1] = ACTIONS(1883),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1885),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1885),
    [anon_sym_LPAREN2] = ACTIONS(1885),
    [anon_sym_BANG] = ACTIONS(1887),
    [anon_sym_TILDE] = ACTIONS(1889),
    [anon_sym_DASH] = ACTIONS(1883),
    [anon_sym_PLUS] = ACTIONS(1883),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_SLASH] = ACTIONS(1883),
    [anon_sym_PERCENT] = ACTIONS(1883),
    [anon_sym_PIPE_PIPE] = ACTIONS(1885),
    [anon_sym_AMP_AMP] = ACTIONS(1885),
    [anon_sym_PIPE] = ACTIONS(1883),
    [anon_sym_CARET] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym_EQ_EQ] = ACTIONS(1885),
    [anon_sym_BANG_EQ] = ACTIONS(1885),
    [anon_sym_GT] = ACTIONS(1883),
    [anon_sym_GT_EQ] = ACTIONS(1885),
    [anon_sym_LT_EQ] = ACTIONS(1883),
    [anon_sym_LT] = ACTIONS(1883),
    [anon_sym_LT_LT] = ACTIONS(1883),
    [anon_sym_GT_GT] = ACTIONS(1883),
    [anon_sym_COLON_COLON] = ACTIONS(1891),
    [anon_sym_LBRACE] = ACTIONS(1893),
    [anon_sym_LBRACK] = ACTIONS(1885),
    [anon_sym_EQ] = ACTIONS(1883),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_QMARK] = ACTIONS(1885),
    [anon_sym_STAR_EQ] = ACTIONS(1885),
    [anon_sym_SLASH_EQ] = ACTIONS(1885),
    [anon_sym_PERCENT_EQ] = ACTIONS(1885),
    [anon_sym_PLUS_EQ] = ACTIONS(1885),
    [anon_sym_DASH_EQ] = ACTIONS(1885),
    [anon_sym_LT_LT_EQ] = ACTIONS(1885),
    [anon_sym_GT_GT_EQ] = ACTIONS(1885),
    [anon_sym_AMP_EQ] = ACTIONS(1885),
    [anon_sym_CARET_EQ] = ACTIONS(1885),
    [anon_sym_PIPE_EQ] = ACTIONS(1885),
    [anon_sym_and_eq] = ACTIONS(1883),
    [anon_sym_or_eq] = ACTIONS(1883),
    [anon_sym_xor_eq] = ACTIONS(1883),
    [anon_sym_not] = ACTIONS(1887),
    [anon_sym_compl] = ACTIONS(1887),
    [anon_sym_LT_EQ_GT] = ACTIONS(1885),
    [anon_sym_or] = ACTIONS(1883),
    [anon_sym_and] = ACTIONS(1883),
    [anon_sym_bitor] = ACTIONS(1883),
    [anon_sym_xor] = ACTIONS(1883),
    [anon_sym_bitand] = ACTIONS(1883),
    [anon_sym_not_eq] = ACTIONS(1883),
    [anon_sym_DASH_DASH] = ACTIONS(1885),
    [anon_sym_PLUS_PLUS] = ACTIONS(1885),
    [anon_sym_sizeof] = ACTIONS(1895),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [anon_sym_DOT] = ACTIONS(1883),
    [anon_sym_DOT_STAR] = ACTIONS(1885),
    [anon_sym_DASH_GT] = ACTIONS(1885),
    [aux_sym_number_literal_token1] = ACTIONS(1905),
    [aux_sym_number_literal_token2] = ACTIONS(1907),
    [anon_sym_L_SQUOTE] = ACTIONS(1909),
    [anon_sym_u_SQUOTE] = ACTIONS(1909),
    [anon_sym_U_SQUOTE] = ACTIONS(1909),
    [anon_sym_u8_SQUOTE] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(1909),
    [anon_sym_L_DQUOTE] = ACTIONS(1911),
    [anon_sym_u_DQUOTE] = ACTIONS(1911),
    [anon_sym_U_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8_DQUOTE] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(1911),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1919),
    [anon_sym_R_DQUOTE] = ACTIONS(1921),
    [anon_sym_LR_DQUOTE] = ACTIONS(1921),
    [anon_sym_uR_DQUOTE] = ACTIONS(1921),
    [anon_sym_UR_DQUOTE] = ACTIONS(1921),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1921),
    [anon_sym_co_await] = ACTIONS(1923),
    [anon_sym_new] = ACTIONS(1925),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [126] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2464),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_initializer_list] = STATE(2567),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1885),
    [anon_sym_COMMA] = ACTIONS(1885),
    [anon_sym_RPAREN] = ACTIONS(1885),
    [anon_sym_LPAREN2] = ACTIONS(1885),
    [anon_sym_BANG] = ACTIONS(1931),
    [anon_sym_TILDE] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1883),
    [anon_sym_PLUS] = ACTIONS(1883),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_SLASH] = ACTIONS(1883),
    [anon_sym_PERCENT] = ACTIONS(1883),
    [anon_sym_PIPE_PIPE] = ACTIONS(1885),
    [anon_sym_AMP_AMP] = ACTIONS(1885),
    [anon_sym_PIPE] = ACTIONS(1883),
    [anon_sym_CARET] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym_EQ_EQ] = ACTIONS(1885),
    [anon_sym_BANG_EQ] = ACTIONS(1885),
    [anon_sym_GT] = ACTIONS(1883),
    [anon_sym_GT_EQ] = ACTIONS(1885),
    [anon_sym_LT_EQ] = ACTIONS(1883),
    [anon_sym_LT] = ACTIONS(1883),
    [anon_sym_LT_LT] = ACTIONS(1883),
    [anon_sym_GT_GT] = ACTIONS(1883),
    [anon_sym_SEMI] = ACTIONS(1885),
    [anon_sym_COLON_COLON] = ACTIONS(1935),
    [anon_sym_LBRACE] = ACTIONS(1893),
    [anon_sym_RBRACE] = ACTIONS(1885),
    [anon_sym_LBRACK] = ACTIONS(1885),
    [anon_sym_RBRACK] = ACTIONS(1885),
    [anon_sym_EQ] = ACTIONS(1883),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_QMARK] = ACTIONS(1885),
    [anon_sym_STAR_EQ] = ACTIONS(1885),
    [anon_sym_SLASH_EQ] = ACTIONS(1885),
    [anon_sym_PERCENT_EQ] = ACTIONS(1885),
    [anon_sym_PLUS_EQ] = ACTIONS(1885),
    [anon_sym_DASH_EQ] = ACTIONS(1885),
    [anon_sym_LT_LT_EQ] = ACTIONS(1885),
    [anon_sym_GT_GT_EQ] = ACTIONS(1885),
    [anon_sym_AMP_EQ] = ACTIONS(1885),
    [anon_sym_CARET_EQ] = ACTIONS(1885),
    [anon_sym_PIPE_EQ] = ACTIONS(1885),
    [anon_sym_and_eq] = ACTIONS(1883),
    [anon_sym_or_eq] = ACTIONS(1883),
    [anon_sym_xor_eq] = ACTIONS(1883),
    [anon_sym_not] = ACTIONS(1931),
    [anon_sym_compl] = ACTIONS(1931),
    [anon_sym_LT_EQ_GT] = ACTIONS(1885),
    [anon_sym_or] = ACTIONS(1883),
    [anon_sym_and] = ACTIONS(1883),
    [anon_sym_bitor] = ACTIONS(1883),
    [anon_sym_xor] = ACTIONS(1883),
    [anon_sym_bitand] = ACTIONS(1883),
    [anon_sym_not_eq] = ACTIONS(1883),
    [anon_sym_DASH_DASH] = ACTIONS(1885),
    [anon_sym_PLUS_PLUS] = ACTIONS(1885),
    [anon_sym_sizeof] = ACTIONS(1937),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [anon_sym_DOT] = ACTIONS(1883),
    [anon_sym_DOT_STAR] = ACTIONS(1885),
    [anon_sym_DASH_GT] = ACTIONS(1885),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [127] = {
    [ts_builtin_sym_end] = ACTIONS(1955),
    [sym_identifier] = ACTIONS(1957),
    [aux_sym_preproc_include_token1] = ACTIONS(1957),
    [aux_sym_preproc_def_token1] = ACTIONS(1957),
    [anon_sym_COMMA] = ACTIONS(1955),
    [anon_sym_RPAREN] = ACTIONS(1955),
    [aux_sym_preproc_if_token1] = ACTIONS(1957),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1957),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1957),
    [sym_preproc_directive] = ACTIONS(1957),
    [anon_sym_LPAREN2] = ACTIONS(1955),
    [anon_sym_BANG] = ACTIONS(1955),
    [anon_sym_TILDE] = ACTIONS(1955),
    [anon_sym_DASH] = ACTIONS(1957),
    [anon_sym_PLUS] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(1955),
    [anon_sym_PIPE_PIPE] = ACTIONS(1955),
    [anon_sym_AMP_AMP] = ACTIONS(1955),
    [anon_sym_AMP] = ACTIONS(1957),
    [anon_sym_SEMI] = ACTIONS(1955),
    [anon_sym___extension__] = ACTIONS(1957),
    [anon_sym_typedef] = ACTIONS(1957),
    [anon_sym_extern] = ACTIONS(1957),
    [anon_sym___attribute__] = ACTIONS(1957),
    [anon_sym_COLON_COLON] = ACTIONS(1955),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1955),
    [anon_sym___declspec] = ACTIONS(1957),
    [anon_sym___based] = ACTIONS(1957),
    [anon_sym___cdecl] = ACTIONS(1957),
    [anon_sym___clrcall] = ACTIONS(1957),
    [anon_sym___stdcall] = ACTIONS(1957),
    [anon_sym___fastcall] = ACTIONS(1957),
    [anon_sym___thiscall] = ACTIONS(1957),
    [anon_sym___vectorcall] = ACTIONS(1957),
    [anon_sym_LBRACE] = ACTIONS(1955),
    [anon_sym_signed] = ACTIONS(1957),
    [anon_sym_unsigned] = ACTIONS(1957),
    [anon_sym_long] = ACTIONS(1957),
    [anon_sym_short] = ACTIONS(1957),
    [anon_sym_LBRACK] = ACTIONS(1957),
    [anon_sym_EQ] = ACTIONS(1955),
    [anon_sym_static] = ACTIONS(1957),
    [anon_sym_register] = ACTIONS(1957),
    [anon_sym_inline] = ACTIONS(1957),
    [anon_sym___inline] = ACTIONS(1957),
    [anon_sym___inline__] = ACTIONS(1957),
    [anon_sym___forceinline] = ACTIONS(1957),
    [anon_sym_thread_local] = ACTIONS(1957),
    [anon_sym___thread] = ACTIONS(1957),
    [anon_sym_const] = ACTIONS(1957),
    [anon_sym_constexpr] = ACTIONS(1957),
    [anon_sym_volatile] = ACTIONS(1957),
    [anon_sym_restrict] = ACTIONS(1957),
    [anon_sym___restrict__] = ACTIONS(1957),
    [anon_sym__Atomic] = ACTIONS(1957),
    [anon_sym__Noreturn] = ACTIONS(1957),
    [anon_sym_noreturn] = ACTIONS(1957),
    [anon_sym_mutable] = ACTIONS(1957),
    [anon_sym_constinit] = ACTIONS(1957),
    [anon_sym_consteval] = ACTIONS(1957),
    [anon_sym_PROGMEM] = ACTIONS(1957),
    [aux_sym_primitive_type_token1] = ACTIONS(1957),
    [anon_sym_byte] = ACTIONS(1957),
    [anon_sym_word] = ACTIONS(1957),
    [anon_sym_enum] = ACTIONS(1957),
    [anon_sym_class] = ACTIONS(1957),
    [anon_sym_struct] = ACTIONS(1957),
    [anon_sym_union] = ACTIONS(1957),
    [anon_sym_if] = ACTIONS(1957),
    [anon_sym_else] = ACTIONS(1957),
    [anon_sym_switch] = ACTIONS(1957),
    [anon_sym_case] = ACTIONS(1957),
    [anon_sym_default] = ACTIONS(1957),
    [anon_sym_while] = ACTIONS(1957),
    [anon_sym_do] = ACTIONS(1957),
    [anon_sym_for] = ACTIONS(1957),
    [anon_sym_return] = ACTIONS(1957),
    [anon_sym_break] = ACTIONS(1957),
    [anon_sym_continue] = ACTIONS(1957),
    [anon_sym_goto] = ACTIONS(1957),
    [anon_sym___try] = ACTIONS(1957),
    [anon_sym___except] = ACTIONS(1957),
    [anon_sym___finally] = ACTIONS(1957),
    [anon_sym___leave] = ACTIONS(1957),
    [anon_sym_not] = ACTIONS(1957),
    [anon_sym_compl] = ACTIONS(1957),
    [anon_sym_or] = ACTIONS(1957),
    [anon_sym_and] = ACTIONS(1957),
    [anon_sym_DASH_DASH] = ACTIONS(1955),
    [anon_sym_PLUS_PLUS] = ACTIONS(1955),
    [anon_sym_sizeof] = ACTIONS(1957),
    [anon_sym___alignof__] = ACTIONS(1957),
    [anon_sym___alignof] = ACTIONS(1957),
    [anon_sym__alignof] = ACTIONS(1957),
    [anon_sym_alignof] = ACTIONS(1957),
    [anon_sym__Alignof] = ACTIONS(1957),
    [anon_sym_offsetof] = ACTIONS(1957),
    [anon_sym__Generic] = ACTIONS(1957),
    [anon_sym_asm] = ACTIONS(1957),
    [anon_sym___asm__] = ACTIONS(1957),
    [aux_sym_number_literal_token1] = ACTIONS(1955),
    [aux_sym_number_literal_token2] = ACTIONS(1957),
    [anon_sym_L_SQUOTE] = ACTIONS(1955),
    [anon_sym_u_SQUOTE] = ACTIONS(1955),
    [anon_sym_U_SQUOTE] = ACTIONS(1955),
    [anon_sym_u8_SQUOTE] = ACTIONS(1955),
    [anon_sym_SQUOTE] = ACTIONS(1955),
    [anon_sym_L_DQUOTE] = ACTIONS(1955),
    [anon_sym_u_DQUOTE] = ACTIONS(1955),
    [anon_sym_U_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8_DQUOTE] = ACTIONS(1955),
    [anon_sym_DQUOTE] = ACTIONS(1955),
    [sym_true] = ACTIONS(1957),
    [sym_false] = ACTIONS(1957),
    [anon_sym_NULL] = ACTIONS(1957),
    [anon_sym_nullptr] = ACTIONS(1957),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1957),
    [anon_sym_decltype] = ACTIONS(1957),
    [anon_sym_final] = ACTIONS(1957),
    [anon_sym_override] = ACTIONS(1957),
    [anon_sym_virtual] = ACTIONS(1957),
    [anon_sym_alignas] = ACTIONS(1957),
    [anon_sym_explicit] = ACTIONS(1957),
    [anon_sym_typename] = ACTIONS(1957),
    [anon_sym_template] = ACTIONS(1957),
    [anon_sym_GT2] = ACTIONS(1955),
    [anon_sym_operator] = ACTIONS(1957),
    [anon_sym_try] = ACTIONS(1957),
    [anon_sym_delete] = ACTIONS(1957),
    [anon_sym_throw] = ACTIONS(1957),
    [anon_sym_namespace] = ACTIONS(1957),
    [anon_sym_using] = ACTIONS(1957),
    [anon_sym_static_assert] = ACTIONS(1957),
    [anon_sym_concept] = ACTIONS(1957),
    [anon_sym_co_return] = ACTIONS(1957),
    [anon_sym_co_yield] = ACTIONS(1957),
    [anon_sym_catch] = ACTIONS(1957),
    [anon_sym_R_DQUOTE] = ACTIONS(1955),
    [anon_sym_LR_DQUOTE] = ACTIONS(1955),
    [anon_sym_uR_DQUOTE] = ACTIONS(1955),
    [anon_sym_UR_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1955),
    [anon_sym_co_await] = ACTIONS(1957),
    [anon_sym_new] = ACTIONS(1957),
    [anon_sym_requires] = ACTIONS(1957),
    [sym_this] = ACTIONS(1957),
  },
  [128] = {
    [ts_builtin_sym_end] = ACTIONS(1959),
    [sym_identifier] = ACTIONS(1961),
    [aux_sym_preproc_include_token1] = ACTIONS(1961),
    [aux_sym_preproc_def_token1] = ACTIONS(1961),
    [anon_sym_COMMA] = ACTIONS(1959),
    [anon_sym_RPAREN] = ACTIONS(1959),
    [aux_sym_preproc_if_token1] = ACTIONS(1961),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1961),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1961),
    [sym_preproc_directive] = ACTIONS(1961),
    [anon_sym_LPAREN2] = ACTIONS(1959),
    [anon_sym_BANG] = ACTIONS(1959),
    [anon_sym_TILDE] = ACTIONS(1959),
    [anon_sym_DASH] = ACTIONS(1961),
    [anon_sym_PLUS] = ACTIONS(1961),
    [anon_sym_STAR] = ACTIONS(1959),
    [anon_sym_PIPE_PIPE] = ACTIONS(1959),
    [anon_sym_AMP_AMP] = ACTIONS(1959),
    [anon_sym_AMP] = ACTIONS(1961),
    [anon_sym_SEMI] = ACTIONS(1959),
    [anon_sym___extension__] = ACTIONS(1961),
    [anon_sym_typedef] = ACTIONS(1961),
    [anon_sym_extern] = ACTIONS(1961),
    [anon_sym___attribute__] = ACTIONS(1961),
    [anon_sym_COLON_COLON] = ACTIONS(1959),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1959),
    [anon_sym___declspec] = ACTIONS(1961),
    [anon_sym___based] = ACTIONS(1961),
    [anon_sym___cdecl] = ACTIONS(1961),
    [anon_sym___clrcall] = ACTIONS(1961),
    [anon_sym___stdcall] = ACTIONS(1961),
    [anon_sym___fastcall] = ACTIONS(1961),
    [anon_sym___thiscall] = ACTIONS(1961),
    [anon_sym___vectorcall] = ACTIONS(1961),
    [anon_sym_LBRACE] = ACTIONS(1959),
    [anon_sym_signed] = ACTIONS(1961),
    [anon_sym_unsigned] = ACTIONS(1961),
    [anon_sym_long] = ACTIONS(1961),
    [anon_sym_short] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1961),
    [anon_sym_EQ] = ACTIONS(1959),
    [anon_sym_static] = ACTIONS(1961),
    [anon_sym_register] = ACTIONS(1961),
    [anon_sym_inline] = ACTIONS(1961),
    [anon_sym___inline] = ACTIONS(1961),
    [anon_sym___inline__] = ACTIONS(1961),
    [anon_sym___forceinline] = ACTIONS(1961),
    [anon_sym_thread_local] = ACTIONS(1961),
    [anon_sym___thread] = ACTIONS(1961),
    [anon_sym_const] = ACTIONS(1961),
    [anon_sym_constexpr] = ACTIONS(1961),
    [anon_sym_volatile] = ACTIONS(1961),
    [anon_sym_restrict] = ACTIONS(1961),
    [anon_sym___restrict__] = ACTIONS(1961),
    [anon_sym__Atomic] = ACTIONS(1961),
    [anon_sym__Noreturn] = ACTIONS(1961),
    [anon_sym_noreturn] = ACTIONS(1961),
    [anon_sym_mutable] = ACTIONS(1961),
    [anon_sym_constinit] = ACTIONS(1961),
    [anon_sym_consteval] = ACTIONS(1961),
    [anon_sym_PROGMEM] = ACTIONS(1961),
    [aux_sym_primitive_type_token1] = ACTIONS(1961),
    [anon_sym_byte] = ACTIONS(1961),
    [anon_sym_word] = ACTIONS(1961),
    [anon_sym_enum] = ACTIONS(1961),
    [anon_sym_class] = ACTIONS(1961),
    [anon_sym_struct] = ACTIONS(1961),
    [anon_sym_union] = ACTIONS(1961),
    [anon_sym_if] = ACTIONS(1961),
    [anon_sym_else] = ACTIONS(1961),
    [anon_sym_switch] = ACTIONS(1961),
    [anon_sym_case] = ACTIONS(1961),
    [anon_sym_default] = ACTIONS(1961),
    [anon_sym_while] = ACTIONS(1961),
    [anon_sym_do] = ACTIONS(1961),
    [anon_sym_for] = ACTIONS(1961),
    [anon_sym_return] = ACTIONS(1961),
    [anon_sym_break] = ACTIONS(1961),
    [anon_sym_continue] = ACTIONS(1961),
    [anon_sym_goto] = ACTIONS(1961),
    [anon_sym___try] = ACTIONS(1961),
    [anon_sym___except] = ACTIONS(1961),
    [anon_sym___finally] = ACTIONS(1961),
    [anon_sym___leave] = ACTIONS(1961),
    [anon_sym_not] = ACTIONS(1961),
    [anon_sym_compl] = ACTIONS(1961),
    [anon_sym_or] = ACTIONS(1961),
    [anon_sym_and] = ACTIONS(1961),
    [anon_sym_DASH_DASH] = ACTIONS(1959),
    [anon_sym_PLUS_PLUS] = ACTIONS(1959),
    [anon_sym_sizeof] = ACTIONS(1961),
    [anon_sym___alignof__] = ACTIONS(1961),
    [anon_sym___alignof] = ACTIONS(1961),
    [anon_sym__alignof] = ACTIONS(1961),
    [anon_sym_alignof] = ACTIONS(1961),
    [anon_sym__Alignof] = ACTIONS(1961),
    [anon_sym_offsetof] = ACTIONS(1961),
    [anon_sym__Generic] = ACTIONS(1961),
    [anon_sym_asm] = ACTIONS(1961),
    [anon_sym___asm__] = ACTIONS(1961),
    [aux_sym_number_literal_token1] = ACTIONS(1959),
    [aux_sym_number_literal_token2] = ACTIONS(1961),
    [anon_sym_L_SQUOTE] = ACTIONS(1959),
    [anon_sym_u_SQUOTE] = ACTIONS(1959),
    [anon_sym_U_SQUOTE] = ACTIONS(1959),
    [anon_sym_u8_SQUOTE] = ACTIONS(1959),
    [anon_sym_SQUOTE] = ACTIONS(1959),
    [anon_sym_L_DQUOTE] = ACTIONS(1959),
    [anon_sym_u_DQUOTE] = ACTIONS(1959),
    [anon_sym_U_DQUOTE] = ACTIONS(1959),
    [anon_sym_u8_DQUOTE] = ACTIONS(1959),
    [anon_sym_DQUOTE] = ACTIONS(1959),
    [sym_true] = ACTIONS(1961),
    [sym_false] = ACTIONS(1961),
    [anon_sym_NULL] = ACTIONS(1961),
    [anon_sym_nullptr] = ACTIONS(1961),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1961),
    [anon_sym_decltype] = ACTIONS(1961),
    [anon_sym_final] = ACTIONS(1961),
    [anon_sym_override] = ACTIONS(1961),
    [anon_sym_virtual] = ACTIONS(1961),
    [anon_sym_alignas] = ACTIONS(1961),
    [anon_sym_explicit] = ACTIONS(1961),
    [anon_sym_typename] = ACTIONS(1961),
    [anon_sym_template] = ACTIONS(1961),
    [anon_sym_GT2] = ACTIONS(1959),
    [anon_sym_operator] = ACTIONS(1961),
    [anon_sym_try] = ACTIONS(1961),
    [anon_sym_delete] = ACTIONS(1961),
    [anon_sym_throw] = ACTIONS(1961),
    [anon_sym_namespace] = ACTIONS(1961),
    [anon_sym_using] = ACTIONS(1961),
    [anon_sym_static_assert] = ACTIONS(1961),
    [anon_sym_concept] = ACTIONS(1961),
    [anon_sym_co_return] = ACTIONS(1961),
    [anon_sym_co_yield] = ACTIONS(1961),
    [anon_sym_catch] = ACTIONS(1961),
    [anon_sym_R_DQUOTE] = ACTIONS(1959),
    [anon_sym_LR_DQUOTE] = ACTIONS(1959),
    [anon_sym_uR_DQUOTE] = ACTIONS(1959),
    [anon_sym_UR_DQUOTE] = ACTIONS(1959),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1959),
    [anon_sym_co_await] = ACTIONS(1961),
    [anon_sym_new] = ACTIONS(1961),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1961),
  },
  [129] = {
    [sym_attribute_declaration] = STATE(170),
    [sym_compound_statement] = STATE(523),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(523),
    [sym_labeled_statement] = STATE(523),
    [sym_expression_statement] = STATE(523),
    [sym_if_statement] = STATE(523),
    [sym_switch_statement] = STATE(523),
    [sym_case_statement] = STATE(523),
    [sym_while_statement] = STATE(523),
    [sym_do_statement] = STATE(523),
    [sym_for_statement] = STATE(523),
    [sym_return_statement] = STATE(523),
    [sym_break_statement] = STATE(523),
    [sym_continue_statement] = STATE(523),
    [sym_goto_statement] = STATE(523),
    [sym_seh_try_statement] = STATE(523),
    [sym_seh_leave_statement] = STATE(523),
    [sym__expression] = STATE(4235),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(7348),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(523),
    [sym_co_return_statement] = STATE(523),
    [sym_co_yield_statement] = STATE(523),
    [sym_throw_statement] = STATE(523),
    [sym_try_statement] = STATE(523),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [130] = {
    [sym_primitive_type] = STATE(6848),
    [sym__expression] = STATE(3064),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_initializer_list] = STATE(3357),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7357),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(7357),
    [sym_user_defined_literal] = STATE(3526),
    [sym_identifier] = ACTIONS(1965),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1885),
    [anon_sym_COMMA] = ACTIONS(1885),
    [anon_sym_RPAREN] = ACTIONS(1885),
    [anon_sym_LPAREN2] = ACTIONS(1885),
    [anon_sym_BANG] = ACTIONS(1817),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1883),
    [anon_sym_PLUS] = ACTIONS(1883),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_SLASH] = ACTIONS(1883),
    [anon_sym_PERCENT] = ACTIONS(1883),
    [anon_sym_PIPE_PIPE] = ACTIONS(1885),
    [anon_sym_AMP_AMP] = ACTIONS(1885),
    [anon_sym_PIPE] = ACTIONS(1883),
    [anon_sym_CARET] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym_EQ_EQ] = ACTIONS(1885),
    [anon_sym_BANG_EQ] = ACTIONS(1885),
    [anon_sym_GT] = ACTIONS(1883),
    [anon_sym_GT_EQ] = ACTIONS(1885),
    [anon_sym_LT_EQ] = ACTIONS(1883),
    [anon_sym_LT] = ACTIONS(1883),
    [anon_sym_LT_LT] = ACTIONS(1883),
    [anon_sym_GT_GT] = ACTIONS(1883),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_LBRACE] = ACTIONS(1967),
    [anon_sym_LBRACK] = ACTIONS(1885),
    [anon_sym_EQ] = ACTIONS(1883),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_QMARK] = ACTIONS(1885),
    [anon_sym_STAR_EQ] = ACTIONS(1885),
    [anon_sym_SLASH_EQ] = ACTIONS(1885),
    [anon_sym_PERCENT_EQ] = ACTIONS(1885),
    [anon_sym_PLUS_EQ] = ACTIONS(1885),
    [anon_sym_DASH_EQ] = ACTIONS(1885),
    [anon_sym_LT_LT_EQ] = ACTIONS(1885),
    [anon_sym_GT_GT_EQ] = ACTIONS(1885),
    [anon_sym_AMP_EQ] = ACTIONS(1885),
    [anon_sym_CARET_EQ] = ACTIONS(1885),
    [anon_sym_PIPE_EQ] = ACTIONS(1885),
    [anon_sym_and_eq] = ACTIONS(1883),
    [anon_sym_or_eq] = ACTIONS(1883),
    [anon_sym_xor_eq] = ACTIONS(1883),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_LT_EQ_GT] = ACTIONS(1885),
    [anon_sym_or] = ACTIONS(1883),
    [anon_sym_and] = ACTIONS(1883),
    [anon_sym_bitor] = ACTIONS(1883),
    [anon_sym_xor] = ACTIONS(1883),
    [anon_sym_bitand] = ACTIONS(1883),
    [anon_sym_not_eq] = ACTIONS(1883),
    [anon_sym_DASH_DASH] = ACTIONS(1885),
    [anon_sym_PLUS_PLUS] = ACTIONS(1885),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [anon_sym_DOT] = ACTIONS(1883),
    [anon_sym_DOT_STAR] = ACTIONS(1885),
    [anon_sym_DASH_GT] = ACTIONS(1883),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [anon_sym_DASH_GT_STAR] = ACTIONS(1885),
    [sym_this] = ACTIONS(1861),
  },
  [131] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2464),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_initializer_list] = STATE(2567),
    [sym_number_literal] = STATE(3292),
    [sym_char_literal] = STATE(3292),
    [sym_concatenated_string] = STATE(3308),
    [sym_string_literal] = STATE(2343),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2348),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1969),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1885),
    [anon_sym_COMMA] = ACTIONS(1885),
    [anon_sym_LPAREN2] = ACTIONS(1885),
    [anon_sym_BANG] = ACTIONS(1971),
    [anon_sym_TILDE] = ACTIONS(1973),
    [anon_sym_DASH] = ACTIONS(1883),
    [anon_sym_PLUS] = ACTIONS(1883),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_SLASH] = ACTIONS(1883),
    [anon_sym_PERCENT] = ACTIONS(1883),
    [anon_sym_PIPE_PIPE] = ACTIONS(1885),
    [anon_sym_AMP_AMP] = ACTIONS(1885),
    [anon_sym_PIPE] = ACTIONS(1883),
    [anon_sym_CARET] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym_EQ_EQ] = ACTIONS(1885),
    [anon_sym_BANG_EQ] = ACTIONS(1885),
    [anon_sym_GT] = ACTIONS(1883),
    [anon_sym_GT_EQ] = ACTIONS(1885),
    [anon_sym_LT_EQ] = ACTIONS(1883),
    [anon_sym_LT] = ACTIONS(1883),
    [anon_sym_LT_LT] = ACTIONS(1883),
    [anon_sym_GT_GT] = ACTIONS(1883),
    [anon_sym_SEMI] = ACTIONS(1885),
    [anon_sym___attribute__] = ACTIONS(1883),
    [anon_sym_COLON_COLON] = ACTIONS(1975),
    [anon_sym_LBRACE] = ACTIONS(1893),
    [anon_sym_LBRACK] = ACTIONS(1885),
    [anon_sym_EQ] = ACTIONS(1883),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_QMARK] = ACTIONS(1885),
    [anon_sym_STAR_EQ] = ACTIONS(1885),
    [anon_sym_SLASH_EQ] = ACTIONS(1885),
    [anon_sym_PERCENT_EQ] = ACTIONS(1885),
    [anon_sym_PLUS_EQ] = ACTIONS(1885),
    [anon_sym_DASH_EQ] = ACTIONS(1885),
    [anon_sym_LT_LT_EQ] = ACTIONS(1885),
    [anon_sym_GT_GT_EQ] = ACTIONS(1885),
    [anon_sym_AMP_EQ] = ACTIONS(1885),
    [anon_sym_CARET_EQ] = ACTIONS(1885),
    [anon_sym_PIPE_EQ] = ACTIONS(1885),
    [anon_sym_and_eq] = ACTIONS(1883),
    [anon_sym_or_eq] = ACTIONS(1883),
    [anon_sym_xor_eq] = ACTIONS(1883),
    [anon_sym_not] = ACTIONS(1971),
    [anon_sym_compl] = ACTIONS(1971),
    [anon_sym_LT_EQ_GT] = ACTIONS(1885),
    [anon_sym_or] = ACTIONS(1883),
    [anon_sym_and] = ACTIONS(1883),
    [anon_sym_bitor] = ACTIONS(1883),
    [anon_sym_xor] = ACTIONS(1883),
    [anon_sym_bitand] = ACTIONS(1883),
    [anon_sym_not_eq] = ACTIONS(1883),
    [anon_sym_DASH_DASH] = ACTIONS(1885),
    [anon_sym_PLUS_PLUS] = ACTIONS(1885),
    [anon_sym_sizeof] = ACTIONS(1977),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [anon_sym_DOT] = ACTIONS(1883),
    [anon_sym_DOT_STAR] = ACTIONS(1885),
    [anon_sym_DASH_GT] = ACTIONS(1885),
    [aux_sym_number_literal_token1] = ACTIONS(1979),
    [aux_sym_number_literal_token2] = ACTIONS(1981),
    [anon_sym_L_SQUOTE] = ACTIONS(1983),
    [anon_sym_u_SQUOTE] = ACTIONS(1983),
    [anon_sym_U_SQUOTE] = ACTIONS(1983),
    [anon_sym_u8_SQUOTE] = ACTIONS(1983),
    [anon_sym_SQUOTE] = ACTIONS(1983),
    [anon_sym_L_DQUOTE] = ACTIONS(1985),
    [anon_sym_u_DQUOTE] = ACTIONS(1985),
    [anon_sym_U_DQUOTE] = ACTIONS(1985),
    [anon_sym_u8_DQUOTE] = ACTIONS(1985),
    [anon_sym_DQUOTE] = ACTIONS(1985),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1987),
    [anon_sym_R_DQUOTE] = ACTIONS(1989),
    [anon_sym_LR_DQUOTE] = ACTIONS(1989),
    [anon_sym_uR_DQUOTE] = ACTIONS(1989),
    [anon_sym_UR_DQUOTE] = ACTIONS(1989),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1989),
    [anon_sym_co_await] = ACTIONS(1991),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [132] = {
    [sym_attribute_declaration] = STATE(173),
    [sym_compound_statement] = STATE(500),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(500),
    [sym_labeled_statement] = STATE(500),
    [sym_expression_statement] = STATE(500),
    [sym_if_statement] = STATE(500),
    [sym_switch_statement] = STATE(500),
    [sym_case_statement] = STATE(500),
    [sym_while_statement] = STATE(500),
    [sym_do_statement] = STATE(500),
    [sym_for_statement] = STATE(500),
    [sym_return_statement] = STATE(500),
    [sym_break_statement] = STATE(500),
    [sym_continue_statement] = STATE(500),
    [sym_goto_statement] = STATE(500),
    [sym_seh_try_statement] = STATE(500),
    [sym_seh_leave_statement] = STATE(500),
    [sym__expression] = STATE(4455),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(7649),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(500),
    [sym_co_return_statement] = STATE(500),
    [sym_co_yield_statement] = STATE(500),
    [sym_throw_statement] = STATE(500),
    [sym_try_statement] = STATE(500),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(173),
    [sym_identifier] = ACTIONS(1993),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(675),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(679),
    [anon_sym_switch] = ACTIONS(681),
    [anon_sym_case] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_while] = ACTIONS(687),
    [anon_sym_do] = ACTIONS(689),
    [anon_sym_for] = ACTIONS(691),
    [anon_sym_return] = ACTIONS(693),
    [anon_sym_break] = ACTIONS(695),
    [anon_sym_continue] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym___try] = ACTIONS(701),
    [anon_sym___leave] = ACTIONS(703),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_try] = ACTIONS(707),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(709),
    [anon_sym_co_return] = ACTIONS(719),
    [anon_sym_co_yield] = ACTIONS(721),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [133] = {
    [sym_attribute_declaration] = STATE(157),
    [sym_compound_statement] = STATE(1029),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(1029),
    [sym_labeled_statement] = STATE(1029),
    [sym_expression_statement] = STATE(1029),
    [sym_if_statement] = STATE(1029),
    [sym_switch_statement] = STATE(1029),
    [sym_case_statement] = STATE(1029),
    [sym_while_statement] = STATE(1029),
    [sym_do_statement] = STATE(1029),
    [sym_for_statement] = STATE(1029),
    [sym_return_statement] = STATE(1029),
    [sym_break_statement] = STATE(1029),
    [sym_continue_statement] = STATE(1029),
    [sym_goto_statement] = STATE(1029),
    [sym_seh_try_statement] = STATE(1029),
    [sym_seh_leave_statement] = STATE(1029),
    [sym__expression] = STATE(4433),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(7776),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(1029),
    [sym_co_return_statement] = STATE(1029),
    [sym_co_yield_statement] = STATE(1029),
    [sym_throw_statement] = STATE(1029),
    [sym_try_statement] = STATE(1029),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(157),
    [sym_identifier] = ACTIONS(1995),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(1633),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(1635),
    [anon_sym_switch] = ACTIONS(1637),
    [anon_sym_case] = ACTIONS(1997),
    [anon_sym_default] = ACTIONS(1999),
    [anon_sym_while] = ACTIONS(1639),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_for] = ACTIONS(1643),
    [anon_sym_return] = ACTIONS(1645),
    [anon_sym_break] = ACTIONS(1647),
    [anon_sym_continue] = ACTIONS(1649),
    [anon_sym_goto] = ACTIONS(1651),
    [anon_sym___try] = ACTIONS(1653),
    [anon_sym___leave] = ACTIONS(1655),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_try] = ACTIONS(1657),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(1659),
    [anon_sym_co_return] = ACTIONS(1661),
    [anon_sym_co_yield] = ACTIONS(1663),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [134] = {
    [sym_attribute_declaration] = STATE(173),
    [sym_compound_statement] = STATE(507),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(507),
    [sym_labeled_statement] = STATE(507),
    [sym_expression_statement] = STATE(507),
    [sym_if_statement] = STATE(507),
    [sym_switch_statement] = STATE(507),
    [sym_case_statement] = STATE(507),
    [sym_while_statement] = STATE(507),
    [sym_do_statement] = STATE(507),
    [sym_for_statement] = STATE(507),
    [sym_return_statement] = STATE(507),
    [sym_break_statement] = STATE(507),
    [sym_continue_statement] = STATE(507),
    [sym_goto_statement] = STATE(507),
    [sym_seh_try_statement] = STATE(507),
    [sym_seh_leave_statement] = STATE(507),
    [sym__expression] = STATE(4455),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(7649),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(507),
    [sym_co_return_statement] = STATE(507),
    [sym_co_yield_statement] = STATE(507),
    [sym_throw_statement] = STATE(507),
    [sym_try_statement] = STATE(507),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(173),
    [sym_identifier] = ACTIONS(1993),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(675),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(679),
    [anon_sym_switch] = ACTIONS(681),
    [anon_sym_case] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_while] = ACTIONS(687),
    [anon_sym_do] = ACTIONS(689),
    [anon_sym_for] = ACTIONS(691),
    [anon_sym_return] = ACTIONS(693),
    [anon_sym_break] = ACTIONS(695),
    [anon_sym_continue] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym___try] = ACTIONS(701),
    [anon_sym___leave] = ACTIONS(703),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_try] = ACTIONS(707),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(709),
    [anon_sym_co_return] = ACTIONS(719),
    [anon_sym_co_yield] = ACTIONS(721),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [135] = {
    [sym_attribute_declaration] = STATE(157),
    [sym_compound_statement] = STATE(992),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(993),
    [sym_labeled_statement] = STATE(998),
    [sym_expression_statement] = STATE(999),
    [sym_if_statement] = STATE(1004),
    [sym_switch_statement] = STATE(1005),
    [sym_case_statement] = STATE(1009),
    [sym_while_statement] = STATE(968),
    [sym_do_statement] = STATE(969),
    [sym_for_statement] = STATE(970),
    [sym_return_statement] = STATE(974),
    [sym_break_statement] = STATE(975),
    [sym_continue_statement] = STATE(976),
    [sym_goto_statement] = STATE(977),
    [sym_seh_try_statement] = STATE(978),
    [sym_seh_leave_statement] = STATE(979),
    [sym__expression] = STATE(4433),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(7776),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(981),
    [sym_co_return_statement] = STATE(982),
    [sym_co_yield_statement] = STATE(983),
    [sym_throw_statement] = STATE(984),
    [sym_try_statement] = STATE(985),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(157),
    [sym_identifier] = ACTIONS(1995),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(1633),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(1635),
    [anon_sym_switch] = ACTIONS(1637),
    [anon_sym_case] = ACTIONS(1997),
    [anon_sym_default] = ACTIONS(1999),
    [anon_sym_while] = ACTIONS(1639),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_for] = ACTIONS(1643),
    [anon_sym_return] = ACTIONS(1645),
    [anon_sym_break] = ACTIONS(1647),
    [anon_sym_continue] = ACTIONS(1649),
    [anon_sym_goto] = ACTIONS(1651),
    [anon_sym___try] = ACTIONS(1653),
    [anon_sym___leave] = ACTIONS(1655),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_try] = ACTIONS(1657),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(1659),
    [anon_sym_co_return] = ACTIONS(1661),
    [anon_sym_co_yield] = ACTIONS(1663),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [136] = {
    [sym_attribute_declaration] = STATE(136),
    [sym_compound_statement] = STATE(479),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(479),
    [sym_labeled_statement] = STATE(479),
    [sym_expression_statement] = STATE(479),
    [sym_if_statement] = STATE(479),
    [sym_switch_statement] = STATE(479),
    [sym_case_statement] = STATE(479),
    [sym_while_statement] = STATE(479),
    [sym_do_statement] = STATE(479),
    [sym_for_statement] = STATE(479),
    [sym_return_statement] = STATE(479),
    [sym_break_statement] = STATE(479),
    [sym_continue_statement] = STATE(479),
    [sym_goto_statement] = STATE(479),
    [sym_seh_try_statement] = STATE(479),
    [sym_seh_leave_statement] = STATE(479),
    [sym__expression] = STATE(4455),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(7649),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(479),
    [sym_co_return_statement] = STATE(479),
    [sym_co_yield_statement] = STATE(479),
    [sym_throw_statement] = STATE(479),
    [sym_try_statement] = STATE(479),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(136),
    [sym_identifier] = ACTIONS(2001),
    [anon_sym_LPAREN2] = ACTIONS(2004),
    [anon_sym_BANG] = ACTIONS(2007),
    [anon_sym_TILDE] = ACTIONS(2007),
    [anon_sym_DASH] = ACTIONS(2010),
    [anon_sym_PLUS] = ACTIONS(2010),
    [anon_sym_STAR] = ACTIONS(2013),
    [anon_sym_AMP] = ACTIONS(2013),
    [anon_sym_SEMI] = ACTIONS(2016),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2022),
    [anon_sym_LBRACE] = ACTIONS(2025),
    [anon_sym_LBRACK] = ACTIONS(2028),
    [aux_sym_primitive_type_token1] = ACTIONS(2031),
    [anon_sym_byte] = ACTIONS(2031),
    [anon_sym_word] = ACTIONS(2031),
    [anon_sym_if] = ACTIONS(2034),
    [anon_sym_switch] = ACTIONS(2037),
    [anon_sym_case] = ACTIONS(2040),
    [anon_sym_default] = ACTIONS(2043),
    [anon_sym_while] = ACTIONS(2046),
    [anon_sym_do] = ACTIONS(2049),
    [anon_sym_for] = ACTIONS(2052),
    [anon_sym_return] = ACTIONS(2055),
    [anon_sym_break] = ACTIONS(2058),
    [anon_sym_continue] = ACTIONS(2061),
    [anon_sym_goto] = ACTIONS(2064),
    [anon_sym___try] = ACTIONS(2067),
    [anon_sym___leave] = ACTIONS(2070),
    [anon_sym_not] = ACTIONS(2010),
    [anon_sym_compl] = ACTIONS(2010),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_sizeof] = ACTIONS(2076),
    [anon_sym___alignof__] = ACTIONS(2079),
    [anon_sym___alignof] = ACTIONS(2079),
    [anon_sym__alignof] = ACTIONS(2079),
    [anon_sym_alignof] = ACTIONS(2079),
    [anon_sym__Alignof] = ACTIONS(2079),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2085),
    [anon_sym_asm] = ACTIONS(2088),
    [anon_sym___asm__] = ACTIONS(2088),
    [aux_sym_number_literal_token1] = ACTIONS(2091),
    [aux_sym_number_literal_token2] = ACTIONS(2094),
    [anon_sym_L_SQUOTE] = ACTIONS(2097),
    [anon_sym_u_SQUOTE] = ACTIONS(2097),
    [anon_sym_U_SQUOTE] = ACTIONS(2097),
    [anon_sym_u8_SQUOTE] = ACTIONS(2097),
    [anon_sym_SQUOTE] = ACTIONS(2097),
    [anon_sym_L_DQUOTE] = ACTIONS(2100),
    [anon_sym_u_DQUOTE] = ACTIONS(2100),
    [anon_sym_U_DQUOTE] = ACTIONS(2100),
    [anon_sym_u8_DQUOTE] = ACTIONS(2100),
    [anon_sym_DQUOTE] = ACTIONS(2100),
    [sym_true] = ACTIONS(2103),
    [sym_false] = ACTIONS(2103),
    [anon_sym_NULL] = ACTIONS(2106),
    [anon_sym_nullptr] = ACTIONS(2106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2109),
    [anon_sym_template] = ACTIONS(2112),
    [anon_sym_try] = ACTIONS(2115),
    [anon_sym_delete] = ACTIONS(2118),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_co_return] = ACTIONS(2124),
    [anon_sym_co_yield] = ACTIONS(2127),
    [anon_sym_R_DQUOTE] = ACTIONS(2130),
    [anon_sym_LR_DQUOTE] = ACTIONS(2130),
    [anon_sym_uR_DQUOTE] = ACTIONS(2130),
    [anon_sym_UR_DQUOTE] = ACTIONS(2130),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2130),
    [anon_sym_co_await] = ACTIONS(2133),
    [anon_sym_new] = ACTIONS(2136),
    [anon_sym_requires] = ACTIONS(2139),
    [sym_this] = ACTIONS(2103),
  },
  [137] = {
    [sym_attribute_declaration] = STATE(173),
    [sym_compound_statement] = STATE(428),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(428),
    [sym_labeled_statement] = STATE(428),
    [sym_expression_statement] = STATE(428),
    [sym_if_statement] = STATE(428),
    [sym_switch_statement] = STATE(428),
    [sym_case_statement] = STATE(428),
    [sym_while_statement] = STATE(428),
    [sym_do_statement] = STATE(428),
    [sym_for_statement] = STATE(428),
    [sym_return_statement] = STATE(428),
    [sym_break_statement] = STATE(428),
    [sym_continue_statement] = STATE(428),
    [sym_goto_statement] = STATE(428),
    [sym_seh_try_statement] = STATE(428),
    [sym_seh_leave_statement] = STATE(428),
    [sym__expression] = STATE(4455),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(7649),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(428),
    [sym_co_return_statement] = STATE(428),
    [sym_co_yield_statement] = STATE(428),
    [sym_throw_statement] = STATE(428),
    [sym_try_statement] = STATE(428),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(173),
    [sym_identifier] = ACTIONS(1993),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(675),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(679),
    [anon_sym_switch] = ACTIONS(681),
    [anon_sym_case] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_while] = ACTIONS(687),
    [anon_sym_do] = ACTIONS(689),
    [anon_sym_for] = ACTIONS(691),
    [anon_sym_return] = ACTIONS(693),
    [anon_sym_break] = ACTIONS(695),
    [anon_sym_continue] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym___try] = ACTIONS(701),
    [anon_sym___leave] = ACTIONS(703),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_try] = ACTIONS(707),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(709),
    [anon_sym_co_return] = ACTIONS(719),
    [anon_sym_co_yield] = ACTIONS(721),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [138] = {
    [sym_attribute_declaration] = STATE(157),
    [sym_compound_statement] = STATE(1015),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(1013),
    [sym_labeled_statement] = STATE(1012),
    [sym_expression_statement] = STATE(1022),
    [sym_if_statement] = STATE(1011),
    [sym_switch_statement] = STATE(986),
    [sym_case_statement] = STATE(1003),
    [sym_while_statement] = STATE(1007),
    [sym_do_statement] = STATE(1002),
    [sym_for_statement] = STATE(967),
    [sym_return_statement] = STATE(980),
    [sym_break_statement] = STATE(988),
    [sym_continue_statement] = STATE(995),
    [sym_goto_statement] = STATE(996),
    [sym_seh_try_statement] = STATE(1001),
    [sym_seh_leave_statement] = STATE(971),
    [sym__expression] = STATE(4433),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(7776),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(972),
    [sym_co_return_statement] = STATE(987),
    [sym_co_yield_statement] = STATE(989),
    [sym_throw_statement] = STATE(990),
    [sym_try_statement] = STATE(991),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(157),
    [sym_identifier] = ACTIONS(1995),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(1633),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(1635),
    [anon_sym_switch] = ACTIONS(1637),
    [anon_sym_case] = ACTIONS(1997),
    [anon_sym_default] = ACTIONS(1999),
    [anon_sym_while] = ACTIONS(1639),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_for] = ACTIONS(1643),
    [anon_sym_return] = ACTIONS(1645),
    [anon_sym_break] = ACTIONS(1647),
    [anon_sym_continue] = ACTIONS(1649),
    [anon_sym_goto] = ACTIONS(1651),
    [anon_sym___try] = ACTIONS(1653),
    [anon_sym___leave] = ACTIONS(1655),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_try] = ACTIONS(1657),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(1659),
    [anon_sym_co_return] = ACTIONS(1661),
    [anon_sym_co_yield] = ACTIONS(1663),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [139] = {
    [sym_attribute_declaration] = STATE(172),
    [sym_compound_statement] = STATE(575),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(575),
    [sym_labeled_statement] = STATE(575),
    [sym_expression_statement] = STATE(575),
    [sym_if_statement] = STATE(575),
    [sym_switch_statement] = STATE(575),
    [sym_case_statement] = STATE(575),
    [sym_while_statement] = STATE(575),
    [sym_do_statement] = STATE(575),
    [sym_for_statement] = STATE(575),
    [sym_return_statement] = STATE(575),
    [sym_break_statement] = STATE(575),
    [sym_continue_statement] = STATE(575),
    [sym_goto_statement] = STATE(575),
    [sym_seh_try_statement] = STATE(575),
    [sym_seh_leave_statement] = STATE(575),
    [sym__expression] = STATE(4447),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8027),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(575),
    [sym_co_return_statement] = STATE(575),
    [sym_co_yield_statement] = STATE(575),
    [sym_throw_statement] = STATE(575),
    [sym_try_statement] = STATE(575),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(172),
    [sym_identifier] = ACTIONS(2142),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1435),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_case] = ACTIONS(77),
    [anon_sym_default] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_do] = ACTIONS(83),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_return] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_goto] = ACTIONS(93),
    [anon_sym___try] = ACTIONS(1437),
    [anon_sym___leave] = ACTIONS(1439),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [140] = {
    [sym_attribute_declaration] = STATE(165),
    [sym_compound_statement] = STATE(6925),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(6925),
    [sym_labeled_statement] = STATE(6925),
    [sym_expression_statement] = STATE(6925),
    [sym_if_statement] = STATE(6925),
    [sym_switch_statement] = STATE(6925),
    [sym_case_statement] = STATE(6925),
    [sym_while_statement] = STATE(6925),
    [sym_do_statement] = STATE(6925),
    [sym_for_statement] = STATE(6925),
    [sym_return_statement] = STATE(6925),
    [sym_break_statement] = STATE(6925),
    [sym_continue_statement] = STATE(6925),
    [sym_goto_statement] = STATE(6925),
    [sym_seh_try_statement] = STATE(6925),
    [sym_seh_leave_statement] = STATE(6925),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(6925),
    [sym_co_return_statement] = STATE(6925),
    [sym_co_yield_statement] = STATE(6925),
    [sym_throw_statement] = STATE(6925),
    [sym_try_statement] = STATE(6925),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(165),
    [sym_identifier] = ACTIONS(2144),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(2146),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_case] = ACTIONS(1997),
    [anon_sym_default] = ACTIONS(1999),
    [anon_sym_while] = ACTIONS(2148),
    [anon_sym_do] = ACTIONS(83),
    [anon_sym_for] = ACTIONS(2150),
    [anon_sym_return] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_goto] = ACTIONS(93),
    [anon_sym___try] = ACTIONS(2152),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [141] = {
    [sym_attribute_declaration] = STATE(141),
    [sym_compound_statement] = STATE(462),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(462),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(141),
    [sym_identifier] = ACTIONS(2154),
    [anon_sym_LPAREN2] = ACTIONS(2004),
    [anon_sym_BANG] = ACTIONS(2007),
    [anon_sym_TILDE] = ACTIONS(2007),
    [anon_sym_DASH] = ACTIONS(2010),
    [anon_sym_PLUS] = ACTIONS(2010),
    [anon_sym_STAR] = ACTIONS(2013),
    [anon_sym_AMP] = ACTIONS(2013),
    [anon_sym_SEMI] = ACTIONS(2157),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2022),
    [anon_sym_LBRACE] = ACTIONS(2160),
    [anon_sym_LBRACK] = ACTIONS(2028),
    [aux_sym_primitive_type_token1] = ACTIONS(2031),
    [anon_sym_byte] = ACTIONS(2031),
    [anon_sym_word] = ACTIONS(2031),
    [anon_sym_if] = ACTIONS(2163),
    [anon_sym_switch] = ACTIONS(2166),
    [anon_sym_case] = ACTIONS(2169),
    [anon_sym_default] = ACTIONS(2172),
    [anon_sym_while] = ACTIONS(2175),
    [anon_sym_do] = ACTIONS(2178),
    [anon_sym_for] = ACTIONS(2181),
    [anon_sym_return] = ACTIONS(2184),
    [anon_sym_break] = ACTIONS(2187),
    [anon_sym_continue] = ACTIONS(2190),
    [anon_sym_goto] = ACTIONS(2193),
    [anon_sym___try] = ACTIONS(2196),
    [anon_sym___leave] = ACTIONS(2199),
    [anon_sym_not] = ACTIONS(2010),
    [anon_sym_compl] = ACTIONS(2010),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_sizeof] = ACTIONS(2076),
    [anon_sym___alignof__] = ACTIONS(2079),
    [anon_sym___alignof] = ACTIONS(2079),
    [anon_sym__alignof] = ACTIONS(2079),
    [anon_sym_alignof] = ACTIONS(2079),
    [anon_sym__Alignof] = ACTIONS(2079),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2085),
    [anon_sym_asm] = ACTIONS(2088),
    [anon_sym___asm__] = ACTIONS(2088),
    [aux_sym_number_literal_token1] = ACTIONS(2091),
    [aux_sym_number_literal_token2] = ACTIONS(2094),
    [anon_sym_L_SQUOTE] = ACTIONS(2097),
    [anon_sym_u_SQUOTE] = ACTIONS(2097),
    [anon_sym_U_SQUOTE] = ACTIONS(2097),
    [anon_sym_u8_SQUOTE] = ACTIONS(2097),
    [anon_sym_SQUOTE] = ACTIONS(2097),
    [anon_sym_L_DQUOTE] = ACTIONS(2100),
    [anon_sym_u_DQUOTE] = ACTIONS(2100),
    [anon_sym_U_DQUOTE] = ACTIONS(2100),
    [anon_sym_u8_DQUOTE] = ACTIONS(2100),
    [anon_sym_DQUOTE] = ACTIONS(2100),
    [sym_true] = ACTIONS(2103),
    [sym_false] = ACTIONS(2103),
    [anon_sym_NULL] = ACTIONS(2106),
    [anon_sym_nullptr] = ACTIONS(2106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2109),
    [anon_sym_template] = ACTIONS(2112),
    [anon_sym_try] = ACTIONS(2202),
    [anon_sym_delete] = ACTIONS(2118),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_co_return] = ACTIONS(2208),
    [anon_sym_co_yield] = ACTIONS(2211),
    [anon_sym_R_DQUOTE] = ACTIONS(2130),
    [anon_sym_LR_DQUOTE] = ACTIONS(2130),
    [anon_sym_uR_DQUOTE] = ACTIONS(2130),
    [anon_sym_UR_DQUOTE] = ACTIONS(2130),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2130),
    [anon_sym_co_await] = ACTIONS(2133),
    [anon_sym_new] = ACTIONS(2136),
    [anon_sym_requires] = ACTIONS(2139),
    [sym_this] = ACTIONS(2103),
  },
  [142] = {
    [sym_attribute_declaration] = STATE(165),
    [sym_compound_statement] = STATE(8137),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(8137),
    [sym_labeled_statement] = STATE(8137),
    [sym_expression_statement] = STATE(8137),
    [sym_if_statement] = STATE(8137),
    [sym_switch_statement] = STATE(8137),
    [sym_case_statement] = STATE(8137),
    [sym_while_statement] = STATE(8137),
    [sym_do_statement] = STATE(8137),
    [sym_for_statement] = STATE(8137),
    [sym_return_statement] = STATE(8137),
    [sym_break_statement] = STATE(8137),
    [sym_continue_statement] = STATE(8137),
    [sym_goto_statement] = STATE(8137),
    [sym_seh_try_statement] = STATE(8137),
    [sym_seh_leave_statement] = STATE(8137),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(8137),
    [sym_co_return_statement] = STATE(8137),
    [sym_co_yield_statement] = STATE(8137),
    [sym_throw_statement] = STATE(8137),
    [sym_try_statement] = STATE(8137),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(165),
    [sym_identifier] = ACTIONS(2144),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(2146),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_case] = ACTIONS(1997),
    [anon_sym_default] = ACTIONS(1999),
    [anon_sym_while] = ACTIONS(2148),
    [anon_sym_do] = ACTIONS(83),
    [anon_sym_for] = ACTIONS(2150),
    [anon_sym_return] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_goto] = ACTIONS(93),
    [anon_sym___try] = ACTIONS(2152),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [143] = {
    [sym_attribute_declaration] = STATE(176),
    [sym_compound_statement] = STATE(275),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(275),
    [sym_labeled_statement] = STATE(275),
    [sym_expression_statement] = STATE(275),
    [sym_if_statement] = STATE(275),
    [sym_switch_statement] = STATE(275),
    [sym_case_statement] = STATE(275),
    [sym_while_statement] = STATE(275),
    [sym_do_statement] = STATE(275),
    [sym_for_statement] = STATE(275),
    [sym_return_statement] = STATE(275),
    [sym_break_statement] = STATE(275),
    [sym_continue_statement] = STATE(275),
    [sym_goto_statement] = STATE(275),
    [sym_seh_try_statement] = STATE(275),
    [sym_seh_leave_statement] = STATE(275),
    [sym__expression] = STATE(4420),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8126),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(275),
    [sym_co_return_statement] = STATE(275),
    [sym_co_yield_statement] = STATE(275),
    [sym_throw_statement] = STATE(275),
    [sym_try_statement] = STATE(275),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(176),
    [sym_identifier] = ACTIONS(2214),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(279),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(287),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(291),
    [anon_sym_switch] = ACTIONS(293),
    [anon_sym_case] = ACTIONS(295),
    [anon_sym_default] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(301),
    [anon_sym_for] = ACTIONS(303),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_break] = ACTIONS(307),
    [anon_sym_continue] = ACTIONS(309),
    [anon_sym_goto] = ACTIONS(311),
    [anon_sym___try] = ACTIONS(313),
    [anon_sym___leave] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_try] = ACTIONS(319),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(321),
    [anon_sym_co_return] = ACTIONS(331),
    [anon_sym_co_yield] = ACTIONS(333),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [144] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(3199),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_initializer_list] = STATE(2567),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1885),
    [anon_sym_COMMA] = ACTIONS(1885),
    [anon_sym_LPAREN2] = ACTIONS(1885),
    [anon_sym_BANG] = ACTIONS(2216),
    [anon_sym_TILDE] = ACTIONS(2218),
    [anon_sym_DASH] = ACTIONS(1883),
    [anon_sym_PLUS] = ACTIONS(1883),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_SLASH] = ACTIONS(1883),
    [anon_sym_PERCENT] = ACTIONS(1883),
    [anon_sym_PIPE_PIPE] = ACTIONS(1885),
    [anon_sym_AMP_AMP] = ACTIONS(1885),
    [anon_sym_PIPE] = ACTIONS(1883),
    [anon_sym_CARET] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym_EQ_EQ] = ACTIONS(1885),
    [anon_sym_BANG_EQ] = ACTIONS(1885),
    [anon_sym_GT] = ACTIONS(1883),
    [anon_sym_GT_EQ] = ACTIONS(1885),
    [anon_sym_LT_EQ] = ACTIONS(1883),
    [anon_sym_LT] = ACTIONS(1883),
    [anon_sym_LT_LT] = ACTIONS(1883),
    [anon_sym_GT_GT] = ACTIONS(1883),
    [anon_sym_COLON_COLON] = ACTIONS(2220),
    [anon_sym_LBRACE] = ACTIONS(1893),
    [anon_sym_LBRACK] = ACTIONS(1885),
    [anon_sym_EQ] = ACTIONS(1883),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_COLON] = ACTIONS(1883),
    [anon_sym_QMARK] = ACTIONS(1885),
    [anon_sym_STAR_EQ] = ACTIONS(1885),
    [anon_sym_SLASH_EQ] = ACTIONS(1885),
    [anon_sym_PERCENT_EQ] = ACTIONS(1885),
    [anon_sym_PLUS_EQ] = ACTIONS(1885),
    [anon_sym_DASH_EQ] = ACTIONS(1885),
    [anon_sym_LT_LT_EQ] = ACTIONS(1885),
    [anon_sym_GT_GT_EQ] = ACTIONS(1885),
    [anon_sym_AMP_EQ] = ACTIONS(1885),
    [anon_sym_CARET_EQ] = ACTIONS(1885),
    [anon_sym_PIPE_EQ] = ACTIONS(1885),
    [anon_sym_and_eq] = ACTIONS(1883),
    [anon_sym_or_eq] = ACTIONS(1883),
    [anon_sym_xor_eq] = ACTIONS(1883),
    [anon_sym_not] = ACTIONS(2216),
    [anon_sym_compl] = ACTIONS(2216),
    [anon_sym_LT_EQ_GT] = ACTIONS(1885),
    [anon_sym_or] = ACTIONS(1883),
    [anon_sym_and] = ACTIONS(1883),
    [anon_sym_bitor] = ACTIONS(1883),
    [anon_sym_xor] = ACTIONS(1883),
    [anon_sym_bitand] = ACTIONS(1883),
    [anon_sym_not_eq] = ACTIONS(1883),
    [anon_sym_DASH_DASH] = ACTIONS(1885),
    [anon_sym_PLUS_PLUS] = ACTIONS(1885),
    [anon_sym_sizeof] = ACTIONS(2222),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [anon_sym_DOT] = ACTIONS(1883),
    [anon_sym_DOT_STAR] = ACTIONS(1885),
    [anon_sym_DASH_GT] = ACTIONS(1885),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2224),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(2226),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [145] = {
    [sym_attribute_declaration] = STATE(170),
    [sym_compound_statement] = STATE(430),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(430),
    [sym_labeled_statement] = STATE(430),
    [sym_expression_statement] = STATE(430),
    [sym_if_statement] = STATE(430),
    [sym_switch_statement] = STATE(430),
    [sym_case_statement] = STATE(430),
    [sym_while_statement] = STATE(430),
    [sym_do_statement] = STATE(430),
    [sym_for_statement] = STATE(430),
    [sym_return_statement] = STATE(430),
    [sym_break_statement] = STATE(430),
    [sym_continue_statement] = STATE(430),
    [sym_goto_statement] = STATE(430),
    [sym_seh_try_statement] = STATE(430),
    [sym_seh_leave_statement] = STATE(430),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(430),
    [sym_co_return_statement] = STATE(430),
    [sym_co_yield_statement] = STATE(430),
    [sym_throw_statement] = STATE(430),
    [sym_try_statement] = STATE(430),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [146] = {
    [sym_attribute_declaration] = STATE(165),
    [sym_compound_statement] = STATE(8136),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(8136),
    [sym_labeled_statement] = STATE(8136),
    [sym_expression_statement] = STATE(8136),
    [sym_if_statement] = STATE(8136),
    [sym_switch_statement] = STATE(8136),
    [sym_case_statement] = STATE(8136),
    [sym_while_statement] = STATE(8136),
    [sym_do_statement] = STATE(8136),
    [sym_for_statement] = STATE(8136),
    [sym_return_statement] = STATE(8136),
    [sym_break_statement] = STATE(8136),
    [sym_continue_statement] = STATE(8136),
    [sym_goto_statement] = STATE(8136),
    [sym_seh_try_statement] = STATE(8136),
    [sym_seh_leave_statement] = STATE(8136),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(8136),
    [sym_co_return_statement] = STATE(8136),
    [sym_co_yield_statement] = STATE(8136),
    [sym_throw_statement] = STATE(8136),
    [sym_try_statement] = STATE(8136),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(165),
    [sym_identifier] = ACTIONS(2144),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(2146),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_case] = ACTIONS(1997),
    [anon_sym_default] = ACTIONS(1999),
    [anon_sym_while] = ACTIONS(2148),
    [anon_sym_do] = ACTIONS(83),
    [anon_sym_for] = ACTIONS(2150),
    [anon_sym_return] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_goto] = ACTIONS(93),
    [anon_sym___try] = ACTIONS(2152),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [147] = {
    [sym_attribute_declaration] = STATE(165),
    [sym_compound_statement] = STATE(8161),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(8161),
    [sym_labeled_statement] = STATE(8161),
    [sym_expression_statement] = STATE(8161),
    [sym_if_statement] = STATE(8161),
    [sym_switch_statement] = STATE(8161),
    [sym_case_statement] = STATE(8161),
    [sym_while_statement] = STATE(8161),
    [sym_do_statement] = STATE(8161),
    [sym_for_statement] = STATE(8161),
    [sym_return_statement] = STATE(8161),
    [sym_break_statement] = STATE(8161),
    [sym_continue_statement] = STATE(8161),
    [sym_goto_statement] = STATE(8161),
    [sym_seh_try_statement] = STATE(8161),
    [sym_seh_leave_statement] = STATE(8161),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(8161),
    [sym_co_return_statement] = STATE(8161),
    [sym_co_yield_statement] = STATE(8161),
    [sym_throw_statement] = STATE(8161),
    [sym_try_statement] = STATE(8161),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(165),
    [sym_identifier] = ACTIONS(2144),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(2146),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_case] = ACTIONS(1997),
    [anon_sym_default] = ACTIONS(1999),
    [anon_sym_while] = ACTIONS(2148),
    [anon_sym_do] = ACTIONS(83),
    [anon_sym_for] = ACTIONS(2150),
    [anon_sym_return] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_goto] = ACTIONS(93),
    [anon_sym___try] = ACTIONS(2152),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [148] = {
    [sym_attribute_declaration] = STATE(172),
    [sym_compound_statement] = STATE(551),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(446),
    [sym_labeled_statement] = STATE(449),
    [sym_expression_statement] = STATE(440),
    [sym_if_statement] = STATE(444),
    [sym_switch_statement] = STATE(456),
    [sym_case_statement] = STATE(476),
    [sym_while_statement] = STATE(483),
    [sym_do_statement] = STATE(486),
    [sym_for_statement] = STATE(490),
    [sym_return_statement] = STATE(528),
    [sym_break_statement] = STATE(529),
    [sym_continue_statement] = STATE(531),
    [sym_goto_statement] = STATE(532),
    [sym_seh_try_statement] = STATE(538),
    [sym_seh_leave_statement] = STATE(560),
    [sym__expression] = STATE(4447),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8027),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(572),
    [sym_co_return_statement] = STATE(587),
    [sym_co_yield_statement] = STATE(590),
    [sym_throw_statement] = STATE(611),
    [sym_try_statement] = STATE(618),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(172),
    [sym_identifier] = ACTIONS(2142),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1435),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_case] = ACTIONS(77),
    [anon_sym_default] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_do] = ACTIONS(83),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_return] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_goto] = ACTIONS(93),
    [anon_sym___try] = ACTIONS(1437),
    [anon_sym___leave] = ACTIONS(1439),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [149] = {
    [sym_attribute_declaration] = STATE(172),
    [sym_compound_statement] = STATE(425),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(425),
    [sym_labeled_statement] = STATE(425),
    [sym_expression_statement] = STATE(425),
    [sym_if_statement] = STATE(425),
    [sym_switch_statement] = STATE(425),
    [sym_case_statement] = STATE(425),
    [sym_while_statement] = STATE(425),
    [sym_do_statement] = STATE(425),
    [sym_for_statement] = STATE(425),
    [sym_return_statement] = STATE(425),
    [sym_break_statement] = STATE(425),
    [sym_continue_statement] = STATE(425),
    [sym_goto_statement] = STATE(425),
    [sym_seh_try_statement] = STATE(425),
    [sym_seh_leave_statement] = STATE(425),
    [sym__expression] = STATE(4447),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8027),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(425),
    [sym_co_return_statement] = STATE(425),
    [sym_co_yield_statement] = STATE(425),
    [sym_throw_statement] = STATE(425),
    [sym_try_statement] = STATE(425),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(172),
    [sym_identifier] = ACTIONS(2142),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1435),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_case] = ACTIONS(77),
    [anon_sym_default] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_do] = ACTIONS(83),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_return] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_goto] = ACTIONS(93),
    [anon_sym___try] = ACTIONS(1437),
    [anon_sym___leave] = ACTIONS(1439),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [150] = {
    [sym_attribute_declaration] = STATE(176),
    [sym_compound_statement] = STATE(266),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(266),
    [sym_labeled_statement] = STATE(266),
    [sym_expression_statement] = STATE(266),
    [sym_if_statement] = STATE(266),
    [sym_switch_statement] = STATE(266),
    [sym_case_statement] = STATE(266),
    [sym_while_statement] = STATE(266),
    [sym_do_statement] = STATE(266),
    [sym_for_statement] = STATE(266),
    [sym_return_statement] = STATE(266),
    [sym_break_statement] = STATE(266),
    [sym_continue_statement] = STATE(266),
    [sym_goto_statement] = STATE(266),
    [sym_seh_try_statement] = STATE(266),
    [sym_seh_leave_statement] = STATE(266),
    [sym__expression] = STATE(4420),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8126),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(266),
    [sym_co_return_statement] = STATE(266),
    [sym_co_yield_statement] = STATE(266),
    [sym_throw_statement] = STATE(266),
    [sym_try_statement] = STATE(266),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(176),
    [sym_identifier] = ACTIONS(2214),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(279),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(287),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(291),
    [anon_sym_switch] = ACTIONS(293),
    [anon_sym_case] = ACTIONS(295),
    [anon_sym_default] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(301),
    [anon_sym_for] = ACTIONS(303),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_break] = ACTIONS(307),
    [anon_sym_continue] = ACTIONS(309),
    [anon_sym_goto] = ACTIONS(311),
    [anon_sym___try] = ACTIONS(313),
    [anon_sym___leave] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_try] = ACTIONS(319),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(321),
    [anon_sym_co_return] = ACTIONS(331),
    [anon_sym_co_yield] = ACTIONS(333),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [151] = {
    [sym_attribute_declaration] = STATE(173),
    [sym_compound_statement] = STATE(569),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(569),
    [sym_labeled_statement] = STATE(569),
    [sym_expression_statement] = STATE(569),
    [sym_if_statement] = STATE(569),
    [sym_switch_statement] = STATE(569),
    [sym_case_statement] = STATE(569),
    [sym_while_statement] = STATE(569),
    [sym_do_statement] = STATE(569),
    [sym_for_statement] = STATE(569),
    [sym_return_statement] = STATE(569),
    [sym_break_statement] = STATE(569),
    [sym_continue_statement] = STATE(569),
    [sym_goto_statement] = STATE(569),
    [sym_seh_try_statement] = STATE(569),
    [sym_seh_leave_statement] = STATE(569),
    [sym__expression] = STATE(4455),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(7649),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(569),
    [sym_co_return_statement] = STATE(569),
    [sym_co_yield_statement] = STATE(569),
    [sym_throw_statement] = STATE(569),
    [sym_try_statement] = STATE(569),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(173),
    [sym_identifier] = ACTIONS(1993),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(675),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(679),
    [anon_sym_switch] = ACTIONS(681),
    [anon_sym_case] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_while] = ACTIONS(687),
    [anon_sym_do] = ACTIONS(689),
    [anon_sym_for] = ACTIONS(691),
    [anon_sym_return] = ACTIONS(693),
    [anon_sym_break] = ACTIONS(695),
    [anon_sym_continue] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym___try] = ACTIONS(701),
    [anon_sym___leave] = ACTIONS(703),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_try] = ACTIONS(707),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(709),
    [anon_sym_co_return] = ACTIONS(719),
    [anon_sym_co_yield] = ACTIONS(721),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [152] = {
    [sym_attribute_declaration] = STATE(157),
    [sym_compound_statement] = STATE(1017),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(1017),
    [sym_labeled_statement] = STATE(1017),
    [sym_expression_statement] = STATE(1017),
    [sym_if_statement] = STATE(1017),
    [sym_switch_statement] = STATE(1017),
    [sym_case_statement] = STATE(1017),
    [sym_while_statement] = STATE(1017),
    [sym_do_statement] = STATE(1017),
    [sym_for_statement] = STATE(1017),
    [sym_return_statement] = STATE(1017),
    [sym_break_statement] = STATE(1017),
    [sym_continue_statement] = STATE(1017),
    [sym_goto_statement] = STATE(1017),
    [sym_seh_try_statement] = STATE(1017),
    [sym_seh_leave_statement] = STATE(1017),
    [sym__expression] = STATE(4433),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(7776),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(1017),
    [sym_co_return_statement] = STATE(1017),
    [sym_co_yield_statement] = STATE(1017),
    [sym_throw_statement] = STATE(1017),
    [sym_try_statement] = STATE(1017),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(157),
    [sym_identifier] = ACTIONS(1995),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(1633),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(1635),
    [anon_sym_switch] = ACTIONS(1637),
    [anon_sym_case] = ACTIONS(1997),
    [anon_sym_default] = ACTIONS(1999),
    [anon_sym_while] = ACTIONS(1639),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_for] = ACTIONS(1643),
    [anon_sym_return] = ACTIONS(1645),
    [anon_sym_break] = ACTIONS(1647),
    [anon_sym_continue] = ACTIONS(1649),
    [anon_sym_goto] = ACTIONS(1651),
    [anon_sym___try] = ACTIONS(1653),
    [anon_sym___leave] = ACTIONS(1655),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_try] = ACTIONS(1657),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(1659),
    [anon_sym_co_return] = ACTIONS(1661),
    [anon_sym_co_yield] = ACTIONS(1663),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [153] = {
    [sym_attribute_declaration] = STATE(173),
    [sym_compound_statement] = STATE(574),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(576),
    [sym_labeled_statement] = STATE(577),
    [sym_expression_statement] = STATE(535),
    [sym_if_statement] = STATE(579),
    [sym_switch_statement] = STATE(581),
    [sym_case_statement] = STATE(582),
    [sym_while_statement] = STATE(583),
    [sym_do_statement] = STATE(584),
    [sym_for_statement] = STATE(585),
    [sym_return_statement] = STATE(586),
    [sym_break_statement] = STATE(589),
    [sym_continue_statement] = STATE(591),
    [sym_goto_statement] = STATE(592),
    [sym_seh_try_statement] = STATE(595),
    [sym_seh_leave_statement] = STATE(596),
    [sym__expression] = STATE(4455),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(7649),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(597),
    [sym_co_return_statement] = STATE(599),
    [sym_co_yield_statement] = STATE(600),
    [sym_throw_statement] = STATE(601),
    [sym_try_statement] = STATE(603),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(173),
    [sym_identifier] = ACTIONS(1993),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(675),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(679),
    [anon_sym_switch] = ACTIONS(681),
    [anon_sym_case] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_while] = ACTIONS(687),
    [anon_sym_do] = ACTIONS(689),
    [anon_sym_for] = ACTIONS(691),
    [anon_sym_return] = ACTIONS(693),
    [anon_sym_break] = ACTIONS(695),
    [anon_sym_continue] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym___try] = ACTIONS(701),
    [anon_sym___leave] = ACTIONS(703),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_try] = ACTIONS(707),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(709),
    [anon_sym_co_return] = ACTIONS(719),
    [anon_sym_co_yield] = ACTIONS(721),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [154] = {
    [sym_attribute_declaration] = STATE(165),
    [sym_compound_statement] = STATE(8181),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(8181),
    [sym_labeled_statement] = STATE(8181),
    [sym_expression_statement] = STATE(8181),
    [sym_if_statement] = STATE(8181),
    [sym_switch_statement] = STATE(8181),
    [sym_case_statement] = STATE(8181),
    [sym_while_statement] = STATE(8181),
    [sym_do_statement] = STATE(8181),
    [sym_for_statement] = STATE(8181),
    [sym_return_statement] = STATE(8181),
    [sym_break_statement] = STATE(8181),
    [sym_continue_statement] = STATE(8181),
    [sym_goto_statement] = STATE(8181),
    [sym_seh_try_statement] = STATE(8181),
    [sym_seh_leave_statement] = STATE(8181),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(8181),
    [sym_co_return_statement] = STATE(8181),
    [sym_co_yield_statement] = STATE(8181),
    [sym_throw_statement] = STATE(8181),
    [sym_try_statement] = STATE(8181),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(165),
    [sym_identifier] = ACTIONS(2144),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(2146),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_case] = ACTIONS(1997),
    [anon_sym_default] = ACTIONS(1999),
    [anon_sym_while] = ACTIONS(2148),
    [anon_sym_do] = ACTIONS(83),
    [anon_sym_for] = ACTIONS(2150),
    [anon_sym_return] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_goto] = ACTIONS(93),
    [anon_sym___try] = ACTIONS(2152),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [155] = {
    [sym_attribute_declaration] = STATE(172),
    [sym_compound_statement] = STATE(463),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(464),
    [sym_labeled_statement] = STATE(471),
    [sym_expression_statement] = STATE(474),
    [sym_if_statement] = STATE(484),
    [sym_switch_statement] = STATE(494),
    [sym_case_statement] = STATE(496),
    [sym_while_statement] = STATE(498),
    [sym_do_statement] = STATE(544),
    [sym_for_statement] = STATE(631),
    [sym_return_statement] = STATE(598),
    [sym_break_statement] = STATE(571),
    [sym_continue_statement] = STATE(548),
    [sym_goto_statement] = STATE(509),
    [sym_seh_try_statement] = STATE(503),
    [sym_seh_leave_statement] = STATE(501),
    [sym__expression] = STATE(4447),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8027),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(487),
    [sym_co_return_statement] = STATE(482),
    [sym_co_yield_statement] = STATE(469),
    [sym_throw_statement] = STATE(459),
    [sym_try_statement] = STATE(451),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(172),
    [sym_identifier] = ACTIONS(2142),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1435),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_case] = ACTIONS(77),
    [anon_sym_default] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_do] = ACTIONS(83),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_return] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_goto] = ACTIONS(93),
    [anon_sym___try] = ACTIONS(1437),
    [anon_sym___leave] = ACTIONS(1439),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [156] = {
    [sym_primitive_type] = STATE(6613),
    [sym__expression] = STATE(3245),
    [sym__expression_not_binary] = STATE(3637),
    [sym__string] = STATE(3637),
    [sym_conditional_expression] = STATE(3637),
    [sym_assignment_expression] = STATE(3637),
    [sym_pointer_expression] = STATE(3637),
    [sym_unary_expression] = STATE(3637),
    [sym_binary_expression] = STATE(3637),
    [sym_update_expression] = STATE(3637),
    [sym_cast_expression] = STATE(3637),
    [sym_sizeof_expression] = STATE(3637),
    [sym_alignof_expression] = STATE(3637),
    [sym_offsetof_expression] = STATE(3637),
    [sym_generic_expression] = STATE(3637),
    [sym_subscript_expression] = STATE(3637),
    [sym_call_expression] = STATE(3637),
    [sym_gnu_asm_expression] = STATE(3637),
    [sym_field_expression] = STATE(3637),
    [sym_compound_literal_expression] = STATE(3637),
    [sym_parenthesized_expression] = STATE(3637),
    [sym_initializer_list] = STATE(3550),
    [sym_number_literal] = STATE(3416),
    [sym_char_literal] = STATE(3416),
    [sym_concatenated_string] = STATE(3415),
    [sym_string_literal] = STATE(2430),
    [sym_null] = STATE(3637),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7434),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3637),
    [sym_raw_string_literal] = STATE(2419),
    [sym_co_await_expression] = STATE(3637),
    [sym_new_expression] = STATE(3637),
    [sym_delete_expression] = STATE(3637),
    [sym_requires_clause] = STATE(3637),
    [sym_requires_expression] = STATE(3637),
    [sym_lambda_expression] = STATE(3637),
    [sym_lambda_capture_specifier] = STATE(5725),
    [sym_fold_expression] = STATE(3637),
    [sym_parameter_pack_expansion] = STATE(3637),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5512),
    [sym_qualified_identifier] = STATE(3637),
    [sym_qualified_type_identifier] = STATE(7434),
    [sym_user_defined_literal] = STATE(3637),
    [sym_identifier] = ACTIONS(2228),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1885),
    [anon_sym_COMMA] = ACTIONS(1885),
    [anon_sym_LPAREN2] = ACTIONS(1885),
    [anon_sym_BANG] = ACTIONS(2230),
    [anon_sym_TILDE] = ACTIONS(2232),
    [anon_sym_DASH] = ACTIONS(1883),
    [anon_sym_PLUS] = ACTIONS(1883),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_SLASH] = ACTIONS(1883),
    [anon_sym_PERCENT] = ACTIONS(1883),
    [anon_sym_PIPE_PIPE] = ACTIONS(1885),
    [anon_sym_AMP_AMP] = ACTIONS(1885),
    [anon_sym_PIPE] = ACTIONS(1883),
    [anon_sym_CARET] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym_EQ_EQ] = ACTIONS(1885),
    [anon_sym_BANG_EQ] = ACTIONS(1885),
    [anon_sym_GT] = ACTIONS(1883),
    [anon_sym_GT_EQ] = ACTIONS(1883),
    [anon_sym_LT_EQ] = ACTIONS(1883),
    [anon_sym_LT] = ACTIONS(1883),
    [anon_sym_LT_LT] = ACTIONS(1883),
    [anon_sym_GT_GT] = ACTIONS(1883),
    [anon_sym_COLON_COLON] = ACTIONS(2234),
    [anon_sym_LBRACE] = ACTIONS(2236),
    [anon_sym_LBRACK] = ACTIONS(1885),
    [anon_sym_EQ] = ACTIONS(1883),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_QMARK] = ACTIONS(1885),
    [anon_sym_STAR_EQ] = ACTIONS(1885),
    [anon_sym_SLASH_EQ] = ACTIONS(1885),
    [anon_sym_PERCENT_EQ] = ACTIONS(1885),
    [anon_sym_PLUS_EQ] = ACTIONS(1885),
    [anon_sym_DASH_EQ] = ACTIONS(1885),
    [anon_sym_LT_LT_EQ] = ACTIONS(1885),
    [anon_sym_GT_GT_EQ] = ACTIONS(1883),
    [anon_sym_AMP_EQ] = ACTIONS(1885),
    [anon_sym_CARET_EQ] = ACTIONS(1885),
    [anon_sym_PIPE_EQ] = ACTIONS(1885),
    [anon_sym_and_eq] = ACTIONS(1883),
    [anon_sym_or_eq] = ACTIONS(1883),
    [anon_sym_xor_eq] = ACTIONS(1883),
    [anon_sym_not] = ACTIONS(2230),
    [anon_sym_compl] = ACTIONS(2230),
    [anon_sym_LT_EQ_GT] = ACTIONS(1885),
    [anon_sym_or] = ACTIONS(1883),
    [anon_sym_and] = ACTIONS(1883),
    [anon_sym_bitor] = ACTIONS(1883),
    [anon_sym_xor] = ACTIONS(1883),
    [anon_sym_bitand] = ACTIONS(1883),
    [anon_sym_not_eq] = ACTIONS(1883),
    [anon_sym_DASH_DASH] = ACTIONS(1885),
    [anon_sym_PLUS_PLUS] = ACTIONS(1885),
    [anon_sym_sizeof] = ACTIONS(2238),
    [anon_sym___alignof__] = ACTIONS(2240),
    [anon_sym___alignof] = ACTIONS(2240),
    [anon_sym__alignof] = ACTIONS(2240),
    [anon_sym_alignof] = ACTIONS(2240),
    [anon_sym__Alignof] = ACTIONS(2240),
    [anon_sym_offsetof] = ACTIONS(2242),
    [anon_sym__Generic] = ACTIONS(2244),
    [anon_sym_asm] = ACTIONS(2246),
    [anon_sym___asm__] = ACTIONS(2246),
    [anon_sym_DOT] = ACTIONS(1883),
    [anon_sym_DOT_STAR] = ACTIONS(1885),
    [anon_sym_DASH_GT] = ACTIONS(1885),
    [aux_sym_number_literal_token1] = ACTIONS(2248),
    [aux_sym_number_literal_token2] = ACTIONS(2250),
    [anon_sym_L_SQUOTE] = ACTIONS(2252),
    [anon_sym_u_SQUOTE] = ACTIONS(2252),
    [anon_sym_U_SQUOTE] = ACTIONS(2252),
    [anon_sym_u8_SQUOTE] = ACTIONS(2252),
    [anon_sym_SQUOTE] = ACTIONS(2252),
    [anon_sym_L_DQUOTE] = ACTIONS(2254),
    [anon_sym_u_DQUOTE] = ACTIONS(2254),
    [anon_sym_U_DQUOTE] = ACTIONS(2254),
    [anon_sym_u8_DQUOTE] = ACTIONS(2254),
    [anon_sym_DQUOTE] = ACTIONS(2254),
    [sym_true] = ACTIONS(2256),
    [sym_false] = ACTIONS(2256),
    [anon_sym_NULL] = ACTIONS(2258),
    [anon_sym_nullptr] = ACTIONS(2258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_GT2] = ACTIONS(1885),
    [anon_sym_delete] = ACTIONS(2260),
    [anon_sym_R_DQUOTE] = ACTIONS(2262),
    [anon_sym_LR_DQUOTE] = ACTIONS(2262),
    [anon_sym_uR_DQUOTE] = ACTIONS(2262),
    [anon_sym_UR_DQUOTE] = ACTIONS(2262),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2262),
    [anon_sym_co_await] = ACTIONS(2264),
    [anon_sym_new] = ACTIONS(2266),
    [anon_sym_requires] = ACTIONS(2268),
    [sym_this] = ACTIONS(2256),
  },
  [157] = {
    [sym_attribute_declaration] = STATE(187),
    [sym_compound_statement] = STATE(1039),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(1039),
    [sym_labeled_statement] = STATE(1039),
    [sym_expression_statement] = STATE(1039),
    [sym_if_statement] = STATE(1039),
    [sym_switch_statement] = STATE(1039),
    [sym_case_statement] = STATE(1039),
    [sym_while_statement] = STATE(1039),
    [sym_do_statement] = STATE(1039),
    [sym_for_statement] = STATE(1039),
    [sym_return_statement] = STATE(1039),
    [sym_break_statement] = STATE(1039),
    [sym_continue_statement] = STATE(1039),
    [sym_goto_statement] = STATE(1039),
    [sym_seh_try_statement] = STATE(1039),
    [sym_seh_leave_statement] = STATE(1039),
    [sym__expression] = STATE(4433),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(7776),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(1039),
    [sym_co_return_statement] = STATE(1039),
    [sym_co_yield_statement] = STATE(1039),
    [sym_throw_statement] = STATE(1039),
    [sym_try_statement] = STATE(1039),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(187),
    [sym_identifier] = ACTIONS(1995),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(1633),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(1635),
    [anon_sym_switch] = ACTIONS(1637),
    [anon_sym_case] = ACTIONS(1997),
    [anon_sym_default] = ACTIONS(1999),
    [anon_sym_while] = ACTIONS(1639),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_for] = ACTIONS(1643),
    [anon_sym_return] = ACTIONS(1645),
    [anon_sym_break] = ACTIONS(1647),
    [anon_sym_continue] = ACTIONS(1649),
    [anon_sym_goto] = ACTIONS(1651),
    [anon_sym___try] = ACTIONS(1653),
    [anon_sym___leave] = ACTIONS(1655),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_try] = ACTIONS(1657),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(1659),
    [anon_sym_co_return] = ACTIONS(1661),
    [anon_sym_co_yield] = ACTIONS(1663),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [158] = {
    [sym_attribute_declaration] = STATE(172),
    [sym_compound_statement] = STATE(615),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(615),
    [sym_labeled_statement] = STATE(615),
    [sym_expression_statement] = STATE(615),
    [sym_if_statement] = STATE(615),
    [sym_switch_statement] = STATE(615),
    [sym_case_statement] = STATE(615),
    [sym_while_statement] = STATE(615),
    [sym_do_statement] = STATE(615),
    [sym_for_statement] = STATE(615),
    [sym_return_statement] = STATE(615),
    [sym_break_statement] = STATE(615),
    [sym_continue_statement] = STATE(615),
    [sym_goto_statement] = STATE(615),
    [sym_seh_try_statement] = STATE(615),
    [sym_seh_leave_statement] = STATE(615),
    [sym__expression] = STATE(4447),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8027),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(615),
    [sym_co_return_statement] = STATE(615),
    [sym_co_yield_statement] = STATE(615),
    [sym_throw_statement] = STATE(615),
    [sym_try_statement] = STATE(615),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(172),
    [sym_identifier] = ACTIONS(2142),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1435),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_case] = ACTIONS(77),
    [anon_sym_default] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_do] = ACTIONS(83),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_return] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_goto] = ACTIONS(93),
    [anon_sym___try] = ACTIONS(1437),
    [anon_sym___leave] = ACTIONS(1439),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [159] = {
    [sym_attribute_declaration] = STATE(165),
    [sym_compound_statement] = STATE(454),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(454),
    [sym_labeled_statement] = STATE(454),
    [sym_expression_statement] = STATE(454),
    [sym_if_statement] = STATE(454),
    [sym_switch_statement] = STATE(454),
    [sym_case_statement] = STATE(454),
    [sym_while_statement] = STATE(454),
    [sym_do_statement] = STATE(454),
    [sym_for_statement] = STATE(454),
    [sym_return_statement] = STATE(454),
    [sym_break_statement] = STATE(454),
    [sym_continue_statement] = STATE(454),
    [sym_goto_statement] = STATE(454),
    [sym_seh_try_statement] = STATE(454),
    [sym_seh_leave_statement] = STATE(454),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(454),
    [sym_co_return_statement] = STATE(454),
    [sym_co_yield_statement] = STATE(454),
    [sym_throw_statement] = STATE(454),
    [sym_try_statement] = STATE(454),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(165),
    [sym_identifier] = ACTIONS(2144),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(2146),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_case] = ACTIONS(1997),
    [anon_sym_default] = ACTIONS(1999),
    [anon_sym_while] = ACTIONS(2148),
    [anon_sym_do] = ACTIONS(83),
    [anon_sym_for] = ACTIONS(2150),
    [anon_sym_return] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_goto] = ACTIONS(93),
    [anon_sym___try] = ACTIONS(2152),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [160] = {
    [sym_attribute_declaration] = STATE(165),
    [sym_compound_statement] = STATE(463),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(464),
    [sym_labeled_statement] = STATE(471),
    [sym_expression_statement] = STATE(474),
    [sym_if_statement] = STATE(484),
    [sym_switch_statement] = STATE(494),
    [sym_case_statement] = STATE(496),
    [sym_while_statement] = STATE(498),
    [sym_do_statement] = STATE(544),
    [sym_for_statement] = STATE(631),
    [sym_return_statement] = STATE(598),
    [sym_break_statement] = STATE(571),
    [sym_continue_statement] = STATE(548),
    [sym_goto_statement] = STATE(509),
    [sym_seh_try_statement] = STATE(503),
    [sym_seh_leave_statement] = STATE(501),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(487),
    [sym_co_return_statement] = STATE(482),
    [sym_co_yield_statement] = STATE(469),
    [sym_throw_statement] = STATE(459),
    [sym_try_statement] = STATE(451),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(165),
    [sym_identifier] = ACTIONS(2144),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(2146),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_case] = ACTIONS(1997),
    [anon_sym_default] = ACTIONS(1999),
    [anon_sym_while] = ACTIONS(2148),
    [anon_sym_do] = ACTIONS(83),
    [anon_sym_for] = ACTIONS(2150),
    [anon_sym_return] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_goto] = ACTIONS(93),
    [anon_sym___try] = ACTIONS(2152),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [161] = {
    [sym_attribute_declaration] = STATE(173),
    [sym_compound_statement] = STATE(604),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(605),
    [sym_labeled_statement] = STATE(606),
    [sym_expression_statement] = STATE(607),
    [sym_if_statement] = STATE(608),
    [sym_switch_statement] = STATE(609),
    [sym_case_statement] = STATE(610),
    [sym_while_statement] = STATE(612),
    [sym_do_statement] = STATE(613),
    [sym_for_statement] = STATE(620),
    [sym_return_statement] = STATE(623),
    [sym_break_statement] = STATE(637),
    [sym_continue_statement] = STATE(638),
    [sym_goto_statement] = STATE(641),
    [sym_seh_try_statement] = STATE(642),
    [sym_seh_leave_statement] = STATE(644),
    [sym__expression] = STATE(4455),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(7649),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(654),
    [sym_co_return_statement] = STATE(578),
    [sym_co_yield_statement] = STATE(651),
    [sym_throw_statement] = STATE(649),
    [sym_try_statement] = STATE(630),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(173),
    [sym_identifier] = ACTIONS(1993),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(675),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(679),
    [anon_sym_switch] = ACTIONS(681),
    [anon_sym_case] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_while] = ACTIONS(687),
    [anon_sym_do] = ACTIONS(689),
    [anon_sym_for] = ACTIONS(691),
    [anon_sym_return] = ACTIONS(693),
    [anon_sym_break] = ACTIONS(695),
    [anon_sym_continue] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym___try] = ACTIONS(701),
    [anon_sym___leave] = ACTIONS(703),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_try] = ACTIONS(707),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(709),
    [anon_sym_co_return] = ACTIONS(719),
    [anon_sym_co_yield] = ACTIONS(721),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [162] = {
    [sym_attribute_declaration] = STATE(165),
    [sym_compound_statement] = STATE(551),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(446),
    [sym_labeled_statement] = STATE(449),
    [sym_expression_statement] = STATE(440),
    [sym_if_statement] = STATE(444),
    [sym_switch_statement] = STATE(456),
    [sym_case_statement] = STATE(476),
    [sym_while_statement] = STATE(483),
    [sym_do_statement] = STATE(486),
    [sym_for_statement] = STATE(490),
    [sym_return_statement] = STATE(528),
    [sym_break_statement] = STATE(529),
    [sym_continue_statement] = STATE(531),
    [sym_goto_statement] = STATE(532),
    [sym_seh_try_statement] = STATE(538),
    [sym_seh_leave_statement] = STATE(560),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(572),
    [sym_co_return_statement] = STATE(587),
    [sym_co_yield_statement] = STATE(590),
    [sym_throw_statement] = STATE(611),
    [sym_try_statement] = STATE(618),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(165),
    [sym_identifier] = ACTIONS(2144),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(2146),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_case] = ACTIONS(1997),
    [anon_sym_default] = ACTIONS(1999),
    [anon_sym_while] = ACTIONS(2148),
    [anon_sym_do] = ACTIONS(83),
    [anon_sym_for] = ACTIONS(2150),
    [anon_sym_return] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_goto] = ACTIONS(93),
    [anon_sym___try] = ACTIONS(2152),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [163] = {
    [sym_attribute_declaration] = STATE(176),
    [sym_compound_statement] = STATE(224),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(224),
    [sym_labeled_statement] = STATE(224),
    [sym_expression_statement] = STATE(224),
    [sym_if_statement] = STATE(224),
    [sym_switch_statement] = STATE(224),
    [sym_case_statement] = STATE(224),
    [sym_while_statement] = STATE(224),
    [sym_do_statement] = STATE(224),
    [sym_for_statement] = STATE(224),
    [sym_return_statement] = STATE(224),
    [sym_break_statement] = STATE(224),
    [sym_continue_statement] = STATE(224),
    [sym_goto_statement] = STATE(224),
    [sym_seh_try_statement] = STATE(224),
    [sym_seh_leave_statement] = STATE(224),
    [sym__expression] = STATE(4420),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8126),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(224),
    [sym_co_return_statement] = STATE(224),
    [sym_co_yield_statement] = STATE(224),
    [sym_throw_statement] = STATE(224),
    [sym_try_statement] = STATE(224),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(176),
    [sym_identifier] = ACTIONS(2214),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(279),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(287),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(291),
    [anon_sym_switch] = ACTIONS(293),
    [anon_sym_case] = ACTIONS(295),
    [anon_sym_default] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(301),
    [anon_sym_for] = ACTIONS(303),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_break] = ACTIONS(307),
    [anon_sym_continue] = ACTIONS(309),
    [anon_sym_goto] = ACTIONS(311),
    [anon_sym___try] = ACTIONS(313),
    [anon_sym___leave] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_try] = ACTIONS(319),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(321),
    [anon_sym_co_return] = ACTIONS(331),
    [anon_sym_co_yield] = ACTIONS(333),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [164] = {
    [sym_attribute_declaration] = STATE(165),
    [sym_compound_statement] = STATE(7971),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(7971),
    [sym_labeled_statement] = STATE(7971),
    [sym_expression_statement] = STATE(7971),
    [sym_if_statement] = STATE(7971),
    [sym_switch_statement] = STATE(7971),
    [sym_case_statement] = STATE(7971),
    [sym_while_statement] = STATE(7971),
    [sym_do_statement] = STATE(7971),
    [sym_for_statement] = STATE(7971),
    [sym_return_statement] = STATE(7971),
    [sym_break_statement] = STATE(7971),
    [sym_continue_statement] = STATE(7971),
    [sym_goto_statement] = STATE(7971),
    [sym_seh_try_statement] = STATE(7971),
    [sym_seh_leave_statement] = STATE(7971),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(7971),
    [sym_co_return_statement] = STATE(7971),
    [sym_co_yield_statement] = STATE(7971),
    [sym_throw_statement] = STATE(7971),
    [sym_try_statement] = STATE(7971),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(165),
    [sym_identifier] = ACTIONS(2144),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(2146),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_case] = ACTIONS(1997),
    [anon_sym_default] = ACTIONS(1999),
    [anon_sym_while] = ACTIONS(2148),
    [anon_sym_do] = ACTIONS(83),
    [anon_sym_for] = ACTIONS(2150),
    [anon_sym_return] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_goto] = ACTIONS(93),
    [anon_sym___try] = ACTIONS(2152),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [165] = {
    [sym_attribute_declaration] = STATE(141),
    [sym_compound_statement] = STATE(462),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(462),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(141),
    [sym_identifier] = ACTIONS(2144),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(2146),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_case] = ACTIONS(1997),
    [anon_sym_default] = ACTIONS(1999),
    [anon_sym_while] = ACTIONS(2148),
    [anon_sym_do] = ACTIONS(83),
    [anon_sym_for] = ACTIONS(2150),
    [anon_sym_return] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_goto] = ACTIONS(93),
    [anon_sym___try] = ACTIONS(2152),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [166] = {
    [sym_attribute_declaration] = STATE(172),
    [sym_compound_statement] = STATE(454),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(454),
    [sym_labeled_statement] = STATE(454),
    [sym_expression_statement] = STATE(454),
    [sym_if_statement] = STATE(454),
    [sym_switch_statement] = STATE(454),
    [sym_case_statement] = STATE(454),
    [sym_while_statement] = STATE(454),
    [sym_do_statement] = STATE(454),
    [sym_for_statement] = STATE(454),
    [sym_return_statement] = STATE(454),
    [sym_break_statement] = STATE(454),
    [sym_continue_statement] = STATE(454),
    [sym_goto_statement] = STATE(454),
    [sym_seh_try_statement] = STATE(454),
    [sym_seh_leave_statement] = STATE(454),
    [sym__expression] = STATE(4447),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8027),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(454),
    [sym_co_return_statement] = STATE(454),
    [sym_co_yield_statement] = STATE(454),
    [sym_throw_statement] = STATE(454),
    [sym_try_statement] = STATE(454),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(172),
    [sym_identifier] = ACTIONS(2142),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1435),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_case] = ACTIONS(77),
    [anon_sym_default] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_do] = ACTIONS(83),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_return] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_goto] = ACTIONS(93),
    [anon_sym___try] = ACTIONS(1437),
    [anon_sym___leave] = ACTIONS(1439),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [167] = {
    [sym_attribute_declaration] = STATE(165),
    [sym_compound_statement] = STATE(615),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(615),
    [sym_labeled_statement] = STATE(615),
    [sym_expression_statement] = STATE(615),
    [sym_if_statement] = STATE(615),
    [sym_switch_statement] = STATE(615),
    [sym_case_statement] = STATE(615),
    [sym_while_statement] = STATE(615),
    [sym_do_statement] = STATE(615),
    [sym_for_statement] = STATE(615),
    [sym_return_statement] = STATE(615),
    [sym_break_statement] = STATE(615),
    [sym_continue_statement] = STATE(615),
    [sym_goto_statement] = STATE(615),
    [sym_seh_try_statement] = STATE(615),
    [sym_seh_leave_statement] = STATE(615),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(615),
    [sym_co_return_statement] = STATE(615),
    [sym_co_yield_statement] = STATE(615),
    [sym_throw_statement] = STATE(615),
    [sym_try_statement] = STATE(615),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(165),
    [sym_identifier] = ACTIONS(2144),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(2146),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_case] = ACTIONS(1997),
    [anon_sym_default] = ACTIONS(1999),
    [anon_sym_while] = ACTIONS(2148),
    [anon_sym_do] = ACTIONS(83),
    [anon_sym_for] = ACTIONS(2150),
    [anon_sym_return] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_goto] = ACTIONS(93),
    [anon_sym___try] = ACTIONS(2152),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [168] = {
    [sym_attribute_declaration] = STATE(165),
    [sym_compound_statement] = STATE(575),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(575),
    [sym_labeled_statement] = STATE(575),
    [sym_expression_statement] = STATE(575),
    [sym_if_statement] = STATE(575),
    [sym_switch_statement] = STATE(575),
    [sym_case_statement] = STATE(575),
    [sym_while_statement] = STATE(575),
    [sym_do_statement] = STATE(575),
    [sym_for_statement] = STATE(575),
    [sym_return_statement] = STATE(575),
    [sym_break_statement] = STATE(575),
    [sym_continue_statement] = STATE(575),
    [sym_goto_statement] = STATE(575),
    [sym_seh_try_statement] = STATE(575),
    [sym_seh_leave_statement] = STATE(575),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(575),
    [sym_co_return_statement] = STATE(575),
    [sym_co_yield_statement] = STATE(575),
    [sym_throw_statement] = STATE(575),
    [sym_try_statement] = STATE(575),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(165),
    [sym_identifier] = ACTIONS(2144),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(2146),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_case] = ACTIONS(1997),
    [anon_sym_default] = ACTIONS(1999),
    [anon_sym_while] = ACTIONS(2148),
    [anon_sym_do] = ACTIONS(83),
    [anon_sym_for] = ACTIONS(2150),
    [anon_sym_return] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_goto] = ACTIONS(93),
    [anon_sym___try] = ACTIONS(2152),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [169] = {
    [sym_attribute_declaration] = STATE(165),
    [sym_compound_statement] = STATE(7068),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(7068),
    [sym_labeled_statement] = STATE(7068),
    [sym_expression_statement] = STATE(7068),
    [sym_if_statement] = STATE(7068),
    [sym_switch_statement] = STATE(7068),
    [sym_case_statement] = STATE(7068),
    [sym_while_statement] = STATE(7068),
    [sym_do_statement] = STATE(7068),
    [sym_for_statement] = STATE(7068),
    [sym_return_statement] = STATE(7068),
    [sym_break_statement] = STATE(7068),
    [sym_continue_statement] = STATE(7068),
    [sym_goto_statement] = STATE(7068),
    [sym_seh_try_statement] = STATE(7068),
    [sym_seh_leave_statement] = STATE(7068),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(7068),
    [sym_co_return_statement] = STATE(7068),
    [sym_co_yield_statement] = STATE(7068),
    [sym_throw_statement] = STATE(7068),
    [sym_try_statement] = STATE(7068),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(165),
    [sym_identifier] = ACTIONS(2144),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(2146),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_case] = ACTIONS(1997),
    [anon_sym_default] = ACTIONS(1999),
    [anon_sym_while] = ACTIONS(2148),
    [anon_sym_do] = ACTIONS(83),
    [anon_sym_for] = ACTIONS(2150),
    [anon_sym_return] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_goto] = ACTIONS(93),
    [anon_sym___try] = ACTIONS(2152),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [170] = {
    [sym_attribute_declaration] = STATE(175),
    [sym_compound_statement] = STATE(495),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(495),
    [sym_labeled_statement] = STATE(495),
    [sym_expression_statement] = STATE(495),
    [sym_if_statement] = STATE(495),
    [sym_switch_statement] = STATE(495),
    [sym_case_statement] = STATE(495),
    [sym_while_statement] = STATE(495),
    [sym_do_statement] = STATE(495),
    [sym_for_statement] = STATE(495),
    [sym_return_statement] = STATE(495),
    [sym_break_statement] = STATE(495),
    [sym_continue_statement] = STATE(495),
    [sym_goto_statement] = STATE(495),
    [sym_seh_try_statement] = STATE(495),
    [sym_seh_leave_statement] = STATE(495),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(495),
    [sym_co_return_statement] = STATE(495),
    [sym_co_yield_statement] = STATE(495),
    [sym_throw_statement] = STATE(495),
    [sym_try_statement] = STATE(495),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(175),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [171] = {
    [sym_attribute_declaration] = STATE(171),
    [sym_compound_statement] = STATE(462),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(462),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym__expression] = STATE(4447),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8027),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(171),
    [sym_identifier] = ACTIONS(2270),
    [anon_sym_LPAREN2] = ACTIONS(2004),
    [anon_sym_BANG] = ACTIONS(2007),
    [anon_sym_TILDE] = ACTIONS(2007),
    [anon_sym_DASH] = ACTIONS(2010),
    [anon_sym_PLUS] = ACTIONS(2010),
    [anon_sym_STAR] = ACTIONS(2013),
    [anon_sym_AMP] = ACTIONS(2013),
    [anon_sym_SEMI] = ACTIONS(2273),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2022),
    [anon_sym_LBRACE] = ACTIONS(2160),
    [anon_sym_LBRACK] = ACTIONS(2028),
    [aux_sym_primitive_type_token1] = ACTIONS(2031),
    [anon_sym_byte] = ACTIONS(2031),
    [anon_sym_word] = ACTIONS(2031),
    [anon_sym_if] = ACTIONS(2276),
    [anon_sym_switch] = ACTIONS(2166),
    [anon_sym_case] = ACTIONS(2279),
    [anon_sym_default] = ACTIONS(2282),
    [anon_sym_while] = ACTIONS(2285),
    [anon_sym_do] = ACTIONS(2178),
    [anon_sym_for] = ACTIONS(2288),
    [anon_sym_return] = ACTIONS(2184),
    [anon_sym_break] = ACTIONS(2187),
    [anon_sym_continue] = ACTIONS(2190),
    [anon_sym_goto] = ACTIONS(2193),
    [anon_sym___try] = ACTIONS(2291),
    [anon_sym___leave] = ACTIONS(2294),
    [anon_sym_not] = ACTIONS(2010),
    [anon_sym_compl] = ACTIONS(2010),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_sizeof] = ACTIONS(2076),
    [anon_sym___alignof__] = ACTIONS(2079),
    [anon_sym___alignof] = ACTIONS(2079),
    [anon_sym__alignof] = ACTIONS(2079),
    [anon_sym_alignof] = ACTIONS(2079),
    [anon_sym__Alignof] = ACTIONS(2079),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2085),
    [anon_sym_asm] = ACTIONS(2088),
    [anon_sym___asm__] = ACTIONS(2088),
    [aux_sym_number_literal_token1] = ACTIONS(2091),
    [aux_sym_number_literal_token2] = ACTIONS(2094),
    [anon_sym_L_SQUOTE] = ACTIONS(2097),
    [anon_sym_u_SQUOTE] = ACTIONS(2097),
    [anon_sym_U_SQUOTE] = ACTIONS(2097),
    [anon_sym_u8_SQUOTE] = ACTIONS(2097),
    [anon_sym_SQUOTE] = ACTIONS(2097),
    [anon_sym_L_DQUOTE] = ACTIONS(2100),
    [anon_sym_u_DQUOTE] = ACTIONS(2100),
    [anon_sym_U_DQUOTE] = ACTIONS(2100),
    [anon_sym_u8_DQUOTE] = ACTIONS(2100),
    [anon_sym_DQUOTE] = ACTIONS(2100),
    [sym_true] = ACTIONS(2103),
    [sym_false] = ACTIONS(2103),
    [anon_sym_NULL] = ACTIONS(2106),
    [anon_sym_nullptr] = ACTIONS(2106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2109),
    [anon_sym_template] = ACTIONS(2112),
    [anon_sym_try] = ACTIONS(2202),
    [anon_sym_delete] = ACTIONS(2118),
    [anon_sym_throw] = ACTIONS(2205),
    [anon_sym_co_return] = ACTIONS(2208),
    [anon_sym_co_yield] = ACTIONS(2211),
    [anon_sym_R_DQUOTE] = ACTIONS(2130),
    [anon_sym_LR_DQUOTE] = ACTIONS(2130),
    [anon_sym_uR_DQUOTE] = ACTIONS(2130),
    [anon_sym_UR_DQUOTE] = ACTIONS(2130),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2130),
    [anon_sym_co_await] = ACTIONS(2133),
    [anon_sym_new] = ACTIONS(2136),
    [anon_sym_requires] = ACTIONS(2139),
    [sym_this] = ACTIONS(2103),
  },
  [172] = {
    [sym_attribute_declaration] = STATE(171),
    [sym_compound_statement] = STATE(462),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(462),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym__expression] = STATE(4447),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8027),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(171),
    [sym_identifier] = ACTIONS(2142),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1435),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_case] = ACTIONS(77),
    [anon_sym_default] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_do] = ACTIONS(83),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_return] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_goto] = ACTIONS(93),
    [anon_sym___try] = ACTIONS(1437),
    [anon_sym___leave] = ACTIONS(1439),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [173] = {
    [sym_attribute_declaration] = STATE(136),
    [sym_compound_statement] = STATE(479),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(479),
    [sym_labeled_statement] = STATE(479),
    [sym_expression_statement] = STATE(479),
    [sym_if_statement] = STATE(479),
    [sym_switch_statement] = STATE(479),
    [sym_case_statement] = STATE(479),
    [sym_while_statement] = STATE(479),
    [sym_do_statement] = STATE(479),
    [sym_for_statement] = STATE(479),
    [sym_return_statement] = STATE(479),
    [sym_break_statement] = STATE(479),
    [sym_continue_statement] = STATE(479),
    [sym_goto_statement] = STATE(479),
    [sym_seh_try_statement] = STATE(479),
    [sym_seh_leave_statement] = STATE(479),
    [sym__expression] = STATE(4455),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(7649),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(479),
    [sym_co_return_statement] = STATE(479),
    [sym_co_yield_statement] = STATE(479),
    [sym_throw_statement] = STATE(479),
    [sym_try_statement] = STATE(479),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(136),
    [sym_identifier] = ACTIONS(1993),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(675),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(679),
    [anon_sym_switch] = ACTIONS(681),
    [anon_sym_case] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_while] = ACTIONS(687),
    [anon_sym_do] = ACTIONS(689),
    [anon_sym_for] = ACTIONS(691),
    [anon_sym_return] = ACTIONS(693),
    [anon_sym_break] = ACTIONS(695),
    [anon_sym_continue] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym___try] = ACTIONS(701),
    [anon_sym___leave] = ACTIONS(703),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_try] = ACTIONS(707),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(709),
    [anon_sym_co_return] = ACTIONS(719),
    [anon_sym_co_yield] = ACTIONS(721),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [174] = {
    [sym_attribute_declaration] = STATE(176),
    [sym_compound_statement] = STATE(227),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(227),
    [sym_labeled_statement] = STATE(227),
    [sym_expression_statement] = STATE(227),
    [sym_if_statement] = STATE(227),
    [sym_switch_statement] = STATE(227),
    [sym_case_statement] = STATE(227),
    [sym_while_statement] = STATE(227),
    [sym_do_statement] = STATE(227),
    [sym_for_statement] = STATE(227),
    [sym_return_statement] = STATE(227),
    [sym_break_statement] = STATE(227),
    [sym_continue_statement] = STATE(227),
    [sym_goto_statement] = STATE(227),
    [sym_seh_try_statement] = STATE(227),
    [sym_seh_leave_statement] = STATE(227),
    [sym__expression] = STATE(4420),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8126),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(227),
    [sym_co_return_statement] = STATE(227),
    [sym_co_yield_statement] = STATE(227),
    [sym_throw_statement] = STATE(227),
    [sym_try_statement] = STATE(227),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(176),
    [sym_identifier] = ACTIONS(2214),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(279),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(287),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(291),
    [anon_sym_switch] = ACTIONS(293),
    [anon_sym_case] = ACTIONS(295),
    [anon_sym_default] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(301),
    [anon_sym_for] = ACTIONS(303),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_break] = ACTIONS(307),
    [anon_sym_continue] = ACTIONS(309),
    [anon_sym_goto] = ACTIONS(311),
    [anon_sym___try] = ACTIONS(313),
    [anon_sym___leave] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_try] = ACTIONS(319),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(321),
    [anon_sym_co_return] = ACTIONS(331),
    [anon_sym_co_yield] = ACTIONS(333),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [175] = {
    [sym_attribute_declaration] = STATE(175),
    [sym_compound_statement] = STATE(495),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(495),
    [sym_labeled_statement] = STATE(495),
    [sym_expression_statement] = STATE(495),
    [sym_if_statement] = STATE(495),
    [sym_switch_statement] = STATE(495),
    [sym_case_statement] = STATE(495),
    [sym_while_statement] = STATE(495),
    [sym_do_statement] = STATE(495),
    [sym_for_statement] = STATE(495),
    [sym_return_statement] = STATE(495),
    [sym_break_statement] = STATE(495),
    [sym_continue_statement] = STATE(495),
    [sym_goto_statement] = STATE(495),
    [sym_seh_try_statement] = STATE(495),
    [sym_seh_leave_statement] = STATE(495),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(495),
    [sym_co_return_statement] = STATE(495),
    [sym_co_yield_statement] = STATE(495),
    [sym_throw_statement] = STATE(495),
    [sym_try_statement] = STATE(495),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(175),
    [sym_identifier] = ACTIONS(2297),
    [anon_sym_LPAREN2] = ACTIONS(2004),
    [anon_sym_BANG] = ACTIONS(2007),
    [anon_sym_TILDE] = ACTIONS(2007),
    [anon_sym_DASH] = ACTIONS(2010),
    [anon_sym_PLUS] = ACTIONS(2010),
    [anon_sym_STAR] = ACTIONS(2013),
    [anon_sym_AMP] = ACTIONS(2013),
    [anon_sym_SEMI] = ACTIONS(2157),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2022),
    [anon_sym_LBRACE] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(2028),
    [aux_sym_primitive_type_token1] = ACTIONS(2031),
    [anon_sym_byte] = ACTIONS(2031),
    [anon_sym_word] = ACTIONS(2031),
    [anon_sym_if] = ACTIONS(2303),
    [anon_sym_switch] = ACTIONS(2306),
    [anon_sym_case] = ACTIONS(2309),
    [anon_sym_default] = ACTIONS(2312),
    [anon_sym_while] = ACTIONS(2315),
    [anon_sym_do] = ACTIONS(2318),
    [anon_sym_for] = ACTIONS(2321),
    [anon_sym_return] = ACTIONS(2324),
    [anon_sym_break] = ACTIONS(2327),
    [anon_sym_continue] = ACTIONS(2330),
    [anon_sym_goto] = ACTIONS(2333),
    [anon_sym___try] = ACTIONS(2336),
    [anon_sym___leave] = ACTIONS(2199),
    [anon_sym_not] = ACTIONS(2010),
    [anon_sym_compl] = ACTIONS(2010),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_sizeof] = ACTIONS(2076),
    [anon_sym___alignof__] = ACTIONS(2079),
    [anon_sym___alignof] = ACTIONS(2079),
    [anon_sym__alignof] = ACTIONS(2079),
    [anon_sym_alignof] = ACTIONS(2079),
    [anon_sym__Alignof] = ACTIONS(2079),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2085),
    [anon_sym_asm] = ACTIONS(2088),
    [anon_sym___asm__] = ACTIONS(2088),
    [aux_sym_number_literal_token1] = ACTIONS(2091),
    [aux_sym_number_literal_token2] = ACTIONS(2094),
    [anon_sym_L_SQUOTE] = ACTIONS(2097),
    [anon_sym_u_SQUOTE] = ACTIONS(2097),
    [anon_sym_U_SQUOTE] = ACTIONS(2097),
    [anon_sym_u8_SQUOTE] = ACTIONS(2097),
    [anon_sym_SQUOTE] = ACTIONS(2097),
    [anon_sym_L_DQUOTE] = ACTIONS(2100),
    [anon_sym_u_DQUOTE] = ACTIONS(2100),
    [anon_sym_U_DQUOTE] = ACTIONS(2100),
    [anon_sym_u8_DQUOTE] = ACTIONS(2100),
    [anon_sym_DQUOTE] = ACTIONS(2100),
    [sym_true] = ACTIONS(2103),
    [sym_false] = ACTIONS(2103),
    [anon_sym_NULL] = ACTIONS(2106),
    [anon_sym_nullptr] = ACTIONS(2106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2109),
    [anon_sym_template] = ACTIONS(2112),
    [anon_sym_try] = ACTIONS(2339),
    [anon_sym_delete] = ACTIONS(2118),
    [anon_sym_throw] = ACTIONS(2342),
    [anon_sym_co_return] = ACTIONS(2345),
    [anon_sym_co_yield] = ACTIONS(2348),
    [anon_sym_R_DQUOTE] = ACTIONS(2130),
    [anon_sym_LR_DQUOTE] = ACTIONS(2130),
    [anon_sym_uR_DQUOTE] = ACTIONS(2130),
    [anon_sym_UR_DQUOTE] = ACTIONS(2130),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2130),
    [anon_sym_co_await] = ACTIONS(2133),
    [anon_sym_new] = ACTIONS(2136),
    [anon_sym_requires] = ACTIONS(2139),
    [sym_this] = ACTIONS(2103),
  },
  [176] = {
    [sym_attribute_declaration] = STATE(178),
    [sym_compound_statement] = STATE(255),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(255),
    [sym_labeled_statement] = STATE(255),
    [sym_expression_statement] = STATE(255),
    [sym_if_statement] = STATE(255),
    [sym_switch_statement] = STATE(255),
    [sym_case_statement] = STATE(255),
    [sym_while_statement] = STATE(255),
    [sym_do_statement] = STATE(255),
    [sym_for_statement] = STATE(255),
    [sym_return_statement] = STATE(255),
    [sym_break_statement] = STATE(255),
    [sym_continue_statement] = STATE(255),
    [sym_goto_statement] = STATE(255),
    [sym_seh_try_statement] = STATE(255),
    [sym_seh_leave_statement] = STATE(255),
    [sym__expression] = STATE(4420),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8126),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(255),
    [sym_co_return_statement] = STATE(255),
    [sym_co_yield_statement] = STATE(255),
    [sym_throw_statement] = STATE(255),
    [sym_try_statement] = STATE(255),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(178),
    [sym_identifier] = ACTIONS(2214),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(279),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(287),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(291),
    [anon_sym_switch] = ACTIONS(293),
    [anon_sym_case] = ACTIONS(295),
    [anon_sym_default] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(301),
    [anon_sym_for] = ACTIONS(303),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_break] = ACTIONS(307),
    [anon_sym_continue] = ACTIONS(309),
    [anon_sym_goto] = ACTIONS(311),
    [anon_sym___try] = ACTIONS(313),
    [anon_sym___leave] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_try] = ACTIONS(319),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(321),
    [anon_sym_co_return] = ACTIONS(331),
    [anon_sym_co_yield] = ACTIONS(333),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [177] = {
    [sym_attribute_declaration] = STATE(173),
    [sym_compound_statement] = STATE(437),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(437),
    [sym_labeled_statement] = STATE(437),
    [sym_expression_statement] = STATE(437),
    [sym_if_statement] = STATE(437),
    [sym_switch_statement] = STATE(437),
    [sym_case_statement] = STATE(437),
    [sym_while_statement] = STATE(437),
    [sym_do_statement] = STATE(437),
    [sym_for_statement] = STATE(437),
    [sym_return_statement] = STATE(437),
    [sym_break_statement] = STATE(437),
    [sym_continue_statement] = STATE(437),
    [sym_goto_statement] = STATE(437),
    [sym_seh_try_statement] = STATE(437),
    [sym_seh_leave_statement] = STATE(437),
    [sym__expression] = STATE(4455),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(7649),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(437),
    [sym_co_return_statement] = STATE(437),
    [sym_co_yield_statement] = STATE(437),
    [sym_throw_statement] = STATE(437),
    [sym_try_statement] = STATE(437),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(173),
    [sym_identifier] = ACTIONS(1993),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(675),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(679),
    [anon_sym_switch] = ACTIONS(681),
    [anon_sym_case] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_while] = ACTIONS(687),
    [anon_sym_do] = ACTIONS(689),
    [anon_sym_for] = ACTIONS(691),
    [anon_sym_return] = ACTIONS(693),
    [anon_sym_break] = ACTIONS(695),
    [anon_sym_continue] = ACTIONS(697),
    [anon_sym_goto] = ACTIONS(699),
    [anon_sym___try] = ACTIONS(701),
    [anon_sym___leave] = ACTIONS(703),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_try] = ACTIONS(707),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(709),
    [anon_sym_co_return] = ACTIONS(719),
    [anon_sym_co_yield] = ACTIONS(721),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [178] = {
    [sym_attribute_declaration] = STATE(178),
    [sym_compound_statement] = STATE(255),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(255),
    [sym_labeled_statement] = STATE(255),
    [sym_expression_statement] = STATE(255),
    [sym_if_statement] = STATE(255),
    [sym_switch_statement] = STATE(255),
    [sym_case_statement] = STATE(255),
    [sym_while_statement] = STATE(255),
    [sym_do_statement] = STATE(255),
    [sym_for_statement] = STATE(255),
    [sym_return_statement] = STATE(255),
    [sym_break_statement] = STATE(255),
    [sym_continue_statement] = STATE(255),
    [sym_goto_statement] = STATE(255),
    [sym_seh_try_statement] = STATE(255),
    [sym_seh_leave_statement] = STATE(255),
    [sym__expression] = STATE(4420),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8126),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(255),
    [sym_co_return_statement] = STATE(255),
    [sym_co_yield_statement] = STATE(255),
    [sym_throw_statement] = STATE(255),
    [sym_try_statement] = STATE(255),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(178),
    [sym_identifier] = ACTIONS(2351),
    [anon_sym_LPAREN2] = ACTIONS(2004),
    [anon_sym_BANG] = ACTIONS(2007),
    [anon_sym_TILDE] = ACTIONS(2007),
    [anon_sym_DASH] = ACTIONS(2010),
    [anon_sym_PLUS] = ACTIONS(2010),
    [anon_sym_STAR] = ACTIONS(2013),
    [anon_sym_AMP] = ACTIONS(2013),
    [anon_sym_SEMI] = ACTIONS(2354),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2022),
    [anon_sym_LBRACE] = ACTIONS(2357),
    [anon_sym_LBRACK] = ACTIONS(2028),
    [aux_sym_primitive_type_token1] = ACTIONS(2031),
    [anon_sym_byte] = ACTIONS(2031),
    [anon_sym_word] = ACTIONS(2031),
    [anon_sym_if] = ACTIONS(2360),
    [anon_sym_switch] = ACTIONS(2363),
    [anon_sym_case] = ACTIONS(2366),
    [anon_sym_default] = ACTIONS(2369),
    [anon_sym_while] = ACTIONS(2372),
    [anon_sym_do] = ACTIONS(2375),
    [anon_sym_for] = ACTIONS(2378),
    [anon_sym_return] = ACTIONS(2381),
    [anon_sym_break] = ACTIONS(2384),
    [anon_sym_continue] = ACTIONS(2387),
    [anon_sym_goto] = ACTIONS(2390),
    [anon_sym___try] = ACTIONS(2393),
    [anon_sym___leave] = ACTIONS(2396),
    [anon_sym_not] = ACTIONS(2010),
    [anon_sym_compl] = ACTIONS(2010),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_sizeof] = ACTIONS(2076),
    [anon_sym___alignof__] = ACTIONS(2079),
    [anon_sym___alignof] = ACTIONS(2079),
    [anon_sym__alignof] = ACTIONS(2079),
    [anon_sym_alignof] = ACTIONS(2079),
    [anon_sym__Alignof] = ACTIONS(2079),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2085),
    [anon_sym_asm] = ACTIONS(2088),
    [anon_sym___asm__] = ACTIONS(2088),
    [aux_sym_number_literal_token1] = ACTIONS(2091),
    [aux_sym_number_literal_token2] = ACTIONS(2094),
    [anon_sym_L_SQUOTE] = ACTIONS(2097),
    [anon_sym_u_SQUOTE] = ACTIONS(2097),
    [anon_sym_U_SQUOTE] = ACTIONS(2097),
    [anon_sym_u8_SQUOTE] = ACTIONS(2097),
    [anon_sym_SQUOTE] = ACTIONS(2097),
    [anon_sym_L_DQUOTE] = ACTIONS(2100),
    [anon_sym_u_DQUOTE] = ACTIONS(2100),
    [anon_sym_U_DQUOTE] = ACTIONS(2100),
    [anon_sym_u8_DQUOTE] = ACTIONS(2100),
    [anon_sym_DQUOTE] = ACTIONS(2100),
    [sym_true] = ACTIONS(2103),
    [sym_false] = ACTIONS(2103),
    [anon_sym_NULL] = ACTIONS(2106),
    [anon_sym_nullptr] = ACTIONS(2106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2109),
    [anon_sym_template] = ACTIONS(2112),
    [anon_sym_try] = ACTIONS(2399),
    [anon_sym_delete] = ACTIONS(2118),
    [anon_sym_throw] = ACTIONS(2402),
    [anon_sym_co_return] = ACTIONS(2405),
    [anon_sym_co_yield] = ACTIONS(2408),
    [anon_sym_R_DQUOTE] = ACTIONS(2130),
    [anon_sym_LR_DQUOTE] = ACTIONS(2130),
    [anon_sym_uR_DQUOTE] = ACTIONS(2130),
    [anon_sym_UR_DQUOTE] = ACTIONS(2130),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2130),
    [anon_sym_co_await] = ACTIONS(2133),
    [anon_sym_new] = ACTIONS(2136),
    [anon_sym_requires] = ACTIONS(2139),
    [sym_this] = ACTIONS(2103),
  },
  [179] = {
    [sym_attribute_declaration] = STATE(170),
    [sym_compound_statement] = STATE(557),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(557),
    [sym_labeled_statement] = STATE(557),
    [sym_expression_statement] = STATE(557),
    [sym_if_statement] = STATE(557),
    [sym_switch_statement] = STATE(557),
    [sym_case_statement] = STATE(557),
    [sym_while_statement] = STATE(557),
    [sym_do_statement] = STATE(557),
    [sym_for_statement] = STATE(557),
    [sym_return_statement] = STATE(557),
    [sym_break_statement] = STATE(557),
    [sym_continue_statement] = STATE(557),
    [sym_goto_statement] = STATE(557),
    [sym_seh_try_statement] = STATE(557),
    [sym_seh_leave_statement] = STATE(557),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(557),
    [sym_co_return_statement] = STATE(557),
    [sym_co_yield_statement] = STATE(557),
    [sym_throw_statement] = STATE(557),
    [sym_try_statement] = STATE(557),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [180] = {
    [sym_attribute_declaration] = STATE(157),
    [sym_compound_statement] = STATE(1035),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(1035),
    [sym_labeled_statement] = STATE(1035),
    [sym_expression_statement] = STATE(1035),
    [sym_if_statement] = STATE(1035),
    [sym_switch_statement] = STATE(1035),
    [sym_case_statement] = STATE(1035),
    [sym_while_statement] = STATE(1035),
    [sym_do_statement] = STATE(1035),
    [sym_for_statement] = STATE(1035),
    [sym_return_statement] = STATE(1035),
    [sym_break_statement] = STATE(1035),
    [sym_continue_statement] = STATE(1035),
    [sym_goto_statement] = STATE(1035),
    [sym_seh_try_statement] = STATE(1035),
    [sym_seh_leave_statement] = STATE(1035),
    [sym__expression] = STATE(4433),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(7776),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(1035),
    [sym_co_return_statement] = STATE(1035),
    [sym_co_yield_statement] = STATE(1035),
    [sym_throw_statement] = STATE(1035),
    [sym_try_statement] = STATE(1035),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(157),
    [sym_identifier] = ACTIONS(1995),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(1633),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(1635),
    [anon_sym_switch] = ACTIONS(1637),
    [anon_sym_case] = ACTIONS(1997),
    [anon_sym_default] = ACTIONS(1999),
    [anon_sym_while] = ACTIONS(1639),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_for] = ACTIONS(1643),
    [anon_sym_return] = ACTIONS(1645),
    [anon_sym_break] = ACTIONS(1647),
    [anon_sym_continue] = ACTIONS(1649),
    [anon_sym_goto] = ACTIONS(1651),
    [anon_sym___try] = ACTIONS(1653),
    [anon_sym___leave] = ACTIONS(1655),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_try] = ACTIONS(1657),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(1659),
    [anon_sym_co_return] = ACTIONS(1661),
    [anon_sym_co_yield] = ACTIONS(1663),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [181] = {
    [sym_attribute_declaration] = STATE(170),
    [sym_compound_statement] = STATE(523),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(523),
    [sym_labeled_statement] = STATE(523),
    [sym_expression_statement] = STATE(523),
    [sym_if_statement] = STATE(523),
    [sym_switch_statement] = STATE(523),
    [sym_case_statement] = STATE(523),
    [sym_while_statement] = STATE(523),
    [sym_do_statement] = STATE(523),
    [sym_for_statement] = STATE(523),
    [sym_return_statement] = STATE(523),
    [sym_break_statement] = STATE(523),
    [sym_continue_statement] = STATE(523),
    [sym_goto_statement] = STATE(523),
    [sym_seh_try_statement] = STATE(523),
    [sym_seh_leave_statement] = STATE(523),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(523),
    [sym_co_return_statement] = STATE(523),
    [sym_co_yield_statement] = STATE(523),
    [sym_throw_statement] = STATE(523),
    [sym_try_statement] = STATE(523),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [182] = {
    [sym_attribute_declaration] = STATE(170),
    [sym_compound_statement] = STATE(520),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(520),
    [sym_labeled_statement] = STATE(520),
    [sym_expression_statement] = STATE(520),
    [sym_if_statement] = STATE(520),
    [sym_switch_statement] = STATE(520),
    [sym_case_statement] = STATE(520),
    [sym_while_statement] = STATE(520),
    [sym_do_statement] = STATE(520),
    [sym_for_statement] = STATE(520),
    [sym_return_statement] = STATE(520),
    [sym_break_statement] = STATE(520),
    [sym_continue_statement] = STATE(520),
    [sym_goto_statement] = STATE(520),
    [sym_seh_try_statement] = STATE(520),
    [sym_seh_leave_statement] = STATE(520),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(520),
    [sym_co_return_statement] = STATE(520),
    [sym_co_yield_statement] = STATE(520),
    [sym_throw_statement] = STATE(520),
    [sym_try_statement] = STATE(520),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [183] = {
    [sym_attribute_declaration] = STATE(170),
    [sym_compound_statement] = STATE(559),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(561),
    [sym_labeled_statement] = STATE(563),
    [sym_expression_statement] = STATE(564),
    [sym_if_statement] = STATE(565),
    [sym_switch_statement] = STATE(567),
    [sym_case_statement] = STATE(573),
    [sym_while_statement] = STATE(580),
    [sym_do_statement] = STATE(588),
    [sym_for_statement] = STATE(602),
    [sym_return_statement] = STATE(616),
    [sym_break_statement] = STATE(619),
    [sym_continue_statement] = STATE(621),
    [sym_goto_statement] = STATE(622),
    [sym_seh_try_statement] = STATE(624),
    [sym_seh_leave_statement] = STATE(625),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(628),
    [sym_co_return_statement] = STATE(629),
    [sym_co_yield_statement] = STATE(632),
    [sym_throw_statement] = STATE(633),
    [sym_try_statement] = STATE(635),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [184] = {
    [sym_attribute_declaration] = STATE(170),
    [sym_compound_statement] = STATE(636),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(643),
    [sym_labeled_statement] = STATE(646),
    [sym_expression_statement] = STATE(647),
    [sym_if_statement] = STATE(650),
    [sym_switch_statement] = STATE(652),
    [sym_case_statement] = STATE(653),
    [sym_while_statement] = STATE(655),
    [sym_do_statement] = STATE(659),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(669),
    [sym_break_statement] = STATE(668),
    [sym_continue_statement] = STATE(667),
    [sym_goto_statement] = STATE(666),
    [sym_seh_try_statement] = STATE(665),
    [sym_seh_leave_statement] = STATE(664),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(663),
    [sym_co_return_statement] = STATE(662),
    [sym_co_yield_statement] = STATE(661),
    [sym_throw_statement] = STATE(660),
    [sym_try_statement] = STATE(656),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [185] = {
    [sym_attribute_declaration] = STATE(170),
    [sym_compound_statement] = STATE(434),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(434),
    [sym_labeled_statement] = STATE(434),
    [sym_expression_statement] = STATE(434),
    [sym_if_statement] = STATE(434),
    [sym_switch_statement] = STATE(434),
    [sym_case_statement] = STATE(434),
    [sym_while_statement] = STATE(434),
    [sym_do_statement] = STATE(434),
    [sym_for_statement] = STATE(434),
    [sym_return_statement] = STATE(434),
    [sym_break_statement] = STATE(434),
    [sym_continue_statement] = STATE(434),
    [sym_goto_statement] = STATE(434),
    [sym_seh_try_statement] = STATE(434),
    [sym_seh_leave_statement] = STATE(434),
    [sym__expression] = STATE(4431),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8211),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(434),
    [sym_co_return_statement] = STATE(434),
    [sym_co_yield_statement] = STATE(434),
    [sym_throw_statement] = STATE(434),
    [sym_try_statement] = STATE(434),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(170),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_try] = ACTIONS(223),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(225),
    [anon_sym_co_return] = ACTIONS(235),
    [anon_sym_co_yield] = ACTIONS(237),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [186] = {
    [sym_attribute_declaration] = STATE(172),
    [sym_compound_statement] = STATE(427),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(427),
    [sym_labeled_statement] = STATE(427),
    [sym_expression_statement] = STATE(427),
    [sym_if_statement] = STATE(427),
    [sym_switch_statement] = STATE(427),
    [sym_case_statement] = STATE(427),
    [sym_while_statement] = STATE(427),
    [sym_do_statement] = STATE(427),
    [sym_for_statement] = STATE(427),
    [sym_return_statement] = STATE(427),
    [sym_break_statement] = STATE(427),
    [sym_continue_statement] = STATE(427),
    [sym_goto_statement] = STATE(427),
    [sym_seh_try_statement] = STATE(427),
    [sym_seh_leave_statement] = STATE(427),
    [sym__expression] = STATE(4447),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8027),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(427),
    [sym_co_return_statement] = STATE(427),
    [sym_co_yield_statement] = STATE(427),
    [sym_throw_statement] = STATE(427),
    [sym_try_statement] = STATE(427),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(172),
    [sym_identifier] = ACTIONS(2142),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1435),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_case] = ACTIONS(77),
    [anon_sym_default] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_do] = ACTIONS(83),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_return] = ACTIONS(87),
    [anon_sym_break] = ACTIONS(89),
    [anon_sym_continue] = ACTIONS(91),
    [anon_sym_goto] = ACTIONS(93),
    [anon_sym___try] = ACTIONS(1437),
    [anon_sym___leave] = ACTIONS(1439),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [187] = {
    [sym_attribute_declaration] = STATE(187),
    [sym_compound_statement] = STATE(1039),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(1039),
    [sym_labeled_statement] = STATE(1039),
    [sym_expression_statement] = STATE(1039),
    [sym_if_statement] = STATE(1039),
    [sym_switch_statement] = STATE(1039),
    [sym_case_statement] = STATE(1039),
    [sym_while_statement] = STATE(1039),
    [sym_do_statement] = STATE(1039),
    [sym_for_statement] = STATE(1039),
    [sym_return_statement] = STATE(1039),
    [sym_break_statement] = STATE(1039),
    [sym_continue_statement] = STATE(1039),
    [sym_goto_statement] = STATE(1039),
    [sym_seh_try_statement] = STATE(1039),
    [sym_seh_leave_statement] = STATE(1039),
    [sym__expression] = STATE(4433),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(7776),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(1039),
    [sym_co_return_statement] = STATE(1039),
    [sym_co_yield_statement] = STATE(1039),
    [sym_throw_statement] = STATE(1039),
    [sym_try_statement] = STATE(1039),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(187),
    [sym_identifier] = ACTIONS(2411),
    [anon_sym_LPAREN2] = ACTIONS(2004),
    [anon_sym_BANG] = ACTIONS(2007),
    [anon_sym_TILDE] = ACTIONS(2007),
    [anon_sym_DASH] = ACTIONS(2010),
    [anon_sym_PLUS] = ACTIONS(2010),
    [anon_sym_STAR] = ACTIONS(2013),
    [anon_sym_AMP] = ACTIONS(2013),
    [anon_sym_SEMI] = ACTIONS(2414),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2022),
    [anon_sym_LBRACE] = ACTIONS(2417),
    [anon_sym_LBRACK] = ACTIONS(2028),
    [aux_sym_primitive_type_token1] = ACTIONS(2031),
    [anon_sym_byte] = ACTIONS(2031),
    [anon_sym_word] = ACTIONS(2031),
    [anon_sym_if] = ACTIONS(2420),
    [anon_sym_switch] = ACTIONS(2423),
    [anon_sym_case] = ACTIONS(2169),
    [anon_sym_default] = ACTIONS(2172),
    [anon_sym_while] = ACTIONS(2426),
    [anon_sym_do] = ACTIONS(2429),
    [anon_sym_for] = ACTIONS(2432),
    [anon_sym_return] = ACTIONS(2435),
    [anon_sym_break] = ACTIONS(2438),
    [anon_sym_continue] = ACTIONS(2441),
    [anon_sym_goto] = ACTIONS(2444),
    [anon_sym___try] = ACTIONS(2447),
    [anon_sym___leave] = ACTIONS(2450),
    [anon_sym_not] = ACTIONS(2010),
    [anon_sym_compl] = ACTIONS(2010),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_sizeof] = ACTIONS(2076),
    [anon_sym___alignof__] = ACTIONS(2079),
    [anon_sym___alignof] = ACTIONS(2079),
    [anon_sym__alignof] = ACTIONS(2079),
    [anon_sym_alignof] = ACTIONS(2079),
    [anon_sym__Alignof] = ACTIONS(2079),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2085),
    [anon_sym_asm] = ACTIONS(2088),
    [anon_sym___asm__] = ACTIONS(2088),
    [aux_sym_number_literal_token1] = ACTIONS(2091),
    [aux_sym_number_literal_token2] = ACTIONS(2094),
    [anon_sym_L_SQUOTE] = ACTIONS(2097),
    [anon_sym_u_SQUOTE] = ACTIONS(2097),
    [anon_sym_U_SQUOTE] = ACTIONS(2097),
    [anon_sym_u8_SQUOTE] = ACTIONS(2097),
    [anon_sym_SQUOTE] = ACTIONS(2097),
    [anon_sym_L_DQUOTE] = ACTIONS(2100),
    [anon_sym_u_DQUOTE] = ACTIONS(2100),
    [anon_sym_U_DQUOTE] = ACTIONS(2100),
    [anon_sym_u8_DQUOTE] = ACTIONS(2100),
    [anon_sym_DQUOTE] = ACTIONS(2100),
    [sym_true] = ACTIONS(2103),
    [sym_false] = ACTIONS(2103),
    [anon_sym_NULL] = ACTIONS(2106),
    [anon_sym_nullptr] = ACTIONS(2106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2109),
    [anon_sym_template] = ACTIONS(2112),
    [anon_sym_try] = ACTIONS(2453),
    [anon_sym_delete] = ACTIONS(2118),
    [anon_sym_throw] = ACTIONS(2456),
    [anon_sym_co_return] = ACTIONS(2459),
    [anon_sym_co_yield] = ACTIONS(2462),
    [anon_sym_R_DQUOTE] = ACTIONS(2130),
    [anon_sym_LR_DQUOTE] = ACTIONS(2130),
    [anon_sym_uR_DQUOTE] = ACTIONS(2130),
    [anon_sym_UR_DQUOTE] = ACTIONS(2130),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2130),
    [anon_sym_co_await] = ACTIONS(2133),
    [anon_sym_new] = ACTIONS(2136),
    [anon_sym_requires] = ACTIONS(2139),
    [sym_this] = ACTIONS(2103),
  },
  [188] = {
    [sym_attribute_declaration] = STATE(176),
    [sym_compound_statement] = STATE(258),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(259),
    [sym_labeled_statement] = STATE(260),
    [sym_expression_statement] = STATE(261),
    [sym_if_statement] = STATE(264),
    [sym_switch_statement] = STATE(269),
    [sym_case_statement] = STATE(270),
    [sym_while_statement] = STATE(272),
    [sym_do_statement] = STATE(273),
    [sym_for_statement] = STATE(274),
    [sym_return_statement] = STATE(276),
    [sym_break_statement] = STATE(277),
    [sym_continue_statement] = STATE(279),
    [sym_goto_statement] = STATE(280),
    [sym_seh_try_statement] = STATE(281),
    [sym_seh_leave_statement] = STATE(282),
    [sym__expression] = STATE(4420),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8126),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(288),
    [sym_co_return_statement] = STATE(290),
    [sym_co_yield_statement] = STATE(292),
    [sym_throw_statement] = STATE(296),
    [sym_try_statement] = STATE(297),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(176),
    [sym_identifier] = ACTIONS(2214),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(279),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(287),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(291),
    [anon_sym_switch] = ACTIONS(293),
    [anon_sym_case] = ACTIONS(295),
    [anon_sym_default] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(301),
    [anon_sym_for] = ACTIONS(303),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_break] = ACTIONS(307),
    [anon_sym_continue] = ACTIONS(309),
    [anon_sym_goto] = ACTIONS(311),
    [anon_sym___try] = ACTIONS(313),
    [anon_sym___leave] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_try] = ACTIONS(319),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(321),
    [anon_sym_co_return] = ACTIONS(331),
    [anon_sym_co_yield] = ACTIONS(333),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [189] = {
    [sym_attribute_declaration] = STATE(176),
    [sym_compound_statement] = STATE(306),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(302),
    [sym_labeled_statement] = STATE(301),
    [sym_expression_statement] = STATE(300),
    [sym_if_statement] = STATE(299),
    [sym_switch_statement] = STATE(295),
    [sym_case_statement] = STATE(293),
    [sym_while_statement] = STATE(287),
    [sym_do_statement] = STATE(235),
    [sym_for_statement] = STATE(234),
    [sym_return_statement] = STATE(238),
    [sym_break_statement] = STATE(239),
    [sym_continue_statement] = STATE(240),
    [sym_goto_statement] = STATE(247),
    [sym_seh_try_statement] = STATE(249),
    [sym_seh_leave_statement] = STATE(250),
    [sym__expression] = STATE(4420),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8126),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(251),
    [sym_co_return_statement] = STATE(252),
    [sym_co_yield_statement] = STATE(254),
    [sym_throw_statement] = STATE(256),
    [sym_try_statement] = STATE(257),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(176),
    [sym_identifier] = ACTIONS(2214),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(279),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(287),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(291),
    [anon_sym_switch] = ACTIONS(293),
    [anon_sym_case] = ACTIONS(295),
    [anon_sym_default] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(301),
    [anon_sym_for] = ACTIONS(303),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_break] = ACTIONS(307),
    [anon_sym_continue] = ACTIONS(309),
    [anon_sym_goto] = ACTIONS(311),
    [anon_sym___try] = ACTIONS(313),
    [anon_sym___leave] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_try] = ACTIONS(319),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(321),
    [anon_sym_co_return] = ACTIONS(331),
    [anon_sym_co_yield] = ACTIONS(333),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [190] = {
    [sym_attribute_declaration] = STATE(176),
    [sym_compound_statement] = STATE(312),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(312),
    [sym_labeled_statement] = STATE(312),
    [sym_expression_statement] = STATE(312),
    [sym_if_statement] = STATE(312),
    [sym_switch_statement] = STATE(312),
    [sym_case_statement] = STATE(312),
    [sym_while_statement] = STATE(312),
    [sym_do_statement] = STATE(312),
    [sym_for_statement] = STATE(312),
    [sym_return_statement] = STATE(312),
    [sym_break_statement] = STATE(312),
    [sym_continue_statement] = STATE(312),
    [sym_goto_statement] = STATE(312),
    [sym_seh_try_statement] = STATE(312),
    [sym_seh_leave_statement] = STATE(312),
    [sym__expression] = STATE(4420),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8126),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(312),
    [sym_co_return_statement] = STATE(312),
    [sym_co_yield_statement] = STATE(312),
    [sym_throw_statement] = STATE(312),
    [sym_try_statement] = STATE(312),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(176),
    [sym_identifier] = ACTIONS(2214),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(279),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(287),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(291),
    [anon_sym_switch] = ACTIONS(293),
    [anon_sym_case] = ACTIONS(295),
    [anon_sym_default] = ACTIONS(297),
    [anon_sym_while] = ACTIONS(299),
    [anon_sym_do] = ACTIONS(301),
    [anon_sym_for] = ACTIONS(303),
    [anon_sym_return] = ACTIONS(305),
    [anon_sym_break] = ACTIONS(307),
    [anon_sym_continue] = ACTIONS(309),
    [anon_sym_goto] = ACTIONS(311),
    [anon_sym___try] = ACTIONS(313),
    [anon_sym___leave] = ACTIONS(315),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_try] = ACTIONS(319),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(321),
    [anon_sym_co_return] = ACTIONS(331),
    [anon_sym_co_yield] = ACTIONS(333),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [191] = {
    [sym_attribute_declaration] = STATE(157),
    [sym_compound_statement] = STATE(964),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(964),
    [sym_labeled_statement] = STATE(964),
    [sym_expression_statement] = STATE(964),
    [sym_if_statement] = STATE(964),
    [sym_switch_statement] = STATE(964),
    [sym_case_statement] = STATE(964),
    [sym_while_statement] = STATE(964),
    [sym_do_statement] = STATE(964),
    [sym_for_statement] = STATE(964),
    [sym_return_statement] = STATE(964),
    [sym_break_statement] = STATE(964),
    [sym_continue_statement] = STATE(964),
    [sym_goto_statement] = STATE(964),
    [sym_seh_try_statement] = STATE(964),
    [sym_seh_leave_statement] = STATE(964),
    [sym__expression] = STATE(4433),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(7776),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(964),
    [sym_co_return_statement] = STATE(964),
    [sym_co_yield_statement] = STATE(964),
    [sym_throw_statement] = STATE(964),
    [sym_try_statement] = STATE(964),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(157),
    [sym_identifier] = ACTIONS(1995),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(1633),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(1635),
    [anon_sym_switch] = ACTIONS(1637),
    [anon_sym_case] = ACTIONS(1997),
    [anon_sym_default] = ACTIONS(1999),
    [anon_sym_while] = ACTIONS(1639),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_for] = ACTIONS(1643),
    [anon_sym_return] = ACTIONS(1645),
    [anon_sym_break] = ACTIONS(1647),
    [anon_sym_continue] = ACTIONS(1649),
    [anon_sym_goto] = ACTIONS(1651),
    [anon_sym___try] = ACTIONS(1653),
    [anon_sym___leave] = ACTIONS(1655),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_try] = ACTIONS(1657),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(1659),
    [anon_sym_co_return] = ACTIONS(1661),
    [anon_sym_co_yield] = ACTIONS(1663),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [192] = {
    [sym_attribute_declaration] = STATE(157),
    [sym_compound_statement] = STATE(961),
    [sym_primitive_type] = STATE(6626),
    [sym_attributed_statement] = STATE(961),
    [sym_labeled_statement] = STATE(961),
    [sym_expression_statement] = STATE(961),
    [sym_if_statement] = STATE(961),
    [sym_switch_statement] = STATE(961),
    [sym_case_statement] = STATE(961),
    [sym_while_statement] = STATE(961),
    [sym_do_statement] = STATE(961),
    [sym_for_statement] = STATE(961),
    [sym_return_statement] = STATE(961),
    [sym_break_statement] = STATE(961),
    [sym_continue_statement] = STATE(961),
    [sym_goto_statement] = STATE(961),
    [sym_seh_try_statement] = STATE(961),
    [sym_seh_leave_statement] = STATE(961),
    [sym__expression] = STATE(4433),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(7776),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_for_range_loop] = STATE(961),
    [sym_co_return_statement] = STATE(961),
    [sym_co_yield_statement] = STATE(961),
    [sym_throw_statement] = STATE(961),
    [sym_try_statement] = STATE(961),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_attributed_declarator_repeat1] = STATE(157),
    [sym_identifier] = ACTIONS(1995),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(1633),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(1635),
    [anon_sym_switch] = ACTIONS(1637),
    [anon_sym_case] = ACTIONS(1997),
    [anon_sym_default] = ACTIONS(1999),
    [anon_sym_while] = ACTIONS(1639),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_for] = ACTIONS(1643),
    [anon_sym_return] = ACTIONS(1645),
    [anon_sym_break] = ACTIONS(1647),
    [anon_sym_continue] = ACTIONS(1649),
    [anon_sym_goto] = ACTIONS(1651),
    [anon_sym___try] = ACTIONS(1653),
    [anon_sym___leave] = ACTIONS(1655),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_try] = ACTIONS(1657),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(1659),
    [anon_sym_co_return] = ACTIONS(1661),
    [anon_sym_co_yield] = ACTIONS(1663),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [193] = {
    [sym_type_qualifier] = STATE(3883),
    [sym__type_specifier] = STATE(4794),
    [sym_sized_type_specifier] = STATE(1990),
    [sym_primitive_type] = STATE(5089),
    [sym_enum_specifier] = STATE(1990),
    [sym_struct_specifier] = STATE(1990),
    [sym_union_specifier] = STATE(1990),
    [sym__expression] = STATE(2960),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_comma_expression] = STATE(8291),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_type_descriptor] = STATE(8134),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_placeholder_type_specifier] = STATE(1990),
    [sym_decltype_auto] = STATE(1973),
    [sym_decltype] = STATE(1874),
    [sym_class_specifier] = STATE(1990),
    [sym__class_name] = STATE(7357),
    [sym_dependent_type] = STATE(1990),
    [sym_template_type] = STATE(5228),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym__unary_left_fold] = STATE(8289),
    [sym__unary_right_fold] = STATE(8288),
    [sym__binary_fold] = STATE(8287),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5522),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(5253),
    [sym__assignment_expression_lhs] = STATE(8285),
    [sym_user_defined_literal] = STATE(3526),
    [aux_sym__type_definition_type_repeat1] = STATE(3883),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1898),
    [sym_identifier] = ACTIONS(2465),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1741),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_signed] = ACTIONS(1827),
    [anon_sym_unsigned] = ACTIONS(1827),
    [anon_sym_long] = ACTIONS(1827),
    [anon_sym_short] = ACTIONS(1827),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(1831),
    [anon_sym_byte] = ACTIONS(1831),
    [anon_sym_word] = ACTIONS(1831),
    [anon_sym_enum] = ACTIONS(1833),
    [anon_sym_class] = ACTIONS(1835),
    [anon_sym_struct] = ACTIONS(1837),
    [anon_sym_union] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1865),
    [anon_sym_decltype] = ACTIONS(1867),
    [anon_sym_typename] = ACTIONS(1869),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [194] = {
    [sym_type_qualifier] = STATE(3883),
    [sym__type_specifier] = STATE(4794),
    [sym_sized_type_specifier] = STATE(1990),
    [sym_primitive_type] = STATE(5089),
    [sym_enum_specifier] = STATE(1990),
    [sym_struct_specifier] = STATE(1990),
    [sym_union_specifier] = STATE(1990),
    [sym__expression] = STATE(2960),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_comma_expression] = STATE(8291),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_type_descriptor] = STATE(8180),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_placeholder_type_specifier] = STATE(1990),
    [sym_decltype_auto] = STATE(1973),
    [sym_decltype] = STATE(1874),
    [sym_class_specifier] = STATE(1990),
    [sym__class_name] = STATE(7357),
    [sym_dependent_type] = STATE(1990),
    [sym_template_type] = STATE(5228),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym__unary_left_fold] = STATE(8289),
    [sym__unary_right_fold] = STATE(8288),
    [sym__binary_fold] = STATE(8287),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5522),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(5253),
    [sym__assignment_expression_lhs] = STATE(8285),
    [sym_user_defined_literal] = STATE(3526),
    [aux_sym__type_definition_type_repeat1] = STATE(3883),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1898),
    [sym_identifier] = ACTIONS(2465),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1741),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_signed] = ACTIONS(1827),
    [anon_sym_unsigned] = ACTIONS(1827),
    [anon_sym_long] = ACTIONS(1827),
    [anon_sym_short] = ACTIONS(1827),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(1831),
    [anon_sym_byte] = ACTIONS(1831),
    [anon_sym_word] = ACTIONS(1831),
    [anon_sym_enum] = ACTIONS(1833),
    [anon_sym_class] = ACTIONS(1835),
    [anon_sym_struct] = ACTIONS(1837),
    [anon_sym_union] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1865),
    [anon_sym_decltype] = ACTIONS(1867),
    [anon_sym_typename] = ACTIONS(1869),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [195] = {
    [sym_type_qualifier] = STATE(3883),
    [sym__type_specifier] = STATE(4794),
    [sym_sized_type_specifier] = STATE(1990),
    [sym_primitive_type] = STATE(5089),
    [sym_enum_specifier] = STATE(1990),
    [sym_struct_specifier] = STATE(1990),
    [sym_union_specifier] = STATE(1990),
    [sym__expression] = STATE(2927),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_comma_expression] = STATE(8403),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_type_descriptor] = STATE(8125),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_placeholder_type_specifier] = STATE(1990),
    [sym_decltype_auto] = STATE(1973),
    [sym_decltype] = STATE(1874),
    [sym_class_specifier] = STATE(1990),
    [sym__class_name] = STATE(7357),
    [sym_dependent_type] = STATE(1990),
    [sym_template_type] = STATE(5228),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym__unary_left_fold] = STATE(8124),
    [sym__unary_right_fold] = STATE(8123),
    [sym__binary_fold] = STATE(8122),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5522),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(5253),
    [sym__assignment_expression_lhs] = STATE(8397),
    [sym_user_defined_literal] = STATE(3526),
    [aux_sym__type_definition_type_repeat1] = STATE(3883),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1898),
    [sym_identifier] = ACTIONS(2465),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1741),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_signed] = ACTIONS(1827),
    [anon_sym_unsigned] = ACTIONS(1827),
    [anon_sym_long] = ACTIONS(1827),
    [anon_sym_short] = ACTIONS(1827),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(1831),
    [anon_sym_byte] = ACTIONS(1831),
    [anon_sym_word] = ACTIONS(1831),
    [anon_sym_enum] = ACTIONS(1833),
    [anon_sym_class] = ACTIONS(1835),
    [anon_sym_struct] = ACTIONS(1837),
    [anon_sym_union] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1865),
    [anon_sym_decltype] = ACTIONS(1867),
    [anon_sym_typename] = ACTIONS(1869),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [196] = {
    [sym_type_qualifier] = STATE(3883),
    [sym__type_specifier] = STATE(4794),
    [sym_sized_type_specifier] = STATE(1990),
    [sym_primitive_type] = STATE(5089),
    [sym_enum_specifier] = STATE(1990),
    [sym_struct_specifier] = STATE(1990),
    [sym_union_specifier] = STATE(1990),
    [sym__expression] = STATE(2960),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_comma_expression] = STATE(8291),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_type_descriptor] = STATE(7961),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_placeholder_type_specifier] = STATE(1990),
    [sym_decltype_auto] = STATE(1973),
    [sym_decltype] = STATE(1874),
    [sym_class_specifier] = STATE(1990),
    [sym__class_name] = STATE(7357),
    [sym_dependent_type] = STATE(1990),
    [sym_template_type] = STATE(5228),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym__unary_left_fold] = STATE(8289),
    [sym__unary_right_fold] = STATE(8288),
    [sym__binary_fold] = STATE(8287),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5522),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(5253),
    [sym__assignment_expression_lhs] = STATE(8285),
    [sym_user_defined_literal] = STATE(3526),
    [aux_sym__type_definition_type_repeat1] = STATE(3883),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1898),
    [sym_identifier] = ACTIONS(2465),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1741),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_signed] = ACTIONS(1827),
    [anon_sym_unsigned] = ACTIONS(1827),
    [anon_sym_long] = ACTIONS(1827),
    [anon_sym_short] = ACTIONS(1827),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(1831),
    [anon_sym_byte] = ACTIONS(1831),
    [anon_sym_word] = ACTIONS(1831),
    [anon_sym_enum] = ACTIONS(1833),
    [anon_sym_class] = ACTIONS(1835),
    [anon_sym_struct] = ACTIONS(1837),
    [anon_sym_union] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1865),
    [anon_sym_decltype] = ACTIONS(1867),
    [anon_sym_typename] = ACTIONS(1869),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [197] = {
    [sym_type_qualifier] = STATE(3883),
    [sym__type_specifier] = STATE(4794),
    [sym_sized_type_specifier] = STATE(1990),
    [sym_primitive_type] = STATE(5089),
    [sym_enum_specifier] = STATE(1990),
    [sym_struct_specifier] = STATE(1990),
    [sym_union_specifier] = STATE(1990),
    [sym__expression] = STATE(2960),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_comma_expression] = STATE(8291),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_type_descriptor] = STATE(7709),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_placeholder_type_specifier] = STATE(1990),
    [sym_decltype_auto] = STATE(1973),
    [sym_decltype] = STATE(1874),
    [sym_class_specifier] = STATE(1990),
    [sym__class_name] = STATE(7357),
    [sym_dependent_type] = STATE(1990),
    [sym_template_type] = STATE(5228),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym__unary_left_fold] = STATE(8289),
    [sym__unary_right_fold] = STATE(8288),
    [sym__binary_fold] = STATE(8287),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5522),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(5253),
    [sym__assignment_expression_lhs] = STATE(8285),
    [sym_user_defined_literal] = STATE(3526),
    [aux_sym__type_definition_type_repeat1] = STATE(3883),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1898),
    [sym_identifier] = ACTIONS(2465),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1741),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_signed] = ACTIONS(1827),
    [anon_sym_unsigned] = ACTIONS(1827),
    [anon_sym_long] = ACTIONS(1827),
    [anon_sym_short] = ACTIONS(1827),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(1831),
    [anon_sym_byte] = ACTIONS(1831),
    [anon_sym_word] = ACTIONS(1831),
    [anon_sym_enum] = ACTIONS(1833),
    [anon_sym_class] = ACTIONS(1835),
    [anon_sym_struct] = ACTIONS(1837),
    [anon_sym_union] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1865),
    [anon_sym_decltype] = ACTIONS(1867),
    [anon_sym_typename] = ACTIONS(1869),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [198] = {
    [sym_type_qualifier] = STATE(3883),
    [sym__type_specifier] = STATE(4794),
    [sym_sized_type_specifier] = STATE(1990),
    [sym_primitive_type] = STATE(5089),
    [sym_enum_specifier] = STATE(1990),
    [sym_struct_specifier] = STATE(1990),
    [sym_union_specifier] = STATE(1990),
    [sym__expression] = STATE(2960),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_comma_expression] = STATE(8291),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_type_descriptor] = STATE(8106),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_placeholder_type_specifier] = STATE(1990),
    [sym_decltype_auto] = STATE(1973),
    [sym_decltype] = STATE(1874),
    [sym_class_specifier] = STATE(1990),
    [sym__class_name] = STATE(7357),
    [sym_dependent_type] = STATE(1990),
    [sym_template_type] = STATE(5228),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym__unary_left_fold] = STATE(8307),
    [sym__unary_right_fold] = STATE(7922),
    [sym__binary_fold] = STATE(8399),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5522),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(5253),
    [sym__assignment_expression_lhs] = STATE(8285),
    [sym_user_defined_literal] = STATE(3526),
    [aux_sym__type_definition_type_repeat1] = STATE(3883),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1898),
    [sym_identifier] = ACTIONS(2465),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1741),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_signed] = ACTIONS(1827),
    [anon_sym_unsigned] = ACTIONS(1827),
    [anon_sym_long] = ACTIONS(1827),
    [anon_sym_short] = ACTIONS(1827),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(1831),
    [anon_sym_byte] = ACTIONS(1831),
    [anon_sym_word] = ACTIONS(1831),
    [anon_sym_enum] = ACTIONS(1833),
    [anon_sym_class] = ACTIONS(1835),
    [anon_sym_struct] = ACTIONS(1837),
    [anon_sym_union] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1865),
    [anon_sym_decltype] = ACTIONS(1867),
    [anon_sym_typename] = ACTIONS(1869),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [199] = {
    [sym_type_qualifier] = STATE(3883),
    [sym__type_specifier] = STATE(4794),
    [sym_sized_type_specifier] = STATE(1990),
    [sym_primitive_type] = STATE(5089),
    [sym_enum_specifier] = STATE(1990),
    [sym_struct_specifier] = STATE(1990),
    [sym_union_specifier] = STATE(1990),
    [sym__expression] = STATE(2894),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_comma_expression] = STATE(8054),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_type_descriptor] = STATE(7944),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_placeholder_type_specifier] = STATE(1990),
    [sym_decltype_auto] = STATE(1973),
    [sym_decltype] = STATE(1874),
    [sym_class_specifier] = STATE(1990),
    [sym__class_name] = STATE(7357),
    [sym_dependent_type] = STATE(1990),
    [sym_template_type] = STATE(5228),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym__unary_left_fold] = STATE(8050),
    [sym__unary_right_fold] = STATE(8049),
    [sym__binary_fold] = STATE(8048),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5522),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(5253),
    [sym__assignment_expression_lhs] = STATE(8047),
    [sym_user_defined_literal] = STATE(3526),
    [aux_sym__type_definition_type_repeat1] = STATE(3883),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1898),
    [sym_identifier] = ACTIONS(2465),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1741),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_signed] = ACTIONS(1827),
    [anon_sym_unsigned] = ACTIONS(1827),
    [anon_sym_long] = ACTIONS(1827),
    [anon_sym_short] = ACTIONS(1827),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(1831),
    [anon_sym_byte] = ACTIONS(1831),
    [anon_sym_word] = ACTIONS(1831),
    [anon_sym_enum] = ACTIONS(1833),
    [anon_sym_class] = ACTIONS(1835),
    [anon_sym_struct] = ACTIONS(1837),
    [anon_sym_union] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1865),
    [anon_sym_decltype] = ACTIONS(1867),
    [anon_sym_typename] = ACTIONS(1869),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [200] = {
    [sym_type_qualifier] = STATE(3883),
    [sym__type_specifier] = STATE(4794),
    [sym_sized_type_specifier] = STATE(1990),
    [sym_primitive_type] = STATE(5089),
    [sym_enum_specifier] = STATE(1990),
    [sym_struct_specifier] = STATE(1990),
    [sym_union_specifier] = STATE(1990),
    [sym__expression] = STATE(2960),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_comma_expression] = STATE(8291),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_type_descriptor] = STATE(8097),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_placeholder_type_specifier] = STATE(1990),
    [sym_decltype_auto] = STATE(1973),
    [sym_decltype] = STATE(1874),
    [sym_class_specifier] = STATE(1990),
    [sym__class_name] = STATE(7357),
    [sym_dependent_type] = STATE(1990),
    [sym_template_type] = STATE(5228),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym__unary_left_fold] = STATE(8289),
    [sym__unary_right_fold] = STATE(8288),
    [sym__binary_fold] = STATE(8287),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5522),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(5253),
    [sym__assignment_expression_lhs] = STATE(8285),
    [sym_user_defined_literal] = STATE(3526),
    [aux_sym__type_definition_type_repeat1] = STATE(3883),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1898),
    [sym_identifier] = ACTIONS(2465),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1741),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_signed] = ACTIONS(1827),
    [anon_sym_unsigned] = ACTIONS(1827),
    [anon_sym_long] = ACTIONS(1827),
    [anon_sym_short] = ACTIONS(1827),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(1831),
    [anon_sym_byte] = ACTIONS(1831),
    [anon_sym_word] = ACTIONS(1831),
    [anon_sym_enum] = ACTIONS(1833),
    [anon_sym_class] = ACTIONS(1835),
    [anon_sym_struct] = ACTIONS(1837),
    [anon_sym_union] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1865),
    [anon_sym_decltype] = ACTIONS(1867),
    [anon_sym_typename] = ACTIONS(1869),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [201] = {
    [sym_type_qualifier] = STATE(3883),
    [sym__type_specifier] = STATE(4794),
    [sym_sized_type_specifier] = STATE(1990),
    [sym_primitive_type] = STATE(5089),
    [sym_enum_specifier] = STATE(1990),
    [sym_struct_specifier] = STATE(1990),
    [sym_union_specifier] = STATE(1990),
    [sym__expression] = STATE(2960),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_comma_expression] = STATE(8291),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_type_descriptor] = STATE(8301),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_placeholder_type_specifier] = STATE(1990),
    [sym_decltype_auto] = STATE(1973),
    [sym_decltype] = STATE(1874),
    [sym_class_specifier] = STATE(1990),
    [sym__class_name] = STATE(7357),
    [sym_dependent_type] = STATE(1990),
    [sym_template_type] = STATE(5228),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym__unary_left_fold] = STATE(8307),
    [sym__unary_right_fold] = STATE(7922),
    [sym__binary_fold] = STATE(8399),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5522),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(5253),
    [sym__assignment_expression_lhs] = STATE(8285),
    [sym_user_defined_literal] = STATE(3526),
    [aux_sym__type_definition_type_repeat1] = STATE(3883),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1898),
    [sym_identifier] = ACTIONS(2465),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1741),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_signed] = ACTIONS(1827),
    [anon_sym_unsigned] = ACTIONS(1827),
    [anon_sym_long] = ACTIONS(1827),
    [anon_sym_short] = ACTIONS(1827),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(1831),
    [anon_sym_byte] = ACTIONS(1831),
    [anon_sym_word] = ACTIONS(1831),
    [anon_sym_enum] = ACTIONS(1833),
    [anon_sym_class] = ACTIONS(1835),
    [anon_sym_struct] = ACTIONS(1837),
    [anon_sym_union] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1865),
    [anon_sym_decltype] = ACTIONS(1867),
    [anon_sym_typename] = ACTIONS(1869),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [202] = {
    [sym_type_qualifier] = STATE(3883),
    [sym__type_specifier] = STATE(4794),
    [sym_sized_type_specifier] = STATE(1990),
    [sym_primitive_type] = STATE(5089),
    [sym_enum_specifier] = STATE(1990),
    [sym_struct_specifier] = STATE(1990),
    [sym_union_specifier] = STATE(1990),
    [sym__expression] = STATE(2894),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_comma_expression] = STATE(8054),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_type_descriptor] = STATE(7685),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_placeholder_type_specifier] = STATE(1990),
    [sym_decltype_auto] = STATE(1973),
    [sym_decltype] = STATE(1874),
    [sym_class_specifier] = STATE(1990),
    [sym__class_name] = STATE(7357),
    [sym_dependent_type] = STATE(1990),
    [sym_template_type] = STATE(5228),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym__unary_left_fold] = STATE(7683),
    [sym__unary_right_fold] = STATE(7679),
    [sym__binary_fold] = STATE(7678),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5522),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(5253),
    [sym__assignment_expression_lhs] = STATE(8047),
    [sym_user_defined_literal] = STATE(3526),
    [aux_sym__type_definition_type_repeat1] = STATE(3883),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1898),
    [sym_identifier] = ACTIONS(2465),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1741),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_signed] = ACTIONS(1827),
    [anon_sym_unsigned] = ACTIONS(1827),
    [anon_sym_long] = ACTIONS(1827),
    [anon_sym_short] = ACTIONS(1827),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(1831),
    [anon_sym_byte] = ACTIONS(1831),
    [anon_sym_word] = ACTIONS(1831),
    [anon_sym_enum] = ACTIONS(1833),
    [anon_sym_class] = ACTIONS(1835),
    [anon_sym_struct] = ACTIONS(1837),
    [anon_sym_union] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1865),
    [anon_sym_decltype] = ACTIONS(1867),
    [anon_sym_typename] = ACTIONS(1869),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [203] = {
    [sym_type_qualifier] = STATE(3883),
    [sym__type_specifier] = STATE(4794),
    [sym_sized_type_specifier] = STATE(1990),
    [sym_primitive_type] = STATE(5089),
    [sym_enum_specifier] = STATE(1990),
    [sym_struct_specifier] = STATE(1990),
    [sym_union_specifier] = STATE(1990),
    [sym__expression] = STATE(2894),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_comma_expression] = STATE(8054),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_type_descriptor] = STATE(7743),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_placeholder_type_specifier] = STATE(1990),
    [sym_decltype_auto] = STATE(1973),
    [sym_decltype] = STATE(1874),
    [sym_class_specifier] = STATE(1990),
    [sym__class_name] = STATE(7357),
    [sym_dependent_type] = STATE(1990),
    [sym_template_type] = STATE(5228),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym__unary_left_fold] = STATE(8050),
    [sym__unary_right_fold] = STATE(8049),
    [sym__binary_fold] = STATE(8048),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5522),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(5253),
    [sym__assignment_expression_lhs] = STATE(8047),
    [sym_user_defined_literal] = STATE(3526),
    [aux_sym__type_definition_type_repeat1] = STATE(3883),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1898),
    [sym_identifier] = ACTIONS(2465),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1741),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_signed] = ACTIONS(1827),
    [anon_sym_unsigned] = ACTIONS(1827),
    [anon_sym_long] = ACTIONS(1827),
    [anon_sym_short] = ACTIONS(1827),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(1831),
    [anon_sym_byte] = ACTIONS(1831),
    [anon_sym_word] = ACTIONS(1831),
    [anon_sym_enum] = ACTIONS(1833),
    [anon_sym_class] = ACTIONS(1835),
    [anon_sym_struct] = ACTIONS(1837),
    [anon_sym_union] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1865),
    [anon_sym_decltype] = ACTIONS(1867),
    [anon_sym_typename] = ACTIONS(1869),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [204] = {
    [sym_type_qualifier] = STATE(3883),
    [sym__type_specifier] = STATE(4794),
    [sym_sized_type_specifier] = STATE(1990),
    [sym_primitive_type] = STATE(5089),
    [sym_enum_specifier] = STATE(1990),
    [sym_struct_specifier] = STATE(1990),
    [sym_union_specifier] = STATE(1990),
    [sym__expression] = STATE(2960),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_comma_expression] = STATE(8291),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_type_descriptor] = STATE(8216),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_placeholder_type_specifier] = STATE(1990),
    [sym_decltype_auto] = STATE(1973),
    [sym_decltype] = STATE(1874),
    [sym_class_specifier] = STATE(1990),
    [sym__class_name] = STATE(7357),
    [sym_dependent_type] = STATE(1990),
    [sym_template_type] = STATE(5228),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym__unary_left_fold] = STATE(8307),
    [sym__unary_right_fold] = STATE(7922),
    [sym__binary_fold] = STATE(8399),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5522),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(5253),
    [sym__assignment_expression_lhs] = STATE(8285),
    [sym_user_defined_literal] = STATE(3526),
    [aux_sym__type_definition_type_repeat1] = STATE(3883),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1898),
    [sym_identifier] = ACTIONS(2465),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1741),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_signed] = ACTIONS(1827),
    [anon_sym_unsigned] = ACTIONS(1827),
    [anon_sym_long] = ACTIONS(1827),
    [anon_sym_short] = ACTIONS(1827),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(1831),
    [anon_sym_byte] = ACTIONS(1831),
    [anon_sym_word] = ACTIONS(1831),
    [anon_sym_enum] = ACTIONS(1833),
    [anon_sym_class] = ACTIONS(1835),
    [anon_sym_struct] = ACTIONS(1837),
    [anon_sym_union] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1865),
    [anon_sym_decltype] = ACTIONS(1867),
    [anon_sym_typename] = ACTIONS(1869),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [205] = {
    [sym_type_qualifier] = STATE(3883),
    [sym__type_specifier] = STATE(4794),
    [sym_sized_type_specifier] = STATE(1990),
    [sym_primitive_type] = STATE(5089),
    [sym_enum_specifier] = STATE(1990),
    [sym_struct_specifier] = STATE(1990),
    [sym_union_specifier] = STATE(1990),
    [sym__expression] = STATE(2960),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_comma_expression] = STATE(8291),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_type_descriptor] = STATE(8145),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_placeholder_type_specifier] = STATE(1990),
    [sym_decltype_auto] = STATE(1973),
    [sym_decltype] = STATE(1874),
    [sym_class_specifier] = STATE(1990),
    [sym__class_name] = STATE(7357),
    [sym_dependent_type] = STATE(1990),
    [sym_template_type] = STATE(5228),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym__unary_left_fold] = STATE(8307),
    [sym__unary_right_fold] = STATE(7922),
    [sym__binary_fold] = STATE(8399),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5522),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(5253),
    [sym__assignment_expression_lhs] = STATE(8285),
    [sym_user_defined_literal] = STATE(3526),
    [aux_sym__type_definition_type_repeat1] = STATE(3883),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1898),
    [sym_identifier] = ACTIONS(2465),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1741),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_signed] = ACTIONS(1827),
    [anon_sym_unsigned] = ACTIONS(1827),
    [anon_sym_long] = ACTIONS(1827),
    [anon_sym_short] = ACTIONS(1827),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(1831),
    [anon_sym_byte] = ACTIONS(1831),
    [anon_sym_word] = ACTIONS(1831),
    [anon_sym_enum] = ACTIONS(1833),
    [anon_sym_class] = ACTIONS(1835),
    [anon_sym_struct] = ACTIONS(1837),
    [anon_sym_union] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1865),
    [anon_sym_decltype] = ACTIONS(1867),
    [anon_sym_typename] = ACTIONS(1869),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [206] = {
    [sym_type_qualifier] = STATE(3883),
    [sym__type_specifier] = STATE(4794),
    [sym_sized_type_specifier] = STATE(1990),
    [sym_primitive_type] = STATE(5089),
    [sym_enum_specifier] = STATE(1990),
    [sym_struct_specifier] = STATE(1990),
    [sym_union_specifier] = STATE(1990),
    [sym__expression] = STATE(2960),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_comma_expression] = STATE(8291),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_type_descriptor] = STATE(8146),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_placeholder_type_specifier] = STATE(1990),
    [sym_decltype_auto] = STATE(1973),
    [sym_decltype] = STATE(1874),
    [sym_class_specifier] = STATE(1990),
    [sym__class_name] = STATE(7357),
    [sym_dependent_type] = STATE(1990),
    [sym_template_type] = STATE(5228),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym__unary_left_fold] = STATE(8289),
    [sym__unary_right_fold] = STATE(8288),
    [sym__binary_fold] = STATE(8287),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5522),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(5253),
    [sym__assignment_expression_lhs] = STATE(8285),
    [sym_user_defined_literal] = STATE(3526),
    [aux_sym__type_definition_type_repeat1] = STATE(3883),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1898),
    [sym_identifier] = ACTIONS(2465),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1741),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_signed] = ACTIONS(1827),
    [anon_sym_unsigned] = ACTIONS(1827),
    [anon_sym_long] = ACTIONS(1827),
    [anon_sym_short] = ACTIONS(1827),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(1831),
    [anon_sym_byte] = ACTIONS(1831),
    [anon_sym_word] = ACTIONS(1831),
    [anon_sym_enum] = ACTIONS(1833),
    [anon_sym_class] = ACTIONS(1835),
    [anon_sym_struct] = ACTIONS(1837),
    [anon_sym_union] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1865),
    [anon_sym_decltype] = ACTIONS(1867),
    [anon_sym_typename] = ACTIONS(1869),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [207] = {
    [sym_type_qualifier] = STATE(3883),
    [sym__type_specifier] = STATE(4794),
    [sym_sized_type_specifier] = STATE(1990),
    [sym_primitive_type] = STATE(5089),
    [sym_enum_specifier] = STATE(1990),
    [sym_struct_specifier] = STATE(1990),
    [sym_union_specifier] = STATE(1990),
    [sym__expression] = STATE(2960),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_comma_expression] = STATE(8291),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_type_descriptor] = STATE(8165),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_placeholder_type_specifier] = STATE(1990),
    [sym_decltype_auto] = STATE(1973),
    [sym_decltype] = STATE(1874),
    [sym_class_specifier] = STATE(1990),
    [sym__class_name] = STATE(7357),
    [sym_dependent_type] = STATE(1990),
    [sym_template_type] = STATE(5228),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym__unary_left_fold] = STATE(8289),
    [sym__unary_right_fold] = STATE(8288),
    [sym__binary_fold] = STATE(8287),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5522),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(5253),
    [sym__assignment_expression_lhs] = STATE(8285),
    [sym_user_defined_literal] = STATE(3526),
    [aux_sym__type_definition_type_repeat1] = STATE(3883),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1898),
    [sym_identifier] = ACTIONS(2465),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1741),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_signed] = ACTIONS(1827),
    [anon_sym_unsigned] = ACTIONS(1827),
    [anon_sym_long] = ACTIONS(1827),
    [anon_sym_short] = ACTIONS(1827),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(1831),
    [anon_sym_byte] = ACTIONS(1831),
    [anon_sym_word] = ACTIONS(1831),
    [anon_sym_enum] = ACTIONS(1833),
    [anon_sym_class] = ACTIONS(1835),
    [anon_sym_struct] = ACTIONS(1837),
    [anon_sym_union] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1865),
    [anon_sym_decltype] = ACTIONS(1867),
    [anon_sym_typename] = ACTIONS(1869),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [208] = {
    [sym_type_qualifier] = STATE(3883),
    [sym__type_specifier] = STATE(4794),
    [sym_sized_type_specifier] = STATE(1990),
    [sym_primitive_type] = STATE(5089),
    [sym_enum_specifier] = STATE(1990),
    [sym_struct_specifier] = STATE(1990),
    [sym_union_specifier] = STATE(1990),
    [sym__expression] = STATE(2894),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_comma_expression] = STATE(8054),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_type_descriptor] = STATE(7601),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_placeholder_type_specifier] = STATE(1990),
    [sym_decltype_auto] = STATE(1973),
    [sym_decltype] = STATE(1874),
    [sym_class_specifier] = STATE(1990),
    [sym__class_name] = STATE(7357),
    [sym_dependent_type] = STATE(1990),
    [sym_template_type] = STATE(5228),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym__unary_left_fold] = STATE(7683),
    [sym__unary_right_fold] = STATE(7679),
    [sym__binary_fold] = STATE(7678),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5522),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(5253),
    [sym__assignment_expression_lhs] = STATE(8047),
    [sym_user_defined_literal] = STATE(3526),
    [aux_sym__type_definition_type_repeat1] = STATE(3883),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1898),
    [sym_identifier] = ACTIONS(2465),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1741),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_signed] = ACTIONS(1827),
    [anon_sym_unsigned] = ACTIONS(1827),
    [anon_sym_long] = ACTIONS(1827),
    [anon_sym_short] = ACTIONS(1827),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(1831),
    [anon_sym_byte] = ACTIONS(1831),
    [anon_sym_word] = ACTIONS(1831),
    [anon_sym_enum] = ACTIONS(1833),
    [anon_sym_class] = ACTIONS(1835),
    [anon_sym_struct] = ACTIONS(1837),
    [anon_sym_union] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1865),
    [anon_sym_decltype] = ACTIONS(1867),
    [anon_sym_typename] = ACTIONS(1869),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [209] = {
    [sym_type_qualifier] = STATE(3883),
    [sym__type_specifier] = STATE(4794),
    [sym_sized_type_specifier] = STATE(1990),
    [sym_primitive_type] = STATE(5089),
    [sym_enum_specifier] = STATE(1990),
    [sym_struct_specifier] = STATE(1990),
    [sym_union_specifier] = STATE(1990),
    [sym__expression] = STATE(2960),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_comma_expression] = STATE(8291),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_type_descriptor] = STATE(8371),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_placeholder_type_specifier] = STATE(1990),
    [sym_decltype_auto] = STATE(1973),
    [sym_decltype] = STATE(1874),
    [sym_class_specifier] = STATE(1990),
    [sym__class_name] = STATE(7357),
    [sym_dependent_type] = STATE(1990),
    [sym_template_type] = STATE(5228),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym__unary_left_fold] = STATE(8289),
    [sym__unary_right_fold] = STATE(8288),
    [sym__binary_fold] = STATE(8287),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5522),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(5253),
    [sym__assignment_expression_lhs] = STATE(8285),
    [sym_user_defined_literal] = STATE(3526),
    [aux_sym__type_definition_type_repeat1] = STATE(3883),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1898),
    [sym_identifier] = ACTIONS(2465),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1741),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_signed] = ACTIONS(1827),
    [anon_sym_unsigned] = ACTIONS(1827),
    [anon_sym_long] = ACTIONS(1827),
    [anon_sym_short] = ACTIONS(1827),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(1831),
    [anon_sym_byte] = ACTIONS(1831),
    [anon_sym_word] = ACTIONS(1831),
    [anon_sym_enum] = ACTIONS(1833),
    [anon_sym_class] = ACTIONS(1835),
    [anon_sym_struct] = ACTIONS(1837),
    [anon_sym_union] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1865),
    [anon_sym_decltype] = ACTIONS(1867),
    [anon_sym_typename] = ACTIONS(1869),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [210] = {
    [sym_type_qualifier] = STATE(3883),
    [sym__type_specifier] = STATE(4794),
    [sym_sized_type_specifier] = STATE(1990),
    [sym_primitive_type] = STATE(5089),
    [sym_enum_specifier] = STATE(1990),
    [sym_struct_specifier] = STATE(1990),
    [sym_union_specifier] = STATE(1990),
    [sym__expression] = STATE(2960),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_comma_expression] = STATE(8291),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_type_descriptor] = STATE(7994),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_placeholder_type_specifier] = STATE(1990),
    [sym_decltype_auto] = STATE(1973),
    [sym_decltype] = STATE(1874),
    [sym_class_specifier] = STATE(1990),
    [sym__class_name] = STATE(7357),
    [sym_dependent_type] = STATE(1990),
    [sym_template_type] = STATE(5228),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym__unary_left_fold] = STATE(8289),
    [sym__unary_right_fold] = STATE(8288),
    [sym__binary_fold] = STATE(8287),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5522),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(5253),
    [sym__assignment_expression_lhs] = STATE(8285),
    [sym_user_defined_literal] = STATE(3526),
    [aux_sym__type_definition_type_repeat1] = STATE(3883),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1898),
    [sym_identifier] = ACTIONS(2465),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1741),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_signed] = ACTIONS(1827),
    [anon_sym_unsigned] = ACTIONS(1827),
    [anon_sym_long] = ACTIONS(1827),
    [anon_sym_short] = ACTIONS(1827),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(1831),
    [anon_sym_byte] = ACTIONS(1831),
    [anon_sym_word] = ACTIONS(1831),
    [anon_sym_enum] = ACTIONS(1833),
    [anon_sym_class] = ACTIONS(1835),
    [anon_sym_struct] = ACTIONS(1837),
    [anon_sym_union] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1865),
    [anon_sym_decltype] = ACTIONS(1867),
    [anon_sym_typename] = ACTIONS(1869),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [211] = {
    [sym_primitive_type] = STATE(6853),
    [sym__expression] = STATE(3557),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_initializer_list] = STATE(3896),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7464),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(7464),
    [sym_user_defined_literal] = STATE(3374),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1885),
    [anon_sym_COMMA] = ACTIONS(1885),
    [anon_sym_RPAREN] = ACTIONS(1885),
    [anon_sym_LPAREN2] = ACTIONS(1885),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1883),
    [anon_sym_PLUS] = ACTIONS(1883),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_SLASH] = ACTIONS(1883),
    [anon_sym_PERCENT] = ACTIONS(1883),
    [anon_sym_PIPE_PIPE] = ACTIONS(1885),
    [anon_sym_AMP_AMP] = ACTIONS(1885),
    [anon_sym_PIPE] = ACTIONS(1883),
    [anon_sym_CARET] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym_EQ_EQ] = ACTIONS(1885),
    [anon_sym_BANG_EQ] = ACTIONS(1885),
    [anon_sym_GT] = ACTIONS(1883),
    [anon_sym_GT_EQ] = ACTIONS(1885),
    [anon_sym_LT_EQ] = ACTIONS(1883),
    [anon_sym_LT] = ACTIONS(1883),
    [anon_sym_LT_LT] = ACTIONS(1883),
    [anon_sym_GT_GT] = ACTIONS(1883),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACE] = ACTIONS(2473),
    [anon_sym_LBRACK] = ACTIONS(1885),
    [anon_sym_EQ] = ACTIONS(1883),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_QMARK] = ACTIONS(1885),
    [anon_sym_STAR_EQ] = ACTIONS(1885),
    [anon_sym_SLASH_EQ] = ACTIONS(1885),
    [anon_sym_PERCENT_EQ] = ACTIONS(1885),
    [anon_sym_PLUS_EQ] = ACTIONS(1885),
    [anon_sym_DASH_EQ] = ACTIONS(1885),
    [anon_sym_LT_LT_EQ] = ACTIONS(1885),
    [anon_sym_GT_GT_EQ] = ACTIONS(1885),
    [anon_sym_AMP_EQ] = ACTIONS(1885),
    [anon_sym_CARET_EQ] = ACTIONS(1885),
    [anon_sym_PIPE_EQ] = ACTIONS(1885),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_LT_EQ_GT] = ACTIONS(1885),
    [anon_sym_or] = ACTIONS(1883),
    [anon_sym_and] = ACTIONS(1883),
    [anon_sym_bitor] = ACTIONS(1883),
    [anon_sym_xor] = ACTIONS(1883),
    [anon_sym_bitand] = ACTIONS(1883),
    [anon_sym_not_eq] = ACTIONS(1883),
    [anon_sym_DASH_DASH] = ACTIONS(1885),
    [anon_sym_PLUS_PLUS] = ACTIONS(1885),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [anon_sym_DOT] = ACTIONS(1883),
    [anon_sym_DOT_STAR] = ACTIONS(1885),
    [anon_sym_DASH_GT] = ACTIONS(1883),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [anon_sym_DASH_GT_STAR] = ACTIONS(1885),
    [sym_this] = ACTIONS(1783),
  },
  [212] = {
    [sym_type_qualifier] = STATE(3883),
    [sym__type_specifier] = STATE(4794),
    [sym_sized_type_specifier] = STATE(1990),
    [sym_primitive_type] = STATE(5089),
    [sym_enum_specifier] = STATE(1990),
    [sym_struct_specifier] = STATE(1990),
    [sym_union_specifier] = STATE(1990),
    [sym__expression] = STATE(2960),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_comma_expression] = STATE(8291),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_type_descriptor] = STATE(8113),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_placeholder_type_specifier] = STATE(1990),
    [sym_decltype_auto] = STATE(1973),
    [sym_decltype] = STATE(1874),
    [sym_class_specifier] = STATE(1990),
    [sym__class_name] = STATE(7357),
    [sym_dependent_type] = STATE(1990),
    [sym_template_type] = STATE(5228),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym__unary_left_fold] = STATE(8307),
    [sym__unary_right_fold] = STATE(7922),
    [sym__binary_fold] = STATE(8399),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5522),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(5253),
    [sym__assignment_expression_lhs] = STATE(8285),
    [sym_user_defined_literal] = STATE(3526),
    [aux_sym__type_definition_type_repeat1] = STATE(3883),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1898),
    [sym_identifier] = ACTIONS(2465),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1741),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_signed] = ACTIONS(1827),
    [anon_sym_unsigned] = ACTIONS(1827),
    [anon_sym_long] = ACTIONS(1827),
    [anon_sym_short] = ACTIONS(1827),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(1831),
    [anon_sym_byte] = ACTIONS(1831),
    [anon_sym_word] = ACTIONS(1831),
    [anon_sym_enum] = ACTIONS(1833),
    [anon_sym_class] = ACTIONS(1835),
    [anon_sym_struct] = ACTIONS(1837),
    [anon_sym_union] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1865),
    [anon_sym_decltype] = ACTIONS(1867),
    [anon_sym_typename] = ACTIONS(1869),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [213] = {
    [sym_type_qualifier] = STATE(3883),
    [sym__type_specifier] = STATE(4794),
    [sym_sized_type_specifier] = STATE(1990),
    [sym_primitive_type] = STATE(5089),
    [sym_enum_specifier] = STATE(1990),
    [sym_struct_specifier] = STATE(1990),
    [sym_union_specifier] = STATE(1990),
    [sym__expression] = STATE(2960),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_comma_expression] = STATE(8291),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_type_descriptor] = STATE(7622),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_placeholder_type_specifier] = STATE(1990),
    [sym_decltype_auto] = STATE(1973),
    [sym_decltype] = STATE(1874),
    [sym_class_specifier] = STATE(1990),
    [sym__class_name] = STATE(7357),
    [sym_dependent_type] = STATE(1990),
    [sym_template_type] = STATE(5228),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym__unary_left_fold] = STATE(8307),
    [sym__unary_right_fold] = STATE(7922),
    [sym__binary_fold] = STATE(8399),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5522),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(5253),
    [sym__assignment_expression_lhs] = STATE(8285),
    [sym_user_defined_literal] = STATE(3526),
    [aux_sym__type_definition_type_repeat1] = STATE(3883),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1898),
    [sym_identifier] = ACTIONS(2465),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1741),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_signed] = ACTIONS(1827),
    [anon_sym_unsigned] = ACTIONS(1827),
    [anon_sym_long] = ACTIONS(1827),
    [anon_sym_short] = ACTIONS(1827),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(1831),
    [anon_sym_byte] = ACTIONS(1831),
    [anon_sym_word] = ACTIONS(1831),
    [anon_sym_enum] = ACTIONS(1833),
    [anon_sym_class] = ACTIONS(1835),
    [anon_sym_struct] = ACTIONS(1837),
    [anon_sym_union] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1865),
    [anon_sym_decltype] = ACTIONS(1867),
    [anon_sym_typename] = ACTIONS(1869),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [214] = {
    [sym_type_qualifier] = STATE(3883),
    [sym__type_specifier] = STATE(4794),
    [sym_sized_type_specifier] = STATE(1990),
    [sym_primitive_type] = STATE(5089),
    [sym_enum_specifier] = STATE(1990),
    [sym_struct_specifier] = STATE(1990),
    [sym_union_specifier] = STATE(1990),
    [sym__expression] = STATE(2960),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_comma_expression] = STATE(8291),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_type_descriptor] = STATE(8312),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_placeholder_type_specifier] = STATE(1990),
    [sym_decltype_auto] = STATE(1973),
    [sym_decltype] = STATE(1874),
    [sym_class_specifier] = STATE(1990),
    [sym__class_name] = STATE(7357),
    [sym_dependent_type] = STATE(1990),
    [sym_template_type] = STATE(5228),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym__unary_left_fold] = STATE(8307),
    [sym__unary_right_fold] = STATE(7922),
    [sym__binary_fold] = STATE(8399),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5522),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(5253),
    [sym__assignment_expression_lhs] = STATE(8285),
    [sym_user_defined_literal] = STATE(3526),
    [aux_sym__type_definition_type_repeat1] = STATE(3883),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1898),
    [sym_identifier] = ACTIONS(2465),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1741),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_signed] = ACTIONS(1827),
    [anon_sym_unsigned] = ACTIONS(1827),
    [anon_sym_long] = ACTIONS(1827),
    [anon_sym_short] = ACTIONS(1827),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(1831),
    [anon_sym_byte] = ACTIONS(1831),
    [anon_sym_word] = ACTIONS(1831),
    [anon_sym_enum] = ACTIONS(1833),
    [anon_sym_class] = ACTIONS(1835),
    [anon_sym_struct] = ACTIONS(1837),
    [anon_sym_union] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1865),
    [anon_sym_decltype] = ACTIONS(1867),
    [anon_sym_typename] = ACTIONS(1869),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [215] = {
    [sym_type_qualifier] = STATE(3883),
    [sym__type_specifier] = STATE(4794),
    [sym_sized_type_specifier] = STATE(1990),
    [sym_primitive_type] = STATE(5089),
    [sym_enum_specifier] = STATE(1990),
    [sym_struct_specifier] = STATE(1990),
    [sym_union_specifier] = STATE(1990),
    [sym__expression] = STATE(2927),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_comma_expression] = STATE(8403),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_type_descriptor] = STATE(8001),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_placeholder_type_specifier] = STATE(1990),
    [sym_decltype_auto] = STATE(1973),
    [sym_decltype] = STATE(1874),
    [sym_class_specifier] = STATE(1990),
    [sym__class_name] = STATE(7357),
    [sym_dependent_type] = STATE(1990),
    [sym_template_type] = STATE(5228),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym__unary_left_fold] = STATE(8124),
    [sym__unary_right_fold] = STATE(8123),
    [sym__binary_fold] = STATE(8122),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5522),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(5253),
    [sym__assignment_expression_lhs] = STATE(8397),
    [sym_user_defined_literal] = STATE(3526),
    [aux_sym__type_definition_type_repeat1] = STATE(3883),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1898),
    [sym_identifier] = ACTIONS(2465),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1741),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_signed] = ACTIONS(1827),
    [anon_sym_unsigned] = ACTIONS(1827),
    [anon_sym_long] = ACTIONS(1827),
    [anon_sym_short] = ACTIONS(1827),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(1831),
    [anon_sym_byte] = ACTIONS(1831),
    [anon_sym_word] = ACTIONS(1831),
    [anon_sym_enum] = ACTIONS(1833),
    [anon_sym_class] = ACTIONS(1835),
    [anon_sym_struct] = ACTIONS(1837),
    [anon_sym_union] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1865),
    [anon_sym_decltype] = ACTIONS(1867),
    [anon_sym_typename] = ACTIONS(1869),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [216] = {
    [sym_type_qualifier] = STATE(3883),
    [sym__type_specifier] = STATE(4794),
    [sym_sized_type_specifier] = STATE(1990),
    [sym_primitive_type] = STATE(5089),
    [sym_enum_specifier] = STATE(1990),
    [sym_struct_specifier] = STATE(1990),
    [sym_union_specifier] = STATE(1990),
    [sym__expression] = STATE(2960),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_comma_expression] = STATE(8291),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_type_descriptor] = STATE(8416),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_placeholder_type_specifier] = STATE(1990),
    [sym_decltype_auto] = STATE(1973),
    [sym_decltype] = STATE(1874),
    [sym_class_specifier] = STATE(1990),
    [sym__class_name] = STATE(7357),
    [sym_dependent_type] = STATE(1990),
    [sym_template_type] = STATE(5228),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym__unary_left_fold] = STATE(8307),
    [sym__unary_right_fold] = STATE(7922),
    [sym__binary_fold] = STATE(8399),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5522),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(5253),
    [sym__assignment_expression_lhs] = STATE(8285),
    [sym_user_defined_literal] = STATE(3526),
    [aux_sym__type_definition_type_repeat1] = STATE(3883),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1898),
    [sym_identifier] = ACTIONS(2465),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1741),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_signed] = ACTIONS(1827),
    [anon_sym_unsigned] = ACTIONS(1827),
    [anon_sym_long] = ACTIONS(1827),
    [anon_sym_short] = ACTIONS(1827),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(1831),
    [anon_sym_byte] = ACTIONS(1831),
    [anon_sym_word] = ACTIONS(1831),
    [anon_sym_enum] = ACTIONS(1833),
    [anon_sym_class] = ACTIONS(1835),
    [anon_sym_struct] = ACTIONS(1837),
    [anon_sym_union] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1865),
    [anon_sym_decltype] = ACTIONS(1867),
    [anon_sym_typename] = ACTIONS(1869),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [217] = {
    [sym_type_qualifier] = STATE(3883),
    [sym__type_specifier] = STATE(4794),
    [sym_sized_type_specifier] = STATE(1990),
    [sym_primitive_type] = STATE(5089),
    [sym_enum_specifier] = STATE(1990),
    [sym_struct_specifier] = STATE(1990),
    [sym_union_specifier] = STATE(1990),
    [sym__expression] = STATE(2927),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_comma_expression] = STATE(8403),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_type_descriptor] = STATE(7749),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_placeholder_type_specifier] = STATE(1990),
    [sym_decltype_auto] = STATE(1973),
    [sym_decltype] = STATE(1874),
    [sym_class_specifier] = STATE(1990),
    [sym__class_name] = STATE(7357),
    [sym_dependent_type] = STATE(1990),
    [sym_template_type] = STATE(5228),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym__unary_left_fold] = STATE(7751),
    [sym__unary_right_fold] = STATE(7755),
    [sym__binary_fold] = STATE(7758),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5522),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(5253),
    [sym__assignment_expression_lhs] = STATE(8397),
    [sym_user_defined_literal] = STATE(3526),
    [aux_sym__type_definition_type_repeat1] = STATE(3883),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1898),
    [sym_identifier] = ACTIONS(2465),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1741),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_signed] = ACTIONS(1827),
    [anon_sym_unsigned] = ACTIONS(1827),
    [anon_sym_long] = ACTIONS(1827),
    [anon_sym_short] = ACTIONS(1827),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(1831),
    [anon_sym_byte] = ACTIONS(1831),
    [anon_sym_word] = ACTIONS(1831),
    [anon_sym_enum] = ACTIONS(1833),
    [anon_sym_class] = ACTIONS(1835),
    [anon_sym_struct] = ACTIONS(1837),
    [anon_sym_union] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1865),
    [anon_sym_decltype] = ACTIONS(1867),
    [anon_sym_typename] = ACTIONS(1869),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [218] = {
    [sym_type_qualifier] = STATE(3883),
    [sym__type_specifier] = STATE(4794),
    [sym_sized_type_specifier] = STATE(1990),
    [sym_primitive_type] = STATE(5089),
    [sym_enum_specifier] = STATE(1990),
    [sym_struct_specifier] = STATE(1990),
    [sym_union_specifier] = STATE(1990),
    [sym__expression] = STATE(2960),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_comma_expression] = STATE(8291),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_type_descriptor] = STATE(8434),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_placeholder_type_specifier] = STATE(1990),
    [sym_decltype_auto] = STATE(1973),
    [sym_decltype] = STATE(1874),
    [sym_class_specifier] = STATE(1990),
    [sym__class_name] = STATE(7357),
    [sym_dependent_type] = STATE(1990),
    [sym_template_type] = STATE(5228),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym__unary_left_fold] = STATE(8289),
    [sym__unary_right_fold] = STATE(8288),
    [sym__binary_fold] = STATE(8287),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5522),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(5253),
    [sym__assignment_expression_lhs] = STATE(8285),
    [sym_user_defined_literal] = STATE(3526),
    [aux_sym__type_definition_type_repeat1] = STATE(3883),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1898),
    [sym_identifier] = ACTIONS(2465),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1741),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_signed] = ACTIONS(1827),
    [anon_sym_unsigned] = ACTIONS(1827),
    [anon_sym_long] = ACTIONS(1827),
    [anon_sym_short] = ACTIONS(1827),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(1831),
    [anon_sym_byte] = ACTIONS(1831),
    [anon_sym_word] = ACTIONS(1831),
    [anon_sym_enum] = ACTIONS(1833),
    [anon_sym_class] = ACTIONS(1835),
    [anon_sym_struct] = ACTIONS(1837),
    [anon_sym_union] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1865),
    [anon_sym_decltype] = ACTIONS(1867),
    [anon_sym_typename] = ACTIONS(1869),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [219] = {
    [sym_type_qualifier] = STATE(3883),
    [sym__type_specifier] = STATE(4794),
    [sym_sized_type_specifier] = STATE(1990),
    [sym_primitive_type] = STATE(5089),
    [sym_enum_specifier] = STATE(1990),
    [sym_struct_specifier] = STATE(1990),
    [sym_union_specifier] = STATE(1990),
    [sym__expression] = STATE(2927),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_comma_expression] = STATE(8403),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_type_descriptor] = STATE(7830),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_placeholder_type_specifier] = STATE(1990),
    [sym_decltype_auto] = STATE(1973),
    [sym_decltype] = STATE(1874),
    [sym_class_specifier] = STATE(1990),
    [sym__class_name] = STATE(7357),
    [sym_dependent_type] = STATE(1990),
    [sym_template_type] = STATE(5228),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym__unary_left_fold] = STATE(7751),
    [sym__unary_right_fold] = STATE(7755),
    [sym__binary_fold] = STATE(7758),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5522),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(5253),
    [sym__assignment_expression_lhs] = STATE(8397),
    [sym_user_defined_literal] = STATE(3526),
    [aux_sym__type_definition_type_repeat1] = STATE(3883),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1898),
    [sym_identifier] = ACTIONS(2465),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1741),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_signed] = ACTIONS(1827),
    [anon_sym_unsigned] = ACTIONS(1827),
    [anon_sym_long] = ACTIONS(1827),
    [anon_sym_short] = ACTIONS(1827),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(1831),
    [anon_sym_byte] = ACTIONS(1831),
    [anon_sym_word] = ACTIONS(1831),
    [anon_sym_enum] = ACTIONS(1833),
    [anon_sym_class] = ACTIONS(1835),
    [anon_sym_struct] = ACTIONS(1837),
    [anon_sym_union] = ACTIONS(1839),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1865),
    [anon_sym_decltype] = ACTIONS(1867),
    [anon_sym_typename] = ACTIONS(1869),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [220] = {
    [sym_catch_clause] = STATE(220),
    [aux_sym_constructor_try_statement_repeat1] = STATE(220),
    [sym_identifier] = ACTIONS(2475),
    [aux_sym_preproc_include_token1] = ACTIONS(2475),
    [aux_sym_preproc_def_token1] = ACTIONS(2475),
    [aux_sym_preproc_if_token1] = ACTIONS(2475),
    [aux_sym_preproc_if_token2] = ACTIONS(2475),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2475),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2475),
    [aux_sym_preproc_else_token1] = ACTIONS(2475),
    [aux_sym_preproc_elif_token1] = ACTIONS(2475),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2475),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2475),
    [sym_preproc_directive] = ACTIONS(2475),
    [anon_sym_LPAREN2] = ACTIONS(2477),
    [anon_sym_BANG] = ACTIONS(2477),
    [anon_sym_TILDE] = ACTIONS(2477),
    [anon_sym_DASH] = ACTIONS(2475),
    [anon_sym_PLUS] = ACTIONS(2475),
    [anon_sym_STAR] = ACTIONS(2477),
    [anon_sym_AMP_AMP] = ACTIONS(2477),
    [anon_sym_AMP] = ACTIONS(2475),
    [anon_sym_SEMI] = ACTIONS(2477),
    [anon_sym___extension__] = ACTIONS(2475),
    [anon_sym_typedef] = ACTIONS(2475),
    [anon_sym_extern] = ACTIONS(2475),
    [anon_sym___attribute__] = ACTIONS(2475),
    [anon_sym_COLON_COLON] = ACTIONS(2477),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2477),
    [anon_sym___declspec] = ACTIONS(2475),
    [anon_sym___based] = ACTIONS(2475),
    [anon_sym___cdecl] = ACTIONS(2475),
    [anon_sym___clrcall] = ACTIONS(2475),
    [anon_sym___stdcall] = ACTIONS(2475),
    [anon_sym___fastcall] = ACTIONS(2475),
    [anon_sym___thiscall] = ACTIONS(2475),
    [anon_sym___vectorcall] = ACTIONS(2475),
    [anon_sym_LBRACE] = ACTIONS(2477),
    [anon_sym_signed] = ACTIONS(2475),
    [anon_sym_unsigned] = ACTIONS(2475),
    [anon_sym_long] = ACTIONS(2475),
    [anon_sym_short] = ACTIONS(2475),
    [anon_sym_LBRACK] = ACTIONS(2475),
    [anon_sym_static] = ACTIONS(2475),
    [anon_sym_register] = ACTIONS(2475),
    [anon_sym_inline] = ACTIONS(2475),
    [anon_sym___inline] = ACTIONS(2475),
    [anon_sym___inline__] = ACTIONS(2475),
    [anon_sym___forceinline] = ACTIONS(2475),
    [anon_sym_thread_local] = ACTIONS(2475),
    [anon_sym___thread] = ACTIONS(2475),
    [anon_sym_const] = ACTIONS(2475),
    [anon_sym_constexpr] = ACTIONS(2475),
    [anon_sym_volatile] = ACTIONS(2475),
    [anon_sym_restrict] = ACTIONS(2475),
    [anon_sym___restrict__] = ACTIONS(2475),
    [anon_sym__Atomic] = ACTIONS(2475),
    [anon_sym__Noreturn] = ACTIONS(2475),
    [anon_sym_noreturn] = ACTIONS(2475),
    [anon_sym_mutable] = ACTIONS(2475),
    [anon_sym_constinit] = ACTIONS(2475),
    [anon_sym_consteval] = ACTIONS(2475),
    [anon_sym_PROGMEM] = ACTIONS(2475),
    [aux_sym_primitive_type_token1] = ACTIONS(2475),
    [anon_sym_byte] = ACTIONS(2475),
    [anon_sym_word] = ACTIONS(2475),
    [anon_sym_enum] = ACTIONS(2475),
    [anon_sym_class] = ACTIONS(2475),
    [anon_sym_struct] = ACTIONS(2475),
    [anon_sym_union] = ACTIONS(2475),
    [anon_sym_if] = ACTIONS(2475),
    [anon_sym_else] = ACTIONS(2475),
    [anon_sym_switch] = ACTIONS(2475),
    [anon_sym_case] = ACTIONS(2475),
    [anon_sym_default] = ACTIONS(2475),
    [anon_sym_while] = ACTIONS(2475),
    [anon_sym_do] = ACTIONS(2475),
    [anon_sym_for] = ACTIONS(2475),
    [anon_sym_return] = ACTIONS(2475),
    [anon_sym_break] = ACTIONS(2475),
    [anon_sym_continue] = ACTIONS(2475),
    [anon_sym_goto] = ACTIONS(2475),
    [anon_sym___try] = ACTIONS(2475),
    [anon_sym___leave] = ACTIONS(2475),
    [anon_sym_not] = ACTIONS(2475),
    [anon_sym_compl] = ACTIONS(2475),
    [anon_sym_DASH_DASH] = ACTIONS(2477),
    [anon_sym_PLUS_PLUS] = ACTIONS(2477),
    [anon_sym_sizeof] = ACTIONS(2475),
    [anon_sym___alignof__] = ACTIONS(2475),
    [anon_sym___alignof] = ACTIONS(2475),
    [anon_sym__alignof] = ACTIONS(2475),
    [anon_sym_alignof] = ACTIONS(2475),
    [anon_sym__Alignof] = ACTIONS(2475),
    [anon_sym_offsetof] = ACTIONS(2475),
    [anon_sym__Generic] = ACTIONS(2475),
    [anon_sym_asm] = ACTIONS(2475),
    [anon_sym___asm__] = ACTIONS(2475),
    [aux_sym_number_literal_token1] = ACTIONS(2477),
    [aux_sym_number_literal_token2] = ACTIONS(2475),
    [anon_sym_L_SQUOTE] = ACTIONS(2477),
    [anon_sym_u_SQUOTE] = ACTIONS(2477),
    [anon_sym_U_SQUOTE] = ACTIONS(2477),
    [anon_sym_u8_SQUOTE] = ACTIONS(2477),
    [anon_sym_SQUOTE] = ACTIONS(2477),
    [anon_sym_L_DQUOTE] = ACTIONS(2477),
    [anon_sym_u_DQUOTE] = ACTIONS(2477),
    [anon_sym_U_DQUOTE] = ACTIONS(2477),
    [anon_sym_u8_DQUOTE] = ACTIONS(2477),
    [anon_sym_DQUOTE] = ACTIONS(2477),
    [sym_true] = ACTIONS(2475),
    [sym_false] = ACTIONS(2475),
    [anon_sym_NULL] = ACTIONS(2475),
    [anon_sym_nullptr] = ACTIONS(2475),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2475),
    [anon_sym_decltype] = ACTIONS(2475),
    [anon_sym_virtual] = ACTIONS(2475),
    [anon_sym_alignas] = ACTIONS(2475),
    [anon_sym_explicit] = ACTIONS(2475),
    [anon_sym_typename] = ACTIONS(2475),
    [anon_sym_template] = ACTIONS(2475),
    [anon_sym_operator] = ACTIONS(2475),
    [anon_sym_try] = ACTIONS(2475),
    [anon_sym_delete] = ACTIONS(2475),
    [anon_sym_throw] = ACTIONS(2475),
    [anon_sym_namespace] = ACTIONS(2475),
    [anon_sym_using] = ACTIONS(2475),
    [anon_sym_static_assert] = ACTIONS(2475),
    [anon_sym_concept] = ACTIONS(2475),
    [anon_sym_co_return] = ACTIONS(2475),
    [anon_sym_co_yield] = ACTIONS(2475),
    [anon_sym_catch] = ACTIONS(2479),
    [anon_sym_R_DQUOTE] = ACTIONS(2477),
    [anon_sym_LR_DQUOTE] = ACTIONS(2477),
    [anon_sym_uR_DQUOTE] = ACTIONS(2477),
    [anon_sym_UR_DQUOTE] = ACTIONS(2477),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2477),
    [anon_sym_co_await] = ACTIONS(2475),
    [anon_sym_new] = ACTIONS(2475),
    [anon_sym_requires] = ACTIONS(2475),
    [sym_this] = ACTIONS(2475),
  },
  [221] = {
    [sym_catch_clause] = STATE(220),
    [aux_sym_constructor_try_statement_repeat1] = STATE(220),
    [sym_identifier] = ACTIONS(2482),
    [aux_sym_preproc_include_token1] = ACTIONS(2482),
    [aux_sym_preproc_def_token1] = ACTIONS(2482),
    [aux_sym_preproc_if_token1] = ACTIONS(2482),
    [aux_sym_preproc_if_token2] = ACTIONS(2482),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2482),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2482),
    [aux_sym_preproc_else_token1] = ACTIONS(2482),
    [aux_sym_preproc_elif_token1] = ACTIONS(2482),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2482),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2482),
    [sym_preproc_directive] = ACTIONS(2482),
    [anon_sym_LPAREN2] = ACTIONS(2484),
    [anon_sym_BANG] = ACTIONS(2484),
    [anon_sym_TILDE] = ACTIONS(2484),
    [anon_sym_DASH] = ACTIONS(2482),
    [anon_sym_PLUS] = ACTIONS(2482),
    [anon_sym_STAR] = ACTIONS(2484),
    [anon_sym_AMP_AMP] = ACTIONS(2484),
    [anon_sym_AMP] = ACTIONS(2482),
    [anon_sym_SEMI] = ACTIONS(2484),
    [anon_sym___extension__] = ACTIONS(2482),
    [anon_sym_typedef] = ACTIONS(2482),
    [anon_sym_extern] = ACTIONS(2482),
    [anon_sym___attribute__] = ACTIONS(2482),
    [anon_sym_COLON_COLON] = ACTIONS(2484),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2484),
    [anon_sym___declspec] = ACTIONS(2482),
    [anon_sym___based] = ACTIONS(2482),
    [anon_sym___cdecl] = ACTIONS(2482),
    [anon_sym___clrcall] = ACTIONS(2482),
    [anon_sym___stdcall] = ACTIONS(2482),
    [anon_sym___fastcall] = ACTIONS(2482),
    [anon_sym___thiscall] = ACTIONS(2482),
    [anon_sym___vectorcall] = ACTIONS(2482),
    [anon_sym_LBRACE] = ACTIONS(2484),
    [anon_sym_signed] = ACTIONS(2482),
    [anon_sym_unsigned] = ACTIONS(2482),
    [anon_sym_long] = ACTIONS(2482),
    [anon_sym_short] = ACTIONS(2482),
    [anon_sym_LBRACK] = ACTIONS(2482),
    [anon_sym_static] = ACTIONS(2482),
    [anon_sym_register] = ACTIONS(2482),
    [anon_sym_inline] = ACTIONS(2482),
    [anon_sym___inline] = ACTIONS(2482),
    [anon_sym___inline__] = ACTIONS(2482),
    [anon_sym___forceinline] = ACTIONS(2482),
    [anon_sym_thread_local] = ACTIONS(2482),
    [anon_sym___thread] = ACTIONS(2482),
    [anon_sym_const] = ACTIONS(2482),
    [anon_sym_constexpr] = ACTIONS(2482),
    [anon_sym_volatile] = ACTIONS(2482),
    [anon_sym_restrict] = ACTIONS(2482),
    [anon_sym___restrict__] = ACTIONS(2482),
    [anon_sym__Atomic] = ACTIONS(2482),
    [anon_sym__Noreturn] = ACTIONS(2482),
    [anon_sym_noreturn] = ACTIONS(2482),
    [anon_sym_mutable] = ACTIONS(2482),
    [anon_sym_constinit] = ACTIONS(2482),
    [anon_sym_consteval] = ACTIONS(2482),
    [anon_sym_PROGMEM] = ACTIONS(2482),
    [aux_sym_primitive_type_token1] = ACTIONS(2482),
    [anon_sym_byte] = ACTIONS(2482),
    [anon_sym_word] = ACTIONS(2482),
    [anon_sym_enum] = ACTIONS(2482),
    [anon_sym_class] = ACTIONS(2482),
    [anon_sym_struct] = ACTIONS(2482),
    [anon_sym_union] = ACTIONS(2482),
    [anon_sym_if] = ACTIONS(2482),
    [anon_sym_else] = ACTIONS(2482),
    [anon_sym_switch] = ACTIONS(2482),
    [anon_sym_case] = ACTIONS(2482),
    [anon_sym_default] = ACTIONS(2482),
    [anon_sym_while] = ACTIONS(2482),
    [anon_sym_do] = ACTIONS(2482),
    [anon_sym_for] = ACTIONS(2482),
    [anon_sym_return] = ACTIONS(2482),
    [anon_sym_break] = ACTIONS(2482),
    [anon_sym_continue] = ACTIONS(2482),
    [anon_sym_goto] = ACTIONS(2482),
    [anon_sym___try] = ACTIONS(2482),
    [anon_sym___leave] = ACTIONS(2482),
    [anon_sym_not] = ACTIONS(2482),
    [anon_sym_compl] = ACTIONS(2482),
    [anon_sym_DASH_DASH] = ACTIONS(2484),
    [anon_sym_PLUS_PLUS] = ACTIONS(2484),
    [anon_sym_sizeof] = ACTIONS(2482),
    [anon_sym___alignof__] = ACTIONS(2482),
    [anon_sym___alignof] = ACTIONS(2482),
    [anon_sym__alignof] = ACTIONS(2482),
    [anon_sym_alignof] = ACTIONS(2482),
    [anon_sym__Alignof] = ACTIONS(2482),
    [anon_sym_offsetof] = ACTIONS(2482),
    [anon_sym__Generic] = ACTIONS(2482),
    [anon_sym_asm] = ACTIONS(2482),
    [anon_sym___asm__] = ACTIONS(2482),
    [aux_sym_number_literal_token1] = ACTIONS(2484),
    [aux_sym_number_literal_token2] = ACTIONS(2482),
    [anon_sym_L_SQUOTE] = ACTIONS(2484),
    [anon_sym_u_SQUOTE] = ACTIONS(2484),
    [anon_sym_U_SQUOTE] = ACTIONS(2484),
    [anon_sym_u8_SQUOTE] = ACTIONS(2484),
    [anon_sym_SQUOTE] = ACTIONS(2484),
    [anon_sym_L_DQUOTE] = ACTIONS(2484),
    [anon_sym_u_DQUOTE] = ACTIONS(2484),
    [anon_sym_U_DQUOTE] = ACTIONS(2484),
    [anon_sym_u8_DQUOTE] = ACTIONS(2484),
    [anon_sym_DQUOTE] = ACTIONS(2484),
    [sym_true] = ACTIONS(2482),
    [sym_false] = ACTIONS(2482),
    [anon_sym_NULL] = ACTIONS(2482),
    [anon_sym_nullptr] = ACTIONS(2482),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2482),
    [anon_sym_decltype] = ACTIONS(2482),
    [anon_sym_virtual] = ACTIONS(2482),
    [anon_sym_alignas] = ACTIONS(2482),
    [anon_sym_explicit] = ACTIONS(2482),
    [anon_sym_typename] = ACTIONS(2482),
    [anon_sym_template] = ACTIONS(2482),
    [anon_sym_operator] = ACTIONS(2482),
    [anon_sym_try] = ACTIONS(2482),
    [anon_sym_delete] = ACTIONS(2482),
    [anon_sym_throw] = ACTIONS(2482),
    [anon_sym_namespace] = ACTIONS(2482),
    [anon_sym_using] = ACTIONS(2482),
    [anon_sym_static_assert] = ACTIONS(2482),
    [anon_sym_concept] = ACTIONS(2482),
    [anon_sym_co_return] = ACTIONS(2482),
    [anon_sym_co_yield] = ACTIONS(2482),
    [anon_sym_catch] = ACTIONS(2486),
    [anon_sym_R_DQUOTE] = ACTIONS(2484),
    [anon_sym_LR_DQUOTE] = ACTIONS(2484),
    [anon_sym_uR_DQUOTE] = ACTIONS(2484),
    [anon_sym_UR_DQUOTE] = ACTIONS(2484),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2484),
    [anon_sym_co_await] = ACTIONS(2482),
    [anon_sym_new] = ACTIONS(2482),
    [anon_sym_requires] = ACTIONS(2482),
    [sym_this] = ACTIONS(2482),
  },
  [222] = {
    [sym_catch_clause] = STATE(220),
    [aux_sym_constructor_try_statement_repeat1] = STATE(220),
    [sym_identifier] = ACTIONS(2488),
    [aux_sym_preproc_include_token1] = ACTIONS(2488),
    [aux_sym_preproc_def_token1] = ACTIONS(2488),
    [aux_sym_preproc_if_token1] = ACTIONS(2488),
    [aux_sym_preproc_if_token2] = ACTIONS(2488),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2488),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2488),
    [aux_sym_preproc_else_token1] = ACTIONS(2488),
    [aux_sym_preproc_elif_token1] = ACTIONS(2488),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2488),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2488),
    [sym_preproc_directive] = ACTIONS(2488),
    [anon_sym_LPAREN2] = ACTIONS(2490),
    [anon_sym_BANG] = ACTIONS(2490),
    [anon_sym_TILDE] = ACTIONS(2490),
    [anon_sym_DASH] = ACTIONS(2488),
    [anon_sym_PLUS] = ACTIONS(2488),
    [anon_sym_STAR] = ACTIONS(2490),
    [anon_sym_AMP_AMP] = ACTIONS(2490),
    [anon_sym_AMP] = ACTIONS(2488),
    [anon_sym_SEMI] = ACTIONS(2490),
    [anon_sym___extension__] = ACTIONS(2488),
    [anon_sym_typedef] = ACTIONS(2488),
    [anon_sym_extern] = ACTIONS(2488),
    [anon_sym___attribute__] = ACTIONS(2488),
    [anon_sym_COLON_COLON] = ACTIONS(2490),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2490),
    [anon_sym___declspec] = ACTIONS(2488),
    [anon_sym___based] = ACTIONS(2488),
    [anon_sym___cdecl] = ACTIONS(2488),
    [anon_sym___clrcall] = ACTIONS(2488),
    [anon_sym___stdcall] = ACTIONS(2488),
    [anon_sym___fastcall] = ACTIONS(2488),
    [anon_sym___thiscall] = ACTIONS(2488),
    [anon_sym___vectorcall] = ACTIONS(2488),
    [anon_sym_LBRACE] = ACTIONS(2490),
    [anon_sym_signed] = ACTIONS(2488),
    [anon_sym_unsigned] = ACTIONS(2488),
    [anon_sym_long] = ACTIONS(2488),
    [anon_sym_short] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(2488),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_register] = ACTIONS(2488),
    [anon_sym_inline] = ACTIONS(2488),
    [anon_sym___inline] = ACTIONS(2488),
    [anon_sym___inline__] = ACTIONS(2488),
    [anon_sym___forceinline] = ACTIONS(2488),
    [anon_sym_thread_local] = ACTIONS(2488),
    [anon_sym___thread] = ACTIONS(2488),
    [anon_sym_const] = ACTIONS(2488),
    [anon_sym_constexpr] = ACTIONS(2488),
    [anon_sym_volatile] = ACTIONS(2488),
    [anon_sym_restrict] = ACTIONS(2488),
    [anon_sym___restrict__] = ACTIONS(2488),
    [anon_sym__Atomic] = ACTIONS(2488),
    [anon_sym__Noreturn] = ACTIONS(2488),
    [anon_sym_noreturn] = ACTIONS(2488),
    [anon_sym_mutable] = ACTIONS(2488),
    [anon_sym_constinit] = ACTIONS(2488),
    [anon_sym_consteval] = ACTIONS(2488),
    [anon_sym_PROGMEM] = ACTIONS(2488),
    [aux_sym_primitive_type_token1] = ACTIONS(2488),
    [anon_sym_byte] = ACTIONS(2488),
    [anon_sym_word] = ACTIONS(2488),
    [anon_sym_enum] = ACTIONS(2488),
    [anon_sym_class] = ACTIONS(2488),
    [anon_sym_struct] = ACTIONS(2488),
    [anon_sym_union] = ACTIONS(2488),
    [anon_sym_if] = ACTIONS(2488),
    [anon_sym_switch] = ACTIONS(2488),
    [anon_sym_case] = ACTIONS(2488),
    [anon_sym_default] = ACTIONS(2488),
    [anon_sym_while] = ACTIONS(2488),
    [anon_sym_do] = ACTIONS(2488),
    [anon_sym_for] = ACTIONS(2488),
    [anon_sym_return] = ACTIONS(2488),
    [anon_sym_break] = ACTIONS(2488),
    [anon_sym_continue] = ACTIONS(2488),
    [anon_sym_goto] = ACTIONS(2488),
    [anon_sym___try] = ACTIONS(2488),
    [anon_sym___leave] = ACTIONS(2488),
    [anon_sym_not] = ACTIONS(2488),
    [anon_sym_compl] = ACTIONS(2488),
    [anon_sym_DASH_DASH] = ACTIONS(2490),
    [anon_sym_PLUS_PLUS] = ACTIONS(2490),
    [anon_sym_sizeof] = ACTIONS(2488),
    [anon_sym___alignof__] = ACTIONS(2488),
    [anon_sym___alignof] = ACTIONS(2488),
    [anon_sym__alignof] = ACTIONS(2488),
    [anon_sym_alignof] = ACTIONS(2488),
    [anon_sym__Alignof] = ACTIONS(2488),
    [anon_sym_offsetof] = ACTIONS(2488),
    [anon_sym__Generic] = ACTIONS(2488),
    [anon_sym_asm] = ACTIONS(2488),
    [anon_sym___asm__] = ACTIONS(2488),
    [aux_sym_number_literal_token1] = ACTIONS(2490),
    [aux_sym_number_literal_token2] = ACTIONS(2488),
    [anon_sym_L_SQUOTE] = ACTIONS(2490),
    [anon_sym_u_SQUOTE] = ACTIONS(2490),
    [anon_sym_U_SQUOTE] = ACTIONS(2490),
    [anon_sym_u8_SQUOTE] = ACTIONS(2490),
    [anon_sym_SQUOTE] = ACTIONS(2490),
    [anon_sym_L_DQUOTE] = ACTIONS(2490),
    [anon_sym_u_DQUOTE] = ACTIONS(2490),
    [anon_sym_U_DQUOTE] = ACTIONS(2490),
    [anon_sym_u8_DQUOTE] = ACTIONS(2490),
    [anon_sym_DQUOTE] = ACTIONS(2490),
    [sym_true] = ACTIONS(2488),
    [sym_false] = ACTIONS(2488),
    [anon_sym_NULL] = ACTIONS(2488),
    [anon_sym_nullptr] = ACTIONS(2488),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2488),
    [anon_sym_decltype] = ACTIONS(2488),
    [anon_sym_virtual] = ACTIONS(2488),
    [anon_sym_alignas] = ACTIONS(2488),
    [anon_sym_explicit] = ACTIONS(2488),
    [anon_sym_typename] = ACTIONS(2488),
    [anon_sym_template] = ACTIONS(2488),
    [anon_sym_operator] = ACTIONS(2488),
    [anon_sym_try] = ACTIONS(2488),
    [anon_sym_delete] = ACTIONS(2488),
    [anon_sym_throw] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_using] = ACTIONS(2488),
    [anon_sym_static_assert] = ACTIONS(2488),
    [anon_sym_concept] = ACTIONS(2488),
    [anon_sym_co_return] = ACTIONS(2488),
    [anon_sym_co_yield] = ACTIONS(2488),
    [anon_sym_catch] = ACTIONS(2486),
    [anon_sym_R_DQUOTE] = ACTIONS(2490),
    [anon_sym_LR_DQUOTE] = ACTIONS(2490),
    [anon_sym_uR_DQUOTE] = ACTIONS(2490),
    [anon_sym_UR_DQUOTE] = ACTIONS(2490),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2490),
    [anon_sym_co_await] = ACTIONS(2488),
    [anon_sym_new] = ACTIONS(2488),
    [anon_sym_requires] = ACTIONS(2488),
    [sym_this] = ACTIONS(2488),
  },
  [223] = {
    [sym_catch_clause] = STATE(220),
    [aux_sym_constructor_try_statement_repeat1] = STATE(220),
    [sym_identifier] = ACTIONS(2492),
    [aux_sym_preproc_include_token1] = ACTIONS(2492),
    [aux_sym_preproc_def_token1] = ACTIONS(2492),
    [aux_sym_preproc_if_token1] = ACTIONS(2492),
    [aux_sym_preproc_if_token2] = ACTIONS(2492),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2492),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2492),
    [aux_sym_preproc_else_token1] = ACTIONS(2492),
    [aux_sym_preproc_elif_token1] = ACTIONS(2492),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2492),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2492),
    [sym_preproc_directive] = ACTIONS(2492),
    [anon_sym_LPAREN2] = ACTIONS(2494),
    [anon_sym_BANG] = ACTIONS(2494),
    [anon_sym_TILDE] = ACTIONS(2494),
    [anon_sym_DASH] = ACTIONS(2492),
    [anon_sym_PLUS] = ACTIONS(2492),
    [anon_sym_STAR] = ACTIONS(2494),
    [anon_sym_AMP_AMP] = ACTIONS(2494),
    [anon_sym_AMP] = ACTIONS(2492),
    [anon_sym_SEMI] = ACTIONS(2494),
    [anon_sym___extension__] = ACTIONS(2492),
    [anon_sym_typedef] = ACTIONS(2492),
    [anon_sym_extern] = ACTIONS(2492),
    [anon_sym___attribute__] = ACTIONS(2492),
    [anon_sym_COLON_COLON] = ACTIONS(2494),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2494),
    [anon_sym___declspec] = ACTIONS(2492),
    [anon_sym___based] = ACTIONS(2492),
    [anon_sym___cdecl] = ACTIONS(2492),
    [anon_sym___clrcall] = ACTIONS(2492),
    [anon_sym___stdcall] = ACTIONS(2492),
    [anon_sym___fastcall] = ACTIONS(2492),
    [anon_sym___thiscall] = ACTIONS(2492),
    [anon_sym___vectorcall] = ACTIONS(2492),
    [anon_sym_LBRACE] = ACTIONS(2494),
    [anon_sym_signed] = ACTIONS(2492),
    [anon_sym_unsigned] = ACTIONS(2492),
    [anon_sym_long] = ACTIONS(2492),
    [anon_sym_short] = ACTIONS(2492),
    [anon_sym_LBRACK] = ACTIONS(2492),
    [anon_sym_static] = ACTIONS(2492),
    [anon_sym_register] = ACTIONS(2492),
    [anon_sym_inline] = ACTIONS(2492),
    [anon_sym___inline] = ACTIONS(2492),
    [anon_sym___inline__] = ACTIONS(2492),
    [anon_sym___forceinline] = ACTIONS(2492),
    [anon_sym_thread_local] = ACTIONS(2492),
    [anon_sym___thread] = ACTIONS(2492),
    [anon_sym_const] = ACTIONS(2492),
    [anon_sym_constexpr] = ACTIONS(2492),
    [anon_sym_volatile] = ACTIONS(2492),
    [anon_sym_restrict] = ACTIONS(2492),
    [anon_sym___restrict__] = ACTIONS(2492),
    [anon_sym__Atomic] = ACTIONS(2492),
    [anon_sym__Noreturn] = ACTIONS(2492),
    [anon_sym_noreturn] = ACTIONS(2492),
    [anon_sym_mutable] = ACTIONS(2492),
    [anon_sym_constinit] = ACTIONS(2492),
    [anon_sym_consteval] = ACTIONS(2492),
    [anon_sym_PROGMEM] = ACTIONS(2492),
    [aux_sym_primitive_type_token1] = ACTIONS(2492),
    [anon_sym_byte] = ACTIONS(2492),
    [anon_sym_word] = ACTIONS(2492),
    [anon_sym_enum] = ACTIONS(2492),
    [anon_sym_class] = ACTIONS(2492),
    [anon_sym_struct] = ACTIONS(2492),
    [anon_sym_union] = ACTIONS(2492),
    [anon_sym_if] = ACTIONS(2492),
    [anon_sym_switch] = ACTIONS(2492),
    [anon_sym_case] = ACTIONS(2492),
    [anon_sym_default] = ACTIONS(2492),
    [anon_sym_while] = ACTIONS(2492),
    [anon_sym_do] = ACTIONS(2492),
    [anon_sym_for] = ACTIONS(2492),
    [anon_sym_return] = ACTIONS(2492),
    [anon_sym_break] = ACTIONS(2492),
    [anon_sym_continue] = ACTIONS(2492),
    [anon_sym_goto] = ACTIONS(2492),
    [anon_sym___try] = ACTIONS(2492),
    [anon_sym___leave] = ACTIONS(2492),
    [anon_sym_not] = ACTIONS(2492),
    [anon_sym_compl] = ACTIONS(2492),
    [anon_sym_DASH_DASH] = ACTIONS(2494),
    [anon_sym_PLUS_PLUS] = ACTIONS(2494),
    [anon_sym_sizeof] = ACTIONS(2492),
    [anon_sym___alignof__] = ACTIONS(2492),
    [anon_sym___alignof] = ACTIONS(2492),
    [anon_sym__alignof] = ACTIONS(2492),
    [anon_sym_alignof] = ACTIONS(2492),
    [anon_sym__Alignof] = ACTIONS(2492),
    [anon_sym_offsetof] = ACTIONS(2492),
    [anon_sym__Generic] = ACTIONS(2492),
    [anon_sym_asm] = ACTIONS(2492),
    [anon_sym___asm__] = ACTIONS(2492),
    [aux_sym_number_literal_token1] = ACTIONS(2494),
    [aux_sym_number_literal_token2] = ACTIONS(2492),
    [anon_sym_L_SQUOTE] = ACTIONS(2494),
    [anon_sym_u_SQUOTE] = ACTIONS(2494),
    [anon_sym_U_SQUOTE] = ACTIONS(2494),
    [anon_sym_u8_SQUOTE] = ACTIONS(2494),
    [anon_sym_SQUOTE] = ACTIONS(2494),
    [anon_sym_L_DQUOTE] = ACTIONS(2494),
    [anon_sym_u_DQUOTE] = ACTIONS(2494),
    [anon_sym_U_DQUOTE] = ACTIONS(2494),
    [anon_sym_u8_DQUOTE] = ACTIONS(2494),
    [anon_sym_DQUOTE] = ACTIONS(2494),
    [sym_true] = ACTIONS(2492),
    [sym_false] = ACTIONS(2492),
    [anon_sym_NULL] = ACTIONS(2492),
    [anon_sym_nullptr] = ACTIONS(2492),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2492),
    [anon_sym_decltype] = ACTIONS(2492),
    [anon_sym_virtual] = ACTIONS(2492),
    [anon_sym_alignas] = ACTIONS(2492),
    [anon_sym_explicit] = ACTIONS(2492),
    [anon_sym_typename] = ACTIONS(2492),
    [anon_sym_template] = ACTIONS(2492),
    [anon_sym_operator] = ACTIONS(2492),
    [anon_sym_try] = ACTIONS(2492),
    [anon_sym_delete] = ACTIONS(2492),
    [anon_sym_throw] = ACTIONS(2492),
    [anon_sym_namespace] = ACTIONS(2492),
    [anon_sym_using] = ACTIONS(2492),
    [anon_sym_static_assert] = ACTIONS(2492),
    [anon_sym_concept] = ACTIONS(2492),
    [anon_sym_co_return] = ACTIONS(2492),
    [anon_sym_co_yield] = ACTIONS(2492),
    [anon_sym_catch] = ACTIONS(2486),
    [anon_sym_R_DQUOTE] = ACTIONS(2494),
    [anon_sym_LR_DQUOTE] = ACTIONS(2494),
    [anon_sym_uR_DQUOTE] = ACTIONS(2494),
    [anon_sym_UR_DQUOTE] = ACTIONS(2494),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2494),
    [anon_sym_co_await] = ACTIONS(2492),
    [anon_sym_new] = ACTIONS(2492),
    [anon_sym_requires] = ACTIONS(2492),
    [sym_this] = ACTIONS(2492),
  },
  [224] = {
    [sym_else_clause] = STATE(313),
    [sym_identifier] = ACTIONS(2496),
    [aux_sym_preproc_include_token1] = ACTIONS(2496),
    [aux_sym_preproc_def_token1] = ACTIONS(2496),
    [aux_sym_preproc_if_token1] = ACTIONS(2496),
    [aux_sym_preproc_if_token2] = ACTIONS(2496),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2496),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2496),
    [aux_sym_preproc_else_token1] = ACTIONS(2496),
    [aux_sym_preproc_elif_token1] = ACTIONS(2496),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2496),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2496),
    [sym_preproc_directive] = ACTIONS(2496),
    [anon_sym_LPAREN2] = ACTIONS(2498),
    [anon_sym_BANG] = ACTIONS(2498),
    [anon_sym_TILDE] = ACTIONS(2498),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_STAR] = ACTIONS(2498),
    [anon_sym_AMP_AMP] = ACTIONS(2498),
    [anon_sym_AMP] = ACTIONS(2496),
    [anon_sym_SEMI] = ACTIONS(2498),
    [anon_sym___extension__] = ACTIONS(2496),
    [anon_sym_typedef] = ACTIONS(2496),
    [anon_sym_extern] = ACTIONS(2496),
    [anon_sym___attribute__] = ACTIONS(2496),
    [anon_sym_COLON_COLON] = ACTIONS(2498),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2498),
    [anon_sym___declspec] = ACTIONS(2496),
    [anon_sym___based] = ACTIONS(2496),
    [anon_sym___cdecl] = ACTIONS(2496),
    [anon_sym___clrcall] = ACTIONS(2496),
    [anon_sym___stdcall] = ACTIONS(2496),
    [anon_sym___fastcall] = ACTIONS(2496),
    [anon_sym___thiscall] = ACTIONS(2496),
    [anon_sym___vectorcall] = ACTIONS(2496),
    [anon_sym_LBRACE] = ACTIONS(2498),
    [anon_sym_signed] = ACTIONS(2496),
    [anon_sym_unsigned] = ACTIONS(2496),
    [anon_sym_long] = ACTIONS(2496),
    [anon_sym_short] = ACTIONS(2496),
    [anon_sym_LBRACK] = ACTIONS(2496),
    [anon_sym_static] = ACTIONS(2496),
    [anon_sym_register] = ACTIONS(2496),
    [anon_sym_inline] = ACTIONS(2496),
    [anon_sym___inline] = ACTIONS(2496),
    [anon_sym___inline__] = ACTIONS(2496),
    [anon_sym___forceinline] = ACTIONS(2496),
    [anon_sym_thread_local] = ACTIONS(2496),
    [anon_sym___thread] = ACTIONS(2496),
    [anon_sym_const] = ACTIONS(2496),
    [anon_sym_constexpr] = ACTIONS(2496),
    [anon_sym_volatile] = ACTIONS(2496),
    [anon_sym_restrict] = ACTIONS(2496),
    [anon_sym___restrict__] = ACTIONS(2496),
    [anon_sym__Atomic] = ACTIONS(2496),
    [anon_sym__Noreturn] = ACTIONS(2496),
    [anon_sym_noreturn] = ACTIONS(2496),
    [anon_sym_mutable] = ACTIONS(2496),
    [anon_sym_constinit] = ACTIONS(2496),
    [anon_sym_consteval] = ACTIONS(2496),
    [anon_sym_PROGMEM] = ACTIONS(2496),
    [aux_sym_primitive_type_token1] = ACTIONS(2496),
    [anon_sym_byte] = ACTIONS(2496),
    [anon_sym_word] = ACTIONS(2496),
    [anon_sym_enum] = ACTIONS(2496),
    [anon_sym_class] = ACTIONS(2496),
    [anon_sym_struct] = ACTIONS(2496),
    [anon_sym_union] = ACTIONS(2496),
    [anon_sym_if] = ACTIONS(2496),
    [anon_sym_else] = ACTIONS(2500),
    [anon_sym_switch] = ACTIONS(2496),
    [anon_sym_case] = ACTIONS(2496),
    [anon_sym_default] = ACTIONS(2496),
    [anon_sym_while] = ACTIONS(2496),
    [anon_sym_do] = ACTIONS(2496),
    [anon_sym_for] = ACTIONS(2496),
    [anon_sym_return] = ACTIONS(2496),
    [anon_sym_break] = ACTIONS(2496),
    [anon_sym_continue] = ACTIONS(2496),
    [anon_sym_goto] = ACTIONS(2496),
    [anon_sym___try] = ACTIONS(2496),
    [anon_sym___leave] = ACTIONS(2496),
    [anon_sym_not] = ACTIONS(2496),
    [anon_sym_compl] = ACTIONS(2496),
    [anon_sym_DASH_DASH] = ACTIONS(2498),
    [anon_sym_PLUS_PLUS] = ACTIONS(2498),
    [anon_sym_sizeof] = ACTIONS(2496),
    [anon_sym___alignof__] = ACTIONS(2496),
    [anon_sym___alignof] = ACTIONS(2496),
    [anon_sym__alignof] = ACTIONS(2496),
    [anon_sym_alignof] = ACTIONS(2496),
    [anon_sym__Alignof] = ACTIONS(2496),
    [anon_sym_offsetof] = ACTIONS(2496),
    [anon_sym__Generic] = ACTIONS(2496),
    [anon_sym_asm] = ACTIONS(2496),
    [anon_sym___asm__] = ACTIONS(2496),
    [aux_sym_number_literal_token1] = ACTIONS(2498),
    [aux_sym_number_literal_token2] = ACTIONS(2496),
    [anon_sym_L_SQUOTE] = ACTIONS(2498),
    [anon_sym_u_SQUOTE] = ACTIONS(2498),
    [anon_sym_U_SQUOTE] = ACTIONS(2498),
    [anon_sym_u8_SQUOTE] = ACTIONS(2498),
    [anon_sym_SQUOTE] = ACTIONS(2498),
    [anon_sym_L_DQUOTE] = ACTIONS(2498),
    [anon_sym_u_DQUOTE] = ACTIONS(2498),
    [anon_sym_U_DQUOTE] = ACTIONS(2498),
    [anon_sym_u8_DQUOTE] = ACTIONS(2498),
    [anon_sym_DQUOTE] = ACTIONS(2498),
    [sym_true] = ACTIONS(2496),
    [sym_false] = ACTIONS(2496),
    [anon_sym_NULL] = ACTIONS(2496),
    [anon_sym_nullptr] = ACTIONS(2496),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2496),
    [anon_sym_decltype] = ACTIONS(2496),
    [anon_sym_virtual] = ACTIONS(2496),
    [anon_sym_alignas] = ACTIONS(2496),
    [anon_sym_explicit] = ACTIONS(2496),
    [anon_sym_typename] = ACTIONS(2496),
    [anon_sym_template] = ACTIONS(2496),
    [anon_sym_operator] = ACTIONS(2496),
    [anon_sym_try] = ACTIONS(2496),
    [anon_sym_delete] = ACTIONS(2496),
    [anon_sym_throw] = ACTIONS(2496),
    [anon_sym_namespace] = ACTIONS(2496),
    [anon_sym_using] = ACTIONS(2496),
    [anon_sym_static_assert] = ACTIONS(2496),
    [anon_sym_concept] = ACTIONS(2496),
    [anon_sym_co_return] = ACTIONS(2496),
    [anon_sym_co_yield] = ACTIONS(2496),
    [anon_sym_R_DQUOTE] = ACTIONS(2498),
    [anon_sym_LR_DQUOTE] = ACTIONS(2498),
    [anon_sym_uR_DQUOTE] = ACTIONS(2498),
    [anon_sym_UR_DQUOTE] = ACTIONS(2498),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2498),
    [anon_sym_co_await] = ACTIONS(2496),
    [anon_sym_new] = ACTIONS(2496),
    [anon_sym_requires] = ACTIONS(2496),
    [sym_this] = ACTIONS(2496),
  },
  [225] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4470),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(7806),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2502),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(2505),
    [anon_sym___extension__] = ACTIONS(2507),
    [anon_sym_extern] = ACTIONS(2507),
    [anon_sym___attribute__] = ACTIONS(2507),
    [anon_sym_COLON_COLON] = ACTIONS(2509),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2512),
    [anon_sym___declspec] = ACTIONS(2507),
    [anon_sym_signed] = ACTIONS(2507),
    [anon_sym_unsigned] = ACTIONS(2507),
    [anon_sym_long] = ACTIONS(2507),
    [anon_sym_short] = ACTIONS(2507),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [anon_sym_static] = ACTIONS(2507),
    [anon_sym_register] = ACTIONS(2507),
    [anon_sym_inline] = ACTIONS(2507),
    [anon_sym___inline] = ACTIONS(2507),
    [anon_sym___inline__] = ACTIONS(2507),
    [anon_sym___forceinline] = ACTIONS(2507),
    [anon_sym_thread_local] = ACTIONS(2507),
    [anon_sym___thread] = ACTIONS(2507),
    [anon_sym_const] = ACTIONS(2507),
    [anon_sym_constexpr] = ACTIONS(2507),
    [anon_sym_volatile] = ACTIONS(2507),
    [anon_sym_restrict] = ACTIONS(2507),
    [anon_sym___restrict__] = ACTIONS(2507),
    [anon_sym__Atomic] = ACTIONS(2507),
    [anon_sym__Noreturn] = ACTIONS(2507),
    [anon_sym_noreturn] = ACTIONS(2507),
    [anon_sym_mutable] = ACTIONS(2507),
    [anon_sym_constinit] = ACTIONS(2507),
    [anon_sym_consteval] = ACTIONS(2507),
    [anon_sym_PROGMEM] = ACTIONS(2507),
    [aux_sym_primitive_type_token1] = ACTIONS(2514),
    [anon_sym_byte] = ACTIONS(2514),
    [anon_sym_word] = ACTIONS(2514),
    [anon_sym_enum] = ACTIONS(2507),
    [anon_sym_class] = ACTIONS(2507),
    [anon_sym_struct] = ACTIONS(2507),
    [anon_sym_union] = ACTIONS(2507),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2507),
    [anon_sym_decltype] = ACTIONS(2517),
    [anon_sym_virtual] = ACTIONS(2507),
    [anon_sym_alignas] = ACTIONS(2507),
    [anon_sym_typename] = ACTIONS(2507),
    [anon_sym_template] = ACTIONS(2520),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [226] = {
    [sym_identifier] = ACTIONS(1961),
    [aux_sym_preproc_include_token1] = ACTIONS(1961),
    [aux_sym_preproc_def_token1] = ACTIONS(1961),
    [aux_sym_preproc_if_token1] = ACTIONS(1961),
    [aux_sym_preproc_if_token2] = ACTIONS(1961),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1961),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1961),
    [aux_sym_preproc_else_token1] = ACTIONS(1961),
    [aux_sym_preproc_elif_token1] = ACTIONS(1961),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1961),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1961),
    [sym_preproc_directive] = ACTIONS(1961),
    [anon_sym_LPAREN2] = ACTIONS(1959),
    [anon_sym_BANG] = ACTIONS(1959),
    [anon_sym_TILDE] = ACTIONS(1959),
    [anon_sym_DASH] = ACTIONS(1961),
    [anon_sym_PLUS] = ACTIONS(1961),
    [anon_sym_STAR] = ACTIONS(1959),
    [anon_sym_AMP_AMP] = ACTIONS(1959),
    [anon_sym_AMP] = ACTIONS(1961),
    [anon_sym_SEMI] = ACTIONS(1959),
    [anon_sym___extension__] = ACTIONS(1961),
    [anon_sym_typedef] = ACTIONS(1961),
    [anon_sym_extern] = ACTIONS(1961),
    [anon_sym___attribute__] = ACTIONS(1961),
    [anon_sym_COLON_COLON] = ACTIONS(1959),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1959),
    [anon_sym___declspec] = ACTIONS(1961),
    [anon_sym___based] = ACTIONS(1961),
    [anon_sym___cdecl] = ACTIONS(1961),
    [anon_sym___clrcall] = ACTIONS(1961),
    [anon_sym___stdcall] = ACTIONS(1961),
    [anon_sym___fastcall] = ACTIONS(1961),
    [anon_sym___thiscall] = ACTIONS(1961),
    [anon_sym___vectorcall] = ACTIONS(1961),
    [anon_sym_LBRACE] = ACTIONS(1959),
    [anon_sym_signed] = ACTIONS(1961),
    [anon_sym_unsigned] = ACTIONS(1961),
    [anon_sym_long] = ACTIONS(1961),
    [anon_sym_short] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1961),
    [anon_sym_static] = ACTIONS(1961),
    [anon_sym_register] = ACTIONS(1961),
    [anon_sym_inline] = ACTIONS(1961),
    [anon_sym___inline] = ACTIONS(1961),
    [anon_sym___inline__] = ACTIONS(1961),
    [anon_sym___forceinline] = ACTIONS(1961),
    [anon_sym_thread_local] = ACTIONS(1961),
    [anon_sym___thread] = ACTIONS(1961),
    [anon_sym_const] = ACTIONS(1961),
    [anon_sym_constexpr] = ACTIONS(1961),
    [anon_sym_volatile] = ACTIONS(1961),
    [anon_sym_restrict] = ACTIONS(1961),
    [anon_sym___restrict__] = ACTIONS(1961),
    [anon_sym__Atomic] = ACTIONS(1961),
    [anon_sym__Noreturn] = ACTIONS(1961),
    [anon_sym_noreturn] = ACTIONS(1961),
    [anon_sym_mutable] = ACTIONS(1961),
    [anon_sym_constinit] = ACTIONS(1961),
    [anon_sym_consteval] = ACTIONS(1961),
    [anon_sym_PROGMEM] = ACTIONS(1961),
    [aux_sym_primitive_type_token1] = ACTIONS(1961),
    [anon_sym_byte] = ACTIONS(1961),
    [anon_sym_word] = ACTIONS(1961),
    [anon_sym_enum] = ACTIONS(1961),
    [anon_sym_class] = ACTIONS(1961),
    [anon_sym_struct] = ACTIONS(1961),
    [anon_sym_union] = ACTIONS(1961),
    [anon_sym_if] = ACTIONS(1961),
    [anon_sym_else] = ACTIONS(1961),
    [anon_sym_switch] = ACTIONS(1961),
    [anon_sym_case] = ACTIONS(1961),
    [anon_sym_default] = ACTIONS(1961),
    [anon_sym_while] = ACTIONS(1961),
    [anon_sym_do] = ACTIONS(1961),
    [anon_sym_for] = ACTIONS(1961),
    [anon_sym_return] = ACTIONS(1961),
    [anon_sym_break] = ACTIONS(1961),
    [anon_sym_continue] = ACTIONS(1961),
    [anon_sym_goto] = ACTIONS(1961),
    [anon_sym___try] = ACTIONS(1961),
    [anon_sym___leave] = ACTIONS(1961),
    [anon_sym_not] = ACTIONS(1961),
    [anon_sym_compl] = ACTIONS(1961),
    [anon_sym_DASH_DASH] = ACTIONS(1959),
    [anon_sym_PLUS_PLUS] = ACTIONS(1959),
    [anon_sym_sizeof] = ACTIONS(1961),
    [anon_sym___alignof__] = ACTIONS(1961),
    [anon_sym___alignof] = ACTIONS(1961),
    [anon_sym__alignof] = ACTIONS(1961),
    [anon_sym_alignof] = ACTIONS(1961),
    [anon_sym__Alignof] = ACTIONS(1961),
    [anon_sym_offsetof] = ACTIONS(1961),
    [anon_sym__Generic] = ACTIONS(1961),
    [anon_sym_asm] = ACTIONS(1961),
    [anon_sym___asm__] = ACTIONS(1961),
    [aux_sym_number_literal_token1] = ACTIONS(1959),
    [aux_sym_number_literal_token2] = ACTIONS(1961),
    [anon_sym_L_SQUOTE] = ACTIONS(1959),
    [anon_sym_u_SQUOTE] = ACTIONS(1959),
    [anon_sym_U_SQUOTE] = ACTIONS(1959),
    [anon_sym_u8_SQUOTE] = ACTIONS(1959),
    [anon_sym_SQUOTE] = ACTIONS(1959),
    [anon_sym_L_DQUOTE] = ACTIONS(1959),
    [anon_sym_u_DQUOTE] = ACTIONS(1959),
    [anon_sym_U_DQUOTE] = ACTIONS(1959),
    [anon_sym_u8_DQUOTE] = ACTIONS(1959),
    [anon_sym_DQUOTE] = ACTIONS(1959),
    [sym_true] = ACTIONS(1961),
    [sym_false] = ACTIONS(1961),
    [anon_sym_NULL] = ACTIONS(1961),
    [anon_sym_nullptr] = ACTIONS(1961),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1961),
    [anon_sym_decltype] = ACTIONS(1961),
    [anon_sym_virtual] = ACTIONS(1961),
    [anon_sym_alignas] = ACTIONS(1961),
    [anon_sym_explicit] = ACTIONS(1961),
    [anon_sym_typename] = ACTIONS(1961),
    [anon_sym_template] = ACTIONS(1961),
    [anon_sym_operator] = ACTIONS(1961),
    [anon_sym_try] = ACTIONS(1961),
    [anon_sym_delete] = ACTIONS(1961),
    [anon_sym_throw] = ACTIONS(1961),
    [anon_sym_namespace] = ACTIONS(1961),
    [anon_sym_using] = ACTIONS(1961),
    [anon_sym_static_assert] = ACTIONS(1961),
    [anon_sym_concept] = ACTIONS(1961),
    [anon_sym_co_return] = ACTIONS(1961),
    [anon_sym_co_yield] = ACTIONS(1961),
    [anon_sym_catch] = ACTIONS(1961),
    [anon_sym_R_DQUOTE] = ACTIONS(1959),
    [anon_sym_LR_DQUOTE] = ACTIONS(1959),
    [anon_sym_uR_DQUOTE] = ACTIONS(1959),
    [anon_sym_UR_DQUOTE] = ACTIONS(1959),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1959),
    [anon_sym_co_await] = ACTIONS(1961),
    [anon_sym_new] = ACTIONS(1961),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1961),
  },
  [227] = {
    [sym_else_clause] = STATE(317),
    [sym_identifier] = ACTIONS(2523),
    [aux_sym_preproc_include_token1] = ACTIONS(2523),
    [aux_sym_preproc_def_token1] = ACTIONS(2523),
    [aux_sym_preproc_if_token1] = ACTIONS(2523),
    [aux_sym_preproc_if_token2] = ACTIONS(2523),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2523),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2523),
    [aux_sym_preproc_else_token1] = ACTIONS(2523),
    [aux_sym_preproc_elif_token1] = ACTIONS(2523),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2523),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2523),
    [sym_preproc_directive] = ACTIONS(2523),
    [anon_sym_LPAREN2] = ACTIONS(2525),
    [anon_sym_BANG] = ACTIONS(2525),
    [anon_sym_TILDE] = ACTIONS(2525),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_PLUS] = ACTIONS(2523),
    [anon_sym_STAR] = ACTIONS(2525),
    [anon_sym_AMP_AMP] = ACTIONS(2525),
    [anon_sym_AMP] = ACTIONS(2523),
    [anon_sym_SEMI] = ACTIONS(2525),
    [anon_sym___extension__] = ACTIONS(2523),
    [anon_sym_typedef] = ACTIONS(2523),
    [anon_sym_extern] = ACTIONS(2523),
    [anon_sym___attribute__] = ACTIONS(2523),
    [anon_sym_COLON_COLON] = ACTIONS(2525),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2525),
    [anon_sym___declspec] = ACTIONS(2523),
    [anon_sym___based] = ACTIONS(2523),
    [anon_sym___cdecl] = ACTIONS(2523),
    [anon_sym___clrcall] = ACTIONS(2523),
    [anon_sym___stdcall] = ACTIONS(2523),
    [anon_sym___fastcall] = ACTIONS(2523),
    [anon_sym___thiscall] = ACTIONS(2523),
    [anon_sym___vectorcall] = ACTIONS(2523),
    [anon_sym_LBRACE] = ACTIONS(2525),
    [anon_sym_signed] = ACTIONS(2523),
    [anon_sym_unsigned] = ACTIONS(2523),
    [anon_sym_long] = ACTIONS(2523),
    [anon_sym_short] = ACTIONS(2523),
    [anon_sym_LBRACK] = ACTIONS(2523),
    [anon_sym_static] = ACTIONS(2523),
    [anon_sym_register] = ACTIONS(2523),
    [anon_sym_inline] = ACTIONS(2523),
    [anon_sym___inline] = ACTIONS(2523),
    [anon_sym___inline__] = ACTIONS(2523),
    [anon_sym___forceinline] = ACTIONS(2523),
    [anon_sym_thread_local] = ACTIONS(2523),
    [anon_sym___thread] = ACTIONS(2523),
    [anon_sym_const] = ACTIONS(2523),
    [anon_sym_constexpr] = ACTIONS(2523),
    [anon_sym_volatile] = ACTIONS(2523),
    [anon_sym_restrict] = ACTIONS(2523),
    [anon_sym___restrict__] = ACTIONS(2523),
    [anon_sym__Atomic] = ACTIONS(2523),
    [anon_sym__Noreturn] = ACTIONS(2523),
    [anon_sym_noreturn] = ACTIONS(2523),
    [anon_sym_mutable] = ACTIONS(2523),
    [anon_sym_constinit] = ACTIONS(2523),
    [anon_sym_consteval] = ACTIONS(2523),
    [anon_sym_PROGMEM] = ACTIONS(2523),
    [aux_sym_primitive_type_token1] = ACTIONS(2523),
    [anon_sym_byte] = ACTIONS(2523),
    [anon_sym_word] = ACTIONS(2523),
    [anon_sym_enum] = ACTIONS(2523),
    [anon_sym_class] = ACTIONS(2523),
    [anon_sym_struct] = ACTIONS(2523),
    [anon_sym_union] = ACTIONS(2523),
    [anon_sym_if] = ACTIONS(2523),
    [anon_sym_else] = ACTIONS(2500),
    [anon_sym_switch] = ACTIONS(2523),
    [anon_sym_case] = ACTIONS(2523),
    [anon_sym_default] = ACTIONS(2523),
    [anon_sym_while] = ACTIONS(2523),
    [anon_sym_do] = ACTIONS(2523),
    [anon_sym_for] = ACTIONS(2523),
    [anon_sym_return] = ACTIONS(2523),
    [anon_sym_break] = ACTIONS(2523),
    [anon_sym_continue] = ACTIONS(2523),
    [anon_sym_goto] = ACTIONS(2523),
    [anon_sym___try] = ACTIONS(2523),
    [anon_sym___leave] = ACTIONS(2523),
    [anon_sym_not] = ACTIONS(2523),
    [anon_sym_compl] = ACTIONS(2523),
    [anon_sym_DASH_DASH] = ACTIONS(2525),
    [anon_sym_PLUS_PLUS] = ACTIONS(2525),
    [anon_sym_sizeof] = ACTIONS(2523),
    [anon_sym___alignof__] = ACTIONS(2523),
    [anon_sym___alignof] = ACTIONS(2523),
    [anon_sym__alignof] = ACTIONS(2523),
    [anon_sym_alignof] = ACTIONS(2523),
    [anon_sym__Alignof] = ACTIONS(2523),
    [anon_sym_offsetof] = ACTIONS(2523),
    [anon_sym__Generic] = ACTIONS(2523),
    [anon_sym_asm] = ACTIONS(2523),
    [anon_sym___asm__] = ACTIONS(2523),
    [aux_sym_number_literal_token1] = ACTIONS(2525),
    [aux_sym_number_literal_token2] = ACTIONS(2523),
    [anon_sym_L_SQUOTE] = ACTIONS(2525),
    [anon_sym_u_SQUOTE] = ACTIONS(2525),
    [anon_sym_U_SQUOTE] = ACTIONS(2525),
    [anon_sym_u8_SQUOTE] = ACTIONS(2525),
    [anon_sym_SQUOTE] = ACTIONS(2525),
    [anon_sym_L_DQUOTE] = ACTIONS(2525),
    [anon_sym_u_DQUOTE] = ACTIONS(2525),
    [anon_sym_U_DQUOTE] = ACTIONS(2525),
    [anon_sym_u8_DQUOTE] = ACTIONS(2525),
    [anon_sym_DQUOTE] = ACTIONS(2525),
    [sym_true] = ACTIONS(2523),
    [sym_false] = ACTIONS(2523),
    [anon_sym_NULL] = ACTIONS(2523),
    [anon_sym_nullptr] = ACTIONS(2523),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2523),
    [anon_sym_decltype] = ACTIONS(2523),
    [anon_sym_virtual] = ACTIONS(2523),
    [anon_sym_alignas] = ACTIONS(2523),
    [anon_sym_explicit] = ACTIONS(2523),
    [anon_sym_typename] = ACTIONS(2523),
    [anon_sym_template] = ACTIONS(2523),
    [anon_sym_operator] = ACTIONS(2523),
    [anon_sym_try] = ACTIONS(2523),
    [anon_sym_delete] = ACTIONS(2523),
    [anon_sym_throw] = ACTIONS(2523),
    [anon_sym_namespace] = ACTIONS(2523),
    [anon_sym_using] = ACTIONS(2523),
    [anon_sym_static_assert] = ACTIONS(2523),
    [anon_sym_concept] = ACTIONS(2523),
    [anon_sym_co_return] = ACTIONS(2523),
    [anon_sym_co_yield] = ACTIONS(2523),
    [anon_sym_R_DQUOTE] = ACTIONS(2525),
    [anon_sym_LR_DQUOTE] = ACTIONS(2525),
    [anon_sym_uR_DQUOTE] = ACTIONS(2525),
    [anon_sym_UR_DQUOTE] = ACTIONS(2525),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2525),
    [anon_sym_co_await] = ACTIONS(2523),
    [anon_sym_new] = ACTIONS(2523),
    [anon_sym_requires] = ACTIONS(2523),
    [sym_this] = ACTIONS(2523),
  },
  [228] = {
    [sym_identifier] = ACTIONS(1957),
    [aux_sym_preproc_include_token1] = ACTIONS(1957),
    [aux_sym_preproc_def_token1] = ACTIONS(1957),
    [aux_sym_preproc_if_token1] = ACTIONS(1957),
    [aux_sym_preproc_if_token2] = ACTIONS(1957),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1957),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1957),
    [aux_sym_preproc_else_token1] = ACTIONS(1957),
    [aux_sym_preproc_elif_token1] = ACTIONS(1957),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1957),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1957),
    [sym_preproc_directive] = ACTIONS(1957),
    [anon_sym_LPAREN2] = ACTIONS(1955),
    [anon_sym_BANG] = ACTIONS(1955),
    [anon_sym_TILDE] = ACTIONS(1955),
    [anon_sym_DASH] = ACTIONS(1957),
    [anon_sym_PLUS] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(1955),
    [anon_sym_AMP_AMP] = ACTIONS(1955),
    [anon_sym_AMP] = ACTIONS(1957),
    [anon_sym_SEMI] = ACTIONS(1955),
    [anon_sym___extension__] = ACTIONS(1957),
    [anon_sym_typedef] = ACTIONS(1957),
    [anon_sym_extern] = ACTIONS(1957),
    [anon_sym___attribute__] = ACTIONS(1957),
    [anon_sym_COLON_COLON] = ACTIONS(1955),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1955),
    [anon_sym___declspec] = ACTIONS(1957),
    [anon_sym___based] = ACTIONS(1957),
    [anon_sym___cdecl] = ACTIONS(1957),
    [anon_sym___clrcall] = ACTIONS(1957),
    [anon_sym___stdcall] = ACTIONS(1957),
    [anon_sym___fastcall] = ACTIONS(1957),
    [anon_sym___thiscall] = ACTIONS(1957),
    [anon_sym___vectorcall] = ACTIONS(1957),
    [anon_sym_LBRACE] = ACTIONS(1955),
    [anon_sym_signed] = ACTIONS(1957),
    [anon_sym_unsigned] = ACTIONS(1957),
    [anon_sym_long] = ACTIONS(1957),
    [anon_sym_short] = ACTIONS(1957),
    [anon_sym_LBRACK] = ACTIONS(1957),
    [anon_sym_static] = ACTIONS(1957),
    [anon_sym_register] = ACTIONS(1957),
    [anon_sym_inline] = ACTIONS(1957),
    [anon_sym___inline] = ACTIONS(1957),
    [anon_sym___inline__] = ACTIONS(1957),
    [anon_sym___forceinline] = ACTIONS(1957),
    [anon_sym_thread_local] = ACTIONS(1957),
    [anon_sym___thread] = ACTIONS(1957),
    [anon_sym_const] = ACTIONS(1957),
    [anon_sym_constexpr] = ACTIONS(1957),
    [anon_sym_volatile] = ACTIONS(1957),
    [anon_sym_restrict] = ACTIONS(1957),
    [anon_sym___restrict__] = ACTIONS(1957),
    [anon_sym__Atomic] = ACTIONS(1957),
    [anon_sym__Noreturn] = ACTIONS(1957),
    [anon_sym_noreturn] = ACTIONS(1957),
    [anon_sym_mutable] = ACTIONS(1957),
    [anon_sym_constinit] = ACTIONS(1957),
    [anon_sym_consteval] = ACTIONS(1957),
    [anon_sym_PROGMEM] = ACTIONS(1957),
    [aux_sym_primitive_type_token1] = ACTIONS(1957),
    [anon_sym_byte] = ACTIONS(1957),
    [anon_sym_word] = ACTIONS(1957),
    [anon_sym_enum] = ACTIONS(1957),
    [anon_sym_class] = ACTIONS(1957),
    [anon_sym_struct] = ACTIONS(1957),
    [anon_sym_union] = ACTIONS(1957),
    [anon_sym_if] = ACTIONS(1957),
    [anon_sym_else] = ACTIONS(1957),
    [anon_sym_switch] = ACTIONS(1957),
    [anon_sym_case] = ACTIONS(1957),
    [anon_sym_default] = ACTIONS(1957),
    [anon_sym_while] = ACTIONS(1957),
    [anon_sym_do] = ACTIONS(1957),
    [anon_sym_for] = ACTIONS(1957),
    [anon_sym_return] = ACTIONS(1957),
    [anon_sym_break] = ACTIONS(1957),
    [anon_sym_continue] = ACTIONS(1957),
    [anon_sym_goto] = ACTIONS(1957),
    [anon_sym___try] = ACTIONS(1957),
    [anon_sym___leave] = ACTIONS(1957),
    [anon_sym_not] = ACTIONS(1957),
    [anon_sym_compl] = ACTIONS(1957),
    [anon_sym_DASH_DASH] = ACTIONS(1955),
    [anon_sym_PLUS_PLUS] = ACTIONS(1955),
    [anon_sym_sizeof] = ACTIONS(1957),
    [anon_sym___alignof__] = ACTIONS(1957),
    [anon_sym___alignof] = ACTIONS(1957),
    [anon_sym__alignof] = ACTIONS(1957),
    [anon_sym_alignof] = ACTIONS(1957),
    [anon_sym__Alignof] = ACTIONS(1957),
    [anon_sym_offsetof] = ACTIONS(1957),
    [anon_sym__Generic] = ACTIONS(1957),
    [anon_sym_asm] = ACTIONS(1957),
    [anon_sym___asm__] = ACTIONS(1957),
    [aux_sym_number_literal_token1] = ACTIONS(1955),
    [aux_sym_number_literal_token2] = ACTIONS(1957),
    [anon_sym_L_SQUOTE] = ACTIONS(1955),
    [anon_sym_u_SQUOTE] = ACTIONS(1955),
    [anon_sym_U_SQUOTE] = ACTIONS(1955),
    [anon_sym_u8_SQUOTE] = ACTIONS(1955),
    [anon_sym_SQUOTE] = ACTIONS(1955),
    [anon_sym_L_DQUOTE] = ACTIONS(1955),
    [anon_sym_u_DQUOTE] = ACTIONS(1955),
    [anon_sym_U_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8_DQUOTE] = ACTIONS(1955),
    [anon_sym_DQUOTE] = ACTIONS(1955),
    [sym_true] = ACTIONS(1957),
    [sym_false] = ACTIONS(1957),
    [anon_sym_NULL] = ACTIONS(1957),
    [anon_sym_nullptr] = ACTIONS(1957),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1957),
    [anon_sym_decltype] = ACTIONS(1957),
    [anon_sym_virtual] = ACTIONS(1957),
    [anon_sym_alignas] = ACTIONS(1957),
    [anon_sym_explicit] = ACTIONS(1957),
    [anon_sym_typename] = ACTIONS(1957),
    [anon_sym_template] = ACTIONS(1957),
    [anon_sym_operator] = ACTIONS(1957),
    [anon_sym_try] = ACTIONS(1957),
    [anon_sym_delete] = ACTIONS(1957),
    [anon_sym_throw] = ACTIONS(1957),
    [anon_sym_namespace] = ACTIONS(1957),
    [anon_sym_using] = ACTIONS(1957),
    [anon_sym_static_assert] = ACTIONS(1957),
    [anon_sym_concept] = ACTIONS(1957),
    [anon_sym_co_return] = ACTIONS(1957),
    [anon_sym_co_yield] = ACTIONS(1957),
    [anon_sym_catch] = ACTIONS(1957),
    [anon_sym_R_DQUOTE] = ACTIONS(1955),
    [anon_sym_LR_DQUOTE] = ACTIONS(1955),
    [anon_sym_uR_DQUOTE] = ACTIONS(1955),
    [anon_sym_UR_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1955),
    [anon_sym_co_await] = ACTIONS(1957),
    [anon_sym_new] = ACTIONS(1957),
    [anon_sym_requires] = ACTIONS(1957),
    [sym_this] = ACTIONS(1957),
  },
  [229] = {
    [sym_identifier] = ACTIONS(2527),
    [aux_sym_preproc_include_token1] = ACTIONS(2527),
    [aux_sym_preproc_def_token1] = ACTIONS(2527),
    [aux_sym_preproc_if_token1] = ACTIONS(2527),
    [aux_sym_preproc_if_token2] = ACTIONS(2527),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2527),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2527),
    [aux_sym_preproc_else_token1] = ACTIONS(2527),
    [aux_sym_preproc_elif_token1] = ACTIONS(2527),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2527),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2527),
    [sym_preproc_directive] = ACTIONS(2527),
    [anon_sym_LPAREN2] = ACTIONS(2529),
    [anon_sym_BANG] = ACTIONS(2529),
    [anon_sym_TILDE] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2527),
    [anon_sym_PLUS] = ACTIONS(2527),
    [anon_sym_STAR] = ACTIONS(2529),
    [anon_sym_AMP_AMP] = ACTIONS(2529),
    [anon_sym_AMP] = ACTIONS(2527),
    [anon_sym_SEMI] = ACTIONS(2529),
    [anon_sym___extension__] = ACTIONS(2527),
    [anon_sym_typedef] = ACTIONS(2527),
    [anon_sym_extern] = ACTIONS(2527),
    [anon_sym___attribute__] = ACTIONS(2527),
    [anon_sym_COLON_COLON] = ACTIONS(2529),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2529),
    [anon_sym___declspec] = ACTIONS(2527),
    [anon_sym___based] = ACTIONS(2527),
    [anon_sym___cdecl] = ACTIONS(2527),
    [anon_sym___clrcall] = ACTIONS(2527),
    [anon_sym___stdcall] = ACTIONS(2527),
    [anon_sym___fastcall] = ACTIONS(2527),
    [anon_sym___thiscall] = ACTIONS(2527),
    [anon_sym___vectorcall] = ACTIONS(2527),
    [anon_sym_LBRACE] = ACTIONS(2529),
    [anon_sym_signed] = ACTIONS(2527),
    [anon_sym_unsigned] = ACTIONS(2527),
    [anon_sym_long] = ACTIONS(2527),
    [anon_sym_short] = ACTIONS(2527),
    [anon_sym_LBRACK] = ACTIONS(2527),
    [anon_sym_static] = ACTIONS(2527),
    [anon_sym_register] = ACTIONS(2527),
    [anon_sym_inline] = ACTIONS(2527),
    [anon_sym___inline] = ACTIONS(2527),
    [anon_sym___inline__] = ACTIONS(2527),
    [anon_sym___forceinline] = ACTIONS(2527),
    [anon_sym_thread_local] = ACTIONS(2527),
    [anon_sym___thread] = ACTIONS(2527),
    [anon_sym_const] = ACTIONS(2527),
    [anon_sym_constexpr] = ACTIONS(2527),
    [anon_sym_volatile] = ACTIONS(2527),
    [anon_sym_restrict] = ACTIONS(2527),
    [anon_sym___restrict__] = ACTIONS(2527),
    [anon_sym__Atomic] = ACTIONS(2527),
    [anon_sym__Noreturn] = ACTIONS(2527),
    [anon_sym_noreturn] = ACTIONS(2527),
    [anon_sym_mutable] = ACTIONS(2527),
    [anon_sym_constinit] = ACTIONS(2527),
    [anon_sym_consteval] = ACTIONS(2527),
    [anon_sym_PROGMEM] = ACTIONS(2527),
    [aux_sym_primitive_type_token1] = ACTIONS(2527),
    [anon_sym_byte] = ACTIONS(2527),
    [anon_sym_word] = ACTIONS(2527),
    [anon_sym_enum] = ACTIONS(2527),
    [anon_sym_class] = ACTIONS(2527),
    [anon_sym_struct] = ACTIONS(2527),
    [anon_sym_union] = ACTIONS(2527),
    [anon_sym_if] = ACTIONS(2527),
    [anon_sym_else] = ACTIONS(2527),
    [anon_sym_switch] = ACTIONS(2527),
    [anon_sym_case] = ACTIONS(2527),
    [anon_sym_default] = ACTIONS(2527),
    [anon_sym_while] = ACTIONS(2527),
    [anon_sym_do] = ACTIONS(2527),
    [anon_sym_for] = ACTIONS(2527),
    [anon_sym_return] = ACTIONS(2527),
    [anon_sym_break] = ACTIONS(2527),
    [anon_sym_continue] = ACTIONS(2527),
    [anon_sym_goto] = ACTIONS(2527),
    [anon_sym___try] = ACTIONS(2527),
    [anon_sym___leave] = ACTIONS(2527),
    [anon_sym_not] = ACTIONS(2527),
    [anon_sym_compl] = ACTIONS(2527),
    [anon_sym_DASH_DASH] = ACTIONS(2529),
    [anon_sym_PLUS_PLUS] = ACTIONS(2529),
    [anon_sym_sizeof] = ACTIONS(2527),
    [anon_sym___alignof__] = ACTIONS(2527),
    [anon_sym___alignof] = ACTIONS(2527),
    [anon_sym__alignof] = ACTIONS(2527),
    [anon_sym_alignof] = ACTIONS(2527),
    [anon_sym__Alignof] = ACTIONS(2527),
    [anon_sym_offsetof] = ACTIONS(2527),
    [anon_sym__Generic] = ACTIONS(2527),
    [anon_sym_asm] = ACTIONS(2527),
    [anon_sym___asm__] = ACTIONS(2527),
    [aux_sym_number_literal_token1] = ACTIONS(2529),
    [aux_sym_number_literal_token2] = ACTIONS(2527),
    [anon_sym_L_SQUOTE] = ACTIONS(2529),
    [anon_sym_u_SQUOTE] = ACTIONS(2529),
    [anon_sym_U_SQUOTE] = ACTIONS(2529),
    [anon_sym_u8_SQUOTE] = ACTIONS(2529),
    [anon_sym_SQUOTE] = ACTIONS(2529),
    [anon_sym_L_DQUOTE] = ACTIONS(2529),
    [anon_sym_u_DQUOTE] = ACTIONS(2529),
    [anon_sym_U_DQUOTE] = ACTIONS(2529),
    [anon_sym_u8_DQUOTE] = ACTIONS(2529),
    [anon_sym_DQUOTE] = ACTIONS(2529),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_NULL] = ACTIONS(2527),
    [anon_sym_nullptr] = ACTIONS(2527),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2527),
    [anon_sym_decltype] = ACTIONS(2527),
    [anon_sym_virtual] = ACTIONS(2527),
    [anon_sym_alignas] = ACTIONS(2527),
    [anon_sym_explicit] = ACTIONS(2527),
    [anon_sym_typename] = ACTIONS(2527),
    [anon_sym_template] = ACTIONS(2527),
    [anon_sym_operator] = ACTIONS(2527),
    [anon_sym_try] = ACTIONS(2527),
    [anon_sym_delete] = ACTIONS(2527),
    [anon_sym_throw] = ACTIONS(2527),
    [anon_sym_namespace] = ACTIONS(2527),
    [anon_sym_using] = ACTIONS(2527),
    [anon_sym_static_assert] = ACTIONS(2527),
    [anon_sym_concept] = ACTIONS(2527),
    [anon_sym_co_return] = ACTIONS(2527),
    [anon_sym_co_yield] = ACTIONS(2527),
    [anon_sym_catch] = ACTIONS(2527),
    [anon_sym_R_DQUOTE] = ACTIONS(2529),
    [anon_sym_LR_DQUOTE] = ACTIONS(2529),
    [anon_sym_uR_DQUOTE] = ACTIONS(2529),
    [anon_sym_UR_DQUOTE] = ACTIONS(2529),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2529),
    [anon_sym_co_await] = ACTIONS(2527),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_requires] = ACTIONS(2527),
    [sym_this] = ACTIONS(2527),
  },
  [230] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4348),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8413),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2531),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(2534),
    [anon_sym___extension__] = ACTIONS(2536),
    [anon_sym_extern] = ACTIONS(2536),
    [anon_sym___attribute__] = ACTIONS(2536),
    [anon_sym_COLON_COLON] = ACTIONS(2538),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2541),
    [anon_sym___declspec] = ACTIONS(2536),
    [anon_sym_signed] = ACTIONS(2536),
    [anon_sym_unsigned] = ACTIONS(2536),
    [anon_sym_long] = ACTIONS(2536),
    [anon_sym_short] = ACTIONS(2536),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [anon_sym_static] = ACTIONS(2536),
    [anon_sym_register] = ACTIONS(2536),
    [anon_sym_inline] = ACTIONS(2536),
    [anon_sym___inline] = ACTIONS(2536),
    [anon_sym___inline__] = ACTIONS(2536),
    [anon_sym___forceinline] = ACTIONS(2536),
    [anon_sym_thread_local] = ACTIONS(2536),
    [anon_sym___thread] = ACTIONS(2536),
    [anon_sym_const] = ACTIONS(2536),
    [anon_sym_constexpr] = ACTIONS(2536),
    [anon_sym_volatile] = ACTIONS(2536),
    [anon_sym_restrict] = ACTIONS(2536),
    [anon_sym___restrict__] = ACTIONS(2536),
    [anon_sym__Atomic] = ACTIONS(2536),
    [anon_sym__Noreturn] = ACTIONS(2536),
    [anon_sym_noreturn] = ACTIONS(2536),
    [anon_sym_mutable] = ACTIONS(2536),
    [anon_sym_constinit] = ACTIONS(2536),
    [anon_sym_consteval] = ACTIONS(2536),
    [anon_sym_PROGMEM] = ACTIONS(2536),
    [aux_sym_primitive_type_token1] = ACTIONS(2543),
    [anon_sym_byte] = ACTIONS(2543),
    [anon_sym_word] = ACTIONS(2543),
    [anon_sym_enum] = ACTIONS(2536),
    [anon_sym_class] = ACTIONS(2536),
    [anon_sym_struct] = ACTIONS(2536),
    [anon_sym_union] = ACTIONS(2536),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2536),
    [anon_sym_decltype] = ACTIONS(2546),
    [anon_sym_virtual] = ACTIONS(2536),
    [anon_sym_alignas] = ACTIONS(2536),
    [anon_sym_typename] = ACTIONS(2536),
    [anon_sym_template] = ACTIONS(2549),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [231] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4345),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8410),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2552),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(2555),
    [anon_sym___extension__] = ACTIONS(2557),
    [anon_sym_extern] = ACTIONS(2557),
    [anon_sym___attribute__] = ACTIONS(2557),
    [anon_sym_COLON_COLON] = ACTIONS(2559),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2562),
    [anon_sym___declspec] = ACTIONS(2557),
    [anon_sym_signed] = ACTIONS(2557),
    [anon_sym_unsigned] = ACTIONS(2557),
    [anon_sym_long] = ACTIONS(2557),
    [anon_sym_short] = ACTIONS(2557),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [anon_sym_static] = ACTIONS(2557),
    [anon_sym_register] = ACTIONS(2557),
    [anon_sym_inline] = ACTIONS(2557),
    [anon_sym___inline] = ACTIONS(2557),
    [anon_sym___inline__] = ACTIONS(2557),
    [anon_sym___forceinline] = ACTIONS(2557),
    [anon_sym_thread_local] = ACTIONS(2557),
    [anon_sym___thread] = ACTIONS(2557),
    [anon_sym_const] = ACTIONS(2557),
    [anon_sym_constexpr] = ACTIONS(2557),
    [anon_sym_volatile] = ACTIONS(2557),
    [anon_sym_restrict] = ACTIONS(2557),
    [anon_sym___restrict__] = ACTIONS(2557),
    [anon_sym__Atomic] = ACTIONS(2557),
    [anon_sym__Noreturn] = ACTIONS(2557),
    [anon_sym_noreturn] = ACTIONS(2557),
    [anon_sym_mutable] = ACTIONS(2557),
    [anon_sym_constinit] = ACTIONS(2557),
    [anon_sym_consteval] = ACTIONS(2557),
    [anon_sym_PROGMEM] = ACTIONS(2557),
    [aux_sym_primitive_type_token1] = ACTIONS(2564),
    [anon_sym_byte] = ACTIONS(2564),
    [anon_sym_word] = ACTIONS(2564),
    [anon_sym_enum] = ACTIONS(2557),
    [anon_sym_class] = ACTIONS(2557),
    [anon_sym_struct] = ACTIONS(2557),
    [anon_sym_union] = ACTIONS(2557),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2557),
    [anon_sym_decltype] = ACTIONS(2567),
    [anon_sym_virtual] = ACTIONS(2557),
    [anon_sym_alignas] = ACTIONS(2557),
    [anon_sym_typename] = ACTIONS(2557),
    [anon_sym_template] = ACTIONS(2570),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [232] = {
    [sym_type_qualifier] = STATE(3799),
    [sym__type_specifier] = STATE(4801),
    [sym_sized_type_specifier] = STATE(2935),
    [sym_primitive_type] = STATE(4963),
    [sym_enum_specifier] = STATE(2935),
    [sym_struct_specifier] = STATE(2935),
    [sym_union_specifier] = STATE(2935),
    [sym__expression] = STATE(4313),
    [sym__expression_not_binary] = STATE(4648),
    [sym__string] = STATE(4648),
    [sym_conditional_expression] = STATE(4648),
    [sym_assignment_expression] = STATE(4648),
    [sym_pointer_expression] = STATE(3663),
    [sym_unary_expression] = STATE(4648),
    [sym_binary_expression] = STATE(4648),
    [sym_update_expression] = STATE(4648),
    [sym_cast_expression] = STATE(4648),
    [sym_type_descriptor] = STATE(6794),
    [sym_sizeof_expression] = STATE(4648),
    [sym_alignof_expression] = STATE(4648),
    [sym_offsetof_expression] = STATE(4648),
    [sym_generic_expression] = STATE(4648),
    [sym_subscript_expression] = STATE(3663),
    [sym_call_expression] = STATE(3663),
    [sym_gnu_asm_expression] = STATE(4648),
    [sym_field_expression] = STATE(3663),
    [sym_compound_literal_expression] = STATE(4648),
    [sym_parenthesized_expression] = STATE(3663),
    [sym_number_literal] = STATE(4573),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4565),
    [sym_string_literal] = STATE(3707),
    [sym_null] = STATE(4648),
    [sym_placeholder_type_specifier] = STATE(2935),
    [sym_decltype_auto] = STATE(2933),
    [sym_decltype] = STATE(2868),
    [sym_class_specifier] = STATE(2935),
    [sym__class_name] = STATE(7442),
    [sym_dependent_type] = STATE(2935),
    [sym_template_type] = STATE(5228),
    [sym_template_function] = STATE(4648),
    [sym_raw_string_literal] = STATE(3709),
    [sym_co_await_expression] = STATE(4648),
    [sym_new_expression] = STATE(4648),
    [sym_delete_expression] = STATE(4648),
    [sym_requires_clause] = STATE(4648),
    [sym_requires_expression] = STATE(4648),
    [sym_lambda_expression] = STATE(4648),
    [sym_lambda_capture_specifier] = STATE(5768),
    [sym_fold_expression] = STATE(4648),
    [sym_parameter_pack_expansion] = STATE(4648),
    [sym_type_parameter_pack_expansion] = STATE(7210),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5541),
    [sym_qualified_identifier] = STATE(3663),
    [sym_qualified_type_identifier] = STATE(5253),
    [sym_user_defined_literal] = STATE(3663),
    [aux_sym__type_definition_type_repeat1] = STATE(3799),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2164),
    [sym_identifier] = ACTIONS(2573),
    [anon_sym_LPAREN2] = ACTIONS(2575),
    [anon_sym_BANG] = ACTIONS(2577),
    [anon_sym_TILDE] = ACTIONS(2577),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2583),
    [anon_sym_signed] = ACTIONS(2585),
    [anon_sym_unsigned] = ACTIONS(2585),
    [anon_sym_long] = ACTIONS(2585),
    [anon_sym_short] = ACTIONS(2585),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2587),
    [anon_sym_byte] = ACTIONS(2587),
    [anon_sym_word] = ACTIONS(2587),
    [anon_sym_enum] = ACTIONS(2589),
    [anon_sym_class] = ACTIONS(2591),
    [anon_sym_struct] = ACTIONS(2593),
    [anon_sym_union] = ACTIONS(2595),
    [anon_sym_not] = ACTIONS(2579),
    [anon_sym_compl] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(2597),
    [anon_sym_PLUS_PLUS] = ACTIONS(2597),
    [anon_sym_sizeof] = ACTIONS(2599),
    [anon_sym___alignof__] = ACTIONS(2601),
    [anon_sym___alignof] = ACTIONS(2601),
    [anon_sym__alignof] = ACTIONS(2601),
    [anon_sym_alignof] = ACTIONS(2601),
    [anon_sym__Alignof] = ACTIONS(2601),
    [anon_sym_offsetof] = ACTIONS(2603),
    [anon_sym__Generic] = ACTIONS(2605),
    [anon_sym_asm] = ACTIONS(2607),
    [anon_sym___asm__] = ACTIONS(2607),
    [aux_sym_number_literal_token1] = ACTIONS(2609),
    [aux_sym_number_literal_token2] = ACTIONS(2611),
    [anon_sym_L_SQUOTE] = ACTIONS(2613),
    [anon_sym_u_SQUOTE] = ACTIONS(2613),
    [anon_sym_U_SQUOTE] = ACTIONS(2613),
    [anon_sym_u8_SQUOTE] = ACTIONS(2613),
    [anon_sym_SQUOTE] = ACTIONS(2613),
    [anon_sym_L_DQUOTE] = ACTIONS(2615),
    [anon_sym_u_DQUOTE] = ACTIONS(2615),
    [anon_sym_U_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8_DQUOTE] = ACTIONS(2615),
    [anon_sym_DQUOTE] = ACTIONS(2615),
    [sym_true] = ACTIONS(2617),
    [sym_false] = ACTIONS(2617),
    [anon_sym_NULL] = ACTIONS(2619),
    [anon_sym_nullptr] = ACTIONS(2619),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2621),
    [anon_sym_decltype] = ACTIONS(2623),
    [anon_sym_typename] = ACTIONS(2625),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_GT2] = ACTIONS(2627),
    [anon_sym_delete] = ACTIONS(2629),
    [anon_sym_R_DQUOTE] = ACTIONS(2631),
    [anon_sym_LR_DQUOTE] = ACTIONS(2631),
    [anon_sym_uR_DQUOTE] = ACTIONS(2631),
    [anon_sym_UR_DQUOTE] = ACTIONS(2631),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2631),
    [anon_sym_co_await] = ACTIONS(2633),
    [anon_sym_new] = ACTIONS(2635),
    [anon_sym_requires] = ACTIONS(2637),
    [sym_this] = ACTIONS(2617),
  },
  [233] = {
    [sym_identifier] = ACTIONS(2639),
    [aux_sym_preproc_include_token1] = ACTIONS(2639),
    [aux_sym_preproc_def_token1] = ACTIONS(2639),
    [aux_sym_preproc_if_token1] = ACTIONS(2639),
    [aux_sym_preproc_if_token2] = ACTIONS(2639),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2639),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2639),
    [aux_sym_preproc_else_token1] = ACTIONS(2639),
    [aux_sym_preproc_elif_token1] = ACTIONS(2639),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2639),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2639),
    [sym_preproc_directive] = ACTIONS(2639),
    [anon_sym_LPAREN2] = ACTIONS(2641),
    [anon_sym_BANG] = ACTIONS(2641),
    [anon_sym_TILDE] = ACTIONS(2641),
    [anon_sym_DASH] = ACTIONS(2639),
    [anon_sym_PLUS] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(2641),
    [anon_sym_AMP_AMP] = ACTIONS(2641),
    [anon_sym_AMP] = ACTIONS(2639),
    [anon_sym_SEMI] = ACTIONS(2641),
    [anon_sym___extension__] = ACTIONS(2639),
    [anon_sym_typedef] = ACTIONS(2639),
    [anon_sym_extern] = ACTIONS(2639),
    [anon_sym___attribute__] = ACTIONS(2639),
    [anon_sym_COLON_COLON] = ACTIONS(2641),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2641),
    [anon_sym___declspec] = ACTIONS(2639),
    [anon_sym___based] = ACTIONS(2639),
    [anon_sym___cdecl] = ACTIONS(2639),
    [anon_sym___clrcall] = ACTIONS(2639),
    [anon_sym___stdcall] = ACTIONS(2639),
    [anon_sym___fastcall] = ACTIONS(2639),
    [anon_sym___thiscall] = ACTIONS(2639),
    [anon_sym___vectorcall] = ACTIONS(2639),
    [anon_sym_LBRACE] = ACTIONS(2641),
    [anon_sym_signed] = ACTIONS(2639),
    [anon_sym_unsigned] = ACTIONS(2639),
    [anon_sym_long] = ACTIONS(2639),
    [anon_sym_short] = ACTIONS(2639),
    [anon_sym_LBRACK] = ACTIONS(2639),
    [anon_sym_static] = ACTIONS(2639),
    [anon_sym_register] = ACTIONS(2639),
    [anon_sym_inline] = ACTIONS(2639),
    [anon_sym___inline] = ACTIONS(2639),
    [anon_sym___inline__] = ACTIONS(2639),
    [anon_sym___forceinline] = ACTIONS(2639),
    [anon_sym_thread_local] = ACTIONS(2639),
    [anon_sym___thread] = ACTIONS(2639),
    [anon_sym_const] = ACTIONS(2639),
    [anon_sym_constexpr] = ACTIONS(2639),
    [anon_sym_volatile] = ACTIONS(2639),
    [anon_sym_restrict] = ACTIONS(2639),
    [anon_sym___restrict__] = ACTIONS(2639),
    [anon_sym__Atomic] = ACTIONS(2639),
    [anon_sym__Noreturn] = ACTIONS(2639),
    [anon_sym_noreturn] = ACTIONS(2639),
    [anon_sym_mutable] = ACTIONS(2639),
    [anon_sym_constinit] = ACTIONS(2639),
    [anon_sym_consteval] = ACTIONS(2639),
    [anon_sym_PROGMEM] = ACTIONS(2639),
    [aux_sym_primitive_type_token1] = ACTIONS(2639),
    [anon_sym_byte] = ACTIONS(2639),
    [anon_sym_word] = ACTIONS(2639),
    [anon_sym_enum] = ACTIONS(2639),
    [anon_sym_class] = ACTIONS(2639),
    [anon_sym_struct] = ACTIONS(2639),
    [anon_sym_union] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2639),
    [anon_sym_else] = ACTIONS(2639),
    [anon_sym_switch] = ACTIONS(2639),
    [anon_sym_case] = ACTIONS(2639),
    [anon_sym_default] = ACTIONS(2639),
    [anon_sym_while] = ACTIONS(2639),
    [anon_sym_do] = ACTIONS(2639),
    [anon_sym_for] = ACTIONS(2639),
    [anon_sym_return] = ACTIONS(2639),
    [anon_sym_break] = ACTIONS(2639),
    [anon_sym_continue] = ACTIONS(2639),
    [anon_sym_goto] = ACTIONS(2639),
    [anon_sym___try] = ACTIONS(2639),
    [anon_sym___leave] = ACTIONS(2639),
    [anon_sym_not] = ACTIONS(2639),
    [anon_sym_compl] = ACTIONS(2639),
    [anon_sym_DASH_DASH] = ACTIONS(2641),
    [anon_sym_PLUS_PLUS] = ACTIONS(2641),
    [anon_sym_sizeof] = ACTIONS(2639),
    [anon_sym___alignof__] = ACTIONS(2639),
    [anon_sym___alignof] = ACTIONS(2639),
    [anon_sym__alignof] = ACTIONS(2639),
    [anon_sym_alignof] = ACTIONS(2639),
    [anon_sym__Alignof] = ACTIONS(2639),
    [anon_sym_offsetof] = ACTIONS(2639),
    [anon_sym__Generic] = ACTIONS(2639),
    [anon_sym_asm] = ACTIONS(2639),
    [anon_sym___asm__] = ACTIONS(2639),
    [aux_sym_number_literal_token1] = ACTIONS(2641),
    [aux_sym_number_literal_token2] = ACTIONS(2639),
    [anon_sym_L_SQUOTE] = ACTIONS(2641),
    [anon_sym_u_SQUOTE] = ACTIONS(2641),
    [anon_sym_U_SQUOTE] = ACTIONS(2641),
    [anon_sym_u8_SQUOTE] = ACTIONS(2641),
    [anon_sym_SQUOTE] = ACTIONS(2641),
    [anon_sym_L_DQUOTE] = ACTIONS(2641),
    [anon_sym_u_DQUOTE] = ACTIONS(2641),
    [anon_sym_U_DQUOTE] = ACTIONS(2641),
    [anon_sym_u8_DQUOTE] = ACTIONS(2641),
    [anon_sym_DQUOTE] = ACTIONS(2641),
    [sym_true] = ACTIONS(2639),
    [sym_false] = ACTIONS(2639),
    [anon_sym_NULL] = ACTIONS(2639),
    [anon_sym_nullptr] = ACTIONS(2639),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2639),
    [anon_sym_decltype] = ACTIONS(2639),
    [anon_sym_virtual] = ACTIONS(2639),
    [anon_sym_alignas] = ACTIONS(2639),
    [anon_sym_explicit] = ACTIONS(2639),
    [anon_sym_typename] = ACTIONS(2639),
    [anon_sym_template] = ACTIONS(2639),
    [anon_sym_operator] = ACTIONS(2639),
    [anon_sym_try] = ACTIONS(2639),
    [anon_sym_delete] = ACTIONS(2639),
    [anon_sym_throw] = ACTIONS(2639),
    [anon_sym_namespace] = ACTIONS(2639),
    [anon_sym_using] = ACTIONS(2639),
    [anon_sym_static_assert] = ACTIONS(2639),
    [anon_sym_concept] = ACTIONS(2639),
    [anon_sym_co_return] = ACTIONS(2639),
    [anon_sym_co_yield] = ACTIONS(2639),
    [anon_sym_R_DQUOTE] = ACTIONS(2641),
    [anon_sym_LR_DQUOTE] = ACTIONS(2641),
    [anon_sym_uR_DQUOTE] = ACTIONS(2641),
    [anon_sym_UR_DQUOTE] = ACTIONS(2641),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2641),
    [anon_sym_co_await] = ACTIONS(2639),
    [anon_sym_new] = ACTIONS(2639),
    [anon_sym_requires] = ACTIONS(2639),
    [sym_this] = ACTIONS(2639),
  },
  [234] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token2] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [aux_sym_preproc_else_token1] = ACTIONS(2643),
    [aux_sym_preproc_elif_token1] = ACTIONS(2643),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [235] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token2] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [aux_sym_preproc_else_token1] = ACTIONS(2643),
    [aux_sym_preproc_elif_token1] = ACTIONS(2643),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [236] = {
    [sym_type_qualifier] = STATE(3799),
    [sym__type_specifier] = STATE(4801),
    [sym_sized_type_specifier] = STATE(2935),
    [sym_primitive_type] = STATE(4963),
    [sym_enum_specifier] = STATE(2935),
    [sym_struct_specifier] = STATE(2935),
    [sym_union_specifier] = STATE(2935),
    [sym__expression] = STATE(4248),
    [sym__expression_not_binary] = STATE(4648),
    [sym__string] = STATE(4648),
    [sym_conditional_expression] = STATE(4648),
    [sym_assignment_expression] = STATE(4648),
    [sym_pointer_expression] = STATE(3663),
    [sym_unary_expression] = STATE(4648),
    [sym_binary_expression] = STATE(4648),
    [sym_update_expression] = STATE(4648),
    [sym_cast_expression] = STATE(4648),
    [sym_type_descriptor] = STATE(6752),
    [sym_sizeof_expression] = STATE(4648),
    [sym_alignof_expression] = STATE(4648),
    [sym_offsetof_expression] = STATE(4648),
    [sym_generic_expression] = STATE(4648),
    [sym_subscript_expression] = STATE(3663),
    [sym_call_expression] = STATE(3663),
    [sym_gnu_asm_expression] = STATE(4648),
    [sym_field_expression] = STATE(3663),
    [sym_compound_literal_expression] = STATE(4648),
    [sym_parenthesized_expression] = STATE(3663),
    [sym_number_literal] = STATE(4573),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4565),
    [sym_string_literal] = STATE(3707),
    [sym_null] = STATE(4648),
    [sym_placeholder_type_specifier] = STATE(2935),
    [sym_decltype_auto] = STATE(2933),
    [sym_decltype] = STATE(2868),
    [sym_class_specifier] = STATE(2935),
    [sym__class_name] = STATE(7442),
    [sym_dependent_type] = STATE(2935),
    [sym_template_type] = STATE(5228),
    [sym_template_function] = STATE(4648),
    [sym_raw_string_literal] = STATE(3709),
    [sym_co_await_expression] = STATE(4648),
    [sym_new_expression] = STATE(4648),
    [sym_delete_expression] = STATE(4648),
    [sym_requires_clause] = STATE(4648),
    [sym_requires_expression] = STATE(4648),
    [sym_lambda_expression] = STATE(4648),
    [sym_lambda_capture_specifier] = STATE(5768),
    [sym_fold_expression] = STATE(4648),
    [sym_parameter_pack_expansion] = STATE(4648),
    [sym_type_parameter_pack_expansion] = STATE(6895),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5541),
    [sym_qualified_identifier] = STATE(3663),
    [sym_qualified_type_identifier] = STATE(5253),
    [sym_user_defined_literal] = STATE(3663),
    [aux_sym__type_definition_type_repeat1] = STATE(3799),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2164),
    [sym_identifier] = ACTIONS(2573),
    [anon_sym_LPAREN2] = ACTIONS(2575),
    [anon_sym_BANG] = ACTIONS(2577),
    [anon_sym_TILDE] = ACTIONS(2577),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2583),
    [anon_sym_signed] = ACTIONS(2585),
    [anon_sym_unsigned] = ACTIONS(2585),
    [anon_sym_long] = ACTIONS(2585),
    [anon_sym_short] = ACTIONS(2585),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2587),
    [anon_sym_byte] = ACTIONS(2587),
    [anon_sym_word] = ACTIONS(2587),
    [anon_sym_enum] = ACTIONS(2589),
    [anon_sym_class] = ACTIONS(2591),
    [anon_sym_struct] = ACTIONS(2593),
    [anon_sym_union] = ACTIONS(2595),
    [anon_sym_not] = ACTIONS(2579),
    [anon_sym_compl] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(2597),
    [anon_sym_PLUS_PLUS] = ACTIONS(2597),
    [anon_sym_sizeof] = ACTIONS(2599),
    [anon_sym___alignof__] = ACTIONS(2601),
    [anon_sym___alignof] = ACTIONS(2601),
    [anon_sym__alignof] = ACTIONS(2601),
    [anon_sym_alignof] = ACTIONS(2601),
    [anon_sym__Alignof] = ACTIONS(2601),
    [anon_sym_offsetof] = ACTIONS(2603),
    [anon_sym__Generic] = ACTIONS(2605),
    [anon_sym_asm] = ACTIONS(2607),
    [anon_sym___asm__] = ACTIONS(2607),
    [aux_sym_number_literal_token1] = ACTIONS(2609),
    [aux_sym_number_literal_token2] = ACTIONS(2611),
    [anon_sym_L_SQUOTE] = ACTIONS(2613),
    [anon_sym_u_SQUOTE] = ACTIONS(2613),
    [anon_sym_U_SQUOTE] = ACTIONS(2613),
    [anon_sym_u8_SQUOTE] = ACTIONS(2613),
    [anon_sym_SQUOTE] = ACTIONS(2613),
    [anon_sym_L_DQUOTE] = ACTIONS(2615),
    [anon_sym_u_DQUOTE] = ACTIONS(2615),
    [anon_sym_U_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8_DQUOTE] = ACTIONS(2615),
    [anon_sym_DQUOTE] = ACTIONS(2615),
    [sym_true] = ACTIONS(2617),
    [sym_false] = ACTIONS(2617),
    [anon_sym_NULL] = ACTIONS(2619),
    [anon_sym_nullptr] = ACTIONS(2619),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2621),
    [anon_sym_decltype] = ACTIONS(2623),
    [anon_sym_typename] = ACTIONS(2625),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_GT2] = ACTIONS(2647),
    [anon_sym_delete] = ACTIONS(2629),
    [anon_sym_R_DQUOTE] = ACTIONS(2631),
    [anon_sym_LR_DQUOTE] = ACTIONS(2631),
    [anon_sym_uR_DQUOTE] = ACTIONS(2631),
    [anon_sym_UR_DQUOTE] = ACTIONS(2631),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2631),
    [anon_sym_co_await] = ACTIONS(2633),
    [anon_sym_new] = ACTIONS(2635),
    [anon_sym_requires] = ACTIONS(2637),
    [sym_this] = ACTIONS(2617),
  },
  [237] = {
    [sym_type_qualifier] = STATE(3799),
    [sym__type_specifier] = STATE(4801),
    [sym_sized_type_specifier] = STATE(2935),
    [sym_primitive_type] = STATE(4963),
    [sym_enum_specifier] = STATE(2935),
    [sym_struct_specifier] = STATE(2935),
    [sym_union_specifier] = STATE(2935),
    [sym__expression] = STATE(4277),
    [sym__expression_not_binary] = STATE(4648),
    [sym__string] = STATE(4648),
    [sym_conditional_expression] = STATE(4648),
    [sym_assignment_expression] = STATE(4648),
    [sym_pointer_expression] = STATE(3663),
    [sym_unary_expression] = STATE(4648),
    [sym_binary_expression] = STATE(4648),
    [sym_update_expression] = STATE(4648),
    [sym_cast_expression] = STATE(4648),
    [sym_type_descriptor] = STATE(6681),
    [sym_sizeof_expression] = STATE(4648),
    [sym_alignof_expression] = STATE(4648),
    [sym_offsetof_expression] = STATE(4648),
    [sym_generic_expression] = STATE(4648),
    [sym_subscript_expression] = STATE(3663),
    [sym_call_expression] = STATE(3663),
    [sym_gnu_asm_expression] = STATE(4648),
    [sym_field_expression] = STATE(3663),
    [sym_compound_literal_expression] = STATE(4648),
    [sym_parenthesized_expression] = STATE(3663),
    [sym_number_literal] = STATE(4573),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4565),
    [sym_string_literal] = STATE(3707),
    [sym_null] = STATE(4648),
    [sym_placeholder_type_specifier] = STATE(2935),
    [sym_decltype_auto] = STATE(2933),
    [sym_decltype] = STATE(2868),
    [sym_class_specifier] = STATE(2935),
    [sym__class_name] = STATE(7442),
    [sym_dependent_type] = STATE(2935),
    [sym_template_type] = STATE(5228),
    [sym_template_function] = STATE(4648),
    [sym_raw_string_literal] = STATE(3709),
    [sym_co_await_expression] = STATE(4648),
    [sym_new_expression] = STATE(4648),
    [sym_delete_expression] = STATE(4648),
    [sym_requires_clause] = STATE(4648),
    [sym_requires_expression] = STATE(4648),
    [sym_lambda_expression] = STATE(4648),
    [sym_lambda_capture_specifier] = STATE(5768),
    [sym_fold_expression] = STATE(4648),
    [sym_parameter_pack_expansion] = STATE(4648),
    [sym_type_parameter_pack_expansion] = STATE(7151),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5541),
    [sym_qualified_identifier] = STATE(3663),
    [sym_qualified_type_identifier] = STATE(5253),
    [sym_user_defined_literal] = STATE(3663),
    [aux_sym__type_definition_type_repeat1] = STATE(3799),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2164),
    [sym_identifier] = ACTIONS(2573),
    [anon_sym_LPAREN2] = ACTIONS(2575),
    [anon_sym_BANG] = ACTIONS(2577),
    [anon_sym_TILDE] = ACTIONS(2577),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2583),
    [anon_sym_signed] = ACTIONS(2585),
    [anon_sym_unsigned] = ACTIONS(2585),
    [anon_sym_long] = ACTIONS(2585),
    [anon_sym_short] = ACTIONS(2585),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2587),
    [anon_sym_byte] = ACTIONS(2587),
    [anon_sym_word] = ACTIONS(2587),
    [anon_sym_enum] = ACTIONS(2589),
    [anon_sym_class] = ACTIONS(2591),
    [anon_sym_struct] = ACTIONS(2593),
    [anon_sym_union] = ACTIONS(2595),
    [anon_sym_not] = ACTIONS(2579),
    [anon_sym_compl] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(2597),
    [anon_sym_PLUS_PLUS] = ACTIONS(2597),
    [anon_sym_sizeof] = ACTIONS(2599),
    [anon_sym___alignof__] = ACTIONS(2601),
    [anon_sym___alignof] = ACTIONS(2601),
    [anon_sym__alignof] = ACTIONS(2601),
    [anon_sym_alignof] = ACTIONS(2601),
    [anon_sym__Alignof] = ACTIONS(2601),
    [anon_sym_offsetof] = ACTIONS(2603),
    [anon_sym__Generic] = ACTIONS(2605),
    [anon_sym_asm] = ACTIONS(2607),
    [anon_sym___asm__] = ACTIONS(2607),
    [aux_sym_number_literal_token1] = ACTIONS(2609),
    [aux_sym_number_literal_token2] = ACTIONS(2611),
    [anon_sym_L_SQUOTE] = ACTIONS(2613),
    [anon_sym_u_SQUOTE] = ACTIONS(2613),
    [anon_sym_U_SQUOTE] = ACTIONS(2613),
    [anon_sym_u8_SQUOTE] = ACTIONS(2613),
    [anon_sym_SQUOTE] = ACTIONS(2613),
    [anon_sym_L_DQUOTE] = ACTIONS(2615),
    [anon_sym_u_DQUOTE] = ACTIONS(2615),
    [anon_sym_U_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8_DQUOTE] = ACTIONS(2615),
    [anon_sym_DQUOTE] = ACTIONS(2615),
    [sym_true] = ACTIONS(2617),
    [sym_false] = ACTIONS(2617),
    [anon_sym_NULL] = ACTIONS(2619),
    [anon_sym_nullptr] = ACTIONS(2619),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2621),
    [anon_sym_decltype] = ACTIONS(2623),
    [anon_sym_typename] = ACTIONS(2625),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_GT2] = ACTIONS(2649),
    [anon_sym_delete] = ACTIONS(2629),
    [anon_sym_R_DQUOTE] = ACTIONS(2631),
    [anon_sym_LR_DQUOTE] = ACTIONS(2631),
    [anon_sym_uR_DQUOTE] = ACTIONS(2631),
    [anon_sym_UR_DQUOTE] = ACTIONS(2631),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2631),
    [anon_sym_co_await] = ACTIONS(2633),
    [anon_sym_new] = ACTIONS(2635),
    [anon_sym_requires] = ACTIONS(2637),
    [sym_this] = ACTIONS(2617),
  },
  [238] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token2] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [aux_sym_preproc_else_token1] = ACTIONS(2643),
    [aux_sym_preproc_elif_token1] = ACTIONS(2643),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [239] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token2] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [aux_sym_preproc_else_token1] = ACTIONS(2643),
    [aux_sym_preproc_elif_token1] = ACTIONS(2643),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [240] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token2] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [aux_sym_preproc_else_token1] = ACTIONS(2643),
    [aux_sym_preproc_elif_token1] = ACTIONS(2643),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [241] = {
    [sym_identifier] = ACTIONS(2557),
    [aux_sym_preproc_include_token1] = ACTIONS(2557),
    [aux_sym_preproc_def_token1] = ACTIONS(2557),
    [aux_sym_preproc_if_token1] = ACTIONS(2557),
    [aux_sym_preproc_if_token2] = ACTIONS(2557),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2557),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2557),
    [aux_sym_preproc_else_token1] = ACTIONS(2557),
    [aux_sym_preproc_elif_token1] = ACTIONS(2557),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2557),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2557),
    [sym_preproc_directive] = ACTIONS(2557),
    [anon_sym_LPAREN2] = ACTIONS(2562),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2557),
    [anon_sym_PLUS] = ACTIONS(2557),
    [anon_sym_STAR] = ACTIONS(2562),
    [anon_sym_AMP_AMP] = ACTIONS(2562),
    [anon_sym_AMP] = ACTIONS(2557),
    [anon_sym_SEMI] = ACTIONS(2562),
    [anon_sym___extension__] = ACTIONS(2557),
    [anon_sym_typedef] = ACTIONS(2557),
    [anon_sym_extern] = ACTIONS(2557),
    [anon_sym___attribute__] = ACTIONS(2557),
    [anon_sym_COLON_COLON] = ACTIONS(2562),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2562),
    [anon_sym___declspec] = ACTIONS(2557),
    [anon_sym___based] = ACTIONS(2557),
    [anon_sym___cdecl] = ACTIONS(2557),
    [anon_sym___clrcall] = ACTIONS(2557),
    [anon_sym___stdcall] = ACTIONS(2557),
    [anon_sym___fastcall] = ACTIONS(2557),
    [anon_sym___thiscall] = ACTIONS(2557),
    [anon_sym___vectorcall] = ACTIONS(2557),
    [anon_sym_LBRACE] = ACTIONS(2562),
    [anon_sym_signed] = ACTIONS(2557),
    [anon_sym_unsigned] = ACTIONS(2557),
    [anon_sym_long] = ACTIONS(2557),
    [anon_sym_short] = ACTIONS(2557),
    [anon_sym_LBRACK] = ACTIONS(2557),
    [anon_sym_static] = ACTIONS(2557),
    [anon_sym_register] = ACTIONS(2557),
    [anon_sym_inline] = ACTIONS(2557),
    [anon_sym___inline] = ACTIONS(2557),
    [anon_sym___inline__] = ACTIONS(2557),
    [anon_sym___forceinline] = ACTIONS(2557),
    [anon_sym_thread_local] = ACTIONS(2557),
    [anon_sym___thread] = ACTIONS(2557),
    [anon_sym_const] = ACTIONS(2557),
    [anon_sym_constexpr] = ACTIONS(2557),
    [anon_sym_volatile] = ACTIONS(2557),
    [anon_sym_restrict] = ACTIONS(2557),
    [anon_sym___restrict__] = ACTIONS(2557),
    [anon_sym__Atomic] = ACTIONS(2557),
    [anon_sym__Noreturn] = ACTIONS(2557),
    [anon_sym_noreturn] = ACTIONS(2557),
    [anon_sym_mutable] = ACTIONS(2557),
    [anon_sym_constinit] = ACTIONS(2557),
    [anon_sym_consteval] = ACTIONS(2557),
    [anon_sym_PROGMEM] = ACTIONS(2557),
    [aux_sym_primitive_type_token1] = ACTIONS(2557),
    [anon_sym_byte] = ACTIONS(2557),
    [anon_sym_word] = ACTIONS(2557),
    [anon_sym_enum] = ACTIONS(2557),
    [anon_sym_class] = ACTIONS(2557),
    [anon_sym_struct] = ACTIONS(2557),
    [anon_sym_union] = ACTIONS(2557),
    [anon_sym_if] = ACTIONS(2557),
    [anon_sym_else] = ACTIONS(2557),
    [anon_sym_switch] = ACTIONS(2557),
    [anon_sym_case] = ACTIONS(2557),
    [anon_sym_default] = ACTIONS(2557),
    [anon_sym_while] = ACTIONS(2557),
    [anon_sym_do] = ACTIONS(2557),
    [anon_sym_for] = ACTIONS(2557),
    [anon_sym_return] = ACTIONS(2557),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_continue] = ACTIONS(2557),
    [anon_sym_goto] = ACTIONS(2557),
    [anon_sym___try] = ACTIONS(2557),
    [anon_sym___leave] = ACTIONS(2557),
    [anon_sym_not] = ACTIONS(2557),
    [anon_sym_compl] = ACTIONS(2557),
    [anon_sym_DASH_DASH] = ACTIONS(2562),
    [anon_sym_PLUS_PLUS] = ACTIONS(2562),
    [anon_sym_sizeof] = ACTIONS(2557),
    [anon_sym___alignof__] = ACTIONS(2557),
    [anon_sym___alignof] = ACTIONS(2557),
    [anon_sym__alignof] = ACTIONS(2557),
    [anon_sym_alignof] = ACTIONS(2557),
    [anon_sym__Alignof] = ACTIONS(2557),
    [anon_sym_offsetof] = ACTIONS(2557),
    [anon_sym__Generic] = ACTIONS(2557),
    [anon_sym_asm] = ACTIONS(2557),
    [anon_sym___asm__] = ACTIONS(2557),
    [aux_sym_number_literal_token1] = ACTIONS(2562),
    [aux_sym_number_literal_token2] = ACTIONS(2557),
    [anon_sym_L_SQUOTE] = ACTIONS(2562),
    [anon_sym_u_SQUOTE] = ACTIONS(2562),
    [anon_sym_U_SQUOTE] = ACTIONS(2562),
    [anon_sym_u8_SQUOTE] = ACTIONS(2562),
    [anon_sym_SQUOTE] = ACTIONS(2562),
    [anon_sym_L_DQUOTE] = ACTIONS(2562),
    [anon_sym_u_DQUOTE] = ACTIONS(2562),
    [anon_sym_U_DQUOTE] = ACTIONS(2562),
    [anon_sym_u8_DQUOTE] = ACTIONS(2562),
    [anon_sym_DQUOTE] = ACTIONS(2562),
    [sym_true] = ACTIONS(2557),
    [sym_false] = ACTIONS(2557),
    [anon_sym_NULL] = ACTIONS(2557),
    [anon_sym_nullptr] = ACTIONS(2557),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2557),
    [anon_sym_decltype] = ACTIONS(2557),
    [anon_sym_virtual] = ACTIONS(2557),
    [anon_sym_alignas] = ACTIONS(2557),
    [anon_sym_explicit] = ACTIONS(2557),
    [anon_sym_typename] = ACTIONS(2557),
    [anon_sym_template] = ACTIONS(2557),
    [anon_sym_operator] = ACTIONS(2557),
    [anon_sym_try] = ACTIONS(2557),
    [anon_sym_delete] = ACTIONS(2557),
    [anon_sym_throw] = ACTIONS(2557),
    [anon_sym_namespace] = ACTIONS(2557),
    [anon_sym_using] = ACTIONS(2557),
    [anon_sym_static_assert] = ACTIONS(2557),
    [anon_sym_concept] = ACTIONS(2557),
    [anon_sym_co_return] = ACTIONS(2557),
    [anon_sym_co_yield] = ACTIONS(2557),
    [anon_sym_R_DQUOTE] = ACTIONS(2562),
    [anon_sym_LR_DQUOTE] = ACTIONS(2562),
    [anon_sym_uR_DQUOTE] = ACTIONS(2562),
    [anon_sym_UR_DQUOTE] = ACTIONS(2562),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2562),
    [anon_sym_co_await] = ACTIONS(2557),
    [anon_sym_new] = ACTIONS(2557),
    [anon_sym_requires] = ACTIONS(2557),
    [sym_this] = ACTIONS(2557),
  },
  [242] = {
    [sym_type_qualifier] = STATE(3799),
    [sym__type_specifier] = STATE(4801),
    [sym_sized_type_specifier] = STATE(2935),
    [sym_primitive_type] = STATE(4963),
    [sym_enum_specifier] = STATE(2935),
    [sym_struct_specifier] = STATE(2935),
    [sym_union_specifier] = STATE(2935),
    [sym__expression] = STATE(4324),
    [sym__expression_not_binary] = STATE(4648),
    [sym__string] = STATE(4648),
    [sym_conditional_expression] = STATE(4648),
    [sym_assignment_expression] = STATE(4648),
    [sym_pointer_expression] = STATE(3663),
    [sym_unary_expression] = STATE(4648),
    [sym_binary_expression] = STATE(4648),
    [sym_update_expression] = STATE(4648),
    [sym_cast_expression] = STATE(4648),
    [sym_type_descriptor] = STATE(6708),
    [sym_sizeof_expression] = STATE(4648),
    [sym_alignof_expression] = STATE(4648),
    [sym_offsetof_expression] = STATE(4648),
    [sym_generic_expression] = STATE(4648),
    [sym_subscript_expression] = STATE(3663),
    [sym_call_expression] = STATE(3663),
    [sym_gnu_asm_expression] = STATE(4648),
    [sym_field_expression] = STATE(3663),
    [sym_compound_literal_expression] = STATE(4648),
    [sym_parenthesized_expression] = STATE(3663),
    [sym_number_literal] = STATE(4573),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4565),
    [sym_string_literal] = STATE(3707),
    [sym_null] = STATE(4648),
    [sym_placeholder_type_specifier] = STATE(2935),
    [sym_decltype_auto] = STATE(2933),
    [sym_decltype] = STATE(2868),
    [sym_class_specifier] = STATE(2935),
    [sym__class_name] = STATE(7442),
    [sym_dependent_type] = STATE(2935),
    [sym_template_type] = STATE(5228),
    [sym_template_function] = STATE(4648),
    [sym_raw_string_literal] = STATE(3709),
    [sym_co_await_expression] = STATE(4648),
    [sym_new_expression] = STATE(4648),
    [sym_delete_expression] = STATE(4648),
    [sym_requires_clause] = STATE(4648),
    [sym_requires_expression] = STATE(4648),
    [sym_lambda_expression] = STATE(4648),
    [sym_lambda_capture_specifier] = STATE(5768),
    [sym_fold_expression] = STATE(4648),
    [sym_parameter_pack_expansion] = STATE(4648),
    [sym_type_parameter_pack_expansion] = STATE(7106),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5541),
    [sym_qualified_identifier] = STATE(3663),
    [sym_qualified_type_identifier] = STATE(5253),
    [sym_user_defined_literal] = STATE(3663),
    [aux_sym__type_definition_type_repeat1] = STATE(3799),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2164),
    [sym_identifier] = ACTIONS(2573),
    [anon_sym_LPAREN2] = ACTIONS(2575),
    [anon_sym_BANG] = ACTIONS(2577),
    [anon_sym_TILDE] = ACTIONS(2577),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2583),
    [anon_sym_signed] = ACTIONS(2585),
    [anon_sym_unsigned] = ACTIONS(2585),
    [anon_sym_long] = ACTIONS(2585),
    [anon_sym_short] = ACTIONS(2585),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2587),
    [anon_sym_byte] = ACTIONS(2587),
    [anon_sym_word] = ACTIONS(2587),
    [anon_sym_enum] = ACTIONS(2589),
    [anon_sym_class] = ACTIONS(2591),
    [anon_sym_struct] = ACTIONS(2593),
    [anon_sym_union] = ACTIONS(2595),
    [anon_sym_not] = ACTIONS(2579),
    [anon_sym_compl] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(2597),
    [anon_sym_PLUS_PLUS] = ACTIONS(2597),
    [anon_sym_sizeof] = ACTIONS(2599),
    [anon_sym___alignof__] = ACTIONS(2601),
    [anon_sym___alignof] = ACTIONS(2601),
    [anon_sym__alignof] = ACTIONS(2601),
    [anon_sym_alignof] = ACTIONS(2601),
    [anon_sym__Alignof] = ACTIONS(2601),
    [anon_sym_offsetof] = ACTIONS(2603),
    [anon_sym__Generic] = ACTIONS(2605),
    [anon_sym_asm] = ACTIONS(2607),
    [anon_sym___asm__] = ACTIONS(2607),
    [aux_sym_number_literal_token1] = ACTIONS(2609),
    [aux_sym_number_literal_token2] = ACTIONS(2611),
    [anon_sym_L_SQUOTE] = ACTIONS(2613),
    [anon_sym_u_SQUOTE] = ACTIONS(2613),
    [anon_sym_U_SQUOTE] = ACTIONS(2613),
    [anon_sym_u8_SQUOTE] = ACTIONS(2613),
    [anon_sym_SQUOTE] = ACTIONS(2613),
    [anon_sym_L_DQUOTE] = ACTIONS(2615),
    [anon_sym_u_DQUOTE] = ACTIONS(2615),
    [anon_sym_U_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8_DQUOTE] = ACTIONS(2615),
    [anon_sym_DQUOTE] = ACTIONS(2615),
    [sym_true] = ACTIONS(2617),
    [sym_false] = ACTIONS(2617),
    [anon_sym_NULL] = ACTIONS(2619),
    [anon_sym_nullptr] = ACTIONS(2619),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2621),
    [anon_sym_decltype] = ACTIONS(2623),
    [anon_sym_typename] = ACTIONS(2625),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_GT2] = ACTIONS(2651),
    [anon_sym_delete] = ACTIONS(2629),
    [anon_sym_R_DQUOTE] = ACTIONS(2631),
    [anon_sym_LR_DQUOTE] = ACTIONS(2631),
    [anon_sym_uR_DQUOTE] = ACTIONS(2631),
    [anon_sym_UR_DQUOTE] = ACTIONS(2631),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2631),
    [anon_sym_co_await] = ACTIONS(2633),
    [anon_sym_new] = ACTIONS(2635),
    [anon_sym_requires] = ACTIONS(2637),
    [sym_this] = ACTIONS(2617),
  },
  [243] = {
    [sym_identifier] = ACTIONS(2653),
    [aux_sym_preproc_include_token1] = ACTIONS(2653),
    [aux_sym_preproc_def_token1] = ACTIONS(2653),
    [aux_sym_preproc_if_token1] = ACTIONS(2653),
    [aux_sym_preproc_if_token2] = ACTIONS(2653),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2653),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2653),
    [aux_sym_preproc_else_token1] = ACTIONS(2653),
    [aux_sym_preproc_elif_token1] = ACTIONS(2653),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2653),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2653),
    [sym_preproc_directive] = ACTIONS(2653),
    [anon_sym_LPAREN2] = ACTIONS(2655),
    [anon_sym_BANG] = ACTIONS(2655),
    [anon_sym_TILDE] = ACTIONS(2655),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_AMP_AMP] = ACTIONS(2655),
    [anon_sym_AMP] = ACTIONS(2653),
    [anon_sym_SEMI] = ACTIONS(2655),
    [anon_sym___extension__] = ACTIONS(2653),
    [anon_sym_typedef] = ACTIONS(2653),
    [anon_sym_extern] = ACTIONS(2653),
    [anon_sym___attribute__] = ACTIONS(2653),
    [anon_sym_COLON_COLON] = ACTIONS(2655),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2655),
    [anon_sym___declspec] = ACTIONS(2653),
    [anon_sym___based] = ACTIONS(2653),
    [anon_sym___cdecl] = ACTIONS(2653),
    [anon_sym___clrcall] = ACTIONS(2653),
    [anon_sym___stdcall] = ACTIONS(2653),
    [anon_sym___fastcall] = ACTIONS(2653),
    [anon_sym___thiscall] = ACTIONS(2653),
    [anon_sym___vectorcall] = ACTIONS(2653),
    [anon_sym_LBRACE] = ACTIONS(2655),
    [anon_sym_signed] = ACTIONS(2653),
    [anon_sym_unsigned] = ACTIONS(2653),
    [anon_sym_long] = ACTIONS(2653),
    [anon_sym_short] = ACTIONS(2653),
    [anon_sym_LBRACK] = ACTIONS(2653),
    [anon_sym_static] = ACTIONS(2653),
    [anon_sym_register] = ACTIONS(2653),
    [anon_sym_inline] = ACTIONS(2653),
    [anon_sym___inline] = ACTIONS(2653),
    [anon_sym___inline__] = ACTIONS(2653),
    [anon_sym___forceinline] = ACTIONS(2653),
    [anon_sym_thread_local] = ACTIONS(2653),
    [anon_sym___thread] = ACTIONS(2653),
    [anon_sym_const] = ACTIONS(2653),
    [anon_sym_constexpr] = ACTIONS(2653),
    [anon_sym_volatile] = ACTIONS(2653),
    [anon_sym_restrict] = ACTIONS(2653),
    [anon_sym___restrict__] = ACTIONS(2653),
    [anon_sym__Atomic] = ACTIONS(2653),
    [anon_sym__Noreturn] = ACTIONS(2653),
    [anon_sym_noreturn] = ACTIONS(2653),
    [anon_sym_mutable] = ACTIONS(2653),
    [anon_sym_constinit] = ACTIONS(2653),
    [anon_sym_consteval] = ACTIONS(2653),
    [anon_sym_PROGMEM] = ACTIONS(2653),
    [aux_sym_primitive_type_token1] = ACTIONS(2653),
    [anon_sym_byte] = ACTIONS(2653),
    [anon_sym_word] = ACTIONS(2653),
    [anon_sym_enum] = ACTIONS(2653),
    [anon_sym_class] = ACTIONS(2653),
    [anon_sym_struct] = ACTIONS(2653),
    [anon_sym_union] = ACTIONS(2653),
    [anon_sym_if] = ACTIONS(2653),
    [anon_sym_else] = ACTIONS(2653),
    [anon_sym_switch] = ACTIONS(2653),
    [anon_sym_case] = ACTIONS(2653),
    [anon_sym_default] = ACTIONS(2653),
    [anon_sym_while] = ACTIONS(2653),
    [anon_sym_do] = ACTIONS(2653),
    [anon_sym_for] = ACTIONS(2653),
    [anon_sym_return] = ACTIONS(2653),
    [anon_sym_break] = ACTIONS(2653),
    [anon_sym_continue] = ACTIONS(2653),
    [anon_sym_goto] = ACTIONS(2653),
    [anon_sym___try] = ACTIONS(2653),
    [anon_sym___leave] = ACTIONS(2653),
    [anon_sym_not] = ACTIONS(2653),
    [anon_sym_compl] = ACTIONS(2653),
    [anon_sym_DASH_DASH] = ACTIONS(2655),
    [anon_sym_PLUS_PLUS] = ACTIONS(2655),
    [anon_sym_sizeof] = ACTIONS(2653),
    [anon_sym___alignof__] = ACTIONS(2653),
    [anon_sym___alignof] = ACTIONS(2653),
    [anon_sym__alignof] = ACTIONS(2653),
    [anon_sym_alignof] = ACTIONS(2653),
    [anon_sym__Alignof] = ACTIONS(2653),
    [anon_sym_offsetof] = ACTIONS(2653),
    [anon_sym__Generic] = ACTIONS(2653),
    [anon_sym_asm] = ACTIONS(2653),
    [anon_sym___asm__] = ACTIONS(2653),
    [aux_sym_number_literal_token1] = ACTIONS(2655),
    [aux_sym_number_literal_token2] = ACTIONS(2653),
    [anon_sym_L_SQUOTE] = ACTIONS(2655),
    [anon_sym_u_SQUOTE] = ACTIONS(2655),
    [anon_sym_U_SQUOTE] = ACTIONS(2655),
    [anon_sym_u8_SQUOTE] = ACTIONS(2655),
    [anon_sym_SQUOTE] = ACTIONS(2655),
    [anon_sym_L_DQUOTE] = ACTIONS(2655),
    [anon_sym_u_DQUOTE] = ACTIONS(2655),
    [anon_sym_U_DQUOTE] = ACTIONS(2655),
    [anon_sym_u8_DQUOTE] = ACTIONS(2655),
    [anon_sym_DQUOTE] = ACTIONS(2655),
    [sym_true] = ACTIONS(2653),
    [sym_false] = ACTIONS(2653),
    [anon_sym_NULL] = ACTIONS(2653),
    [anon_sym_nullptr] = ACTIONS(2653),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2653),
    [anon_sym_decltype] = ACTIONS(2653),
    [anon_sym_virtual] = ACTIONS(2653),
    [anon_sym_alignas] = ACTIONS(2653),
    [anon_sym_explicit] = ACTIONS(2653),
    [anon_sym_typename] = ACTIONS(2653),
    [anon_sym_template] = ACTIONS(2653),
    [anon_sym_operator] = ACTIONS(2653),
    [anon_sym_try] = ACTIONS(2653),
    [anon_sym_delete] = ACTIONS(2653),
    [anon_sym_throw] = ACTIONS(2653),
    [anon_sym_namespace] = ACTIONS(2653),
    [anon_sym_using] = ACTIONS(2653),
    [anon_sym_static_assert] = ACTIONS(2653),
    [anon_sym_concept] = ACTIONS(2653),
    [anon_sym_co_return] = ACTIONS(2653),
    [anon_sym_co_yield] = ACTIONS(2653),
    [anon_sym_R_DQUOTE] = ACTIONS(2655),
    [anon_sym_LR_DQUOTE] = ACTIONS(2655),
    [anon_sym_uR_DQUOTE] = ACTIONS(2655),
    [anon_sym_UR_DQUOTE] = ACTIONS(2655),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2655),
    [anon_sym_co_await] = ACTIONS(2653),
    [anon_sym_new] = ACTIONS(2653),
    [anon_sym_requires] = ACTIONS(2653),
    [sym_this] = ACTIONS(2653),
  },
  [244] = {
    [sym_identifier] = ACTIONS(2657),
    [aux_sym_preproc_include_token1] = ACTIONS(2657),
    [aux_sym_preproc_def_token1] = ACTIONS(2657),
    [aux_sym_preproc_if_token1] = ACTIONS(2657),
    [aux_sym_preproc_if_token2] = ACTIONS(2657),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2657),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2657),
    [aux_sym_preproc_else_token1] = ACTIONS(2657),
    [aux_sym_preproc_elif_token1] = ACTIONS(2657),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2657),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2657),
    [sym_preproc_directive] = ACTIONS(2657),
    [anon_sym_LPAREN2] = ACTIONS(2659),
    [anon_sym_BANG] = ACTIONS(2659),
    [anon_sym_TILDE] = ACTIONS(2659),
    [anon_sym_DASH] = ACTIONS(2657),
    [anon_sym_PLUS] = ACTIONS(2657),
    [anon_sym_STAR] = ACTIONS(2659),
    [anon_sym_AMP_AMP] = ACTIONS(2659),
    [anon_sym_AMP] = ACTIONS(2657),
    [anon_sym_SEMI] = ACTIONS(2659),
    [anon_sym___extension__] = ACTIONS(2657),
    [anon_sym_typedef] = ACTIONS(2657),
    [anon_sym_extern] = ACTIONS(2657),
    [anon_sym___attribute__] = ACTIONS(2657),
    [anon_sym_COLON_COLON] = ACTIONS(2659),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2659),
    [anon_sym___declspec] = ACTIONS(2657),
    [anon_sym___based] = ACTIONS(2657),
    [anon_sym___cdecl] = ACTIONS(2657),
    [anon_sym___clrcall] = ACTIONS(2657),
    [anon_sym___stdcall] = ACTIONS(2657),
    [anon_sym___fastcall] = ACTIONS(2657),
    [anon_sym___thiscall] = ACTIONS(2657),
    [anon_sym___vectorcall] = ACTIONS(2657),
    [anon_sym_LBRACE] = ACTIONS(2659),
    [anon_sym_signed] = ACTIONS(2657),
    [anon_sym_unsigned] = ACTIONS(2657),
    [anon_sym_long] = ACTIONS(2657),
    [anon_sym_short] = ACTIONS(2657),
    [anon_sym_LBRACK] = ACTIONS(2657),
    [anon_sym_static] = ACTIONS(2657),
    [anon_sym_register] = ACTIONS(2657),
    [anon_sym_inline] = ACTIONS(2657),
    [anon_sym___inline] = ACTIONS(2657),
    [anon_sym___inline__] = ACTIONS(2657),
    [anon_sym___forceinline] = ACTIONS(2657),
    [anon_sym_thread_local] = ACTIONS(2657),
    [anon_sym___thread] = ACTIONS(2657),
    [anon_sym_const] = ACTIONS(2657),
    [anon_sym_constexpr] = ACTIONS(2657),
    [anon_sym_volatile] = ACTIONS(2657),
    [anon_sym_restrict] = ACTIONS(2657),
    [anon_sym___restrict__] = ACTIONS(2657),
    [anon_sym__Atomic] = ACTIONS(2657),
    [anon_sym__Noreturn] = ACTIONS(2657),
    [anon_sym_noreturn] = ACTIONS(2657),
    [anon_sym_mutable] = ACTIONS(2657),
    [anon_sym_constinit] = ACTIONS(2657),
    [anon_sym_consteval] = ACTIONS(2657),
    [anon_sym_PROGMEM] = ACTIONS(2657),
    [aux_sym_primitive_type_token1] = ACTIONS(2657),
    [anon_sym_byte] = ACTIONS(2657),
    [anon_sym_word] = ACTIONS(2657),
    [anon_sym_enum] = ACTIONS(2657),
    [anon_sym_class] = ACTIONS(2657),
    [anon_sym_struct] = ACTIONS(2657),
    [anon_sym_union] = ACTIONS(2657),
    [anon_sym_if] = ACTIONS(2657),
    [anon_sym_else] = ACTIONS(2657),
    [anon_sym_switch] = ACTIONS(2657),
    [anon_sym_case] = ACTIONS(2657),
    [anon_sym_default] = ACTIONS(2657),
    [anon_sym_while] = ACTIONS(2657),
    [anon_sym_do] = ACTIONS(2657),
    [anon_sym_for] = ACTIONS(2657),
    [anon_sym_return] = ACTIONS(2657),
    [anon_sym_break] = ACTIONS(2657),
    [anon_sym_continue] = ACTIONS(2657),
    [anon_sym_goto] = ACTIONS(2657),
    [anon_sym___try] = ACTIONS(2657),
    [anon_sym___leave] = ACTIONS(2657),
    [anon_sym_not] = ACTIONS(2657),
    [anon_sym_compl] = ACTIONS(2657),
    [anon_sym_DASH_DASH] = ACTIONS(2659),
    [anon_sym_PLUS_PLUS] = ACTIONS(2659),
    [anon_sym_sizeof] = ACTIONS(2657),
    [anon_sym___alignof__] = ACTIONS(2657),
    [anon_sym___alignof] = ACTIONS(2657),
    [anon_sym__alignof] = ACTIONS(2657),
    [anon_sym_alignof] = ACTIONS(2657),
    [anon_sym__Alignof] = ACTIONS(2657),
    [anon_sym_offsetof] = ACTIONS(2657),
    [anon_sym__Generic] = ACTIONS(2657),
    [anon_sym_asm] = ACTIONS(2657),
    [anon_sym___asm__] = ACTIONS(2657),
    [aux_sym_number_literal_token1] = ACTIONS(2659),
    [aux_sym_number_literal_token2] = ACTIONS(2657),
    [anon_sym_L_SQUOTE] = ACTIONS(2659),
    [anon_sym_u_SQUOTE] = ACTIONS(2659),
    [anon_sym_U_SQUOTE] = ACTIONS(2659),
    [anon_sym_u8_SQUOTE] = ACTIONS(2659),
    [anon_sym_SQUOTE] = ACTIONS(2659),
    [anon_sym_L_DQUOTE] = ACTIONS(2659),
    [anon_sym_u_DQUOTE] = ACTIONS(2659),
    [anon_sym_U_DQUOTE] = ACTIONS(2659),
    [anon_sym_u8_DQUOTE] = ACTIONS(2659),
    [anon_sym_DQUOTE] = ACTIONS(2659),
    [sym_true] = ACTIONS(2657),
    [sym_false] = ACTIONS(2657),
    [anon_sym_NULL] = ACTIONS(2657),
    [anon_sym_nullptr] = ACTIONS(2657),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2657),
    [anon_sym_decltype] = ACTIONS(2657),
    [anon_sym_virtual] = ACTIONS(2657),
    [anon_sym_alignas] = ACTIONS(2657),
    [anon_sym_explicit] = ACTIONS(2657),
    [anon_sym_typename] = ACTIONS(2657),
    [anon_sym_template] = ACTIONS(2657),
    [anon_sym_operator] = ACTIONS(2657),
    [anon_sym_try] = ACTIONS(2657),
    [anon_sym_delete] = ACTIONS(2657),
    [anon_sym_throw] = ACTIONS(2657),
    [anon_sym_namespace] = ACTIONS(2657),
    [anon_sym_using] = ACTIONS(2657),
    [anon_sym_static_assert] = ACTIONS(2657),
    [anon_sym_concept] = ACTIONS(2657),
    [anon_sym_co_return] = ACTIONS(2657),
    [anon_sym_co_yield] = ACTIONS(2657),
    [anon_sym_R_DQUOTE] = ACTIONS(2659),
    [anon_sym_LR_DQUOTE] = ACTIONS(2659),
    [anon_sym_uR_DQUOTE] = ACTIONS(2659),
    [anon_sym_UR_DQUOTE] = ACTIONS(2659),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2659),
    [anon_sym_co_await] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(2657),
    [anon_sym_requires] = ACTIONS(2657),
    [sym_this] = ACTIONS(2657),
  },
  [245] = {
    [sym_identifier] = ACTIONS(2661),
    [aux_sym_preproc_include_token1] = ACTIONS(2661),
    [aux_sym_preproc_def_token1] = ACTIONS(2661),
    [aux_sym_preproc_if_token1] = ACTIONS(2661),
    [aux_sym_preproc_if_token2] = ACTIONS(2661),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2661),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2661),
    [aux_sym_preproc_else_token1] = ACTIONS(2661),
    [aux_sym_preproc_elif_token1] = ACTIONS(2661),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2661),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2661),
    [sym_preproc_directive] = ACTIONS(2661),
    [anon_sym_LPAREN2] = ACTIONS(2663),
    [anon_sym_BANG] = ACTIONS(2663),
    [anon_sym_TILDE] = ACTIONS(2663),
    [anon_sym_DASH] = ACTIONS(2661),
    [anon_sym_PLUS] = ACTIONS(2661),
    [anon_sym_STAR] = ACTIONS(2663),
    [anon_sym_AMP_AMP] = ACTIONS(2663),
    [anon_sym_AMP] = ACTIONS(2661),
    [anon_sym_SEMI] = ACTIONS(2663),
    [anon_sym___extension__] = ACTIONS(2661),
    [anon_sym_typedef] = ACTIONS(2661),
    [anon_sym_extern] = ACTIONS(2661),
    [anon_sym___attribute__] = ACTIONS(2661),
    [anon_sym_COLON_COLON] = ACTIONS(2663),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2663),
    [anon_sym___declspec] = ACTIONS(2661),
    [anon_sym___based] = ACTIONS(2661),
    [anon_sym___cdecl] = ACTIONS(2661),
    [anon_sym___clrcall] = ACTIONS(2661),
    [anon_sym___stdcall] = ACTIONS(2661),
    [anon_sym___fastcall] = ACTIONS(2661),
    [anon_sym___thiscall] = ACTIONS(2661),
    [anon_sym___vectorcall] = ACTIONS(2661),
    [anon_sym_LBRACE] = ACTIONS(2663),
    [anon_sym_signed] = ACTIONS(2661),
    [anon_sym_unsigned] = ACTIONS(2661),
    [anon_sym_long] = ACTIONS(2661),
    [anon_sym_short] = ACTIONS(2661),
    [anon_sym_LBRACK] = ACTIONS(2661),
    [anon_sym_static] = ACTIONS(2661),
    [anon_sym_register] = ACTIONS(2661),
    [anon_sym_inline] = ACTIONS(2661),
    [anon_sym___inline] = ACTIONS(2661),
    [anon_sym___inline__] = ACTIONS(2661),
    [anon_sym___forceinline] = ACTIONS(2661),
    [anon_sym_thread_local] = ACTIONS(2661),
    [anon_sym___thread] = ACTIONS(2661),
    [anon_sym_const] = ACTIONS(2661),
    [anon_sym_constexpr] = ACTIONS(2661),
    [anon_sym_volatile] = ACTIONS(2661),
    [anon_sym_restrict] = ACTIONS(2661),
    [anon_sym___restrict__] = ACTIONS(2661),
    [anon_sym__Atomic] = ACTIONS(2661),
    [anon_sym__Noreturn] = ACTIONS(2661),
    [anon_sym_noreturn] = ACTIONS(2661),
    [anon_sym_mutable] = ACTIONS(2661),
    [anon_sym_constinit] = ACTIONS(2661),
    [anon_sym_consteval] = ACTIONS(2661),
    [anon_sym_PROGMEM] = ACTIONS(2661),
    [aux_sym_primitive_type_token1] = ACTIONS(2661),
    [anon_sym_byte] = ACTIONS(2661),
    [anon_sym_word] = ACTIONS(2661),
    [anon_sym_enum] = ACTIONS(2661),
    [anon_sym_class] = ACTIONS(2661),
    [anon_sym_struct] = ACTIONS(2661),
    [anon_sym_union] = ACTIONS(2661),
    [anon_sym_if] = ACTIONS(2661),
    [anon_sym_else] = ACTIONS(2661),
    [anon_sym_switch] = ACTIONS(2661),
    [anon_sym_case] = ACTIONS(2661),
    [anon_sym_default] = ACTIONS(2661),
    [anon_sym_while] = ACTIONS(2661),
    [anon_sym_do] = ACTIONS(2661),
    [anon_sym_for] = ACTIONS(2661),
    [anon_sym_return] = ACTIONS(2661),
    [anon_sym_break] = ACTIONS(2661),
    [anon_sym_continue] = ACTIONS(2661),
    [anon_sym_goto] = ACTIONS(2661),
    [anon_sym___try] = ACTIONS(2661),
    [anon_sym___leave] = ACTIONS(2661),
    [anon_sym_not] = ACTIONS(2661),
    [anon_sym_compl] = ACTIONS(2661),
    [anon_sym_DASH_DASH] = ACTIONS(2663),
    [anon_sym_PLUS_PLUS] = ACTIONS(2663),
    [anon_sym_sizeof] = ACTIONS(2661),
    [anon_sym___alignof__] = ACTIONS(2661),
    [anon_sym___alignof] = ACTIONS(2661),
    [anon_sym__alignof] = ACTIONS(2661),
    [anon_sym_alignof] = ACTIONS(2661),
    [anon_sym__Alignof] = ACTIONS(2661),
    [anon_sym_offsetof] = ACTIONS(2661),
    [anon_sym__Generic] = ACTIONS(2661),
    [anon_sym_asm] = ACTIONS(2661),
    [anon_sym___asm__] = ACTIONS(2661),
    [aux_sym_number_literal_token1] = ACTIONS(2663),
    [aux_sym_number_literal_token2] = ACTIONS(2661),
    [anon_sym_L_SQUOTE] = ACTIONS(2663),
    [anon_sym_u_SQUOTE] = ACTIONS(2663),
    [anon_sym_U_SQUOTE] = ACTIONS(2663),
    [anon_sym_u8_SQUOTE] = ACTIONS(2663),
    [anon_sym_SQUOTE] = ACTIONS(2663),
    [anon_sym_L_DQUOTE] = ACTIONS(2663),
    [anon_sym_u_DQUOTE] = ACTIONS(2663),
    [anon_sym_U_DQUOTE] = ACTIONS(2663),
    [anon_sym_u8_DQUOTE] = ACTIONS(2663),
    [anon_sym_DQUOTE] = ACTIONS(2663),
    [sym_true] = ACTIONS(2661),
    [sym_false] = ACTIONS(2661),
    [anon_sym_NULL] = ACTIONS(2661),
    [anon_sym_nullptr] = ACTIONS(2661),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2661),
    [anon_sym_decltype] = ACTIONS(2661),
    [anon_sym_virtual] = ACTIONS(2661),
    [anon_sym_alignas] = ACTIONS(2661),
    [anon_sym_explicit] = ACTIONS(2661),
    [anon_sym_typename] = ACTIONS(2661),
    [anon_sym_template] = ACTIONS(2661),
    [anon_sym_operator] = ACTIONS(2661),
    [anon_sym_try] = ACTIONS(2661),
    [anon_sym_delete] = ACTIONS(2661),
    [anon_sym_throw] = ACTIONS(2661),
    [anon_sym_namespace] = ACTIONS(2661),
    [anon_sym_using] = ACTIONS(2661),
    [anon_sym_static_assert] = ACTIONS(2661),
    [anon_sym_concept] = ACTIONS(2661),
    [anon_sym_co_return] = ACTIONS(2661),
    [anon_sym_co_yield] = ACTIONS(2661),
    [anon_sym_R_DQUOTE] = ACTIONS(2663),
    [anon_sym_LR_DQUOTE] = ACTIONS(2663),
    [anon_sym_uR_DQUOTE] = ACTIONS(2663),
    [anon_sym_UR_DQUOTE] = ACTIONS(2663),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2663),
    [anon_sym_co_await] = ACTIONS(2661),
    [anon_sym_new] = ACTIONS(2661),
    [anon_sym_requires] = ACTIONS(2661),
    [sym_this] = ACTIONS(2661),
  },
  [246] = {
    [sym_identifier] = ACTIONS(2665),
    [aux_sym_preproc_include_token1] = ACTIONS(2665),
    [aux_sym_preproc_def_token1] = ACTIONS(2665),
    [aux_sym_preproc_if_token1] = ACTIONS(2665),
    [aux_sym_preproc_if_token2] = ACTIONS(2665),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2665),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2665),
    [aux_sym_preproc_else_token1] = ACTIONS(2665),
    [aux_sym_preproc_elif_token1] = ACTIONS(2665),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2665),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2665),
    [sym_preproc_directive] = ACTIONS(2665),
    [anon_sym_LPAREN2] = ACTIONS(2667),
    [anon_sym_BANG] = ACTIONS(2667),
    [anon_sym_TILDE] = ACTIONS(2667),
    [anon_sym_DASH] = ACTIONS(2665),
    [anon_sym_PLUS] = ACTIONS(2665),
    [anon_sym_STAR] = ACTIONS(2667),
    [anon_sym_AMP_AMP] = ACTIONS(2667),
    [anon_sym_AMP] = ACTIONS(2665),
    [anon_sym_SEMI] = ACTIONS(2667),
    [anon_sym___extension__] = ACTIONS(2665),
    [anon_sym_typedef] = ACTIONS(2665),
    [anon_sym_extern] = ACTIONS(2665),
    [anon_sym___attribute__] = ACTIONS(2665),
    [anon_sym_COLON_COLON] = ACTIONS(2667),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2667),
    [anon_sym___declspec] = ACTIONS(2665),
    [anon_sym___based] = ACTIONS(2665),
    [anon_sym___cdecl] = ACTIONS(2665),
    [anon_sym___clrcall] = ACTIONS(2665),
    [anon_sym___stdcall] = ACTIONS(2665),
    [anon_sym___fastcall] = ACTIONS(2665),
    [anon_sym___thiscall] = ACTIONS(2665),
    [anon_sym___vectorcall] = ACTIONS(2665),
    [anon_sym_LBRACE] = ACTIONS(2667),
    [anon_sym_signed] = ACTIONS(2665),
    [anon_sym_unsigned] = ACTIONS(2665),
    [anon_sym_long] = ACTIONS(2665),
    [anon_sym_short] = ACTIONS(2665),
    [anon_sym_LBRACK] = ACTIONS(2665),
    [anon_sym_static] = ACTIONS(2665),
    [anon_sym_register] = ACTIONS(2665),
    [anon_sym_inline] = ACTIONS(2665),
    [anon_sym___inline] = ACTIONS(2665),
    [anon_sym___inline__] = ACTIONS(2665),
    [anon_sym___forceinline] = ACTIONS(2665),
    [anon_sym_thread_local] = ACTIONS(2665),
    [anon_sym___thread] = ACTIONS(2665),
    [anon_sym_const] = ACTIONS(2665),
    [anon_sym_constexpr] = ACTIONS(2665),
    [anon_sym_volatile] = ACTIONS(2665),
    [anon_sym_restrict] = ACTIONS(2665),
    [anon_sym___restrict__] = ACTIONS(2665),
    [anon_sym__Atomic] = ACTIONS(2665),
    [anon_sym__Noreturn] = ACTIONS(2665),
    [anon_sym_noreturn] = ACTIONS(2665),
    [anon_sym_mutable] = ACTIONS(2665),
    [anon_sym_constinit] = ACTIONS(2665),
    [anon_sym_consteval] = ACTIONS(2665),
    [anon_sym_PROGMEM] = ACTIONS(2665),
    [aux_sym_primitive_type_token1] = ACTIONS(2665),
    [anon_sym_byte] = ACTIONS(2665),
    [anon_sym_word] = ACTIONS(2665),
    [anon_sym_enum] = ACTIONS(2665),
    [anon_sym_class] = ACTIONS(2665),
    [anon_sym_struct] = ACTIONS(2665),
    [anon_sym_union] = ACTIONS(2665),
    [anon_sym_if] = ACTIONS(2665),
    [anon_sym_else] = ACTIONS(2665),
    [anon_sym_switch] = ACTIONS(2665),
    [anon_sym_case] = ACTIONS(2665),
    [anon_sym_default] = ACTIONS(2665),
    [anon_sym_while] = ACTIONS(2665),
    [anon_sym_do] = ACTIONS(2665),
    [anon_sym_for] = ACTIONS(2665),
    [anon_sym_return] = ACTIONS(2665),
    [anon_sym_break] = ACTIONS(2665),
    [anon_sym_continue] = ACTIONS(2665),
    [anon_sym_goto] = ACTIONS(2665),
    [anon_sym___try] = ACTIONS(2665),
    [anon_sym___leave] = ACTIONS(2665),
    [anon_sym_not] = ACTIONS(2665),
    [anon_sym_compl] = ACTIONS(2665),
    [anon_sym_DASH_DASH] = ACTIONS(2667),
    [anon_sym_PLUS_PLUS] = ACTIONS(2667),
    [anon_sym_sizeof] = ACTIONS(2665),
    [anon_sym___alignof__] = ACTIONS(2665),
    [anon_sym___alignof] = ACTIONS(2665),
    [anon_sym__alignof] = ACTIONS(2665),
    [anon_sym_alignof] = ACTIONS(2665),
    [anon_sym__Alignof] = ACTIONS(2665),
    [anon_sym_offsetof] = ACTIONS(2665),
    [anon_sym__Generic] = ACTIONS(2665),
    [anon_sym_asm] = ACTIONS(2665),
    [anon_sym___asm__] = ACTIONS(2665),
    [aux_sym_number_literal_token1] = ACTIONS(2667),
    [aux_sym_number_literal_token2] = ACTIONS(2665),
    [anon_sym_L_SQUOTE] = ACTIONS(2667),
    [anon_sym_u_SQUOTE] = ACTIONS(2667),
    [anon_sym_U_SQUOTE] = ACTIONS(2667),
    [anon_sym_u8_SQUOTE] = ACTIONS(2667),
    [anon_sym_SQUOTE] = ACTIONS(2667),
    [anon_sym_L_DQUOTE] = ACTIONS(2667),
    [anon_sym_u_DQUOTE] = ACTIONS(2667),
    [anon_sym_U_DQUOTE] = ACTIONS(2667),
    [anon_sym_u8_DQUOTE] = ACTIONS(2667),
    [anon_sym_DQUOTE] = ACTIONS(2667),
    [sym_true] = ACTIONS(2665),
    [sym_false] = ACTIONS(2665),
    [anon_sym_NULL] = ACTIONS(2665),
    [anon_sym_nullptr] = ACTIONS(2665),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2665),
    [anon_sym_decltype] = ACTIONS(2665),
    [anon_sym_virtual] = ACTIONS(2665),
    [anon_sym_alignas] = ACTIONS(2665),
    [anon_sym_explicit] = ACTIONS(2665),
    [anon_sym_typename] = ACTIONS(2665),
    [anon_sym_template] = ACTIONS(2665),
    [anon_sym_operator] = ACTIONS(2665),
    [anon_sym_try] = ACTIONS(2665),
    [anon_sym_delete] = ACTIONS(2665),
    [anon_sym_throw] = ACTIONS(2665),
    [anon_sym_namespace] = ACTIONS(2665),
    [anon_sym_using] = ACTIONS(2665),
    [anon_sym_static_assert] = ACTIONS(2665),
    [anon_sym_concept] = ACTIONS(2665),
    [anon_sym_co_return] = ACTIONS(2665),
    [anon_sym_co_yield] = ACTIONS(2665),
    [anon_sym_R_DQUOTE] = ACTIONS(2667),
    [anon_sym_LR_DQUOTE] = ACTIONS(2667),
    [anon_sym_uR_DQUOTE] = ACTIONS(2667),
    [anon_sym_UR_DQUOTE] = ACTIONS(2667),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2667),
    [anon_sym_co_await] = ACTIONS(2665),
    [anon_sym_new] = ACTIONS(2665),
    [anon_sym_requires] = ACTIONS(2665),
    [sym_this] = ACTIONS(2665),
  },
  [247] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token2] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [aux_sym_preproc_else_token1] = ACTIONS(2643),
    [aux_sym_preproc_elif_token1] = ACTIONS(2643),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [248] = {
    [sym_identifier] = ACTIONS(2669),
    [aux_sym_preproc_include_token1] = ACTIONS(2669),
    [aux_sym_preproc_def_token1] = ACTIONS(2669),
    [aux_sym_preproc_if_token1] = ACTIONS(2669),
    [aux_sym_preproc_if_token2] = ACTIONS(2669),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2669),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2669),
    [aux_sym_preproc_else_token1] = ACTIONS(2669),
    [aux_sym_preproc_elif_token1] = ACTIONS(2669),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2669),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2669),
    [sym_preproc_directive] = ACTIONS(2669),
    [anon_sym_LPAREN2] = ACTIONS(2671),
    [anon_sym_BANG] = ACTIONS(2671),
    [anon_sym_TILDE] = ACTIONS(2671),
    [anon_sym_DASH] = ACTIONS(2669),
    [anon_sym_PLUS] = ACTIONS(2669),
    [anon_sym_STAR] = ACTIONS(2671),
    [anon_sym_AMP_AMP] = ACTIONS(2671),
    [anon_sym_AMP] = ACTIONS(2669),
    [anon_sym_SEMI] = ACTIONS(2671),
    [anon_sym___extension__] = ACTIONS(2669),
    [anon_sym_typedef] = ACTIONS(2669),
    [anon_sym_extern] = ACTIONS(2669),
    [anon_sym___attribute__] = ACTIONS(2669),
    [anon_sym_COLON_COLON] = ACTIONS(2671),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2671),
    [anon_sym___declspec] = ACTIONS(2669),
    [anon_sym___based] = ACTIONS(2669),
    [anon_sym___cdecl] = ACTIONS(2669),
    [anon_sym___clrcall] = ACTIONS(2669),
    [anon_sym___stdcall] = ACTIONS(2669),
    [anon_sym___fastcall] = ACTIONS(2669),
    [anon_sym___thiscall] = ACTIONS(2669),
    [anon_sym___vectorcall] = ACTIONS(2669),
    [anon_sym_LBRACE] = ACTIONS(2671),
    [anon_sym_signed] = ACTIONS(2669),
    [anon_sym_unsigned] = ACTIONS(2669),
    [anon_sym_long] = ACTIONS(2669),
    [anon_sym_short] = ACTIONS(2669),
    [anon_sym_LBRACK] = ACTIONS(2669),
    [anon_sym_static] = ACTIONS(2669),
    [anon_sym_register] = ACTIONS(2669),
    [anon_sym_inline] = ACTIONS(2669),
    [anon_sym___inline] = ACTIONS(2669),
    [anon_sym___inline__] = ACTIONS(2669),
    [anon_sym___forceinline] = ACTIONS(2669),
    [anon_sym_thread_local] = ACTIONS(2669),
    [anon_sym___thread] = ACTIONS(2669),
    [anon_sym_const] = ACTIONS(2669),
    [anon_sym_constexpr] = ACTIONS(2669),
    [anon_sym_volatile] = ACTIONS(2669),
    [anon_sym_restrict] = ACTIONS(2669),
    [anon_sym___restrict__] = ACTIONS(2669),
    [anon_sym__Atomic] = ACTIONS(2669),
    [anon_sym__Noreturn] = ACTIONS(2669),
    [anon_sym_noreturn] = ACTIONS(2669),
    [anon_sym_mutable] = ACTIONS(2669),
    [anon_sym_constinit] = ACTIONS(2669),
    [anon_sym_consteval] = ACTIONS(2669),
    [anon_sym_PROGMEM] = ACTIONS(2669),
    [aux_sym_primitive_type_token1] = ACTIONS(2669),
    [anon_sym_byte] = ACTIONS(2669),
    [anon_sym_word] = ACTIONS(2669),
    [anon_sym_enum] = ACTIONS(2669),
    [anon_sym_class] = ACTIONS(2669),
    [anon_sym_struct] = ACTIONS(2669),
    [anon_sym_union] = ACTIONS(2669),
    [anon_sym_if] = ACTIONS(2669),
    [anon_sym_else] = ACTIONS(2669),
    [anon_sym_switch] = ACTIONS(2669),
    [anon_sym_case] = ACTIONS(2669),
    [anon_sym_default] = ACTIONS(2669),
    [anon_sym_while] = ACTIONS(2669),
    [anon_sym_do] = ACTIONS(2669),
    [anon_sym_for] = ACTIONS(2669),
    [anon_sym_return] = ACTIONS(2669),
    [anon_sym_break] = ACTIONS(2669),
    [anon_sym_continue] = ACTIONS(2669),
    [anon_sym_goto] = ACTIONS(2669),
    [anon_sym___try] = ACTIONS(2669),
    [anon_sym___leave] = ACTIONS(2669),
    [anon_sym_not] = ACTIONS(2669),
    [anon_sym_compl] = ACTIONS(2669),
    [anon_sym_DASH_DASH] = ACTIONS(2671),
    [anon_sym_PLUS_PLUS] = ACTIONS(2671),
    [anon_sym_sizeof] = ACTIONS(2669),
    [anon_sym___alignof__] = ACTIONS(2669),
    [anon_sym___alignof] = ACTIONS(2669),
    [anon_sym__alignof] = ACTIONS(2669),
    [anon_sym_alignof] = ACTIONS(2669),
    [anon_sym__Alignof] = ACTIONS(2669),
    [anon_sym_offsetof] = ACTIONS(2669),
    [anon_sym__Generic] = ACTIONS(2669),
    [anon_sym_asm] = ACTIONS(2669),
    [anon_sym___asm__] = ACTIONS(2669),
    [aux_sym_number_literal_token1] = ACTIONS(2671),
    [aux_sym_number_literal_token2] = ACTIONS(2669),
    [anon_sym_L_SQUOTE] = ACTIONS(2671),
    [anon_sym_u_SQUOTE] = ACTIONS(2671),
    [anon_sym_U_SQUOTE] = ACTIONS(2671),
    [anon_sym_u8_SQUOTE] = ACTIONS(2671),
    [anon_sym_SQUOTE] = ACTIONS(2671),
    [anon_sym_L_DQUOTE] = ACTIONS(2671),
    [anon_sym_u_DQUOTE] = ACTIONS(2671),
    [anon_sym_U_DQUOTE] = ACTIONS(2671),
    [anon_sym_u8_DQUOTE] = ACTIONS(2671),
    [anon_sym_DQUOTE] = ACTIONS(2671),
    [sym_true] = ACTIONS(2669),
    [sym_false] = ACTIONS(2669),
    [anon_sym_NULL] = ACTIONS(2669),
    [anon_sym_nullptr] = ACTIONS(2669),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2669),
    [anon_sym_decltype] = ACTIONS(2669),
    [anon_sym_virtual] = ACTIONS(2669),
    [anon_sym_alignas] = ACTIONS(2669),
    [anon_sym_explicit] = ACTIONS(2669),
    [anon_sym_typename] = ACTIONS(2669),
    [anon_sym_template] = ACTIONS(2669),
    [anon_sym_operator] = ACTIONS(2669),
    [anon_sym_try] = ACTIONS(2669),
    [anon_sym_delete] = ACTIONS(2669),
    [anon_sym_throw] = ACTIONS(2669),
    [anon_sym_namespace] = ACTIONS(2669),
    [anon_sym_using] = ACTIONS(2669),
    [anon_sym_static_assert] = ACTIONS(2669),
    [anon_sym_concept] = ACTIONS(2669),
    [anon_sym_co_return] = ACTIONS(2669),
    [anon_sym_co_yield] = ACTIONS(2669),
    [anon_sym_R_DQUOTE] = ACTIONS(2671),
    [anon_sym_LR_DQUOTE] = ACTIONS(2671),
    [anon_sym_uR_DQUOTE] = ACTIONS(2671),
    [anon_sym_UR_DQUOTE] = ACTIONS(2671),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2671),
    [anon_sym_co_await] = ACTIONS(2669),
    [anon_sym_new] = ACTIONS(2669),
    [anon_sym_requires] = ACTIONS(2669),
    [sym_this] = ACTIONS(2669),
  },
  [249] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token2] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [aux_sym_preproc_else_token1] = ACTIONS(2643),
    [aux_sym_preproc_elif_token1] = ACTIONS(2643),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [250] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token2] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [aux_sym_preproc_else_token1] = ACTIONS(2643),
    [aux_sym_preproc_elif_token1] = ACTIONS(2643),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [251] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token2] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [aux_sym_preproc_else_token1] = ACTIONS(2643),
    [aux_sym_preproc_elif_token1] = ACTIONS(2643),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [252] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token2] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [aux_sym_preproc_else_token1] = ACTIONS(2643),
    [aux_sym_preproc_elif_token1] = ACTIONS(2643),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [253] = {
    [sym_type_qualifier] = STATE(3799),
    [sym__type_specifier] = STATE(4801),
    [sym_sized_type_specifier] = STATE(2935),
    [sym_primitive_type] = STATE(4963),
    [sym_enum_specifier] = STATE(2935),
    [sym_struct_specifier] = STATE(2935),
    [sym_union_specifier] = STATE(2935),
    [sym__expression] = STATE(4288),
    [sym__expression_not_binary] = STATE(4648),
    [sym__string] = STATE(4648),
    [sym_conditional_expression] = STATE(4648),
    [sym_assignment_expression] = STATE(4648),
    [sym_pointer_expression] = STATE(3663),
    [sym_unary_expression] = STATE(4648),
    [sym_binary_expression] = STATE(4648),
    [sym_update_expression] = STATE(4648),
    [sym_cast_expression] = STATE(4648),
    [sym_type_descriptor] = STATE(6627),
    [sym_sizeof_expression] = STATE(4648),
    [sym_alignof_expression] = STATE(4648),
    [sym_offsetof_expression] = STATE(4648),
    [sym_generic_expression] = STATE(4648),
    [sym_subscript_expression] = STATE(3663),
    [sym_call_expression] = STATE(3663),
    [sym_gnu_asm_expression] = STATE(4648),
    [sym_field_expression] = STATE(3663),
    [sym_compound_literal_expression] = STATE(4648),
    [sym_parenthesized_expression] = STATE(3663),
    [sym_number_literal] = STATE(4573),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4565),
    [sym_string_literal] = STATE(3707),
    [sym_null] = STATE(4648),
    [sym_placeholder_type_specifier] = STATE(2935),
    [sym_decltype_auto] = STATE(2933),
    [sym_decltype] = STATE(2868),
    [sym_class_specifier] = STATE(2935),
    [sym__class_name] = STATE(7442),
    [sym_dependent_type] = STATE(2935),
    [sym_template_type] = STATE(5228),
    [sym_template_function] = STATE(4648),
    [sym_raw_string_literal] = STATE(3709),
    [sym_co_await_expression] = STATE(4648),
    [sym_new_expression] = STATE(4648),
    [sym_delete_expression] = STATE(4648),
    [sym_requires_clause] = STATE(4648),
    [sym_requires_expression] = STATE(4648),
    [sym_lambda_expression] = STATE(4648),
    [sym_lambda_capture_specifier] = STATE(5768),
    [sym_fold_expression] = STATE(4648),
    [sym_parameter_pack_expansion] = STATE(4648),
    [sym_type_parameter_pack_expansion] = STATE(6943),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5541),
    [sym_qualified_identifier] = STATE(3663),
    [sym_qualified_type_identifier] = STATE(5253),
    [sym_user_defined_literal] = STATE(3663),
    [aux_sym__type_definition_type_repeat1] = STATE(3799),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2164),
    [sym_identifier] = ACTIONS(2573),
    [anon_sym_LPAREN2] = ACTIONS(2575),
    [anon_sym_BANG] = ACTIONS(2577),
    [anon_sym_TILDE] = ACTIONS(2577),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2583),
    [anon_sym_signed] = ACTIONS(2585),
    [anon_sym_unsigned] = ACTIONS(2585),
    [anon_sym_long] = ACTIONS(2585),
    [anon_sym_short] = ACTIONS(2585),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2587),
    [anon_sym_byte] = ACTIONS(2587),
    [anon_sym_word] = ACTIONS(2587),
    [anon_sym_enum] = ACTIONS(2589),
    [anon_sym_class] = ACTIONS(2591),
    [anon_sym_struct] = ACTIONS(2593),
    [anon_sym_union] = ACTIONS(2595),
    [anon_sym_not] = ACTIONS(2579),
    [anon_sym_compl] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(2597),
    [anon_sym_PLUS_PLUS] = ACTIONS(2597),
    [anon_sym_sizeof] = ACTIONS(2599),
    [anon_sym___alignof__] = ACTIONS(2601),
    [anon_sym___alignof] = ACTIONS(2601),
    [anon_sym__alignof] = ACTIONS(2601),
    [anon_sym_alignof] = ACTIONS(2601),
    [anon_sym__Alignof] = ACTIONS(2601),
    [anon_sym_offsetof] = ACTIONS(2603),
    [anon_sym__Generic] = ACTIONS(2605),
    [anon_sym_asm] = ACTIONS(2607),
    [anon_sym___asm__] = ACTIONS(2607),
    [aux_sym_number_literal_token1] = ACTIONS(2609),
    [aux_sym_number_literal_token2] = ACTIONS(2611),
    [anon_sym_L_SQUOTE] = ACTIONS(2613),
    [anon_sym_u_SQUOTE] = ACTIONS(2613),
    [anon_sym_U_SQUOTE] = ACTIONS(2613),
    [anon_sym_u8_SQUOTE] = ACTIONS(2613),
    [anon_sym_SQUOTE] = ACTIONS(2613),
    [anon_sym_L_DQUOTE] = ACTIONS(2615),
    [anon_sym_u_DQUOTE] = ACTIONS(2615),
    [anon_sym_U_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8_DQUOTE] = ACTIONS(2615),
    [anon_sym_DQUOTE] = ACTIONS(2615),
    [sym_true] = ACTIONS(2617),
    [sym_false] = ACTIONS(2617),
    [anon_sym_NULL] = ACTIONS(2619),
    [anon_sym_nullptr] = ACTIONS(2619),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2621),
    [anon_sym_decltype] = ACTIONS(2623),
    [anon_sym_typename] = ACTIONS(2625),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_GT2] = ACTIONS(2673),
    [anon_sym_delete] = ACTIONS(2629),
    [anon_sym_R_DQUOTE] = ACTIONS(2631),
    [anon_sym_LR_DQUOTE] = ACTIONS(2631),
    [anon_sym_uR_DQUOTE] = ACTIONS(2631),
    [anon_sym_UR_DQUOTE] = ACTIONS(2631),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2631),
    [anon_sym_co_await] = ACTIONS(2633),
    [anon_sym_new] = ACTIONS(2635),
    [anon_sym_requires] = ACTIONS(2637),
    [sym_this] = ACTIONS(2617),
  },
  [254] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token2] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [aux_sym_preproc_else_token1] = ACTIONS(2643),
    [aux_sym_preproc_elif_token1] = ACTIONS(2643),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [255] = {
    [sym_identifier] = ACTIONS(2675),
    [aux_sym_preproc_include_token1] = ACTIONS(2675),
    [aux_sym_preproc_def_token1] = ACTIONS(2675),
    [aux_sym_preproc_if_token1] = ACTIONS(2675),
    [aux_sym_preproc_if_token2] = ACTIONS(2675),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2675),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2675),
    [aux_sym_preproc_else_token1] = ACTIONS(2675),
    [aux_sym_preproc_elif_token1] = ACTIONS(2675),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2675),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2675),
    [sym_preproc_directive] = ACTIONS(2675),
    [anon_sym_LPAREN2] = ACTIONS(2677),
    [anon_sym_BANG] = ACTIONS(2677),
    [anon_sym_TILDE] = ACTIONS(2677),
    [anon_sym_DASH] = ACTIONS(2675),
    [anon_sym_PLUS] = ACTIONS(2675),
    [anon_sym_STAR] = ACTIONS(2677),
    [anon_sym_AMP_AMP] = ACTIONS(2677),
    [anon_sym_AMP] = ACTIONS(2675),
    [anon_sym_SEMI] = ACTIONS(2677),
    [anon_sym___extension__] = ACTIONS(2675),
    [anon_sym_typedef] = ACTIONS(2675),
    [anon_sym_extern] = ACTIONS(2675),
    [anon_sym___attribute__] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(2677),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2677),
    [anon_sym___declspec] = ACTIONS(2675),
    [anon_sym___based] = ACTIONS(2675),
    [anon_sym___cdecl] = ACTIONS(2675),
    [anon_sym___clrcall] = ACTIONS(2675),
    [anon_sym___stdcall] = ACTIONS(2675),
    [anon_sym___fastcall] = ACTIONS(2675),
    [anon_sym___thiscall] = ACTIONS(2675),
    [anon_sym___vectorcall] = ACTIONS(2675),
    [anon_sym_LBRACE] = ACTIONS(2677),
    [anon_sym_signed] = ACTIONS(2675),
    [anon_sym_unsigned] = ACTIONS(2675),
    [anon_sym_long] = ACTIONS(2675),
    [anon_sym_short] = ACTIONS(2675),
    [anon_sym_LBRACK] = ACTIONS(2675),
    [anon_sym_static] = ACTIONS(2675),
    [anon_sym_register] = ACTIONS(2675),
    [anon_sym_inline] = ACTIONS(2675),
    [anon_sym___inline] = ACTIONS(2675),
    [anon_sym___inline__] = ACTIONS(2675),
    [anon_sym___forceinline] = ACTIONS(2675),
    [anon_sym_thread_local] = ACTIONS(2675),
    [anon_sym___thread] = ACTIONS(2675),
    [anon_sym_const] = ACTIONS(2675),
    [anon_sym_constexpr] = ACTIONS(2675),
    [anon_sym_volatile] = ACTIONS(2675),
    [anon_sym_restrict] = ACTIONS(2675),
    [anon_sym___restrict__] = ACTIONS(2675),
    [anon_sym__Atomic] = ACTIONS(2675),
    [anon_sym__Noreturn] = ACTIONS(2675),
    [anon_sym_noreturn] = ACTIONS(2675),
    [anon_sym_mutable] = ACTIONS(2675),
    [anon_sym_constinit] = ACTIONS(2675),
    [anon_sym_consteval] = ACTIONS(2675),
    [anon_sym_PROGMEM] = ACTIONS(2675),
    [aux_sym_primitive_type_token1] = ACTIONS(2675),
    [anon_sym_byte] = ACTIONS(2675),
    [anon_sym_word] = ACTIONS(2675),
    [anon_sym_enum] = ACTIONS(2675),
    [anon_sym_class] = ACTIONS(2675),
    [anon_sym_struct] = ACTIONS(2675),
    [anon_sym_union] = ACTIONS(2675),
    [anon_sym_if] = ACTIONS(2675),
    [anon_sym_else] = ACTIONS(2675),
    [anon_sym_switch] = ACTIONS(2675),
    [anon_sym_case] = ACTIONS(2675),
    [anon_sym_default] = ACTIONS(2675),
    [anon_sym_while] = ACTIONS(2675),
    [anon_sym_do] = ACTIONS(2675),
    [anon_sym_for] = ACTIONS(2675),
    [anon_sym_return] = ACTIONS(2675),
    [anon_sym_break] = ACTIONS(2675),
    [anon_sym_continue] = ACTIONS(2675),
    [anon_sym_goto] = ACTIONS(2675),
    [anon_sym___try] = ACTIONS(2675),
    [anon_sym___leave] = ACTIONS(2675),
    [anon_sym_not] = ACTIONS(2675),
    [anon_sym_compl] = ACTIONS(2675),
    [anon_sym_DASH_DASH] = ACTIONS(2677),
    [anon_sym_PLUS_PLUS] = ACTIONS(2677),
    [anon_sym_sizeof] = ACTIONS(2675),
    [anon_sym___alignof__] = ACTIONS(2675),
    [anon_sym___alignof] = ACTIONS(2675),
    [anon_sym__alignof] = ACTIONS(2675),
    [anon_sym_alignof] = ACTIONS(2675),
    [anon_sym__Alignof] = ACTIONS(2675),
    [anon_sym_offsetof] = ACTIONS(2675),
    [anon_sym__Generic] = ACTIONS(2675),
    [anon_sym_asm] = ACTIONS(2675),
    [anon_sym___asm__] = ACTIONS(2675),
    [aux_sym_number_literal_token1] = ACTIONS(2677),
    [aux_sym_number_literal_token2] = ACTIONS(2675),
    [anon_sym_L_SQUOTE] = ACTIONS(2677),
    [anon_sym_u_SQUOTE] = ACTIONS(2677),
    [anon_sym_U_SQUOTE] = ACTIONS(2677),
    [anon_sym_u8_SQUOTE] = ACTIONS(2677),
    [anon_sym_SQUOTE] = ACTIONS(2677),
    [anon_sym_L_DQUOTE] = ACTIONS(2677),
    [anon_sym_u_DQUOTE] = ACTIONS(2677),
    [anon_sym_U_DQUOTE] = ACTIONS(2677),
    [anon_sym_u8_DQUOTE] = ACTIONS(2677),
    [anon_sym_DQUOTE] = ACTIONS(2677),
    [sym_true] = ACTIONS(2675),
    [sym_false] = ACTIONS(2675),
    [anon_sym_NULL] = ACTIONS(2675),
    [anon_sym_nullptr] = ACTIONS(2675),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2675),
    [anon_sym_decltype] = ACTIONS(2675),
    [anon_sym_virtual] = ACTIONS(2675),
    [anon_sym_alignas] = ACTIONS(2675),
    [anon_sym_explicit] = ACTIONS(2675),
    [anon_sym_typename] = ACTIONS(2675),
    [anon_sym_template] = ACTIONS(2675),
    [anon_sym_operator] = ACTIONS(2675),
    [anon_sym_try] = ACTIONS(2675),
    [anon_sym_delete] = ACTIONS(2675),
    [anon_sym_throw] = ACTIONS(2675),
    [anon_sym_namespace] = ACTIONS(2675),
    [anon_sym_using] = ACTIONS(2675),
    [anon_sym_static_assert] = ACTIONS(2675),
    [anon_sym_concept] = ACTIONS(2675),
    [anon_sym_co_return] = ACTIONS(2675),
    [anon_sym_co_yield] = ACTIONS(2675),
    [anon_sym_R_DQUOTE] = ACTIONS(2677),
    [anon_sym_LR_DQUOTE] = ACTIONS(2677),
    [anon_sym_uR_DQUOTE] = ACTIONS(2677),
    [anon_sym_UR_DQUOTE] = ACTIONS(2677),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2677),
    [anon_sym_co_await] = ACTIONS(2675),
    [anon_sym_new] = ACTIONS(2675),
    [anon_sym_requires] = ACTIONS(2675),
    [sym_this] = ACTIONS(2675),
  },
  [256] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token2] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [aux_sym_preproc_else_token1] = ACTIONS(2643),
    [aux_sym_preproc_elif_token1] = ACTIONS(2643),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [257] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token2] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [aux_sym_preproc_else_token1] = ACTIONS(2643),
    [aux_sym_preproc_elif_token1] = ACTIONS(2643),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [258] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token2] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [aux_sym_preproc_else_token1] = ACTIONS(2679),
    [aux_sym_preproc_elif_token1] = ACTIONS(2679),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [259] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token2] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [aux_sym_preproc_else_token1] = ACTIONS(2679),
    [aux_sym_preproc_elif_token1] = ACTIONS(2679),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [260] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token2] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [aux_sym_preproc_else_token1] = ACTIONS(2679),
    [aux_sym_preproc_elif_token1] = ACTIONS(2679),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [261] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token2] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [aux_sym_preproc_else_token1] = ACTIONS(2679),
    [aux_sym_preproc_elif_token1] = ACTIONS(2679),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [262] = {
    [sym_identifier] = ACTIONS(2683),
    [aux_sym_preproc_include_token1] = ACTIONS(2683),
    [aux_sym_preproc_def_token1] = ACTIONS(2683),
    [aux_sym_preproc_if_token1] = ACTIONS(2683),
    [aux_sym_preproc_if_token2] = ACTIONS(2683),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2683),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2683),
    [aux_sym_preproc_else_token1] = ACTIONS(2683),
    [aux_sym_preproc_elif_token1] = ACTIONS(2683),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2683),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2683),
    [sym_preproc_directive] = ACTIONS(2683),
    [anon_sym_LPAREN2] = ACTIONS(2685),
    [anon_sym_BANG] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2685),
    [anon_sym_DASH] = ACTIONS(2683),
    [anon_sym_PLUS] = ACTIONS(2683),
    [anon_sym_STAR] = ACTIONS(2685),
    [anon_sym_AMP_AMP] = ACTIONS(2685),
    [anon_sym_AMP] = ACTIONS(2683),
    [anon_sym_SEMI] = ACTIONS(2685),
    [anon_sym___extension__] = ACTIONS(2683),
    [anon_sym_typedef] = ACTIONS(2683),
    [anon_sym_extern] = ACTIONS(2683),
    [anon_sym___attribute__] = ACTIONS(2683),
    [anon_sym_COLON_COLON] = ACTIONS(2685),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2685),
    [anon_sym___declspec] = ACTIONS(2683),
    [anon_sym___based] = ACTIONS(2683),
    [anon_sym___cdecl] = ACTIONS(2683),
    [anon_sym___clrcall] = ACTIONS(2683),
    [anon_sym___stdcall] = ACTIONS(2683),
    [anon_sym___fastcall] = ACTIONS(2683),
    [anon_sym___thiscall] = ACTIONS(2683),
    [anon_sym___vectorcall] = ACTIONS(2683),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_signed] = ACTIONS(2683),
    [anon_sym_unsigned] = ACTIONS(2683),
    [anon_sym_long] = ACTIONS(2683),
    [anon_sym_short] = ACTIONS(2683),
    [anon_sym_LBRACK] = ACTIONS(2683),
    [anon_sym_static] = ACTIONS(2683),
    [anon_sym_register] = ACTIONS(2683),
    [anon_sym_inline] = ACTIONS(2683),
    [anon_sym___inline] = ACTIONS(2683),
    [anon_sym___inline__] = ACTIONS(2683),
    [anon_sym___forceinline] = ACTIONS(2683),
    [anon_sym_thread_local] = ACTIONS(2683),
    [anon_sym___thread] = ACTIONS(2683),
    [anon_sym_const] = ACTIONS(2683),
    [anon_sym_constexpr] = ACTIONS(2683),
    [anon_sym_volatile] = ACTIONS(2683),
    [anon_sym_restrict] = ACTIONS(2683),
    [anon_sym___restrict__] = ACTIONS(2683),
    [anon_sym__Atomic] = ACTIONS(2683),
    [anon_sym__Noreturn] = ACTIONS(2683),
    [anon_sym_noreturn] = ACTIONS(2683),
    [anon_sym_mutable] = ACTIONS(2683),
    [anon_sym_constinit] = ACTIONS(2683),
    [anon_sym_consteval] = ACTIONS(2683),
    [anon_sym_PROGMEM] = ACTIONS(2683),
    [aux_sym_primitive_type_token1] = ACTIONS(2683),
    [anon_sym_byte] = ACTIONS(2683),
    [anon_sym_word] = ACTIONS(2683),
    [anon_sym_enum] = ACTIONS(2683),
    [anon_sym_class] = ACTIONS(2683),
    [anon_sym_struct] = ACTIONS(2683),
    [anon_sym_union] = ACTIONS(2683),
    [anon_sym_if] = ACTIONS(2683),
    [anon_sym_else] = ACTIONS(2683),
    [anon_sym_switch] = ACTIONS(2683),
    [anon_sym_case] = ACTIONS(2683),
    [anon_sym_default] = ACTIONS(2683),
    [anon_sym_while] = ACTIONS(2683),
    [anon_sym_do] = ACTIONS(2683),
    [anon_sym_for] = ACTIONS(2683),
    [anon_sym_return] = ACTIONS(2683),
    [anon_sym_break] = ACTIONS(2683),
    [anon_sym_continue] = ACTIONS(2683),
    [anon_sym_goto] = ACTIONS(2683),
    [anon_sym___try] = ACTIONS(2683),
    [anon_sym___leave] = ACTIONS(2683),
    [anon_sym_not] = ACTIONS(2683),
    [anon_sym_compl] = ACTIONS(2683),
    [anon_sym_DASH_DASH] = ACTIONS(2685),
    [anon_sym_PLUS_PLUS] = ACTIONS(2685),
    [anon_sym_sizeof] = ACTIONS(2683),
    [anon_sym___alignof__] = ACTIONS(2683),
    [anon_sym___alignof] = ACTIONS(2683),
    [anon_sym__alignof] = ACTIONS(2683),
    [anon_sym_alignof] = ACTIONS(2683),
    [anon_sym__Alignof] = ACTIONS(2683),
    [anon_sym_offsetof] = ACTIONS(2683),
    [anon_sym__Generic] = ACTIONS(2683),
    [anon_sym_asm] = ACTIONS(2683),
    [anon_sym___asm__] = ACTIONS(2683),
    [aux_sym_number_literal_token1] = ACTIONS(2685),
    [aux_sym_number_literal_token2] = ACTIONS(2683),
    [anon_sym_L_SQUOTE] = ACTIONS(2685),
    [anon_sym_u_SQUOTE] = ACTIONS(2685),
    [anon_sym_U_SQUOTE] = ACTIONS(2685),
    [anon_sym_u8_SQUOTE] = ACTIONS(2685),
    [anon_sym_SQUOTE] = ACTIONS(2685),
    [anon_sym_L_DQUOTE] = ACTIONS(2685),
    [anon_sym_u_DQUOTE] = ACTIONS(2685),
    [anon_sym_U_DQUOTE] = ACTIONS(2685),
    [anon_sym_u8_DQUOTE] = ACTIONS(2685),
    [anon_sym_DQUOTE] = ACTIONS(2685),
    [sym_true] = ACTIONS(2683),
    [sym_false] = ACTIONS(2683),
    [anon_sym_NULL] = ACTIONS(2683),
    [anon_sym_nullptr] = ACTIONS(2683),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2683),
    [anon_sym_decltype] = ACTIONS(2683),
    [anon_sym_virtual] = ACTIONS(2683),
    [anon_sym_alignas] = ACTIONS(2683),
    [anon_sym_explicit] = ACTIONS(2683),
    [anon_sym_typename] = ACTIONS(2683),
    [anon_sym_template] = ACTIONS(2683),
    [anon_sym_operator] = ACTIONS(2683),
    [anon_sym_try] = ACTIONS(2683),
    [anon_sym_delete] = ACTIONS(2683),
    [anon_sym_throw] = ACTIONS(2683),
    [anon_sym_namespace] = ACTIONS(2683),
    [anon_sym_using] = ACTIONS(2683),
    [anon_sym_static_assert] = ACTIONS(2683),
    [anon_sym_concept] = ACTIONS(2683),
    [anon_sym_co_return] = ACTIONS(2683),
    [anon_sym_co_yield] = ACTIONS(2683),
    [anon_sym_R_DQUOTE] = ACTIONS(2685),
    [anon_sym_LR_DQUOTE] = ACTIONS(2685),
    [anon_sym_uR_DQUOTE] = ACTIONS(2685),
    [anon_sym_UR_DQUOTE] = ACTIONS(2685),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2685),
    [anon_sym_co_await] = ACTIONS(2683),
    [anon_sym_new] = ACTIONS(2683),
    [anon_sym_requires] = ACTIONS(2683),
    [sym_this] = ACTIONS(2683),
  },
  [263] = {
    [sym_identifier] = ACTIONS(2507),
    [aux_sym_preproc_include_token1] = ACTIONS(2507),
    [aux_sym_preproc_def_token1] = ACTIONS(2507),
    [aux_sym_preproc_if_token1] = ACTIONS(2507),
    [aux_sym_preproc_if_token2] = ACTIONS(2507),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2507),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2507),
    [aux_sym_preproc_else_token1] = ACTIONS(2507),
    [aux_sym_preproc_elif_token1] = ACTIONS(2507),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2507),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2507),
    [sym_preproc_directive] = ACTIONS(2507),
    [anon_sym_LPAREN2] = ACTIONS(2512),
    [anon_sym_BANG] = ACTIONS(2512),
    [anon_sym_TILDE] = ACTIONS(2512),
    [anon_sym_DASH] = ACTIONS(2507),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_STAR] = ACTIONS(2512),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2507),
    [anon_sym_SEMI] = ACTIONS(2512),
    [anon_sym___extension__] = ACTIONS(2507),
    [anon_sym_typedef] = ACTIONS(2507),
    [anon_sym_extern] = ACTIONS(2507),
    [anon_sym___attribute__] = ACTIONS(2507),
    [anon_sym_COLON_COLON] = ACTIONS(2512),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2512),
    [anon_sym___declspec] = ACTIONS(2507),
    [anon_sym___based] = ACTIONS(2507),
    [anon_sym___cdecl] = ACTIONS(2507),
    [anon_sym___clrcall] = ACTIONS(2507),
    [anon_sym___stdcall] = ACTIONS(2507),
    [anon_sym___fastcall] = ACTIONS(2507),
    [anon_sym___thiscall] = ACTIONS(2507),
    [anon_sym___vectorcall] = ACTIONS(2507),
    [anon_sym_LBRACE] = ACTIONS(2512),
    [anon_sym_signed] = ACTIONS(2507),
    [anon_sym_unsigned] = ACTIONS(2507),
    [anon_sym_long] = ACTIONS(2507),
    [anon_sym_short] = ACTIONS(2507),
    [anon_sym_LBRACK] = ACTIONS(2507),
    [anon_sym_static] = ACTIONS(2507),
    [anon_sym_register] = ACTIONS(2507),
    [anon_sym_inline] = ACTIONS(2507),
    [anon_sym___inline] = ACTIONS(2507),
    [anon_sym___inline__] = ACTIONS(2507),
    [anon_sym___forceinline] = ACTIONS(2507),
    [anon_sym_thread_local] = ACTIONS(2507),
    [anon_sym___thread] = ACTIONS(2507),
    [anon_sym_const] = ACTIONS(2507),
    [anon_sym_constexpr] = ACTIONS(2507),
    [anon_sym_volatile] = ACTIONS(2507),
    [anon_sym_restrict] = ACTIONS(2507),
    [anon_sym___restrict__] = ACTIONS(2507),
    [anon_sym__Atomic] = ACTIONS(2507),
    [anon_sym__Noreturn] = ACTIONS(2507),
    [anon_sym_noreturn] = ACTIONS(2507),
    [anon_sym_mutable] = ACTIONS(2507),
    [anon_sym_constinit] = ACTIONS(2507),
    [anon_sym_consteval] = ACTIONS(2507),
    [anon_sym_PROGMEM] = ACTIONS(2507),
    [aux_sym_primitive_type_token1] = ACTIONS(2507),
    [anon_sym_byte] = ACTIONS(2507),
    [anon_sym_word] = ACTIONS(2507),
    [anon_sym_enum] = ACTIONS(2507),
    [anon_sym_class] = ACTIONS(2507),
    [anon_sym_struct] = ACTIONS(2507),
    [anon_sym_union] = ACTIONS(2507),
    [anon_sym_if] = ACTIONS(2507),
    [anon_sym_else] = ACTIONS(2507),
    [anon_sym_switch] = ACTIONS(2507),
    [anon_sym_case] = ACTIONS(2507),
    [anon_sym_default] = ACTIONS(2507),
    [anon_sym_while] = ACTIONS(2507),
    [anon_sym_do] = ACTIONS(2507),
    [anon_sym_for] = ACTIONS(2507),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_break] = ACTIONS(2507),
    [anon_sym_continue] = ACTIONS(2507),
    [anon_sym_goto] = ACTIONS(2507),
    [anon_sym___try] = ACTIONS(2507),
    [anon_sym___leave] = ACTIONS(2507),
    [anon_sym_not] = ACTIONS(2507),
    [anon_sym_compl] = ACTIONS(2507),
    [anon_sym_DASH_DASH] = ACTIONS(2512),
    [anon_sym_PLUS_PLUS] = ACTIONS(2512),
    [anon_sym_sizeof] = ACTIONS(2507),
    [anon_sym___alignof__] = ACTIONS(2507),
    [anon_sym___alignof] = ACTIONS(2507),
    [anon_sym__alignof] = ACTIONS(2507),
    [anon_sym_alignof] = ACTIONS(2507),
    [anon_sym__Alignof] = ACTIONS(2507),
    [anon_sym_offsetof] = ACTIONS(2507),
    [anon_sym__Generic] = ACTIONS(2507),
    [anon_sym_asm] = ACTIONS(2507),
    [anon_sym___asm__] = ACTIONS(2507),
    [aux_sym_number_literal_token1] = ACTIONS(2512),
    [aux_sym_number_literal_token2] = ACTIONS(2507),
    [anon_sym_L_SQUOTE] = ACTIONS(2512),
    [anon_sym_u_SQUOTE] = ACTIONS(2512),
    [anon_sym_U_SQUOTE] = ACTIONS(2512),
    [anon_sym_u8_SQUOTE] = ACTIONS(2512),
    [anon_sym_SQUOTE] = ACTIONS(2512),
    [anon_sym_L_DQUOTE] = ACTIONS(2512),
    [anon_sym_u_DQUOTE] = ACTIONS(2512),
    [anon_sym_U_DQUOTE] = ACTIONS(2512),
    [anon_sym_u8_DQUOTE] = ACTIONS(2512),
    [anon_sym_DQUOTE] = ACTIONS(2512),
    [sym_true] = ACTIONS(2507),
    [sym_false] = ACTIONS(2507),
    [anon_sym_NULL] = ACTIONS(2507),
    [anon_sym_nullptr] = ACTIONS(2507),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2507),
    [anon_sym_decltype] = ACTIONS(2507),
    [anon_sym_virtual] = ACTIONS(2507),
    [anon_sym_alignas] = ACTIONS(2507),
    [anon_sym_explicit] = ACTIONS(2507),
    [anon_sym_typename] = ACTIONS(2507),
    [anon_sym_template] = ACTIONS(2507),
    [anon_sym_operator] = ACTIONS(2507),
    [anon_sym_try] = ACTIONS(2507),
    [anon_sym_delete] = ACTIONS(2507),
    [anon_sym_throw] = ACTIONS(2507),
    [anon_sym_namespace] = ACTIONS(2507),
    [anon_sym_using] = ACTIONS(2507),
    [anon_sym_static_assert] = ACTIONS(2507),
    [anon_sym_concept] = ACTIONS(2507),
    [anon_sym_co_return] = ACTIONS(2507),
    [anon_sym_co_yield] = ACTIONS(2507),
    [anon_sym_R_DQUOTE] = ACTIONS(2512),
    [anon_sym_LR_DQUOTE] = ACTIONS(2512),
    [anon_sym_uR_DQUOTE] = ACTIONS(2512),
    [anon_sym_UR_DQUOTE] = ACTIONS(2512),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2512),
    [anon_sym_co_await] = ACTIONS(2507),
    [anon_sym_new] = ACTIONS(2507),
    [anon_sym_requires] = ACTIONS(2507),
    [sym_this] = ACTIONS(2507),
  },
  [264] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token2] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [aux_sym_preproc_else_token1] = ACTIONS(2679),
    [aux_sym_preproc_elif_token1] = ACTIONS(2679),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [265] = {
    [sym_identifier] = ACTIONS(2687),
    [aux_sym_preproc_include_token1] = ACTIONS(2687),
    [aux_sym_preproc_def_token1] = ACTIONS(2687),
    [aux_sym_preproc_if_token1] = ACTIONS(2687),
    [aux_sym_preproc_if_token2] = ACTIONS(2687),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2687),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2687),
    [aux_sym_preproc_else_token1] = ACTIONS(2687),
    [aux_sym_preproc_elif_token1] = ACTIONS(2687),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2687),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2687),
    [sym_preproc_directive] = ACTIONS(2687),
    [anon_sym_LPAREN2] = ACTIONS(2689),
    [anon_sym_BANG] = ACTIONS(2689),
    [anon_sym_TILDE] = ACTIONS(2689),
    [anon_sym_DASH] = ACTIONS(2687),
    [anon_sym_PLUS] = ACTIONS(2687),
    [anon_sym_STAR] = ACTIONS(2689),
    [anon_sym_AMP_AMP] = ACTIONS(2689),
    [anon_sym_AMP] = ACTIONS(2687),
    [anon_sym_SEMI] = ACTIONS(2689),
    [anon_sym___extension__] = ACTIONS(2687),
    [anon_sym_typedef] = ACTIONS(2687),
    [anon_sym_extern] = ACTIONS(2687),
    [anon_sym___attribute__] = ACTIONS(2687),
    [anon_sym_COLON_COLON] = ACTIONS(2689),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2689),
    [anon_sym___declspec] = ACTIONS(2687),
    [anon_sym___based] = ACTIONS(2687),
    [anon_sym___cdecl] = ACTIONS(2687),
    [anon_sym___clrcall] = ACTIONS(2687),
    [anon_sym___stdcall] = ACTIONS(2687),
    [anon_sym___fastcall] = ACTIONS(2687),
    [anon_sym___thiscall] = ACTIONS(2687),
    [anon_sym___vectorcall] = ACTIONS(2687),
    [anon_sym_LBRACE] = ACTIONS(2689),
    [anon_sym_signed] = ACTIONS(2687),
    [anon_sym_unsigned] = ACTIONS(2687),
    [anon_sym_long] = ACTIONS(2687),
    [anon_sym_short] = ACTIONS(2687),
    [anon_sym_LBRACK] = ACTIONS(2687),
    [anon_sym_static] = ACTIONS(2687),
    [anon_sym_register] = ACTIONS(2687),
    [anon_sym_inline] = ACTIONS(2687),
    [anon_sym___inline] = ACTIONS(2687),
    [anon_sym___inline__] = ACTIONS(2687),
    [anon_sym___forceinline] = ACTIONS(2687),
    [anon_sym_thread_local] = ACTIONS(2687),
    [anon_sym___thread] = ACTIONS(2687),
    [anon_sym_const] = ACTIONS(2687),
    [anon_sym_constexpr] = ACTIONS(2687),
    [anon_sym_volatile] = ACTIONS(2687),
    [anon_sym_restrict] = ACTIONS(2687),
    [anon_sym___restrict__] = ACTIONS(2687),
    [anon_sym__Atomic] = ACTIONS(2687),
    [anon_sym__Noreturn] = ACTIONS(2687),
    [anon_sym_noreturn] = ACTIONS(2687),
    [anon_sym_mutable] = ACTIONS(2687),
    [anon_sym_constinit] = ACTIONS(2687),
    [anon_sym_consteval] = ACTIONS(2687),
    [anon_sym_PROGMEM] = ACTIONS(2687),
    [aux_sym_primitive_type_token1] = ACTIONS(2687),
    [anon_sym_byte] = ACTIONS(2687),
    [anon_sym_word] = ACTIONS(2687),
    [anon_sym_enum] = ACTIONS(2687),
    [anon_sym_class] = ACTIONS(2687),
    [anon_sym_struct] = ACTIONS(2687),
    [anon_sym_union] = ACTIONS(2687),
    [anon_sym_if] = ACTIONS(2687),
    [anon_sym_else] = ACTIONS(2687),
    [anon_sym_switch] = ACTIONS(2687),
    [anon_sym_case] = ACTIONS(2687),
    [anon_sym_default] = ACTIONS(2687),
    [anon_sym_while] = ACTIONS(2687),
    [anon_sym_do] = ACTIONS(2687),
    [anon_sym_for] = ACTIONS(2687),
    [anon_sym_return] = ACTIONS(2687),
    [anon_sym_break] = ACTIONS(2687),
    [anon_sym_continue] = ACTIONS(2687),
    [anon_sym_goto] = ACTIONS(2687),
    [anon_sym___try] = ACTIONS(2687),
    [anon_sym___leave] = ACTIONS(2687),
    [anon_sym_not] = ACTIONS(2687),
    [anon_sym_compl] = ACTIONS(2687),
    [anon_sym_DASH_DASH] = ACTIONS(2689),
    [anon_sym_PLUS_PLUS] = ACTIONS(2689),
    [anon_sym_sizeof] = ACTIONS(2687),
    [anon_sym___alignof__] = ACTIONS(2687),
    [anon_sym___alignof] = ACTIONS(2687),
    [anon_sym__alignof] = ACTIONS(2687),
    [anon_sym_alignof] = ACTIONS(2687),
    [anon_sym__Alignof] = ACTIONS(2687),
    [anon_sym_offsetof] = ACTIONS(2687),
    [anon_sym__Generic] = ACTIONS(2687),
    [anon_sym_asm] = ACTIONS(2687),
    [anon_sym___asm__] = ACTIONS(2687),
    [aux_sym_number_literal_token1] = ACTIONS(2689),
    [aux_sym_number_literal_token2] = ACTIONS(2687),
    [anon_sym_L_SQUOTE] = ACTIONS(2689),
    [anon_sym_u_SQUOTE] = ACTIONS(2689),
    [anon_sym_U_SQUOTE] = ACTIONS(2689),
    [anon_sym_u8_SQUOTE] = ACTIONS(2689),
    [anon_sym_SQUOTE] = ACTIONS(2689),
    [anon_sym_L_DQUOTE] = ACTIONS(2689),
    [anon_sym_u_DQUOTE] = ACTIONS(2689),
    [anon_sym_U_DQUOTE] = ACTIONS(2689),
    [anon_sym_u8_DQUOTE] = ACTIONS(2689),
    [anon_sym_DQUOTE] = ACTIONS(2689),
    [sym_true] = ACTIONS(2687),
    [sym_false] = ACTIONS(2687),
    [anon_sym_NULL] = ACTIONS(2687),
    [anon_sym_nullptr] = ACTIONS(2687),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2687),
    [anon_sym_decltype] = ACTIONS(2687),
    [anon_sym_virtual] = ACTIONS(2687),
    [anon_sym_alignas] = ACTIONS(2687),
    [anon_sym_explicit] = ACTIONS(2687),
    [anon_sym_typename] = ACTIONS(2687),
    [anon_sym_template] = ACTIONS(2687),
    [anon_sym_operator] = ACTIONS(2687),
    [anon_sym_try] = ACTIONS(2687),
    [anon_sym_delete] = ACTIONS(2687),
    [anon_sym_throw] = ACTIONS(2687),
    [anon_sym_namespace] = ACTIONS(2687),
    [anon_sym_using] = ACTIONS(2687),
    [anon_sym_static_assert] = ACTIONS(2687),
    [anon_sym_concept] = ACTIONS(2687),
    [anon_sym_co_return] = ACTIONS(2687),
    [anon_sym_co_yield] = ACTIONS(2687),
    [anon_sym_R_DQUOTE] = ACTIONS(2689),
    [anon_sym_LR_DQUOTE] = ACTIONS(2689),
    [anon_sym_uR_DQUOTE] = ACTIONS(2689),
    [anon_sym_UR_DQUOTE] = ACTIONS(2689),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2689),
    [anon_sym_co_await] = ACTIONS(2687),
    [anon_sym_new] = ACTIONS(2687),
    [anon_sym_requires] = ACTIONS(2687),
    [sym_this] = ACTIONS(2687),
  },
  [266] = {
    [sym_identifier] = ACTIONS(2691),
    [aux_sym_preproc_include_token1] = ACTIONS(2691),
    [aux_sym_preproc_def_token1] = ACTIONS(2691),
    [aux_sym_preproc_if_token1] = ACTIONS(2691),
    [aux_sym_preproc_if_token2] = ACTIONS(2691),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2691),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2691),
    [aux_sym_preproc_else_token1] = ACTIONS(2691),
    [aux_sym_preproc_elif_token1] = ACTIONS(2691),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2691),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2691),
    [sym_preproc_directive] = ACTIONS(2691),
    [anon_sym_LPAREN2] = ACTIONS(2693),
    [anon_sym_BANG] = ACTIONS(2693),
    [anon_sym_TILDE] = ACTIONS(2693),
    [anon_sym_DASH] = ACTIONS(2691),
    [anon_sym_PLUS] = ACTIONS(2691),
    [anon_sym_STAR] = ACTIONS(2693),
    [anon_sym_AMP_AMP] = ACTIONS(2693),
    [anon_sym_AMP] = ACTIONS(2691),
    [anon_sym_SEMI] = ACTIONS(2693),
    [anon_sym___extension__] = ACTIONS(2691),
    [anon_sym_typedef] = ACTIONS(2691),
    [anon_sym_extern] = ACTIONS(2691),
    [anon_sym___attribute__] = ACTIONS(2691),
    [anon_sym_COLON_COLON] = ACTIONS(2693),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2693),
    [anon_sym___declspec] = ACTIONS(2691),
    [anon_sym___based] = ACTIONS(2691),
    [anon_sym___cdecl] = ACTIONS(2691),
    [anon_sym___clrcall] = ACTIONS(2691),
    [anon_sym___stdcall] = ACTIONS(2691),
    [anon_sym___fastcall] = ACTIONS(2691),
    [anon_sym___thiscall] = ACTIONS(2691),
    [anon_sym___vectorcall] = ACTIONS(2691),
    [anon_sym_LBRACE] = ACTIONS(2693),
    [anon_sym_signed] = ACTIONS(2691),
    [anon_sym_unsigned] = ACTIONS(2691),
    [anon_sym_long] = ACTIONS(2691),
    [anon_sym_short] = ACTIONS(2691),
    [anon_sym_LBRACK] = ACTIONS(2691),
    [anon_sym_static] = ACTIONS(2691),
    [anon_sym_register] = ACTIONS(2691),
    [anon_sym_inline] = ACTIONS(2691),
    [anon_sym___inline] = ACTIONS(2691),
    [anon_sym___inline__] = ACTIONS(2691),
    [anon_sym___forceinline] = ACTIONS(2691),
    [anon_sym_thread_local] = ACTIONS(2691),
    [anon_sym___thread] = ACTIONS(2691),
    [anon_sym_const] = ACTIONS(2691),
    [anon_sym_constexpr] = ACTIONS(2691),
    [anon_sym_volatile] = ACTIONS(2691),
    [anon_sym_restrict] = ACTIONS(2691),
    [anon_sym___restrict__] = ACTIONS(2691),
    [anon_sym__Atomic] = ACTIONS(2691),
    [anon_sym__Noreturn] = ACTIONS(2691),
    [anon_sym_noreturn] = ACTIONS(2691),
    [anon_sym_mutable] = ACTIONS(2691),
    [anon_sym_constinit] = ACTIONS(2691),
    [anon_sym_consteval] = ACTIONS(2691),
    [anon_sym_PROGMEM] = ACTIONS(2691),
    [aux_sym_primitive_type_token1] = ACTIONS(2691),
    [anon_sym_byte] = ACTIONS(2691),
    [anon_sym_word] = ACTIONS(2691),
    [anon_sym_enum] = ACTIONS(2691),
    [anon_sym_class] = ACTIONS(2691),
    [anon_sym_struct] = ACTIONS(2691),
    [anon_sym_union] = ACTIONS(2691),
    [anon_sym_if] = ACTIONS(2691),
    [anon_sym_else] = ACTIONS(2691),
    [anon_sym_switch] = ACTIONS(2691),
    [anon_sym_case] = ACTIONS(2691),
    [anon_sym_default] = ACTIONS(2691),
    [anon_sym_while] = ACTIONS(2691),
    [anon_sym_do] = ACTIONS(2691),
    [anon_sym_for] = ACTIONS(2691),
    [anon_sym_return] = ACTIONS(2691),
    [anon_sym_break] = ACTIONS(2691),
    [anon_sym_continue] = ACTIONS(2691),
    [anon_sym_goto] = ACTIONS(2691),
    [anon_sym___try] = ACTIONS(2691),
    [anon_sym___leave] = ACTIONS(2691),
    [anon_sym_not] = ACTIONS(2691),
    [anon_sym_compl] = ACTIONS(2691),
    [anon_sym_DASH_DASH] = ACTIONS(2693),
    [anon_sym_PLUS_PLUS] = ACTIONS(2693),
    [anon_sym_sizeof] = ACTIONS(2691),
    [anon_sym___alignof__] = ACTIONS(2691),
    [anon_sym___alignof] = ACTIONS(2691),
    [anon_sym__alignof] = ACTIONS(2691),
    [anon_sym_alignof] = ACTIONS(2691),
    [anon_sym__Alignof] = ACTIONS(2691),
    [anon_sym_offsetof] = ACTIONS(2691),
    [anon_sym__Generic] = ACTIONS(2691),
    [anon_sym_asm] = ACTIONS(2691),
    [anon_sym___asm__] = ACTIONS(2691),
    [aux_sym_number_literal_token1] = ACTIONS(2693),
    [aux_sym_number_literal_token2] = ACTIONS(2691),
    [anon_sym_L_SQUOTE] = ACTIONS(2693),
    [anon_sym_u_SQUOTE] = ACTIONS(2693),
    [anon_sym_U_SQUOTE] = ACTIONS(2693),
    [anon_sym_u8_SQUOTE] = ACTIONS(2693),
    [anon_sym_SQUOTE] = ACTIONS(2693),
    [anon_sym_L_DQUOTE] = ACTIONS(2693),
    [anon_sym_u_DQUOTE] = ACTIONS(2693),
    [anon_sym_U_DQUOTE] = ACTIONS(2693),
    [anon_sym_u8_DQUOTE] = ACTIONS(2693),
    [anon_sym_DQUOTE] = ACTIONS(2693),
    [sym_true] = ACTIONS(2691),
    [sym_false] = ACTIONS(2691),
    [anon_sym_NULL] = ACTIONS(2691),
    [anon_sym_nullptr] = ACTIONS(2691),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2691),
    [anon_sym_decltype] = ACTIONS(2691),
    [anon_sym_virtual] = ACTIONS(2691),
    [anon_sym_alignas] = ACTIONS(2691),
    [anon_sym_explicit] = ACTIONS(2691),
    [anon_sym_typename] = ACTIONS(2691),
    [anon_sym_template] = ACTIONS(2691),
    [anon_sym_operator] = ACTIONS(2691),
    [anon_sym_try] = ACTIONS(2691),
    [anon_sym_delete] = ACTIONS(2691),
    [anon_sym_throw] = ACTIONS(2691),
    [anon_sym_namespace] = ACTIONS(2691),
    [anon_sym_using] = ACTIONS(2691),
    [anon_sym_static_assert] = ACTIONS(2691),
    [anon_sym_concept] = ACTIONS(2691),
    [anon_sym_co_return] = ACTIONS(2691),
    [anon_sym_co_yield] = ACTIONS(2691),
    [anon_sym_R_DQUOTE] = ACTIONS(2693),
    [anon_sym_LR_DQUOTE] = ACTIONS(2693),
    [anon_sym_uR_DQUOTE] = ACTIONS(2693),
    [anon_sym_UR_DQUOTE] = ACTIONS(2693),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2693),
    [anon_sym_co_await] = ACTIONS(2691),
    [anon_sym_new] = ACTIONS(2691),
    [anon_sym_requires] = ACTIONS(2691),
    [sym_this] = ACTIONS(2691),
  },
  [267] = {
    [sym_identifier] = ACTIONS(2695),
    [aux_sym_preproc_include_token1] = ACTIONS(2695),
    [aux_sym_preproc_def_token1] = ACTIONS(2695),
    [aux_sym_preproc_if_token1] = ACTIONS(2695),
    [aux_sym_preproc_if_token2] = ACTIONS(2695),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2695),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2695),
    [aux_sym_preproc_else_token1] = ACTIONS(2695),
    [aux_sym_preproc_elif_token1] = ACTIONS(2695),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2695),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2695),
    [sym_preproc_directive] = ACTIONS(2695),
    [anon_sym_LPAREN2] = ACTIONS(2697),
    [anon_sym_BANG] = ACTIONS(2697),
    [anon_sym_TILDE] = ACTIONS(2697),
    [anon_sym_DASH] = ACTIONS(2695),
    [anon_sym_PLUS] = ACTIONS(2695),
    [anon_sym_STAR] = ACTIONS(2697),
    [anon_sym_AMP_AMP] = ACTIONS(2697),
    [anon_sym_AMP] = ACTIONS(2695),
    [anon_sym_SEMI] = ACTIONS(2697),
    [anon_sym___extension__] = ACTIONS(2695),
    [anon_sym_typedef] = ACTIONS(2695),
    [anon_sym_extern] = ACTIONS(2695),
    [anon_sym___attribute__] = ACTIONS(2695),
    [anon_sym_COLON_COLON] = ACTIONS(2697),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2697),
    [anon_sym___declspec] = ACTIONS(2695),
    [anon_sym___based] = ACTIONS(2695),
    [anon_sym___cdecl] = ACTIONS(2695),
    [anon_sym___clrcall] = ACTIONS(2695),
    [anon_sym___stdcall] = ACTIONS(2695),
    [anon_sym___fastcall] = ACTIONS(2695),
    [anon_sym___thiscall] = ACTIONS(2695),
    [anon_sym___vectorcall] = ACTIONS(2695),
    [anon_sym_LBRACE] = ACTIONS(2697),
    [anon_sym_signed] = ACTIONS(2695),
    [anon_sym_unsigned] = ACTIONS(2695),
    [anon_sym_long] = ACTIONS(2695),
    [anon_sym_short] = ACTIONS(2695),
    [anon_sym_LBRACK] = ACTIONS(2695),
    [anon_sym_static] = ACTIONS(2695),
    [anon_sym_register] = ACTIONS(2695),
    [anon_sym_inline] = ACTIONS(2695),
    [anon_sym___inline] = ACTIONS(2695),
    [anon_sym___inline__] = ACTIONS(2695),
    [anon_sym___forceinline] = ACTIONS(2695),
    [anon_sym_thread_local] = ACTIONS(2695),
    [anon_sym___thread] = ACTIONS(2695),
    [anon_sym_const] = ACTIONS(2695),
    [anon_sym_constexpr] = ACTIONS(2695),
    [anon_sym_volatile] = ACTIONS(2695),
    [anon_sym_restrict] = ACTIONS(2695),
    [anon_sym___restrict__] = ACTIONS(2695),
    [anon_sym__Atomic] = ACTIONS(2695),
    [anon_sym__Noreturn] = ACTIONS(2695),
    [anon_sym_noreturn] = ACTIONS(2695),
    [anon_sym_mutable] = ACTIONS(2695),
    [anon_sym_constinit] = ACTIONS(2695),
    [anon_sym_consteval] = ACTIONS(2695),
    [anon_sym_PROGMEM] = ACTIONS(2695),
    [aux_sym_primitive_type_token1] = ACTIONS(2695),
    [anon_sym_byte] = ACTIONS(2695),
    [anon_sym_word] = ACTIONS(2695),
    [anon_sym_enum] = ACTIONS(2695),
    [anon_sym_class] = ACTIONS(2695),
    [anon_sym_struct] = ACTIONS(2695),
    [anon_sym_union] = ACTIONS(2695),
    [anon_sym_if] = ACTIONS(2695),
    [anon_sym_else] = ACTIONS(2695),
    [anon_sym_switch] = ACTIONS(2695),
    [anon_sym_case] = ACTIONS(2695),
    [anon_sym_default] = ACTIONS(2695),
    [anon_sym_while] = ACTIONS(2695),
    [anon_sym_do] = ACTIONS(2695),
    [anon_sym_for] = ACTIONS(2695),
    [anon_sym_return] = ACTIONS(2695),
    [anon_sym_break] = ACTIONS(2695),
    [anon_sym_continue] = ACTIONS(2695),
    [anon_sym_goto] = ACTIONS(2695),
    [anon_sym___try] = ACTIONS(2695),
    [anon_sym___leave] = ACTIONS(2695),
    [anon_sym_not] = ACTIONS(2695),
    [anon_sym_compl] = ACTIONS(2695),
    [anon_sym_DASH_DASH] = ACTIONS(2697),
    [anon_sym_PLUS_PLUS] = ACTIONS(2697),
    [anon_sym_sizeof] = ACTIONS(2695),
    [anon_sym___alignof__] = ACTIONS(2695),
    [anon_sym___alignof] = ACTIONS(2695),
    [anon_sym__alignof] = ACTIONS(2695),
    [anon_sym_alignof] = ACTIONS(2695),
    [anon_sym__Alignof] = ACTIONS(2695),
    [anon_sym_offsetof] = ACTIONS(2695),
    [anon_sym__Generic] = ACTIONS(2695),
    [anon_sym_asm] = ACTIONS(2695),
    [anon_sym___asm__] = ACTIONS(2695),
    [aux_sym_number_literal_token1] = ACTIONS(2697),
    [aux_sym_number_literal_token2] = ACTIONS(2695),
    [anon_sym_L_SQUOTE] = ACTIONS(2697),
    [anon_sym_u_SQUOTE] = ACTIONS(2697),
    [anon_sym_U_SQUOTE] = ACTIONS(2697),
    [anon_sym_u8_SQUOTE] = ACTIONS(2697),
    [anon_sym_SQUOTE] = ACTIONS(2697),
    [anon_sym_L_DQUOTE] = ACTIONS(2697),
    [anon_sym_u_DQUOTE] = ACTIONS(2697),
    [anon_sym_U_DQUOTE] = ACTIONS(2697),
    [anon_sym_u8_DQUOTE] = ACTIONS(2697),
    [anon_sym_DQUOTE] = ACTIONS(2697),
    [sym_true] = ACTIONS(2695),
    [sym_false] = ACTIONS(2695),
    [anon_sym_NULL] = ACTIONS(2695),
    [anon_sym_nullptr] = ACTIONS(2695),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2695),
    [anon_sym_decltype] = ACTIONS(2695),
    [anon_sym_virtual] = ACTIONS(2695),
    [anon_sym_alignas] = ACTIONS(2695),
    [anon_sym_explicit] = ACTIONS(2695),
    [anon_sym_typename] = ACTIONS(2695),
    [anon_sym_template] = ACTIONS(2695),
    [anon_sym_operator] = ACTIONS(2695),
    [anon_sym_try] = ACTIONS(2695),
    [anon_sym_delete] = ACTIONS(2695),
    [anon_sym_throw] = ACTIONS(2695),
    [anon_sym_namespace] = ACTIONS(2695),
    [anon_sym_using] = ACTIONS(2695),
    [anon_sym_static_assert] = ACTIONS(2695),
    [anon_sym_concept] = ACTIONS(2695),
    [anon_sym_co_return] = ACTIONS(2695),
    [anon_sym_co_yield] = ACTIONS(2695),
    [anon_sym_R_DQUOTE] = ACTIONS(2697),
    [anon_sym_LR_DQUOTE] = ACTIONS(2697),
    [anon_sym_uR_DQUOTE] = ACTIONS(2697),
    [anon_sym_UR_DQUOTE] = ACTIONS(2697),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2697),
    [anon_sym_co_await] = ACTIONS(2695),
    [anon_sym_new] = ACTIONS(2695),
    [anon_sym_requires] = ACTIONS(2695),
    [sym_this] = ACTIONS(2695),
  },
  [268] = {
    [sym_type_qualifier] = STATE(3799),
    [sym__type_specifier] = STATE(4801),
    [sym_sized_type_specifier] = STATE(2935),
    [sym_primitive_type] = STATE(4963),
    [sym_enum_specifier] = STATE(2935),
    [sym_struct_specifier] = STATE(2935),
    [sym_union_specifier] = STATE(2935),
    [sym__expression] = STATE(4303),
    [sym__expression_not_binary] = STATE(4648),
    [sym__string] = STATE(4648),
    [sym_conditional_expression] = STATE(4648),
    [sym_assignment_expression] = STATE(4648),
    [sym_pointer_expression] = STATE(3663),
    [sym_unary_expression] = STATE(4648),
    [sym_binary_expression] = STATE(4648),
    [sym_update_expression] = STATE(4648),
    [sym_cast_expression] = STATE(4648),
    [sym_type_descriptor] = STATE(6739),
    [sym_sizeof_expression] = STATE(4648),
    [sym_alignof_expression] = STATE(4648),
    [sym_offsetof_expression] = STATE(4648),
    [sym_generic_expression] = STATE(4648),
    [sym_subscript_expression] = STATE(3663),
    [sym_call_expression] = STATE(3663),
    [sym_gnu_asm_expression] = STATE(4648),
    [sym_field_expression] = STATE(3663),
    [sym_compound_literal_expression] = STATE(4648),
    [sym_parenthesized_expression] = STATE(3663),
    [sym_number_literal] = STATE(4573),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4565),
    [sym_string_literal] = STATE(3707),
    [sym_null] = STATE(4648),
    [sym_placeholder_type_specifier] = STATE(2935),
    [sym_decltype_auto] = STATE(2933),
    [sym_decltype] = STATE(2868),
    [sym_class_specifier] = STATE(2935),
    [sym__class_name] = STATE(7442),
    [sym_dependent_type] = STATE(2935),
    [sym_template_type] = STATE(5228),
    [sym_template_function] = STATE(4648),
    [sym_raw_string_literal] = STATE(3709),
    [sym_co_await_expression] = STATE(4648),
    [sym_new_expression] = STATE(4648),
    [sym_delete_expression] = STATE(4648),
    [sym_requires_clause] = STATE(4648),
    [sym_requires_expression] = STATE(4648),
    [sym_lambda_expression] = STATE(4648),
    [sym_lambda_capture_specifier] = STATE(5768),
    [sym_fold_expression] = STATE(4648),
    [sym_parameter_pack_expansion] = STATE(4648),
    [sym_type_parameter_pack_expansion] = STATE(7071),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5541),
    [sym_qualified_identifier] = STATE(3663),
    [sym_qualified_type_identifier] = STATE(5253),
    [sym_user_defined_literal] = STATE(3663),
    [aux_sym__type_definition_type_repeat1] = STATE(3799),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2164),
    [sym_identifier] = ACTIONS(2573),
    [anon_sym_LPAREN2] = ACTIONS(2575),
    [anon_sym_BANG] = ACTIONS(2577),
    [anon_sym_TILDE] = ACTIONS(2577),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2583),
    [anon_sym_signed] = ACTIONS(2585),
    [anon_sym_unsigned] = ACTIONS(2585),
    [anon_sym_long] = ACTIONS(2585),
    [anon_sym_short] = ACTIONS(2585),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2587),
    [anon_sym_byte] = ACTIONS(2587),
    [anon_sym_word] = ACTIONS(2587),
    [anon_sym_enum] = ACTIONS(2589),
    [anon_sym_class] = ACTIONS(2591),
    [anon_sym_struct] = ACTIONS(2593),
    [anon_sym_union] = ACTIONS(2595),
    [anon_sym_not] = ACTIONS(2579),
    [anon_sym_compl] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(2597),
    [anon_sym_PLUS_PLUS] = ACTIONS(2597),
    [anon_sym_sizeof] = ACTIONS(2599),
    [anon_sym___alignof__] = ACTIONS(2601),
    [anon_sym___alignof] = ACTIONS(2601),
    [anon_sym__alignof] = ACTIONS(2601),
    [anon_sym_alignof] = ACTIONS(2601),
    [anon_sym__Alignof] = ACTIONS(2601),
    [anon_sym_offsetof] = ACTIONS(2603),
    [anon_sym__Generic] = ACTIONS(2605),
    [anon_sym_asm] = ACTIONS(2607),
    [anon_sym___asm__] = ACTIONS(2607),
    [aux_sym_number_literal_token1] = ACTIONS(2609),
    [aux_sym_number_literal_token2] = ACTIONS(2611),
    [anon_sym_L_SQUOTE] = ACTIONS(2613),
    [anon_sym_u_SQUOTE] = ACTIONS(2613),
    [anon_sym_U_SQUOTE] = ACTIONS(2613),
    [anon_sym_u8_SQUOTE] = ACTIONS(2613),
    [anon_sym_SQUOTE] = ACTIONS(2613),
    [anon_sym_L_DQUOTE] = ACTIONS(2615),
    [anon_sym_u_DQUOTE] = ACTIONS(2615),
    [anon_sym_U_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8_DQUOTE] = ACTIONS(2615),
    [anon_sym_DQUOTE] = ACTIONS(2615),
    [sym_true] = ACTIONS(2617),
    [sym_false] = ACTIONS(2617),
    [anon_sym_NULL] = ACTIONS(2619),
    [anon_sym_nullptr] = ACTIONS(2619),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2621),
    [anon_sym_decltype] = ACTIONS(2623),
    [anon_sym_typename] = ACTIONS(2625),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_GT2] = ACTIONS(2699),
    [anon_sym_delete] = ACTIONS(2629),
    [anon_sym_R_DQUOTE] = ACTIONS(2631),
    [anon_sym_LR_DQUOTE] = ACTIONS(2631),
    [anon_sym_uR_DQUOTE] = ACTIONS(2631),
    [anon_sym_UR_DQUOTE] = ACTIONS(2631),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2631),
    [anon_sym_co_await] = ACTIONS(2633),
    [anon_sym_new] = ACTIONS(2635),
    [anon_sym_requires] = ACTIONS(2637),
    [sym_this] = ACTIONS(2617),
  },
  [269] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token2] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [aux_sym_preproc_else_token1] = ACTIONS(2679),
    [aux_sym_preproc_elif_token1] = ACTIONS(2679),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [270] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token2] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [aux_sym_preproc_else_token1] = ACTIONS(2679),
    [aux_sym_preproc_elif_token1] = ACTIONS(2679),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [271] = {
    [sym_identifier] = ACTIONS(2701),
    [aux_sym_preproc_include_token1] = ACTIONS(2701),
    [aux_sym_preproc_def_token1] = ACTIONS(2701),
    [aux_sym_preproc_if_token1] = ACTIONS(2701),
    [aux_sym_preproc_if_token2] = ACTIONS(2701),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2701),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2701),
    [aux_sym_preproc_else_token1] = ACTIONS(2701),
    [aux_sym_preproc_elif_token1] = ACTIONS(2701),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2701),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2701),
    [sym_preproc_directive] = ACTIONS(2701),
    [anon_sym_LPAREN2] = ACTIONS(2703),
    [anon_sym_BANG] = ACTIONS(2703),
    [anon_sym_TILDE] = ACTIONS(2703),
    [anon_sym_DASH] = ACTIONS(2701),
    [anon_sym_PLUS] = ACTIONS(2701),
    [anon_sym_STAR] = ACTIONS(2703),
    [anon_sym_AMP_AMP] = ACTIONS(2703),
    [anon_sym_AMP] = ACTIONS(2701),
    [anon_sym_SEMI] = ACTIONS(2703),
    [anon_sym___extension__] = ACTIONS(2701),
    [anon_sym_typedef] = ACTIONS(2701),
    [anon_sym_extern] = ACTIONS(2701),
    [anon_sym___attribute__] = ACTIONS(2701),
    [anon_sym_COLON_COLON] = ACTIONS(2703),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2703),
    [anon_sym___declspec] = ACTIONS(2701),
    [anon_sym___based] = ACTIONS(2701),
    [anon_sym___cdecl] = ACTIONS(2701),
    [anon_sym___clrcall] = ACTIONS(2701),
    [anon_sym___stdcall] = ACTIONS(2701),
    [anon_sym___fastcall] = ACTIONS(2701),
    [anon_sym___thiscall] = ACTIONS(2701),
    [anon_sym___vectorcall] = ACTIONS(2701),
    [anon_sym_LBRACE] = ACTIONS(2703),
    [anon_sym_signed] = ACTIONS(2701),
    [anon_sym_unsigned] = ACTIONS(2701),
    [anon_sym_long] = ACTIONS(2701),
    [anon_sym_short] = ACTIONS(2701),
    [anon_sym_LBRACK] = ACTIONS(2701),
    [anon_sym_static] = ACTIONS(2701),
    [anon_sym_register] = ACTIONS(2701),
    [anon_sym_inline] = ACTIONS(2701),
    [anon_sym___inline] = ACTIONS(2701),
    [anon_sym___inline__] = ACTIONS(2701),
    [anon_sym___forceinline] = ACTIONS(2701),
    [anon_sym_thread_local] = ACTIONS(2701),
    [anon_sym___thread] = ACTIONS(2701),
    [anon_sym_const] = ACTIONS(2701),
    [anon_sym_constexpr] = ACTIONS(2701),
    [anon_sym_volatile] = ACTIONS(2701),
    [anon_sym_restrict] = ACTIONS(2701),
    [anon_sym___restrict__] = ACTIONS(2701),
    [anon_sym__Atomic] = ACTIONS(2701),
    [anon_sym__Noreturn] = ACTIONS(2701),
    [anon_sym_noreturn] = ACTIONS(2701),
    [anon_sym_mutable] = ACTIONS(2701),
    [anon_sym_constinit] = ACTIONS(2701),
    [anon_sym_consteval] = ACTIONS(2701),
    [anon_sym_PROGMEM] = ACTIONS(2701),
    [aux_sym_primitive_type_token1] = ACTIONS(2701),
    [anon_sym_byte] = ACTIONS(2701),
    [anon_sym_word] = ACTIONS(2701),
    [anon_sym_enum] = ACTIONS(2701),
    [anon_sym_class] = ACTIONS(2701),
    [anon_sym_struct] = ACTIONS(2701),
    [anon_sym_union] = ACTIONS(2701),
    [anon_sym_if] = ACTIONS(2701),
    [anon_sym_else] = ACTIONS(2701),
    [anon_sym_switch] = ACTIONS(2701),
    [anon_sym_case] = ACTIONS(2701),
    [anon_sym_default] = ACTIONS(2701),
    [anon_sym_while] = ACTIONS(2701),
    [anon_sym_do] = ACTIONS(2701),
    [anon_sym_for] = ACTIONS(2701),
    [anon_sym_return] = ACTIONS(2701),
    [anon_sym_break] = ACTIONS(2701),
    [anon_sym_continue] = ACTIONS(2701),
    [anon_sym_goto] = ACTIONS(2701),
    [anon_sym___try] = ACTIONS(2701),
    [anon_sym___leave] = ACTIONS(2701),
    [anon_sym_not] = ACTIONS(2701),
    [anon_sym_compl] = ACTIONS(2701),
    [anon_sym_DASH_DASH] = ACTIONS(2703),
    [anon_sym_PLUS_PLUS] = ACTIONS(2703),
    [anon_sym_sizeof] = ACTIONS(2701),
    [anon_sym___alignof__] = ACTIONS(2701),
    [anon_sym___alignof] = ACTIONS(2701),
    [anon_sym__alignof] = ACTIONS(2701),
    [anon_sym_alignof] = ACTIONS(2701),
    [anon_sym__Alignof] = ACTIONS(2701),
    [anon_sym_offsetof] = ACTIONS(2701),
    [anon_sym__Generic] = ACTIONS(2701),
    [anon_sym_asm] = ACTIONS(2701),
    [anon_sym___asm__] = ACTIONS(2701),
    [aux_sym_number_literal_token1] = ACTIONS(2703),
    [aux_sym_number_literal_token2] = ACTIONS(2701),
    [anon_sym_L_SQUOTE] = ACTIONS(2703),
    [anon_sym_u_SQUOTE] = ACTIONS(2703),
    [anon_sym_U_SQUOTE] = ACTIONS(2703),
    [anon_sym_u8_SQUOTE] = ACTIONS(2703),
    [anon_sym_SQUOTE] = ACTIONS(2703),
    [anon_sym_L_DQUOTE] = ACTIONS(2703),
    [anon_sym_u_DQUOTE] = ACTIONS(2703),
    [anon_sym_U_DQUOTE] = ACTIONS(2703),
    [anon_sym_u8_DQUOTE] = ACTIONS(2703),
    [anon_sym_DQUOTE] = ACTIONS(2703),
    [sym_true] = ACTIONS(2701),
    [sym_false] = ACTIONS(2701),
    [anon_sym_NULL] = ACTIONS(2701),
    [anon_sym_nullptr] = ACTIONS(2701),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2701),
    [anon_sym_decltype] = ACTIONS(2701),
    [anon_sym_virtual] = ACTIONS(2701),
    [anon_sym_alignas] = ACTIONS(2701),
    [anon_sym_explicit] = ACTIONS(2701),
    [anon_sym_typename] = ACTIONS(2701),
    [anon_sym_template] = ACTIONS(2701),
    [anon_sym_operator] = ACTIONS(2701),
    [anon_sym_try] = ACTIONS(2701),
    [anon_sym_delete] = ACTIONS(2701),
    [anon_sym_throw] = ACTIONS(2701),
    [anon_sym_namespace] = ACTIONS(2701),
    [anon_sym_using] = ACTIONS(2701),
    [anon_sym_static_assert] = ACTIONS(2701),
    [anon_sym_concept] = ACTIONS(2701),
    [anon_sym_co_return] = ACTIONS(2701),
    [anon_sym_co_yield] = ACTIONS(2701),
    [anon_sym_R_DQUOTE] = ACTIONS(2703),
    [anon_sym_LR_DQUOTE] = ACTIONS(2703),
    [anon_sym_uR_DQUOTE] = ACTIONS(2703),
    [anon_sym_UR_DQUOTE] = ACTIONS(2703),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2703),
    [anon_sym_co_await] = ACTIONS(2701),
    [anon_sym_new] = ACTIONS(2701),
    [anon_sym_requires] = ACTIONS(2701),
    [sym_this] = ACTIONS(2701),
  },
  [272] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token2] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [aux_sym_preproc_else_token1] = ACTIONS(2679),
    [aux_sym_preproc_elif_token1] = ACTIONS(2679),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [273] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token2] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [aux_sym_preproc_else_token1] = ACTIONS(2679),
    [aux_sym_preproc_elif_token1] = ACTIONS(2679),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [274] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token2] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [aux_sym_preproc_else_token1] = ACTIONS(2679),
    [aux_sym_preproc_elif_token1] = ACTIONS(2679),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [275] = {
    [sym_identifier] = ACTIONS(2705),
    [aux_sym_preproc_include_token1] = ACTIONS(2705),
    [aux_sym_preproc_def_token1] = ACTIONS(2705),
    [aux_sym_preproc_if_token1] = ACTIONS(2705),
    [aux_sym_preproc_if_token2] = ACTIONS(2705),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2705),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2705),
    [aux_sym_preproc_else_token1] = ACTIONS(2705),
    [aux_sym_preproc_elif_token1] = ACTIONS(2705),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2705),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2705),
    [sym_preproc_directive] = ACTIONS(2705),
    [anon_sym_LPAREN2] = ACTIONS(2707),
    [anon_sym_BANG] = ACTIONS(2707),
    [anon_sym_TILDE] = ACTIONS(2707),
    [anon_sym_DASH] = ACTIONS(2705),
    [anon_sym_PLUS] = ACTIONS(2705),
    [anon_sym_STAR] = ACTIONS(2707),
    [anon_sym_AMP_AMP] = ACTIONS(2707),
    [anon_sym_AMP] = ACTIONS(2705),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym___extension__] = ACTIONS(2705),
    [anon_sym_typedef] = ACTIONS(2705),
    [anon_sym_extern] = ACTIONS(2705),
    [anon_sym___attribute__] = ACTIONS(2705),
    [anon_sym_COLON_COLON] = ACTIONS(2707),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2707),
    [anon_sym___declspec] = ACTIONS(2705),
    [anon_sym___based] = ACTIONS(2705),
    [anon_sym___cdecl] = ACTIONS(2705),
    [anon_sym___clrcall] = ACTIONS(2705),
    [anon_sym___stdcall] = ACTIONS(2705),
    [anon_sym___fastcall] = ACTIONS(2705),
    [anon_sym___thiscall] = ACTIONS(2705),
    [anon_sym___vectorcall] = ACTIONS(2705),
    [anon_sym_LBRACE] = ACTIONS(2707),
    [anon_sym_signed] = ACTIONS(2705),
    [anon_sym_unsigned] = ACTIONS(2705),
    [anon_sym_long] = ACTIONS(2705),
    [anon_sym_short] = ACTIONS(2705),
    [anon_sym_LBRACK] = ACTIONS(2705),
    [anon_sym_static] = ACTIONS(2705),
    [anon_sym_register] = ACTIONS(2705),
    [anon_sym_inline] = ACTIONS(2705),
    [anon_sym___inline] = ACTIONS(2705),
    [anon_sym___inline__] = ACTIONS(2705),
    [anon_sym___forceinline] = ACTIONS(2705),
    [anon_sym_thread_local] = ACTIONS(2705),
    [anon_sym___thread] = ACTIONS(2705),
    [anon_sym_const] = ACTIONS(2705),
    [anon_sym_constexpr] = ACTIONS(2705),
    [anon_sym_volatile] = ACTIONS(2705),
    [anon_sym_restrict] = ACTIONS(2705),
    [anon_sym___restrict__] = ACTIONS(2705),
    [anon_sym__Atomic] = ACTIONS(2705),
    [anon_sym__Noreturn] = ACTIONS(2705),
    [anon_sym_noreturn] = ACTIONS(2705),
    [anon_sym_mutable] = ACTIONS(2705),
    [anon_sym_constinit] = ACTIONS(2705),
    [anon_sym_consteval] = ACTIONS(2705),
    [anon_sym_PROGMEM] = ACTIONS(2705),
    [aux_sym_primitive_type_token1] = ACTIONS(2705),
    [anon_sym_byte] = ACTIONS(2705),
    [anon_sym_word] = ACTIONS(2705),
    [anon_sym_enum] = ACTIONS(2705),
    [anon_sym_class] = ACTIONS(2705),
    [anon_sym_struct] = ACTIONS(2705),
    [anon_sym_union] = ACTIONS(2705),
    [anon_sym_if] = ACTIONS(2705),
    [anon_sym_else] = ACTIONS(2705),
    [anon_sym_switch] = ACTIONS(2705),
    [anon_sym_case] = ACTIONS(2705),
    [anon_sym_default] = ACTIONS(2705),
    [anon_sym_while] = ACTIONS(2705),
    [anon_sym_do] = ACTIONS(2705),
    [anon_sym_for] = ACTIONS(2705),
    [anon_sym_return] = ACTIONS(2705),
    [anon_sym_break] = ACTIONS(2705),
    [anon_sym_continue] = ACTIONS(2705),
    [anon_sym_goto] = ACTIONS(2705),
    [anon_sym___try] = ACTIONS(2705),
    [anon_sym___leave] = ACTIONS(2705),
    [anon_sym_not] = ACTIONS(2705),
    [anon_sym_compl] = ACTIONS(2705),
    [anon_sym_DASH_DASH] = ACTIONS(2707),
    [anon_sym_PLUS_PLUS] = ACTIONS(2707),
    [anon_sym_sizeof] = ACTIONS(2705),
    [anon_sym___alignof__] = ACTIONS(2705),
    [anon_sym___alignof] = ACTIONS(2705),
    [anon_sym__alignof] = ACTIONS(2705),
    [anon_sym_alignof] = ACTIONS(2705),
    [anon_sym__Alignof] = ACTIONS(2705),
    [anon_sym_offsetof] = ACTIONS(2705),
    [anon_sym__Generic] = ACTIONS(2705),
    [anon_sym_asm] = ACTIONS(2705),
    [anon_sym___asm__] = ACTIONS(2705),
    [aux_sym_number_literal_token1] = ACTIONS(2707),
    [aux_sym_number_literal_token2] = ACTIONS(2705),
    [anon_sym_L_SQUOTE] = ACTIONS(2707),
    [anon_sym_u_SQUOTE] = ACTIONS(2707),
    [anon_sym_U_SQUOTE] = ACTIONS(2707),
    [anon_sym_u8_SQUOTE] = ACTIONS(2707),
    [anon_sym_SQUOTE] = ACTIONS(2707),
    [anon_sym_L_DQUOTE] = ACTIONS(2707),
    [anon_sym_u_DQUOTE] = ACTIONS(2707),
    [anon_sym_U_DQUOTE] = ACTIONS(2707),
    [anon_sym_u8_DQUOTE] = ACTIONS(2707),
    [anon_sym_DQUOTE] = ACTIONS(2707),
    [sym_true] = ACTIONS(2705),
    [sym_false] = ACTIONS(2705),
    [anon_sym_NULL] = ACTIONS(2705),
    [anon_sym_nullptr] = ACTIONS(2705),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2705),
    [anon_sym_decltype] = ACTIONS(2705),
    [anon_sym_virtual] = ACTIONS(2705),
    [anon_sym_alignas] = ACTIONS(2705),
    [anon_sym_explicit] = ACTIONS(2705),
    [anon_sym_typename] = ACTIONS(2705),
    [anon_sym_template] = ACTIONS(2705),
    [anon_sym_operator] = ACTIONS(2705),
    [anon_sym_try] = ACTIONS(2705),
    [anon_sym_delete] = ACTIONS(2705),
    [anon_sym_throw] = ACTIONS(2705),
    [anon_sym_namespace] = ACTIONS(2705),
    [anon_sym_using] = ACTIONS(2705),
    [anon_sym_static_assert] = ACTIONS(2705),
    [anon_sym_concept] = ACTIONS(2705),
    [anon_sym_co_return] = ACTIONS(2705),
    [anon_sym_co_yield] = ACTIONS(2705),
    [anon_sym_R_DQUOTE] = ACTIONS(2707),
    [anon_sym_LR_DQUOTE] = ACTIONS(2707),
    [anon_sym_uR_DQUOTE] = ACTIONS(2707),
    [anon_sym_UR_DQUOTE] = ACTIONS(2707),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2707),
    [anon_sym_co_await] = ACTIONS(2705),
    [anon_sym_new] = ACTIONS(2705),
    [anon_sym_requires] = ACTIONS(2705),
    [sym_this] = ACTIONS(2705),
  },
  [276] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token2] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [aux_sym_preproc_else_token1] = ACTIONS(2679),
    [aux_sym_preproc_elif_token1] = ACTIONS(2679),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [277] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token2] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [aux_sym_preproc_else_token1] = ACTIONS(2679),
    [aux_sym_preproc_elif_token1] = ACTIONS(2679),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [278] = {
    [sym_identifier] = ACTIONS(2709),
    [aux_sym_preproc_include_token1] = ACTIONS(2709),
    [aux_sym_preproc_def_token1] = ACTIONS(2709),
    [aux_sym_preproc_if_token1] = ACTIONS(2709),
    [aux_sym_preproc_if_token2] = ACTIONS(2709),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2709),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2709),
    [aux_sym_preproc_else_token1] = ACTIONS(2709),
    [aux_sym_preproc_elif_token1] = ACTIONS(2709),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2709),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2709),
    [sym_preproc_directive] = ACTIONS(2709),
    [anon_sym_LPAREN2] = ACTIONS(2711),
    [anon_sym_BANG] = ACTIONS(2711),
    [anon_sym_TILDE] = ACTIONS(2711),
    [anon_sym_DASH] = ACTIONS(2709),
    [anon_sym_PLUS] = ACTIONS(2709),
    [anon_sym_STAR] = ACTIONS(2711),
    [anon_sym_AMP_AMP] = ACTIONS(2711),
    [anon_sym_AMP] = ACTIONS(2709),
    [anon_sym_SEMI] = ACTIONS(2711),
    [anon_sym___extension__] = ACTIONS(2709),
    [anon_sym_typedef] = ACTIONS(2709),
    [anon_sym_extern] = ACTIONS(2709),
    [anon_sym___attribute__] = ACTIONS(2709),
    [anon_sym_COLON_COLON] = ACTIONS(2711),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2711),
    [anon_sym___declspec] = ACTIONS(2709),
    [anon_sym___based] = ACTIONS(2709),
    [anon_sym___cdecl] = ACTIONS(2709),
    [anon_sym___clrcall] = ACTIONS(2709),
    [anon_sym___stdcall] = ACTIONS(2709),
    [anon_sym___fastcall] = ACTIONS(2709),
    [anon_sym___thiscall] = ACTIONS(2709),
    [anon_sym___vectorcall] = ACTIONS(2709),
    [anon_sym_LBRACE] = ACTIONS(2711),
    [anon_sym_signed] = ACTIONS(2709),
    [anon_sym_unsigned] = ACTIONS(2709),
    [anon_sym_long] = ACTIONS(2709),
    [anon_sym_short] = ACTIONS(2709),
    [anon_sym_LBRACK] = ACTIONS(2709),
    [anon_sym_static] = ACTIONS(2709),
    [anon_sym_register] = ACTIONS(2709),
    [anon_sym_inline] = ACTIONS(2709),
    [anon_sym___inline] = ACTIONS(2709),
    [anon_sym___inline__] = ACTIONS(2709),
    [anon_sym___forceinline] = ACTIONS(2709),
    [anon_sym_thread_local] = ACTIONS(2709),
    [anon_sym___thread] = ACTIONS(2709),
    [anon_sym_const] = ACTIONS(2709),
    [anon_sym_constexpr] = ACTIONS(2709),
    [anon_sym_volatile] = ACTIONS(2709),
    [anon_sym_restrict] = ACTIONS(2709),
    [anon_sym___restrict__] = ACTIONS(2709),
    [anon_sym__Atomic] = ACTIONS(2709),
    [anon_sym__Noreturn] = ACTIONS(2709),
    [anon_sym_noreturn] = ACTIONS(2709),
    [anon_sym_mutable] = ACTIONS(2709),
    [anon_sym_constinit] = ACTIONS(2709),
    [anon_sym_consteval] = ACTIONS(2709),
    [anon_sym_PROGMEM] = ACTIONS(2709),
    [aux_sym_primitive_type_token1] = ACTIONS(2709),
    [anon_sym_byte] = ACTIONS(2709),
    [anon_sym_word] = ACTIONS(2709),
    [anon_sym_enum] = ACTIONS(2709),
    [anon_sym_class] = ACTIONS(2709),
    [anon_sym_struct] = ACTIONS(2709),
    [anon_sym_union] = ACTIONS(2709),
    [anon_sym_if] = ACTIONS(2709),
    [anon_sym_else] = ACTIONS(2709),
    [anon_sym_switch] = ACTIONS(2709),
    [anon_sym_case] = ACTIONS(2709),
    [anon_sym_default] = ACTIONS(2709),
    [anon_sym_while] = ACTIONS(2709),
    [anon_sym_do] = ACTIONS(2709),
    [anon_sym_for] = ACTIONS(2709),
    [anon_sym_return] = ACTIONS(2709),
    [anon_sym_break] = ACTIONS(2709),
    [anon_sym_continue] = ACTIONS(2709),
    [anon_sym_goto] = ACTIONS(2709),
    [anon_sym___try] = ACTIONS(2709),
    [anon_sym___leave] = ACTIONS(2709),
    [anon_sym_not] = ACTIONS(2709),
    [anon_sym_compl] = ACTIONS(2709),
    [anon_sym_DASH_DASH] = ACTIONS(2711),
    [anon_sym_PLUS_PLUS] = ACTIONS(2711),
    [anon_sym_sizeof] = ACTIONS(2709),
    [anon_sym___alignof__] = ACTIONS(2709),
    [anon_sym___alignof] = ACTIONS(2709),
    [anon_sym__alignof] = ACTIONS(2709),
    [anon_sym_alignof] = ACTIONS(2709),
    [anon_sym__Alignof] = ACTIONS(2709),
    [anon_sym_offsetof] = ACTIONS(2709),
    [anon_sym__Generic] = ACTIONS(2709),
    [anon_sym_asm] = ACTIONS(2709),
    [anon_sym___asm__] = ACTIONS(2709),
    [aux_sym_number_literal_token1] = ACTIONS(2711),
    [aux_sym_number_literal_token2] = ACTIONS(2709),
    [anon_sym_L_SQUOTE] = ACTIONS(2711),
    [anon_sym_u_SQUOTE] = ACTIONS(2711),
    [anon_sym_U_SQUOTE] = ACTIONS(2711),
    [anon_sym_u8_SQUOTE] = ACTIONS(2711),
    [anon_sym_SQUOTE] = ACTIONS(2711),
    [anon_sym_L_DQUOTE] = ACTIONS(2711),
    [anon_sym_u_DQUOTE] = ACTIONS(2711),
    [anon_sym_U_DQUOTE] = ACTIONS(2711),
    [anon_sym_u8_DQUOTE] = ACTIONS(2711),
    [anon_sym_DQUOTE] = ACTIONS(2711),
    [sym_true] = ACTIONS(2709),
    [sym_false] = ACTIONS(2709),
    [anon_sym_NULL] = ACTIONS(2709),
    [anon_sym_nullptr] = ACTIONS(2709),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2709),
    [anon_sym_decltype] = ACTIONS(2709),
    [anon_sym_virtual] = ACTIONS(2709),
    [anon_sym_alignas] = ACTIONS(2709),
    [anon_sym_explicit] = ACTIONS(2709),
    [anon_sym_typename] = ACTIONS(2709),
    [anon_sym_template] = ACTIONS(2709),
    [anon_sym_operator] = ACTIONS(2709),
    [anon_sym_try] = ACTIONS(2709),
    [anon_sym_delete] = ACTIONS(2709),
    [anon_sym_throw] = ACTIONS(2709),
    [anon_sym_namespace] = ACTIONS(2709),
    [anon_sym_using] = ACTIONS(2709),
    [anon_sym_static_assert] = ACTIONS(2709),
    [anon_sym_concept] = ACTIONS(2709),
    [anon_sym_co_return] = ACTIONS(2709),
    [anon_sym_co_yield] = ACTIONS(2709),
    [anon_sym_R_DQUOTE] = ACTIONS(2711),
    [anon_sym_LR_DQUOTE] = ACTIONS(2711),
    [anon_sym_uR_DQUOTE] = ACTIONS(2711),
    [anon_sym_UR_DQUOTE] = ACTIONS(2711),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2711),
    [anon_sym_co_await] = ACTIONS(2709),
    [anon_sym_new] = ACTIONS(2709),
    [anon_sym_requires] = ACTIONS(2709),
    [sym_this] = ACTIONS(2709),
  },
  [279] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token2] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [aux_sym_preproc_else_token1] = ACTIONS(2679),
    [aux_sym_preproc_elif_token1] = ACTIONS(2679),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [280] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token2] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [aux_sym_preproc_else_token1] = ACTIONS(2679),
    [aux_sym_preproc_elif_token1] = ACTIONS(2679),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [281] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token2] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [aux_sym_preproc_else_token1] = ACTIONS(2679),
    [aux_sym_preproc_elif_token1] = ACTIONS(2679),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [282] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token2] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [aux_sym_preproc_else_token1] = ACTIONS(2679),
    [aux_sym_preproc_elif_token1] = ACTIONS(2679),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [283] = {
    [sym_identifier] = ACTIONS(2713),
    [aux_sym_preproc_include_token1] = ACTIONS(2713),
    [aux_sym_preproc_def_token1] = ACTIONS(2713),
    [aux_sym_preproc_if_token1] = ACTIONS(2713),
    [aux_sym_preproc_if_token2] = ACTIONS(2713),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2713),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2713),
    [aux_sym_preproc_else_token1] = ACTIONS(2713),
    [aux_sym_preproc_elif_token1] = ACTIONS(2713),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2713),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2713),
    [sym_preproc_directive] = ACTIONS(2713),
    [anon_sym_LPAREN2] = ACTIONS(2715),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_DASH] = ACTIONS(2713),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_STAR] = ACTIONS(2715),
    [anon_sym_AMP_AMP] = ACTIONS(2715),
    [anon_sym_AMP] = ACTIONS(2713),
    [anon_sym_SEMI] = ACTIONS(2715),
    [anon_sym___extension__] = ACTIONS(2713),
    [anon_sym_typedef] = ACTIONS(2713),
    [anon_sym_extern] = ACTIONS(2713),
    [anon_sym___attribute__] = ACTIONS(2713),
    [anon_sym_COLON_COLON] = ACTIONS(2715),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2715),
    [anon_sym___declspec] = ACTIONS(2713),
    [anon_sym___based] = ACTIONS(2713),
    [anon_sym___cdecl] = ACTIONS(2713),
    [anon_sym___clrcall] = ACTIONS(2713),
    [anon_sym___stdcall] = ACTIONS(2713),
    [anon_sym___fastcall] = ACTIONS(2713),
    [anon_sym___thiscall] = ACTIONS(2713),
    [anon_sym___vectorcall] = ACTIONS(2713),
    [anon_sym_LBRACE] = ACTIONS(2715),
    [anon_sym_signed] = ACTIONS(2713),
    [anon_sym_unsigned] = ACTIONS(2713),
    [anon_sym_long] = ACTIONS(2713),
    [anon_sym_short] = ACTIONS(2713),
    [anon_sym_LBRACK] = ACTIONS(2713),
    [anon_sym_static] = ACTIONS(2713),
    [anon_sym_register] = ACTIONS(2713),
    [anon_sym_inline] = ACTIONS(2713),
    [anon_sym___inline] = ACTIONS(2713),
    [anon_sym___inline__] = ACTIONS(2713),
    [anon_sym___forceinline] = ACTIONS(2713),
    [anon_sym_thread_local] = ACTIONS(2713),
    [anon_sym___thread] = ACTIONS(2713),
    [anon_sym_const] = ACTIONS(2713),
    [anon_sym_constexpr] = ACTIONS(2713),
    [anon_sym_volatile] = ACTIONS(2713),
    [anon_sym_restrict] = ACTIONS(2713),
    [anon_sym___restrict__] = ACTIONS(2713),
    [anon_sym__Atomic] = ACTIONS(2713),
    [anon_sym__Noreturn] = ACTIONS(2713),
    [anon_sym_noreturn] = ACTIONS(2713),
    [anon_sym_mutable] = ACTIONS(2713),
    [anon_sym_constinit] = ACTIONS(2713),
    [anon_sym_consteval] = ACTIONS(2713),
    [anon_sym_PROGMEM] = ACTIONS(2713),
    [aux_sym_primitive_type_token1] = ACTIONS(2713),
    [anon_sym_byte] = ACTIONS(2713),
    [anon_sym_word] = ACTIONS(2713),
    [anon_sym_enum] = ACTIONS(2713),
    [anon_sym_class] = ACTIONS(2713),
    [anon_sym_struct] = ACTIONS(2713),
    [anon_sym_union] = ACTIONS(2713),
    [anon_sym_if] = ACTIONS(2713),
    [anon_sym_else] = ACTIONS(2713),
    [anon_sym_switch] = ACTIONS(2713),
    [anon_sym_case] = ACTIONS(2713),
    [anon_sym_default] = ACTIONS(2713),
    [anon_sym_while] = ACTIONS(2713),
    [anon_sym_do] = ACTIONS(2713),
    [anon_sym_for] = ACTIONS(2713),
    [anon_sym_return] = ACTIONS(2713),
    [anon_sym_break] = ACTIONS(2713),
    [anon_sym_continue] = ACTIONS(2713),
    [anon_sym_goto] = ACTIONS(2713),
    [anon_sym___try] = ACTIONS(2713),
    [anon_sym___leave] = ACTIONS(2713),
    [anon_sym_not] = ACTIONS(2713),
    [anon_sym_compl] = ACTIONS(2713),
    [anon_sym_DASH_DASH] = ACTIONS(2715),
    [anon_sym_PLUS_PLUS] = ACTIONS(2715),
    [anon_sym_sizeof] = ACTIONS(2713),
    [anon_sym___alignof__] = ACTIONS(2713),
    [anon_sym___alignof] = ACTIONS(2713),
    [anon_sym__alignof] = ACTIONS(2713),
    [anon_sym_alignof] = ACTIONS(2713),
    [anon_sym__Alignof] = ACTIONS(2713),
    [anon_sym_offsetof] = ACTIONS(2713),
    [anon_sym__Generic] = ACTIONS(2713),
    [anon_sym_asm] = ACTIONS(2713),
    [anon_sym___asm__] = ACTIONS(2713),
    [aux_sym_number_literal_token1] = ACTIONS(2715),
    [aux_sym_number_literal_token2] = ACTIONS(2713),
    [anon_sym_L_SQUOTE] = ACTIONS(2715),
    [anon_sym_u_SQUOTE] = ACTIONS(2715),
    [anon_sym_U_SQUOTE] = ACTIONS(2715),
    [anon_sym_u8_SQUOTE] = ACTIONS(2715),
    [anon_sym_SQUOTE] = ACTIONS(2715),
    [anon_sym_L_DQUOTE] = ACTIONS(2715),
    [anon_sym_u_DQUOTE] = ACTIONS(2715),
    [anon_sym_U_DQUOTE] = ACTIONS(2715),
    [anon_sym_u8_DQUOTE] = ACTIONS(2715),
    [anon_sym_DQUOTE] = ACTIONS(2715),
    [sym_true] = ACTIONS(2713),
    [sym_false] = ACTIONS(2713),
    [anon_sym_NULL] = ACTIONS(2713),
    [anon_sym_nullptr] = ACTIONS(2713),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2713),
    [anon_sym_decltype] = ACTIONS(2713),
    [anon_sym_virtual] = ACTIONS(2713),
    [anon_sym_alignas] = ACTIONS(2713),
    [anon_sym_explicit] = ACTIONS(2713),
    [anon_sym_typename] = ACTIONS(2713),
    [anon_sym_template] = ACTIONS(2713),
    [anon_sym_operator] = ACTIONS(2713),
    [anon_sym_try] = ACTIONS(2713),
    [anon_sym_delete] = ACTIONS(2713),
    [anon_sym_throw] = ACTIONS(2713),
    [anon_sym_namespace] = ACTIONS(2713),
    [anon_sym_using] = ACTIONS(2713),
    [anon_sym_static_assert] = ACTIONS(2713),
    [anon_sym_concept] = ACTIONS(2713),
    [anon_sym_co_return] = ACTIONS(2713),
    [anon_sym_co_yield] = ACTIONS(2713),
    [anon_sym_R_DQUOTE] = ACTIONS(2715),
    [anon_sym_LR_DQUOTE] = ACTIONS(2715),
    [anon_sym_uR_DQUOTE] = ACTIONS(2715),
    [anon_sym_UR_DQUOTE] = ACTIONS(2715),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2715),
    [anon_sym_co_await] = ACTIONS(2713),
    [anon_sym_new] = ACTIONS(2713),
    [anon_sym_requires] = ACTIONS(2713),
    [sym_this] = ACTIONS(2713),
  },
  [284] = {
    [sym_identifier] = ACTIONS(2717),
    [aux_sym_preproc_include_token1] = ACTIONS(2717),
    [aux_sym_preproc_def_token1] = ACTIONS(2717),
    [aux_sym_preproc_if_token1] = ACTIONS(2717),
    [aux_sym_preproc_if_token2] = ACTIONS(2717),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2717),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2717),
    [aux_sym_preproc_else_token1] = ACTIONS(2717),
    [aux_sym_preproc_elif_token1] = ACTIONS(2717),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2717),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2717),
    [sym_preproc_directive] = ACTIONS(2717),
    [anon_sym_LPAREN2] = ACTIONS(2719),
    [anon_sym_BANG] = ACTIONS(2719),
    [anon_sym_TILDE] = ACTIONS(2719),
    [anon_sym_DASH] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP_AMP] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2717),
    [anon_sym_SEMI] = ACTIONS(2719),
    [anon_sym___extension__] = ACTIONS(2717),
    [anon_sym_typedef] = ACTIONS(2717),
    [anon_sym_extern] = ACTIONS(2717),
    [anon_sym___attribute__] = ACTIONS(2717),
    [anon_sym_COLON_COLON] = ACTIONS(2719),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2719),
    [anon_sym___declspec] = ACTIONS(2717),
    [anon_sym___based] = ACTIONS(2717),
    [anon_sym___cdecl] = ACTIONS(2717),
    [anon_sym___clrcall] = ACTIONS(2717),
    [anon_sym___stdcall] = ACTIONS(2717),
    [anon_sym___fastcall] = ACTIONS(2717),
    [anon_sym___thiscall] = ACTIONS(2717),
    [anon_sym___vectorcall] = ACTIONS(2717),
    [anon_sym_LBRACE] = ACTIONS(2719),
    [anon_sym_signed] = ACTIONS(2717),
    [anon_sym_unsigned] = ACTIONS(2717),
    [anon_sym_long] = ACTIONS(2717),
    [anon_sym_short] = ACTIONS(2717),
    [anon_sym_LBRACK] = ACTIONS(2717),
    [anon_sym_static] = ACTIONS(2717),
    [anon_sym_register] = ACTIONS(2717),
    [anon_sym_inline] = ACTIONS(2717),
    [anon_sym___inline] = ACTIONS(2717),
    [anon_sym___inline__] = ACTIONS(2717),
    [anon_sym___forceinline] = ACTIONS(2717),
    [anon_sym_thread_local] = ACTIONS(2717),
    [anon_sym___thread] = ACTIONS(2717),
    [anon_sym_const] = ACTIONS(2717),
    [anon_sym_constexpr] = ACTIONS(2717),
    [anon_sym_volatile] = ACTIONS(2717),
    [anon_sym_restrict] = ACTIONS(2717),
    [anon_sym___restrict__] = ACTIONS(2717),
    [anon_sym__Atomic] = ACTIONS(2717),
    [anon_sym__Noreturn] = ACTIONS(2717),
    [anon_sym_noreturn] = ACTIONS(2717),
    [anon_sym_mutable] = ACTIONS(2717),
    [anon_sym_constinit] = ACTIONS(2717),
    [anon_sym_consteval] = ACTIONS(2717),
    [anon_sym_PROGMEM] = ACTIONS(2717),
    [aux_sym_primitive_type_token1] = ACTIONS(2717),
    [anon_sym_byte] = ACTIONS(2717),
    [anon_sym_word] = ACTIONS(2717),
    [anon_sym_enum] = ACTIONS(2717),
    [anon_sym_class] = ACTIONS(2717),
    [anon_sym_struct] = ACTIONS(2717),
    [anon_sym_union] = ACTIONS(2717),
    [anon_sym_if] = ACTIONS(2717),
    [anon_sym_else] = ACTIONS(2717),
    [anon_sym_switch] = ACTIONS(2717),
    [anon_sym_case] = ACTIONS(2717),
    [anon_sym_default] = ACTIONS(2717),
    [anon_sym_while] = ACTIONS(2717),
    [anon_sym_do] = ACTIONS(2717),
    [anon_sym_for] = ACTIONS(2717),
    [anon_sym_return] = ACTIONS(2717),
    [anon_sym_break] = ACTIONS(2717),
    [anon_sym_continue] = ACTIONS(2717),
    [anon_sym_goto] = ACTIONS(2717),
    [anon_sym___try] = ACTIONS(2717),
    [anon_sym___leave] = ACTIONS(2717),
    [anon_sym_not] = ACTIONS(2717),
    [anon_sym_compl] = ACTIONS(2717),
    [anon_sym_DASH_DASH] = ACTIONS(2719),
    [anon_sym_PLUS_PLUS] = ACTIONS(2719),
    [anon_sym_sizeof] = ACTIONS(2717),
    [anon_sym___alignof__] = ACTIONS(2717),
    [anon_sym___alignof] = ACTIONS(2717),
    [anon_sym__alignof] = ACTIONS(2717),
    [anon_sym_alignof] = ACTIONS(2717),
    [anon_sym__Alignof] = ACTIONS(2717),
    [anon_sym_offsetof] = ACTIONS(2717),
    [anon_sym__Generic] = ACTIONS(2717),
    [anon_sym_asm] = ACTIONS(2717),
    [anon_sym___asm__] = ACTIONS(2717),
    [aux_sym_number_literal_token1] = ACTIONS(2719),
    [aux_sym_number_literal_token2] = ACTIONS(2717),
    [anon_sym_L_SQUOTE] = ACTIONS(2719),
    [anon_sym_u_SQUOTE] = ACTIONS(2719),
    [anon_sym_U_SQUOTE] = ACTIONS(2719),
    [anon_sym_u8_SQUOTE] = ACTIONS(2719),
    [anon_sym_SQUOTE] = ACTIONS(2719),
    [anon_sym_L_DQUOTE] = ACTIONS(2719),
    [anon_sym_u_DQUOTE] = ACTIONS(2719),
    [anon_sym_U_DQUOTE] = ACTIONS(2719),
    [anon_sym_u8_DQUOTE] = ACTIONS(2719),
    [anon_sym_DQUOTE] = ACTIONS(2719),
    [sym_true] = ACTIONS(2717),
    [sym_false] = ACTIONS(2717),
    [anon_sym_NULL] = ACTIONS(2717),
    [anon_sym_nullptr] = ACTIONS(2717),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2717),
    [anon_sym_decltype] = ACTIONS(2717),
    [anon_sym_virtual] = ACTIONS(2717),
    [anon_sym_alignas] = ACTIONS(2717),
    [anon_sym_explicit] = ACTIONS(2717),
    [anon_sym_typename] = ACTIONS(2717),
    [anon_sym_template] = ACTIONS(2717),
    [anon_sym_operator] = ACTIONS(2717),
    [anon_sym_try] = ACTIONS(2717),
    [anon_sym_delete] = ACTIONS(2717),
    [anon_sym_throw] = ACTIONS(2717),
    [anon_sym_namespace] = ACTIONS(2717),
    [anon_sym_using] = ACTIONS(2717),
    [anon_sym_static_assert] = ACTIONS(2717),
    [anon_sym_concept] = ACTIONS(2717),
    [anon_sym_co_return] = ACTIONS(2717),
    [anon_sym_co_yield] = ACTIONS(2717),
    [anon_sym_R_DQUOTE] = ACTIONS(2719),
    [anon_sym_LR_DQUOTE] = ACTIONS(2719),
    [anon_sym_uR_DQUOTE] = ACTIONS(2719),
    [anon_sym_UR_DQUOTE] = ACTIONS(2719),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2719),
    [anon_sym_co_await] = ACTIONS(2717),
    [anon_sym_new] = ACTIONS(2717),
    [anon_sym_requires] = ACTIONS(2717),
    [sym_this] = ACTIONS(2717),
  },
  [285] = {
    [sym_type_qualifier] = STATE(3799),
    [sym__type_specifier] = STATE(4801),
    [sym_sized_type_specifier] = STATE(2935),
    [sym_primitive_type] = STATE(4963),
    [sym_enum_specifier] = STATE(2935),
    [sym_struct_specifier] = STATE(2935),
    [sym_union_specifier] = STATE(2935),
    [sym__expression] = STATE(4258),
    [sym__expression_not_binary] = STATE(4648),
    [sym__string] = STATE(4648),
    [sym_conditional_expression] = STATE(4648),
    [sym_assignment_expression] = STATE(4648),
    [sym_pointer_expression] = STATE(3663),
    [sym_unary_expression] = STATE(4648),
    [sym_binary_expression] = STATE(4648),
    [sym_update_expression] = STATE(4648),
    [sym_cast_expression] = STATE(4648),
    [sym_type_descriptor] = STATE(6611),
    [sym_sizeof_expression] = STATE(4648),
    [sym_alignof_expression] = STATE(4648),
    [sym_offsetof_expression] = STATE(4648),
    [sym_generic_expression] = STATE(4648),
    [sym_subscript_expression] = STATE(3663),
    [sym_call_expression] = STATE(3663),
    [sym_gnu_asm_expression] = STATE(4648),
    [sym_field_expression] = STATE(3663),
    [sym_compound_literal_expression] = STATE(4648),
    [sym_parenthesized_expression] = STATE(3663),
    [sym_number_literal] = STATE(4573),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4565),
    [sym_string_literal] = STATE(3707),
    [sym_null] = STATE(4648),
    [sym_placeholder_type_specifier] = STATE(2935),
    [sym_decltype_auto] = STATE(2933),
    [sym_decltype] = STATE(2868),
    [sym_class_specifier] = STATE(2935),
    [sym__class_name] = STATE(7442),
    [sym_dependent_type] = STATE(2935),
    [sym_template_type] = STATE(5228),
    [sym_template_function] = STATE(4648),
    [sym_raw_string_literal] = STATE(3709),
    [sym_co_await_expression] = STATE(4648),
    [sym_new_expression] = STATE(4648),
    [sym_delete_expression] = STATE(4648),
    [sym_requires_clause] = STATE(4648),
    [sym_requires_expression] = STATE(4648),
    [sym_lambda_expression] = STATE(4648),
    [sym_lambda_capture_specifier] = STATE(5768),
    [sym_fold_expression] = STATE(4648),
    [sym_parameter_pack_expansion] = STATE(4648),
    [sym_type_parameter_pack_expansion] = STATE(7137),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5541),
    [sym_qualified_identifier] = STATE(3663),
    [sym_qualified_type_identifier] = STATE(5253),
    [sym_user_defined_literal] = STATE(3663),
    [aux_sym__type_definition_type_repeat1] = STATE(3799),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2164),
    [sym_identifier] = ACTIONS(2573),
    [anon_sym_LPAREN2] = ACTIONS(2575),
    [anon_sym_BANG] = ACTIONS(2577),
    [anon_sym_TILDE] = ACTIONS(2577),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2583),
    [anon_sym_signed] = ACTIONS(2585),
    [anon_sym_unsigned] = ACTIONS(2585),
    [anon_sym_long] = ACTIONS(2585),
    [anon_sym_short] = ACTIONS(2585),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2587),
    [anon_sym_byte] = ACTIONS(2587),
    [anon_sym_word] = ACTIONS(2587),
    [anon_sym_enum] = ACTIONS(2589),
    [anon_sym_class] = ACTIONS(2591),
    [anon_sym_struct] = ACTIONS(2593),
    [anon_sym_union] = ACTIONS(2595),
    [anon_sym_not] = ACTIONS(2579),
    [anon_sym_compl] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(2597),
    [anon_sym_PLUS_PLUS] = ACTIONS(2597),
    [anon_sym_sizeof] = ACTIONS(2599),
    [anon_sym___alignof__] = ACTIONS(2601),
    [anon_sym___alignof] = ACTIONS(2601),
    [anon_sym__alignof] = ACTIONS(2601),
    [anon_sym_alignof] = ACTIONS(2601),
    [anon_sym__Alignof] = ACTIONS(2601),
    [anon_sym_offsetof] = ACTIONS(2603),
    [anon_sym__Generic] = ACTIONS(2605),
    [anon_sym_asm] = ACTIONS(2607),
    [anon_sym___asm__] = ACTIONS(2607),
    [aux_sym_number_literal_token1] = ACTIONS(2609),
    [aux_sym_number_literal_token2] = ACTIONS(2611),
    [anon_sym_L_SQUOTE] = ACTIONS(2613),
    [anon_sym_u_SQUOTE] = ACTIONS(2613),
    [anon_sym_U_SQUOTE] = ACTIONS(2613),
    [anon_sym_u8_SQUOTE] = ACTIONS(2613),
    [anon_sym_SQUOTE] = ACTIONS(2613),
    [anon_sym_L_DQUOTE] = ACTIONS(2615),
    [anon_sym_u_DQUOTE] = ACTIONS(2615),
    [anon_sym_U_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8_DQUOTE] = ACTIONS(2615),
    [anon_sym_DQUOTE] = ACTIONS(2615),
    [sym_true] = ACTIONS(2617),
    [sym_false] = ACTIONS(2617),
    [anon_sym_NULL] = ACTIONS(2619),
    [anon_sym_nullptr] = ACTIONS(2619),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2621),
    [anon_sym_decltype] = ACTIONS(2623),
    [anon_sym_typename] = ACTIONS(2625),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_GT2] = ACTIONS(2721),
    [anon_sym_delete] = ACTIONS(2629),
    [anon_sym_R_DQUOTE] = ACTIONS(2631),
    [anon_sym_LR_DQUOTE] = ACTIONS(2631),
    [anon_sym_uR_DQUOTE] = ACTIONS(2631),
    [anon_sym_UR_DQUOTE] = ACTIONS(2631),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2631),
    [anon_sym_co_await] = ACTIONS(2633),
    [anon_sym_new] = ACTIONS(2635),
    [anon_sym_requires] = ACTIONS(2637),
    [sym_this] = ACTIONS(2617),
  },
  [286] = {
    [sym_identifier] = ACTIONS(2723),
    [aux_sym_preproc_include_token1] = ACTIONS(2723),
    [aux_sym_preproc_def_token1] = ACTIONS(2723),
    [aux_sym_preproc_if_token1] = ACTIONS(2723),
    [aux_sym_preproc_if_token2] = ACTIONS(2723),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2723),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2723),
    [aux_sym_preproc_else_token1] = ACTIONS(2723),
    [aux_sym_preproc_elif_token1] = ACTIONS(2723),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2723),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2723),
    [sym_preproc_directive] = ACTIONS(2723),
    [anon_sym_LPAREN2] = ACTIONS(2725),
    [anon_sym_BANG] = ACTIONS(2725),
    [anon_sym_TILDE] = ACTIONS(2725),
    [anon_sym_DASH] = ACTIONS(2723),
    [anon_sym_PLUS] = ACTIONS(2723),
    [anon_sym_STAR] = ACTIONS(2725),
    [anon_sym_AMP_AMP] = ACTIONS(2725),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_SEMI] = ACTIONS(2725),
    [anon_sym___extension__] = ACTIONS(2723),
    [anon_sym_typedef] = ACTIONS(2723),
    [anon_sym_extern] = ACTIONS(2723),
    [anon_sym___attribute__] = ACTIONS(2723),
    [anon_sym_COLON_COLON] = ACTIONS(2725),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2725),
    [anon_sym___declspec] = ACTIONS(2723),
    [anon_sym___based] = ACTIONS(2723),
    [anon_sym___cdecl] = ACTIONS(2723),
    [anon_sym___clrcall] = ACTIONS(2723),
    [anon_sym___stdcall] = ACTIONS(2723),
    [anon_sym___fastcall] = ACTIONS(2723),
    [anon_sym___thiscall] = ACTIONS(2723),
    [anon_sym___vectorcall] = ACTIONS(2723),
    [anon_sym_LBRACE] = ACTIONS(2725),
    [anon_sym_signed] = ACTIONS(2723),
    [anon_sym_unsigned] = ACTIONS(2723),
    [anon_sym_long] = ACTIONS(2723),
    [anon_sym_short] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_static] = ACTIONS(2723),
    [anon_sym_register] = ACTIONS(2723),
    [anon_sym_inline] = ACTIONS(2723),
    [anon_sym___inline] = ACTIONS(2723),
    [anon_sym___inline__] = ACTIONS(2723),
    [anon_sym___forceinline] = ACTIONS(2723),
    [anon_sym_thread_local] = ACTIONS(2723),
    [anon_sym___thread] = ACTIONS(2723),
    [anon_sym_const] = ACTIONS(2723),
    [anon_sym_constexpr] = ACTIONS(2723),
    [anon_sym_volatile] = ACTIONS(2723),
    [anon_sym_restrict] = ACTIONS(2723),
    [anon_sym___restrict__] = ACTIONS(2723),
    [anon_sym__Atomic] = ACTIONS(2723),
    [anon_sym__Noreturn] = ACTIONS(2723),
    [anon_sym_noreturn] = ACTIONS(2723),
    [anon_sym_mutable] = ACTIONS(2723),
    [anon_sym_constinit] = ACTIONS(2723),
    [anon_sym_consteval] = ACTIONS(2723),
    [anon_sym_PROGMEM] = ACTIONS(2723),
    [aux_sym_primitive_type_token1] = ACTIONS(2723),
    [anon_sym_byte] = ACTIONS(2723),
    [anon_sym_word] = ACTIONS(2723),
    [anon_sym_enum] = ACTIONS(2723),
    [anon_sym_class] = ACTIONS(2723),
    [anon_sym_struct] = ACTIONS(2723),
    [anon_sym_union] = ACTIONS(2723),
    [anon_sym_if] = ACTIONS(2723),
    [anon_sym_else] = ACTIONS(2723),
    [anon_sym_switch] = ACTIONS(2723),
    [anon_sym_case] = ACTIONS(2723),
    [anon_sym_default] = ACTIONS(2723),
    [anon_sym_while] = ACTIONS(2723),
    [anon_sym_do] = ACTIONS(2723),
    [anon_sym_for] = ACTIONS(2723),
    [anon_sym_return] = ACTIONS(2723),
    [anon_sym_break] = ACTIONS(2723),
    [anon_sym_continue] = ACTIONS(2723),
    [anon_sym_goto] = ACTIONS(2723),
    [anon_sym___try] = ACTIONS(2723),
    [anon_sym___leave] = ACTIONS(2723),
    [anon_sym_not] = ACTIONS(2723),
    [anon_sym_compl] = ACTIONS(2723),
    [anon_sym_DASH_DASH] = ACTIONS(2725),
    [anon_sym_PLUS_PLUS] = ACTIONS(2725),
    [anon_sym_sizeof] = ACTIONS(2723),
    [anon_sym___alignof__] = ACTIONS(2723),
    [anon_sym___alignof] = ACTIONS(2723),
    [anon_sym__alignof] = ACTIONS(2723),
    [anon_sym_alignof] = ACTIONS(2723),
    [anon_sym__Alignof] = ACTIONS(2723),
    [anon_sym_offsetof] = ACTIONS(2723),
    [anon_sym__Generic] = ACTIONS(2723),
    [anon_sym_asm] = ACTIONS(2723),
    [anon_sym___asm__] = ACTIONS(2723),
    [aux_sym_number_literal_token1] = ACTIONS(2725),
    [aux_sym_number_literal_token2] = ACTIONS(2723),
    [anon_sym_L_SQUOTE] = ACTIONS(2725),
    [anon_sym_u_SQUOTE] = ACTIONS(2725),
    [anon_sym_U_SQUOTE] = ACTIONS(2725),
    [anon_sym_u8_SQUOTE] = ACTIONS(2725),
    [anon_sym_SQUOTE] = ACTIONS(2725),
    [anon_sym_L_DQUOTE] = ACTIONS(2725),
    [anon_sym_u_DQUOTE] = ACTIONS(2725),
    [anon_sym_U_DQUOTE] = ACTIONS(2725),
    [anon_sym_u8_DQUOTE] = ACTIONS(2725),
    [anon_sym_DQUOTE] = ACTIONS(2725),
    [sym_true] = ACTIONS(2723),
    [sym_false] = ACTIONS(2723),
    [anon_sym_NULL] = ACTIONS(2723),
    [anon_sym_nullptr] = ACTIONS(2723),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2723),
    [anon_sym_decltype] = ACTIONS(2723),
    [anon_sym_virtual] = ACTIONS(2723),
    [anon_sym_alignas] = ACTIONS(2723),
    [anon_sym_explicit] = ACTIONS(2723),
    [anon_sym_typename] = ACTIONS(2723),
    [anon_sym_template] = ACTIONS(2723),
    [anon_sym_operator] = ACTIONS(2723),
    [anon_sym_try] = ACTIONS(2723),
    [anon_sym_delete] = ACTIONS(2723),
    [anon_sym_throw] = ACTIONS(2723),
    [anon_sym_namespace] = ACTIONS(2723),
    [anon_sym_using] = ACTIONS(2723),
    [anon_sym_static_assert] = ACTIONS(2723),
    [anon_sym_concept] = ACTIONS(2723),
    [anon_sym_co_return] = ACTIONS(2723),
    [anon_sym_co_yield] = ACTIONS(2723),
    [anon_sym_R_DQUOTE] = ACTIONS(2725),
    [anon_sym_LR_DQUOTE] = ACTIONS(2725),
    [anon_sym_uR_DQUOTE] = ACTIONS(2725),
    [anon_sym_UR_DQUOTE] = ACTIONS(2725),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2725),
    [anon_sym_co_await] = ACTIONS(2723),
    [anon_sym_new] = ACTIONS(2723),
    [anon_sym_requires] = ACTIONS(2723),
    [sym_this] = ACTIONS(2723),
  },
  [287] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token2] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [aux_sym_preproc_else_token1] = ACTIONS(2643),
    [aux_sym_preproc_elif_token1] = ACTIONS(2643),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [288] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token2] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [aux_sym_preproc_else_token1] = ACTIONS(2679),
    [aux_sym_preproc_elif_token1] = ACTIONS(2679),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [289] = {
    [sym_identifier] = ACTIONS(2723),
    [aux_sym_preproc_include_token1] = ACTIONS(2723),
    [aux_sym_preproc_def_token1] = ACTIONS(2723),
    [aux_sym_preproc_if_token1] = ACTIONS(2723),
    [aux_sym_preproc_if_token2] = ACTIONS(2723),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2723),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2723),
    [aux_sym_preproc_else_token1] = ACTIONS(2723),
    [aux_sym_preproc_elif_token1] = ACTIONS(2723),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2723),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2723),
    [sym_preproc_directive] = ACTIONS(2723),
    [anon_sym_LPAREN2] = ACTIONS(2725),
    [anon_sym_BANG] = ACTIONS(2725),
    [anon_sym_TILDE] = ACTIONS(2725),
    [anon_sym_DASH] = ACTIONS(2723),
    [anon_sym_PLUS] = ACTIONS(2723),
    [anon_sym_STAR] = ACTIONS(2725),
    [anon_sym_AMP_AMP] = ACTIONS(2725),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_SEMI] = ACTIONS(2725),
    [anon_sym___extension__] = ACTIONS(2723),
    [anon_sym_typedef] = ACTIONS(2723),
    [anon_sym_extern] = ACTIONS(2723),
    [anon_sym___attribute__] = ACTIONS(2723),
    [anon_sym_COLON_COLON] = ACTIONS(2725),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2725),
    [anon_sym___declspec] = ACTIONS(2723),
    [anon_sym___based] = ACTIONS(2723),
    [anon_sym___cdecl] = ACTIONS(2723),
    [anon_sym___clrcall] = ACTIONS(2723),
    [anon_sym___stdcall] = ACTIONS(2723),
    [anon_sym___fastcall] = ACTIONS(2723),
    [anon_sym___thiscall] = ACTIONS(2723),
    [anon_sym___vectorcall] = ACTIONS(2723),
    [anon_sym_LBRACE] = ACTIONS(2725),
    [anon_sym_signed] = ACTIONS(2723),
    [anon_sym_unsigned] = ACTIONS(2723),
    [anon_sym_long] = ACTIONS(2723),
    [anon_sym_short] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_static] = ACTIONS(2723),
    [anon_sym_register] = ACTIONS(2723),
    [anon_sym_inline] = ACTIONS(2723),
    [anon_sym___inline] = ACTIONS(2723),
    [anon_sym___inline__] = ACTIONS(2723),
    [anon_sym___forceinline] = ACTIONS(2723),
    [anon_sym_thread_local] = ACTIONS(2723),
    [anon_sym___thread] = ACTIONS(2723),
    [anon_sym_const] = ACTIONS(2723),
    [anon_sym_constexpr] = ACTIONS(2723),
    [anon_sym_volatile] = ACTIONS(2723),
    [anon_sym_restrict] = ACTIONS(2723),
    [anon_sym___restrict__] = ACTIONS(2723),
    [anon_sym__Atomic] = ACTIONS(2723),
    [anon_sym__Noreturn] = ACTIONS(2723),
    [anon_sym_noreturn] = ACTIONS(2723),
    [anon_sym_mutable] = ACTIONS(2723),
    [anon_sym_constinit] = ACTIONS(2723),
    [anon_sym_consteval] = ACTIONS(2723),
    [anon_sym_PROGMEM] = ACTIONS(2723),
    [aux_sym_primitive_type_token1] = ACTIONS(2723),
    [anon_sym_byte] = ACTIONS(2723),
    [anon_sym_word] = ACTIONS(2723),
    [anon_sym_enum] = ACTIONS(2723),
    [anon_sym_class] = ACTIONS(2723),
    [anon_sym_struct] = ACTIONS(2723),
    [anon_sym_union] = ACTIONS(2723),
    [anon_sym_if] = ACTIONS(2723),
    [anon_sym_else] = ACTIONS(2723),
    [anon_sym_switch] = ACTIONS(2723),
    [anon_sym_case] = ACTIONS(2723),
    [anon_sym_default] = ACTIONS(2723),
    [anon_sym_while] = ACTIONS(2723),
    [anon_sym_do] = ACTIONS(2723),
    [anon_sym_for] = ACTIONS(2723),
    [anon_sym_return] = ACTIONS(2723),
    [anon_sym_break] = ACTIONS(2723),
    [anon_sym_continue] = ACTIONS(2723),
    [anon_sym_goto] = ACTIONS(2723),
    [anon_sym___try] = ACTIONS(2723),
    [anon_sym___leave] = ACTIONS(2723),
    [anon_sym_not] = ACTIONS(2723),
    [anon_sym_compl] = ACTIONS(2723),
    [anon_sym_DASH_DASH] = ACTIONS(2725),
    [anon_sym_PLUS_PLUS] = ACTIONS(2725),
    [anon_sym_sizeof] = ACTIONS(2723),
    [anon_sym___alignof__] = ACTIONS(2723),
    [anon_sym___alignof] = ACTIONS(2723),
    [anon_sym__alignof] = ACTIONS(2723),
    [anon_sym_alignof] = ACTIONS(2723),
    [anon_sym__Alignof] = ACTIONS(2723),
    [anon_sym_offsetof] = ACTIONS(2723),
    [anon_sym__Generic] = ACTIONS(2723),
    [anon_sym_asm] = ACTIONS(2723),
    [anon_sym___asm__] = ACTIONS(2723),
    [aux_sym_number_literal_token1] = ACTIONS(2725),
    [aux_sym_number_literal_token2] = ACTIONS(2723),
    [anon_sym_L_SQUOTE] = ACTIONS(2725),
    [anon_sym_u_SQUOTE] = ACTIONS(2725),
    [anon_sym_U_SQUOTE] = ACTIONS(2725),
    [anon_sym_u8_SQUOTE] = ACTIONS(2725),
    [anon_sym_SQUOTE] = ACTIONS(2725),
    [anon_sym_L_DQUOTE] = ACTIONS(2725),
    [anon_sym_u_DQUOTE] = ACTIONS(2725),
    [anon_sym_U_DQUOTE] = ACTIONS(2725),
    [anon_sym_u8_DQUOTE] = ACTIONS(2725),
    [anon_sym_DQUOTE] = ACTIONS(2725),
    [sym_true] = ACTIONS(2723),
    [sym_false] = ACTIONS(2723),
    [anon_sym_NULL] = ACTIONS(2723),
    [anon_sym_nullptr] = ACTIONS(2723),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2723),
    [anon_sym_decltype] = ACTIONS(2723),
    [anon_sym_virtual] = ACTIONS(2723),
    [anon_sym_alignas] = ACTIONS(2723),
    [anon_sym_explicit] = ACTIONS(2723),
    [anon_sym_typename] = ACTIONS(2723),
    [anon_sym_template] = ACTIONS(2723),
    [anon_sym_operator] = ACTIONS(2723),
    [anon_sym_try] = ACTIONS(2723),
    [anon_sym_delete] = ACTIONS(2723),
    [anon_sym_throw] = ACTIONS(2723),
    [anon_sym_namespace] = ACTIONS(2723),
    [anon_sym_using] = ACTIONS(2723),
    [anon_sym_static_assert] = ACTIONS(2723),
    [anon_sym_concept] = ACTIONS(2723),
    [anon_sym_co_return] = ACTIONS(2723),
    [anon_sym_co_yield] = ACTIONS(2723),
    [anon_sym_R_DQUOTE] = ACTIONS(2725),
    [anon_sym_LR_DQUOTE] = ACTIONS(2725),
    [anon_sym_uR_DQUOTE] = ACTIONS(2725),
    [anon_sym_UR_DQUOTE] = ACTIONS(2725),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2725),
    [anon_sym_co_await] = ACTIONS(2723),
    [anon_sym_new] = ACTIONS(2723),
    [anon_sym_requires] = ACTIONS(2723),
    [sym_this] = ACTIONS(2723),
  },
  [290] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token2] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [aux_sym_preproc_else_token1] = ACTIONS(2679),
    [aux_sym_preproc_elif_token1] = ACTIONS(2679),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [291] = {
    [sym_type_qualifier] = STATE(3799),
    [sym__type_specifier] = STATE(4801),
    [sym_sized_type_specifier] = STATE(2935),
    [sym_primitive_type] = STATE(4963),
    [sym_enum_specifier] = STATE(2935),
    [sym_struct_specifier] = STATE(2935),
    [sym_union_specifier] = STATE(2935),
    [sym__expression] = STATE(4240),
    [sym__expression_not_binary] = STATE(4648),
    [sym__string] = STATE(4648),
    [sym_conditional_expression] = STATE(4648),
    [sym_assignment_expression] = STATE(4648),
    [sym_pointer_expression] = STATE(3663),
    [sym_unary_expression] = STATE(4648),
    [sym_binary_expression] = STATE(4648),
    [sym_update_expression] = STATE(4648),
    [sym_cast_expression] = STATE(4648),
    [sym_type_descriptor] = STATE(6784),
    [sym_sizeof_expression] = STATE(4648),
    [sym_alignof_expression] = STATE(4648),
    [sym_offsetof_expression] = STATE(4648),
    [sym_generic_expression] = STATE(4648),
    [sym_subscript_expression] = STATE(3663),
    [sym_call_expression] = STATE(3663),
    [sym_gnu_asm_expression] = STATE(4648),
    [sym_field_expression] = STATE(3663),
    [sym_compound_literal_expression] = STATE(4648),
    [sym_parenthesized_expression] = STATE(3663),
    [sym_number_literal] = STATE(4573),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4565),
    [sym_string_literal] = STATE(3707),
    [sym_null] = STATE(4648),
    [sym_placeholder_type_specifier] = STATE(2935),
    [sym_decltype_auto] = STATE(2933),
    [sym_decltype] = STATE(2868),
    [sym_class_specifier] = STATE(2935),
    [sym__class_name] = STATE(7442),
    [sym_dependent_type] = STATE(2935),
    [sym_template_type] = STATE(5228),
    [sym_template_function] = STATE(4648),
    [sym_raw_string_literal] = STATE(3709),
    [sym_co_await_expression] = STATE(4648),
    [sym_new_expression] = STATE(4648),
    [sym_delete_expression] = STATE(4648),
    [sym_requires_clause] = STATE(4648),
    [sym_requires_expression] = STATE(4648),
    [sym_lambda_expression] = STATE(4648),
    [sym_lambda_capture_specifier] = STATE(5768),
    [sym_fold_expression] = STATE(4648),
    [sym_parameter_pack_expansion] = STATE(4648),
    [sym_type_parameter_pack_expansion] = STATE(6997),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5541),
    [sym_qualified_identifier] = STATE(3663),
    [sym_qualified_type_identifier] = STATE(5253),
    [sym_user_defined_literal] = STATE(3663),
    [aux_sym__type_definition_type_repeat1] = STATE(3799),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2164),
    [sym_identifier] = ACTIONS(2573),
    [anon_sym_LPAREN2] = ACTIONS(2575),
    [anon_sym_BANG] = ACTIONS(2577),
    [anon_sym_TILDE] = ACTIONS(2577),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2583),
    [anon_sym_signed] = ACTIONS(2585),
    [anon_sym_unsigned] = ACTIONS(2585),
    [anon_sym_long] = ACTIONS(2585),
    [anon_sym_short] = ACTIONS(2585),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2587),
    [anon_sym_byte] = ACTIONS(2587),
    [anon_sym_word] = ACTIONS(2587),
    [anon_sym_enum] = ACTIONS(2589),
    [anon_sym_class] = ACTIONS(2591),
    [anon_sym_struct] = ACTIONS(2593),
    [anon_sym_union] = ACTIONS(2595),
    [anon_sym_not] = ACTIONS(2579),
    [anon_sym_compl] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(2597),
    [anon_sym_PLUS_PLUS] = ACTIONS(2597),
    [anon_sym_sizeof] = ACTIONS(2599),
    [anon_sym___alignof__] = ACTIONS(2601),
    [anon_sym___alignof] = ACTIONS(2601),
    [anon_sym__alignof] = ACTIONS(2601),
    [anon_sym_alignof] = ACTIONS(2601),
    [anon_sym__Alignof] = ACTIONS(2601),
    [anon_sym_offsetof] = ACTIONS(2603),
    [anon_sym__Generic] = ACTIONS(2605),
    [anon_sym_asm] = ACTIONS(2607),
    [anon_sym___asm__] = ACTIONS(2607),
    [aux_sym_number_literal_token1] = ACTIONS(2609),
    [aux_sym_number_literal_token2] = ACTIONS(2611),
    [anon_sym_L_SQUOTE] = ACTIONS(2613),
    [anon_sym_u_SQUOTE] = ACTIONS(2613),
    [anon_sym_U_SQUOTE] = ACTIONS(2613),
    [anon_sym_u8_SQUOTE] = ACTIONS(2613),
    [anon_sym_SQUOTE] = ACTIONS(2613),
    [anon_sym_L_DQUOTE] = ACTIONS(2615),
    [anon_sym_u_DQUOTE] = ACTIONS(2615),
    [anon_sym_U_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8_DQUOTE] = ACTIONS(2615),
    [anon_sym_DQUOTE] = ACTIONS(2615),
    [sym_true] = ACTIONS(2617),
    [sym_false] = ACTIONS(2617),
    [anon_sym_NULL] = ACTIONS(2619),
    [anon_sym_nullptr] = ACTIONS(2619),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2621),
    [anon_sym_decltype] = ACTIONS(2623),
    [anon_sym_typename] = ACTIONS(2625),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_GT2] = ACTIONS(2727),
    [anon_sym_delete] = ACTIONS(2629),
    [anon_sym_R_DQUOTE] = ACTIONS(2631),
    [anon_sym_LR_DQUOTE] = ACTIONS(2631),
    [anon_sym_uR_DQUOTE] = ACTIONS(2631),
    [anon_sym_UR_DQUOTE] = ACTIONS(2631),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2631),
    [anon_sym_co_await] = ACTIONS(2633),
    [anon_sym_new] = ACTIONS(2635),
    [anon_sym_requires] = ACTIONS(2637),
    [sym_this] = ACTIONS(2617),
  },
  [292] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token2] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [aux_sym_preproc_else_token1] = ACTIONS(2679),
    [aux_sym_preproc_elif_token1] = ACTIONS(2679),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [293] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token2] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [aux_sym_preproc_else_token1] = ACTIONS(2643),
    [aux_sym_preproc_elif_token1] = ACTIONS(2643),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [294] = {
    [sym_type_qualifier] = STATE(3799),
    [sym__type_specifier] = STATE(4801),
    [sym_sized_type_specifier] = STATE(2935),
    [sym_primitive_type] = STATE(4963),
    [sym_enum_specifier] = STATE(2935),
    [sym_struct_specifier] = STATE(2935),
    [sym_union_specifier] = STATE(2935),
    [sym__expression] = STATE(4296),
    [sym__expression_not_binary] = STATE(4648),
    [sym__string] = STATE(4648),
    [sym_conditional_expression] = STATE(4648),
    [sym_assignment_expression] = STATE(4648),
    [sym_pointer_expression] = STATE(3663),
    [sym_unary_expression] = STATE(4648),
    [sym_binary_expression] = STATE(4648),
    [sym_update_expression] = STATE(4648),
    [sym_cast_expression] = STATE(4648),
    [sym_type_descriptor] = STATE(6834),
    [sym_sizeof_expression] = STATE(4648),
    [sym_alignof_expression] = STATE(4648),
    [sym_offsetof_expression] = STATE(4648),
    [sym_generic_expression] = STATE(4648),
    [sym_subscript_expression] = STATE(3663),
    [sym_call_expression] = STATE(3663),
    [sym_gnu_asm_expression] = STATE(4648),
    [sym_field_expression] = STATE(3663),
    [sym_compound_literal_expression] = STATE(4648),
    [sym_parenthesized_expression] = STATE(3663),
    [sym_number_literal] = STATE(4573),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4565),
    [sym_string_literal] = STATE(3707),
    [sym_null] = STATE(4648),
    [sym_placeholder_type_specifier] = STATE(2935),
    [sym_decltype_auto] = STATE(2933),
    [sym_decltype] = STATE(2868),
    [sym_class_specifier] = STATE(2935),
    [sym__class_name] = STATE(7442),
    [sym_dependent_type] = STATE(2935),
    [sym_template_type] = STATE(5228),
    [sym_template_function] = STATE(4648),
    [sym_raw_string_literal] = STATE(3709),
    [sym_co_await_expression] = STATE(4648),
    [sym_new_expression] = STATE(4648),
    [sym_delete_expression] = STATE(4648),
    [sym_requires_clause] = STATE(4648),
    [sym_requires_expression] = STATE(4648),
    [sym_lambda_expression] = STATE(4648),
    [sym_lambda_capture_specifier] = STATE(5768),
    [sym_fold_expression] = STATE(4648),
    [sym_parameter_pack_expansion] = STATE(4648),
    [sym_type_parameter_pack_expansion] = STATE(6910),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5541),
    [sym_qualified_identifier] = STATE(3663),
    [sym_qualified_type_identifier] = STATE(5253),
    [sym_user_defined_literal] = STATE(3663),
    [aux_sym__type_definition_type_repeat1] = STATE(3799),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2164),
    [sym_identifier] = ACTIONS(2573),
    [anon_sym_LPAREN2] = ACTIONS(2575),
    [anon_sym_BANG] = ACTIONS(2577),
    [anon_sym_TILDE] = ACTIONS(2577),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2583),
    [anon_sym_signed] = ACTIONS(2585),
    [anon_sym_unsigned] = ACTIONS(2585),
    [anon_sym_long] = ACTIONS(2585),
    [anon_sym_short] = ACTIONS(2585),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2587),
    [anon_sym_byte] = ACTIONS(2587),
    [anon_sym_word] = ACTIONS(2587),
    [anon_sym_enum] = ACTIONS(2589),
    [anon_sym_class] = ACTIONS(2591),
    [anon_sym_struct] = ACTIONS(2593),
    [anon_sym_union] = ACTIONS(2595),
    [anon_sym_not] = ACTIONS(2579),
    [anon_sym_compl] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(2597),
    [anon_sym_PLUS_PLUS] = ACTIONS(2597),
    [anon_sym_sizeof] = ACTIONS(2599),
    [anon_sym___alignof__] = ACTIONS(2601),
    [anon_sym___alignof] = ACTIONS(2601),
    [anon_sym__alignof] = ACTIONS(2601),
    [anon_sym_alignof] = ACTIONS(2601),
    [anon_sym__Alignof] = ACTIONS(2601),
    [anon_sym_offsetof] = ACTIONS(2603),
    [anon_sym__Generic] = ACTIONS(2605),
    [anon_sym_asm] = ACTIONS(2607),
    [anon_sym___asm__] = ACTIONS(2607),
    [aux_sym_number_literal_token1] = ACTIONS(2609),
    [aux_sym_number_literal_token2] = ACTIONS(2611),
    [anon_sym_L_SQUOTE] = ACTIONS(2613),
    [anon_sym_u_SQUOTE] = ACTIONS(2613),
    [anon_sym_U_SQUOTE] = ACTIONS(2613),
    [anon_sym_u8_SQUOTE] = ACTIONS(2613),
    [anon_sym_SQUOTE] = ACTIONS(2613),
    [anon_sym_L_DQUOTE] = ACTIONS(2615),
    [anon_sym_u_DQUOTE] = ACTIONS(2615),
    [anon_sym_U_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8_DQUOTE] = ACTIONS(2615),
    [anon_sym_DQUOTE] = ACTIONS(2615),
    [sym_true] = ACTIONS(2617),
    [sym_false] = ACTIONS(2617),
    [anon_sym_NULL] = ACTIONS(2619),
    [anon_sym_nullptr] = ACTIONS(2619),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2621),
    [anon_sym_decltype] = ACTIONS(2623),
    [anon_sym_typename] = ACTIONS(2625),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_GT2] = ACTIONS(2729),
    [anon_sym_delete] = ACTIONS(2629),
    [anon_sym_R_DQUOTE] = ACTIONS(2631),
    [anon_sym_LR_DQUOTE] = ACTIONS(2631),
    [anon_sym_uR_DQUOTE] = ACTIONS(2631),
    [anon_sym_UR_DQUOTE] = ACTIONS(2631),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2631),
    [anon_sym_co_await] = ACTIONS(2633),
    [anon_sym_new] = ACTIONS(2635),
    [anon_sym_requires] = ACTIONS(2637),
    [sym_this] = ACTIONS(2617),
  },
  [295] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token2] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [aux_sym_preproc_else_token1] = ACTIONS(2643),
    [aux_sym_preproc_elif_token1] = ACTIONS(2643),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [296] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token2] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [aux_sym_preproc_else_token1] = ACTIONS(2679),
    [aux_sym_preproc_elif_token1] = ACTIONS(2679),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [297] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token2] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [aux_sym_preproc_else_token1] = ACTIONS(2679),
    [aux_sym_preproc_elif_token1] = ACTIONS(2679),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [298] = {
    [sym_identifier] = ACTIONS(2731),
    [aux_sym_preproc_include_token1] = ACTIONS(2731),
    [aux_sym_preproc_def_token1] = ACTIONS(2731),
    [aux_sym_preproc_if_token1] = ACTIONS(2731),
    [aux_sym_preproc_if_token2] = ACTIONS(2731),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2731),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2731),
    [aux_sym_preproc_else_token1] = ACTIONS(2731),
    [aux_sym_preproc_elif_token1] = ACTIONS(2731),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2731),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2731),
    [sym_preproc_directive] = ACTIONS(2731),
    [anon_sym_LPAREN2] = ACTIONS(2733),
    [anon_sym_BANG] = ACTIONS(2733),
    [anon_sym_TILDE] = ACTIONS(2733),
    [anon_sym_DASH] = ACTIONS(2731),
    [anon_sym_PLUS] = ACTIONS(2731),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_AMP_AMP] = ACTIONS(2733),
    [anon_sym_AMP] = ACTIONS(2731),
    [anon_sym_SEMI] = ACTIONS(2733),
    [anon_sym___extension__] = ACTIONS(2731),
    [anon_sym_typedef] = ACTIONS(2731),
    [anon_sym_extern] = ACTIONS(2731),
    [anon_sym___attribute__] = ACTIONS(2731),
    [anon_sym_COLON_COLON] = ACTIONS(2733),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2733),
    [anon_sym___declspec] = ACTIONS(2731),
    [anon_sym___based] = ACTIONS(2731),
    [anon_sym___cdecl] = ACTIONS(2731),
    [anon_sym___clrcall] = ACTIONS(2731),
    [anon_sym___stdcall] = ACTIONS(2731),
    [anon_sym___fastcall] = ACTIONS(2731),
    [anon_sym___thiscall] = ACTIONS(2731),
    [anon_sym___vectorcall] = ACTIONS(2731),
    [anon_sym_LBRACE] = ACTIONS(2733),
    [anon_sym_signed] = ACTIONS(2731),
    [anon_sym_unsigned] = ACTIONS(2731),
    [anon_sym_long] = ACTIONS(2731),
    [anon_sym_short] = ACTIONS(2731),
    [anon_sym_LBRACK] = ACTIONS(2731),
    [anon_sym_static] = ACTIONS(2731),
    [anon_sym_register] = ACTIONS(2731),
    [anon_sym_inline] = ACTIONS(2731),
    [anon_sym___inline] = ACTIONS(2731),
    [anon_sym___inline__] = ACTIONS(2731),
    [anon_sym___forceinline] = ACTIONS(2731),
    [anon_sym_thread_local] = ACTIONS(2731),
    [anon_sym___thread] = ACTIONS(2731),
    [anon_sym_const] = ACTIONS(2731),
    [anon_sym_constexpr] = ACTIONS(2731),
    [anon_sym_volatile] = ACTIONS(2731),
    [anon_sym_restrict] = ACTIONS(2731),
    [anon_sym___restrict__] = ACTIONS(2731),
    [anon_sym__Atomic] = ACTIONS(2731),
    [anon_sym__Noreturn] = ACTIONS(2731),
    [anon_sym_noreturn] = ACTIONS(2731),
    [anon_sym_mutable] = ACTIONS(2731),
    [anon_sym_constinit] = ACTIONS(2731),
    [anon_sym_consteval] = ACTIONS(2731),
    [anon_sym_PROGMEM] = ACTIONS(2731),
    [aux_sym_primitive_type_token1] = ACTIONS(2731),
    [anon_sym_byte] = ACTIONS(2731),
    [anon_sym_word] = ACTIONS(2731),
    [anon_sym_enum] = ACTIONS(2731),
    [anon_sym_class] = ACTIONS(2731),
    [anon_sym_struct] = ACTIONS(2731),
    [anon_sym_union] = ACTIONS(2731),
    [anon_sym_if] = ACTIONS(2731),
    [anon_sym_else] = ACTIONS(2731),
    [anon_sym_switch] = ACTIONS(2731),
    [anon_sym_case] = ACTIONS(2731),
    [anon_sym_default] = ACTIONS(2731),
    [anon_sym_while] = ACTIONS(2731),
    [anon_sym_do] = ACTIONS(2731),
    [anon_sym_for] = ACTIONS(2731),
    [anon_sym_return] = ACTIONS(2731),
    [anon_sym_break] = ACTIONS(2731),
    [anon_sym_continue] = ACTIONS(2731),
    [anon_sym_goto] = ACTIONS(2731),
    [anon_sym___try] = ACTIONS(2731),
    [anon_sym___leave] = ACTIONS(2731),
    [anon_sym_not] = ACTIONS(2731),
    [anon_sym_compl] = ACTIONS(2731),
    [anon_sym_DASH_DASH] = ACTIONS(2733),
    [anon_sym_PLUS_PLUS] = ACTIONS(2733),
    [anon_sym_sizeof] = ACTIONS(2731),
    [anon_sym___alignof__] = ACTIONS(2731),
    [anon_sym___alignof] = ACTIONS(2731),
    [anon_sym__alignof] = ACTIONS(2731),
    [anon_sym_alignof] = ACTIONS(2731),
    [anon_sym__Alignof] = ACTIONS(2731),
    [anon_sym_offsetof] = ACTIONS(2731),
    [anon_sym__Generic] = ACTIONS(2731),
    [anon_sym_asm] = ACTIONS(2731),
    [anon_sym___asm__] = ACTIONS(2731),
    [aux_sym_number_literal_token1] = ACTIONS(2733),
    [aux_sym_number_literal_token2] = ACTIONS(2731),
    [anon_sym_L_SQUOTE] = ACTIONS(2733),
    [anon_sym_u_SQUOTE] = ACTIONS(2733),
    [anon_sym_U_SQUOTE] = ACTIONS(2733),
    [anon_sym_u8_SQUOTE] = ACTIONS(2733),
    [anon_sym_SQUOTE] = ACTIONS(2733),
    [anon_sym_L_DQUOTE] = ACTIONS(2733),
    [anon_sym_u_DQUOTE] = ACTIONS(2733),
    [anon_sym_U_DQUOTE] = ACTIONS(2733),
    [anon_sym_u8_DQUOTE] = ACTIONS(2733),
    [anon_sym_DQUOTE] = ACTIONS(2733),
    [sym_true] = ACTIONS(2731),
    [sym_false] = ACTIONS(2731),
    [anon_sym_NULL] = ACTIONS(2731),
    [anon_sym_nullptr] = ACTIONS(2731),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2731),
    [anon_sym_decltype] = ACTIONS(2731),
    [anon_sym_virtual] = ACTIONS(2731),
    [anon_sym_alignas] = ACTIONS(2731),
    [anon_sym_explicit] = ACTIONS(2731),
    [anon_sym_typename] = ACTIONS(2731),
    [anon_sym_template] = ACTIONS(2731),
    [anon_sym_operator] = ACTIONS(2731),
    [anon_sym_try] = ACTIONS(2731),
    [anon_sym_delete] = ACTIONS(2731),
    [anon_sym_throw] = ACTIONS(2731),
    [anon_sym_namespace] = ACTIONS(2731),
    [anon_sym_using] = ACTIONS(2731),
    [anon_sym_static_assert] = ACTIONS(2731),
    [anon_sym_concept] = ACTIONS(2731),
    [anon_sym_co_return] = ACTIONS(2731),
    [anon_sym_co_yield] = ACTIONS(2731),
    [anon_sym_R_DQUOTE] = ACTIONS(2733),
    [anon_sym_LR_DQUOTE] = ACTIONS(2733),
    [anon_sym_uR_DQUOTE] = ACTIONS(2733),
    [anon_sym_UR_DQUOTE] = ACTIONS(2733),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2733),
    [anon_sym_co_await] = ACTIONS(2731),
    [anon_sym_new] = ACTIONS(2731),
    [anon_sym_requires] = ACTIONS(2731),
    [sym_this] = ACTIONS(2731),
  },
  [299] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token2] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [aux_sym_preproc_else_token1] = ACTIONS(2643),
    [aux_sym_preproc_elif_token1] = ACTIONS(2643),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [300] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token2] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [aux_sym_preproc_else_token1] = ACTIONS(2643),
    [aux_sym_preproc_elif_token1] = ACTIONS(2643),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [301] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token2] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [aux_sym_preproc_else_token1] = ACTIONS(2643),
    [aux_sym_preproc_elif_token1] = ACTIONS(2643),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [302] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token2] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [aux_sym_preproc_else_token1] = ACTIONS(2643),
    [aux_sym_preproc_elif_token1] = ACTIONS(2643),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [303] = {
    [sym_identifier] = ACTIONS(2735),
    [aux_sym_preproc_include_token1] = ACTIONS(2735),
    [aux_sym_preproc_def_token1] = ACTIONS(2735),
    [aux_sym_preproc_if_token1] = ACTIONS(2735),
    [aux_sym_preproc_if_token2] = ACTIONS(2735),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2735),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2735),
    [aux_sym_preproc_else_token1] = ACTIONS(2735),
    [aux_sym_preproc_elif_token1] = ACTIONS(2735),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2735),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2735),
    [sym_preproc_directive] = ACTIONS(2735),
    [anon_sym_LPAREN2] = ACTIONS(2737),
    [anon_sym_BANG] = ACTIONS(2737),
    [anon_sym_TILDE] = ACTIONS(2737),
    [anon_sym_DASH] = ACTIONS(2735),
    [anon_sym_PLUS] = ACTIONS(2735),
    [anon_sym_STAR] = ACTIONS(2737),
    [anon_sym_AMP_AMP] = ACTIONS(2737),
    [anon_sym_AMP] = ACTIONS(2735),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym___extension__] = ACTIONS(2735),
    [anon_sym_typedef] = ACTIONS(2735),
    [anon_sym_extern] = ACTIONS(2735),
    [anon_sym___attribute__] = ACTIONS(2735),
    [anon_sym_COLON_COLON] = ACTIONS(2737),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2737),
    [anon_sym___declspec] = ACTIONS(2735),
    [anon_sym___based] = ACTIONS(2735),
    [anon_sym___cdecl] = ACTIONS(2735),
    [anon_sym___clrcall] = ACTIONS(2735),
    [anon_sym___stdcall] = ACTIONS(2735),
    [anon_sym___fastcall] = ACTIONS(2735),
    [anon_sym___thiscall] = ACTIONS(2735),
    [anon_sym___vectorcall] = ACTIONS(2735),
    [anon_sym_LBRACE] = ACTIONS(2737),
    [anon_sym_signed] = ACTIONS(2735),
    [anon_sym_unsigned] = ACTIONS(2735),
    [anon_sym_long] = ACTIONS(2735),
    [anon_sym_short] = ACTIONS(2735),
    [anon_sym_LBRACK] = ACTIONS(2735),
    [anon_sym_static] = ACTIONS(2735),
    [anon_sym_register] = ACTIONS(2735),
    [anon_sym_inline] = ACTIONS(2735),
    [anon_sym___inline] = ACTIONS(2735),
    [anon_sym___inline__] = ACTIONS(2735),
    [anon_sym___forceinline] = ACTIONS(2735),
    [anon_sym_thread_local] = ACTIONS(2735),
    [anon_sym___thread] = ACTIONS(2735),
    [anon_sym_const] = ACTIONS(2735),
    [anon_sym_constexpr] = ACTIONS(2735),
    [anon_sym_volatile] = ACTIONS(2735),
    [anon_sym_restrict] = ACTIONS(2735),
    [anon_sym___restrict__] = ACTIONS(2735),
    [anon_sym__Atomic] = ACTIONS(2735),
    [anon_sym__Noreturn] = ACTIONS(2735),
    [anon_sym_noreturn] = ACTIONS(2735),
    [anon_sym_mutable] = ACTIONS(2735),
    [anon_sym_constinit] = ACTIONS(2735),
    [anon_sym_consteval] = ACTIONS(2735),
    [anon_sym_PROGMEM] = ACTIONS(2735),
    [aux_sym_primitive_type_token1] = ACTIONS(2735),
    [anon_sym_byte] = ACTIONS(2735),
    [anon_sym_word] = ACTIONS(2735),
    [anon_sym_enum] = ACTIONS(2735),
    [anon_sym_class] = ACTIONS(2735),
    [anon_sym_struct] = ACTIONS(2735),
    [anon_sym_union] = ACTIONS(2735),
    [anon_sym_if] = ACTIONS(2735),
    [anon_sym_else] = ACTIONS(2735),
    [anon_sym_switch] = ACTIONS(2735),
    [anon_sym_case] = ACTIONS(2735),
    [anon_sym_default] = ACTIONS(2735),
    [anon_sym_while] = ACTIONS(2735),
    [anon_sym_do] = ACTIONS(2735),
    [anon_sym_for] = ACTIONS(2735),
    [anon_sym_return] = ACTIONS(2735),
    [anon_sym_break] = ACTIONS(2735),
    [anon_sym_continue] = ACTIONS(2735),
    [anon_sym_goto] = ACTIONS(2735),
    [anon_sym___try] = ACTIONS(2735),
    [anon_sym___leave] = ACTIONS(2735),
    [anon_sym_not] = ACTIONS(2735),
    [anon_sym_compl] = ACTIONS(2735),
    [anon_sym_DASH_DASH] = ACTIONS(2737),
    [anon_sym_PLUS_PLUS] = ACTIONS(2737),
    [anon_sym_sizeof] = ACTIONS(2735),
    [anon_sym___alignof__] = ACTIONS(2735),
    [anon_sym___alignof] = ACTIONS(2735),
    [anon_sym__alignof] = ACTIONS(2735),
    [anon_sym_alignof] = ACTIONS(2735),
    [anon_sym__Alignof] = ACTIONS(2735),
    [anon_sym_offsetof] = ACTIONS(2735),
    [anon_sym__Generic] = ACTIONS(2735),
    [anon_sym_asm] = ACTIONS(2735),
    [anon_sym___asm__] = ACTIONS(2735),
    [aux_sym_number_literal_token1] = ACTIONS(2737),
    [aux_sym_number_literal_token2] = ACTIONS(2735),
    [anon_sym_L_SQUOTE] = ACTIONS(2737),
    [anon_sym_u_SQUOTE] = ACTIONS(2737),
    [anon_sym_U_SQUOTE] = ACTIONS(2737),
    [anon_sym_u8_SQUOTE] = ACTIONS(2737),
    [anon_sym_SQUOTE] = ACTIONS(2737),
    [anon_sym_L_DQUOTE] = ACTIONS(2737),
    [anon_sym_u_DQUOTE] = ACTIONS(2737),
    [anon_sym_U_DQUOTE] = ACTIONS(2737),
    [anon_sym_u8_DQUOTE] = ACTIONS(2737),
    [anon_sym_DQUOTE] = ACTIONS(2737),
    [sym_true] = ACTIONS(2735),
    [sym_false] = ACTIONS(2735),
    [anon_sym_NULL] = ACTIONS(2735),
    [anon_sym_nullptr] = ACTIONS(2735),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2735),
    [anon_sym_decltype] = ACTIONS(2735),
    [anon_sym_virtual] = ACTIONS(2735),
    [anon_sym_alignas] = ACTIONS(2735),
    [anon_sym_explicit] = ACTIONS(2735),
    [anon_sym_typename] = ACTIONS(2735),
    [anon_sym_template] = ACTIONS(2735),
    [anon_sym_operator] = ACTIONS(2735),
    [anon_sym_try] = ACTIONS(2735),
    [anon_sym_delete] = ACTIONS(2735),
    [anon_sym_throw] = ACTIONS(2735),
    [anon_sym_namespace] = ACTIONS(2735),
    [anon_sym_using] = ACTIONS(2735),
    [anon_sym_static_assert] = ACTIONS(2735),
    [anon_sym_concept] = ACTIONS(2735),
    [anon_sym_co_return] = ACTIONS(2735),
    [anon_sym_co_yield] = ACTIONS(2735),
    [anon_sym_R_DQUOTE] = ACTIONS(2737),
    [anon_sym_LR_DQUOTE] = ACTIONS(2737),
    [anon_sym_uR_DQUOTE] = ACTIONS(2737),
    [anon_sym_UR_DQUOTE] = ACTIONS(2737),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2737),
    [anon_sym_co_await] = ACTIONS(2735),
    [anon_sym_new] = ACTIONS(2735),
    [anon_sym_requires] = ACTIONS(2735),
    [sym_this] = ACTIONS(2735),
  },
  [304] = {
    [sym_identifier] = ACTIONS(2739),
    [aux_sym_preproc_include_token1] = ACTIONS(2739),
    [aux_sym_preproc_def_token1] = ACTIONS(2739),
    [aux_sym_preproc_if_token1] = ACTIONS(2739),
    [aux_sym_preproc_if_token2] = ACTIONS(2739),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2739),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2739),
    [aux_sym_preproc_else_token1] = ACTIONS(2739),
    [aux_sym_preproc_elif_token1] = ACTIONS(2739),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2739),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2739),
    [sym_preproc_directive] = ACTIONS(2739),
    [anon_sym_LPAREN2] = ACTIONS(2741),
    [anon_sym_BANG] = ACTIONS(2741),
    [anon_sym_TILDE] = ACTIONS(2741),
    [anon_sym_DASH] = ACTIONS(2739),
    [anon_sym_PLUS] = ACTIONS(2739),
    [anon_sym_STAR] = ACTIONS(2741),
    [anon_sym_AMP_AMP] = ACTIONS(2741),
    [anon_sym_AMP] = ACTIONS(2739),
    [anon_sym_SEMI] = ACTIONS(2741),
    [anon_sym___extension__] = ACTIONS(2739),
    [anon_sym_typedef] = ACTIONS(2739),
    [anon_sym_extern] = ACTIONS(2739),
    [anon_sym___attribute__] = ACTIONS(2739),
    [anon_sym_COLON_COLON] = ACTIONS(2741),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2741),
    [anon_sym___declspec] = ACTIONS(2739),
    [anon_sym___based] = ACTIONS(2739),
    [anon_sym___cdecl] = ACTIONS(2739),
    [anon_sym___clrcall] = ACTIONS(2739),
    [anon_sym___stdcall] = ACTIONS(2739),
    [anon_sym___fastcall] = ACTIONS(2739),
    [anon_sym___thiscall] = ACTIONS(2739),
    [anon_sym___vectorcall] = ACTIONS(2739),
    [anon_sym_LBRACE] = ACTIONS(2741),
    [anon_sym_signed] = ACTIONS(2739),
    [anon_sym_unsigned] = ACTIONS(2739),
    [anon_sym_long] = ACTIONS(2739),
    [anon_sym_short] = ACTIONS(2739),
    [anon_sym_LBRACK] = ACTIONS(2739),
    [anon_sym_static] = ACTIONS(2739),
    [anon_sym_register] = ACTIONS(2739),
    [anon_sym_inline] = ACTIONS(2739),
    [anon_sym___inline] = ACTIONS(2739),
    [anon_sym___inline__] = ACTIONS(2739),
    [anon_sym___forceinline] = ACTIONS(2739),
    [anon_sym_thread_local] = ACTIONS(2739),
    [anon_sym___thread] = ACTIONS(2739),
    [anon_sym_const] = ACTIONS(2739),
    [anon_sym_constexpr] = ACTIONS(2739),
    [anon_sym_volatile] = ACTIONS(2739),
    [anon_sym_restrict] = ACTIONS(2739),
    [anon_sym___restrict__] = ACTIONS(2739),
    [anon_sym__Atomic] = ACTIONS(2739),
    [anon_sym__Noreturn] = ACTIONS(2739),
    [anon_sym_noreturn] = ACTIONS(2739),
    [anon_sym_mutable] = ACTIONS(2739),
    [anon_sym_constinit] = ACTIONS(2739),
    [anon_sym_consteval] = ACTIONS(2739),
    [anon_sym_PROGMEM] = ACTIONS(2739),
    [aux_sym_primitive_type_token1] = ACTIONS(2739),
    [anon_sym_byte] = ACTIONS(2739),
    [anon_sym_word] = ACTIONS(2739),
    [anon_sym_enum] = ACTIONS(2739),
    [anon_sym_class] = ACTIONS(2739),
    [anon_sym_struct] = ACTIONS(2739),
    [anon_sym_union] = ACTIONS(2739),
    [anon_sym_if] = ACTIONS(2739),
    [anon_sym_else] = ACTIONS(2739),
    [anon_sym_switch] = ACTIONS(2739),
    [anon_sym_case] = ACTIONS(2739),
    [anon_sym_default] = ACTIONS(2739),
    [anon_sym_while] = ACTIONS(2739),
    [anon_sym_do] = ACTIONS(2739),
    [anon_sym_for] = ACTIONS(2739),
    [anon_sym_return] = ACTIONS(2739),
    [anon_sym_break] = ACTIONS(2739),
    [anon_sym_continue] = ACTIONS(2739),
    [anon_sym_goto] = ACTIONS(2739),
    [anon_sym___try] = ACTIONS(2739),
    [anon_sym___leave] = ACTIONS(2739),
    [anon_sym_not] = ACTIONS(2739),
    [anon_sym_compl] = ACTIONS(2739),
    [anon_sym_DASH_DASH] = ACTIONS(2741),
    [anon_sym_PLUS_PLUS] = ACTIONS(2741),
    [anon_sym_sizeof] = ACTIONS(2739),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2739),
    [anon_sym__Generic] = ACTIONS(2739),
    [anon_sym_asm] = ACTIONS(2739),
    [anon_sym___asm__] = ACTIONS(2739),
    [aux_sym_number_literal_token1] = ACTIONS(2741),
    [aux_sym_number_literal_token2] = ACTIONS(2739),
    [anon_sym_L_SQUOTE] = ACTIONS(2741),
    [anon_sym_u_SQUOTE] = ACTIONS(2741),
    [anon_sym_U_SQUOTE] = ACTIONS(2741),
    [anon_sym_u8_SQUOTE] = ACTIONS(2741),
    [anon_sym_SQUOTE] = ACTIONS(2741),
    [anon_sym_L_DQUOTE] = ACTIONS(2741),
    [anon_sym_u_DQUOTE] = ACTIONS(2741),
    [anon_sym_U_DQUOTE] = ACTIONS(2741),
    [anon_sym_u8_DQUOTE] = ACTIONS(2741),
    [anon_sym_DQUOTE] = ACTIONS(2741),
    [sym_true] = ACTIONS(2739),
    [sym_false] = ACTIONS(2739),
    [anon_sym_NULL] = ACTIONS(2739),
    [anon_sym_nullptr] = ACTIONS(2739),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2739),
    [anon_sym_decltype] = ACTIONS(2739),
    [anon_sym_virtual] = ACTIONS(2739),
    [anon_sym_alignas] = ACTIONS(2739),
    [anon_sym_explicit] = ACTIONS(2739),
    [anon_sym_typename] = ACTIONS(2739),
    [anon_sym_template] = ACTIONS(2739),
    [anon_sym_operator] = ACTIONS(2739),
    [anon_sym_try] = ACTIONS(2739),
    [anon_sym_delete] = ACTIONS(2739),
    [anon_sym_throw] = ACTIONS(2739),
    [anon_sym_namespace] = ACTIONS(2739),
    [anon_sym_using] = ACTIONS(2739),
    [anon_sym_static_assert] = ACTIONS(2739),
    [anon_sym_concept] = ACTIONS(2739),
    [anon_sym_co_return] = ACTIONS(2739),
    [anon_sym_co_yield] = ACTIONS(2739),
    [anon_sym_R_DQUOTE] = ACTIONS(2741),
    [anon_sym_LR_DQUOTE] = ACTIONS(2741),
    [anon_sym_uR_DQUOTE] = ACTIONS(2741),
    [anon_sym_UR_DQUOTE] = ACTIONS(2741),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2741),
    [anon_sym_co_await] = ACTIONS(2739),
    [anon_sym_new] = ACTIONS(2739),
    [anon_sym_requires] = ACTIONS(2739),
    [sym_this] = ACTIONS(2739),
  },
  [305] = {
    [sym_identifier] = ACTIONS(1957),
    [aux_sym_preproc_include_token1] = ACTIONS(1957),
    [aux_sym_preproc_def_token1] = ACTIONS(1957),
    [anon_sym_COMMA] = ACTIONS(2743),
    [aux_sym_preproc_if_token1] = ACTIONS(1957),
    [aux_sym_preproc_if_token2] = ACTIONS(1957),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1957),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1957),
    [aux_sym_preproc_else_token1] = ACTIONS(1957),
    [aux_sym_preproc_elif_token1] = ACTIONS(1957),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1957),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1957),
    [sym_preproc_directive] = ACTIONS(1957),
    [anon_sym_LPAREN2] = ACTIONS(1955),
    [anon_sym_BANG] = ACTIONS(1955),
    [anon_sym_TILDE] = ACTIONS(1955),
    [anon_sym_DASH] = ACTIONS(1957),
    [anon_sym_PLUS] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(1955),
    [anon_sym_AMP_AMP] = ACTIONS(1955),
    [anon_sym_AMP] = ACTIONS(1957),
    [anon_sym_SEMI] = ACTIONS(2743),
    [anon_sym___extension__] = ACTIONS(1957),
    [anon_sym_typedef] = ACTIONS(1957),
    [anon_sym_extern] = ACTIONS(1957),
    [anon_sym___attribute__] = ACTIONS(1957),
    [anon_sym_COLON_COLON] = ACTIONS(1955),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1955),
    [anon_sym___declspec] = ACTIONS(1957),
    [anon_sym___based] = ACTIONS(1957),
    [anon_sym___cdecl] = ACTIONS(1957),
    [anon_sym___clrcall] = ACTIONS(1957),
    [anon_sym___stdcall] = ACTIONS(1957),
    [anon_sym___fastcall] = ACTIONS(1957),
    [anon_sym___thiscall] = ACTIONS(1957),
    [anon_sym___vectorcall] = ACTIONS(1957),
    [anon_sym_LBRACE] = ACTIONS(1955),
    [anon_sym_signed] = ACTIONS(1957),
    [anon_sym_unsigned] = ACTIONS(1957),
    [anon_sym_long] = ACTIONS(1957),
    [anon_sym_short] = ACTIONS(1957),
    [anon_sym_LBRACK] = ACTIONS(1957),
    [anon_sym_static] = ACTIONS(1957),
    [anon_sym_register] = ACTIONS(1957),
    [anon_sym_inline] = ACTIONS(1957),
    [anon_sym___inline] = ACTIONS(1957),
    [anon_sym___inline__] = ACTIONS(1957),
    [anon_sym___forceinline] = ACTIONS(1957),
    [anon_sym_thread_local] = ACTIONS(1957),
    [anon_sym___thread] = ACTIONS(1957),
    [anon_sym_const] = ACTIONS(1957),
    [anon_sym_constexpr] = ACTIONS(1957),
    [anon_sym_volatile] = ACTIONS(1957),
    [anon_sym_restrict] = ACTIONS(1957),
    [anon_sym___restrict__] = ACTIONS(1957),
    [anon_sym__Atomic] = ACTIONS(1957),
    [anon_sym__Noreturn] = ACTIONS(1957),
    [anon_sym_noreturn] = ACTIONS(1957),
    [anon_sym_mutable] = ACTIONS(1957),
    [anon_sym_constinit] = ACTIONS(1957),
    [anon_sym_consteval] = ACTIONS(1957),
    [anon_sym_PROGMEM] = ACTIONS(1957),
    [aux_sym_primitive_type_token1] = ACTIONS(1957),
    [anon_sym_byte] = ACTIONS(1957),
    [anon_sym_word] = ACTIONS(1957),
    [anon_sym_enum] = ACTIONS(1957),
    [anon_sym_class] = ACTIONS(1957),
    [anon_sym_struct] = ACTIONS(1957),
    [anon_sym_union] = ACTIONS(1957),
    [anon_sym_if] = ACTIONS(1957),
    [anon_sym_switch] = ACTIONS(1957),
    [anon_sym_case] = ACTIONS(1957),
    [anon_sym_default] = ACTIONS(1957),
    [anon_sym_while] = ACTIONS(1957),
    [anon_sym_do] = ACTIONS(1957),
    [anon_sym_for] = ACTIONS(1957),
    [anon_sym_return] = ACTIONS(1957),
    [anon_sym_break] = ACTIONS(1957),
    [anon_sym_continue] = ACTIONS(1957),
    [anon_sym_goto] = ACTIONS(1957),
    [anon_sym___try] = ACTIONS(1957),
    [anon_sym___leave] = ACTIONS(1957),
    [anon_sym_not] = ACTIONS(1957),
    [anon_sym_compl] = ACTIONS(1957),
    [anon_sym_DASH_DASH] = ACTIONS(1955),
    [anon_sym_PLUS_PLUS] = ACTIONS(1955),
    [anon_sym_sizeof] = ACTIONS(1957),
    [anon_sym___alignof__] = ACTIONS(1957),
    [anon_sym___alignof] = ACTIONS(1957),
    [anon_sym__alignof] = ACTIONS(1957),
    [anon_sym_alignof] = ACTIONS(1957),
    [anon_sym__Alignof] = ACTIONS(1957),
    [anon_sym_offsetof] = ACTIONS(1957),
    [anon_sym__Generic] = ACTIONS(1957),
    [anon_sym_asm] = ACTIONS(1957),
    [anon_sym___asm__] = ACTIONS(1957),
    [aux_sym_number_literal_token1] = ACTIONS(1955),
    [aux_sym_number_literal_token2] = ACTIONS(1957),
    [anon_sym_L_SQUOTE] = ACTIONS(1955),
    [anon_sym_u_SQUOTE] = ACTIONS(1955),
    [anon_sym_U_SQUOTE] = ACTIONS(1955),
    [anon_sym_u8_SQUOTE] = ACTIONS(1955),
    [anon_sym_SQUOTE] = ACTIONS(1955),
    [anon_sym_L_DQUOTE] = ACTIONS(1955),
    [anon_sym_u_DQUOTE] = ACTIONS(1955),
    [anon_sym_U_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8_DQUOTE] = ACTIONS(1955),
    [anon_sym_DQUOTE] = ACTIONS(1955),
    [sym_true] = ACTIONS(1957),
    [sym_false] = ACTIONS(1957),
    [anon_sym_NULL] = ACTIONS(1957),
    [anon_sym_nullptr] = ACTIONS(1957),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1957),
    [anon_sym_decltype] = ACTIONS(1957),
    [anon_sym_virtual] = ACTIONS(1957),
    [anon_sym_alignas] = ACTIONS(1957),
    [anon_sym_explicit] = ACTIONS(1957),
    [anon_sym_typename] = ACTIONS(1957),
    [anon_sym_template] = ACTIONS(1957),
    [anon_sym_operator] = ACTIONS(1957),
    [anon_sym_try] = ACTIONS(1957),
    [anon_sym_delete] = ACTIONS(1957),
    [anon_sym_throw] = ACTIONS(1957),
    [anon_sym_namespace] = ACTIONS(1957),
    [anon_sym_using] = ACTIONS(1957),
    [anon_sym_static_assert] = ACTIONS(1957),
    [anon_sym_concept] = ACTIONS(1957),
    [anon_sym_co_return] = ACTIONS(1957),
    [anon_sym_co_yield] = ACTIONS(1957),
    [anon_sym_R_DQUOTE] = ACTIONS(1955),
    [anon_sym_LR_DQUOTE] = ACTIONS(1955),
    [anon_sym_uR_DQUOTE] = ACTIONS(1955),
    [anon_sym_UR_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1955),
    [anon_sym_co_await] = ACTIONS(1957),
    [anon_sym_new] = ACTIONS(1957),
    [anon_sym_requires] = ACTIONS(1957),
    [sym_this] = ACTIONS(1957),
  },
  [306] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token2] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [aux_sym_preproc_else_token1] = ACTIONS(2643),
    [aux_sym_preproc_elif_token1] = ACTIONS(2643),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [307] = {
    [sym_type_qualifier] = STATE(3799),
    [sym__type_specifier] = STATE(4801),
    [sym_sized_type_specifier] = STATE(2935),
    [sym_primitive_type] = STATE(4963),
    [sym_enum_specifier] = STATE(2935),
    [sym_struct_specifier] = STATE(2935),
    [sym_union_specifier] = STATE(2935),
    [sym__expression] = STATE(4327),
    [sym__expression_not_binary] = STATE(4648),
    [sym__string] = STATE(4648),
    [sym_conditional_expression] = STATE(4648),
    [sym_assignment_expression] = STATE(4648),
    [sym_pointer_expression] = STATE(3663),
    [sym_unary_expression] = STATE(4648),
    [sym_binary_expression] = STATE(4648),
    [sym_update_expression] = STATE(4648),
    [sym_cast_expression] = STATE(4648),
    [sym_type_descriptor] = STATE(6690),
    [sym_sizeof_expression] = STATE(4648),
    [sym_alignof_expression] = STATE(4648),
    [sym_offsetof_expression] = STATE(4648),
    [sym_generic_expression] = STATE(4648),
    [sym_subscript_expression] = STATE(3663),
    [sym_call_expression] = STATE(3663),
    [sym_gnu_asm_expression] = STATE(4648),
    [sym_field_expression] = STATE(3663),
    [sym_compound_literal_expression] = STATE(4648),
    [sym_parenthesized_expression] = STATE(3663),
    [sym_number_literal] = STATE(4573),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4565),
    [sym_string_literal] = STATE(3707),
    [sym_null] = STATE(4648),
    [sym_placeholder_type_specifier] = STATE(2935),
    [sym_decltype_auto] = STATE(2933),
    [sym_decltype] = STATE(2868),
    [sym_class_specifier] = STATE(2935),
    [sym__class_name] = STATE(7442),
    [sym_dependent_type] = STATE(2935),
    [sym_template_type] = STATE(5228),
    [sym_template_function] = STATE(4648),
    [sym_raw_string_literal] = STATE(3709),
    [sym_co_await_expression] = STATE(4648),
    [sym_new_expression] = STATE(4648),
    [sym_delete_expression] = STATE(4648),
    [sym_requires_clause] = STATE(4648),
    [sym_requires_expression] = STATE(4648),
    [sym_lambda_expression] = STATE(4648),
    [sym_lambda_capture_specifier] = STATE(5768),
    [sym_fold_expression] = STATE(4648),
    [sym_parameter_pack_expansion] = STATE(4648),
    [sym_type_parameter_pack_expansion] = STATE(7129),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5541),
    [sym_qualified_identifier] = STATE(3663),
    [sym_qualified_type_identifier] = STATE(5253),
    [sym_user_defined_literal] = STATE(3663),
    [aux_sym__type_definition_type_repeat1] = STATE(3799),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2164),
    [sym_identifier] = ACTIONS(2573),
    [anon_sym_LPAREN2] = ACTIONS(2575),
    [anon_sym_BANG] = ACTIONS(2577),
    [anon_sym_TILDE] = ACTIONS(2577),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2583),
    [anon_sym_signed] = ACTIONS(2585),
    [anon_sym_unsigned] = ACTIONS(2585),
    [anon_sym_long] = ACTIONS(2585),
    [anon_sym_short] = ACTIONS(2585),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2587),
    [anon_sym_byte] = ACTIONS(2587),
    [anon_sym_word] = ACTIONS(2587),
    [anon_sym_enum] = ACTIONS(2589),
    [anon_sym_class] = ACTIONS(2591),
    [anon_sym_struct] = ACTIONS(2593),
    [anon_sym_union] = ACTIONS(2595),
    [anon_sym_not] = ACTIONS(2579),
    [anon_sym_compl] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(2597),
    [anon_sym_PLUS_PLUS] = ACTIONS(2597),
    [anon_sym_sizeof] = ACTIONS(2599),
    [anon_sym___alignof__] = ACTIONS(2601),
    [anon_sym___alignof] = ACTIONS(2601),
    [anon_sym__alignof] = ACTIONS(2601),
    [anon_sym_alignof] = ACTIONS(2601),
    [anon_sym__Alignof] = ACTIONS(2601),
    [anon_sym_offsetof] = ACTIONS(2603),
    [anon_sym__Generic] = ACTIONS(2605),
    [anon_sym_asm] = ACTIONS(2607),
    [anon_sym___asm__] = ACTIONS(2607),
    [aux_sym_number_literal_token1] = ACTIONS(2609),
    [aux_sym_number_literal_token2] = ACTIONS(2611),
    [anon_sym_L_SQUOTE] = ACTIONS(2613),
    [anon_sym_u_SQUOTE] = ACTIONS(2613),
    [anon_sym_U_SQUOTE] = ACTIONS(2613),
    [anon_sym_u8_SQUOTE] = ACTIONS(2613),
    [anon_sym_SQUOTE] = ACTIONS(2613),
    [anon_sym_L_DQUOTE] = ACTIONS(2615),
    [anon_sym_u_DQUOTE] = ACTIONS(2615),
    [anon_sym_U_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8_DQUOTE] = ACTIONS(2615),
    [anon_sym_DQUOTE] = ACTIONS(2615),
    [sym_true] = ACTIONS(2617),
    [sym_false] = ACTIONS(2617),
    [anon_sym_NULL] = ACTIONS(2619),
    [anon_sym_nullptr] = ACTIONS(2619),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2621),
    [anon_sym_decltype] = ACTIONS(2623),
    [anon_sym_typename] = ACTIONS(2625),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_GT2] = ACTIONS(2745),
    [anon_sym_delete] = ACTIONS(2629),
    [anon_sym_R_DQUOTE] = ACTIONS(2631),
    [anon_sym_LR_DQUOTE] = ACTIONS(2631),
    [anon_sym_uR_DQUOTE] = ACTIONS(2631),
    [anon_sym_UR_DQUOTE] = ACTIONS(2631),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2631),
    [anon_sym_co_await] = ACTIONS(2633),
    [anon_sym_new] = ACTIONS(2635),
    [anon_sym_requires] = ACTIONS(2637),
    [sym_this] = ACTIONS(2617),
  },
  [308] = {
    [sym_identifier] = ACTIONS(2747),
    [aux_sym_preproc_include_token1] = ACTIONS(2747),
    [aux_sym_preproc_def_token1] = ACTIONS(2747),
    [aux_sym_preproc_if_token1] = ACTIONS(2747),
    [aux_sym_preproc_if_token2] = ACTIONS(2747),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2747),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2747),
    [aux_sym_preproc_else_token1] = ACTIONS(2747),
    [aux_sym_preproc_elif_token1] = ACTIONS(2747),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2747),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2747),
    [sym_preproc_directive] = ACTIONS(2747),
    [anon_sym_LPAREN2] = ACTIONS(2749),
    [anon_sym_BANG] = ACTIONS(2749),
    [anon_sym_TILDE] = ACTIONS(2749),
    [anon_sym_DASH] = ACTIONS(2747),
    [anon_sym_PLUS] = ACTIONS(2747),
    [anon_sym_STAR] = ACTIONS(2749),
    [anon_sym_AMP_AMP] = ACTIONS(2749),
    [anon_sym_AMP] = ACTIONS(2747),
    [anon_sym_SEMI] = ACTIONS(2749),
    [anon_sym___extension__] = ACTIONS(2747),
    [anon_sym_typedef] = ACTIONS(2747),
    [anon_sym_extern] = ACTIONS(2747),
    [anon_sym___attribute__] = ACTIONS(2747),
    [anon_sym_COLON_COLON] = ACTIONS(2749),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2749),
    [anon_sym___declspec] = ACTIONS(2747),
    [anon_sym___based] = ACTIONS(2747),
    [anon_sym___cdecl] = ACTIONS(2747),
    [anon_sym___clrcall] = ACTIONS(2747),
    [anon_sym___stdcall] = ACTIONS(2747),
    [anon_sym___fastcall] = ACTIONS(2747),
    [anon_sym___thiscall] = ACTIONS(2747),
    [anon_sym___vectorcall] = ACTIONS(2747),
    [anon_sym_LBRACE] = ACTIONS(2749),
    [anon_sym_signed] = ACTIONS(2747),
    [anon_sym_unsigned] = ACTIONS(2747),
    [anon_sym_long] = ACTIONS(2747),
    [anon_sym_short] = ACTIONS(2747),
    [anon_sym_LBRACK] = ACTIONS(2747),
    [anon_sym_static] = ACTIONS(2747),
    [anon_sym_register] = ACTIONS(2747),
    [anon_sym_inline] = ACTIONS(2747),
    [anon_sym___inline] = ACTIONS(2747),
    [anon_sym___inline__] = ACTIONS(2747),
    [anon_sym___forceinline] = ACTIONS(2747),
    [anon_sym_thread_local] = ACTIONS(2747),
    [anon_sym___thread] = ACTIONS(2747),
    [anon_sym_const] = ACTIONS(2747),
    [anon_sym_constexpr] = ACTIONS(2747),
    [anon_sym_volatile] = ACTIONS(2747),
    [anon_sym_restrict] = ACTIONS(2747),
    [anon_sym___restrict__] = ACTIONS(2747),
    [anon_sym__Atomic] = ACTIONS(2747),
    [anon_sym__Noreturn] = ACTIONS(2747),
    [anon_sym_noreturn] = ACTIONS(2747),
    [anon_sym_mutable] = ACTIONS(2747),
    [anon_sym_constinit] = ACTIONS(2747),
    [anon_sym_consteval] = ACTIONS(2747),
    [anon_sym_PROGMEM] = ACTIONS(2747),
    [aux_sym_primitive_type_token1] = ACTIONS(2747),
    [anon_sym_byte] = ACTIONS(2747),
    [anon_sym_word] = ACTIONS(2747),
    [anon_sym_enum] = ACTIONS(2747),
    [anon_sym_class] = ACTIONS(2747),
    [anon_sym_struct] = ACTIONS(2747),
    [anon_sym_union] = ACTIONS(2747),
    [anon_sym_if] = ACTIONS(2747),
    [anon_sym_else] = ACTIONS(2747),
    [anon_sym_switch] = ACTIONS(2747),
    [anon_sym_case] = ACTIONS(2747),
    [anon_sym_default] = ACTIONS(2747),
    [anon_sym_while] = ACTIONS(2747),
    [anon_sym_do] = ACTIONS(2747),
    [anon_sym_for] = ACTIONS(2747),
    [anon_sym_return] = ACTIONS(2747),
    [anon_sym_break] = ACTIONS(2747),
    [anon_sym_continue] = ACTIONS(2747),
    [anon_sym_goto] = ACTIONS(2747),
    [anon_sym___try] = ACTIONS(2747),
    [anon_sym___leave] = ACTIONS(2747),
    [anon_sym_not] = ACTIONS(2747),
    [anon_sym_compl] = ACTIONS(2747),
    [anon_sym_DASH_DASH] = ACTIONS(2749),
    [anon_sym_PLUS_PLUS] = ACTIONS(2749),
    [anon_sym_sizeof] = ACTIONS(2747),
    [anon_sym___alignof__] = ACTIONS(2747),
    [anon_sym___alignof] = ACTIONS(2747),
    [anon_sym__alignof] = ACTIONS(2747),
    [anon_sym_alignof] = ACTIONS(2747),
    [anon_sym__Alignof] = ACTIONS(2747),
    [anon_sym_offsetof] = ACTIONS(2747),
    [anon_sym__Generic] = ACTIONS(2747),
    [anon_sym_asm] = ACTIONS(2747),
    [anon_sym___asm__] = ACTIONS(2747),
    [aux_sym_number_literal_token1] = ACTIONS(2749),
    [aux_sym_number_literal_token2] = ACTIONS(2747),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2749),
    [anon_sym_u_DQUOTE] = ACTIONS(2749),
    [anon_sym_U_DQUOTE] = ACTIONS(2749),
    [anon_sym_u8_DQUOTE] = ACTIONS(2749),
    [anon_sym_DQUOTE] = ACTIONS(2749),
    [sym_true] = ACTIONS(2747),
    [sym_false] = ACTIONS(2747),
    [anon_sym_NULL] = ACTIONS(2747),
    [anon_sym_nullptr] = ACTIONS(2747),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2747),
    [anon_sym_decltype] = ACTIONS(2747),
    [anon_sym_virtual] = ACTIONS(2747),
    [anon_sym_alignas] = ACTIONS(2747),
    [anon_sym_explicit] = ACTIONS(2747),
    [anon_sym_typename] = ACTIONS(2747),
    [anon_sym_template] = ACTIONS(2747),
    [anon_sym_operator] = ACTIONS(2747),
    [anon_sym_try] = ACTIONS(2747),
    [anon_sym_delete] = ACTIONS(2747),
    [anon_sym_throw] = ACTIONS(2747),
    [anon_sym_namespace] = ACTIONS(2747),
    [anon_sym_using] = ACTIONS(2747),
    [anon_sym_static_assert] = ACTIONS(2747),
    [anon_sym_concept] = ACTIONS(2747),
    [anon_sym_co_return] = ACTIONS(2747),
    [anon_sym_co_yield] = ACTIONS(2747),
    [anon_sym_R_DQUOTE] = ACTIONS(2749),
    [anon_sym_LR_DQUOTE] = ACTIONS(2749),
    [anon_sym_uR_DQUOTE] = ACTIONS(2749),
    [anon_sym_UR_DQUOTE] = ACTIONS(2749),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2749),
    [anon_sym_co_await] = ACTIONS(2747),
    [anon_sym_new] = ACTIONS(2747),
    [anon_sym_requires] = ACTIONS(2747),
    [sym_this] = ACTIONS(2747),
  },
  [309] = {
    [sym_identifier] = ACTIONS(2751),
    [aux_sym_preproc_include_token1] = ACTIONS(2751),
    [aux_sym_preproc_def_token1] = ACTIONS(2751),
    [aux_sym_preproc_if_token1] = ACTIONS(2751),
    [aux_sym_preproc_if_token2] = ACTIONS(2751),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2751),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2751),
    [aux_sym_preproc_else_token1] = ACTIONS(2751),
    [aux_sym_preproc_elif_token1] = ACTIONS(2751),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2751),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2751),
    [sym_preproc_directive] = ACTIONS(2751),
    [anon_sym_LPAREN2] = ACTIONS(2753),
    [anon_sym_BANG] = ACTIONS(2753),
    [anon_sym_TILDE] = ACTIONS(2753),
    [anon_sym_DASH] = ACTIONS(2751),
    [anon_sym_PLUS] = ACTIONS(2751),
    [anon_sym_STAR] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2751),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym___extension__] = ACTIONS(2751),
    [anon_sym_typedef] = ACTIONS(2751),
    [anon_sym_extern] = ACTIONS(2751),
    [anon_sym___attribute__] = ACTIONS(2751),
    [anon_sym_COLON_COLON] = ACTIONS(2753),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2753),
    [anon_sym___declspec] = ACTIONS(2751),
    [anon_sym___based] = ACTIONS(2751),
    [anon_sym___cdecl] = ACTIONS(2751),
    [anon_sym___clrcall] = ACTIONS(2751),
    [anon_sym___stdcall] = ACTIONS(2751),
    [anon_sym___fastcall] = ACTIONS(2751),
    [anon_sym___thiscall] = ACTIONS(2751),
    [anon_sym___vectorcall] = ACTIONS(2751),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_signed] = ACTIONS(2751),
    [anon_sym_unsigned] = ACTIONS(2751),
    [anon_sym_long] = ACTIONS(2751),
    [anon_sym_short] = ACTIONS(2751),
    [anon_sym_LBRACK] = ACTIONS(2751),
    [anon_sym_static] = ACTIONS(2751),
    [anon_sym_register] = ACTIONS(2751),
    [anon_sym_inline] = ACTIONS(2751),
    [anon_sym___inline] = ACTIONS(2751),
    [anon_sym___inline__] = ACTIONS(2751),
    [anon_sym___forceinline] = ACTIONS(2751),
    [anon_sym_thread_local] = ACTIONS(2751),
    [anon_sym___thread] = ACTIONS(2751),
    [anon_sym_const] = ACTIONS(2751),
    [anon_sym_constexpr] = ACTIONS(2751),
    [anon_sym_volatile] = ACTIONS(2751),
    [anon_sym_restrict] = ACTIONS(2751),
    [anon_sym___restrict__] = ACTIONS(2751),
    [anon_sym__Atomic] = ACTIONS(2751),
    [anon_sym__Noreturn] = ACTIONS(2751),
    [anon_sym_noreturn] = ACTIONS(2751),
    [anon_sym_mutable] = ACTIONS(2751),
    [anon_sym_constinit] = ACTIONS(2751),
    [anon_sym_consteval] = ACTIONS(2751),
    [anon_sym_PROGMEM] = ACTIONS(2751),
    [aux_sym_primitive_type_token1] = ACTIONS(2751),
    [anon_sym_byte] = ACTIONS(2751),
    [anon_sym_word] = ACTIONS(2751),
    [anon_sym_enum] = ACTIONS(2751),
    [anon_sym_class] = ACTIONS(2751),
    [anon_sym_struct] = ACTIONS(2751),
    [anon_sym_union] = ACTIONS(2751),
    [anon_sym_if] = ACTIONS(2751),
    [anon_sym_else] = ACTIONS(2751),
    [anon_sym_switch] = ACTIONS(2751),
    [anon_sym_case] = ACTIONS(2751),
    [anon_sym_default] = ACTIONS(2751),
    [anon_sym_while] = ACTIONS(2751),
    [anon_sym_do] = ACTIONS(2751),
    [anon_sym_for] = ACTIONS(2751),
    [anon_sym_return] = ACTIONS(2751),
    [anon_sym_break] = ACTIONS(2751),
    [anon_sym_continue] = ACTIONS(2751),
    [anon_sym_goto] = ACTIONS(2751),
    [anon_sym___try] = ACTIONS(2751),
    [anon_sym___leave] = ACTIONS(2751),
    [anon_sym_not] = ACTIONS(2751),
    [anon_sym_compl] = ACTIONS(2751),
    [anon_sym_DASH_DASH] = ACTIONS(2753),
    [anon_sym_PLUS_PLUS] = ACTIONS(2753),
    [anon_sym_sizeof] = ACTIONS(2751),
    [anon_sym___alignof__] = ACTIONS(2751),
    [anon_sym___alignof] = ACTIONS(2751),
    [anon_sym__alignof] = ACTIONS(2751),
    [anon_sym_alignof] = ACTIONS(2751),
    [anon_sym__Alignof] = ACTIONS(2751),
    [anon_sym_offsetof] = ACTIONS(2751),
    [anon_sym__Generic] = ACTIONS(2751),
    [anon_sym_asm] = ACTIONS(2751),
    [anon_sym___asm__] = ACTIONS(2751),
    [aux_sym_number_literal_token1] = ACTIONS(2753),
    [aux_sym_number_literal_token2] = ACTIONS(2751),
    [anon_sym_L_SQUOTE] = ACTIONS(2753),
    [anon_sym_u_SQUOTE] = ACTIONS(2753),
    [anon_sym_U_SQUOTE] = ACTIONS(2753),
    [anon_sym_u8_SQUOTE] = ACTIONS(2753),
    [anon_sym_SQUOTE] = ACTIONS(2753),
    [anon_sym_L_DQUOTE] = ACTIONS(2753),
    [anon_sym_u_DQUOTE] = ACTIONS(2753),
    [anon_sym_U_DQUOTE] = ACTIONS(2753),
    [anon_sym_u8_DQUOTE] = ACTIONS(2753),
    [anon_sym_DQUOTE] = ACTIONS(2753),
    [sym_true] = ACTIONS(2751),
    [sym_false] = ACTIONS(2751),
    [anon_sym_NULL] = ACTIONS(2751),
    [anon_sym_nullptr] = ACTIONS(2751),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2751),
    [anon_sym_decltype] = ACTIONS(2751),
    [anon_sym_virtual] = ACTIONS(2751),
    [anon_sym_alignas] = ACTIONS(2751),
    [anon_sym_explicit] = ACTIONS(2751),
    [anon_sym_typename] = ACTIONS(2751),
    [anon_sym_template] = ACTIONS(2751),
    [anon_sym_operator] = ACTIONS(2751),
    [anon_sym_try] = ACTIONS(2751),
    [anon_sym_delete] = ACTIONS(2751),
    [anon_sym_throw] = ACTIONS(2751),
    [anon_sym_namespace] = ACTIONS(2751),
    [anon_sym_using] = ACTIONS(2751),
    [anon_sym_static_assert] = ACTIONS(2751),
    [anon_sym_concept] = ACTIONS(2751),
    [anon_sym_co_return] = ACTIONS(2751),
    [anon_sym_co_yield] = ACTIONS(2751),
    [anon_sym_R_DQUOTE] = ACTIONS(2753),
    [anon_sym_LR_DQUOTE] = ACTIONS(2753),
    [anon_sym_uR_DQUOTE] = ACTIONS(2753),
    [anon_sym_UR_DQUOTE] = ACTIONS(2753),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2753),
    [anon_sym_co_await] = ACTIONS(2751),
    [anon_sym_new] = ACTIONS(2751),
    [anon_sym_requires] = ACTIONS(2751),
    [sym_this] = ACTIONS(2751),
  },
  [310] = {
    [sym_identifier] = ACTIONS(2755),
    [aux_sym_preproc_include_token1] = ACTIONS(2755),
    [aux_sym_preproc_def_token1] = ACTIONS(2755),
    [aux_sym_preproc_if_token1] = ACTIONS(2755),
    [aux_sym_preproc_if_token2] = ACTIONS(2755),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2755),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2755),
    [aux_sym_preproc_else_token1] = ACTIONS(2755),
    [aux_sym_preproc_elif_token1] = ACTIONS(2755),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2755),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2755),
    [sym_preproc_directive] = ACTIONS(2755),
    [anon_sym_LPAREN2] = ACTIONS(2757),
    [anon_sym_BANG] = ACTIONS(2757),
    [anon_sym_TILDE] = ACTIONS(2757),
    [anon_sym_DASH] = ACTIONS(2755),
    [anon_sym_PLUS] = ACTIONS(2755),
    [anon_sym_STAR] = ACTIONS(2757),
    [anon_sym_AMP_AMP] = ACTIONS(2757),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2757),
    [anon_sym___extension__] = ACTIONS(2755),
    [anon_sym_typedef] = ACTIONS(2755),
    [anon_sym_extern] = ACTIONS(2755),
    [anon_sym___attribute__] = ACTIONS(2755),
    [anon_sym_COLON_COLON] = ACTIONS(2757),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2757),
    [anon_sym___declspec] = ACTIONS(2755),
    [anon_sym___based] = ACTIONS(2755),
    [anon_sym___cdecl] = ACTIONS(2755),
    [anon_sym___clrcall] = ACTIONS(2755),
    [anon_sym___stdcall] = ACTIONS(2755),
    [anon_sym___fastcall] = ACTIONS(2755),
    [anon_sym___thiscall] = ACTIONS(2755),
    [anon_sym___vectorcall] = ACTIONS(2755),
    [anon_sym_LBRACE] = ACTIONS(2757),
    [anon_sym_signed] = ACTIONS(2755),
    [anon_sym_unsigned] = ACTIONS(2755),
    [anon_sym_long] = ACTIONS(2755),
    [anon_sym_short] = ACTIONS(2755),
    [anon_sym_LBRACK] = ACTIONS(2755),
    [anon_sym_static] = ACTIONS(2755),
    [anon_sym_register] = ACTIONS(2755),
    [anon_sym_inline] = ACTIONS(2755),
    [anon_sym___inline] = ACTIONS(2755),
    [anon_sym___inline__] = ACTIONS(2755),
    [anon_sym___forceinline] = ACTIONS(2755),
    [anon_sym_thread_local] = ACTIONS(2755),
    [anon_sym___thread] = ACTIONS(2755),
    [anon_sym_const] = ACTIONS(2755),
    [anon_sym_constexpr] = ACTIONS(2755),
    [anon_sym_volatile] = ACTIONS(2755),
    [anon_sym_restrict] = ACTIONS(2755),
    [anon_sym___restrict__] = ACTIONS(2755),
    [anon_sym__Atomic] = ACTIONS(2755),
    [anon_sym__Noreturn] = ACTIONS(2755),
    [anon_sym_noreturn] = ACTIONS(2755),
    [anon_sym_mutable] = ACTIONS(2755),
    [anon_sym_constinit] = ACTIONS(2755),
    [anon_sym_consteval] = ACTIONS(2755),
    [anon_sym_PROGMEM] = ACTIONS(2755),
    [aux_sym_primitive_type_token1] = ACTIONS(2755),
    [anon_sym_byte] = ACTIONS(2755),
    [anon_sym_word] = ACTIONS(2755),
    [anon_sym_enum] = ACTIONS(2755),
    [anon_sym_class] = ACTIONS(2755),
    [anon_sym_struct] = ACTIONS(2755),
    [anon_sym_union] = ACTIONS(2755),
    [anon_sym_if] = ACTIONS(2755),
    [anon_sym_else] = ACTIONS(2755),
    [anon_sym_switch] = ACTIONS(2755),
    [anon_sym_case] = ACTIONS(2755),
    [anon_sym_default] = ACTIONS(2755),
    [anon_sym_while] = ACTIONS(2755),
    [anon_sym_do] = ACTIONS(2755),
    [anon_sym_for] = ACTIONS(2755),
    [anon_sym_return] = ACTIONS(2755),
    [anon_sym_break] = ACTIONS(2755),
    [anon_sym_continue] = ACTIONS(2755),
    [anon_sym_goto] = ACTIONS(2755),
    [anon_sym___try] = ACTIONS(2755),
    [anon_sym___leave] = ACTIONS(2755),
    [anon_sym_not] = ACTIONS(2755),
    [anon_sym_compl] = ACTIONS(2755),
    [anon_sym_DASH_DASH] = ACTIONS(2757),
    [anon_sym_PLUS_PLUS] = ACTIONS(2757),
    [anon_sym_sizeof] = ACTIONS(2755),
    [anon_sym___alignof__] = ACTIONS(2755),
    [anon_sym___alignof] = ACTIONS(2755),
    [anon_sym__alignof] = ACTIONS(2755),
    [anon_sym_alignof] = ACTIONS(2755),
    [anon_sym__Alignof] = ACTIONS(2755),
    [anon_sym_offsetof] = ACTIONS(2755),
    [anon_sym__Generic] = ACTIONS(2755),
    [anon_sym_asm] = ACTIONS(2755),
    [anon_sym___asm__] = ACTIONS(2755),
    [aux_sym_number_literal_token1] = ACTIONS(2757),
    [aux_sym_number_literal_token2] = ACTIONS(2755),
    [anon_sym_L_SQUOTE] = ACTIONS(2757),
    [anon_sym_u_SQUOTE] = ACTIONS(2757),
    [anon_sym_U_SQUOTE] = ACTIONS(2757),
    [anon_sym_u8_SQUOTE] = ACTIONS(2757),
    [anon_sym_SQUOTE] = ACTIONS(2757),
    [anon_sym_L_DQUOTE] = ACTIONS(2757),
    [anon_sym_u_DQUOTE] = ACTIONS(2757),
    [anon_sym_U_DQUOTE] = ACTIONS(2757),
    [anon_sym_u8_DQUOTE] = ACTIONS(2757),
    [anon_sym_DQUOTE] = ACTIONS(2757),
    [sym_true] = ACTIONS(2755),
    [sym_false] = ACTIONS(2755),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2755),
    [anon_sym_decltype] = ACTIONS(2755),
    [anon_sym_virtual] = ACTIONS(2755),
    [anon_sym_alignas] = ACTIONS(2755),
    [anon_sym_explicit] = ACTIONS(2755),
    [anon_sym_typename] = ACTIONS(2755),
    [anon_sym_template] = ACTIONS(2755),
    [anon_sym_operator] = ACTIONS(2755),
    [anon_sym_try] = ACTIONS(2755),
    [anon_sym_delete] = ACTIONS(2755),
    [anon_sym_throw] = ACTIONS(2755),
    [anon_sym_namespace] = ACTIONS(2755),
    [anon_sym_using] = ACTIONS(2755),
    [anon_sym_static_assert] = ACTIONS(2755),
    [anon_sym_concept] = ACTIONS(2755),
    [anon_sym_co_return] = ACTIONS(2755),
    [anon_sym_co_yield] = ACTIONS(2755),
    [anon_sym_R_DQUOTE] = ACTIONS(2757),
    [anon_sym_LR_DQUOTE] = ACTIONS(2757),
    [anon_sym_uR_DQUOTE] = ACTIONS(2757),
    [anon_sym_UR_DQUOTE] = ACTIONS(2757),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2757),
    [anon_sym_co_await] = ACTIONS(2755),
    [anon_sym_new] = ACTIONS(2755),
    [anon_sym_requires] = ACTIONS(2755),
    [sym_this] = ACTIONS(2755),
  },
  [311] = {
    [sym_type_qualifier] = STATE(3799),
    [sym__type_specifier] = STATE(4801),
    [sym_sized_type_specifier] = STATE(2935),
    [sym_primitive_type] = STATE(4963),
    [sym_enum_specifier] = STATE(2935),
    [sym_struct_specifier] = STATE(2935),
    [sym_union_specifier] = STATE(2935),
    [sym__expression] = STATE(4302),
    [sym__expression_not_binary] = STATE(4648),
    [sym__string] = STATE(4648),
    [sym_conditional_expression] = STATE(4648),
    [sym_assignment_expression] = STATE(4648),
    [sym_pointer_expression] = STATE(3663),
    [sym_unary_expression] = STATE(4648),
    [sym_binary_expression] = STATE(4648),
    [sym_update_expression] = STATE(4648),
    [sym_cast_expression] = STATE(4648),
    [sym_type_descriptor] = STATE(6780),
    [sym_sizeof_expression] = STATE(4648),
    [sym_alignof_expression] = STATE(4648),
    [sym_offsetof_expression] = STATE(4648),
    [sym_generic_expression] = STATE(4648),
    [sym_subscript_expression] = STATE(3663),
    [sym_call_expression] = STATE(3663),
    [sym_gnu_asm_expression] = STATE(4648),
    [sym_field_expression] = STATE(3663),
    [sym_compound_literal_expression] = STATE(4648),
    [sym_parenthesized_expression] = STATE(3663),
    [sym_number_literal] = STATE(4573),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4565),
    [sym_string_literal] = STATE(3707),
    [sym_null] = STATE(4648),
    [sym_placeholder_type_specifier] = STATE(2935),
    [sym_decltype_auto] = STATE(2933),
    [sym_decltype] = STATE(2868),
    [sym_class_specifier] = STATE(2935),
    [sym__class_name] = STATE(7442),
    [sym_dependent_type] = STATE(2935),
    [sym_template_type] = STATE(5228),
    [sym_template_function] = STATE(4648),
    [sym_raw_string_literal] = STATE(3709),
    [sym_co_await_expression] = STATE(4648),
    [sym_new_expression] = STATE(4648),
    [sym_delete_expression] = STATE(4648),
    [sym_requires_clause] = STATE(4648),
    [sym_requires_expression] = STATE(4648),
    [sym_lambda_expression] = STATE(4648),
    [sym_lambda_capture_specifier] = STATE(5768),
    [sym_fold_expression] = STATE(4648),
    [sym_parameter_pack_expansion] = STATE(4648),
    [sym_type_parameter_pack_expansion] = STATE(7006),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5541),
    [sym_qualified_identifier] = STATE(3663),
    [sym_qualified_type_identifier] = STATE(5253),
    [sym_user_defined_literal] = STATE(3663),
    [aux_sym__type_definition_type_repeat1] = STATE(3799),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2164),
    [sym_identifier] = ACTIONS(2573),
    [anon_sym_LPAREN2] = ACTIONS(2575),
    [anon_sym_BANG] = ACTIONS(2577),
    [anon_sym_TILDE] = ACTIONS(2577),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2583),
    [anon_sym_signed] = ACTIONS(2585),
    [anon_sym_unsigned] = ACTIONS(2585),
    [anon_sym_long] = ACTIONS(2585),
    [anon_sym_short] = ACTIONS(2585),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2587),
    [anon_sym_byte] = ACTIONS(2587),
    [anon_sym_word] = ACTIONS(2587),
    [anon_sym_enum] = ACTIONS(2589),
    [anon_sym_class] = ACTIONS(2591),
    [anon_sym_struct] = ACTIONS(2593),
    [anon_sym_union] = ACTIONS(2595),
    [anon_sym_not] = ACTIONS(2579),
    [anon_sym_compl] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(2597),
    [anon_sym_PLUS_PLUS] = ACTIONS(2597),
    [anon_sym_sizeof] = ACTIONS(2599),
    [anon_sym___alignof__] = ACTIONS(2601),
    [anon_sym___alignof] = ACTIONS(2601),
    [anon_sym__alignof] = ACTIONS(2601),
    [anon_sym_alignof] = ACTIONS(2601),
    [anon_sym__Alignof] = ACTIONS(2601),
    [anon_sym_offsetof] = ACTIONS(2603),
    [anon_sym__Generic] = ACTIONS(2605),
    [anon_sym_asm] = ACTIONS(2607),
    [anon_sym___asm__] = ACTIONS(2607),
    [aux_sym_number_literal_token1] = ACTIONS(2609),
    [aux_sym_number_literal_token2] = ACTIONS(2611),
    [anon_sym_L_SQUOTE] = ACTIONS(2613),
    [anon_sym_u_SQUOTE] = ACTIONS(2613),
    [anon_sym_U_SQUOTE] = ACTIONS(2613),
    [anon_sym_u8_SQUOTE] = ACTIONS(2613),
    [anon_sym_SQUOTE] = ACTIONS(2613),
    [anon_sym_L_DQUOTE] = ACTIONS(2615),
    [anon_sym_u_DQUOTE] = ACTIONS(2615),
    [anon_sym_U_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8_DQUOTE] = ACTIONS(2615),
    [anon_sym_DQUOTE] = ACTIONS(2615),
    [sym_true] = ACTIONS(2617),
    [sym_false] = ACTIONS(2617),
    [anon_sym_NULL] = ACTIONS(2619),
    [anon_sym_nullptr] = ACTIONS(2619),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2621),
    [anon_sym_decltype] = ACTIONS(2623),
    [anon_sym_typename] = ACTIONS(2625),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_GT2] = ACTIONS(2759),
    [anon_sym_delete] = ACTIONS(2629),
    [anon_sym_R_DQUOTE] = ACTIONS(2631),
    [anon_sym_LR_DQUOTE] = ACTIONS(2631),
    [anon_sym_uR_DQUOTE] = ACTIONS(2631),
    [anon_sym_UR_DQUOTE] = ACTIONS(2631),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2631),
    [anon_sym_co_await] = ACTIONS(2633),
    [anon_sym_new] = ACTIONS(2635),
    [anon_sym_requires] = ACTIONS(2637),
    [sym_this] = ACTIONS(2617),
  },
  [312] = {
    [sym_identifier] = ACTIONS(2761),
    [aux_sym_preproc_include_token1] = ACTIONS(2761),
    [aux_sym_preproc_def_token1] = ACTIONS(2761),
    [aux_sym_preproc_if_token1] = ACTIONS(2761),
    [aux_sym_preproc_if_token2] = ACTIONS(2761),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2761),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2761),
    [aux_sym_preproc_else_token1] = ACTIONS(2761),
    [aux_sym_preproc_elif_token1] = ACTIONS(2761),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2761),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2761),
    [sym_preproc_directive] = ACTIONS(2761),
    [anon_sym_LPAREN2] = ACTIONS(2763),
    [anon_sym_BANG] = ACTIONS(2763),
    [anon_sym_TILDE] = ACTIONS(2763),
    [anon_sym_DASH] = ACTIONS(2761),
    [anon_sym_PLUS] = ACTIONS(2761),
    [anon_sym_STAR] = ACTIONS(2763),
    [anon_sym_AMP_AMP] = ACTIONS(2763),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2763),
    [anon_sym___extension__] = ACTIONS(2761),
    [anon_sym_typedef] = ACTIONS(2761),
    [anon_sym_extern] = ACTIONS(2761),
    [anon_sym___attribute__] = ACTIONS(2761),
    [anon_sym_COLON_COLON] = ACTIONS(2763),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2763),
    [anon_sym___declspec] = ACTIONS(2761),
    [anon_sym___based] = ACTIONS(2761),
    [anon_sym___cdecl] = ACTIONS(2761),
    [anon_sym___clrcall] = ACTIONS(2761),
    [anon_sym___stdcall] = ACTIONS(2761),
    [anon_sym___fastcall] = ACTIONS(2761),
    [anon_sym___thiscall] = ACTIONS(2761),
    [anon_sym___vectorcall] = ACTIONS(2761),
    [anon_sym_LBRACE] = ACTIONS(2763),
    [anon_sym_signed] = ACTIONS(2761),
    [anon_sym_unsigned] = ACTIONS(2761),
    [anon_sym_long] = ACTIONS(2761),
    [anon_sym_short] = ACTIONS(2761),
    [anon_sym_LBRACK] = ACTIONS(2761),
    [anon_sym_static] = ACTIONS(2761),
    [anon_sym_register] = ACTIONS(2761),
    [anon_sym_inline] = ACTIONS(2761),
    [anon_sym___inline] = ACTIONS(2761),
    [anon_sym___inline__] = ACTIONS(2761),
    [anon_sym___forceinline] = ACTIONS(2761),
    [anon_sym_thread_local] = ACTIONS(2761),
    [anon_sym___thread] = ACTIONS(2761),
    [anon_sym_const] = ACTIONS(2761),
    [anon_sym_constexpr] = ACTIONS(2761),
    [anon_sym_volatile] = ACTIONS(2761),
    [anon_sym_restrict] = ACTIONS(2761),
    [anon_sym___restrict__] = ACTIONS(2761),
    [anon_sym__Atomic] = ACTIONS(2761),
    [anon_sym__Noreturn] = ACTIONS(2761),
    [anon_sym_noreturn] = ACTIONS(2761),
    [anon_sym_mutable] = ACTIONS(2761),
    [anon_sym_constinit] = ACTIONS(2761),
    [anon_sym_consteval] = ACTIONS(2761),
    [anon_sym_PROGMEM] = ACTIONS(2761),
    [aux_sym_primitive_type_token1] = ACTIONS(2761),
    [anon_sym_byte] = ACTIONS(2761),
    [anon_sym_word] = ACTIONS(2761),
    [anon_sym_enum] = ACTIONS(2761),
    [anon_sym_class] = ACTIONS(2761),
    [anon_sym_struct] = ACTIONS(2761),
    [anon_sym_union] = ACTIONS(2761),
    [anon_sym_if] = ACTIONS(2761),
    [anon_sym_else] = ACTIONS(2761),
    [anon_sym_switch] = ACTIONS(2761),
    [anon_sym_case] = ACTIONS(2761),
    [anon_sym_default] = ACTIONS(2761),
    [anon_sym_while] = ACTIONS(2761),
    [anon_sym_do] = ACTIONS(2761),
    [anon_sym_for] = ACTIONS(2761),
    [anon_sym_return] = ACTIONS(2761),
    [anon_sym_break] = ACTIONS(2761),
    [anon_sym_continue] = ACTIONS(2761),
    [anon_sym_goto] = ACTIONS(2761),
    [anon_sym___try] = ACTIONS(2761),
    [anon_sym___leave] = ACTIONS(2761),
    [anon_sym_not] = ACTIONS(2761),
    [anon_sym_compl] = ACTIONS(2761),
    [anon_sym_DASH_DASH] = ACTIONS(2763),
    [anon_sym_PLUS_PLUS] = ACTIONS(2763),
    [anon_sym_sizeof] = ACTIONS(2761),
    [anon_sym___alignof__] = ACTIONS(2761),
    [anon_sym___alignof] = ACTIONS(2761),
    [anon_sym__alignof] = ACTIONS(2761),
    [anon_sym_alignof] = ACTIONS(2761),
    [anon_sym__Alignof] = ACTIONS(2761),
    [anon_sym_offsetof] = ACTIONS(2761),
    [anon_sym__Generic] = ACTIONS(2761),
    [anon_sym_asm] = ACTIONS(2761),
    [anon_sym___asm__] = ACTIONS(2761),
    [aux_sym_number_literal_token1] = ACTIONS(2763),
    [aux_sym_number_literal_token2] = ACTIONS(2761),
    [anon_sym_L_SQUOTE] = ACTIONS(2763),
    [anon_sym_u_SQUOTE] = ACTIONS(2763),
    [anon_sym_U_SQUOTE] = ACTIONS(2763),
    [anon_sym_u8_SQUOTE] = ACTIONS(2763),
    [anon_sym_SQUOTE] = ACTIONS(2763),
    [anon_sym_L_DQUOTE] = ACTIONS(2763),
    [anon_sym_u_DQUOTE] = ACTIONS(2763),
    [anon_sym_U_DQUOTE] = ACTIONS(2763),
    [anon_sym_u8_DQUOTE] = ACTIONS(2763),
    [anon_sym_DQUOTE] = ACTIONS(2763),
    [sym_true] = ACTIONS(2761),
    [sym_false] = ACTIONS(2761),
    [anon_sym_NULL] = ACTIONS(2761),
    [anon_sym_nullptr] = ACTIONS(2761),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2761),
    [anon_sym_decltype] = ACTIONS(2761),
    [anon_sym_virtual] = ACTIONS(2761),
    [anon_sym_alignas] = ACTIONS(2761),
    [anon_sym_explicit] = ACTIONS(2761),
    [anon_sym_typename] = ACTIONS(2761),
    [anon_sym_template] = ACTIONS(2761),
    [anon_sym_operator] = ACTIONS(2761),
    [anon_sym_try] = ACTIONS(2761),
    [anon_sym_delete] = ACTIONS(2761),
    [anon_sym_throw] = ACTIONS(2761),
    [anon_sym_namespace] = ACTIONS(2761),
    [anon_sym_using] = ACTIONS(2761),
    [anon_sym_static_assert] = ACTIONS(2761),
    [anon_sym_concept] = ACTIONS(2761),
    [anon_sym_co_return] = ACTIONS(2761),
    [anon_sym_co_yield] = ACTIONS(2761),
    [anon_sym_R_DQUOTE] = ACTIONS(2763),
    [anon_sym_LR_DQUOTE] = ACTIONS(2763),
    [anon_sym_uR_DQUOTE] = ACTIONS(2763),
    [anon_sym_UR_DQUOTE] = ACTIONS(2763),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2763),
    [anon_sym_co_await] = ACTIONS(2761),
    [anon_sym_new] = ACTIONS(2761),
    [anon_sym_requires] = ACTIONS(2761),
    [sym_this] = ACTIONS(2761),
  },
  [313] = {
    [sym_identifier] = ACTIONS(2765),
    [aux_sym_preproc_include_token1] = ACTIONS(2765),
    [aux_sym_preproc_def_token1] = ACTIONS(2765),
    [aux_sym_preproc_if_token1] = ACTIONS(2765),
    [aux_sym_preproc_if_token2] = ACTIONS(2765),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2765),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2765),
    [aux_sym_preproc_else_token1] = ACTIONS(2765),
    [aux_sym_preproc_elif_token1] = ACTIONS(2765),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2765),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2765),
    [sym_preproc_directive] = ACTIONS(2765),
    [anon_sym_LPAREN2] = ACTIONS(2767),
    [anon_sym_BANG] = ACTIONS(2767),
    [anon_sym_TILDE] = ACTIONS(2767),
    [anon_sym_DASH] = ACTIONS(2765),
    [anon_sym_PLUS] = ACTIONS(2765),
    [anon_sym_STAR] = ACTIONS(2767),
    [anon_sym_AMP_AMP] = ACTIONS(2767),
    [anon_sym_AMP] = ACTIONS(2765),
    [anon_sym_SEMI] = ACTIONS(2767),
    [anon_sym___extension__] = ACTIONS(2765),
    [anon_sym_typedef] = ACTIONS(2765),
    [anon_sym_extern] = ACTIONS(2765),
    [anon_sym___attribute__] = ACTIONS(2765),
    [anon_sym_COLON_COLON] = ACTIONS(2767),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2767),
    [anon_sym___declspec] = ACTIONS(2765),
    [anon_sym___based] = ACTIONS(2765),
    [anon_sym___cdecl] = ACTIONS(2765),
    [anon_sym___clrcall] = ACTIONS(2765),
    [anon_sym___stdcall] = ACTIONS(2765),
    [anon_sym___fastcall] = ACTIONS(2765),
    [anon_sym___thiscall] = ACTIONS(2765),
    [anon_sym___vectorcall] = ACTIONS(2765),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_signed] = ACTIONS(2765),
    [anon_sym_unsigned] = ACTIONS(2765),
    [anon_sym_long] = ACTIONS(2765),
    [anon_sym_short] = ACTIONS(2765),
    [anon_sym_LBRACK] = ACTIONS(2765),
    [anon_sym_static] = ACTIONS(2765),
    [anon_sym_register] = ACTIONS(2765),
    [anon_sym_inline] = ACTIONS(2765),
    [anon_sym___inline] = ACTIONS(2765),
    [anon_sym___inline__] = ACTIONS(2765),
    [anon_sym___forceinline] = ACTIONS(2765),
    [anon_sym_thread_local] = ACTIONS(2765),
    [anon_sym___thread] = ACTIONS(2765),
    [anon_sym_const] = ACTIONS(2765),
    [anon_sym_constexpr] = ACTIONS(2765),
    [anon_sym_volatile] = ACTIONS(2765),
    [anon_sym_restrict] = ACTIONS(2765),
    [anon_sym___restrict__] = ACTIONS(2765),
    [anon_sym__Atomic] = ACTIONS(2765),
    [anon_sym__Noreturn] = ACTIONS(2765),
    [anon_sym_noreturn] = ACTIONS(2765),
    [anon_sym_mutable] = ACTIONS(2765),
    [anon_sym_constinit] = ACTIONS(2765),
    [anon_sym_consteval] = ACTIONS(2765),
    [anon_sym_PROGMEM] = ACTIONS(2765),
    [aux_sym_primitive_type_token1] = ACTIONS(2765),
    [anon_sym_byte] = ACTIONS(2765),
    [anon_sym_word] = ACTIONS(2765),
    [anon_sym_enum] = ACTIONS(2765),
    [anon_sym_class] = ACTIONS(2765),
    [anon_sym_struct] = ACTIONS(2765),
    [anon_sym_union] = ACTIONS(2765),
    [anon_sym_if] = ACTIONS(2765),
    [anon_sym_else] = ACTIONS(2765),
    [anon_sym_switch] = ACTIONS(2765),
    [anon_sym_case] = ACTIONS(2765),
    [anon_sym_default] = ACTIONS(2765),
    [anon_sym_while] = ACTIONS(2765),
    [anon_sym_do] = ACTIONS(2765),
    [anon_sym_for] = ACTIONS(2765),
    [anon_sym_return] = ACTIONS(2765),
    [anon_sym_break] = ACTIONS(2765),
    [anon_sym_continue] = ACTIONS(2765),
    [anon_sym_goto] = ACTIONS(2765),
    [anon_sym___try] = ACTIONS(2765),
    [anon_sym___leave] = ACTIONS(2765),
    [anon_sym_not] = ACTIONS(2765),
    [anon_sym_compl] = ACTIONS(2765),
    [anon_sym_DASH_DASH] = ACTIONS(2767),
    [anon_sym_PLUS_PLUS] = ACTIONS(2767),
    [anon_sym_sizeof] = ACTIONS(2765),
    [anon_sym___alignof__] = ACTIONS(2765),
    [anon_sym___alignof] = ACTIONS(2765),
    [anon_sym__alignof] = ACTIONS(2765),
    [anon_sym_alignof] = ACTIONS(2765),
    [anon_sym__Alignof] = ACTIONS(2765),
    [anon_sym_offsetof] = ACTIONS(2765),
    [anon_sym__Generic] = ACTIONS(2765),
    [anon_sym_asm] = ACTIONS(2765),
    [anon_sym___asm__] = ACTIONS(2765),
    [aux_sym_number_literal_token1] = ACTIONS(2767),
    [aux_sym_number_literal_token2] = ACTIONS(2765),
    [anon_sym_L_SQUOTE] = ACTIONS(2767),
    [anon_sym_u_SQUOTE] = ACTIONS(2767),
    [anon_sym_U_SQUOTE] = ACTIONS(2767),
    [anon_sym_u8_SQUOTE] = ACTIONS(2767),
    [anon_sym_SQUOTE] = ACTIONS(2767),
    [anon_sym_L_DQUOTE] = ACTIONS(2767),
    [anon_sym_u_DQUOTE] = ACTIONS(2767),
    [anon_sym_U_DQUOTE] = ACTIONS(2767),
    [anon_sym_u8_DQUOTE] = ACTIONS(2767),
    [anon_sym_DQUOTE] = ACTIONS(2767),
    [sym_true] = ACTIONS(2765),
    [sym_false] = ACTIONS(2765),
    [anon_sym_NULL] = ACTIONS(2765),
    [anon_sym_nullptr] = ACTIONS(2765),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2765),
    [anon_sym_decltype] = ACTIONS(2765),
    [anon_sym_virtual] = ACTIONS(2765),
    [anon_sym_alignas] = ACTIONS(2765),
    [anon_sym_explicit] = ACTIONS(2765),
    [anon_sym_typename] = ACTIONS(2765),
    [anon_sym_template] = ACTIONS(2765),
    [anon_sym_operator] = ACTIONS(2765),
    [anon_sym_try] = ACTIONS(2765),
    [anon_sym_delete] = ACTIONS(2765),
    [anon_sym_throw] = ACTIONS(2765),
    [anon_sym_namespace] = ACTIONS(2765),
    [anon_sym_using] = ACTIONS(2765),
    [anon_sym_static_assert] = ACTIONS(2765),
    [anon_sym_concept] = ACTIONS(2765),
    [anon_sym_co_return] = ACTIONS(2765),
    [anon_sym_co_yield] = ACTIONS(2765),
    [anon_sym_R_DQUOTE] = ACTIONS(2767),
    [anon_sym_LR_DQUOTE] = ACTIONS(2767),
    [anon_sym_uR_DQUOTE] = ACTIONS(2767),
    [anon_sym_UR_DQUOTE] = ACTIONS(2767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2767),
    [anon_sym_co_await] = ACTIONS(2765),
    [anon_sym_new] = ACTIONS(2765),
    [anon_sym_requires] = ACTIONS(2765),
    [sym_this] = ACTIONS(2765),
  },
  [314] = {
    [sym_identifier] = ACTIONS(2769),
    [aux_sym_preproc_include_token1] = ACTIONS(2769),
    [aux_sym_preproc_def_token1] = ACTIONS(2769),
    [aux_sym_preproc_if_token1] = ACTIONS(2769),
    [aux_sym_preproc_if_token2] = ACTIONS(2769),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2769),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2769),
    [aux_sym_preproc_else_token1] = ACTIONS(2769),
    [aux_sym_preproc_elif_token1] = ACTIONS(2769),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2769),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2769),
    [sym_preproc_directive] = ACTIONS(2769),
    [anon_sym_LPAREN2] = ACTIONS(2771),
    [anon_sym_BANG] = ACTIONS(2771),
    [anon_sym_TILDE] = ACTIONS(2771),
    [anon_sym_DASH] = ACTIONS(2769),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_STAR] = ACTIONS(2771),
    [anon_sym_AMP_AMP] = ACTIONS(2771),
    [anon_sym_AMP] = ACTIONS(2769),
    [anon_sym_SEMI] = ACTIONS(2771),
    [anon_sym___extension__] = ACTIONS(2769),
    [anon_sym_typedef] = ACTIONS(2769),
    [anon_sym_extern] = ACTIONS(2769),
    [anon_sym___attribute__] = ACTIONS(2769),
    [anon_sym_COLON_COLON] = ACTIONS(2771),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2771),
    [anon_sym___declspec] = ACTIONS(2769),
    [anon_sym___based] = ACTIONS(2769),
    [anon_sym___cdecl] = ACTIONS(2769),
    [anon_sym___clrcall] = ACTIONS(2769),
    [anon_sym___stdcall] = ACTIONS(2769),
    [anon_sym___fastcall] = ACTIONS(2769),
    [anon_sym___thiscall] = ACTIONS(2769),
    [anon_sym___vectorcall] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(2771),
    [anon_sym_signed] = ACTIONS(2769),
    [anon_sym_unsigned] = ACTIONS(2769),
    [anon_sym_long] = ACTIONS(2769),
    [anon_sym_short] = ACTIONS(2769),
    [anon_sym_LBRACK] = ACTIONS(2769),
    [anon_sym_static] = ACTIONS(2769),
    [anon_sym_register] = ACTIONS(2769),
    [anon_sym_inline] = ACTIONS(2769),
    [anon_sym___inline] = ACTIONS(2769),
    [anon_sym___inline__] = ACTIONS(2769),
    [anon_sym___forceinline] = ACTIONS(2769),
    [anon_sym_thread_local] = ACTIONS(2769),
    [anon_sym___thread] = ACTIONS(2769),
    [anon_sym_const] = ACTIONS(2769),
    [anon_sym_constexpr] = ACTIONS(2769),
    [anon_sym_volatile] = ACTIONS(2769),
    [anon_sym_restrict] = ACTIONS(2769),
    [anon_sym___restrict__] = ACTIONS(2769),
    [anon_sym__Atomic] = ACTIONS(2769),
    [anon_sym__Noreturn] = ACTIONS(2769),
    [anon_sym_noreturn] = ACTIONS(2769),
    [anon_sym_mutable] = ACTIONS(2769),
    [anon_sym_constinit] = ACTIONS(2769),
    [anon_sym_consteval] = ACTIONS(2769),
    [anon_sym_PROGMEM] = ACTIONS(2769),
    [aux_sym_primitive_type_token1] = ACTIONS(2769),
    [anon_sym_byte] = ACTIONS(2769),
    [anon_sym_word] = ACTIONS(2769),
    [anon_sym_enum] = ACTIONS(2769),
    [anon_sym_class] = ACTIONS(2769),
    [anon_sym_struct] = ACTIONS(2769),
    [anon_sym_union] = ACTIONS(2769),
    [anon_sym_if] = ACTIONS(2769),
    [anon_sym_else] = ACTIONS(2769),
    [anon_sym_switch] = ACTIONS(2769),
    [anon_sym_case] = ACTIONS(2769),
    [anon_sym_default] = ACTIONS(2769),
    [anon_sym_while] = ACTIONS(2769),
    [anon_sym_do] = ACTIONS(2769),
    [anon_sym_for] = ACTIONS(2769),
    [anon_sym_return] = ACTIONS(2769),
    [anon_sym_break] = ACTIONS(2769),
    [anon_sym_continue] = ACTIONS(2769),
    [anon_sym_goto] = ACTIONS(2769),
    [anon_sym___try] = ACTIONS(2769),
    [anon_sym___leave] = ACTIONS(2769),
    [anon_sym_not] = ACTIONS(2769),
    [anon_sym_compl] = ACTIONS(2769),
    [anon_sym_DASH_DASH] = ACTIONS(2771),
    [anon_sym_PLUS_PLUS] = ACTIONS(2771),
    [anon_sym_sizeof] = ACTIONS(2769),
    [anon_sym___alignof__] = ACTIONS(2769),
    [anon_sym___alignof] = ACTIONS(2769),
    [anon_sym__alignof] = ACTIONS(2769),
    [anon_sym_alignof] = ACTIONS(2769),
    [anon_sym__Alignof] = ACTIONS(2769),
    [anon_sym_offsetof] = ACTIONS(2769),
    [anon_sym__Generic] = ACTIONS(2769),
    [anon_sym_asm] = ACTIONS(2769),
    [anon_sym___asm__] = ACTIONS(2769),
    [aux_sym_number_literal_token1] = ACTIONS(2771),
    [aux_sym_number_literal_token2] = ACTIONS(2769),
    [anon_sym_L_SQUOTE] = ACTIONS(2771),
    [anon_sym_u_SQUOTE] = ACTIONS(2771),
    [anon_sym_U_SQUOTE] = ACTIONS(2771),
    [anon_sym_u8_SQUOTE] = ACTIONS(2771),
    [anon_sym_SQUOTE] = ACTIONS(2771),
    [anon_sym_L_DQUOTE] = ACTIONS(2771),
    [anon_sym_u_DQUOTE] = ACTIONS(2771),
    [anon_sym_U_DQUOTE] = ACTIONS(2771),
    [anon_sym_u8_DQUOTE] = ACTIONS(2771),
    [anon_sym_DQUOTE] = ACTIONS(2771),
    [sym_true] = ACTIONS(2769),
    [sym_false] = ACTIONS(2769),
    [anon_sym_NULL] = ACTIONS(2769),
    [anon_sym_nullptr] = ACTIONS(2769),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2769),
    [anon_sym_decltype] = ACTIONS(2769),
    [anon_sym_virtual] = ACTIONS(2769),
    [anon_sym_alignas] = ACTIONS(2769),
    [anon_sym_explicit] = ACTIONS(2769),
    [anon_sym_typename] = ACTIONS(2769),
    [anon_sym_template] = ACTIONS(2769),
    [anon_sym_operator] = ACTIONS(2769),
    [anon_sym_try] = ACTIONS(2769),
    [anon_sym_delete] = ACTIONS(2769),
    [anon_sym_throw] = ACTIONS(2769),
    [anon_sym_namespace] = ACTIONS(2769),
    [anon_sym_using] = ACTIONS(2769),
    [anon_sym_static_assert] = ACTIONS(2769),
    [anon_sym_concept] = ACTIONS(2769),
    [anon_sym_co_return] = ACTIONS(2769),
    [anon_sym_co_yield] = ACTIONS(2769),
    [anon_sym_R_DQUOTE] = ACTIONS(2771),
    [anon_sym_LR_DQUOTE] = ACTIONS(2771),
    [anon_sym_uR_DQUOTE] = ACTIONS(2771),
    [anon_sym_UR_DQUOTE] = ACTIONS(2771),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2771),
    [anon_sym_co_await] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2769),
    [anon_sym_requires] = ACTIONS(2769),
    [sym_this] = ACTIONS(2769),
  },
  [315] = {
    [sym_identifier] = ACTIONS(2773),
    [aux_sym_preproc_include_token1] = ACTIONS(2773),
    [aux_sym_preproc_def_token1] = ACTIONS(2773),
    [aux_sym_preproc_if_token1] = ACTIONS(2773),
    [aux_sym_preproc_if_token2] = ACTIONS(2773),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2773),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2773),
    [aux_sym_preproc_else_token1] = ACTIONS(2773),
    [aux_sym_preproc_elif_token1] = ACTIONS(2773),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2773),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2773),
    [sym_preproc_directive] = ACTIONS(2773),
    [anon_sym_LPAREN2] = ACTIONS(2775),
    [anon_sym_BANG] = ACTIONS(2775),
    [anon_sym_TILDE] = ACTIONS(2775),
    [anon_sym_DASH] = ACTIONS(2773),
    [anon_sym_PLUS] = ACTIONS(2773),
    [anon_sym_STAR] = ACTIONS(2775),
    [anon_sym_AMP_AMP] = ACTIONS(2775),
    [anon_sym_AMP] = ACTIONS(2773),
    [anon_sym_SEMI] = ACTIONS(2775),
    [anon_sym___extension__] = ACTIONS(2773),
    [anon_sym_typedef] = ACTIONS(2773),
    [anon_sym_extern] = ACTIONS(2773),
    [anon_sym___attribute__] = ACTIONS(2773),
    [anon_sym_COLON_COLON] = ACTIONS(2775),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2775),
    [anon_sym___declspec] = ACTIONS(2773),
    [anon_sym___based] = ACTIONS(2773),
    [anon_sym___cdecl] = ACTIONS(2773),
    [anon_sym___clrcall] = ACTIONS(2773),
    [anon_sym___stdcall] = ACTIONS(2773),
    [anon_sym___fastcall] = ACTIONS(2773),
    [anon_sym___thiscall] = ACTIONS(2773),
    [anon_sym___vectorcall] = ACTIONS(2773),
    [anon_sym_LBRACE] = ACTIONS(2775),
    [anon_sym_signed] = ACTIONS(2773),
    [anon_sym_unsigned] = ACTIONS(2773),
    [anon_sym_long] = ACTIONS(2773),
    [anon_sym_short] = ACTIONS(2773),
    [anon_sym_LBRACK] = ACTIONS(2773),
    [anon_sym_static] = ACTIONS(2773),
    [anon_sym_register] = ACTIONS(2773),
    [anon_sym_inline] = ACTIONS(2773),
    [anon_sym___inline] = ACTIONS(2773),
    [anon_sym___inline__] = ACTIONS(2773),
    [anon_sym___forceinline] = ACTIONS(2773),
    [anon_sym_thread_local] = ACTIONS(2773),
    [anon_sym___thread] = ACTIONS(2773),
    [anon_sym_const] = ACTIONS(2773),
    [anon_sym_constexpr] = ACTIONS(2773),
    [anon_sym_volatile] = ACTIONS(2773),
    [anon_sym_restrict] = ACTIONS(2773),
    [anon_sym___restrict__] = ACTIONS(2773),
    [anon_sym__Atomic] = ACTIONS(2773),
    [anon_sym__Noreturn] = ACTIONS(2773),
    [anon_sym_noreturn] = ACTIONS(2773),
    [anon_sym_mutable] = ACTIONS(2773),
    [anon_sym_constinit] = ACTIONS(2773),
    [anon_sym_consteval] = ACTIONS(2773),
    [anon_sym_PROGMEM] = ACTIONS(2773),
    [aux_sym_primitive_type_token1] = ACTIONS(2773),
    [anon_sym_byte] = ACTIONS(2773),
    [anon_sym_word] = ACTIONS(2773),
    [anon_sym_enum] = ACTIONS(2773),
    [anon_sym_class] = ACTIONS(2773),
    [anon_sym_struct] = ACTIONS(2773),
    [anon_sym_union] = ACTIONS(2773),
    [anon_sym_if] = ACTIONS(2773),
    [anon_sym_else] = ACTIONS(2773),
    [anon_sym_switch] = ACTIONS(2773),
    [anon_sym_case] = ACTIONS(2773),
    [anon_sym_default] = ACTIONS(2773),
    [anon_sym_while] = ACTIONS(2773),
    [anon_sym_do] = ACTIONS(2773),
    [anon_sym_for] = ACTIONS(2773),
    [anon_sym_return] = ACTIONS(2773),
    [anon_sym_break] = ACTIONS(2773),
    [anon_sym_continue] = ACTIONS(2773),
    [anon_sym_goto] = ACTIONS(2773),
    [anon_sym___try] = ACTIONS(2773),
    [anon_sym___leave] = ACTIONS(2773),
    [anon_sym_not] = ACTIONS(2773),
    [anon_sym_compl] = ACTIONS(2773),
    [anon_sym_DASH_DASH] = ACTIONS(2775),
    [anon_sym_PLUS_PLUS] = ACTIONS(2775),
    [anon_sym_sizeof] = ACTIONS(2773),
    [anon_sym___alignof__] = ACTIONS(2773),
    [anon_sym___alignof] = ACTIONS(2773),
    [anon_sym__alignof] = ACTIONS(2773),
    [anon_sym_alignof] = ACTIONS(2773),
    [anon_sym__Alignof] = ACTIONS(2773),
    [anon_sym_offsetof] = ACTIONS(2773),
    [anon_sym__Generic] = ACTIONS(2773),
    [anon_sym_asm] = ACTIONS(2773),
    [anon_sym___asm__] = ACTIONS(2773),
    [aux_sym_number_literal_token1] = ACTIONS(2775),
    [aux_sym_number_literal_token2] = ACTIONS(2773),
    [anon_sym_L_SQUOTE] = ACTIONS(2775),
    [anon_sym_u_SQUOTE] = ACTIONS(2775),
    [anon_sym_U_SQUOTE] = ACTIONS(2775),
    [anon_sym_u8_SQUOTE] = ACTIONS(2775),
    [anon_sym_SQUOTE] = ACTIONS(2775),
    [anon_sym_L_DQUOTE] = ACTIONS(2775),
    [anon_sym_u_DQUOTE] = ACTIONS(2775),
    [anon_sym_U_DQUOTE] = ACTIONS(2775),
    [anon_sym_u8_DQUOTE] = ACTIONS(2775),
    [anon_sym_DQUOTE] = ACTIONS(2775),
    [sym_true] = ACTIONS(2773),
    [sym_false] = ACTIONS(2773),
    [anon_sym_NULL] = ACTIONS(2773),
    [anon_sym_nullptr] = ACTIONS(2773),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2773),
    [anon_sym_decltype] = ACTIONS(2773),
    [anon_sym_virtual] = ACTIONS(2773),
    [anon_sym_alignas] = ACTIONS(2773),
    [anon_sym_explicit] = ACTIONS(2773),
    [anon_sym_typename] = ACTIONS(2773),
    [anon_sym_template] = ACTIONS(2773),
    [anon_sym_operator] = ACTIONS(2773),
    [anon_sym_try] = ACTIONS(2773),
    [anon_sym_delete] = ACTIONS(2773),
    [anon_sym_throw] = ACTIONS(2773),
    [anon_sym_namespace] = ACTIONS(2773),
    [anon_sym_using] = ACTIONS(2773),
    [anon_sym_static_assert] = ACTIONS(2773),
    [anon_sym_concept] = ACTIONS(2773),
    [anon_sym_co_return] = ACTIONS(2773),
    [anon_sym_co_yield] = ACTIONS(2773),
    [anon_sym_R_DQUOTE] = ACTIONS(2775),
    [anon_sym_LR_DQUOTE] = ACTIONS(2775),
    [anon_sym_uR_DQUOTE] = ACTIONS(2775),
    [anon_sym_UR_DQUOTE] = ACTIONS(2775),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2775),
    [anon_sym_co_await] = ACTIONS(2773),
    [anon_sym_new] = ACTIONS(2773),
    [anon_sym_requires] = ACTIONS(2773),
    [sym_this] = ACTIONS(2773),
  },
  [316] = {
    [sym_type_qualifier] = STATE(3799),
    [sym__type_specifier] = STATE(4801),
    [sym_sized_type_specifier] = STATE(2935),
    [sym_primitive_type] = STATE(4963),
    [sym_enum_specifier] = STATE(2935),
    [sym_struct_specifier] = STATE(2935),
    [sym_union_specifier] = STATE(2935),
    [sym__expression] = STATE(4335),
    [sym__expression_not_binary] = STATE(4648),
    [sym__string] = STATE(4648),
    [sym_conditional_expression] = STATE(4648),
    [sym_assignment_expression] = STATE(4648),
    [sym_pointer_expression] = STATE(3663),
    [sym_unary_expression] = STATE(4648),
    [sym_binary_expression] = STATE(4648),
    [sym_update_expression] = STATE(4648),
    [sym_cast_expression] = STATE(4648),
    [sym_type_descriptor] = STATE(6657),
    [sym_sizeof_expression] = STATE(4648),
    [sym_alignof_expression] = STATE(4648),
    [sym_offsetof_expression] = STATE(4648),
    [sym_generic_expression] = STATE(4648),
    [sym_subscript_expression] = STATE(3663),
    [sym_call_expression] = STATE(3663),
    [sym_gnu_asm_expression] = STATE(4648),
    [sym_field_expression] = STATE(3663),
    [sym_compound_literal_expression] = STATE(4648),
    [sym_parenthesized_expression] = STATE(3663),
    [sym_number_literal] = STATE(4573),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4565),
    [sym_string_literal] = STATE(3707),
    [sym_null] = STATE(4648),
    [sym_placeholder_type_specifier] = STATE(2935),
    [sym_decltype_auto] = STATE(2933),
    [sym_decltype] = STATE(2868),
    [sym_class_specifier] = STATE(2935),
    [sym__class_name] = STATE(7442),
    [sym_dependent_type] = STATE(2935),
    [sym_template_type] = STATE(5228),
    [sym_template_function] = STATE(4648),
    [sym_raw_string_literal] = STATE(3709),
    [sym_co_await_expression] = STATE(4648),
    [sym_new_expression] = STATE(4648),
    [sym_delete_expression] = STATE(4648),
    [sym_requires_clause] = STATE(4648),
    [sym_requires_expression] = STATE(4648),
    [sym_lambda_expression] = STATE(4648),
    [sym_lambda_capture_specifier] = STATE(5768),
    [sym_fold_expression] = STATE(4648),
    [sym_parameter_pack_expansion] = STATE(4648),
    [sym_type_parameter_pack_expansion] = STATE(7192),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5541),
    [sym_qualified_identifier] = STATE(3663),
    [sym_qualified_type_identifier] = STATE(5253),
    [sym_user_defined_literal] = STATE(3663),
    [aux_sym__type_definition_type_repeat1] = STATE(3799),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2164),
    [sym_identifier] = ACTIONS(2573),
    [anon_sym_LPAREN2] = ACTIONS(2575),
    [anon_sym_BANG] = ACTIONS(2577),
    [anon_sym_TILDE] = ACTIONS(2577),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2583),
    [anon_sym_signed] = ACTIONS(2585),
    [anon_sym_unsigned] = ACTIONS(2585),
    [anon_sym_long] = ACTIONS(2585),
    [anon_sym_short] = ACTIONS(2585),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2587),
    [anon_sym_byte] = ACTIONS(2587),
    [anon_sym_word] = ACTIONS(2587),
    [anon_sym_enum] = ACTIONS(2589),
    [anon_sym_class] = ACTIONS(2591),
    [anon_sym_struct] = ACTIONS(2593),
    [anon_sym_union] = ACTIONS(2595),
    [anon_sym_not] = ACTIONS(2579),
    [anon_sym_compl] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(2597),
    [anon_sym_PLUS_PLUS] = ACTIONS(2597),
    [anon_sym_sizeof] = ACTIONS(2599),
    [anon_sym___alignof__] = ACTIONS(2601),
    [anon_sym___alignof] = ACTIONS(2601),
    [anon_sym__alignof] = ACTIONS(2601),
    [anon_sym_alignof] = ACTIONS(2601),
    [anon_sym__Alignof] = ACTIONS(2601),
    [anon_sym_offsetof] = ACTIONS(2603),
    [anon_sym__Generic] = ACTIONS(2605),
    [anon_sym_asm] = ACTIONS(2607),
    [anon_sym___asm__] = ACTIONS(2607),
    [aux_sym_number_literal_token1] = ACTIONS(2609),
    [aux_sym_number_literal_token2] = ACTIONS(2611),
    [anon_sym_L_SQUOTE] = ACTIONS(2613),
    [anon_sym_u_SQUOTE] = ACTIONS(2613),
    [anon_sym_U_SQUOTE] = ACTIONS(2613),
    [anon_sym_u8_SQUOTE] = ACTIONS(2613),
    [anon_sym_SQUOTE] = ACTIONS(2613),
    [anon_sym_L_DQUOTE] = ACTIONS(2615),
    [anon_sym_u_DQUOTE] = ACTIONS(2615),
    [anon_sym_U_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8_DQUOTE] = ACTIONS(2615),
    [anon_sym_DQUOTE] = ACTIONS(2615),
    [sym_true] = ACTIONS(2617),
    [sym_false] = ACTIONS(2617),
    [anon_sym_NULL] = ACTIONS(2619),
    [anon_sym_nullptr] = ACTIONS(2619),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2621),
    [anon_sym_decltype] = ACTIONS(2623),
    [anon_sym_typename] = ACTIONS(2625),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_GT2] = ACTIONS(2777),
    [anon_sym_delete] = ACTIONS(2629),
    [anon_sym_R_DQUOTE] = ACTIONS(2631),
    [anon_sym_LR_DQUOTE] = ACTIONS(2631),
    [anon_sym_uR_DQUOTE] = ACTIONS(2631),
    [anon_sym_UR_DQUOTE] = ACTIONS(2631),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2631),
    [anon_sym_co_await] = ACTIONS(2633),
    [anon_sym_new] = ACTIONS(2635),
    [anon_sym_requires] = ACTIONS(2637),
    [sym_this] = ACTIONS(2617),
  },
  [317] = {
    [sym_identifier] = ACTIONS(2779),
    [aux_sym_preproc_include_token1] = ACTIONS(2779),
    [aux_sym_preproc_def_token1] = ACTIONS(2779),
    [aux_sym_preproc_if_token1] = ACTIONS(2779),
    [aux_sym_preproc_if_token2] = ACTIONS(2779),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2779),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2779),
    [aux_sym_preproc_else_token1] = ACTIONS(2779),
    [aux_sym_preproc_elif_token1] = ACTIONS(2779),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2779),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2779),
    [sym_preproc_directive] = ACTIONS(2779),
    [anon_sym_LPAREN2] = ACTIONS(2781),
    [anon_sym_BANG] = ACTIONS(2781),
    [anon_sym_TILDE] = ACTIONS(2781),
    [anon_sym_DASH] = ACTIONS(2779),
    [anon_sym_PLUS] = ACTIONS(2779),
    [anon_sym_STAR] = ACTIONS(2781),
    [anon_sym_AMP_AMP] = ACTIONS(2781),
    [anon_sym_AMP] = ACTIONS(2779),
    [anon_sym_SEMI] = ACTIONS(2781),
    [anon_sym___extension__] = ACTIONS(2779),
    [anon_sym_typedef] = ACTIONS(2779),
    [anon_sym_extern] = ACTIONS(2779),
    [anon_sym___attribute__] = ACTIONS(2779),
    [anon_sym_COLON_COLON] = ACTIONS(2781),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2781),
    [anon_sym___declspec] = ACTIONS(2779),
    [anon_sym___based] = ACTIONS(2779),
    [anon_sym___cdecl] = ACTIONS(2779),
    [anon_sym___clrcall] = ACTIONS(2779),
    [anon_sym___stdcall] = ACTIONS(2779),
    [anon_sym___fastcall] = ACTIONS(2779),
    [anon_sym___thiscall] = ACTIONS(2779),
    [anon_sym___vectorcall] = ACTIONS(2779),
    [anon_sym_LBRACE] = ACTIONS(2781),
    [anon_sym_signed] = ACTIONS(2779),
    [anon_sym_unsigned] = ACTIONS(2779),
    [anon_sym_long] = ACTIONS(2779),
    [anon_sym_short] = ACTIONS(2779),
    [anon_sym_LBRACK] = ACTIONS(2779),
    [anon_sym_static] = ACTIONS(2779),
    [anon_sym_register] = ACTIONS(2779),
    [anon_sym_inline] = ACTIONS(2779),
    [anon_sym___inline] = ACTIONS(2779),
    [anon_sym___inline__] = ACTIONS(2779),
    [anon_sym___forceinline] = ACTIONS(2779),
    [anon_sym_thread_local] = ACTIONS(2779),
    [anon_sym___thread] = ACTIONS(2779),
    [anon_sym_const] = ACTIONS(2779),
    [anon_sym_constexpr] = ACTIONS(2779),
    [anon_sym_volatile] = ACTIONS(2779),
    [anon_sym_restrict] = ACTIONS(2779),
    [anon_sym___restrict__] = ACTIONS(2779),
    [anon_sym__Atomic] = ACTIONS(2779),
    [anon_sym__Noreturn] = ACTIONS(2779),
    [anon_sym_noreturn] = ACTIONS(2779),
    [anon_sym_mutable] = ACTIONS(2779),
    [anon_sym_constinit] = ACTIONS(2779),
    [anon_sym_consteval] = ACTIONS(2779),
    [anon_sym_PROGMEM] = ACTIONS(2779),
    [aux_sym_primitive_type_token1] = ACTIONS(2779),
    [anon_sym_byte] = ACTIONS(2779),
    [anon_sym_word] = ACTIONS(2779),
    [anon_sym_enum] = ACTIONS(2779),
    [anon_sym_class] = ACTIONS(2779),
    [anon_sym_struct] = ACTIONS(2779),
    [anon_sym_union] = ACTIONS(2779),
    [anon_sym_if] = ACTIONS(2779),
    [anon_sym_else] = ACTIONS(2779),
    [anon_sym_switch] = ACTIONS(2779),
    [anon_sym_case] = ACTIONS(2779),
    [anon_sym_default] = ACTIONS(2779),
    [anon_sym_while] = ACTIONS(2779),
    [anon_sym_do] = ACTIONS(2779),
    [anon_sym_for] = ACTIONS(2779),
    [anon_sym_return] = ACTIONS(2779),
    [anon_sym_break] = ACTIONS(2779),
    [anon_sym_continue] = ACTIONS(2779),
    [anon_sym_goto] = ACTIONS(2779),
    [anon_sym___try] = ACTIONS(2779),
    [anon_sym___leave] = ACTIONS(2779),
    [anon_sym_not] = ACTIONS(2779),
    [anon_sym_compl] = ACTIONS(2779),
    [anon_sym_DASH_DASH] = ACTIONS(2781),
    [anon_sym_PLUS_PLUS] = ACTIONS(2781),
    [anon_sym_sizeof] = ACTIONS(2779),
    [anon_sym___alignof__] = ACTIONS(2779),
    [anon_sym___alignof] = ACTIONS(2779),
    [anon_sym__alignof] = ACTIONS(2779),
    [anon_sym_alignof] = ACTIONS(2779),
    [anon_sym__Alignof] = ACTIONS(2779),
    [anon_sym_offsetof] = ACTIONS(2779),
    [anon_sym__Generic] = ACTIONS(2779),
    [anon_sym_asm] = ACTIONS(2779),
    [anon_sym___asm__] = ACTIONS(2779),
    [aux_sym_number_literal_token1] = ACTIONS(2781),
    [aux_sym_number_literal_token2] = ACTIONS(2779),
    [anon_sym_L_SQUOTE] = ACTIONS(2781),
    [anon_sym_u_SQUOTE] = ACTIONS(2781),
    [anon_sym_U_SQUOTE] = ACTIONS(2781),
    [anon_sym_u8_SQUOTE] = ACTIONS(2781),
    [anon_sym_SQUOTE] = ACTIONS(2781),
    [anon_sym_L_DQUOTE] = ACTIONS(2781),
    [anon_sym_u_DQUOTE] = ACTIONS(2781),
    [anon_sym_U_DQUOTE] = ACTIONS(2781),
    [anon_sym_u8_DQUOTE] = ACTIONS(2781),
    [anon_sym_DQUOTE] = ACTIONS(2781),
    [sym_true] = ACTIONS(2779),
    [sym_false] = ACTIONS(2779),
    [anon_sym_NULL] = ACTIONS(2779),
    [anon_sym_nullptr] = ACTIONS(2779),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2779),
    [anon_sym_decltype] = ACTIONS(2779),
    [anon_sym_virtual] = ACTIONS(2779),
    [anon_sym_alignas] = ACTIONS(2779),
    [anon_sym_explicit] = ACTIONS(2779),
    [anon_sym_typename] = ACTIONS(2779),
    [anon_sym_template] = ACTIONS(2779),
    [anon_sym_operator] = ACTIONS(2779),
    [anon_sym_try] = ACTIONS(2779),
    [anon_sym_delete] = ACTIONS(2779),
    [anon_sym_throw] = ACTIONS(2779),
    [anon_sym_namespace] = ACTIONS(2779),
    [anon_sym_using] = ACTIONS(2779),
    [anon_sym_static_assert] = ACTIONS(2779),
    [anon_sym_concept] = ACTIONS(2779),
    [anon_sym_co_return] = ACTIONS(2779),
    [anon_sym_co_yield] = ACTIONS(2779),
    [anon_sym_R_DQUOTE] = ACTIONS(2781),
    [anon_sym_LR_DQUOTE] = ACTIONS(2781),
    [anon_sym_uR_DQUOTE] = ACTIONS(2781),
    [anon_sym_UR_DQUOTE] = ACTIONS(2781),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2781),
    [anon_sym_co_await] = ACTIONS(2779),
    [anon_sym_new] = ACTIONS(2779),
    [anon_sym_requires] = ACTIONS(2779),
    [sym_this] = ACTIONS(2779),
  },
  [318] = {
    [sym_identifier] = ACTIONS(2783),
    [aux_sym_preproc_include_token1] = ACTIONS(2783),
    [aux_sym_preproc_def_token1] = ACTIONS(2783),
    [aux_sym_preproc_if_token1] = ACTIONS(2783),
    [aux_sym_preproc_if_token2] = ACTIONS(2783),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2783),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2783),
    [aux_sym_preproc_else_token1] = ACTIONS(2783),
    [aux_sym_preproc_elif_token1] = ACTIONS(2783),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2783),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2783),
    [sym_preproc_directive] = ACTIONS(2783),
    [anon_sym_LPAREN2] = ACTIONS(2785),
    [anon_sym_BANG] = ACTIONS(2785),
    [anon_sym_TILDE] = ACTIONS(2785),
    [anon_sym_DASH] = ACTIONS(2783),
    [anon_sym_PLUS] = ACTIONS(2783),
    [anon_sym_STAR] = ACTIONS(2785),
    [anon_sym_AMP_AMP] = ACTIONS(2785),
    [anon_sym_AMP] = ACTIONS(2783),
    [anon_sym_SEMI] = ACTIONS(2785),
    [anon_sym___extension__] = ACTIONS(2783),
    [anon_sym_typedef] = ACTIONS(2783),
    [anon_sym_extern] = ACTIONS(2783),
    [anon_sym___attribute__] = ACTIONS(2783),
    [anon_sym_COLON_COLON] = ACTIONS(2785),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2785),
    [anon_sym___declspec] = ACTIONS(2783),
    [anon_sym___based] = ACTIONS(2783),
    [anon_sym___cdecl] = ACTIONS(2783),
    [anon_sym___clrcall] = ACTIONS(2783),
    [anon_sym___stdcall] = ACTIONS(2783),
    [anon_sym___fastcall] = ACTIONS(2783),
    [anon_sym___thiscall] = ACTIONS(2783),
    [anon_sym___vectorcall] = ACTIONS(2783),
    [anon_sym_LBRACE] = ACTIONS(2785),
    [anon_sym_signed] = ACTIONS(2783),
    [anon_sym_unsigned] = ACTIONS(2783),
    [anon_sym_long] = ACTIONS(2783),
    [anon_sym_short] = ACTIONS(2783),
    [anon_sym_LBRACK] = ACTIONS(2783),
    [anon_sym_static] = ACTIONS(2783),
    [anon_sym_register] = ACTIONS(2783),
    [anon_sym_inline] = ACTIONS(2783),
    [anon_sym___inline] = ACTIONS(2783),
    [anon_sym___inline__] = ACTIONS(2783),
    [anon_sym___forceinline] = ACTIONS(2783),
    [anon_sym_thread_local] = ACTIONS(2783),
    [anon_sym___thread] = ACTIONS(2783),
    [anon_sym_const] = ACTIONS(2783),
    [anon_sym_constexpr] = ACTIONS(2783),
    [anon_sym_volatile] = ACTIONS(2783),
    [anon_sym_restrict] = ACTIONS(2783),
    [anon_sym___restrict__] = ACTIONS(2783),
    [anon_sym__Atomic] = ACTIONS(2783),
    [anon_sym__Noreturn] = ACTIONS(2783),
    [anon_sym_noreturn] = ACTIONS(2783),
    [anon_sym_mutable] = ACTIONS(2783),
    [anon_sym_constinit] = ACTIONS(2783),
    [anon_sym_consteval] = ACTIONS(2783),
    [anon_sym_PROGMEM] = ACTIONS(2783),
    [aux_sym_primitive_type_token1] = ACTIONS(2783),
    [anon_sym_byte] = ACTIONS(2783),
    [anon_sym_word] = ACTIONS(2783),
    [anon_sym_enum] = ACTIONS(2783),
    [anon_sym_class] = ACTIONS(2783),
    [anon_sym_struct] = ACTIONS(2783),
    [anon_sym_union] = ACTIONS(2783),
    [anon_sym_if] = ACTIONS(2783),
    [anon_sym_else] = ACTIONS(2783),
    [anon_sym_switch] = ACTIONS(2783),
    [anon_sym_case] = ACTIONS(2783),
    [anon_sym_default] = ACTIONS(2783),
    [anon_sym_while] = ACTIONS(2783),
    [anon_sym_do] = ACTIONS(2783),
    [anon_sym_for] = ACTIONS(2783),
    [anon_sym_return] = ACTIONS(2783),
    [anon_sym_break] = ACTIONS(2783),
    [anon_sym_continue] = ACTIONS(2783),
    [anon_sym_goto] = ACTIONS(2783),
    [anon_sym___try] = ACTIONS(2783),
    [anon_sym___leave] = ACTIONS(2783),
    [anon_sym_not] = ACTIONS(2783),
    [anon_sym_compl] = ACTIONS(2783),
    [anon_sym_DASH_DASH] = ACTIONS(2785),
    [anon_sym_PLUS_PLUS] = ACTIONS(2785),
    [anon_sym_sizeof] = ACTIONS(2783),
    [anon_sym___alignof__] = ACTIONS(2783),
    [anon_sym___alignof] = ACTIONS(2783),
    [anon_sym__alignof] = ACTIONS(2783),
    [anon_sym_alignof] = ACTIONS(2783),
    [anon_sym__Alignof] = ACTIONS(2783),
    [anon_sym_offsetof] = ACTIONS(2783),
    [anon_sym__Generic] = ACTIONS(2783),
    [anon_sym_asm] = ACTIONS(2783),
    [anon_sym___asm__] = ACTIONS(2783),
    [aux_sym_number_literal_token1] = ACTIONS(2785),
    [aux_sym_number_literal_token2] = ACTIONS(2783),
    [anon_sym_L_SQUOTE] = ACTIONS(2785),
    [anon_sym_u_SQUOTE] = ACTIONS(2785),
    [anon_sym_U_SQUOTE] = ACTIONS(2785),
    [anon_sym_u8_SQUOTE] = ACTIONS(2785),
    [anon_sym_SQUOTE] = ACTIONS(2785),
    [anon_sym_L_DQUOTE] = ACTIONS(2785),
    [anon_sym_u_DQUOTE] = ACTIONS(2785),
    [anon_sym_U_DQUOTE] = ACTIONS(2785),
    [anon_sym_u8_DQUOTE] = ACTIONS(2785),
    [anon_sym_DQUOTE] = ACTIONS(2785),
    [sym_true] = ACTIONS(2783),
    [sym_false] = ACTIONS(2783),
    [anon_sym_NULL] = ACTIONS(2783),
    [anon_sym_nullptr] = ACTIONS(2783),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2783),
    [anon_sym_decltype] = ACTIONS(2783),
    [anon_sym_virtual] = ACTIONS(2783),
    [anon_sym_alignas] = ACTIONS(2783),
    [anon_sym_explicit] = ACTIONS(2783),
    [anon_sym_typename] = ACTIONS(2783),
    [anon_sym_template] = ACTIONS(2783),
    [anon_sym_operator] = ACTIONS(2783),
    [anon_sym_try] = ACTIONS(2783),
    [anon_sym_delete] = ACTIONS(2783),
    [anon_sym_throw] = ACTIONS(2783),
    [anon_sym_namespace] = ACTIONS(2783),
    [anon_sym_using] = ACTIONS(2783),
    [anon_sym_static_assert] = ACTIONS(2783),
    [anon_sym_concept] = ACTIONS(2783),
    [anon_sym_co_return] = ACTIONS(2783),
    [anon_sym_co_yield] = ACTIONS(2783),
    [anon_sym_R_DQUOTE] = ACTIONS(2785),
    [anon_sym_LR_DQUOTE] = ACTIONS(2785),
    [anon_sym_uR_DQUOTE] = ACTIONS(2785),
    [anon_sym_UR_DQUOTE] = ACTIONS(2785),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2785),
    [anon_sym_co_await] = ACTIONS(2783),
    [anon_sym_new] = ACTIONS(2783),
    [anon_sym_requires] = ACTIONS(2783),
    [sym_this] = ACTIONS(2783),
  },
  [319] = {
    [sym_type_qualifier] = STATE(3799),
    [sym__type_specifier] = STATE(4801),
    [sym_sized_type_specifier] = STATE(2935),
    [sym_primitive_type] = STATE(4963),
    [sym_enum_specifier] = STATE(2935),
    [sym_struct_specifier] = STATE(2935),
    [sym_union_specifier] = STATE(2935),
    [sym__expression] = STATE(4286),
    [sym__expression_not_binary] = STATE(4648),
    [sym__string] = STATE(4648),
    [sym_conditional_expression] = STATE(4648),
    [sym_assignment_expression] = STATE(4648),
    [sym_pointer_expression] = STATE(3663),
    [sym_unary_expression] = STATE(4648),
    [sym_binary_expression] = STATE(4648),
    [sym_update_expression] = STATE(4648),
    [sym_cast_expression] = STATE(4648),
    [sym_type_descriptor] = STATE(6619),
    [sym_sizeof_expression] = STATE(4648),
    [sym_alignof_expression] = STATE(4648),
    [sym_offsetof_expression] = STATE(4648),
    [sym_generic_expression] = STATE(4648),
    [sym_subscript_expression] = STATE(3663),
    [sym_call_expression] = STATE(3663),
    [sym_gnu_asm_expression] = STATE(4648),
    [sym_field_expression] = STATE(3663),
    [sym_compound_literal_expression] = STATE(4648),
    [sym_parenthesized_expression] = STATE(3663),
    [sym_number_literal] = STATE(4573),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4565),
    [sym_string_literal] = STATE(3707),
    [sym_null] = STATE(4648),
    [sym_placeholder_type_specifier] = STATE(2935),
    [sym_decltype_auto] = STATE(2933),
    [sym_decltype] = STATE(2868),
    [sym_class_specifier] = STATE(2935),
    [sym__class_name] = STATE(7442),
    [sym_dependent_type] = STATE(2935),
    [sym_template_type] = STATE(5228),
    [sym_template_function] = STATE(4648),
    [sym_raw_string_literal] = STATE(3709),
    [sym_co_await_expression] = STATE(4648),
    [sym_new_expression] = STATE(4648),
    [sym_delete_expression] = STATE(4648),
    [sym_requires_clause] = STATE(4648),
    [sym_requires_expression] = STATE(4648),
    [sym_lambda_expression] = STATE(4648),
    [sym_lambda_capture_specifier] = STATE(5768),
    [sym_fold_expression] = STATE(4648),
    [sym_parameter_pack_expansion] = STATE(4648),
    [sym_type_parameter_pack_expansion] = STATE(6911),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5541),
    [sym_qualified_identifier] = STATE(3663),
    [sym_qualified_type_identifier] = STATE(5253),
    [sym_user_defined_literal] = STATE(3663),
    [aux_sym__type_definition_type_repeat1] = STATE(3799),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2164),
    [sym_identifier] = ACTIONS(2573),
    [anon_sym_LPAREN2] = ACTIONS(2575),
    [anon_sym_BANG] = ACTIONS(2577),
    [anon_sym_TILDE] = ACTIONS(2577),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2583),
    [anon_sym_signed] = ACTIONS(2585),
    [anon_sym_unsigned] = ACTIONS(2585),
    [anon_sym_long] = ACTIONS(2585),
    [anon_sym_short] = ACTIONS(2585),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2587),
    [anon_sym_byte] = ACTIONS(2587),
    [anon_sym_word] = ACTIONS(2587),
    [anon_sym_enum] = ACTIONS(2589),
    [anon_sym_class] = ACTIONS(2591),
    [anon_sym_struct] = ACTIONS(2593),
    [anon_sym_union] = ACTIONS(2595),
    [anon_sym_not] = ACTIONS(2579),
    [anon_sym_compl] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(2597),
    [anon_sym_PLUS_PLUS] = ACTIONS(2597),
    [anon_sym_sizeof] = ACTIONS(2599),
    [anon_sym___alignof__] = ACTIONS(2601),
    [anon_sym___alignof] = ACTIONS(2601),
    [anon_sym__alignof] = ACTIONS(2601),
    [anon_sym_alignof] = ACTIONS(2601),
    [anon_sym__Alignof] = ACTIONS(2601),
    [anon_sym_offsetof] = ACTIONS(2603),
    [anon_sym__Generic] = ACTIONS(2605),
    [anon_sym_asm] = ACTIONS(2607),
    [anon_sym___asm__] = ACTIONS(2607),
    [aux_sym_number_literal_token1] = ACTIONS(2609),
    [aux_sym_number_literal_token2] = ACTIONS(2611),
    [anon_sym_L_SQUOTE] = ACTIONS(2613),
    [anon_sym_u_SQUOTE] = ACTIONS(2613),
    [anon_sym_U_SQUOTE] = ACTIONS(2613),
    [anon_sym_u8_SQUOTE] = ACTIONS(2613),
    [anon_sym_SQUOTE] = ACTIONS(2613),
    [anon_sym_L_DQUOTE] = ACTIONS(2615),
    [anon_sym_u_DQUOTE] = ACTIONS(2615),
    [anon_sym_U_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8_DQUOTE] = ACTIONS(2615),
    [anon_sym_DQUOTE] = ACTIONS(2615),
    [sym_true] = ACTIONS(2617),
    [sym_false] = ACTIONS(2617),
    [anon_sym_NULL] = ACTIONS(2619),
    [anon_sym_nullptr] = ACTIONS(2619),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2621),
    [anon_sym_decltype] = ACTIONS(2623),
    [anon_sym_typename] = ACTIONS(2625),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_GT2] = ACTIONS(2787),
    [anon_sym_delete] = ACTIONS(2629),
    [anon_sym_R_DQUOTE] = ACTIONS(2631),
    [anon_sym_LR_DQUOTE] = ACTIONS(2631),
    [anon_sym_uR_DQUOTE] = ACTIONS(2631),
    [anon_sym_UR_DQUOTE] = ACTIONS(2631),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2631),
    [anon_sym_co_await] = ACTIONS(2633),
    [anon_sym_new] = ACTIONS(2635),
    [anon_sym_requires] = ACTIONS(2637),
    [sym_this] = ACTIONS(2617),
  },
  [320] = {
    [sym_type_qualifier] = STATE(3799),
    [sym__type_specifier] = STATE(4801),
    [sym_sized_type_specifier] = STATE(2935),
    [sym_primitive_type] = STATE(4963),
    [sym_enum_specifier] = STATE(2935),
    [sym_struct_specifier] = STATE(2935),
    [sym_union_specifier] = STATE(2935),
    [sym__expression] = STATE(4325),
    [sym__expression_not_binary] = STATE(4648),
    [sym__string] = STATE(4648),
    [sym_conditional_expression] = STATE(4648),
    [sym_assignment_expression] = STATE(4648),
    [sym_pointer_expression] = STATE(3663),
    [sym_unary_expression] = STATE(4648),
    [sym_binary_expression] = STATE(4648),
    [sym_update_expression] = STATE(4648),
    [sym_cast_expression] = STATE(4648),
    [sym_type_descriptor] = STATE(6660),
    [sym_sizeof_expression] = STATE(4648),
    [sym_alignof_expression] = STATE(4648),
    [sym_offsetof_expression] = STATE(4648),
    [sym_generic_expression] = STATE(4648),
    [sym_subscript_expression] = STATE(3663),
    [sym_call_expression] = STATE(3663),
    [sym_gnu_asm_expression] = STATE(4648),
    [sym_field_expression] = STATE(3663),
    [sym_compound_literal_expression] = STATE(4648),
    [sym_parenthesized_expression] = STATE(3663),
    [sym_number_literal] = STATE(4573),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4565),
    [sym_string_literal] = STATE(3707),
    [sym_null] = STATE(4648),
    [sym_placeholder_type_specifier] = STATE(2935),
    [sym_decltype_auto] = STATE(2933),
    [sym_decltype] = STATE(2868),
    [sym_class_specifier] = STATE(2935),
    [sym__class_name] = STATE(7442),
    [sym_dependent_type] = STATE(2935),
    [sym_template_type] = STATE(5228),
    [sym_template_function] = STATE(4648),
    [sym_raw_string_literal] = STATE(3709),
    [sym_co_await_expression] = STATE(4648),
    [sym_new_expression] = STATE(4648),
    [sym_delete_expression] = STATE(4648),
    [sym_requires_clause] = STATE(4648),
    [sym_requires_expression] = STATE(4648),
    [sym_lambda_expression] = STATE(4648),
    [sym_lambda_capture_specifier] = STATE(5768),
    [sym_fold_expression] = STATE(4648),
    [sym_parameter_pack_expansion] = STATE(4648),
    [sym_type_parameter_pack_expansion] = STATE(7021),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5541),
    [sym_qualified_identifier] = STATE(3663),
    [sym_qualified_type_identifier] = STATE(5253),
    [sym_user_defined_literal] = STATE(3663),
    [aux_sym__type_definition_type_repeat1] = STATE(3799),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2164),
    [sym_identifier] = ACTIONS(2573),
    [anon_sym_LPAREN2] = ACTIONS(2575),
    [anon_sym_BANG] = ACTIONS(2577),
    [anon_sym_TILDE] = ACTIONS(2577),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2583),
    [anon_sym_signed] = ACTIONS(2585),
    [anon_sym_unsigned] = ACTIONS(2585),
    [anon_sym_long] = ACTIONS(2585),
    [anon_sym_short] = ACTIONS(2585),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2587),
    [anon_sym_byte] = ACTIONS(2587),
    [anon_sym_word] = ACTIONS(2587),
    [anon_sym_enum] = ACTIONS(2589),
    [anon_sym_class] = ACTIONS(2591),
    [anon_sym_struct] = ACTIONS(2593),
    [anon_sym_union] = ACTIONS(2595),
    [anon_sym_not] = ACTIONS(2579),
    [anon_sym_compl] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(2597),
    [anon_sym_PLUS_PLUS] = ACTIONS(2597),
    [anon_sym_sizeof] = ACTIONS(2599),
    [anon_sym___alignof__] = ACTIONS(2601),
    [anon_sym___alignof] = ACTIONS(2601),
    [anon_sym__alignof] = ACTIONS(2601),
    [anon_sym_alignof] = ACTIONS(2601),
    [anon_sym__Alignof] = ACTIONS(2601),
    [anon_sym_offsetof] = ACTIONS(2603),
    [anon_sym__Generic] = ACTIONS(2605),
    [anon_sym_asm] = ACTIONS(2607),
    [anon_sym___asm__] = ACTIONS(2607),
    [aux_sym_number_literal_token1] = ACTIONS(2609),
    [aux_sym_number_literal_token2] = ACTIONS(2611),
    [anon_sym_L_SQUOTE] = ACTIONS(2613),
    [anon_sym_u_SQUOTE] = ACTIONS(2613),
    [anon_sym_U_SQUOTE] = ACTIONS(2613),
    [anon_sym_u8_SQUOTE] = ACTIONS(2613),
    [anon_sym_SQUOTE] = ACTIONS(2613),
    [anon_sym_L_DQUOTE] = ACTIONS(2615),
    [anon_sym_u_DQUOTE] = ACTIONS(2615),
    [anon_sym_U_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8_DQUOTE] = ACTIONS(2615),
    [anon_sym_DQUOTE] = ACTIONS(2615),
    [sym_true] = ACTIONS(2617),
    [sym_false] = ACTIONS(2617),
    [anon_sym_NULL] = ACTIONS(2619),
    [anon_sym_nullptr] = ACTIONS(2619),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2621),
    [anon_sym_decltype] = ACTIONS(2623),
    [anon_sym_typename] = ACTIONS(2625),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_GT2] = ACTIONS(2789),
    [anon_sym_delete] = ACTIONS(2629),
    [anon_sym_R_DQUOTE] = ACTIONS(2631),
    [anon_sym_LR_DQUOTE] = ACTIONS(2631),
    [anon_sym_uR_DQUOTE] = ACTIONS(2631),
    [anon_sym_UR_DQUOTE] = ACTIONS(2631),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2631),
    [anon_sym_co_await] = ACTIONS(2633),
    [anon_sym_new] = ACTIONS(2635),
    [anon_sym_requires] = ACTIONS(2637),
    [sym_this] = ACTIONS(2617),
  },
  [321] = {
    [sym_identifier] = ACTIONS(2639),
    [aux_sym_preproc_include_token1] = ACTIONS(2639),
    [aux_sym_preproc_def_token1] = ACTIONS(2639),
    [aux_sym_preproc_if_token1] = ACTIONS(2639),
    [aux_sym_preproc_if_token2] = ACTIONS(2639),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2639),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2639),
    [aux_sym_preproc_else_token1] = ACTIONS(2639),
    [aux_sym_preproc_elif_token1] = ACTIONS(2639),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2639),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2639),
    [sym_preproc_directive] = ACTIONS(2639),
    [anon_sym_LPAREN2] = ACTIONS(2641),
    [anon_sym_BANG] = ACTIONS(2641),
    [anon_sym_TILDE] = ACTIONS(2641),
    [anon_sym_DASH] = ACTIONS(2639),
    [anon_sym_PLUS] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(2641),
    [anon_sym_AMP_AMP] = ACTIONS(2641),
    [anon_sym_AMP] = ACTIONS(2639),
    [anon_sym_SEMI] = ACTIONS(2641),
    [anon_sym___extension__] = ACTIONS(2639),
    [anon_sym_typedef] = ACTIONS(2639),
    [anon_sym_extern] = ACTIONS(2639),
    [anon_sym___attribute__] = ACTIONS(2639),
    [anon_sym_COLON_COLON] = ACTIONS(2641),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2641),
    [anon_sym___declspec] = ACTIONS(2639),
    [anon_sym___based] = ACTIONS(2639),
    [anon_sym___cdecl] = ACTIONS(2639),
    [anon_sym___clrcall] = ACTIONS(2639),
    [anon_sym___stdcall] = ACTIONS(2639),
    [anon_sym___fastcall] = ACTIONS(2639),
    [anon_sym___thiscall] = ACTIONS(2639),
    [anon_sym___vectorcall] = ACTIONS(2639),
    [anon_sym_LBRACE] = ACTIONS(2641),
    [anon_sym_signed] = ACTIONS(2639),
    [anon_sym_unsigned] = ACTIONS(2639),
    [anon_sym_long] = ACTIONS(2639),
    [anon_sym_short] = ACTIONS(2639),
    [anon_sym_LBRACK] = ACTIONS(2639),
    [anon_sym_static] = ACTIONS(2639),
    [anon_sym_register] = ACTIONS(2639),
    [anon_sym_inline] = ACTIONS(2639),
    [anon_sym___inline] = ACTIONS(2639),
    [anon_sym___inline__] = ACTIONS(2639),
    [anon_sym___forceinline] = ACTIONS(2639),
    [anon_sym_thread_local] = ACTIONS(2639),
    [anon_sym___thread] = ACTIONS(2639),
    [anon_sym_const] = ACTIONS(2639),
    [anon_sym_constexpr] = ACTIONS(2639),
    [anon_sym_volatile] = ACTIONS(2639),
    [anon_sym_restrict] = ACTIONS(2639),
    [anon_sym___restrict__] = ACTIONS(2639),
    [anon_sym__Atomic] = ACTIONS(2639),
    [anon_sym__Noreturn] = ACTIONS(2639),
    [anon_sym_noreturn] = ACTIONS(2639),
    [anon_sym_mutable] = ACTIONS(2639),
    [anon_sym_constinit] = ACTIONS(2639),
    [anon_sym_consteval] = ACTIONS(2639),
    [anon_sym_PROGMEM] = ACTIONS(2639),
    [aux_sym_primitive_type_token1] = ACTIONS(2639),
    [anon_sym_byte] = ACTIONS(2639),
    [anon_sym_word] = ACTIONS(2639),
    [anon_sym_enum] = ACTIONS(2639),
    [anon_sym_class] = ACTIONS(2639),
    [anon_sym_struct] = ACTIONS(2639),
    [anon_sym_union] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2639),
    [anon_sym_else] = ACTIONS(2639),
    [anon_sym_switch] = ACTIONS(2639),
    [anon_sym_case] = ACTIONS(2639),
    [anon_sym_default] = ACTIONS(2639),
    [anon_sym_while] = ACTIONS(2639),
    [anon_sym_do] = ACTIONS(2639),
    [anon_sym_for] = ACTIONS(2639),
    [anon_sym_return] = ACTIONS(2639),
    [anon_sym_break] = ACTIONS(2639),
    [anon_sym_continue] = ACTIONS(2639),
    [anon_sym_goto] = ACTIONS(2639),
    [anon_sym___try] = ACTIONS(2639),
    [anon_sym___leave] = ACTIONS(2639),
    [anon_sym_not] = ACTIONS(2639),
    [anon_sym_compl] = ACTIONS(2639),
    [anon_sym_DASH_DASH] = ACTIONS(2641),
    [anon_sym_PLUS_PLUS] = ACTIONS(2641),
    [anon_sym_sizeof] = ACTIONS(2639),
    [anon_sym___alignof__] = ACTIONS(2639),
    [anon_sym___alignof] = ACTIONS(2639),
    [anon_sym__alignof] = ACTIONS(2639),
    [anon_sym_alignof] = ACTIONS(2639),
    [anon_sym__Alignof] = ACTIONS(2639),
    [anon_sym_offsetof] = ACTIONS(2639),
    [anon_sym__Generic] = ACTIONS(2639),
    [anon_sym_asm] = ACTIONS(2639),
    [anon_sym___asm__] = ACTIONS(2639),
    [aux_sym_number_literal_token1] = ACTIONS(2641),
    [aux_sym_number_literal_token2] = ACTIONS(2639),
    [anon_sym_L_SQUOTE] = ACTIONS(2641),
    [anon_sym_u_SQUOTE] = ACTIONS(2641),
    [anon_sym_U_SQUOTE] = ACTIONS(2641),
    [anon_sym_u8_SQUOTE] = ACTIONS(2641),
    [anon_sym_SQUOTE] = ACTIONS(2641),
    [anon_sym_L_DQUOTE] = ACTIONS(2641),
    [anon_sym_u_DQUOTE] = ACTIONS(2641),
    [anon_sym_U_DQUOTE] = ACTIONS(2641),
    [anon_sym_u8_DQUOTE] = ACTIONS(2641),
    [anon_sym_DQUOTE] = ACTIONS(2641),
    [sym_true] = ACTIONS(2639),
    [sym_false] = ACTIONS(2639),
    [anon_sym_NULL] = ACTIONS(2639),
    [anon_sym_nullptr] = ACTIONS(2639),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2639),
    [anon_sym_decltype] = ACTIONS(2639),
    [anon_sym_virtual] = ACTIONS(2639),
    [anon_sym_alignas] = ACTIONS(2639),
    [anon_sym_explicit] = ACTIONS(2639),
    [anon_sym_typename] = ACTIONS(2639),
    [anon_sym_template] = ACTIONS(2639),
    [anon_sym_operator] = ACTIONS(2639),
    [anon_sym_try] = ACTIONS(2639),
    [anon_sym_delete] = ACTIONS(2639),
    [anon_sym_throw] = ACTIONS(2639),
    [anon_sym_namespace] = ACTIONS(2639),
    [anon_sym_using] = ACTIONS(2639),
    [anon_sym_static_assert] = ACTIONS(2639),
    [anon_sym_concept] = ACTIONS(2639),
    [anon_sym_co_return] = ACTIONS(2639),
    [anon_sym_co_yield] = ACTIONS(2639),
    [anon_sym_R_DQUOTE] = ACTIONS(2641),
    [anon_sym_LR_DQUOTE] = ACTIONS(2641),
    [anon_sym_uR_DQUOTE] = ACTIONS(2641),
    [anon_sym_UR_DQUOTE] = ACTIONS(2641),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2641),
    [anon_sym_co_await] = ACTIONS(2639),
    [anon_sym_new] = ACTIONS(2639),
    [anon_sym_requires] = ACTIONS(2639),
    [sym_this] = ACTIONS(2639),
  },
  [322] = {
    [sym_type_qualifier] = STATE(3799),
    [sym__type_specifier] = STATE(4801),
    [sym_sized_type_specifier] = STATE(2935),
    [sym_primitive_type] = STATE(4963),
    [sym_enum_specifier] = STATE(2935),
    [sym_struct_specifier] = STATE(2935),
    [sym_union_specifier] = STATE(2935),
    [sym__expression] = STATE(4329),
    [sym__expression_not_binary] = STATE(4648),
    [sym__string] = STATE(4648),
    [sym_conditional_expression] = STATE(4648),
    [sym_assignment_expression] = STATE(4648),
    [sym_pointer_expression] = STATE(3663),
    [sym_unary_expression] = STATE(4648),
    [sym_binary_expression] = STATE(4648),
    [sym_update_expression] = STATE(4648),
    [sym_cast_expression] = STATE(4648),
    [sym_type_descriptor] = STATE(6643),
    [sym_sizeof_expression] = STATE(4648),
    [sym_alignof_expression] = STATE(4648),
    [sym_offsetof_expression] = STATE(4648),
    [sym_generic_expression] = STATE(4648),
    [sym_subscript_expression] = STATE(3663),
    [sym_call_expression] = STATE(3663),
    [sym_gnu_asm_expression] = STATE(4648),
    [sym_field_expression] = STATE(3663),
    [sym_compound_literal_expression] = STATE(4648),
    [sym_parenthesized_expression] = STATE(3663),
    [sym_number_literal] = STATE(4573),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4565),
    [sym_string_literal] = STATE(3707),
    [sym_null] = STATE(4648),
    [sym_placeholder_type_specifier] = STATE(2935),
    [sym_decltype_auto] = STATE(2933),
    [sym_decltype] = STATE(2868),
    [sym_class_specifier] = STATE(2935),
    [sym__class_name] = STATE(7442),
    [sym_dependent_type] = STATE(2935),
    [sym_template_type] = STATE(5228),
    [sym_template_function] = STATE(4648),
    [sym_raw_string_literal] = STATE(3709),
    [sym_co_await_expression] = STATE(4648),
    [sym_new_expression] = STATE(4648),
    [sym_delete_expression] = STATE(4648),
    [sym_requires_clause] = STATE(4648),
    [sym_requires_expression] = STATE(4648),
    [sym_lambda_expression] = STATE(4648),
    [sym_lambda_capture_specifier] = STATE(5768),
    [sym_fold_expression] = STATE(4648),
    [sym_parameter_pack_expansion] = STATE(4648),
    [sym_type_parameter_pack_expansion] = STATE(7232),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5541),
    [sym_qualified_identifier] = STATE(3663),
    [sym_qualified_type_identifier] = STATE(5253),
    [sym_user_defined_literal] = STATE(3663),
    [aux_sym__type_definition_type_repeat1] = STATE(3799),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2164),
    [sym_identifier] = ACTIONS(2573),
    [anon_sym_LPAREN2] = ACTIONS(2575),
    [anon_sym_BANG] = ACTIONS(2577),
    [anon_sym_TILDE] = ACTIONS(2577),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2583),
    [anon_sym_signed] = ACTIONS(2585),
    [anon_sym_unsigned] = ACTIONS(2585),
    [anon_sym_long] = ACTIONS(2585),
    [anon_sym_short] = ACTIONS(2585),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2587),
    [anon_sym_byte] = ACTIONS(2587),
    [anon_sym_word] = ACTIONS(2587),
    [anon_sym_enum] = ACTIONS(2589),
    [anon_sym_class] = ACTIONS(2591),
    [anon_sym_struct] = ACTIONS(2593),
    [anon_sym_union] = ACTIONS(2595),
    [anon_sym_not] = ACTIONS(2579),
    [anon_sym_compl] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(2597),
    [anon_sym_PLUS_PLUS] = ACTIONS(2597),
    [anon_sym_sizeof] = ACTIONS(2599),
    [anon_sym___alignof__] = ACTIONS(2601),
    [anon_sym___alignof] = ACTIONS(2601),
    [anon_sym__alignof] = ACTIONS(2601),
    [anon_sym_alignof] = ACTIONS(2601),
    [anon_sym__Alignof] = ACTIONS(2601),
    [anon_sym_offsetof] = ACTIONS(2603),
    [anon_sym__Generic] = ACTIONS(2605),
    [anon_sym_asm] = ACTIONS(2607),
    [anon_sym___asm__] = ACTIONS(2607),
    [aux_sym_number_literal_token1] = ACTIONS(2609),
    [aux_sym_number_literal_token2] = ACTIONS(2611),
    [anon_sym_L_SQUOTE] = ACTIONS(2613),
    [anon_sym_u_SQUOTE] = ACTIONS(2613),
    [anon_sym_U_SQUOTE] = ACTIONS(2613),
    [anon_sym_u8_SQUOTE] = ACTIONS(2613),
    [anon_sym_SQUOTE] = ACTIONS(2613),
    [anon_sym_L_DQUOTE] = ACTIONS(2615),
    [anon_sym_u_DQUOTE] = ACTIONS(2615),
    [anon_sym_U_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8_DQUOTE] = ACTIONS(2615),
    [anon_sym_DQUOTE] = ACTIONS(2615),
    [sym_true] = ACTIONS(2617),
    [sym_false] = ACTIONS(2617),
    [anon_sym_NULL] = ACTIONS(2619),
    [anon_sym_nullptr] = ACTIONS(2619),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2621),
    [anon_sym_decltype] = ACTIONS(2623),
    [anon_sym_typename] = ACTIONS(2625),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_GT2] = ACTIONS(2791),
    [anon_sym_delete] = ACTIONS(2629),
    [anon_sym_R_DQUOTE] = ACTIONS(2631),
    [anon_sym_LR_DQUOTE] = ACTIONS(2631),
    [anon_sym_uR_DQUOTE] = ACTIONS(2631),
    [anon_sym_UR_DQUOTE] = ACTIONS(2631),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2631),
    [anon_sym_co_await] = ACTIONS(2633),
    [anon_sym_new] = ACTIONS(2635),
    [anon_sym_requires] = ACTIONS(2637),
    [sym_this] = ACTIONS(2617),
  },
  [323] = {
    [sym_type_qualifier] = STATE(3799),
    [sym__type_specifier] = STATE(4801),
    [sym_sized_type_specifier] = STATE(2935),
    [sym_primitive_type] = STATE(4963),
    [sym_enum_specifier] = STATE(2935),
    [sym_struct_specifier] = STATE(2935),
    [sym_union_specifier] = STATE(2935),
    [sym__expression] = STATE(4338),
    [sym__expression_not_binary] = STATE(4648),
    [sym__string] = STATE(4648),
    [sym_conditional_expression] = STATE(4648),
    [sym_assignment_expression] = STATE(4648),
    [sym_pointer_expression] = STATE(3663),
    [sym_unary_expression] = STATE(4648),
    [sym_binary_expression] = STATE(4648),
    [sym_update_expression] = STATE(4648),
    [sym_cast_expression] = STATE(4648),
    [sym_type_descriptor] = STATE(6671),
    [sym_sizeof_expression] = STATE(4648),
    [sym_alignof_expression] = STATE(4648),
    [sym_offsetof_expression] = STATE(4648),
    [sym_generic_expression] = STATE(4648),
    [sym_subscript_expression] = STATE(3663),
    [sym_call_expression] = STATE(3663),
    [sym_gnu_asm_expression] = STATE(4648),
    [sym_field_expression] = STATE(3663),
    [sym_compound_literal_expression] = STATE(4648),
    [sym_parenthesized_expression] = STATE(3663),
    [sym_number_literal] = STATE(4573),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4565),
    [sym_string_literal] = STATE(3707),
    [sym_null] = STATE(4648),
    [sym_placeholder_type_specifier] = STATE(2935),
    [sym_decltype_auto] = STATE(2933),
    [sym_decltype] = STATE(2868),
    [sym_class_specifier] = STATE(2935),
    [sym__class_name] = STATE(7442),
    [sym_dependent_type] = STATE(2935),
    [sym_template_type] = STATE(5228),
    [sym_template_function] = STATE(4648),
    [sym_raw_string_literal] = STATE(3709),
    [sym_co_await_expression] = STATE(4648),
    [sym_new_expression] = STATE(4648),
    [sym_delete_expression] = STATE(4648),
    [sym_requires_clause] = STATE(4648),
    [sym_requires_expression] = STATE(4648),
    [sym_lambda_expression] = STATE(4648),
    [sym_lambda_capture_specifier] = STATE(5768),
    [sym_fold_expression] = STATE(4648),
    [sym_parameter_pack_expansion] = STATE(4648),
    [sym_type_parameter_pack_expansion] = STATE(7172),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5541),
    [sym_qualified_identifier] = STATE(3663),
    [sym_qualified_type_identifier] = STATE(5253),
    [sym_user_defined_literal] = STATE(3663),
    [aux_sym__type_definition_type_repeat1] = STATE(3799),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2164),
    [sym_identifier] = ACTIONS(2573),
    [anon_sym_LPAREN2] = ACTIONS(2575),
    [anon_sym_BANG] = ACTIONS(2577),
    [anon_sym_TILDE] = ACTIONS(2577),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2583),
    [anon_sym_signed] = ACTIONS(2585),
    [anon_sym_unsigned] = ACTIONS(2585),
    [anon_sym_long] = ACTIONS(2585),
    [anon_sym_short] = ACTIONS(2585),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2587),
    [anon_sym_byte] = ACTIONS(2587),
    [anon_sym_word] = ACTIONS(2587),
    [anon_sym_enum] = ACTIONS(2589),
    [anon_sym_class] = ACTIONS(2591),
    [anon_sym_struct] = ACTIONS(2593),
    [anon_sym_union] = ACTIONS(2595),
    [anon_sym_not] = ACTIONS(2579),
    [anon_sym_compl] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(2597),
    [anon_sym_PLUS_PLUS] = ACTIONS(2597),
    [anon_sym_sizeof] = ACTIONS(2599),
    [anon_sym___alignof__] = ACTIONS(2601),
    [anon_sym___alignof] = ACTIONS(2601),
    [anon_sym__alignof] = ACTIONS(2601),
    [anon_sym_alignof] = ACTIONS(2601),
    [anon_sym__Alignof] = ACTIONS(2601),
    [anon_sym_offsetof] = ACTIONS(2603),
    [anon_sym__Generic] = ACTIONS(2605),
    [anon_sym_asm] = ACTIONS(2607),
    [anon_sym___asm__] = ACTIONS(2607),
    [aux_sym_number_literal_token1] = ACTIONS(2609),
    [aux_sym_number_literal_token2] = ACTIONS(2611),
    [anon_sym_L_SQUOTE] = ACTIONS(2613),
    [anon_sym_u_SQUOTE] = ACTIONS(2613),
    [anon_sym_U_SQUOTE] = ACTIONS(2613),
    [anon_sym_u8_SQUOTE] = ACTIONS(2613),
    [anon_sym_SQUOTE] = ACTIONS(2613),
    [anon_sym_L_DQUOTE] = ACTIONS(2615),
    [anon_sym_u_DQUOTE] = ACTIONS(2615),
    [anon_sym_U_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8_DQUOTE] = ACTIONS(2615),
    [anon_sym_DQUOTE] = ACTIONS(2615),
    [sym_true] = ACTIONS(2617),
    [sym_false] = ACTIONS(2617),
    [anon_sym_NULL] = ACTIONS(2619),
    [anon_sym_nullptr] = ACTIONS(2619),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2621),
    [anon_sym_decltype] = ACTIONS(2623),
    [anon_sym_typename] = ACTIONS(2625),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_GT2] = ACTIONS(2793),
    [anon_sym_delete] = ACTIONS(2629),
    [anon_sym_R_DQUOTE] = ACTIONS(2631),
    [anon_sym_LR_DQUOTE] = ACTIONS(2631),
    [anon_sym_uR_DQUOTE] = ACTIONS(2631),
    [anon_sym_UR_DQUOTE] = ACTIONS(2631),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2631),
    [anon_sym_co_await] = ACTIONS(2633),
    [anon_sym_new] = ACTIONS(2635),
    [anon_sym_requires] = ACTIONS(2637),
    [sym_this] = ACTIONS(2617),
  },
  [324] = {
    [sym_type_qualifier] = STATE(3799),
    [sym__type_specifier] = STATE(4801),
    [sym_sized_type_specifier] = STATE(2935),
    [sym_primitive_type] = STATE(4963),
    [sym_enum_specifier] = STATE(2935),
    [sym_struct_specifier] = STATE(2935),
    [sym_union_specifier] = STATE(2935),
    [sym__expression] = STATE(4334),
    [sym__expression_not_binary] = STATE(4648),
    [sym__string] = STATE(4648),
    [sym_conditional_expression] = STATE(4648),
    [sym_assignment_expression] = STATE(4648),
    [sym_pointer_expression] = STATE(3663),
    [sym_unary_expression] = STATE(4648),
    [sym_binary_expression] = STATE(4648),
    [sym_update_expression] = STATE(4648),
    [sym_cast_expression] = STATE(4648),
    [sym_type_descriptor] = STATE(6651),
    [sym_sizeof_expression] = STATE(4648),
    [sym_alignof_expression] = STATE(4648),
    [sym_offsetof_expression] = STATE(4648),
    [sym_generic_expression] = STATE(4648),
    [sym_subscript_expression] = STATE(3663),
    [sym_call_expression] = STATE(3663),
    [sym_gnu_asm_expression] = STATE(4648),
    [sym_field_expression] = STATE(3663),
    [sym_compound_literal_expression] = STATE(4648),
    [sym_parenthesized_expression] = STATE(3663),
    [sym_number_literal] = STATE(4573),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4565),
    [sym_string_literal] = STATE(3707),
    [sym_null] = STATE(4648),
    [sym_placeholder_type_specifier] = STATE(2935),
    [sym_decltype_auto] = STATE(2933),
    [sym_decltype] = STATE(2868),
    [sym_class_specifier] = STATE(2935),
    [sym__class_name] = STATE(7442),
    [sym_dependent_type] = STATE(2935),
    [sym_template_type] = STATE(5228),
    [sym_template_function] = STATE(4648),
    [sym_raw_string_literal] = STATE(3709),
    [sym_co_await_expression] = STATE(4648),
    [sym_new_expression] = STATE(4648),
    [sym_delete_expression] = STATE(4648),
    [sym_requires_clause] = STATE(4648),
    [sym_requires_expression] = STATE(4648),
    [sym_lambda_expression] = STATE(4648),
    [sym_lambda_capture_specifier] = STATE(5768),
    [sym_fold_expression] = STATE(4648),
    [sym_parameter_pack_expansion] = STATE(4648),
    [sym_type_parameter_pack_expansion] = STATE(7212),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5541),
    [sym_qualified_identifier] = STATE(3663),
    [sym_qualified_type_identifier] = STATE(5253),
    [sym_user_defined_literal] = STATE(3663),
    [aux_sym__type_definition_type_repeat1] = STATE(3799),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2164),
    [sym_identifier] = ACTIONS(2573),
    [anon_sym_LPAREN2] = ACTIONS(2575),
    [anon_sym_BANG] = ACTIONS(2577),
    [anon_sym_TILDE] = ACTIONS(2577),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2583),
    [anon_sym_signed] = ACTIONS(2585),
    [anon_sym_unsigned] = ACTIONS(2585),
    [anon_sym_long] = ACTIONS(2585),
    [anon_sym_short] = ACTIONS(2585),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2587),
    [anon_sym_byte] = ACTIONS(2587),
    [anon_sym_word] = ACTIONS(2587),
    [anon_sym_enum] = ACTIONS(2589),
    [anon_sym_class] = ACTIONS(2591),
    [anon_sym_struct] = ACTIONS(2593),
    [anon_sym_union] = ACTIONS(2595),
    [anon_sym_not] = ACTIONS(2579),
    [anon_sym_compl] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(2597),
    [anon_sym_PLUS_PLUS] = ACTIONS(2597),
    [anon_sym_sizeof] = ACTIONS(2599),
    [anon_sym___alignof__] = ACTIONS(2601),
    [anon_sym___alignof] = ACTIONS(2601),
    [anon_sym__alignof] = ACTIONS(2601),
    [anon_sym_alignof] = ACTIONS(2601),
    [anon_sym__Alignof] = ACTIONS(2601),
    [anon_sym_offsetof] = ACTIONS(2603),
    [anon_sym__Generic] = ACTIONS(2605),
    [anon_sym_asm] = ACTIONS(2607),
    [anon_sym___asm__] = ACTIONS(2607),
    [aux_sym_number_literal_token1] = ACTIONS(2609),
    [aux_sym_number_literal_token2] = ACTIONS(2611),
    [anon_sym_L_SQUOTE] = ACTIONS(2613),
    [anon_sym_u_SQUOTE] = ACTIONS(2613),
    [anon_sym_U_SQUOTE] = ACTIONS(2613),
    [anon_sym_u8_SQUOTE] = ACTIONS(2613),
    [anon_sym_SQUOTE] = ACTIONS(2613),
    [anon_sym_L_DQUOTE] = ACTIONS(2615),
    [anon_sym_u_DQUOTE] = ACTIONS(2615),
    [anon_sym_U_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8_DQUOTE] = ACTIONS(2615),
    [anon_sym_DQUOTE] = ACTIONS(2615),
    [sym_true] = ACTIONS(2617),
    [sym_false] = ACTIONS(2617),
    [anon_sym_NULL] = ACTIONS(2619),
    [anon_sym_nullptr] = ACTIONS(2619),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2621),
    [anon_sym_decltype] = ACTIONS(2623),
    [anon_sym_typename] = ACTIONS(2625),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_GT2] = ACTIONS(2795),
    [anon_sym_delete] = ACTIONS(2629),
    [anon_sym_R_DQUOTE] = ACTIONS(2631),
    [anon_sym_LR_DQUOTE] = ACTIONS(2631),
    [anon_sym_uR_DQUOTE] = ACTIONS(2631),
    [anon_sym_UR_DQUOTE] = ACTIONS(2631),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2631),
    [anon_sym_co_await] = ACTIONS(2633),
    [anon_sym_new] = ACTIONS(2635),
    [anon_sym_requires] = ACTIONS(2637),
    [sym_this] = ACTIONS(2617),
  },
  [325] = {
    [sym_identifier] = ACTIONS(2797),
    [aux_sym_preproc_include_token1] = ACTIONS(2797),
    [aux_sym_preproc_def_token1] = ACTIONS(2797),
    [aux_sym_preproc_if_token1] = ACTIONS(2797),
    [aux_sym_preproc_if_token2] = ACTIONS(2797),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2797),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2797),
    [aux_sym_preproc_else_token1] = ACTIONS(2797),
    [aux_sym_preproc_elif_token1] = ACTIONS(2797),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2797),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2797),
    [sym_preproc_directive] = ACTIONS(2797),
    [anon_sym_LPAREN2] = ACTIONS(2799),
    [anon_sym_BANG] = ACTIONS(2799),
    [anon_sym_TILDE] = ACTIONS(2799),
    [anon_sym_DASH] = ACTIONS(2797),
    [anon_sym_PLUS] = ACTIONS(2797),
    [anon_sym_STAR] = ACTIONS(2799),
    [anon_sym_AMP_AMP] = ACTIONS(2799),
    [anon_sym_AMP] = ACTIONS(2797),
    [anon_sym_SEMI] = ACTIONS(2799),
    [anon_sym___extension__] = ACTIONS(2797),
    [anon_sym_typedef] = ACTIONS(2797),
    [anon_sym_extern] = ACTIONS(2797),
    [anon_sym___attribute__] = ACTIONS(2797),
    [anon_sym_COLON_COLON] = ACTIONS(2799),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2799),
    [anon_sym___declspec] = ACTIONS(2797),
    [anon_sym___based] = ACTIONS(2797),
    [anon_sym___cdecl] = ACTIONS(2797),
    [anon_sym___clrcall] = ACTIONS(2797),
    [anon_sym___stdcall] = ACTIONS(2797),
    [anon_sym___fastcall] = ACTIONS(2797),
    [anon_sym___thiscall] = ACTIONS(2797),
    [anon_sym___vectorcall] = ACTIONS(2797),
    [anon_sym_LBRACE] = ACTIONS(2799),
    [anon_sym_signed] = ACTIONS(2797),
    [anon_sym_unsigned] = ACTIONS(2797),
    [anon_sym_long] = ACTIONS(2797),
    [anon_sym_short] = ACTIONS(2797),
    [anon_sym_LBRACK] = ACTIONS(2797),
    [anon_sym_static] = ACTIONS(2797),
    [anon_sym_register] = ACTIONS(2797),
    [anon_sym_inline] = ACTIONS(2797),
    [anon_sym___inline] = ACTIONS(2797),
    [anon_sym___inline__] = ACTIONS(2797),
    [anon_sym___forceinline] = ACTIONS(2797),
    [anon_sym_thread_local] = ACTIONS(2797),
    [anon_sym___thread] = ACTIONS(2797),
    [anon_sym_const] = ACTIONS(2797),
    [anon_sym_constexpr] = ACTIONS(2797),
    [anon_sym_volatile] = ACTIONS(2797),
    [anon_sym_restrict] = ACTIONS(2797),
    [anon_sym___restrict__] = ACTIONS(2797),
    [anon_sym__Atomic] = ACTIONS(2797),
    [anon_sym__Noreturn] = ACTIONS(2797),
    [anon_sym_noreturn] = ACTIONS(2797),
    [anon_sym_mutable] = ACTIONS(2797),
    [anon_sym_constinit] = ACTIONS(2797),
    [anon_sym_consteval] = ACTIONS(2797),
    [anon_sym_PROGMEM] = ACTIONS(2797),
    [aux_sym_primitive_type_token1] = ACTIONS(2797),
    [anon_sym_byte] = ACTIONS(2797),
    [anon_sym_word] = ACTIONS(2797),
    [anon_sym_enum] = ACTIONS(2797),
    [anon_sym_class] = ACTIONS(2797),
    [anon_sym_struct] = ACTIONS(2797),
    [anon_sym_union] = ACTIONS(2797),
    [anon_sym_if] = ACTIONS(2797),
    [anon_sym_else] = ACTIONS(2797),
    [anon_sym_switch] = ACTIONS(2797),
    [anon_sym_case] = ACTIONS(2797),
    [anon_sym_default] = ACTIONS(2797),
    [anon_sym_while] = ACTIONS(2797),
    [anon_sym_do] = ACTIONS(2797),
    [anon_sym_for] = ACTIONS(2797),
    [anon_sym_return] = ACTIONS(2797),
    [anon_sym_break] = ACTIONS(2797),
    [anon_sym_continue] = ACTIONS(2797),
    [anon_sym_goto] = ACTIONS(2797),
    [anon_sym___try] = ACTIONS(2797),
    [anon_sym___leave] = ACTIONS(2797),
    [anon_sym_not] = ACTIONS(2797),
    [anon_sym_compl] = ACTIONS(2797),
    [anon_sym_DASH_DASH] = ACTIONS(2799),
    [anon_sym_PLUS_PLUS] = ACTIONS(2799),
    [anon_sym_sizeof] = ACTIONS(2797),
    [anon_sym___alignof__] = ACTIONS(2797),
    [anon_sym___alignof] = ACTIONS(2797),
    [anon_sym__alignof] = ACTIONS(2797),
    [anon_sym_alignof] = ACTIONS(2797),
    [anon_sym__Alignof] = ACTIONS(2797),
    [anon_sym_offsetof] = ACTIONS(2797),
    [anon_sym__Generic] = ACTIONS(2797),
    [anon_sym_asm] = ACTIONS(2797),
    [anon_sym___asm__] = ACTIONS(2797),
    [aux_sym_number_literal_token1] = ACTIONS(2799),
    [aux_sym_number_literal_token2] = ACTIONS(2797),
    [anon_sym_L_SQUOTE] = ACTIONS(2799),
    [anon_sym_u_SQUOTE] = ACTIONS(2799),
    [anon_sym_U_SQUOTE] = ACTIONS(2799),
    [anon_sym_u8_SQUOTE] = ACTIONS(2799),
    [anon_sym_SQUOTE] = ACTIONS(2799),
    [anon_sym_L_DQUOTE] = ACTIONS(2799),
    [anon_sym_u_DQUOTE] = ACTIONS(2799),
    [anon_sym_U_DQUOTE] = ACTIONS(2799),
    [anon_sym_u8_DQUOTE] = ACTIONS(2799),
    [anon_sym_DQUOTE] = ACTIONS(2799),
    [sym_true] = ACTIONS(2797),
    [sym_false] = ACTIONS(2797),
    [anon_sym_NULL] = ACTIONS(2797),
    [anon_sym_nullptr] = ACTIONS(2797),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2797),
    [anon_sym_decltype] = ACTIONS(2797),
    [anon_sym_virtual] = ACTIONS(2797),
    [anon_sym_alignas] = ACTIONS(2797),
    [anon_sym_explicit] = ACTIONS(2797),
    [anon_sym_typename] = ACTIONS(2797),
    [anon_sym_template] = ACTIONS(2797),
    [anon_sym_operator] = ACTIONS(2797),
    [anon_sym_try] = ACTIONS(2797),
    [anon_sym_delete] = ACTIONS(2797),
    [anon_sym_throw] = ACTIONS(2797),
    [anon_sym_namespace] = ACTIONS(2797),
    [anon_sym_using] = ACTIONS(2797),
    [anon_sym_static_assert] = ACTIONS(2797),
    [anon_sym_concept] = ACTIONS(2797),
    [anon_sym_co_return] = ACTIONS(2797),
    [anon_sym_co_yield] = ACTIONS(2797),
    [anon_sym_R_DQUOTE] = ACTIONS(2799),
    [anon_sym_LR_DQUOTE] = ACTIONS(2799),
    [anon_sym_uR_DQUOTE] = ACTIONS(2799),
    [anon_sym_UR_DQUOTE] = ACTIONS(2799),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2799),
    [anon_sym_co_await] = ACTIONS(2797),
    [anon_sym_new] = ACTIONS(2797),
    [anon_sym_requires] = ACTIONS(2797),
    [sym_this] = ACTIONS(2797),
  },
  [326] = {
    [sym_identifier] = ACTIONS(2801),
    [aux_sym_preproc_include_token1] = ACTIONS(2801),
    [aux_sym_preproc_def_token1] = ACTIONS(2801),
    [aux_sym_preproc_if_token1] = ACTIONS(2801),
    [aux_sym_preproc_if_token2] = ACTIONS(2801),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2801),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2801),
    [aux_sym_preproc_else_token1] = ACTIONS(2801),
    [aux_sym_preproc_elif_token1] = ACTIONS(2801),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2801),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2801),
    [sym_preproc_directive] = ACTIONS(2801),
    [anon_sym_LPAREN2] = ACTIONS(2803),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2801),
    [anon_sym_PLUS] = ACTIONS(2801),
    [anon_sym_STAR] = ACTIONS(2803),
    [anon_sym_AMP_AMP] = ACTIONS(2803),
    [anon_sym_AMP] = ACTIONS(2801),
    [anon_sym_SEMI] = ACTIONS(2803),
    [anon_sym___extension__] = ACTIONS(2801),
    [anon_sym_typedef] = ACTIONS(2801),
    [anon_sym_extern] = ACTIONS(2801),
    [anon_sym___attribute__] = ACTIONS(2801),
    [anon_sym_COLON_COLON] = ACTIONS(2803),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2803),
    [anon_sym___declspec] = ACTIONS(2801),
    [anon_sym___based] = ACTIONS(2801),
    [anon_sym___cdecl] = ACTIONS(2801),
    [anon_sym___clrcall] = ACTIONS(2801),
    [anon_sym___stdcall] = ACTIONS(2801),
    [anon_sym___fastcall] = ACTIONS(2801),
    [anon_sym___thiscall] = ACTIONS(2801),
    [anon_sym___vectorcall] = ACTIONS(2801),
    [anon_sym_LBRACE] = ACTIONS(2803),
    [anon_sym_signed] = ACTIONS(2801),
    [anon_sym_unsigned] = ACTIONS(2801),
    [anon_sym_long] = ACTIONS(2801),
    [anon_sym_short] = ACTIONS(2801),
    [anon_sym_LBRACK] = ACTIONS(2801),
    [anon_sym_static] = ACTIONS(2801),
    [anon_sym_register] = ACTIONS(2801),
    [anon_sym_inline] = ACTIONS(2801),
    [anon_sym___inline] = ACTIONS(2801),
    [anon_sym___inline__] = ACTIONS(2801),
    [anon_sym___forceinline] = ACTIONS(2801),
    [anon_sym_thread_local] = ACTIONS(2801),
    [anon_sym___thread] = ACTIONS(2801),
    [anon_sym_const] = ACTIONS(2801),
    [anon_sym_constexpr] = ACTIONS(2801),
    [anon_sym_volatile] = ACTIONS(2801),
    [anon_sym_restrict] = ACTIONS(2801),
    [anon_sym___restrict__] = ACTIONS(2801),
    [anon_sym__Atomic] = ACTIONS(2801),
    [anon_sym__Noreturn] = ACTIONS(2801),
    [anon_sym_noreturn] = ACTIONS(2801),
    [anon_sym_mutable] = ACTIONS(2801),
    [anon_sym_constinit] = ACTIONS(2801),
    [anon_sym_consteval] = ACTIONS(2801),
    [anon_sym_PROGMEM] = ACTIONS(2801),
    [aux_sym_primitive_type_token1] = ACTIONS(2801),
    [anon_sym_byte] = ACTIONS(2801),
    [anon_sym_word] = ACTIONS(2801),
    [anon_sym_enum] = ACTIONS(2801),
    [anon_sym_class] = ACTIONS(2801),
    [anon_sym_struct] = ACTIONS(2801),
    [anon_sym_union] = ACTIONS(2801),
    [anon_sym_if] = ACTIONS(2801),
    [anon_sym_switch] = ACTIONS(2801),
    [anon_sym_case] = ACTIONS(2801),
    [anon_sym_default] = ACTIONS(2801),
    [anon_sym_while] = ACTIONS(2801),
    [anon_sym_do] = ACTIONS(2801),
    [anon_sym_for] = ACTIONS(2801),
    [anon_sym_return] = ACTIONS(2801),
    [anon_sym_break] = ACTIONS(2801),
    [anon_sym_continue] = ACTIONS(2801),
    [anon_sym_goto] = ACTIONS(2801),
    [anon_sym___try] = ACTIONS(2801),
    [anon_sym___leave] = ACTIONS(2801),
    [anon_sym_not] = ACTIONS(2801),
    [anon_sym_compl] = ACTIONS(2801),
    [anon_sym_DASH_DASH] = ACTIONS(2803),
    [anon_sym_PLUS_PLUS] = ACTIONS(2803),
    [anon_sym_sizeof] = ACTIONS(2801),
    [anon_sym___alignof__] = ACTIONS(2801),
    [anon_sym___alignof] = ACTIONS(2801),
    [anon_sym__alignof] = ACTIONS(2801),
    [anon_sym_alignof] = ACTIONS(2801),
    [anon_sym__Alignof] = ACTIONS(2801),
    [anon_sym_offsetof] = ACTIONS(2801),
    [anon_sym__Generic] = ACTIONS(2801),
    [anon_sym_asm] = ACTIONS(2801),
    [anon_sym___asm__] = ACTIONS(2801),
    [aux_sym_number_literal_token1] = ACTIONS(2803),
    [aux_sym_number_literal_token2] = ACTIONS(2801),
    [anon_sym_L_SQUOTE] = ACTIONS(2803),
    [anon_sym_u_SQUOTE] = ACTIONS(2803),
    [anon_sym_U_SQUOTE] = ACTIONS(2803),
    [anon_sym_u8_SQUOTE] = ACTIONS(2803),
    [anon_sym_SQUOTE] = ACTIONS(2803),
    [anon_sym_L_DQUOTE] = ACTIONS(2803),
    [anon_sym_u_DQUOTE] = ACTIONS(2803),
    [anon_sym_U_DQUOTE] = ACTIONS(2803),
    [anon_sym_u8_DQUOTE] = ACTIONS(2803),
    [anon_sym_DQUOTE] = ACTIONS(2803),
    [sym_true] = ACTIONS(2801),
    [sym_false] = ACTIONS(2801),
    [anon_sym_NULL] = ACTIONS(2801),
    [anon_sym_nullptr] = ACTIONS(2801),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2801),
    [anon_sym_decltype] = ACTIONS(2801),
    [anon_sym_virtual] = ACTIONS(2801),
    [anon_sym_alignas] = ACTIONS(2801),
    [anon_sym_explicit] = ACTIONS(2801),
    [anon_sym_typename] = ACTIONS(2801),
    [anon_sym_template] = ACTIONS(2801),
    [anon_sym_operator] = ACTIONS(2801),
    [anon_sym_try] = ACTIONS(2801),
    [anon_sym_delete] = ACTIONS(2801),
    [anon_sym_throw] = ACTIONS(2801),
    [anon_sym_namespace] = ACTIONS(2801),
    [anon_sym_using] = ACTIONS(2801),
    [anon_sym_static_assert] = ACTIONS(2801),
    [anon_sym_concept] = ACTIONS(2801),
    [anon_sym_co_return] = ACTIONS(2801),
    [anon_sym_co_yield] = ACTIONS(2801),
    [anon_sym_R_DQUOTE] = ACTIONS(2803),
    [anon_sym_LR_DQUOTE] = ACTIONS(2803),
    [anon_sym_uR_DQUOTE] = ACTIONS(2803),
    [anon_sym_UR_DQUOTE] = ACTIONS(2803),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2803),
    [anon_sym_co_await] = ACTIONS(2801),
    [anon_sym_new] = ACTIONS(2801),
    [anon_sym_requires] = ACTIONS(2801),
    [sym_this] = ACTIONS(2801),
  },
  [327] = {
    [sym_identifier] = ACTIONS(2805),
    [aux_sym_preproc_include_token1] = ACTIONS(2805),
    [aux_sym_preproc_def_token1] = ACTIONS(2805),
    [aux_sym_preproc_if_token1] = ACTIONS(2805),
    [aux_sym_preproc_if_token2] = ACTIONS(2805),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2805),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2805),
    [aux_sym_preproc_else_token1] = ACTIONS(2805),
    [aux_sym_preproc_elif_token1] = ACTIONS(2805),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2805),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2805),
    [sym_preproc_directive] = ACTIONS(2805),
    [anon_sym_LPAREN2] = ACTIONS(2807),
    [anon_sym_BANG] = ACTIONS(2807),
    [anon_sym_TILDE] = ACTIONS(2807),
    [anon_sym_DASH] = ACTIONS(2805),
    [anon_sym_PLUS] = ACTIONS(2805),
    [anon_sym_STAR] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2805),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym___extension__] = ACTIONS(2805),
    [anon_sym_typedef] = ACTIONS(2805),
    [anon_sym_extern] = ACTIONS(2805),
    [anon_sym___attribute__] = ACTIONS(2805),
    [anon_sym_COLON_COLON] = ACTIONS(2807),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2807),
    [anon_sym___declspec] = ACTIONS(2805),
    [anon_sym___based] = ACTIONS(2805),
    [anon_sym___cdecl] = ACTIONS(2805),
    [anon_sym___clrcall] = ACTIONS(2805),
    [anon_sym___stdcall] = ACTIONS(2805),
    [anon_sym___fastcall] = ACTIONS(2805),
    [anon_sym___thiscall] = ACTIONS(2805),
    [anon_sym___vectorcall] = ACTIONS(2805),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_signed] = ACTIONS(2805),
    [anon_sym_unsigned] = ACTIONS(2805),
    [anon_sym_long] = ACTIONS(2805),
    [anon_sym_short] = ACTIONS(2805),
    [anon_sym_LBRACK] = ACTIONS(2805),
    [anon_sym_static] = ACTIONS(2805),
    [anon_sym_register] = ACTIONS(2805),
    [anon_sym_inline] = ACTIONS(2805),
    [anon_sym___inline] = ACTIONS(2805),
    [anon_sym___inline__] = ACTIONS(2805),
    [anon_sym___forceinline] = ACTIONS(2805),
    [anon_sym_thread_local] = ACTIONS(2805),
    [anon_sym___thread] = ACTIONS(2805),
    [anon_sym_const] = ACTIONS(2805),
    [anon_sym_constexpr] = ACTIONS(2805),
    [anon_sym_volatile] = ACTIONS(2805),
    [anon_sym_restrict] = ACTIONS(2805),
    [anon_sym___restrict__] = ACTIONS(2805),
    [anon_sym__Atomic] = ACTIONS(2805),
    [anon_sym__Noreturn] = ACTIONS(2805),
    [anon_sym_noreturn] = ACTIONS(2805),
    [anon_sym_mutable] = ACTIONS(2805),
    [anon_sym_constinit] = ACTIONS(2805),
    [anon_sym_consteval] = ACTIONS(2805),
    [anon_sym_PROGMEM] = ACTIONS(2805),
    [aux_sym_primitive_type_token1] = ACTIONS(2805),
    [anon_sym_byte] = ACTIONS(2805),
    [anon_sym_word] = ACTIONS(2805),
    [anon_sym_enum] = ACTIONS(2805),
    [anon_sym_class] = ACTIONS(2805),
    [anon_sym_struct] = ACTIONS(2805),
    [anon_sym_union] = ACTIONS(2805),
    [anon_sym_if] = ACTIONS(2805),
    [anon_sym_switch] = ACTIONS(2805),
    [anon_sym_case] = ACTIONS(2805),
    [anon_sym_default] = ACTIONS(2805),
    [anon_sym_while] = ACTIONS(2805),
    [anon_sym_do] = ACTIONS(2805),
    [anon_sym_for] = ACTIONS(2805),
    [anon_sym_return] = ACTIONS(2805),
    [anon_sym_break] = ACTIONS(2805),
    [anon_sym_continue] = ACTIONS(2805),
    [anon_sym_goto] = ACTIONS(2805),
    [anon_sym___try] = ACTIONS(2805),
    [anon_sym___leave] = ACTIONS(2805),
    [anon_sym_not] = ACTIONS(2805),
    [anon_sym_compl] = ACTIONS(2805),
    [anon_sym_DASH_DASH] = ACTIONS(2807),
    [anon_sym_PLUS_PLUS] = ACTIONS(2807),
    [anon_sym_sizeof] = ACTIONS(2805),
    [anon_sym___alignof__] = ACTIONS(2805),
    [anon_sym___alignof] = ACTIONS(2805),
    [anon_sym__alignof] = ACTIONS(2805),
    [anon_sym_alignof] = ACTIONS(2805),
    [anon_sym__Alignof] = ACTIONS(2805),
    [anon_sym_offsetof] = ACTIONS(2805),
    [anon_sym__Generic] = ACTIONS(2805),
    [anon_sym_asm] = ACTIONS(2805),
    [anon_sym___asm__] = ACTIONS(2805),
    [aux_sym_number_literal_token1] = ACTIONS(2807),
    [aux_sym_number_literal_token2] = ACTIONS(2805),
    [anon_sym_L_SQUOTE] = ACTIONS(2807),
    [anon_sym_u_SQUOTE] = ACTIONS(2807),
    [anon_sym_U_SQUOTE] = ACTIONS(2807),
    [anon_sym_u8_SQUOTE] = ACTIONS(2807),
    [anon_sym_SQUOTE] = ACTIONS(2807),
    [anon_sym_L_DQUOTE] = ACTIONS(2807),
    [anon_sym_u_DQUOTE] = ACTIONS(2807),
    [anon_sym_U_DQUOTE] = ACTIONS(2807),
    [anon_sym_u8_DQUOTE] = ACTIONS(2807),
    [anon_sym_DQUOTE] = ACTIONS(2807),
    [sym_true] = ACTIONS(2805),
    [sym_false] = ACTIONS(2805),
    [anon_sym_NULL] = ACTIONS(2805),
    [anon_sym_nullptr] = ACTIONS(2805),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2805),
    [anon_sym_decltype] = ACTIONS(2805),
    [anon_sym_virtual] = ACTIONS(2805),
    [anon_sym_alignas] = ACTIONS(2805),
    [anon_sym_explicit] = ACTIONS(2805),
    [anon_sym_typename] = ACTIONS(2805),
    [anon_sym_template] = ACTIONS(2805),
    [anon_sym_operator] = ACTIONS(2805),
    [anon_sym_try] = ACTIONS(2805),
    [anon_sym_delete] = ACTIONS(2805),
    [anon_sym_throw] = ACTIONS(2805),
    [anon_sym_namespace] = ACTIONS(2805),
    [anon_sym_using] = ACTIONS(2805),
    [anon_sym_static_assert] = ACTIONS(2805),
    [anon_sym_concept] = ACTIONS(2805),
    [anon_sym_co_return] = ACTIONS(2805),
    [anon_sym_co_yield] = ACTIONS(2805),
    [anon_sym_R_DQUOTE] = ACTIONS(2807),
    [anon_sym_LR_DQUOTE] = ACTIONS(2807),
    [anon_sym_uR_DQUOTE] = ACTIONS(2807),
    [anon_sym_UR_DQUOTE] = ACTIONS(2807),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2807),
    [anon_sym_co_await] = ACTIONS(2805),
    [anon_sym_new] = ACTIONS(2805),
    [anon_sym_requires] = ACTIONS(2805),
    [sym_this] = ACTIONS(2805),
  },
  [328] = {
    [sym_identifier] = ACTIONS(2809),
    [aux_sym_preproc_include_token1] = ACTIONS(2809),
    [aux_sym_preproc_def_token1] = ACTIONS(2809),
    [aux_sym_preproc_if_token1] = ACTIONS(2809),
    [aux_sym_preproc_if_token2] = ACTIONS(2809),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2809),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2809),
    [aux_sym_preproc_else_token1] = ACTIONS(2809),
    [aux_sym_preproc_elif_token1] = ACTIONS(2809),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2809),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2809),
    [sym_preproc_directive] = ACTIONS(2809),
    [anon_sym_LPAREN2] = ACTIONS(2811),
    [anon_sym_BANG] = ACTIONS(2811),
    [anon_sym_TILDE] = ACTIONS(2811),
    [anon_sym_DASH] = ACTIONS(2809),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_STAR] = ACTIONS(2811),
    [anon_sym_AMP_AMP] = ACTIONS(2811),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2811),
    [anon_sym___extension__] = ACTIONS(2809),
    [anon_sym_typedef] = ACTIONS(2809),
    [anon_sym_extern] = ACTIONS(2809),
    [anon_sym___attribute__] = ACTIONS(2809),
    [anon_sym_COLON_COLON] = ACTIONS(2811),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2811),
    [anon_sym___declspec] = ACTIONS(2809),
    [anon_sym___based] = ACTIONS(2809),
    [anon_sym___cdecl] = ACTIONS(2809),
    [anon_sym___clrcall] = ACTIONS(2809),
    [anon_sym___stdcall] = ACTIONS(2809),
    [anon_sym___fastcall] = ACTIONS(2809),
    [anon_sym___thiscall] = ACTIONS(2809),
    [anon_sym___vectorcall] = ACTIONS(2809),
    [anon_sym_LBRACE] = ACTIONS(2811),
    [anon_sym_signed] = ACTIONS(2809),
    [anon_sym_unsigned] = ACTIONS(2809),
    [anon_sym_long] = ACTIONS(2809),
    [anon_sym_short] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2809),
    [anon_sym_static] = ACTIONS(2809),
    [anon_sym_register] = ACTIONS(2809),
    [anon_sym_inline] = ACTIONS(2809),
    [anon_sym___inline] = ACTIONS(2809),
    [anon_sym___inline__] = ACTIONS(2809),
    [anon_sym___forceinline] = ACTIONS(2809),
    [anon_sym_thread_local] = ACTIONS(2809),
    [anon_sym___thread] = ACTIONS(2809),
    [anon_sym_const] = ACTIONS(2809),
    [anon_sym_constexpr] = ACTIONS(2809),
    [anon_sym_volatile] = ACTIONS(2809),
    [anon_sym_restrict] = ACTIONS(2809),
    [anon_sym___restrict__] = ACTIONS(2809),
    [anon_sym__Atomic] = ACTIONS(2809),
    [anon_sym__Noreturn] = ACTIONS(2809),
    [anon_sym_noreturn] = ACTIONS(2809),
    [anon_sym_mutable] = ACTIONS(2809),
    [anon_sym_constinit] = ACTIONS(2809),
    [anon_sym_consteval] = ACTIONS(2809),
    [anon_sym_PROGMEM] = ACTIONS(2809),
    [aux_sym_primitive_type_token1] = ACTIONS(2809),
    [anon_sym_byte] = ACTIONS(2809),
    [anon_sym_word] = ACTIONS(2809),
    [anon_sym_enum] = ACTIONS(2809),
    [anon_sym_class] = ACTIONS(2809),
    [anon_sym_struct] = ACTIONS(2809),
    [anon_sym_union] = ACTIONS(2809),
    [anon_sym_if] = ACTIONS(2809),
    [anon_sym_switch] = ACTIONS(2809),
    [anon_sym_case] = ACTIONS(2809),
    [anon_sym_default] = ACTIONS(2809),
    [anon_sym_while] = ACTIONS(2809),
    [anon_sym_do] = ACTIONS(2809),
    [anon_sym_for] = ACTIONS(2809),
    [anon_sym_return] = ACTIONS(2809),
    [anon_sym_break] = ACTIONS(2809),
    [anon_sym_continue] = ACTIONS(2809),
    [anon_sym_goto] = ACTIONS(2809),
    [anon_sym___try] = ACTIONS(2809),
    [anon_sym___leave] = ACTIONS(2809),
    [anon_sym_not] = ACTIONS(2809),
    [anon_sym_compl] = ACTIONS(2809),
    [anon_sym_DASH_DASH] = ACTIONS(2811),
    [anon_sym_PLUS_PLUS] = ACTIONS(2811),
    [anon_sym_sizeof] = ACTIONS(2809),
    [anon_sym___alignof__] = ACTIONS(2809),
    [anon_sym___alignof] = ACTIONS(2809),
    [anon_sym__alignof] = ACTIONS(2809),
    [anon_sym_alignof] = ACTIONS(2809),
    [anon_sym__Alignof] = ACTIONS(2809),
    [anon_sym_offsetof] = ACTIONS(2809),
    [anon_sym__Generic] = ACTIONS(2809),
    [anon_sym_asm] = ACTIONS(2809),
    [anon_sym___asm__] = ACTIONS(2809),
    [aux_sym_number_literal_token1] = ACTIONS(2811),
    [aux_sym_number_literal_token2] = ACTIONS(2809),
    [anon_sym_L_SQUOTE] = ACTIONS(2811),
    [anon_sym_u_SQUOTE] = ACTIONS(2811),
    [anon_sym_U_SQUOTE] = ACTIONS(2811),
    [anon_sym_u8_SQUOTE] = ACTIONS(2811),
    [anon_sym_SQUOTE] = ACTIONS(2811),
    [anon_sym_L_DQUOTE] = ACTIONS(2811),
    [anon_sym_u_DQUOTE] = ACTIONS(2811),
    [anon_sym_U_DQUOTE] = ACTIONS(2811),
    [anon_sym_u8_DQUOTE] = ACTIONS(2811),
    [anon_sym_DQUOTE] = ACTIONS(2811),
    [sym_true] = ACTIONS(2809),
    [sym_false] = ACTIONS(2809),
    [anon_sym_NULL] = ACTIONS(2809),
    [anon_sym_nullptr] = ACTIONS(2809),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2809),
    [anon_sym_decltype] = ACTIONS(2809),
    [anon_sym_virtual] = ACTIONS(2809),
    [anon_sym_alignas] = ACTIONS(2809),
    [anon_sym_explicit] = ACTIONS(2809),
    [anon_sym_typename] = ACTIONS(2809),
    [anon_sym_template] = ACTIONS(2809),
    [anon_sym_operator] = ACTIONS(2809),
    [anon_sym_try] = ACTIONS(2809),
    [anon_sym_delete] = ACTIONS(2809),
    [anon_sym_throw] = ACTIONS(2809),
    [anon_sym_namespace] = ACTIONS(2809),
    [anon_sym_using] = ACTIONS(2809),
    [anon_sym_static_assert] = ACTIONS(2809),
    [anon_sym_concept] = ACTIONS(2809),
    [anon_sym_co_return] = ACTIONS(2809),
    [anon_sym_co_yield] = ACTIONS(2809),
    [anon_sym_R_DQUOTE] = ACTIONS(2811),
    [anon_sym_LR_DQUOTE] = ACTIONS(2811),
    [anon_sym_uR_DQUOTE] = ACTIONS(2811),
    [anon_sym_UR_DQUOTE] = ACTIONS(2811),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2811),
    [anon_sym_co_await] = ACTIONS(2809),
    [anon_sym_new] = ACTIONS(2809),
    [anon_sym_requires] = ACTIONS(2809),
    [sym_this] = ACTIONS(2809),
  },
  [329] = {
    [sym_identifier] = ACTIONS(2813),
    [aux_sym_preproc_include_token1] = ACTIONS(2813),
    [aux_sym_preproc_def_token1] = ACTIONS(2813),
    [aux_sym_preproc_if_token1] = ACTIONS(2813),
    [aux_sym_preproc_if_token2] = ACTIONS(2813),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2813),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2813),
    [aux_sym_preproc_else_token1] = ACTIONS(2813),
    [aux_sym_preproc_elif_token1] = ACTIONS(2813),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2813),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2813),
    [sym_preproc_directive] = ACTIONS(2813),
    [anon_sym_LPAREN2] = ACTIONS(2815),
    [anon_sym_BANG] = ACTIONS(2815),
    [anon_sym_TILDE] = ACTIONS(2815),
    [anon_sym_DASH] = ACTIONS(2813),
    [anon_sym_PLUS] = ACTIONS(2813),
    [anon_sym_STAR] = ACTIONS(2815),
    [anon_sym_AMP_AMP] = ACTIONS(2815),
    [anon_sym_AMP] = ACTIONS(2813),
    [anon_sym_SEMI] = ACTIONS(2815),
    [anon_sym___extension__] = ACTIONS(2813),
    [anon_sym_typedef] = ACTIONS(2813),
    [anon_sym_extern] = ACTIONS(2813),
    [anon_sym___attribute__] = ACTIONS(2813),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2815),
    [anon_sym___declspec] = ACTIONS(2813),
    [anon_sym___based] = ACTIONS(2813),
    [anon_sym___cdecl] = ACTIONS(2813),
    [anon_sym___clrcall] = ACTIONS(2813),
    [anon_sym___stdcall] = ACTIONS(2813),
    [anon_sym___fastcall] = ACTIONS(2813),
    [anon_sym___thiscall] = ACTIONS(2813),
    [anon_sym___vectorcall] = ACTIONS(2813),
    [anon_sym_LBRACE] = ACTIONS(2815),
    [anon_sym_signed] = ACTIONS(2813),
    [anon_sym_unsigned] = ACTIONS(2813),
    [anon_sym_long] = ACTIONS(2813),
    [anon_sym_short] = ACTIONS(2813),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_static] = ACTIONS(2813),
    [anon_sym_register] = ACTIONS(2813),
    [anon_sym_inline] = ACTIONS(2813),
    [anon_sym___inline] = ACTIONS(2813),
    [anon_sym___inline__] = ACTIONS(2813),
    [anon_sym___forceinline] = ACTIONS(2813),
    [anon_sym_thread_local] = ACTIONS(2813),
    [anon_sym___thread] = ACTIONS(2813),
    [anon_sym_const] = ACTIONS(2813),
    [anon_sym_constexpr] = ACTIONS(2813),
    [anon_sym_volatile] = ACTIONS(2813),
    [anon_sym_restrict] = ACTIONS(2813),
    [anon_sym___restrict__] = ACTIONS(2813),
    [anon_sym__Atomic] = ACTIONS(2813),
    [anon_sym__Noreturn] = ACTIONS(2813),
    [anon_sym_noreturn] = ACTIONS(2813),
    [anon_sym_mutable] = ACTIONS(2813),
    [anon_sym_constinit] = ACTIONS(2813),
    [anon_sym_consteval] = ACTIONS(2813),
    [anon_sym_PROGMEM] = ACTIONS(2813),
    [aux_sym_primitive_type_token1] = ACTIONS(2813),
    [anon_sym_byte] = ACTIONS(2813),
    [anon_sym_word] = ACTIONS(2813),
    [anon_sym_enum] = ACTIONS(2813),
    [anon_sym_class] = ACTIONS(2813),
    [anon_sym_struct] = ACTIONS(2813),
    [anon_sym_union] = ACTIONS(2813),
    [anon_sym_if] = ACTIONS(2813),
    [anon_sym_switch] = ACTIONS(2813),
    [anon_sym_case] = ACTIONS(2813),
    [anon_sym_default] = ACTIONS(2813),
    [anon_sym_while] = ACTIONS(2813),
    [anon_sym_do] = ACTIONS(2813),
    [anon_sym_for] = ACTIONS(2813),
    [anon_sym_return] = ACTIONS(2813),
    [anon_sym_break] = ACTIONS(2813),
    [anon_sym_continue] = ACTIONS(2813),
    [anon_sym_goto] = ACTIONS(2813),
    [anon_sym___try] = ACTIONS(2813),
    [anon_sym___leave] = ACTIONS(2813),
    [anon_sym_not] = ACTIONS(2813),
    [anon_sym_compl] = ACTIONS(2813),
    [anon_sym_DASH_DASH] = ACTIONS(2815),
    [anon_sym_PLUS_PLUS] = ACTIONS(2815),
    [anon_sym_sizeof] = ACTIONS(2813),
    [anon_sym___alignof__] = ACTIONS(2813),
    [anon_sym___alignof] = ACTIONS(2813),
    [anon_sym__alignof] = ACTIONS(2813),
    [anon_sym_alignof] = ACTIONS(2813),
    [anon_sym__Alignof] = ACTIONS(2813),
    [anon_sym_offsetof] = ACTIONS(2813),
    [anon_sym__Generic] = ACTIONS(2813),
    [anon_sym_asm] = ACTIONS(2813),
    [anon_sym___asm__] = ACTIONS(2813),
    [aux_sym_number_literal_token1] = ACTIONS(2815),
    [aux_sym_number_literal_token2] = ACTIONS(2813),
    [anon_sym_L_SQUOTE] = ACTIONS(2815),
    [anon_sym_u_SQUOTE] = ACTIONS(2815),
    [anon_sym_U_SQUOTE] = ACTIONS(2815),
    [anon_sym_u8_SQUOTE] = ACTIONS(2815),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_L_DQUOTE] = ACTIONS(2815),
    [anon_sym_u_DQUOTE] = ACTIONS(2815),
    [anon_sym_U_DQUOTE] = ACTIONS(2815),
    [anon_sym_u8_DQUOTE] = ACTIONS(2815),
    [anon_sym_DQUOTE] = ACTIONS(2815),
    [sym_true] = ACTIONS(2813),
    [sym_false] = ACTIONS(2813),
    [anon_sym_NULL] = ACTIONS(2813),
    [anon_sym_nullptr] = ACTIONS(2813),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2813),
    [anon_sym_decltype] = ACTIONS(2813),
    [anon_sym_virtual] = ACTIONS(2813),
    [anon_sym_alignas] = ACTIONS(2813),
    [anon_sym_explicit] = ACTIONS(2813),
    [anon_sym_typename] = ACTIONS(2813),
    [anon_sym_template] = ACTIONS(2813),
    [anon_sym_operator] = ACTIONS(2813),
    [anon_sym_try] = ACTIONS(2813),
    [anon_sym_delete] = ACTIONS(2813),
    [anon_sym_throw] = ACTIONS(2813),
    [anon_sym_namespace] = ACTIONS(2813),
    [anon_sym_using] = ACTIONS(2813),
    [anon_sym_static_assert] = ACTIONS(2813),
    [anon_sym_concept] = ACTIONS(2813),
    [anon_sym_co_return] = ACTIONS(2813),
    [anon_sym_co_yield] = ACTIONS(2813),
    [anon_sym_R_DQUOTE] = ACTIONS(2815),
    [anon_sym_LR_DQUOTE] = ACTIONS(2815),
    [anon_sym_uR_DQUOTE] = ACTIONS(2815),
    [anon_sym_UR_DQUOTE] = ACTIONS(2815),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2815),
    [anon_sym_co_await] = ACTIONS(2813),
    [anon_sym_new] = ACTIONS(2813),
    [anon_sym_requires] = ACTIONS(2813),
    [sym_this] = ACTIONS(2813),
  },
  [330] = {
    [sym_identifier] = ACTIONS(2813),
    [aux_sym_preproc_include_token1] = ACTIONS(2813),
    [aux_sym_preproc_def_token1] = ACTIONS(2813),
    [aux_sym_preproc_if_token1] = ACTIONS(2813),
    [aux_sym_preproc_if_token2] = ACTIONS(2813),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2813),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2813),
    [aux_sym_preproc_else_token1] = ACTIONS(2813),
    [aux_sym_preproc_elif_token1] = ACTIONS(2813),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2813),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2813),
    [sym_preproc_directive] = ACTIONS(2813),
    [anon_sym_LPAREN2] = ACTIONS(2815),
    [anon_sym_BANG] = ACTIONS(2815),
    [anon_sym_TILDE] = ACTIONS(2815),
    [anon_sym_DASH] = ACTIONS(2813),
    [anon_sym_PLUS] = ACTIONS(2813),
    [anon_sym_STAR] = ACTIONS(2815),
    [anon_sym_AMP_AMP] = ACTIONS(2815),
    [anon_sym_AMP] = ACTIONS(2813),
    [anon_sym_SEMI] = ACTIONS(2815),
    [anon_sym___extension__] = ACTIONS(2813),
    [anon_sym_typedef] = ACTIONS(2813),
    [anon_sym_extern] = ACTIONS(2813),
    [anon_sym___attribute__] = ACTIONS(2813),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2815),
    [anon_sym___declspec] = ACTIONS(2813),
    [anon_sym___based] = ACTIONS(2813),
    [anon_sym___cdecl] = ACTIONS(2813),
    [anon_sym___clrcall] = ACTIONS(2813),
    [anon_sym___stdcall] = ACTIONS(2813),
    [anon_sym___fastcall] = ACTIONS(2813),
    [anon_sym___thiscall] = ACTIONS(2813),
    [anon_sym___vectorcall] = ACTIONS(2813),
    [anon_sym_LBRACE] = ACTIONS(2815),
    [anon_sym_signed] = ACTIONS(2813),
    [anon_sym_unsigned] = ACTIONS(2813),
    [anon_sym_long] = ACTIONS(2813),
    [anon_sym_short] = ACTIONS(2813),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_static] = ACTIONS(2813),
    [anon_sym_register] = ACTIONS(2813),
    [anon_sym_inline] = ACTIONS(2813),
    [anon_sym___inline] = ACTIONS(2813),
    [anon_sym___inline__] = ACTIONS(2813),
    [anon_sym___forceinline] = ACTIONS(2813),
    [anon_sym_thread_local] = ACTIONS(2813),
    [anon_sym___thread] = ACTIONS(2813),
    [anon_sym_const] = ACTIONS(2813),
    [anon_sym_constexpr] = ACTIONS(2813),
    [anon_sym_volatile] = ACTIONS(2813),
    [anon_sym_restrict] = ACTIONS(2813),
    [anon_sym___restrict__] = ACTIONS(2813),
    [anon_sym__Atomic] = ACTIONS(2813),
    [anon_sym__Noreturn] = ACTIONS(2813),
    [anon_sym_noreturn] = ACTIONS(2813),
    [anon_sym_mutable] = ACTIONS(2813),
    [anon_sym_constinit] = ACTIONS(2813),
    [anon_sym_consteval] = ACTIONS(2813),
    [anon_sym_PROGMEM] = ACTIONS(2813),
    [aux_sym_primitive_type_token1] = ACTIONS(2813),
    [anon_sym_byte] = ACTIONS(2813),
    [anon_sym_word] = ACTIONS(2813),
    [anon_sym_enum] = ACTIONS(2813),
    [anon_sym_class] = ACTIONS(2813),
    [anon_sym_struct] = ACTIONS(2813),
    [anon_sym_union] = ACTIONS(2813),
    [anon_sym_if] = ACTIONS(2813),
    [anon_sym_switch] = ACTIONS(2813),
    [anon_sym_case] = ACTIONS(2813),
    [anon_sym_default] = ACTIONS(2813),
    [anon_sym_while] = ACTIONS(2813),
    [anon_sym_do] = ACTIONS(2813),
    [anon_sym_for] = ACTIONS(2813),
    [anon_sym_return] = ACTIONS(2813),
    [anon_sym_break] = ACTIONS(2813),
    [anon_sym_continue] = ACTIONS(2813),
    [anon_sym_goto] = ACTIONS(2813),
    [anon_sym___try] = ACTIONS(2813),
    [anon_sym___leave] = ACTIONS(2813),
    [anon_sym_not] = ACTIONS(2813),
    [anon_sym_compl] = ACTIONS(2813),
    [anon_sym_DASH_DASH] = ACTIONS(2815),
    [anon_sym_PLUS_PLUS] = ACTIONS(2815),
    [anon_sym_sizeof] = ACTIONS(2813),
    [anon_sym___alignof__] = ACTIONS(2813),
    [anon_sym___alignof] = ACTIONS(2813),
    [anon_sym__alignof] = ACTIONS(2813),
    [anon_sym_alignof] = ACTIONS(2813),
    [anon_sym__Alignof] = ACTIONS(2813),
    [anon_sym_offsetof] = ACTIONS(2813),
    [anon_sym__Generic] = ACTIONS(2813),
    [anon_sym_asm] = ACTIONS(2813),
    [anon_sym___asm__] = ACTIONS(2813),
    [aux_sym_number_literal_token1] = ACTIONS(2815),
    [aux_sym_number_literal_token2] = ACTIONS(2813),
    [anon_sym_L_SQUOTE] = ACTIONS(2815),
    [anon_sym_u_SQUOTE] = ACTIONS(2815),
    [anon_sym_U_SQUOTE] = ACTIONS(2815),
    [anon_sym_u8_SQUOTE] = ACTIONS(2815),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_L_DQUOTE] = ACTIONS(2815),
    [anon_sym_u_DQUOTE] = ACTIONS(2815),
    [anon_sym_U_DQUOTE] = ACTIONS(2815),
    [anon_sym_u8_DQUOTE] = ACTIONS(2815),
    [anon_sym_DQUOTE] = ACTIONS(2815),
    [sym_true] = ACTIONS(2813),
    [sym_false] = ACTIONS(2813),
    [anon_sym_NULL] = ACTIONS(2813),
    [anon_sym_nullptr] = ACTIONS(2813),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2813),
    [anon_sym_decltype] = ACTIONS(2813),
    [anon_sym_virtual] = ACTIONS(2813),
    [anon_sym_alignas] = ACTIONS(2813),
    [anon_sym_explicit] = ACTIONS(2813),
    [anon_sym_typename] = ACTIONS(2813),
    [anon_sym_template] = ACTIONS(2813),
    [anon_sym_operator] = ACTIONS(2813),
    [anon_sym_try] = ACTIONS(2813),
    [anon_sym_delete] = ACTIONS(2813),
    [anon_sym_throw] = ACTIONS(2813),
    [anon_sym_namespace] = ACTIONS(2813),
    [anon_sym_using] = ACTIONS(2813),
    [anon_sym_static_assert] = ACTIONS(2813),
    [anon_sym_concept] = ACTIONS(2813),
    [anon_sym_co_return] = ACTIONS(2813),
    [anon_sym_co_yield] = ACTIONS(2813),
    [anon_sym_R_DQUOTE] = ACTIONS(2815),
    [anon_sym_LR_DQUOTE] = ACTIONS(2815),
    [anon_sym_uR_DQUOTE] = ACTIONS(2815),
    [anon_sym_UR_DQUOTE] = ACTIONS(2815),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2815),
    [anon_sym_co_await] = ACTIONS(2813),
    [anon_sym_new] = ACTIONS(2813),
    [anon_sym_requires] = ACTIONS(2813),
    [sym_this] = ACTIONS(2813),
  },
  [331] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4295),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym___extension__] = ACTIONS(2819),
    [anon_sym_extern] = ACTIONS(2819),
    [anon_sym___attribute__] = ACTIONS(2819),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2821),
    [anon_sym___declspec] = ACTIONS(2819),
    [anon_sym_signed] = ACTIONS(2819),
    [anon_sym_unsigned] = ACTIONS(2819),
    [anon_sym_long] = ACTIONS(2819),
    [anon_sym_short] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [anon_sym_static] = ACTIONS(2819),
    [anon_sym_register] = ACTIONS(2819),
    [anon_sym_inline] = ACTIONS(2819),
    [anon_sym___inline] = ACTIONS(2819),
    [anon_sym___inline__] = ACTIONS(2819),
    [anon_sym___forceinline] = ACTIONS(2819),
    [anon_sym_thread_local] = ACTIONS(2819),
    [anon_sym___thread] = ACTIONS(2819),
    [anon_sym_const] = ACTIONS(2819),
    [anon_sym_constexpr] = ACTIONS(2819),
    [anon_sym_volatile] = ACTIONS(2819),
    [anon_sym_restrict] = ACTIONS(2819),
    [anon_sym___restrict__] = ACTIONS(2819),
    [anon_sym__Atomic] = ACTIONS(2819),
    [anon_sym__Noreturn] = ACTIONS(2819),
    [anon_sym_noreturn] = ACTIONS(2819),
    [anon_sym_mutable] = ACTIONS(2819),
    [anon_sym_constinit] = ACTIONS(2819),
    [anon_sym_consteval] = ACTIONS(2819),
    [anon_sym_PROGMEM] = ACTIONS(2819),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2819),
    [anon_sym_class] = ACTIONS(2819),
    [anon_sym_struct] = ACTIONS(2819),
    [anon_sym_union] = ACTIONS(2819),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2819),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_virtual] = ACTIONS(2819),
    [anon_sym_alignas] = ACTIONS(2819),
    [anon_sym_typename] = ACTIONS(2819),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [332] = {
    [sym_preproc_def] = STATE(409),
    [sym_preproc_function_def] = STATE(409),
    [sym_preproc_call] = STATE(409),
    [sym_preproc_if_in_field_declaration_list] = STATE(409),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(409),
    [sym_preproc_else_in_field_declaration_list] = STATE(8269),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8269),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8269),
    [sym_type_definition] = STATE(409),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(5531),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(3150),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(5962),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym__field_declaration_list_item] = STATE(409),
    [sym_field_declaration] = STATE(409),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1838),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(409),
    [sym_operator_cast] = STATE(6510),
    [sym_inline_method_definition] = STATE(409),
    [sym__constructor_specifiers] = STATE(1838),
    [sym_operator_cast_definition] = STATE(409),
    [sym_operator_cast_declaration] = STATE(409),
    [sym_constructor_or_destructor_definition] = STATE(409),
    [sym_constructor_or_destructor_declaration] = STATE(409),
    [sym_friend_declaration] = STATE(409),
    [sym_access_specifier] = STATE(7787),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(2618),
    [sym_template_function] = STATE(6098),
    [sym_using_declaration] = STATE(409),
    [sym_alias_declaration] = STATE(409),
    [sym_static_assert_declaration] = STATE(409),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5301),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_qualified_operator_cast_identifier] = STATE(6510),
    [sym_operator_name] = STATE(6098),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(409),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1961),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1838),
    [sym_identifier] = ACTIONS(2823),
    [aux_sym_preproc_def_token1] = ACTIONS(2825),
    [aux_sym_preproc_if_token1] = ACTIONS(2827),
    [aux_sym_preproc_if_token2] = ACTIONS(2829),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2831),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2831),
    [aux_sym_preproc_else_token1] = ACTIONS(2833),
    [aux_sym_preproc_elif_token1] = ACTIONS(2835),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2837),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2837),
    [sym_preproc_directive] = ACTIONS(2839),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(2849),
    [anon_sym_typedef] = ACTIONS(2851),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(2853),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2857),
    [anon_sym_class] = ACTIONS(2859),
    [anon_sym_struct] = ACTIONS(2861),
    [anon_sym_union] = ACTIONS(2863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(2865),
    [anon_sym_template] = ACTIONS(2867),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(2869),
    [anon_sym_public] = ACTIONS(2871),
    [anon_sym_private] = ACTIONS(2871),
    [anon_sym_protected] = ACTIONS(2871),
    [anon_sym_using] = ACTIONS(2873),
    [anon_sym_static_assert] = ACTIONS(2875),
  },
  [333] = {
    [sym_type_qualifier] = STATE(3799),
    [sym__type_specifier] = STATE(4801),
    [sym_sized_type_specifier] = STATE(2935),
    [sym_primitive_type] = STATE(4963),
    [sym_enum_specifier] = STATE(2935),
    [sym_struct_specifier] = STATE(2935),
    [sym_union_specifier] = STATE(2935),
    [sym__expression] = STATE(4384),
    [sym__expression_not_binary] = STATE(4648),
    [sym__string] = STATE(4648),
    [sym_conditional_expression] = STATE(4648),
    [sym_assignment_expression] = STATE(4648),
    [sym_pointer_expression] = STATE(3663),
    [sym_unary_expression] = STATE(4648),
    [sym_binary_expression] = STATE(4648),
    [sym_update_expression] = STATE(4648),
    [sym_cast_expression] = STATE(4648),
    [sym_type_descriptor] = STATE(7231),
    [sym_sizeof_expression] = STATE(4648),
    [sym_alignof_expression] = STATE(4648),
    [sym_offsetof_expression] = STATE(4648),
    [sym_generic_expression] = STATE(4648),
    [sym_subscript_expression] = STATE(3663),
    [sym_call_expression] = STATE(3663),
    [sym_gnu_asm_expression] = STATE(4648),
    [sym_field_expression] = STATE(3663),
    [sym_compound_literal_expression] = STATE(4648),
    [sym_parenthesized_expression] = STATE(3663),
    [sym_number_literal] = STATE(4573),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4565),
    [sym_string_literal] = STATE(3707),
    [sym_null] = STATE(4648),
    [sym_placeholder_type_specifier] = STATE(2935),
    [sym_decltype_auto] = STATE(2933),
    [sym_decltype] = STATE(2868),
    [sym_class_specifier] = STATE(2935),
    [sym__class_name] = STATE(7442),
    [sym_dependent_type] = STATE(2935),
    [sym_template_type] = STATE(5228),
    [sym_template_function] = STATE(4648),
    [sym_raw_string_literal] = STATE(3709),
    [sym_co_await_expression] = STATE(4648),
    [sym_new_expression] = STATE(4648),
    [sym_delete_expression] = STATE(4648),
    [sym_requires_clause] = STATE(4648),
    [sym_requires_expression] = STATE(4648),
    [sym_lambda_expression] = STATE(4648),
    [sym_lambda_capture_specifier] = STATE(5768),
    [sym_fold_expression] = STATE(4648),
    [sym_parameter_pack_expansion] = STATE(4648),
    [sym_type_parameter_pack_expansion] = STATE(7291),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5541),
    [sym_qualified_identifier] = STATE(3663),
    [sym_qualified_type_identifier] = STATE(5253),
    [sym_user_defined_literal] = STATE(3663),
    [aux_sym__type_definition_type_repeat1] = STATE(3799),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2164),
    [sym_identifier] = ACTIONS(2573),
    [anon_sym_LPAREN2] = ACTIONS(2575),
    [anon_sym_BANG] = ACTIONS(2577),
    [anon_sym_TILDE] = ACTIONS(2577),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_COLON_COLON] = ACTIONS(2583),
    [anon_sym_signed] = ACTIONS(2585),
    [anon_sym_unsigned] = ACTIONS(2585),
    [anon_sym_long] = ACTIONS(2585),
    [anon_sym_short] = ACTIONS(2585),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(2587),
    [anon_sym_byte] = ACTIONS(2587),
    [anon_sym_word] = ACTIONS(2587),
    [anon_sym_enum] = ACTIONS(2589),
    [anon_sym_class] = ACTIONS(2591),
    [anon_sym_struct] = ACTIONS(2593),
    [anon_sym_union] = ACTIONS(2595),
    [anon_sym_not] = ACTIONS(2579),
    [anon_sym_compl] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(2597),
    [anon_sym_PLUS_PLUS] = ACTIONS(2597),
    [anon_sym_sizeof] = ACTIONS(2599),
    [anon_sym___alignof__] = ACTIONS(2601),
    [anon_sym___alignof] = ACTIONS(2601),
    [anon_sym__alignof] = ACTIONS(2601),
    [anon_sym_alignof] = ACTIONS(2601),
    [anon_sym__Alignof] = ACTIONS(2601),
    [anon_sym_offsetof] = ACTIONS(2603),
    [anon_sym__Generic] = ACTIONS(2605),
    [anon_sym_asm] = ACTIONS(2607),
    [anon_sym___asm__] = ACTIONS(2607),
    [aux_sym_number_literal_token1] = ACTIONS(2609),
    [aux_sym_number_literal_token2] = ACTIONS(2611),
    [anon_sym_L_SQUOTE] = ACTIONS(2613),
    [anon_sym_u_SQUOTE] = ACTIONS(2613),
    [anon_sym_U_SQUOTE] = ACTIONS(2613),
    [anon_sym_u8_SQUOTE] = ACTIONS(2613),
    [anon_sym_SQUOTE] = ACTIONS(2613),
    [anon_sym_L_DQUOTE] = ACTIONS(2615),
    [anon_sym_u_DQUOTE] = ACTIONS(2615),
    [anon_sym_U_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8_DQUOTE] = ACTIONS(2615),
    [anon_sym_DQUOTE] = ACTIONS(2615),
    [sym_true] = ACTIONS(2617),
    [sym_false] = ACTIONS(2617),
    [anon_sym_NULL] = ACTIONS(2619),
    [anon_sym_nullptr] = ACTIONS(2619),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2621),
    [anon_sym_decltype] = ACTIONS(2623),
    [anon_sym_typename] = ACTIONS(2625),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2629),
    [anon_sym_R_DQUOTE] = ACTIONS(2631),
    [anon_sym_LR_DQUOTE] = ACTIONS(2631),
    [anon_sym_uR_DQUOTE] = ACTIONS(2631),
    [anon_sym_UR_DQUOTE] = ACTIONS(2631),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2631),
    [anon_sym_co_await] = ACTIONS(2633),
    [anon_sym_new] = ACTIONS(2635),
    [anon_sym_requires] = ACTIONS(2637),
    [sym_this] = ACTIONS(2617),
  },
  [334] = {
    [sym_identifier] = ACTIONS(2877),
    [aux_sym_preproc_include_token1] = ACTIONS(2877),
    [aux_sym_preproc_def_token1] = ACTIONS(2877),
    [aux_sym_preproc_if_token1] = ACTIONS(2877),
    [aux_sym_preproc_if_token2] = ACTIONS(2877),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2877),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2877),
    [aux_sym_preproc_else_token1] = ACTIONS(2877),
    [aux_sym_preproc_elif_token1] = ACTIONS(2877),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2877),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2877),
    [sym_preproc_directive] = ACTIONS(2877),
    [anon_sym_LPAREN2] = ACTIONS(2879),
    [anon_sym_BANG] = ACTIONS(2879),
    [anon_sym_TILDE] = ACTIONS(2879),
    [anon_sym_DASH] = ACTIONS(2877),
    [anon_sym_PLUS] = ACTIONS(2877),
    [anon_sym_STAR] = ACTIONS(2879),
    [anon_sym_AMP_AMP] = ACTIONS(2879),
    [anon_sym_AMP] = ACTIONS(2877),
    [anon_sym_SEMI] = ACTIONS(2879),
    [anon_sym___extension__] = ACTIONS(2877),
    [anon_sym_typedef] = ACTIONS(2877),
    [anon_sym_extern] = ACTIONS(2877),
    [anon_sym___attribute__] = ACTIONS(2877),
    [anon_sym_COLON_COLON] = ACTIONS(2879),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2879),
    [anon_sym___declspec] = ACTIONS(2877),
    [anon_sym___based] = ACTIONS(2877),
    [anon_sym___cdecl] = ACTIONS(2877),
    [anon_sym___clrcall] = ACTIONS(2877),
    [anon_sym___stdcall] = ACTIONS(2877),
    [anon_sym___fastcall] = ACTIONS(2877),
    [anon_sym___thiscall] = ACTIONS(2877),
    [anon_sym___vectorcall] = ACTIONS(2877),
    [anon_sym_LBRACE] = ACTIONS(2879),
    [anon_sym_signed] = ACTIONS(2877),
    [anon_sym_unsigned] = ACTIONS(2877),
    [anon_sym_long] = ACTIONS(2877),
    [anon_sym_short] = ACTIONS(2877),
    [anon_sym_LBRACK] = ACTIONS(2877),
    [anon_sym_static] = ACTIONS(2877),
    [anon_sym_register] = ACTIONS(2877),
    [anon_sym_inline] = ACTIONS(2877),
    [anon_sym___inline] = ACTIONS(2877),
    [anon_sym___inline__] = ACTIONS(2877),
    [anon_sym___forceinline] = ACTIONS(2877),
    [anon_sym_thread_local] = ACTIONS(2877),
    [anon_sym___thread] = ACTIONS(2877),
    [anon_sym_const] = ACTIONS(2877),
    [anon_sym_constexpr] = ACTIONS(2877),
    [anon_sym_volatile] = ACTIONS(2877),
    [anon_sym_restrict] = ACTIONS(2877),
    [anon_sym___restrict__] = ACTIONS(2877),
    [anon_sym__Atomic] = ACTIONS(2877),
    [anon_sym__Noreturn] = ACTIONS(2877),
    [anon_sym_noreturn] = ACTIONS(2877),
    [anon_sym_mutable] = ACTIONS(2877),
    [anon_sym_constinit] = ACTIONS(2877),
    [anon_sym_consteval] = ACTIONS(2877),
    [anon_sym_PROGMEM] = ACTIONS(2877),
    [aux_sym_primitive_type_token1] = ACTIONS(2877),
    [anon_sym_byte] = ACTIONS(2877),
    [anon_sym_word] = ACTIONS(2877),
    [anon_sym_enum] = ACTIONS(2877),
    [anon_sym_class] = ACTIONS(2877),
    [anon_sym_struct] = ACTIONS(2877),
    [anon_sym_union] = ACTIONS(2877),
    [anon_sym_if] = ACTIONS(2877),
    [anon_sym_switch] = ACTIONS(2877),
    [anon_sym_case] = ACTIONS(2877),
    [anon_sym_default] = ACTIONS(2877),
    [anon_sym_while] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_for] = ACTIONS(2877),
    [anon_sym_return] = ACTIONS(2877),
    [anon_sym_break] = ACTIONS(2877),
    [anon_sym_continue] = ACTIONS(2877),
    [anon_sym_goto] = ACTIONS(2877),
    [anon_sym___try] = ACTIONS(2877),
    [anon_sym___leave] = ACTIONS(2877),
    [anon_sym_not] = ACTIONS(2877),
    [anon_sym_compl] = ACTIONS(2877),
    [anon_sym_DASH_DASH] = ACTIONS(2879),
    [anon_sym_PLUS_PLUS] = ACTIONS(2879),
    [anon_sym_sizeof] = ACTIONS(2877),
    [anon_sym___alignof__] = ACTIONS(2877),
    [anon_sym___alignof] = ACTIONS(2877),
    [anon_sym__alignof] = ACTIONS(2877),
    [anon_sym_alignof] = ACTIONS(2877),
    [anon_sym__Alignof] = ACTIONS(2877),
    [anon_sym_offsetof] = ACTIONS(2877),
    [anon_sym__Generic] = ACTIONS(2877),
    [anon_sym_asm] = ACTIONS(2877),
    [anon_sym___asm__] = ACTIONS(2877),
    [aux_sym_number_literal_token1] = ACTIONS(2879),
    [aux_sym_number_literal_token2] = ACTIONS(2877),
    [anon_sym_L_SQUOTE] = ACTIONS(2879),
    [anon_sym_u_SQUOTE] = ACTIONS(2879),
    [anon_sym_U_SQUOTE] = ACTIONS(2879),
    [anon_sym_u8_SQUOTE] = ACTIONS(2879),
    [anon_sym_SQUOTE] = ACTIONS(2879),
    [anon_sym_L_DQUOTE] = ACTIONS(2879),
    [anon_sym_u_DQUOTE] = ACTIONS(2879),
    [anon_sym_U_DQUOTE] = ACTIONS(2879),
    [anon_sym_u8_DQUOTE] = ACTIONS(2879),
    [anon_sym_DQUOTE] = ACTIONS(2879),
    [sym_true] = ACTIONS(2877),
    [sym_false] = ACTIONS(2877),
    [anon_sym_NULL] = ACTIONS(2877),
    [anon_sym_nullptr] = ACTIONS(2877),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2877),
    [anon_sym_decltype] = ACTIONS(2877),
    [anon_sym_virtual] = ACTIONS(2877),
    [anon_sym_alignas] = ACTIONS(2877),
    [anon_sym_explicit] = ACTIONS(2877),
    [anon_sym_typename] = ACTIONS(2877),
    [anon_sym_template] = ACTIONS(2877),
    [anon_sym_operator] = ACTIONS(2877),
    [anon_sym_try] = ACTIONS(2877),
    [anon_sym_delete] = ACTIONS(2877),
    [anon_sym_throw] = ACTIONS(2877),
    [anon_sym_namespace] = ACTIONS(2877),
    [anon_sym_using] = ACTIONS(2877),
    [anon_sym_static_assert] = ACTIONS(2877),
    [anon_sym_concept] = ACTIONS(2877),
    [anon_sym_co_return] = ACTIONS(2877),
    [anon_sym_co_yield] = ACTIONS(2877),
    [anon_sym_R_DQUOTE] = ACTIONS(2879),
    [anon_sym_LR_DQUOTE] = ACTIONS(2879),
    [anon_sym_uR_DQUOTE] = ACTIONS(2879),
    [anon_sym_UR_DQUOTE] = ACTIONS(2879),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2879),
    [anon_sym_co_await] = ACTIONS(2877),
    [anon_sym_new] = ACTIONS(2877),
    [anon_sym_requires] = ACTIONS(2877),
    [sym_this] = ACTIONS(2877),
  },
  [335] = {
    [sym_preproc_def] = STATE(541),
    [sym_preproc_function_def] = STATE(541),
    [sym_preproc_call] = STATE(541),
    [sym_preproc_if_in_field_declaration_list] = STATE(541),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(541),
    [sym_preproc_else_in_field_declaration_list] = STATE(8094),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8094),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8094),
    [sym_type_definition] = STATE(541),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(5531),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(3150),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(5962),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym__field_declaration_list_item] = STATE(541),
    [sym_field_declaration] = STATE(541),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1838),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(541),
    [sym_operator_cast] = STATE(6510),
    [sym_inline_method_definition] = STATE(541),
    [sym__constructor_specifiers] = STATE(1838),
    [sym_operator_cast_definition] = STATE(541),
    [sym_operator_cast_declaration] = STATE(541),
    [sym_constructor_or_destructor_definition] = STATE(541),
    [sym_constructor_or_destructor_declaration] = STATE(541),
    [sym_friend_declaration] = STATE(541),
    [sym_access_specifier] = STATE(7787),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(2618),
    [sym_template_function] = STATE(6098),
    [sym_using_declaration] = STATE(541),
    [sym_alias_declaration] = STATE(541),
    [sym_static_assert_declaration] = STATE(541),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5301),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_qualified_operator_cast_identifier] = STATE(6510),
    [sym_operator_name] = STATE(6098),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(541),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1961),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1838),
    [sym_identifier] = ACTIONS(2823),
    [aux_sym_preproc_def_token1] = ACTIONS(2825),
    [aux_sym_preproc_if_token1] = ACTIONS(2827),
    [aux_sym_preproc_if_token2] = ACTIONS(2881),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2831),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2831),
    [aux_sym_preproc_else_token1] = ACTIONS(2833),
    [aux_sym_preproc_elif_token1] = ACTIONS(2835),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2837),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2837),
    [sym_preproc_directive] = ACTIONS(2839),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(2849),
    [anon_sym_typedef] = ACTIONS(2851),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(2853),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2857),
    [anon_sym_class] = ACTIONS(2859),
    [anon_sym_struct] = ACTIONS(2861),
    [anon_sym_union] = ACTIONS(2863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(2865),
    [anon_sym_template] = ACTIONS(2867),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(2869),
    [anon_sym_public] = ACTIONS(2871),
    [anon_sym_private] = ACTIONS(2871),
    [anon_sym_protected] = ACTIONS(2871),
    [anon_sym_using] = ACTIONS(2873),
    [anon_sym_static_assert] = ACTIONS(2875),
  },
  [336] = {
    [sym_catch_clause] = STATE(402),
    [aux_sym_constructor_try_statement_repeat1] = STATE(402),
    [sym_identifier] = ACTIONS(2482),
    [aux_sym_preproc_include_token1] = ACTIONS(2482),
    [aux_sym_preproc_def_token1] = ACTIONS(2482),
    [aux_sym_preproc_if_token1] = ACTIONS(2482),
    [aux_sym_preproc_if_token2] = ACTIONS(2482),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2482),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2482),
    [sym_preproc_directive] = ACTIONS(2482),
    [anon_sym_LPAREN2] = ACTIONS(2484),
    [anon_sym_BANG] = ACTIONS(2484),
    [anon_sym_TILDE] = ACTIONS(2484),
    [anon_sym_DASH] = ACTIONS(2482),
    [anon_sym_PLUS] = ACTIONS(2482),
    [anon_sym_STAR] = ACTIONS(2484),
    [anon_sym_AMP_AMP] = ACTIONS(2484),
    [anon_sym_AMP] = ACTIONS(2482),
    [anon_sym_SEMI] = ACTIONS(2484),
    [anon_sym___extension__] = ACTIONS(2482),
    [anon_sym_typedef] = ACTIONS(2482),
    [anon_sym_extern] = ACTIONS(2482),
    [anon_sym___attribute__] = ACTIONS(2482),
    [anon_sym_COLON_COLON] = ACTIONS(2484),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2484),
    [anon_sym___declspec] = ACTIONS(2482),
    [anon_sym___based] = ACTIONS(2482),
    [anon_sym___cdecl] = ACTIONS(2482),
    [anon_sym___clrcall] = ACTIONS(2482),
    [anon_sym___stdcall] = ACTIONS(2482),
    [anon_sym___fastcall] = ACTIONS(2482),
    [anon_sym___thiscall] = ACTIONS(2482),
    [anon_sym___vectorcall] = ACTIONS(2482),
    [anon_sym_LBRACE] = ACTIONS(2484),
    [anon_sym_signed] = ACTIONS(2482),
    [anon_sym_unsigned] = ACTIONS(2482),
    [anon_sym_long] = ACTIONS(2482),
    [anon_sym_short] = ACTIONS(2482),
    [anon_sym_LBRACK] = ACTIONS(2482),
    [anon_sym_static] = ACTIONS(2482),
    [anon_sym_register] = ACTIONS(2482),
    [anon_sym_inline] = ACTIONS(2482),
    [anon_sym___inline] = ACTIONS(2482),
    [anon_sym___inline__] = ACTIONS(2482),
    [anon_sym___forceinline] = ACTIONS(2482),
    [anon_sym_thread_local] = ACTIONS(2482),
    [anon_sym___thread] = ACTIONS(2482),
    [anon_sym_const] = ACTIONS(2482),
    [anon_sym_constexpr] = ACTIONS(2482),
    [anon_sym_volatile] = ACTIONS(2482),
    [anon_sym_restrict] = ACTIONS(2482),
    [anon_sym___restrict__] = ACTIONS(2482),
    [anon_sym__Atomic] = ACTIONS(2482),
    [anon_sym__Noreturn] = ACTIONS(2482),
    [anon_sym_noreturn] = ACTIONS(2482),
    [anon_sym_mutable] = ACTIONS(2482),
    [anon_sym_constinit] = ACTIONS(2482),
    [anon_sym_consteval] = ACTIONS(2482),
    [anon_sym_PROGMEM] = ACTIONS(2482),
    [aux_sym_primitive_type_token1] = ACTIONS(2482),
    [anon_sym_byte] = ACTIONS(2482),
    [anon_sym_word] = ACTIONS(2482),
    [anon_sym_enum] = ACTIONS(2482),
    [anon_sym_class] = ACTIONS(2482),
    [anon_sym_struct] = ACTIONS(2482),
    [anon_sym_union] = ACTIONS(2482),
    [anon_sym_if] = ACTIONS(2482),
    [anon_sym_else] = ACTIONS(2482),
    [anon_sym_switch] = ACTIONS(2482),
    [anon_sym_case] = ACTIONS(2482),
    [anon_sym_default] = ACTIONS(2482),
    [anon_sym_while] = ACTIONS(2482),
    [anon_sym_do] = ACTIONS(2482),
    [anon_sym_for] = ACTIONS(2482),
    [anon_sym_return] = ACTIONS(2482),
    [anon_sym_break] = ACTIONS(2482),
    [anon_sym_continue] = ACTIONS(2482),
    [anon_sym_goto] = ACTIONS(2482),
    [anon_sym___try] = ACTIONS(2482),
    [anon_sym___leave] = ACTIONS(2482),
    [anon_sym_not] = ACTIONS(2482),
    [anon_sym_compl] = ACTIONS(2482),
    [anon_sym_DASH_DASH] = ACTIONS(2484),
    [anon_sym_PLUS_PLUS] = ACTIONS(2484),
    [anon_sym_sizeof] = ACTIONS(2482),
    [anon_sym___alignof__] = ACTIONS(2482),
    [anon_sym___alignof] = ACTIONS(2482),
    [anon_sym__alignof] = ACTIONS(2482),
    [anon_sym_alignof] = ACTIONS(2482),
    [anon_sym__Alignof] = ACTIONS(2482),
    [anon_sym_offsetof] = ACTIONS(2482),
    [anon_sym__Generic] = ACTIONS(2482),
    [anon_sym_asm] = ACTIONS(2482),
    [anon_sym___asm__] = ACTIONS(2482),
    [aux_sym_number_literal_token1] = ACTIONS(2484),
    [aux_sym_number_literal_token2] = ACTIONS(2482),
    [anon_sym_L_SQUOTE] = ACTIONS(2484),
    [anon_sym_u_SQUOTE] = ACTIONS(2484),
    [anon_sym_U_SQUOTE] = ACTIONS(2484),
    [anon_sym_u8_SQUOTE] = ACTIONS(2484),
    [anon_sym_SQUOTE] = ACTIONS(2484),
    [anon_sym_L_DQUOTE] = ACTIONS(2484),
    [anon_sym_u_DQUOTE] = ACTIONS(2484),
    [anon_sym_U_DQUOTE] = ACTIONS(2484),
    [anon_sym_u8_DQUOTE] = ACTIONS(2484),
    [anon_sym_DQUOTE] = ACTIONS(2484),
    [sym_true] = ACTIONS(2482),
    [sym_false] = ACTIONS(2482),
    [anon_sym_NULL] = ACTIONS(2482),
    [anon_sym_nullptr] = ACTIONS(2482),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2482),
    [anon_sym_decltype] = ACTIONS(2482),
    [anon_sym_virtual] = ACTIONS(2482),
    [anon_sym_alignas] = ACTIONS(2482),
    [anon_sym_explicit] = ACTIONS(2482),
    [anon_sym_typename] = ACTIONS(2482),
    [anon_sym_template] = ACTIONS(2482),
    [anon_sym_operator] = ACTIONS(2482),
    [anon_sym_try] = ACTIONS(2482),
    [anon_sym_delete] = ACTIONS(2482),
    [anon_sym_throw] = ACTIONS(2482),
    [anon_sym_namespace] = ACTIONS(2482),
    [anon_sym_using] = ACTIONS(2482),
    [anon_sym_static_assert] = ACTIONS(2482),
    [anon_sym_concept] = ACTIONS(2482),
    [anon_sym_co_return] = ACTIONS(2482),
    [anon_sym_co_yield] = ACTIONS(2482),
    [anon_sym_catch] = ACTIONS(2883),
    [anon_sym_R_DQUOTE] = ACTIONS(2484),
    [anon_sym_LR_DQUOTE] = ACTIONS(2484),
    [anon_sym_uR_DQUOTE] = ACTIONS(2484),
    [anon_sym_UR_DQUOTE] = ACTIONS(2484),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2484),
    [anon_sym_co_await] = ACTIONS(2482),
    [anon_sym_new] = ACTIONS(2482),
    [anon_sym_requires] = ACTIONS(2482),
    [sym_this] = ACTIONS(2482),
  },
  [337] = {
    [sym_identifier] = ACTIONS(2885),
    [aux_sym_preproc_include_token1] = ACTIONS(2885),
    [aux_sym_preproc_def_token1] = ACTIONS(2885),
    [aux_sym_preproc_if_token1] = ACTIONS(2885),
    [aux_sym_preproc_if_token2] = ACTIONS(2885),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2885),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2885),
    [aux_sym_preproc_else_token1] = ACTIONS(2885),
    [aux_sym_preproc_elif_token1] = ACTIONS(2885),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2885),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2885),
    [sym_preproc_directive] = ACTIONS(2885),
    [anon_sym_LPAREN2] = ACTIONS(2887),
    [anon_sym_BANG] = ACTIONS(2887),
    [anon_sym_TILDE] = ACTIONS(2887),
    [anon_sym_DASH] = ACTIONS(2885),
    [anon_sym_PLUS] = ACTIONS(2885),
    [anon_sym_STAR] = ACTIONS(2887),
    [anon_sym_AMP_AMP] = ACTIONS(2887),
    [anon_sym_AMP] = ACTIONS(2885),
    [anon_sym_SEMI] = ACTIONS(2887),
    [anon_sym___extension__] = ACTIONS(2885),
    [anon_sym_typedef] = ACTIONS(2885),
    [anon_sym_extern] = ACTIONS(2885),
    [anon_sym___attribute__] = ACTIONS(2885),
    [anon_sym_COLON_COLON] = ACTIONS(2887),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2887),
    [anon_sym___declspec] = ACTIONS(2885),
    [anon_sym___based] = ACTIONS(2885),
    [anon_sym___cdecl] = ACTIONS(2885),
    [anon_sym___clrcall] = ACTIONS(2885),
    [anon_sym___stdcall] = ACTIONS(2885),
    [anon_sym___fastcall] = ACTIONS(2885),
    [anon_sym___thiscall] = ACTIONS(2885),
    [anon_sym___vectorcall] = ACTIONS(2885),
    [anon_sym_LBRACE] = ACTIONS(2887),
    [anon_sym_signed] = ACTIONS(2885),
    [anon_sym_unsigned] = ACTIONS(2885),
    [anon_sym_long] = ACTIONS(2885),
    [anon_sym_short] = ACTIONS(2885),
    [anon_sym_LBRACK] = ACTIONS(2885),
    [anon_sym_static] = ACTIONS(2885),
    [anon_sym_register] = ACTIONS(2885),
    [anon_sym_inline] = ACTIONS(2885),
    [anon_sym___inline] = ACTIONS(2885),
    [anon_sym___inline__] = ACTIONS(2885),
    [anon_sym___forceinline] = ACTIONS(2885),
    [anon_sym_thread_local] = ACTIONS(2885),
    [anon_sym___thread] = ACTIONS(2885),
    [anon_sym_const] = ACTIONS(2885),
    [anon_sym_constexpr] = ACTIONS(2885),
    [anon_sym_volatile] = ACTIONS(2885),
    [anon_sym_restrict] = ACTIONS(2885),
    [anon_sym___restrict__] = ACTIONS(2885),
    [anon_sym__Atomic] = ACTIONS(2885),
    [anon_sym__Noreturn] = ACTIONS(2885),
    [anon_sym_noreturn] = ACTIONS(2885),
    [anon_sym_mutable] = ACTIONS(2885),
    [anon_sym_constinit] = ACTIONS(2885),
    [anon_sym_consteval] = ACTIONS(2885),
    [anon_sym_PROGMEM] = ACTIONS(2885),
    [aux_sym_primitive_type_token1] = ACTIONS(2885),
    [anon_sym_byte] = ACTIONS(2885),
    [anon_sym_word] = ACTIONS(2885),
    [anon_sym_enum] = ACTIONS(2885),
    [anon_sym_class] = ACTIONS(2885),
    [anon_sym_struct] = ACTIONS(2885),
    [anon_sym_union] = ACTIONS(2885),
    [anon_sym_if] = ACTIONS(2885),
    [anon_sym_switch] = ACTIONS(2885),
    [anon_sym_case] = ACTIONS(2885),
    [anon_sym_default] = ACTIONS(2885),
    [anon_sym_while] = ACTIONS(2885),
    [anon_sym_do] = ACTIONS(2885),
    [anon_sym_for] = ACTIONS(2885),
    [anon_sym_return] = ACTIONS(2885),
    [anon_sym_break] = ACTIONS(2885),
    [anon_sym_continue] = ACTIONS(2885),
    [anon_sym_goto] = ACTIONS(2885),
    [anon_sym___try] = ACTIONS(2885),
    [anon_sym___leave] = ACTIONS(2885),
    [anon_sym_not] = ACTIONS(2885),
    [anon_sym_compl] = ACTIONS(2885),
    [anon_sym_DASH_DASH] = ACTIONS(2887),
    [anon_sym_PLUS_PLUS] = ACTIONS(2887),
    [anon_sym_sizeof] = ACTIONS(2885),
    [anon_sym___alignof__] = ACTIONS(2885),
    [anon_sym___alignof] = ACTIONS(2885),
    [anon_sym__alignof] = ACTIONS(2885),
    [anon_sym_alignof] = ACTIONS(2885),
    [anon_sym__Alignof] = ACTIONS(2885),
    [anon_sym_offsetof] = ACTIONS(2885),
    [anon_sym__Generic] = ACTIONS(2885),
    [anon_sym_asm] = ACTIONS(2885),
    [anon_sym___asm__] = ACTIONS(2885),
    [aux_sym_number_literal_token1] = ACTIONS(2887),
    [aux_sym_number_literal_token2] = ACTIONS(2885),
    [anon_sym_L_SQUOTE] = ACTIONS(2887),
    [anon_sym_u_SQUOTE] = ACTIONS(2887),
    [anon_sym_U_SQUOTE] = ACTIONS(2887),
    [anon_sym_u8_SQUOTE] = ACTIONS(2887),
    [anon_sym_SQUOTE] = ACTIONS(2887),
    [anon_sym_L_DQUOTE] = ACTIONS(2887),
    [anon_sym_u_DQUOTE] = ACTIONS(2887),
    [anon_sym_U_DQUOTE] = ACTIONS(2887),
    [anon_sym_u8_DQUOTE] = ACTIONS(2887),
    [anon_sym_DQUOTE] = ACTIONS(2887),
    [sym_true] = ACTIONS(2885),
    [sym_false] = ACTIONS(2885),
    [anon_sym_NULL] = ACTIONS(2885),
    [anon_sym_nullptr] = ACTIONS(2885),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2885),
    [anon_sym_decltype] = ACTIONS(2885),
    [anon_sym_virtual] = ACTIONS(2885),
    [anon_sym_alignas] = ACTIONS(2885),
    [anon_sym_explicit] = ACTIONS(2885),
    [anon_sym_typename] = ACTIONS(2885),
    [anon_sym_template] = ACTIONS(2885),
    [anon_sym_operator] = ACTIONS(2885),
    [anon_sym_try] = ACTIONS(2885),
    [anon_sym_delete] = ACTIONS(2885),
    [anon_sym_throw] = ACTIONS(2885),
    [anon_sym_namespace] = ACTIONS(2885),
    [anon_sym_using] = ACTIONS(2885),
    [anon_sym_static_assert] = ACTIONS(2885),
    [anon_sym_concept] = ACTIONS(2885),
    [anon_sym_co_return] = ACTIONS(2885),
    [anon_sym_co_yield] = ACTIONS(2885),
    [anon_sym_R_DQUOTE] = ACTIONS(2887),
    [anon_sym_LR_DQUOTE] = ACTIONS(2887),
    [anon_sym_uR_DQUOTE] = ACTIONS(2887),
    [anon_sym_UR_DQUOTE] = ACTIONS(2887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2887),
    [anon_sym_co_await] = ACTIONS(2885),
    [anon_sym_new] = ACTIONS(2885),
    [anon_sym_requires] = ACTIONS(2885),
    [sym_this] = ACTIONS(2885),
  },
  [338] = {
    [sym_identifier] = ACTIONS(2889),
    [aux_sym_preproc_include_token1] = ACTIONS(2889),
    [aux_sym_preproc_def_token1] = ACTIONS(2889),
    [aux_sym_preproc_if_token1] = ACTIONS(2889),
    [aux_sym_preproc_if_token2] = ACTIONS(2889),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2889),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2889),
    [aux_sym_preproc_else_token1] = ACTIONS(2889),
    [aux_sym_preproc_elif_token1] = ACTIONS(2889),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2889),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2889),
    [sym_preproc_directive] = ACTIONS(2889),
    [anon_sym_LPAREN2] = ACTIONS(2891),
    [anon_sym_BANG] = ACTIONS(2891),
    [anon_sym_TILDE] = ACTIONS(2891),
    [anon_sym_DASH] = ACTIONS(2889),
    [anon_sym_PLUS] = ACTIONS(2889),
    [anon_sym_STAR] = ACTIONS(2891),
    [anon_sym_AMP_AMP] = ACTIONS(2891),
    [anon_sym_AMP] = ACTIONS(2889),
    [anon_sym_SEMI] = ACTIONS(2891),
    [anon_sym___extension__] = ACTIONS(2889),
    [anon_sym_typedef] = ACTIONS(2889),
    [anon_sym_extern] = ACTIONS(2889),
    [anon_sym___attribute__] = ACTIONS(2889),
    [anon_sym_COLON_COLON] = ACTIONS(2891),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2891),
    [anon_sym___declspec] = ACTIONS(2889),
    [anon_sym___based] = ACTIONS(2889),
    [anon_sym___cdecl] = ACTIONS(2889),
    [anon_sym___clrcall] = ACTIONS(2889),
    [anon_sym___stdcall] = ACTIONS(2889),
    [anon_sym___fastcall] = ACTIONS(2889),
    [anon_sym___thiscall] = ACTIONS(2889),
    [anon_sym___vectorcall] = ACTIONS(2889),
    [anon_sym_LBRACE] = ACTIONS(2891),
    [anon_sym_signed] = ACTIONS(2889),
    [anon_sym_unsigned] = ACTIONS(2889),
    [anon_sym_long] = ACTIONS(2889),
    [anon_sym_short] = ACTIONS(2889),
    [anon_sym_LBRACK] = ACTIONS(2889),
    [anon_sym_static] = ACTIONS(2889),
    [anon_sym_register] = ACTIONS(2889),
    [anon_sym_inline] = ACTIONS(2889),
    [anon_sym___inline] = ACTIONS(2889),
    [anon_sym___inline__] = ACTIONS(2889),
    [anon_sym___forceinline] = ACTIONS(2889),
    [anon_sym_thread_local] = ACTIONS(2889),
    [anon_sym___thread] = ACTIONS(2889),
    [anon_sym_const] = ACTIONS(2889),
    [anon_sym_constexpr] = ACTIONS(2889),
    [anon_sym_volatile] = ACTIONS(2889),
    [anon_sym_restrict] = ACTIONS(2889),
    [anon_sym___restrict__] = ACTIONS(2889),
    [anon_sym__Atomic] = ACTIONS(2889),
    [anon_sym__Noreturn] = ACTIONS(2889),
    [anon_sym_noreturn] = ACTIONS(2889),
    [anon_sym_mutable] = ACTIONS(2889),
    [anon_sym_constinit] = ACTIONS(2889),
    [anon_sym_consteval] = ACTIONS(2889),
    [anon_sym_PROGMEM] = ACTIONS(2889),
    [aux_sym_primitive_type_token1] = ACTIONS(2889),
    [anon_sym_byte] = ACTIONS(2889),
    [anon_sym_word] = ACTIONS(2889),
    [anon_sym_enum] = ACTIONS(2889),
    [anon_sym_class] = ACTIONS(2889),
    [anon_sym_struct] = ACTIONS(2889),
    [anon_sym_union] = ACTIONS(2889),
    [anon_sym_if] = ACTIONS(2889),
    [anon_sym_switch] = ACTIONS(2889),
    [anon_sym_case] = ACTIONS(2889),
    [anon_sym_default] = ACTIONS(2889),
    [anon_sym_while] = ACTIONS(2889),
    [anon_sym_do] = ACTIONS(2889),
    [anon_sym_for] = ACTIONS(2889),
    [anon_sym_return] = ACTIONS(2889),
    [anon_sym_break] = ACTIONS(2889),
    [anon_sym_continue] = ACTIONS(2889),
    [anon_sym_goto] = ACTIONS(2889),
    [anon_sym___try] = ACTIONS(2889),
    [anon_sym___leave] = ACTIONS(2889),
    [anon_sym_not] = ACTIONS(2889),
    [anon_sym_compl] = ACTIONS(2889),
    [anon_sym_DASH_DASH] = ACTIONS(2891),
    [anon_sym_PLUS_PLUS] = ACTIONS(2891),
    [anon_sym_sizeof] = ACTIONS(2889),
    [anon_sym___alignof__] = ACTIONS(2889),
    [anon_sym___alignof] = ACTIONS(2889),
    [anon_sym__alignof] = ACTIONS(2889),
    [anon_sym_alignof] = ACTIONS(2889),
    [anon_sym__Alignof] = ACTIONS(2889),
    [anon_sym_offsetof] = ACTIONS(2889),
    [anon_sym__Generic] = ACTIONS(2889),
    [anon_sym_asm] = ACTIONS(2889),
    [anon_sym___asm__] = ACTIONS(2889),
    [aux_sym_number_literal_token1] = ACTIONS(2891),
    [aux_sym_number_literal_token2] = ACTIONS(2889),
    [anon_sym_L_SQUOTE] = ACTIONS(2891),
    [anon_sym_u_SQUOTE] = ACTIONS(2891),
    [anon_sym_U_SQUOTE] = ACTIONS(2891),
    [anon_sym_u8_SQUOTE] = ACTIONS(2891),
    [anon_sym_SQUOTE] = ACTIONS(2891),
    [anon_sym_L_DQUOTE] = ACTIONS(2891),
    [anon_sym_u_DQUOTE] = ACTIONS(2891),
    [anon_sym_U_DQUOTE] = ACTIONS(2891),
    [anon_sym_u8_DQUOTE] = ACTIONS(2891),
    [anon_sym_DQUOTE] = ACTIONS(2891),
    [sym_true] = ACTIONS(2889),
    [sym_false] = ACTIONS(2889),
    [anon_sym_NULL] = ACTIONS(2889),
    [anon_sym_nullptr] = ACTIONS(2889),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2889),
    [anon_sym_decltype] = ACTIONS(2889),
    [anon_sym_virtual] = ACTIONS(2889),
    [anon_sym_alignas] = ACTIONS(2889),
    [anon_sym_explicit] = ACTIONS(2889),
    [anon_sym_typename] = ACTIONS(2889),
    [anon_sym_template] = ACTIONS(2889),
    [anon_sym_operator] = ACTIONS(2889),
    [anon_sym_try] = ACTIONS(2889),
    [anon_sym_delete] = ACTIONS(2889),
    [anon_sym_throw] = ACTIONS(2889),
    [anon_sym_namespace] = ACTIONS(2889),
    [anon_sym_using] = ACTIONS(2889),
    [anon_sym_static_assert] = ACTIONS(2889),
    [anon_sym_concept] = ACTIONS(2889),
    [anon_sym_co_return] = ACTIONS(2889),
    [anon_sym_co_yield] = ACTIONS(2889),
    [anon_sym_R_DQUOTE] = ACTIONS(2891),
    [anon_sym_LR_DQUOTE] = ACTIONS(2891),
    [anon_sym_uR_DQUOTE] = ACTIONS(2891),
    [anon_sym_UR_DQUOTE] = ACTIONS(2891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2891),
    [anon_sym_co_await] = ACTIONS(2889),
    [anon_sym_new] = ACTIONS(2889),
    [anon_sym_requires] = ACTIONS(2889),
    [sym_this] = ACTIONS(2889),
  },
  [339] = {
    [sym_identifier] = ACTIONS(2893),
    [aux_sym_preproc_include_token1] = ACTIONS(2893),
    [aux_sym_preproc_def_token1] = ACTIONS(2893),
    [aux_sym_preproc_if_token1] = ACTIONS(2893),
    [aux_sym_preproc_if_token2] = ACTIONS(2893),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2893),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2893),
    [aux_sym_preproc_else_token1] = ACTIONS(2893),
    [aux_sym_preproc_elif_token1] = ACTIONS(2893),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2893),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2893),
    [sym_preproc_directive] = ACTIONS(2893),
    [anon_sym_LPAREN2] = ACTIONS(2895),
    [anon_sym_BANG] = ACTIONS(2895),
    [anon_sym_TILDE] = ACTIONS(2895),
    [anon_sym_DASH] = ACTIONS(2893),
    [anon_sym_PLUS] = ACTIONS(2893),
    [anon_sym_STAR] = ACTIONS(2895),
    [anon_sym_AMP_AMP] = ACTIONS(2895),
    [anon_sym_AMP] = ACTIONS(2893),
    [anon_sym_SEMI] = ACTIONS(2895),
    [anon_sym___extension__] = ACTIONS(2893),
    [anon_sym_typedef] = ACTIONS(2893),
    [anon_sym_extern] = ACTIONS(2893),
    [anon_sym___attribute__] = ACTIONS(2893),
    [anon_sym_COLON_COLON] = ACTIONS(2895),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2895),
    [anon_sym___declspec] = ACTIONS(2893),
    [anon_sym___based] = ACTIONS(2893),
    [anon_sym___cdecl] = ACTIONS(2893),
    [anon_sym___clrcall] = ACTIONS(2893),
    [anon_sym___stdcall] = ACTIONS(2893),
    [anon_sym___fastcall] = ACTIONS(2893),
    [anon_sym___thiscall] = ACTIONS(2893),
    [anon_sym___vectorcall] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(2895),
    [anon_sym_signed] = ACTIONS(2893),
    [anon_sym_unsigned] = ACTIONS(2893),
    [anon_sym_long] = ACTIONS(2893),
    [anon_sym_short] = ACTIONS(2893),
    [anon_sym_LBRACK] = ACTIONS(2893),
    [anon_sym_static] = ACTIONS(2893),
    [anon_sym_register] = ACTIONS(2893),
    [anon_sym_inline] = ACTIONS(2893),
    [anon_sym___inline] = ACTIONS(2893),
    [anon_sym___inline__] = ACTIONS(2893),
    [anon_sym___forceinline] = ACTIONS(2893),
    [anon_sym_thread_local] = ACTIONS(2893),
    [anon_sym___thread] = ACTIONS(2893),
    [anon_sym_const] = ACTIONS(2893),
    [anon_sym_constexpr] = ACTIONS(2893),
    [anon_sym_volatile] = ACTIONS(2893),
    [anon_sym_restrict] = ACTIONS(2893),
    [anon_sym___restrict__] = ACTIONS(2893),
    [anon_sym__Atomic] = ACTIONS(2893),
    [anon_sym__Noreturn] = ACTIONS(2893),
    [anon_sym_noreturn] = ACTIONS(2893),
    [anon_sym_mutable] = ACTIONS(2893),
    [anon_sym_constinit] = ACTIONS(2893),
    [anon_sym_consteval] = ACTIONS(2893),
    [anon_sym_PROGMEM] = ACTIONS(2893),
    [aux_sym_primitive_type_token1] = ACTIONS(2893),
    [anon_sym_byte] = ACTIONS(2893),
    [anon_sym_word] = ACTIONS(2893),
    [anon_sym_enum] = ACTIONS(2893),
    [anon_sym_class] = ACTIONS(2893),
    [anon_sym_struct] = ACTIONS(2893),
    [anon_sym_union] = ACTIONS(2893),
    [anon_sym_if] = ACTIONS(2893),
    [anon_sym_switch] = ACTIONS(2893),
    [anon_sym_case] = ACTIONS(2893),
    [anon_sym_default] = ACTIONS(2893),
    [anon_sym_while] = ACTIONS(2893),
    [anon_sym_do] = ACTIONS(2893),
    [anon_sym_for] = ACTIONS(2893),
    [anon_sym_return] = ACTIONS(2893),
    [anon_sym_break] = ACTIONS(2893),
    [anon_sym_continue] = ACTIONS(2893),
    [anon_sym_goto] = ACTIONS(2893),
    [anon_sym___try] = ACTIONS(2893),
    [anon_sym___leave] = ACTIONS(2893),
    [anon_sym_not] = ACTIONS(2893),
    [anon_sym_compl] = ACTIONS(2893),
    [anon_sym_DASH_DASH] = ACTIONS(2895),
    [anon_sym_PLUS_PLUS] = ACTIONS(2895),
    [anon_sym_sizeof] = ACTIONS(2893),
    [anon_sym___alignof__] = ACTIONS(2893),
    [anon_sym___alignof] = ACTIONS(2893),
    [anon_sym__alignof] = ACTIONS(2893),
    [anon_sym_alignof] = ACTIONS(2893),
    [anon_sym__Alignof] = ACTIONS(2893),
    [anon_sym_offsetof] = ACTIONS(2893),
    [anon_sym__Generic] = ACTIONS(2893),
    [anon_sym_asm] = ACTIONS(2893),
    [anon_sym___asm__] = ACTIONS(2893),
    [aux_sym_number_literal_token1] = ACTIONS(2895),
    [aux_sym_number_literal_token2] = ACTIONS(2893),
    [anon_sym_L_SQUOTE] = ACTIONS(2895),
    [anon_sym_u_SQUOTE] = ACTIONS(2895),
    [anon_sym_U_SQUOTE] = ACTIONS(2895),
    [anon_sym_u8_SQUOTE] = ACTIONS(2895),
    [anon_sym_SQUOTE] = ACTIONS(2895),
    [anon_sym_L_DQUOTE] = ACTIONS(2895),
    [anon_sym_u_DQUOTE] = ACTIONS(2895),
    [anon_sym_U_DQUOTE] = ACTIONS(2895),
    [anon_sym_u8_DQUOTE] = ACTIONS(2895),
    [anon_sym_DQUOTE] = ACTIONS(2895),
    [sym_true] = ACTIONS(2893),
    [sym_false] = ACTIONS(2893),
    [anon_sym_NULL] = ACTIONS(2893),
    [anon_sym_nullptr] = ACTIONS(2893),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2893),
    [anon_sym_decltype] = ACTIONS(2893),
    [anon_sym_virtual] = ACTIONS(2893),
    [anon_sym_alignas] = ACTIONS(2893),
    [anon_sym_explicit] = ACTIONS(2893),
    [anon_sym_typename] = ACTIONS(2893),
    [anon_sym_template] = ACTIONS(2893),
    [anon_sym_operator] = ACTIONS(2893),
    [anon_sym_try] = ACTIONS(2893),
    [anon_sym_delete] = ACTIONS(2893),
    [anon_sym_throw] = ACTIONS(2893),
    [anon_sym_namespace] = ACTIONS(2893),
    [anon_sym_using] = ACTIONS(2893),
    [anon_sym_static_assert] = ACTIONS(2893),
    [anon_sym_concept] = ACTIONS(2893),
    [anon_sym_co_return] = ACTIONS(2893),
    [anon_sym_co_yield] = ACTIONS(2893),
    [anon_sym_R_DQUOTE] = ACTIONS(2895),
    [anon_sym_LR_DQUOTE] = ACTIONS(2895),
    [anon_sym_uR_DQUOTE] = ACTIONS(2895),
    [anon_sym_UR_DQUOTE] = ACTIONS(2895),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2895),
    [anon_sym_co_await] = ACTIONS(2893),
    [anon_sym_new] = ACTIONS(2893),
    [anon_sym_requires] = ACTIONS(2893),
    [sym_this] = ACTIONS(2893),
  },
  [340] = {
    [sym_identifier] = ACTIONS(2893),
    [aux_sym_preproc_include_token1] = ACTIONS(2893),
    [aux_sym_preproc_def_token1] = ACTIONS(2893),
    [aux_sym_preproc_if_token1] = ACTIONS(2893),
    [aux_sym_preproc_if_token2] = ACTIONS(2893),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2893),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2893),
    [aux_sym_preproc_else_token1] = ACTIONS(2893),
    [aux_sym_preproc_elif_token1] = ACTIONS(2893),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2893),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2893),
    [sym_preproc_directive] = ACTIONS(2893),
    [anon_sym_LPAREN2] = ACTIONS(2895),
    [anon_sym_BANG] = ACTIONS(2895),
    [anon_sym_TILDE] = ACTIONS(2895),
    [anon_sym_DASH] = ACTIONS(2893),
    [anon_sym_PLUS] = ACTIONS(2893),
    [anon_sym_STAR] = ACTIONS(2895),
    [anon_sym_AMP_AMP] = ACTIONS(2895),
    [anon_sym_AMP] = ACTIONS(2893),
    [anon_sym_SEMI] = ACTIONS(2895),
    [anon_sym___extension__] = ACTIONS(2893),
    [anon_sym_typedef] = ACTIONS(2893),
    [anon_sym_extern] = ACTIONS(2893),
    [anon_sym___attribute__] = ACTIONS(2893),
    [anon_sym_COLON_COLON] = ACTIONS(2895),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2895),
    [anon_sym___declspec] = ACTIONS(2893),
    [anon_sym___based] = ACTIONS(2893),
    [anon_sym___cdecl] = ACTIONS(2893),
    [anon_sym___clrcall] = ACTIONS(2893),
    [anon_sym___stdcall] = ACTIONS(2893),
    [anon_sym___fastcall] = ACTIONS(2893),
    [anon_sym___thiscall] = ACTIONS(2893),
    [anon_sym___vectorcall] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(2895),
    [anon_sym_signed] = ACTIONS(2893),
    [anon_sym_unsigned] = ACTIONS(2893),
    [anon_sym_long] = ACTIONS(2893),
    [anon_sym_short] = ACTIONS(2893),
    [anon_sym_LBRACK] = ACTIONS(2893),
    [anon_sym_static] = ACTIONS(2893),
    [anon_sym_register] = ACTIONS(2893),
    [anon_sym_inline] = ACTIONS(2893),
    [anon_sym___inline] = ACTIONS(2893),
    [anon_sym___inline__] = ACTIONS(2893),
    [anon_sym___forceinline] = ACTIONS(2893),
    [anon_sym_thread_local] = ACTIONS(2893),
    [anon_sym___thread] = ACTIONS(2893),
    [anon_sym_const] = ACTIONS(2893),
    [anon_sym_constexpr] = ACTIONS(2893),
    [anon_sym_volatile] = ACTIONS(2893),
    [anon_sym_restrict] = ACTIONS(2893),
    [anon_sym___restrict__] = ACTIONS(2893),
    [anon_sym__Atomic] = ACTIONS(2893),
    [anon_sym__Noreturn] = ACTIONS(2893),
    [anon_sym_noreturn] = ACTIONS(2893),
    [anon_sym_mutable] = ACTIONS(2893),
    [anon_sym_constinit] = ACTIONS(2893),
    [anon_sym_consteval] = ACTIONS(2893),
    [anon_sym_PROGMEM] = ACTIONS(2893),
    [aux_sym_primitive_type_token1] = ACTIONS(2893),
    [anon_sym_byte] = ACTIONS(2893),
    [anon_sym_word] = ACTIONS(2893),
    [anon_sym_enum] = ACTIONS(2893),
    [anon_sym_class] = ACTIONS(2893),
    [anon_sym_struct] = ACTIONS(2893),
    [anon_sym_union] = ACTIONS(2893),
    [anon_sym_if] = ACTIONS(2893),
    [anon_sym_switch] = ACTIONS(2893),
    [anon_sym_case] = ACTIONS(2893),
    [anon_sym_default] = ACTIONS(2893),
    [anon_sym_while] = ACTIONS(2893),
    [anon_sym_do] = ACTIONS(2893),
    [anon_sym_for] = ACTIONS(2893),
    [anon_sym_return] = ACTIONS(2893),
    [anon_sym_break] = ACTIONS(2893),
    [anon_sym_continue] = ACTIONS(2893),
    [anon_sym_goto] = ACTIONS(2893),
    [anon_sym___try] = ACTIONS(2893),
    [anon_sym___leave] = ACTIONS(2893),
    [anon_sym_not] = ACTIONS(2893),
    [anon_sym_compl] = ACTIONS(2893),
    [anon_sym_DASH_DASH] = ACTIONS(2895),
    [anon_sym_PLUS_PLUS] = ACTIONS(2895),
    [anon_sym_sizeof] = ACTIONS(2893),
    [anon_sym___alignof__] = ACTIONS(2893),
    [anon_sym___alignof] = ACTIONS(2893),
    [anon_sym__alignof] = ACTIONS(2893),
    [anon_sym_alignof] = ACTIONS(2893),
    [anon_sym__Alignof] = ACTIONS(2893),
    [anon_sym_offsetof] = ACTIONS(2893),
    [anon_sym__Generic] = ACTIONS(2893),
    [anon_sym_asm] = ACTIONS(2893),
    [anon_sym___asm__] = ACTIONS(2893),
    [aux_sym_number_literal_token1] = ACTIONS(2895),
    [aux_sym_number_literal_token2] = ACTIONS(2893),
    [anon_sym_L_SQUOTE] = ACTIONS(2895),
    [anon_sym_u_SQUOTE] = ACTIONS(2895),
    [anon_sym_U_SQUOTE] = ACTIONS(2895),
    [anon_sym_u8_SQUOTE] = ACTIONS(2895),
    [anon_sym_SQUOTE] = ACTIONS(2895),
    [anon_sym_L_DQUOTE] = ACTIONS(2895),
    [anon_sym_u_DQUOTE] = ACTIONS(2895),
    [anon_sym_U_DQUOTE] = ACTIONS(2895),
    [anon_sym_u8_DQUOTE] = ACTIONS(2895),
    [anon_sym_DQUOTE] = ACTIONS(2895),
    [sym_true] = ACTIONS(2893),
    [sym_false] = ACTIONS(2893),
    [anon_sym_NULL] = ACTIONS(2893),
    [anon_sym_nullptr] = ACTIONS(2893),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2893),
    [anon_sym_decltype] = ACTIONS(2893),
    [anon_sym_virtual] = ACTIONS(2893),
    [anon_sym_alignas] = ACTIONS(2893),
    [anon_sym_explicit] = ACTIONS(2893),
    [anon_sym_typename] = ACTIONS(2893),
    [anon_sym_template] = ACTIONS(2893),
    [anon_sym_operator] = ACTIONS(2893),
    [anon_sym_try] = ACTIONS(2893),
    [anon_sym_delete] = ACTIONS(2893),
    [anon_sym_throw] = ACTIONS(2893),
    [anon_sym_namespace] = ACTIONS(2893),
    [anon_sym_using] = ACTIONS(2893),
    [anon_sym_static_assert] = ACTIONS(2893),
    [anon_sym_concept] = ACTIONS(2893),
    [anon_sym_co_return] = ACTIONS(2893),
    [anon_sym_co_yield] = ACTIONS(2893),
    [anon_sym_R_DQUOTE] = ACTIONS(2895),
    [anon_sym_LR_DQUOTE] = ACTIONS(2895),
    [anon_sym_uR_DQUOTE] = ACTIONS(2895),
    [anon_sym_UR_DQUOTE] = ACTIONS(2895),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2895),
    [anon_sym_co_await] = ACTIONS(2893),
    [anon_sym_new] = ACTIONS(2893),
    [anon_sym_requires] = ACTIONS(2893),
    [sym_this] = ACTIONS(2893),
  },
  [341] = {
    [sym_identifier] = ACTIONS(2897),
    [aux_sym_preproc_include_token1] = ACTIONS(2897),
    [aux_sym_preproc_def_token1] = ACTIONS(2897),
    [aux_sym_preproc_if_token1] = ACTIONS(2897),
    [aux_sym_preproc_if_token2] = ACTIONS(2897),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2897),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2897),
    [aux_sym_preproc_else_token1] = ACTIONS(2897),
    [aux_sym_preproc_elif_token1] = ACTIONS(2897),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2897),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2897),
    [sym_preproc_directive] = ACTIONS(2897),
    [anon_sym_LPAREN2] = ACTIONS(2899),
    [anon_sym_BANG] = ACTIONS(2899),
    [anon_sym_TILDE] = ACTIONS(2899),
    [anon_sym_DASH] = ACTIONS(2897),
    [anon_sym_PLUS] = ACTIONS(2897),
    [anon_sym_STAR] = ACTIONS(2899),
    [anon_sym_AMP_AMP] = ACTIONS(2899),
    [anon_sym_AMP] = ACTIONS(2897),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym___extension__] = ACTIONS(2897),
    [anon_sym_typedef] = ACTIONS(2897),
    [anon_sym_extern] = ACTIONS(2897),
    [anon_sym___attribute__] = ACTIONS(2897),
    [anon_sym_COLON_COLON] = ACTIONS(2899),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2899),
    [anon_sym___declspec] = ACTIONS(2897),
    [anon_sym___based] = ACTIONS(2897),
    [anon_sym___cdecl] = ACTIONS(2897),
    [anon_sym___clrcall] = ACTIONS(2897),
    [anon_sym___stdcall] = ACTIONS(2897),
    [anon_sym___fastcall] = ACTIONS(2897),
    [anon_sym___thiscall] = ACTIONS(2897),
    [anon_sym___vectorcall] = ACTIONS(2897),
    [anon_sym_LBRACE] = ACTIONS(2899),
    [anon_sym_signed] = ACTIONS(2897),
    [anon_sym_unsigned] = ACTIONS(2897),
    [anon_sym_long] = ACTIONS(2897),
    [anon_sym_short] = ACTIONS(2897),
    [anon_sym_LBRACK] = ACTIONS(2897),
    [anon_sym_static] = ACTIONS(2897),
    [anon_sym_register] = ACTIONS(2897),
    [anon_sym_inline] = ACTIONS(2897),
    [anon_sym___inline] = ACTIONS(2897),
    [anon_sym___inline__] = ACTIONS(2897),
    [anon_sym___forceinline] = ACTIONS(2897),
    [anon_sym_thread_local] = ACTIONS(2897),
    [anon_sym___thread] = ACTIONS(2897),
    [anon_sym_const] = ACTIONS(2897),
    [anon_sym_constexpr] = ACTIONS(2897),
    [anon_sym_volatile] = ACTIONS(2897),
    [anon_sym_restrict] = ACTIONS(2897),
    [anon_sym___restrict__] = ACTIONS(2897),
    [anon_sym__Atomic] = ACTIONS(2897),
    [anon_sym__Noreturn] = ACTIONS(2897),
    [anon_sym_noreturn] = ACTIONS(2897),
    [anon_sym_mutable] = ACTIONS(2897),
    [anon_sym_constinit] = ACTIONS(2897),
    [anon_sym_consteval] = ACTIONS(2897),
    [anon_sym_PROGMEM] = ACTIONS(2897),
    [aux_sym_primitive_type_token1] = ACTIONS(2897),
    [anon_sym_byte] = ACTIONS(2897),
    [anon_sym_word] = ACTIONS(2897),
    [anon_sym_enum] = ACTIONS(2897),
    [anon_sym_class] = ACTIONS(2897),
    [anon_sym_struct] = ACTIONS(2897),
    [anon_sym_union] = ACTIONS(2897),
    [anon_sym_if] = ACTIONS(2897),
    [anon_sym_switch] = ACTIONS(2897),
    [anon_sym_case] = ACTIONS(2897),
    [anon_sym_default] = ACTIONS(2897),
    [anon_sym_while] = ACTIONS(2897),
    [anon_sym_do] = ACTIONS(2897),
    [anon_sym_for] = ACTIONS(2897),
    [anon_sym_return] = ACTIONS(2897),
    [anon_sym_break] = ACTIONS(2897),
    [anon_sym_continue] = ACTIONS(2897),
    [anon_sym_goto] = ACTIONS(2897),
    [anon_sym___try] = ACTIONS(2897),
    [anon_sym___leave] = ACTIONS(2897),
    [anon_sym_not] = ACTIONS(2897),
    [anon_sym_compl] = ACTIONS(2897),
    [anon_sym_DASH_DASH] = ACTIONS(2899),
    [anon_sym_PLUS_PLUS] = ACTIONS(2899),
    [anon_sym_sizeof] = ACTIONS(2897),
    [anon_sym___alignof__] = ACTIONS(2897),
    [anon_sym___alignof] = ACTIONS(2897),
    [anon_sym__alignof] = ACTIONS(2897),
    [anon_sym_alignof] = ACTIONS(2897),
    [anon_sym__Alignof] = ACTIONS(2897),
    [anon_sym_offsetof] = ACTIONS(2897),
    [anon_sym__Generic] = ACTIONS(2897),
    [anon_sym_asm] = ACTIONS(2897),
    [anon_sym___asm__] = ACTIONS(2897),
    [aux_sym_number_literal_token1] = ACTIONS(2899),
    [aux_sym_number_literal_token2] = ACTIONS(2897),
    [anon_sym_L_SQUOTE] = ACTIONS(2899),
    [anon_sym_u_SQUOTE] = ACTIONS(2899),
    [anon_sym_U_SQUOTE] = ACTIONS(2899),
    [anon_sym_u8_SQUOTE] = ACTIONS(2899),
    [anon_sym_SQUOTE] = ACTIONS(2899),
    [anon_sym_L_DQUOTE] = ACTIONS(2899),
    [anon_sym_u_DQUOTE] = ACTIONS(2899),
    [anon_sym_U_DQUOTE] = ACTIONS(2899),
    [anon_sym_u8_DQUOTE] = ACTIONS(2899),
    [anon_sym_DQUOTE] = ACTIONS(2899),
    [sym_true] = ACTIONS(2897),
    [sym_false] = ACTIONS(2897),
    [anon_sym_NULL] = ACTIONS(2897),
    [anon_sym_nullptr] = ACTIONS(2897),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2897),
    [anon_sym_decltype] = ACTIONS(2897),
    [anon_sym_virtual] = ACTIONS(2897),
    [anon_sym_alignas] = ACTIONS(2897),
    [anon_sym_explicit] = ACTIONS(2897),
    [anon_sym_typename] = ACTIONS(2897),
    [anon_sym_template] = ACTIONS(2897),
    [anon_sym_operator] = ACTIONS(2897),
    [anon_sym_try] = ACTIONS(2897),
    [anon_sym_delete] = ACTIONS(2897),
    [anon_sym_throw] = ACTIONS(2897),
    [anon_sym_namespace] = ACTIONS(2897),
    [anon_sym_using] = ACTIONS(2897),
    [anon_sym_static_assert] = ACTIONS(2897),
    [anon_sym_concept] = ACTIONS(2897),
    [anon_sym_co_return] = ACTIONS(2897),
    [anon_sym_co_yield] = ACTIONS(2897),
    [anon_sym_R_DQUOTE] = ACTIONS(2899),
    [anon_sym_LR_DQUOTE] = ACTIONS(2899),
    [anon_sym_uR_DQUOTE] = ACTIONS(2899),
    [anon_sym_UR_DQUOTE] = ACTIONS(2899),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2899),
    [anon_sym_co_await] = ACTIONS(2897),
    [anon_sym_new] = ACTIONS(2897),
    [anon_sym_requires] = ACTIONS(2897),
    [sym_this] = ACTIONS(2897),
  },
  [342] = {
    [sym_identifier] = ACTIONS(2901),
    [aux_sym_preproc_include_token1] = ACTIONS(2901),
    [aux_sym_preproc_def_token1] = ACTIONS(2901),
    [aux_sym_preproc_if_token1] = ACTIONS(2901),
    [aux_sym_preproc_if_token2] = ACTIONS(2901),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2901),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2901),
    [aux_sym_preproc_else_token1] = ACTIONS(2901),
    [aux_sym_preproc_elif_token1] = ACTIONS(2901),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2901),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2901),
    [sym_preproc_directive] = ACTIONS(2901),
    [anon_sym_LPAREN2] = ACTIONS(2903),
    [anon_sym_BANG] = ACTIONS(2903),
    [anon_sym_TILDE] = ACTIONS(2903),
    [anon_sym_DASH] = ACTIONS(2901),
    [anon_sym_PLUS] = ACTIONS(2901),
    [anon_sym_STAR] = ACTIONS(2903),
    [anon_sym_AMP_AMP] = ACTIONS(2903),
    [anon_sym_AMP] = ACTIONS(2901),
    [anon_sym_SEMI] = ACTIONS(2903),
    [anon_sym___extension__] = ACTIONS(2901),
    [anon_sym_typedef] = ACTIONS(2901),
    [anon_sym_extern] = ACTIONS(2901),
    [anon_sym___attribute__] = ACTIONS(2901),
    [anon_sym_COLON_COLON] = ACTIONS(2903),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2903),
    [anon_sym___declspec] = ACTIONS(2901),
    [anon_sym___based] = ACTIONS(2901),
    [anon_sym___cdecl] = ACTIONS(2901),
    [anon_sym___clrcall] = ACTIONS(2901),
    [anon_sym___stdcall] = ACTIONS(2901),
    [anon_sym___fastcall] = ACTIONS(2901),
    [anon_sym___thiscall] = ACTIONS(2901),
    [anon_sym___vectorcall] = ACTIONS(2901),
    [anon_sym_LBRACE] = ACTIONS(2903),
    [anon_sym_signed] = ACTIONS(2901),
    [anon_sym_unsigned] = ACTIONS(2901),
    [anon_sym_long] = ACTIONS(2901),
    [anon_sym_short] = ACTIONS(2901),
    [anon_sym_LBRACK] = ACTIONS(2901),
    [anon_sym_static] = ACTIONS(2901),
    [anon_sym_register] = ACTIONS(2901),
    [anon_sym_inline] = ACTIONS(2901),
    [anon_sym___inline] = ACTIONS(2901),
    [anon_sym___inline__] = ACTIONS(2901),
    [anon_sym___forceinline] = ACTIONS(2901),
    [anon_sym_thread_local] = ACTIONS(2901),
    [anon_sym___thread] = ACTIONS(2901),
    [anon_sym_const] = ACTIONS(2901),
    [anon_sym_constexpr] = ACTIONS(2901),
    [anon_sym_volatile] = ACTIONS(2901),
    [anon_sym_restrict] = ACTIONS(2901),
    [anon_sym___restrict__] = ACTIONS(2901),
    [anon_sym__Atomic] = ACTIONS(2901),
    [anon_sym__Noreturn] = ACTIONS(2901),
    [anon_sym_noreturn] = ACTIONS(2901),
    [anon_sym_mutable] = ACTIONS(2901),
    [anon_sym_constinit] = ACTIONS(2901),
    [anon_sym_consteval] = ACTIONS(2901),
    [anon_sym_PROGMEM] = ACTIONS(2901),
    [aux_sym_primitive_type_token1] = ACTIONS(2901),
    [anon_sym_byte] = ACTIONS(2901),
    [anon_sym_word] = ACTIONS(2901),
    [anon_sym_enum] = ACTIONS(2901),
    [anon_sym_class] = ACTIONS(2901),
    [anon_sym_struct] = ACTIONS(2901),
    [anon_sym_union] = ACTIONS(2901),
    [anon_sym_if] = ACTIONS(2901),
    [anon_sym_switch] = ACTIONS(2901),
    [anon_sym_case] = ACTIONS(2901),
    [anon_sym_default] = ACTIONS(2901),
    [anon_sym_while] = ACTIONS(2901),
    [anon_sym_do] = ACTIONS(2901),
    [anon_sym_for] = ACTIONS(2901),
    [anon_sym_return] = ACTIONS(2901),
    [anon_sym_break] = ACTIONS(2901),
    [anon_sym_continue] = ACTIONS(2901),
    [anon_sym_goto] = ACTIONS(2901),
    [anon_sym___try] = ACTIONS(2901),
    [anon_sym___leave] = ACTIONS(2901),
    [anon_sym_not] = ACTIONS(2901),
    [anon_sym_compl] = ACTIONS(2901),
    [anon_sym_DASH_DASH] = ACTIONS(2903),
    [anon_sym_PLUS_PLUS] = ACTIONS(2903),
    [anon_sym_sizeof] = ACTIONS(2901),
    [anon_sym___alignof__] = ACTIONS(2901),
    [anon_sym___alignof] = ACTIONS(2901),
    [anon_sym__alignof] = ACTIONS(2901),
    [anon_sym_alignof] = ACTIONS(2901),
    [anon_sym__Alignof] = ACTIONS(2901),
    [anon_sym_offsetof] = ACTIONS(2901),
    [anon_sym__Generic] = ACTIONS(2901),
    [anon_sym_asm] = ACTIONS(2901),
    [anon_sym___asm__] = ACTIONS(2901),
    [aux_sym_number_literal_token1] = ACTIONS(2903),
    [aux_sym_number_literal_token2] = ACTIONS(2901),
    [anon_sym_L_SQUOTE] = ACTIONS(2903),
    [anon_sym_u_SQUOTE] = ACTIONS(2903),
    [anon_sym_U_SQUOTE] = ACTIONS(2903),
    [anon_sym_u8_SQUOTE] = ACTIONS(2903),
    [anon_sym_SQUOTE] = ACTIONS(2903),
    [anon_sym_L_DQUOTE] = ACTIONS(2903),
    [anon_sym_u_DQUOTE] = ACTIONS(2903),
    [anon_sym_U_DQUOTE] = ACTIONS(2903),
    [anon_sym_u8_DQUOTE] = ACTIONS(2903),
    [anon_sym_DQUOTE] = ACTIONS(2903),
    [sym_true] = ACTIONS(2901),
    [sym_false] = ACTIONS(2901),
    [anon_sym_NULL] = ACTIONS(2901),
    [anon_sym_nullptr] = ACTIONS(2901),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2901),
    [anon_sym_decltype] = ACTIONS(2901),
    [anon_sym_virtual] = ACTIONS(2901),
    [anon_sym_alignas] = ACTIONS(2901),
    [anon_sym_explicit] = ACTIONS(2901),
    [anon_sym_typename] = ACTIONS(2901),
    [anon_sym_template] = ACTIONS(2901),
    [anon_sym_operator] = ACTIONS(2901),
    [anon_sym_try] = ACTIONS(2901),
    [anon_sym_delete] = ACTIONS(2901),
    [anon_sym_throw] = ACTIONS(2901),
    [anon_sym_namespace] = ACTIONS(2901),
    [anon_sym_using] = ACTIONS(2901),
    [anon_sym_static_assert] = ACTIONS(2901),
    [anon_sym_concept] = ACTIONS(2901),
    [anon_sym_co_return] = ACTIONS(2901),
    [anon_sym_co_yield] = ACTIONS(2901),
    [anon_sym_R_DQUOTE] = ACTIONS(2903),
    [anon_sym_LR_DQUOTE] = ACTIONS(2903),
    [anon_sym_uR_DQUOTE] = ACTIONS(2903),
    [anon_sym_UR_DQUOTE] = ACTIONS(2903),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2903),
    [anon_sym_co_await] = ACTIONS(2901),
    [anon_sym_new] = ACTIONS(2901),
    [anon_sym_requires] = ACTIONS(2901),
    [sym_this] = ACTIONS(2901),
  },
  [343] = {
    [sym_identifier] = ACTIONS(2905),
    [aux_sym_preproc_include_token1] = ACTIONS(2905),
    [aux_sym_preproc_def_token1] = ACTIONS(2905),
    [aux_sym_preproc_if_token1] = ACTIONS(2905),
    [aux_sym_preproc_if_token2] = ACTIONS(2905),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2905),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2905),
    [aux_sym_preproc_else_token1] = ACTIONS(2905),
    [aux_sym_preproc_elif_token1] = ACTIONS(2905),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2905),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2905),
    [sym_preproc_directive] = ACTIONS(2905),
    [anon_sym_LPAREN2] = ACTIONS(2907),
    [anon_sym_BANG] = ACTIONS(2907),
    [anon_sym_TILDE] = ACTIONS(2907),
    [anon_sym_DASH] = ACTIONS(2905),
    [anon_sym_PLUS] = ACTIONS(2905),
    [anon_sym_STAR] = ACTIONS(2907),
    [anon_sym_AMP_AMP] = ACTIONS(2907),
    [anon_sym_AMP] = ACTIONS(2905),
    [anon_sym_SEMI] = ACTIONS(2907),
    [anon_sym___extension__] = ACTIONS(2905),
    [anon_sym_typedef] = ACTIONS(2905),
    [anon_sym_extern] = ACTIONS(2905),
    [anon_sym___attribute__] = ACTIONS(2905),
    [anon_sym_COLON_COLON] = ACTIONS(2907),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2907),
    [anon_sym___declspec] = ACTIONS(2905),
    [anon_sym___based] = ACTIONS(2905),
    [anon_sym___cdecl] = ACTIONS(2905),
    [anon_sym___clrcall] = ACTIONS(2905),
    [anon_sym___stdcall] = ACTIONS(2905),
    [anon_sym___fastcall] = ACTIONS(2905),
    [anon_sym___thiscall] = ACTIONS(2905),
    [anon_sym___vectorcall] = ACTIONS(2905),
    [anon_sym_LBRACE] = ACTIONS(2907),
    [anon_sym_signed] = ACTIONS(2905),
    [anon_sym_unsigned] = ACTIONS(2905),
    [anon_sym_long] = ACTIONS(2905),
    [anon_sym_short] = ACTIONS(2905),
    [anon_sym_LBRACK] = ACTIONS(2905),
    [anon_sym_static] = ACTIONS(2905),
    [anon_sym_register] = ACTIONS(2905),
    [anon_sym_inline] = ACTIONS(2905),
    [anon_sym___inline] = ACTIONS(2905),
    [anon_sym___inline__] = ACTIONS(2905),
    [anon_sym___forceinline] = ACTIONS(2905),
    [anon_sym_thread_local] = ACTIONS(2905),
    [anon_sym___thread] = ACTIONS(2905),
    [anon_sym_const] = ACTIONS(2905),
    [anon_sym_constexpr] = ACTIONS(2905),
    [anon_sym_volatile] = ACTIONS(2905),
    [anon_sym_restrict] = ACTIONS(2905),
    [anon_sym___restrict__] = ACTIONS(2905),
    [anon_sym__Atomic] = ACTIONS(2905),
    [anon_sym__Noreturn] = ACTIONS(2905),
    [anon_sym_noreturn] = ACTIONS(2905),
    [anon_sym_mutable] = ACTIONS(2905),
    [anon_sym_constinit] = ACTIONS(2905),
    [anon_sym_consteval] = ACTIONS(2905),
    [anon_sym_PROGMEM] = ACTIONS(2905),
    [aux_sym_primitive_type_token1] = ACTIONS(2905),
    [anon_sym_byte] = ACTIONS(2905),
    [anon_sym_word] = ACTIONS(2905),
    [anon_sym_enum] = ACTIONS(2905),
    [anon_sym_class] = ACTIONS(2905),
    [anon_sym_struct] = ACTIONS(2905),
    [anon_sym_union] = ACTIONS(2905),
    [anon_sym_if] = ACTIONS(2905),
    [anon_sym_switch] = ACTIONS(2905),
    [anon_sym_case] = ACTIONS(2905),
    [anon_sym_default] = ACTIONS(2905),
    [anon_sym_while] = ACTIONS(2905),
    [anon_sym_do] = ACTIONS(2905),
    [anon_sym_for] = ACTIONS(2905),
    [anon_sym_return] = ACTIONS(2905),
    [anon_sym_break] = ACTIONS(2905),
    [anon_sym_continue] = ACTIONS(2905),
    [anon_sym_goto] = ACTIONS(2905),
    [anon_sym___try] = ACTIONS(2905),
    [anon_sym___leave] = ACTIONS(2905),
    [anon_sym_not] = ACTIONS(2905),
    [anon_sym_compl] = ACTIONS(2905),
    [anon_sym_DASH_DASH] = ACTIONS(2907),
    [anon_sym_PLUS_PLUS] = ACTIONS(2907),
    [anon_sym_sizeof] = ACTIONS(2905),
    [anon_sym___alignof__] = ACTIONS(2905),
    [anon_sym___alignof] = ACTIONS(2905),
    [anon_sym__alignof] = ACTIONS(2905),
    [anon_sym_alignof] = ACTIONS(2905),
    [anon_sym__Alignof] = ACTIONS(2905),
    [anon_sym_offsetof] = ACTIONS(2905),
    [anon_sym__Generic] = ACTIONS(2905),
    [anon_sym_asm] = ACTIONS(2905),
    [anon_sym___asm__] = ACTIONS(2905),
    [aux_sym_number_literal_token1] = ACTIONS(2907),
    [aux_sym_number_literal_token2] = ACTIONS(2905),
    [anon_sym_L_SQUOTE] = ACTIONS(2907),
    [anon_sym_u_SQUOTE] = ACTIONS(2907),
    [anon_sym_U_SQUOTE] = ACTIONS(2907),
    [anon_sym_u8_SQUOTE] = ACTIONS(2907),
    [anon_sym_SQUOTE] = ACTIONS(2907),
    [anon_sym_L_DQUOTE] = ACTIONS(2907),
    [anon_sym_u_DQUOTE] = ACTIONS(2907),
    [anon_sym_U_DQUOTE] = ACTIONS(2907),
    [anon_sym_u8_DQUOTE] = ACTIONS(2907),
    [anon_sym_DQUOTE] = ACTIONS(2907),
    [sym_true] = ACTIONS(2905),
    [sym_false] = ACTIONS(2905),
    [anon_sym_NULL] = ACTIONS(2905),
    [anon_sym_nullptr] = ACTIONS(2905),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2905),
    [anon_sym_decltype] = ACTIONS(2905),
    [anon_sym_virtual] = ACTIONS(2905),
    [anon_sym_alignas] = ACTIONS(2905),
    [anon_sym_explicit] = ACTIONS(2905),
    [anon_sym_typename] = ACTIONS(2905),
    [anon_sym_template] = ACTIONS(2905),
    [anon_sym_operator] = ACTIONS(2905),
    [anon_sym_try] = ACTIONS(2905),
    [anon_sym_delete] = ACTIONS(2905),
    [anon_sym_throw] = ACTIONS(2905),
    [anon_sym_namespace] = ACTIONS(2905),
    [anon_sym_using] = ACTIONS(2905),
    [anon_sym_static_assert] = ACTIONS(2905),
    [anon_sym_concept] = ACTIONS(2905),
    [anon_sym_co_return] = ACTIONS(2905),
    [anon_sym_co_yield] = ACTIONS(2905),
    [anon_sym_R_DQUOTE] = ACTIONS(2907),
    [anon_sym_LR_DQUOTE] = ACTIONS(2907),
    [anon_sym_uR_DQUOTE] = ACTIONS(2907),
    [anon_sym_UR_DQUOTE] = ACTIONS(2907),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2907),
    [anon_sym_co_await] = ACTIONS(2905),
    [anon_sym_new] = ACTIONS(2905),
    [anon_sym_requires] = ACTIONS(2905),
    [sym_this] = ACTIONS(2905),
  },
  [344] = {
    [sym_catch_clause] = STATE(395),
    [aux_sym_constructor_try_statement_repeat1] = STATE(395),
    [sym_identifier] = ACTIONS(2482),
    [aux_sym_preproc_include_token1] = ACTIONS(2482),
    [aux_sym_preproc_def_token1] = ACTIONS(2482),
    [aux_sym_preproc_if_token1] = ACTIONS(2482),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2482),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2482),
    [sym_preproc_directive] = ACTIONS(2482),
    [anon_sym_LPAREN2] = ACTIONS(2484),
    [anon_sym_BANG] = ACTIONS(2484),
    [anon_sym_TILDE] = ACTIONS(2484),
    [anon_sym_DASH] = ACTIONS(2482),
    [anon_sym_PLUS] = ACTIONS(2482),
    [anon_sym_STAR] = ACTIONS(2484),
    [anon_sym_AMP_AMP] = ACTIONS(2484),
    [anon_sym_AMP] = ACTIONS(2482),
    [anon_sym_SEMI] = ACTIONS(2484),
    [anon_sym___extension__] = ACTIONS(2482),
    [anon_sym_typedef] = ACTIONS(2482),
    [anon_sym_extern] = ACTIONS(2482),
    [anon_sym___attribute__] = ACTIONS(2482),
    [anon_sym_COLON_COLON] = ACTIONS(2484),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2484),
    [anon_sym___declspec] = ACTIONS(2482),
    [anon_sym___based] = ACTIONS(2482),
    [anon_sym___cdecl] = ACTIONS(2482),
    [anon_sym___clrcall] = ACTIONS(2482),
    [anon_sym___stdcall] = ACTIONS(2482),
    [anon_sym___fastcall] = ACTIONS(2482),
    [anon_sym___thiscall] = ACTIONS(2482),
    [anon_sym___vectorcall] = ACTIONS(2482),
    [anon_sym_LBRACE] = ACTIONS(2484),
    [anon_sym_RBRACE] = ACTIONS(2484),
    [anon_sym_signed] = ACTIONS(2482),
    [anon_sym_unsigned] = ACTIONS(2482),
    [anon_sym_long] = ACTIONS(2482),
    [anon_sym_short] = ACTIONS(2482),
    [anon_sym_LBRACK] = ACTIONS(2482),
    [anon_sym_static] = ACTIONS(2482),
    [anon_sym_register] = ACTIONS(2482),
    [anon_sym_inline] = ACTIONS(2482),
    [anon_sym___inline] = ACTIONS(2482),
    [anon_sym___inline__] = ACTIONS(2482),
    [anon_sym___forceinline] = ACTIONS(2482),
    [anon_sym_thread_local] = ACTIONS(2482),
    [anon_sym___thread] = ACTIONS(2482),
    [anon_sym_const] = ACTIONS(2482),
    [anon_sym_constexpr] = ACTIONS(2482),
    [anon_sym_volatile] = ACTIONS(2482),
    [anon_sym_restrict] = ACTIONS(2482),
    [anon_sym___restrict__] = ACTIONS(2482),
    [anon_sym__Atomic] = ACTIONS(2482),
    [anon_sym__Noreturn] = ACTIONS(2482),
    [anon_sym_noreturn] = ACTIONS(2482),
    [anon_sym_mutable] = ACTIONS(2482),
    [anon_sym_constinit] = ACTIONS(2482),
    [anon_sym_consteval] = ACTIONS(2482),
    [anon_sym_PROGMEM] = ACTIONS(2482),
    [aux_sym_primitive_type_token1] = ACTIONS(2482),
    [anon_sym_byte] = ACTIONS(2482),
    [anon_sym_word] = ACTIONS(2482),
    [anon_sym_enum] = ACTIONS(2482),
    [anon_sym_class] = ACTIONS(2482),
    [anon_sym_struct] = ACTIONS(2482),
    [anon_sym_union] = ACTIONS(2482),
    [anon_sym_if] = ACTIONS(2482),
    [anon_sym_else] = ACTIONS(2482),
    [anon_sym_switch] = ACTIONS(2482),
    [anon_sym_case] = ACTIONS(2482),
    [anon_sym_default] = ACTIONS(2482),
    [anon_sym_while] = ACTIONS(2482),
    [anon_sym_do] = ACTIONS(2482),
    [anon_sym_for] = ACTIONS(2482),
    [anon_sym_return] = ACTIONS(2482),
    [anon_sym_break] = ACTIONS(2482),
    [anon_sym_continue] = ACTIONS(2482),
    [anon_sym_goto] = ACTIONS(2482),
    [anon_sym___try] = ACTIONS(2482),
    [anon_sym___leave] = ACTIONS(2482),
    [anon_sym_not] = ACTIONS(2482),
    [anon_sym_compl] = ACTIONS(2482),
    [anon_sym_DASH_DASH] = ACTIONS(2484),
    [anon_sym_PLUS_PLUS] = ACTIONS(2484),
    [anon_sym_sizeof] = ACTIONS(2482),
    [anon_sym___alignof__] = ACTIONS(2482),
    [anon_sym___alignof] = ACTIONS(2482),
    [anon_sym__alignof] = ACTIONS(2482),
    [anon_sym_alignof] = ACTIONS(2482),
    [anon_sym__Alignof] = ACTIONS(2482),
    [anon_sym_offsetof] = ACTIONS(2482),
    [anon_sym__Generic] = ACTIONS(2482),
    [anon_sym_asm] = ACTIONS(2482),
    [anon_sym___asm__] = ACTIONS(2482),
    [aux_sym_number_literal_token1] = ACTIONS(2484),
    [aux_sym_number_literal_token2] = ACTIONS(2482),
    [anon_sym_L_SQUOTE] = ACTIONS(2484),
    [anon_sym_u_SQUOTE] = ACTIONS(2484),
    [anon_sym_U_SQUOTE] = ACTIONS(2484),
    [anon_sym_u8_SQUOTE] = ACTIONS(2484),
    [anon_sym_SQUOTE] = ACTIONS(2484),
    [anon_sym_L_DQUOTE] = ACTIONS(2484),
    [anon_sym_u_DQUOTE] = ACTIONS(2484),
    [anon_sym_U_DQUOTE] = ACTIONS(2484),
    [anon_sym_u8_DQUOTE] = ACTIONS(2484),
    [anon_sym_DQUOTE] = ACTIONS(2484),
    [sym_true] = ACTIONS(2482),
    [sym_false] = ACTIONS(2482),
    [anon_sym_NULL] = ACTIONS(2482),
    [anon_sym_nullptr] = ACTIONS(2482),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2482),
    [anon_sym_decltype] = ACTIONS(2482),
    [anon_sym_virtual] = ACTIONS(2482),
    [anon_sym_alignas] = ACTIONS(2482),
    [anon_sym_explicit] = ACTIONS(2482),
    [anon_sym_typename] = ACTIONS(2482),
    [anon_sym_template] = ACTIONS(2482),
    [anon_sym_operator] = ACTIONS(2482),
    [anon_sym_try] = ACTIONS(2482),
    [anon_sym_delete] = ACTIONS(2482),
    [anon_sym_throw] = ACTIONS(2482),
    [anon_sym_namespace] = ACTIONS(2482),
    [anon_sym_using] = ACTIONS(2482),
    [anon_sym_static_assert] = ACTIONS(2482),
    [anon_sym_concept] = ACTIONS(2482),
    [anon_sym_co_return] = ACTIONS(2482),
    [anon_sym_co_yield] = ACTIONS(2482),
    [anon_sym_catch] = ACTIONS(2909),
    [anon_sym_R_DQUOTE] = ACTIONS(2484),
    [anon_sym_LR_DQUOTE] = ACTIONS(2484),
    [anon_sym_uR_DQUOTE] = ACTIONS(2484),
    [anon_sym_UR_DQUOTE] = ACTIONS(2484),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2484),
    [anon_sym_co_await] = ACTIONS(2482),
    [anon_sym_new] = ACTIONS(2482),
    [anon_sym_requires] = ACTIONS(2482),
    [sym_this] = ACTIONS(2482),
  },
  [345] = {
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_unaligned_ptr_modifier] = STATE(4186),
    [sym_ms_pointer_modifier] = STATE(3271),
    [sym__declarator] = STATE(6279),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6098),
    [sym_array_declarator] = STATE(6098),
    [sym_type_qualifier] = STATE(4051),
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2440),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3290),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5554),
    [sym_qualified_identifier] = STATE(3310),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(2520),
    [aux_sym__type_definition_type_repeat1] = STATE(4051),
    [aux_sym_pointer_declarator_repeat1] = STATE(3271),
    [sym_identifier] = ACTIONS(2911),
    [anon_sym_LPAREN2] = ACTIONS(2913),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_TILDE] = ACTIONS(2915),
    [anon_sym_DASH] = ACTIONS(1931),
    [anon_sym_PLUS] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym___extension__] = ACTIONS(2917),
    [anon_sym_COLON_COLON] = ACTIONS(1935),
    [anon_sym___based] = ACTIONS(47),
    [sym_ms_restrict_modifier] = ACTIONS(2919),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(2919),
    [sym_ms_signed_ptr_modifier] = ACTIONS(2919),
    [anon_sym__unaligned] = ACTIONS(2921),
    [anon_sym___unaligned] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(1829),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_constexpr] = ACTIONS(2917),
    [anon_sym_volatile] = ACTIONS(2917),
    [anon_sym_restrict] = ACTIONS(2917),
    [anon_sym___restrict__] = ACTIONS(2917),
    [anon_sym__Atomic] = ACTIONS(2917),
    [anon_sym__Noreturn] = ACTIONS(2917),
    [anon_sym_noreturn] = ACTIONS(2917),
    [anon_sym_mutable] = ACTIONS(2917),
    [anon_sym_constinit] = ACTIONS(2917),
    [anon_sym_consteval] = ACTIONS(2917),
    [anon_sym_PROGMEM] = ACTIONS(2917),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1931),
    [anon_sym_compl] = ACTIONS(1931),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_sizeof] = ACTIONS(1937),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_operator] = ACTIONS(1871),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [346] = {
    [sym_identifier] = ACTIONS(2925),
    [aux_sym_preproc_include_token1] = ACTIONS(2925),
    [aux_sym_preproc_def_token1] = ACTIONS(2925),
    [aux_sym_preproc_if_token1] = ACTIONS(2925),
    [aux_sym_preproc_if_token2] = ACTIONS(2925),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2925),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2925),
    [aux_sym_preproc_else_token1] = ACTIONS(2925),
    [aux_sym_preproc_elif_token1] = ACTIONS(2925),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2925),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2925),
    [sym_preproc_directive] = ACTIONS(2925),
    [anon_sym_LPAREN2] = ACTIONS(2927),
    [anon_sym_BANG] = ACTIONS(2927),
    [anon_sym_TILDE] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(2925),
    [anon_sym_PLUS] = ACTIONS(2925),
    [anon_sym_STAR] = ACTIONS(2927),
    [anon_sym_AMP_AMP] = ACTIONS(2927),
    [anon_sym_AMP] = ACTIONS(2925),
    [anon_sym_SEMI] = ACTIONS(2927),
    [anon_sym___extension__] = ACTIONS(2925),
    [anon_sym_typedef] = ACTIONS(2925),
    [anon_sym_extern] = ACTIONS(2925),
    [anon_sym___attribute__] = ACTIONS(2925),
    [anon_sym_COLON_COLON] = ACTIONS(2927),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2927),
    [anon_sym___declspec] = ACTIONS(2925),
    [anon_sym___based] = ACTIONS(2925),
    [anon_sym___cdecl] = ACTIONS(2925),
    [anon_sym___clrcall] = ACTIONS(2925),
    [anon_sym___stdcall] = ACTIONS(2925),
    [anon_sym___fastcall] = ACTIONS(2925),
    [anon_sym___thiscall] = ACTIONS(2925),
    [anon_sym___vectorcall] = ACTIONS(2925),
    [anon_sym_LBRACE] = ACTIONS(2927),
    [anon_sym_signed] = ACTIONS(2925),
    [anon_sym_unsigned] = ACTIONS(2925),
    [anon_sym_long] = ACTIONS(2925),
    [anon_sym_short] = ACTIONS(2925),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_static] = ACTIONS(2925),
    [anon_sym_register] = ACTIONS(2925),
    [anon_sym_inline] = ACTIONS(2925),
    [anon_sym___inline] = ACTIONS(2925),
    [anon_sym___inline__] = ACTIONS(2925),
    [anon_sym___forceinline] = ACTIONS(2925),
    [anon_sym_thread_local] = ACTIONS(2925),
    [anon_sym___thread] = ACTIONS(2925),
    [anon_sym_const] = ACTIONS(2925),
    [anon_sym_constexpr] = ACTIONS(2925),
    [anon_sym_volatile] = ACTIONS(2925),
    [anon_sym_restrict] = ACTIONS(2925),
    [anon_sym___restrict__] = ACTIONS(2925),
    [anon_sym__Atomic] = ACTIONS(2925),
    [anon_sym__Noreturn] = ACTIONS(2925),
    [anon_sym_noreturn] = ACTIONS(2925),
    [anon_sym_mutable] = ACTIONS(2925),
    [anon_sym_constinit] = ACTIONS(2925),
    [anon_sym_consteval] = ACTIONS(2925),
    [anon_sym_PROGMEM] = ACTIONS(2925),
    [aux_sym_primitive_type_token1] = ACTIONS(2925),
    [anon_sym_byte] = ACTIONS(2925),
    [anon_sym_word] = ACTIONS(2925),
    [anon_sym_enum] = ACTIONS(2925),
    [anon_sym_class] = ACTIONS(2925),
    [anon_sym_struct] = ACTIONS(2925),
    [anon_sym_union] = ACTIONS(2925),
    [anon_sym_if] = ACTIONS(2925),
    [anon_sym_switch] = ACTIONS(2925),
    [anon_sym_case] = ACTIONS(2925),
    [anon_sym_default] = ACTIONS(2925),
    [anon_sym_while] = ACTIONS(2925),
    [anon_sym_do] = ACTIONS(2925),
    [anon_sym_for] = ACTIONS(2925),
    [anon_sym_return] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(2925),
    [anon_sym_continue] = ACTIONS(2925),
    [anon_sym_goto] = ACTIONS(2925),
    [anon_sym___try] = ACTIONS(2925),
    [anon_sym___leave] = ACTIONS(2925),
    [anon_sym_not] = ACTIONS(2925),
    [anon_sym_compl] = ACTIONS(2925),
    [anon_sym_DASH_DASH] = ACTIONS(2927),
    [anon_sym_PLUS_PLUS] = ACTIONS(2927),
    [anon_sym_sizeof] = ACTIONS(2925),
    [anon_sym___alignof__] = ACTIONS(2925),
    [anon_sym___alignof] = ACTIONS(2925),
    [anon_sym__alignof] = ACTIONS(2925),
    [anon_sym_alignof] = ACTIONS(2925),
    [anon_sym__Alignof] = ACTIONS(2925),
    [anon_sym_offsetof] = ACTIONS(2925),
    [anon_sym__Generic] = ACTIONS(2925),
    [anon_sym_asm] = ACTIONS(2925),
    [anon_sym___asm__] = ACTIONS(2925),
    [aux_sym_number_literal_token1] = ACTIONS(2927),
    [aux_sym_number_literal_token2] = ACTIONS(2925),
    [anon_sym_L_SQUOTE] = ACTIONS(2927),
    [anon_sym_u_SQUOTE] = ACTIONS(2927),
    [anon_sym_U_SQUOTE] = ACTIONS(2927),
    [anon_sym_u8_SQUOTE] = ACTIONS(2927),
    [anon_sym_SQUOTE] = ACTIONS(2927),
    [anon_sym_L_DQUOTE] = ACTIONS(2927),
    [anon_sym_u_DQUOTE] = ACTIONS(2927),
    [anon_sym_U_DQUOTE] = ACTIONS(2927),
    [anon_sym_u8_DQUOTE] = ACTIONS(2927),
    [anon_sym_DQUOTE] = ACTIONS(2927),
    [sym_true] = ACTIONS(2925),
    [sym_false] = ACTIONS(2925),
    [anon_sym_NULL] = ACTIONS(2925),
    [anon_sym_nullptr] = ACTIONS(2925),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2925),
    [anon_sym_decltype] = ACTIONS(2925),
    [anon_sym_virtual] = ACTIONS(2925),
    [anon_sym_alignas] = ACTIONS(2925),
    [anon_sym_explicit] = ACTIONS(2925),
    [anon_sym_typename] = ACTIONS(2925),
    [anon_sym_template] = ACTIONS(2925),
    [anon_sym_operator] = ACTIONS(2925),
    [anon_sym_try] = ACTIONS(2925),
    [anon_sym_delete] = ACTIONS(2925),
    [anon_sym_throw] = ACTIONS(2925),
    [anon_sym_namespace] = ACTIONS(2925),
    [anon_sym_using] = ACTIONS(2925),
    [anon_sym_static_assert] = ACTIONS(2925),
    [anon_sym_concept] = ACTIONS(2925),
    [anon_sym_co_return] = ACTIONS(2925),
    [anon_sym_co_yield] = ACTIONS(2925),
    [anon_sym_R_DQUOTE] = ACTIONS(2927),
    [anon_sym_LR_DQUOTE] = ACTIONS(2927),
    [anon_sym_uR_DQUOTE] = ACTIONS(2927),
    [anon_sym_UR_DQUOTE] = ACTIONS(2927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2927),
    [anon_sym_co_await] = ACTIONS(2925),
    [anon_sym_new] = ACTIONS(2925),
    [anon_sym_requires] = ACTIONS(2925),
    [sym_this] = ACTIONS(2925),
  },
  [347] = {
    [sym_identifier] = ACTIONS(2929),
    [aux_sym_preproc_include_token1] = ACTIONS(2929),
    [aux_sym_preproc_def_token1] = ACTIONS(2929),
    [aux_sym_preproc_if_token1] = ACTIONS(2929),
    [aux_sym_preproc_if_token2] = ACTIONS(2929),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2929),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2929),
    [aux_sym_preproc_else_token1] = ACTIONS(2929),
    [aux_sym_preproc_elif_token1] = ACTIONS(2929),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2929),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2929),
    [sym_preproc_directive] = ACTIONS(2929),
    [anon_sym_LPAREN2] = ACTIONS(2931),
    [anon_sym_BANG] = ACTIONS(2931),
    [anon_sym_TILDE] = ACTIONS(2931),
    [anon_sym_DASH] = ACTIONS(2929),
    [anon_sym_PLUS] = ACTIONS(2929),
    [anon_sym_STAR] = ACTIONS(2931),
    [anon_sym_AMP_AMP] = ACTIONS(2931),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_SEMI] = ACTIONS(2931),
    [anon_sym___extension__] = ACTIONS(2929),
    [anon_sym_typedef] = ACTIONS(2929),
    [anon_sym_extern] = ACTIONS(2929),
    [anon_sym___attribute__] = ACTIONS(2929),
    [anon_sym_COLON_COLON] = ACTIONS(2931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2931),
    [anon_sym___declspec] = ACTIONS(2929),
    [anon_sym___based] = ACTIONS(2929),
    [anon_sym___cdecl] = ACTIONS(2929),
    [anon_sym___clrcall] = ACTIONS(2929),
    [anon_sym___stdcall] = ACTIONS(2929),
    [anon_sym___fastcall] = ACTIONS(2929),
    [anon_sym___thiscall] = ACTIONS(2929),
    [anon_sym___vectorcall] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [anon_sym_signed] = ACTIONS(2929),
    [anon_sym_unsigned] = ACTIONS(2929),
    [anon_sym_long] = ACTIONS(2929),
    [anon_sym_short] = ACTIONS(2929),
    [anon_sym_LBRACK] = ACTIONS(2929),
    [anon_sym_static] = ACTIONS(2929),
    [anon_sym_register] = ACTIONS(2929),
    [anon_sym_inline] = ACTIONS(2929),
    [anon_sym___inline] = ACTIONS(2929),
    [anon_sym___inline__] = ACTIONS(2929),
    [anon_sym___forceinline] = ACTIONS(2929),
    [anon_sym_thread_local] = ACTIONS(2929),
    [anon_sym___thread] = ACTIONS(2929),
    [anon_sym_const] = ACTIONS(2929),
    [anon_sym_constexpr] = ACTIONS(2929),
    [anon_sym_volatile] = ACTIONS(2929),
    [anon_sym_restrict] = ACTIONS(2929),
    [anon_sym___restrict__] = ACTIONS(2929),
    [anon_sym__Atomic] = ACTIONS(2929),
    [anon_sym__Noreturn] = ACTIONS(2929),
    [anon_sym_noreturn] = ACTIONS(2929),
    [anon_sym_mutable] = ACTIONS(2929),
    [anon_sym_constinit] = ACTIONS(2929),
    [anon_sym_consteval] = ACTIONS(2929),
    [anon_sym_PROGMEM] = ACTIONS(2929),
    [aux_sym_primitive_type_token1] = ACTIONS(2929),
    [anon_sym_byte] = ACTIONS(2929),
    [anon_sym_word] = ACTIONS(2929),
    [anon_sym_enum] = ACTIONS(2929),
    [anon_sym_class] = ACTIONS(2929),
    [anon_sym_struct] = ACTIONS(2929),
    [anon_sym_union] = ACTIONS(2929),
    [anon_sym_if] = ACTIONS(2929),
    [anon_sym_switch] = ACTIONS(2929),
    [anon_sym_case] = ACTIONS(2929),
    [anon_sym_default] = ACTIONS(2929),
    [anon_sym_while] = ACTIONS(2929),
    [anon_sym_do] = ACTIONS(2929),
    [anon_sym_for] = ACTIONS(2929),
    [anon_sym_return] = ACTIONS(2929),
    [anon_sym_break] = ACTIONS(2929),
    [anon_sym_continue] = ACTIONS(2929),
    [anon_sym_goto] = ACTIONS(2929),
    [anon_sym___try] = ACTIONS(2929),
    [anon_sym___leave] = ACTIONS(2929),
    [anon_sym_not] = ACTIONS(2929),
    [anon_sym_compl] = ACTIONS(2929),
    [anon_sym_DASH_DASH] = ACTIONS(2931),
    [anon_sym_PLUS_PLUS] = ACTIONS(2931),
    [anon_sym_sizeof] = ACTIONS(2929),
    [anon_sym___alignof__] = ACTIONS(2929),
    [anon_sym___alignof] = ACTIONS(2929),
    [anon_sym__alignof] = ACTIONS(2929),
    [anon_sym_alignof] = ACTIONS(2929),
    [anon_sym__Alignof] = ACTIONS(2929),
    [anon_sym_offsetof] = ACTIONS(2929),
    [anon_sym__Generic] = ACTIONS(2929),
    [anon_sym_asm] = ACTIONS(2929),
    [anon_sym___asm__] = ACTIONS(2929),
    [aux_sym_number_literal_token1] = ACTIONS(2931),
    [aux_sym_number_literal_token2] = ACTIONS(2929),
    [anon_sym_L_SQUOTE] = ACTIONS(2931),
    [anon_sym_u_SQUOTE] = ACTIONS(2931),
    [anon_sym_U_SQUOTE] = ACTIONS(2931),
    [anon_sym_u8_SQUOTE] = ACTIONS(2931),
    [anon_sym_SQUOTE] = ACTIONS(2931),
    [anon_sym_L_DQUOTE] = ACTIONS(2931),
    [anon_sym_u_DQUOTE] = ACTIONS(2931),
    [anon_sym_U_DQUOTE] = ACTIONS(2931),
    [anon_sym_u8_DQUOTE] = ACTIONS(2931),
    [anon_sym_DQUOTE] = ACTIONS(2931),
    [sym_true] = ACTIONS(2929),
    [sym_false] = ACTIONS(2929),
    [anon_sym_NULL] = ACTIONS(2929),
    [anon_sym_nullptr] = ACTIONS(2929),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2929),
    [anon_sym_decltype] = ACTIONS(2929),
    [anon_sym_virtual] = ACTIONS(2929),
    [anon_sym_alignas] = ACTIONS(2929),
    [anon_sym_explicit] = ACTIONS(2929),
    [anon_sym_typename] = ACTIONS(2929),
    [anon_sym_template] = ACTIONS(2929),
    [anon_sym_operator] = ACTIONS(2929),
    [anon_sym_try] = ACTIONS(2929),
    [anon_sym_delete] = ACTIONS(2929),
    [anon_sym_throw] = ACTIONS(2929),
    [anon_sym_namespace] = ACTIONS(2929),
    [anon_sym_using] = ACTIONS(2929),
    [anon_sym_static_assert] = ACTIONS(2929),
    [anon_sym_concept] = ACTIONS(2929),
    [anon_sym_co_return] = ACTIONS(2929),
    [anon_sym_co_yield] = ACTIONS(2929),
    [anon_sym_R_DQUOTE] = ACTIONS(2931),
    [anon_sym_LR_DQUOTE] = ACTIONS(2931),
    [anon_sym_uR_DQUOTE] = ACTIONS(2931),
    [anon_sym_UR_DQUOTE] = ACTIONS(2931),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2931),
    [anon_sym_co_await] = ACTIONS(2929),
    [anon_sym_new] = ACTIONS(2929),
    [anon_sym_requires] = ACTIONS(2929),
    [sym_this] = ACTIONS(2929),
  },
  [348] = {
    [sym_preproc_def] = STATE(541),
    [sym_preproc_function_def] = STATE(541),
    [sym_preproc_call] = STATE(541),
    [sym_preproc_if_in_field_declaration_list] = STATE(541),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(541),
    [sym_preproc_else_in_field_declaration_list] = STATE(7773),
    [sym_preproc_elif_in_field_declaration_list] = STATE(7773),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(7773),
    [sym_type_definition] = STATE(541),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(5531),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(3150),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(5962),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym__field_declaration_list_item] = STATE(541),
    [sym_field_declaration] = STATE(541),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1838),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(541),
    [sym_operator_cast] = STATE(6510),
    [sym_inline_method_definition] = STATE(541),
    [sym__constructor_specifiers] = STATE(1838),
    [sym_operator_cast_definition] = STATE(541),
    [sym_operator_cast_declaration] = STATE(541),
    [sym_constructor_or_destructor_definition] = STATE(541),
    [sym_constructor_or_destructor_declaration] = STATE(541),
    [sym_friend_declaration] = STATE(541),
    [sym_access_specifier] = STATE(7787),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(2618),
    [sym_template_function] = STATE(6098),
    [sym_using_declaration] = STATE(541),
    [sym_alias_declaration] = STATE(541),
    [sym_static_assert_declaration] = STATE(541),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5301),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_qualified_operator_cast_identifier] = STATE(6510),
    [sym_operator_name] = STATE(6098),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(541),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1961),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1838),
    [sym_identifier] = ACTIONS(2823),
    [aux_sym_preproc_def_token1] = ACTIONS(2825),
    [aux_sym_preproc_if_token1] = ACTIONS(2827),
    [aux_sym_preproc_if_token2] = ACTIONS(2933),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2831),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2831),
    [aux_sym_preproc_else_token1] = ACTIONS(2833),
    [aux_sym_preproc_elif_token1] = ACTIONS(2835),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2837),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2837),
    [sym_preproc_directive] = ACTIONS(2839),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(2849),
    [anon_sym_typedef] = ACTIONS(2851),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(2853),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2857),
    [anon_sym_class] = ACTIONS(2859),
    [anon_sym_struct] = ACTIONS(2861),
    [anon_sym_union] = ACTIONS(2863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(2865),
    [anon_sym_template] = ACTIONS(2867),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(2869),
    [anon_sym_public] = ACTIONS(2871),
    [anon_sym_private] = ACTIONS(2871),
    [anon_sym_protected] = ACTIONS(2871),
    [anon_sym_using] = ACTIONS(2873),
    [anon_sym_static_assert] = ACTIONS(2875),
  },
  [349] = {
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_unaligned_ptr_modifier] = STATE(4186),
    [sym_ms_pointer_modifier] = STATE(3271),
    [sym__declarator] = STATE(6279),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6098),
    [sym_array_declarator] = STATE(6098),
    [sym_type_qualifier] = STATE(4051),
    [sym_primitive_type] = STATE(6848),
    [sym__expression] = STATE(3149),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7357),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3242),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5535),
    [sym_qualified_identifier] = STATE(3247),
    [sym_qualified_type_identifier] = STATE(7357),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3526),
    [aux_sym__type_definition_type_repeat1] = STATE(4051),
    [aux_sym_pointer_declarator_repeat1] = STATE(3271),
    [sym_identifier] = ACTIONS(2935),
    [anon_sym_LPAREN2] = ACTIONS(1811),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1815),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(1821),
    [anon_sym___extension__] = ACTIONS(2917),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym___based] = ACTIONS(47),
    [sym_ms_restrict_modifier] = ACTIONS(2919),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(2919),
    [sym_ms_signed_ptr_modifier] = ACTIONS(2919),
    [anon_sym__unaligned] = ACTIONS(2921),
    [anon_sym___unaligned] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(1829),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_constexpr] = ACTIONS(2917),
    [anon_sym_volatile] = ACTIONS(2917),
    [anon_sym_restrict] = ACTIONS(2917),
    [anon_sym___restrict__] = ACTIONS(2917),
    [anon_sym__Atomic] = ACTIONS(2917),
    [anon_sym__Noreturn] = ACTIONS(2917),
    [anon_sym_noreturn] = ACTIONS(2917),
    [anon_sym_mutable] = ACTIONS(2917),
    [anon_sym_constinit] = ACTIONS(2917),
    [anon_sym_consteval] = ACTIONS(2917),
    [anon_sym_PROGMEM] = ACTIONS(2917),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_operator] = ACTIONS(1871),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [350] = {
    [sym_identifier] = ACTIONS(2937),
    [aux_sym_preproc_include_token1] = ACTIONS(2937),
    [aux_sym_preproc_def_token1] = ACTIONS(2937),
    [aux_sym_preproc_if_token1] = ACTIONS(2937),
    [aux_sym_preproc_if_token2] = ACTIONS(2937),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2937),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2937),
    [aux_sym_preproc_else_token1] = ACTIONS(2937),
    [aux_sym_preproc_elif_token1] = ACTIONS(2937),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2937),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2937),
    [sym_preproc_directive] = ACTIONS(2937),
    [anon_sym_LPAREN2] = ACTIONS(2939),
    [anon_sym_BANG] = ACTIONS(2939),
    [anon_sym_TILDE] = ACTIONS(2939),
    [anon_sym_DASH] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(2937),
    [anon_sym_STAR] = ACTIONS(2939),
    [anon_sym_AMP_AMP] = ACTIONS(2939),
    [anon_sym_AMP] = ACTIONS(2937),
    [anon_sym_SEMI] = ACTIONS(2939),
    [anon_sym___extension__] = ACTIONS(2937),
    [anon_sym_typedef] = ACTIONS(2937),
    [anon_sym_extern] = ACTIONS(2937),
    [anon_sym___attribute__] = ACTIONS(2937),
    [anon_sym_COLON_COLON] = ACTIONS(2939),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2939),
    [anon_sym___declspec] = ACTIONS(2937),
    [anon_sym___based] = ACTIONS(2937),
    [anon_sym___cdecl] = ACTIONS(2937),
    [anon_sym___clrcall] = ACTIONS(2937),
    [anon_sym___stdcall] = ACTIONS(2937),
    [anon_sym___fastcall] = ACTIONS(2937),
    [anon_sym___thiscall] = ACTIONS(2937),
    [anon_sym___vectorcall] = ACTIONS(2937),
    [anon_sym_LBRACE] = ACTIONS(2939),
    [anon_sym_signed] = ACTIONS(2937),
    [anon_sym_unsigned] = ACTIONS(2937),
    [anon_sym_long] = ACTIONS(2937),
    [anon_sym_short] = ACTIONS(2937),
    [anon_sym_LBRACK] = ACTIONS(2937),
    [anon_sym_static] = ACTIONS(2937),
    [anon_sym_register] = ACTIONS(2937),
    [anon_sym_inline] = ACTIONS(2937),
    [anon_sym___inline] = ACTIONS(2937),
    [anon_sym___inline__] = ACTIONS(2937),
    [anon_sym___forceinline] = ACTIONS(2937),
    [anon_sym_thread_local] = ACTIONS(2937),
    [anon_sym___thread] = ACTIONS(2937),
    [anon_sym_const] = ACTIONS(2937),
    [anon_sym_constexpr] = ACTIONS(2937),
    [anon_sym_volatile] = ACTIONS(2937),
    [anon_sym_restrict] = ACTIONS(2937),
    [anon_sym___restrict__] = ACTIONS(2937),
    [anon_sym__Atomic] = ACTIONS(2937),
    [anon_sym__Noreturn] = ACTIONS(2937),
    [anon_sym_noreturn] = ACTIONS(2937),
    [anon_sym_mutable] = ACTIONS(2937),
    [anon_sym_constinit] = ACTIONS(2937),
    [anon_sym_consteval] = ACTIONS(2937),
    [anon_sym_PROGMEM] = ACTIONS(2937),
    [aux_sym_primitive_type_token1] = ACTIONS(2937),
    [anon_sym_byte] = ACTIONS(2937),
    [anon_sym_word] = ACTIONS(2937),
    [anon_sym_enum] = ACTIONS(2937),
    [anon_sym_class] = ACTIONS(2937),
    [anon_sym_struct] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_if] = ACTIONS(2937),
    [anon_sym_switch] = ACTIONS(2937),
    [anon_sym_case] = ACTIONS(2937),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_while] = ACTIONS(2937),
    [anon_sym_do] = ACTIONS(2937),
    [anon_sym_for] = ACTIONS(2937),
    [anon_sym_return] = ACTIONS(2937),
    [anon_sym_break] = ACTIONS(2937),
    [anon_sym_continue] = ACTIONS(2937),
    [anon_sym_goto] = ACTIONS(2937),
    [anon_sym___try] = ACTIONS(2937),
    [anon_sym___leave] = ACTIONS(2937),
    [anon_sym_not] = ACTIONS(2937),
    [anon_sym_compl] = ACTIONS(2937),
    [anon_sym_DASH_DASH] = ACTIONS(2939),
    [anon_sym_PLUS_PLUS] = ACTIONS(2939),
    [anon_sym_sizeof] = ACTIONS(2937),
    [anon_sym___alignof__] = ACTIONS(2937),
    [anon_sym___alignof] = ACTIONS(2937),
    [anon_sym__alignof] = ACTIONS(2937),
    [anon_sym_alignof] = ACTIONS(2937),
    [anon_sym__Alignof] = ACTIONS(2937),
    [anon_sym_offsetof] = ACTIONS(2937),
    [anon_sym__Generic] = ACTIONS(2937),
    [anon_sym_asm] = ACTIONS(2937),
    [anon_sym___asm__] = ACTIONS(2937),
    [aux_sym_number_literal_token1] = ACTIONS(2939),
    [aux_sym_number_literal_token2] = ACTIONS(2937),
    [anon_sym_L_SQUOTE] = ACTIONS(2939),
    [anon_sym_u_SQUOTE] = ACTIONS(2939),
    [anon_sym_U_SQUOTE] = ACTIONS(2939),
    [anon_sym_u8_SQUOTE] = ACTIONS(2939),
    [anon_sym_SQUOTE] = ACTIONS(2939),
    [anon_sym_L_DQUOTE] = ACTIONS(2939),
    [anon_sym_u_DQUOTE] = ACTIONS(2939),
    [anon_sym_U_DQUOTE] = ACTIONS(2939),
    [anon_sym_u8_DQUOTE] = ACTIONS(2939),
    [anon_sym_DQUOTE] = ACTIONS(2939),
    [sym_true] = ACTIONS(2937),
    [sym_false] = ACTIONS(2937),
    [anon_sym_NULL] = ACTIONS(2937),
    [anon_sym_nullptr] = ACTIONS(2937),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2937),
    [anon_sym_decltype] = ACTIONS(2937),
    [anon_sym_virtual] = ACTIONS(2937),
    [anon_sym_alignas] = ACTIONS(2937),
    [anon_sym_explicit] = ACTIONS(2937),
    [anon_sym_typename] = ACTIONS(2937),
    [anon_sym_template] = ACTIONS(2937),
    [anon_sym_operator] = ACTIONS(2937),
    [anon_sym_try] = ACTIONS(2937),
    [anon_sym_delete] = ACTIONS(2937),
    [anon_sym_throw] = ACTIONS(2937),
    [anon_sym_namespace] = ACTIONS(2937),
    [anon_sym_using] = ACTIONS(2937),
    [anon_sym_static_assert] = ACTIONS(2937),
    [anon_sym_concept] = ACTIONS(2937),
    [anon_sym_co_return] = ACTIONS(2937),
    [anon_sym_co_yield] = ACTIONS(2937),
    [anon_sym_R_DQUOTE] = ACTIONS(2939),
    [anon_sym_LR_DQUOTE] = ACTIONS(2939),
    [anon_sym_uR_DQUOTE] = ACTIONS(2939),
    [anon_sym_UR_DQUOTE] = ACTIONS(2939),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2939),
    [anon_sym_co_await] = ACTIONS(2937),
    [anon_sym_new] = ACTIONS(2937),
    [anon_sym_requires] = ACTIONS(2937),
    [sym_this] = ACTIONS(2937),
  },
  [351] = {
    [sym_identifier] = ACTIONS(2941),
    [aux_sym_preproc_include_token1] = ACTIONS(2941),
    [aux_sym_preproc_def_token1] = ACTIONS(2941),
    [aux_sym_preproc_if_token1] = ACTIONS(2941),
    [aux_sym_preproc_if_token2] = ACTIONS(2941),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2941),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2941),
    [aux_sym_preproc_else_token1] = ACTIONS(2941),
    [aux_sym_preproc_elif_token1] = ACTIONS(2941),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2941),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2941),
    [sym_preproc_directive] = ACTIONS(2941),
    [anon_sym_LPAREN2] = ACTIONS(2943),
    [anon_sym_BANG] = ACTIONS(2943),
    [anon_sym_TILDE] = ACTIONS(2943),
    [anon_sym_DASH] = ACTIONS(2941),
    [anon_sym_PLUS] = ACTIONS(2941),
    [anon_sym_STAR] = ACTIONS(2943),
    [anon_sym_AMP_AMP] = ACTIONS(2943),
    [anon_sym_AMP] = ACTIONS(2941),
    [anon_sym_SEMI] = ACTIONS(2943),
    [anon_sym___extension__] = ACTIONS(2941),
    [anon_sym_typedef] = ACTIONS(2941),
    [anon_sym_extern] = ACTIONS(2941),
    [anon_sym___attribute__] = ACTIONS(2941),
    [anon_sym_COLON_COLON] = ACTIONS(2943),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2943),
    [anon_sym___declspec] = ACTIONS(2941),
    [anon_sym___based] = ACTIONS(2941),
    [anon_sym___cdecl] = ACTIONS(2941),
    [anon_sym___clrcall] = ACTIONS(2941),
    [anon_sym___stdcall] = ACTIONS(2941),
    [anon_sym___fastcall] = ACTIONS(2941),
    [anon_sym___thiscall] = ACTIONS(2941),
    [anon_sym___vectorcall] = ACTIONS(2941),
    [anon_sym_LBRACE] = ACTIONS(2943),
    [anon_sym_signed] = ACTIONS(2941),
    [anon_sym_unsigned] = ACTIONS(2941),
    [anon_sym_long] = ACTIONS(2941),
    [anon_sym_short] = ACTIONS(2941),
    [anon_sym_LBRACK] = ACTIONS(2941),
    [anon_sym_static] = ACTIONS(2941),
    [anon_sym_register] = ACTIONS(2941),
    [anon_sym_inline] = ACTIONS(2941),
    [anon_sym___inline] = ACTIONS(2941),
    [anon_sym___inline__] = ACTIONS(2941),
    [anon_sym___forceinline] = ACTIONS(2941),
    [anon_sym_thread_local] = ACTIONS(2941),
    [anon_sym___thread] = ACTIONS(2941),
    [anon_sym_const] = ACTIONS(2941),
    [anon_sym_constexpr] = ACTIONS(2941),
    [anon_sym_volatile] = ACTIONS(2941),
    [anon_sym_restrict] = ACTIONS(2941),
    [anon_sym___restrict__] = ACTIONS(2941),
    [anon_sym__Atomic] = ACTIONS(2941),
    [anon_sym__Noreturn] = ACTIONS(2941),
    [anon_sym_noreturn] = ACTIONS(2941),
    [anon_sym_mutable] = ACTIONS(2941),
    [anon_sym_constinit] = ACTIONS(2941),
    [anon_sym_consteval] = ACTIONS(2941),
    [anon_sym_PROGMEM] = ACTIONS(2941),
    [aux_sym_primitive_type_token1] = ACTIONS(2941),
    [anon_sym_byte] = ACTIONS(2941),
    [anon_sym_word] = ACTIONS(2941),
    [anon_sym_enum] = ACTIONS(2941),
    [anon_sym_class] = ACTIONS(2941),
    [anon_sym_struct] = ACTIONS(2941),
    [anon_sym_union] = ACTIONS(2941),
    [anon_sym_if] = ACTIONS(2941),
    [anon_sym_switch] = ACTIONS(2941),
    [anon_sym_case] = ACTIONS(2941),
    [anon_sym_default] = ACTIONS(2941),
    [anon_sym_while] = ACTIONS(2941),
    [anon_sym_do] = ACTIONS(2941),
    [anon_sym_for] = ACTIONS(2941),
    [anon_sym_return] = ACTIONS(2941),
    [anon_sym_break] = ACTIONS(2941),
    [anon_sym_continue] = ACTIONS(2941),
    [anon_sym_goto] = ACTIONS(2941),
    [anon_sym___try] = ACTIONS(2941),
    [anon_sym___leave] = ACTIONS(2941),
    [anon_sym_not] = ACTIONS(2941),
    [anon_sym_compl] = ACTIONS(2941),
    [anon_sym_DASH_DASH] = ACTIONS(2943),
    [anon_sym_PLUS_PLUS] = ACTIONS(2943),
    [anon_sym_sizeof] = ACTIONS(2941),
    [anon_sym___alignof__] = ACTIONS(2941),
    [anon_sym___alignof] = ACTIONS(2941),
    [anon_sym__alignof] = ACTIONS(2941),
    [anon_sym_alignof] = ACTIONS(2941),
    [anon_sym__Alignof] = ACTIONS(2941),
    [anon_sym_offsetof] = ACTIONS(2941),
    [anon_sym__Generic] = ACTIONS(2941),
    [anon_sym_asm] = ACTIONS(2941),
    [anon_sym___asm__] = ACTIONS(2941),
    [aux_sym_number_literal_token1] = ACTIONS(2943),
    [aux_sym_number_literal_token2] = ACTIONS(2941),
    [anon_sym_L_SQUOTE] = ACTIONS(2943),
    [anon_sym_u_SQUOTE] = ACTIONS(2943),
    [anon_sym_U_SQUOTE] = ACTIONS(2943),
    [anon_sym_u8_SQUOTE] = ACTIONS(2943),
    [anon_sym_SQUOTE] = ACTIONS(2943),
    [anon_sym_L_DQUOTE] = ACTIONS(2943),
    [anon_sym_u_DQUOTE] = ACTIONS(2943),
    [anon_sym_U_DQUOTE] = ACTIONS(2943),
    [anon_sym_u8_DQUOTE] = ACTIONS(2943),
    [anon_sym_DQUOTE] = ACTIONS(2943),
    [sym_true] = ACTIONS(2941),
    [sym_false] = ACTIONS(2941),
    [anon_sym_NULL] = ACTIONS(2941),
    [anon_sym_nullptr] = ACTIONS(2941),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2941),
    [anon_sym_decltype] = ACTIONS(2941),
    [anon_sym_virtual] = ACTIONS(2941),
    [anon_sym_alignas] = ACTIONS(2941),
    [anon_sym_explicit] = ACTIONS(2941),
    [anon_sym_typename] = ACTIONS(2941),
    [anon_sym_template] = ACTIONS(2941),
    [anon_sym_operator] = ACTIONS(2941),
    [anon_sym_try] = ACTIONS(2941),
    [anon_sym_delete] = ACTIONS(2941),
    [anon_sym_throw] = ACTIONS(2941),
    [anon_sym_namespace] = ACTIONS(2941),
    [anon_sym_using] = ACTIONS(2941),
    [anon_sym_static_assert] = ACTIONS(2941),
    [anon_sym_concept] = ACTIONS(2941),
    [anon_sym_co_return] = ACTIONS(2941),
    [anon_sym_co_yield] = ACTIONS(2941),
    [anon_sym_R_DQUOTE] = ACTIONS(2943),
    [anon_sym_LR_DQUOTE] = ACTIONS(2943),
    [anon_sym_uR_DQUOTE] = ACTIONS(2943),
    [anon_sym_UR_DQUOTE] = ACTIONS(2943),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2943),
    [anon_sym_co_await] = ACTIONS(2941),
    [anon_sym_new] = ACTIONS(2941),
    [anon_sym_requires] = ACTIONS(2941),
    [sym_this] = ACTIONS(2941),
  },
  [352] = {
    [sym_identifier] = ACTIONS(2945),
    [aux_sym_preproc_include_token1] = ACTIONS(2945),
    [aux_sym_preproc_def_token1] = ACTIONS(2945),
    [aux_sym_preproc_if_token1] = ACTIONS(2945),
    [aux_sym_preproc_if_token2] = ACTIONS(2945),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2945),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2945),
    [aux_sym_preproc_else_token1] = ACTIONS(2945),
    [aux_sym_preproc_elif_token1] = ACTIONS(2945),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2945),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2945),
    [sym_preproc_directive] = ACTIONS(2945),
    [anon_sym_LPAREN2] = ACTIONS(2947),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2947),
    [anon_sym_DASH] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(2945),
    [anon_sym_STAR] = ACTIONS(2947),
    [anon_sym_AMP_AMP] = ACTIONS(2947),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_SEMI] = ACTIONS(2947),
    [anon_sym___extension__] = ACTIONS(2945),
    [anon_sym_typedef] = ACTIONS(2945),
    [anon_sym_extern] = ACTIONS(2945),
    [anon_sym___attribute__] = ACTIONS(2945),
    [anon_sym_COLON_COLON] = ACTIONS(2947),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2947),
    [anon_sym___declspec] = ACTIONS(2945),
    [anon_sym___based] = ACTIONS(2945),
    [anon_sym___cdecl] = ACTIONS(2945),
    [anon_sym___clrcall] = ACTIONS(2945),
    [anon_sym___stdcall] = ACTIONS(2945),
    [anon_sym___fastcall] = ACTIONS(2945),
    [anon_sym___thiscall] = ACTIONS(2945),
    [anon_sym___vectorcall] = ACTIONS(2945),
    [anon_sym_LBRACE] = ACTIONS(2947),
    [anon_sym_signed] = ACTIONS(2945),
    [anon_sym_unsigned] = ACTIONS(2945),
    [anon_sym_long] = ACTIONS(2945),
    [anon_sym_short] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(2945),
    [anon_sym_static] = ACTIONS(2945),
    [anon_sym_register] = ACTIONS(2945),
    [anon_sym_inline] = ACTIONS(2945),
    [anon_sym___inline] = ACTIONS(2945),
    [anon_sym___inline__] = ACTIONS(2945),
    [anon_sym___forceinline] = ACTIONS(2945),
    [anon_sym_thread_local] = ACTIONS(2945),
    [anon_sym___thread] = ACTIONS(2945),
    [anon_sym_const] = ACTIONS(2945),
    [anon_sym_constexpr] = ACTIONS(2945),
    [anon_sym_volatile] = ACTIONS(2945),
    [anon_sym_restrict] = ACTIONS(2945),
    [anon_sym___restrict__] = ACTIONS(2945),
    [anon_sym__Atomic] = ACTIONS(2945),
    [anon_sym__Noreturn] = ACTIONS(2945),
    [anon_sym_noreturn] = ACTIONS(2945),
    [anon_sym_mutable] = ACTIONS(2945),
    [anon_sym_constinit] = ACTIONS(2945),
    [anon_sym_consteval] = ACTIONS(2945),
    [anon_sym_PROGMEM] = ACTIONS(2945),
    [aux_sym_primitive_type_token1] = ACTIONS(2945),
    [anon_sym_byte] = ACTIONS(2945),
    [anon_sym_word] = ACTIONS(2945),
    [anon_sym_enum] = ACTIONS(2945),
    [anon_sym_class] = ACTIONS(2945),
    [anon_sym_struct] = ACTIONS(2945),
    [anon_sym_union] = ACTIONS(2945),
    [anon_sym_if] = ACTIONS(2945),
    [anon_sym_switch] = ACTIONS(2945),
    [anon_sym_case] = ACTIONS(2945),
    [anon_sym_default] = ACTIONS(2945),
    [anon_sym_while] = ACTIONS(2945),
    [anon_sym_do] = ACTIONS(2945),
    [anon_sym_for] = ACTIONS(2945),
    [anon_sym_return] = ACTIONS(2945),
    [anon_sym_break] = ACTIONS(2945),
    [anon_sym_continue] = ACTIONS(2945),
    [anon_sym_goto] = ACTIONS(2945),
    [anon_sym___try] = ACTIONS(2945),
    [anon_sym___leave] = ACTIONS(2945),
    [anon_sym_not] = ACTIONS(2945),
    [anon_sym_compl] = ACTIONS(2945),
    [anon_sym_DASH_DASH] = ACTIONS(2947),
    [anon_sym_PLUS_PLUS] = ACTIONS(2947),
    [anon_sym_sizeof] = ACTIONS(2945),
    [anon_sym___alignof__] = ACTIONS(2945),
    [anon_sym___alignof] = ACTIONS(2945),
    [anon_sym__alignof] = ACTIONS(2945),
    [anon_sym_alignof] = ACTIONS(2945),
    [anon_sym__Alignof] = ACTIONS(2945),
    [anon_sym_offsetof] = ACTIONS(2945),
    [anon_sym__Generic] = ACTIONS(2945),
    [anon_sym_asm] = ACTIONS(2945),
    [anon_sym___asm__] = ACTIONS(2945),
    [aux_sym_number_literal_token1] = ACTIONS(2947),
    [aux_sym_number_literal_token2] = ACTIONS(2945),
    [anon_sym_L_SQUOTE] = ACTIONS(2947),
    [anon_sym_u_SQUOTE] = ACTIONS(2947),
    [anon_sym_U_SQUOTE] = ACTIONS(2947),
    [anon_sym_u8_SQUOTE] = ACTIONS(2947),
    [anon_sym_SQUOTE] = ACTIONS(2947),
    [anon_sym_L_DQUOTE] = ACTIONS(2947),
    [anon_sym_u_DQUOTE] = ACTIONS(2947),
    [anon_sym_U_DQUOTE] = ACTIONS(2947),
    [anon_sym_u8_DQUOTE] = ACTIONS(2947),
    [anon_sym_DQUOTE] = ACTIONS(2947),
    [sym_true] = ACTIONS(2945),
    [sym_false] = ACTIONS(2945),
    [anon_sym_NULL] = ACTIONS(2945),
    [anon_sym_nullptr] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2945),
    [anon_sym_decltype] = ACTIONS(2945),
    [anon_sym_virtual] = ACTIONS(2945),
    [anon_sym_alignas] = ACTIONS(2945),
    [anon_sym_explicit] = ACTIONS(2945),
    [anon_sym_typename] = ACTIONS(2945),
    [anon_sym_template] = ACTIONS(2945),
    [anon_sym_operator] = ACTIONS(2945),
    [anon_sym_try] = ACTIONS(2945),
    [anon_sym_delete] = ACTIONS(2945),
    [anon_sym_throw] = ACTIONS(2945),
    [anon_sym_namespace] = ACTIONS(2945),
    [anon_sym_using] = ACTIONS(2945),
    [anon_sym_static_assert] = ACTIONS(2945),
    [anon_sym_concept] = ACTIONS(2945),
    [anon_sym_co_return] = ACTIONS(2945),
    [anon_sym_co_yield] = ACTIONS(2945),
    [anon_sym_R_DQUOTE] = ACTIONS(2947),
    [anon_sym_LR_DQUOTE] = ACTIONS(2947),
    [anon_sym_uR_DQUOTE] = ACTIONS(2947),
    [anon_sym_UR_DQUOTE] = ACTIONS(2947),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2947),
    [anon_sym_co_await] = ACTIONS(2945),
    [anon_sym_new] = ACTIONS(2945),
    [anon_sym_requires] = ACTIONS(2945),
    [sym_this] = ACTIONS(2945),
  },
  [353] = {
    [sym_identifier] = ACTIONS(2949),
    [aux_sym_preproc_include_token1] = ACTIONS(2949),
    [aux_sym_preproc_def_token1] = ACTIONS(2949),
    [aux_sym_preproc_if_token1] = ACTIONS(2949),
    [aux_sym_preproc_if_token2] = ACTIONS(2949),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2949),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2949),
    [aux_sym_preproc_else_token1] = ACTIONS(2949),
    [aux_sym_preproc_elif_token1] = ACTIONS(2949),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2949),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2949),
    [sym_preproc_directive] = ACTIONS(2949),
    [anon_sym_LPAREN2] = ACTIONS(2951),
    [anon_sym_BANG] = ACTIONS(2951),
    [anon_sym_TILDE] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2949),
    [anon_sym_STAR] = ACTIONS(2951),
    [anon_sym_AMP_AMP] = ACTIONS(2951),
    [anon_sym_AMP] = ACTIONS(2949),
    [anon_sym_SEMI] = ACTIONS(2951),
    [anon_sym___extension__] = ACTIONS(2949),
    [anon_sym_typedef] = ACTIONS(2949),
    [anon_sym_extern] = ACTIONS(2949),
    [anon_sym___attribute__] = ACTIONS(2949),
    [anon_sym_COLON_COLON] = ACTIONS(2951),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2951),
    [anon_sym___declspec] = ACTIONS(2949),
    [anon_sym___based] = ACTIONS(2949),
    [anon_sym___cdecl] = ACTIONS(2949),
    [anon_sym___clrcall] = ACTIONS(2949),
    [anon_sym___stdcall] = ACTIONS(2949),
    [anon_sym___fastcall] = ACTIONS(2949),
    [anon_sym___thiscall] = ACTIONS(2949),
    [anon_sym___vectorcall] = ACTIONS(2949),
    [anon_sym_LBRACE] = ACTIONS(2951),
    [anon_sym_signed] = ACTIONS(2949),
    [anon_sym_unsigned] = ACTIONS(2949),
    [anon_sym_long] = ACTIONS(2949),
    [anon_sym_short] = ACTIONS(2949),
    [anon_sym_LBRACK] = ACTIONS(2949),
    [anon_sym_static] = ACTIONS(2949),
    [anon_sym_register] = ACTIONS(2949),
    [anon_sym_inline] = ACTIONS(2949),
    [anon_sym___inline] = ACTIONS(2949),
    [anon_sym___inline__] = ACTIONS(2949),
    [anon_sym___forceinline] = ACTIONS(2949),
    [anon_sym_thread_local] = ACTIONS(2949),
    [anon_sym___thread] = ACTIONS(2949),
    [anon_sym_const] = ACTIONS(2949),
    [anon_sym_constexpr] = ACTIONS(2949),
    [anon_sym_volatile] = ACTIONS(2949),
    [anon_sym_restrict] = ACTIONS(2949),
    [anon_sym___restrict__] = ACTIONS(2949),
    [anon_sym__Atomic] = ACTIONS(2949),
    [anon_sym__Noreturn] = ACTIONS(2949),
    [anon_sym_noreturn] = ACTIONS(2949),
    [anon_sym_mutable] = ACTIONS(2949),
    [anon_sym_constinit] = ACTIONS(2949),
    [anon_sym_consteval] = ACTIONS(2949),
    [anon_sym_PROGMEM] = ACTIONS(2949),
    [aux_sym_primitive_type_token1] = ACTIONS(2949),
    [anon_sym_byte] = ACTIONS(2949),
    [anon_sym_word] = ACTIONS(2949),
    [anon_sym_enum] = ACTIONS(2949),
    [anon_sym_class] = ACTIONS(2949),
    [anon_sym_struct] = ACTIONS(2949),
    [anon_sym_union] = ACTIONS(2949),
    [anon_sym_if] = ACTIONS(2949),
    [anon_sym_switch] = ACTIONS(2949),
    [anon_sym_case] = ACTIONS(2949),
    [anon_sym_default] = ACTIONS(2949),
    [anon_sym_while] = ACTIONS(2949),
    [anon_sym_do] = ACTIONS(2949),
    [anon_sym_for] = ACTIONS(2949),
    [anon_sym_return] = ACTIONS(2949),
    [anon_sym_break] = ACTIONS(2949),
    [anon_sym_continue] = ACTIONS(2949),
    [anon_sym_goto] = ACTIONS(2949),
    [anon_sym___try] = ACTIONS(2949),
    [anon_sym___leave] = ACTIONS(2949),
    [anon_sym_not] = ACTIONS(2949),
    [anon_sym_compl] = ACTIONS(2949),
    [anon_sym_DASH_DASH] = ACTIONS(2951),
    [anon_sym_PLUS_PLUS] = ACTIONS(2951),
    [anon_sym_sizeof] = ACTIONS(2949),
    [anon_sym___alignof__] = ACTIONS(2949),
    [anon_sym___alignof] = ACTIONS(2949),
    [anon_sym__alignof] = ACTIONS(2949),
    [anon_sym_alignof] = ACTIONS(2949),
    [anon_sym__Alignof] = ACTIONS(2949),
    [anon_sym_offsetof] = ACTIONS(2949),
    [anon_sym__Generic] = ACTIONS(2949),
    [anon_sym_asm] = ACTIONS(2949),
    [anon_sym___asm__] = ACTIONS(2949),
    [aux_sym_number_literal_token1] = ACTIONS(2951),
    [aux_sym_number_literal_token2] = ACTIONS(2949),
    [anon_sym_L_SQUOTE] = ACTIONS(2951),
    [anon_sym_u_SQUOTE] = ACTIONS(2951),
    [anon_sym_U_SQUOTE] = ACTIONS(2951),
    [anon_sym_u8_SQUOTE] = ACTIONS(2951),
    [anon_sym_SQUOTE] = ACTIONS(2951),
    [anon_sym_L_DQUOTE] = ACTIONS(2951),
    [anon_sym_u_DQUOTE] = ACTIONS(2951),
    [anon_sym_U_DQUOTE] = ACTIONS(2951),
    [anon_sym_u8_DQUOTE] = ACTIONS(2951),
    [anon_sym_DQUOTE] = ACTIONS(2951),
    [sym_true] = ACTIONS(2949),
    [sym_false] = ACTIONS(2949),
    [anon_sym_NULL] = ACTIONS(2949),
    [anon_sym_nullptr] = ACTIONS(2949),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2949),
    [anon_sym_decltype] = ACTIONS(2949),
    [anon_sym_virtual] = ACTIONS(2949),
    [anon_sym_alignas] = ACTIONS(2949),
    [anon_sym_explicit] = ACTIONS(2949),
    [anon_sym_typename] = ACTIONS(2949),
    [anon_sym_template] = ACTIONS(2949),
    [anon_sym_operator] = ACTIONS(2949),
    [anon_sym_try] = ACTIONS(2949),
    [anon_sym_delete] = ACTIONS(2949),
    [anon_sym_throw] = ACTIONS(2949),
    [anon_sym_namespace] = ACTIONS(2949),
    [anon_sym_using] = ACTIONS(2949),
    [anon_sym_static_assert] = ACTIONS(2949),
    [anon_sym_concept] = ACTIONS(2949),
    [anon_sym_co_return] = ACTIONS(2949),
    [anon_sym_co_yield] = ACTIONS(2949),
    [anon_sym_R_DQUOTE] = ACTIONS(2951),
    [anon_sym_LR_DQUOTE] = ACTIONS(2951),
    [anon_sym_uR_DQUOTE] = ACTIONS(2951),
    [anon_sym_UR_DQUOTE] = ACTIONS(2951),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2951),
    [anon_sym_co_await] = ACTIONS(2949),
    [anon_sym_new] = ACTIONS(2949),
    [anon_sym_requires] = ACTIONS(2949),
    [sym_this] = ACTIONS(2949),
  },
  [354] = {
    [sym_identifier] = ACTIONS(2953),
    [aux_sym_preproc_include_token1] = ACTIONS(2953),
    [aux_sym_preproc_def_token1] = ACTIONS(2953),
    [aux_sym_preproc_if_token1] = ACTIONS(2953),
    [aux_sym_preproc_if_token2] = ACTIONS(2953),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2953),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2953),
    [aux_sym_preproc_else_token1] = ACTIONS(2953),
    [aux_sym_preproc_elif_token1] = ACTIONS(2953),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2953),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2953),
    [sym_preproc_directive] = ACTIONS(2953),
    [anon_sym_LPAREN2] = ACTIONS(2955),
    [anon_sym_BANG] = ACTIONS(2955),
    [anon_sym_TILDE] = ACTIONS(2955),
    [anon_sym_DASH] = ACTIONS(2953),
    [anon_sym_PLUS] = ACTIONS(2953),
    [anon_sym_STAR] = ACTIONS(2955),
    [anon_sym_AMP_AMP] = ACTIONS(2955),
    [anon_sym_AMP] = ACTIONS(2953),
    [anon_sym_SEMI] = ACTIONS(2955),
    [anon_sym___extension__] = ACTIONS(2953),
    [anon_sym_typedef] = ACTIONS(2953),
    [anon_sym_extern] = ACTIONS(2953),
    [anon_sym___attribute__] = ACTIONS(2953),
    [anon_sym_COLON_COLON] = ACTIONS(2955),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2955),
    [anon_sym___declspec] = ACTIONS(2953),
    [anon_sym___based] = ACTIONS(2953),
    [anon_sym___cdecl] = ACTIONS(2953),
    [anon_sym___clrcall] = ACTIONS(2953),
    [anon_sym___stdcall] = ACTIONS(2953),
    [anon_sym___fastcall] = ACTIONS(2953),
    [anon_sym___thiscall] = ACTIONS(2953),
    [anon_sym___vectorcall] = ACTIONS(2953),
    [anon_sym_LBRACE] = ACTIONS(2955),
    [anon_sym_signed] = ACTIONS(2953),
    [anon_sym_unsigned] = ACTIONS(2953),
    [anon_sym_long] = ACTIONS(2953),
    [anon_sym_short] = ACTIONS(2953),
    [anon_sym_LBRACK] = ACTIONS(2953),
    [anon_sym_static] = ACTIONS(2953),
    [anon_sym_register] = ACTIONS(2953),
    [anon_sym_inline] = ACTIONS(2953),
    [anon_sym___inline] = ACTIONS(2953),
    [anon_sym___inline__] = ACTIONS(2953),
    [anon_sym___forceinline] = ACTIONS(2953),
    [anon_sym_thread_local] = ACTIONS(2953),
    [anon_sym___thread] = ACTIONS(2953),
    [anon_sym_const] = ACTIONS(2953),
    [anon_sym_constexpr] = ACTIONS(2953),
    [anon_sym_volatile] = ACTIONS(2953),
    [anon_sym_restrict] = ACTIONS(2953),
    [anon_sym___restrict__] = ACTIONS(2953),
    [anon_sym__Atomic] = ACTIONS(2953),
    [anon_sym__Noreturn] = ACTIONS(2953),
    [anon_sym_noreturn] = ACTIONS(2953),
    [anon_sym_mutable] = ACTIONS(2953),
    [anon_sym_constinit] = ACTIONS(2953),
    [anon_sym_consteval] = ACTIONS(2953),
    [anon_sym_PROGMEM] = ACTIONS(2953),
    [aux_sym_primitive_type_token1] = ACTIONS(2953),
    [anon_sym_byte] = ACTIONS(2953),
    [anon_sym_word] = ACTIONS(2953),
    [anon_sym_enum] = ACTIONS(2953),
    [anon_sym_class] = ACTIONS(2953),
    [anon_sym_struct] = ACTIONS(2953),
    [anon_sym_union] = ACTIONS(2953),
    [anon_sym_if] = ACTIONS(2953),
    [anon_sym_switch] = ACTIONS(2953),
    [anon_sym_case] = ACTIONS(2953),
    [anon_sym_default] = ACTIONS(2953),
    [anon_sym_while] = ACTIONS(2953),
    [anon_sym_do] = ACTIONS(2953),
    [anon_sym_for] = ACTIONS(2953),
    [anon_sym_return] = ACTIONS(2953),
    [anon_sym_break] = ACTIONS(2953),
    [anon_sym_continue] = ACTIONS(2953),
    [anon_sym_goto] = ACTIONS(2953),
    [anon_sym___try] = ACTIONS(2953),
    [anon_sym___leave] = ACTIONS(2953),
    [anon_sym_not] = ACTIONS(2953),
    [anon_sym_compl] = ACTIONS(2953),
    [anon_sym_DASH_DASH] = ACTIONS(2955),
    [anon_sym_PLUS_PLUS] = ACTIONS(2955),
    [anon_sym_sizeof] = ACTIONS(2953),
    [anon_sym___alignof__] = ACTIONS(2953),
    [anon_sym___alignof] = ACTIONS(2953),
    [anon_sym__alignof] = ACTIONS(2953),
    [anon_sym_alignof] = ACTIONS(2953),
    [anon_sym__Alignof] = ACTIONS(2953),
    [anon_sym_offsetof] = ACTIONS(2953),
    [anon_sym__Generic] = ACTIONS(2953),
    [anon_sym_asm] = ACTIONS(2953),
    [anon_sym___asm__] = ACTIONS(2953),
    [aux_sym_number_literal_token1] = ACTIONS(2955),
    [aux_sym_number_literal_token2] = ACTIONS(2953),
    [anon_sym_L_SQUOTE] = ACTIONS(2955),
    [anon_sym_u_SQUOTE] = ACTIONS(2955),
    [anon_sym_U_SQUOTE] = ACTIONS(2955),
    [anon_sym_u8_SQUOTE] = ACTIONS(2955),
    [anon_sym_SQUOTE] = ACTIONS(2955),
    [anon_sym_L_DQUOTE] = ACTIONS(2955),
    [anon_sym_u_DQUOTE] = ACTIONS(2955),
    [anon_sym_U_DQUOTE] = ACTIONS(2955),
    [anon_sym_u8_DQUOTE] = ACTIONS(2955),
    [anon_sym_DQUOTE] = ACTIONS(2955),
    [sym_true] = ACTIONS(2953),
    [sym_false] = ACTIONS(2953),
    [anon_sym_NULL] = ACTIONS(2953),
    [anon_sym_nullptr] = ACTIONS(2953),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2953),
    [anon_sym_decltype] = ACTIONS(2953),
    [anon_sym_virtual] = ACTIONS(2953),
    [anon_sym_alignas] = ACTIONS(2953),
    [anon_sym_explicit] = ACTIONS(2953),
    [anon_sym_typename] = ACTIONS(2953),
    [anon_sym_template] = ACTIONS(2953),
    [anon_sym_operator] = ACTIONS(2953),
    [anon_sym_try] = ACTIONS(2953),
    [anon_sym_delete] = ACTIONS(2953),
    [anon_sym_throw] = ACTIONS(2953),
    [anon_sym_namespace] = ACTIONS(2953),
    [anon_sym_using] = ACTIONS(2953),
    [anon_sym_static_assert] = ACTIONS(2953),
    [anon_sym_concept] = ACTIONS(2953),
    [anon_sym_co_return] = ACTIONS(2953),
    [anon_sym_co_yield] = ACTIONS(2953),
    [anon_sym_R_DQUOTE] = ACTIONS(2955),
    [anon_sym_LR_DQUOTE] = ACTIONS(2955),
    [anon_sym_uR_DQUOTE] = ACTIONS(2955),
    [anon_sym_UR_DQUOTE] = ACTIONS(2955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2955),
    [anon_sym_co_await] = ACTIONS(2953),
    [anon_sym_new] = ACTIONS(2953),
    [anon_sym_requires] = ACTIONS(2953),
    [sym_this] = ACTIONS(2953),
  },
  [355] = {
    [sym_identifier] = ACTIONS(2957),
    [aux_sym_preproc_include_token1] = ACTIONS(2957),
    [aux_sym_preproc_def_token1] = ACTIONS(2957),
    [aux_sym_preproc_if_token1] = ACTIONS(2957),
    [aux_sym_preproc_if_token2] = ACTIONS(2957),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2957),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2957),
    [aux_sym_preproc_else_token1] = ACTIONS(2957),
    [aux_sym_preproc_elif_token1] = ACTIONS(2957),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2957),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2957),
    [sym_preproc_directive] = ACTIONS(2957),
    [anon_sym_LPAREN2] = ACTIONS(2959),
    [anon_sym_BANG] = ACTIONS(2959),
    [anon_sym_TILDE] = ACTIONS(2959),
    [anon_sym_DASH] = ACTIONS(2957),
    [anon_sym_PLUS] = ACTIONS(2957),
    [anon_sym_STAR] = ACTIONS(2959),
    [anon_sym_AMP_AMP] = ACTIONS(2959),
    [anon_sym_AMP] = ACTIONS(2957),
    [anon_sym_SEMI] = ACTIONS(2959),
    [anon_sym___extension__] = ACTIONS(2957),
    [anon_sym_typedef] = ACTIONS(2957),
    [anon_sym_extern] = ACTIONS(2957),
    [anon_sym___attribute__] = ACTIONS(2957),
    [anon_sym_COLON_COLON] = ACTIONS(2959),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2959),
    [anon_sym___declspec] = ACTIONS(2957),
    [anon_sym___based] = ACTIONS(2957),
    [anon_sym___cdecl] = ACTIONS(2957),
    [anon_sym___clrcall] = ACTIONS(2957),
    [anon_sym___stdcall] = ACTIONS(2957),
    [anon_sym___fastcall] = ACTIONS(2957),
    [anon_sym___thiscall] = ACTIONS(2957),
    [anon_sym___vectorcall] = ACTIONS(2957),
    [anon_sym_LBRACE] = ACTIONS(2959),
    [anon_sym_signed] = ACTIONS(2957),
    [anon_sym_unsigned] = ACTIONS(2957),
    [anon_sym_long] = ACTIONS(2957),
    [anon_sym_short] = ACTIONS(2957),
    [anon_sym_LBRACK] = ACTIONS(2957),
    [anon_sym_static] = ACTIONS(2957),
    [anon_sym_register] = ACTIONS(2957),
    [anon_sym_inline] = ACTIONS(2957),
    [anon_sym___inline] = ACTIONS(2957),
    [anon_sym___inline__] = ACTIONS(2957),
    [anon_sym___forceinline] = ACTIONS(2957),
    [anon_sym_thread_local] = ACTIONS(2957),
    [anon_sym___thread] = ACTIONS(2957),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_constexpr] = ACTIONS(2957),
    [anon_sym_volatile] = ACTIONS(2957),
    [anon_sym_restrict] = ACTIONS(2957),
    [anon_sym___restrict__] = ACTIONS(2957),
    [anon_sym__Atomic] = ACTIONS(2957),
    [anon_sym__Noreturn] = ACTIONS(2957),
    [anon_sym_noreturn] = ACTIONS(2957),
    [anon_sym_mutable] = ACTIONS(2957),
    [anon_sym_constinit] = ACTIONS(2957),
    [anon_sym_consteval] = ACTIONS(2957),
    [anon_sym_PROGMEM] = ACTIONS(2957),
    [aux_sym_primitive_type_token1] = ACTIONS(2957),
    [anon_sym_byte] = ACTIONS(2957),
    [anon_sym_word] = ACTIONS(2957),
    [anon_sym_enum] = ACTIONS(2957),
    [anon_sym_class] = ACTIONS(2957),
    [anon_sym_struct] = ACTIONS(2957),
    [anon_sym_union] = ACTIONS(2957),
    [anon_sym_if] = ACTIONS(2957),
    [anon_sym_switch] = ACTIONS(2957),
    [anon_sym_case] = ACTIONS(2957),
    [anon_sym_default] = ACTIONS(2957),
    [anon_sym_while] = ACTIONS(2957),
    [anon_sym_do] = ACTIONS(2957),
    [anon_sym_for] = ACTIONS(2957),
    [anon_sym_return] = ACTIONS(2957),
    [anon_sym_break] = ACTIONS(2957),
    [anon_sym_continue] = ACTIONS(2957),
    [anon_sym_goto] = ACTIONS(2957),
    [anon_sym___try] = ACTIONS(2957),
    [anon_sym___leave] = ACTIONS(2957),
    [anon_sym_not] = ACTIONS(2957),
    [anon_sym_compl] = ACTIONS(2957),
    [anon_sym_DASH_DASH] = ACTIONS(2959),
    [anon_sym_PLUS_PLUS] = ACTIONS(2959),
    [anon_sym_sizeof] = ACTIONS(2957),
    [anon_sym___alignof__] = ACTIONS(2957),
    [anon_sym___alignof] = ACTIONS(2957),
    [anon_sym__alignof] = ACTIONS(2957),
    [anon_sym_alignof] = ACTIONS(2957),
    [anon_sym__Alignof] = ACTIONS(2957),
    [anon_sym_offsetof] = ACTIONS(2957),
    [anon_sym__Generic] = ACTIONS(2957),
    [anon_sym_asm] = ACTIONS(2957),
    [anon_sym___asm__] = ACTIONS(2957),
    [aux_sym_number_literal_token1] = ACTIONS(2959),
    [aux_sym_number_literal_token2] = ACTIONS(2957),
    [anon_sym_L_SQUOTE] = ACTIONS(2959),
    [anon_sym_u_SQUOTE] = ACTIONS(2959),
    [anon_sym_U_SQUOTE] = ACTIONS(2959),
    [anon_sym_u8_SQUOTE] = ACTIONS(2959),
    [anon_sym_SQUOTE] = ACTIONS(2959),
    [anon_sym_L_DQUOTE] = ACTIONS(2959),
    [anon_sym_u_DQUOTE] = ACTIONS(2959),
    [anon_sym_U_DQUOTE] = ACTIONS(2959),
    [anon_sym_u8_DQUOTE] = ACTIONS(2959),
    [anon_sym_DQUOTE] = ACTIONS(2959),
    [sym_true] = ACTIONS(2957),
    [sym_false] = ACTIONS(2957),
    [anon_sym_NULL] = ACTIONS(2957),
    [anon_sym_nullptr] = ACTIONS(2957),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2957),
    [anon_sym_decltype] = ACTIONS(2957),
    [anon_sym_virtual] = ACTIONS(2957),
    [anon_sym_alignas] = ACTIONS(2957),
    [anon_sym_explicit] = ACTIONS(2957),
    [anon_sym_typename] = ACTIONS(2957),
    [anon_sym_template] = ACTIONS(2957),
    [anon_sym_operator] = ACTIONS(2957),
    [anon_sym_try] = ACTIONS(2957),
    [anon_sym_delete] = ACTIONS(2957),
    [anon_sym_throw] = ACTIONS(2957),
    [anon_sym_namespace] = ACTIONS(2957),
    [anon_sym_using] = ACTIONS(2957),
    [anon_sym_static_assert] = ACTIONS(2957),
    [anon_sym_concept] = ACTIONS(2957),
    [anon_sym_co_return] = ACTIONS(2957),
    [anon_sym_co_yield] = ACTIONS(2957),
    [anon_sym_R_DQUOTE] = ACTIONS(2959),
    [anon_sym_LR_DQUOTE] = ACTIONS(2959),
    [anon_sym_uR_DQUOTE] = ACTIONS(2959),
    [anon_sym_UR_DQUOTE] = ACTIONS(2959),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2959),
    [anon_sym_co_await] = ACTIONS(2957),
    [anon_sym_new] = ACTIONS(2957),
    [anon_sym_requires] = ACTIONS(2957),
    [sym_this] = ACTIONS(2957),
  },
  [356] = {
    [sym_catch_clause] = STATE(368),
    [aux_sym_constructor_try_statement_repeat1] = STATE(368),
    [ts_builtin_sym_end] = ACTIONS(2484),
    [sym_identifier] = ACTIONS(2482),
    [aux_sym_preproc_include_token1] = ACTIONS(2482),
    [aux_sym_preproc_def_token1] = ACTIONS(2482),
    [aux_sym_preproc_if_token1] = ACTIONS(2482),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2482),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2482),
    [sym_preproc_directive] = ACTIONS(2482),
    [anon_sym_LPAREN2] = ACTIONS(2484),
    [anon_sym_BANG] = ACTIONS(2484),
    [anon_sym_TILDE] = ACTIONS(2484),
    [anon_sym_DASH] = ACTIONS(2482),
    [anon_sym_PLUS] = ACTIONS(2482),
    [anon_sym_STAR] = ACTIONS(2484),
    [anon_sym_AMP_AMP] = ACTIONS(2484),
    [anon_sym_AMP] = ACTIONS(2482),
    [anon_sym_SEMI] = ACTIONS(2484),
    [anon_sym___extension__] = ACTIONS(2482),
    [anon_sym_typedef] = ACTIONS(2482),
    [anon_sym_extern] = ACTIONS(2482),
    [anon_sym___attribute__] = ACTIONS(2482),
    [anon_sym_COLON_COLON] = ACTIONS(2484),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2484),
    [anon_sym___declspec] = ACTIONS(2482),
    [anon_sym___based] = ACTIONS(2482),
    [anon_sym___cdecl] = ACTIONS(2482),
    [anon_sym___clrcall] = ACTIONS(2482),
    [anon_sym___stdcall] = ACTIONS(2482),
    [anon_sym___fastcall] = ACTIONS(2482),
    [anon_sym___thiscall] = ACTIONS(2482),
    [anon_sym___vectorcall] = ACTIONS(2482),
    [anon_sym_LBRACE] = ACTIONS(2484),
    [anon_sym_signed] = ACTIONS(2482),
    [anon_sym_unsigned] = ACTIONS(2482),
    [anon_sym_long] = ACTIONS(2482),
    [anon_sym_short] = ACTIONS(2482),
    [anon_sym_LBRACK] = ACTIONS(2482),
    [anon_sym_static] = ACTIONS(2482),
    [anon_sym_register] = ACTIONS(2482),
    [anon_sym_inline] = ACTIONS(2482),
    [anon_sym___inline] = ACTIONS(2482),
    [anon_sym___inline__] = ACTIONS(2482),
    [anon_sym___forceinline] = ACTIONS(2482),
    [anon_sym_thread_local] = ACTIONS(2482),
    [anon_sym___thread] = ACTIONS(2482),
    [anon_sym_const] = ACTIONS(2482),
    [anon_sym_constexpr] = ACTIONS(2482),
    [anon_sym_volatile] = ACTIONS(2482),
    [anon_sym_restrict] = ACTIONS(2482),
    [anon_sym___restrict__] = ACTIONS(2482),
    [anon_sym__Atomic] = ACTIONS(2482),
    [anon_sym__Noreturn] = ACTIONS(2482),
    [anon_sym_noreturn] = ACTIONS(2482),
    [anon_sym_mutable] = ACTIONS(2482),
    [anon_sym_constinit] = ACTIONS(2482),
    [anon_sym_consteval] = ACTIONS(2482),
    [anon_sym_PROGMEM] = ACTIONS(2482),
    [aux_sym_primitive_type_token1] = ACTIONS(2482),
    [anon_sym_byte] = ACTIONS(2482),
    [anon_sym_word] = ACTIONS(2482),
    [anon_sym_enum] = ACTIONS(2482),
    [anon_sym_class] = ACTIONS(2482),
    [anon_sym_struct] = ACTIONS(2482),
    [anon_sym_union] = ACTIONS(2482),
    [anon_sym_if] = ACTIONS(2482),
    [anon_sym_else] = ACTIONS(2482),
    [anon_sym_switch] = ACTIONS(2482),
    [anon_sym_case] = ACTIONS(2482),
    [anon_sym_default] = ACTIONS(2482),
    [anon_sym_while] = ACTIONS(2482),
    [anon_sym_do] = ACTIONS(2482),
    [anon_sym_for] = ACTIONS(2482),
    [anon_sym_return] = ACTIONS(2482),
    [anon_sym_break] = ACTIONS(2482),
    [anon_sym_continue] = ACTIONS(2482),
    [anon_sym_goto] = ACTIONS(2482),
    [anon_sym___try] = ACTIONS(2482),
    [anon_sym___leave] = ACTIONS(2482),
    [anon_sym_not] = ACTIONS(2482),
    [anon_sym_compl] = ACTIONS(2482),
    [anon_sym_DASH_DASH] = ACTIONS(2484),
    [anon_sym_PLUS_PLUS] = ACTIONS(2484),
    [anon_sym_sizeof] = ACTIONS(2482),
    [anon_sym___alignof__] = ACTIONS(2482),
    [anon_sym___alignof] = ACTIONS(2482),
    [anon_sym__alignof] = ACTIONS(2482),
    [anon_sym_alignof] = ACTIONS(2482),
    [anon_sym__Alignof] = ACTIONS(2482),
    [anon_sym_offsetof] = ACTIONS(2482),
    [anon_sym__Generic] = ACTIONS(2482),
    [anon_sym_asm] = ACTIONS(2482),
    [anon_sym___asm__] = ACTIONS(2482),
    [aux_sym_number_literal_token1] = ACTIONS(2484),
    [aux_sym_number_literal_token2] = ACTIONS(2482),
    [anon_sym_L_SQUOTE] = ACTIONS(2484),
    [anon_sym_u_SQUOTE] = ACTIONS(2484),
    [anon_sym_U_SQUOTE] = ACTIONS(2484),
    [anon_sym_u8_SQUOTE] = ACTIONS(2484),
    [anon_sym_SQUOTE] = ACTIONS(2484),
    [anon_sym_L_DQUOTE] = ACTIONS(2484),
    [anon_sym_u_DQUOTE] = ACTIONS(2484),
    [anon_sym_U_DQUOTE] = ACTIONS(2484),
    [anon_sym_u8_DQUOTE] = ACTIONS(2484),
    [anon_sym_DQUOTE] = ACTIONS(2484),
    [sym_true] = ACTIONS(2482),
    [sym_false] = ACTIONS(2482),
    [anon_sym_NULL] = ACTIONS(2482),
    [anon_sym_nullptr] = ACTIONS(2482),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2482),
    [anon_sym_decltype] = ACTIONS(2482),
    [anon_sym_virtual] = ACTIONS(2482),
    [anon_sym_alignas] = ACTIONS(2482),
    [anon_sym_explicit] = ACTIONS(2482),
    [anon_sym_typename] = ACTIONS(2482),
    [anon_sym_template] = ACTIONS(2482),
    [anon_sym_operator] = ACTIONS(2482),
    [anon_sym_try] = ACTIONS(2482),
    [anon_sym_delete] = ACTIONS(2482),
    [anon_sym_throw] = ACTIONS(2482),
    [anon_sym_namespace] = ACTIONS(2482),
    [anon_sym_using] = ACTIONS(2482),
    [anon_sym_static_assert] = ACTIONS(2482),
    [anon_sym_concept] = ACTIONS(2482),
    [anon_sym_co_return] = ACTIONS(2482),
    [anon_sym_co_yield] = ACTIONS(2482),
    [anon_sym_catch] = ACTIONS(2961),
    [anon_sym_R_DQUOTE] = ACTIONS(2484),
    [anon_sym_LR_DQUOTE] = ACTIONS(2484),
    [anon_sym_uR_DQUOTE] = ACTIONS(2484),
    [anon_sym_UR_DQUOTE] = ACTIONS(2484),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2484),
    [anon_sym_co_await] = ACTIONS(2482),
    [anon_sym_new] = ACTIONS(2482),
    [anon_sym_requires] = ACTIONS(2482),
    [sym_this] = ACTIONS(2482),
  },
  [357] = {
    [sym_preproc_def] = STATE(348),
    [sym_preproc_function_def] = STATE(348),
    [sym_preproc_call] = STATE(348),
    [sym_preproc_if_in_field_declaration_list] = STATE(348),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(348),
    [sym_preproc_else_in_field_declaration_list] = STATE(7737),
    [sym_preproc_elif_in_field_declaration_list] = STATE(7737),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(7737),
    [sym_type_definition] = STATE(348),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(5531),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(3150),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(5962),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym__field_declaration_list_item] = STATE(348),
    [sym_field_declaration] = STATE(348),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1838),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(348),
    [sym_operator_cast] = STATE(6510),
    [sym_inline_method_definition] = STATE(348),
    [sym__constructor_specifiers] = STATE(1838),
    [sym_operator_cast_definition] = STATE(348),
    [sym_operator_cast_declaration] = STATE(348),
    [sym_constructor_or_destructor_definition] = STATE(348),
    [sym_constructor_or_destructor_declaration] = STATE(348),
    [sym_friend_declaration] = STATE(348),
    [sym_access_specifier] = STATE(7787),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(2618),
    [sym_template_function] = STATE(6098),
    [sym_using_declaration] = STATE(348),
    [sym_alias_declaration] = STATE(348),
    [sym_static_assert_declaration] = STATE(348),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5301),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_qualified_operator_cast_identifier] = STATE(6510),
    [sym_operator_name] = STATE(6098),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(348),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1961),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1838),
    [sym_identifier] = ACTIONS(2823),
    [aux_sym_preproc_def_token1] = ACTIONS(2825),
    [aux_sym_preproc_if_token1] = ACTIONS(2827),
    [aux_sym_preproc_if_token2] = ACTIONS(2963),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2831),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2831),
    [aux_sym_preproc_else_token1] = ACTIONS(2833),
    [aux_sym_preproc_elif_token1] = ACTIONS(2835),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2837),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2837),
    [sym_preproc_directive] = ACTIONS(2839),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(2849),
    [anon_sym_typedef] = ACTIONS(2851),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(2853),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2857),
    [anon_sym_class] = ACTIONS(2859),
    [anon_sym_struct] = ACTIONS(2861),
    [anon_sym_union] = ACTIONS(2863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(2865),
    [anon_sym_template] = ACTIONS(2867),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(2869),
    [anon_sym_public] = ACTIONS(2871),
    [anon_sym_private] = ACTIONS(2871),
    [anon_sym_protected] = ACTIONS(2871),
    [anon_sym_using] = ACTIONS(2873),
    [anon_sym_static_assert] = ACTIONS(2875),
  },
  [358] = {
    [sym_preproc_def] = STATE(389),
    [sym_preproc_function_def] = STATE(389),
    [sym_preproc_call] = STATE(389),
    [sym_preproc_if_in_field_declaration_list] = STATE(389),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(389),
    [sym_preproc_else_in_field_declaration_list] = STATE(8281),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8281),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8281),
    [sym_type_definition] = STATE(389),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(5531),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(3150),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(5962),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym__field_declaration_list_item] = STATE(389),
    [sym_field_declaration] = STATE(389),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1838),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(389),
    [sym_operator_cast] = STATE(6510),
    [sym_inline_method_definition] = STATE(389),
    [sym__constructor_specifiers] = STATE(1838),
    [sym_operator_cast_definition] = STATE(389),
    [sym_operator_cast_declaration] = STATE(389),
    [sym_constructor_or_destructor_definition] = STATE(389),
    [sym_constructor_or_destructor_declaration] = STATE(389),
    [sym_friend_declaration] = STATE(389),
    [sym_access_specifier] = STATE(7787),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(2618),
    [sym_template_function] = STATE(6098),
    [sym_using_declaration] = STATE(389),
    [sym_alias_declaration] = STATE(389),
    [sym_static_assert_declaration] = STATE(389),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5301),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_qualified_operator_cast_identifier] = STATE(6510),
    [sym_operator_name] = STATE(6098),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(389),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1961),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1838),
    [sym_identifier] = ACTIONS(2823),
    [aux_sym_preproc_def_token1] = ACTIONS(2825),
    [aux_sym_preproc_if_token1] = ACTIONS(2827),
    [aux_sym_preproc_if_token2] = ACTIONS(2965),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2831),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2831),
    [aux_sym_preproc_else_token1] = ACTIONS(2833),
    [aux_sym_preproc_elif_token1] = ACTIONS(2835),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2837),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2837),
    [sym_preproc_directive] = ACTIONS(2839),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(2849),
    [anon_sym_typedef] = ACTIONS(2851),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(2853),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2857),
    [anon_sym_class] = ACTIONS(2859),
    [anon_sym_struct] = ACTIONS(2861),
    [anon_sym_union] = ACTIONS(2863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(2865),
    [anon_sym_template] = ACTIONS(2867),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(2869),
    [anon_sym_public] = ACTIONS(2871),
    [anon_sym_private] = ACTIONS(2871),
    [anon_sym_protected] = ACTIONS(2871),
    [anon_sym_using] = ACTIONS(2873),
    [anon_sym_static_assert] = ACTIONS(2875),
  },
  [359] = {
    [sym_identifier] = ACTIONS(2967),
    [aux_sym_preproc_include_token1] = ACTIONS(2967),
    [aux_sym_preproc_def_token1] = ACTIONS(2967),
    [aux_sym_preproc_if_token1] = ACTIONS(2967),
    [aux_sym_preproc_if_token2] = ACTIONS(2967),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2967),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2967),
    [aux_sym_preproc_else_token1] = ACTIONS(2967),
    [aux_sym_preproc_elif_token1] = ACTIONS(2967),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2967),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2967),
    [sym_preproc_directive] = ACTIONS(2967),
    [anon_sym_LPAREN2] = ACTIONS(2969),
    [anon_sym_BANG] = ACTIONS(2969),
    [anon_sym_TILDE] = ACTIONS(2969),
    [anon_sym_DASH] = ACTIONS(2967),
    [anon_sym_PLUS] = ACTIONS(2967),
    [anon_sym_STAR] = ACTIONS(2969),
    [anon_sym_AMP_AMP] = ACTIONS(2969),
    [anon_sym_AMP] = ACTIONS(2967),
    [anon_sym_SEMI] = ACTIONS(2969),
    [anon_sym___extension__] = ACTIONS(2967),
    [anon_sym_typedef] = ACTIONS(2967),
    [anon_sym_extern] = ACTIONS(2967),
    [anon_sym___attribute__] = ACTIONS(2967),
    [anon_sym_COLON_COLON] = ACTIONS(2969),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2969),
    [anon_sym___declspec] = ACTIONS(2967),
    [anon_sym___based] = ACTIONS(2967),
    [anon_sym___cdecl] = ACTIONS(2967),
    [anon_sym___clrcall] = ACTIONS(2967),
    [anon_sym___stdcall] = ACTIONS(2967),
    [anon_sym___fastcall] = ACTIONS(2967),
    [anon_sym___thiscall] = ACTIONS(2967),
    [anon_sym___vectorcall] = ACTIONS(2967),
    [anon_sym_LBRACE] = ACTIONS(2969),
    [anon_sym_signed] = ACTIONS(2967),
    [anon_sym_unsigned] = ACTIONS(2967),
    [anon_sym_long] = ACTIONS(2967),
    [anon_sym_short] = ACTIONS(2967),
    [anon_sym_LBRACK] = ACTIONS(2967),
    [anon_sym_static] = ACTIONS(2967),
    [anon_sym_register] = ACTIONS(2967),
    [anon_sym_inline] = ACTIONS(2967),
    [anon_sym___inline] = ACTIONS(2967),
    [anon_sym___inline__] = ACTIONS(2967),
    [anon_sym___forceinline] = ACTIONS(2967),
    [anon_sym_thread_local] = ACTIONS(2967),
    [anon_sym___thread] = ACTIONS(2967),
    [anon_sym_const] = ACTIONS(2967),
    [anon_sym_constexpr] = ACTIONS(2967),
    [anon_sym_volatile] = ACTIONS(2967),
    [anon_sym_restrict] = ACTIONS(2967),
    [anon_sym___restrict__] = ACTIONS(2967),
    [anon_sym__Atomic] = ACTIONS(2967),
    [anon_sym__Noreturn] = ACTIONS(2967),
    [anon_sym_noreturn] = ACTIONS(2967),
    [anon_sym_mutable] = ACTIONS(2967),
    [anon_sym_constinit] = ACTIONS(2967),
    [anon_sym_consteval] = ACTIONS(2967),
    [anon_sym_PROGMEM] = ACTIONS(2967),
    [aux_sym_primitive_type_token1] = ACTIONS(2967),
    [anon_sym_byte] = ACTIONS(2967),
    [anon_sym_word] = ACTIONS(2967),
    [anon_sym_enum] = ACTIONS(2967),
    [anon_sym_class] = ACTIONS(2967),
    [anon_sym_struct] = ACTIONS(2967),
    [anon_sym_union] = ACTIONS(2967),
    [anon_sym_if] = ACTIONS(2967),
    [anon_sym_switch] = ACTIONS(2967),
    [anon_sym_case] = ACTIONS(2967),
    [anon_sym_default] = ACTIONS(2967),
    [anon_sym_while] = ACTIONS(2967),
    [anon_sym_do] = ACTIONS(2967),
    [anon_sym_for] = ACTIONS(2967),
    [anon_sym_return] = ACTIONS(2967),
    [anon_sym_break] = ACTIONS(2967),
    [anon_sym_continue] = ACTIONS(2967),
    [anon_sym_goto] = ACTIONS(2967),
    [anon_sym___try] = ACTIONS(2967),
    [anon_sym___leave] = ACTIONS(2967),
    [anon_sym_not] = ACTIONS(2967),
    [anon_sym_compl] = ACTIONS(2967),
    [anon_sym_DASH_DASH] = ACTIONS(2969),
    [anon_sym_PLUS_PLUS] = ACTIONS(2969),
    [anon_sym_sizeof] = ACTIONS(2967),
    [anon_sym___alignof__] = ACTIONS(2967),
    [anon_sym___alignof] = ACTIONS(2967),
    [anon_sym__alignof] = ACTIONS(2967),
    [anon_sym_alignof] = ACTIONS(2967),
    [anon_sym__Alignof] = ACTIONS(2967),
    [anon_sym_offsetof] = ACTIONS(2967),
    [anon_sym__Generic] = ACTIONS(2967),
    [anon_sym_asm] = ACTIONS(2967),
    [anon_sym___asm__] = ACTIONS(2967),
    [aux_sym_number_literal_token1] = ACTIONS(2969),
    [aux_sym_number_literal_token2] = ACTIONS(2967),
    [anon_sym_L_SQUOTE] = ACTIONS(2969),
    [anon_sym_u_SQUOTE] = ACTIONS(2969),
    [anon_sym_U_SQUOTE] = ACTIONS(2969),
    [anon_sym_u8_SQUOTE] = ACTIONS(2969),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_L_DQUOTE] = ACTIONS(2969),
    [anon_sym_u_DQUOTE] = ACTIONS(2969),
    [anon_sym_U_DQUOTE] = ACTIONS(2969),
    [anon_sym_u8_DQUOTE] = ACTIONS(2969),
    [anon_sym_DQUOTE] = ACTIONS(2969),
    [sym_true] = ACTIONS(2967),
    [sym_false] = ACTIONS(2967),
    [anon_sym_NULL] = ACTIONS(2967),
    [anon_sym_nullptr] = ACTIONS(2967),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2967),
    [anon_sym_decltype] = ACTIONS(2967),
    [anon_sym_virtual] = ACTIONS(2967),
    [anon_sym_alignas] = ACTIONS(2967),
    [anon_sym_explicit] = ACTIONS(2967),
    [anon_sym_typename] = ACTIONS(2967),
    [anon_sym_template] = ACTIONS(2967),
    [anon_sym_operator] = ACTIONS(2967),
    [anon_sym_try] = ACTIONS(2967),
    [anon_sym_delete] = ACTIONS(2967),
    [anon_sym_throw] = ACTIONS(2967),
    [anon_sym_namespace] = ACTIONS(2967),
    [anon_sym_using] = ACTIONS(2967),
    [anon_sym_static_assert] = ACTIONS(2967),
    [anon_sym_concept] = ACTIONS(2967),
    [anon_sym_co_return] = ACTIONS(2967),
    [anon_sym_co_yield] = ACTIONS(2967),
    [anon_sym_R_DQUOTE] = ACTIONS(2969),
    [anon_sym_LR_DQUOTE] = ACTIONS(2969),
    [anon_sym_uR_DQUOTE] = ACTIONS(2969),
    [anon_sym_UR_DQUOTE] = ACTIONS(2969),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2969),
    [anon_sym_co_await] = ACTIONS(2967),
    [anon_sym_new] = ACTIONS(2967),
    [anon_sym_requires] = ACTIONS(2967),
    [sym_this] = ACTIONS(2967),
  },
  [360] = {
    [sym_identifier] = ACTIONS(2971),
    [aux_sym_preproc_include_token1] = ACTIONS(2971),
    [aux_sym_preproc_def_token1] = ACTIONS(2971),
    [aux_sym_preproc_if_token1] = ACTIONS(2971),
    [aux_sym_preproc_if_token2] = ACTIONS(2971),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2971),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2971),
    [aux_sym_preproc_else_token1] = ACTIONS(2971),
    [aux_sym_preproc_elif_token1] = ACTIONS(2971),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2971),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2971),
    [sym_preproc_directive] = ACTIONS(2971),
    [anon_sym_LPAREN2] = ACTIONS(2973),
    [anon_sym_BANG] = ACTIONS(2973),
    [anon_sym_TILDE] = ACTIONS(2973),
    [anon_sym_DASH] = ACTIONS(2971),
    [anon_sym_PLUS] = ACTIONS(2971),
    [anon_sym_STAR] = ACTIONS(2973),
    [anon_sym_AMP_AMP] = ACTIONS(2973),
    [anon_sym_AMP] = ACTIONS(2971),
    [anon_sym_SEMI] = ACTIONS(2973),
    [anon_sym___extension__] = ACTIONS(2971),
    [anon_sym_typedef] = ACTIONS(2971),
    [anon_sym_extern] = ACTIONS(2971),
    [anon_sym___attribute__] = ACTIONS(2971),
    [anon_sym_COLON_COLON] = ACTIONS(2973),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2973),
    [anon_sym___declspec] = ACTIONS(2971),
    [anon_sym___based] = ACTIONS(2971),
    [anon_sym___cdecl] = ACTIONS(2971),
    [anon_sym___clrcall] = ACTIONS(2971),
    [anon_sym___stdcall] = ACTIONS(2971),
    [anon_sym___fastcall] = ACTIONS(2971),
    [anon_sym___thiscall] = ACTIONS(2971),
    [anon_sym___vectorcall] = ACTIONS(2971),
    [anon_sym_LBRACE] = ACTIONS(2973),
    [anon_sym_signed] = ACTIONS(2971),
    [anon_sym_unsigned] = ACTIONS(2971),
    [anon_sym_long] = ACTIONS(2971),
    [anon_sym_short] = ACTIONS(2971),
    [anon_sym_LBRACK] = ACTIONS(2971),
    [anon_sym_static] = ACTIONS(2971),
    [anon_sym_register] = ACTIONS(2971),
    [anon_sym_inline] = ACTIONS(2971),
    [anon_sym___inline] = ACTIONS(2971),
    [anon_sym___inline__] = ACTIONS(2971),
    [anon_sym___forceinline] = ACTIONS(2971),
    [anon_sym_thread_local] = ACTIONS(2971),
    [anon_sym___thread] = ACTIONS(2971),
    [anon_sym_const] = ACTIONS(2971),
    [anon_sym_constexpr] = ACTIONS(2971),
    [anon_sym_volatile] = ACTIONS(2971),
    [anon_sym_restrict] = ACTIONS(2971),
    [anon_sym___restrict__] = ACTIONS(2971),
    [anon_sym__Atomic] = ACTIONS(2971),
    [anon_sym__Noreturn] = ACTIONS(2971),
    [anon_sym_noreturn] = ACTIONS(2971),
    [anon_sym_mutable] = ACTIONS(2971),
    [anon_sym_constinit] = ACTIONS(2971),
    [anon_sym_consteval] = ACTIONS(2971),
    [anon_sym_PROGMEM] = ACTIONS(2971),
    [aux_sym_primitive_type_token1] = ACTIONS(2971),
    [anon_sym_byte] = ACTIONS(2971),
    [anon_sym_word] = ACTIONS(2971),
    [anon_sym_enum] = ACTIONS(2971),
    [anon_sym_class] = ACTIONS(2971),
    [anon_sym_struct] = ACTIONS(2971),
    [anon_sym_union] = ACTIONS(2971),
    [anon_sym_if] = ACTIONS(2971),
    [anon_sym_switch] = ACTIONS(2971),
    [anon_sym_case] = ACTIONS(2971),
    [anon_sym_default] = ACTIONS(2971),
    [anon_sym_while] = ACTIONS(2971),
    [anon_sym_do] = ACTIONS(2971),
    [anon_sym_for] = ACTIONS(2971),
    [anon_sym_return] = ACTIONS(2971),
    [anon_sym_break] = ACTIONS(2971),
    [anon_sym_continue] = ACTIONS(2971),
    [anon_sym_goto] = ACTIONS(2971),
    [anon_sym___try] = ACTIONS(2971),
    [anon_sym___leave] = ACTIONS(2971),
    [anon_sym_not] = ACTIONS(2971),
    [anon_sym_compl] = ACTIONS(2971),
    [anon_sym_DASH_DASH] = ACTIONS(2973),
    [anon_sym_PLUS_PLUS] = ACTIONS(2973),
    [anon_sym_sizeof] = ACTIONS(2971),
    [anon_sym___alignof__] = ACTIONS(2971),
    [anon_sym___alignof] = ACTIONS(2971),
    [anon_sym__alignof] = ACTIONS(2971),
    [anon_sym_alignof] = ACTIONS(2971),
    [anon_sym__Alignof] = ACTIONS(2971),
    [anon_sym_offsetof] = ACTIONS(2971),
    [anon_sym__Generic] = ACTIONS(2971),
    [anon_sym_asm] = ACTIONS(2971),
    [anon_sym___asm__] = ACTIONS(2971),
    [aux_sym_number_literal_token1] = ACTIONS(2973),
    [aux_sym_number_literal_token2] = ACTIONS(2971),
    [anon_sym_L_SQUOTE] = ACTIONS(2973),
    [anon_sym_u_SQUOTE] = ACTIONS(2973),
    [anon_sym_U_SQUOTE] = ACTIONS(2973),
    [anon_sym_u8_SQUOTE] = ACTIONS(2973),
    [anon_sym_SQUOTE] = ACTIONS(2973),
    [anon_sym_L_DQUOTE] = ACTIONS(2973),
    [anon_sym_u_DQUOTE] = ACTIONS(2973),
    [anon_sym_U_DQUOTE] = ACTIONS(2973),
    [anon_sym_u8_DQUOTE] = ACTIONS(2973),
    [anon_sym_DQUOTE] = ACTIONS(2973),
    [sym_true] = ACTIONS(2971),
    [sym_false] = ACTIONS(2971),
    [anon_sym_NULL] = ACTIONS(2971),
    [anon_sym_nullptr] = ACTIONS(2971),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2971),
    [anon_sym_decltype] = ACTIONS(2971),
    [anon_sym_virtual] = ACTIONS(2971),
    [anon_sym_alignas] = ACTIONS(2971),
    [anon_sym_explicit] = ACTIONS(2971),
    [anon_sym_typename] = ACTIONS(2971),
    [anon_sym_template] = ACTIONS(2971),
    [anon_sym_operator] = ACTIONS(2971),
    [anon_sym_try] = ACTIONS(2971),
    [anon_sym_delete] = ACTIONS(2971),
    [anon_sym_throw] = ACTIONS(2971),
    [anon_sym_namespace] = ACTIONS(2971),
    [anon_sym_using] = ACTIONS(2971),
    [anon_sym_static_assert] = ACTIONS(2971),
    [anon_sym_concept] = ACTIONS(2971),
    [anon_sym_co_return] = ACTIONS(2971),
    [anon_sym_co_yield] = ACTIONS(2971),
    [anon_sym_R_DQUOTE] = ACTIONS(2973),
    [anon_sym_LR_DQUOTE] = ACTIONS(2973),
    [anon_sym_uR_DQUOTE] = ACTIONS(2973),
    [anon_sym_UR_DQUOTE] = ACTIONS(2973),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2973),
    [anon_sym_co_await] = ACTIONS(2971),
    [anon_sym_new] = ACTIONS(2971),
    [anon_sym_requires] = ACTIONS(2971),
    [sym_this] = ACTIONS(2971),
  },
  [361] = {
    [sym_identifier] = ACTIONS(2975),
    [aux_sym_preproc_include_token1] = ACTIONS(2975),
    [aux_sym_preproc_def_token1] = ACTIONS(2975),
    [aux_sym_preproc_if_token1] = ACTIONS(2975),
    [aux_sym_preproc_if_token2] = ACTIONS(2975),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2975),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2975),
    [aux_sym_preproc_else_token1] = ACTIONS(2975),
    [aux_sym_preproc_elif_token1] = ACTIONS(2975),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2975),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2975),
    [sym_preproc_directive] = ACTIONS(2975),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_BANG] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2975),
    [anon_sym_PLUS] = ACTIONS(2975),
    [anon_sym_STAR] = ACTIONS(2977),
    [anon_sym_AMP_AMP] = ACTIONS(2977),
    [anon_sym_AMP] = ACTIONS(2975),
    [anon_sym_SEMI] = ACTIONS(2977),
    [anon_sym___extension__] = ACTIONS(2975),
    [anon_sym_typedef] = ACTIONS(2975),
    [anon_sym_extern] = ACTIONS(2975),
    [anon_sym___attribute__] = ACTIONS(2975),
    [anon_sym_COLON_COLON] = ACTIONS(2977),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2977),
    [anon_sym___declspec] = ACTIONS(2975),
    [anon_sym___based] = ACTIONS(2975),
    [anon_sym___cdecl] = ACTIONS(2975),
    [anon_sym___clrcall] = ACTIONS(2975),
    [anon_sym___stdcall] = ACTIONS(2975),
    [anon_sym___fastcall] = ACTIONS(2975),
    [anon_sym___thiscall] = ACTIONS(2975),
    [anon_sym___vectorcall] = ACTIONS(2975),
    [anon_sym_LBRACE] = ACTIONS(2977),
    [anon_sym_signed] = ACTIONS(2975),
    [anon_sym_unsigned] = ACTIONS(2975),
    [anon_sym_long] = ACTIONS(2975),
    [anon_sym_short] = ACTIONS(2975),
    [anon_sym_LBRACK] = ACTIONS(2975),
    [anon_sym_static] = ACTIONS(2975),
    [anon_sym_register] = ACTIONS(2975),
    [anon_sym_inline] = ACTIONS(2975),
    [anon_sym___inline] = ACTIONS(2975),
    [anon_sym___inline__] = ACTIONS(2975),
    [anon_sym___forceinline] = ACTIONS(2975),
    [anon_sym_thread_local] = ACTIONS(2975),
    [anon_sym___thread] = ACTIONS(2975),
    [anon_sym_const] = ACTIONS(2975),
    [anon_sym_constexpr] = ACTIONS(2975),
    [anon_sym_volatile] = ACTIONS(2975),
    [anon_sym_restrict] = ACTIONS(2975),
    [anon_sym___restrict__] = ACTIONS(2975),
    [anon_sym__Atomic] = ACTIONS(2975),
    [anon_sym__Noreturn] = ACTIONS(2975),
    [anon_sym_noreturn] = ACTIONS(2975),
    [anon_sym_mutable] = ACTIONS(2975),
    [anon_sym_constinit] = ACTIONS(2975),
    [anon_sym_consteval] = ACTIONS(2975),
    [anon_sym_PROGMEM] = ACTIONS(2975),
    [aux_sym_primitive_type_token1] = ACTIONS(2975),
    [anon_sym_byte] = ACTIONS(2975),
    [anon_sym_word] = ACTIONS(2975),
    [anon_sym_enum] = ACTIONS(2975),
    [anon_sym_class] = ACTIONS(2975),
    [anon_sym_struct] = ACTIONS(2975),
    [anon_sym_union] = ACTIONS(2975),
    [anon_sym_if] = ACTIONS(2975),
    [anon_sym_switch] = ACTIONS(2975),
    [anon_sym_case] = ACTIONS(2975),
    [anon_sym_default] = ACTIONS(2975),
    [anon_sym_while] = ACTIONS(2975),
    [anon_sym_do] = ACTIONS(2975),
    [anon_sym_for] = ACTIONS(2975),
    [anon_sym_return] = ACTIONS(2975),
    [anon_sym_break] = ACTIONS(2975),
    [anon_sym_continue] = ACTIONS(2975),
    [anon_sym_goto] = ACTIONS(2975),
    [anon_sym___try] = ACTIONS(2975),
    [anon_sym___leave] = ACTIONS(2975),
    [anon_sym_not] = ACTIONS(2975),
    [anon_sym_compl] = ACTIONS(2975),
    [anon_sym_DASH_DASH] = ACTIONS(2977),
    [anon_sym_PLUS_PLUS] = ACTIONS(2977),
    [anon_sym_sizeof] = ACTIONS(2975),
    [anon_sym___alignof__] = ACTIONS(2975),
    [anon_sym___alignof] = ACTIONS(2975),
    [anon_sym__alignof] = ACTIONS(2975),
    [anon_sym_alignof] = ACTIONS(2975),
    [anon_sym__Alignof] = ACTIONS(2975),
    [anon_sym_offsetof] = ACTIONS(2975),
    [anon_sym__Generic] = ACTIONS(2975),
    [anon_sym_asm] = ACTIONS(2975),
    [anon_sym___asm__] = ACTIONS(2975),
    [aux_sym_number_literal_token1] = ACTIONS(2977),
    [aux_sym_number_literal_token2] = ACTIONS(2975),
    [anon_sym_L_SQUOTE] = ACTIONS(2977),
    [anon_sym_u_SQUOTE] = ACTIONS(2977),
    [anon_sym_U_SQUOTE] = ACTIONS(2977),
    [anon_sym_u8_SQUOTE] = ACTIONS(2977),
    [anon_sym_SQUOTE] = ACTIONS(2977),
    [anon_sym_L_DQUOTE] = ACTIONS(2977),
    [anon_sym_u_DQUOTE] = ACTIONS(2977),
    [anon_sym_U_DQUOTE] = ACTIONS(2977),
    [anon_sym_u8_DQUOTE] = ACTIONS(2977),
    [anon_sym_DQUOTE] = ACTIONS(2977),
    [sym_true] = ACTIONS(2975),
    [sym_false] = ACTIONS(2975),
    [anon_sym_NULL] = ACTIONS(2975),
    [anon_sym_nullptr] = ACTIONS(2975),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2975),
    [anon_sym_decltype] = ACTIONS(2975),
    [anon_sym_virtual] = ACTIONS(2975),
    [anon_sym_alignas] = ACTIONS(2975),
    [anon_sym_explicit] = ACTIONS(2975),
    [anon_sym_typename] = ACTIONS(2975),
    [anon_sym_template] = ACTIONS(2975),
    [anon_sym_operator] = ACTIONS(2975),
    [anon_sym_try] = ACTIONS(2975),
    [anon_sym_delete] = ACTIONS(2975),
    [anon_sym_throw] = ACTIONS(2975),
    [anon_sym_namespace] = ACTIONS(2975),
    [anon_sym_using] = ACTIONS(2975),
    [anon_sym_static_assert] = ACTIONS(2975),
    [anon_sym_concept] = ACTIONS(2975),
    [anon_sym_co_return] = ACTIONS(2975),
    [anon_sym_co_yield] = ACTIONS(2975),
    [anon_sym_R_DQUOTE] = ACTIONS(2977),
    [anon_sym_LR_DQUOTE] = ACTIONS(2977),
    [anon_sym_uR_DQUOTE] = ACTIONS(2977),
    [anon_sym_UR_DQUOTE] = ACTIONS(2977),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2977),
    [anon_sym_co_await] = ACTIONS(2975),
    [anon_sym_new] = ACTIONS(2975),
    [anon_sym_requires] = ACTIONS(2975),
    [sym_this] = ACTIONS(2975),
  },
  [362] = {
    [sym_identifier] = ACTIONS(2979),
    [aux_sym_preproc_include_token1] = ACTIONS(2979),
    [aux_sym_preproc_def_token1] = ACTIONS(2979),
    [aux_sym_preproc_if_token1] = ACTIONS(2979),
    [aux_sym_preproc_if_token2] = ACTIONS(2979),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2979),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2979),
    [aux_sym_preproc_else_token1] = ACTIONS(2979),
    [aux_sym_preproc_elif_token1] = ACTIONS(2979),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2979),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2979),
    [sym_preproc_directive] = ACTIONS(2979),
    [anon_sym_LPAREN2] = ACTIONS(2981),
    [anon_sym_BANG] = ACTIONS(2981),
    [anon_sym_TILDE] = ACTIONS(2981),
    [anon_sym_DASH] = ACTIONS(2979),
    [anon_sym_PLUS] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(2981),
    [anon_sym_AMP] = ACTIONS(2979),
    [anon_sym_SEMI] = ACTIONS(2981),
    [anon_sym___extension__] = ACTIONS(2979),
    [anon_sym_typedef] = ACTIONS(2979),
    [anon_sym_extern] = ACTIONS(2979),
    [anon_sym___attribute__] = ACTIONS(2979),
    [anon_sym_COLON_COLON] = ACTIONS(2981),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2981),
    [anon_sym___declspec] = ACTIONS(2979),
    [anon_sym___based] = ACTIONS(2979),
    [anon_sym___cdecl] = ACTIONS(2979),
    [anon_sym___clrcall] = ACTIONS(2979),
    [anon_sym___stdcall] = ACTIONS(2979),
    [anon_sym___fastcall] = ACTIONS(2979),
    [anon_sym___thiscall] = ACTIONS(2979),
    [anon_sym___vectorcall] = ACTIONS(2979),
    [anon_sym_LBRACE] = ACTIONS(2981),
    [anon_sym_signed] = ACTIONS(2979),
    [anon_sym_unsigned] = ACTIONS(2979),
    [anon_sym_long] = ACTIONS(2979),
    [anon_sym_short] = ACTIONS(2979),
    [anon_sym_LBRACK] = ACTIONS(2979),
    [anon_sym_static] = ACTIONS(2979),
    [anon_sym_register] = ACTIONS(2979),
    [anon_sym_inline] = ACTIONS(2979),
    [anon_sym___inline] = ACTIONS(2979),
    [anon_sym___inline__] = ACTIONS(2979),
    [anon_sym___forceinline] = ACTIONS(2979),
    [anon_sym_thread_local] = ACTIONS(2979),
    [anon_sym___thread] = ACTIONS(2979),
    [anon_sym_const] = ACTIONS(2979),
    [anon_sym_constexpr] = ACTIONS(2979),
    [anon_sym_volatile] = ACTIONS(2979),
    [anon_sym_restrict] = ACTIONS(2979),
    [anon_sym___restrict__] = ACTIONS(2979),
    [anon_sym__Atomic] = ACTIONS(2979),
    [anon_sym__Noreturn] = ACTIONS(2979),
    [anon_sym_noreturn] = ACTIONS(2979),
    [anon_sym_mutable] = ACTIONS(2979),
    [anon_sym_constinit] = ACTIONS(2979),
    [anon_sym_consteval] = ACTIONS(2979),
    [anon_sym_PROGMEM] = ACTIONS(2979),
    [aux_sym_primitive_type_token1] = ACTIONS(2979),
    [anon_sym_byte] = ACTIONS(2979),
    [anon_sym_word] = ACTIONS(2979),
    [anon_sym_enum] = ACTIONS(2979),
    [anon_sym_class] = ACTIONS(2979),
    [anon_sym_struct] = ACTIONS(2979),
    [anon_sym_union] = ACTIONS(2979),
    [anon_sym_if] = ACTIONS(2979),
    [anon_sym_switch] = ACTIONS(2979),
    [anon_sym_case] = ACTIONS(2979),
    [anon_sym_default] = ACTIONS(2979),
    [anon_sym_while] = ACTIONS(2979),
    [anon_sym_do] = ACTIONS(2979),
    [anon_sym_for] = ACTIONS(2979),
    [anon_sym_return] = ACTIONS(2979),
    [anon_sym_break] = ACTIONS(2979),
    [anon_sym_continue] = ACTIONS(2979),
    [anon_sym_goto] = ACTIONS(2979),
    [anon_sym___try] = ACTIONS(2979),
    [anon_sym___leave] = ACTIONS(2979),
    [anon_sym_not] = ACTIONS(2979),
    [anon_sym_compl] = ACTIONS(2979),
    [anon_sym_DASH_DASH] = ACTIONS(2981),
    [anon_sym_PLUS_PLUS] = ACTIONS(2981),
    [anon_sym_sizeof] = ACTIONS(2979),
    [anon_sym___alignof__] = ACTIONS(2979),
    [anon_sym___alignof] = ACTIONS(2979),
    [anon_sym__alignof] = ACTIONS(2979),
    [anon_sym_alignof] = ACTIONS(2979),
    [anon_sym__Alignof] = ACTIONS(2979),
    [anon_sym_offsetof] = ACTIONS(2979),
    [anon_sym__Generic] = ACTIONS(2979),
    [anon_sym_asm] = ACTIONS(2979),
    [anon_sym___asm__] = ACTIONS(2979),
    [aux_sym_number_literal_token1] = ACTIONS(2981),
    [aux_sym_number_literal_token2] = ACTIONS(2979),
    [anon_sym_L_SQUOTE] = ACTIONS(2981),
    [anon_sym_u_SQUOTE] = ACTIONS(2981),
    [anon_sym_U_SQUOTE] = ACTIONS(2981),
    [anon_sym_u8_SQUOTE] = ACTIONS(2981),
    [anon_sym_SQUOTE] = ACTIONS(2981),
    [anon_sym_L_DQUOTE] = ACTIONS(2981),
    [anon_sym_u_DQUOTE] = ACTIONS(2981),
    [anon_sym_U_DQUOTE] = ACTIONS(2981),
    [anon_sym_u8_DQUOTE] = ACTIONS(2981),
    [anon_sym_DQUOTE] = ACTIONS(2981),
    [sym_true] = ACTIONS(2979),
    [sym_false] = ACTIONS(2979),
    [anon_sym_NULL] = ACTIONS(2979),
    [anon_sym_nullptr] = ACTIONS(2979),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2979),
    [anon_sym_decltype] = ACTIONS(2979),
    [anon_sym_virtual] = ACTIONS(2979),
    [anon_sym_alignas] = ACTIONS(2979),
    [anon_sym_explicit] = ACTIONS(2979),
    [anon_sym_typename] = ACTIONS(2979),
    [anon_sym_template] = ACTIONS(2979),
    [anon_sym_operator] = ACTIONS(2979),
    [anon_sym_try] = ACTIONS(2979),
    [anon_sym_delete] = ACTIONS(2979),
    [anon_sym_throw] = ACTIONS(2979),
    [anon_sym_namespace] = ACTIONS(2979),
    [anon_sym_using] = ACTIONS(2979),
    [anon_sym_static_assert] = ACTIONS(2979),
    [anon_sym_concept] = ACTIONS(2979),
    [anon_sym_co_return] = ACTIONS(2979),
    [anon_sym_co_yield] = ACTIONS(2979),
    [anon_sym_R_DQUOTE] = ACTIONS(2981),
    [anon_sym_LR_DQUOTE] = ACTIONS(2981),
    [anon_sym_uR_DQUOTE] = ACTIONS(2981),
    [anon_sym_UR_DQUOTE] = ACTIONS(2981),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2981),
    [anon_sym_co_await] = ACTIONS(2979),
    [anon_sym_new] = ACTIONS(2979),
    [anon_sym_requires] = ACTIONS(2979),
    [sym_this] = ACTIONS(2979),
  },
  [363] = {
    [sym_preproc_def] = STATE(541),
    [sym_preproc_function_def] = STATE(541),
    [sym_preproc_call] = STATE(541),
    [sym_preproc_if_in_field_declaration_list] = STATE(541),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(541),
    [sym_preproc_else_in_field_declaration_list] = STATE(8272),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8272),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8272),
    [sym_type_definition] = STATE(541),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(5531),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(3150),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(5962),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym__field_declaration_list_item] = STATE(541),
    [sym_field_declaration] = STATE(541),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1838),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(541),
    [sym_operator_cast] = STATE(6510),
    [sym_inline_method_definition] = STATE(541),
    [sym__constructor_specifiers] = STATE(1838),
    [sym_operator_cast_definition] = STATE(541),
    [sym_operator_cast_declaration] = STATE(541),
    [sym_constructor_or_destructor_definition] = STATE(541),
    [sym_constructor_or_destructor_declaration] = STATE(541),
    [sym_friend_declaration] = STATE(541),
    [sym_access_specifier] = STATE(7787),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(2618),
    [sym_template_function] = STATE(6098),
    [sym_using_declaration] = STATE(541),
    [sym_alias_declaration] = STATE(541),
    [sym_static_assert_declaration] = STATE(541),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5301),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_qualified_operator_cast_identifier] = STATE(6510),
    [sym_operator_name] = STATE(6098),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(541),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1961),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1838),
    [sym_identifier] = ACTIONS(2823),
    [aux_sym_preproc_def_token1] = ACTIONS(2825),
    [aux_sym_preproc_if_token1] = ACTIONS(2827),
    [aux_sym_preproc_if_token2] = ACTIONS(2983),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2831),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2831),
    [aux_sym_preproc_else_token1] = ACTIONS(2833),
    [aux_sym_preproc_elif_token1] = ACTIONS(2835),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2837),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2837),
    [sym_preproc_directive] = ACTIONS(2839),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(2849),
    [anon_sym_typedef] = ACTIONS(2851),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(2853),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2857),
    [anon_sym_class] = ACTIONS(2859),
    [anon_sym_struct] = ACTIONS(2861),
    [anon_sym_union] = ACTIONS(2863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(2865),
    [anon_sym_template] = ACTIONS(2867),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(2869),
    [anon_sym_public] = ACTIONS(2871),
    [anon_sym_private] = ACTIONS(2871),
    [anon_sym_protected] = ACTIONS(2871),
    [anon_sym_using] = ACTIONS(2873),
    [anon_sym_static_assert] = ACTIONS(2875),
  },
  [364] = {
    [sym_identifier] = ACTIONS(2985),
    [aux_sym_preproc_include_token1] = ACTIONS(2985),
    [aux_sym_preproc_def_token1] = ACTIONS(2985),
    [aux_sym_preproc_if_token1] = ACTIONS(2985),
    [aux_sym_preproc_if_token2] = ACTIONS(2985),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2985),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2985),
    [aux_sym_preproc_else_token1] = ACTIONS(2985),
    [aux_sym_preproc_elif_token1] = ACTIONS(2985),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2985),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2985),
    [sym_preproc_directive] = ACTIONS(2985),
    [anon_sym_LPAREN2] = ACTIONS(2987),
    [anon_sym_BANG] = ACTIONS(2987),
    [anon_sym_TILDE] = ACTIONS(2987),
    [anon_sym_DASH] = ACTIONS(2985),
    [anon_sym_PLUS] = ACTIONS(2985),
    [anon_sym_STAR] = ACTIONS(2987),
    [anon_sym_AMP_AMP] = ACTIONS(2987),
    [anon_sym_AMP] = ACTIONS(2985),
    [anon_sym_SEMI] = ACTIONS(2987),
    [anon_sym___extension__] = ACTIONS(2985),
    [anon_sym_typedef] = ACTIONS(2985),
    [anon_sym_extern] = ACTIONS(2985),
    [anon_sym___attribute__] = ACTIONS(2985),
    [anon_sym_COLON_COLON] = ACTIONS(2987),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2987),
    [anon_sym___declspec] = ACTIONS(2985),
    [anon_sym___based] = ACTIONS(2985),
    [anon_sym___cdecl] = ACTIONS(2985),
    [anon_sym___clrcall] = ACTIONS(2985),
    [anon_sym___stdcall] = ACTIONS(2985),
    [anon_sym___fastcall] = ACTIONS(2985),
    [anon_sym___thiscall] = ACTIONS(2985),
    [anon_sym___vectorcall] = ACTIONS(2985),
    [anon_sym_LBRACE] = ACTIONS(2987),
    [anon_sym_signed] = ACTIONS(2985),
    [anon_sym_unsigned] = ACTIONS(2985),
    [anon_sym_long] = ACTIONS(2985),
    [anon_sym_short] = ACTIONS(2985),
    [anon_sym_LBRACK] = ACTIONS(2985),
    [anon_sym_static] = ACTIONS(2985),
    [anon_sym_register] = ACTIONS(2985),
    [anon_sym_inline] = ACTIONS(2985),
    [anon_sym___inline] = ACTIONS(2985),
    [anon_sym___inline__] = ACTIONS(2985),
    [anon_sym___forceinline] = ACTIONS(2985),
    [anon_sym_thread_local] = ACTIONS(2985),
    [anon_sym___thread] = ACTIONS(2985),
    [anon_sym_const] = ACTIONS(2985),
    [anon_sym_constexpr] = ACTIONS(2985),
    [anon_sym_volatile] = ACTIONS(2985),
    [anon_sym_restrict] = ACTIONS(2985),
    [anon_sym___restrict__] = ACTIONS(2985),
    [anon_sym__Atomic] = ACTIONS(2985),
    [anon_sym__Noreturn] = ACTIONS(2985),
    [anon_sym_noreturn] = ACTIONS(2985),
    [anon_sym_mutable] = ACTIONS(2985),
    [anon_sym_constinit] = ACTIONS(2985),
    [anon_sym_consteval] = ACTIONS(2985),
    [anon_sym_PROGMEM] = ACTIONS(2985),
    [aux_sym_primitive_type_token1] = ACTIONS(2985),
    [anon_sym_byte] = ACTIONS(2985),
    [anon_sym_word] = ACTIONS(2985),
    [anon_sym_enum] = ACTIONS(2985),
    [anon_sym_class] = ACTIONS(2985),
    [anon_sym_struct] = ACTIONS(2985),
    [anon_sym_union] = ACTIONS(2985),
    [anon_sym_if] = ACTIONS(2985),
    [anon_sym_switch] = ACTIONS(2985),
    [anon_sym_case] = ACTIONS(2985),
    [anon_sym_default] = ACTIONS(2985),
    [anon_sym_while] = ACTIONS(2985),
    [anon_sym_do] = ACTIONS(2985),
    [anon_sym_for] = ACTIONS(2985),
    [anon_sym_return] = ACTIONS(2985),
    [anon_sym_break] = ACTIONS(2985),
    [anon_sym_continue] = ACTIONS(2985),
    [anon_sym_goto] = ACTIONS(2985),
    [anon_sym___try] = ACTIONS(2985),
    [anon_sym___leave] = ACTIONS(2985),
    [anon_sym_not] = ACTIONS(2985),
    [anon_sym_compl] = ACTIONS(2985),
    [anon_sym_DASH_DASH] = ACTIONS(2987),
    [anon_sym_PLUS_PLUS] = ACTIONS(2987),
    [anon_sym_sizeof] = ACTIONS(2985),
    [anon_sym___alignof__] = ACTIONS(2985),
    [anon_sym___alignof] = ACTIONS(2985),
    [anon_sym__alignof] = ACTIONS(2985),
    [anon_sym_alignof] = ACTIONS(2985),
    [anon_sym__Alignof] = ACTIONS(2985),
    [anon_sym_offsetof] = ACTIONS(2985),
    [anon_sym__Generic] = ACTIONS(2985),
    [anon_sym_asm] = ACTIONS(2985),
    [anon_sym___asm__] = ACTIONS(2985),
    [aux_sym_number_literal_token1] = ACTIONS(2987),
    [aux_sym_number_literal_token2] = ACTIONS(2985),
    [anon_sym_L_SQUOTE] = ACTIONS(2987),
    [anon_sym_u_SQUOTE] = ACTIONS(2987),
    [anon_sym_U_SQUOTE] = ACTIONS(2987),
    [anon_sym_u8_SQUOTE] = ACTIONS(2987),
    [anon_sym_SQUOTE] = ACTIONS(2987),
    [anon_sym_L_DQUOTE] = ACTIONS(2987),
    [anon_sym_u_DQUOTE] = ACTIONS(2987),
    [anon_sym_U_DQUOTE] = ACTIONS(2987),
    [anon_sym_u8_DQUOTE] = ACTIONS(2987),
    [anon_sym_DQUOTE] = ACTIONS(2987),
    [sym_true] = ACTIONS(2985),
    [sym_false] = ACTIONS(2985),
    [anon_sym_NULL] = ACTIONS(2985),
    [anon_sym_nullptr] = ACTIONS(2985),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2985),
    [anon_sym_decltype] = ACTIONS(2985),
    [anon_sym_virtual] = ACTIONS(2985),
    [anon_sym_alignas] = ACTIONS(2985),
    [anon_sym_explicit] = ACTIONS(2985),
    [anon_sym_typename] = ACTIONS(2985),
    [anon_sym_template] = ACTIONS(2985),
    [anon_sym_operator] = ACTIONS(2985),
    [anon_sym_try] = ACTIONS(2985),
    [anon_sym_delete] = ACTIONS(2985),
    [anon_sym_throw] = ACTIONS(2985),
    [anon_sym_namespace] = ACTIONS(2985),
    [anon_sym_using] = ACTIONS(2985),
    [anon_sym_static_assert] = ACTIONS(2985),
    [anon_sym_concept] = ACTIONS(2985),
    [anon_sym_co_return] = ACTIONS(2985),
    [anon_sym_co_yield] = ACTIONS(2985),
    [anon_sym_R_DQUOTE] = ACTIONS(2987),
    [anon_sym_LR_DQUOTE] = ACTIONS(2987),
    [anon_sym_uR_DQUOTE] = ACTIONS(2987),
    [anon_sym_UR_DQUOTE] = ACTIONS(2987),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2987),
    [anon_sym_co_await] = ACTIONS(2985),
    [anon_sym_new] = ACTIONS(2985),
    [anon_sym_requires] = ACTIONS(2985),
    [sym_this] = ACTIONS(2985),
  },
  [365] = {
    [sym_identifier] = ACTIONS(2989),
    [aux_sym_preproc_include_token1] = ACTIONS(2989),
    [aux_sym_preproc_def_token1] = ACTIONS(2989),
    [aux_sym_preproc_if_token1] = ACTIONS(2989),
    [aux_sym_preproc_if_token2] = ACTIONS(2989),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2989),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2989),
    [aux_sym_preproc_else_token1] = ACTIONS(2989),
    [aux_sym_preproc_elif_token1] = ACTIONS(2989),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2989),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2989),
    [sym_preproc_directive] = ACTIONS(2989),
    [anon_sym_LPAREN2] = ACTIONS(2991),
    [anon_sym_BANG] = ACTIONS(2991),
    [anon_sym_TILDE] = ACTIONS(2991),
    [anon_sym_DASH] = ACTIONS(2989),
    [anon_sym_PLUS] = ACTIONS(2989),
    [anon_sym_STAR] = ACTIONS(2991),
    [anon_sym_AMP_AMP] = ACTIONS(2991),
    [anon_sym_AMP] = ACTIONS(2989),
    [anon_sym_SEMI] = ACTIONS(2991),
    [anon_sym___extension__] = ACTIONS(2989),
    [anon_sym_typedef] = ACTIONS(2989),
    [anon_sym_extern] = ACTIONS(2989),
    [anon_sym___attribute__] = ACTIONS(2989),
    [anon_sym_COLON_COLON] = ACTIONS(2991),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2991),
    [anon_sym___declspec] = ACTIONS(2989),
    [anon_sym___based] = ACTIONS(2989),
    [anon_sym___cdecl] = ACTIONS(2989),
    [anon_sym___clrcall] = ACTIONS(2989),
    [anon_sym___stdcall] = ACTIONS(2989),
    [anon_sym___fastcall] = ACTIONS(2989),
    [anon_sym___thiscall] = ACTIONS(2989),
    [anon_sym___vectorcall] = ACTIONS(2989),
    [anon_sym_LBRACE] = ACTIONS(2991),
    [anon_sym_signed] = ACTIONS(2989),
    [anon_sym_unsigned] = ACTIONS(2989),
    [anon_sym_long] = ACTIONS(2989),
    [anon_sym_short] = ACTIONS(2989),
    [anon_sym_LBRACK] = ACTIONS(2989),
    [anon_sym_static] = ACTIONS(2989),
    [anon_sym_register] = ACTIONS(2989),
    [anon_sym_inline] = ACTIONS(2989),
    [anon_sym___inline] = ACTIONS(2989),
    [anon_sym___inline__] = ACTIONS(2989),
    [anon_sym___forceinline] = ACTIONS(2989),
    [anon_sym_thread_local] = ACTIONS(2989),
    [anon_sym___thread] = ACTIONS(2989),
    [anon_sym_const] = ACTIONS(2989),
    [anon_sym_constexpr] = ACTIONS(2989),
    [anon_sym_volatile] = ACTIONS(2989),
    [anon_sym_restrict] = ACTIONS(2989),
    [anon_sym___restrict__] = ACTIONS(2989),
    [anon_sym__Atomic] = ACTIONS(2989),
    [anon_sym__Noreturn] = ACTIONS(2989),
    [anon_sym_noreturn] = ACTIONS(2989),
    [anon_sym_mutable] = ACTIONS(2989),
    [anon_sym_constinit] = ACTIONS(2989),
    [anon_sym_consteval] = ACTIONS(2989),
    [anon_sym_PROGMEM] = ACTIONS(2989),
    [aux_sym_primitive_type_token1] = ACTIONS(2989),
    [anon_sym_byte] = ACTIONS(2989),
    [anon_sym_word] = ACTIONS(2989),
    [anon_sym_enum] = ACTIONS(2989),
    [anon_sym_class] = ACTIONS(2989),
    [anon_sym_struct] = ACTIONS(2989),
    [anon_sym_union] = ACTIONS(2989),
    [anon_sym_if] = ACTIONS(2989),
    [anon_sym_switch] = ACTIONS(2989),
    [anon_sym_case] = ACTIONS(2989),
    [anon_sym_default] = ACTIONS(2989),
    [anon_sym_while] = ACTIONS(2989),
    [anon_sym_do] = ACTIONS(2989),
    [anon_sym_for] = ACTIONS(2989),
    [anon_sym_return] = ACTIONS(2989),
    [anon_sym_break] = ACTIONS(2989),
    [anon_sym_continue] = ACTIONS(2989),
    [anon_sym_goto] = ACTIONS(2989),
    [anon_sym___try] = ACTIONS(2989),
    [anon_sym___leave] = ACTIONS(2989),
    [anon_sym_not] = ACTIONS(2989),
    [anon_sym_compl] = ACTIONS(2989),
    [anon_sym_DASH_DASH] = ACTIONS(2991),
    [anon_sym_PLUS_PLUS] = ACTIONS(2991),
    [anon_sym_sizeof] = ACTIONS(2989),
    [anon_sym___alignof__] = ACTIONS(2989),
    [anon_sym___alignof] = ACTIONS(2989),
    [anon_sym__alignof] = ACTIONS(2989),
    [anon_sym_alignof] = ACTIONS(2989),
    [anon_sym__Alignof] = ACTIONS(2989),
    [anon_sym_offsetof] = ACTIONS(2989),
    [anon_sym__Generic] = ACTIONS(2989),
    [anon_sym_asm] = ACTIONS(2989),
    [anon_sym___asm__] = ACTIONS(2989),
    [aux_sym_number_literal_token1] = ACTIONS(2991),
    [aux_sym_number_literal_token2] = ACTIONS(2989),
    [anon_sym_L_SQUOTE] = ACTIONS(2991),
    [anon_sym_u_SQUOTE] = ACTIONS(2991),
    [anon_sym_U_SQUOTE] = ACTIONS(2991),
    [anon_sym_u8_SQUOTE] = ACTIONS(2991),
    [anon_sym_SQUOTE] = ACTIONS(2991),
    [anon_sym_L_DQUOTE] = ACTIONS(2991),
    [anon_sym_u_DQUOTE] = ACTIONS(2991),
    [anon_sym_U_DQUOTE] = ACTIONS(2991),
    [anon_sym_u8_DQUOTE] = ACTIONS(2991),
    [anon_sym_DQUOTE] = ACTIONS(2991),
    [sym_true] = ACTIONS(2989),
    [sym_false] = ACTIONS(2989),
    [anon_sym_NULL] = ACTIONS(2989),
    [anon_sym_nullptr] = ACTIONS(2989),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2989),
    [anon_sym_decltype] = ACTIONS(2989),
    [anon_sym_virtual] = ACTIONS(2989),
    [anon_sym_alignas] = ACTIONS(2989),
    [anon_sym_explicit] = ACTIONS(2989),
    [anon_sym_typename] = ACTIONS(2989),
    [anon_sym_template] = ACTIONS(2989),
    [anon_sym_operator] = ACTIONS(2989),
    [anon_sym_try] = ACTIONS(2989),
    [anon_sym_delete] = ACTIONS(2989),
    [anon_sym_throw] = ACTIONS(2989),
    [anon_sym_namespace] = ACTIONS(2989),
    [anon_sym_using] = ACTIONS(2989),
    [anon_sym_static_assert] = ACTIONS(2989),
    [anon_sym_concept] = ACTIONS(2989),
    [anon_sym_co_return] = ACTIONS(2989),
    [anon_sym_co_yield] = ACTIONS(2989),
    [anon_sym_R_DQUOTE] = ACTIONS(2991),
    [anon_sym_LR_DQUOTE] = ACTIONS(2991),
    [anon_sym_uR_DQUOTE] = ACTIONS(2991),
    [anon_sym_UR_DQUOTE] = ACTIONS(2991),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2991),
    [anon_sym_co_await] = ACTIONS(2989),
    [anon_sym_new] = ACTIONS(2989),
    [anon_sym_requires] = ACTIONS(2989),
    [sym_this] = ACTIONS(2989),
  },
  [366] = {
    [sym_identifier] = ACTIONS(2993),
    [aux_sym_preproc_include_token1] = ACTIONS(2993),
    [aux_sym_preproc_def_token1] = ACTIONS(2993),
    [aux_sym_preproc_if_token1] = ACTIONS(2993),
    [aux_sym_preproc_if_token2] = ACTIONS(2993),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2993),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2993),
    [aux_sym_preproc_else_token1] = ACTIONS(2993),
    [aux_sym_preproc_elif_token1] = ACTIONS(2993),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2993),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2993),
    [sym_preproc_directive] = ACTIONS(2993),
    [anon_sym_LPAREN2] = ACTIONS(2995),
    [anon_sym_BANG] = ACTIONS(2995),
    [anon_sym_TILDE] = ACTIONS(2995),
    [anon_sym_DASH] = ACTIONS(2993),
    [anon_sym_PLUS] = ACTIONS(2993),
    [anon_sym_STAR] = ACTIONS(2995),
    [anon_sym_AMP_AMP] = ACTIONS(2995),
    [anon_sym_AMP] = ACTIONS(2993),
    [anon_sym_SEMI] = ACTIONS(2995),
    [anon_sym___extension__] = ACTIONS(2993),
    [anon_sym_typedef] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(2993),
    [anon_sym___attribute__] = ACTIONS(2993),
    [anon_sym_COLON_COLON] = ACTIONS(2995),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2995),
    [anon_sym___declspec] = ACTIONS(2993),
    [anon_sym___based] = ACTIONS(2993),
    [anon_sym___cdecl] = ACTIONS(2993),
    [anon_sym___clrcall] = ACTIONS(2993),
    [anon_sym___stdcall] = ACTIONS(2993),
    [anon_sym___fastcall] = ACTIONS(2993),
    [anon_sym___thiscall] = ACTIONS(2993),
    [anon_sym___vectorcall] = ACTIONS(2993),
    [anon_sym_LBRACE] = ACTIONS(2995),
    [anon_sym_signed] = ACTIONS(2993),
    [anon_sym_unsigned] = ACTIONS(2993),
    [anon_sym_long] = ACTIONS(2993),
    [anon_sym_short] = ACTIONS(2993),
    [anon_sym_LBRACK] = ACTIONS(2993),
    [anon_sym_static] = ACTIONS(2993),
    [anon_sym_register] = ACTIONS(2993),
    [anon_sym_inline] = ACTIONS(2993),
    [anon_sym___inline] = ACTIONS(2993),
    [anon_sym___inline__] = ACTIONS(2993),
    [anon_sym___forceinline] = ACTIONS(2993),
    [anon_sym_thread_local] = ACTIONS(2993),
    [anon_sym___thread] = ACTIONS(2993),
    [anon_sym_const] = ACTIONS(2993),
    [anon_sym_constexpr] = ACTIONS(2993),
    [anon_sym_volatile] = ACTIONS(2993),
    [anon_sym_restrict] = ACTIONS(2993),
    [anon_sym___restrict__] = ACTIONS(2993),
    [anon_sym__Atomic] = ACTIONS(2993),
    [anon_sym__Noreturn] = ACTIONS(2993),
    [anon_sym_noreturn] = ACTIONS(2993),
    [anon_sym_mutable] = ACTIONS(2993),
    [anon_sym_constinit] = ACTIONS(2993),
    [anon_sym_consteval] = ACTIONS(2993),
    [anon_sym_PROGMEM] = ACTIONS(2993),
    [aux_sym_primitive_type_token1] = ACTIONS(2993),
    [anon_sym_byte] = ACTIONS(2993),
    [anon_sym_word] = ACTIONS(2993),
    [anon_sym_enum] = ACTIONS(2993),
    [anon_sym_class] = ACTIONS(2993),
    [anon_sym_struct] = ACTIONS(2993),
    [anon_sym_union] = ACTIONS(2993),
    [anon_sym_if] = ACTIONS(2993),
    [anon_sym_switch] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2993),
    [anon_sym_default] = ACTIONS(2993),
    [anon_sym_while] = ACTIONS(2993),
    [anon_sym_do] = ACTIONS(2993),
    [anon_sym_for] = ACTIONS(2993),
    [anon_sym_return] = ACTIONS(2993),
    [anon_sym_break] = ACTIONS(2993),
    [anon_sym_continue] = ACTIONS(2993),
    [anon_sym_goto] = ACTIONS(2993),
    [anon_sym___try] = ACTIONS(2993),
    [anon_sym___leave] = ACTIONS(2993),
    [anon_sym_not] = ACTIONS(2993),
    [anon_sym_compl] = ACTIONS(2993),
    [anon_sym_DASH_DASH] = ACTIONS(2995),
    [anon_sym_PLUS_PLUS] = ACTIONS(2995),
    [anon_sym_sizeof] = ACTIONS(2993),
    [anon_sym___alignof__] = ACTIONS(2993),
    [anon_sym___alignof] = ACTIONS(2993),
    [anon_sym__alignof] = ACTIONS(2993),
    [anon_sym_alignof] = ACTIONS(2993),
    [anon_sym__Alignof] = ACTIONS(2993),
    [anon_sym_offsetof] = ACTIONS(2993),
    [anon_sym__Generic] = ACTIONS(2993),
    [anon_sym_asm] = ACTIONS(2993),
    [anon_sym___asm__] = ACTIONS(2993),
    [aux_sym_number_literal_token1] = ACTIONS(2995),
    [aux_sym_number_literal_token2] = ACTIONS(2993),
    [anon_sym_L_SQUOTE] = ACTIONS(2995),
    [anon_sym_u_SQUOTE] = ACTIONS(2995),
    [anon_sym_U_SQUOTE] = ACTIONS(2995),
    [anon_sym_u8_SQUOTE] = ACTIONS(2995),
    [anon_sym_SQUOTE] = ACTIONS(2995),
    [anon_sym_L_DQUOTE] = ACTIONS(2995),
    [anon_sym_u_DQUOTE] = ACTIONS(2995),
    [anon_sym_U_DQUOTE] = ACTIONS(2995),
    [anon_sym_u8_DQUOTE] = ACTIONS(2995),
    [anon_sym_DQUOTE] = ACTIONS(2995),
    [sym_true] = ACTIONS(2993),
    [sym_false] = ACTIONS(2993),
    [anon_sym_NULL] = ACTIONS(2993),
    [anon_sym_nullptr] = ACTIONS(2993),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2993),
    [anon_sym_decltype] = ACTIONS(2993),
    [anon_sym_virtual] = ACTIONS(2993),
    [anon_sym_alignas] = ACTIONS(2993),
    [anon_sym_explicit] = ACTIONS(2993),
    [anon_sym_typename] = ACTIONS(2993),
    [anon_sym_template] = ACTIONS(2993),
    [anon_sym_operator] = ACTIONS(2993),
    [anon_sym_try] = ACTIONS(2993),
    [anon_sym_delete] = ACTIONS(2993),
    [anon_sym_throw] = ACTIONS(2993),
    [anon_sym_namespace] = ACTIONS(2993),
    [anon_sym_using] = ACTIONS(2993),
    [anon_sym_static_assert] = ACTIONS(2993),
    [anon_sym_concept] = ACTIONS(2993),
    [anon_sym_co_return] = ACTIONS(2993),
    [anon_sym_co_yield] = ACTIONS(2993),
    [anon_sym_R_DQUOTE] = ACTIONS(2995),
    [anon_sym_LR_DQUOTE] = ACTIONS(2995),
    [anon_sym_uR_DQUOTE] = ACTIONS(2995),
    [anon_sym_UR_DQUOTE] = ACTIONS(2995),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2995),
    [anon_sym_co_await] = ACTIONS(2993),
    [anon_sym_new] = ACTIONS(2993),
    [anon_sym_requires] = ACTIONS(2993),
    [sym_this] = ACTIONS(2993),
  },
  [367] = {
    [sym_preproc_def] = STATE(541),
    [sym_preproc_function_def] = STATE(541),
    [sym_preproc_call] = STATE(541),
    [sym_preproc_if_in_field_declaration_list] = STATE(541),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(541),
    [sym_preproc_else_in_field_declaration_list] = STATE(7739),
    [sym_preproc_elif_in_field_declaration_list] = STATE(7739),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(7739),
    [sym_type_definition] = STATE(541),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(5531),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(3150),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(5962),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym__field_declaration_list_item] = STATE(541),
    [sym_field_declaration] = STATE(541),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1838),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(541),
    [sym_operator_cast] = STATE(6510),
    [sym_inline_method_definition] = STATE(541),
    [sym__constructor_specifiers] = STATE(1838),
    [sym_operator_cast_definition] = STATE(541),
    [sym_operator_cast_declaration] = STATE(541),
    [sym_constructor_or_destructor_definition] = STATE(541),
    [sym_constructor_or_destructor_declaration] = STATE(541),
    [sym_friend_declaration] = STATE(541),
    [sym_access_specifier] = STATE(7787),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(2618),
    [sym_template_function] = STATE(6098),
    [sym_using_declaration] = STATE(541),
    [sym_alias_declaration] = STATE(541),
    [sym_static_assert_declaration] = STATE(541),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5301),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_qualified_operator_cast_identifier] = STATE(6510),
    [sym_operator_name] = STATE(6098),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(541),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1961),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1838),
    [sym_identifier] = ACTIONS(2823),
    [aux_sym_preproc_def_token1] = ACTIONS(2825),
    [aux_sym_preproc_if_token1] = ACTIONS(2827),
    [aux_sym_preproc_if_token2] = ACTIONS(2997),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2831),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2831),
    [aux_sym_preproc_else_token1] = ACTIONS(2833),
    [aux_sym_preproc_elif_token1] = ACTIONS(2835),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2837),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2837),
    [sym_preproc_directive] = ACTIONS(2839),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(2849),
    [anon_sym_typedef] = ACTIONS(2851),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(2853),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2857),
    [anon_sym_class] = ACTIONS(2859),
    [anon_sym_struct] = ACTIONS(2861),
    [anon_sym_union] = ACTIONS(2863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(2865),
    [anon_sym_template] = ACTIONS(2867),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(2869),
    [anon_sym_public] = ACTIONS(2871),
    [anon_sym_private] = ACTIONS(2871),
    [anon_sym_protected] = ACTIONS(2871),
    [anon_sym_using] = ACTIONS(2873),
    [anon_sym_static_assert] = ACTIONS(2875),
  },
  [368] = {
    [sym_catch_clause] = STATE(368),
    [aux_sym_constructor_try_statement_repeat1] = STATE(368),
    [ts_builtin_sym_end] = ACTIONS(2477),
    [sym_identifier] = ACTIONS(2475),
    [aux_sym_preproc_include_token1] = ACTIONS(2475),
    [aux_sym_preproc_def_token1] = ACTIONS(2475),
    [aux_sym_preproc_if_token1] = ACTIONS(2475),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2475),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2475),
    [sym_preproc_directive] = ACTIONS(2475),
    [anon_sym_LPAREN2] = ACTIONS(2477),
    [anon_sym_BANG] = ACTIONS(2477),
    [anon_sym_TILDE] = ACTIONS(2477),
    [anon_sym_DASH] = ACTIONS(2475),
    [anon_sym_PLUS] = ACTIONS(2475),
    [anon_sym_STAR] = ACTIONS(2477),
    [anon_sym_AMP_AMP] = ACTIONS(2477),
    [anon_sym_AMP] = ACTIONS(2475),
    [anon_sym_SEMI] = ACTIONS(2477),
    [anon_sym___extension__] = ACTIONS(2475),
    [anon_sym_typedef] = ACTIONS(2475),
    [anon_sym_extern] = ACTIONS(2475),
    [anon_sym___attribute__] = ACTIONS(2475),
    [anon_sym_COLON_COLON] = ACTIONS(2477),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2477),
    [anon_sym___declspec] = ACTIONS(2475),
    [anon_sym___based] = ACTIONS(2475),
    [anon_sym___cdecl] = ACTIONS(2475),
    [anon_sym___clrcall] = ACTIONS(2475),
    [anon_sym___stdcall] = ACTIONS(2475),
    [anon_sym___fastcall] = ACTIONS(2475),
    [anon_sym___thiscall] = ACTIONS(2475),
    [anon_sym___vectorcall] = ACTIONS(2475),
    [anon_sym_LBRACE] = ACTIONS(2477),
    [anon_sym_signed] = ACTIONS(2475),
    [anon_sym_unsigned] = ACTIONS(2475),
    [anon_sym_long] = ACTIONS(2475),
    [anon_sym_short] = ACTIONS(2475),
    [anon_sym_LBRACK] = ACTIONS(2475),
    [anon_sym_static] = ACTIONS(2475),
    [anon_sym_register] = ACTIONS(2475),
    [anon_sym_inline] = ACTIONS(2475),
    [anon_sym___inline] = ACTIONS(2475),
    [anon_sym___inline__] = ACTIONS(2475),
    [anon_sym___forceinline] = ACTIONS(2475),
    [anon_sym_thread_local] = ACTIONS(2475),
    [anon_sym___thread] = ACTIONS(2475),
    [anon_sym_const] = ACTIONS(2475),
    [anon_sym_constexpr] = ACTIONS(2475),
    [anon_sym_volatile] = ACTIONS(2475),
    [anon_sym_restrict] = ACTIONS(2475),
    [anon_sym___restrict__] = ACTIONS(2475),
    [anon_sym__Atomic] = ACTIONS(2475),
    [anon_sym__Noreturn] = ACTIONS(2475),
    [anon_sym_noreturn] = ACTIONS(2475),
    [anon_sym_mutable] = ACTIONS(2475),
    [anon_sym_constinit] = ACTIONS(2475),
    [anon_sym_consteval] = ACTIONS(2475),
    [anon_sym_PROGMEM] = ACTIONS(2475),
    [aux_sym_primitive_type_token1] = ACTIONS(2475),
    [anon_sym_byte] = ACTIONS(2475),
    [anon_sym_word] = ACTIONS(2475),
    [anon_sym_enum] = ACTIONS(2475),
    [anon_sym_class] = ACTIONS(2475),
    [anon_sym_struct] = ACTIONS(2475),
    [anon_sym_union] = ACTIONS(2475),
    [anon_sym_if] = ACTIONS(2475),
    [anon_sym_else] = ACTIONS(2475),
    [anon_sym_switch] = ACTIONS(2475),
    [anon_sym_case] = ACTIONS(2475),
    [anon_sym_default] = ACTIONS(2475),
    [anon_sym_while] = ACTIONS(2475),
    [anon_sym_do] = ACTIONS(2475),
    [anon_sym_for] = ACTIONS(2475),
    [anon_sym_return] = ACTIONS(2475),
    [anon_sym_break] = ACTIONS(2475),
    [anon_sym_continue] = ACTIONS(2475),
    [anon_sym_goto] = ACTIONS(2475),
    [anon_sym___try] = ACTIONS(2475),
    [anon_sym___leave] = ACTIONS(2475),
    [anon_sym_not] = ACTIONS(2475),
    [anon_sym_compl] = ACTIONS(2475),
    [anon_sym_DASH_DASH] = ACTIONS(2477),
    [anon_sym_PLUS_PLUS] = ACTIONS(2477),
    [anon_sym_sizeof] = ACTIONS(2475),
    [anon_sym___alignof__] = ACTIONS(2475),
    [anon_sym___alignof] = ACTIONS(2475),
    [anon_sym__alignof] = ACTIONS(2475),
    [anon_sym_alignof] = ACTIONS(2475),
    [anon_sym__Alignof] = ACTIONS(2475),
    [anon_sym_offsetof] = ACTIONS(2475),
    [anon_sym__Generic] = ACTIONS(2475),
    [anon_sym_asm] = ACTIONS(2475),
    [anon_sym___asm__] = ACTIONS(2475),
    [aux_sym_number_literal_token1] = ACTIONS(2477),
    [aux_sym_number_literal_token2] = ACTIONS(2475),
    [anon_sym_L_SQUOTE] = ACTIONS(2477),
    [anon_sym_u_SQUOTE] = ACTIONS(2477),
    [anon_sym_U_SQUOTE] = ACTIONS(2477),
    [anon_sym_u8_SQUOTE] = ACTIONS(2477),
    [anon_sym_SQUOTE] = ACTIONS(2477),
    [anon_sym_L_DQUOTE] = ACTIONS(2477),
    [anon_sym_u_DQUOTE] = ACTIONS(2477),
    [anon_sym_U_DQUOTE] = ACTIONS(2477),
    [anon_sym_u8_DQUOTE] = ACTIONS(2477),
    [anon_sym_DQUOTE] = ACTIONS(2477),
    [sym_true] = ACTIONS(2475),
    [sym_false] = ACTIONS(2475),
    [anon_sym_NULL] = ACTIONS(2475),
    [anon_sym_nullptr] = ACTIONS(2475),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2475),
    [anon_sym_decltype] = ACTIONS(2475),
    [anon_sym_virtual] = ACTIONS(2475),
    [anon_sym_alignas] = ACTIONS(2475),
    [anon_sym_explicit] = ACTIONS(2475),
    [anon_sym_typename] = ACTIONS(2475),
    [anon_sym_template] = ACTIONS(2475),
    [anon_sym_operator] = ACTIONS(2475),
    [anon_sym_try] = ACTIONS(2475),
    [anon_sym_delete] = ACTIONS(2475),
    [anon_sym_throw] = ACTIONS(2475),
    [anon_sym_namespace] = ACTIONS(2475),
    [anon_sym_using] = ACTIONS(2475),
    [anon_sym_static_assert] = ACTIONS(2475),
    [anon_sym_concept] = ACTIONS(2475),
    [anon_sym_co_return] = ACTIONS(2475),
    [anon_sym_co_yield] = ACTIONS(2475),
    [anon_sym_catch] = ACTIONS(2999),
    [anon_sym_R_DQUOTE] = ACTIONS(2477),
    [anon_sym_LR_DQUOTE] = ACTIONS(2477),
    [anon_sym_uR_DQUOTE] = ACTIONS(2477),
    [anon_sym_UR_DQUOTE] = ACTIONS(2477),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2477),
    [anon_sym_co_await] = ACTIONS(2475),
    [anon_sym_new] = ACTIONS(2475),
    [anon_sym_requires] = ACTIONS(2475),
    [sym_this] = ACTIONS(2475),
  },
  [369] = {
    [sym_identifier] = ACTIONS(3002),
    [aux_sym_preproc_include_token1] = ACTIONS(3002),
    [aux_sym_preproc_def_token1] = ACTIONS(3002),
    [aux_sym_preproc_if_token1] = ACTIONS(3002),
    [aux_sym_preproc_if_token2] = ACTIONS(3002),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3002),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3002),
    [aux_sym_preproc_else_token1] = ACTIONS(3002),
    [aux_sym_preproc_elif_token1] = ACTIONS(3002),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3002),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3002),
    [sym_preproc_directive] = ACTIONS(3002),
    [anon_sym_LPAREN2] = ACTIONS(3004),
    [anon_sym_BANG] = ACTIONS(3004),
    [anon_sym_TILDE] = ACTIONS(3004),
    [anon_sym_DASH] = ACTIONS(3002),
    [anon_sym_PLUS] = ACTIONS(3002),
    [anon_sym_STAR] = ACTIONS(3004),
    [anon_sym_AMP_AMP] = ACTIONS(3004),
    [anon_sym_AMP] = ACTIONS(3002),
    [anon_sym_SEMI] = ACTIONS(3004),
    [anon_sym___extension__] = ACTIONS(3002),
    [anon_sym_typedef] = ACTIONS(3002),
    [anon_sym_extern] = ACTIONS(3002),
    [anon_sym___attribute__] = ACTIONS(3002),
    [anon_sym_COLON_COLON] = ACTIONS(3004),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3004),
    [anon_sym___declspec] = ACTIONS(3002),
    [anon_sym___based] = ACTIONS(3002),
    [anon_sym___cdecl] = ACTIONS(3002),
    [anon_sym___clrcall] = ACTIONS(3002),
    [anon_sym___stdcall] = ACTIONS(3002),
    [anon_sym___fastcall] = ACTIONS(3002),
    [anon_sym___thiscall] = ACTIONS(3002),
    [anon_sym___vectorcall] = ACTIONS(3002),
    [anon_sym_LBRACE] = ACTIONS(3004),
    [anon_sym_signed] = ACTIONS(3002),
    [anon_sym_unsigned] = ACTIONS(3002),
    [anon_sym_long] = ACTIONS(3002),
    [anon_sym_short] = ACTIONS(3002),
    [anon_sym_LBRACK] = ACTIONS(3002),
    [anon_sym_static] = ACTIONS(3002),
    [anon_sym_register] = ACTIONS(3002),
    [anon_sym_inline] = ACTIONS(3002),
    [anon_sym___inline] = ACTIONS(3002),
    [anon_sym___inline__] = ACTIONS(3002),
    [anon_sym___forceinline] = ACTIONS(3002),
    [anon_sym_thread_local] = ACTIONS(3002),
    [anon_sym___thread] = ACTIONS(3002),
    [anon_sym_const] = ACTIONS(3002),
    [anon_sym_constexpr] = ACTIONS(3002),
    [anon_sym_volatile] = ACTIONS(3002),
    [anon_sym_restrict] = ACTIONS(3002),
    [anon_sym___restrict__] = ACTIONS(3002),
    [anon_sym__Atomic] = ACTIONS(3002),
    [anon_sym__Noreturn] = ACTIONS(3002),
    [anon_sym_noreturn] = ACTIONS(3002),
    [anon_sym_mutable] = ACTIONS(3002),
    [anon_sym_constinit] = ACTIONS(3002),
    [anon_sym_consteval] = ACTIONS(3002),
    [anon_sym_PROGMEM] = ACTIONS(3002),
    [aux_sym_primitive_type_token1] = ACTIONS(3002),
    [anon_sym_byte] = ACTIONS(3002),
    [anon_sym_word] = ACTIONS(3002),
    [anon_sym_enum] = ACTIONS(3002),
    [anon_sym_class] = ACTIONS(3002),
    [anon_sym_struct] = ACTIONS(3002),
    [anon_sym_union] = ACTIONS(3002),
    [anon_sym_if] = ACTIONS(3002),
    [anon_sym_switch] = ACTIONS(3002),
    [anon_sym_case] = ACTIONS(3002),
    [anon_sym_default] = ACTIONS(3002),
    [anon_sym_while] = ACTIONS(3002),
    [anon_sym_do] = ACTIONS(3002),
    [anon_sym_for] = ACTIONS(3002),
    [anon_sym_return] = ACTIONS(3002),
    [anon_sym_break] = ACTIONS(3002),
    [anon_sym_continue] = ACTIONS(3002),
    [anon_sym_goto] = ACTIONS(3002),
    [anon_sym___try] = ACTIONS(3002),
    [anon_sym___leave] = ACTIONS(3002),
    [anon_sym_not] = ACTIONS(3002),
    [anon_sym_compl] = ACTIONS(3002),
    [anon_sym_DASH_DASH] = ACTIONS(3004),
    [anon_sym_PLUS_PLUS] = ACTIONS(3004),
    [anon_sym_sizeof] = ACTIONS(3002),
    [anon_sym___alignof__] = ACTIONS(3002),
    [anon_sym___alignof] = ACTIONS(3002),
    [anon_sym__alignof] = ACTIONS(3002),
    [anon_sym_alignof] = ACTIONS(3002),
    [anon_sym__Alignof] = ACTIONS(3002),
    [anon_sym_offsetof] = ACTIONS(3002),
    [anon_sym__Generic] = ACTIONS(3002),
    [anon_sym_asm] = ACTIONS(3002),
    [anon_sym___asm__] = ACTIONS(3002),
    [aux_sym_number_literal_token1] = ACTIONS(3004),
    [aux_sym_number_literal_token2] = ACTIONS(3002),
    [anon_sym_L_SQUOTE] = ACTIONS(3004),
    [anon_sym_u_SQUOTE] = ACTIONS(3004),
    [anon_sym_U_SQUOTE] = ACTIONS(3004),
    [anon_sym_u8_SQUOTE] = ACTIONS(3004),
    [anon_sym_SQUOTE] = ACTIONS(3004),
    [anon_sym_L_DQUOTE] = ACTIONS(3004),
    [anon_sym_u_DQUOTE] = ACTIONS(3004),
    [anon_sym_U_DQUOTE] = ACTIONS(3004),
    [anon_sym_u8_DQUOTE] = ACTIONS(3004),
    [anon_sym_DQUOTE] = ACTIONS(3004),
    [sym_true] = ACTIONS(3002),
    [sym_false] = ACTIONS(3002),
    [anon_sym_NULL] = ACTIONS(3002),
    [anon_sym_nullptr] = ACTIONS(3002),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3002),
    [anon_sym_decltype] = ACTIONS(3002),
    [anon_sym_virtual] = ACTIONS(3002),
    [anon_sym_alignas] = ACTIONS(3002),
    [anon_sym_explicit] = ACTIONS(3002),
    [anon_sym_typename] = ACTIONS(3002),
    [anon_sym_template] = ACTIONS(3002),
    [anon_sym_operator] = ACTIONS(3002),
    [anon_sym_try] = ACTIONS(3002),
    [anon_sym_delete] = ACTIONS(3002),
    [anon_sym_throw] = ACTIONS(3002),
    [anon_sym_namespace] = ACTIONS(3002),
    [anon_sym_using] = ACTIONS(3002),
    [anon_sym_static_assert] = ACTIONS(3002),
    [anon_sym_concept] = ACTIONS(3002),
    [anon_sym_co_return] = ACTIONS(3002),
    [anon_sym_co_yield] = ACTIONS(3002),
    [anon_sym_R_DQUOTE] = ACTIONS(3004),
    [anon_sym_LR_DQUOTE] = ACTIONS(3004),
    [anon_sym_uR_DQUOTE] = ACTIONS(3004),
    [anon_sym_UR_DQUOTE] = ACTIONS(3004),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3004),
    [anon_sym_co_await] = ACTIONS(3002),
    [anon_sym_new] = ACTIONS(3002),
    [anon_sym_requires] = ACTIONS(3002),
    [sym_this] = ACTIONS(3002),
  },
  [370] = {
    [sym_preproc_def] = STATE(401),
    [sym_preproc_function_def] = STATE(401),
    [sym_preproc_call] = STATE(401),
    [sym_preproc_if_in_field_declaration_list] = STATE(401),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(401),
    [sym_preproc_else_in_field_declaration_list] = STATE(8335),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8335),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8335),
    [sym_type_definition] = STATE(401),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(5531),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(3150),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(5962),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym__field_declaration_list_item] = STATE(401),
    [sym_field_declaration] = STATE(401),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1838),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(401),
    [sym_operator_cast] = STATE(6510),
    [sym_inline_method_definition] = STATE(401),
    [sym__constructor_specifiers] = STATE(1838),
    [sym_operator_cast_definition] = STATE(401),
    [sym_operator_cast_declaration] = STATE(401),
    [sym_constructor_or_destructor_definition] = STATE(401),
    [sym_constructor_or_destructor_declaration] = STATE(401),
    [sym_friend_declaration] = STATE(401),
    [sym_access_specifier] = STATE(7787),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(2618),
    [sym_template_function] = STATE(6098),
    [sym_using_declaration] = STATE(401),
    [sym_alias_declaration] = STATE(401),
    [sym_static_assert_declaration] = STATE(401),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5301),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_qualified_operator_cast_identifier] = STATE(6510),
    [sym_operator_name] = STATE(6098),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(401),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1961),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1838),
    [sym_identifier] = ACTIONS(2823),
    [aux_sym_preproc_def_token1] = ACTIONS(2825),
    [aux_sym_preproc_if_token1] = ACTIONS(2827),
    [aux_sym_preproc_if_token2] = ACTIONS(3006),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2831),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2831),
    [aux_sym_preproc_else_token1] = ACTIONS(2833),
    [aux_sym_preproc_elif_token1] = ACTIONS(2835),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2837),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2837),
    [sym_preproc_directive] = ACTIONS(2839),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(2849),
    [anon_sym_typedef] = ACTIONS(2851),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(2853),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2857),
    [anon_sym_class] = ACTIONS(2859),
    [anon_sym_struct] = ACTIONS(2861),
    [anon_sym_union] = ACTIONS(2863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(2865),
    [anon_sym_template] = ACTIONS(2867),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(2869),
    [anon_sym_public] = ACTIONS(2871),
    [anon_sym_private] = ACTIONS(2871),
    [anon_sym_protected] = ACTIONS(2871),
    [anon_sym_using] = ACTIONS(2873),
    [anon_sym_static_assert] = ACTIONS(2875),
  },
  [371] = {
    [sym_identifier] = ACTIONS(3008),
    [aux_sym_preproc_include_token1] = ACTIONS(3008),
    [aux_sym_preproc_def_token1] = ACTIONS(3008),
    [aux_sym_preproc_if_token1] = ACTIONS(3008),
    [aux_sym_preproc_if_token2] = ACTIONS(3008),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3008),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3008),
    [aux_sym_preproc_else_token1] = ACTIONS(3008),
    [aux_sym_preproc_elif_token1] = ACTIONS(3008),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3008),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3008),
    [sym_preproc_directive] = ACTIONS(3008),
    [anon_sym_LPAREN2] = ACTIONS(3010),
    [anon_sym_BANG] = ACTIONS(3010),
    [anon_sym_TILDE] = ACTIONS(3010),
    [anon_sym_DASH] = ACTIONS(3008),
    [anon_sym_PLUS] = ACTIONS(3008),
    [anon_sym_STAR] = ACTIONS(3010),
    [anon_sym_AMP_AMP] = ACTIONS(3010),
    [anon_sym_AMP] = ACTIONS(3008),
    [anon_sym_SEMI] = ACTIONS(3010),
    [anon_sym___extension__] = ACTIONS(3008),
    [anon_sym_typedef] = ACTIONS(3008),
    [anon_sym_extern] = ACTIONS(3008),
    [anon_sym___attribute__] = ACTIONS(3008),
    [anon_sym_COLON_COLON] = ACTIONS(3010),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3010),
    [anon_sym___declspec] = ACTIONS(3008),
    [anon_sym___based] = ACTIONS(3008),
    [anon_sym___cdecl] = ACTIONS(3008),
    [anon_sym___clrcall] = ACTIONS(3008),
    [anon_sym___stdcall] = ACTIONS(3008),
    [anon_sym___fastcall] = ACTIONS(3008),
    [anon_sym___thiscall] = ACTIONS(3008),
    [anon_sym___vectorcall] = ACTIONS(3008),
    [anon_sym_LBRACE] = ACTIONS(3010),
    [anon_sym_signed] = ACTIONS(3008),
    [anon_sym_unsigned] = ACTIONS(3008),
    [anon_sym_long] = ACTIONS(3008),
    [anon_sym_short] = ACTIONS(3008),
    [anon_sym_LBRACK] = ACTIONS(3008),
    [anon_sym_static] = ACTIONS(3008),
    [anon_sym_register] = ACTIONS(3008),
    [anon_sym_inline] = ACTIONS(3008),
    [anon_sym___inline] = ACTIONS(3008),
    [anon_sym___inline__] = ACTIONS(3008),
    [anon_sym___forceinline] = ACTIONS(3008),
    [anon_sym_thread_local] = ACTIONS(3008),
    [anon_sym___thread] = ACTIONS(3008),
    [anon_sym_const] = ACTIONS(3008),
    [anon_sym_constexpr] = ACTIONS(3008),
    [anon_sym_volatile] = ACTIONS(3008),
    [anon_sym_restrict] = ACTIONS(3008),
    [anon_sym___restrict__] = ACTIONS(3008),
    [anon_sym__Atomic] = ACTIONS(3008),
    [anon_sym__Noreturn] = ACTIONS(3008),
    [anon_sym_noreturn] = ACTIONS(3008),
    [anon_sym_mutable] = ACTIONS(3008),
    [anon_sym_constinit] = ACTIONS(3008),
    [anon_sym_consteval] = ACTIONS(3008),
    [anon_sym_PROGMEM] = ACTIONS(3008),
    [aux_sym_primitive_type_token1] = ACTIONS(3008),
    [anon_sym_byte] = ACTIONS(3008),
    [anon_sym_word] = ACTIONS(3008),
    [anon_sym_enum] = ACTIONS(3008),
    [anon_sym_class] = ACTIONS(3008),
    [anon_sym_struct] = ACTIONS(3008),
    [anon_sym_union] = ACTIONS(3008),
    [anon_sym_if] = ACTIONS(3008),
    [anon_sym_switch] = ACTIONS(3008),
    [anon_sym_case] = ACTIONS(3008),
    [anon_sym_default] = ACTIONS(3008),
    [anon_sym_while] = ACTIONS(3008),
    [anon_sym_do] = ACTIONS(3008),
    [anon_sym_for] = ACTIONS(3008),
    [anon_sym_return] = ACTIONS(3008),
    [anon_sym_break] = ACTIONS(3008),
    [anon_sym_continue] = ACTIONS(3008),
    [anon_sym_goto] = ACTIONS(3008),
    [anon_sym___try] = ACTIONS(3008),
    [anon_sym___leave] = ACTIONS(3008),
    [anon_sym_not] = ACTIONS(3008),
    [anon_sym_compl] = ACTIONS(3008),
    [anon_sym_DASH_DASH] = ACTIONS(3010),
    [anon_sym_PLUS_PLUS] = ACTIONS(3010),
    [anon_sym_sizeof] = ACTIONS(3008),
    [anon_sym___alignof__] = ACTIONS(3008),
    [anon_sym___alignof] = ACTIONS(3008),
    [anon_sym__alignof] = ACTIONS(3008),
    [anon_sym_alignof] = ACTIONS(3008),
    [anon_sym__Alignof] = ACTIONS(3008),
    [anon_sym_offsetof] = ACTIONS(3008),
    [anon_sym__Generic] = ACTIONS(3008),
    [anon_sym_asm] = ACTIONS(3008),
    [anon_sym___asm__] = ACTIONS(3008),
    [aux_sym_number_literal_token1] = ACTIONS(3010),
    [aux_sym_number_literal_token2] = ACTIONS(3008),
    [anon_sym_L_SQUOTE] = ACTIONS(3010),
    [anon_sym_u_SQUOTE] = ACTIONS(3010),
    [anon_sym_U_SQUOTE] = ACTIONS(3010),
    [anon_sym_u8_SQUOTE] = ACTIONS(3010),
    [anon_sym_SQUOTE] = ACTIONS(3010),
    [anon_sym_L_DQUOTE] = ACTIONS(3010),
    [anon_sym_u_DQUOTE] = ACTIONS(3010),
    [anon_sym_U_DQUOTE] = ACTIONS(3010),
    [anon_sym_u8_DQUOTE] = ACTIONS(3010),
    [anon_sym_DQUOTE] = ACTIONS(3010),
    [sym_true] = ACTIONS(3008),
    [sym_false] = ACTIONS(3008),
    [anon_sym_NULL] = ACTIONS(3008),
    [anon_sym_nullptr] = ACTIONS(3008),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3008),
    [anon_sym_decltype] = ACTIONS(3008),
    [anon_sym_virtual] = ACTIONS(3008),
    [anon_sym_alignas] = ACTIONS(3008),
    [anon_sym_explicit] = ACTIONS(3008),
    [anon_sym_typename] = ACTIONS(3008),
    [anon_sym_template] = ACTIONS(3008),
    [anon_sym_operator] = ACTIONS(3008),
    [anon_sym_try] = ACTIONS(3008),
    [anon_sym_delete] = ACTIONS(3008),
    [anon_sym_throw] = ACTIONS(3008),
    [anon_sym_namespace] = ACTIONS(3008),
    [anon_sym_using] = ACTIONS(3008),
    [anon_sym_static_assert] = ACTIONS(3008),
    [anon_sym_concept] = ACTIONS(3008),
    [anon_sym_co_return] = ACTIONS(3008),
    [anon_sym_co_yield] = ACTIONS(3008),
    [anon_sym_R_DQUOTE] = ACTIONS(3010),
    [anon_sym_LR_DQUOTE] = ACTIONS(3010),
    [anon_sym_uR_DQUOTE] = ACTIONS(3010),
    [anon_sym_UR_DQUOTE] = ACTIONS(3010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3010),
    [anon_sym_co_await] = ACTIONS(3008),
    [anon_sym_new] = ACTIONS(3008),
    [anon_sym_requires] = ACTIONS(3008),
    [sym_this] = ACTIONS(3008),
  },
  [372] = {
    [sym_identifier] = ACTIONS(3012),
    [aux_sym_preproc_include_token1] = ACTIONS(3012),
    [aux_sym_preproc_def_token1] = ACTIONS(3012),
    [aux_sym_preproc_if_token1] = ACTIONS(3012),
    [aux_sym_preproc_if_token2] = ACTIONS(3012),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3012),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3012),
    [aux_sym_preproc_else_token1] = ACTIONS(3012),
    [aux_sym_preproc_elif_token1] = ACTIONS(3012),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3012),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3012),
    [sym_preproc_directive] = ACTIONS(3012),
    [anon_sym_LPAREN2] = ACTIONS(3014),
    [anon_sym_BANG] = ACTIONS(3014),
    [anon_sym_TILDE] = ACTIONS(3014),
    [anon_sym_DASH] = ACTIONS(3012),
    [anon_sym_PLUS] = ACTIONS(3012),
    [anon_sym_STAR] = ACTIONS(3014),
    [anon_sym_AMP_AMP] = ACTIONS(3014),
    [anon_sym_AMP] = ACTIONS(3012),
    [anon_sym_SEMI] = ACTIONS(3014),
    [anon_sym___extension__] = ACTIONS(3012),
    [anon_sym_typedef] = ACTIONS(3012),
    [anon_sym_extern] = ACTIONS(3012),
    [anon_sym___attribute__] = ACTIONS(3012),
    [anon_sym_COLON_COLON] = ACTIONS(3014),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3014),
    [anon_sym___declspec] = ACTIONS(3012),
    [anon_sym___based] = ACTIONS(3012),
    [anon_sym___cdecl] = ACTIONS(3012),
    [anon_sym___clrcall] = ACTIONS(3012),
    [anon_sym___stdcall] = ACTIONS(3012),
    [anon_sym___fastcall] = ACTIONS(3012),
    [anon_sym___thiscall] = ACTIONS(3012),
    [anon_sym___vectorcall] = ACTIONS(3012),
    [anon_sym_LBRACE] = ACTIONS(3014),
    [anon_sym_signed] = ACTIONS(3012),
    [anon_sym_unsigned] = ACTIONS(3012),
    [anon_sym_long] = ACTIONS(3012),
    [anon_sym_short] = ACTIONS(3012),
    [anon_sym_LBRACK] = ACTIONS(3012),
    [anon_sym_static] = ACTIONS(3012),
    [anon_sym_register] = ACTIONS(3012),
    [anon_sym_inline] = ACTIONS(3012),
    [anon_sym___inline] = ACTIONS(3012),
    [anon_sym___inline__] = ACTIONS(3012),
    [anon_sym___forceinline] = ACTIONS(3012),
    [anon_sym_thread_local] = ACTIONS(3012),
    [anon_sym___thread] = ACTIONS(3012),
    [anon_sym_const] = ACTIONS(3012),
    [anon_sym_constexpr] = ACTIONS(3012),
    [anon_sym_volatile] = ACTIONS(3012),
    [anon_sym_restrict] = ACTIONS(3012),
    [anon_sym___restrict__] = ACTIONS(3012),
    [anon_sym__Atomic] = ACTIONS(3012),
    [anon_sym__Noreturn] = ACTIONS(3012),
    [anon_sym_noreturn] = ACTIONS(3012),
    [anon_sym_mutable] = ACTIONS(3012),
    [anon_sym_constinit] = ACTIONS(3012),
    [anon_sym_consteval] = ACTIONS(3012),
    [anon_sym_PROGMEM] = ACTIONS(3012),
    [aux_sym_primitive_type_token1] = ACTIONS(3012),
    [anon_sym_byte] = ACTIONS(3012),
    [anon_sym_word] = ACTIONS(3012),
    [anon_sym_enum] = ACTIONS(3012),
    [anon_sym_class] = ACTIONS(3012),
    [anon_sym_struct] = ACTIONS(3012),
    [anon_sym_union] = ACTIONS(3012),
    [anon_sym_if] = ACTIONS(3012),
    [anon_sym_switch] = ACTIONS(3012),
    [anon_sym_case] = ACTIONS(3012),
    [anon_sym_default] = ACTIONS(3012),
    [anon_sym_while] = ACTIONS(3012),
    [anon_sym_do] = ACTIONS(3012),
    [anon_sym_for] = ACTIONS(3012),
    [anon_sym_return] = ACTIONS(3012),
    [anon_sym_break] = ACTIONS(3012),
    [anon_sym_continue] = ACTIONS(3012),
    [anon_sym_goto] = ACTIONS(3012),
    [anon_sym___try] = ACTIONS(3012),
    [anon_sym___leave] = ACTIONS(3012),
    [anon_sym_not] = ACTIONS(3012),
    [anon_sym_compl] = ACTIONS(3012),
    [anon_sym_DASH_DASH] = ACTIONS(3014),
    [anon_sym_PLUS_PLUS] = ACTIONS(3014),
    [anon_sym_sizeof] = ACTIONS(3012),
    [anon_sym___alignof__] = ACTIONS(3012),
    [anon_sym___alignof] = ACTIONS(3012),
    [anon_sym__alignof] = ACTIONS(3012),
    [anon_sym_alignof] = ACTIONS(3012),
    [anon_sym__Alignof] = ACTIONS(3012),
    [anon_sym_offsetof] = ACTIONS(3012),
    [anon_sym__Generic] = ACTIONS(3012),
    [anon_sym_asm] = ACTIONS(3012),
    [anon_sym___asm__] = ACTIONS(3012),
    [aux_sym_number_literal_token1] = ACTIONS(3014),
    [aux_sym_number_literal_token2] = ACTIONS(3012),
    [anon_sym_L_SQUOTE] = ACTIONS(3014),
    [anon_sym_u_SQUOTE] = ACTIONS(3014),
    [anon_sym_U_SQUOTE] = ACTIONS(3014),
    [anon_sym_u8_SQUOTE] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [anon_sym_L_DQUOTE] = ACTIONS(3014),
    [anon_sym_u_DQUOTE] = ACTIONS(3014),
    [anon_sym_U_DQUOTE] = ACTIONS(3014),
    [anon_sym_u8_DQUOTE] = ACTIONS(3014),
    [anon_sym_DQUOTE] = ACTIONS(3014),
    [sym_true] = ACTIONS(3012),
    [sym_false] = ACTIONS(3012),
    [anon_sym_NULL] = ACTIONS(3012),
    [anon_sym_nullptr] = ACTIONS(3012),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3012),
    [anon_sym_decltype] = ACTIONS(3012),
    [anon_sym_virtual] = ACTIONS(3012),
    [anon_sym_alignas] = ACTIONS(3012),
    [anon_sym_explicit] = ACTIONS(3012),
    [anon_sym_typename] = ACTIONS(3012),
    [anon_sym_template] = ACTIONS(3012),
    [anon_sym_operator] = ACTIONS(3012),
    [anon_sym_try] = ACTIONS(3012),
    [anon_sym_delete] = ACTIONS(3012),
    [anon_sym_throw] = ACTIONS(3012),
    [anon_sym_namespace] = ACTIONS(3012),
    [anon_sym_using] = ACTIONS(3012),
    [anon_sym_static_assert] = ACTIONS(3012),
    [anon_sym_concept] = ACTIONS(3012),
    [anon_sym_co_return] = ACTIONS(3012),
    [anon_sym_co_yield] = ACTIONS(3012),
    [anon_sym_R_DQUOTE] = ACTIONS(3014),
    [anon_sym_LR_DQUOTE] = ACTIONS(3014),
    [anon_sym_uR_DQUOTE] = ACTIONS(3014),
    [anon_sym_UR_DQUOTE] = ACTIONS(3014),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3014),
    [anon_sym_co_await] = ACTIONS(3012),
    [anon_sym_new] = ACTIONS(3012),
    [anon_sym_requires] = ACTIONS(3012),
    [sym_this] = ACTIONS(3012),
  },
  [373] = {
    [sym_identifier] = ACTIONS(3016),
    [aux_sym_preproc_include_token1] = ACTIONS(3016),
    [aux_sym_preproc_def_token1] = ACTIONS(3016),
    [aux_sym_preproc_if_token1] = ACTIONS(3016),
    [aux_sym_preproc_if_token2] = ACTIONS(3016),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3016),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3016),
    [aux_sym_preproc_else_token1] = ACTIONS(3016),
    [aux_sym_preproc_elif_token1] = ACTIONS(3016),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3016),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3016),
    [sym_preproc_directive] = ACTIONS(3016),
    [anon_sym_LPAREN2] = ACTIONS(3018),
    [anon_sym_BANG] = ACTIONS(3018),
    [anon_sym_TILDE] = ACTIONS(3018),
    [anon_sym_DASH] = ACTIONS(3016),
    [anon_sym_PLUS] = ACTIONS(3016),
    [anon_sym_STAR] = ACTIONS(3018),
    [anon_sym_AMP_AMP] = ACTIONS(3018),
    [anon_sym_AMP] = ACTIONS(3016),
    [anon_sym_SEMI] = ACTIONS(3018),
    [anon_sym___extension__] = ACTIONS(3016),
    [anon_sym_typedef] = ACTIONS(3016),
    [anon_sym_extern] = ACTIONS(3016),
    [anon_sym___attribute__] = ACTIONS(3016),
    [anon_sym_COLON_COLON] = ACTIONS(3018),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3018),
    [anon_sym___declspec] = ACTIONS(3016),
    [anon_sym___based] = ACTIONS(3016),
    [anon_sym___cdecl] = ACTIONS(3016),
    [anon_sym___clrcall] = ACTIONS(3016),
    [anon_sym___stdcall] = ACTIONS(3016),
    [anon_sym___fastcall] = ACTIONS(3016),
    [anon_sym___thiscall] = ACTIONS(3016),
    [anon_sym___vectorcall] = ACTIONS(3016),
    [anon_sym_LBRACE] = ACTIONS(3018),
    [anon_sym_signed] = ACTIONS(3016),
    [anon_sym_unsigned] = ACTIONS(3016),
    [anon_sym_long] = ACTIONS(3016),
    [anon_sym_short] = ACTIONS(3016),
    [anon_sym_LBRACK] = ACTIONS(3016),
    [anon_sym_static] = ACTIONS(3016),
    [anon_sym_register] = ACTIONS(3016),
    [anon_sym_inline] = ACTIONS(3016),
    [anon_sym___inline] = ACTIONS(3016),
    [anon_sym___inline__] = ACTIONS(3016),
    [anon_sym___forceinline] = ACTIONS(3016),
    [anon_sym_thread_local] = ACTIONS(3016),
    [anon_sym___thread] = ACTIONS(3016),
    [anon_sym_const] = ACTIONS(3016),
    [anon_sym_constexpr] = ACTIONS(3016),
    [anon_sym_volatile] = ACTIONS(3016),
    [anon_sym_restrict] = ACTIONS(3016),
    [anon_sym___restrict__] = ACTIONS(3016),
    [anon_sym__Atomic] = ACTIONS(3016),
    [anon_sym__Noreturn] = ACTIONS(3016),
    [anon_sym_noreturn] = ACTIONS(3016),
    [anon_sym_mutable] = ACTIONS(3016),
    [anon_sym_constinit] = ACTIONS(3016),
    [anon_sym_consteval] = ACTIONS(3016),
    [anon_sym_PROGMEM] = ACTIONS(3016),
    [aux_sym_primitive_type_token1] = ACTIONS(3016),
    [anon_sym_byte] = ACTIONS(3016),
    [anon_sym_word] = ACTIONS(3016),
    [anon_sym_enum] = ACTIONS(3016),
    [anon_sym_class] = ACTIONS(3016),
    [anon_sym_struct] = ACTIONS(3016),
    [anon_sym_union] = ACTIONS(3016),
    [anon_sym_if] = ACTIONS(3016),
    [anon_sym_switch] = ACTIONS(3016),
    [anon_sym_case] = ACTIONS(3016),
    [anon_sym_default] = ACTIONS(3016),
    [anon_sym_while] = ACTIONS(3016),
    [anon_sym_do] = ACTIONS(3016),
    [anon_sym_for] = ACTIONS(3016),
    [anon_sym_return] = ACTIONS(3016),
    [anon_sym_break] = ACTIONS(3016),
    [anon_sym_continue] = ACTIONS(3016),
    [anon_sym_goto] = ACTIONS(3016),
    [anon_sym___try] = ACTIONS(3016),
    [anon_sym___leave] = ACTIONS(3016),
    [anon_sym_not] = ACTIONS(3016),
    [anon_sym_compl] = ACTIONS(3016),
    [anon_sym_DASH_DASH] = ACTIONS(3018),
    [anon_sym_PLUS_PLUS] = ACTIONS(3018),
    [anon_sym_sizeof] = ACTIONS(3016),
    [anon_sym___alignof__] = ACTIONS(3016),
    [anon_sym___alignof] = ACTIONS(3016),
    [anon_sym__alignof] = ACTIONS(3016),
    [anon_sym_alignof] = ACTIONS(3016),
    [anon_sym__Alignof] = ACTIONS(3016),
    [anon_sym_offsetof] = ACTIONS(3016),
    [anon_sym__Generic] = ACTIONS(3016),
    [anon_sym_asm] = ACTIONS(3016),
    [anon_sym___asm__] = ACTIONS(3016),
    [aux_sym_number_literal_token1] = ACTIONS(3018),
    [aux_sym_number_literal_token2] = ACTIONS(3016),
    [anon_sym_L_SQUOTE] = ACTIONS(3018),
    [anon_sym_u_SQUOTE] = ACTIONS(3018),
    [anon_sym_U_SQUOTE] = ACTIONS(3018),
    [anon_sym_u8_SQUOTE] = ACTIONS(3018),
    [anon_sym_SQUOTE] = ACTIONS(3018),
    [anon_sym_L_DQUOTE] = ACTIONS(3018),
    [anon_sym_u_DQUOTE] = ACTIONS(3018),
    [anon_sym_U_DQUOTE] = ACTIONS(3018),
    [anon_sym_u8_DQUOTE] = ACTIONS(3018),
    [anon_sym_DQUOTE] = ACTIONS(3018),
    [sym_true] = ACTIONS(3016),
    [sym_false] = ACTIONS(3016),
    [anon_sym_NULL] = ACTIONS(3016),
    [anon_sym_nullptr] = ACTIONS(3016),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3016),
    [anon_sym_decltype] = ACTIONS(3016),
    [anon_sym_virtual] = ACTIONS(3016),
    [anon_sym_alignas] = ACTIONS(3016),
    [anon_sym_explicit] = ACTIONS(3016),
    [anon_sym_typename] = ACTIONS(3016),
    [anon_sym_template] = ACTIONS(3016),
    [anon_sym_operator] = ACTIONS(3016),
    [anon_sym_try] = ACTIONS(3016),
    [anon_sym_delete] = ACTIONS(3016),
    [anon_sym_throw] = ACTIONS(3016),
    [anon_sym_namespace] = ACTIONS(3016),
    [anon_sym_using] = ACTIONS(3016),
    [anon_sym_static_assert] = ACTIONS(3016),
    [anon_sym_concept] = ACTIONS(3016),
    [anon_sym_co_return] = ACTIONS(3016),
    [anon_sym_co_yield] = ACTIONS(3016),
    [anon_sym_R_DQUOTE] = ACTIONS(3018),
    [anon_sym_LR_DQUOTE] = ACTIONS(3018),
    [anon_sym_uR_DQUOTE] = ACTIONS(3018),
    [anon_sym_UR_DQUOTE] = ACTIONS(3018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3018),
    [anon_sym_co_await] = ACTIONS(3016),
    [anon_sym_new] = ACTIONS(3016),
    [anon_sym_requires] = ACTIONS(3016),
    [sym_this] = ACTIONS(3016),
  },
  [374] = {
    [sym_identifier] = ACTIONS(3020),
    [aux_sym_preproc_include_token1] = ACTIONS(3020),
    [aux_sym_preproc_def_token1] = ACTIONS(3020),
    [aux_sym_preproc_if_token1] = ACTIONS(3020),
    [aux_sym_preproc_if_token2] = ACTIONS(3020),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3020),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3020),
    [aux_sym_preproc_else_token1] = ACTIONS(3020),
    [aux_sym_preproc_elif_token1] = ACTIONS(3020),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3020),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3020),
    [sym_preproc_directive] = ACTIONS(3020),
    [anon_sym_LPAREN2] = ACTIONS(3022),
    [anon_sym_BANG] = ACTIONS(3022),
    [anon_sym_TILDE] = ACTIONS(3022),
    [anon_sym_DASH] = ACTIONS(3020),
    [anon_sym_PLUS] = ACTIONS(3020),
    [anon_sym_STAR] = ACTIONS(3022),
    [anon_sym_AMP_AMP] = ACTIONS(3022),
    [anon_sym_AMP] = ACTIONS(3020),
    [anon_sym_SEMI] = ACTIONS(3022),
    [anon_sym___extension__] = ACTIONS(3020),
    [anon_sym_typedef] = ACTIONS(3020),
    [anon_sym_extern] = ACTIONS(3020),
    [anon_sym___attribute__] = ACTIONS(3020),
    [anon_sym_COLON_COLON] = ACTIONS(3022),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3022),
    [anon_sym___declspec] = ACTIONS(3020),
    [anon_sym___based] = ACTIONS(3020),
    [anon_sym___cdecl] = ACTIONS(3020),
    [anon_sym___clrcall] = ACTIONS(3020),
    [anon_sym___stdcall] = ACTIONS(3020),
    [anon_sym___fastcall] = ACTIONS(3020),
    [anon_sym___thiscall] = ACTIONS(3020),
    [anon_sym___vectorcall] = ACTIONS(3020),
    [anon_sym_LBRACE] = ACTIONS(3022),
    [anon_sym_signed] = ACTIONS(3020),
    [anon_sym_unsigned] = ACTIONS(3020),
    [anon_sym_long] = ACTIONS(3020),
    [anon_sym_short] = ACTIONS(3020),
    [anon_sym_LBRACK] = ACTIONS(3020),
    [anon_sym_static] = ACTIONS(3020),
    [anon_sym_register] = ACTIONS(3020),
    [anon_sym_inline] = ACTIONS(3020),
    [anon_sym___inline] = ACTIONS(3020),
    [anon_sym___inline__] = ACTIONS(3020),
    [anon_sym___forceinline] = ACTIONS(3020),
    [anon_sym_thread_local] = ACTIONS(3020),
    [anon_sym___thread] = ACTIONS(3020),
    [anon_sym_const] = ACTIONS(3020),
    [anon_sym_constexpr] = ACTIONS(3020),
    [anon_sym_volatile] = ACTIONS(3020),
    [anon_sym_restrict] = ACTIONS(3020),
    [anon_sym___restrict__] = ACTIONS(3020),
    [anon_sym__Atomic] = ACTIONS(3020),
    [anon_sym__Noreturn] = ACTIONS(3020),
    [anon_sym_noreturn] = ACTIONS(3020),
    [anon_sym_mutable] = ACTIONS(3020),
    [anon_sym_constinit] = ACTIONS(3020),
    [anon_sym_consteval] = ACTIONS(3020),
    [anon_sym_PROGMEM] = ACTIONS(3020),
    [aux_sym_primitive_type_token1] = ACTIONS(3020),
    [anon_sym_byte] = ACTIONS(3020),
    [anon_sym_word] = ACTIONS(3020),
    [anon_sym_enum] = ACTIONS(3020),
    [anon_sym_class] = ACTIONS(3020),
    [anon_sym_struct] = ACTIONS(3020),
    [anon_sym_union] = ACTIONS(3020),
    [anon_sym_if] = ACTIONS(3020),
    [anon_sym_switch] = ACTIONS(3020),
    [anon_sym_case] = ACTIONS(3020),
    [anon_sym_default] = ACTIONS(3020),
    [anon_sym_while] = ACTIONS(3020),
    [anon_sym_do] = ACTIONS(3020),
    [anon_sym_for] = ACTIONS(3020),
    [anon_sym_return] = ACTIONS(3020),
    [anon_sym_break] = ACTIONS(3020),
    [anon_sym_continue] = ACTIONS(3020),
    [anon_sym_goto] = ACTIONS(3020),
    [anon_sym___try] = ACTIONS(3020),
    [anon_sym___leave] = ACTIONS(3020),
    [anon_sym_not] = ACTIONS(3020),
    [anon_sym_compl] = ACTIONS(3020),
    [anon_sym_DASH_DASH] = ACTIONS(3022),
    [anon_sym_PLUS_PLUS] = ACTIONS(3022),
    [anon_sym_sizeof] = ACTIONS(3020),
    [anon_sym___alignof__] = ACTIONS(3020),
    [anon_sym___alignof] = ACTIONS(3020),
    [anon_sym__alignof] = ACTIONS(3020),
    [anon_sym_alignof] = ACTIONS(3020),
    [anon_sym__Alignof] = ACTIONS(3020),
    [anon_sym_offsetof] = ACTIONS(3020),
    [anon_sym__Generic] = ACTIONS(3020),
    [anon_sym_asm] = ACTIONS(3020),
    [anon_sym___asm__] = ACTIONS(3020),
    [aux_sym_number_literal_token1] = ACTIONS(3022),
    [aux_sym_number_literal_token2] = ACTIONS(3020),
    [anon_sym_L_SQUOTE] = ACTIONS(3022),
    [anon_sym_u_SQUOTE] = ACTIONS(3022),
    [anon_sym_U_SQUOTE] = ACTIONS(3022),
    [anon_sym_u8_SQUOTE] = ACTIONS(3022),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [anon_sym_L_DQUOTE] = ACTIONS(3022),
    [anon_sym_u_DQUOTE] = ACTIONS(3022),
    [anon_sym_U_DQUOTE] = ACTIONS(3022),
    [anon_sym_u8_DQUOTE] = ACTIONS(3022),
    [anon_sym_DQUOTE] = ACTIONS(3022),
    [sym_true] = ACTIONS(3020),
    [sym_false] = ACTIONS(3020),
    [anon_sym_NULL] = ACTIONS(3020),
    [anon_sym_nullptr] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3020),
    [anon_sym_decltype] = ACTIONS(3020),
    [anon_sym_virtual] = ACTIONS(3020),
    [anon_sym_alignas] = ACTIONS(3020),
    [anon_sym_explicit] = ACTIONS(3020),
    [anon_sym_typename] = ACTIONS(3020),
    [anon_sym_template] = ACTIONS(3020),
    [anon_sym_operator] = ACTIONS(3020),
    [anon_sym_try] = ACTIONS(3020),
    [anon_sym_delete] = ACTIONS(3020),
    [anon_sym_throw] = ACTIONS(3020),
    [anon_sym_namespace] = ACTIONS(3020),
    [anon_sym_using] = ACTIONS(3020),
    [anon_sym_static_assert] = ACTIONS(3020),
    [anon_sym_concept] = ACTIONS(3020),
    [anon_sym_co_return] = ACTIONS(3020),
    [anon_sym_co_yield] = ACTIONS(3020),
    [anon_sym_R_DQUOTE] = ACTIONS(3022),
    [anon_sym_LR_DQUOTE] = ACTIONS(3022),
    [anon_sym_uR_DQUOTE] = ACTIONS(3022),
    [anon_sym_UR_DQUOTE] = ACTIONS(3022),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3022),
    [anon_sym_co_await] = ACTIONS(3020),
    [anon_sym_new] = ACTIONS(3020),
    [anon_sym_requires] = ACTIONS(3020),
    [sym_this] = ACTIONS(3020),
  },
  [375] = {
    [sym_identifier] = ACTIONS(3024),
    [aux_sym_preproc_include_token1] = ACTIONS(3024),
    [aux_sym_preproc_def_token1] = ACTIONS(3024),
    [aux_sym_preproc_if_token1] = ACTIONS(3024),
    [aux_sym_preproc_if_token2] = ACTIONS(3024),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3024),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3024),
    [aux_sym_preproc_else_token1] = ACTIONS(3024),
    [aux_sym_preproc_elif_token1] = ACTIONS(3024),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3024),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3024),
    [sym_preproc_directive] = ACTIONS(3024),
    [anon_sym_LPAREN2] = ACTIONS(3026),
    [anon_sym_BANG] = ACTIONS(3026),
    [anon_sym_TILDE] = ACTIONS(3026),
    [anon_sym_DASH] = ACTIONS(3024),
    [anon_sym_PLUS] = ACTIONS(3024),
    [anon_sym_STAR] = ACTIONS(3026),
    [anon_sym_AMP_AMP] = ACTIONS(3026),
    [anon_sym_AMP] = ACTIONS(3024),
    [anon_sym_SEMI] = ACTIONS(3026),
    [anon_sym___extension__] = ACTIONS(3024),
    [anon_sym_typedef] = ACTIONS(3024),
    [anon_sym_extern] = ACTIONS(3024),
    [anon_sym___attribute__] = ACTIONS(3024),
    [anon_sym_COLON_COLON] = ACTIONS(3026),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3026),
    [anon_sym___declspec] = ACTIONS(3024),
    [anon_sym___based] = ACTIONS(3024),
    [anon_sym___cdecl] = ACTIONS(3024),
    [anon_sym___clrcall] = ACTIONS(3024),
    [anon_sym___stdcall] = ACTIONS(3024),
    [anon_sym___fastcall] = ACTIONS(3024),
    [anon_sym___thiscall] = ACTIONS(3024),
    [anon_sym___vectorcall] = ACTIONS(3024),
    [anon_sym_LBRACE] = ACTIONS(3026),
    [anon_sym_signed] = ACTIONS(3024),
    [anon_sym_unsigned] = ACTIONS(3024),
    [anon_sym_long] = ACTIONS(3024),
    [anon_sym_short] = ACTIONS(3024),
    [anon_sym_LBRACK] = ACTIONS(3024),
    [anon_sym_static] = ACTIONS(3024),
    [anon_sym_register] = ACTIONS(3024),
    [anon_sym_inline] = ACTIONS(3024),
    [anon_sym___inline] = ACTIONS(3024),
    [anon_sym___inline__] = ACTIONS(3024),
    [anon_sym___forceinline] = ACTIONS(3024),
    [anon_sym_thread_local] = ACTIONS(3024),
    [anon_sym___thread] = ACTIONS(3024),
    [anon_sym_const] = ACTIONS(3024),
    [anon_sym_constexpr] = ACTIONS(3024),
    [anon_sym_volatile] = ACTIONS(3024),
    [anon_sym_restrict] = ACTIONS(3024),
    [anon_sym___restrict__] = ACTIONS(3024),
    [anon_sym__Atomic] = ACTIONS(3024),
    [anon_sym__Noreturn] = ACTIONS(3024),
    [anon_sym_noreturn] = ACTIONS(3024),
    [anon_sym_mutable] = ACTIONS(3024),
    [anon_sym_constinit] = ACTIONS(3024),
    [anon_sym_consteval] = ACTIONS(3024),
    [anon_sym_PROGMEM] = ACTIONS(3024),
    [aux_sym_primitive_type_token1] = ACTIONS(3024),
    [anon_sym_byte] = ACTIONS(3024),
    [anon_sym_word] = ACTIONS(3024),
    [anon_sym_enum] = ACTIONS(3024),
    [anon_sym_class] = ACTIONS(3024),
    [anon_sym_struct] = ACTIONS(3024),
    [anon_sym_union] = ACTIONS(3024),
    [anon_sym_if] = ACTIONS(3024),
    [anon_sym_switch] = ACTIONS(3024),
    [anon_sym_case] = ACTIONS(3024),
    [anon_sym_default] = ACTIONS(3024),
    [anon_sym_while] = ACTIONS(3024),
    [anon_sym_do] = ACTIONS(3024),
    [anon_sym_for] = ACTIONS(3024),
    [anon_sym_return] = ACTIONS(3024),
    [anon_sym_break] = ACTIONS(3024),
    [anon_sym_continue] = ACTIONS(3024),
    [anon_sym_goto] = ACTIONS(3024),
    [anon_sym___try] = ACTIONS(3024),
    [anon_sym___leave] = ACTIONS(3024),
    [anon_sym_not] = ACTIONS(3024),
    [anon_sym_compl] = ACTIONS(3024),
    [anon_sym_DASH_DASH] = ACTIONS(3026),
    [anon_sym_PLUS_PLUS] = ACTIONS(3026),
    [anon_sym_sizeof] = ACTIONS(3024),
    [anon_sym___alignof__] = ACTIONS(3024),
    [anon_sym___alignof] = ACTIONS(3024),
    [anon_sym__alignof] = ACTIONS(3024),
    [anon_sym_alignof] = ACTIONS(3024),
    [anon_sym__Alignof] = ACTIONS(3024),
    [anon_sym_offsetof] = ACTIONS(3024),
    [anon_sym__Generic] = ACTIONS(3024),
    [anon_sym_asm] = ACTIONS(3024),
    [anon_sym___asm__] = ACTIONS(3024),
    [aux_sym_number_literal_token1] = ACTIONS(3026),
    [aux_sym_number_literal_token2] = ACTIONS(3024),
    [anon_sym_L_SQUOTE] = ACTIONS(3026),
    [anon_sym_u_SQUOTE] = ACTIONS(3026),
    [anon_sym_U_SQUOTE] = ACTIONS(3026),
    [anon_sym_u8_SQUOTE] = ACTIONS(3026),
    [anon_sym_SQUOTE] = ACTIONS(3026),
    [anon_sym_L_DQUOTE] = ACTIONS(3026),
    [anon_sym_u_DQUOTE] = ACTIONS(3026),
    [anon_sym_U_DQUOTE] = ACTIONS(3026),
    [anon_sym_u8_DQUOTE] = ACTIONS(3026),
    [anon_sym_DQUOTE] = ACTIONS(3026),
    [sym_true] = ACTIONS(3024),
    [sym_false] = ACTIONS(3024),
    [anon_sym_NULL] = ACTIONS(3024),
    [anon_sym_nullptr] = ACTIONS(3024),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3024),
    [anon_sym_decltype] = ACTIONS(3024),
    [anon_sym_virtual] = ACTIONS(3024),
    [anon_sym_alignas] = ACTIONS(3024),
    [anon_sym_explicit] = ACTIONS(3024),
    [anon_sym_typename] = ACTIONS(3024),
    [anon_sym_template] = ACTIONS(3024),
    [anon_sym_operator] = ACTIONS(3024),
    [anon_sym_try] = ACTIONS(3024),
    [anon_sym_delete] = ACTIONS(3024),
    [anon_sym_throw] = ACTIONS(3024),
    [anon_sym_namespace] = ACTIONS(3024),
    [anon_sym_using] = ACTIONS(3024),
    [anon_sym_static_assert] = ACTIONS(3024),
    [anon_sym_concept] = ACTIONS(3024),
    [anon_sym_co_return] = ACTIONS(3024),
    [anon_sym_co_yield] = ACTIONS(3024),
    [anon_sym_R_DQUOTE] = ACTIONS(3026),
    [anon_sym_LR_DQUOTE] = ACTIONS(3026),
    [anon_sym_uR_DQUOTE] = ACTIONS(3026),
    [anon_sym_UR_DQUOTE] = ACTIONS(3026),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3026),
    [anon_sym_co_await] = ACTIONS(3024),
    [anon_sym_new] = ACTIONS(3024),
    [anon_sym_requires] = ACTIONS(3024),
    [sym_this] = ACTIONS(3024),
  },
  [376] = {
    [sym_identifier] = ACTIONS(3028),
    [aux_sym_preproc_include_token1] = ACTIONS(3028),
    [aux_sym_preproc_def_token1] = ACTIONS(3028),
    [aux_sym_preproc_if_token1] = ACTIONS(3028),
    [aux_sym_preproc_if_token2] = ACTIONS(3028),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3028),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3028),
    [aux_sym_preproc_else_token1] = ACTIONS(3028),
    [aux_sym_preproc_elif_token1] = ACTIONS(3028),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3028),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3028),
    [sym_preproc_directive] = ACTIONS(3028),
    [anon_sym_LPAREN2] = ACTIONS(3030),
    [anon_sym_BANG] = ACTIONS(3030),
    [anon_sym_TILDE] = ACTIONS(3030),
    [anon_sym_DASH] = ACTIONS(3028),
    [anon_sym_PLUS] = ACTIONS(3028),
    [anon_sym_STAR] = ACTIONS(3030),
    [anon_sym_AMP_AMP] = ACTIONS(3030),
    [anon_sym_AMP] = ACTIONS(3028),
    [anon_sym_SEMI] = ACTIONS(3030),
    [anon_sym___extension__] = ACTIONS(3028),
    [anon_sym_typedef] = ACTIONS(3028),
    [anon_sym_extern] = ACTIONS(3028),
    [anon_sym___attribute__] = ACTIONS(3028),
    [anon_sym_COLON_COLON] = ACTIONS(3030),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3030),
    [anon_sym___declspec] = ACTIONS(3028),
    [anon_sym___based] = ACTIONS(3028),
    [anon_sym___cdecl] = ACTIONS(3028),
    [anon_sym___clrcall] = ACTIONS(3028),
    [anon_sym___stdcall] = ACTIONS(3028),
    [anon_sym___fastcall] = ACTIONS(3028),
    [anon_sym___thiscall] = ACTIONS(3028),
    [anon_sym___vectorcall] = ACTIONS(3028),
    [anon_sym_LBRACE] = ACTIONS(3030),
    [anon_sym_signed] = ACTIONS(3028),
    [anon_sym_unsigned] = ACTIONS(3028),
    [anon_sym_long] = ACTIONS(3028),
    [anon_sym_short] = ACTIONS(3028),
    [anon_sym_LBRACK] = ACTIONS(3028),
    [anon_sym_static] = ACTIONS(3028),
    [anon_sym_register] = ACTIONS(3028),
    [anon_sym_inline] = ACTIONS(3028),
    [anon_sym___inline] = ACTIONS(3028),
    [anon_sym___inline__] = ACTIONS(3028),
    [anon_sym___forceinline] = ACTIONS(3028),
    [anon_sym_thread_local] = ACTIONS(3028),
    [anon_sym___thread] = ACTIONS(3028),
    [anon_sym_const] = ACTIONS(3028),
    [anon_sym_constexpr] = ACTIONS(3028),
    [anon_sym_volatile] = ACTIONS(3028),
    [anon_sym_restrict] = ACTIONS(3028),
    [anon_sym___restrict__] = ACTIONS(3028),
    [anon_sym__Atomic] = ACTIONS(3028),
    [anon_sym__Noreturn] = ACTIONS(3028),
    [anon_sym_noreturn] = ACTIONS(3028),
    [anon_sym_mutable] = ACTIONS(3028),
    [anon_sym_constinit] = ACTIONS(3028),
    [anon_sym_consteval] = ACTIONS(3028),
    [anon_sym_PROGMEM] = ACTIONS(3028),
    [aux_sym_primitive_type_token1] = ACTIONS(3028),
    [anon_sym_byte] = ACTIONS(3028),
    [anon_sym_word] = ACTIONS(3028),
    [anon_sym_enum] = ACTIONS(3028),
    [anon_sym_class] = ACTIONS(3028),
    [anon_sym_struct] = ACTIONS(3028),
    [anon_sym_union] = ACTIONS(3028),
    [anon_sym_if] = ACTIONS(3028),
    [anon_sym_switch] = ACTIONS(3028),
    [anon_sym_case] = ACTIONS(3028),
    [anon_sym_default] = ACTIONS(3028),
    [anon_sym_while] = ACTIONS(3028),
    [anon_sym_do] = ACTIONS(3028),
    [anon_sym_for] = ACTIONS(3028),
    [anon_sym_return] = ACTIONS(3028),
    [anon_sym_break] = ACTIONS(3028),
    [anon_sym_continue] = ACTIONS(3028),
    [anon_sym_goto] = ACTIONS(3028),
    [anon_sym___try] = ACTIONS(3028),
    [anon_sym___leave] = ACTIONS(3028),
    [anon_sym_not] = ACTIONS(3028),
    [anon_sym_compl] = ACTIONS(3028),
    [anon_sym_DASH_DASH] = ACTIONS(3030),
    [anon_sym_PLUS_PLUS] = ACTIONS(3030),
    [anon_sym_sizeof] = ACTIONS(3028),
    [anon_sym___alignof__] = ACTIONS(3028),
    [anon_sym___alignof] = ACTIONS(3028),
    [anon_sym__alignof] = ACTIONS(3028),
    [anon_sym_alignof] = ACTIONS(3028),
    [anon_sym__Alignof] = ACTIONS(3028),
    [anon_sym_offsetof] = ACTIONS(3028),
    [anon_sym__Generic] = ACTIONS(3028),
    [anon_sym_asm] = ACTIONS(3028),
    [anon_sym___asm__] = ACTIONS(3028),
    [aux_sym_number_literal_token1] = ACTIONS(3030),
    [aux_sym_number_literal_token2] = ACTIONS(3028),
    [anon_sym_L_SQUOTE] = ACTIONS(3030),
    [anon_sym_u_SQUOTE] = ACTIONS(3030),
    [anon_sym_U_SQUOTE] = ACTIONS(3030),
    [anon_sym_u8_SQUOTE] = ACTIONS(3030),
    [anon_sym_SQUOTE] = ACTIONS(3030),
    [anon_sym_L_DQUOTE] = ACTIONS(3030),
    [anon_sym_u_DQUOTE] = ACTIONS(3030),
    [anon_sym_U_DQUOTE] = ACTIONS(3030),
    [anon_sym_u8_DQUOTE] = ACTIONS(3030),
    [anon_sym_DQUOTE] = ACTIONS(3030),
    [sym_true] = ACTIONS(3028),
    [sym_false] = ACTIONS(3028),
    [anon_sym_NULL] = ACTIONS(3028),
    [anon_sym_nullptr] = ACTIONS(3028),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3028),
    [anon_sym_decltype] = ACTIONS(3028),
    [anon_sym_virtual] = ACTIONS(3028),
    [anon_sym_alignas] = ACTIONS(3028),
    [anon_sym_explicit] = ACTIONS(3028),
    [anon_sym_typename] = ACTIONS(3028),
    [anon_sym_template] = ACTIONS(3028),
    [anon_sym_operator] = ACTIONS(3028),
    [anon_sym_try] = ACTIONS(3028),
    [anon_sym_delete] = ACTIONS(3028),
    [anon_sym_throw] = ACTIONS(3028),
    [anon_sym_namespace] = ACTIONS(3028),
    [anon_sym_using] = ACTIONS(3028),
    [anon_sym_static_assert] = ACTIONS(3028),
    [anon_sym_concept] = ACTIONS(3028),
    [anon_sym_co_return] = ACTIONS(3028),
    [anon_sym_co_yield] = ACTIONS(3028),
    [anon_sym_R_DQUOTE] = ACTIONS(3030),
    [anon_sym_LR_DQUOTE] = ACTIONS(3030),
    [anon_sym_uR_DQUOTE] = ACTIONS(3030),
    [anon_sym_UR_DQUOTE] = ACTIONS(3030),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3030),
    [anon_sym_co_await] = ACTIONS(3028),
    [anon_sym_new] = ACTIONS(3028),
    [anon_sym_requires] = ACTIONS(3028),
    [sym_this] = ACTIONS(3028),
  },
  [377] = {
    [sym_identifier] = ACTIONS(3032),
    [aux_sym_preproc_include_token1] = ACTIONS(3032),
    [aux_sym_preproc_def_token1] = ACTIONS(3032),
    [aux_sym_preproc_if_token1] = ACTIONS(3032),
    [aux_sym_preproc_if_token2] = ACTIONS(3032),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3032),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3032),
    [aux_sym_preproc_else_token1] = ACTIONS(3032),
    [aux_sym_preproc_elif_token1] = ACTIONS(3032),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3032),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3032),
    [sym_preproc_directive] = ACTIONS(3032),
    [anon_sym_LPAREN2] = ACTIONS(3034),
    [anon_sym_BANG] = ACTIONS(3034),
    [anon_sym_TILDE] = ACTIONS(3034),
    [anon_sym_DASH] = ACTIONS(3032),
    [anon_sym_PLUS] = ACTIONS(3032),
    [anon_sym_STAR] = ACTIONS(3034),
    [anon_sym_AMP_AMP] = ACTIONS(3034),
    [anon_sym_AMP] = ACTIONS(3032),
    [anon_sym_SEMI] = ACTIONS(3034),
    [anon_sym___extension__] = ACTIONS(3032),
    [anon_sym_typedef] = ACTIONS(3032),
    [anon_sym_extern] = ACTIONS(3032),
    [anon_sym___attribute__] = ACTIONS(3032),
    [anon_sym_COLON_COLON] = ACTIONS(3034),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3034),
    [anon_sym___declspec] = ACTIONS(3032),
    [anon_sym___based] = ACTIONS(3032),
    [anon_sym___cdecl] = ACTIONS(3032),
    [anon_sym___clrcall] = ACTIONS(3032),
    [anon_sym___stdcall] = ACTIONS(3032),
    [anon_sym___fastcall] = ACTIONS(3032),
    [anon_sym___thiscall] = ACTIONS(3032),
    [anon_sym___vectorcall] = ACTIONS(3032),
    [anon_sym_LBRACE] = ACTIONS(3034),
    [anon_sym_signed] = ACTIONS(3032),
    [anon_sym_unsigned] = ACTIONS(3032),
    [anon_sym_long] = ACTIONS(3032),
    [anon_sym_short] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(3032),
    [anon_sym_static] = ACTIONS(3032),
    [anon_sym_register] = ACTIONS(3032),
    [anon_sym_inline] = ACTIONS(3032),
    [anon_sym___inline] = ACTIONS(3032),
    [anon_sym___inline__] = ACTIONS(3032),
    [anon_sym___forceinline] = ACTIONS(3032),
    [anon_sym_thread_local] = ACTIONS(3032),
    [anon_sym___thread] = ACTIONS(3032),
    [anon_sym_const] = ACTIONS(3032),
    [anon_sym_constexpr] = ACTIONS(3032),
    [anon_sym_volatile] = ACTIONS(3032),
    [anon_sym_restrict] = ACTIONS(3032),
    [anon_sym___restrict__] = ACTIONS(3032),
    [anon_sym__Atomic] = ACTIONS(3032),
    [anon_sym__Noreturn] = ACTIONS(3032),
    [anon_sym_noreturn] = ACTIONS(3032),
    [anon_sym_mutable] = ACTIONS(3032),
    [anon_sym_constinit] = ACTIONS(3032),
    [anon_sym_consteval] = ACTIONS(3032),
    [anon_sym_PROGMEM] = ACTIONS(3032),
    [aux_sym_primitive_type_token1] = ACTIONS(3032),
    [anon_sym_byte] = ACTIONS(3032),
    [anon_sym_word] = ACTIONS(3032),
    [anon_sym_enum] = ACTIONS(3032),
    [anon_sym_class] = ACTIONS(3032),
    [anon_sym_struct] = ACTIONS(3032),
    [anon_sym_union] = ACTIONS(3032),
    [anon_sym_if] = ACTIONS(3032),
    [anon_sym_switch] = ACTIONS(3032),
    [anon_sym_case] = ACTIONS(3032),
    [anon_sym_default] = ACTIONS(3032),
    [anon_sym_while] = ACTIONS(3032),
    [anon_sym_do] = ACTIONS(3032),
    [anon_sym_for] = ACTIONS(3032),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_break] = ACTIONS(3032),
    [anon_sym_continue] = ACTIONS(3032),
    [anon_sym_goto] = ACTIONS(3032),
    [anon_sym___try] = ACTIONS(3032),
    [anon_sym___leave] = ACTIONS(3032),
    [anon_sym_not] = ACTIONS(3032),
    [anon_sym_compl] = ACTIONS(3032),
    [anon_sym_DASH_DASH] = ACTIONS(3034),
    [anon_sym_PLUS_PLUS] = ACTIONS(3034),
    [anon_sym_sizeof] = ACTIONS(3032),
    [anon_sym___alignof__] = ACTIONS(3032),
    [anon_sym___alignof] = ACTIONS(3032),
    [anon_sym__alignof] = ACTIONS(3032),
    [anon_sym_alignof] = ACTIONS(3032),
    [anon_sym__Alignof] = ACTIONS(3032),
    [anon_sym_offsetof] = ACTIONS(3032),
    [anon_sym__Generic] = ACTIONS(3032),
    [anon_sym_asm] = ACTIONS(3032),
    [anon_sym___asm__] = ACTIONS(3032),
    [aux_sym_number_literal_token1] = ACTIONS(3034),
    [aux_sym_number_literal_token2] = ACTIONS(3032),
    [anon_sym_L_SQUOTE] = ACTIONS(3034),
    [anon_sym_u_SQUOTE] = ACTIONS(3034),
    [anon_sym_U_SQUOTE] = ACTIONS(3034),
    [anon_sym_u8_SQUOTE] = ACTIONS(3034),
    [anon_sym_SQUOTE] = ACTIONS(3034),
    [anon_sym_L_DQUOTE] = ACTIONS(3034),
    [anon_sym_u_DQUOTE] = ACTIONS(3034),
    [anon_sym_U_DQUOTE] = ACTIONS(3034),
    [anon_sym_u8_DQUOTE] = ACTIONS(3034),
    [anon_sym_DQUOTE] = ACTIONS(3034),
    [sym_true] = ACTIONS(3032),
    [sym_false] = ACTIONS(3032),
    [anon_sym_NULL] = ACTIONS(3032),
    [anon_sym_nullptr] = ACTIONS(3032),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3032),
    [anon_sym_decltype] = ACTIONS(3032),
    [anon_sym_virtual] = ACTIONS(3032),
    [anon_sym_alignas] = ACTIONS(3032),
    [anon_sym_explicit] = ACTIONS(3032),
    [anon_sym_typename] = ACTIONS(3032),
    [anon_sym_template] = ACTIONS(3032),
    [anon_sym_operator] = ACTIONS(3032),
    [anon_sym_try] = ACTIONS(3032),
    [anon_sym_delete] = ACTIONS(3032),
    [anon_sym_throw] = ACTIONS(3032),
    [anon_sym_namespace] = ACTIONS(3032),
    [anon_sym_using] = ACTIONS(3032),
    [anon_sym_static_assert] = ACTIONS(3032),
    [anon_sym_concept] = ACTIONS(3032),
    [anon_sym_co_return] = ACTIONS(3032),
    [anon_sym_co_yield] = ACTIONS(3032),
    [anon_sym_R_DQUOTE] = ACTIONS(3034),
    [anon_sym_LR_DQUOTE] = ACTIONS(3034),
    [anon_sym_uR_DQUOTE] = ACTIONS(3034),
    [anon_sym_UR_DQUOTE] = ACTIONS(3034),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3034),
    [anon_sym_co_await] = ACTIONS(3032),
    [anon_sym_new] = ACTIONS(3032),
    [anon_sym_requires] = ACTIONS(3032),
    [sym_this] = ACTIONS(3032),
  },
  [378] = {
    [sym_identifier] = ACTIONS(3036),
    [aux_sym_preproc_include_token1] = ACTIONS(3036),
    [aux_sym_preproc_def_token1] = ACTIONS(3036),
    [aux_sym_preproc_if_token1] = ACTIONS(3036),
    [aux_sym_preproc_if_token2] = ACTIONS(3036),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3036),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3036),
    [aux_sym_preproc_else_token1] = ACTIONS(3036),
    [aux_sym_preproc_elif_token1] = ACTIONS(3036),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3036),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3036),
    [sym_preproc_directive] = ACTIONS(3036),
    [anon_sym_LPAREN2] = ACTIONS(3038),
    [anon_sym_BANG] = ACTIONS(3038),
    [anon_sym_TILDE] = ACTIONS(3038),
    [anon_sym_DASH] = ACTIONS(3036),
    [anon_sym_PLUS] = ACTIONS(3036),
    [anon_sym_STAR] = ACTIONS(3038),
    [anon_sym_AMP_AMP] = ACTIONS(3038),
    [anon_sym_AMP] = ACTIONS(3036),
    [anon_sym_SEMI] = ACTIONS(3038),
    [anon_sym___extension__] = ACTIONS(3036),
    [anon_sym_typedef] = ACTIONS(3036),
    [anon_sym_extern] = ACTIONS(3036),
    [anon_sym___attribute__] = ACTIONS(3036),
    [anon_sym_COLON_COLON] = ACTIONS(3038),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3038),
    [anon_sym___declspec] = ACTIONS(3036),
    [anon_sym___based] = ACTIONS(3036),
    [anon_sym___cdecl] = ACTIONS(3036),
    [anon_sym___clrcall] = ACTIONS(3036),
    [anon_sym___stdcall] = ACTIONS(3036),
    [anon_sym___fastcall] = ACTIONS(3036),
    [anon_sym___thiscall] = ACTIONS(3036),
    [anon_sym___vectorcall] = ACTIONS(3036),
    [anon_sym_LBRACE] = ACTIONS(3038),
    [anon_sym_signed] = ACTIONS(3036),
    [anon_sym_unsigned] = ACTIONS(3036),
    [anon_sym_long] = ACTIONS(3036),
    [anon_sym_short] = ACTIONS(3036),
    [anon_sym_LBRACK] = ACTIONS(3036),
    [anon_sym_static] = ACTIONS(3036),
    [anon_sym_register] = ACTIONS(3036),
    [anon_sym_inline] = ACTIONS(3036),
    [anon_sym___inline] = ACTIONS(3036),
    [anon_sym___inline__] = ACTIONS(3036),
    [anon_sym___forceinline] = ACTIONS(3036),
    [anon_sym_thread_local] = ACTIONS(3036),
    [anon_sym___thread] = ACTIONS(3036),
    [anon_sym_const] = ACTIONS(3036),
    [anon_sym_constexpr] = ACTIONS(3036),
    [anon_sym_volatile] = ACTIONS(3036),
    [anon_sym_restrict] = ACTIONS(3036),
    [anon_sym___restrict__] = ACTIONS(3036),
    [anon_sym__Atomic] = ACTIONS(3036),
    [anon_sym__Noreturn] = ACTIONS(3036),
    [anon_sym_noreturn] = ACTIONS(3036),
    [anon_sym_mutable] = ACTIONS(3036),
    [anon_sym_constinit] = ACTIONS(3036),
    [anon_sym_consteval] = ACTIONS(3036),
    [anon_sym_PROGMEM] = ACTIONS(3036),
    [aux_sym_primitive_type_token1] = ACTIONS(3036),
    [anon_sym_byte] = ACTIONS(3036),
    [anon_sym_word] = ACTIONS(3036),
    [anon_sym_enum] = ACTIONS(3036),
    [anon_sym_class] = ACTIONS(3036),
    [anon_sym_struct] = ACTIONS(3036),
    [anon_sym_union] = ACTIONS(3036),
    [anon_sym_if] = ACTIONS(3036),
    [anon_sym_switch] = ACTIONS(3036),
    [anon_sym_case] = ACTIONS(3036),
    [anon_sym_default] = ACTIONS(3036),
    [anon_sym_while] = ACTIONS(3036),
    [anon_sym_do] = ACTIONS(3036),
    [anon_sym_for] = ACTIONS(3036),
    [anon_sym_return] = ACTIONS(3036),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_continue] = ACTIONS(3036),
    [anon_sym_goto] = ACTIONS(3036),
    [anon_sym___try] = ACTIONS(3036),
    [anon_sym___leave] = ACTIONS(3036),
    [anon_sym_not] = ACTIONS(3036),
    [anon_sym_compl] = ACTIONS(3036),
    [anon_sym_DASH_DASH] = ACTIONS(3038),
    [anon_sym_PLUS_PLUS] = ACTIONS(3038),
    [anon_sym_sizeof] = ACTIONS(3036),
    [anon_sym___alignof__] = ACTIONS(3036),
    [anon_sym___alignof] = ACTIONS(3036),
    [anon_sym__alignof] = ACTIONS(3036),
    [anon_sym_alignof] = ACTIONS(3036),
    [anon_sym__Alignof] = ACTIONS(3036),
    [anon_sym_offsetof] = ACTIONS(3036),
    [anon_sym__Generic] = ACTIONS(3036),
    [anon_sym_asm] = ACTIONS(3036),
    [anon_sym___asm__] = ACTIONS(3036),
    [aux_sym_number_literal_token1] = ACTIONS(3038),
    [aux_sym_number_literal_token2] = ACTIONS(3036),
    [anon_sym_L_SQUOTE] = ACTIONS(3038),
    [anon_sym_u_SQUOTE] = ACTIONS(3038),
    [anon_sym_U_SQUOTE] = ACTIONS(3038),
    [anon_sym_u8_SQUOTE] = ACTIONS(3038),
    [anon_sym_SQUOTE] = ACTIONS(3038),
    [anon_sym_L_DQUOTE] = ACTIONS(3038),
    [anon_sym_u_DQUOTE] = ACTIONS(3038),
    [anon_sym_U_DQUOTE] = ACTIONS(3038),
    [anon_sym_u8_DQUOTE] = ACTIONS(3038),
    [anon_sym_DQUOTE] = ACTIONS(3038),
    [sym_true] = ACTIONS(3036),
    [sym_false] = ACTIONS(3036),
    [anon_sym_NULL] = ACTIONS(3036),
    [anon_sym_nullptr] = ACTIONS(3036),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3036),
    [anon_sym_decltype] = ACTIONS(3036),
    [anon_sym_virtual] = ACTIONS(3036),
    [anon_sym_alignas] = ACTIONS(3036),
    [anon_sym_explicit] = ACTIONS(3036),
    [anon_sym_typename] = ACTIONS(3036),
    [anon_sym_template] = ACTIONS(3036),
    [anon_sym_operator] = ACTIONS(3036),
    [anon_sym_try] = ACTIONS(3036),
    [anon_sym_delete] = ACTIONS(3036),
    [anon_sym_throw] = ACTIONS(3036),
    [anon_sym_namespace] = ACTIONS(3036),
    [anon_sym_using] = ACTIONS(3036),
    [anon_sym_static_assert] = ACTIONS(3036),
    [anon_sym_concept] = ACTIONS(3036),
    [anon_sym_co_return] = ACTIONS(3036),
    [anon_sym_co_yield] = ACTIONS(3036),
    [anon_sym_R_DQUOTE] = ACTIONS(3038),
    [anon_sym_LR_DQUOTE] = ACTIONS(3038),
    [anon_sym_uR_DQUOTE] = ACTIONS(3038),
    [anon_sym_UR_DQUOTE] = ACTIONS(3038),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3038),
    [anon_sym_co_await] = ACTIONS(3036),
    [anon_sym_new] = ACTIONS(3036),
    [anon_sym_requires] = ACTIONS(3036),
    [sym_this] = ACTIONS(3036),
  },
  [379] = {
    [sym_identifier] = ACTIONS(3040),
    [aux_sym_preproc_include_token1] = ACTIONS(3040),
    [aux_sym_preproc_def_token1] = ACTIONS(3040),
    [aux_sym_preproc_if_token1] = ACTIONS(3040),
    [aux_sym_preproc_if_token2] = ACTIONS(3040),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3040),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3040),
    [aux_sym_preproc_else_token1] = ACTIONS(3040),
    [aux_sym_preproc_elif_token1] = ACTIONS(3040),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3040),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3040),
    [sym_preproc_directive] = ACTIONS(3040),
    [anon_sym_LPAREN2] = ACTIONS(3042),
    [anon_sym_BANG] = ACTIONS(3042),
    [anon_sym_TILDE] = ACTIONS(3042),
    [anon_sym_DASH] = ACTIONS(3040),
    [anon_sym_PLUS] = ACTIONS(3040),
    [anon_sym_STAR] = ACTIONS(3042),
    [anon_sym_AMP_AMP] = ACTIONS(3042),
    [anon_sym_AMP] = ACTIONS(3040),
    [anon_sym_SEMI] = ACTIONS(3042),
    [anon_sym___extension__] = ACTIONS(3040),
    [anon_sym_typedef] = ACTIONS(3040),
    [anon_sym_extern] = ACTIONS(3040),
    [anon_sym___attribute__] = ACTIONS(3040),
    [anon_sym_COLON_COLON] = ACTIONS(3042),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3042),
    [anon_sym___declspec] = ACTIONS(3040),
    [anon_sym___based] = ACTIONS(3040),
    [anon_sym___cdecl] = ACTIONS(3040),
    [anon_sym___clrcall] = ACTIONS(3040),
    [anon_sym___stdcall] = ACTIONS(3040),
    [anon_sym___fastcall] = ACTIONS(3040),
    [anon_sym___thiscall] = ACTIONS(3040),
    [anon_sym___vectorcall] = ACTIONS(3040),
    [anon_sym_LBRACE] = ACTIONS(3042),
    [anon_sym_signed] = ACTIONS(3040),
    [anon_sym_unsigned] = ACTIONS(3040),
    [anon_sym_long] = ACTIONS(3040),
    [anon_sym_short] = ACTIONS(3040),
    [anon_sym_LBRACK] = ACTIONS(3040),
    [anon_sym_static] = ACTIONS(3040),
    [anon_sym_register] = ACTIONS(3040),
    [anon_sym_inline] = ACTIONS(3040),
    [anon_sym___inline] = ACTIONS(3040),
    [anon_sym___inline__] = ACTIONS(3040),
    [anon_sym___forceinline] = ACTIONS(3040),
    [anon_sym_thread_local] = ACTIONS(3040),
    [anon_sym___thread] = ACTIONS(3040),
    [anon_sym_const] = ACTIONS(3040),
    [anon_sym_constexpr] = ACTIONS(3040),
    [anon_sym_volatile] = ACTIONS(3040),
    [anon_sym_restrict] = ACTIONS(3040),
    [anon_sym___restrict__] = ACTIONS(3040),
    [anon_sym__Atomic] = ACTIONS(3040),
    [anon_sym__Noreturn] = ACTIONS(3040),
    [anon_sym_noreturn] = ACTIONS(3040),
    [anon_sym_mutable] = ACTIONS(3040),
    [anon_sym_constinit] = ACTIONS(3040),
    [anon_sym_consteval] = ACTIONS(3040),
    [anon_sym_PROGMEM] = ACTIONS(3040),
    [aux_sym_primitive_type_token1] = ACTIONS(3040),
    [anon_sym_byte] = ACTIONS(3040),
    [anon_sym_word] = ACTIONS(3040),
    [anon_sym_enum] = ACTIONS(3040),
    [anon_sym_class] = ACTIONS(3040),
    [anon_sym_struct] = ACTIONS(3040),
    [anon_sym_union] = ACTIONS(3040),
    [anon_sym_if] = ACTIONS(3040),
    [anon_sym_switch] = ACTIONS(3040),
    [anon_sym_case] = ACTIONS(3040),
    [anon_sym_default] = ACTIONS(3040),
    [anon_sym_while] = ACTIONS(3040),
    [anon_sym_do] = ACTIONS(3040),
    [anon_sym_for] = ACTIONS(3040),
    [anon_sym_return] = ACTIONS(3040),
    [anon_sym_break] = ACTIONS(3040),
    [anon_sym_continue] = ACTIONS(3040),
    [anon_sym_goto] = ACTIONS(3040),
    [anon_sym___try] = ACTIONS(3040),
    [anon_sym___leave] = ACTIONS(3040),
    [anon_sym_not] = ACTIONS(3040),
    [anon_sym_compl] = ACTIONS(3040),
    [anon_sym_DASH_DASH] = ACTIONS(3042),
    [anon_sym_PLUS_PLUS] = ACTIONS(3042),
    [anon_sym_sizeof] = ACTIONS(3040),
    [anon_sym___alignof__] = ACTIONS(3040),
    [anon_sym___alignof] = ACTIONS(3040),
    [anon_sym__alignof] = ACTIONS(3040),
    [anon_sym_alignof] = ACTIONS(3040),
    [anon_sym__Alignof] = ACTIONS(3040),
    [anon_sym_offsetof] = ACTIONS(3040),
    [anon_sym__Generic] = ACTIONS(3040),
    [anon_sym_asm] = ACTIONS(3040),
    [anon_sym___asm__] = ACTIONS(3040),
    [aux_sym_number_literal_token1] = ACTIONS(3042),
    [aux_sym_number_literal_token2] = ACTIONS(3040),
    [anon_sym_L_SQUOTE] = ACTIONS(3042),
    [anon_sym_u_SQUOTE] = ACTIONS(3042),
    [anon_sym_U_SQUOTE] = ACTIONS(3042),
    [anon_sym_u8_SQUOTE] = ACTIONS(3042),
    [anon_sym_SQUOTE] = ACTIONS(3042),
    [anon_sym_L_DQUOTE] = ACTIONS(3042),
    [anon_sym_u_DQUOTE] = ACTIONS(3042),
    [anon_sym_U_DQUOTE] = ACTIONS(3042),
    [anon_sym_u8_DQUOTE] = ACTIONS(3042),
    [anon_sym_DQUOTE] = ACTIONS(3042),
    [sym_true] = ACTIONS(3040),
    [sym_false] = ACTIONS(3040),
    [anon_sym_NULL] = ACTIONS(3040),
    [anon_sym_nullptr] = ACTIONS(3040),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3040),
    [anon_sym_decltype] = ACTIONS(3040),
    [anon_sym_virtual] = ACTIONS(3040),
    [anon_sym_alignas] = ACTIONS(3040),
    [anon_sym_explicit] = ACTIONS(3040),
    [anon_sym_typename] = ACTIONS(3040),
    [anon_sym_template] = ACTIONS(3040),
    [anon_sym_operator] = ACTIONS(3040),
    [anon_sym_try] = ACTIONS(3040),
    [anon_sym_delete] = ACTIONS(3040),
    [anon_sym_throw] = ACTIONS(3040),
    [anon_sym_namespace] = ACTIONS(3040),
    [anon_sym_using] = ACTIONS(3040),
    [anon_sym_static_assert] = ACTIONS(3040),
    [anon_sym_concept] = ACTIONS(3040),
    [anon_sym_co_return] = ACTIONS(3040),
    [anon_sym_co_yield] = ACTIONS(3040),
    [anon_sym_R_DQUOTE] = ACTIONS(3042),
    [anon_sym_LR_DQUOTE] = ACTIONS(3042),
    [anon_sym_uR_DQUOTE] = ACTIONS(3042),
    [anon_sym_UR_DQUOTE] = ACTIONS(3042),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3042),
    [anon_sym_co_await] = ACTIONS(3040),
    [anon_sym_new] = ACTIONS(3040),
    [anon_sym_requires] = ACTIONS(3040),
    [sym_this] = ACTIONS(3040),
  },
  [380] = {
    [sym_identifier] = ACTIONS(3044),
    [aux_sym_preproc_include_token1] = ACTIONS(3044),
    [aux_sym_preproc_def_token1] = ACTIONS(3044),
    [aux_sym_preproc_if_token1] = ACTIONS(3044),
    [aux_sym_preproc_if_token2] = ACTIONS(3044),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3044),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3044),
    [aux_sym_preproc_else_token1] = ACTIONS(3044),
    [aux_sym_preproc_elif_token1] = ACTIONS(3044),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3044),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3044),
    [sym_preproc_directive] = ACTIONS(3044),
    [anon_sym_LPAREN2] = ACTIONS(3046),
    [anon_sym_BANG] = ACTIONS(3046),
    [anon_sym_TILDE] = ACTIONS(3046),
    [anon_sym_DASH] = ACTIONS(3044),
    [anon_sym_PLUS] = ACTIONS(3044),
    [anon_sym_STAR] = ACTIONS(3046),
    [anon_sym_AMP_AMP] = ACTIONS(3046),
    [anon_sym_AMP] = ACTIONS(3044),
    [anon_sym_SEMI] = ACTIONS(3046),
    [anon_sym___extension__] = ACTIONS(3044),
    [anon_sym_typedef] = ACTIONS(3044),
    [anon_sym_extern] = ACTIONS(3044),
    [anon_sym___attribute__] = ACTIONS(3044),
    [anon_sym_COLON_COLON] = ACTIONS(3046),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3046),
    [anon_sym___declspec] = ACTIONS(3044),
    [anon_sym___based] = ACTIONS(3044),
    [anon_sym___cdecl] = ACTIONS(3044),
    [anon_sym___clrcall] = ACTIONS(3044),
    [anon_sym___stdcall] = ACTIONS(3044),
    [anon_sym___fastcall] = ACTIONS(3044),
    [anon_sym___thiscall] = ACTIONS(3044),
    [anon_sym___vectorcall] = ACTIONS(3044),
    [anon_sym_LBRACE] = ACTIONS(3046),
    [anon_sym_signed] = ACTIONS(3044),
    [anon_sym_unsigned] = ACTIONS(3044),
    [anon_sym_long] = ACTIONS(3044),
    [anon_sym_short] = ACTIONS(3044),
    [anon_sym_LBRACK] = ACTIONS(3044),
    [anon_sym_static] = ACTIONS(3044),
    [anon_sym_register] = ACTIONS(3044),
    [anon_sym_inline] = ACTIONS(3044),
    [anon_sym___inline] = ACTIONS(3044),
    [anon_sym___inline__] = ACTIONS(3044),
    [anon_sym___forceinline] = ACTIONS(3044),
    [anon_sym_thread_local] = ACTIONS(3044),
    [anon_sym___thread] = ACTIONS(3044),
    [anon_sym_const] = ACTIONS(3044),
    [anon_sym_constexpr] = ACTIONS(3044),
    [anon_sym_volatile] = ACTIONS(3044),
    [anon_sym_restrict] = ACTIONS(3044),
    [anon_sym___restrict__] = ACTIONS(3044),
    [anon_sym__Atomic] = ACTIONS(3044),
    [anon_sym__Noreturn] = ACTIONS(3044),
    [anon_sym_noreturn] = ACTIONS(3044),
    [anon_sym_mutable] = ACTIONS(3044),
    [anon_sym_constinit] = ACTIONS(3044),
    [anon_sym_consteval] = ACTIONS(3044),
    [anon_sym_PROGMEM] = ACTIONS(3044),
    [aux_sym_primitive_type_token1] = ACTIONS(3044),
    [anon_sym_byte] = ACTIONS(3044),
    [anon_sym_word] = ACTIONS(3044),
    [anon_sym_enum] = ACTIONS(3044),
    [anon_sym_class] = ACTIONS(3044),
    [anon_sym_struct] = ACTIONS(3044),
    [anon_sym_union] = ACTIONS(3044),
    [anon_sym_if] = ACTIONS(3044),
    [anon_sym_switch] = ACTIONS(3044),
    [anon_sym_case] = ACTIONS(3044),
    [anon_sym_default] = ACTIONS(3044),
    [anon_sym_while] = ACTIONS(3044),
    [anon_sym_do] = ACTIONS(3044),
    [anon_sym_for] = ACTIONS(3044),
    [anon_sym_return] = ACTIONS(3044),
    [anon_sym_break] = ACTIONS(3044),
    [anon_sym_continue] = ACTIONS(3044),
    [anon_sym_goto] = ACTIONS(3044),
    [anon_sym___try] = ACTIONS(3044),
    [anon_sym___leave] = ACTIONS(3044),
    [anon_sym_not] = ACTIONS(3044),
    [anon_sym_compl] = ACTIONS(3044),
    [anon_sym_DASH_DASH] = ACTIONS(3046),
    [anon_sym_PLUS_PLUS] = ACTIONS(3046),
    [anon_sym_sizeof] = ACTIONS(3044),
    [anon_sym___alignof__] = ACTIONS(3044),
    [anon_sym___alignof] = ACTIONS(3044),
    [anon_sym__alignof] = ACTIONS(3044),
    [anon_sym_alignof] = ACTIONS(3044),
    [anon_sym__Alignof] = ACTIONS(3044),
    [anon_sym_offsetof] = ACTIONS(3044),
    [anon_sym__Generic] = ACTIONS(3044),
    [anon_sym_asm] = ACTIONS(3044),
    [anon_sym___asm__] = ACTIONS(3044),
    [aux_sym_number_literal_token1] = ACTIONS(3046),
    [aux_sym_number_literal_token2] = ACTIONS(3044),
    [anon_sym_L_SQUOTE] = ACTIONS(3046),
    [anon_sym_u_SQUOTE] = ACTIONS(3046),
    [anon_sym_U_SQUOTE] = ACTIONS(3046),
    [anon_sym_u8_SQUOTE] = ACTIONS(3046),
    [anon_sym_SQUOTE] = ACTIONS(3046),
    [anon_sym_L_DQUOTE] = ACTIONS(3046),
    [anon_sym_u_DQUOTE] = ACTIONS(3046),
    [anon_sym_U_DQUOTE] = ACTIONS(3046),
    [anon_sym_u8_DQUOTE] = ACTIONS(3046),
    [anon_sym_DQUOTE] = ACTIONS(3046),
    [sym_true] = ACTIONS(3044),
    [sym_false] = ACTIONS(3044),
    [anon_sym_NULL] = ACTIONS(3044),
    [anon_sym_nullptr] = ACTIONS(3044),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3044),
    [anon_sym_decltype] = ACTIONS(3044),
    [anon_sym_virtual] = ACTIONS(3044),
    [anon_sym_alignas] = ACTIONS(3044),
    [anon_sym_explicit] = ACTIONS(3044),
    [anon_sym_typename] = ACTIONS(3044),
    [anon_sym_template] = ACTIONS(3044),
    [anon_sym_operator] = ACTIONS(3044),
    [anon_sym_try] = ACTIONS(3044),
    [anon_sym_delete] = ACTIONS(3044),
    [anon_sym_throw] = ACTIONS(3044),
    [anon_sym_namespace] = ACTIONS(3044),
    [anon_sym_using] = ACTIONS(3044),
    [anon_sym_static_assert] = ACTIONS(3044),
    [anon_sym_concept] = ACTIONS(3044),
    [anon_sym_co_return] = ACTIONS(3044),
    [anon_sym_co_yield] = ACTIONS(3044),
    [anon_sym_R_DQUOTE] = ACTIONS(3046),
    [anon_sym_LR_DQUOTE] = ACTIONS(3046),
    [anon_sym_uR_DQUOTE] = ACTIONS(3046),
    [anon_sym_UR_DQUOTE] = ACTIONS(3046),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3046),
    [anon_sym_co_await] = ACTIONS(3044),
    [anon_sym_new] = ACTIONS(3044),
    [anon_sym_requires] = ACTIONS(3044),
    [sym_this] = ACTIONS(3044),
  },
  [381] = {
    [sym_identifier] = ACTIONS(3048),
    [aux_sym_preproc_include_token1] = ACTIONS(3048),
    [aux_sym_preproc_def_token1] = ACTIONS(3048),
    [aux_sym_preproc_if_token1] = ACTIONS(3048),
    [aux_sym_preproc_if_token2] = ACTIONS(3048),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3048),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3048),
    [aux_sym_preproc_else_token1] = ACTIONS(3048),
    [aux_sym_preproc_elif_token1] = ACTIONS(3048),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3048),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3048),
    [sym_preproc_directive] = ACTIONS(3048),
    [anon_sym_LPAREN2] = ACTIONS(3050),
    [anon_sym_BANG] = ACTIONS(3050),
    [anon_sym_TILDE] = ACTIONS(3050),
    [anon_sym_DASH] = ACTIONS(3048),
    [anon_sym_PLUS] = ACTIONS(3048),
    [anon_sym_STAR] = ACTIONS(3050),
    [anon_sym_AMP_AMP] = ACTIONS(3050),
    [anon_sym_AMP] = ACTIONS(3048),
    [anon_sym_SEMI] = ACTIONS(3050),
    [anon_sym___extension__] = ACTIONS(3048),
    [anon_sym_typedef] = ACTIONS(3048),
    [anon_sym_extern] = ACTIONS(3048),
    [anon_sym___attribute__] = ACTIONS(3048),
    [anon_sym_COLON_COLON] = ACTIONS(3050),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3050),
    [anon_sym___declspec] = ACTIONS(3048),
    [anon_sym___based] = ACTIONS(3048),
    [anon_sym___cdecl] = ACTIONS(3048),
    [anon_sym___clrcall] = ACTIONS(3048),
    [anon_sym___stdcall] = ACTIONS(3048),
    [anon_sym___fastcall] = ACTIONS(3048),
    [anon_sym___thiscall] = ACTIONS(3048),
    [anon_sym___vectorcall] = ACTIONS(3048),
    [anon_sym_LBRACE] = ACTIONS(3050),
    [anon_sym_signed] = ACTIONS(3048),
    [anon_sym_unsigned] = ACTIONS(3048),
    [anon_sym_long] = ACTIONS(3048),
    [anon_sym_short] = ACTIONS(3048),
    [anon_sym_LBRACK] = ACTIONS(3048),
    [anon_sym_static] = ACTIONS(3048),
    [anon_sym_register] = ACTIONS(3048),
    [anon_sym_inline] = ACTIONS(3048),
    [anon_sym___inline] = ACTIONS(3048),
    [anon_sym___inline__] = ACTIONS(3048),
    [anon_sym___forceinline] = ACTIONS(3048),
    [anon_sym_thread_local] = ACTIONS(3048),
    [anon_sym___thread] = ACTIONS(3048),
    [anon_sym_const] = ACTIONS(3048),
    [anon_sym_constexpr] = ACTIONS(3048),
    [anon_sym_volatile] = ACTIONS(3048),
    [anon_sym_restrict] = ACTIONS(3048),
    [anon_sym___restrict__] = ACTIONS(3048),
    [anon_sym__Atomic] = ACTIONS(3048),
    [anon_sym__Noreturn] = ACTIONS(3048),
    [anon_sym_noreturn] = ACTIONS(3048),
    [anon_sym_mutable] = ACTIONS(3048),
    [anon_sym_constinit] = ACTIONS(3048),
    [anon_sym_consteval] = ACTIONS(3048),
    [anon_sym_PROGMEM] = ACTIONS(3048),
    [aux_sym_primitive_type_token1] = ACTIONS(3048),
    [anon_sym_byte] = ACTIONS(3048),
    [anon_sym_word] = ACTIONS(3048),
    [anon_sym_enum] = ACTIONS(3048),
    [anon_sym_class] = ACTIONS(3048),
    [anon_sym_struct] = ACTIONS(3048),
    [anon_sym_union] = ACTIONS(3048),
    [anon_sym_if] = ACTIONS(3048),
    [anon_sym_switch] = ACTIONS(3048),
    [anon_sym_case] = ACTIONS(3048),
    [anon_sym_default] = ACTIONS(3048),
    [anon_sym_while] = ACTIONS(3048),
    [anon_sym_do] = ACTIONS(3048),
    [anon_sym_for] = ACTIONS(3048),
    [anon_sym_return] = ACTIONS(3048),
    [anon_sym_break] = ACTIONS(3048),
    [anon_sym_continue] = ACTIONS(3048),
    [anon_sym_goto] = ACTIONS(3048),
    [anon_sym___try] = ACTIONS(3048),
    [anon_sym___leave] = ACTIONS(3048),
    [anon_sym_not] = ACTIONS(3048),
    [anon_sym_compl] = ACTIONS(3048),
    [anon_sym_DASH_DASH] = ACTIONS(3050),
    [anon_sym_PLUS_PLUS] = ACTIONS(3050),
    [anon_sym_sizeof] = ACTIONS(3048),
    [anon_sym___alignof__] = ACTIONS(3048),
    [anon_sym___alignof] = ACTIONS(3048),
    [anon_sym__alignof] = ACTIONS(3048),
    [anon_sym_alignof] = ACTIONS(3048),
    [anon_sym__Alignof] = ACTIONS(3048),
    [anon_sym_offsetof] = ACTIONS(3048),
    [anon_sym__Generic] = ACTIONS(3048),
    [anon_sym_asm] = ACTIONS(3048),
    [anon_sym___asm__] = ACTIONS(3048),
    [aux_sym_number_literal_token1] = ACTIONS(3050),
    [aux_sym_number_literal_token2] = ACTIONS(3048),
    [anon_sym_L_SQUOTE] = ACTIONS(3050),
    [anon_sym_u_SQUOTE] = ACTIONS(3050),
    [anon_sym_U_SQUOTE] = ACTIONS(3050),
    [anon_sym_u8_SQUOTE] = ACTIONS(3050),
    [anon_sym_SQUOTE] = ACTIONS(3050),
    [anon_sym_L_DQUOTE] = ACTIONS(3050),
    [anon_sym_u_DQUOTE] = ACTIONS(3050),
    [anon_sym_U_DQUOTE] = ACTIONS(3050),
    [anon_sym_u8_DQUOTE] = ACTIONS(3050),
    [anon_sym_DQUOTE] = ACTIONS(3050),
    [sym_true] = ACTIONS(3048),
    [sym_false] = ACTIONS(3048),
    [anon_sym_NULL] = ACTIONS(3048),
    [anon_sym_nullptr] = ACTIONS(3048),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3048),
    [anon_sym_decltype] = ACTIONS(3048),
    [anon_sym_virtual] = ACTIONS(3048),
    [anon_sym_alignas] = ACTIONS(3048),
    [anon_sym_explicit] = ACTIONS(3048),
    [anon_sym_typename] = ACTIONS(3048),
    [anon_sym_template] = ACTIONS(3048),
    [anon_sym_operator] = ACTIONS(3048),
    [anon_sym_try] = ACTIONS(3048),
    [anon_sym_delete] = ACTIONS(3048),
    [anon_sym_throw] = ACTIONS(3048),
    [anon_sym_namespace] = ACTIONS(3048),
    [anon_sym_using] = ACTIONS(3048),
    [anon_sym_static_assert] = ACTIONS(3048),
    [anon_sym_concept] = ACTIONS(3048),
    [anon_sym_co_return] = ACTIONS(3048),
    [anon_sym_co_yield] = ACTIONS(3048),
    [anon_sym_R_DQUOTE] = ACTIONS(3050),
    [anon_sym_LR_DQUOTE] = ACTIONS(3050),
    [anon_sym_uR_DQUOTE] = ACTIONS(3050),
    [anon_sym_UR_DQUOTE] = ACTIONS(3050),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3050),
    [anon_sym_co_await] = ACTIONS(3048),
    [anon_sym_new] = ACTIONS(3048),
    [anon_sym_requires] = ACTIONS(3048),
    [sym_this] = ACTIONS(3048),
  },
  [382] = {
    [sym_identifier] = ACTIONS(3052),
    [aux_sym_preproc_include_token1] = ACTIONS(3052),
    [aux_sym_preproc_def_token1] = ACTIONS(3052),
    [aux_sym_preproc_if_token1] = ACTIONS(3052),
    [aux_sym_preproc_if_token2] = ACTIONS(3052),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3052),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3052),
    [aux_sym_preproc_else_token1] = ACTIONS(3052),
    [aux_sym_preproc_elif_token1] = ACTIONS(3052),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3052),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3052),
    [sym_preproc_directive] = ACTIONS(3052),
    [anon_sym_LPAREN2] = ACTIONS(3054),
    [anon_sym_BANG] = ACTIONS(3054),
    [anon_sym_TILDE] = ACTIONS(3054),
    [anon_sym_DASH] = ACTIONS(3052),
    [anon_sym_PLUS] = ACTIONS(3052),
    [anon_sym_STAR] = ACTIONS(3054),
    [anon_sym_AMP_AMP] = ACTIONS(3054),
    [anon_sym_AMP] = ACTIONS(3052),
    [anon_sym_SEMI] = ACTIONS(3054),
    [anon_sym___extension__] = ACTIONS(3052),
    [anon_sym_typedef] = ACTIONS(3052),
    [anon_sym_extern] = ACTIONS(3052),
    [anon_sym___attribute__] = ACTIONS(3052),
    [anon_sym_COLON_COLON] = ACTIONS(3054),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3054),
    [anon_sym___declspec] = ACTIONS(3052),
    [anon_sym___based] = ACTIONS(3052),
    [anon_sym___cdecl] = ACTIONS(3052),
    [anon_sym___clrcall] = ACTIONS(3052),
    [anon_sym___stdcall] = ACTIONS(3052),
    [anon_sym___fastcall] = ACTIONS(3052),
    [anon_sym___thiscall] = ACTIONS(3052),
    [anon_sym___vectorcall] = ACTIONS(3052),
    [anon_sym_LBRACE] = ACTIONS(3054),
    [anon_sym_signed] = ACTIONS(3052),
    [anon_sym_unsigned] = ACTIONS(3052),
    [anon_sym_long] = ACTIONS(3052),
    [anon_sym_short] = ACTIONS(3052),
    [anon_sym_LBRACK] = ACTIONS(3052),
    [anon_sym_static] = ACTIONS(3052),
    [anon_sym_register] = ACTIONS(3052),
    [anon_sym_inline] = ACTIONS(3052),
    [anon_sym___inline] = ACTIONS(3052),
    [anon_sym___inline__] = ACTIONS(3052),
    [anon_sym___forceinline] = ACTIONS(3052),
    [anon_sym_thread_local] = ACTIONS(3052),
    [anon_sym___thread] = ACTIONS(3052),
    [anon_sym_const] = ACTIONS(3052),
    [anon_sym_constexpr] = ACTIONS(3052),
    [anon_sym_volatile] = ACTIONS(3052),
    [anon_sym_restrict] = ACTIONS(3052),
    [anon_sym___restrict__] = ACTIONS(3052),
    [anon_sym__Atomic] = ACTIONS(3052),
    [anon_sym__Noreturn] = ACTIONS(3052),
    [anon_sym_noreturn] = ACTIONS(3052),
    [anon_sym_mutable] = ACTIONS(3052),
    [anon_sym_constinit] = ACTIONS(3052),
    [anon_sym_consteval] = ACTIONS(3052),
    [anon_sym_PROGMEM] = ACTIONS(3052),
    [aux_sym_primitive_type_token1] = ACTIONS(3052),
    [anon_sym_byte] = ACTIONS(3052),
    [anon_sym_word] = ACTIONS(3052),
    [anon_sym_enum] = ACTIONS(3052),
    [anon_sym_class] = ACTIONS(3052),
    [anon_sym_struct] = ACTIONS(3052),
    [anon_sym_union] = ACTIONS(3052),
    [anon_sym_if] = ACTIONS(3052),
    [anon_sym_switch] = ACTIONS(3052),
    [anon_sym_case] = ACTIONS(3052),
    [anon_sym_default] = ACTIONS(3052),
    [anon_sym_while] = ACTIONS(3052),
    [anon_sym_do] = ACTIONS(3052),
    [anon_sym_for] = ACTIONS(3052),
    [anon_sym_return] = ACTIONS(3052),
    [anon_sym_break] = ACTIONS(3052),
    [anon_sym_continue] = ACTIONS(3052),
    [anon_sym_goto] = ACTIONS(3052),
    [anon_sym___try] = ACTIONS(3052),
    [anon_sym___leave] = ACTIONS(3052),
    [anon_sym_not] = ACTIONS(3052),
    [anon_sym_compl] = ACTIONS(3052),
    [anon_sym_DASH_DASH] = ACTIONS(3054),
    [anon_sym_PLUS_PLUS] = ACTIONS(3054),
    [anon_sym_sizeof] = ACTIONS(3052),
    [anon_sym___alignof__] = ACTIONS(3052),
    [anon_sym___alignof] = ACTIONS(3052),
    [anon_sym__alignof] = ACTIONS(3052),
    [anon_sym_alignof] = ACTIONS(3052),
    [anon_sym__Alignof] = ACTIONS(3052),
    [anon_sym_offsetof] = ACTIONS(3052),
    [anon_sym__Generic] = ACTIONS(3052),
    [anon_sym_asm] = ACTIONS(3052),
    [anon_sym___asm__] = ACTIONS(3052),
    [aux_sym_number_literal_token1] = ACTIONS(3054),
    [aux_sym_number_literal_token2] = ACTIONS(3052),
    [anon_sym_L_SQUOTE] = ACTIONS(3054),
    [anon_sym_u_SQUOTE] = ACTIONS(3054),
    [anon_sym_U_SQUOTE] = ACTIONS(3054),
    [anon_sym_u8_SQUOTE] = ACTIONS(3054),
    [anon_sym_SQUOTE] = ACTIONS(3054),
    [anon_sym_L_DQUOTE] = ACTIONS(3054),
    [anon_sym_u_DQUOTE] = ACTIONS(3054),
    [anon_sym_U_DQUOTE] = ACTIONS(3054),
    [anon_sym_u8_DQUOTE] = ACTIONS(3054),
    [anon_sym_DQUOTE] = ACTIONS(3054),
    [sym_true] = ACTIONS(3052),
    [sym_false] = ACTIONS(3052),
    [anon_sym_NULL] = ACTIONS(3052),
    [anon_sym_nullptr] = ACTIONS(3052),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3052),
    [anon_sym_decltype] = ACTIONS(3052),
    [anon_sym_virtual] = ACTIONS(3052),
    [anon_sym_alignas] = ACTIONS(3052),
    [anon_sym_explicit] = ACTIONS(3052),
    [anon_sym_typename] = ACTIONS(3052),
    [anon_sym_template] = ACTIONS(3052),
    [anon_sym_operator] = ACTIONS(3052),
    [anon_sym_try] = ACTIONS(3052),
    [anon_sym_delete] = ACTIONS(3052),
    [anon_sym_throw] = ACTIONS(3052),
    [anon_sym_namespace] = ACTIONS(3052),
    [anon_sym_using] = ACTIONS(3052),
    [anon_sym_static_assert] = ACTIONS(3052),
    [anon_sym_concept] = ACTIONS(3052),
    [anon_sym_co_return] = ACTIONS(3052),
    [anon_sym_co_yield] = ACTIONS(3052),
    [anon_sym_R_DQUOTE] = ACTIONS(3054),
    [anon_sym_LR_DQUOTE] = ACTIONS(3054),
    [anon_sym_uR_DQUOTE] = ACTIONS(3054),
    [anon_sym_UR_DQUOTE] = ACTIONS(3054),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3054),
    [anon_sym_co_await] = ACTIONS(3052),
    [anon_sym_new] = ACTIONS(3052),
    [anon_sym_requires] = ACTIONS(3052),
    [sym_this] = ACTIONS(3052),
  },
  [383] = {
    [sym_identifier] = ACTIONS(3056),
    [aux_sym_preproc_include_token1] = ACTIONS(3056),
    [aux_sym_preproc_def_token1] = ACTIONS(3056),
    [aux_sym_preproc_if_token1] = ACTIONS(3056),
    [aux_sym_preproc_if_token2] = ACTIONS(3056),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3056),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3056),
    [aux_sym_preproc_else_token1] = ACTIONS(3056),
    [aux_sym_preproc_elif_token1] = ACTIONS(3056),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3056),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3056),
    [sym_preproc_directive] = ACTIONS(3056),
    [anon_sym_LPAREN2] = ACTIONS(3058),
    [anon_sym_BANG] = ACTIONS(3058),
    [anon_sym_TILDE] = ACTIONS(3058),
    [anon_sym_DASH] = ACTIONS(3056),
    [anon_sym_PLUS] = ACTIONS(3056),
    [anon_sym_STAR] = ACTIONS(3058),
    [anon_sym_AMP_AMP] = ACTIONS(3058),
    [anon_sym_AMP] = ACTIONS(3056),
    [anon_sym_SEMI] = ACTIONS(3058),
    [anon_sym___extension__] = ACTIONS(3056),
    [anon_sym_typedef] = ACTIONS(3056),
    [anon_sym_extern] = ACTIONS(3056),
    [anon_sym___attribute__] = ACTIONS(3056),
    [anon_sym_COLON_COLON] = ACTIONS(3058),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3058),
    [anon_sym___declspec] = ACTIONS(3056),
    [anon_sym___based] = ACTIONS(3056),
    [anon_sym___cdecl] = ACTIONS(3056),
    [anon_sym___clrcall] = ACTIONS(3056),
    [anon_sym___stdcall] = ACTIONS(3056),
    [anon_sym___fastcall] = ACTIONS(3056),
    [anon_sym___thiscall] = ACTIONS(3056),
    [anon_sym___vectorcall] = ACTIONS(3056),
    [anon_sym_LBRACE] = ACTIONS(3058),
    [anon_sym_signed] = ACTIONS(3056),
    [anon_sym_unsigned] = ACTIONS(3056),
    [anon_sym_long] = ACTIONS(3056),
    [anon_sym_short] = ACTIONS(3056),
    [anon_sym_LBRACK] = ACTIONS(3056),
    [anon_sym_static] = ACTIONS(3056),
    [anon_sym_register] = ACTIONS(3056),
    [anon_sym_inline] = ACTIONS(3056),
    [anon_sym___inline] = ACTIONS(3056),
    [anon_sym___inline__] = ACTIONS(3056),
    [anon_sym___forceinline] = ACTIONS(3056),
    [anon_sym_thread_local] = ACTIONS(3056),
    [anon_sym___thread] = ACTIONS(3056),
    [anon_sym_const] = ACTIONS(3056),
    [anon_sym_constexpr] = ACTIONS(3056),
    [anon_sym_volatile] = ACTIONS(3056),
    [anon_sym_restrict] = ACTIONS(3056),
    [anon_sym___restrict__] = ACTIONS(3056),
    [anon_sym__Atomic] = ACTIONS(3056),
    [anon_sym__Noreturn] = ACTIONS(3056),
    [anon_sym_noreturn] = ACTIONS(3056),
    [anon_sym_mutable] = ACTIONS(3056),
    [anon_sym_constinit] = ACTIONS(3056),
    [anon_sym_consteval] = ACTIONS(3056),
    [anon_sym_PROGMEM] = ACTIONS(3056),
    [aux_sym_primitive_type_token1] = ACTIONS(3056),
    [anon_sym_byte] = ACTIONS(3056),
    [anon_sym_word] = ACTIONS(3056),
    [anon_sym_enum] = ACTIONS(3056),
    [anon_sym_class] = ACTIONS(3056),
    [anon_sym_struct] = ACTIONS(3056),
    [anon_sym_union] = ACTIONS(3056),
    [anon_sym_if] = ACTIONS(3056),
    [anon_sym_switch] = ACTIONS(3056),
    [anon_sym_case] = ACTIONS(3056),
    [anon_sym_default] = ACTIONS(3056),
    [anon_sym_while] = ACTIONS(3056),
    [anon_sym_do] = ACTIONS(3056),
    [anon_sym_for] = ACTIONS(3056),
    [anon_sym_return] = ACTIONS(3056),
    [anon_sym_break] = ACTIONS(3056),
    [anon_sym_continue] = ACTIONS(3056),
    [anon_sym_goto] = ACTIONS(3056),
    [anon_sym___try] = ACTIONS(3056),
    [anon_sym___leave] = ACTIONS(3056),
    [anon_sym_not] = ACTIONS(3056),
    [anon_sym_compl] = ACTIONS(3056),
    [anon_sym_DASH_DASH] = ACTIONS(3058),
    [anon_sym_PLUS_PLUS] = ACTIONS(3058),
    [anon_sym_sizeof] = ACTIONS(3056),
    [anon_sym___alignof__] = ACTIONS(3056),
    [anon_sym___alignof] = ACTIONS(3056),
    [anon_sym__alignof] = ACTIONS(3056),
    [anon_sym_alignof] = ACTIONS(3056),
    [anon_sym__Alignof] = ACTIONS(3056),
    [anon_sym_offsetof] = ACTIONS(3056),
    [anon_sym__Generic] = ACTIONS(3056),
    [anon_sym_asm] = ACTIONS(3056),
    [anon_sym___asm__] = ACTIONS(3056),
    [aux_sym_number_literal_token1] = ACTIONS(3058),
    [aux_sym_number_literal_token2] = ACTIONS(3056),
    [anon_sym_L_SQUOTE] = ACTIONS(3058),
    [anon_sym_u_SQUOTE] = ACTIONS(3058),
    [anon_sym_U_SQUOTE] = ACTIONS(3058),
    [anon_sym_u8_SQUOTE] = ACTIONS(3058),
    [anon_sym_SQUOTE] = ACTIONS(3058),
    [anon_sym_L_DQUOTE] = ACTIONS(3058),
    [anon_sym_u_DQUOTE] = ACTIONS(3058),
    [anon_sym_U_DQUOTE] = ACTIONS(3058),
    [anon_sym_u8_DQUOTE] = ACTIONS(3058),
    [anon_sym_DQUOTE] = ACTIONS(3058),
    [sym_true] = ACTIONS(3056),
    [sym_false] = ACTIONS(3056),
    [anon_sym_NULL] = ACTIONS(3056),
    [anon_sym_nullptr] = ACTIONS(3056),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3056),
    [anon_sym_decltype] = ACTIONS(3056),
    [anon_sym_virtual] = ACTIONS(3056),
    [anon_sym_alignas] = ACTIONS(3056),
    [anon_sym_explicit] = ACTIONS(3056),
    [anon_sym_typename] = ACTIONS(3056),
    [anon_sym_template] = ACTIONS(3056),
    [anon_sym_operator] = ACTIONS(3056),
    [anon_sym_try] = ACTIONS(3056),
    [anon_sym_delete] = ACTIONS(3056),
    [anon_sym_throw] = ACTIONS(3056),
    [anon_sym_namespace] = ACTIONS(3056),
    [anon_sym_using] = ACTIONS(3056),
    [anon_sym_static_assert] = ACTIONS(3056),
    [anon_sym_concept] = ACTIONS(3056),
    [anon_sym_co_return] = ACTIONS(3056),
    [anon_sym_co_yield] = ACTIONS(3056),
    [anon_sym_R_DQUOTE] = ACTIONS(3058),
    [anon_sym_LR_DQUOTE] = ACTIONS(3058),
    [anon_sym_uR_DQUOTE] = ACTIONS(3058),
    [anon_sym_UR_DQUOTE] = ACTIONS(3058),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3058),
    [anon_sym_co_await] = ACTIONS(3056),
    [anon_sym_new] = ACTIONS(3056),
    [anon_sym_requires] = ACTIONS(3056),
    [sym_this] = ACTIONS(3056),
  },
  [384] = {
    [sym_identifier] = ACTIONS(3060),
    [aux_sym_preproc_include_token1] = ACTIONS(3060),
    [aux_sym_preproc_def_token1] = ACTIONS(3060),
    [aux_sym_preproc_if_token1] = ACTIONS(3060),
    [aux_sym_preproc_if_token2] = ACTIONS(3060),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3060),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3060),
    [aux_sym_preproc_else_token1] = ACTIONS(3060),
    [aux_sym_preproc_elif_token1] = ACTIONS(3060),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3060),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3060),
    [sym_preproc_directive] = ACTIONS(3060),
    [anon_sym_LPAREN2] = ACTIONS(3062),
    [anon_sym_BANG] = ACTIONS(3062),
    [anon_sym_TILDE] = ACTIONS(3062),
    [anon_sym_DASH] = ACTIONS(3060),
    [anon_sym_PLUS] = ACTIONS(3060),
    [anon_sym_STAR] = ACTIONS(3062),
    [anon_sym_AMP_AMP] = ACTIONS(3062),
    [anon_sym_AMP] = ACTIONS(3060),
    [anon_sym_SEMI] = ACTIONS(3062),
    [anon_sym___extension__] = ACTIONS(3060),
    [anon_sym_typedef] = ACTIONS(3060),
    [anon_sym_extern] = ACTIONS(3060),
    [anon_sym___attribute__] = ACTIONS(3060),
    [anon_sym_COLON_COLON] = ACTIONS(3062),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3062),
    [anon_sym___declspec] = ACTIONS(3060),
    [anon_sym___based] = ACTIONS(3060),
    [anon_sym___cdecl] = ACTIONS(3060),
    [anon_sym___clrcall] = ACTIONS(3060),
    [anon_sym___stdcall] = ACTIONS(3060),
    [anon_sym___fastcall] = ACTIONS(3060),
    [anon_sym___thiscall] = ACTIONS(3060),
    [anon_sym___vectorcall] = ACTIONS(3060),
    [anon_sym_LBRACE] = ACTIONS(3062),
    [anon_sym_signed] = ACTIONS(3060),
    [anon_sym_unsigned] = ACTIONS(3060),
    [anon_sym_long] = ACTIONS(3060),
    [anon_sym_short] = ACTIONS(3060),
    [anon_sym_LBRACK] = ACTIONS(3060),
    [anon_sym_static] = ACTIONS(3060),
    [anon_sym_register] = ACTIONS(3060),
    [anon_sym_inline] = ACTIONS(3060),
    [anon_sym___inline] = ACTIONS(3060),
    [anon_sym___inline__] = ACTIONS(3060),
    [anon_sym___forceinline] = ACTIONS(3060),
    [anon_sym_thread_local] = ACTIONS(3060),
    [anon_sym___thread] = ACTIONS(3060),
    [anon_sym_const] = ACTIONS(3060),
    [anon_sym_constexpr] = ACTIONS(3060),
    [anon_sym_volatile] = ACTIONS(3060),
    [anon_sym_restrict] = ACTIONS(3060),
    [anon_sym___restrict__] = ACTIONS(3060),
    [anon_sym__Atomic] = ACTIONS(3060),
    [anon_sym__Noreturn] = ACTIONS(3060),
    [anon_sym_noreturn] = ACTIONS(3060),
    [anon_sym_mutable] = ACTIONS(3060),
    [anon_sym_constinit] = ACTIONS(3060),
    [anon_sym_consteval] = ACTIONS(3060),
    [anon_sym_PROGMEM] = ACTIONS(3060),
    [aux_sym_primitive_type_token1] = ACTIONS(3060),
    [anon_sym_byte] = ACTIONS(3060),
    [anon_sym_word] = ACTIONS(3060),
    [anon_sym_enum] = ACTIONS(3060),
    [anon_sym_class] = ACTIONS(3060),
    [anon_sym_struct] = ACTIONS(3060),
    [anon_sym_union] = ACTIONS(3060),
    [anon_sym_if] = ACTIONS(3060),
    [anon_sym_switch] = ACTIONS(3060),
    [anon_sym_case] = ACTIONS(3060),
    [anon_sym_default] = ACTIONS(3060),
    [anon_sym_while] = ACTIONS(3060),
    [anon_sym_do] = ACTIONS(3060),
    [anon_sym_for] = ACTIONS(3060),
    [anon_sym_return] = ACTIONS(3060),
    [anon_sym_break] = ACTIONS(3060),
    [anon_sym_continue] = ACTIONS(3060),
    [anon_sym_goto] = ACTIONS(3060),
    [anon_sym___try] = ACTIONS(3060),
    [anon_sym___leave] = ACTIONS(3060),
    [anon_sym_not] = ACTIONS(3060),
    [anon_sym_compl] = ACTIONS(3060),
    [anon_sym_DASH_DASH] = ACTIONS(3062),
    [anon_sym_PLUS_PLUS] = ACTIONS(3062),
    [anon_sym_sizeof] = ACTIONS(3060),
    [anon_sym___alignof__] = ACTIONS(3060),
    [anon_sym___alignof] = ACTIONS(3060),
    [anon_sym__alignof] = ACTIONS(3060),
    [anon_sym_alignof] = ACTIONS(3060),
    [anon_sym__Alignof] = ACTIONS(3060),
    [anon_sym_offsetof] = ACTIONS(3060),
    [anon_sym__Generic] = ACTIONS(3060),
    [anon_sym_asm] = ACTIONS(3060),
    [anon_sym___asm__] = ACTIONS(3060),
    [aux_sym_number_literal_token1] = ACTIONS(3062),
    [aux_sym_number_literal_token2] = ACTIONS(3060),
    [anon_sym_L_SQUOTE] = ACTIONS(3062),
    [anon_sym_u_SQUOTE] = ACTIONS(3062),
    [anon_sym_U_SQUOTE] = ACTIONS(3062),
    [anon_sym_u8_SQUOTE] = ACTIONS(3062),
    [anon_sym_SQUOTE] = ACTIONS(3062),
    [anon_sym_L_DQUOTE] = ACTIONS(3062),
    [anon_sym_u_DQUOTE] = ACTIONS(3062),
    [anon_sym_U_DQUOTE] = ACTIONS(3062),
    [anon_sym_u8_DQUOTE] = ACTIONS(3062),
    [anon_sym_DQUOTE] = ACTIONS(3062),
    [sym_true] = ACTIONS(3060),
    [sym_false] = ACTIONS(3060),
    [anon_sym_NULL] = ACTIONS(3060),
    [anon_sym_nullptr] = ACTIONS(3060),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3060),
    [anon_sym_decltype] = ACTIONS(3060),
    [anon_sym_virtual] = ACTIONS(3060),
    [anon_sym_alignas] = ACTIONS(3060),
    [anon_sym_explicit] = ACTIONS(3060),
    [anon_sym_typename] = ACTIONS(3060),
    [anon_sym_template] = ACTIONS(3060),
    [anon_sym_operator] = ACTIONS(3060),
    [anon_sym_try] = ACTIONS(3060),
    [anon_sym_delete] = ACTIONS(3060),
    [anon_sym_throw] = ACTIONS(3060),
    [anon_sym_namespace] = ACTIONS(3060),
    [anon_sym_using] = ACTIONS(3060),
    [anon_sym_static_assert] = ACTIONS(3060),
    [anon_sym_concept] = ACTIONS(3060),
    [anon_sym_co_return] = ACTIONS(3060),
    [anon_sym_co_yield] = ACTIONS(3060),
    [anon_sym_R_DQUOTE] = ACTIONS(3062),
    [anon_sym_LR_DQUOTE] = ACTIONS(3062),
    [anon_sym_uR_DQUOTE] = ACTIONS(3062),
    [anon_sym_UR_DQUOTE] = ACTIONS(3062),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3062),
    [anon_sym_co_await] = ACTIONS(3060),
    [anon_sym_new] = ACTIONS(3060),
    [anon_sym_requires] = ACTIONS(3060),
    [sym_this] = ACTIONS(3060),
  },
  [385] = {
    [sym_identifier] = ACTIONS(3064),
    [aux_sym_preproc_include_token1] = ACTIONS(3064),
    [aux_sym_preproc_def_token1] = ACTIONS(3064),
    [aux_sym_preproc_if_token1] = ACTIONS(3064),
    [aux_sym_preproc_if_token2] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3064),
    [aux_sym_preproc_else_token1] = ACTIONS(3064),
    [aux_sym_preproc_elif_token1] = ACTIONS(3064),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3064),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3064),
    [sym_preproc_directive] = ACTIONS(3064),
    [anon_sym_LPAREN2] = ACTIONS(3066),
    [anon_sym_BANG] = ACTIONS(3066),
    [anon_sym_TILDE] = ACTIONS(3066),
    [anon_sym_DASH] = ACTIONS(3064),
    [anon_sym_PLUS] = ACTIONS(3064),
    [anon_sym_STAR] = ACTIONS(3066),
    [anon_sym_AMP_AMP] = ACTIONS(3066),
    [anon_sym_AMP] = ACTIONS(3064),
    [anon_sym_SEMI] = ACTIONS(3066),
    [anon_sym___extension__] = ACTIONS(3064),
    [anon_sym_typedef] = ACTIONS(3064),
    [anon_sym_extern] = ACTIONS(3064),
    [anon_sym___attribute__] = ACTIONS(3064),
    [anon_sym_COLON_COLON] = ACTIONS(3066),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3066),
    [anon_sym___declspec] = ACTIONS(3064),
    [anon_sym___based] = ACTIONS(3064),
    [anon_sym___cdecl] = ACTIONS(3064),
    [anon_sym___clrcall] = ACTIONS(3064),
    [anon_sym___stdcall] = ACTIONS(3064),
    [anon_sym___fastcall] = ACTIONS(3064),
    [anon_sym___thiscall] = ACTIONS(3064),
    [anon_sym___vectorcall] = ACTIONS(3064),
    [anon_sym_LBRACE] = ACTIONS(3066),
    [anon_sym_signed] = ACTIONS(3064),
    [anon_sym_unsigned] = ACTIONS(3064),
    [anon_sym_long] = ACTIONS(3064),
    [anon_sym_short] = ACTIONS(3064),
    [anon_sym_LBRACK] = ACTIONS(3064),
    [anon_sym_static] = ACTIONS(3064),
    [anon_sym_register] = ACTIONS(3064),
    [anon_sym_inline] = ACTIONS(3064),
    [anon_sym___inline] = ACTIONS(3064),
    [anon_sym___inline__] = ACTIONS(3064),
    [anon_sym___forceinline] = ACTIONS(3064),
    [anon_sym_thread_local] = ACTIONS(3064),
    [anon_sym___thread] = ACTIONS(3064),
    [anon_sym_const] = ACTIONS(3064),
    [anon_sym_constexpr] = ACTIONS(3064),
    [anon_sym_volatile] = ACTIONS(3064),
    [anon_sym_restrict] = ACTIONS(3064),
    [anon_sym___restrict__] = ACTIONS(3064),
    [anon_sym__Atomic] = ACTIONS(3064),
    [anon_sym__Noreturn] = ACTIONS(3064),
    [anon_sym_noreturn] = ACTIONS(3064),
    [anon_sym_mutable] = ACTIONS(3064),
    [anon_sym_constinit] = ACTIONS(3064),
    [anon_sym_consteval] = ACTIONS(3064),
    [anon_sym_PROGMEM] = ACTIONS(3064),
    [aux_sym_primitive_type_token1] = ACTIONS(3064),
    [anon_sym_byte] = ACTIONS(3064),
    [anon_sym_word] = ACTIONS(3064),
    [anon_sym_enum] = ACTIONS(3064),
    [anon_sym_class] = ACTIONS(3064),
    [anon_sym_struct] = ACTIONS(3064),
    [anon_sym_union] = ACTIONS(3064),
    [anon_sym_if] = ACTIONS(3064),
    [anon_sym_switch] = ACTIONS(3064),
    [anon_sym_case] = ACTIONS(3064),
    [anon_sym_default] = ACTIONS(3064),
    [anon_sym_while] = ACTIONS(3064),
    [anon_sym_do] = ACTIONS(3064),
    [anon_sym_for] = ACTIONS(3064),
    [anon_sym_return] = ACTIONS(3064),
    [anon_sym_break] = ACTIONS(3064),
    [anon_sym_continue] = ACTIONS(3064),
    [anon_sym_goto] = ACTIONS(3064),
    [anon_sym___try] = ACTIONS(3064),
    [anon_sym___leave] = ACTIONS(3064),
    [anon_sym_not] = ACTIONS(3064),
    [anon_sym_compl] = ACTIONS(3064),
    [anon_sym_DASH_DASH] = ACTIONS(3066),
    [anon_sym_PLUS_PLUS] = ACTIONS(3066),
    [anon_sym_sizeof] = ACTIONS(3064),
    [anon_sym___alignof__] = ACTIONS(3064),
    [anon_sym___alignof] = ACTIONS(3064),
    [anon_sym__alignof] = ACTIONS(3064),
    [anon_sym_alignof] = ACTIONS(3064),
    [anon_sym__Alignof] = ACTIONS(3064),
    [anon_sym_offsetof] = ACTIONS(3064),
    [anon_sym__Generic] = ACTIONS(3064),
    [anon_sym_asm] = ACTIONS(3064),
    [anon_sym___asm__] = ACTIONS(3064),
    [aux_sym_number_literal_token1] = ACTIONS(3066),
    [aux_sym_number_literal_token2] = ACTIONS(3064),
    [anon_sym_L_SQUOTE] = ACTIONS(3066),
    [anon_sym_u_SQUOTE] = ACTIONS(3066),
    [anon_sym_U_SQUOTE] = ACTIONS(3066),
    [anon_sym_u8_SQUOTE] = ACTIONS(3066),
    [anon_sym_SQUOTE] = ACTIONS(3066),
    [anon_sym_L_DQUOTE] = ACTIONS(3066),
    [anon_sym_u_DQUOTE] = ACTIONS(3066),
    [anon_sym_U_DQUOTE] = ACTIONS(3066),
    [anon_sym_u8_DQUOTE] = ACTIONS(3066),
    [anon_sym_DQUOTE] = ACTIONS(3066),
    [sym_true] = ACTIONS(3064),
    [sym_false] = ACTIONS(3064),
    [anon_sym_NULL] = ACTIONS(3064),
    [anon_sym_nullptr] = ACTIONS(3064),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3064),
    [anon_sym_decltype] = ACTIONS(3064),
    [anon_sym_virtual] = ACTIONS(3064),
    [anon_sym_alignas] = ACTIONS(3064),
    [anon_sym_explicit] = ACTIONS(3064),
    [anon_sym_typename] = ACTIONS(3064),
    [anon_sym_template] = ACTIONS(3064),
    [anon_sym_operator] = ACTIONS(3064),
    [anon_sym_try] = ACTIONS(3064),
    [anon_sym_delete] = ACTIONS(3064),
    [anon_sym_throw] = ACTIONS(3064),
    [anon_sym_namespace] = ACTIONS(3064),
    [anon_sym_using] = ACTIONS(3064),
    [anon_sym_static_assert] = ACTIONS(3064),
    [anon_sym_concept] = ACTIONS(3064),
    [anon_sym_co_return] = ACTIONS(3064),
    [anon_sym_co_yield] = ACTIONS(3064),
    [anon_sym_R_DQUOTE] = ACTIONS(3066),
    [anon_sym_LR_DQUOTE] = ACTIONS(3066),
    [anon_sym_uR_DQUOTE] = ACTIONS(3066),
    [anon_sym_UR_DQUOTE] = ACTIONS(3066),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3066),
    [anon_sym_co_await] = ACTIONS(3064),
    [anon_sym_new] = ACTIONS(3064),
    [anon_sym_requires] = ACTIONS(3064),
    [sym_this] = ACTIONS(3064),
  },
  [386] = {
    [sym_identifier] = ACTIONS(3068),
    [aux_sym_preproc_include_token1] = ACTIONS(3068),
    [aux_sym_preproc_def_token1] = ACTIONS(3068),
    [aux_sym_preproc_if_token1] = ACTIONS(3068),
    [aux_sym_preproc_if_token2] = ACTIONS(3068),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3068),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3068),
    [aux_sym_preproc_else_token1] = ACTIONS(3068),
    [aux_sym_preproc_elif_token1] = ACTIONS(3068),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3068),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3068),
    [sym_preproc_directive] = ACTIONS(3068),
    [anon_sym_LPAREN2] = ACTIONS(3070),
    [anon_sym_BANG] = ACTIONS(3070),
    [anon_sym_TILDE] = ACTIONS(3070),
    [anon_sym_DASH] = ACTIONS(3068),
    [anon_sym_PLUS] = ACTIONS(3068),
    [anon_sym_STAR] = ACTIONS(3070),
    [anon_sym_AMP_AMP] = ACTIONS(3070),
    [anon_sym_AMP] = ACTIONS(3068),
    [anon_sym_SEMI] = ACTIONS(3070),
    [anon_sym___extension__] = ACTIONS(3068),
    [anon_sym_typedef] = ACTIONS(3068),
    [anon_sym_extern] = ACTIONS(3068),
    [anon_sym___attribute__] = ACTIONS(3068),
    [anon_sym_COLON_COLON] = ACTIONS(3070),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3070),
    [anon_sym___declspec] = ACTIONS(3068),
    [anon_sym___based] = ACTIONS(3068),
    [anon_sym___cdecl] = ACTIONS(3068),
    [anon_sym___clrcall] = ACTIONS(3068),
    [anon_sym___stdcall] = ACTIONS(3068),
    [anon_sym___fastcall] = ACTIONS(3068),
    [anon_sym___thiscall] = ACTIONS(3068),
    [anon_sym___vectorcall] = ACTIONS(3068),
    [anon_sym_LBRACE] = ACTIONS(3070),
    [anon_sym_signed] = ACTIONS(3068),
    [anon_sym_unsigned] = ACTIONS(3068),
    [anon_sym_long] = ACTIONS(3068),
    [anon_sym_short] = ACTIONS(3068),
    [anon_sym_LBRACK] = ACTIONS(3068),
    [anon_sym_static] = ACTIONS(3068),
    [anon_sym_register] = ACTIONS(3068),
    [anon_sym_inline] = ACTIONS(3068),
    [anon_sym___inline] = ACTIONS(3068),
    [anon_sym___inline__] = ACTIONS(3068),
    [anon_sym___forceinline] = ACTIONS(3068),
    [anon_sym_thread_local] = ACTIONS(3068),
    [anon_sym___thread] = ACTIONS(3068),
    [anon_sym_const] = ACTIONS(3068),
    [anon_sym_constexpr] = ACTIONS(3068),
    [anon_sym_volatile] = ACTIONS(3068),
    [anon_sym_restrict] = ACTIONS(3068),
    [anon_sym___restrict__] = ACTIONS(3068),
    [anon_sym__Atomic] = ACTIONS(3068),
    [anon_sym__Noreturn] = ACTIONS(3068),
    [anon_sym_noreturn] = ACTIONS(3068),
    [anon_sym_mutable] = ACTIONS(3068),
    [anon_sym_constinit] = ACTIONS(3068),
    [anon_sym_consteval] = ACTIONS(3068),
    [anon_sym_PROGMEM] = ACTIONS(3068),
    [aux_sym_primitive_type_token1] = ACTIONS(3068),
    [anon_sym_byte] = ACTIONS(3068),
    [anon_sym_word] = ACTIONS(3068),
    [anon_sym_enum] = ACTIONS(3068),
    [anon_sym_class] = ACTIONS(3068),
    [anon_sym_struct] = ACTIONS(3068),
    [anon_sym_union] = ACTIONS(3068),
    [anon_sym_if] = ACTIONS(3068),
    [anon_sym_switch] = ACTIONS(3068),
    [anon_sym_case] = ACTIONS(3068),
    [anon_sym_default] = ACTIONS(3068),
    [anon_sym_while] = ACTIONS(3068),
    [anon_sym_do] = ACTIONS(3068),
    [anon_sym_for] = ACTIONS(3068),
    [anon_sym_return] = ACTIONS(3068),
    [anon_sym_break] = ACTIONS(3068),
    [anon_sym_continue] = ACTIONS(3068),
    [anon_sym_goto] = ACTIONS(3068),
    [anon_sym___try] = ACTIONS(3068),
    [anon_sym___leave] = ACTIONS(3068),
    [anon_sym_not] = ACTIONS(3068),
    [anon_sym_compl] = ACTIONS(3068),
    [anon_sym_DASH_DASH] = ACTIONS(3070),
    [anon_sym_PLUS_PLUS] = ACTIONS(3070),
    [anon_sym_sizeof] = ACTIONS(3068),
    [anon_sym___alignof__] = ACTIONS(3068),
    [anon_sym___alignof] = ACTIONS(3068),
    [anon_sym__alignof] = ACTIONS(3068),
    [anon_sym_alignof] = ACTIONS(3068),
    [anon_sym__Alignof] = ACTIONS(3068),
    [anon_sym_offsetof] = ACTIONS(3068),
    [anon_sym__Generic] = ACTIONS(3068),
    [anon_sym_asm] = ACTIONS(3068),
    [anon_sym___asm__] = ACTIONS(3068),
    [aux_sym_number_literal_token1] = ACTIONS(3070),
    [aux_sym_number_literal_token2] = ACTIONS(3068),
    [anon_sym_L_SQUOTE] = ACTIONS(3070),
    [anon_sym_u_SQUOTE] = ACTIONS(3070),
    [anon_sym_U_SQUOTE] = ACTIONS(3070),
    [anon_sym_u8_SQUOTE] = ACTIONS(3070),
    [anon_sym_SQUOTE] = ACTIONS(3070),
    [anon_sym_L_DQUOTE] = ACTIONS(3070),
    [anon_sym_u_DQUOTE] = ACTIONS(3070),
    [anon_sym_U_DQUOTE] = ACTIONS(3070),
    [anon_sym_u8_DQUOTE] = ACTIONS(3070),
    [anon_sym_DQUOTE] = ACTIONS(3070),
    [sym_true] = ACTIONS(3068),
    [sym_false] = ACTIONS(3068),
    [anon_sym_NULL] = ACTIONS(3068),
    [anon_sym_nullptr] = ACTIONS(3068),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3068),
    [anon_sym_decltype] = ACTIONS(3068),
    [anon_sym_virtual] = ACTIONS(3068),
    [anon_sym_alignas] = ACTIONS(3068),
    [anon_sym_explicit] = ACTIONS(3068),
    [anon_sym_typename] = ACTIONS(3068),
    [anon_sym_template] = ACTIONS(3068),
    [anon_sym_operator] = ACTIONS(3068),
    [anon_sym_try] = ACTIONS(3068),
    [anon_sym_delete] = ACTIONS(3068),
    [anon_sym_throw] = ACTIONS(3068),
    [anon_sym_namespace] = ACTIONS(3068),
    [anon_sym_using] = ACTIONS(3068),
    [anon_sym_static_assert] = ACTIONS(3068),
    [anon_sym_concept] = ACTIONS(3068),
    [anon_sym_co_return] = ACTIONS(3068),
    [anon_sym_co_yield] = ACTIONS(3068),
    [anon_sym_R_DQUOTE] = ACTIONS(3070),
    [anon_sym_LR_DQUOTE] = ACTIONS(3070),
    [anon_sym_uR_DQUOTE] = ACTIONS(3070),
    [anon_sym_UR_DQUOTE] = ACTIONS(3070),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3070),
    [anon_sym_co_await] = ACTIONS(3068),
    [anon_sym_new] = ACTIONS(3068),
    [anon_sym_requires] = ACTIONS(3068),
    [sym_this] = ACTIONS(3068),
  },
  [387] = {
    [sym_identifier] = ACTIONS(3068),
    [aux_sym_preproc_include_token1] = ACTIONS(3068),
    [aux_sym_preproc_def_token1] = ACTIONS(3068),
    [aux_sym_preproc_if_token1] = ACTIONS(3068),
    [aux_sym_preproc_if_token2] = ACTIONS(3068),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3068),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3068),
    [aux_sym_preproc_else_token1] = ACTIONS(3068),
    [aux_sym_preproc_elif_token1] = ACTIONS(3068),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3068),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3068),
    [sym_preproc_directive] = ACTIONS(3068),
    [anon_sym_LPAREN2] = ACTIONS(3070),
    [anon_sym_BANG] = ACTIONS(3070),
    [anon_sym_TILDE] = ACTIONS(3070),
    [anon_sym_DASH] = ACTIONS(3068),
    [anon_sym_PLUS] = ACTIONS(3068),
    [anon_sym_STAR] = ACTIONS(3070),
    [anon_sym_AMP_AMP] = ACTIONS(3070),
    [anon_sym_AMP] = ACTIONS(3068),
    [anon_sym_SEMI] = ACTIONS(3070),
    [anon_sym___extension__] = ACTIONS(3068),
    [anon_sym_typedef] = ACTIONS(3068),
    [anon_sym_extern] = ACTIONS(3068),
    [anon_sym___attribute__] = ACTIONS(3068),
    [anon_sym_COLON_COLON] = ACTIONS(3070),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3070),
    [anon_sym___declspec] = ACTIONS(3068),
    [anon_sym___based] = ACTIONS(3068),
    [anon_sym___cdecl] = ACTIONS(3068),
    [anon_sym___clrcall] = ACTIONS(3068),
    [anon_sym___stdcall] = ACTIONS(3068),
    [anon_sym___fastcall] = ACTIONS(3068),
    [anon_sym___thiscall] = ACTIONS(3068),
    [anon_sym___vectorcall] = ACTIONS(3068),
    [anon_sym_LBRACE] = ACTIONS(3070),
    [anon_sym_signed] = ACTIONS(3068),
    [anon_sym_unsigned] = ACTIONS(3068),
    [anon_sym_long] = ACTIONS(3068),
    [anon_sym_short] = ACTIONS(3068),
    [anon_sym_LBRACK] = ACTIONS(3068),
    [anon_sym_static] = ACTIONS(3068),
    [anon_sym_register] = ACTIONS(3068),
    [anon_sym_inline] = ACTIONS(3068),
    [anon_sym___inline] = ACTIONS(3068),
    [anon_sym___inline__] = ACTIONS(3068),
    [anon_sym___forceinline] = ACTIONS(3068),
    [anon_sym_thread_local] = ACTIONS(3068),
    [anon_sym___thread] = ACTIONS(3068),
    [anon_sym_const] = ACTIONS(3068),
    [anon_sym_constexpr] = ACTIONS(3068),
    [anon_sym_volatile] = ACTIONS(3068),
    [anon_sym_restrict] = ACTIONS(3068),
    [anon_sym___restrict__] = ACTIONS(3068),
    [anon_sym__Atomic] = ACTIONS(3068),
    [anon_sym__Noreturn] = ACTIONS(3068),
    [anon_sym_noreturn] = ACTIONS(3068),
    [anon_sym_mutable] = ACTIONS(3068),
    [anon_sym_constinit] = ACTIONS(3068),
    [anon_sym_consteval] = ACTIONS(3068),
    [anon_sym_PROGMEM] = ACTIONS(3068),
    [aux_sym_primitive_type_token1] = ACTIONS(3068),
    [anon_sym_byte] = ACTIONS(3068),
    [anon_sym_word] = ACTIONS(3068),
    [anon_sym_enum] = ACTIONS(3068),
    [anon_sym_class] = ACTIONS(3068),
    [anon_sym_struct] = ACTIONS(3068),
    [anon_sym_union] = ACTIONS(3068),
    [anon_sym_if] = ACTIONS(3068),
    [anon_sym_switch] = ACTIONS(3068),
    [anon_sym_case] = ACTIONS(3068),
    [anon_sym_default] = ACTIONS(3068),
    [anon_sym_while] = ACTIONS(3068),
    [anon_sym_do] = ACTIONS(3068),
    [anon_sym_for] = ACTIONS(3068),
    [anon_sym_return] = ACTIONS(3068),
    [anon_sym_break] = ACTIONS(3068),
    [anon_sym_continue] = ACTIONS(3068),
    [anon_sym_goto] = ACTIONS(3068),
    [anon_sym___try] = ACTIONS(3068),
    [anon_sym___leave] = ACTIONS(3068),
    [anon_sym_not] = ACTIONS(3068),
    [anon_sym_compl] = ACTIONS(3068),
    [anon_sym_DASH_DASH] = ACTIONS(3070),
    [anon_sym_PLUS_PLUS] = ACTIONS(3070),
    [anon_sym_sizeof] = ACTIONS(3068),
    [anon_sym___alignof__] = ACTIONS(3068),
    [anon_sym___alignof] = ACTIONS(3068),
    [anon_sym__alignof] = ACTIONS(3068),
    [anon_sym_alignof] = ACTIONS(3068),
    [anon_sym__Alignof] = ACTIONS(3068),
    [anon_sym_offsetof] = ACTIONS(3068),
    [anon_sym__Generic] = ACTIONS(3068),
    [anon_sym_asm] = ACTIONS(3068),
    [anon_sym___asm__] = ACTIONS(3068),
    [aux_sym_number_literal_token1] = ACTIONS(3070),
    [aux_sym_number_literal_token2] = ACTIONS(3068),
    [anon_sym_L_SQUOTE] = ACTIONS(3070),
    [anon_sym_u_SQUOTE] = ACTIONS(3070),
    [anon_sym_U_SQUOTE] = ACTIONS(3070),
    [anon_sym_u8_SQUOTE] = ACTIONS(3070),
    [anon_sym_SQUOTE] = ACTIONS(3070),
    [anon_sym_L_DQUOTE] = ACTIONS(3070),
    [anon_sym_u_DQUOTE] = ACTIONS(3070),
    [anon_sym_U_DQUOTE] = ACTIONS(3070),
    [anon_sym_u8_DQUOTE] = ACTIONS(3070),
    [anon_sym_DQUOTE] = ACTIONS(3070),
    [sym_true] = ACTIONS(3068),
    [sym_false] = ACTIONS(3068),
    [anon_sym_NULL] = ACTIONS(3068),
    [anon_sym_nullptr] = ACTIONS(3068),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3068),
    [anon_sym_decltype] = ACTIONS(3068),
    [anon_sym_virtual] = ACTIONS(3068),
    [anon_sym_alignas] = ACTIONS(3068),
    [anon_sym_explicit] = ACTIONS(3068),
    [anon_sym_typename] = ACTIONS(3068),
    [anon_sym_template] = ACTIONS(3068),
    [anon_sym_operator] = ACTIONS(3068),
    [anon_sym_try] = ACTIONS(3068),
    [anon_sym_delete] = ACTIONS(3068),
    [anon_sym_throw] = ACTIONS(3068),
    [anon_sym_namespace] = ACTIONS(3068),
    [anon_sym_using] = ACTIONS(3068),
    [anon_sym_static_assert] = ACTIONS(3068),
    [anon_sym_concept] = ACTIONS(3068),
    [anon_sym_co_return] = ACTIONS(3068),
    [anon_sym_co_yield] = ACTIONS(3068),
    [anon_sym_R_DQUOTE] = ACTIONS(3070),
    [anon_sym_LR_DQUOTE] = ACTIONS(3070),
    [anon_sym_uR_DQUOTE] = ACTIONS(3070),
    [anon_sym_UR_DQUOTE] = ACTIONS(3070),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3070),
    [anon_sym_co_await] = ACTIONS(3068),
    [anon_sym_new] = ACTIONS(3068),
    [anon_sym_requires] = ACTIONS(3068),
    [sym_this] = ACTIONS(3068),
  },
  [388] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [aux_sym_preproc_else_token1] = ACTIONS(3072),
    [aux_sym_preproc_elif_token1] = ACTIONS(3072),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [389] = {
    [sym_preproc_def] = STATE(541),
    [sym_preproc_function_def] = STATE(541),
    [sym_preproc_call] = STATE(541),
    [sym_preproc_if_in_field_declaration_list] = STATE(541),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(541),
    [sym_preproc_else_in_field_declaration_list] = STATE(8333),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8333),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8333),
    [sym_type_definition] = STATE(541),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(5531),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(3150),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(5962),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym__field_declaration_list_item] = STATE(541),
    [sym_field_declaration] = STATE(541),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1838),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(541),
    [sym_operator_cast] = STATE(6510),
    [sym_inline_method_definition] = STATE(541),
    [sym__constructor_specifiers] = STATE(1838),
    [sym_operator_cast_definition] = STATE(541),
    [sym_operator_cast_declaration] = STATE(541),
    [sym_constructor_or_destructor_definition] = STATE(541),
    [sym_constructor_or_destructor_declaration] = STATE(541),
    [sym_friend_declaration] = STATE(541),
    [sym_access_specifier] = STATE(7787),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(2618),
    [sym_template_function] = STATE(6098),
    [sym_using_declaration] = STATE(541),
    [sym_alias_declaration] = STATE(541),
    [sym_static_assert_declaration] = STATE(541),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5301),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_qualified_operator_cast_identifier] = STATE(6510),
    [sym_operator_name] = STATE(6098),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(541),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1961),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1838),
    [sym_identifier] = ACTIONS(2823),
    [aux_sym_preproc_def_token1] = ACTIONS(2825),
    [aux_sym_preproc_if_token1] = ACTIONS(2827),
    [aux_sym_preproc_if_token2] = ACTIONS(3076),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2831),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2831),
    [aux_sym_preproc_else_token1] = ACTIONS(2833),
    [aux_sym_preproc_elif_token1] = ACTIONS(2835),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2837),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2837),
    [sym_preproc_directive] = ACTIONS(2839),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(2849),
    [anon_sym_typedef] = ACTIONS(2851),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(2853),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2857),
    [anon_sym_class] = ACTIONS(2859),
    [anon_sym_struct] = ACTIONS(2861),
    [anon_sym_union] = ACTIONS(2863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(2865),
    [anon_sym_template] = ACTIONS(2867),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(2869),
    [anon_sym_public] = ACTIONS(2871),
    [anon_sym_private] = ACTIONS(2871),
    [anon_sym_protected] = ACTIONS(2871),
    [anon_sym_using] = ACTIONS(2873),
    [anon_sym_static_assert] = ACTIONS(2875),
  },
  [390] = {
    [sym_identifier] = ACTIONS(3078),
    [aux_sym_preproc_include_token1] = ACTIONS(3078),
    [aux_sym_preproc_def_token1] = ACTIONS(3078),
    [aux_sym_preproc_if_token1] = ACTIONS(3078),
    [aux_sym_preproc_if_token2] = ACTIONS(3078),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3078),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3078),
    [aux_sym_preproc_else_token1] = ACTIONS(3078),
    [aux_sym_preproc_elif_token1] = ACTIONS(3078),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3078),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3078),
    [sym_preproc_directive] = ACTIONS(3078),
    [anon_sym_LPAREN2] = ACTIONS(3080),
    [anon_sym_BANG] = ACTIONS(3080),
    [anon_sym_TILDE] = ACTIONS(3080),
    [anon_sym_DASH] = ACTIONS(3078),
    [anon_sym_PLUS] = ACTIONS(3078),
    [anon_sym_STAR] = ACTIONS(3080),
    [anon_sym_AMP_AMP] = ACTIONS(3080),
    [anon_sym_AMP] = ACTIONS(3078),
    [anon_sym_SEMI] = ACTIONS(3080),
    [anon_sym___extension__] = ACTIONS(3078),
    [anon_sym_typedef] = ACTIONS(3078),
    [anon_sym_extern] = ACTIONS(3078),
    [anon_sym___attribute__] = ACTIONS(3078),
    [anon_sym_COLON_COLON] = ACTIONS(3080),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3080),
    [anon_sym___declspec] = ACTIONS(3078),
    [anon_sym___based] = ACTIONS(3078),
    [anon_sym___cdecl] = ACTIONS(3078),
    [anon_sym___clrcall] = ACTIONS(3078),
    [anon_sym___stdcall] = ACTIONS(3078),
    [anon_sym___fastcall] = ACTIONS(3078),
    [anon_sym___thiscall] = ACTIONS(3078),
    [anon_sym___vectorcall] = ACTIONS(3078),
    [anon_sym_LBRACE] = ACTIONS(3080),
    [anon_sym_signed] = ACTIONS(3078),
    [anon_sym_unsigned] = ACTIONS(3078),
    [anon_sym_long] = ACTIONS(3078),
    [anon_sym_short] = ACTIONS(3078),
    [anon_sym_LBRACK] = ACTIONS(3078),
    [anon_sym_static] = ACTIONS(3078),
    [anon_sym_register] = ACTIONS(3078),
    [anon_sym_inline] = ACTIONS(3078),
    [anon_sym___inline] = ACTIONS(3078),
    [anon_sym___inline__] = ACTIONS(3078),
    [anon_sym___forceinline] = ACTIONS(3078),
    [anon_sym_thread_local] = ACTIONS(3078),
    [anon_sym___thread] = ACTIONS(3078),
    [anon_sym_const] = ACTIONS(3078),
    [anon_sym_constexpr] = ACTIONS(3078),
    [anon_sym_volatile] = ACTIONS(3078),
    [anon_sym_restrict] = ACTIONS(3078),
    [anon_sym___restrict__] = ACTIONS(3078),
    [anon_sym__Atomic] = ACTIONS(3078),
    [anon_sym__Noreturn] = ACTIONS(3078),
    [anon_sym_noreturn] = ACTIONS(3078),
    [anon_sym_mutable] = ACTIONS(3078),
    [anon_sym_constinit] = ACTIONS(3078),
    [anon_sym_consteval] = ACTIONS(3078),
    [anon_sym_PROGMEM] = ACTIONS(3078),
    [aux_sym_primitive_type_token1] = ACTIONS(3078),
    [anon_sym_byte] = ACTIONS(3078),
    [anon_sym_word] = ACTIONS(3078),
    [anon_sym_enum] = ACTIONS(3078),
    [anon_sym_class] = ACTIONS(3078),
    [anon_sym_struct] = ACTIONS(3078),
    [anon_sym_union] = ACTIONS(3078),
    [anon_sym_if] = ACTIONS(3078),
    [anon_sym_switch] = ACTIONS(3078),
    [anon_sym_case] = ACTIONS(3078),
    [anon_sym_default] = ACTIONS(3078),
    [anon_sym_while] = ACTIONS(3078),
    [anon_sym_do] = ACTIONS(3078),
    [anon_sym_for] = ACTIONS(3078),
    [anon_sym_return] = ACTIONS(3078),
    [anon_sym_break] = ACTIONS(3078),
    [anon_sym_continue] = ACTIONS(3078),
    [anon_sym_goto] = ACTIONS(3078),
    [anon_sym___try] = ACTIONS(3078),
    [anon_sym___leave] = ACTIONS(3078),
    [anon_sym_not] = ACTIONS(3078),
    [anon_sym_compl] = ACTIONS(3078),
    [anon_sym_DASH_DASH] = ACTIONS(3080),
    [anon_sym_PLUS_PLUS] = ACTIONS(3080),
    [anon_sym_sizeof] = ACTIONS(3078),
    [anon_sym___alignof__] = ACTIONS(3078),
    [anon_sym___alignof] = ACTIONS(3078),
    [anon_sym__alignof] = ACTIONS(3078),
    [anon_sym_alignof] = ACTIONS(3078),
    [anon_sym__Alignof] = ACTIONS(3078),
    [anon_sym_offsetof] = ACTIONS(3078),
    [anon_sym__Generic] = ACTIONS(3078),
    [anon_sym_asm] = ACTIONS(3078),
    [anon_sym___asm__] = ACTIONS(3078),
    [aux_sym_number_literal_token1] = ACTIONS(3080),
    [aux_sym_number_literal_token2] = ACTIONS(3078),
    [anon_sym_L_SQUOTE] = ACTIONS(3080),
    [anon_sym_u_SQUOTE] = ACTIONS(3080),
    [anon_sym_U_SQUOTE] = ACTIONS(3080),
    [anon_sym_u8_SQUOTE] = ACTIONS(3080),
    [anon_sym_SQUOTE] = ACTIONS(3080),
    [anon_sym_L_DQUOTE] = ACTIONS(3080),
    [anon_sym_u_DQUOTE] = ACTIONS(3080),
    [anon_sym_U_DQUOTE] = ACTIONS(3080),
    [anon_sym_u8_DQUOTE] = ACTIONS(3080),
    [anon_sym_DQUOTE] = ACTIONS(3080),
    [sym_true] = ACTIONS(3078),
    [sym_false] = ACTIONS(3078),
    [anon_sym_NULL] = ACTIONS(3078),
    [anon_sym_nullptr] = ACTIONS(3078),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3078),
    [anon_sym_decltype] = ACTIONS(3078),
    [anon_sym_virtual] = ACTIONS(3078),
    [anon_sym_alignas] = ACTIONS(3078),
    [anon_sym_explicit] = ACTIONS(3078),
    [anon_sym_typename] = ACTIONS(3078),
    [anon_sym_template] = ACTIONS(3078),
    [anon_sym_operator] = ACTIONS(3078),
    [anon_sym_try] = ACTIONS(3078),
    [anon_sym_delete] = ACTIONS(3078),
    [anon_sym_throw] = ACTIONS(3078),
    [anon_sym_namespace] = ACTIONS(3078),
    [anon_sym_using] = ACTIONS(3078),
    [anon_sym_static_assert] = ACTIONS(3078),
    [anon_sym_concept] = ACTIONS(3078),
    [anon_sym_co_return] = ACTIONS(3078),
    [anon_sym_co_yield] = ACTIONS(3078),
    [anon_sym_R_DQUOTE] = ACTIONS(3080),
    [anon_sym_LR_DQUOTE] = ACTIONS(3080),
    [anon_sym_uR_DQUOTE] = ACTIONS(3080),
    [anon_sym_UR_DQUOTE] = ACTIONS(3080),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3080),
    [anon_sym_co_await] = ACTIONS(3078),
    [anon_sym_new] = ACTIONS(3078),
    [anon_sym_requires] = ACTIONS(3078),
    [sym_this] = ACTIONS(3078),
  },
  [391] = {
    [sym_identifier] = ACTIONS(3082),
    [aux_sym_preproc_include_token1] = ACTIONS(3082),
    [aux_sym_preproc_def_token1] = ACTIONS(3082),
    [aux_sym_preproc_if_token1] = ACTIONS(3082),
    [aux_sym_preproc_if_token2] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3082),
    [aux_sym_preproc_else_token1] = ACTIONS(3082),
    [aux_sym_preproc_elif_token1] = ACTIONS(3082),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3082),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3082),
    [sym_preproc_directive] = ACTIONS(3082),
    [anon_sym_LPAREN2] = ACTIONS(3084),
    [anon_sym_BANG] = ACTIONS(3084),
    [anon_sym_TILDE] = ACTIONS(3084),
    [anon_sym_DASH] = ACTIONS(3082),
    [anon_sym_PLUS] = ACTIONS(3082),
    [anon_sym_STAR] = ACTIONS(3084),
    [anon_sym_AMP_AMP] = ACTIONS(3084),
    [anon_sym_AMP] = ACTIONS(3082),
    [anon_sym_SEMI] = ACTIONS(3084),
    [anon_sym___extension__] = ACTIONS(3082),
    [anon_sym_typedef] = ACTIONS(3082),
    [anon_sym_extern] = ACTIONS(3082),
    [anon_sym___attribute__] = ACTIONS(3082),
    [anon_sym_COLON_COLON] = ACTIONS(3084),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3084),
    [anon_sym___declspec] = ACTIONS(3082),
    [anon_sym___based] = ACTIONS(3082),
    [anon_sym___cdecl] = ACTIONS(3082),
    [anon_sym___clrcall] = ACTIONS(3082),
    [anon_sym___stdcall] = ACTIONS(3082),
    [anon_sym___fastcall] = ACTIONS(3082),
    [anon_sym___thiscall] = ACTIONS(3082),
    [anon_sym___vectorcall] = ACTIONS(3082),
    [anon_sym_LBRACE] = ACTIONS(3084),
    [anon_sym_signed] = ACTIONS(3082),
    [anon_sym_unsigned] = ACTIONS(3082),
    [anon_sym_long] = ACTIONS(3082),
    [anon_sym_short] = ACTIONS(3082),
    [anon_sym_LBRACK] = ACTIONS(3082),
    [anon_sym_static] = ACTIONS(3082),
    [anon_sym_register] = ACTIONS(3082),
    [anon_sym_inline] = ACTIONS(3082),
    [anon_sym___inline] = ACTIONS(3082),
    [anon_sym___inline__] = ACTIONS(3082),
    [anon_sym___forceinline] = ACTIONS(3082),
    [anon_sym_thread_local] = ACTIONS(3082),
    [anon_sym___thread] = ACTIONS(3082),
    [anon_sym_const] = ACTIONS(3082),
    [anon_sym_constexpr] = ACTIONS(3082),
    [anon_sym_volatile] = ACTIONS(3082),
    [anon_sym_restrict] = ACTIONS(3082),
    [anon_sym___restrict__] = ACTIONS(3082),
    [anon_sym__Atomic] = ACTIONS(3082),
    [anon_sym__Noreturn] = ACTIONS(3082),
    [anon_sym_noreturn] = ACTIONS(3082),
    [anon_sym_mutable] = ACTIONS(3082),
    [anon_sym_constinit] = ACTIONS(3082),
    [anon_sym_consteval] = ACTIONS(3082),
    [anon_sym_PROGMEM] = ACTIONS(3082),
    [aux_sym_primitive_type_token1] = ACTIONS(3082),
    [anon_sym_byte] = ACTIONS(3082),
    [anon_sym_word] = ACTIONS(3082),
    [anon_sym_enum] = ACTIONS(3082),
    [anon_sym_class] = ACTIONS(3082),
    [anon_sym_struct] = ACTIONS(3082),
    [anon_sym_union] = ACTIONS(3082),
    [anon_sym_if] = ACTIONS(3082),
    [anon_sym_switch] = ACTIONS(3082),
    [anon_sym_case] = ACTIONS(3082),
    [anon_sym_default] = ACTIONS(3082),
    [anon_sym_while] = ACTIONS(3082),
    [anon_sym_do] = ACTIONS(3082),
    [anon_sym_for] = ACTIONS(3082),
    [anon_sym_return] = ACTIONS(3082),
    [anon_sym_break] = ACTIONS(3082),
    [anon_sym_continue] = ACTIONS(3082),
    [anon_sym_goto] = ACTIONS(3082),
    [anon_sym___try] = ACTIONS(3082),
    [anon_sym___leave] = ACTIONS(3082),
    [anon_sym_not] = ACTIONS(3082),
    [anon_sym_compl] = ACTIONS(3082),
    [anon_sym_DASH_DASH] = ACTIONS(3084),
    [anon_sym_PLUS_PLUS] = ACTIONS(3084),
    [anon_sym_sizeof] = ACTIONS(3082),
    [anon_sym___alignof__] = ACTIONS(3082),
    [anon_sym___alignof] = ACTIONS(3082),
    [anon_sym__alignof] = ACTIONS(3082),
    [anon_sym_alignof] = ACTIONS(3082),
    [anon_sym__Alignof] = ACTIONS(3082),
    [anon_sym_offsetof] = ACTIONS(3082),
    [anon_sym__Generic] = ACTIONS(3082),
    [anon_sym_asm] = ACTIONS(3082),
    [anon_sym___asm__] = ACTIONS(3082),
    [aux_sym_number_literal_token1] = ACTIONS(3084),
    [aux_sym_number_literal_token2] = ACTIONS(3082),
    [anon_sym_L_SQUOTE] = ACTIONS(3084),
    [anon_sym_u_SQUOTE] = ACTIONS(3084),
    [anon_sym_U_SQUOTE] = ACTIONS(3084),
    [anon_sym_u8_SQUOTE] = ACTIONS(3084),
    [anon_sym_SQUOTE] = ACTIONS(3084),
    [anon_sym_L_DQUOTE] = ACTIONS(3084),
    [anon_sym_u_DQUOTE] = ACTIONS(3084),
    [anon_sym_U_DQUOTE] = ACTIONS(3084),
    [anon_sym_u8_DQUOTE] = ACTIONS(3084),
    [anon_sym_DQUOTE] = ACTIONS(3084),
    [sym_true] = ACTIONS(3082),
    [sym_false] = ACTIONS(3082),
    [anon_sym_NULL] = ACTIONS(3082),
    [anon_sym_nullptr] = ACTIONS(3082),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3082),
    [anon_sym_decltype] = ACTIONS(3082),
    [anon_sym_virtual] = ACTIONS(3082),
    [anon_sym_alignas] = ACTIONS(3082),
    [anon_sym_explicit] = ACTIONS(3082),
    [anon_sym_typename] = ACTIONS(3082),
    [anon_sym_template] = ACTIONS(3082),
    [anon_sym_operator] = ACTIONS(3082),
    [anon_sym_try] = ACTIONS(3082),
    [anon_sym_delete] = ACTIONS(3082),
    [anon_sym_throw] = ACTIONS(3082),
    [anon_sym_namespace] = ACTIONS(3082),
    [anon_sym_using] = ACTIONS(3082),
    [anon_sym_static_assert] = ACTIONS(3082),
    [anon_sym_concept] = ACTIONS(3082),
    [anon_sym_co_return] = ACTIONS(3082),
    [anon_sym_co_yield] = ACTIONS(3082),
    [anon_sym_R_DQUOTE] = ACTIONS(3084),
    [anon_sym_LR_DQUOTE] = ACTIONS(3084),
    [anon_sym_uR_DQUOTE] = ACTIONS(3084),
    [anon_sym_UR_DQUOTE] = ACTIONS(3084),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3084),
    [anon_sym_co_await] = ACTIONS(3082),
    [anon_sym_new] = ACTIONS(3082),
    [anon_sym_requires] = ACTIONS(3082),
    [sym_this] = ACTIONS(3082),
  },
  [392] = {
    [sym_identifier] = ACTIONS(3086),
    [aux_sym_preproc_include_token1] = ACTIONS(3086),
    [aux_sym_preproc_def_token1] = ACTIONS(3086),
    [aux_sym_preproc_if_token1] = ACTIONS(3086),
    [aux_sym_preproc_if_token2] = ACTIONS(3086),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3086),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3086),
    [aux_sym_preproc_else_token1] = ACTIONS(3086),
    [aux_sym_preproc_elif_token1] = ACTIONS(3086),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3086),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3086),
    [sym_preproc_directive] = ACTIONS(3086),
    [anon_sym_LPAREN2] = ACTIONS(3088),
    [anon_sym_BANG] = ACTIONS(3088),
    [anon_sym_TILDE] = ACTIONS(3088),
    [anon_sym_DASH] = ACTIONS(3086),
    [anon_sym_PLUS] = ACTIONS(3086),
    [anon_sym_STAR] = ACTIONS(3088),
    [anon_sym_AMP_AMP] = ACTIONS(3088),
    [anon_sym_AMP] = ACTIONS(3086),
    [anon_sym_SEMI] = ACTIONS(3088),
    [anon_sym___extension__] = ACTIONS(3086),
    [anon_sym_typedef] = ACTIONS(3086),
    [anon_sym_extern] = ACTIONS(3086),
    [anon_sym___attribute__] = ACTIONS(3086),
    [anon_sym_COLON_COLON] = ACTIONS(3088),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3088),
    [anon_sym___declspec] = ACTIONS(3086),
    [anon_sym___based] = ACTIONS(3086),
    [anon_sym___cdecl] = ACTIONS(3086),
    [anon_sym___clrcall] = ACTIONS(3086),
    [anon_sym___stdcall] = ACTIONS(3086),
    [anon_sym___fastcall] = ACTIONS(3086),
    [anon_sym___thiscall] = ACTIONS(3086),
    [anon_sym___vectorcall] = ACTIONS(3086),
    [anon_sym_LBRACE] = ACTIONS(3088),
    [anon_sym_signed] = ACTIONS(3086),
    [anon_sym_unsigned] = ACTIONS(3086),
    [anon_sym_long] = ACTIONS(3086),
    [anon_sym_short] = ACTIONS(3086),
    [anon_sym_LBRACK] = ACTIONS(3086),
    [anon_sym_static] = ACTIONS(3086),
    [anon_sym_register] = ACTIONS(3086),
    [anon_sym_inline] = ACTIONS(3086),
    [anon_sym___inline] = ACTIONS(3086),
    [anon_sym___inline__] = ACTIONS(3086),
    [anon_sym___forceinline] = ACTIONS(3086),
    [anon_sym_thread_local] = ACTIONS(3086),
    [anon_sym___thread] = ACTIONS(3086),
    [anon_sym_const] = ACTIONS(3086),
    [anon_sym_constexpr] = ACTIONS(3086),
    [anon_sym_volatile] = ACTIONS(3086),
    [anon_sym_restrict] = ACTIONS(3086),
    [anon_sym___restrict__] = ACTIONS(3086),
    [anon_sym__Atomic] = ACTIONS(3086),
    [anon_sym__Noreturn] = ACTIONS(3086),
    [anon_sym_noreturn] = ACTIONS(3086),
    [anon_sym_mutable] = ACTIONS(3086),
    [anon_sym_constinit] = ACTIONS(3086),
    [anon_sym_consteval] = ACTIONS(3086),
    [anon_sym_PROGMEM] = ACTIONS(3086),
    [aux_sym_primitive_type_token1] = ACTIONS(3086),
    [anon_sym_byte] = ACTIONS(3086),
    [anon_sym_word] = ACTIONS(3086),
    [anon_sym_enum] = ACTIONS(3086),
    [anon_sym_class] = ACTIONS(3086),
    [anon_sym_struct] = ACTIONS(3086),
    [anon_sym_union] = ACTIONS(3086),
    [anon_sym_if] = ACTIONS(3086),
    [anon_sym_switch] = ACTIONS(3086),
    [anon_sym_case] = ACTIONS(3086),
    [anon_sym_default] = ACTIONS(3086),
    [anon_sym_while] = ACTIONS(3086),
    [anon_sym_do] = ACTIONS(3086),
    [anon_sym_for] = ACTIONS(3086),
    [anon_sym_return] = ACTIONS(3086),
    [anon_sym_break] = ACTIONS(3086),
    [anon_sym_continue] = ACTIONS(3086),
    [anon_sym_goto] = ACTIONS(3086),
    [anon_sym___try] = ACTIONS(3086),
    [anon_sym___leave] = ACTIONS(3086),
    [anon_sym_not] = ACTIONS(3086),
    [anon_sym_compl] = ACTIONS(3086),
    [anon_sym_DASH_DASH] = ACTIONS(3088),
    [anon_sym_PLUS_PLUS] = ACTIONS(3088),
    [anon_sym_sizeof] = ACTIONS(3086),
    [anon_sym___alignof__] = ACTIONS(3086),
    [anon_sym___alignof] = ACTIONS(3086),
    [anon_sym__alignof] = ACTIONS(3086),
    [anon_sym_alignof] = ACTIONS(3086),
    [anon_sym__Alignof] = ACTIONS(3086),
    [anon_sym_offsetof] = ACTIONS(3086),
    [anon_sym__Generic] = ACTIONS(3086),
    [anon_sym_asm] = ACTIONS(3086),
    [anon_sym___asm__] = ACTIONS(3086),
    [aux_sym_number_literal_token1] = ACTIONS(3088),
    [aux_sym_number_literal_token2] = ACTIONS(3086),
    [anon_sym_L_SQUOTE] = ACTIONS(3088),
    [anon_sym_u_SQUOTE] = ACTIONS(3088),
    [anon_sym_U_SQUOTE] = ACTIONS(3088),
    [anon_sym_u8_SQUOTE] = ACTIONS(3088),
    [anon_sym_SQUOTE] = ACTIONS(3088),
    [anon_sym_L_DQUOTE] = ACTIONS(3088),
    [anon_sym_u_DQUOTE] = ACTIONS(3088),
    [anon_sym_U_DQUOTE] = ACTIONS(3088),
    [anon_sym_u8_DQUOTE] = ACTIONS(3088),
    [anon_sym_DQUOTE] = ACTIONS(3088),
    [sym_true] = ACTIONS(3086),
    [sym_false] = ACTIONS(3086),
    [anon_sym_NULL] = ACTIONS(3086),
    [anon_sym_nullptr] = ACTIONS(3086),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3086),
    [anon_sym_decltype] = ACTIONS(3086),
    [anon_sym_virtual] = ACTIONS(3086),
    [anon_sym_alignas] = ACTIONS(3086),
    [anon_sym_explicit] = ACTIONS(3086),
    [anon_sym_typename] = ACTIONS(3086),
    [anon_sym_template] = ACTIONS(3086),
    [anon_sym_operator] = ACTIONS(3086),
    [anon_sym_try] = ACTIONS(3086),
    [anon_sym_delete] = ACTIONS(3086),
    [anon_sym_throw] = ACTIONS(3086),
    [anon_sym_namespace] = ACTIONS(3086),
    [anon_sym_using] = ACTIONS(3086),
    [anon_sym_static_assert] = ACTIONS(3086),
    [anon_sym_concept] = ACTIONS(3086),
    [anon_sym_co_return] = ACTIONS(3086),
    [anon_sym_co_yield] = ACTIONS(3086),
    [anon_sym_R_DQUOTE] = ACTIONS(3088),
    [anon_sym_LR_DQUOTE] = ACTIONS(3088),
    [anon_sym_uR_DQUOTE] = ACTIONS(3088),
    [anon_sym_UR_DQUOTE] = ACTIONS(3088),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3088),
    [anon_sym_co_await] = ACTIONS(3086),
    [anon_sym_new] = ACTIONS(3086),
    [anon_sym_requires] = ACTIONS(3086),
    [sym_this] = ACTIONS(3086),
  },
  [393] = {
    [sym_identifier] = ACTIONS(3090),
    [aux_sym_preproc_include_token1] = ACTIONS(3090),
    [aux_sym_preproc_def_token1] = ACTIONS(3090),
    [aux_sym_preproc_if_token1] = ACTIONS(3090),
    [aux_sym_preproc_if_token2] = ACTIONS(3090),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3090),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3090),
    [aux_sym_preproc_else_token1] = ACTIONS(3090),
    [aux_sym_preproc_elif_token1] = ACTIONS(3090),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3090),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3090),
    [sym_preproc_directive] = ACTIONS(3090),
    [anon_sym_LPAREN2] = ACTIONS(3092),
    [anon_sym_BANG] = ACTIONS(3092),
    [anon_sym_TILDE] = ACTIONS(3092),
    [anon_sym_DASH] = ACTIONS(3090),
    [anon_sym_PLUS] = ACTIONS(3090),
    [anon_sym_STAR] = ACTIONS(3092),
    [anon_sym_AMP_AMP] = ACTIONS(3092),
    [anon_sym_AMP] = ACTIONS(3090),
    [anon_sym_SEMI] = ACTIONS(3092),
    [anon_sym___extension__] = ACTIONS(3090),
    [anon_sym_typedef] = ACTIONS(3090),
    [anon_sym_extern] = ACTIONS(3090),
    [anon_sym___attribute__] = ACTIONS(3090),
    [anon_sym_COLON_COLON] = ACTIONS(3092),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3092),
    [anon_sym___declspec] = ACTIONS(3090),
    [anon_sym___based] = ACTIONS(3090),
    [anon_sym___cdecl] = ACTIONS(3090),
    [anon_sym___clrcall] = ACTIONS(3090),
    [anon_sym___stdcall] = ACTIONS(3090),
    [anon_sym___fastcall] = ACTIONS(3090),
    [anon_sym___thiscall] = ACTIONS(3090),
    [anon_sym___vectorcall] = ACTIONS(3090),
    [anon_sym_LBRACE] = ACTIONS(3092),
    [anon_sym_signed] = ACTIONS(3090),
    [anon_sym_unsigned] = ACTIONS(3090),
    [anon_sym_long] = ACTIONS(3090),
    [anon_sym_short] = ACTIONS(3090),
    [anon_sym_LBRACK] = ACTIONS(3090),
    [anon_sym_static] = ACTIONS(3090),
    [anon_sym_register] = ACTIONS(3090),
    [anon_sym_inline] = ACTIONS(3090),
    [anon_sym___inline] = ACTIONS(3090),
    [anon_sym___inline__] = ACTIONS(3090),
    [anon_sym___forceinline] = ACTIONS(3090),
    [anon_sym_thread_local] = ACTIONS(3090),
    [anon_sym___thread] = ACTIONS(3090),
    [anon_sym_const] = ACTIONS(3090),
    [anon_sym_constexpr] = ACTIONS(3090),
    [anon_sym_volatile] = ACTIONS(3090),
    [anon_sym_restrict] = ACTIONS(3090),
    [anon_sym___restrict__] = ACTIONS(3090),
    [anon_sym__Atomic] = ACTIONS(3090),
    [anon_sym__Noreturn] = ACTIONS(3090),
    [anon_sym_noreturn] = ACTIONS(3090),
    [anon_sym_mutable] = ACTIONS(3090),
    [anon_sym_constinit] = ACTIONS(3090),
    [anon_sym_consteval] = ACTIONS(3090),
    [anon_sym_PROGMEM] = ACTIONS(3090),
    [aux_sym_primitive_type_token1] = ACTIONS(3090),
    [anon_sym_byte] = ACTIONS(3090),
    [anon_sym_word] = ACTIONS(3090),
    [anon_sym_enum] = ACTIONS(3090),
    [anon_sym_class] = ACTIONS(3090),
    [anon_sym_struct] = ACTIONS(3090),
    [anon_sym_union] = ACTIONS(3090),
    [anon_sym_if] = ACTIONS(3090),
    [anon_sym_switch] = ACTIONS(3090),
    [anon_sym_case] = ACTIONS(3090),
    [anon_sym_default] = ACTIONS(3090),
    [anon_sym_while] = ACTIONS(3090),
    [anon_sym_do] = ACTIONS(3090),
    [anon_sym_for] = ACTIONS(3090),
    [anon_sym_return] = ACTIONS(3090),
    [anon_sym_break] = ACTIONS(3090),
    [anon_sym_continue] = ACTIONS(3090),
    [anon_sym_goto] = ACTIONS(3090),
    [anon_sym___try] = ACTIONS(3090),
    [anon_sym___leave] = ACTIONS(3090),
    [anon_sym_not] = ACTIONS(3090),
    [anon_sym_compl] = ACTIONS(3090),
    [anon_sym_DASH_DASH] = ACTIONS(3092),
    [anon_sym_PLUS_PLUS] = ACTIONS(3092),
    [anon_sym_sizeof] = ACTIONS(3090),
    [anon_sym___alignof__] = ACTIONS(3090),
    [anon_sym___alignof] = ACTIONS(3090),
    [anon_sym__alignof] = ACTIONS(3090),
    [anon_sym_alignof] = ACTIONS(3090),
    [anon_sym__Alignof] = ACTIONS(3090),
    [anon_sym_offsetof] = ACTIONS(3090),
    [anon_sym__Generic] = ACTIONS(3090),
    [anon_sym_asm] = ACTIONS(3090),
    [anon_sym___asm__] = ACTIONS(3090),
    [aux_sym_number_literal_token1] = ACTIONS(3092),
    [aux_sym_number_literal_token2] = ACTIONS(3090),
    [anon_sym_L_SQUOTE] = ACTIONS(3092),
    [anon_sym_u_SQUOTE] = ACTIONS(3092),
    [anon_sym_U_SQUOTE] = ACTIONS(3092),
    [anon_sym_u8_SQUOTE] = ACTIONS(3092),
    [anon_sym_SQUOTE] = ACTIONS(3092),
    [anon_sym_L_DQUOTE] = ACTIONS(3092),
    [anon_sym_u_DQUOTE] = ACTIONS(3092),
    [anon_sym_U_DQUOTE] = ACTIONS(3092),
    [anon_sym_u8_DQUOTE] = ACTIONS(3092),
    [anon_sym_DQUOTE] = ACTIONS(3092),
    [sym_true] = ACTIONS(3090),
    [sym_false] = ACTIONS(3090),
    [anon_sym_NULL] = ACTIONS(3090),
    [anon_sym_nullptr] = ACTIONS(3090),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3090),
    [anon_sym_decltype] = ACTIONS(3090),
    [anon_sym_virtual] = ACTIONS(3090),
    [anon_sym_alignas] = ACTIONS(3090),
    [anon_sym_explicit] = ACTIONS(3090),
    [anon_sym_typename] = ACTIONS(3090),
    [anon_sym_template] = ACTIONS(3090),
    [anon_sym_operator] = ACTIONS(3090),
    [anon_sym_try] = ACTIONS(3090),
    [anon_sym_delete] = ACTIONS(3090),
    [anon_sym_throw] = ACTIONS(3090),
    [anon_sym_namespace] = ACTIONS(3090),
    [anon_sym_using] = ACTIONS(3090),
    [anon_sym_static_assert] = ACTIONS(3090),
    [anon_sym_concept] = ACTIONS(3090),
    [anon_sym_co_return] = ACTIONS(3090),
    [anon_sym_co_yield] = ACTIONS(3090),
    [anon_sym_R_DQUOTE] = ACTIONS(3092),
    [anon_sym_LR_DQUOTE] = ACTIONS(3092),
    [anon_sym_uR_DQUOTE] = ACTIONS(3092),
    [anon_sym_UR_DQUOTE] = ACTIONS(3092),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3092),
    [anon_sym_co_await] = ACTIONS(3090),
    [anon_sym_new] = ACTIONS(3090),
    [anon_sym_requires] = ACTIONS(3090),
    [sym_this] = ACTIONS(3090),
  },
  [394] = {
    [sym_identifier] = ACTIONS(3094),
    [aux_sym_preproc_include_token1] = ACTIONS(3094),
    [aux_sym_preproc_def_token1] = ACTIONS(3094),
    [aux_sym_preproc_if_token1] = ACTIONS(3094),
    [aux_sym_preproc_if_token2] = ACTIONS(3094),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3094),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3094),
    [aux_sym_preproc_else_token1] = ACTIONS(3094),
    [aux_sym_preproc_elif_token1] = ACTIONS(3094),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3094),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3094),
    [sym_preproc_directive] = ACTIONS(3094),
    [anon_sym_LPAREN2] = ACTIONS(3096),
    [anon_sym_BANG] = ACTIONS(3096),
    [anon_sym_TILDE] = ACTIONS(3096),
    [anon_sym_DASH] = ACTIONS(3094),
    [anon_sym_PLUS] = ACTIONS(3094),
    [anon_sym_STAR] = ACTIONS(3096),
    [anon_sym_AMP_AMP] = ACTIONS(3096),
    [anon_sym_AMP] = ACTIONS(3094),
    [anon_sym_SEMI] = ACTIONS(3096),
    [anon_sym___extension__] = ACTIONS(3094),
    [anon_sym_typedef] = ACTIONS(3094),
    [anon_sym_extern] = ACTIONS(3094),
    [anon_sym___attribute__] = ACTIONS(3094),
    [anon_sym_COLON_COLON] = ACTIONS(3096),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3096),
    [anon_sym___declspec] = ACTIONS(3094),
    [anon_sym___based] = ACTIONS(3094),
    [anon_sym___cdecl] = ACTIONS(3094),
    [anon_sym___clrcall] = ACTIONS(3094),
    [anon_sym___stdcall] = ACTIONS(3094),
    [anon_sym___fastcall] = ACTIONS(3094),
    [anon_sym___thiscall] = ACTIONS(3094),
    [anon_sym___vectorcall] = ACTIONS(3094),
    [anon_sym_LBRACE] = ACTIONS(3096),
    [anon_sym_signed] = ACTIONS(3094),
    [anon_sym_unsigned] = ACTIONS(3094),
    [anon_sym_long] = ACTIONS(3094),
    [anon_sym_short] = ACTIONS(3094),
    [anon_sym_LBRACK] = ACTIONS(3094),
    [anon_sym_static] = ACTIONS(3094),
    [anon_sym_register] = ACTIONS(3094),
    [anon_sym_inline] = ACTIONS(3094),
    [anon_sym___inline] = ACTIONS(3094),
    [anon_sym___inline__] = ACTIONS(3094),
    [anon_sym___forceinline] = ACTIONS(3094),
    [anon_sym_thread_local] = ACTIONS(3094),
    [anon_sym___thread] = ACTIONS(3094),
    [anon_sym_const] = ACTIONS(3094),
    [anon_sym_constexpr] = ACTIONS(3094),
    [anon_sym_volatile] = ACTIONS(3094),
    [anon_sym_restrict] = ACTIONS(3094),
    [anon_sym___restrict__] = ACTIONS(3094),
    [anon_sym__Atomic] = ACTIONS(3094),
    [anon_sym__Noreturn] = ACTIONS(3094),
    [anon_sym_noreturn] = ACTIONS(3094),
    [anon_sym_mutable] = ACTIONS(3094),
    [anon_sym_constinit] = ACTIONS(3094),
    [anon_sym_consteval] = ACTIONS(3094),
    [anon_sym_PROGMEM] = ACTIONS(3094),
    [aux_sym_primitive_type_token1] = ACTIONS(3094),
    [anon_sym_byte] = ACTIONS(3094),
    [anon_sym_word] = ACTIONS(3094),
    [anon_sym_enum] = ACTIONS(3094),
    [anon_sym_class] = ACTIONS(3094),
    [anon_sym_struct] = ACTIONS(3094),
    [anon_sym_union] = ACTIONS(3094),
    [anon_sym_if] = ACTIONS(3094),
    [anon_sym_switch] = ACTIONS(3094),
    [anon_sym_case] = ACTIONS(3094),
    [anon_sym_default] = ACTIONS(3094),
    [anon_sym_while] = ACTIONS(3094),
    [anon_sym_do] = ACTIONS(3094),
    [anon_sym_for] = ACTIONS(3094),
    [anon_sym_return] = ACTIONS(3094),
    [anon_sym_break] = ACTIONS(3094),
    [anon_sym_continue] = ACTIONS(3094),
    [anon_sym_goto] = ACTIONS(3094),
    [anon_sym___try] = ACTIONS(3094),
    [anon_sym___leave] = ACTIONS(3094),
    [anon_sym_not] = ACTIONS(3094),
    [anon_sym_compl] = ACTIONS(3094),
    [anon_sym_DASH_DASH] = ACTIONS(3096),
    [anon_sym_PLUS_PLUS] = ACTIONS(3096),
    [anon_sym_sizeof] = ACTIONS(3094),
    [anon_sym___alignof__] = ACTIONS(3094),
    [anon_sym___alignof] = ACTIONS(3094),
    [anon_sym__alignof] = ACTIONS(3094),
    [anon_sym_alignof] = ACTIONS(3094),
    [anon_sym__Alignof] = ACTIONS(3094),
    [anon_sym_offsetof] = ACTIONS(3094),
    [anon_sym__Generic] = ACTIONS(3094),
    [anon_sym_asm] = ACTIONS(3094),
    [anon_sym___asm__] = ACTIONS(3094),
    [aux_sym_number_literal_token1] = ACTIONS(3096),
    [aux_sym_number_literal_token2] = ACTIONS(3094),
    [anon_sym_L_SQUOTE] = ACTIONS(3096),
    [anon_sym_u_SQUOTE] = ACTIONS(3096),
    [anon_sym_U_SQUOTE] = ACTIONS(3096),
    [anon_sym_u8_SQUOTE] = ACTIONS(3096),
    [anon_sym_SQUOTE] = ACTIONS(3096),
    [anon_sym_L_DQUOTE] = ACTIONS(3096),
    [anon_sym_u_DQUOTE] = ACTIONS(3096),
    [anon_sym_U_DQUOTE] = ACTIONS(3096),
    [anon_sym_u8_DQUOTE] = ACTIONS(3096),
    [anon_sym_DQUOTE] = ACTIONS(3096),
    [sym_true] = ACTIONS(3094),
    [sym_false] = ACTIONS(3094),
    [anon_sym_NULL] = ACTIONS(3094),
    [anon_sym_nullptr] = ACTIONS(3094),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3094),
    [anon_sym_decltype] = ACTIONS(3094),
    [anon_sym_virtual] = ACTIONS(3094),
    [anon_sym_alignas] = ACTIONS(3094),
    [anon_sym_explicit] = ACTIONS(3094),
    [anon_sym_typename] = ACTIONS(3094),
    [anon_sym_template] = ACTIONS(3094),
    [anon_sym_operator] = ACTIONS(3094),
    [anon_sym_try] = ACTIONS(3094),
    [anon_sym_delete] = ACTIONS(3094),
    [anon_sym_throw] = ACTIONS(3094),
    [anon_sym_namespace] = ACTIONS(3094),
    [anon_sym_using] = ACTIONS(3094),
    [anon_sym_static_assert] = ACTIONS(3094),
    [anon_sym_concept] = ACTIONS(3094),
    [anon_sym_co_return] = ACTIONS(3094),
    [anon_sym_co_yield] = ACTIONS(3094),
    [anon_sym_R_DQUOTE] = ACTIONS(3096),
    [anon_sym_LR_DQUOTE] = ACTIONS(3096),
    [anon_sym_uR_DQUOTE] = ACTIONS(3096),
    [anon_sym_UR_DQUOTE] = ACTIONS(3096),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3096),
    [anon_sym_co_await] = ACTIONS(3094),
    [anon_sym_new] = ACTIONS(3094),
    [anon_sym_requires] = ACTIONS(3094),
    [sym_this] = ACTIONS(3094),
  },
  [395] = {
    [sym_catch_clause] = STATE(395),
    [aux_sym_constructor_try_statement_repeat1] = STATE(395),
    [sym_identifier] = ACTIONS(2475),
    [aux_sym_preproc_include_token1] = ACTIONS(2475),
    [aux_sym_preproc_def_token1] = ACTIONS(2475),
    [aux_sym_preproc_if_token1] = ACTIONS(2475),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2475),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2475),
    [sym_preproc_directive] = ACTIONS(2475),
    [anon_sym_LPAREN2] = ACTIONS(2477),
    [anon_sym_BANG] = ACTIONS(2477),
    [anon_sym_TILDE] = ACTIONS(2477),
    [anon_sym_DASH] = ACTIONS(2475),
    [anon_sym_PLUS] = ACTIONS(2475),
    [anon_sym_STAR] = ACTIONS(2477),
    [anon_sym_AMP_AMP] = ACTIONS(2477),
    [anon_sym_AMP] = ACTIONS(2475),
    [anon_sym_SEMI] = ACTIONS(2477),
    [anon_sym___extension__] = ACTIONS(2475),
    [anon_sym_typedef] = ACTIONS(2475),
    [anon_sym_extern] = ACTIONS(2475),
    [anon_sym___attribute__] = ACTIONS(2475),
    [anon_sym_COLON_COLON] = ACTIONS(2477),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2477),
    [anon_sym___declspec] = ACTIONS(2475),
    [anon_sym___based] = ACTIONS(2475),
    [anon_sym___cdecl] = ACTIONS(2475),
    [anon_sym___clrcall] = ACTIONS(2475),
    [anon_sym___stdcall] = ACTIONS(2475),
    [anon_sym___fastcall] = ACTIONS(2475),
    [anon_sym___thiscall] = ACTIONS(2475),
    [anon_sym___vectorcall] = ACTIONS(2475),
    [anon_sym_LBRACE] = ACTIONS(2477),
    [anon_sym_RBRACE] = ACTIONS(2477),
    [anon_sym_signed] = ACTIONS(2475),
    [anon_sym_unsigned] = ACTIONS(2475),
    [anon_sym_long] = ACTIONS(2475),
    [anon_sym_short] = ACTIONS(2475),
    [anon_sym_LBRACK] = ACTIONS(2475),
    [anon_sym_static] = ACTIONS(2475),
    [anon_sym_register] = ACTIONS(2475),
    [anon_sym_inline] = ACTIONS(2475),
    [anon_sym___inline] = ACTIONS(2475),
    [anon_sym___inline__] = ACTIONS(2475),
    [anon_sym___forceinline] = ACTIONS(2475),
    [anon_sym_thread_local] = ACTIONS(2475),
    [anon_sym___thread] = ACTIONS(2475),
    [anon_sym_const] = ACTIONS(2475),
    [anon_sym_constexpr] = ACTIONS(2475),
    [anon_sym_volatile] = ACTIONS(2475),
    [anon_sym_restrict] = ACTIONS(2475),
    [anon_sym___restrict__] = ACTIONS(2475),
    [anon_sym__Atomic] = ACTIONS(2475),
    [anon_sym__Noreturn] = ACTIONS(2475),
    [anon_sym_noreturn] = ACTIONS(2475),
    [anon_sym_mutable] = ACTIONS(2475),
    [anon_sym_constinit] = ACTIONS(2475),
    [anon_sym_consteval] = ACTIONS(2475),
    [anon_sym_PROGMEM] = ACTIONS(2475),
    [aux_sym_primitive_type_token1] = ACTIONS(2475),
    [anon_sym_byte] = ACTIONS(2475),
    [anon_sym_word] = ACTIONS(2475),
    [anon_sym_enum] = ACTIONS(2475),
    [anon_sym_class] = ACTIONS(2475),
    [anon_sym_struct] = ACTIONS(2475),
    [anon_sym_union] = ACTIONS(2475),
    [anon_sym_if] = ACTIONS(2475),
    [anon_sym_else] = ACTIONS(2475),
    [anon_sym_switch] = ACTIONS(2475),
    [anon_sym_case] = ACTIONS(2475),
    [anon_sym_default] = ACTIONS(2475),
    [anon_sym_while] = ACTIONS(2475),
    [anon_sym_do] = ACTIONS(2475),
    [anon_sym_for] = ACTIONS(2475),
    [anon_sym_return] = ACTIONS(2475),
    [anon_sym_break] = ACTIONS(2475),
    [anon_sym_continue] = ACTIONS(2475),
    [anon_sym_goto] = ACTIONS(2475),
    [anon_sym___try] = ACTIONS(2475),
    [anon_sym___leave] = ACTIONS(2475),
    [anon_sym_not] = ACTIONS(2475),
    [anon_sym_compl] = ACTIONS(2475),
    [anon_sym_DASH_DASH] = ACTIONS(2477),
    [anon_sym_PLUS_PLUS] = ACTIONS(2477),
    [anon_sym_sizeof] = ACTIONS(2475),
    [anon_sym___alignof__] = ACTIONS(2475),
    [anon_sym___alignof] = ACTIONS(2475),
    [anon_sym__alignof] = ACTIONS(2475),
    [anon_sym_alignof] = ACTIONS(2475),
    [anon_sym__Alignof] = ACTIONS(2475),
    [anon_sym_offsetof] = ACTIONS(2475),
    [anon_sym__Generic] = ACTIONS(2475),
    [anon_sym_asm] = ACTIONS(2475),
    [anon_sym___asm__] = ACTIONS(2475),
    [aux_sym_number_literal_token1] = ACTIONS(2477),
    [aux_sym_number_literal_token2] = ACTIONS(2475),
    [anon_sym_L_SQUOTE] = ACTIONS(2477),
    [anon_sym_u_SQUOTE] = ACTIONS(2477),
    [anon_sym_U_SQUOTE] = ACTIONS(2477),
    [anon_sym_u8_SQUOTE] = ACTIONS(2477),
    [anon_sym_SQUOTE] = ACTIONS(2477),
    [anon_sym_L_DQUOTE] = ACTIONS(2477),
    [anon_sym_u_DQUOTE] = ACTIONS(2477),
    [anon_sym_U_DQUOTE] = ACTIONS(2477),
    [anon_sym_u8_DQUOTE] = ACTIONS(2477),
    [anon_sym_DQUOTE] = ACTIONS(2477),
    [sym_true] = ACTIONS(2475),
    [sym_false] = ACTIONS(2475),
    [anon_sym_NULL] = ACTIONS(2475),
    [anon_sym_nullptr] = ACTIONS(2475),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2475),
    [anon_sym_decltype] = ACTIONS(2475),
    [anon_sym_virtual] = ACTIONS(2475),
    [anon_sym_alignas] = ACTIONS(2475),
    [anon_sym_explicit] = ACTIONS(2475),
    [anon_sym_typename] = ACTIONS(2475),
    [anon_sym_template] = ACTIONS(2475),
    [anon_sym_operator] = ACTIONS(2475),
    [anon_sym_try] = ACTIONS(2475),
    [anon_sym_delete] = ACTIONS(2475),
    [anon_sym_throw] = ACTIONS(2475),
    [anon_sym_namespace] = ACTIONS(2475),
    [anon_sym_using] = ACTIONS(2475),
    [anon_sym_static_assert] = ACTIONS(2475),
    [anon_sym_concept] = ACTIONS(2475),
    [anon_sym_co_return] = ACTIONS(2475),
    [anon_sym_co_yield] = ACTIONS(2475),
    [anon_sym_catch] = ACTIONS(3098),
    [anon_sym_R_DQUOTE] = ACTIONS(2477),
    [anon_sym_LR_DQUOTE] = ACTIONS(2477),
    [anon_sym_uR_DQUOTE] = ACTIONS(2477),
    [anon_sym_UR_DQUOTE] = ACTIONS(2477),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2477),
    [anon_sym_co_await] = ACTIONS(2475),
    [anon_sym_new] = ACTIONS(2475),
    [anon_sym_requires] = ACTIONS(2475),
    [sym_this] = ACTIONS(2475),
  },
  [396] = {
    [sym_identifier] = ACTIONS(3101),
    [aux_sym_preproc_include_token1] = ACTIONS(3101),
    [aux_sym_preproc_def_token1] = ACTIONS(3101),
    [aux_sym_preproc_if_token1] = ACTIONS(3101),
    [aux_sym_preproc_if_token2] = ACTIONS(3101),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3101),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3101),
    [aux_sym_preproc_else_token1] = ACTIONS(3101),
    [aux_sym_preproc_elif_token1] = ACTIONS(3101),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3101),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3101),
    [sym_preproc_directive] = ACTIONS(3101),
    [anon_sym_LPAREN2] = ACTIONS(3103),
    [anon_sym_BANG] = ACTIONS(3103),
    [anon_sym_TILDE] = ACTIONS(3103),
    [anon_sym_DASH] = ACTIONS(3101),
    [anon_sym_PLUS] = ACTIONS(3101),
    [anon_sym_STAR] = ACTIONS(3103),
    [anon_sym_AMP_AMP] = ACTIONS(3103),
    [anon_sym_AMP] = ACTIONS(3101),
    [anon_sym_SEMI] = ACTIONS(3103),
    [anon_sym___extension__] = ACTIONS(3101),
    [anon_sym_typedef] = ACTIONS(3101),
    [anon_sym_extern] = ACTIONS(3101),
    [anon_sym___attribute__] = ACTIONS(3101),
    [anon_sym_COLON_COLON] = ACTIONS(3103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3103),
    [anon_sym___declspec] = ACTIONS(3101),
    [anon_sym___based] = ACTIONS(3101),
    [anon_sym___cdecl] = ACTIONS(3101),
    [anon_sym___clrcall] = ACTIONS(3101),
    [anon_sym___stdcall] = ACTIONS(3101),
    [anon_sym___fastcall] = ACTIONS(3101),
    [anon_sym___thiscall] = ACTIONS(3101),
    [anon_sym___vectorcall] = ACTIONS(3101),
    [anon_sym_LBRACE] = ACTIONS(3103),
    [anon_sym_signed] = ACTIONS(3101),
    [anon_sym_unsigned] = ACTIONS(3101),
    [anon_sym_long] = ACTIONS(3101),
    [anon_sym_short] = ACTIONS(3101),
    [anon_sym_LBRACK] = ACTIONS(3101),
    [anon_sym_static] = ACTIONS(3101),
    [anon_sym_register] = ACTIONS(3101),
    [anon_sym_inline] = ACTIONS(3101),
    [anon_sym___inline] = ACTIONS(3101),
    [anon_sym___inline__] = ACTIONS(3101),
    [anon_sym___forceinline] = ACTIONS(3101),
    [anon_sym_thread_local] = ACTIONS(3101),
    [anon_sym___thread] = ACTIONS(3101),
    [anon_sym_const] = ACTIONS(3101),
    [anon_sym_constexpr] = ACTIONS(3101),
    [anon_sym_volatile] = ACTIONS(3101),
    [anon_sym_restrict] = ACTIONS(3101),
    [anon_sym___restrict__] = ACTIONS(3101),
    [anon_sym__Atomic] = ACTIONS(3101),
    [anon_sym__Noreturn] = ACTIONS(3101),
    [anon_sym_noreturn] = ACTIONS(3101),
    [anon_sym_mutable] = ACTIONS(3101),
    [anon_sym_constinit] = ACTIONS(3101),
    [anon_sym_consteval] = ACTIONS(3101),
    [anon_sym_PROGMEM] = ACTIONS(3101),
    [aux_sym_primitive_type_token1] = ACTIONS(3101),
    [anon_sym_byte] = ACTIONS(3101),
    [anon_sym_word] = ACTIONS(3101),
    [anon_sym_enum] = ACTIONS(3101),
    [anon_sym_class] = ACTIONS(3101),
    [anon_sym_struct] = ACTIONS(3101),
    [anon_sym_union] = ACTIONS(3101),
    [anon_sym_if] = ACTIONS(3101),
    [anon_sym_switch] = ACTIONS(3101),
    [anon_sym_case] = ACTIONS(3101),
    [anon_sym_default] = ACTIONS(3101),
    [anon_sym_while] = ACTIONS(3101),
    [anon_sym_do] = ACTIONS(3101),
    [anon_sym_for] = ACTIONS(3101),
    [anon_sym_return] = ACTIONS(3101),
    [anon_sym_break] = ACTIONS(3101),
    [anon_sym_continue] = ACTIONS(3101),
    [anon_sym_goto] = ACTIONS(3101),
    [anon_sym___try] = ACTIONS(3101),
    [anon_sym___leave] = ACTIONS(3101),
    [anon_sym_not] = ACTIONS(3101),
    [anon_sym_compl] = ACTIONS(3101),
    [anon_sym_DASH_DASH] = ACTIONS(3103),
    [anon_sym_PLUS_PLUS] = ACTIONS(3103),
    [anon_sym_sizeof] = ACTIONS(3101),
    [anon_sym___alignof__] = ACTIONS(3101),
    [anon_sym___alignof] = ACTIONS(3101),
    [anon_sym__alignof] = ACTIONS(3101),
    [anon_sym_alignof] = ACTIONS(3101),
    [anon_sym__Alignof] = ACTIONS(3101),
    [anon_sym_offsetof] = ACTIONS(3101),
    [anon_sym__Generic] = ACTIONS(3101),
    [anon_sym_asm] = ACTIONS(3101),
    [anon_sym___asm__] = ACTIONS(3101),
    [aux_sym_number_literal_token1] = ACTIONS(3103),
    [aux_sym_number_literal_token2] = ACTIONS(3101),
    [anon_sym_L_SQUOTE] = ACTIONS(3103),
    [anon_sym_u_SQUOTE] = ACTIONS(3103),
    [anon_sym_U_SQUOTE] = ACTIONS(3103),
    [anon_sym_u8_SQUOTE] = ACTIONS(3103),
    [anon_sym_SQUOTE] = ACTIONS(3103),
    [anon_sym_L_DQUOTE] = ACTIONS(3103),
    [anon_sym_u_DQUOTE] = ACTIONS(3103),
    [anon_sym_U_DQUOTE] = ACTIONS(3103),
    [anon_sym_u8_DQUOTE] = ACTIONS(3103),
    [anon_sym_DQUOTE] = ACTIONS(3103),
    [sym_true] = ACTIONS(3101),
    [sym_false] = ACTIONS(3101),
    [anon_sym_NULL] = ACTIONS(3101),
    [anon_sym_nullptr] = ACTIONS(3101),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3101),
    [anon_sym_decltype] = ACTIONS(3101),
    [anon_sym_virtual] = ACTIONS(3101),
    [anon_sym_alignas] = ACTIONS(3101),
    [anon_sym_explicit] = ACTIONS(3101),
    [anon_sym_typename] = ACTIONS(3101),
    [anon_sym_template] = ACTIONS(3101),
    [anon_sym_operator] = ACTIONS(3101),
    [anon_sym_try] = ACTIONS(3101),
    [anon_sym_delete] = ACTIONS(3101),
    [anon_sym_throw] = ACTIONS(3101),
    [anon_sym_namespace] = ACTIONS(3101),
    [anon_sym_using] = ACTIONS(3101),
    [anon_sym_static_assert] = ACTIONS(3101),
    [anon_sym_concept] = ACTIONS(3101),
    [anon_sym_co_return] = ACTIONS(3101),
    [anon_sym_co_yield] = ACTIONS(3101),
    [anon_sym_R_DQUOTE] = ACTIONS(3103),
    [anon_sym_LR_DQUOTE] = ACTIONS(3103),
    [anon_sym_uR_DQUOTE] = ACTIONS(3103),
    [anon_sym_UR_DQUOTE] = ACTIONS(3103),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3103),
    [anon_sym_co_await] = ACTIONS(3101),
    [anon_sym_new] = ACTIONS(3101),
    [anon_sym_requires] = ACTIONS(3101),
    [sym_this] = ACTIONS(3101),
  },
  [397] = {
    [sym_identifier] = ACTIONS(3105),
    [aux_sym_preproc_include_token1] = ACTIONS(3105),
    [aux_sym_preproc_def_token1] = ACTIONS(3105),
    [aux_sym_preproc_if_token1] = ACTIONS(3105),
    [aux_sym_preproc_if_token2] = ACTIONS(3105),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3105),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3105),
    [aux_sym_preproc_else_token1] = ACTIONS(3105),
    [aux_sym_preproc_elif_token1] = ACTIONS(3105),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3105),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3105),
    [sym_preproc_directive] = ACTIONS(3105),
    [anon_sym_LPAREN2] = ACTIONS(3107),
    [anon_sym_BANG] = ACTIONS(3107),
    [anon_sym_TILDE] = ACTIONS(3107),
    [anon_sym_DASH] = ACTIONS(3105),
    [anon_sym_PLUS] = ACTIONS(3105),
    [anon_sym_STAR] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3107),
    [anon_sym_AMP] = ACTIONS(3105),
    [anon_sym_SEMI] = ACTIONS(3107),
    [anon_sym___extension__] = ACTIONS(3105),
    [anon_sym_typedef] = ACTIONS(3105),
    [anon_sym_extern] = ACTIONS(3105),
    [anon_sym___attribute__] = ACTIONS(3105),
    [anon_sym_COLON_COLON] = ACTIONS(3107),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3107),
    [anon_sym___declspec] = ACTIONS(3105),
    [anon_sym___based] = ACTIONS(3105),
    [anon_sym___cdecl] = ACTIONS(3105),
    [anon_sym___clrcall] = ACTIONS(3105),
    [anon_sym___stdcall] = ACTIONS(3105),
    [anon_sym___fastcall] = ACTIONS(3105),
    [anon_sym___thiscall] = ACTIONS(3105),
    [anon_sym___vectorcall] = ACTIONS(3105),
    [anon_sym_LBRACE] = ACTIONS(3107),
    [anon_sym_signed] = ACTIONS(3105),
    [anon_sym_unsigned] = ACTIONS(3105),
    [anon_sym_long] = ACTIONS(3105),
    [anon_sym_short] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(3105),
    [anon_sym_static] = ACTIONS(3105),
    [anon_sym_register] = ACTIONS(3105),
    [anon_sym_inline] = ACTIONS(3105),
    [anon_sym___inline] = ACTIONS(3105),
    [anon_sym___inline__] = ACTIONS(3105),
    [anon_sym___forceinline] = ACTIONS(3105),
    [anon_sym_thread_local] = ACTIONS(3105),
    [anon_sym___thread] = ACTIONS(3105),
    [anon_sym_const] = ACTIONS(3105),
    [anon_sym_constexpr] = ACTIONS(3105),
    [anon_sym_volatile] = ACTIONS(3105),
    [anon_sym_restrict] = ACTIONS(3105),
    [anon_sym___restrict__] = ACTIONS(3105),
    [anon_sym__Atomic] = ACTIONS(3105),
    [anon_sym__Noreturn] = ACTIONS(3105),
    [anon_sym_noreturn] = ACTIONS(3105),
    [anon_sym_mutable] = ACTIONS(3105),
    [anon_sym_constinit] = ACTIONS(3105),
    [anon_sym_consteval] = ACTIONS(3105),
    [anon_sym_PROGMEM] = ACTIONS(3105),
    [aux_sym_primitive_type_token1] = ACTIONS(3105),
    [anon_sym_byte] = ACTIONS(3105),
    [anon_sym_word] = ACTIONS(3105),
    [anon_sym_enum] = ACTIONS(3105),
    [anon_sym_class] = ACTIONS(3105),
    [anon_sym_struct] = ACTIONS(3105),
    [anon_sym_union] = ACTIONS(3105),
    [anon_sym_if] = ACTIONS(3105),
    [anon_sym_switch] = ACTIONS(3105),
    [anon_sym_case] = ACTIONS(3105),
    [anon_sym_default] = ACTIONS(3105),
    [anon_sym_while] = ACTIONS(3105),
    [anon_sym_do] = ACTIONS(3105),
    [anon_sym_for] = ACTIONS(3105),
    [anon_sym_return] = ACTIONS(3105),
    [anon_sym_break] = ACTIONS(3105),
    [anon_sym_continue] = ACTIONS(3105),
    [anon_sym_goto] = ACTIONS(3105),
    [anon_sym___try] = ACTIONS(3105),
    [anon_sym___leave] = ACTIONS(3105),
    [anon_sym_not] = ACTIONS(3105),
    [anon_sym_compl] = ACTIONS(3105),
    [anon_sym_DASH_DASH] = ACTIONS(3107),
    [anon_sym_PLUS_PLUS] = ACTIONS(3107),
    [anon_sym_sizeof] = ACTIONS(3105),
    [anon_sym___alignof__] = ACTIONS(3105),
    [anon_sym___alignof] = ACTIONS(3105),
    [anon_sym__alignof] = ACTIONS(3105),
    [anon_sym_alignof] = ACTIONS(3105),
    [anon_sym__Alignof] = ACTIONS(3105),
    [anon_sym_offsetof] = ACTIONS(3105),
    [anon_sym__Generic] = ACTIONS(3105),
    [anon_sym_asm] = ACTIONS(3105),
    [anon_sym___asm__] = ACTIONS(3105),
    [aux_sym_number_literal_token1] = ACTIONS(3107),
    [aux_sym_number_literal_token2] = ACTIONS(3105),
    [anon_sym_L_SQUOTE] = ACTIONS(3107),
    [anon_sym_u_SQUOTE] = ACTIONS(3107),
    [anon_sym_U_SQUOTE] = ACTIONS(3107),
    [anon_sym_u8_SQUOTE] = ACTIONS(3107),
    [anon_sym_SQUOTE] = ACTIONS(3107),
    [anon_sym_L_DQUOTE] = ACTIONS(3107),
    [anon_sym_u_DQUOTE] = ACTIONS(3107),
    [anon_sym_U_DQUOTE] = ACTIONS(3107),
    [anon_sym_u8_DQUOTE] = ACTIONS(3107),
    [anon_sym_DQUOTE] = ACTIONS(3107),
    [sym_true] = ACTIONS(3105),
    [sym_false] = ACTIONS(3105),
    [anon_sym_NULL] = ACTIONS(3105),
    [anon_sym_nullptr] = ACTIONS(3105),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3105),
    [anon_sym_decltype] = ACTIONS(3105),
    [anon_sym_virtual] = ACTIONS(3105),
    [anon_sym_alignas] = ACTIONS(3105),
    [anon_sym_explicit] = ACTIONS(3105),
    [anon_sym_typename] = ACTIONS(3105),
    [anon_sym_template] = ACTIONS(3105),
    [anon_sym_operator] = ACTIONS(3105),
    [anon_sym_try] = ACTIONS(3105),
    [anon_sym_delete] = ACTIONS(3105),
    [anon_sym_throw] = ACTIONS(3105),
    [anon_sym_namespace] = ACTIONS(3105),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_static_assert] = ACTIONS(3105),
    [anon_sym_concept] = ACTIONS(3105),
    [anon_sym_co_return] = ACTIONS(3105),
    [anon_sym_co_yield] = ACTIONS(3105),
    [anon_sym_R_DQUOTE] = ACTIONS(3107),
    [anon_sym_LR_DQUOTE] = ACTIONS(3107),
    [anon_sym_uR_DQUOTE] = ACTIONS(3107),
    [anon_sym_UR_DQUOTE] = ACTIONS(3107),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3107),
    [anon_sym_co_await] = ACTIONS(3105),
    [anon_sym_new] = ACTIONS(3105),
    [anon_sym_requires] = ACTIONS(3105),
    [sym_this] = ACTIONS(3105),
  },
  [398] = {
    [sym_preproc_def] = STATE(367),
    [sym_preproc_function_def] = STATE(367),
    [sym_preproc_call] = STATE(367),
    [sym_preproc_if_in_field_declaration_list] = STATE(367),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(367),
    [sym_preproc_else_in_field_declaration_list] = STATE(7699),
    [sym_preproc_elif_in_field_declaration_list] = STATE(7699),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(7699),
    [sym_type_definition] = STATE(367),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(5531),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(3150),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(5962),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym__field_declaration_list_item] = STATE(367),
    [sym_field_declaration] = STATE(367),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1838),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(367),
    [sym_operator_cast] = STATE(6510),
    [sym_inline_method_definition] = STATE(367),
    [sym__constructor_specifiers] = STATE(1838),
    [sym_operator_cast_definition] = STATE(367),
    [sym_operator_cast_declaration] = STATE(367),
    [sym_constructor_or_destructor_definition] = STATE(367),
    [sym_constructor_or_destructor_declaration] = STATE(367),
    [sym_friend_declaration] = STATE(367),
    [sym_access_specifier] = STATE(7787),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(2618),
    [sym_template_function] = STATE(6098),
    [sym_using_declaration] = STATE(367),
    [sym_alias_declaration] = STATE(367),
    [sym_static_assert_declaration] = STATE(367),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5301),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_qualified_operator_cast_identifier] = STATE(6510),
    [sym_operator_name] = STATE(6098),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(367),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1961),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1838),
    [sym_identifier] = ACTIONS(2823),
    [aux_sym_preproc_def_token1] = ACTIONS(2825),
    [aux_sym_preproc_if_token1] = ACTIONS(2827),
    [aux_sym_preproc_if_token2] = ACTIONS(3109),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2831),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2831),
    [aux_sym_preproc_else_token1] = ACTIONS(2833),
    [aux_sym_preproc_elif_token1] = ACTIONS(2835),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2837),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2837),
    [sym_preproc_directive] = ACTIONS(2839),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(2849),
    [anon_sym_typedef] = ACTIONS(2851),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(2853),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2857),
    [anon_sym_class] = ACTIONS(2859),
    [anon_sym_struct] = ACTIONS(2861),
    [anon_sym_union] = ACTIONS(2863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(2865),
    [anon_sym_template] = ACTIONS(2867),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(2869),
    [anon_sym_public] = ACTIONS(2871),
    [anon_sym_private] = ACTIONS(2871),
    [anon_sym_protected] = ACTIONS(2871),
    [anon_sym_using] = ACTIONS(2873),
    [anon_sym_static_assert] = ACTIONS(2875),
  },
  [399] = {
    [sym_identifier] = ACTIONS(3111),
    [aux_sym_preproc_include_token1] = ACTIONS(3111),
    [aux_sym_preproc_def_token1] = ACTIONS(3111),
    [aux_sym_preproc_if_token1] = ACTIONS(3111),
    [aux_sym_preproc_if_token2] = ACTIONS(3111),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3111),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3111),
    [aux_sym_preproc_else_token1] = ACTIONS(3111),
    [aux_sym_preproc_elif_token1] = ACTIONS(3111),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3111),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3111),
    [sym_preproc_directive] = ACTIONS(3111),
    [anon_sym_LPAREN2] = ACTIONS(3113),
    [anon_sym_BANG] = ACTIONS(3113),
    [anon_sym_TILDE] = ACTIONS(3113),
    [anon_sym_DASH] = ACTIONS(3111),
    [anon_sym_PLUS] = ACTIONS(3111),
    [anon_sym_STAR] = ACTIONS(3113),
    [anon_sym_AMP_AMP] = ACTIONS(3113),
    [anon_sym_AMP] = ACTIONS(3111),
    [anon_sym_SEMI] = ACTIONS(3113),
    [anon_sym___extension__] = ACTIONS(3111),
    [anon_sym_typedef] = ACTIONS(3111),
    [anon_sym_extern] = ACTIONS(3111),
    [anon_sym___attribute__] = ACTIONS(3111),
    [anon_sym_COLON_COLON] = ACTIONS(3113),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3113),
    [anon_sym___declspec] = ACTIONS(3111),
    [anon_sym___based] = ACTIONS(3111),
    [anon_sym___cdecl] = ACTIONS(3111),
    [anon_sym___clrcall] = ACTIONS(3111),
    [anon_sym___stdcall] = ACTIONS(3111),
    [anon_sym___fastcall] = ACTIONS(3111),
    [anon_sym___thiscall] = ACTIONS(3111),
    [anon_sym___vectorcall] = ACTIONS(3111),
    [anon_sym_LBRACE] = ACTIONS(3113),
    [anon_sym_signed] = ACTIONS(3111),
    [anon_sym_unsigned] = ACTIONS(3111),
    [anon_sym_long] = ACTIONS(3111),
    [anon_sym_short] = ACTIONS(3111),
    [anon_sym_LBRACK] = ACTIONS(3111),
    [anon_sym_static] = ACTIONS(3111),
    [anon_sym_register] = ACTIONS(3111),
    [anon_sym_inline] = ACTIONS(3111),
    [anon_sym___inline] = ACTIONS(3111),
    [anon_sym___inline__] = ACTIONS(3111),
    [anon_sym___forceinline] = ACTIONS(3111),
    [anon_sym_thread_local] = ACTIONS(3111),
    [anon_sym___thread] = ACTIONS(3111),
    [anon_sym_const] = ACTIONS(3111),
    [anon_sym_constexpr] = ACTIONS(3111),
    [anon_sym_volatile] = ACTIONS(3111),
    [anon_sym_restrict] = ACTIONS(3111),
    [anon_sym___restrict__] = ACTIONS(3111),
    [anon_sym__Atomic] = ACTIONS(3111),
    [anon_sym__Noreturn] = ACTIONS(3111),
    [anon_sym_noreturn] = ACTIONS(3111),
    [anon_sym_mutable] = ACTIONS(3111),
    [anon_sym_constinit] = ACTIONS(3111),
    [anon_sym_consteval] = ACTIONS(3111),
    [anon_sym_PROGMEM] = ACTIONS(3111),
    [aux_sym_primitive_type_token1] = ACTIONS(3111),
    [anon_sym_byte] = ACTIONS(3111),
    [anon_sym_word] = ACTIONS(3111),
    [anon_sym_enum] = ACTIONS(3111),
    [anon_sym_class] = ACTIONS(3111),
    [anon_sym_struct] = ACTIONS(3111),
    [anon_sym_union] = ACTIONS(3111),
    [anon_sym_if] = ACTIONS(3111),
    [anon_sym_switch] = ACTIONS(3111),
    [anon_sym_case] = ACTIONS(3111),
    [anon_sym_default] = ACTIONS(3111),
    [anon_sym_while] = ACTIONS(3111),
    [anon_sym_do] = ACTIONS(3111),
    [anon_sym_for] = ACTIONS(3111),
    [anon_sym_return] = ACTIONS(3111),
    [anon_sym_break] = ACTIONS(3111),
    [anon_sym_continue] = ACTIONS(3111),
    [anon_sym_goto] = ACTIONS(3111),
    [anon_sym___try] = ACTIONS(3111),
    [anon_sym___leave] = ACTIONS(3111),
    [anon_sym_not] = ACTIONS(3111),
    [anon_sym_compl] = ACTIONS(3111),
    [anon_sym_DASH_DASH] = ACTIONS(3113),
    [anon_sym_PLUS_PLUS] = ACTIONS(3113),
    [anon_sym_sizeof] = ACTIONS(3111),
    [anon_sym___alignof__] = ACTIONS(3111),
    [anon_sym___alignof] = ACTIONS(3111),
    [anon_sym__alignof] = ACTIONS(3111),
    [anon_sym_alignof] = ACTIONS(3111),
    [anon_sym__Alignof] = ACTIONS(3111),
    [anon_sym_offsetof] = ACTIONS(3111),
    [anon_sym__Generic] = ACTIONS(3111),
    [anon_sym_asm] = ACTIONS(3111),
    [anon_sym___asm__] = ACTIONS(3111),
    [aux_sym_number_literal_token1] = ACTIONS(3113),
    [aux_sym_number_literal_token2] = ACTIONS(3111),
    [anon_sym_L_SQUOTE] = ACTIONS(3113),
    [anon_sym_u_SQUOTE] = ACTIONS(3113),
    [anon_sym_U_SQUOTE] = ACTIONS(3113),
    [anon_sym_u8_SQUOTE] = ACTIONS(3113),
    [anon_sym_SQUOTE] = ACTIONS(3113),
    [anon_sym_L_DQUOTE] = ACTIONS(3113),
    [anon_sym_u_DQUOTE] = ACTIONS(3113),
    [anon_sym_U_DQUOTE] = ACTIONS(3113),
    [anon_sym_u8_DQUOTE] = ACTIONS(3113),
    [anon_sym_DQUOTE] = ACTIONS(3113),
    [sym_true] = ACTIONS(3111),
    [sym_false] = ACTIONS(3111),
    [anon_sym_NULL] = ACTIONS(3111),
    [anon_sym_nullptr] = ACTIONS(3111),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3111),
    [anon_sym_decltype] = ACTIONS(3111),
    [anon_sym_virtual] = ACTIONS(3111),
    [anon_sym_alignas] = ACTIONS(3111),
    [anon_sym_explicit] = ACTIONS(3111),
    [anon_sym_typename] = ACTIONS(3111),
    [anon_sym_template] = ACTIONS(3111),
    [anon_sym_operator] = ACTIONS(3111),
    [anon_sym_try] = ACTIONS(3111),
    [anon_sym_delete] = ACTIONS(3111),
    [anon_sym_throw] = ACTIONS(3111),
    [anon_sym_namespace] = ACTIONS(3111),
    [anon_sym_using] = ACTIONS(3111),
    [anon_sym_static_assert] = ACTIONS(3111),
    [anon_sym_concept] = ACTIONS(3111),
    [anon_sym_co_return] = ACTIONS(3111),
    [anon_sym_co_yield] = ACTIONS(3111),
    [anon_sym_R_DQUOTE] = ACTIONS(3113),
    [anon_sym_LR_DQUOTE] = ACTIONS(3113),
    [anon_sym_uR_DQUOTE] = ACTIONS(3113),
    [anon_sym_UR_DQUOTE] = ACTIONS(3113),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3113),
    [anon_sym_co_await] = ACTIONS(3111),
    [anon_sym_new] = ACTIONS(3111),
    [anon_sym_requires] = ACTIONS(3111),
    [sym_this] = ACTIONS(3111),
  },
  [400] = {
    [sym_preproc_def] = STATE(541),
    [sym_preproc_function_def] = STATE(541),
    [sym_preproc_call] = STATE(541),
    [sym_preproc_if_in_field_declaration_list] = STATE(541),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(541),
    [sym_preproc_else_in_field_declaration_list] = STATE(7917),
    [sym_preproc_elif_in_field_declaration_list] = STATE(7917),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(7917),
    [sym_type_definition] = STATE(541),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(5531),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(3150),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(5962),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym__field_declaration_list_item] = STATE(541),
    [sym_field_declaration] = STATE(541),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1838),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(541),
    [sym_operator_cast] = STATE(6510),
    [sym_inline_method_definition] = STATE(541),
    [sym__constructor_specifiers] = STATE(1838),
    [sym_operator_cast_definition] = STATE(541),
    [sym_operator_cast_declaration] = STATE(541),
    [sym_constructor_or_destructor_definition] = STATE(541),
    [sym_constructor_or_destructor_declaration] = STATE(541),
    [sym_friend_declaration] = STATE(541),
    [sym_access_specifier] = STATE(7787),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(2618),
    [sym_template_function] = STATE(6098),
    [sym_using_declaration] = STATE(541),
    [sym_alias_declaration] = STATE(541),
    [sym_static_assert_declaration] = STATE(541),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5301),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_qualified_operator_cast_identifier] = STATE(6510),
    [sym_operator_name] = STATE(6098),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(541),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1961),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1838),
    [sym_identifier] = ACTIONS(2823),
    [aux_sym_preproc_def_token1] = ACTIONS(2825),
    [aux_sym_preproc_if_token1] = ACTIONS(2827),
    [aux_sym_preproc_if_token2] = ACTIONS(3115),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2831),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2831),
    [aux_sym_preproc_else_token1] = ACTIONS(2833),
    [aux_sym_preproc_elif_token1] = ACTIONS(2835),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2837),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2837),
    [sym_preproc_directive] = ACTIONS(2839),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(2849),
    [anon_sym_typedef] = ACTIONS(2851),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(2853),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2857),
    [anon_sym_class] = ACTIONS(2859),
    [anon_sym_struct] = ACTIONS(2861),
    [anon_sym_union] = ACTIONS(2863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(2865),
    [anon_sym_template] = ACTIONS(2867),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(2869),
    [anon_sym_public] = ACTIONS(2871),
    [anon_sym_private] = ACTIONS(2871),
    [anon_sym_protected] = ACTIONS(2871),
    [anon_sym_using] = ACTIONS(2873),
    [anon_sym_static_assert] = ACTIONS(2875),
  },
  [401] = {
    [sym_preproc_def] = STATE(541),
    [sym_preproc_function_def] = STATE(541),
    [sym_preproc_call] = STATE(541),
    [sym_preproc_if_in_field_declaration_list] = STATE(541),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(541),
    [sym_preproc_else_in_field_declaration_list] = STATE(8313),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8313),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8313),
    [sym_type_definition] = STATE(541),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(5531),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(3150),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(5962),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym__field_declaration_list_item] = STATE(541),
    [sym_field_declaration] = STATE(541),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1838),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(541),
    [sym_operator_cast] = STATE(6510),
    [sym_inline_method_definition] = STATE(541),
    [sym__constructor_specifiers] = STATE(1838),
    [sym_operator_cast_definition] = STATE(541),
    [sym_operator_cast_declaration] = STATE(541),
    [sym_constructor_or_destructor_definition] = STATE(541),
    [sym_constructor_or_destructor_declaration] = STATE(541),
    [sym_friend_declaration] = STATE(541),
    [sym_access_specifier] = STATE(7787),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(2618),
    [sym_template_function] = STATE(6098),
    [sym_using_declaration] = STATE(541),
    [sym_alias_declaration] = STATE(541),
    [sym_static_assert_declaration] = STATE(541),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5301),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_qualified_operator_cast_identifier] = STATE(6510),
    [sym_operator_name] = STATE(6098),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(541),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1961),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1838),
    [sym_identifier] = ACTIONS(2823),
    [aux_sym_preproc_def_token1] = ACTIONS(2825),
    [aux_sym_preproc_if_token1] = ACTIONS(2827),
    [aux_sym_preproc_if_token2] = ACTIONS(3117),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2831),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2831),
    [aux_sym_preproc_else_token1] = ACTIONS(2833),
    [aux_sym_preproc_elif_token1] = ACTIONS(2835),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2837),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2837),
    [sym_preproc_directive] = ACTIONS(2839),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(2849),
    [anon_sym_typedef] = ACTIONS(2851),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(2853),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2857),
    [anon_sym_class] = ACTIONS(2859),
    [anon_sym_struct] = ACTIONS(2861),
    [anon_sym_union] = ACTIONS(2863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(2865),
    [anon_sym_template] = ACTIONS(2867),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(2869),
    [anon_sym_public] = ACTIONS(2871),
    [anon_sym_private] = ACTIONS(2871),
    [anon_sym_protected] = ACTIONS(2871),
    [anon_sym_using] = ACTIONS(2873),
    [anon_sym_static_assert] = ACTIONS(2875),
  },
  [402] = {
    [sym_catch_clause] = STATE(402),
    [aux_sym_constructor_try_statement_repeat1] = STATE(402),
    [sym_identifier] = ACTIONS(2475),
    [aux_sym_preproc_include_token1] = ACTIONS(2475),
    [aux_sym_preproc_def_token1] = ACTIONS(2475),
    [aux_sym_preproc_if_token1] = ACTIONS(2475),
    [aux_sym_preproc_if_token2] = ACTIONS(2475),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2475),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2475),
    [sym_preproc_directive] = ACTIONS(2475),
    [anon_sym_LPAREN2] = ACTIONS(2477),
    [anon_sym_BANG] = ACTIONS(2477),
    [anon_sym_TILDE] = ACTIONS(2477),
    [anon_sym_DASH] = ACTIONS(2475),
    [anon_sym_PLUS] = ACTIONS(2475),
    [anon_sym_STAR] = ACTIONS(2477),
    [anon_sym_AMP_AMP] = ACTIONS(2477),
    [anon_sym_AMP] = ACTIONS(2475),
    [anon_sym_SEMI] = ACTIONS(2477),
    [anon_sym___extension__] = ACTIONS(2475),
    [anon_sym_typedef] = ACTIONS(2475),
    [anon_sym_extern] = ACTIONS(2475),
    [anon_sym___attribute__] = ACTIONS(2475),
    [anon_sym_COLON_COLON] = ACTIONS(2477),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2477),
    [anon_sym___declspec] = ACTIONS(2475),
    [anon_sym___based] = ACTIONS(2475),
    [anon_sym___cdecl] = ACTIONS(2475),
    [anon_sym___clrcall] = ACTIONS(2475),
    [anon_sym___stdcall] = ACTIONS(2475),
    [anon_sym___fastcall] = ACTIONS(2475),
    [anon_sym___thiscall] = ACTIONS(2475),
    [anon_sym___vectorcall] = ACTIONS(2475),
    [anon_sym_LBRACE] = ACTIONS(2477),
    [anon_sym_signed] = ACTIONS(2475),
    [anon_sym_unsigned] = ACTIONS(2475),
    [anon_sym_long] = ACTIONS(2475),
    [anon_sym_short] = ACTIONS(2475),
    [anon_sym_LBRACK] = ACTIONS(2475),
    [anon_sym_static] = ACTIONS(2475),
    [anon_sym_register] = ACTIONS(2475),
    [anon_sym_inline] = ACTIONS(2475),
    [anon_sym___inline] = ACTIONS(2475),
    [anon_sym___inline__] = ACTIONS(2475),
    [anon_sym___forceinline] = ACTIONS(2475),
    [anon_sym_thread_local] = ACTIONS(2475),
    [anon_sym___thread] = ACTIONS(2475),
    [anon_sym_const] = ACTIONS(2475),
    [anon_sym_constexpr] = ACTIONS(2475),
    [anon_sym_volatile] = ACTIONS(2475),
    [anon_sym_restrict] = ACTIONS(2475),
    [anon_sym___restrict__] = ACTIONS(2475),
    [anon_sym__Atomic] = ACTIONS(2475),
    [anon_sym__Noreturn] = ACTIONS(2475),
    [anon_sym_noreturn] = ACTIONS(2475),
    [anon_sym_mutable] = ACTIONS(2475),
    [anon_sym_constinit] = ACTIONS(2475),
    [anon_sym_consteval] = ACTIONS(2475),
    [anon_sym_PROGMEM] = ACTIONS(2475),
    [aux_sym_primitive_type_token1] = ACTIONS(2475),
    [anon_sym_byte] = ACTIONS(2475),
    [anon_sym_word] = ACTIONS(2475),
    [anon_sym_enum] = ACTIONS(2475),
    [anon_sym_class] = ACTIONS(2475),
    [anon_sym_struct] = ACTIONS(2475),
    [anon_sym_union] = ACTIONS(2475),
    [anon_sym_if] = ACTIONS(2475),
    [anon_sym_else] = ACTIONS(2475),
    [anon_sym_switch] = ACTIONS(2475),
    [anon_sym_case] = ACTIONS(2475),
    [anon_sym_default] = ACTIONS(2475),
    [anon_sym_while] = ACTIONS(2475),
    [anon_sym_do] = ACTIONS(2475),
    [anon_sym_for] = ACTIONS(2475),
    [anon_sym_return] = ACTIONS(2475),
    [anon_sym_break] = ACTIONS(2475),
    [anon_sym_continue] = ACTIONS(2475),
    [anon_sym_goto] = ACTIONS(2475),
    [anon_sym___try] = ACTIONS(2475),
    [anon_sym___leave] = ACTIONS(2475),
    [anon_sym_not] = ACTIONS(2475),
    [anon_sym_compl] = ACTIONS(2475),
    [anon_sym_DASH_DASH] = ACTIONS(2477),
    [anon_sym_PLUS_PLUS] = ACTIONS(2477),
    [anon_sym_sizeof] = ACTIONS(2475),
    [anon_sym___alignof__] = ACTIONS(2475),
    [anon_sym___alignof] = ACTIONS(2475),
    [anon_sym__alignof] = ACTIONS(2475),
    [anon_sym_alignof] = ACTIONS(2475),
    [anon_sym__Alignof] = ACTIONS(2475),
    [anon_sym_offsetof] = ACTIONS(2475),
    [anon_sym__Generic] = ACTIONS(2475),
    [anon_sym_asm] = ACTIONS(2475),
    [anon_sym___asm__] = ACTIONS(2475),
    [aux_sym_number_literal_token1] = ACTIONS(2477),
    [aux_sym_number_literal_token2] = ACTIONS(2475),
    [anon_sym_L_SQUOTE] = ACTIONS(2477),
    [anon_sym_u_SQUOTE] = ACTIONS(2477),
    [anon_sym_U_SQUOTE] = ACTIONS(2477),
    [anon_sym_u8_SQUOTE] = ACTIONS(2477),
    [anon_sym_SQUOTE] = ACTIONS(2477),
    [anon_sym_L_DQUOTE] = ACTIONS(2477),
    [anon_sym_u_DQUOTE] = ACTIONS(2477),
    [anon_sym_U_DQUOTE] = ACTIONS(2477),
    [anon_sym_u8_DQUOTE] = ACTIONS(2477),
    [anon_sym_DQUOTE] = ACTIONS(2477),
    [sym_true] = ACTIONS(2475),
    [sym_false] = ACTIONS(2475),
    [anon_sym_NULL] = ACTIONS(2475),
    [anon_sym_nullptr] = ACTIONS(2475),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2475),
    [anon_sym_decltype] = ACTIONS(2475),
    [anon_sym_virtual] = ACTIONS(2475),
    [anon_sym_alignas] = ACTIONS(2475),
    [anon_sym_explicit] = ACTIONS(2475),
    [anon_sym_typename] = ACTIONS(2475),
    [anon_sym_template] = ACTIONS(2475),
    [anon_sym_operator] = ACTIONS(2475),
    [anon_sym_try] = ACTIONS(2475),
    [anon_sym_delete] = ACTIONS(2475),
    [anon_sym_throw] = ACTIONS(2475),
    [anon_sym_namespace] = ACTIONS(2475),
    [anon_sym_using] = ACTIONS(2475),
    [anon_sym_static_assert] = ACTIONS(2475),
    [anon_sym_concept] = ACTIONS(2475),
    [anon_sym_co_return] = ACTIONS(2475),
    [anon_sym_co_yield] = ACTIONS(2475),
    [anon_sym_catch] = ACTIONS(3119),
    [anon_sym_R_DQUOTE] = ACTIONS(2477),
    [anon_sym_LR_DQUOTE] = ACTIONS(2477),
    [anon_sym_uR_DQUOTE] = ACTIONS(2477),
    [anon_sym_UR_DQUOTE] = ACTIONS(2477),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2477),
    [anon_sym_co_await] = ACTIONS(2475),
    [anon_sym_new] = ACTIONS(2475),
    [anon_sym_requires] = ACTIONS(2475),
    [sym_this] = ACTIONS(2475),
  },
  [403] = {
    [sym_identifier] = ACTIONS(3122),
    [aux_sym_preproc_include_token1] = ACTIONS(3122),
    [aux_sym_preproc_def_token1] = ACTIONS(3122),
    [aux_sym_preproc_if_token1] = ACTIONS(3122),
    [aux_sym_preproc_if_token2] = ACTIONS(3122),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3122),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3122),
    [aux_sym_preproc_else_token1] = ACTIONS(3122),
    [aux_sym_preproc_elif_token1] = ACTIONS(3122),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3122),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3122),
    [sym_preproc_directive] = ACTIONS(3122),
    [anon_sym_LPAREN2] = ACTIONS(3124),
    [anon_sym_BANG] = ACTIONS(3124),
    [anon_sym_TILDE] = ACTIONS(3124),
    [anon_sym_DASH] = ACTIONS(3122),
    [anon_sym_PLUS] = ACTIONS(3122),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP_AMP] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3122),
    [anon_sym_SEMI] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(3122),
    [anon_sym_typedef] = ACTIONS(3122),
    [anon_sym_extern] = ACTIONS(3122),
    [anon_sym___attribute__] = ACTIONS(3122),
    [anon_sym_COLON_COLON] = ACTIONS(3124),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3124),
    [anon_sym___declspec] = ACTIONS(3122),
    [anon_sym___based] = ACTIONS(3122),
    [anon_sym___cdecl] = ACTIONS(3122),
    [anon_sym___clrcall] = ACTIONS(3122),
    [anon_sym___stdcall] = ACTIONS(3122),
    [anon_sym___fastcall] = ACTIONS(3122),
    [anon_sym___thiscall] = ACTIONS(3122),
    [anon_sym___vectorcall] = ACTIONS(3122),
    [anon_sym_LBRACE] = ACTIONS(3124),
    [anon_sym_signed] = ACTIONS(3122),
    [anon_sym_unsigned] = ACTIONS(3122),
    [anon_sym_long] = ACTIONS(3122),
    [anon_sym_short] = ACTIONS(3122),
    [anon_sym_LBRACK] = ACTIONS(3122),
    [anon_sym_static] = ACTIONS(3122),
    [anon_sym_register] = ACTIONS(3122),
    [anon_sym_inline] = ACTIONS(3122),
    [anon_sym___inline] = ACTIONS(3122),
    [anon_sym___inline__] = ACTIONS(3122),
    [anon_sym___forceinline] = ACTIONS(3122),
    [anon_sym_thread_local] = ACTIONS(3122),
    [anon_sym___thread] = ACTIONS(3122),
    [anon_sym_const] = ACTIONS(3122),
    [anon_sym_constexpr] = ACTIONS(3122),
    [anon_sym_volatile] = ACTIONS(3122),
    [anon_sym_restrict] = ACTIONS(3122),
    [anon_sym___restrict__] = ACTIONS(3122),
    [anon_sym__Atomic] = ACTIONS(3122),
    [anon_sym__Noreturn] = ACTIONS(3122),
    [anon_sym_noreturn] = ACTIONS(3122),
    [anon_sym_mutable] = ACTIONS(3122),
    [anon_sym_constinit] = ACTIONS(3122),
    [anon_sym_consteval] = ACTIONS(3122),
    [anon_sym_PROGMEM] = ACTIONS(3122),
    [aux_sym_primitive_type_token1] = ACTIONS(3122),
    [anon_sym_byte] = ACTIONS(3122),
    [anon_sym_word] = ACTIONS(3122),
    [anon_sym_enum] = ACTIONS(3122),
    [anon_sym_class] = ACTIONS(3122),
    [anon_sym_struct] = ACTIONS(3122),
    [anon_sym_union] = ACTIONS(3122),
    [anon_sym_if] = ACTIONS(3122),
    [anon_sym_switch] = ACTIONS(3122),
    [anon_sym_case] = ACTIONS(3122),
    [anon_sym_default] = ACTIONS(3122),
    [anon_sym_while] = ACTIONS(3122),
    [anon_sym_do] = ACTIONS(3122),
    [anon_sym_for] = ACTIONS(3122),
    [anon_sym_return] = ACTIONS(3122),
    [anon_sym_break] = ACTIONS(3122),
    [anon_sym_continue] = ACTIONS(3122),
    [anon_sym_goto] = ACTIONS(3122),
    [anon_sym___try] = ACTIONS(3122),
    [anon_sym___leave] = ACTIONS(3122),
    [anon_sym_not] = ACTIONS(3122),
    [anon_sym_compl] = ACTIONS(3122),
    [anon_sym_DASH_DASH] = ACTIONS(3124),
    [anon_sym_PLUS_PLUS] = ACTIONS(3124),
    [anon_sym_sizeof] = ACTIONS(3122),
    [anon_sym___alignof__] = ACTIONS(3122),
    [anon_sym___alignof] = ACTIONS(3122),
    [anon_sym__alignof] = ACTIONS(3122),
    [anon_sym_alignof] = ACTIONS(3122),
    [anon_sym__Alignof] = ACTIONS(3122),
    [anon_sym_offsetof] = ACTIONS(3122),
    [anon_sym__Generic] = ACTIONS(3122),
    [anon_sym_asm] = ACTIONS(3122),
    [anon_sym___asm__] = ACTIONS(3122),
    [aux_sym_number_literal_token1] = ACTIONS(3124),
    [aux_sym_number_literal_token2] = ACTIONS(3122),
    [anon_sym_L_SQUOTE] = ACTIONS(3124),
    [anon_sym_u_SQUOTE] = ACTIONS(3124),
    [anon_sym_U_SQUOTE] = ACTIONS(3124),
    [anon_sym_u8_SQUOTE] = ACTIONS(3124),
    [anon_sym_SQUOTE] = ACTIONS(3124),
    [anon_sym_L_DQUOTE] = ACTIONS(3124),
    [anon_sym_u_DQUOTE] = ACTIONS(3124),
    [anon_sym_U_DQUOTE] = ACTIONS(3124),
    [anon_sym_u8_DQUOTE] = ACTIONS(3124),
    [anon_sym_DQUOTE] = ACTIONS(3124),
    [sym_true] = ACTIONS(3122),
    [sym_false] = ACTIONS(3122),
    [anon_sym_NULL] = ACTIONS(3122),
    [anon_sym_nullptr] = ACTIONS(3122),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3122),
    [anon_sym_decltype] = ACTIONS(3122),
    [anon_sym_virtual] = ACTIONS(3122),
    [anon_sym_alignas] = ACTIONS(3122),
    [anon_sym_explicit] = ACTIONS(3122),
    [anon_sym_typename] = ACTIONS(3122),
    [anon_sym_template] = ACTIONS(3122),
    [anon_sym_operator] = ACTIONS(3122),
    [anon_sym_try] = ACTIONS(3122),
    [anon_sym_delete] = ACTIONS(3122),
    [anon_sym_throw] = ACTIONS(3122),
    [anon_sym_namespace] = ACTIONS(3122),
    [anon_sym_using] = ACTIONS(3122),
    [anon_sym_static_assert] = ACTIONS(3122),
    [anon_sym_concept] = ACTIONS(3122),
    [anon_sym_co_return] = ACTIONS(3122),
    [anon_sym_co_yield] = ACTIONS(3122),
    [anon_sym_R_DQUOTE] = ACTIONS(3124),
    [anon_sym_LR_DQUOTE] = ACTIONS(3124),
    [anon_sym_uR_DQUOTE] = ACTIONS(3124),
    [anon_sym_UR_DQUOTE] = ACTIONS(3124),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3124),
    [anon_sym_co_await] = ACTIONS(3122),
    [anon_sym_new] = ACTIONS(3122),
    [anon_sym_requires] = ACTIONS(3122),
    [sym_this] = ACTIONS(3122),
  },
  [404] = {
    [sym_identifier] = ACTIONS(3126),
    [aux_sym_preproc_include_token1] = ACTIONS(3126),
    [aux_sym_preproc_def_token1] = ACTIONS(3126),
    [aux_sym_preproc_if_token1] = ACTIONS(3126),
    [aux_sym_preproc_if_token2] = ACTIONS(3126),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3126),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3126),
    [aux_sym_preproc_else_token1] = ACTIONS(3126),
    [aux_sym_preproc_elif_token1] = ACTIONS(3126),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3126),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3126),
    [sym_preproc_directive] = ACTIONS(3126),
    [anon_sym_LPAREN2] = ACTIONS(3128),
    [anon_sym_BANG] = ACTIONS(3128),
    [anon_sym_TILDE] = ACTIONS(3128),
    [anon_sym_DASH] = ACTIONS(3126),
    [anon_sym_PLUS] = ACTIONS(3126),
    [anon_sym_STAR] = ACTIONS(3128),
    [anon_sym_AMP_AMP] = ACTIONS(3128),
    [anon_sym_AMP] = ACTIONS(3126),
    [anon_sym_SEMI] = ACTIONS(3128),
    [anon_sym___extension__] = ACTIONS(3126),
    [anon_sym_typedef] = ACTIONS(3126),
    [anon_sym_extern] = ACTIONS(3126),
    [anon_sym___attribute__] = ACTIONS(3126),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3128),
    [anon_sym___declspec] = ACTIONS(3126),
    [anon_sym___based] = ACTIONS(3126),
    [anon_sym___cdecl] = ACTIONS(3126),
    [anon_sym___clrcall] = ACTIONS(3126),
    [anon_sym___stdcall] = ACTIONS(3126),
    [anon_sym___fastcall] = ACTIONS(3126),
    [anon_sym___thiscall] = ACTIONS(3126),
    [anon_sym___vectorcall] = ACTIONS(3126),
    [anon_sym_LBRACE] = ACTIONS(3128),
    [anon_sym_signed] = ACTIONS(3126),
    [anon_sym_unsigned] = ACTIONS(3126),
    [anon_sym_long] = ACTIONS(3126),
    [anon_sym_short] = ACTIONS(3126),
    [anon_sym_LBRACK] = ACTIONS(3126),
    [anon_sym_static] = ACTIONS(3126),
    [anon_sym_register] = ACTIONS(3126),
    [anon_sym_inline] = ACTIONS(3126),
    [anon_sym___inline] = ACTIONS(3126),
    [anon_sym___inline__] = ACTIONS(3126),
    [anon_sym___forceinline] = ACTIONS(3126),
    [anon_sym_thread_local] = ACTIONS(3126),
    [anon_sym___thread] = ACTIONS(3126),
    [anon_sym_const] = ACTIONS(3126),
    [anon_sym_constexpr] = ACTIONS(3126),
    [anon_sym_volatile] = ACTIONS(3126),
    [anon_sym_restrict] = ACTIONS(3126),
    [anon_sym___restrict__] = ACTIONS(3126),
    [anon_sym__Atomic] = ACTIONS(3126),
    [anon_sym__Noreturn] = ACTIONS(3126),
    [anon_sym_noreturn] = ACTIONS(3126),
    [anon_sym_mutable] = ACTIONS(3126),
    [anon_sym_constinit] = ACTIONS(3126),
    [anon_sym_consteval] = ACTIONS(3126),
    [anon_sym_PROGMEM] = ACTIONS(3126),
    [aux_sym_primitive_type_token1] = ACTIONS(3126),
    [anon_sym_byte] = ACTIONS(3126),
    [anon_sym_word] = ACTIONS(3126),
    [anon_sym_enum] = ACTIONS(3126),
    [anon_sym_class] = ACTIONS(3126),
    [anon_sym_struct] = ACTIONS(3126),
    [anon_sym_union] = ACTIONS(3126),
    [anon_sym_if] = ACTIONS(3126),
    [anon_sym_switch] = ACTIONS(3126),
    [anon_sym_case] = ACTIONS(3126),
    [anon_sym_default] = ACTIONS(3126),
    [anon_sym_while] = ACTIONS(3126),
    [anon_sym_do] = ACTIONS(3126),
    [anon_sym_for] = ACTIONS(3126),
    [anon_sym_return] = ACTIONS(3126),
    [anon_sym_break] = ACTIONS(3126),
    [anon_sym_continue] = ACTIONS(3126),
    [anon_sym_goto] = ACTIONS(3126),
    [anon_sym___try] = ACTIONS(3126),
    [anon_sym___leave] = ACTIONS(3126),
    [anon_sym_not] = ACTIONS(3126),
    [anon_sym_compl] = ACTIONS(3126),
    [anon_sym_DASH_DASH] = ACTIONS(3128),
    [anon_sym_PLUS_PLUS] = ACTIONS(3128),
    [anon_sym_sizeof] = ACTIONS(3126),
    [anon_sym___alignof__] = ACTIONS(3126),
    [anon_sym___alignof] = ACTIONS(3126),
    [anon_sym__alignof] = ACTIONS(3126),
    [anon_sym_alignof] = ACTIONS(3126),
    [anon_sym__Alignof] = ACTIONS(3126),
    [anon_sym_offsetof] = ACTIONS(3126),
    [anon_sym__Generic] = ACTIONS(3126),
    [anon_sym_asm] = ACTIONS(3126),
    [anon_sym___asm__] = ACTIONS(3126),
    [aux_sym_number_literal_token1] = ACTIONS(3128),
    [aux_sym_number_literal_token2] = ACTIONS(3126),
    [anon_sym_L_SQUOTE] = ACTIONS(3128),
    [anon_sym_u_SQUOTE] = ACTIONS(3128),
    [anon_sym_U_SQUOTE] = ACTIONS(3128),
    [anon_sym_u8_SQUOTE] = ACTIONS(3128),
    [anon_sym_SQUOTE] = ACTIONS(3128),
    [anon_sym_L_DQUOTE] = ACTIONS(3128),
    [anon_sym_u_DQUOTE] = ACTIONS(3128),
    [anon_sym_U_DQUOTE] = ACTIONS(3128),
    [anon_sym_u8_DQUOTE] = ACTIONS(3128),
    [anon_sym_DQUOTE] = ACTIONS(3128),
    [sym_true] = ACTIONS(3126),
    [sym_false] = ACTIONS(3126),
    [anon_sym_NULL] = ACTIONS(3126),
    [anon_sym_nullptr] = ACTIONS(3126),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3126),
    [anon_sym_decltype] = ACTIONS(3126),
    [anon_sym_virtual] = ACTIONS(3126),
    [anon_sym_alignas] = ACTIONS(3126),
    [anon_sym_explicit] = ACTIONS(3126),
    [anon_sym_typename] = ACTIONS(3126),
    [anon_sym_template] = ACTIONS(3126),
    [anon_sym_operator] = ACTIONS(3126),
    [anon_sym_try] = ACTIONS(3126),
    [anon_sym_delete] = ACTIONS(3126),
    [anon_sym_throw] = ACTIONS(3126),
    [anon_sym_namespace] = ACTIONS(3126),
    [anon_sym_using] = ACTIONS(3126),
    [anon_sym_static_assert] = ACTIONS(3126),
    [anon_sym_concept] = ACTIONS(3126),
    [anon_sym_co_return] = ACTIONS(3126),
    [anon_sym_co_yield] = ACTIONS(3126),
    [anon_sym_R_DQUOTE] = ACTIONS(3128),
    [anon_sym_LR_DQUOTE] = ACTIONS(3128),
    [anon_sym_uR_DQUOTE] = ACTIONS(3128),
    [anon_sym_UR_DQUOTE] = ACTIONS(3128),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3128),
    [anon_sym_co_await] = ACTIONS(3126),
    [anon_sym_new] = ACTIONS(3126),
    [anon_sym_requires] = ACTIONS(3126),
    [sym_this] = ACTIONS(3126),
  },
  [405] = {
    [sym_preproc_def] = STATE(335),
    [sym_preproc_function_def] = STATE(335),
    [sym_preproc_call] = STATE(335),
    [sym_preproc_if_in_field_declaration_list] = STATE(335),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(335),
    [sym_preproc_else_in_field_declaration_list] = STATE(7849),
    [sym_preproc_elif_in_field_declaration_list] = STATE(7849),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(7849),
    [sym_type_definition] = STATE(335),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(5531),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(3150),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(5962),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym__field_declaration_list_item] = STATE(335),
    [sym_field_declaration] = STATE(335),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1838),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(335),
    [sym_operator_cast] = STATE(6510),
    [sym_inline_method_definition] = STATE(335),
    [sym__constructor_specifiers] = STATE(1838),
    [sym_operator_cast_definition] = STATE(335),
    [sym_operator_cast_declaration] = STATE(335),
    [sym_constructor_or_destructor_definition] = STATE(335),
    [sym_constructor_or_destructor_declaration] = STATE(335),
    [sym_friend_declaration] = STATE(335),
    [sym_access_specifier] = STATE(7787),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(2618),
    [sym_template_function] = STATE(6098),
    [sym_using_declaration] = STATE(335),
    [sym_alias_declaration] = STATE(335),
    [sym_static_assert_declaration] = STATE(335),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5301),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_qualified_operator_cast_identifier] = STATE(6510),
    [sym_operator_name] = STATE(6098),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(335),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1961),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1838),
    [sym_identifier] = ACTIONS(2823),
    [aux_sym_preproc_def_token1] = ACTIONS(2825),
    [aux_sym_preproc_if_token1] = ACTIONS(2827),
    [aux_sym_preproc_if_token2] = ACTIONS(3130),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2831),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2831),
    [aux_sym_preproc_else_token1] = ACTIONS(2833),
    [aux_sym_preproc_elif_token1] = ACTIONS(2835),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2837),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2837),
    [sym_preproc_directive] = ACTIONS(2839),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(2849),
    [anon_sym_typedef] = ACTIONS(2851),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(2853),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2857),
    [anon_sym_class] = ACTIONS(2859),
    [anon_sym_struct] = ACTIONS(2861),
    [anon_sym_union] = ACTIONS(2863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(2865),
    [anon_sym_template] = ACTIONS(2867),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(2869),
    [anon_sym_public] = ACTIONS(2871),
    [anon_sym_private] = ACTIONS(2871),
    [anon_sym_protected] = ACTIONS(2871),
    [anon_sym_using] = ACTIONS(2873),
    [anon_sym_static_assert] = ACTIONS(2875),
  },
  [406] = {
    [sym_identifier] = ACTIONS(3126),
    [aux_sym_preproc_include_token1] = ACTIONS(3126),
    [aux_sym_preproc_def_token1] = ACTIONS(3126),
    [aux_sym_preproc_if_token1] = ACTIONS(3126),
    [aux_sym_preproc_if_token2] = ACTIONS(3126),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3126),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3126),
    [aux_sym_preproc_else_token1] = ACTIONS(3126),
    [aux_sym_preproc_elif_token1] = ACTIONS(3126),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3126),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3126),
    [sym_preproc_directive] = ACTIONS(3126),
    [anon_sym_LPAREN2] = ACTIONS(3128),
    [anon_sym_BANG] = ACTIONS(3128),
    [anon_sym_TILDE] = ACTIONS(3128),
    [anon_sym_DASH] = ACTIONS(3126),
    [anon_sym_PLUS] = ACTIONS(3126),
    [anon_sym_STAR] = ACTIONS(3128),
    [anon_sym_AMP_AMP] = ACTIONS(3128),
    [anon_sym_AMP] = ACTIONS(3126),
    [anon_sym_SEMI] = ACTIONS(3128),
    [anon_sym___extension__] = ACTIONS(3126),
    [anon_sym_typedef] = ACTIONS(3126),
    [anon_sym_extern] = ACTIONS(3126),
    [anon_sym___attribute__] = ACTIONS(3126),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3128),
    [anon_sym___declspec] = ACTIONS(3126),
    [anon_sym___based] = ACTIONS(3126),
    [anon_sym___cdecl] = ACTIONS(3126),
    [anon_sym___clrcall] = ACTIONS(3126),
    [anon_sym___stdcall] = ACTIONS(3126),
    [anon_sym___fastcall] = ACTIONS(3126),
    [anon_sym___thiscall] = ACTIONS(3126),
    [anon_sym___vectorcall] = ACTIONS(3126),
    [anon_sym_LBRACE] = ACTIONS(3128),
    [anon_sym_signed] = ACTIONS(3126),
    [anon_sym_unsigned] = ACTIONS(3126),
    [anon_sym_long] = ACTIONS(3126),
    [anon_sym_short] = ACTIONS(3126),
    [anon_sym_LBRACK] = ACTIONS(3126),
    [anon_sym_static] = ACTIONS(3126),
    [anon_sym_register] = ACTIONS(3126),
    [anon_sym_inline] = ACTIONS(3126),
    [anon_sym___inline] = ACTIONS(3126),
    [anon_sym___inline__] = ACTIONS(3126),
    [anon_sym___forceinline] = ACTIONS(3126),
    [anon_sym_thread_local] = ACTIONS(3126),
    [anon_sym___thread] = ACTIONS(3126),
    [anon_sym_const] = ACTIONS(3126),
    [anon_sym_constexpr] = ACTIONS(3126),
    [anon_sym_volatile] = ACTIONS(3126),
    [anon_sym_restrict] = ACTIONS(3126),
    [anon_sym___restrict__] = ACTIONS(3126),
    [anon_sym__Atomic] = ACTIONS(3126),
    [anon_sym__Noreturn] = ACTIONS(3126),
    [anon_sym_noreturn] = ACTIONS(3126),
    [anon_sym_mutable] = ACTIONS(3126),
    [anon_sym_constinit] = ACTIONS(3126),
    [anon_sym_consteval] = ACTIONS(3126),
    [anon_sym_PROGMEM] = ACTIONS(3126),
    [aux_sym_primitive_type_token1] = ACTIONS(3126),
    [anon_sym_byte] = ACTIONS(3126),
    [anon_sym_word] = ACTIONS(3126),
    [anon_sym_enum] = ACTIONS(3126),
    [anon_sym_class] = ACTIONS(3126),
    [anon_sym_struct] = ACTIONS(3126),
    [anon_sym_union] = ACTIONS(3126),
    [anon_sym_if] = ACTIONS(3126),
    [anon_sym_switch] = ACTIONS(3126),
    [anon_sym_case] = ACTIONS(3126),
    [anon_sym_default] = ACTIONS(3126),
    [anon_sym_while] = ACTIONS(3126),
    [anon_sym_do] = ACTIONS(3126),
    [anon_sym_for] = ACTIONS(3126),
    [anon_sym_return] = ACTIONS(3126),
    [anon_sym_break] = ACTIONS(3126),
    [anon_sym_continue] = ACTIONS(3126),
    [anon_sym_goto] = ACTIONS(3126),
    [anon_sym___try] = ACTIONS(3126),
    [anon_sym___leave] = ACTIONS(3126),
    [anon_sym_not] = ACTIONS(3126),
    [anon_sym_compl] = ACTIONS(3126),
    [anon_sym_DASH_DASH] = ACTIONS(3128),
    [anon_sym_PLUS_PLUS] = ACTIONS(3128),
    [anon_sym_sizeof] = ACTIONS(3126),
    [anon_sym___alignof__] = ACTIONS(3126),
    [anon_sym___alignof] = ACTIONS(3126),
    [anon_sym__alignof] = ACTIONS(3126),
    [anon_sym_alignof] = ACTIONS(3126),
    [anon_sym__Alignof] = ACTIONS(3126),
    [anon_sym_offsetof] = ACTIONS(3126),
    [anon_sym__Generic] = ACTIONS(3126),
    [anon_sym_asm] = ACTIONS(3126),
    [anon_sym___asm__] = ACTIONS(3126),
    [aux_sym_number_literal_token1] = ACTIONS(3128),
    [aux_sym_number_literal_token2] = ACTIONS(3126),
    [anon_sym_L_SQUOTE] = ACTIONS(3128),
    [anon_sym_u_SQUOTE] = ACTIONS(3128),
    [anon_sym_U_SQUOTE] = ACTIONS(3128),
    [anon_sym_u8_SQUOTE] = ACTIONS(3128),
    [anon_sym_SQUOTE] = ACTIONS(3128),
    [anon_sym_L_DQUOTE] = ACTIONS(3128),
    [anon_sym_u_DQUOTE] = ACTIONS(3128),
    [anon_sym_U_DQUOTE] = ACTIONS(3128),
    [anon_sym_u8_DQUOTE] = ACTIONS(3128),
    [anon_sym_DQUOTE] = ACTIONS(3128),
    [sym_true] = ACTIONS(3126),
    [sym_false] = ACTIONS(3126),
    [anon_sym_NULL] = ACTIONS(3126),
    [anon_sym_nullptr] = ACTIONS(3126),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3126),
    [anon_sym_decltype] = ACTIONS(3126),
    [anon_sym_virtual] = ACTIONS(3126),
    [anon_sym_alignas] = ACTIONS(3126),
    [anon_sym_explicit] = ACTIONS(3126),
    [anon_sym_typename] = ACTIONS(3126),
    [anon_sym_template] = ACTIONS(3126),
    [anon_sym_operator] = ACTIONS(3126),
    [anon_sym_try] = ACTIONS(3126),
    [anon_sym_delete] = ACTIONS(3126),
    [anon_sym_throw] = ACTIONS(3126),
    [anon_sym_namespace] = ACTIONS(3126),
    [anon_sym_using] = ACTIONS(3126),
    [anon_sym_static_assert] = ACTIONS(3126),
    [anon_sym_concept] = ACTIONS(3126),
    [anon_sym_co_return] = ACTIONS(3126),
    [anon_sym_co_yield] = ACTIONS(3126),
    [anon_sym_R_DQUOTE] = ACTIONS(3128),
    [anon_sym_LR_DQUOTE] = ACTIONS(3128),
    [anon_sym_uR_DQUOTE] = ACTIONS(3128),
    [anon_sym_UR_DQUOTE] = ACTIONS(3128),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3128),
    [anon_sym_co_await] = ACTIONS(3126),
    [anon_sym_new] = ACTIONS(3126),
    [anon_sym_requires] = ACTIONS(3126),
    [sym_this] = ACTIONS(3126),
  },
  [407] = {
    [sym_identifier] = ACTIONS(3132),
    [aux_sym_preproc_include_token1] = ACTIONS(3132),
    [aux_sym_preproc_def_token1] = ACTIONS(3132),
    [aux_sym_preproc_if_token1] = ACTIONS(3132),
    [aux_sym_preproc_if_token2] = ACTIONS(3132),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3132),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3132),
    [aux_sym_preproc_else_token1] = ACTIONS(3132),
    [aux_sym_preproc_elif_token1] = ACTIONS(3132),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3132),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3132),
    [sym_preproc_directive] = ACTIONS(3132),
    [anon_sym_LPAREN2] = ACTIONS(3134),
    [anon_sym_BANG] = ACTIONS(3134),
    [anon_sym_TILDE] = ACTIONS(3134),
    [anon_sym_DASH] = ACTIONS(3132),
    [anon_sym_PLUS] = ACTIONS(3132),
    [anon_sym_STAR] = ACTIONS(3134),
    [anon_sym_AMP_AMP] = ACTIONS(3134),
    [anon_sym_AMP] = ACTIONS(3132),
    [anon_sym_SEMI] = ACTIONS(3134),
    [anon_sym___extension__] = ACTIONS(3132),
    [anon_sym_typedef] = ACTIONS(3132),
    [anon_sym_extern] = ACTIONS(3132),
    [anon_sym___attribute__] = ACTIONS(3132),
    [anon_sym_COLON_COLON] = ACTIONS(3134),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3134),
    [anon_sym___declspec] = ACTIONS(3132),
    [anon_sym___based] = ACTIONS(3132),
    [anon_sym___cdecl] = ACTIONS(3132),
    [anon_sym___clrcall] = ACTIONS(3132),
    [anon_sym___stdcall] = ACTIONS(3132),
    [anon_sym___fastcall] = ACTIONS(3132),
    [anon_sym___thiscall] = ACTIONS(3132),
    [anon_sym___vectorcall] = ACTIONS(3132),
    [anon_sym_LBRACE] = ACTIONS(3134),
    [anon_sym_signed] = ACTIONS(3132),
    [anon_sym_unsigned] = ACTIONS(3132),
    [anon_sym_long] = ACTIONS(3132),
    [anon_sym_short] = ACTIONS(3132),
    [anon_sym_LBRACK] = ACTIONS(3132),
    [anon_sym_static] = ACTIONS(3132),
    [anon_sym_register] = ACTIONS(3132),
    [anon_sym_inline] = ACTIONS(3132),
    [anon_sym___inline] = ACTIONS(3132),
    [anon_sym___inline__] = ACTIONS(3132),
    [anon_sym___forceinline] = ACTIONS(3132),
    [anon_sym_thread_local] = ACTIONS(3132),
    [anon_sym___thread] = ACTIONS(3132),
    [anon_sym_const] = ACTIONS(3132),
    [anon_sym_constexpr] = ACTIONS(3132),
    [anon_sym_volatile] = ACTIONS(3132),
    [anon_sym_restrict] = ACTIONS(3132),
    [anon_sym___restrict__] = ACTIONS(3132),
    [anon_sym__Atomic] = ACTIONS(3132),
    [anon_sym__Noreturn] = ACTIONS(3132),
    [anon_sym_noreturn] = ACTIONS(3132),
    [anon_sym_mutable] = ACTIONS(3132),
    [anon_sym_constinit] = ACTIONS(3132),
    [anon_sym_consteval] = ACTIONS(3132),
    [anon_sym_PROGMEM] = ACTIONS(3132),
    [aux_sym_primitive_type_token1] = ACTIONS(3132),
    [anon_sym_byte] = ACTIONS(3132),
    [anon_sym_word] = ACTIONS(3132),
    [anon_sym_enum] = ACTIONS(3132),
    [anon_sym_class] = ACTIONS(3132),
    [anon_sym_struct] = ACTIONS(3132),
    [anon_sym_union] = ACTIONS(3132),
    [anon_sym_if] = ACTIONS(3132),
    [anon_sym_switch] = ACTIONS(3132),
    [anon_sym_case] = ACTIONS(3132),
    [anon_sym_default] = ACTIONS(3132),
    [anon_sym_while] = ACTIONS(3132),
    [anon_sym_do] = ACTIONS(3132),
    [anon_sym_for] = ACTIONS(3132),
    [anon_sym_return] = ACTIONS(3132),
    [anon_sym_break] = ACTIONS(3132),
    [anon_sym_continue] = ACTIONS(3132),
    [anon_sym_goto] = ACTIONS(3132),
    [anon_sym___try] = ACTIONS(3132),
    [anon_sym___leave] = ACTIONS(3132),
    [anon_sym_not] = ACTIONS(3132),
    [anon_sym_compl] = ACTIONS(3132),
    [anon_sym_DASH_DASH] = ACTIONS(3134),
    [anon_sym_PLUS_PLUS] = ACTIONS(3134),
    [anon_sym_sizeof] = ACTIONS(3132),
    [anon_sym___alignof__] = ACTIONS(3132),
    [anon_sym___alignof] = ACTIONS(3132),
    [anon_sym__alignof] = ACTIONS(3132),
    [anon_sym_alignof] = ACTIONS(3132),
    [anon_sym__Alignof] = ACTIONS(3132),
    [anon_sym_offsetof] = ACTIONS(3132),
    [anon_sym__Generic] = ACTIONS(3132),
    [anon_sym_asm] = ACTIONS(3132),
    [anon_sym___asm__] = ACTIONS(3132),
    [aux_sym_number_literal_token1] = ACTIONS(3134),
    [aux_sym_number_literal_token2] = ACTIONS(3132),
    [anon_sym_L_SQUOTE] = ACTIONS(3134),
    [anon_sym_u_SQUOTE] = ACTIONS(3134),
    [anon_sym_U_SQUOTE] = ACTIONS(3134),
    [anon_sym_u8_SQUOTE] = ACTIONS(3134),
    [anon_sym_SQUOTE] = ACTIONS(3134),
    [anon_sym_L_DQUOTE] = ACTIONS(3134),
    [anon_sym_u_DQUOTE] = ACTIONS(3134),
    [anon_sym_U_DQUOTE] = ACTIONS(3134),
    [anon_sym_u8_DQUOTE] = ACTIONS(3134),
    [anon_sym_DQUOTE] = ACTIONS(3134),
    [sym_true] = ACTIONS(3132),
    [sym_false] = ACTIONS(3132),
    [anon_sym_NULL] = ACTIONS(3132),
    [anon_sym_nullptr] = ACTIONS(3132),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3132),
    [anon_sym_decltype] = ACTIONS(3132),
    [anon_sym_virtual] = ACTIONS(3132),
    [anon_sym_alignas] = ACTIONS(3132),
    [anon_sym_explicit] = ACTIONS(3132),
    [anon_sym_typename] = ACTIONS(3132),
    [anon_sym_template] = ACTIONS(3132),
    [anon_sym_operator] = ACTIONS(3132),
    [anon_sym_try] = ACTIONS(3132),
    [anon_sym_delete] = ACTIONS(3132),
    [anon_sym_throw] = ACTIONS(3132),
    [anon_sym_namespace] = ACTIONS(3132),
    [anon_sym_using] = ACTIONS(3132),
    [anon_sym_static_assert] = ACTIONS(3132),
    [anon_sym_concept] = ACTIONS(3132),
    [anon_sym_co_return] = ACTIONS(3132),
    [anon_sym_co_yield] = ACTIONS(3132),
    [anon_sym_R_DQUOTE] = ACTIONS(3134),
    [anon_sym_LR_DQUOTE] = ACTIONS(3134),
    [anon_sym_uR_DQUOTE] = ACTIONS(3134),
    [anon_sym_UR_DQUOTE] = ACTIONS(3134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3134),
    [anon_sym_co_await] = ACTIONS(3132),
    [anon_sym_new] = ACTIONS(3132),
    [anon_sym_requires] = ACTIONS(3132),
    [sym_this] = ACTIONS(3132),
  },
  [408] = {
    [sym_identifier] = ACTIONS(3136),
    [aux_sym_preproc_include_token1] = ACTIONS(3136),
    [aux_sym_preproc_def_token1] = ACTIONS(3136),
    [aux_sym_preproc_if_token1] = ACTIONS(3136),
    [aux_sym_preproc_if_token2] = ACTIONS(3136),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3136),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3136),
    [aux_sym_preproc_else_token1] = ACTIONS(3136),
    [aux_sym_preproc_elif_token1] = ACTIONS(3136),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3136),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3136),
    [sym_preproc_directive] = ACTIONS(3136),
    [anon_sym_LPAREN2] = ACTIONS(3138),
    [anon_sym_BANG] = ACTIONS(3138),
    [anon_sym_TILDE] = ACTIONS(3138),
    [anon_sym_DASH] = ACTIONS(3136),
    [anon_sym_PLUS] = ACTIONS(3136),
    [anon_sym_STAR] = ACTIONS(3138),
    [anon_sym_AMP_AMP] = ACTIONS(3138),
    [anon_sym_AMP] = ACTIONS(3136),
    [anon_sym_SEMI] = ACTIONS(3138),
    [anon_sym___extension__] = ACTIONS(3136),
    [anon_sym_typedef] = ACTIONS(3136),
    [anon_sym_extern] = ACTIONS(3136),
    [anon_sym___attribute__] = ACTIONS(3136),
    [anon_sym_COLON_COLON] = ACTIONS(3138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3138),
    [anon_sym___declspec] = ACTIONS(3136),
    [anon_sym___based] = ACTIONS(3136),
    [anon_sym___cdecl] = ACTIONS(3136),
    [anon_sym___clrcall] = ACTIONS(3136),
    [anon_sym___stdcall] = ACTIONS(3136),
    [anon_sym___fastcall] = ACTIONS(3136),
    [anon_sym___thiscall] = ACTIONS(3136),
    [anon_sym___vectorcall] = ACTIONS(3136),
    [anon_sym_LBRACE] = ACTIONS(3138),
    [anon_sym_signed] = ACTIONS(3136),
    [anon_sym_unsigned] = ACTIONS(3136),
    [anon_sym_long] = ACTIONS(3136),
    [anon_sym_short] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3136),
    [anon_sym_static] = ACTIONS(3136),
    [anon_sym_register] = ACTIONS(3136),
    [anon_sym_inline] = ACTIONS(3136),
    [anon_sym___inline] = ACTIONS(3136),
    [anon_sym___inline__] = ACTIONS(3136),
    [anon_sym___forceinline] = ACTIONS(3136),
    [anon_sym_thread_local] = ACTIONS(3136),
    [anon_sym___thread] = ACTIONS(3136),
    [anon_sym_const] = ACTIONS(3136),
    [anon_sym_constexpr] = ACTIONS(3136),
    [anon_sym_volatile] = ACTIONS(3136),
    [anon_sym_restrict] = ACTIONS(3136),
    [anon_sym___restrict__] = ACTIONS(3136),
    [anon_sym__Atomic] = ACTIONS(3136),
    [anon_sym__Noreturn] = ACTIONS(3136),
    [anon_sym_noreturn] = ACTIONS(3136),
    [anon_sym_mutable] = ACTIONS(3136),
    [anon_sym_constinit] = ACTIONS(3136),
    [anon_sym_consteval] = ACTIONS(3136),
    [anon_sym_PROGMEM] = ACTIONS(3136),
    [aux_sym_primitive_type_token1] = ACTIONS(3136),
    [anon_sym_byte] = ACTIONS(3136),
    [anon_sym_word] = ACTIONS(3136),
    [anon_sym_enum] = ACTIONS(3136),
    [anon_sym_class] = ACTIONS(3136),
    [anon_sym_struct] = ACTIONS(3136),
    [anon_sym_union] = ACTIONS(3136),
    [anon_sym_if] = ACTIONS(3136),
    [anon_sym_switch] = ACTIONS(3136),
    [anon_sym_case] = ACTIONS(3136),
    [anon_sym_default] = ACTIONS(3136),
    [anon_sym_while] = ACTIONS(3136),
    [anon_sym_do] = ACTIONS(3136),
    [anon_sym_for] = ACTIONS(3136),
    [anon_sym_return] = ACTIONS(3136),
    [anon_sym_break] = ACTIONS(3136),
    [anon_sym_continue] = ACTIONS(3136),
    [anon_sym_goto] = ACTIONS(3136),
    [anon_sym___try] = ACTIONS(3136),
    [anon_sym___leave] = ACTIONS(3136),
    [anon_sym_not] = ACTIONS(3136),
    [anon_sym_compl] = ACTIONS(3136),
    [anon_sym_DASH_DASH] = ACTIONS(3138),
    [anon_sym_PLUS_PLUS] = ACTIONS(3138),
    [anon_sym_sizeof] = ACTIONS(3136),
    [anon_sym___alignof__] = ACTIONS(3136),
    [anon_sym___alignof] = ACTIONS(3136),
    [anon_sym__alignof] = ACTIONS(3136),
    [anon_sym_alignof] = ACTIONS(3136),
    [anon_sym__Alignof] = ACTIONS(3136),
    [anon_sym_offsetof] = ACTIONS(3136),
    [anon_sym__Generic] = ACTIONS(3136),
    [anon_sym_asm] = ACTIONS(3136),
    [anon_sym___asm__] = ACTIONS(3136),
    [aux_sym_number_literal_token1] = ACTIONS(3138),
    [aux_sym_number_literal_token2] = ACTIONS(3136),
    [anon_sym_L_SQUOTE] = ACTIONS(3138),
    [anon_sym_u_SQUOTE] = ACTIONS(3138),
    [anon_sym_U_SQUOTE] = ACTIONS(3138),
    [anon_sym_u8_SQUOTE] = ACTIONS(3138),
    [anon_sym_SQUOTE] = ACTIONS(3138),
    [anon_sym_L_DQUOTE] = ACTIONS(3138),
    [anon_sym_u_DQUOTE] = ACTIONS(3138),
    [anon_sym_U_DQUOTE] = ACTIONS(3138),
    [anon_sym_u8_DQUOTE] = ACTIONS(3138),
    [anon_sym_DQUOTE] = ACTIONS(3138),
    [sym_true] = ACTIONS(3136),
    [sym_false] = ACTIONS(3136),
    [anon_sym_NULL] = ACTIONS(3136),
    [anon_sym_nullptr] = ACTIONS(3136),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3136),
    [anon_sym_decltype] = ACTIONS(3136),
    [anon_sym_virtual] = ACTIONS(3136),
    [anon_sym_alignas] = ACTIONS(3136),
    [anon_sym_explicit] = ACTIONS(3136),
    [anon_sym_typename] = ACTIONS(3136),
    [anon_sym_template] = ACTIONS(3136),
    [anon_sym_operator] = ACTIONS(3136),
    [anon_sym_try] = ACTIONS(3136),
    [anon_sym_delete] = ACTIONS(3136),
    [anon_sym_throw] = ACTIONS(3136),
    [anon_sym_namespace] = ACTIONS(3136),
    [anon_sym_using] = ACTIONS(3136),
    [anon_sym_static_assert] = ACTIONS(3136),
    [anon_sym_concept] = ACTIONS(3136),
    [anon_sym_co_return] = ACTIONS(3136),
    [anon_sym_co_yield] = ACTIONS(3136),
    [anon_sym_R_DQUOTE] = ACTIONS(3138),
    [anon_sym_LR_DQUOTE] = ACTIONS(3138),
    [anon_sym_uR_DQUOTE] = ACTIONS(3138),
    [anon_sym_UR_DQUOTE] = ACTIONS(3138),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3138),
    [anon_sym_co_await] = ACTIONS(3136),
    [anon_sym_new] = ACTIONS(3136),
    [anon_sym_requires] = ACTIONS(3136),
    [sym_this] = ACTIONS(3136),
  },
  [409] = {
    [sym_preproc_def] = STATE(541),
    [sym_preproc_function_def] = STATE(541),
    [sym_preproc_call] = STATE(541),
    [sym_preproc_if_in_field_declaration_list] = STATE(541),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(541),
    [sym_preproc_else_in_field_declaration_list] = STATE(7845),
    [sym_preproc_elif_in_field_declaration_list] = STATE(7845),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(7845),
    [sym_type_definition] = STATE(541),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(5531),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(3150),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(5962),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym__field_declaration_list_item] = STATE(541),
    [sym_field_declaration] = STATE(541),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1838),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(541),
    [sym_operator_cast] = STATE(6510),
    [sym_inline_method_definition] = STATE(541),
    [sym__constructor_specifiers] = STATE(1838),
    [sym_operator_cast_definition] = STATE(541),
    [sym_operator_cast_declaration] = STATE(541),
    [sym_constructor_or_destructor_definition] = STATE(541),
    [sym_constructor_or_destructor_declaration] = STATE(541),
    [sym_friend_declaration] = STATE(541),
    [sym_access_specifier] = STATE(7787),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(2618),
    [sym_template_function] = STATE(6098),
    [sym_using_declaration] = STATE(541),
    [sym_alias_declaration] = STATE(541),
    [sym_static_assert_declaration] = STATE(541),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5301),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_qualified_operator_cast_identifier] = STATE(6510),
    [sym_operator_name] = STATE(6098),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(541),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1961),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1838),
    [sym_identifier] = ACTIONS(2823),
    [aux_sym_preproc_def_token1] = ACTIONS(2825),
    [aux_sym_preproc_if_token1] = ACTIONS(2827),
    [aux_sym_preproc_if_token2] = ACTIONS(3140),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2831),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2831),
    [aux_sym_preproc_else_token1] = ACTIONS(2833),
    [aux_sym_preproc_elif_token1] = ACTIONS(2835),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2837),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2837),
    [sym_preproc_directive] = ACTIONS(2839),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(2849),
    [anon_sym_typedef] = ACTIONS(2851),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(2853),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2857),
    [anon_sym_class] = ACTIONS(2859),
    [anon_sym_struct] = ACTIONS(2861),
    [anon_sym_union] = ACTIONS(2863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(2865),
    [anon_sym_template] = ACTIONS(2867),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(2869),
    [anon_sym_public] = ACTIONS(2871),
    [anon_sym_private] = ACTIONS(2871),
    [anon_sym_protected] = ACTIONS(2871),
    [anon_sym_using] = ACTIONS(2873),
    [anon_sym_static_assert] = ACTIONS(2875),
  },
  [410] = {
    [sym_preproc_def] = STATE(400),
    [sym_preproc_function_def] = STATE(400),
    [sym_preproc_call] = STATE(400),
    [sym_preproc_if_in_field_declaration_list] = STATE(400),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(400),
    [sym_preproc_else_in_field_declaration_list] = STATE(8100),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8100),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8100),
    [sym_type_definition] = STATE(400),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(5531),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(3150),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(5962),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym__field_declaration_list_item] = STATE(400),
    [sym_field_declaration] = STATE(400),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1838),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(400),
    [sym_operator_cast] = STATE(6510),
    [sym_inline_method_definition] = STATE(400),
    [sym__constructor_specifiers] = STATE(1838),
    [sym_operator_cast_definition] = STATE(400),
    [sym_operator_cast_declaration] = STATE(400),
    [sym_constructor_or_destructor_definition] = STATE(400),
    [sym_constructor_or_destructor_declaration] = STATE(400),
    [sym_friend_declaration] = STATE(400),
    [sym_access_specifier] = STATE(7787),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(2618),
    [sym_template_function] = STATE(6098),
    [sym_using_declaration] = STATE(400),
    [sym_alias_declaration] = STATE(400),
    [sym_static_assert_declaration] = STATE(400),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5301),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_qualified_operator_cast_identifier] = STATE(6510),
    [sym_operator_name] = STATE(6098),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(400),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1961),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1838),
    [sym_identifier] = ACTIONS(2823),
    [aux_sym_preproc_def_token1] = ACTIONS(2825),
    [aux_sym_preproc_if_token1] = ACTIONS(2827),
    [aux_sym_preproc_if_token2] = ACTIONS(3142),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2831),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2831),
    [aux_sym_preproc_else_token1] = ACTIONS(2833),
    [aux_sym_preproc_elif_token1] = ACTIONS(2835),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2837),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2837),
    [sym_preproc_directive] = ACTIONS(2839),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(2849),
    [anon_sym_typedef] = ACTIONS(2851),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(2853),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2857),
    [anon_sym_class] = ACTIONS(2859),
    [anon_sym_struct] = ACTIONS(2861),
    [anon_sym_union] = ACTIONS(2863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(2865),
    [anon_sym_template] = ACTIONS(2867),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(2869),
    [anon_sym_public] = ACTIONS(2871),
    [anon_sym_private] = ACTIONS(2871),
    [anon_sym_protected] = ACTIONS(2871),
    [anon_sym_using] = ACTIONS(2873),
    [anon_sym_static_assert] = ACTIONS(2875),
  },
  [411] = {
    [sym_identifier] = ACTIONS(3144),
    [aux_sym_preproc_include_token1] = ACTIONS(3144),
    [aux_sym_preproc_def_token1] = ACTIONS(3144),
    [aux_sym_preproc_if_token1] = ACTIONS(3144),
    [aux_sym_preproc_if_token2] = ACTIONS(3144),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3144),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3144),
    [aux_sym_preproc_else_token1] = ACTIONS(3144),
    [aux_sym_preproc_elif_token1] = ACTIONS(3144),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3144),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3144),
    [sym_preproc_directive] = ACTIONS(3144),
    [anon_sym_LPAREN2] = ACTIONS(3146),
    [anon_sym_BANG] = ACTIONS(3146),
    [anon_sym_TILDE] = ACTIONS(3146),
    [anon_sym_DASH] = ACTIONS(3144),
    [anon_sym_PLUS] = ACTIONS(3144),
    [anon_sym_STAR] = ACTIONS(3146),
    [anon_sym_AMP_AMP] = ACTIONS(3146),
    [anon_sym_AMP] = ACTIONS(3144),
    [anon_sym_SEMI] = ACTIONS(3146),
    [anon_sym___extension__] = ACTIONS(3144),
    [anon_sym_typedef] = ACTIONS(3144),
    [anon_sym_extern] = ACTIONS(3144),
    [anon_sym___attribute__] = ACTIONS(3144),
    [anon_sym_COLON_COLON] = ACTIONS(3146),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3146),
    [anon_sym___declspec] = ACTIONS(3144),
    [anon_sym___based] = ACTIONS(3144),
    [anon_sym___cdecl] = ACTIONS(3144),
    [anon_sym___clrcall] = ACTIONS(3144),
    [anon_sym___stdcall] = ACTIONS(3144),
    [anon_sym___fastcall] = ACTIONS(3144),
    [anon_sym___thiscall] = ACTIONS(3144),
    [anon_sym___vectorcall] = ACTIONS(3144),
    [anon_sym_LBRACE] = ACTIONS(3146),
    [anon_sym_signed] = ACTIONS(3144),
    [anon_sym_unsigned] = ACTIONS(3144),
    [anon_sym_long] = ACTIONS(3144),
    [anon_sym_short] = ACTIONS(3144),
    [anon_sym_LBRACK] = ACTIONS(3144),
    [anon_sym_static] = ACTIONS(3144),
    [anon_sym_register] = ACTIONS(3144),
    [anon_sym_inline] = ACTIONS(3144),
    [anon_sym___inline] = ACTIONS(3144),
    [anon_sym___inline__] = ACTIONS(3144),
    [anon_sym___forceinline] = ACTIONS(3144),
    [anon_sym_thread_local] = ACTIONS(3144),
    [anon_sym___thread] = ACTIONS(3144),
    [anon_sym_const] = ACTIONS(3144),
    [anon_sym_constexpr] = ACTIONS(3144),
    [anon_sym_volatile] = ACTIONS(3144),
    [anon_sym_restrict] = ACTIONS(3144),
    [anon_sym___restrict__] = ACTIONS(3144),
    [anon_sym__Atomic] = ACTIONS(3144),
    [anon_sym__Noreturn] = ACTIONS(3144),
    [anon_sym_noreturn] = ACTIONS(3144),
    [anon_sym_mutable] = ACTIONS(3144),
    [anon_sym_constinit] = ACTIONS(3144),
    [anon_sym_consteval] = ACTIONS(3144),
    [anon_sym_PROGMEM] = ACTIONS(3144),
    [aux_sym_primitive_type_token1] = ACTIONS(3144),
    [anon_sym_byte] = ACTIONS(3144),
    [anon_sym_word] = ACTIONS(3144),
    [anon_sym_enum] = ACTIONS(3144),
    [anon_sym_class] = ACTIONS(3144),
    [anon_sym_struct] = ACTIONS(3144),
    [anon_sym_union] = ACTIONS(3144),
    [anon_sym_if] = ACTIONS(3144),
    [anon_sym_switch] = ACTIONS(3144),
    [anon_sym_case] = ACTIONS(3144),
    [anon_sym_default] = ACTIONS(3144),
    [anon_sym_while] = ACTIONS(3144),
    [anon_sym_do] = ACTIONS(3144),
    [anon_sym_for] = ACTIONS(3144),
    [anon_sym_return] = ACTIONS(3144),
    [anon_sym_break] = ACTIONS(3144),
    [anon_sym_continue] = ACTIONS(3144),
    [anon_sym_goto] = ACTIONS(3144),
    [anon_sym___try] = ACTIONS(3144),
    [anon_sym___leave] = ACTIONS(3144),
    [anon_sym_not] = ACTIONS(3144),
    [anon_sym_compl] = ACTIONS(3144),
    [anon_sym_DASH_DASH] = ACTIONS(3146),
    [anon_sym_PLUS_PLUS] = ACTIONS(3146),
    [anon_sym_sizeof] = ACTIONS(3144),
    [anon_sym___alignof__] = ACTIONS(3144),
    [anon_sym___alignof] = ACTIONS(3144),
    [anon_sym__alignof] = ACTIONS(3144),
    [anon_sym_alignof] = ACTIONS(3144),
    [anon_sym__Alignof] = ACTIONS(3144),
    [anon_sym_offsetof] = ACTIONS(3144),
    [anon_sym__Generic] = ACTIONS(3144),
    [anon_sym_asm] = ACTIONS(3144),
    [anon_sym___asm__] = ACTIONS(3144),
    [aux_sym_number_literal_token1] = ACTIONS(3146),
    [aux_sym_number_literal_token2] = ACTIONS(3144),
    [anon_sym_L_SQUOTE] = ACTIONS(3146),
    [anon_sym_u_SQUOTE] = ACTIONS(3146),
    [anon_sym_U_SQUOTE] = ACTIONS(3146),
    [anon_sym_u8_SQUOTE] = ACTIONS(3146),
    [anon_sym_SQUOTE] = ACTIONS(3146),
    [anon_sym_L_DQUOTE] = ACTIONS(3146),
    [anon_sym_u_DQUOTE] = ACTIONS(3146),
    [anon_sym_U_DQUOTE] = ACTIONS(3146),
    [anon_sym_u8_DQUOTE] = ACTIONS(3146),
    [anon_sym_DQUOTE] = ACTIONS(3146),
    [sym_true] = ACTIONS(3144),
    [sym_false] = ACTIONS(3144),
    [anon_sym_NULL] = ACTIONS(3144),
    [anon_sym_nullptr] = ACTIONS(3144),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3144),
    [anon_sym_decltype] = ACTIONS(3144),
    [anon_sym_virtual] = ACTIONS(3144),
    [anon_sym_alignas] = ACTIONS(3144),
    [anon_sym_explicit] = ACTIONS(3144),
    [anon_sym_typename] = ACTIONS(3144),
    [anon_sym_template] = ACTIONS(3144),
    [anon_sym_operator] = ACTIONS(3144),
    [anon_sym_try] = ACTIONS(3144),
    [anon_sym_delete] = ACTIONS(3144),
    [anon_sym_throw] = ACTIONS(3144),
    [anon_sym_namespace] = ACTIONS(3144),
    [anon_sym_using] = ACTIONS(3144),
    [anon_sym_static_assert] = ACTIONS(3144),
    [anon_sym_concept] = ACTIONS(3144),
    [anon_sym_co_return] = ACTIONS(3144),
    [anon_sym_co_yield] = ACTIONS(3144),
    [anon_sym_R_DQUOTE] = ACTIONS(3146),
    [anon_sym_LR_DQUOTE] = ACTIONS(3146),
    [anon_sym_uR_DQUOTE] = ACTIONS(3146),
    [anon_sym_UR_DQUOTE] = ACTIONS(3146),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3146),
    [anon_sym_co_await] = ACTIONS(3144),
    [anon_sym_new] = ACTIONS(3144),
    [anon_sym_requires] = ACTIONS(3144),
    [sym_this] = ACTIONS(3144),
  },
  [412] = {
    [sym_identifier] = ACTIONS(3148),
    [aux_sym_preproc_include_token1] = ACTIONS(3148),
    [aux_sym_preproc_def_token1] = ACTIONS(3148),
    [aux_sym_preproc_if_token1] = ACTIONS(3148),
    [aux_sym_preproc_if_token2] = ACTIONS(3148),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3148),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3148),
    [aux_sym_preproc_else_token1] = ACTIONS(3148),
    [aux_sym_preproc_elif_token1] = ACTIONS(3148),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3148),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3148),
    [sym_preproc_directive] = ACTIONS(3148),
    [anon_sym_LPAREN2] = ACTIONS(3150),
    [anon_sym_BANG] = ACTIONS(3150),
    [anon_sym_TILDE] = ACTIONS(3150),
    [anon_sym_DASH] = ACTIONS(3148),
    [anon_sym_PLUS] = ACTIONS(3148),
    [anon_sym_STAR] = ACTIONS(3150),
    [anon_sym_AMP_AMP] = ACTIONS(3150),
    [anon_sym_AMP] = ACTIONS(3148),
    [anon_sym_SEMI] = ACTIONS(3150),
    [anon_sym___extension__] = ACTIONS(3148),
    [anon_sym_typedef] = ACTIONS(3148),
    [anon_sym_extern] = ACTIONS(3148),
    [anon_sym___attribute__] = ACTIONS(3148),
    [anon_sym_COLON_COLON] = ACTIONS(3150),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3150),
    [anon_sym___declspec] = ACTIONS(3148),
    [anon_sym___based] = ACTIONS(3148),
    [anon_sym___cdecl] = ACTIONS(3148),
    [anon_sym___clrcall] = ACTIONS(3148),
    [anon_sym___stdcall] = ACTIONS(3148),
    [anon_sym___fastcall] = ACTIONS(3148),
    [anon_sym___thiscall] = ACTIONS(3148),
    [anon_sym___vectorcall] = ACTIONS(3148),
    [anon_sym_LBRACE] = ACTIONS(3150),
    [anon_sym_signed] = ACTIONS(3148),
    [anon_sym_unsigned] = ACTIONS(3148),
    [anon_sym_long] = ACTIONS(3148),
    [anon_sym_short] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_static] = ACTIONS(3148),
    [anon_sym_register] = ACTIONS(3148),
    [anon_sym_inline] = ACTIONS(3148),
    [anon_sym___inline] = ACTIONS(3148),
    [anon_sym___inline__] = ACTIONS(3148),
    [anon_sym___forceinline] = ACTIONS(3148),
    [anon_sym_thread_local] = ACTIONS(3148),
    [anon_sym___thread] = ACTIONS(3148),
    [anon_sym_const] = ACTIONS(3148),
    [anon_sym_constexpr] = ACTIONS(3148),
    [anon_sym_volatile] = ACTIONS(3148),
    [anon_sym_restrict] = ACTIONS(3148),
    [anon_sym___restrict__] = ACTIONS(3148),
    [anon_sym__Atomic] = ACTIONS(3148),
    [anon_sym__Noreturn] = ACTIONS(3148),
    [anon_sym_noreturn] = ACTIONS(3148),
    [anon_sym_mutable] = ACTIONS(3148),
    [anon_sym_constinit] = ACTIONS(3148),
    [anon_sym_consteval] = ACTIONS(3148),
    [anon_sym_PROGMEM] = ACTIONS(3148),
    [aux_sym_primitive_type_token1] = ACTIONS(3148),
    [anon_sym_byte] = ACTIONS(3148),
    [anon_sym_word] = ACTIONS(3148),
    [anon_sym_enum] = ACTIONS(3148),
    [anon_sym_class] = ACTIONS(3148),
    [anon_sym_struct] = ACTIONS(3148),
    [anon_sym_union] = ACTIONS(3148),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_switch] = ACTIONS(3148),
    [anon_sym_case] = ACTIONS(3148),
    [anon_sym_default] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_for] = ACTIONS(3148),
    [anon_sym_return] = ACTIONS(3148),
    [anon_sym_break] = ACTIONS(3148),
    [anon_sym_continue] = ACTIONS(3148),
    [anon_sym_goto] = ACTIONS(3148),
    [anon_sym___try] = ACTIONS(3148),
    [anon_sym___leave] = ACTIONS(3148),
    [anon_sym_not] = ACTIONS(3148),
    [anon_sym_compl] = ACTIONS(3148),
    [anon_sym_DASH_DASH] = ACTIONS(3150),
    [anon_sym_PLUS_PLUS] = ACTIONS(3150),
    [anon_sym_sizeof] = ACTIONS(3148),
    [anon_sym___alignof__] = ACTIONS(3148),
    [anon_sym___alignof] = ACTIONS(3148),
    [anon_sym__alignof] = ACTIONS(3148),
    [anon_sym_alignof] = ACTIONS(3148),
    [anon_sym__Alignof] = ACTIONS(3148),
    [anon_sym_offsetof] = ACTIONS(3148),
    [anon_sym__Generic] = ACTIONS(3148),
    [anon_sym_asm] = ACTIONS(3148),
    [anon_sym___asm__] = ACTIONS(3148),
    [aux_sym_number_literal_token1] = ACTIONS(3150),
    [aux_sym_number_literal_token2] = ACTIONS(3148),
    [anon_sym_L_SQUOTE] = ACTIONS(3150),
    [anon_sym_u_SQUOTE] = ACTIONS(3150),
    [anon_sym_U_SQUOTE] = ACTIONS(3150),
    [anon_sym_u8_SQUOTE] = ACTIONS(3150),
    [anon_sym_SQUOTE] = ACTIONS(3150),
    [anon_sym_L_DQUOTE] = ACTIONS(3150),
    [anon_sym_u_DQUOTE] = ACTIONS(3150),
    [anon_sym_U_DQUOTE] = ACTIONS(3150),
    [anon_sym_u8_DQUOTE] = ACTIONS(3150),
    [anon_sym_DQUOTE] = ACTIONS(3150),
    [sym_true] = ACTIONS(3148),
    [sym_false] = ACTIONS(3148),
    [anon_sym_NULL] = ACTIONS(3148),
    [anon_sym_nullptr] = ACTIONS(3148),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3148),
    [anon_sym_decltype] = ACTIONS(3148),
    [anon_sym_virtual] = ACTIONS(3148),
    [anon_sym_alignas] = ACTIONS(3148),
    [anon_sym_explicit] = ACTIONS(3148),
    [anon_sym_typename] = ACTIONS(3148),
    [anon_sym_template] = ACTIONS(3148),
    [anon_sym_operator] = ACTIONS(3148),
    [anon_sym_try] = ACTIONS(3148),
    [anon_sym_delete] = ACTIONS(3148),
    [anon_sym_throw] = ACTIONS(3148),
    [anon_sym_namespace] = ACTIONS(3148),
    [anon_sym_using] = ACTIONS(3148),
    [anon_sym_static_assert] = ACTIONS(3148),
    [anon_sym_concept] = ACTIONS(3148),
    [anon_sym_co_return] = ACTIONS(3148),
    [anon_sym_co_yield] = ACTIONS(3148),
    [anon_sym_R_DQUOTE] = ACTIONS(3150),
    [anon_sym_LR_DQUOTE] = ACTIONS(3150),
    [anon_sym_uR_DQUOTE] = ACTIONS(3150),
    [anon_sym_UR_DQUOTE] = ACTIONS(3150),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3150),
    [anon_sym_co_await] = ACTIONS(3148),
    [anon_sym_new] = ACTIONS(3148),
    [anon_sym_requires] = ACTIONS(3148),
    [sym_this] = ACTIONS(3148),
  },
  [413] = {
    [sym_identifier] = ACTIONS(3152),
    [aux_sym_preproc_include_token1] = ACTIONS(3152),
    [aux_sym_preproc_def_token1] = ACTIONS(3152),
    [aux_sym_preproc_if_token1] = ACTIONS(3152),
    [aux_sym_preproc_if_token2] = ACTIONS(3152),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3152),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3152),
    [aux_sym_preproc_else_token1] = ACTIONS(3152),
    [aux_sym_preproc_elif_token1] = ACTIONS(3152),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3152),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3152),
    [sym_preproc_directive] = ACTIONS(3152),
    [anon_sym_LPAREN2] = ACTIONS(3154),
    [anon_sym_BANG] = ACTIONS(3154),
    [anon_sym_TILDE] = ACTIONS(3154),
    [anon_sym_DASH] = ACTIONS(3152),
    [anon_sym_PLUS] = ACTIONS(3152),
    [anon_sym_STAR] = ACTIONS(3154),
    [anon_sym_AMP_AMP] = ACTIONS(3154),
    [anon_sym_AMP] = ACTIONS(3152),
    [anon_sym_SEMI] = ACTIONS(3154),
    [anon_sym___extension__] = ACTIONS(3152),
    [anon_sym_typedef] = ACTIONS(3152),
    [anon_sym_extern] = ACTIONS(3152),
    [anon_sym___attribute__] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3154),
    [anon_sym___declspec] = ACTIONS(3152),
    [anon_sym___based] = ACTIONS(3152),
    [anon_sym___cdecl] = ACTIONS(3152),
    [anon_sym___clrcall] = ACTIONS(3152),
    [anon_sym___stdcall] = ACTIONS(3152),
    [anon_sym___fastcall] = ACTIONS(3152),
    [anon_sym___thiscall] = ACTIONS(3152),
    [anon_sym___vectorcall] = ACTIONS(3152),
    [anon_sym_LBRACE] = ACTIONS(3154),
    [anon_sym_signed] = ACTIONS(3152),
    [anon_sym_unsigned] = ACTIONS(3152),
    [anon_sym_long] = ACTIONS(3152),
    [anon_sym_short] = ACTIONS(3152),
    [anon_sym_LBRACK] = ACTIONS(3152),
    [anon_sym_static] = ACTIONS(3152),
    [anon_sym_register] = ACTIONS(3152),
    [anon_sym_inline] = ACTIONS(3152),
    [anon_sym___inline] = ACTIONS(3152),
    [anon_sym___inline__] = ACTIONS(3152),
    [anon_sym___forceinline] = ACTIONS(3152),
    [anon_sym_thread_local] = ACTIONS(3152),
    [anon_sym___thread] = ACTIONS(3152),
    [anon_sym_const] = ACTIONS(3152),
    [anon_sym_constexpr] = ACTIONS(3152),
    [anon_sym_volatile] = ACTIONS(3152),
    [anon_sym_restrict] = ACTIONS(3152),
    [anon_sym___restrict__] = ACTIONS(3152),
    [anon_sym__Atomic] = ACTIONS(3152),
    [anon_sym__Noreturn] = ACTIONS(3152),
    [anon_sym_noreturn] = ACTIONS(3152),
    [anon_sym_mutable] = ACTIONS(3152),
    [anon_sym_constinit] = ACTIONS(3152),
    [anon_sym_consteval] = ACTIONS(3152),
    [anon_sym_PROGMEM] = ACTIONS(3152),
    [aux_sym_primitive_type_token1] = ACTIONS(3152),
    [anon_sym_byte] = ACTIONS(3152),
    [anon_sym_word] = ACTIONS(3152),
    [anon_sym_enum] = ACTIONS(3152),
    [anon_sym_class] = ACTIONS(3152),
    [anon_sym_struct] = ACTIONS(3152),
    [anon_sym_union] = ACTIONS(3152),
    [anon_sym_if] = ACTIONS(3152),
    [anon_sym_switch] = ACTIONS(3152),
    [anon_sym_case] = ACTIONS(3152),
    [anon_sym_default] = ACTIONS(3152),
    [anon_sym_while] = ACTIONS(3152),
    [anon_sym_do] = ACTIONS(3152),
    [anon_sym_for] = ACTIONS(3152),
    [anon_sym_return] = ACTIONS(3152),
    [anon_sym_break] = ACTIONS(3152),
    [anon_sym_continue] = ACTIONS(3152),
    [anon_sym_goto] = ACTIONS(3152),
    [anon_sym___try] = ACTIONS(3152),
    [anon_sym___leave] = ACTIONS(3152),
    [anon_sym_not] = ACTIONS(3152),
    [anon_sym_compl] = ACTIONS(3152),
    [anon_sym_DASH_DASH] = ACTIONS(3154),
    [anon_sym_PLUS_PLUS] = ACTIONS(3154),
    [anon_sym_sizeof] = ACTIONS(3152),
    [anon_sym___alignof__] = ACTIONS(3152),
    [anon_sym___alignof] = ACTIONS(3152),
    [anon_sym__alignof] = ACTIONS(3152),
    [anon_sym_alignof] = ACTIONS(3152),
    [anon_sym__Alignof] = ACTIONS(3152),
    [anon_sym_offsetof] = ACTIONS(3152),
    [anon_sym__Generic] = ACTIONS(3152),
    [anon_sym_asm] = ACTIONS(3152),
    [anon_sym___asm__] = ACTIONS(3152),
    [aux_sym_number_literal_token1] = ACTIONS(3154),
    [aux_sym_number_literal_token2] = ACTIONS(3152),
    [anon_sym_L_SQUOTE] = ACTIONS(3154),
    [anon_sym_u_SQUOTE] = ACTIONS(3154),
    [anon_sym_U_SQUOTE] = ACTIONS(3154),
    [anon_sym_u8_SQUOTE] = ACTIONS(3154),
    [anon_sym_SQUOTE] = ACTIONS(3154),
    [anon_sym_L_DQUOTE] = ACTIONS(3154),
    [anon_sym_u_DQUOTE] = ACTIONS(3154),
    [anon_sym_U_DQUOTE] = ACTIONS(3154),
    [anon_sym_u8_DQUOTE] = ACTIONS(3154),
    [anon_sym_DQUOTE] = ACTIONS(3154),
    [sym_true] = ACTIONS(3152),
    [sym_false] = ACTIONS(3152),
    [anon_sym_NULL] = ACTIONS(3152),
    [anon_sym_nullptr] = ACTIONS(3152),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3152),
    [anon_sym_decltype] = ACTIONS(3152),
    [anon_sym_virtual] = ACTIONS(3152),
    [anon_sym_alignas] = ACTIONS(3152),
    [anon_sym_explicit] = ACTIONS(3152),
    [anon_sym_typename] = ACTIONS(3152),
    [anon_sym_template] = ACTIONS(3152),
    [anon_sym_operator] = ACTIONS(3152),
    [anon_sym_try] = ACTIONS(3152),
    [anon_sym_delete] = ACTIONS(3152),
    [anon_sym_throw] = ACTIONS(3152),
    [anon_sym_namespace] = ACTIONS(3152),
    [anon_sym_using] = ACTIONS(3152),
    [anon_sym_static_assert] = ACTIONS(3152),
    [anon_sym_concept] = ACTIONS(3152),
    [anon_sym_co_return] = ACTIONS(3152),
    [anon_sym_co_yield] = ACTIONS(3152),
    [anon_sym_R_DQUOTE] = ACTIONS(3154),
    [anon_sym_LR_DQUOTE] = ACTIONS(3154),
    [anon_sym_uR_DQUOTE] = ACTIONS(3154),
    [anon_sym_UR_DQUOTE] = ACTIONS(3154),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3154),
    [anon_sym_co_await] = ACTIONS(3152),
    [anon_sym_new] = ACTIONS(3152),
    [anon_sym_requires] = ACTIONS(3152),
    [sym_this] = ACTIONS(3152),
  },
  [414] = {
    [sym_identifier] = ACTIONS(3156),
    [aux_sym_preproc_include_token1] = ACTIONS(3156),
    [aux_sym_preproc_def_token1] = ACTIONS(3156),
    [aux_sym_preproc_if_token1] = ACTIONS(3156),
    [aux_sym_preproc_if_token2] = ACTIONS(3156),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3156),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3156),
    [aux_sym_preproc_else_token1] = ACTIONS(3156),
    [aux_sym_preproc_elif_token1] = ACTIONS(3156),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3156),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3156),
    [sym_preproc_directive] = ACTIONS(3156),
    [anon_sym_LPAREN2] = ACTIONS(3158),
    [anon_sym_BANG] = ACTIONS(3158),
    [anon_sym_TILDE] = ACTIONS(3158),
    [anon_sym_DASH] = ACTIONS(3156),
    [anon_sym_PLUS] = ACTIONS(3156),
    [anon_sym_STAR] = ACTIONS(3158),
    [anon_sym_AMP_AMP] = ACTIONS(3158),
    [anon_sym_AMP] = ACTIONS(3156),
    [anon_sym_SEMI] = ACTIONS(3158),
    [anon_sym___extension__] = ACTIONS(3156),
    [anon_sym_typedef] = ACTIONS(3156),
    [anon_sym_extern] = ACTIONS(3156),
    [anon_sym___attribute__] = ACTIONS(3156),
    [anon_sym_COLON_COLON] = ACTIONS(3158),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3158),
    [anon_sym___declspec] = ACTIONS(3156),
    [anon_sym___based] = ACTIONS(3156),
    [anon_sym___cdecl] = ACTIONS(3156),
    [anon_sym___clrcall] = ACTIONS(3156),
    [anon_sym___stdcall] = ACTIONS(3156),
    [anon_sym___fastcall] = ACTIONS(3156),
    [anon_sym___thiscall] = ACTIONS(3156),
    [anon_sym___vectorcall] = ACTIONS(3156),
    [anon_sym_LBRACE] = ACTIONS(3158),
    [anon_sym_signed] = ACTIONS(3156),
    [anon_sym_unsigned] = ACTIONS(3156),
    [anon_sym_long] = ACTIONS(3156),
    [anon_sym_short] = ACTIONS(3156),
    [anon_sym_LBRACK] = ACTIONS(3156),
    [anon_sym_static] = ACTIONS(3156),
    [anon_sym_register] = ACTIONS(3156),
    [anon_sym_inline] = ACTIONS(3156),
    [anon_sym___inline] = ACTIONS(3156),
    [anon_sym___inline__] = ACTIONS(3156),
    [anon_sym___forceinline] = ACTIONS(3156),
    [anon_sym_thread_local] = ACTIONS(3156),
    [anon_sym___thread] = ACTIONS(3156),
    [anon_sym_const] = ACTIONS(3156),
    [anon_sym_constexpr] = ACTIONS(3156),
    [anon_sym_volatile] = ACTIONS(3156),
    [anon_sym_restrict] = ACTIONS(3156),
    [anon_sym___restrict__] = ACTIONS(3156),
    [anon_sym__Atomic] = ACTIONS(3156),
    [anon_sym__Noreturn] = ACTIONS(3156),
    [anon_sym_noreturn] = ACTIONS(3156),
    [anon_sym_mutable] = ACTIONS(3156),
    [anon_sym_constinit] = ACTIONS(3156),
    [anon_sym_consteval] = ACTIONS(3156),
    [anon_sym_PROGMEM] = ACTIONS(3156),
    [aux_sym_primitive_type_token1] = ACTIONS(3156),
    [anon_sym_byte] = ACTIONS(3156),
    [anon_sym_word] = ACTIONS(3156),
    [anon_sym_enum] = ACTIONS(3156),
    [anon_sym_class] = ACTIONS(3156),
    [anon_sym_struct] = ACTIONS(3156),
    [anon_sym_union] = ACTIONS(3156),
    [anon_sym_if] = ACTIONS(3156),
    [anon_sym_switch] = ACTIONS(3156),
    [anon_sym_case] = ACTIONS(3156),
    [anon_sym_default] = ACTIONS(3156),
    [anon_sym_while] = ACTIONS(3156),
    [anon_sym_do] = ACTIONS(3156),
    [anon_sym_for] = ACTIONS(3156),
    [anon_sym_return] = ACTIONS(3156),
    [anon_sym_break] = ACTIONS(3156),
    [anon_sym_continue] = ACTIONS(3156),
    [anon_sym_goto] = ACTIONS(3156),
    [anon_sym___try] = ACTIONS(3156),
    [anon_sym___leave] = ACTIONS(3156),
    [anon_sym_not] = ACTIONS(3156),
    [anon_sym_compl] = ACTIONS(3156),
    [anon_sym_DASH_DASH] = ACTIONS(3158),
    [anon_sym_PLUS_PLUS] = ACTIONS(3158),
    [anon_sym_sizeof] = ACTIONS(3156),
    [anon_sym___alignof__] = ACTIONS(3156),
    [anon_sym___alignof] = ACTIONS(3156),
    [anon_sym__alignof] = ACTIONS(3156),
    [anon_sym_alignof] = ACTIONS(3156),
    [anon_sym__Alignof] = ACTIONS(3156),
    [anon_sym_offsetof] = ACTIONS(3156),
    [anon_sym__Generic] = ACTIONS(3156),
    [anon_sym_asm] = ACTIONS(3156),
    [anon_sym___asm__] = ACTIONS(3156),
    [aux_sym_number_literal_token1] = ACTIONS(3158),
    [aux_sym_number_literal_token2] = ACTIONS(3156),
    [anon_sym_L_SQUOTE] = ACTIONS(3158),
    [anon_sym_u_SQUOTE] = ACTIONS(3158),
    [anon_sym_U_SQUOTE] = ACTIONS(3158),
    [anon_sym_u8_SQUOTE] = ACTIONS(3158),
    [anon_sym_SQUOTE] = ACTIONS(3158),
    [anon_sym_L_DQUOTE] = ACTIONS(3158),
    [anon_sym_u_DQUOTE] = ACTIONS(3158),
    [anon_sym_U_DQUOTE] = ACTIONS(3158),
    [anon_sym_u8_DQUOTE] = ACTIONS(3158),
    [anon_sym_DQUOTE] = ACTIONS(3158),
    [sym_true] = ACTIONS(3156),
    [sym_false] = ACTIONS(3156),
    [anon_sym_NULL] = ACTIONS(3156),
    [anon_sym_nullptr] = ACTIONS(3156),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3156),
    [anon_sym_decltype] = ACTIONS(3156),
    [anon_sym_virtual] = ACTIONS(3156),
    [anon_sym_alignas] = ACTIONS(3156),
    [anon_sym_explicit] = ACTIONS(3156),
    [anon_sym_typename] = ACTIONS(3156),
    [anon_sym_template] = ACTIONS(3156),
    [anon_sym_operator] = ACTIONS(3156),
    [anon_sym_try] = ACTIONS(3156),
    [anon_sym_delete] = ACTIONS(3156),
    [anon_sym_throw] = ACTIONS(3156),
    [anon_sym_namespace] = ACTIONS(3156),
    [anon_sym_using] = ACTIONS(3156),
    [anon_sym_static_assert] = ACTIONS(3156),
    [anon_sym_concept] = ACTIONS(3156),
    [anon_sym_co_return] = ACTIONS(3156),
    [anon_sym_co_yield] = ACTIONS(3156),
    [anon_sym_R_DQUOTE] = ACTIONS(3158),
    [anon_sym_LR_DQUOTE] = ACTIONS(3158),
    [anon_sym_uR_DQUOTE] = ACTIONS(3158),
    [anon_sym_UR_DQUOTE] = ACTIONS(3158),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3158),
    [anon_sym_co_await] = ACTIONS(3156),
    [anon_sym_new] = ACTIONS(3156),
    [anon_sym_requires] = ACTIONS(3156),
    [sym_this] = ACTIONS(3156),
  },
  [415] = {
    [sym_identifier] = ACTIONS(3160),
    [aux_sym_preproc_include_token1] = ACTIONS(3160),
    [aux_sym_preproc_def_token1] = ACTIONS(3160),
    [aux_sym_preproc_if_token1] = ACTIONS(3160),
    [aux_sym_preproc_if_token2] = ACTIONS(3160),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3160),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3160),
    [aux_sym_preproc_else_token1] = ACTIONS(3160),
    [aux_sym_preproc_elif_token1] = ACTIONS(3160),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3160),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3160),
    [sym_preproc_directive] = ACTIONS(3160),
    [anon_sym_LPAREN2] = ACTIONS(3162),
    [anon_sym_BANG] = ACTIONS(3162),
    [anon_sym_TILDE] = ACTIONS(3162),
    [anon_sym_DASH] = ACTIONS(3160),
    [anon_sym_PLUS] = ACTIONS(3160),
    [anon_sym_STAR] = ACTIONS(3162),
    [anon_sym_AMP_AMP] = ACTIONS(3162),
    [anon_sym_AMP] = ACTIONS(3160),
    [anon_sym_SEMI] = ACTIONS(3162),
    [anon_sym___extension__] = ACTIONS(3160),
    [anon_sym_typedef] = ACTIONS(3160),
    [anon_sym_extern] = ACTIONS(3160),
    [anon_sym___attribute__] = ACTIONS(3160),
    [anon_sym_COLON_COLON] = ACTIONS(3162),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3162),
    [anon_sym___declspec] = ACTIONS(3160),
    [anon_sym___based] = ACTIONS(3160),
    [anon_sym___cdecl] = ACTIONS(3160),
    [anon_sym___clrcall] = ACTIONS(3160),
    [anon_sym___stdcall] = ACTIONS(3160),
    [anon_sym___fastcall] = ACTIONS(3160),
    [anon_sym___thiscall] = ACTIONS(3160),
    [anon_sym___vectorcall] = ACTIONS(3160),
    [anon_sym_LBRACE] = ACTIONS(3162),
    [anon_sym_signed] = ACTIONS(3160),
    [anon_sym_unsigned] = ACTIONS(3160),
    [anon_sym_long] = ACTIONS(3160),
    [anon_sym_short] = ACTIONS(3160),
    [anon_sym_LBRACK] = ACTIONS(3160),
    [anon_sym_static] = ACTIONS(3160),
    [anon_sym_register] = ACTIONS(3160),
    [anon_sym_inline] = ACTIONS(3160),
    [anon_sym___inline] = ACTIONS(3160),
    [anon_sym___inline__] = ACTIONS(3160),
    [anon_sym___forceinline] = ACTIONS(3160),
    [anon_sym_thread_local] = ACTIONS(3160),
    [anon_sym___thread] = ACTIONS(3160),
    [anon_sym_const] = ACTIONS(3160),
    [anon_sym_constexpr] = ACTIONS(3160),
    [anon_sym_volatile] = ACTIONS(3160),
    [anon_sym_restrict] = ACTIONS(3160),
    [anon_sym___restrict__] = ACTIONS(3160),
    [anon_sym__Atomic] = ACTIONS(3160),
    [anon_sym__Noreturn] = ACTIONS(3160),
    [anon_sym_noreturn] = ACTIONS(3160),
    [anon_sym_mutable] = ACTIONS(3160),
    [anon_sym_constinit] = ACTIONS(3160),
    [anon_sym_consteval] = ACTIONS(3160),
    [anon_sym_PROGMEM] = ACTIONS(3160),
    [aux_sym_primitive_type_token1] = ACTIONS(3160),
    [anon_sym_byte] = ACTIONS(3160),
    [anon_sym_word] = ACTIONS(3160),
    [anon_sym_enum] = ACTIONS(3160),
    [anon_sym_class] = ACTIONS(3160),
    [anon_sym_struct] = ACTIONS(3160),
    [anon_sym_union] = ACTIONS(3160),
    [anon_sym_if] = ACTIONS(3160),
    [anon_sym_switch] = ACTIONS(3160),
    [anon_sym_case] = ACTIONS(3160),
    [anon_sym_default] = ACTIONS(3160),
    [anon_sym_while] = ACTIONS(3160),
    [anon_sym_do] = ACTIONS(3160),
    [anon_sym_for] = ACTIONS(3160),
    [anon_sym_return] = ACTIONS(3160),
    [anon_sym_break] = ACTIONS(3160),
    [anon_sym_continue] = ACTIONS(3160),
    [anon_sym_goto] = ACTIONS(3160),
    [anon_sym___try] = ACTIONS(3160),
    [anon_sym___leave] = ACTIONS(3160),
    [anon_sym_not] = ACTIONS(3160),
    [anon_sym_compl] = ACTIONS(3160),
    [anon_sym_DASH_DASH] = ACTIONS(3162),
    [anon_sym_PLUS_PLUS] = ACTIONS(3162),
    [anon_sym_sizeof] = ACTIONS(3160),
    [anon_sym___alignof__] = ACTIONS(3160),
    [anon_sym___alignof] = ACTIONS(3160),
    [anon_sym__alignof] = ACTIONS(3160),
    [anon_sym_alignof] = ACTIONS(3160),
    [anon_sym__Alignof] = ACTIONS(3160),
    [anon_sym_offsetof] = ACTIONS(3160),
    [anon_sym__Generic] = ACTIONS(3160),
    [anon_sym_asm] = ACTIONS(3160),
    [anon_sym___asm__] = ACTIONS(3160),
    [aux_sym_number_literal_token1] = ACTIONS(3162),
    [aux_sym_number_literal_token2] = ACTIONS(3160),
    [anon_sym_L_SQUOTE] = ACTIONS(3162),
    [anon_sym_u_SQUOTE] = ACTIONS(3162),
    [anon_sym_U_SQUOTE] = ACTIONS(3162),
    [anon_sym_u8_SQUOTE] = ACTIONS(3162),
    [anon_sym_SQUOTE] = ACTIONS(3162),
    [anon_sym_L_DQUOTE] = ACTIONS(3162),
    [anon_sym_u_DQUOTE] = ACTIONS(3162),
    [anon_sym_U_DQUOTE] = ACTIONS(3162),
    [anon_sym_u8_DQUOTE] = ACTIONS(3162),
    [anon_sym_DQUOTE] = ACTIONS(3162),
    [sym_true] = ACTIONS(3160),
    [sym_false] = ACTIONS(3160),
    [anon_sym_NULL] = ACTIONS(3160),
    [anon_sym_nullptr] = ACTIONS(3160),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3160),
    [anon_sym_decltype] = ACTIONS(3160),
    [anon_sym_virtual] = ACTIONS(3160),
    [anon_sym_alignas] = ACTIONS(3160),
    [anon_sym_explicit] = ACTIONS(3160),
    [anon_sym_typename] = ACTIONS(3160),
    [anon_sym_template] = ACTIONS(3160),
    [anon_sym_operator] = ACTIONS(3160),
    [anon_sym_try] = ACTIONS(3160),
    [anon_sym_delete] = ACTIONS(3160),
    [anon_sym_throw] = ACTIONS(3160),
    [anon_sym_namespace] = ACTIONS(3160),
    [anon_sym_using] = ACTIONS(3160),
    [anon_sym_static_assert] = ACTIONS(3160),
    [anon_sym_concept] = ACTIONS(3160),
    [anon_sym_co_return] = ACTIONS(3160),
    [anon_sym_co_yield] = ACTIONS(3160),
    [anon_sym_R_DQUOTE] = ACTIONS(3162),
    [anon_sym_LR_DQUOTE] = ACTIONS(3162),
    [anon_sym_uR_DQUOTE] = ACTIONS(3162),
    [anon_sym_UR_DQUOTE] = ACTIONS(3162),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3162),
    [anon_sym_co_await] = ACTIONS(3160),
    [anon_sym_new] = ACTIONS(3160),
    [anon_sym_requires] = ACTIONS(3160),
    [sym_this] = ACTIONS(3160),
  },
  [416] = {
    [sym_identifier] = ACTIONS(3164),
    [aux_sym_preproc_include_token1] = ACTIONS(3164),
    [aux_sym_preproc_def_token1] = ACTIONS(3164),
    [aux_sym_preproc_if_token1] = ACTIONS(3164),
    [aux_sym_preproc_if_token2] = ACTIONS(3164),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3164),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3164),
    [aux_sym_preproc_else_token1] = ACTIONS(3164),
    [aux_sym_preproc_elif_token1] = ACTIONS(3164),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3164),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3164),
    [sym_preproc_directive] = ACTIONS(3164),
    [anon_sym_LPAREN2] = ACTIONS(3166),
    [anon_sym_BANG] = ACTIONS(3166),
    [anon_sym_TILDE] = ACTIONS(3166),
    [anon_sym_DASH] = ACTIONS(3164),
    [anon_sym_PLUS] = ACTIONS(3164),
    [anon_sym_STAR] = ACTIONS(3166),
    [anon_sym_AMP_AMP] = ACTIONS(3166),
    [anon_sym_AMP] = ACTIONS(3164),
    [anon_sym_SEMI] = ACTIONS(3166),
    [anon_sym___extension__] = ACTIONS(3164),
    [anon_sym_typedef] = ACTIONS(3164),
    [anon_sym_extern] = ACTIONS(3164),
    [anon_sym___attribute__] = ACTIONS(3164),
    [anon_sym_COLON_COLON] = ACTIONS(3166),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3166),
    [anon_sym___declspec] = ACTIONS(3164),
    [anon_sym___based] = ACTIONS(3164),
    [anon_sym___cdecl] = ACTIONS(3164),
    [anon_sym___clrcall] = ACTIONS(3164),
    [anon_sym___stdcall] = ACTIONS(3164),
    [anon_sym___fastcall] = ACTIONS(3164),
    [anon_sym___thiscall] = ACTIONS(3164),
    [anon_sym___vectorcall] = ACTIONS(3164),
    [anon_sym_LBRACE] = ACTIONS(3166),
    [anon_sym_signed] = ACTIONS(3164),
    [anon_sym_unsigned] = ACTIONS(3164),
    [anon_sym_long] = ACTIONS(3164),
    [anon_sym_short] = ACTIONS(3164),
    [anon_sym_LBRACK] = ACTIONS(3164),
    [anon_sym_static] = ACTIONS(3164),
    [anon_sym_register] = ACTIONS(3164),
    [anon_sym_inline] = ACTIONS(3164),
    [anon_sym___inline] = ACTIONS(3164),
    [anon_sym___inline__] = ACTIONS(3164),
    [anon_sym___forceinline] = ACTIONS(3164),
    [anon_sym_thread_local] = ACTIONS(3164),
    [anon_sym___thread] = ACTIONS(3164),
    [anon_sym_const] = ACTIONS(3164),
    [anon_sym_constexpr] = ACTIONS(3164),
    [anon_sym_volatile] = ACTIONS(3164),
    [anon_sym_restrict] = ACTIONS(3164),
    [anon_sym___restrict__] = ACTIONS(3164),
    [anon_sym__Atomic] = ACTIONS(3164),
    [anon_sym__Noreturn] = ACTIONS(3164),
    [anon_sym_noreturn] = ACTIONS(3164),
    [anon_sym_mutable] = ACTIONS(3164),
    [anon_sym_constinit] = ACTIONS(3164),
    [anon_sym_consteval] = ACTIONS(3164),
    [anon_sym_PROGMEM] = ACTIONS(3164),
    [aux_sym_primitive_type_token1] = ACTIONS(3164),
    [anon_sym_byte] = ACTIONS(3164),
    [anon_sym_word] = ACTIONS(3164),
    [anon_sym_enum] = ACTIONS(3164),
    [anon_sym_class] = ACTIONS(3164),
    [anon_sym_struct] = ACTIONS(3164),
    [anon_sym_union] = ACTIONS(3164),
    [anon_sym_if] = ACTIONS(3164),
    [anon_sym_switch] = ACTIONS(3164),
    [anon_sym_case] = ACTIONS(3164),
    [anon_sym_default] = ACTIONS(3164),
    [anon_sym_while] = ACTIONS(3164),
    [anon_sym_do] = ACTIONS(3164),
    [anon_sym_for] = ACTIONS(3164),
    [anon_sym_return] = ACTIONS(3164),
    [anon_sym_break] = ACTIONS(3164),
    [anon_sym_continue] = ACTIONS(3164),
    [anon_sym_goto] = ACTIONS(3164),
    [anon_sym___try] = ACTIONS(3164),
    [anon_sym___leave] = ACTIONS(3164),
    [anon_sym_not] = ACTIONS(3164),
    [anon_sym_compl] = ACTIONS(3164),
    [anon_sym_DASH_DASH] = ACTIONS(3166),
    [anon_sym_PLUS_PLUS] = ACTIONS(3166),
    [anon_sym_sizeof] = ACTIONS(3164),
    [anon_sym___alignof__] = ACTIONS(3164),
    [anon_sym___alignof] = ACTIONS(3164),
    [anon_sym__alignof] = ACTIONS(3164),
    [anon_sym_alignof] = ACTIONS(3164),
    [anon_sym__Alignof] = ACTIONS(3164),
    [anon_sym_offsetof] = ACTIONS(3164),
    [anon_sym__Generic] = ACTIONS(3164),
    [anon_sym_asm] = ACTIONS(3164),
    [anon_sym___asm__] = ACTIONS(3164),
    [aux_sym_number_literal_token1] = ACTIONS(3166),
    [aux_sym_number_literal_token2] = ACTIONS(3164),
    [anon_sym_L_SQUOTE] = ACTIONS(3166),
    [anon_sym_u_SQUOTE] = ACTIONS(3166),
    [anon_sym_U_SQUOTE] = ACTIONS(3166),
    [anon_sym_u8_SQUOTE] = ACTIONS(3166),
    [anon_sym_SQUOTE] = ACTIONS(3166),
    [anon_sym_L_DQUOTE] = ACTIONS(3166),
    [anon_sym_u_DQUOTE] = ACTIONS(3166),
    [anon_sym_U_DQUOTE] = ACTIONS(3166),
    [anon_sym_u8_DQUOTE] = ACTIONS(3166),
    [anon_sym_DQUOTE] = ACTIONS(3166),
    [sym_true] = ACTIONS(3164),
    [sym_false] = ACTIONS(3164),
    [anon_sym_NULL] = ACTIONS(3164),
    [anon_sym_nullptr] = ACTIONS(3164),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3164),
    [anon_sym_decltype] = ACTIONS(3164),
    [anon_sym_virtual] = ACTIONS(3164),
    [anon_sym_alignas] = ACTIONS(3164),
    [anon_sym_explicit] = ACTIONS(3164),
    [anon_sym_typename] = ACTIONS(3164),
    [anon_sym_template] = ACTIONS(3164),
    [anon_sym_operator] = ACTIONS(3164),
    [anon_sym_try] = ACTIONS(3164),
    [anon_sym_delete] = ACTIONS(3164),
    [anon_sym_throw] = ACTIONS(3164),
    [anon_sym_namespace] = ACTIONS(3164),
    [anon_sym_using] = ACTIONS(3164),
    [anon_sym_static_assert] = ACTIONS(3164),
    [anon_sym_concept] = ACTIONS(3164),
    [anon_sym_co_return] = ACTIONS(3164),
    [anon_sym_co_yield] = ACTIONS(3164),
    [anon_sym_R_DQUOTE] = ACTIONS(3166),
    [anon_sym_LR_DQUOTE] = ACTIONS(3166),
    [anon_sym_uR_DQUOTE] = ACTIONS(3166),
    [anon_sym_UR_DQUOTE] = ACTIONS(3166),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3166),
    [anon_sym_co_await] = ACTIONS(3164),
    [anon_sym_new] = ACTIONS(3164),
    [anon_sym_requires] = ACTIONS(3164),
    [sym_this] = ACTIONS(3164),
  },
  [417] = {
    [sym_preproc_def] = STATE(363),
    [sym_preproc_function_def] = STATE(363),
    [sym_preproc_call] = STATE(363),
    [sym_preproc_if_in_field_declaration_list] = STATE(363),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(363),
    [sym_preproc_else_in_field_declaration_list] = STATE(7671),
    [sym_preproc_elif_in_field_declaration_list] = STATE(7671),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(7671),
    [sym_type_definition] = STATE(363),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(5531),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(3150),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(5962),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym__field_declaration_list_item] = STATE(363),
    [sym_field_declaration] = STATE(363),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1838),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(363),
    [sym_operator_cast] = STATE(6510),
    [sym_inline_method_definition] = STATE(363),
    [sym__constructor_specifiers] = STATE(1838),
    [sym_operator_cast_definition] = STATE(363),
    [sym_operator_cast_declaration] = STATE(363),
    [sym_constructor_or_destructor_definition] = STATE(363),
    [sym_constructor_or_destructor_declaration] = STATE(363),
    [sym_friend_declaration] = STATE(363),
    [sym_access_specifier] = STATE(7787),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(2618),
    [sym_template_function] = STATE(6098),
    [sym_using_declaration] = STATE(363),
    [sym_alias_declaration] = STATE(363),
    [sym_static_assert_declaration] = STATE(363),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5301),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_qualified_operator_cast_identifier] = STATE(6510),
    [sym_operator_name] = STATE(6098),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(363),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1961),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1838),
    [sym_identifier] = ACTIONS(2823),
    [aux_sym_preproc_def_token1] = ACTIONS(2825),
    [aux_sym_preproc_if_token1] = ACTIONS(2827),
    [aux_sym_preproc_if_token2] = ACTIONS(3168),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2831),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2831),
    [aux_sym_preproc_else_token1] = ACTIONS(2833),
    [aux_sym_preproc_elif_token1] = ACTIONS(2835),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2837),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2837),
    [sym_preproc_directive] = ACTIONS(2839),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(2849),
    [anon_sym_typedef] = ACTIONS(2851),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(2853),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2857),
    [anon_sym_class] = ACTIONS(2859),
    [anon_sym_struct] = ACTIONS(2861),
    [anon_sym_union] = ACTIONS(2863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(2865),
    [anon_sym_template] = ACTIONS(2867),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(2869),
    [anon_sym_public] = ACTIONS(2871),
    [anon_sym_private] = ACTIONS(2871),
    [anon_sym_protected] = ACTIONS(2871),
    [anon_sym_using] = ACTIONS(2873),
    [anon_sym_static_assert] = ACTIONS(2875),
  },
  [418] = {
    [sym_identifier] = ACTIONS(3170),
    [aux_sym_preproc_include_token1] = ACTIONS(3170),
    [aux_sym_preproc_def_token1] = ACTIONS(3170),
    [aux_sym_preproc_if_token1] = ACTIONS(3170),
    [aux_sym_preproc_if_token2] = ACTIONS(3170),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3170),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3170),
    [aux_sym_preproc_else_token1] = ACTIONS(3170),
    [aux_sym_preproc_elif_token1] = ACTIONS(3170),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3170),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3170),
    [sym_preproc_directive] = ACTIONS(3170),
    [anon_sym_LPAREN2] = ACTIONS(3172),
    [anon_sym_BANG] = ACTIONS(3172),
    [anon_sym_TILDE] = ACTIONS(3172),
    [anon_sym_DASH] = ACTIONS(3170),
    [anon_sym_PLUS] = ACTIONS(3170),
    [anon_sym_STAR] = ACTIONS(3172),
    [anon_sym_AMP_AMP] = ACTIONS(3172),
    [anon_sym_AMP] = ACTIONS(3170),
    [anon_sym_SEMI] = ACTIONS(3172),
    [anon_sym___extension__] = ACTIONS(3170),
    [anon_sym_typedef] = ACTIONS(3170),
    [anon_sym_extern] = ACTIONS(3170),
    [anon_sym___attribute__] = ACTIONS(3170),
    [anon_sym_COLON_COLON] = ACTIONS(3172),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3172),
    [anon_sym___declspec] = ACTIONS(3170),
    [anon_sym___based] = ACTIONS(3170),
    [anon_sym___cdecl] = ACTIONS(3170),
    [anon_sym___clrcall] = ACTIONS(3170),
    [anon_sym___stdcall] = ACTIONS(3170),
    [anon_sym___fastcall] = ACTIONS(3170),
    [anon_sym___thiscall] = ACTIONS(3170),
    [anon_sym___vectorcall] = ACTIONS(3170),
    [anon_sym_LBRACE] = ACTIONS(3172),
    [anon_sym_signed] = ACTIONS(3170),
    [anon_sym_unsigned] = ACTIONS(3170),
    [anon_sym_long] = ACTIONS(3170),
    [anon_sym_short] = ACTIONS(3170),
    [anon_sym_LBRACK] = ACTIONS(3170),
    [anon_sym_static] = ACTIONS(3170),
    [anon_sym_register] = ACTIONS(3170),
    [anon_sym_inline] = ACTIONS(3170),
    [anon_sym___inline] = ACTIONS(3170),
    [anon_sym___inline__] = ACTIONS(3170),
    [anon_sym___forceinline] = ACTIONS(3170),
    [anon_sym_thread_local] = ACTIONS(3170),
    [anon_sym___thread] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3170),
    [anon_sym_constexpr] = ACTIONS(3170),
    [anon_sym_volatile] = ACTIONS(3170),
    [anon_sym_restrict] = ACTIONS(3170),
    [anon_sym___restrict__] = ACTIONS(3170),
    [anon_sym__Atomic] = ACTIONS(3170),
    [anon_sym__Noreturn] = ACTIONS(3170),
    [anon_sym_noreturn] = ACTIONS(3170),
    [anon_sym_mutable] = ACTIONS(3170),
    [anon_sym_constinit] = ACTIONS(3170),
    [anon_sym_consteval] = ACTIONS(3170),
    [anon_sym_PROGMEM] = ACTIONS(3170),
    [aux_sym_primitive_type_token1] = ACTIONS(3170),
    [anon_sym_byte] = ACTIONS(3170),
    [anon_sym_word] = ACTIONS(3170),
    [anon_sym_enum] = ACTIONS(3170),
    [anon_sym_class] = ACTIONS(3170),
    [anon_sym_struct] = ACTIONS(3170),
    [anon_sym_union] = ACTIONS(3170),
    [anon_sym_if] = ACTIONS(3170),
    [anon_sym_switch] = ACTIONS(3170),
    [anon_sym_case] = ACTIONS(3170),
    [anon_sym_default] = ACTIONS(3170),
    [anon_sym_while] = ACTIONS(3170),
    [anon_sym_do] = ACTIONS(3170),
    [anon_sym_for] = ACTIONS(3170),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_break] = ACTIONS(3170),
    [anon_sym_continue] = ACTIONS(3170),
    [anon_sym_goto] = ACTIONS(3170),
    [anon_sym___try] = ACTIONS(3170),
    [anon_sym___leave] = ACTIONS(3170),
    [anon_sym_not] = ACTIONS(3170),
    [anon_sym_compl] = ACTIONS(3170),
    [anon_sym_DASH_DASH] = ACTIONS(3172),
    [anon_sym_PLUS_PLUS] = ACTIONS(3172),
    [anon_sym_sizeof] = ACTIONS(3170),
    [anon_sym___alignof__] = ACTIONS(3170),
    [anon_sym___alignof] = ACTIONS(3170),
    [anon_sym__alignof] = ACTIONS(3170),
    [anon_sym_alignof] = ACTIONS(3170),
    [anon_sym__Alignof] = ACTIONS(3170),
    [anon_sym_offsetof] = ACTIONS(3170),
    [anon_sym__Generic] = ACTIONS(3170),
    [anon_sym_asm] = ACTIONS(3170),
    [anon_sym___asm__] = ACTIONS(3170),
    [aux_sym_number_literal_token1] = ACTIONS(3172),
    [aux_sym_number_literal_token2] = ACTIONS(3170),
    [anon_sym_L_SQUOTE] = ACTIONS(3172),
    [anon_sym_u_SQUOTE] = ACTIONS(3172),
    [anon_sym_U_SQUOTE] = ACTIONS(3172),
    [anon_sym_u8_SQUOTE] = ACTIONS(3172),
    [anon_sym_SQUOTE] = ACTIONS(3172),
    [anon_sym_L_DQUOTE] = ACTIONS(3172),
    [anon_sym_u_DQUOTE] = ACTIONS(3172),
    [anon_sym_U_DQUOTE] = ACTIONS(3172),
    [anon_sym_u8_DQUOTE] = ACTIONS(3172),
    [anon_sym_DQUOTE] = ACTIONS(3172),
    [sym_true] = ACTIONS(3170),
    [sym_false] = ACTIONS(3170),
    [anon_sym_NULL] = ACTIONS(3170),
    [anon_sym_nullptr] = ACTIONS(3170),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3170),
    [anon_sym_decltype] = ACTIONS(3170),
    [anon_sym_virtual] = ACTIONS(3170),
    [anon_sym_alignas] = ACTIONS(3170),
    [anon_sym_explicit] = ACTIONS(3170),
    [anon_sym_typename] = ACTIONS(3170),
    [anon_sym_template] = ACTIONS(3170),
    [anon_sym_operator] = ACTIONS(3170),
    [anon_sym_try] = ACTIONS(3170),
    [anon_sym_delete] = ACTIONS(3170),
    [anon_sym_throw] = ACTIONS(3170),
    [anon_sym_namespace] = ACTIONS(3170),
    [anon_sym_using] = ACTIONS(3170),
    [anon_sym_static_assert] = ACTIONS(3170),
    [anon_sym_concept] = ACTIONS(3170),
    [anon_sym_co_return] = ACTIONS(3170),
    [anon_sym_co_yield] = ACTIONS(3170),
    [anon_sym_R_DQUOTE] = ACTIONS(3172),
    [anon_sym_LR_DQUOTE] = ACTIONS(3172),
    [anon_sym_uR_DQUOTE] = ACTIONS(3172),
    [anon_sym_UR_DQUOTE] = ACTIONS(3172),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3172),
    [anon_sym_co_await] = ACTIONS(3170),
    [anon_sym_new] = ACTIONS(3170),
    [anon_sym_requires] = ACTIONS(3170),
    [sym_this] = ACTIONS(3170),
  },
  [419] = {
    [sym_identifier] = ACTIONS(3174),
    [aux_sym_preproc_include_token1] = ACTIONS(3174),
    [aux_sym_preproc_def_token1] = ACTIONS(3174),
    [aux_sym_preproc_if_token1] = ACTIONS(3174),
    [aux_sym_preproc_if_token2] = ACTIONS(3174),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3174),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3174),
    [aux_sym_preproc_else_token1] = ACTIONS(3174),
    [aux_sym_preproc_elif_token1] = ACTIONS(3174),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3174),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3174),
    [sym_preproc_directive] = ACTIONS(3174),
    [anon_sym_LPAREN2] = ACTIONS(3176),
    [anon_sym_BANG] = ACTIONS(3176),
    [anon_sym_TILDE] = ACTIONS(3176),
    [anon_sym_DASH] = ACTIONS(3174),
    [anon_sym_PLUS] = ACTIONS(3174),
    [anon_sym_STAR] = ACTIONS(3176),
    [anon_sym_AMP_AMP] = ACTIONS(3176),
    [anon_sym_AMP] = ACTIONS(3174),
    [anon_sym_SEMI] = ACTIONS(3176),
    [anon_sym___extension__] = ACTIONS(3174),
    [anon_sym_typedef] = ACTIONS(3174),
    [anon_sym_extern] = ACTIONS(3174),
    [anon_sym___attribute__] = ACTIONS(3174),
    [anon_sym_COLON_COLON] = ACTIONS(3176),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3176),
    [anon_sym___declspec] = ACTIONS(3174),
    [anon_sym___based] = ACTIONS(3174),
    [anon_sym___cdecl] = ACTIONS(3174),
    [anon_sym___clrcall] = ACTIONS(3174),
    [anon_sym___stdcall] = ACTIONS(3174),
    [anon_sym___fastcall] = ACTIONS(3174),
    [anon_sym___thiscall] = ACTIONS(3174),
    [anon_sym___vectorcall] = ACTIONS(3174),
    [anon_sym_LBRACE] = ACTIONS(3176),
    [anon_sym_signed] = ACTIONS(3174),
    [anon_sym_unsigned] = ACTIONS(3174),
    [anon_sym_long] = ACTIONS(3174),
    [anon_sym_short] = ACTIONS(3174),
    [anon_sym_LBRACK] = ACTIONS(3174),
    [anon_sym_static] = ACTIONS(3174),
    [anon_sym_register] = ACTIONS(3174),
    [anon_sym_inline] = ACTIONS(3174),
    [anon_sym___inline] = ACTIONS(3174),
    [anon_sym___inline__] = ACTIONS(3174),
    [anon_sym___forceinline] = ACTIONS(3174),
    [anon_sym_thread_local] = ACTIONS(3174),
    [anon_sym___thread] = ACTIONS(3174),
    [anon_sym_const] = ACTIONS(3174),
    [anon_sym_constexpr] = ACTIONS(3174),
    [anon_sym_volatile] = ACTIONS(3174),
    [anon_sym_restrict] = ACTIONS(3174),
    [anon_sym___restrict__] = ACTIONS(3174),
    [anon_sym__Atomic] = ACTIONS(3174),
    [anon_sym__Noreturn] = ACTIONS(3174),
    [anon_sym_noreturn] = ACTIONS(3174),
    [anon_sym_mutable] = ACTIONS(3174),
    [anon_sym_constinit] = ACTIONS(3174),
    [anon_sym_consteval] = ACTIONS(3174),
    [anon_sym_PROGMEM] = ACTIONS(3174),
    [aux_sym_primitive_type_token1] = ACTIONS(3174),
    [anon_sym_byte] = ACTIONS(3174),
    [anon_sym_word] = ACTIONS(3174),
    [anon_sym_enum] = ACTIONS(3174),
    [anon_sym_class] = ACTIONS(3174),
    [anon_sym_struct] = ACTIONS(3174),
    [anon_sym_union] = ACTIONS(3174),
    [anon_sym_if] = ACTIONS(3174),
    [anon_sym_switch] = ACTIONS(3174),
    [anon_sym_case] = ACTIONS(3174),
    [anon_sym_default] = ACTIONS(3174),
    [anon_sym_while] = ACTIONS(3174),
    [anon_sym_do] = ACTIONS(3174),
    [anon_sym_for] = ACTIONS(3174),
    [anon_sym_return] = ACTIONS(3174),
    [anon_sym_break] = ACTIONS(3174),
    [anon_sym_continue] = ACTIONS(3174),
    [anon_sym_goto] = ACTIONS(3174),
    [anon_sym___try] = ACTIONS(3174),
    [anon_sym___leave] = ACTIONS(3174),
    [anon_sym_not] = ACTIONS(3174),
    [anon_sym_compl] = ACTIONS(3174),
    [anon_sym_DASH_DASH] = ACTIONS(3176),
    [anon_sym_PLUS_PLUS] = ACTIONS(3176),
    [anon_sym_sizeof] = ACTIONS(3174),
    [anon_sym___alignof__] = ACTIONS(3174),
    [anon_sym___alignof] = ACTIONS(3174),
    [anon_sym__alignof] = ACTIONS(3174),
    [anon_sym_alignof] = ACTIONS(3174),
    [anon_sym__Alignof] = ACTIONS(3174),
    [anon_sym_offsetof] = ACTIONS(3174),
    [anon_sym__Generic] = ACTIONS(3174),
    [anon_sym_asm] = ACTIONS(3174),
    [anon_sym___asm__] = ACTIONS(3174),
    [aux_sym_number_literal_token1] = ACTIONS(3176),
    [aux_sym_number_literal_token2] = ACTIONS(3174),
    [anon_sym_L_SQUOTE] = ACTIONS(3176),
    [anon_sym_u_SQUOTE] = ACTIONS(3176),
    [anon_sym_U_SQUOTE] = ACTIONS(3176),
    [anon_sym_u8_SQUOTE] = ACTIONS(3176),
    [anon_sym_SQUOTE] = ACTIONS(3176),
    [anon_sym_L_DQUOTE] = ACTIONS(3176),
    [anon_sym_u_DQUOTE] = ACTIONS(3176),
    [anon_sym_U_DQUOTE] = ACTIONS(3176),
    [anon_sym_u8_DQUOTE] = ACTIONS(3176),
    [anon_sym_DQUOTE] = ACTIONS(3176),
    [sym_true] = ACTIONS(3174),
    [sym_false] = ACTIONS(3174),
    [anon_sym_NULL] = ACTIONS(3174),
    [anon_sym_nullptr] = ACTIONS(3174),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3174),
    [anon_sym_decltype] = ACTIONS(3174),
    [anon_sym_virtual] = ACTIONS(3174),
    [anon_sym_alignas] = ACTIONS(3174),
    [anon_sym_explicit] = ACTIONS(3174),
    [anon_sym_typename] = ACTIONS(3174),
    [anon_sym_template] = ACTIONS(3174),
    [anon_sym_operator] = ACTIONS(3174),
    [anon_sym_try] = ACTIONS(3174),
    [anon_sym_delete] = ACTIONS(3174),
    [anon_sym_throw] = ACTIONS(3174),
    [anon_sym_namespace] = ACTIONS(3174),
    [anon_sym_using] = ACTIONS(3174),
    [anon_sym_static_assert] = ACTIONS(3174),
    [anon_sym_concept] = ACTIONS(3174),
    [anon_sym_co_return] = ACTIONS(3174),
    [anon_sym_co_yield] = ACTIONS(3174),
    [anon_sym_R_DQUOTE] = ACTIONS(3176),
    [anon_sym_LR_DQUOTE] = ACTIONS(3176),
    [anon_sym_uR_DQUOTE] = ACTIONS(3176),
    [anon_sym_UR_DQUOTE] = ACTIONS(3176),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3176),
    [anon_sym_co_await] = ACTIONS(3174),
    [anon_sym_new] = ACTIONS(3174),
    [anon_sym_requires] = ACTIONS(3174),
    [sym_this] = ACTIONS(3174),
  },
  [420] = {
    [sym_identifier] = ACTIONS(3178),
    [aux_sym_preproc_include_token1] = ACTIONS(3178),
    [aux_sym_preproc_def_token1] = ACTIONS(3178),
    [aux_sym_preproc_if_token1] = ACTIONS(3178),
    [aux_sym_preproc_if_token2] = ACTIONS(3178),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3178),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3178),
    [aux_sym_preproc_else_token1] = ACTIONS(3178),
    [aux_sym_preproc_elif_token1] = ACTIONS(3178),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3178),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3178),
    [sym_preproc_directive] = ACTIONS(3178),
    [anon_sym_LPAREN2] = ACTIONS(3180),
    [anon_sym_BANG] = ACTIONS(3180),
    [anon_sym_TILDE] = ACTIONS(3180),
    [anon_sym_DASH] = ACTIONS(3178),
    [anon_sym_PLUS] = ACTIONS(3178),
    [anon_sym_STAR] = ACTIONS(3180),
    [anon_sym_AMP_AMP] = ACTIONS(3180),
    [anon_sym_AMP] = ACTIONS(3178),
    [anon_sym_SEMI] = ACTIONS(3180),
    [anon_sym___extension__] = ACTIONS(3178),
    [anon_sym_typedef] = ACTIONS(3178),
    [anon_sym_extern] = ACTIONS(3178),
    [anon_sym___attribute__] = ACTIONS(3178),
    [anon_sym_COLON_COLON] = ACTIONS(3180),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3180),
    [anon_sym___declspec] = ACTIONS(3178),
    [anon_sym___based] = ACTIONS(3178),
    [anon_sym___cdecl] = ACTIONS(3178),
    [anon_sym___clrcall] = ACTIONS(3178),
    [anon_sym___stdcall] = ACTIONS(3178),
    [anon_sym___fastcall] = ACTIONS(3178),
    [anon_sym___thiscall] = ACTIONS(3178),
    [anon_sym___vectorcall] = ACTIONS(3178),
    [anon_sym_LBRACE] = ACTIONS(3180),
    [anon_sym_signed] = ACTIONS(3178),
    [anon_sym_unsigned] = ACTIONS(3178),
    [anon_sym_long] = ACTIONS(3178),
    [anon_sym_short] = ACTIONS(3178),
    [anon_sym_LBRACK] = ACTIONS(3178),
    [anon_sym_static] = ACTIONS(3178),
    [anon_sym_register] = ACTIONS(3178),
    [anon_sym_inline] = ACTIONS(3178),
    [anon_sym___inline] = ACTIONS(3178),
    [anon_sym___inline__] = ACTIONS(3178),
    [anon_sym___forceinline] = ACTIONS(3178),
    [anon_sym_thread_local] = ACTIONS(3178),
    [anon_sym___thread] = ACTIONS(3178),
    [anon_sym_const] = ACTIONS(3178),
    [anon_sym_constexpr] = ACTIONS(3178),
    [anon_sym_volatile] = ACTIONS(3178),
    [anon_sym_restrict] = ACTIONS(3178),
    [anon_sym___restrict__] = ACTIONS(3178),
    [anon_sym__Atomic] = ACTIONS(3178),
    [anon_sym__Noreturn] = ACTIONS(3178),
    [anon_sym_noreturn] = ACTIONS(3178),
    [anon_sym_mutable] = ACTIONS(3178),
    [anon_sym_constinit] = ACTIONS(3178),
    [anon_sym_consteval] = ACTIONS(3178),
    [anon_sym_PROGMEM] = ACTIONS(3178),
    [aux_sym_primitive_type_token1] = ACTIONS(3178),
    [anon_sym_byte] = ACTIONS(3178),
    [anon_sym_word] = ACTIONS(3178),
    [anon_sym_enum] = ACTIONS(3178),
    [anon_sym_class] = ACTIONS(3178),
    [anon_sym_struct] = ACTIONS(3178),
    [anon_sym_union] = ACTIONS(3178),
    [anon_sym_if] = ACTIONS(3178),
    [anon_sym_switch] = ACTIONS(3178),
    [anon_sym_case] = ACTIONS(3178),
    [anon_sym_default] = ACTIONS(3178),
    [anon_sym_while] = ACTIONS(3178),
    [anon_sym_do] = ACTIONS(3178),
    [anon_sym_for] = ACTIONS(3178),
    [anon_sym_return] = ACTIONS(3178),
    [anon_sym_break] = ACTIONS(3178),
    [anon_sym_continue] = ACTIONS(3178),
    [anon_sym_goto] = ACTIONS(3178),
    [anon_sym___try] = ACTIONS(3178),
    [anon_sym___leave] = ACTIONS(3178),
    [anon_sym_not] = ACTIONS(3178),
    [anon_sym_compl] = ACTIONS(3178),
    [anon_sym_DASH_DASH] = ACTIONS(3180),
    [anon_sym_PLUS_PLUS] = ACTIONS(3180),
    [anon_sym_sizeof] = ACTIONS(3178),
    [anon_sym___alignof__] = ACTIONS(3178),
    [anon_sym___alignof] = ACTIONS(3178),
    [anon_sym__alignof] = ACTIONS(3178),
    [anon_sym_alignof] = ACTIONS(3178),
    [anon_sym__Alignof] = ACTIONS(3178),
    [anon_sym_offsetof] = ACTIONS(3178),
    [anon_sym__Generic] = ACTIONS(3178),
    [anon_sym_asm] = ACTIONS(3178),
    [anon_sym___asm__] = ACTIONS(3178),
    [aux_sym_number_literal_token1] = ACTIONS(3180),
    [aux_sym_number_literal_token2] = ACTIONS(3178),
    [anon_sym_L_SQUOTE] = ACTIONS(3180),
    [anon_sym_u_SQUOTE] = ACTIONS(3180),
    [anon_sym_U_SQUOTE] = ACTIONS(3180),
    [anon_sym_u8_SQUOTE] = ACTIONS(3180),
    [anon_sym_SQUOTE] = ACTIONS(3180),
    [anon_sym_L_DQUOTE] = ACTIONS(3180),
    [anon_sym_u_DQUOTE] = ACTIONS(3180),
    [anon_sym_U_DQUOTE] = ACTIONS(3180),
    [anon_sym_u8_DQUOTE] = ACTIONS(3180),
    [anon_sym_DQUOTE] = ACTIONS(3180),
    [sym_true] = ACTIONS(3178),
    [sym_false] = ACTIONS(3178),
    [anon_sym_NULL] = ACTIONS(3178),
    [anon_sym_nullptr] = ACTIONS(3178),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3178),
    [anon_sym_decltype] = ACTIONS(3178),
    [anon_sym_virtual] = ACTIONS(3178),
    [anon_sym_alignas] = ACTIONS(3178),
    [anon_sym_explicit] = ACTIONS(3178),
    [anon_sym_typename] = ACTIONS(3178),
    [anon_sym_template] = ACTIONS(3178),
    [anon_sym_operator] = ACTIONS(3178),
    [anon_sym_try] = ACTIONS(3178),
    [anon_sym_delete] = ACTIONS(3178),
    [anon_sym_throw] = ACTIONS(3178),
    [anon_sym_namespace] = ACTIONS(3178),
    [anon_sym_using] = ACTIONS(3178),
    [anon_sym_static_assert] = ACTIONS(3178),
    [anon_sym_concept] = ACTIONS(3178),
    [anon_sym_co_return] = ACTIONS(3178),
    [anon_sym_co_yield] = ACTIONS(3178),
    [anon_sym_R_DQUOTE] = ACTIONS(3180),
    [anon_sym_LR_DQUOTE] = ACTIONS(3180),
    [anon_sym_uR_DQUOTE] = ACTIONS(3180),
    [anon_sym_UR_DQUOTE] = ACTIONS(3180),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3180),
    [anon_sym_co_await] = ACTIONS(3178),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3178),
    [sym_this] = ACTIONS(3178),
  },
  [421] = {
    [sym_catch_clause] = STATE(402),
    [aux_sym_constructor_try_statement_repeat1] = STATE(402),
    [sym_identifier] = ACTIONS(2488),
    [aux_sym_preproc_include_token1] = ACTIONS(2488),
    [aux_sym_preproc_def_token1] = ACTIONS(2488),
    [aux_sym_preproc_if_token1] = ACTIONS(2488),
    [aux_sym_preproc_if_token2] = ACTIONS(2488),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2488),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2488),
    [sym_preproc_directive] = ACTIONS(2488),
    [anon_sym_LPAREN2] = ACTIONS(2490),
    [anon_sym_BANG] = ACTIONS(2490),
    [anon_sym_TILDE] = ACTIONS(2490),
    [anon_sym_DASH] = ACTIONS(2488),
    [anon_sym_PLUS] = ACTIONS(2488),
    [anon_sym_STAR] = ACTIONS(2490),
    [anon_sym_AMP_AMP] = ACTIONS(2490),
    [anon_sym_AMP] = ACTIONS(2488),
    [anon_sym_SEMI] = ACTIONS(2490),
    [anon_sym___extension__] = ACTIONS(2488),
    [anon_sym_typedef] = ACTIONS(2488),
    [anon_sym_extern] = ACTIONS(2488),
    [anon_sym___attribute__] = ACTIONS(2488),
    [anon_sym_COLON_COLON] = ACTIONS(2490),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2490),
    [anon_sym___declspec] = ACTIONS(2488),
    [anon_sym___based] = ACTIONS(2488),
    [anon_sym___cdecl] = ACTIONS(2488),
    [anon_sym___clrcall] = ACTIONS(2488),
    [anon_sym___stdcall] = ACTIONS(2488),
    [anon_sym___fastcall] = ACTIONS(2488),
    [anon_sym___thiscall] = ACTIONS(2488),
    [anon_sym___vectorcall] = ACTIONS(2488),
    [anon_sym_LBRACE] = ACTIONS(2490),
    [anon_sym_signed] = ACTIONS(2488),
    [anon_sym_unsigned] = ACTIONS(2488),
    [anon_sym_long] = ACTIONS(2488),
    [anon_sym_short] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(2488),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_register] = ACTIONS(2488),
    [anon_sym_inline] = ACTIONS(2488),
    [anon_sym___inline] = ACTIONS(2488),
    [anon_sym___inline__] = ACTIONS(2488),
    [anon_sym___forceinline] = ACTIONS(2488),
    [anon_sym_thread_local] = ACTIONS(2488),
    [anon_sym___thread] = ACTIONS(2488),
    [anon_sym_const] = ACTIONS(2488),
    [anon_sym_constexpr] = ACTIONS(2488),
    [anon_sym_volatile] = ACTIONS(2488),
    [anon_sym_restrict] = ACTIONS(2488),
    [anon_sym___restrict__] = ACTIONS(2488),
    [anon_sym__Atomic] = ACTIONS(2488),
    [anon_sym__Noreturn] = ACTIONS(2488),
    [anon_sym_noreturn] = ACTIONS(2488),
    [anon_sym_mutable] = ACTIONS(2488),
    [anon_sym_constinit] = ACTIONS(2488),
    [anon_sym_consteval] = ACTIONS(2488),
    [anon_sym_PROGMEM] = ACTIONS(2488),
    [aux_sym_primitive_type_token1] = ACTIONS(2488),
    [anon_sym_byte] = ACTIONS(2488),
    [anon_sym_word] = ACTIONS(2488),
    [anon_sym_enum] = ACTIONS(2488),
    [anon_sym_class] = ACTIONS(2488),
    [anon_sym_struct] = ACTIONS(2488),
    [anon_sym_union] = ACTIONS(2488),
    [anon_sym_if] = ACTIONS(2488),
    [anon_sym_switch] = ACTIONS(2488),
    [anon_sym_case] = ACTIONS(2488),
    [anon_sym_default] = ACTIONS(2488),
    [anon_sym_while] = ACTIONS(2488),
    [anon_sym_do] = ACTIONS(2488),
    [anon_sym_for] = ACTIONS(2488),
    [anon_sym_return] = ACTIONS(2488),
    [anon_sym_break] = ACTIONS(2488),
    [anon_sym_continue] = ACTIONS(2488),
    [anon_sym_goto] = ACTIONS(2488),
    [anon_sym___try] = ACTIONS(2488),
    [anon_sym___leave] = ACTIONS(2488),
    [anon_sym_not] = ACTIONS(2488),
    [anon_sym_compl] = ACTIONS(2488),
    [anon_sym_DASH_DASH] = ACTIONS(2490),
    [anon_sym_PLUS_PLUS] = ACTIONS(2490),
    [anon_sym_sizeof] = ACTIONS(2488),
    [anon_sym___alignof__] = ACTIONS(2488),
    [anon_sym___alignof] = ACTIONS(2488),
    [anon_sym__alignof] = ACTIONS(2488),
    [anon_sym_alignof] = ACTIONS(2488),
    [anon_sym__Alignof] = ACTIONS(2488),
    [anon_sym_offsetof] = ACTIONS(2488),
    [anon_sym__Generic] = ACTIONS(2488),
    [anon_sym_asm] = ACTIONS(2488),
    [anon_sym___asm__] = ACTIONS(2488),
    [aux_sym_number_literal_token1] = ACTIONS(2490),
    [aux_sym_number_literal_token2] = ACTIONS(2488),
    [anon_sym_L_SQUOTE] = ACTIONS(2490),
    [anon_sym_u_SQUOTE] = ACTIONS(2490),
    [anon_sym_U_SQUOTE] = ACTIONS(2490),
    [anon_sym_u8_SQUOTE] = ACTIONS(2490),
    [anon_sym_SQUOTE] = ACTIONS(2490),
    [anon_sym_L_DQUOTE] = ACTIONS(2490),
    [anon_sym_u_DQUOTE] = ACTIONS(2490),
    [anon_sym_U_DQUOTE] = ACTIONS(2490),
    [anon_sym_u8_DQUOTE] = ACTIONS(2490),
    [anon_sym_DQUOTE] = ACTIONS(2490),
    [sym_true] = ACTIONS(2488),
    [sym_false] = ACTIONS(2488),
    [anon_sym_NULL] = ACTIONS(2488),
    [anon_sym_nullptr] = ACTIONS(2488),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2488),
    [anon_sym_decltype] = ACTIONS(2488),
    [anon_sym_virtual] = ACTIONS(2488),
    [anon_sym_alignas] = ACTIONS(2488),
    [anon_sym_explicit] = ACTIONS(2488),
    [anon_sym_typename] = ACTIONS(2488),
    [anon_sym_template] = ACTIONS(2488),
    [anon_sym_operator] = ACTIONS(2488),
    [anon_sym_try] = ACTIONS(2488),
    [anon_sym_delete] = ACTIONS(2488),
    [anon_sym_throw] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_using] = ACTIONS(2488),
    [anon_sym_static_assert] = ACTIONS(2488),
    [anon_sym_concept] = ACTIONS(2488),
    [anon_sym_co_return] = ACTIONS(2488),
    [anon_sym_co_yield] = ACTIONS(2488),
    [anon_sym_catch] = ACTIONS(2883),
    [anon_sym_R_DQUOTE] = ACTIONS(2490),
    [anon_sym_LR_DQUOTE] = ACTIONS(2490),
    [anon_sym_uR_DQUOTE] = ACTIONS(2490),
    [anon_sym_UR_DQUOTE] = ACTIONS(2490),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2490),
    [anon_sym_co_await] = ACTIONS(2488),
    [anon_sym_new] = ACTIONS(2488),
    [anon_sym_requires] = ACTIONS(2488),
    [sym_this] = ACTIONS(2488),
  },
  [422] = {
    [sym_catch_clause] = STATE(395),
    [aux_sym_constructor_try_statement_repeat1] = STATE(395),
    [sym_identifier] = ACTIONS(2488),
    [aux_sym_preproc_include_token1] = ACTIONS(2488),
    [aux_sym_preproc_def_token1] = ACTIONS(2488),
    [aux_sym_preproc_if_token1] = ACTIONS(2488),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2488),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2488),
    [sym_preproc_directive] = ACTIONS(2488),
    [anon_sym_LPAREN2] = ACTIONS(2490),
    [anon_sym_BANG] = ACTIONS(2490),
    [anon_sym_TILDE] = ACTIONS(2490),
    [anon_sym_DASH] = ACTIONS(2488),
    [anon_sym_PLUS] = ACTIONS(2488),
    [anon_sym_STAR] = ACTIONS(2490),
    [anon_sym_AMP_AMP] = ACTIONS(2490),
    [anon_sym_AMP] = ACTIONS(2488),
    [anon_sym_SEMI] = ACTIONS(2490),
    [anon_sym___extension__] = ACTIONS(2488),
    [anon_sym_typedef] = ACTIONS(2488),
    [anon_sym_extern] = ACTIONS(2488),
    [anon_sym___attribute__] = ACTIONS(2488),
    [anon_sym_COLON_COLON] = ACTIONS(2490),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2490),
    [anon_sym___declspec] = ACTIONS(2488),
    [anon_sym___based] = ACTIONS(2488),
    [anon_sym___cdecl] = ACTIONS(2488),
    [anon_sym___clrcall] = ACTIONS(2488),
    [anon_sym___stdcall] = ACTIONS(2488),
    [anon_sym___fastcall] = ACTIONS(2488),
    [anon_sym___thiscall] = ACTIONS(2488),
    [anon_sym___vectorcall] = ACTIONS(2488),
    [anon_sym_LBRACE] = ACTIONS(2490),
    [anon_sym_RBRACE] = ACTIONS(2490),
    [anon_sym_signed] = ACTIONS(2488),
    [anon_sym_unsigned] = ACTIONS(2488),
    [anon_sym_long] = ACTIONS(2488),
    [anon_sym_short] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(2488),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_register] = ACTIONS(2488),
    [anon_sym_inline] = ACTIONS(2488),
    [anon_sym___inline] = ACTIONS(2488),
    [anon_sym___inline__] = ACTIONS(2488),
    [anon_sym___forceinline] = ACTIONS(2488),
    [anon_sym_thread_local] = ACTIONS(2488),
    [anon_sym___thread] = ACTIONS(2488),
    [anon_sym_const] = ACTIONS(2488),
    [anon_sym_constexpr] = ACTIONS(2488),
    [anon_sym_volatile] = ACTIONS(2488),
    [anon_sym_restrict] = ACTIONS(2488),
    [anon_sym___restrict__] = ACTIONS(2488),
    [anon_sym__Atomic] = ACTIONS(2488),
    [anon_sym__Noreturn] = ACTIONS(2488),
    [anon_sym_noreturn] = ACTIONS(2488),
    [anon_sym_mutable] = ACTIONS(2488),
    [anon_sym_constinit] = ACTIONS(2488),
    [anon_sym_consteval] = ACTIONS(2488),
    [anon_sym_PROGMEM] = ACTIONS(2488),
    [aux_sym_primitive_type_token1] = ACTIONS(2488),
    [anon_sym_byte] = ACTIONS(2488),
    [anon_sym_word] = ACTIONS(2488),
    [anon_sym_enum] = ACTIONS(2488),
    [anon_sym_class] = ACTIONS(2488),
    [anon_sym_struct] = ACTIONS(2488),
    [anon_sym_union] = ACTIONS(2488),
    [anon_sym_if] = ACTIONS(2488),
    [anon_sym_switch] = ACTIONS(2488),
    [anon_sym_case] = ACTIONS(2488),
    [anon_sym_default] = ACTIONS(2488),
    [anon_sym_while] = ACTIONS(2488),
    [anon_sym_do] = ACTIONS(2488),
    [anon_sym_for] = ACTIONS(2488),
    [anon_sym_return] = ACTIONS(2488),
    [anon_sym_break] = ACTIONS(2488),
    [anon_sym_continue] = ACTIONS(2488),
    [anon_sym_goto] = ACTIONS(2488),
    [anon_sym___try] = ACTIONS(2488),
    [anon_sym___leave] = ACTIONS(2488),
    [anon_sym_not] = ACTIONS(2488),
    [anon_sym_compl] = ACTIONS(2488),
    [anon_sym_DASH_DASH] = ACTIONS(2490),
    [anon_sym_PLUS_PLUS] = ACTIONS(2490),
    [anon_sym_sizeof] = ACTIONS(2488),
    [anon_sym___alignof__] = ACTIONS(2488),
    [anon_sym___alignof] = ACTIONS(2488),
    [anon_sym__alignof] = ACTIONS(2488),
    [anon_sym_alignof] = ACTIONS(2488),
    [anon_sym__Alignof] = ACTIONS(2488),
    [anon_sym_offsetof] = ACTIONS(2488),
    [anon_sym__Generic] = ACTIONS(2488),
    [anon_sym_asm] = ACTIONS(2488),
    [anon_sym___asm__] = ACTIONS(2488),
    [aux_sym_number_literal_token1] = ACTIONS(2490),
    [aux_sym_number_literal_token2] = ACTIONS(2488),
    [anon_sym_L_SQUOTE] = ACTIONS(2490),
    [anon_sym_u_SQUOTE] = ACTIONS(2490),
    [anon_sym_U_SQUOTE] = ACTIONS(2490),
    [anon_sym_u8_SQUOTE] = ACTIONS(2490),
    [anon_sym_SQUOTE] = ACTIONS(2490),
    [anon_sym_L_DQUOTE] = ACTIONS(2490),
    [anon_sym_u_DQUOTE] = ACTIONS(2490),
    [anon_sym_U_DQUOTE] = ACTIONS(2490),
    [anon_sym_u8_DQUOTE] = ACTIONS(2490),
    [anon_sym_DQUOTE] = ACTIONS(2490),
    [sym_true] = ACTIONS(2488),
    [sym_false] = ACTIONS(2488),
    [anon_sym_NULL] = ACTIONS(2488),
    [anon_sym_nullptr] = ACTIONS(2488),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2488),
    [anon_sym_decltype] = ACTIONS(2488),
    [anon_sym_virtual] = ACTIONS(2488),
    [anon_sym_alignas] = ACTIONS(2488),
    [anon_sym_explicit] = ACTIONS(2488),
    [anon_sym_typename] = ACTIONS(2488),
    [anon_sym_template] = ACTIONS(2488),
    [anon_sym_operator] = ACTIONS(2488),
    [anon_sym_try] = ACTIONS(2488),
    [anon_sym_delete] = ACTIONS(2488),
    [anon_sym_throw] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_using] = ACTIONS(2488),
    [anon_sym_static_assert] = ACTIONS(2488),
    [anon_sym_concept] = ACTIONS(2488),
    [anon_sym_co_return] = ACTIONS(2488),
    [anon_sym_co_yield] = ACTIONS(2488),
    [anon_sym_catch] = ACTIONS(2909),
    [anon_sym_R_DQUOTE] = ACTIONS(2490),
    [anon_sym_LR_DQUOTE] = ACTIONS(2490),
    [anon_sym_uR_DQUOTE] = ACTIONS(2490),
    [anon_sym_UR_DQUOTE] = ACTIONS(2490),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2490),
    [anon_sym_co_await] = ACTIONS(2488),
    [anon_sym_new] = ACTIONS(2488),
    [anon_sym_requires] = ACTIONS(2488),
    [sym_this] = ACTIONS(2488),
  },
  [423] = {
    [sym_catch_clause] = STATE(402),
    [aux_sym_constructor_try_statement_repeat1] = STATE(402),
    [sym_identifier] = ACTIONS(2492),
    [aux_sym_preproc_include_token1] = ACTIONS(2492),
    [aux_sym_preproc_def_token1] = ACTIONS(2492),
    [aux_sym_preproc_if_token1] = ACTIONS(2492),
    [aux_sym_preproc_if_token2] = ACTIONS(2492),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2492),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2492),
    [sym_preproc_directive] = ACTIONS(2492),
    [anon_sym_LPAREN2] = ACTIONS(2494),
    [anon_sym_BANG] = ACTIONS(2494),
    [anon_sym_TILDE] = ACTIONS(2494),
    [anon_sym_DASH] = ACTIONS(2492),
    [anon_sym_PLUS] = ACTIONS(2492),
    [anon_sym_STAR] = ACTIONS(2494),
    [anon_sym_AMP_AMP] = ACTIONS(2494),
    [anon_sym_AMP] = ACTIONS(2492),
    [anon_sym_SEMI] = ACTIONS(2494),
    [anon_sym___extension__] = ACTIONS(2492),
    [anon_sym_typedef] = ACTIONS(2492),
    [anon_sym_extern] = ACTIONS(2492),
    [anon_sym___attribute__] = ACTIONS(2492),
    [anon_sym_COLON_COLON] = ACTIONS(2494),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2494),
    [anon_sym___declspec] = ACTIONS(2492),
    [anon_sym___based] = ACTIONS(2492),
    [anon_sym___cdecl] = ACTIONS(2492),
    [anon_sym___clrcall] = ACTIONS(2492),
    [anon_sym___stdcall] = ACTIONS(2492),
    [anon_sym___fastcall] = ACTIONS(2492),
    [anon_sym___thiscall] = ACTIONS(2492),
    [anon_sym___vectorcall] = ACTIONS(2492),
    [anon_sym_LBRACE] = ACTIONS(2494),
    [anon_sym_signed] = ACTIONS(2492),
    [anon_sym_unsigned] = ACTIONS(2492),
    [anon_sym_long] = ACTIONS(2492),
    [anon_sym_short] = ACTIONS(2492),
    [anon_sym_LBRACK] = ACTIONS(2492),
    [anon_sym_static] = ACTIONS(2492),
    [anon_sym_register] = ACTIONS(2492),
    [anon_sym_inline] = ACTIONS(2492),
    [anon_sym___inline] = ACTIONS(2492),
    [anon_sym___inline__] = ACTIONS(2492),
    [anon_sym___forceinline] = ACTIONS(2492),
    [anon_sym_thread_local] = ACTIONS(2492),
    [anon_sym___thread] = ACTIONS(2492),
    [anon_sym_const] = ACTIONS(2492),
    [anon_sym_constexpr] = ACTIONS(2492),
    [anon_sym_volatile] = ACTIONS(2492),
    [anon_sym_restrict] = ACTIONS(2492),
    [anon_sym___restrict__] = ACTIONS(2492),
    [anon_sym__Atomic] = ACTIONS(2492),
    [anon_sym__Noreturn] = ACTIONS(2492),
    [anon_sym_noreturn] = ACTIONS(2492),
    [anon_sym_mutable] = ACTIONS(2492),
    [anon_sym_constinit] = ACTIONS(2492),
    [anon_sym_consteval] = ACTIONS(2492),
    [anon_sym_PROGMEM] = ACTIONS(2492),
    [aux_sym_primitive_type_token1] = ACTIONS(2492),
    [anon_sym_byte] = ACTIONS(2492),
    [anon_sym_word] = ACTIONS(2492),
    [anon_sym_enum] = ACTIONS(2492),
    [anon_sym_class] = ACTIONS(2492),
    [anon_sym_struct] = ACTIONS(2492),
    [anon_sym_union] = ACTIONS(2492),
    [anon_sym_if] = ACTIONS(2492),
    [anon_sym_switch] = ACTIONS(2492),
    [anon_sym_case] = ACTIONS(2492),
    [anon_sym_default] = ACTIONS(2492),
    [anon_sym_while] = ACTIONS(2492),
    [anon_sym_do] = ACTIONS(2492),
    [anon_sym_for] = ACTIONS(2492),
    [anon_sym_return] = ACTIONS(2492),
    [anon_sym_break] = ACTIONS(2492),
    [anon_sym_continue] = ACTIONS(2492),
    [anon_sym_goto] = ACTIONS(2492),
    [anon_sym___try] = ACTIONS(2492),
    [anon_sym___leave] = ACTIONS(2492),
    [anon_sym_not] = ACTIONS(2492),
    [anon_sym_compl] = ACTIONS(2492),
    [anon_sym_DASH_DASH] = ACTIONS(2494),
    [anon_sym_PLUS_PLUS] = ACTIONS(2494),
    [anon_sym_sizeof] = ACTIONS(2492),
    [anon_sym___alignof__] = ACTIONS(2492),
    [anon_sym___alignof] = ACTIONS(2492),
    [anon_sym__alignof] = ACTIONS(2492),
    [anon_sym_alignof] = ACTIONS(2492),
    [anon_sym__Alignof] = ACTIONS(2492),
    [anon_sym_offsetof] = ACTIONS(2492),
    [anon_sym__Generic] = ACTIONS(2492),
    [anon_sym_asm] = ACTIONS(2492),
    [anon_sym___asm__] = ACTIONS(2492),
    [aux_sym_number_literal_token1] = ACTIONS(2494),
    [aux_sym_number_literal_token2] = ACTIONS(2492),
    [anon_sym_L_SQUOTE] = ACTIONS(2494),
    [anon_sym_u_SQUOTE] = ACTIONS(2494),
    [anon_sym_U_SQUOTE] = ACTIONS(2494),
    [anon_sym_u8_SQUOTE] = ACTIONS(2494),
    [anon_sym_SQUOTE] = ACTIONS(2494),
    [anon_sym_L_DQUOTE] = ACTIONS(2494),
    [anon_sym_u_DQUOTE] = ACTIONS(2494),
    [anon_sym_U_DQUOTE] = ACTIONS(2494),
    [anon_sym_u8_DQUOTE] = ACTIONS(2494),
    [anon_sym_DQUOTE] = ACTIONS(2494),
    [sym_true] = ACTIONS(2492),
    [sym_false] = ACTIONS(2492),
    [anon_sym_NULL] = ACTIONS(2492),
    [anon_sym_nullptr] = ACTIONS(2492),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2492),
    [anon_sym_decltype] = ACTIONS(2492),
    [anon_sym_virtual] = ACTIONS(2492),
    [anon_sym_alignas] = ACTIONS(2492),
    [anon_sym_explicit] = ACTIONS(2492),
    [anon_sym_typename] = ACTIONS(2492),
    [anon_sym_template] = ACTIONS(2492),
    [anon_sym_operator] = ACTIONS(2492),
    [anon_sym_try] = ACTIONS(2492),
    [anon_sym_delete] = ACTIONS(2492),
    [anon_sym_throw] = ACTIONS(2492),
    [anon_sym_namespace] = ACTIONS(2492),
    [anon_sym_using] = ACTIONS(2492),
    [anon_sym_static_assert] = ACTIONS(2492),
    [anon_sym_concept] = ACTIONS(2492),
    [anon_sym_co_return] = ACTIONS(2492),
    [anon_sym_co_yield] = ACTIONS(2492),
    [anon_sym_catch] = ACTIONS(2883),
    [anon_sym_R_DQUOTE] = ACTIONS(2494),
    [anon_sym_LR_DQUOTE] = ACTIONS(2494),
    [anon_sym_uR_DQUOTE] = ACTIONS(2494),
    [anon_sym_UR_DQUOTE] = ACTIONS(2494),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2494),
    [anon_sym_co_await] = ACTIONS(2492),
    [anon_sym_new] = ACTIONS(2492),
    [anon_sym_requires] = ACTIONS(2492),
    [sym_this] = ACTIONS(2492),
  },
  [424] = {
    [sym_catch_clause] = STATE(395),
    [aux_sym_constructor_try_statement_repeat1] = STATE(395),
    [sym_identifier] = ACTIONS(2492),
    [aux_sym_preproc_include_token1] = ACTIONS(2492),
    [aux_sym_preproc_def_token1] = ACTIONS(2492),
    [aux_sym_preproc_if_token1] = ACTIONS(2492),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2492),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2492),
    [sym_preproc_directive] = ACTIONS(2492),
    [anon_sym_LPAREN2] = ACTIONS(2494),
    [anon_sym_BANG] = ACTIONS(2494),
    [anon_sym_TILDE] = ACTIONS(2494),
    [anon_sym_DASH] = ACTIONS(2492),
    [anon_sym_PLUS] = ACTIONS(2492),
    [anon_sym_STAR] = ACTIONS(2494),
    [anon_sym_AMP_AMP] = ACTIONS(2494),
    [anon_sym_AMP] = ACTIONS(2492),
    [anon_sym_SEMI] = ACTIONS(2494),
    [anon_sym___extension__] = ACTIONS(2492),
    [anon_sym_typedef] = ACTIONS(2492),
    [anon_sym_extern] = ACTIONS(2492),
    [anon_sym___attribute__] = ACTIONS(2492),
    [anon_sym_COLON_COLON] = ACTIONS(2494),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2494),
    [anon_sym___declspec] = ACTIONS(2492),
    [anon_sym___based] = ACTIONS(2492),
    [anon_sym___cdecl] = ACTIONS(2492),
    [anon_sym___clrcall] = ACTIONS(2492),
    [anon_sym___stdcall] = ACTIONS(2492),
    [anon_sym___fastcall] = ACTIONS(2492),
    [anon_sym___thiscall] = ACTIONS(2492),
    [anon_sym___vectorcall] = ACTIONS(2492),
    [anon_sym_LBRACE] = ACTIONS(2494),
    [anon_sym_RBRACE] = ACTIONS(2494),
    [anon_sym_signed] = ACTIONS(2492),
    [anon_sym_unsigned] = ACTIONS(2492),
    [anon_sym_long] = ACTIONS(2492),
    [anon_sym_short] = ACTIONS(2492),
    [anon_sym_LBRACK] = ACTIONS(2492),
    [anon_sym_static] = ACTIONS(2492),
    [anon_sym_register] = ACTIONS(2492),
    [anon_sym_inline] = ACTIONS(2492),
    [anon_sym___inline] = ACTIONS(2492),
    [anon_sym___inline__] = ACTIONS(2492),
    [anon_sym___forceinline] = ACTIONS(2492),
    [anon_sym_thread_local] = ACTIONS(2492),
    [anon_sym___thread] = ACTIONS(2492),
    [anon_sym_const] = ACTIONS(2492),
    [anon_sym_constexpr] = ACTIONS(2492),
    [anon_sym_volatile] = ACTIONS(2492),
    [anon_sym_restrict] = ACTIONS(2492),
    [anon_sym___restrict__] = ACTIONS(2492),
    [anon_sym__Atomic] = ACTIONS(2492),
    [anon_sym__Noreturn] = ACTIONS(2492),
    [anon_sym_noreturn] = ACTIONS(2492),
    [anon_sym_mutable] = ACTIONS(2492),
    [anon_sym_constinit] = ACTIONS(2492),
    [anon_sym_consteval] = ACTIONS(2492),
    [anon_sym_PROGMEM] = ACTIONS(2492),
    [aux_sym_primitive_type_token1] = ACTIONS(2492),
    [anon_sym_byte] = ACTIONS(2492),
    [anon_sym_word] = ACTIONS(2492),
    [anon_sym_enum] = ACTIONS(2492),
    [anon_sym_class] = ACTIONS(2492),
    [anon_sym_struct] = ACTIONS(2492),
    [anon_sym_union] = ACTIONS(2492),
    [anon_sym_if] = ACTIONS(2492),
    [anon_sym_switch] = ACTIONS(2492),
    [anon_sym_case] = ACTIONS(2492),
    [anon_sym_default] = ACTIONS(2492),
    [anon_sym_while] = ACTIONS(2492),
    [anon_sym_do] = ACTIONS(2492),
    [anon_sym_for] = ACTIONS(2492),
    [anon_sym_return] = ACTIONS(2492),
    [anon_sym_break] = ACTIONS(2492),
    [anon_sym_continue] = ACTIONS(2492),
    [anon_sym_goto] = ACTIONS(2492),
    [anon_sym___try] = ACTIONS(2492),
    [anon_sym___leave] = ACTIONS(2492),
    [anon_sym_not] = ACTIONS(2492),
    [anon_sym_compl] = ACTIONS(2492),
    [anon_sym_DASH_DASH] = ACTIONS(2494),
    [anon_sym_PLUS_PLUS] = ACTIONS(2494),
    [anon_sym_sizeof] = ACTIONS(2492),
    [anon_sym___alignof__] = ACTIONS(2492),
    [anon_sym___alignof] = ACTIONS(2492),
    [anon_sym__alignof] = ACTIONS(2492),
    [anon_sym_alignof] = ACTIONS(2492),
    [anon_sym__Alignof] = ACTIONS(2492),
    [anon_sym_offsetof] = ACTIONS(2492),
    [anon_sym__Generic] = ACTIONS(2492),
    [anon_sym_asm] = ACTIONS(2492),
    [anon_sym___asm__] = ACTIONS(2492),
    [aux_sym_number_literal_token1] = ACTIONS(2494),
    [aux_sym_number_literal_token2] = ACTIONS(2492),
    [anon_sym_L_SQUOTE] = ACTIONS(2494),
    [anon_sym_u_SQUOTE] = ACTIONS(2494),
    [anon_sym_U_SQUOTE] = ACTIONS(2494),
    [anon_sym_u8_SQUOTE] = ACTIONS(2494),
    [anon_sym_SQUOTE] = ACTIONS(2494),
    [anon_sym_L_DQUOTE] = ACTIONS(2494),
    [anon_sym_u_DQUOTE] = ACTIONS(2494),
    [anon_sym_U_DQUOTE] = ACTIONS(2494),
    [anon_sym_u8_DQUOTE] = ACTIONS(2494),
    [anon_sym_DQUOTE] = ACTIONS(2494),
    [sym_true] = ACTIONS(2492),
    [sym_false] = ACTIONS(2492),
    [anon_sym_NULL] = ACTIONS(2492),
    [anon_sym_nullptr] = ACTIONS(2492),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2492),
    [anon_sym_decltype] = ACTIONS(2492),
    [anon_sym_virtual] = ACTIONS(2492),
    [anon_sym_alignas] = ACTIONS(2492),
    [anon_sym_explicit] = ACTIONS(2492),
    [anon_sym_typename] = ACTIONS(2492),
    [anon_sym_template] = ACTIONS(2492),
    [anon_sym_operator] = ACTIONS(2492),
    [anon_sym_try] = ACTIONS(2492),
    [anon_sym_delete] = ACTIONS(2492),
    [anon_sym_throw] = ACTIONS(2492),
    [anon_sym_namespace] = ACTIONS(2492),
    [anon_sym_using] = ACTIONS(2492),
    [anon_sym_static_assert] = ACTIONS(2492),
    [anon_sym_concept] = ACTIONS(2492),
    [anon_sym_co_return] = ACTIONS(2492),
    [anon_sym_co_yield] = ACTIONS(2492),
    [anon_sym_catch] = ACTIONS(2909),
    [anon_sym_R_DQUOTE] = ACTIONS(2494),
    [anon_sym_LR_DQUOTE] = ACTIONS(2494),
    [anon_sym_uR_DQUOTE] = ACTIONS(2494),
    [anon_sym_UR_DQUOTE] = ACTIONS(2494),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2494),
    [anon_sym_co_await] = ACTIONS(2492),
    [anon_sym_new] = ACTIONS(2492),
    [anon_sym_requires] = ACTIONS(2492),
    [sym_this] = ACTIONS(2492),
  },
  [425] = {
    [sym_else_clause] = STATE(473),
    [ts_builtin_sym_end] = ACTIONS(2525),
    [sym_identifier] = ACTIONS(2523),
    [aux_sym_preproc_include_token1] = ACTIONS(2523),
    [aux_sym_preproc_def_token1] = ACTIONS(2523),
    [aux_sym_preproc_if_token1] = ACTIONS(2523),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2523),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2523),
    [sym_preproc_directive] = ACTIONS(2523),
    [anon_sym_LPAREN2] = ACTIONS(2525),
    [anon_sym_BANG] = ACTIONS(2525),
    [anon_sym_TILDE] = ACTIONS(2525),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_PLUS] = ACTIONS(2523),
    [anon_sym_STAR] = ACTIONS(2525),
    [anon_sym_AMP_AMP] = ACTIONS(2525),
    [anon_sym_AMP] = ACTIONS(2523),
    [anon_sym_SEMI] = ACTIONS(2525),
    [anon_sym___extension__] = ACTIONS(2523),
    [anon_sym_typedef] = ACTIONS(2523),
    [anon_sym_extern] = ACTIONS(2523),
    [anon_sym___attribute__] = ACTIONS(2523),
    [anon_sym_COLON_COLON] = ACTIONS(2525),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2525),
    [anon_sym___declspec] = ACTIONS(2523),
    [anon_sym___based] = ACTIONS(2523),
    [anon_sym___cdecl] = ACTIONS(2523),
    [anon_sym___clrcall] = ACTIONS(2523),
    [anon_sym___stdcall] = ACTIONS(2523),
    [anon_sym___fastcall] = ACTIONS(2523),
    [anon_sym___thiscall] = ACTIONS(2523),
    [anon_sym___vectorcall] = ACTIONS(2523),
    [anon_sym_LBRACE] = ACTIONS(2525),
    [anon_sym_signed] = ACTIONS(2523),
    [anon_sym_unsigned] = ACTIONS(2523),
    [anon_sym_long] = ACTIONS(2523),
    [anon_sym_short] = ACTIONS(2523),
    [anon_sym_LBRACK] = ACTIONS(2523),
    [anon_sym_static] = ACTIONS(2523),
    [anon_sym_register] = ACTIONS(2523),
    [anon_sym_inline] = ACTIONS(2523),
    [anon_sym___inline] = ACTIONS(2523),
    [anon_sym___inline__] = ACTIONS(2523),
    [anon_sym___forceinline] = ACTIONS(2523),
    [anon_sym_thread_local] = ACTIONS(2523),
    [anon_sym___thread] = ACTIONS(2523),
    [anon_sym_const] = ACTIONS(2523),
    [anon_sym_constexpr] = ACTIONS(2523),
    [anon_sym_volatile] = ACTIONS(2523),
    [anon_sym_restrict] = ACTIONS(2523),
    [anon_sym___restrict__] = ACTIONS(2523),
    [anon_sym__Atomic] = ACTIONS(2523),
    [anon_sym__Noreturn] = ACTIONS(2523),
    [anon_sym_noreturn] = ACTIONS(2523),
    [anon_sym_mutable] = ACTIONS(2523),
    [anon_sym_constinit] = ACTIONS(2523),
    [anon_sym_consteval] = ACTIONS(2523),
    [anon_sym_PROGMEM] = ACTIONS(2523),
    [aux_sym_primitive_type_token1] = ACTIONS(2523),
    [anon_sym_byte] = ACTIONS(2523),
    [anon_sym_word] = ACTIONS(2523),
    [anon_sym_enum] = ACTIONS(2523),
    [anon_sym_class] = ACTIONS(2523),
    [anon_sym_struct] = ACTIONS(2523),
    [anon_sym_union] = ACTIONS(2523),
    [anon_sym_if] = ACTIONS(2523),
    [anon_sym_else] = ACTIONS(3182),
    [anon_sym_switch] = ACTIONS(2523),
    [anon_sym_case] = ACTIONS(2523),
    [anon_sym_default] = ACTIONS(2523),
    [anon_sym_while] = ACTIONS(2523),
    [anon_sym_do] = ACTIONS(2523),
    [anon_sym_for] = ACTIONS(2523),
    [anon_sym_return] = ACTIONS(2523),
    [anon_sym_break] = ACTIONS(2523),
    [anon_sym_continue] = ACTIONS(2523),
    [anon_sym_goto] = ACTIONS(2523),
    [anon_sym___try] = ACTIONS(2523),
    [anon_sym___leave] = ACTIONS(2523),
    [anon_sym_not] = ACTIONS(2523),
    [anon_sym_compl] = ACTIONS(2523),
    [anon_sym_DASH_DASH] = ACTIONS(2525),
    [anon_sym_PLUS_PLUS] = ACTIONS(2525),
    [anon_sym_sizeof] = ACTIONS(2523),
    [anon_sym___alignof__] = ACTIONS(2523),
    [anon_sym___alignof] = ACTIONS(2523),
    [anon_sym__alignof] = ACTIONS(2523),
    [anon_sym_alignof] = ACTIONS(2523),
    [anon_sym__Alignof] = ACTIONS(2523),
    [anon_sym_offsetof] = ACTIONS(2523),
    [anon_sym__Generic] = ACTIONS(2523),
    [anon_sym_asm] = ACTIONS(2523),
    [anon_sym___asm__] = ACTIONS(2523),
    [aux_sym_number_literal_token1] = ACTIONS(2525),
    [aux_sym_number_literal_token2] = ACTIONS(2523),
    [anon_sym_L_SQUOTE] = ACTIONS(2525),
    [anon_sym_u_SQUOTE] = ACTIONS(2525),
    [anon_sym_U_SQUOTE] = ACTIONS(2525),
    [anon_sym_u8_SQUOTE] = ACTIONS(2525),
    [anon_sym_SQUOTE] = ACTIONS(2525),
    [anon_sym_L_DQUOTE] = ACTIONS(2525),
    [anon_sym_u_DQUOTE] = ACTIONS(2525),
    [anon_sym_U_DQUOTE] = ACTIONS(2525),
    [anon_sym_u8_DQUOTE] = ACTIONS(2525),
    [anon_sym_DQUOTE] = ACTIONS(2525),
    [sym_true] = ACTIONS(2523),
    [sym_false] = ACTIONS(2523),
    [anon_sym_NULL] = ACTIONS(2523),
    [anon_sym_nullptr] = ACTIONS(2523),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2523),
    [anon_sym_decltype] = ACTIONS(2523),
    [anon_sym_virtual] = ACTIONS(2523),
    [anon_sym_alignas] = ACTIONS(2523),
    [anon_sym_explicit] = ACTIONS(2523),
    [anon_sym_typename] = ACTIONS(2523),
    [anon_sym_template] = ACTIONS(2523),
    [anon_sym_operator] = ACTIONS(2523),
    [anon_sym_try] = ACTIONS(2523),
    [anon_sym_delete] = ACTIONS(2523),
    [anon_sym_throw] = ACTIONS(2523),
    [anon_sym_namespace] = ACTIONS(2523),
    [anon_sym_using] = ACTIONS(2523),
    [anon_sym_static_assert] = ACTIONS(2523),
    [anon_sym_concept] = ACTIONS(2523),
    [anon_sym_co_return] = ACTIONS(2523),
    [anon_sym_co_yield] = ACTIONS(2523),
    [anon_sym_R_DQUOTE] = ACTIONS(2525),
    [anon_sym_LR_DQUOTE] = ACTIONS(2525),
    [anon_sym_uR_DQUOTE] = ACTIONS(2525),
    [anon_sym_UR_DQUOTE] = ACTIONS(2525),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2525),
    [anon_sym_co_await] = ACTIONS(2523),
    [anon_sym_new] = ACTIONS(2523),
    [anon_sym_requires] = ACTIONS(2523),
    [sym_this] = ACTIONS(2523),
  },
  [426] = {
    [sym_identifier] = ACTIONS(1957),
    [aux_sym_preproc_include_token1] = ACTIONS(1957),
    [aux_sym_preproc_def_token1] = ACTIONS(1957),
    [aux_sym_preproc_if_token1] = ACTIONS(1957),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1957),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1957),
    [sym_preproc_directive] = ACTIONS(1957),
    [anon_sym_LPAREN2] = ACTIONS(1955),
    [anon_sym_BANG] = ACTIONS(1955),
    [anon_sym_TILDE] = ACTIONS(1955),
    [anon_sym_DASH] = ACTIONS(1957),
    [anon_sym_PLUS] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(1955),
    [anon_sym_AMP_AMP] = ACTIONS(1955),
    [anon_sym_AMP] = ACTIONS(1957),
    [anon_sym_SEMI] = ACTIONS(1955),
    [anon_sym___extension__] = ACTIONS(1957),
    [anon_sym_typedef] = ACTIONS(1957),
    [anon_sym_extern] = ACTIONS(1957),
    [anon_sym___attribute__] = ACTIONS(1957),
    [anon_sym_COLON_COLON] = ACTIONS(1955),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1955),
    [anon_sym___declspec] = ACTIONS(1957),
    [anon_sym___based] = ACTIONS(1957),
    [anon_sym___cdecl] = ACTIONS(1957),
    [anon_sym___clrcall] = ACTIONS(1957),
    [anon_sym___stdcall] = ACTIONS(1957),
    [anon_sym___fastcall] = ACTIONS(1957),
    [anon_sym___thiscall] = ACTIONS(1957),
    [anon_sym___vectorcall] = ACTIONS(1957),
    [anon_sym_LBRACE] = ACTIONS(1955),
    [anon_sym_RBRACE] = ACTIONS(1955),
    [anon_sym_signed] = ACTIONS(1957),
    [anon_sym_unsigned] = ACTIONS(1957),
    [anon_sym_long] = ACTIONS(1957),
    [anon_sym_short] = ACTIONS(1957),
    [anon_sym_LBRACK] = ACTIONS(1957),
    [anon_sym_static] = ACTIONS(1957),
    [anon_sym_register] = ACTIONS(1957),
    [anon_sym_inline] = ACTIONS(1957),
    [anon_sym___inline] = ACTIONS(1957),
    [anon_sym___inline__] = ACTIONS(1957),
    [anon_sym___forceinline] = ACTIONS(1957),
    [anon_sym_thread_local] = ACTIONS(1957),
    [anon_sym___thread] = ACTIONS(1957),
    [anon_sym_const] = ACTIONS(1957),
    [anon_sym_constexpr] = ACTIONS(1957),
    [anon_sym_volatile] = ACTIONS(1957),
    [anon_sym_restrict] = ACTIONS(1957),
    [anon_sym___restrict__] = ACTIONS(1957),
    [anon_sym__Atomic] = ACTIONS(1957),
    [anon_sym__Noreturn] = ACTIONS(1957),
    [anon_sym_noreturn] = ACTIONS(1957),
    [anon_sym_mutable] = ACTIONS(1957),
    [anon_sym_constinit] = ACTIONS(1957),
    [anon_sym_consteval] = ACTIONS(1957),
    [anon_sym_PROGMEM] = ACTIONS(1957),
    [aux_sym_primitive_type_token1] = ACTIONS(1957),
    [anon_sym_byte] = ACTIONS(1957),
    [anon_sym_word] = ACTIONS(1957),
    [anon_sym_enum] = ACTIONS(1957),
    [anon_sym_class] = ACTIONS(1957),
    [anon_sym_struct] = ACTIONS(1957),
    [anon_sym_union] = ACTIONS(1957),
    [anon_sym_if] = ACTIONS(1957),
    [anon_sym_else] = ACTIONS(1957),
    [anon_sym_switch] = ACTIONS(1957),
    [anon_sym_case] = ACTIONS(1957),
    [anon_sym_default] = ACTIONS(1957),
    [anon_sym_while] = ACTIONS(1957),
    [anon_sym_do] = ACTIONS(1957),
    [anon_sym_for] = ACTIONS(1957),
    [anon_sym_return] = ACTIONS(1957),
    [anon_sym_break] = ACTIONS(1957),
    [anon_sym_continue] = ACTIONS(1957),
    [anon_sym_goto] = ACTIONS(1957),
    [anon_sym___try] = ACTIONS(1957),
    [anon_sym___leave] = ACTIONS(1957),
    [anon_sym_not] = ACTIONS(1957),
    [anon_sym_compl] = ACTIONS(1957),
    [anon_sym_DASH_DASH] = ACTIONS(1955),
    [anon_sym_PLUS_PLUS] = ACTIONS(1955),
    [anon_sym_sizeof] = ACTIONS(1957),
    [anon_sym___alignof__] = ACTIONS(1957),
    [anon_sym___alignof] = ACTIONS(1957),
    [anon_sym__alignof] = ACTIONS(1957),
    [anon_sym_alignof] = ACTIONS(1957),
    [anon_sym__Alignof] = ACTIONS(1957),
    [anon_sym_offsetof] = ACTIONS(1957),
    [anon_sym__Generic] = ACTIONS(1957),
    [anon_sym_asm] = ACTIONS(1957),
    [anon_sym___asm__] = ACTIONS(1957),
    [aux_sym_number_literal_token1] = ACTIONS(1955),
    [aux_sym_number_literal_token2] = ACTIONS(1957),
    [anon_sym_L_SQUOTE] = ACTIONS(1955),
    [anon_sym_u_SQUOTE] = ACTIONS(1955),
    [anon_sym_U_SQUOTE] = ACTIONS(1955),
    [anon_sym_u8_SQUOTE] = ACTIONS(1955),
    [anon_sym_SQUOTE] = ACTIONS(1955),
    [anon_sym_L_DQUOTE] = ACTIONS(1955),
    [anon_sym_u_DQUOTE] = ACTIONS(1955),
    [anon_sym_U_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8_DQUOTE] = ACTIONS(1955),
    [anon_sym_DQUOTE] = ACTIONS(1955),
    [sym_true] = ACTIONS(1957),
    [sym_false] = ACTIONS(1957),
    [anon_sym_NULL] = ACTIONS(1957),
    [anon_sym_nullptr] = ACTIONS(1957),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1957),
    [anon_sym_decltype] = ACTIONS(1957),
    [anon_sym_virtual] = ACTIONS(1957),
    [anon_sym_alignas] = ACTIONS(1957),
    [anon_sym_explicit] = ACTIONS(1957),
    [anon_sym_typename] = ACTIONS(1957),
    [anon_sym_template] = ACTIONS(1957),
    [anon_sym_operator] = ACTIONS(1957),
    [anon_sym_try] = ACTIONS(1957),
    [anon_sym_delete] = ACTIONS(1957),
    [anon_sym_throw] = ACTIONS(1957),
    [anon_sym_namespace] = ACTIONS(1957),
    [anon_sym_using] = ACTIONS(1957),
    [anon_sym_static_assert] = ACTIONS(1957),
    [anon_sym_concept] = ACTIONS(1957),
    [anon_sym_co_return] = ACTIONS(1957),
    [anon_sym_co_yield] = ACTIONS(1957),
    [anon_sym_catch] = ACTIONS(1957),
    [anon_sym_R_DQUOTE] = ACTIONS(1955),
    [anon_sym_LR_DQUOTE] = ACTIONS(1955),
    [anon_sym_uR_DQUOTE] = ACTIONS(1955),
    [anon_sym_UR_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1955),
    [anon_sym_co_await] = ACTIONS(1957),
    [anon_sym_new] = ACTIONS(1957),
    [anon_sym_requires] = ACTIONS(1957),
    [sym_this] = ACTIONS(1957),
  },
  [427] = {
    [sym_else_clause] = STATE(455),
    [ts_builtin_sym_end] = ACTIONS(2498),
    [sym_identifier] = ACTIONS(2496),
    [aux_sym_preproc_include_token1] = ACTIONS(2496),
    [aux_sym_preproc_def_token1] = ACTIONS(2496),
    [aux_sym_preproc_if_token1] = ACTIONS(2496),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2496),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2496),
    [sym_preproc_directive] = ACTIONS(2496),
    [anon_sym_LPAREN2] = ACTIONS(2498),
    [anon_sym_BANG] = ACTIONS(2498),
    [anon_sym_TILDE] = ACTIONS(2498),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_STAR] = ACTIONS(2498),
    [anon_sym_AMP_AMP] = ACTIONS(2498),
    [anon_sym_AMP] = ACTIONS(2496),
    [anon_sym_SEMI] = ACTIONS(2498),
    [anon_sym___extension__] = ACTIONS(2496),
    [anon_sym_typedef] = ACTIONS(2496),
    [anon_sym_extern] = ACTIONS(2496),
    [anon_sym___attribute__] = ACTIONS(2496),
    [anon_sym_COLON_COLON] = ACTIONS(2498),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2498),
    [anon_sym___declspec] = ACTIONS(2496),
    [anon_sym___based] = ACTIONS(2496),
    [anon_sym___cdecl] = ACTIONS(2496),
    [anon_sym___clrcall] = ACTIONS(2496),
    [anon_sym___stdcall] = ACTIONS(2496),
    [anon_sym___fastcall] = ACTIONS(2496),
    [anon_sym___thiscall] = ACTIONS(2496),
    [anon_sym___vectorcall] = ACTIONS(2496),
    [anon_sym_LBRACE] = ACTIONS(2498),
    [anon_sym_signed] = ACTIONS(2496),
    [anon_sym_unsigned] = ACTIONS(2496),
    [anon_sym_long] = ACTIONS(2496),
    [anon_sym_short] = ACTIONS(2496),
    [anon_sym_LBRACK] = ACTIONS(2496),
    [anon_sym_static] = ACTIONS(2496),
    [anon_sym_register] = ACTIONS(2496),
    [anon_sym_inline] = ACTIONS(2496),
    [anon_sym___inline] = ACTIONS(2496),
    [anon_sym___inline__] = ACTIONS(2496),
    [anon_sym___forceinline] = ACTIONS(2496),
    [anon_sym_thread_local] = ACTIONS(2496),
    [anon_sym___thread] = ACTIONS(2496),
    [anon_sym_const] = ACTIONS(2496),
    [anon_sym_constexpr] = ACTIONS(2496),
    [anon_sym_volatile] = ACTIONS(2496),
    [anon_sym_restrict] = ACTIONS(2496),
    [anon_sym___restrict__] = ACTIONS(2496),
    [anon_sym__Atomic] = ACTIONS(2496),
    [anon_sym__Noreturn] = ACTIONS(2496),
    [anon_sym_noreturn] = ACTIONS(2496),
    [anon_sym_mutable] = ACTIONS(2496),
    [anon_sym_constinit] = ACTIONS(2496),
    [anon_sym_consteval] = ACTIONS(2496),
    [anon_sym_PROGMEM] = ACTIONS(2496),
    [aux_sym_primitive_type_token1] = ACTIONS(2496),
    [anon_sym_byte] = ACTIONS(2496),
    [anon_sym_word] = ACTIONS(2496),
    [anon_sym_enum] = ACTIONS(2496),
    [anon_sym_class] = ACTIONS(2496),
    [anon_sym_struct] = ACTIONS(2496),
    [anon_sym_union] = ACTIONS(2496),
    [anon_sym_if] = ACTIONS(2496),
    [anon_sym_else] = ACTIONS(3182),
    [anon_sym_switch] = ACTIONS(2496),
    [anon_sym_case] = ACTIONS(2496),
    [anon_sym_default] = ACTIONS(2496),
    [anon_sym_while] = ACTIONS(2496),
    [anon_sym_do] = ACTIONS(2496),
    [anon_sym_for] = ACTIONS(2496),
    [anon_sym_return] = ACTIONS(2496),
    [anon_sym_break] = ACTIONS(2496),
    [anon_sym_continue] = ACTIONS(2496),
    [anon_sym_goto] = ACTIONS(2496),
    [anon_sym___try] = ACTIONS(2496),
    [anon_sym___leave] = ACTIONS(2496),
    [anon_sym_not] = ACTIONS(2496),
    [anon_sym_compl] = ACTIONS(2496),
    [anon_sym_DASH_DASH] = ACTIONS(2498),
    [anon_sym_PLUS_PLUS] = ACTIONS(2498),
    [anon_sym_sizeof] = ACTIONS(2496),
    [anon_sym___alignof__] = ACTIONS(2496),
    [anon_sym___alignof] = ACTIONS(2496),
    [anon_sym__alignof] = ACTIONS(2496),
    [anon_sym_alignof] = ACTIONS(2496),
    [anon_sym__Alignof] = ACTIONS(2496),
    [anon_sym_offsetof] = ACTIONS(2496),
    [anon_sym__Generic] = ACTIONS(2496),
    [anon_sym_asm] = ACTIONS(2496),
    [anon_sym___asm__] = ACTIONS(2496),
    [aux_sym_number_literal_token1] = ACTIONS(2498),
    [aux_sym_number_literal_token2] = ACTIONS(2496),
    [anon_sym_L_SQUOTE] = ACTIONS(2498),
    [anon_sym_u_SQUOTE] = ACTIONS(2498),
    [anon_sym_U_SQUOTE] = ACTIONS(2498),
    [anon_sym_u8_SQUOTE] = ACTIONS(2498),
    [anon_sym_SQUOTE] = ACTIONS(2498),
    [anon_sym_L_DQUOTE] = ACTIONS(2498),
    [anon_sym_u_DQUOTE] = ACTIONS(2498),
    [anon_sym_U_DQUOTE] = ACTIONS(2498),
    [anon_sym_u8_DQUOTE] = ACTIONS(2498),
    [anon_sym_DQUOTE] = ACTIONS(2498),
    [sym_true] = ACTIONS(2496),
    [sym_false] = ACTIONS(2496),
    [anon_sym_NULL] = ACTIONS(2496),
    [anon_sym_nullptr] = ACTIONS(2496),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2496),
    [anon_sym_decltype] = ACTIONS(2496),
    [anon_sym_virtual] = ACTIONS(2496),
    [anon_sym_alignas] = ACTIONS(2496),
    [anon_sym_explicit] = ACTIONS(2496),
    [anon_sym_typename] = ACTIONS(2496),
    [anon_sym_template] = ACTIONS(2496),
    [anon_sym_operator] = ACTIONS(2496),
    [anon_sym_try] = ACTIONS(2496),
    [anon_sym_delete] = ACTIONS(2496),
    [anon_sym_throw] = ACTIONS(2496),
    [anon_sym_namespace] = ACTIONS(2496),
    [anon_sym_using] = ACTIONS(2496),
    [anon_sym_static_assert] = ACTIONS(2496),
    [anon_sym_concept] = ACTIONS(2496),
    [anon_sym_co_return] = ACTIONS(2496),
    [anon_sym_co_yield] = ACTIONS(2496),
    [anon_sym_R_DQUOTE] = ACTIONS(2498),
    [anon_sym_LR_DQUOTE] = ACTIONS(2498),
    [anon_sym_uR_DQUOTE] = ACTIONS(2498),
    [anon_sym_UR_DQUOTE] = ACTIONS(2498),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2498),
    [anon_sym_co_await] = ACTIONS(2496),
    [anon_sym_new] = ACTIONS(2496),
    [anon_sym_requires] = ACTIONS(2496),
    [sym_this] = ACTIONS(2496),
  },
  [428] = {
    [sym_else_clause] = STATE(566),
    [sym_identifier] = ACTIONS(2496),
    [aux_sym_preproc_include_token1] = ACTIONS(2496),
    [aux_sym_preproc_def_token1] = ACTIONS(2496),
    [aux_sym_preproc_if_token1] = ACTIONS(2496),
    [aux_sym_preproc_if_token2] = ACTIONS(2496),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2496),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2496),
    [sym_preproc_directive] = ACTIONS(2496),
    [anon_sym_LPAREN2] = ACTIONS(2498),
    [anon_sym_BANG] = ACTIONS(2498),
    [anon_sym_TILDE] = ACTIONS(2498),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_STAR] = ACTIONS(2498),
    [anon_sym_AMP_AMP] = ACTIONS(2498),
    [anon_sym_AMP] = ACTIONS(2496),
    [anon_sym_SEMI] = ACTIONS(2498),
    [anon_sym___extension__] = ACTIONS(2496),
    [anon_sym_typedef] = ACTIONS(2496),
    [anon_sym_extern] = ACTIONS(2496),
    [anon_sym___attribute__] = ACTIONS(2496),
    [anon_sym_COLON_COLON] = ACTIONS(2498),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2498),
    [anon_sym___declspec] = ACTIONS(2496),
    [anon_sym___based] = ACTIONS(2496),
    [anon_sym___cdecl] = ACTIONS(2496),
    [anon_sym___clrcall] = ACTIONS(2496),
    [anon_sym___stdcall] = ACTIONS(2496),
    [anon_sym___fastcall] = ACTIONS(2496),
    [anon_sym___thiscall] = ACTIONS(2496),
    [anon_sym___vectorcall] = ACTIONS(2496),
    [anon_sym_LBRACE] = ACTIONS(2498),
    [anon_sym_signed] = ACTIONS(2496),
    [anon_sym_unsigned] = ACTIONS(2496),
    [anon_sym_long] = ACTIONS(2496),
    [anon_sym_short] = ACTIONS(2496),
    [anon_sym_LBRACK] = ACTIONS(2496),
    [anon_sym_static] = ACTIONS(2496),
    [anon_sym_register] = ACTIONS(2496),
    [anon_sym_inline] = ACTIONS(2496),
    [anon_sym___inline] = ACTIONS(2496),
    [anon_sym___inline__] = ACTIONS(2496),
    [anon_sym___forceinline] = ACTIONS(2496),
    [anon_sym_thread_local] = ACTIONS(2496),
    [anon_sym___thread] = ACTIONS(2496),
    [anon_sym_const] = ACTIONS(2496),
    [anon_sym_constexpr] = ACTIONS(2496),
    [anon_sym_volatile] = ACTIONS(2496),
    [anon_sym_restrict] = ACTIONS(2496),
    [anon_sym___restrict__] = ACTIONS(2496),
    [anon_sym__Atomic] = ACTIONS(2496),
    [anon_sym__Noreturn] = ACTIONS(2496),
    [anon_sym_noreturn] = ACTIONS(2496),
    [anon_sym_mutable] = ACTIONS(2496),
    [anon_sym_constinit] = ACTIONS(2496),
    [anon_sym_consteval] = ACTIONS(2496),
    [anon_sym_PROGMEM] = ACTIONS(2496),
    [aux_sym_primitive_type_token1] = ACTIONS(2496),
    [anon_sym_byte] = ACTIONS(2496),
    [anon_sym_word] = ACTIONS(2496),
    [anon_sym_enum] = ACTIONS(2496),
    [anon_sym_class] = ACTIONS(2496),
    [anon_sym_struct] = ACTIONS(2496),
    [anon_sym_union] = ACTIONS(2496),
    [anon_sym_if] = ACTIONS(2496),
    [anon_sym_else] = ACTIONS(3184),
    [anon_sym_switch] = ACTIONS(2496),
    [anon_sym_case] = ACTIONS(2496),
    [anon_sym_default] = ACTIONS(2496),
    [anon_sym_while] = ACTIONS(2496),
    [anon_sym_do] = ACTIONS(2496),
    [anon_sym_for] = ACTIONS(2496),
    [anon_sym_return] = ACTIONS(2496),
    [anon_sym_break] = ACTIONS(2496),
    [anon_sym_continue] = ACTIONS(2496),
    [anon_sym_goto] = ACTIONS(2496),
    [anon_sym___try] = ACTIONS(2496),
    [anon_sym___leave] = ACTIONS(2496),
    [anon_sym_not] = ACTIONS(2496),
    [anon_sym_compl] = ACTIONS(2496),
    [anon_sym_DASH_DASH] = ACTIONS(2498),
    [anon_sym_PLUS_PLUS] = ACTIONS(2498),
    [anon_sym_sizeof] = ACTIONS(2496),
    [anon_sym___alignof__] = ACTIONS(2496),
    [anon_sym___alignof] = ACTIONS(2496),
    [anon_sym__alignof] = ACTIONS(2496),
    [anon_sym_alignof] = ACTIONS(2496),
    [anon_sym__Alignof] = ACTIONS(2496),
    [anon_sym_offsetof] = ACTIONS(2496),
    [anon_sym__Generic] = ACTIONS(2496),
    [anon_sym_asm] = ACTIONS(2496),
    [anon_sym___asm__] = ACTIONS(2496),
    [aux_sym_number_literal_token1] = ACTIONS(2498),
    [aux_sym_number_literal_token2] = ACTIONS(2496),
    [anon_sym_L_SQUOTE] = ACTIONS(2498),
    [anon_sym_u_SQUOTE] = ACTIONS(2498),
    [anon_sym_U_SQUOTE] = ACTIONS(2498),
    [anon_sym_u8_SQUOTE] = ACTIONS(2498),
    [anon_sym_SQUOTE] = ACTIONS(2498),
    [anon_sym_L_DQUOTE] = ACTIONS(2498),
    [anon_sym_u_DQUOTE] = ACTIONS(2498),
    [anon_sym_U_DQUOTE] = ACTIONS(2498),
    [anon_sym_u8_DQUOTE] = ACTIONS(2498),
    [anon_sym_DQUOTE] = ACTIONS(2498),
    [sym_true] = ACTIONS(2496),
    [sym_false] = ACTIONS(2496),
    [anon_sym_NULL] = ACTIONS(2496),
    [anon_sym_nullptr] = ACTIONS(2496),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2496),
    [anon_sym_decltype] = ACTIONS(2496),
    [anon_sym_virtual] = ACTIONS(2496),
    [anon_sym_alignas] = ACTIONS(2496),
    [anon_sym_explicit] = ACTIONS(2496),
    [anon_sym_typename] = ACTIONS(2496),
    [anon_sym_template] = ACTIONS(2496),
    [anon_sym_operator] = ACTIONS(2496),
    [anon_sym_try] = ACTIONS(2496),
    [anon_sym_delete] = ACTIONS(2496),
    [anon_sym_throw] = ACTIONS(2496),
    [anon_sym_namespace] = ACTIONS(2496),
    [anon_sym_using] = ACTIONS(2496),
    [anon_sym_static_assert] = ACTIONS(2496),
    [anon_sym_concept] = ACTIONS(2496),
    [anon_sym_co_return] = ACTIONS(2496),
    [anon_sym_co_yield] = ACTIONS(2496),
    [anon_sym_R_DQUOTE] = ACTIONS(2498),
    [anon_sym_LR_DQUOTE] = ACTIONS(2498),
    [anon_sym_uR_DQUOTE] = ACTIONS(2498),
    [anon_sym_UR_DQUOTE] = ACTIONS(2498),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2498),
    [anon_sym_co_await] = ACTIONS(2496),
    [anon_sym_new] = ACTIONS(2496),
    [anon_sym_requires] = ACTIONS(2496),
    [sym_this] = ACTIONS(2496),
  },
  [429] = {
    [sym_identifier] = ACTIONS(1961),
    [aux_sym_preproc_include_token1] = ACTIONS(1961),
    [aux_sym_preproc_def_token1] = ACTIONS(1961),
    [aux_sym_preproc_if_token1] = ACTIONS(1961),
    [aux_sym_preproc_if_token2] = ACTIONS(1961),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1961),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1961),
    [sym_preproc_directive] = ACTIONS(1961),
    [anon_sym_LPAREN2] = ACTIONS(1959),
    [anon_sym_BANG] = ACTIONS(1959),
    [anon_sym_TILDE] = ACTIONS(1959),
    [anon_sym_DASH] = ACTIONS(1961),
    [anon_sym_PLUS] = ACTIONS(1961),
    [anon_sym_STAR] = ACTIONS(1959),
    [anon_sym_AMP_AMP] = ACTIONS(1959),
    [anon_sym_AMP] = ACTIONS(1961),
    [anon_sym_SEMI] = ACTIONS(1959),
    [anon_sym___extension__] = ACTIONS(1961),
    [anon_sym_typedef] = ACTIONS(1961),
    [anon_sym_extern] = ACTIONS(1961),
    [anon_sym___attribute__] = ACTIONS(1961),
    [anon_sym_COLON_COLON] = ACTIONS(1959),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1959),
    [anon_sym___declspec] = ACTIONS(1961),
    [anon_sym___based] = ACTIONS(1961),
    [anon_sym___cdecl] = ACTIONS(1961),
    [anon_sym___clrcall] = ACTIONS(1961),
    [anon_sym___stdcall] = ACTIONS(1961),
    [anon_sym___fastcall] = ACTIONS(1961),
    [anon_sym___thiscall] = ACTIONS(1961),
    [anon_sym___vectorcall] = ACTIONS(1961),
    [anon_sym_LBRACE] = ACTIONS(1959),
    [anon_sym_signed] = ACTIONS(1961),
    [anon_sym_unsigned] = ACTIONS(1961),
    [anon_sym_long] = ACTIONS(1961),
    [anon_sym_short] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1961),
    [anon_sym_static] = ACTIONS(1961),
    [anon_sym_register] = ACTIONS(1961),
    [anon_sym_inline] = ACTIONS(1961),
    [anon_sym___inline] = ACTIONS(1961),
    [anon_sym___inline__] = ACTIONS(1961),
    [anon_sym___forceinline] = ACTIONS(1961),
    [anon_sym_thread_local] = ACTIONS(1961),
    [anon_sym___thread] = ACTIONS(1961),
    [anon_sym_const] = ACTIONS(1961),
    [anon_sym_constexpr] = ACTIONS(1961),
    [anon_sym_volatile] = ACTIONS(1961),
    [anon_sym_restrict] = ACTIONS(1961),
    [anon_sym___restrict__] = ACTIONS(1961),
    [anon_sym__Atomic] = ACTIONS(1961),
    [anon_sym__Noreturn] = ACTIONS(1961),
    [anon_sym_noreturn] = ACTIONS(1961),
    [anon_sym_mutable] = ACTIONS(1961),
    [anon_sym_constinit] = ACTIONS(1961),
    [anon_sym_consteval] = ACTIONS(1961),
    [anon_sym_PROGMEM] = ACTIONS(1961),
    [aux_sym_primitive_type_token1] = ACTIONS(1961),
    [anon_sym_byte] = ACTIONS(1961),
    [anon_sym_word] = ACTIONS(1961),
    [anon_sym_enum] = ACTIONS(1961),
    [anon_sym_class] = ACTIONS(1961),
    [anon_sym_struct] = ACTIONS(1961),
    [anon_sym_union] = ACTIONS(1961),
    [anon_sym_if] = ACTIONS(1961),
    [anon_sym_else] = ACTIONS(1961),
    [anon_sym_switch] = ACTIONS(1961),
    [anon_sym_case] = ACTIONS(1961),
    [anon_sym_default] = ACTIONS(1961),
    [anon_sym_while] = ACTIONS(1961),
    [anon_sym_do] = ACTIONS(1961),
    [anon_sym_for] = ACTIONS(1961),
    [anon_sym_return] = ACTIONS(1961),
    [anon_sym_break] = ACTIONS(1961),
    [anon_sym_continue] = ACTIONS(1961),
    [anon_sym_goto] = ACTIONS(1961),
    [anon_sym___try] = ACTIONS(1961),
    [anon_sym___leave] = ACTIONS(1961),
    [anon_sym_not] = ACTIONS(1961),
    [anon_sym_compl] = ACTIONS(1961),
    [anon_sym_DASH_DASH] = ACTIONS(1959),
    [anon_sym_PLUS_PLUS] = ACTIONS(1959),
    [anon_sym_sizeof] = ACTIONS(1961),
    [anon_sym___alignof__] = ACTIONS(1961),
    [anon_sym___alignof] = ACTIONS(1961),
    [anon_sym__alignof] = ACTIONS(1961),
    [anon_sym_alignof] = ACTIONS(1961),
    [anon_sym__Alignof] = ACTIONS(1961),
    [anon_sym_offsetof] = ACTIONS(1961),
    [anon_sym__Generic] = ACTIONS(1961),
    [anon_sym_asm] = ACTIONS(1961),
    [anon_sym___asm__] = ACTIONS(1961),
    [aux_sym_number_literal_token1] = ACTIONS(1959),
    [aux_sym_number_literal_token2] = ACTIONS(1961),
    [anon_sym_L_SQUOTE] = ACTIONS(1959),
    [anon_sym_u_SQUOTE] = ACTIONS(1959),
    [anon_sym_U_SQUOTE] = ACTIONS(1959),
    [anon_sym_u8_SQUOTE] = ACTIONS(1959),
    [anon_sym_SQUOTE] = ACTIONS(1959),
    [anon_sym_L_DQUOTE] = ACTIONS(1959),
    [anon_sym_u_DQUOTE] = ACTIONS(1959),
    [anon_sym_U_DQUOTE] = ACTIONS(1959),
    [anon_sym_u8_DQUOTE] = ACTIONS(1959),
    [anon_sym_DQUOTE] = ACTIONS(1959),
    [sym_true] = ACTIONS(1961),
    [sym_false] = ACTIONS(1961),
    [anon_sym_NULL] = ACTIONS(1961),
    [anon_sym_nullptr] = ACTIONS(1961),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1961),
    [anon_sym_decltype] = ACTIONS(1961),
    [anon_sym_virtual] = ACTIONS(1961),
    [anon_sym_alignas] = ACTIONS(1961),
    [anon_sym_explicit] = ACTIONS(1961),
    [anon_sym_typename] = ACTIONS(1961),
    [anon_sym_template] = ACTIONS(1961),
    [anon_sym_operator] = ACTIONS(1961),
    [anon_sym_try] = ACTIONS(1961),
    [anon_sym_delete] = ACTIONS(1961),
    [anon_sym_throw] = ACTIONS(1961),
    [anon_sym_namespace] = ACTIONS(1961),
    [anon_sym_using] = ACTIONS(1961),
    [anon_sym_static_assert] = ACTIONS(1961),
    [anon_sym_concept] = ACTIONS(1961),
    [anon_sym_co_return] = ACTIONS(1961),
    [anon_sym_co_yield] = ACTIONS(1961),
    [anon_sym_catch] = ACTIONS(1961),
    [anon_sym_R_DQUOTE] = ACTIONS(1959),
    [anon_sym_LR_DQUOTE] = ACTIONS(1959),
    [anon_sym_uR_DQUOTE] = ACTIONS(1959),
    [anon_sym_UR_DQUOTE] = ACTIONS(1959),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1959),
    [anon_sym_co_await] = ACTIONS(1961),
    [anon_sym_new] = ACTIONS(1961),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1961),
  },
  [430] = {
    [sym_else_clause] = STATE(556),
    [sym_identifier] = ACTIONS(2496),
    [aux_sym_preproc_include_token1] = ACTIONS(2496),
    [aux_sym_preproc_def_token1] = ACTIONS(2496),
    [aux_sym_preproc_if_token1] = ACTIONS(2496),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2496),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2496),
    [sym_preproc_directive] = ACTIONS(2496),
    [anon_sym_LPAREN2] = ACTIONS(2498),
    [anon_sym_BANG] = ACTIONS(2498),
    [anon_sym_TILDE] = ACTIONS(2498),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_STAR] = ACTIONS(2498),
    [anon_sym_AMP_AMP] = ACTIONS(2498),
    [anon_sym_AMP] = ACTIONS(2496),
    [anon_sym_SEMI] = ACTIONS(2498),
    [anon_sym___extension__] = ACTIONS(2496),
    [anon_sym_typedef] = ACTIONS(2496),
    [anon_sym_extern] = ACTIONS(2496),
    [anon_sym___attribute__] = ACTIONS(2496),
    [anon_sym_COLON_COLON] = ACTIONS(2498),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2498),
    [anon_sym___declspec] = ACTIONS(2496),
    [anon_sym___based] = ACTIONS(2496),
    [anon_sym___cdecl] = ACTIONS(2496),
    [anon_sym___clrcall] = ACTIONS(2496),
    [anon_sym___stdcall] = ACTIONS(2496),
    [anon_sym___fastcall] = ACTIONS(2496),
    [anon_sym___thiscall] = ACTIONS(2496),
    [anon_sym___vectorcall] = ACTIONS(2496),
    [anon_sym_LBRACE] = ACTIONS(2498),
    [anon_sym_RBRACE] = ACTIONS(2498),
    [anon_sym_signed] = ACTIONS(2496),
    [anon_sym_unsigned] = ACTIONS(2496),
    [anon_sym_long] = ACTIONS(2496),
    [anon_sym_short] = ACTIONS(2496),
    [anon_sym_LBRACK] = ACTIONS(2496),
    [anon_sym_static] = ACTIONS(2496),
    [anon_sym_register] = ACTIONS(2496),
    [anon_sym_inline] = ACTIONS(2496),
    [anon_sym___inline] = ACTIONS(2496),
    [anon_sym___inline__] = ACTIONS(2496),
    [anon_sym___forceinline] = ACTIONS(2496),
    [anon_sym_thread_local] = ACTIONS(2496),
    [anon_sym___thread] = ACTIONS(2496),
    [anon_sym_const] = ACTIONS(2496),
    [anon_sym_constexpr] = ACTIONS(2496),
    [anon_sym_volatile] = ACTIONS(2496),
    [anon_sym_restrict] = ACTIONS(2496),
    [anon_sym___restrict__] = ACTIONS(2496),
    [anon_sym__Atomic] = ACTIONS(2496),
    [anon_sym__Noreturn] = ACTIONS(2496),
    [anon_sym_noreturn] = ACTIONS(2496),
    [anon_sym_mutable] = ACTIONS(2496),
    [anon_sym_constinit] = ACTIONS(2496),
    [anon_sym_consteval] = ACTIONS(2496),
    [anon_sym_PROGMEM] = ACTIONS(2496),
    [aux_sym_primitive_type_token1] = ACTIONS(2496),
    [anon_sym_byte] = ACTIONS(2496),
    [anon_sym_word] = ACTIONS(2496),
    [anon_sym_enum] = ACTIONS(2496),
    [anon_sym_class] = ACTIONS(2496),
    [anon_sym_struct] = ACTIONS(2496),
    [anon_sym_union] = ACTIONS(2496),
    [anon_sym_if] = ACTIONS(2496),
    [anon_sym_else] = ACTIONS(3186),
    [anon_sym_switch] = ACTIONS(2496),
    [anon_sym_case] = ACTIONS(2496),
    [anon_sym_default] = ACTIONS(2496),
    [anon_sym_while] = ACTIONS(2496),
    [anon_sym_do] = ACTIONS(2496),
    [anon_sym_for] = ACTIONS(2496),
    [anon_sym_return] = ACTIONS(2496),
    [anon_sym_break] = ACTIONS(2496),
    [anon_sym_continue] = ACTIONS(2496),
    [anon_sym_goto] = ACTIONS(2496),
    [anon_sym___try] = ACTIONS(2496),
    [anon_sym___leave] = ACTIONS(2496),
    [anon_sym_not] = ACTIONS(2496),
    [anon_sym_compl] = ACTIONS(2496),
    [anon_sym_DASH_DASH] = ACTIONS(2498),
    [anon_sym_PLUS_PLUS] = ACTIONS(2498),
    [anon_sym_sizeof] = ACTIONS(2496),
    [anon_sym___alignof__] = ACTIONS(2496),
    [anon_sym___alignof] = ACTIONS(2496),
    [anon_sym__alignof] = ACTIONS(2496),
    [anon_sym_alignof] = ACTIONS(2496),
    [anon_sym__Alignof] = ACTIONS(2496),
    [anon_sym_offsetof] = ACTIONS(2496),
    [anon_sym__Generic] = ACTIONS(2496),
    [anon_sym_asm] = ACTIONS(2496),
    [anon_sym___asm__] = ACTIONS(2496),
    [aux_sym_number_literal_token1] = ACTIONS(2498),
    [aux_sym_number_literal_token2] = ACTIONS(2496),
    [anon_sym_L_SQUOTE] = ACTIONS(2498),
    [anon_sym_u_SQUOTE] = ACTIONS(2498),
    [anon_sym_U_SQUOTE] = ACTIONS(2498),
    [anon_sym_u8_SQUOTE] = ACTIONS(2498),
    [anon_sym_SQUOTE] = ACTIONS(2498),
    [anon_sym_L_DQUOTE] = ACTIONS(2498),
    [anon_sym_u_DQUOTE] = ACTIONS(2498),
    [anon_sym_U_DQUOTE] = ACTIONS(2498),
    [anon_sym_u8_DQUOTE] = ACTIONS(2498),
    [anon_sym_DQUOTE] = ACTIONS(2498),
    [sym_true] = ACTIONS(2496),
    [sym_false] = ACTIONS(2496),
    [anon_sym_NULL] = ACTIONS(2496),
    [anon_sym_nullptr] = ACTIONS(2496),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2496),
    [anon_sym_decltype] = ACTIONS(2496),
    [anon_sym_virtual] = ACTIONS(2496),
    [anon_sym_alignas] = ACTIONS(2496),
    [anon_sym_explicit] = ACTIONS(2496),
    [anon_sym_typename] = ACTIONS(2496),
    [anon_sym_template] = ACTIONS(2496),
    [anon_sym_operator] = ACTIONS(2496),
    [anon_sym_try] = ACTIONS(2496),
    [anon_sym_delete] = ACTIONS(2496),
    [anon_sym_throw] = ACTIONS(2496),
    [anon_sym_namespace] = ACTIONS(2496),
    [anon_sym_using] = ACTIONS(2496),
    [anon_sym_static_assert] = ACTIONS(2496),
    [anon_sym_concept] = ACTIONS(2496),
    [anon_sym_co_return] = ACTIONS(2496),
    [anon_sym_co_yield] = ACTIONS(2496),
    [anon_sym_R_DQUOTE] = ACTIONS(2498),
    [anon_sym_LR_DQUOTE] = ACTIONS(2498),
    [anon_sym_uR_DQUOTE] = ACTIONS(2498),
    [anon_sym_UR_DQUOTE] = ACTIONS(2498),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2498),
    [anon_sym_co_await] = ACTIONS(2496),
    [anon_sym_new] = ACTIONS(2496),
    [anon_sym_requires] = ACTIONS(2496),
    [sym_this] = ACTIONS(2496),
  },
  [431] = {
    [sym_identifier] = ACTIONS(1957),
    [aux_sym_preproc_include_token1] = ACTIONS(1957),
    [aux_sym_preproc_def_token1] = ACTIONS(1957),
    [aux_sym_preproc_if_token1] = ACTIONS(1957),
    [aux_sym_preproc_if_token2] = ACTIONS(1957),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1957),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1957),
    [sym_preproc_directive] = ACTIONS(1957),
    [anon_sym_LPAREN2] = ACTIONS(1955),
    [anon_sym_BANG] = ACTIONS(1955),
    [anon_sym_TILDE] = ACTIONS(1955),
    [anon_sym_DASH] = ACTIONS(1957),
    [anon_sym_PLUS] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(1955),
    [anon_sym_AMP_AMP] = ACTIONS(1955),
    [anon_sym_AMP] = ACTIONS(1957),
    [anon_sym_SEMI] = ACTIONS(1955),
    [anon_sym___extension__] = ACTIONS(1957),
    [anon_sym_typedef] = ACTIONS(1957),
    [anon_sym_extern] = ACTIONS(1957),
    [anon_sym___attribute__] = ACTIONS(1957),
    [anon_sym_COLON_COLON] = ACTIONS(1955),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1955),
    [anon_sym___declspec] = ACTIONS(1957),
    [anon_sym___based] = ACTIONS(1957),
    [anon_sym___cdecl] = ACTIONS(1957),
    [anon_sym___clrcall] = ACTIONS(1957),
    [anon_sym___stdcall] = ACTIONS(1957),
    [anon_sym___fastcall] = ACTIONS(1957),
    [anon_sym___thiscall] = ACTIONS(1957),
    [anon_sym___vectorcall] = ACTIONS(1957),
    [anon_sym_LBRACE] = ACTIONS(1955),
    [anon_sym_signed] = ACTIONS(1957),
    [anon_sym_unsigned] = ACTIONS(1957),
    [anon_sym_long] = ACTIONS(1957),
    [anon_sym_short] = ACTIONS(1957),
    [anon_sym_LBRACK] = ACTIONS(1957),
    [anon_sym_static] = ACTIONS(1957),
    [anon_sym_register] = ACTIONS(1957),
    [anon_sym_inline] = ACTIONS(1957),
    [anon_sym___inline] = ACTIONS(1957),
    [anon_sym___inline__] = ACTIONS(1957),
    [anon_sym___forceinline] = ACTIONS(1957),
    [anon_sym_thread_local] = ACTIONS(1957),
    [anon_sym___thread] = ACTIONS(1957),
    [anon_sym_const] = ACTIONS(1957),
    [anon_sym_constexpr] = ACTIONS(1957),
    [anon_sym_volatile] = ACTIONS(1957),
    [anon_sym_restrict] = ACTIONS(1957),
    [anon_sym___restrict__] = ACTIONS(1957),
    [anon_sym__Atomic] = ACTIONS(1957),
    [anon_sym__Noreturn] = ACTIONS(1957),
    [anon_sym_noreturn] = ACTIONS(1957),
    [anon_sym_mutable] = ACTIONS(1957),
    [anon_sym_constinit] = ACTIONS(1957),
    [anon_sym_consteval] = ACTIONS(1957),
    [anon_sym_PROGMEM] = ACTIONS(1957),
    [aux_sym_primitive_type_token1] = ACTIONS(1957),
    [anon_sym_byte] = ACTIONS(1957),
    [anon_sym_word] = ACTIONS(1957),
    [anon_sym_enum] = ACTIONS(1957),
    [anon_sym_class] = ACTIONS(1957),
    [anon_sym_struct] = ACTIONS(1957),
    [anon_sym_union] = ACTIONS(1957),
    [anon_sym_if] = ACTIONS(1957),
    [anon_sym_else] = ACTIONS(1957),
    [anon_sym_switch] = ACTIONS(1957),
    [anon_sym_case] = ACTIONS(1957),
    [anon_sym_default] = ACTIONS(1957),
    [anon_sym_while] = ACTIONS(1957),
    [anon_sym_do] = ACTIONS(1957),
    [anon_sym_for] = ACTIONS(1957),
    [anon_sym_return] = ACTIONS(1957),
    [anon_sym_break] = ACTIONS(1957),
    [anon_sym_continue] = ACTIONS(1957),
    [anon_sym_goto] = ACTIONS(1957),
    [anon_sym___try] = ACTIONS(1957),
    [anon_sym___leave] = ACTIONS(1957),
    [anon_sym_not] = ACTIONS(1957),
    [anon_sym_compl] = ACTIONS(1957),
    [anon_sym_DASH_DASH] = ACTIONS(1955),
    [anon_sym_PLUS_PLUS] = ACTIONS(1955),
    [anon_sym_sizeof] = ACTIONS(1957),
    [anon_sym___alignof__] = ACTIONS(1957),
    [anon_sym___alignof] = ACTIONS(1957),
    [anon_sym__alignof] = ACTIONS(1957),
    [anon_sym_alignof] = ACTIONS(1957),
    [anon_sym__Alignof] = ACTIONS(1957),
    [anon_sym_offsetof] = ACTIONS(1957),
    [anon_sym__Generic] = ACTIONS(1957),
    [anon_sym_asm] = ACTIONS(1957),
    [anon_sym___asm__] = ACTIONS(1957),
    [aux_sym_number_literal_token1] = ACTIONS(1955),
    [aux_sym_number_literal_token2] = ACTIONS(1957),
    [anon_sym_L_SQUOTE] = ACTIONS(1955),
    [anon_sym_u_SQUOTE] = ACTIONS(1955),
    [anon_sym_U_SQUOTE] = ACTIONS(1955),
    [anon_sym_u8_SQUOTE] = ACTIONS(1955),
    [anon_sym_SQUOTE] = ACTIONS(1955),
    [anon_sym_L_DQUOTE] = ACTIONS(1955),
    [anon_sym_u_DQUOTE] = ACTIONS(1955),
    [anon_sym_U_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8_DQUOTE] = ACTIONS(1955),
    [anon_sym_DQUOTE] = ACTIONS(1955),
    [sym_true] = ACTIONS(1957),
    [sym_false] = ACTIONS(1957),
    [anon_sym_NULL] = ACTIONS(1957),
    [anon_sym_nullptr] = ACTIONS(1957),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1957),
    [anon_sym_decltype] = ACTIONS(1957),
    [anon_sym_virtual] = ACTIONS(1957),
    [anon_sym_alignas] = ACTIONS(1957),
    [anon_sym_explicit] = ACTIONS(1957),
    [anon_sym_typename] = ACTIONS(1957),
    [anon_sym_template] = ACTIONS(1957),
    [anon_sym_operator] = ACTIONS(1957),
    [anon_sym_try] = ACTIONS(1957),
    [anon_sym_delete] = ACTIONS(1957),
    [anon_sym_throw] = ACTIONS(1957),
    [anon_sym_namespace] = ACTIONS(1957),
    [anon_sym_using] = ACTIONS(1957),
    [anon_sym_static_assert] = ACTIONS(1957),
    [anon_sym_concept] = ACTIONS(1957),
    [anon_sym_co_return] = ACTIONS(1957),
    [anon_sym_co_yield] = ACTIONS(1957),
    [anon_sym_catch] = ACTIONS(1957),
    [anon_sym_R_DQUOTE] = ACTIONS(1955),
    [anon_sym_LR_DQUOTE] = ACTIONS(1955),
    [anon_sym_uR_DQUOTE] = ACTIONS(1955),
    [anon_sym_UR_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1955),
    [anon_sym_co_await] = ACTIONS(1957),
    [anon_sym_new] = ACTIONS(1957),
    [anon_sym_requires] = ACTIONS(1957),
    [sym_this] = ACTIONS(1957),
  },
  [432] = {
    [ts_builtin_sym_end] = ACTIONS(2529),
    [sym_identifier] = ACTIONS(2527),
    [aux_sym_preproc_include_token1] = ACTIONS(2527),
    [aux_sym_preproc_def_token1] = ACTIONS(2527),
    [aux_sym_preproc_if_token1] = ACTIONS(2527),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2527),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2527),
    [sym_preproc_directive] = ACTIONS(2527),
    [anon_sym_LPAREN2] = ACTIONS(2529),
    [anon_sym_BANG] = ACTIONS(2529),
    [anon_sym_TILDE] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2527),
    [anon_sym_PLUS] = ACTIONS(2527),
    [anon_sym_STAR] = ACTIONS(2529),
    [anon_sym_AMP_AMP] = ACTIONS(2529),
    [anon_sym_AMP] = ACTIONS(2527),
    [anon_sym_SEMI] = ACTIONS(2529),
    [anon_sym___extension__] = ACTIONS(2527),
    [anon_sym_typedef] = ACTIONS(2527),
    [anon_sym_extern] = ACTIONS(2527),
    [anon_sym___attribute__] = ACTIONS(2527),
    [anon_sym_COLON_COLON] = ACTIONS(2529),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2529),
    [anon_sym___declspec] = ACTIONS(2527),
    [anon_sym___based] = ACTIONS(2527),
    [anon_sym___cdecl] = ACTIONS(2527),
    [anon_sym___clrcall] = ACTIONS(2527),
    [anon_sym___stdcall] = ACTIONS(2527),
    [anon_sym___fastcall] = ACTIONS(2527),
    [anon_sym___thiscall] = ACTIONS(2527),
    [anon_sym___vectorcall] = ACTIONS(2527),
    [anon_sym_LBRACE] = ACTIONS(2529),
    [anon_sym_signed] = ACTIONS(2527),
    [anon_sym_unsigned] = ACTIONS(2527),
    [anon_sym_long] = ACTIONS(2527),
    [anon_sym_short] = ACTIONS(2527),
    [anon_sym_LBRACK] = ACTIONS(2527),
    [anon_sym_static] = ACTIONS(2527),
    [anon_sym_register] = ACTIONS(2527),
    [anon_sym_inline] = ACTIONS(2527),
    [anon_sym___inline] = ACTIONS(2527),
    [anon_sym___inline__] = ACTIONS(2527),
    [anon_sym___forceinline] = ACTIONS(2527),
    [anon_sym_thread_local] = ACTIONS(2527),
    [anon_sym___thread] = ACTIONS(2527),
    [anon_sym_const] = ACTIONS(2527),
    [anon_sym_constexpr] = ACTIONS(2527),
    [anon_sym_volatile] = ACTIONS(2527),
    [anon_sym_restrict] = ACTIONS(2527),
    [anon_sym___restrict__] = ACTIONS(2527),
    [anon_sym__Atomic] = ACTIONS(2527),
    [anon_sym__Noreturn] = ACTIONS(2527),
    [anon_sym_noreturn] = ACTIONS(2527),
    [anon_sym_mutable] = ACTIONS(2527),
    [anon_sym_constinit] = ACTIONS(2527),
    [anon_sym_consteval] = ACTIONS(2527),
    [anon_sym_PROGMEM] = ACTIONS(2527),
    [aux_sym_primitive_type_token1] = ACTIONS(2527),
    [anon_sym_byte] = ACTIONS(2527),
    [anon_sym_word] = ACTIONS(2527),
    [anon_sym_enum] = ACTIONS(2527),
    [anon_sym_class] = ACTIONS(2527),
    [anon_sym_struct] = ACTIONS(2527),
    [anon_sym_union] = ACTIONS(2527),
    [anon_sym_if] = ACTIONS(2527),
    [anon_sym_else] = ACTIONS(2527),
    [anon_sym_switch] = ACTIONS(2527),
    [anon_sym_case] = ACTIONS(2527),
    [anon_sym_default] = ACTIONS(2527),
    [anon_sym_while] = ACTIONS(2527),
    [anon_sym_do] = ACTIONS(2527),
    [anon_sym_for] = ACTIONS(2527),
    [anon_sym_return] = ACTIONS(2527),
    [anon_sym_break] = ACTIONS(2527),
    [anon_sym_continue] = ACTIONS(2527),
    [anon_sym_goto] = ACTIONS(2527),
    [anon_sym___try] = ACTIONS(2527),
    [anon_sym___leave] = ACTIONS(2527),
    [anon_sym_not] = ACTIONS(2527),
    [anon_sym_compl] = ACTIONS(2527),
    [anon_sym_DASH_DASH] = ACTIONS(2529),
    [anon_sym_PLUS_PLUS] = ACTIONS(2529),
    [anon_sym_sizeof] = ACTIONS(2527),
    [anon_sym___alignof__] = ACTIONS(2527),
    [anon_sym___alignof] = ACTIONS(2527),
    [anon_sym__alignof] = ACTIONS(2527),
    [anon_sym_alignof] = ACTIONS(2527),
    [anon_sym__Alignof] = ACTIONS(2527),
    [anon_sym_offsetof] = ACTIONS(2527),
    [anon_sym__Generic] = ACTIONS(2527),
    [anon_sym_asm] = ACTIONS(2527),
    [anon_sym___asm__] = ACTIONS(2527),
    [aux_sym_number_literal_token1] = ACTIONS(2529),
    [aux_sym_number_literal_token2] = ACTIONS(2527),
    [anon_sym_L_SQUOTE] = ACTIONS(2529),
    [anon_sym_u_SQUOTE] = ACTIONS(2529),
    [anon_sym_U_SQUOTE] = ACTIONS(2529),
    [anon_sym_u8_SQUOTE] = ACTIONS(2529),
    [anon_sym_SQUOTE] = ACTIONS(2529),
    [anon_sym_L_DQUOTE] = ACTIONS(2529),
    [anon_sym_u_DQUOTE] = ACTIONS(2529),
    [anon_sym_U_DQUOTE] = ACTIONS(2529),
    [anon_sym_u8_DQUOTE] = ACTIONS(2529),
    [anon_sym_DQUOTE] = ACTIONS(2529),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_NULL] = ACTIONS(2527),
    [anon_sym_nullptr] = ACTIONS(2527),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2527),
    [anon_sym_decltype] = ACTIONS(2527),
    [anon_sym_virtual] = ACTIONS(2527),
    [anon_sym_alignas] = ACTIONS(2527),
    [anon_sym_explicit] = ACTIONS(2527),
    [anon_sym_typename] = ACTIONS(2527),
    [anon_sym_template] = ACTIONS(2527),
    [anon_sym_operator] = ACTIONS(2527),
    [anon_sym_try] = ACTIONS(2527),
    [anon_sym_delete] = ACTIONS(2527),
    [anon_sym_throw] = ACTIONS(2527),
    [anon_sym_namespace] = ACTIONS(2527),
    [anon_sym_using] = ACTIONS(2527),
    [anon_sym_static_assert] = ACTIONS(2527),
    [anon_sym_concept] = ACTIONS(2527),
    [anon_sym_co_return] = ACTIONS(2527),
    [anon_sym_co_yield] = ACTIONS(2527),
    [anon_sym_catch] = ACTIONS(2527),
    [anon_sym_R_DQUOTE] = ACTIONS(2529),
    [anon_sym_LR_DQUOTE] = ACTIONS(2529),
    [anon_sym_uR_DQUOTE] = ACTIONS(2529),
    [anon_sym_UR_DQUOTE] = ACTIONS(2529),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2529),
    [anon_sym_co_await] = ACTIONS(2527),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_requires] = ACTIONS(2527),
    [sym_this] = ACTIONS(2527),
  },
  [433] = {
    [sym_identifier] = ACTIONS(2527),
    [aux_sym_preproc_include_token1] = ACTIONS(2527),
    [aux_sym_preproc_def_token1] = ACTIONS(2527),
    [aux_sym_preproc_if_token1] = ACTIONS(2527),
    [aux_sym_preproc_if_token2] = ACTIONS(2527),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2527),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2527),
    [sym_preproc_directive] = ACTIONS(2527),
    [anon_sym_LPAREN2] = ACTIONS(2529),
    [anon_sym_BANG] = ACTIONS(2529),
    [anon_sym_TILDE] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2527),
    [anon_sym_PLUS] = ACTIONS(2527),
    [anon_sym_STAR] = ACTIONS(2529),
    [anon_sym_AMP_AMP] = ACTIONS(2529),
    [anon_sym_AMP] = ACTIONS(2527),
    [anon_sym_SEMI] = ACTIONS(2529),
    [anon_sym___extension__] = ACTIONS(2527),
    [anon_sym_typedef] = ACTIONS(2527),
    [anon_sym_extern] = ACTIONS(2527),
    [anon_sym___attribute__] = ACTIONS(2527),
    [anon_sym_COLON_COLON] = ACTIONS(2529),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2529),
    [anon_sym___declspec] = ACTIONS(2527),
    [anon_sym___based] = ACTIONS(2527),
    [anon_sym___cdecl] = ACTIONS(2527),
    [anon_sym___clrcall] = ACTIONS(2527),
    [anon_sym___stdcall] = ACTIONS(2527),
    [anon_sym___fastcall] = ACTIONS(2527),
    [anon_sym___thiscall] = ACTIONS(2527),
    [anon_sym___vectorcall] = ACTIONS(2527),
    [anon_sym_LBRACE] = ACTIONS(2529),
    [anon_sym_signed] = ACTIONS(2527),
    [anon_sym_unsigned] = ACTIONS(2527),
    [anon_sym_long] = ACTIONS(2527),
    [anon_sym_short] = ACTIONS(2527),
    [anon_sym_LBRACK] = ACTIONS(2527),
    [anon_sym_static] = ACTIONS(2527),
    [anon_sym_register] = ACTIONS(2527),
    [anon_sym_inline] = ACTIONS(2527),
    [anon_sym___inline] = ACTIONS(2527),
    [anon_sym___inline__] = ACTIONS(2527),
    [anon_sym___forceinline] = ACTIONS(2527),
    [anon_sym_thread_local] = ACTIONS(2527),
    [anon_sym___thread] = ACTIONS(2527),
    [anon_sym_const] = ACTIONS(2527),
    [anon_sym_constexpr] = ACTIONS(2527),
    [anon_sym_volatile] = ACTIONS(2527),
    [anon_sym_restrict] = ACTIONS(2527),
    [anon_sym___restrict__] = ACTIONS(2527),
    [anon_sym__Atomic] = ACTIONS(2527),
    [anon_sym__Noreturn] = ACTIONS(2527),
    [anon_sym_noreturn] = ACTIONS(2527),
    [anon_sym_mutable] = ACTIONS(2527),
    [anon_sym_constinit] = ACTIONS(2527),
    [anon_sym_consteval] = ACTIONS(2527),
    [anon_sym_PROGMEM] = ACTIONS(2527),
    [aux_sym_primitive_type_token1] = ACTIONS(2527),
    [anon_sym_byte] = ACTIONS(2527),
    [anon_sym_word] = ACTIONS(2527),
    [anon_sym_enum] = ACTIONS(2527),
    [anon_sym_class] = ACTIONS(2527),
    [anon_sym_struct] = ACTIONS(2527),
    [anon_sym_union] = ACTIONS(2527),
    [anon_sym_if] = ACTIONS(2527),
    [anon_sym_else] = ACTIONS(2527),
    [anon_sym_switch] = ACTIONS(2527),
    [anon_sym_case] = ACTIONS(2527),
    [anon_sym_default] = ACTIONS(2527),
    [anon_sym_while] = ACTIONS(2527),
    [anon_sym_do] = ACTIONS(2527),
    [anon_sym_for] = ACTIONS(2527),
    [anon_sym_return] = ACTIONS(2527),
    [anon_sym_break] = ACTIONS(2527),
    [anon_sym_continue] = ACTIONS(2527),
    [anon_sym_goto] = ACTIONS(2527),
    [anon_sym___try] = ACTIONS(2527),
    [anon_sym___leave] = ACTIONS(2527),
    [anon_sym_not] = ACTIONS(2527),
    [anon_sym_compl] = ACTIONS(2527),
    [anon_sym_DASH_DASH] = ACTIONS(2529),
    [anon_sym_PLUS_PLUS] = ACTIONS(2529),
    [anon_sym_sizeof] = ACTIONS(2527),
    [anon_sym___alignof__] = ACTIONS(2527),
    [anon_sym___alignof] = ACTIONS(2527),
    [anon_sym__alignof] = ACTIONS(2527),
    [anon_sym_alignof] = ACTIONS(2527),
    [anon_sym__Alignof] = ACTIONS(2527),
    [anon_sym_offsetof] = ACTIONS(2527),
    [anon_sym__Generic] = ACTIONS(2527),
    [anon_sym_asm] = ACTIONS(2527),
    [anon_sym___asm__] = ACTIONS(2527),
    [aux_sym_number_literal_token1] = ACTIONS(2529),
    [aux_sym_number_literal_token2] = ACTIONS(2527),
    [anon_sym_L_SQUOTE] = ACTIONS(2529),
    [anon_sym_u_SQUOTE] = ACTIONS(2529),
    [anon_sym_U_SQUOTE] = ACTIONS(2529),
    [anon_sym_u8_SQUOTE] = ACTIONS(2529),
    [anon_sym_SQUOTE] = ACTIONS(2529),
    [anon_sym_L_DQUOTE] = ACTIONS(2529),
    [anon_sym_u_DQUOTE] = ACTIONS(2529),
    [anon_sym_U_DQUOTE] = ACTIONS(2529),
    [anon_sym_u8_DQUOTE] = ACTIONS(2529),
    [anon_sym_DQUOTE] = ACTIONS(2529),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_NULL] = ACTIONS(2527),
    [anon_sym_nullptr] = ACTIONS(2527),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2527),
    [anon_sym_decltype] = ACTIONS(2527),
    [anon_sym_virtual] = ACTIONS(2527),
    [anon_sym_alignas] = ACTIONS(2527),
    [anon_sym_explicit] = ACTIONS(2527),
    [anon_sym_typename] = ACTIONS(2527),
    [anon_sym_template] = ACTIONS(2527),
    [anon_sym_operator] = ACTIONS(2527),
    [anon_sym_try] = ACTIONS(2527),
    [anon_sym_delete] = ACTIONS(2527),
    [anon_sym_throw] = ACTIONS(2527),
    [anon_sym_namespace] = ACTIONS(2527),
    [anon_sym_using] = ACTIONS(2527),
    [anon_sym_static_assert] = ACTIONS(2527),
    [anon_sym_concept] = ACTIONS(2527),
    [anon_sym_co_return] = ACTIONS(2527),
    [anon_sym_co_yield] = ACTIONS(2527),
    [anon_sym_catch] = ACTIONS(2527),
    [anon_sym_R_DQUOTE] = ACTIONS(2529),
    [anon_sym_LR_DQUOTE] = ACTIONS(2529),
    [anon_sym_uR_DQUOTE] = ACTIONS(2529),
    [anon_sym_UR_DQUOTE] = ACTIONS(2529),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2529),
    [anon_sym_co_await] = ACTIONS(2527),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_requires] = ACTIONS(2527),
    [sym_this] = ACTIONS(2527),
  },
  [434] = {
    [sym_else_clause] = STATE(542),
    [sym_identifier] = ACTIONS(2523),
    [aux_sym_preproc_include_token1] = ACTIONS(2523),
    [aux_sym_preproc_def_token1] = ACTIONS(2523),
    [aux_sym_preproc_if_token1] = ACTIONS(2523),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2523),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2523),
    [sym_preproc_directive] = ACTIONS(2523),
    [anon_sym_LPAREN2] = ACTIONS(2525),
    [anon_sym_BANG] = ACTIONS(2525),
    [anon_sym_TILDE] = ACTIONS(2525),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_PLUS] = ACTIONS(2523),
    [anon_sym_STAR] = ACTIONS(2525),
    [anon_sym_AMP_AMP] = ACTIONS(2525),
    [anon_sym_AMP] = ACTIONS(2523),
    [anon_sym_SEMI] = ACTIONS(2525),
    [anon_sym___extension__] = ACTIONS(2523),
    [anon_sym_typedef] = ACTIONS(2523),
    [anon_sym_extern] = ACTIONS(2523),
    [anon_sym___attribute__] = ACTIONS(2523),
    [anon_sym_COLON_COLON] = ACTIONS(2525),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2525),
    [anon_sym___declspec] = ACTIONS(2523),
    [anon_sym___based] = ACTIONS(2523),
    [anon_sym___cdecl] = ACTIONS(2523),
    [anon_sym___clrcall] = ACTIONS(2523),
    [anon_sym___stdcall] = ACTIONS(2523),
    [anon_sym___fastcall] = ACTIONS(2523),
    [anon_sym___thiscall] = ACTIONS(2523),
    [anon_sym___vectorcall] = ACTIONS(2523),
    [anon_sym_LBRACE] = ACTIONS(2525),
    [anon_sym_RBRACE] = ACTIONS(2525),
    [anon_sym_signed] = ACTIONS(2523),
    [anon_sym_unsigned] = ACTIONS(2523),
    [anon_sym_long] = ACTIONS(2523),
    [anon_sym_short] = ACTIONS(2523),
    [anon_sym_LBRACK] = ACTIONS(2523),
    [anon_sym_static] = ACTIONS(2523),
    [anon_sym_register] = ACTIONS(2523),
    [anon_sym_inline] = ACTIONS(2523),
    [anon_sym___inline] = ACTIONS(2523),
    [anon_sym___inline__] = ACTIONS(2523),
    [anon_sym___forceinline] = ACTIONS(2523),
    [anon_sym_thread_local] = ACTIONS(2523),
    [anon_sym___thread] = ACTIONS(2523),
    [anon_sym_const] = ACTIONS(2523),
    [anon_sym_constexpr] = ACTIONS(2523),
    [anon_sym_volatile] = ACTIONS(2523),
    [anon_sym_restrict] = ACTIONS(2523),
    [anon_sym___restrict__] = ACTIONS(2523),
    [anon_sym__Atomic] = ACTIONS(2523),
    [anon_sym__Noreturn] = ACTIONS(2523),
    [anon_sym_noreturn] = ACTIONS(2523),
    [anon_sym_mutable] = ACTIONS(2523),
    [anon_sym_constinit] = ACTIONS(2523),
    [anon_sym_consteval] = ACTIONS(2523),
    [anon_sym_PROGMEM] = ACTIONS(2523),
    [aux_sym_primitive_type_token1] = ACTIONS(2523),
    [anon_sym_byte] = ACTIONS(2523),
    [anon_sym_word] = ACTIONS(2523),
    [anon_sym_enum] = ACTIONS(2523),
    [anon_sym_class] = ACTIONS(2523),
    [anon_sym_struct] = ACTIONS(2523),
    [anon_sym_union] = ACTIONS(2523),
    [anon_sym_if] = ACTIONS(2523),
    [anon_sym_else] = ACTIONS(3186),
    [anon_sym_switch] = ACTIONS(2523),
    [anon_sym_case] = ACTIONS(2523),
    [anon_sym_default] = ACTIONS(2523),
    [anon_sym_while] = ACTIONS(2523),
    [anon_sym_do] = ACTIONS(2523),
    [anon_sym_for] = ACTIONS(2523),
    [anon_sym_return] = ACTIONS(2523),
    [anon_sym_break] = ACTIONS(2523),
    [anon_sym_continue] = ACTIONS(2523),
    [anon_sym_goto] = ACTIONS(2523),
    [anon_sym___try] = ACTIONS(2523),
    [anon_sym___leave] = ACTIONS(2523),
    [anon_sym_not] = ACTIONS(2523),
    [anon_sym_compl] = ACTIONS(2523),
    [anon_sym_DASH_DASH] = ACTIONS(2525),
    [anon_sym_PLUS_PLUS] = ACTIONS(2525),
    [anon_sym_sizeof] = ACTIONS(2523),
    [anon_sym___alignof__] = ACTIONS(2523),
    [anon_sym___alignof] = ACTIONS(2523),
    [anon_sym__alignof] = ACTIONS(2523),
    [anon_sym_alignof] = ACTIONS(2523),
    [anon_sym__Alignof] = ACTIONS(2523),
    [anon_sym_offsetof] = ACTIONS(2523),
    [anon_sym__Generic] = ACTIONS(2523),
    [anon_sym_asm] = ACTIONS(2523),
    [anon_sym___asm__] = ACTIONS(2523),
    [aux_sym_number_literal_token1] = ACTIONS(2525),
    [aux_sym_number_literal_token2] = ACTIONS(2523),
    [anon_sym_L_SQUOTE] = ACTIONS(2525),
    [anon_sym_u_SQUOTE] = ACTIONS(2525),
    [anon_sym_U_SQUOTE] = ACTIONS(2525),
    [anon_sym_u8_SQUOTE] = ACTIONS(2525),
    [anon_sym_SQUOTE] = ACTIONS(2525),
    [anon_sym_L_DQUOTE] = ACTIONS(2525),
    [anon_sym_u_DQUOTE] = ACTIONS(2525),
    [anon_sym_U_DQUOTE] = ACTIONS(2525),
    [anon_sym_u8_DQUOTE] = ACTIONS(2525),
    [anon_sym_DQUOTE] = ACTIONS(2525),
    [sym_true] = ACTIONS(2523),
    [sym_false] = ACTIONS(2523),
    [anon_sym_NULL] = ACTIONS(2523),
    [anon_sym_nullptr] = ACTIONS(2523),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2523),
    [anon_sym_decltype] = ACTIONS(2523),
    [anon_sym_virtual] = ACTIONS(2523),
    [anon_sym_alignas] = ACTIONS(2523),
    [anon_sym_explicit] = ACTIONS(2523),
    [anon_sym_typename] = ACTIONS(2523),
    [anon_sym_template] = ACTIONS(2523),
    [anon_sym_operator] = ACTIONS(2523),
    [anon_sym_try] = ACTIONS(2523),
    [anon_sym_delete] = ACTIONS(2523),
    [anon_sym_throw] = ACTIONS(2523),
    [anon_sym_namespace] = ACTIONS(2523),
    [anon_sym_using] = ACTIONS(2523),
    [anon_sym_static_assert] = ACTIONS(2523),
    [anon_sym_concept] = ACTIONS(2523),
    [anon_sym_co_return] = ACTIONS(2523),
    [anon_sym_co_yield] = ACTIONS(2523),
    [anon_sym_R_DQUOTE] = ACTIONS(2525),
    [anon_sym_LR_DQUOTE] = ACTIONS(2525),
    [anon_sym_uR_DQUOTE] = ACTIONS(2525),
    [anon_sym_UR_DQUOTE] = ACTIONS(2525),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2525),
    [anon_sym_co_await] = ACTIONS(2523),
    [anon_sym_new] = ACTIONS(2523),
    [anon_sym_requires] = ACTIONS(2523),
    [sym_this] = ACTIONS(2523),
  },
  [435] = {
    [sym_identifier] = ACTIONS(2527),
    [aux_sym_preproc_include_token1] = ACTIONS(2527),
    [aux_sym_preproc_def_token1] = ACTIONS(2527),
    [aux_sym_preproc_if_token1] = ACTIONS(2527),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2527),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2527),
    [sym_preproc_directive] = ACTIONS(2527),
    [anon_sym_LPAREN2] = ACTIONS(2529),
    [anon_sym_BANG] = ACTIONS(2529),
    [anon_sym_TILDE] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2527),
    [anon_sym_PLUS] = ACTIONS(2527),
    [anon_sym_STAR] = ACTIONS(2529),
    [anon_sym_AMP_AMP] = ACTIONS(2529),
    [anon_sym_AMP] = ACTIONS(2527),
    [anon_sym_SEMI] = ACTIONS(2529),
    [anon_sym___extension__] = ACTIONS(2527),
    [anon_sym_typedef] = ACTIONS(2527),
    [anon_sym_extern] = ACTIONS(2527),
    [anon_sym___attribute__] = ACTIONS(2527),
    [anon_sym_COLON_COLON] = ACTIONS(2529),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2529),
    [anon_sym___declspec] = ACTIONS(2527),
    [anon_sym___based] = ACTIONS(2527),
    [anon_sym___cdecl] = ACTIONS(2527),
    [anon_sym___clrcall] = ACTIONS(2527),
    [anon_sym___stdcall] = ACTIONS(2527),
    [anon_sym___fastcall] = ACTIONS(2527),
    [anon_sym___thiscall] = ACTIONS(2527),
    [anon_sym___vectorcall] = ACTIONS(2527),
    [anon_sym_LBRACE] = ACTIONS(2529),
    [anon_sym_RBRACE] = ACTIONS(2529),
    [anon_sym_signed] = ACTIONS(2527),
    [anon_sym_unsigned] = ACTIONS(2527),
    [anon_sym_long] = ACTIONS(2527),
    [anon_sym_short] = ACTIONS(2527),
    [anon_sym_LBRACK] = ACTIONS(2527),
    [anon_sym_static] = ACTIONS(2527),
    [anon_sym_register] = ACTIONS(2527),
    [anon_sym_inline] = ACTIONS(2527),
    [anon_sym___inline] = ACTIONS(2527),
    [anon_sym___inline__] = ACTIONS(2527),
    [anon_sym___forceinline] = ACTIONS(2527),
    [anon_sym_thread_local] = ACTIONS(2527),
    [anon_sym___thread] = ACTIONS(2527),
    [anon_sym_const] = ACTIONS(2527),
    [anon_sym_constexpr] = ACTIONS(2527),
    [anon_sym_volatile] = ACTIONS(2527),
    [anon_sym_restrict] = ACTIONS(2527),
    [anon_sym___restrict__] = ACTIONS(2527),
    [anon_sym__Atomic] = ACTIONS(2527),
    [anon_sym__Noreturn] = ACTIONS(2527),
    [anon_sym_noreturn] = ACTIONS(2527),
    [anon_sym_mutable] = ACTIONS(2527),
    [anon_sym_constinit] = ACTIONS(2527),
    [anon_sym_consteval] = ACTIONS(2527),
    [anon_sym_PROGMEM] = ACTIONS(2527),
    [aux_sym_primitive_type_token1] = ACTIONS(2527),
    [anon_sym_byte] = ACTIONS(2527),
    [anon_sym_word] = ACTIONS(2527),
    [anon_sym_enum] = ACTIONS(2527),
    [anon_sym_class] = ACTIONS(2527),
    [anon_sym_struct] = ACTIONS(2527),
    [anon_sym_union] = ACTIONS(2527),
    [anon_sym_if] = ACTIONS(2527),
    [anon_sym_else] = ACTIONS(2527),
    [anon_sym_switch] = ACTIONS(2527),
    [anon_sym_case] = ACTIONS(2527),
    [anon_sym_default] = ACTIONS(2527),
    [anon_sym_while] = ACTIONS(2527),
    [anon_sym_do] = ACTIONS(2527),
    [anon_sym_for] = ACTIONS(2527),
    [anon_sym_return] = ACTIONS(2527),
    [anon_sym_break] = ACTIONS(2527),
    [anon_sym_continue] = ACTIONS(2527),
    [anon_sym_goto] = ACTIONS(2527),
    [anon_sym___try] = ACTIONS(2527),
    [anon_sym___leave] = ACTIONS(2527),
    [anon_sym_not] = ACTIONS(2527),
    [anon_sym_compl] = ACTIONS(2527),
    [anon_sym_DASH_DASH] = ACTIONS(2529),
    [anon_sym_PLUS_PLUS] = ACTIONS(2529),
    [anon_sym_sizeof] = ACTIONS(2527),
    [anon_sym___alignof__] = ACTIONS(2527),
    [anon_sym___alignof] = ACTIONS(2527),
    [anon_sym__alignof] = ACTIONS(2527),
    [anon_sym_alignof] = ACTIONS(2527),
    [anon_sym__Alignof] = ACTIONS(2527),
    [anon_sym_offsetof] = ACTIONS(2527),
    [anon_sym__Generic] = ACTIONS(2527),
    [anon_sym_asm] = ACTIONS(2527),
    [anon_sym___asm__] = ACTIONS(2527),
    [aux_sym_number_literal_token1] = ACTIONS(2529),
    [aux_sym_number_literal_token2] = ACTIONS(2527),
    [anon_sym_L_SQUOTE] = ACTIONS(2529),
    [anon_sym_u_SQUOTE] = ACTIONS(2529),
    [anon_sym_U_SQUOTE] = ACTIONS(2529),
    [anon_sym_u8_SQUOTE] = ACTIONS(2529),
    [anon_sym_SQUOTE] = ACTIONS(2529),
    [anon_sym_L_DQUOTE] = ACTIONS(2529),
    [anon_sym_u_DQUOTE] = ACTIONS(2529),
    [anon_sym_U_DQUOTE] = ACTIONS(2529),
    [anon_sym_u8_DQUOTE] = ACTIONS(2529),
    [anon_sym_DQUOTE] = ACTIONS(2529),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_NULL] = ACTIONS(2527),
    [anon_sym_nullptr] = ACTIONS(2527),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2527),
    [anon_sym_decltype] = ACTIONS(2527),
    [anon_sym_virtual] = ACTIONS(2527),
    [anon_sym_alignas] = ACTIONS(2527),
    [anon_sym_explicit] = ACTIONS(2527),
    [anon_sym_typename] = ACTIONS(2527),
    [anon_sym_template] = ACTIONS(2527),
    [anon_sym_operator] = ACTIONS(2527),
    [anon_sym_try] = ACTIONS(2527),
    [anon_sym_delete] = ACTIONS(2527),
    [anon_sym_throw] = ACTIONS(2527),
    [anon_sym_namespace] = ACTIONS(2527),
    [anon_sym_using] = ACTIONS(2527),
    [anon_sym_static_assert] = ACTIONS(2527),
    [anon_sym_concept] = ACTIONS(2527),
    [anon_sym_co_return] = ACTIONS(2527),
    [anon_sym_co_yield] = ACTIONS(2527),
    [anon_sym_catch] = ACTIONS(2527),
    [anon_sym_R_DQUOTE] = ACTIONS(2529),
    [anon_sym_LR_DQUOTE] = ACTIONS(2529),
    [anon_sym_uR_DQUOTE] = ACTIONS(2529),
    [anon_sym_UR_DQUOTE] = ACTIONS(2529),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2529),
    [anon_sym_co_await] = ACTIONS(2527),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_requires] = ACTIONS(2527),
    [sym_this] = ACTIONS(2527),
  },
  [436] = {
    [sym_identifier] = ACTIONS(1961),
    [aux_sym_preproc_include_token1] = ACTIONS(1961),
    [aux_sym_preproc_def_token1] = ACTIONS(1961),
    [aux_sym_preproc_if_token1] = ACTIONS(1961),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1961),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1961),
    [sym_preproc_directive] = ACTIONS(1961),
    [anon_sym_LPAREN2] = ACTIONS(1959),
    [anon_sym_BANG] = ACTIONS(1959),
    [anon_sym_TILDE] = ACTIONS(1959),
    [anon_sym_DASH] = ACTIONS(1961),
    [anon_sym_PLUS] = ACTIONS(1961),
    [anon_sym_STAR] = ACTIONS(1959),
    [anon_sym_AMP_AMP] = ACTIONS(1959),
    [anon_sym_AMP] = ACTIONS(1961),
    [anon_sym_SEMI] = ACTIONS(1959),
    [anon_sym___extension__] = ACTIONS(1961),
    [anon_sym_typedef] = ACTIONS(1961),
    [anon_sym_extern] = ACTIONS(1961),
    [anon_sym___attribute__] = ACTIONS(1961),
    [anon_sym_COLON_COLON] = ACTIONS(1959),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1959),
    [anon_sym___declspec] = ACTIONS(1961),
    [anon_sym___based] = ACTIONS(1961),
    [anon_sym___cdecl] = ACTIONS(1961),
    [anon_sym___clrcall] = ACTIONS(1961),
    [anon_sym___stdcall] = ACTIONS(1961),
    [anon_sym___fastcall] = ACTIONS(1961),
    [anon_sym___thiscall] = ACTIONS(1961),
    [anon_sym___vectorcall] = ACTIONS(1961),
    [anon_sym_LBRACE] = ACTIONS(1959),
    [anon_sym_RBRACE] = ACTIONS(1959),
    [anon_sym_signed] = ACTIONS(1961),
    [anon_sym_unsigned] = ACTIONS(1961),
    [anon_sym_long] = ACTIONS(1961),
    [anon_sym_short] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1961),
    [anon_sym_static] = ACTIONS(1961),
    [anon_sym_register] = ACTIONS(1961),
    [anon_sym_inline] = ACTIONS(1961),
    [anon_sym___inline] = ACTIONS(1961),
    [anon_sym___inline__] = ACTIONS(1961),
    [anon_sym___forceinline] = ACTIONS(1961),
    [anon_sym_thread_local] = ACTIONS(1961),
    [anon_sym___thread] = ACTIONS(1961),
    [anon_sym_const] = ACTIONS(1961),
    [anon_sym_constexpr] = ACTIONS(1961),
    [anon_sym_volatile] = ACTIONS(1961),
    [anon_sym_restrict] = ACTIONS(1961),
    [anon_sym___restrict__] = ACTIONS(1961),
    [anon_sym__Atomic] = ACTIONS(1961),
    [anon_sym__Noreturn] = ACTIONS(1961),
    [anon_sym_noreturn] = ACTIONS(1961),
    [anon_sym_mutable] = ACTIONS(1961),
    [anon_sym_constinit] = ACTIONS(1961),
    [anon_sym_consteval] = ACTIONS(1961),
    [anon_sym_PROGMEM] = ACTIONS(1961),
    [aux_sym_primitive_type_token1] = ACTIONS(1961),
    [anon_sym_byte] = ACTIONS(1961),
    [anon_sym_word] = ACTIONS(1961),
    [anon_sym_enum] = ACTIONS(1961),
    [anon_sym_class] = ACTIONS(1961),
    [anon_sym_struct] = ACTIONS(1961),
    [anon_sym_union] = ACTIONS(1961),
    [anon_sym_if] = ACTIONS(1961),
    [anon_sym_else] = ACTIONS(1961),
    [anon_sym_switch] = ACTIONS(1961),
    [anon_sym_case] = ACTIONS(1961),
    [anon_sym_default] = ACTIONS(1961),
    [anon_sym_while] = ACTIONS(1961),
    [anon_sym_do] = ACTIONS(1961),
    [anon_sym_for] = ACTIONS(1961),
    [anon_sym_return] = ACTIONS(1961),
    [anon_sym_break] = ACTIONS(1961),
    [anon_sym_continue] = ACTIONS(1961),
    [anon_sym_goto] = ACTIONS(1961),
    [anon_sym___try] = ACTIONS(1961),
    [anon_sym___leave] = ACTIONS(1961),
    [anon_sym_not] = ACTIONS(1961),
    [anon_sym_compl] = ACTIONS(1961),
    [anon_sym_DASH_DASH] = ACTIONS(1959),
    [anon_sym_PLUS_PLUS] = ACTIONS(1959),
    [anon_sym_sizeof] = ACTIONS(1961),
    [anon_sym___alignof__] = ACTIONS(1961),
    [anon_sym___alignof] = ACTIONS(1961),
    [anon_sym__alignof] = ACTIONS(1961),
    [anon_sym_alignof] = ACTIONS(1961),
    [anon_sym__Alignof] = ACTIONS(1961),
    [anon_sym_offsetof] = ACTIONS(1961),
    [anon_sym__Generic] = ACTIONS(1961),
    [anon_sym_asm] = ACTIONS(1961),
    [anon_sym___asm__] = ACTIONS(1961),
    [aux_sym_number_literal_token1] = ACTIONS(1959),
    [aux_sym_number_literal_token2] = ACTIONS(1961),
    [anon_sym_L_SQUOTE] = ACTIONS(1959),
    [anon_sym_u_SQUOTE] = ACTIONS(1959),
    [anon_sym_U_SQUOTE] = ACTIONS(1959),
    [anon_sym_u8_SQUOTE] = ACTIONS(1959),
    [anon_sym_SQUOTE] = ACTIONS(1959),
    [anon_sym_L_DQUOTE] = ACTIONS(1959),
    [anon_sym_u_DQUOTE] = ACTIONS(1959),
    [anon_sym_U_DQUOTE] = ACTIONS(1959),
    [anon_sym_u8_DQUOTE] = ACTIONS(1959),
    [anon_sym_DQUOTE] = ACTIONS(1959),
    [sym_true] = ACTIONS(1961),
    [sym_false] = ACTIONS(1961),
    [anon_sym_NULL] = ACTIONS(1961),
    [anon_sym_nullptr] = ACTIONS(1961),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1961),
    [anon_sym_decltype] = ACTIONS(1961),
    [anon_sym_virtual] = ACTIONS(1961),
    [anon_sym_alignas] = ACTIONS(1961),
    [anon_sym_explicit] = ACTIONS(1961),
    [anon_sym_typename] = ACTIONS(1961),
    [anon_sym_template] = ACTIONS(1961),
    [anon_sym_operator] = ACTIONS(1961),
    [anon_sym_try] = ACTIONS(1961),
    [anon_sym_delete] = ACTIONS(1961),
    [anon_sym_throw] = ACTIONS(1961),
    [anon_sym_namespace] = ACTIONS(1961),
    [anon_sym_using] = ACTIONS(1961),
    [anon_sym_static_assert] = ACTIONS(1961),
    [anon_sym_concept] = ACTIONS(1961),
    [anon_sym_co_return] = ACTIONS(1961),
    [anon_sym_co_yield] = ACTIONS(1961),
    [anon_sym_catch] = ACTIONS(1961),
    [anon_sym_R_DQUOTE] = ACTIONS(1959),
    [anon_sym_LR_DQUOTE] = ACTIONS(1959),
    [anon_sym_uR_DQUOTE] = ACTIONS(1959),
    [anon_sym_UR_DQUOTE] = ACTIONS(1959),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1959),
    [anon_sym_co_await] = ACTIONS(1961),
    [anon_sym_new] = ACTIONS(1961),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1961),
  },
  [437] = {
    [sym_else_clause] = STATE(545),
    [sym_identifier] = ACTIONS(2523),
    [aux_sym_preproc_include_token1] = ACTIONS(2523),
    [aux_sym_preproc_def_token1] = ACTIONS(2523),
    [aux_sym_preproc_if_token1] = ACTIONS(2523),
    [aux_sym_preproc_if_token2] = ACTIONS(2523),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2523),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2523),
    [sym_preproc_directive] = ACTIONS(2523),
    [anon_sym_LPAREN2] = ACTIONS(2525),
    [anon_sym_BANG] = ACTIONS(2525),
    [anon_sym_TILDE] = ACTIONS(2525),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_PLUS] = ACTIONS(2523),
    [anon_sym_STAR] = ACTIONS(2525),
    [anon_sym_AMP_AMP] = ACTIONS(2525),
    [anon_sym_AMP] = ACTIONS(2523),
    [anon_sym_SEMI] = ACTIONS(2525),
    [anon_sym___extension__] = ACTIONS(2523),
    [anon_sym_typedef] = ACTIONS(2523),
    [anon_sym_extern] = ACTIONS(2523),
    [anon_sym___attribute__] = ACTIONS(2523),
    [anon_sym_COLON_COLON] = ACTIONS(2525),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2525),
    [anon_sym___declspec] = ACTIONS(2523),
    [anon_sym___based] = ACTIONS(2523),
    [anon_sym___cdecl] = ACTIONS(2523),
    [anon_sym___clrcall] = ACTIONS(2523),
    [anon_sym___stdcall] = ACTIONS(2523),
    [anon_sym___fastcall] = ACTIONS(2523),
    [anon_sym___thiscall] = ACTIONS(2523),
    [anon_sym___vectorcall] = ACTIONS(2523),
    [anon_sym_LBRACE] = ACTIONS(2525),
    [anon_sym_signed] = ACTIONS(2523),
    [anon_sym_unsigned] = ACTIONS(2523),
    [anon_sym_long] = ACTIONS(2523),
    [anon_sym_short] = ACTIONS(2523),
    [anon_sym_LBRACK] = ACTIONS(2523),
    [anon_sym_static] = ACTIONS(2523),
    [anon_sym_register] = ACTIONS(2523),
    [anon_sym_inline] = ACTIONS(2523),
    [anon_sym___inline] = ACTIONS(2523),
    [anon_sym___inline__] = ACTIONS(2523),
    [anon_sym___forceinline] = ACTIONS(2523),
    [anon_sym_thread_local] = ACTIONS(2523),
    [anon_sym___thread] = ACTIONS(2523),
    [anon_sym_const] = ACTIONS(2523),
    [anon_sym_constexpr] = ACTIONS(2523),
    [anon_sym_volatile] = ACTIONS(2523),
    [anon_sym_restrict] = ACTIONS(2523),
    [anon_sym___restrict__] = ACTIONS(2523),
    [anon_sym__Atomic] = ACTIONS(2523),
    [anon_sym__Noreturn] = ACTIONS(2523),
    [anon_sym_noreturn] = ACTIONS(2523),
    [anon_sym_mutable] = ACTIONS(2523),
    [anon_sym_constinit] = ACTIONS(2523),
    [anon_sym_consteval] = ACTIONS(2523),
    [anon_sym_PROGMEM] = ACTIONS(2523),
    [aux_sym_primitive_type_token1] = ACTIONS(2523),
    [anon_sym_byte] = ACTIONS(2523),
    [anon_sym_word] = ACTIONS(2523),
    [anon_sym_enum] = ACTIONS(2523),
    [anon_sym_class] = ACTIONS(2523),
    [anon_sym_struct] = ACTIONS(2523),
    [anon_sym_union] = ACTIONS(2523),
    [anon_sym_if] = ACTIONS(2523),
    [anon_sym_else] = ACTIONS(3184),
    [anon_sym_switch] = ACTIONS(2523),
    [anon_sym_case] = ACTIONS(2523),
    [anon_sym_default] = ACTIONS(2523),
    [anon_sym_while] = ACTIONS(2523),
    [anon_sym_do] = ACTIONS(2523),
    [anon_sym_for] = ACTIONS(2523),
    [anon_sym_return] = ACTIONS(2523),
    [anon_sym_break] = ACTIONS(2523),
    [anon_sym_continue] = ACTIONS(2523),
    [anon_sym_goto] = ACTIONS(2523),
    [anon_sym___try] = ACTIONS(2523),
    [anon_sym___leave] = ACTIONS(2523),
    [anon_sym_not] = ACTIONS(2523),
    [anon_sym_compl] = ACTIONS(2523),
    [anon_sym_DASH_DASH] = ACTIONS(2525),
    [anon_sym_PLUS_PLUS] = ACTIONS(2525),
    [anon_sym_sizeof] = ACTIONS(2523),
    [anon_sym___alignof__] = ACTIONS(2523),
    [anon_sym___alignof] = ACTIONS(2523),
    [anon_sym__alignof] = ACTIONS(2523),
    [anon_sym_alignof] = ACTIONS(2523),
    [anon_sym__Alignof] = ACTIONS(2523),
    [anon_sym_offsetof] = ACTIONS(2523),
    [anon_sym__Generic] = ACTIONS(2523),
    [anon_sym_asm] = ACTIONS(2523),
    [anon_sym___asm__] = ACTIONS(2523),
    [aux_sym_number_literal_token1] = ACTIONS(2525),
    [aux_sym_number_literal_token2] = ACTIONS(2523),
    [anon_sym_L_SQUOTE] = ACTIONS(2525),
    [anon_sym_u_SQUOTE] = ACTIONS(2525),
    [anon_sym_U_SQUOTE] = ACTIONS(2525),
    [anon_sym_u8_SQUOTE] = ACTIONS(2525),
    [anon_sym_SQUOTE] = ACTIONS(2525),
    [anon_sym_L_DQUOTE] = ACTIONS(2525),
    [anon_sym_u_DQUOTE] = ACTIONS(2525),
    [anon_sym_U_DQUOTE] = ACTIONS(2525),
    [anon_sym_u8_DQUOTE] = ACTIONS(2525),
    [anon_sym_DQUOTE] = ACTIONS(2525),
    [sym_true] = ACTIONS(2523),
    [sym_false] = ACTIONS(2523),
    [anon_sym_NULL] = ACTIONS(2523),
    [anon_sym_nullptr] = ACTIONS(2523),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2523),
    [anon_sym_decltype] = ACTIONS(2523),
    [anon_sym_virtual] = ACTIONS(2523),
    [anon_sym_alignas] = ACTIONS(2523),
    [anon_sym_explicit] = ACTIONS(2523),
    [anon_sym_typename] = ACTIONS(2523),
    [anon_sym_template] = ACTIONS(2523),
    [anon_sym_operator] = ACTIONS(2523),
    [anon_sym_try] = ACTIONS(2523),
    [anon_sym_delete] = ACTIONS(2523),
    [anon_sym_throw] = ACTIONS(2523),
    [anon_sym_namespace] = ACTIONS(2523),
    [anon_sym_using] = ACTIONS(2523),
    [anon_sym_static_assert] = ACTIONS(2523),
    [anon_sym_concept] = ACTIONS(2523),
    [anon_sym_co_return] = ACTIONS(2523),
    [anon_sym_co_yield] = ACTIONS(2523),
    [anon_sym_R_DQUOTE] = ACTIONS(2525),
    [anon_sym_LR_DQUOTE] = ACTIONS(2525),
    [anon_sym_uR_DQUOTE] = ACTIONS(2525),
    [anon_sym_UR_DQUOTE] = ACTIONS(2525),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2525),
    [anon_sym_co_await] = ACTIONS(2523),
    [anon_sym_new] = ACTIONS(2523),
    [anon_sym_requires] = ACTIONS(2523),
    [sym_this] = ACTIONS(2523),
  },
  [438] = {
    [sym_identifier] = ACTIONS(2747),
    [aux_sym_preproc_include_token1] = ACTIONS(2747),
    [aux_sym_preproc_def_token1] = ACTIONS(2747),
    [aux_sym_preproc_if_token1] = ACTIONS(2747),
    [aux_sym_preproc_if_token2] = ACTIONS(2747),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2747),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2747),
    [sym_preproc_directive] = ACTIONS(2747),
    [anon_sym_LPAREN2] = ACTIONS(2749),
    [anon_sym_BANG] = ACTIONS(2749),
    [anon_sym_TILDE] = ACTIONS(2749),
    [anon_sym_DASH] = ACTIONS(2747),
    [anon_sym_PLUS] = ACTIONS(2747),
    [anon_sym_STAR] = ACTIONS(2749),
    [anon_sym_AMP_AMP] = ACTIONS(2749),
    [anon_sym_AMP] = ACTIONS(2747),
    [anon_sym_SEMI] = ACTIONS(2749),
    [anon_sym___extension__] = ACTIONS(2747),
    [anon_sym_typedef] = ACTIONS(2747),
    [anon_sym_extern] = ACTIONS(2747),
    [anon_sym___attribute__] = ACTIONS(2747),
    [anon_sym_COLON_COLON] = ACTIONS(2749),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2749),
    [anon_sym___declspec] = ACTIONS(2747),
    [anon_sym___based] = ACTIONS(2747),
    [anon_sym___cdecl] = ACTIONS(2747),
    [anon_sym___clrcall] = ACTIONS(2747),
    [anon_sym___stdcall] = ACTIONS(2747),
    [anon_sym___fastcall] = ACTIONS(2747),
    [anon_sym___thiscall] = ACTIONS(2747),
    [anon_sym___vectorcall] = ACTIONS(2747),
    [anon_sym_LBRACE] = ACTIONS(2749),
    [anon_sym_signed] = ACTIONS(2747),
    [anon_sym_unsigned] = ACTIONS(2747),
    [anon_sym_long] = ACTIONS(2747),
    [anon_sym_short] = ACTIONS(2747),
    [anon_sym_LBRACK] = ACTIONS(2747),
    [anon_sym_static] = ACTIONS(2747),
    [anon_sym_register] = ACTIONS(2747),
    [anon_sym_inline] = ACTIONS(2747),
    [anon_sym___inline] = ACTIONS(2747),
    [anon_sym___inline__] = ACTIONS(2747),
    [anon_sym___forceinline] = ACTIONS(2747),
    [anon_sym_thread_local] = ACTIONS(2747),
    [anon_sym___thread] = ACTIONS(2747),
    [anon_sym_const] = ACTIONS(2747),
    [anon_sym_constexpr] = ACTIONS(2747),
    [anon_sym_volatile] = ACTIONS(2747),
    [anon_sym_restrict] = ACTIONS(2747),
    [anon_sym___restrict__] = ACTIONS(2747),
    [anon_sym__Atomic] = ACTIONS(2747),
    [anon_sym__Noreturn] = ACTIONS(2747),
    [anon_sym_noreturn] = ACTIONS(2747),
    [anon_sym_mutable] = ACTIONS(2747),
    [anon_sym_constinit] = ACTIONS(2747),
    [anon_sym_consteval] = ACTIONS(2747),
    [anon_sym_PROGMEM] = ACTIONS(2747),
    [aux_sym_primitive_type_token1] = ACTIONS(2747),
    [anon_sym_byte] = ACTIONS(2747),
    [anon_sym_word] = ACTIONS(2747),
    [anon_sym_enum] = ACTIONS(2747),
    [anon_sym_class] = ACTIONS(2747),
    [anon_sym_struct] = ACTIONS(2747),
    [anon_sym_union] = ACTIONS(2747),
    [anon_sym_if] = ACTIONS(2747),
    [anon_sym_else] = ACTIONS(2747),
    [anon_sym_switch] = ACTIONS(2747),
    [anon_sym_case] = ACTIONS(2747),
    [anon_sym_default] = ACTIONS(2747),
    [anon_sym_while] = ACTIONS(2747),
    [anon_sym_do] = ACTIONS(2747),
    [anon_sym_for] = ACTIONS(2747),
    [anon_sym_return] = ACTIONS(2747),
    [anon_sym_break] = ACTIONS(2747),
    [anon_sym_continue] = ACTIONS(2747),
    [anon_sym_goto] = ACTIONS(2747),
    [anon_sym___try] = ACTIONS(2747),
    [anon_sym___leave] = ACTIONS(2747),
    [anon_sym_not] = ACTIONS(2747),
    [anon_sym_compl] = ACTIONS(2747),
    [anon_sym_DASH_DASH] = ACTIONS(2749),
    [anon_sym_PLUS_PLUS] = ACTIONS(2749),
    [anon_sym_sizeof] = ACTIONS(2747),
    [anon_sym___alignof__] = ACTIONS(2747),
    [anon_sym___alignof] = ACTIONS(2747),
    [anon_sym__alignof] = ACTIONS(2747),
    [anon_sym_alignof] = ACTIONS(2747),
    [anon_sym__Alignof] = ACTIONS(2747),
    [anon_sym_offsetof] = ACTIONS(2747),
    [anon_sym__Generic] = ACTIONS(2747),
    [anon_sym_asm] = ACTIONS(2747),
    [anon_sym___asm__] = ACTIONS(2747),
    [aux_sym_number_literal_token1] = ACTIONS(2749),
    [aux_sym_number_literal_token2] = ACTIONS(2747),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2749),
    [anon_sym_u_DQUOTE] = ACTIONS(2749),
    [anon_sym_U_DQUOTE] = ACTIONS(2749),
    [anon_sym_u8_DQUOTE] = ACTIONS(2749),
    [anon_sym_DQUOTE] = ACTIONS(2749),
    [sym_true] = ACTIONS(2747),
    [sym_false] = ACTIONS(2747),
    [anon_sym_NULL] = ACTIONS(2747),
    [anon_sym_nullptr] = ACTIONS(2747),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2747),
    [anon_sym_decltype] = ACTIONS(2747),
    [anon_sym_virtual] = ACTIONS(2747),
    [anon_sym_alignas] = ACTIONS(2747),
    [anon_sym_explicit] = ACTIONS(2747),
    [anon_sym_typename] = ACTIONS(2747),
    [anon_sym_template] = ACTIONS(2747),
    [anon_sym_operator] = ACTIONS(2747),
    [anon_sym_try] = ACTIONS(2747),
    [anon_sym_delete] = ACTIONS(2747),
    [anon_sym_throw] = ACTIONS(2747),
    [anon_sym_namespace] = ACTIONS(2747),
    [anon_sym_using] = ACTIONS(2747),
    [anon_sym_static_assert] = ACTIONS(2747),
    [anon_sym_concept] = ACTIONS(2747),
    [anon_sym_co_return] = ACTIONS(2747),
    [anon_sym_co_yield] = ACTIONS(2747),
    [anon_sym_R_DQUOTE] = ACTIONS(2749),
    [anon_sym_LR_DQUOTE] = ACTIONS(2749),
    [anon_sym_uR_DQUOTE] = ACTIONS(2749),
    [anon_sym_UR_DQUOTE] = ACTIONS(2749),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2749),
    [anon_sym_co_await] = ACTIONS(2747),
    [anon_sym_new] = ACTIONS(2747),
    [anon_sym_requires] = ACTIONS(2747),
    [sym_this] = ACTIONS(2747),
  },
  [439] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_RBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [440] = {
    [ts_builtin_sym_end] = ACTIONS(2681),
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [441] = {
    [ts_builtin_sym_end] = ACTIONS(2775),
    [sym_identifier] = ACTIONS(2773),
    [aux_sym_preproc_include_token1] = ACTIONS(2773),
    [aux_sym_preproc_def_token1] = ACTIONS(2773),
    [aux_sym_preproc_if_token1] = ACTIONS(2773),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2773),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2773),
    [sym_preproc_directive] = ACTIONS(2773),
    [anon_sym_LPAREN2] = ACTIONS(2775),
    [anon_sym_BANG] = ACTIONS(2775),
    [anon_sym_TILDE] = ACTIONS(2775),
    [anon_sym_DASH] = ACTIONS(2773),
    [anon_sym_PLUS] = ACTIONS(2773),
    [anon_sym_STAR] = ACTIONS(2775),
    [anon_sym_AMP_AMP] = ACTIONS(2775),
    [anon_sym_AMP] = ACTIONS(2773),
    [anon_sym_SEMI] = ACTIONS(2775),
    [anon_sym___extension__] = ACTIONS(2773),
    [anon_sym_typedef] = ACTIONS(2773),
    [anon_sym_extern] = ACTIONS(2773),
    [anon_sym___attribute__] = ACTIONS(2773),
    [anon_sym_COLON_COLON] = ACTIONS(2775),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2775),
    [anon_sym___declspec] = ACTIONS(2773),
    [anon_sym___based] = ACTIONS(2773),
    [anon_sym___cdecl] = ACTIONS(2773),
    [anon_sym___clrcall] = ACTIONS(2773),
    [anon_sym___stdcall] = ACTIONS(2773),
    [anon_sym___fastcall] = ACTIONS(2773),
    [anon_sym___thiscall] = ACTIONS(2773),
    [anon_sym___vectorcall] = ACTIONS(2773),
    [anon_sym_LBRACE] = ACTIONS(2775),
    [anon_sym_signed] = ACTIONS(2773),
    [anon_sym_unsigned] = ACTIONS(2773),
    [anon_sym_long] = ACTIONS(2773),
    [anon_sym_short] = ACTIONS(2773),
    [anon_sym_LBRACK] = ACTIONS(2773),
    [anon_sym_static] = ACTIONS(2773),
    [anon_sym_register] = ACTIONS(2773),
    [anon_sym_inline] = ACTIONS(2773),
    [anon_sym___inline] = ACTIONS(2773),
    [anon_sym___inline__] = ACTIONS(2773),
    [anon_sym___forceinline] = ACTIONS(2773),
    [anon_sym_thread_local] = ACTIONS(2773),
    [anon_sym___thread] = ACTIONS(2773),
    [anon_sym_const] = ACTIONS(2773),
    [anon_sym_constexpr] = ACTIONS(2773),
    [anon_sym_volatile] = ACTIONS(2773),
    [anon_sym_restrict] = ACTIONS(2773),
    [anon_sym___restrict__] = ACTIONS(2773),
    [anon_sym__Atomic] = ACTIONS(2773),
    [anon_sym__Noreturn] = ACTIONS(2773),
    [anon_sym_noreturn] = ACTIONS(2773),
    [anon_sym_mutable] = ACTIONS(2773),
    [anon_sym_constinit] = ACTIONS(2773),
    [anon_sym_consteval] = ACTIONS(2773),
    [anon_sym_PROGMEM] = ACTIONS(2773),
    [aux_sym_primitive_type_token1] = ACTIONS(2773),
    [anon_sym_byte] = ACTIONS(2773),
    [anon_sym_word] = ACTIONS(2773),
    [anon_sym_enum] = ACTIONS(2773),
    [anon_sym_class] = ACTIONS(2773),
    [anon_sym_struct] = ACTIONS(2773),
    [anon_sym_union] = ACTIONS(2773),
    [anon_sym_if] = ACTIONS(2773),
    [anon_sym_else] = ACTIONS(2773),
    [anon_sym_switch] = ACTIONS(2773),
    [anon_sym_case] = ACTIONS(2773),
    [anon_sym_default] = ACTIONS(2773),
    [anon_sym_while] = ACTIONS(2773),
    [anon_sym_do] = ACTIONS(2773),
    [anon_sym_for] = ACTIONS(2773),
    [anon_sym_return] = ACTIONS(2773),
    [anon_sym_break] = ACTIONS(2773),
    [anon_sym_continue] = ACTIONS(2773),
    [anon_sym_goto] = ACTIONS(2773),
    [anon_sym___try] = ACTIONS(2773),
    [anon_sym___leave] = ACTIONS(2773),
    [anon_sym_not] = ACTIONS(2773),
    [anon_sym_compl] = ACTIONS(2773),
    [anon_sym_DASH_DASH] = ACTIONS(2775),
    [anon_sym_PLUS_PLUS] = ACTIONS(2775),
    [anon_sym_sizeof] = ACTIONS(2773),
    [anon_sym___alignof__] = ACTIONS(2773),
    [anon_sym___alignof] = ACTIONS(2773),
    [anon_sym__alignof] = ACTIONS(2773),
    [anon_sym_alignof] = ACTIONS(2773),
    [anon_sym__Alignof] = ACTIONS(2773),
    [anon_sym_offsetof] = ACTIONS(2773),
    [anon_sym__Generic] = ACTIONS(2773),
    [anon_sym_asm] = ACTIONS(2773),
    [anon_sym___asm__] = ACTIONS(2773),
    [aux_sym_number_literal_token1] = ACTIONS(2775),
    [aux_sym_number_literal_token2] = ACTIONS(2773),
    [anon_sym_L_SQUOTE] = ACTIONS(2775),
    [anon_sym_u_SQUOTE] = ACTIONS(2775),
    [anon_sym_U_SQUOTE] = ACTIONS(2775),
    [anon_sym_u8_SQUOTE] = ACTIONS(2775),
    [anon_sym_SQUOTE] = ACTIONS(2775),
    [anon_sym_L_DQUOTE] = ACTIONS(2775),
    [anon_sym_u_DQUOTE] = ACTIONS(2775),
    [anon_sym_U_DQUOTE] = ACTIONS(2775),
    [anon_sym_u8_DQUOTE] = ACTIONS(2775),
    [anon_sym_DQUOTE] = ACTIONS(2775),
    [sym_true] = ACTIONS(2773),
    [sym_false] = ACTIONS(2773),
    [anon_sym_NULL] = ACTIONS(2773),
    [anon_sym_nullptr] = ACTIONS(2773),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2773),
    [anon_sym_decltype] = ACTIONS(2773),
    [anon_sym_virtual] = ACTIONS(2773),
    [anon_sym_alignas] = ACTIONS(2773),
    [anon_sym_explicit] = ACTIONS(2773),
    [anon_sym_typename] = ACTIONS(2773),
    [anon_sym_template] = ACTIONS(2773),
    [anon_sym_operator] = ACTIONS(2773),
    [anon_sym_try] = ACTIONS(2773),
    [anon_sym_delete] = ACTIONS(2773),
    [anon_sym_throw] = ACTIONS(2773),
    [anon_sym_namespace] = ACTIONS(2773),
    [anon_sym_using] = ACTIONS(2773),
    [anon_sym_static_assert] = ACTIONS(2773),
    [anon_sym_concept] = ACTIONS(2773),
    [anon_sym_co_return] = ACTIONS(2773),
    [anon_sym_co_yield] = ACTIONS(2773),
    [anon_sym_R_DQUOTE] = ACTIONS(2775),
    [anon_sym_LR_DQUOTE] = ACTIONS(2775),
    [anon_sym_uR_DQUOTE] = ACTIONS(2775),
    [anon_sym_UR_DQUOTE] = ACTIONS(2775),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2775),
    [anon_sym_co_await] = ACTIONS(2773),
    [anon_sym_new] = ACTIONS(2773),
    [anon_sym_requires] = ACTIONS(2773),
    [sym_this] = ACTIONS(2773),
  },
  [442] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(3868),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(2961),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(2961),
    [sym_call_expression] = STATE(2961),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(2961),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(2961),
    [sym_initializer_list] = STATE(3905),
    [sym_number_literal] = STATE(4149),
    [sym_char_literal] = STATE(4149),
    [sym_concatenated_string] = STATE(4150),
    [sym_string_literal] = STATE(3034),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3026),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2961),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(2961),
    [sym_identifier] = ACTIONS(1883),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1885),
    [anon_sym_COMMA] = ACTIONS(1885),
    [aux_sym_preproc_if_token2] = ACTIONS(1885),
    [aux_sym_preproc_else_token1] = ACTIONS(1885),
    [aux_sym_preproc_elif_token1] = ACTIONS(1883),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1885),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1885),
    [anon_sym_LPAREN2] = ACTIONS(1885),
    [anon_sym_BANG] = ACTIONS(3188),
    [anon_sym_TILDE] = ACTIONS(3190),
    [anon_sym_DASH] = ACTIONS(1883),
    [anon_sym_PLUS] = ACTIONS(1883),
    [anon_sym_STAR] = ACTIONS(1885),
    [anon_sym_SLASH] = ACTIONS(1883),
    [anon_sym_PERCENT] = ACTIONS(1885),
    [anon_sym_PIPE_PIPE] = ACTIONS(1885),
    [anon_sym_AMP_AMP] = ACTIONS(1885),
    [anon_sym_PIPE] = ACTIONS(1883),
    [anon_sym_CARET] = ACTIONS(1885),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym_EQ_EQ] = ACTIONS(1885),
    [anon_sym_BANG_EQ] = ACTIONS(1885),
    [anon_sym_GT] = ACTIONS(1883),
    [anon_sym_GT_EQ] = ACTIONS(1885),
    [anon_sym_LT_EQ] = ACTIONS(1883),
    [anon_sym_LT] = ACTIONS(1883),
    [anon_sym_LT_LT] = ACTIONS(1885),
    [anon_sym_GT_GT] = ACTIONS(1885),
    [anon_sym_COLON_COLON] = ACTIONS(3192),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(1885),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_QMARK] = ACTIONS(1885),
    [anon_sym_not] = ACTIONS(3188),
    [anon_sym_compl] = ACTIONS(3188),
    [anon_sym_LT_EQ_GT] = ACTIONS(1885),
    [anon_sym_or] = ACTIONS(1883),
    [anon_sym_and] = ACTIONS(1883),
    [anon_sym_bitor] = ACTIONS(1883),
    [anon_sym_xor] = ACTIONS(1883),
    [anon_sym_bitand] = ACTIONS(1883),
    [anon_sym_not_eq] = ACTIONS(1883),
    [anon_sym_DASH_DASH] = ACTIONS(1885),
    [anon_sym_PLUS_PLUS] = ACTIONS(1885),
    [anon_sym_sizeof] = ACTIONS(3196),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(1883),
    [anon_sym_DOT_STAR] = ACTIONS(1885),
    [anon_sym_DASH_GT] = ACTIONS(1885),
    [aux_sym_number_literal_token1] = ACTIONS(3198),
    [aux_sym_number_literal_token2] = ACTIONS(3200),
    [anon_sym_L_SQUOTE] = ACTIONS(3202),
    [anon_sym_u_SQUOTE] = ACTIONS(3202),
    [anon_sym_U_SQUOTE] = ACTIONS(3202),
    [anon_sym_u8_SQUOTE] = ACTIONS(3202),
    [anon_sym_SQUOTE] = ACTIONS(3202),
    [anon_sym_L_DQUOTE] = ACTIONS(3204),
    [anon_sym_u_DQUOTE] = ACTIONS(3204),
    [anon_sym_U_DQUOTE] = ACTIONS(3204),
    [anon_sym_u8_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3204),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3206),
    [anon_sym_R_DQUOTE] = ACTIONS(3208),
    [anon_sym_LR_DQUOTE] = ACTIONS(3208),
    [anon_sym_uR_DQUOTE] = ACTIONS(3208),
    [anon_sym_UR_DQUOTE] = ACTIONS(3208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3208),
    [anon_sym_co_await] = ACTIONS(3210),
    [anon_sym_new] = ACTIONS(3212),
    [anon_sym_requires] = ACTIONS(3214),
    [sym_this] = ACTIONS(219),
  },
  [443] = {
    [sym_identifier] = ACTIONS(2735),
    [aux_sym_preproc_include_token1] = ACTIONS(2735),
    [aux_sym_preproc_def_token1] = ACTIONS(2735),
    [aux_sym_preproc_if_token1] = ACTIONS(2735),
    [aux_sym_preproc_if_token2] = ACTIONS(2735),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2735),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2735),
    [sym_preproc_directive] = ACTIONS(2735),
    [anon_sym_LPAREN2] = ACTIONS(2737),
    [anon_sym_BANG] = ACTIONS(2737),
    [anon_sym_TILDE] = ACTIONS(2737),
    [anon_sym_DASH] = ACTIONS(2735),
    [anon_sym_PLUS] = ACTIONS(2735),
    [anon_sym_STAR] = ACTIONS(2737),
    [anon_sym_AMP_AMP] = ACTIONS(2737),
    [anon_sym_AMP] = ACTIONS(2735),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym___extension__] = ACTIONS(2735),
    [anon_sym_typedef] = ACTIONS(2735),
    [anon_sym_extern] = ACTIONS(2735),
    [anon_sym___attribute__] = ACTIONS(2735),
    [anon_sym_COLON_COLON] = ACTIONS(2737),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2737),
    [anon_sym___declspec] = ACTIONS(2735),
    [anon_sym___based] = ACTIONS(2735),
    [anon_sym___cdecl] = ACTIONS(2735),
    [anon_sym___clrcall] = ACTIONS(2735),
    [anon_sym___stdcall] = ACTIONS(2735),
    [anon_sym___fastcall] = ACTIONS(2735),
    [anon_sym___thiscall] = ACTIONS(2735),
    [anon_sym___vectorcall] = ACTIONS(2735),
    [anon_sym_LBRACE] = ACTIONS(2737),
    [anon_sym_signed] = ACTIONS(2735),
    [anon_sym_unsigned] = ACTIONS(2735),
    [anon_sym_long] = ACTIONS(2735),
    [anon_sym_short] = ACTIONS(2735),
    [anon_sym_LBRACK] = ACTIONS(2735),
    [anon_sym_static] = ACTIONS(2735),
    [anon_sym_register] = ACTIONS(2735),
    [anon_sym_inline] = ACTIONS(2735),
    [anon_sym___inline] = ACTIONS(2735),
    [anon_sym___inline__] = ACTIONS(2735),
    [anon_sym___forceinline] = ACTIONS(2735),
    [anon_sym_thread_local] = ACTIONS(2735),
    [anon_sym___thread] = ACTIONS(2735),
    [anon_sym_const] = ACTIONS(2735),
    [anon_sym_constexpr] = ACTIONS(2735),
    [anon_sym_volatile] = ACTIONS(2735),
    [anon_sym_restrict] = ACTIONS(2735),
    [anon_sym___restrict__] = ACTIONS(2735),
    [anon_sym__Atomic] = ACTIONS(2735),
    [anon_sym__Noreturn] = ACTIONS(2735),
    [anon_sym_noreturn] = ACTIONS(2735),
    [anon_sym_mutable] = ACTIONS(2735),
    [anon_sym_constinit] = ACTIONS(2735),
    [anon_sym_consteval] = ACTIONS(2735),
    [anon_sym_PROGMEM] = ACTIONS(2735),
    [aux_sym_primitive_type_token1] = ACTIONS(2735),
    [anon_sym_byte] = ACTIONS(2735),
    [anon_sym_word] = ACTIONS(2735),
    [anon_sym_enum] = ACTIONS(2735),
    [anon_sym_class] = ACTIONS(2735),
    [anon_sym_struct] = ACTIONS(2735),
    [anon_sym_union] = ACTIONS(2735),
    [anon_sym_if] = ACTIONS(2735),
    [anon_sym_else] = ACTIONS(2735),
    [anon_sym_switch] = ACTIONS(2735),
    [anon_sym_case] = ACTIONS(2735),
    [anon_sym_default] = ACTIONS(2735),
    [anon_sym_while] = ACTIONS(2735),
    [anon_sym_do] = ACTIONS(2735),
    [anon_sym_for] = ACTIONS(2735),
    [anon_sym_return] = ACTIONS(2735),
    [anon_sym_break] = ACTIONS(2735),
    [anon_sym_continue] = ACTIONS(2735),
    [anon_sym_goto] = ACTIONS(2735),
    [anon_sym___try] = ACTIONS(2735),
    [anon_sym___leave] = ACTIONS(2735),
    [anon_sym_not] = ACTIONS(2735),
    [anon_sym_compl] = ACTIONS(2735),
    [anon_sym_DASH_DASH] = ACTIONS(2737),
    [anon_sym_PLUS_PLUS] = ACTIONS(2737),
    [anon_sym_sizeof] = ACTIONS(2735),
    [anon_sym___alignof__] = ACTIONS(2735),
    [anon_sym___alignof] = ACTIONS(2735),
    [anon_sym__alignof] = ACTIONS(2735),
    [anon_sym_alignof] = ACTIONS(2735),
    [anon_sym__Alignof] = ACTIONS(2735),
    [anon_sym_offsetof] = ACTIONS(2735),
    [anon_sym__Generic] = ACTIONS(2735),
    [anon_sym_asm] = ACTIONS(2735),
    [anon_sym___asm__] = ACTIONS(2735),
    [aux_sym_number_literal_token1] = ACTIONS(2737),
    [aux_sym_number_literal_token2] = ACTIONS(2735),
    [anon_sym_L_SQUOTE] = ACTIONS(2737),
    [anon_sym_u_SQUOTE] = ACTIONS(2737),
    [anon_sym_U_SQUOTE] = ACTIONS(2737),
    [anon_sym_u8_SQUOTE] = ACTIONS(2737),
    [anon_sym_SQUOTE] = ACTIONS(2737),
    [anon_sym_L_DQUOTE] = ACTIONS(2737),
    [anon_sym_u_DQUOTE] = ACTIONS(2737),
    [anon_sym_U_DQUOTE] = ACTIONS(2737),
    [anon_sym_u8_DQUOTE] = ACTIONS(2737),
    [anon_sym_DQUOTE] = ACTIONS(2737),
    [sym_true] = ACTIONS(2735),
    [sym_false] = ACTIONS(2735),
    [anon_sym_NULL] = ACTIONS(2735),
    [anon_sym_nullptr] = ACTIONS(2735),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2735),
    [anon_sym_decltype] = ACTIONS(2735),
    [anon_sym_virtual] = ACTIONS(2735),
    [anon_sym_alignas] = ACTIONS(2735),
    [anon_sym_explicit] = ACTIONS(2735),
    [anon_sym_typename] = ACTIONS(2735),
    [anon_sym_template] = ACTIONS(2735),
    [anon_sym_operator] = ACTIONS(2735),
    [anon_sym_try] = ACTIONS(2735),
    [anon_sym_delete] = ACTIONS(2735),
    [anon_sym_throw] = ACTIONS(2735),
    [anon_sym_namespace] = ACTIONS(2735),
    [anon_sym_using] = ACTIONS(2735),
    [anon_sym_static_assert] = ACTIONS(2735),
    [anon_sym_concept] = ACTIONS(2735),
    [anon_sym_co_return] = ACTIONS(2735),
    [anon_sym_co_yield] = ACTIONS(2735),
    [anon_sym_R_DQUOTE] = ACTIONS(2737),
    [anon_sym_LR_DQUOTE] = ACTIONS(2737),
    [anon_sym_uR_DQUOTE] = ACTIONS(2737),
    [anon_sym_UR_DQUOTE] = ACTIONS(2737),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2737),
    [anon_sym_co_await] = ACTIONS(2735),
    [anon_sym_new] = ACTIONS(2735),
    [anon_sym_requires] = ACTIONS(2735),
    [sym_this] = ACTIONS(2735),
  },
  [444] = {
    [ts_builtin_sym_end] = ACTIONS(2681),
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [445] = {
    [sym_identifier] = ACTIONS(2773),
    [aux_sym_preproc_include_token1] = ACTIONS(2773),
    [aux_sym_preproc_def_token1] = ACTIONS(2773),
    [aux_sym_preproc_if_token1] = ACTIONS(2773),
    [aux_sym_preproc_if_token2] = ACTIONS(2773),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2773),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2773),
    [sym_preproc_directive] = ACTIONS(2773),
    [anon_sym_LPAREN2] = ACTIONS(2775),
    [anon_sym_BANG] = ACTIONS(2775),
    [anon_sym_TILDE] = ACTIONS(2775),
    [anon_sym_DASH] = ACTIONS(2773),
    [anon_sym_PLUS] = ACTIONS(2773),
    [anon_sym_STAR] = ACTIONS(2775),
    [anon_sym_AMP_AMP] = ACTIONS(2775),
    [anon_sym_AMP] = ACTIONS(2773),
    [anon_sym_SEMI] = ACTIONS(2775),
    [anon_sym___extension__] = ACTIONS(2773),
    [anon_sym_typedef] = ACTIONS(2773),
    [anon_sym_extern] = ACTIONS(2773),
    [anon_sym___attribute__] = ACTIONS(2773),
    [anon_sym_COLON_COLON] = ACTIONS(2775),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2775),
    [anon_sym___declspec] = ACTIONS(2773),
    [anon_sym___based] = ACTIONS(2773),
    [anon_sym___cdecl] = ACTIONS(2773),
    [anon_sym___clrcall] = ACTIONS(2773),
    [anon_sym___stdcall] = ACTIONS(2773),
    [anon_sym___fastcall] = ACTIONS(2773),
    [anon_sym___thiscall] = ACTIONS(2773),
    [anon_sym___vectorcall] = ACTIONS(2773),
    [anon_sym_LBRACE] = ACTIONS(2775),
    [anon_sym_signed] = ACTIONS(2773),
    [anon_sym_unsigned] = ACTIONS(2773),
    [anon_sym_long] = ACTIONS(2773),
    [anon_sym_short] = ACTIONS(2773),
    [anon_sym_LBRACK] = ACTIONS(2773),
    [anon_sym_static] = ACTIONS(2773),
    [anon_sym_register] = ACTIONS(2773),
    [anon_sym_inline] = ACTIONS(2773),
    [anon_sym___inline] = ACTIONS(2773),
    [anon_sym___inline__] = ACTIONS(2773),
    [anon_sym___forceinline] = ACTIONS(2773),
    [anon_sym_thread_local] = ACTIONS(2773),
    [anon_sym___thread] = ACTIONS(2773),
    [anon_sym_const] = ACTIONS(2773),
    [anon_sym_constexpr] = ACTIONS(2773),
    [anon_sym_volatile] = ACTIONS(2773),
    [anon_sym_restrict] = ACTIONS(2773),
    [anon_sym___restrict__] = ACTIONS(2773),
    [anon_sym__Atomic] = ACTIONS(2773),
    [anon_sym__Noreturn] = ACTIONS(2773),
    [anon_sym_noreturn] = ACTIONS(2773),
    [anon_sym_mutable] = ACTIONS(2773),
    [anon_sym_constinit] = ACTIONS(2773),
    [anon_sym_consteval] = ACTIONS(2773),
    [anon_sym_PROGMEM] = ACTIONS(2773),
    [aux_sym_primitive_type_token1] = ACTIONS(2773),
    [anon_sym_byte] = ACTIONS(2773),
    [anon_sym_word] = ACTIONS(2773),
    [anon_sym_enum] = ACTIONS(2773),
    [anon_sym_class] = ACTIONS(2773),
    [anon_sym_struct] = ACTIONS(2773),
    [anon_sym_union] = ACTIONS(2773),
    [anon_sym_if] = ACTIONS(2773),
    [anon_sym_else] = ACTIONS(2773),
    [anon_sym_switch] = ACTIONS(2773),
    [anon_sym_case] = ACTIONS(2773),
    [anon_sym_default] = ACTIONS(2773),
    [anon_sym_while] = ACTIONS(2773),
    [anon_sym_do] = ACTIONS(2773),
    [anon_sym_for] = ACTIONS(2773),
    [anon_sym_return] = ACTIONS(2773),
    [anon_sym_break] = ACTIONS(2773),
    [anon_sym_continue] = ACTIONS(2773),
    [anon_sym_goto] = ACTIONS(2773),
    [anon_sym___try] = ACTIONS(2773),
    [anon_sym___leave] = ACTIONS(2773),
    [anon_sym_not] = ACTIONS(2773),
    [anon_sym_compl] = ACTIONS(2773),
    [anon_sym_DASH_DASH] = ACTIONS(2775),
    [anon_sym_PLUS_PLUS] = ACTIONS(2775),
    [anon_sym_sizeof] = ACTIONS(2773),
    [anon_sym___alignof__] = ACTIONS(2773),
    [anon_sym___alignof] = ACTIONS(2773),
    [anon_sym__alignof] = ACTIONS(2773),
    [anon_sym_alignof] = ACTIONS(2773),
    [anon_sym__Alignof] = ACTIONS(2773),
    [anon_sym_offsetof] = ACTIONS(2773),
    [anon_sym__Generic] = ACTIONS(2773),
    [anon_sym_asm] = ACTIONS(2773),
    [anon_sym___asm__] = ACTIONS(2773),
    [aux_sym_number_literal_token1] = ACTIONS(2775),
    [aux_sym_number_literal_token2] = ACTIONS(2773),
    [anon_sym_L_SQUOTE] = ACTIONS(2775),
    [anon_sym_u_SQUOTE] = ACTIONS(2775),
    [anon_sym_U_SQUOTE] = ACTIONS(2775),
    [anon_sym_u8_SQUOTE] = ACTIONS(2775),
    [anon_sym_SQUOTE] = ACTIONS(2775),
    [anon_sym_L_DQUOTE] = ACTIONS(2775),
    [anon_sym_u_DQUOTE] = ACTIONS(2775),
    [anon_sym_U_DQUOTE] = ACTIONS(2775),
    [anon_sym_u8_DQUOTE] = ACTIONS(2775),
    [anon_sym_DQUOTE] = ACTIONS(2775),
    [sym_true] = ACTIONS(2773),
    [sym_false] = ACTIONS(2773),
    [anon_sym_NULL] = ACTIONS(2773),
    [anon_sym_nullptr] = ACTIONS(2773),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2773),
    [anon_sym_decltype] = ACTIONS(2773),
    [anon_sym_virtual] = ACTIONS(2773),
    [anon_sym_alignas] = ACTIONS(2773),
    [anon_sym_explicit] = ACTIONS(2773),
    [anon_sym_typename] = ACTIONS(2773),
    [anon_sym_template] = ACTIONS(2773),
    [anon_sym_operator] = ACTIONS(2773),
    [anon_sym_try] = ACTIONS(2773),
    [anon_sym_delete] = ACTIONS(2773),
    [anon_sym_throw] = ACTIONS(2773),
    [anon_sym_namespace] = ACTIONS(2773),
    [anon_sym_using] = ACTIONS(2773),
    [anon_sym_static_assert] = ACTIONS(2773),
    [anon_sym_concept] = ACTIONS(2773),
    [anon_sym_co_return] = ACTIONS(2773),
    [anon_sym_co_yield] = ACTIONS(2773),
    [anon_sym_R_DQUOTE] = ACTIONS(2775),
    [anon_sym_LR_DQUOTE] = ACTIONS(2775),
    [anon_sym_uR_DQUOTE] = ACTIONS(2775),
    [anon_sym_UR_DQUOTE] = ACTIONS(2775),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2775),
    [anon_sym_co_await] = ACTIONS(2773),
    [anon_sym_new] = ACTIONS(2773),
    [anon_sym_requires] = ACTIONS(2773),
    [sym_this] = ACTIONS(2773),
  },
  [446] = {
    [ts_builtin_sym_end] = ACTIONS(2681),
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [447] = {
    [ts_builtin_sym_end] = ACTIONS(2785),
    [sym_identifier] = ACTIONS(2783),
    [aux_sym_preproc_include_token1] = ACTIONS(2783),
    [aux_sym_preproc_def_token1] = ACTIONS(2783),
    [aux_sym_preproc_if_token1] = ACTIONS(2783),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2783),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2783),
    [sym_preproc_directive] = ACTIONS(2783),
    [anon_sym_LPAREN2] = ACTIONS(2785),
    [anon_sym_BANG] = ACTIONS(2785),
    [anon_sym_TILDE] = ACTIONS(2785),
    [anon_sym_DASH] = ACTIONS(2783),
    [anon_sym_PLUS] = ACTIONS(2783),
    [anon_sym_STAR] = ACTIONS(2785),
    [anon_sym_AMP_AMP] = ACTIONS(2785),
    [anon_sym_AMP] = ACTIONS(2783),
    [anon_sym_SEMI] = ACTIONS(2785),
    [anon_sym___extension__] = ACTIONS(2783),
    [anon_sym_typedef] = ACTIONS(2783),
    [anon_sym_extern] = ACTIONS(2783),
    [anon_sym___attribute__] = ACTIONS(2783),
    [anon_sym_COLON_COLON] = ACTIONS(2785),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2785),
    [anon_sym___declspec] = ACTIONS(2783),
    [anon_sym___based] = ACTIONS(2783),
    [anon_sym___cdecl] = ACTIONS(2783),
    [anon_sym___clrcall] = ACTIONS(2783),
    [anon_sym___stdcall] = ACTIONS(2783),
    [anon_sym___fastcall] = ACTIONS(2783),
    [anon_sym___thiscall] = ACTIONS(2783),
    [anon_sym___vectorcall] = ACTIONS(2783),
    [anon_sym_LBRACE] = ACTIONS(2785),
    [anon_sym_signed] = ACTIONS(2783),
    [anon_sym_unsigned] = ACTIONS(2783),
    [anon_sym_long] = ACTIONS(2783),
    [anon_sym_short] = ACTIONS(2783),
    [anon_sym_LBRACK] = ACTIONS(2783),
    [anon_sym_static] = ACTIONS(2783),
    [anon_sym_register] = ACTIONS(2783),
    [anon_sym_inline] = ACTIONS(2783),
    [anon_sym___inline] = ACTIONS(2783),
    [anon_sym___inline__] = ACTIONS(2783),
    [anon_sym___forceinline] = ACTIONS(2783),
    [anon_sym_thread_local] = ACTIONS(2783),
    [anon_sym___thread] = ACTIONS(2783),
    [anon_sym_const] = ACTIONS(2783),
    [anon_sym_constexpr] = ACTIONS(2783),
    [anon_sym_volatile] = ACTIONS(2783),
    [anon_sym_restrict] = ACTIONS(2783),
    [anon_sym___restrict__] = ACTIONS(2783),
    [anon_sym__Atomic] = ACTIONS(2783),
    [anon_sym__Noreturn] = ACTIONS(2783),
    [anon_sym_noreturn] = ACTIONS(2783),
    [anon_sym_mutable] = ACTIONS(2783),
    [anon_sym_constinit] = ACTIONS(2783),
    [anon_sym_consteval] = ACTIONS(2783),
    [anon_sym_PROGMEM] = ACTIONS(2783),
    [aux_sym_primitive_type_token1] = ACTIONS(2783),
    [anon_sym_byte] = ACTIONS(2783),
    [anon_sym_word] = ACTIONS(2783),
    [anon_sym_enum] = ACTIONS(2783),
    [anon_sym_class] = ACTIONS(2783),
    [anon_sym_struct] = ACTIONS(2783),
    [anon_sym_union] = ACTIONS(2783),
    [anon_sym_if] = ACTIONS(2783),
    [anon_sym_else] = ACTIONS(2783),
    [anon_sym_switch] = ACTIONS(2783),
    [anon_sym_case] = ACTIONS(2783),
    [anon_sym_default] = ACTIONS(2783),
    [anon_sym_while] = ACTIONS(2783),
    [anon_sym_do] = ACTIONS(2783),
    [anon_sym_for] = ACTIONS(2783),
    [anon_sym_return] = ACTIONS(2783),
    [anon_sym_break] = ACTIONS(2783),
    [anon_sym_continue] = ACTIONS(2783),
    [anon_sym_goto] = ACTIONS(2783),
    [anon_sym___try] = ACTIONS(2783),
    [anon_sym___leave] = ACTIONS(2783),
    [anon_sym_not] = ACTIONS(2783),
    [anon_sym_compl] = ACTIONS(2783),
    [anon_sym_DASH_DASH] = ACTIONS(2785),
    [anon_sym_PLUS_PLUS] = ACTIONS(2785),
    [anon_sym_sizeof] = ACTIONS(2783),
    [anon_sym___alignof__] = ACTIONS(2783),
    [anon_sym___alignof] = ACTIONS(2783),
    [anon_sym__alignof] = ACTIONS(2783),
    [anon_sym_alignof] = ACTIONS(2783),
    [anon_sym__Alignof] = ACTIONS(2783),
    [anon_sym_offsetof] = ACTIONS(2783),
    [anon_sym__Generic] = ACTIONS(2783),
    [anon_sym_asm] = ACTIONS(2783),
    [anon_sym___asm__] = ACTIONS(2783),
    [aux_sym_number_literal_token1] = ACTIONS(2785),
    [aux_sym_number_literal_token2] = ACTIONS(2783),
    [anon_sym_L_SQUOTE] = ACTIONS(2785),
    [anon_sym_u_SQUOTE] = ACTIONS(2785),
    [anon_sym_U_SQUOTE] = ACTIONS(2785),
    [anon_sym_u8_SQUOTE] = ACTIONS(2785),
    [anon_sym_SQUOTE] = ACTIONS(2785),
    [anon_sym_L_DQUOTE] = ACTIONS(2785),
    [anon_sym_u_DQUOTE] = ACTIONS(2785),
    [anon_sym_U_DQUOTE] = ACTIONS(2785),
    [anon_sym_u8_DQUOTE] = ACTIONS(2785),
    [anon_sym_DQUOTE] = ACTIONS(2785),
    [sym_true] = ACTIONS(2783),
    [sym_false] = ACTIONS(2783),
    [anon_sym_NULL] = ACTIONS(2783),
    [anon_sym_nullptr] = ACTIONS(2783),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2783),
    [anon_sym_decltype] = ACTIONS(2783),
    [anon_sym_virtual] = ACTIONS(2783),
    [anon_sym_alignas] = ACTIONS(2783),
    [anon_sym_explicit] = ACTIONS(2783),
    [anon_sym_typename] = ACTIONS(2783),
    [anon_sym_template] = ACTIONS(2783),
    [anon_sym_operator] = ACTIONS(2783),
    [anon_sym_try] = ACTIONS(2783),
    [anon_sym_delete] = ACTIONS(2783),
    [anon_sym_throw] = ACTIONS(2783),
    [anon_sym_namespace] = ACTIONS(2783),
    [anon_sym_using] = ACTIONS(2783),
    [anon_sym_static_assert] = ACTIONS(2783),
    [anon_sym_concept] = ACTIONS(2783),
    [anon_sym_co_return] = ACTIONS(2783),
    [anon_sym_co_yield] = ACTIONS(2783),
    [anon_sym_R_DQUOTE] = ACTIONS(2785),
    [anon_sym_LR_DQUOTE] = ACTIONS(2785),
    [anon_sym_uR_DQUOTE] = ACTIONS(2785),
    [anon_sym_UR_DQUOTE] = ACTIONS(2785),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2785),
    [anon_sym_co_await] = ACTIONS(2783),
    [anon_sym_new] = ACTIONS(2783),
    [anon_sym_requires] = ACTIONS(2783),
    [sym_this] = ACTIONS(2783),
  },
  [448] = {
    [sym_identifier] = ACTIONS(2783),
    [aux_sym_preproc_include_token1] = ACTIONS(2783),
    [aux_sym_preproc_def_token1] = ACTIONS(2783),
    [aux_sym_preproc_if_token1] = ACTIONS(2783),
    [aux_sym_preproc_if_token2] = ACTIONS(2783),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2783),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2783),
    [sym_preproc_directive] = ACTIONS(2783),
    [anon_sym_LPAREN2] = ACTIONS(2785),
    [anon_sym_BANG] = ACTIONS(2785),
    [anon_sym_TILDE] = ACTIONS(2785),
    [anon_sym_DASH] = ACTIONS(2783),
    [anon_sym_PLUS] = ACTIONS(2783),
    [anon_sym_STAR] = ACTIONS(2785),
    [anon_sym_AMP_AMP] = ACTIONS(2785),
    [anon_sym_AMP] = ACTIONS(2783),
    [anon_sym_SEMI] = ACTIONS(2785),
    [anon_sym___extension__] = ACTIONS(2783),
    [anon_sym_typedef] = ACTIONS(2783),
    [anon_sym_extern] = ACTIONS(2783),
    [anon_sym___attribute__] = ACTIONS(2783),
    [anon_sym_COLON_COLON] = ACTIONS(2785),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2785),
    [anon_sym___declspec] = ACTIONS(2783),
    [anon_sym___based] = ACTIONS(2783),
    [anon_sym___cdecl] = ACTIONS(2783),
    [anon_sym___clrcall] = ACTIONS(2783),
    [anon_sym___stdcall] = ACTIONS(2783),
    [anon_sym___fastcall] = ACTIONS(2783),
    [anon_sym___thiscall] = ACTIONS(2783),
    [anon_sym___vectorcall] = ACTIONS(2783),
    [anon_sym_LBRACE] = ACTIONS(2785),
    [anon_sym_signed] = ACTIONS(2783),
    [anon_sym_unsigned] = ACTIONS(2783),
    [anon_sym_long] = ACTIONS(2783),
    [anon_sym_short] = ACTIONS(2783),
    [anon_sym_LBRACK] = ACTIONS(2783),
    [anon_sym_static] = ACTIONS(2783),
    [anon_sym_register] = ACTIONS(2783),
    [anon_sym_inline] = ACTIONS(2783),
    [anon_sym___inline] = ACTIONS(2783),
    [anon_sym___inline__] = ACTIONS(2783),
    [anon_sym___forceinline] = ACTIONS(2783),
    [anon_sym_thread_local] = ACTIONS(2783),
    [anon_sym___thread] = ACTIONS(2783),
    [anon_sym_const] = ACTIONS(2783),
    [anon_sym_constexpr] = ACTIONS(2783),
    [anon_sym_volatile] = ACTIONS(2783),
    [anon_sym_restrict] = ACTIONS(2783),
    [anon_sym___restrict__] = ACTIONS(2783),
    [anon_sym__Atomic] = ACTIONS(2783),
    [anon_sym__Noreturn] = ACTIONS(2783),
    [anon_sym_noreturn] = ACTIONS(2783),
    [anon_sym_mutable] = ACTIONS(2783),
    [anon_sym_constinit] = ACTIONS(2783),
    [anon_sym_consteval] = ACTIONS(2783),
    [anon_sym_PROGMEM] = ACTIONS(2783),
    [aux_sym_primitive_type_token1] = ACTIONS(2783),
    [anon_sym_byte] = ACTIONS(2783),
    [anon_sym_word] = ACTIONS(2783),
    [anon_sym_enum] = ACTIONS(2783),
    [anon_sym_class] = ACTIONS(2783),
    [anon_sym_struct] = ACTIONS(2783),
    [anon_sym_union] = ACTIONS(2783),
    [anon_sym_if] = ACTIONS(2783),
    [anon_sym_else] = ACTIONS(2783),
    [anon_sym_switch] = ACTIONS(2783),
    [anon_sym_case] = ACTIONS(2783),
    [anon_sym_default] = ACTIONS(2783),
    [anon_sym_while] = ACTIONS(2783),
    [anon_sym_do] = ACTIONS(2783),
    [anon_sym_for] = ACTIONS(2783),
    [anon_sym_return] = ACTIONS(2783),
    [anon_sym_break] = ACTIONS(2783),
    [anon_sym_continue] = ACTIONS(2783),
    [anon_sym_goto] = ACTIONS(2783),
    [anon_sym___try] = ACTIONS(2783),
    [anon_sym___leave] = ACTIONS(2783),
    [anon_sym_not] = ACTIONS(2783),
    [anon_sym_compl] = ACTIONS(2783),
    [anon_sym_DASH_DASH] = ACTIONS(2785),
    [anon_sym_PLUS_PLUS] = ACTIONS(2785),
    [anon_sym_sizeof] = ACTIONS(2783),
    [anon_sym___alignof__] = ACTIONS(2783),
    [anon_sym___alignof] = ACTIONS(2783),
    [anon_sym__alignof] = ACTIONS(2783),
    [anon_sym_alignof] = ACTIONS(2783),
    [anon_sym__Alignof] = ACTIONS(2783),
    [anon_sym_offsetof] = ACTIONS(2783),
    [anon_sym__Generic] = ACTIONS(2783),
    [anon_sym_asm] = ACTIONS(2783),
    [anon_sym___asm__] = ACTIONS(2783),
    [aux_sym_number_literal_token1] = ACTIONS(2785),
    [aux_sym_number_literal_token2] = ACTIONS(2783),
    [anon_sym_L_SQUOTE] = ACTIONS(2785),
    [anon_sym_u_SQUOTE] = ACTIONS(2785),
    [anon_sym_U_SQUOTE] = ACTIONS(2785),
    [anon_sym_u8_SQUOTE] = ACTIONS(2785),
    [anon_sym_SQUOTE] = ACTIONS(2785),
    [anon_sym_L_DQUOTE] = ACTIONS(2785),
    [anon_sym_u_DQUOTE] = ACTIONS(2785),
    [anon_sym_U_DQUOTE] = ACTIONS(2785),
    [anon_sym_u8_DQUOTE] = ACTIONS(2785),
    [anon_sym_DQUOTE] = ACTIONS(2785),
    [sym_true] = ACTIONS(2783),
    [sym_false] = ACTIONS(2783),
    [anon_sym_NULL] = ACTIONS(2783),
    [anon_sym_nullptr] = ACTIONS(2783),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2783),
    [anon_sym_decltype] = ACTIONS(2783),
    [anon_sym_virtual] = ACTIONS(2783),
    [anon_sym_alignas] = ACTIONS(2783),
    [anon_sym_explicit] = ACTIONS(2783),
    [anon_sym_typename] = ACTIONS(2783),
    [anon_sym_template] = ACTIONS(2783),
    [anon_sym_operator] = ACTIONS(2783),
    [anon_sym_try] = ACTIONS(2783),
    [anon_sym_delete] = ACTIONS(2783),
    [anon_sym_throw] = ACTIONS(2783),
    [anon_sym_namespace] = ACTIONS(2783),
    [anon_sym_using] = ACTIONS(2783),
    [anon_sym_static_assert] = ACTIONS(2783),
    [anon_sym_concept] = ACTIONS(2783),
    [anon_sym_co_return] = ACTIONS(2783),
    [anon_sym_co_yield] = ACTIONS(2783),
    [anon_sym_R_DQUOTE] = ACTIONS(2785),
    [anon_sym_LR_DQUOTE] = ACTIONS(2785),
    [anon_sym_uR_DQUOTE] = ACTIONS(2785),
    [anon_sym_UR_DQUOTE] = ACTIONS(2785),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2785),
    [anon_sym_co_await] = ACTIONS(2783),
    [anon_sym_new] = ACTIONS(2783),
    [anon_sym_requires] = ACTIONS(2783),
    [sym_this] = ACTIONS(2783),
  },
  [449] = {
    [ts_builtin_sym_end] = ACTIONS(2681),
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [450] = {
    [ts_builtin_sym_end] = ACTIONS(2737),
    [sym_identifier] = ACTIONS(2735),
    [aux_sym_preproc_include_token1] = ACTIONS(2735),
    [aux_sym_preproc_def_token1] = ACTIONS(2735),
    [aux_sym_preproc_if_token1] = ACTIONS(2735),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2735),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2735),
    [sym_preproc_directive] = ACTIONS(2735),
    [anon_sym_LPAREN2] = ACTIONS(2737),
    [anon_sym_BANG] = ACTIONS(2737),
    [anon_sym_TILDE] = ACTIONS(2737),
    [anon_sym_DASH] = ACTIONS(2735),
    [anon_sym_PLUS] = ACTIONS(2735),
    [anon_sym_STAR] = ACTIONS(2737),
    [anon_sym_AMP_AMP] = ACTIONS(2737),
    [anon_sym_AMP] = ACTIONS(2735),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym___extension__] = ACTIONS(2735),
    [anon_sym_typedef] = ACTIONS(2735),
    [anon_sym_extern] = ACTIONS(2735),
    [anon_sym___attribute__] = ACTIONS(2735),
    [anon_sym_COLON_COLON] = ACTIONS(2737),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2737),
    [anon_sym___declspec] = ACTIONS(2735),
    [anon_sym___based] = ACTIONS(2735),
    [anon_sym___cdecl] = ACTIONS(2735),
    [anon_sym___clrcall] = ACTIONS(2735),
    [anon_sym___stdcall] = ACTIONS(2735),
    [anon_sym___fastcall] = ACTIONS(2735),
    [anon_sym___thiscall] = ACTIONS(2735),
    [anon_sym___vectorcall] = ACTIONS(2735),
    [anon_sym_LBRACE] = ACTIONS(2737),
    [anon_sym_signed] = ACTIONS(2735),
    [anon_sym_unsigned] = ACTIONS(2735),
    [anon_sym_long] = ACTIONS(2735),
    [anon_sym_short] = ACTIONS(2735),
    [anon_sym_LBRACK] = ACTIONS(2735),
    [anon_sym_static] = ACTIONS(2735),
    [anon_sym_register] = ACTIONS(2735),
    [anon_sym_inline] = ACTIONS(2735),
    [anon_sym___inline] = ACTIONS(2735),
    [anon_sym___inline__] = ACTIONS(2735),
    [anon_sym___forceinline] = ACTIONS(2735),
    [anon_sym_thread_local] = ACTIONS(2735),
    [anon_sym___thread] = ACTIONS(2735),
    [anon_sym_const] = ACTIONS(2735),
    [anon_sym_constexpr] = ACTIONS(2735),
    [anon_sym_volatile] = ACTIONS(2735),
    [anon_sym_restrict] = ACTIONS(2735),
    [anon_sym___restrict__] = ACTIONS(2735),
    [anon_sym__Atomic] = ACTIONS(2735),
    [anon_sym__Noreturn] = ACTIONS(2735),
    [anon_sym_noreturn] = ACTIONS(2735),
    [anon_sym_mutable] = ACTIONS(2735),
    [anon_sym_constinit] = ACTIONS(2735),
    [anon_sym_consteval] = ACTIONS(2735),
    [anon_sym_PROGMEM] = ACTIONS(2735),
    [aux_sym_primitive_type_token1] = ACTIONS(2735),
    [anon_sym_byte] = ACTIONS(2735),
    [anon_sym_word] = ACTIONS(2735),
    [anon_sym_enum] = ACTIONS(2735),
    [anon_sym_class] = ACTIONS(2735),
    [anon_sym_struct] = ACTIONS(2735),
    [anon_sym_union] = ACTIONS(2735),
    [anon_sym_if] = ACTIONS(2735),
    [anon_sym_else] = ACTIONS(2735),
    [anon_sym_switch] = ACTIONS(2735),
    [anon_sym_case] = ACTIONS(2735),
    [anon_sym_default] = ACTIONS(2735),
    [anon_sym_while] = ACTIONS(2735),
    [anon_sym_do] = ACTIONS(2735),
    [anon_sym_for] = ACTIONS(2735),
    [anon_sym_return] = ACTIONS(2735),
    [anon_sym_break] = ACTIONS(2735),
    [anon_sym_continue] = ACTIONS(2735),
    [anon_sym_goto] = ACTIONS(2735),
    [anon_sym___try] = ACTIONS(2735),
    [anon_sym___leave] = ACTIONS(2735),
    [anon_sym_not] = ACTIONS(2735),
    [anon_sym_compl] = ACTIONS(2735),
    [anon_sym_DASH_DASH] = ACTIONS(2737),
    [anon_sym_PLUS_PLUS] = ACTIONS(2737),
    [anon_sym_sizeof] = ACTIONS(2735),
    [anon_sym___alignof__] = ACTIONS(2735),
    [anon_sym___alignof] = ACTIONS(2735),
    [anon_sym__alignof] = ACTIONS(2735),
    [anon_sym_alignof] = ACTIONS(2735),
    [anon_sym__Alignof] = ACTIONS(2735),
    [anon_sym_offsetof] = ACTIONS(2735),
    [anon_sym__Generic] = ACTIONS(2735),
    [anon_sym_asm] = ACTIONS(2735),
    [anon_sym___asm__] = ACTIONS(2735),
    [aux_sym_number_literal_token1] = ACTIONS(2737),
    [aux_sym_number_literal_token2] = ACTIONS(2735),
    [anon_sym_L_SQUOTE] = ACTIONS(2737),
    [anon_sym_u_SQUOTE] = ACTIONS(2737),
    [anon_sym_U_SQUOTE] = ACTIONS(2737),
    [anon_sym_u8_SQUOTE] = ACTIONS(2737),
    [anon_sym_SQUOTE] = ACTIONS(2737),
    [anon_sym_L_DQUOTE] = ACTIONS(2737),
    [anon_sym_u_DQUOTE] = ACTIONS(2737),
    [anon_sym_U_DQUOTE] = ACTIONS(2737),
    [anon_sym_u8_DQUOTE] = ACTIONS(2737),
    [anon_sym_DQUOTE] = ACTIONS(2737),
    [sym_true] = ACTIONS(2735),
    [sym_false] = ACTIONS(2735),
    [anon_sym_NULL] = ACTIONS(2735),
    [anon_sym_nullptr] = ACTIONS(2735),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2735),
    [anon_sym_decltype] = ACTIONS(2735),
    [anon_sym_virtual] = ACTIONS(2735),
    [anon_sym_alignas] = ACTIONS(2735),
    [anon_sym_explicit] = ACTIONS(2735),
    [anon_sym_typename] = ACTIONS(2735),
    [anon_sym_template] = ACTIONS(2735),
    [anon_sym_operator] = ACTIONS(2735),
    [anon_sym_try] = ACTIONS(2735),
    [anon_sym_delete] = ACTIONS(2735),
    [anon_sym_throw] = ACTIONS(2735),
    [anon_sym_namespace] = ACTIONS(2735),
    [anon_sym_using] = ACTIONS(2735),
    [anon_sym_static_assert] = ACTIONS(2735),
    [anon_sym_concept] = ACTIONS(2735),
    [anon_sym_co_return] = ACTIONS(2735),
    [anon_sym_co_yield] = ACTIONS(2735),
    [anon_sym_R_DQUOTE] = ACTIONS(2737),
    [anon_sym_LR_DQUOTE] = ACTIONS(2737),
    [anon_sym_uR_DQUOTE] = ACTIONS(2737),
    [anon_sym_UR_DQUOTE] = ACTIONS(2737),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2737),
    [anon_sym_co_await] = ACTIONS(2735),
    [anon_sym_new] = ACTIONS(2735),
    [anon_sym_requires] = ACTIONS(2735),
    [sym_this] = ACTIONS(2735),
  },
  [451] = {
    [ts_builtin_sym_end] = ACTIONS(2645),
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [452] = {
    [sym_identifier] = ACTIONS(2739),
    [aux_sym_preproc_include_token1] = ACTIONS(2739),
    [aux_sym_preproc_def_token1] = ACTIONS(2739),
    [aux_sym_preproc_if_token1] = ACTIONS(2739),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2739),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2739),
    [sym_preproc_directive] = ACTIONS(2739),
    [anon_sym_LPAREN2] = ACTIONS(2741),
    [anon_sym_BANG] = ACTIONS(2741),
    [anon_sym_TILDE] = ACTIONS(2741),
    [anon_sym_DASH] = ACTIONS(2739),
    [anon_sym_PLUS] = ACTIONS(2739),
    [anon_sym_STAR] = ACTIONS(2741),
    [anon_sym_AMP_AMP] = ACTIONS(2741),
    [anon_sym_AMP] = ACTIONS(2739),
    [anon_sym_SEMI] = ACTIONS(2741),
    [anon_sym___extension__] = ACTIONS(2739),
    [anon_sym_typedef] = ACTIONS(2739),
    [anon_sym_extern] = ACTIONS(2739),
    [anon_sym___attribute__] = ACTIONS(2739),
    [anon_sym_COLON_COLON] = ACTIONS(2741),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2741),
    [anon_sym___declspec] = ACTIONS(2739),
    [anon_sym___based] = ACTIONS(2739),
    [anon_sym___cdecl] = ACTIONS(2739),
    [anon_sym___clrcall] = ACTIONS(2739),
    [anon_sym___stdcall] = ACTIONS(2739),
    [anon_sym___fastcall] = ACTIONS(2739),
    [anon_sym___thiscall] = ACTIONS(2739),
    [anon_sym___vectorcall] = ACTIONS(2739),
    [anon_sym_LBRACE] = ACTIONS(2741),
    [anon_sym_RBRACE] = ACTIONS(2741),
    [anon_sym_signed] = ACTIONS(2739),
    [anon_sym_unsigned] = ACTIONS(2739),
    [anon_sym_long] = ACTIONS(2739),
    [anon_sym_short] = ACTIONS(2739),
    [anon_sym_LBRACK] = ACTIONS(2739),
    [anon_sym_static] = ACTIONS(2739),
    [anon_sym_register] = ACTIONS(2739),
    [anon_sym_inline] = ACTIONS(2739),
    [anon_sym___inline] = ACTIONS(2739),
    [anon_sym___inline__] = ACTIONS(2739),
    [anon_sym___forceinline] = ACTIONS(2739),
    [anon_sym_thread_local] = ACTIONS(2739),
    [anon_sym___thread] = ACTIONS(2739),
    [anon_sym_const] = ACTIONS(2739),
    [anon_sym_constexpr] = ACTIONS(2739),
    [anon_sym_volatile] = ACTIONS(2739),
    [anon_sym_restrict] = ACTIONS(2739),
    [anon_sym___restrict__] = ACTIONS(2739),
    [anon_sym__Atomic] = ACTIONS(2739),
    [anon_sym__Noreturn] = ACTIONS(2739),
    [anon_sym_noreturn] = ACTIONS(2739),
    [anon_sym_mutable] = ACTIONS(2739),
    [anon_sym_constinit] = ACTIONS(2739),
    [anon_sym_consteval] = ACTIONS(2739),
    [anon_sym_PROGMEM] = ACTIONS(2739),
    [aux_sym_primitive_type_token1] = ACTIONS(2739),
    [anon_sym_byte] = ACTIONS(2739),
    [anon_sym_word] = ACTIONS(2739),
    [anon_sym_enum] = ACTIONS(2739),
    [anon_sym_class] = ACTIONS(2739),
    [anon_sym_struct] = ACTIONS(2739),
    [anon_sym_union] = ACTIONS(2739),
    [anon_sym_if] = ACTIONS(2739),
    [anon_sym_else] = ACTIONS(2739),
    [anon_sym_switch] = ACTIONS(2739),
    [anon_sym_case] = ACTIONS(2739),
    [anon_sym_default] = ACTIONS(2739),
    [anon_sym_while] = ACTIONS(2739),
    [anon_sym_do] = ACTIONS(2739),
    [anon_sym_for] = ACTIONS(2739),
    [anon_sym_return] = ACTIONS(2739),
    [anon_sym_break] = ACTIONS(2739),
    [anon_sym_continue] = ACTIONS(2739),
    [anon_sym_goto] = ACTIONS(2739),
    [anon_sym___try] = ACTIONS(2739),
    [anon_sym___leave] = ACTIONS(2739),
    [anon_sym_not] = ACTIONS(2739),
    [anon_sym_compl] = ACTIONS(2739),
    [anon_sym_DASH_DASH] = ACTIONS(2741),
    [anon_sym_PLUS_PLUS] = ACTIONS(2741),
    [anon_sym_sizeof] = ACTIONS(2739),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2739),
    [anon_sym__Generic] = ACTIONS(2739),
    [anon_sym_asm] = ACTIONS(2739),
    [anon_sym___asm__] = ACTIONS(2739),
    [aux_sym_number_literal_token1] = ACTIONS(2741),
    [aux_sym_number_literal_token2] = ACTIONS(2739),
    [anon_sym_L_SQUOTE] = ACTIONS(2741),
    [anon_sym_u_SQUOTE] = ACTIONS(2741),
    [anon_sym_U_SQUOTE] = ACTIONS(2741),
    [anon_sym_u8_SQUOTE] = ACTIONS(2741),
    [anon_sym_SQUOTE] = ACTIONS(2741),
    [anon_sym_L_DQUOTE] = ACTIONS(2741),
    [anon_sym_u_DQUOTE] = ACTIONS(2741),
    [anon_sym_U_DQUOTE] = ACTIONS(2741),
    [anon_sym_u8_DQUOTE] = ACTIONS(2741),
    [anon_sym_DQUOTE] = ACTIONS(2741),
    [sym_true] = ACTIONS(2739),
    [sym_false] = ACTIONS(2739),
    [anon_sym_NULL] = ACTIONS(2739),
    [anon_sym_nullptr] = ACTIONS(2739),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2739),
    [anon_sym_decltype] = ACTIONS(2739),
    [anon_sym_virtual] = ACTIONS(2739),
    [anon_sym_alignas] = ACTIONS(2739),
    [anon_sym_explicit] = ACTIONS(2739),
    [anon_sym_typename] = ACTIONS(2739),
    [anon_sym_template] = ACTIONS(2739),
    [anon_sym_operator] = ACTIONS(2739),
    [anon_sym_try] = ACTIONS(2739),
    [anon_sym_delete] = ACTIONS(2739),
    [anon_sym_throw] = ACTIONS(2739),
    [anon_sym_namespace] = ACTIONS(2739),
    [anon_sym_using] = ACTIONS(2739),
    [anon_sym_static_assert] = ACTIONS(2739),
    [anon_sym_concept] = ACTIONS(2739),
    [anon_sym_co_return] = ACTIONS(2739),
    [anon_sym_co_yield] = ACTIONS(2739),
    [anon_sym_R_DQUOTE] = ACTIONS(2741),
    [anon_sym_LR_DQUOTE] = ACTIONS(2741),
    [anon_sym_uR_DQUOTE] = ACTIONS(2741),
    [anon_sym_UR_DQUOTE] = ACTIONS(2741),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2741),
    [anon_sym_co_await] = ACTIONS(2739),
    [anon_sym_new] = ACTIONS(2739),
    [anon_sym_requires] = ACTIONS(2739),
    [sym_this] = ACTIONS(2739),
  },
  [453] = {
    [sym_identifier] = ACTIONS(2751),
    [aux_sym_preproc_include_token1] = ACTIONS(2751),
    [aux_sym_preproc_def_token1] = ACTIONS(2751),
    [aux_sym_preproc_if_token1] = ACTIONS(2751),
    [aux_sym_preproc_if_token2] = ACTIONS(2751),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2751),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2751),
    [sym_preproc_directive] = ACTIONS(2751),
    [anon_sym_LPAREN2] = ACTIONS(2753),
    [anon_sym_BANG] = ACTIONS(2753),
    [anon_sym_TILDE] = ACTIONS(2753),
    [anon_sym_DASH] = ACTIONS(2751),
    [anon_sym_PLUS] = ACTIONS(2751),
    [anon_sym_STAR] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2751),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym___extension__] = ACTIONS(2751),
    [anon_sym_typedef] = ACTIONS(2751),
    [anon_sym_extern] = ACTIONS(2751),
    [anon_sym___attribute__] = ACTIONS(2751),
    [anon_sym_COLON_COLON] = ACTIONS(2753),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2753),
    [anon_sym___declspec] = ACTIONS(2751),
    [anon_sym___based] = ACTIONS(2751),
    [anon_sym___cdecl] = ACTIONS(2751),
    [anon_sym___clrcall] = ACTIONS(2751),
    [anon_sym___stdcall] = ACTIONS(2751),
    [anon_sym___fastcall] = ACTIONS(2751),
    [anon_sym___thiscall] = ACTIONS(2751),
    [anon_sym___vectorcall] = ACTIONS(2751),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_signed] = ACTIONS(2751),
    [anon_sym_unsigned] = ACTIONS(2751),
    [anon_sym_long] = ACTIONS(2751),
    [anon_sym_short] = ACTIONS(2751),
    [anon_sym_LBRACK] = ACTIONS(2751),
    [anon_sym_static] = ACTIONS(2751),
    [anon_sym_register] = ACTIONS(2751),
    [anon_sym_inline] = ACTIONS(2751),
    [anon_sym___inline] = ACTIONS(2751),
    [anon_sym___inline__] = ACTIONS(2751),
    [anon_sym___forceinline] = ACTIONS(2751),
    [anon_sym_thread_local] = ACTIONS(2751),
    [anon_sym___thread] = ACTIONS(2751),
    [anon_sym_const] = ACTIONS(2751),
    [anon_sym_constexpr] = ACTIONS(2751),
    [anon_sym_volatile] = ACTIONS(2751),
    [anon_sym_restrict] = ACTIONS(2751),
    [anon_sym___restrict__] = ACTIONS(2751),
    [anon_sym__Atomic] = ACTIONS(2751),
    [anon_sym__Noreturn] = ACTIONS(2751),
    [anon_sym_noreturn] = ACTIONS(2751),
    [anon_sym_mutable] = ACTIONS(2751),
    [anon_sym_constinit] = ACTIONS(2751),
    [anon_sym_consteval] = ACTIONS(2751),
    [anon_sym_PROGMEM] = ACTIONS(2751),
    [aux_sym_primitive_type_token1] = ACTIONS(2751),
    [anon_sym_byte] = ACTIONS(2751),
    [anon_sym_word] = ACTIONS(2751),
    [anon_sym_enum] = ACTIONS(2751),
    [anon_sym_class] = ACTIONS(2751),
    [anon_sym_struct] = ACTIONS(2751),
    [anon_sym_union] = ACTIONS(2751),
    [anon_sym_if] = ACTIONS(2751),
    [anon_sym_else] = ACTIONS(2751),
    [anon_sym_switch] = ACTIONS(2751),
    [anon_sym_case] = ACTIONS(2751),
    [anon_sym_default] = ACTIONS(2751),
    [anon_sym_while] = ACTIONS(2751),
    [anon_sym_do] = ACTIONS(2751),
    [anon_sym_for] = ACTIONS(2751),
    [anon_sym_return] = ACTIONS(2751),
    [anon_sym_break] = ACTIONS(2751),
    [anon_sym_continue] = ACTIONS(2751),
    [anon_sym_goto] = ACTIONS(2751),
    [anon_sym___try] = ACTIONS(2751),
    [anon_sym___leave] = ACTIONS(2751),
    [anon_sym_not] = ACTIONS(2751),
    [anon_sym_compl] = ACTIONS(2751),
    [anon_sym_DASH_DASH] = ACTIONS(2753),
    [anon_sym_PLUS_PLUS] = ACTIONS(2753),
    [anon_sym_sizeof] = ACTIONS(2751),
    [anon_sym___alignof__] = ACTIONS(2751),
    [anon_sym___alignof] = ACTIONS(2751),
    [anon_sym__alignof] = ACTIONS(2751),
    [anon_sym_alignof] = ACTIONS(2751),
    [anon_sym__Alignof] = ACTIONS(2751),
    [anon_sym_offsetof] = ACTIONS(2751),
    [anon_sym__Generic] = ACTIONS(2751),
    [anon_sym_asm] = ACTIONS(2751),
    [anon_sym___asm__] = ACTIONS(2751),
    [aux_sym_number_literal_token1] = ACTIONS(2753),
    [aux_sym_number_literal_token2] = ACTIONS(2751),
    [anon_sym_L_SQUOTE] = ACTIONS(2753),
    [anon_sym_u_SQUOTE] = ACTIONS(2753),
    [anon_sym_U_SQUOTE] = ACTIONS(2753),
    [anon_sym_u8_SQUOTE] = ACTIONS(2753),
    [anon_sym_SQUOTE] = ACTIONS(2753),
    [anon_sym_L_DQUOTE] = ACTIONS(2753),
    [anon_sym_u_DQUOTE] = ACTIONS(2753),
    [anon_sym_U_DQUOTE] = ACTIONS(2753),
    [anon_sym_u8_DQUOTE] = ACTIONS(2753),
    [anon_sym_DQUOTE] = ACTIONS(2753),
    [sym_true] = ACTIONS(2751),
    [sym_false] = ACTIONS(2751),
    [anon_sym_NULL] = ACTIONS(2751),
    [anon_sym_nullptr] = ACTIONS(2751),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2751),
    [anon_sym_decltype] = ACTIONS(2751),
    [anon_sym_virtual] = ACTIONS(2751),
    [anon_sym_alignas] = ACTIONS(2751),
    [anon_sym_explicit] = ACTIONS(2751),
    [anon_sym_typename] = ACTIONS(2751),
    [anon_sym_template] = ACTIONS(2751),
    [anon_sym_operator] = ACTIONS(2751),
    [anon_sym_try] = ACTIONS(2751),
    [anon_sym_delete] = ACTIONS(2751),
    [anon_sym_throw] = ACTIONS(2751),
    [anon_sym_namespace] = ACTIONS(2751),
    [anon_sym_using] = ACTIONS(2751),
    [anon_sym_static_assert] = ACTIONS(2751),
    [anon_sym_concept] = ACTIONS(2751),
    [anon_sym_co_return] = ACTIONS(2751),
    [anon_sym_co_yield] = ACTIONS(2751),
    [anon_sym_R_DQUOTE] = ACTIONS(2753),
    [anon_sym_LR_DQUOTE] = ACTIONS(2753),
    [anon_sym_uR_DQUOTE] = ACTIONS(2753),
    [anon_sym_UR_DQUOTE] = ACTIONS(2753),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2753),
    [anon_sym_co_await] = ACTIONS(2751),
    [anon_sym_new] = ACTIONS(2751),
    [anon_sym_requires] = ACTIONS(2751),
    [sym_this] = ACTIONS(2751),
  },
  [454] = {
    [ts_builtin_sym_end] = ACTIONS(2763),
    [sym_identifier] = ACTIONS(2761),
    [aux_sym_preproc_include_token1] = ACTIONS(2761),
    [aux_sym_preproc_def_token1] = ACTIONS(2761),
    [aux_sym_preproc_if_token1] = ACTIONS(2761),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2761),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2761),
    [sym_preproc_directive] = ACTIONS(2761),
    [anon_sym_LPAREN2] = ACTIONS(2763),
    [anon_sym_BANG] = ACTIONS(2763),
    [anon_sym_TILDE] = ACTIONS(2763),
    [anon_sym_DASH] = ACTIONS(2761),
    [anon_sym_PLUS] = ACTIONS(2761),
    [anon_sym_STAR] = ACTIONS(2763),
    [anon_sym_AMP_AMP] = ACTIONS(2763),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2763),
    [anon_sym___extension__] = ACTIONS(2761),
    [anon_sym_typedef] = ACTIONS(2761),
    [anon_sym_extern] = ACTIONS(2761),
    [anon_sym___attribute__] = ACTIONS(2761),
    [anon_sym_COLON_COLON] = ACTIONS(2763),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2763),
    [anon_sym___declspec] = ACTIONS(2761),
    [anon_sym___based] = ACTIONS(2761),
    [anon_sym___cdecl] = ACTIONS(2761),
    [anon_sym___clrcall] = ACTIONS(2761),
    [anon_sym___stdcall] = ACTIONS(2761),
    [anon_sym___fastcall] = ACTIONS(2761),
    [anon_sym___thiscall] = ACTIONS(2761),
    [anon_sym___vectorcall] = ACTIONS(2761),
    [anon_sym_LBRACE] = ACTIONS(2763),
    [anon_sym_signed] = ACTIONS(2761),
    [anon_sym_unsigned] = ACTIONS(2761),
    [anon_sym_long] = ACTIONS(2761),
    [anon_sym_short] = ACTIONS(2761),
    [anon_sym_LBRACK] = ACTIONS(2761),
    [anon_sym_static] = ACTIONS(2761),
    [anon_sym_register] = ACTIONS(2761),
    [anon_sym_inline] = ACTIONS(2761),
    [anon_sym___inline] = ACTIONS(2761),
    [anon_sym___inline__] = ACTIONS(2761),
    [anon_sym___forceinline] = ACTIONS(2761),
    [anon_sym_thread_local] = ACTIONS(2761),
    [anon_sym___thread] = ACTIONS(2761),
    [anon_sym_const] = ACTIONS(2761),
    [anon_sym_constexpr] = ACTIONS(2761),
    [anon_sym_volatile] = ACTIONS(2761),
    [anon_sym_restrict] = ACTIONS(2761),
    [anon_sym___restrict__] = ACTIONS(2761),
    [anon_sym__Atomic] = ACTIONS(2761),
    [anon_sym__Noreturn] = ACTIONS(2761),
    [anon_sym_noreturn] = ACTIONS(2761),
    [anon_sym_mutable] = ACTIONS(2761),
    [anon_sym_constinit] = ACTIONS(2761),
    [anon_sym_consteval] = ACTIONS(2761),
    [anon_sym_PROGMEM] = ACTIONS(2761),
    [aux_sym_primitive_type_token1] = ACTIONS(2761),
    [anon_sym_byte] = ACTIONS(2761),
    [anon_sym_word] = ACTIONS(2761),
    [anon_sym_enum] = ACTIONS(2761),
    [anon_sym_class] = ACTIONS(2761),
    [anon_sym_struct] = ACTIONS(2761),
    [anon_sym_union] = ACTIONS(2761),
    [anon_sym_if] = ACTIONS(2761),
    [anon_sym_else] = ACTIONS(2761),
    [anon_sym_switch] = ACTIONS(2761),
    [anon_sym_case] = ACTIONS(2761),
    [anon_sym_default] = ACTIONS(2761),
    [anon_sym_while] = ACTIONS(2761),
    [anon_sym_do] = ACTIONS(2761),
    [anon_sym_for] = ACTIONS(2761),
    [anon_sym_return] = ACTIONS(2761),
    [anon_sym_break] = ACTIONS(2761),
    [anon_sym_continue] = ACTIONS(2761),
    [anon_sym_goto] = ACTIONS(2761),
    [anon_sym___try] = ACTIONS(2761),
    [anon_sym___leave] = ACTIONS(2761),
    [anon_sym_not] = ACTIONS(2761),
    [anon_sym_compl] = ACTIONS(2761),
    [anon_sym_DASH_DASH] = ACTIONS(2763),
    [anon_sym_PLUS_PLUS] = ACTIONS(2763),
    [anon_sym_sizeof] = ACTIONS(2761),
    [anon_sym___alignof__] = ACTIONS(2761),
    [anon_sym___alignof] = ACTIONS(2761),
    [anon_sym__alignof] = ACTIONS(2761),
    [anon_sym_alignof] = ACTIONS(2761),
    [anon_sym__Alignof] = ACTIONS(2761),
    [anon_sym_offsetof] = ACTIONS(2761),
    [anon_sym__Generic] = ACTIONS(2761),
    [anon_sym_asm] = ACTIONS(2761),
    [anon_sym___asm__] = ACTIONS(2761),
    [aux_sym_number_literal_token1] = ACTIONS(2763),
    [aux_sym_number_literal_token2] = ACTIONS(2761),
    [anon_sym_L_SQUOTE] = ACTIONS(2763),
    [anon_sym_u_SQUOTE] = ACTIONS(2763),
    [anon_sym_U_SQUOTE] = ACTIONS(2763),
    [anon_sym_u8_SQUOTE] = ACTIONS(2763),
    [anon_sym_SQUOTE] = ACTIONS(2763),
    [anon_sym_L_DQUOTE] = ACTIONS(2763),
    [anon_sym_u_DQUOTE] = ACTIONS(2763),
    [anon_sym_U_DQUOTE] = ACTIONS(2763),
    [anon_sym_u8_DQUOTE] = ACTIONS(2763),
    [anon_sym_DQUOTE] = ACTIONS(2763),
    [sym_true] = ACTIONS(2761),
    [sym_false] = ACTIONS(2761),
    [anon_sym_NULL] = ACTIONS(2761),
    [anon_sym_nullptr] = ACTIONS(2761),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2761),
    [anon_sym_decltype] = ACTIONS(2761),
    [anon_sym_virtual] = ACTIONS(2761),
    [anon_sym_alignas] = ACTIONS(2761),
    [anon_sym_explicit] = ACTIONS(2761),
    [anon_sym_typename] = ACTIONS(2761),
    [anon_sym_template] = ACTIONS(2761),
    [anon_sym_operator] = ACTIONS(2761),
    [anon_sym_try] = ACTIONS(2761),
    [anon_sym_delete] = ACTIONS(2761),
    [anon_sym_throw] = ACTIONS(2761),
    [anon_sym_namespace] = ACTIONS(2761),
    [anon_sym_using] = ACTIONS(2761),
    [anon_sym_static_assert] = ACTIONS(2761),
    [anon_sym_concept] = ACTIONS(2761),
    [anon_sym_co_return] = ACTIONS(2761),
    [anon_sym_co_yield] = ACTIONS(2761),
    [anon_sym_R_DQUOTE] = ACTIONS(2763),
    [anon_sym_LR_DQUOTE] = ACTIONS(2763),
    [anon_sym_uR_DQUOTE] = ACTIONS(2763),
    [anon_sym_UR_DQUOTE] = ACTIONS(2763),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2763),
    [anon_sym_co_await] = ACTIONS(2761),
    [anon_sym_new] = ACTIONS(2761),
    [anon_sym_requires] = ACTIONS(2761),
    [sym_this] = ACTIONS(2761),
  },
  [455] = {
    [ts_builtin_sym_end] = ACTIONS(2767),
    [sym_identifier] = ACTIONS(2765),
    [aux_sym_preproc_include_token1] = ACTIONS(2765),
    [aux_sym_preproc_def_token1] = ACTIONS(2765),
    [aux_sym_preproc_if_token1] = ACTIONS(2765),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2765),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2765),
    [sym_preproc_directive] = ACTIONS(2765),
    [anon_sym_LPAREN2] = ACTIONS(2767),
    [anon_sym_BANG] = ACTIONS(2767),
    [anon_sym_TILDE] = ACTIONS(2767),
    [anon_sym_DASH] = ACTIONS(2765),
    [anon_sym_PLUS] = ACTIONS(2765),
    [anon_sym_STAR] = ACTIONS(2767),
    [anon_sym_AMP_AMP] = ACTIONS(2767),
    [anon_sym_AMP] = ACTIONS(2765),
    [anon_sym_SEMI] = ACTIONS(2767),
    [anon_sym___extension__] = ACTIONS(2765),
    [anon_sym_typedef] = ACTIONS(2765),
    [anon_sym_extern] = ACTIONS(2765),
    [anon_sym___attribute__] = ACTIONS(2765),
    [anon_sym_COLON_COLON] = ACTIONS(2767),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2767),
    [anon_sym___declspec] = ACTIONS(2765),
    [anon_sym___based] = ACTIONS(2765),
    [anon_sym___cdecl] = ACTIONS(2765),
    [anon_sym___clrcall] = ACTIONS(2765),
    [anon_sym___stdcall] = ACTIONS(2765),
    [anon_sym___fastcall] = ACTIONS(2765),
    [anon_sym___thiscall] = ACTIONS(2765),
    [anon_sym___vectorcall] = ACTIONS(2765),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_signed] = ACTIONS(2765),
    [anon_sym_unsigned] = ACTIONS(2765),
    [anon_sym_long] = ACTIONS(2765),
    [anon_sym_short] = ACTIONS(2765),
    [anon_sym_LBRACK] = ACTIONS(2765),
    [anon_sym_static] = ACTIONS(2765),
    [anon_sym_register] = ACTIONS(2765),
    [anon_sym_inline] = ACTIONS(2765),
    [anon_sym___inline] = ACTIONS(2765),
    [anon_sym___inline__] = ACTIONS(2765),
    [anon_sym___forceinline] = ACTIONS(2765),
    [anon_sym_thread_local] = ACTIONS(2765),
    [anon_sym___thread] = ACTIONS(2765),
    [anon_sym_const] = ACTIONS(2765),
    [anon_sym_constexpr] = ACTIONS(2765),
    [anon_sym_volatile] = ACTIONS(2765),
    [anon_sym_restrict] = ACTIONS(2765),
    [anon_sym___restrict__] = ACTIONS(2765),
    [anon_sym__Atomic] = ACTIONS(2765),
    [anon_sym__Noreturn] = ACTIONS(2765),
    [anon_sym_noreturn] = ACTIONS(2765),
    [anon_sym_mutable] = ACTIONS(2765),
    [anon_sym_constinit] = ACTIONS(2765),
    [anon_sym_consteval] = ACTIONS(2765),
    [anon_sym_PROGMEM] = ACTIONS(2765),
    [aux_sym_primitive_type_token1] = ACTIONS(2765),
    [anon_sym_byte] = ACTIONS(2765),
    [anon_sym_word] = ACTIONS(2765),
    [anon_sym_enum] = ACTIONS(2765),
    [anon_sym_class] = ACTIONS(2765),
    [anon_sym_struct] = ACTIONS(2765),
    [anon_sym_union] = ACTIONS(2765),
    [anon_sym_if] = ACTIONS(2765),
    [anon_sym_else] = ACTIONS(2765),
    [anon_sym_switch] = ACTIONS(2765),
    [anon_sym_case] = ACTIONS(2765),
    [anon_sym_default] = ACTIONS(2765),
    [anon_sym_while] = ACTIONS(2765),
    [anon_sym_do] = ACTIONS(2765),
    [anon_sym_for] = ACTIONS(2765),
    [anon_sym_return] = ACTIONS(2765),
    [anon_sym_break] = ACTIONS(2765),
    [anon_sym_continue] = ACTIONS(2765),
    [anon_sym_goto] = ACTIONS(2765),
    [anon_sym___try] = ACTIONS(2765),
    [anon_sym___leave] = ACTIONS(2765),
    [anon_sym_not] = ACTIONS(2765),
    [anon_sym_compl] = ACTIONS(2765),
    [anon_sym_DASH_DASH] = ACTIONS(2767),
    [anon_sym_PLUS_PLUS] = ACTIONS(2767),
    [anon_sym_sizeof] = ACTIONS(2765),
    [anon_sym___alignof__] = ACTIONS(2765),
    [anon_sym___alignof] = ACTIONS(2765),
    [anon_sym__alignof] = ACTIONS(2765),
    [anon_sym_alignof] = ACTIONS(2765),
    [anon_sym__Alignof] = ACTIONS(2765),
    [anon_sym_offsetof] = ACTIONS(2765),
    [anon_sym__Generic] = ACTIONS(2765),
    [anon_sym_asm] = ACTIONS(2765),
    [anon_sym___asm__] = ACTIONS(2765),
    [aux_sym_number_literal_token1] = ACTIONS(2767),
    [aux_sym_number_literal_token2] = ACTIONS(2765),
    [anon_sym_L_SQUOTE] = ACTIONS(2767),
    [anon_sym_u_SQUOTE] = ACTIONS(2767),
    [anon_sym_U_SQUOTE] = ACTIONS(2767),
    [anon_sym_u8_SQUOTE] = ACTIONS(2767),
    [anon_sym_SQUOTE] = ACTIONS(2767),
    [anon_sym_L_DQUOTE] = ACTIONS(2767),
    [anon_sym_u_DQUOTE] = ACTIONS(2767),
    [anon_sym_U_DQUOTE] = ACTIONS(2767),
    [anon_sym_u8_DQUOTE] = ACTIONS(2767),
    [anon_sym_DQUOTE] = ACTIONS(2767),
    [sym_true] = ACTIONS(2765),
    [sym_false] = ACTIONS(2765),
    [anon_sym_NULL] = ACTIONS(2765),
    [anon_sym_nullptr] = ACTIONS(2765),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2765),
    [anon_sym_decltype] = ACTIONS(2765),
    [anon_sym_virtual] = ACTIONS(2765),
    [anon_sym_alignas] = ACTIONS(2765),
    [anon_sym_explicit] = ACTIONS(2765),
    [anon_sym_typename] = ACTIONS(2765),
    [anon_sym_template] = ACTIONS(2765),
    [anon_sym_operator] = ACTIONS(2765),
    [anon_sym_try] = ACTIONS(2765),
    [anon_sym_delete] = ACTIONS(2765),
    [anon_sym_throw] = ACTIONS(2765),
    [anon_sym_namespace] = ACTIONS(2765),
    [anon_sym_using] = ACTIONS(2765),
    [anon_sym_static_assert] = ACTIONS(2765),
    [anon_sym_concept] = ACTIONS(2765),
    [anon_sym_co_return] = ACTIONS(2765),
    [anon_sym_co_yield] = ACTIONS(2765),
    [anon_sym_R_DQUOTE] = ACTIONS(2767),
    [anon_sym_LR_DQUOTE] = ACTIONS(2767),
    [anon_sym_uR_DQUOTE] = ACTIONS(2767),
    [anon_sym_UR_DQUOTE] = ACTIONS(2767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2767),
    [anon_sym_co_await] = ACTIONS(2765),
    [anon_sym_new] = ACTIONS(2765),
    [anon_sym_requires] = ACTIONS(2765),
    [sym_this] = ACTIONS(2765),
  },
  [456] = {
    [ts_builtin_sym_end] = ACTIONS(2681),
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [457] = {
    [sym_identifier] = ACTIONS(1957),
    [aux_sym_preproc_include_token1] = ACTIONS(1957),
    [aux_sym_preproc_def_token1] = ACTIONS(1957),
    [anon_sym_COMMA] = ACTIONS(2743),
    [aux_sym_preproc_if_token1] = ACTIONS(1957),
    [aux_sym_preproc_if_token2] = ACTIONS(1957),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1957),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1957),
    [sym_preproc_directive] = ACTIONS(1957),
    [anon_sym_LPAREN2] = ACTIONS(1955),
    [anon_sym_BANG] = ACTIONS(1955),
    [anon_sym_TILDE] = ACTIONS(1955),
    [anon_sym_DASH] = ACTIONS(1957),
    [anon_sym_PLUS] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(1955),
    [anon_sym_AMP_AMP] = ACTIONS(1955),
    [anon_sym_AMP] = ACTIONS(1957),
    [anon_sym_SEMI] = ACTIONS(2743),
    [anon_sym___extension__] = ACTIONS(1957),
    [anon_sym_typedef] = ACTIONS(1957),
    [anon_sym_extern] = ACTIONS(1957),
    [anon_sym___attribute__] = ACTIONS(1957),
    [anon_sym_COLON_COLON] = ACTIONS(1955),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1955),
    [anon_sym___declspec] = ACTIONS(1957),
    [anon_sym___based] = ACTIONS(1957),
    [anon_sym___cdecl] = ACTIONS(1957),
    [anon_sym___clrcall] = ACTIONS(1957),
    [anon_sym___stdcall] = ACTIONS(1957),
    [anon_sym___fastcall] = ACTIONS(1957),
    [anon_sym___thiscall] = ACTIONS(1957),
    [anon_sym___vectorcall] = ACTIONS(1957),
    [anon_sym_LBRACE] = ACTIONS(1955),
    [anon_sym_signed] = ACTIONS(1957),
    [anon_sym_unsigned] = ACTIONS(1957),
    [anon_sym_long] = ACTIONS(1957),
    [anon_sym_short] = ACTIONS(1957),
    [anon_sym_LBRACK] = ACTIONS(1957),
    [anon_sym_static] = ACTIONS(1957),
    [anon_sym_register] = ACTIONS(1957),
    [anon_sym_inline] = ACTIONS(1957),
    [anon_sym___inline] = ACTIONS(1957),
    [anon_sym___inline__] = ACTIONS(1957),
    [anon_sym___forceinline] = ACTIONS(1957),
    [anon_sym_thread_local] = ACTIONS(1957),
    [anon_sym___thread] = ACTIONS(1957),
    [anon_sym_const] = ACTIONS(1957),
    [anon_sym_constexpr] = ACTIONS(1957),
    [anon_sym_volatile] = ACTIONS(1957),
    [anon_sym_restrict] = ACTIONS(1957),
    [anon_sym___restrict__] = ACTIONS(1957),
    [anon_sym__Atomic] = ACTIONS(1957),
    [anon_sym__Noreturn] = ACTIONS(1957),
    [anon_sym_noreturn] = ACTIONS(1957),
    [anon_sym_mutable] = ACTIONS(1957),
    [anon_sym_constinit] = ACTIONS(1957),
    [anon_sym_consteval] = ACTIONS(1957),
    [anon_sym_PROGMEM] = ACTIONS(1957),
    [aux_sym_primitive_type_token1] = ACTIONS(1957),
    [anon_sym_byte] = ACTIONS(1957),
    [anon_sym_word] = ACTIONS(1957),
    [anon_sym_enum] = ACTIONS(1957),
    [anon_sym_class] = ACTIONS(1957),
    [anon_sym_struct] = ACTIONS(1957),
    [anon_sym_union] = ACTIONS(1957),
    [anon_sym_if] = ACTIONS(1957),
    [anon_sym_switch] = ACTIONS(1957),
    [anon_sym_case] = ACTIONS(1957),
    [anon_sym_default] = ACTIONS(1957),
    [anon_sym_while] = ACTIONS(1957),
    [anon_sym_do] = ACTIONS(1957),
    [anon_sym_for] = ACTIONS(1957),
    [anon_sym_return] = ACTIONS(1957),
    [anon_sym_break] = ACTIONS(1957),
    [anon_sym_continue] = ACTIONS(1957),
    [anon_sym_goto] = ACTIONS(1957),
    [anon_sym___try] = ACTIONS(1957),
    [anon_sym___leave] = ACTIONS(1957),
    [anon_sym_not] = ACTIONS(1957),
    [anon_sym_compl] = ACTIONS(1957),
    [anon_sym_DASH_DASH] = ACTIONS(1955),
    [anon_sym_PLUS_PLUS] = ACTIONS(1955),
    [anon_sym_sizeof] = ACTIONS(1957),
    [anon_sym___alignof__] = ACTIONS(1957),
    [anon_sym___alignof] = ACTIONS(1957),
    [anon_sym__alignof] = ACTIONS(1957),
    [anon_sym_alignof] = ACTIONS(1957),
    [anon_sym__Alignof] = ACTIONS(1957),
    [anon_sym_offsetof] = ACTIONS(1957),
    [anon_sym__Generic] = ACTIONS(1957),
    [anon_sym_asm] = ACTIONS(1957),
    [anon_sym___asm__] = ACTIONS(1957),
    [aux_sym_number_literal_token1] = ACTIONS(1955),
    [aux_sym_number_literal_token2] = ACTIONS(1957),
    [anon_sym_L_SQUOTE] = ACTIONS(1955),
    [anon_sym_u_SQUOTE] = ACTIONS(1955),
    [anon_sym_U_SQUOTE] = ACTIONS(1955),
    [anon_sym_u8_SQUOTE] = ACTIONS(1955),
    [anon_sym_SQUOTE] = ACTIONS(1955),
    [anon_sym_L_DQUOTE] = ACTIONS(1955),
    [anon_sym_u_DQUOTE] = ACTIONS(1955),
    [anon_sym_U_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8_DQUOTE] = ACTIONS(1955),
    [anon_sym_DQUOTE] = ACTIONS(1955),
    [sym_true] = ACTIONS(1957),
    [sym_false] = ACTIONS(1957),
    [anon_sym_NULL] = ACTIONS(1957),
    [anon_sym_nullptr] = ACTIONS(1957),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1957),
    [anon_sym_decltype] = ACTIONS(1957),
    [anon_sym_virtual] = ACTIONS(1957),
    [anon_sym_alignas] = ACTIONS(1957),
    [anon_sym_explicit] = ACTIONS(1957),
    [anon_sym_typename] = ACTIONS(1957),
    [anon_sym_template] = ACTIONS(1957),
    [anon_sym_operator] = ACTIONS(1957),
    [anon_sym_try] = ACTIONS(1957),
    [anon_sym_delete] = ACTIONS(1957),
    [anon_sym_throw] = ACTIONS(1957),
    [anon_sym_namespace] = ACTIONS(1957),
    [anon_sym_using] = ACTIONS(1957),
    [anon_sym_static_assert] = ACTIONS(1957),
    [anon_sym_concept] = ACTIONS(1957),
    [anon_sym_co_return] = ACTIONS(1957),
    [anon_sym_co_yield] = ACTIONS(1957),
    [anon_sym_R_DQUOTE] = ACTIONS(1955),
    [anon_sym_LR_DQUOTE] = ACTIONS(1955),
    [anon_sym_uR_DQUOTE] = ACTIONS(1955),
    [anon_sym_UR_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1955),
    [anon_sym_co_await] = ACTIONS(1957),
    [anon_sym_new] = ACTIONS(1957),
    [anon_sym_requires] = ACTIONS(1957),
    [sym_this] = ACTIONS(1957),
  },
  [458] = {
    [ts_builtin_sym_end] = ACTIONS(2749),
    [sym_identifier] = ACTIONS(2747),
    [aux_sym_preproc_include_token1] = ACTIONS(2747),
    [aux_sym_preproc_def_token1] = ACTIONS(2747),
    [aux_sym_preproc_if_token1] = ACTIONS(2747),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2747),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2747),
    [sym_preproc_directive] = ACTIONS(2747),
    [anon_sym_LPAREN2] = ACTIONS(2749),
    [anon_sym_BANG] = ACTIONS(2749),
    [anon_sym_TILDE] = ACTIONS(2749),
    [anon_sym_DASH] = ACTIONS(2747),
    [anon_sym_PLUS] = ACTIONS(2747),
    [anon_sym_STAR] = ACTIONS(2749),
    [anon_sym_AMP_AMP] = ACTIONS(2749),
    [anon_sym_AMP] = ACTIONS(2747),
    [anon_sym_SEMI] = ACTIONS(2749),
    [anon_sym___extension__] = ACTIONS(2747),
    [anon_sym_typedef] = ACTIONS(2747),
    [anon_sym_extern] = ACTIONS(2747),
    [anon_sym___attribute__] = ACTIONS(2747),
    [anon_sym_COLON_COLON] = ACTIONS(2749),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2749),
    [anon_sym___declspec] = ACTIONS(2747),
    [anon_sym___based] = ACTIONS(2747),
    [anon_sym___cdecl] = ACTIONS(2747),
    [anon_sym___clrcall] = ACTIONS(2747),
    [anon_sym___stdcall] = ACTIONS(2747),
    [anon_sym___fastcall] = ACTIONS(2747),
    [anon_sym___thiscall] = ACTIONS(2747),
    [anon_sym___vectorcall] = ACTIONS(2747),
    [anon_sym_LBRACE] = ACTIONS(2749),
    [anon_sym_signed] = ACTIONS(2747),
    [anon_sym_unsigned] = ACTIONS(2747),
    [anon_sym_long] = ACTIONS(2747),
    [anon_sym_short] = ACTIONS(2747),
    [anon_sym_LBRACK] = ACTIONS(2747),
    [anon_sym_static] = ACTIONS(2747),
    [anon_sym_register] = ACTIONS(2747),
    [anon_sym_inline] = ACTIONS(2747),
    [anon_sym___inline] = ACTIONS(2747),
    [anon_sym___inline__] = ACTIONS(2747),
    [anon_sym___forceinline] = ACTIONS(2747),
    [anon_sym_thread_local] = ACTIONS(2747),
    [anon_sym___thread] = ACTIONS(2747),
    [anon_sym_const] = ACTIONS(2747),
    [anon_sym_constexpr] = ACTIONS(2747),
    [anon_sym_volatile] = ACTIONS(2747),
    [anon_sym_restrict] = ACTIONS(2747),
    [anon_sym___restrict__] = ACTIONS(2747),
    [anon_sym__Atomic] = ACTIONS(2747),
    [anon_sym__Noreturn] = ACTIONS(2747),
    [anon_sym_noreturn] = ACTIONS(2747),
    [anon_sym_mutable] = ACTIONS(2747),
    [anon_sym_constinit] = ACTIONS(2747),
    [anon_sym_consteval] = ACTIONS(2747),
    [anon_sym_PROGMEM] = ACTIONS(2747),
    [aux_sym_primitive_type_token1] = ACTIONS(2747),
    [anon_sym_byte] = ACTIONS(2747),
    [anon_sym_word] = ACTIONS(2747),
    [anon_sym_enum] = ACTIONS(2747),
    [anon_sym_class] = ACTIONS(2747),
    [anon_sym_struct] = ACTIONS(2747),
    [anon_sym_union] = ACTIONS(2747),
    [anon_sym_if] = ACTIONS(2747),
    [anon_sym_else] = ACTIONS(2747),
    [anon_sym_switch] = ACTIONS(2747),
    [anon_sym_case] = ACTIONS(2747),
    [anon_sym_default] = ACTIONS(2747),
    [anon_sym_while] = ACTIONS(2747),
    [anon_sym_do] = ACTIONS(2747),
    [anon_sym_for] = ACTIONS(2747),
    [anon_sym_return] = ACTIONS(2747),
    [anon_sym_break] = ACTIONS(2747),
    [anon_sym_continue] = ACTIONS(2747),
    [anon_sym_goto] = ACTIONS(2747),
    [anon_sym___try] = ACTIONS(2747),
    [anon_sym___leave] = ACTIONS(2747),
    [anon_sym_not] = ACTIONS(2747),
    [anon_sym_compl] = ACTIONS(2747),
    [anon_sym_DASH_DASH] = ACTIONS(2749),
    [anon_sym_PLUS_PLUS] = ACTIONS(2749),
    [anon_sym_sizeof] = ACTIONS(2747),
    [anon_sym___alignof__] = ACTIONS(2747),
    [anon_sym___alignof] = ACTIONS(2747),
    [anon_sym__alignof] = ACTIONS(2747),
    [anon_sym_alignof] = ACTIONS(2747),
    [anon_sym__Alignof] = ACTIONS(2747),
    [anon_sym_offsetof] = ACTIONS(2747),
    [anon_sym__Generic] = ACTIONS(2747),
    [anon_sym_asm] = ACTIONS(2747),
    [anon_sym___asm__] = ACTIONS(2747),
    [aux_sym_number_literal_token1] = ACTIONS(2749),
    [aux_sym_number_literal_token2] = ACTIONS(2747),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2749),
    [anon_sym_u_DQUOTE] = ACTIONS(2749),
    [anon_sym_U_DQUOTE] = ACTIONS(2749),
    [anon_sym_u8_DQUOTE] = ACTIONS(2749),
    [anon_sym_DQUOTE] = ACTIONS(2749),
    [sym_true] = ACTIONS(2747),
    [sym_false] = ACTIONS(2747),
    [anon_sym_NULL] = ACTIONS(2747),
    [anon_sym_nullptr] = ACTIONS(2747),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2747),
    [anon_sym_decltype] = ACTIONS(2747),
    [anon_sym_virtual] = ACTIONS(2747),
    [anon_sym_alignas] = ACTIONS(2747),
    [anon_sym_explicit] = ACTIONS(2747),
    [anon_sym_typename] = ACTIONS(2747),
    [anon_sym_template] = ACTIONS(2747),
    [anon_sym_operator] = ACTIONS(2747),
    [anon_sym_try] = ACTIONS(2747),
    [anon_sym_delete] = ACTIONS(2747),
    [anon_sym_throw] = ACTIONS(2747),
    [anon_sym_namespace] = ACTIONS(2747),
    [anon_sym_using] = ACTIONS(2747),
    [anon_sym_static_assert] = ACTIONS(2747),
    [anon_sym_concept] = ACTIONS(2747),
    [anon_sym_co_return] = ACTIONS(2747),
    [anon_sym_co_yield] = ACTIONS(2747),
    [anon_sym_R_DQUOTE] = ACTIONS(2749),
    [anon_sym_LR_DQUOTE] = ACTIONS(2749),
    [anon_sym_uR_DQUOTE] = ACTIONS(2749),
    [anon_sym_UR_DQUOTE] = ACTIONS(2749),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2749),
    [anon_sym_co_await] = ACTIONS(2747),
    [anon_sym_new] = ACTIONS(2747),
    [anon_sym_requires] = ACTIONS(2747),
    [sym_this] = ACTIONS(2747),
  },
  [459] = {
    [ts_builtin_sym_end] = ACTIONS(2645),
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [460] = {
    [sym_identifier] = ACTIONS(2507),
    [aux_sym_preproc_include_token1] = ACTIONS(2507),
    [aux_sym_preproc_def_token1] = ACTIONS(2507),
    [aux_sym_preproc_if_token1] = ACTIONS(2507),
    [aux_sym_preproc_if_token2] = ACTIONS(2507),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2507),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2507),
    [sym_preproc_directive] = ACTIONS(2507),
    [anon_sym_LPAREN2] = ACTIONS(2512),
    [anon_sym_BANG] = ACTIONS(2512),
    [anon_sym_TILDE] = ACTIONS(2512),
    [anon_sym_DASH] = ACTIONS(2507),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_STAR] = ACTIONS(2512),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2507),
    [anon_sym_SEMI] = ACTIONS(2512),
    [anon_sym___extension__] = ACTIONS(2507),
    [anon_sym_typedef] = ACTIONS(2507),
    [anon_sym_extern] = ACTIONS(2507),
    [anon_sym___attribute__] = ACTIONS(2507),
    [anon_sym_COLON_COLON] = ACTIONS(2512),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2512),
    [anon_sym___declspec] = ACTIONS(2507),
    [anon_sym___based] = ACTIONS(2507),
    [anon_sym___cdecl] = ACTIONS(2507),
    [anon_sym___clrcall] = ACTIONS(2507),
    [anon_sym___stdcall] = ACTIONS(2507),
    [anon_sym___fastcall] = ACTIONS(2507),
    [anon_sym___thiscall] = ACTIONS(2507),
    [anon_sym___vectorcall] = ACTIONS(2507),
    [anon_sym_LBRACE] = ACTIONS(2512),
    [anon_sym_signed] = ACTIONS(2507),
    [anon_sym_unsigned] = ACTIONS(2507),
    [anon_sym_long] = ACTIONS(2507),
    [anon_sym_short] = ACTIONS(2507),
    [anon_sym_LBRACK] = ACTIONS(2507),
    [anon_sym_static] = ACTIONS(2507),
    [anon_sym_register] = ACTIONS(2507),
    [anon_sym_inline] = ACTIONS(2507),
    [anon_sym___inline] = ACTIONS(2507),
    [anon_sym___inline__] = ACTIONS(2507),
    [anon_sym___forceinline] = ACTIONS(2507),
    [anon_sym_thread_local] = ACTIONS(2507),
    [anon_sym___thread] = ACTIONS(2507),
    [anon_sym_const] = ACTIONS(2507),
    [anon_sym_constexpr] = ACTIONS(2507),
    [anon_sym_volatile] = ACTIONS(2507),
    [anon_sym_restrict] = ACTIONS(2507),
    [anon_sym___restrict__] = ACTIONS(2507),
    [anon_sym__Atomic] = ACTIONS(2507),
    [anon_sym__Noreturn] = ACTIONS(2507),
    [anon_sym_noreturn] = ACTIONS(2507),
    [anon_sym_mutable] = ACTIONS(2507),
    [anon_sym_constinit] = ACTIONS(2507),
    [anon_sym_consteval] = ACTIONS(2507),
    [anon_sym_PROGMEM] = ACTIONS(2507),
    [aux_sym_primitive_type_token1] = ACTIONS(2507),
    [anon_sym_byte] = ACTIONS(2507),
    [anon_sym_word] = ACTIONS(2507),
    [anon_sym_enum] = ACTIONS(2507),
    [anon_sym_class] = ACTIONS(2507),
    [anon_sym_struct] = ACTIONS(2507),
    [anon_sym_union] = ACTIONS(2507),
    [anon_sym_if] = ACTIONS(2507),
    [anon_sym_else] = ACTIONS(2507),
    [anon_sym_switch] = ACTIONS(2507),
    [anon_sym_case] = ACTIONS(2507),
    [anon_sym_default] = ACTIONS(2507),
    [anon_sym_while] = ACTIONS(2507),
    [anon_sym_do] = ACTIONS(2507),
    [anon_sym_for] = ACTIONS(2507),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_break] = ACTIONS(2507),
    [anon_sym_continue] = ACTIONS(2507),
    [anon_sym_goto] = ACTIONS(2507),
    [anon_sym___try] = ACTIONS(2507),
    [anon_sym___leave] = ACTIONS(2507),
    [anon_sym_not] = ACTIONS(2507),
    [anon_sym_compl] = ACTIONS(2507),
    [anon_sym_DASH_DASH] = ACTIONS(2512),
    [anon_sym_PLUS_PLUS] = ACTIONS(2512),
    [anon_sym_sizeof] = ACTIONS(2507),
    [anon_sym___alignof__] = ACTIONS(2507),
    [anon_sym___alignof] = ACTIONS(2507),
    [anon_sym__alignof] = ACTIONS(2507),
    [anon_sym_alignof] = ACTIONS(2507),
    [anon_sym__Alignof] = ACTIONS(2507),
    [anon_sym_offsetof] = ACTIONS(2507),
    [anon_sym__Generic] = ACTIONS(2507),
    [anon_sym_asm] = ACTIONS(2507),
    [anon_sym___asm__] = ACTIONS(2507),
    [aux_sym_number_literal_token1] = ACTIONS(2512),
    [aux_sym_number_literal_token2] = ACTIONS(2507),
    [anon_sym_L_SQUOTE] = ACTIONS(2512),
    [anon_sym_u_SQUOTE] = ACTIONS(2512),
    [anon_sym_U_SQUOTE] = ACTIONS(2512),
    [anon_sym_u8_SQUOTE] = ACTIONS(2512),
    [anon_sym_SQUOTE] = ACTIONS(2512),
    [anon_sym_L_DQUOTE] = ACTIONS(2512),
    [anon_sym_u_DQUOTE] = ACTIONS(2512),
    [anon_sym_U_DQUOTE] = ACTIONS(2512),
    [anon_sym_u8_DQUOTE] = ACTIONS(2512),
    [anon_sym_DQUOTE] = ACTIONS(2512),
    [sym_true] = ACTIONS(2507),
    [sym_false] = ACTIONS(2507),
    [anon_sym_NULL] = ACTIONS(2507),
    [anon_sym_nullptr] = ACTIONS(2507),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2507),
    [anon_sym_decltype] = ACTIONS(2507),
    [anon_sym_virtual] = ACTIONS(2507),
    [anon_sym_alignas] = ACTIONS(2507),
    [anon_sym_explicit] = ACTIONS(2507),
    [anon_sym_typename] = ACTIONS(2507),
    [anon_sym_template] = ACTIONS(2507),
    [anon_sym_operator] = ACTIONS(2507),
    [anon_sym_try] = ACTIONS(2507),
    [anon_sym_delete] = ACTIONS(2507),
    [anon_sym_throw] = ACTIONS(2507),
    [anon_sym_namespace] = ACTIONS(2507),
    [anon_sym_using] = ACTIONS(2507),
    [anon_sym_static_assert] = ACTIONS(2507),
    [anon_sym_concept] = ACTIONS(2507),
    [anon_sym_co_return] = ACTIONS(2507),
    [anon_sym_co_yield] = ACTIONS(2507),
    [anon_sym_R_DQUOTE] = ACTIONS(2512),
    [anon_sym_LR_DQUOTE] = ACTIONS(2512),
    [anon_sym_uR_DQUOTE] = ACTIONS(2512),
    [anon_sym_UR_DQUOTE] = ACTIONS(2512),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2512),
    [anon_sym_co_await] = ACTIONS(2507),
    [anon_sym_new] = ACTIONS(2507),
    [anon_sym_requires] = ACTIONS(2507),
    [sym_this] = ACTIONS(2507),
  },
  [461] = {
    [sym_identifier] = ACTIONS(2557),
    [aux_sym_preproc_include_token1] = ACTIONS(2557),
    [aux_sym_preproc_def_token1] = ACTIONS(2557),
    [aux_sym_preproc_if_token1] = ACTIONS(2557),
    [aux_sym_preproc_if_token2] = ACTIONS(2557),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2557),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2557),
    [sym_preproc_directive] = ACTIONS(2557),
    [anon_sym_LPAREN2] = ACTIONS(2562),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2557),
    [anon_sym_PLUS] = ACTIONS(2557),
    [anon_sym_STAR] = ACTIONS(2562),
    [anon_sym_AMP_AMP] = ACTIONS(2562),
    [anon_sym_AMP] = ACTIONS(2557),
    [anon_sym_SEMI] = ACTIONS(2562),
    [anon_sym___extension__] = ACTIONS(2557),
    [anon_sym_typedef] = ACTIONS(2557),
    [anon_sym_extern] = ACTIONS(2557),
    [anon_sym___attribute__] = ACTIONS(2557),
    [anon_sym_COLON_COLON] = ACTIONS(2562),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2562),
    [anon_sym___declspec] = ACTIONS(2557),
    [anon_sym___based] = ACTIONS(2557),
    [anon_sym___cdecl] = ACTIONS(2557),
    [anon_sym___clrcall] = ACTIONS(2557),
    [anon_sym___stdcall] = ACTIONS(2557),
    [anon_sym___fastcall] = ACTIONS(2557),
    [anon_sym___thiscall] = ACTIONS(2557),
    [anon_sym___vectorcall] = ACTIONS(2557),
    [anon_sym_LBRACE] = ACTIONS(2562),
    [anon_sym_signed] = ACTIONS(2557),
    [anon_sym_unsigned] = ACTIONS(2557),
    [anon_sym_long] = ACTIONS(2557),
    [anon_sym_short] = ACTIONS(2557),
    [anon_sym_LBRACK] = ACTIONS(2557),
    [anon_sym_static] = ACTIONS(2557),
    [anon_sym_register] = ACTIONS(2557),
    [anon_sym_inline] = ACTIONS(2557),
    [anon_sym___inline] = ACTIONS(2557),
    [anon_sym___inline__] = ACTIONS(2557),
    [anon_sym___forceinline] = ACTIONS(2557),
    [anon_sym_thread_local] = ACTIONS(2557),
    [anon_sym___thread] = ACTIONS(2557),
    [anon_sym_const] = ACTIONS(2557),
    [anon_sym_constexpr] = ACTIONS(2557),
    [anon_sym_volatile] = ACTIONS(2557),
    [anon_sym_restrict] = ACTIONS(2557),
    [anon_sym___restrict__] = ACTIONS(2557),
    [anon_sym__Atomic] = ACTIONS(2557),
    [anon_sym__Noreturn] = ACTIONS(2557),
    [anon_sym_noreturn] = ACTIONS(2557),
    [anon_sym_mutable] = ACTIONS(2557),
    [anon_sym_constinit] = ACTIONS(2557),
    [anon_sym_consteval] = ACTIONS(2557),
    [anon_sym_PROGMEM] = ACTIONS(2557),
    [aux_sym_primitive_type_token1] = ACTIONS(2557),
    [anon_sym_byte] = ACTIONS(2557),
    [anon_sym_word] = ACTIONS(2557),
    [anon_sym_enum] = ACTIONS(2557),
    [anon_sym_class] = ACTIONS(2557),
    [anon_sym_struct] = ACTIONS(2557),
    [anon_sym_union] = ACTIONS(2557),
    [anon_sym_if] = ACTIONS(2557),
    [anon_sym_else] = ACTIONS(2557),
    [anon_sym_switch] = ACTIONS(2557),
    [anon_sym_case] = ACTIONS(2557),
    [anon_sym_default] = ACTIONS(2557),
    [anon_sym_while] = ACTIONS(2557),
    [anon_sym_do] = ACTIONS(2557),
    [anon_sym_for] = ACTIONS(2557),
    [anon_sym_return] = ACTIONS(2557),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_continue] = ACTIONS(2557),
    [anon_sym_goto] = ACTIONS(2557),
    [anon_sym___try] = ACTIONS(2557),
    [anon_sym___leave] = ACTIONS(2557),
    [anon_sym_not] = ACTIONS(2557),
    [anon_sym_compl] = ACTIONS(2557),
    [anon_sym_DASH_DASH] = ACTIONS(2562),
    [anon_sym_PLUS_PLUS] = ACTIONS(2562),
    [anon_sym_sizeof] = ACTIONS(2557),
    [anon_sym___alignof__] = ACTIONS(2557),
    [anon_sym___alignof] = ACTIONS(2557),
    [anon_sym__alignof] = ACTIONS(2557),
    [anon_sym_alignof] = ACTIONS(2557),
    [anon_sym__Alignof] = ACTIONS(2557),
    [anon_sym_offsetof] = ACTIONS(2557),
    [anon_sym__Generic] = ACTIONS(2557),
    [anon_sym_asm] = ACTIONS(2557),
    [anon_sym___asm__] = ACTIONS(2557),
    [aux_sym_number_literal_token1] = ACTIONS(2562),
    [aux_sym_number_literal_token2] = ACTIONS(2557),
    [anon_sym_L_SQUOTE] = ACTIONS(2562),
    [anon_sym_u_SQUOTE] = ACTIONS(2562),
    [anon_sym_U_SQUOTE] = ACTIONS(2562),
    [anon_sym_u8_SQUOTE] = ACTIONS(2562),
    [anon_sym_SQUOTE] = ACTIONS(2562),
    [anon_sym_L_DQUOTE] = ACTIONS(2562),
    [anon_sym_u_DQUOTE] = ACTIONS(2562),
    [anon_sym_U_DQUOTE] = ACTIONS(2562),
    [anon_sym_u8_DQUOTE] = ACTIONS(2562),
    [anon_sym_DQUOTE] = ACTIONS(2562),
    [sym_true] = ACTIONS(2557),
    [sym_false] = ACTIONS(2557),
    [anon_sym_NULL] = ACTIONS(2557),
    [anon_sym_nullptr] = ACTIONS(2557),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2557),
    [anon_sym_decltype] = ACTIONS(2557),
    [anon_sym_virtual] = ACTIONS(2557),
    [anon_sym_alignas] = ACTIONS(2557),
    [anon_sym_explicit] = ACTIONS(2557),
    [anon_sym_typename] = ACTIONS(2557),
    [anon_sym_template] = ACTIONS(2557),
    [anon_sym_operator] = ACTIONS(2557),
    [anon_sym_try] = ACTIONS(2557),
    [anon_sym_delete] = ACTIONS(2557),
    [anon_sym_throw] = ACTIONS(2557),
    [anon_sym_namespace] = ACTIONS(2557),
    [anon_sym_using] = ACTIONS(2557),
    [anon_sym_static_assert] = ACTIONS(2557),
    [anon_sym_concept] = ACTIONS(2557),
    [anon_sym_co_return] = ACTIONS(2557),
    [anon_sym_co_yield] = ACTIONS(2557),
    [anon_sym_R_DQUOTE] = ACTIONS(2562),
    [anon_sym_LR_DQUOTE] = ACTIONS(2562),
    [anon_sym_uR_DQUOTE] = ACTIONS(2562),
    [anon_sym_UR_DQUOTE] = ACTIONS(2562),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2562),
    [anon_sym_co_await] = ACTIONS(2557),
    [anon_sym_new] = ACTIONS(2557),
    [anon_sym_requires] = ACTIONS(2557),
    [sym_this] = ACTIONS(2557),
  },
  [462] = {
    [ts_builtin_sym_end] = ACTIONS(2677),
    [sym_identifier] = ACTIONS(2675),
    [aux_sym_preproc_include_token1] = ACTIONS(2675),
    [aux_sym_preproc_def_token1] = ACTIONS(2675),
    [aux_sym_preproc_if_token1] = ACTIONS(2675),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2675),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2675),
    [sym_preproc_directive] = ACTIONS(2675),
    [anon_sym_LPAREN2] = ACTIONS(2677),
    [anon_sym_BANG] = ACTIONS(2677),
    [anon_sym_TILDE] = ACTIONS(2677),
    [anon_sym_DASH] = ACTIONS(2675),
    [anon_sym_PLUS] = ACTIONS(2675),
    [anon_sym_STAR] = ACTIONS(2677),
    [anon_sym_AMP_AMP] = ACTIONS(2677),
    [anon_sym_AMP] = ACTIONS(2675),
    [anon_sym_SEMI] = ACTIONS(2677),
    [anon_sym___extension__] = ACTIONS(2675),
    [anon_sym_typedef] = ACTIONS(2675),
    [anon_sym_extern] = ACTIONS(2675),
    [anon_sym___attribute__] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(2677),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2677),
    [anon_sym___declspec] = ACTIONS(2675),
    [anon_sym___based] = ACTIONS(2675),
    [anon_sym___cdecl] = ACTIONS(2675),
    [anon_sym___clrcall] = ACTIONS(2675),
    [anon_sym___stdcall] = ACTIONS(2675),
    [anon_sym___fastcall] = ACTIONS(2675),
    [anon_sym___thiscall] = ACTIONS(2675),
    [anon_sym___vectorcall] = ACTIONS(2675),
    [anon_sym_LBRACE] = ACTIONS(2677),
    [anon_sym_signed] = ACTIONS(2675),
    [anon_sym_unsigned] = ACTIONS(2675),
    [anon_sym_long] = ACTIONS(2675),
    [anon_sym_short] = ACTIONS(2675),
    [anon_sym_LBRACK] = ACTIONS(2675),
    [anon_sym_static] = ACTIONS(2675),
    [anon_sym_register] = ACTIONS(2675),
    [anon_sym_inline] = ACTIONS(2675),
    [anon_sym___inline] = ACTIONS(2675),
    [anon_sym___inline__] = ACTIONS(2675),
    [anon_sym___forceinline] = ACTIONS(2675),
    [anon_sym_thread_local] = ACTIONS(2675),
    [anon_sym___thread] = ACTIONS(2675),
    [anon_sym_const] = ACTIONS(2675),
    [anon_sym_constexpr] = ACTIONS(2675),
    [anon_sym_volatile] = ACTIONS(2675),
    [anon_sym_restrict] = ACTIONS(2675),
    [anon_sym___restrict__] = ACTIONS(2675),
    [anon_sym__Atomic] = ACTIONS(2675),
    [anon_sym__Noreturn] = ACTIONS(2675),
    [anon_sym_noreturn] = ACTIONS(2675),
    [anon_sym_mutable] = ACTIONS(2675),
    [anon_sym_constinit] = ACTIONS(2675),
    [anon_sym_consteval] = ACTIONS(2675),
    [anon_sym_PROGMEM] = ACTIONS(2675),
    [aux_sym_primitive_type_token1] = ACTIONS(2675),
    [anon_sym_byte] = ACTIONS(2675),
    [anon_sym_word] = ACTIONS(2675),
    [anon_sym_enum] = ACTIONS(2675),
    [anon_sym_class] = ACTIONS(2675),
    [anon_sym_struct] = ACTIONS(2675),
    [anon_sym_union] = ACTIONS(2675),
    [anon_sym_if] = ACTIONS(2675),
    [anon_sym_else] = ACTIONS(2675),
    [anon_sym_switch] = ACTIONS(2675),
    [anon_sym_case] = ACTIONS(2675),
    [anon_sym_default] = ACTIONS(2675),
    [anon_sym_while] = ACTIONS(2675),
    [anon_sym_do] = ACTIONS(2675),
    [anon_sym_for] = ACTIONS(2675),
    [anon_sym_return] = ACTIONS(2675),
    [anon_sym_break] = ACTIONS(2675),
    [anon_sym_continue] = ACTIONS(2675),
    [anon_sym_goto] = ACTIONS(2675),
    [anon_sym___try] = ACTIONS(2675),
    [anon_sym___leave] = ACTIONS(2675),
    [anon_sym_not] = ACTIONS(2675),
    [anon_sym_compl] = ACTIONS(2675),
    [anon_sym_DASH_DASH] = ACTIONS(2677),
    [anon_sym_PLUS_PLUS] = ACTIONS(2677),
    [anon_sym_sizeof] = ACTIONS(2675),
    [anon_sym___alignof__] = ACTIONS(2675),
    [anon_sym___alignof] = ACTIONS(2675),
    [anon_sym__alignof] = ACTIONS(2675),
    [anon_sym_alignof] = ACTIONS(2675),
    [anon_sym__Alignof] = ACTIONS(2675),
    [anon_sym_offsetof] = ACTIONS(2675),
    [anon_sym__Generic] = ACTIONS(2675),
    [anon_sym_asm] = ACTIONS(2675),
    [anon_sym___asm__] = ACTIONS(2675),
    [aux_sym_number_literal_token1] = ACTIONS(2677),
    [aux_sym_number_literal_token2] = ACTIONS(2675),
    [anon_sym_L_SQUOTE] = ACTIONS(2677),
    [anon_sym_u_SQUOTE] = ACTIONS(2677),
    [anon_sym_U_SQUOTE] = ACTIONS(2677),
    [anon_sym_u8_SQUOTE] = ACTIONS(2677),
    [anon_sym_SQUOTE] = ACTIONS(2677),
    [anon_sym_L_DQUOTE] = ACTIONS(2677),
    [anon_sym_u_DQUOTE] = ACTIONS(2677),
    [anon_sym_U_DQUOTE] = ACTIONS(2677),
    [anon_sym_u8_DQUOTE] = ACTIONS(2677),
    [anon_sym_DQUOTE] = ACTIONS(2677),
    [sym_true] = ACTIONS(2675),
    [sym_false] = ACTIONS(2675),
    [anon_sym_NULL] = ACTIONS(2675),
    [anon_sym_nullptr] = ACTIONS(2675),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2675),
    [anon_sym_decltype] = ACTIONS(2675),
    [anon_sym_virtual] = ACTIONS(2675),
    [anon_sym_alignas] = ACTIONS(2675),
    [anon_sym_explicit] = ACTIONS(2675),
    [anon_sym_typename] = ACTIONS(2675),
    [anon_sym_template] = ACTIONS(2675),
    [anon_sym_operator] = ACTIONS(2675),
    [anon_sym_try] = ACTIONS(2675),
    [anon_sym_delete] = ACTIONS(2675),
    [anon_sym_throw] = ACTIONS(2675),
    [anon_sym_namespace] = ACTIONS(2675),
    [anon_sym_using] = ACTIONS(2675),
    [anon_sym_static_assert] = ACTIONS(2675),
    [anon_sym_concept] = ACTIONS(2675),
    [anon_sym_co_return] = ACTIONS(2675),
    [anon_sym_co_yield] = ACTIONS(2675),
    [anon_sym_R_DQUOTE] = ACTIONS(2677),
    [anon_sym_LR_DQUOTE] = ACTIONS(2677),
    [anon_sym_uR_DQUOTE] = ACTIONS(2677),
    [anon_sym_UR_DQUOTE] = ACTIONS(2677),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2677),
    [anon_sym_co_await] = ACTIONS(2675),
    [anon_sym_new] = ACTIONS(2675),
    [anon_sym_requires] = ACTIONS(2675),
    [sym_this] = ACTIONS(2675),
  },
  [463] = {
    [ts_builtin_sym_end] = ACTIONS(2645),
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [464] = {
    [ts_builtin_sym_end] = ACTIONS(2645),
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [465] = {
    [sym_identifier] = ACTIONS(2731),
    [aux_sym_preproc_include_token1] = ACTIONS(2731),
    [aux_sym_preproc_def_token1] = ACTIONS(2731),
    [aux_sym_preproc_if_token1] = ACTIONS(2731),
    [aux_sym_preproc_if_token2] = ACTIONS(2731),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2731),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2731),
    [sym_preproc_directive] = ACTIONS(2731),
    [anon_sym_LPAREN2] = ACTIONS(2733),
    [anon_sym_BANG] = ACTIONS(2733),
    [anon_sym_TILDE] = ACTIONS(2733),
    [anon_sym_DASH] = ACTIONS(2731),
    [anon_sym_PLUS] = ACTIONS(2731),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_AMP_AMP] = ACTIONS(2733),
    [anon_sym_AMP] = ACTIONS(2731),
    [anon_sym_SEMI] = ACTIONS(2733),
    [anon_sym___extension__] = ACTIONS(2731),
    [anon_sym_typedef] = ACTIONS(2731),
    [anon_sym_extern] = ACTIONS(2731),
    [anon_sym___attribute__] = ACTIONS(2731),
    [anon_sym_COLON_COLON] = ACTIONS(2733),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2733),
    [anon_sym___declspec] = ACTIONS(2731),
    [anon_sym___based] = ACTIONS(2731),
    [anon_sym___cdecl] = ACTIONS(2731),
    [anon_sym___clrcall] = ACTIONS(2731),
    [anon_sym___stdcall] = ACTIONS(2731),
    [anon_sym___fastcall] = ACTIONS(2731),
    [anon_sym___thiscall] = ACTIONS(2731),
    [anon_sym___vectorcall] = ACTIONS(2731),
    [anon_sym_LBRACE] = ACTIONS(2733),
    [anon_sym_signed] = ACTIONS(2731),
    [anon_sym_unsigned] = ACTIONS(2731),
    [anon_sym_long] = ACTIONS(2731),
    [anon_sym_short] = ACTIONS(2731),
    [anon_sym_LBRACK] = ACTIONS(2731),
    [anon_sym_static] = ACTIONS(2731),
    [anon_sym_register] = ACTIONS(2731),
    [anon_sym_inline] = ACTIONS(2731),
    [anon_sym___inline] = ACTIONS(2731),
    [anon_sym___inline__] = ACTIONS(2731),
    [anon_sym___forceinline] = ACTIONS(2731),
    [anon_sym_thread_local] = ACTIONS(2731),
    [anon_sym___thread] = ACTIONS(2731),
    [anon_sym_const] = ACTIONS(2731),
    [anon_sym_constexpr] = ACTIONS(2731),
    [anon_sym_volatile] = ACTIONS(2731),
    [anon_sym_restrict] = ACTIONS(2731),
    [anon_sym___restrict__] = ACTIONS(2731),
    [anon_sym__Atomic] = ACTIONS(2731),
    [anon_sym__Noreturn] = ACTIONS(2731),
    [anon_sym_noreturn] = ACTIONS(2731),
    [anon_sym_mutable] = ACTIONS(2731),
    [anon_sym_constinit] = ACTIONS(2731),
    [anon_sym_consteval] = ACTIONS(2731),
    [anon_sym_PROGMEM] = ACTIONS(2731),
    [aux_sym_primitive_type_token1] = ACTIONS(2731),
    [anon_sym_byte] = ACTIONS(2731),
    [anon_sym_word] = ACTIONS(2731),
    [anon_sym_enum] = ACTIONS(2731),
    [anon_sym_class] = ACTIONS(2731),
    [anon_sym_struct] = ACTIONS(2731),
    [anon_sym_union] = ACTIONS(2731),
    [anon_sym_if] = ACTIONS(2731),
    [anon_sym_else] = ACTIONS(2731),
    [anon_sym_switch] = ACTIONS(2731),
    [anon_sym_case] = ACTIONS(2731),
    [anon_sym_default] = ACTIONS(2731),
    [anon_sym_while] = ACTIONS(2731),
    [anon_sym_do] = ACTIONS(2731),
    [anon_sym_for] = ACTIONS(2731),
    [anon_sym_return] = ACTIONS(2731),
    [anon_sym_break] = ACTIONS(2731),
    [anon_sym_continue] = ACTIONS(2731),
    [anon_sym_goto] = ACTIONS(2731),
    [anon_sym___try] = ACTIONS(2731),
    [anon_sym___leave] = ACTIONS(2731),
    [anon_sym_not] = ACTIONS(2731),
    [anon_sym_compl] = ACTIONS(2731),
    [anon_sym_DASH_DASH] = ACTIONS(2733),
    [anon_sym_PLUS_PLUS] = ACTIONS(2733),
    [anon_sym_sizeof] = ACTIONS(2731),
    [anon_sym___alignof__] = ACTIONS(2731),
    [anon_sym___alignof] = ACTIONS(2731),
    [anon_sym__alignof] = ACTIONS(2731),
    [anon_sym_alignof] = ACTIONS(2731),
    [anon_sym__Alignof] = ACTIONS(2731),
    [anon_sym_offsetof] = ACTIONS(2731),
    [anon_sym__Generic] = ACTIONS(2731),
    [anon_sym_asm] = ACTIONS(2731),
    [anon_sym___asm__] = ACTIONS(2731),
    [aux_sym_number_literal_token1] = ACTIONS(2733),
    [aux_sym_number_literal_token2] = ACTIONS(2731),
    [anon_sym_L_SQUOTE] = ACTIONS(2733),
    [anon_sym_u_SQUOTE] = ACTIONS(2733),
    [anon_sym_U_SQUOTE] = ACTIONS(2733),
    [anon_sym_u8_SQUOTE] = ACTIONS(2733),
    [anon_sym_SQUOTE] = ACTIONS(2733),
    [anon_sym_L_DQUOTE] = ACTIONS(2733),
    [anon_sym_u_DQUOTE] = ACTIONS(2733),
    [anon_sym_U_DQUOTE] = ACTIONS(2733),
    [anon_sym_u8_DQUOTE] = ACTIONS(2733),
    [anon_sym_DQUOTE] = ACTIONS(2733),
    [sym_true] = ACTIONS(2731),
    [sym_false] = ACTIONS(2731),
    [anon_sym_NULL] = ACTIONS(2731),
    [anon_sym_nullptr] = ACTIONS(2731),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2731),
    [anon_sym_decltype] = ACTIONS(2731),
    [anon_sym_virtual] = ACTIONS(2731),
    [anon_sym_alignas] = ACTIONS(2731),
    [anon_sym_explicit] = ACTIONS(2731),
    [anon_sym_typename] = ACTIONS(2731),
    [anon_sym_template] = ACTIONS(2731),
    [anon_sym_operator] = ACTIONS(2731),
    [anon_sym_try] = ACTIONS(2731),
    [anon_sym_delete] = ACTIONS(2731),
    [anon_sym_throw] = ACTIONS(2731),
    [anon_sym_namespace] = ACTIONS(2731),
    [anon_sym_using] = ACTIONS(2731),
    [anon_sym_static_assert] = ACTIONS(2731),
    [anon_sym_concept] = ACTIONS(2731),
    [anon_sym_co_return] = ACTIONS(2731),
    [anon_sym_co_yield] = ACTIONS(2731),
    [anon_sym_R_DQUOTE] = ACTIONS(2733),
    [anon_sym_LR_DQUOTE] = ACTIONS(2733),
    [anon_sym_uR_DQUOTE] = ACTIONS(2733),
    [anon_sym_UR_DQUOTE] = ACTIONS(2733),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2733),
    [anon_sym_co_await] = ACTIONS(2731),
    [anon_sym_new] = ACTIONS(2731),
    [anon_sym_requires] = ACTIONS(2731),
    [sym_this] = ACTIONS(2731),
  },
  [466] = {
    [sym_identifier] = ACTIONS(2653),
    [aux_sym_preproc_include_token1] = ACTIONS(2653),
    [aux_sym_preproc_def_token1] = ACTIONS(2653),
    [aux_sym_preproc_if_token1] = ACTIONS(2653),
    [aux_sym_preproc_if_token2] = ACTIONS(2653),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2653),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2653),
    [sym_preproc_directive] = ACTIONS(2653),
    [anon_sym_LPAREN2] = ACTIONS(2655),
    [anon_sym_BANG] = ACTIONS(2655),
    [anon_sym_TILDE] = ACTIONS(2655),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_AMP_AMP] = ACTIONS(2655),
    [anon_sym_AMP] = ACTIONS(2653),
    [anon_sym_SEMI] = ACTIONS(2655),
    [anon_sym___extension__] = ACTIONS(2653),
    [anon_sym_typedef] = ACTIONS(2653),
    [anon_sym_extern] = ACTIONS(2653),
    [anon_sym___attribute__] = ACTIONS(2653),
    [anon_sym_COLON_COLON] = ACTIONS(2655),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2655),
    [anon_sym___declspec] = ACTIONS(2653),
    [anon_sym___based] = ACTIONS(2653),
    [anon_sym___cdecl] = ACTIONS(2653),
    [anon_sym___clrcall] = ACTIONS(2653),
    [anon_sym___stdcall] = ACTIONS(2653),
    [anon_sym___fastcall] = ACTIONS(2653),
    [anon_sym___thiscall] = ACTIONS(2653),
    [anon_sym___vectorcall] = ACTIONS(2653),
    [anon_sym_LBRACE] = ACTIONS(2655),
    [anon_sym_signed] = ACTIONS(2653),
    [anon_sym_unsigned] = ACTIONS(2653),
    [anon_sym_long] = ACTIONS(2653),
    [anon_sym_short] = ACTIONS(2653),
    [anon_sym_LBRACK] = ACTIONS(2653),
    [anon_sym_static] = ACTIONS(2653),
    [anon_sym_register] = ACTIONS(2653),
    [anon_sym_inline] = ACTIONS(2653),
    [anon_sym___inline] = ACTIONS(2653),
    [anon_sym___inline__] = ACTIONS(2653),
    [anon_sym___forceinline] = ACTIONS(2653),
    [anon_sym_thread_local] = ACTIONS(2653),
    [anon_sym___thread] = ACTIONS(2653),
    [anon_sym_const] = ACTIONS(2653),
    [anon_sym_constexpr] = ACTIONS(2653),
    [anon_sym_volatile] = ACTIONS(2653),
    [anon_sym_restrict] = ACTIONS(2653),
    [anon_sym___restrict__] = ACTIONS(2653),
    [anon_sym__Atomic] = ACTIONS(2653),
    [anon_sym__Noreturn] = ACTIONS(2653),
    [anon_sym_noreturn] = ACTIONS(2653),
    [anon_sym_mutable] = ACTIONS(2653),
    [anon_sym_constinit] = ACTIONS(2653),
    [anon_sym_consteval] = ACTIONS(2653),
    [anon_sym_PROGMEM] = ACTIONS(2653),
    [aux_sym_primitive_type_token1] = ACTIONS(2653),
    [anon_sym_byte] = ACTIONS(2653),
    [anon_sym_word] = ACTIONS(2653),
    [anon_sym_enum] = ACTIONS(2653),
    [anon_sym_class] = ACTIONS(2653),
    [anon_sym_struct] = ACTIONS(2653),
    [anon_sym_union] = ACTIONS(2653),
    [anon_sym_if] = ACTIONS(2653),
    [anon_sym_else] = ACTIONS(2653),
    [anon_sym_switch] = ACTIONS(2653),
    [anon_sym_case] = ACTIONS(2653),
    [anon_sym_default] = ACTIONS(2653),
    [anon_sym_while] = ACTIONS(2653),
    [anon_sym_do] = ACTIONS(2653),
    [anon_sym_for] = ACTIONS(2653),
    [anon_sym_return] = ACTIONS(2653),
    [anon_sym_break] = ACTIONS(2653),
    [anon_sym_continue] = ACTIONS(2653),
    [anon_sym_goto] = ACTIONS(2653),
    [anon_sym___try] = ACTIONS(2653),
    [anon_sym___leave] = ACTIONS(2653),
    [anon_sym_not] = ACTIONS(2653),
    [anon_sym_compl] = ACTIONS(2653),
    [anon_sym_DASH_DASH] = ACTIONS(2655),
    [anon_sym_PLUS_PLUS] = ACTIONS(2655),
    [anon_sym_sizeof] = ACTIONS(2653),
    [anon_sym___alignof__] = ACTIONS(2653),
    [anon_sym___alignof] = ACTIONS(2653),
    [anon_sym__alignof] = ACTIONS(2653),
    [anon_sym_alignof] = ACTIONS(2653),
    [anon_sym__Alignof] = ACTIONS(2653),
    [anon_sym_offsetof] = ACTIONS(2653),
    [anon_sym__Generic] = ACTIONS(2653),
    [anon_sym_asm] = ACTIONS(2653),
    [anon_sym___asm__] = ACTIONS(2653),
    [aux_sym_number_literal_token1] = ACTIONS(2655),
    [aux_sym_number_literal_token2] = ACTIONS(2653),
    [anon_sym_L_SQUOTE] = ACTIONS(2655),
    [anon_sym_u_SQUOTE] = ACTIONS(2655),
    [anon_sym_U_SQUOTE] = ACTIONS(2655),
    [anon_sym_u8_SQUOTE] = ACTIONS(2655),
    [anon_sym_SQUOTE] = ACTIONS(2655),
    [anon_sym_L_DQUOTE] = ACTIONS(2655),
    [anon_sym_u_DQUOTE] = ACTIONS(2655),
    [anon_sym_U_DQUOTE] = ACTIONS(2655),
    [anon_sym_u8_DQUOTE] = ACTIONS(2655),
    [anon_sym_DQUOTE] = ACTIONS(2655),
    [sym_true] = ACTIONS(2653),
    [sym_false] = ACTIONS(2653),
    [anon_sym_NULL] = ACTIONS(2653),
    [anon_sym_nullptr] = ACTIONS(2653),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2653),
    [anon_sym_decltype] = ACTIONS(2653),
    [anon_sym_virtual] = ACTIONS(2653),
    [anon_sym_alignas] = ACTIONS(2653),
    [anon_sym_explicit] = ACTIONS(2653),
    [anon_sym_typename] = ACTIONS(2653),
    [anon_sym_template] = ACTIONS(2653),
    [anon_sym_operator] = ACTIONS(2653),
    [anon_sym_try] = ACTIONS(2653),
    [anon_sym_delete] = ACTIONS(2653),
    [anon_sym_throw] = ACTIONS(2653),
    [anon_sym_namespace] = ACTIONS(2653),
    [anon_sym_using] = ACTIONS(2653),
    [anon_sym_static_assert] = ACTIONS(2653),
    [anon_sym_concept] = ACTIONS(2653),
    [anon_sym_co_return] = ACTIONS(2653),
    [anon_sym_co_yield] = ACTIONS(2653),
    [anon_sym_R_DQUOTE] = ACTIONS(2655),
    [anon_sym_LR_DQUOTE] = ACTIONS(2655),
    [anon_sym_uR_DQUOTE] = ACTIONS(2655),
    [anon_sym_UR_DQUOTE] = ACTIONS(2655),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2655),
    [anon_sym_co_await] = ACTIONS(2653),
    [anon_sym_new] = ACTIONS(2653),
    [anon_sym_requires] = ACTIONS(2653),
    [sym_this] = ACTIONS(2653),
  },
  [467] = {
    [sym_identifier] = ACTIONS(2657),
    [aux_sym_preproc_include_token1] = ACTIONS(2657),
    [aux_sym_preproc_def_token1] = ACTIONS(2657),
    [aux_sym_preproc_if_token1] = ACTIONS(2657),
    [aux_sym_preproc_if_token2] = ACTIONS(2657),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2657),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2657),
    [sym_preproc_directive] = ACTIONS(2657),
    [anon_sym_LPAREN2] = ACTIONS(2659),
    [anon_sym_BANG] = ACTIONS(2659),
    [anon_sym_TILDE] = ACTIONS(2659),
    [anon_sym_DASH] = ACTIONS(2657),
    [anon_sym_PLUS] = ACTIONS(2657),
    [anon_sym_STAR] = ACTIONS(2659),
    [anon_sym_AMP_AMP] = ACTIONS(2659),
    [anon_sym_AMP] = ACTIONS(2657),
    [anon_sym_SEMI] = ACTIONS(2659),
    [anon_sym___extension__] = ACTIONS(2657),
    [anon_sym_typedef] = ACTIONS(2657),
    [anon_sym_extern] = ACTIONS(2657),
    [anon_sym___attribute__] = ACTIONS(2657),
    [anon_sym_COLON_COLON] = ACTIONS(2659),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2659),
    [anon_sym___declspec] = ACTIONS(2657),
    [anon_sym___based] = ACTIONS(2657),
    [anon_sym___cdecl] = ACTIONS(2657),
    [anon_sym___clrcall] = ACTIONS(2657),
    [anon_sym___stdcall] = ACTIONS(2657),
    [anon_sym___fastcall] = ACTIONS(2657),
    [anon_sym___thiscall] = ACTIONS(2657),
    [anon_sym___vectorcall] = ACTIONS(2657),
    [anon_sym_LBRACE] = ACTIONS(2659),
    [anon_sym_signed] = ACTIONS(2657),
    [anon_sym_unsigned] = ACTIONS(2657),
    [anon_sym_long] = ACTIONS(2657),
    [anon_sym_short] = ACTIONS(2657),
    [anon_sym_LBRACK] = ACTIONS(2657),
    [anon_sym_static] = ACTIONS(2657),
    [anon_sym_register] = ACTIONS(2657),
    [anon_sym_inline] = ACTIONS(2657),
    [anon_sym___inline] = ACTIONS(2657),
    [anon_sym___inline__] = ACTIONS(2657),
    [anon_sym___forceinline] = ACTIONS(2657),
    [anon_sym_thread_local] = ACTIONS(2657),
    [anon_sym___thread] = ACTIONS(2657),
    [anon_sym_const] = ACTIONS(2657),
    [anon_sym_constexpr] = ACTIONS(2657),
    [anon_sym_volatile] = ACTIONS(2657),
    [anon_sym_restrict] = ACTIONS(2657),
    [anon_sym___restrict__] = ACTIONS(2657),
    [anon_sym__Atomic] = ACTIONS(2657),
    [anon_sym__Noreturn] = ACTIONS(2657),
    [anon_sym_noreturn] = ACTIONS(2657),
    [anon_sym_mutable] = ACTIONS(2657),
    [anon_sym_constinit] = ACTIONS(2657),
    [anon_sym_consteval] = ACTIONS(2657),
    [anon_sym_PROGMEM] = ACTIONS(2657),
    [aux_sym_primitive_type_token1] = ACTIONS(2657),
    [anon_sym_byte] = ACTIONS(2657),
    [anon_sym_word] = ACTIONS(2657),
    [anon_sym_enum] = ACTIONS(2657),
    [anon_sym_class] = ACTIONS(2657),
    [anon_sym_struct] = ACTIONS(2657),
    [anon_sym_union] = ACTIONS(2657),
    [anon_sym_if] = ACTIONS(2657),
    [anon_sym_else] = ACTIONS(2657),
    [anon_sym_switch] = ACTIONS(2657),
    [anon_sym_case] = ACTIONS(2657),
    [anon_sym_default] = ACTIONS(2657),
    [anon_sym_while] = ACTIONS(2657),
    [anon_sym_do] = ACTIONS(2657),
    [anon_sym_for] = ACTIONS(2657),
    [anon_sym_return] = ACTIONS(2657),
    [anon_sym_break] = ACTIONS(2657),
    [anon_sym_continue] = ACTIONS(2657),
    [anon_sym_goto] = ACTIONS(2657),
    [anon_sym___try] = ACTIONS(2657),
    [anon_sym___leave] = ACTIONS(2657),
    [anon_sym_not] = ACTIONS(2657),
    [anon_sym_compl] = ACTIONS(2657),
    [anon_sym_DASH_DASH] = ACTIONS(2659),
    [anon_sym_PLUS_PLUS] = ACTIONS(2659),
    [anon_sym_sizeof] = ACTIONS(2657),
    [anon_sym___alignof__] = ACTIONS(2657),
    [anon_sym___alignof] = ACTIONS(2657),
    [anon_sym__alignof] = ACTIONS(2657),
    [anon_sym_alignof] = ACTIONS(2657),
    [anon_sym__Alignof] = ACTIONS(2657),
    [anon_sym_offsetof] = ACTIONS(2657),
    [anon_sym__Generic] = ACTIONS(2657),
    [anon_sym_asm] = ACTIONS(2657),
    [anon_sym___asm__] = ACTIONS(2657),
    [aux_sym_number_literal_token1] = ACTIONS(2659),
    [aux_sym_number_literal_token2] = ACTIONS(2657),
    [anon_sym_L_SQUOTE] = ACTIONS(2659),
    [anon_sym_u_SQUOTE] = ACTIONS(2659),
    [anon_sym_U_SQUOTE] = ACTIONS(2659),
    [anon_sym_u8_SQUOTE] = ACTIONS(2659),
    [anon_sym_SQUOTE] = ACTIONS(2659),
    [anon_sym_L_DQUOTE] = ACTIONS(2659),
    [anon_sym_u_DQUOTE] = ACTIONS(2659),
    [anon_sym_U_DQUOTE] = ACTIONS(2659),
    [anon_sym_u8_DQUOTE] = ACTIONS(2659),
    [anon_sym_DQUOTE] = ACTIONS(2659),
    [sym_true] = ACTIONS(2657),
    [sym_false] = ACTIONS(2657),
    [anon_sym_NULL] = ACTIONS(2657),
    [anon_sym_nullptr] = ACTIONS(2657),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2657),
    [anon_sym_decltype] = ACTIONS(2657),
    [anon_sym_virtual] = ACTIONS(2657),
    [anon_sym_alignas] = ACTIONS(2657),
    [anon_sym_explicit] = ACTIONS(2657),
    [anon_sym_typename] = ACTIONS(2657),
    [anon_sym_template] = ACTIONS(2657),
    [anon_sym_operator] = ACTIONS(2657),
    [anon_sym_try] = ACTIONS(2657),
    [anon_sym_delete] = ACTIONS(2657),
    [anon_sym_throw] = ACTIONS(2657),
    [anon_sym_namespace] = ACTIONS(2657),
    [anon_sym_using] = ACTIONS(2657),
    [anon_sym_static_assert] = ACTIONS(2657),
    [anon_sym_concept] = ACTIONS(2657),
    [anon_sym_co_return] = ACTIONS(2657),
    [anon_sym_co_yield] = ACTIONS(2657),
    [anon_sym_R_DQUOTE] = ACTIONS(2659),
    [anon_sym_LR_DQUOTE] = ACTIONS(2659),
    [anon_sym_uR_DQUOTE] = ACTIONS(2659),
    [anon_sym_UR_DQUOTE] = ACTIONS(2659),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2659),
    [anon_sym_co_await] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(2657),
    [anon_sym_requires] = ACTIONS(2657),
    [sym_this] = ACTIONS(2657),
  },
  [468] = {
    [sym_identifier] = ACTIONS(2661),
    [aux_sym_preproc_include_token1] = ACTIONS(2661),
    [aux_sym_preproc_def_token1] = ACTIONS(2661),
    [aux_sym_preproc_if_token1] = ACTIONS(2661),
    [aux_sym_preproc_if_token2] = ACTIONS(2661),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2661),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2661),
    [sym_preproc_directive] = ACTIONS(2661),
    [anon_sym_LPAREN2] = ACTIONS(2663),
    [anon_sym_BANG] = ACTIONS(2663),
    [anon_sym_TILDE] = ACTIONS(2663),
    [anon_sym_DASH] = ACTIONS(2661),
    [anon_sym_PLUS] = ACTIONS(2661),
    [anon_sym_STAR] = ACTIONS(2663),
    [anon_sym_AMP_AMP] = ACTIONS(2663),
    [anon_sym_AMP] = ACTIONS(2661),
    [anon_sym_SEMI] = ACTIONS(2663),
    [anon_sym___extension__] = ACTIONS(2661),
    [anon_sym_typedef] = ACTIONS(2661),
    [anon_sym_extern] = ACTIONS(2661),
    [anon_sym___attribute__] = ACTIONS(2661),
    [anon_sym_COLON_COLON] = ACTIONS(2663),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2663),
    [anon_sym___declspec] = ACTIONS(2661),
    [anon_sym___based] = ACTIONS(2661),
    [anon_sym___cdecl] = ACTIONS(2661),
    [anon_sym___clrcall] = ACTIONS(2661),
    [anon_sym___stdcall] = ACTIONS(2661),
    [anon_sym___fastcall] = ACTIONS(2661),
    [anon_sym___thiscall] = ACTIONS(2661),
    [anon_sym___vectorcall] = ACTIONS(2661),
    [anon_sym_LBRACE] = ACTIONS(2663),
    [anon_sym_signed] = ACTIONS(2661),
    [anon_sym_unsigned] = ACTIONS(2661),
    [anon_sym_long] = ACTIONS(2661),
    [anon_sym_short] = ACTIONS(2661),
    [anon_sym_LBRACK] = ACTIONS(2661),
    [anon_sym_static] = ACTIONS(2661),
    [anon_sym_register] = ACTIONS(2661),
    [anon_sym_inline] = ACTIONS(2661),
    [anon_sym___inline] = ACTIONS(2661),
    [anon_sym___inline__] = ACTIONS(2661),
    [anon_sym___forceinline] = ACTIONS(2661),
    [anon_sym_thread_local] = ACTIONS(2661),
    [anon_sym___thread] = ACTIONS(2661),
    [anon_sym_const] = ACTIONS(2661),
    [anon_sym_constexpr] = ACTIONS(2661),
    [anon_sym_volatile] = ACTIONS(2661),
    [anon_sym_restrict] = ACTIONS(2661),
    [anon_sym___restrict__] = ACTIONS(2661),
    [anon_sym__Atomic] = ACTIONS(2661),
    [anon_sym__Noreturn] = ACTIONS(2661),
    [anon_sym_noreturn] = ACTIONS(2661),
    [anon_sym_mutable] = ACTIONS(2661),
    [anon_sym_constinit] = ACTIONS(2661),
    [anon_sym_consteval] = ACTIONS(2661),
    [anon_sym_PROGMEM] = ACTIONS(2661),
    [aux_sym_primitive_type_token1] = ACTIONS(2661),
    [anon_sym_byte] = ACTIONS(2661),
    [anon_sym_word] = ACTIONS(2661),
    [anon_sym_enum] = ACTIONS(2661),
    [anon_sym_class] = ACTIONS(2661),
    [anon_sym_struct] = ACTIONS(2661),
    [anon_sym_union] = ACTIONS(2661),
    [anon_sym_if] = ACTIONS(2661),
    [anon_sym_else] = ACTIONS(2661),
    [anon_sym_switch] = ACTIONS(2661),
    [anon_sym_case] = ACTIONS(2661),
    [anon_sym_default] = ACTIONS(2661),
    [anon_sym_while] = ACTIONS(2661),
    [anon_sym_do] = ACTIONS(2661),
    [anon_sym_for] = ACTIONS(2661),
    [anon_sym_return] = ACTIONS(2661),
    [anon_sym_break] = ACTIONS(2661),
    [anon_sym_continue] = ACTIONS(2661),
    [anon_sym_goto] = ACTIONS(2661),
    [anon_sym___try] = ACTIONS(2661),
    [anon_sym___leave] = ACTIONS(2661),
    [anon_sym_not] = ACTIONS(2661),
    [anon_sym_compl] = ACTIONS(2661),
    [anon_sym_DASH_DASH] = ACTIONS(2663),
    [anon_sym_PLUS_PLUS] = ACTIONS(2663),
    [anon_sym_sizeof] = ACTIONS(2661),
    [anon_sym___alignof__] = ACTIONS(2661),
    [anon_sym___alignof] = ACTIONS(2661),
    [anon_sym__alignof] = ACTIONS(2661),
    [anon_sym_alignof] = ACTIONS(2661),
    [anon_sym__Alignof] = ACTIONS(2661),
    [anon_sym_offsetof] = ACTIONS(2661),
    [anon_sym__Generic] = ACTIONS(2661),
    [anon_sym_asm] = ACTIONS(2661),
    [anon_sym___asm__] = ACTIONS(2661),
    [aux_sym_number_literal_token1] = ACTIONS(2663),
    [aux_sym_number_literal_token2] = ACTIONS(2661),
    [anon_sym_L_SQUOTE] = ACTIONS(2663),
    [anon_sym_u_SQUOTE] = ACTIONS(2663),
    [anon_sym_U_SQUOTE] = ACTIONS(2663),
    [anon_sym_u8_SQUOTE] = ACTIONS(2663),
    [anon_sym_SQUOTE] = ACTIONS(2663),
    [anon_sym_L_DQUOTE] = ACTIONS(2663),
    [anon_sym_u_DQUOTE] = ACTIONS(2663),
    [anon_sym_U_DQUOTE] = ACTIONS(2663),
    [anon_sym_u8_DQUOTE] = ACTIONS(2663),
    [anon_sym_DQUOTE] = ACTIONS(2663),
    [sym_true] = ACTIONS(2661),
    [sym_false] = ACTIONS(2661),
    [anon_sym_NULL] = ACTIONS(2661),
    [anon_sym_nullptr] = ACTIONS(2661),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2661),
    [anon_sym_decltype] = ACTIONS(2661),
    [anon_sym_virtual] = ACTIONS(2661),
    [anon_sym_alignas] = ACTIONS(2661),
    [anon_sym_explicit] = ACTIONS(2661),
    [anon_sym_typename] = ACTIONS(2661),
    [anon_sym_template] = ACTIONS(2661),
    [anon_sym_operator] = ACTIONS(2661),
    [anon_sym_try] = ACTIONS(2661),
    [anon_sym_delete] = ACTIONS(2661),
    [anon_sym_throw] = ACTIONS(2661),
    [anon_sym_namespace] = ACTIONS(2661),
    [anon_sym_using] = ACTIONS(2661),
    [anon_sym_static_assert] = ACTIONS(2661),
    [anon_sym_concept] = ACTIONS(2661),
    [anon_sym_co_return] = ACTIONS(2661),
    [anon_sym_co_yield] = ACTIONS(2661),
    [anon_sym_R_DQUOTE] = ACTIONS(2663),
    [anon_sym_LR_DQUOTE] = ACTIONS(2663),
    [anon_sym_uR_DQUOTE] = ACTIONS(2663),
    [anon_sym_UR_DQUOTE] = ACTIONS(2663),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2663),
    [anon_sym_co_await] = ACTIONS(2661),
    [anon_sym_new] = ACTIONS(2661),
    [anon_sym_requires] = ACTIONS(2661),
    [sym_this] = ACTIONS(2661),
  },
  [469] = {
    [ts_builtin_sym_end] = ACTIONS(2645),
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [470] = {
    [sym_identifier] = ACTIONS(2665),
    [aux_sym_preproc_include_token1] = ACTIONS(2665),
    [aux_sym_preproc_def_token1] = ACTIONS(2665),
    [aux_sym_preproc_if_token1] = ACTIONS(2665),
    [aux_sym_preproc_if_token2] = ACTIONS(2665),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2665),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2665),
    [sym_preproc_directive] = ACTIONS(2665),
    [anon_sym_LPAREN2] = ACTIONS(2667),
    [anon_sym_BANG] = ACTIONS(2667),
    [anon_sym_TILDE] = ACTIONS(2667),
    [anon_sym_DASH] = ACTIONS(2665),
    [anon_sym_PLUS] = ACTIONS(2665),
    [anon_sym_STAR] = ACTIONS(2667),
    [anon_sym_AMP_AMP] = ACTIONS(2667),
    [anon_sym_AMP] = ACTIONS(2665),
    [anon_sym_SEMI] = ACTIONS(2667),
    [anon_sym___extension__] = ACTIONS(2665),
    [anon_sym_typedef] = ACTIONS(2665),
    [anon_sym_extern] = ACTIONS(2665),
    [anon_sym___attribute__] = ACTIONS(2665),
    [anon_sym_COLON_COLON] = ACTIONS(2667),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2667),
    [anon_sym___declspec] = ACTIONS(2665),
    [anon_sym___based] = ACTIONS(2665),
    [anon_sym___cdecl] = ACTIONS(2665),
    [anon_sym___clrcall] = ACTIONS(2665),
    [anon_sym___stdcall] = ACTIONS(2665),
    [anon_sym___fastcall] = ACTIONS(2665),
    [anon_sym___thiscall] = ACTIONS(2665),
    [anon_sym___vectorcall] = ACTIONS(2665),
    [anon_sym_LBRACE] = ACTIONS(2667),
    [anon_sym_signed] = ACTIONS(2665),
    [anon_sym_unsigned] = ACTIONS(2665),
    [anon_sym_long] = ACTIONS(2665),
    [anon_sym_short] = ACTIONS(2665),
    [anon_sym_LBRACK] = ACTIONS(2665),
    [anon_sym_static] = ACTIONS(2665),
    [anon_sym_register] = ACTIONS(2665),
    [anon_sym_inline] = ACTIONS(2665),
    [anon_sym___inline] = ACTIONS(2665),
    [anon_sym___inline__] = ACTIONS(2665),
    [anon_sym___forceinline] = ACTIONS(2665),
    [anon_sym_thread_local] = ACTIONS(2665),
    [anon_sym___thread] = ACTIONS(2665),
    [anon_sym_const] = ACTIONS(2665),
    [anon_sym_constexpr] = ACTIONS(2665),
    [anon_sym_volatile] = ACTIONS(2665),
    [anon_sym_restrict] = ACTIONS(2665),
    [anon_sym___restrict__] = ACTIONS(2665),
    [anon_sym__Atomic] = ACTIONS(2665),
    [anon_sym__Noreturn] = ACTIONS(2665),
    [anon_sym_noreturn] = ACTIONS(2665),
    [anon_sym_mutable] = ACTIONS(2665),
    [anon_sym_constinit] = ACTIONS(2665),
    [anon_sym_consteval] = ACTIONS(2665),
    [anon_sym_PROGMEM] = ACTIONS(2665),
    [aux_sym_primitive_type_token1] = ACTIONS(2665),
    [anon_sym_byte] = ACTIONS(2665),
    [anon_sym_word] = ACTIONS(2665),
    [anon_sym_enum] = ACTIONS(2665),
    [anon_sym_class] = ACTIONS(2665),
    [anon_sym_struct] = ACTIONS(2665),
    [anon_sym_union] = ACTIONS(2665),
    [anon_sym_if] = ACTIONS(2665),
    [anon_sym_else] = ACTIONS(2665),
    [anon_sym_switch] = ACTIONS(2665),
    [anon_sym_case] = ACTIONS(2665),
    [anon_sym_default] = ACTIONS(2665),
    [anon_sym_while] = ACTIONS(2665),
    [anon_sym_do] = ACTIONS(2665),
    [anon_sym_for] = ACTIONS(2665),
    [anon_sym_return] = ACTIONS(2665),
    [anon_sym_break] = ACTIONS(2665),
    [anon_sym_continue] = ACTIONS(2665),
    [anon_sym_goto] = ACTIONS(2665),
    [anon_sym___try] = ACTIONS(2665),
    [anon_sym___leave] = ACTIONS(2665),
    [anon_sym_not] = ACTIONS(2665),
    [anon_sym_compl] = ACTIONS(2665),
    [anon_sym_DASH_DASH] = ACTIONS(2667),
    [anon_sym_PLUS_PLUS] = ACTIONS(2667),
    [anon_sym_sizeof] = ACTIONS(2665),
    [anon_sym___alignof__] = ACTIONS(2665),
    [anon_sym___alignof] = ACTIONS(2665),
    [anon_sym__alignof] = ACTIONS(2665),
    [anon_sym_alignof] = ACTIONS(2665),
    [anon_sym__Alignof] = ACTIONS(2665),
    [anon_sym_offsetof] = ACTIONS(2665),
    [anon_sym__Generic] = ACTIONS(2665),
    [anon_sym_asm] = ACTIONS(2665),
    [anon_sym___asm__] = ACTIONS(2665),
    [aux_sym_number_literal_token1] = ACTIONS(2667),
    [aux_sym_number_literal_token2] = ACTIONS(2665),
    [anon_sym_L_SQUOTE] = ACTIONS(2667),
    [anon_sym_u_SQUOTE] = ACTIONS(2667),
    [anon_sym_U_SQUOTE] = ACTIONS(2667),
    [anon_sym_u8_SQUOTE] = ACTIONS(2667),
    [anon_sym_SQUOTE] = ACTIONS(2667),
    [anon_sym_L_DQUOTE] = ACTIONS(2667),
    [anon_sym_u_DQUOTE] = ACTIONS(2667),
    [anon_sym_U_DQUOTE] = ACTIONS(2667),
    [anon_sym_u8_DQUOTE] = ACTIONS(2667),
    [anon_sym_DQUOTE] = ACTIONS(2667),
    [sym_true] = ACTIONS(2665),
    [sym_false] = ACTIONS(2665),
    [anon_sym_NULL] = ACTIONS(2665),
    [anon_sym_nullptr] = ACTIONS(2665),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2665),
    [anon_sym_decltype] = ACTIONS(2665),
    [anon_sym_virtual] = ACTIONS(2665),
    [anon_sym_alignas] = ACTIONS(2665),
    [anon_sym_explicit] = ACTIONS(2665),
    [anon_sym_typename] = ACTIONS(2665),
    [anon_sym_template] = ACTIONS(2665),
    [anon_sym_operator] = ACTIONS(2665),
    [anon_sym_try] = ACTIONS(2665),
    [anon_sym_delete] = ACTIONS(2665),
    [anon_sym_throw] = ACTIONS(2665),
    [anon_sym_namespace] = ACTIONS(2665),
    [anon_sym_using] = ACTIONS(2665),
    [anon_sym_static_assert] = ACTIONS(2665),
    [anon_sym_concept] = ACTIONS(2665),
    [anon_sym_co_return] = ACTIONS(2665),
    [anon_sym_co_yield] = ACTIONS(2665),
    [anon_sym_R_DQUOTE] = ACTIONS(2667),
    [anon_sym_LR_DQUOTE] = ACTIONS(2667),
    [anon_sym_uR_DQUOTE] = ACTIONS(2667),
    [anon_sym_UR_DQUOTE] = ACTIONS(2667),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2667),
    [anon_sym_co_await] = ACTIONS(2665),
    [anon_sym_new] = ACTIONS(2665),
    [anon_sym_requires] = ACTIONS(2665),
    [sym_this] = ACTIONS(2665),
  },
  [471] = {
    [ts_builtin_sym_end] = ACTIONS(2645),
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [472] = {
    [sym_identifier] = ACTIONS(2669),
    [aux_sym_preproc_include_token1] = ACTIONS(2669),
    [aux_sym_preproc_def_token1] = ACTIONS(2669),
    [aux_sym_preproc_if_token1] = ACTIONS(2669),
    [aux_sym_preproc_if_token2] = ACTIONS(2669),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2669),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2669),
    [sym_preproc_directive] = ACTIONS(2669),
    [anon_sym_LPAREN2] = ACTIONS(2671),
    [anon_sym_BANG] = ACTIONS(2671),
    [anon_sym_TILDE] = ACTIONS(2671),
    [anon_sym_DASH] = ACTIONS(2669),
    [anon_sym_PLUS] = ACTIONS(2669),
    [anon_sym_STAR] = ACTIONS(2671),
    [anon_sym_AMP_AMP] = ACTIONS(2671),
    [anon_sym_AMP] = ACTIONS(2669),
    [anon_sym_SEMI] = ACTIONS(2671),
    [anon_sym___extension__] = ACTIONS(2669),
    [anon_sym_typedef] = ACTIONS(2669),
    [anon_sym_extern] = ACTIONS(2669),
    [anon_sym___attribute__] = ACTIONS(2669),
    [anon_sym_COLON_COLON] = ACTIONS(2671),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2671),
    [anon_sym___declspec] = ACTIONS(2669),
    [anon_sym___based] = ACTIONS(2669),
    [anon_sym___cdecl] = ACTIONS(2669),
    [anon_sym___clrcall] = ACTIONS(2669),
    [anon_sym___stdcall] = ACTIONS(2669),
    [anon_sym___fastcall] = ACTIONS(2669),
    [anon_sym___thiscall] = ACTIONS(2669),
    [anon_sym___vectorcall] = ACTIONS(2669),
    [anon_sym_LBRACE] = ACTIONS(2671),
    [anon_sym_signed] = ACTIONS(2669),
    [anon_sym_unsigned] = ACTIONS(2669),
    [anon_sym_long] = ACTIONS(2669),
    [anon_sym_short] = ACTIONS(2669),
    [anon_sym_LBRACK] = ACTIONS(2669),
    [anon_sym_static] = ACTIONS(2669),
    [anon_sym_register] = ACTIONS(2669),
    [anon_sym_inline] = ACTIONS(2669),
    [anon_sym___inline] = ACTIONS(2669),
    [anon_sym___inline__] = ACTIONS(2669),
    [anon_sym___forceinline] = ACTIONS(2669),
    [anon_sym_thread_local] = ACTIONS(2669),
    [anon_sym___thread] = ACTIONS(2669),
    [anon_sym_const] = ACTIONS(2669),
    [anon_sym_constexpr] = ACTIONS(2669),
    [anon_sym_volatile] = ACTIONS(2669),
    [anon_sym_restrict] = ACTIONS(2669),
    [anon_sym___restrict__] = ACTIONS(2669),
    [anon_sym__Atomic] = ACTIONS(2669),
    [anon_sym__Noreturn] = ACTIONS(2669),
    [anon_sym_noreturn] = ACTIONS(2669),
    [anon_sym_mutable] = ACTIONS(2669),
    [anon_sym_constinit] = ACTIONS(2669),
    [anon_sym_consteval] = ACTIONS(2669),
    [anon_sym_PROGMEM] = ACTIONS(2669),
    [aux_sym_primitive_type_token1] = ACTIONS(2669),
    [anon_sym_byte] = ACTIONS(2669),
    [anon_sym_word] = ACTIONS(2669),
    [anon_sym_enum] = ACTIONS(2669),
    [anon_sym_class] = ACTIONS(2669),
    [anon_sym_struct] = ACTIONS(2669),
    [anon_sym_union] = ACTIONS(2669),
    [anon_sym_if] = ACTIONS(2669),
    [anon_sym_else] = ACTIONS(2669),
    [anon_sym_switch] = ACTIONS(2669),
    [anon_sym_case] = ACTIONS(2669),
    [anon_sym_default] = ACTIONS(2669),
    [anon_sym_while] = ACTIONS(2669),
    [anon_sym_do] = ACTIONS(2669),
    [anon_sym_for] = ACTIONS(2669),
    [anon_sym_return] = ACTIONS(2669),
    [anon_sym_break] = ACTIONS(2669),
    [anon_sym_continue] = ACTIONS(2669),
    [anon_sym_goto] = ACTIONS(2669),
    [anon_sym___try] = ACTIONS(2669),
    [anon_sym___leave] = ACTIONS(2669),
    [anon_sym_not] = ACTIONS(2669),
    [anon_sym_compl] = ACTIONS(2669),
    [anon_sym_DASH_DASH] = ACTIONS(2671),
    [anon_sym_PLUS_PLUS] = ACTIONS(2671),
    [anon_sym_sizeof] = ACTIONS(2669),
    [anon_sym___alignof__] = ACTIONS(2669),
    [anon_sym___alignof] = ACTIONS(2669),
    [anon_sym__alignof] = ACTIONS(2669),
    [anon_sym_alignof] = ACTIONS(2669),
    [anon_sym__Alignof] = ACTIONS(2669),
    [anon_sym_offsetof] = ACTIONS(2669),
    [anon_sym__Generic] = ACTIONS(2669),
    [anon_sym_asm] = ACTIONS(2669),
    [anon_sym___asm__] = ACTIONS(2669),
    [aux_sym_number_literal_token1] = ACTIONS(2671),
    [aux_sym_number_literal_token2] = ACTIONS(2669),
    [anon_sym_L_SQUOTE] = ACTIONS(2671),
    [anon_sym_u_SQUOTE] = ACTIONS(2671),
    [anon_sym_U_SQUOTE] = ACTIONS(2671),
    [anon_sym_u8_SQUOTE] = ACTIONS(2671),
    [anon_sym_SQUOTE] = ACTIONS(2671),
    [anon_sym_L_DQUOTE] = ACTIONS(2671),
    [anon_sym_u_DQUOTE] = ACTIONS(2671),
    [anon_sym_U_DQUOTE] = ACTIONS(2671),
    [anon_sym_u8_DQUOTE] = ACTIONS(2671),
    [anon_sym_DQUOTE] = ACTIONS(2671),
    [sym_true] = ACTIONS(2669),
    [sym_false] = ACTIONS(2669),
    [anon_sym_NULL] = ACTIONS(2669),
    [anon_sym_nullptr] = ACTIONS(2669),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2669),
    [anon_sym_decltype] = ACTIONS(2669),
    [anon_sym_virtual] = ACTIONS(2669),
    [anon_sym_alignas] = ACTIONS(2669),
    [anon_sym_explicit] = ACTIONS(2669),
    [anon_sym_typename] = ACTIONS(2669),
    [anon_sym_template] = ACTIONS(2669),
    [anon_sym_operator] = ACTIONS(2669),
    [anon_sym_try] = ACTIONS(2669),
    [anon_sym_delete] = ACTIONS(2669),
    [anon_sym_throw] = ACTIONS(2669),
    [anon_sym_namespace] = ACTIONS(2669),
    [anon_sym_using] = ACTIONS(2669),
    [anon_sym_static_assert] = ACTIONS(2669),
    [anon_sym_concept] = ACTIONS(2669),
    [anon_sym_co_return] = ACTIONS(2669),
    [anon_sym_co_yield] = ACTIONS(2669),
    [anon_sym_R_DQUOTE] = ACTIONS(2671),
    [anon_sym_LR_DQUOTE] = ACTIONS(2671),
    [anon_sym_uR_DQUOTE] = ACTIONS(2671),
    [anon_sym_UR_DQUOTE] = ACTIONS(2671),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2671),
    [anon_sym_co_await] = ACTIONS(2669),
    [anon_sym_new] = ACTIONS(2669),
    [anon_sym_requires] = ACTIONS(2669),
    [sym_this] = ACTIONS(2669),
  },
  [473] = {
    [ts_builtin_sym_end] = ACTIONS(2781),
    [sym_identifier] = ACTIONS(2779),
    [aux_sym_preproc_include_token1] = ACTIONS(2779),
    [aux_sym_preproc_def_token1] = ACTIONS(2779),
    [aux_sym_preproc_if_token1] = ACTIONS(2779),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2779),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2779),
    [sym_preproc_directive] = ACTIONS(2779),
    [anon_sym_LPAREN2] = ACTIONS(2781),
    [anon_sym_BANG] = ACTIONS(2781),
    [anon_sym_TILDE] = ACTIONS(2781),
    [anon_sym_DASH] = ACTIONS(2779),
    [anon_sym_PLUS] = ACTIONS(2779),
    [anon_sym_STAR] = ACTIONS(2781),
    [anon_sym_AMP_AMP] = ACTIONS(2781),
    [anon_sym_AMP] = ACTIONS(2779),
    [anon_sym_SEMI] = ACTIONS(2781),
    [anon_sym___extension__] = ACTIONS(2779),
    [anon_sym_typedef] = ACTIONS(2779),
    [anon_sym_extern] = ACTIONS(2779),
    [anon_sym___attribute__] = ACTIONS(2779),
    [anon_sym_COLON_COLON] = ACTIONS(2781),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2781),
    [anon_sym___declspec] = ACTIONS(2779),
    [anon_sym___based] = ACTIONS(2779),
    [anon_sym___cdecl] = ACTIONS(2779),
    [anon_sym___clrcall] = ACTIONS(2779),
    [anon_sym___stdcall] = ACTIONS(2779),
    [anon_sym___fastcall] = ACTIONS(2779),
    [anon_sym___thiscall] = ACTIONS(2779),
    [anon_sym___vectorcall] = ACTIONS(2779),
    [anon_sym_LBRACE] = ACTIONS(2781),
    [anon_sym_signed] = ACTIONS(2779),
    [anon_sym_unsigned] = ACTIONS(2779),
    [anon_sym_long] = ACTIONS(2779),
    [anon_sym_short] = ACTIONS(2779),
    [anon_sym_LBRACK] = ACTIONS(2779),
    [anon_sym_static] = ACTIONS(2779),
    [anon_sym_register] = ACTIONS(2779),
    [anon_sym_inline] = ACTIONS(2779),
    [anon_sym___inline] = ACTIONS(2779),
    [anon_sym___inline__] = ACTIONS(2779),
    [anon_sym___forceinline] = ACTIONS(2779),
    [anon_sym_thread_local] = ACTIONS(2779),
    [anon_sym___thread] = ACTIONS(2779),
    [anon_sym_const] = ACTIONS(2779),
    [anon_sym_constexpr] = ACTIONS(2779),
    [anon_sym_volatile] = ACTIONS(2779),
    [anon_sym_restrict] = ACTIONS(2779),
    [anon_sym___restrict__] = ACTIONS(2779),
    [anon_sym__Atomic] = ACTIONS(2779),
    [anon_sym__Noreturn] = ACTIONS(2779),
    [anon_sym_noreturn] = ACTIONS(2779),
    [anon_sym_mutable] = ACTIONS(2779),
    [anon_sym_constinit] = ACTIONS(2779),
    [anon_sym_consteval] = ACTIONS(2779),
    [anon_sym_PROGMEM] = ACTIONS(2779),
    [aux_sym_primitive_type_token1] = ACTIONS(2779),
    [anon_sym_byte] = ACTIONS(2779),
    [anon_sym_word] = ACTIONS(2779),
    [anon_sym_enum] = ACTIONS(2779),
    [anon_sym_class] = ACTIONS(2779),
    [anon_sym_struct] = ACTIONS(2779),
    [anon_sym_union] = ACTIONS(2779),
    [anon_sym_if] = ACTIONS(2779),
    [anon_sym_else] = ACTIONS(2779),
    [anon_sym_switch] = ACTIONS(2779),
    [anon_sym_case] = ACTIONS(2779),
    [anon_sym_default] = ACTIONS(2779),
    [anon_sym_while] = ACTIONS(2779),
    [anon_sym_do] = ACTIONS(2779),
    [anon_sym_for] = ACTIONS(2779),
    [anon_sym_return] = ACTIONS(2779),
    [anon_sym_break] = ACTIONS(2779),
    [anon_sym_continue] = ACTIONS(2779),
    [anon_sym_goto] = ACTIONS(2779),
    [anon_sym___try] = ACTIONS(2779),
    [anon_sym___leave] = ACTIONS(2779),
    [anon_sym_not] = ACTIONS(2779),
    [anon_sym_compl] = ACTIONS(2779),
    [anon_sym_DASH_DASH] = ACTIONS(2781),
    [anon_sym_PLUS_PLUS] = ACTIONS(2781),
    [anon_sym_sizeof] = ACTIONS(2779),
    [anon_sym___alignof__] = ACTIONS(2779),
    [anon_sym___alignof] = ACTIONS(2779),
    [anon_sym__alignof] = ACTIONS(2779),
    [anon_sym_alignof] = ACTIONS(2779),
    [anon_sym__Alignof] = ACTIONS(2779),
    [anon_sym_offsetof] = ACTIONS(2779),
    [anon_sym__Generic] = ACTIONS(2779),
    [anon_sym_asm] = ACTIONS(2779),
    [anon_sym___asm__] = ACTIONS(2779),
    [aux_sym_number_literal_token1] = ACTIONS(2781),
    [aux_sym_number_literal_token2] = ACTIONS(2779),
    [anon_sym_L_SQUOTE] = ACTIONS(2781),
    [anon_sym_u_SQUOTE] = ACTIONS(2781),
    [anon_sym_U_SQUOTE] = ACTIONS(2781),
    [anon_sym_u8_SQUOTE] = ACTIONS(2781),
    [anon_sym_SQUOTE] = ACTIONS(2781),
    [anon_sym_L_DQUOTE] = ACTIONS(2781),
    [anon_sym_u_DQUOTE] = ACTIONS(2781),
    [anon_sym_U_DQUOTE] = ACTIONS(2781),
    [anon_sym_u8_DQUOTE] = ACTIONS(2781),
    [anon_sym_DQUOTE] = ACTIONS(2781),
    [sym_true] = ACTIONS(2779),
    [sym_false] = ACTIONS(2779),
    [anon_sym_NULL] = ACTIONS(2779),
    [anon_sym_nullptr] = ACTIONS(2779),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2779),
    [anon_sym_decltype] = ACTIONS(2779),
    [anon_sym_virtual] = ACTIONS(2779),
    [anon_sym_alignas] = ACTIONS(2779),
    [anon_sym_explicit] = ACTIONS(2779),
    [anon_sym_typename] = ACTIONS(2779),
    [anon_sym_template] = ACTIONS(2779),
    [anon_sym_operator] = ACTIONS(2779),
    [anon_sym_try] = ACTIONS(2779),
    [anon_sym_delete] = ACTIONS(2779),
    [anon_sym_throw] = ACTIONS(2779),
    [anon_sym_namespace] = ACTIONS(2779),
    [anon_sym_using] = ACTIONS(2779),
    [anon_sym_static_assert] = ACTIONS(2779),
    [anon_sym_concept] = ACTIONS(2779),
    [anon_sym_co_return] = ACTIONS(2779),
    [anon_sym_co_yield] = ACTIONS(2779),
    [anon_sym_R_DQUOTE] = ACTIONS(2781),
    [anon_sym_LR_DQUOTE] = ACTIONS(2781),
    [anon_sym_uR_DQUOTE] = ACTIONS(2781),
    [anon_sym_UR_DQUOTE] = ACTIONS(2781),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2781),
    [anon_sym_co_await] = ACTIONS(2779),
    [anon_sym_new] = ACTIONS(2779),
    [anon_sym_requires] = ACTIONS(2779),
    [sym_this] = ACTIONS(2779),
  },
  [474] = {
    [ts_builtin_sym_end] = ACTIONS(2645),
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [475] = {
    [ts_builtin_sym_end] = ACTIONS(2799),
    [sym_identifier] = ACTIONS(2797),
    [aux_sym_preproc_include_token1] = ACTIONS(2797),
    [aux_sym_preproc_def_token1] = ACTIONS(2797),
    [aux_sym_preproc_if_token1] = ACTIONS(2797),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2797),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2797),
    [sym_preproc_directive] = ACTIONS(2797),
    [anon_sym_LPAREN2] = ACTIONS(2799),
    [anon_sym_BANG] = ACTIONS(2799),
    [anon_sym_TILDE] = ACTIONS(2799),
    [anon_sym_DASH] = ACTIONS(2797),
    [anon_sym_PLUS] = ACTIONS(2797),
    [anon_sym_STAR] = ACTIONS(2799),
    [anon_sym_AMP_AMP] = ACTIONS(2799),
    [anon_sym_AMP] = ACTIONS(2797),
    [anon_sym_SEMI] = ACTIONS(2799),
    [anon_sym___extension__] = ACTIONS(2797),
    [anon_sym_typedef] = ACTIONS(2797),
    [anon_sym_extern] = ACTIONS(2797),
    [anon_sym___attribute__] = ACTIONS(2797),
    [anon_sym_COLON_COLON] = ACTIONS(2799),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2799),
    [anon_sym___declspec] = ACTIONS(2797),
    [anon_sym___based] = ACTIONS(2797),
    [anon_sym___cdecl] = ACTIONS(2797),
    [anon_sym___clrcall] = ACTIONS(2797),
    [anon_sym___stdcall] = ACTIONS(2797),
    [anon_sym___fastcall] = ACTIONS(2797),
    [anon_sym___thiscall] = ACTIONS(2797),
    [anon_sym___vectorcall] = ACTIONS(2797),
    [anon_sym_LBRACE] = ACTIONS(2799),
    [anon_sym_signed] = ACTIONS(2797),
    [anon_sym_unsigned] = ACTIONS(2797),
    [anon_sym_long] = ACTIONS(2797),
    [anon_sym_short] = ACTIONS(2797),
    [anon_sym_LBRACK] = ACTIONS(2797),
    [anon_sym_static] = ACTIONS(2797),
    [anon_sym_register] = ACTIONS(2797),
    [anon_sym_inline] = ACTIONS(2797),
    [anon_sym___inline] = ACTIONS(2797),
    [anon_sym___inline__] = ACTIONS(2797),
    [anon_sym___forceinline] = ACTIONS(2797),
    [anon_sym_thread_local] = ACTIONS(2797),
    [anon_sym___thread] = ACTIONS(2797),
    [anon_sym_const] = ACTIONS(2797),
    [anon_sym_constexpr] = ACTIONS(2797),
    [anon_sym_volatile] = ACTIONS(2797),
    [anon_sym_restrict] = ACTIONS(2797),
    [anon_sym___restrict__] = ACTIONS(2797),
    [anon_sym__Atomic] = ACTIONS(2797),
    [anon_sym__Noreturn] = ACTIONS(2797),
    [anon_sym_noreturn] = ACTIONS(2797),
    [anon_sym_mutable] = ACTIONS(2797),
    [anon_sym_constinit] = ACTIONS(2797),
    [anon_sym_consteval] = ACTIONS(2797),
    [anon_sym_PROGMEM] = ACTIONS(2797),
    [aux_sym_primitive_type_token1] = ACTIONS(2797),
    [anon_sym_byte] = ACTIONS(2797),
    [anon_sym_word] = ACTIONS(2797),
    [anon_sym_enum] = ACTIONS(2797),
    [anon_sym_class] = ACTIONS(2797),
    [anon_sym_struct] = ACTIONS(2797),
    [anon_sym_union] = ACTIONS(2797),
    [anon_sym_if] = ACTIONS(2797),
    [anon_sym_else] = ACTIONS(2797),
    [anon_sym_switch] = ACTIONS(2797),
    [anon_sym_case] = ACTIONS(2797),
    [anon_sym_default] = ACTIONS(2797),
    [anon_sym_while] = ACTIONS(2797),
    [anon_sym_do] = ACTIONS(2797),
    [anon_sym_for] = ACTIONS(2797),
    [anon_sym_return] = ACTIONS(2797),
    [anon_sym_break] = ACTIONS(2797),
    [anon_sym_continue] = ACTIONS(2797),
    [anon_sym_goto] = ACTIONS(2797),
    [anon_sym___try] = ACTIONS(2797),
    [anon_sym___leave] = ACTIONS(2797),
    [anon_sym_not] = ACTIONS(2797),
    [anon_sym_compl] = ACTIONS(2797),
    [anon_sym_DASH_DASH] = ACTIONS(2799),
    [anon_sym_PLUS_PLUS] = ACTIONS(2799),
    [anon_sym_sizeof] = ACTIONS(2797),
    [anon_sym___alignof__] = ACTIONS(2797),
    [anon_sym___alignof] = ACTIONS(2797),
    [anon_sym__alignof] = ACTIONS(2797),
    [anon_sym_alignof] = ACTIONS(2797),
    [anon_sym__Alignof] = ACTIONS(2797),
    [anon_sym_offsetof] = ACTIONS(2797),
    [anon_sym__Generic] = ACTIONS(2797),
    [anon_sym_asm] = ACTIONS(2797),
    [anon_sym___asm__] = ACTIONS(2797),
    [aux_sym_number_literal_token1] = ACTIONS(2799),
    [aux_sym_number_literal_token2] = ACTIONS(2797),
    [anon_sym_L_SQUOTE] = ACTIONS(2799),
    [anon_sym_u_SQUOTE] = ACTIONS(2799),
    [anon_sym_U_SQUOTE] = ACTIONS(2799),
    [anon_sym_u8_SQUOTE] = ACTIONS(2799),
    [anon_sym_SQUOTE] = ACTIONS(2799),
    [anon_sym_L_DQUOTE] = ACTIONS(2799),
    [anon_sym_u_DQUOTE] = ACTIONS(2799),
    [anon_sym_U_DQUOTE] = ACTIONS(2799),
    [anon_sym_u8_DQUOTE] = ACTIONS(2799),
    [anon_sym_DQUOTE] = ACTIONS(2799),
    [sym_true] = ACTIONS(2797),
    [sym_false] = ACTIONS(2797),
    [anon_sym_NULL] = ACTIONS(2797),
    [anon_sym_nullptr] = ACTIONS(2797),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2797),
    [anon_sym_decltype] = ACTIONS(2797),
    [anon_sym_virtual] = ACTIONS(2797),
    [anon_sym_alignas] = ACTIONS(2797),
    [anon_sym_explicit] = ACTIONS(2797),
    [anon_sym_typename] = ACTIONS(2797),
    [anon_sym_template] = ACTIONS(2797),
    [anon_sym_operator] = ACTIONS(2797),
    [anon_sym_try] = ACTIONS(2797),
    [anon_sym_delete] = ACTIONS(2797),
    [anon_sym_throw] = ACTIONS(2797),
    [anon_sym_namespace] = ACTIONS(2797),
    [anon_sym_using] = ACTIONS(2797),
    [anon_sym_static_assert] = ACTIONS(2797),
    [anon_sym_concept] = ACTIONS(2797),
    [anon_sym_co_return] = ACTIONS(2797),
    [anon_sym_co_yield] = ACTIONS(2797),
    [anon_sym_R_DQUOTE] = ACTIONS(2799),
    [anon_sym_LR_DQUOTE] = ACTIONS(2799),
    [anon_sym_uR_DQUOTE] = ACTIONS(2799),
    [anon_sym_UR_DQUOTE] = ACTIONS(2799),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2799),
    [anon_sym_co_await] = ACTIONS(2797),
    [anon_sym_new] = ACTIONS(2797),
    [anon_sym_requires] = ACTIONS(2797),
    [sym_this] = ACTIONS(2797),
  },
  [476] = {
    [ts_builtin_sym_end] = ACTIONS(2681),
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [477] = {
    [ts_builtin_sym_end] = ACTIONS(2641),
    [sym_identifier] = ACTIONS(2639),
    [aux_sym_preproc_include_token1] = ACTIONS(2639),
    [aux_sym_preproc_def_token1] = ACTIONS(2639),
    [aux_sym_preproc_if_token1] = ACTIONS(2639),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2639),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2639),
    [sym_preproc_directive] = ACTIONS(2639),
    [anon_sym_LPAREN2] = ACTIONS(2641),
    [anon_sym_BANG] = ACTIONS(2641),
    [anon_sym_TILDE] = ACTIONS(2641),
    [anon_sym_DASH] = ACTIONS(2639),
    [anon_sym_PLUS] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(2641),
    [anon_sym_AMP_AMP] = ACTIONS(2641),
    [anon_sym_AMP] = ACTIONS(2639),
    [anon_sym_SEMI] = ACTIONS(2641),
    [anon_sym___extension__] = ACTIONS(2639),
    [anon_sym_typedef] = ACTIONS(2639),
    [anon_sym_extern] = ACTIONS(2639),
    [anon_sym___attribute__] = ACTIONS(2639),
    [anon_sym_COLON_COLON] = ACTIONS(2641),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2641),
    [anon_sym___declspec] = ACTIONS(2639),
    [anon_sym___based] = ACTIONS(2639),
    [anon_sym___cdecl] = ACTIONS(2639),
    [anon_sym___clrcall] = ACTIONS(2639),
    [anon_sym___stdcall] = ACTIONS(2639),
    [anon_sym___fastcall] = ACTIONS(2639),
    [anon_sym___thiscall] = ACTIONS(2639),
    [anon_sym___vectorcall] = ACTIONS(2639),
    [anon_sym_LBRACE] = ACTIONS(2641),
    [anon_sym_signed] = ACTIONS(2639),
    [anon_sym_unsigned] = ACTIONS(2639),
    [anon_sym_long] = ACTIONS(2639),
    [anon_sym_short] = ACTIONS(2639),
    [anon_sym_LBRACK] = ACTIONS(2639),
    [anon_sym_static] = ACTIONS(2639),
    [anon_sym_register] = ACTIONS(2639),
    [anon_sym_inline] = ACTIONS(2639),
    [anon_sym___inline] = ACTIONS(2639),
    [anon_sym___inline__] = ACTIONS(2639),
    [anon_sym___forceinline] = ACTIONS(2639),
    [anon_sym_thread_local] = ACTIONS(2639),
    [anon_sym___thread] = ACTIONS(2639),
    [anon_sym_const] = ACTIONS(2639),
    [anon_sym_constexpr] = ACTIONS(2639),
    [anon_sym_volatile] = ACTIONS(2639),
    [anon_sym_restrict] = ACTIONS(2639),
    [anon_sym___restrict__] = ACTIONS(2639),
    [anon_sym__Atomic] = ACTIONS(2639),
    [anon_sym__Noreturn] = ACTIONS(2639),
    [anon_sym_noreturn] = ACTIONS(2639),
    [anon_sym_mutable] = ACTIONS(2639),
    [anon_sym_constinit] = ACTIONS(2639),
    [anon_sym_consteval] = ACTIONS(2639),
    [anon_sym_PROGMEM] = ACTIONS(2639),
    [aux_sym_primitive_type_token1] = ACTIONS(2639),
    [anon_sym_byte] = ACTIONS(2639),
    [anon_sym_word] = ACTIONS(2639),
    [anon_sym_enum] = ACTIONS(2639),
    [anon_sym_class] = ACTIONS(2639),
    [anon_sym_struct] = ACTIONS(2639),
    [anon_sym_union] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2639),
    [anon_sym_else] = ACTIONS(2639),
    [anon_sym_switch] = ACTIONS(2639),
    [anon_sym_case] = ACTIONS(2639),
    [anon_sym_default] = ACTIONS(2639),
    [anon_sym_while] = ACTIONS(2639),
    [anon_sym_do] = ACTIONS(2639),
    [anon_sym_for] = ACTIONS(2639),
    [anon_sym_return] = ACTIONS(2639),
    [anon_sym_break] = ACTIONS(2639),
    [anon_sym_continue] = ACTIONS(2639),
    [anon_sym_goto] = ACTIONS(2639),
    [anon_sym___try] = ACTIONS(2639),
    [anon_sym___leave] = ACTIONS(2639),
    [anon_sym_not] = ACTIONS(2639),
    [anon_sym_compl] = ACTIONS(2639),
    [anon_sym_DASH_DASH] = ACTIONS(2641),
    [anon_sym_PLUS_PLUS] = ACTIONS(2641),
    [anon_sym_sizeof] = ACTIONS(2639),
    [anon_sym___alignof__] = ACTIONS(2639),
    [anon_sym___alignof] = ACTIONS(2639),
    [anon_sym__alignof] = ACTIONS(2639),
    [anon_sym_alignof] = ACTIONS(2639),
    [anon_sym__Alignof] = ACTIONS(2639),
    [anon_sym_offsetof] = ACTIONS(2639),
    [anon_sym__Generic] = ACTIONS(2639),
    [anon_sym_asm] = ACTIONS(2639),
    [anon_sym___asm__] = ACTIONS(2639),
    [aux_sym_number_literal_token1] = ACTIONS(2641),
    [aux_sym_number_literal_token2] = ACTIONS(2639),
    [anon_sym_L_SQUOTE] = ACTIONS(2641),
    [anon_sym_u_SQUOTE] = ACTIONS(2641),
    [anon_sym_U_SQUOTE] = ACTIONS(2641),
    [anon_sym_u8_SQUOTE] = ACTIONS(2641),
    [anon_sym_SQUOTE] = ACTIONS(2641),
    [anon_sym_L_DQUOTE] = ACTIONS(2641),
    [anon_sym_u_DQUOTE] = ACTIONS(2641),
    [anon_sym_U_DQUOTE] = ACTIONS(2641),
    [anon_sym_u8_DQUOTE] = ACTIONS(2641),
    [anon_sym_DQUOTE] = ACTIONS(2641),
    [sym_true] = ACTIONS(2639),
    [sym_false] = ACTIONS(2639),
    [anon_sym_NULL] = ACTIONS(2639),
    [anon_sym_nullptr] = ACTIONS(2639),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2639),
    [anon_sym_decltype] = ACTIONS(2639),
    [anon_sym_virtual] = ACTIONS(2639),
    [anon_sym_alignas] = ACTIONS(2639),
    [anon_sym_explicit] = ACTIONS(2639),
    [anon_sym_typename] = ACTIONS(2639),
    [anon_sym_template] = ACTIONS(2639),
    [anon_sym_operator] = ACTIONS(2639),
    [anon_sym_try] = ACTIONS(2639),
    [anon_sym_delete] = ACTIONS(2639),
    [anon_sym_throw] = ACTIONS(2639),
    [anon_sym_namespace] = ACTIONS(2639),
    [anon_sym_using] = ACTIONS(2639),
    [anon_sym_static_assert] = ACTIONS(2639),
    [anon_sym_concept] = ACTIONS(2639),
    [anon_sym_co_return] = ACTIONS(2639),
    [anon_sym_co_yield] = ACTIONS(2639),
    [anon_sym_R_DQUOTE] = ACTIONS(2641),
    [anon_sym_LR_DQUOTE] = ACTIONS(2641),
    [anon_sym_uR_DQUOTE] = ACTIONS(2641),
    [anon_sym_UR_DQUOTE] = ACTIONS(2641),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2641),
    [anon_sym_co_await] = ACTIONS(2639),
    [anon_sym_new] = ACTIONS(2639),
    [anon_sym_requires] = ACTIONS(2639),
    [sym_this] = ACTIONS(2639),
  },
  [478] = {
    [ts_builtin_sym_end] = ACTIONS(2641),
    [sym_identifier] = ACTIONS(2639),
    [aux_sym_preproc_include_token1] = ACTIONS(2639),
    [aux_sym_preproc_def_token1] = ACTIONS(2639),
    [aux_sym_preproc_if_token1] = ACTIONS(2639),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2639),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2639),
    [sym_preproc_directive] = ACTIONS(2639),
    [anon_sym_LPAREN2] = ACTIONS(2641),
    [anon_sym_BANG] = ACTIONS(2641),
    [anon_sym_TILDE] = ACTIONS(2641),
    [anon_sym_DASH] = ACTIONS(2639),
    [anon_sym_PLUS] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(2641),
    [anon_sym_AMP_AMP] = ACTIONS(2641),
    [anon_sym_AMP] = ACTIONS(2639),
    [anon_sym_SEMI] = ACTIONS(2641),
    [anon_sym___extension__] = ACTIONS(2639),
    [anon_sym_typedef] = ACTIONS(2639),
    [anon_sym_extern] = ACTIONS(2639),
    [anon_sym___attribute__] = ACTIONS(2639),
    [anon_sym_COLON_COLON] = ACTIONS(2641),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2641),
    [anon_sym___declspec] = ACTIONS(2639),
    [anon_sym___based] = ACTIONS(2639),
    [anon_sym___cdecl] = ACTIONS(2639),
    [anon_sym___clrcall] = ACTIONS(2639),
    [anon_sym___stdcall] = ACTIONS(2639),
    [anon_sym___fastcall] = ACTIONS(2639),
    [anon_sym___thiscall] = ACTIONS(2639),
    [anon_sym___vectorcall] = ACTIONS(2639),
    [anon_sym_LBRACE] = ACTIONS(2641),
    [anon_sym_signed] = ACTIONS(2639),
    [anon_sym_unsigned] = ACTIONS(2639),
    [anon_sym_long] = ACTIONS(2639),
    [anon_sym_short] = ACTIONS(2639),
    [anon_sym_LBRACK] = ACTIONS(2639),
    [anon_sym_static] = ACTIONS(2639),
    [anon_sym_register] = ACTIONS(2639),
    [anon_sym_inline] = ACTIONS(2639),
    [anon_sym___inline] = ACTIONS(2639),
    [anon_sym___inline__] = ACTIONS(2639),
    [anon_sym___forceinline] = ACTIONS(2639),
    [anon_sym_thread_local] = ACTIONS(2639),
    [anon_sym___thread] = ACTIONS(2639),
    [anon_sym_const] = ACTIONS(2639),
    [anon_sym_constexpr] = ACTIONS(2639),
    [anon_sym_volatile] = ACTIONS(2639),
    [anon_sym_restrict] = ACTIONS(2639),
    [anon_sym___restrict__] = ACTIONS(2639),
    [anon_sym__Atomic] = ACTIONS(2639),
    [anon_sym__Noreturn] = ACTIONS(2639),
    [anon_sym_noreturn] = ACTIONS(2639),
    [anon_sym_mutable] = ACTIONS(2639),
    [anon_sym_constinit] = ACTIONS(2639),
    [anon_sym_consteval] = ACTIONS(2639),
    [anon_sym_PROGMEM] = ACTIONS(2639),
    [aux_sym_primitive_type_token1] = ACTIONS(2639),
    [anon_sym_byte] = ACTIONS(2639),
    [anon_sym_word] = ACTIONS(2639),
    [anon_sym_enum] = ACTIONS(2639),
    [anon_sym_class] = ACTIONS(2639),
    [anon_sym_struct] = ACTIONS(2639),
    [anon_sym_union] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2639),
    [anon_sym_else] = ACTIONS(2639),
    [anon_sym_switch] = ACTIONS(2639),
    [anon_sym_case] = ACTIONS(2639),
    [anon_sym_default] = ACTIONS(2639),
    [anon_sym_while] = ACTIONS(2639),
    [anon_sym_do] = ACTIONS(2639),
    [anon_sym_for] = ACTIONS(2639),
    [anon_sym_return] = ACTIONS(2639),
    [anon_sym_break] = ACTIONS(2639),
    [anon_sym_continue] = ACTIONS(2639),
    [anon_sym_goto] = ACTIONS(2639),
    [anon_sym___try] = ACTIONS(2639),
    [anon_sym___leave] = ACTIONS(2639),
    [anon_sym_not] = ACTIONS(2639),
    [anon_sym_compl] = ACTIONS(2639),
    [anon_sym_DASH_DASH] = ACTIONS(2641),
    [anon_sym_PLUS_PLUS] = ACTIONS(2641),
    [anon_sym_sizeof] = ACTIONS(2639),
    [anon_sym___alignof__] = ACTIONS(2639),
    [anon_sym___alignof] = ACTIONS(2639),
    [anon_sym__alignof] = ACTIONS(2639),
    [anon_sym_alignof] = ACTIONS(2639),
    [anon_sym__Alignof] = ACTIONS(2639),
    [anon_sym_offsetof] = ACTIONS(2639),
    [anon_sym__Generic] = ACTIONS(2639),
    [anon_sym_asm] = ACTIONS(2639),
    [anon_sym___asm__] = ACTIONS(2639),
    [aux_sym_number_literal_token1] = ACTIONS(2641),
    [aux_sym_number_literal_token2] = ACTIONS(2639),
    [anon_sym_L_SQUOTE] = ACTIONS(2641),
    [anon_sym_u_SQUOTE] = ACTIONS(2641),
    [anon_sym_U_SQUOTE] = ACTIONS(2641),
    [anon_sym_u8_SQUOTE] = ACTIONS(2641),
    [anon_sym_SQUOTE] = ACTIONS(2641),
    [anon_sym_L_DQUOTE] = ACTIONS(2641),
    [anon_sym_u_DQUOTE] = ACTIONS(2641),
    [anon_sym_U_DQUOTE] = ACTIONS(2641),
    [anon_sym_u8_DQUOTE] = ACTIONS(2641),
    [anon_sym_DQUOTE] = ACTIONS(2641),
    [sym_true] = ACTIONS(2639),
    [sym_false] = ACTIONS(2639),
    [anon_sym_NULL] = ACTIONS(2639),
    [anon_sym_nullptr] = ACTIONS(2639),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2639),
    [anon_sym_decltype] = ACTIONS(2639),
    [anon_sym_virtual] = ACTIONS(2639),
    [anon_sym_alignas] = ACTIONS(2639),
    [anon_sym_explicit] = ACTIONS(2639),
    [anon_sym_typename] = ACTIONS(2639),
    [anon_sym_template] = ACTIONS(2639),
    [anon_sym_operator] = ACTIONS(2639),
    [anon_sym_try] = ACTIONS(2639),
    [anon_sym_delete] = ACTIONS(2639),
    [anon_sym_throw] = ACTIONS(2639),
    [anon_sym_namespace] = ACTIONS(2639),
    [anon_sym_using] = ACTIONS(2639),
    [anon_sym_static_assert] = ACTIONS(2639),
    [anon_sym_concept] = ACTIONS(2639),
    [anon_sym_co_return] = ACTIONS(2639),
    [anon_sym_co_yield] = ACTIONS(2639),
    [anon_sym_R_DQUOTE] = ACTIONS(2641),
    [anon_sym_LR_DQUOTE] = ACTIONS(2641),
    [anon_sym_uR_DQUOTE] = ACTIONS(2641),
    [anon_sym_UR_DQUOTE] = ACTIONS(2641),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2641),
    [anon_sym_co_await] = ACTIONS(2639),
    [anon_sym_new] = ACTIONS(2639),
    [anon_sym_requires] = ACTIONS(2639),
    [sym_this] = ACTIONS(2639),
  },
  [479] = {
    [sym_identifier] = ACTIONS(2675),
    [aux_sym_preproc_include_token1] = ACTIONS(2675),
    [aux_sym_preproc_def_token1] = ACTIONS(2675),
    [aux_sym_preproc_if_token1] = ACTIONS(2675),
    [aux_sym_preproc_if_token2] = ACTIONS(2675),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2675),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2675),
    [sym_preproc_directive] = ACTIONS(2675),
    [anon_sym_LPAREN2] = ACTIONS(2677),
    [anon_sym_BANG] = ACTIONS(2677),
    [anon_sym_TILDE] = ACTIONS(2677),
    [anon_sym_DASH] = ACTIONS(2675),
    [anon_sym_PLUS] = ACTIONS(2675),
    [anon_sym_STAR] = ACTIONS(2677),
    [anon_sym_AMP_AMP] = ACTIONS(2677),
    [anon_sym_AMP] = ACTIONS(2675),
    [anon_sym_SEMI] = ACTIONS(2677),
    [anon_sym___extension__] = ACTIONS(2675),
    [anon_sym_typedef] = ACTIONS(2675),
    [anon_sym_extern] = ACTIONS(2675),
    [anon_sym___attribute__] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(2677),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2677),
    [anon_sym___declspec] = ACTIONS(2675),
    [anon_sym___based] = ACTIONS(2675),
    [anon_sym___cdecl] = ACTIONS(2675),
    [anon_sym___clrcall] = ACTIONS(2675),
    [anon_sym___stdcall] = ACTIONS(2675),
    [anon_sym___fastcall] = ACTIONS(2675),
    [anon_sym___thiscall] = ACTIONS(2675),
    [anon_sym___vectorcall] = ACTIONS(2675),
    [anon_sym_LBRACE] = ACTIONS(2677),
    [anon_sym_signed] = ACTIONS(2675),
    [anon_sym_unsigned] = ACTIONS(2675),
    [anon_sym_long] = ACTIONS(2675),
    [anon_sym_short] = ACTIONS(2675),
    [anon_sym_LBRACK] = ACTIONS(2675),
    [anon_sym_static] = ACTIONS(2675),
    [anon_sym_register] = ACTIONS(2675),
    [anon_sym_inline] = ACTIONS(2675),
    [anon_sym___inline] = ACTIONS(2675),
    [anon_sym___inline__] = ACTIONS(2675),
    [anon_sym___forceinline] = ACTIONS(2675),
    [anon_sym_thread_local] = ACTIONS(2675),
    [anon_sym___thread] = ACTIONS(2675),
    [anon_sym_const] = ACTIONS(2675),
    [anon_sym_constexpr] = ACTIONS(2675),
    [anon_sym_volatile] = ACTIONS(2675),
    [anon_sym_restrict] = ACTIONS(2675),
    [anon_sym___restrict__] = ACTIONS(2675),
    [anon_sym__Atomic] = ACTIONS(2675),
    [anon_sym__Noreturn] = ACTIONS(2675),
    [anon_sym_noreturn] = ACTIONS(2675),
    [anon_sym_mutable] = ACTIONS(2675),
    [anon_sym_constinit] = ACTIONS(2675),
    [anon_sym_consteval] = ACTIONS(2675),
    [anon_sym_PROGMEM] = ACTIONS(2675),
    [aux_sym_primitive_type_token1] = ACTIONS(2675),
    [anon_sym_byte] = ACTIONS(2675),
    [anon_sym_word] = ACTIONS(2675),
    [anon_sym_enum] = ACTIONS(2675),
    [anon_sym_class] = ACTIONS(2675),
    [anon_sym_struct] = ACTIONS(2675),
    [anon_sym_union] = ACTIONS(2675),
    [anon_sym_if] = ACTIONS(2675),
    [anon_sym_else] = ACTIONS(2675),
    [anon_sym_switch] = ACTIONS(2675),
    [anon_sym_case] = ACTIONS(2675),
    [anon_sym_default] = ACTIONS(2675),
    [anon_sym_while] = ACTIONS(2675),
    [anon_sym_do] = ACTIONS(2675),
    [anon_sym_for] = ACTIONS(2675),
    [anon_sym_return] = ACTIONS(2675),
    [anon_sym_break] = ACTIONS(2675),
    [anon_sym_continue] = ACTIONS(2675),
    [anon_sym_goto] = ACTIONS(2675),
    [anon_sym___try] = ACTIONS(2675),
    [anon_sym___leave] = ACTIONS(2675),
    [anon_sym_not] = ACTIONS(2675),
    [anon_sym_compl] = ACTIONS(2675),
    [anon_sym_DASH_DASH] = ACTIONS(2677),
    [anon_sym_PLUS_PLUS] = ACTIONS(2677),
    [anon_sym_sizeof] = ACTIONS(2675),
    [anon_sym___alignof__] = ACTIONS(2675),
    [anon_sym___alignof] = ACTIONS(2675),
    [anon_sym__alignof] = ACTIONS(2675),
    [anon_sym_alignof] = ACTIONS(2675),
    [anon_sym__Alignof] = ACTIONS(2675),
    [anon_sym_offsetof] = ACTIONS(2675),
    [anon_sym__Generic] = ACTIONS(2675),
    [anon_sym_asm] = ACTIONS(2675),
    [anon_sym___asm__] = ACTIONS(2675),
    [aux_sym_number_literal_token1] = ACTIONS(2677),
    [aux_sym_number_literal_token2] = ACTIONS(2675),
    [anon_sym_L_SQUOTE] = ACTIONS(2677),
    [anon_sym_u_SQUOTE] = ACTIONS(2677),
    [anon_sym_U_SQUOTE] = ACTIONS(2677),
    [anon_sym_u8_SQUOTE] = ACTIONS(2677),
    [anon_sym_SQUOTE] = ACTIONS(2677),
    [anon_sym_L_DQUOTE] = ACTIONS(2677),
    [anon_sym_u_DQUOTE] = ACTIONS(2677),
    [anon_sym_U_DQUOTE] = ACTIONS(2677),
    [anon_sym_u8_DQUOTE] = ACTIONS(2677),
    [anon_sym_DQUOTE] = ACTIONS(2677),
    [sym_true] = ACTIONS(2675),
    [sym_false] = ACTIONS(2675),
    [anon_sym_NULL] = ACTIONS(2675),
    [anon_sym_nullptr] = ACTIONS(2675),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2675),
    [anon_sym_decltype] = ACTIONS(2675),
    [anon_sym_virtual] = ACTIONS(2675),
    [anon_sym_alignas] = ACTIONS(2675),
    [anon_sym_explicit] = ACTIONS(2675),
    [anon_sym_typename] = ACTIONS(2675),
    [anon_sym_template] = ACTIONS(2675),
    [anon_sym_operator] = ACTIONS(2675),
    [anon_sym_try] = ACTIONS(2675),
    [anon_sym_delete] = ACTIONS(2675),
    [anon_sym_throw] = ACTIONS(2675),
    [anon_sym_namespace] = ACTIONS(2675),
    [anon_sym_using] = ACTIONS(2675),
    [anon_sym_static_assert] = ACTIONS(2675),
    [anon_sym_concept] = ACTIONS(2675),
    [anon_sym_co_return] = ACTIONS(2675),
    [anon_sym_co_yield] = ACTIONS(2675),
    [anon_sym_R_DQUOTE] = ACTIONS(2677),
    [anon_sym_LR_DQUOTE] = ACTIONS(2677),
    [anon_sym_uR_DQUOTE] = ACTIONS(2677),
    [anon_sym_UR_DQUOTE] = ACTIONS(2677),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2677),
    [anon_sym_co_await] = ACTIONS(2675),
    [anon_sym_new] = ACTIONS(2675),
    [anon_sym_requires] = ACTIONS(2675),
    [sym_this] = ACTIONS(2675),
  },
  [480] = {
    [ts_builtin_sym_end] = ACTIONS(2733),
    [sym_identifier] = ACTIONS(2731),
    [aux_sym_preproc_include_token1] = ACTIONS(2731),
    [aux_sym_preproc_def_token1] = ACTIONS(2731),
    [aux_sym_preproc_if_token1] = ACTIONS(2731),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2731),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2731),
    [sym_preproc_directive] = ACTIONS(2731),
    [anon_sym_LPAREN2] = ACTIONS(2733),
    [anon_sym_BANG] = ACTIONS(2733),
    [anon_sym_TILDE] = ACTIONS(2733),
    [anon_sym_DASH] = ACTIONS(2731),
    [anon_sym_PLUS] = ACTIONS(2731),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_AMP_AMP] = ACTIONS(2733),
    [anon_sym_AMP] = ACTIONS(2731),
    [anon_sym_SEMI] = ACTIONS(2733),
    [anon_sym___extension__] = ACTIONS(2731),
    [anon_sym_typedef] = ACTIONS(2731),
    [anon_sym_extern] = ACTIONS(2731),
    [anon_sym___attribute__] = ACTIONS(2731),
    [anon_sym_COLON_COLON] = ACTIONS(2733),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2733),
    [anon_sym___declspec] = ACTIONS(2731),
    [anon_sym___based] = ACTIONS(2731),
    [anon_sym___cdecl] = ACTIONS(2731),
    [anon_sym___clrcall] = ACTIONS(2731),
    [anon_sym___stdcall] = ACTIONS(2731),
    [anon_sym___fastcall] = ACTIONS(2731),
    [anon_sym___thiscall] = ACTIONS(2731),
    [anon_sym___vectorcall] = ACTIONS(2731),
    [anon_sym_LBRACE] = ACTIONS(2733),
    [anon_sym_signed] = ACTIONS(2731),
    [anon_sym_unsigned] = ACTIONS(2731),
    [anon_sym_long] = ACTIONS(2731),
    [anon_sym_short] = ACTIONS(2731),
    [anon_sym_LBRACK] = ACTIONS(2731),
    [anon_sym_static] = ACTIONS(2731),
    [anon_sym_register] = ACTIONS(2731),
    [anon_sym_inline] = ACTIONS(2731),
    [anon_sym___inline] = ACTIONS(2731),
    [anon_sym___inline__] = ACTIONS(2731),
    [anon_sym___forceinline] = ACTIONS(2731),
    [anon_sym_thread_local] = ACTIONS(2731),
    [anon_sym___thread] = ACTIONS(2731),
    [anon_sym_const] = ACTIONS(2731),
    [anon_sym_constexpr] = ACTIONS(2731),
    [anon_sym_volatile] = ACTIONS(2731),
    [anon_sym_restrict] = ACTIONS(2731),
    [anon_sym___restrict__] = ACTIONS(2731),
    [anon_sym__Atomic] = ACTIONS(2731),
    [anon_sym__Noreturn] = ACTIONS(2731),
    [anon_sym_noreturn] = ACTIONS(2731),
    [anon_sym_mutable] = ACTIONS(2731),
    [anon_sym_constinit] = ACTIONS(2731),
    [anon_sym_consteval] = ACTIONS(2731),
    [anon_sym_PROGMEM] = ACTIONS(2731),
    [aux_sym_primitive_type_token1] = ACTIONS(2731),
    [anon_sym_byte] = ACTIONS(2731),
    [anon_sym_word] = ACTIONS(2731),
    [anon_sym_enum] = ACTIONS(2731),
    [anon_sym_class] = ACTIONS(2731),
    [anon_sym_struct] = ACTIONS(2731),
    [anon_sym_union] = ACTIONS(2731),
    [anon_sym_if] = ACTIONS(2731),
    [anon_sym_else] = ACTIONS(2731),
    [anon_sym_switch] = ACTIONS(2731),
    [anon_sym_case] = ACTIONS(2731),
    [anon_sym_default] = ACTIONS(2731),
    [anon_sym_while] = ACTIONS(2731),
    [anon_sym_do] = ACTIONS(2731),
    [anon_sym_for] = ACTIONS(2731),
    [anon_sym_return] = ACTIONS(2731),
    [anon_sym_break] = ACTIONS(2731),
    [anon_sym_continue] = ACTIONS(2731),
    [anon_sym_goto] = ACTIONS(2731),
    [anon_sym___try] = ACTIONS(2731),
    [anon_sym___leave] = ACTIONS(2731),
    [anon_sym_not] = ACTIONS(2731),
    [anon_sym_compl] = ACTIONS(2731),
    [anon_sym_DASH_DASH] = ACTIONS(2733),
    [anon_sym_PLUS_PLUS] = ACTIONS(2733),
    [anon_sym_sizeof] = ACTIONS(2731),
    [anon_sym___alignof__] = ACTIONS(2731),
    [anon_sym___alignof] = ACTIONS(2731),
    [anon_sym__alignof] = ACTIONS(2731),
    [anon_sym_alignof] = ACTIONS(2731),
    [anon_sym__Alignof] = ACTIONS(2731),
    [anon_sym_offsetof] = ACTIONS(2731),
    [anon_sym__Generic] = ACTIONS(2731),
    [anon_sym_asm] = ACTIONS(2731),
    [anon_sym___asm__] = ACTIONS(2731),
    [aux_sym_number_literal_token1] = ACTIONS(2733),
    [aux_sym_number_literal_token2] = ACTIONS(2731),
    [anon_sym_L_SQUOTE] = ACTIONS(2733),
    [anon_sym_u_SQUOTE] = ACTIONS(2733),
    [anon_sym_U_SQUOTE] = ACTIONS(2733),
    [anon_sym_u8_SQUOTE] = ACTIONS(2733),
    [anon_sym_SQUOTE] = ACTIONS(2733),
    [anon_sym_L_DQUOTE] = ACTIONS(2733),
    [anon_sym_u_DQUOTE] = ACTIONS(2733),
    [anon_sym_U_DQUOTE] = ACTIONS(2733),
    [anon_sym_u8_DQUOTE] = ACTIONS(2733),
    [anon_sym_DQUOTE] = ACTIONS(2733),
    [sym_true] = ACTIONS(2731),
    [sym_false] = ACTIONS(2731),
    [anon_sym_NULL] = ACTIONS(2731),
    [anon_sym_nullptr] = ACTIONS(2731),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2731),
    [anon_sym_decltype] = ACTIONS(2731),
    [anon_sym_virtual] = ACTIONS(2731),
    [anon_sym_alignas] = ACTIONS(2731),
    [anon_sym_explicit] = ACTIONS(2731),
    [anon_sym_typename] = ACTIONS(2731),
    [anon_sym_template] = ACTIONS(2731),
    [anon_sym_operator] = ACTIONS(2731),
    [anon_sym_try] = ACTIONS(2731),
    [anon_sym_delete] = ACTIONS(2731),
    [anon_sym_throw] = ACTIONS(2731),
    [anon_sym_namespace] = ACTIONS(2731),
    [anon_sym_using] = ACTIONS(2731),
    [anon_sym_static_assert] = ACTIONS(2731),
    [anon_sym_concept] = ACTIONS(2731),
    [anon_sym_co_return] = ACTIONS(2731),
    [anon_sym_co_yield] = ACTIONS(2731),
    [anon_sym_R_DQUOTE] = ACTIONS(2733),
    [anon_sym_LR_DQUOTE] = ACTIONS(2733),
    [anon_sym_uR_DQUOTE] = ACTIONS(2733),
    [anon_sym_UR_DQUOTE] = ACTIONS(2733),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2733),
    [anon_sym_co_await] = ACTIONS(2731),
    [anon_sym_new] = ACTIONS(2731),
    [anon_sym_requires] = ACTIONS(2731),
    [sym_this] = ACTIONS(2731),
  },
  [481] = {
    [ts_builtin_sym_end] = ACTIONS(2562),
    [sym_identifier] = ACTIONS(2557),
    [aux_sym_preproc_include_token1] = ACTIONS(2557),
    [aux_sym_preproc_def_token1] = ACTIONS(2557),
    [aux_sym_preproc_if_token1] = ACTIONS(2557),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2557),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2557),
    [sym_preproc_directive] = ACTIONS(2557),
    [anon_sym_LPAREN2] = ACTIONS(2562),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2557),
    [anon_sym_PLUS] = ACTIONS(2557),
    [anon_sym_STAR] = ACTIONS(2562),
    [anon_sym_AMP_AMP] = ACTIONS(2562),
    [anon_sym_AMP] = ACTIONS(2557),
    [anon_sym_SEMI] = ACTIONS(2562),
    [anon_sym___extension__] = ACTIONS(2557),
    [anon_sym_typedef] = ACTIONS(2557),
    [anon_sym_extern] = ACTIONS(2557),
    [anon_sym___attribute__] = ACTIONS(2557),
    [anon_sym_COLON_COLON] = ACTIONS(2562),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2562),
    [anon_sym___declspec] = ACTIONS(2557),
    [anon_sym___based] = ACTIONS(2557),
    [anon_sym___cdecl] = ACTIONS(2557),
    [anon_sym___clrcall] = ACTIONS(2557),
    [anon_sym___stdcall] = ACTIONS(2557),
    [anon_sym___fastcall] = ACTIONS(2557),
    [anon_sym___thiscall] = ACTIONS(2557),
    [anon_sym___vectorcall] = ACTIONS(2557),
    [anon_sym_LBRACE] = ACTIONS(2562),
    [anon_sym_signed] = ACTIONS(2557),
    [anon_sym_unsigned] = ACTIONS(2557),
    [anon_sym_long] = ACTIONS(2557),
    [anon_sym_short] = ACTIONS(2557),
    [anon_sym_LBRACK] = ACTIONS(2557),
    [anon_sym_static] = ACTIONS(2557),
    [anon_sym_register] = ACTIONS(2557),
    [anon_sym_inline] = ACTIONS(2557),
    [anon_sym___inline] = ACTIONS(2557),
    [anon_sym___inline__] = ACTIONS(2557),
    [anon_sym___forceinline] = ACTIONS(2557),
    [anon_sym_thread_local] = ACTIONS(2557),
    [anon_sym___thread] = ACTIONS(2557),
    [anon_sym_const] = ACTIONS(2557),
    [anon_sym_constexpr] = ACTIONS(2557),
    [anon_sym_volatile] = ACTIONS(2557),
    [anon_sym_restrict] = ACTIONS(2557),
    [anon_sym___restrict__] = ACTIONS(2557),
    [anon_sym__Atomic] = ACTIONS(2557),
    [anon_sym__Noreturn] = ACTIONS(2557),
    [anon_sym_noreturn] = ACTIONS(2557),
    [anon_sym_mutable] = ACTIONS(2557),
    [anon_sym_constinit] = ACTIONS(2557),
    [anon_sym_consteval] = ACTIONS(2557),
    [anon_sym_PROGMEM] = ACTIONS(2557),
    [aux_sym_primitive_type_token1] = ACTIONS(2557),
    [anon_sym_byte] = ACTIONS(2557),
    [anon_sym_word] = ACTIONS(2557),
    [anon_sym_enum] = ACTIONS(2557),
    [anon_sym_class] = ACTIONS(2557),
    [anon_sym_struct] = ACTIONS(2557),
    [anon_sym_union] = ACTIONS(2557),
    [anon_sym_if] = ACTIONS(2557),
    [anon_sym_else] = ACTIONS(2557),
    [anon_sym_switch] = ACTIONS(2557),
    [anon_sym_case] = ACTIONS(2557),
    [anon_sym_default] = ACTIONS(2557),
    [anon_sym_while] = ACTIONS(2557),
    [anon_sym_do] = ACTIONS(2557),
    [anon_sym_for] = ACTIONS(2557),
    [anon_sym_return] = ACTIONS(2557),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_continue] = ACTIONS(2557),
    [anon_sym_goto] = ACTIONS(2557),
    [anon_sym___try] = ACTIONS(2557),
    [anon_sym___leave] = ACTIONS(2557),
    [anon_sym_not] = ACTIONS(2557),
    [anon_sym_compl] = ACTIONS(2557),
    [anon_sym_DASH_DASH] = ACTIONS(2562),
    [anon_sym_PLUS_PLUS] = ACTIONS(2562),
    [anon_sym_sizeof] = ACTIONS(2557),
    [anon_sym___alignof__] = ACTIONS(2557),
    [anon_sym___alignof] = ACTIONS(2557),
    [anon_sym__alignof] = ACTIONS(2557),
    [anon_sym_alignof] = ACTIONS(2557),
    [anon_sym__Alignof] = ACTIONS(2557),
    [anon_sym_offsetof] = ACTIONS(2557),
    [anon_sym__Generic] = ACTIONS(2557),
    [anon_sym_asm] = ACTIONS(2557),
    [anon_sym___asm__] = ACTIONS(2557),
    [aux_sym_number_literal_token1] = ACTIONS(2562),
    [aux_sym_number_literal_token2] = ACTIONS(2557),
    [anon_sym_L_SQUOTE] = ACTIONS(2562),
    [anon_sym_u_SQUOTE] = ACTIONS(2562),
    [anon_sym_U_SQUOTE] = ACTIONS(2562),
    [anon_sym_u8_SQUOTE] = ACTIONS(2562),
    [anon_sym_SQUOTE] = ACTIONS(2562),
    [anon_sym_L_DQUOTE] = ACTIONS(2562),
    [anon_sym_u_DQUOTE] = ACTIONS(2562),
    [anon_sym_U_DQUOTE] = ACTIONS(2562),
    [anon_sym_u8_DQUOTE] = ACTIONS(2562),
    [anon_sym_DQUOTE] = ACTIONS(2562),
    [sym_true] = ACTIONS(2557),
    [sym_false] = ACTIONS(2557),
    [anon_sym_NULL] = ACTIONS(2557),
    [anon_sym_nullptr] = ACTIONS(2557),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2557),
    [anon_sym_decltype] = ACTIONS(2557),
    [anon_sym_virtual] = ACTIONS(2557),
    [anon_sym_alignas] = ACTIONS(2557),
    [anon_sym_explicit] = ACTIONS(2557),
    [anon_sym_typename] = ACTIONS(2557),
    [anon_sym_template] = ACTIONS(2557),
    [anon_sym_operator] = ACTIONS(2557),
    [anon_sym_try] = ACTIONS(2557),
    [anon_sym_delete] = ACTIONS(2557),
    [anon_sym_throw] = ACTIONS(2557),
    [anon_sym_namespace] = ACTIONS(2557),
    [anon_sym_using] = ACTIONS(2557),
    [anon_sym_static_assert] = ACTIONS(2557),
    [anon_sym_concept] = ACTIONS(2557),
    [anon_sym_co_return] = ACTIONS(2557),
    [anon_sym_co_yield] = ACTIONS(2557),
    [anon_sym_R_DQUOTE] = ACTIONS(2562),
    [anon_sym_LR_DQUOTE] = ACTIONS(2562),
    [anon_sym_uR_DQUOTE] = ACTIONS(2562),
    [anon_sym_UR_DQUOTE] = ACTIONS(2562),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2562),
    [anon_sym_co_await] = ACTIONS(2557),
    [anon_sym_new] = ACTIONS(2557),
    [anon_sym_requires] = ACTIONS(2557),
    [sym_this] = ACTIONS(2557),
  },
  [482] = {
    [ts_builtin_sym_end] = ACTIONS(2645),
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [483] = {
    [ts_builtin_sym_end] = ACTIONS(2681),
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [484] = {
    [ts_builtin_sym_end] = ACTIONS(2645),
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [485] = {
    [sym_identifier] = ACTIONS(2653),
    [aux_sym_preproc_include_token1] = ACTIONS(2653),
    [aux_sym_preproc_def_token1] = ACTIONS(2653),
    [aux_sym_preproc_if_token1] = ACTIONS(2653),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2653),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2653),
    [sym_preproc_directive] = ACTIONS(2653),
    [anon_sym_LPAREN2] = ACTIONS(2655),
    [anon_sym_BANG] = ACTIONS(2655),
    [anon_sym_TILDE] = ACTIONS(2655),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_AMP_AMP] = ACTIONS(2655),
    [anon_sym_AMP] = ACTIONS(2653),
    [anon_sym_SEMI] = ACTIONS(2655),
    [anon_sym___extension__] = ACTIONS(2653),
    [anon_sym_typedef] = ACTIONS(2653),
    [anon_sym_extern] = ACTIONS(2653),
    [anon_sym___attribute__] = ACTIONS(2653),
    [anon_sym_COLON_COLON] = ACTIONS(2655),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2655),
    [anon_sym___declspec] = ACTIONS(2653),
    [anon_sym___based] = ACTIONS(2653),
    [anon_sym___cdecl] = ACTIONS(2653),
    [anon_sym___clrcall] = ACTIONS(2653),
    [anon_sym___stdcall] = ACTIONS(2653),
    [anon_sym___fastcall] = ACTIONS(2653),
    [anon_sym___thiscall] = ACTIONS(2653),
    [anon_sym___vectorcall] = ACTIONS(2653),
    [anon_sym_LBRACE] = ACTIONS(2655),
    [anon_sym_RBRACE] = ACTIONS(2655),
    [anon_sym_signed] = ACTIONS(2653),
    [anon_sym_unsigned] = ACTIONS(2653),
    [anon_sym_long] = ACTIONS(2653),
    [anon_sym_short] = ACTIONS(2653),
    [anon_sym_LBRACK] = ACTIONS(2653),
    [anon_sym_static] = ACTIONS(2653),
    [anon_sym_register] = ACTIONS(2653),
    [anon_sym_inline] = ACTIONS(2653),
    [anon_sym___inline] = ACTIONS(2653),
    [anon_sym___inline__] = ACTIONS(2653),
    [anon_sym___forceinline] = ACTIONS(2653),
    [anon_sym_thread_local] = ACTIONS(2653),
    [anon_sym___thread] = ACTIONS(2653),
    [anon_sym_const] = ACTIONS(2653),
    [anon_sym_constexpr] = ACTIONS(2653),
    [anon_sym_volatile] = ACTIONS(2653),
    [anon_sym_restrict] = ACTIONS(2653),
    [anon_sym___restrict__] = ACTIONS(2653),
    [anon_sym__Atomic] = ACTIONS(2653),
    [anon_sym__Noreturn] = ACTIONS(2653),
    [anon_sym_noreturn] = ACTIONS(2653),
    [anon_sym_mutable] = ACTIONS(2653),
    [anon_sym_constinit] = ACTIONS(2653),
    [anon_sym_consteval] = ACTIONS(2653),
    [anon_sym_PROGMEM] = ACTIONS(2653),
    [aux_sym_primitive_type_token1] = ACTIONS(2653),
    [anon_sym_byte] = ACTIONS(2653),
    [anon_sym_word] = ACTIONS(2653),
    [anon_sym_enum] = ACTIONS(2653),
    [anon_sym_class] = ACTIONS(2653),
    [anon_sym_struct] = ACTIONS(2653),
    [anon_sym_union] = ACTIONS(2653),
    [anon_sym_if] = ACTIONS(2653),
    [anon_sym_else] = ACTIONS(2653),
    [anon_sym_switch] = ACTIONS(2653),
    [anon_sym_case] = ACTIONS(2653),
    [anon_sym_default] = ACTIONS(2653),
    [anon_sym_while] = ACTIONS(2653),
    [anon_sym_do] = ACTIONS(2653),
    [anon_sym_for] = ACTIONS(2653),
    [anon_sym_return] = ACTIONS(2653),
    [anon_sym_break] = ACTIONS(2653),
    [anon_sym_continue] = ACTIONS(2653),
    [anon_sym_goto] = ACTIONS(2653),
    [anon_sym___try] = ACTIONS(2653),
    [anon_sym___leave] = ACTIONS(2653),
    [anon_sym_not] = ACTIONS(2653),
    [anon_sym_compl] = ACTIONS(2653),
    [anon_sym_DASH_DASH] = ACTIONS(2655),
    [anon_sym_PLUS_PLUS] = ACTIONS(2655),
    [anon_sym_sizeof] = ACTIONS(2653),
    [anon_sym___alignof__] = ACTIONS(2653),
    [anon_sym___alignof] = ACTIONS(2653),
    [anon_sym__alignof] = ACTIONS(2653),
    [anon_sym_alignof] = ACTIONS(2653),
    [anon_sym__Alignof] = ACTIONS(2653),
    [anon_sym_offsetof] = ACTIONS(2653),
    [anon_sym__Generic] = ACTIONS(2653),
    [anon_sym_asm] = ACTIONS(2653),
    [anon_sym___asm__] = ACTIONS(2653),
    [aux_sym_number_literal_token1] = ACTIONS(2655),
    [aux_sym_number_literal_token2] = ACTIONS(2653),
    [anon_sym_L_SQUOTE] = ACTIONS(2655),
    [anon_sym_u_SQUOTE] = ACTIONS(2655),
    [anon_sym_U_SQUOTE] = ACTIONS(2655),
    [anon_sym_u8_SQUOTE] = ACTIONS(2655),
    [anon_sym_SQUOTE] = ACTIONS(2655),
    [anon_sym_L_DQUOTE] = ACTIONS(2655),
    [anon_sym_u_DQUOTE] = ACTIONS(2655),
    [anon_sym_U_DQUOTE] = ACTIONS(2655),
    [anon_sym_u8_DQUOTE] = ACTIONS(2655),
    [anon_sym_DQUOTE] = ACTIONS(2655),
    [sym_true] = ACTIONS(2653),
    [sym_false] = ACTIONS(2653),
    [anon_sym_NULL] = ACTIONS(2653),
    [anon_sym_nullptr] = ACTIONS(2653),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2653),
    [anon_sym_decltype] = ACTIONS(2653),
    [anon_sym_virtual] = ACTIONS(2653),
    [anon_sym_alignas] = ACTIONS(2653),
    [anon_sym_explicit] = ACTIONS(2653),
    [anon_sym_typename] = ACTIONS(2653),
    [anon_sym_template] = ACTIONS(2653),
    [anon_sym_operator] = ACTIONS(2653),
    [anon_sym_try] = ACTIONS(2653),
    [anon_sym_delete] = ACTIONS(2653),
    [anon_sym_throw] = ACTIONS(2653),
    [anon_sym_namespace] = ACTIONS(2653),
    [anon_sym_using] = ACTIONS(2653),
    [anon_sym_static_assert] = ACTIONS(2653),
    [anon_sym_concept] = ACTIONS(2653),
    [anon_sym_co_return] = ACTIONS(2653),
    [anon_sym_co_yield] = ACTIONS(2653),
    [anon_sym_R_DQUOTE] = ACTIONS(2655),
    [anon_sym_LR_DQUOTE] = ACTIONS(2655),
    [anon_sym_uR_DQUOTE] = ACTIONS(2655),
    [anon_sym_UR_DQUOTE] = ACTIONS(2655),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2655),
    [anon_sym_co_await] = ACTIONS(2653),
    [anon_sym_new] = ACTIONS(2653),
    [anon_sym_requires] = ACTIONS(2653),
    [sym_this] = ACTIONS(2653),
  },
  [486] = {
    [ts_builtin_sym_end] = ACTIONS(2681),
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [487] = {
    [ts_builtin_sym_end] = ACTIONS(2645),
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [488] = {
    [sym_identifier] = ACTIONS(2657),
    [aux_sym_preproc_include_token1] = ACTIONS(2657),
    [aux_sym_preproc_def_token1] = ACTIONS(2657),
    [aux_sym_preproc_if_token1] = ACTIONS(2657),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2657),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2657),
    [sym_preproc_directive] = ACTIONS(2657),
    [anon_sym_LPAREN2] = ACTIONS(2659),
    [anon_sym_BANG] = ACTIONS(2659),
    [anon_sym_TILDE] = ACTIONS(2659),
    [anon_sym_DASH] = ACTIONS(2657),
    [anon_sym_PLUS] = ACTIONS(2657),
    [anon_sym_STAR] = ACTIONS(2659),
    [anon_sym_AMP_AMP] = ACTIONS(2659),
    [anon_sym_AMP] = ACTIONS(2657),
    [anon_sym_SEMI] = ACTIONS(2659),
    [anon_sym___extension__] = ACTIONS(2657),
    [anon_sym_typedef] = ACTIONS(2657),
    [anon_sym_extern] = ACTIONS(2657),
    [anon_sym___attribute__] = ACTIONS(2657),
    [anon_sym_COLON_COLON] = ACTIONS(2659),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2659),
    [anon_sym___declspec] = ACTIONS(2657),
    [anon_sym___based] = ACTIONS(2657),
    [anon_sym___cdecl] = ACTIONS(2657),
    [anon_sym___clrcall] = ACTIONS(2657),
    [anon_sym___stdcall] = ACTIONS(2657),
    [anon_sym___fastcall] = ACTIONS(2657),
    [anon_sym___thiscall] = ACTIONS(2657),
    [anon_sym___vectorcall] = ACTIONS(2657),
    [anon_sym_LBRACE] = ACTIONS(2659),
    [anon_sym_RBRACE] = ACTIONS(2659),
    [anon_sym_signed] = ACTIONS(2657),
    [anon_sym_unsigned] = ACTIONS(2657),
    [anon_sym_long] = ACTIONS(2657),
    [anon_sym_short] = ACTIONS(2657),
    [anon_sym_LBRACK] = ACTIONS(2657),
    [anon_sym_static] = ACTIONS(2657),
    [anon_sym_register] = ACTIONS(2657),
    [anon_sym_inline] = ACTIONS(2657),
    [anon_sym___inline] = ACTIONS(2657),
    [anon_sym___inline__] = ACTIONS(2657),
    [anon_sym___forceinline] = ACTIONS(2657),
    [anon_sym_thread_local] = ACTIONS(2657),
    [anon_sym___thread] = ACTIONS(2657),
    [anon_sym_const] = ACTIONS(2657),
    [anon_sym_constexpr] = ACTIONS(2657),
    [anon_sym_volatile] = ACTIONS(2657),
    [anon_sym_restrict] = ACTIONS(2657),
    [anon_sym___restrict__] = ACTIONS(2657),
    [anon_sym__Atomic] = ACTIONS(2657),
    [anon_sym__Noreturn] = ACTIONS(2657),
    [anon_sym_noreturn] = ACTIONS(2657),
    [anon_sym_mutable] = ACTIONS(2657),
    [anon_sym_constinit] = ACTIONS(2657),
    [anon_sym_consteval] = ACTIONS(2657),
    [anon_sym_PROGMEM] = ACTIONS(2657),
    [aux_sym_primitive_type_token1] = ACTIONS(2657),
    [anon_sym_byte] = ACTIONS(2657),
    [anon_sym_word] = ACTIONS(2657),
    [anon_sym_enum] = ACTIONS(2657),
    [anon_sym_class] = ACTIONS(2657),
    [anon_sym_struct] = ACTIONS(2657),
    [anon_sym_union] = ACTIONS(2657),
    [anon_sym_if] = ACTIONS(2657),
    [anon_sym_else] = ACTIONS(2657),
    [anon_sym_switch] = ACTIONS(2657),
    [anon_sym_case] = ACTIONS(2657),
    [anon_sym_default] = ACTIONS(2657),
    [anon_sym_while] = ACTIONS(2657),
    [anon_sym_do] = ACTIONS(2657),
    [anon_sym_for] = ACTIONS(2657),
    [anon_sym_return] = ACTIONS(2657),
    [anon_sym_break] = ACTIONS(2657),
    [anon_sym_continue] = ACTIONS(2657),
    [anon_sym_goto] = ACTIONS(2657),
    [anon_sym___try] = ACTIONS(2657),
    [anon_sym___leave] = ACTIONS(2657),
    [anon_sym_not] = ACTIONS(2657),
    [anon_sym_compl] = ACTIONS(2657),
    [anon_sym_DASH_DASH] = ACTIONS(2659),
    [anon_sym_PLUS_PLUS] = ACTIONS(2659),
    [anon_sym_sizeof] = ACTIONS(2657),
    [anon_sym___alignof__] = ACTIONS(2657),
    [anon_sym___alignof] = ACTIONS(2657),
    [anon_sym__alignof] = ACTIONS(2657),
    [anon_sym_alignof] = ACTIONS(2657),
    [anon_sym__Alignof] = ACTIONS(2657),
    [anon_sym_offsetof] = ACTIONS(2657),
    [anon_sym__Generic] = ACTIONS(2657),
    [anon_sym_asm] = ACTIONS(2657),
    [anon_sym___asm__] = ACTIONS(2657),
    [aux_sym_number_literal_token1] = ACTIONS(2659),
    [aux_sym_number_literal_token2] = ACTIONS(2657),
    [anon_sym_L_SQUOTE] = ACTIONS(2659),
    [anon_sym_u_SQUOTE] = ACTIONS(2659),
    [anon_sym_U_SQUOTE] = ACTIONS(2659),
    [anon_sym_u8_SQUOTE] = ACTIONS(2659),
    [anon_sym_SQUOTE] = ACTIONS(2659),
    [anon_sym_L_DQUOTE] = ACTIONS(2659),
    [anon_sym_u_DQUOTE] = ACTIONS(2659),
    [anon_sym_U_DQUOTE] = ACTIONS(2659),
    [anon_sym_u8_DQUOTE] = ACTIONS(2659),
    [anon_sym_DQUOTE] = ACTIONS(2659),
    [sym_true] = ACTIONS(2657),
    [sym_false] = ACTIONS(2657),
    [anon_sym_NULL] = ACTIONS(2657),
    [anon_sym_nullptr] = ACTIONS(2657),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2657),
    [anon_sym_decltype] = ACTIONS(2657),
    [anon_sym_virtual] = ACTIONS(2657),
    [anon_sym_alignas] = ACTIONS(2657),
    [anon_sym_explicit] = ACTIONS(2657),
    [anon_sym_typename] = ACTIONS(2657),
    [anon_sym_template] = ACTIONS(2657),
    [anon_sym_operator] = ACTIONS(2657),
    [anon_sym_try] = ACTIONS(2657),
    [anon_sym_delete] = ACTIONS(2657),
    [anon_sym_throw] = ACTIONS(2657),
    [anon_sym_namespace] = ACTIONS(2657),
    [anon_sym_using] = ACTIONS(2657),
    [anon_sym_static_assert] = ACTIONS(2657),
    [anon_sym_concept] = ACTIONS(2657),
    [anon_sym_co_return] = ACTIONS(2657),
    [anon_sym_co_yield] = ACTIONS(2657),
    [anon_sym_R_DQUOTE] = ACTIONS(2659),
    [anon_sym_LR_DQUOTE] = ACTIONS(2659),
    [anon_sym_uR_DQUOTE] = ACTIONS(2659),
    [anon_sym_UR_DQUOTE] = ACTIONS(2659),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2659),
    [anon_sym_co_await] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(2657),
    [anon_sym_requires] = ACTIONS(2657),
    [sym_this] = ACTIONS(2657),
  },
  [489] = {
    [sym_identifier] = ACTIONS(2661),
    [aux_sym_preproc_include_token1] = ACTIONS(2661),
    [aux_sym_preproc_def_token1] = ACTIONS(2661),
    [aux_sym_preproc_if_token1] = ACTIONS(2661),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2661),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2661),
    [sym_preproc_directive] = ACTIONS(2661),
    [anon_sym_LPAREN2] = ACTIONS(2663),
    [anon_sym_BANG] = ACTIONS(2663),
    [anon_sym_TILDE] = ACTIONS(2663),
    [anon_sym_DASH] = ACTIONS(2661),
    [anon_sym_PLUS] = ACTIONS(2661),
    [anon_sym_STAR] = ACTIONS(2663),
    [anon_sym_AMP_AMP] = ACTIONS(2663),
    [anon_sym_AMP] = ACTIONS(2661),
    [anon_sym_SEMI] = ACTIONS(2663),
    [anon_sym___extension__] = ACTIONS(2661),
    [anon_sym_typedef] = ACTIONS(2661),
    [anon_sym_extern] = ACTIONS(2661),
    [anon_sym___attribute__] = ACTIONS(2661),
    [anon_sym_COLON_COLON] = ACTIONS(2663),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2663),
    [anon_sym___declspec] = ACTIONS(2661),
    [anon_sym___based] = ACTIONS(2661),
    [anon_sym___cdecl] = ACTIONS(2661),
    [anon_sym___clrcall] = ACTIONS(2661),
    [anon_sym___stdcall] = ACTIONS(2661),
    [anon_sym___fastcall] = ACTIONS(2661),
    [anon_sym___thiscall] = ACTIONS(2661),
    [anon_sym___vectorcall] = ACTIONS(2661),
    [anon_sym_LBRACE] = ACTIONS(2663),
    [anon_sym_RBRACE] = ACTIONS(2663),
    [anon_sym_signed] = ACTIONS(2661),
    [anon_sym_unsigned] = ACTIONS(2661),
    [anon_sym_long] = ACTIONS(2661),
    [anon_sym_short] = ACTIONS(2661),
    [anon_sym_LBRACK] = ACTIONS(2661),
    [anon_sym_static] = ACTIONS(2661),
    [anon_sym_register] = ACTIONS(2661),
    [anon_sym_inline] = ACTIONS(2661),
    [anon_sym___inline] = ACTIONS(2661),
    [anon_sym___inline__] = ACTIONS(2661),
    [anon_sym___forceinline] = ACTIONS(2661),
    [anon_sym_thread_local] = ACTIONS(2661),
    [anon_sym___thread] = ACTIONS(2661),
    [anon_sym_const] = ACTIONS(2661),
    [anon_sym_constexpr] = ACTIONS(2661),
    [anon_sym_volatile] = ACTIONS(2661),
    [anon_sym_restrict] = ACTIONS(2661),
    [anon_sym___restrict__] = ACTIONS(2661),
    [anon_sym__Atomic] = ACTIONS(2661),
    [anon_sym__Noreturn] = ACTIONS(2661),
    [anon_sym_noreturn] = ACTIONS(2661),
    [anon_sym_mutable] = ACTIONS(2661),
    [anon_sym_constinit] = ACTIONS(2661),
    [anon_sym_consteval] = ACTIONS(2661),
    [anon_sym_PROGMEM] = ACTIONS(2661),
    [aux_sym_primitive_type_token1] = ACTIONS(2661),
    [anon_sym_byte] = ACTIONS(2661),
    [anon_sym_word] = ACTIONS(2661),
    [anon_sym_enum] = ACTIONS(2661),
    [anon_sym_class] = ACTIONS(2661),
    [anon_sym_struct] = ACTIONS(2661),
    [anon_sym_union] = ACTIONS(2661),
    [anon_sym_if] = ACTIONS(2661),
    [anon_sym_else] = ACTIONS(2661),
    [anon_sym_switch] = ACTIONS(2661),
    [anon_sym_case] = ACTIONS(2661),
    [anon_sym_default] = ACTIONS(2661),
    [anon_sym_while] = ACTIONS(2661),
    [anon_sym_do] = ACTIONS(2661),
    [anon_sym_for] = ACTIONS(2661),
    [anon_sym_return] = ACTIONS(2661),
    [anon_sym_break] = ACTIONS(2661),
    [anon_sym_continue] = ACTIONS(2661),
    [anon_sym_goto] = ACTIONS(2661),
    [anon_sym___try] = ACTIONS(2661),
    [anon_sym___leave] = ACTIONS(2661),
    [anon_sym_not] = ACTIONS(2661),
    [anon_sym_compl] = ACTIONS(2661),
    [anon_sym_DASH_DASH] = ACTIONS(2663),
    [anon_sym_PLUS_PLUS] = ACTIONS(2663),
    [anon_sym_sizeof] = ACTIONS(2661),
    [anon_sym___alignof__] = ACTIONS(2661),
    [anon_sym___alignof] = ACTIONS(2661),
    [anon_sym__alignof] = ACTIONS(2661),
    [anon_sym_alignof] = ACTIONS(2661),
    [anon_sym__Alignof] = ACTIONS(2661),
    [anon_sym_offsetof] = ACTIONS(2661),
    [anon_sym__Generic] = ACTIONS(2661),
    [anon_sym_asm] = ACTIONS(2661),
    [anon_sym___asm__] = ACTIONS(2661),
    [aux_sym_number_literal_token1] = ACTIONS(2663),
    [aux_sym_number_literal_token2] = ACTIONS(2661),
    [anon_sym_L_SQUOTE] = ACTIONS(2663),
    [anon_sym_u_SQUOTE] = ACTIONS(2663),
    [anon_sym_U_SQUOTE] = ACTIONS(2663),
    [anon_sym_u8_SQUOTE] = ACTIONS(2663),
    [anon_sym_SQUOTE] = ACTIONS(2663),
    [anon_sym_L_DQUOTE] = ACTIONS(2663),
    [anon_sym_u_DQUOTE] = ACTIONS(2663),
    [anon_sym_U_DQUOTE] = ACTIONS(2663),
    [anon_sym_u8_DQUOTE] = ACTIONS(2663),
    [anon_sym_DQUOTE] = ACTIONS(2663),
    [sym_true] = ACTIONS(2661),
    [sym_false] = ACTIONS(2661),
    [anon_sym_NULL] = ACTIONS(2661),
    [anon_sym_nullptr] = ACTIONS(2661),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2661),
    [anon_sym_decltype] = ACTIONS(2661),
    [anon_sym_virtual] = ACTIONS(2661),
    [anon_sym_alignas] = ACTIONS(2661),
    [anon_sym_explicit] = ACTIONS(2661),
    [anon_sym_typename] = ACTIONS(2661),
    [anon_sym_template] = ACTIONS(2661),
    [anon_sym_operator] = ACTIONS(2661),
    [anon_sym_try] = ACTIONS(2661),
    [anon_sym_delete] = ACTIONS(2661),
    [anon_sym_throw] = ACTIONS(2661),
    [anon_sym_namespace] = ACTIONS(2661),
    [anon_sym_using] = ACTIONS(2661),
    [anon_sym_static_assert] = ACTIONS(2661),
    [anon_sym_concept] = ACTIONS(2661),
    [anon_sym_co_return] = ACTIONS(2661),
    [anon_sym_co_yield] = ACTIONS(2661),
    [anon_sym_R_DQUOTE] = ACTIONS(2663),
    [anon_sym_LR_DQUOTE] = ACTIONS(2663),
    [anon_sym_uR_DQUOTE] = ACTIONS(2663),
    [anon_sym_UR_DQUOTE] = ACTIONS(2663),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2663),
    [anon_sym_co_await] = ACTIONS(2661),
    [anon_sym_new] = ACTIONS(2661),
    [anon_sym_requires] = ACTIONS(2661),
    [sym_this] = ACTIONS(2661),
  },
  [490] = {
    [ts_builtin_sym_end] = ACTIONS(2681),
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [491] = {
    [sym_identifier] = ACTIONS(2665),
    [aux_sym_preproc_include_token1] = ACTIONS(2665),
    [aux_sym_preproc_def_token1] = ACTIONS(2665),
    [aux_sym_preproc_if_token1] = ACTIONS(2665),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2665),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2665),
    [sym_preproc_directive] = ACTIONS(2665),
    [anon_sym_LPAREN2] = ACTIONS(2667),
    [anon_sym_BANG] = ACTIONS(2667),
    [anon_sym_TILDE] = ACTIONS(2667),
    [anon_sym_DASH] = ACTIONS(2665),
    [anon_sym_PLUS] = ACTIONS(2665),
    [anon_sym_STAR] = ACTIONS(2667),
    [anon_sym_AMP_AMP] = ACTIONS(2667),
    [anon_sym_AMP] = ACTIONS(2665),
    [anon_sym_SEMI] = ACTIONS(2667),
    [anon_sym___extension__] = ACTIONS(2665),
    [anon_sym_typedef] = ACTIONS(2665),
    [anon_sym_extern] = ACTIONS(2665),
    [anon_sym___attribute__] = ACTIONS(2665),
    [anon_sym_COLON_COLON] = ACTIONS(2667),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2667),
    [anon_sym___declspec] = ACTIONS(2665),
    [anon_sym___based] = ACTIONS(2665),
    [anon_sym___cdecl] = ACTIONS(2665),
    [anon_sym___clrcall] = ACTIONS(2665),
    [anon_sym___stdcall] = ACTIONS(2665),
    [anon_sym___fastcall] = ACTIONS(2665),
    [anon_sym___thiscall] = ACTIONS(2665),
    [anon_sym___vectorcall] = ACTIONS(2665),
    [anon_sym_LBRACE] = ACTIONS(2667),
    [anon_sym_RBRACE] = ACTIONS(2667),
    [anon_sym_signed] = ACTIONS(2665),
    [anon_sym_unsigned] = ACTIONS(2665),
    [anon_sym_long] = ACTIONS(2665),
    [anon_sym_short] = ACTIONS(2665),
    [anon_sym_LBRACK] = ACTIONS(2665),
    [anon_sym_static] = ACTIONS(2665),
    [anon_sym_register] = ACTIONS(2665),
    [anon_sym_inline] = ACTIONS(2665),
    [anon_sym___inline] = ACTIONS(2665),
    [anon_sym___inline__] = ACTIONS(2665),
    [anon_sym___forceinline] = ACTIONS(2665),
    [anon_sym_thread_local] = ACTIONS(2665),
    [anon_sym___thread] = ACTIONS(2665),
    [anon_sym_const] = ACTIONS(2665),
    [anon_sym_constexpr] = ACTIONS(2665),
    [anon_sym_volatile] = ACTIONS(2665),
    [anon_sym_restrict] = ACTIONS(2665),
    [anon_sym___restrict__] = ACTIONS(2665),
    [anon_sym__Atomic] = ACTIONS(2665),
    [anon_sym__Noreturn] = ACTIONS(2665),
    [anon_sym_noreturn] = ACTIONS(2665),
    [anon_sym_mutable] = ACTIONS(2665),
    [anon_sym_constinit] = ACTIONS(2665),
    [anon_sym_consteval] = ACTIONS(2665),
    [anon_sym_PROGMEM] = ACTIONS(2665),
    [aux_sym_primitive_type_token1] = ACTIONS(2665),
    [anon_sym_byte] = ACTIONS(2665),
    [anon_sym_word] = ACTIONS(2665),
    [anon_sym_enum] = ACTIONS(2665),
    [anon_sym_class] = ACTIONS(2665),
    [anon_sym_struct] = ACTIONS(2665),
    [anon_sym_union] = ACTIONS(2665),
    [anon_sym_if] = ACTIONS(2665),
    [anon_sym_else] = ACTIONS(2665),
    [anon_sym_switch] = ACTIONS(2665),
    [anon_sym_case] = ACTIONS(2665),
    [anon_sym_default] = ACTIONS(2665),
    [anon_sym_while] = ACTIONS(2665),
    [anon_sym_do] = ACTIONS(2665),
    [anon_sym_for] = ACTIONS(2665),
    [anon_sym_return] = ACTIONS(2665),
    [anon_sym_break] = ACTIONS(2665),
    [anon_sym_continue] = ACTIONS(2665),
    [anon_sym_goto] = ACTIONS(2665),
    [anon_sym___try] = ACTIONS(2665),
    [anon_sym___leave] = ACTIONS(2665),
    [anon_sym_not] = ACTIONS(2665),
    [anon_sym_compl] = ACTIONS(2665),
    [anon_sym_DASH_DASH] = ACTIONS(2667),
    [anon_sym_PLUS_PLUS] = ACTIONS(2667),
    [anon_sym_sizeof] = ACTIONS(2665),
    [anon_sym___alignof__] = ACTIONS(2665),
    [anon_sym___alignof] = ACTIONS(2665),
    [anon_sym__alignof] = ACTIONS(2665),
    [anon_sym_alignof] = ACTIONS(2665),
    [anon_sym__Alignof] = ACTIONS(2665),
    [anon_sym_offsetof] = ACTIONS(2665),
    [anon_sym__Generic] = ACTIONS(2665),
    [anon_sym_asm] = ACTIONS(2665),
    [anon_sym___asm__] = ACTIONS(2665),
    [aux_sym_number_literal_token1] = ACTIONS(2667),
    [aux_sym_number_literal_token2] = ACTIONS(2665),
    [anon_sym_L_SQUOTE] = ACTIONS(2667),
    [anon_sym_u_SQUOTE] = ACTIONS(2667),
    [anon_sym_U_SQUOTE] = ACTIONS(2667),
    [anon_sym_u8_SQUOTE] = ACTIONS(2667),
    [anon_sym_SQUOTE] = ACTIONS(2667),
    [anon_sym_L_DQUOTE] = ACTIONS(2667),
    [anon_sym_u_DQUOTE] = ACTIONS(2667),
    [anon_sym_U_DQUOTE] = ACTIONS(2667),
    [anon_sym_u8_DQUOTE] = ACTIONS(2667),
    [anon_sym_DQUOTE] = ACTIONS(2667),
    [sym_true] = ACTIONS(2665),
    [sym_false] = ACTIONS(2665),
    [anon_sym_NULL] = ACTIONS(2665),
    [anon_sym_nullptr] = ACTIONS(2665),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2665),
    [anon_sym_decltype] = ACTIONS(2665),
    [anon_sym_virtual] = ACTIONS(2665),
    [anon_sym_alignas] = ACTIONS(2665),
    [anon_sym_explicit] = ACTIONS(2665),
    [anon_sym_typename] = ACTIONS(2665),
    [anon_sym_template] = ACTIONS(2665),
    [anon_sym_operator] = ACTIONS(2665),
    [anon_sym_try] = ACTIONS(2665),
    [anon_sym_delete] = ACTIONS(2665),
    [anon_sym_throw] = ACTIONS(2665),
    [anon_sym_namespace] = ACTIONS(2665),
    [anon_sym_using] = ACTIONS(2665),
    [anon_sym_static_assert] = ACTIONS(2665),
    [anon_sym_concept] = ACTIONS(2665),
    [anon_sym_co_return] = ACTIONS(2665),
    [anon_sym_co_yield] = ACTIONS(2665),
    [anon_sym_R_DQUOTE] = ACTIONS(2667),
    [anon_sym_LR_DQUOTE] = ACTIONS(2667),
    [anon_sym_uR_DQUOTE] = ACTIONS(2667),
    [anon_sym_UR_DQUOTE] = ACTIONS(2667),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2667),
    [anon_sym_co_await] = ACTIONS(2665),
    [anon_sym_new] = ACTIONS(2665),
    [anon_sym_requires] = ACTIONS(2665),
    [sym_this] = ACTIONS(2665),
  },
  [492] = {
    [sym_identifier] = ACTIONS(2683),
    [aux_sym_preproc_include_token1] = ACTIONS(2683),
    [aux_sym_preproc_def_token1] = ACTIONS(2683),
    [aux_sym_preproc_if_token1] = ACTIONS(2683),
    [aux_sym_preproc_if_token2] = ACTIONS(2683),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2683),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2683),
    [sym_preproc_directive] = ACTIONS(2683),
    [anon_sym_LPAREN2] = ACTIONS(2685),
    [anon_sym_BANG] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2685),
    [anon_sym_DASH] = ACTIONS(2683),
    [anon_sym_PLUS] = ACTIONS(2683),
    [anon_sym_STAR] = ACTIONS(2685),
    [anon_sym_AMP_AMP] = ACTIONS(2685),
    [anon_sym_AMP] = ACTIONS(2683),
    [anon_sym_SEMI] = ACTIONS(2685),
    [anon_sym___extension__] = ACTIONS(2683),
    [anon_sym_typedef] = ACTIONS(2683),
    [anon_sym_extern] = ACTIONS(2683),
    [anon_sym___attribute__] = ACTIONS(2683),
    [anon_sym_COLON_COLON] = ACTIONS(2685),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2685),
    [anon_sym___declspec] = ACTIONS(2683),
    [anon_sym___based] = ACTIONS(2683),
    [anon_sym___cdecl] = ACTIONS(2683),
    [anon_sym___clrcall] = ACTIONS(2683),
    [anon_sym___stdcall] = ACTIONS(2683),
    [anon_sym___fastcall] = ACTIONS(2683),
    [anon_sym___thiscall] = ACTIONS(2683),
    [anon_sym___vectorcall] = ACTIONS(2683),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_signed] = ACTIONS(2683),
    [anon_sym_unsigned] = ACTIONS(2683),
    [anon_sym_long] = ACTIONS(2683),
    [anon_sym_short] = ACTIONS(2683),
    [anon_sym_LBRACK] = ACTIONS(2683),
    [anon_sym_static] = ACTIONS(2683),
    [anon_sym_register] = ACTIONS(2683),
    [anon_sym_inline] = ACTIONS(2683),
    [anon_sym___inline] = ACTIONS(2683),
    [anon_sym___inline__] = ACTIONS(2683),
    [anon_sym___forceinline] = ACTIONS(2683),
    [anon_sym_thread_local] = ACTIONS(2683),
    [anon_sym___thread] = ACTIONS(2683),
    [anon_sym_const] = ACTIONS(2683),
    [anon_sym_constexpr] = ACTIONS(2683),
    [anon_sym_volatile] = ACTIONS(2683),
    [anon_sym_restrict] = ACTIONS(2683),
    [anon_sym___restrict__] = ACTIONS(2683),
    [anon_sym__Atomic] = ACTIONS(2683),
    [anon_sym__Noreturn] = ACTIONS(2683),
    [anon_sym_noreturn] = ACTIONS(2683),
    [anon_sym_mutable] = ACTIONS(2683),
    [anon_sym_constinit] = ACTIONS(2683),
    [anon_sym_consteval] = ACTIONS(2683),
    [anon_sym_PROGMEM] = ACTIONS(2683),
    [aux_sym_primitive_type_token1] = ACTIONS(2683),
    [anon_sym_byte] = ACTIONS(2683),
    [anon_sym_word] = ACTIONS(2683),
    [anon_sym_enum] = ACTIONS(2683),
    [anon_sym_class] = ACTIONS(2683),
    [anon_sym_struct] = ACTIONS(2683),
    [anon_sym_union] = ACTIONS(2683),
    [anon_sym_if] = ACTIONS(2683),
    [anon_sym_else] = ACTIONS(2683),
    [anon_sym_switch] = ACTIONS(2683),
    [anon_sym_case] = ACTIONS(2683),
    [anon_sym_default] = ACTIONS(2683),
    [anon_sym_while] = ACTIONS(2683),
    [anon_sym_do] = ACTIONS(2683),
    [anon_sym_for] = ACTIONS(2683),
    [anon_sym_return] = ACTIONS(2683),
    [anon_sym_break] = ACTIONS(2683),
    [anon_sym_continue] = ACTIONS(2683),
    [anon_sym_goto] = ACTIONS(2683),
    [anon_sym___try] = ACTIONS(2683),
    [anon_sym___leave] = ACTIONS(2683),
    [anon_sym_not] = ACTIONS(2683),
    [anon_sym_compl] = ACTIONS(2683),
    [anon_sym_DASH_DASH] = ACTIONS(2685),
    [anon_sym_PLUS_PLUS] = ACTIONS(2685),
    [anon_sym_sizeof] = ACTIONS(2683),
    [anon_sym___alignof__] = ACTIONS(2683),
    [anon_sym___alignof] = ACTIONS(2683),
    [anon_sym__alignof] = ACTIONS(2683),
    [anon_sym_alignof] = ACTIONS(2683),
    [anon_sym__Alignof] = ACTIONS(2683),
    [anon_sym_offsetof] = ACTIONS(2683),
    [anon_sym__Generic] = ACTIONS(2683),
    [anon_sym_asm] = ACTIONS(2683),
    [anon_sym___asm__] = ACTIONS(2683),
    [aux_sym_number_literal_token1] = ACTIONS(2685),
    [aux_sym_number_literal_token2] = ACTIONS(2683),
    [anon_sym_L_SQUOTE] = ACTIONS(2685),
    [anon_sym_u_SQUOTE] = ACTIONS(2685),
    [anon_sym_U_SQUOTE] = ACTIONS(2685),
    [anon_sym_u8_SQUOTE] = ACTIONS(2685),
    [anon_sym_SQUOTE] = ACTIONS(2685),
    [anon_sym_L_DQUOTE] = ACTIONS(2685),
    [anon_sym_u_DQUOTE] = ACTIONS(2685),
    [anon_sym_U_DQUOTE] = ACTIONS(2685),
    [anon_sym_u8_DQUOTE] = ACTIONS(2685),
    [anon_sym_DQUOTE] = ACTIONS(2685),
    [sym_true] = ACTIONS(2683),
    [sym_false] = ACTIONS(2683),
    [anon_sym_NULL] = ACTIONS(2683),
    [anon_sym_nullptr] = ACTIONS(2683),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2683),
    [anon_sym_decltype] = ACTIONS(2683),
    [anon_sym_virtual] = ACTIONS(2683),
    [anon_sym_alignas] = ACTIONS(2683),
    [anon_sym_explicit] = ACTIONS(2683),
    [anon_sym_typename] = ACTIONS(2683),
    [anon_sym_template] = ACTIONS(2683),
    [anon_sym_operator] = ACTIONS(2683),
    [anon_sym_try] = ACTIONS(2683),
    [anon_sym_delete] = ACTIONS(2683),
    [anon_sym_throw] = ACTIONS(2683),
    [anon_sym_namespace] = ACTIONS(2683),
    [anon_sym_using] = ACTIONS(2683),
    [anon_sym_static_assert] = ACTIONS(2683),
    [anon_sym_concept] = ACTIONS(2683),
    [anon_sym_co_return] = ACTIONS(2683),
    [anon_sym_co_yield] = ACTIONS(2683),
    [anon_sym_R_DQUOTE] = ACTIONS(2685),
    [anon_sym_LR_DQUOTE] = ACTIONS(2685),
    [anon_sym_uR_DQUOTE] = ACTIONS(2685),
    [anon_sym_UR_DQUOTE] = ACTIONS(2685),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2685),
    [anon_sym_co_await] = ACTIONS(2683),
    [anon_sym_new] = ACTIONS(2683),
    [anon_sym_requires] = ACTIONS(2683),
    [sym_this] = ACTIONS(2683),
  },
  [493] = {
    [sym_identifier] = ACTIONS(2669),
    [aux_sym_preproc_include_token1] = ACTIONS(2669),
    [aux_sym_preproc_def_token1] = ACTIONS(2669),
    [aux_sym_preproc_if_token1] = ACTIONS(2669),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2669),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2669),
    [sym_preproc_directive] = ACTIONS(2669),
    [anon_sym_LPAREN2] = ACTIONS(2671),
    [anon_sym_BANG] = ACTIONS(2671),
    [anon_sym_TILDE] = ACTIONS(2671),
    [anon_sym_DASH] = ACTIONS(2669),
    [anon_sym_PLUS] = ACTIONS(2669),
    [anon_sym_STAR] = ACTIONS(2671),
    [anon_sym_AMP_AMP] = ACTIONS(2671),
    [anon_sym_AMP] = ACTIONS(2669),
    [anon_sym_SEMI] = ACTIONS(2671),
    [anon_sym___extension__] = ACTIONS(2669),
    [anon_sym_typedef] = ACTIONS(2669),
    [anon_sym_extern] = ACTIONS(2669),
    [anon_sym___attribute__] = ACTIONS(2669),
    [anon_sym_COLON_COLON] = ACTIONS(2671),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2671),
    [anon_sym___declspec] = ACTIONS(2669),
    [anon_sym___based] = ACTIONS(2669),
    [anon_sym___cdecl] = ACTIONS(2669),
    [anon_sym___clrcall] = ACTIONS(2669),
    [anon_sym___stdcall] = ACTIONS(2669),
    [anon_sym___fastcall] = ACTIONS(2669),
    [anon_sym___thiscall] = ACTIONS(2669),
    [anon_sym___vectorcall] = ACTIONS(2669),
    [anon_sym_LBRACE] = ACTIONS(2671),
    [anon_sym_RBRACE] = ACTIONS(2671),
    [anon_sym_signed] = ACTIONS(2669),
    [anon_sym_unsigned] = ACTIONS(2669),
    [anon_sym_long] = ACTIONS(2669),
    [anon_sym_short] = ACTIONS(2669),
    [anon_sym_LBRACK] = ACTIONS(2669),
    [anon_sym_static] = ACTIONS(2669),
    [anon_sym_register] = ACTIONS(2669),
    [anon_sym_inline] = ACTIONS(2669),
    [anon_sym___inline] = ACTIONS(2669),
    [anon_sym___inline__] = ACTIONS(2669),
    [anon_sym___forceinline] = ACTIONS(2669),
    [anon_sym_thread_local] = ACTIONS(2669),
    [anon_sym___thread] = ACTIONS(2669),
    [anon_sym_const] = ACTIONS(2669),
    [anon_sym_constexpr] = ACTIONS(2669),
    [anon_sym_volatile] = ACTIONS(2669),
    [anon_sym_restrict] = ACTIONS(2669),
    [anon_sym___restrict__] = ACTIONS(2669),
    [anon_sym__Atomic] = ACTIONS(2669),
    [anon_sym__Noreturn] = ACTIONS(2669),
    [anon_sym_noreturn] = ACTIONS(2669),
    [anon_sym_mutable] = ACTIONS(2669),
    [anon_sym_constinit] = ACTIONS(2669),
    [anon_sym_consteval] = ACTIONS(2669),
    [anon_sym_PROGMEM] = ACTIONS(2669),
    [aux_sym_primitive_type_token1] = ACTIONS(2669),
    [anon_sym_byte] = ACTIONS(2669),
    [anon_sym_word] = ACTIONS(2669),
    [anon_sym_enum] = ACTIONS(2669),
    [anon_sym_class] = ACTIONS(2669),
    [anon_sym_struct] = ACTIONS(2669),
    [anon_sym_union] = ACTIONS(2669),
    [anon_sym_if] = ACTIONS(2669),
    [anon_sym_else] = ACTIONS(2669),
    [anon_sym_switch] = ACTIONS(2669),
    [anon_sym_case] = ACTIONS(2669),
    [anon_sym_default] = ACTIONS(2669),
    [anon_sym_while] = ACTIONS(2669),
    [anon_sym_do] = ACTIONS(2669),
    [anon_sym_for] = ACTIONS(2669),
    [anon_sym_return] = ACTIONS(2669),
    [anon_sym_break] = ACTIONS(2669),
    [anon_sym_continue] = ACTIONS(2669),
    [anon_sym_goto] = ACTIONS(2669),
    [anon_sym___try] = ACTIONS(2669),
    [anon_sym___leave] = ACTIONS(2669),
    [anon_sym_not] = ACTIONS(2669),
    [anon_sym_compl] = ACTIONS(2669),
    [anon_sym_DASH_DASH] = ACTIONS(2671),
    [anon_sym_PLUS_PLUS] = ACTIONS(2671),
    [anon_sym_sizeof] = ACTIONS(2669),
    [anon_sym___alignof__] = ACTIONS(2669),
    [anon_sym___alignof] = ACTIONS(2669),
    [anon_sym__alignof] = ACTIONS(2669),
    [anon_sym_alignof] = ACTIONS(2669),
    [anon_sym__Alignof] = ACTIONS(2669),
    [anon_sym_offsetof] = ACTIONS(2669),
    [anon_sym__Generic] = ACTIONS(2669),
    [anon_sym_asm] = ACTIONS(2669),
    [anon_sym___asm__] = ACTIONS(2669),
    [aux_sym_number_literal_token1] = ACTIONS(2671),
    [aux_sym_number_literal_token2] = ACTIONS(2669),
    [anon_sym_L_SQUOTE] = ACTIONS(2671),
    [anon_sym_u_SQUOTE] = ACTIONS(2671),
    [anon_sym_U_SQUOTE] = ACTIONS(2671),
    [anon_sym_u8_SQUOTE] = ACTIONS(2671),
    [anon_sym_SQUOTE] = ACTIONS(2671),
    [anon_sym_L_DQUOTE] = ACTIONS(2671),
    [anon_sym_u_DQUOTE] = ACTIONS(2671),
    [anon_sym_U_DQUOTE] = ACTIONS(2671),
    [anon_sym_u8_DQUOTE] = ACTIONS(2671),
    [anon_sym_DQUOTE] = ACTIONS(2671),
    [sym_true] = ACTIONS(2669),
    [sym_false] = ACTIONS(2669),
    [anon_sym_NULL] = ACTIONS(2669),
    [anon_sym_nullptr] = ACTIONS(2669),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2669),
    [anon_sym_decltype] = ACTIONS(2669),
    [anon_sym_virtual] = ACTIONS(2669),
    [anon_sym_alignas] = ACTIONS(2669),
    [anon_sym_explicit] = ACTIONS(2669),
    [anon_sym_typename] = ACTIONS(2669),
    [anon_sym_template] = ACTIONS(2669),
    [anon_sym_operator] = ACTIONS(2669),
    [anon_sym_try] = ACTIONS(2669),
    [anon_sym_delete] = ACTIONS(2669),
    [anon_sym_throw] = ACTIONS(2669),
    [anon_sym_namespace] = ACTIONS(2669),
    [anon_sym_using] = ACTIONS(2669),
    [anon_sym_static_assert] = ACTIONS(2669),
    [anon_sym_concept] = ACTIONS(2669),
    [anon_sym_co_return] = ACTIONS(2669),
    [anon_sym_co_yield] = ACTIONS(2669),
    [anon_sym_R_DQUOTE] = ACTIONS(2671),
    [anon_sym_LR_DQUOTE] = ACTIONS(2671),
    [anon_sym_uR_DQUOTE] = ACTIONS(2671),
    [anon_sym_UR_DQUOTE] = ACTIONS(2671),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2671),
    [anon_sym_co_await] = ACTIONS(2669),
    [anon_sym_new] = ACTIONS(2669),
    [anon_sym_requires] = ACTIONS(2669),
    [sym_this] = ACTIONS(2669),
  },
  [494] = {
    [ts_builtin_sym_end] = ACTIONS(2645),
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [495] = {
    [sym_identifier] = ACTIONS(2675),
    [aux_sym_preproc_include_token1] = ACTIONS(2675),
    [aux_sym_preproc_def_token1] = ACTIONS(2675),
    [aux_sym_preproc_if_token1] = ACTIONS(2675),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2675),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2675),
    [sym_preproc_directive] = ACTIONS(2675),
    [anon_sym_LPAREN2] = ACTIONS(2677),
    [anon_sym_BANG] = ACTIONS(2677),
    [anon_sym_TILDE] = ACTIONS(2677),
    [anon_sym_DASH] = ACTIONS(2675),
    [anon_sym_PLUS] = ACTIONS(2675),
    [anon_sym_STAR] = ACTIONS(2677),
    [anon_sym_AMP_AMP] = ACTIONS(2677),
    [anon_sym_AMP] = ACTIONS(2675),
    [anon_sym_SEMI] = ACTIONS(2677),
    [anon_sym___extension__] = ACTIONS(2675),
    [anon_sym_typedef] = ACTIONS(2675),
    [anon_sym_extern] = ACTIONS(2675),
    [anon_sym___attribute__] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(2677),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2677),
    [anon_sym___declspec] = ACTIONS(2675),
    [anon_sym___based] = ACTIONS(2675),
    [anon_sym___cdecl] = ACTIONS(2675),
    [anon_sym___clrcall] = ACTIONS(2675),
    [anon_sym___stdcall] = ACTIONS(2675),
    [anon_sym___fastcall] = ACTIONS(2675),
    [anon_sym___thiscall] = ACTIONS(2675),
    [anon_sym___vectorcall] = ACTIONS(2675),
    [anon_sym_LBRACE] = ACTIONS(2677),
    [anon_sym_RBRACE] = ACTIONS(2677),
    [anon_sym_signed] = ACTIONS(2675),
    [anon_sym_unsigned] = ACTIONS(2675),
    [anon_sym_long] = ACTIONS(2675),
    [anon_sym_short] = ACTIONS(2675),
    [anon_sym_LBRACK] = ACTIONS(2675),
    [anon_sym_static] = ACTIONS(2675),
    [anon_sym_register] = ACTIONS(2675),
    [anon_sym_inline] = ACTIONS(2675),
    [anon_sym___inline] = ACTIONS(2675),
    [anon_sym___inline__] = ACTIONS(2675),
    [anon_sym___forceinline] = ACTIONS(2675),
    [anon_sym_thread_local] = ACTIONS(2675),
    [anon_sym___thread] = ACTIONS(2675),
    [anon_sym_const] = ACTIONS(2675),
    [anon_sym_constexpr] = ACTIONS(2675),
    [anon_sym_volatile] = ACTIONS(2675),
    [anon_sym_restrict] = ACTIONS(2675),
    [anon_sym___restrict__] = ACTIONS(2675),
    [anon_sym__Atomic] = ACTIONS(2675),
    [anon_sym__Noreturn] = ACTIONS(2675),
    [anon_sym_noreturn] = ACTIONS(2675),
    [anon_sym_mutable] = ACTIONS(2675),
    [anon_sym_constinit] = ACTIONS(2675),
    [anon_sym_consteval] = ACTIONS(2675),
    [anon_sym_PROGMEM] = ACTIONS(2675),
    [aux_sym_primitive_type_token1] = ACTIONS(2675),
    [anon_sym_byte] = ACTIONS(2675),
    [anon_sym_word] = ACTIONS(2675),
    [anon_sym_enum] = ACTIONS(2675),
    [anon_sym_class] = ACTIONS(2675),
    [anon_sym_struct] = ACTIONS(2675),
    [anon_sym_union] = ACTIONS(2675),
    [anon_sym_if] = ACTIONS(2675),
    [anon_sym_else] = ACTIONS(2675),
    [anon_sym_switch] = ACTIONS(2675),
    [anon_sym_case] = ACTIONS(2675),
    [anon_sym_default] = ACTIONS(2675),
    [anon_sym_while] = ACTIONS(2675),
    [anon_sym_do] = ACTIONS(2675),
    [anon_sym_for] = ACTIONS(2675),
    [anon_sym_return] = ACTIONS(2675),
    [anon_sym_break] = ACTIONS(2675),
    [anon_sym_continue] = ACTIONS(2675),
    [anon_sym_goto] = ACTIONS(2675),
    [anon_sym___try] = ACTIONS(2675),
    [anon_sym___leave] = ACTIONS(2675),
    [anon_sym_not] = ACTIONS(2675),
    [anon_sym_compl] = ACTIONS(2675),
    [anon_sym_DASH_DASH] = ACTIONS(2677),
    [anon_sym_PLUS_PLUS] = ACTIONS(2677),
    [anon_sym_sizeof] = ACTIONS(2675),
    [anon_sym___alignof__] = ACTIONS(2675),
    [anon_sym___alignof] = ACTIONS(2675),
    [anon_sym__alignof] = ACTIONS(2675),
    [anon_sym_alignof] = ACTIONS(2675),
    [anon_sym__Alignof] = ACTIONS(2675),
    [anon_sym_offsetof] = ACTIONS(2675),
    [anon_sym__Generic] = ACTIONS(2675),
    [anon_sym_asm] = ACTIONS(2675),
    [anon_sym___asm__] = ACTIONS(2675),
    [aux_sym_number_literal_token1] = ACTIONS(2677),
    [aux_sym_number_literal_token2] = ACTIONS(2675),
    [anon_sym_L_SQUOTE] = ACTIONS(2677),
    [anon_sym_u_SQUOTE] = ACTIONS(2677),
    [anon_sym_U_SQUOTE] = ACTIONS(2677),
    [anon_sym_u8_SQUOTE] = ACTIONS(2677),
    [anon_sym_SQUOTE] = ACTIONS(2677),
    [anon_sym_L_DQUOTE] = ACTIONS(2677),
    [anon_sym_u_DQUOTE] = ACTIONS(2677),
    [anon_sym_U_DQUOTE] = ACTIONS(2677),
    [anon_sym_u8_DQUOTE] = ACTIONS(2677),
    [anon_sym_DQUOTE] = ACTIONS(2677),
    [sym_true] = ACTIONS(2675),
    [sym_false] = ACTIONS(2675),
    [anon_sym_NULL] = ACTIONS(2675),
    [anon_sym_nullptr] = ACTIONS(2675),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2675),
    [anon_sym_decltype] = ACTIONS(2675),
    [anon_sym_virtual] = ACTIONS(2675),
    [anon_sym_alignas] = ACTIONS(2675),
    [anon_sym_explicit] = ACTIONS(2675),
    [anon_sym_typename] = ACTIONS(2675),
    [anon_sym_template] = ACTIONS(2675),
    [anon_sym_operator] = ACTIONS(2675),
    [anon_sym_try] = ACTIONS(2675),
    [anon_sym_delete] = ACTIONS(2675),
    [anon_sym_throw] = ACTIONS(2675),
    [anon_sym_namespace] = ACTIONS(2675),
    [anon_sym_using] = ACTIONS(2675),
    [anon_sym_static_assert] = ACTIONS(2675),
    [anon_sym_concept] = ACTIONS(2675),
    [anon_sym_co_return] = ACTIONS(2675),
    [anon_sym_co_yield] = ACTIONS(2675),
    [anon_sym_R_DQUOTE] = ACTIONS(2677),
    [anon_sym_LR_DQUOTE] = ACTIONS(2677),
    [anon_sym_uR_DQUOTE] = ACTIONS(2677),
    [anon_sym_UR_DQUOTE] = ACTIONS(2677),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2677),
    [anon_sym_co_await] = ACTIONS(2675),
    [anon_sym_new] = ACTIONS(2675),
    [anon_sym_requires] = ACTIONS(2675),
    [sym_this] = ACTIONS(2675),
  },
  [496] = {
    [ts_builtin_sym_end] = ACTIONS(2645),
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [497] = {
    [sym_identifier] = ACTIONS(2755),
    [aux_sym_preproc_include_token1] = ACTIONS(2755),
    [aux_sym_preproc_def_token1] = ACTIONS(2755),
    [aux_sym_preproc_if_token1] = ACTIONS(2755),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2755),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2755),
    [sym_preproc_directive] = ACTIONS(2755),
    [anon_sym_LPAREN2] = ACTIONS(2757),
    [anon_sym_BANG] = ACTIONS(2757),
    [anon_sym_TILDE] = ACTIONS(2757),
    [anon_sym_DASH] = ACTIONS(2755),
    [anon_sym_PLUS] = ACTIONS(2755),
    [anon_sym_STAR] = ACTIONS(2757),
    [anon_sym_AMP_AMP] = ACTIONS(2757),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2757),
    [anon_sym___extension__] = ACTIONS(2755),
    [anon_sym_typedef] = ACTIONS(2755),
    [anon_sym_extern] = ACTIONS(2755),
    [anon_sym___attribute__] = ACTIONS(2755),
    [anon_sym_COLON_COLON] = ACTIONS(2757),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2757),
    [anon_sym___declspec] = ACTIONS(2755),
    [anon_sym___based] = ACTIONS(2755),
    [anon_sym___cdecl] = ACTIONS(2755),
    [anon_sym___clrcall] = ACTIONS(2755),
    [anon_sym___stdcall] = ACTIONS(2755),
    [anon_sym___fastcall] = ACTIONS(2755),
    [anon_sym___thiscall] = ACTIONS(2755),
    [anon_sym___vectorcall] = ACTIONS(2755),
    [anon_sym_LBRACE] = ACTIONS(2757),
    [anon_sym_RBRACE] = ACTIONS(2757),
    [anon_sym_signed] = ACTIONS(2755),
    [anon_sym_unsigned] = ACTIONS(2755),
    [anon_sym_long] = ACTIONS(2755),
    [anon_sym_short] = ACTIONS(2755),
    [anon_sym_LBRACK] = ACTIONS(2755),
    [anon_sym_static] = ACTIONS(2755),
    [anon_sym_register] = ACTIONS(2755),
    [anon_sym_inline] = ACTIONS(2755),
    [anon_sym___inline] = ACTIONS(2755),
    [anon_sym___inline__] = ACTIONS(2755),
    [anon_sym___forceinline] = ACTIONS(2755),
    [anon_sym_thread_local] = ACTIONS(2755),
    [anon_sym___thread] = ACTIONS(2755),
    [anon_sym_const] = ACTIONS(2755),
    [anon_sym_constexpr] = ACTIONS(2755),
    [anon_sym_volatile] = ACTIONS(2755),
    [anon_sym_restrict] = ACTIONS(2755),
    [anon_sym___restrict__] = ACTIONS(2755),
    [anon_sym__Atomic] = ACTIONS(2755),
    [anon_sym__Noreturn] = ACTIONS(2755),
    [anon_sym_noreturn] = ACTIONS(2755),
    [anon_sym_mutable] = ACTIONS(2755),
    [anon_sym_constinit] = ACTIONS(2755),
    [anon_sym_consteval] = ACTIONS(2755),
    [anon_sym_PROGMEM] = ACTIONS(2755),
    [aux_sym_primitive_type_token1] = ACTIONS(2755),
    [anon_sym_byte] = ACTIONS(2755),
    [anon_sym_word] = ACTIONS(2755),
    [anon_sym_enum] = ACTIONS(2755),
    [anon_sym_class] = ACTIONS(2755),
    [anon_sym_struct] = ACTIONS(2755),
    [anon_sym_union] = ACTIONS(2755),
    [anon_sym_if] = ACTIONS(2755),
    [anon_sym_else] = ACTIONS(2755),
    [anon_sym_switch] = ACTIONS(2755),
    [anon_sym_case] = ACTIONS(2755),
    [anon_sym_default] = ACTIONS(2755),
    [anon_sym_while] = ACTIONS(2755),
    [anon_sym_do] = ACTIONS(2755),
    [anon_sym_for] = ACTIONS(2755),
    [anon_sym_return] = ACTIONS(2755),
    [anon_sym_break] = ACTIONS(2755),
    [anon_sym_continue] = ACTIONS(2755),
    [anon_sym_goto] = ACTIONS(2755),
    [anon_sym___try] = ACTIONS(2755),
    [anon_sym___leave] = ACTIONS(2755),
    [anon_sym_not] = ACTIONS(2755),
    [anon_sym_compl] = ACTIONS(2755),
    [anon_sym_DASH_DASH] = ACTIONS(2757),
    [anon_sym_PLUS_PLUS] = ACTIONS(2757),
    [anon_sym_sizeof] = ACTIONS(2755),
    [anon_sym___alignof__] = ACTIONS(2755),
    [anon_sym___alignof] = ACTIONS(2755),
    [anon_sym__alignof] = ACTIONS(2755),
    [anon_sym_alignof] = ACTIONS(2755),
    [anon_sym__Alignof] = ACTIONS(2755),
    [anon_sym_offsetof] = ACTIONS(2755),
    [anon_sym__Generic] = ACTIONS(2755),
    [anon_sym_asm] = ACTIONS(2755),
    [anon_sym___asm__] = ACTIONS(2755),
    [aux_sym_number_literal_token1] = ACTIONS(2757),
    [aux_sym_number_literal_token2] = ACTIONS(2755),
    [anon_sym_L_SQUOTE] = ACTIONS(2757),
    [anon_sym_u_SQUOTE] = ACTIONS(2757),
    [anon_sym_U_SQUOTE] = ACTIONS(2757),
    [anon_sym_u8_SQUOTE] = ACTIONS(2757),
    [anon_sym_SQUOTE] = ACTIONS(2757),
    [anon_sym_L_DQUOTE] = ACTIONS(2757),
    [anon_sym_u_DQUOTE] = ACTIONS(2757),
    [anon_sym_U_DQUOTE] = ACTIONS(2757),
    [anon_sym_u8_DQUOTE] = ACTIONS(2757),
    [anon_sym_DQUOTE] = ACTIONS(2757),
    [sym_true] = ACTIONS(2755),
    [sym_false] = ACTIONS(2755),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2755),
    [anon_sym_decltype] = ACTIONS(2755),
    [anon_sym_virtual] = ACTIONS(2755),
    [anon_sym_alignas] = ACTIONS(2755),
    [anon_sym_explicit] = ACTIONS(2755),
    [anon_sym_typename] = ACTIONS(2755),
    [anon_sym_template] = ACTIONS(2755),
    [anon_sym_operator] = ACTIONS(2755),
    [anon_sym_try] = ACTIONS(2755),
    [anon_sym_delete] = ACTIONS(2755),
    [anon_sym_throw] = ACTIONS(2755),
    [anon_sym_namespace] = ACTIONS(2755),
    [anon_sym_using] = ACTIONS(2755),
    [anon_sym_static_assert] = ACTIONS(2755),
    [anon_sym_concept] = ACTIONS(2755),
    [anon_sym_co_return] = ACTIONS(2755),
    [anon_sym_co_yield] = ACTIONS(2755),
    [anon_sym_R_DQUOTE] = ACTIONS(2757),
    [anon_sym_LR_DQUOTE] = ACTIONS(2757),
    [anon_sym_uR_DQUOTE] = ACTIONS(2757),
    [anon_sym_UR_DQUOTE] = ACTIONS(2757),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2757),
    [anon_sym_co_await] = ACTIONS(2755),
    [anon_sym_new] = ACTIONS(2755),
    [anon_sym_requires] = ACTIONS(2755),
    [sym_this] = ACTIONS(2755),
  },
  [498] = {
    [ts_builtin_sym_end] = ACTIONS(2645),
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [499] = {
    [sym_identifier] = ACTIONS(2687),
    [aux_sym_preproc_include_token1] = ACTIONS(2687),
    [aux_sym_preproc_def_token1] = ACTIONS(2687),
    [aux_sym_preproc_if_token1] = ACTIONS(2687),
    [aux_sym_preproc_if_token2] = ACTIONS(2687),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2687),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2687),
    [sym_preproc_directive] = ACTIONS(2687),
    [anon_sym_LPAREN2] = ACTIONS(2689),
    [anon_sym_BANG] = ACTIONS(2689),
    [anon_sym_TILDE] = ACTIONS(2689),
    [anon_sym_DASH] = ACTIONS(2687),
    [anon_sym_PLUS] = ACTIONS(2687),
    [anon_sym_STAR] = ACTIONS(2689),
    [anon_sym_AMP_AMP] = ACTIONS(2689),
    [anon_sym_AMP] = ACTIONS(2687),
    [anon_sym_SEMI] = ACTIONS(2689),
    [anon_sym___extension__] = ACTIONS(2687),
    [anon_sym_typedef] = ACTIONS(2687),
    [anon_sym_extern] = ACTIONS(2687),
    [anon_sym___attribute__] = ACTIONS(2687),
    [anon_sym_COLON_COLON] = ACTIONS(2689),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2689),
    [anon_sym___declspec] = ACTIONS(2687),
    [anon_sym___based] = ACTIONS(2687),
    [anon_sym___cdecl] = ACTIONS(2687),
    [anon_sym___clrcall] = ACTIONS(2687),
    [anon_sym___stdcall] = ACTIONS(2687),
    [anon_sym___fastcall] = ACTIONS(2687),
    [anon_sym___thiscall] = ACTIONS(2687),
    [anon_sym___vectorcall] = ACTIONS(2687),
    [anon_sym_LBRACE] = ACTIONS(2689),
    [anon_sym_signed] = ACTIONS(2687),
    [anon_sym_unsigned] = ACTIONS(2687),
    [anon_sym_long] = ACTIONS(2687),
    [anon_sym_short] = ACTIONS(2687),
    [anon_sym_LBRACK] = ACTIONS(2687),
    [anon_sym_static] = ACTIONS(2687),
    [anon_sym_register] = ACTIONS(2687),
    [anon_sym_inline] = ACTIONS(2687),
    [anon_sym___inline] = ACTIONS(2687),
    [anon_sym___inline__] = ACTIONS(2687),
    [anon_sym___forceinline] = ACTIONS(2687),
    [anon_sym_thread_local] = ACTIONS(2687),
    [anon_sym___thread] = ACTIONS(2687),
    [anon_sym_const] = ACTIONS(2687),
    [anon_sym_constexpr] = ACTIONS(2687),
    [anon_sym_volatile] = ACTIONS(2687),
    [anon_sym_restrict] = ACTIONS(2687),
    [anon_sym___restrict__] = ACTIONS(2687),
    [anon_sym__Atomic] = ACTIONS(2687),
    [anon_sym__Noreturn] = ACTIONS(2687),
    [anon_sym_noreturn] = ACTIONS(2687),
    [anon_sym_mutable] = ACTIONS(2687),
    [anon_sym_constinit] = ACTIONS(2687),
    [anon_sym_consteval] = ACTIONS(2687),
    [anon_sym_PROGMEM] = ACTIONS(2687),
    [aux_sym_primitive_type_token1] = ACTIONS(2687),
    [anon_sym_byte] = ACTIONS(2687),
    [anon_sym_word] = ACTIONS(2687),
    [anon_sym_enum] = ACTIONS(2687),
    [anon_sym_class] = ACTIONS(2687),
    [anon_sym_struct] = ACTIONS(2687),
    [anon_sym_union] = ACTIONS(2687),
    [anon_sym_if] = ACTIONS(2687),
    [anon_sym_else] = ACTIONS(2687),
    [anon_sym_switch] = ACTIONS(2687),
    [anon_sym_case] = ACTIONS(2687),
    [anon_sym_default] = ACTIONS(2687),
    [anon_sym_while] = ACTIONS(2687),
    [anon_sym_do] = ACTIONS(2687),
    [anon_sym_for] = ACTIONS(2687),
    [anon_sym_return] = ACTIONS(2687),
    [anon_sym_break] = ACTIONS(2687),
    [anon_sym_continue] = ACTIONS(2687),
    [anon_sym_goto] = ACTIONS(2687),
    [anon_sym___try] = ACTIONS(2687),
    [anon_sym___leave] = ACTIONS(2687),
    [anon_sym_not] = ACTIONS(2687),
    [anon_sym_compl] = ACTIONS(2687),
    [anon_sym_DASH_DASH] = ACTIONS(2689),
    [anon_sym_PLUS_PLUS] = ACTIONS(2689),
    [anon_sym_sizeof] = ACTIONS(2687),
    [anon_sym___alignof__] = ACTIONS(2687),
    [anon_sym___alignof] = ACTIONS(2687),
    [anon_sym__alignof] = ACTIONS(2687),
    [anon_sym_alignof] = ACTIONS(2687),
    [anon_sym__Alignof] = ACTIONS(2687),
    [anon_sym_offsetof] = ACTIONS(2687),
    [anon_sym__Generic] = ACTIONS(2687),
    [anon_sym_asm] = ACTIONS(2687),
    [anon_sym___asm__] = ACTIONS(2687),
    [aux_sym_number_literal_token1] = ACTIONS(2689),
    [aux_sym_number_literal_token2] = ACTIONS(2687),
    [anon_sym_L_SQUOTE] = ACTIONS(2689),
    [anon_sym_u_SQUOTE] = ACTIONS(2689),
    [anon_sym_U_SQUOTE] = ACTIONS(2689),
    [anon_sym_u8_SQUOTE] = ACTIONS(2689),
    [anon_sym_SQUOTE] = ACTIONS(2689),
    [anon_sym_L_DQUOTE] = ACTIONS(2689),
    [anon_sym_u_DQUOTE] = ACTIONS(2689),
    [anon_sym_U_DQUOTE] = ACTIONS(2689),
    [anon_sym_u8_DQUOTE] = ACTIONS(2689),
    [anon_sym_DQUOTE] = ACTIONS(2689),
    [sym_true] = ACTIONS(2687),
    [sym_false] = ACTIONS(2687),
    [anon_sym_NULL] = ACTIONS(2687),
    [anon_sym_nullptr] = ACTIONS(2687),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2687),
    [anon_sym_decltype] = ACTIONS(2687),
    [anon_sym_virtual] = ACTIONS(2687),
    [anon_sym_alignas] = ACTIONS(2687),
    [anon_sym_explicit] = ACTIONS(2687),
    [anon_sym_typename] = ACTIONS(2687),
    [anon_sym_template] = ACTIONS(2687),
    [anon_sym_operator] = ACTIONS(2687),
    [anon_sym_try] = ACTIONS(2687),
    [anon_sym_delete] = ACTIONS(2687),
    [anon_sym_throw] = ACTIONS(2687),
    [anon_sym_namespace] = ACTIONS(2687),
    [anon_sym_using] = ACTIONS(2687),
    [anon_sym_static_assert] = ACTIONS(2687),
    [anon_sym_concept] = ACTIONS(2687),
    [anon_sym_co_return] = ACTIONS(2687),
    [anon_sym_co_yield] = ACTIONS(2687),
    [anon_sym_R_DQUOTE] = ACTIONS(2689),
    [anon_sym_LR_DQUOTE] = ACTIONS(2689),
    [anon_sym_uR_DQUOTE] = ACTIONS(2689),
    [anon_sym_UR_DQUOTE] = ACTIONS(2689),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2689),
    [anon_sym_co_await] = ACTIONS(2687),
    [anon_sym_new] = ACTIONS(2687),
    [anon_sym_requires] = ACTIONS(2687),
    [sym_this] = ACTIONS(2687),
  },
  [500] = {
    [sym_identifier] = ACTIONS(2691),
    [aux_sym_preproc_include_token1] = ACTIONS(2691),
    [aux_sym_preproc_def_token1] = ACTIONS(2691),
    [aux_sym_preproc_if_token1] = ACTIONS(2691),
    [aux_sym_preproc_if_token2] = ACTIONS(2691),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2691),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2691),
    [sym_preproc_directive] = ACTIONS(2691),
    [anon_sym_LPAREN2] = ACTIONS(2693),
    [anon_sym_BANG] = ACTIONS(2693),
    [anon_sym_TILDE] = ACTIONS(2693),
    [anon_sym_DASH] = ACTIONS(2691),
    [anon_sym_PLUS] = ACTIONS(2691),
    [anon_sym_STAR] = ACTIONS(2693),
    [anon_sym_AMP_AMP] = ACTIONS(2693),
    [anon_sym_AMP] = ACTIONS(2691),
    [anon_sym_SEMI] = ACTIONS(2693),
    [anon_sym___extension__] = ACTIONS(2691),
    [anon_sym_typedef] = ACTIONS(2691),
    [anon_sym_extern] = ACTIONS(2691),
    [anon_sym___attribute__] = ACTIONS(2691),
    [anon_sym_COLON_COLON] = ACTIONS(2693),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2693),
    [anon_sym___declspec] = ACTIONS(2691),
    [anon_sym___based] = ACTIONS(2691),
    [anon_sym___cdecl] = ACTIONS(2691),
    [anon_sym___clrcall] = ACTIONS(2691),
    [anon_sym___stdcall] = ACTIONS(2691),
    [anon_sym___fastcall] = ACTIONS(2691),
    [anon_sym___thiscall] = ACTIONS(2691),
    [anon_sym___vectorcall] = ACTIONS(2691),
    [anon_sym_LBRACE] = ACTIONS(2693),
    [anon_sym_signed] = ACTIONS(2691),
    [anon_sym_unsigned] = ACTIONS(2691),
    [anon_sym_long] = ACTIONS(2691),
    [anon_sym_short] = ACTIONS(2691),
    [anon_sym_LBRACK] = ACTIONS(2691),
    [anon_sym_static] = ACTIONS(2691),
    [anon_sym_register] = ACTIONS(2691),
    [anon_sym_inline] = ACTIONS(2691),
    [anon_sym___inline] = ACTIONS(2691),
    [anon_sym___inline__] = ACTIONS(2691),
    [anon_sym___forceinline] = ACTIONS(2691),
    [anon_sym_thread_local] = ACTIONS(2691),
    [anon_sym___thread] = ACTIONS(2691),
    [anon_sym_const] = ACTIONS(2691),
    [anon_sym_constexpr] = ACTIONS(2691),
    [anon_sym_volatile] = ACTIONS(2691),
    [anon_sym_restrict] = ACTIONS(2691),
    [anon_sym___restrict__] = ACTIONS(2691),
    [anon_sym__Atomic] = ACTIONS(2691),
    [anon_sym__Noreturn] = ACTIONS(2691),
    [anon_sym_noreturn] = ACTIONS(2691),
    [anon_sym_mutable] = ACTIONS(2691),
    [anon_sym_constinit] = ACTIONS(2691),
    [anon_sym_consteval] = ACTIONS(2691),
    [anon_sym_PROGMEM] = ACTIONS(2691),
    [aux_sym_primitive_type_token1] = ACTIONS(2691),
    [anon_sym_byte] = ACTIONS(2691),
    [anon_sym_word] = ACTIONS(2691),
    [anon_sym_enum] = ACTIONS(2691),
    [anon_sym_class] = ACTIONS(2691),
    [anon_sym_struct] = ACTIONS(2691),
    [anon_sym_union] = ACTIONS(2691),
    [anon_sym_if] = ACTIONS(2691),
    [anon_sym_else] = ACTIONS(2691),
    [anon_sym_switch] = ACTIONS(2691),
    [anon_sym_case] = ACTIONS(2691),
    [anon_sym_default] = ACTIONS(2691),
    [anon_sym_while] = ACTIONS(2691),
    [anon_sym_do] = ACTIONS(2691),
    [anon_sym_for] = ACTIONS(2691),
    [anon_sym_return] = ACTIONS(2691),
    [anon_sym_break] = ACTIONS(2691),
    [anon_sym_continue] = ACTIONS(2691),
    [anon_sym_goto] = ACTIONS(2691),
    [anon_sym___try] = ACTIONS(2691),
    [anon_sym___leave] = ACTIONS(2691),
    [anon_sym_not] = ACTIONS(2691),
    [anon_sym_compl] = ACTIONS(2691),
    [anon_sym_DASH_DASH] = ACTIONS(2693),
    [anon_sym_PLUS_PLUS] = ACTIONS(2693),
    [anon_sym_sizeof] = ACTIONS(2691),
    [anon_sym___alignof__] = ACTIONS(2691),
    [anon_sym___alignof] = ACTIONS(2691),
    [anon_sym__alignof] = ACTIONS(2691),
    [anon_sym_alignof] = ACTIONS(2691),
    [anon_sym__Alignof] = ACTIONS(2691),
    [anon_sym_offsetof] = ACTIONS(2691),
    [anon_sym__Generic] = ACTIONS(2691),
    [anon_sym_asm] = ACTIONS(2691),
    [anon_sym___asm__] = ACTIONS(2691),
    [aux_sym_number_literal_token1] = ACTIONS(2693),
    [aux_sym_number_literal_token2] = ACTIONS(2691),
    [anon_sym_L_SQUOTE] = ACTIONS(2693),
    [anon_sym_u_SQUOTE] = ACTIONS(2693),
    [anon_sym_U_SQUOTE] = ACTIONS(2693),
    [anon_sym_u8_SQUOTE] = ACTIONS(2693),
    [anon_sym_SQUOTE] = ACTIONS(2693),
    [anon_sym_L_DQUOTE] = ACTIONS(2693),
    [anon_sym_u_DQUOTE] = ACTIONS(2693),
    [anon_sym_U_DQUOTE] = ACTIONS(2693),
    [anon_sym_u8_DQUOTE] = ACTIONS(2693),
    [anon_sym_DQUOTE] = ACTIONS(2693),
    [sym_true] = ACTIONS(2691),
    [sym_false] = ACTIONS(2691),
    [anon_sym_NULL] = ACTIONS(2691),
    [anon_sym_nullptr] = ACTIONS(2691),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2691),
    [anon_sym_decltype] = ACTIONS(2691),
    [anon_sym_virtual] = ACTIONS(2691),
    [anon_sym_alignas] = ACTIONS(2691),
    [anon_sym_explicit] = ACTIONS(2691),
    [anon_sym_typename] = ACTIONS(2691),
    [anon_sym_template] = ACTIONS(2691),
    [anon_sym_operator] = ACTIONS(2691),
    [anon_sym_try] = ACTIONS(2691),
    [anon_sym_delete] = ACTIONS(2691),
    [anon_sym_throw] = ACTIONS(2691),
    [anon_sym_namespace] = ACTIONS(2691),
    [anon_sym_using] = ACTIONS(2691),
    [anon_sym_static_assert] = ACTIONS(2691),
    [anon_sym_concept] = ACTIONS(2691),
    [anon_sym_co_return] = ACTIONS(2691),
    [anon_sym_co_yield] = ACTIONS(2691),
    [anon_sym_R_DQUOTE] = ACTIONS(2693),
    [anon_sym_LR_DQUOTE] = ACTIONS(2693),
    [anon_sym_uR_DQUOTE] = ACTIONS(2693),
    [anon_sym_UR_DQUOTE] = ACTIONS(2693),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2693),
    [anon_sym_co_await] = ACTIONS(2691),
    [anon_sym_new] = ACTIONS(2691),
    [anon_sym_requires] = ACTIONS(2691),
    [sym_this] = ACTIONS(2691),
  },
  [501] = {
    [ts_builtin_sym_end] = ACTIONS(2645),
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [502] = {
    [sym_identifier] = ACTIONS(2683),
    [aux_sym_preproc_include_token1] = ACTIONS(2683),
    [aux_sym_preproc_def_token1] = ACTIONS(2683),
    [aux_sym_preproc_if_token1] = ACTIONS(2683),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2683),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2683),
    [sym_preproc_directive] = ACTIONS(2683),
    [anon_sym_LPAREN2] = ACTIONS(2685),
    [anon_sym_BANG] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2685),
    [anon_sym_DASH] = ACTIONS(2683),
    [anon_sym_PLUS] = ACTIONS(2683),
    [anon_sym_STAR] = ACTIONS(2685),
    [anon_sym_AMP_AMP] = ACTIONS(2685),
    [anon_sym_AMP] = ACTIONS(2683),
    [anon_sym_SEMI] = ACTIONS(2685),
    [anon_sym___extension__] = ACTIONS(2683),
    [anon_sym_typedef] = ACTIONS(2683),
    [anon_sym_extern] = ACTIONS(2683),
    [anon_sym___attribute__] = ACTIONS(2683),
    [anon_sym_COLON_COLON] = ACTIONS(2685),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2685),
    [anon_sym___declspec] = ACTIONS(2683),
    [anon_sym___based] = ACTIONS(2683),
    [anon_sym___cdecl] = ACTIONS(2683),
    [anon_sym___clrcall] = ACTIONS(2683),
    [anon_sym___stdcall] = ACTIONS(2683),
    [anon_sym___fastcall] = ACTIONS(2683),
    [anon_sym___thiscall] = ACTIONS(2683),
    [anon_sym___vectorcall] = ACTIONS(2683),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_RBRACE] = ACTIONS(2685),
    [anon_sym_signed] = ACTIONS(2683),
    [anon_sym_unsigned] = ACTIONS(2683),
    [anon_sym_long] = ACTIONS(2683),
    [anon_sym_short] = ACTIONS(2683),
    [anon_sym_LBRACK] = ACTIONS(2683),
    [anon_sym_static] = ACTIONS(2683),
    [anon_sym_register] = ACTIONS(2683),
    [anon_sym_inline] = ACTIONS(2683),
    [anon_sym___inline] = ACTIONS(2683),
    [anon_sym___inline__] = ACTIONS(2683),
    [anon_sym___forceinline] = ACTIONS(2683),
    [anon_sym_thread_local] = ACTIONS(2683),
    [anon_sym___thread] = ACTIONS(2683),
    [anon_sym_const] = ACTIONS(2683),
    [anon_sym_constexpr] = ACTIONS(2683),
    [anon_sym_volatile] = ACTIONS(2683),
    [anon_sym_restrict] = ACTIONS(2683),
    [anon_sym___restrict__] = ACTIONS(2683),
    [anon_sym__Atomic] = ACTIONS(2683),
    [anon_sym__Noreturn] = ACTIONS(2683),
    [anon_sym_noreturn] = ACTIONS(2683),
    [anon_sym_mutable] = ACTIONS(2683),
    [anon_sym_constinit] = ACTIONS(2683),
    [anon_sym_consteval] = ACTIONS(2683),
    [anon_sym_PROGMEM] = ACTIONS(2683),
    [aux_sym_primitive_type_token1] = ACTIONS(2683),
    [anon_sym_byte] = ACTIONS(2683),
    [anon_sym_word] = ACTIONS(2683),
    [anon_sym_enum] = ACTIONS(2683),
    [anon_sym_class] = ACTIONS(2683),
    [anon_sym_struct] = ACTIONS(2683),
    [anon_sym_union] = ACTIONS(2683),
    [anon_sym_if] = ACTIONS(2683),
    [anon_sym_else] = ACTIONS(2683),
    [anon_sym_switch] = ACTIONS(2683),
    [anon_sym_case] = ACTIONS(2683),
    [anon_sym_default] = ACTIONS(2683),
    [anon_sym_while] = ACTIONS(2683),
    [anon_sym_do] = ACTIONS(2683),
    [anon_sym_for] = ACTIONS(2683),
    [anon_sym_return] = ACTIONS(2683),
    [anon_sym_break] = ACTIONS(2683),
    [anon_sym_continue] = ACTIONS(2683),
    [anon_sym_goto] = ACTIONS(2683),
    [anon_sym___try] = ACTIONS(2683),
    [anon_sym___leave] = ACTIONS(2683),
    [anon_sym_not] = ACTIONS(2683),
    [anon_sym_compl] = ACTIONS(2683),
    [anon_sym_DASH_DASH] = ACTIONS(2685),
    [anon_sym_PLUS_PLUS] = ACTIONS(2685),
    [anon_sym_sizeof] = ACTIONS(2683),
    [anon_sym___alignof__] = ACTIONS(2683),
    [anon_sym___alignof] = ACTIONS(2683),
    [anon_sym__alignof] = ACTIONS(2683),
    [anon_sym_alignof] = ACTIONS(2683),
    [anon_sym__Alignof] = ACTIONS(2683),
    [anon_sym_offsetof] = ACTIONS(2683),
    [anon_sym__Generic] = ACTIONS(2683),
    [anon_sym_asm] = ACTIONS(2683),
    [anon_sym___asm__] = ACTIONS(2683),
    [aux_sym_number_literal_token1] = ACTIONS(2685),
    [aux_sym_number_literal_token2] = ACTIONS(2683),
    [anon_sym_L_SQUOTE] = ACTIONS(2685),
    [anon_sym_u_SQUOTE] = ACTIONS(2685),
    [anon_sym_U_SQUOTE] = ACTIONS(2685),
    [anon_sym_u8_SQUOTE] = ACTIONS(2685),
    [anon_sym_SQUOTE] = ACTIONS(2685),
    [anon_sym_L_DQUOTE] = ACTIONS(2685),
    [anon_sym_u_DQUOTE] = ACTIONS(2685),
    [anon_sym_U_DQUOTE] = ACTIONS(2685),
    [anon_sym_u8_DQUOTE] = ACTIONS(2685),
    [anon_sym_DQUOTE] = ACTIONS(2685),
    [sym_true] = ACTIONS(2683),
    [sym_false] = ACTIONS(2683),
    [anon_sym_NULL] = ACTIONS(2683),
    [anon_sym_nullptr] = ACTIONS(2683),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2683),
    [anon_sym_decltype] = ACTIONS(2683),
    [anon_sym_virtual] = ACTIONS(2683),
    [anon_sym_alignas] = ACTIONS(2683),
    [anon_sym_explicit] = ACTIONS(2683),
    [anon_sym_typename] = ACTIONS(2683),
    [anon_sym_template] = ACTIONS(2683),
    [anon_sym_operator] = ACTIONS(2683),
    [anon_sym_try] = ACTIONS(2683),
    [anon_sym_delete] = ACTIONS(2683),
    [anon_sym_throw] = ACTIONS(2683),
    [anon_sym_namespace] = ACTIONS(2683),
    [anon_sym_using] = ACTIONS(2683),
    [anon_sym_static_assert] = ACTIONS(2683),
    [anon_sym_concept] = ACTIONS(2683),
    [anon_sym_co_return] = ACTIONS(2683),
    [anon_sym_co_yield] = ACTIONS(2683),
    [anon_sym_R_DQUOTE] = ACTIONS(2685),
    [anon_sym_LR_DQUOTE] = ACTIONS(2685),
    [anon_sym_uR_DQUOTE] = ACTIONS(2685),
    [anon_sym_UR_DQUOTE] = ACTIONS(2685),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2685),
    [anon_sym_co_await] = ACTIONS(2683),
    [anon_sym_new] = ACTIONS(2683),
    [anon_sym_requires] = ACTIONS(2683),
    [sym_this] = ACTIONS(2683),
  },
  [503] = {
    [ts_builtin_sym_end] = ACTIONS(2645),
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [504] = {
    [sym_identifier] = ACTIONS(2507),
    [aux_sym_preproc_include_token1] = ACTIONS(2507),
    [aux_sym_preproc_def_token1] = ACTIONS(2507),
    [aux_sym_preproc_if_token1] = ACTIONS(2507),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2507),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2507),
    [sym_preproc_directive] = ACTIONS(2507),
    [anon_sym_LPAREN2] = ACTIONS(2512),
    [anon_sym_BANG] = ACTIONS(2512),
    [anon_sym_TILDE] = ACTIONS(2512),
    [anon_sym_DASH] = ACTIONS(2507),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_STAR] = ACTIONS(2512),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2507),
    [anon_sym_SEMI] = ACTIONS(2512),
    [anon_sym___extension__] = ACTIONS(2507),
    [anon_sym_typedef] = ACTIONS(2507),
    [anon_sym_extern] = ACTIONS(2507),
    [anon_sym___attribute__] = ACTIONS(2507),
    [anon_sym_COLON_COLON] = ACTIONS(2512),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2512),
    [anon_sym___declspec] = ACTIONS(2507),
    [anon_sym___based] = ACTIONS(2507),
    [anon_sym___cdecl] = ACTIONS(2507),
    [anon_sym___clrcall] = ACTIONS(2507),
    [anon_sym___stdcall] = ACTIONS(2507),
    [anon_sym___fastcall] = ACTIONS(2507),
    [anon_sym___thiscall] = ACTIONS(2507),
    [anon_sym___vectorcall] = ACTIONS(2507),
    [anon_sym_LBRACE] = ACTIONS(2512),
    [anon_sym_RBRACE] = ACTIONS(2512),
    [anon_sym_signed] = ACTIONS(2507),
    [anon_sym_unsigned] = ACTIONS(2507),
    [anon_sym_long] = ACTIONS(2507),
    [anon_sym_short] = ACTIONS(2507),
    [anon_sym_LBRACK] = ACTIONS(2507),
    [anon_sym_static] = ACTIONS(2507),
    [anon_sym_register] = ACTIONS(2507),
    [anon_sym_inline] = ACTIONS(2507),
    [anon_sym___inline] = ACTIONS(2507),
    [anon_sym___inline__] = ACTIONS(2507),
    [anon_sym___forceinline] = ACTIONS(2507),
    [anon_sym_thread_local] = ACTIONS(2507),
    [anon_sym___thread] = ACTIONS(2507),
    [anon_sym_const] = ACTIONS(2507),
    [anon_sym_constexpr] = ACTIONS(2507),
    [anon_sym_volatile] = ACTIONS(2507),
    [anon_sym_restrict] = ACTIONS(2507),
    [anon_sym___restrict__] = ACTIONS(2507),
    [anon_sym__Atomic] = ACTIONS(2507),
    [anon_sym__Noreturn] = ACTIONS(2507),
    [anon_sym_noreturn] = ACTIONS(2507),
    [anon_sym_mutable] = ACTIONS(2507),
    [anon_sym_constinit] = ACTIONS(2507),
    [anon_sym_consteval] = ACTIONS(2507),
    [anon_sym_PROGMEM] = ACTIONS(2507),
    [aux_sym_primitive_type_token1] = ACTIONS(2507),
    [anon_sym_byte] = ACTIONS(2507),
    [anon_sym_word] = ACTIONS(2507),
    [anon_sym_enum] = ACTIONS(2507),
    [anon_sym_class] = ACTIONS(2507),
    [anon_sym_struct] = ACTIONS(2507),
    [anon_sym_union] = ACTIONS(2507),
    [anon_sym_if] = ACTIONS(2507),
    [anon_sym_else] = ACTIONS(2507),
    [anon_sym_switch] = ACTIONS(2507),
    [anon_sym_case] = ACTIONS(2507),
    [anon_sym_default] = ACTIONS(2507),
    [anon_sym_while] = ACTIONS(2507),
    [anon_sym_do] = ACTIONS(2507),
    [anon_sym_for] = ACTIONS(2507),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_break] = ACTIONS(2507),
    [anon_sym_continue] = ACTIONS(2507),
    [anon_sym_goto] = ACTIONS(2507),
    [anon_sym___try] = ACTIONS(2507),
    [anon_sym___leave] = ACTIONS(2507),
    [anon_sym_not] = ACTIONS(2507),
    [anon_sym_compl] = ACTIONS(2507),
    [anon_sym_DASH_DASH] = ACTIONS(2512),
    [anon_sym_PLUS_PLUS] = ACTIONS(2512),
    [anon_sym_sizeof] = ACTIONS(2507),
    [anon_sym___alignof__] = ACTIONS(2507),
    [anon_sym___alignof] = ACTIONS(2507),
    [anon_sym__alignof] = ACTIONS(2507),
    [anon_sym_alignof] = ACTIONS(2507),
    [anon_sym__Alignof] = ACTIONS(2507),
    [anon_sym_offsetof] = ACTIONS(2507),
    [anon_sym__Generic] = ACTIONS(2507),
    [anon_sym_asm] = ACTIONS(2507),
    [anon_sym___asm__] = ACTIONS(2507),
    [aux_sym_number_literal_token1] = ACTIONS(2512),
    [aux_sym_number_literal_token2] = ACTIONS(2507),
    [anon_sym_L_SQUOTE] = ACTIONS(2512),
    [anon_sym_u_SQUOTE] = ACTIONS(2512),
    [anon_sym_U_SQUOTE] = ACTIONS(2512),
    [anon_sym_u8_SQUOTE] = ACTIONS(2512),
    [anon_sym_SQUOTE] = ACTIONS(2512),
    [anon_sym_L_DQUOTE] = ACTIONS(2512),
    [anon_sym_u_DQUOTE] = ACTIONS(2512),
    [anon_sym_U_DQUOTE] = ACTIONS(2512),
    [anon_sym_u8_DQUOTE] = ACTIONS(2512),
    [anon_sym_DQUOTE] = ACTIONS(2512),
    [sym_true] = ACTIONS(2507),
    [sym_false] = ACTIONS(2507),
    [anon_sym_NULL] = ACTIONS(2507),
    [anon_sym_nullptr] = ACTIONS(2507),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2507),
    [anon_sym_decltype] = ACTIONS(2507),
    [anon_sym_virtual] = ACTIONS(2507),
    [anon_sym_alignas] = ACTIONS(2507),
    [anon_sym_explicit] = ACTIONS(2507),
    [anon_sym_typename] = ACTIONS(2507),
    [anon_sym_template] = ACTIONS(2507),
    [anon_sym_operator] = ACTIONS(2507),
    [anon_sym_try] = ACTIONS(2507),
    [anon_sym_delete] = ACTIONS(2507),
    [anon_sym_throw] = ACTIONS(2507),
    [anon_sym_namespace] = ACTIONS(2507),
    [anon_sym_using] = ACTIONS(2507),
    [anon_sym_static_assert] = ACTIONS(2507),
    [anon_sym_concept] = ACTIONS(2507),
    [anon_sym_co_return] = ACTIONS(2507),
    [anon_sym_co_yield] = ACTIONS(2507),
    [anon_sym_R_DQUOTE] = ACTIONS(2512),
    [anon_sym_LR_DQUOTE] = ACTIONS(2512),
    [anon_sym_uR_DQUOTE] = ACTIONS(2512),
    [anon_sym_UR_DQUOTE] = ACTIONS(2512),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2512),
    [anon_sym_co_await] = ACTIONS(2507),
    [anon_sym_new] = ACTIONS(2507),
    [anon_sym_requires] = ACTIONS(2507),
    [sym_this] = ACTIONS(2507),
  },
  [505] = {
    [sym_identifier] = ACTIONS(2695),
    [aux_sym_preproc_include_token1] = ACTIONS(2695),
    [aux_sym_preproc_def_token1] = ACTIONS(2695),
    [aux_sym_preproc_if_token1] = ACTIONS(2695),
    [aux_sym_preproc_if_token2] = ACTIONS(2695),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2695),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2695),
    [sym_preproc_directive] = ACTIONS(2695),
    [anon_sym_LPAREN2] = ACTIONS(2697),
    [anon_sym_BANG] = ACTIONS(2697),
    [anon_sym_TILDE] = ACTIONS(2697),
    [anon_sym_DASH] = ACTIONS(2695),
    [anon_sym_PLUS] = ACTIONS(2695),
    [anon_sym_STAR] = ACTIONS(2697),
    [anon_sym_AMP_AMP] = ACTIONS(2697),
    [anon_sym_AMP] = ACTIONS(2695),
    [anon_sym_SEMI] = ACTIONS(2697),
    [anon_sym___extension__] = ACTIONS(2695),
    [anon_sym_typedef] = ACTIONS(2695),
    [anon_sym_extern] = ACTIONS(2695),
    [anon_sym___attribute__] = ACTIONS(2695),
    [anon_sym_COLON_COLON] = ACTIONS(2697),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2697),
    [anon_sym___declspec] = ACTIONS(2695),
    [anon_sym___based] = ACTIONS(2695),
    [anon_sym___cdecl] = ACTIONS(2695),
    [anon_sym___clrcall] = ACTIONS(2695),
    [anon_sym___stdcall] = ACTIONS(2695),
    [anon_sym___fastcall] = ACTIONS(2695),
    [anon_sym___thiscall] = ACTIONS(2695),
    [anon_sym___vectorcall] = ACTIONS(2695),
    [anon_sym_LBRACE] = ACTIONS(2697),
    [anon_sym_signed] = ACTIONS(2695),
    [anon_sym_unsigned] = ACTIONS(2695),
    [anon_sym_long] = ACTIONS(2695),
    [anon_sym_short] = ACTIONS(2695),
    [anon_sym_LBRACK] = ACTIONS(2695),
    [anon_sym_static] = ACTIONS(2695),
    [anon_sym_register] = ACTIONS(2695),
    [anon_sym_inline] = ACTIONS(2695),
    [anon_sym___inline] = ACTIONS(2695),
    [anon_sym___inline__] = ACTIONS(2695),
    [anon_sym___forceinline] = ACTIONS(2695),
    [anon_sym_thread_local] = ACTIONS(2695),
    [anon_sym___thread] = ACTIONS(2695),
    [anon_sym_const] = ACTIONS(2695),
    [anon_sym_constexpr] = ACTIONS(2695),
    [anon_sym_volatile] = ACTIONS(2695),
    [anon_sym_restrict] = ACTIONS(2695),
    [anon_sym___restrict__] = ACTIONS(2695),
    [anon_sym__Atomic] = ACTIONS(2695),
    [anon_sym__Noreturn] = ACTIONS(2695),
    [anon_sym_noreturn] = ACTIONS(2695),
    [anon_sym_mutable] = ACTIONS(2695),
    [anon_sym_constinit] = ACTIONS(2695),
    [anon_sym_consteval] = ACTIONS(2695),
    [anon_sym_PROGMEM] = ACTIONS(2695),
    [aux_sym_primitive_type_token1] = ACTIONS(2695),
    [anon_sym_byte] = ACTIONS(2695),
    [anon_sym_word] = ACTIONS(2695),
    [anon_sym_enum] = ACTIONS(2695),
    [anon_sym_class] = ACTIONS(2695),
    [anon_sym_struct] = ACTIONS(2695),
    [anon_sym_union] = ACTIONS(2695),
    [anon_sym_if] = ACTIONS(2695),
    [anon_sym_else] = ACTIONS(2695),
    [anon_sym_switch] = ACTIONS(2695),
    [anon_sym_case] = ACTIONS(2695),
    [anon_sym_default] = ACTIONS(2695),
    [anon_sym_while] = ACTIONS(2695),
    [anon_sym_do] = ACTIONS(2695),
    [anon_sym_for] = ACTIONS(2695),
    [anon_sym_return] = ACTIONS(2695),
    [anon_sym_break] = ACTIONS(2695),
    [anon_sym_continue] = ACTIONS(2695),
    [anon_sym_goto] = ACTIONS(2695),
    [anon_sym___try] = ACTIONS(2695),
    [anon_sym___leave] = ACTIONS(2695),
    [anon_sym_not] = ACTIONS(2695),
    [anon_sym_compl] = ACTIONS(2695),
    [anon_sym_DASH_DASH] = ACTIONS(2697),
    [anon_sym_PLUS_PLUS] = ACTIONS(2697),
    [anon_sym_sizeof] = ACTIONS(2695),
    [anon_sym___alignof__] = ACTIONS(2695),
    [anon_sym___alignof] = ACTIONS(2695),
    [anon_sym__alignof] = ACTIONS(2695),
    [anon_sym_alignof] = ACTIONS(2695),
    [anon_sym__Alignof] = ACTIONS(2695),
    [anon_sym_offsetof] = ACTIONS(2695),
    [anon_sym__Generic] = ACTIONS(2695),
    [anon_sym_asm] = ACTIONS(2695),
    [anon_sym___asm__] = ACTIONS(2695),
    [aux_sym_number_literal_token1] = ACTIONS(2697),
    [aux_sym_number_literal_token2] = ACTIONS(2695),
    [anon_sym_L_SQUOTE] = ACTIONS(2697),
    [anon_sym_u_SQUOTE] = ACTIONS(2697),
    [anon_sym_U_SQUOTE] = ACTIONS(2697),
    [anon_sym_u8_SQUOTE] = ACTIONS(2697),
    [anon_sym_SQUOTE] = ACTIONS(2697),
    [anon_sym_L_DQUOTE] = ACTIONS(2697),
    [anon_sym_u_DQUOTE] = ACTIONS(2697),
    [anon_sym_U_DQUOTE] = ACTIONS(2697),
    [anon_sym_u8_DQUOTE] = ACTIONS(2697),
    [anon_sym_DQUOTE] = ACTIONS(2697),
    [sym_true] = ACTIONS(2695),
    [sym_false] = ACTIONS(2695),
    [anon_sym_NULL] = ACTIONS(2695),
    [anon_sym_nullptr] = ACTIONS(2695),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2695),
    [anon_sym_decltype] = ACTIONS(2695),
    [anon_sym_virtual] = ACTIONS(2695),
    [anon_sym_alignas] = ACTIONS(2695),
    [anon_sym_explicit] = ACTIONS(2695),
    [anon_sym_typename] = ACTIONS(2695),
    [anon_sym_template] = ACTIONS(2695),
    [anon_sym_operator] = ACTIONS(2695),
    [anon_sym_try] = ACTIONS(2695),
    [anon_sym_delete] = ACTIONS(2695),
    [anon_sym_throw] = ACTIONS(2695),
    [anon_sym_namespace] = ACTIONS(2695),
    [anon_sym_using] = ACTIONS(2695),
    [anon_sym_static_assert] = ACTIONS(2695),
    [anon_sym_concept] = ACTIONS(2695),
    [anon_sym_co_return] = ACTIONS(2695),
    [anon_sym_co_yield] = ACTIONS(2695),
    [anon_sym_R_DQUOTE] = ACTIONS(2697),
    [anon_sym_LR_DQUOTE] = ACTIONS(2697),
    [anon_sym_uR_DQUOTE] = ACTIONS(2697),
    [anon_sym_UR_DQUOTE] = ACTIONS(2697),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2697),
    [anon_sym_co_await] = ACTIONS(2695),
    [anon_sym_new] = ACTIONS(2695),
    [anon_sym_requires] = ACTIONS(2695),
    [sym_this] = ACTIONS(2695),
  },
  [506] = {
    [sym_identifier] = ACTIONS(2701),
    [aux_sym_preproc_include_token1] = ACTIONS(2701),
    [aux_sym_preproc_def_token1] = ACTIONS(2701),
    [aux_sym_preproc_if_token1] = ACTIONS(2701),
    [aux_sym_preproc_if_token2] = ACTIONS(2701),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2701),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2701),
    [sym_preproc_directive] = ACTIONS(2701),
    [anon_sym_LPAREN2] = ACTIONS(2703),
    [anon_sym_BANG] = ACTIONS(2703),
    [anon_sym_TILDE] = ACTIONS(2703),
    [anon_sym_DASH] = ACTIONS(2701),
    [anon_sym_PLUS] = ACTIONS(2701),
    [anon_sym_STAR] = ACTIONS(2703),
    [anon_sym_AMP_AMP] = ACTIONS(2703),
    [anon_sym_AMP] = ACTIONS(2701),
    [anon_sym_SEMI] = ACTIONS(2703),
    [anon_sym___extension__] = ACTIONS(2701),
    [anon_sym_typedef] = ACTIONS(2701),
    [anon_sym_extern] = ACTIONS(2701),
    [anon_sym___attribute__] = ACTIONS(2701),
    [anon_sym_COLON_COLON] = ACTIONS(2703),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2703),
    [anon_sym___declspec] = ACTIONS(2701),
    [anon_sym___based] = ACTIONS(2701),
    [anon_sym___cdecl] = ACTIONS(2701),
    [anon_sym___clrcall] = ACTIONS(2701),
    [anon_sym___stdcall] = ACTIONS(2701),
    [anon_sym___fastcall] = ACTIONS(2701),
    [anon_sym___thiscall] = ACTIONS(2701),
    [anon_sym___vectorcall] = ACTIONS(2701),
    [anon_sym_LBRACE] = ACTIONS(2703),
    [anon_sym_signed] = ACTIONS(2701),
    [anon_sym_unsigned] = ACTIONS(2701),
    [anon_sym_long] = ACTIONS(2701),
    [anon_sym_short] = ACTIONS(2701),
    [anon_sym_LBRACK] = ACTIONS(2701),
    [anon_sym_static] = ACTIONS(2701),
    [anon_sym_register] = ACTIONS(2701),
    [anon_sym_inline] = ACTIONS(2701),
    [anon_sym___inline] = ACTIONS(2701),
    [anon_sym___inline__] = ACTIONS(2701),
    [anon_sym___forceinline] = ACTIONS(2701),
    [anon_sym_thread_local] = ACTIONS(2701),
    [anon_sym___thread] = ACTIONS(2701),
    [anon_sym_const] = ACTIONS(2701),
    [anon_sym_constexpr] = ACTIONS(2701),
    [anon_sym_volatile] = ACTIONS(2701),
    [anon_sym_restrict] = ACTIONS(2701),
    [anon_sym___restrict__] = ACTIONS(2701),
    [anon_sym__Atomic] = ACTIONS(2701),
    [anon_sym__Noreturn] = ACTIONS(2701),
    [anon_sym_noreturn] = ACTIONS(2701),
    [anon_sym_mutable] = ACTIONS(2701),
    [anon_sym_constinit] = ACTIONS(2701),
    [anon_sym_consteval] = ACTIONS(2701),
    [anon_sym_PROGMEM] = ACTIONS(2701),
    [aux_sym_primitive_type_token1] = ACTIONS(2701),
    [anon_sym_byte] = ACTIONS(2701),
    [anon_sym_word] = ACTIONS(2701),
    [anon_sym_enum] = ACTIONS(2701),
    [anon_sym_class] = ACTIONS(2701),
    [anon_sym_struct] = ACTIONS(2701),
    [anon_sym_union] = ACTIONS(2701),
    [anon_sym_if] = ACTIONS(2701),
    [anon_sym_else] = ACTIONS(2701),
    [anon_sym_switch] = ACTIONS(2701),
    [anon_sym_case] = ACTIONS(2701),
    [anon_sym_default] = ACTIONS(2701),
    [anon_sym_while] = ACTIONS(2701),
    [anon_sym_do] = ACTIONS(2701),
    [anon_sym_for] = ACTIONS(2701),
    [anon_sym_return] = ACTIONS(2701),
    [anon_sym_break] = ACTIONS(2701),
    [anon_sym_continue] = ACTIONS(2701),
    [anon_sym_goto] = ACTIONS(2701),
    [anon_sym___try] = ACTIONS(2701),
    [anon_sym___leave] = ACTIONS(2701),
    [anon_sym_not] = ACTIONS(2701),
    [anon_sym_compl] = ACTIONS(2701),
    [anon_sym_DASH_DASH] = ACTIONS(2703),
    [anon_sym_PLUS_PLUS] = ACTIONS(2703),
    [anon_sym_sizeof] = ACTIONS(2701),
    [anon_sym___alignof__] = ACTIONS(2701),
    [anon_sym___alignof] = ACTIONS(2701),
    [anon_sym__alignof] = ACTIONS(2701),
    [anon_sym_alignof] = ACTIONS(2701),
    [anon_sym__Alignof] = ACTIONS(2701),
    [anon_sym_offsetof] = ACTIONS(2701),
    [anon_sym__Generic] = ACTIONS(2701),
    [anon_sym_asm] = ACTIONS(2701),
    [anon_sym___asm__] = ACTIONS(2701),
    [aux_sym_number_literal_token1] = ACTIONS(2703),
    [aux_sym_number_literal_token2] = ACTIONS(2701),
    [anon_sym_L_SQUOTE] = ACTIONS(2703),
    [anon_sym_u_SQUOTE] = ACTIONS(2703),
    [anon_sym_U_SQUOTE] = ACTIONS(2703),
    [anon_sym_u8_SQUOTE] = ACTIONS(2703),
    [anon_sym_SQUOTE] = ACTIONS(2703),
    [anon_sym_L_DQUOTE] = ACTIONS(2703),
    [anon_sym_u_DQUOTE] = ACTIONS(2703),
    [anon_sym_U_DQUOTE] = ACTIONS(2703),
    [anon_sym_u8_DQUOTE] = ACTIONS(2703),
    [anon_sym_DQUOTE] = ACTIONS(2703),
    [sym_true] = ACTIONS(2701),
    [sym_false] = ACTIONS(2701),
    [anon_sym_NULL] = ACTIONS(2701),
    [anon_sym_nullptr] = ACTIONS(2701),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2701),
    [anon_sym_decltype] = ACTIONS(2701),
    [anon_sym_virtual] = ACTIONS(2701),
    [anon_sym_alignas] = ACTIONS(2701),
    [anon_sym_explicit] = ACTIONS(2701),
    [anon_sym_typename] = ACTIONS(2701),
    [anon_sym_template] = ACTIONS(2701),
    [anon_sym_operator] = ACTIONS(2701),
    [anon_sym_try] = ACTIONS(2701),
    [anon_sym_delete] = ACTIONS(2701),
    [anon_sym_throw] = ACTIONS(2701),
    [anon_sym_namespace] = ACTIONS(2701),
    [anon_sym_using] = ACTIONS(2701),
    [anon_sym_static_assert] = ACTIONS(2701),
    [anon_sym_concept] = ACTIONS(2701),
    [anon_sym_co_return] = ACTIONS(2701),
    [anon_sym_co_yield] = ACTIONS(2701),
    [anon_sym_R_DQUOTE] = ACTIONS(2703),
    [anon_sym_LR_DQUOTE] = ACTIONS(2703),
    [anon_sym_uR_DQUOTE] = ACTIONS(2703),
    [anon_sym_UR_DQUOTE] = ACTIONS(2703),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2703),
    [anon_sym_co_await] = ACTIONS(2701),
    [anon_sym_new] = ACTIONS(2701),
    [anon_sym_requires] = ACTIONS(2701),
    [sym_this] = ACTIONS(2701),
  },
  [507] = {
    [sym_identifier] = ACTIONS(2705),
    [aux_sym_preproc_include_token1] = ACTIONS(2705),
    [aux_sym_preproc_def_token1] = ACTIONS(2705),
    [aux_sym_preproc_if_token1] = ACTIONS(2705),
    [aux_sym_preproc_if_token2] = ACTIONS(2705),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2705),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2705),
    [sym_preproc_directive] = ACTIONS(2705),
    [anon_sym_LPAREN2] = ACTIONS(2707),
    [anon_sym_BANG] = ACTIONS(2707),
    [anon_sym_TILDE] = ACTIONS(2707),
    [anon_sym_DASH] = ACTIONS(2705),
    [anon_sym_PLUS] = ACTIONS(2705),
    [anon_sym_STAR] = ACTIONS(2707),
    [anon_sym_AMP_AMP] = ACTIONS(2707),
    [anon_sym_AMP] = ACTIONS(2705),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym___extension__] = ACTIONS(2705),
    [anon_sym_typedef] = ACTIONS(2705),
    [anon_sym_extern] = ACTIONS(2705),
    [anon_sym___attribute__] = ACTIONS(2705),
    [anon_sym_COLON_COLON] = ACTIONS(2707),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2707),
    [anon_sym___declspec] = ACTIONS(2705),
    [anon_sym___based] = ACTIONS(2705),
    [anon_sym___cdecl] = ACTIONS(2705),
    [anon_sym___clrcall] = ACTIONS(2705),
    [anon_sym___stdcall] = ACTIONS(2705),
    [anon_sym___fastcall] = ACTIONS(2705),
    [anon_sym___thiscall] = ACTIONS(2705),
    [anon_sym___vectorcall] = ACTIONS(2705),
    [anon_sym_LBRACE] = ACTIONS(2707),
    [anon_sym_signed] = ACTIONS(2705),
    [anon_sym_unsigned] = ACTIONS(2705),
    [anon_sym_long] = ACTIONS(2705),
    [anon_sym_short] = ACTIONS(2705),
    [anon_sym_LBRACK] = ACTIONS(2705),
    [anon_sym_static] = ACTIONS(2705),
    [anon_sym_register] = ACTIONS(2705),
    [anon_sym_inline] = ACTIONS(2705),
    [anon_sym___inline] = ACTIONS(2705),
    [anon_sym___inline__] = ACTIONS(2705),
    [anon_sym___forceinline] = ACTIONS(2705),
    [anon_sym_thread_local] = ACTIONS(2705),
    [anon_sym___thread] = ACTIONS(2705),
    [anon_sym_const] = ACTIONS(2705),
    [anon_sym_constexpr] = ACTIONS(2705),
    [anon_sym_volatile] = ACTIONS(2705),
    [anon_sym_restrict] = ACTIONS(2705),
    [anon_sym___restrict__] = ACTIONS(2705),
    [anon_sym__Atomic] = ACTIONS(2705),
    [anon_sym__Noreturn] = ACTIONS(2705),
    [anon_sym_noreturn] = ACTIONS(2705),
    [anon_sym_mutable] = ACTIONS(2705),
    [anon_sym_constinit] = ACTIONS(2705),
    [anon_sym_consteval] = ACTIONS(2705),
    [anon_sym_PROGMEM] = ACTIONS(2705),
    [aux_sym_primitive_type_token1] = ACTIONS(2705),
    [anon_sym_byte] = ACTIONS(2705),
    [anon_sym_word] = ACTIONS(2705),
    [anon_sym_enum] = ACTIONS(2705),
    [anon_sym_class] = ACTIONS(2705),
    [anon_sym_struct] = ACTIONS(2705),
    [anon_sym_union] = ACTIONS(2705),
    [anon_sym_if] = ACTIONS(2705),
    [anon_sym_else] = ACTIONS(2705),
    [anon_sym_switch] = ACTIONS(2705),
    [anon_sym_case] = ACTIONS(2705),
    [anon_sym_default] = ACTIONS(2705),
    [anon_sym_while] = ACTIONS(2705),
    [anon_sym_do] = ACTIONS(2705),
    [anon_sym_for] = ACTIONS(2705),
    [anon_sym_return] = ACTIONS(2705),
    [anon_sym_break] = ACTIONS(2705),
    [anon_sym_continue] = ACTIONS(2705),
    [anon_sym_goto] = ACTIONS(2705),
    [anon_sym___try] = ACTIONS(2705),
    [anon_sym___leave] = ACTIONS(2705),
    [anon_sym_not] = ACTIONS(2705),
    [anon_sym_compl] = ACTIONS(2705),
    [anon_sym_DASH_DASH] = ACTIONS(2707),
    [anon_sym_PLUS_PLUS] = ACTIONS(2707),
    [anon_sym_sizeof] = ACTIONS(2705),
    [anon_sym___alignof__] = ACTIONS(2705),
    [anon_sym___alignof] = ACTIONS(2705),
    [anon_sym__alignof] = ACTIONS(2705),
    [anon_sym_alignof] = ACTIONS(2705),
    [anon_sym__Alignof] = ACTIONS(2705),
    [anon_sym_offsetof] = ACTIONS(2705),
    [anon_sym__Generic] = ACTIONS(2705),
    [anon_sym_asm] = ACTIONS(2705),
    [anon_sym___asm__] = ACTIONS(2705),
    [aux_sym_number_literal_token1] = ACTIONS(2707),
    [aux_sym_number_literal_token2] = ACTIONS(2705),
    [anon_sym_L_SQUOTE] = ACTIONS(2707),
    [anon_sym_u_SQUOTE] = ACTIONS(2707),
    [anon_sym_U_SQUOTE] = ACTIONS(2707),
    [anon_sym_u8_SQUOTE] = ACTIONS(2707),
    [anon_sym_SQUOTE] = ACTIONS(2707),
    [anon_sym_L_DQUOTE] = ACTIONS(2707),
    [anon_sym_u_DQUOTE] = ACTIONS(2707),
    [anon_sym_U_DQUOTE] = ACTIONS(2707),
    [anon_sym_u8_DQUOTE] = ACTIONS(2707),
    [anon_sym_DQUOTE] = ACTIONS(2707),
    [sym_true] = ACTIONS(2705),
    [sym_false] = ACTIONS(2705),
    [anon_sym_NULL] = ACTIONS(2705),
    [anon_sym_nullptr] = ACTIONS(2705),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2705),
    [anon_sym_decltype] = ACTIONS(2705),
    [anon_sym_virtual] = ACTIONS(2705),
    [anon_sym_alignas] = ACTIONS(2705),
    [anon_sym_explicit] = ACTIONS(2705),
    [anon_sym_typename] = ACTIONS(2705),
    [anon_sym_template] = ACTIONS(2705),
    [anon_sym_operator] = ACTIONS(2705),
    [anon_sym_try] = ACTIONS(2705),
    [anon_sym_delete] = ACTIONS(2705),
    [anon_sym_throw] = ACTIONS(2705),
    [anon_sym_namespace] = ACTIONS(2705),
    [anon_sym_using] = ACTIONS(2705),
    [anon_sym_static_assert] = ACTIONS(2705),
    [anon_sym_concept] = ACTIONS(2705),
    [anon_sym_co_return] = ACTIONS(2705),
    [anon_sym_co_yield] = ACTIONS(2705),
    [anon_sym_R_DQUOTE] = ACTIONS(2707),
    [anon_sym_LR_DQUOTE] = ACTIONS(2707),
    [anon_sym_uR_DQUOTE] = ACTIONS(2707),
    [anon_sym_UR_DQUOTE] = ACTIONS(2707),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2707),
    [anon_sym_co_await] = ACTIONS(2705),
    [anon_sym_new] = ACTIONS(2705),
    [anon_sym_requires] = ACTIONS(2705),
    [sym_this] = ACTIONS(2705),
  },
  [508] = {
    [ts_builtin_sym_end] = ACTIONS(2685),
    [sym_identifier] = ACTIONS(2683),
    [aux_sym_preproc_include_token1] = ACTIONS(2683),
    [aux_sym_preproc_def_token1] = ACTIONS(2683),
    [aux_sym_preproc_if_token1] = ACTIONS(2683),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2683),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2683),
    [sym_preproc_directive] = ACTIONS(2683),
    [anon_sym_LPAREN2] = ACTIONS(2685),
    [anon_sym_BANG] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2685),
    [anon_sym_DASH] = ACTIONS(2683),
    [anon_sym_PLUS] = ACTIONS(2683),
    [anon_sym_STAR] = ACTIONS(2685),
    [anon_sym_AMP_AMP] = ACTIONS(2685),
    [anon_sym_AMP] = ACTIONS(2683),
    [anon_sym_SEMI] = ACTIONS(2685),
    [anon_sym___extension__] = ACTIONS(2683),
    [anon_sym_typedef] = ACTIONS(2683),
    [anon_sym_extern] = ACTIONS(2683),
    [anon_sym___attribute__] = ACTIONS(2683),
    [anon_sym_COLON_COLON] = ACTIONS(2685),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2685),
    [anon_sym___declspec] = ACTIONS(2683),
    [anon_sym___based] = ACTIONS(2683),
    [anon_sym___cdecl] = ACTIONS(2683),
    [anon_sym___clrcall] = ACTIONS(2683),
    [anon_sym___stdcall] = ACTIONS(2683),
    [anon_sym___fastcall] = ACTIONS(2683),
    [anon_sym___thiscall] = ACTIONS(2683),
    [anon_sym___vectorcall] = ACTIONS(2683),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_signed] = ACTIONS(2683),
    [anon_sym_unsigned] = ACTIONS(2683),
    [anon_sym_long] = ACTIONS(2683),
    [anon_sym_short] = ACTIONS(2683),
    [anon_sym_LBRACK] = ACTIONS(2683),
    [anon_sym_static] = ACTIONS(2683),
    [anon_sym_register] = ACTIONS(2683),
    [anon_sym_inline] = ACTIONS(2683),
    [anon_sym___inline] = ACTIONS(2683),
    [anon_sym___inline__] = ACTIONS(2683),
    [anon_sym___forceinline] = ACTIONS(2683),
    [anon_sym_thread_local] = ACTIONS(2683),
    [anon_sym___thread] = ACTIONS(2683),
    [anon_sym_const] = ACTIONS(2683),
    [anon_sym_constexpr] = ACTIONS(2683),
    [anon_sym_volatile] = ACTIONS(2683),
    [anon_sym_restrict] = ACTIONS(2683),
    [anon_sym___restrict__] = ACTIONS(2683),
    [anon_sym__Atomic] = ACTIONS(2683),
    [anon_sym__Noreturn] = ACTIONS(2683),
    [anon_sym_noreturn] = ACTIONS(2683),
    [anon_sym_mutable] = ACTIONS(2683),
    [anon_sym_constinit] = ACTIONS(2683),
    [anon_sym_consteval] = ACTIONS(2683),
    [anon_sym_PROGMEM] = ACTIONS(2683),
    [aux_sym_primitive_type_token1] = ACTIONS(2683),
    [anon_sym_byte] = ACTIONS(2683),
    [anon_sym_word] = ACTIONS(2683),
    [anon_sym_enum] = ACTIONS(2683),
    [anon_sym_class] = ACTIONS(2683),
    [anon_sym_struct] = ACTIONS(2683),
    [anon_sym_union] = ACTIONS(2683),
    [anon_sym_if] = ACTIONS(2683),
    [anon_sym_else] = ACTIONS(2683),
    [anon_sym_switch] = ACTIONS(2683),
    [anon_sym_case] = ACTIONS(2683),
    [anon_sym_default] = ACTIONS(2683),
    [anon_sym_while] = ACTIONS(2683),
    [anon_sym_do] = ACTIONS(2683),
    [anon_sym_for] = ACTIONS(2683),
    [anon_sym_return] = ACTIONS(2683),
    [anon_sym_break] = ACTIONS(2683),
    [anon_sym_continue] = ACTIONS(2683),
    [anon_sym_goto] = ACTIONS(2683),
    [anon_sym___try] = ACTIONS(2683),
    [anon_sym___leave] = ACTIONS(2683),
    [anon_sym_not] = ACTIONS(2683),
    [anon_sym_compl] = ACTIONS(2683),
    [anon_sym_DASH_DASH] = ACTIONS(2685),
    [anon_sym_PLUS_PLUS] = ACTIONS(2685),
    [anon_sym_sizeof] = ACTIONS(2683),
    [anon_sym___alignof__] = ACTIONS(2683),
    [anon_sym___alignof] = ACTIONS(2683),
    [anon_sym__alignof] = ACTIONS(2683),
    [anon_sym_alignof] = ACTIONS(2683),
    [anon_sym__Alignof] = ACTIONS(2683),
    [anon_sym_offsetof] = ACTIONS(2683),
    [anon_sym__Generic] = ACTIONS(2683),
    [anon_sym_asm] = ACTIONS(2683),
    [anon_sym___asm__] = ACTIONS(2683),
    [aux_sym_number_literal_token1] = ACTIONS(2685),
    [aux_sym_number_literal_token2] = ACTIONS(2683),
    [anon_sym_L_SQUOTE] = ACTIONS(2685),
    [anon_sym_u_SQUOTE] = ACTIONS(2685),
    [anon_sym_U_SQUOTE] = ACTIONS(2685),
    [anon_sym_u8_SQUOTE] = ACTIONS(2685),
    [anon_sym_SQUOTE] = ACTIONS(2685),
    [anon_sym_L_DQUOTE] = ACTIONS(2685),
    [anon_sym_u_DQUOTE] = ACTIONS(2685),
    [anon_sym_U_DQUOTE] = ACTIONS(2685),
    [anon_sym_u8_DQUOTE] = ACTIONS(2685),
    [anon_sym_DQUOTE] = ACTIONS(2685),
    [sym_true] = ACTIONS(2683),
    [sym_false] = ACTIONS(2683),
    [anon_sym_NULL] = ACTIONS(2683),
    [anon_sym_nullptr] = ACTIONS(2683),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2683),
    [anon_sym_decltype] = ACTIONS(2683),
    [anon_sym_virtual] = ACTIONS(2683),
    [anon_sym_alignas] = ACTIONS(2683),
    [anon_sym_explicit] = ACTIONS(2683),
    [anon_sym_typename] = ACTIONS(2683),
    [anon_sym_template] = ACTIONS(2683),
    [anon_sym_operator] = ACTIONS(2683),
    [anon_sym_try] = ACTIONS(2683),
    [anon_sym_delete] = ACTIONS(2683),
    [anon_sym_throw] = ACTIONS(2683),
    [anon_sym_namespace] = ACTIONS(2683),
    [anon_sym_using] = ACTIONS(2683),
    [anon_sym_static_assert] = ACTIONS(2683),
    [anon_sym_concept] = ACTIONS(2683),
    [anon_sym_co_return] = ACTIONS(2683),
    [anon_sym_co_yield] = ACTIONS(2683),
    [anon_sym_R_DQUOTE] = ACTIONS(2685),
    [anon_sym_LR_DQUOTE] = ACTIONS(2685),
    [anon_sym_uR_DQUOTE] = ACTIONS(2685),
    [anon_sym_UR_DQUOTE] = ACTIONS(2685),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2685),
    [anon_sym_co_await] = ACTIONS(2683),
    [anon_sym_new] = ACTIONS(2683),
    [anon_sym_requires] = ACTIONS(2683),
    [sym_this] = ACTIONS(2683),
  },
  [509] = {
    [ts_builtin_sym_end] = ACTIONS(2645),
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [510] = {
    [sym_identifier] = ACTIONS(2709),
    [aux_sym_preproc_include_token1] = ACTIONS(2709),
    [aux_sym_preproc_def_token1] = ACTIONS(2709),
    [aux_sym_preproc_if_token1] = ACTIONS(2709),
    [aux_sym_preproc_if_token2] = ACTIONS(2709),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2709),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2709),
    [sym_preproc_directive] = ACTIONS(2709),
    [anon_sym_LPAREN2] = ACTIONS(2711),
    [anon_sym_BANG] = ACTIONS(2711),
    [anon_sym_TILDE] = ACTIONS(2711),
    [anon_sym_DASH] = ACTIONS(2709),
    [anon_sym_PLUS] = ACTIONS(2709),
    [anon_sym_STAR] = ACTIONS(2711),
    [anon_sym_AMP_AMP] = ACTIONS(2711),
    [anon_sym_AMP] = ACTIONS(2709),
    [anon_sym_SEMI] = ACTIONS(2711),
    [anon_sym___extension__] = ACTIONS(2709),
    [anon_sym_typedef] = ACTIONS(2709),
    [anon_sym_extern] = ACTIONS(2709),
    [anon_sym___attribute__] = ACTIONS(2709),
    [anon_sym_COLON_COLON] = ACTIONS(2711),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2711),
    [anon_sym___declspec] = ACTIONS(2709),
    [anon_sym___based] = ACTIONS(2709),
    [anon_sym___cdecl] = ACTIONS(2709),
    [anon_sym___clrcall] = ACTIONS(2709),
    [anon_sym___stdcall] = ACTIONS(2709),
    [anon_sym___fastcall] = ACTIONS(2709),
    [anon_sym___thiscall] = ACTIONS(2709),
    [anon_sym___vectorcall] = ACTIONS(2709),
    [anon_sym_LBRACE] = ACTIONS(2711),
    [anon_sym_signed] = ACTIONS(2709),
    [anon_sym_unsigned] = ACTIONS(2709),
    [anon_sym_long] = ACTIONS(2709),
    [anon_sym_short] = ACTIONS(2709),
    [anon_sym_LBRACK] = ACTIONS(2709),
    [anon_sym_static] = ACTIONS(2709),
    [anon_sym_register] = ACTIONS(2709),
    [anon_sym_inline] = ACTIONS(2709),
    [anon_sym___inline] = ACTIONS(2709),
    [anon_sym___inline__] = ACTIONS(2709),
    [anon_sym___forceinline] = ACTIONS(2709),
    [anon_sym_thread_local] = ACTIONS(2709),
    [anon_sym___thread] = ACTIONS(2709),
    [anon_sym_const] = ACTIONS(2709),
    [anon_sym_constexpr] = ACTIONS(2709),
    [anon_sym_volatile] = ACTIONS(2709),
    [anon_sym_restrict] = ACTIONS(2709),
    [anon_sym___restrict__] = ACTIONS(2709),
    [anon_sym__Atomic] = ACTIONS(2709),
    [anon_sym__Noreturn] = ACTIONS(2709),
    [anon_sym_noreturn] = ACTIONS(2709),
    [anon_sym_mutable] = ACTIONS(2709),
    [anon_sym_constinit] = ACTIONS(2709),
    [anon_sym_consteval] = ACTIONS(2709),
    [anon_sym_PROGMEM] = ACTIONS(2709),
    [aux_sym_primitive_type_token1] = ACTIONS(2709),
    [anon_sym_byte] = ACTIONS(2709),
    [anon_sym_word] = ACTIONS(2709),
    [anon_sym_enum] = ACTIONS(2709),
    [anon_sym_class] = ACTIONS(2709),
    [anon_sym_struct] = ACTIONS(2709),
    [anon_sym_union] = ACTIONS(2709),
    [anon_sym_if] = ACTIONS(2709),
    [anon_sym_else] = ACTIONS(2709),
    [anon_sym_switch] = ACTIONS(2709),
    [anon_sym_case] = ACTIONS(2709),
    [anon_sym_default] = ACTIONS(2709),
    [anon_sym_while] = ACTIONS(2709),
    [anon_sym_do] = ACTIONS(2709),
    [anon_sym_for] = ACTIONS(2709),
    [anon_sym_return] = ACTIONS(2709),
    [anon_sym_break] = ACTIONS(2709),
    [anon_sym_continue] = ACTIONS(2709),
    [anon_sym_goto] = ACTIONS(2709),
    [anon_sym___try] = ACTIONS(2709),
    [anon_sym___leave] = ACTIONS(2709),
    [anon_sym_not] = ACTIONS(2709),
    [anon_sym_compl] = ACTIONS(2709),
    [anon_sym_DASH_DASH] = ACTIONS(2711),
    [anon_sym_PLUS_PLUS] = ACTIONS(2711),
    [anon_sym_sizeof] = ACTIONS(2709),
    [anon_sym___alignof__] = ACTIONS(2709),
    [anon_sym___alignof] = ACTIONS(2709),
    [anon_sym__alignof] = ACTIONS(2709),
    [anon_sym_alignof] = ACTIONS(2709),
    [anon_sym__Alignof] = ACTIONS(2709),
    [anon_sym_offsetof] = ACTIONS(2709),
    [anon_sym__Generic] = ACTIONS(2709),
    [anon_sym_asm] = ACTIONS(2709),
    [anon_sym___asm__] = ACTIONS(2709),
    [aux_sym_number_literal_token1] = ACTIONS(2711),
    [aux_sym_number_literal_token2] = ACTIONS(2709),
    [anon_sym_L_SQUOTE] = ACTIONS(2711),
    [anon_sym_u_SQUOTE] = ACTIONS(2711),
    [anon_sym_U_SQUOTE] = ACTIONS(2711),
    [anon_sym_u8_SQUOTE] = ACTIONS(2711),
    [anon_sym_SQUOTE] = ACTIONS(2711),
    [anon_sym_L_DQUOTE] = ACTIONS(2711),
    [anon_sym_u_DQUOTE] = ACTIONS(2711),
    [anon_sym_U_DQUOTE] = ACTIONS(2711),
    [anon_sym_u8_DQUOTE] = ACTIONS(2711),
    [anon_sym_DQUOTE] = ACTIONS(2711),
    [sym_true] = ACTIONS(2709),
    [sym_false] = ACTIONS(2709),
    [anon_sym_NULL] = ACTIONS(2709),
    [anon_sym_nullptr] = ACTIONS(2709),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2709),
    [anon_sym_decltype] = ACTIONS(2709),
    [anon_sym_virtual] = ACTIONS(2709),
    [anon_sym_alignas] = ACTIONS(2709),
    [anon_sym_explicit] = ACTIONS(2709),
    [anon_sym_typename] = ACTIONS(2709),
    [anon_sym_template] = ACTIONS(2709),
    [anon_sym_operator] = ACTIONS(2709),
    [anon_sym_try] = ACTIONS(2709),
    [anon_sym_delete] = ACTIONS(2709),
    [anon_sym_throw] = ACTIONS(2709),
    [anon_sym_namespace] = ACTIONS(2709),
    [anon_sym_using] = ACTIONS(2709),
    [anon_sym_static_assert] = ACTIONS(2709),
    [anon_sym_concept] = ACTIONS(2709),
    [anon_sym_co_return] = ACTIONS(2709),
    [anon_sym_co_yield] = ACTIONS(2709),
    [anon_sym_R_DQUOTE] = ACTIONS(2711),
    [anon_sym_LR_DQUOTE] = ACTIONS(2711),
    [anon_sym_uR_DQUOTE] = ACTIONS(2711),
    [anon_sym_UR_DQUOTE] = ACTIONS(2711),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2711),
    [anon_sym_co_await] = ACTIONS(2709),
    [anon_sym_new] = ACTIONS(2709),
    [anon_sym_requires] = ACTIONS(2709),
    [sym_this] = ACTIONS(2709),
  },
  [511] = {
    [ts_builtin_sym_end] = ACTIONS(2512),
    [sym_identifier] = ACTIONS(2507),
    [aux_sym_preproc_include_token1] = ACTIONS(2507),
    [aux_sym_preproc_def_token1] = ACTIONS(2507),
    [aux_sym_preproc_if_token1] = ACTIONS(2507),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2507),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2507),
    [sym_preproc_directive] = ACTIONS(2507),
    [anon_sym_LPAREN2] = ACTIONS(2512),
    [anon_sym_BANG] = ACTIONS(2512),
    [anon_sym_TILDE] = ACTIONS(2512),
    [anon_sym_DASH] = ACTIONS(2507),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_STAR] = ACTIONS(2512),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2507),
    [anon_sym_SEMI] = ACTIONS(2512),
    [anon_sym___extension__] = ACTIONS(2507),
    [anon_sym_typedef] = ACTIONS(2507),
    [anon_sym_extern] = ACTIONS(2507),
    [anon_sym___attribute__] = ACTIONS(2507),
    [anon_sym_COLON_COLON] = ACTIONS(2512),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2512),
    [anon_sym___declspec] = ACTIONS(2507),
    [anon_sym___based] = ACTIONS(2507),
    [anon_sym___cdecl] = ACTIONS(2507),
    [anon_sym___clrcall] = ACTIONS(2507),
    [anon_sym___stdcall] = ACTIONS(2507),
    [anon_sym___fastcall] = ACTIONS(2507),
    [anon_sym___thiscall] = ACTIONS(2507),
    [anon_sym___vectorcall] = ACTIONS(2507),
    [anon_sym_LBRACE] = ACTIONS(2512),
    [anon_sym_signed] = ACTIONS(2507),
    [anon_sym_unsigned] = ACTIONS(2507),
    [anon_sym_long] = ACTIONS(2507),
    [anon_sym_short] = ACTIONS(2507),
    [anon_sym_LBRACK] = ACTIONS(2507),
    [anon_sym_static] = ACTIONS(2507),
    [anon_sym_register] = ACTIONS(2507),
    [anon_sym_inline] = ACTIONS(2507),
    [anon_sym___inline] = ACTIONS(2507),
    [anon_sym___inline__] = ACTIONS(2507),
    [anon_sym___forceinline] = ACTIONS(2507),
    [anon_sym_thread_local] = ACTIONS(2507),
    [anon_sym___thread] = ACTIONS(2507),
    [anon_sym_const] = ACTIONS(2507),
    [anon_sym_constexpr] = ACTIONS(2507),
    [anon_sym_volatile] = ACTIONS(2507),
    [anon_sym_restrict] = ACTIONS(2507),
    [anon_sym___restrict__] = ACTIONS(2507),
    [anon_sym__Atomic] = ACTIONS(2507),
    [anon_sym__Noreturn] = ACTIONS(2507),
    [anon_sym_noreturn] = ACTIONS(2507),
    [anon_sym_mutable] = ACTIONS(2507),
    [anon_sym_constinit] = ACTIONS(2507),
    [anon_sym_consteval] = ACTIONS(2507),
    [anon_sym_PROGMEM] = ACTIONS(2507),
    [aux_sym_primitive_type_token1] = ACTIONS(2507),
    [anon_sym_byte] = ACTIONS(2507),
    [anon_sym_word] = ACTIONS(2507),
    [anon_sym_enum] = ACTIONS(2507),
    [anon_sym_class] = ACTIONS(2507),
    [anon_sym_struct] = ACTIONS(2507),
    [anon_sym_union] = ACTIONS(2507),
    [anon_sym_if] = ACTIONS(2507),
    [anon_sym_else] = ACTIONS(2507),
    [anon_sym_switch] = ACTIONS(2507),
    [anon_sym_case] = ACTIONS(2507),
    [anon_sym_default] = ACTIONS(2507),
    [anon_sym_while] = ACTIONS(2507),
    [anon_sym_do] = ACTIONS(2507),
    [anon_sym_for] = ACTIONS(2507),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_break] = ACTIONS(2507),
    [anon_sym_continue] = ACTIONS(2507),
    [anon_sym_goto] = ACTIONS(2507),
    [anon_sym___try] = ACTIONS(2507),
    [anon_sym___leave] = ACTIONS(2507),
    [anon_sym_not] = ACTIONS(2507),
    [anon_sym_compl] = ACTIONS(2507),
    [anon_sym_DASH_DASH] = ACTIONS(2512),
    [anon_sym_PLUS_PLUS] = ACTIONS(2512),
    [anon_sym_sizeof] = ACTIONS(2507),
    [anon_sym___alignof__] = ACTIONS(2507),
    [anon_sym___alignof] = ACTIONS(2507),
    [anon_sym__alignof] = ACTIONS(2507),
    [anon_sym_alignof] = ACTIONS(2507),
    [anon_sym__Alignof] = ACTIONS(2507),
    [anon_sym_offsetof] = ACTIONS(2507),
    [anon_sym__Generic] = ACTIONS(2507),
    [anon_sym_asm] = ACTIONS(2507),
    [anon_sym___asm__] = ACTIONS(2507),
    [aux_sym_number_literal_token1] = ACTIONS(2512),
    [aux_sym_number_literal_token2] = ACTIONS(2507),
    [anon_sym_L_SQUOTE] = ACTIONS(2512),
    [anon_sym_u_SQUOTE] = ACTIONS(2512),
    [anon_sym_U_SQUOTE] = ACTIONS(2512),
    [anon_sym_u8_SQUOTE] = ACTIONS(2512),
    [anon_sym_SQUOTE] = ACTIONS(2512),
    [anon_sym_L_DQUOTE] = ACTIONS(2512),
    [anon_sym_u_DQUOTE] = ACTIONS(2512),
    [anon_sym_U_DQUOTE] = ACTIONS(2512),
    [anon_sym_u8_DQUOTE] = ACTIONS(2512),
    [anon_sym_DQUOTE] = ACTIONS(2512),
    [sym_true] = ACTIONS(2507),
    [sym_false] = ACTIONS(2507),
    [anon_sym_NULL] = ACTIONS(2507),
    [anon_sym_nullptr] = ACTIONS(2507),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2507),
    [anon_sym_decltype] = ACTIONS(2507),
    [anon_sym_virtual] = ACTIONS(2507),
    [anon_sym_alignas] = ACTIONS(2507),
    [anon_sym_explicit] = ACTIONS(2507),
    [anon_sym_typename] = ACTIONS(2507),
    [anon_sym_template] = ACTIONS(2507),
    [anon_sym_operator] = ACTIONS(2507),
    [anon_sym_try] = ACTIONS(2507),
    [anon_sym_delete] = ACTIONS(2507),
    [anon_sym_throw] = ACTIONS(2507),
    [anon_sym_namespace] = ACTIONS(2507),
    [anon_sym_using] = ACTIONS(2507),
    [anon_sym_static_assert] = ACTIONS(2507),
    [anon_sym_concept] = ACTIONS(2507),
    [anon_sym_co_return] = ACTIONS(2507),
    [anon_sym_co_yield] = ACTIONS(2507),
    [anon_sym_R_DQUOTE] = ACTIONS(2512),
    [anon_sym_LR_DQUOTE] = ACTIONS(2512),
    [anon_sym_uR_DQUOTE] = ACTIONS(2512),
    [anon_sym_UR_DQUOTE] = ACTIONS(2512),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2512),
    [anon_sym_co_await] = ACTIONS(2507),
    [anon_sym_new] = ACTIONS(2507),
    [anon_sym_requires] = ACTIONS(2507),
    [sym_this] = ACTIONS(2507),
  },
  [512] = {
    [sym_identifier] = ACTIONS(2639),
    [aux_sym_preproc_include_token1] = ACTIONS(2639),
    [aux_sym_preproc_def_token1] = ACTIONS(2639),
    [aux_sym_preproc_if_token1] = ACTIONS(2639),
    [aux_sym_preproc_if_token2] = ACTIONS(2639),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2639),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2639),
    [sym_preproc_directive] = ACTIONS(2639),
    [anon_sym_LPAREN2] = ACTIONS(2641),
    [anon_sym_BANG] = ACTIONS(2641),
    [anon_sym_TILDE] = ACTIONS(2641),
    [anon_sym_DASH] = ACTIONS(2639),
    [anon_sym_PLUS] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(2641),
    [anon_sym_AMP_AMP] = ACTIONS(2641),
    [anon_sym_AMP] = ACTIONS(2639),
    [anon_sym_SEMI] = ACTIONS(2641),
    [anon_sym___extension__] = ACTIONS(2639),
    [anon_sym_typedef] = ACTIONS(2639),
    [anon_sym_extern] = ACTIONS(2639),
    [anon_sym___attribute__] = ACTIONS(2639),
    [anon_sym_COLON_COLON] = ACTIONS(2641),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2641),
    [anon_sym___declspec] = ACTIONS(2639),
    [anon_sym___based] = ACTIONS(2639),
    [anon_sym___cdecl] = ACTIONS(2639),
    [anon_sym___clrcall] = ACTIONS(2639),
    [anon_sym___stdcall] = ACTIONS(2639),
    [anon_sym___fastcall] = ACTIONS(2639),
    [anon_sym___thiscall] = ACTIONS(2639),
    [anon_sym___vectorcall] = ACTIONS(2639),
    [anon_sym_LBRACE] = ACTIONS(2641),
    [anon_sym_signed] = ACTIONS(2639),
    [anon_sym_unsigned] = ACTIONS(2639),
    [anon_sym_long] = ACTIONS(2639),
    [anon_sym_short] = ACTIONS(2639),
    [anon_sym_LBRACK] = ACTIONS(2639),
    [anon_sym_static] = ACTIONS(2639),
    [anon_sym_register] = ACTIONS(2639),
    [anon_sym_inline] = ACTIONS(2639),
    [anon_sym___inline] = ACTIONS(2639),
    [anon_sym___inline__] = ACTIONS(2639),
    [anon_sym___forceinline] = ACTIONS(2639),
    [anon_sym_thread_local] = ACTIONS(2639),
    [anon_sym___thread] = ACTIONS(2639),
    [anon_sym_const] = ACTIONS(2639),
    [anon_sym_constexpr] = ACTIONS(2639),
    [anon_sym_volatile] = ACTIONS(2639),
    [anon_sym_restrict] = ACTIONS(2639),
    [anon_sym___restrict__] = ACTIONS(2639),
    [anon_sym__Atomic] = ACTIONS(2639),
    [anon_sym__Noreturn] = ACTIONS(2639),
    [anon_sym_noreturn] = ACTIONS(2639),
    [anon_sym_mutable] = ACTIONS(2639),
    [anon_sym_constinit] = ACTIONS(2639),
    [anon_sym_consteval] = ACTIONS(2639),
    [anon_sym_PROGMEM] = ACTIONS(2639),
    [aux_sym_primitive_type_token1] = ACTIONS(2639),
    [anon_sym_byte] = ACTIONS(2639),
    [anon_sym_word] = ACTIONS(2639),
    [anon_sym_enum] = ACTIONS(2639),
    [anon_sym_class] = ACTIONS(2639),
    [anon_sym_struct] = ACTIONS(2639),
    [anon_sym_union] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2639),
    [anon_sym_else] = ACTIONS(2639),
    [anon_sym_switch] = ACTIONS(2639),
    [anon_sym_case] = ACTIONS(2639),
    [anon_sym_default] = ACTIONS(2639),
    [anon_sym_while] = ACTIONS(2639),
    [anon_sym_do] = ACTIONS(2639),
    [anon_sym_for] = ACTIONS(2639),
    [anon_sym_return] = ACTIONS(2639),
    [anon_sym_break] = ACTIONS(2639),
    [anon_sym_continue] = ACTIONS(2639),
    [anon_sym_goto] = ACTIONS(2639),
    [anon_sym___try] = ACTIONS(2639),
    [anon_sym___leave] = ACTIONS(2639),
    [anon_sym_not] = ACTIONS(2639),
    [anon_sym_compl] = ACTIONS(2639),
    [anon_sym_DASH_DASH] = ACTIONS(2641),
    [anon_sym_PLUS_PLUS] = ACTIONS(2641),
    [anon_sym_sizeof] = ACTIONS(2639),
    [anon_sym___alignof__] = ACTIONS(2639),
    [anon_sym___alignof] = ACTIONS(2639),
    [anon_sym__alignof] = ACTIONS(2639),
    [anon_sym_alignof] = ACTIONS(2639),
    [anon_sym__Alignof] = ACTIONS(2639),
    [anon_sym_offsetof] = ACTIONS(2639),
    [anon_sym__Generic] = ACTIONS(2639),
    [anon_sym_asm] = ACTIONS(2639),
    [anon_sym___asm__] = ACTIONS(2639),
    [aux_sym_number_literal_token1] = ACTIONS(2641),
    [aux_sym_number_literal_token2] = ACTIONS(2639),
    [anon_sym_L_SQUOTE] = ACTIONS(2641),
    [anon_sym_u_SQUOTE] = ACTIONS(2641),
    [anon_sym_U_SQUOTE] = ACTIONS(2641),
    [anon_sym_u8_SQUOTE] = ACTIONS(2641),
    [anon_sym_SQUOTE] = ACTIONS(2641),
    [anon_sym_L_DQUOTE] = ACTIONS(2641),
    [anon_sym_u_DQUOTE] = ACTIONS(2641),
    [anon_sym_U_DQUOTE] = ACTIONS(2641),
    [anon_sym_u8_DQUOTE] = ACTIONS(2641),
    [anon_sym_DQUOTE] = ACTIONS(2641),
    [sym_true] = ACTIONS(2639),
    [sym_false] = ACTIONS(2639),
    [anon_sym_NULL] = ACTIONS(2639),
    [anon_sym_nullptr] = ACTIONS(2639),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2639),
    [anon_sym_decltype] = ACTIONS(2639),
    [anon_sym_virtual] = ACTIONS(2639),
    [anon_sym_alignas] = ACTIONS(2639),
    [anon_sym_explicit] = ACTIONS(2639),
    [anon_sym_typename] = ACTIONS(2639),
    [anon_sym_template] = ACTIONS(2639),
    [anon_sym_operator] = ACTIONS(2639),
    [anon_sym_try] = ACTIONS(2639),
    [anon_sym_delete] = ACTIONS(2639),
    [anon_sym_throw] = ACTIONS(2639),
    [anon_sym_namespace] = ACTIONS(2639),
    [anon_sym_using] = ACTIONS(2639),
    [anon_sym_static_assert] = ACTIONS(2639),
    [anon_sym_concept] = ACTIONS(2639),
    [anon_sym_co_return] = ACTIONS(2639),
    [anon_sym_co_yield] = ACTIONS(2639),
    [anon_sym_R_DQUOTE] = ACTIONS(2641),
    [anon_sym_LR_DQUOTE] = ACTIONS(2641),
    [anon_sym_uR_DQUOTE] = ACTIONS(2641),
    [anon_sym_UR_DQUOTE] = ACTIONS(2641),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2641),
    [anon_sym_co_await] = ACTIONS(2639),
    [anon_sym_new] = ACTIONS(2639),
    [anon_sym_requires] = ACTIONS(2639),
    [sym_this] = ACTIONS(2639),
  },
  [513] = {
    [sym_identifier] = ACTIONS(2639),
    [aux_sym_preproc_include_token1] = ACTIONS(2639),
    [aux_sym_preproc_def_token1] = ACTIONS(2639),
    [aux_sym_preproc_if_token1] = ACTIONS(2639),
    [aux_sym_preproc_if_token2] = ACTIONS(2639),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2639),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2639),
    [sym_preproc_directive] = ACTIONS(2639),
    [anon_sym_LPAREN2] = ACTIONS(2641),
    [anon_sym_BANG] = ACTIONS(2641),
    [anon_sym_TILDE] = ACTIONS(2641),
    [anon_sym_DASH] = ACTIONS(2639),
    [anon_sym_PLUS] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(2641),
    [anon_sym_AMP_AMP] = ACTIONS(2641),
    [anon_sym_AMP] = ACTIONS(2639),
    [anon_sym_SEMI] = ACTIONS(2641),
    [anon_sym___extension__] = ACTIONS(2639),
    [anon_sym_typedef] = ACTIONS(2639),
    [anon_sym_extern] = ACTIONS(2639),
    [anon_sym___attribute__] = ACTIONS(2639),
    [anon_sym_COLON_COLON] = ACTIONS(2641),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2641),
    [anon_sym___declspec] = ACTIONS(2639),
    [anon_sym___based] = ACTIONS(2639),
    [anon_sym___cdecl] = ACTIONS(2639),
    [anon_sym___clrcall] = ACTIONS(2639),
    [anon_sym___stdcall] = ACTIONS(2639),
    [anon_sym___fastcall] = ACTIONS(2639),
    [anon_sym___thiscall] = ACTIONS(2639),
    [anon_sym___vectorcall] = ACTIONS(2639),
    [anon_sym_LBRACE] = ACTIONS(2641),
    [anon_sym_signed] = ACTIONS(2639),
    [anon_sym_unsigned] = ACTIONS(2639),
    [anon_sym_long] = ACTIONS(2639),
    [anon_sym_short] = ACTIONS(2639),
    [anon_sym_LBRACK] = ACTIONS(2639),
    [anon_sym_static] = ACTIONS(2639),
    [anon_sym_register] = ACTIONS(2639),
    [anon_sym_inline] = ACTIONS(2639),
    [anon_sym___inline] = ACTIONS(2639),
    [anon_sym___inline__] = ACTIONS(2639),
    [anon_sym___forceinline] = ACTIONS(2639),
    [anon_sym_thread_local] = ACTIONS(2639),
    [anon_sym___thread] = ACTIONS(2639),
    [anon_sym_const] = ACTIONS(2639),
    [anon_sym_constexpr] = ACTIONS(2639),
    [anon_sym_volatile] = ACTIONS(2639),
    [anon_sym_restrict] = ACTIONS(2639),
    [anon_sym___restrict__] = ACTIONS(2639),
    [anon_sym__Atomic] = ACTIONS(2639),
    [anon_sym__Noreturn] = ACTIONS(2639),
    [anon_sym_noreturn] = ACTIONS(2639),
    [anon_sym_mutable] = ACTIONS(2639),
    [anon_sym_constinit] = ACTIONS(2639),
    [anon_sym_consteval] = ACTIONS(2639),
    [anon_sym_PROGMEM] = ACTIONS(2639),
    [aux_sym_primitive_type_token1] = ACTIONS(2639),
    [anon_sym_byte] = ACTIONS(2639),
    [anon_sym_word] = ACTIONS(2639),
    [anon_sym_enum] = ACTIONS(2639),
    [anon_sym_class] = ACTIONS(2639),
    [anon_sym_struct] = ACTIONS(2639),
    [anon_sym_union] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2639),
    [anon_sym_else] = ACTIONS(2639),
    [anon_sym_switch] = ACTIONS(2639),
    [anon_sym_case] = ACTIONS(2639),
    [anon_sym_default] = ACTIONS(2639),
    [anon_sym_while] = ACTIONS(2639),
    [anon_sym_do] = ACTIONS(2639),
    [anon_sym_for] = ACTIONS(2639),
    [anon_sym_return] = ACTIONS(2639),
    [anon_sym_break] = ACTIONS(2639),
    [anon_sym_continue] = ACTIONS(2639),
    [anon_sym_goto] = ACTIONS(2639),
    [anon_sym___try] = ACTIONS(2639),
    [anon_sym___leave] = ACTIONS(2639),
    [anon_sym_not] = ACTIONS(2639),
    [anon_sym_compl] = ACTIONS(2639),
    [anon_sym_DASH_DASH] = ACTIONS(2641),
    [anon_sym_PLUS_PLUS] = ACTIONS(2641),
    [anon_sym_sizeof] = ACTIONS(2639),
    [anon_sym___alignof__] = ACTIONS(2639),
    [anon_sym___alignof] = ACTIONS(2639),
    [anon_sym__alignof] = ACTIONS(2639),
    [anon_sym_alignof] = ACTIONS(2639),
    [anon_sym__Alignof] = ACTIONS(2639),
    [anon_sym_offsetof] = ACTIONS(2639),
    [anon_sym__Generic] = ACTIONS(2639),
    [anon_sym_asm] = ACTIONS(2639),
    [anon_sym___asm__] = ACTIONS(2639),
    [aux_sym_number_literal_token1] = ACTIONS(2641),
    [aux_sym_number_literal_token2] = ACTIONS(2639),
    [anon_sym_L_SQUOTE] = ACTIONS(2641),
    [anon_sym_u_SQUOTE] = ACTIONS(2641),
    [anon_sym_U_SQUOTE] = ACTIONS(2641),
    [anon_sym_u8_SQUOTE] = ACTIONS(2641),
    [anon_sym_SQUOTE] = ACTIONS(2641),
    [anon_sym_L_DQUOTE] = ACTIONS(2641),
    [anon_sym_u_DQUOTE] = ACTIONS(2641),
    [anon_sym_U_DQUOTE] = ACTIONS(2641),
    [anon_sym_u8_DQUOTE] = ACTIONS(2641),
    [anon_sym_DQUOTE] = ACTIONS(2641),
    [sym_true] = ACTIONS(2639),
    [sym_false] = ACTIONS(2639),
    [anon_sym_NULL] = ACTIONS(2639),
    [anon_sym_nullptr] = ACTIONS(2639),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2639),
    [anon_sym_decltype] = ACTIONS(2639),
    [anon_sym_virtual] = ACTIONS(2639),
    [anon_sym_alignas] = ACTIONS(2639),
    [anon_sym_explicit] = ACTIONS(2639),
    [anon_sym_typename] = ACTIONS(2639),
    [anon_sym_template] = ACTIONS(2639),
    [anon_sym_operator] = ACTIONS(2639),
    [anon_sym_try] = ACTIONS(2639),
    [anon_sym_delete] = ACTIONS(2639),
    [anon_sym_throw] = ACTIONS(2639),
    [anon_sym_namespace] = ACTIONS(2639),
    [anon_sym_using] = ACTIONS(2639),
    [anon_sym_static_assert] = ACTIONS(2639),
    [anon_sym_concept] = ACTIONS(2639),
    [anon_sym_co_return] = ACTIONS(2639),
    [anon_sym_co_yield] = ACTIONS(2639),
    [anon_sym_R_DQUOTE] = ACTIONS(2641),
    [anon_sym_LR_DQUOTE] = ACTIONS(2641),
    [anon_sym_uR_DQUOTE] = ACTIONS(2641),
    [anon_sym_UR_DQUOTE] = ACTIONS(2641),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2641),
    [anon_sym_co_await] = ACTIONS(2639),
    [anon_sym_new] = ACTIONS(2639),
    [anon_sym_requires] = ACTIONS(2639),
    [sym_this] = ACTIONS(2639),
  },
  [514] = {
    [ts_builtin_sym_end] = ACTIONS(2753),
    [sym_identifier] = ACTIONS(2751),
    [aux_sym_preproc_include_token1] = ACTIONS(2751),
    [aux_sym_preproc_def_token1] = ACTIONS(2751),
    [aux_sym_preproc_if_token1] = ACTIONS(2751),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2751),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2751),
    [sym_preproc_directive] = ACTIONS(2751),
    [anon_sym_LPAREN2] = ACTIONS(2753),
    [anon_sym_BANG] = ACTIONS(2753),
    [anon_sym_TILDE] = ACTIONS(2753),
    [anon_sym_DASH] = ACTIONS(2751),
    [anon_sym_PLUS] = ACTIONS(2751),
    [anon_sym_STAR] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2751),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym___extension__] = ACTIONS(2751),
    [anon_sym_typedef] = ACTIONS(2751),
    [anon_sym_extern] = ACTIONS(2751),
    [anon_sym___attribute__] = ACTIONS(2751),
    [anon_sym_COLON_COLON] = ACTIONS(2753),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2753),
    [anon_sym___declspec] = ACTIONS(2751),
    [anon_sym___based] = ACTIONS(2751),
    [anon_sym___cdecl] = ACTIONS(2751),
    [anon_sym___clrcall] = ACTIONS(2751),
    [anon_sym___stdcall] = ACTIONS(2751),
    [anon_sym___fastcall] = ACTIONS(2751),
    [anon_sym___thiscall] = ACTIONS(2751),
    [anon_sym___vectorcall] = ACTIONS(2751),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_signed] = ACTIONS(2751),
    [anon_sym_unsigned] = ACTIONS(2751),
    [anon_sym_long] = ACTIONS(2751),
    [anon_sym_short] = ACTIONS(2751),
    [anon_sym_LBRACK] = ACTIONS(2751),
    [anon_sym_static] = ACTIONS(2751),
    [anon_sym_register] = ACTIONS(2751),
    [anon_sym_inline] = ACTIONS(2751),
    [anon_sym___inline] = ACTIONS(2751),
    [anon_sym___inline__] = ACTIONS(2751),
    [anon_sym___forceinline] = ACTIONS(2751),
    [anon_sym_thread_local] = ACTIONS(2751),
    [anon_sym___thread] = ACTIONS(2751),
    [anon_sym_const] = ACTIONS(2751),
    [anon_sym_constexpr] = ACTIONS(2751),
    [anon_sym_volatile] = ACTIONS(2751),
    [anon_sym_restrict] = ACTIONS(2751),
    [anon_sym___restrict__] = ACTIONS(2751),
    [anon_sym__Atomic] = ACTIONS(2751),
    [anon_sym__Noreturn] = ACTIONS(2751),
    [anon_sym_noreturn] = ACTIONS(2751),
    [anon_sym_mutable] = ACTIONS(2751),
    [anon_sym_constinit] = ACTIONS(2751),
    [anon_sym_consteval] = ACTIONS(2751),
    [anon_sym_PROGMEM] = ACTIONS(2751),
    [aux_sym_primitive_type_token1] = ACTIONS(2751),
    [anon_sym_byte] = ACTIONS(2751),
    [anon_sym_word] = ACTIONS(2751),
    [anon_sym_enum] = ACTIONS(2751),
    [anon_sym_class] = ACTIONS(2751),
    [anon_sym_struct] = ACTIONS(2751),
    [anon_sym_union] = ACTIONS(2751),
    [anon_sym_if] = ACTIONS(2751),
    [anon_sym_else] = ACTIONS(2751),
    [anon_sym_switch] = ACTIONS(2751),
    [anon_sym_case] = ACTIONS(2751),
    [anon_sym_default] = ACTIONS(2751),
    [anon_sym_while] = ACTIONS(2751),
    [anon_sym_do] = ACTIONS(2751),
    [anon_sym_for] = ACTIONS(2751),
    [anon_sym_return] = ACTIONS(2751),
    [anon_sym_break] = ACTIONS(2751),
    [anon_sym_continue] = ACTIONS(2751),
    [anon_sym_goto] = ACTIONS(2751),
    [anon_sym___try] = ACTIONS(2751),
    [anon_sym___leave] = ACTIONS(2751),
    [anon_sym_not] = ACTIONS(2751),
    [anon_sym_compl] = ACTIONS(2751),
    [anon_sym_DASH_DASH] = ACTIONS(2753),
    [anon_sym_PLUS_PLUS] = ACTIONS(2753),
    [anon_sym_sizeof] = ACTIONS(2751),
    [anon_sym___alignof__] = ACTIONS(2751),
    [anon_sym___alignof] = ACTIONS(2751),
    [anon_sym__alignof] = ACTIONS(2751),
    [anon_sym_alignof] = ACTIONS(2751),
    [anon_sym__Alignof] = ACTIONS(2751),
    [anon_sym_offsetof] = ACTIONS(2751),
    [anon_sym__Generic] = ACTIONS(2751),
    [anon_sym_asm] = ACTIONS(2751),
    [anon_sym___asm__] = ACTIONS(2751),
    [aux_sym_number_literal_token1] = ACTIONS(2753),
    [aux_sym_number_literal_token2] = ACTIONS(2751),
    [anon_sym_L_SQUOTE] = ACTIONS(2753),
    [anon_sym_u_SQUOTE] = ACTIONS(2753),
    [anon_sym_U_SQUOTE] = ACTIONS(2753),
    [anon_sym_u8_SQUOTE] = ACTIONS(2753),
    [anon_sym_SQUOTE] = ACTIONS(2753),
    [anon_sym_L_DQUOTE] = ACTIONS(2753),
    [anon_sym_u_DQUOTE] = ACTIONS(2753),
    [anon_sym_U_DQUOTE] = ACTIONS(2753),
    [anon_sym_u8_DQUOTE] = ACTIONS(2753),
    [anon_sym_DQUOTE] = ACTIONS(2753),
    [sym_true] = ACTIONS(2751),
    [sym_false] = ACTIONS(2751),
    [anon_sym_NULL] = ACTIONS(2751),
    [anon_sym_nullptr] = ACTIONS(2751),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2751),
    [anon_sym_decltype] = ACTIONS(2751),
    [anon_sym_virtual] = ACTIONS(2751),
    [anon_sym_alignas] = ACTIONS(2751),
    [anon_sym_explicit] = ACTIONS(2751),
    [anon_sym_typename] = ACTIONS(2751),
    [anon_sym_template] = ACTIONS(2751),
    [anon_sym_operator] = ACTIONS(2751),
    [anon_sym_try] = ACTIONS(2751),
    [anon_sym_delete] = ACTIONS(2751),
    [anon_sym_throw] = ACTIONS(2751),
    [anon_sym_namespace] = ACTIONS(2751),
    [anon_sym_using] = ACTIONS(2751),
    [anon_sym_static_assert] = ACTIONS(2751),
    [anon_sym_concept] = ACTIONS(2751),
    [anon_sym_co_return] = ACTIONS(2751),
    [anon_sym_co_yield] = ACTIONS(2751),
    [anon_sym_R_DQUOTE] = ACTIONS(2753),
    [anon_sym_LR_DQUOTE] = ACTIONS(2753),
    [anon_sym_uR_DQUOTE] = ACTIONS(2753),
    [anon_sym_UR_DQUOTE] = ACTIONS(2753),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2753),
    [anon_sym_co_await] = ACTIONS(2751),
    [anon_sym_new] = ACTIONS(2751),
    [anon_sym_requires] = ACTIONS(2751),
    [sym_this] = ACTIONS(2751),
  },
  [515] = {
    [sym_identifier] = ACTIONS(2713),
    [aux_sym_preproc_include_token1] = ACTIONS(2713),
    [aux_sym_preproc_def_token1] = ACTIONS(2713),
    [aux_sym_preproc_if_token1] = ACTIONS(2713),
    [aux_sym_preproc_if_token2] = ACTIONS(2713),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2713),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2713),
    [sym_preproc_directive] = ACTIONS(2713),
    [anon_sym_LPAREN2] = ACTIONS(2715),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_DASH] = ACTIONS(2713),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_STAR] = ACTIONS(2715),
    [anon_sym_AMP_AMP] = ACTIONS(2715),
    [anon_sym_AMP] = ACTIONS(2713),
    [anon_sym_SEMI] = ACTIONS(2715),
    [anon_sym___extension__] = ACTIONS(2713),
    [anon_sym_typedef] = ACTIONS(2713),
    [anon_sym_extern] = ACTIONS(2713),
    [anon_sym___attribute__] = ACTIONS(2713),
    [anon_sym_COLON_COLON] = ACTIONS(2715),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2715),
    [anon_sym___declspec] = ACTIONS(2713),
    [anon_sym___based] = ACTIONS(2713),
    [anon_sym___cdecl] = ACTIONS(2713),
    [anon_sym___clrcall] = ACTIONS(2713),
    [anon_sym___stdcall] = ACTIONS(2713),
    [anon_sym___fastcall] = ACTIONS(2713),
    [anon_sym___thiscall] = ACTIONS(2713),
    [anon_sym___vectorcall] = ACTIONS(2713),
    [anon_sym_LBRACE] = ACTIONS(2715),
    [anon_sym_signed] = ACTIONS(2713),
    [anon_sym_unsigned] = ACTIONS(2713),
    [anon_sym_long] = ACTIONS(2713),
    [anon_sym_short] = ACTIONS(2713),
    [anon_sym_LBRACK] = ACTIONS(2713),
    [anon_sym_static] = ACTIONS(2713),
    [anon_sym_register] = ACTIONS(2713),
    [anon_sym_inline] = ACTIONS(2713),
    [anon_sym___inline] = ACTIONS(2713),
    [anon_sym___inline__] = ACTIONS(2713),
    [anon_sym___forceinline] = ACTIONS(2713),
    [anon_sym_thread_local] = ACTIONS(2713),
    [anon_sym___thread] = ACTIONS(2713),
    [anon_sym_const] = ACTIONS(2713),
    [anon_sym_constexpr] = ACTIONS(2713),
    [anon_sym_volatile] = ACTIONS(2713),
    [anon_sym_restrict] = ACTIONS(2713),
    [anon_sym___restrict__] = ACTIONS(2713),
    [anon_sym__Atomic] = ACTIONS(2713),
    [anon_sym__Noreturn] = ACTIONS(2713),
    [anon_sym_noreturn] = ACTIONS(2713),
    [anon_sym_mutable] = ACTIONS(2713),
    [anon_sym_constinit] = ACTIONS(2713),
    [anon_sym_consteval] = ACTIONS(2713),
    [anon_sym_PROGMEM] = ACTIONS(2713),
    [aux_sym_primitive_type_token1] = ACTIONS(2713),
    [anon_sym_byte] = ACTIONS(2713),
    [anon_sym_word] = ACTIONS(2713),
    [anon_sym_enum] = ACTIONS(2713),
    [anon_sym_class] = ACTIONS(2713),
    [anon_sym_struct] = ACTIONS(2713),
    [anon_sym_union] = ACTIONS(2713),
    [anon_sym_if] = ACTIONS(2713),
    [anon_sym_else] = ACTIONS(2713),
    [anon_sym_switch] = ACTIONS(2713),
    [anon_sym_case] = ACTIONS(2713),
    [anon_sym_default] = ACTIONS(2713),
    [anon_sym_while] = ACTIONS(2713),
    [anon_sym_do] = ACTIONS(2713),
    [anon_sym_for] = ACTIONS(2713),
    [anon_sym_return] = ACTIONS(2713),
    [anon_sym_break] = ACTIONS(2713),
    [anon_sym_continue] = ACTIONS(2713),
    [anon_sym_goto] = ACTIONS(2713),
    [anon_sym___try] = ACTIONS(2713),
    [anon_sym___leave] = ACTIONS(2713),
    [anon_sym_not] = ACTIONS(2713),
    [anon_sym_compl] = ACTIONS(2713),
    [anon_sym_DASH_DASH] = ACTIONS(2715),
    [anon_sym_PLUS_PLUS] = ACTIONS(2715),
    [anon_sym_sizeof] = ACTIONS(2713),
    [anon_sym___alignof__] = ACTIONS(2713),
    [anon_sym___alignof] = ACTIONS(2713),
    [anon_sym__alignof] = ACTIONS(2713),
    [anon_sym_alignof] = ACTIONS(2713),
    [anon_sym__Alignof] = ACTIONS(2713),
    [anon_sym_offsetof] = ACTIONS(2713),
    [anon_sym__Generic] = ACTIONS(2713),
    [anon_sym_asm] = ACTIONS(2713),
    [anon_sym___asm__] = ACTIONS(2713),
    [aux_sym_number_literal_token1] = ACTIONS(2715),
    [aux_sym_number_literal_token2] = ACTIONS(2713),
    [anon_sym_L_SQUOTE] = ACTIONS(2715),
    [anon_sym_u_SQUOTE] = ACTIONS(2715),
    [anon_sym_U_SQUOTE] = ACTIONS(2715),
    [anon_sym_u8_SQUOTE] = ACTIONS(2715),
    [anon_sym_SQUOTE] = ACTIONS(2715),
    [anon_sym_L_DQUOTE] = ACTIONS(2715),
    [anon_sym_u_DQUOTE] = ACTIONS(2715),
    [anon_sym_U_DQUOTE] = ACTIONS(2715),
    [anon_sym_u8_DQUOTE] = ACTIONS(2715),
    [anon_sym_DQUOTE] = ACTIONS(2715),
    [sym_true] = ACTIONS(2713),
    [sym_false] = ACTIONS(2713),
    [anon_sym_NULL] = ACTIONS(2713),
    [anon_sym_nullptr] = ACTIONS(2713),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2713),
    [anon_sym_decltype] = ACTIONS(2713),
    [anon_sym_virtual] = ACTIONS(2713),
    [anon_sym_alignas] = ACTIONS(2713),
    [anon_sym_explicit] = ACTIONS(2713),
    [anon_sym_typename] = ACTIONS(2713),
    [anon_sym_template] = ACTIONS(2713),
    [anon_sym_operator] = ACTIONS(2713),
    [anon_sym_try] = ACTIONS(2713),
    [anon_sym_delete] = ACTIONS(2713),
    [anon_sym_throw] = ACTIONS(2713),
    [anon_sym_namespace] = ACTIONS(2713),
    [anon_sym_using] = ACTIONS(2713),
    [anon_sym_static_assert] = ACTIONS(2713),
    [anon_sym_concept] = ACTIONS(2713),
    [anon_sym_co_return] = ACTIONS(2713),
    [anon_sym_co_yield] = ACTIONS(2713),
    [anon_sym_R_DQUOTE] = ACTIONS(2715),
    [anon_sym_LR_DQUOTE] = ACTIONS(2715),
    [anon_sym_uR_DQUOTE] = ACTIONS(2715),
    [anon_sym_UR_DQUOTE] = ACTIONS(2715),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2715),
    [anon_sym_co_await] = ACTIONS(2713),
    [anon_sym_new] = ACTIONS(2713),
    [anon_sym_requires] = ACTIONS(2713),
    [sym_this] = ACTIONS(2713),
  },
  [516] = {
    [sym_identifier] = ACTIONS(2723),
    [aux_sym_preproc_include_token1] = ACTIONS(2723),
    [aux_sym_preproc_def_token1] = ACTIONS(2723),
    [aux_sym_preproc_if_token1] = ACTIONS(2723),
    [aux_sym_preproc_if_token2] = ACTIONS(2723),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2723),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2723),
    [sym_preproc_directive] = ACTIONS(2723),
    [anon_sym_LPAREN2] = ACTIONS(2725),
    [anon_sym_BANG] = ACTIONS(2725),
    [anon_sym_TILDE] = ACTIONS(2725),
    [anon_sym_DASH] = ACTIONS(2723),
    [anon_sym_PLUS] = ACTIONS(2723),
    [anon_sym_STAR] = ACTIONS(2725),
    [anon_sym_AMP_AMP] = ACTIONS(2725),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_SEMI] = ACTIONS(2725),
    [anon_sym___extension__] = ACTIONS(2723),
    [anon_sym_typedef] = ACTIONS(2723),
    [anon_sym_extern] = ACTIONS(2723),
    [anon_sym___attribute__] = ACTIONS(2723),
    [anon_sym_COLON_COLON] = ACTIONS(2725),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2725),
    [anon_sym___declspec] = ACTIONS(2723),
    [anon_sym___based] = ACTIONS(2723),
    [anon_sym___cdecl] = ACTIONS(2723),
    [anon_sym___clrcall] = ACTIONS(2723),
    [anon_sym___stdcall] = ACTIONS(2723),
    [anon_sym___fastcall] = ACTIONS(2723),
    [anon_sym___thiscall] = ACTIONS(2723),
    [anon_sym___vectorcall] = ACTIONS(2723),
    [anon_sym_LBRACE] = ACTIONS(2725),
    [anon_sym_signed] = ACTIONS(2723),
    [anon_sym_unsigned] = ACTIONS(2723),
    [anon_sym_long] = ACTIONS(2723),
    [anon_sym_short] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_static] = ACTIONS(2723),
    [anon_sym_register] = ACTIONS(2723),
    [anon_sym_inline] = ACTIONS(2723),
    [anon_sym___inline] = ACTIONS(2723),
    [anon_sym___inline__] = ACTIONS(2723),
    [anon_sym___forceinline] = ACTIONS(2723),
    [anon_sym_thread_local] = ACTIONS(2723),
    [anon_sym___thread] = ACTIONS(2723),
    [anon_sym_const] = ACTIONS(2723),
    [anon_sym_constexpr] = ACTIONS(2723),
    [anon_sym_volatile] = ACTIONS(2723),
    [anon_sym_restrict] = ACTIONS(2723),
    [anon_sym___restrict__] = ACTIONS(2723),
    [anon_sym__Atomic] = ACTIONS(2723),
    [anon_sym__Noreturn] = ACTIONS(2723),
    [anon_sym_noreturn] = ACTIONS(2723),
    [anon_sym_mutable] = ACTIONS(2723),
    [anon_sym_constinit] = ACTIONS(2723),
    [anon_sym_consteval] = ACTIONS(2723),
    [anon_sym_PROGMEM] = ACTIONS(2723),
    [aux_sym_primitive_type_token1] = ACTIONS(2723),
    [anon_sym_byte] = ACTIONS(2723),
    [anon_sym_word] = ACTIONS(2723),
    [anon_sym_enum] = ACTIONS(2723),
    [anon_sym_class] = ACTIONS(2723),
    [anon_sym_struct] = ACTIONS(2723),
    [anon_sym_union] = ACTIONS(2723),
    [anon_sym_if] = ACTIONS(2723),
    [anon_sym_else] = ACTIONS(2723),
    [anon_sym_switch] = ACTIONS(2723),
    [anon_sym_case] = ACTIONS(2723),
    [anon_sym_default] = ACTIONS(2723),
    [anon_sym_while] = ACTIONS(2723),
    [anon_sym_do] = ACTIONS(2723),
    [anon_sym_for] = ACTIONS(2723),
    [anon_sym_return] = ACTIONS(2723),
    [anon_sym_break] = ACTIONS(2723),
    [anon_sym_continue] = ACTIONS(2723),
    [anon_sym_goto] = ACTIONS(2723),
    [anon_sym___try] = ACTIONS(2723),
    [anon_sym___leave] = ACTIONS(2723),
    [anon_sym_not] = ACTIONS(2723),
    [anon_sym_compl] = ACTIONS(2723),
    [anon_sym_DASH_DASH] = ACTIONS(2725),
    [anon_sym_PLUS_PLUS] = ACTIONS(2725),
    [anon_sym_sizeof] = ACTIONS(2723),
    [anon_sym___alignof__] = ACTIONS(2723),
    [anon_sym___alignof] = ACTIONS(2723),
    [anon_sym__alignof] = ACTIONS(2723),
    [anon_sym_alignof] = ACTIONS(2723),
    [anon_sym__Alignof] = ACTIONS(2723),
    [anon_sym_offsetof] = ACTIONS(2723),
    [anon_sym__Generic] = ACTIONS(2723),
    [anon_sym_asm] = ACTIONS(2723),
    [anon_sym___asm__] = ACTIONS(2723),
    [aux_sym_number_literal_token1] = ACTIONS(2725),
    [aux_sym_number_literal_token2] = ACTIONS(2723),
    [anon_sym_L_SQUOTE] = ACTIONS(2725),
    [anon_sym_u_SQUOTE] = ACTIONS(2725),
    [anon_sym_U_SQUOTE] = ACTIONS(2725),
    [anon_sym_u8_SQUOTE] = ACTIONS(2725),
    [anon_sym_SQUOTE] = ACTIONS(2725),
    [anon_sym_L_DQUOTE] = ACTIONS(2725),
    [anon_sym_u_DQUOTE] = ACTIONS(2725),
    [anon_sym_U_DQUOTE] = ACTIONS(2725),
    [anon_sym_u8_DQUOTE] = ACTIONS(2725),
    [anon_sym_DQUOTE] = ACTIONS(2725),
    [sym_true] = ACTIONS(2723),
    [sym_false] = ACTIONS(2723),
    [anon_sym_NULL] = ACTIONS(2723),
    [anon_sym_nullptr] = ACTIONS(2723),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2723),
    [anon_sym_decltype] = ACTIONS(2723),
    [anon_sym_virtual] = ACTIONS(2723),
    [anon_sym_alignas] = ACTIONS(2723),
    [anon_sym_explicit] = ACTIONS(2723),
    [anon_sym_typename] = ACTIONS(2723),
    [anon_sym_template] = ACTIONS(2723),
    [anon_sym_operator] = ACTIONS(2723),
    [anon_sym_try] = ACTIONS(2723),
    [anon_sym_delete] = ACTIONS(2723),
    [anon_sym_throw] = ACTIONS(2723),
    [anon_sym_namespace] = ACTIONS(2723),
    [anon_sym_using] = ACTIONS(2723),
    [anon_sym_static_assert] = ACTIONS(2723),
    [anon_sym_concept] = ACTIONS(2723),
    [anon_sym_co_return] = ACTIONS(2723),
    [anon_sym_co_yield] = ACTIONS(2723),
    [anon_sym_R_DQUOTE] = ACTIONS(2725),
    [anon_sym_LR_DQUOTE] = ACTIONS(2725),
    [anon_sym_uR_DQUOTE] = ACTIONS(2725),
    [anon_sym_UR_DQUOTE] = ACTIONS(2725),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2725),
    [anon_sym_co_await] = ACTIONS(2723),
    [anon_sym_new] = ACTIONS(2723),
    [anon_sym_requires] = ACTIONS(2723),
    [sym_this] = ACTIONS(2723),
  },
  [517] = {
    [sym_identifier] = ACTIONS(2717),
    [aux_sym_preproc_include_token1] = ACTIONS(2717),
    [aux_sym_preproc_def_token1] = ACTIONS(2717),
    [aux_sym_preproc_if_token1] = ACTIONS(2717),
    [aux_sym_preproc_if_token2] = ACTIONS(2717),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2717),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2717),
    [sym_preproc_directive] = ACTIONS(2717),
    [anon_sym_LPAREN2] = ACTIONS(2719),
    [anon_sym_BANG] = ACTIONS(2719),
    [anon_sym_TILDE] = ACTIONS(2719),
    [anon_sym_DASH] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP_AMP] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2717),
    [anon_sym_SEMI] = ACTIONS(2719),
    [anon_sym___extension__] = ACTIONS(2717),
    [anon_sym_typedef] = ACTIONS(2717),
    [anon_sym_extern] = ACTIONS(2717),
    [anon_sym___attribute__] = ACTIONS(2717),
    [anon_sym_COLON_COLON] = ACTIONS(2719),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2719),
    [anon_sym___declspec] = ACTIONS(2717),
    [anon_sym___based] = ACTIONS(2717),
    [anon_sym___cdecl] = ACTIONS(2717),
    [anon_sym___clrcall] = ACTIONS(2717),
    [anon_sym___stdcall] = ACTIONS(2717),
    [anon_sym___fastcall] = ACTIONS(2717),
    [anon_sym___thiscall] = ACTIONS(2717),
    [anon_sym___vectorcall] = ACTIONS(2717),
    [anon_sym_LBRACE] = ACTIONS(2719),
    [anon_sym_signed] = ACTIONS(2717),
    [anon_sym_unsigned] = ACTIONS(2717),
    [anon_sym_long] = ACTIONS(2717),
    [anon_sym_short] = ACTIONS(2717),
    [anon_sym_LBRACK] = ACTIONS(2717),
    [anon_sym_static] = ACTIONS(2717),
    [anon_sym_register] = ACTIONS(2717),
    [anon_sym_inline] = ACTIONS(2717),
    [anon_sym___inline] = ACTIONS(2717),
    [anon_sym___inline__] = ACTIONS(2717),
    [anon_sym___forceinline] = ACTIONS(2717),
    [anon_sym_thread_local] = ACTIONS(2717),
    [anon_sym___thread] = ACTIONS(2717),
    [anon_sym_const] = ACTIONS(2717),
    [anon_sym_constexpr] = ACTIONS(2717),
    [anon_sym_volatile] = ACTIONS(2717),
    [anon_sym_restrict] = ACTIONS(2717),
    [anon_sym___restrict__] = ACTIONS(2717),
    [anon_sym__Atomic] = ACTIONS(2717),
    [anon_sym__Noreturn] = ACTIONS(2717),
    [anon_sym_noreturn] = ACTIONS(2717),
    [anon_sym_mutable] = ACTIONS(2717),
    [anon_sym_constinit] = ACTIONS(2717),
    [anon_sym_consteval] = ACTIONS(2717),
    [anon_sym_PROGMEM] = ACTIONS(2717),
    [aux_sym_primitive_type_token1] = ACTIONS(2717),
    [anon_sym_byte] = ACTIONS(2717),
    [anon_sym_word] = ACTIONS(2717),
    [anon_sym_enum] = ACTIONS(2717),
    [anon_sym_class] = ACTIONS(2717),
    [anon_sym_struct] = ACTIONS(2717),
    [anon_sym_union] = ACTIONS(2717),
    [anon_sym_if] = ACTIONS(2717),
    [anon_sym_else] = ACTIONS(2717),
    [anon_sym_switch] = ACTIONS(2717),
    [anon_sym_case] = ACTIONS(2717),
    [anon_sym_default] = ACTIONS(2717),
    [anon_sym_while] = ACTIONS(2717),
    [anon_sym_do] = ACTIONS(2717),
    [anon_sym_for] = ACTIONS(2717),
    [anon_sym_return] = ACTIONS(2717),
    [anon_sym_break] = ACTIONS(2717),
    [anon_sym_continue] = ACTIONS(2717),
    [anon_sym_goto] = ACTIONS(2717),
    [anon_sym___try] = ACTIONS(2717),
    [anon_sym___leave] = ACTIONS(2717),
    [anon_sym_not] = ACTIONS(2717),
    [anon_sym_compl] = ACTIONS(2717),
    [anon_sym_DASH_DASH] = ACTIONS(2719),
    [anon_sym_PLUS_PLUS] = ACTIONS(2719),
    [anon_sym_sizeof] = ACTIONS(2717),
    [anon_sym___alignof__] = ACTIONS(2717),
    [anon_sym___alignof] = ACTIONS(2717),
    [anon_sym__alignof] = ACTIONS(2717),
    [anon_sym_alignof] = ACTIONS(2717),
    [anon_sym__Alignof] = ACTIONS(2717),
    [anon_sym_offsetof] = ACTIONS(2717),
    [anon_sym__Generic] = ACTIONS(2717),
    [anon_sym_asm] = ACTIONS(2717),
    [anon_sym___asm__] = ACTIONS(2717),
    [aux_sym_number_literal_token1] = ACTIONS(2719),
    [aux_sym_number_literal_token2] = ACTIONS(2717),
    [anon_sym_L_SQUOTE] = ACTIONS(2719),
    [anon_sym_u_SQUOTE] = ACTIONS(2719),
    [anon_sym_U_SQUOTE] = ACTIONS(2719),
    [anon_sym_u8_SQUOTE] = ACTIONS(2719),
    [anon_sym_SQUOTE] = ACTIONS(2719),
    [anon_sym_L_DQUOTE] = ACTIONS(2719),
    [anon_sym_u_DQUOTE] = ACTIONS(2719),
    [anon_sym_U_DQUOTE] = ACTIONS(2719),
    [anon_sym_u8_DQUOTE] = ACTIONS(2719),
    [anon_sym_DQUOTE] = ACTIONS(2719),
    [sym_true] = ACTIONS(2717),
    [sym_false] = ACTIONS(2717),
    [anon_sym_NULL] = ACTIONS(2717),
    [anon_sym_nullptr] = ACTIONS(2717),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2717),
    [anon_sym_decltype] = ACTIONS(2717),
    [anon_sym_virtual] = ACTIONS(2717),
    [anon_sym_alignas] = ACTIONS(2717),
    [anon_sym_explicit] = ACTIONS(2717),
    [anon_sym_typename] = ACTIONS(2717),
    [anon_sym_template] = ACTIONS(2717),
    [anon_sym_operator] = ACTIONS(2717),
    [anon_sym_try] = ACTIONS(2717),
    [anon_sym_delete] = ACTIONS(2717),
    [anon_sym_throw] = ACTIONS(2717),
    [anon_sym_namespace] = ACTIONS(2717),
    [anon_sym_using] = ACTIONS(2717),
    [anon_sym_static_assert] = ACTIONS(2717),
    [anon_sym_concept] = ACTIONS(2717),
    [anon_sym_co_return] = ACTIONS(2717),
    [anon_sym_co_yield] = ACTIONS(2717),
    [anon_sym_R_DQUOTE] = ACTIONS(2719),
    [anon_sym_LR_DQUOTE] = ACTIONS(2719),
    [anon_sym_uR_DQUOTE] = ACTIONS(2719),
    [anon_sym_UR_DQUOTE] = ACTIONS(2719),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2719),
    [anon_sym_co_await] = ACTIONS(2717),
    [anon_sym_new] = ACTIONS(2717),
    [anon_sym_requires] = ACTIONS(2717),
    [sym_this] = ACTIONS(2717),
  },
  [518] = {
    [sym_identifier] = ACTIONS(2723),
    [aux_sym_preproc_include_token1] = ACTIONS(2723),
    [aux_sym_preproc_def_token1] = ACTIONS(2723),
    [aux_sym_preproc_if_token1] = ACTIONS(2723),
    [aux_sym_preproc_if_token2] = ACTIONS(2723),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2723),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2723),
    [sym_preproc_directive] = ACTIONS(2723),
    [anon_sym_LPAREN2] = ACTIONS(2725),
    [anon_sym_BANG] = ACTIONS(2725),
    [anon_sym_TILDE] = ACTIONS(2725),
    [anon_sym_DASH] = ACTIONS(2723),
    [anon_sym_PLUS] = ACTIONS(2723),
    [anon_sym_STAR] = ACTIONS(2725),
    [anon_sym_AMP_AMP] = ACTIONS(2725),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_SEMI] = ACTIONS(2725),
    [anon_sym___extension__] = ACTIONS(2723),
    [anon_sym_typedef] = ACTIONS(2723),
    [anon_sym_extern] = ACTIONS(2723),
    [anon_sym___attribute__] = ACTIONS(2723),
    [anon_sym_COLON_COLON] = ACTIONS(2725),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2725),
    [anon_sym___declspec] = ACTIONS(2723),
    [anon_sym___based] = ACTIONS(2723),
    [anon_sym___cdecl] = ACTIONS(2723),
    [anon_sym___clrcall] = ACTIONS(2723),
    [anon_sym___stdcall] = ACTIONS(2723),
    [anon_sym___fastcall] = ACTIONS(2723),
    [anon_sym___thiscall] = ACTIONS(2723),
    [anon_sym___vectorcall] = ACTIONS(2723),
    [anon_sym_LBRACE] = ACTIONS(2725),
    [anon_sym_signed] = ACTIONS(2723),
    [anon_sym_unsigned] = ACTIONS(2723),
    [anon_sym_long] = ACTIONS(2723),
    [anon_sym_short] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_static] = ACTIONS(2723),
    [anon_sym_register] = ACTIONS(2723),
    [anon_sym_inline] = ACTIONS(2723),
    [anon_sym___inline] = ACTIONS(2723),
    [anon_sym___inline__] = ACTIONS(2723),
    [anon_sym___forceinline] = ACTIONS(2723),
    [anon_sym_thread_local] = ACTIONS(2723),
    [anon_sym___thread] = ACTIONS(2723),
    [anon_sym_const] = ACTIONS(2723),
    [anon_sym_constexpr] = ACTIONS(2723),
    [anon_sym_volatile] = ACTIONS(2723),
    [anon_sym_restrict] = ACTIONS(2723),
    [anon_sym___restrict__] = ACTIONS(2723),
    [anon_sym__Atomic] = ACTIONS(2723),
    [anon_sym__Noreturn] = ACTIONS(2723),
    [anon_sym_noreturn] = ACTIONS(2723),
    [anon_sym_mutable] = ACTIONS(2723),
    [anon_sym_constinit] = ACTIONS(2723),
    [anon_sym_consteval] = ACTIONS(2723),
    [anon_sym_PROGMEM] = ACTIONS(2723),
    [aux_sym_primitive_type_token1] = ACTIONS(2723),
    [anon_sym_byte] = ACTIONS(2723),
    [anon_sym_word] = ACTIONS(2723),
    [anon_sym_enum] = ACTIONS(2723),
    [anon_sym_class] = ACTIONS(2723),
    [anon_sym_struct] = ACTIONS(2723),
    [anon_sym_union] = ACTIONS(2723),
    [anon_sym_if] = ACTIONS(2723),
    [anon_sym_else] = ACTIONS(2723),
    [anon_sym_switch] = ACTIONS(2723),
    [anon_sym_case] = ACTIONS(2723),
    [anon_sym_default] = ACTIONS(2723),
    [anon_sym_while] = ACTIONS(2723),
    [anon_sym_do] = ACTIONS(2723),
    [anon_sym_for] = ACTIONS(2723),
    [anon_sym_return] = ACTIONS(2723),
    [anon_sym_break] = ACTIONS(2723),
    [anon_sym_continue] = ACTIONS(2723),
    [anon_sym_goto] = ACTIONS(2723),
    [anon_sym___try] = ACTIONS(2723),
    [anon_sym___leave] = ACTIONS(2723),
    [anon_sym_not] = ACTIONS(2723),
    [anon_sym_compl] = ACTIONS(2723),
    [anon_sym_DASH_DASH] = ACTIONS(2725),
    [anon_sym_PLUS_PLUS] = ACTIONS(2725),
    [anon_sym_sizeof] = ACTIONS(2723),
    [anon_sym___alignof__] = ACTIONS(2723),
    [anon_sym___alignof] = ACTIONS(2723),
    [anon_sym__alignof] = ACTIONS(2723),
    [anon_sym_alignof] = ACTIONS(2723),
    [anon_sym__Alignof] = ACTIONS(2723),
    [anon_sym_offsetof] = ACTIONS(2723),
    [anon_sym__Generic] = ACTIONS(2723),
    [anon_sym_asm] = ACTIONS(2723),
    [anon_sym___asm__] = ACTIONS(2723),
    [aux_sym_number_literal_token1] = ACTIONS(2725),
    [aux_sym_number_literal_token2] = ACTIONS(2723),
    [anon_sym_L_SQUOTE] = ACTIONS(2725),
    [anon_sym_u_SQUOTE] = ACTIONS(2725),
    [anon_sym_U_SQUOTE] = ACTIONS(2725),
    [anon_sym_u8_SQUOTE] = ACTIONS(2725),
    [anon_sym_SQUOTE] = ACTIONS(2725),
    [anon_sym_L_DQUOTE] = ACTIONS(2725),
    [anon_sym_u_DQUOTE] = ACTIONS(2725),
    [anon_sym_U_DQUOTE] = ACTIONS(2725),
    [anon_sym_u8_DQUOTE] = ACTIONS(2725),
    [anon_sym_DQUOTE] = ACTIONS(2725),
    [sym_true] = ACTIONS(2723),
    [sym_false] = ACTIONS(2723),
    [anon_sym_NULL] = ACTIONS(2723),
    [anon_sym_nullptr] = ACTIONS(2723),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2723),
    [anon_sym_decltype] = ACTIONS(2723),
    [anon_sym_virtual] = ACTIONS(2723),
    [anon_sym_alignas] = ACTIONS(2723),
    [anon_sym_explicit] = ACTIONS(2723),
    [anon_sym_typename] = ACTIONS(2723),
    [anon_sym_template] = ACTIONS(2723),
    [anon_sym_operator] = ACTIONS(2723),
    [anon_sym_try] = ACTIONS(2723),
    [anon_sym_delete] = ACTIONS(2723),
    [anon_sym_throw] = ACTIONS(2723),
    [anon_sym_namespace] = ACTIONS(2723),
    [anon_sym_using] = ACTIONS(2723),
    [anon_sym_static_assert] = ACTIONS(2723),
    [anon_sym_concept] = ACTIONS(2723),
    [anon_sym_co_return] = ACTIONS(2723),
    [anon_sym_co_yield] = ACTIONS(2723),
    [anon_sym_R_DQUOTE] = ACTIONS(2725),
    [anon_sym_LR_DQUOTE] = ACTIONS(2725),
    [anon_sym_uR_DQUOTE] = ACTIONS(2725),
    [anon_sym_UR_DQUOTE] = ACTIONS(2725),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2725),
    [anon_sym_co_await] = ACTIONS(2723),
    [anon_sym_new] = ACTIONS(2723),
    [anon_sym_requires] = ACTIONS(2723),
    [sym_this] = ACTIONS(2723),
  },
  [519] = {
    [sym_identifier] = ACTIONS(2687),
    [aux_sym_preproc_include_token1] = ACTIONS(2687),
    [aux_sym_preproc_def_token1] = ACTIONS(2687),
    [aux_sym_preproc_if_token1] = ACTIONS(2687),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2687),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2687),
    [sym_preproc_directive] = ACTIONS(2687),
    [anon_sym_LPAREN2] = ACTIONS(2689),
    [anon_sym_BANG] = ACTIONS(2689),
    [anon_sym_TILDE] = ACTIONS(2689),
    [anon_sym_DASH] = ACTIONS(2687),
    [anon_sym_PLUS] = ACTIONS(2687),
    [anon_sym_STAR] = ACTIONS(2689),
    [anon_sym_AMP_AMP] = ACTIONS(2689),
    [anon_sym_AMP] = ACTIONS(2687),
    [anon_sym_SEMI] = ACTIONS(2689),
    [anon_sym___extension__] = ACTIONS(2687),
    [anon_sym_typedef] = ACTIONS(2687),
    [anon_sym_extern] = ACTIONS(2687),
    [anon_sym___attribute__] = ACTIONS(2687),
    [anon_sym_COLON_COLON] = ACTIONS(2689),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2689),
    [anon_sym___declspec] = ACTIONS(2687),
    [anon_sym___based] = ACTIONS(2687),
    [anon_sym___cdecl] = ACTIONS(2687),
    [anon_sym___clrcall] = ACTIONS(2687),
    [anon_sym___stdcall] = ACTIONS(2687),
    [anon_sym___fastcall] = ACTIONS(2687),
    [anon_sym___thiscall] = ACTIONS(2687),
    [anon_sym___vectorcall] = ACTIONS(2687),
    [anon_sym_LBRACE] = ACTIONS(2689),
    [anon_sym_RBRACE] = ACTIONS(2689),
    [anon_sym_signed] = ACTIONS(2687),
    [anon_sym_unsigned] = ACTIONS(2687),
    [anon_sym_long] = ACTIONS(2687),
    [anon_sym_short] = ACTIONS(2687),
    [anon_sym_LBRACK] = ACTIONS(2687),
    [anon_sym_static] = ACTIONS(2687),
    [anon_sym_register] = ACTIONS(2687),
    [anon_sym_inline] = ACTIONS(2687),
    [anon_sym___inline] = ACTIONS(2687),
    [anon_sym___inline__] = ACTIONS(2687),
    [anon_sym___forceinline] = ACTIONS(2687),
    [anon_sym_thread_local] = ACTIONS(2687),
    [anon_sym___thread] = ACTIONS(2687),
    [anon_sym_const] = ACTIONS(2687),
    [anon_sym_constexpr] = ACTIONS(2687),
    [anon_sym_volatile] = ACTIONS(2687),
    [anon_sym_restrict] = ACTIONS(2687),
    [anon_sym___restrict__] = ACTIONS(2687),
    [anon_sym__Atomic] = ACTIONS(2687),
    [anon_sym__Noreturn] = ACTIONS(2687),
    [anon_sym_noreturn] = ACTIONS(2687),
    [anon_sym_mutable] = ACTIONS(2687),
    [anon_sym_constinit] = ACTIONS(2687),
    [anon_sym_consteval] = ACTIONS(2687),
    [anon_sym_PROGMEM] = ACTIONS(2687),
    [aux_sym_primitive_type_token1] = ACTIONS(2687),
    [anon_sym_byte] = ACTIONS(2687),
    [anon_sym_word] = ACTIONS(2687),
    [anon_sym_enum] = ACTIONS(2687),
    [anon_sym_class] = ACTIONS(2687),
    [anon_sym_struct] = ACTIONS(2687),
    [anon_sym_union] = ACTIONS(2687),
    [anon_sym_if] = ACTIONS(2687),
    [anon_sym_else] = ACTIONS(2687),
    [anon_sym_switch] = ACTIONS(2687),
    [anon_sym_case] = ACTIONS(2687),
    [anon_sym_default] = ACTIONS(2687),
    [anon_sym_while] = ACTIONS(2687),
    [anon_sym_do] = ACTIONS(2687),
    [anon_sym_for] = ACTIONS(2687),
    [anon_sym_return] = ACTIONS(2687),
    [anon_sym_break] = ACTIONS(2687),
    [anon_sym_continue] = ACTIONS(2687),
    [anon_sym_goto] = ACTIONS(2687),
    [anon_sym___try] = ACTIONS(2687),
    [anon_sym___leave] = ACTIONS(2687),
    [anon_sym_not] = ACTIONS(2687),
    [anon_sym_compl] = ACTIONS(2687),
    [anon_sym_DASH_DASH] = ACTIONS(2689),
    [anon_sym_PLUS_PLUS] = ACTIONS(2689),
    [anon_sym_sizeof] = ACTIONS(2687),
    [anon_sym___alignof__] = ACTIONS(2687),
    [anon_sym___alignof] = ACTIONS(2687),
    [anon_sym__alignof] = ACTIONS(2687),
    [anon_sym_alignof] = ACTIONS(2687),
    [anon_sym__Alignof] = ACTIONS(2687),
    [anon_sym_offsetof] = ACTIONS(2687),
    [anon_sym__Generic] = ACTIONS(2687),
    [anon_sym_asm] = ACTIONS(2687),
    [anon_sym___asm__] = ACTIONS(2687),
    [aux_sym_number_literal_token1] = ACTIONS(2689),
    [aux_sym_number_literal_token2] = ACTIONS(2687),
    [anon_sym_L_SQUOTE] = ACTIONS(2689),
    [anon_sym_u_SQUOTE] = ACTIONS(2689),
    [anon_sym_U_SQUOTE] = ACTIONS(2689),
    [anon_sym_u8_SQUOTE] = ACTIONS(2689),
    [anon_sym_SQUOTE] = ACTIONS(2689),
    [anon_sym_L_DQUOTE] = ACTIONS(2689),
    [anon_sym_u_DQUOTE] = ACTIONS(2689),
    [anon_sym_U_DQUOTE] = ACTIONS(2689),
    [anon_sym_u8_DQUOTE] = ACTIONS(2689),
    [anon_sym_DQUOTE] = ACTIONS(2689),
    [sym_true] = ACTIONS(2687),
    [sym_false] = ACTIONS(2687),
    [anon_sym_NULL] = ACTIONS(2687),
    [anon_sym_nullptr] = ACTIONS(2687),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2687),
    [anon_sym_decltype] = ACTIONS(2687),
    [anon_sym_virtual] = ACTIONS(2687),
    [anon_sym_alignas] = ACTIONS(2687),
    [anon_sym_explicit] = ACTIONS(2687),
    [anon_sym_typename] = ACTIONS(2687),
    [anon_sym_template] = ACTIONS(2687),
    [anon_sym_operator] = ACTIONS(2687),
    [anon_sym_try] = ACTIONS(2687),
    [anon_sym_delete] = ACTIONS(2687),
    [anon_sym_throw] = ACTIONS(2687),
    [anon_sym_namespace] = ACTIONS(2687),
    [anon_sym_using] = ACTIONS(2687),
    [anon_sym_static_assert] = ACTIONS(2687),
    [anon_sym_concept] = ACTIONS(2687),
    [anon_sym_co_return] = ACTIONS(2687),
    [anon_sym_co_yield] = ACTIONS(2687),
    [anon_sym_R_DQUOTE] = ACTIONS(2689),
    [anon_sym_LR_DQUOTE] = ACTIONS(2689),
    [anon_sym_uR_DQUOTE] = ACTIONS(2689),
    [anon_sym_UR_DQUOTE] = ACTIONS(2689),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2689),
    [anon_sym_co_await] = ACTIONS(2687),
    [anon_sym_new] = ACTIONS(2687),
    [anon_sym_requires] = ACTIONS(2687),
    [sym_this] = ACTIONS(2687),
  },
  [520] = {
    [sym_identifier] = ACTIONS(2691),
    [aux_sym_preproc_include_token1] = ACTIONS(2691),
    [aux_sym_preproc_def_token1] = ACTIONS(2691),
    [aux_sym_preproc_if_token1] = ACTIONS(2691),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2691),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2691),
    [sym_preproc_directive] = ACTIONS(2691),
    [anon_sym_LPAREN2] = ACTIONS(2693),
    [anon_sym_BANG] = ACTIONS(2693),
    [anon_sym_TILDE] = ACTIONS(2693),
    [anon_sym_DASH] = ACTIONS(2691),
    [anon_sym_PLUS] = ACTIONS(2691),
    [anon_sym_STAR] = ACTIONS(2693),
    [anon_sym_AMP_AMP] = ACTIONS(2693),
    [anon_sym_AMP] = ACTIONS(2691),
    [anon_sym_SEMI] = ACTIONS(2693),
    [anon_sym___extension__] = ACTIONS(2691),
    [anon_sym_typedef] = ACTIONS(2691),
    [anon_sym_extern] = ACTIONS(2691),
    [anon_sym___attribute__] = ACTIONS(2691),
    [anon_sym_COLON_COLON] = ACTIONS(2693),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2693),
    [anon_sym___declspec] = ACTIONS(2691),
    [anon_sym___based] = ACTIONS(2691),
    [anon_sym___cdecl] = ACTIONS(2691),
    [anon_sym___clrcall] = ACTIONS(2691),
    [anon_sym___stdcall] = ACTIONS(2691),
    [anon_sym___fastcall] = ACTIONS(2691),
    [anon_sym___thiscall] = ACTIONS(2691),
    [anon_sym___vectorcall] = ACTIONS(2691),
    [anon_sym_LBRACE] = ACTIONS(2693),
    [anon_sym_RBRACE] = ACTIONS(2693),
    [anon_sym_signed] = ACTIONS(2691),
    [anon_sym_unsigned] = ACTIONS(2691),
    [anon_sym_long] = ACTIONS(2691),
    [anon_sym_short] = ACTIONS(2691),
    [anon_sym_LBRACK] = ACTIONS(2691),
    [anon_sym_static] = ACTIONS(2691),
    [anon_sym_register] = ACTIONS(2691),
    [anon_sym_inline] = ACTIONS(2691),
    [anon_sym___inline] = ACTIONS(2691),
    [anon_sym___inline__] = ACTIONS(2691),
    [anon_sym___forceinline] = ACTIONS(2691),
    [anon_sym_thread_local] = ACTIONS(2691),
    [anon_sym___thread] = ACTIONS(2691),
    [anon_sym_const] = ACTIONS(2691),
    [anon_sym_constexpr] = ACTIONS(2691),
    [anon_sym_volatile] = ACTIONS(2691),
    [anon_sym_restrict] = ACTIONS(2691),
    [anon_sym___restrict__] = ACTIONS(2691),
    [anon_sym__Atomic] = ACTIONS(2691),
    [anon_sym__Noreturn] = ACTIONS(2691),
    [anon_sym_noreturn] = ACTIONS(2691),
    [anon_sym_mutable] = ACTIONS(2691),
    [anon_sym_constinit] = ACTIONS(2691),
    [anon_sym_consteval] = ACTIONS(2691),
    [anon_sym_PROGMEM] = ACTIONS(2691),
    [aux_sym_primitive_type_token1] = ACTIONS(2691),
    [anon_sym_byte] = ACTIONS(2691),
    [anon_sym_word] = ACTIONS(2691),
    [anon_sym_enum] = ACTIONS(2691),
    [anon_sym_class] = ACTIONS(2691),
    [anon_sym_struct] = ACTIONS(2691),
    [anon_sym_union] = ACTIONS(2691),
    [anon_sym_if] = ACTIONS(2691),
    [anon_sym_else] = ACTIONS(2691),
    [anon_sym_switch] = ACTIONS(2691),
    [anon_sym_case] = ACTIONS(2691),
    [anon_sym_default] = ACTIONS(2691),
    [anon_sym_while] = ACTIONS(2691),
    [anon_sym_do] = ACTIONS(2691),
    [anon_sym_for] = ACTIONS(2691),
    [anon_sym_return] = ACTIONS(2691),
    [anon_sym_break] = ACTIONS(2691),
    [anon_sym_continue] = ACTIONS(2691),
    [anon_sym_goto] = ACTIONS(2691),
    [anon_sym___try] = ACTIONS(2691),
    [anon_sym___leave] = ACTIONS(2691),
    [anon_sym_not] = ACTIONS(2691),
    [anon_sym_compl] = ACTIONS(2691),
    [anon_sym_DASH_DASH] = ACTIONS(2693),
    [anon_sym_PLUS_PLUS] = ACTIONS(2693),
    [anon_sym_sizeof] = ACTIONS(2691),
    [anon_sym___alignof__] = ACTIONS(2691),
    [anon_sym___alignof] = ACTIONS(2691),
    [anon_sym__alignof] = ACTIONS(2691),
    [anon_sym_alignof] = ACTIONS(2691),
    [anon_sym__Alignof] = ACTIONS(2691),
    [anon_sym_offsetof] = ACTIONS(2691),
    [anon_sym__Generic] = ACTIONS(2691),
    [anon_sym_asm] = ACTIONS(2691),
    [anon_sym___asm__] = ACTIONS(2691),
    [aux_sym_number_literal_token1] = ACTIONS(2693),
    [aux_sym_number_literal_token2] = ACTIONS(2691),
    [anon_sym_L_SQUOTE] = ACTIONS(2693),
    [anon_sym_u_SQUOTE] = ACTIONS(2693),
    [anon_sym_U_SQUOTE] = ACTIONS(2693),
    [anon_sym_u8_SQUOTE] = ACTIONS(2693),
    [anon_sym_SQUOTE] = ACTIONS(2693),
    [anon_sym_L_DQUOTE] = ACTIONS(2693),
    [anon_sym_u_DQUOTE] = ACTIONS(2693),
    [anon_sym_U_DQUOTE] = ACTIONS(2693),
    [anon_sym_u8_DQUOTE] = ACTIONS(2693),
    [anon_sym_DQUOTE] = ACTIONS(2693),
    [sym_true] = ACTIONS(2691),
    [sym_false] = ACTIONS(2691),
    [anon_sym_NULL] = ACTIONS(2691),
    [anon_sym_nullptr] = ACTIONS(2691),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2691),
    [anon_sym_decltype] = ACTIONS(2691),
    [anon_sym_virtual] = ACTIONS(2691),
    [anon_sym_alignas] = ACTIONS(2691),
    [anon_sym_explicit] = ACTIONS(2691),
    [anon_sym_typename] = ACTIONS(2691),
    [anon_sym_template] = ACTIONS(2691),
    [anon_sym_operator] = ACTIONS(2691),
    [anon_sym_try] = ACTIONS(2691),
    [anon_sym_delete] = ACTIONS(2691),
    [anon_sym_throw] = ACTIONS(2691),
    [anon_sym_namespace] = ACTIONS(2691),
    [anon_sym_using] = ACTIONS(2691),
    [anon_sym_static_assert] = ACTIONS(2691),
    [anon_sym_concept] = ACTIONS(2691),
    [anon_sym_co_return] = ACTIONS(2691),
    [anon_sym_co_yield] = ACTIONS(2691),
    [anon_sym_R_DQUOTE] = ACTIONS(2693),
    [anon_sym_LR_DQUOTE] = ACTIONS(2693),
    [anon_sym_uR_DQUOTE] = ACTIONS(2693),
    [anon_sym_UR_DQUOTE] = ACTIONS(2693),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2693),
    [anon_sym_co_await] = ACTIONS(2691),
    [anon_sym_new] = ACTIONS(2691),
    [anon_sym_requires] = ACTIONS(2691),
    [sym_this] = ACTIONS(2691),
  },
  [521] = {
    [sym_identifier] = ACTIONS(2695),
    [aux_sym_preproc_include_token1] = ACTIONS(2695),
    [aux_sym_preproc_def_token1] = ACTIONS(2695),
    [aux_sym_preproc_if_token1] = ACTIONS(2695),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2695),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2695),
    [sym_preproc_directive] = ACTIONS(2695),
    [anon_sym_LPAREN2] = ACTIONS(2697),
    [anon_sym_BANG] = ACTIONS(2697),
    [anon_sym_TILDE] = ACTIONS(2697),
    [anon_sym_DASH] = ACTIONS(2695),
    [anon_sym_PLUS] = ACTIONS(2695),
    [anon_sym_STAR] = ACTIONS(2697),
    [anon_sym_AMP_AMP] = ACTIONS(2697),
    [anon_sym_AMP] = ACTIONS(2695),
    [anon_sym_SEMI] = ACTIONS(2697),
    [anon_sym___extension__] = ACTIONS(2695),
    [anon_sym_typedef] = ACTIONS(2695),
    [anon_sym_extern] = ACTIONS(2695),
    [anon_sym___attribute__] = ACTIONS(2695),
    [anon_sym_COLON_COLON] = ACTIONS(2697),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2697),
    [anon_sym___declspec] = ACTIONS(2695),
    [anon_sym___based] = ACTIONS(2695),
    [anon_sym___cdecl] = ACTIONS(2695),
    [anon_sym___clrcall] = ACTIONS(2695),
    [anon_sym___stdcall] = ACTIONS(2695),
    [anon_sym___fastcall] = ACTIONS(2695),
    [anon_sym___thiscall] = ACTIONS(2695),
    [anon_sym___vectorcall] = ACTIONS(2695),
    [anon_sym_LBRACE] = ACTIONS(2697),
    [anon_sym_RBRACE] = ACTIONS(2697),
    [anon_sym_signed] = ACTIONS(2695),
    [anon_sym_unsigned] = ACTIONS(2695),
    [anon_sym_long] = ACTIONS(2695),
    [anon_sym_short] = ACTIONS(2695),
    [anon_sym_LBRACK] = ACTIONS(2695),
    [anon_sym_static] = ACTIONS(2695),
    [anon_sym_register] = ACTIONS(2695),
    [anon_sym_inline] = ACTIONS(2695),
    [anon_sym___inline] = ACTIONS(2695),
    [anon_sym___inline__] = ACTIONS(2695),
    [anon_sym___forceinline] = ACTIONS(2695),
    [anon_sym_thread_local] = ACTIONS(2695),
    [anon_sym___thread] = ACTIONS(2695),
    [anon_sym_const] = ACTIONS(2695),
    [anon_sym_constexpr] = ACTIONS(2695),
    [anon_sym_volatile] = ACTIONS(2695),
    [anon_sym_restrict] = ACTIONS(2695),
    [anon_sym___restrict__] = ACTIONS(2695),
    [anon_sym__Atomic] = ACTIONS(2695),
    [anon_sym__Noreturn] = ACTIONS(2695),
    [anon_sym_noreturn] = ACTIONS(2695),
    [anon_sym_mutable] = ACTIONS(2695),
    [anon_sym_constinit] = ACTIONS(2695),
    [anon_sym_consteval] = ACTIONS(2695),
    [anon_sym_PROGMEM] = ACTIONS(2695),
    [aux_sym_primitive_type_token1] = ACTIONS(2695),
    [anon_sym_byte] = ACTIONS(2695),
    [anon_sym_word] = ACTIONS(2695),
    [anon_sym_enum] = ACTIONS(2695),
    [anon_sym_class] = ACTIONS(2695),
    [anon_sym_struct] = ACTIONS(2695),
    [anon_sym_union] = ACTIONS(2695),
    [anon_sym_if] = ACTIONS(2695),
    [anon_sym_else] = ACTIONS(2695),
    [anon_sym_switch] = ACTIONS(2695),
    [anon_sym_case] = ACTIONS(2695),
    [anon_sym_default] = ACTIONS(2695),
    [anon_sym_while] = ACTIONS(2695),
    [anon_sym_do] = ACTIONS(2695),
    [anon_sym_for] = ACTIONS(2695),
    [anon_sym_return] = ACTIONS(2695),
    [anon_sym_break] = ACTIONS(2695),
    [anon_sym_continue] = ACTIONS(2695),
    [anon_sym_goto] = ACTIONS(2695),
    [anon_sym___try] = ACTIONS(2695),
    [anon_sym___leave] = ACTIONS(2695),
    [anon_sym_not] = ACTIONS(2695),
    [anon_sym_compl] = ACTIONS(2695),
    [anon_sym_DASH_DASH] = ACTIONS(2697),
    [anon_sym_PLUS_PLUS] = ACTIONS(2697),
    [anon_sym_sizeof] = ACTIONS(2695),
    [anon_sym___alignof__] = ACTIONS(2695),
    [anon_sym___alignof] = ACTIONS(2695),
    [anon_sym__alignof] = ACTIONS(2695),
    [anon_sym_alignof] = ACTIONS(2695),
    [anon_sym__Alignof] = ACTIONS(2695),
    [anon_sym_offsetof] = ACTIONS(2695),
    [anon_sym__Generic] = ACTIONS(2695),
    [anon_sym_asm] = ACTIONS(2695),
    [anon_sym___asm__] = ACTIONS(2695),
    [aux_sym_number_literal_token1] = ACTIONS(2697),
    [aux_sym_number_literal_token2] = ACTIONS(2695),
    [anon_sym_L_SQUOTE] = ACTIONS(2697),
    [anon_sym_u_SQUOTE] = ACTIONS(2697),
    [anon_sym_U_SQUOTE] = ACTIONS(2697),
    [anon_sym_u8_SQUOTE] = ACTIONS(2697),
    [anon_sym_SQUOTE] = ACTIONS(2697),
    [anon_sym_L_DQUOTE] = ACTIONS(2697),
    [anon_sym_u_DQUOTE] = ACTIONS(2697),
    [anon_sym_U_DQUOTE] = ACTIONS(2697),
    [anon_sym_u8_DQUOTE] = ACTIONS(2697),
    [anon_sym_DQUOTE] = ACTIONS(2697),
    [sym_true] = ACTIONS(2695),
    [sym_false] = ACTIONS(2695),
    [anon_sym_NULL] = ACTIONS(2695),
    [anon_sym_nullptr] = ACTIONS(2695),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2695),
    [anon_sym_decltype] = ACTIONS(2695),
    [anon_sym_virtual] = ACTIONS(2695),
    [anon_sym_alignas] = ACTIONS(2695),
    [anon_sym_explicit] = ACTIONS(2695),
    [anon_sym_typename] = ACTIONS(2695),
    [anon_sym_template] = ACTIONS(2695),
    [anon_sym_operator] = ACTIONS(2695),
    [anon_sym_try] = ACTIONS(2695),
    [anon_sym_delete] = ACTIONS(2695),
    [anon_sym_throw] = ACTIONS(2695),
    [anon_sym_namespace] = ACTIONS(2695),
    [anon_sym_using] = ACTIONS(2695),
    [anon_sym_static_assert] = ACTIONS(2695),
    [anon_sym_concept] = ACTIONS(2695),
    [anon_sym_co_return] = ACTIONS(2695),
    [anon_sym_co_yield] = ACTIONS(2695),
    [anon_sym_R_DQUOTE] = ACTIONS(2697),
    [anon_sym_LR_DQUOTE] = ACTIONS(2697),
    [anon_sym_uR_DQUOTE] = ACTIONS(2697),
    [anon_sym_UR_DQUOTE] = ACTIONS(2697),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2697),
    [anon_sym_co_await] = ACTIONS(2695),
    [anon_sym_new] = ACTIONS(2695),
    [anon_sym_requires] = ACTIONS(2695),
    [sym_this] = ACTIONS(2695),
  },
  [522] = {
    [sym_identifier] = ACTIONS(2701),
    [aux_sym_preproc_include_token1] = ACTIONS(2701),
    [aux_sym_preproc_def_token1] = ACTIONS(2701),
    [aux_sym_preproc_if_token1] = ACTIONS(2701),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2701),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2701),
    [sym_preproc_directive] = ACTIONS(2701),
    [anon_sym_LPAREN2] = ACTIONS(2703),
    [anon_sym_BANG] = ACTIONS(2703),
    [anon_sym_TILDE] = ACTIONS(2703),
    [anon_sym_DASH] = ACTIONS(2701),
    [anon_sym_PLUS] = ACTIONS(2701),
    [anon_sym_STAR] = ACTIONS(2703),
    [anon_sym_AMP_AMP] = ACTIONS(2703),
    [anon_sym_AMP] = ACTIONS(2701),
    [anon_sym_SEMI] = ACTIONS(2703),
    [anon_sym___extension__] = ACTIONS(2701),
    [anon_sym_typedef] = ACTIONS(2701),
    [anon_sym_extern] = ACTIONS(2701),
    [anon_sym___attribute__] = ACTIONS(2701),
    [anon_sym_COLON_COLON] = ACTIONS(2703),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2703),
    [anon_sym___declspec] = ACTIONS(2701),
    [anon_sym___based] = ACTIONS(2701),
    [anon_sym___cdecl] = ACTIONS(2701),
    [anon_sym___clrcall] = ACTIONS(2701),
    [anon_sym___stdcall] = ACTIONS(2701),
    [anon_sym___fastcall] = ACTIONS(2701),
    [anon_sym___thiscall] = ACTIONS(2701),
    [anon_sym___vectorcall] = ACTIONS(2701),
    [anon_sym_LBRACE] = ACTIONS(2703),
    [anon_sym_RBRACE] = ACTIONS(2703),
    [anon_sym_signed] = ACTIONS(2701),
    [anon_sym_unsigned] = ACTIONS(2701),
    [anon_sym_long] = ACTIONS(2701),
    [anon_sym_short] = ACTIONS(2701),
    [anon_sym_LBRACK] = ACTIONS(2701),
    [anon_sym_static] = ACTIONS(2701),
    [anon_sym_register] = ACTIONS(2701),
    [anon_sym_inline] = ACTIONS(2701),
    [anon_sym___inline] = ACTIONS(2701),
    [anon_sym___inline__] = ACTIONS(2701),
    [anon_sym___forceinline] = ACTIONS(2701),
    [anon_sym_thread_local] = ACTIONS(2701),
    [anon_sym___thread] = ACTIONS(2701),
    [anon_sym_const] = ACTIONS(2701),
    [anon_sym_constexpr] = ACTIONS(2701),
    [anon_sym_volatile] = ACTIONS(2701),
    [anon_sym_restrict] = ACTIONS(2701),
    [anon_sym___restrict__] = ACTIONS(2701),
    [anon_sym__Atomic] = ACTIONS(2701),
    [anon_sym__Noreturn] = ACTIONS(2701),
    [anon_sym_noreturn] = ACTIONS(2701),
    [anon_sym_mutable] = ACTIONS(2701),
    [anon_sym_constinit] = ACTIONS(2701),
    [anon_sym_consteval] = ACTIONS(2701),
    [anon_sym_PROGMEM] = ACTIONS(2701),
    [aux_sym_primitive_type_token1] = ACTIONS(2701),
    [anon_sym_byte] = ACTIONS(2701),
    [anon_sym_word] = ACTIONS(2701),
    [anon_sym_enum] = ACTIONS(2701),
    [anon_sym_class] = ACTIONS(2701),
    [anon_sym_struct] = ACTIONS(2701),
    [anon_sym_union] = ACTIONS(2701),
    [anon_sym_if] = ACTIONS(2701),
    [anon_sym_else] = ACTIONS(2701),
    [anon_sym_switch] = ACTIONS(2701),
    [anon_sym_case] = ACTIONS(2701),
    [anon_sym_default] = ACTIONS(2701),
    [anon_sym_while] = ACTIONS(2701),
    [anon_sym_do] = ACTIONS(2701),
    [anon_sym_for] = ACTIONS(2701),
    [anon_sym_return] = ACTIONS(2701),
    [anon_sym_break] = ACTIONS(2701),
    [anon_sym_continue] = ACTIONS(2701),
    [anon_sym_goto] = ACTIONS(2701),
    [anon_sym___try] = ACTIONS(2701),
    [anon_sym___leave] = ACTIONS(2701),
    [anon_sym_not] = ACTIONS(2701),
    [anon_sym_compl] = ACTIONS(2701),
    [anon_sym_DASH_DASH] = ACTIONS(2703),
    [anon_sym_PLUS_PLUS] = ACTIONS(2703),
    [anon_sym_sizeof] = ACTIONS(2701),
    [anon_sym___alignof__] = ACTIONS(2701),
    [anon_sym___alignof] = ACTIONS(2701),
    [anon_sym__alignof] = ACTIONS(2701),
    [anon_sym_alignof] = ACTIONS(2701),
    [anon_sym__Alignof] = ACTIONS(2701),
    [anon_sym_offsetof] = ACTIONS(2701),
    [anon_sym__Generic] = ACTIONS(2701),
    [anon_sym_asm] = ACTIONS(2701),
    [anon_sym___asm__] = ACTIONS(2701),
    [aux_sym_number_literal_token1] = ACTIONS(2703),
    [aux_sym_number_literal_token2] = ACTIONS(2701),
    [anon_sym_L_SQUOTE] = ACTIONS(2703),
    [anon_sym_u_SQUOTE] = ACTIONS(2703),
    [anon_sym_U_SQUOTE] = ACTIONS(2703),
    [anon_sym_u8_SQUOTE] = ACTIONS(2703),
    [anon_sym_SQUOTE] = ACTIONS(2703),
    [anon_sym_L_DQUOTE] = ACTIONS(2703),
    [anon_sym_u_DQUOTE] = ACTIONS(2703),
    [anon_sym_U_DQUOTE] = ACTIONS(2703),
    [anon_sym_u8_DQUOTE] = ACTIONS(2703),
    [anon_sym_DQUOTE] = ACTIONS(2703),
    [sym_true] = ACTIONS(2701),
    [sym_false] = ACTIONS(2701),
    [anon_sym_NULL] = ACTIONS(2701),
    [anon_sym_nullptr] = ACTIONS(2701),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2701),
    [anon_sym_decltype] = ACTIONS(2701),
    [anon_sym_virtual] = ACTIONS(2701),
    [anon_sym_alignas] = ACTIONS(2701),
    [anon_sym_explicit] = ACTIONS(2701),
    [anon_sym_typename] = ACTIONS(2701),
    [anon_sym_template] = ACTIONS(2701),
    [anon_sym_operator] = ACTIONS(2701),
    [anon_sym_try] = ACTIONS(2701),
    [anon_sym_delete] = ACTIONS(2701),
    [anon_sym_throw] = ACTIONS(2701),
    [anon_sym_namespace] = ACTIONS(2701),
    [anon_sym_using] = ACTIONS(2701),
    [anon_sym_static_assert] = ACTIONS(2701),
    [anon_sym_concept] = ACTIONS(2701),
    [anon_sym_co_return] = ACTIONS(2701),
    [anon_sym_co_yield] = ACTIONS(2701),
    [anon_sym_R_DQUOTE] = ACTIONS(2703),
    [anon_sym_LR_DQUOTE] = ACTIONS(2703),
    [anon_sym_uR_DQUOTE] = ACTIONS(2703),
    [anon_sym_UR_DQUOTE] = ACTIONS(2703),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2703),
    [anon_sym_co_await] = ACTIONS(2701),
    [anon_sym_new] = ACTIONS(2701),
    [anon_sym_requires] = ACTIONS(2701),
    [sym_this] = ACTIONS(2701),
  },
  [523] = {
    [sym_identifier] = ACTIONS(2705),
    [aux_sym_preproc_include_token1] = ACTIONS(2705),
    [aux_sym_preproc_def_token1] = ACTIONS(2705),
    [aux_sym_preproc_if_token1] = ACTIONS(2705),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2705),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2705),
    [sym_preproc_directive] = ACTIONS(2705),
    [anon_sym_LPAREN2] = ACTIONS(2707),
    [anon_sym_BANG] = ACTIONS(2707),
    [anon_sym_TILDE] = ACTIONS(2707),
    [anon_sym_DASH] = ACTIONS(2705),
    [anon_sym_PLUS] = ACTIONS(2705),
    [anon_sym_STAR] = ACTIONS(2707),
    [anon_sym_AMP_AMP] = ACTIONS(2707),
    [anon_sym_AMP] = ACTIONS(2705),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym___extension__] = ACTIONS(2705),
    [anon_sym_typedef] = ACTIONS(2705),
    [anon_sym_extern] = ACTIONS(2705),
    [anon_sym___attribute__] = ACTIONS(2705),
    [anon_sym_COLON_COLON] = ACTIONS(2707),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2707),
    [anon_sym___declspec] = ACTIONS(2705),
    [anon_sym___based] = ACTIONS(2705),
    [anon_sym___cdecl] = ACTIONS(2705),
    [anon_sym___clrcall] = ACTIONS(2705),
    [anon_sym___stdcall] = ACTIONS(2705),
    [anon_sym___fastcall] = ACTIONS(2705),
    [anon_sym___thiscall] = ACTIONS(2705),
    [anon_sym___vectorcall] = ACTIONS(2705),
    [anon_sym_LBRACE] = ACTIONS(2707),
    [anon_sym_RBRACE] = ACTIONS(2707),
    [anon_sym_signed] = ACTIONS(2705),
    [anon_sym_unsigned] = ACTIONS(2705),
    [anon_sym_long] = ACTIONS(2705),
    [anon_sym_short] = ACTIONS(2705),
    [anon_sym_LBRACK] = ACTIONS(2705),
    [anon_sym_static] = ACTIONS(2705),
    [anon_sym_register] = ACTIONS(2705),
    [anon_sym_inline] = ACTIONS(2705),
    [anon_sym___inline] = ACTIONS(2705),
    [anon_sym___inline__] = ACTIONS(2705),
    [anon_sym___forceinline] = ACTIONS(2705),
    [anon_sym_thread_local] = ACTIONS(2705),
    [anon_sym___thread] = ACTIONS(2705),
    [anon_sym_const] = ACTIONS(2705),
    [anon_sym_constexpr] = ACTIONS(2705),
    [anon_sym_volatile] = ACTIONS(2705),
    [anon_sym_restrict] = ACTIONS(2705),
    [anon_sym___restrict__] = ACTIONS(2705),
    [anon_sym__Atomic] = ACTIONS(2705),
    [anon_sym__Noreturn] = ACTIONS(2705),
    [anon_sym_noreturn] = ACTIONS(2705),
    [anon_sym_mutable] = ACTIONS(2705),
    [anon_sym_constinit] = ACTIONS(2705),
    [anon_sym_consteval] = ACTIONS(2705),
    [anon_sym_PROGMEM] = ACTIONS(2705),
    [aux_sym_primitive_type_token1] = ACTIONS(2705),
    [anon_sym_byte] = ACTIONS(2705),
    [anon_sym_word] = ACTIONS(2705),
    [anon_sym_enum] = ACTIONS(2705),
    [anon_sym_class] = ACTIONS(2705),
    [anon_sym_struct] = ACTIONS(2705),
    [anon_sym_union] = ACTIONS(2705),
    [anon_sym_if] = ACTIONS(2705),
    [anon_sym_else] = ACTIONS(2705),
    [anon_sym_switch] = ACTIONS(2705),
    [anon_sym_case] = ACTIONS(2705),
    [anon_sym_default] = ACTIONS(2705),
    [anon_sym_while] = ACTIONS(2705),
    [anon_sym_do] = ACTIONS(2705),
    [anon_sym_for] = ACTIONS(2705),
    [anon_sym_return] = ACTIONS(2705),
    [anon_sym_break] = ACTIONS(2705),
    [anon_sym_continue] = ACTIONS(2705),
    [anon_sym_goto] = ACTIONS(2705),
    [anon_sym___try] = ACTIONS(2705),
    [anon_sym___leave] = ACTIONS(2705),
    [anon_sym_not] = ACTIONS(2705),
    [anon_sym_compl] = ACTIONS(2705),
    [anon_sym_DASH_DASH] = ACTIONS(2707),
    [anon_sym_PLUS_PLUS] = ACTIONS(2707),
    [anon_sym_sizeof] = ACTIONS(2705),
    [anon_sym___alignof__] = ACTIONS(2705),
    [anon_sym___alignof] = ACTIONS(2705),
    [anon_sym__alignof] = ACTIONS(2705),
    [anon_sym_alignof] = ACTIONS(2705),
    [anon_sym__Alignof] = ACTIONS(2705),
    [anon_sym_offsetof] = ACTIONS(2705),
    [anon_sym__Generic] = ACTIONS(2705),
    [anon_sym_asm] = ACTIONS(2705),
    [anon_sym___asm__] = ACTIONS(2705),
    [aux_sym_number_literal_token1] = ACTIONS(2707),
    [aux_sym_number_literal_token2] = ACTIONS(2705),
    [anon_sym_L_SQUOTE] = ACTIONS(2707),
    [anon_sym_u_SQUOTE] = ACTIONS(2707),
    [anon_sym_U_SQUOTE] = ACTIONS(2707),
    [anon_sym_u8_SQUOTE] = ACTIONS(2707),
    [anon_sym_SQUOTE] = ACTIONS(2707),
    [anon_sym_L_DQUOTE] = ACTIONS(2707),
    [anon_sym_u_DQUOTE] = ACTIONS(2707),
    [anon_sym_U_DQUOTE] = ACTIONS(2707),
    [anon_sym_u8_DQUOTE] = ACTIONS(2707),
    [anon_sym_DQUOTE] = ACTIONS(2707),
    [sym_true] = ACTIONS(2705),
    [sym_false] = ACTIONS(2705),
    [anon_sym_NULL] = ACTIONS(2705),
    [anon_sym_nullptr] = ACTIONS(2705),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2705),
    [anon_sym_decltype] = ACTIONS(2705),
    [anon_sym_virtual] = ACTIONS(2705),
    [anon_sym_alignas] = ACTIONS(2705),
    [anon_sym_explicit] = ACTIONS(2705),
    [anon_sym_typename] = ACTIONS(2705),
    [anon_sym_template] = ACTIONS(2705),
    [anon_sym_operator] = ACTIONS(2705),
    [anon_sym_try] = ACTIONS(2705),
    [anon_sym_delete] = ACTIONS(2705),
    [anon_sym_throw] = ACTIONS(2705),
    [anon_sym_namespace] = ACTIONS(2705),
    [anon_sym_using] = ACTIONS(2705),
    [anon_sym_static_assert] = ACTIONS(2705),
    [anon_sym_concept] = ACTIONS(2705),
    [anon_sym_co_return] = ACTIONS(2705),
    [anon_sym_co_yield] = ACTIONS(2705),
    [anon_sym_R_DQUOTE] = ACTIONS(2707),
    [anon_sym_LR_DQUOTE] = ACTIONS(2707),
    [anon_sym_uR_DQUOTE] = ACTIONS(2707),
    [anon_sym_UR_DQUOTE] = ACTIONS(2707),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2707),
    [anon_sym_co_await] = ACTIONS(2705),
    [anon_sym_new] = ACTIONS(2705),
    [anon_sym_requires] = ACTIONS(2705),
    [sym_this] = ACTIONS(2705),
  },
  [524] = {
    [sym_identifier] = ACTIONS(2709),
    [aux_sym_preproc_include_token1] = ACTIONS(2709),
    [aux_sym_preproc_def_token1] = ACTIONS(2709),
    [aux_sym_preproc_if_token1] = ACTIONS(2709),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2709),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2709),
    [sym_preproc_directive] = ACTIONS(2709),
    [anon_sym_LPAREN2] = ACTIONS(2711),
    [anon_sym_BANG] = ACTIONS(2711),
    [anon_sym_TILDE] = ACTIONS(2711),
    [anon_sym_DASH] = ACTIONS(2709),
    [anon_sym_PLUS] = ACTIONS(2709),
    [anon_sym_STAR] = ACTIONS(2711),
    [anon_sym_AMP_AMP] = ACTIONS(2711),
    [anon_sym_AMP] = ACTIONS(2709),
    [anon_sym_SEMI] = ACTIONS(2711),
    [anon_sym___extension__] = ACTIONS(2709),
    [anon_sym_typedef] = ACTIONS(2709),
    [anon_sym_extern] = ACTIONS(2709),
    [anon_sym___attribute__] = ACTIONS(2709),
    [anon_sym_COLON_COLON] = ACTIONS(2711),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2711),
    [anon_sym___declspec] = ACTIONS(2709),
    [anon_sym___based] = ACTIONS(2709),
    [anon_sym___cdecl] = ACTIONS(2709),
    [anon_sym___clrcall] = ACTIONS(2709),
    [anon_sym___stdcall] = ACTIONS(2709),
    [anon_sym___fastcall] = ACTIONS(2709),
    [anon_sym___thiscall] = ACTIONS(2709),
    [anon_sym___vectorcall] = ACTIONS(2709),
    [anon_sym_LBRACE] = ACTIONS(2711),
    [anon_sym_RBRACE] = ACTIONS(2711),
    [anon_sym_signed] = ACTIONS(2709),
    [anon_sym_unsigned] = ACTIONS(2709),
    [anon_sym_long] = ACTIONS(2709),
    [anon_sym_short] = ACTIONS(2709),
    [anon_sym_LBRACK] = ACTIONS(2709),
    [anon_sym_static] = ACTIONS(2709),
    [anon_sym_register] = ACTIONS(2709),
    [anon_sym_inline] = ACTIONS(2709),
    [anon_sym___inline] = ACTIONS(2709),
    [anon_sym___inline__] = ACTIONS(2709),
    [anon_sym___forceinline] = ACTIONS(2709),
    [anon_sym_thread_local] = ACTIONS(2709),
    [anon_sym___thread] = ACTIONS(2709),
    [anon_sym_const] = ACTIONS(2709),
    [anon_sym_constexpr] = ACTIONS(2709),
    [anon_sym_volatile] = ACTIONS(2709),
    [anon_sym_restrict] = ACTIONS(2709),
    [anon_sym___restrict__] = ACTIONS(2709),
    [anon_sym__Atomic] = ACTIONS(2709),
    [anon_sym__Noreturn] = ACTIONS(2709),
    [anon_sym_noreturn] = ACTIONS(2709),
    [anon_sym_mutable] = ACTIONS(2709),
    [anon_sym_constinit] = ACTIONS(2709),
    [anon_sym_consteval] = ACTIONS(2709),
    [anon_sym_PROGMEM] = ACTIONS(2709),
    [aux_sym_primitive_type_token1] = ACTIONS(2709),
    [anon_sym_byte] = ACTIONS(2709),
    [anon_sym_word] = ACTIONS(2709),
    [anon_sym_enum] = ACTIONS(2709),
    [anon_sym_class] = ACTIONS(2709),
    [anon_sym_struct] = ACTIONS(2709),
    [anon_sym_union] = ACTIONS(2709),
    [anon_sym_if] = ACTIONS(2709),
    [anon_sym_else] = ACTIONS(2709),
    [anon_sym_switch] = ACTIONS(2709),
    [anon_sym_case] = ACTIONS(2709),
    [anon_sym_default] = ACTIONS(2709),
    [anon_sym_while] = ACTIONS(2709),
    [anon_sym_do] = ACTIONS(2709),
    [anon_sym_for] = ACTIONS(2709),
    [anon_sym_return] = ACTIONS(2709),
    [anon_sym_break] = ACTIONS(2709),
    [anon_sym_continue] = ACTIONS(2709),
    [anon_sym_goto] = ACTIONS(2709),
    [anon_sym___try] = ACTIONS(2709),
    [anon_sym___leave] = ACTIONS(2709),
    [anon_sym_not] = ACTIONS(2709),
    [anon_sym_compl] = ACTIONS(2709),
    [anon_sym_DASH_DASH] = ACTIONS(2711),
    [anon_sym_PLUS_PLUS] = ACTIONS(2711),
    [anon_sym_sizeof] = ACTIONS(2709),
    [anon_sym___alignof__] = ACTIONS(2709),
    [anon_sym___alignof] = ACTIONS(2709),
    [anon_sym__alignof] = ACTIONS(2709),
    [anon_sym_alignof] = ACTIONS(2709),
    [anon_sym__Alignof] = ACTIONS(2709),
    [anon_sym_offsetof] = ACTIONS(2709),
    [anon_sym__Generic] = ACTIONS(2709),
    [anon_sym_asm] = ACTIONS(2709),
    [anon_sym___asm__] = ACTIONS(2709),
    [aux_sym_number_literal_token1] = ACTIONS(2711),
    [aux_sym_number_literal_token2] = ACTIONS(2709),
    [anon_sym_L_SQUOTE] = ACTIONS(2711),
    [anon_sym_u_SQUOTE] = ACTIONS(2711),
    [anon_sym_U_SQUOTE] = ACTIONS(2711),
    [anon_sym_u8_SQUOTE] = ACTIONS(2711),
    [anon_sym_SQUOTE] = ACTIONS(2711),
    [anon_sym_L_DQUOTE] = ACTIONS(2711),
    [anon_sym_u_DQUOTE] = ACTIONS(2711),
    [anon_sym_U_DQUOTE] = ACTIONS(2711),
    [anon_sym_u8_DQUOTE] = ACTIONS(2711),
    [anon_sym_DQUOTE] = ACTIONS(2711),
    [sym_true] = ACTIONS(2709),
    [sym_false] = ACTIONS(2709),
    [anon_sym_NULL] = ACTIONS(2709),
    [anon_sym_nullptr] = ACTIONS(2709),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2709),
    [anon_sym_decltype] = ACTIONS(2709),
    [anon_sym_virtual] = ACTIONS(2709),
    [anon_sym_alignas] = ACTIONS(2709),
    [anon_sym_explicit] = ACTIONS(2709),
    [anon_sym_typename] = ACTIONS(2709),
    [anon_sym_template] = ACTIONS(2709),
    [anon_sym_operator] = ACTIONS(2709),
    [anon_sym_try] = ACTIONS(2709),
    [anon_sym_delete] = ACTIONS(2709),
    [anon_sym_throw] = ACTIONS(2709),
    [anon_sym_namespace] = ACTIONS(2709),
    [anon_sym_using] = ACTIONS(2709),
    [anon_sym_static_assert] = ACTIONS(2709),
    [anon_sym_concept] = ACTIONS(2709),
    [anon_sym_co_return] = ACTIONS(2709),
    [anon_sym_co_yield] = ACTIONS(2709),
    [anon_sym_R_DQUOTE] = ACTIONS(2711),
    [anon_sym_LR_DQUOTE] = ACTIONS(2711),
    [anon_sym_uR_DQUOTE] = ACTIONS(2711),
    [anon_sym_UR_DQUOTE] = ACTIONS(2711),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2711),
    [anon_sym_co_await] = ACTIONS(2709),
    [anon_sym_new] = ACTIONS(2709),
    [anon_sym_requires] = ACTIONS(2709),
    [sym_this] = ACTIONS(2709),
  },
  [525] = {
    [sym_identifier] = ACTIONS(2713),
    [aux_sym_preproc_include_token1] = ACTIONS(2713),
    [aux_sym_preproc_def_token1] = ACTIONS(2713),
    [aux_sym_preproc_if_token1] = ACTIONS(2713),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2713),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2713),
    [sym_preproc_directive] = ACTIONS(2713),
    [anon_sym_LPAREN2] = ACTIONS(2715),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_DASH] = ACTIONS(2713),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_STAR] = ACTIONS(2715),
    [anon_sym_AMP_AMP] = ACTIONS(2715),
    [anon_sym_AMP] = ACTIONS(2713),
    [anon_sym_SEMI] = ACTIONS(2715),
    [anon_sym___extension__] = ACTIONS(2713),
    [anon_sym_typedef] = ACTIONS(2713),
    [anon_sym_extern] = ACTIONS(2713),
    [anon_sym___attribute__] = ACTIONS(2713),
    [anon_sym_COLON_COLON] = ACTIONS(2715),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2715),
    [anon_sym___declspec] = ACTIONS(2713),
    [anon_sym___based] = ACTIONS(2713),
    [anon_sym___cdecl] = ACTIONS(2713),
    [anon_sym___clrcall] = ACTIONS(2713),
    [anon_sym___stdcall] = ACTIONS(2713),
    [anon_sym___fastcall] = ACTIONS(2713),
    [anon_sym___thiscall] = ACTIONS(2713),
    [anon_sym___vectorcall] = ACTIONS(2713),
    [anon_sym_LBRACE] = ACTIONS(2715),
    [anon_sym_RBRACE] = ACTIONS(2715),
    [anon_sym_signed] = ACTIONS(2713),
    [anon_sym_unsigned] = ACTIONS(2713),
    [anon_sym_long] = ACTIONS(2713),
    [anon_sym_short] = ACTIONS(2713),
    [anon_sym_LBRACK] = ACTIONS(2713),
    [anon_sym_static] = ACTIONS(2713),
    [anon_sym_register] = ACTIONS(2713),
    [anon_sym_inline] = ACTIONS(2713),
    [anon_sym___inline] = ACTIONS(2713),
    [anon_sym___inline__] = ACTIONS(2713),
    [anon_sym___forceinline] = ACTIONS(2713),
    [anon_sym_thread_local] = ACTIONS(2713),
    [anon_sym___thread] = ACTIONS(2713),
    [anon_sym_const] = ACTIONS(2713),
    [anon_sym_constexpr] = ACTIONS(2713),
    [anon_sym_volatile] = ACTIONS(2713),
    [anon_sym_restrict] = ACTIONS(2713),
    [anon_sym___restrict__] = ACTIONS(2713),
    [anon_sym__Atomic] = ACTIONS(2713),
    [anon_sym__Noreturn] = ACTIONS(2713),
    [anon_sym_noreturn] = ACTIONS(2713),
    [anon_sym_mutable] = ACTIONS(2713),
    [anon_sym_constinit] = ACTIONS(2713),
    [anon_sym_consteval] = ACTIONS(2713),
    [anon_sym_PROGMEM] = ACTIONS(2713),
    [aux_sym_primitive_type_token1] = ACTIONS(2713),
    [anon_sym_byte] = ACTIONS(2713),
    [anon_sym_word] = ACTIONS(2713),
    [anon_sym_enum] = ACTIONS(2713),
    [anon_sym_class] = ACTIONS(2713),
    [anon_sym_struct] = ACTIONS(2713),
    [anon_sym_union] = ACTIONS(2713),
    [anon_sym_if] = ACTIONS(2713),
    [anon_sym_else] = ACTIONS(2713),
    [anon_sym_switch] = ACTIONS(2713),
    [anon_sym_case] = ACTIONS(2713),
    [anon_sym_default] = ACTIONS(2713),
    [anon_sym_while] = ACTIONS(2713),
    [anon_sym_do] = ACTIONS(2713),
    [anon_sym_for] = ACTIONS(2713),
    [anon_sym_return] = ACTIONS(2713),
    [anon_sym_break] = ACTIONS(2713),
    [anon_sym_continue] = ACTIONS(2713),
    [anon_sym_goto] = ACTIONS(2713),
    [anon_sym___try] = ACTIONS(2713),
    [anon_sym___leave] = ACTIONS(2713),
    [anon_sym_not] = ACTIONS(2713),
    [anon_sym_compl] = ACTIONS(2713),
    [anon_sym_DASH_DASH] = ACTIONS(2715),
    [anon_sym_PLUS_PLUS] = ACTIONS(2715),
    [anon_sym_sizeof] = ACTIONS(2713),
    [anon_sym___alignof__] = ACTIONS(2713),
    [anon_sym___alignof] = ACTIONS(2713),
    [anon_sym__alignof] = ACTIONS(2713),
    [anon_sym_alignof] = ACTIONS(2713),
    [anon_sym__Alignof] = ACTIONS(2713),
    [anon_sym_offsetof] = ACTIONS(2713),
    [anon_sym__Generic] = ACTIONS(2713),
    [anon_sym_asm] = ACTIONS(2713),
    [anon_sym___asm__] = ACTIONS(2713),
    [aux_sym_number_literal_token1] = ACTIONS(2715),
    [aux_sym_number_literal_token2] = ACTIONS(2713),
    [anon_sym_L_SQUOTE] = ACTIONS(2715),
    [anon_sym_u_SQUOTE] = ACTIONS(2715),
    [anon_sym_U_SQUOTE] = ACTIONS(2715),
    [anon_sym_u8_SQUOTE] = ACTIONS(2715),
    [anon_sym_SQUOTE] = ACTIONS(2715),
    [anon_sym_L_DQUOTE] = ACTIONS(2715),
    [anon_sym_u_DQUOTE] = ACTIONS(2715),
    [anon_sym_U_DQUOTE] = ACTIONS(2715),
    [anon_sym_u8_DQUOTE] = ACTIONS(2715),
    [anon_sym_DQUOTE] = ACTIONS(2715),
    [sym_true] = ACTIONS(2713),
    [sym_false] = ACTIONS(2713),
    [anon_sym_NULL] = ACTIONS(2713),
    [anon_sym_nullptr] = ACTIONS(2713),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2713),
    [anon_sym_decltype] = ACTIONS(2713),
    [anon_sym_virtual] = ACTIONS(2713),
    [anon_sym_alignas] = ACTIONS(2713),
    [anon_sym_explicit] = ACTIONS(2713),
    [anon_sym_typename] = ACTIONS(2713),
    [anon_sym_template] = ACTIONS(2713),
    [anon_sym_operator] = ACTIONS(2713),
    [anon_sym_try] = ACTIONS(2713),
    [anon_sym_delete] = ACTIONS(2713),
    [anon_sym_throw] = ACTIONS(2713),
    [anon_sym_namespace] = ACTIONS(2713),
    [anon_sym_using] = ACTIONS(2713),
    [anon_sym_static_assert] = ACTIONS(2713),
    [anon_sym_concept] = ACTIONS(2713),
    [anon_sym_co_return] = ACTIONS(2713),
    [anon_sym_co_yield] = ACTIONS(2713),
    [anon_sym_R_DQUOTE] = ACTIONS(2715),
    [anon_sym_LR_DQUOTE] = ACTIONS(2715),
    [anon_sym_uR_DQUOTE] = ACTIONS(2715),
    [anon_sym_UR_DQUOTE] = ACTIONS(2715),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2715),
    [anon_sym_co_await] = ACTIONS(2713),
    [anon_sym_new] = ACTIONS(2713),
    [anon_sym_requires] = ACTIONS(2713),
    [sym_this] = ACTIONS(2713),
  },
  [526] = {
    [sym_identifier] = ACTIONS(1957),
    [aux_sym_preproc_include_token1] = ACTIONS(1957),
    [aux_sym_preproc_def_token1] = ACTIONS(1957),
    [anon_sym_COMMA] = ACTIONS(2743),
    [aux_sym_preproc_if_token1] = ACTIONS(1957),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1957),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1957),
    [sym_preproc_directive] = ACTIONS(1957),
    [anon_sym_LPAREN2] = ACTIONS(1955),
    [anon_sym_BANG] = ACTIONS(1955),
    [anon_sym_TILDE] = ACTIONS(1955),
    [anon_sym_DASH] = ACTIONS(1957),
    [anon_sym_PLUS] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(1955),
    [anon_sym_AMP_AMP] = ACTIONS(1955),
    [anon_sym_AMP] = ACTIONS(1957),
    [anon_sym_SEMI] = ACTIONS(2743),
    [anon_sym___extension__] = ACTIONS(1957),
    [anon_sym_typedef] = ACTIONS(1957),
    [anon_sym_extern] = ACTIONS(1957),
    [anon_sym___attribute__] = ACTIONS(1957),
    [anon_sym_COLON_COLON] = ACTIONS(1955),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1955),
    [anon_sym___declspec] = ACTIONS(1957),
    [anon_sym___based] = ACTIONS(1957),
    [anon_sym___cdecl] = ACTIONS(1957),
    [anon_sym___clrcall] = ACTIONS(1957),
    [anon_sym___stdcall] = ACTIONS(1957),
    [anon_sym___fastcall] = ACTIONS(1957),
    [anon_sym___thiscall] = ACTIONS(1957),
    [anon_sym___vectorcall] = ACTIONS(1957),
    [anon_sym_LBRACE] = ACTIONS(1955),
    [anon_sym_RBRACE] = ACTIONS(1955),
    [anon_sym_signed] = ACTIONS(1957),
    [anon_sym_unsigned] = ACTIONS(1957),
    [anon_sym_long] = ACTIONS(1957),
    [anon_sym_short] = ACTIONS(1957),
    [anon_sym_LBRACK] = ACTIONS(1957),
    [anon_sym_static] = ACTIONS(1957),
    [anon_sym_register] = ACTIONS(1957),
    [anon_sym_inline] = ACTIONS(1957),
    [anon_sym___inline] = ACTIONS(1957),
    [anon_sym___inline__] = ACTIONS(1957),
    [anon_sym___forceinline] = ACTIONS(1957),
    [anon_sym_thread_local] = ACTIONS(1957),
    [anon_sym___thread] = ACTIONS(1957),
    [anon_sym_const] = ACTIONS(1957),
    [anon_sym_constexpr] = ACTIONS(1957),
    [anon_sym_volatile] = ACTIONS(1957),
    [anon_sym_restrict] = ACTIONS(1957),
    [anon_sym___restrict__] = ACTIONS(1957),
    [anon_sym__Atomic] = ACTIONS(1957),
    [anon_sym__Noreturn] = ACTIONS(1957),
    [anon_sym_noreturn] = ACTIONS(1957),
    [anon_sym_mutable] = ACTIONS(1957),
    [anon_sym_constinit] = ACTIONS(1957),
    [anon_sym_consteval] = ACTIONS(1957),
    [anon_sym_PROGMEM] = ACTIONS(1957),
    [aux_sym_primitive_type_token1] = ACTIONS(1957),
    [anon_sym_byte] = ACTIONS(1957),
    [anon_sym_word] = ACTIONS(1957),
    [anon_sym_enum] = ACTIONS(1957),
    [anon_sym_class] = ACTIONS(1957),
    [anon_sym_struct] = ACTIONS(1957),
    [anon_sym_union] = ACTIONS(1957),
    [anon_sym_if] = ACTIONS(1957),
    [anon_sym_switch] = ACTIONS(1957),
    [anon_sym_case] = ACTIONS(1957),
    [anon_sym_default] = ACTIONS(1957),
    [anon_sym_while] = ACTIONS(1957),
    [anon_sym_do] = ACTIONS(1957),
    [anon_sym_for] = ACTIONS(1957),
    [anon_sym_return] = ACTIONS(1957),
    [anon_sym_break] = ACTIONS(1957),
    [anon_sym_continue] = ACTIONS(1957),
    [anon_sym_goto] = ACTIONS(1957),
    [anon_sym___try] = ACTIONS(1957),
    [anon_sym___leave] = ACTIONS(1957),
    [anon_sym_not] = ACTIONS(1957),
    [anon_sym_compl] = ACTIONS(1957),
    [anon_sym_DASH_DASH] = ACTIONS(1955),
    [anon_sym_PLUS_PLUS] = ACTIONS(1955),
    [anon_sym_sizeof] = ACTIONS(1957),
    [anon_sym___alignof__] = ACTIONS(1957),
    [anon_sym___alignof] = ACTIONS(1957),
    [anon_sym__alignof] = ACTIONS(1957),
    [anon_sym_alignof] = ACTIONS(1957),
    [anon_sym__Alignof] = ACTIONS(1957),
    [anon_sym_offsetof] = ACTIONS(1957),
    [anon_sym__Generic] = ACTIONS(1957),
    [anon_sym_asm] = ACTIONS(1957),
    [anon_sym___asm__] = ACTIONS(1957),
    [aux_sym_number_literal_token1] = ACTIONS(1955),
    [aux_sym_number_literal_token2] = ACTIONS(1957),
    [anon_sym_L_SQUOTE] = ACTIONS(1955),
    [anon_sym_u_SQUOTE] = ACTIONS(1955),
    [anon_sym_U_SQUOTE] = ACTIONS(1955),
    [anon_sym_u8_SQUOTE] = ACTIONS(1955),
    [anon_sym_SQUOTE] = ACTIONS(1955),
    [anon_sym_L_DQUOTE] = ACTIONS(1955),
    [anon_sym_u_DQUOTE] = ACTIONS(1955),
    [anon_sym_U_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8_DQUOTE] = ACTIONS(1955),
    [anon_sym_DQUOTE] = ACTIONS(1955),
    [sym_true] = ACTIONS(1957),
    [sym_false] = ACTIONS(1957),
    [anon_sym_NULL] = ACTIONS(1957),
    [anon_sym_nullptr] = ACTIONS(1957),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1957),
    [anon_sym_decltype] = ACTIONS(1957),
    [anon_sym_virtual] = ACTIONS(1957),
    [anon_sym_alignas] = ACTIONS(1957),
    [anon_sym_explicit] = ACTIONS(1957),
    [anon_sym_typename] = ACTIONS(1957),
    [anon_sym_template] = ACTIONS(1957),
    [anon_sym_operator] = ACTIONS(1957),
    [anon_sym_try] = ACTIONS(1957),
    [anon_sym_delete] = ACTIONS(1957),
    [anon_sym_throw] = ACTIONS(1957),
    [anon_sym_namespace] = ACTIONS(1957),
    [anon_sym_using] = ACTIONS(1957),
    [anon_sym_static_assert] = ACTIONS(1957),
    [anon_sym_concept] = ACTIONS(1957),
    [anon_sym_co_return] = ACTIONS(1957),
    [anon_sym_co_yield] = ACTIONS(1957),
    [anon_sym_R_DQUOTE] = ACTIONS(1955),
    [anon_sym_LR_DQUOTE] = ACTIONS(1955),
    [anon_sym_uR_DQUOTE] = ACTIONS(1955),
    [anon_sym_UR_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1955),
    [anon_sym_co_await] = ACTIONS(1957),
    [anon_sym_new] = ACTIONS(1957),
    [anon_sym_requires] = ACTIONS(1957),
    [sym_this] = ACTIONS(1957),
  },
  [527] = {
    [sym_identifier] = ACTIONS(2717),
    [aux_sym_preproc_include_token1] = ACTIONS(2717),
    [aux_sym_preproc_def_token1] = ACTIONS(2717),
    [aux_sym_preproc_if_token1] = ACTIONS(2717),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2717),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2717),
    [sym_preproc_directive] = ACTIONS(2717),
    [anon_sym_LPAREN2] = ACTIONS(2719),
    [anon_sym_BANG] = ACTIONS(2719),
    [anon_sym_TILDE] = ACTIONS(2719),
    [anon_sym_DASH] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP_AMP] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2717),
    [anon_sym_SEMI] = ACTIONS(2719),
    [anon_sym___extension__] = ACTIONS(2717),
    [anon_sym_typedef] = ACTIONS(2717),
    [anon_sym_extern] = ACTIONS(2717),
    [anon_sym___attribute__] = ACTIONS(2717),
    [anon_sym_COLON_COLON] = ACTIONS(2719),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2719),
    [anon_sym___declspec] = ACTIONS(2717),
    [anon_sym___based] = ACTIONS(2717),
    [anon_sym___cdecl] = ACTIONS(2717),
    [anon_sym___clrcall] = ACTIONS(2717),
    [anon_sym___stdcall] = ACTIONS(2717),
    [anon_sym___fastcall] = ACTIONS(2717),
    [anon_sym___thiscall] = ACTIONS(2717),
    [anon_sym___vectorcall] = ACTIONS(2717),
    [anon_sym_LBRACE] = ACTIONS(2719),
    [anon_sym_RBRACE] = ACTIONS(2719),
    [anon_sym_signed] = ACTIONS(2717),
    [anon_sym_unsigned] = ACTIONS(2717),
    [anon_sym_long] = ACTIONS(2717),
    [anon_sym_short] = ACTIONS(2717),
    [anon_sym_LBRACK] = ACTIONS(2717),
    [anon_sym_static] = ACTIONS(2717),
    [anon_sym_register] = ACTIONS(2717),
    [anon_sym_inline] = ACTIONS(2717),
    [anon_sym___inline] = ACTIONS(2717),
    [anon_sym___inline__] = ACTIONS(2717),
    [anon_sym___forceinline] = ACTIONS(2717),
    [anon_sym_thread_local] = ACTIONS(2717),
    [anon_sym___thread] = ACTIONS(2717),
    [anon_sym_const] = ACTIONS(2717),
    [anon_sym_constexpr] = ACTIONS(2717),
    [anon_sym_volatile] = ACTIONS(2717),
    [anon_sym_restrict] = ACTIONS(2717),
    [anon_sym___restrict__] = ACTIONS(2717),
    [anon_sym__Atomic] = ACTIONS(2717),
    [anon_sym__Noreturn] = ACTIONS(2717),
    [anon_sym_noreturn] = ACTIONS(2717),
    [anon_sym_mutable] = ACTIONS(2717),
    [anon_sym_constinit] = ACTIONS(2717),
    [anon_sym_consteval] = ACTIONS(2717),
    [anon_sym_PROGMEM] = ACTIONS(2717),
    [aux_sym_primitive_type_token1] = ACTIONS(2717),
    [anon_sym_byte] = ACTIONS(2717),
    [anon_sym_word] = ACTIONS(2717),
    [anon_sym_enum] = ACTIONS(2717),
    [anon_sym_class] = ACTIONS(2717),
    [anon_sym_struct] = ACTIONS(2717),
    [anon_sym_union] = ACTIONS(2717),
    [anon_sym_if] = ACTIONS(2717),
    [anon_sym_else] = ACTIONS(2717),
    [anon_sym_switch] = ACTIONS(2717),
    [anon_sym_case] = ACTIONS(2717),
    [anon_sym_default] = ACTIONS(2717),
    [anon_sym_while] = ACTIONS(2717),
    [anon_sym_do] = ACTIONS(2717),
    [anon_sym_for] = ACTIONS(2717),
    [anon_sym_return] = ACTIONS(2717),
    [anon_sym_break] = ACTIONS(2717),
    [anon_sym_continue] = ACTIONS(2717),
    [anon_sym_goto] = ACTIONS(2717),
    [anon_sym___try] = ACTIONS(2717),
    [anon_sym___leave] = ACTIONS(2717),
    [anon_sym_not] = ACTIONS(2717),
    [anon_sym_compl] = ACTIONS(2717),
    [anon_sym_DASH_DASH] = ACTIONS(2719),
    [anon_sym_PLUS_PLUS] = ACTIONS(2719),
    [anon_sym_sizeof] = ACTIONS(2717),
    [anon_sym___alignof__] = ACTIONS(2717),
    [anon_sym___alignof] = ACTIONS(2717),
    [anon_sym__alignof] = ACTIONS(2717),
    [anon_sym_alignof] = ACTIONS(2717),
    [anon_sym__Alignof] = ACTIONS(2717),
    [anon_sym_offsetof] = ACTIONS(2717),
    [anon_sym__Generic] = ACTIONS(2717),
    [anon_sym_asm] = ACTIONS(2717),
    [anon_sym___asm__] = ACTIONS(2717),
    [aux_sym_number_literal_token1] = ACTIONS(2719),
    [aux_sym_number_literal_token2] = ACTIONS(2717),
    [anon_sym_L_SQUOTE] = ACTIONS(2719),
    [anon_sym_u_SQUOTE] = ACTIONS(2719),
    [anon_sym_U_SQUOTE] = ACTIONS(2719),
    [anon_sym_u8_SQUOTE] = ACTIONS(2719),
    [anon_sym_SQUOTE] = ACTIONS(2719),
    [anon_sym_L_DQUOTE] = ACTIONS(2719),
    [anon_sym_u_DQUOTE] = ACTIONS(2719),
    [anon_sym_U_DQUOTE] = ACTIONS(2719),
    [anon_sym_u8_DQUOTE] = ACTIONS(2719),
    [anon_sym_DQUOTE] = ACTIONS(2719),
    [sym_true] = ACTIONS(2717),
    [sym_false] = ACTIONS(2717),
    [anon_sym_NULL] = ACTIONS(2717),
    [anon_sym_nullptr] = ACTIONS(2717),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2717),
    [anon_sym_decltype] = ACTIONS(2717),
    [anon_sym_virtual] = ACTIONS(2717),
    [anon_sym_alignas] = ACTIONS(2717),
    [anon_sym_explicit] = ACTIONS(2717),
    [anon_sym_typename] = ACTIONS(2717),
    [anon_sym_template] = ACTIONS(2717),
    [anon_sym_operator] = ACTIONS(2717),
    [anon_sym_try] = ACTIONS(2717),
    [anon_sym_delete] = ACTIONS(2717),
    [anon_sym_throw] = ACTIONS(2717),
    [anon_sym_namespace] = ACTIONS(2717),
    [anon_sym_using] = ACTIONS(2717),
    [anon_sym_static_assert] = ACTIONS(2717),
    [anon_sym_concept] = ACTIONS(2717),
    [anon_sym_co_return] = ACTIONS(2717),
    [anon_sym_co_yield] = ACTIONS(2717),
    [anon_sym_R_DQUOTE] = ACTIONS(2719),
    [anon_sym_LR_DQUOTE] = ACTIONS(2719),
    [anon_sym_uR_DQUOTE] = ACTIONS(2719),
    [anon_sym_UR_DQUOTE] = ACTIONS(2719),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2719),
    [anon_sym_co_await] = ACTIONS(2717),
    [anon_sym_new] = ACTIONS(2717),
    [anon_sym_requires] = ACTIONS(2717),
    [sym_this] = ACTIONS(2717),
  },
  [528] = {
    [ts_builtin_sym_end] = ACTIONS(2681),
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [529] = {
    [ts_builtin_sym_end] = ACTIONS(2681),
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [530] = {
    [sym_identifier] = ACTIONS(2723),
    [aux_sym_preproc_include_token1] = ACTIONS(2723),
    [aux_sym_preproc_def_token1] = ACTIONS(2723),
    [aux_sym_preproc_if_token1] = ACTIONS(2723),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2723),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2723),
    [sym_preproc_directive] = ACTIONS(2723),
    [anon_sym_LPAREN2] = ACTIONS(2725),
    [anon_sym_BANG] = ACTIONS(2725),
    [anon_sym_TILDE] = ACTIONS(2725),
    [anon_sym_DASH] = ACTIONS(2723),
    [anon_sym_PLUS] = ACTIONS(2723),
    [anon_sym_STAR] = ACTIONS(2725),
    [anon_sym_AMP_AMP] = ACTIONS(2725),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_SEMI] = ACTIONS(2725),
    [anon_sym___extension__] = ACTIONS(2723),
    [anon_sym_typedef] = ACTIONS(2723),
    [anon_sym_extern] = ACTIONS(2723),
    [anon_sym___attribute__] = ACTIONS(2723),
    [anon_sym_COLON_COLON] = ACTIONS(2725),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2725),
    [anon_sym___declspec] = ACTIONS(2723),
    [anon_sym___based] = ACTIONS(2723),
    [anon_sym___cdecl] = ACTIONS(2723),
    [anon_sym___clrcall] = ACTIONS(2723),
    [anon_sym___stdcall] = ACTIONS(2723),
    [anon_sym___fastcall] = ACTIONS(2723),
    [anon_sym___thiscall] = ACTIONS(2723),
    [anon_sym___vectorcall] = ACTIONS(2723),
    [anon_sym_LBRACE] = ACTIONS(2725),
    [anon_sym_RBRACE] = ACTIONS(2725),
    [anon_sym_signed] = ACTIONS(2723),
    [anon_sym_unsigned] = ACTIONS(2723),
    [anon_sym_long] = ACTIONS(2723),
    [anon_sym_short] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_static] = ACTIONS(2723),
    [anon_sym_register] = ACTIONS(2723),
    [anon_sym_inline] = ACTIONS(2723),
    [anon_sym___inline] = ACTIONS(2723),
    [anon_sym___inline__] = ACTIONS(2723),
    [anon_sym___forceinline] = ACTIONS(2723),
    [anon_sym_thread_local] = ACTIONS(2723),
    [anon_sym___thread] = ACTIONS(2723),
    [anon_sym_const] = ACTIONS(2723),
    [anon_sym_constexpr] = ACTIONS(2723),
    [anon_sym_volatile] = ACTIONS(2723),
    [anon_sym_restrict] = ACTIONS(2723),
    [anon_sym___restrict__] = ACTIONS(2723),
    [anon_sym__Atomic] = ACTIONS(2723),
    [anon_sym__Noreturn] = ACTIONS(2723),
    [anon_sym_noreturn] = ACTIONS(2723),
    [anon_sym_mutable] = ACTIONS(2723),
    [anon_sym_constinit] = ACTIONS(2723),
    [anon_sym_consteval] = ACTIONS(2723),
    [anon_sym_PROGMEM] = ACTIONS(2723),
    [aux_sym_primitive_type_token1] = ACTIONS(2723),
    [anon_sym_byte] = ACTIONS(2723),
    [anon_sym_word] = ACTIONS(2723),
    [anon_sym_enum] = ACTIONS(2723),
    [anon_sym_class] = ACTIONS(2723),
    [anon_sym_struct] = ACTIONS(2723),
    [anon_sym_union] = ACTIONS(2723),
    [anon_sym_if] = ACTIONS(2723),
    [anon_sym_else] = ACTIONS(2723),
    [anon_sym_switch] = ACTIONS(2723),
    [anon_sym_case] = ACTIONS(2723),
    [anon_sym_default] = ACTIONS(2723),
    [anon_sym_while] = ACTIONS(2723),
    [anon_sym_do] = ACTIONS(2723),
    [anon_sym_for] = ACTIONS(2723),
    [anon_sym_return] = ACTIONS(2723),
    [anon_sym_break] = ACTIONS(2723),
    [anon_sym_continue] = ACTIONS(2723),
    [anon_sym_goto] = ACTIONS(2723),
    [anon_sym___try] = ACTIONS(2723),
    [anon_sym___leave] = ACTIONS(2723),
    [anon_sym_not] = ACTIONS(2723),
    [anon_sym_compl] = ACTIONS(2723),
    [anon_sym_DASH_DASH] = ACTIONS(2725),
    [anon_sym_PLUS_PLUS] = ACTIONS(2725),
    [anon_sym_sizeof] = ACTIONS(2723),
    [anon_sym___alignof__] = ACTIONS(2723),
    [anon_sym___alignof] = ACTIONS(2723),
    [anon_sym__alignof] = ACTIONS(2723),
    [anon_sym_alignof] = ACTIONS(2723),
    [anon_sym__Alignof] = ACTIONS(2723),
    [anon_sym_offsetof] = ACTIONS(2723),
    [anon_sym__Generic] = ACTIONS(2723),
    [anon_sym_asm] = ACTIONS(2723),
    [anon_sym___asm__] = ACTIONS(2723),
    [aux_sym_number_literal_token1] = ACTIONS(2725),
    [aux_sym_number_literal_token2] = ACTIONS(2723),
    [anon_sym_L_SQUOTE] = ACTIONS(2725),
    [anon_sym_u_SQUOTE] = ACTIONS(2725),
    [anon_sym_U_SQUOTE] = ACTIONS(2725),
    [anon_sym_u8_SQUOTE] = ACTIONS(2725),
    [anon_sym_SQUOTE] = ACTIONS(2725),
    [anon_sym_L_DQUOTE] = ACTIONS(2725),
    [anon_sym_u_DQUOTE] = ACTIONS(2725),
    [anon_sym_U_DQUOTE] = ACTIONS(2725),
    [anon_sym_u8_DQUOTE] = ACTIONS(2725),
    [anon_sym_DQUOTE] = ACTIONS(2725),
    [sym_true] = ACTIONS(2723),
    [sym_false] = ACTIONS(2723),
    [anon_sym_NULL] = ACTIONS(2723),
    [anon_sym_nullptr] = ACTIONS(2723),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2723),
    [anon_sym_decltype] = ACTIONS(2723),
    [anon_sym_virtual] = ACTIONS(2723),
    [anon_sym_alignas] = ACTIONS(2723),
    [anon_sym_explicit] = ACTIONS(2723),
    [anon_sym_typename] = ACTIONS(2723),
    [anon_sym_template] = ACTIONS(2723),
    [anon_sym_operator] = ACTIONS(2723),
    [anon_sym_try] = ACTIONS(2723),
    [anon_sym_delete] = ACTIONS(2723),
    [anon_sym_throw] = ACTIONS(2723),
    [anon_sym_namespace] = ACTIONS(2723),
    [anon_sym_using] = ACTIONS(2723),
    [anon_sym_static_assert] = ACTIONS(2723),
    [anon_sym_concept] = ACTIONS(2723),
    [anon_sym_co_return] = ACTIONS(2723),
    [anon_sym_co_yield] = ACTIONS(2723),
    [anon_sym_R_DQUOTE] = ACTIONS(2725),
    [anon_sym_LR_DQUOTE] = ACTIONS(2725),
    [anon_sym_uR_DQUOTE] = ACTIONS(2725),
    [anon_sym_UR_DQUOTE] = ACTIONS(2725),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2725),
    [anon_sym_co_await] = ACTIONS(2723),
    [anon_sym_new] = ACTIONS(2723),
    [anon_sym_requires] = ACTIONS(2723),
    [sym_this] = ACTIONS(2723),
  },
  [531] = {
    [ts_builtin_sym_end] = ACTIONS(2681),
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [532] = {
    [ts_builtin_sym_end] = ACTIONS(2681),
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [533] = {
    [sym_identifier] = ACTIONS(2723),
    [aux_sym_preproc_include_token1] = ACTIONS(2723),
    [aux_sym_preproc_def_token1] = ACTIONS(2723),
    [aux_sym_preproc_if_token1] = ACTIONS(2723),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2723),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2723),
    [sym_preproc_directive] = ACTIONS(2723),
    [anon_sym_LPAREN2] = ACTIONS(2725),
    [anon_sym_BANG] = ACTIONS(2725),
    [anon_sym_TILDE] = ACTIONS(2725),
    [anon_sym_DASH] = ACTIONS(2723),
    [anon_sym_PLUS] = ACTIONS(2723),
    [anon_sym_STAR] = ACTIONS(2725),
    [anon_sym_AMP_AMP] = ACTIONS(2725),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_SEMI] = ACTIONS(2725),
    [anon_sym___extension__] = ACTIONS(2723),
    [anon_sym_typedef] = ACTIONS(2723),
    [anon_sym_extern] = ACTIONS(2723),
    [anon_sym___attribute__] = ACTIONS(2723),
    [anon_sym_COLON_COLON] = ACTIONS(2725),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2725),
    [anon_sym___declspec] = ACTIONS(2723),
    [anon_sym___based] = ACTIONS(2723),
    [anon_sym___cdecl] = ACTIONS(2723),
    [anon_sym___clrcall] = ACTIONS(2723),
    [anon_sym___stdcall] = ACTIONS(2723),
    [anon_sym___fastcall] = ACTIONS(2723),
    [anon_sym___thiscall] = ACTIONS(2723),
    [anon_sym___vectorcall] = ACTIONS(2723),
    [anon_sym_LBRACE] = ACTIONS(2725),
    [anon_sym_RBRACE] = ACTIONS(2725),
    [anon_sym_signed] = ACTIONS(2723),
    [anon_sym_unsigned] = ACTIONS(2723),
    [anon_sym_long] = ACTIONS(2723),
    [anon_sym_short] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_static] = ACTIONS(2723),
    [anon_sym_register] = ACTIONS(2723),
    [anon_sym_inline] = ACTIONS(2723),
    [anon_sym___inline] = ACTIONS(2723),
    [anon_sym___inline__] = ACTIONS(2723),
    [anon_sym___forceinline] = ACTIONS(2723),
    [anon_sym_thread_local] = ACTIONS(2723),
    [anon_sym___thread] = ACTIONS(2723),
    [anon_sym_const] = ACTIONS(2723),
    [anon_sym_constexpr] = ACTIONS(2723),
    [anon_sym_volatile] = ACTIONS(2723),
    [anon_sym_restrict] = ACTIONS(2723),
    [anon_sym___restrict__] = ACTIONS(2723),
    [anon_sym__Atomic] = ACTIONS(2723),
    [anon_sym__Noreturn] = ACTIONS(2723),
    [anon_sym_noreturn] = ACTIONS(2723),
    [anon_sym_mutable] = ACTIONS(2723),
    [anon_sym_constinit] = ACTIONS(2723),
    [anon_sym_consteval] = ACTIONS(2723),
    [anon_sym_PROGMEM] = ACTIONS(2723),
    [aux_sym_primitive_type_token1] = ACTIONS(2723),
    [anon_sym_byte] = ACTIONS(2723),
    [anon_sym_word] = ACTIONS(2723),
    [anon_sym_enum] = ACTIONS(2723),
    [anon_sym_class] = ACTIONS(2723),
    [anon_sym_struct] = ACTIONS(2723),
    [anon_sym_union] = ACTIONS(2723),
    [anon_sym_if] = ACTIONS(2723),
    [anon_sym_else] = ACTIONS(2723),
    [anon_sym_switch] = ACTIONS(2723),
    [anon_sym_case] = ACTIONS(2723),
    [anon_sym_default] = ACTIONS(2723),
    [anon_sym_while] = ACTIONS(2723),
    [anon_sym_do] = ACTIONS(2723),
    [anon_sym_for] = ACTIONS(2723),
    [anon_sym_return] = ACTIONS(2723),
    [anon_sym_break] = ACTIONS(2723),
    [anon_sym_continue] = ACTIONS(2723),
    [anon_sym_goto] = ACTIONS(2723),
    [anon_sym___try] = ACTIONS(2723),
    [anon_sym___leave] = ACTIONS(2723),
    [anon_sym_not] = ACTIONS(2723),
    [anon_sym_compl] = ACTIONS(2723),
    [anon_sym_DASH_DASH] = ACTIONS(2725),
    [anon_sym_PLUS_PLUS] = ACTIONS(2725),
    [anon_sym_sizeof] = ACTIONS(2723),
    [anon_sym___alignof__] = ACTIONS(2723),
    [anon_sym___alignof] = ACTIONS(2723),
    [anon_sym__alignof] = ACTIONS(2723),
    [anon_sym_alignof] = ACTIONS(2723),
    [anon_sym__Alignof] = ACTIONS(2723),
    [anon_sym_offsetof] = ACTIONS(2723),
    [anon_sym__Generic] = ACTIONS(2723),
    [anon_sym_asm] = ACTIONS(2723),
    [anon_sym___asm__] = ACTIONS(2723),
    [aux_sym_number_literal_token1] = ACTIONS(2725),
    [aux_sym_number_literal_token2] = ACTIONS(2723),
    [anon_sym_L_SQUOTE] = ACTIONS(2725),
    [anon_sym_u_SQUOTE] = ACTIONS(2725),
    [anon_sym_U_SQUOTE] = ACTIONS(2725),
    [anon_sym_u8_SQUOTE] = ACTIONS(2725),
    [anon_sym_SQUOTE] = ACTIONS(2725),
    [anon_sym_L_DQUOTE] = ACTIONS(2725),
    [anon_sym_u_DQUOTE] = ACTIONS(2725),
    [anon_sym_U_DQUOTE] = ACTIONS(2725),
    [anon_sym_u8_DQUOTE] = ACTIONS(2725),
    [anon_sym_DQUOTE] = ACTIONS(2725),
    [sym_true] = ACTIONS(2723),
    [sym_false] = ACTIONS(2723),
    [anon_sym_NULL] = ACTIONS(2723),
    [anon_sym_nullptr] = ACTIONS(2723),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2723),
    [anon_sym_decltype] = ACTIONS(2723),
    [anon_sym_virtual] = ACTIONS(2723),
    [anon_sym_alignas] = ACTIONS(2723),
    [anon_sym_explicit] = ACTIONS(2723),
    [anon_sym_typename] = ACTIONS(2723),
    [anon_sym_template] = ACTIONS(2723),
    [anon_sym_operator] = ACTIONS(2723),
    [anon_sym_try] = ACTIONS(2723),
    [anon_sym_delete] = ACTIONS(2723),
    [anon_sym_throw] = ACTIONS(2723),
    [anon_sym_namespace] = ACTIONS(2723),
    [anon_sym_using] = ACTIONS(2723),
    [anon_sym_static_assert] = ACTIONS(2723),
    [anon_sym_concept] = ACTIONS(2723),
    [anon_sym_co_return] = ACTIONS(2723),
    [anon_sym_co_yield] = ACTIONS(2723),
    [anon_sym_R_DQUOTE] = ACTIONS(2725),
    [anon_sym_LR_DQUOTE] = ACTIONS(2725),
    [anon_sym_uR_DQUOTE] = ACTIONS(2725),
    [anon_sym_UR_DQUOTE] = ACTIONS(2725),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2725),
    [anon_sym_co_await] = ACTIONS(2723),
    [anon_sym_new] = ACTIONS(2723),
    [anon_sym_requires] = ACTIONS(2723),
    [sym_this] = ACTIONS(2723),
  },
  [534] = {
    [sym_identifier] = ACTIONS(2797),
    [aux_sym_preproc_include_token1] = ACTIONS(2797),
    [aux_sym_preproc_def_token1] = ACTIONS(2797),
    [aux_sym_preproc_if_token1] = ACTIONS(2797),
    [aux_sym_preproc_if_token2] = ACTIONS(2797),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2797),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2797),
    [sym_preproc_directive] = ACTIONS(2797),
    [anon_sym_LPAREN2] = ACTIONS(2799),
    [anon_sym_BANG] = ACTIONS(2799),
    [anon_sym_TILDE] = ACTIONS(2799),
    [anon_sym_DASH] = ACTIONS(2797),
    [anon_sym_PLUS] = ACTIONS(2797),
    [anon_sym_STAR] = ACTIONS(2799),
    [anon_sym_AMP_AMP] = ACTIONS(2799),
    [anon_sym_AMP] = ACTIONS(2797),
    [anon_sym_SEMI] = ACTIONS(2799),
    [anon_sym___extension__] = ACTIONS(2797),
    [anon_sym_typedef] = ACTIONS(2797),
    [anon_sym_extern] = ACTIONS(2797),
    [anon_sym___attribute__] = ACTIONS(2797),
    [anon_sym_COLON_COLON] = ACTIONS(2799),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2799),
    [anon_sym___declspec] = ACTIONS(2797),
    [anon_sym___based] = ACTIONS(2797),
    [anon_sym___cdecl] = ACTIONS(2797),
    [anon_sym___clrcall] = ACTIONS(2797),
    [anon_sym___stdcall] = ACTIONS(2797),
    [anon_sym___fastcall] = ACTIONS(2797),
    [anon_sym___thiscall] = ACTIONS(2797),
    [anon_sym___vectorcall] = ACTIONS(2797),
    [anon_sym_LBRACE] = ACTIONS(2799),
    [anon_sym_signed] = ACTIONS(2797),
    [anon_sym_unsigned] = ACTIONS(2797),
    [anon_sym_long] = ACTIONS(2797),
    [anon_sym_short] = ACTIONS(2797),
    [anon_sym_LBRACK] = ACTIONS(2797),
    [anon_sym_static] = ACTIONS(2797),
    [anon_sym_register] = ACTIONS(2797),
    [anon_sym_inline] = ACTIONS(2797),
    [anon_sym___inline] = ACTIONS(2797),
    [anon_sym___inline__] = ACTIONS(2797),
    [anon_sym___forceinline] = ACTIONS(2797),
    [anon_sym_thread_local] = ACTIONS(2797),
    [anon_sym___thread] = ACTIONS(2797),
    [anon_sym_const] = ACTIONS(2797),
    [anon_sym_constexpr] = ACTIONS(2797),
    [anon_sym_volatile] = ACTIONS(2797),
    [anon_sym_restrict] = ACTIONS(2797),
    [anon_sym___restrict__] = ACTIONS(2797),
    [anon_sym__Atomic] = ACTIONS(2797),
    [anon_sym__Noreturn] = ACTIONS(2797),
    [anon_sym_noreturn] = ACTIONS(2797),
    [anon_sym_mutable] = ACTIONS(2797),
    [anon_sym_constinit] = ACTIONS(2797),
    [anon_sym_consteval] = ACTIONS(2797),
    [anon_sym_PROGMEM] = ACTIONS(2797),
    [aux_sym_primitive_type_token1] = ACTIONS(2797),
    [anon_sym_byte] = ACTIONS(2797),
    [anon_sym_word] = ACTIONS(2797),
    [anon_sym_enum] = ACTIONS(2797),
    [anon_sym_class] = ACTIONS(2797),
    [anon_sym_struct] = ACTIONS(2797),
    [anon_sym_union] = ACTIONS(2797),
    [anon_sym_if] = ACTIONS(2797),
    [anon_sym_else] = ACTIONS(2797),
    [anon_sym_switch] = ACTIONS(2797),
    [anon_sym_case] = ACTIONS(2797),
    [anon_sym_default] = ACTIONS(2797),
    [anon_sym_while] = ACTIONS(2797),
    [anon_sym_do] = ACTIONS(2797),
    [anon_sym_for] = ACTIONS(2797),
    [anon_sym_return] = ACTIONS(2797),
    [anon_sym_break] = ACTIONS(2797),
    [anon_sym_continue] = ACTIONS(2797),
    [anon_sym_goto] = ACTIONS(2797),
    [anon_sym___try] = ACTIONS(2797),
    [anon_sym___leave] = ACTIONS(2797),
    [anon_sym_not] = ACTIONS(2797),
    [anon_sym_compl] = ACTIONS(2797),
    [anon_sym_DASH_DASH] = ACTIONS(2799),
    [anon_sym_PLUS_PLUS] = ACTIONS(2799),
    [anon_sym_sizeof] = ACTIONS(2797),
    [anon_sym___alignof__] = ACTIONS(2797),
    [anon_sym___alignof] = ACTIONS(2797),
    [anon_sym__alignof] = ACTIONS(2797),
    [anon_sym_alignof] = ACTIONS(2797),
    [anon_sym__Alignof] = ACTIONS(2797),
    [anon_sym_offsetof] = ACTIONS(2797),
    [anon_sym__Generic] = ACTIONS(2797),
    [anon_sym_asm] = ACTIONS(2797),
    [anon_sym___asm__] = ACTIONS(2797),
    [aux_sym_number_literal_token1] = ACTIONS(2799),
    [aux_sym_number_literal_token2] = ACTIONS(2797),
    [anon_sym_L_SQUOTE] = ACTIONS(2799),
    [anon_sym_u_SQUOTE] = ACTIONS(2799),
    [anon_sym_U_SQUOTE] = ACTIONS(2799),
    [anon_sym_u8_SQUOTE] = ACTIONS(2799),
    [anon_sym_SQUOTE] = ACTIONS(2799),
    [anon_sym_L_DQUOTE] = ACTIONS(2799),
    [anon_sym_u_DQUOTE] = ACTIONS(2799),
    [anon_sym_U_DQUOTE] = ACTIONS(2799),
    [anon_sym_u8_DQUOTE] = ACTIONS(2799),
    [anon_sym_DQUOTE] = ACTIONS(2799),
    [sym_true] = ACTIONS(2797),
    [sym_false] = ACTIONS(2797),
    [anon_sym_NULL] = ACTIONS(2797),
    [anon_sym_nullptr] = ACTIONS(2797),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2797),
    [anon_sym_decltype] = ACTIONS(2797),
    [anon_sym_virtual] = ACTIONS(2797),
    [anon_sym_alignas] = ACTIONS(2797),
    [anon_sym_explicit] = ACTIONS(2797),
    [anon_sym_typename] = ACTIONS(2797),
    [anon_sym_template] = ACTIONS(2797),
    [anon_sym_operator] = ACTIONS(2797),
    [anon_sym_try] = ACTIONS(2797),
    [anon_sym_delete] = ACTIONS(2797),
    [anon_sym_throw] = ACTIONS(2797),
    [anon_sym_namespace] = ACTIONS(2797),
    [anon_sym_using] = ACTIONS(2797),
    [anon_sym_static_assert] = ACTIONS(2797),
    [anon_sym_concept] = ACTIONS(2797),
    [anon_sym_co_return] = ACTIONS(2797),
    [anon_sym_co_yield] = ACTIONS(2797),
    [anon_sym_R_DQUOTE] = ACTIONS(2799),
    [anon_sym_LR_DQUOTE] = ACTIONS(2799),
    [anon_sym_uR_DQUOTE] = ACTIONS(2799),
    [anon_sym_UR_DQUOTE] = ACTIONS(2799),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2799),
    [anon_sym_co_await] = ACTIONS(2797),
    [anon_sym_new] = ACTIONS(2797),
    [anon_sym_requires] = ACTIONS(2797),
    [sym_this] = ACTIONS(2797),
  },
  [535] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token2] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [536] = {
    [sym_identifier] = ACTIONS(2751),
    [aux_sym_preproc_include_token1] = ACTIONS(2751),
    [aux_sym_preproc_def_token1] = ACTIONS(2751),
    [aux_sym_preproc_if_token1] = ACTIONS(2751),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2751),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2751),
    [sym_preproc_directive] = ACTIONS(2751),
    [anon_sym_LPAREN2] = ACTIONS(2753),
    [anon_sym_BANG] = ACTIONS(2753),
    [anon_sym_TILDE] = ACTIONS(2753),
    [anon_sym_DASH] = ACTIONS(2751),
    [anon_sym_PLUS] = ACTIONS(2751),
    [anon_sym_STAR] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2751),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym___extension__] = ACTIONS(2751),
    [anon_sym_typedef] = ACTIONS(2751),
    [anon_sym_extern] = ACTIONS(2751),
    [anon_sym___attribute__] = ACTIONS(2751),
    [anon_sym_COLON_COLON] = ACTIONS(2753),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2753),
    [anon_sym___declspec] = ACTIONS(2751),
    [anon_sym___based] = ACTIONS(2751),
    [anon_sym___cdecl] = ACTIONS(2751),
    [anon_sym___clrcall] = ACTIONS(2751),
    [anon_sym___stdcall] = ACTIONS(2751),
    [anon_sym___fastcall] = ACTIONS(2751),
    [anon_sym___thiscall] = ACTIONS(2751),
    [anon_sym___vectorcall] = ACTIONS(2751),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_RBRACE] = ACTIONS(2753),
    [anon_sym_signed] = ACTIONS(2751),
    [anon_sym_unsigned] = ACTIONS(2751),
    [anon_sym_long] = ACTIONS(2751),
    [anon_sym_short] = ACTIONS(2751),
    [anon_sym_LBRACK] = ACTIONS(2751),
    [anon_sym_static] = ACTIONS(2751),
    [anon_sym_register] = ACTIONS(2751),
    [anon_sym_inline] = ACTIONS(2751),
    [anon_sym___inline] = ACTIONS(2751),
    [anon_sym___inline__] = ACTIONS(2751),
    [anon_sym___forceinline] = ACTIONS(2751),
    [anon_sym_thread_local] = ACTIONS(2751),
    [anon_sym___thread] = ACTIONS(2751),
    [anon_sym_const] = ACTIONS(2751),
    [anon_sym_constexpr] = ACTIONS(2751),
    [anon_sym_volatile] = ACTIONS(2751),
    [anon_sym_restrict] = ACTIONS(2751),
    [anon_sym___restrict__] = ACTIONS(2751),
    [anon_sym__Atomic] = ACTIONS(2751),
    [anon_sym__Noreturn] = ACTIONS(2751),
    [anon_sym_noreturn] = ACTIONS(2751),
    [anon_sym_mutable] = ACTIONS(2751),
    [anon_sym_constinit] = ACTIONS(2751),
    [anon_sym_consteval] = ACTIONS(2751),
    [anon_sym_PROGMEM] = ACTIONS(2751),
    [aux_sym_primitive_type_token1] = ACTIONS(2751),
    [anon_sym_byte] = ACTIONS(2751),
    [anon_sym_word] = ACTIONS(2751),
    [anon_sym_enum] = ACTIONS(2751),
    [anon_sym_class] = ACTIONS(2751),
    [anon_sym_struct] = ACTIONS(2751),
    [anon_sym_union] = ACTIONS(2751),
    [anon_sym_if] = ACTIONS(2751),
    [anon_sym_else] = ACTIONS(2751),
    [anon_sym_switch] = ACTIONS(2751),
    [anon_sym_case] = ACTIONS(2751),
    [anon_sym_default] = ACTIONS(2751),
    [anon_sym_while] = ACTIONS(2751),
    [anon_sym_do] = ACTIONS(2751),
    [anon_sym_for] = ACTIONS(2751),
    [anon_sym_return] = ACTIONS(2751),
    [anon_sym_break] = ACTIONS(2751),
    [anon_sym_continue] = ACTIONS(2751),
    [anon_sym_goto] = ACTIONS(2751),
    [anon_sym___try] = ACTIONS(2751),
    [anon_sym___leave] = ACTIONS(2751),
    [anon_sym_not] = ACTIONS(2751),
    [anon_sym_compl] = ACTIONS(2751),
    [anon_sym_DASH_DASH] = ACTIONS(2753),
    [anon_sym_PLUS_PLUS] = ACTIONS(2753),
    [anon_sym_sizeof] = ACTIONS(2751),
    [anon_sym___alignof__] = ACTIONS(2751),
    [anon_sym___alignof] = ACTIONS(2751),
    [anon_sym__alignof] = ACTIONS(2751),
    [anon_sym_alignof] = ACTIONS(2751),
    [anon_sym__Alignof] = ACTIONS(2751),
    [anon_sym_offsetof] = ACTIONS(2751),
    [anon_sym__Generic] = ACTIONS(2751),
    [anon_sym_asm] = ACTIONS(2751),
    [anon_sym___asm__] = ACTIONS(2751),
    [aux_sym_number_literal_token1] = ACTIONS(2753),
    [aux_sym_number_literal_token2] = ACTIONS(2751),
    [anon_sym_L_SQUOTE] = ACTIONS(2753),
    [anon_sym_u_SQUOTE] = ACTIONS(2753),
    [anon_sym_U_SQUOTE] = ACTIONS(2753),
    [anon_sym_u8_SQUOTE] = ACTIONS(2753),
    [anon_sym_SQUOTE] = ACTIONS(2753),
    [anon_sym_L_DQUOTE] = ACTIONS(2753),
    [anon_sym_u_DQUOTE] = ACTIONS(2753),
    [anon_sym_U_DQUOTE] = ACTIONS(2753),
    [anon_sym_u8_DQUOTE] = ACTIONS(2753),
    [anon_sym_DQUOTE] = ACTIONS(2753),
    [sym_true] = ACTIONS(2751),
    [sym_false] = ACTIONS(2751),
    [anon_sym_NULL] = ACTIONS(2751),
    [anon_sym_nullptr] = ACTIONS(2751),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2751),
    [anon_sym_decltype] = ACTIONS(2751),
    [anon_sym_virtual] = ACTIONS(2751),
    [anon_sym_alignas] = ACTIONS(2751),
    [anon_sym_explicit] = ACTIONS(2751),
    [anon_sym_typename] = ACTIONS(2751),
    [anon_sym_template] = ACTIONS(2751),
    [anon_sym_operator] = ACTIONS(2751),
    [anon_sym_try] = ACTIONS(2751),
    [anon_sym_delete] = ACTIONS(2751),
    [anon_sym_throw] = ACTIONS(2751),
    [anon_sym_namespace] = ACTIONS(2751),
    [anon_sym_using] = ACTIONS(2751),
    [anon_sym_static_assert] = ACTIONS(2751),
    [anon_sym_concept] = ACTIONS(2751),
    [anon_sym_co_return] = ACTIONS(2751),
    [anon_sym_co_yield] = ACTIONS(2751),
    [anon_sym_R_DQUOTE] = ACTIONS(2753),
    [anon_sym_LR_DQUOTE] = ACTIONS(2753),
    [anon_sym_uR_DQUOTE] = ACTIONS(2753),
    [anon_sym_UR_DQUOTE] = ACTIONS(2753),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2753),
    [anon_sym_co_await] = ACTIONS(2751),
    [anon_sym_new] = ACTIONS(2751),
    [anon_sym_requires] = ACTIONS(2751),
    [sym_this] = ACTIONS(2751),
  },
  [537] = {
    [sym_identifier] = ACTIONS(2755),
    [aux_sym_preproc_include_token1] = ACTIONS(2755),
    [aux_sym_preproc_def_token1] = ACTIONS(2755),
    [aux_sym_preproc_if_token1] = ACTIONS(2755),
    [aux_sym_preproc_if_token2] = ACTIONS(2755),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2755),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2755),
    [sym_preproc_directive] = ACTIONS(2755),
    [anon_sym_LPAREN2] = ACTIONS(2757),
    [anon_sym_BANG] = ACTIONS(2757),
    [anon_sym_TILDE] = ACTIONS(2757),
    [anon_sym_DASH] = ACTIONS(2755),
    [anon_sym_PLUS] = ACTIONS(2755),
    [anon_sym_STAR] = ACTIONS(2757),
    [anon_sym_AMP_AMP] = ACTIONS(2757),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2757),
    [anon_sym___extension__] = ACTIONS(2755),
    [anon_sym_typedef] = ACTIONS(2755),
    [anon_sym_extern] = ACTIONS(2755),
    [anon_sym___attribute__] = ACTIONS(2755),
    [anon_sym_COLON_COLON] = ACTIONS(2757),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2757),
    [anon_sym___declspec] = ACTIONS(2755),
    [anon_sym___based] = ACTIONS(2755),
    [anon_sym___cdecl] = ACTIONS(2755),
    [anon_sym___clrcall] = ACTIONS(2755),
    [anon_sym___stdcall] = ACTIONS(2755),
    [anon_sym___fastcall] = ACTIONS(2755),
    [anon_sym___thiscall] = ACTIONS(2755),
    [anon_sym___vectorcall] = ACTIONS(2755),
    [anon_sym_LBRACE] = ACTIONS(2757),
    [anon_sym_signed] = ACTIONS(2755),
    [anon_sym_unsigned] = ACTIONS(2755),
    [anon_sym_long] = ACTIONS(2755),
    [anon_sym_short] = ACTIONS(2755),
    [anon_sym_LBRACK] = ACTIONS(2755),
    [anon_sym_static] = ACTIONS(2755),
    [anon_sym_register] = ACTIONS(2755),
    [anon_sym_inline] = ACTIONS(2755),
    [anon_sym___inline] = ACTIONS(2755),
    [anon_sym___inline__] = ACTIONS(2755),
    [anon_sym___forceinline] = ACTIONS(2755),
    [anon_sym_thread_local] = ACTIONS(2755),
    [anon_sym___thread] = ACTIONS(2755),
    [anon_sym_const] = ACTIONS(2755),
    [anon_sym_constexpr] = ACTIONS(2755),
    [anon_sym_volatile] = ACTIONS(2755),
    [anon_sym_restrict] = ACTIONS(2755),
    [anon_sym___restrict__] = ACTIONS(2755),
    [anon_sym__Atomic] = ACTIONS(2755),
    [anon_sym__Noreturn] = ACTIONS(2755),
    [anon_sym_noreturn] = ACTIONS(2755),
    [anon_sym_mutable] = ACTIONS(2755),
    [anon_sym_constinit] = ACTIONS(2755),
    [anon_sym_consteval] = ACTIONS(2755),
    [anon_sym_PROGMEM] = ACTIONS(2755),
    [aux_sym_primitive_type_token1] = ACTIONS(2755),
    [anon_sym_byte] = ACTIONS(2755),
    [anon_sym_word] = ACTIONS(2755),
    [anon_sym_enum] = ACTIONS(2755),
    [anon_sym_class] = ACTIONS(2755),
    [anon_sym_struct] = ACTIONS(2755),
    [anon_sym_union] = ACTIONS(2755),
    [anon_sym_if] = ACTIONS(2755),
    [anon_sym_else] = ACTIONS(2755),
    [anon_sym_switch] = ACTIONS(2755),
    [anon_sym_case] = ACTIONS(2755),
    [anon_sym_default] = ACTIONS(2755),
    [anon_sym_while] = ACTIONS(2755),
    [anon_sym_do] = ACTIONS(2755),
    [anon_sym_for] = ACTIONS(2755),
    [anon_sym_return] = ACTIONS(2755),
    [anon_sym_break] = ACTIONS(2755),
    [anon_sym_continue] = ACTIONS(2755),
    [anon_sym_goto] = ACTIONS(2755),
    [anon_sym___try] = ACTIONS(2755),
    [anon_sym___leave] = ACTIONS(2755),
    [anon_sym_not] = ACTIONS(2755),
    [anon_sym_compl] = ACTIONS(2755),
    [anon_sym_DASH_DASH] = ACTIONS(2757),
    [anon_sym_PLUS_PLUS] = ACTIONS(2757),
    [anon_sym_sizeof] = ACTIONS(2755),
    [anon_sym___alignof__] = ACTIONS(2755),
    [anon_sym___alignof] = ACTIONS(2755),
    [anon_sym__alignof] = ACTIONS(2755),
    [anon_sym_alignof] = ACTIONS(2755),
    [anon_sym__Alignof] = ACTIONS(2755),
    [anon_sym_offsetof] = ACTIONS(2755),
    [anon_sym__Generic] = ACTIONS(2755),
    [anon_sym_asm] = ACTIONS(2755),
    [anon_sym___asm__] = ACTIONS(2755),
    [aux_sym_number_literal_token1] = ACTIONS(2757),
    [aux_sym_number_literal_token2] = ACTIONS(2755),
    [anon_sym_L_SQUOTE] = ACTIONS(2757),
    [anon_sym_u_SQUOTE] = ACTIONS(2757),
    [anon_sym_U_SQUOTE] = ACTIONS(2757),
    [anon_sym_u8_SQUOTE] = ACTIONS(2757),
    [anon_sym_SQUOTE] = ACTIONS(2757),
    [anon_sym_L_DQUOTE] = ACTIONS(2757),
    [anon_sym_u_DQUOTE] = ACTIONS(2757),
    [anon_sym_U_DQUOTE] = ACTIONS(2757),
    [anon_sym_u8_DQUOTE] = ACTIONS(2757),
    [anon_sym_DQUOTE] = ACTIONS(2757),
    [sym_true] = ACTIONS(2755),
    [sym_false] = ACTIONS(2755),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2755),
    [anon_sym_decltype] = ACTIONS(2755),
    [anon_sym_virtual] = ACTIONS(2755),
    [anon_sym_alignas] = ACTIONS(2755),
    [anon_sym_explicit] = ACTIONS(2755),
    [anon_sym_typename] = ACTIONS(2755),
    [anon_sym_template] = ACTIONS(2755),
    [anon_sym_operator] = ACTIONS(2755),
    [anon_sym_try] = ACTIONS(2755),
    [anon_sym_delete] = ACTIONS(2755),
    [anon_sym_throw] = ACTIONS(2755),
    [anon_sym_namespace] = ACTIONS(2755),
    [anon_sym_using] = ACTIONS(2755),
    [anon_sym_static_assert] = ACTIONS(2755),
    [anon_sym_concept] = ACTIONS(2755),
    [anon_sym_co_return] = ACTIONS(2755),
    [anon_sym_co_yield] = ACTIONS(2755),
    [anon_sym_R_DQUOTE] = ACTIONS(2757),
    [anon_sym_LR_DQUOTE] = ACTIONS(2757),
    [anon_sym_uR_DQUOTE] = ACTIONS(2757),
    [anon_sym_UR_DQUOTE] = ACTIONS(2757),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2757),
    [anon_sym_co_await] = ACTIONS(2755),
    [anon_sym_new] = ACTIONS(2755),
    [anon_sym_requires] = ACTIONS(2755),
    [sym_this] = ACTIONS(2755),
  },
  [538] = {
    [ts_builtin_sym_end] = ACTIONS(2681),
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [539] = {
    [sym_identifier] = ACTIONS(1957),
    [aux_sym_preproc_include_token1] = ACTIONS(1957),
    [aux_sym_preproc_def_token1] = ACTIONS(1957),
    [anon_sym_COMMA] = ACTIONS(2743),
    [aux_sym_preproc_if_token1] = ACTIONS(1957),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1957),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1957),
    [sym_preproc_directive] = ACTIONS(1957),
    [anon_sym_LPAREN2] = ACTIONS(1955),
    [anon_sym_BANG] = ACTIONS(1955),
    [anon_sym_TILDE] = ACTIONS(1955),
    [anon_sym_DASH] = ACTIONS(1957),
    [anon_sym_PLUS] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(1955),
    [anon_sym_AMP_AMP] = ACTIONS(1955),
    [anon_sym_AMP] = ACTIONS(1957),
    [anon_sym_SEMI] = ACTIONS(1955),
    [anon_sym___extension__] = ACTIONS(1957),
    [anon_sym_typedef] = ACTIONS(1957),
    [anon_sym_extern] = ACTIONS(1957),
    [anon_sym___attribute__] = ACTIONS(1957),
    [anon_sym_COLON_COLON] = ACTIONS(1955),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1955),
    [anon_sym___declspec] = ACTIONS(1957),
    [anon_sym___based] = ACTIONS(1957),
    [anon_sym___cdecl] = ACTIONS(1957),
    [anon_sym___clrcall] = ACTIONS(1957),
    [anon_sym___stdcall] = ACTIONS(1957),
    [anon_sym___fastcall] = ACTIONS(1957),
    [anon_sym___thiscall] = ACTIONS(1957),
    [anon_sym___vectorcall] = ACTIONS(1957),
    [anon_sym_LBRACE] = ACTIONS(1955),
    [anon_sym_RBRACE] = ACTIONS(2743),
    [anon_sym_signed] = ACTIONS(1957),
    [anon_sym_unsigned] = ACTIONS(1957),
    [anon_sym_long] = ACTIONS(1957),
    [anon_sym_short] = ACTIONS(1957),
    [anon_sym_LBRACK] = ACTIONS(1957),
    [anon_sym_static] = ACTIONS(1957),
    [anon_sym_register] = ACTIONS(1957),
    [anon_sym_inline] = ACTIONS(1957),
    [anon_sym___inline] = ACTIONS(1957),
    [anon_sym___inline__] = ACTIONS(1957),
    [anon_sym___forceinline] = ACTIONS(1957),
    [anon_sym_thread_local] = ACTIONS(1957),
    [anon_sym___thread] = ACTIONS(1957),
    [anon_sym_const] = ACTIONS(1957),
    [anon_sym_constexpr] = ACTIONS(1957),
    [anon_sym_volatile] = ACTIONS(1957),
    [anon_sym_restrict] = ACTIONS(1957),
    [anon_sym___restrict__] = ACTIONS(1957),
    [anon_sym__Atomic] = ACTIONS(1957),
    [anon_sym__Noreturn] = ACTIONS(1957),
    [anon_sym_noreturn] = ACTIONS(1957),
    [anon_sym_mutable] = ACTIONS(1957),
    [anon_sym_constinit] = ACTIONS(1957),
    [anon_sym_consteval] = ACTIONS(1957),
    [anon_sym_PROGMEM] = ACTIONS(1957),
    [aux_sym_primitive_type_token1] = ACTIONS(1957),
    [anon_sym_byte] = ACTIONS(1957),
    [anon_sym_word] = ACTIONS(1957),
    [anon_sym_enum] = ACTIONS(1957),
    [anon_sym_class] = ACTIONS(1957),
    [anon_sym_struct] = ACTIONS(1957),
    [anon_sym_union] = ACTIONS(1957),
    [anon_sym_if] = ACTIONS(1957),
    [anon_sym_switch] = ACTIONS(1957),
    [anon_sym_case] = ACTIONS(1957),
    [anon_sym_default] = ACTIONS(1957),
    [anon_sym_while] = ACTIONS(1957),
    [anon_sym_do] = ACTIONS(1957),
    [anon_sym_for] = ACTIONS(1957),
    [anon_sym_return] = ACTIONS(1957),
    [anon_sym_break] = ACTIONS(1957),
    [anon_sym_continue] = ACTIONS(1957),
    [anon_sym_goto] = ACTIONS(1957),
    [anon_sym___try] = ACTIONS(1957),
    [anon_sym___leave] = ACTIONS(1957),
    [anon_sym_not] = ACTIONS(1957),
    [anon_sym_compl] = ACTIONS(1957),
    [anon_sym_DASH_DASH] = ACTIONS(1955),
    [anon_sym_PLUS_PLUS] = ACTIONS(1955),
    [anon_sym_sizeof] = ACTIONS(1957),
    [anon_sym___alignof__] = ACTIONS(1957),
    [anon_sym___alignof] = ACTIONS(1957),
    [anon_sym__alignof] = ACTIONS(1957),
    [anon_sym_alignof] = ACTIONS(1957),
    [anon_sym__Alignof] = ACTIONS(1957),
    [anon_sym_offsetof] = ACTIONS(1957),
    [anon_sym__Generic] = ACTIONS(1957),
    [anon_sym_asm] = ACTIONS(1957),
    [anon_sym___asm__] = ACTIONS(1957),
    [aux_sym_number_literal_token1] = ACTIONS(1955),
    [aux_sym_number_literal_token2] = ACTIONS(1957),
    [anon_sym_L_SQUOTE] = ACTIONS(1955),
    [anon_sym_u_SQUOTE] = ACTIONS(1955),
    [anon_sym_U_SQUOTE] = ACTIONS(1955),
    [anon_sym_u8_SQUOTE] = ACTIONS(1955),
    [anon_sym_SQUOTE] = ACTIONS(1955),
    [anon_sym_L_DQUOTE] = ACTIONS(1955),
    [anon_sym_u_DQUOTE] = ACTIONS(1955),
    [anon_sym_U_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8_DQUOTE] = ACTIONS(1955),
    [anon_sym_DQUOTE] = ACTIONS(1955),
    [sym_true] = ACTIONS(1957),
    [sym_false] = ACTIONS(1957),
    [anon_sym_NULL] = ACTIONS(1957),
    [anon_sym_nullptr] = ACTIONS(1957),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1957),
    [anon_sym_decltype] = ACTIONS(1957),
    [anon_sym_virtual] = ACTIONS(1957),
    [anon_sym_alignas] = ACTIONS(1957),
    [anon_sym_explicit] = ACTIONS(1957),
    [anon_sym_typename] = ACTIONS(1957),
    [anon_sym_template] = ACTIONS(1957),
    [anon_sym_operator] = ACTIONS(1957),
    [anon_sym_try] = ACTIONS(1957),
    [anon_sym_delete] = ACTIONS(1957),
    [anon_sym_throw] = ACTIONS(1957),
    [anon_sym_namespace] = ACTIONS(1957),
    [anon_sym_using] = ACTIONS(1957),
    [anon_sym_static_assert] = ACTIONS(1957),
    [anon_sym_concept] = ACTIONS(1957),
    [anon_sym_co_return] = ACTIONS(1957),
    [anon_sym_co_yield] = ACTIONS(1957),
    [anon_sym_R_DQUOTE] = ACTIONS(1955),
    [anon_sym_LR_DQUOTE] = ACTIONS(1955),
    [anon_sym_uR_DQUOTE] = ACTIONS(1955),
    [anon_sym_UR_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1955),
    [anon_sym_co_await] = ACTIONS(1957),
    [anon_sym_new] = ACTIONS(1957),
    [anon_sym_requires] = ACTIONS(1957),
    [sym_this] = ACTIONS(1957),
  },
  [540] = {
    [ts_builtin_sym_end] = ACTIONS(2757),
    [sym_identifier] = ACTIONS(2755),
    [aux_sym_preproc_include_token1] = ACTIONS(2755),
    [aux_sym_preproc_def_token1] = ACTIONS(2755),
    [aux_sym_preproc_if_token1] = ACTIONS(2755),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2755),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2755),
    [sym_preproc_directive] = ACTIONS(2755),
    [anon_sym_LPAREN2] = ACTIONS(2757),
    [anon_sym_BANG] = ACTIONS(2757),
    [anon_sym_TILDE] = ACTIONS(2757),
    [anon_sym_DASH] = ACTIONS(2755),
    [anon_sym_PLUS] = ACTIONS(2755),
    [anon_sym_STAR] = ACTIONS(2757),
    [anon_sym_AMP_AMP] = ACTIONS(2757),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2757),
    [anon_sym___extension__] = ACTIONS(2755),
    [anon_sym_typedef] = ACTIONS(2755),
    [anon_sym_extern] = ACTIONS(2755),
    [anon_sym___attribute__] = ACTIONS(2755),
    [anon_sym_COLON_COLON] = ACTIONS(2757),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2757),
    [anon_sym___declspec] = ACTIONS(2755),
    [anon_sym___based] = ACTIONS(2755),
    [anon_sym___cdecl] = ACTIONS(2755),
    [anon_sym___clrcall] = ACTIONS(2755),
    [anon_sym___stdcall] = ACTIONS(2755),
    [anon_sym___fastcall] = ACTIONS(2755),
    [anon_sym___thiscall] = ACTIONS(2755),
    [anon_sym___vectorcall] = ACTIONS(2755),
    [anon_sym_LBRACE] = ACTIONS(2757),
    [anon_sym_signed] = ACTIONS(2755),
    [anon_sym_unsigned] = ACTIONS(2755),
    [anon_sym_long] = ACTIONS(2755),
    [anon_sym_short] = ACTIONS(2755),
    [anon_sym_LBRACK] = ACTIONS(2755),
    [anon_sym_static] = ACTIONS(2755),
    [anon_sym_register] = ACTIONS(2755),
    [anon_sym_inline] = ACTIONS(2755),
    [anon_sym___inline] = ACTIONS(2755),
    [anon_sym___inline__] = ACTIONS(2755),
    [anon_sym___forceinline] = ACTIONS(2755),
    [anon_sym_thread_local] = ACTIONS(2755),
    [anon_sym___thread] = ACTIONS(2755),
    [anon_sym_const] = ACTIONS(2755),
    [anon_sym_constexpr] = ACTIONS(2755),
    [anon_sym_volatile] = ACTIONS(2755),
    [anon_sym_restrict] = ACTIONS(2755),
    [anon_sym___restrict__] = ACTIONS(2755),
    [anon_sym__Atomic] = ACTIONS(2755),
    [anon_sym__Noreturn] = ACTIONS(2755),
    [anon_sym_noreturn] = ACTIONS(2755),
    [anon_sym_mutable] = ACTIONS(2755),
    [anon_sym_constinit] = ACTIONS(2755),
    [anon_sym_consteval] = ACTIONS(2755),
    [anon_sym_PROGMEM] = ACTIONS(2755),
    [aux_sym_primitive_type_token1] = ACTIONS(2755),
    [anon_sym_byte] = ACTIONS(2755),
    [anon_sym_word] = ACTIONS(2755),
    [anon_sym_enum] = ACTIONS(2755),
    [anon_sym_class] = ACTIONS(2755),
    [anon_sym_struct] = ACTIONS(2755),
    [anon_sym_union] = ACTIONS(2755),
    [anon_sym_if] = ACTIONS(2755),
    [anon_sym_else] = ACTIONS(2755),
    [anon_sym_switch] = ACTIONS(2755),
    [anon_sym_case] = ACTIONS(2755),
    [anon_sym_default] = ACTIONS(2755),
    [anon_sym_while] = ACTIONS(2755),
    [anon_sym_do] = ACTIONS(2755),
    [anon_sym_for] = ACTIONS(2755),
    [anon_sym_return] = ACTIONS(2755),
    [anon_sym_break] = ACTIONS(2755),
    [anon_sym_continue] = ACTIONS(2755),
    [anon_sym_goto] = ACTIONS(2755),
    [anon_sym___try] = ACTIONS(2755),
    [anon_sym___leave] = ACTIONS(2755),
    [anon_sym_not] = ACTIONS(2755),
    [anon_sym_compl] = ACTIONS(2755),
    [anon_sym_DASH_DASH] = ACTIONS(2757),
    [anon_sym_PLUS_PLUS] = ACTIONS(2757),
    [anon_sym_sizeof] = ACTIONS(2755),
    [anon_sym___alignof__] = ACTIONS(2755),
    [anon_sym___alignof] = ACTIONS(2755),
    [anon_sym__alignof] = ACTIONS(2755),
    [anon_sym_alignof] = ACTIONS(2755),
    [anon_sym__Alignof] = ACTIONS(2755),
    [anon_sym_offsetof] = ACTIONS(2755),
    [anon_sym__Generic] = ACTIONS(2755),
    [anon_sym_asm] = ACTIONS(2755),
    [anon_sym___asm__] = ACTIONS(2755),
    [aux_sym_number_literal_token1] = ACTIONS(2757),
    [aux_sym_number_literal_token2] = ACTIONS(2755),
    [anon_sym_L_SQUOTE] = ACTIONS(2757),
    [anon_sym_u_SQUOTE] = ACTIONS(2757),
    [anon_sym_U_SQUOTE] = ACTIONS(2757),
    [anon_sym_u8_SQUOTE] = ACTIONS(2757),
    [anon_sym_SQUOTE] = ACTIONS(2757),
    [anon_sym_L_DQUOTE] = ACTIONS(2757),
    [anon_sym_u_DQUOTE] = ACTIONS(2757),
    [anon_sym_U_DQUOTE] = ACTIONS(2757),
    [anon_sym_u8_DQUOTE] = ACTIONS(2757),
    [anon_sym_DQUOTE] = ACTIONS(2757),
    [sym_true] = ACTIONS(2755),
    [sym_false] = ACTIONS(2755),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2755),
    [anon_sym_decltype] = ACTIONS(2755),
    [anon_sym_virtual] = ACTIONS(2755),
    [anon_sym_alignas] = ACTIONS(2755),
    [anon_sym_explicit] = ACTIONS(2755),
    [anon_sym_typename] = ACTIONS(2755),
    [anon_sym_template] = ACTIONS(2755),
    [anon_sym_operator] = ACTIONS(2755),
    [anon_sym_try] = ACTIONS(2755),
    [anon_sym_delete] = ACTIONS(2755),
    [anon_sym_throw] = ACTIONS(2755),
    [anon_sym_namespace] = ACTIONS(2755),
    [anon_sym_using] = ACTIONS(2755),
    [anon_sym_static_assert] = ACTIONS(2755),
    [anon_sym_concept] = ACTIONS(2755),
    [anon_sym_co_return] = ACTIONS(2755),
    [anon_sym_co_yield] = ACTIONS(2755),
    [anon_sym_R_DQUOTE] = ACTIONS(2757),
    [anon_sym_LR_DQUOTE] = ACTIONS(2757),
    [anon_sym_uR_DQUOTE] = ACTIONS(2757),
    [anon_sym_UR_DQUOTE] = ACTIONS(2757),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2757),
    [anon_sym_co_await] = ACTIONS(2755),
    [anon_sym_new] = ACTIONS(2755),
    [anon_sym_requires] = ACTIONS(2755),
    [sym_this] = ACTIONS(2755),
  },
  [541] = {
    [sym_preproc_def] = STATE(541),
    [sym_preproc_function_def] = STATE(541),
    [sym_preproc_call] = STATE(541),
    [sym_preproc_if_in_field_declaration_list] = STATE(541),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(541),
    [sym_type_definition] = STATE(541),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(5531),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(3150),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(5962),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym__field_declaration_list_item] = STATE(541),
    [sym_field_declaration] = STATE(541),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1838),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(541),
    [sym_operator_cast] = STATE(6510),
    [sym_inline_method_definition] = STATE(541),
    [sym__constructor_specifiers] = STATE(1838),
    [sym_operator_cast_definition] = STATE(541),
    [sym_operator_cast_declaration] = STATE(541),
    [sym_constructor_or_destructor_definition] = STATE(541),
    [sym_constructor_or_destructor_declaration] = STATE(541),
    [sym_friend_declaration] = STATE(541),
    [sym_access_specifier] = STATE(7787),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(2618),
    [sym_template_function] = STATE(6098),
    [sym_using_declaration] = STATE(541),
    [sym_alias_declaration] = STATE(541),
    [sym_static_assert_declaration] = STATE(541),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5301),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_qualified_operator_cast_identifier] = STATE(6510),
    [sym_operator_name] = STATE(6098),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(541),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1961),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1838),
    [sym_identifier] = ACTIONS(3216),
    [aux_sym_preproc_def_token1] = ACTIONS(3219),
    [aux_sym_preproc_if_token1] = ACTIONS(3222),
    [aux_sym_preproc_if_token2] = ACTIONS(3225),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3227),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3227),
    [aux_sym_preproc_else_token1] = ACTIONS(3225),
    [aux_sym_preproc_elif_token1] = ACTIONS(3225),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3225),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3225),
    [sym_preproc_directive] = ACTIONS(3230),
    [anon_sym_LPAREN2] = ACTIONS(3233),
    [anon_sym_TILDE] = ACTIONS(3236),
    [anon_sym_STAR] = ACTIONS(3239),
    [anon_sym_AMP_AMP] = ACTIONS(3242),
    [anon_sym_AMP] = ACTIONS(3245),
    [anon_sym___extension__] = ACTIONS(3248),
    [anon_sym_typedef] = ACTIONS(3251),
    [anon_sym_extern] = ACTIONS(3254),
    [anon_sym___attribute__] = ACTIONS(3257),
    [anon_sym_COLON_COLON] = ACTIONS(3260),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3263),
    [anon_sym___declspec] = ACTIONS(3266),
    [anon_sym___based] = ACTIONS(3269),
    [anon_sym_signed] = ACTIONS(3272),
    [anon_sym_unsigned] = ACTIONS(3272),
    [anon_sym_long] = ACTIONS(3272),
    [anon_sym_short] = ACTIONS(3272),
    [anon_sym_LBRACK] = ACTIONS(3275),
    [anon_sym_static] = ACTIONS(3254),
    [anon_sym_register] = ACTIONS(3254),
    [anon_sym_inline] = ACTIONS(3254),
    [anon_sym___inline] = ACTIONS(3254),
    [anon_sym___inline__] = ACTIONS(3254),
    [anon_sym___forceinline] = ACTIONS(3254),
    [anon_sym_thread_local] = ACTIONS(3254),
    [anon_sym___thread] = ACTIONS(3254),
    [anon_sym_const] = ACTIONS(3278),
    [anon_sym_constexpr] = ACTIONS(3278),
    [anon_sym_volatile] = ACTIONS(3278),
    [anon_sym_restrict] = ACTIONS(3278),
    [anon_sym___restrict__] = ACTIONS(3278),
    [anon_sym__Atomic] = ACTIONS(3278),
    [anon_sym__Noreturn] = ACTIONS(3278),
    [anon_sym_noreturn] = ACTIONS(3278),
    [anon_sym_mutable] = ACTIONS(3278),
    [anon_sym_constinit] = ACTIONS(3278),
    [anon_sym_consteval] = ACTIONS(3278),
    [anon_sym_PROGMEM] = ACTIONS(3278),
    [aux_sym_primitive_type_token1] = ACTIONS(3281),
    [anon_sym_byte] = ACTIONS(3281),
    [anon_sym_word] = ACTIONS(3281),
    [anon_sym_enum] = ACTIONS(3284),
    [anon_sym_class] = ACTIONS(3287),
    [anon_sym_struct] = ACTIONS(3290),
    [anon_sym_union] = ACTIONS(3293),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3296),
    [anon_sym_decltype] = ACTIONS(3299),
    [anon_sym_virtual] = ACTIONS(3302),
    [anon_sym_alignas] = ACTIONS(3305),
    [anon_sym_explicit] = ACTIONS(3308),
    [anon_sym_typename] = ACTIONS(3311),
    [anon_sym_template] = ACTIONS(3314),
    [anon_sym_operator] = ACTIONS(3317),
    [anon_sym_friend] = ACTIONS(3320),
    [anon_sym_public] = ACTIONS(3323),
    [anon_sym_private] = ACTIONS(3323),
    [anon_sym_protected] = ACTIONS(3323),
    [anon_sym_using] = ACTIONS(3326),
    [anon_sym_static_assert] = ACTIONS(3329),
  },
  [542] = {
    [sym_identifier] = ACTIONS(2779),
    [aux_sym_preproc_include_token1] = ACTIONS(2779),
    [aux_sym_preproc_def_token1] = ACTIONS(2779),
    [aux_sym_preproc_if_token1] = ACTIONS(2779),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2779),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2779),
    [sym_preproc_directive] = ACTIONS(2779),
    [anon_sym_LPAREN2] = ACTIONS(2781),
    [anon_sym_BANG] = ACTIONS(2781),
    [anon_sym_TILDE] = ACTIONS(2781),
    [anon_sym_DASH] = ACTIONS(2779),
    [anon_sym_PLUS] = ACTIONS(2779),
    [anon_sym_STAR] = ACTIONS(2781),
    [anon_sym_AMP_AMP] = ACTIONS(2781),
    [anon_sym_AMP] = ACTIONS(2779),
    [anon_sym_SEMI] = ACTIONS(2781),
    [anon_sym___extension__] = ACTIONS(2779),
    [anon_sym_typedef] = ACTIONS(2779),
    [anon_sym_extern] = ACTIONS(2779),
    [anon_sym___attribute__] = ACTIONS(2779),
    [anon_sym_COLON_COLON] = ACTIONS(2781),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2781),
    [anon_sym___declspec] = ACTIONS(2779),
    [anon_sym___based] = ACTIONS(2779),
    [anon_sym___cdecl] = ACTIONS(2779),
    [anon_sym___clrcall] = ACTIONS(2779),
    [anon_sym___stdcall] = ACTIONS(2779),
    [anon_sym___fastcall] = ACTIONS(2779),
    [anon_sym___thiscall] = ACTIONS(2779),
    [anon_sym___vectorcall] = ACTIONS(2779),
    [anon_sym_LBRACE] = ACTIONS(2781),
    [anon_sym_RBRACE] = ACTIONS(2781),
    [anon_sym_signed] = ACTIONS(2779),
    [anon_sym_unsigned] = ACTIONS(2779),
    [anon_sym_long] = ACTIONS(2779),
    [anon_sym_short] = ACTIONS(2779),
    [anon_sym_LBRACK] = ACTIONS(2779),
    [anon_sym_static] = ACTIONS(2779),
    [anon_sym_register] = ACTIONS(2779),
    [anon_sym_inline] = ACTIONS(2779),
    [anon_sym___inline] = ACTIONS(2779),
    [anon_sym___inline__] = ACTIONS(2779),
    [anon_sym___forceinline] = ACTIONS(2779),
    [anon_sym_thread_local] = ACTIONS(2779),
    [anon_sym___thread] = ACTIONS(2779),
    [anon_sym_const] = ACTIONS(2779),
    [anon_sym_constexpr] = ACTIONS(2779),
    [anon_sym_volatile] = ACTIONS(2779),
    [anon_sym_restrict] = ACTIONS(2779),
    [anon_sym___restrict__] = ACTIONS(2779),
    [anon_sym__Atomic] = ACTIONS(2779),
    [anon_sym__Noreturn] = ACTIONS(2779),
    [anon_sym_noreturn] = ACTIONS(2779),
    [anon_sym_mutable] = ACTIONS(2779),
    [anon_sym_constinit] = ACTIONS(2779),
    [anon_sym_consteval] = ACTIONS(2779),
    [anon_sym_PROGMEM] = ACTIONS(2779),
    [aux_sym_primitive_type_token1] = ACTIONS(2779),
    [anon_sym_byte] = ACTIONS(2779),
    [anon_sym_word] = ACTIONS(2779),
    [anon_sym_enum] = ACTIONS(2779),
    [anon_sym_class] = ACTIONS(2779),
    [anon_sym_struct] = ACTIONS(2779),
    [anon_sym_union] = ACTIONS(2779),
    [anon_sym_if] = ACTIONS(2779),
    [anon_sym_else] = ACTIONS(2779),
    [anon_sym_switch] = ACTIONS(2779),
    [anon_sym_case] = ACTIONS(2779),
    [anon_sym_default] = ACTIONS(2779),
    [anon_sym_while] = ACTIONS(2779),
    [anon_sym_do] = ACTIONS(2779),
    [anon_sym_for] = ACTIONS(2779),
    [anon_sym_return] = ACTIONS(2779),
    [anon_sym_break] = ACTIONS(2779),
    [anon_sym_continue] = ACTIONS(2779),
    [anon_sym_goto] = ACTIONS(2779),
    [anon_sym___try] = ACTIONS(2779),
    [anon_sym___leave] = ACTIONS(2779),
    [anon_sym_not] = ACTIONS(2779),
    [anon_sym_compl] = ACTIONS(2779),
    [anon_sym_DASH_DASH] = ACTIONS(2781),
    [anon_sym_PLUS_PLUS] = ACTIONS(2781),
    [anon_sym_sizeof] = ACTIONS(2779),
    [anon_sym___alignof__] = ACTIONS(2779),
    [anon_sym___alignof] = ACTIONS(2779),
    [anon_sym__alignof] = ACTIONS(2779),
    [anon_sym_alignof] = ACTIONS(2779),
    [anon_sym__Alignof] = ACTIONS(2779),
    [anon_sym_offsetof] = ACTIONS(2779),
    [anon_sym__Generic] = ACTIONS(2779),
    [anon_sym_asm] = ACTIONS(2779),
    [anon_sym___asm__] = ACTIONS(2779),
    [aux_sym_number_literal_token1] = ACTIONS(2781),
    [aux_sym_number_literal_token2] = ACTIONS(2779),
    [anon_sym_L_SQUOTE] = ACTIONS(2781),
    [anon_sym_u_SQUOTE] = ACTIONS(2781),
    [anon_sym_U_SQUOTE] = ACTIONS(2781),
    [anon_sym_u8_SQUOTE] = ACTIONS(2781),
    [anon_sym_SQUOTE] = ACTIONS(2781),
    [anon_sym_L_DQUOTE] = ACTIONS(2781),
    [anon_sym_u_DQUOTE] = ACTIONS(2781),
    [anon_sym_U_DQUOTE] = ACTIONS(2781),
    [anon_sym_u8_DQUOTE] = ACTIONS(2781),
    [anon_sym_DQUOTE] = ACTIONS(2781),
    [sym_true] = ACTIONS(2779),
    [sym_false] = ACTIONS(2779),
    [anon_sym_NULL] = ACTIONS(2779),
    [anon_sym_nullptr] = ACTIONS(2779),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2779),
    [anon_sym_decltype] = ACTIONS(2779),
    [anon_sym_virtual] = ACTIONS(2779),
    [anon_sym_alignas] = ACTIONS(2779),
    [anon_sym_explicit] = ACTIONS(2779),
    [anon_sym_typename] = ACTIONS(2779),
    [anon_sym_template] = ACTIONS(2779),
    [anon_sym_operator] = ACTIONS(2779),
    [anon_sym_try] = ACTIONS(2779),
    [anon_sym_delete] = ACTIONS(2779),
    [anon_sym_throw] = ACTIONS(2779),
    [anon_sym_namespace] = ACTIONS(2779),
    [anon_sym_using] = ACTIONS(2779),
    [anon_sym_static_assert] = ACTIONS(2779),
    [anon_sym_concept] = ACTIONS(2779),
    [anon_sym_co_return] = ACTIONS(2779),
    [anon_sym_co_yield] = ACTIONS(2779),
    [anon_sym_R_DQUOTE] = ACTIONS(2781),
    [anon_sym_LR_DQUOTE] = ACTIONS(2781),
    [anon_sym_uR_DQUOTE] = ACTIONS(2781),
    [anon_sym_UR_DQUOTE] = ACTIONS(2781),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2781),
    [anon_sym_co_await] = ACTIONS(2779),
    [anon_sym_new] = ACTIONS(2779),
    [anon_sym_requires] = ACTIONS(2779),
    [sym_this] = ACTIONS(2779),
  },
  [543] = {
    [sym_identifier] = ACTIONS(2769),
    [aux_sym_preproc_include_token1] = ACTIONS(2769),
    [aux_sym_preproc_def_token1] = ACTIONS(2769),
    [aux_sym_preproc_if_token1] = ACTIONS(2769),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2769),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2769),
    [sym_preproc_directive] = ACTIONS(2769),
    [anon_sym_LPAREN2] = ACTIONS(2771),
    [anon_sym_BANG] = ACTIONS(2771),
    [anon_sym_TILDE] = ACTIONS(2771),
    [anon_sym_DASH] = ACTIONS(2769),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_STAR] = ACTIONS(2771),
    [anon_sym_AMP_AMP] = ACTIONS(2771),
    [anon_sym_AMP] = ACTIONS(2769),
    [anon_sym_SEMI] = ACTIONS(2771),
    [anon_sym___extension__] = ACTIONS(2769),
    [anon_sym_typedef] = ACTIONS(2769),
    [anon_sym_extern] = ACTIONS(2769),
    [anon_sym___attribute__] = ACTIONS(2769),
    [anon_sym_COLON_COLON] = ACTIONS(2771),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2771),
    [anon_sym___declspec] = ACTIONS(2769),
    [anon_sym___based] = ACTIONS(2769),
    [anon_sym___cdecl] = ACTIONS(2769),
    [anon_sym___clrcall] = ACTIONS(2769),
    [anon_sym___stdcall] = ACTIONS(2769),
    [anon_sym___fastcall] = ACTIONS(2769),
    [anon_sym___thiscall] = ACTIONS(2769),
    [anon_sym___vectorcall] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(2771),
    [anon_sym_RBRACE] = ACTIONS(2771),
    [anon_sym_signed] = ACTIONS(2769),
    [anon_sym_unsigned] = ACTIONS(2769),
    [anon_sym_long] = ACTIONS(2769),
    [anon_sym_short] = ACTIONS(2769),
    [anon_sym_LBRACK] = ACTIONS(2769),
    [anon_sym_static] = ACTIONS(2769),
    [anon_sym_register] = ACTIONS(2769),
    [anon_sym_inline] = ACTIONS(2769),
    [anon_sym___inline] = ACTIONS(2769),
    [anon_sym___inline__] = ACTIONS(2769),
    [anon_sym___forceinline] = ACTIONS(2769),
    [anon_sym_thread_local] = ACTIONS(2769),
    [anon_sym___thread] = ACTIONS(2769),
    [anon_sym_const] = ACTIONS(2769),
    [anon_sym_constexpr] = ACTIONS(2769),
    [anon_sym_volatile] = ACTIONS(2769),
    [anon_sym_restrict] = ACTIONS(2769),
    [anon_sym___restrict__] = ACTIONS(2769),
    [anon_sym__Atomic] = ACTIONS(2769),
    [anon_sym__Noreturn] = ACTIONS(2769),
    [anon_sym_noreturn] = ACTIONS(2769),
    [anon_sym_mutable] = ACTIONS(2769),
    [anon_sym_constinit] = ACTIONS(2769),
    [anon_sym_consteval] = ACTIONS(2769),
    [anon_sym_PROGMEM] = ACTIONS(2769),
    [aux_sym_primitive_type_token1] = ACTIONS(2769),
    [anon_sym_byte] = ACTIONS(2769),
    [anon_sym_word] = ACTIONS(2769),
    [anon_sym_enum] = ACTIONS(2769),
    [anon_sym_class] = ACTIONS(2769),
    [anon_sym_struct] = ACTIONS(2769),
    [anon_sym_union] = ACTIONS(2769),
    [anon_sym_if] = ACTIONS(2769),
    [anon_sym_else] = ACTIONS(2769),
    [anon_sym_switch] = ACTIONS(2769),
    [anon_sym_case] = ACTIONS(2769),
    [anon_sym_default] = ACTIONS(2769),
    [anon_sym_while] = ACTIONS(2769),
    [anon_sym_do] = ACTIONS(2769),
    [anon_sym_for] = ACTIONS(2769),
    [anon_sym_return] = ACTIONS(2769),
    [anon_sym_break] = ACTIONS(2769),
    [anon_sym_continue] = ACTIONS(2769),
    [anon_sym_goto] = ACTIONS(2769),
    [anon_sym___try] = ACTIONS(2769),
    [anon_sym___leave] = ACTIONS(2769),
    [anon_sym_not] = ACTIONS(2769),
    [anon_sym_compl] = ACTIONS(2769),
    [anon_sym_DASH_DASH] = ACTIONS(2771),
    [anon_sym_PLUS_PLUS] = ACTIONS(2771),
    [anon_sym_sizeof] = ACTIONS(2769),
    [anon_sym___alignof__] = ACTIONS(2769),
    [anon_sym___alignof] = ACTIONS(2769),
    [anon_sym__alignof] = ACTIONS(2769),
    [anon_sym_alignof] = ACTIONS(2769),
    [anon_sym__Alignof] = ACTIONS(2769),
    [anon_sym_offsetof] = ACTIONS(2769),
    [anon_sym__Generic] = ACTIONS(2769),
    [anon_sym_asm] = ACTIONS(2769),
    [anon_sym___asm__] = ACTIONS(2769),
    [aux_sym_number_literal_token1] = ACTIONS(2771),
    [aux_sym_number_literal_token2] = ACTIONS(2769),
    [anon_sym_L_SQUOTE] = ACTIONS(2771),
    [anon_sym_u_SQUOTE] = ACTIONS(2771),
    [anon_sym_U_SQUOTE] = ACTIONS(2771),
    [anon_sym_u8_SQUOTE] = ACTIONS(2771),
    [anon_sym_SQUOTE] = ACTIONS(2771),
    [anon_sym_L_DQUOTE] = ACTIONS(2771),
    [anon_sym_u_DQUOTE] = ACTIONS(2771),
    [anon_sym_U_DQUOTE] = ACTIONS(2771),
    [anon_sym_u8_DQUOTE] = ACTIONS(2771),
    [anon_sym_DQUOTE] = ACTIONS(2771),
    [sym_true] = ACTIONS(2769),
    [sym_false] = ACTIONS(2769),
    [anon_sym_NULL] = ACTIONS(2769),
    [anon_sym_nullptr] = ACTIONS(2769),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2769),
    [anon_sym_decltype] = ACTIONS(2769),
    [anon_sym_virtual] = ACTIONS(2769),
    [anon_sym_alignas] = ACTIONS(2769),
    [anon_sym_explicit] = ACTIONS(2769),
    [anon_sym_typename] = ACTIONS(2769),
    [anon_sym_template] = ACTIONS(2769),
    [anon_sym_operator] = ACTIONS(2769),
    [anon_sym_try] = ACTIONS(2769),
    [anon_sym_delete] = ACTIONS(2769),
    [anon_sym_throw] = ACTIONS(2769),
    [anon_sym_namespace] = ACTIONS(2769),
    [anon_sym_using] = ACTIONS(2769),
    [anon_sym_static_assert] = ACTIONS(2769),
    [anon_sym_concept] = ACTIONS(2769),
    [anon_sym_co_return] = ACTIONS(2769),
    [anon_sym_co_yield] = ACTIONS(2769),
    [anon_sym_R_DQUOTE] = ACTIONS(2771),
    [anon_sym_LR_DQUOTE] = ACTIONS(2771),
    [anon_sym_uR_DQUOTE] = ACTIONS(2771),
    [anon_sym_UR_DQUOTE] = ACTIONS(2771),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2771),
    [anon_sym_co_await] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2769),
    [anon_sym_requires] = ACTIONS(2769),
    [sym_this] = ACTIONS(2769),
  },
  [544] = {
    [ts_builtin_sym_end] = ACTIONS(2645),
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [545] = {
    [sym_identifier] = ACTIONS(2779),
    [aux_sym_preproc_include_token1] = ACTIONS(2779),
    [aux_sym_preproc_def_token1] = ACTIONS(2779),
    [aux_sym_preproc_if_token1] = ACTIONS(2779),
    [aux_sym_preproc_if_token2] = ACTIONS(2779),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2779),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2779),
    [sym_preproc_directive] = ACTIONS(2779),
    [anon_sym_LPAREN2] = ACTIONS(2781),
    [anon_sym_BANG] = ACTIONS(2781),
    [anon_sym_TILDE] = ACTIONS(2781),
    [anon_sym_DASH] = ACTIONS(2779),
    [anon_sym_PLUS] = ACTIONS(2779),
    [anon_sym_STAR] = ACTIONS(2781),
    [anon_sym_AMP_AMP] = ACTIONS(2781),
    [anon_sym_AMP] = ACTIONS(2779),
    [anon_sym_SEMI] = ACTIONS(2781),
    [anon_sym___extension__] = ACTIONS(2779),
    [anon_sym_typedef] = ACTIONS(2779),
    [anon_sym_extern] = ACTIONS(2779),
    [anon_sym___attribute__] = ACTIONS(2779),
    [anon_sym_COLON_COLON] = ACTIONS(2781),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2781),
    [anon_sym___declspec] = ACTIONS(2779),
    [anon_sym___based] = ACTIONS(2779),
    [anon_sym___cdecl] = ACTIONS(2779),
    [anon_sym___clrcall] = ACTIONS(2779),
    [anon_sym___stdcall] = ACTIONS(2779),
    [anon_sym___fastcall] = ACTIONS(2779),
    [anon_sym___thiscall] = ACTIONS(2779),
    [anon_sym___vectorcall] = ACTIONS(2779),
    [anon_sym_LBRACE] = ACTIONS(2781),
    [anon_sym_signed] = ACTIONS(2779),
    [anon_sym_unsigned] = ACTIONS(2779),
    [anon_sym_long] = ACTIONS(2779),
    [anon_sym_short] = ACTIONS(2779),
    [anon_sym_LBRACK] = ACTIONS(2779),
    [anon_sym_static] = ACTIONS(2779),
    [anon_sym_register] = ACTIONS(2779),
    [anon_sym_inline] = ACTIONS(2779),
    [anon_sym___inline] = ACTIONS(2779),
    [anon_sym___inline__] = ACTIONS(2779),
    [anon_sym___forceinline] = ACTIONS(2779),
    [anon_sym_thread_local] = ACTIONS(2779),
    [anon_sym___thread] = ACTIONS(2779),
    [anon_sym_const] = ACTIONS(2779),
    [anon_sym_constexpr] = ACTIONS(2779),
    [anon_sym_volatile] = ACTIONS(2779),
    [anon_sym_restrict] = ACTIONS(2779),
    [anon_sym___restrict__] = ACTIONS(2779),
    [anon_sym__Atomic] = ACTIONS(2779),
    [anon_sym__Noreturn] = ACTIONS(2779),
    [anon_sym_noreturn] = ACTIONS(2779),
    [anon_sym_mutable] = ACTIONS(2779),
    [anon_sym_constinit] = ACTIONS(2779),
    [anon_sym_consteval] = ACTIONS(2779),
    [anon_sym_PROGMEM] = ACTIONS(2779),
    [aux_sym_primitive_type_token1] = ACTIONS(2779),
    [anon_sym_byte] = ACTIONS(2779),
    [anon_sym_word] = ACTIONS(2779),
    [anon_sym_enum] = ACTIONS(2779),
    [anon_sym_class] = ACTIONS(2779),
    [anon_sym_struct] = ACTIONS(2779),
    [anon_sym_union] = ACTIONS(2779),
    [anon_sym_if] = ACTIONS(2779),
    [anon_sym_else] = ACTIONS(2779),
    [anon_sym_switch] = ACTIONS(2779),
    [anon_sym_case] = ACTIONS(2779),
    [anon_sym_default] = ACTIONS(2779),
    [anon_sym_while] = ACTIONS(2779),
    [anon_sym_do] = ACTIONS(2779),
    [anon_sym_for] = ACTIONS(2779),
    [anon_sym_return] = ACTIONS(2779),
    [anon_sym_break] = ACTIONS(2779),
    [anon_sym_continue] = ACTIONS(2779),
    [anon_sym_goto] = ACTIONS(2779),
    [anon_sym___try] = ACTIONS(2779),
    [anon_sym___leave] = ACTIONS(2779),
    [anon_sym_not] = ACTIONS(2779),
    [anon_sym_compl] = ACTIONS(2779),
    [anon_sym_DASH_DASH] = ACTIONS(2781),
    [anon_sym_PLUS_PLUS] = ACTIONS(2781),
    [anon_sym_sizeof] = ACTIONS(2779),
    [anon_sym___alignof__] = ACTIONS(2779),
    [anon_sym___alignof] = ACTIONS(2779),
    [anon_sym__alignof] = ACTIONS(2779),
    [anon_sym_alignof] = ACTIONS(2779),
    [anon_sym__Alignof] = ACTIONS(2779),
    [anon_sym_offsetof] = ACTIONS(2779),
    [anon_sym__Generic] = ACTIONS(2779),
    [anon_sym_asm] = ACTIONS(2779),
    [anon_sym___asm__] = ACTIONS(2779),
    [aux_sym_number_literal_token1] = ACTIONS(2781),
    [aux_sym_number_literal_token2] = ACTIONS(2779),
    [anon_sym_L_SQUOTE] = ACTIONS(2781),
    [anon_sym_u_SQUOTE] = ACTIONS(2781),
    [anon_sym_U_SQUOTE] = ACTIONS(2781),
    [anon_sym_u8_SQUOTE] = ACTIONS(2781),
    [anon_sym_SQUOTE] = ACTIONS(2781),
    [anon_sym_L_DQUOTE] = ACTIONS(2781),
    [anon_sym_u_DQUOTE] = ACTIONS(2781),
    [anon_sym_U_DQUOTE] = ACTIONS(2781),
    [anon_sym_u8_DQUOTE] = ACTIONS(2781),
    [anon_sym_DQUOTE] = ACTIONS(2781),
    [sym_true] = ACTIONS(2779),
    [sym_false] = ACTIONS(2779),
    [anon_sym_NULL] = ACTIONS(2779),
    [anon_sym_nullptr] = ACTIONS(2779),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2779),
    [anon_sym_decltype] = ACTIONS(2779),
    [anon_sym_virtual] = ACTIONS(2779),
    [anon_sym_alignas] = ACTIONS(2779),
    [anon_sym_explicit] = ACTIONS(2779),
    [anon_sym_typename] = ACTIONS(2779),
    [anon_sym_template] = ACTIONS(2779),
    [anon_sym_operator] = ACTIONS(2779),
    [anon_sym_try] = ACTIONS(2779),
    [anon_sym_delete] = ACTIONS(2779),
    [anon_sym_throw] = ACTIONS(2779),
    [anon_sym_namespace] = ACTIONS(2779),
    [anon_sym_using] = ACTIONS(2779),
    [anon_sym_static_assert] = ACTIONS(2779),
    [anon_sym_concept] = ACTIONS(2779),
    [anon_sym_co_return] = ACTIONS(2779),
    [anon_sym_co_yield] = ACTIONS(2779),
    [anon_sym_R_DQUOTE] = ACTIONS(2781),
    [anon_sym_LR_DQUOTE] = ACTIONS(2781),
    [anon_sym_uR_DQUOTE] = ACTIONS(2781),
    [anon_sym_UR_DQUOTE] = ACTIONS(2781),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2781),
    [anon_sym_co_await] = ACTIONS(2779),
    [anon_sym_new] = ACTIONS(2779),
    [anon_sym_requires] = ACTIONS(2779),
    [sym_this] = ACTIONS(2779),
  },
  [546] = {
    [sym_identifier] = ACTIONS(2797),
    [aux_sym_preproc_include_token1] = ACTIONS(2797),
    [aux_sym_preproc_def_token1] = ACTIONS(2797),
    [aux_sym_preproc_if_token1] = ACTIONS(2797),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2797),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2797),
    [sym_preproc_directive] = ACTIONS(2797),
    [anon_sym_LPAREN2] = ACTIONS(2799),
    [anon_sym_BANG] = ACTIONS(2799),
    [anon_sym_TILDE] = ACTIONS(2799),
    [anon_sym_DASH] = ACTIONS(2797),
    [anon_sym_PLUS] = ACTIONS(2797),
    [anon_sym_STAR] = ACTIONS(2799),
    [anon_sym_AMP_AMP] = ACTIONS(2799),
    [anon_sym_AMP] = ACTIONS(2797),
    [anon_sym_SEMI] = ACTIONS(2799),
    [anon_sym___extension__] = ACTIONS(2797),
    [anon_sym_typedef] = ACTIONS(2797),
    [anon_sym_extern] = ACTIONS(2797),
    [anon_sym___attribute__] = ACTIONS(2797),
    [anon_sym_COLON_COLON] = ACTIONS(2799),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2799),
    [anon_sym___declspec] = ACTIONS(2797),
    [anon_sym___based] = ACTIONS(2797),
    [anon_sym___cdecl] = ACTIONS(2797),
    [anon_sym___clrcall] = ACTIONS(2797),
    [anon_sym___stdcall] = ACTIONS(2797),
    [anon_sym___fastcall] = ACTIONS(2797),
    [anon_sym___thiscall] = ACTIONS(2797),
    [anon_sym___vectorcall] = ACTIONS(2797),
    [anon_sym_LBRACE] = ACTIONS(2799),
    [anon_sym_RBRACE] = ACTIONS(2799),
    [anon_sym_signed] = ACTIONS(2797),
    [anon_sym_unsigned] = ACTIONS(2797),
    [anon_sym_long] = ACTIONS(2797),
    [anon_sym_short] = ACTIONS(2797),
    [anon_sym_LBRACK] = ACTIONS(2797),
    [anon_sym_static] = ACTIONS(2797),
    [anon_sym_register] = ACTIONS(2797),
    [anon_sym_inline] = ACTIONS(2797),
    [anon_sym___inline] = ACTIONS(2797),
    [anon_sym___inline__] = ACTIONS(2797),
    [anon_sym___forceinline] = ACTIONS(2797),
    [anon_sym_thread_local] = ACTIONS(2797),
    [anon_sym___thread] = ACTIONS(2797),
    [anon_sym_const] = ACTIONS(2797),
    [anon_sym_constexpr] = ACTIONS(2797),
    [anon_sym_volatile] = ACTIONS(2797),
    [anon_sym_restrict] = ACTIONS(2797),
    [anon_sym___restrict__] = ACTIONS(2797),
    [anon_sym__Atomic] = ACTIONS(2797),
    [anon_sym__Noreturn] = ACTIONS(2797),
    [anon_sym_noreturn] = ACTIONS(2797),
    [anon_sym_mutable] = ACTIONS(2797),
    [anon_sym_constinit] = ACTIONS(2797),
    [anon_sym_consteval] = ACTIONS(2797),
    [anon_sym_PROGMEM] = ACTIONS(2797),
    [aux_sym_primitive_type_token1] = ACTIONS(2797),
    [anon_sym_byte] = ACTIONS(2797),
    [anon_sym_word] = ACTIONS(2797),
    [anon_sym_enum] = ACTIONS(2797),
    [anon_sym_class] = ACTIONS(2797),
    [anon_sym_struct] = ACTIONS(2797),
    [anon_sym_union] = ACTIONS(2797),
    [anon_sym_if] = ACTIONS(2797),
    [anon_sym_else] = ACTIONS(2797),
    [anon_sym_switch] = ACTIONS(2797),
    [anon_sym_case] = ACTIONS(2797),
    [anon_sym_default] = ACTIONS(2797),
    [anon_sym_while] = ACTIONS(2797),
    [anon_sym_do] = ACTIONS(2797),
    [anon_sym_for] = ACTIONS(2797),
    [anon_sym_return] = ACTIONS(2797),
    [anon_sym_break] = ACTIONS(2797),
    [anon_sym_continue] = ACTIONS(2797),
    [anon_sym_goto] = ACTIONS(2797),
    [anon_sym___try] = ACTIONS(2797),
    [anon_sym___leave] = ACTIONS(2797),
    [anon_sym_not] = ACTIONS(2797),
    [anon_sym_compl] = ACTIONS(2797),
    [anon_sym_DASH_DASH] = ACTIONS(2799),
    [anon_sym_PLUS_PLUS] = ACTIONS(2799),
    [anon_sym_sizeof] = ACTIONS(2797),
    [anon_sym___alignof__] = ACTIONS(2797),
    [anon_sym___alignof] = ACTIONS(2797),
    [anon_sym__alignof] = ACTIONS(2797),
    [anon_sym_alignof] = ACTIONS(2797),
    [anon_sym__Alignof] = ACTIONS(2797),
    [anon_sym_offsetof] = ACTIONS(2797),
    [anon_sym__Generic] = ACTIONS(2797),
    [anon_sym_asm] = ACTIONS(2797),
    [anon_sym___asm__] = ACTIONS(2797),
    [aux_sym_number_literal_token1] = ACTIONS(2799),
    [aux_sym_number_literal_token2] = ACTIONS(2797),
    [anon_sym_L_SQUOTE] = ACTIONS(2799),
    [anon_sym_u_SQUOTE] = ACTIONS(2799),
    [anon_sym_U_SQUOTE] = ACTIONS(2799),
    [anon_sym_u8_SQUOTE] = ACTIONS(2799),
    [anon_sym_SQUOTE] = ACTIONS(2799),
    [anon_sym_L_DQUOTE] = ACTIONS(2799),
    [anon_sym_u_DQUOTE] = ACTIONS(2799),
    [anon_sym_U_DQUOTE] = ACTIONS(2799),
    [anon_sym_u8_DQUOTE] = ACTIONS(2799),
    [anon_sym_DQUOTE] = ACTIONS(2799),
    [sym_true] = ACTIONS(2797),
    [sym_false] = ACTIONS(2797),
    [anon_sym_NULL] = ACTIONS(2797),
    [anon_sym_nullptr] = ACTIONS(2797),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2797),
    [anon_sym_decltype] = ACTIONS(2797),
    [anon_sym_virtual] = ACTIONS(2797),
    [anon_sym_alignas] = ACTIONS(2797),
    [anon_sym_explicit] = ACTIONS(2797),
    [anon_sym_typename] = ACTIONS(2797),
    [anon_sym_template] = ACTIONS(2797),
    [anon_sym_operator] = ACTIONS(2797),
    [anon_sym_try] = ACTIONS(2797),
    [anon_sym_delete] = ACTIONS(2797),
    [anon_sym_throw] = ACTIONS(2797),
    [anon_sym_namespace] = ACTIONS(2797),
    [anon_sym_using] = ACTIONS(2797),
    [anon_sym_static_assert] = ACTIONS(2797),
    [anon_sym_concept] = ACTIONS(2797),
    [anon_sym_co_return] = ACTIONS(2797),
    [anon_sym_co_yield] = ACTIONS(2797),
    [anon_sym_R_DQUOTE] = ACTIONS(2799),
    [anon_sym_LR_DQUOTE] = ACTIONS(2799),
    [anon_sym_uR_DQUOTE] = ACTIONS(2799),
    [anon_sym_UR_DQUOTE] = ACTIONS(2799),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2799),
    [anon_sym_co_await] = ACTIONS(2797),
    [anon_sym_new] = ACTIONS(2797),
    [anon_sym_requires] = ACTIONS(2797),
    [sym_this] = ACTIONS(2797),
  },
  [547] = {
    [sym_identifier] = ACTIONS(2639),
    [aux_sym_preproc_include_token1] = ACTIONS(2639),
    [aux_sym_preproc_def_token1] = ACTIONS(2639),
    [aux_sym_preproc_if_token1] = ACTIONS(2639),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2639),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2639),
    [sym_preproc_directive] = ACTIONS(2639),
    [anon_sym_LPAREN2] = ACTIONS(2641),
    [anon_sym_BANG] = ACTIONS(2641),
    [anon_sym_TILDE] = ACTIONS(2641),
    [anon_sym_DASH] = ACTIONS(2639),
    [anon_sym_PLUS] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(2641),
    [anon_sym_AMP_AMP] = ACTIONS(2641),
    [anon_sym_AMP] = ACTIONS(2639),
    [anon_sym_SEMI] = ACTIONS(2641),
    [anon_sym___extension__] = ACTIONS(2639),
    [anon_sym_typedef] = ACTIONS(2639),
    [anon_sym_extern] = ACTIONS(2639),
    [anon_sym___attribute__] = ACTIONS(2639),
    [anon_sym_COLON_COLON] = ACTIONS(2641),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2641),
    [anon_sym___declspec] = ACTIONS(2639),
    [anon_sym___based] = ACTIONS(2639),
    [anon_sym___cdecl] = ACTIONS(2639),
    [anon_sym___clrcall] = ACTIONS(2639),
    [anon_sym___stdcall] = ACTIONS(2639),
    [anon_sym___fastcall] = ACTIONS(2639),
    [anon_sym___thiscall] = ACTIONS(2639),
    [anon_sym___vectorcall] = ACTIONS(2639),
    [anon_sym_LBRACE] = ACTIONS(2641),
    [anon_sym_RBRACE] = ACTIONS(2641),
    [anon_sym_signed] = ACTIONS(2639),
    [anon_sym_unsigned] = ACTIONS(2639),
    [anon_sym_long] = ACTIONS(2639),
    [anon_sym_short] = ACTIONS(2639),
    [anon_sym_LBRACK] = ACTIONS(2639),
    [anon_sym_static] = ACTIONS(2639),
    [anon_sym_register] = ACTIONS(2639),
    [anon_sym_inline] = ACTIONS(2639),
    [anon_sym___inline] = ACTIONS(2639),
    [anon_sym___inline__] = ACTIONS(2639),
    [anon_sym___forceinline] = ACTIONS(2639),
    [anon_sym_thread_local] = ACTIONS(2639),
    [anon_sym___thread] = ACTIONS(2639),
    [anon_sym_const] = ACTIONS(2639),
    [anon_sym_constexpr] = ACTIONS(2639),
    [anon_sym_volatile] = ACTIONS(2639),
    [anon_sym_restrict] = ACTIONS(2639),
    [anon_sym___restrict__] = ACTIONS(2639),
    [anon_sym__Atomic] = ACTIONS(2639),
    [anon_sym__Noreturn] = ACTIONS(2639),
    [anon_sym_noreturn] = ACTIONS(2639),
    [anon_sym_mutable] = ACTIONS(2639),
    [anon_sym_constinit] = ACTIONS(2639),
    [anon_sym_consteval] = ACTIONS(2639),
    [anon_sym_PROGMEM] = ACTIONS(2639),
    [aux_sym_primitive_type_token1] = ACTIONS(2639),
    [anon_sym_byte] = ACTIONS(2639),
    [anon_sym_word] = ACTIONS(2639),
    [anon_sym_enum] = ACTIONS(2639),
    [anon_sym_class] = ACTIONS(2639),
    [anon_sym_struct] = ACTIONS(2639),
    [anon_sym_union] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2639),
    [anon_sym_else] = ACTIONS(2639),
    [anon_sym_switch] = ACTIONS(2639),
    [anon_sym_case] = ACTIONS(2639),
    [anon_sym_default] = ACTIONS(2639),
    [anon_sym_while] = ACTIONS(2639),
    [anon_sym_do] = ACTIONS(2639),
    [anon_sym_for] = ACTIONS(2639),
    [anon_sym_return] = ACTIONS(2639),
    [anon_sym_break] = ACTIONS(2639),
    [anon_sym_continue] = ACTIONS(2639),
    [anon_sym_goto] = ACTIONS(2639),
    [anon_sym___try] = ACTIONS(2639),
    [anon_sym___leave] = ACTIONS(2639),
    [anon_sym_not] = ACTIONS(2639),
    [anon_sym_compl] = ACTIONS(2639),
    [anon_sym_DASH_DASH] = ACTIONS(2641),
    [anon_sym_PLUS_PLUS] = ACTIONS(2641),
    [anon_sym_sizeof] = ACTIONS(2639),
    [anon_sym___alignof__] = ACTIONS(2639),
    [anon_sym___alignof] = ACTIONS(2639),
    [anon_sym__alignof] = ACTIONS(2639),
    [anon_sym_alignof] = ACTIONS(2639),
    [anon_sym__Alignof] = ACTIONS(2639),
    [anon_sym_offsetof] = ACTIONS(2639),
    [anon_sym__Generic] = ACTIONS(2639),
    [anon_sym_asm] = ACTIONS(2639),
    [anon_sym___asm__] = ACTIONS(2639),
    [aux_sym_number_literal_token1] = ACTIONS(2641),
    [aux_sym_number_literal_token2] = ACTIONS(2639),
    [anon_sym_L_SQUOTE] = ACTIONS(2641),
    [anon_sym_u_SQUOTE] = ACTIONS(2641),
    [anon_sym_U_SQUOTE] = ACTIONS(2641),
    [anon_sym_u8_SQUOTE] = ACTIONS(2641),
    [anon_sym_SQUOTE] = ACTIONS(2641),
    [anon_sym_L_DQUOTE] = ACTIONS(2641),
    [anon_sym_u_DQUOTE] = ACTIONS(2641),
    [anon_sym_U_DQUOTE] = ACTIONS(2641),
    [anon_sym_u8_DQUOTE] = ACTIONS(2641),
    [anon_sym_DQUOTE] = ACTIONS(2641),
    [sym_true] = ACTIONS(2639),
    [sym_false] = ACTIONS(2639),
    [anon_sym_NULL] = ACTIONS(2639),
    [anon_sym_nullptr] = ACTIONS(2639),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2639),
    [anon_sym_decltype] = ACTIONS(2639),
    [anon_sym_virtual] = ACTIONS(2639),
    [anon_sym_alignas] = ACTIONS(2639),
    [anon_sym_explicit] = ACTIONS(2639),
    [anon_sym_typename] = ACTIONS(2639),
    [anon_sym_template] = ACTIONS(2639),
    [anon_sym_operator] = ACTIONS(2639),
    [anon_sym_try] = ACTIONS(2639),
    [anon_sym_delete] = ACTIONS(2639),
    [anon_sym_throw] = ACTIONS(2639),
    [anon_sym_namespace] = ACTIONS(2639),
    [anon_sym_using] = ACTIONS(2639),
    [anon_sym_static_assert] = ACTIONS(2639),
    [anon_sym_concept] = ACTIONS(2639),
    [anon_sym_co_return] = ACTIONS(2639),
    [anon_sym_co_yield] = ACTIONS(2639),
    [anon_sym_R_DQUOTE] = ACTIONS(2641),
    [anon_sym_LR_DQUOTE] = ACTIONS(2641),
    [anon_sym_uR_DQUOTE] = ACTIONS(2641),
    [anon_sym_UR_DQUOTE] = ACTIONS(2641),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2641),
    [anon_sym_co_await] = ACTIONS(2639),
    [anon_sym_new] = ACTIONS(2639),
    [anon_sym_requires] = ACTIONS(2639),
    [sym_this] = ACTIONS(2639),
  },
  [548] = {
    [ts_builtin_sym_end] = ACTIONS(2645),
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [549] = {
    [sym_identifier] = ACTIONS(2639),
    [aux_sym_preproc_include_token1] = ACTIONS(2639),
    [aux_sym_preproc_def_token1] = ACTIONS(2639),
    [aux_sym_preproc_if_token1] = ACTIONS(2639),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2639),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2639),
    [sym_preproc_directive] = ACTIONS(2639),
    [anon_sym_LPAREN2] = ACTIONS(2641),
    [anon_sym_BANG] = ACTIONS(2641),
    [anon_sym_TILDE] = ACTIONS(2641),
    [anon_sym_DASH] = ACTIONS(2639),
    [anon_sym_PLUS] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(2641),
    [anon_sym_AMP_AMP] = ACTIONS(2641),
    [anon_sym_AMP] = ACTIONS(2639),
    [anon_sym_SEMI] = ACTIONS(2641),
    [anon_sym___extension__] = ACTIONS(2639),
    [anon_sym_typedef] = ACTIONS(2639),
    [anon_sym_extern] = ACTIONS(2639),
    [anon_sym___attribute__] = ACTIONS(2639),
    [anon_sym_COLON_COLON] = ACTIONS(2641),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2641),
    [anon_sym___declspec] = ACTIONS(2639),
    [anon_sym___based] = ACTIONS(2639),
    [anon_sym___cdecl] = ACTIONS(2639),
    [anon_sym___clrcall] = ACTIONS(2639),
    [anon_sym___stdcall] = ACTIONS(2639),
    [anon_sym___fastcall] = ACTIONS(2639),
    [anon_sym___thiscall] = ACTIONS(2639),
    [anon_sym___vectorcall] = ACTIONS(2639),
    [anon_sym_LBRACE] = ACTIONS(2641),
    [anon_sym_RBRACE] = ACTIONS(2641),
    [anon_sym_signed] = ACTIONS(2639),
    [anon_sym_unsigned] = ACTIONS(2639),
    [anon_sym_long] = ACTIONS(2639),
    [anon_sym_short] = ACTIONS(2639),
    [anon_sym_LBRACK] = ACTIONS(2639),
    [anon_sym_static] = ACTIONS(2639),
    [anon_sym_register] = ACTIONS(2639),
    [anon_sym_inline] = ACTIONS(2639),
    [anon_sym___inline] = ACTIONS(2639),
    [anon_sym___inline__] = ACTIONS(2639),
    [anon_sym___forceinline] = ACTIONS(2639),
    [anon_sym_thread_local] = ACTIONS(2639),
    [anon_sym___thread] = ACTIONS(2639),
    [anon_sym_const] = ACTIONS(2639),
    [anon_sym_constexpr] = ACTIONS(2639),
    [anon_sym_volatile] = ACTIONS(2639),
    [anon_sym_restrict] = ACTIONS(2639),
    [anon_sym___restrict__] = ACTIONS(2639),
    [anon_sym__Atomic] = ACTIONS(2639),
    [anon_sym__Noreturn] = ACTIONS(2639),
    [anon_sym_noreturn] = ACTIONS(2639),
    [anon_sym_mutable] = ACTIONS(2639),
    [anon_sym_constinit] = ACTIONS(2639),
    [anon_sym_consteval] = ACTIONS(2639),
    [anon_sym_PROGMEM] = ACTIONS(2639),
    [aux_sym_primitive_type_token1] = ACTIONS(2639),
    [anon_sym_byte] = ACTIONS(2639),
    [anon_sym_word] = ACTIONS(2639),
    [anon_sym_enum] = ACTIONS(2639),
    [anon_sym_class] = ACTIONS(2639),
    [anon_sym_struct] = ACTIONS(2639),
    [anon_sym_union] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2639),
    [anon_sym_else] = ACTIONS(2639),
    [anon_sym_switch] = ACTIONS(2639),
    [anon_sym_case] = ACTIONS(2639),
    [anon_sym_default] = ACTIONS(2639),
    [anon_sym_while] = ACTIONS(2639),
    [anon_sym_do] = ACTIONS(2639),
    [anon_sym_for] = ACTIONS(2639),
    [anon_sym_return] = ACTIONS(2639),
    [anon_sym_break] = ACTIONS(2639),
    [anon_sym_continue] = ACTIONS(2639),
    [anon_sym_goto] = ACTIONS(2639),
    [anon_sym___try] = ACTIONS(2639),
    [anon_sym___leave] = ACTIONS(2639),
    [anon_sym_not] = ACTIONS(2639),
    [anon_sym_compl] = ACTIONS(2639),
    [anon_sym_DASH_DASH] = ACTIONS(2641),
    [anon_sym_PLUS_PLUS] = ACTIONS(2641),
    [anon_sym_sizeof] = ACTIONS(2639),
    [anon_sym___alignof__] = ACTIONS(2639),
    [anon_sym___alignof] = ACTIONS(2639),
    [anon_sym__alignof] = ACTIONS(2639),
    [anon_sym_alignof] = ACTIONS(2639),
    [anon_sym__Alignof] = ACTIONS(2639),
    [anon_sym_offsetof] = ACTIONS(2639),
    [anon_sym__Generic] = ACTIONS(2639),
    [anon_sym_asm] = ACTIONS(2639),
    [anon_sym___asm__] = ACTIONS(2639),
    [aux_sym_number_literal_token1] = ACTIONS(2641),
    [aux_sym_number_literal_token2] = ACTIONS(2639),
    [anon_sym_L_SQUOTE] = ACTIONS(2641),
    [anon_sym_u_SQUOTE] = ACTIONS(2641),
    [anon_sym_U_SQUOTE] = ACTIONS(2641),
    [anon_sym_u8_SQUOTE] = ACTIONS(2641),
    [anon_sym_SQUOTE] = ACTIONS(2641),
    [anon_sym_L_DQUOTE] = ACTIONS(2641),
    [anon_sym_u_DQUOTE] = ACTIONS(2641),
    [anon_sym_U_DQUOTE] = ACTIONS(2641),
    [anon_sym_u8_DQUOTE] = ACTIONS(2641),
    [anon_sym_DQUOTE] = ACTIONS(2641),
    [sym_true] = ACTIONS(2639),
    [sym_false] = ACTIONS(2639),
    [anon_sym_NULL] = ACTIONS(2639),
    [anon_sym_nullptr] = ACTIONS(2639),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2639),
    [anon_sym_decltype] = ACTIONS(2639),
    [anon_sym_virtual] = ACTIONS(2639),
    [anon_sym_alignas] = ACTIONS(2639),
    [anon_sym_explicit] = ACTIONS(2639),
    [anon_sym_typename] = ACTIONS(2639),
    [anon_sym_template] = ACTIONS(2639),
    [anon_sym_operator] = ACTIONS(2639),
    [anon_sym_try] = ACTIONS(2639),
    [anon_sym_delete] = ACTIONS(2639),
    [anon_sym_throw] = ACTIONS(2639),
    [anon_sym_namespace] = ACTIONS(2639),
    [anon_sym_using] = ACTIONS(2639),
    [anon_sym_static_assert] = ACTIONS(2639),
    [anon_sym_concept] = ACTIONS(2639),
    [anon_sym_co_return] = ACTIONS(2639),
    [anon_sym_co_yield] = ACTIONS(2639),
    [anon_sym_R_DQUOTE] = ACTIONS(2641),
    [anon_sym_LR_DQUOTE] = ACTIONS(2641),
    [anon_sym_uR_DQUOTE] = ACTIONS(2641),
    [anon_sym_UR_DQUOTE] = ACTIONS(2641),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2641),
    [anon_sym_co_await] = ACTIONS(2639),
    [anon_sym_new] = ACTIONS(2639),
    [anon_sym_requires] = ACTIONS(2639),
    [sym_this] = ACTIONS(2639),
  },
  [550] = {
    [sym_identifier] = ACTIONS(2739),
    [aux_sym_preproc_include_token1] = ACTIONS(2739),
    [aux_sym_preproc_def_token1] = ACTIONS(2739),
    [aux_sym_preproc_if_token1] = ACTIONS(2739),
    [aux_sym_preproc_if_token2] = ACTIONS(2739),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2739),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2739),
    [sym_preproc_directive] = ACTIONS(2739),
    [anon_sym_LPAREN2] = ACTIONS(2741),
    [anon_sym_BANG] = ACTIONS(2741),
    [anon_sym_TILDE] = ACTIONS(2741),
    [anon_sym_DASH] = ACTIONS(2739),
    [anon_sym_PLUS] = ACTIONS(2739),
    [anon_sym_STAR] = ACTIONS(2741),
    [anon_sym_AMP_AMP] = ACTIONS(2741),
    [anon_sym_AMP] = ACTIONS(2739),
    [anon_sym_SEMI] = ACTIONS(2741),
    [anon_sym___extension__] = ACTIONS(2739),
    [anon_sym_typedef] = ACTIONS(2739),
    [anon_sym_extern] = ACTIONS(2739),
    [anon_sym___attribute__] = ACTIONS(2739),
    [anon_sym_COLON_COLON] = ACTIONS(2741),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2741),
    [anon_sym___declspec] = ACTIONS(2739),
    [anon_sym___based] = ACTIONS(2739),
    [anon_sym___cdecl] = ACTIONS(2739),
    [anon_sym___clrcall] = ACTIONS(2739),
    [anon_sym___stdcall] = ACTIONS(2739),
    [anon_sym___fastcall] = ACTIONS(2739),
    [anon_sym___thiscall] = ACTIONS(2739),
    [anon_sym___vectorcall] = ACTIONS(2739),
    [anon_sym_LBRACE] = ACTIONS(2741),
    [anon_sym_signed] = ACTIONS(2739),
    [anon_sym_unsigned] = ACTIONS(2739),
    [anon_sym_long] = ACTIONS(2739),
    [anon_sym_short] = ACTIONS(2739),
    [anon_sym_LBRACK] = ACTIONS(2739),
    [anon_sym_static] = ACTIONS(2739),
    [anon_sym_register] = ACTIONS(2739),
    [anon_sym_inline] = ACTIONS(2739),
    [anon_sym___inline] = ACTIONS(2739),
    [anon_sym___inline__] = ACTIONS(2739),
    [anon_sym___forceinline] = ACTIONS(2739),
    [anon_sym_thread_local] = ACTIONS(2739),
    [anon_sym___thread] = ACTIONS(2739),
    [anon_sym_const] = ACTIONS(2739),
    [anon_sym_constexpr] = ACTIONS(2739),
    [anon_sym_volatile] = ACTIONS(2739),
    [anon_sym_restrict] = ACTIONS(2739),
    [anon_sym___restrict__] = ACTIONS(2739),
    [anon_sym__Atomic] = ACTIONS(2739),
    [anon_sym__Noreturn] = ACTIONS(2739),
    [anon_sym_noreturn] = ACTIONS(2739),
    [anon_sym_mutable] = ACTIONS(2739),
    [anon_sym_constinit] = ACTIONS(2739),
    [anon_sym_consteval] = ACTIONS(2739),
    [anon_sym_PROGMEM] = ACTIONS(2739),
    [aux_sym_primitive_type_token1] = ACTIONS(2739),
    [anon_sym_byte] = ACTIONS(2739),
    [anon_sym_word] = ACTIONS(2739),
    [anon_sym_enum] = ACTIONS(2739),
    [anon_sym_class] = ACTIONS(2739),
    [anon_sym_struct] = ACTIONS(2739),
    [anon_sym_union] = ACTIONS(2739),
    [anon_sym_if] = ACTIONS(2739),
    [anon_sym_else] = ACTIONS(2739),
    [anon_sym_switch] = ACTIONS(2739),
    [anon_sym_case] = ACTIONS(2739),
    [anon_sym_default] = ACTIONS(2739),
    [anon_sym_while] = ACTIONS(2739),
    [anon_sym_do] = ACTIONS(2739),
    [anon_sym_for] = ACTIONS(2739),
    [anon_sym_return] = ACTIONS(2739),
    [anon_sym_break] = ACTIONS(2739),
    [anon_sym_continue] = ACTIONS(2739),
    [anon_sym_goto] = ACTIONS(2739),
    [anon_sym___try] = ACTIONS(2739),
    [anon_sym___leave] = ACTIONS(2739),
    [anon_sym_not] = ACTIONS(2739),
    [anon_sym_compl] = ACTIONS(2739),
    [anon_sym_DASH_DASH] = ACTIONS(2741),
    [anon_sym_PLUS_PLUS] = ACTIONS(2741),
    [anon_sym_sizeof] = ACTIONS(2739),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2739),
    [anon_sym__Generic] = ACTIONS(2739),
    [anon_sym_asm] = ACTIONS(2739),
    [anon_sym___asm__] = ACTIONS(2739),
    [aux_sym_number_literal_token1] = ACTIONS(2741),
    [aux_sym_number_literal_token2] = ACTIONS(2739),
    [anon_sym_L_SQUOTE] = ACTIONS(2741),
    [anon_sym_u_SQUOTE] = ACTIONS(2741),
    [anon_sym_U_SQUOTE] = ACTIONS(2741),
    [anon_sym_u8_SQUOTE] = ACTIONS(2741),
    [anon_sym_SQUOTE] = ACTIONS(2741),
    [anon_sym_L_DQUOTE] = ACTIONS(2741),
    [anon_sym_u_DQUOTE] = ACTIONS(2741),
    [anon_sym_U_DQUOTE] = ACTIONS(2741),
    [anon_sym_u8_DQUOTE] = ACTIONS(2741),
    [anon_sym_DQUOTE] = ACTIONS(2741),
    [sym_true] = ACTIONS(2739),
    [sym_false] = ACTIONS(2739),
    [anon_sym_NULL] = ACTIONS(2739),
    [anon_sym_nullptr] = ACTIONS(2739),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2739),
    [anon_sym_decltype] = ACTIONS(2739),
    [anon_sym_virtual] = ACTIONS(2739),
    [anon_sym_alignas] = ACTIONS(2739),
    [anon_sym_explicit] = ACTIONS(2739),
    [anon_sym_typename] = ACTIONS(2739),
    [anon_sym_template] = ACTIONS(2739),
    [anon_sym_operator] = ACTIONS(2739),
    [anon_sym_try] = ACTIONS(2739),
    [anon_sym_delete] = ACTIONS(2739),
    [anon_sym_throw] = ACTIONS(2739),
    [anon_sym_namespace] = ACTIONS(2739),
    [anon_sym_using] = ACTIONS(2739),
    [anon_sym_static_assert] = ACTIONS(2739),
    [anon_sym_concept] = ACTIONS(2739),
    [anon_sym_co_return] = ACTIONS(2739),
    [anon_sym_co_yield] = ACTIONS(2739),
    [anon_sym_R_DQUOTE] = ACTIONS(2741),
    [anon_sym_LR_DQUOTE] = ACTIONS(2741),
    [anon_sym_uR_DQUOTE] = ACTIONS(2741),
    [anon_sym_UR_DQUOTE] = ACTIONS(2741),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2741),
    [anon_sym_co_await] = ACTIONS(2739),
    [anon_sym_new] = ACTIONS(2739),
    [anon_sym_requires] = ACTIONS(2739),
    [sym_this] = ACTIONS(2739),
  },
  [551] = {
    [ts_builtin_sym_end] = ACTIONS(2681),
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [552] = {
    [sym_identifier] = ACTIONS(2783),
    [aux_sym_preproc_include_token1] = ACTIONS(2783),
    [aux_sym_preproc_def_token1] = ACTIONS(2783),
    [aux_sym_preproc_if_token1] = ACTIONS(2783),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2783),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2783),
    [sym_preproc_directive] = ACTIONS(2783),
    [anon_sym_LPAREN2] = ACTIONS(2785),
    [anon_sym_BANG] = ACTIONS(2785),
    [anon_sym_TILDE] = ACTIONS(2785),
    [anon_sym_DASH] = ACTIONS(2783),
    [anon_sym_PLUS] = ACTIONS(2783),
    [anon_sym_STAR] = ACTIONS(2785),
    [anon_sym_AMP_AMP] = ACTIONS(2785),
    [anon_sym_AMP] = ACTIONS(2783),
    [anon_sym_SEMI] = ACTIONS(2785),
    [anon_sym___extension__] = ACTIONS(2783),
    [anon_sym_typedef] = ACTIONS(2783),
    [anon_sym_extern] = ACTIONS(2783),
    [anon_sym___attribute__] = ACTIONS(2783),
    [anon_sym_COLON_COLON] = ACTIONS(2785),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2785),
    [anon_sym___declspec] = ACTIONS(2783),
    [anon_sym___based] = ACTIONS(2783),
    [anon_sym___cdecl] = ACTIONS(2783),
    [anon_sym___clrcall] = ACTIONS(2783),
    [anon_sym___stdcall] = ACTIONS(2783),
    [anon_sym___fastcall] = ACTIONS(2783),
    [anon_sym___thiscall] = ACTIONS(2783),
    [anon_sym___vectorcall] = ACTIONS(2783),
    [anon_sym_LBRACE] = ACTIONS(2785),
    [anon_sym_RBRACE] = ACTIONS(2785),
    [anon_sym_signed] = ACTIONS(2783),
    [anon_sym_unsigned] = ACTIONS(2783),
    [anon_sym_long] = ACTIONS(2783),
    [anon_sym_short] = ACTIONS(2783),
    [anon_sym_LBRACK] = ACTIONS(2783),
    [anon_sym_static] = ACTIONS(2783),
    [anon_sym_register] = ACTIONS(2783),
    [anon_sym_inline] = ACTIONS(2783),
    [anon_sym___inline] = ACTIONS(2783),
    [anon_sym___inline__] = ACTIONS(2783),
    [anon_sym___forceinline] = ACTIONS(2783),
    [anon_sym_thread_local] = ACTIONS(2783),
    [anon_sym___thread] = ACTIONS(2783),
    [anon_sym_const] = ACTIONS(2783),
    [anon_sym_constexpr] = ACTIONS(2783),
    [anon_sym_volatile] = ACTIONS(2783),
    [anon_sym_restrict] = ACTIONS(2783),
    [anon_sym___restrict__] = ACTIONS(2783),
    [anon_sym__Atomic] = ACTIONS(2783),
    [anon_sym__Noreturn] = ACTIONS(2783),
    [anon_sym_noreturn] = ACTIONS(2783),
    [anon_sym_mutable] = ACTIONS(2783),
    [anon_sym_constinit] = ACTIONS(2783),
    [anon_sym_consteval] = ACTIONS(2783),
    [anon_sym_PROGMEM] = ACTIONS(2783),
    [aux_sym_primitive_type_token1] = ACTIONS(2783),
    [anon_sym_byte] = ACTIONS(2783),
    [anon_sym_word] = ACTIONS(2783),
    [anon_sym_enum] = ACTIONS(2783),
    [anon_sym_class] = ACTIONS(2783),
    [anon_sym_struct] = ACTIONS(2783),
    [anon_sym_union] = ACTIONS(2783),
    [anon_sym_if] = ACTIONS(2783),
    [anon_sym_else] = ACTIONS(2783),
    [anon_sym_switch] = ACTIONS(2783),
    [anon_sym_case] = ACTIONS(2783),
    [anon_sym_default] = ACTIONS(2783),
    [anon_sym_while] = ACTIONS(2783),
    [anon_sym_do] = ACTIONS(2783),
    [anon_sym_for] = ACTIONS(2783),
    [anon_sym_return] = ACTIONS(2783),
    [anon_sym_break] = ACTIONS(2783),
    [anon_sym_continue] = ACTIONS(2783),
    [anon_sym_goto] = ACTIONS(2783),
    [anon_sym___try] = ACTIONS(2783),
    [anon_sym___leave] = ACTIONS(2783),
    [anon_sym_not] = ACTIONS(2783),
    [anon_sym_compl] = ACTIONS(2783),
    [anon_sym_DASH_DASH] = ACTIONS(2785),
    [anon_sym_PLUS_PLUS] = ACTIONS(2785),
    [anon_sym_sizeof] = ACTIONS(2783),
    [anon_sym___alignof__] = ACTIONS(2783),
    [anon_sym___alignof] = ACTIONS(2783),
    [anon_sym__alignof] = ACTIONS(2783),
    [anon_sym_alignof] = ACTIONS(2783),
    [anon_sym__Alignof] = ACTIONS(2783),
    [anon_sym_offsetof] = ACTIONS(2783),
    [anon_sym__Generic] = ACTIONS(2783),
    [anon_sym_asm] = ACTIONS(2783),
    [anon_sym___asm__] = ACTIONS(2783),
    [aux_sym_number_literal_token1] = ACTIONS(2785),
    [aux_sym_number_literal_token2] = ACTIONS(2783),
    [anon_sym_L_SQUOTE] = ACTIONS(2785),
    [anon_sym_u_SQUOTE] = ACTIONS(2785),
    [anon_sym_U_SQUOTE] = ACTIONS(2785),
    [anon_sym_u8_SQUOTE] = ACTIONS(2785),
    [anon_sym_SQUOTE] = ACTIONS(2785),
    [anon_sym_L_DQUOTE] = ACTIONS(2785),
    [anon_sym_u_DQUOTE] = ACTIONS(2785),
    [anon_sym_U_DQUOTE] = ACTIONS(2785),
    [anon_sym_u8_DQUOTE] = ACTIONS(2785),
    [anon_sym_DQUOTE] = ACTIONS(2785),
    [sym_true] = ACTIONS(2783),
    [sym_false] = ACTIONS(2783),
    [anon_sym_NULL] = ACTIONS(2783),
    [anon_sym_nullptr] = ACTIONS(2783),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2783),
    [anon_sym_decltype] = ACTIONS(2783),
    [anon_sym_virtual] = ACTIONS(2783),
    [anon_sym_alignas] = ACTIONS(2783),
    [anon_sym_explicit] = ACTIONS(2783),
    [anon_sym_typename] = ACTIONS(2783),
    [anon_sym_template] = ACTIONS(2783),
    [anon_sym_operator] = ACTIONS(2783),
    [anon_sym_try] = ACTIONS(2783),
    [anon_sym_delete] = ACTIONS(2783),
    [anon_sym_throw] = ACTIONS(2783),
    [anon_sym_namespace] = ACTIONS(2783),
    [anon_sym_using] = ACTIONS(2783),
    [anon_sym_static_assert] = ACTIONS(2783),
    [anon_sym_concept] = ACTIONS(2783),
    [anon_sym_co_return] = ACTIONS(2783),
    [anon_sym_co_yield] = ACTIONS(2783),
    [anon_sym_R_DQUOTE] = ACTIONS(2785),
    [anon_sym_LR_DQUOTE] = ACTIONS(2785),
    [anon_sym_uR_DQUOTE] = ACTIONS(2785),
    [anon_sym_UR_DQUOTE] = ACTIONS(2785),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2785),
    [anon_sym_co_await] = ACTIONS(2783),
    [anon_sym_new] = ACTIONS(2783),
    [anon_sym_requires] = ACTIONS(2783),
    [sym_this] = ACTIONS(2783),
  },
  [553] = {
    [sym_identifier] = ACTIONS(2773),
    [aux_sym_preproc_include_token1] = ACTIONS(2773),
    [aux_sym_preproc_def_token1] = ACTIONS(2773),
    [aux_sym_preproc_if_token1] = ACTIONS(2773),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2773),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2773),
    [sym_preproc_directive] = ACTIONS(2773),
    [anon_sym_LPAREN2] = ACTIONS(2775),
    [anon_sym_BANG] = ACTIONS(2775),
    [anon_sym_TILDE] = ACTIONS(2775),
    [anon_sym_DASH] = ACTIONS(2773),
    [anon_sym_PLUS] = ACTIONS(2773),
    [anon_sym_STAR] = ACTIONS(2775),
    [anon_sym_AMP_AMP] = ACTIONS(2775),
    [anon_sym_AMP] = ACTIONS(2773),
    [anon_sym_SEMI] = ACTIONS(2775),
    [anon_sym___extension__] = ACTIONS(2773),
    [anon_sym_typedef] = ACTIONS(2773),
    [anon_sym_extern] = ACTIONS(2773),
    [anon_sym___attribute__] = ACTIONS(2773),
    [anon_sym_COLON_COLON] = ACTIONS(2775),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2775),
    [anon_sym___declspec] = ACTIONS(2773),
    [anon_sym___based] = ACTIONS(2773),
    [anon_sym___cdecl] = ACTIONS(2773),
    [anon_sym___clrcall] = ACTIONS(2773),
    [anon_sym___stdcall] = ACTIONS(2773),
    [anon_sym___fastcall] = ACTIONS(2773),
    [anon_sym___thiscall] = ACTIONS(2773),
    [anon_sym___vectorcall] = ACTIONS(2773),
    [anon_sym_LBRACE] = ACTIONS(2775),
    [anon_sym_RBRACE] = ACTIONS(2775),
    [anon_sym_signed] = ACTIONS(2773),
    [anon_sym_unsigned] = ACTIONS(2773),
    [anon_sym_long] = ACTIONS(2773),
    [anon_sym_short] = ACTIONS(2773),
    [anon_sym_LBRACK] = ACTIONS(2773),
    [anon_sym_static] = ACTIONS(2773),
    [anon_sym_register] = ACTIONS(2773),
    [anon_sym_inline] = ACTIONS(2773),
    [anon_sym___inline] = ACTIONS(2773),
    [anon_sym___inline__] = ACTIONS(2773),
    [anon_sym___forceinline] = ACTIONS(2773),
    [anon_sym_thread_local] = ACTIONS(2773),
    [anon_sym___thread] = ACTIONS(2773),
    [anon_sym_const] = ACTIONS(2773),
    [anon_sym_constexpr] = ACTIONS(2773),
    [anon_sym_volatile] = ACTIONS(2773),
    [anon_sym_restrict] = ACTIONS(2773),
    [anon_sym___restrict__] = ACTIONS(2773),
    [anon_sym__Atomic] = ACTIONS(2773),
    [anon_sym__Noreturn] = ACTIONS(2773),
    [anon_sym_noreturn] = ACTIONS(2773),
    [anon_sym_mutable] = ACTIONS(2773),
    [anon_sym_constinit] = ACTIONS(2773),
    [anon_sym_consteval] = ACTIONS(2773),
    [anon_sym_PROGMEM] = ACTIONS(2773),
    [aux_sym_primitive_type_token1] = ACTIONS(2773),
    [anon_sym_byte] = ACTIONS(2773),
    [anon_sym_word] = ACTIONS(2773),
    [anon_sym_enum] = ACTIONS(2773),
    [anon_sym_class] = ACTIONS(2773),
    [anon_sym_struct] = ACTIONS(2773),
    [anon_sym_union] = ACTIONS(2773),
    [anon_sym_if] = ACTIONS(2773),
    [anon_sym_else] = ACTIONS(2773),
    [anon_sym_switch] = ACTIONS(2773),
    [anon_sym_case] = ACTIONS(2773),
    [anon_sym_default] = ACTIONS(2773),
    [anon_sym_while] = ACTIONS(2773),
    [anon_sym_do] = ACTIONS(2773),
    [anon_sym_for] = ACTIONS(2773),
    [anon_sym_return] = ACTIONS(2773),
    [anon_sym_break] = ACTIONS(2773),
    [anon_sym_continue] = ACTIONS(2773),
    [anon_sym_goto] = ACTIONS(2773),
    [anon_sym___try] = ACTIONS(2773),
    [anon_sym___leave] = ACTIONS(2773),
    [anon_sym_not] = ACTIONS(2773),
    [anon_sym_compl] = ACTIONS(2773),
    [anon_sym_DASH_DASH] = ACTIONS(2775),
    [anon_sym_PLUS_PLUS] = ACTIONS(2775),
    [anon_sym_sizeof] = ACTIONS(2773),
    [anon_sym___alignof__] = ACTIONS(2773),
    [anon_sym___alignof] = ACTIONS(2773),
    [anon_sym__alignof] = ACTIONS(2773),
    [anon_sym_alignof] = ACTIONS(2773),
    [anon_sym__Alignof] = ACTIONS(2773),
    [anon_sym_offsetof] = ACTIONS(2773),
    [anon_sym__Generic] = ACTIONS(2773),
    [anon_sym_asm] = ACTIONS(2773),
    [anon_sym___asm__] = ACTIONS(2773),
    [aux_sym_number_literal_token1] = ACTIONS(2775),
    [aux_sym_number_literal_token2] = ACTIONS(2773),
    [anon_sym_L_SQUOTE] = ACTIONS(2775),
    [anon_sym_u_SQUOTE] = ACTIONS(2775),
    [anon_sym_U_SQUOTE] = ACTIONS(2775),
    [anon_sym_u8_SQUOTE] = ACTIONS(2775),
    [anon_sym_SQUOTE] = ACTIONS(2775),
    [anon_sym_L_DQUOTE] = ACTIONS(2775),
    [anon_sym_u_DQUOTE] = ACTIONS(2775),
    [anon_sym_U_DQUOTE] = ACTIONS(2775),
    [anon_sym_u8_DQUOTE] = ACTIONS(2775),
    [anon_sym_DQUOTE] = ACTIONS(2775),
    [sym_true] = ACTIONS(2773),
    [sym_false] = ACTIONS(2773),
    [anon_sym_NULL] = ACTIONS(2773),
    [anon_sym_nullptr] = ACTIONS(2773),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2773),
    [anon_sym_decltype] = ACTIONS(2773),
    [anon_sym_virtual] = ACTIONS(2773),
    [anon_sym_alignas] = ACTIONS(2773),
    [anon_sym_explicit] = ACTIONS(2773),
    [anon_sym_typename] = ACTIONS(2773),
    [anon_sym_template] = ACTIONS(2773),
    [anon_sym_operator] = ACTIONS(2773),
    [anon_sym_try] = ACTIONS(2773),
    [anon_sym_delete] = ACTIONS(2773),
    [anon_sym_throw] = ACTIONS(2773),
    [anon_sym_namespace] = ACTIONS(2773),
    [anon_sym_using] = ACTIONS(2773),
    [anon_sym_static_assert] = ACTIONS(2773),
    [anon_sym_concept] = ACTIONS(2773),
    [anon_sym_co_return] = ACTIONS(2773),
    [anon_sym_co_yield] = ACTIONS(2773),
    [anon_sym_R_DQUOTE] = ACTIONS(2775),
    [anon_sym_LR_DQUOTE] = ACTIONS(2775),
    [anon_sym_uR_DQUOTE] = ACTIONS(2775),
    [anon_sym_UR_DQUOTE] = ACTIONS(2775),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2775),
    [anon_sym_co_await] = ACTIONS(2773),
    [anon_sym_new] = ACTIONS(2773),
    [anon_sym_requires] = ACTIONS(2773),
    [sym_this] = ACTIONS(2773),
  },
  [554] = {
    [ts_builtin_sym_end] = ACTIONS(2771),
    [sym_identifier] = ACTIONS(2769),
    [aux_sym_preproc_include_token1] = ACTIONS(2769),
    [aux_sym_preproc_def_token1] = ACTIONS(2769),
    [aux_sym_preproc_if_token1] = ACTIONS(2769),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2769),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2769),
    [sym_preproc_directive] = ACTIONS(2769),
    [anon_sym_LPAREN2] = ACTIONS(2771),
    [anon_sym_BANG] = ACTIONS(2771),
    [anon_sym_TILDE] = ACTIONS(2771),
    [anon_sym_DASH] = ACTIONS(2769),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_STAR] = ACTIONS(2771),
    [anon_sym_AMP_AMP] = ACTIONS(2771),
    [anon_sym_AMP] = ACTIONS(2769),
    [anon_sym_SEMI] = ACTIONS(2771),
    [anon_sym___extension__] = ACTIONS(2769),
    [anon_sym_typedef] = ACTIONS(2769),
    [anon_sym_extern] = ACTIONS(2769),
    [anon_sym___attribute__] = ACTIONS(2769),
    [anon_sym_COLON_COLON] = ACTIONS(2771),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2771),
    [anon_sym___declspec] = ACTIONS(2769),
    [anon_sym___based] = ACTIONS(2769),
    [anon_sym___cdecl] = ACTIONS(2769),
    [anon_sym___clrcall] = ACTIONS(2769),
    [anon_sym___stdcall] = ACTIONS(2769),
    [anon_sym___fastcall] = ACTIONS(2769),
    [anon_sym___thiscall] = ACTIONS(2769),
    [anon_sym___vectorcall] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(2771),
    [anon_sym_signed] = ACTIONS(2769),
    [anon_sym_unsigned] = ACTIONS(2769),
    [anon_sym_long] = ACTIONS(2769),
    [anon_sym_short] = ACTIONS(2769),
    [anon_sym_LBRACK] = ACTIONS(2769),
    [anon_sym_static] = ACTIONS(2769),
    [anon_sym_register] = ACTIONS(2769),
    [anon_sym_inline] = ACTIONS(2769),
    [anon_sym___inline] = ACTIONS(2769),
    [anon_sym___inline__] = ACTIONS(2769),
    [anon_sym___forceinline] = ACTIONS(2769),
    [anon_sym_thread_local] = ACTIONS(2769),
    [anon_sym___thread] = ACTIONS(2769),
    [anon_sym_const] = ACTIONS(2769),
    [anon_sym_constexpr] = ACTIONS(2769),
    [anon_sym_volatile] = ACTIONS(2769),
    [anon_sym_restrict] = ACTIONS(2769),
    [anon_sym___restrict__] = ACTIONS(2769),
    [anon_sym__Atomic] = ACTIONS(2769),
    [anon_sym__Noreturn] = ACTIONS(2769),
    [anon_sym_noreturn] = ACTIONS(2769),
    [anon_sym_mutable] = ACTIONS(2769),
    [anon_sym_constinit] = ACTIONS(2769),
    [anon_sym_consteval] = ACTIONS(2769),
    [anon_sym_PROGMEM] = ACTIONS(2769),
    [aux_sym_primitive_type_token1] = ACTIONS(2769),
    [anon_sym_byte] = ACTIONS(2769),
    [anon_sym_word] = ACTIONS(2769),
    [anon_sym_enum] = ACTIONS(2769),
    [anon_sym_class] = ACTIONS(2769),
    [anon_sym_struct] = ACTIONS(2769),
    [anon_sym_union] = ACTIONS(2769),
    [anon_sym_if] = ACTIONS(2769),
    [anon_sym_else] = ACTIONS(2769),
    [anon_sym_switch] = ACTIONS(2769),
    [anon_sym_case] = ACTIONS(2769),
    [anon_sym_default] = ACTIONS(2769),
    [anon_sym_while] = ACTIONS(2769),
    [anon_sym_do] = ACTIONS(2769),
    [anon_sym_for] = ACTIONS(2769),
    [anon_sym_return] = ACTIONS(2769),
    [anon_sym_break] = ACTIONS(2769),
    [anon_sym_continue] = ACTIONS(2769),
    [anon_sym_goto] = ACTIONS(2769),
    [anon_sym___try] = ACTIONS(2769),
    [anon_sym___leave] = ACTIONS(2769),
    [anon_sym_not] = ACTIONS(2769),
    [anon_sym_compl] = ACTIONS(2769),
    [anon_sym_DASH_DASH] = ACTIONS(2771),
    [anon_sym_PLUS_PLUS] = ACTIONS(2771),
    [anon_sym_sizeof] = ACTIONS(2769),
    [anon_sym___alignof__] = ACTIONS(2769),
    [anon_sym___alignof] = ACTIONS(2769),
    [anon_sym__alignof] = ACTIONS(2769),
    [anon_sym_alignof] = ACTIONS(2769),
    [anon_sym__Alignof] = ACTIONS(2769),
    [anon_sym_offsetof] = ACTIONS(2769),
    [anon_sym__Generic] = ACTIONS(2769),
    [anon_sym_asm] = ACTIONS(2769),
    [anon_sym___asm__] = ACTIONS(2769),
    [aux_sym_number_literal_token1] = ACTIONS(2771),
    [aux_sym_number_literal_token2] = ACTIONS(2769),
    [anon_sym_L_SQUOTE] = ACTIONS(2771),
    [anon_sym_u_SQUOTE] = ACTIONS(2771),
    [anon_sym_U_SQUOTE] = ACTIONS(2771),
    [anon_sym_u8_SQUOTE] = ACTIONS(2771),
    [anon_sym_SQUOTE] = ACTIONS(2771),
    [anon_sym_L_DQUOTE] = ACTIONS(2771),
    [anon_sym_u_DQUOTE] = ACTIONS(2771),
    [anon_sym_U_DQUOTE] = ACTIONS(2771),
    [anon_sym_u8_DQUOTE] = ACTIONS(2771),
    [anon_sym_DQUOTE] = ACTIONS(2771),
    [sym_true] = ACTIONS(2769),
    [sym_false] = ACTIONS(2769),
    [anon_sym_NULL] = ACTIONS(2769),
    [anon_sym_nullptr] = ACTIONS(2769),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2769),
    [anon_sym_decltype] = ACTIONS(2769),
    [anon_sym_virtual] = ACTIONS(2769),
    [anon_sym_alignas] = ACTIONS(2769),
    [anon_sym_explicit] = ACTIONS(2769),
    [anon_sym_typename] = ACTIONS(2769),
    [anon_sym_template] = ACTIONS(2769),
    [anon_sym_operator] = ACTIONS(2769),
    [anon_sym_try] = ACTIONS(2769),
    [anon_sym_delete] = ACTIONS(2769),
    [anon_sym_throw] = ACTIONS(2769),
    [anon_sym_namespace] = ACTIONS(2769),
    [anon_sym_using] = ACTIONS(2769),
    [anon_sym_static_assert] = ACTIONS(2769),
    [anon_sym_concept] = ACTIONS(2769),
    [anon_sym_co_return] = ACTIONS(2769),
    [anon_sym_co_yield] = ACTIONS(2769),
    [anon_sym_R_DQUOTE] = ACTIONS(2771),
    [anon_sym_LR_DQUOTE] = ACTIONS(2771),
    [anon_sym_uR_DQUOTE] = ACTIONS(2771),
    [anon_sym_UR_DQUOTE] = ACTIONS(2771),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2771),
    [anon_sym_co_await] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2769),
    [anon_sym_requires] = ACTIONS(2769),
    [sym_this] = ACTIONS(2769),
  },
  [555] = {
    [ts_builtin_sym_end] = ACTIONS(2671),
    [sym_identifier] = ACTIONS(2669),
    [aux_sym_preproc_include_token1] = ACTIONS(2669),
    [aux_sym_preproc_def_token1] = ACTIONS(2669),
    [aux_sym_preproc_if_token1] = ACTIONS(2669),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2669),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2669),
    [sym_preproc_directive] = ACTIONS(2669),
    [anon_sym_LPAREN2] = ACTIONS(2671),
    [anon_sym_BANG] = ACTIONS(2671),
    [anon_sym_TILDE] = ACTIONS(2671),
    [anon_sym_DASH] = ACTIONS(2669),
    [anon_sym_PLUS] = ACTIONS(2669),
    [anon_sym_STAR] = ACTIONS(2671),
    [anon_sym_AMP_AMP] = ACTIONS(2671),
    [anon_sym_AMP] = ACTIONS(2669),
    [anon_sym_SEMI] = ACTIONS(2671),
    [anon_sym___extension__] = ACTIONS(2669),
    [anon_sym_typedef] = ACTIONS(2669),
    [anon_sym_extern] = ACTIONS(2669),
    [anon_sym___attribute__] = ACTIONS(2669),
    [anon_sym_COLON_COLON] = ACTIONS(2671),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2671),
    [anon_sym___declspec] = ACTIONS(2669),
    [anon_sym___based] = ACTIONS(2669),
    [anon_sym___cdecl] = ACTIONS(2669),
    [anon_sym___clrcall] = ACTIONS(2669),
    [anon_sym___stdcall] = ACTIONS(2669),
    [anon_sym___fastcall] = ACTIONS(2669),
    [anon_sym___thiscall] = ACTIONS(2669),
    [anon_sym___vectorcall] = ACTIONS(2669),
    [anon_sym_LBRACE] = ACTIONS(2671),
    [anon_sym_signed] = ACTIONS(2669),
    [anon_sym_unsigned] = ACTIONS(2669),
    [anon_sym_long] = ACTIONS(2669),
    [anon_sym_short] = ACTIONS(2669),
    [anon_sym_LBRACK] = ACTIONS(2669),
    [anon_sym_static] = ACTIONS(2669),
    [anon_sym_register] = ACTIONS(2669),
    [anon_sym_inline] = ACTIONS(2669),
    [anon_sym___inline] = ACTIONS(2669),
    [anon_sym___inline__] = ACTIONS(2669),
    [anon_sym___forceinline] = ACTIONS(2669),
    [anon_sym_thread_local] = ACTIONS(2669),
    [anon_sym___thread] = ACTIONS(2669),
    [anon_sym_const] = ACTIONS(2669),
    [anon_sym_constexpr] = ACTIONS(2669),
    [anon_sym_volatile] = ACTIONS(2669),
    [anon_sym_restrict] = ACTIONS(2669),
    [anon_sym___restrict__] = ACTIONS(2669),
    [anon_sym__Atomic] = ACTIONS(2669),
    [anon_sym__Noreturn] = ACTIONS(2669),
    [anon_sym_noreturn] = ACTIONS(2669),
    [anon_sym_mutable] = ACTIONS(2669),
    [anon_sym_constinit] = ACTIONS(2669),
    [anon_sym_consteval] = ACTIONS(2669),
    [anon_sym_PROGMEM] = ACTIONS(2669),
    [aux_sym_primitive_type_token1] = ACTIONS(2669),
    [anon_sym_byte] = ACTIONS(2669),
    [anon_sym_word] = ACTIONS(2669),
    [anon_sym_enum] = ACTIONS(2669),
    [anon_sym_class] = ACTIONS(2669),
    [anon_sym_struct] = ACTIONS(2669),
    [anon_sym_union] = ACTIONS(2669),
    [anon_sym_if] = ACTIONS(2669),
    [anon_sym_else] = ACTIONS(2669),
    [anon_sym_switch] = ACTIONS(2669),
    [anon_sym_case] = ACTIONS(2669),
    [anon_sym_default] = ACTIONS(2669),
    [anon_sym_while] = ACTIONS(2669),
    [anon_sym_do] = ACTIONS(2669),
    [anon_sym_for] = ACTIONS(2669),
    [anon_sym_return] = ACTIONS(2669),
    [anon_sym_break] = ACTIONS(2669),
    [anon_sym_continue] = ACTIONS(2669),
    [anon_sym_goto] = ACTIONS(2669),
    [anon_sym___try] = ACTIONS(2669),
    [anon_sym___leave] = ACTIONS(2669),
    [anon_sym_not] = ACTIONS(2669),
    [anon_sym_compl] = ACTIONS(2669),
    [anon_sym_DASH_DASH] = ACTIONS(2671),
    [anon_sym_PLUS_PLUS] = ACTIONS(2671),
    [anon_sym_sizeof] = ACTIONS(2669),
    [anon_sym___alignof__] = ACTIONS(2669),
    [anon_sym___alignof] = ACTIONS(2669),
    [anon_sym__alignof] = ACTIONS(2669),
    [anon_sym_alignof] = ACTIONS(2669),
    [anon_sym__Alignof] = ACTIONS(2669),
    [anon_sym_offsetof] = ACTIONS(2669),
    [anon_sym__Generic] = ACTIONS(2669),
    [anon_sym_asm] = ACTIONS(2669),
    [anon_sym___asm__] = ACTIONS(2669),
    [aux_sym_number_literal_token1] = ACTIONS(2671),
    [aux_sym_number_literal_token2] = ACTIONS(2669),
    [anon_sym_L_SQUOTE] = ACTIONS(2671),
    [anon_sym_u_SQUOTE] = ACTIONS(2671),
    [anon_sym_U_SQUOTE] = ACTIONS(2671),
    [anon_sym_u8_SQUOTE] = ACTIONS(2671),
    [anon_sym_SQUOTE] = ACTIONS(2671),
    [anon_sym_L_DQUOTE] = ACTIONS(2671),
    [anon_sym_u_DQUOTE] = ACTIONS(2671),
    [anon_sym_U_DQUOTE] = ACTIONS(2671),
    [anon_sym_u8_DQUOTE] = ACTIONS(2671),
    [anon_sym_DQUOTE] = ACTIONS(2671),
    [sym_true] = ACTIONS(2669),
    [sym_false] = ACTIONS(2669),
    [anon_sym_NULL] = ACTIONS(2669),
    [anon_sym_nullptr] = ACTIONS(2669),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2669),
    [anon_sym_decltype] = ACTIONS(2669),
    [anon_sym_virtual] = ACTIONS(2669),
    [anon_sym_alignas] = ACTIONS(2669),
    [anon_sym_explicit] = ACTIONS(2669),
    [anon_sym_typename] = ACTIONS(2669),
    [anon_sym_template] = ACTIONS(2669),
    [anon_sym_operator] = ACTIONS(2669),
    [anon_sym_try] = ACTIONS(2669),
    [anon_sym_delete] = ACTIONS(2669),
    [anon_sym_throw] = ACTIONS(2669),
    [anon_sym_namespace] = ACTIONS(2669),
    [anon_sym_using] = ACTIONS(2669),
    [anon_sym_static_assert] = ACTIONS(2669),
    [anon_sym_concept] = ACTIONS(2669),
    [anon_sym_co_return] = ACTIONS(2669),
    [anon_sym_co_yield] = ACTIONS(2669),
    [anon_sym_R_DQUOTE] = ACTIONS(2671),
    [anon_sym_LR_DQUOTE] = ACTIONS(2671),
    [anon_sym_uR_DQUOTE] = ACTIONS(2671),
    [anon_sym_UR_DQUOTE] = ACTIONS(2671),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2671),
    [anon_sym_co_await] = ACTIONS(2669),
    [anon_sym_new] = ACTIONS(2669),
    [anon_sym_requires] = ACTIONS(2669),
    [sym_this] = ACTIONS(2669),
  },
  [556] = {
    [sym_identifier] = ACTIONS(2765),
    [aux_sym_preproc_include_token1] = ACTIONS(2765),
    [aux_sym_preproc_def_token1] = ACTIONS(2765),
    [aux_sym_preproc_if_token1] = ACTIONS(2765),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2765),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2765),
    [sym_preproc_directive] = ACTIONS(2765),
    [anon_sym_LPAREN2] = ACTIONS(2767),
    [anon_sym_BANG] = ACTIONS(2767),
    [anon_sym_TILDE] = ACTIONS(2767),
    [anon_sym_DASH] = ACTIONS(2765),
    [anon_sym_PLUS] = ACTIONS(2765),
    [anon_sym_STAR] = ACTIONS(2767),
    [anon_sym_AMP_AMP] = ACTIONS(2767),
    [anon_sym_AMP] = ACTIONS(2765),
    [anon_sym_SEMI] = ACTIONS(2767),
    [anon_sym___extension__] = ACTIONS(2765),
    [anon_sym_typedef] = ACTIONS(2765),
    [anon_sym_extern] = ACTIONS(2765),
    [anon_sym___attribute__] = ACTIONS(2765),
    [anon_sym_COLON_COLON] = ACTIONS(2767),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2767),
    [anon_sym___declspec] = ACTIONS(2765),
    [anon_sym___based] = ACTIONS(2765),
    [anon_sym___cdecl] = ACTIONS(2765),
    [anon_sym___clrcall] = ACTIONS(2765),
    [anon_sym___stdcall] = ACTIONS(2765),
    [anon_sym___fastcall] = ACTIONS(2765),
    [anon_sym___thiscall] = ACTIONS(2765),
    [anon_sym___vectorcall] = ACTIONS(2765),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_RBRACE] = ACTIONS(2767),
    [anon_sym_signed] = ACTIONS(2765),
    [anon_sym_unsigned] = ACTIONS(2765),
    [anon_sym_long] = ACTIONS(2765),
    [anon_sym_short] = ACTIONS(2765),
    [anon_sym_LBRACK] = ACTIONS(2765),
    [anon_sym_static] = ACTIONS(2765),
    [anon_sym_register] = ACTIONS(2765),
    [anon_sym_inline] = ACTIONS(2765),
    [anon_sym___inline] = ACTIONS(2765),
    [anon_sym___inline__] = ACTIONS(2765),
    [anon_sym___forceinline] = ACTIONS(2765),
    [anon_sym_thread_local] = ACTIONS(2765),
    [anon_sym___thread] = ACTIONS(2765),
    [anon_sym_const] = ACTIONS(2765),
    [anon_sym_constexpr] = ACTIONS(2765),
    [anon_sym_volatile] = ACTIONS(2765),
    [anon_sym_restrict] = ACTIONS(2765),
    [anon_sym___restrict__] = ACTIONS(2765),
    [anon_sym__Atomic] = ACTIONS(2765),
    [anon_sym__Noreturn] = ACTIONS(2765),
    [anon_sym_noreturn] = ACTIONS(2765),
    [anon_sym_mutable] = ACTIONS(2765),
    [anon_sym_constinit] = ACTIONS(2765),
    [anon_sym_consteval] = ACTIONS(2765),
    [anon_sym_PROGMEM] = ACTIONS(2765),
    [aux_sym_primitive_type_token1] = ACTIONS(2765),
    [anon_sym_byte] = ACTIONS(2765),
    [anon_sym_word] = ACTIONS(2765),
    [anon_sym_enum] = ACTIONS(2765),
    [anon_sym_class] = ACTIONS(2765),
    [anon_sym_struct] = ACTIONS(2765),
    [anon_sym_union] = ACTIONS(2765),
    [anon_sym_if] = ACTIONS(2765),
    [anon_sym_else] = ACTIONS(2765),
    [anon_sym_switch] = ACTIONS(2765),
    [anon_sym_case] = ACTIONS(2765),
    [anon_sym_default] = ACTIONS(2765),
    [anon_sym_while] = ACTIONS(2765),
    [anon_sym_do] = ACTIONS(2765),
    [anon_sym_for] = ACTIONS(2765),
    [anon_sym_return] = ACTIONS(2765),
    [anon_sym_break] = ACTIONS(2765),
    [anon_sym_continue] = ACTIONS(2765),
    [anon_sym_goto] = ACTIONS(2765),
    [anon_sym___try] = ACTIONS(2765),
    [anon_sym___leave] = ACTIONS(2765),
    [anon_sym_not] = ACTIONS(2765),
    [anon_sym_compl] = ACTIONS(2765),
    [anon_sym_DASH_DASH] = ACTIONS(2767),
    [anon_sym_PLUS_PLUS] = ACTIONS(2767),
    [anon_sym_sizeof] = ACTIONS(2765),
    [anon_sym___alignof__] = ACTIONS(2765),
    [anon_sym___alignof] = ACTIONS(2765),
    [anon_sym__alignof] = ACTIONS(2765),
    [anon_sym_alignof] = ACTIONS(2765),
    [anon_sym__Alignof] = ACTIONS(2765),
    [anon_sym_offsetof] = ACTIONS(2765),
    [anon_sym__Generic] = ACTIONS(2765),
    [anon_sym_asm] = ACTIONS(2765),
    [anon_sym___asm__] = ACTIONS(2765),
    [aux_sym_number_literal_token1] = ACTIONS(2767),
    [aux_sym_number_literal_token2] = ACTIONS(2765),
    [anon_sym_L_SQUOTE] = ACTIONS(2767),
    [anon_sym_u_SQUOTE] = ACTIONS(2767),
    [anon_sym_U_SQUOTE] = ACTIONS(2767),
    [anon_sym_u8_SQUOTE] = ACTIONS(2767),
    [anon_sym_SQUOTE] = ACTIONS(2767),
    [anon_sym_L_DQUOTE] = ACTIONS(2767),
    [anon_sym_u_DQUOTE] = ACTIONS(2767),
    [anon_sym_U_DQUOTE] = ACTIONS(2767),
    [anon_sym_u8_DQUOTE] = ACTIONS(2767),
    [anon_sym_DQUOTE] = ACTIONS(2767),
    [sym_true] = ACTIONS(2765),
    [sym_false] = ACTIONS(2765),
    [anon_sym_NULL] = ACTIONS(2765),
    [anon_sym_nullptr] = ACTIONS(2765),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2765),
    [anon_sym_decltype] = ACTIONS(2765),
    [anon_sym_virtual] = ACTIONS(2765),
    [anon_sym_alignas] = ACTIONS(2765),
    [anon_sym_explicit] = ACTIONS(2765),
    [anon_sym_typename] = ACTIONS(2765),
    [anon_sym_template] = ACTIONS(2765),
    [anon_sym_operator] = ACTIONS(2765),
    [anon_sym_try] = ACTIONS(2765),
    [anon_sym_delete] = ACTIONS(2765),
    [anon_sym_throw] = ACTIONS(2765),
    [anon_sym_namespace] = ACTIONS(2765),
    [anon_sym_using] = ACTIONS(2765),
    [anon_sym_static_assert] = ACTIONS(2765),
    [anon_sym_concept] = ACTIONS(2765),
    [anon_sym_co_return] = ACTIONS(2765),
    [anon_sym_co_yield] = ACTIONS(2765),
    [anon_sym_R_DQUOTE] = ACTIONS(2767),
    [anon_sym_LR_DQUOTE] = ACTIONS(2767),
    [anon_sym_uR_DQUOTE] = ACTIONS(2767),
    [anon_sym_UR_DQUOTE] = ACTIONS(2767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2767),
    [anon_sym_co_await] = ACTIONS(2765),
    [anon_sym_new] = ACTIONS(2765),
    [anon_sym_requires] = ACTIONS(2765),
    [sym_this] = ACTIONS(2765),
  },
  [557] = {
    [sym_identifier] = ACTIONS(2761),
    [aux_sym_preproc_include_token1] = ACTIONS(2761),
    [aux_sym_preproc_def_token1] = ACTIONS(2761),
    [aux_sym_preproc_if_token1] = ACTIONS(2761),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2761),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2761),
    [sym_preproc_directive] = ACTIONS(2761),
    [anon_sym_LPAREN2] = ACTIONS(2763),
    [anon_sym_BANG] = ACTIONS(2763),
    [anon_sym_TILDE] = ACTIONS(2763),
    [anon_sym_DASH] = ACTIONS(2761),
    [anon_sym_PLUS] = ACTIONS(2761),
    [anon_sym_STAR] = ACTIONS(2763),
    [anon_sym_AMP_AMP] = ACTIONS(2763),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2763),
    [anon_sym___extension__] = ACTIONS(2761),
    [anon_sym_typedef] = ACTIONS(2761),
    [anon_sym_extern] = ACTIONS(2761),
    [anon_sym___attribute__] = ACTIONS(2761),
    [anon_sym_COLON_COLON] = ACTIONS(2763),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2763),
    [anon_sym___declspec] = ACTIONS(2761),
    [anon_sym___based] = ACTIONS(2761),
    [anon_sym___cdecl] = ACTIONS(2761),
    [anon_sym___clrcall] = ACTIONS(2761),
    [anon_sym___stdcall] = ACTIONS(2761),
    [anon_sym___fastcall] = ACTIONS(2761),
    [anon_sym___thiscall] = ACTIONS(2761),
    [anon_sym___vectorcall] = ACTIONS(2761),
    [anon_sym_LBRACE] = ACTIONS(2763),
    [anon_sym_RBRACE] = ACTIONS(2763),
    [anon_sym_signed] = ACTIONS(2761),
    [anon_sym_unsigned] = ACTIONS(2761),
    [anon_sym_long] = ACTIONS(2761),
    [anon_sym_short] = ACTIONS(2761),
    [anon_sym_LBRACK] = ACTIONS(2761),
    [anon_sym_static] = ACTIONS(2761),
    [anon_sym_register] = ACTIONS(2761),
    [anon_sym_inline] = ACTIONS(2761),
    [anon_sym___inline] = ACTIONS(2761),
    [anon_sym___inline__] = ACTIONS(2761),
    [anon_sym___forceinline] = ACTIONS(2761),
    [anon_sym_thread_local] = ACTIONS(2761),
    [anon_sym___thread] = ACTIONS(2761),
    [anon_sym_const] = ACTIONS(2761),
    [anon_sym_constexpr] = ACTIONS(2761),
    [anon_sym_volatile] = ACTIONS(2761),
    [anon_sym_restrict] = ACTIONS(2761),
    [anon_sym___restrict__] = ACTIONS(2761),
    [anon_sym__Atomic] = ACTIONS(2761),
    [anon_sym__Noreturn] = ACTIONS(2761),
    [anon_sym_noreturn] = ACTIONS(2761),
    [anon_sym_mutable] = ACTIONS(2761),
    [anon_sym_constinit] = ACTIONS(2761),
    [anon_sym_consteval] = ACTIONS(2761),
    [anon_sym_PROGMEM] = ACTIONS(2761),
    [aux_sym_primitive_type_token1] = ACTIONS(2761),
    [anon_sym_byte] = ACTIONS(2761),
    [anon_sym_word] = ACTIONS(2761),
    [anon_sym_enum] = ACTIONS(2761),
    [anon_sym_class] = ACTIONS(2761),
    [anon_sym_struct] = ACTIONS(2761),
    [anon_sym_union] = ACTIONS(2761),
    [anon_sym_if] = ACTIONS(2761),
    [anon_sym_else] = ACTIONS(2761),
    [anon_sym_switch] = ACTIONS(2761),
    [anon_sym_case] = ACTIONS(2761),
    [anon_sym_default] = ACTIONS(2761),
    [anon_sym_while] = ACTIONS(2761),
    [anon_sym_do] = ACTIONS(2761),
    [anon_sym_for] = ACTIONS(2761),
    [anon_sym_return] = ACTIONS(2761),
    [anon_sym_break] = ACTIONS(2761),
    [anon_sym_continue] = ACTIONS(2761),
    [anon_sym_goto] = ACTIONS(2761),
    [anon_sym___try] = ACTIONS(2761),
    [anon_sym___leave] = ACTIONS(2761),
    [anon_sym_not] = ACTIONS(2761),
    [anon_sym_compl] = ACTIONS(2761),
    [anon_sym_DASH_DASH] = ACTIONS(2763),
    [anon_sym_PLUS_PLUS] = ACTIONS(2763),
    [anon_sym_sizeof] = ACTIONS(2761),
    [anon_sym___alignof__] = ACTIONS(2761),
    [anon_sym___alignof] = ACTIONS(2761),
    [anon_sym__alignof] = ACTIONS(2761),
    [anon_sym_alignof] = ACTIONS(2761),
    [anon_sym__Alignof] = ACTIONS(2761),
    [anon_sym_offsetof] = ACTIONS(2761),
    [anon_sym__Generic] = ACTIONS(2761),
    [anon_sym_asm] = ACTIONS(2761),
    [anon_sym___asm__] = ACTIONS(2761),
    [aux_sym_number_literal_token1] = ACTIONS(2763),
    [aux_sym_number_literal_token2] = ACTIONS(2761),
    [anon_sym_L_SQUOTE] = ACTIONS(2763),
    [anon_sym_u_SQUOTE] = ACTIONS(2763),
    [anon_sym_U_SQUOTE] = ACTIONS(2763),
    [anon_sym_u8_SQUOTE] = ACTIONS(2763),
    [anon_sym_SQUOTE] = ACTIONS(2763),
    [anon_sym_L_DQUOTE] = ACTIONS(2763),
    [anon_sym_u_DQUOTE] = ACTIONS(2763),
    [anon_sym_U_DQUOTE] = ACTIONS(2763),
    [anon_sym_u8_DQUOTE] = ACTIONS(2763),
    [anon_sym_DQUOTE] = ACTIONS(2763),
    [sym_true] = ACTIONS(2761),
    [sym_false] = ACTIONS(2761),
    [anon_sym_NULL] = ACTIONS(2761),
    [anon_sym_nullptr] = ACTIONS(2761),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2761),
    [anon_sym_decltype] = ACTIONS(2761),
    [anon_sym_virtual] = ACTIONS(2761),
    [anon_sym_alignas] = ACTIONS(2761),
    [anon_sym_explicit] = ACTIONS(2761),
    [anon_sym_typename] = ACTIONS(2761),
    [anon_sym_template] = ACTIONS(2761),
    [anon_sym_operator] = ACTIONS(2761),
    [anon_sym_try] = ACTIONS(2761),
    [anon_sym_delete] = ACTIONS(2761),
    [anon_sym_throw] = ACTIONS(2761),
    [anon_sym_namespace] = ACTIONS(2761),
    [anon_sym_using] = ACTIONS(2761),
    [anon_sym_static_assert] = ACTIONS(2761),
    [anon_sym_concept] = ACTIONS(2761),
    [anon_sym_co_return] = ACTIONS(2761),
    [anon_sym_co_yield] = ACTIONS(2761),
    [anon_sym_R_DQUOTE] = ACTIONS(2763),
    [anon_sym_LR_DQUOTE] = ACTIONS(2763),
    [anon_sym_uR_DQUOTE] = ACTIONS(2763),
    [anon_sym_UR_DQUOTE] = ACTIONS(2763),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2763),
    [anon_sym_co_await] = ACTIONS(2761),
    [anon_sym_new] = ACTIONS(2761),
    [anon_sym_requires] = ACTIONS(2761),
    [sym_this] = ACTIONS(2761),
  },
  [558] = {
    [sym_identifier] = ACTIONS(2747),
    [aux_sym_preproc_include_token1] = ACTIONS(2747),
    [aux_sym_preproc_def_token1] = ACTIONS(2747),
    [aux_sym_preproc_if_token1] = ACTIONS(2747),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2747),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2747),
    [sym_preproc_directive] = ACTIONS(2747),
    [anon_sym_LPAREN2] = ACTIONS(2749),
    [anon_sym_BANG] = ACTIONS(2749),
    [anon_sym_TILDE] = ACTIONS(2749),
    [anon_sym_DASH] = ACTIONS(2747),
    [anon_sym_PLUS] = ACTIONS(2747),
    [anon_sym_STAR] = ACTIONS(2749),
    [anon_sym_AMP_AMP] = ACTIONS(2749),
    [anon_sym_AMP] = ACTIONS(2747),
    [anon_sym_SEMI] = ACTIONS(2749),
    [anon_sym___extension__] = ACTIONS(2747),
    [anon_sym_typedef] = ACTIONS(2747),
    [anon_sym_extern] = ACTIONS(2747),
    [anon_sym___attribute__] = ACTIONS(2747),
    [anon_sym_COLON_COLON] = ACTIONS(2749),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2749),
    [anon_sym___declspec] = ACTIONS(2747),
    [anon_sym___based] = ACTIONS(2747),
    [anon_sym___cdecl] = ACTIONS(2747),
    [anon_sym___clrcall] = ACTIONS(2747),
    [anon_sym___stdcall] = ACTIONS(2747),
    [anon_sym___fastcall] = ACTIONS(2747),
    [anon_sym___thiscall] = ACTIONS(2747),
    [anon_sym___vectorcall] = ACTIONS(2747),
    [anon_sym_LBRACE] = ACTIONS(2749),
    [anon_sym_RBRACE] = ACTIONS(2749),
    [anon_sym_signed] = ACTIONS(2747),
    [anon_sym_unsigned] = ACTIONS(2747),
    [anon_sym_long] = ACTIONS(2747),
    [anon_sym_short] = ACTIONS(2747),
    [anon_sym_LBRACK] = ACTIONS(2747),
    [anon_sym_static] = ACTIONS(2747),
    [anon_sym_register] = ACTIONS(2747),
    [anon_sym_inline] = ACTIONS(2747),
    [anon_sym___inline] = ACTIONS(2747),
    [anon_sym___inline__] = ACTIONS(2747),
    [anon_sym___forceinline] = ACTIONS(2747),
    [anon_sym_thread_local] = ACTIONS(2747),
    [anon_sym___thread] = ACTIONS(2747),
    [anon_sym_const] = ACTIONS(2747),
    [anon_sym_constexpr] = ACTIONS(2747),
    [anon_sym_volatile] = ACTIONS(2747),
    [anon_sym_restrict] = ACTIONS(2747),
    [anon_sym___restrict__] = ACTIONS(2747),
    [anon_sym__Atomic] = ACTIONS(2747),
    [anon_sym__Noreturn] = ACTIONS(2747),
    [anon_sym_noreturn] = ACTIONS(2747),
    [anon_sym_mutable] = ACTIONS(2747),
    [anon_sym_constinit] = ACTIONS(2747),
    [anon_sym_consteval] = ACTIONS(2747),
    [anon_sym_PROGMEM] = ACTIONS(2747),
    [aux_sym_primitive_type_token1] = ACTIONS(2747),
    [anon_sym_byte] = ACTIONS(2747),
    [anon_sym_word] = ACTIONS(2747),
    [anon_sym_enum] = ACTIONS(2747),
    [anon_sym_class] = ACTIONS(2747),
    [anon_sym_struct] = ACTIONS(2747),
    [anon_sym_union] = ACTIONS(2747),
    [anon_sym_if] = ACTIONS(2747),
    [anon_sym_else] = ACTIONS(2747),
    [anon_sym_switch] = ACTIONS(2747),
    [anon_sym_case] = ACTIONS(2747),
    [anon_sym_default] = ACTIONS(2747),
    [anon_sym_while] = ACTIONS(2747),
    [anon_sym_do] = ACTIONS(2747),
    [anon_sym_for] = ACTIONS(2747),
    [anon_sym_return] = ACTIONS(2747),
    [anon_sym_break] = ACTIONS(2747),
    [anon_sym_continue] = ACTIONS(2747),
    [anon_sym_goto] = ACTIONS(2747),
    [anon_sym___try] = ACTIONS(2747),
    [anon_sym___leave] = ACTIONS(2747),
    [anon_sym_not] = ACTIONS(2747),
    [anon_sym_compl] = ACTIONS(2747),
    [anon_sym_DASH_DASH] = ACTIONS(2749),
    [anon_sym_PLUS_PLUS] = ACTIONS(2749),
    [anon_sym_sizeof] = ACTIONS(2747),
    [anon_sym___alignof__] = ACTIONS(2747),
    [anon_sym___alignof] = ACTIONS(2747),
    [anon_sym__alignof] = ACTIONS(2747),
    [anon_sym_alignof] = ACTIONS(2747),
    [anon_sym__Alignof] = ACTIONS(2747),
    [anon_sym_offsetof] = ACTIONS(2747),
    [anon_sym__Generic] = ACTIONS(2747),
    [anon_sym_asm] = ACTIONS(2747),
    [anon_sym___asm__] = ACTIONS(2747),
    [aux_sym_number_literal_token1] = ACTIONS(2749),
    [aux_sym_number_literal_token2] = ACTIONS(2747),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2749),
    [anon_sym_u_DQUOTE] = ACTIONS(2749),
    [anon_sym_U_DQUOTE] = ACTIONS(2749),
    [anon_sym_u8_DQUOTE] = ACTIONS(2749),
    [anon_sym_DQUOTE] = ACTIONS(2749),
    [sym_true] = ACTIONS(2747),
    [sym_false] = ACTIONS(2747),
    [anon_sym_NULL] = ACTIONS(2747),
    [anon_sym_nullptr] = ACTIONS(2747),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2747),
    [anon_sym_decltype] = ACTIONS(2747),
    [anon_sym_virtual] = ACTIONS(2747),
    [anon_sym_alignas] = ACTIONS(2747),
    [anon_sym_explicit] = ACTIONS(2747),
    [anon_sym_typename] = ACTIONS(2747),
    [anon_sym_template] = ACTIONS(2747),
    [anon_sym_operator] = ACTIONS(2747),
    [anon_sym_try] = ACTIONS(2747),
    [anon_sym_delete] = ACTIONS(2747),
    [anon_sym_throw] = ACTIONS(2747),
    [anon_sym_namespace] = ACTIONS(2747),
    [anon_sym_using] = ACTIONS(2747),
    [anon_sym_static_assert] = ACTIONS(2747),
    [anon_sym_concept] = ACTIONS(2747),
    [anon_sym_co_return] = ACTIONS(2747),
    [anon_sym_co_yield] = ACTIONS(2747),
    [anon_sym_R_DQUOTE] = ACTIONS(2749),
    [anon_sym_LR_DQUOTE] = ACTIONS(2749),
    [anon_sym_uR_DQUOTE] = ACTIONS(2749),
    [anon_sym_UR_DQUOTE] = ACTIONS(2749),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2749),
    [anon_sym_co_await] = ACTIONS(2747),
    [anon_sym_new] = ACTIONS(2747),
    [anon_sym_requires] = ACTIONS(2747),
    [sym_this] = ACTIONS(2747),
  },
  [559] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_RBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [560] = {
    [ts_builtin_sym_end] = ACTIONS(2681),
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [561] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_RBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [562] = {
    [sym_identifier] = ACTIONS(2769),
    [aux_sym_preproc_include_token1] = ACTIONS(2769),
    [aux_sym_preproc_def_token1] = ACTIONS(2769),
    [aux_sym_preproc_if_token1] = ACTIONS(2769),
    [aux_sym_preproc_if_token2] = ACTIONS(2769),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2769),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2769),
    [sym_preproc_directive] = ACTIONS(2769),
    [anon_sym_LPAREN2] = ACTIONS(2771),
    [anon_sym_BANG] = ACTIONS(2771),
    [anon_sym_TILDE] = ACTIONS(2771),
    [anon_sym_DASH] = ACTIONS(2769),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_STAR] = ACTIONS(2771),
    [anon_sym_AMP_AMP] = ACTIONS(2771),
    [anon_sym_AMP] = ACTIONS(2769),
    [anon_sym_SEMI] = ACTIONS(2771),
    [anon_sym___extension__] = ACTIONS(2769),
    [anon_sym_typedef] = ACTIONS(2769),
    [anon_sym_extern] = ACTIONS(2769),
    [anon_sym___attribute__] = ACTIONS(2769),
    [anon_sym_COLON_COLON] = ACTIONS(2771),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2771),
    [anon_sym___declspec] = ACTIONS(2769),
    [anon_sym___based] = ACTIONS(2769),
    [anon_sym___cdecl] = ACTIONS(2769),
    [anon_sym___clrcall] = ACTIONS(2769),
    [anon_sym___stdcall] = ACTIONS(2769),
    [anon_sym___fastcall] = ACTIONS(2769),
    [anon_sym___thiscall] = ACTIONS(2769),
    [anon_sym___vectorcall] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(2771),
    [anon_sym_signed] = ACTIONS(2769),
    [anon_sym_unsigned] = ACTIONS(2769),
    [anon_sym_long] = ACTIONS(2769),
    [anon_sym_short] = ACTIONS(2769),
    [anon_sym_LBRACK] = ACTIONS(2769),
    [anon_sym_static] = ACTIONS(2769),
    [anon_sym_register] = ACTIONS(2769),
    [anon_sym_inline] = ACTIONS(2769),
    [anon_sym___inline] = ACTIONS(2769),
    [anon_sym___inline__] = ACTIONS(2769),
    [anon_sym___forceinline] = ACTIONS(2769),
    [anon_sym_thread_local] = ACTIONS(2769),
    [anon_sym___thread] = ACTIONS(2769),
    [anon_sym_const] = ACTIONS(2769),
    [anon_sym_constexpr] = ACTIONS(2769),
    [anon_sym_volatile] = ACTIONS(2769),
    [anon_sym_restrict] = ACTIONS(2769),
    [anon_sym___restrict__] = ACTIONS(2769),
    [anon_sym__Atomic] = ACTIONS(2769),
    [anon_sym__Noreturn] = ACTIONS(2769),
    [anon_sym_noreturn] = ACTIONS(2769),
    [anon_sym_mutable] = ACTIONS(2769),
    [anon_sym_constinit] = ACTIONS(2769),
    [anon_sym_consteval] = ACTIONS(2769),
    [anon_sym_PROGMEM] = ACTIONS(2769),
    [aux_sym_primitive_type_token1] = ACTIONS(2769),
    [anon_sym_byte] = ACTIONS(2769),
    [anon_sym_word] = ACTIONS(2769),
    [anon_sym_enum] = ACTIONS(2769),
    [anon_sym_class] = ACTIONS(2769),
    [anon_sym_struct] = ACTIONS(2769),
    [anon_sym_union] = ACTIONS(2769),
    [anon_sym_if] = ACTIONS(2769),
    [anon_sym_else] = ACTIONS(2769),
    [anon_sym_switch] = ACTIONS(2769),
    [anon_sym_case] = ACTIONS(2769),
    [anon_sym_default] = ACTIONS(2769),
    [anon_sym_while] = ACTIONS(2769),
    [anon_sym_do] = ACTIONS(2769),
    [anon_sym_for] = ACTIONS(2769),
    [anon_sym_return] = ACTIONS(2769),
    [anon_sym_break] = ACTIONS(2769),
    [anon_sym_continue] = ACTIONS(2769),
    [anon_sym_goto] = ACTIONS(2769),
    [anon_sym___try] = ACTIONS(2769),
    [anon_sym___leave] = ACTIONS(2769),
    [anon_sym_not] = ACTIONS(2769),
    [anon_sym_compl] = ACTIONS(2769),
    [anon_sym_DASH_DASH] = ACTIONS(2771),
    [anon_sym_PLUS_PLUS] = ACTIONS(2771),
    [anon_sym_sizeof] = ACTIONS(2769),
    [anon_sym___alignof__] = ACTIONS(2769),
    [anon_sym___alignof] = ACTIONS(2769),
    [anon_sym__alignof] = ACTIONS(2769),
    [anon_sym_alignof] = ACTIONS(2769),
    [anon_sym__Alignof] = ACTIONS(2769),
    [anon_sym_offsetof] = ACTIONS(2769),
    [anon_sym__Generic] = ACTIONS(2769),
    [anon_sym_asm] = ACTIONS(2769),
    [anon_sym___asm__] = ACTIONS(2769),
    [aux_sym_number_literal_token1] = ACTIONS(2771),
    [aux_sym_number_literal_token2] = ACTIONS(2769),
    [anon_sym_L_SQUOTE] = ACTIONS(2771),
    [anon_sym_u_SQUOTE] = ACTIONS(2771),
    [anon_sym_U_SQUOTE] = ACTIONS(2771),
    [anon_sym_u8_SQUOTE] = ACTIONS(2771),
    [anon_sym_SQUOTE] = ACTIONS(2771),
    [anon_sym_L_DQUOTE] = ACTIONS(2771),
    [anon_sym_u_DQUOTE] = ACTIONS(2771),
    [anon_sym_U_DQUOTE] = ACTIONS(2771),
    [anon_sym_u8_DQUOTE] = ACTIONS(2771),
    [anon_sym_DQUOTE] = ACTIONS(2771),
    [sym_true] = ACTIONS(2769),
    [sym_false] = ACTIONS(2769),
    [anon_sym_NULL] = ACTIONS(2769),
    [anon_sym_nullptr] = ACTIONS(2769),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2769),
    [anon_sym_decltype] = ACTIONS(2769),
    [anon_sym_virtual] = ACTIONS(2769),
    [anon_sym_alignas] = ACTIONS(2769),
    [anon_sym_explicit] = ACTIONS(2769),
    [anon_sym_typename] = ACTIONS(2769),
    [anon_sym_template] = ACTIONS(2769),
    [anon_sym_operator] = ACTIONS(2769),
    [anon_sym_try] = ACTIONS(2769),
    [anon_sym_delete] = ACTIONS(2769),
    [anon_sym_throw] = ACTIONS(2769),
    [anon_sym_namespace] = ACTIONS(2769),
    [anon_sym_using] = ACTIONS(2769),
    [anon_sym_static_assert] = ACTIONS(2769),
    [anon_sym_concept] = ACTIONS(2769),
    [anon_sym_co_return] = ACTIONS(2769),
    [anon_sym_co_yield] = ACTIONS(2769),
    [anon_sym_R_DQUOTE] = ACTIONS(2771),
    [anon_sym_LR_DQUOTE] = ACTIONS(2771),
    [anon_sym_uR_DQUOTE] = ACTIONS(2771),
    [anon_sym_UR_DQUOTE] = ACTIONS(2771),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2771),
    [anon_sym_co_await] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2769),
    [anon_sym_requires] = ACTIONS(2769),
    [sym_this] = ACTIONS(2769),
  },
  [563] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_RBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [564] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_RBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [565] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_RBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [566] = {
    [sym_identifier] = ACTIONS(2765),
    [aux_sym_preproc_include_token1] = ACTIONS(2765),
    [aux_sym_preproc_def_token1] = ACTIONS(2765),
    [aux_sym_preproc_if_token1] = ACTIONS(2765),
    [aux_sym_preproc_if_token2] = ACTIONS(2765),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2765),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2765),
    [sym_preproc_directive] = ACTIONS(2765),
    [anon_sym_LPAREN2] = ACTIONS(2767),
    [anon_sym_BANG] = ACTIONS(2767),
    [anon_sym_TILDE] = ACTIONS(2767),
    [anon_sym_DASH] = ACTIONS(2765),
    [anon_sym_PLUS] = ACTIONS(2765),
    [anon_sym_STAR] = ACTIONS(2767),
    [anon_sym_AMP_AMP] = ACTIONS(2767),
    [anon_sym_AMP] = ACTIONS(2765),
    [anon_sym_SEMI] = ACTIONS(2767),
    [anon_sym___extension__] = ACTIONS(2765),
    [anon_sym_typedef] = ACTIONS(2765),
    [anon_sym_extern] = ACTIONS(2765),
    [anon_sym___attribute__] = ACTIONS(2765),
    [anon_sym_COLON_COLON] = ACTIONS(2767),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2767),
    [anon_sym___declspec] = ACTIONS(2765),
    [anon_sym___based] = ACTIONS(2765),
    [anon_sym___cdecl] = ACTIONS(2765),
    [anon_sym___clrcall] = ACTIONS(2765),
    [anon_sym___stdcall] = ACTIONS(2765),
    [anon_sym___fastcall] = ACTIONS(2765),
    [anon_sym___thiscall] = ACTIONS(2765),
    [anon_sym___vectorcall] = ACTIONS(2765),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_signed] = ACTIONS(2765),
    [anon_sym_unsigned] = ACTIONS(2765),
    [anon_sym_long] = ACTIONS(2765),
    [anon_sym_short] = ACTIONS(2765),
    [anon_sym_LBRACK] = ACTIONS(2765),
    [anon_sym_static] = ACTIONS(2765),
    [anon_sym_register] = ACTIONS(2765),
    [anon_sym_inline] = ACTIONS(2765),
    [anon_sym___inline] = ACTIONS(2765),
    [anon_sym___inline__] = ACTIONS(2765),
    [anon_sym___forceinline] = ACTIONS(2765),
    [anon_sym_thread_local] = ACTIONS(2765),
    [anon_sym___thread] = ACTIONS(2765),
    [anon_sym_const] = ACTIONS(2765),
    [anon_sym_constexpr] = ACTIONS(2765),
    [anon_sym_volatile] = ACTIONS(2765),
    [anon_sym_restrict] = ACTIONS(2765),
    [anon_sym___restrict__] = ACTIONS(2765),
    [anon_sym__Atomic] = ACTIONS(2765),
    [anon_sym__Noreturn] = ACTIONS(2765),
    [anon_sym_noreturn] = ACTIONS(2765),
    [anon_sym_mutable] = ACTIONS(2765),
    [anon_sym_constinit] = ACTIONS(2765),
    [anon_sym_consteval] = ACTIONS(2765),
    [anon_sym_PROGMEM] = ACTIONS(2765),
    [aux_sym_primitive_type_token1] = ACTIONS(2765),
    [anon_sym_byte] = ACTIONS(2765),
    [anon_sym_word] = ACTIONS(2765),
    [anon_sym_enum] = ACTIONS(2765),
    [anon_sym_class] = ACTIONS(2765),
    [anon_sym_struct] = ACTIONS(2765),
    [anon_sym_union] = ACTIONS(2765),
    [anon_sym_if] = ACTIONS(2765),
    [anon_sym_else] = ACTIONS(2765),
    [anon_sym_switch] = ACTIONS(2765),
    [anon_sym_case] = ACTIONS(2765),
    [anon_sym_default] = ACTIONS(2765),
    [anon_sym_while] = ACTIONS(2765),
    [anon_sym_do] = ACTIONS(2765),
    [anon_sym_for] = ACTIONS(2765),
    [anon_sym_return] = ACTIONS(2765),
    [anon_sym_break] = ACTIONS(2765),
    [anon_sym_continue] = ACTIONS(2765),
    [anon_sym_goto] = ACTIONS(2765),
    [anon_sym___try] = ACTIONS(2765),
    [anon_sym___leave] = ACTIONS(2765),
    [anon_sym_not] = ACTIONS(2765),
    [anon_sym_compl] = ACTIONS(2765),
    [anon_sym_DASH_DASH] = ACTIONS(2767),
    [anon_sym_PLUS_PLUS] = ACTIONS(2767),
    [anon_sym_sizeof] = ACTIONS(2765),
    [anon_sym___alignof__] = ACTIONS(2765),
    [anon_sym___alignof] = ACTIONS(2765),
    [anon_sym__alignof] = ACTIONS(2765),
    [anon_sym_alignof] = ACTIONS(2765),
    [anon_sym__Alignof] = ACTIONS(2765),
    [anon_sym_offsetof] = ACTIONS(2765),
    [anon_sym__Generic] = ACTIONS(2765),
    [anon_sym_asm] = ACTIONS(2765),
    [anon_sym___asm__] = ACTIONS(2765),
    [aux_sym_number_literal_token1] = ACTIONS(2767),
    [aux_sym_number_literal_token2] = ACTIONS(2765),
    [anon_sym_L_SQUOTE] = ACTIONS(2767),
    [anon_sym_u_SQUOTE] = ACTIONS(2767),
    [anon_sym_U_SQUOTE] = ACTIONS(2767),
    [anon_sym_u8_SQUOTE] = ACTIONS(2767),
    [anon_sym_SQUOTE] = ACTIONS(2767),
    [anon_sym_L_DQUOTE] = ACTIONS(2767),
    [anon_sym_u_DQUOTE] = ACTIONS(2767),
    [anon_sym_U_DQUOTE] = ACTIONS(2767),
    [anon_sym_u8_DQUOTE] = ACTIONS(2767),
    [anon_sym_DQUOTE] = ACTIONS(2767),
    [sym_true] = ACTIONS(2765),
    [sym_false] = ACTIONS(2765),
    [anon_sym_NULL] = ACTIONS(2765),
    [anon_sym_nullptr] = ACTIONS(2765),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2765),
    [anon_sym_decltype] = ACTIONS(2765),
    [anon_sym_virtual] = ACTIONS(2765),
    [anon_sym_alignas] = ACTIONS(2765),
    [anon_sym_explicit] = ACTIONS(2765),
    [anon_sym_typename] = ACTIONS(2765),
    [anon_sym_template] = ACTIONS(2765),
    [anon_sym_operator] = ACTIONS(2765),
    [anon_sym_try] = ACTIONS(2765),
    [anon_sym_delete] = ACTIONS(2765),
    [anon_sym_throw] = ACTIONS(2765),
    [anon_sym_namespace] = ACTIONS(2765),
    [anon_sym_using] = ACTIONS(2765),
    [anon_sym_static_assert] = ACTIONS(2765),
    [anon_sym_concept] = ACTIONS(2765),
    [anon_sym_co_return] = ACTIONS(2765),
    [anon_sym_co_yield] = ACTIONS(2765),
    [anon_sym_R_DQUOTE] = ACTIONS(2767),
    [anon_sym_LR_DQUOTE] = ACTIONS(2767),
    [anon_sym_uR_DQUOTE] = ACTIONS(2767),
    [anon_sym_UR_DQUOTE] = ACTIONS(2767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2767),
    [anon_sym_co_await] = ACTIONS(2765),
    [anon_sym_new] = ACTIONS(2765),
    [anon_sym_requires] = ACTIONS(2765),
    [sym_this] = ACTIONS(2765),
  },
  [567] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_RBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [568] = {
    [ts_builtin_sym_end] = ACTIONS(2667),
    [sym_identifier] = ACTIONS(2665),
    [aux_sym_preproc_include_token1] = ACTIONS(2665),
    [aux_sym_preproc_def_token1] = ACTIONS(2665),
    [aux_sym_preproc_if_token1] = ACTIONS(2665),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2665),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2665),
    [sym_preproc_directive] = ACTIONS(2665),
    [anon_sym_LPAREN2] = ACTIONS(2667),
    [anon_sym_BANG] = ACTIONS(2667),
    [anon_sym_TILDE] = ACTIONS(2667),
    [anon_sym_DASH] = ACTIONS(2665),
    [anon_sym_PLUS] = ACTIONS(2665),
    [anon_sym_STAR] = ACTIONS(2667),
    [anon_sym_AMP_AMP] = ACTIONS(2667),
    [anon_sym_AMP] = ACTIONS(2665),
    [anon_sym_SEMI] = ACTIONS(2667),
    [anon_sym___extension__] = ACTIONS(2665),
    [anon_sym_typedef] = ACTIONS(2665),
    [anon_sym_extern] = ACTIONS(2665),
    [anon_sym___attribute__] = ACTIONS(2665),
    [anon_sym_COLON_COLON] = ACTIONS(2667),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2667),
    [anon_sym___declspec] = ACTIONS(2665),
    [anon_sym___based] = ACTIONS(2665),
    [anon_sym___cdecl] = ACTIONS(2665),
    [anon_sym___clrcall] = ACTIONS(2665),
    [anon_sym___stdcall] = ACTIONS(2665),
    [anon_sym___fastcall] = ACTIONS(2665),
    [anon_sym___thiscall] = ACTIONS(2665),
    [anon_sym___vectorcall] = ACTIONS(2665),
    [anon_sym_LBRACE] = ACTIONS(2667),
    [anon_sym_signed] = ACTIONS(2665),
    [anon_sym_unsigned] = ACTIONS(2665),
    [anon_sym_long] = ACTIONS(2665),
    [anon_sym_short] = ACTIONS(2665),
    [anon_sym_LBRACK] = ACTIONS(2665),
    [anon_sym_static] = ACTIONS(2665),
    [anon_sym_register] = ACTIONS(2665),
    [anon_sym_inline] = ACTIONS(2665),
    [anon_sym___inline] = ACTIONS(2665),
    [anon_sym___inline__] = ACTIONS(2665),
    [anon_sym___forceinline] = ACTIONS(2665),
    [anon_sym_thread_local] = ACTIONS(2665),
    [anon_sym___thread] = ACTIONS(2665),
    [anon_sym_const] = ACTIONS(2665),
    [anon_sym_constexpr] = ACTIONS(2665),
    [anon_sym_volatile] = ACTIONS(2665),
    [anon_sym_restrict] = ACTIONS(2665),
    [anon_sym___restrict__] = ACTIONS(2665),
    [anon_sym__Atomic] = ACTIONS(2665),
    [anon_sym__Noreturn] = ACTIONS(2665),
    [anon_sym_noreturn] = ACTIONS(2665),
    [anon_sym_mutable] = ACTIONS(2665),
    [anon_sym_constinit] = ACTIONS(2665),
    [anon_sym_consteval] = ACTIONS(2665),
    [anon_sym_PROGMEM] = ACTIONS(2665),
    [aux_sym_primitive_type_token1] = ACTIONS(2665),
    [anon_sym_byte] = ACTIONS(2665),
    [anon_sym_word] = ACTIONS(2665),
    [anon_sym_enum] = ACTIONS(2665),
    [anon_sym_class] = ACTIONS(2665),
    [anon_sym_struct] = ACTIONS(2665),
    [anon_sym_union] = ACTIONS(2665),
    [anon_sym_if] = ACTIONS(2665),
    [anon_sym_else] = ACTIONS(2665),
    [anon_sym_switch] = ACTIONS(2665),
    [anon_sym_case] = ACTIONS(2665),
    [anon_sym_default] = ACTIONS(2665),
    [anon_sym_while] = ACTIONS(2665),
    [anon_sym_do] = ACTIONS(2665),
    [anon_sym_for] = ACTIONS(2665),
    [anon_sym_return] = ACTIONS(2665),
    [anon_sym_break] = ACTIONS(2665),
    [anon_sym_continue] = ACTIONS(2665),
    [anon_sym_goto] = ACTIONS(2665),
    [anon_sym___try] = ACTIONS(2665),
    [anon_sym___leave] = ACTIONS(2665),
    [anon_sym_not] = ACTIONS(2665),
    [anon_sym_compl] = ACTIONS(2665),
    [anon_sym_DASH_DASH] = ACTIONS(2667),
    [anon_sym_PLUS_PLUS] = ACTIONS(2667),
    [anon_sym_sizeof] = ACTIONS(2665),
    [anon_sym___alignof__] = ACTIONS(2665),
    [anon_sym___alignof] = ACTIONS(2665),
    [anon_sym__alignof] = ACTIONS(2665),
    [anon_sym_alignof] = ACTIONS(2665),
    [anon_sym__Alignof] = ACTIONS(2665),
    [anon_sym_offsetof] = ACTIONS(2665),
    [anon_sym__Generic] = ACTIONS(2665),
    [anon_sym_asm] = ACTIONS(2665),
    [anon_sym___asm__] = ACTIONS(2665),
    [aux_sym_number_literal_token1] = ACTIONS(2667),
    [aux_sym_number_literal_token2] = ACTIONS(2665),
    [anon_sym_L_SQUOTE] = ACTIONS(2667),
    [anon_sym_u_SQUOTE] = ACTIONS(2667),
    [anon_sym_U_SQUOTE] = ACTIONS(2667),
    [anon_sym_u8_SQUOTE] = ACTIONS(2667),
    [anon_sym_SQUOTE] = ACTIONS(2667),
    [anon_sym_L_DQUOTE] = ACTIONS(2667),
    [anon_sym_u_DQUOTE] = ACTIONS(2667),
    [anon_sym_U_DQUOTE] = ACTIONS(2667),
    [anon_sym_u8_DQUOTE] = ACTIONS(2667),
    [anon_sym_DQUOTE] = ACTIONS(2667),
    [sym_true] = ACTIONS(2665),
    [sym_false] = ACTIONS(2665),
    [anon_sym_NULL] = ACTIONS(2665),
    [anon_sym_nullptr] = ACTIONS(2665),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2665),
    [anon_sym_decltype] = ACTIONS(2665),
    [anon_sym_virtual] = ACTIONS(2665),
    [anon_sym_alignas] = ACTIONS(2665),
    [anon_sym_explicit] = ACTIONS(2665),
    [anon_sym_typename] = ACTIONS(2665),
    [anon_sym_template] = ACTIONS(2665),
    [anon_sym_operator] = ACTIONS(2665),
    [anon_sym_try] = ACTIONS(2665),
    [anon_sym_delete] = ACTIONS(2665),
    [anon_sym_throw] = ACTIONS(2665),
    [anon_sym_namespace] = ACTIONS(2665),
    [anon_sym_using] = ACTIONS(2665),
    [anon_sym_static_assert] = ACTIONS(2665),
    [anon_sym_concept] = ACTIONS(2665),
    [anon_sym_co_return] = ACTIONS(2665),
    [anon_sym_co_yield] = ACTIONS(2665),
    [anon_sym_R_DQUOTE] = ACTIONS(2667),
    [anon_sym_LR_DQUOTE] = ACTIONS(2667),
    [anon_sym_uR_DQUOTE] = ACTIONS(2667),
    [anon_sym_UR_DQUOTE] = ACTIONS(2667),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2667),
    [anon_sym_co_await] = ACTIONS(2665),
    [anon_sym_new] = ACTIONS(2665),
    [anon_sym_requires] = ACTIONS(2665),
    [sym_this] = ACTIONS(2665),
  },
  [569] = {
    [sym_identifier] = ACTIONS(2761),
    [aux_sym_preproc_include_token1] = ACTIONS(2761),
    [aux_sym_preproc_def_token1] = ACTIONS(2761),
    [aux_sym_preproc_if_token1] = ACTIONS(2761),
    [aux_sym_preproc_if_token2] = ACTIONS(2761),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2761),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2761),
    [sym_preproc_directive] = ACTIONS(2761),
    [anon_sym_LPAREN2] = ACTIONS(2763),
    [anon_sym_BANG] = ACTIONS(2763),
    [anon_sym_TILDE] = ACTIONS(2763),
    [anon_sym_DASH] = ACTIONS(2761),
    [anon_sym_PLUS] = ACTIONS(2761),
    [anon_sym_STAR] = ACTIONS(2763),
    [anon_sym_AMP_AMP] = ACTIONS(2763),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2763),
    [anon_sym___extension__] = ACTIONS(2761),
    [anon_sym_typedef] = ACTIONS(2761),
    [anon_sym_extern] = ACTIONS(2761),
    [anon_sym___attribute__] = ACTIONS(2761),
    [anon_sym_COLON_COLON] = ACTIONS(2763),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2763),
    [anon_sym___declspec] = ACTIONS(2761),
    [anon_sym___based] = ACTIONS(2761),
    [anon_sym___cdecl] = ACTIONS(2761),
    [anon_sym___clrcall] = ACTIONS(2761),
    [anon_sym___stdcall] = ACTIONS(2761),
    [anon_sym___fastcall] = ACTIONS(2761),
    [anon_sym___thiscall] = ACTIONS(2761),
    [anon_sym___vectorcall] = ACTIONS(2761),
    [anon_sym_LBRACE] = ACTIONS(2763),
    [anon_sym_signed] = ACTIONS(2761),
    [anon_sym_unsigned] = ACTIONS(2761),
    [anon_sym_long] = ACTIONS(2761),
    [anon_sym_short] = ACTIONS(2761),
    [anon_sym_LBRACK] = ACTIONS(2761),
    [anon_sym_static] = ACTIONS(2761),
    [anon_sym_register] = ACTIONS(2761),
    [anon_sym_inline] = ACTIONS(2761),
    [anon_sym___inline] = ACTIONS(2761),
    [anon_sym___inline__] = ACTIONS(2761),
    [anon_sym___forceinline] = ACTIONS(2761),
    [anon_sym_thread_local] = ACTIONS(2761),
    [anon_sym___thread] = ACTIONS(2761),
    [anon_sym_const] = ACTIONS(2761),
    [anon_sym_constexpr] = ACTIONS(2761),
    [anon_sym_volatile] = ACTIONS(2761),
    [anon_sym_restrict] = ACTIONS(2761),
    [anon_sym___restrict__] = ACTIONS(2761),
    [anon_sym__Atomic] = ACTIONS(2761),
    [anon_sym__Noreturn] = ACTIONS(2761),
    [anon_sym_noreturn] = ACTIONS(2761),
    [anon_sym_mutable] = ACTIONS(2761),
    [anon_sym_constinit] = ACTIONS(2761),
    [anon_sym_consteval] = ACTIONS(2761),
    [anon_sym_PROGMEM] = ACTIONS(2761),
    [aux_sym_primitive_type_token1] = ACTIONS(2761),
    [anon_sym_byte] = ACTIONS(2761),
    [anon_sym_word] = ACTIONS(2761),
    [anon_sym_enum] = ACTIONS(2761),
    [anon_sym_class] = ACTIONS(2761),
    [anon_sym_struct] = ACTIONS(2761),
    [anon_sym_union] = ACTIONS(2761),
    [anon_sym_if] = ACTIONS(2761),
    [anon_sym_else] = ACTIONS(2761),
    [anon_sym_switch] = ACTIONS(2761),
    [anon_sym_case] = ACTIONS(2761),
    [anon_sym_default] = ACTIONS(2761),
    [anon_sym_while] = ACTIONS(2761),
    [anon_sym_do] = ACTIONS(2761),
    [anon_sym_for] = ACTIONS(2761),
    [anon_sym_return] = ACTIONS(2761),
    [anon_sym_break] = ACTIONS(2761),
    [anon_sym_continue] = ACTIONS(2761),
    [anon_sym_goto] = ACTIONS(2761),
    [anon_sym___try] = ACTIONS(2761),
    [anon_sym___leave] = ACTIONS(2761),
    [anon_sym_not] = ACTIONS(2761),
    [anon_sym_compl] = ACTIONS(2761),
    [anon_sym_DASH_DASH] = ACTIONS(2763),
    [anon_sym_PLUS_PLUS] = ACTIONS(2763),
    [anon_sym_sizeof] = ACTIONS(2761),
    [anon_sym___alignof__] = ACTIONS(2761),
    [anon_sym___alignof] = ACTIONS(2761),
    [anon_sym__alignof] = ACTIONS(2761),
    [anon_sym_alignof] = ACTIONS(2761),
    [anon_sym__Alignof] = ACTIONS(2761),
    [anon_sym_offsetof] = ACTIONS(2761),
    [anon_sym__Generic] = ACTIONS(2761),
    [anon_sym_asm] = ACTIONS(2761),
    [anon_sym___asm__] = ACTIONS(2761),
    [aux_sym_number_literal_token1] = ACTIONS(2763),
    [aux_sym_number_literal_token2] = ACTIONS(2761),
    [anon_sym_L_SQUOTE] = ACTIONS(2763),
    [anon_sym_u_SQUOTE] = ACTIONS(2763),
    [anon_sym_U_SQUOTE] = ACTIONS(2763),
    [anon_sym_u8_SQUOTE] = ACTIONS(2763),
    [anon_sym_SQUOTE] = ACTIONS(2763),
    [anon_sym_L_DQUOTE] = ACTIONS(2763),
    [anon_sym_u_DQUOTE] = ACTIONS(2763),
    [anon_sym_U_DQUOTE] = ACTIONS(2763),
    [anon_sym_u8_DQUOTE] = ACTIONS(2763),
    [anon_sym_DQUOTE] = ACTIONS(2763),
    [sym_true] = ACTIONS(2761),
    [sym_false] = ACTIONS(2761),
    [anon_sym_NULL] = ACTIONS(2761),
    [anon_sym_nullptr] = ACTIONS(2761),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2761),
    [anon_sym_decltype] = ACTIONS(2761),
    [anon_sym_virtual] = ACTIONS(2761),
    [anon_sym_alignas] = ACTIONS(2761),
    [anon_sym_explicit] = ACTIONS(2761),
    [anon_sym_typename] = ACTIONS(2761),
    [anon_sym_template] = ACTIONS(2761),
    [anon_sym_operator] = ACTIONS(2761),
    [anon_sym_try] = ACTIONS(2761),
    [anon_sym_delete] = ACTIONS(2761),
    [anon_sym_throw] = ACTIONS(2761),
    [anon_sym_namespace] = ACTIONS(2761),
    [anon_sym_using] = ACTIONS(2761),
    [anon_sym_static_assert] = ACTIONS(2761),
    [anon_sym_concept] = ACTIONS(2761),
    [anon_sym_co_return] = ACTIONS(2761),
    [anon_sym_co_yield] = ACTIONS(2761),
    [anon_sym_R_DQUOTE] = ACTIONS(2763),
    [anon_sym_LR_DQUOTE] = ACTIONS(2763),
    [anon_sym_uR_DQUOTE] = ACTIONS(2763),
    [anon_sym_UR_DQUOTE] = ACTIONS(2763),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2763),
    [anon_sym_co_await] = ACTIONS(2761),
    [anon_sym_new] = ACTIONS(2761),
    [anon_sym_requires] = ACTIONS(2761),
    [sym_this] = ACTIONS(2761),
  },
  [570] = {
    [ts_builtin_sym_end] = ACTIONS(2689),
    [sym_identifier] = ACTIONS(2687),
    [aux_sym_preproc_include_token1] = ACTIONS(2687),
    [aux_sym_preproc_def_token1] = ACTIONS(2687),
    [aux_sym_preproc_if_token1] = ACTIONS(2687),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2687),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2687),
    [sym_preproc_directive] = ACTIONS(2687),
    [anon_sym_LPAREN2] = ACTIONS(2689),
    [anon_sym_BANG] = ACTIONS(2689),
    [anon_sym_TILDE] = ACTIONS(2689),
    [anon_sym_DASH] = ACTIONS(2687),
    [anon_sym_PLUS] = ACTIONS(2687),
    [anon_sym_STAR] = ACTIONS(2689),
    [anon_sym_AMP_AMP] = ACTIONS(2689),
    [anon_sym_AMP] = ACTIONS(2687),
    [anon_sym_SEMI] = ACTIONS(2689),
    [anon_sym___extension__] = ACTIONS(2687),
    [anon_sym_typedef] = ACTIONS(2687),
    [anon_sym_extern] = ACTIONS(2687),
    [anon_sym___attribute__] = ACTIONS(2687),
    [anon_sym_COLON_COLON] = ACTIONS(2689),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2689),
    [anon_sym___declspec] = ACTIONS(2687),
    [anon_sym___based] = ACTIONS(2687),
    [anon_sym___cdecl] = ACTIONS(2687),
    [anon_sym___clrcall] = ACTIONS(2687),
    [anon_sym___stdcall] = ACTIONS(2687),
    [anon_sym___fastcall] = ACTIONS(2687),
    [anon_sym___thiscall] = ACTIONS(2687),
    [anon_sym___vectorcall] = ACTIONS(2687),
    [anon_sym_LBRACE] = ACTIONS(2689),
    [anon_sym_signed] = ACTIONS(2687),
    [anon_sym_unsigned] = ACTIONS(2687),
    [anon_sym_long] = ACTIONS(2687),
    [anon_sym_short] = ACTIONS(2687),
    [anon_sym_LBRACK] = ACTIONS(2687),
    [anon_sym_static] = ACTIONS(2687),
    [anon_sym_register] = ACTIONS(2687),
    [anon_sym_inline] = ACTIONS(2687),
    [anon_sym___inline] = ACTIONS(2687),
    [anon_sym___inline__] = ACTIONS(2687),
    [anon_sym___forceinline] = ACTIONS(2687),
    [anon_sym_thread_local] = ACTIONS(2687),
    [anon_sym___thread] = ACTIONS(2687),
    [anon_sym_const] = ACTIONS(2687),
    [anon_sym_constexpr] = ACTIONS(2687),
    [anon_sym_volatile] = ACTIONS(2687),
    [anon_sym_restrict] = ACTIONS(2687),
    [anon_sym___restrict__] = ACTIONS(2687),
    [anon_sym__Atomic] = ACTIONS(2687),
    [anon_sym__Noreturn] = ACTIONS(2687),
    [anon_sym_noreturn] = ACTIONS(2687),
    [anon_sym_mutable] = ACTIONS(2687),
    [anon_sym_constinit] = ACTIONS(2687),
    [anon_sym_consteval] = ACTIONS(2687),
    [anon_sym_PROGMEM] = ACTIONS(2687),
    [aux_sym_primitive_type_token1] = ACTIONS(2687),
    [anon_sym_byte] = ACTIONS(2687),
    [anon_sym_word] = ACTIONS(2687),
    [anon_sym_enum] = ACTIONS(2687),
    [anon_sym_class] = ACTIONS(2687),
    [anon_sym_struct] = ACTIONS(2687),
    [anon_sym_union] = ACTIONS(2687),
    [anon_sym_if] = ACTIONS(2687),
    [anon_sym_else] = ACTIONS(2687),
    [anon_sym_switch] = ACTIONS(2687),
    [anon_sym_case] = ACTIONS(2687),
    [anon_sym_default] = ACTIONS(2687),
    [anon_sym_while] = ACTIONS(2687),
    [anon_sym_do] = ACTIONS(2687),
    [anon_sym_for] = ACTIONS(2687),
    [anon_sym_return] = ACTIONS(2687),
    [anon_sym_break] = ACTIONS(2687),
    [anon_sym_continue] = ACTIONS(2687),
    [anon_sym_goto] = ACTIONS(2687),
    [anon_sym___try] = ACTIONS(2687),
    [anon_sym___leave] = ACTIONS(2687),
    [anon_sym_not] = ACTIONS(2687),
    [anon_sym_compl] = ACTIONS(2687),
    [anon_sym_DASH_DASH] = ACTIONS(2689),
    [anon_sym_PLUS_PLUS] = ACTIONS(2689),
    [anon_sym_sizeof] = ACTIONS(2687),
    [anon_sym___alignof__] = ACTIONS(2687),
    [anon_sym___alignof] = ACTIONS(2687),
    [anon_sym__alignof] = ACTIONS(2687),
    [anon_sym_alignof] = ACTIONS(2687),
    [anon_sym__Alignof] = ACTIONS(2687),
    [anon_sym_offsetof] = ACTIONS(2687),
    [anon_sym__Generic] = ACTIONS(2687),
    [anon_sym_asm] = ACTIONS(2687),
    [anon_sym___asm__] = ACTIONS(2687),
    [aux_sym_number_literal_token1] = ACTIONS(2689),
    [aux_sym_number_literal_token2] = ACTIONS(2687),
    [anon_sym_L_SQUOTE] = ACTIONS(2689),
    [anon_sym_u_SQUOTE] = ACTIONS(2689),
    [anon_sym_U_SQUOTE] = ACTIONS(2689),
    [anon_sym_u8_SQUOTE] = ACTIONS(2689),
    [anon_sym_SQUOTE] = ACTIONS(2689),
    [anon_sym_L_DQUOTE] = ACTIONS(2689),
    [anon_sym_u_DQUOTE] = ACTIONS(2689),
    [anon_sym_U_DQUOTE] = ACTIONS(2689),
    [anon_sym_u8_DQUOTE] = ACTIONS(2689),
    [anon_sym_DQUOTE] = ACTIONS(2689),
    [sym_true] = ACTIONS(2687),
    [sym_false] = ACTIONS(2687),
    [anon_sym_NULL] = ACTIONS(2687),
    [anon_sym_nullptr] = ACTIONS(2687),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2687),
    [anon_sym_decltype] = ACTIONS(2687),
    [anon_sym_virtual] = ACTIONS(2687),
    [anon_sym_alignas] = ACTIONS(2687),
    [anon_sym_explicit] = ACTIONS(2687),
    [anon_sym_typename] = ACTIONS(2687),
    [anon_sym_template] = ACTIONS(2687),
    [anon_sym_operator] = ACTIONS(2687),
    [anon_sym_try] = ACTIONS(2687),
    [anon_sym_delete] = ACTIONS(2687),
    [anon_sym_throw] = ACTIONS(2687),
    [anon_sym_namespace] = ACTIONS(2687),
    [anon_sym_using] = ACTIONS(2687),
    [anon_sym_static_assert] = ACTIONS(2687),
    [anon_sym_concept] = ACTIONS(2687),
    [anon_sym_co_return] = ACTIONS(2687),
    [anon_sym_co_yield] = ACTIONS(2687),
    [anon_sym_R_DQUOTE] = ACTIONS(2689),
    [anon_sym_LR_DQUOTE] = ACTIONS(2689),
    [anon_sym_uR_DQUOTE] = ACTIONS(2689),
    [anon_sym_UR_DQUOTE] = ACTIONS(2689),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2689),
    [anon_sym_co_await] = ACTIONS(2687),
    [anon_sym_new] = ACTIONS(2687),
    [anon_sym_requires] = ACTIONS(2687),
    [sym_this] = ACTIONS(2687),
  },
  [571] = {
    [ts_builtin_sym_end] = ACTIONS(2645),
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [572] = {
    [ts_builtin_sym_end] = ACTIONS(2681),
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [573] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_RBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [574] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token2] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [575] = {
    [ts_builtin_sym_end] = ACTIONS(2693),
    [sym_identifier] = ACTIONS(2691),
    [aux_sym_preproc_include_token1] = ACTIONS(2691),
    [aux_sym_preproc_def_token1] = ACTIONS(2691),
    [aux_sym_preproc_if_token1] = ACTIONS(2691),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2691),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2691),
    [sym_preproc_directive] = ACTIONS(2691),
    [anon_sym_LPAREN2] = ACTIONS(2693),
    [anon_sym_BANG] = ACTIONS(2693),
    [anon_sym_TILDE] = ACTIONS(2693),
    [anon_sym_DASH] = ACTIONS(2691),
    [anon_sym_PLUS] = ACTIONS(2691),
    [anon_sym_STAR] = ACTIONS(2693),
    [anon_sym_AMP_AMP] = ACTIONS(2693),
    [anon_sym_AMP] = ACTIONS(2691),
    [anon_sym_SEMI] = ACTIONS(2693),
    [anon_sym___extension__] = ACTIONS(2691),
    [anon_sym_typedef] = ACTIONS(2691),
    [anon_sym_extern] = ACTIONS(2691),
    [anon_sym___attribute__] = ACTIONS(2691),
    [anon_sym_COLON_COLON] = ACTIONS(2693),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2693),
    [anon_sym___declspec] = ACTIONS(2691),
    [anon_sym___based] = ACTIONS(2691),
    [anon_sym___cdecl] = ACTIONS(2691),
    [anon_sym___clrcall] = ACTIONS(2691),
    [anon_sym___stdcall] = ACTIONS(2691),
    [anon_sym___fastcall] = ACTIONS(2691),
    [anon_sym___thiscall] = ACTIONS(2691),
    [anon_sym___vectorcall] = ACTIONS(2691),
    [anon_sym_LBRACE] = ACTIONS(2693),
    [anon_sym_signed] = ACTIONS(2691),
    [anon_sym_unsigned] = ACTIONS(2691),
    [anon_sym_long] = ACTIONS(2691),
    [anon_sym_short] = ACTIONS(2691),
    [anon_sym_LBRACK] = ACTIONS(2691),
    [anon_sym_static] = ACTIONS(2691),
    [anon_sym_register] = ACTIONS(2691),
    [anon_sym_inline] = ACTIONS(2691),
    [anon_sym___inline] = ACTIONS(2691),
    [anon_sym___inline__] = ACTIONS(2691),
    [anon_sym___forceinline] = ACTIONS(2691),
    [anon_sym_thread_local] = ACTIONS(2691),
    [anon_sym___thread] = ACTIONS(2691),
    [anon_sym_const] = ACTIONS(2691),
    [anon_sym_constexpr] = ACTIONS(2691),
    [anon_sym_volatile] = ACTIONS(2691),
    [anon_sym_restrict] = ACTIONS(2691),
    [anon_sym___restrict__] = ACTIONS(2691),
    [anon_sym__Atomic] = ACTIONS(2691),
    [anon_sym__Noreturn] = ACTIONS(2691),
    [anon_sym_noreturn] = ACTIONS(2691),
    [anon_sym_mutable] = ACTIONS(2691),
    [anon_sym_constinit] = ACTIONS(2691),
    [anon_sym_consteval] = ACTIONS(2691),
    [anon_sym_PROGMEM] = ACTIONS(2691),
    [aux_sym_primitive_type_token1] = ACTIONS(2691),
    [anon_sym_byte] = ACTIONS(2691),
    [anon_sym_word] = ACTIONS(2691),
    [anon_sym_enum] = ACTIONS(2691),
    [anon_sym_class] = ACTIONS(2691),
    [anon_sym_struct] = ACTIONS(2691),
    [anon_sym_union] = ACTIONS(2691),
    [anon_sym_if] = ACTIONS(2691),
    [anon_sym_else] = ACTIONS(2691),
    [anon_sym_switch] = ACTIONS(2691),
    [anon_sym_case] = ACTIONS(2691),
    [anon_sym_default] = ACTIONS(2691),
    [anon_sym_while] = ACTIONS(2691),
    [anon_sym_do] = ACTIONS(2691),
    [anon_sym_for] = ACTIONS(2691),
    [anon_sym_return] = ACTIONS(2691),
    [anon_sym_break] = ACTIONS(2691),
    [anon_sym_continue] = ACTIONS(2691),
    [anon_sym_goto] = ACTIONS(2691),
    [anon_sym___try] = ACTIONS(2691),
    [anon_sym___leave] = ACTIONS(2691),
    [anon_sym_not] = ACTIONS(2691),
    [anon_sym_compl] = ACTIONS(2691),
    [anon_sym_DASH_DASH] = ACTIONS(2693),
    [anon_sym_PLUS_PLUS] = ACTIONS(2693),
    [anon_sym_sizeof] = ACTIONS(2691),
    [anon_sym___alignof__] = ACTIONS(2691),
    [anon_sym___alignof] = ACTIONS(2691),
    [anon_sym__alignof] = ACTIONS(2691),
    [anon_sym_alignof] = ACTIONS(2691),
    [anon_sym__Alignof] = ACTIONS(2691),
    [anon_sym_offsetof] = ACTIONS(2691),
    [anon_sym__Generic] = ACTIONS(2691),
    [anon_sym_asm] = ACTIONS(2691),
    [anon_sym___asm__] = ACTIONS(2691),
    [aux_sym_number_literal_token1] = ACTIONS(2693),
    [aux_sym_number_literal_token2] = ACTIONS(2691),
    [anon_sym_L_SQUOTE] = ACTIONS(2693),
    [anon_sym_u_SQUOTE] = ACTIONS(2693),
    [anon_sym_U_SQUOTE] = ACTIONS(2693),
    [anon_sym_u8_SQUOTE] = ACTIONS(2693),
    [anon_sym_SQUOTE] = ACTIONS(2693),
    [anon_sym_L_DQUOTE] = ACTIONS(2693),
    [anon_sym_u_DQUOTE] = ACTIONS(2693),
    [anon_sym_U_DQUOTE] = ACTIONS(2693),
    [anon_sym_u8_DQUOTE] = ACTIONS(2693),
    [anon_sym_DQUOTE] = ACTIONS(2693),
    [sym_true] = ACTIONS(2691),
    [sym_false] = ACTIONS(2691),
    [anon_sym_NULL] = ACTIONS(2691),
    [anon_sym_nullptr] = ACTIONS(2691),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2691),
    [anon_sym_decltype] = ACTIONS(2691),
    [anon_sym_virtual] = ACTIONS(2691),
    [anon_sym_alignas] = ACTIONS(2691),
    [anon_sym_explicit] = ACTIONS(2691),
    [anon_sym_typename] = ACTIONS(2691),
    [anon_sym_template] = ACTIONS(2691),
    [anon_sym_operator] = ACTIONS(2691),
    [anon_sym_try] = ACTIONS(2691),
    [anon_sym_delete] = ACTIONS(2691),
    [anon_sym_throw] = ACTIONS(2691),
    [anon_sym_namespace] = ACTIONS(2691),
    [anon_sym_using] = ACTIONS(2691),
    [anon_sym_static_assert] = ACTIONS(2691),
    [anon_sym_concept] = ACTIONS(2691),
    [anon_sym_co_return] = ACTIONS(2691),
    [anon_sym_co_yield] = ACTIONS(2691),
    [anon_sym_R_DQUOTE] = ACTIONS(2693),
    [anon_sym_LR_DQUOTE] = ACTIONS(2693),
    [anon_sym_uR_DQUOTE] = ACTIONS(2693),
    [anon_sym_UR_DQUOTE] = ACTIONS(2693),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2693),
    [anon_sym_co_await] = ACTIONS(2691),
    [anon_sym_new] = ACTIONS(2691),
    [anon_sym_requires] = ACTIONS(2691),
    [sym_this] = ACTIONS(2691),
  },
  [576] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token2] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [577] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token2] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [578] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token2] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [579] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token2] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [580] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_RBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [581] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token2] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [582] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token2] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [583] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token2] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [584] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token2] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [585] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token2] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [586] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token2] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [587] = {
    [ts_builtin_sym_end] = ACTIONS(2681),
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [588] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_RBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [589] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token2] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [590] = {
    [ts_builtin_sym_end] = ACTIONS(2681),
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [591] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token2] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [592] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token2] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [593] = {
    [ts_builtin_sym_end] = ACTIONS(2697),
    [sym_identifier] = ACTIONS(2695),
    [aux_sym_preproc_include_token1] = ACTIONS(2695),
    [aux_sym_preproc_def_token1] = ACTIONS(2695),
    [aux_sym_preproc_if_token1] = ACTIONS(2695),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2695),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2695),
    [sym_preproc_directive] = ACTIONS(2695),
    [anon_sym_LPAREN2] = ACTIONS(2697),
    [anon_sym_BANG] = ACTIONS(2697),
    [anon_sym_TILDE] = ACTIONS(2697),
    [anon_sym_DASH] = ACTIONS(2695),
    [anon_sym_PLUS] = ACTIONS(2695),
    [anon_sym_STAR] = ACTIONS(2697),
    [anon_sym_AMP_AMP] = ACTIONS(2697),
    [anon_sym_AMP] = ACTIONS(2695),
    [anon_sym_SEMI] = ACTIONS(2697),
    [anon_sym___extension__] = ACTIONS(2695),
    [anon_sym_typedef] = ACTIONS(2695),
    [anon_sym_extern] = ACTIONS(2695),
    [anon_sym___attribute__] = ACTIONS(2695),
    [anon_sym_COLON_COLON] = ACTIONS(2697),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2697),
    [anon_sym___declspec] = ACTIONS(2695),
    [anon_sym___based] = ACTIONS(2695),
    [anon_sym___cdecl] = ACTIONS(2695),
    [anon_sym___clrcall] = ACTIONS(2695),
    [anon_sym___stdcall] = ACTIONS(2695),
    [anon_sym___fastcall] = ACTIONS(2695),
    [anon_sym___thiscall] = ACTIONS(2695),
    [anon_sym___vectorcall] = ACTIONS(2695),
    [anon_sym_LBRACE] = ACTIONS(2697),
    [anon_sym_signed] = ACTIONS(2695),
    [anon_sym_unsigned] = ACTIONS(2695),
    [anon_sym_long] = ACTIONS(2695),
    [anon_sym_short] = ACTIONS(2695),
    [anon_sym_LBRACK] = ACTIONS(2695),
    [anon_sym_static] = ACTIONS(2695),
    [anon_sym_register] = ACTIONS(2695),
    [anon_sym_inline] = ACTIONS(2695),
    [anon_sym___inline] = ACTIONS(2695),
    [anon_sym___inline__] = ACTIONS(2695),
    [anon_sym___forceinline] = ACTIONS(2695),
    [anon_sym_thread_local] = ACTIONS(2695),
    [anon_sym___thread] = ACTIONS(2695),
    [anon_sym_const] = ACTIONS(2695),
    [anon_sym_constexpr] = ACTIONS(2695),
    [anon_sym_volatile] = ACTIONS(2695),
    [anon_sym_restrict] = ACTIONS(2695),
    [anon_sym___restrict__] = ACTIONS(2695),
    [anon_sym__Atomic] = ACTIONS(2695),
    [anon_sym__Noreturn] = ACTIONS(2695),
    [anon_sym_noreturn] = ACTIONS(2695),
    [anon_sym_mutable] = ACTIONS(2695),
    [anon_sym_constinit] = ACTIONS(2695),
    [anon_sym_consteval] = ACTIONS(2695),
    [anon_sym_PROGMEM] = ACTIONS(2695),
    [aux_sym_primitive_type_token1] = ACTIONS(2695),
    [anon_sym_byte] = ACTIONS(2695),
    [anon_sym_word] = ACTIONS(2695),
    [anon_sym_enum] = ACTIONS(2695),
    [anon_sym_class] = ACTIONS(2695),
    [anon_sym_struct] = ACTIONS(2695),
    [anon_sym_union] = ACTIONS(2695),
    [anon_sym_if] = ACTIONS(2695),
    [anon_sym_else] = ACTIONS(2695),
    [anon_sym_switch] = ACTIONS(2695),
    [anon_sym_case] = ACTIONS(2695),
    [anon_sym_default] = ACTIONS(2695),
    [anon_sym_while] = ACTIONS(2695),
    [anon_sym_do] = ACTIONS(2695),
    [anon_sym_for] = ACTIONS(2695),
    [anon_sym_return] = ACTIONS(2695),
    [anon_sym_break] = ACTIONS(2695),
    [anon_sym_continue] = ACTIONS(2695),
    [anon_sym_goto] = ACTIONS(2695),
    [anon_sym___try] = ACTIONS(2695),
    [anon_sym___leave] = ACTIONS(2695),
    [anon_sym_not] = ACTIONS(2695),
    [anon_sym_compl] = ACTIONS(2695),
    [anon_sym_DASH_DASH] = ACTIONS(2697),
    [anon_sym_PLUS_PLUS] = ACTIONS(2697),
    [anon_sym_sizeof] = ACTIONS(2695),
    [anon_sym___alignof__] = ACTIONS(2695),
    [anon_sym___alignof] = ACTIONS(2695),
    [anon_sym__alignof] = ACTIONS(2695),
    [anon_sym_alignof] = ACTIONS(2695),
    [anon_sym__Alignof] = ACTIONS(2695),
    [anon_sym_offsetof] = ACTIONS(2695),
    [anon_sym__Generic] = ACTIONS(2695),
    [anon_sym_asm] = ACTIONS(2695),
    [anon_sym___asm__] = ACTIONS(2695),
    [aux_sym_number_literal_token1] = ACTIONS(2697),
    [aux_sym_number_literal_token2] = ACTIONS(2695),
    [anon_sym_L_SQUOTE] = ACTIONS(2697),
    [anon_sym_u_SQUOTE] = ACTIONS(2697),
    [anon_sym_U_SQUOTE] = ACTIONS(2697),
    [anon_sym_u8_SQUOTE] = ACTIONS(2697),
    [anon_sym_SQUOTE] = ACTIONS(2697),
    [anon_sym_L_DQUOTE] = ACTIONS(2697),
    [anon_sym_u_DQUOTE] = ACTIONS(2697),
    [anon_sym_U_DQUOTE] = ACTIONS(2697),
    [anon_sym_u8_DQUOTE] = ACTIONS(2697),
    [anon_sym_DQUOTE] = ACTIONS(2697),
    [sym_true] = ACTIONS(2695),
    [sym_false] = ACTIONS(2695),
    [anon_sym_NULL] = ACTIONS(2695),
    [anon_sym_nullptr] = ACTIONS(2695),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2695),
    [anon_sym_decltype] = ACTIONS(2695),
    [anon_sym_virtual] = ACTIONS(2695),
    [anon_sym_alignas] = ACTIONS(2695),
    [anon_sym_explicit] = ACTIONS(2695),
    [anon_sym_typename] = ACTIONS(2695),
    [anon_sym_template] = ACTIONS(2695),
    [anon_sym_operator] = ACTIONS(2695),
    [anon_sym_try] = ACTIONS(2695),
    [anon_sym_delete] = ACTIONS(2695),
    [anon_sym_throw] = ACTIONS(2695),
    [anon_sym_namespace] = ACTIONS(2695),
    [anon_sym_using] = ACTIONS(2695),
    [anon_sym_static_assert] = ACTIONS(2695),
    [anon_sym_concept] = ACTIONS(2695),
    [anon_sym_co_return] = ACTIONS(2695),
    [anon_sym_co_yield] = ACTIONS(2695),
    [anon_sym_R_DQUOTE] = ACTIONS(2697),
    [anon_sym_LR_DQUOTE] = ACTIONS(2697),
    [anon_sym_uR_DQUOTE] = ACTIONS(2697),
    [anon_sym_UR_DQUOTE] = ACTIONS(2697),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2697),
    [anon_sym_co_await] = ACTIONS(2695),
    [anon_sym_new] = ACTIONS(2695),
    [anon_sym_requires] = ACTIONS(2695),
    [sym_this] = ACTIONS(2695),
  },
  [594] = {
    [ts_builtin_sym_end] = ACTIONS(2703),
    [sym_identifier] = ACTIONS(2701),
    [aux_sym_preproc_include_token1] = ACTIONS(2701),
    [aux_sym_preproc_def_token1] = ACTIONS(2701),
    [aux_sym_preproc_if_token1] = ACTIONS(2701),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2701),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2701),
    [sym_preproc_directive] = ACTIONS(2701),
    [anon_sym_LPAREN2] = ACTIONS(2703),
    [anon_sym_BANG] = ACTIONS(2703),
    [anon_sym_TILDE] = ACTIONS(2703),
    [anon_sym_DASH] = ACTIONS(2701),
    [anon_sym_PLUS] = ACTIONS(2701),
    [anon_sym_STAR] = ACTIONS(2703),
    [anon_sym_AMP_AMP] = ACTIONS(2703),
    [anon_sym_AMP] = ACTIONS(2701),
    [anon_sym_SEMI] = ACTIONS(2703),
    [anon_sym___extension__] = ACTIONS(2701),
    [anon_sym_typedef] = ACTIONS(2701),
    [anon_sym_extern] = ACTIONS(2701),
    [anon_sym___attribute__] = ACTIONS(2701),
    [anon_sym_COLON_COLON] = ACTIONS(2703),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2703),
    [anon_sym___declspec] = ACTIONS(2701),
    [anon_sym___based] = ACTIONS(2701),
    [anon_sym___cdecl] = ACTIONS(2701),
    [anon_sym___clrcall] = ACTIONS(2701),
    [anon_sym___stdcall] = ACTIONS(2701),
    [anon_sym___fastcall] = ACTIONS(2701),
    [anon_sym___thiscall] = ACTIONS(2701),
    [anon_sym___vectorcall] = ACTIONS(2701),
    [anon_sym_LBRACE] = ACTIONS(2703),
    [anon_sym_signed] = ACTIONS(2701),
    [anon_sym_unsigned] = ACTIONS(2701),
    [anon_sym_long] = ACTIONS(2701),
    [anon_sym_short] = ACTIONS(2701),
    [anon_sym_LBRACK] = ACTIONS(2701),
    [anon_sym_static] = ACTIONS(2701),
    [anon_sym_register] = ACTIONS(2701),
    [anon_sym_inline] = ACTIONS(2701),
    [anon_sym___inline] = ACTIONS(2701),
    [anon_sym___inline__] = ACTIONS(2701),
    [anon_sym___forceinline] = ACTIONS(2701),
    [anon_sym_thread_local] = ACTIONS(2701),
    [anon_sym___thread] = ACTIONS(2701),
    [anon_sym_const] = ACTIONS(2701),
    [anon_sym_constexpr] = ACTIONS(2701),
    [anon_sym_volatile] = ACTIONS(2701),
    [anon_sym_restrict] = ACTIONS(2701),
    [anon_sym___restrict__] = ACTIONS(2701),
    [anon_sym__Atomic] = ACTIONS(2701),
    [anon_sym__Noreturn] = ACTIONS(2701),
    [anon_sym_noreturn] = ACTIONS(2701),
    [anon_sym_mutable] = ACTIONS(2701),
    [anon_sym_constinit] = ACTIONS(2701),
    [anon_sym_consteval] = ACTIONS(2701),
    [anon_sym_PROGMEM] = ACTIONS(2701),
    [aux_sym_primitive_type_token1] = ACTIONS(2701),
    [anon_sym_byte] = ACTIONS(2701),
    [anon_sym_word] = ACTIONS(2701),
    [anon_sym_enum] = ACTIONS(2701),
    [anon_sym_class] = ACTIONS(2701),
    [anon_sym_struct] = ACTIONS(2701),
    [anon_sym_union] = ACTIONS(2701),
    [anon_sym_if] = ACTIONS(2701),
    [anon_sym_else] = ACTIONS(2701),
    [anon_sym_switch] = ACTIONS(2701),
    [anon_sym_case] = ACTIONS(2701),
    [anon_sym_default] = ACTIONS(2701),
    [anon_sym_while] = ACTIONS(2701),
    [anon_sym_do] = ACTIONS(2701),
    [anon_sym_for] = ACTIONS(2701),
    [anon_sym_return] = ACTIONS(2701),
    [anon_sym_break] = ACTIONS(2701),
    [anon_sym_continue] = ACTIONS(2701),
    [anon_sym_goto] = ACTIONS(2701),
    [anon_sym___try] = ACTIONS(2701),
    [anon_sym___leave] = ACTIONS(2701),
    [anon_sym_not] = ACTIONS(2701),
    [anon_sym_compl] = ACTIONS(2701),
    [anon_sym_DASH_DASH] = ACTIONS(2703),
    [anon_sym_PLUS_PLUS] = ACTIONS(2703),
    [anon_sym_sizeof] = ACTIONS(2701),
    [anon_sym___alignof__] = ACTIONS(2701),
    [anon_sym___alignof] = ACTIONS(2701),
    [anon_sym__alignof] = ACTIONS(2701),
    [anon_sym_alignof] = ACTIONS(2701),
    [anon_sym__Alignof] = ACTIONS(2701),
    [anon_sym_offsetof] = ACTIONS(2701),
    [anon_sym__Generic] = ACTIONS(2701),
    [anon_sym_asm] = ACTIONS(2701),
    [anon_sym___asm__] = ACTIONS(2701),
    [aux_sym_number_literal_token1] = ACTIONS(2703),
    [aux_sym_number_literal_token2] = ACTIONS(2701),
    [anon_sym_L_SQUOTE] = ACTIONS(2703),
    [anon_sym_u_SQUOTE] = ACTIONS(2703),
    [anon_sym_U_SQUOTE] = ACTIONS(2703),
    [anon_sym_u8_SQUOTE] = ACTIONS(2703),
    [anon_sym_SQUOTE] = ACTIONS(2703),
    [anon_sym_L_DQUOTE] = ACTIONS(2703),
    [anon_sym_u_DQUOTE] = ACTIONS(2703),
    [anon_sym_U_DQUOTE] = ACTIONS(2703),
    [anon_sym_u8_DQUOTE] = ACTIONS(2703),
    [anon_sym_DQUOTE] = ACTIONS(2703),
    [sym_true] = ACTIONS(2701),
    [sym_false] = ACTIONS(2701),
    [anon_sym_NULL] = ACTIONS(2701),
    [anon_sym_nullptr] = ACTIONS(2701),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2701),
    [anon_sym_decltype] = ACTIONS(2701),
    [anon_sym_virtual] = ACTIONS(2701),
    [anon_sym_alignas] = ACTIONS(2701),
    [anon_sym_explicit] = ACTIONS(2701),
    [anon_sym_typename] = ACTIONS(2701),
    [anon_sym_template] = ACTIONS(2701),
    [anon_sym_operator] = ACTIONS(2701),
    [anon_sym_try] = ACTIONS(2701),
    [anon_sym_delete] = ACTIONS(2701),
    [anon_sym_throw] = ACTIONS(2701),
    [anon_sym_namespace] = ACTIONS(2701),
    [anon_sym_using] = ACTIONS(2701),
    [anon_sym_static_assert] = ACTIONS(2701),
    [anon_sym_concept] = ACTIONS(2701),
    [anon_sym_co_return] = ACTIONS(2701),
    [anon_sym_co_yield] = ACTIONS(2701),
    [anon_sym_R_DQUOTE] = ACTIONS(2703),
    [anon_sym_LR_DQUOTE] = ACTIONS(2703),
    [anon_sym_uR_DQUOTE] = ACTIONS(2703),
    [anon_sym_UR_DQUOTE] = ACTIONS(2703),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2703),
    [anon_sym_co_await] = ACTIONS(2701),
    [anon_sym_new] = ACTIONS(2701),
    [anon_sym_requires] = ACTIONS(2701),
    [sym_this] = ACTIONS(2701),
  },
  [595] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token2] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [596] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token2] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [597] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token2] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [598] = {
    [ts_builtin_sym_end] = ACTIONS(2645),
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [599] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token2] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [600] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token2] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [601] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token2] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [602] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_RBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [603] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token2] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [604] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token2] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [605] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token2] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [606] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token2] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [607] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token2] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [608] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token2] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [609] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token2] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [610] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token2] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [611] = {
    [ts_builtin_sym_end] = ACTIONS(2681),
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [612] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token2] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [613] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token2] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [614] = {
    [ts_builtin_sym_end] = ACTIONS(2663),
    [sym_identifier] = ACTIONS(2661),
    [aux_sym_preproc_include_token1] = ACTIONS(2661),
    [aux_sym_preproc_def_token1] = ACTIONS(2661),
    [aux_sym_preproc_if_token1] = ACTIONS(2661),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2661),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2661),
    [sym_preproc_directive] = ACTIONS(2661),
    [anon_sym_LPAREN2] = ACTIONS(2663),
    [anon_sym_BANG] = ACTIONS(2663),
    [anon_sym_TILDE] = ACTIONS(2663),
    [anon_sym_DASH] = ACTIONS(2661),
    [anon_sym_PLUS] = ACTIONS(2661),
    [anon_sym_STAR] = ACTIONS(2663),
    [anon_sym_AMP_AMP] = ACTIONS(2663),
    [anon_sym_AMP] = ACTIONS(2661),
    [anon_sym_SEMI] = ACTIONS(2663),
    [anon_sym___extension__] = ACTIONS(2661),
    [anon_sym_typedef] = ACTIONS(2661),
    [anon_sym_extern] = ACTIONS(2661),
    [anon_sym___attribute__] = ACTIONS(2661),
    [anon_sym_COLON_COLON] = ACTIONS(2663),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2663),
    [anon_sym___declspec] = ACTIONS(2661),
    [anon_sym___based] = ACTIONS(2661),
    [anon_sym___cdecl] = ACTIONS(2661),
    [anon_sym___clrcall] = ACTIONS(2661),
    [anon_sym___stdcall] = ACTIONS(2661),
    [anon_sym___fastcall] = ACTIONS(2661),
    [anon_sym___thiscall] = ACTIONS(2661),
    [anon_sym___vectorcall] = ACTIONS(2661),
    [anon_sym_LBRACE] = ACTIONS(2663),
    [anon_sym_signed] = ACTIONS(2661),
    [anon_sym_unsigned] = ACTIONS(2661),
    [anon_sym_long] = ACTIONS(2661),
    [anon_sym_short] = ACTIONS(2661),
    [anon_sym_LBRACK] = ACTIONS(2661),
    [anon_sym_static] = ACTIONS(2661),
    [anon_sym_register] = ACTIONS(2661),
    [anon_sym_inline] = ACTIONS(2661),
    [anon_sym___inline] = ACTIONS(2661),
    [anon_sym___inline__] = ACTIONS(2661),
    [anon_sym___forceinline] = ACTIONS(2661),
    [anon_sym_thread_local] = ACTIONS(2661),
    [anon_sym___thread] = ACTIONS(2661),
    [anon_sym_const] = ACTIONS(2661),
    [anon_sym_constexpr] = ACTIONS(2661),
    [anon_sym_volatile] = ACTIONS(2661),
    [anon_sym_restrict] = ACTIONS(2661),
    [anon_sym___restrict__] = ACTIONS(2661),
    [anon_sym__Atomic] = ACTIONS(2661),
    [anon_sym__Noreturn] = ACTIONS(2661),
    [anon_sym_noreturn] = ACTIONS(2661),
    [anon_sym_mutable] = ACTIONS(2661),
    [anon_sym_constinit] = ACTIONS(2661),
    [anon_sym_consteval] = ACTIONS(2661),
    [anon_sym_PROGMEM] = ACTIONS(2661),
    [aux_sym_primitive_type_token1] = ACTIONS(2661),
    [anon_sym_byte] = ACTIONS(2661),
    [anon_sym_word] = ACTIONS(2661),
    [anon_sym_enum] = ACTIONS(2661),
    [anon_sym_class] = ACTIONS(2661),
    [anon_sym_struct] = ACTIONS(2661),
    [anon_sym_union] = ACTIONS(2661),
    [anon_sym_if] = ACTIONS(2661),
    [anon_sym_else] = ACTIONS(2661),
    [anon_sym_switch] = ACTIONS(2661),
    [anon_sym_case] = ACTIONS(2661),
    [anon_sym_default] = ACTIONS(2661),
    [anon_sym_while] = ACTIONS(2661),
    [anon_sym_do] = ACTIONS(2661),
    [anon_sym_for] = ACTIONS(2661),
    [anon_sym_return] = ACTIONS(2661),
    [anon_sym_break] = ACTIONS(2661),
    [anon_sym_continue] = ACTIONS(2661),
    [anon_sym_goto] = ACTIONS(2661),
    [anon_sym___try] = ACTIONS(2661),
    [anon_sym___leave] = ACTIONS(2661),
    [anon_sym_not] = ACTIONS(2661),
    [anon_sym_compl] = ACTIONS(2661),
    [anon_sym_DASH_DASH] = ACTIONS(2663),
    [anon_sym_PLUS_PLUS] = ACTIONS(2663),
    [anon_sym_sizeof] = ACTIONS(2661),
    [anon_sym___alignof__] = ACTIONS(2661),
    [anon_sym___alignof] = ACTIONS(2661),
    [anon_sym__alignof] = ACTIONS(2661),
    [anon_sym_alignof] = ACTIONS(2661),
    [anon_sym__Alignof] = ACTIONS(2661),
    [anon_sym_offsetof] = ACTIONS(2661),
    [anon_sym__Generic] = ACTIONS(2661),
    [anon_sym_asm] = ACTIONS(2661),
    [anon_sym___asm__] = ACTIONS(2661),
    [aux_sym_number_literal_token1] = ACTIONS(2663),
    [aux_sym_number_literal_token2] = ACTIONS(2661),
    [anon_sym_L_SQUOTE] = ACTIONS(2663),
    [anon_sym_u_SQUOTE] = ACTIONS(2663),
    [anon_sym_U_SQUOTE] = ACTIONS(2663),
    [anon_sym_u8_SQUOTE] = ACTIONS(2663),
    [anon_sym_SQUOTE] = ACTIONS(2663),
    [anon_sym_L_DQUOTE] = ACTIONS(2663),
    [anon_sym_u_DQUOTE] = ACTIONS(2663),
    [anon_sym_U_DQUOTE] = ACTIONS(2663),
    [anon_sym_u8_DQUOTE] = ACTIONS(2663),
    [anon_sym_DQUOTE] = ACTIONS(2663),
    [sym_true] = ACTIONS(2661),
    [sym_false] = ACTIONS(2661),
    [anon_sym_NULL] = ACTIONS(2661),
    [anon_sym_nullptr] = ACTIONS(2661),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2661),
    [anon_sym_decltype] = ACTIONS(2661),
    [anon_sym_virtual] = ACTIONS(2661),
    [anon_sym_alignas] = ACTIONS(2661),
    [anon_sym_explicit] = ACTIONS(2661),
    [anon_sym_typename] = ACTIONS(2661),
    [anon_sym_template] = ACTIONS(2661),
    [anon_sym_operator] = ACTIONS(2661),
    [anon_sym_try] = ACTIONS(2661),
    [anon_sym_delete] = ACTIONS(2661),
    [anon_sym_throw] = ACTIONS(2661),
    [anon_sym_namespace] = ACTIONS(2661),
    [anon_sym_using] = ACTIONS(2661),
    [anon_sym_static_assert] = ACTIONS(2661),
    [anon_sym_concept] = ACTIONS(2661),
    [anon_sym_co_return] = ACTIONS(2661),
    [anon_sym_co_yield] = ACTIONS(2661),
    [anon_sym_R_DQUOTE] = ACTIONS(2663),
    [anon_sym_LR_DQUOTE] = ACTIONS(2663),
    [anon_sym_uR_DQUOTE] = ACTIONS(2663),
    [anon_sym_UR_DQUOTE] = ACTIONS(2663),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2663),
    [anon_sym_co_await] = ACTIONS(2661),
    [anon_sym_new] = ACTIONS(2661),
    [anon_sym_requires] = ACTIONS(2661),
    [sym_this] = ACTIONS(2661),
  },
  [615] = {
    [ts_builtin_sym_end] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2705),
    [aux_sym_preproc_include_token1] = ACTIONS(2705),
    [aux_sym_preproc_def_token1] = ACTIONS(2705),
    [aux_sym_preproc_if_token1] = ACTIONS(2705),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2705),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2705),
    [sym_preproc_directive] = ACTIONS(2705),
    [anon_sym_LPAREN2] = ACTIONS(2707),
    [anon_sym_BANG] = ACTIONS(2707),
    [anon_sym_TILDE] = ACTIONS(2707),
    [anon_sym_DASH] = ACTIONS(2705),
    [anon_sym_PLUS] = ACTIONS(2705),
    [anon_sym_STAR] = ACTIONS(2707),
    [anon_sym_AMP_AMP] = ACTIONS(2707),
    [anon_sym_AMP] = ACTIONS(2705),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym___extension__] = ACTIONS(2705),
    [anon_sym_typedef] = ACTIONS(2705),
    [anon_sym_extern] = ACTIONS(2705),
    [anon_sym___attribute__] = ACTIONS(2705),
    [anon_sym_COLON_COLON] = ACTIONS(2707),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2707),
    [anon_sym___declspec] = ACTIONS(2705),
    [anon_sym___based] = ACTIONS(2705),
    [anon_sym___cdecl] = ACTIONS(2705),
    [anon_sym___clrcall] = ACTIONS(2705),
    [anon_sym___stdcall] = ACTIONS(2705),
    [anon_sym___fastcall] = ACTIONS(2705),
    [anon_sym___thiscall] = ACTIONS(2705),
    [anon_sym___vectorcall] = ACTIONS(2705),
    [anon_sym_LBRACE] = ACTIONS(2707),
    [anon_sym_signed] = ACTIONS(2705),
    [anon_sym_unsigned] = ACTIONS(2705),
    [anon_sym_long] = ACTIONS(2705),
    [anon_sym_short] = ACTIONS(2705),
    [anon_sym_LBRACK] = ACTIONS(2705),
    [anon_sym_static] = ACTIONS(2705),
    [anon_sym_register] = ACTIONS(2705),
    [anon_sym_inline] = ACTIONS(2705),
    [anon_sym___inline] = ACTIONS(2705),
    [anon_sym___inline__] = ACTIONS(2705),
    [anon_sym___forceinline] = ACTIONS(2705),
    [anon_sym_thread_local] = ACTIONS(2705),
    [anon_sym___thread] = ACTIONS(2705),
    [anon_sym_const] = ACTIONS(2705),
    [anon_sym_constexpr] = ACTIONS(2705),
    [anon_sym_volatile] = ACTIONS(2705),
    [anon_sym_restrict] = ACTIONS(2705),
    [anon_sym___restrict__] = ACTIONS(2705),
    [anon_sym__Atomic] = ACTIONS(2705),
    [anon_sym__Noreturn] = ACTIONS(2705),
    [anon_sym_noreturn] = ACTIONS(2705),
    [anon_sym_mutable] = ACTIONS(2705),
    [anon_sym_constinit] = ACTIONS(2705),
    [anon_sym_consteval] = ACTIONS(2705),
    [anon_sym_PROGMEM] = ACTIONS(2705),
    [aux_sym_primitive_type_token1] = ACTIONS(2705),
    [anon_sym_byte] = ACTIONS(2705),
    [anon_sym_word] = ACTIONS(2705),
    [anon_sym_enum] = ACTIONS(2705),
    [anon_sym_class] = ACTIONS(2705),
    [anon_sym_struct] = ACTIONS(2705),
    [anon_sym_union] = ACTIONS(2705),
    [anon_sym_if] = ACTIONS(2705),
    [anon_sym_else] = ACTIONS(2705),
    [anon_sym_switch] = ACTIONS(2705),
    [anon_sym_case] = ACTIONS(2705),
    [anon_sym_default] = ACTIONS(2705),
    [anon_sym_while] = ACTIONS(2705),
    [anon_sym_do] = ACTIONS(2705),
    [anon_sym_for] = ACTIONS(2705),
    [anon_sym_return] = ACTIONS(2705),
    [anon_sym_break] = ACTIONS(2705),
    [anon_sym_continue] = ACTIONS(2705),
    [anon_sym_goto] = ACTIONS(2705),
    [anon_sym___try] = ACTIONS(2705),
    [anon_sym___leave] = ACTIONS(2705),
    [anon_sym_not] = ACTIONS(2705),
    [anon_sym_compl] = ACTIONS(2705),
    [anon_sym_DASH_DASH] = ACTIONS(2707),
    [anon_sym_PLUS_PLUS] = ACTIONS(2707),
    [anon_sym_sizeof] = ACTIONS(2705),
    [anon_sym___alignof__] = ACTIONS(2705),
    [anon_sym___alignof] = ACTIONS(2705),
    [anon_sym__alignof] = ACTIONS(2705),
    [anon_sym_alignof] = ACTIONS(2705),
    [anon_sym__Alignof] = ACTIONS(2705),
    [anon_sym_offsetof] = ACTIONS(2705),
    [anon_sym__Generic] = ACTIONS(2705),
    [anon_sym_asm] = ACTIONS(2705),
    [anon_sym___asm__] = ACTIONS(2705),
    [aux_sym_number_literal_token1] = ACTIONS(2707),
    [aux_sym_number_literal_token2] = ACTIONS(2705),
    [anon_sym_L_SQUOTE] = ACTIONS(2707),
    [anon_sym_u_SQUOTE] = ACTIONS(2707),
    [anon_sym_U_SQUOTE] = ACTIONS(2707),
    [anon_sym_u8_SQUOTE] = ACTIONS(2707),
    [anon_sym_SQUOTE] = ACTIONS(2707),
    [anon_sym_L_DQUOTE] = ACTIONS(2707),
    [anon_sym_u_DQUOTE] = ACTIONS(2707),
    [anon_sym_U_DQUOTE] = ACTIONS(2707),
    [anon_sym_u8_DQUOTE] = ACTIONS(2707),
    [anon_sym_DQUOTE] = ACTIONS(2707),
    [sym_true] = ACTIONS(2705),
    [sym_false] = ACTIONS(2705),
    [anon_sym_NULL] = ACTIONS(2705),
    [anon_sym_nullptr] = ACTIONS(2705),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2705),
    [anon_sym_decltype] = ACTIONS(2705),
    [anon_sym_virtual] = ACTIONS(2705),
    [anon_sym_alignas] = ACTIONS(2705),
    [anon_sym_explicit] = ACTIONS(2705),
    [anon_sym_typename] = ACTIONS(2705),
    [anon_sym_template] = ACTIONS(2705),
    [anon_sym_operator] = ACTIONS(2705),
    [anon_sym_try] = ACTIONS(2705),
    [anon_sym_delete] = ACTIONS(2705),
    [anon_sym_throw] = ACTIONS(2705),
    [anon_sym_namespace] = ACTIONS(2705),
    [anon_sym_using] = ACTIONS(2705),
    [anon_sym_static_assert] = ACTIONS(2705),
    [anon_sym_concept] = ACTIONS(2705),
    [anon_sym_co_return] = ACTIONS(2705),
    [anon_sym_co_yield] = ACTIONS(2705),
    [anon_sym_R_DQUOTE] = ACTIONS(2707),
    [anon_sym_LR_DQUOTE] = ACTIONS(2707),
    [anon_sym_uR_DQUOTE] = ACTIONS(2707),
    [anon_sym_UR_DQUOTE] = ACTIONS(2707),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2707),
    [anon_sym_co_await] = ACTIONS(2705),
    [anon_sym_new] = ACTIONS(2705),
    [anon_sym_requires] = ACTIONS(2705),
    [sym_this] = ACTIONS(2705),
  },
  [616] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_RBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [617] = {
    [ts_builtin_sym_end] = ACTIONS(2659),
    [sym_identifier] = ACTIONS(2657),
    [aux_sym_preproc_include_token1] = ACTIONS(2657),
    [aux_sym_preproc_def_token1] = ACTIONS(2657),
    [aux_sym_preproc_if_token1] = ACTIONS(2657),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2657),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2657),
    [sym_preproc_directive] = ACTIONS(2657),
    [anon_sym_LPAREN2] = ACTIONS(2659),
    [anon_sym_BANG] = ACTIONS(2659),
    [anon_sym_TILDE] = ACTIONS(2659),
    [anon_sym_DASH] = ACTIONS(2657),
    [anon_sym_PLUS] = ACTIONS(2657),
    [anon_sym_STAR] = ACTIONS(2659),
    [anon_sym_AMP_AMP] = ACTIONS(2659),
    [anon_sym_AMP] = ACTIONS(2657),
    [anon_sym_SEMI] = ACTIONS(2659),
    [anon_sym___extension__] = ACTIONS(2657),
    [anon_sym_typedef] = ACTIONS(2657),
    [anon_sym_extern] = ACTIONS(2657),
    [anon_sym___attribute__] = ACTIONS(2657),
    [anon_sym_COLON_COLON] = ACTIONS(2659),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2659),
    [anon_sym___declspec] = ACTIONS(2657),
    [anon_sym___based] = ACTIONS(2657),
    [anon_sym___cdecl] = ACTIONS(2657),
    [anon_sym___clrcall] = ACTIONS(2657),
    [anon_sym___stdcall] = ACTIONS(2657),
    [anon_sym___fastcall] = ACTIONS(2657),
    [anon_sym___thiscall] = ACTIONS(2657),
    [anon_sym___vectorcall] = ACTIONS(2657),
    [anon_sym_LBRACE] = ACTIONS(2659),
    [anon_sym_signed] = ACTIONS(2657),
    [anon_sym_unsigned] = ACTIONS(2657),
    [anon_sym_long] = ACTIONS(2657),
    [anon_sym_short] = ACTIONS(2657),
    [anon_sym_LBRACK] = ACTIONS(2657),
    [anon_sym_static] = ACTIONS(2657),
    [anon_sym_register] = ACTIONS(2657),
    [anon_sym_inline] = ACTIONS(2657),
    [anon_sym___inline] = ACTIONS(2657),
    [anon_sym___inline__] = ACTIONS(2657),
    [anon_sym___forceinline] = ACTIONS(2657),
    [anon_sym_thread_local] = ACTIONS(2657),
    [anon_sym___thread] = ACTIONS(2657),
    [anon_sym_const] = ACTIONS(2657),
    [anon_sym_constexpr] = ACTIONS(2657),
    [anon_sym_volatile] = ACTIONS(2657),
    [anon_sym_restrict] = ACTIONS(2657),
    [anon_sym___restrict__] = ACTIONS(2657),
    [anon_sym__Atomic] = ACTIONS(2657),
    [anon_sym__Noreturn] = ACTIONS(2657),
    [anon_sym_noreturn] = ACTIONS(2657),
    [anon_sym_mutable] = ACTIONS(2657),
    [anon_sym_constinit] = ACTIONS(2657),
    [anon_sym_consteval] = ACTIONS(2657),
    [anon_sym_PROGMEM] = ACTIONS(2657),
    [aux_sym_primitive_type_token1] = ACTIONS(2657),
    [anon_sym_byte] = ACTIONS(2657),
    [anon_sym_word] = ACTIONS(2657),
    [anon_sym_enum] = ACTIONS(2657),
    [anon_sym_class] = ACTIONS(2657),
    [anon_sym_struct] = ACTIONS(2657),
    [anon_sym_union] = ACTIONS(2657),
    [anon_sym_if] = ACTIONS(2657),
    [anon_sym_else] = ACTIONS(2657),
    [anon_sym_switch] = ACTIONS(2657),
    [anon_sym_case] = ACTIONS(2657),
    [anon_sym_default] = ACTIONS(2657),
    [anon_sym_while] = ACTIONS(2657),
    [anon_sym_do] = ACTIONS(2657),
    [anon_sym_for] = ACTIONS(2657),
    [anon_sym_return] = ACTIONS(2657),
    [anon_sym_break] = ACTIONS(2657),
    [anon_sym_continue] = ACTIONS(2657),
    [anon_sym_goto] = ACTIONS(2657),
    [anon_sym___try] = ACTIONS(2657),
    [anon_sym___leave] = ACTIONS(2657),
    [anon_sym_not] = ACTIONS(2657),
    [anon_sym_compl] = ACTIONS(2657),
    [anon_sym_DASH_DASH] = ACTIONS(2659),
    [anon_sym_PLUS_PLUS] = ACTIONS(2659),
    [anon_sym_sizeof] = ACTIONS(2657),
    [anon_sym___alignof__] = ACTIONS(2657),
    [anon_sym___alignof] = ACTIONS(2657),
    [anon_sym__alignof] = ACTIONS(2657),
    [anon_sym_alignof] = ACTIONS(2657),
    [anon_sym__Alignof] = ACTIONS(2657),
    [anon_sym_offsetof] = ACTIONS(2657),
    [anon_sym__Generic] = ACTIONS(2657),
    [anon_sym_asm] = ACTIONS(2657),
    [anon_sym___asm__] = ACTIONS(2657),
    [aux_sym_number_literal_token1] = ACTIONS(2659),
    [aux_sym_number_literal_token2] = ACTIONS(2657),
    [anon_sym_L_SQUOTE] = ACTIONS(2659),
    [anon_sym_u_SQUOTE] = ACTIONS(2659),
    [anon_sym_U_SQUOTE] = ACTIONS(2659),
    [anon_sym_u8_SQUOTE] = ACTIONS(2659),
    [anon_sym_SQUOTE] = ACTIONS(2659),
    [anon_sym_L_DQUOTE] = ACTIONS(2659),
    [anon_sym_u_DQUOTE] = ACTIONS(2659),
    [anon_sym_U_DQUOTE] = ACTIONS(2659),
    [anon_sym_u8_DQUOTE] = ACTIONS(2659),
    [anon_sym_DQUOTE] = ACTIONS(2659),
    [sym_true] = ACTIONS(2657),
    [sym_false] = ACTIONS(2657),
    [anon_sym_NULL] = ACTIONS(2657),
    [anon_sym_nullptr] = ACTIONS(2657),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2657),
    [anon_sym_decltype] = ACTIONS(2657),
    [anon_sym_virtual] = ACTIONS(2657),
    [anon_sym_alignas] = ACTIONS(2657),
    [anon_sym_explicit] = ACTIONS(2657),
    [anon_sym_typename] = ACTIONS(2657),
    [anon_sym_template] = ACTIONS(2657),
    [anon_sym_operator] = ACTIONS(2657),
    [anon_sym_try] = ACTIONS(2657),
    [anon_sym_delete] = ACTIONS(2657),
    [anon_sym_throw] = ACTIONS(2657),
    [anon_sym_namespace] = ACTIONS(2657),
    [anon_sym_using] = ACTIONS(2657),
    [anon_sym_static_assert] = ACTIONS(2657),
    [anon_sym_concept] = ACTIONS(2657),
    [anon_sym_co_return] = ACTIONS(2657),
    [anon_sym_co_yield] = ACTIONS(2657),
    [anon_sym_R_DQUOTE] = ACTIONS(2659),
    [anon_sym_LR_DQUOTE] = ACTIONS(2659),
    [anon_sym_uR_DQUOTE] = ACTIONS(2659),
    [anon_sym_UR_DQUOTE] = ACTIONS(2659),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2659),
    [anon_sym_co_await] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(2657),
    [anon_sym_requires] = ACTIONS(2657),
    [sym_this] = ACTIONS(2657),
  },
  [618] = {
    [ts_builtin_sym_end] = ACTIONS(2681),
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [619] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_RBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [620] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token2] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [621] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_RBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [622] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_RBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [623] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token2] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [624] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_RBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [625] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_RBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [626] = {
    [ts_builtin_sym_end] = ACTIONS(2741),
    [sym_identifier] = ACTIONS(2739),
    [aux_sym_preproc_include_token1] = ACTIONS(2739),
    [aux_sym_preproc_def_token1] = ACTIONS(2739),
    [aux_sym_preproc_if_token1] = ACTIONS(2739),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2739),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2739),
    [sym_preproc_directive] = ACTIONS(2739),
    [anon_sym_LPAREN2] = ACTIONS(2741),
    [anon_sym_BANG] = ACTIONS(2741),
    [anon_sym_TILDE] = ACTIONS(2741),
    [anon_sym_DASH] = ACTIONS(2739),
    [anon_sym_PLUS] = ACTIONS(2739),
    [anon_sym_STAR] = ACTIONS(2741),
    [anon_sym_AMP_AMP] = ACTIONS(2741),
    [anon_sym_AMP] = ACTIONS(2739),
    [anon_sym_SEMI] = ACTIONS(2741),
    [anon_sym___extension__] = ACTIONS(2739),
    [anon_sym_typedef] = ACTIONS(2739),
    [anon_sym_extern] = ACTIONS(2739),
    [anon_sym___attribute__] = ACTIONS(2739),
    [anon_sym_COLON_COLON] = ACTIONS(2741),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2741),
    [anon_sym___declspec] = ACTIONS(2739),
    [anon_sym___based] = ACTIONS(2739),
    [anon_sym___cdecl] = ACTIONS(2739),
    [anon_sym___clrcall] = ACTIONS(2739),
    [anon_sym___stdcall] = ACTIONS(2739),
    [anon_sym___fastcall] = ACTIONS(2739),
    [anon_sym___thiscall] = ACTIONS(2739),
    [anon_sym___vectorcall] = ACTIONS(2739),
    [anon_sym_LBRACE] = ACTIONS(2741),
    [anon_sym_signed] = ACTIONS(2739),
    [anon_sym_unsigned] = ACTIONS(2739),
    [anon_sym_long] = ACTIONS(2739),
    [anon_sym_short] = ACTIONS(2739),
    [anon_sym_LBRACK] = ACTIONS(2739),
    [anon_sym_static] = ACTIONS(2739),
    [anon_sym_register] = ACTIONS(2739),
    [anon_sym_inline] = ACTIONS(2739),
    [anon_sym___inline] = ACTIONS(2739),
    [anon_sym___inline__] = ACTIONS(2739),
    [anon_sym___forceinline] = ACTIONS(2739),
    [anon_sym_thread_local] = ACTIONS(2739),
    [anon_sym___thread] = ACTIONS(2739),
    [anon_sym_const] = ACTIONS(2739),
    [anon_sym_constexpr] = ACTIONS(2739),
    [anon_sym_volatile] = ACTIONS(2739),
    [anon_sym_restrict] = ACTIONS(2739),
    [anon_sym___restrict__] = ACTIONS(2739),
    [anon_sym__Atomic] = ACTIONS(2739),
    [anon_sym__Noreturn] = ACTIONS(2739),
    [anon_sym_noreturn] = ACTIONS(2739),
    [anon_sym_mutable] = ACTIONS(2739),
    [anon_sym_constinit] = ACTIONS(2739),
    [anon_sym_consteval] = ACTIONS(2739),
    [anon_sym_PROGMEM] = ACTIONS(2739),
    [aux_sym_primitive_type_token1] = ACTIONS(2739),
    [anon_sym_byte] = ACTIONS(2739),
    [anon_sym_word] = ACTIONS(2739),
    [anon_sym_enum] = ACTIONS(2739),
    [anon_sym_class] = ACTIONS(2739),
    [anon_sym_struct] = ACTIONS(2739),
    [anon_sym_union] = ACTIONS(2739),
    [anon_sym_if] = ACTIONS(2739),
    [anon_sym_else] = ACTIONS(2739),
    [anon_sym_switch] = ACTIONS(2739),
    [anon_sym_case] = ACTIONS(2739),
    [anon_sym_default] = ACTIONS(2739),
    [anon_sym_while] = ACTIONS(2739),
    [anon_sym_do] = ACTIONS(2739),
    [anon_sym_for] = ACTIONS(2739),
    [anon_sym_return] = ACTIONS(2739),
    [anon_sym_break] = ACTIONS(2739),
    [anon_sym_continue] = ACTIONS(2739),
    [anon_sym_goto] = ACTIONS(2739),
    [anon_sym___try] = ACTIONS(2739),
    [anon_sym___leave] = ACTIONS(2739),
    [anon_sym_not] = ACTIONS(2739),
    [anon_sym_compl] = ACTIONS(2739),
    [anon_sym_DASH_DASH] = ACTIONS(2741),
    [anon_sym_PLUS_PLUS] = ACTIONS(2741),
    [anon_sym_sizeof] = ACTIONS(2739),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2739),
    [anon_sym__Generic] = ACTIONS(2739),
    [anon_sym_asm] = ACTIONS(2739),
    [anon_sym___asm__] = ACTIONS(2739),
    [aux_sym_number_literal_token1] = ACTIONS(2741),
    [aux_sym_number_literal_token2] = ACTIONS(2739),
    [anon_sym_L_SQUOTE] = ACTIONS(2741),
    [anon_sym_u_SQUOTE] = ACTIONS(2741),
    [anon_sym_U_SQUOTE] = ACTIONS(2741),
    [anon_sym_u8_SQUOTE] = ACTIONS(2741),
    [anon_sym_SQUOTE] = ACTIONS(2741),
    [anon_sym_L_DQUOTE] = ACTIONS(2741),
    [anon_sym_u_DQUOTE] = ACTIONS(2741),
    [anon_sym_U_DQUOTE] = ACTIONS(2741),
    [anon_sym_u8_DQUOTE] = ACTIONS(2741),
    [anon_sym_DQUOTE] = ACTIONS(2741),
    [sym_true] = ACTIONS(2739),
    [sym_false] = ACTIONS(2739),
    [anon_sym_NULL] = ACTIONS(2739),
    [anon_sym_nullptr] = ACTIONS(2739),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2739),
    [anon_sym_decltype] = ACTIONS(2739),
    [anon_sym_virtual] = ACTIONS(2739),
    [anon_sym_alignas] = ACTIONS(2739),
    [anon_sym_explicit] = ACTIONS(2739),
    [anon_sym_typename] = ACTIONS(2739),
    [anon_sym_template] = ACTIONS(2739),
    [anon_sym_operator] = ACTIONS(2739),
    [anon_sym_try] = ACTIONS(2739),
    [anon_sym_delete] = ACTIONS(2739),
    [anon_sym_throw] = ACTIONS(2739),
    [anon_sym_namespace] = ACTIONS(2739),
    [anon_sym_using] = ACTIONS(2739),
    [anon_sym_static_assert] = ACTIONS(2739),
    [anon_sym_concept] = ACTIONS(2739),
    [anon_sym_co_return] = ACTIONS(2739),
    [anon_sym_co_yield] = ACTIONS(2739),
    [anon_sym_R_DQUOTE] = ACTIONS(2741),
    [anon_sym_LR_DQUOTE] = ACTIONS(2741),
    [anon_sym_uR_DQUOTE] = ACTIONS(2741),
    [anon_sym_UR_DQUOTE] = ACTIONS(2741),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2741),
    [anon_sym_co_await] = ACTIONS(2739),
    [anon_sym_new] = ACTIONS(2739),
    [anon_sym_requires] = ACTIONS(2739),
    [sym_this] = ACTIONS(2739),
  },
  [627] = {
    [sym_identifier] = ACTIONS(2735),
    [aux_sym_preproc_include_token1] = ACTIONS(2735),
    [aux_sym_preproc_def_token1] = ACTIONS(2735),
    [aux_sym_preproc_if_token1] = ACTIONS(2735),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2735),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2735),
    [sym_preproc_directive] = ACTIONS(2735),
    [anon_sym_LPAREN2] = ACTIONS(2737),
    [anon_sym_BANG] = ACTIONS(2737),
    [anon_sym_TILDE] = ACTIONS(2737),
    [anon_sym_DASH] = ACTIONS(2735),
    [anon_sym_PLUS] = ACTIONS(2735),
    [anon_sym_STAR] = ACTIONS(2737),
    [anon_sym_AMP_AMP] = ACTIONS(2737),
    [anon_sym_AMP] = ACTIONS(2735),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym___extension__] = ACTIONS(2735),
    [anon_sym_typedef] = ACTIONS(2735),
    [anon_sym_extern] = ACTIONS(2735),
    [anon_sym___attribute__] = ACTIONS(2735),
    [anon_sym_COLON_COLON] = ACTIONS(2737),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2737),
    [anon_sym___declspec] = ACTIONS(2735),
    [anon_sym___based] = ACTIONS(2735),
    [anon_sym___cdecl] = ACTIONS(2735),
    [anon_sym___clrcall] = ACTIONS(2735),
    [anon_sym___stdcall] = ACTIONS(2735),
    [anon_sym___fastcall] = ACTIONS(2735),
    [anon_sym___thiscall] = ACTIONS(2735),
    [anon_sym___vectorcall] = ACTIONS(2735),
    [anon_sym_LBRACE] = ACTIONS(2737),
    [anon_sym_RBRACE] = ACTIONS(2737),
    [anon_sym_signed] = ACTIONS(2735),
    [anon_sym_unsigned] = ACTIONS(2735),
    [anon_sym_long] = ACTIONS(2735),
    [anon_sym_short] = ACTIONS(2735),
    [anon_sym_LBRACK] = ACTIONS(2735),
    [anon_sym_static] = ACTIONS(2735),
    [anon_sym_register] = ACTIONS(2735),
    [anon_sym_inline] = ACTIONS(2735),
    [anon_sym___inline] = ACTIONS(2735),
    [anon_sym___inline__] = ACTIONS(2735),
    [anon_sym___forceinline] = ACTIONS(2735),
    [anon_sym_thread_local] = ACTIONS(2735),
    [anon_sym___thread] = ACTIONS(2735),
    [anon_sym_const] = ACTIONS(2735),
    [anon_sym_constexpr] = ACTIONS(2735),
    [anon_sym_volatile] = ACTIONS(2735),
    [anon_sym_restrict] = ACTIONS(2735),
    [anon_sym___restrict__] = ACTIONS(2735),
    [anon_sym__Atomic] = ACTIONS(2735),
    [anon_sym__Noreturn] = ACTIONS(2735),
    [anon_sym_noreturn] = ACTIONS(2735),
    [anon_sym_mutable] = ACTIONS(2735),
    [anon_sym_constinit] = ACTIONS(2735),
    [anon_sym_consteval] = ACTIONS(2735),
    [anon_sym_PROGMEM] = ACTIONS(2735),
    [aux_sym_primitive_type_token1] = ACTIONS(2735),
    [anon_sym_byte] = ACTIONS(2735),
    [anon_sym_word] = ACTIONS(2735),
    [anon_sym_enum] = ACTIONS(2735),
    [anon_sym_class] = ACTIONS(2735),
    [anon_sym_struct] = ACTIONS(2735),
    [anon_sym_union] = ACTIONS(2735),
    [anon_sym_if] = ACTIONS(2735),
    [anon_sym_else] = ACTIONS(2735),
    [anon_sym_switch] = ACTIONS(2735),
    [anon_sym_case] = ACTIONS(2735),
    [anon_sym_default] = ACTIONS(2735),
    [anon_sym_while] = ACTIONS(2735),
    [anon_sym_do] = ACTIONS(2735),
    [anon_sym_for] = ACTIONS(2735),
    [anon_sym_return] = ACTIONS(2735),
    [anon_sym_break] = ACTIONS(2735),
    [anon_sym_continue] = ACTIONS(2735),
    [anon_sym_goto] = ACTIONS(2735),
    [anon_sym___try] = ACTIONS(2735),
    [anon_sym___leave] = ACTIONS(2735),
    [anon_sym_not] = ACTIONS(2735),
    [anon_sym_compl] = ACTIONS(2735),
    [anon_sym_DASH_DASH] = ACTIONS(2737),
    [anon_sym_PLUS_PLUS] = ACTIONS(2737),
    [anon_sym_sizeof] = ACTIONS(2735),
    [anon_sym___alignof__] = ACTIONS(2735),
    [anon_sym___alignof] = ACTIONS(2735),
    [anon_sym__alignof] = ACTIONS(2735),
    [anon_sym_alignof] = ACTIONS(2735),
    [anon_sym__Alignof] = ACTIONS(2735),
    [anon_sym_offsetof] = ACTIONS(2735),
    [anon_sym__Generic] = ACTIONS(2735),
    [anon_sym_asm] = ACTIONS(2735),
    [anon_sym___asm__] = ACTIONS(2735),
    [aux_sym_number_literal_token1] = ACTIONS(2737),
    [aux_sym_number_literal_token2] = ACTIONS(2735),
    [anon_sym_L_SQUOTE] = ACTIONS(2737),
    [anon_sym_u_SQUOTE] = ACTIONS(2737),
    [anon_sym_U_SQUOTE] = ACTIONS(2737),
    [anon_sym_u8_SQUOTE] = ACTIONS(2737),
    [anon_sym_SQUOTE] = ACTIONS(2737),
    [anon_sym_L_DQUOTE] = ACTIONS(2737),
    [anon_sym_u_DQUOTE] = ACTIONS(2737),
    [anon_sym_U_DQUOTE] = ACTIONS(2737),
    [anon_sym_u8_DQUOTE] = ACTIONS(2737),
    [anon_sym_DQUOTE] = ACTIONS(2737),
    [sym_true] = ACTIONS(2735),
    [sym_false] = ACTIONS(2735),
    [anon_sym_NULL] = ACTIONS(2735),
    [anon_sym_nullptr] = ACTIONS(2735),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2735),
    [anon_sym_decltype] = ACTIONS(2735),
    [anon_sym_virtual] = ACTIONS(2735),
    [anon_sym_alignas] = ACTIONS(2735),
    [anon_sym_explicit] = ACTIONS(2735),
    [anon_sym_typename] = ACTIONS(2735),
    [anon_sym_template] = ACTIONS(2735),
    [anon_sym_operator] = ACTIONS(2735),
    [anon_sym_try] = ACTIONS(2735),
    [anon_sym_delete] = ACTIONS(2735),
    [anon_sym_throw] = ACTIONS(2735),
    [anon_sym_namespace] = ACTIONS(2735),
    [anon_sym_using] = ACTIONS(2735),
    [anon_sym_static_assert] = ACTIONS(2735),
    [anon_sym_concept] = ACTIONS(2735),
    [anon_sym_co_return] = ACTIONS(2735),
    [anon_sym_co_yield] = ACTIONS(2735),
    [anon_sym_R_DQUOTE] = ACTIONS(2737),
    [anon_sym_LR_DQUOTE] = ACTIONS(2737),
    [anon_sym_uR_DQUOTE] = ACTIONS(2737),
    [anon_sym_UR_DQUOTE] = ACTIONS(2737),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2737),
    [anon_sym_co_await] = ACTIONS(2735),
    [anon_sym_new] = ACTIONS(2735),
    [anon_sym_requires] = ACTIONS(2735),
    [sym_this] = ACTIONS(2735),
  },
  [628] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_RBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [629] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_RBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [630] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token2] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [631] = {
    [ts_builtin_sym_end] = ACTIONS(2645),
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [632] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_RBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [633] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_RBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [634] = {
    [ts_builtin_sym_end] = ACTIONS(2655),
    [sym_identifier] = ACTIONS(2653),
    [aux_sym_preproc_include_token1] = ACTIONS(2653),
    [aux_sym_preproc_def_token1] = ACTIONS(2653),
    [aux_sym_preproc_if_token1] = ACTIONS(2653),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2653),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2653),
    [sym_preproc_directive] = ACTIONS(2653),
    [anon_sym_LPAREN2] = ACTIONS(2655),
    [anon_sym_BANG] = ACTIONS(2655),
    [anon_sym_TILDE] = ACTIONS(2655),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_AMP_AMP] = ACTIONS(2655),
    [anon_sym_AMP] = ACTIONS(2653),
    [anon_sym_SEMI] = ACTIONS(2655),
    [anon_sym___extension__] = ACTIONS(2653),
    [anon_sym_typedef] = ACTIONS(2653),
    [anon_sym_extern] = ACTIONS(2653),
    [anon_sym___attribute__] = ACTIONS(2653),
    [anon_sym_COLON_COLON] = ACTIONS(2655),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2655),
    [anon_sym___declspec] = ACTIONS(2653),
    [anon_sym___based] = ACTIONS(2653),
    [anon_sym___cdecl] = ACTIONS(2653),
    [anon_sym___clrcall] = ACTIONS(2653),
    [anon_sym___stdcall] = ACTIONS(2653),
    [anon_sym___fastcall] = ACTIONS(2653),
    [anon_sym___thiscall] = ACTIONS(2653),
    [anon_sym___vectorcall] = ACTIONS(2653),
    [anon_sym_LBRACE] = ACTIONS(2655),
    [anon_sym_signed] = ACTIONS(2653),
    [anon_sym_unsigned] = ACTIONS(2653),
    [anon_sym_long] = ACTIONS(2653),
    [anon_sym_short] = ACTIONS(2653),
    [anon_sym_LBRACK] = ACTIONS(2653),
    [anon_sym_static] = ACTIONS(2653),
    [anon_sym_register] = ACTIONS(2653),
    [anon_sym_inline] = ACTIONS(2653),
    [anon_sym___inline] = ACTIONS(2653),
    [anon_sym___inline__] = ACTIONS(2653),
    [anon_sym___forceinline] = ACTIONS(2653),
    [anon_sym_thread_local] = ACTIONS(2653),
    [anon_sym___thread] = ACTIONS(2653),
    [anon_sym_const] = ACTIONS(2653),
    [anon_sym_constexpr] = ACTIONS(2653),
    [anon_sym_volatile] = ACTIONS(2653),
    [anon_sym_restrict] = ACTIONS(2653),
    [anon_sym___restrict__] = ACTIONS(2653),
    [anon_sym__Atomic] = ACTIONS(2653),
    [anon_sym__Noreturn] = ACTIONS(2653),
    [anon_sym_noreturn] = ACTIONS(2653),
    [anon_sym_mutable] = ACTIONS(2653),
    [anon_sym_constinit] = ACTIONS(2653),
    [anon_sym_consteval] = ACTIONS(2653),
    [anon_sym_PROGMEM] = ACTIONS(2653),
    [aux_sym_primitive_type_token1] = ACTIONS(2653),
    [anon_sym_byte] = ACTIONS(2653),
    [anon_sym_word] = ACTIONS(2653),
    [anon_sym_enum] = ACTIONS(2653),
    [anon_sym_class] = ACTIONS(2653),
    [anon_sym_struct] = ACTIONS(2653),
    [anon_sym_union] = ACTIONS(2653),
    [anon_sym_if] = ACTIONS(2653),
    [anon_sym_else] = ACTIONS(2653),
    [anon_sym_switch] = ACTIONS(2653),
    [anon_sym_case] = ACTIONS(2653),
    [anon_sym_default] = ACTIONS(2653),
    [anon_sym_while] = ACTIONS(2653),
    [anon_sym_do] = ACTIONS(2653),
    [anon_sym_for] = ACTIONS(2653),
    [anon_sym_return] = ACTIONS(2653),
    [anon_sym_break] = ACTIONS(2653),
    [anon_sym_continue] = ACTIONS(2653),
    [anon_sym_goto] = ACTIONS(2653),
    [anon_sym___try] = ACTIONS(2653),
    [anon_sym___leave] = ACTIONS(2653),
    [anon_sym_not] = ACTIONS(2653),
    [anon_sym_compl] = ACTIONS(2653),
    [anon_sym_DASH_DASH] = ACTIONS(2655),
    [anon_sym_PLUS_PLUS] = ACTIONS(2655),
    [anon_sym_sizeof] = ACTIONS(2653),
    [anon_sym___alignof__] = ACTIONS(2653),
    [anon_sym___alignof] = ACTIONS(2653),
    [anon_sym__alignof] = ACTIONS(2653),
    [anon_sym_alignof] = ACTIONS(2653),
    [anon_sym__Alignof] = ACTIONS(2653),
    [anon_sym_offsetof] = ACTIONS(2653),
    [anon_sym__Generic] = ACTIONS(2653),
    [anon_sym_asm] = ACTIONS(2653),
    [anon_sym___asm__] = ACTIONS(2653),
    [aux_sym_number_literal_token1] = ACTIONS(2655),
    [aux_sym_number_literal_token2] = ACTIONS(2653),
    [anon_sym_L_SQUOTE] = ACTIONS(2655),
    [anon_sym_u_SQUOTE] = ACTIONS(2655),
    [anon_sym_U_SQUOTE] = ACTIONS(2655),
    [anon_sym_u8_SQUOTE] = ACTIONS(2655),
    [anon_sym_SQUOTE] = ACTIONS(2655),
    [anon_sym_L_DQUOTE] = ACTIONS(2655),
    [anon_sym_u_DQUOTE] = ACTIONS(2655),
    [anon_sym_U_DQUOTE] = ACTIONS(2655),
    [anon_sym_u8_DQUOTE] = ACTIONS(2655),
    [anon_sym_DQUOTE] = ACTIONS(2655),
    [sym_true] = ACTIONS(2653),
    [sym_false] = ACTIONS(2653),
    [anon_sym_NULL] = ACTIONS(2653),
    [anon_sym_nullptr] = ACTIONS(2653),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2653),
    [anon_sym_decltype] = ACTIONS(2653),
    [anon_sym_virtual] = ACTIONS(2653),
    [anon_sym_alignas] = ACTIONS(2653),
    [anon_sym_explicit] = ACTIONS(2653),
    [anon_sym_typename] = ACTIONS(2653),
    [anon_sym_template] = ACTIONS(2653),
    [anon_sym_operator] = ACTIONS(2653),
    [anon_sym_try] = ACTIONS(2653),
    [anon_sym_delete] = ACTIONS(2653),
    [anon_sym_throw] = ACTIONS(2653),
    [anon_sym_namespace] = ACTIONS(2653),
    [anon_sym_using] = ACTIONS(2653),
    [anon_sym_static_assert] = ACTIONS(2653),
    [anon_sym_concept] = ACTIONS(2653),
    [anon_sym_co_return] = ACTIONS(2653),
    [anon_sym_co_yield] = ACTIONS(2653),
    [anon_sym_R_DQUOTE] = ACTIONS(2655),
    [anon_sym_LR_DQUOTE] = ACTIONS(2655),
    [anon_sym_uR_DQUOTE] = ACTIONS(2655),
    [anon_sym_UR_DQUOTE] = ACTIONS(2655),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2655),
    [anon_sym_co_await] = ACTIONS(2653),
    [anon_sym_new] = ACTIONS(2653),
    [anon_sym_requires] = ACTIONS(2653),
    [sym_this] = ACTIONS(2653),
  },
  [635] = {
    [sym_identifier] = ACTIONS(2643),
    [aux_sym_preproc_include_token1] = ACTIONS(2643),
    [aux_sym_preproc_def_token1] = ACTIONS(2643),
    [aux_sym_preproc_if_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2643),
    [sym_preproc_directive] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP_AMP] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym___based] = ACTIONS(2643),
    [anon_sym___cdecl] = ACTIONS(2643),
    [anon_sym___clrcall] = ACTIONS(2643),
    [anon_sym___stdcall] = ACTIONS(2643),
    [anon_sym___fastcall] = ACTIONS(2643),
    [anon_sym___thiscall] = ACTIONS(2643),
    [anon_sym___vectorcall] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_RBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2643),
    [anon_sym_default] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_explicit] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_operator] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_namespace] = ACTIONS(2643),
    [anon_sym_using] = ACTIONS(2643),
    [anon_sym_static_assert] = ACTIONS(2643),
    [anon_sym_concept] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [636] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_RBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [637] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token2] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [638] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token2] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [639] = {
    [ts_builtin_sym_end] = ACTIONS(2711),
    [sym_identifier] = ACTIONS(2709),
    [aux_sym_preproc_include_token1] = ACTIONS(2709),
    [aux_sym_preproc_def_token1] = ACTIONS(2709),
    [aux_sym_preproc_if_token1] = ACTIONS(2709),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2709),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2709),
    [sym_preproc_directive] = ACTIONS(2709),
    [anon_sym_LPAREN2] = ACTIONS(2711),
    [anon_sym_BANG] = ACTIONS(2711),
    [anon_sym_TILDE] = ACTIONS(2711),
    [anon_sym_DASH] = ACTIONS(2709),
    [anon_sym_PLUS] = ACTIONS(2709),
    [anon_sym_STAR] = ACTIONS(2711),
    [anon_sym_AMP_AMP] = ACTIONS(2711),
    [anon_sym_AMP] = ACTIONS(2709),
    [anon_sym_SEMI] = ACTIONS(2711),
    [anon_sym___extension__] = ACTIONS(2709),
    [anon_sym_typedef] = ACTIONS(2709),
    [anon_sym_extern] = ACTIONS(2709),
    [anon_sym___attribute__] = ACTIONS(2709),
    [anon_sym_COLON_COLON] = ACTIONS(2711),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2711),
    [anon_sym___declspec] = ACTIONS(2709),
    [anon_sym___based] = ACTIONS(2709),
    [anon_sym___cdecl] = ACTIONS(2709),
    [anon_sym___clrcall] = ACTIONS(2709),
    [anon_sym___stdcall] = ACTIONS(2709),
    [anon_sym___fastcall] = ACTIONS(2709),
    [anon_sym___thiscall] = ACTIONS(2709),
    [anon_sym___vectorcall] = ACTIONS(2709),
    [anon_sym_LBRACE] = ACTIONS(2711),
    [anon_sym_signed] = ACTIONS(2709),
    [anon_sym_unsigned] = ACTIONS(2709),
    [anon_sym_long] = ACTIONS(2709),
    [anon_sym_short] = ACTIONS(2709),
    [anon_sym_LBRACK] = ACTIONS(2709),
    [anon_sym_static] = ACTIONS(2709),
    [anon_sym_register] = ACTIONS(2709),
    [anon_sym_inline] = ACTIONS(2709),
    [anon_sym___inline] = ACTIONS(2709),
    [anon_sym___inline__] = ACTIONS(2709),
    [anon_sym___forceinline] = ACTIONS(2709),
    [anon_sym_thread_local] = ACTIONS(2709),
    [anon_sym___thread] = ACTIONS(2709),
    [anon_sym_const] = ACTIONS(2709),
    [anon_sym_constexpr] = ACTIONS(2709),
    [anon_sym_volatile] = ACTIONS(2709),
    [anon_sym_restrict] = ACTIONS(2709),
    [anon_sym___restrict__] = ACTIONS(2709),
    [anon_sym__Atomic] = ACTIONS(2709),
    [anon_sym__Noreturn] = ACTIONS(2709),
    [anon_sym_noreturn] = ACTIONS(2709),
    [anon_sym_mutable] = ACTIONS(2709),
    [anon_sym_constinit] = ACTIONS(2709),
    [anon_sym_consteval] = ACTIONS(2709),
    [anon_sym_PROGMEM] = ACTIONS(2709),
    [aux_sym_primitive_type_token1] = ACTIONS(2709),
    [anon_sym_byte] = ACTIONS(2709),
    [anon_sym_word] = ACTIONS(2709),
    [anon_sym_enum] = ACTIONS(2709),
    [anon_sym_class] = ACTIONS(2709),
    [anon_sym_struct] = ACTIONS(2709),
    [anon_sym_union] = ACTIONS(2709),
    [anon_sym_if] = ACTIONS(2709),
    [anon_sym_else] = ACTIONS(2709),
    [anon_sym_switch] = ACTIONS(2709),
    [anon_sym_case] = ACTIONS(2709),
    [anon_sym_default] = ACTIONS(2709),
    [anon_sym_while] = ACTIONS(2709),
    [anon_sym_do] = ACTIONS(2709),
    [anon_sym_for] = ACTIONS(2709),
    [anon_sym_return] = ACTIONS(2709),
    [anon_sym_break] = ACTIONS(2709),
    [anon_sym_continue] = ACTIONS(2709),
    [anon_sym_goto] = ACTIONS(2709),
    [anon_sym___try] = ACTIONS(2709),
    [anon_sym___leave] = ACTIONS(2709),
    [anon_sym_not] = ACTIONS(2709),
    [anon_sym_compl] = ACTIONS(2709),
    [anon_sym_DASH_DASH] = ACTIONS(2711),
    [anon_sym_PLUS_PLUS] = ACTIONS(2711),
    [anon_sym_sizeof] = ACTIONS(2709),
    [anon_sym___alignof__] = ACTIONS(2709),
    [anon_sym___alignof] = ACTIONS(2709),
    [anon_sym__alignof] = ACTIONS(2709),
    [anon_sym_alignof] = ACTIONS(2709),
    [anon_sym__Alignof] = ACTIONS(2709),
    [anon_sym_offsetof] = ACTIONS(2709),
    [anon_sym__Generic] = ACTIONS(2709),
    [anon_sym_asm] = ACTIONS(2709),
    [anon_sym___asm__] = ACTIONS(2709),
    [aux_sym_number_literal_token1] = ACTIONS(2711),
    [aux_sym_number_literal_token2] = ACTIONS(2709),
    [anon_sym_L_SQUOTE] = ACTIONS(2711),
    [anon_sym_u_SQUOTE] = ACTIONS(2711),
    [anon_sym_U_SQUOTE] = ACTIONS(2711),
    [anon_sym_u8_SQUOTE] = ACTIONS(2711),
    [anon_sym_SQUOTE] = ACTIONS(2711),
    [anon_sym_L_DQUOTE] = ACTIONS(2711),
    [anon_sym_u_DQUOTE] = ACTIONS(2711),
    [anon_sym_U_DQUOTE] = ACTIONS(2711),
    [anon_sym_u8_DQUOTE] = ACTIONS(2711),
    [anon_sym_DQUOTE] = ACTIONS(2711),
    [sym_true] = ACTIONS(2709),
    [sym_false] = ACTIONS(2709),
    [anon_sym_NULL] = ACTIONS(2709),
    [anon_sym_nullptr] = ACTIONS(2709),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2709),
    [anon_sym_decltype] = ACTIONS(2709),
    [anon_sym_virtual] = ACTIONS(2709),
    [anon_sym_alignas] = ACTIONS(2709),
    [anon_sym_explicit] = ACTIONS(2709),
    [anon_sym_typename] = ACTIONS(2709),
    [anon_sym_template] = ACTIONS(2709),
    [anon_sym_operator] = ACTIONS(2709),
    [anon_sym_try] = ACTIONS(2709),
    [anon_sym_delete] = ACTIONS(2709),
    [anon_sym_throw] = ACTIONS(2709),
    [anon_sym_namespace] = ACTIONS(2709),
    [anon_sym_using] = ACTIONS(2709),
    [anon_sym_static_assert] = ACTIONS(2709),
    [anon_sym_concept] = ACTIONS(2709),
    [anon_sym_co_return] = ACTIONS(2709),
    [anon_sym_co_yield] = ACTIONS(2709),
    [anon_sym_R_DQUOTE] = ACTIONS(2711),
    [anon_sym_LR_DQUOTE] = ACTIONS(2711),
    [anon_sym_uR_DQUOTE] = ACTIONS(2711),
    [anon_sym_UR_DQUOTE] = ACTIONS(2711),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2711),
    [anon_sym_co_await] = ACTIONS(2709),
    [anon_sym_new] = ACTIONS(2709),
    [anon_sym_requires] = ACTIONS(2709),
    [sym_this] = ACTIONS(2709),
  },
  [640] = {
    [ts_builtin_sym_end] = ACTIONS(2725),
    [sym_identifier] = ACTIONS(2723),
    [aux_sym_preproc_include_token1] = ACTIONS(2723),
    [aux_sym_preproc_def_token1] = ACTIONS(2723),
    [aux_sym_preproc_if_token1] = ACTIONS(2723),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2723),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2723),
    [sym_preproc_directive] = ACTIONS(2723),
    [anon_sym_LPAREN2] = ACTIONS(2725),
    [anon_sym_BANG] = ACTIONS(2725),
    [anon_sym_TILDE] = ACTIONS(2725),
    [anon_sym_DASH] = ACTIONS(2723),
    [anon_sym_PLUS] = ACTIONS(2723),
    [anon_sym_STAR] = ACTIONS(2725),
    [anon_sym_AMP_AMP] = ACTIONS(2725),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_SEMI] = ACTIONS(2725),
    [anon_sym___extension__] = ACTIONS(2723),
    [anon_sym_typedef] = ACTIONS(2723),
    [anon_sym_extern] = ACTIONS(2723),
    [anon_sym___attribute__] = ACTIONS(2723),
    [anon_sym_COLON_COLON] = ACTIONS(2725),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2725),
    [anon_sym___declspec] = ACTIONS(2723),
    [anon_sym___based] = ACTIONS(2723),
    [anon_sym___cdecl] = ACTIONS(2723),
    [anon_sym___clrcall] = ACTIONS(2723),
    [anon_sym___stdcall] = ACTIONS(2723),
    [anon_sym___fastcall] = ACTIONS(2723),
    [anon_sym___thiscall] = ACTIONS(2723),
    [anon_sym___vectorcall] = ACTIONS(2723),
    [anon_sym_LBRACE] = ACTIONS(2725),
    [anon_sym_signed] = ACTIONS(2723),
    [anon_sym_unsigned] = ACTIONS(2723),
    [anon_sym_long] = ACTIONS(2723),
    [anon_sym_short] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_static] = ACTIONS(2723),
    [anon_sym_register] = ACTIONS(2723),
    [anon_sym_inline] = ACTIONS(2723),
    [anon_sym___inline] = ACTIONS(2723),
    [anon_sym___inline__] = ACTIONS(2723),
    [anon_sym___forceinline] = ACTIONS(2723),
    [anon_sym_thread_local] = ACTIONS(2723),
    [anon_sym___thread] = ACTIONS(2723),
    [anon_sym_const] = ACTIONS(2723),
    [anon_sym_constexpr] = ACTIONS(2723),
    [anon_sym_volatile] = ACTIONS(2723),
    [anon_sym_restrict] = ACTIONS(2723),
    [anon_sym___restrict__] = ACTIONS(2723),
    [anon_sym__Atomic] = ACTIONS(2723),
    [anon_sym__Noreturn] = ACTIONS(2723),
    [anon_sym_noreturn] = ACTIONS(2723),
    [anon_sym_mutable] = ACTIONS(2723),
    [anon_sym_constinit] = ACTIONS(2723),
    [anon_sym_consteval] = ACTIONS(2723),
    [anon_sym_PROGMEM] = ACTIONS(2723),
    [aux_sym_primitive_type_token1] = ACTIONS(2723),
    [anon_sym_byte] = ACTIONS(2723),
    [anon_sym_word] = ACTIONS(2723),
    [anon_sym_enum] = ACTIONS(2723),
    [anon_sym_class] = ACTIONS(2723),
    [anon_sym_struct] = ACTIONS(2723),
    [anon_sym_union] = ACTIONS(2723),
    [anon_sym_if] = ACTIONS(2723),
    [anon_sym_else] = ACTIONS(2723),
    [anon_sym_switch] = ACTIONS(2723),
    [anon_sym_case] = ACTIONS(2723),
    [anon_sym_default] = ACTIONS(2723),
    [anon_sym_while] = ACTIONS(2723),
    [anon_sym_do] = ACTIONS(2723),
    [anon_sym_for] = ACTIONS(2723),
    [anon_sym_return] = ACTIONS(2723),
    [anon_sym_break] = ACTIONS(2723),
    [anon_sym_continue] = ACTIONS(2723),
    [anon_sym_goto] = ACTIONS(2723),
    [anon_sym___try] = ACTIONS(2723),
    [anon_sym___leave] = ACTIONS(2723),
    [anon_sym_not] = ACTIONS(2723),
    [anon_sym_compl] = ACTIONS(2723),
    [anon_sym_DASH_DASH] = ACTIONS(2725),
    [anon_sym_PLUS_PLUS] = ACTIONS(2725),
    [anon_sym_sizeof] = ACTIONS(2723),
    [anon_sym___alignof__] = ACTIONS(2723),
    [anon_sym___alignof] = ACTIONS(2723),
    [anon_sym__alignof] = ACTIONS(2723),
    [anon_sym_alignof] = ACTIONS(2723),
    [anon_sym__Alignof] = ACTIONS(2723),
    [anon_sym_offsetof] = ACTIONS(2723),
    [anon_sym__Generic] = ACTIONS(2723),
    [anon_sym_asm] = ACTIONS(2723),
    [anon_sym___asm__] = ACTIONS(2723),
    [aux_sym_number_literal_token1] = ACTIONS(2725),
    [aux_sym_number_literal_token2] = ACTIONS(2723),
    [anon_sym_L_SQUOTE] = ACTIONS(2725),
    [anon_sym_u_SQUOTE] = ACTIONS(2725),
    [anon_sym_U_SQUOTE] = ACTIONS(2725),
    [anon_sym_u8_SQUOTE] = ACTIONS(2725),
    [anon_sym_SQUOTE] = ACTIONS(2725),
    [anon_sym_L_DQUOTE] = ACTIONS(2725),
    [anon_sym_u_DQUOTE] = ACTIONS(2725),
    [anon_sym_U_DQUOTE] = ACTIONS(2725),
    [anon_sym_u8_DQUOTE] = ACTIONS(2725),
    [anon_sym_DQUOTE] = ACTIONS(2725),
    [sym_true] = ACTIONS(2723),
    [sym_false] = ACTIONS(2723),
    [anon_sym_NULL] = ACTIONS(2723),
    [anon_sym_nullptr] = ACTIONS(2723),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2723),
    [anon_sym_decltype] = ACTIONS(2723),
    [anon_sym_virtual] = ACTIONS(2723),
    [anon_sym_alignas] = ACTIONS(2723),
    [anon_sym_explicit] = ACTIONS(2723),
    [anon_sym_typename] = ACTIONS(2723),
    [anon_sym_template] = ACTIONS(2723),
    [anon_sym_operator] = ACTIONS(2723),
    [anon_sym_try] = ACTIONS(2723),
    [anon_sym_delete] = ACTIONS(2723),
    [anon_sym_throw] = ACTIONS(2723),
    [anon_sym_namespace] = ACTIONS(2723),
    [anon_sym_using] = ACTIONS(2723),
    [anon_sym_static_assert] = ACTIONS(2723),
    [anon_sym_concept] = ACTIONS(2723),
    [anon_sym_co_return] = ACTIONS(2723),
    [anon_sym_co_yield] = ACTIONS(2723),
    [anon_sym_R_DQUOTE] = ACTIONS(2725),
    [anon_sym_LR_DQUOTE] = ACTIONS(2725),
    [anon_sym_uR_DQUOTE] = ACTIONS(2725),
    [anon_sym_UR_DQUOTE] = ACTIONS(2725),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2725),
    [anon_sym_co_await] = ACTIONS(2723),
    [anon_sym_new] = ACTIONS(2723),
    [anon_sym_requires] = ACTIONS(2723),
    [sym_this] = ACTIONS(2723),
  },
  [641] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token2] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [642] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token2] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [643] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_RBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [644] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token2] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [645] = {
    [sym_identifier] = ACTIONS(2731),
    [aux_sym_preproc_include_token1] = ACTIONS(2731),
    [aux_sym_preproc_def_token1] = ACTIONS(2731),
    [aux_sym_preproc_if_token1] = ACTIONS(2731),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2731),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2731),
    [sym_preproc_directive] = ACTIONS(2731),
    [anon_sym_LPAREN2] = ACTIONS(2733),
    [anon_sym_BANG] = ACTIONS(2733),
    [anon_sym_TILDE] = ACTIONS(2733),
    [anon_sym_DASH] = ACTIONS(2731),
    [anon_sym_PLUS] = ACTIONS(2731),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_AMP_AMP] = ACTIONS(2733),
    [anon_sym_AMP] = ACTIONS(2731),
    [anon_sym_SEMI] = ACTIONS(2733),
    [anon_sym___extension__] = ACTIONS(2731),
    [anon_sym_typedef] = ACTIONS(2731),
    [anon_sym_extern] = ACTIONS(2731),
    [anon_sym___attribute__] = ACTIONS(2731),
    [anon_sym_COLON_COLON] = ACTIONS(2733),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2733),
    [anon_sym___declspec] = ACTIONS(2731),
    [anon_sym___based] = ACTIONS(2731),
    [anon_sym___cdecl] = ACTIONS(2731),
    [anon_sym___clrcall] = ACTIONS(2731),
    [anon_sym___stdcall] = ACTIONS(2731),
    [anon_sym___fastcall] = ACTIONS(2731),
    [anon_sym___thiscall] = ACTIONS(2731),
    [anon_sym___vectorcall] = ACTIONS(2731),
    [anon_sym_LBRACE] = ACTIONS(2733),
    [anon_sym_RBRACE] = ACTIONS(2733),
    [anon_sym_signed] = ACTIONS(2731),
    [anon_sym_unsigned] = ACTIONS(2731),
    [anon_sym_long] = ACTIONS(2731),
    [anon_sym_short] = ACTIONS(2731),
    [anon_sym_LBRACK] = ACTIONS(2731),
    [anon_sym_static] = ACTIONS(2731),
    [anon_sym_register] = ACTIONS(2731),
    [anon_sym_inline] = ACTIONS(2731),
    [anon_sym___inline] = ACTIONS(2731),
    [anon_sym___inline__] = ACTIONS(2731),
    [anon_sym___forceinline] = ACTIONS(2731),
    [anon_sym_thread_local] = ACTIONS(2731),
    [anon_sym___thread] = ACTIONS(2731),
    [anon_sym_const] = ACTIONS(2731),
    [anon_sym_constexpr] = ACTIONS(2731),
    [anon_sym_volatile] = ACTIONS(2731),
    [anon_sym_restrict] = ACTIONS(2731),
    [anon_sym___restrict__] = ACTIONS(2731),
    [anon_sym__Atomic] = ACTIONS(2731),
    [anon_sym__Noreturn] = ACTIONS(2731),
    [anon_sym_noreturn] = ACTIONS(2731),
    [anon_sym_mutable] = ACTIONS(2731),
    [anon_sym_constinit] = ACTIONS(2731),
    [anon_sym_consteval] = ACTIONS(2731),
    [anon_sym_PROGMEM] = ACTIONS(2731),
    [aux_sym_primitive_type_token1] = ACTIONS(2731),
    [anon_sym_byte] = ACTIONS(2731),
    [anon_sym_word] = ACTIONS(2731),
    [anon_sym_enum] = ACTIONS(2731),
    [anon_sym_class] = ACTIONS(2731),
    [anon_sym_struct] = ACTIONS(2731),
    [anon_sym_union] = ACTIONS(2731),
    [anon_sym_if] = ACTIONS(2731),
    [anon_sym_else] = ACTIONS(2731),
    [anon_sym_switch] = ACTIONS(2731),
    [anon_sym_case] = ACTIONS(2731),
    [anon_sym_default] = ACTIONS(2731),
    [anon_sym_while] = ACTIONS(2731),
    [anon_sym_do] = ACTIONS(2731),
    [anon_sym_for] = ACTIONS(2731),
    [anon_sym_return] = ACTIONS(2731),
    [anon_sym_break] = ACTIONS(2731),
    [anon_sym_continue] = ACTIONS(2731),
    [anon_sym_goto] = ACTIONS(2731),
    [anon_sym___try] = ACTIONS(2731),
    [anon_sym___leave] = ACTIONS(2731),
    [anon_sym_not] = ACTIONS(2731),
    [anon_sym_compl] = ACTIONS(2731),
    [anon_sym_DASH_DASH] = ACTIONS(2733),
    [anon_sym_PLUS_PLUS] = ACTIONS(2733),
    [anon_sym_sizeof] = ACTIONS(2731),
    [anon_sym___alignof__] = ACTIONS(2731),
    [anon_sym___alignof] = ACTIONS(2731),
    [anon_sym__alignof] = ACTIONS(2731),
    [anon_sym_alignof] = ACTIONS(2731),
    [anon_sym__Alignof] = ACTIONS(2731),
    [anon_sym_offsetof] = ACTIONS(2731),
    [anon_sym__Generic] = ACTIONS(2731),
    [anon_sym_asm] = ACTIONS(2731),
    [anon_sym___asm__] = ACTIONS(2731),
    [aux_sym_number_literal_token1] = ACTIONS(2733),
    [aux_sym_number_literal_token2] = ACTIONS(2731),
    [anon_sym_L_SQUOTE] = ACTIONS(2733),
    [anon_sym_u_SQUOTE] = ACTIONS(2733),
    [anon_sym_U_SQUOTE] = ACTIONS(2733),
    [anon_sym_u8_SQUOTE] = ACTIONS(2733),
    [anon_sym_SQUOTE] = ACTIONS(2733),
    [anon_sym_L_DQUOTE] = ACTIONS(2733),
    [anon_sym_u_DQUOTE] = ACTIONS(2733),
    [anon_sym_U_DQUOTE] = ACTIONS(2733),
    [anon_sym_u8_DQUOTE] = ACTIONS(2733),
    [anon_sym_DQUOTE] = ACTIONS(2733),
    [sym_true] = ACTIONS(2731),
    [sym_false] = ACTIONS(2731),
    [anon_sym_NULL] = ACTIONS(2731),
    [anon_sym_nullptr] = ACTIONS(2731),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2731),
    [anon_sym_decltype] = ACTIONS(2731),
    [anon_sym_virtual] = ACTIONS(2731),
    [anon_sym_alignas] = ACTIONS(2731),
    [anon_sym_explicit] = ACTIONS(2731),
    [anon_sym_typename] = ACTIONS(2731),
    [anon_sym_template] = ACTIONS(2731),
    [anon_sym_operator] = ACTIONS(2731),
    [anon_sym_try] = ACTIONS(2731),
    [anon_sym_delete] = ACTIONS(2731),
    [anon_sym_throw] = ACTIONS(2731),
    [anon_sym_namespace] = ACTIONS(2731),
    [anon_sym_using] = ACTIONS(2731),
    [anon_sym_static_assert] = ACTIONS(2731),
    [anon_sym_concept] = ACTIONS(2731),
    [anon_sym_co_return] = ACTIONS(2731),
    [anon_sym_co_yield] = ACTIONS(2731),
    [anon_sym_R_DQUOTE] = ACTIONS(2733),
    [anon_sym_LR_DQUOTE] = ACTIONS(2733),
    [anon_sym_uR_DQUOTE] = ACTIONS(2733),
    [anon_sym_UR_DQUOTE] = ACTIONS(2733),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2733),
    [anon_sym_co_await] = ACTIONS(2731),
    [anon_sym_new] = ACTIONS(2731),
    [anon_sym_requires] = ACTIONS(2731),
    [sym_this] = ACTIONS(2731),
  },
  [646] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_RBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [647] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_RBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [648] = {
    [ts_builtin_sym_end] = ACTIONS(2725),
    [sym_identifier] = ACTIONS(2723),
    [aux_sym_preproc_include_token1] = ACTIONS(2723),
    [aux_sym_preproc_def_token1] = ACTIONS(2723),
    [aux_sym_preproc_if_token1] = ACTIONS(2723),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2723),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2723),
    [sym_preproc_directive] = ACTIONS(2723),
    [anon_sym_LPAREN2] = ACTIONS(2725),
    [anon_sym_BANG] = ACTIONS(2725),
    [anon_sym_TILDE] = ACTIONS(2725),
    [anon_sym_DASH] = ACTIONS(2723),
    [anon_sym_PLUS] = ACTIONS(2723),
    [anon_sym_STAR] = ACTIONS(2725),
    [anon_sym_AMP_AMP] = ACTIONS(2725),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_SEMI] = ACTIONS(2725),
    [anon_sym___extension__] = ACTIONS(2723),
    [anon_sym_typedef] = ACTIONS(2723),
    [anon_sym_extern] = ACTIONS(2723),
    [anon_sym___attribute__] = ACTIONS(2723),
    [anon_sym_COLON_COLON] = ACTIONS(2725),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2725),
    [anon_sym___declspec] = ACTIONS(2723),
    [anon_sym___based] = ACTIONS(2723),
    [anon_sym___cdecl] = ACTIONS(2723),
    [anon_sym___clrcall] = ACTIONS(2723),
    [anon_sym___stdcall] = ACTIONS(2723),
    [anon_sym___fastcall] = ACTIONS(2723),
    [anon_sym___thiscall] = ACTIONS(2723),
    [anon_sym___vectorcall] = ACTIONS(2723),
    [anon_sym_LBRACE] = ACTIONS(2725),
    [anon_sym_signed] = ACTIONS(2723),
    [anon_sym_unsigned] = ACTIONS(2723),
    [anon_sym_long] = ACTIONS(2723),
    [anon_sym_short] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_static] = ACTIONS(2723),
    [anon_sym_register] = ACTIONS(2723),
    [anon_sym_inline] = ACTIONS(2723),
    [anon_sym___inline] = ACTIONS(2723),
    [anon_sym___inline__] = ACTIONS(2723),
    [anon_sym___forceinline] = ACTIONS(2723),
    [anon_sym_thread_local] = ACTIONS(2723),
    [anon_sym___thread] = ACTIONS(2723),
    [anon_sym_const] = ACTIONS(2723),
    [anon_sym_constexpr] = ACTIONS(2723),
    [anon_sym_volatile] = ACTIONS(2723),
    [anon_sym_restrict] = ACTIONS(2723),
    [anon_sym___restrict__] = ACTIONS(2723),
    [anon_sym__Atomic] = ACTIONS(2723),
    [anon_sym__Noreturn] = ACTIONS(2723),
    [anon_sym_noreturn] = ACTIONS(2723),
    [anon_sym_mutable] = ACTIONS(2723),
    [anon_sym_constinit] = ACTIONS(2723),
    [anon_sym_consteval] = ACTIONS(2723),
    [anon_sym_PROGMEM] = ACTIONS(2723),
    [aux_sym_primitive_type_token1] = ACTIONS(2723),
    [anon_sym_byte] = ACTIONS(2723),
    [anon_sym_word] = ACTIONS(2723),
    [anon_sym_enum] = ACTIONS(2723),
    [anon_sym_class] = ACTIONS(2723),
    [anon_sym_struct] = ACTIONS(2723),
    [anon_sym_union] = ACTIONS(2723),
    [anon_sym_if] = ACTIONS(2723),
    [anon_sym_else] = ACTIONS(2723),
    [anon_sym_switch] = ACTIONS(2723),
    [anon_sym_case] = ACTIONS(2723),
    [anon_sym_default] = ACTIONS(2723),
    [anon_sym_while] = ACTIONS(2723),
    [anon_sym_do] = ACTIONS(2723),
    [anon_sym_for] = ACTIONS(2723),
    [anon_sym_return] = ACTIONS(2723),
    [anon_sym_break] = ACTIONS(2723),
    [anon_sym_continue] = ACTIONS(2723),
    [anon_sym_goto] = ACTIONS(2723),
    [anon_sym___try] = ACTIONS(2723),
    [anon_sym___leave] = ACTIONS(2723),
    [anon_sym_not] = ACTIONS(2723),
    [anon_sym_compl] = ACTIONS(2723),
    [anon_sym_DASH_DASH] = ACTIONS(2725),
    [anon_sym_PLUS_PLUS] = ACTIONS(2725),
    [anon_sym_sizeof] = ACTIONS(2723),
    [anon_sym___alignof__] = ACTIONS(2723),
    [anon_sym___alignof] = ACTIONS(2723),
    [anon_sym__alignof] = ACTIONS(2723),
    [anon_sym_alignof] = ACTIONS(2723),
    [anon_sym__Alignof] = ACTIONS(2723),
    [anon_sym_offsetof] = ACTIONS(2723),
    [anon_sym__Generic] = ACTIONS(2723),
    [anon_sym_asm] = ACTIONS(2723),
    [anon_sym___asm__] = ACTIONS(2723),
    [aux_sym_number_literal_token1] = ACTIONS(2725),
    [aux_sym_number_literal_token2] = ACTIONS(2723),
    [anon_sym_L_SQUOTE] = ACTIONS(2725),
    [anon_sym_u_SQUOTE] = ACTIONS(2725),
    [anon_sym_U_SQUOTE] = ACTIONS(2725),
    [anon_sym_u8_SQUOTE] = ACTIONS(2725),
    [anon_sym_SQUOTE] = ACTIONS(2725),
    [anon_sym_L_DQUOTE] = ACTIONS(2725),
    [anon_sym_u_DQUOTE] = ACTIONS(2725),
    [anon_sym_U_DQUOTE] = ACTIONS(2725),
    [anon_sym_u8_DQUOTE] = ACTIONS(2725),
    [anon_sym_DQUOTE] = ACTIONS(2725),
    [sym_true] = ACTIONS(2723),
    [sym_false] = ACTIONS(2723),
    [anon_sym_NULL] = ACTIONS(2723),
    [anon_sym_nullptr] = ACTIONS(2723),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2723),
    [anon_sym_decltype] = ACTIONS(2723),
    [anon_sym_virtual] = ACTIONS(2723),
    [anon_sym_alignas] = ACTIONS(2723),
    [anon_sym_explicit] = ACTIONS(2723),
    [anon_sym_typename] = ACTIONS(2723),
    [anon_sym_template] = ACTIONS(2723),
    [anon_sym_operator] = ACTIONS(2723),
    [anon_sym_try] = ACTIONS(2723),
    [anon_sym_delete] = ACTIONS(2723),
    [anon_sym_throw] = ACTIONS(2723),
    [anon_sym_namespace] = ACTIONS(2723),
    [anon_sym_using] = ACTIONS(2723),
    [anon_sym_static_assert] = ACTIONS(2723),
    [anon_sym_concept] = ACTIONS(2723),
    [anon_sym_co_return] = ACTIONS(2723),
    [anon_sym_co_yield] = ACTIONS(2723),
    [anon_sym_R_DQUOTE] = ACTIONS(2725),
    [anon_sym_LR_DQUOTE] = ACTIONS(2725),
    [anon_sym_uR_DQUOTE] = ACTIONS(2725),
    [anon_sym_UR_DQUOTE] = ACTIONS(2725),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2725),
    [anon_sym_co_await] = ACTIONS(2723),
    [anon_sym_new] = ACTIONS(2723),
    [anon_sym_requires] = ACTIONS(2723),
    [sym_this] = ACTIONS(2723),
  },
  [649] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token2] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [650] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_RBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [651] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token2] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [652] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_RBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [653] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_RBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [654] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token2] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [655] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_RBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [656] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_RBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [657] = {
    [ts_builtin_sym_end] = ACTIONS(2715),
    [sym_identifier] = ACTIONS(2713),
    [aux_sym_preproc_include_token1] = ACTIONS(2713),
    [aux_sym_preproc_def_token1] = ACTIONS(2713),
    [aux_sym_preproc_if_token1] = ACTIONS(2713),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2713),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2713),
    [sym_preproc_directive] = ACTIONS(2713),
    [anon_sym_LPAREN2] = ACTIONS(2715),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_DASH] = ACTIONS(2713),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_STAR] = ACTIONS(2715),
    [anon_sym_AMP_AMP] = ACTIONS(2715),
    [anon_sym_AMP] = ACTIONS(2713),
    [anon_sym_SEMI] = ACTIONS(2715),
    [anon_sym___extension__] = ACTIONS(2713),
    [anon_sym_typedef] = ACTIONS(2713),
    [anon_sym_extern] = ACTIONS(2713),
    [anon_sym___attribute__] = ACTIONS(2713),
    [anon_sym_COLON_COLON] = ACTIONS(2715),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2715),
    [anon_sym___declspec] = ACTIONS(2713),
    [anon_sym___based] = ACTIONS(2713),
    [anon_sym___cdecl] = ACTIONS(2713),
    [anon_sym___clrcall] = ACTIONS(2713),
    [anon_sym___stdcall] = ACTIONS(2713),
    [anon_sym___fastcall] = ACTIONS(2713),
    [anon_sym___thiscall] = ACTIONS(2713),
    [anon_sym___vectorcall] = ACTIONS(2713),
    [anon_sym_LBRACE] = ACTIONS(2715),
    [anon_sym_signed] = ACTIONS(2713),
    [anon_sym_unsigned] = ACTIONS(2713),
    [anon_sym_long] = ACTIONS(2713),
    [anon_sym_short] = ACTIONS(2713),
    [anon_sym_LBRACK] = ACTIONS(2713),
    [anon_sym_static] = ACTIONS(2713),
    [anon_sym_register] = ACTIONS(2713),
    [anon_sym_inline] = ACTIONS(2713),
    [anon_sym___inline] = ACTIONS(2713),
    [anon_sym___inline__] = ACTIONS(2713),
    [anon_sym___forceinline] = ACTIONS(2713),
    [anon_sym_thread_local] = ACTIONS(2713),
    [anon_sym___thread] = ACTIONS(2713),
    [anon_sym_const] = ACTIONS(2713),
    [anon_sym_constexpr] = ACTIONS(2713),
    [anon_sym_volatile] = ACTIONS(2713),
    [anon_sym_restrict] = ACTIONS(2713),
    [anon_sym___restrict__] = ACTIONS(2713),
    [anon_sym__Atomic] = ACTIONS(2713),
    [anon_sym__Noreturn] = ACTIONS(2713),
    [anon_sym_noreturn] = ACTIONS(2713),
    [anon_sym_mutable] = ACTIONS(2713),
    [anon_sym_constinit] = ACTIONS(2713),
    [anon_sym_consteval] = ACTIONS(2713),
    [anon_sym_PROGMEM] = ACTIONS(2713),
    [aux_sym_primitive_type_token1] = ACTIONS(2713),
    [anon_sym_byte] = ACTIONS(2713),
    [anon_sym_word] = ACTIONS(2713),
    [anon_sym_enum] = ACTIONS(2713),
    [anon_sym_class] = ACTIONS(2713),
    [anon_sym_struct] = ACTIONS(2713),
    [anon_sym_union] = ACTIONS(2713),
    [anon_sym_if] = ACTIONS(2713),
    [anon_sym_else] = ACTIONS(2713),
    [anon_sym_switch] = ACTIONS(2713),
    [anon_sym_case] = ACTIONS(2713),
    [anon_sym_default] = ACTIONS(2713),
    [anon_sym_while] = ACTIONS(2713),
    [anon_sym_do] = ACTIONS(2713),
    [anon_sym_for] = ACTIONS(2713),
    [anon_sym_return] = ACTIONS(2713),
    [anon_sym_break] = ACTIONS(2713),
    [anon_sym_continue] = ACTIONS(2713),
    [anon_sym_goto] = ACTIONS(2713),
    [anon_sym___try] = ACTIONS(2713),
    [anon_sym___leave] = ACTIONS(2713),
    [anon_sym_not] = ACTIONS(2713),
    [anon_sym_compl] = ACTIONS(2713),
    [anon_sym_DASH_DASH] = ACTIONS(2715),
    [anon_sym_PLUS_PLUS] = ACTIONS(2715),
    [anon_sym_sizeof] = ACTIONS(2713),
    [anon_sym___alignof__] = ACTIONS(2713),
    [anon_sym___alignof] = ACTIONS(2713),
    [anon_sym__alignof] = ACTIONS(2713),
    [anon_sym_alignof] = ACTIONS(2713),
    [anon_sym__Alignof] = ACTIONS(2713),
    [anon_sym_offsetof] = ACTIONS(2713),
    [anon_sym__Generic] = ACTIONS(2713),
    [anon_sym_asm] = ACTIONS(2713),
    [anon_sym___asm__] = ACTIONS(2713),
    [aux_sym_number_literal_token1] = ACTIONS(2715),
    [aux_sym_number_literal_token2] = ACTIONS(2713),
    [anon_sym_L_SQUOTE] = ACTIONS(2715),
    [anon_sym_u_SQUOTE] = ACTIONS(2715),
    [anon_sym_U_SQUOTE] = ACTIONS(2715),
    [anon_sym_u8_SQUOTE] = ACTIONS(2715),
    [anon_sym_SQUOTE] = ACTIONS(2715),
    [anon_sym_L_DQUOTE] = ACTIONS(2715),
    [anon_sym_u_DQUOTE] = ACTIONS(2715),
    [anon_sym_U_DQUOTE] = ACTIONS(2715),
    [anon_sym_u8_DQUOTE] = ACTIONS(2715),
    [anon_sym_DQUOTE] = ACTIONS(2715),
    [sym_true] = ACTIONS(2713),
    [sym_false] = ACTIONS(2713),
    [anon_sym_NULL] = ACTIONS(2713),
    [anon_sym_nullptr] = ACTIONS(2713),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2713),
    [anon_sym_decltype] = ACTIONS(2713),
    [anon_sym_virtual] = ACTIONS(2713),
    [anon_sym_alignas] = ACTIONS(2713),
    [anon_sym_explicit] = ACTIONS(2713),
    [anon_sym_typename] = ACTIONS(2713),
    [anon_sym_template] = ACTIONS(2713),
    [anon_sym_operator] = ACTIONS(2713),
    [anon_sym_try] = ACTIONS(2713),
    [anon_sym_delete] = ACTIONS(2713),
    [anon_sym_throw] = ACTIONS(2713),
    [anon_sym_namespace] = ACTIONS(2713),
    [anon_sym_using] = ACTIONS(2713),
    [anon_sym_static_assert] = ACTIONS(2713),
    [anon_sym_concept] = ACTIONS(2713),
    [anon_sym_co_return] = ACTIONS(2713),
    [anon_sym_co_yield] = ACTIONS(2713),
    [anon_sym_R_DQUOTE] = ACTIONS(2715),
    [anon_sym_LR_DQUOTE] = ACTIONS(2715),
    [anon_sym_uR_DQUOTE] = ACTIONS(2715),
    [anon_sym_UR_DQUOTE] = ACTIONS(2715),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2715),
    [anon_sym_co_await] = ACTIONS(2713),
    [anon_sym_new] = ACTIONS(2713),
    [anon_sym_requires] = ACTIONS(2713),
    [sym_this] = ACTIONS(2713),
  },
  [658] = {
    [ts_builtin_sym_end] = ACTIONS(2719),
    [sym_identifier] = ACTIONS(2717),
    [aux_sym_preproc_include_token1] = ACTIONS(2717),
    [aux_sym_preproc_def_token1] = ACTIONS(2717),
    [aux_sym_preproc_if_token1] = ACTIONS(2717),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2717),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2717),
    [sym_preproc_directive] = ACTIONS(2717),
    [anon_sym_LPAREN2] = ACTIONS(2719),
    [anon_sym_BANG] = ACTIONS(2719),
    [anon_sym_TILDE] = ACTIONS(2719),
    [anon_sym_DASH] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP_AMP] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2717),
    [anon_sym_SEMI] = ACTIONS(2719),
    [anon_sym___extension__] = ACTIONS(2717),
    [anon_sym_typedef] = ACTIONS(2717),
    [anon_sym_extern] = ACTIONS(2717),
    [anon_sym___attribute__] = ACTIONS(2717),
    [anon_sym_COLON_COLON] = ACTIONS(2719),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2719),
    [anon_sym___declspec] = ACTIONS(2717),
    [anon_sym___based] = ACTIONS(2717),
    [anon_sym___cdecl] = ACTIONS(2717),
    [anon_sym___clrcall] = ACTIONS(2717),
    [anon_sym___stdcall] = ACTIONS(2717),
    [anon_sym___fastcall] = ACTIONS(2717),
    [anon_sym___thiscall] = ACTIONS(2717),
    [anon_sym___vectorcall] = ACTIONS(2717),
    [anon_sym_LBRACE] = ACTIONS(2719),
    [anon_sym_signed] = ACTIONS(2717),
    [anon_sym_unsigned] = ACTIONS(2717),
    [anon_sym_long] = ACTIONS(2717),
    [anon_sym_short] = ACTIONS(2717),
    [anon_sym_LBRACK] = ACTIONS(2717),
    [anon_sym_static] = ACTIONS(2717),
    [anon_sym_register] = ACTIONS(2717),
    [anon_sym_inline] = ACTIONS(2717),
    [anon_sym___inline] = ACTIONS(2717),
    [anon_sym___inline__] = ACTIONS(2717),
    [anon_sym___forceinline] = ACTIONS(2717),
    [anon_sym_thread_local] = ACTIONS(2717),
    [anon_sym___thread] = ACTIONS(2717),
    [anon_sym_const] = ACTIONS(2717),
    [anon_sym_constexpr] = ACTIONS(2717),
    [anon_sym_volatile] = ACTIONS(2717),
    [anon_sym_restrict] = ACTIONS(2717),
    [anon_sym___restrict__] = ACTIONS(2717),
    [anon_sym__Atomic] = ACTIONS(2717),
    [anon_sym__Noreturn] = ACTIONS(2717),
    [anon_sym_noreturn] = ACTIONS(2717),
    [anon_sym_mutable] = ACTIONS(2717),
    [anon_sym_constinit] = ACTIONS(2717),
    [anon_sym_consteval] = ACTIONS(2717),
    [anon_sym_PROGMEM] = ACTIONS(2717),
    [aux_sym_primitive_type_token1] = ACTIONS(2717),
    [anon_sym_byte] = ACTIONS(2717),
    [anon_sym_word] = ACTIONS(2717),
    [anon_sym_enum] = ACTIONS(2717),
    [anon_sym_class] = ACTIONS(2717),
    [anon_sym_struct] = ACTIONS(2717),
    [anon_sym_union] = ACTIONS(2717),
    [anon_sym_if] = ACTIONS(2717),
    [anon_sym_else] = ACTIONS(2717),
    [anon_sym_switch] = ACTIONS(2717),
    [anon_sym_case] = ACTIONS(2717),
    [anon_sym_default] = ACTIONS(2717),
    [anon_sym_while] = ACTIONS(2717),
    [anon_sym_do] = ACTIONS(2717),
    [anon_sym_for] = ACTIONS(2717),
    [anon_sym_return] = ACTIONS(2717),
    [anon_sym_break] = ACTIONS(2717),
    [anon_sym_continue] = ACTIONS(2717),
    [anon_sym_goto] = ACTIONS(2717),
    [anon_sym___try] = ACTIONS(2717),
    [anon_sym___leave] = ACTIONS(2717),
    [anon_sym_not] = ACTIONS(2717),
    [anon_sym_compl] = ACTIONS(2717),
    [anon_sym_DASH_DASH] = ACTIONS(2719),
    [anon_sym_PLUS_PLUS] = ACTIONS(2719),
    [anon_sym_sizeof] = ACTIONS(2717),
    [anon_sym___alignof__] = ACTIONS(2717),
    [anon_sym___alignof] = ACTIONS(2717),
    [anon_sym__alignof] = ACTIONS(2717),
    [anon_sym_alignof] = ACTIONS(2717),
    [anon_sym__Alignof] = ACTIONS(2717),
    [anon_sym_offsetof] = ACTIONS(2717),
    [anon_sym__Generic] = ACTIONS(2717),
    [anon_sym_asm] = ACTIONS(2717),
    [anon_sym___asm__] = ACTIONS(2717),
    [aux_sym_number_literal_token1] = ACTIONS(2719),
    [aux_sym_number_literal_token2] = ACTIONS(2717),
    [anon_sym_L_SQUOTE] = ACTIONS(2719),
    [anon_sym_u_SQUOTE] = ACTIONS(2719),
    [anon_sym_U_SQUOTE] = ACTIONS(2719),
    [anon_sym_u8_SQUOTE] = ACTIONS(2719),
    [anon_sym_SQUOTE] = ACTIONS(2719),
    [anon_sym_L_DQUOTE] = ACTIONS(2719),
    [anon_sym_u_DQUOTE] = ACTIONS(2719),
    [anon_sym_U_DQUOTE] = ACTIONS(2719),
    [anon_sym_u8_DQUOTE] = ACTIONS(2719),
    [anon_sym_DQUOTE] = ACTIONS(2719),
    [sym_true] = ACTIONS(2717),
    [sym_false] = ACTIONS(2717),
    [anon_sym_NULL] = ACTIONS(2717),
    [anon_sym_nullptr] = ACTIONS(2717),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2717),
    [anon_sym_decltype] = ACTIONS(2717),
    [anon_sym_virtual] = ACTIONS(2717),
    [anon_sym_alignas] = ACTIONS(2717),
    [anon_sym_explicit] = ACTIONS(2717),
    [anon_sym_typename] = ACTIONS(2717),
    [anon_sym_template] = ACTIONS(2717),
    [anon_sym_operator] = ACTIONS(2717),
    [anon_sym_try] = ACTIONS(2717),
    [anon_sym_delete] = ACTIONS(2717),
    [anon_sym_throw] = ACTIONS(2717),
    [anon_sym_namespace] = ACTIONS(2717),
    [anon_sym_using] = ACTIONS(2717),
    [anon_sym_static_assert] = ACTIONS(2717),
    [anon_sym_concept] = ACTIONS(2717),
    [anon_sym_co_return] = ACTIONS(2717),
    [anon_sym_co_yield] = ACTIONS(2717),
    [anon_sym_R_DQUOTE] = ACTIONS(2719),
    [anon_sym_LR_DQUOTE] = ACTIONS(2719),
    [anon_sym_uR_DQUOTE] = ACTIONS(2719),
    [anon_sym_UR_DQUOTE] = ACTIONS(2719),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2719),
    [anon_sym_co_await] = ACTIONS(2717),
    [anon_sym_new] = ACTIONS(2717),
    [anon_sym_requires] = ACTIONS(2717),
    [sym_this] = ACTIONS(2717),
  },
  [659] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_RBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [660] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_RBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [661] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_RBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [662] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_RBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [663] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_RBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [664] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_RBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [665] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_RBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [666] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_RBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [667] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_RBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [668] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_RBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [669] = {
    [sym_identifier] = ACTIONS(2679),
    [aux_sym_preproc_include_token1] = ACTIONS(2679),
    [aux_sym_preproc_def_token1] = ACTIONS(2679),
    [aux_sym_preproc_if_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2679),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2679),
    [sym_preproc_directive] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP_AMP] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym___based] = ACTIONS(2679),
    [anon_sym___cdecl] = ACTIONS(2679),
    [anon_sym___clrcall] = ACTIONS(2679),
    [anon_sym___stdcall] = ACTIONS(2679),
    [anon_sym___fastcall] = ACTIONS(2679),
    [anon_sym___thiscall] = ACTIONS(2679),
    [anon_sym___vectorcall] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_RBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2679),
    [anon_sym_default] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_explicit] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_operator] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_namespace] = ACTIONS(2679),
    [anon_sym_using] = ACTIONS(2679),
    [anon_sym_static_assert] = ACTIONS(2679),
    [anon_sym_concept] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [670] = {
    [sym_identifier] = ACTIONS(2557),
    [aux_sym_preproc_include_token1] = ACTIONS(2557),
    [aux_sym_preproc_def_token1] = ACTIONS(2557),
    [aux_sym_preproc_if_token1] = ACTIONS(2557),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2557),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2557),
    [sym_preproc_directive] = ACTIONS(2557),
    [anon_sym_LPAREN2] = ACTIONS(2562),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2557),
    [anon_sym_PLUS] = ACTIONS(2557),
    [anon_sym_STAR] = ACTIONS(2562),
    [anon_sym_AMP_AMP] = ACTIONS(2562),
    [anon_sym_AMP] = ACTIONS(2557),
    [anon_sym_SEMI] = ACTIONS(2562),
    [anon_sym___extension__] = ACTIONS(2557),
    [anon_sym_typedef] = ACTIONS(2557),
    [anon_sym_extern] = ACTIONS(2557),
    [anon_sym___attribute__] = ACTIONS(2557),
    [anon_sym_COLON_COLON] = ACTIONS(2562),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2562),
    [anon_sym___declspec] = ACTIONS(2557),
    [anon_sym___based] = ACTIONS(2557),
    [anon_sym___cdecl] = ACTIONS(2557),
    [anon_sym___clrcall] = ACTIONS(2557),
    [anon_sym___stdcall] = ACTIONS(2557),
    [anon_sym___fastcall] = ACTIONS(2557),
    [anon_sym___thiscall] = ACTIONS(2557),
    [anon_sym___vectorcall] = ACTIONS(2557),
    [anon_sym_LBRACE] = ACTIONS(2562),
    [anon_sym_RBRACE] = ACTIONS(2562),
    [anon_sym_signed] = ACTIONS(2557),
    [anon_sym_unsigned] = ACTIONS(2557),
    [anon_sym_long] = ACTIONS(2557),
    [anon_sym_short] = ACTIONS(2557),
    [anon_sym_LBRACK] = ACTIONS(2557),
    [anon_sym_static] = ACTIONS(2557),
    [anon_sym_register] = ACTIONS(2557),
    [anon_sym_inline] = ACTIONS(2557),
    [anon_sym___inline] = ACTIONS(2557),
    [anon_sym___inline__] = ACTIONS(2557),
    [anon_sym___forceinline] = ACTIONS(2557),
    [anon_sym_thread_local] = ACTIONS(2557),
    [anon_sym___thread] = ACTIONS(2557),
    [anon_sym_const] = ACTIONS(2557),
    [anon_sym_constexpr] = ACTIONS(2557),
    [anon_sym_volatile] = ACTIONS(2557),
    [anon_sym_restrict] = ACTIONS(2557),
    [anon_sym___restrict__] = ACTIONS(2557),
    [anon_sym__Atomic] = ACTIONS(2557),
    [anon_sym__Noreturn] = ACTIONS(2557),
    [anon_sym_noreturn] = ACTIONS(2557),
    [anon_sym_mutable] = ACTIONS(2557),
    [anon_sym_constinit] = ACTIONS(2557),
    [anon_sym_consteval] = ACTIONS(2557),
    [anon_sym_PROGMEM] = ACTIONS(2557),
    [aux_sym_primitive_type_token1] = ACTIONS(2557),
    [anon_sym_byte] = ACTIONS(2557),
    [anon_sym_word] = ACTIONS(2557),
    [anon_sym_enum] = ACTIONS(2557),
    [anon_sym_class] = ACTIONS(2557),
    [anon_sym_struct] = ACTIONS(2557),
    [anon_sym_union] = ACTIONS(2557),
    [anon_sym_if] = ACTIONS(2557),
    [anon_sym_else] = ACTIONS(2557),
    [anon_sym_switch] = ACTIONS(2557),
    [anon_sym_case] = ACTIONS(2557),
    [anon_sym_default] = ACTIONS(2557),
    [anon_sym_while] = ACTIONS(2557),
    [anon_sym_do] = ACTIONS(2557),
    [anon_sym_for] = ACTIONS(2557),
    [anon_sym_return] = ACTIONS(2557),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_continue] = ACTIONS(2557),
    [anon_sym_goto] = ACTIONS(2557),
    [anon_sym___try] = ACTIONS(2557),
    [anon_sym___leave] = ACTIONS(2557),
    [anon_sym_not] = ACTIONS(2557),
    [anon_sym_compl] = ACTIONS(2557),
    [anon_sym_DASH_DASH] = ACTIONS(2562),
    [anon_sym_PLUS_PLUS] = ACTIONS(2562),
    [anon_sym_sizeof] = ACTIONS(2557),
    [anon_sym___alignof__] = ACTIONS(2557),
    [anon_sym___alignof] = ACTIONS(2557),
    [anon_sym__alignof] = ACTIONS(2557),
    [anon_sym_alignof] = ACTIONS(2557),
    [anon_sym__Alignof] = ACTIONS(2557),
    [anon_sym_offsetof] = ACTIONS(2557),
    [anon_sym__Generic] = ACTIONS(2557),
    [anon_sym_asm] = ACTIONS(2557),
    [anon_sym___asm__] = ACTIONS(2557),
    [aux_sym_number_literal_token1] = ACTIONS(2562),
    [aux_sym_number_literal_token2] = ACTIONS(2557),
    [anon_sym_L_SQUOTE] = ACTIONS(2562),
    [anon_sym_u_SQUOTE] = ACTIONS(2562),
    [anon_sym_U_SQUOTE] = ACTIONS(2562),
    [anon_sym_u8_SQUOTE] = ACTIONS(2562),
    [anon_sym_SQUOTE] = ACTIONS(2562),
    [anon_sym_L_DQUOTE] = ACTIONS(2562),
    [anon_sym_u_DQUOTE] = ACTIONS(2562),
    [anon_sym_U_DQUOTE] = ACTIONS(2562),
    [anon_sym_u8_DQUOTE] = ACTIONS(2562),
    [anon_sym_DQUOTE] = ACTIONS(2562),
    [sym_true] = ACTIONS(2557),
    [sym_false] = ACTIONS(2557),
    [anon_sym_NULL] = ACTIONS(2557),
    [anon_sym_nullptr] = ACTIONS(2557),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2557),
    [anon_sym_decltype] = ACTIONS(2557),
    [anon_sym_virtual] = ACTIONS(2557),
    [anon_sym_alignas] = ACTIONS(2557),
    [anon_sym_explicit] = ACTIONS(2557),
    [anon_sym_typename] = ACTIONS(2557),
    [anon_sym_template] = ACTIONS(2557),
    [anon_sym_operator] = ACTIONS(2557),
    [anon_sym_try] = ACTIONS(2557),
    [anon_sym_delete] = ACTIONS(2557),
    [anon_sym_throw] = ACTIONS(2557),
    [anon_sym_namespace] = ACTIONS(2557),
    [anon_sym_using] = ACTIONS(2557),
    [anon_sym_static_assert] = ACTIONS(2557),
    [anon_sym_concept] = ACTIONS(2557),
    [anon_sym_co_return] = ACTIONS(2557),
    [anon_sym_co_yield] = ACTIONS(2557),
    [anon_sym_R_DQUOTE] = ACTIONS(2562),
    [anon_sym_LR_DQUOTE] = ACTIONS(2562),
    [anon_sym_uR_DQUOTE] = ACTIONS(2562),
    [anon_sym_UR_DQUOTE] = ACTIONS(2562),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2562),
    [anon_sym_co_await] = ACTIONS(2557),
    [anon_sym_new] = ACTIONS(2557),
    [anon_sym_requires] = ACTIONS(2557),
    [sym_this] = ACTIONS(2557),
  },
  [671] = {
    [sym_identifier] = ACTIONS(3032),
    [aux_sym_preproc_include_token1] = ACTIONS(3032),
    [aux_sym_preproc_def_token1] = ACTIONS(3032),
    [aux_sym_preproc_if_token1] = ACTIONS(3032),
    [aux_sym_preproc_if_token2] = ACTIONS(3032),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3032),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3032),
    [sym_preproc_directive] = ACTIONS(3032),
    [anon_sym_LPAREN2] = ACTIONS(3034),
    [anon_sym_BANG] = ACTIONS(3034),
    [anon_sym_TILDE] = ACTIONS(3034),
    [anon_sym_DASH] = ACTIONS(3032),
    [anon_sym_PLUS] = ACTIONS(3032),
    [anon_sym_STAR] = ACTIONS(3034),
    [anon_sym_AMP_AMP] = ACTIONS(3034),
    [anon_sym_AMP] = ACTIONS(3032),
    [anon_sym_SEMI] = ACTIONS(3034),
    [anon_sym___extension__] = ACTIONS(3032),
    [anon_sym_typedef] = ACTIONS(3032),
    [anon_sym_extern] = ACTIONS(3032),
    [anon_sym___attribute__] = ACTIONS(3032),
    [anon_sym_COLON_COLON] = ACTIONS(3034),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3034),
    [anon_sym___declspec] = ACTIONS(3032),
    [anon_sym___based] = ACTIONS(3032),
    [anon_sym___cdecl] = ACTIONS(3032),
    [anon_sym___clrcall] = ACTIONS(3032),
    [anon_sym___stdcall] = ACTIONS(3032),
    [anon_sym___fastcall] = ACTIONS(3032),
    [anon_sym___thiscall] = ACTIONS(3032),
    [anon_sym___vectorcall] = ACTIONS(3032),
    [anon_sym_LBRACE] = ACTIONS(3034),
    [anon_sym_signed] = ACTIONS(3032),
    [anon_sym_unsigned] = ACTIONS(3032),
    [anon_sym_long] = ACTIONS(3032),
    [anon_sym_short] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(3032),
    [anon_sym_static] = ACTIONS(3032),
    [anon_sym_register] = ACTIONS(3032),
    [anon_sym_inline] = ACTIONS(3032),
    [anon_sym___inline] = ACTIONS(3032),
    [anon_sym___inline__] = ACTIONS(3032),
    [anon_sym___forceinline] = ACTIONS(3032),
    [anon_sym_thread_local] = ACTIONS(3032),
    [anon_sym___thread] = ACTIONS(3032),
    [anon_sym_const] = ACTIONS(3032),
    [anon_sym_constexpr] = ACTIONS(3032),
    [anon_sym_volatile] = ACTIONS(3032),
    [anon_sym_restrict] = ACTIONS(3032),
    [anon_sym___restrict__] = ACTIONS(3032),
    [anon_sym__Atomic] = ACTIONS(3032),
    [anon_sym__Noreturn] = ACTIONS(3032),
    [anon_sym_noreturn] = ACTIONS(3032),
    [anon_sym_mutable] = ACTIONS(3032),
    [anon_sym_constinit] = ACTIONS(3032),
    [anon_sym_consteval] = ACTIONS(3032),
    [anon_sym_PROGMEM] = ACTIONS(3032),
    [aux_sym_primitive_type_token1] = ACTIONS(3032),
    [anon_sym_byte] = ACTIONS(3032),
    [anon_sym_word] = ACTIONS(3032),
    [anon_sym_enum] = ACTIONS(3032),
    [anon_sym_class] = ACTIONS(3032),
    [anon_sym_struct] = ACTIONS(3032),
    [anon_sym_union] = ACTIONS(3032),
    [anon_sym_if] = ACTIONS(3032),
    [anon_sym_switch] = ACTIONS(3032),
    [anon_sym_case] = ACTIONS(3032),
    [anon_sym_default] = ACTIONS(3032),
    [anon_sym_while] = ACTIONS(3032),
    [anon_sym_do] = ACTIONS(3032),
    [anon_sym_for] = ACTIONS(3032),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_break] = ACTIONS(3032),
    [anon_sym_continue] = ACTIONS(3032),
    [anon_sym_goto] = ACTIONS(3032),
    [anon_sym___try] = ACTIONS(3032),
    [anon_sym___leave] = ACTIONS(3032),
    [anon_sym_not] = ACTIONS(3032),
    [anon_sym_compl] = ACTIONS(3032),
    [anon_sym_DASH_DASH] = ACTIONS(3034),
    [anon_sym_PLUS_PLUS] = ACTIONS(3034),
    [anon_sym_sizeof] = ACTIONS(3032),
    [anon_sym___alignof__] = ACTIONS(3032),
    [anon_sym___alignof] = ACTIONS(3032),
    [anon_sym__alignof] = ACTIONS(3032),
    [anon_sym_alignof] = ACTIONS(3032),
    [anon_sym__Alignof] = ACTIONS(3032),
    [anon_sym_offsetof] = ACTIONS(3032),
    [anon_sym__Generic] = ACTIONS(3032),
    [anon_sym_asm] = ACTIONS(3032),
    [anon_sym___asm__] = ACTIONS(3032),
    [aux_sym_number_literal_token1] = ACTIONS(3034),
    [aux_sym_number_literal_token2] = ACTIONS(3032),
    [anon_sym_L_SQUOTE] = ACTIONS(3034),
    [anon_sym_u_SQUOTE] = ACTIONS(3034),
    [anon_sym_U_SQUOTE] = ACTIONS(3034),
    [anon_sym_u8_SQUOTE] = ACTIONS(3034),
    [anon_sym_SQUOTE] = ACTIONS(3034),
    [anon_sym_L_DQUOTE] = ACTIONS(3034),
    [anon_sym_u_DQUOTE] = ACTIONS(3034),
    [anon_sym_U_DQUOTE] = ACTIONS(3034),
    [anon_sym_u8_DQUOTE] = ACTIONS(3034),
    [anon_sym_DQUOTE] = ACTIONS(3034),
    [sym_true] = ACTIONS(3032),
    [sym_false] = ACTIONS(3032),
    [anon_sym_NULL] = ACTIONS(3032),
    [anon_sym_nullptr] = ACTIONS(3032),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3032),
    [anon_sym_decltype] = ACTIONS(3032),
    [anon_sym_virtual] = ACTIONS(3032),
    [anon_sym_alignas] = ACTIONS(3032),
    [anon_sym_explicit] = ACTIONS(3032),
    [anon_sym_typename] = ACTIONS(3032),
    [anon_sym_template] = ACTIONS(3032),
    [anon_sym_operator] = ACTIONS(3032),
    [anon_sym_try] = ACTIONS(3032),
    [anon_sym_delete] = ACTIONS(3032),
    [anon_sym_throw] = ACTIONS(3032),
    [anon_sym_namespace] = ACTIONS(3032),
    [anon_sym_using] = ACTIONS(3032),
    [anon_sym_static_assert] = ACTIONS(3032),
    [anon_sym_concept] = ACTIONS(3032),
    [anon_sym_co_return] = ACTIONS(3032),
    [anon_sym_co_yield] = ACTIONS(3032),
    [anon_sym_R_DQUOTE] = ACTIONS(3034),
    [anon_sym_LR_DQUOTE] = ACTIONS(3034),
    [anon_sym_uR_DQUOTE] = ACTIONS(3034),
    [anon_sym_UR_DQUOTE] = ACTIONS(3034),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3034),
    [anon_sym_co_await] = ACTIONS(3032),
    [anon_sym_new] = ACTIONS(3032),
    [anon_sym_requires] = ACTIONS(3032),
    [sym_this] = ACTIONS(3032),
  },
  [672] = {
    [sym_identifier] = ACTIONS(3164),
    [aux_sym_preproc_include_token1] = ACTIONS(3164),
    [aux_sym_preproc_def_token1] = ACTIONS(3164),
    [aux_sym_preproc_if_token1] = ACTIONS(3164),
    [aux_sym_preproc_if_token2] = ACTIONS(3164),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3164),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3164),
    [sym_preproc_directive] = ACTIONS(3164),
    [anon_sym_LPAREN2] = ACTIONS(3166),
    [anon_sym_BANG] = ACTIONS(3166),
    [anon_sym_TILDE] = ACTIONS(3166),
    [anon_sym_DASH] = ACTIONS(3164),
    [anon_sym_PLUS] = ACTIONS(3164),
    [anon_sym_STAR] = ACTIONS(3166),
    [anon_sym_AMP_AMP] = ACTIONS(3166),
    [anon_sym_AMP] = ACTIONS(3164),
    [anon_sym_SEMI] = ACTIONS(3166),
    [anon_sym___extension__] = ACTIONS(3164),
    [anon_sym_typedef] = ACTIONS(3164),
    [anon_sym_extern] = ACTIONS(3164),
    [anon_sym___attribute__] = ACTIONS(3164),
    [anon_sym_COLON_COLON] = ACTIONS(3166),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3166),
    [anon_sym___declspec] = ACTIONS(3164),
    [anon_sym___based] = ACTIONS(3164),
    [anon_sym___cdecl] = ACTIONS(3164),
    [anon_sym___clrcall] = ACTIONS(3164),
    [anon_sym___stdcall] = ACTIONS(3164),
    [anon_sym___fastcall] = ACTIONS(3164),
    [anon_sym___thiscall] = ACTIONS(3164),
    [anon_sym___vectorcall] = ACTIONS(3164),
    [anon_sym_LBRACE] = ACTIONS(3166),
    [anon_sym_signed] = ACTIONS(3164),
    [anon_sym_unsigned] = ACTIONS(3164),
    [anon_sym_long] = ACTIONS(3164),
    [anon_sym_short] = ACTIONS(3164),
    [anon_sym_LBRACK] = ACTIONS(3164),
    [anon_sym_static] = ACTIONS(3164),
    [anon_sym_register] = ACTIONS(3164),
    [anon_sym_inline] = ACTIONS(3164),
    [anon_sym___inline] = ACTIONS(3164),
    [anon_sym___inline__] = ACTIONS(3164),
    [anon_sym___forceinline] = ACTIONS(3164),
    [anon_sym_thread_local] = ACTIONS(3164),
    [anon_sym___thread] = ACTIONS(3164),
    [anon_sym_const] = ACTIONS(3164),
    [anon_sym_constexpr] = ACTIONS(3164),
    [anon_sym_volatile] = ACTIONS(3164),
    [anon_sym_restrict] = ACTIONS(3164),
    [anon_sym___restrict__] = ACTIONS(3164),
    [anon_sym__Atomic] = ACTIONS(3164),
    [anon_sym__Noreturn] = ACTIONS(3164),
    [anon_sym_noreturn] = ACTIONS(3164),
    [anon_sym_mutable] = ACTIONS(3164),
    [anon_sym_constinit] = ACTIONS(3164),
    [anon_sym_consteval] = ACTIONS(3164),
    [anon_sym_PROGMEM] = ACTIONS(3164),
    [aux_sym_primitive_type_token1] = ACTIONS(3164),
    [anon_sym_byte] = ACTIONS(3164),
    [anon_sym_word] = ACTIONS(3164),
    [anon_sym_enum] = ACTIONS(3164),
    [anon_sym_class] = ACTIONS(3164),
    [anon_sym_struct] = ACTIONS(3164),
    [anon_sym_union] = ACTIONS(3164),
    [anon_sym_if] = ACTIONS(3164),
    [anon_sym_switch] = ACTIONS(3164),
    [anon_sym_case] = ACTIONS(3164),
    [anon_sym_default] = ACTIONS(3164),
    [anon_sym_while] = ACTIONS(3164),
    [anon_sym_do] = ACTIONS(3164),
    [anon_sym_for] = ACTIONS(3164),
    [anon_sym_return] = ACTIONS(3164),
    [anon_sym_break] = ACTIONS(3164),
    [anon_sym_continue] = ACTIONS(3164),
    [anon_sym_goto] = ACTIONS(3164),
    [anon_sym___try] = ACTIONS(3164),
    [anon_sym___leave] = ACTIONS(3164),
    [anon_sym_not] = ACTIONS(3164),
    [anon_sym_compl] = ACTIONS(3164),
    [anon_sym_DASH_DASH] = ACTIONS(3166),
    [anon_sym_PLUS_PLUS] = ACTIONS(3166),
    [anon_sym_sizeof] = ACTIONS(3164),
    [anon_sym___alignof__] = ACTIONS(3164),
    [anon_sym___alignof] = ACTIONS(3164),
    [anon_sym__alignof] = ACTIONS(3164),
    [anon_sym_alignof] = ACTIONS(3164),
    [anon_sym__Alignof] = ACTIONS(3164),
    [anon_sym_offsetof] = ACTIONS(3164),
    [anon_sym__Generic] = ACTIONS(3164),
    [anon_sym_asm] = ACTIONS(3164),
    [anon_sym___asm__] = ACTIONS(3164),
    [aux_sym_number_literal_token1] = ACTIONS(3166),
    [aux_sym_number_literal_token2] = ACTIONS(3164),
    [anon_sym_L_SQUOTE] = ACTIONS(3166),
    [anon_sym_u_SQUOTE] = ACTIONS(3166),
    [anon_sym_U_SQUOTE] = ACTIONS(3166),
    [anon_sym_u8_SQUOTE] = ACTIONS(3166),
    [anon_sym_SQUOTE] = ACTIONS(3166),
    [anon_sym_L_DQUOTE] = ACTIONS(3166),
    [anon_sym_u_DQUOTE] = ACTIONS(3166),
    [anon_sym_U_DQUOTE] = ACTIONS(3166),
    [anon_sym_u8_DQUOTE] = ACTIONS(3166),
    [anon_sym_DQUOTE] = ACTIONS(3166),
    [sym_true] = ACTIONS(3164),
    [sym_false] = ACTIONS(3164),
    [anon_sym_NULL] = ACTIONS(3164),
    [anon_sym_nullptr] = ACTIONS(3164),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3164),
    [anon_sym_decltype] = ACTIONS(3164),
    [anon_sym_virtual] = ACTIONS(3164),
    [anon_sym_alignas] = ACTIONS(3164),
    [anon_sym_explicit] = ACTIONS(3164),
    [anon_sym_typename] = ACTIONS(3164),
    [anon_sym_template] = ACTIONS(3164),
    [anon_sym_operator] = ACTIONS(3164),
    [anon_sym_try] = ACTIONS(3164),
    [anon_sym_delete] = ACTIONS(3164),
    [anon_sym_throw] = ACTIONS(3164),
    [anon_sym_namespace] = ACTIONS(3164),
    [anon_sym_using] = ACTIONS(3164),
    [anon_sym_static_assert] = ACTIONS(3164),
    [anon_sym_concept] = ACTIONS(3164),
    [anon_sym_co_return] = ACTIONS(3164),
    [anon_sym_co_yield] = ACTIONS(3164),
    [anon_sym_R_DQUOTE] = ACTIONS(3166),
    [anon_sym_LR_DQUOTE] = ACTIONS(3166),
    [anon_sym_uR_DQUOTE] = ACTIONS(3166),
    [anon_sym_UR_DQUOTE] = ACTIONS(3166),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3166),
    [anon_sym_co_await] = ACTIONS(3164),
    [anon_sym_new] = ACTIONS(3164),
    [anon_sym_requires] = ACTIONS(3164),
    [sym_this] = ACTIONS(3164),
  },
  [673] = {
    [sym_identifier] = ACTIONS(2967),
    [aux_sym_preproc_include_token1] = ACTIONS(2967),
    [aux_sym_preproc_def_token1] = ACTIONS(2967),
    [aux_sym_preproc_if_token1] = ACTIONS(2967),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2967),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2967),
    [sym_preproc_directive] = ACTIONS(2967),
    [anon_sym_LPAREN2] = ACTIONS(2969),
    [anon_sym_BANG] = ACTIONS(2969),
    [anon_sym_TILDE] = ACTIONS(2969),
    [anon_sym_DASH] = ACTIONS(2967),
    [anon_sym_PLUS] = ACTIONS(2967),
    [anon_sym_STAR] = ACTIONS(2969),
    [anon_sym_AMP_AMP] = ACTIONS(2969),
    [anon_sym_AMP] = ACTIONS(2967),
    [anon_sym_SEMI] = ACTIONS(2969),
    [anon_sym___extension__] = ACTIONS(2967),
    [anon_sym_typedef] = ACTIONS(2967),
    [anon_sym_extern] = ACTIONS(2967),
    [anon_sym___attribute__] = ACTIONS(2967),
    [anon_sym_COLON_COLON] = ACTIONS(2969),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2969),
    [anon_sym___declspec] = ACTIONS(2967),
    [anon_sym___based] = ACTIONS(2967),
    [anon_sym___cdecl] = ACTIONS(2967),
    [anon_sym___clrcall] = ACTIONS(2967),
    [anon_sym___stdcall] = ACTIONS(2967),
    [anon_sym___fastcall] = ACTIONS(2967),
    [anon_sym___thiscall] = ACTIONS(2967),
    [anon_sym___vectorcall] = ACTIONS(2967),
    [anon_sym_LBRACE] = ACTIONS(2969),
    [anon_sym_RBRACE] = ACTIONS(2969),
    [anon_sym_signed] = ACTIONS(2967),
    [anon_sym_unsigned] = ACTIONS(2967),
    [anon_sym_long] = ACTIONS(2967),
    [anon_sym_short] = ACTIONS(2967),
    [anon_sym_LBRACK] = ACTIONS(2967),
    [anon_sym_static] = ACTIONS(2967),
    [anon_sym_register] = ACTIONS(2967),
    [anon_sym_inline] = ACTIONS(2967),
    [anon_sym___inline] = ACTIONS(2967),
    [anon_sym___inline__] = ACTIONS(2967),
    [anon_sym___forceinline] = ACTIONS(2967),
    [anon_sym_thread_local] = ACTIONS(2967),
    [anon_sym___thread] = ACTIONS(2967),
    [anon_sym_const] = ACTIONS(2967),
    [anon_sym_constexpr] = ACTIONS(2967),
    [anon_sym_volatile] = ACTIONS(2967),
    [anon_sym_restrict] = ACTIONS(2967),
    [anon_sym___restrict__] = ACTIONS(2967),
    [anon_sym__Atomic] = ACTIONS(2967),
    [anon_sym__Noreturn] = ACTIONS(2967),
    [anon_sym_noreturn] = ACTIONS(2967),
    [anon_sym_mutable] = ACTIONS(2967),
    [anon_sym_constinit] = ACTIONS(2967),
    [anon_sym_consteval] = ACTIONS(2967),
    [anon_sym_PROGMEM] = ACTIONS(2967),
    [aux_sym_primitive_type_token1] = ACTIONS(2967),
    [anon_sym_byte] = ACTIONS(2967),
    [anon_sym_word] = ACTIONS(2967),
    [anon_sym_enum] = ACTIONS(2967),
    [anon_sym_class] = ACTIONS(2967),
    [anon_sym_struct] = ACTIONS(2967),
    [anon_sym_union] = ACTIONS(2967),
    [anon_sym_if] = ACTIONS(2967),
    [anon_sym_switch] = ACTIONS(2967),
    [anon_sym_case] = ACTIONS(2967),
    [anon_sym_default] = ACTIONS(2967),
    [anon_sym_while] = ACTIONS(2967),
    [anon_sym_do] = ACTIONS(2967),
    [anon_sym_for] = ACTIONS(2967),
    [anon_sym_return] = ACTIONS(2967),
    [anon_sym_break] = ACTIONS(2967),
    [anon_sym_continue] = ACTIONS(2967),
    [anon_sym_goto] = ACTIONS(2967),
    [anon_sym___try] = ACTIONS(2967),
    [anon_sym___leave] = ACTIONS(2967),
    [anon_sym_not] = ACTIONS(2967),
    [anon_sym_compl] = ACTIONS(2967),
    [anon_sym_DASH_DASH] = ACTIONS(2969),
    [anon_sym_PLUS_PLUS] = ACTIONS(2969),
    [anon_sym_sizeof] = ACTIONS(2967),
    [anon_sym___alignof__] = ACTIONS(2967),
    [anon_sym___alignof] = ACTIONS(2967),
    [anon_sym__alignof] = ACTIONS(2967),
    [anon_sym_alignof] = ACTIONS(2967),
    [anon_sym__Alignof] = ACTIONS(2967),
    [anon_sym_offsetof] = ACTIONS(2967),
    [anon_sym__Generic] = ACTIONS(2967),
    [anon_sym_asm] = ACTIONS(2967),
    [anon_sym___asm__] = ACTIONS(2967),
    [aux_sym_number_literal_token1] = ACTIONS(2969),
    [aux_sym_number_literal_token2] = ACTIONS(2967),
    [anon_sym_L_SQUOTE] = ACTIONS(2969),
    [anon_sym_u_SQUOTE] = ACTIONS(2969),
    [anon_sym_U_SQUOTE] = ACTIONS(2969),
    [anon_sym_u8_SQUOTE] = ACTIONS(2969),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_L_DQUOTE] = ACTIONS(2969),
    [anon_sym_u_DQUOTE] = ACTIONS(2969),
    [anon_sym_U_DQUOTE] = ACTIONS(2969),
    [anon_sym_u8_DQUOTE] = ACTIONS(2969),
    [anon_sym_DQUOTE] = ACTIONS(2969),
    [sym_true] = ACTIONS(2967),
    [sym_false] = ACTIONS(2967),
    [anon_sym_NULL] = ACTIONS(2967),
    [anon_sym_nullptr] = ACTIONS(2967),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2967),
    [anon_sym_decltype] = ACTIONS(2967),
    [anon_sym_virtual] = ACTIONS(2967),
    [anon_sym_alignas] = ACTIONS(2967),
    [anon_sym_explicit] = ACTIONS(2967),
    [anon_sym_typename] = ACTIONS(2967),
    [anon_sym_template] = ACTIONS(2967),
    [anon_sym_operator] = ACTIONS(2967),
    [anon_sym_try] = ACTIONS(2967),
    [anon_sym_delete] = ACTIONS(2967),
    [anon_sym_throw] = ACTIONS(2967),
    [anon_sym_namespace] = ACTIONS(2967),
    [anon_sym_using] = ACTIONS(2967),
    [anon_sym_static_assert] = ACTIONS(2967),
    [anon_sym_concept] = ACTIONS(2967),
    [anon_sym_co_return] = ACTIONS(2967),
    [anon_sym_co_yield] = ACTIONS(2967),
    [anon_sym_R_DQUOTE] = ACTIONS(2969),
    [anon_sym_LR_DQUOTE] = ACTIONS(2969),
    [anon_sym_uR_DQUOTE] = ACTIONS(2969),
    [anon_sym_UR_DQUOTE] = ACTIONS(2969),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2969),
    [anon_sym_co_await] = ACTIONS(2967),
    [anon_sym_new] = ACTIONS(2967),
    [anon_sym_requires] = ACTIONS(2967),
    [sym_this] = ACTIONS(2967),
  },
  [674] = {
    [sym_identifier] = ACTIONS(3008),
    [aux_sym_preproc_include_token1] = ACTIONS(3008),
    [aux_sym_preproc_def_token1] = ACTIONS(3008),
    [aux_sym_preproc_if_token1] = ACTIONS(3008),
    [aux_sym_preproc_if_token2] = ACTIONS(3008),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3008),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3008),
    [sym_preproc_directive] = ACTIONS(3008),
    [anon_sym_LPAREN2] = ACTIONS(3010),
    [anon_sym_BANG] = ACTIONS(3010),
    [anon_sym_TILDE] = ACTIONS(3010),
    [anon_sym_DASH] = ACTIONS(3008),
    [anon_sym_PLUS] = ACTIONS(3008),
    [anon_sym_STAR] = ACTIONS(3010),
    [anon_sym_AMP_AMP] = ACTIONS(3010),
    [anon_sym_AMP] = ACTIONS(3008),
    [anon_sym_SEMI] = ACTIONS(3010),
    [anon_sym___extension__] = ACTIONS(3008),
    [anon_sym_typedef] = ACTIONS(3008),
    [anon_sym_extern] = ACTIONS(3008),
    [anon_sym___attribute__] = ACTIONS(3008),
    [anon_sym_COLON_COLON] = ACTIONS(3010),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3010),
    [anon_sym___declspec] = ACTIONS(3008),
    [anon_sym___based] = ACTIONS(3008),
    [anon_sym___cdecl] = ACTIONS(3008),
    [anon_sym___clrcall] = ACTIONS(3008),
    [anon_sym___stdcall] = ACTIONS(3008),
    [anon_sym___fastcall] = ACTIONS(3008),
    [anon_sym___thiscall] = ACTIONS(3008),
    [anon_sym___vectorcall] = ACTIONS(3008),
    [anon_sym_LBRACE] = ACTIONS(3010),
    [anon_sym_signed] = ACTIONS(3008),
    [anon_sym_unsigned] = ACTIONS(3008),
    [anon_sym_long] = ACTIONS(3008),
    [anon_sym_short] = ACTIONS(3008),
    [anon_sym_LBRACK] = ACTIONS(3008),
    [anon_sym_static] = ACTIONS(3008),
    [anon_sym_register] = ACTIONS(3008),
    [anon_sym_inline] = ACTIONS(3008),
    [anon_sym___inline] = ACTIONS(3008),
    [anon_sym___inline__] = ACTIONS(3008),
    [anon_sym___forceinline] = ACTIONS(3008),
    [anon_sym_thread_local] = ACTIONS(3008),
    [anon_sym___thread] = ACTIONS(3008),
    [anon_sym_const] = ACTIONS(3008),
    [anon_sym_constexpr] = ACTIONS(3008),
    [anon_sym_volatile] = ACTIONS(3008),
    [anon_sym_restrict] = ACTIONS(3008),
    [anon_sym___restrict__] = ACTIONS(3008),
    [anon_sym__Atomic] = ACTIONS(3008),
    [anon_sym__Noreturn] = ACTIONS(3008),
    [anon_sym_noreturn] = ACTIONS(3008),
    [anon_sym_mutable] = ACTIONS(3008),
    [anon_sym_constinit] = ACTIONS(3008),
    [anon_sym_consteval] = ACTIONS(3008),
    [anon_sym_PROGMEM] = ACTIONS(3008),
    [aux_sym_primitive_type_token1] = ACTIONS(3008),
    [anon_sym_byte] = ACTIONS(3008),
    [anon_sym_word] = ACTIONS(3008),
    [anon_sym_enum] = ACTIONS(3008),
    [anon_sym_class] = ACTIONS(3008),
    [anon_sym_struct] = ACTIONS(3008),
    [anon_sym_union] = ACTIONS(3008),
    [anon_sym_if] = ACTIONS(3008),
    [anon_sym_switch] = ACTIONS(3008),
    [anon_sym_case] = ACTIONS(3008),
    [anon_sym_default] = ACTIONS(3008),
    [anon_sym_while] = ACTIONS(3008),
    [anon_sym_do] = ACTIONS(3008),
    [anon_sym_for] = ACTIONS(3008),
    [anon_sym_return] = ACTIONS(3008),
    [anon_sym_break] = ACTIONS(3008),
    [anon_sym_continue] = ACTIONS(3008),
    [anon_sym_goto] = ACTIONS(3008),
    [anon_sym___try] = ACTIONS(3008),
    [anon_sym___leave] = ACTIONS(3008),
    [anon_sym_not] = ACTIONS(3008),
    [anon_sym_compl] = ACTIONS(3008),
    [anon_sym_DASH_DASH] = ACTIONS(3010),
    [anon_sym_PLUS_PLUS] = ACTIONS(3010),
    [anon_sym_sizeof] = ACTIONS(3008),
    [anon_sym___alignof__] = ACTIONS(3008),
    [anon_sym___alignof] = ACTIONS(3008),
    [anon_sym__alignof] = ACTIONS(3008),
    [anon_sym_alignof] = ACTIONS(3008),
    [anon_sym__Alignof] = ACTIONS(3008),
    [anon_sym_offsetof] = ACTIONS(3008),
    [anon_sym__Generic] = ACTIONS(3008),
    [anon_sym_asm] = ACTIONS(3008),
    [anon_sym___asm__] = ACTIONS(3008),
    [aux_sym_number_literal_token1] = ACTIONS(3010),
    [aux_sym_number_literal_token2] = ACTIONS(3008),
    [anon_sym_L_SQUOTE] = ACTIONS(3010),
    [anon_sym_u_SQUOTE] = ACTIONS(3010),
    [anon_sym_U_SQUOTE] = ACTIONS(3010),
    [anon_sym_u8_SQUOTE] = ACTIONS(3010),
    [anon_sym_SQUOTE] = ACTIONS(3010),
    [anon_sym_L_DQUOTE] = ACTIONS(3010),
    [anon_sym_u_DQUOTE] = ACTIONS(3010),
    [anon_sym_U_DQUOTE] = ACTIONS(3010),
    [anon_sym_u8_DQUOTE] = ACTIONS(3010),
    [anon_sym_DQUOTE] = ACTIONS(3010),
    [sym_true] = ACTIONS(3008),
    [sym_false] = ACTIONS(3008),
    [anon_sym_NULL] = ACTIONS(3008),
    [anon_sym_nullptr] = ACTIONS(3008),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3008),
    [anon_sym_decltype] = ACTIONS(3008),
    [anon_sym_virtual] = ACTIONS(3008),
    [anon_sym_alignas] = ACTIONS(3008),
    [anon_sym_explicit] = ACTIONS(3008),
    [anon_sym_typename] = ACTIONS(3008),
    [anon_sym_template] = ACTIONS(3008),
    [anon_sym_operator] = ACTIONS(3008),
    [anon_sym_try] = ACTIONS(3008),
    [anon_sym_delete] = ACTIONS(3008),
    [anon_sym_throw] = ACTIONS(3008),
    [anon_sym_namespace] = ACTIONS(3008),
    [anon_sym_using] = ACTIONS(3008),
    [anon_sym_static_assert] = ACTIONS(3008),
    [anon_sym_concept] = ACTIONS(3008),
    [anon_sym_co_return] = ACTIONS(3008),
    [anon_sym_co_yield] = ACTIONS(3008),
    [anon_sym_R_DQUOTE] = ACTIONS(3010),
    [anon_sym_LR_DQUOTE] = ACTIONS(3010),
    [anon_sym_uR_DQUOTE] = ACTIONS(3010),
    [anon_sym_UR_DQUOTE] = ACTIONS(3010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3010),
    [anon_sym_co_await] = ACTIONS(3008),
    [anon_sym_new] = ACTIONS(3008),
    [anon_sym_requires] = ACTIONS(3008),
    [sym_this] = ACTIONS(3008),
  },
  [675] = {
    [sym_identifier] = ACTIONS(3164),
    [aux_sym_preproc_include_token1] = ACTIONS(3164),
    [aux_sym_preproc_def_token1] = ACTIONS(3164),
    [aux_sym_preproc_if_token1] = ACTIONS(3164),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3164),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3164),
    [sym_preproc_directive] = ACTIONS(3164),
    [anon_sym_LPAREN2] = ACTIONS(3166),
    [anon_sym_BANG] = ACTIONS(3166),
    [anon_sym_TILDE] = ACTIONS(3166),
    [anon_sym_DASH] = ACTIONS(3164),
    [anon_sym_PLUS] = ACTIONS(3164),
    [anon_sym_STAR] = ACTIONS(3166),
    [anon_sym_AMP_AMP] = ACTIONS(3166),
    [anon_sym_AMP] = ACTIONS(3164),
    [anon_sym_SEMI] = ACTIONS(3166),
    [anon_sym___extension__] = ACTIONS(3164),
    [anon_sym_typedef] = ACTIONS(3164),
    [anon_sym_extern] = ACTIONS(3164),
    [anon_sym___attribute__] = ACTIONS(3164),
    [anon_sym_COLON_COLON] = ACTIONS(3166),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3166),
    [anon_sym___declspec] = ACTIONS(3164),
    [anon_sym___based] = ACTIONS(3164),
    [anon_sym___cdecl] = ACTIONS(3164),
    [anon_sym___clrcall] = ACTIONS(3164),
    [anon_sym___stdcall] = ACTIONS(3164),
    [anon_sym___fastcall] = ACTIONS(3164),
    [anon_sym___thiscall] = ACTIONS(3164),
    [anon_sym___vectorcall] = ACTIONS(3164),
    [anon_sym_LBRACE] = ACTIONS(3166),
    [anon_sym_RBRACE] = ACTIONS(3166),
    [anon_sym_signed] = ACTIONS(3164),
    [anon_sym_unsigned] = ACTIONS(3164),
    [anon_sym_long] = ACTIONS(3164),
    [anon_sym_short] = ACTIONS(3164),
    [anon_sym_LBRACK] = ACTIONS(3164),
    [anon_sym_static] = ACTIONS(3164),
    [anon_sym_register] = ACTIONS(3164),
    [anon_sym_inline] = ACTIONS(3164),
    [anon_sym___inline] = ACTIONS(3164),
    [anon_sym___inline__] = ACTIONS(3164),
    [anon_sym___forceinline] = ACTIONS(3164),
    [anon_sym_thread_local] = ACTIONS(3164),
    [anon_sym___thread] = ACTIONS(3164),
    [anon_sym_const] = ACTIONS(3164),
    [anon_sym_constexpr] = ACTIONS(3164),
    [anon_sym_volatile] = ACTIONS(3164),
    [anon_sym_restrict] = ACTIONS(3164),
    [anon_sym___restrict__] = ACTIONS(3164),
    [anon_sym__Atomic] = ACTIONS(3164),
    [anon_sym__Noreturn] = ACTIONS(3164),
    [anon_sym_noreturn] = ACTIONS(3164),
    [anon_sym_mutable] = ACTIONS(3164),
    [anon_sym_constinit] = ACTIONS(3164),
    [anon_sym_consteval] = ACTIONS(3164),
    [anon_sym_PROGMEM] = ACTIONS(3164),
    [aux_sym_primitive_type_token1] = ACTIONS(3164),
    [anon_sym_byte] = ACTIONS(3164),
    [anon_sym_word] = ACTIONS(3164),
    [anon_sym_enum] = ACTIONS(3164),
    [anon_sym_class] = ACTIONS(3164),
    [anon_sym_struct] = ACTIONS(3164),
    [anon_sym_union] = ACTIONS(3164),
    [anon_sym_if] = ACTIONS(3164),
    [anon_sym_switch] = ACTIONS(3164),
    [anon_sym_case] = ACTIONS(3164),
    [anon_sym_default] = ACTIONS(3164),
    [anon_sym_while] = ACTIONS(3164),
    [anon_sym_do] = ACTIONS(3164),
    [anon_sym_for] = ACTIONS(3164),
    [anon_sym_return] = ACTIONS(3164),
    [anon_sym_break] = ACTIONS(3164),
    [anon_sym_continue] = ACTIONS(3164),
    [anon_sym_goto] = ACTIONS(3164),
    [anon_sym___try] = ACTIONS(3164),
    [anon_sym___leave] = ACTIONS(3164),
    [anon_sym_not] = ACTIONS(3164),
    [anon_sym_compl] = ACTIONS(3164),
    [anon_sym_DASH_DASH] = ACTIONS(3166),
    [anon_sym_PLUS_PLUS] = ACTIONS(3166),
    [anon_sym_sizeof] = ACTIONS(3164),
    [anon_sym___alignof__] = ACTIONS(3164),
    [anon_sym___alignof] = ACTIONS(3164),
    [anon_sym__alignof] = ACTIONS(3164),
    [anon_sym_alignof] = ACTIONS(3164),
    [anon_sym__Alignof] = ACTIONS(3164),
    [anon_sym_offsetof] = ACTIONS(3164),
    [anon_sym__Generic] = ACTIONS(3164),
    [anon_sym_asm] = ACTIONS(3164),
    [anon_sym___asm__] = ACTIONS(3164),
    [aux_sym_number_literal_token1] = ACTIONS(3166),
    [aux_sym_number_literal_token2] = ACTIONS(3164),
    [anon_sym_L_SQUOTE] = ACTIONS(3166),
    [anon_sym_u_SQUOTE] = ACTIONS(3166),
    [anon_sym_U_SQUOTE] = ACTIONS(3166),
    [anon_sym_u8_SQUOTE] = ACTIONS(3166),
    [anon_sym_SQUOTE] = ACTIONS(3166),
    [anon_sym_L_DQUOTE] = ACTIONS(3166),
    [anon_sym_u_DQUOTE] = ACTIONS(3166),
    [anon_sym_U_DQUOTE] = ACTIONS(3166),
    [anon_sym_u8_DQUOTE] = ACTIONS(3166),
    [anon_sym_DQUOTE] = ACTIONS(3166),
    [sym_true] = ACTIONS(3164),
    [sym_false] = ACTIONS(3164),
    [anon_sym_NULL] = ACTIONS(3164),
    [anon_sym_nullptr] = ACTIONS(3164),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3164),
    [anon_sym_decltype] = ACTIONS(3164),
    [anon_sym_virtual] = ACTIONS(3164),
    [anon_sym_alignas] = ACTIONS(3164),
    [anon_sym_explicit] = ACTIONS(3164),
    [anon_sym_typename] = ACTIONS(3164),
    [anon_sym_template] = ACTIONS(3164),
    [anon_sym_operator] = ACTIONS(3164),
    [anon_sym_try] = ACTIONS(3164),
    [anon_sym_delete] = ACTIONS(3164),
    [anon_sym_throw] = ACTIONS(3164),
    [anon_sym_namespace] = ACTIONS(3164),
    [anon_sym_using] = ACTIONS(3164),
    [anon_sym_static_assert] = ACTIONS(3164),
    [anon_sym_concept] = ACTIONS(3164),
    [anon_sym_co_return] = ACTIONS(3164),
    [anon_sym_co_yield] = ACTIONS(3164),
    [anon_sym_R_DQUOTE] = ACTIONS(3166),
    [anon_sym_LR_DQUOTE] = ACTIONS(3166),
    [anon_sym_uR_DQUOTE] = ACTIONS(3166),
    [anon_sym_UR_DQUOTE] = ACTIONS(3166),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3166),
    [anon_sym_co_await] = ACTIONS(3164),
    [anon_sym_new] = ACTIONS(3164),
    [anon_sym_requires] = ACTIONS(3164),
    [sym_this] = ACTIONS(3164),
  },
  [676] = {
    [sym_identifier] = ACTIONS(3094),
    [aux_sym_preproc_include_token1] = ACTIONS(3094),
    [aux_sym_preproc_def_token1] = ACTIONS(3094),
    [aux_sym_preproc_if_token1] = ACTIONS(3094),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3094),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3094),
    [sym_preproc_directive] = ACTIONS(3094),
    [anon_sym_LPAREN2] = ACTIONS(3096),
    [anon_sym_BANG] = ACTIONS(3096),
    [anon_sym_TILDE] = ACTIONS(3096),
    [anon_sym_DASH] = ACTIONS(3094),
    [anon_sym_PLUS] = ACTIONS(3094),
    [anon_sym_STAR] = ACTIONS(3096),
    [anon_sym_AMP_AMP] = ACTIONS(3096),
    [anon_sym_AMP] = ACTIONS(3094),
    [anon_sym_SEMI] = ACTIONS(3096),
    [anon_sym___extension__] = ACTIONS(3094),
    [anon_sym_typedef] = ACTIONS(3094),
    [anon_sym_extern] = ACTIONS(3094),
    [anon_sym___attribute__] = ACTIONS(3094),
    [anon_sym_COLON_COLON] = ACTIONS(3096),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3096),
    [anon_sym___declspec] = ACTIONS(3094),
    [anon_sym___based] = ACTIONS(3094),
    [anon_sym___cdecl] = ACTIONS(3094),
    [anon_sym___clrcall] = ACTIONS(3094),
    [anon_sym___stdcall] = ACTIONS(3094),
    [anon_sym___fastcall] = ACTIONS(3094),
    [anon_sym___thiscall] = ACTIONS(3094),
    [anon_sym___vectorcall] = ACTIONS(3094),
    [anon_sym_LBRACE] = ACTIONS(3096),
    [anon_sym_RBRACE] = ACTIONS(3096),
    [anon_sym_signed] = ACTIONS(3094),
    [anon_sym_unsigned] = ACTIONS(3094),
    [anon_sym_long] = ACTIONS(3094),
    [anon_sym_short] = ACTIONS(3094),
    [anon_sym_LBRACK] = ACTIONS(3094),
    [anon_sym_static] = ACTIONS(3094),
    [anon_sym_register] = ACTIONS(3094),
    [anon_sym_inline] = ACTIONS(3094),
    [anon_sym___inline] = ACTIONS(3094),
    [anon_sym___inline__] = ACTIONS(3094),
    [anon_sym___forceinline] = ACTIONS(3094),
    [anon_sym_thread_local] = ACTIONS(3094),
    [anon_sym___thread] = ACTIONS(3094),
    [anon_sym_const] = ACTIONS(3094),
    [anon_sym_constexpr] = ACTIONS(3094),
    [anon_sym_volatile] = ACTIONS(3094),
    [anon_sym_restrict] = ACTIONS(3094),
    [anon_sym___restrict__] = ACTIONS(3094),
    [anon_sym__Atomic] = ACTIONS(3094),
    [anon_sym__Noreturn] = ACTIONS(3094),
    [anon_sym_noreturn] = ACTIONS(3094),
    [anon_sym_mutable] = ACTIONS(3094),
    [anon_sym_constinit] = ACTIONS(3094),
    [anon_sym_consteval] = ACTIONS(3094),
    [anon_sym_PROGMEM] = ACTIONS(3094),
    [aux_sym_primitive_type_token1] = ACTIONS(3094),
    [anon_sym_byte] = ACTIONS(3094),
    [anon_sym_word] = ACTIONS(3094),
    [anon_sym_enum] = ACTIONS(3094),
    [anon_sym_class] = ACTIONS(3094),
    [anon_sym_struct] = ACTIONS(3094),
    [anon_sym_union] = ACTIONS(3094),
    [anon_sym_if] = ACTIONS(3094),
    [anon_sym_switch] = ACTIONS(3094),
    [anon_sym_case] = ACTIONS(3094),
    [anon_sym_default] = ACTIONS(3094),
    [anon_sym_while] = ACTIONS(3094),
    [anon_sym_do] = ACTIONS(3094),
    [anon_sym_for] = ACTIONS(3094),
    [anon_sym_return] = ACTIONS(3094),
    [anon_sym_break] = ACTIONS(3094),
    [anon_sym_continue] = ACTIONS(3094),
    [anon_sym_goto] = ACTIONS(3094),
    [anon_sym___try] = ACTIONS(3094),
    [anon_sym___leave] = ACTIONS(3094),
    [anon_sym_not] = ACTIONS(3094),
    [anon_sym_compl] = ACTIONS(3094),
    [anon_sym_DASH_DASH] = ACTIONS(3096),
    [anon_sym_PLUS_PLUS] = ACTIONS(3096),
    [anon_sym_sizeof] = ACTIONS(3094),
    [anon_sym___alignof__] = ACTIONS(3094),
    [anon_sym___alignof] = ACTIONS(3094),
    [anon_sym__alignof] = ACTIONS(3094),
    [anon_sym_alignof] = ACTIONS(3094),
    [anon_sym__Alignof] = ACTIONS(3094),
    [anon_sym_offsetof] = ACTIONS(3094),
    [anon_sym__Generic] = ACTIONS(3094),
    [anon_sym_asm] = ACTIONS(3094),
    [anon_sym___asm__] = ACTIONS(3094),
    [aux_sym_number_literal_token1] = ACTIONS(3096),
    [aux_sym_number_literal_token2] = ACTIONS(3094),
    [anon_sym_L_SQUOTE] = ACTIONS(3096),
    [anon_sym_u_SQUOTE] = ACTIONS(3096),
    [anon_sym_U_SQUOTE] = ACTIONS(3096),
    [anon_sym_u8_SQUOTE] = ACTIONS(3096),
    [anon_sym_SQUOTE] = ACTIONS(3096),
    [anon_sym_L_DQUOTE] = ACTIONS(3096),
    [anon_sym_u_DQUOTE] = ACTIONS(3096),
    [anon_sym_U_DQUOTE] = ACTIONS(3096),
    [anon_sym_u8_DQUOTE] = ACTIONS(3096),
    [anon_sym_DQUOTE] = ACTIONS(3096),
    [sym_true] = ACTIONS(3094),
    [sym_false] = ACTIONS(3094),
    [anon_sym_NULL] = ACTIONS(3094),
    [anon_sym_nullptr] = ACTIONS(3094),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3094),
    [anon_sym_decltype] = ACTIONS(3094),
    [anon_sym_virtual] = ACTIONS(3094),
    [anon_sym_alignas] = ACTIONS(3094),
    [anon_sym_explicit] = ACTIONS(3094),
    [anon_sym_typename] = ACTIONS(3094),
    [anon_sym_template] = ACTIONS(3094),
    [anon_sym_operator] = ACTIONS(3094),
    [anon_sym_try] = ACTIONS(3094),
    [anon_sym_delete] = ACTIONS(3094),
    [anon_sym_throw] = ACTIONS(3094),
    [anon_sym_namespace] = ACTIONS(3094),
    [anon_sym_using] = ACTIONS(3094),
    [anon_sym_static_assert] = ACTIONS(3094),
    [anon_sym_concept] = ACTIONS(3094),
    [anon_sym_co_return] = ACTIONS(3094),
    [anon_sym_co_yield] = ACTIONS(3094),
    [anon_sym_R_DQUOTE] = ACTIONS(3096),
    [anon_sym_LR_DQUOTE] = ACTIONS(3096),
    [anon_sym_uR_DQUOTE] = ACTIONS(3096),
    [anon_sym_UR_DQUOTE] = ACTIONS(3096),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3096),
    [anon_sym_co_await] = ACTIONS(3094),
    [anon_sym_new] = ACTIONS(3094),
    [anon_sym_requires] = ACTIONS(3094),
    [sym_this] = ACTIONS(3094),
  },
  [677] = {
    [sym_identifier] = ACTIONS(3020),
    [aux_sym_preproc_include_token1] = ACTIONS(3020),
    [aux_sym_preproc_def_token1] = ACTIONS(3020),
    [aux_sym_preproc_if_token1] = ACTIONS(3020),
    [aux_sym_preproc_if_token2] = ACTIONS(3020),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3020),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3020),
    [sym_preproc_directive] = ACTIONS(3020),
    [anon_sym_LPAREN2] = ACTIONS(3022),
    [anon_sym_BANG] = ACTIONS(3022),
    [anon_sym_TILDE] = ACTIONS(3022),
    [anon_sym_DASH] = ACTIONS(3020),
    [anon_sym_PLUS] = ACTIONS(3020),
    [anon_sym_STAR] = ACTIONS(3022),
    [anon_sym_AMP_AMP] = ACTIONS(3022),
    [anon_sym_AMP] = ACTIONS(3020),
    [anon_sym_SEMI] = ACTIONS(3022),
    [anon_sym___extension__] = ACTIONS(3020),
    [anon_sym_typedef] = ACTIONS(3020),
    [anon_sym_extern] = ACTIONS(3020),
    [anon_sym___attribute__] = ACTIONS(3020),
    [anon_sym_COLON_COLON] = ACTIONS(3022),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3022),
    [anon_sym___declspec] = ACTIONS(3020),
    [anon_sym___based] = ACTIONS(3020),
    [anon_sym___cdecl] = ACTIONS(3020),
    [anon_sym___clrcall] = ACTIONS(3020),
    [anon_sym___stdcall] = ACTIONS(3020),
    [anon_sym___fastcall] = ACTIONS(3020),
    [anon_sym___thiscall] = ACTIONS(3020),
    [anon_sym___vectorcall] = ACTIONS(3020),
    [anon_sym_LBRACE] = ACTIONS(3022),
    [anon_sym_signed] = ACTIONS(3020),
    [anon_sym_unsigned] = ACTIONS(3020),
    [anon_sym_long] = ACTIONS(3020),
    [anon_sym_short] = ACTIONS(3020),
    [anon_sym_LBRACK] = ACTIONS(3020),
    [anon_sym_static] = ACTIONS(3020),
    [anon_sym_register] = ACTIONS(3020),
    [anon_sym_inline] = ACTIONS(3020),
    [anon_sym___inline] = ACTIONS(3020),
    [anon_sym___inline__] = ACTIONS(3020),
    [anon_sym___forceinline] = ACTIONS(3020),
    [anon_sym_thread_local] = ACTIONS(3020),
    [anon_sym___thread] = ACTIONS(3020),
    [anon_sym_const] = ACTIONS(3020),
    [anon_sym_constexpr] = ACTIONS(3020),
    [anon_sym_volatile] = ACTIONS(3020),
    [anon_sym_restrict] = ACTIONS(3020),
    [anon_sym___restrict__] = ACTIONS(3020),
    [anon_sym__Atomic] = ACTIONS(3020),
    [anon_sym__Noreturn] = ACTIONS(3020),
    [anon_sym_noreturn] = ACTIONS(3020),
    [anon_sym_mutable] = ACTIONS(3020),
    [anon_sym_constinit] = ACTIONS(3020),
    [anon_sym_consteval] = ACTIONS(3020),
    [anon_sym_PROGMEM] = ACTIONS(3020),
    [aux_sym_primitive_type_token1] = ACTIONS(3020),
    [anon_sym_byte] = ACTIONS(3020),
    [anon_sym_word] = ACTIONS(3020),
    [anon_sym_enum] = ACTIONS(3020),
    [anon_sym_class] = ACTIONS(3020),
    [anon_sym_struct] = ACTIONS(3020),
    [anon_sym_union] = ACTIONS(3020),
    [anon_sym_if] = ACTIONS(3020),
    [anon_sym_switch] = ACTIONS(3020),
    [anon_sym_case] = ACTIONS(3020),
    [anon_sym_default] = ACTIONS(3020),
    [anon_sym_while] = ACTIONS(3020),
    [anon_sym_do] = ACTIONS(3020),
    [anon_sym_for] = ACTIONS(3020),
    [anon_sym_return] = ACTIONS(3020),
    [anon_sym_break] = ACTIONS(3020),
    [anon_sym_continue] = ACTIONS(3020),
    [anon_sym_goto] = ACTIONS(3020),
    [anon_sym___try] = ACTIONS(3020),
    [anon_sym___leave] = ACTIONS(3020),
    [anon_sym_not] = ACTIONS(3020),
    [anon_sym_compl] = ACTIONS(3020),
    [anon_sym_DASH_DASH] = ACTIONS(3022),
    [anon_sym_PLUS_PLUS] = ACTIONS(3022),
    [anon_sym_sizeof] = ACTIONS(3020),
    [anon_sym___alignof__] = ACTIONS(3020),
    [anon_sym___alignof] = ACTIONS(3020),
    [anon_sym__alignof] = ACTIONS(3020),
    [anon_sym_alignof] = ACTIONS(3020),
    [anon_sym__Alignof] = ACTIONS(3020),
    [anon_sym_offsetof] = ACTIONS(3020),
    [anon_sym__Generic] = ACTIONS(3020),
    [anon_sym_asm] = ACTIONS(3020),
    [anon_sym___asm__] = ACTIONS(3020),
    [aux_sym_number_literal_token1] = ACTIONS(3022),
    [aux_sym_number_literal_token2] = ACTIONS(3020),
    [anon_sym_L_SQUOTE] = ACTIONS(3022),
    [anon_sym_u_SQUOTE] = ACTIONS(3022),
    [anon_sym_U_SQUOTE] = ACTIONS(3022),
    [anon_sym_u8_SQUOTE] = ACTIONS(3022),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [anon_sym_L_DQUOTE] = ACTIONS(3022),
    [anon_sym_u_DQUOTE] = ACTIONS(3022),
    [anon_sym_U_DQUOTE] = ACTIONS(3022),
    [anon_sym_u8_DQUOTE] = ACTIONS(3022),
    [anon_sym_DQUOTE] = ACTIONS(3022),
    [sym_true] = ACTIONS(3020),
    [sym_false] = ACTIONS(3020),
    [anon_sym_NULL] = ACTIONS(3020),
    [anon_sym_nullptr] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3020),
    [anon_sym_decltype] = ACTIONS(3020),
    [anon_sym_virtual] = ACTIONS(3020),
    [anon_sym_alignas] = ACTIONS(3020),
    [anon_sym_explicit] = ACTIONS(3020),
    [anon_sym_typename] = ACTIONS(3020),
    [anon_sym_template] = ACTIONS(3020),
    [anon_sym_operator] = ACTIONS(3020),
    [anon_sym_try] = ACTIONS(3020),
    [anon_sym_delete] = ACTIONS(3020),
    [anon_sym_throw] = ACTIONS(3020),
    [anon_sym_namespace] = ACTIONS(3020),
    [anon_sym_using] = ACTIONS(3020),
    [anon_sym_static_assert] = ACTIONS(3020),
    [anon_sym_concept] = ACTIONS(3020),
    [anon_sym_co_return] = ACTIONS(3020),
    [anon_sym_co_yield] = ACTIONS(3020),
    [anon_sym_R_DQUOTE] = ACTIONS(3022),
    [anon_sym_LR_DQUOTE] = ACTIONS(3022),
    [anon_sym_uR_DQUOTE] = ACTIONS(3022),
    [anon_sym_UR_DQUOTE] = ACTIONS(3022),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3022),
    [anon_sym_co_await] = ACTIONS(3020),
    [anon_sym_new] = ACTIONS(3020),
    [anon_sym_requires] = ACTIONS(3020),
    [sym_this] = ACTIONS(3020),
  },
  [678] = {
    [sym_identifier] = ACTIONS(3090),
    [aux_sym_preproc_include_token1] = ACTIONS(3090),
    [aux_sym_preproc_def_token1] = ACTIONS(3090),
    [aux_sym_preproc_if_token1] = ACTIONS(3090),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3090),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3090),
    [sym_preproc_directive] = ACTIONS(3090),
    [anon_sym_LPAREN2] = ACTIONS(3092),
    [anon_sym_BANG] = ACTIONS(3092),
    [anon_sym_TILDE] = ACTIONS(3092),
    [anon_sym_DASH] = ACTIONS(3090),
    [anon_sym_PLUS] = ACTIONS(3090),
    [anon_sym_STAR] = ACTIONS(3092),
    [anon_sym_AMP_AMP] = ACTIONS(3092),
    [anon_sym_AMP] = ACTIONS(3090),
    [anon_sym_SEMI] = ACTIONS(3092),
    [anon_sym___extension__] = ACTIONS(3090),
    [anon_sym_typedef] = ACTIONS(3090),
    [anon_sym_extern] = ACTIONS(3090),
    [anon_sym___attribute__] = ACTIONS(3090),
    [anon_sym_COLON_COLON] = ACTIONS(3092),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3092),
    [anon_sym___declspec] = ACTIONS(3090),
    [anon_sym___based] = ACTIONS(3090),
    [anon_sym___cdecl] = ACTIONS(3090),
    [anon_sym___clrcall] = ACTIONS(3090),
    [anon_sym___stdcall] = ACTIONS(3090),
    [anon_sym___fastcall] = ACTIONS(3090),
    [anon_sym___thiscall] = ACTIONS(3090),
    [anon_sym___vectorcall] = ACTIONS(3090),
    [anon_sym_LBRACE] = ACTIONS(3092),
    [anon_sym_RBRACE] = ACTIONS(3092),
    [anon_sym_signed] = ACTIONS(3090),
    [anon_sym_unsigned] = ACTIONS(3090),
    [anon_sym_long] = ACTIONS(3090),
    [anon_sym_short] = ACTIONS(3090),
    [anon_sym_LBRACK] = ACTIONS(3090),
    [anon_sym_static] = ACTIONS(3090),
    [anon_sym_register] = ACTIONS(3090),
    [anon_sym_inline] = ACTIONS(3090),
    [anon_sym___inline] = ACTIONS(3090),
    [anon_sym___inline__] = ACTIONS(3090),
    [anon_sym___forceinline] = ACTIONS(3090),
    [anon_sym_thread_local] = ACTIONS(3090),
    [anon_sym___thread] = ACTIONS(3090),
    [anon_sym_const] = ACTIONS(3090),
    [anon_sym_constexpr] = ACTIONS(3090),
    [anon_sym_volatile] = ACTIONS(3090),
    [anon_sym_restrict] = ACTIONS(3090),
    [anon_sym___restrict__] = ACTIONS(3090),
    [anon_sym__Atomic] = ACTIONS(3090),
    [anon_sym__Noreturn] = ACTIONS(3090),
    [anon_sym_noreturn] = ACTIONS(3090),
    [anon_sym_mutable] = ACTIONS(3090),
    [anon_sym_constinit] = ACTIONS(3090),
    [anon_sym_consteval] = ACTIONS(3090),
    [anon_sym_PROGMEM] = ACTIONS(3090),
    [aux_sym_primitive_type_token1] = ACTIONS(3090),
    [anon_sym_byte] = ACTIONS(3090),
    [anon_sym_word] = ACTIONS(3090),
    [anon_sym_enum] = ACTIONS(3090),
    [anon_sym_class] = ACTIONS(3090),
    [anon_sym_struct] = ACTIONS(3090),
    [anon_sym_union] = ACTIONS(3090),
    [anon_sym_if] = ACTIONS(3090),
    [anon_sym_switch] = ACTIONS(3090),
    [anon_sym_case] = ACTIONS(3090),
    [anon_sym_default] = ACTIONS(3090),
    [anon_sym_while] = ACTIONS(3090),
    [anon_sym_do] = ACTIONS(3090),
    [anon_sym_for] = ACTIONS(3090),
    [anon_sym_return] = ACTIONS(3090),
    [anon_sym_break] = ACTIONS(3090),
    [anon_sym_continue] = ACTIONS(3090),
    [anon_sym_goto] = ACTIONS(3090),
    [anon_sym___try] = ACTIONS(3090),
    [anon_sym___leave] = ACTIONS(3090),
    [anon_sym_not] = ACTIONS(3090),
    [anon_sym_compl] = ACTIONS(3090),
    [anon_sym_DASH_DASH] = ACTIONS(3092),
    [anon_sym_PLUS_PLUS] = ACTIONS(3092),
    [anon_sym_sizeof] = ACTIONS(3090),
    [anon_sym___alignof__] = ACTIONS(3090),
    [anon_sym___alignof] = ACTIONS(3090),
    [anon_sym__alignof] = ACTIONS(3090),
    [anon_sym_alignof] = ACTIONS(3090),
    [anon_sym__Alignof] = ACTIONS(3090),
    [anon_sym_offsetof] = ACTIONS(3090),
    [anon_sym__Generic] = ACTIONS(3090),
    [anon_sym_asm] = ACTIONS(3090),
    [anon_sym___asm__] = ACTIONS(3090),
    [aux_sym_number_literal_token1] = ACTIONS(3092),
    [aux_sym_number_literal_token2] = ACTIONS(3090),
    [anon_sym_L_SQUOTE] = ACTIONS(3092),
    [anon_sym_u_SQUOTE] = ACTIONS(3092),
    [anon_sym_U_SQUOTE] = ACTIONS(3092),
    [anon_sym_u8_SQUOTE] = ACTIONS(3092),
    [anon_sym_SQUOTE] = ACTIONS(3092),
    [anon_sym_L_DQUOTE] = ACTIONS(3092),
    [anon_sym_u_DQUOTE] = ACTIONS(3092),
    [anon_sym_U_DQUOTE] = ACTIONS(3092),
    [anon_sym_u8_DQUOTE] = ACTIONS(3092),
    [anon_sym_DQUOTE] = ACTIONS(3092),
    [sym_true] = ACTIONS(3090),
    [sym_false] = ACTIONS(3090),
    [anon_sym_NULL] = ACTIONS(3090),
    [anon_sym_nullptr] = ACTIONS(3090),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3090),
    [anon_sym_decltype] = ACTIONS(3090),
    [anon_sym_virtual] = ACTIONS(3090),
    [anon_sym_alignas] = ACTIONS(3090),
    [anon_sym_explicit] = ACTIONS(3090),
    [anon_sym_typename] = ACTIONS(3090),
    [anon_sym_template] = ACTIONS(3090),
    [anon_sym_operator] = ACTIONS(3090),
    [anon_sym_try] = ACTIONS(3090),
    [anon_sym_delete] = ACTIONS(3090),
    [anon_sym_throw] = ACTIONS(3090),
    [anon_sym_namespace] = ACTIONS(3090),
    [anon_sym_using] = ACTIONS(3090),
    [anon_sym_static_assert] = ACTIONS(3090),
    [anon_sym_concept] = ACTIONS(3090),
    [anon_sym_co_return] = ACTIONS(3090),
    [anon_sym_co_yield] = ACTIONS(3090),
    [anon_sym_R_DQUOTE] = ACTIONS(3092),
    [anon_sym_LR_DQUOTE] = ACTIONS(3092),
    [anon_sym_uR_DQUOTE] = ACTIONS(3092),
    [anon_sym_UR_DQUOTE] = ACTIONS(3092),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3092),
    [anon_sym_co_await] = ACTIONS(3090),
    [anon_sym_new] = ACTIONS(3090),
    [anon_sym_requires] = ACTIONS(3090),
    [sym_this] = ACTIONS(3090),
  },
  [679] = {
    [sym_identifier] = ACTIONS(3086),
    [aux_sym_preproc_include_token1] = ACTIONS(3086),
    [aux_sym_preproc_def_token1] = ACTIONS(3086),
    [aux_sym_preproc_if_token1] = ACTIONS(3086),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3086),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3086),
    [sym_preproc_directive] = ACTIONS(3086),
    [anon_sym_LPAREN2] = ACTIONS(3088),
    [anon_sym_BANG] = ACTIONS(3088),
    [anon_sym_TILDE] = ACTIONS(3088),
    [anon_sym_DASH] = ACTIONS(3086),
    [anon_sym_PLUS] = ACTIONS(3086),
    [anon_sym_STAR] = ACTIONS(3088),
    [anon_sym_AMP_AMP] = ACTIONS(3088),
    [anon_sym_AMP] = ACTIONS(3086),
    [anon_sym_SEMI] = ACTIONS(3088),
    [anon_sym___extension__] = ACTIONS(3086),
    [anon_sym_typedef] = ACTIONS(3086),
    [anon_sym_extern] = ACTIONS(3086),
    [anon_sym___attribute__] = ACTIONS(3086),
    [anon_sym_COLON_COLON] = ACTIONS(3088),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3088),
    [anon_sym___declspec] = ACTIONS(3086),
    [anon_sym___based] = ACTIONS(3086),
    [anon_sym___cdecl] = ACTIONS(3086),
    [anon_sym___clrcall] = ACTIONS(3086),
    [anon_sym___stdcall] = ACTIONS(3086),
    [anon_sym___fastcall] = ACTIONS(3086),
    [anon_sym___thiscall] = ACTIONS(3086),
    [anon_sym___vectorcall] = ACTIONS(3086),
    [anon_sym_LBRACE] = ACTIONS(3088),
    [anon_sym_RBRACE] = ACTIONS(3088),
    [anon_sym_signed] = ACTIONS(3086),
    [anon_sym_unsigned] = ACTIONS(3086),
    [anon_sym_long] = ACTIONS(3086),
    [anon_sym_short] = ACTIONS(3086),
    [anon_sym_LBRACK] = ACTIONS(3086),
    [anon_sym_static] = ACTIONS(3086),
    [anon_sym_register] = ACTIONS(3086),
    [anon_sym_inline] = ACTIONS(3086),
    [anon_sym___inline] = ACTIONS(3086),
    [anon_sym___inline__] = ACTIONS(3086),
    [anon_sym___forceinline] = ACTIONS(3086),
    [anon_sym_thread_local] = ACTIONS(3086),
    [anon_sym___thread] = ACTIONS(3086),
    [anon_sym_const] = ACTIONS(3086),
    [anon_sym_constexpr] = ACTIONS(3086),
    [anon_sym_volatile] = ACTIONS(3086),
    [anon_sym_restrict] = ACTIONS(3086),
    [anon_sym___restrict__] = ACTIONS(3086),
    [anon_sym__Atomic] = ACTIONS(3086),
    [anon_sym__Noreturn] = ACTIONS(3086),
    [anon_sym_noreturn] = ACTIONS(3086),
    [anon_sym_mutable] = ACTIONS(3086),
    [anon_sym_constinit] = ACTIONS(3086),
    [anon_sym_consteval] = ACTIONS(3086),
    [anon_sym_PROGMEM] = ACTIONS(3086),
    [aux_sym_primitive_type_token1] = ACTIONS(3086),
    [anon_sym_byte] = ACTIONS(3086),
    [anon_sym_word] = ACTIONS(3086),
    [anon_sym_enum] = ACTIONS(3086),
    [anon_sym_class] = ACTIONS(3086),
    [anon_sym_struct] = ACTIONS(3086),
    [anon_sym_union] = ACTIONS(3086),
    [anon_sym_if] = ACTIONS(3086),
    [anon_sym_switch] = ACTIONS(3086),
    [anon_sym_case] = ACTIONS(3086),
    [anon_sym_default] = ACTIONS(3086),
    [anon_sym_while] = ACTIONS(3086),
    [anon_sym_do] = ACTIONS(3086),
    [anon_sym_for] = ACTIONS(3086),
    [anon_sym_return] = ACTIONS(3086),
    [anon_sym_break] = ACTIONS(3086),
    [anon_sym_continue] = ACTIONS(3086),
    [anon_sym_goto] = ACTIONS(3086),
    [anon_sym___try] = ACTIONS(3086),
    [anon_sym___leave] = ACTIONS(3086),
    [anon_sym_not] = ACTIONS(3086),
    [anon_sym_compl] = ACTIONS(3086),
    [anon_sym_DASH_DASH] = ACTIONS(3088),
    [anon_sym_PLUS_PLUS] = ACTIONS(3088),
    [anon_sym_sizeof] = ACTIONS(3086),
    [anon_sym___alignof__] = ACTIONS(3086),
    [anon_sym___alignof] = ACTIONS(3086),
    [anon_sym__alignof] = ACTIONS(3086),
    [anon_sym_alignof] = ACTIONS(3086),
    [anon_sym__Alignof] = ACTIONS(3086),
    [anon_sym_offsetof] = ACTIONS(3086),
    [anon_sym__Generic] = ACTIONS(3086),
    [anon_sym_asm] = ACTIONS(3086),
    [anon_sym___asm__] = ACTIONS(3086),
    [aux_sym_number_literal_token1] = ACTIONS(3088),
    [aux_sym_number_literal_token2] = ACTIONS(3086),
    [anon_sym_L_SQUOTE] = ACTIONS(3088),
    [anon_sym_u_SQUOTE] = ACTIONS(3088),
    [anon_sym_U_SQUOTE] = ACTIONS(3088),
    [anon_sym_u8_SQUOTE] = ACTIONS(3088),
    [anon_sym_SQUOTE] = ACTIONS(3088),
    [anon_sym_L_DQUOTE] = ACTIONS(3088),
    [anon_sym_u_DQUOTE] = ACTIONS(3088),
    [anon_sym_U_DQUOTE] = ACTIONS(3088),
    [anon_sym_u8_DQUOTE] = ACTIONS(3088),
    [anon_sym_DQUOTE] = ACTIONS(3088),
    [sym_true] = ACTIONS(3086),
    [sym_false] = ACTIONS(3086),
    [anon_sym_NULL] = ACTIONS(3086),
    [anon_sym_nullptr] = ACTIONS(3086),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3086),
    [anon_sym_decltype] = ACTIONS(3086),
    [anon_sym_virtual] = ACTIONS(3086),
    [anon_sym_alignas] = ACTIONS(3086),
    [anon_sym_explicit] = ACTIONS(3086),
    [anon_sym_typename] = ACTIONS(3086),
    [anon_sym_template] = ACTIONS(3086),
    [anon_sym_operator] = ACTIONS(3086),
    [anon_sym_try] = ACTIONS(3086),
    [anon_sym_delete] = ACTIONS(3086),
    [anon_sym_throw] = ACTIONS(3086),
    [anon_sym_namespace] = ACTIONS(3086),
    [anon_sym_using] = ACTIONS(3086),
    [anon_sym_static_assert] = ACTIONS(3086),
    [anon_sym_concept] = ACTIONS(3086),
    [anon_sym_co_return] = ACTIONS(3086),
    [anon_sym_co_yield] = ACTIONS(3086),
    [anon_sym_R_DQUOTE] = ACTIONS(3088),
    [anon_sym_LR_DQUOTE] = ACTIONS(3088),
    [anon_sym_uR_DQUOTE] = ACTIONS(3088),
    [anon_sym_UR_DQUOTE] = ACTIONS(3088),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3088),
    [anon_sym_co_await] = ACTIONS(3086),
    [anon_sym_new] = ACTIONS(3086),
    [anon_sym_requires] = ACTIONS(3086),
    [sym_this] = ACTIONS(3086),
  },
  [680] = {
    [sym_identifier] = ACTIONS(3160),
    [aux_sym_preproc_include_token1] = ACTIONS(3160),
    [aux_sym_preproc_def_token1] = ACTIONS(3160),
    [aux_sym_preproc_if_token1] = ACTIONS(3160),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3160),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3160),
    [sym_preproc_directive] = ACTIONS(3160),
    [anon_sym_LPAREN2] = ACTIONS(3162),
    [anon_sym_BANG] = ACTIONS(3162),
    [anon_sym_TILDE] = ACTIONS(3162),
    [anon_sym_DASH] = ACTIONS(3160),
    [anon_sym_PLUS] = ACTIONS(3160),
    [anon_sym_STAR] = ACTIONS(3162),
    [anon_sym_AMP_AMP] = ACTIONS(3162),
    [anon_sym_AMP] = ACTIONS(3160),
    [anon_sym_SEMI] = ACTIONS(3162),
    [anon_sym___extension__] = ACTIONS(3160),
    [anon_sym_typedef] = ACTIONS(3160),
    [anon_sym_extern] = ACTIONS(3160),
    [anon_sym___attribute__] = ACTIONS(3160),
    [anon_sym_COLON_COLON] = ACTIONS(3162),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3162),
    [anon_sym___declspec] = ACTIONS(3160),
    [anon_sym___based] = ACTIONS(3160),
    [anon_sym___cdecl] = ACTIONS(3160),
    [anon_sym___clrcall] = ACTIONS(3160),
    [anon_sym___stdcall] = ACTIONS(3160),
    [anon_sym___fastcall] = ACTIONS(3160),
    [anon_sym___thiscall] = ACTIONS(3160),
    [anon_sym___vectorcall] = ACTIONS(3160),
    [anon_sym_LBRACE] = ACTIONS(3162),
    [anon_sym_RBRACE] = ACTIONS(3162),
    [anon_sym_signed] = ACTIONS(3160),
    [anon_sym_unsigned] = ACTIONS(3160),
    [anon_sym_long] = ACTIONS(3160),
    [anon_sym_short] = ACTIONS(3160),
    [anon_sym_LBRACK] = ACTIONS(3160),
    [anon_sym_static] = ACTIONS(3160),
    [anon_sym_register] = ACTIONS(3160),
    [anon_sym_inline] = ACTIONS(3160),
    [anon_sym___inline] = ACTIONS(3160),
    [anon_sym___inline__] = ACTIONS(3160),
    [anon_sym___forceinline] = ACTIONS(3160),
    [anon_sym_thread_local] = ACTIONS(3160),
    [anon_sym___thread] = ACTIONS(3160),
    [anon_sym_const] = ACTIONS(3160),
    [anon_sym_constexpr] = ACTIONS(3160),
    [anon_sym_volatile] = ACTIONS(3160),
    [anon_sym_restrict] = ACTIONS(3160),
    [anon_sym___restrict__] = ACTIONS(3160),
    [anon_sym__Atomic] = ACTIONS(3160),
    [anon_sym__Noreturn] = ACTIONS(3160),
    [anon_sym_noreturn] = ACTIONS(3160),
    [anon_sym_mutable] = ACTIONS(3160),
    [anon_sym_constinit] = ACTIONS(3160),
    [anon_sym_consteval] = ACTIONS(3160),
    [anon_sym_PROGMEM] = ACTIONS(3160),
    [aux_sym_primitive_type_token1] = ACTIONS(3160),
    [anon_sym_byte] = ACTIONS(3160),
    [anon_sym_word] = ACTIONS(3160),
    [anon_sym_enum] = ACTIONS(3160),
    [anon_sym_class] = ACTIONS(3160),
    [anon_sym_struct] = ACTIONS(3160),
    [anon_sym_union] = ACTIONS(3160),
    [anon_sym_if] = ACTIONS(3160),
    [anon_sym_switch] = ACTIONS(3160),
    [anon_sym_case] = ACTIONS(3160),
    [anon_sym_default] = ACTIONS(3160),
    [anon_sym_while] = ACTIONS(3160),
    [anon_sym_do] = ACTIONS(3160),
    [anon_sym_for] = ACTIONS(3160),
    [anon_sym_return] = ACTIONS(3160),
    [anon_sym_break] = ACTIONS(3160),
    [anon_sym_continue] = ACTIONS(3160),
    [anon_sym_goto] = ACTIONS(3160),
    [anon_sym___try] = ACTIONS(3160),
    [anon_sym___leave] = ACTIONS(3160),
    [anon_sym_not] = ACTIONS(3160),
    [anon_sym_compl] = ACTIONS(3160),
    [anon_sym_DASH_DASH] = ACTIONS(3162),
    [anon_sym_PLUS_PLUS] = ACTIONS(3162),
    [anon_sym_sizeof] = ACTIONS(3160),
    [anon_sym___alignof__] = ACTIONS(3160),
    [anon_sym___alignof] = ACTIONS(3160),
    [anon_sym__alignof] = ACTIONS(3160),
    [anon_sym_alignof] = ACTIONS(3160),
    [anon_sym__Alignof] = ACTIONS(3160),
    [anon_sym_offsetof] = ACTIONS(3160),
    [anon_sym__Generic] = ACTIONS(3160),
    [anon_sym_asm] = ACTIONS(3160),
    [anon_sym___asm__] = ACTIONS(3160),
    [aux_sym_number_literal_token1] = ACTIONS(3162),
    [aux_sym_number_literal_token2] = ACTIONS(3160),
    [anon_sym_L_SQUOTE] = ACTIONS(3162),
    [anon_sym_u_SQUOTE] = ACTIONS(3162),
    [anon_sym_U_SQUOTE] = ACTIONS(3162),
    [anon_sym_u8_SQUOTE] = ACTIONS(3162),
    [anon_sym_SQUOTE] = ACTIONS(3162),
    [anon_sym_L_DQUOTE] = ACTIONS(3162),
    [anon_sym_u_DQUOTE] = ACTIONS(3162),
    [anon_sym_U_DQUOTE] = ACTIONS(3162),
    [anon_sym_u8_DQUOTE] = ACTIONS(3162),
    [anon_sym_DQUOTE] = ACTIONS(3162),
    [sym_true] = ACTIONS(3160),
    [sym_false] = ACTIONS(3160),
    [anon_sym_NULL] = ACTIONS(3160),
    [anon_sym_nullptr] = ACTIONS(3160),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3160),
    [anon_sym_decltype] = ACTIONS(3160),
    [anon_sym_virtual] = ACTIONS(3160),
    [anon_sym_alignas] = ACTIONS(3160),
    [anon_sym_explicit] = ACTIONS(3160),
    [anon_sym_typename] = ACTIONS(3160),
    [anon_sym_template] = ACTIONS(3160),
    [anon_sym_operator] = ACTIONS(3160),
    [anon_sym_try] = ACTIONS(3160),
    [anon_sym_delete] = ACTIONS(3160),
    [anon_sym_throw] = ACTIONS(3160),
    [anon_sym_namespace] = ACTIONS(3160),
    [anon_sym_using] = ACTIONS(3160),
    [anon_sym_static_assert] = ACTIONS(3160),
    [anon_sym_concept] = ACTIONS(3160),
    [anon_sym_co_return] = ACTIONS(3160),
    [anon_sym_co_yield] = ACTIONS(3160),
    [anon_sym_R_DQUOTE] = ACTIONS(3162),
    [anon_sym_LR_DQUOTE] = ACTIONS(3162),
    [anon_sym_uR_DQUOTE] = ACTIONS(3162),
    [anon_sym_UR_DQUOTE] = ACTIONS(3162),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3162),
    [anon_sym_co_await] = ACTIONS(3160),
    [anon_sym_new] = ACTIONS(3160),
    [anon_sym_requires] = ACTIONS(3160),
    [sym_this] = ACTIONS(3160),
  },
  [681] = {
    [sym_identifier] = ACTIONS(2929),
    [aux_sym_preproc_include_token1] = ACTIONS(2929),
    [aux_sym_preproc_def_token1] = ACTIONS(2929),
    [aux_sym_preproc_if_token1] = ACTIONS(2929),
    [aux_sym_preproc_if_token2] = ACTIONS(2929),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2929),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2929),
    [sym_preproc_directive] = ACTIONS(2929),
    [anon_sym_LPAREN2] = ACTIONS(2931),
    [anon_sym_BANG] = ACTIONS(2931),
    [anon_sym_TILDE] = ACTIONS(2931),
    [anon_sym_DASH] = ACTIONS(2929),
    [anon_sym_PLUS] = ACTIONS(2929),
    [anon_sym_STAR] = ACTIONS(2931),
    [anon_sym_AMP_AMP] = ACTIONS(2931),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_SEMI] = ACTIONS(2931),
    [anon_sym___extension__] = ACTIONS(2929),
    [anon_sym_typedef] = ACTIONS(2929),
    [anon_sym_extern] = ACTIONS(2929),
    [anon_sym___attribute__] = ACTIONS(2929),
    [anon_sym_COLON_COLON] = ACTIONS(2931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2931),
    [anon_sym___declspec] = ACTIONS(2929),
    [anon_sym___based] = ACTIONS(2929),
    [anon_sym___cdecl] = ACTIONS(2929),
    [anon_sym___clrcall] = ACTIONS(2929),
    [anon_sym___stdcall] = ACTIONS(2929),
    [anon_sym___fastcall] = ACTIONS(2929),
    [anon_sym___thiscall] = ACTIONS(2929),
    [anon_sym___vectorcall] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [anon_sym_signed] = ACTIONS(2929),
    [anon_sym_unsigned] = ACTIONS(2929),
    [anon_sym_long] = ACTIONS(2929),
    [anon_sym_short] = ACTIONS(2929),
    [anon_sym_LBRACK] = ACTIONS(2929),
    [anon_sym_static] = ACTIONS(2929),
    [anon_sym_register] = ACTIONS(2929),
    [anon_sym_inline] = ACTIONS(2929),
    [anon_sym___inline] = ACTIONS(2929),
    [anon_sym___inline__] = ACTIONS(2929),
    [anon_sym___forceinline] = ACTIONS(2929),
    [anon_sym_thread_local] = ACTIONS(2929),
    [anon_sym___thread] = ACTIONS(2929),
    [anon_sym_const] = ACTIONS(2929),
    [anon_sym_constexpr] = ACTIONS(2929),
    [anon_sym_volatile] = ACTIONS(2929),
    [anon_sym_restrict] = ACTIONS(2929),
    [anon_sym___restrict__] = ACTIONS(2929),
    [anon_sym__Atomic] = ACTIONS(2929),
    [anon_sym__Noreturn] = ACTIONS(2929),
    [anon_sym_noreturn] = ACTIONS(2929),
    [anon_sym_mutable] = ACTIONS(2929),
    [anon_sym_constinit] = ACTIONS(2929),
    [anon_sym_consteval] = ACTIONS(2929),
    [anon_sym_PROGMEM] = ACTIONS(2929),
    [aux_sym_primitive_type_token1] = ACTIONS(2929),
    [anon_sym_byte] = ACTIONS(2929),
    [anon_sym_word] = ACTIONS(2929),
    [anon_sym_enum] = ACTIONS(2929),
    [anon_sym_class] = ACTIONS(2929),
    [anon_sym_struct] = ACTIONS(2929),
    [anon_sym_union] = ACTIONS(2929),
    [anon_sym_if] = ACTIONS(2929),
    [anon_sym_switch] = ACTIONS(2929),
    [anon_sym_case] = ACTIONS(2929),
    [anon_sym_default] = ACTIONS(2929),
    [anon_sym_while] = ACTIONS(2929),
    [anon_sym_do] = ACTIONS(2929),
    [anon_sym_for] = ACTIONS(2929),
    [anon_sym_return] = ACTIONS(2929),
    [anon_sym_break] = ACTIONS(2929),
    [anon_sym_continue] = ACTIONS(2929),
    [anon_sym_goto] = ACTIONS(2929),
    [anon_sym___try] = ACTIONS(2929),
    [anon_sym___leave] = ACTIONS(2929),
    [anon_sym_not] = ACTIONS(2929),
    [anon_sym_compl] = ACTIONS(2929),
    [anon_sym_DASH_DASH] = ACTIONS(2931),
    [anon_sym_PLUS_PLUS] = ACTIONS(2931),
    [anon_sym_sizeof] = ACTIONS(2929),
    [anon_sym___alignof__] = ACTIONS(2929),
    [anon_sym___alignof] = ACTIONS(2929),
    [anon_sym__alignof] = ACTIONS(2929),
    [anon_sym_alignof] = ACTIONS(2929),
    [anon_sym__Alignof] = ACTIONS(2929),
    [anon_sym_offsetof] = ACTIONS(2929),
    [anon_sym__Generic] = ACTIONS(2929),
    [anon_sym_asm] = ACTIONS(2929),
    [anon_sym___asm__] = ACTIONS(2929),
    [aux_sym_number_literal_token1] = ACTIONS(2931),
    [aux_sym_number_literal_token2] = ACTIONS(2929),
    [anon_sym_L_SQUOTE] = ACTIONS(2931),
    [anon_sym_u_SQUOTE] = ACTIONS(2931),
    [anon_sym_U_SQUOTE] = ACTIONS(2931),
    [anon_sym_u8_SQUOTE] = ACTIONS(2931),
    [anon_sym_SQUOTE] = ACTIONS(2931),
    [anon_sym_L_DQUOTE] = ACTIONS(2931),
    [anon_sym_u_DQUOTE] = ACTIONS(2931),
    [anon_sym_U_DQUOTE] = ACTIONS(2931),
    [anon_sym_u8_DQUOTE] = ACTIONS(2931),
    [anon_sym_DQUOTE] = ACTIONS(2931),
    [sym_true] = ACTIONS(2929),
    [sym_false] = ACTIONS(2929),
    [anon_sym_NULL] = ACTIONS(2929),
    [anon_sym_nullptr] = ACTIONS(2929),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2929),
    [anon_sym_decltype] = ACTIONS(2929),
    [anon_sym_virtual] = ACTIONS(2929),
    [anon_sym_alignas] = ACTIONS(2929),
    [anon_sym_explicit] = ACTIONS(2929),
    [anon_sym_typename] = ACTIONS(2929),
    [anon_sym_template] = ACTIONS(2929),
    [anon_sym_operator] = ACTIONS(2929),
    [anon_sym_try] = ACTIONS(2929),
    [anon_sym_delete] = ACTIONS(2929),
    [anon_sym_throw] = ACTIONS(2929),
    [anon_sym_namespace] = ACTIONS(2929),
    [anon_sym_using] = ACTIONS(2929),
    [anon_sym_static_assert] = ACTIONS(2929),
    [anon_sym_concept] = ACTIONS(2929),
    [anon_sym_co_return] = ACTIONS(2929),
    [anon_sym_co_yield] = ACTIONS(2929),
    [anon_sym_R_DQUOTE] = ACTIONS(2931),
    [anon_sym_LR_DQUOTE] = ACTIONS(2931),
    [anon_sym_uR_DQUOTE] = ACTIONS(2931),
    [anon_sym_UR_DQUOTE] = ACTIONS(2931),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2931),
    [anon_sym_co_await] = ACTIONS(2929),
    [anon_sym_new] = ACTIONS(2929),
    [anon_sym_requires] = ACTIONS(2929),
    [sym_this] = ACTIONS(2929),
  },
  [682] = {
    [sym_identifier] = ACTIONS(3082),
    [aux_sym_preproc_include_token1] = ACTIONS(3082),
    [aux_sym_preproc_def_token1] = ACTIONS(3082),
    [aux_sym_preproc_if_token1] = ACTIONS(3082),
    [aux_sym_preproc_if_token2] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3082),
    [sym_preproc_directive] = ACTIONS(3082),
    [anon_sym_LPAREN2] = ACTIONS(3084),
    [anon_sym_BANG] = ACTIONS(3084),
    [anon_sym_TILDE] = ACTIONS(3084),
    [anon_sym_DASH] = ACTIONS(3082),
    [anon_sym_PLUS] = ACTIONS(3082),
    [anon_sym_STAR] = ACTIONS(3084),
    [anon_sym_AMP_AMP] = ACTIONS(3084),
    [anon_sym_AMP] = ACTIONS(3082),
    [anon_sym_SEMI] = ACTIONS(3084),
    [anon_sym___extension__] = ACTIONS(3082),
    [anon_sym_typedef] = ACTIONS(3082),
    [anon_sym_extern] = ACTIONS(3082),
    [anon_sym___attribute__] = ACTIONS(3082),
    [anon_sym_COLON_COLON] = ACTIONS(3084),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3084),
    [anon_sym___declspec] = ACTIONS(3082),
    [anon_sym___based] = ACTIONS(3082),
    [anon_sym___cdecl] = ACTIONS(3082),
    [anon_sym___clrcall] = ACTIONS(3082),
    [anon_sym___stdcall] = ACTIONS(3082),
    [anon_sym___fastcall] = ACTIONS(3082),
    [anon_sym___thiscall] = ACTIONS(3082),
    [anon_sym___vectorcall] = ACTIONS(3082),
    [anon_sym_LBRACE] = ACTIONS(3084),
    [anon_sym_signed] = ACTIONS(3082),
    [anon_sym_unsigned] = ACTIONS(3082),
    [anon_sym_long] = ACTIONS(3082),
    [anon_sym_short] = ACTIONS(3082),
    [anon_sym_LBRACK] = ACTIONS(3082),
    [anon_sym_static] = ACTIONS(3082),
    [anon_sym_register] = ACTIONS(3082),
    [anon_sym_inline] = ACTIONS(3082),
    [anon_sym___inline] = ACTIONS(3082),
    [anon_sym___inline__] = ACTIONS(3082),
    [anon_sym___forceinline] = ACTIONS(3082),
    [anon_sym_thread_local] = ACTIONS(3082),
    [anon_sym___thread] = ACTIONS(3082),
    [anon_sym_const] = ACTIONS(3082),
    [anon_sym_constexpr] = ACTIONS(3082),
    [anon_sym_volatile] = ACTIONS(3082),
    [anon_sym_restrict] = ACTIONS(3082),
    [anon_sym___restrict__] = ACTIONS(3082),
    [anon_sym__Atomic] = ACTIONS(3082),
    [anon_sym__Noreturn] = ACTIONS(3082),
    [anon_sym_noreturn] = ACTIONS(3082),
    [anon_sym_mutable] = ACTIONS(3082),
    [anon_sym_constinit] = ACTIONS(3082),
    [anon_sym_consteval] = ACTIONS(3082),
    [anon_sym_PROGMEM] = ACTIONS(3082),
    [aux_sym_primitive_type_token1] = ACTIONS(3082),
    [anon_sym_byte] = ACTIONS(3082),
    [anon_sym_word] = ACTIONS(3082),
    [anon_sym_enum] = ACTIONS(3082),
    [anon_sym_class] = ACTIONS(3082),
    [anon_sym_struct] = ACTIONS(3082),
    [anon_sym_union] = ACTIONS(3082),
    [anon_sym_if] = ACTIONS(3082),
    [anon_sym_switch] = ACTIONS(3082),
    [anon_sym_case] = ACTIONS(3082),
    [anon_sym_default] = ACTIONS(3082),
    [anon_sym_while] = ACTIONS(3082),
    [anon_sym_do] = ACTIONS(3082),
    [anon_sym_for] = ACTIONS(3082),
    [anon_sym_return] = ACTIONS(3082),
    [anon_sym_break] = ACTIONS(3082),
    [anon_sym_continue] = ACTIONS(3082),
    [anon_sym_goto] = ACTIONS(3082),
    [anon_sym___try] = ACTIONS(3082),
    [anon_sym___leave] = ACTIONS(3082),
    [anon_sym_not] = ACTIONS(3082),
    [anon_sym_compl] = ACTIONS(3082),
    [anon_sym_DASH_DASH] = ACTIONS(3084),
    [anon_sym_PLUS_PLUS] = ACTIONS(3084),
    [anon_sym_sizeof] = ACTIONS(3082),
    [anon_sym___alignof__] = ACTIONS(3082),
    [anon_sym___alignof] = ACTIONS(3082),
    [anon_sym__alignof] = ACTIONS(3082),
    [anon_sym_alignof] = ACTIONS(3082),
    [anon_sym__Alignof] = ACTIONS(3082),
    [anon_sym_offsetof] = ACTIONS(3082),
    [anon_sym__Generic] = ACTIONS(3082),
    [anon_sym_asm] = ACTIONS(3082),
    [anon_sym___asm__] = ACTIONS(3082),
    [aux_sym_number_literal_token1] = ACTIONS(3084),
    [aux_sym_number_literal_token2] = ACTIONS(3082),
    [anon_sym_L_SQUOTE] = ACTIONS(3084),
    [anon_sym_u_SQUOTE] = ACTIONS(3084),
    [anon_sym_U_SQUOTE] = ACTIONS(3084),
    [anon_sym_u8_SQUOTE] = ACTIONS(3084),
    [anon_sym_SQUOTE] = ACTIONS(3084),
    [anon_sym_L_DQUOTE] = ACTIONS(3084),
    [anon_sym_u_DQUOTE] = ACTIONS(3084),
    [anon_sym_U_DQUOTE] = ACTIONS(3084),
    [anon_sym_u8_DQUOTE] = ACTIONS(3084),
    [anon_sym_DQUOTE] = ACTIONS(3084),
    [sym_true] = ACTIONS(3082),
    [sym_false] = ACTIONS(3082),
    [anon_sym_NULL] = ACTIONS(3082),
    [anon_sym_nullptr] = ACTIONS(3082),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3082),
    [anon_sym_decltype] = ACTIONS(3082),
    [anon_sym_virtual] = ACTIONS(3082),
    [anon_sym_alignas] = ACTIONS(3082),
    [anon_sym_explicit] = ACTIONS(3082),
    [anon_sym_typename] = ACTIONS(3082),
    [anon_sym_template] = ACTIONS(3082),
    [anon_sym_operator] = ACTIONS(3082),
    [anon_sym_try] = ACTIONS(3082),
    [anon_sym_delete] = ACTIONS(3082),
    [anon_sym_throw] = ACTIONS(3082),
    [anon_sym_namespace] = ACTIONS(3082),
    [anon_sym_using] = ACTIONS(3082),
    [anon_sym_static_assert] = ACTIONS(3082),
    [anon_sym_concept] = ACTIONS(3082),
    [anon_sym_co_return] = ACTIONS(3082),
    [anon_sym_co_yield] = ACTIONS(3082),
    [anon_sym_R_DQUOTE] = ACTIONS(3084),
    [anon_sym_LR_DQUOTE] = ACTIONS(3084),
    [anon_sym_uR_DQUOTE] = ACTIONS(3084),
    [anon_sym_UR_DQUOTE] = ACTIONS(3084),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3084),
    [anon_sym_co_await] = ACTIONS(3082),
    [anon_sym_new] = ACTIONS(3082),
    [anon_sym_requires] = ACTIONS(3082),
    [sym_this] = ACTIONS(3082),
  },
  [683] = {
    [sym_identifier] = ACTIONS(3082),
    [aux_sym_preproc_include_token1] = ACTIONS(3082),
    [aux_sym_preproc_def_token1] = ACTIONS(3082),
    [aux_sym_preproc_if_token1] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3082),
    [sym_preproc_directive] = ACTIONS(3082),
    [anon_sym_LPAREN2] = ACTIONS(3084),
    [anon_sym_BANG] = ACTIONS(3084),
    [anon_sym_TILDE] = ACTIONS(3084),
    [anon_sym_DASH] = ACTIONS(3082),
    [anon_sym_PLUS] = ACTIONS(3082),
    [anon_sym_STAR] = ACTIONS(3084),
    [anon_sym_AMP_AMP] = ACTIONS(3084),
    [anon_sym_AMP] = ACTIONS(3082),
    [anon_sym_SEMI] = ACTIONS(3084),
    [anon_sym___extension__] = ACTIONS(3082),
    [anon_sym_typedef] = ACTIONS(3082),
    [anon_sym_extern] = ACTIONS(3082),
    [anon_sym___attribute__] = ACTIONS(3082),
    [anon_sym_COLON_COLON] = ACTIONS(3084),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3084),
    [anon_sym___declspec] = ACTIONS(3082),
    [anon_sym___based] = ACTIONS(3082),
    [anon_sym___cdecl] = ACTIONS(3082),
    [anon_sym___clrcall] = ACTIONS(3082),
    [anon_sym___stdcall] = ACTIONS(3082),
    [anon_sym___fastcall] = ACTIONS(3082),
    [anon_sym___thiscall] = ACTIONS(3082),
    [anon_sym___vectorcall] = ACTIONS(3082),
    [anon_sym_LBRACE] = ACTIONS(3084),
    [anon_sym_RBRACE] = ACTIONS(3084),
    [anon_sym_signed] = ACTIONS(3082),
    [anon_sym_unsigned] = ACTIONS(3082),
    [anon_sym_long] = ACTIONS(3082),
    [anon_sym_short] = ACTIONS(3082),
    [anon_sym_LBRACK] = ACTIONS(3082),
    [anon_sym_static] = ACTIONS(3082),
    [anon_sym_register] = ACTIONS(3082),
    [anon_sym_inline] = ACTIONS(3082),
    [anon_sym___inline] = ACTIONS(3082),
    [anon_sym___inline__] = ACTIONS(3082),
    [anon_sym___forceinline] = ACTIONS(3082),
    [anon_sym_thread_local] = ACTIONS(3082),
    [anon_sym___thread] = ACTIONS(3082),
    [anon_sym_const] = ACTIONS(3082),
    [anon_sym_constexpr] = ACTIONS(3082),
    [anon_sym_volatile] = ACTIONS(3082),
    [anon_sym_restrict] = ACTIONS(3082),
    [anon_sym___restrict__] = ACTIONS(3082),
    [anon_sym__Atomic] = ACTIONS(3082),
    [anon_sym__Noreturn] = ACTIONS(3082),
    [anon_sym_noreturn] = ACTIONS(3082),
    [anon_sym_mutable] = ACTIONS(3082),
    [anon_sym_constinit] = ACTIONS(3082),
    [anon_sym_consteval] = ACTIONS(3082),
    [anon_sym_PROGMEM] = ACTIONS(3082),
    [aux_sym_primitive_type_token1] = ACTIONS(3082),
    [anon_sym_byte] = ACTIONS(3082),
    [anon_sym_word] = ACTIONS(3082),
    [anon_sym_enum] = ACTIONS(3082),
    [anon_sym_class] = ACTIONS(3082),
    [anon_sym_struct] = ACTIONS(3082),
    [anon_sym_union] = ACTIONS(3082),
    [anon_sym_if] = ACTIONS(3082),
    [anon_sym_switch] = ACTIONS(3082),
    [anon_sym_case] = ACTIONS(3082),
    [anon_sym_default] = ACTIONS(3082),
    [anon_sym_while] = ACTIONS(3082),
    [anon_sym_do] = ACTIONS(3082),
    [anon_sym_for] = ACTIONS(3082),
    [anon_sym_return] = ACTIONS(3082),
    [anon_sym_break] = ACTIONS(3082),
    [anon_sym_continue] = ACTIONS(3082),
    [anon_sym_goto] = ACTIONS(3082),
    [anon_sym___try] = ACTIONS(3082),
    [anon_sym___leave] = ACTIONS(3082),
    [anon_sym_not] = ACTIONS(3082),
    [anon_sym_compl] = ACTIONS(3082),
    [anon_sym_DASH_DASH] = ACTIONS(3084),
    [anon_sym_PLUS_PLUS] = ACTIONS(3084),
    [anon_sym_sizeof] = ACTIONS(3082),
    [anon_sym___alignof__] = ACTIONS(3082),
    [anon_sym___alignof] = ACTIONS(3082),
    [anon_sym__alignof] = ACTIONS(3082),
    [anon_sym_alignof] = ACTIONS(3082),
    [anon_sym__Alignof] = ACTIONS(3082),
    [anon_sym_offsetof] = ACTIONS(3082),
    [anon_sym__Generic] = ACTIONS(3082),
    [anon_sym_asm] = ACTIONS(3082),
    [anon_sym___asm__] = ACTIONS(3082),
    [aux_sym_number_literal_token1] = ACTIONS(3084),
    [aux_sym_number_literal_token2] = ACTIONS(3082),
    [anon_sym_L_SQUOTE] = ACTIONS(3084),
    [anon_sym_u_SQUOTE] = ACTIONS(3084),
    [anon_sym_U_SQUOTE] = ACTIONS(3084),
    [anon_sym_u8_SQUOTE] = ACTIONS(3084),
    [anon_sym_SQUOTE] = ACTIONS(3084),
    [anon_sym_L_DQUOTE] = ACTIONS(3084),
    [anon_sym_u_DQUOTE] = ACTIONS(3084),
    [anon_sym_U_DQUOTE] = ACTIONS(3084),
    [anon_sym_u8_DQUOTE] = ACTIONS(3084),
    [anon_sym_DQUOTE] = ACTIONS(3084),
    [sym_true] = ACTIONS(3082),
    [sym_false] = ACTIONS(3082),
    [anon_sym_NULL] = ACTIONS(3082),
    [anon_sym_nullptr] = ACTIONS(3082),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3082),
    [anon_sym_decltype] = ACTIONS(3082),
    [anon_sym_virtual] = ACTIONS(3082),
    [anon_sym_alignas] = ACTIONS(3082),
    [anon_sym_explicit] = ACTIONS(3082),
    [anon_sym_typename] = ACTIONS(3082),
    [anon_sym_template] = ACTIONS(3082),
    [anon_sym_operator] = ACTIONS(3082),
    [anon_sym_try] = ACTIONS(3082),
    [anon_sym_delete] = ACTIONS(3082),
    [anon_sym_throw] = ACTIONS(3082),
    [anon_sym_namespace] = ACTIONS(3082),
    [anon_sym_using] = ACTIONS(3082),
    [anon_sym_static_assert] = ACTIONS(3082),
    [anon_sym_concept] = ACTIONS(3082),
    [anon_sym_co_return] = ACTIONS(3082),
    [anon_sym_co_yield] = ACTIONS(3082),
    [anon_sym_R_DQUOTE] = ACTIONS(3084),
    [anon_sym_LR_DQUOTE] = ACTIONS(3084),
    [anon_sym_uR_DQUOTE] = ACTIONS(3084),
    [anon_sym_UR_DQUOTE] = ACTIONS(3084),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3084),
    [anon_sym_co_await] = ACTIONS(3082),
    [anon_sym_new] = ACTIONS(3082),
    [anon_sym_requires] = ACTIONS(3082),
    [sym_this] = ACTIONS(3082),
  },
  [684] = {
    [sym_identifier] = ACTIONS(3052),
    [aux_sym_preproc_include_token1] = ACTIONS(3052),
    [aux_sym_preproc_def_token1] = ACTIONS(3052),
    [aux_sym_preproc_if_token1] = ACTIONS(3052),
    [aux_sym_preproc_if_token2] = ACTIONS(3052),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3052),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3052),
    [sym_preproc_directive] = ACTIONS(3052),
    [anon_sym_LPAREN2] = ACTIONS(3054),
    [anon_sym_BANG] = ACTIONS(3054),
    [anon_sym_TILDE] = ACTIONS(3054),
    [anon_sym_DASH] = ACTIONS(3052),
    [anon_sym_PLUS] = ACTIONS(3052),
    [anon_sym_STAR] = ACTIONS(3054),
    [anon_sym_AMP_AMP] = ACTIONS(3054),
    [anon_sym_AMP] = ACTIONS(3052),
    [anon_sym_SEMI] = ACTIONS(3054),
    [anon_sym___extension__] = ACTIONS(3052),
    [anon_sym_typedef] = ACTIONS(3052),
    [anon_sym_extern] = ACTIONS(3052),
    [anon_sym___attribute__] = ACTIONS(3052),
    [anon_sym_COLON_COLON] = ACTIONS(3054),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3054),
    [anon_sym___declspec] = ACTIONS(3052),
    [anon_sym___based] = ACTIONS(3052),
    [anon_sym___cdecl] = ACTIONS(3052),
    [anon_sym___clrcall] = ACTIONS(3052),
    [anon_sym___stdcall] = ACTIONS(3052),
    [anon_sym___fastcall] = ACTIONS(3052),
    [anon_sym___thiscall] = ACTIONS(3052),
    [anon_sym___vectorcall] = ACTIONS(3052),
    [anon_sym_LBRACE] = ACTIONS(3054),
    [anon_sym_signed] = ACTIONS(3052),
    [anon_sym_unsigned] = ACTIONS(3052),
    [anon_sym_long] = ACTIONS(3052),
    [anon_sym_short] = ACTIONS(3052),
    [anon_sym_LBRACK] = ACTIONS(3052),
    [anon_sym_static] = ACTIONS(3052),
    [anon_sym_register] = ACTIONS(3052),
    [anon_sym_inline] = ACTIONS(3052),
    [anon_sym___inline] = ACTIONS(3052),
    [anon_sym___inline__] = ACTIONS(3052),
    [anon_sym___forceinline] = ACTIONS(3052),
    [anon_sym_thread_local] = ACTIONS(3052),
    [anon_sym___thread] = ACTIONS(3052),
    [anon_sym_const] = ACTIONS(3052),
    [anon_sym_constexpr] = ACTIONS(3052),
    [anon_sym_volatile] = ACTIONS(3052),
    [anon_sym_restrict] = ACTIONS(3052),
    [anon_sym___restrict__] = ACTIONS(3052),
    [anon_sym__Atomic] = ACTIONS(3052),
    [anon_sym__Noreturn] = ACTIONS(3052),
    [anon_sym_noreturn] = ACTIONS(3052),
    [anon_sym_mutable] = ACTIONS(3052),
    [anon_sym_constinit] = ACTIONS(3052),
    [anon_sym_consteval] = ACTIONS(3052),
    [anon_sym_PROGMEM] = ACTIONS(3052),
    [aux_sym_primitive_type_token1] = ACTIONS(3052),
    [anon_sym_byte] = ACTIONS(3052),
    [anon_sym_word] = ACTIONS(3052),
    [anon_sym_enum] = ACTIONS(3052),
    [anon_sym_class] = ACTIONS(3052),
    [anon_sym_struct] = ACTIONS(3052),
    [anon_sym_union] = ACTIONS(3052),
    [anon_sym_if] = ACTIONS(3052),
    [anon_sym_switch] = ACTIONS(3052),
    [anon_sym_case] = ACTIONS(3052),
    [anon_sym_default] = ACTIONS(3052),
    [anon_sym_while] = ACTIONS(3052),
    [anon_sym_do] = ACTIONS(3052),
    [anon_sym_for] = ACTIONS(3052),
    [anon_sym_return] = ACTIONS(3052),
    [anon_sym_break] = ACTIONS(3052),
    [anon_sym_continue] = ACTIONS(3052),
    [anon_sym_goto] = ACTIONS(3052),
    [anon_sym___try] = ACTIONS(3052),
    [anon_sym___leave] = ACTIONS(3052),
    [anon_sym_not] = ACTIONS(3052),
    [anon_sym_compl] = ACTIONS(3052),
    [anon_sym_DASH_DASH] = ACTIONS(3054),
    [anon_sym_PLUS_PLUS] = ACTIONS(3054),
    [anon_sym_sizeof] = ACTIONS(3052),
    [anon_sym___alignof__] = ACTIONS(3052),
    [anon_sym___alignof] = ACTIONS(3052),
    [anon_sym__alignof] = ACTIONS(3052),
    [anon_sym_alignof] = ACTIONS(3052),
    [anon_sym__Alignof] = ACTIONS(3052),
    [anon_sym_offsetof] = ACTIONS(3052),
    [anon_sym__Generic] = ACTIONS(3052),
    [anon_sym_asm] = ACTIONS(3052),
    [anon_sym___asm__] = ACTIONS(3052),
    [aux_sym_number_literal_token1] = ACTIONS(3054),
    [aux_sym_number_literal_token2] = ACTIONS(3052),
    [anon_sym_L_SQUOTE] = ACTIONS(3054),
    [anon_sym_u_SQUOTE] = ACTIONS(3054),
    [anon_sym_U_SQUOTE] = ACTIONS(3054),
    [anon_sym_u8_SQUOTE] = ACTIONS(3054),
    [anon_sym_SQUOTE] = ACTIONS(3054),
    [anon_sym_L_DQUOTE] = ACTIONS(3054),
    [anon_sym_u_DQUOTE] = ACTIONS(3054),
    [anon_sym_U_DQUOTE] = ACTIONS(3054),
    [anon_sym_u8_DQUOTE] = ACTIONS(3054),
    [anon_sym_DQUOTE] = ACTIONS(3054),
    [sym_true] = ACTIONS(3052),
    [sym_false] = ACTIONS(3052),
    [anon_sym_NULL] = ACTIONS(3052),
    [anon_sym_nullptr] = ACTIONS(3052),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3052),
    [anon_sym_decltype] = ACTIONS(3052),
    [anon_sym_virtual] = ACTIONS(3052),
    [anon_sym_alignas] = ACTIONS(3052),
    [anon_sym_explicit] = ACTIONS(3052),
    [anon_sym_typename] = ACTIONS(3052),
    [anon_sym_template] = ACTIONS(3052),
    [anon_sym_operator] = ACTIONS(3052),
    [anon_sym_try] = ACTIONS(3052),
    [anon_sym_delete] = ACTIONS(3052),
    [anon_sym_throw] = ACTIONS(3052),
    [anon_sym_namespace] = ACTIONS(3052),
    [anon_sym_using] = ACTIONS(3052),
    [anon_sym_static_assert] = ACTIONS(3052),
    [anon_sym_concept] = ACTIONS(3052),
    [anon_sym_co_return] = ACTIONS(3052),
    [anon_sym_co_yield] = ACTIONS(3052),
    [anon_sym_R_DQUOTE] = ACTIONS(3054),
    [anon_sym_LR_DQUOTE] = ACTIONS(3054),
    [anon_sym_uR_DQUOTE] = ACTIONS(3054),
    [anon_sym_UR_DQUOTE] = ACTIONS(3054),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3054),
    [anon_sym_co_await] = ACTIONS(3052),
    [anon_sym_new] = ACTIONS(3052),
    [anon_sym_requires] = ACTIONS(3052),
    [sym_this] = ACTIONS(3052),
  },
  [685] = {
    [sym_identifier] = ACTIONS(3101),
    [aux_sym_preproc_include_token1] = ACTIONS(3101),
    [aux_sym_preproc_def_token1] = ACTIONS(3101),
    [aux_sym_preproc_if_token1] = ACTIONS(3101),
    [aux_sym_preproc_if_token2] = ACTIONS(3101),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3101),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3101),
    [sym_preproc_directive] = ACTIONS(3101),
    [anon_sym_LPAREN2] = ACTIONS(3103),
    [anon_sym_BANG] = ACTIONS(3103),
    [anon_sym_TILDE] = ACTIONS(3103),
    [anon_sym_DASH] = ACTIONS(3101),
    [anon_sym_PLUS] = ACTIONS(3101),
    [anon_sym_STAR] = ACTIONS(3103),
    [anon_sym_AMP_AMP] = ACTIONS(3103),
    [anon_sym_AMP] = ACTIONS(3101),
    [anon_sym_SEMI] = ACTIONS(3103),
    [anon_sym___extension__] = ACTIONS(3101),
    [anon_sym_typedef] = ACTIONS(3101),
    [anon_sym_extern] = ACTIONS(3101),
    [anon_sym___attribute__] = ACTIONS(3101),
    [anon_sym_COLON_COLON] = ACTIONS(3103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3103),
    [anon_sym___declspec] = ACTIONS(3101),
    [anon_sym___based] = ACTIONS(3101),
    [anon_sym___cdecl] = ACTIONS(3101),
    [anon_sym___clrcall] = ACTIONS(3101),
    [anon_sym___stdcall] = ACTIONS(3101),
    [anon_sym___fastcall] = ACTIONS(3101),
    [anon_sym___thiscall] = ACTIONS(3101),
    [anon_sym___vectorcall] = ACTIONS(3101),
    [anon_sym_LBRACE] = ACTIONS(3103),
    [anon_sym_signed] = ACTIONS(3101),
    [anon_sym_unsigned] = ACTIONS(3101),
    [anon_sym_long] = ACTIONS(3101),
    [anon_sym_short] = ACTIONS(3101),
    [anon_sym_LBRACK] = ACTIONS(3101),
    [anon_sym_static] = ACTIONS(3101),
    [anon_sym_register] = ACTIONS(3101),
    [anon_sym_inline] = ACTIONS(3101),
    [anon_sym___inline] = ACTIONS(3101),
    [anon_sym___inline__] = ACTIONS(3101),
    [anon_sym___forceinline] = ACTIONS(3101),
    [anon_sym_thread_local] = ACTIONS(3101),
    [anon_sym___thread] = ACTIONS(3101),
    [anon_sym_const] = ACTIONS(3101),
    [anon_sym_constexpr] = ACTIONS(3101),
    [anon_sym_volatile] = ACTIONS(3101),
    [anon_sym_restrict] = ACTIONS(3101),
    [anon_sym___restrict__] = ACTIONS(3101),
    [anon_sym__Atomic] = ACTIONS(3101),
    [anon_sym__Noreturn] = ACTIONS(3101),
    [anon_sym_noreturn] = ACTIONS(3101),
    [anon_sym_mutable] = ACTIONS(3101),
    [anon_sym_constinit] = ACTIONS(3101),
    [anon_sym_consteval] = ACTIONS(3101),
    [anon_sym_PROGMEM] = ACTIONS(3101),
    [aux_sym_primitive_type_token1] = ACTIONS(3101),
    [anon_sym_byte] = ACTIONS(3101),
    [anon_sym_word] = ACTIONS(3101),
    [anon_sym_enum] = ACTIONS(3101),
    [anon_sym_class] = ACTIONS(3101),
    [anon_sym_struct] = ACTIONS(3101),
    [anon_sym_union] = ACTIONS(3101),
    [anon_sym_if] = ACTIONS(3101),
    [anon_sym_switch] = ACTIONS(3101),
    [anon_sym_case] = ACTIONS(3101),
    [anon_sym_default] = ACTIONS(3101),
    [anon_sym_while] = ACTIONS(3101),
    [anon_sym_do] = ACTIONS(3101),
    [anon_sym_for] = ACTIONS(3101),
    [anon_sym_return] = ACTIONS(3101),
    [anon_sym_break] = ACTIONS(3101),
    [anon_sym_continue] = ACTIONS(3101),
    [anon_sym_goto] = ACTIONS(3101),
    [anon_sym___try] = ACTIONS(3101),
    [anon_sym___leave] = ACTIONS(3101),
    [anon_sym_not] = ACTIONS(3101),
    [anon_sym_compl] = ACTIONS(3101),
    [anon_sym_DASH_DASH] = ACTIONS(3103),
    [anon_sym_PLUS_PLUS] = ACTIONS(3103),
    [anon_sym_sizeof] = ACTIONS(3101),
    [anon_sym___alignof__] = ACTIONS(3101),
    [anon_sym___alignof] = ACTIONS(3101),
    [anon_sym__alignof] = ACTIONS(3101),
    [anon_sym_alignof] = ACTIONS(3101),
    [anon_sym__Alignof] = ACTIONS(3101),
    [anon_sym_offsetof] = ACTIONS(3101),
    [anon_sym__Generic] = ACTIONS(3101),
    [anon_sym_asm] = ACTIONS(3101),
    [anon_sym___asm__] = ACTIONS(3101),
    [aux_sym_number_literal_token1] = ACTIONS(3103),
    [aux_sym_number_literal_token2] = ACTIONS(3101),
    [anon_sym_L_SQUOTE] = ACTIONS(3103),
    [anon_sym_u_SQUOTE] = ACTIONS(3103),
    [anon_sym_U_SQUOTE] = ACTIONS(3103),
    [anon_sym_u8_SQUOTE] = ACTIONS(3103),
    [anon_sym_SQUOTE] = ACTIONS(3103),
    [anon_sym_L_DQUOTE] = ACTIONS(3103),
    [anon_sym_u_DQUOTE] = ACTIONS(3103),
    [anon_sym_U_DQUOTE] = ACTIONS(3103),
    [anon_sym_u8_DQUOTE] = ACTIONS(3103),
    [anon_sym_DQUOTE] = ACTIONS(3103),
    [sym_true] = ACTIONS(3101),
    [sym_false] = ACTIONS(3101),
    [anon_sym_NULL] = ACTIONS(3101),
    [anon_sym_nullptr] = ACTIONS(3101),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3101),
    [anon_sym_decltype] = ACTIONS(3101),
    [anon_sym_virtual] = ACTIONS(3101),
    [anon_sym_alignas] = ACTIONS(3101),
    [anon_sym_explicit] = ACTIONS(3101),
    [anon_sym_typename] = ACTIONS(3101),
    [anon_sym_template] = ACTIONS(3101),
    [anon_sym_operator] = ACTIONS(3101),
    [anon_sym_try] = ACTIONS(3101),
    [anon_sym_delete] = ACTIONS(3101),
    [anon_sym_throw] = ACTIONS(3101),
    [anon_sym_namespace] = ACTIONS(3101),
    [anon_sym_using] = ACTIONS(3101),
    [anon_sym_static_assert] = ACTIONS(3101),
    [anon_sym_concept] = ACTIONS(3101),
    [anon_sym_co_return] = ACTIONS(3101),
    [anon_sym_co_yield] = ACTIONS(3101),
    [anon_sym_R_DQUOTE] = ACTIONS(3103),
    [anon_sym_LR_DQUOTE] = ACTIONS(3103),
    [anon_sym_uR_DQUOTE] = ACTIONS(3103),
    [anon_sym_UR_DQUOTE] = ACTIONS(3103),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3103),
    [anon_sym_co_await] = ACTIONS(3101),
    [anon_sym_new] = ACTIONS(3101),
    [anon_sym_requires] = ACTIONS(3101),
    [sym_this] = ACTIONS(3101),
  },
  [686] = {
    [sym_identifier] = ACTIONS(3078),
    [aux_sym_preproc_include_token1] = ACTIONS(3078),
    [aux_sym_preproc_def_token1] = ACTIONS(3078),
    [aux_sym_preproc_if_token1] = ACTIONS(3078),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3078),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3078),
    [sym_preproc_directive] = ACTIONS(3078),
    [anon_sym_LPAREN2] = ACTIONS(3080),
    [anon_sym_BANG] = ACTIONS(3080),
    [anon_sym_TILDE] = ACTIONS(3080),
    [anon_sym_DASH] = ACTIONS(3078),
    [anon_sym_PLUS] = ACTIONS(3078),
    [anon_sym_STAR] = ACTIONS(3080),
    [anon_sym_AMP_AMP] = ACTIONS(3080),
    [anon_sym_AMP] = ACTIONS(3078),
    [anon_sym_SEMI] = ACTIONS(3080),
    [anon_sym___extension__] = ACTIONS(3078),
    [anon_sym_typedef] = ACTIONS(3078),
    [anon_sym_extern] = ACTIONS(3078),
    [anon_sym___attribute__] = ACTIONS(3078),
    [anon_sym_COLON_COLON] = ACTIONS(3080),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3080),
    [anon_sym___declspec] = ACTIONS(3078),
    [anon_sym___based] = ACTIONS(3078),
    [anon_sym___cdecl] = ACTIONS(3078),
    [anon_sym___clrcall] = ACTIONS(3078),
    [anon_sym___stdcall] = ACTIONS(3078),
    [anon_sym___fastcall] = ACTIONS(3078),
    [anon_sym___thiscall] = ACTIONS(3078),
    [anon_sym___vectorcall] = ACTIONS(3078),
    [anon_sym_LBRACE] = ACTIONS(3080),
    [anon_sym_RBRACE] = ACTIONS(3080),
    [anon_sym_signed] = ACTIONS(3078),
    [anon_sym_unsigned] = ACTIONS(3078),
    [anon_sym_long] = ACTIONS(3078),
    [anon_sym_short] = ACTIONS(3078),
    [anon_sym_LBRACK] = ACTIONS(3078),
    [anon_sym_static] = ACTIONS(3078),
    [anon_sym_register] = ACTIONS(3078),
    [anon_sym_inline] = ACTIONS(3078),
    [anon_sym___inline] = ACTIONS(3078),
    [anon_sym___inline__] = ACTIONS(3078),
    [anon_sym___forceinline] = ACTIONS(3078),
    [anon_sym_thread_local] = ACTIONS(3078),
    [anon_sym___thread] = ACTIONS(3078),
    [anon_sym_const] = ACTIONS(3078),
    [anon_sym_constexpr] = ACTIONS(3078),
    [anon_sym_volatile] = ACTIONS(3078),
    [anon_sym_restrict] = ACTIONS(3078),
    [anon_sym___restrict__] = ACTIONS(3078),
    [anon_sym__Atomic] = ACTIONS(3078),
    [anon_sym__Noreturn] = ACTIONS(3078),
    [anon_sym_noreturn] = ACTIONS(3078),
    [anon_sym_mutable] = ACTIONS(3078),
    [anon_sym_constinit] = ACTIONS(3078),
    [anon_sym_consteval] = ACTIONS(3078),
    [anon_sym_PROGMEM] = ACTIONS(3078),
    [aux_sym_primitive_type_token1] = ACTIONS(3078),
    [anon_sym_byte] = ACTIONS(3078),
    [anon_sym_word] = ACTIONS(3078),
    [anon_sym_enum] = ACTIONS(3078),
    [anon_sym_class] = ACTIONS(3078),
    [anon_sym_struct] = ACTIONS(3078),
    [anon_sym_union] = ACTIONS(3078),
    [anon_sym_if] = ACTIONS(3078),
    [anon_sym_switch] = ACTIONS(3078),
    [anon_sym_case] = ACTIONS(3078),
    [anon_sym_default] = ACTIONS(3078),
    [anon_sym_while] = ACTIONS(3078),
    [anon_sym_do] = ACTIONS(3078),
    [anon_sym_for] = ACTIONS(3078),
    [anon_sym_return] = ACTIONS(3078),
    [anon_sym_break] = ACTIONS(3078),
    [anon_sym_continue] = ACTIONS(3078),
    [anon_sym_goto] = ACTIONS(3078),
    [anon_sym___try] = ACTIONS(3078),
    [anon_sym___leave] = ACTIONS(3078),
    [anon_sym_not] = ACTIONS(3078),
    [anon_sym_compl] = ACTIONS(3078),
    [anon_sym_DASH_DASH] = ACTIONS(3080),
    [anon_sym_PLUS_PLUS] = ACTIONS(3080),
    [anon_sym_sizeof] = ACTIONS(3078),
    [anon_sym___alignof__] = ACTIONS(3078),
    [anon_sym___alignof] = ACTIONS(3078),
    [anon_sym__alignof] = ACTIONS(3078),
    [anon_sym_alignof] = ACTIONS(3078),
    [anon_sym__Alignof] = ACTIONS(3078),
    [anon_sym_offsetof] = ACTIONS(3078),
    [anon_sym__Generic] = ACTIONS(3078),
    [anon_sym_asm] = ACTIONS(3078),
    [anon_sym___asm__] = ACTIONS(3078),
    [aux_sym_number_literal_token1] = ACTIONS(3080),
    [aux_sym_number_literal_token2] = ACTIONS(3078),
    [anon_sym_L_SQUOTE] = ACTIONS(3080),
    [anon_sym_u_SQUOTE] = ACTIONS(3080),
    [anon_sym_U_SQUOTE] = ACTIONS(3080),
    [anon_sym_u8_SQUOTE] = ACTIONS(3080),
    [anon_sym_SQUOTE] = ACTIONS(3080),
    [anon_sym_L_DQUOTE] = ACTIONS(3080),
    [anon_sym_u_DQUOTE] = ACTIONS(3080),
    [anon_sym_U_DQUOTE] = ACTIONS(3080),
    [anon_sym_u8_DQUOTE] = ACTIONS(3080),
    [anon_sym_DQUOTE] = ACTIONS(3080),
    [sym_true] = ACTIONS(3078),
    [sym_false] = ACTIONS(3078),
    [anon_sym_NULL] = ACTIONS(3078),
    [anon_sym_nullptr] = ACTIONS(3078),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3078),
    [anon_sym_decltype] = ACTIONS(3078),
    [anon_sym_virtual] = ACTIONS(3078),
    [anon_sym_alignas] = ACTIONS(3078),
    [anon_sym_explicit] = ACTIONS(3078),
    [anon_sym_typename] = ACTIONS(3078),
    [anon_sym_template] = ACTIONS(3078),
    [anon_sym_operator] = ACTIONS(3078),
    [anon_sym_try] = ACTIONS(3078),
    [anon_sym_delete] = ACTIONS(3078),
    [anon_sym_throw] = ACTIONS(3078),
    [anon_sym_namespace] = ACTIONS(3078),
    [anon_sym_using] = ACTIONS(3078),
    [anon_sym_static_assert] = ACTIONS(3078),
    [anon_sym_concept] = ACTIONS(3078),
    [anon_sym_co_return] = ACTIONS(3078),
    [anon_sym_co_yield] = ACTIONS(3078),
    [anon_sym_R_DQUOTE] = ACTIONS(3080),
    [anon_sym_LR_DQUOTE] = ACTIONS(3080),
    [anon_sym_uR_DQUOTE] = ACTIONS(3080),
    [anon_sym_UR_DQUOTE] = ACTIONS(3080),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3080),
    [anon_sym_co_await] = ACTIONS(3078),
    [anon_sym_new] = ACTIONS(3078),
    [anon_sym_requires] = ACTIONS(3078),
    [sym_this] = ACTIONS(3078),
  },
  [687] = {
    [sym_identifier] = ACTIONS(3156),
    [aux_sym_preproc_include_token1] = ACTIONS(3156),
    [aux_sym_preproc_def_token1] = ACTIONS(3156),
    [aux_sym_preproc_if_token1] = ACTIONS(3156),
    [aux_sym_preproc_if_token2] = ACTIONS(3156),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3156),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3156),
    [sym_preproc_directive] = ACTIONS(3156),
    [anon_sym_LPAREN2] = ACTIONS(3158),
    [anon_sym_BANG] = ACTIONS(3158),
    [anon_sym_TILDE] = ACTIONS(3158),
    [anon_sym_DASH] = ACTIONS(3156),
    [anon_sym_PLUS] = ACTIONS(3156),
    [anon_sym_STAR] = ACTIONS(3158),
    [anon_sym_AMP_AMP] = ACTIONS(3158),
    [anon_sym_AMP] = ACTIONS(3156),
    [anon_sym_SEMI] = ACTIONS(3158),
    [anon_sym___extension__] = ACTIONS(3156),
    [anon_sym_typedef] = ACTIONS(3156),
    [anon_sym_extern] = ACTIONS(3156),
    [anon_sym___attribute__] = ACTIONS(3156),
    [anon_sym_COLON_COLON] = ACTIONS(3158),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3158),
    [anon_sym___declspec] = ACTIONS(3156),
    [anon_sym___based] = ACTIONS(3156),
    [anon_sym___cdecl] = ACTIONS(3156),
    [anon_sym___clrcall] = ACTIONS(3156),
    [anon_sym___stdcall] = ACTIONS(3156),
    [anon_sym___fastcall] = ACTIONS(3156),
    [anon_sym___thiscall] = ACTIONS(3156),
    [anon_sym___vectorcall] = ACTIONS(3156),
    [anon_sym_LBRACE] = ACTIONS(3158),
    [anon_sym_signed] = ACTIONS(3156),
    [anon_sym_unsigned] = ACTIONS(3156),
    [anon_sym_long] = ACTIONS(3156),
    [anon_sym_short] = ACTIONS(3156),
    [anon_sym_LBRACK] = ACTIONS(3156),
    [anon_sym_static] = ACTIONS(3156),
    [anon_sym_register] = ACTIONS(3156),
    [anon_sym_inline] = ACTIONS(3156),
    [anon_sym___inline] = ACTIONS(3156),
    [anon_sym___inline__] = ACTIONS(3156),
    [anon_sym___forceinline] = ACTIONS(3156),
    [anon_sym_thread_local] = ACTIONS(3156),
    [anon_sym___thread] = ACTIONS(3156),
    [anon_sym_const] = ACTIONS(3156),
    [anon_sym_constexpr] = ACTIONS(3156),
    [anon_sym_volatile] = ACTIONS(3156),
    [anon_sym_restrict] = ACTIONS(3156),
    [anon_sym___restrict__] = ACTIONS(3156),
    [anon_sym__Atomic] = ACTIONS(3156),
    [anon_sym__Noreturn] = ACTIONS(3156),
    [anon_sym_noreturn] = ACTIONS(3156),
    [anon_sym_mutable] = ACTIONS(3156),
    [anon_sym_constinit] = ACTIONS(3156),
    [anon_sym_consteval] = ACTIONS(3156),
    [anon_sym_PROGMEM] = ACTIONS(3156),
    [aux_sym_primitive_type_token1] = ACTIONS(3156),
    [anon_sym_byte] = ACTIONS(3156),
    [anon_sym_word] = ACTIONS(3156),
    [anon_sym_enum] = ACTIONS(3156),
    [anon_sym_class] = ACTIONS(3156),
    [anon_sym_struct] = ACTIONS(3156),
    [anon_sym_union] = ACTIONS(3156),
    [anon_sym_if] = ACTIONS(3156),
    [anon_sym_switch] = ACTIONS(3156),
    [anon_sym_case] = ACTIONS(3156),
    [anon_sym_default] = ACTIONS(3156),
    [anon_sym_while] = ACTIONS(3156),
    [anon_sym_do] = ACTIONS(3156),
    [anon_sym_for] = ACTIONS(3156),
    [anon_sym_return] = ACTIONS(3156),
    [anon_sym_break] = ACTIONS(3156),
    [anon_sym_continue] = ACTIONS(3156),
    [anon_sym_goto] = ACTIONS(3156),
    [anon_sym___try] = ACTIONS(3156),
    [anon_sym___leave] = ACTIONS(3156),
    [anon_sym_not] = ACTIONS(3156),
    [anon_sym_compl] = ACTIONS(3156),
    [anon_sym_DASH_DASH] = ACTIONS(3158),
    [anon_sym_PLUS_PLUS] = ACTIONS(3158),
    [anon_sym_sizeof] = ACTIONS(3156),
    [anon_sym___alignof__] = ACTIONS(3156),
    [anon_sym___alignof] = ACTIONS(3156),
    [anon_sym__alignof] = ACTIONS(3156),
    [anon_sym_alignof] = ACTIONS(3156),
    [anon_sym__Alignof] = ACTIONS(3156),
    [anon_sym_offsetof] = ACTIONS(3156),
    [anon_sym__Generic] = ACTIONS(3156),
    [anon_sym_asm] = ACTIONS(3156),
    [anon_sym___asm__] = ACTIONS(3156),
    [aux_sym_number_literal_token1] = ACTIONS(3158),
    [aux_sym_number_literal_token2] = ACTIONS(3156),
    [anon_sym_L_SQUOTE] = ACTIONS(3158),
    [anon_sym_u_SQUOTE] = ACTIONS(3158),
    [anon_sym_U_SQUOTE] = ACTIONS(3158),
    [anon_sym_u8_SQUOTE] = ACTIONS(3158),
    [anon_sym_SQUOTE] = ACTIONS(3158),
    [anon_sym_L_DQUOTE] = ACTIONS(3158),
    [anon_sym_u_DQUOTE] = ACTIONS(3158),
    [anon_sym_U_DQUOTE] = ACTIONS(3158),
    [anon_sym_u8_DQUOTE] = ACTIONS(3158),
    [anon_sym_DQUOTE] = ACTIONS(3158),
    [sym_true] = ACTIONS(3156),
    [sym_false] = ACTIONS(3156),
    [anon_sym_NULL] = ACTIONS(3156),
    [anon_sym_nullptr] = ACTIONS(3156),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3156),
    [anon_sym_decltype] = ACTIONS(3156),
    [anon_sym_virtual] = ACTIONS(3156),
    [anon_sym_alignas] = ACTIONS(3156),
    [anon_sym_explicit] = ACTIONS(3156),
    [anon_sym_typename] = ACTIONS(3156),
    [anon_sym_template] = ACTIONS(3156),
    [anon_sym_operator] = ACTIONS(3156),
    [anon_sym_try] = ACTIONS(3156),
    [anon_sym_delete] = ACTIONS(3156),
    [anon_sym_throw] = ACTIONS(3156),
    [anon_sym_namespace] = ACTIONS(3156),
    [anon_sym_using] = ACTIONS(3156),
    [anon_sym_static_assert] = ACTIONS(3156),
    [anon_sym_concept] = ACTIONS(3156),
    [anon_sym_co_return] = ACTIONS(3156),
    [anon_sym_co_yield] = ACTIONS(3156),
    [anon_sym_R_DQUOTE] = ACTIONS(3158),
    [anon_sym_LR_DQUOTE] = ACTIONS(3158),
    [anon_sym_uR_DQUOTE] = ACTIONS(3158),
    [anon_sym_UR_DQUOTE] = ACTIONS(3158),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3158),
    [anon_sym_co_await] = ACTIONS(3156),
    [anon_sym_new] = ACTIONS(3156),
    [anon_sym_requires] = ACTIONS(3156),
    [sym_this] = ACTIONS(3156),
  },
  [688] = {
    [sym_identifier] = ACTIONS(3068),
    [aux_sym_preproc_include_token1] = ACTIONS(3068),
    [aux_sym_preproc_def_token1] = ACTIONS(3068),
    [aux_sym_preproc_if_token1] = ACTIONS(3068),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3068),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3068),
    [sym_preproc_directive] = ACTIONS(3068),
    [anon_sym_LPAREN2] = ACTIONS(3070),
    [anon_sym_BANG] = ACTIONS(3070),
    [anon_sym_TILDE] = ACTIONS(3070),
    [anon_sym_DASH] = ACTIONS(3068),
    [anon_sym_PLUS] = ACTIONS(3068),
    [anon_sym_STAR] = ACTIONS(3070),
    [anon_sym_AMP_AMP] = ACTIONS(3070),
    [anon_sym_AMP] = ACTIONS(3068),
    [anon_sym_SEMI] = ACTIONS(3070),
    [anon_sym___extension__] = ACTIONS(3068),
    [anon_sym_typedef] = ACTIONS(3068),
    [anon_sym_extern] = ACTIONS(3068),
    [anon_sym___attribute__] = ACTIONS(3068),
    [anon_sym_COLON_COLON] = ACTIONS(3070),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3070),
    [anon_sym___declspec] = ACTIONS(3068),
    [anon_sym___based] = ACTIONS(3068),
    [anon_sym___cdecl] = ACTIONS(3068),
    [anon_sym___clrcall] = ACTIONS(3068),
    [anon_sym___stdcall] = ACTIONS(3068),
    [anon_sym___fastcall] = ACTIONS(3068),
    [anon_sym___thiscall] = ACTIONS(3068),
    [anon_sym___vectorcall] = ACTIONS(3068),
    [anon_sym_LBRACE] = ACTIONS(3070),
    [anon_sym_RBRACE] = ACTIONS(3070),
    [anon_sym_signed] = ACTIONS(3068),
    [anon_sym_unsigned] = ACTIONS(3068),
    [anon_sym_long] = ACTIONS(3068),
    [anon_sym_short] = ACTIONS(3068),
    [anon_sym_LBRACK] = ACTIONS(3068),
    [anon_sym_static] = ACTIONS(3068),
    [anon_sym_register] = ACTIONS(3068),
    [anon_sym_inline] = ACTIONS(3068),
    [anon_sym___inline] = ACTIONS(3068),
    [anon_sym___inline__] = ACTIONS(3068),
    [anon_sym___forceinline] = ACTIONS(3068),
    [anon_sym_thread_local] = ACTIONS(3068),
    [anon_sym___thread] = ACTIONS(3068),
    [anon_sym_const] = ACTIONS(3068),
    [anon_sym_constexpr] = ACTIONS(3068),
    [anon_sym_volatile] = ACTIONS(3068),
    [anon_sym_restrict] = ACTIONS(3068),
    [anon_sym___restrict__] = ACTIONS(3068),
    [anon_sym__Atomic] = ACTIONS(3068),
    [anon_sym__Noreturn] = ACTIONS(3068),
    [anon_sym_noreturn] = ACTIONS(3068),
    [anon_sym_mutable] = ACTIONS(3068),
    [anon_sym_constinit] = ACTIONS(3068),
    [anon_sym_consteval] = ACTIONS(3068),
    [anon_sym_PROGMEM] = ACTIONS(3068),
    [aux_sym_primitive_type_token1] = ACTIONS(3068),
    [anon_sym_byte] = ACTIONS(3068),
    [anon_sym_word] = ACTIONS(3068),
    [anon_sym_enum] = ACTIONS(3068),
    [anon_sym_class] = ACTIONS(3068),
    [anon_sym_struct] = ACTIONS(3068),
    [anon_sym_union] = ACTIONS(3068),
    [anon_sym_if] = ACTIONS(3068),
    [anon_sym_switch] = ACTIONS(3068),
    [anon_sym_case] = ACTIONS(3068),
    [anon_sym_default] = ACTIONS(3068),
    [anon_sym_while] = ACTIONS(3068),
    [anon_sym_do] = ACTIONS(3068),
    [anon_sym_for] = ACTIONS(3068),
    [anon_sym_return] = ACTIONS(3068),
    [anon_sym_break] = ACTIONS(3068),
    [anon_sym_continue] = ACTIONS(3068),
    [anon_sym_goto] = ACTIONS(3068),
    [anon_sym___try] = ACTIONS(3068),
    [anon_sym___leave] = ACTIONS(3068),
    [anon_sym_not] = ACTIONS(3068),
    [anon_sym_compl] = ACTIONS(3068),
    [anon_sym_DASH_DASH] = ACTIONS(3070),
    [anon_sym_PLUS_PLUS] = ACTIONS(3070),
    [anon_sym_sizeof] = ACTIONS(3068),
    [anon_sym___alignof__] = ACTIONS(3068),
    [anon_sym___alignof] = ACTIONS(3068),
    [anon_sym__alignof] = ACTIONS(3068),
    [anon_sym_alignof] = ACTIONS(3068),
    [anon_sym__Alignof] = ACTIONS(3068),
    [anon_sym_offsetof] = ACTIONS(3068),
    [anon_sym__Generic] = ACTIONS(3068),
    [anon_sym_asm] = ACTIONS(3068),
    [anon_sym___asm__] = ACTIONS(3068),
    [aux_sym_number_literal_token1] = ACTIONS(3070),
    [aux_sym_number_literal_token2] = ACTIONS(3068),
    [anon_sym_L_SQUOTE] = ACTIONS(3070),
    [anon_sym_u_SQUOTE] = ACTIONS(3070),
    [anon_sym_U_SQUOTE] = ACTIONS(3070),
    [anon_sym_u8_SQUOTE] = ACTIONS(3070),
    [anon_sym_SQUOTE] = ACTIONS(3070),
    [anon_sym_L_DQUOTE] = ACTIONS(3070),
    [anon_sym_u_DQUOTE] = ACTIONS(3070),
    [anon_sym_U_DQUOTE] = ACTIONS(3070),
    [anon_sym_u8_DQUOTE] = ACTIONS(3070),
    [anon_sym_DQUOTE] = ACTIONS(3070),
    [sym_true] = ACTIONS(3068),
    [sym_false] = ACTIONS(3068),
    [anon_sym_NULL] = ACTIONS(3068),
    [anon_sym_nullptr] = ACTIONS(3068),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3068),
    [anon_sym_decltype] = ACTIONS(3068),
    [anon_sym_virtual] = ACTIONS(3068),
    [anon_sym_alignas] = ACTIONS(3068),
    [anon_sym_explicit] = ACTIONS(3068),
    [anon_sym_typename] = ACTIONS(3068),
    [anon_sym_template] = ACTIONS(3068),
    [anon_sym_operator] = ACTIONS(3068),
    [anon_sym_try] = ACTIONS(3068),
    [anon_sym_delete] = ACTIONS(3068),
    [anon_sym_throw] = ACTIONS(3068),
    [anon_sym_namespace] = ACTIONS(3068),
    [anon_sym_using] = ACTIONS(3068),
    [anon_sym_static_assert] = ACTIONS(3068),
    [anon_sym_concept] = ACTIONS(3068),
    [anon_sym_co_return] = ACTIONS(3068),
    [anon_sym_co_yield] = ACTIONS(3068),
    [anon_sym_R_DQUOTE] = ACTIONS(3070),
    [anon_sym_LR_DQUOTE] = ACTIONS(3070),
    [anon_sym_uR_DQUOTE] = ACTIONS(3070),
    [anon_sym_UR_DQUOTE] = ACTIONS(3070),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3070),
    [anon_sym_co_await] = ACTIONS(3068),
    [anon_sym_new] = ACTIONS(3068),
    [anon_sym_requires] = ACTIONS(3068),
    [sym_this] = ACTIONS(3068),
  },
  [689] = {
    [sym_identifier] = ACTIONS(3068),
    [aux_sym_preproc_include_token1] = ACTIONS(3068),
    [aux_sym_preproc_def_token1] = ACTIONS(3068),
    [aux_sym_preproc_if_token1] = ACTIONS(3068),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3068),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3068),
    [sym_preproc_directive] = ACTIONS(3068),
    [anon_sym_LPAREN2] = ACTIONS(3070),
    [anon_sym_BANG] = ACTIONS(3070),
    [anon_sym_TILDE] = ACTIONS(3070),
    [anon_sym_DASH] = ACTIONS(3068),
    [anon_sym_PLUS] = ACTIONS(3068),
    [anon_sym_STAR] = ACTIONS(3070),
    [anon_sym_AMP_AMP] = ACTIONS(3070),
    [anon_sym_AMP] = ACTIONS(3068),
    [anon_sym_SEMI] = ACTIONS(3070),
    [anon_sym___extension__] = ACTIONS(3068),
    [anon_sym_typedef] = ACTIONS(3068),
    [anon_sym_extern] = ACTIONS(3068),
    [anon_sym___attribute__] = ACTIONS(3068),
    [anon_sym_COLON_COLON] = ACTIONS(3070),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3070),
    [anon_sym___declspec] = ACTIONS(3068),
    [anon_sym___based] = ACTIONS(3068),
    [anon_sym___cdecl] = ACTIONS(3068),
    [anon_sym___clrcall] = ACTIONS(3068),
    [anon_sym___stdcall] = ACTIONS(3068),
    [anon_sym___fastcall] = ACTIONS(3068),
    [anon_sym___thiscall] = ACTIONS(3068),
    [anon_sym___vectorcall] = ACTIONS(3068),
    [anon_sym_LBRACE] = ACTIONS(3070),
    [anon_sym_RBRACE] = ACTIONS(3070),
    [anon_sym_signed] = ACTIONS(3068),
    [anon_sym_unsigned] = ACTIONS(3068),
    [anon_sym_long] = ACTIONS(3068),
    [anon_sym_short] = ACTIONS(3068),
    [anon_sym_LBRACK] = ACTIONS(3068),
    [anon_sym_static] = ACTIONS(3068),
    [anon_sym_register] = ACTIONS(3068),
    [anon_sym_inline] = ACTIONS(3068),
    [anon_sym___inline] = ACTIONS(3068),
    [anon_sym___inline__] = ACTIONS(3068),
    [anon_sym___forceinline] = ACTIONS(3068),
    [anon_sym_thread_local] = ACTIONS(3068),
    [anon_sym___thread] = ACTIONS(3068),
    [anon_sym_const] = ACTIONS(3068),
    [anon_sym_constexpr] = ACTIONS(3068),
    [anon_sym_volatile] = ACTIONS(3068),
    [anon_sym_restrict] = ACTIONS(3068),
    [anon_sym___restrict__] = ACTIONS(3068),
    [anon_sym__Atomic] = ACTIONS(3068),
    [anon_sym__Noreturn] = ACTIONS(3068),
    [anon_sym_noreturn] = ACTIONS(3068),
    [anon_sym_mutable] = ACTIONS(3068),
    [anon_sym_constinit] = ACTIONS(3068),
    [anon_sym_consteval] = ACTIONS(3068),
    [anon_sym_PROGMEM] = ACTIONS(3068),
    [aux_sym_primitive_type_token1] = ACTIONS(3068),
    [anon_sym_byte] = ACTIONS(3068),
    [anon_sym_word] = ACTIONS(3068),
    [anon_sym_enum] = ACTIONS(3068),
    [anon_sym_class] = ACTIONS(3068),
    [anon_sym_struct] = ACTIONS(3068),
    [anon_sym_union] = ACTIONS(3068),
    [anon_sym_if] = ACTIONS(3068),
    [anon_sym_switch] = ACTIONS(3068),
    [anon_sym_case] = ACTIONS(3068),
    [anon_sym_default] = ACTIONS(3068),
    [anon_sym_while] = ACTIONS(3068),
    [anon_sym_do] = ACTIONS(3068),
    [anon_sym_for] = ACTIONS(3068),
    [anon_sym_return] = ACTIONS(3068),
    [anon_sym_break] = ACTIONS(3068),
    [anon_sym_continue] = ACTIONS(3068),
    [anon_sym_goto] = ACTIONS(3068),
    [anon_sym___try] = ACTIONS(3068),
    [anon_sym___leave] = ACTIONS(3068),
    [anon_sym_not] = ACTIONS(3068),
    [anon_sym_compl] = ACTIONS(3068),
    [anon_sym_DASH_DASH] = ACTIONS(3070),
    [anon_sym_PLUS_PLUS] = ACTIONS(3070),
    [anon_sym_sizeof] = ACTIONS(3068),
    [anon_sym___alignof__] = ACTIONS(3068),
    [anon_sym___alignof] = ACTIONS(3068),
    [anon_sym__alignof] = ACTIONS(3068),
    [anon_sym_alignof] = ACTIONS(3068),
    [anon_sym__Alignof] = ACTIONS(3068),
    [anon_sym_offsetof] = ACTIONS(3068),
    [anon_sym__Generic] = ACTIONS(3068),
    [anon_sym_asm] = ACTIONS(3068),
    [anon_sym___asm__] = ACTIONS(3068),
    [aux_sym_number_literal_token1] = ACTIONS(3070),
    [aux_sym_number_literal_token2] = ACTIONS(3068),
    [anon_sym_L_SQUOTE] = ACTIONS(3070),
    [anon_sym_u_SQUOTE] = ACTIONS(3070),
    [anon_sym_U_SQUOTE] = ACTIONS(3070),
    [anon_sym_u8_SQUOTE] = ACTIONS(3070),
    [anon_sym_SQUOTE] = ACTIONS(3070),
    [anon_sym_L_DQUOTE] = ACTIONS(3070),
    [anon_sym_u_DQUOTE] = ACTIONS(3070),
    [anon_sym_U_DQUOTE] = ACTIONS(3070),
    [anon_sym_u8_DQUOTE] = ACTIONS(3070),
    [anon_sym_DQUOTE] = ACTIONS(3070),
    [sym_true] = ACTIONS(3068),
    [sym_false] = ACTIONS(3068),
    [anon_sym_NULL] = ACTIONS(3068),
    [anon_sym_nullptr] = ACTIONS(3068),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3068),
    [anon_sym_decltype] = ACTIONS(3068),
    [anon_sym_virtual] = ACTIONS(3068),
    [anon_sym_alignas] = ACTIONS(3068),
    [anon_sym_explicit] = ACTIONS(3068),
    [anon_sym_typename] = ACTIONS(3068),
    [anon_sym_template] = ACTIONS(3068),
    [anon_sym_operator] = ACTIONS(3068),
    [anon_sym_try] = ACTIONS(3068),
    [anon_sym_delete] = ACTIONS(3068),
    [anon_sym_throw] = ACTIONS(3068),
    [anon_sym_namespace] = ACTIONS(3068),
    [anon_sym_using] = ACTIONS(3068),
    [anon_sym_static_assert] = ACTIONS(3068),
    [anon_sym_concept] = ACTIONS(3068),
    [anon_sym_co_return] = ACTIONS(3068),
    [anon_sym_co_yield] = ACTIONS(3068),
    [anon_sym_R_DQUOTE] = ACTIONS(3070),
    [anon_sym_LR_DQUOTE] = ACTIONS(3070),
    [anon_sym_uR_DQUOTE] = ACTIONS(3070),
    [anon_sym_UR_DQUOTE] = ACTIONS(3070),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3070),
    [anon_sym_co_await] = ACTIONS(3068),
    [anon_sym_new] = ACTIONS(3068),
    [anon_sym_requires] = ACTIONS(3068),
    [sym_this] = ACTIONS(3068),
  },
  [690] = {
    [sym_identifier] = ACTIONS(2877),
    [aux_sym_preproc_include_token1] = ACTIONS(2877),
    [aux_sym_preproc_def_token1] = ACTIONS(2877),
    [aux_sym_preproc_if_token1] = ACTIONS(2877),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2877),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2877),
    [sym_preproc_directive] = ACTIONS(2877),
    [anon_sym_LPAREN2] = ACTIONS(2879),
    [anon_sym_BANG] = ACTIONS(2879),
    [anon_sym_TILDE] = ACTIONS(2879),
    [anon_sym_DASH] = ACTIONS(2877),
    [anon_sym_PLUS] = ACTIONS(2877),
    [anon_sym_STAR] = ACTIONS(2879),
    [anon_sym_AMP_AMP] = ACTIONS(2879),
    [anon_sym_AMP] = ACTIONS(2877),
    [anon_sym_SEMI] = ACTIONS(2879),
    [anon_sym___extension__] = ACTIONS(2877),
    [anon_sym_typedef] = ACTIONS(2877),
    [anon_sym_extern] = ACTIONS(2877),
    [anon_sym___attribute__] = ACTIONS(2877),
    [anon_sym_COLON_COLON] = ACTIONS(2879),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2879),
    [anon_sym___declspec] = ACTIONS(2877),
    [anon_sym___based] = ACTIONS(2877),
    [anon_sym___cdecl] = ACTIONS(2877),
    [anon_sym___clrcall] = ACTIONS(2877),
    [anon_sym___stdcall] = ACTIONS(2877),
    [anon_sym___fastcall] = ACTIONS(2877),
    [anon_sym___thiscall] = ACTIONS(2877),
    [anon_sym___vectorcall] = ACTIONS(2877),
    [anon_sym_LBRACE] = ACTIONS(2879),
    [anon_sym_RBRACE] = ACTIONS(2879),
    [anon_sym_signed] = ACTIONS(2877),
    [anon_sym_unsigned] = ACTIONS(2877),
    [anon_sym_long] = ACTIONS(2877),
    [anon_sym_short] = ACTIONS(2877),
    [anon_sym_LBRACK] = ACTIONS(2877),
    [anon_sym_static] = ACTIONS(2877),
    [anon_sym_register] = ACTIONS(2877),
    [anon_sym_inline] = ACTIONS(2877),
    [anon_sym___inline] = ACTIONS(2877),
    [anon_sym___inline__] = ACTIONS(2877),
    [anon_sym___forceinline] = ACTIONS(2877),
    [anon_sym_thread_local] = ACTIONS(2877),
    [anon_sym___thread] = ACTIONS(2877),
    [anon_sym_const] = ACTIONS(2877),
    [anon_sym_constexpr] = ACTIONS(2877),
    [anon_sym_volatile] = ACTIONS(2877),
    [anon_sym_restrict] = ACTIONS(2877),
    [anon_sym___restrict__] = ACTIONS(2877),
    [anon_sym__Atomic] = ACTIONS(2877),
    [anon_sym__Noreturn] = ACTIONS(2877),
    [anon_sym_noreturn] = ACTIONS(2877),
    [anon_sym_mutable] = ACTIONS(2877),
    [anon_sym_constinit] = ACTIONS(2877),
    [anon_sym_consteval] = ACTIONS(2877),
    [anon_sym_PROGMEM] = ACTIONS(2877),
    [aux_sym_primitive_type_token1] = ACTIONS(2877),
    [anon_sym_byte] = ACTIONS(2877),
    [anon_sym_word] = ACTIONS(2877),
    [anon_sym_enum] = ACTIONS(2877),
    [anon_sym_class] = ACTIONS(2877),
    [anon_sym_struct] = ACTIONS(2877),
    [anon_sym_union] = ACTIONS(2877),
    [anon_sym_if] = ACTIONS(2877),
    [anon_sym_switch] = ACTIONS(2877),
    [anon_sym_case] = ACTIONS(2877),
    [anon_sym_default] = ACTIONS(2877),
    [anon_sym_while] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_for] = ACTIONS(2877),
    [anon_sym_return] = ACTIONS(2877),
    [anon_sym_break] = ACTIONS(2877),
    [anon_sym_continue] = ACTIONS(2877),
    [anon_sym_goto] = ACTIONS(2877),
    [anon_sym___try] = ACTIONS(2877),
    [anon_sym___leave] = ACTIONS(2877),
    [anon_sym_not] = ACTIONS(2877),
    [anon_sym_compl] = ACTIONS(2877),
    [anon_sym_DASH_DASH] = ACTIONS(2879),
    [anon_sym_PLUS_PLUS] = ACTIONS(2879),
    [anon_sym_sizeof] = ACTIONS(2877),
    [anon_sym___alignof__] = ACTIONS(2877),
    [anon_sym___alignof] = ACTIONS(2877),
    [anon_sym__alignof] = ACTIONS(2877),
    [anon_sym_alignof] = ACTIONS(2877),
    [anon_sym__Alignof] = ACTIONS(2877),
    [anon_sym_offsetof] = ACTIONS(2877),
    [anon_sym__Generic] = ACTIONS(2877),
    [anon_sym_asm] = ACTIONS(2877),
    [anon_sym___asm__] = ACTIONS(2877),
    [aux_sym_number_literal_token1] = ACTIONS(2879),
    [aux_sym_number_literal_token2] = ACTIONS(2877),
    [anon_sym_L_SQUOTE] = ACTIONS(2879),
    [anon_sym_u_SQUOTE] = ACTIONS(2879),
    [anon_sym_U_SQUOTE] = ACTIONS(2879),
    [anon_sym_u8_SQUOTE] = ACTIONS(2879),
    [anon_sym_SQUOTE] = ACTIONS(2879),
    [anon_sym_L_DQUOTE] = ACTIONS(2879),
    [anon_sym_u_DQUOTE] = ACTIONS(2879),
    [anon_sym_U_DQUOTE] = ACTIONS(2879),
    [anon_sym_u8_DQUOTE] = ACTIONS(2879),
    [anon_sym_DQUOTE] = ACTIONS(2879),
    [sym_true] = ACTIONS(2877),
    [sym_false] = ACTIONS(2877),
    [anon_sym_NULL] = ACTIONS(2877),
    [anon_sym_nullptr] = ACTIONS(2877),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2877),
    [anon_sym_decltype] = ACTIONS(2877),
    [anon_sym_virtual] = ACTIONS(2877),
    [anon_sym_alignas] = ACTIONS(2877),
    [anon_sym_explicit] = ACTIONS(2877),
    [anon_sym_typename] = ACTIONS(2877),
    [anon_sym_template] = ACTIONS(2877),
    [anon_sym_operator] = ACTIONS(2877),
    [anon_sym_try] = ACTIONS(2877),
    [anon_sym_delete] = ACTIONS(2877),
    [anon_sym_throw] = ACTIONS(2877),
    [anon_sym_namespace] = ACTIONS(2877),
    [anon_sym_using] = ACTIONS(2877),
    [anon_sym_static_assert] = ACTIONS(2877),
    [anon_sym_concept] = ACTIONS(2877),
    [anon_sym_co_return] = ACTIONS(2877),
    [anon_sym_co_yield] = ACTIONS(2877),
    [anon_sym_R_DQUOTE] = ACTIONS(2879),
    [anon_sym_LR_DQUOTE] = ACTIONS(2879),
    [anon_sym_uR_DQUOTE] = ACTIONS(2879),
    [anon_sym_UR_DQUOTE] = ACTIONS(2879),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2879),
    [anon_sym_co_await] = ACTIONS(2877),
    [anon_sym_new] = ACTIONS(2877),
    [anon_sym_requires] = ACTIONS(2877),
    [sym_this] = ACTIONS(2877),
  },
  [691] = {
    [sym_identifier] = ACTIONS(3178),
    [aux_sym_preproc_include_token1] = ACTIONS(3178),
    [aux_sym_preproc_def_token1] = ACTIONS(3178),
    [aux_sym_preproc_if_token1] = ACTIONS(3178),
    [aux_sym_preproc_if_token2] = ACTIONS(3178),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3178),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3178),
    [sym_preproc_directive] = ACTIONS(3178),
    [anon_sym_LPAREN2] = ACTIONS(3180),
    [anon_sym_BANG] = ACTIONS(3180),
    [anon_sym_TILDE] = ACTIONS(3180),
    [anon_sym_DASH] = ACTIONS(3178),
    [anon_sym_PLUS] = ACTIONS(3178),
    [anon_sym_STAR] = ACTIONS(3180),
    [anon_sym_AMP_AMP] = ACTIONS(3180),
    [anon_sym_AMP] = ACTIONS(3178),
    [anon_sym_SEMI] = ACTIONS(3180),
    [anon_sym___extension__] = ACTIONS(3178),
    [anon_sym_typedef] = ACTIONS(3178),
    [anon_sym_extern] = ACTIONS(3178),
    [anon_sym___attribute__] = ACTIONS(3178),
    [anon_sym_COLON_COLON] = ACTIONS(3180),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3180),
    [anon_sym___declspec] = ACTIONS(3178),
    [anon_sym___based] = ACTIONS(3178),
    [anon_sym___cdecl] = ACTIONS(3178),
    [anon_sym___clrcall] = ACTIONS(3178),
    [anon_sym___stdcall] = ACTIONS(3178),
    [anon_sym___fastcall] = ACTIONS(3178),
    [anon_sym___thiscall] = ACTIONS(3178),
    [anon_sym___vectorcall] = ACTIONS(3178),
    [anon_sym_LBRACE] = ACTIONS(3180),
    [anon_sym_signed] = ACTIONS(3178),
    [anon_sym_unsigned] = ACTIONS(3178),
    [anon_sym_long] = ACTIONS(3178),
    [anon_sym_short] = ACTIONS(3178),
    [anon_sym_LBRACK] = ACTIONS(3178),
    [anon_sym_static] = ACTIONS(3178),
    [anon_sym_register] = ACTIONS(3178),
    [anon_sym_inline] = ACTIONS(3178),
    [anon_sym___inline] = ACTIONS(3178),
    [anon_sym___inline__] = ACTIONS(3178),
    [anon_sym___forceinline] = ACTIONS(3178),
    [anon_sym_thread_local] = ACTIONS(3178),
    [anon_sym___thread] = ACTIONS(3178),
    [anon_sym_const] = ACTIONS(3178),
    [anon_sym_constexpr] = ACTIONS(3178),
    [anon_sym_volatile] = ACTIONS(3178),
    [anon_sym_restrict] = ACTIONS(3178),
    [anon_sym___restrict__] = ACTIONS(3178),
    [anon_sym__Atomic] = ACTIONS(3178),
    [anon_sym__Noreturn] = ACTIONS(3178),
    [anon_sym_noreturn] = ACTIONS(3178),
    [anon_sym_mutable] = ACTIONS(3178),
    [anon_sym_constinit] = ACTIONS(3178),
    [anon_sym_consteval] = ACTIONS(3178),
    [anon_sym_PROGMEM] = ACTIONS(3178),
    [aux_sym_primitive_type_token1] = ACTIONS(3178),
    [anon_sym_byte] = ACTIONS(3178),
    [anon_sym_word] = ACTIONS(3178),
    [anon_sym_enum] = ACTIONS(3178),
    [anon_sym_class] = ACTIONS(3178),
    [anon_sym_struct] = ACTIONS(3178),
    [anon_sym_union] = ACTIONS(3178),
    [anon_sym_if] = ACTIONS(3178),
    [anon_sym_switch] = ACTIONS(3178),
    [anon_sym_case] = ACTIONS(3178),
    [anon_sym_default] = ACTIONS(3178),
    [anon_sym_while] = ACTIONS(3178),
    [anon_sym_do] = ACTIONS(3178),
    [anon_sym_for] = ACTIONS(3178),
    [anon_sym_return] = ACTIONS(3178),
    [anon_sym_break] = ACTIONS(3178),
    [anon_sym_continue] = ACTIONS(3178),
    [anon_sym_goto] = ACTIONS(3178),
    [anon_sym___try] = ACTIONS(3178),
    [anon_sym___leave] = ACTIONS(3178),
    [anon_sym_not] = ACTIONS(3178),
    [anon_sym_compl] = ACTIONS(3178),
    [anon_sym_DASH_DASH] = ACTIONS(3180),
    [anon_sym_PLUS_PLUS] = ACTIONS(3180),
    [anon_sym_sizeof] = ACTIONS(3178),
    [anon_sym___alignof__] = ACTIONS(3178),
    [anon_sym___alignof] = ACTIONS(3178),
    [anon_sym__alignof] = ACTIONS(3178),
    [anon_sym_alignof] = ACTIONS(3178),
    [anon_sym__Alignof] = ACTIONS(3178),
    [anon_sym_offsetof] = ACTIONS(3178),
    [anon_sym__Generic] = ACTIONS(3178),
    [anon_sym_asm] = ACTIONS(3178),
    [anon_sym___asm__] = ACTIONS(3178),
    [aux_sym_number_literal_token1] = ACTIONS(3180),
    [aux_sym_number_literal_token2] = ACTIONS(3178),
    [anon_sym_L_SQUOTE] = ACTIONS(3180),
    [anon_sym_u_SQUOTE] = ACTIONS(3180),
    [anon_sym_U_SQUOTE] = ACTIONS(3180),
    [anon_sym_u8_SQUOTE] = ACTIONS(3180),
    [anon_sym_SQUOTE] = ACTIONS(3180),
    [anon_sym_L_DQUOTE] = ACTIONS(3180),
    [anon_sym_u_DQUOTE] = ACTIONS(3180),
    [anon_sym_U_DQUOTE] = ACTIONS(3180),
    [anon_sym_u8_DQUOTE] = ACTIONS(3180),
    [anon_sym_DQUOTE] = ACTIONS(3180),
    [sym_true] = ACTIONS(3178),
    [sym_false] = ACTIONS(3178),
    [anon_sym_NULL] = ACTIONS(3178),
    [anon_sym_nullptr] = ACTIONS(3178),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3178),
    [anon_sym_decltype] = ACTIONS(3178),
    [anon_sym_virtual] = ACTIONS(3178),
    [anon_sym_alignas] = ACTIONS(3178),
    [anon_sym_explicit] = ACTIONS(3178),
    [anon_sym_typename] = ACTIONS(3178),
    [anon_sym_template] = ACTIONS(3178),
    [anon_sym_operator] = ACTIONS(3178),
    [anon_sym_try] = ACTIONS(3178),
    [anon_sym_delete] = ACTIONS(3178),
    [anon_sym_throw] = ACTIONS(3178),
    [anon_sym_namespace] = ACTIONS(3178),
    [anon_sym_using] = ACTIONS(3178),
    [anon_sym_static_assert] = ACTIONS(3178),
    [anon_sym_concept] = ACTIONS(3178),
    [anon_sym_co_return] = ACTIONS(3178),
    [anon_sym_co_yield] = ACTIONS(3178),
    [anon_sym_R_DQUOTE] = ACTIONS(3180),
    [anon_sym_LR_DQUOTE] = ACTIONS(3180),
    [anon_sym_uR_DQUOTE] = ACTIONS(3180),
    [anon_sym_UR_DQUOTE] = ACTIONS(3180),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3180),
    [anon_sym_co_await] = ACTIONS(3178),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3178),
    [sym_this] = ACTIONS(3178),
  },
  [692] = {
    [sym_identifier] = ACTIONS(3060),
    [aux_sym_preproc_include_token1] = ACTIONS(3060),
    [aux_sym_preproc_def_token1] = ACTIONS(3060),
    [aux_sym_preproc_if_token1] = ACTIONS(3060),
    [aux_sym_preproc_if_token2] = ACTIONS(3060),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3060),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3060),
    [sym_preproc_directive] = ACTIONS(3060),
    [anon_sym_LPAREN2] = ACTIONS(3062),
    [anon_sym_BANG] = ACTIONS(3062),
    [anon_sym_TILDE] = ACTIONS(3062),
    [anon_sym_DASH] = ACTIONS(3060),
    [anon_sym_PLUS] = ACTIONS(3060),
    [anon_sym_STAR] = ACTIONS(3062),
    [anon_sym_AMP_AMP] = ACTIONS(3062),
    [anon_sym_AMP] = ACTIONS(3060),
    [anon_sym_SEMI] = ACTIONS(3062),
    [anon_sym___extension__] = ACTIONS(3060),
    [anon_sym_typedef] = ACTIONS(3060),
    [anon_sym_extern] = ACTIONS(3060),
    [anon_sym___attribute__] = ACTIONS(3060),
    [anon_sym_COLON_COLON] = ACTIONS(3062),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3062),
    [anon_sym___declspec] = ACTIONS(3060),
    [anon_sym___based] = ACTIONS(3060),
    [anon_sym___cdecl] = ACTIONS(3060),
    [anon_sym___clrcall] = ACTIONS(3060),
    [anon_sym___stdcall] = ACTIONS(3060),
    [anon_sym___fastcall] = ACTIONS(3060),
    [anon_sym___thiscall] = ACTIONS(3060),
    [anon_sym___vectorcall] = ACTIONS(3060),
    [anon_sym_LBRACE] = ACTIONS(3062),
    [anon_sym_signed] = ACTIONS(3060),
    [anon_sym_unsigned] = ACTIONS(3060),
    [anon_sym_long] = ACTIONS(3060),
    [anon_sym_short] = ACTIONS(3060),
    [anon_sym_LBRACK] = ACTIONS(3060),
    [anon_sym_static] = ACTIONS(3060),
    [anon_sym_register] = ACTIONS(3060),
    [anon_sym_inline] = ACTIONS(3060),
    [anon_sym___inline] = ACTIONS(3060),
    [anon_sym___inline__] = ACTIONS(3060),
    [anon_sym___forceinline] = ACTIONS(3060),
    [anon_sym_thread_local] = ACTIONS(3060),
    [anon_sym___thread] = ACTIONS(3060),
    [anon_sym_const] = ACTIONS(3060),
    [anon_sym_constexpr] = ACTIONS(3060),
    [anon_sym_volatile] = ACTIONS(3060),
    [anon_sym_restrict] = ACTIONS(3060),
    [anon_sym___restrict__] = ACTIONS(3060),
    [anon_sym__Atomic] = ACTIONS(3060),
    [anon_sym__Noreturn] = ACTIONS(3060),
    [anon_sym_noreturn] = ACTIONS(3060),
    [anon_sym_mutable] = ACTIONS(3060),
    [anon_sym_constinit] = ACTIONS(3060),
    [anon_sym_consteval] = ACTIONS(3060),
    [anon_sym_PROGMEM] = ACTIONS(3060),
    [aux_sym_primitive_type_token1] = ACTIONS(3060),
    [anon_sym_byte] = ACTIONS(3060),
    [anon_sym_word] = ACTIONS(3060),
    [anon_sym_enum] = ACTIONS(3060),
    [anon_sym_class] = ACTIONS(3060),
    [anon_sym_struct] = ACTIONS(3060),
    [anon_sym_union] = ACTIONS(3060),
    [anon_sym_if] = ACTIONS(3060),
    [anon_sym_switch] = ACTIONS(3060),
    [anon_sym_case] = ACTIONS(3060),
    [anon_sym_default] = ACTIONS(3060),
    [anon_sym_while] = ACTIONS(3060),
    [anon_sym_do] = ACTIONS(3060),
    [anon_sym_for] = ACTIONS(3060),
    [anon_sym_return] = ACTIONS(3060),
    [anon_sym_break] = ACTIONS(3060),
    [anon_sym_continue] = ACTIONS(3060),
    [anon_sym_goto] = ACTIONS(3060),
    [anon_sym___try] = ACTIONS(3060),
    [anon_sym___leave] = ACTIONS(3060),
    [anon_sym_not] = ACTIONS(3060),
    [anon_sym_compl] = ACTIONS(3060),
    [anon_sym_DASH_DASH] = ACTIONS(3062),
    [anon_sym_PLUS_PLUS] = ACTIONS(3062),
    [anon_sym_sizeof] = ACTIONS(3060),
    [anon_sym___alignof__] = ACTIONS(3060),
    [anon_sym___alignof] = ACTIONS(3060),
    [anon_sym__alignof] = ACTIONS(3060),
    [anon_sym_alignof] = ACTIONS(3060),
    [anon_sym__Alignof] = ACTIONS(3060),
    [anon_sym_offsetof] = ACTIONS(3060),
    [anon_sym__Generic] = ACTIONS(3060),
    [anon_sym_asm] = ACTIONS(3060),
    [anon_sym___asm__] = ACTIONS(3060),
    [aux_sym_number_literal_token1] = ACTIONS(3062),
    [aux_sym_number_literal_token2] = ACTIONS(3060),
    [anon_sym_L_SQUOTE] = ACTIONS(3062),
    [anon_sym_u_SQUOTE] = ACTIONS(3062),
    [anon_sym_U_SQUOTE] = ACTIONS(3062),
    [anon_sym_u8_SQUOTE] = ACTIONS(3062),
    [anon_sym_SQUOTE] = ACTIONS(3062),
    [anon_sym_L_DQUOTE] = ACTIONS(3062),
    [anon_sym_u_DQUOTE] = ACTIONS(3062),
    [anon_sym_U_DQUOTE] = ACTIONS(3062),
    [anon_sym_u8_DQUOTE] = ACTIONS(3062),
    [anon_sym_DQUOTE] = ACTIONS(3062),
    [sym_true] = ACTIONS(3060),
    [sym_false] = ACTIONS(3060),
    [anon_sym_NULL] = ACTIONS(3060),
    [anon_sym_nullptr] = ACTIONS(3060),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3060),
    [anon_sym_decltype] = ACTIONS(3060),
    [anon_sym_virtual] = ACTIONS(3060),
    [anon_sym_alignas] = ACTIONS(3060),
    [anon_sym_explicit] = ACTIONS(3060),
    [anon_sym_typename] = ACTIONS(3060),
    [anon_sym_template] = ACTIONS(3060),
    [anon_sym_operator] = ACTIONS(3060),
    [anon_sym_try] = ACTIONS(3060),
    [anon_sym_delete] = ACTIONS(3060),
    [anon_sym_throw] = ACTIONS(3060),
    [anon_sym_namespace] = ACTIONS(3060),
    [anon_sym_using] = ACTIONS(3060),
    [anon_sym_static_assert] = ACTIONS(3060),
    [anon_sym_concept] = ACTIONS(3060),
    [anon_sym_co_return] = ACTIONS(3060),
    [anon_sym_co_yield] = ACTIONS(3060),
    [anon_sym_R_DQUOTE] = ACTIONS(3062),
    [anon_sym_LR_DQUOTE] = ACTIONS(3062),
    [anon_sym_uR_DQUOTE] = ACTIONS(3062),
    [anon_sym_UR_DQUOTE] = ACTIONS(3062),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3062),
    [anon_sym_co_await] = ACTIONS(3060),
    [anon_sym_new] = ACTIONS(3060),
    [anon_sym_requires] = ACTIONS(3060),
    [sym_this] = ACTIONS(3060),
  },
  [693] = {
    [sym_identifier] = ACTIONS(2929),
    [aux_sym_preproc_include_token1] = ACTIONS(2929),
    [aux_sym_preproc_def_token1] = ACTIONS(2929),
    [aux_sym_preproc_if_token1] = ACTIONS(2929),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2929),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2929),
    [sym_preproc_directive] = ACTIONS(2929),
    [anon_sym_LPAREN2] = ACTIONS(2931),
    [anon_sym_BANG] = ACTIONS(2931),
    [anon_sym_TILDE] = ACTIONS(2931),
    [anon_sym_DASH] = ACTIONS(2929),
    [anon_sym_PLUS] = ACTIONS(2929),
    [anon_sym_STAR] = ACTIONS(2931),
    [anon_sym_AMP_AMP] = ACTIONS(2931),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym_SEMI] = ACTIONS(2931),
    [anon_sym___extension__] = ACTIONS(2929),
    [anon_sym_typedef] = ACTIONS(2929),
    [anon_sym_extern] = ACTIONS(2929),
    [anon_sym___attribute__] = ACTIONS(2929),
    [anon_sym_COLON_COLON] = ACTIONS(2931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2931),
    [anon_sym___declspec] = ACTIONS(2929),
    [anon_sym___based] = ACTIONS(2929),
    [anon_sym___cdecl] = ACTIONS(2929),
    [anon_sym___clrcall] = ACTIONS(2929),
    [anon_sym___stdcall] = ACTIONS(2929),
    [anon_sym___fastcall] = ACTIONS(2929),
    [anon_sym___thiscall] = ACTIONS(2929),
    [anon_sym___vectorcall] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [anon_sym_RBRACE] = ACTIONS(2931),
    [anon_sym_signed] = ACTIONS(2929),
    [anon_sym_unsigned] = ACTIONS(2929),
    [anon_sym_long] = ACTIONS(2929),
    [anon_sym_short] = ACTIONS(2929),
    [anon_sym_LBRACK] = ACTIONS(2929),
    [anon_sym_static] = ACTIONS(2929),
    [anon_sym_register] = ACTIONS(2929),
    [anon_sym_inline] = ACTIONS(2929),
    [anon_sym___inline] = ACTIONS(2929),
    [anon_sym___inline__] = ACTIONS(2929),
    [anon_sym___forceinline] = ACTIONS(2929),
    [anon_sym_thread_local] = ACTIONS(2929),
    [anon_sym___thread] = ACTIONS(2929),
    [anon_sym_const] = ACTIONS(2929),
    [anon_sym_constexpr] = ACTIONS(2929),
    [anon_sym_volatile] = ACTIONS(2929),
    [anon_sym_restrict] = ACTIONS(2929),
    [anon_sym___restrict__] = ACTIONS(2929),
    [anon_sym__Atomic] = ACTIONS(2929),
    [anon_sym__Noreturn] = ACTIONS(2929),
    [anon_sym_noreturn] = ACTIONS(2929),
    [anon_sym_mutable] = ACTIONS(2929),
    [anon_sym_constinit] = ACTIONS(2929),
    [anon_sym_consteval] = ACTIONS(2929),
    [anon_sym_PROGMEM] = ACTIONS(2929),
    [aux_sym_primitive_type_token1] = ACTIONS(2929),
    [anon_sym_byte] = ACTIONS(2929),
    [anon_sym_word] = ACTIONS(2929),
    [anon_sym_enum] = ACTIONS(2929),
    [anon_sym_class] = ACTIONS(2929),
    [anon_sym_struct] = ACTIONS(2929),
    [anon_sym_union] = ACTIONS(2929),
    [anon_sym_if] = ACTIONS(2929),
    [anon_sym_switch] = ACTIONS(2929),
    [anon_sym_case] = ACTIONS(2929),
    [anon_sym_default] = ACTIONS(2929),
    [anon_sym_while] = ACTIONS(2929),
    [anon_sym_do] = ACTIONS(2929),
    [anon_sym_for] = ACTIONS(2929),
    [anon_sym_return] = ACTIONS(2929),
    [anon_sym_break] = ACTIONS(2929),
    [anon_sym_continue] = ACTIONS(2929),
    [anon_sym_goto] = ACTIONS(2929),
    [anon_sym___try] = ACTIONS(2929),
    [anon_sym___leave] = ACTIONS(2929),
    [anon_sym_not] = ACTIONS(2929),
    [anon_sym_compl] = ACTIONS(2929),
    [anon_sym_DASH_DASH] = ACTIONS(2931),
    [anon_sym_PLUS_PLUS] = ACTIONS(2931),
    [anon_sym_sizeof] = ACTIONS(2929),
    [anon_sym___alignof__] = ACTIONS(2929),
    [anon_sym___alignof] = ACTIONS(2929),
    [anon_sym__alignof] = ACTIONS(2929),
    [anon_sym_alignof] = ACTIONS(2929),
    [anon_sym__Alignof] = ACTIONS(2929),
    [anon_sym_offsetof] = ACTIONS(2929),
    [anon_sym__Generic] = ACTIONS(2929),
    [anon_sym_asm] = ACTIONS(2929),
    [anon_sym___asm__] = ACTIONS(2929),
    [aux_sym_number_literal_token1] = ACTIONS(2931),
    [aux_sym_number_literal_token2] = ACTIONS(2929),
    [anon_sym_L_SQUOTE] = ACTIONS(2931),
    [anon_sym_u_SQUOTE] = ACTIONS(2931),
    [anon_sym_U_SQUOTE] = ACTIONS(2931),
    [anon_sym_u8_SQUOTE] = ACTIONS(2931),
    [anon_sym_SQUOTE] = ACTIONS(2931),
    [anon_sym_L_DQUOTE] = ACTIONS(2931),
    [anon_sym_u_DQUOTE] = ACTIONS(2931),
    [anon_sym_U_DQUOTE] = ACTIONS(2931),
    [anon_sym_u8_DQUOTE] = ACTIONS(2931),
    [anon_sym_DQUOTE] = ACTIONS(2931),
    [sym_true] = ACTIONS(2929),
    [sym_false] = ACTIONS(2929),
    [anon_sym_NULL] = ACTIONS(2929),
    [anon_sym_nullptr] = ACTIONS(2929),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2929),
    [anon_sym_decltype] = ACTIONS(2929),
    [anon_sym_virtual] = ACTIONS(2929),
    [anon_sym_alignas] = ACTIONS(2929),
    [anon_sym_explicit] = ACTIONS(2929),
    [anon_sym_typename] = ACTIONS(2929),
    [anon_sym_template] = ACTIONS(2929),
    [anon_sym_operator] = ACTIONS(2929),
    [anon_sym_try] = ACTIONS(2929),
    [anon_sym_delete] = ACTIONS(2929),
    [anon_sym_throw] = ACTIONS(2929),
    [anon_sym_namespace] = ACTIONS(2929),
    [anon_sym_using] = ACTIONS(2929),
    [anon_sym_static_assert] = ACTIONS(2929),
    [anon_sym_concept] = ACTIONS(2929),
    [anon_sym_co_return] = ACTIONS(2929),
    [anon_sym_co_yield] = ACTIONS(2929),
    [anon_sym_R_DQUOTE] = ACTIONS(2931),
    [anon_sym_LR_DQUOTE] = ACTIONS(2931),
    [anon_sym_uR_DQUOTE] = ACTIONS(2931),
    [anon_sym_UR_DQUOTE] = ACTIONS(2931),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2931),
    [anon_sym_co_await] = ACTIONS(2929),
    [anon_sym_new] = ACTIONS(2929),
    [anon_sym_requires] = ACTIONS(2929),
    [sym_this] = ACTIONS(2929),
  },
  [694] = {
    [sym_identifier] = ACTIONS(3020),
    [aux_sym_preproc_include_token1] = ACTIONS(3020),
    [aux_sym_preproc_def_token1] = ACTIONS(3020),
    [aux_sym_preproc_if_token1] = ACTIONS(3020),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3020),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3020),
    [sym_preproc_directive] = ACTIONS(3020),
    [anon_sym_LPAREN2] = ACTIONS(3022),
    [anon_sym_BANG] = ACTIONS(3022),
    [anon_sym_TILDE] = ACTIONS(3022),
    [anon_sym_DASH] = ACTIONS(3020),
    [anon_sym_PLUS] = ACTIONS(3020),
    [anon_sym_STAR] = ACTIONS(3022),
    [anon_sym_AMP_AMP] = ACTIONS(3022),
    [anon_sym_AMP] = ACTIONS(3020),
    [anon_sym_SEMI] = ACTIONS(3022),
    [anon_sym___extension__] = ACTIONS(3020),
    [anon_sym_typedef] = ACTIONS(3020),
    [anon_sym_extern] = ACTIONS(3020),
    [anon_sym___attribute__] = ACTIONS(3020),
    [anon_sym_COLON_COLON] = ACTIONS(3022),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3022),
    [anon_sym___declspec] = ACTIONS(3020),
    [anon_sym___based] = ACTIONS(3020),
    [anon_sym___cdecl] = ACTIONS(3020),
    [anon_sym___clrcall] = ACTIONS(3020),
    [anon_sym___stdcall] = ACTIONS(3020),
    [anon_sym___fastcall] = ACTIONS(3020),
    [anon_sym___thiscall] = ACTIONS(3020),
    [anon_sym___vectorcall] = ACTIONS(3020),
    [anon_sym_LBRACE] = ACTIONS(3022),
    [anon_sym_RBRACE] = ACTIONS(3022),
    [anon_sym_signed] = ACTIONS(3020),
    [anon_sym_unsigned] = ACTIONS(3020),
    [anon_sym_long] = ACTIONS(3020),
    [anon_sym_short] = ACTIONS(3020),
    [anon_sym_LBRACK] = ACTIONS(3020),
    [anon_sym_static] = ACTIONS(3020),
    [anon_sym_register] = ACTIONS(3020),
    [anon_sym_inline] = ACTIONS(3020),
    [anon_sym___inline] = ACTIONS(3020),
    [anon_sym___inline__] = ACTIONS(3020),
    [anon_sym___forceinline] = ACTIONS(3020),
    [anon_sym_thread_local] = ACTIONS(3020),
    [anon_sym___thread] = ACTIONS(3020),
    [anon_sym_const] = ACTIONS(3020),
    [anon_sym_constexpr] = ACTIONS(3020),
    [anon_sym_volatile] = ACTIONS(3020),
    [anon_sym_restrict] = ACTIONS(3020),
    [anon_sym___restrict__] = ACTIONS(3020),
    [anon_sym__Atomic] = ACTIONS(3020),
    [anon_sym__Noreturn] = ACTIONS(3020),
    [anon_sym_noreturn] = ACTIONS(3020),
    [anon_sym_mutable] = ACTIONS(3020),
    [anon_sym_constinit] = ACTIONS(3020),
    [anon_sym_consteval] = ACTIONS(3020),
    [anon_sym_PROGMEM] = ACTIONS(3020),
    [aux_sym_primitive_type_token1] = ACTIONS(3020),
    [anon_sym_byte] = ACTIONS(3020),
    [anon_sym_word] = ACTIONS(3020),
    [anon_sym_enum] = ACTIONS(3020),
    [anon_sym_class] = ACTIONS(3020),
    [anon_sym_struct] = ACTIONS(3020),
    [anon_sym_union] = ACTIONS(3020),
    [anon_sym_if] = ACTIONS(3020),
    [anon_sym_switch] = ACTIONS(3020),
    [anon_sym_case] = ACTIONS(3020),
    [anon_sym_default] = ACTIONS(3020),
    [anon_sym_while] = ACTIONS(3020),
    [anon_sym_do] = ACTIONS(3020),
    [anon_sym_for] = ACTIONS(3020),
    [anon_sym_return] = ACTIONS(3020),
    [anon_sym_break] = ACTIONS(3020),
    [anon_sym_continue] = ACTIONS(3020),
    [anon_sym_goto] = ACTIONS(3020),
    [anon_sym___try] = ACTIONS(3020),
    [anon_sym___leave] = ACTIONS(3020),
    [anon_sym_not] = ACTIONS(3020),
    [anon_sym_compl] = ACTIONS(3020),
    [anon_sym_DASH_DASH] = ACTIONS(3022),
    [anon_sym_PLUS_PLUS] = ACTIONS(3022),
    [anon_sym_sizeof] = ACTIONS(3020),
    [anon_sym___alignof__] = ACTIONS(3020),
    [anon_sym___alignof] = ACTIONS(3020),
    [anon_sym__alignof] = ACTIONS(3020),
    [anon_sym_alignof] = ACTIONS(3020),
    [anon_sym__Alignof] = ACTIONS(3020),
    [anon_sym_offsetof] = ACTIONS(3020),
    [anon_sym__Generic] = ACTIONS(3020),
    [anon_sym_asm] = ACTIONS(3020),
    [anon_sym___asm__] = ACTIONS(3020),
    [aux_sym_number_literal_token1] = ACTIONS(3022),
    [aux_sym_number_literal_token2] = ACTIONS(3020),
    [anon_sym_L_SQUOTE] = ACTIONS(3022),
    [anon_sym_u_SQUOTE] = ACTIONS(3022),
    [anon_sym_U_SQUOTE] = ACTIONS(3022),
    [anon_sym_u8_SQUOTE] = ACTIONS(3022),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [anon_sym_L_DQUOTE] = ACTIONS(3022),
    [anon_sym_u_DQUOTE] = ACTIONS(3022),
    [anon_sym_U_DQUOTE] = ACTIONS(3022),
    [anon_sym_u8_DQUOTE] = ACTIONS(3022),
    [anon_sym_DQUOTE] = ACTIONS(3022),
    [sym_true] = ACTIONS(3020),
    [sym_false] = ACTIONS(3020),
    [anon_sym_NULL] = ACTIONS(3020),
    [anon_sym_nullptr] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3020),
    [anon_sym_decltype] = ACTIONS(3020),
    [anon_sym_virtual] = ACTIONS(3020),
    [anon_sym_alignas] = ACTIONS(3020),
    [anon_sym_explicit] = ACTIONS(3020),
    [anon_sym_typename] = ACTIONS(3020),
    [anon_sym_template] = ACTIONS(3020),
    [anon_sym_operator] = ACTIONS(3020),
    [anon_sym_try] = ACTIONS(3020),
    [anon_sym_delete] = ACTIONS(3020),
    [anon_sym_throw] = ACTIONS(3020),
    [anon_sym_namespace] = ACTIONS(3020),
    [anon_sym_using] = ACTIONS(3020),
    [anon_sym_static_assert] = ACTIONS(3020),
    [anon_sym_concept] = ACTIONS(3020),
    [anon_sym_co_return] = ACTIONS(3020),
    [anon_sym_co_yield] = ACTIONS(3020),
    [anon_sym_R_DQUOTE] = ACTIONS(3022),
    [anon_sym_LR_DQUOTE] = ACTIONS(3022),
    [anon_sym_uR_DQUOTE] = ACTIONS(3022),
    [anon_sym_UR_DQUOTE] = ACTIONS(3022),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3022),
    [anon_sym_co_await] = ACTIONS(3020),
    [anon_sym_new] = ACTIONS(3020),
    [anon_sym_requires] = ACTIONS(3020),
    [sym_this] = ACTIONS(3020),
  },
  [695] = {
    [sym_identifier] = ACTIONS(3032),
    [aux_sym_preproc_include_token1] = ACTIONS(3032),
    [aux_sym_preproc_def_token1] = ACTIONS(3032),
    [aux_sym_preproc_if_token1] = ACTIONS(3032),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3032),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3032),
    [sym_preproc_directive] = ACTIONS(3032),
    [anon_sym_LPAREN2] = ACTIONS(3034),
    [anon_sym_BANG] = ACTIONS(3034),
    [anon_sym_TILDE] = ACTIONS(3034),
    [anon_sym_DASH] = ACTIONS(3032),
    [anon_sym_PLUS] = ACTIONS(3032),
    [anon_sym_STAR] = ACTIONS(3034),
    [anon_sym_AMP_AMP] = ACTIONS(3034),
    [anon_sym_AMP] = ACTIONS(3032),
    [anon_sym_SEMI] = ACTIONS(3034),
    [anon_sym___extension__] = ACTIONS(3032),
    [anon_sym_typedef] = ACTIONS(3032),
    [anon_sym_extern] = ACTIONS(3032),
    [anon_sym___attribute__] = ACTIONS(3032),
    [anon_sym_COLON_COLON] = ACTIONS(3034),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3034),
    [anon_sym___declspec] = ACTIONS(3032),
    [anon_sym___based] = ACTIONS(3032),
    [anon_sym___cdecl] = ACTIONS(3032),
    [anon_sym___clrcall] = ACTIONS(3032),
    [anon_sym___stdcall] = ACTIONS(3032),
    [anon_sym___fastcall] = ACTIONS(3032),
    [anon_sym___thiscall] = ACTIONS(3032),
    [anon_sym___vectorcall] = ACTIONS(3032),
    [anon_sym_LBRACE] = ACTIONS(3034),
    [anon_sym_RBRACE] = ACTIONS(3034),
    [anon_sym_signed] = ACTIONS(3032),
    [anon_sym_unsigned] = ACTIONS(3032),
    [anon_sym_long] = ACTIONS(3032),
    [anon_sym_short] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(3032),
    [anon_sym_static] = ACTIONS(3032),
    [anon_sym_register] = ACTIONS(3032),
    [anon_sym_inline] = ACTIONS(3032),
    [anon_sym___inline] = ACTIONS(3032),
    [anon_sym___inline__] = ACTIONS(3032),
    [anon_sym___forceinline] = ACTIONS(3032),
    [anon_sym_thread_local] = ACTIONS(3032),
    [anon_sym___thread] = ACTIONS(3032),
    [anon_sym_const] = ACTIONS(3032),
    [anon_sym_constexpr] = ACTIONS(3032),
    [anon_sym_volatile] = ACTIONS(3032),
    [anon_sym_restrict] = ACTIONS(3032),
    [anon_sym___restrict__] = ACTIONS(3032),
    [anon_sym__Atomic] = ACTIONS(3032),
    [anon_sym__Noreturn] = ACTIONS(3032),
    [anon_sym_noreturn] = ACTIONS(3032),
    [anon_sym_mutable] = ACTIONS(3032),
    [anon_sym_constinit] = ACTIONS(3032),
    [anon_sym_consteval] = ACTIONS(3032),
    [anon_sym_PROGMEM] = ACTIONS(3032),
    [aux_sym_primitive_type_token1] = ACTIONS(3032),
    [anon_sym_byte] = ACTIONS(3032),
    [anon_sym_word] = ACTIONS(3032),
    [anon_sym_enum] = ACTIONS(3032),
    [anon_sym_class] = ACTIONS(3032),
    [anon_sym_struct] = ACTIONS(3032),
    [anon_sym_union] = ACTIONS(3032),
    [anon_sym_if] = ACTIONS(3032),
    [anon_sym_switch] = ACTIONS(3032),
    [anon_sym_case] = ACTIONS(3032),
    [anon_sym_default] = ACTIONS(3032),
    [anon_sym_while] = ACTIONS(3032),
    [anon_sym_do] = ACTIONS(3032),
    [anon_sym_for] = ACTIONS(3032),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_break] = ACTIONS(3032),
    [anon_sym_continue] = ACTIONS(3032),
    [anon_sym_goto] = ACTIONS(3032),
    [anon_sym___try] = ACTIONS(3032),
    [anon_sym___leave] = ACTIONS(3032),
    [anon_sym_not] = ACTIONS(3032),
    [anon_sym_compl] = ACTIONS(3032),
    [anon_sym_DASH_DASH] = ACTIONS(3034),
    [anon_sym_PLUS_PLUS] = ACTIONS(3034),
    [anon_sym_sizeof] = ACTIONS(3032),
    [anon_sym___alignof__] = ACTIONS(3032),
    [anon_sym___alignof] = ACTIONS(3032),
    [anon_sym__alignof] = ACTIONS(3032),
    [anon_sym_alignof] = ACTIONS(3032),
    [anon_sym__Alignof] = ACTIONS(3032),
    [anon_sym_offsetof] = ACTIONS(3032),
    [anon_sym__Generic] = ACTIONS(3032),
    [anon_sym_asm] = ACTIONS(3032),
    [anon_sym___asm__] = ACTIONS(3032),
    [aux_sym_number_literal_token1] = ACTIONS(3034),
    [aux_sym_number_literal_token2] = ACTIONS(3032),
    [anon_sym_L_SQUOTE] = ACTIONS(3034),
    [anon_sym_u_SQUOTE] = ACTIONS(3034),
    [anon_sym_U_SQUOTE] = ACTIONS(3034),
    [anon_sym_u8_SQUOTE] = ACTIONS(3034),
    [anon_sym_SQUOTE] = ACTIONS(3034),
    [anon_sym_L_DQUOTE] = ACTIONS(3034),
    [anon_sym_u_DQUOTE] = ACTIONS(3034),
    [anon_sym_U_DQUOTE] = ACTIONS(3034),
    [anon_sym_u8_DQUOTE] = ACTIONS(3034),
    [anon_sym_DQUOTE] = ACTIONS(3034),
    [sym_true] = ACTIONS(3032),
    [sym_false] = ACTIONS(3032),
    [anon_sym_NULL] = ACTIONS(3032),
    [anon_sym_nullptr] = ACTIONS(3032),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3032),
    [anon_sym_decltype] = ACTIONS(3032),
    [anon_sym_virtual] = ACTIONS(3032),
    [anon_sym_alignas] = ACTIONS(3032),
    [anon_sym_explicit] = ACTIONS(3032),
    [anon_sym_typename] = ACTIONS(3032),
    [anon_sym_template] = ACTIONS(3032),
    [anon_sym_operator] = ACTIONS(3032),
    [anon_sym_try] = ACTIONS(3032),
    [anon_sym_delete] = ACTIONS(3032),
    [anon_sym_throw] = ACTIONS(3032),
    [anon_sym_namespace] = ACTIONS(3032),
    [anon_sym_using] = ACTIONS(3032),
    [anon_sym_static_assert] = ACTIONS(3032),
    [anon_sym_concept] = ACTIONS(3032),
    [anon_sym_co_return] = ACTIONS(3032),
    [anon_sym_co_yield] = ACTIONS(3032),
    [anon_sym_R_DQUOTE] = ACTIONS(3034),
    [anon_sym_LR_DQUOTE] = ACTIONS(3034),
    [anon_sym_uR_DQUOTE] = ACTIONS(3034),
    [anon_sym_UR_DQUOTE] = ACTIONS(3034),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3034),
    [anon_sym_co_await] = ACTIONS(3032),
    [anon_sym_new] = ACTIONS(3032),
    [anon_sym_requires] = ACTIONS(3032),
    [sym_this] = ACTIONS(3032),
  },
  [696] = {
    [sym_identifier] = ACTIONS(2985),
    [aux_sym_preproc_include_token1] = ACTIONS(2985),
    [aux_sym_preproc_def_token1] = ACTIONS(2985),
    [aux_sym_preproc_if_token1] = ACTIONS(2985),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2985),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2985),
    [sym_preproc_directive] = ACTIONS(2985),
    [anon_sym_LPAREN2] = ACTIONS(2987),
    [anon_sym_BANG] = ACTIONS(2987),
    [anon_sym_TILDE] = ACTIONS(2987),
    [anon_sym_DASH] = ACTIONS(2985),
    [anon_sym_PLUS] = ACTIONS(2985),
    [anon_sym_STAR] = ACTIONS(2987),
    [anon_sym_AMP_AMP] = ACTIONS(2987),
    [anon_sym_AMP] = ACTIONS(2985),
    [anon_sym_SEMI] = ACTIONS(2987),
    [anon_sym___extension__] = ACTIONS(2985),
    [anon_sym_typedef] = ACTIONS(2985),
    [anon_sym_extern] = ACTIONS(2985),
    [anon_sym___attribute__] = ACTIONS(2985),
    [anon_sym_COLON_COLON] = ACTIONS(2987),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2987),
    [anon_sym___declspec] = ACTIONS(2985),
    [anon_sym___based] = ACTIONS(2985),
    [anon_sym___cdecl] = ACTIONS(2985),
    [anon_sym___clrcall] = ACTIONS(2985),
    [anon_sym___stdcall] = ACTIONS(2985),
    [anon_sym___fastcall] = ACTIONS(2985),
    [anon_sym___thiscall] = ACTIONS(2985),
    [anon_sym___vectorcall] = ACTIONS(2985),
    [anon_sym_LBRACE] = ACTIONS(2987),
    [anon_sym_RBRACE] = ACTIONS(2987),
    [anon_sym_signed] = ACTIONS(2985),
    [anon_sym_unsigned] = ACTIONS(2985),
    [anon_sym_long] = ACTIONS(2985),
    [anon_sym_short] = ACTIONS(2985),
    [anon_sym_LBRACK] = ACTIONS(2985),
    [anon_sym_static] = ACTIONS(2985),
    [anon_sym_register] = ACTIONS(2985),
    [anon_sym_inline] = ACTIONS(2985),
    [anon_sym___inline] = ACTIONS(2985),
    [anon_sym___inline__] = ACTIONS(2985),
    [anon_sym___forceinline] = ACTIONS(2985),
    [anon_sym_thread_local] = ACTIONS(2985),
    [anon_sym___thread] = ACTIONS(2985),
    [anon_sym_const] = ACTIONS(2985),
    [anon_sym_constexpr] = ACTIONS(2985),
    [anon_sym_volatile] = ACTIONS(2985),
    [anon_sym_restrict] = ACTIONS(2985),
    [anon_sym___restrict__] = ACTIONS(2985),
    [anon_sym__Atomic] = ACTIONS(2985),
    [anon_sym__Noreturn] = ACTIONS(2985),
    [anon_sym_noreturn] = ACTIONS(2985),
    [anon_sym_mutable] = ACTIONS(2985),
    [anon_sym_constinit] = ACTIONS(2985),
    [anon_sym_consteval] = ACTIONS(2985),
    [anon_sym_PROGMEM] = ACTIONS(2985),
    [aux_sym_primitive_type_token1] = ACTIONS(2985),
    [anon_sym_byte] = ACTIONS(2985),
    [anon_sym_word] = ACTIONS(2985),
    [anon_sym_enum] = ACTIONS(2985),
    [anon_sym_class] = ACTIONS(2985),
    [anon_sym_struct] = ACTIONS(2985),
    [anon_sym_union] = ACTIONS(2985),
    [anon_sym_if] = ACTIONS(2985),
    [anon_sym_switch] = ACTIONS(2985),
    [anon_sym_case] = ACTIONS(2985),
    [anon_sym_default] = ACTIONS(2985),
    [anon_sym_while] = ACTIONS(2985),
    [anon_sym_do] = ACTIONS(2985),
    [anon_sym_for] = ACTIONS(2985),
    [anon_sym_return] = ACTIONS(2985),
    [anon_sym_break] = ACTIONS(2985),
    [anon_sym_continue] = ACTIONS(2985),
    [anon_sym_goto] = ACTIONS(2985),
    [anon_sym___try] = ACTIONS(2985),
    [anon_sym___leave] = ACTIONS(2985),
    [anon_sym_not] = ACTIONS(2985),
    [anon_sym_compl] = ACTIONS(2985),
    [anon_sym_DASH_DASH] = ACTIONS(2987),
    [anon_sym_PLUS_PLUS] = ACTIONS(2987),
    [anon_sym_sizeof] = ACTIONS(2985),
    [anon_sym___alignof__] = ACTIONS(2985),
    [anon_sym___alignof] = ACTIONS(2985),
    [anon_sym__alignof] = ACTIONS(2985),
    [anon_sym_alignof] = ACTIONS(2985),
    [anon_sym__Alignof] = ACTIONS(2985),
    [anon_sym_offsetof] = ACTIONS(2985),
    [anon_sym__Generic] = ACTIONS(2985),
    [anon_sym_asm] = ACTIONS(2985),
    [anon_sym___asm__] = ACTIONS(2985),
    [aux_sym_number_literal_token1] = ACTIONS(2987),
    [aux_sym_number_literal_token2] = ACTIONS(2985),
    [anon_sym_L_SQUOTE] = ACTIONS(2987),
    [anon_sym_u_SQUOTE] = ACTIONS(2987),
    [anon_sym_U_SQUOTE] = ACTIONS(2987),
    [anon_sym_u8_SQUOTE] = ACTIONS(2987),
    [anon_sym_SQUOTE] = ACTIONS(2987),
    [anon_sym_L_DQUOTE] = ACTIONS(2987),
    [anon_sym_u_DQUOTE] = ACTIONS(2987),
    [anon_sym_U_DQUOTE] = ACTIONS(2987),
    [anon_sym_u8_DQUOTE] = ACTIONS(2987),
    [anon_sym_DQUOTE] = ACTIONS(2987),
    [sym_true] = ACTIONS(2985),
    [sym_false] = ACTIONS(2985),
    [anon_sym_NULL] = ACTIONS(2985),
    [anon_sym_nullptr] = ACTIONS(2985),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2985),
    [anon_sym_decltype] = ACTIONS(2985),
    [anon_sym_virtual] = ACTIONS(2985),
    [anon_sym_alignas] = ACTIONS(2985),
    [anon_sym_explicit] = ACTIONS(2985),
    [anon_sym_typename] = ACTIONS(2985),
    [anon_sym_template] = ACTIONS(2985),
    [anon_sym_operator] = ACTIONS(2985),
    [anon_sym_try] = ACTIONS(2985),
    [anon_sym_delete] = ACTIONS(2985),
    [anon_sym_throw] = ACTIONS(2985),
    [anon_sym_namespace] = ACTIONS(2985),
    [anon_sym_using] = ACTIONS(2985),
    [anon_sym_static_assert] = ACTIONS(2985),
    [anon_sym_concept] = ACTIONS(2985),
    [anon_sym_co_return] = ACTIONS(2985),
    [anon_sym_co_yield] = ACTIONS(2985),
    [anon_sym_R_DQUOTE] = ACTIONS(2987),
    [anon_sym_LR_DQUOTE] = ACTIONS(2987),
    [anon_sym_uR_DQUOTE] = ACTIONS(2987),
    [anon_sym_UR_DQUOTE] = ACTIONS(2987),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2987),
    [anon_sym_co_await] = ACTIONS(2985),
    [anon_sym_new] = ACTIONS(2985),
    [anon_sym_requires] = ACTIONS(2985),
    [sym_this] = ACTIONS(2985),
  },
  [697] = {
    [sym_identifier] = ACTIONS(3048),
    [aux_sym_preproc_include_token1] = ACTIONS(3048),
    [aux_sym_preproc_def_token1] = ACTIONS(3048),
    [aux_sym_preproc_if_token1] = ACTIONS(3048),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3048),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3048),
    [sym_preproc_directive] = ACTIONS(3048),
    [anon_sym_LPAREN2] = ACTIONS(3050),
    [anon_sym_BANG] = ACTIONS(3050),
    [anon_sym_TILDE] = ACTIONS(3050),
    [anon_sym_DASH] = ACTIONS(3048),
    [anon_sym_PLUS] = ACTIONS(3048),
    [anon_sym_STAR] = ACTIONS(3050),
    [anon_sym_AMP_AMP] = ACTIONS(3050),
    [anon_sym_AMP] = ACTIONS(3048),
    [anon_sym_SEMI] = ACTIONS(3050),
    [anon_sym___extension__] = ACTIONS(3048),
    [anon_sym_typedef] = ACTIONS(3048),
    [anon_sym_extern] = ACTIONS(3048),
    [anon_sym___attribute__] = ACTIONS(3048),
    [anon_sym_COLON_COLON] = ACTIONS(3050),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3050),
    [anon_sym___declspec] = ACTIONS(3048),
    [anon_sym___based] = ACTIONS(3048),
    [anon_sym___cdecl] = ACTIONS(3048),
    [anon_sym___clrcall] = ACTIONS(3048),
    [anon_sym___stdcall] = ACTIONS(3048),
    [anon_sym___fastcall] = ACTIONS(3048),
    [anon_sym___thiscall] = ACTIONS(3048),
    [anon_sym___vectorcall] = ACTIONS(3048),
    [anon_sym_LBRACE] = ACTIONS(3050),
    [anon_sym_RBRACE] = ACTIONS(3050),
    [anon_sym_signed] = ACTIONS(3048),
    [anon_sym_unsigned] = ACTIONS(3048),
    [anon_sym_long] = ACTIONS(3048),
    [anon_sym_short] = ACTIONS(3048),
    [anon_sym_LBRACK] = ACTIONS(3048),
    [anon_sym_static] = ACTIONS(3048),
    [anon_sym_register] = ACTIONS(3048),
    [anon_sym_inline] = ACTIONS(3048),
    [anon_sym___inline] = ACTIONS(3048),
    [anon_sym___inline__] = ACTIONS(3048),
    [anon_sym___forceinline] = ACTIONS(3048),
    [anon_sym_thread_local] = ACTIONS(3048),
    [anon_sym___thread] = ACTIONS(3048),
    [anon_sym_const] = ACTIONS(3048),
    [anon_sym_constexpr] = ACTIONS(3048),
    [anon_sym_volatile] = ACTIONS(3048),
    [anon_sym_restrict] = ACTIONS(3048),
    [anon_sym___restrict__] = ACTIONS(3048),
    [anon_sym__Atomic] = ACTIONS(3048),
    [anon_sym__Noreturn] = ACTIONS(3048),
    [anon_sym_noreturn] = ACTIONS(3048),
    [anon_sym_mutable] = ACTIONS(3048),
    [anon_sym_constinit] = ACTIONS(3048),
    [anon_sym_consteval] = ACTIONS(3048),
    [anon_sym_PROGMEM] = ACTIONS(3048),
    [aux_sym_primitive_type_token1] = ACTIONS(3048),
    [anon_sym_byte] = ACTIONS(3048),
    [anon_sym_word] = ACTIONS(3048),
    [anon_sym_enum] = ACTIONS(3048),
    [anon_sym_class] = ACTIONS(3048),
    [anon_sym_struct] = ACTIONS(3048),
    [anon_sym_union] = ACTIONS(3048),
    [anon_sym_if] = ACTIONS(3048),
    [anon_sym_switch] = ACTIONS(3048),
    [anon_sym_case] = ACTIONS(3048),
    [anon_sym_default] = ACTIONS(3048),
    [anon_sym_while] = ACTIONS(3048),
    [anon_sym_do] = ACTIONS(3048),
    [anon_sym_for] = ACTIONS(3048),
    [anon_sym_return] = ACTIONS(3048),
    [anon_sym_break] = ACTIONS(3048),
    [anon_sym_continue] = ACTIONS(3048),
    [anon_sym_goto] = ACTIONS(3048),
    [anon_sym___try] = ACTIONS(3048),
    [anon_sym___leave] = ACTIONS(3048),
    [anon_sym_not] = ACTIONS(3048),
    [anon_sym_compl] = ACTIONS(3048),
    [anon_sym_DASH_DASH] = ACTIONS(3050),
    [anon_sym_PLUS_PLUS] = ACTIONS(3050),
    [anon_sym_sizeof] = ACTIONS(3048),
    [anon_sym___alignof__] = ACTIONS(3048),
    [anon_sym___alignof] = ACTIONS(3048),
    [anon_sym__alignof] = ACTIONS(3048),
    [anon_sym_alignof] = ACTIONS(3048),
    [anon_sym__Alignof] = ACTIONS(3048),
    [anon_sym_offsetof] = ACTIONS(3048),
    [anon_sym__Generic] = ACTIONS(3048),
    [anon_sym_asm] = ACTIONS(3048),
    [anon_sym___asm__] = ACTIONS(3048),
    [aux_sym_number_literal_token1] = ACTIONS(3050),
    [aux_sym_number_literal_token2] = ACTIONS(3048),
    [anon_sym_L_SQUOTE] = ACTIONS(3050),
    [anon_sym_u_SQUOTE] = ACTIONS(3050),
    [anon_sym_U_SQUOTE] = ACTIONS(3050),
    [anon_sym_u8_SQUOTE] = ACTIONS(3050),
    [anon_sym_SQUOTE] = ACTIONS(3050),
    [anon_sym_L_DQUOTE] = ACTIONS(3050),
    [anon_sym_u_DQUOTE] = ACTIONS(3050),
    [anon_sym_U_DQUOTE] = ACTIONS(3050),
    [anon_sym_u8_DQUOTE] = ACTIONS(3050),
    [anon_sym_DQUOTE] = ACTIONS(3050),
    [sym_true] = ACTIONS(3048),
    [sym_false] = ACTIONS(3048),
    [anon_sym_NULL] = ACTIONS(3048),
    [anon_sym_nullptr] = ACTIONS(3048),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3048),
    [anon_sym_decltype] = ACTIONS(3048),
    [anon_sym_virtual] = ACTIONS(3048),
    [anon_sym_alignas] = ACTIONS(3048),
    [anon_sym_explicit] = ACTIONS(3048),
    [anon_sym_typename] = ACTIONS(3048),
    [anon_sym_template] = ACTIONS(3048),
    [anon_sym_operator] = ACTIONS(3048),
    [anon_sym_try] = ACTIONS(3048),
    [anon_sym_delete] = ACTIONS(3048),
    [anon_sym_throw] = ACTIONS(3048),
    [anon_sym_namespace] = ACTIONS(3048),
    [anon_sym_using] = ACTIONS(3048),
    [anon_sym_static_assert] = ACTIONS(3048),
    [anon_sym_concept] = ACTIONS(3048),
    [anon_sym_co_return] = ACTIONS(3048),
    [anon_sym_co_yield] = ACTIONS(3048),
    [anon_sym_R_DQUOTE] = ACTIONS(3050),
    [anon_sym_LR_DQUOTE] = ACTIONS(3050),
    [anon_sym_uR_DQUOTE] = ACTIONS(3050),
    [anon_sym_UR_DQUOTE] = ACTIONS(3050),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3050),
    [anon_sym_co_await] = ACTIONS(3048),
    [anon_sym_new] = ACTIONS(3048),
    [anon_sym_requires] = ACTIONS(3048),
    [sym_this] = ACTIONS(3048),
  },
  [698] = {
    [sym_identifier] = ACTIONS(3016),
    [aux_sym_preproc_include_token1] = ACTIONS(3016),
    [aux_sym_preproc_def_token1] = ACTIONS(3016),
    [aux_sym_preproc_if_token1] = ACTIONS(3016),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3016),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3016),
    [sym_preproc_directive] = ACTIONS(3016),
    [anon_sym_LPAREN2] = ACTIONS(3018),
    [anon_sym_BANG] = ACTIONS(3018),
    [anon_sym_TILDE] = ACTIONS(3018),
    [anon_sym_DASH] = ACTIONS(3016),
    [anon_sym_PLUS] = ACTIONS(3016),
    [anon_sym_STAR] = ACTIONS(3018),
    [anon_sym_AMP_AMP] = ACTIONS(3018),
    [anon_sym_AMP] = ACTIONS(3016),
    [anon_sym_SEMI] = ACTIONS(3018),
    [anon_sym___extension__] = ACTIONS(3016),
    [anon_sym_typedef] = ACTIONS(3016),
    [anon_sym_extern] = ACTIONS(3016),
    [anon_sym___attribute__] = ACTIONS(3016),
    [anon_sym_COLON_COLON] = ACTIONS(3018),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3018),
    [anon_sym___declspec] = ACTIONS(3016),
    [anon_sym___based] = ACTIONS(3016),
    [anon_sym___cdecl] = ACTIONS(3016),
    [anon_sym___clrcall] = ACTIONS(3016),
    [anon_sym___stdcall] = ACTIONS(3016),
    [anon_sym___fastcall] = ACTIONS(3016),
    [anon_sym___thiscall] = ACTIONS(3016),
    [anon_sym___vectorcall] = ACTIONS(3016),
    [anon_sym_LBRACE] = ACTIONS(3018),
    [anon_sym_RBRACE] = ACTIONS(3018),
    [anon_sym_signed] = ACTIONS(3016),
    [anon_sym_unsigned] = ACTIONS(3016),
    [anon_sym_long] = ACTIONS(3016),
    [anon_sym_short] = ACTIONS(3016),
    [anon_sym_LBRACK] = ACTIONS(3016),
    [anon_sym_static] = ACTIONS(3016),
    [anon_sym_register] = ACTIONS(3016),
    [anon_sym_inline] = ACTIONS(3016),
    [anon_sym___inline] = ACTIONS(3016),
    [anon_sym___inline__] = ACTIONS(3016),
    [anon_sym___forceinline] = ACTIONS(3016),
    [anon_sym_thread_local] = ACTIONS(3016),
    [anon_sym___thread] = ACTIONS(3016),
    [anon_sym_const] = ACTIONS(3016),
    [anon_sym_constexpr] = ACTIONS(3016),
    [anon_sym_volatile] = ACTIONS(3016),
    [anon_sym_restrict] = ACTIONS(3016),
    [anon_sym___restrict__] = ACTIONS(3016),
    [anon_sym__Atomic] = ACTIONS(3016),
    [anon_sym__Noreturn] = ACTIONS(3016),
    [anon_sym_noreturn] = ACTIONS(3016),
    [anon_sym_mutable] = ACTIONS(3016),
    [anon_sym_constinit] = ACTIONS(3016),
    [anon_sym_consteval] = ACTIONS(3016),
    [anon_sym_PROGMEM] = ACTIONS(3016),
    [aux_sym_primitive_type_token1] = ACTIONS(3016),
    [anon_sym_byte] = ACTIONS(3016),
    [anon_sym_word] = ACTIONS(3016),
    [anon_sym_enum] = ACTIONS(3016),
    [anon_sym_class] = ACTIONS(3016),
    [anon_sym_struct] = ACTIONS(3016),
    [anon_sym_union] = ACTIONS(3016),
    [anon_sym_if] = ACTIONS(3016),
    [anon_sym_switch] = ACTIONS(3016),
    [anon_sym_case] = ACTIONS(3016),
    [anon_sym_default] = ACTIONS(3016),
    [anon_sym_while] = ACTIONS(3016),
    [anon_sym_do] = ACTIONS(3016),
    [anon_sym_for] = ACTIONS(3016),
    [anon_sym_return] = ACTIONS(3016),
    [anon_sym_break] = ACTIONS(3016),
    [anon_sym_continue] = ACTIONS(3016),
    [anon_sym_goto] = ACTIONS(3016),
    [anon_sym___try] = ACTIONS(3016),
    [anon_sym___leave] = ACTIONS(3016),
    [anon_sym_not] = ACTIONS(3016),
    [anon_sym_compl] = ACTIONS(3016),
    [anon_sym_DASH_DASH] = ACTIONS(3018),
    [anon_sym_PLUS_PLUS] = ACTIONS(3018),
    [anon_sym_sizeof] = ACTIONS(3016),
    [anon_sym___alignof__] = ACTIONS(3016),
    [anon_sym___alignof] = ACTIONS(3016),
    [anon_sym__alignof] = ACTIONS(3016),
    [anon_sym_alignof] = ACTIONS(3016),
    [anon_sym__Alignof] = ACTIONS(3016),
    [anon_sym_offsetof] = ACTIONS(3016),
    [anon_sym__Generic] = ACTIONS(3016),
    [anon_sym_asm] = ACTIONS(3016),
    [anon_sym___asm__] = ACTIONS(3016),
    [aux_sym_number_literal_token1] = ACTIONS(3018),
    [aux_sym_number_literal_token2] = ACTIONS(3016),
    [anon_sym_L_SQUOTE] = ACTIONS(3018),
    [anon_sym_u_SQUOTE] = ACTIONS(3018),
    [anon_sym_U_SQUOTE] = ACTIONS(3018),
    [anon_sym_u8_SQUOTE] = ACTIONS(3018),
    [anon_sym_SQUOTE] = ACTIONS(3018),
    [anon_sym_L_DQUOTE] = ACTIONS(3018),
    [anon_sym_u_DQUOTE] = ACTIONS(3018),
    [anon_sym_U_DQUOTE] = ACTIONS(3018),
    [anon_sym_u8_DQUOTE] = ACTIONS(3018),
    [anon_sym_DQUOTE] = ACTIONS(3018),
    [sym_true] = ACTIONS(3016),
    [sym_false] = ACTIONS(3016),
    [anon_sym_NULL] = ACTIONS(3016),
    [anon_sym_nullptr] = ACTIONS(3016),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3016),
    [anon_sym_decltype] = ACTIONS(3016),
    [anon_sym_virtual] = ACTIONS(3016),
    [anon_sym_alignas] = ACTIONS(3016),
    [anon_sym_explicit] = ACTIONS(3016),
    [anon_sym_typename] = ACTIONS(3016),
    [anon_sym_template] = ACTIONS(3016),
    [anon_sym_operator] = ACTIONS(3016),
    [anon_sym_try] = ACTIONS(3016),
    [anon_sym_delete] = ACTIONS(3016),
    [anon_sym_throw] = ACTIONS(3016),
    [anon_sym_namespace] = ACTIONS(3016),
    [anon_sym_using] = ACTIONS(3016),
    [anon_sym_static_assert] = ACTIONS(3016),
    [anon_sym_concept] = ACTIONS(3016),
    [anon_sym_co_return] = ACTIONS(3016),
    [anon_sym_co_yield] = ACTIONS(3016),
    [anon_sym_R_DQUOTE] = ACTIONS(3018),
    [anon_sym_LR_DQUOTE] = ACTIONS(3018),
    [anon_sym_uR_DQUOTE] = ACTIONS(3018),
    [anon_sym_UR_DQUOTE] = ACTIONS(3018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3018),
    [anon_sym_co_await] = ACTIONS(3016),
    [anon_sym_new] = ACTIONS(3016),
    [anon_sym_requires] = ACTIONS(3016),
    [sym_this] = ACTIONS(3016),
  },
  [699] = {
    [sym_identifier] = ACTIONS(3052),
    [aux_sym_preproc_include_token1] = ACTIONS(3052),
    [aux_sym_preproc_def_token1] = ACTIONS(3052),
    [aux_sym_preproc_if_token1] = ACTIONS(3052),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3052),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3052),
    [sym_preproc_directive] = ACTIONS(3052),
    [anon_sym_LPAREN2] = ACTIONS(3054),
    [anon_sym_BANG] = ACTIONS(3054),
    [anon_sym_TILDE] = ACTIONS(3054),
    [anon_sym_DASH] = ACTIONS(3052),
    [anon_sym_PLUS] = ACTIONS(3052),
    [anon_sym_STAR] = ACTIONS(3054),
    [anon_sym_AMP_AMP] = ACTIONS(3054),
    [anon_sym_AMP] = ACTIONS(3052),
    [anon_sym_SEMI] = ACTIONS(3054),
    [anon_sym___extension__] = ACTIONS(3052),
    [anon_sym_typedef] = ACTIONS(3052),
    [anon_sym_extern] = ACTIONS(3052),
    [anon_sym___attribute__] = ACTIONS(3052),
    [anon_sym_COLON_COLON] = ACTIONS(3054),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3054),
    [anon_sym___declspec] = ACTIONS(3052),
    [anon_sym___based] = ACTIONS(3052),
    [anon_sym___cdecl] = ACTIONS(3052),
    [anon_sym___clrcall] = ACTIONS(3052),
    [anon_sym___stdcall] = ACTIONS(3052),
    [anon_sym___fastcall] = ACTIONS(3052),
    [anon_sym___thiscall] = ACTIONS(3052),
    [anon_sym___vectorcall] = ACTIONS(3052),
    [anon_sym_LBRACE] = ACTIONS(3054),
    [anon_sym_RBRACE] = ACTIONS(3054),
    [anon_sym_signed] = ACTIONS(3052),
    [anon_sym_unsigned] = ACTIONS(3052),
    [anon_sym_long] = ACTIONS(3052),
    [anon_sym_short] = ACTIONS(3052),
    [anon_sym_LBRACK] = ACTIONS(3052),
    [anon_sym_static] = ACTIONS(3052),
    [anon_sym_register] = ACTIONS(3052),
    [anon_sym_inline] = ACTIONS(3052),
    [anon_sym___inline] = ACTIONS(3052),
    [anon_sym___inline__] = ACTIONS(3052),
    [anon_sym___forceinline] = ACTIONS(3052),
    [anon_sym_thread_local] = ACTIONS(3052),
    [anon_sym___thread] = ACTIONS(3052),
    [anon_sym_const] = ACTIONS(3052),
    [anon_sym_constexpr] = ACTIONS(3052),
    [anon_sym_volatile] = ACTIONS(3052),
    [anon_sym_restrict] = ACTIONS(3052),
    [anon_sym___restrict__] = ACTIONS(3052),
    [anon_sym__Atomic] = ACTIONS(3052),
    [anon_sym__Noreturn] = ACTIONS(3052),
    [anon_sym_noreturn] = ACTIONS(3052),
    [anon_sym_mutable] = ACTIONS(3052),
    [anon_sym_constinit] = ACTIONS(3052),
    [anon_sym_consteval] = ACTIONS(3052),
    [anon_sym_PROGMEM] = ACTIONS(3052),
    [aux_sym_primitive_type_token1] = ACTIONS(3052),
    [anon_sym_byte] = ACTIONS(3052),
    [anon_sym_word] = ACTIONS(3052),
    [anon_sym_enum] = ACTIONS(3052),
    [anon_sym_class] = ACTIONS(3052),
    [anon_sym_struct] = ACTIONS(3052),
    [anon_sym_union] = ACTIONS(3052),
    [anon_sym_if] = ACTIONS(3052),
    [anon_sym_switch] = ACTIONS(3052),
    [anon_sym_case] = ACTIONS(3052),
    [anon_sym_default] = ACTIONS(3052),
    [anon_sym_while] = ACTIONS(3052),
    [anon_sym_do] = ACTIONS(3052),
    [anon_sym_for] = ACTIONS(3052),
    [anon_sym_return] = ACTIONS(3052),
    [anon_sym_break] = ACTIONS(3052),
    [anon_sym_continue] = ACTIONS(3052),
    [anon_sym_goto] = ACTIONS(3052),
    [anon_sym___try] = ACTIONS(3052),
    [anon_sym___leave] = ACTIONS(3052),
    [anon_sym_not] = ACTIONS(3052),
    [anon_sym_compl] = ACTIONS(3052),
    [anon_sym_DASH_DASH] = ACTIONS(3054),
    [anon_sym_PLUS_PLUS] = ACTIONS(3054),
    [anon_sym_sizeof] = ACTIONS(3052),
    [anon_sym___alignof__] = ACTIONS(3052),
    [anon_sym___alignof] = ACTIONS(3052),
    [anon_sym__alignof] = ACTIONS(3052),
    [anon_sym_alignof] = ACTIONS(3052),
    [anon_sym__Alignof] = ACTIONS(3052),
    [anon_sym_offsetof] = ACTIONS(3052),
    [anon_sym__Generic] = ACTIONS(3052),
    [anon_sym_asm] = ACTIONS(3052),
    [anon_sym___asm__] = ACTIONS(3052),
    [aux_sym_number_literal_token1] = ACTIONS(3054),
    [aux_sym_number_literal_token2] = ACTIONS(3052),
    [anon_sym_L_SQUOTE] = ACTIONS(3054),
    [anon_sym_u_SQUOTE] = ACTIONS(3054),
    [anon_sym_U_SQUOTE] = ACTIONS(3054),
    [anon_sym_u8_SQUOTE] = ACTIONS(3054),
    [anon_sym_SQUOTE] = ACTIONS(3054),
    [anon_sym_L_DQUOTE] = ACTIONS(3054),
    [anon_sym_u_DQUOTE] = ACTIONS(3054),
    [anon_sym_U_DQUOTE] = ACTIONS(3054),
    [anon_sym_u8_DQUOTE] = ACTIONS(3054),
    [anon_sym_DQUOTE] = ACTIONS(3054),
    [sym_true] = ACTIONS(3052),
    [sym_false] = ACTIONS(3052),
    [anon_sym_NULL] = ACTIONS(3052),
    [anon_sym_nullptr] = ACTIONS(3052),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3052),
    [anon_sym_decltype] = ACTIONS(3052),
    [anon_sym_virtual] = ACTIONS(3052),
    [anon_sym_alignas] = ACTIONS(3052),
    [anon_sym_explicit] = ACTIONS(3052),
    [anon_sym_typename] = ACTIONS(3052),
    [anon_sym_template] = ACTIONS(3052),
    [anon_sym_operator] = ACTIONS(3052),
    [anon_sym_try] = ACTIONS(3052),
    [anon_sym_delete] = ACTIONS(3052),
    [anon_sym_throw] = ACTIONS(3052),
    [anon_sym_namespace] = ACTIONS(3052),
    [anon_sym_using] = ACTIONS(3052),
    [anon_sym_static_assert] = ACTIONS(3052),
    [anon_sym_concept] = ACTIONS(3052),
    [anon_sym_co_return] = ACTIONS(3052),
    [anon_sym_co_yield] = ACTIONS(3052),
    [anon_sym_R_DQUOTE] = ACTIONS(3054),
    [anon_sym_LR_DQUOTE] = ACTIONS(3054),
    [anon_sym_uR_DQUOTE] = ACTIONS(3054),
    [anon_sym_UR_DQUOTE] = ACTIONS(3054),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3054),
    [anon_sym_co_await] = ACTIONS(3052),
    [anon_sym_new] = ACTIONS(3052),
    [anon_sym_requires] = ACTIONS(3052),
    [sym_this] = ACTIONS(3052),
  },
  [700] = {
    [sym_identifier] = ACTIONS(3008),
    [aux_sym_preproc_include_token1] = ACTIONS(3008),
    [aux_sym_preproc_def_token1] = ACTIONS(3008),
    [aux_sym_preproc_if_token1] = ACTIONS(3008),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3008),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3008),
    [sym_preproc_directive] = ACTIONS(3008),
    [anon_sym_LPAREN2] = ACTIONS(3010),
    [anon_sym_BANG] = ACTIONS(3010),
    [anon_sym_TILDE] = ACTIONS(3010),
    [anon_sym_DASH] = ACTIONS(3008),
    [anon_sym_PLUS] = ACTIONS(3008),
    [anon_sym_STAR] = ACTIONS(3010),
    [anon_sym_AMP_AMP] = ACTIONS(3010),
    [anon_sym_AMP] = ACTIONS(3008),
    [anon_sym_SEMI] = ACTIONS(3010),
    [anon_sym___extension__] = ACTIONS(3008),
    [anon_sym_typedef] = ACTIONS(3008),
    [anon_sym_extern] = ACTIONS(3008),
    [anon_sym___attribute__] = ACTIONS(3008),
    [anon_sym_COLON_COLON] = ACTIONS(3010),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3010),
    [anon_sym___declspec] = ACTIONS(3008),
    [anon_sym___based] = ACTIONS(3008),
    [anon_sym___cdecl] = ACTIONS(3008),
    [anon_sym___clrcall] = ACTIONS(3008),
    [anon_sym___stdcall] = ACTIONS(3008),
    [anon_sym___fastcall] = ACTIONS(3008),
    [anon_sym___thiscall] = ACTIONS(3008),
    [anon_sym___vectorcall] = ACTIONS(3008),
    [anon_sym_LBRACE] = ACTIONS(3010),
    [anon_sym_RBRACE] = ACTIONS(3010),
    [anon_sym_signed] = ACTIONS(3008),
    [anon_sym_unsigned] = ACTIONS(3008),
    [anon_sym_long] = ACTIONS(3008),
    [anon_sym_short] = ACTIONS(3008),
    [anon_sym_LBRACK] = ACTIONS(3008),
    [anon_sym_static] = ACTIONS(3008),
    [anon_sym_register] = ACTIONS(3008),
    [anon_sym_inline] = ACTIONS(3008),
    [anon_sym___inline] = ACTIONS(3008),
    [anon_sym___inline__] = ACTIONS(3008),
    [anon_sym___forceinline] = ACTIONS(3008),
    [anon_sym_thread_local] = ACTIONS(3008),
    [anon_sym___thread] = ACTIONS(3008),
    [anon_sym_const] = ACTIONS(3008),
    [anon_sym_constexpr] = ACTIONS(3008),
    [anon_sym_volatile] = ACTIONS(3008),
    [anon_sym_restrict] = ACTIONS(3008),
    [anon_sym___restrict__] = ACTIONS(3008),
    [anon_sym__Atomic] = ACTIONS(3008),
    [anon_sym__Noreturn] = ACTIONS(3008),
    [anon_sym_noreturn] = ACTIONS(3008),
    [anon_sym_mutable] = ACTIONS(3008),
    [anon_sym_constinit] = ACTIONS(3008),
    [anon_sym_consteval] = ACTIONS(3008),
    [anon_sym_PROGMEM] = ACTIONS(3008),
    [aux_sym_primitive_type_token1] = ACTIONS(3008),
    [anon_sym_byte] = ACTIONS(3008),
    [anon_sym_word] = ACTIONS(3008),
    [anon_sym_enum] = ACTIONS(3008),
    [anon_sym_class] = ACTIONS(3008),
    [anon_sym_struct] = ACTIONS(3008),
    [anon_sym_union] = ACTIONS(3008),
    [anon_sym_if] = ACTIONS(3008),
    [anon_sym_switch] = ACTIONS(3008),
    [anon_sym_case] = ACTIONS(3008),
    [anon_sym_default] = ACTIONS(3008),
    [anon_sym_while] = ACTIONS(3008),
    [anon_sym_do] = ACTIONS(3008),
    [anon_sym_for] = ACTIONS(3008),
    [anon_sym_return] = ACTIONS(3008),
    [anon_sym_break] = ACTIONS(3008),
    [anon_sym_continue] = ACTIONS(3008),
    [anon_sym_goto] = ACTIONS(3008),
    [anon_sym___try] = ACTIONS(3008),
    [anon_sym___leave] = ACTIONS(3008),
    [anon_sym_not] = ACTIONS(3008),
    [anon_sym_compl] = ACTIONS(3008),
    [anon_sym_DASH_DASH] = ACTIONS(3010),
    [anon_sym_PLUS_PLUS] = ACTIONS(3010),
    [anon_sym_sizeof] = ACTIONS(3008),
    [anon_sym___alignof__] = ACTIONS(3008),
    [anon_sym___alignof] = ACTIONS(3008),
    [anon_sym__alignof] = ACTIONS(3008),
    [anon_sym_alignof] = ACTIONS(3008),
    [anon_sym__Alignof] = ACTIONS(3008),
    [anon_sym_offsetof] = ACTIONS(3008),
    [anon_sym__Generic] = ACTIONS(3008),
    [anon_sym_asm] = ACTIONS(3008),
    [anon_sym___asm__] = ACTIONS(3008),
    [aux_sym_number_literal_token1] = ACTIONS(3010),
    [aux_sym_number_literal_token2] = ACTIONS(3008),
    [anon_sym_L_SQUOTE] = ACTIONS(3010),
    [anon_sym_u_SQUOTE] = ACTIONS(3010),
    [anon_sym_U_SQUOTE] = ACTIONS(3010),
    [anon_sym_u8_SQUOTE] = ACTIONS(3010),
    [anon_sym_SQUOTE] = ACTIONS(3010),
    [anon_sym_L_DQUOTE] = ACTIONS(3010),
    [anon_sym_u_DQUOTE] = ACTIONS(3010),
    [anon_sym_U_DQUOTE] = ACTIONS(3010),
    [anon_sym_u8_DQUOTE] = ACTIONS(3010),
    [anon_sym_DQUOTE] = ACTIONS(3010),
    [sym_true] = ACTIONS(3008),
    [sym_false] = ACTIONS(3008),
    [anon_sym_NULL] = ACTIONS(3008),
    [anon_sym_nullptr] = ACTIONS(3008),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3008),
    [anon_sym_decltype] = ACTIONS(3008),
    [anon_sym_virtual] = ACTIONS(3008),
    [anon_sym_alignas] = ACTIONS(3008),
    [anon_sym_explicit] = ACTIONS(3008),
    [anon_sym_typename] = ACTIONS(3008),
    [anon_sym_template] = ACTIONS(3008),
    [anon_sym_operator] = ACTIONS(3008),
    [anon_sym_try] = ACTIONS(3008),
    [anon_sym_delete] = ACTIONS(3008),
    [anon_sym_throw] = ACTIONS(3008),
    [anon_sym_namespace] = ACTIONS(3008),
    [anon_sym_using] = ACTIONS(3008),
    [anon_sym_static_assert] = ACTIONS(3008),
    [anon_sym_concept] = ACTIONS(3008),
    [anon_sym_co_return] = ACTIONS(3008),
    [anon_sym_co_yield] = ACTIONS(3008),
    [anon_sym_R_DQUOTE] = ACTIONS(3010),
    [anon_sym_LR_DQUOTE] = ACTIONS(3010),
    [anon_sym_uR_DQUOTE] = ACTIONS(3010),
    [anon_sym_UR_DQUOTE] = ACTIONS(3010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3010),
    [anon_sym_co_await] = ACTIONS(3008),
    [anon_sym_new] = ACTIONS(3008),
    [anon_sym_requires] = ACTIONS(3008),
    [sym_this] = ACTIONS(3008),
  },
  [701] = {
    [sym_identifier] = ACTIONS(3056),
    [aux_sym_preproc_include_token1] = ACTIONS(3056),
    [aux_sym_preproc_def_token1] = ACTIONS(3056),
    [aux_sym_preproc_if_token1] = ACTIONS(3056),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3056),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3056),
    [sym_preproc_directive] = ACTIONS(3056),
    [anon_sym_LPAREN2] = ACTIONS(3058),
    [anon_sym_BANG] = ACTIONS(3058),
    [anon_sym_TILDE] = ACTIONS(3058),
    [anon_sym_DASH] = ACTIONS(3056),
    [anon_sym_PLUS] = ACTIONS(3056),
    [anon_sym_STAR] = ACTIONS(3058),
    [anon_sym_AMP_AMP] = ACTIONS(3058),
    [anon_sym_AMP] = ACTIONS(3056),
    [anon_sym_SEMI] = ACTIONS(3058),
    [anon_sym___extension__] = ACTIONS(3056),
    [anon_sym_typedef] = ACTIONS(3056),
    [anon_sym_extern] = ACTIONS(3056),
    [anon_sym___attribute__] = ACTIONS(3056),
    [anon_sym_COLON_COLON] = ACTIONS(3058),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3058),
    [anon_sym___declspec] = ACTIONS(3056),
    [anon_sym___based] = ACTIONS(3056),
    [anon_sym___cdecl] = ACTIONS(3056),
    [anon_sym___clrcall] = ACTIONS(3056),
    [anon_sym___stdcall] = ACTIONS(3056),
    [anon_sym___fastcall] = ACTIONS(3056),
    [anon_sym___thiscall] = ACTIONS(3056),
    [anon_sym___vectorcall] = ACTIONS(3056),
    [anon_sym_LBRACE] = ACTIONS(3058),
    [anon_sym_RBRACE] = ACTIONS(3058),
    [anon_sym_signed] = ACTIONS(3056),
    [anon_sym_unsigned] = ACTIONS(3056),
    [anon_sym_long] = ACTIONS(3056),
    [anon_sym_short] = ACTIONS(3056),
    [anon_sym_LBRACK] = ACTIONS(3056),
    [anon_sym_static] = ACTIONS(3056),
    [anon_sym_register] = ACTIONS(3056),
    [anon_sym_inline] = ACTIONS(3056),
    [anon_sym___inline] = ACTIONS(3056),
    [anon_sym___inline__] = ACTIONS(3056),
    [anon_sym___forceinline] = ACTIONS(3056),
    [anon_sym_thread_local] = ACTIONS(3056),
    [anon_sym___thread] = ACTIONS(3056),
    [anon_sym_const] = ACTIONS(3056),
    [anon_sym_constexpr] = ACTIONS(3056),
    [anon_sym_volatile] = ACTIONS(3056),
    [anon_sym_restrict] = ACTIONS(3056),
    [anon_sym___restrict__] = ACTIONS(3056),
    [anon_sym__Atomic] = ACTIONS(3056),
    [anon_sym__Noreturn] = ACTIONS(3056),
    [anon_sym_noreturn] = ACTIONS(3056),
    [anon_sym_mutable] = ACTIONS(3056),
    [anon_sym_constinit] = ACTIONS(3056),
    [anon_sym_consteval] = ACTIONS(3056),
    [anon_sym_PROGMEM] = ACTIONS(3056),
    [aux_sym_primitive_type_token1] = ACTIONS(3056),
    [anon_sym_byte] = ACTIONS(3056),
    [anon_sym_word] = ACTIONS(3056),
    [anon_sym_enum] = ACTIONS(3056),
    [anon_sym_class] = ACTIONS(3056),
    [anon_sym_struct] = ACTIONS(3056),
    [anon_sym_union] = ACTIONS(3056),
    [anon_sym_if] = ACTIONS(3056),
    [anon_sym_switch] = ACTIONS(3056),
    [anon_sym_case] = ACTIONS(3056),
    [anon_sym_default] = ACTIONS(3056),
    [anon_sym_while] = ACTIONS(3056),
    [anon_sym_do] = ACTIONS(3056),
    [anon_sym_for] = ACTIONS(3056),
    [anon_sym_return] = ACTIONS(3056),
    [anon_sym_break] = ACTIONS(3056),
    [anon_sym_continue] = ACTIONS(3056),
    [anon_sym_goto] = ACTIONS(3056),
    [anon_sym___try] = ACTIONS(3056),
    [anon_sym___leave] = ACTIONS(3056),
    [anon_sym_not] = ACTIONS(3056),
    [anon_sym_compl] = ACTIONS(3056),
    [anon_sym_DASH_DASH] = ACTIONS(3058),
    [anon_sym_PLUS_PLUS] = ACTIONS(3058),
    [anon_sym_sizeof] = ACTIONS(3056),
    [anon_sym___alignof__] = ACTIONS(3056),
    [anon_sym___alignof] = ACTIONS(3056),
    [anon_sym__alignof] = ACTIONS(3056),
    [anon_sym_alignof] = ACTIONS(3056),
    [anon_sym__Alignof] = ACTIONS(3056),
    [anon_sym_offsetof] = ACTIONS(3056),
    [anon_sym__Generic] = ACTIONS(3056),
    [anon_sym_asm] = ACTIONS(3056),
    [anon_sym___asm__] = ACTIONS(3056),
    [aux_sym_number_literal_token1] = ACTIONS(3058),
    [aux_sym_number_literal_token2] = ACTIONS(3056),
    [anon_sym_L_SQUOTE] = ACTIONS(3058),
    [anon_sym_u_SQUOTE] = ACTIONS(3058),
    [anon_sym_U_SQUOTE] = ACTIONS(3058),
    [anon_sym_u8_SQUOTE] = ACTIONS(3058),
    [anon_sym_SQUOTE] = ACTIONS(3058),
    [anon_sym_L_DQUOTE] = ACTIONS(3058),
    [anon_sym_u_DQUOTE] = ACTIONS(3058),
    [anon_sym_U_DQUOTE] = ACTIONS(3058),
    [anon_sym_u8_DQUOTE] = ACTIONS(3058),
    [anon_sym_DQUOTE] = ACTIONS(3058),
    [sym_true] = ACTIONS(3056),
    [sym_false] = ACTIONS(3056),
    [anon_sym_NULL] = ACTIONS(3056),
    [anon_sym_nullptr] = ACTIONS(3056),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3056),
    [anon_sym_decltype] = ACTIONS(3056),
    [anon_sym_virtual] = ACTIONS(3056),
    [anon_sym_alignas] = ACTIONS(3056),
    [anon_sym_explicit] = ACTIONS(3056),
    [anon_sym_typename] = ACTIONS(3056),
    [anon_sym_template] = ACTIONS(3056),
    [anon_sym_operator] = ACTIONS(3056),
    [anon_sym_try] = ACTIONS(3056),
    [anon_sym_delete] = ACTIONS(3056),
    [anon_sym_throw] = ACTIONS(3056),
    [anon_sym_namespace] = ACTIONS(3056),
    [anon_sym_using] = ACTIONS(3056),
    [anon_sym_static_assert] = ACTIONS(3056),
    [anon_sym_concept] = ACTIONS(3056),
    [anon_sym_co_return] = ACTIONS(3056),
    [anon_sym_co_yield] = ACTIONS(3056),
    [anon_sym_R_DQUOTE] = ACTIONS(3058),
    [anon_sym_LR_DQUOTE] = ACTIONS(3058),
    [anon_sym_uR_DQUOTE] = ACTIONS(3058),
    [anon_sym_UR_DQUOTE] = ACTIONS(3058),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3058),
    [anon_sym_co_await] = ACTIONS(3056),
    [anon_sym_new] = ACTIONS(3056),
    [anon_sym_requires] = ACTIONS(3056),
    [sym_this] = ACTIONS(3056),
  },
  [702] = {
    [sym_identifier] = ACTIONS(3064),
    [aux_sym_preproc_include_token1] = ACTIONS(3064),
    [aux_sym_preproc_def_token1] = ACTIONS(3064),
    [aux_sym_preproc_if_token1] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3064),
    [sym_preproc_directive] = ACTIONS(3064),
    [anon_sym_LPAREN2] = ACTIONS(3066),
    [anon_sym_BANG] = ACTIONS(3066),
    [anon_sym_TILDE] = ACTIONS(3066),
    [anon_sym_DASH] = ACTIONS(3064),
    [anon_sym_PLUS] = ACTIONS(3064),
    [anon_sym_STAR] = ACTIONS(3066),
    [anon_sym_AMP_AMP] = ACTIONS(3066),
    [anon_sym_AMP] = ACTIONS(3064),
    [anon_sym_SEMI] = ACTIONS(3066),
    [anon_sym___extension__] = ACTIONS(3064),
    [anon_sym_typedef] = ACTIONS(3064),
    [anon_sym_extern] = ACTIONS(3064),
    [anon_sym___attribute__] = ACTIONS(3064),
    [anon_sym_COLON_COLON] = ACTIONS(3066),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3066),
    [anon_sym___declspec] = ACTIONS(3064),
    [anon_sym___based] = ACTIONS(3064),
    [anon_sym___cdecl] = ACTIONS(3064),
    [anon_sym___clrcall] = ACTIONS(3064),
    [anon_sym___stdcall] = ACTIONS(3064),
    [anon_sym___fastcall] = ACTIONS(3064),
    [anon_sym___thiscall] = ACTIONS(3064),
    [anon_sym___vectorcall] = ACTIONS(3064),
    [anon_sym_LBRACE] = ACTIONS(3066),
    [anon_sym_RBRACE] = ACTIONS(3066),
    [anon_sym_signed] = ACTIONS(3064),
    [anon_sym_unsigned] = ACTIONS(3064),
    [anon_sym_long] = ACTIONS(3064),
    [anon_sym_short] = ACTIONS(3064),
    [anon_sym_LBRACK] = ACTIONS(3064),
    [anon_sym_static] = ACTIONS(3064),
    [anon_sym_register] = ACTIONS(3064),
    [anon_sym_inline] = ACTIONS(3064),
    [anon_sym___inline] = ACTIONS(3064),
    [anon_sym___inline__] = ACTIONS(3064),
    [anon_sym___forceinline] = ACTIONS(3064),
    [anon_sym_thread_local] = ACTIONS(3064),
    [anon_sym___thread] = ACTIONS(3064),
    [anon_sym_const] = ACTIONS(3064),
    [anon_sym_constexpr] = ACTIONS(3064),
    [anon_sym_volatile] = ACTIONS(3064),
    [anon_sym_restrict] = ACTIONS(3064),
    [anon_sym___restrict__] = ACTIONS(3064),
    [anon_sym__Atomic] = ACTIONS(3064),
    [anon_sym__Noreturn] = ACTIONS(3064),
    [anon_sym_noreturn] = ACTIONS(3064),
    [anon_sym_mutable] = ACTIONS(3064),
    [anon_sym_constinit] = ACTIONS(3064),
    [anon_sym_consteval] = ACTIONS(3064),
    [anon_sym_PROGMEM] = ACTIONS(3064),
    [aux_sym_primitive_type_token1] = ACTIONS(3064),
    [anon_sym_byte] = ACTIONS(3064),
    [anon_sym_word] = ACTIONS(3064),
    [anon_sym_enum] = ACTIONS(3064),
    [anon_sym_class] = ACTIONS(3064),
    [anon_sym_struct] = ACTIONS(3064),
    [anon_sym_union] = ACTIONS(3064),
    [anon_sym_if] = ACTIONS(3064),
    [anon_sym_switch] = ACTIONS(3064),
    [anon_sym_case] = ACTIONS(3064),
    [anon_sym_default] = ACTIONS(3064),
    [anon_sym_while] = ACTIONS(3064),
    [anon_sym_do] = ACTIONS(3064),
    [anon_sym_for] = ACTIONS(3064),
    [anon_sym_return] = ACTIONS(3064),
    [anon_sym_break] = ACTIONS(3064),
    [anon_sym_continue] = ACTIONS(3064),
    [anon_sym_goto] = ACTIONS(3064),
    [anon_sym___try] = ACTIONS(3064),
    [anon_sym___leave] = ACTIONS(3064),
    [anon_sym_not] = ACTIONS(3064),
    [anon_sym_compl] = ACTIONS(3064),
    [anon_sym_DASH_DASH] = ACTIONS(3066),
    [anon_sym_PLUS_PLUS] = ACTIONS(3066),
    [anon_sym_sizeof] = ACTIONS(3064),
    [anon_sym___alignof__] = ACTIONS(3064),
    [anon_sym___alignof] = ACTIONS(3064),
    [anon_sym__alignof] = ACTIONS(3064),
    [anon_sym_alignof] = ACTIONS(3064),
    [anon_sym__Alignof] = ACTIONS(3064),
    [anon_sym_offsetof] = ACTIONS(3064),
    [anon_sym__Generic] = ACTIONS(3064),
    [anon_sym_asm] = ACTIONS(3064),
    [anon_sym___asm__] = ACTIONS(3064),
    [aux_sym_number_literal_token1] = ACTIONS(3066),
    [aux_sym_number_literal_token2] = ACTIONS(3064),
    [anon_sym_L_SQUOTE] = ACTIONS(3066),
    [anon_sym_u_SQUOTE] = ACTIONS(3066),
    [anon_sym_U_SQUOTE] = ACTIONS(3066),
    [anon_sym_u8_SQUOTE] = ACTIONS(3066),
    [anon_sym_SQUOTE] = ACTIONS(3066),
    [anon_sym_L_DQUOTE] = ACTIONS(3066),
    [anon_sym_u_DQUOTE] = ACTIONS(3066),
    [anon_sym_U_DQUOTE] = ACTIONS(3066),
    [anon_sym_u8_DQUOTE] = ACTIONS(3066),
    [anon_sym_DQUOTE] = ACTIONS(3066),
    [sym_true] = ACTIONS(3064),
    [sym_false] = ACTIONS(3064),
    [anon_sym_NULL] = ACTIONS(3064),
    [anon_sym_nullptr] = ACTIONS(3064),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3064),
    [anon_sym_decltype] = ACTIONS(3064),
    [anon_sym_virtual] = ACTIONS(3064),
    [anon_sym_alignas] = ACTIONS(3064),
    [anon_sym_explicit] = ACTIONS(3064),
    [anon_sym_typename] = ACTIONS(3064),
    [anon_sym_template] = ACTIONS(3064),
    [anon_sym_operator] = ACTIONS(3064),
    [anon_sym_try] = ACTIONS(3064),
    [anon_sym_delete] = ACTIONS(3064),
    [anon_sym_throw] = ACTIONS(3064),
    [anon_sym_namespace] = ACTIONS(3064),
    [anon_sym_using] = ACTIONS(3064),
    [anon_sym_static_assert] = ACTIONS(3064),
    [anon_sym_concept] = ACTIONS(3064),
    [anon_sym_co_return] = ACTIONS(3064),
    [anon_sym_co_yield] = ACTIONS(3064),
    [anon_sym_R_DQUOTE] = ACTIONS(3066),
    [anon_sym_LR_DQUOTE] = ACTIONS(3066),
    [anon_sym_uR_DQUOTE] = ACTIONS(3066),
    [anon_sym_UR_DQUOTE] = ACTIONS(3066),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3066),
    [anon_sym_co_await] = ACTIONS(3064),
    [anon_sym_new] = ACTIONS(3064),
    [anon_sym_requires] = ACTIONS(3064),
    [sym_this] = ACTIONS(3064),
  },
  [703] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [704] = {
    [sym_identifier] = ACTIONS(3160),
    [aux_sym_preproc_include_token1] = ACTIONS(3160),
    [aux_sym_preproc_def_token1] = ACTIONS(3160),
    [aux_sym_preproc_if_token1] = ACTIONS(3160),
    [aux_sym_preproc_if_token2] = ACTIONS(3160),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3160),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3160),
    [sym_preproc_directive] = ACTIONS(3160),
    [anon_sym_LPAREN2] = ACTIONS(3162),
    [anon_sym_BANG] = ACTIONS(3162),
    [anon_sym_TILDE] = ACTIONS(3162),
    [anon_sym_DASH] = ACTIONS(3160),
    [anon_sym_PLUS] = ACTIONS(3160),
    [anon_sym_STAR] = ACTIONS(3162),
    [anon_sym_AMP_AMP] = ACTIONS(3162),
    [anon_sym_AMP] = ACTIONS(3160),
    [anon_sym_SEMI] = ACTIONS(3162),
    [anon_sym___extension__] = ACTIONS(3160),
    [anon_sym_typedef] = ACTIONS(3160),
    [anon_sym_extern] = ACTIONS(3160),
    [anon_sym___attribute__] = ACTIONS(3160),
    [anon_sym_COLON_COLON] = ACTIONS(3162),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3162),
    [anon_sym___declspec] = ACTIONS(3160),
    [anon_sym___based] = ACTIONS(3160),
    [anon_sym___cdecl] = ACTIONS(3160),
    [anon_sym___clrcall] = ACTIONS(3160),
    [anon_sym___stdcall] = ACTIONS(3160),
    [anon_sym___fastcall] = ACTIONS(3160),
    [anon_sym___thiscall] = ACTIONS(3160),
    [anon_sym___vectorcall] = ACTIONS(3160),
    [anon_sym_LBRACE] = ACTIONS(3162),
    [anon_sym_signed] = ACTIONS(3160),
    [anon_sym_unsigned] = ACTIONS(3160),
    [anon_sym_long] = ACTIONS(3160),
    [anon_sym_short] = ACTIONS(3160),
    [anon_sym_LBRACK] = ACTIONS(3160),
    [anon_sym_static] = ACTIONS(3160),
    [anon_sym_register] = ACTIONS(3160),
    [anon_sym_inline] = ACTIONS(3160),
    [anon_sym___inline] = ACTIONS(3160),
    [anon_sym___inline__] = ACTIONS(3160),
    [anon_sym___forceinline] = ACTIONS(3160),
    [anon_sym_thread_local] = ACTIONS(3160),
    [anon_sym___thread] = ACTIONS(3160),
    [anon_sym_const] = ACTIONS(3160),
    [anon_sym_constexpr] = ACTIONS(3160),
    [anon_sym_volatile] = ACTIONS(3160),
    [anon_sym_restrict] = ACTIONS(3160),
    [anon_sym___restrict__] = ACTIONS(3160),
    [anon_sym__Atomic] = ACTIONS(3160),
    [anon_sym__Noreturn] = ACTIONS(3160),
    [anon_sym_noreturn] = ACTIONS(3160),
    [anon_sym_mutable] = ACTIONS(3160),
    [anon_sym_constinit] = ACTIONS(3160),
    [anon_sym_consteval] = ACTIONS(3160),
    [anon_sym_PROGMEM] = ACTIONS(3160),
    [aux_sym_primitive_type_token1] = ACTIONS(3160),
    [anon_sym_byte] = ACTIONS(3160),
    [anon_sym_word] = ACTIONS(3160),
    [anon_sym_enum] = ACTIONS(3160),
    [anon_sym_class] = ACTIONS(3160),
    [anon_sym_struct] = ACTIONS(3160),
    [anon_sym_union] = ACTIONS(3160),
    [anon_sym_if] = ACTIONS(3160),
    [anon_sym_switch] = ACTIONS(3160),
    [anon_sym_case] = ACTIONS(3160),
    [anon_sym_default] = ACTIONS(3160),
    [anon_sym_while] = ACTIONS(3160),
    [anon_sym_do] = ACTIONS(3160),
    [anon_sym_for] = ACTIONS(3160),
    [anon_sym_return] = ACTIONS(3160),
    [anon_sym_break] = ACTIONS(3160),
    [anon_sym_continue] = ACTIONS(3160),
    [anon_sym_goto] = ACTIONS(3160),
    [anon_sym___try] = ACTIONS(3160),
    [anon_sym___leave] = ACTIONS(3160),
    [anon_sym_not] = ACTIONS(3160),
    [anon_sym_compl] = ACTIONS(3160),
    [anon_sym_DASH_DASH] = ACTIONS(3162),
    [anon_sym_PLUS_PLUS] = ACTIONS(3162),
    [anon_sym_sizeof] = ACTIONS(3160),
    [anon_sym___alignof__] = ACTIONS(3160),
    [anon_sym___alignof] = ACTIONS(3160),
    [anon_sym__alignof] = ACTIONS(3160),
    [anon_sym_alignof] = ACTIONS(3160),
    [anon_sym__Alignof] = ACTIONS(3160),
    [anon_sym_offsetof] = ACTIONS(3160),
    [anon_sym__Generic] = ACTIONS(3160),
    [anon_sym_asm] = ACTIONS(3160),
    [anon_sym___asm__] = ACTIONS(3160),
    [aux_sym_number_literal_token1] = ACTIONS(3162),
    [aux_sym_number_literal_token2] = ACTIONS(3160),
    [anon_sym_L_SQUOTE] = ACTIONS(3162),
    [anon_sym_u_SQUOTE] = ACTIONS(3162),
    [anon_sym_U_SQUOTE] = ACTIONS(3162),
    [anon_sym_u8_SQUOTE] = ACTIONS(3162),
    [anon_sym_SQUOTE] = ACTIONS(3162),
    [anon_sym_L_DQUOTE] = ACTIONS(3162),
    [anon_sym_u_DQUOTE] = ACTIONS(3162),
    [anon_sym_U_DQUOTE] = ACTIONS(3162),
    [anon_sym_u8_DQUOTE] = ACTIONS(3162),
    [anon_sym_DQUOTE] = ACTIONS(3162),
    [sym_true] = ACTIONS(3160),
    [sym_false] = ACTIONS(3160),
    [anon_sym_NULL] = ACTIONS(3160),
    [anon_sym_nullptr] = ACTIONS(3160),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3160),
    [anon_sym_decltype] = ACTIONS(3160),
    [anon_sym_virtual] = ACTIONS(3160),
    [anon_sym_alignas] = ACTIONS(3160),
    [anon_sym_explicit] = ACTIONS(3160),
    [anon_sym_typename] = ACTIONS(3160),
    [anon_sym_template] = ACTIONS(3160),
    [anon_sym_operator] = ACTIONS(3160),
    [anon_sym_try] = ACTIONS(3160),
    [anon_sym_delete] = ACTIONS(3160),
    [anon_sym_throw] = ACTIONS(3160),
    [anon_sym_namespace] = ACTIONS(3160),
    [anon_sym_using] = ACTIONS(3160),
    [anon_sym_static_assert] = ACTIONS(3160),
    [anon_sym_concept] = ACTIONS(3160),
    [anon_sym_co_return] = ACTIONS(3160),
    [anon_sym_co_yield] = ACTIONS(3160),
    [anon_sym_R_DQUOTE] = ACTIONS(3162),
    [anon_sym_LR_DQUOTE] = ACTIONS(3162),
    [anon_sym_uR_DQUOTE] = ACTIONS(3162),
    [anon_sym_UR_DQUOTE] = ACTIONS(3162),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3162),
    [anon_sym_co_await] = ACTIONS(3160),
    [anon_sym_new] = ACTIONS(3160),
    [anon_sym_requires] = ACTIONS(3160),
    [sym_this] = ACTIONS(3160),
  },
  [705] = {
    [sym_identifier] = ACTIONS(3101),
    [aux_sym_preproc_include_token1] = ACTIONS(3101),
    [aux_sym_preproc_def_token1] = ACTIONS(3101),
    [aux_sym_preproc_if_token1] = ACTIONS(3101),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3101),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3101),
    [sym_preproc_directive] = ACTIONS(3101),
    [anon_sym_LPAREN2] = ACTIONS(3103),
    [anon_sym_BANG] = ACTIONS(3103),
    [anon_sym_TILDE] = ACTIONS(3103),
    [anon_sym_DASH] = ACTIONS(3101),
    [anon_sym_PLUS] = ACTIONS(3101),
    [anon_sym_STAR] = ACTIONS(3103),
    [anon_sym_AMP_AMP] = ACTIONS(3103),
    [anon_sym_AMP] = ACTIONS(3101),
    [anon_sym_SEMI] = ACTIONS(3103),
    [anon_sym___extension__] = ACTIONS(3101),
    [anon_sym_typedef] = ACTIONS(3101),
    [anon_sym_extern] = ACTIONS(3101),
    [anon_sym___attribute__] = ACTIONS(3101),
    [anon_sym_COLON_COLON] = ACTIONS(3103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3103),
    [anon_sym___declspec] = ACTIONS(3101),
    [anon_sym___based] = ACTIONS(3101),
    [anon_sym___cdecl] = ACTIONS(3101),
    [anon_sym___clrcall] = ACTIONS(3101),
    [anon_sym___stdcall] = ACTIONS(3101),
    [anon_sym___fastcall] = ACTIONS(3101),
    [anon_sym___thiscall] = ACTIONS(3101),
    [anon_sym___vectorcall] = ACTIONS(3101),
    [anon_sym_LBRACE] = ACTIONS(3103),
    [anon_sym_RBRACE] = ACTIONS(3103),
    [anon_sym_signed] = ACTIONS(3101),
    [anon_sym_unsigned] = ACTIONS(3101),
    [anon_sym_long] = ACTIONS(3101),
    [anon_sym_short] = ACTIONS(3101),
    [anon_sym_LBRACK] = ACTIONS(3101),
    [anon_sym_static] = ACTIONS(3101),
    [anon_sym_register] = ACTIONS(3101),
    [anon_sym_inline] = ACTIONS(3101),
    [anon_sym___inline] = ACTIONS(3101),
    [anon_sym___inline__] = ACTIONS(3101),
    [anon_sym___forceinline] = ACTIONS(3101),
    [anon_sym_thread_local] = ACTIONS(3101),
    [anon_sym___thread] = ACTIONS(3101),
    [anon_sym_const] = ACTIONS(3101),
    [anon_sym_constexpr] = ACTIONS(3101),
    [anon_sym_volatile] = ACTIONS(3101),
    [anon_sym_restrict] = ACTIONS(3101),
    [anon_sym___restrict__] = ACTIONS(3101),
    [anon_sym__Atomic] = ACTIONS(3101),
    [anon_sym__Noreturn] = ACTIONS(3101),
    [anon_sym_noreturn] = ACTIONS(3101),
    [anon_sym_mutable] = ACTIONS(3101),
    [anon_sym_constinit] = ACTIONS(3101),
    [anon_sym_consteval] = ACTIONS(3101),
    [anon_sym_PROGMEM] = ACTIONS(3101),
    [aux_sym_primitive_type_token1] = ACTIONS(3101),
    [anon_sym_byte] = ACTIONS(3101),
    [anon_sym_word] = ACTIONS(3101),
    [anon_sym_enum] = ACTIONS(3101),
    [anon_sym_class] = ACTIONS(3101),
    [anon_sym_struct] = ACTIONS(3101),
    [anon_sym_union] = ACTIONS(3101),
    [anon_sym_if] = ACTIONS(3101),
    [anon_sym_switch] = ACTIONS(3101),
    [anon_sym_case] = ACTIONS(3101),
    [anon_sym_default] = ACTIONS(3101),
    [anon_sym_while] = ACTIONS(3101),
    [anon_sym_do] = ACTIONS(3101),
    [anon_sym_for] = ACTIONS(3101),
    [anon_sym_return] = ACTIONS(3101),
    [anon_sym_break] = ACTIONS(3101),
    [anon_sym_continue] = ACTIONS(3101),
    [anon_sym_goto] = ACTIONS(3101),
    [anon_sym___try] = ACTIONS(3101),
    [anon_sym___leave] = ACTIONS(3101),
    [anon_sym_not] = ACTIONS(3101),
    [anon_sym_compl] = ACTIONS(3101),
    [anon_sym_DASH_DASH] = ACTIONS(3103),
    [anon_sym_PLUS_PLUS] = ACTIONS(3103),
    [anon_sym_sizeof] = ACTIONS(3101),
    [anon_sym___alignof__] = ACTIONS(3101),
    [anon_sym___alignof] = ACTIONS(3101),
    [anon_sym__alignof] = ACTIONS(3101),
    [anon_sym_alignof] = ACTIONS(3101),
    [anon_sym__Alignof] = ACTIONS(3101),
    [anon_sym_offsetof] = ACTIONS(3101),
    [anon_sym__Generic] = ACTIONS(3101),
    [anon_sym_asm] = ACTIONS(3101),
    [anon_sym___asm__] = ACTIONS(3101),
    [aux_sym_number_literal_token1] = ACTIONS(3103),
    [aux_sym_number_literal_token2] = ACTIONS(3101),
    [anon_sym_L_SQUOTE] = ACTIONS(3103),
    [anon_sym_u_SQUOTE] = ACTIONS(3103),
    [anon_sym_U_SQUOTE] = ACTIONS(3103),
    [anon_sym_u8_SQUOTE] = ACTIONS(3103),
    [anon_sym_SQUOTE] = ACTIONS(3103),
    [anon_sym_L_DQUOTE] = ACTIONS(3103),
    [anon_sym_u_DQUOTE] = ACTIONS(3103),
    [anon_sym_U_DQUOTE] = ACTIONS(3103),
    [anon_sym_u8_DQUOTE] = ACTIONS(3103),
    [anon_sym_DQUOTE] = ACTIONS(3103),
    [sym_true] = ACTIONS(3101),
    [sym_false] = ACTIONS(3101),
    [anon_sym_NULL] = ACTIONS(3101),
    [anon_sym_nullptr] = ACTIONS(3101),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3101),
    [anon_sym_decltype] = ACTIONS(3101),
    [anon_sym_virtual] = ACTIONS(3101),
    [anon_sym_alignas] = ACTIONS(3101),
    [anon_sym_explicit] = ACTIONS(3101),
    [anon_sym_typename] = ACTIONS(3101),
    [anon_sym_template] = ACTIONS(3101),
    [anon_sym_operator] = ACTIONS(3101),
    [anon_sym_try] = ACTIONS(3101),
    [anon_sym_delete] = ACTIONS(3101),
    [anon_sym_throw] = ACTIONS(3101),
    [anon_sym_namespace] = ACTIONS(3101),
    [anon_sym_using] = ACTIONS(3101),
    [anon_sym_static_assert] = ACTIONS(3101),
    [anon_sym_concept] = ACTIONS(3101),
    [anon_sym_co_return] = ACTIONS(3101),
    [anon_sym_co_yield] = ACTIONS(3101),
    [anon_sym_R_DQUOTE] = ACTIONS(3103),
    [anon_sym_LR_DQUOTE] = ACTIONS(3103),
    [anon_sym_uR_DQUOTE] = ACTIONS(3103),
    [anon_sym_UR_DQUOTE] = ACTIONS(3103),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3103),
    [anon_sym_co_await] = ACTIONS(3101),
    [anon_sym_new] = ACTIONS(3101),
    [anon_sym_requires] = ACTIONS(3101),
    [sym_this] = ACTIONS(3101),
  },
  [706] = {
    [sym_identifier] = ACTIONS(3002),
    [aux_sym_preproc_include_token1] = ACTIONS(3002),
    [aux_sym_preproc_def_token1] = ACTIONS(3002),
    [aux_sym_preproc_if_token1] = ACTIONS(3002),
    [aux_sym_preproc_if_token2] = ACTIONS(3002),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3002),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3002),
    [sym_preproc_directive] = ACTIONS(3002),
    [anon_sym_LPAREN2] = ACTIONS(3004),
    [anon_sym_BANG] = ACTIONS(3004),
    [anon_sym_TILDE] = ACTIONS(3004),
    [anon_sym_DASH] = ACTIONS(3002),
    [anon_sym_PLUS] = ACTIONS(3002),
    [anon_sym_STAR] = ACTIONS(3004),
    [anon_sym_AMP_AMP] = ACTIONS(3004),
    [anon_sym_AMP] = ACTIONS(3002),
    [anon_sym_SEMI] = ACTIONS(3004),
    [anon_sym___extension__] = ACTIONS(3002),
    [anon_sym_typedef] = ACTIONS(3002),
    [anon_sym_extern] = ACTIONS(3002),
    [anon_sym___attribute__] = ACTIONS(3002),
    [anon_sym_COLON_COLON] = ACTIONS(3004),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3004),
    [anon_sym___declspec] = ACTIONS(3002),
    [anon_sym___based] = ACTIONS(3002),
    [anon_sym___cdecl] = ACTIONS(3002),
    [anon_sym___clrcall] = ACTIONS(3002),
    [anon_sym___stdcall] = ACTIONS(3002),
    [anon_sym___fastcall] = ACTIONS(3002),
    [anon_sym___thiscall] = ACTIONS(3002),
    [anon_sym___vectorcall] = ACTIONS(3002),
    [anon_sym_LBRACE] = ACTIONS(3004),
    [anon_sym_signed] = ACTIONS(3002),
    [anon_sym_unsigned] = ACTIONS(3002),
    [anon_sym_long] = ACTIONS(3002),
    [anon_sym_short] = ACTIONS(3002),
    [anon_sym_LBRACK] = ACTIONS(3002),
    [anon_sym_static] = ACTIONS(3002),
    [anon_sym_register] = ACTIONS(3002),
    [anon_sym_inline] = ACTIONS(3002),
    [anon_sym___inline] = ACTIONS(3002),
    [anon_sym___inline__] = ACTIONS(3002),
    [anon_sym___forceinline] = ACTIONS(3002),
    [anon_sym_thread_local] = ACTIONS(3002),
    [anon_sym___thread] = ACTIONS(3002),
    [anon_sym_const] = ACTIONS(3002),
    [anon_sym_constexpr] = ACTIONS(3002),
    [anon_sym_volatile] = ACTIONS(3002),
    [anon_sym_restrict] = ACTIONS(3002),
    [anon_sym___restrict__] = ACTIONS(3002),
    [anon_sym__Atomic] = ACTIONS(3002),
    [anon_sym__Noreturn] = ACTIONS(3002),
    [anon_sym_noreturn] = ACTIONS(3002),
    [anon_sym_mutable] = ACTIONS(3002),
    [anon_sym_constinit] = ACTIONS(3002),
    [anon_sym_consteval] = ACTIONS(3002),
    [anon_sym_PROGMEM] = ACTIONS(3002),
    [aux_sym_primitive_type_token1] = ACTIONS(3002),
    [anon_sym_byte] = ACTIONS(3002),
    [anon_sym_word] = ACTIONS(3002),
    [anon_sym_enum] = ACTIONS(3002),
    [anon_sym_class] = ACTIONS(3002),
    [anon_sym_struct] = ACTIONS(3002),
    [anon_sym_union] = ACTIONS(3002),
    [anon_sym_if] = ACTIONS(3002),
    [anon_sym_switch] = ACTIONS(3002),
    [anon_sym_case] = ACTIONS(3002),
    [anon_sym_default] = ACTIONS(3002),
    [anon_sym_while] = ACTIONS(3002),
    [anon_sym_do] = ACTIONS(3002),
    [anon_sym_for] = ACTIONS(3002),
    [anon_sym_return] = ACTIONS(3002),
    [anon_sym_break] = ACTIONS(3002),
    [anon_sym_continue] = ACTIONS(3002),
    [anon_sym_goto] = ACTIONS(3002),
    [anon_sym___try] = ACTIONS(3002),
    [anon_sym___leave] = ACTIONS(3002),
    [anon_sym_not] = ACTIONS(3002),
    [anon_sym_compl] = ACTIONS(3002),
    [anon_sym_DASH_DASH] = ACTIONS(3004),
    [anon_sym_PLUS_PLUS] = ACTIONS(3004),
    [anon_sym_sizeof] = ACTIONS(3002),
    [anon_sym___alignof__] = ACTIONS(3002),
    [anon_sym___alignof] = ACTIONS(3002),
    [anon_sym__alignof] = ACTIONS(3002),
    [anon_sym_alignof] = ACTIONS(3002),
    [anon_sym__Alignof] = ACTIONS(3002),
    [anon_sym_offsetof] = ACTIONS(3002),
    [anon_sym__Generic] = ACTIONS(3002),
    [anon_sym_asm] = ACTIONS(3002),
    [anon_sym___asm__] = ACTIONS(3002),
    [aux_sym_number_literal_token1] = ACTIONS(3004),
    [aux_sym_number_literal_token2] = ACTIONS(3002),
    [anon_sym_L_SQUOTE] = ACTIONS(3004),
    [anon_sym_u_SQUOTE] = ACTIONS(3004),
    [anon_sym_U_SQUOTE] = ACTIONS(3004),
    [anon_sym_u8_SQUOTE] = ACTIONS(3004),
    [anon_sym_SQUOTE] = ACTIONS(3004),
    [anon_sym_L_DQUOTE] = ACTIONS(3004),
    [anon_sym_u_DQUOTE] = ACTIONS(3004),
    [anon_sym_U_DQUOTE] = ACTIONS(3004),
    [anon_sym_u8_DQUOTE] = ACTIONS(3004),
    [anon_sym_DQUOTE] = ACTIONS(3004),
    [sym_true] = ACTIONS(3002),
    [sym_false] = ACTIONS(3002),
    [anon_sym_NULL] = ACTIONS(3002),
    [anon_sym_nullptr] = ACTIONS(3002),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3002),
    [anon_sym_decltype] = ACTIONS(3002),
    [anon_sym_virtual] = ACTIONS(3002),
    [anon_sym_alignas] = ACTIONS(3002),
    [anon_sym_explicit] = ACTIONS(3002),
    [anon_sym_typename] = ACTIONS(3002),
    [anon_sym_template] = ACTIONS(3002),
    [anon_sym_operator] = ACTIONS(3002),
    [anon_sym_try] = ACTIONS(3002),
    [anon_sym_delete] = ACTIONS(3002),
    [anon_sym_throw] = ACTIONS(3002),
    [anon_sym_namespace] = ACTIONS(3002),
    [anon_sym_using] = ACTIONS(3002),
    [anon_sym_static_assert] = ACTIONS(3002),
    [anon_sym_concept] = ACTIONS(3002),
    [anon_sym_co_return] = ACTIONS(3002),
    [anon_sym_co_yield] = ACTIONS(3002),
    [anon_sym_R_DQUOTE] = ACTIONS(3004),
    [anon_sym_LR_DQUOTE] = ACTIONS(3004),
    [anon_sym_uR_DQUOTE] = ACTIONS(3004),
    [anon_sym_UR_DQUOTE] = ACTIONS(3004),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3004),
    [anon_sym_co_await] = ACTIONS(3002),
    [anon_sym_new] = ACTIONS(3002),
    [anon_sym_requires] = ACTIONS(3002),
    [sym_this] = ACTIONS(3002),
  },
  [707] = {
    [sym_identifier] = ACTIONS(3174),
    [aux_sym_preproc_include_token1] = ACTIONS(3174),
    [aux_sym_preproc_def_token1] = ACTIONS(3174),
    [aux_sym_preproc_if_token1] = ACTIONS(3174),
    [aux_sym_preproc_if_token2] = ACTIONS(3174),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3174),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3174),
    [sym_preproc_directive] = ACTIONS(3174),
    [anon_sym_LPAREN2] = ACTIONS(3176),
    [anon_sym_BANG] = ACTIONS(3176),
    [anon_sym_TILDE] = ACTIONS(3176),
    [anon_sym_DASH] = ACTIONS(3174),
    [anon_sym_PLUS] = ACTIONS(3174),
    [anon_sym_STAR] = ACTIONS(3176),
    [anon_sym_AMP_AMP] = ACTIONS(3176),
    [anon_sym_AMP] = ACTIONS(3174),
    [anon_sym_SEMI] = ACTIONS(3176),
    [anon_sym___extension__] = ACTIONS(3174),
    [anon_sym_typedef] = ACTIONS(3174),
    [anon_sym_extern] = ACTIONS(3174),
    [anon_sym___attribute__] = ACTIONS(3174),
    [anon_sym_COLON_COLON] = ACTIONS(3176),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3176),
    [anon_sym___declspec] = ACTIONS(3174),
    [anon_sym___based] = ACTIONS(3174),
    [anon_sym___cdecl] = ACTIONS(3174),
    [anon_sym___clrcall] = ACTIONS(3174),
    [anon_sym___stdcall] = ACTIONS(3174),
    [anon_sym___fastcall] = ACTIONS(3174),
    [anon_sym___thiscall] = ACTIONS(3174),
    [anon_sym___vectorcall] = ACTIONS(3174),
    [anon_sym_LBRACE] = ACTIONS(3176),
    [anon_sym_signed] = ACTIONS(3174),
    [anon_sym_unsigned] = ACTIONS(3174),
    [anon_sym_long] = ACTIONS(3174),
    [anon_sym_short] = ACTIONS(3174),
    [anon_sym_LBRACK] = ACTIONS(3174),
    [anon_sym_static] = ACTIONS(3174),
    [anon_sym_register] = ACTIONS(3174),
    [anon_sym_inline] = ACTIONS(3174),
    [anon_sym___inline] = ACTIONS(3174),
    [anon_sym___inline__] = ACTIONS(3174),
    [anon_sym___forceinline] = ACTIONS(3174),
    [anon_sym_thread_local] = ACTIONS(3174),
    [anon_sym___thread] = ACTIONS(3174),
    [anon_sym_const] = ACTIONS(3174),
    [anon_sym_constexpr] = ACTIONS(3174),
    [anon_sym_volatile] = ACTIONS(3174),
    [anon_sym_restrict] = ACTIONS(3174),
    [anon_sym___restrict__] = ACTIONS(3174),
    [anon_sym__Atomic] = ACTIONS(3174),
    [anon_sym__Noreturn] = ACTIONS(3174),
    [anon_sym_noreturn] = ACTIONS(3174),
    [anon_sym_mutable] = ACTIONS(3174),
    [anon_sym_constinit] = ACTIONS(3174),
    [anon_sym_consteval] = ACTIONS(3174),
    [anon_sym_PROGMEM] = ACTIONS(3174),
    [aux_sym_primitive_type_token1] = ACTIONS(3174),
    [anon_sym_byte] = ACTIONS(3174),
    [anon_sym_word] = ACTIONS(3174),
    [anon_sym_enum] = ACTIONS(3174),
    [anon_sym_class] = ACTIONS(3174),
    [anon_sym_struct] = ACTIONS(3174),
    [anon_sym_union] = ACTIONS(3174),
    [anon_sym_if] = ACTIONS(3174),
    [anon_sym_switch] = ACTIONS(3174),
    [anon_sym_case] = ACTIONS(3174),
    [anon_sym_default] = ACTIONS(3174),
    [anon_sym_while] = ACTIONS(3174),
    [anon_sym_do] = ACTIONS(3174),
    [anon_sym_for] = ACTIONS(3174),
    [anon_sym_return] = ACTIONS(3174),
    [anon_sym_break] = ACTIONS(3174),
    [anon_sym_continue] = ACTIONS(3174),
    [anon_sym_goto] = ACTIONS(3174),
    [anon_sym___try] = ACTIONS(3174),
    [anon_sym___leave] = ACTIONS(3174),
    [anon_sym_not] = ACTIONS(3174),
    [anon_sym_compl] = ACTIONS(3174),
    [anon_sym_DASH_DASH] = ACTIONS(3176),
    [anon_sym_PLUS_PLUS] = ACTIONS(3176),
    [anon_sym_sizeof] = ACTIONS(3174),
    [anon_sym___alignof__] = ACTIONS(3174),
    [anon_sym___alignof] = ACTIONS(3174),
    [anon_sym__alignof] = ACTIONS(3174),
    [anon_sym_alignof] = ACTIONS(3174),
    [anon_sym__Alignof] = ACTIONS(3174),
    [anon_sym_offsetof] = ACTIONS(3174),
    [anon_sym__Generic] = ACTIONS(3174),
    [anon_sym_asm] = ACTIONS(3174),
    [anon_sym___asm__] = ACTIONS(3174),
    [aux_sym_number_literal_token1] = ACTIONS(3176),
    [aux_sym_number_literal_token2] = ACTIONS(3174),
    [anon_sym_L_SQUOTE] = ACTIONS(3176),
    [anon_sym_u_SQUOTE] = ACTIONS(3176),
    [anon_sym_U_SQUOTE] = ACTIONS(3176),
    [anon_sym_u8_SQUOTE] = ACTIONS(3176),
    [anon_sym_SQUOTE] = ACTIONS(3176),
    [anon_sym_L_DQUOTE] = ACTIONS(3176),
    [anon_sym_u_DQUOTE] = ACTIONS(3176),
    [anon_sym_U_DQUOTE] = ACTIONS(3176),
    [anon_sym_u8_DQUOTE] = ACTIONS(3176),
    [anon_sym_DQUOTE] = ACTIONS(3176),
    [sym_true] = ACTIONS(3174),
    [sym_false] = ACTIONS(3174),
    [anon_sym_NULL] = ACTIONS(3174),
    [anon_sym_nullptr] = ACTIONS(3174),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3174),
    [anon_sym_decltype] = ACTIONS(3174),
    [anon_sym_virtual] = ACTIONS(3174),
    [anon_sym_alignas] = ACTIONS(3174),
    [anon_sym_explicit] = ACTIONS(3174),
    [anon_sym_typename] = ACTIONS(3174),
    [anon_sym_template] = ACTIONS(3174),
    [anon_sym_operator] = ACTIONS(3174),
    [anon_sym_try] = ACTIONS(3174),
    [anon_sym_delete] = ACTIONS(3174),
    [anon_sym_throw] = ACTIONS(3174),
    [anon_sym_namespace] = ACTIONS(3174),
    [anon_sym_using] = ACTIONS(3174),
    [anon_sym_static_assert] = ACTIONS(3174),
    [anon_sym_concept] = ACTIONS(3174),
    [anon_sym_co_return] = ACTIONS(3174),
    [anon_sym_co_yield] = ACTIONS(3174),
    [anon_sym_R_DQUOTE] = ACTIONS(3176),
    [anon_sym_LR_DQUOTE] = ACTIONS(3176),
    [anon_sym_uR_DQUOTE] = ACTIONS(3176),
    [anon_sym_UR_DQUOTE] = ACTIONS(3176),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3176),
    [anon_sym_co_await] = ACTIONS(3174),
    [anon_sym_new] = ACTIONS(3174),
    [anon_sym_requires] = ACTIONS(3174),
    [sym_this] = ACTIONS(3174),
  },
  [708] = {
    [sym_identifier] = ACTIONS(2975),
    [aux_sym_preproc_include_token1] = ACTIONS(2975),
    [aux_sym_preproc_def_token1] = ACTIONS(2975),
    [aux_sym_preproc_if_token1] = ACTIONS(2975),
    [aux_sym_preproc_if_token2] = ACTIONS(2975),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2975),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2975),
    [sym_preproc_directive] = ACTIONS(2975),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_BANG] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2975),
    [anon_sym_PLUS] = ACTIONS(2975),
    [anon_sym_STAR] = ACTIONS(2977),
    [anon_sym_AMP_AMP] = ACTIONS(2977),
    [anon_sym_AMP] = ACTIONS(2975),
    [anon_sym_SEMI] = ACTIONS(2977),
    [anon_sym___extension__] = ACTIONS(2975),
    [anon_sym_typedef] = ACTIONS(2975),
    [anon_sym_extern] = ACTIONS(2975),
    [anon_sym___attribute__] = ACTIONS(2975),
    [anon_sym_COLON_COLON] = ACTIONS(2977),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2977),
    [anon_sym___declspec] = ACTIONS(2975),
    [anon_sym___based] = ACTIONS(2975),
    [anon_sym___cdecl] = ACTIONS(2975),
    [anon_sym___clrcall] = ACTIONS(2975),
    [anon_sym___stdcall] = ACTIONS(2975),
    [anon_sym___fastcall] = ACTIONS(2975),
    [anon_sym___thiscall] = ACTIONS(2975),
    [anon_sym___vectorcall] = ACTIONS(2975),
    [anon_sym_LBRACE] = ACTIONS(2977),
    [anon_sym_signed] = ACTIONS(2975),
    [anon_sym_unsigned] = ACTIONS(2975),
    [anon_sym_long] = ACTIONS(2975),
    [anon_sym_short] = ACTIONS(2975),
    [anon_sym_LBRACK] = ACTIONS(2975),
    [anon_sym_static] = ACTIONS(2975),
    [anon_sym_register] = ACTIONS(2975),
    [anon_sym_inline] = ACTIONS(2975),
    [anon_sym___inline] = ACTIONS(2975),
    [anon_sym___inline__] = ACTIONS(2975),
    [anon_sym___forceinline] = ACTIONS(2975),
    [anon_sym_thread_local] = ACTIONS(2975),
    [anon_sym___thread] = ACTIONS(2975),
    [anon_sym_const] = ACTIONS(2975),
    [anon_sym_constexpr] = ACTIONS(2975),
    [anon_sym_volatile] = ACTIONS(2975),
    [anon_sym_restrict] = ACTIONS(2975),
    [anon_sym___restrict__] = ACTIONS(2975),
    [anon_sym__Atomic] = ACTIONS(2975),
    [anon_sym__Noreturn] = ACTIONS(2975),
    [anon_sym_noreturn] = ACTIONS(2975),
    [anon_sym_mutable] = ACTIONS(2975),
    [anon_sym_constinit] = ACTIONS(2975),
    [anon_sym_consteval] = ACTIONS(2975),
    [anon_sym_PROGMEM] = ACTIONS(2975),
    [aux_sym_primitive_type_token1] = ACTIONS(2975),
    [anon_sym_byte] = ACTIONS(2975),
    [anon_sym_word] = ACTIONS(2975),
    [anon_sym_enum] = ACTIONS(2975),
    [anon_sym_class] = ACTIONS(2975),
    [anon_sym_struct] = ACTIONS(2975),
    [anon_sym_union] = ACTIONS(2975),
    [anon_sym_if] = ACTIONS(2975),
    [anon_sym_switch] = ACTIONS(2975),
    [anon_sym_case] = ACTIONS(2975),
    [anon_sym_default] = ACTIONS(2975),
    [anon_sym_while] = ACTIONS(2975),
    [anon_sym_do] = ACTIONS(2975),
    [anon_sym_for] = ACTIONS(2975),
    [anon_sym_return] = ACTIONS(2975),
    [anon_sym_break] = ACTIONS(2975),
    [anon_sym_continue] = ACTIONS(2975),
    [anon_sym_goto] = ACTIONS(2975),
    [anon_sym___try] = ACTIONS(2975),
    [anon_sym___leave] = ACTIONS(2975),
    [anon_sym_not] = ACTIONS(2975),
    [anon_sym_compl] = ACTIONS(2975),
    [anon_sym_DASH_DASH] = ACTIONS(2977),
    [anon_sym_PLUS_PLUS] = ACTIONS(2977),
    [anon_sym_sizeof] = ACTIONS(2975),
    [anon_sym___alignof__] = ACTIONS(2975),
    [anon_sym___alignof] = ACTIONS(2975),
    [anon_sym__alignof] = ACTIONS(2975),
    [anon_sym_alignof] = ACTIONS(2975),
    [anon_sym__Alignof] = ACTIONS(2975),
    [anon_sym_offsetof] = ACTIONS(2975),
    [anon_sym__Generic] = ACTIONS(2975),
    [anon_sym_asm] = ACTIONS(2975),
    [anon_sym___asm__] = ACTIONS(2975),
    [aux_sym_number_literal_token1] = ACTIONS(2977),
    [aux_sym_number_literal_token2] = ACTIONS(2975),
    [anon_sym_L_SQUOTE] = ACTIONS(2977),
    [anon_sym_u_SQUOTE] = ACTIONS(2977),
    [anon_sym_U_SQUOTE] = ACTIONS(2977),
    [anon_sym_u8_SQUOTE] = ACTIONS(2977),
    [anon_sym_SQUOTE] = ACTIONS(2977),
    [anon_sym_L_DQUOTE] = ACTIONS(2977),
    [anon_sym_u_DQUOTE] = ACTIONS(2977),
    [anon_sym_U_DQUOTE] = ACTIONS(2977),
    [anon_sym_u8_DQUOTE] = ACTIONS(2977),
    [anon_sym_DQUOTE] = ACTIONS(2977),
    [sym_true] = ACTIONS(2975),
    [sym_false] = ACTIONS(2975),
    [anon_sym_NULL] = ACTIONS(2975),
    [anon_sym_nullptr] = ACTIONS(2975),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2975),
    [anon_sym_decltype] = ACTIONS(2975),
    [anon_sym_virtual] = ACTIONS(2975),
    [anon_sym_alignas] = ACTIONS(2975),
    [anon_sym_explicit] = ACTIONS(2975),
    [anon_sym_typename] = ACTIONS(2975),
    [anon_sym_template] = ACTIONS(2975),
    [anon_sym_operator] = ACTIONS(2975),
    [anon_sym_try] = ACTIONS(2975),
    [anon_sym_delete] = ACTIONS(2975),
    [anon_sym_throw] = ACTIONS(2975),
    [anon_sym_namespace] = ACTIONS(2975),
    [anon_sym_using] = ACTIONS(2975),
    [anon_sym_static_assert] = ACTIONS(2975),
    [anon_sym_concept] = ACTIONS(2975),
    [anon_sym_co_return] = ACTIONS(2975),
    [anon_sym_co_yield] = ACTIONS(2975),
    [anon_sym_R_DQUOTE] = ACTIONS(2977),
    [anon_sym_LR_DQUOTE] = ACTIONS(2977),
    [anon_sym_uR_DQUOTE] = ACTIONS(2977),
    [anon_sym_UR_DQUOTE] = ACTIONS(2977),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2977),
    [anon_sym_co_await] = ACTIONS(2975),
    [anon_sym_new] = ACTIONS(2975),
    [anon_sym_requires] = ACTIONS(2975),
    [sym_this] = ACTIONS(2975),
  },
  [709] = {
    [sym_identifier] = ACTIONS(3111),
    [aux_sym_preproc_include_token1] = ACTIONS(3111),
    [aux_sym_preproc_def_token1] = ACTIONS(3111),
    [aux_sym_preproc_if_token1] = ACTIONS(3111),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3111),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3111),
    [sym_preproc_directive] = ACTIONS(3111),
    [anon_sym_LPAREN2] = ACTIONS(3113),
    [anon_sym_BANG] = ACTIONS(3113),
    [anon_sym_TILDE] = ACTIONS(3113),
    [anon_sym_DASH] = ACTIONS(3111),
    [anon_sym_PLUS] = ACTIONS(3111),
    [anon_sym_STAR] = ACTIONS(3113),
    [anon_sym_AMP_AMP] = ACTIONS(3113),
    [anon_sym_AMP] = ACTIONS(3111),
    [anon_sym_SEMI] = ACTIONS(3113),
    [anon_sym___extension__] = ACTIONS(3111),
    [anon_sym_typedef] = ACTIONS(3111),
    [anon_sym_extern] = ACTIONS(3111),
    [anon_sym___attribute__] = ACTIONS(3111),
    [anon_sym_COLON_COLON] = ACTIONS(3113),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3113),
    [anon_sym___declspec] = ACTIONS(3111),
    [anon_sym___based] = ACTIONS(3111),
    [anon_sym___cdecl] = ACTIONS(3111),
    [anon_sym___clrcall] = ACTIONS(3111),
    [anon_sym___stdcall] = ACTIONS(3111),
    [anon_sym___fastcall] = ACTIONS(3111),
    [anon_sym___thiscall] = ACTIONS(3111),
    [anon_sym___vectorcall] = ACTIONS(3111),
    [anon_sym_LBRACE] = ACTIONS(3113),
    [anon_sym_RBRACE] = ACTIONS(3113),
    [anon_sym_signed] = ACTIONS(3111),
    [anon_sym_unsigned] = ACTIONS(3111),
    [anon_sym_long] = ACTIONS(3111),
    [anon_sym_short] = ACTIONS(3111),
    [anon_sym_LBRACK] = ACTIONS(3111),
    [anon_sym_static] = ACTIONS(3111),
    [anon_sym_register] = ACTIONS(3111),
    [anon_sym_inline] = ACTIONS(3111),
    [anon_sym___inline] = ACTIONS(3111),
    [anon_sym___inline__] = ACTIONS(3111),
    [anon_sym___forceinline] = ACTIONS(3111),
    [anon_sym_thread_local] = ACTIONS(3111),
    [anon_sym___thread] = ACTIONS(3111),
    [anon_sym_const] = ACTIONS(3111),
    [anon_sym_constexpr] = ACTIONS(3111),
    [anon_sym_volatile] = ACTIONS(3111),
    [anon_sym_restrict] = ACTIONS(3111),
    [anon_sym___restrict__] = ACTIONS(3111),
    [anon_sym__Atomic] = ACTIONS(3111),
    [anon_sym__Noreturn] = ACTIONS(3111),
    [anon_sym_noreturn] = ACTIONS(3111),
    [anon_sym_mutable] = ACTIONS(3111),
    [anon_sym_constinit] = ACTIONS(3111),
    [anon_sym_consteval] = ACTIONS(3111),
    [anon_sym_PROGMEM] = ACTIONS(3111),
    [aux_sym_primitive_type_token1] = ACTIONS(3111),
    [anon_sym_byte] = ACTIONS(3111),
    [anon_sym_word] = ACTIONS(3111),
    [anon_sym_enum] = ACTIONS(3111),
    [anon_sym_class] = ACTIONS(3111),
    [anon_sym_struct] = ACTIONS(3111),
    [anon_sym_union] = ACTIONS(3111),
    [anon_sym_if] = ACTIONS(3111),
    [anon_sym_switch] = ACTIONS(3111),
    [anon_sym_case] = ACTIONS(3111),
    [anon_sym_default] = ACTIONS(3111),
    [anon_sym_while] = ACTIONS(3111),
    [anon_sym_do] = ACTIONS(3111),
    [anon_sym_for] = ACTIONS(3111),
    [anon_sym_return] = ACTIONS(3111),
    [anon_sym_break] = ACTIONS(3111),
    [anon_sym_continue] = ACTIONS(3111),
    [anon_sym_goto] = ACTIONS(3111),
    [anon_sym___try] = ACTIONS(3111),
    [anon_sym___leave] = ACTIONS(3111),
    [anon_sym_not] = ACTIONS(3111),
    [anon_sym_compl] = ACTIONS(3111),
    [anon_sym_DASH_DASH] = ACTIONS(3113),
    [anon_sym_PLUS_PLUS] = ACTIONS(3113),
    [anon_sym_sizeof] = ACTIONS(3111),
    [anon_sym___alignof__] = ACTIONS(3111),
    [anon_sym___alignof] = ACTIONS(3111),
    [anon_sym__alignof] = ACTIONS(3111),
    [anon_sym_alignof] = ACTIONS(3111),
    [anon_sym__Alignof] = ACTIONS(3111),
    [anon_sym_offsetof] = ACTIONS(3111),
    [anon_sym__Generic] = ACTIONS(3111),
    [anon_sym_asm] = ACTIONS(3111),
    [anon_sym___asm__] = ACTIONS(3111),
    [aux_sym_number_literal_token1] = ACTIONS(3113),
    [aux_sym_number_literal_token2] = ACTIONS(3111),
    [anon_sym_L_SQUOTE] = ACTIONS(3113),
    [anon_sym_u_SQUOTE] = ACTIONS(3113),
    [anon_sym_U_SQUOTE] = ACTIONS(3113),
    [anon_sym_u8_SQUOTE] = ACTIONS(3113),
    [anon_sym_SQUOTE] = ACTIONS(3113),
    [anon_sym_L_DQUOTE] = ACTIONS(3113),
    [anon_sym_u_DQUOTE] = ACTIONS(3113),
    [anon_sym_U_DQUOTE] = ACTIONS(3113),
    [anon_sym_u8_DQUOTE] = ACTIONS(3113),
    [anon_sym_DQUOTE] = ACTIONS(3113),
    [sym_true] = ACTIONS(3111),
    [sym_false] = ACTIONS(3111),
    [anon_sym_NULL] = ACTIONS(3111),
    [anon_sym_nullptr] = ACTIONS(3111),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3111),
    [anon_sym_decltype] = ACTIONS(3111),
    [anon_sym_virtual] = ACTIONS(3111),
    [anon_sym_alignas] = ACTIONS(3111),
    [anon_sym_explicit] = ACTIONS(3111),
    [anon_sym_typename] = ACTIONS(3111),
    [anon_sym_template] = ACTIONS(3111),
    [anon_sym_operator] = ACTIONS(3111),
    [anon_sym_try] = ACTIONS(3111),
    [anon_sym_delete] = ACTIONS(3111),
    [anon_sym_throw] = ACTIONS(3111),
    [anon_sym_namespace] = ACTIONS(3111),
    [anon_sym_using] = ACTIONS(3111),
    [anon_sym_static_assert] = ACTIONS(3111),
    [anon_sym_concept] = ACTIONS(3111),
    [anon_sym_co_return] = ACTIONS(3111),
    [anon_sym_co_yield] = ACTIONS(3111),
    [anon_sym_R_DQUOTE] = ACTIONS(3113),
    [anon_sym_LR_DQUOTE] = ACTIONS(3113),
    [anon_sym_uR_DQUOTE] = ACTIONS(3113),
    [anon_sym_UR_DQUOTE] = ACTIONS(3113),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3113),
    [anon_sym_co_await] = ACTIONS(3111),
    [anon_sym_new] = ACTIONS(3111),
    [anon_sym_requires] = ACTIONS(3111),
    [sym_this] = ACTIONS(3111),
  },
  [710] = {
    [sym_identifier] = ACTIONS(2971),
    [aux_sym_preproc_include_token1] = ACTIONS(2971),
    [aux_sym_preproc_def_token1] = ACTIONS(2971),
    [aux_sym_preproc_if_token1] = ACTIONS(2971),
    [aux_sym_preproc_if_token2] = ACTIONS(2971),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2971),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2971),
    [sym_preproc_directive] = ACTIONS(2971),
    [anon_sym_LPAREN2] = ACTIONS(2973),
    [anon_sym_BANG] = ACTIONS(2973),
    [anon_sym_TILDE] = ACTIONS(2973),
    [anon_sym_DASH] = ACTIONS(2971),
    [anon_sym_PLUS] = ACTIONS(2971),
    [anon_sym_STAR] = ACTIONS(2973),
    [anon_sym_AMP_AMP] = ACTIONS(2973),
    [anon_sym_AMP] = ACTIONS(2971),
    [anon_sym_SEMI] = ACTIONS(2973),
    [anon_sym___extension__] = ACTIONS(2971),
    [anon_sym_typedef] = ACTIONS(2971),
    [anon_sym_extern] = ACTIONS(2971),
    [anon_sym___attribute__] = ACTIONS(2971),
    [anon_sym_COLON_COLON] = ACTIONS(2973),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2973),
    [anon_sym___declspec] = ACTIONS(2971),
    [anon_sym___based] = ACTIONS(2971),
    [anon_sym___cdecl] = ACTIONS(2971),
    [anon_sym___clrcall] = ACTIONS(2971),
    [anon_sym___stdcall] = ACTIONS(2971),
    [anon_sym___fastcall] = ACTIONS(2971),
    [anon_sym___thiscall] = ACTIONS(2971),
    [anon_sym___vectorcall] = ACTIONS(2971),
    [anon_sym_LBRACE] = ACTIONS(2973),
    [anon_sym_signed] = ACTIONS(2971),
    [anon_sym_unsigned] = ACTIONS(2971),
    [anon_sym_long] = ACTIONS(2971),
    [anon_sym_short] = ACTIONS(2971),
    [anon_sym_LBRACK] = ACTIONS(2971),
    [anon_sym_static] = ACTIONS(2971),
    [anon_sym_register] = ACTIONS(2971),
    [anon_sym_inline] = ACTIONS(2971),
    [anon_sym___inline] = ACTIONS(2971),
    [anon_sym___inline__] = ACTIONS(2971),
    [anon_sym___forceinline] = ACTIONS(2971),
    [anon_sym_thread_local] = ACTIONS(2971),
    [anon_sym___thread] = ACTIONS(2971),
    [anon_sym_const] = ACTIONS(2971),
    [anon_sym_constexpr] = ACTIONS(2971),
    [anon_sym_volatile] = ACTIONS(2971),
    [anon_sym_restrict] = ACTIONS(2971),
    [anon_sym___restrict__] = ACTIONS(2971),
    [anon_sym__Atomic] = ACTIONS(2971),
    [anon_sym__Noreturn] = ACTIONS(2971),
    [anon_sym_noreturn] = ACTIONS(2971),
    [anon_sym_mutable] = ACTIONS(2971),
    [anon_sym_constinit] = ACTIONS(2971),
    [anon_sym_consteval] = ACTIONS(2971),
    [anon_sym_PROGMEM] = ACTIONS(2971),
    [aux_sym_primitive_type_token1] = ACTIONS(2971),
    [anon_sym_byte] = ACTIONS(2971),
    [anon_sym_word] = ACTIONS(2971),
    [anon_sym_enum] = ACTIONS(2971),
    [anon_sym_class] = ACTIONS(2971),
    [anon_sym_struct] = ACTIONS(2971),
    [anon_sym_union] = ACTIONS(2971),
    [anon_sym_if] = ACTIONS(2971),
    [anon_sym_switch] = ACTIONS(2971),
    [anon_sym_case] = ACTIONS(2971),
    [anon_sym_default] = ACTIONS(2971),
    [anon_sym_while] = ACTIONS(2971),
    [anon_sym_do] = ACTIONS(2971),
    [anon_sym_for] = ACTIONS(2971),
    [anon_sym_return] = ACTIONS(2971),
    [anon_sym_break] = ACTIONS(2971),
    [anon_sym_continue] = ACTIONS(2971),
    [anon_sym_goto] = ACTIONS(2971),
    [anon_sym___try] = ACTIONS(2971),
    [anon_sym___leave] = ACTIONS(2971),
    [anon_sym_not] = ACTIONS(2971),
    [anon_sym_compl] = ACTIONS(2971),
    [anon_sym_DASH_DASH] = ACTIONS(2973),
    [anon_sym_PLUS_PLUS] = ACTIONS(2973),
    [anon_sym_sizeof] = ACTIONS(2971),
    [anon_sym___alignof__] = ACTIONS(2971),
    [anon_sym___alignof] = ACTIONS(2971),
    [anon_sym__alignof] = ACTIONS(2971),
    [anon_sym_alignof] = ACTIONS(2971),
    [anon_sym__Alignof] = ACTIONS(2971),
    [anon_sym_offsetof] = ACTIONS(2971),
    [anon_sym__Generic] = ACTIONS(2971),
    [anon_sym_asm] = ACTIONS(2971),
    [anon_sym___asm__] = ACTIONS(2971),
    [aux_sym_number_literal_token1] = ACTIONS(2973),
    [aux_sym_number_literal_token2] = ACTIONS(2971),
    [anon_sym_L_SQUOTE] = ACTIONS(2973),
    [anon_sym_u_SQUOTE] = ACTIONS(2973),
    [anon_sym_U_SQUOTE] = ACTIONS(2973),
    [anon_sym_u8_SQUOTE] = ACTIONS(2973),
    [anon_sym_SQUOTE] = ACTIONS(2973),
    [anon_sym_L_DQUOTE] = ACTIONS(2973),
    [anon_sym_u_DQUOTE] = ACTIONS(2973),
    [anon_sym_U_DQUOTE] = ACTIONS(2973),
    [anon_sym_u8_DQUOTE] = ACTIONS(2973),
    [anon_sym_DQUOTE] = ACTIONS(2973),
    [sym_true] = ACTIONS(2971),
    [sym_false] = ACTIONS(2971),
    [anon_sym_NULL] = ACTIONS(2971),
    [anon_sym_nullptr] = ACTIONS(2971),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2971),
    [anon_sym_decltype] = ACTIONS(2971),
    [anon_sym_virtual] = ACTIONS(2971),
    [anon_sym_alignas] = ACTIONS(2971),
    [anon_sym_explicit] = ACTIONS(2971),
    [anon_sym_typename] = ACTIONS(2971),
    [anon_sym_template] = ACTIONS(2971),
    [anon_sym_operator] = ACTIONS(2971),
    [anon_sym_try] = ACTIONS(2971),
    [anon_sym_delete] = ACTIONS(2971),
    [anon_sym_throw] = ACTIONS(2971),
    [anon_sym_namespace] = ACTIONS(2971),
    [anon_sym_using] = ACTIONS(2971),
    [anon_sym_static_assert] = ACTIONS(2971),
    [anon_sym_concept] = ACTIONS(2971),
    [anon_sym_co_return] = ACTIONS(2971),
    [anon_sym_co_yield] = ACTIONS(2971),
    [anon_sym_R_DQUOTE] = ACTIONS(2973),
    [anon_sym_LR_DQUOTE] = ACTIONS(2973),
    [anon_sym_uR_DQUOTE] = ACTIONS(2973),
    [anon_sym_UR_DQUOTE] = ACTIONS(2973),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2973),
    [anon_sym_co_await] = ACTIONS(2971),
    [anon_sym_new] = ACTIONS(2971),
    [anon_sym_requires] = ACTIONS(2971),
    [sym_this] = ACTIONS(2971),
  },
  [711] = {
    [sym_identifier] = ACTIONS(2957),
    [aux_sym_preproc_include_token1] = ACTIONS(2957),
    [aux_sym_preproc_def_token1] = ACTIONS(2957),
    [aux_sym_preproc_if_token1] = ACTIONS(2957),
    [aux_sym_preproc_if_token2] = ACTIONS(2957),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2957),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2957),
    [sym_preproc_directive] = ACTIONS(2957),
    [anon_sym_LPAREN2] = ACTIONS(2959),
    [anon_sym_BANG] = ACTIONS(2959),
    [anon_sym_TILDE] = ACTIONS(2959),
    [anon_sym_DASH] = ACTIONS(2957),
    [anon_sym_PLUS] = ACTIONS(2957),
    [anon_sym_STAR] = ACTIONS(2959),
    [anon_sym_AMP_AMP] = ACTIONS(2959),
    [anon_sym_AMP] = ACTIONS(2957),
    [anon_sym_SEMI] = ACTIONS(2959),
    [anon_sym___extension__] = ACTIONS(2957),
    [anon_sym_typedef] = ACTIONS(2957),
    [anon_sym_extern] = ACTIONS(2957),
    [anon_sym___attribute__] = ACTIONS(2957),
    [anon_sym_COLON_COLON] = ACTIONS(2959),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2959),
    [anon_sym___declspec] = ACTIONS(2957),
    [anon_sym___based] = ACTIONS(2957),
    [anon_sym___cdecl] = ACTIONS(2957),
    [anon_sym___clrcall] = ACTIONS(2957),
    [anon_sym___stdcall] = ACTIONS(2957),
    [anon_sym___fastcall] = ACTIONS(2957),
    [anon_sym___thiscall] = ACTIONS(2957),
    [anon_sym___vectorcall] = ACTIONS(2957),
    [anon_sym_LBRACE] = ACTIONS(2959),
    [anon_sym_signed] = ACTIONS(2957),
    [anon_sym_unsigned] = ACTIONS(2957),
    [anon_sym_long] = ACTIONS(2957),
    [anon_sym_short] = ACTIONS(2957),
    [anon_sym_LBRACK] = ACTIONS(2957),
    [anon_sym_static] = ACTIONS(2957),
    [anon_sym_register] = ACTIONS(2957),
    [anon_sym_inline] = ACTIONS(2957),
    [anon_sym___inline] = ACTIONS(2957),
    [anon_sym___inline__] = ACTIONS(2957),
    [anon_sym___forceinline] = ACTIONS(2957),
    [anon_sym_thread_local] = ACTIONS(2957),
    [anon_sym___thread] = ACTIONS(2957),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_constexpr] = ACTIONS(2957),
    [anon_sym_volatile] = ACTIONS(2957),
    [anon_sym_restrict] = ACTIONS(2957),
    [anon_sym___restrict__] = ACTIONS(2957),
    [anon_sym__Atomic] = ACTIONS(2957),
    [anon_sym__Noreturn] = ACTIONS(2957),
    [anon_sym_noreturn] = ACTIONS(2957),
    [anon_sym_mutable] = ACTIONS(2957),
    [anon_sym_constinit] = ACTIONS(2957),
    [anon_sym_consteval] = ACTIONS(2957),
    [anon_sym_PROGMEM] = ACTIONS(2957),
    [aux_sym_primitive_type_token1] = ACTIONS(2957),
    [anon_sym_byte] = ACTIONS(2957),
    [anon_sym_word] = ACTIONS(2957),
    [anon_sym_enum] = ACTIONS(2957),
    [anon_sym_class] = ACTIONS(2957),
    [anon_sym_struct] = ACTIONS(2957),
    [anon_sym_union] = ACTIONS(2957),
    [anon_sym_if] = ACTIONS(2957),
    [anon_sym_switch] = ACTIONS(2957),
    [anon_sym_case] = ACTIONS(2957),
    [anon_sym_default] = ACTIONS(2957),
    [anon_sym_while] = ACTIONS(2957),
    [anon_sym_do] = ACTIONS(2957),
    [anon_sym_for] = ACTIONS(2957),
    [anon_sym_return] = ACTIONS(2957),
    [anon_sym_break] = ACTIONS(2957),
    [anon_sym_continue] = ACTIONS(2957),
    [anon_sym_goto] = ACTIONS(2957),
    [anon_sym___try] = ACTIONS(2957),
    [anon_sym___leave] = ACTIONS(2957),
    [anon_sym_not] = ACTIONS(2957),
    [anon_sym_compl] = ACTIONS(2957),
    [anon_sym_DASH_DASH] = ACTIONS(2959),
    [anon_sym_PLUS_PLUS] = ACTIONS(2959),
    [anon_sym_sizeof] = ACTIONS(2957),
    [anon_sym___alignof__] = ACTIONS(2957),
    [anon_sym___alignof] = ACTIONS(2957),
    [anon_sym__alignof] = ACTIONS(2957),
    [anon_sym_alignof] = ACTIONS(2957),
    [anon_sym__Alignof] = ACTIONS(2957),
    [anon_sym_offsetof] = ACTIONS(2957),
    [anon_sym__Generic] = ACTIONS(2957),
    [anon_sym_asm] = ACTIONS(2957),
    [anon_sym___asm__] = ACTIONS(2957),
    [aux_sym_number_literal_token1] = ACTIONS(2959),
    [aux_sym_number_literal_token2] = ACTIONS(2957),
    [anon_sym_L_SQUOTE] = ACTIONS(2959),
    [anon_sym_u_SQUOTE] = ACTIONS(2959),
    [anon_sym_U_SQUOTE] = ACTIONS(2959),
    [anon_sym_u8_SQUOTE] = ACTIONS(2959),
    [anon_sym_SQUOTE] = ACTIONS(2959),
    [anon_sym_L_DQUOTE] = ACTIONS(2959),
    [anon_sym_u_DQUOTE] = ACTIONS(2959),
    [anon_sym_U_DQUOTE] = ACTIONS(2959),
    [anon_sym_u8_DQUOTE] = ACTIONS(2959),
    [anon_sym_DQUOTE] = ACTIONS(2959),
    [sym_true] = ACTIONS(2957),
    [sym_false] = ACTIONS(2957),
    [anon_sym_NULL] = ACTIONS(2957),
    [anon_sym_nullptr] = ACTIONS(2957),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2957),
    [anon_sym_decltype] = ACTIONS(2957),
    [anon_sym_virtual] = ACTIONS(2957),
    [anon_sym_alignas] = ACTIONS(2957),
    [anon_sym_explicit] = ACTIONS(2957),
    [anon_sym_typename] = ACTIONS(2957),
    [anon_sym_template] = ACTIONS(2957),
    [anon_sym_operator] = ACTIONS(2957),
    [anon_sym_try] = ACTIONS(2957),
    [anon_sym_delete] = ACTIONS(2957),
    [anon_sym_throw] = ACTIONS(2957),
    [anon_sym_namespace] = ACTIONS(2957),
    [anon_sym_using] = ACTIONS(2957),
    [anon_sym_static_assert] = ACTIONS(2957),
    [anon_sym_concept] = ACTIONS(2957),
    [anon_sym_co_return] = ACTIONS(2957),
    [anon_sym_co_yield] = ACTIONS(2957),
    [anon_sym_R_DQUOTE] = ACTIONS(2959),
    [anon_sym_LR_DQUOTE] = ACTIONS(2959),
    [anon_sym_uR_DQUOTE] = ACTIONS(2959),
    [anon_sym_UR_DQUOTE] = ACTIONS(2959),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2959),
    [anon_sym_co_await] = ACTIONS(2957),
    [anon_sym_new] = ACTIONS(2957),
    [anon_sym_requires] = ACTIONS(2957),
    [sym_this] = ACTIONS(2957),
  },
  [712] = {
    [sym_identifier] = ACTIONS(2953),
    [aux_sym_preproc_include_token1] = ACTIONS(2953),
    [aux_sym_preproc_def_token1] = ACTIONS(2953),
    [aux_sym_preproc_if_token1] = ACTIONS(2953),
    [aux_sym_preproc_if_token2] = ACTIONS(2953),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2953),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2953),
    [sym_preproc_directive] = ACTIONS(2953),
    [anon_sym_LPAREN2] = ACTIONS(2955),
    [anon_sym_BANG] = ACTIONS(2955),
    [anon_sym_TILDE] = ACTIONS(2955),
    [anon_sym_DASH] = ACTIONS(2953),
    [anon_sym_PLUS] = ACTIONS(2953),
    [anon_sym_STAR] = ACTIONS(2955),
    [anon_sym_AMP_AMP] = ACTIONS(2955),
    [anon_sym_AMP] = ACTIONS(2953),
    [anon_sym_SEMI] = ACTIONS(2955),
    [anon_sym___extension__] = ACTIONS(2953),
    [anon_sym_typedef] = ACTIONS(2953),
    [anon_sym_extern] = ACTIONS(2953),
    [anon_sym___attribute__] = ACTIONS(2953),
    [anon_sym_COLON_COLON] = ACTIONS(2955),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2955),
    [anon_sym___declspec] = ACTIONS(2953),
    [anon_sym___based] = ACTIONS(2953),
    [anon_sym___cdecl] = ACTIONS(2953),
    [anon_sym___clrcall] = ACTIONS(2953),
    [anon_sym___stdcall] = ACTIONS(2953),
    [anon_sym___fastcall] = ACTIONS(2953),
    [anon_sym___thiscall] = ACTIONS(2953),
    [anon_sym___vectorcall] = ACTIONS(2953),
    [anon_sym_LBRACE] = ACTIONS(2955),
    [anon_sym_signed] = ACTIONS(2953),
    [anon_sym_unsigned] = ACTIONS(2953),
    [anon_sym_long] = ACTIONS(2953),
    [anon_sym_short] = ACTIONS(2953),
    [anon_sym_LBRACK] = ACTIONS(2953),
    [anon_sym_static] = ACTIONS(2953),
    [anon_sym_register] = ACTIONS(2953),
    [anon_sym_inline] = ACTIONS(2953),
    [anon_sym___inline] = ACTIONS(2953),
    [anon_sym___inline__] = ACTIONS(2953),
    [anon_sym___forceinline] = ACTIONS(2953),
    [anon_sym_thread_local] = ACTIONS(2953),
    [anon_sym___thread] = ACTIONS(2953),
    [anon_sym_const] = ACTIONS(2953),
    [anon_sym_constexpr] = ACTIONS(2953),
    [anon_sym_volatile] = ACTIONS(2953),
    [anon_sym_restrict] = ACTIONS(2953),
    [anon_sym___restrict__] = ACTIONS(2953),
    [anon_sym__Atomic] = ACTIONS(2953),
    [anon_sym__Noreturn] = ACTIONS(2953),
    [anon_sym_noreturn] = ACTIONS(2953),
    [anon_sym_mutable] = ACTIONS(2953),
    [anon_sym_constinit] = ACTIONS(2953),
    [anon_sym_consteval] = ACTIONS(2953),
    [anon_sym_PROGMEM] = ACTIONS(2953),
    [aux_sym_primitive_type_token1] = ACTIONS(2953),
    [anon_sym_byte] = ACTIONS(2953),
    [anon_sym_word] = ACTIONS(2953),
    [anon_sym_enum] = ACTIONS(2953),
    [anon_sym_class] = ACTIONS(2953),
    [anon_sym_struct] = ACTIONS(2953),
    [anon_sym_union] = ACTIONS(2953),
    [anon_sym_if] = ACTIONS(2953),
    [anon_sym_switch] = ACTIONS(2953),
    [anon_sym_case] = ACTIONS(2953),
    [anon_sym_default] = ACTIONS(2953),
    [anon_sym_while] = ACTIONS(2953),
    [anon_sym_do] = ACTIONS(2953),
    [anon_sym_for] = ACTIONS(2953),
    [anon_sym_return] = ACTIONS(2953),
    [anon_sym_break] = ACTIONS(2953),
    [anon_sym_continue] = ACTIONS(2953),
    [anon_sym_goto] = ACTIONS(2953),
    [anon_sym___try] = ACTIONS(2953),
    [anon_sym___leave] = ACTIONS(2953),
    [anon_sym_not] = ACTIONS(2953),
    [anon_sym_compl] = ACTIONS(2953),
    [anon_sym_DASH_DASH] = ACTIONS(2955),
    [anon_sym_PLUS_PLUS] = ACTIONS(2955),
    [anon_sym_sizeof] = ACTIONS(2953),
    [anon_sym___alignof__] = ACTIONS(2953),
    [anon_sym___alignof] = ACTIONS(2953),
    [anon_sym__alignof] = ACTIONS(2953),
    [anon_sym_alignof] = ACTIONS(2953),
    [anon_sym__Alignof] = ACTIONS(2953),
    [anon_sym_offsetof] = ACTIONS(2953),
    [anon_sym__Generic] = ACTIONS(2953),
    [anon_sym_asm] = ACTIONS(2953),
    [anon_sym___asm__] = ACTIONS(2953),
    [aux_sym_number_literal_token1] = ACTIONS(2955),
    [aux_sym_number_literal_token2] = ACTIONS(2953),
    [anon_sym_L_SQUOTE] = ACTIONS(2955),
    [anon_sym_u_SQUOTE] = ACTIONS(2955),
    [anon_sym_U_SQUOTE] = ACTIONS(2955),
    [anon_sym_u8_SQUOTE] = ACTIONS(2955),
    [anon_sym_SQUOTE] = ACTIONS(2955),
    [anon_sym_L_DQUOTE] = ACTIONS(2955),
    [anon_sym_u_DQUOTE] = ACTIONS(2955),
    [anon_sym_U_DQUOTE] = ACTIONS(2955),
    [anon_sym_u8_DQUOTE] = ACTIONS(2955),
    [anon_sym_DQUOTE] = ACTIONS(2955),
    [sym_true] = ACTIONS(2953),
    [sym_false] = ACTIONS(2953),
    [anon_sym_NULL] = ACTIONS(2953),
    [anon_sym_nullptr] = ACTIONS(2953),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2953),
    [anon_sym_decltype] = ACTIONS(2953),
    [anon_sym_virtual] = ACTIONS(2953),
    [anon_sym_alignas] = ACTIONS(2953),
    [anon_sym_explicit] = ACTIONS(2953),
    [anon_sym_typename] = ACTIONS(2953),
    [anon_sym_template] = ACTIONS(2953),
    [anon_sym_operator] = ACTIONS(2953),
    [anon_sym_try] = ACTIONS(2953),
    [anon_sym_delete] = ACTIONS(2953),
    [anon_sym_throw] = ACTIONS(2953),
    [anon_sym_namespace] = ACTIONS(2953),
    [anon_sym_using] = ACTIONS(2953),
    [anon_sym_static_assert] = ACTIONS(2953),
    [anon_sym_concept] = ACTIONS(2953),
    [anon_sym_co_return] = ACTIONS(2953),
    [anon_sym_co_yield] = ACTIONS(2953),
    [anon_sym_R_DQUOTE] = ACTIONS(2955),
    [anon_sym_LR_DQUOTE] = ACTIONS(2955),
    [anon_sym_uR_DQUOTE] = ACTIONS(2955),
    [anon_sym_UR_DQUOTE] = ACTIONS(2955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2955),
    [anon_sym_co_await] = ACTIONS(2953),
    [anon_sym_new] = ACTIONS(2953),
    [anon_sym_requires] = ACTIONS(2953),
    [sym_this] = ACTIONS(2953),
  },
  [713] = {
    [sym_identifier] = ACTIONS(2949),
    [aux_sym_preproc_include_token1] = ACTIONS(2949),
    [aux_sym_preproc_def_token1] = ACTIONS(2949),
    [aux_sym_preproc_if_token1] = ACTIONS(2949),
    [aux_sym_preproc_if_token2] = ACTIONS(2949),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2949),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2949),
    [sym_preproc_directive] = ACTIONS(2949),
    [anon_sym_LPAREN2] = ACTIONS(2951),
    [anon_sym_BANG] = ACTIONS(2951),
    [anon_sym_TILDE] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2949),
    [anon_sym_STAR] = ACTIONS(2951),
    [anon_sym_AMP_AMP] = ACTIONS(2951),
    [anon_sym_AMP] = ACTIONS(2949),
    [anon_sym_SEMI] = ACTIONS(2951),
    [anon_sym___extension__] = ACTIONS(2949),
    [anon_sym_typedef] = ACTIONS(2949),
    [anon_sym_extern] = ACTIONS(2949),
    [anon_sym___attribute__] = ACTIONS(2949),
    [anon_sym_COLON_COLON] = ACTIONS(2951),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2951),
    [anon_sym___declspec] = ACTIONS(2949),
    [anon_sym___based] = ACTIONS(2949),
    [anon_sym___cdecl] = ACTIONS(2949),
    [anon_sym___clrcall] = ACTIONS(2949),
    [anon_sym___stdcall] = ACTIONS(2949),
    [anon_sym___fastcall] = ACTIONS(2949),
    [anon_sym___thiscall] = ACTIONS(2949),
    [anon_sym___vectorcall] = ACTIONS(2949),
    [anon_sym_LBRACE] = ACTIONS(2951),
    [anon_sym_signed] = ACTIONS(2949),
    [anon_sym_unsigned] = ACTIONS(2949),
    [anon_sym_long] = ACTIONS(2949),
    [anon_sym_short] = ACTIONS(2949),
    [anon_sym_LBRACK] = ACTIONS(2949),
    [anon_sym_static] = ACTIONS(2949),
    [anon_sym_register] = ACTIONS(2949),
    [anon_sym_inline] = ACTIONS(2949),
    [anon_sym___inline] = ACTIONS(2949),
    [anon_sym___inline__] = ACTIONS(2949),
    [anon_sym___forceinline] = ACTIONS(2949),
    [anon_sym_thread_local] = ACTIONS(2949),
    [anon_sym___thread] = ACTIONS(2949),
    [anon_sym_const] = ACTIONS(2949),
    [anon_sym_constexpr] = ACTIONS(2949),
    [anon_sym_volatile] = ACTIONS(2949),
    [anon_sym_restrict] = ACTIONS(2949),
    [anon_sym___restrict__] = ACTIONS(2949),
    [anon_sym__Atomic] = ACTIONS(2949),
    [anon_sym__Noreturn] = ACTIONS(2949),
    [anon_sym_noreturn] = ACTIONS(2949),
    [anon_sym_mutable] = ACTIONS(2949),
    [anon_sym_constinit] = ACTIONS(2949),
    [anon_sym_consteval] = ACTIONS(2949),
    [anon_sym_PROGMEM] = ACTIONS(2949),
    [aux_sym_primitive_type_token1] = ACTIONS(2949),
    [anon_sym_byte] = ACTIONS(2949),
    [anon_sym_word] = ACTIONS(2949),
    [anon_sym_enum] = ACTIONS(2949),
    [anon_sym_class] = ACTIONS(2949),
    [anon_sym_struct] = ACTIONS(2949),
    [anon_sym_union] = ACTIONS(2949),
    [anon_sym_if] = ACTIONS(2949),
    [anon_sym_switch] = ACTIONS(2949),
    [anon_sym_case] = ACTIONS(2949),
    [anon_sym_default] = ACTIONS(2949),
    [anon_sym_while] = ACTIONS(2949),
    [anon_sym_do] = ACTIONS(2949),
    [anon_sym_for] = ACTIONS(2949),
    [anon_sym_return] = ACTIONS(2949),
    [anon_sym_break] = ACTIONS(2949),
    [anon_sym_continue] = ACTIONS(2949),
    [anon_sym_goto] = ACTIONS(2949),
    [anon_sym___try] = ACTIONS(2949),
    [anon_sym___leave] = ACTIONS(2949),
    [anon_sym_not] = ACTIONS(2949),
    [anon_sym_compl] = ACTIONS(2949),
    [anon_sym_DASH_DASH] = ACTIONS(2951),
    [anon_sym_PLUS_PLUS] = ACTIONS(2951),
    [anon_sym_sizeof] = ACTIONS(2949),
    [anon_sym___alignof__] = ACTIONS(2949),
    [anon_sym___alignof] = ACTIONS(2949),
    [anon_sym__alignof] = ACTIONS(2949),
    [anon_sym_alignof] = ACTIONS(2949),
    [anon_sym__Alignof] = ACTIONS(2949),
    [anon_sym_offsetof] = ACTIONS(2949),
    [anon_sym__Generic] = ACTIONS(2949),
    [anon_sym_asm] = ACTIONS(2949),
    [anon_sym___asm__] = ACTIONS(2949),
    [aux_sym_number_literal_token1] = ACTIONS(2951),
    [aux_sym_number_literal_token2] = ACTIONS(2949),
    [anon_sym_L_SQUOTE] = ACTIONS(2951),
    [anon_sym_u_SQUOTE] = ACTIONS(2951),
    [anon_sym_U_SQUOTE] = ACTIONS(2951),
    [anon_sym_u8_SQUOTE] = ACTIONS(2951),
    [anon_sym_SQUOTE] = ACTIONS(2951),
    [anon_sym_L_DQUOTE] = ACTIONS(2951),
    [anon_sym_u_DQUOTE] = ACTIONS(2951),
    [anon_sym_U_DQUOTE] = ACTIONS(2951),
    [anon_sym_u8_DQUOTE] = ACTIONS(2951),
    [anon_sym_DQUOTE] = ACTIONS(2951),
    [sym_true] = ACTIONS(2949),
    [sym_false] = ACTIONS(2949),
    [anon_sym_NULL] = ACTIONS(2949),
    [anon_sym_nullptr] = ACTIONS(2949),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2949),
    [anon_sym_decltype] = ACTIONS(2949),
    [anon_sym_virtual] = ACTIONS(2949),
    [anon_sym_alignas] = ACTIONS(2949),
    [anon_sym_explicit] = ACTIONS(2949),
    [anon_sym_typename] = ACTIONS(2949),
    [anon_sym_template] = ACTIONS(2949),
    [anon_sym_operator] = ACTIONS(2949),
    [anon_sym_try] = ACTIONS(2949),
    [anon_sym_delete] = ACTIONS(2949),
    [anon_sym_throw] = ACTIONS(2949),
    [anon_sym_namespace] = ACTIONS(2949),
    [anon_sym_using] = ACTIONS(2949),
    [anon_sym_static_assert] = ACTIONS(2949),
    [anon_sym_concept] = ACTIONS(2949),
    [anon_sym_co_return] = ACTIONS(2949),
    [anon_sym_co_yield] = ACTIONS(2949),
    [anon_sym_R_DQUOTE] = ACTIONS(2951),
    [anon_sym_LR_DQUOTE] = ACTIONS(2951),
    [anon_sym_uR_DQUOTE] = ACTIONS(2951),
    [anon_sym_UR_DQUOTE] = ACTIONS(2951),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2951),
    [anon_sym_co_await] = ACTIONS(2949),
    [anon_sym_new] = ACTIONS(2949),
    [anon_sym_requires] = ACTIONS(2949),
    [sym_this] = ACTIONS(2949),
  },
  [714] = {
    [sym_identifier] = ACTIONS(3094),
    [aux_sym_preproc_include_token1] = ACTIONS(3094),
    [aux_sym_preproc_def_token1] = ACTIONS(3094),
    [aux_sym_preproc_if_token1] = ACTIONS(3094),
    [aux_sym_preproc_if_token2] = ACTIONS(3094),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3094),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3094),
    [sym_preproc_directive] = ACTIONS(3094),
    [anon_sym_LPAREN2] = ACTIONS(3096),
    [anon_sym_BANG] = ACTIONS(3096),
    [anon_sym_TILDE] = ACTIONS(3096),
    [anon_sym_DASH] = ACTIONS(3094),
    [anon_sym_PLUS] = ACTIONS(3094),
    [anon_sym_STAR] = ACTIONS(3096),
    [anon_sym_AMP_AMP] = ACTIONS(3096),
    [anon_sym_AMP] = ACTIONS(3094),
    [anon_sym_SEMI] = ACTIONS(3096),
    [anon_sym___extension__] = ACTIONS(3094),
    [anon_sym_typedef] = ACTIONS(3094),
    [anon_sym_extern] = ACTIONS(3094),
    [anon_sym___attribute__] = ACTIONS(3094),
    [anon_sym_COLON_COLON] = ACTIONS(3096),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3096),
    [anon_sym___declspec] = ACTIONS(3094),
    [anon_sym___based] = ACTIONS(3094),
    [anon_sym___cdecl] = ACTIONS(3094),
    [anon_sym___clrcall] = ACTIONS(3094),
    [anon_sym___stdcall] = ACTIONS(3094),
    [anon_sym___fastcall] = ACTIONS(3094),
    [anon_sym___thiscall] = ACTIONS(3094),
    [anon_sym___vectorcall] = ACTIONS(3094),
    [anon_sym_LBRACE] = ACTIONS(3096),
    [anon_sym_signed] = ACTIONS(3094),
    [anon_sym_unsigned] = ACTIONS(3094),
    [anon_sym_long] = ACTIONS(3094),
    [anon_sym_short] = ACTIONS(3094),
    [anon_sym_LBRACK] = ACTIONS(3094),
    [anon_sym_static] = ACTIONS(3094),
    [anon_sym_register] = ACTIONS(3094),
    [anon_sym_inline] = ACTIONS(3094),
    [anon_sym___inline] = ACTIONS(3094),
    [anon_sym___inline__] = ACTIONS(3094),
    [anon_sym___forceinline] = ACTIONS(3094),
    [anon_sym_thread_local] = ACTIONS(3094),
    [anon_sym___thread] = ACTIONS(3094),
    [anon_sym_const] = ACTIONS(3094),
    [anon_sym_constexpr] = ACTIONS(3094),
    [anon_sym_volatile] = ACTIONS(3094),
    [anon_sym_restrict] = ACTIONS(3094),
    [anon_sym___restrict__] = ACTIONS(3094),
    [anon_sym__Atomic] = ACTIONS(3094),
    [anon_sym__Noreturn] = ACTIONS(3094),
    [anon_sym_noreturn] = ACTIONS(3094),
    [anon_sym_mutable] = ACTIONS(3094),
    [anon_sym_constinit] = ACTIONS(3094),
    [anon_sym_consteval] = ACTIONS(3094),
    [anon_sym_PROGMEM] = ACTIONS(3094),
    [aux_sym_primitive_type_token1] = ACTIONS(3094),
    [anon_sym_byte] = ACTIONS(3094),
    [anon_sym_word] = ACTIONS(3094),
    [anon_sym_enum] = ACTIONS(3094),
    [anon_sym_class] = ACTIONS(3094),
    [anon_sym_struct] = ACTIONS(3094),
    [anon_sym_union] = ACTIONS(3094),
    [anon_sym_if] = ACTIONS(3094),
    [anon_sym_switch] = ACTIONS(3094),
    [anon_sym_case] = ACTIONS(3094),
    [anon_sym_default] = ACTIONS(3094),
    [anon_sym_while] = ACTIONS(3094),
    [anon_sym_do] = ACTIONS(3094),
    [anon_sym_for] = ACTIONS(3094),
    [anon_sym_return] = ACTIONS(3094),
    [anon_sym_break] = ACTIONS(3094),
    [anon_sym_continue] = ACTIONS(3094),
    [anon_sym_goto] = ACTIONS(3094),
    [anon_sym___try] = ACTIONS(3094),
    [anon_sym___leave] = ACTIONS(3094),
    [anon_sym_not] = ACTIONS(3094),
    [anon_sym_compl] = ACTIONS(3094),
    [anon_sym_DASH_DASH] = ACTIONS(3096),
    [anon_sym_PLUS_PLUS] = ACTIONS(3096),
    [anon_sym_sizeof] = ACTIONS(3094),
    [anon_sym___alignof__] = ACTIONS(3094),
    [anon_sym___alignof] = ACTIONS(3094),
    [anon_sym__alignof] = ACTIONS(3094),
    [anon_sym_alignof] = ACTIONS(3094),
    [anon_sym__Alignof] = ACTIONS(3094),
    [anon_sym_offsetof] = ACTIONS(3094),
    [anon_sym__Generic] = ACTIONS(3094),
    [anon_sym_asm] = ACTIONS(3094),
    [anon_sym___asm__] = ACTIONS(3094),
    [aux_sym_number_literal_token1] = ACTIONS(3096),
    [aux_sym_number_literal_token2] = ACTIONS(3094),
    [anon_sym_L_SQUOTE] = ACTIONS(3096),
    [anon_sym_u_SQUOTE] = ACTIONS(3096),
    [anon_sym_U_SQUOTE] = ACTIONS(3096),
    [anon_sym_u8_SQUOTE] = ACTIONS(3096),
    [anon_sym_SQUOTE] = ACTIONS(3096),
    [anon_sym_L_DQUOTE] = ACTIONS(3096),
    [anon_sym_u_DQUOTE] = ACTIONS(3096),
    [anon_sym_U_DQUOTE] = ACTIONS(3096),
    [anon_sym_u8_DQUOTE] = ACTIONS(3096),
    [anon_sym_DQUOTE] = ACTIONS(3096),
    [sym_true] = ACTIONS(3094),
    [sym_false] = ACTIONS(3094),
    [anon_sym_NULL] = ACTIONS(3094),
    [anon_sym_nullptr] = ACTIONS(3094),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3094),
    [anon_sym_decltype] = ACTIONS(3094),
    [anon_sym_virtual] = ACTIONS(3094),
    [anon_sym_alignas] = ACTIONS(3094),
    [anon_sym_explicit] = ACTIONS(3094),
    [anon_sym_typename] = ACTIONS(3094),
    [anon_sym_template] = ACTIONS(3094),
    [anon_sym_operator] = ACTIONS(3094),
    [anon_sym_try] = ACTIONS(3094),
    [anon_sym_delete] = ACTIONS(3094),
    [anon_sym_throw] = ACTIONS(3094),
    [anon_sym_namespace] = ACTIONS(3094),
    [anon_sym_using] = ACTIONS(3094),
    [anon_sym_static_assert] = ACTIONS(3094),
    [anon_sym_concept] = ACTIONS(3094),
    [anon_sym_co_return] = ACTIONS(3094),
    [anon_sym_co_yield] = ACTIONS(3094),
    [anon_sym_R_DQUOTE] = ACTIONS(3096),
    [anon_sym_LR_DQUOTE] = ACTIONS(3096),
    [anon_sym_uR_DQUOTE] = ACTIONS(3096),
    [anon_sym_UR_DQUOTE] = ACTIONS(3096),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3096),
    [anon_sym_co_await] = ACTIONS(3094),
    [anon_sym_new] = ACTIONS(3094),
    [anon_sym_requires] = ACTIONS(3094),
    [sym_this] = ACTIONS(3094),
  },
  [715] = {
    [sym_identifier] = ACTIONS(2893),
    [aux_sym_preproc_include_token1] = ACTIONS(2893),
    [aux_sym_preproc_def_token1] = ACTIONS(2893),
    [aux_sym_preproc_if_token1] = ACTIONS(2893),
    [aux_sym_preproc_if_token2] = ACTIONS(2893),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2893),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2893),
    [sym_preproc_directive] = ACTIONS(2893),
    [anon_sym_LPAREN2] = ACTIONS(2895),
    [anon_sym_BANG] = ACTIONS(2895),
    [anon_sym_TILDE] = ACTIONS(2895),
    [anon_sym_DASH] = ACTIONS(2893),
    [anon_sym_PLUS] = ACTIONS(2893),
    [anon_sym_STAR] = ACTIONS(2895),
    [anon_sym_AMP_AMP] = ACTIONS(2895),
    [anon_sym_AMP] = ACTIONS(2893),
    [anon_sym_SEMI] = ACTIONS(2895),
    [anon_sym___extension__] = ACTIONS(2893),
    [anon_sym_typedef] = ACTIONS(2893),
    [anon_sym_extern] = ACTIONS(2893),
    [anon_sym___attribute__] = ACTIONS(2893),
    [anon_sym_COLON_COLON] = ACTIONS(2895),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2895),
    [anon_sym___declspec] = ACTIONS(2893),
    [anon_sym___based] = ACTIONS(2893),
    [anon_sym___cdecl] = ACTIONS(2893),
    [anon_sym___clrcall] = ACTIONS(2893),
    [anon_sym___stdcall] = ACTIONS(2893),
    [anon_sym___fastcall] = ACTIONS(2893),
    [anon_sym___thiscall] = ACTIONS(2893),
    [anon_sym___vectorcall] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(2895),
    [anon_sym_signed] = ACTIONS(2893),
    [anon_sym_unsigned] = ACTIONS(2893),
    [anon_sym_long] = ACTIONS(2893),
    [anon_sym_short] = ACTIONS(2893),
    [anon_sym_LBRACK] = ACTIONS(2893),
    [anon_sym_static] = ACTIONS(2893),
    [anon_sym_register] = ACTIONS(2893),
    [anon_sym_inline] = ACTIONS(2893),
    [anon_sym___inline] = ACTIONS(2893),
    [anon_sym___inline__] = ACTIONS(2893),
    [anon_sym___forceinline] = ACTIONS(2893),
    [anon_sym_thread_local] = ACTIONS(2893),
    [anon_sym___thread] = ACTIONS(2893),
    [anon_sym_const] = ACTIONS(2893),
    [anon_sym_constexpr] = ACTIONS(2893),
    [anon_sym_volatile] = ACTIONS(2893),
    [anon_sym_restrict] = ACTIONS(2893),
    [anon_sym___restrict__] = ACTIONS(2893),
    [anon_sym__Atomic] = ACTIONS(2893),
    [anon_sym__Noreturn] = ACTIONS(2893),
    [anon_sym_noreturn] = ACTIONS(2893),
    [anon_sym_mutable] = ACTIONS(2893),
    [anon_sym_constinit] = ACTIONS(2893),
    [anon_sym_consteval] = ACTIONS(2893),
    [anon_sym_PROGMEM] = ACTIONS(2893),
    [aux_sym_primitive_type_token1] = ACTIONS(2893),
    [anon_sym_byte] = ACTIONS(2893),
    [anon_sym_word] = ACTIONS(2893),
    [anon_sym_enum] = ACTIONS(2893),
    [anon_sym_class] = ACTIONS(2893),
    [anon_sym_struct] = ACTIONS(2893),
    [anon_sym_union] = ACTIONS(2893),
    [anon_sym_if] = ACTIONS(2893),
    [anon_sym_switch] = ACTIONS(2893),
    [anon_sym_case] = ACTIONS(2893),
    [anon_sym_default] = ACTIONS(2893),
    [anon_sym_while] = ACTIONS(2893),
    [anon_sym_do] = ACTIONS(2893),
    [anon_sym_for] = ACTIONS(2893),
    [anon_sym_return] = ACTIONS(2893),
    [anon_sym_break] = ACTIONS(2893),
    [anon_sym_continue] = ACTIONS(2893),
    [anon_sym_goto] = ACTIONS(2893),
    [anon_sym___try] = ACTIONS(2893),
    [anon_sym___leave] = ACTIONS(2893),
    [anon_sym_not] = ACTIONS(2893),
    [anon_sym_compl] = ACTIONS(2893),
    [anon_sym_DASH_DASH] = ACTIONS(2895),
    [anon_sym_PLUS_PLUS] = ACTIONS(2895),
    [anon_sym_sizeof] = ACTIONS(2893),
    [anon_sym___alignof__] = ACTIONS(2893),
    [anon_sym___alignof] = ACTIONS(2893),
    [anon_sym__alignof] = ACTIONS(2893),
    [anon_sym_alignof] = ACTIONS(2893),
    [anon_sym__Alignof] = ACTIONS(2893),
    [anon_sym_offsetof] = ACTIONS(2893),
    [anon_sym__Generic] = ACTIONS(2893),
    [anon_sym_asm] = ACTIONS(2893),
    [anon_sym___asm__] = ACTIONS(2893),
    [aux_sym_number_literal_token1] = ACTIONS(2895),
    [aux_sym_number_literal_token2] = ACTIONS(2893),
    [anon_sym_L_SQUOTE] = ACTIONS(2895),
    [anon_sym_u_SQUOTE] = ACTIONS(2895),
    [anon_sym_U_SQUOTE] = ACTIONS(2895),
    [anon_sym_u8_SQUOTE] = ACTIONS(2895),
    [anon_sym_SQUOTE] = ACTIONS(2895),
    [anon_sym_L_DQUOTE] = ACTIONS(2895),
    [anon_sym_u_DQUOTE] = ACTIONS(2895),
    [anon_sym_U_DQUOTE] = ACTIONS(2895),
    [anon_sym_u8_DQUOTE] = ACTIONS(2895),
    [anon_sym_DQUOTE] = ACTIONS(2895),
    [sym_true] = ACTIONS(2893),
    [sym_false] = ACTIONS(2893),
    [anon_sym_NULL] = ACTIONS(2893),
    [anon_sym_nullptr] = ACTIONS(2893),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2893),
    [anon_sym_decltype] = ACTIONS(2893),
    [anon_sym_virtual] = ACTIONS(2893),
    [anon_sym_alignas] = ACTIONS(2893),
    [anon_sym_explicit] = ACTIONS(2893),
    [anon_sym_typename] = ACTIONS(2893),
    [anon_sym_template] = ACTIONS(2893),
    [anon_sym_operator] = ACTIONS(2893),
    [anon_sym_try] = ACTIONS(2893),
    [anon_sym_delete] = ACTIONS(2893),
    [anon_sym_throw] = ACTIONS(2893),
    [anon_sym_namespace] = ACTIONS(2893),
    [anon_sym_using] = ACTIONS(2893),
    [anon_sym_static_assert] = ACTIONS(2893),
    [anon_sym_concept] = ACTIONS(2893),
    [anon_sym_co_return] = ACTIONS(2893),
    [anon_sym_co_yield] = ACTIONS(2893),
    [anon_sym_R_DQUOTE] = ACTIONS(2895),
    [anon_sym_LR_DQUOTE] = ACTIONS(2895),
    [anon_sym_uR_DQUOTE] = ACTIONS(2895),
    [anon_sym_UR_DQUOTE] = ACTIONS(2895),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2895),
    [anon_sym_co_await] = ACTIONS(2893),
    [anon_sym_new] = ACTIONS(2893),
    [anon_sym_requires] = ACTIONS(2893),
    [sym_this] = ACTIONS(2893),
  },
  [716] = {
    [sym_identifier] = ACTIONS(3152),
    [aux_sym_preproc_include_token1] = ACTIONS(3152),
    [aux_sym_preproc_def_token1] = ACTIONS(3152),
    [aux_sym_preproc_if_token1] = ACTIONS(3152),
    [aux_sym_preproc_if_token2] = ACTIONS(3152),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3152),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3152),
    [sym_preproc_directive] = ACTIONS(3152),
    [anon_sym_LPAREN2] = ACTIONS(3154),
    [anon_sym_BANG] = ACTIONS(3154),
    [anon_sym_TILDE] = ACTIONS(3154),
    [anon_sym_DASH] = ACTIONS(3152),
    [anon_sym_PLUS] = ACTIONS(3152),
    [anon_sym_STAR] = ACTIONS(3154),
    [anon_sym_AMP_AMP] = ACTIONS(3154),
    [anon_sym_AMP] = ACTIONS(3152),
    [anon_sym_SEMI] = ACTIONS(3154),
    [anon_sym___extension__] = ACTIONS(3152),
    [anon_sym_typedef] = ACTIONS(3152),
    [anon_sym_extern] = ACTIONS(3152),
    [anon_sym___attribute__] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3154),
    [anon_sym___declspec] = ACTIONS(3152),
    [anon_sym___based] = ACTIONS(3152),
    [anon_sym___cdecl] = ACTIONS(3152),
    [anon_sym___clrcall] = ACTIONS(3152),
    [anon_sym___stdcall] = ACTIONS(3152),
    [anon_sym___fastcall] = ACTIONS(3152),
    [anon_sym___thiscall] = ACTIONS(3152),
    [anon_sym___vectorcall] = ACTIONS(3152),
    [anon_sym_LBRACE] = ACTIONS(3154),
    [anon_sym_signed] = ACTIONS(3152),
    [anon_sym_unsigned] = ACTIONS(3152),
    [anon_sym_long] = ACTIONS(3152),
    [anon_sym_short] = ACTIONS(3152),
    [anon_sym_LBRACK] = ACTIONS(3152),
    [anon_sym_static] = ACTIONS(3152),
    [anon_sym_register] = ACTIONS(3152),
    [anon_sym_inline] = ACTIONS(3152),
    [anon_sym___inline] = ACTIONS(3152),
    [anon_sym___inline__] = ACTIONS(3152),
    [anon_sym___forceinline] = ACTIONS(3152),
    [anon_sym_thread_local] = ACTIONS(3152),
    [anon_sym___thread] = ACTIONS(3152),
    [anon_sym_const] = ACTIONS(3152),
    [anon_sym_constexpr] = ACTIONS(3152),
    [anon_sym_volatile] = ACTIONS(3152),
    [anon_sym_restrict] = ACTIONS(3152),
    [anon_sym___restrict__] = ACTIONS(3152),
    [anon_sym__Atomic] = ACTIONS(3152),
    [anon_sym__Noreturn] = ACTIONS(3152),
    [anon_sym_noreturn] = ACTIONS(3152),
    [anon_sym_mutable] = ACTIONS(3152),
    [anon_sym_constinit] = ACTIONS(3152),
    [anon_sym_consteval] = ACTIONS(3152),
    [anon_sym_PROGMEM] = ACTIONS(3152),
    [aux_sym_primitive_type_token1] = ACTIONS(3152),
    [anon_sym_byte] = ACTIONS(3152),
    [anon_sym_word] = ACTIONS(3152),
    [anon_sym_enum] = ACTIONS(3152),
    [anon_sym_class] = ACTIONS(3152),
    [anon_sym_struct] = ACTIONS(3152),
    [anon_sym_union] = ACTIONS(3152),
    [anon_sym_if] = ACTIONS(3152),
    [anon_sym_switch] = ACTIONS(3152),
    [anon_sym_case] = ACTIONS(3152),
    [anon_sym_default] = ACTIONS(3152),
    [anon_sym_while] = ACTIONS(3152),
    [anon_sym_do] = ACTIONS(3152),
    [anon_sym_for] = ACTIONS(3152),
    [anon_sym_return] = ACTIONS(3152),
    [anon_sym_break] = ACTIONS(3152),
    [anon_sym_continue] = ACTIONS(3152),
    [anon_sym_goto] = ACTIONS(3152),
    [anon_sym___try] = ACTIONS(3152),
    [anon_sym___leave] = ACTIONS(3152),
    [anon_sym_not] = ACTIONS(3152),
    [anon_sym_compl] = ACTIONS(3152),
    [anon_sym_DASH_DASH] = ACTIONS(3154),
    [anon_sym_PLUS_PLUS] = ACTIONS(3154),
    [anon_sym_sizeof] = ACTIONS(3152),
    [anon_sym___alignof__] = ACTIONS(3152),
    [anon_sym___alignof] = ACTIONS(3152),
    [anon_sym__alignof] = ACTIONS(3152),
    [anon_sym_alignof] = ACTIONS(3152),
    [anon_sym__Alignof] = ACTIONS(3152),
    [anon_sym_offsetof] = ACTIONS(3152),
    [anon_sym__Generic] = ACTIONS(3152),
    [anon_sym_asm] = ACTIONS(3152),
    [anon_sym___asm__] = ACTIONS(3152),
    [aux_sym_number_literal_token1] = ACTIONS(3154),
    [aux_sym_number_literal_token2] = ACTIONS(3152),
    [anon_sym_L_SQUOTE] = ACTIONS(3154),
    [anon_sym_u_SQUOTE] = ACTIONS(3154),
    [anon_sym_U_SQUOTE] = ACTIONS(3154),
    [anon_sym_u8_SQUOTE] = ACTIONS(3154),
    [anon_sym_SQUOTE] = ACTIONS(3154),
    [anon_sym_L_DQUOTE] = ACTIONS(3154),
    [anon_sym_u_DQUOTE] = ACTIONS(3154),
    [anon_sym_U_DQUOTE] = ACTIONS(3154),
    [anon_sym_u8_DQUOTE] = ACTIONS(3154),
    [anon_sym_DQUOTE] = ACTIONS(3154),
    [sym_true] = ACTIONS(3152),
    [sym_false] = ACTIONS(3152),
    [anon_sym_NULL] = ACTIONS(3152),
    [anon_sym_nullptr] = ACTIONS(3152),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3152),
    [anon_sym_decltype] = ACTIONS(3152),
    [anon_sym_virtual] = ACTIONS(3152),
    [anon_sym_alignas] = ACTIONS(3152),
    [anon_sym_explicit] = ACTIONS(3152),
    [anon_sym_typename] = ACTIONS(3152),
    [anon_sym_template] = ACTIONS(3152),
    [anon_sym_operator] = ACTIONS(3152),
    [anon_sym_try] = ACTIONS(3152),
    [anon_sym_delete] = ACTIONS(3152),
    [anon_sym_throw] = ACTIONS(3152),
    [anon_sym_namespace] = ACTIONS(3152),
    [anon_sym_using] = ACTIONS(3152),
    [anon_sym_static_assert] = ACTIONS(3152),
    [anon_sym_concept] = ACTIONS(3152),
    [anon_sym_co_return] = ACTIONS(3152),
    [anon_sym_co_yield] = ACTIONS(3152),
    [anon_sym_R_DQUOTE] = ACTIONS(3154),
    [anon_sym_LR_DQUOTE] = ACTIONS(3154),
    [anon_sym_uR_DQUOTE] = ACTIONS(3154),
    [anon_sym_UR_DQUOTE] = ACTIONS(3154),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3154),
    [anon_sym_co_await] = ACTIONS(3152),
    [anon_sym_new] = ACTIONS(3152),
    [anon_sym_requires] = ACTIONS(3152),
    [sym_this] = ACTIONS(3152),
  },
  [717] = {
    [ts_builtin_sym_end] = ACTIONS(1955),
    [sym_identifier] = ACTIONS(1957),
    [aux_sym_preproc_include_token1] = ACTIONS(1957),
    [aux_sym_preproc_def_token1] = ACTIONS(1957),
    [anon_sym_COMMA] = ACTIONS(2743),
    [anon_sym_RPAREN] = ACTIONS(2743),
    [aux_sym_preproc_if_token1] = ACTIONS(1957),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1957),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1957),
    [sym_preproc_directive] = ACTIONS(1957),
    [anon_sym_LPAREN2] = ACTIONS(1955),
    [anon_sym_BANG] = ACTIONS(1955),
    [anon_sym_TILDE] = ACTIONS(1955),
    [anon_sym_DASH] = ACTIONS(1957),
    [anon_sym_PLUS] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(1955),
    [anon_sym_AMP_AMP] = ACTIONS(1955),
    [anon_sym_AMP] = ACTIONS(1957),
    [anon_sym_SEMI] = ACTIONS(2743),
    [anon_sym___extension__] = ACTIONS(1957),
    [anon_sym_typedef] = ACTIONS(1957),
    [anon_sym_extern] = ACTIONS(1957),
    [anon_sym___attribute__] = ACTIONS(1957),
    [anon_sym_COLON_COLON] = ACTIONS(1955),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1955),
    [anon_sym___declspec] = ACTIONS(1957),
    [anon_sym___based] = ACTIONS(1957),
    [anon_sym___cdecl] = ACTIONS(1957),
    [anon_sym___clrcall] = ACTIONS(1957),
    [anon_sym___stdcall] = ACTIONS(1957),
    [anon_sym___fastcall] = ACTIONS(1957),
    [anon_sym___thiscall] = ACTIONS(1957),
    [anon_sym___vectorcall] = ACTIONS(1957),
    [anon_sym_LBRACE] = ACTIONS(1955),
    [anon_sym_signed] = ACTIONS(1957),
    [anon_sym_unsigned] = ACTIONS(1957),
    [anon_sym_long] = ACTIONS(1957),
    [anon_sym_short] = ACTIONS(1957),
    [anon_sym_LBRACK] = ACTIONS(1957),
    [anon_sym_static] = ACTIONS(1957),
    [anon_sym_register] = ACTIONS(1957),
    [anon_sym_inline] = ACTIONS(1957),
    [anon_sym___inline] = ACTIONS(1957),
    [anon_sym___inline__] = ACTIONS(1957),
    [anon_sym___forceinline] = ACTIONS(1957),
    [anon_sym_thread_local] = ACTIONS(1957),
    [anon_sym___thread] = ACTIONS(1957),
    [anon_sym_const] = ACTIONS(1957),
    [anon_sym_constexpr] = ACTIONS(1957),
    [anon_sym_volatile] = ACTIONS(1957),
    [anon_sym_restrict] = ACTIONS(1957),
    [anon_sym___restrict__] = ACTIONS(1957),
    [anon_sym__Atomic] = ACTIONS(1957),
    [anon_sym__Noreturn] = ACTIONS(1957),
    [anon_sym_noreturn] = ACTIONS(1957),
    [anon_sym_mutable] = ACTIONS(1957),
    [anon_sym_constinit] = ACTIONS(1957),
    [anon_sym_consteval] = ACTIONS(1957),
    [anon_sym_PROGMEM] = ACTIONS(1957),
    [aux_sym_primitive_type_token1] = ACTIONS(1957),
    [anon_sym_byte] = ACTIONS(1957),
    [anon_sym_word] = ACTIONS(1957),
    [anon_sym_enum] = ACTIONS(1957),
    [anon_sym_class] = ACTIONS(1957),
    [anon_sym_struct] = ACTIONS(1957),
    [anon_sym_union] = ACTIONS(1957),
    [anon_sym_if] = ACTIONS(1957),
    [anon_sym_switch] = ACTIONS(1957),
    [anon_sym_case] = ACTIONS(1957),
    [anon_sym_default] = ACTIONS(1957),
    [anon_sym_while] = ACTIONS(1957),
    [anon_sym_do] = ACTIONS(1957),
    [anon_sym_for] = ACTIONS(1957),
    [anon_sym_return] = ACTIONS(1957),
    [anon_sym_break] = ACTIONS(1957),
    [anon_sym_continue] = ACTIONS(1957),
    [anon_sym_goto] = ACTIONS(1957),
    [anon_sym_not] = ACTIONS(1957),
    [anon_sym_compl] = ACTIONS(1957),
    [anon_sym_DASH_DASH] = ACTIONS(1955),
    [anon_sym_PLUS_PLUS] = ACTIONS(1955),
    [anon_sym_sizeof] = ACTIONS(1957),
    [anon_sym___alignof__] = ACTIONS(1957),
    [anon_sym___alignof] = ACTIONS(1957),
    [anon_sym__alignof] = ACTIONS(1957),
    [anon_sym_alignof] = ACTIONS(1957),
    [anon_sym__Alignof] = ACTIONS(1957),
    [anon_sym_offsetof] = ACTIONS(1957),
    [anon_sym__Generic] = ACTIONS(1957),
    [anon_sym_asm] = ACTIONS(1957),
    [anon_sym___asm__] = ACTIONS(1957),
    [aux_sym_number_literal_token1] = ACTIONS(1955),
    [aux_sym_number_literal_token2] = ACTIONS(1957),
    [anon_sym_L_SQUOTE] = ACTIONS(1955),
    [anon_sym_u_SQUOTE] = ACTIONS(1955),
    [anon_sym_U_SQUOTE] = ACTIONS(1955),
    [anon_sym_u8_SQUOTE] = ACTIONS(1955),
    [anon_sym_SQUOTE] = ACTIONS(1955),
    [anon_sym_L_DQUOTE] = ACTIONS(1955),
    [anon_sym_u_DQUOTE] = ACTIONS(1955),
    [anon_sym_U_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8_DQUOTE] = ACTIONS(1955),
    [anon_sym_DQUOTE] = ACTIONS(1955),
    [sym_true] = ACTIONS(1957),
    [sym_false] = ACTIONS(1957),
    [anon_sym_NULL] = ACTIONS(1957),
    [anon_sym_nullptr] = ACTIONS(1957),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1957),
    [anon_sym_decltype] = ACTIONS(1957),
    [anon_sym_virtual] = ACTIONS(1957),
    [anon_sym_alignas] = ACTIONS(1957),
    [anon_sym_explicit] = ACTIONS(1957),
    [anon_sym_typename] = ACTIONS(1957),
    [anon_sym_template] = ACTIONS(1957),
    [anon_sym_operator] = ACTIONS(1957),
    [anon_sym_try] = ACTIONS(1957),
    [anon_sym_delete] = ACTIONS(1957),
    [anon_sym_throw] = ACTIONS(1957),
    [anon_sym_namespace] = ACTIONS(1957),
    [anon_sym_using] = ACTIONS(1957),
    [anon_sym_static_assert] = ACTIONS(1957),
    [anon_sym_concept] = ACTIONS(1957),
    [anon_sym_co_return] = ACTIONS(1957),
    [anon_sym_co_yield] = ACTIONS(1957),
    [anon_sym_R_DQUOTE] = ACTIONS(1955),
    [anon_sym_LR_DQUOTE] = ACTIONS(1955),
    [anon_sym_uR_DQUOTE] = ACTIONS(1955),
    [anon_sym_UR_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1955),
    [anon_sym_co_await] = ACTIONS(1957),
    [anon_sym_new] = ACTIONS(1957),
    [anon_sym_requires] = ACTIONS(1957),
    [sym_this] = ACTIONS(1957),
  },
  [718] = {
    [sym_identifier] = ACTIONS(2975),
    [aux_sym_preproc_include_token1] = ACTIONS(2975),
    [aux_sym_preproc_def_token1] = ACTIONS(2975),
    [aux_sym_preproc_if_token1] = ACTIONS(2975),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2975),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2975),
    [sym_preproc_directive] = ACTIONS(2975),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_BANG] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2975),
    [anon_sym_PLUS] = ACTIONS(2975),
    [anon_sym_STAR] = ACTIONS(2977),
    [anon_sym_AMP_AMP] = ACTIONS(2977),
    [anon_sym_AMP] = ACTIONS(2975),
    [anon_sym_SEMI] = ACTIONS(2977),
    [anon_sym___extension__] = ACTIONS(2975),
    [anon_sym_typedef] = ACTIONS(2975),
    [anon_sym_extern] = ACTIONS(2975),
    [anon_sym___attribute__] = ACTIONS(2975),
    [anon_sym_COLON_COLON] = ACTIONS(2977),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2977),
    [anon_sym___declspec] = ACTIONS(2975),
    [anon_sym___based] = ACTIONS(2975),
    [anon_sym___cdecl] = ACTIONS(2975),
    [anon_sym___clrcall] = ACTIONS(2975),
    [anon_sym___stdcall] = ACTIONS(2975),
    [anon_sym___fastcall] = ACTIONS(2975),
    [anon_sym___thiscall] = ACTIONS(2975),
    [anon_sym___vectorcall] = ACTIONS(2975),
    [anon_sym_LBRACE] = ACTIONS(2977),
    [anon_sym_RBRACE] = ACTIONS(2977),
    [anon_sym_signed] = ACTIONS(2975),
    [anon_sym_unsigned] = ACTIONS(2975),
    [anon_sym_long] = ACTIONS(2975),
    [anon_sym_short] = ACTIONS(2975),
    [anon_sym_LBRACK] = ACTIONS(2975),
    [anon_sym_static] = ACTIONS(2975),
    [anon_sym_register] = ACTIONS(2975),
    [anon_sym_inline] = ACTIONS(2975),
    [anon_sym___inline] = ACTIONS(2975),
    [anon_sym___inline__] = ACTIONS(2975),
    [anon_sym___forceinline] = ACTIONS(2975),
    [anon_sym_thread_local] = ACTIONS(2975),
    [anon_sym___thread] = ACTIONS(2975),
    [anon_sym_const] = ACTIONS(2975),
    [anon_sym_constexpr] = ACTIONS(2975),
    [anon_sym_volatile] = ACTIONS(2975),
    [anon_sym_restrict] = ACTIONS(2975),
    [anon_sym___restrict__] = ACTIONS(2975),
    [anon_sym__Atomic] = ACTIONS(2975),
    [anon_sym__Noreturn] = ACTIONS(2975),
    [anon_sym_noreturn] = ACTIONS(2975),
    [anon_sym_mutable] = ACTIONS(2975),
    [anon_sym_constinit] = ACTIONS(2975),
    [anon_sym_consteval] = ACTIONS(2975),
    [anon_sym_PROGMEM] = ACTIONS(2975),
    [aux_sym_primitive_type_token1] = ACTIONS(2975),
    [anon_sym_byte] = ACTIONS(2975),
    [anon_sym_word] = ACTIONS(2975),
    [anon_sym_enum] = ACTIONS(2975),
    [anon_sym_class] = ACTIONS(2975),
    [anon_sym_struct] = ACTIONS(2975),
    [anon_sym_union] = ACTIONS(2975),
    [anon_sym_if] = ACTIONS(2975),
    [anon_sym_switch] = ACTIONS(2975),
    [anon_sym_case] = ACTIONS(2975),
    [anon_sym_default] = ACTIONS(2975),
    [anon_sym_while] = ACTIONS(2975),
    [anon_sym_do] = ACTIONS(2975),
    [anon_sym_for] = ACTIONS(2975),
    [anon_sym_return] = ACTIONS(2975),
    [anon_sym_break] = ACTIONS(2975),
    [anon_sym_continue] = ACTIONS(2975),
    [anon_sym_goto] = ACTIONS(2975),
    [anon_sym___try] = ACTIONS(2975),
    [anon_sym___leave] = ACTIONS(2975),
    [anon_sym_not] = ACTIONS(2975),
    [anon_sym_compl] = ACTIONS(2975),
    [anon_sym_DASH_DASH] = ACTIONS(2977),
    [anon_sym_PLUS_PLUS] = ACTIONS(2977),
    [anon_sym_sizeof] = ACTIONS(2975),
    [anon_sym___alignof__] = ACTIONS(2975),
    [anon_sym___alignof] = ACTIONS(2975),
    [anon_sym__alignof] = ACTIONS(2975),
    [anon_sym_alignof] = ACTIONS(2975),
    [anon_sym__Alignof] = ACTIONS(2975),
    [anon_sym_offsetof] = ACTIONS(2975),
    [anon_sym__Generic] = ACTIONS(2975),
    [anon_sym_asm] = ACTIONS(2975),
    [anon_sym___asm__] = ACTIONS(2975),
    [aux_sym_number_literal_token1] = ACTIONS(2977),
    [aux_sym_number_literal_token2] = ACTIONS(2975),
    [anon_sym_L_SQUOTE] = ACTIONS(2977),
    [anon_sym_u_SQUOTE] = ACTIONS(2977),
    [anon_sym_U_SQUOTE] = ACTIONS(2977),
    [anon_sym_u8_SQUOTE] = ACTIONS(2977),
    [anon_sym_SQUOTE] = ACTIONS(2977),
    [anon_sym_L_DQUOTE] = ACTIONS(2977),
    [anon_sym_u_DQUOTE] = ACTIONS(2977),
    [anon_sym_U_DQUOTE] = ACTIONS(2977),
    [anon_sym_u8_DQUOTE] = ACTIONS(2977),
    [anon_sym_DQUOTE] = ACTIONS(2977),
    [sym_true] = ACTIONS(2975),
    [sym_false] = ACTIONS(2975),
    [anon_sym_NULL] = ACTIONS(2975),
    [anon_sym_nullptr] = ACTIONS(2975),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2975),
    [anon_sym_decltype] = ACTIONS(2975),
    [anon_sym_virtual] = ACTIONS(2975),
    [anon_sym_alignas] = ACTIONS(2975),
    [anon_sym_explicit] = ACTIONS(2975),
    [anon_sym_typename] = ACTIONS(2975),
    [anon_sym_template] = ACTIONS(2975),
    [anon_sym_operator] = ACTIONS(2975),
    [anon_sym_try] = ACTIONS(2975),
    [anon_sym_delete] = ACTIONS(2975),
    [anon_sym_throw] = ACTIONS(2975),
    [anon_sym_namespace] = ACTIONS(2975),
    [anon_sym_using] = ACTIONS(2975),
    [anon_sym_static_assert] = ACTIONS(2975),
    [anon_sym_concept] = ACTIONS(2975),
    [anon_sym_co_return] = ACTIONS(2975),
    [anon_sym_co_yield] = ACTIONS(2975),
    [anon_sym_R_DQUOTE] = ACTIONS(2977),
    [anon_sym_LR_DQUOTE] = ACTIONS(2977),
    [anon_sym_uR_DQUOTE] = ACTIONS(2977),
    [anon_sym_UR_DQUOTE] = ACTIONS(2977),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2977),
    [anon_sym_co_await] = ACTIONS(2975),
    [anon_sym_new] = ACTIONS(2975),
    [anon_sym_requires] = ACTIONS(2975),
    [sym_this] = ACTIONS(2975),
  },
  [719] = {
    [sym_identifier] = ACTIONS(2971),
    [aux_sym_preproc_include_token1] = ACTIONS(2971),
    [aux_sym_preproc_def_token1] = ACTIONS(2971),
    [aux_sym_preproc_if_token1] = ACTIONS(2971),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2971),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2971),
    [sym_preproc_directive] = ACTIONS(2971),
    [anon_sym_LPAREN2] = ACTIONS(2973),
    [anon_sym_BANG] = ACTIONS(2973),
    [anon_sym_TILDE] = ACTIONS(2973),
    [anon_sym_DASH] = ACTIONS(2971),
    [anon_sym_PLUS] = ACTIONS(2971),
    [anon_sym_STAR] = ACTIONS(2973),
    [anon_sym_AMP_AMP] = ACTIONS(2973),
    [anon_sym_AMP] = ACTIONS(2971),
    [anon_sym_SEMI] = ACTIONS(2973),
    [anon_sym___extension__] = ACTIONS(2971),
    [anon_sym_typedef] = ACTIONS(2971),
    [anon_sym_extern] = ACTIONS(2971),
    [anon_sym___attribute__] = ACTIONS(2971),
    [anon_sym_COLON_COLON] = ACTIONS(2973),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2973),
    [anon_sym___declspec] = ACTIONS(2971),
    [anon_sym___based] = ACTIONS(2971),
    [anon_sym___cdecl] = ACTIONS(2971),
    [anon_sym___clrcall] = ACTIONS(2971),
    [anon_sym___stdcall] = ACTIONS(2971),
    [anon_sym___fastcall] = ACTIONS(2971),
    [anon_sym___thiscall] = ACTIONS(2971),
    [anon_sym___vectorcall] = ACTIONS(2971),
    [anon_sym_LBRACE] = ACTIONS(2973),
    [anon_sym_RBRACE] = ACTIONS(2973),
    [anon_sym_signed] = ACTIONS(2971),
    [anon_sym_unsigned] = ACTIONS(2971),
    [anon_sym_long] = ACTIONS(2971),
    [anon_sym_short] = ACTIONS(2971),
    [anon_sym_LBRACK] = ACTIONS(2971),
    [anon_sym_static] = ACTIONS(2971),
    [anon_sym_register] = ACTIONS(2971),
    [anon_sym_inline] = ACTIONS(2971),
    [anon_sym___inline] = ACTIONS(2971),
    [anon_sym___inline__] = ACTIONS(2971),
    [anon_sym___forceinline] = ACTIONS(2971),
    [anon_sym_thread_local] = ACTIONS(2971),
    [anon_sym___thread] = ACTIONS(2971),
    [anon_sym_const] = ACTIONS(2971),
    [anon_sym_constexpr] = ACTIONS(2971),
    [anon_sym_volatile] = ACTIONS(2971),
    [anon_sym_restrict] = ACTIONS(2971),
    [anon_sym___restrict__] = ACTIONS(2971),
    [anon_sym__Atomic] = ACTIONS(2971),
    [anon_sym__Noreturn] = ACTIONS(2971),
    [anon_sym_noreturn] = ACTIONS(2971),
    [anon_sym_mutable] = ACTIONS(2971),
    [anon_sym_constinit] = ACTIONS(2971),
    [anon_sym_consteval] = ACTIONS(2971),
    [anon_sym_PROGMEM] = ACTIONS(2971),
    [aux_sym_primitive_type_token1] = ACTIONS(2971),
    [anon_sym_byte] = ACTIONS(2971),
    [anon_sym_word] = ACTIONS(2971),
    [anon_sym_enum] = ACTIONS(2971),
    [anon_sym_class] = ACTIONS(2971),
    [anon_sym_struct] = ACTIONS(2971),
    [anon_sym_union] = ACTIONS(2971),
    [anon_sym_if] = ACTIONS(2971),
    [anon_sym_switch] = ACTIONS(2971),
    [anon_sym_case] = ACTIONS(2971),
    [anon_sym_default] = ACTIONS(2971),
    [anon_sym_while] = ACTIONS(2971),
    [anon_sym_do] = ACTIONS(2971),
    [anon_sym_for] = ACTIONS(2971),
    [anon_sym_return] = ACTIONS(2971),
    [anon_sym_break] = ACTIONS(2971),
    [anon_sym_continue] = ACTIONS(2971),
    [anon_sym_goto] = ACTIONS(2971),
    [anon_sym___try] = ACTIONS(2971),
    [anon_sym___leave] = ACTIONS(2971),
    [anon_sym_not] = ACTIONS(2971),
    [anon_sym_compl] = ACTIONS(2971),
    [anon_sym_DASH_DASH] = ACTIONS(2973),
    [anon_sym_PLUS_PLUS] = ACTIONS(2973),
    [anon_sym_sizeof] = ACTIONS(2971),
    [anon_sym___alignof__] = ACTIONS(2971),
    [anon_sym___alignof] = ACTIONS(2971),
    [anon_sym__alignof] = ACTIONS(2971),
    [anon_sym_alignof] = ACTIONS(2971),
    [anon_sym__Alignof] = ACTIONS(2971),
    [anon_sym_offsetof] = ACTIONS(2971),
    [anon_sym__Generic] = ACTIONS(2971),
    [anon_sym_asm] = ACTIONS(2971),
    [anon_sym___asm__] = ACTIONS(2971),
    [aux_sym_number_literal_token1] = ACTIONS(2973),
    [aux_sym_number_literal_token2] = ACTIONS(2971),
    [anon_sym_L_SQUOTE] = ACTIONS(2973),
    [anon_sym_u_SQUOTE] = ACTIONS(2973),
    [anon_sym_U_SQUOTE] = ACTIONS(2973),
    [anon_sym_u8_SQUOTE] = ACTIONS(2973),
    [anon_sym_SQUOTE] = ACTIONS(2973),
    [anon_sym_L_DQUOTE] = ACTIONS(2973),
    [anon_sym_u_DQUOTE] = ACTIONS(2973),
    [anon_sym_U_DQUOTE] = ACTIONS(2973),
    [anon_sym_u8_DQUOTE] = ACTIONS(2973),
    [anon_sym_DQUOTE] = ACTIONS(2973),
    [sym_true] = ACTIONS(2971),
    [sym_false] = ACTIONS(2971),
    [anon_sym_NULL] = ACTIONS(2971),
    [anon_sym_nullptr] = ACTIONS(2971),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2971),
    [anon_sym_decltype] = ACTIONS(2971),
    [anon_sym_virtual] = ACTIONS(2971),
    [anon_sym_alignas] = ACTIONS(2971),
    [anon_sym_explicit] = ACTIONS(2971),
    [anon_sym_typename] = ACTIONS(2971),
    [anon_sym_template] = ACTIONS(2971),
    [anon_sym_operator] = ACTIONS(2971),
    [anon_sym_try] = ACTIONS(2971),
    [anon_sym_delete] = ACTIONS(2971),
    [anon_sym_throw] = ACTIONS(2971),
    [anon_sym_namespace] = ACTIONS(2971),
    [anon_sym_using] = ACTIONS(2971),
    [anon_sym_static_assert] = ACTIONS(2971),
    [anon_sym_concept] = ACTIONS(2971),
    [anon_sym_co_return] = ACTIONS(2971),
    [anon_sym_co_yield] = ACTIONS(2971),
    [anon_sym_R_DQUOTE] = ACTIONS(2973),
    [anon_sym_LR_DQUOTE] = ACTIONS(2973),
    [anon_sym_uR_DQUOTE] = ACTIONS(2973),
    [anon_sym_UR_DQUOTE] = ACTIONS(2973),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2973),
    [anon_sym_co_await] = ACTIONS(2971),
    [anon_sym_new] = ACTIONS(2971),
    [anon_sym_requires] = ACTIONS(2971),
    [sym_this] = ACTIONS(2971),
  },
  [720] = {
    [sym_identifier] = ACTIONS(2893),
    [aux_sym_preproc_include_token1] = ACTIONS(2893),
    [aux_sym_preproc_def_token1] = ACTIONS(2893),
    [aux_sym_preproc_if_token1] = ACTIONS(2893),
    [aux_sym_preproc_if_token2] = ACTIONS(2893),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2893),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2893),
    [sym_preproc_directive] = ACTIONS(2893),
    [anon_sym_LPAREN2] = ACTIONS(2895),
    [anon_sym_BANG] = ACTIONS(2895),
    [anon_sym_TILDE] = ACTIONS(2895),
    [anon_sym_DASH] = ACTIONS(2893),
    [anon_sym_PLUS] = ACTIONS(2893),
    [anon_sym_STAR] = ACTIONS(2895),
    [anon_sym_AMP_AMP] = ACTIONS(2895),
    [anon_sym_AMP] = ACTIONS(2893),
    [anon_sym_SEMI] = ACTIONS(2895),
    [anon_sym___extension__] = ACTIONS(2893),
    [anon_sym_typedef] = ACTIONS(2893),
    [anon_sym_extern] = ACTIONS(2893),
    [anon_sym___attribute__] = ACTIONS(2893),
    [anon_sym_COLON_COLON] = ACTIONS(2895),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2895),
    [anon_sym___declspec] = ACTIONS(2893),
    [anon_sym___based] = ACTIONS(2893),
    [anon_sym___cdecl] = ACTIONS(2893),
    [anon_sym___clrcall] = ACTIONS(2893),
    [anon_sym___stdcall] = ACTIONS(2893),
    [anon_sym___fastcall] = ACTIONS(2893),
    [anon_sym___thiscall] = ACTIONS(2893),
    [anon_sym___vectorcall] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(2895),
    [anon_sym_signed] = ACTIONS(2893),
    [anon_sym_unsigned] = ACTIONS(2893),
    [anon_sym_long] = ACTIONS(2893),
    [anon_sym_short] = ACTIONS(2893),
    [anon_sym_LBRACK] = ACTIONS(2893),
    [anon_sym_static] = ACTIONS(2893),
    [anon_sym_register] = ACTIONS(2893),
    [anon_sym_inline] = ACTIONS(2893),
    [anon_sym___inline] = ACTIONS(2893),
    [anon_sym___inline__] = ACTIONS(2893),
    [anon_sym___forceinline] = ACTIONS(2893),
    [anon_sym_thread_local] = ACTIONS(2893),
    [anon_sym___thread] = ACTIONS(2893),
    [anon_sym_const] = ACTIONS(2893),
    [anon_sym_constexpr] = ACTIONS(2893),
    [anon_sym_volatile] = ACTIONS(2893),
    [anon_sym_restrict] = ACTIONS(2893),
    [anon_sym___restrict__] = ACTIONS(2893),
    [anon_sym__Atomic] = ACTIONS(2893),
    [anon_sym__Noreturn] = ACTIONS(2893),
    [anon_sym_noreturn] = ACTIONS(2893),
    [anon_sym_mutable] = ACTIONS(2893),
    [anon_sym_constinit] = ACTIONS(2893),
    [anon_sym_consteval] = ACTIONS(2893),
    [anon_sym_PROGMEM] = ACTIONS(2893),
    [aux_sym_primitive_type_token1] = ACTIONS(2893),
    [anon_sym_byte] = ACTIONS(2893),
    [anon_sym_word] = ACTIONS(2893),
    [anon_sym_enum] = ACTIONS(2893),
    [anon_sym_class] = ACTIONS(2893),
    [anon_sym_struct] = ACTIONS(2893),
    [anon_sym_union] = ACTIONS(2893),
    [anon_sym_if] = ACTIONS(2893),
    [anon_sym_switch] = ACTIONS(2893),
    [anon_sym_case] = ACTIONS(2893),
    [anon_sym_default] = ACTIONS(2893),
    [anon_sym_while] = ACTIONS(2893),
    [anon_sym_do] = ACTIONS(2893),
    [anon_sym_for] = ACTIONS(2893),
    [anon_sym_return] = ACTIONS(2893),
    [anon_sym_break] = ACTIONS(2893),
    [anon_sym_continue] = ACTIONS(2893),
    [anon_sym_goto] = ACTIONS(2893),
    [anon_sym___try] = ACTIONS(2893),
    [anon_sym___leave] = ACTIONS(2893),
    [anon_sym_not] = ACTIONS(2893),
    [anon_sym_compl] = ACTIONS(2893),
    [anon_sym_DASH_DASH] = ACTIONS(2895),
    [anon_sym_PLUS_PLUS] = ACTIONS(2895),
    [anon_sym_sizeof] = ACTIONS(2893),
    [anon_sym___alignof__] = ACTIONS(2893),
    [anon_sym___alignof] = ACTIONS(2893),
    [anon_sym__alignof] = ACTIONS(2893),
    [anon_sym_alignof] = ACTIONS(2893),
    [anon_sym__Alignof] = ACTIONS(2893),
    [anon_sym_offsetof] = ACTIONS(2893),
    [anon_sym__Generic] = ACTIONS(2893),
    [anon_sym_asm] = ACTIONS(2893),
    [anon_sym___asm__] = ACTIONS(2893),
    [aux_sym_number_literal_token1] = ACTIONS(2895),
    [aux_sym_number_literal_token2] = ACTIONS(2893),
    [anon_sym_L_SQUOTE] = ACTIONS(2895),
    [anon_sym_u_SQUOTE] = ACTIONS(2895),
    [anon_sym_U_SQUOTE] = ACTIONS(2895),
    [anon_sym_u8_SQUOTE] = ACTIONS(2895),
    [anon_sym_SQUOTE] = ACTIONS(2895),
    [anon_sym_L_DQUOTE] = ACTIONS(2895),
    [anon_sym_u_DQUOTE] = ACTIONS(2895),
    [anon_sym_U_DQUOTE] = ACTIONS(2895),
    [anon_sym_u8_DQUOTE] = ACTIONS(2895),
    [anon_sym_DQUOTE] = ACTIONS(2895),
    [sym_true] = ACTIONS(2893),
    [sym_false] = ACTIONS(2893),
    [anon_sym_NULL] = ACTIONS(2893),
    [anon_sym_nullptr] = ACTIONS(2893),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2893),
    [anon_sym_decltype] = ACTIONS(2893),
    [anon_sym_virtual] = ACTIONS(2893),
    [anon_sym_alignas] = ACTIONS(2893),
    [anon_sym_explicit] = ACTIONS(2893),
    [anon_sym_typename] = ACTIONS(2893),
    [anon_sym_template] = ACTIONS(2893),
    [anon_sym_operator] = ACTIONS(2893),
    [anon_sym_try] = ACTIONS(2893),
    [anon_sym_delete] = ACTIONS(2893),
    [anon_sym_throw] = ACTIONS(2893),
    [anon_sym_namespace] = ACTIONS(2893),
    [anon_sym_using] = ACTIONS(2893),
    [anon_sym_static_assert] = ACTIONS(2893),
    [anon_sym_concept] = ACTIONS(2893),
    [anon_sym_co_return] = ACTIONS(2893),
    [anon_sym_co_yield] = ACTIONS(2893),
    [anon_sym_R_DQUOTE] = ACTIONS(2895),
    [anon_sym_LR_DQUOTE] = ACTIONS(2895),
    [anon_sym_uR_DQUOTE] = ACTIONS(2895),
    [anon_sym_UR_DQUOTE] = ACTIONS(2895),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2895),
    [anon_sym_co_await] = ACTIONS(2893),
    [anon_sym_new] = ACTIONS(2893),
    [anon_sym_requires] = ACTIONS(2893),
    [sym_this] = ACTIONS(2893),
  },
  [721] = {
    [sym_identifier] = ACTIONS(3156),
    [aux_sym_preproc_include_token1] = ACTIONS(3156),
    [aux_sym_preproc_def_token1] = ACTIONS(3156),
    [aux_sym_preproc_if_token1] = ACTIONS(3156),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3156),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3156),
    [sym_preproc_directive] = ACTIONS(3156),
    [anon_sym_LPAREN2] = ACTIONS(3158),
    [anon_sym_BANG] = ACTIONS(3158),
    [anon_sym_TILDE] = ACTIONS(3158),
    [anon_sym_DASH] = ACTIONS(3156),
    [anon_sym_PLUS] = ACTIONS(3156),
    [anon_sym_STAR] = ACTIONS(3158),
    [anon_sym_AMP_AMP] = ACTIONS(3158),
    [anon_sym_AMP] = ACTIONS(3156),
    [anon_sym_SEMI] = ACTIONS(3158),
    [anon_sym___extension__] = ACTIONS(3156),
    [anon_sym_typedef] = ACTIONS(3156),
    [anon_sym_extern] = ACTIONS(3156),
    [anon_sym___attribute__] = ACTIONS(3156),
    [anon_sym_COLON_COLON] = ACTIONS(3158),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3158),
    [anon_sym___declspec] = ACTIONS(3156),
    [anon_sym___based] = ACTIONS(3156),
    [anon_sym___cdecl] = ACTIONS(3156),
    [anon_sym___clrcall] = ACTIONS(3156),
    [anon_sym___stdcall] = ACTIONS(3156),
    [anon_sym___fastcall] = ACTIONS(3156),
    [anon_sym___thiscall] = ACTIONS(3156),
    [anon_sym___vectorcall] = ACTIONS(3156),
    [anon_sym_LBRACE] = ACTIONS(3158),
    [anon_sym_RBRACE] = ACTIONS(3158),
    [anon_sym_signed] = ACTIONS(3156),
    [anon_sym_unsigned] = ACTIONS(3156),
    [anon_sym_long] = ACTIONS(3156),
    [anon_sym_short] = ACTIONS(3156),
    [anon_sym_LBRACK] = ACTIONS(3156),
    [anon_sym_static] = ACTIONS(3156),
    [anon_sym_register] = ACTIONS(3156),
    [anon_sym_inline] = ACTIONS(3156),
    [anon_sym___inline] = ACTIONS(3156),
    [anon_sym___inline__] = ACTIONS(3156),
    [anon_sym___forceinline] = ACTIONS(3156),
    [anon_sym_thread_local] = ACTIONS(3156),
    [anon_sym___thread] = ACTIONS(3156),
    [anon_sym_const] = ACTIONS(3156),
    [anon_sym_constexpr] = ACTIONS(3156),
    [anon_sym_volatile] = ACTIONS(3156),
    [anon_sym_restrict] = ACTIONS(3156),
    [anon_sym___restrict__] = ACTIONS(3156),
    [anon_sym__Atomic] = ACTIONS(3156),
    [anon_sym__Noreturn] = ACTIONS(3156),
    [anon_sym_noreturn] = ACTIONS(3156),
    [anon_sym_mutable] = ACTIONS(3156),
    [anon_sym_constinit] = ACTIONS(3156),
    [anon_sym_consteval] = ACTIONS(3156),
    [anon_sym_PROGMEM] = ACTIONS(3156),
    [aux_sym_primitive_type_token1] = ACTIONS(3156),
    [anon_sym_byte] = ACTIONS(3156),
    [anon_sym_word] = ACTIONS(3156),
    [anon_sym_enum] = ACTIONS(3156),
    [anon_sym_class] = ACTIONS(3156),
    [anon_sym_struct] = ACTIONS(3156),
    [anon_sym_union] = ACTIONS(3156),
    [anon_sym_if] = ACTIONS(3156),
    [anon_sym_switch] = ACTIONS(3156),
    [anon_sym_case] = ACTIONS(3156),
    [anon_sym_default] = ACTIONS(3156),
    [anon_sym_while] = ACTIONS(3156),
    [anon_sym_do] = ACTIONS(3156),
    [anon_sym_for] = ACTIONS(3156),
    [anon_sym_return] = ACTIONS(3156),
    [anon_sym_break] = ACTIONS(3156),
    [anon_sym_continue] = ACTIONS(3156),
    [anon_sym_goto] = ACTIONS(3156),
    [anon_sym___try] = ACTIONS(3156),
    [anon_sym___leave] = ACTIONS(3156),
    [anon_sym_not] = ACTIONS(3156),
    [anon_sym_compl] = ACTIONS(3156),
    [anon_sym_DASH_DASH] = ACTIONS(3158),
    [anon_sym_PLUS_PLUS] = ACTIONS(3158),
    [anon_sym_sizeof] = ACTIONS(3156),
    [anon_sym___alignof__] = ACTIONS(3156),
    [anon_sym___alignof] = ACTIONS(3156),
    [anon_sym__alignof] = ACTIONS(3156),
    [anon_sym_alignof] = ACTIONS(3156),
    [anon_sym__Alignof] = ACTIONS(3156),
    [anon_sym_offsetof] = ACTIONS(3156),
    [anon_sym__Generic] = ACTIONS(3156),
    [anon_sym_asm] = ACTIONS(3156),
    [anon_sym___asm__] = ACTIONS(3156),
    [aux_sym_number_literal_token1] = ACTIONS(3158),
    [aux_sym_number_literal_token2] = ACTIONS(3156),
    [anon_sym_L_SQUOTE] = ACTIONS(3158),
    [anon_sym_u_SQUOTE] = ACTIONS(3158),
    [anon_sym_U_SQUOTE] = ACTIONS(3158),
    [anon_sym_u8_SQUOTE] = ACTIONS(3158),
    [anon_sym_SQUOTE] = ACTIONS(3158),
    [anon_sym_L_DQUOTE] = ACTIONS(3158),
    [anon_sym_u_DQUOTE] = ACTIONS(3158),
    [anon_sym_U_DQUOTE] = ACTIONS(3158),
    [anon_sym_u8_DQUOTE] = ACTIONS(3158),
    [anon_sym_DQUOTE] = ACTIONS(3158),
    [sym_true] = ACTIONS(3156),
    [sym_false] = ACTIONS(3156),
    [anon_sym_NULL] = ACTIONS(3156),
    [anon_sym_nullptr] = ACTIONS(3156),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3156),
    [anon_sym_decltype] = ACTIONS(3156),
    [anon_sym_virtual] = ACTIONS(3156),
    [anon_sym_alignas] = ACTIONS(3156),
    [anon_sym_explicit] = ACTIONS(3156),
    [anon_sym_typename] = ACTIONS(3156),
    [anon_sym_template] = ACTIONS(3156),
    [anon_sym_operator] = ACTIONS(3156),
    [anon_sym_try] = ACTIONS(3156),
    [anon_sym_delete] = ACTIONS(3156),
    [anon_sym_throw] = ACTIONS(3156),
    [anon_sym_namespace] = ACTIONS(3156),
    [anon_sym_using] = ACTIONS(3156),
    [anon_sym_static_assert] = ACTIONS(3156),
    [anon_sym_concept] = ACTIONS(3156),
    [anon_sym_co_return] = ACTIONS(3156),
    [anon_sym_co_yield] = ACTIONS(3156),
    [anon_sym_R_DQUOTE] = ACTIONS(3158),
    [anon_sym_LR_DQUOTE] = ACTIONS(3158),
    [anon_sym_uR_DQUOTE] = ACTIONS(3158),
    [anon_sym_UR_DQUOTE] = ACTIONS(3158),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3158),
    [anon_sym_co_await] = ACTIONS(3156),
    [anon_sym_new] = ACTIONS(3156),
    [anon_sym_requires] = ACTIONS(3156),
    [sym_this] = ACTIONS(3156),
  },
  [722] = {
    [sym_identifier] = ACTIONS(3170),
    [aux_sym_preproc_include_token1] = ACTIONS(3170),
    [aux_sym_preproc_def_token1] = ACTIONS(3170),
    [aux_sym_preproc_if_token1] = ACTIONS(3170),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3170),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3170),
    [sym_preproc_directive] = ACTIONS(3170),
    [anon_sym_LPAREN2] = ACTIONS(3172),
    [anon_sym_BANG] = ACTIONS(3172),
    [anon_sym_TILDE] = ACTIONS(3172),
    [anon_sym_DASH] = ACTIONS(3170),
    [anon_sym_PLUS] = ACTIONS(3170),
    [anon_sym_STAR] = ACTIONS(3172),
    [anon_sym_AMP_AMP] = ACTIONS(3172),
    [anon_sym_AMP] = ACTIONS(3170),
    [anon_sym_SEMI] = ACTIONS(3172),
    [anon_sym___extension__] = ACTIONS(3170),
    [anon_sym_typedef] = ACTIONS(3170),
    [anon_sym_extern] = ACTIONS(3170),
    [anon_sym___attribute__] = ACTIONS(3170),
    [anon_sym_COLON_COLON] = ACTIONS(3172),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3172),
    [anon_sym___declspec] = ACTIONS(3170),
    [anon_sym___based] = ACTIONS(3170),
    [anon_sym___cdecl] = ACTIONS(3170),
    [anon_sym___clrcall] = ACTIONS(3170),
    [anon_sym___stdcall] = ACTIONS(3170),
    [anon_sym___fastcall] = ACTIONS(3170),
    [anon_sym___thiscall] = ACTIONS(3170),
    [anon_sym___vectorcall] = ACTIONS(3170),
    [anon_sym_LBRACE] = ACTIONS(3172),
    [anon_sym_RBRACE] = ACTIONS(3172),
    [anon_sym_signed] = ACTIONS(3170),
    [anon_sym_unsigned] = ACTIONS(3170),
    [anon_sym_long] = ACTIONS(3170),
    [anon_sym_short] = ACTIONS(3170),
    [anon_sym_LBRACK] = ACTIONS(3170),
    [anon_sym_static] = ACTIONS(3170),
    [anon_sym_register] = ACTIONS(3170),
    [anon_sym_inline] = ACTIONS(3170),
    [anon_sym___inline] = ACTIONS(3170),
    [anon_sym___inline__] = ACTIONS(3170),
    [anon_sym___forceinline] = ACTIONS(3170),
    [anon_sym_thread_local] = ACTIONS(3170),
    [anon_sym___thread] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3170),
    [anon_sym_constexpr] = ACTIONS(3170),
    [anon_sym_volatile] = ACTIONS(3170),
    [anon_sym_restrict] = ACTIONS(3170),
    [anon_sym___restrict__] = ACTIONS(3170),
    [anon_sym__Atomic] = ACTIONS(3170),
    [anon_sym__Noreturn] = ACTIONS(3170),
    [anon_sym_noreturn] = ACTIONS(3170),
    [anon_sym_mutable] = ACTIONS(3170),
    [anon_sym_constinit] = ACTIONS(3170),
    [anon_sym_consteval] = ACTIONS(3170),
    [anon_sym_PROGMEM] = ACTIONS(3170),
    [aux_sym_primitive_type_token1] = ACTIONS(3170),
    [anon_sym_byte] = ACTIONS(3170),
    [anon_sym_word] = ACTIONS(3170),
    [anon_sym_enum] = ACTIONS(3170),
    [anon_sym_class] = ACTIONS(3170),
    [anon_sym_struct] = ACTIONS(3170),
    [anon_sym_union] = ACTIONS(3170),
    [anon_sym_if] = ACTIONS(3170),
    [anon_sym_switch] = ACTIONS(3170),
    [anon_sym_case] = ACTIONS(3170),
    [anon_sym_default] = ACTIONS(3170),
    [anon_sym_while] = ACTIONS(3170),
    [anon_sym_do] = ACTIONS(3170),
    [anon_sym_for] = ACTIONS(3170),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_break] = ACTIONS(3170),
    [anon_sym_continue] = ACTIONS(3170),
    [anon_sym_goto] = ACTIONS(3170),
    [anon_sym___try] = ACTIONS(3170),
    [anon_sym___leave] = ACTIONS(3170),
    [anon_sym_not] = ACTIONS(3170),
    [anon_sym_compl] = ACTIONS(3170),
    [anon_sym_DASH_DASH] = ACTIONS(3172),
    [anon_sym_PLUS_PLUS] = ACTIONS(3172),
    [anon_sym_sizeof] = ACTIONS(3170),
    [anon_sym___alignof__] = ACTIONS(3170),
    [anon_sym___alignof] = ACTIONS(3170),
    [anon_sym__alignof] = ACTIONS(3170),
    [anon_sym_alignof] = ACTIONS(3170),
    [anon_sym__Alignof] = ACTIONS(3170),
    [anon_sym_offsetof] = ACTIONS(3170),
    [anon_sym__Generic] = ACTIONS(3170),
    [anon_sym_asm] = ACTIONS(3170),
    [anon_sym___asm__] = ACTIONS(3170),
    [aux_sym_number_literal_token1] = ACTIONS(3172),
    [aux_sym_number_literal_token2] = ACTIONS(3170),
    [anon_sym_L_SQUOTE] = ACTIONS(3172),
    [anon_sym_u_SQUOTE] = ACTIONS(3172),
    [anon_sym_U_SQUOTE] = ACTIONS(3172),
    [anon_sym_u8_SQUOTE] = ACTIONS(3172),
    [anon_sym_SQUOTE] = ACTIONS(3172),
    [anon_sym_L_DQUOTE] = ACTIONS(3172),
    [anon_sym_u_DQUOTE] = ACTIONS(3172),
    [anon_sym_U_DQUOTE] = ACTIONS(3172),
    [anon_sym_u8_DQUOTE] = ACTIONS(3172),
    [anon_sym_DQUOTE] = ACTIONS(3172),
    [sym_true] = ACTIONS(3170),
    [sym_false] = ACTIONS(3170),
    [anon_sym_NULL] = ACTIONS(3170),
    [anon_sym_nullptr] = ACTIONS(3170),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3170),
    [anon_sym_decltype] = ACTIONS(3170),
    [anon_sym_virtual] = ACTIONS(3170),
    [anon_sym_alignas] = ACTIONS(3170),
    [anon_sym_explicit] = ACTIONS(3170),
    [anon_sym_typename] = ACTIONS(3170),
    [anon_sym_template] = ACTIONS(3170),
    [anon_sym_operator] = ACTIONS(3170),
    [anon_sym_try] = ACTIONS(3170),
    [anon_sym_delete] = ACTIONS(3170),
    [anon_sym_throw] = ACTIONS(3170),
    [anon_sym_namespace] = ACTIONS(3170),
    [anon_sym_using] = ACTIONS(3170),
    [anon_sym_static_assert] = ACTIONS(3170),
    [anon_sym_concept] = ACTIONS(3170),
    [anon_sym_co_return] = ACTIONS(3170),
    [anon_sym_co_yield] = ACTIONS(3170),
    [anon_sym_R_DQUOTE] = ACTIONS(3172),
    [anon_sym_LR_DQUOTE] = ACTIONS(3172),
    [anon_sym_uR_DQUOTE] = ACTIONS(3172),
    [anon_sym_UR_DQUOTE] = ACTIONS(3172),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3172),
    [anon_sym_co_await] = ACTIONS(3170),
    [anon_sym_new] = ACTIONS(3170),
    [anon_sym_requires] = ACTIONS(3170),
    [sym_this] = ACTIONS(3170),
  },
  [723] = {
    [sym_identifier] = ACTIONS(2945),
    [aux_sym_preproc_include_token1] = ACTIONS(2945),
    [aux_sym_preproc_def_token1] = ACTIONS(2945),
    [aux_sym_preproc_if_token1] = ACTIONS(2945),
    [aux_sym_preproc_if_token2] = ACTIONS(2945),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2945),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2945),
    [sym_preproc_directive] = ACTIONS(2945),
    [anon_sym_LPAREN2] = ACTIONS(2947),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2947),
    [anon_sym_DASH] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(2945),
    [anon_sym_STAR] = ACTIONS(2947),
    [anon_sym_AMP_AMP] = ACTIONS(2947),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_SEMI] = ACTIONS(2947),
    [anon_sym___extension__] = ACTIONS(2945),
    [anon_sym_typedef] = ACTIONS(2945),
    [anon_sym_extern] = ACTIONS(2945),
    [anon_sym___attribute__] = ACTIONS(2945),
    [anon_sym_COLON_COLON] = ACTIONS(2947),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2947),
    [anon_sym___declspec] = ACTIONS(2945),
    [anon_sym___based] = ACTIONS(2945),
    [anon_sym___cdecl] = ACTIONS(2945),
    [anon_sym___clrcall] = ACTIONS(2945),
    [anon_sym___stdcall] = ACTIONS(2945),
    [anon_sym___fastcall] = ACTIONS(2945),
    [anon_sym___thiscall] = ACTIONS(2945),
    [anon_sym___vectorcall] = ACTIONS(2945),
    [anon_sym_LBRACE] = ACTIONS(2947),
    [anon_sym_signed] = ACTIONS(2945),
    [anon_sym_unsigned] = ACTIONS(2945),
    [anon_sym_long] = ACTIONS(2945),
    [anon_sym_short] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(2945),
    [anon_sym_static] = ACTIONS(2945),
    [anon_sym_register] = ACTIONS(2945),
    [anon_sym_inline] = ACTIONS(2945),
    [anon_sym___inline] = ACTIONS(2945),
    [anon_sym___inline__] = ACTIONS(2945),
    [anon_sym___forceinline] = ACTIONS(2945),
    [anon_sym_thread_local] = ACTIONS(2945),
    [anon_sym___thread] = ACTIONS(2945),
    [anon_sym_const] = ACTIONS(2945),
    [anon_sym_constexpr] = ACTIONS(2945),
    [anon_sym_volatile] = ACTIONS(2945),
    [anon_sym_restrict] = ACTIONS(2945),
    [anon_sym___restrict__] = ACTIONS(2945),
    [anon_sym__Atomic] = ACTIONS(2945),
    [anon_sym__Noreturn] = ACTIONS(2945),
    [anon_sym_noreturn] = ACTIONS(2945),
    [anon_sym_mutable] = ACTIONS(2945),
    [anon_sym_constinit] = ACTIONS(2945),
    [anon_sym_consteval] = ACTIONS(2945),
    [anon_sym_PROGMEM] = ACTIONS(2945),
    [aux_sym_primitive_type_token1] = ACTIONS(2945),
    [anon_sym_byte] = ACTIONS(2945),
    [anon_sym_word] = ACTIONS(2945),
    [anon_sym_enum] = ACTIONS(2945),
    [anon_sym_class] = ACTIONS(2945),
    [anon_sym_struct] = ACTIONS(2945),
    [anon_sym_union] = ACTIONS(2945),
    [anon_sym_if] = ACTIONS(2945),
    [anon_sym_switch] = ACTIONS(2945),
    [anon_sym_case] = ACTIONS(2945),
    [anon_sym_default] = ACTIONS(2945),
    [anon_sym_while] = ACTIONS(2945),
    [anon_sym_do] = ACTIONS(2945),
    [anon_sym_for] = ACTIONS(2945),
    [anon_sym_return] = ACTIONS(2945),
    [anon_sym_break] = ACTIONS(2945),
    [anon_sym_continue] = ACTIONS(2945),
    [anon_sym_goto] = ACTIONS(2945),
    [anon_sym___try] = ACTIONS(2945),
    [anon_sym___leave] = ACTIONS(2945),
    [anon_sym_not] = ACTIONS(2945),
    [anon_sym_compl] = ACTIONS(2945),
    [anon_sym_DASH_DASH] = ACTIONS(2947),
    [anon_sym_PLUS_PLUS] = ACTIONS(2947),
    [anon_sym_sizeof] = ACTIONS(2945),
    [anon_sym___alignof__] = ACTIONS(2945),
    [anon_sym___alignof] = ACTIONS(2945),
    [anon_sym__alignof] = ACTIONS(2945),
    [anon_sym_alignof] = ACTIONS(2945),
    [anon_sym__Alignof] = ACTIONS(2945),
    [anon_sym_offsetof] = ACTIONS(2945),
    [anon_sym__Generic] = ACTIONS(2945),
    [anon_sym_asm] = ACTIONS(2945),
    [anon_sym___asm__] = ACTIONS(2945),
    [aux_sym_number_literal_token1] = ACTIONS(2947),
    [aux_sym_number_literal_token2] = ACTIONS(2945),
    [anon_sym_L_SQUOTE] = ACTIONS(2947),
    [anon_sym_u_SQUOTE] = ACTIONS(2947),
    [anon_sym_U_SQUOTE] = ACTIONS(2947),
    [anon_sym_u8_SQUOTE] = ACTIONS(2947),
    [anon_sym_SQUOTE] = ACTIONS(2947),
    [anon_sym_L_DQUOTE] = ACTIONS(2947),
    [anon_sym_u_DQUOTE] = ACTIONS(2947),
    [anon_sym_U_DQUOTE] = ACTIONS(2947),
    [anon_sym_u8_DQUOTE] = ACTIONS(2947),
    [anon_sym_DQUOTE] = ACTIONS(2947),
    [sym_true] = ACTIONS(2945),
    [sym_false] = ACTIONS(2945),
    [anon_sym_NULL] = ACTIONS(2945),
    [anon_sym_nullptr] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2945),
    [anon_sym_decltype] = ACTIONS(2945),
    [anon_sym_virtual] = ACTIONS(2945),
    [anon_sym_alignas] = ACTIONS(2945),
    [anon_sym_explicit] = ACTIONS(2945),
    [anon_sym_typename] = ACTIONS(2945),
    [anon_sym_template] = ACTIONS(2945),
    [anon_sym_operator] = ACTIONS(2945),
    [anon_sym_try] = ACTIONS(2945),
    [anon_sym_delete] = ACTIONS(2945),
    [anon_sym_throw] = ACTIONS(2945),
    [anon_sym_namespace] = ACTIONS(2945),
    [anon_sym_using] = ACTIONS(2945),
    [anon_sym_static_assert] = ACTIONS(2945),
    [anon_sym_concept] = ACTIONS(2945),
    [anon_sym_co_return] = ACTIONS(2945),
    [anon_sym_co_yield] = ACTIONS(2945),
    [anon_sym_R_DQUOTE] = ACTIONS(2947),
    [anon_sym_LR_DQUOTE] = ACTIONS(2947),
    [anon_sym_uR_DQUOTE] = ACTIONS(2947),
    [anon_sym_UR_DQUOTE] = ACTIONS(2947),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2947),
    [anon_sym_co_await] = ACTIONS(2945),
    [anon_sym_new] = ACTIONS(2945),
    [anon_sym_requires] = ACTIONS(2945),
    [sym_this] = ACTIONS(2945),
  },
  [724] = {
    [sym_identifier] = ACTIONS(2937),
    [aux_sym_preproc_include_token1] = ACTIONS(2937),
    [aux_sym_preproc_def_token1] = ACTIONS(2937),
    [aux_sym_preproc_if_token1] = ACTIONS(2937),
    [aux_sym_preproc_if_token2] = ACTIONS(2937),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2937),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2937),
    [sym_preproc_directive] = ACTIONS(2937),
    [anon_sym_LPAREN2] = ACTIONS(2939),
    [anon_sym_BANG] = ACTIONS(2939),
    [anon_sym_TILDE] = ACTIONS(2939),
    [anon_sym_DASH] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(2937),
    [anon_sym_STAR] = ACTIONS(2939),
    [anon_sym_AMP_AMP] = ACTIONS(2939),
    [anon_sym_AMP] = ACTIONS(2937),
    [anon_sym_SEMI] = ACTIONS(2939),
    [anon_sym___extension__] = ACTIONS(2937),
    [anon_sym_typedef] = ACTIONS(2937),
    [anon_sym_extern] = ACTIONS(2937),
    [anon_sym___attribute__] = ACTIONS(2937),
    [anon_sym_COLON_COLON] = ACTIONS(2939),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2939),
    [anon_sym___declspec] = ACTIONS(2937),
    [anon_sym___based] = ACTIONS(2937),
    [anon_sym___cdecl] = ACTIONS(2937),
    [anon_sym___clrcall] = ACTIONS(2937),
    [anon_sym___stdcall] = ACTIONS(2937),
    [anon_sym___fastcall] = ACTIONS(2937),
    [anon_sym___thiscall] = ACTIONS(2937),
    [anon_sym___vectorcall] = ACTIONS(2937),
    [anon_sym_LBRACE] = ACTIONS(2939),
    [anon_sym_signed] = ACTIONS(2937),
    [anon_sym_unsigned] = ACTIONS(2937),
    [anon_sym_long] = ACTIONS(2937),
    [anon_sym_short] = ACTIONS(2937),
    [anon_sym_LBRACK] = ACTIONS(2937),
    [anon_sym_static] = ACTIONS(2937),
    [anon_sym_register] = ACTIONS(2937),
    [anon_sym_inline] = ACTIONS(2937),
    [anon_sym___inline] = ACTIONS(2937),
    [anon_sym___inline__] = ACTIONS(2937),
    [anon_sym___forceinline] = ACTIONS(2937),
    [anon_sym_thread_local] = ACTIONS(2937),
    [anon_sym___thread] = ACTIONS(2937),
    [anon_sym_const] = ACTIONS(2937),
    [anon_sym_constexpr] = ACTIONS(2937),
    [anon_sym_volatile] = ACTIONS(2937),
    [anon_sym_restrict] = ACTIONS(2937),
    [anon_sym___restrict__] = ACTIONS(2937),
    [anon_sym__Atomic] = ACTIONS(2937),
    [anon_sym__Noreturn] = ACTIONS(2937),
    [anon_sym_noreturn] = ACTIONS(2937),
    [anon_sym_mutable] = ACTIONS(2937),
    [anon_sym_constinit] = ACTIONS(2937),
    [anon_sym_consteval] = ACTIONS(2937),
    [anon_sym_PROGMEM] = ACTIONS(2937),
    [aux_sym_primitive_type_token1] = ACTIONS(2937),
    [anon_sym_byte] = ACTIONS(2937),
    [anon_sym_word] = ACTIONS(2937),
    [anon_sym_enum] = ACTIONS(2937),
    [anon_sym_class] = ACTIONS(2937),
    [anon_sym_struct] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_if] = ACTIONS(2937),
    [anon_sym_switch] = ACTIONS(2937),
    [anon_sym_case] = ACTIONS(2937),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_while] = ACTIONS(2937),
    [anon_sym_do] = ACTIONS(2937),
    [anon_sym_for] = ACTIONS(2937),
    [anon_sym_return] = ACTIONS(2937),
    [anon_sym_break] = ACTIONS(2937),
    [anon_sym_continue] = ACTIONS(2937),
    [anon_sym_goto] = ACTIONS(2937),
    [anon_sym___try] = ACTIONS(2937),
    [anon_sym___leave] = ACTIONS(2937),
    [anon_sym_not] = ACTIONS(2937),
    [anon_sym_compl] = ACTIONS(2937),
    [anon_sym_DASH_DASH] = ACTIONS(2939),
    [anon_sym_PLUS_PLUS] = ACTIONS(2939),
    [anon_sym_sizeof] = ACTIONS(2937),
    [anon_sym___alignof__] = ACTIONS(2937),
    [anon_sym___alignof] = ACTIONS(2937),
    [anon_sym__alignof] = ACTIONS(2937),
    [anon_sym_alignof] = ACTIONS(2937),
    [anon_sym__Alignof] = ACTIONS(2937),
    [anon_sym_offsetof] = ACTIONS(2937),
    [anon_sym__Generic] = ACTIONS(2937),
    [anon_sym_asm] = ACTIONS(2937),
    [anon_sym___asm__] = ACTIONS(2937),
    [aux_sym_number_literal_token1] = ACTIONS(2939),
    [aux_sym_number_literal_token2] = ACTIONS(2937),
    [anon_sym_L_SQUOTE] = ACTIONS(2939),
    [anon_sym_u_SQUOTE] = ACTIONS(2939),
    [anon_sym_U_SQUOTE] = ACTIONS(2939),
    [anon_sym_u8_SQUOTE] = ACTIONS(2939),
    [anon_sym_SQUOTE] = ACTIONS(2939),
    [anon_sym_L_DQUOTE] = ACTIONS(2939),
    [anon_sym_u_DQUOTE] = ACTIONS(2939),
    [anon_sym_U_DQUOTE] = ACTIONS(2939),
    [anon_sym_u8_DQUOTE] = ACTIONS(2939),
    [anon_sym_DQUOTE] = ACTIONS(2939),
    [sym_true] = ACTIONS(2937),
    [sym_false] = ACTIONS(2937),
    [anon_sym_NULL] = ACTIONS(2937),
    [anon_sym_nullptr] = ACTIONS(2937),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2937),
    [anon_sym_decltype] = ACTIONS(2937),
    [anon_sym_virtual] = ACTIONS(2937),
    [anon_sym_alignas] = ACTIONS(2937),
    [anon_sym_explicit] = ACTIONS(2937),
    [anon_sym_typename] = ACTIONS(2937),
    [anon_sym_template] = ACTIONS(2937),
    [anon_sym_operator] = ACTIONS(2937),
    [anon_sym_try] = ACTIONS(2937),
    [anon_sym_delete] = ACTIONS(2937),
    [anon_sym_throw] = ACTIONS(2937),
    [anon_sym_namespace] = ACTIONS(2937),
    [anon_sym_using] = ACTIONS(2937),
    [anon_sym_static_assert] = ACTIONS(2937),
    [anon_sym_concept] = ACTIONS(2937),
    [anon_sym_co_return] = ACTIONS(2937),
    [anon_sym_co_yield] = ACTIONS(2937),
    [anon_sym_R_DQUOTE] = ACTIONS(2939),
    [anon_sym_LR_DQUOTE] = ACTIONS(2939),
    [anon_sym_uR_DQUOTE] = ACTIONS(2939),
    [anon_sym_UR_DQUOTE] = ACTIONS(2939),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2939),
    [anon_sym_co_await] = ACTIONS(2937),
    [anon_sym_new] = ACTIONS(2937),
    [anon_sym_requires] = ACTIONS(2937),
    [sym_this] = ACTIONS(2937),
  },
  [725] = {
    [sym_identifier] = ACTIONS(3178),
    [aux_sym_preproc_include_token1] = ACTIONS(3178),
    [aux_sym_preproc_def_token1] = ACTIONS(3178),
    [aux_sym_preproc_if_token1] = ACTIONS(3178),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3178),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3178),
    [sym_preproc_directive] = ACTIONS(3178),
    [anon_sym_LPAREN2] = ACTIONS(3180),
    [anon_sym_BANG] = ACTIONS(3180),
    [anon_sym_TILDE] = ACTIONS(3180),
    [anon_sym_DASH] = ACTIONS(3178),
    [anon_sym_PLUS] = ACTIONS(3178),
    [anon_sym_STAR] = ACTIONS(3180),
    [anon_sym_AMP_AMP] = ACTIONS(3180),
    [anon_sym_AMP] = ACTIONS(3178),
    [anon_sym_SEMI] = ACTIONS(3180),
    [anon_sym___extension__] = ACTIONS(3178),
    [anon_sym_typedef] = ACTIONS(3178),
    [anon_sym_extern] = ACTIONS(3178),
    [anon_sym___attribute__] = ACTIONS(3178),
    [anon_sym_COLON_COLON] = ACTIONS(3180),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3180),
    [anon_sym___declspec] = ACTIONS(3178),
    [anon_sym___based] = ACTIONS(3178),
    [anon_sym___cdecl] = ACTIONS(3178),
    [anon_sym___clrcall] = ACTIONS(3178),
    [anon_sym___stdcall] = ACTIONS(3178),
    [anon_sym___fastcall] = ACTIONS(3178),
    [anon_sym___thiscall] = ACTIONS(3178),
    [anon_sym___vectorcall] = ACTIONS(3178),
    [anon_sym_LBRACE] = ACTIONS(3180),
    [anon_sym_RBRACE] = ACTIONS(3180),
    [anon_sym_signed] = ACTIONS(3178),
    [anon_sym_unsigned] = ACTIONS(3178),
    [anon_sym_long] = ACTIONS(3178),
    [anon_sym_short] = ACTIONS(3178),
    [anon_sym_LBRACK] = ACTIONS(3178),
    [anon_sym_static] = ACTIONS(3178),
    [anon_sym_register] = ACTIONS(3178),
    [anon_sym_inline] = ACTIONS(3178),
    [anon_sym___inline] = ACTIONS(3178),
    [anon_sym___inline__] = ACTIONS(3178),
    [anon_sym___forceinline] = ACTIONS(3178),
    [anon_sym_thread_local] = ACTIONS(3178),
    [anon_sym___thread] = ACTIONS(3178),
    [anon_sym_const] = ACTIONS(3178),
    [anon_sym_constexpr] = ACTIONS(3178),
    [anon_sym_volatile] = ACTIONS(3178),
    [anon_sym_restrict] = ACTIONS(3178),
    [anon_sym___restrict__] = ACTIONS(3178),
    [anon_sym__Atomic] = ACTIONS(3178),
    [anon_sym__Noreturn] = ACTIONS(3178),
    [anon_sym_noreturn] = ACTIONS(3178),
    [anon_sym_mutable] = ACTIONS(3178),
    [anon_sym_constinit] = ACTIONS(3178),
    [anon_sym_consteval] = ACTIONS(3178),
    [anon_sym_PROGMEM] = ACTIONS(3178),
    [aux_sym_primitive_type_token1] = ACTIONS(3178),
    [anon_sym_byte] = ACTIONS(3178),
    [anon_sym_word] = ACTIONS(3178),
    [anon_sym_enum] = ACTIONS(3178),
    [anon_sym_class] = ACTIONS(3178),
    [anon_sym_struct] = ACTIONS(3178),
    [anon_sym_union] = ACTIONS(3178),
    [anon_sym_if] = ACTIONS(3178),
    [anon_sym_switch] = ACTIONS(3178),
    [anon_sym_case] = ACTIONS(3178),
    [anon_sym_default] = ACTIONS(3178),
    [anon_sym_while] = ACTIONS(3178),
    [anon_sym_do] = ACTIONS(3178),
    [anon_sym_for] = ACTIONS(3178),
    [anon_sym_return] = ACTIONS(3178),
    [anon_sym_break] = ACTIONS(3178),
    [anon_sym_continue] = ACTIONS(3178),
    [anon_sym_goto] = ACTIONS(3178),
    [anon_sym___try] = ACTIONS(3178),
    [anon_sym___leave] = ACTIONS(3178),
    [anon_sym_not] = ACTIONS(3178),
    [anon_sym_compl] = ACTIONS(3178),
    [anon_sym_DASH_DASH] = ACTIONS(3180),
    [anon_sym_PLUS_PLUS] = ACTIONS(3180),
    [anon_sym_sizeof] = ACTIONS(3178),
    [anon_sym___alignof__] = ACTIONS(3178),
    [anon_sym___alignof] = ACTIONS(3178),
    [anon_sym__alignof] = ACTIONS(3178),
    [anon_sym_alignof] = ACTIONS(3178),
    [anon_sym__Alignof] = ACTIONS(3178),
    [anon_sym_offsetof] = ACTIONS(3178),
    [anon_sym__Generic] = ACTIONS(3178),
    [anon_sym_asm] = ACTIONS(3178),
    [anon_sym___asm__] = ACTIONS(3178),
    [aux_sym_number_literal_token1] = ACTIONS(3180),
    [aux_sym_number_literal_token2] = ACTIONS(3178),
    [anon_sym_L_SQUOTE] = ACTIONS(3180),
    [anon_sym_u_SQUOTE] = ACTIONS(3180),
    [anon_sym_U_SQUOTE] = ACTIONS(3180),
    [anon_sym_u8_SQUOTE] = ACTIONS(3180),
    [anon_sym_SQUOTE] = ACTIONS(3180),
    [anon_sym_L_DQUOTE] = ACTIONS(3180),
    [anon_sym_u_DQUOTE] = ACTIONS(3180),
    [anon_sym_U_DQUOTE] = ACTIONS(3180),
    [anon_sym_u8_DQUOTE] = ACTIONS(3180),
    [anon_sym_DQUOTE] = ACTIONS(3180),
    [sym_true] = ACTIONS(3178),
    [sym_false] = ACTIONS(3178),
    [anon_sym_NULL] = ACTIONS(3178),
    [anon_sym_nullptr] = ACTIONS(3178),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3178),
    [anon_sym_decltype] = ACTIONS(3178),
    [anon_sym_virtual] = ACTIONS(3178),
    [anon_sym_alignas] = ACTIONS(3178),
    [anon_sym_explicit] = ACTIONS(3178),
    [anon_sym_typename] = ACTIONS(3178),
    [anon_sym_template] = ACTIONS(3178),
    [anon_sym_operator] = ACTIONS(3178),
    [anon_sym_try] = ACTIONS(3178),
    [anon_sym_delete] = ACTIONS(3178),
    [anon_sym_throw] = ACTIONS(3178),
    [anon_sym_namespace] = ACTIONS(3178),
    [anon_sym_using] = ACTIONS(3178),
    [anon_sym_static_assert] = ACTIONS(3178),
    [anon_sym_concept] = ACTIONS(3178),
    [anon_sym_co_return] = ACTIONS(3178),
    [anon_sym_co_yield] = ACTIONS(3178),
    [anon_sym_R_DQUOTE] = ACTIONS(3180),
    [anon_sym_LR_DQUOTE] = ACTIONS(3180),
    [anon_sym_uR_DQUOTE] = ACTIONS(3180),
    [anon_sym_UR_DQUOTE] = ACTIONS(3180),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3180),
    [anon_sym_co_await] = ACTIONS(3178),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3178),
    [sym_this] = ACTIONS(3178),
  },
  [726] = {
    [sym_identifier] = ACTIONS(2925),
    [aux_sym_preproc_include_token1] = ACTIONS(2925),
    [aux_sym_preproc_def_token1] = ACTIONS(2925),
    [aux_sym_preproc_if_token1] = ACTIONS(2925),
    [aux_sym_preproc_if_token2] = ACTIONS(2925),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2925),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2925),
    [sym_preproc_directive] = ACTIONS(2925),
    [anon_sym_LPAREN2] = ACTIONS(2927),
    [anon_sym_BANG] = ACTIONS(2927),
    [anon_sym_TILDE] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(2925),
    [anon_sym_PLUS] = ACTIONS(2925),
    [anon_sym_STAR] = ACTIONS(2927),
    [anon_sym_AMP_AMP] = ACTIONS(2927),
    [anon_sym_AMP] = ACTIONS(2925),
    [anon_sym_SEMI] = ACTIONS(2927),
    [anon_sym___extension__] = ACTIONS(2925),
    [anon_sym_typedef] = ACTIONS(2925),
    [anon_sym_extern] = ACTIONS(2925),
    [anon_sym___attribute__] = ACTIONS(2925),
    [anon_sym_COLON_COLON] = ACTIONS(2927),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2927),
    [anon_sym___declspec] = ACTIONS(2925),
    [anon_sym___based] = ACTIONS(2925),
    [anon_sym___cdecl] = ACTIONS(2925),
    [anon_sym___clrcall] = ACTIONS(2925),
    [anon_sym___stdcall] = ACTIONS(2925),
    [anon_sym___fastcall] = ACTIONS(2925),
    [anon_sym___thiscall] = ACTIONS(2925),
    [anon_sym___vectorcall] = ACTIONS(2925),
    [anon_sym_LBRACE] = ACTIONS(2927),
    [anon_sym_signed] = ACTIONS(2925),
    [anon_sym_unsigned] = ACTIONS(2925),
    [anon_sym_long] = ACTIONS(2925),
    [anon_sym_short] = ACTIONS(2925),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_static] = ACTIONS(2925),
    [anon_sym_register] = ACTIONS(2925),
    [anon_sym_inline] = ACTIONS(2925),
    [anon_sym___inline] = ACTIONS(2925),
    [anon_sym___inline__] = ACTIONS(2925),
    [anon_sym___forceinline] = ACTIONS(2925),
    [anon_sym_thread_local] = ACTIONS(2925),
    [anon_sym___thread] = ACTIONS(2925),
    [anon_sym_const] = ACTIONS(2925),
    [anon_sym_constexpr] = ACTIONS(2925),
    [anon_sym_volatile] = ACTIONS(2925),
    [anon_sym_restrict] = ACTIONS(2925),
    [anon_sym___restrict__] = ACTIONS(2925),
    [anon_sym__Atomic] = ACTIONS(2925),
    [anon_sym__Noreturn] = ACTIONS(2925),
    [anon_sym_noreturn] = ACTIONS(2925),
    [anon_sym_mutable] = ACTIONS(2925),
    [anon_sym_constinit] = ACTIONS(2925),
    [anon_sym_consteval] = ACTIONS(2925),
    [anon_sym_PROGMEM] = ACTIONS(2925),
    [aux_sym_primitive_type_token1] = ACTIONS(2925),
    [anon_sym_byte] = ACTIONS(2925),
    [anon_sym_word] = ACTIONS(2925),
    [anon_sym_enum] = ACTIONS(2925),
    [anon_sym_class] = ACTIONS(2925),
    [anon_sym_struct] = ACTIONS(2925),
    [anon_sym_union] = ACTIONS(2925),
    [anon_sym_if] = ACTIONS(2925),
    [anon_sym_switch] = ACTIONS(2925),
    [anon_sym_case] = ACTIONS(2925),
    [anon_sym_default] = ACTIONS(2925),
    [anon_sym_while] = ACTIONS(2925),
    [anon_sym_do] = ACTIONS(2925),
    [anon_sym_for] = ACTIONS(2925),
    [anon_sym_return] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(2925),
    [anon_sym_continue] = ACTIONS(2925),
    [anon_sym_goto] = ACTIONS(2925),
    [anon_sym___try] = ACTIONS(2925),
    [anon_sym___leave] = ACTIONS(2925),
    [anon_sym_not] = ACTIONS(2925),
    [anon_sym_compl] = ACTIONS(2925),
    [anon_sym_DASH_DASH] = ACTIONS(2927),
    [anon_sym_PLUS_PLUS] = ACTIONS(2927),
    [anon_sym_sizeof] = ACTIONS(2925),
    [anon_sym___alignof__] = ACTIONS(2925),
    [anon_sym___alignof] = ACTIONS(2925),
    [anon_sym__alignof] = ACTIONS(2925),
    [anon_sym_alignof] = ACTIONS(2925),
    [anon_sym__Alignof] = ACTIONS(2925),
    [anon_sym_offsetof] = ACTIONS(2925),
    [anon_sym__Generic] = ACTIONS(2925),
    [anon_sym_asm] = ACTIONS(2925),
    [anon_sym___asm__] = ACTIONS(2925),
    [aux_sym_number_literal_token1] = ACTIONS(2927),
    [aux_sym_number_literal_token2] = ACTIONS(2925),
    [anon_sym_L_SQUOTE] = ACTIONS(2927),
    [anon_sym_u_SQUOTE] = ACTIONS(2927),
    [anon_sym_U_SQUOTE] = ACTIONS(2927),
    [anon_sym_u8_SQUOTE] = ACTIONS(2927),
    [anon_sym_SQUOTE] = ACTIONS(2927),
    [anon_sym_L_DQUOTE] = ACTIONS(2927),
    [anon_sym_u_DQUOTE] = ACTIONS(2927),
    [anon_sym_U_DQUOTE] = ACTIONS(2927),
    [anon_sym_u8_DQUOTE] = ACTIONS(2927),
    [anon_sym_DQUOTE] = ACTIONS(2927),
    [sym_true] = ACTIONS(2925),
    [sym_false] = ACTIONS(2925),
    [anon_sym_NULL] = ACTIONS(2925),
    [anon_sym_nullptr] = ACTIONS(2925),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2925),
    [anon_sym_decltype] = ACTIONS(2925),
    [anon_sym_virtual] = ACTIONS(2925),
    [anon_sym_alignas] = ACTIONS(2925),
    [anon_sym_explicit] = ACTIONS(2925),
    [anon_sym_typename] = ACTIONS(2925),
    [anon_sym_template] = ACTIONS(2925),
    [anon_sym_operator] = ACTIONS(2925),
    [anon_sym_try] = ACTIONS(2925),
    [anon_sym_delete] = ACTIONS(2925),
    [anon_sym_throw] = ACTIONS(2925),
    [anon_sym_namespace] = ACTIONS(2925),
    [anon_sym_using] = ACTIONS(2925),
    [anon_sym_static_assert] = ACTIONS(2925),
    [anon_sym_concept] = ACTIONS(2925),
    [anon_sym_co_return] = ACTIONS(2925),
    [anon_sym_co_yield] = ACTIONS(2925),
    [anon_sym_R_DQUOTE] = ACTIONS(2927),
    [anon_sym_LR_DQUOTE] = ACTIONS(2927),
    [anon_sym_uR_DQUOTE] = ACTIONS(2927),
    [anon_sym_UR_DQUOTE] = ACTIONS(2927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2927),
    [anon_sym_co_await] = ACTIONS(2925),
    [anon_sym_new] = ACTIONS(2925),
    [anon_sym_requires] = ACTIONS(2925),
    [sym_this] = ACTIONS(2925),
  },
  [727] = {
    [sym_identifier] = ACTIONS(2957),
    [aux_sym_preproc_include_token1] = ACTIONS(2957),
    [aux_sym_preproc_def_token1] = ACTIONS(2957),
    [aux_sym_preproc_if_token1] = ACTIONS(2957),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2957),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2957),
    [sym_preproc_directive] = ACTIONS(2957),
    [anon_sym_LPAREN2] = ACTIONS(2959),
    [anon_sym_BANG] = ACTIONS(2959),
    [anon_sym_TILDE] = ACTIONS(2959),
    [anon_sym_DASH] = ACTIONS(2957),
    [anon_sym_PLUS] = ACTIONS(2957),
    [anon_sym_STAR] = ACTIONS(2959),
    [anon_sym_AMP_AMP] = ACTIONS(2959),
    [anon_sym_AMP] = ACTIONS(2957),
    [anon_sym_SEMI] = ACTIONS(2959),
    [anon_sym___extension__] = ACTIONS(2957),
    [anon_sym_typedef] = ACTIONS(2957),
    [anon_sym_extern] = ACTIONS(2957),
    [anon_sym___attribute__] = ACTIONS(2957),
    [anon_sym_COLON_COLON] = ACTIONS(2959),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2959),
    [anon_sym___declspec] = ACTIONS(2957),
    [anon_sym___based] = ACTIONS(2957),
    [anon_sym___cdecl] = ACTIONS(2957),
    [anon_sym___clrcall] = ACTIONS(2957),
    [anon_sym___stdcall] = ACTIONS(2957),
    [anon_sym___fastcall] = ACTIONS(2957),
    [anon_sym___thiscall] = ACTIONS(2957),
    [anon_sym___vectorcall] = ACTIONS(2957),
    [anon_sym_LBRACE] = ACTIONS(2959),
    [anon_sym_RBRACE] = ACTIONS(2959),
    [anon_sym_signed] = ACTIONS(2957),
    [anon_sym_unsigned] = ACTIONS(2957),
    [anon_sym_long] = ACTIONS(2957),
    [anon_sym_short] = ACTIONS(2957),
    [anon_sym_LBRACK] = ACTIONS(2957),
    [anon_sym_static] = ACTIONS(2957),
    [anon_sym_register] = ACTIONS(2957),
    [anon_sym_inline] = ACTIONS(2957),
    [anon_sym___inline] = ACTIONS(2957),
    [anon_sym___inline__] = ACTIONS(2957),
    [anon_sym___forceinline] = ACTIONS(2957),
    [anon_sym_thread_local] = ACTIONS(2957),
    [anon_sym___thread] = ACTIONS(2957),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_constexpr] = ACTIONS(2957),
    [anon_sym_volatile] = ACTIONS(2957),
    [anon_sym_restrict] = ACTIONS(2957),
    [anon_sym___restrict__] = ACTIONS(2957),
    [anon_sym__Atomic] = ACTIONS(2957),
    [anon_sym__Noreturn] = ACTIONS(2957),
    [anon_sym_noreturn] = ACTIONS(2957),
    [anon_sym_mutable] = ACTIONS(2957),
    [anon_sym_constinit] = ACTIONS(2957),
    [anon_sym_consteval] = ACTIONS(2957),
    [anon_sym_PROGMEM] = ACTIONS(2957),
    [aux_sym_primitive_type_token1] = ACTIONS(2957),
    [anon_sym_byte] = ACTIONS(2957),
    [anon_sym_word] = ACTIONS(2957),
    [anon_sym_enum] = ACTIONS(2957),
    [anon_sym_class] = ACTIONS(2957),
    [anon_sym_struct] = ACTIONS(2957),
    [anon_sym_union] = ACTIONS(2957),
    [anon_sym_if] = ACTIONS(2957),
    [anon_sym_switch] = ACTIONS(2957),
    [anon_sym_case] = ACTIONS(2957),
    [anon_sym_default] = ACTIONS(2957),
    [anon_sym_while] = ACTIONS(2957),
    [anon_sym_do] = ACTIONS(2957),
    [anon_sym_for] = ACTIONS(2957),
    [anon_sym_return] = ACTIONS(2957),
    [anon_sym_break] = ACTIONS(2957),
    [anon_sym_continue] = ACTIONS(2957),
    [anon_sym_goto] = ACTIONS(2957),
    [anon_sym___try] = ACTIONS(2957),
    [anon_sym___leave] = ACTIONS(2957),
    [anon_sym_not] = ACTIONS(2957),
    [anon_sym_compl] = ACTIONS(2957),
    [anon_sym_DASH_DASH] = ACTIONS(2959),
    [anon_sym_PLUS_PLUS] = ACTIONS(2959),
    [anon_sym_sizeof] = ACTIONS(2957),
    [anon_sym___alignof__] = ACTIONS(2957),
    [anon_sym___alignof] = ACTIONS(2957),
    [anon_sym__alignof] = ACTIONS(2957),
    [anon_sym_alignof] = ACTIONS(2957),
    [anon_sym__Alignof] = ACTIONS(2957),
    [anon_sym_offsetof] = ACTIONS(2957),
    [anon_sym__Generic] = ACTIONS(2957),
    [anon_sym_asm] = ACTIONS(2957),
    [anon_sym___asm__] = ACTIONS(2957),
    [aux_sym_number_literal_token1] = ACTIONS(2959),
    [aux_sym_number_literal_token2] = ACTIONS(2957),
    [anon_sym_L_SQUOTE] = ACTIONS(2959),
    [anon_sym_u_SQUOTE] = ACTIONS(2959),
    [anon_sym_U_SQUOTE] = ACTIONS(2959),
    [anon_sym_u8_SQUOTE] = ACTIONS(2959),
    [anon_sym_SQUOTE] = ACTIONS(2959),
    [anon_sym_L_DQUOTE] = ACTIONS(2959),
    [anon_sym_u_DQUOTE] = ACTIONS(2959),
    [anon_sym_U_DQUOTE] = ACTIONS(2959),
    [anon_sym_u8_DQUOTE] = ACTIONS(2959),
    [anon_sym_DQUOTE] = ACTIONS(2959),
    [sym_true] = ACTIONS(2957),
    [sym_false] = ACTIONS(2957),
    [anon_sym_NULL] = ACTIONS(2957),
    [anon_sym_nullptr] = ACTIONS(2957),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2957),
    [anon_sym_decltype] = ACTIONS(2957),
    [anon_sym_virtual] = ACTIONS(2957),
    [anon_sym_alignas] = ACTIONS(2957),
    [anon_sym_explicit] = ACTIONS(2957),
    [anon_sym_typename] = ACTIONS(2957),
    [anon_sym_template] = ACTIONS(2957),
    [anon_sym_operator] = ACTIONS(2957),
    [anon_sym_try] = ACTIONS(2957),
    [anon_sym_delete] = ACTIONS(2957),
    [anon_sym_throw] = ACTIONS(2957),
    [anon_sym_namespace] = ACTIONS(2957),
    [anon_sym_using] = ACTIONS(2957),
    [anon_sym_static_assert] = ACTIONS(2957),
    [anon_sym_concept] = ACTIONS(2957),
    [anon_sym_co_return] = ACTIONS(2957),
    [anon_sym_co_yield] = ACTIONS(2957),
    [anon_sym_R_DQUOTE] = ACTIONS(2959),
    [anon_sym_LR_DQUOTE] = ACTIONS(2959),
    [anon_sym_uR_DQUOTE] = ACTIONS(2959),
    [anon_sym_UR_DQUOTE] = ACTIONS(2959),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2959),
    [anon_sym_co_await] = ACTIONS(2957),
    [anon_sym_new] = ACTIONS(2957),
    [anon_sym_requires] = ACTIONS(2957),
    [sym_this] = ACTIONS(2957),
  },
  [728] = {
    [sym_identifier] = ACTIONS(2953),
    [aux_sym_preproc_include_token1] = ACTIONS(2953),
    [aux_sym_preproc_def_token1] = ACTIONS(2953),
    [aux_sym_preproc_if_token1] = ACTIONS(2953),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2953),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2953),
    [sym_preproc_directive] = ACTIONS(2953),
    [anon_sym_LPAREN2] = ACTIONS(2955),
    [anon_sym_BANG] = ACTIONS(2955),
    [anon_sym_TILDE] = ACTIONS(2955),
    [anon_sym_DASH] = ACTIONS(2953),
    [anon_sym_PLUS] = ACTIONS(2953),
    [anon_sym_STAR] = ACTIONS(2955),
    [anon_sym_AMP_AMP] = ACTIONS(2955),
    [anon_sym_AMP] = ACTIONS(2953),
    [anon_sym_SEMI] = ACTIONS(2955),
    [anon_sym___extension__] = ACTIONS(2953),
    [anon_sym_typedef] = ACTIONS(2953),
    [anon_sym_extern] = ACTIONS(2953),
    [anon_sym___attribute__] = ACTIONS(2953),
    [anon_sym_COLON_COLON] = ACTIONS(2955),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2955),
    [anon_sym___declspec] = ACTIONS(2953),
    [anon_sym___based] = ACTIONS(2953),
    [anon_sym___cdecl] = ACTIONS(2953),
    [anon_sym___clrcall] = ACTIONS(2953),
    [anon_sym___stdcall] = ACTIONS(2953),
    [anon_sym___fastcall] = ACTIONS(2953),
    [anon_sym___thiscall] = ACTIONS(2953),
    [anon_sym___vectorcall] = ACTIONS(2953),
    [anon_sym_LBRACE] = ACTIONS(2955),
    [anon_sym_RBRACE] = ACTIONS(2955),
    [anon_sym_signed] = ACTIONS(2953),
    [anon_sym_unsigned] = ACTIONS(2953),
    [anon_sym_long] = ACTIONS(2953),
    [anon_sym_short] = ACTIONS(2953),
    [anon_sym_LBRACK] = ACTIONS(2953),
    [anon_sym_static] = ACTIONS(2953),
    [anon_sym_register] = ACTIONS(2953),
    [anon_sym_inline] = ACTIONS(2953),
    [anon_sym___inline] = ACTIONS(2953),
    [anon_sym___inline__] = ACTIONS(2953),
    [anon_sym___forceinline] = ACTIONS(2953),
    [anon_sym_thread_local] = ACTIONS(2953),
    [anon_sym___thread] = ACTIONS(2953),
    [anon_sym_const] = ACTIONS(2953),
    [anon_sym_constexpr] = ACTIONS(2953),
    [anon_sym_volatile] = ACTIONS(2953),
    [anon_sym_restrict] = ACTIONS(2953),
    [anon_sym___restrict__] = ACTIONS(2953),
    [anon_sym__Atomic] = ACTIONS(2953),
    [anon_sym__Noreturn] = ACTIONS(2953),
    [anon_sym_noreturn] = ACTIONS(2953),
    [anon_sym_mutable] = ACTIONS(2953),
    [anon_sym_constinit] = ACTIONS(2953),
    [anon_sym_consteval] = ACTIONS(2953),
    [anon_sym_PROGMEM] = ACTIONS(2953),
    [aux_sym_primitive_type_token1] = ACTIONS(2953),
    [anon_sym_byte] = ACTIONS(2953),
    [anon_sym_word] = ACTIONS(2953),
    [anon_sym_enum] = ACTIONS(2953),
    [anon_sym_class] = ACTIONS(2953),
    [anon_sym_struct] = ACTIONS(2953),
    [anon_sym_union] = ACTIONS(2953),
    [anon_sym_if] = ACTIONS(2953),
    [anon_sym_switch] = ACTIONS(2953),
    [anon_sym_case] = ACTIONS(2953),
    [anon_sym_default] = ACTIONS(2953),
    [anon_sym_while] = ACTIONS(2953),
    [anon_sym_do] = ACTIONS(2953),
    [anon_sym_for] = ACTIONS(2953),
    [anon_sym_return] = ACTIONS(2953),
    [anon_sym_break] = ACTIONS(2953),
    [anon_sym_continue] = ACTIONS(2953),
    [anon_sym_goto] = ACTIONS(2953),
    [anon_sym___try] = ACTIONS(2953),
    [anon_sym___leave] = ACTIONS(2953),
    [anon_sym_not] = ACTIONS(2953),
    [anon_sym_compl] = ACTIONS(2953),
    [anon_sym_DASH_DASH] = ACTIONS(2955),
    [anon_sym_PLUS_PLUS] = ACTIONS(2955),
    [anon_sym_sizeof] = ACTIONS(2953),
    [anon_sym___alignof__] = ACTIONS(2953),
    [anon_sym___alignof] = ACTIONS(2953),
    [anon_sym__alignof] = ACTIONS(2953),
    [anon_sym_alignof] = ACTIONS(2953),
    [anon_sym__Alignof] = ACTIONS(2953),
    [anon_sym_offsetof] = ACTIONS(2953),
    [anon_sym__Generic] = ACTIONS(2953),
    [anon_sym_asm] = ACTIONS(2953),
    [anon_sym___asm__] = ACTIONS(2953),
    [aux_sym_number_literal_token1] = ACTIONS(2955),
    [aux_sym_number_literal_token2] = ACTIONS(2953),
    [anon_sym_L_SQUOTE] = ACTIONS(2955),
    [anon_sym_u_SQUOTE] = ACTIONS(2955),
    [anon_sym_U_SQUOTE] = ACTIONS(2955),
    [anon_sym_u8_SQUOTE] = ACTIONS(2955),
    [anon_sym_SQUOTE] = ACTIONS(2955),
    [anon_sym_L_DQUOTE] = ACTIONS(2955),
    [anon_sym_u_DQUOTE] = ACTIONS(2955),
    [anon_sym_U_DQUOTE] = ACTIONS(2955),
    [anon_sym_u8_DQUOTE] = ACTIONS(2955),
    [anon_sym_DQUOTE] = ACTIONS(2955),
    [sym_true] = ACTIONS(2953),
    [sym_false] = ACTIONS(2953),
    [anon_sym_NULL] = ACTIONS(2953),
    [anon_sym_nullptr] = ACTIONS(2953),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2953),
    [anon_sym_decltype] = ACTIONS(2953),
    [anon_sym_virtual] = ACTIONS(2953),
    [anon_sym_alignas] = ACTIONS(2953),
    [anon_sym_explicit] = ACTIONS(2953),
    [anon_sym_typename] = ACTIONS(2953),
    [anon_sym_template] = ACTIONS(2953),
    [anon_sym_operator] = ACTIONS(2953),
    [anon_sym_try] = ACTIONS(2953),
    [anon_sym_delete] = ACTIONS(2953),
    [anon_sym_throw] = ACTIONS(2953),
    [anon_sym_namespace] = ACTIONS(2953),
    [anon_sym_using] = ACTIONS(2953),
    [anon_sym_static_assert] = ACTIONS(2953),
    [anon_sym_concept] = ACTIONS(2953),
    [anon_sym_co_return] = ACTIONS(2953),
    [anon_sym_co_yield] = ACTIONS(2953),
    [anon_sym_R_DQUOTE] = ACTIONS(2955),
    [anon_sym_LR_DQUOTE] = ACTIONS(2955),
    [anon_sym_uR_DQUOTE] = ACTIONS(2955),
    [anon_sym_UR_DQUOTE] = ACTIONS(2955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2955),
    [anon_sym_co_await] = ACTIONS(2953),
    [anon_sym_new] = ACTIONS(2953),
    [anon_sym_requires] = ACTIONS(2953),
    [sym_this] = ACTIONS(2953),
  },
  [729] = {
    [sym_identifier] = ACTIONS(2949),
    [aux_sym_preproc_include_token1] = ACTIONS(2949),
    [aux_sym_preproc_def_token1] = ACTIONS(2949),
    [aux_sym_preproc_if_token1] = ACTIONS(2949),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2949),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2949),
    [sym_preproc_directive] = ACTIONS(2949),
    [anon_sym_LPAREN2] = ACTIONS(2951),
    [anon_sym_BANG] = ACTIONS(2951),
    [anon_sym_TILDE] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2949),
    [anon_sym_STAR] = ACTIONS(2951),
    [anon_sym_AMP_AMP] = ACTIONS(2951),
    [anon_sym_AMP] = ACTIONS(2949),
    [anon_sym_SEMI] = ACTIONS(2951),
    [anon_sym___extension__] = ACTIONS(2949),
    [anon_sym_typedef] = ACTIONS(2949),
    [anon_sym_extern] = ACTIONS(2949),
    [anon_sym___attribute__] = ACTIONS(2949),
    [anon_sym_COLON_COLON] = ACTIONS(2951),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2951),
    [anon_sym___declspec] = ACTIONS(2949),
    [anon_sym___based] = ACTIONS(2949),
    [anon_sym___cdecl] = ACTIONS(2949),
    [anon_sym___clrcall] = ACTIONS(2949),
    [anon_sym___stdcall] = ACTIONS(2949),
    [anon_sym___fastcall] = ACTIONS(2949),
    [anon_sym___thiscall] = ACTIONS(2949),
    [anon_sym___vectorcall] = ACTIONS(2949),
    [anon_sym_LBRACE] = ACTIONS(2951),
    [anon_sym_RBRACE] = ACTIONS(2951),
    [anon_sym_signed] = ACTIONS(2949),
    [anon_sym_unsigned] = ACTIONS(2949),
    [anon_sym_long] = ACTIONS(2949),
    [anon_sym_short] = ACTIONS(2949),
    [anon_sym_LBRACK] = ACTIONS(2949),
    [anon_sym_static] = ACTIONS(2949),
    [anon_sym_register] = ACTIONS(2949),
    [anon_sym_inline] = ACTIONS(2949),
    [anon_sym___inline] = ACTIONS(2949),
    [anon_sym___inline__] = ACTIONS(2949),
    [anon_sym___forceinline] = ACTIONS(2949),
    [anon_sym_thread_local] = ACTIONS(2949),
    [anon_sym___thread] = ACTIONS(2949),
    [anon_sym_const] = ACTIONS(2949),
    [anon_sym_constexpr] = ACTIONS(2949),
    [anon_sym_volatile] = ACTIONS(2949),
    [anon_sym_restrict] = ACTIONS(2949),
    [anon_sym___restrict__] = ACTIONS(2949),
    [anon_sym__Atomic] = ACTIONS(2949),
    [anon_sym__Noreturn] = ACTIONS(2949),
    [anon_sym_noreturn] = ACTIONS(2949),
    [anon_sym_mutable] = ACTIONS(2949),
    [anon_sym_constinit] = ACTIONS(2949),
    [anon_sym_consteval] = ACTIONS(2949),
    [anon_sym_PROGMEM] = ACTIONS(2949),
    [aux_sym_primitive_type_token1] = ACTIONS(2949),
    [anon_sym_byte] = ACTIONS(2949),
    [anon_sym_word] = ACTIONS(2949),
    [anon_sym_enum] = ACTIONS(2949),
    [anon_sym_class] = ACTIONS(2949),
    [anon_sym_struct] = ACTIONS(2949),
    [anon_sym_union] = ACTIONS(2949),
    [anon_sym_if] = ACTIONS(2949),
    [anon_sym_switch] = ACTIONS(2949),
    [anon_sym_case] = ACTIONS(2949),
    [anon_sym_default] = ACTIONS(2949),
    [anon_sym_while] = ACTIONS(2949),
    [anon_sym_do] = ACTIONS(2949),
    [anon_sym_for] = ACTIONS(2949),
    [anon_sym_return] = ACTIONS(2949),
    [anon_sym_break] = ACTIONS(2949),
    [anon_sym_continue] = ACTIONS(2949),
    [anon_sym_goto] = ACTIONS(2949),
    [anon_sym___try] = ACTIONS(2949),
    [anon_sym___leave] = ACTIONS(2949),
    [anon_sym_not] = ACTIONS(2949),
    [anon_sym_compl] = ACTIONS(2949),
    [anon_sym_DASH_DASH] = ACTIONS(2951),
    [anon_sym_PLUS_PLUS] = ACTIONS(2951),
    [anon_sym_sizeof] = ACTIONS(2949),
    [anon_sym___alignof__] = ACTIONS(2949),
    [anon_sym___alignof] = ACTIONS(2949),
    [anon_sym__alignof] = ACTIONS(2949),
    [anon_sym_alignof] = ACTIONS(2949),
    [anon_sym__Alignof] = ACTIONS(2949),
    [anon_sym_offsetof] = ACTIONS(2949),
    [anon_sym__Generic] = ACTIONS(2949),
    [anon_sym_asm] = ACTIONS(2949),
    [anon_sym___asm__] = ACTIONS(2949),
    [aux_sym_number_literal_token1] = ACTIONS(2951),
    [aux_sym_number_literal_token2] = ACTIONS(2949),
    [anon_sym_L_SQUOTE] = ACTIONS(2951),
    [anon_sym_u_SQUOTE] = ACTIONS(2951),
    [anon_sym_U_SQUOTE] = ACTIONS(2951),
    [anon_sym_u8_SQUOTE] = ACTIONS(2951),
    [anon_sym_SQUOTE] = ACTIONS(2951),
    [anon_sym_L_DQUOTE] = ACTIONS(2951),
    [anon_sym_u_DQUOTE] = ACTIONS(2951),
    [anon_sym_U_DQUOTE] = ACTIONS(2951),
    [anon_sym_u8_DQUOTE] = ACTIONS(2951),
    [anon_sym_DQUOTE] = ACTIONS(2951),
    [sym_true] = ACTIONS(2949),
    [sym_false] = ACTIONS(2949),
    [anon_sym_NULL] = ACTIONS(2949),
    [anon_sym_nullptr] = ACTIONS(2949),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2949),
    [anon_sym_decltype] = ACTIONS(2949),
    [anon_sym_virtual] = ACTIONS(2949),
    [anon_sym_alignas] = ACTIONS(2949),
    [anon_sym_explicit] = ACTIONS(2949),
    [anon_sym_typename] = ACTIONS(2949),
    [anon_sym_template] = ACTIONS(2949),
    [anon_sym_operator] = ACTIONS(2949),
    [anon_sym_try] = ACTIONS(2949),
    [anon_sym_delete] = ACTIONS(2949),
    [anon_sym_throw] = ACTIONS(2949),
    [anon_sym_namespace] = ACTIONS(2949),
    [anon_sym_using] = ACTIONS(2949),
    [anon_sym_static_assert] = ACTIONS(2949),
    [anon_sym_concept] = ACTIONS(2949),
    [anon_sym_co_return] = ACTIONS(2949),
    [anon_sym_co_yield] = ACTIONS(2949),
    [anon_sym_R_DQUOTE] = ACTIONS(2951),
    [anon_sym_LR_DQUOTE] = ACTIONS(2951),
    [anon_sym_uR_DQUOTE] = ACTIONS(2951),
    [anon_sym_UR_DQUOTE] = ACTIONS(2951),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2951),
    [anon_sym_co_await] = ACTIONS(2949),
    [anon_sym_new] = ACTIONS(2949),
    [anon_sym_requires] = ACTIONS(2949),
    [sym_this] = ACTIONS(2949),
  },
  [730] = {
    [sym_identifier] = ACTIONS(3090),
    [aux_sym_preproc_include_token1] = ACTIONS(3090),
    [aux_sym_preproc_def_token1] = ACTIONS(3090),
    [aux_sym_preproc_if_token1] = ACTIONS(3090),
    [aux_sym_preproc_if_token2] = ACTIONS(3090),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3090),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3090),
    [sym_preproc_directive] = ACTIONS(3090),
    [anon_sym_LPAREN2] = ACTIONS(3092),
    [anon_sym_BANG] = ACTIONS(3092),
    [anon_sym_TILDE] = ACTIONS(3092),
    [anon_sym_DASH] = ACTIONS(3090),
    [anon_sym_PLUS] = ACTIONS(3090),
    [anon_sym_STAR] = ACTIONS(3092),
    [anon_sym_AMP_AMP] = ACTIONS(3092),
    [anon_sym_AMP] = ACTIONS(3090),
    [anon_sym_SEMI] = ACTIONS(3092),
    [anon_sym___extension__] = ACTIONS(3090),
    [anon_sym_typedef] = ACTIONS(3090),
    [anon_sym_extern] = ACTIONS(3090),
    [anon_sym___attribute__] = ACTIONS(3090),
    [anon_sym_COLON_COLON] = ACTIONS(3092),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3092),
    [anon_sym___declspec] = ACTIONS(3090),
    [anon_sym___based] = ACTIONS(3090),
    [anon_sym___cdecl] = ACTIONS(3090),
    [anon_sym___clrcall] = ACTIONS(3090),
    [anon_sym___stdcall] = ACTIONS(3090),
    [anon_sym___fastcall] = ACTIONS(3090),
    [anon_sym___thiscall] = ACTIONS(3090),
    [anon_sym___vectorcall] = ACTIONS(3090),
    [anon_sym_LBRACE] = ACTIONS(3092),
    [anon_sym_signed] = ACTIONS(3090),
    [anon_sym_unsigned] = ACTIONS(3090),
    [anon_sym_long] = ACTIONS(3090),
    [anon_sym_short] = ACTIONS(3090),
    [anon_sym_LBRACK] = ACTIONS(3090),
    [anon_sym_static] = ACTIONS(3090),
    [anon_sym_register] = ACTIONS(3090),
    [anon_sym_inline] = ACTIONS(3090),
    [anon_sym___inline] = ACTIONS(3090),
    [anon_sym___inline__] = ACTIONS(3090),
    [anon_sym___forceinline] = ACTIONS(3090),
    [anon_sym_thread_local] = ACTIONS(3090),
    [anon_sym___thread] = ACTIONS(3090),
    [anon_sym_const] = ACTIONS(3090),
    [anon_sym_constexpr] = ACTIONS(3090),
    [anon_sym_volatile] = ACTIONS(3090),
    [anon_sym_restrict] = ACTIONS(3090),
    [anon_sym___restrict__] = ACTIONS(3090),
    [anon_sym__Atomic] = ACTIONS(3090),
    [anon_sym__Noreturn] = ACTIONS(3090),
    [anon_sym_noreturn] = ACTIONS(3090),
    [anon_sym_mutable] = ACTIONS(3090),
    [anon_sym_constinit] = ACTIONS(3090),
    [anon_sym_consteval] = ACTIONS(3090),
    [anon_sym_PROGMEM] = ACTIONS(3090),
    [aux_sym_primitive_type_token1] = ACTIONS(3090),
    [anon_sym_byte] = ACTIONS(3090),
    [anon_sym_word] = ACTIONS(3090),
    [anon_sym_enum] = ACTIONS(3090),
    [anon_sym_class] = ACTIONS(3090),
    [anon_sym_struct] = ACTIONS(3090),
    [anon_sym_union] = ACTIONS(3090),
    [anon_sym_if] = ACTIONS(3090),
    [anon_sym_switch] = ACTIONS(3090),
    [anon_sym_case] = ACTIONS(3090),
    [anon_sym_default] = ACTIONS(3090),
    [anon_sym_while] = ACTIONS(3090),
    [anon_sym_do] = ACTIONS(3090),
    [anon_sym_for] = ACTIONS(3090),
    [anon_sym_return] = ACTIONS(3090),
    [anon_sym_break] = ACTIONS(3090),
    [anon_sym_continue] = ACTIONS(3090),
    [anon_sym_goto] = ACTIONS(3090),
    [anon_sym___try] = ACTIONS(3090),
    [anon_sym___leave] = ACTIONS(3090),
    [anon_sym_not] = ACTIONS(3090),
    [anon_sym_compl] = ACTIONS(3090),
    [anon_sym_DASH_DASH] = ACTIONS(3092),
    [anon_sym_PLUS_PLUS] = ACTIONS(3092),
    [anon_sym_sizeof] = ACTIONS(3090),
    [anon_sym___alignof__] = ACTIONS(3090),
    [anon_sym___alignof] = ACTIONS(3090),
    [anon_sym__alignof] = ACTIONS(3090),
    [anon_sym_alignof] = ACTIONS(3090),
    [anon_sym__Alignof] = ACTIONS(3090),
    [anon_sym_offsetof] = ACTIONS(3090),
    [anon_sym__Generic] = ACTIONS(3090),
    [anon_sym_asm] = ACTIONS(3090),
    [anon_sym___asm__] = ACTIONS(3090),
    [aux_sym_number_literal_token1] = ACTIONS(3092),
    [aux_sym_number_literal_token2] = ACTIONS(3090),
    [anon_sym_L_SQUOTE] = ACTIONS(3092),
    [anon_sym_u_SQUOTE] = ACTIONS(3092),
    [anon_sym_U_SQUOTE] = ACTIONS(3092),
    [anon_sym_u8_SQUOTE] = ACTIONS(3092),
    [anon_sym_SQUOTE] = ACTIONS(3092),
    [anon_sym_L_DQUOTE] = ACTIONS(3092),
    [anon_sym_u_DQUOTE] = ACTIONS(3092),
    [anon_sym_U_DQUOTE] = ACTIONS(3092),
    [anon_sym_u8_DQUOTE] = ACTIONS(3092),
    [anon_sym_DQUOTE] = ACTIONS(3092),
    [sym_true] = ACTIONS(3090),
    [sym_false] = ACTIONS(3090),
    [anon_sym_NULL] = ACTIONS(3090),
    [anon_sym_nullptr] = ACTIONS(3090),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3090),
    [anon_sym_decltype] = ACTIONS(3090),
    [anon_sym_virtual] = ACTIONS(3090),
    [anon_sym_alignas] = ACTIONS(3090),
    [anon_sym_explicit] = ACTIONS(3090),
    [anon_sym_typename] = ACTIONS(3090),
    [anon_sym_template] = ACTIONS(3090),
    [anon_sym_operator] = ACTIONS(3090),
    [anon_sym_try] = ACTIONS(3090),
    [anon_sym_delete] = ACTIONS(3090),
    [anon_sym_throw] = ACTIONS(3090),
    [anon_sym_namespace] = ACTIONS(3090),
    [anon_sym_using] = ACTIONS(3090),
    [anon_sym_static_assert] = ACTIONS(3090),
    [anon_sym_concept] = ACTIONS(3090),
    [anon_sym_co_return] = ACTIONS(3090),
    [anon_sym_co_yield] = ACTIONS(3090),
    [anon_sym_R_DQUOTE] = ACTIONS(3092),
    [anon_sym_LR_DQUOTE] = ACTIONS(3092),
    [anon_sym_uR_DQUOTE] = ACTIONS(3092),
    [anon_sym_UR_DQUOTE] = ACTIONS(3092),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3092),
    [anon_sym_co_await] = ACTIONS(3090),
    [anon_sym_new] = ACTIONS(3090),
    [anon_sym_requires] = ACTIONS(3090),
    [sym_this] = ACTIONS(3090),
  },
  [731] = {
    [sym_identifier] = ACTIONS(2945),
    [aux_sym_preproc_include_token1] = ACTIONS(2945),
    [aux_sym_preproc_def_token1] = ACTIONS(2945),
    [aux_sym_preproc_if_token1] = ACTIONS(2945),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2945),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2945),
    [sym_preproc_directive] = ACTIONS(2945),
    [anon_sym_LPAREN2] = ACTIONS(2947),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2947),
    [anon_sym_DASH] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(2945),
    [anon_sym_STAR] = ACTIONS(2947),
    [anon_sym_AMP_AMP] = ACTIONS(2947),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_SEMI] = ACTIONS(2947),
    [anon_sym___extension__] = ACTIONS(2945),
    [anon_sym_typedef] = ACTIONS(2945),
    [anon_sym_extern] = ACTIONS(2945),
    [anon_sym___attribute__] = ACTIONS(2945),
    [anon_sym_COLON_COLON] = ACTIONS(2947),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2947),
    [anon_sym___declspec] = ACTIONS(2945),
    [anon_sym___based] = ACTIONS(2945),
    [anon_sym___cdecl] = ACTIONS(2945),
    [anon_sym___clrcall] = ACTIONS(2945),
    [anon_sym___stdcall] = ACTIONS(2945),
    [anon_sym___fastcall] = ACTIONS(2945),
    [anon_sym___thiscall] = ACTIONS(2945),
    [anon_sym___vectorcall] = ACTIONS(2945),
    [anon_sym_LBRACE] = ACTIONS(2947),
    [anon_sym_RBRACE] = ACTIONS(2947),
    [anon_sym_signed] = ACTIONS(2945),
    [anon_sym_unsigned] = ACTIONS(2945),
    [anon_sym_long] = ACTIONS(2945),
    [anon_sym_short] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(2945),
    [anon_sym_static] = ACTIONS(2945),
    [anon_sym_register] = ACTIONS(2945),
    [anon_sym_inline] = ACTIONS(2945),
    [anon_sym___inline] = ACTIONS(2945),
    [anon_sym___inline__] = ACTIONS(2945),
    [anon_sym___forceinline] = ACTIONS(2945),
    [anon_sym_thread_local] = ACTIONS(2945),
    [anon_sym___thread] = ACTIONS(2945),
    [anon_sym_const] = ACTIONS(2945),
    [anon_sym_constexpr] = ACTIONS(2945),
    [anon_sym_volatile] = ACTIONS(2945),
    [anon_sym_restrict] = ACTIONS(2945),
    [anon_sym___restrict__] = ACTIONS(2945),
    [anon_sym__Atomic] = ACTIONS(2945),
    [anon_sym__Noreturn] = ACTIONS(2945),
    [anon_sym_noreturn] = ACTIONS(2945),
    [anon_sym_mutable] = ACTIONS(2945),
    [anon_sym_constinit] = ACTIONS(2945),
    [anon_sym_consteval] = ACTIONS(2945),
    [anon_sym_PROGMEM] = ACTIONS(2945),
    [aux_sym_primitive_type_token1] = ACTIONS(2945),
    [anon_sym_byte] = ACTIONS(2945),
    [anon_sym_word] = ACTIONS(2945),
    [anon_sym_enum] = ACTIONS(2945),
    [anon_sym_class] = ACTIONS(2945),
    [anon_sym_struct] = ACTIONS(2945),
    [anon_sym_union] = ACTIONS(2945),
    [anon_sym_if] = ACTIONS(2945),
    [anon_sym_switch] = ACTIONS(2945),
    [anon_sym_case] = ACTIONS(2945),
    [anon_sym_default] = ACTIONS(2945),
    [anon_sym_while] = ACTIONS(2945),
    [anon_sym_do] = ACTIONS(2945),
    [anon_sym_for] = ACTIONS(2945),
    [anon_sym_return] = ACTIONS(2945),
    [anon_sym_break] = ACTIONS(2945),
    [anon_sym_continue] = ACTIONS(2945),
    [anon_sym_goto] = ACTIONS(2945),
    [anon_sym___try] = ACTIONS(2945),
    [anon_sym___leave] = ACTIONS(2945),
    [anon_sym_not] = ACTIONS(2945),
    [anon_sym_compl] = ACTIONS(2945),
    [anon_sym_DASH_DASH] = ACTIONS(2947),
    [anon_sym_PLUS_PLUS] = ACTIONS(2947),
    [anon_sym_sizeof] = ACTIONS(2945),
    [anon_sym___alignof__] = ACTIONS(2945),
    [anon_sym___alignof] = ACTIONS(2945),
    [anon_sym__alignof] = ACTIONS(2945),
    [anon_sym_alignof] = ACTIONS(2945),
    [anon_sym__Alignof] = ACTIONS(2945),
    [anon_sym_offsetof] = ACTIONS(2945),
    [anon_sym__Generic] = ACTIONS(2945),
    [anon_sym_asm] = ACTIONS(2945),
    [anon_sym___asm__] = ACTIONS(2945),
    [aux_sym_number_literal_token1] = ACTIONS(2947),
    [aux_sym_number_literal_token2] = ACTIONS(2945),
    [anon_sym_L_SQUOTE] = ACTIONS(2947),
    [anon_sym_u_SQUOTE] = ACTIONS(2947),
    [anon_sym_U_SQUOTE] = ACTIONS(2947),
    [anon_sym_u8_SQUOTE] = ACTIONS(2947),
    [anon_sym_SQUOTE] = ACTIONS(2947),
    [anon_sym_L_DQUOTE] = ACTIONS(2947),
    [anon_sym_u_DQUOTE] = ACTIONS(2947),
    [anon_sym_U_DQUOTE] = ACTIONS(2947),
    [anon_sym_u8_DQUOTE] = ACTIONS(2947),
    [anon_sym_DQUOTE] = ACTIONS(2947),
    [sym_true] = ACTIONS(2945),
    [sym_false] = ACTIONS(2945),
    [anon_sym_NULL] = ACTIONS(2945),
    [anon_sym_nullptr] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2945),
    [anon_sym_decltype] = ACTIONS(2945),
    [anon_sym_virtual] = ACTIONS(2945),
    [anon_sym_alignas] = ACTIONS(2945),
    [anon_sym_explicit] = ACTIONS(2945),
    [anon_sym_typename] = ACTIONS(2945),
    [anon_sym_template] = ACTIONS(2945),
    [anon_sym_operator] = ACTIONS(2945),
    [anon_sym_try] = ACTIONS(2945),
    [anon_sym_delete] = ACTIONS(2945),
    [anon_sym_throw] = ACTIONS(2945),
    [anon_sym_namespace] = ACTIONS(2945),
    [anon_sym_using] = ACTIONS(2945),
    [anon_sym_static_assert] = ACTIONS(2945),
    [anon_sym_concept] = ACTIONS(2945),
    [anon_sym_co_return] = ACTIONS(2945),
    [anon_sym_co_yield] = ACTIONS(2945),
    [anon_sym_R_DQUOTE] = ACTIONS(2947),
    [anon_sym_LR_DQUOTE] = ACTIONS(2947),
    [anon_sym_uR_DQUOTE] = ACTIONS(2947),
    [anon_sym_UR_DQUOTE] = ACTIONS(2947),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2947),
    [anon_sym_co_await] = ACTIONS(2945),
    [anon_sym_new] = ACTIONS(2945),
    [anon_sym_requires] = ACTIONS(2945),
    [sym_this] = ACTIONS(2945),
  },
  [732] = {
    [sym_identifier] = ACTIONS(2937),
    [aux_sym_preproc_include_token1] = ACTIONS(2937),
    [aux_sym_preproc_def_token1] = ACTIONS(2937),
    [aux_sym_preproc_if_token1] = ACTIONS(2937),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2937),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2937),
    [sym_preproc_directive] = ACTIONS(2937),
    [anon_sym_LPAREN2] = ACTIONS(2939),
    [anon_sym_BANG] = ACTIONS(2939),
    [anon_sym_TILDE] = ACTIONS(2939),
    [anon_sym_DASH] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(2937),
    [anon_sym_STAR] = ACTIONS(2939),
    [anon_sym_AMP_AMP] = ACTIONS(2939),
    [anon_sym_AMP] = ACTIONS(2937),
    [anon_sym_SEMI] = ACTIONS(2939),
    [anon_sym___extension__] = ACTIONS(2937),
    [anon_sym_typedef] = ACTIONS(2937),
    [anon_sym_extern] = ACTIONS(2937),
    [anon_sym___attribute__] = ACTIONS(2937),
    [anon_sym_COLON_COLON] = ACTIONS(2939),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2939),
    [anon_sym___declspec] = ACTIONS(2937),
    [anon_sym___based] = ACTIONS(2937),
    [anon_sym___cdecl] = ACTIONS(2937),
    [anon_sym___clrcall] = ACTIONS(2937),
    [anon_sym___stdcall] = ACTIONS(2937),
    [anon_sym___fastcall] = ACTIONS(2937),
    [anon_sym___thiscall] = ACTIONS(2937),
    [anon_sym___vectorcall] = ACTIONS(2937),
    [anon_sym_LBRACE] = ACTIONS(2939),
    [anon_sym_RBRACE] = ACTIONS(2939),
    [anon_sym_signed] = ACTIONS(2937),
    [anon_sym_unsigned] = ACTIONS(2937),
    [anon_sym_long] = ACTIONS(2937),
    [anon_sym_short] = ACTIONS(2937),
    [anon_sym_LBRACK] = ACTIONS(2937),
    [anon_sym_static] = ACTIONS(2937),
    [anon_sym_register] = ACTIONS(2937),
    [anon_sym_inline] = ACTIONS(2937),
    [anon_sym___inline] = ACTIONS(2937),
    [anon_sym___inline__] = ACTIONS(2937),
    [anon_sym___forceinline] = ACTIONS(2937),
    [anon_sym_thread_local] = ACTIONS(2937),
    [anon_sym___thread] = ACTIONS(2937),
    [anon_sym_const] = ACTIONS(2937),
    [anon_sym_constexpr] = ACTIONS(2937),
    [anon_sym_volatile] = ACTIONS(2937),
    [anon_sym_restrict] = ACTIONS(2937),
    [anon_sym___restrict__] = ACTIONS(2937),
    [anon_sym__Atomic] = ACTIONS(2937),
    [anon_sym__Noreturn] = ACTIONS(2937),
    [anon_sym_noreturn] = ACTIONS(2937),
    [anon_sym_mutable] = ACTIONS(2937),
    [anon_sym_constinit] = ACTIONS(2937),
    [anon_sym_consteval] = ACTIONS(2937),
    [anon_sym_PROGMEM] = ACTIONS(2937),
    [aux_sym_primitive_type_token1] = ACTIONS(2937),
    [anon_sym_byte] = ACTIONS(2937),
    [anon_sym_word] = ACTIONS(2937),
    [anon_sym_enum] = ACTIONS(2937),
    [anon_sym_class] = ACTIONS(2937),
    [anon_sym_struct] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_if] = ACTIONS(2937),
    [anon_sym_switch] = ACTIONS(2937),
    [anon_sym_case] = ACTIONS(2937),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_while] = ACTIONS(2937),
    [anon_sym_do] = ACTIONS(2937),
    [anon_sym_for] = ACTIONS(2937),
    [anon_sym_return] = ACTIONS(2937),
    [anon_sym_break] = ACTIONS(2937),
    [anon_sym_continue] = ACTIONS(2937),
    [anon_sym_goto] = ACTIONS(2937),
    [anon_sym___try] = ACTIONS(2937),
    [anon_sym___leave] = ACTIONS(2937),
    [anon_sym_not] = ACTIONS(2937),
    [anon_sym_compl] = ACTIONS(2937),
    [anon_sym_DASH_DASH] = ACTIONS(2939),
    [anon_sym_PLUS_PLUS] = ACTIONS(2939),
    [anon_sym_sizeof] = ACTIONS(2937),
    [anon_sym___alignof__] = ACTIONS(2937),
    [anon_sym___alignof] = ACTIONS(2937),
    [anon_sym__alignof] = ACTIONS(2937),
    [anon_sym_alignof] = ACTIONS(2937),
    [anon_sym__Alignof] = ACTIONS(2937),
    [anon_sym_offsetof] = ACTIONS(2937),
    [anon_sym__Generic] = ACTIONS(2937),
    [anon_sym_asm] = ACTIONS(2937),
    [anon_sym___asm__] = ACTIONS(2937),
    [aux_sym_number_literal_token1] = ACTIONS(2939),
    [aux_sym_number_literal_token2] = ACTIONS(2937),
    [anon_sym_L_SQUOTE] = ACTIONS(2939),
    [anon_sym_u_SQUOTE] = ACTIONS(2939),
    [anon_sym_U_SQUOTE] = ACTIONS(2939),
    [anon_sym_u8_SQUOTE] = ACTIONS(2939),
    [anon_sym_SQUOTE] = ACTIONS(2939),
    [anon_sym_L_DQUOTE] = ACTIONS(2939),
    [anon_sym_u_DQUOTE] = ACTIONS(2939),
    [anon_sym_U_DQUOTE] = ACTIONS(2939),
    [anon_sym_u8_DQUOTE] = ACTIONS(2939),
    [anon_sym_DQUOTE] = ACTIONS(2939),
    [sym_true] = ACTIONS(2937),
    [sym_false] = ACTIONS(2937),
    [anon_sym_NULL] = ACTIONS(2937),
    [anon_sym_nullptr] = ACTIONS(2937),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2937),
    [anon_sym_decltype] = ACTIONS(2937),
    [anon_sym_virtual] = ACTIONS(2937),
    [anon_sym_alignas] = ACTIONS(2937),
    [anon_sym_explicit] = ACTIONS(2937),
    [anon_sym_typename] = ACTIONS(2937),
    [anon_sym_template] = ACTIONS(2937),
    [anon_sym_operator] = ACTIONS(2937),
    [anon_sym_try] = ACTIONS(2937),
    [anon_sym_delete] = ACTIONS(2937),
    [anon_sym_throw] = ACTIONS(2937),
    [anon_sym_namespace] = ACTIONS(2937),
    [anon_sym_using] = ACTIONS(2937),
    [anon_sym_static_assert] = ACTIONS(2937),
    [anon_sym_concept] = ACTIONS(2937),
    [anon_sym_co_return] = ACTIONS(2937),
    [anon_sym_co_yield] = ACTIONS(2937),
    [anon_sym_R_DQUOTE] = ACTIONS(2939),
    [anon_sym_LR_DQUOTE] = ACTIONS(2939),
    [anon_sym_uR_DQUOTE] = ACTIONS(2939),
    [anon_sym_UR_DQUOTE] = ACTIONS(2939),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2939),
    [anon_sym_co_await] = ACTIONS(2937),
    [anon_sym_new] = ACTIONS(2937),
    [anon_sym_requires] = ACTIONS(2937),
    [sym_this] = ACTIONS(2937),
  },
  [733] = {
    [sym_identifier] = ACTIONS(3144),
    [aux_sym_preproc_include_token1] = ACTIONS(3144),
    [aux_sym_preproc_def_token1] = ACTIONS(3144),
    [aux_sym_preproc_if_token1] = ACTIONS(3144),
    [aux_sym_preproc_if_token2] = ACTIONS(3144),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3144),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3144),
    [sym_preproc_directive] = ACTIONS(3144),
    [anon_sym_LPAREN2] = ACTIONS(3146),
    [anon_sym_BANG] = ACTIONS(3146),
    [anon_sym_TILDE] = ACTIONS(3146),
    [anon_sym_DASH] = ACTIONS(3144),
    [anon_sym_PLUS] = ACTIONS(3144),
    [anon_sym_STAR] = ACTIONS(3146),
    [anon_sym_AMP_AMP] = ACTIONS(3146),
    [anon_sym_AMP] = ACTIONS(3144),
    [anon_sym_SEMI] = ACTIONS(3146),
    [anon_sym___extension__] = ACTIONS(3144),
    [anon_sym_typedef] = ACTIONS(3144),
    [anon_sym_extern] = ACTIONS(3144),
    [anon_sym___attribute__] = ACTIONS(3144),
    [anon_sym_COLON_COLON] = ACTIONS(3146),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3146),
    [anon_sym___declspec] = ACTIONS(3144),
    [anon_sym___based] = ACTIONS(3144),
    [anon_sym___cdecl] = ACTIONS(3144),
    [anon_sym___clrcall] = ACTIONS(3144),
    [anon_sym___stdcall] = ACTIONS(3144),
    [anon_sym___fastcall] = ACTIONS(3144),
    [anon_sym___thiscall] = ACTIONS(3144),
    [anon_sym___vectorcall] = ACTIONS(3144),
    [anon_sym_LBRACE] = ACTIONS(3146),
    [anon_sym_signed] = ACTIONS(3144),
    [anon_sym_unsigned] = ACTIONS(3144),
    [anon_sym_long] = ACTIONS(3144),
    [anon_sym_short] = ACTIONS(3144),
    [anon_sym_LBRACK] = ACTIONS(3144),
    [anon_sym_static] = ACTIONS(3144),
    [anon_sym_register] = ACTIONS(3144),
    [anon_sym_inline] = ACTIONS(3144),
    [anon_sym___inline] = ACTIONS(3144),
    [anon_sym___inline__] = ACTIONS(3144),
    [anon_sym___forceinline] = ACTIONS(3144),
    [anon_sym_thread_local] = ACTIONS(3144),
    [anon_sym___thread] = ACTIONS(3144),
    [anon_sym_const] = ACTIONS(3144),
    [anon_sym_constexpr] = ACTIONS(3144),
    [anon_sym_volatile] = ACTIONS(3144),
    [anon_sym_restrict] = ACTIONS(3144),
    [anon_sym___restrict__] = ACTIONS(3144),
    [anon_sym__Atomic] = ACTIONS(3144),
    [anon_sym__Noreturn] = ACTIONS(3144),
    [anon_sym_noreturn] = ACTIONS(3144),
    [anon_sym_mutable] = ACTIONS(3144),
    [anon_sym_constinit] = ACTIONS(3144),
    [anon_sym_consteval] = ACTIONS(3144),
    [anon_sym_PROGMEM] = ACTIONS(3144),
    [aux_sym_primitive_type_token1] = ACTIONS(3144),
    [anon_sym_byte] = ACTIONS(3144),
    [anon_sym_word] = ACTIONS(3144),
    [anon_sym_enum] = ACTIONS(3144),
    [anon_sym_class] = ACTIONS(3144),
    [anon_sym_struct] = ACTIONS(3144),
    [anon_sym_union] = ACTIONS(3144),
    [anon_sym_if] = ACTIONS(3144),
    [anon_sym_switch] = ACTIONS(3144),
    [anon_sym_case] = ACTIONS(3144),
    [anon_sym_default] = ACTIONS(3144),
    [anon_sym_while] = ACTIONS(3144),
    [anon_sym_do] = ACTIONS(3144),
    [anon_sym_for] = ACTIONS(3144),
    [anon_sym_return] = ACTIONS(3144),
    [anon_sym_break] = ACTIONS(3144),
    [anon_sym_continue] = ACTIONS(3144),
    [anon_sym_goto] = ACTIONS(3144),
    [anon_sym___try] = ACTIONS(3144),
    [anon_sym___leave] = ACTIONS(3144),
    [anon_sym_not] = ACTIONS(3144),
    [anon_sym_compl] = ACTIONS(3144),
    [anon_sym_DASH_DASH] = ACTIONS(3146),
    [anon_sym_PLUS_PLUS] = ACTIONS(3146),
    [anon_sym_sizeof] = ACTIONS(3144),
    [anon_sym___alignof__] = ACTIONS(3144),
    [anon_sym___alignof] = ACTIONS(3144),
    [anon_sym__alignof] = ACTIONS(3144),
    [anon_sym_alignof] = ACTIONS(3144),
    [anon_sym__Alignof] = ACTIONS(3144),
    [anon_sym_offsetof] = ACTIONS(3144),
    [anon_sym__Generic] = ACTIONS(3144),
    [anon_sym_asm] = ACTIONS(3144),
    [anon_sym___asm__] = ACTIONS(3144),
    [aux_sym_number_literal_token1] = ACTIONS(3146),
    [aux_sym_number_literal_token2] = ACTIONS(3144),
    [anon_sym_L_SQUOTE] = ACTIONS(3146),
    [anon_sym_u_SQUOTE] = ACTIONS(3146),
    [anon_sym_U_SQUOTE] = ACTIONS(3146),
    [anon_sym_u8_SQUOTE] = ACTIONS(3146),
    [anon_sym_SQUOTE] = ACTIONS(3146),
    [anon_sym_L_DQUOTE] = ACTIONS(3146),
    [anon_sym_u_DQUOTE] = ACTIONS(3146),
    [anon_sym_U_DQUOTE] = ACTIONS(3146),
    [anon_sym_u8_DQUOTE] = ACTIONS(3146),
    [anon_sym_DQUOTE] = ACTIONS(3146),
    [sym_true] = ACTIONS(3144),
    [sym_false] = ACTIONS(3144),
    [anon_sym_NULL] = ACTIONS(3144),
    [anon_sym_nullptr] = ACTIONS(3144),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3144),
    [anon_sym_decltype] = ACTIONS(3144),
    [anon_sym_virtual] = ACTIONS(3144),
    [anon_sym_alignas] = ACTIONS(3144),
    [anon_sym_explicit] = ACTIONS(3144),
    [anon_sym_typename] = ACTIONS(3144),
    [anon_sym_template] = ACTIONS(3144),
    [anon_sym_operator] = ACTIONS(3144),
    [anon_sym_try] = ACTIONS(3144),
    [anon_sym_delete] = ACTIONS(3144),
    [anon_sym_throw] = ACTIONS(3144),
    [anon_sym_namespace] = ACTIONS(3144),
    [anon_sym_using] = ACTIONS(3144),
    [anon_sym_static_assert] = ACTIONS(3144),
    [anon_sym_concept] = ACTIONS(3144),
    [anon_sym_co_return] = ACTIONS(3144),
    [anon_sym_co_yield] = ACTIONS(3144),
    [anon_sym_R_DQUOTE] = ACTIONS(3146),
    [anon_sym_LR_DQUOTE] = ACTIONS(3146),
    [anon_sym_uR_DQUOTE] = ACTIONS(3146),
    [anon_sym_UR_DQUOTE] = ACTIONS(3146),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3146),
    [anon_sym_co_await] = ACTIONS(3144),
    [anon_sym_new] = ACTIONS(3144),
    [anon_sym_requires] = ACTIONS(3144),
    [sym_this] = ACTIONS(3144),
  },
  [734] = {
    [sym_identifier] = ACTIONS(3078),
    [aux_sym_preproc_include_token1] = ACTIONS(3078),
    [aux_sym_preproc_def_token1] = ACTIONS(3078),
    [aux_sym_preproc_if_token1] = ACTIONS(3078),
    [aux_sym_preproc_if_token2] = ACTIONS(3078),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3078),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3078),
    [sym_preproc_directive] = ACTIONS(3078),
    [anon_sym_LPAREN2] = ACTIONS(3080),
    [anon_sym_BANG] = ACTIONS(3080),
    [anon_sym_TILDE] = ACTIONS(3080),
    [anon_sym_DASH] = ACTIONS(3078),
    [anon_sym_PLUS] = ACTIONS(3078),
    [anon_sym_STAR] = ACTIONS(3080),
    [anon_sym_AMP_AMP] = ACTIONS(3080),
    [anon_sym_AMP] = ACTIONS(3078),
    [anon_sym_SEMI] = ACTIONS(3080),
    [anon_sym___extension__] = ACTIONS(3078),
    [anon_sym_typedef] = ACTIONS(3078),
    [anon_sym_extern] = ACTIONS(3078),
    [anon_sym___attribute__] = ACTIONS(3078),
    [anon_sym_COLON_COLON] = ACTIONS(3080),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3080),
    [anon_sym___declspec] = ACTIONS(3078),
    [anon_sym___based] = ACTIONS(3078),
    [anon_sym___cdecl] = ACTIONS(3078),
    [anon_sym___clrcall] = ACTIONS(3078),
    [anon_sym___stdcall] = ACTIONS(3078),
    [anon_sym___fastcall] = ACTIONS(3078),
    [anon_sym___thiscall] = ACTIONS(3078),
    [anon_sym___vectorcall] = ACTIONS(3078),
    [anon_sym_LBRACE] = ACTIONS(3080),
    [anon_sym_signed] = ACTIONS(3078),
    [anon_sym_unsigned] = ACTIONS(3078),
    [anon_sym_long] = ACTIONS(3078),
    [anon_sym_short] = ACTIONS(3078),
    [anon_sym_LBRACK] = ACTIONS(3078),
    [anon_sym_static] = ACTIONS(3078),
    [anon_sym_register] = ACTIONS(3078),
    [anon_sym_inline] = ACTIONS(3078),
    [anon_sym___inline] = ACTIONS(3078),
    [anon_sym___inline__] = ACTIONS(3078),
    [anon_sym___forceinline] = ACTIONS(3078),
    [anon_sym_thread_local] = ACTIONS(3078),
    [anon_sym___thread] = ACTIONS(3078),
    [anon_sym_const] = ACTIONS(3078),
    [anon_sym_constexpr] = ACTIONS(3078),
    [anon_sym_volatile] = ACTIONS(3078),
    [anon_sym_restrict] = ACTIONS(3078),
    [anon_sym___restrict__] = ACTIONS(3078),
    [anon_sym__Atomic] = ACTIONS(3078),
    [anon_sym__Noreturn] = ACTIONS(3078),
    [anon_sym_noreturn] = ACTIONS(3078),
    [anon_sym_mutable] = ACTIONS(3078),
    [anon_sym_constinit] = ACTIONS(3078),
    [anon_sym_consteval] = ACTIONS(3078),
    [anon_sym_PROGMEM] = ACTIONS(3078),
    [aux_sym_primitive_type_token1] = ACTIONS(3078),
    [anon_sym_byte] = ACTIONS(3078),
    [anon_sym_word] = ACTIONS(3078),
    [anon_sym_enum] = ACTIONS(3078),
    [anon_sym_class] = ACTIONS(3078),
    [anon_sym_struct] = ACTIONS(3078),
    [anon_sym_union] = ACTIONS(3078),
    [anon_sym_if] = ACTIONS(3078),
    [anon_sym_switch] = ACTIONS(3078),
    [anon_sym_case] = ACTIONS(3078),
    [anon_sym_default] = ACTIONS(3078),
    [anon_sym_while] = ACTIONS(3078),
    [anon_sym_do] = ACTIONS(3078),
    [anon_sym_for] = ACTIONS(3078),
    [anon_sym_return] = ACTIONS(3078),
    [anon_sym_break] = ACTIONS(3078),
    [anon_sym_continue] = ACTIONS(3078),
    [anon_sym_goto] = ACTIONS(3078),
    [anon_sym___try] = ACTIONS(3078),
    [anon_sym___leave] = ACTIONS(3078),
    [anon_sym_not] = ACTIONS(3078),
    [anon_sym_compl] = ACTIONS(3078),
    [anon_sym_DASH_DASH] = ACTIONS(3080),
    [anon_sym_PLUS_PLUS] = ACTIONS(3080),
    [anon_sym_sizeof] = ACTIONS(3078),
    [anon_sym___alignof__] = ACTIONS(3078),
    [anon_sym___alignof] = ACTIONS(3078),
    [anon_sym__alignof] = ACTIONS(3078),
    [anon_sym_alignof] = ACTIONS(3078),
    [anon_sym__Alignof] = ACTIONS(3078),
    [anon_sym_offsetof] = ACTIONS(3078),
    [anon_sym__Generic] = ACTIONS(3078),
    [anon_sym_asm] = ACTIONS(3078),
    [anon_sym___asm__] = ACTIONS(3078),
    [aux_sym_number_literal_token1] = ACTIONS(3080),
    [aux_sym_number_literal_token2] = ACTIONS(3078),
    [anon_sym_L_SQUOTE] = ACTIONS(3080),
    [anon_sym_u_SQUOTE] = ACTIONS(3080),
    [anon_sym_U_SQUOTE] = ACTIONS(3080),
    [anon_sym_u8_SQUOTE] = ACTIONS(3080),
    [anon_sym_SQUOTE] = ACTIONS(3080),
    [anon_sym_L_DQUOTE] = ACTIONS(3080),
    [anon_sym_u_DQUOTE] = ACTIONS(3080),
    [anon_sym_U_DQUOTE] = ACTIONS(3080),
    [anon_sym_u8_DQUOTE] = ACTIONS(3080),
    [anon_sym_DQUOTE] = ACTIONS(3080),
    [sym_true] = ACTIONS(3078),
    [sym_false] = ACTIONS(3078),
    [anon_sym_NULL] = ACTIONS(3078),
    [anon_sym_nullptr] = ACTIONS(3078),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3078),
    [anon_sym_decltype] = ACTIONS(3078),
    [anon_sym_virtual] = ACTIONS(3078),
    [anon_sym_alignas] = ACTIONS(3078),
    [anon_sym_explicit] = ACTIONS(3078),
    [anon_sym_typename] = ACTIONS(3078),
    [anon_sym_template] = ACTIONS(3078),
    [anon_sym_operator] = ACTIONS(3078),
    [anon_sym_try] = ACTIONS(3078),
    [anon_sym_delete] = ACTIONS(3078),
    [anon_sym_throw] = ACTIONS(3078),
    [anon_sym_namespace] = ACTIONS(3078),
    [anon_sym_using] = ACTIONS(3078),
    [anon_sym_static_assert] = ACTIONS(3078),
    [anon_sym_concept] = ACTIONS(3078),
    [anon_sym_co_return] = ACTIONS(3078),
    [anon_sym_co_yield] = ACTIONS(3078),
    [anon_sym_R_DQUOTE] = ACTIONS(3080),
    [anon_sym_LR_DQUOTE] = ACTIONS(3080),
    [anon_sym_uR_DQUOTE] = ACTIONS(3080),
    [anon_sym_UR_DQUOTE] = ACTIONS(3080),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3080),
    [anon_sym_co_await] = ACTIONS(3078),
    [anon_sym_new] = ACTIONS(3078),
    [anon_sym_requires] = ACTIONS(3078),
    [sym_this] = ACTIONS(3078),
  },
  [735] = {
    [sym_identifier] = ACTIONS(2925),
    [aux_sym_preproc_include_token1] = ACTIONS(2925),
    [aux_sym_preproc_def_token1] = ACTIONS(2925),
    [aux_sym_preproc_if_token1] = ACTIONS(2925),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2925),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2925),
    [sym_preproc_directive] = ACTIONS(2925),
    [anon_sym_LPAREN2] = ACTIONS(2927),
    [anon_sym_BANG] = ACTIONS(2927),
    [anon_sym_TILDE] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(2925),
    [anon_sym_PLUS] = ACTIONS(2925),
    [anon_sym_STAR] = ACTIONS(2927),
    [anon_sym_AMP_AMP] = ACTIONS(2927),
    [anon_sym_AMP] = ACTIONS(2925),
    [anon_sym_SEMI] = ACTIONS(2927),
    [anon_sym___extension__] = ACTIONS(2925),
    [anon_sym_typedef] = ACTIONS(2925),
    [anon_sym_extern] = ACTIONS(2925),
    [anon_sym___attribute__] = ACTIONS(2925),
    [anon_sym_COLON_COLON] = ACTIONS(2927),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2927),
    [anon_sym___declspec] = ACTIONS(2925),
    [anon_sym___based] = ACTIONS(2925),
    [anon_sym___cdecl] = ACTIONS(2925),
    [anon_sym___clrcall] = ACTIONS(2925),
    [anon_sym___stdcall] = ACTIONS(2925),
    [anon_sym___fastcall] = ACTIONS(2925),
    [anon_sym___thiscall] = ACTIONS(2925),
    [anon_sym___vectorcall] = ACTIONS(2925),
    [anon_sym_LBRACE] = ACTIONS(2927),
    [anon_sym_RBRACE] = ACTIONS(2927),
    [anon_sym_signed] = ACTIONS(2925),
    [anon_sym_unsigned] = ACTIONS(2925),
    [anon_sym_long] = ACTIONS(2925),
    [anon_sym_short] = ACTIONS(2925),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_static] = ACTIONS(2925),
    [anon_sym_register] = ACTIONS(2925),
    [anon_sym_inline] = ACTIONS(2925),
    [anon_sym___inline] = ACTIONS(2925),
    [anon_sym___inline__] = ACTIONS(2925),
    [anon_sym___forceinline] = ACTIONS(2925),
    [anon_sym_thread_local] = ACTIONS(2925),
    [anon_sym___thread] = ACTIONS(2925),
    [anon_sym_const] = ACTIONS(2925),
    [anon_sym_constexpr] = ACTIONS(2925),
    [anon_sym_volatile] = ACTIONS(2925),
    [anon_sym_restrict] = ACTIONS(2925),
    [anon_sym___restrict__] = ACTIONS(2925),
    [anon_sym__Atomic] = ACTIONS(2925),
    [anon_sym__Noreturn] = ACTIONS(2925),
    [anon_sym_noreturn] = ACTIONS(2925),
    [anon_sym_mutable] = ACTIONS(2925),
    [anon_sym_constinit] = ACTIONS(2925),
    [anon_sym_consteval] = ACTIONS(2925),
    [anon_sym_PROGMEM] = ACTIONS(2925),
    [aux_sym_primitive_type_token1] = ACTIONS(2925),
    [anon_sym_byte] = ACTIONS(2925),
    [anon_sym_word] = ACTIONS(2925),
    [anon_sym_enum] = ACTIONS(2925),
    [anon_sym_class] = ACTIONS(2925),
    [anon_sym_struct] = ACTIONS(2925),
    [anon_sym_union] = ACTIONS(2925),
    [anon_sym_if] = ACTIONS(2925),
    [anon_sym_switch] = ACTIONS(2925),
    [anon_sym_case] = ACTIONS(2925),
    [anon_sym_default] = ACTIONS(2925),
    [anon_sym_while] = ACTIONS(2925),
    [anon_sym_do] = ACTIONS(2925),
    [anon_sym_for] = ACTIONS(2925),
    [anon_sym_return] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(2925),
    [anon_sym_continue] = ACTIONS(2925),
    [anon_sym_goto] = ACTIONS(2925),
    [anon_sym___try] = ACTIONS(2925),
    [anon_sym___leave] = ACTIONS(2925),
    [anon_sym_not] = ACTIONS(2925),
    [anon_sym_compl] = ACTIONS(2925),
    [anon_sym_DASH_DASH] = ACTIONS(2927),
    [anon_sym_PLUS_PLUS] = ACTIONS(2927),
    [anon_sym_sizeof] = ACTIONS(2925),
    [anon_sym___alignof__] = ACTIONS(2925),
    [anon_sym___alignof] = ACTIONS(2925),
    [anon_sym__alignof] = ACTIONS(2925),
    [anon_sym_alignof] = ACTIONS(2925),
    [anon_sym__Alignof] = ACTIONS(2925),
    [anon_sym_offsetof] = ACTIONS(2925),
    [anon_sym__Generic] = ACTIONS(2925),
    [anon_sym_asm] = ACTIONS(2925),
    [anon_sym___asm__] = ACTIONS(2925),
    [aux_sym_number_literal_token1] = ACTIONS(2927),
    [aux_sym_number_literal_token2] = ACTIONS(2925),
    [anon_sym_L_SQUOTE] = ACTIONS(2927),
    [anon_sym_u_SQUOTE] = ACTIONS(2927),
    [anon_sym_U_SQUOTE] = ACTIONS(2927),
    [anon_sym_u8_SQUOTE] = ACTIONS(2927),
    [anon_sym_SQUOTE] = ACTIONS(2927),
    [anon_sym_L_DQUOTE] = ACTIONS(2927),
    [anon_sym_u_DQUOTE] = ACTIONS(2927),
    [anon_sym_U_DQUOTE] = ACTIONS(2927),
    [anon_sym_u8_DQUOTE] = ACTIONS(2927),
    [anon_sym_DQUOTE] = ACTIONS(2927),
    [sym_true] = ACTIONS(2925),
    [sym_false] = ACTIONS(2925),
    [anon_sym_NULL] = ACTIONS(2925),
    [anon_sym_nullptr] = ACTIONS(2925),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2925),
    [anon_sym_decltype] = ACTIONS(2925),
    [anon_sym_virtual] = ACTIONS(2925),
    [anon_sym_alignas] = ACTIONS(2925),
    [anon_sym_explicit] = ACTIONS(2925),
    [anon_sym_typename] = ACTIONS(2925),
    [anon_sym_template] = ACTIONS(2925),
    [anon_sym_operator] = ACTIONS(2925),
    [anon_sym_try] = ACTIONS(2925),
    [anon_sym_delete] = ACTIONS(2925),
    [anon_sym_throw] = ACTIONS(2925),
    [anon_sym_namespace] = ACTIONS(2925),
    [anon_sym_using] = ACTIONS(2925),
    [anon_sym_static_assert] = ACTIONS(2925),
    [anon_sym_concept] = ACTIONS(2925),
    [anon_sym_co_return] = ACTIONS(2925),
    [anon_sym_co_yield] = ACTIONS(2925),
    [anon_sym_R_DQUOTE] = ACTIONS(2927),
    [anon_sym_LR_DQUOTE] = ACTIONS(2927),
    [anon_sym_uR_DQUOTE] = ACTIONS(2927),
    [anon_sym_UR_DQUOTE] = ACTIONS(2927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2927),
    [anon_sym_co_await] = ACTIONS(2925),
    [anon_sym_new] = ACTIONS(2925),
    [anon_sym_requires] = ACTIONS(2925),
    [sym_this] = ACTIONS(2925),
  },
  [736] = {
    [sym_identifier] = ACTIONS(3016),
    [aux_sym_preproc_include_token1] = ACTIONS(3016),
    [aux_sym_preproc_def_token1] = ACTIONS(3016),
    [aux_sym_preproc_if_token1] = ACTIONS(3016),
    [aux_sym_preproc_if_token2] = ACTIONS(3016),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3016),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3016),
    [sym_preproc_directive] = ACTIONS(3016),
    [anon_sym_LPAREN2] = ACTIONS(3018),
    [anon_sym_BANG] = ACTIONS(3018),
    [anon_sym_TILDE] = ACTIONS(3018),
    [anon_sym_DASH] = ACTIONS(3016),
    [anon_sym_PLUS] = ACTIONS(3016),
    [anon_sym_STAR] = ACTIONS(3018),
    [anon_sym_AMP_AMP] = ACTIONS(3018),
    [anon_sym_AMP] = ACTIONS(3016),
    [anon_sym_SEMI] = ACTIONS(3018),
    [anon_sym___extension__] = ACTIONS(3016),
    [anon_sym_typedef] = ACTIONS(3016),
    [anon_sym_extern] = ACTIONS(3016),
    [anon_sym___attribute__] = ACTIONS(3016),
    [anon_sym_COLON_COLON] = ACTIONS(3018),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3018),
    [anon_sym___declspec] = ACTIONS(3016),
    [anon_sym___based] = ACTIONS(3016),
    [anon_sym___cdecl] = ACTIONS(3016),
    [anon_sym___clrcall] = ACTIONS(3016),
    [anon_sym___stdcall] = ACTIONS(3016),
    [anon_sym___fastcall] = ACTIONS(3016),
    [anon_sym___thiscall] = ACTIONS(3016),
    [anon_sym___vectorcall] = ACTIONS(3016),
    [anon_sym_LBRACE] = ACTIONS(3018),
    [anon_sym_signed] = ACTIONS(3016),
    [anon_sym_unsigned] = ACTIONS(3016),
    [anon_sym_long] = ACTIONS(3016),
    [anon_sym_short] = ACTIONS(3016),
    [anon_sym_LBRACK] = ACTIONS(3016),
    [anon_sym_static] = ACTIONS(3016),
    [anon_sym_register] = ACTIONS(3016),
    [anon_sym_inline] = ACTIONS(3016),
    [anon_sym___inline] = ACTIONS(3016),
    [anon_sym___inline__] = ACTIONS(3016),
    [anon_sym___forceinline] = ACTIONS(3016),
    [anon_sym_thread_local] = ACTIONS(3016),
    [anon_sym___thread] = ACTIONS(3016),
    [anon_sym_const] = ACTIONS(3016),
    [anon_sym_constexpr] = ACTIONS(3016),
    [anon_sym_volatile] = ACTIONS(3016),
    [anon_sym_restrict] = ACTIONS(3016),
    [anon_sym___restrict__] = ACTIONS(3016),
    [anon_sym__Atomic] = ACTIONS(3016),
    [anon_sym__Noreturn] = ACTIONS(3016),
    [anon_sym_noreturn] = ACTIONS(3016),
    [anon_sym_mutable] = ACTIONS(3016),
    [anon_sym_constinit] = ACTIONS(3016),
    [anon_sym_consteval] = ACTIONS(3016),
    [anon_sym_PROGMEM] = ACTIONS(3016),
    [aux_sym_primitive_type_token1] = ACTIONS(3016),
    [anon_sym_byte] = ACTIONS(3016),
    [anon_sym_word] = ACTIONS(3016),
    [anon_sym_enum] = ACTIONS(3016),
    [anon_sym_class] = ACTIONS(3016),
    [anon_sym_struct] = ACTIONS(3016),
    [anon_sym_union] = ACTIONS(3016),
    [anon_sym_if] = ACTIONS(3016),
    [anon_sym_switch] = ACTIONS(3016),
    [anon_sym_case] = ACTIONS(3016),
    [anon_sym_default] = ACTIONS(3016),
    [anon_sym_while] = ACTIONS(3016),
    [anon_sym_do] = ACTIONS(3016),
    [anon_sym_for] = ACTIONS(3016),
    [anon_sym_return] = ACTIONS(3016),
    [anon_sym_break] = ACTIONS(3016),
    [anon_sym_continue] = ACTIONS(3016),
    [anon_sym_goto] = ACTIONS(3016),
    [anon_sym___try] = ACTIONS(3016),
    [anon_sym___leave] = ACTIONS(3016),
    [anon_sym_not] = ACTIONS(3016),
    [anon_sym_compl] = ACTIONS(3016),
    [anon_sym_DASH_DASH] = ACTIONS(3018),
    [anon_sym_PLUS_PLUS] = ACTIONS(3018),
    [anon_sym_sizeof] = ACTIONS(3016),
    [anon_sym___alignof__] = ACTIONS(3016),
    [anon_sym___alignof] = ACTIONS(3016),
    [anon_sym__alignof] = ACTIONS(3016),
    [anon_sym_alignof] = ACTIONS(3016),
    [anon_sym__Alignof] = ACTIONS(3016),
    [anon_sym_offsetof] = ACTIONS(3016),
    [anon_sym__Generic] = ACTIONS(3016),
    [anon_sym_asm] = ACTIONS(3016),
    [anon_sym___asm__] = ACTIONS(3016),
    [aux_sym_number_literal_token1] = ACTIONS(3018),
    [aux_sym_number_literal_token2] = ACTIONS(3016),
    [anon_sym_L_SQUOTE] = ACTIONS(3018),
    [anon_sym_u_SQUOTE] = ACTIONS(3018),
    [anon_sym_U_SQUOTE] = ACTIONS(3018),
    [anon_sym_u8_SQUOTE] = ACTIONS(3018),
    [anon_sym_SQUOTE] = ACTIONS(3018),
    [anon_sym_L_DQUOTE] = ACTIONS(3018),
    [anon_sym_u_DQUOTE] = ACTIONS(3018),
    [anon_sym_U_DQUOTE] = ACTIONS(3018),
    [anon_sym_u8_DQUOTE] = ACTIONS(3018),
    [anon_sym_DQUOTE] = ACTIONS(3018),
    [sym_true] = ACTIONS(3016),
    [sym_false] = ACTIONS(3016),
    [anon_sym_NULL] = ACTIONS(3016),
    [anon_sym_nullptr] = ACTIONS(3016),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3016),
    [anon_sym_decltype] = ACTIONS(3016),
    [anon_sym_virtual] = ACTIONS(3016),
    [anon_sym_alignas] = ACTIONS(3016),
    [anon_sym_explicit] = ACTIONS(3016),
    [anon_sym_typename] = ACTIONS(3016),
    [anon_sym_template] = ACTIONS(3016),
    [anon_sym_operator] = ACTIONS(3016),
    [anon_sym_try] = ACTIONS(3016),
    [anon_sym_delete] = ACTIONS(3016),
    [anon_sym_throw] = ACTIONS(3016),
    [anon_sym_namespace] = ACTIONS(3016),
    [anon_sym_using] = ACTIONS(3016),
    [anon_sym_static_assert] = ACTIONS(3016),
    [anon_sym_concept] = ACTIONS(3016),
    [anon_sym_co_return] = ACTIONS(3016),
    [anon_sym_co_yield] = ACTIONS(3016),
    [anon_sym_R_DQUOTE] = ACTIONS(3018),
    [anon_sym_LR_DQUOTE] = ACTIONS(3018),
    [anon_sym_uR_DQUOTE] = ACTIONS(3018),
    [anon_sym_UR_DQUOTE] = ACTIONS(3018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3018),
    [anon_sym_co_await] = ACTIONS(3016),
    [anon_sym_new] = ACTIONS(3016),
    [anon_sym_requires] = ACTIONS(3016),
    [sym_this] = ACTIONS(3016),
  },
  [737] = {
    [sym_identifier] = ACTIONS(2905),
    [aux_sym_preproc_include_token1] = ACTIONS(2905),
    [aux_sym_preproc_def_token1] = ACTIONS(2905),
    [aux_sym_preproc_if_token1] = ACTIONS(2905),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2905),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2905),
    [sym_preproc_directive] = ACTIONS(2905),
    [anon_sym_LPAREN2] = ACTIONS(2907),
    [anon_sym_BANG] = ACTIONS(2907),
    [anon_sym_TILDE] = ACTIONS(2907),
    [anon_sym_DASH] = ACTIONS(2905),
    [anon_sym_PLUS] = ACTIONS(2905),
    [anon_sym_STAR] = ACTIONS(2907),
    [anon_sym_AMP_AMP] = ACTIONS(2907),
    [anon_sym_AMP] = ACTIONS(2905),
    [anon_sym_SEMI] = ACTIONS(2907),
    [anon_sym___extension__] = ACTIONS(2905),
    [anon_sym_typedef] = ACTIONS(2905),
    [anon_sym_extern] = ACTIONS(2905),
    [anon_sym___attribute__] = ACTIONS(2905),
    [anon_sym_COLON_COLON] = ACTIONS(2907),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2907),
    [anon_sym___declspec] = ACTIONS(2905),
    [anon_sym___based] = ACTIONS(2905),
    [anon_sym___cdecl] = ACTIONS(2905),
    [anon_sym___clrcall] = ACTIONS(2905),
    [anon_sym___stdcall] = ACTIONS(2905),
    [anon_sym___fastcall] = ACTIONS(2905),
    [anon_sym___thiscall] = ACTIONS(2905),
    [anon_sym___vectorcall] = ACTIONS(2905),
    [anon_sym_LBRACE] = ACTIONS(2907),
    [anon_sym_RBRACE] = ACTIONS(2907),
    [anon_sym_signed] = ACTIONS(2905),
    [anon_sym_unsigned] = ACTIONS(2905),
    [anon_sym_long] = ACTIONS(2905),
    [anon_sym_short] = ACTIONS(2905),
    [anon_sym_LBRACK] = ACTIONS(2905),
    [anon_sym_static] = ACTIONS(2905),
    [anon_sym_register] = ACTIONS(2905),
    [anon_sym_inline] = ACTIONS(2905),
    [anon_sym___inline] = ACTIONS(2905),
    [anon_sym___inline__] = ACTIONS(2905),
    [anon_sym___forceinline] = ACTIONS(2905),
    [anon_sym_thread_local] = ACTIONS(2905),
    [anon_sym___thread] = ACTIONS(2905),
    [anon_sym_const] = ACTIONS(2905),
    [anon_sym_constexpr] = ACTIONS(2905),
    [anon_sym_volatile] = ACTIONS(2905),
    [anon_sym_restrict] = ACTIONS(2905),
    [anon_sym___restrict__] = ACTIONS(2905),
    [anon_sym__Atomic] = ACTIONS(2905),
    [anon_sym__Noreturn] = ACTIONS(2905),
    [anon_sym_noreturn] = ACTIONS(2905),
    [anon_sym_mutable] = ACTIONS(2905),
    [anon_sym_constinit] = ACTIONS(2905),
    [anon_sym_consteval] = ACTIONS(2905),
    [anon_sym_PROGMEM] = ACTIONS(2905),
    [aux_sym_primitive_type_token1] = ACTIONS(2905),
    [anon_sym_byte] = ACTIONS(2905),
    [anon_sym_word] = ACTIONS(2905),
    [anon_sym_enum] = ACTIONS(2905),
    [anon_sym_class] = ACTIONS(2905),
    [anon_sym_struct] = ACTIONS(2905),
    [anon_sym_union] = ACTIONS(2905),
    [anon_sym_if] = ACTIONS(2905),
    [anon_sym_switch] = ACTIONS(2905),
    [anon_sym_case] = ACTIONS(2905),
    [anon_sym_default] = ACTIONS(2905),
    [anon_sym_while] = ACTIONS(2905),
    [anon_sym_do] = ACTIONS(2905),
    [anon_sym_for] = ACTIONS(2905),
    [anon_sym_return] = ACTIONS(2905),
    [anon_sym_break] = ACTIONS(2905),
    [anon_sym_continue] = ACTIONS(2905),
    [anon_sym_goto] = ACTIONS(2905),
    [anon_sym___try] = ACTIONS(2905),
    [anon_sym___leave] = ACTIONS(2905),
    [anon_sym_not] = ACTIONS(2905),
    [anon_sym_compl] = ACTIONS(2905),
    [anon_sym_DASH_DASH] = ACTIONS(2907),
    [anon_sym_PLUS_PLUS] = ACTIONS(2907),
    [anon_sym_sizeof] = ACTIONS(2905),
    [anon_sym___alignof__] = ACTIONS(2905),
    [anon_sym___alignof] = ACTIONS(2905),
    [anon_sym__alignof] = ACTIONS(2905),
    [anon_sym_alignof] = ACTIONS(2905),
    [anon_sym__Alignof] = ACTIONS(2905),
    [anon_sym_offsetof] = ACTIONS(2905),
    [anon_sym__Generic] = ACTIONS(2905),
    [anon_sym_asm] = ACTIONS(2905),
    [anon_sym___asm__] = ACTIONS(2905),
    [aux_sym_number_literal_token1] = ACTIONS(2907),
    [aux_sym_number_literal_token2] = ACTIONS(2905),
    [anon_sym_L_SQUOTE] = ACTIONS(2907),
    [anon_sym_u_SQUOTE] = ACTIONS(2907),
    [anon_sym_U_SQUOTE] = ACTIONS(2907),
    [anon_sym_u8_SQUOTE] = ACTIONS(2907),
    [anon_sym_SQUOTE] = ACTIONS(2907),
    [anon_sym_L_DQUOTE] = ACTIONS(2907),
    [anon_sym_u_DQUOTE] = ACTIONS(2907),
    [anon_sym_U_DQUOTE] = ACTIONS(2907),
    [anon_sym_u8_DQUOTE] = ACTIONS(2907),
    [anon_sym_DQUOTE] = ACTIONS(2907),
    [sym_true] = ACTIONS(2905),
    [sym_false] = ACTIONS(2905),
    [anon_sym_NULL] = ACTIONS(2905),
    [anon_sym_nullptr] = ACTIONS(2905),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2905),
    [anon_sym_decltype] = ACTIONS(2905),
    [anon_sym_virtual] = ACTIONS(2905),
    [anon_sym_alignas] = ACTIONS(2905),
    [anon_sym_explicit] = ACTIONS(2905),
    [anon_sym_typename] = ACTIONS(2905),
    [anon_sym_template] = ACTIONS(2905),
    [anon_sym_operator] = ACTIONS(2905),
    [anon_sym_try] = ACTIONS(2905),
    [anon_sym_delete] = ACTIONS(2905),
    [anon_sym_throw] = ACTIONS(2905),
    [anon_sym_namespace] = ACTIONS(2905),
    [anon_sym_using] = ACTIONS(2905),
    [anon_sym_static_assert] = ACTIONS(2905),
    [anon_sym_concept] = ACTIONS(2905),
    [anon_sym_co_return] = ACTIONS(2905),
    [anon_sym_co_yield] = ACTIONS(2905),
    [anon_sym_R_DQUOTE] = ACTIONS(2907),
    [anon_sym_LR_DQUOTE] = ACTIONS(2907),
    [anon_sym_uR_DQUOTE] = ACTIONS(2907),
    [anon_sym_UR_DQUOTE] = ACTIONS(2907),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2907),
    [anon_sym_co_await] = ACTIONS(2905),
    [anon_sym_new] = ACTIONS(2905),
    [anon_sym_requires] = ACTIONS(2905),
    [sym_this] = ACTIONS(2905),
  },
  [738] = {
    [sym_identifier] = ACTIONS(2905),
    [aux_sym_preproc_include_token1] = ACTIONS(2905),
    [aux_sym_preproc_def_token1] = ACTIONS(2905),
    [aux_sym_preproc_if_token1] = ACTIONS(2905),
    [aux_sym_preproc_if_token2] = ACTIONS(2905),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2905),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2905),
    [sym_preproc_directive] = ACTIONS(2905),
    [anon_sym_LPAREN2] = ACTIONS(2907),
    [anon_sym_BANG] = ACTIONS(2907),
    [anon_sym_TILDE] = ACTIONS(2907),
    [anon_sym_DASH] = ACTIONS(2905),
    [anon_sym_PLUS] = ACTIONS(2905),
    [anon_sym_STAR] = ACTIONS(2907),
    [anon_sym_AMP_AMP] = ACTIONS(2907),
    [anon_sym_AMP] = ACTIONS(2905),
    [anon_sym_SEMI] = ACTIONS(2907),
    [anon_sym___extension__] = ACTIONS(2905),
    [anon_sym_typedef] = ACTIONS(2905),
    [anon_sym_extern] = ACTIONS(2905),
    [anon_sym___attribute__] = ACTIONS(2905),
    [anon_sym_COLON_COLON] = ACTIONS(2907),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2907),
    [anon_sym___declspec] = ACTIONS(2905),
    [anon_sym___based] = ACTIONS(2905),
    [anon_sym___cdecl] = ACTIONS(2905),
    [anon_sym___clrcall] = ACTIONS(2905),
    [anon_sym___stdcall] = ACTIONS(2905),
    [anon_sym___fastcall] = ACTIONS(2905),
    [anon_sym___thiscall] = ACTIONS(2905),
    [anon_sym___vectorcall] = ACTIONS(2905),
    [anon_sym_LBRACE] = ACTIONS(2907),
    [anon_sym_signed] = ACTIONS(2905),
    [anon_sym_unsigned] = ACTIONS(2905),
    [anon_sym_long] = ACTIONS(2905),
    [anon_sym_short] = ACTIONS(2905),
    [anon_sym_LBRACK] = ACTIONS(2905),
    [anon_sym_static] = ACTIONS(2905),
    [anon_sym_register] = ACTIONS(2905),
    [anon_sym_inline] = ACTIONS(2905),
    [anon_sym___inline] = ACTIONS(2905),
    [anon_sym___inline__] = ACTIONS(2905),
    [anon_sym___forceinline] = ACTIONS(2905),
    [anon_sym_thread_local] = ACTIONS(2905),
    [anon_sym___thread] = ACTIONS(2905),
    [anon_sym_const] = ACTIONS(2905),
    [anon_sym_constexpr] = ACTIONS(2905),
    [anon_sym_volatile] = ACTIONS(2905),
    [anon_sym_restrict] = ACTIONS(2905),
    [anon_sym___restrict__] = ACTIONS(2905),
    [anon_sym__Atomic] = ACTIONS(2905),
    [anon_sym__Noreturn] = ACTIONS(2905),
    [anon_sym_noreturn] = ACTIONS(2905),
    [anon_sym_mutable] = ACTIONS(2905),
    [anon_sym_constinit] = ACTIONS(2905),
    [anon_sym_consteval] = ACTIONS(2905),
    [anon_sym_PROGMEM] = ACTIONS(2905),
    [aux_sym_primitive_type_token1] = ACTIONS(2905),
    [anon_sym_byte] = ACTIONS(2905),
    [anon_sym_word] = ACTIONS(2905),
    [anon_sym_enum] = ACTIONS(2905),
    [anon_sym_class] = ACTIONS(2905),
    [anon_sym_struct] = ACTIONS(2905),
    [anon_sym_union] = ACTIONS(2905),
    [anon_sym_if] = ACTIONS(2905),
    [anon_sym_switch] = ACTIONS(2905),
    [anon_sym_case] = ACTIONS(2905),
    [anon_sym_default] = ACTIONS(2905),
    [anon_sym_while] = ACTIONS(2905),
    [anon_sym_do] = ACTIONS(2905),
    [anon_sym_for] = ACTIONS(2905),
    [anon_sym_return] = ACTIONS(2905),
    [anon_sym_break] = ACTIONS(2905),
    [anon_sym_continue] = ACTIONS(2905),
    [anon_sym_goto] = ACTIONS(2905),
    [anon_sym___try] = ACTIONS(2905),
    [anon_sym___leave] = ACTIONS(2905),
    [anon_sym_not] = ACTIONS(2905),
    [anon_sym_compl] = ACTIONS(2905),
    [anon_sym_DASH_DASH] = ACTIONS(2907),
    [anon_sym_PLUS_PLUS] = ACTIONS(2907),
    [anon_sym_sizeof] = ACTIONS(2905),
    [anon_sym___alignof__] = ACTIONS(2905),
    [anon_sym___alignof] = ACTIONS(2905),
    [anon_sym__alignof] = ACTIONS(2905),
    [anon_sym_alignof] = ACTIONS(2905),
    [anon_sym__Alignof] = ACTIONS(2905),
    [anon_sym_offsetof] = ACTIONS(2905),
    [anon_sym__Generic] = ACTIONS(2905),
    [anon_sym_asm] = ACTIONS(2905),
    [anon_sym___asm__] = ACTIONS(2905),
    [aux_sym_number_literal_token1] = ACTIONS(2907),
    [aux_sym_number_literal_token2] = ACTIONS(2905),
    [anon_sym_L_SQUOTE] = ACTIONS(2907),
    [anon_sym_u_SQUOTE] = ACTIONS(2907),
    [anon_sym_U_SQUOTE] = ACTIONS(2907),
    [anon_sym_u8_SQUOTE] = ACTIONS(2907),
    [anon_sym_SQUOTE] = ACTIONS(2907),
    [anon_sym_L_DQUOTE] = ACTIONS(2907),
    [anon_sym_u_DQUOTE] = ACTIONS(2907),
    [anon_sym_U_DQUOTE] = ACTIONS(2907),
    [anon_sym_u8_DQUOTE] = ACTIONS(2907),
    [anon_sym_DQUOTE] = ACTIONS(2907),
    [sym_true] = ACTIONS(2905),
    [sym_false] = ACTIONS(2905),
    [anon_sym_NULL] = ACTIONS(2905),
    [anon_sym_nullptr] = ACTIONS(2905),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2905),
    [anon_sym_decltype] = ACTIONS(2905),
    [anon_sym_virtual] = ACTIONS(2905),
    [anon_sym_alignas] = ACTIONS(2905),
    [anon_sym_explicit] = ACTIONS(2905),
    [anon_sym_typename] = ACTIONS(2905),
    [anon_sym_template] = ACTIONS(2905),
    [anon_sym_operator] = ACTIONS(2905),
    [anon_sym_try] = ACTIONS(2905),
    [anon_sym_delete] = ACTIONS(2905),
    [anon_sym_throw] = ACTIONS(2905),
    [anon_sym_namespace] = ACTIONS(2905),
    [anon_sym_using] = ACTIONS(2905),
    [anon_sym_static_assert] = ACTIONS(2905),
    [anon_sym_concept] = ACTIONS(2905),
    [anon_sym_co_return] = ACTIONS(2905),
    [anon_sym_co_yield] = ACTIONS(2905),
    [anon_sym_R_DQUOTE] = ACTIONS(2907),
    [anon_sym_LR_DQUOTE] = ACTIONS(2907),
    [anon_sym_uR_DQUOTE] = ACTIONS(2907),
    [anon_sym_UR_DQUOTE] = ACTIONS(2907),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2907),
    [anon_sym_co_await] = ACTIONS(2905),
    [anon_sym_new] = ACTIONS(2905),
    [anon_sym_requires] = ACTIONS(2905),
    [sym_this] = ACTIONS(2905),
  },
  [739] = {
    [sym_identifier] = ACTIONS(2901),
    [aux_sym_preproc_include_token1] = ACTIONS(2901),
    [aux_sym_preproc_def_token1] = ACTIONS(2901),
    [aux_sym_preproc_if_token1] = ACTIONS(2901),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2901),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2901),
    [sym_preproc_directive] = ACTIONS(2901),
    [anon_sym_LPAREN2] = ACTIONS(2903),
    [anon_sym_BANG] = ACTIONS(2903),
    [anon_sym_TILDE] = ACTIONS(2903),
    [anon_sym_DASH] = ACTIONS(2901),
    [anon_sym_PLUS] = ACTIONS(2901),
    [anon_sym_STAR] = ACTIONS(2903),
    [anon_sym_AMP_AMP] = ACTIONS(2903),
    [anon_sym_AMP] = ACTIONS(2901),
    [anon_sym_SEMI] = ACTIONS(2903),
    [anon_sym___extension__] = ACTIONS(2901),
    [anon_sym_typedef] = ACTIONS(2901),
    [anon_sym_extern] = ACTIONS(2901),
    [anon_sym___attribute__] = ACTIONS(2901),
    [anon_sym_COLON_COLON] = ACTIONS(2903),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2903),
    [anon_sym___declspec] = ACTIONS(2901),
    [anon_sym___based] = ACTIONS(2901),
    [anon_sym___cdecl] = ACTIONS(2901),
    [anon_sym___clrcall] = ACTIONS(2901),
    [anon_sym___stdcall] = ACTIONS(2901),
    [anon_sym___fastcall] = ACTIONS(2901),
    [anon_sym___thiscall] = ACTIONS(2901),
    [anon_sym___vectorcall] = ACTIONS(2901),
    [anon_sym_LBRACE] = ACTIONS(2903),
    [anon_sym_RBRACE] = ACTIONS(2903),
    [anon_sym_signed] = ACTIONS(2901),
    [anon_sym_unsigned] = ACTIONS(2901),
    [anon_sym_long] = ACTIONS(2901),
    [anon_sym_short] = ACTIONS(2901),
    [anon_sym_LBRACK] = ACTIONS(2901),
    [anon_sym_static] = ACTIONS(2901),
    [anon_sym_register] = ACTIONS(2901),
    [anon_sym_inline] = ACTIONS(2901),
    [anon_sym___inline] = ACTIONS(2901),
    [anon_sym___inline__] = ACTIONS(2901),
    [anon_sym___forceinline] = ACTIONS(2901),
    [anon_sym_thread_local] = ACTIONS(2901),
    [anon_sym___thread] = ACTIONS(2901),
    [anon_sym_const] = ACTIONS(2901),
    [anon_sym_constexpr] = ACTIONS(2901),
    [anon_sym_volatile] = ACTIONS(2901),
    [anon_sym_restrict] = ACTIONS(2901),
    [anon_sym___restrict__] = ACTIONS(2901),
    [anon_sym__Atomic] = ACTIONS(2901),
    [anon_sym__Noreturn] = ACTIONS(2901),
    [anon_sym_noreturn] = ACTIONS(2901),
    [anon_sym_mutable] = ACTIONS(2901),
    [anon_sym_constinit] = ACTIONS(2901),
    [anon_sym_consteval] = ACTIONS(2901),
    [anon_sym_PROGMEM] = ACTIONS(2901),
    [aux_sym_primitive_type_token1] = ACTIONS(2901),
    [anon_sym_byte] = ACTIONS(2901),
    [anon_sym_word] = ACTIONS(2901),
    [anon_sym_enum] = ACTIONS(2901),
    [anon_sym_class] = ACTIONS(2901),
    [anon_sym_struct] = ACTIONS(2901),
    [anon_sym_union] = ACTIONS(2901),
    [anon_sym_if] = ACTIONS(2901),
    [anon_sym_switch] = ACTIONS(2901),
    [anon_sym_case] = ACTIONS(2901),
    [anon_sym_default] = ACTIONS(2901),
    [anon_sym_while] = ACTIONS(2901),
    [anon_sym_do] = ACTIONS(2901),
    [anon_sym_for] = ACTIONS(2901),
    [anon_sym_return] = ACTIONS(2901),
    [anon_sym_break] = ACTIONS(2901),
    [anon_sym_continue] = ACTIONS(2901),
    [anon_sym_goto] = ACTIONS(2901),
    [anon_sym___try] = ACTIONS(2901),
    [anon_sym___leave] = ACTIONS(2901),
    [anon_sym_not] = ACTIONS(2901),
    [anon_sym_compl] = ACTIONS(2901),
    [anon_sym_DASH_DASH] = ACTIONS(2903),
    [anon_sym_PLUS_PLUS] = ACTIONS(2903),
    [anon_sym_sizeof] = ACTIONS(2901),
    [anon_sym___alignof__] = ACTIONS(2901),
    [anon_sym___alignof] = ACTIONS(2901),
    [anon_sym__alignof] = ACTIONS(2901),
    [anon_sym_alignof] = ACTIONS(2901),
    [anon_sym__Alignof] = ACTIONS(2901),
    [anon_sym_offsetof] = ACTIONS(2901),
    [anon_sym__Generic] = ACTIONS(2901),
    [anon_sym_asm] = ACTIONS(2901),
    [anon_sym___asm__] = ACTIONS(2901),
    [aux_sym_number_literal_token1] = ACTIONS(2903),
    [aux_sym_number_literal_token2] = ACTIONS(2901),
    [anon_sym_L_SQUOTE] = ACTIONS(2903),
    [anon_sym_u_SQUOTE] = ACTIONS(2903),
    [anon_sym_U_SQUOTE] = ACTIONS(2903),
    [anon_sym_u8_SQUOTE] = ACTIONS(2903),
    [anon_sym_SQUOTE] = ACTIONS(2903),
    [anon_sym_L_DQUOTE] = ACTIONS(2903),
    [anon_sym_u_DQUOTE] = ACTIONS(2903),
    [anon_sym_U_DQUOTE] = ACTIONS(2903),
    [anon_sym_u8_DQUOTE] = ACTIONS(2903),
    [anon_sym_DQUOTE] = ACTIONS(2903),
    [sym_true] = ACTIONS(2901),
    [sym_false] = ACTIONS(2901),
    [anon_sym_NULL] = ACTIONS(2901),
    [anon_sym_nullptr] = ACTIONS(2901),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2901),
    [anon_sym_decltype] = ACTIONS(2901),
    [anon_sym_virtual] = ACTIONS(2901),
    [anon_sym_alignas] = ACTIONS(2901),
    [anon_sym_explicit] = ACTIONS(2901),
    [anon_sym_typename] = ACTIONS(2901),
    [anon_sym_template] = ACTIONS(2901),
    [anon_sym_operator] = ACTIONS(2901),
    [anon_sym_try] = ACTIONS(2901),
    [anon_sym_delete] = ACTIONS(2901),
    [anon_sym_throw] = ACTIONS(2901),
    [anon_sym_namespace] = ACTIONS(2901),
    [anon_sym_using] = ACTIONS(2901),
    [anon_sym_static_assert] = ACTIONS(2901),
    [anon_sym_concept] = ACTIONS(2901),
    [anon_sym_co_return] = ACTIONS(2901),
    [anon_sym_co_yield] = ACTIONS(2901),
    [anon_sym_R_DQUOTE] = ACTIONS(2903),
    [anon_sym_LR_DQUOTE] = ACTIONS(2903),
    [anon_sym_uR_DQUOTE] = ACTIONS(2903),
    [anon_sym_UR_DQUOTE] = ACTIONS(2903),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2903),
    [anon_sym_co_await] = ACTIONS(2901),
    [anon_sym_new] = ACTIONS(2901),
    [anon_sym_requires] = ACTIONS(2901),
    [sym_this] = ACTIONS(2901),
  },
  [740] = {
    [sym_identifier] = ACTIONS(2897),
    [aux_sym_preproc_include_token1] = ACTIONS(2897),
    [aux_sym_preproc_def_token1] = ACTIONS(2897),
    [aux_sym_preproc_if_token1] = ACTIONS(2897),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2897),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2897),
    [sym_preproc_directive] = ACTIONS(2897),
    [anon_sym_LPAREN2] = ACTIONS(2899),
    [anon_sym_BANG] = ACTIONS(2899),
    [anon_sym_TILDE] = ACTIONS(2899),
    [anon_sym_DASH] = ACTIONS(2897),
    [anon_sym_PLUS] = ACTIONS(2897),
    [anon_sym_STAR] = ACTIONS(2899),
    [anon_sym_AMP_AMP] = ACTIONS(2899),
    [anon_sym_AMP] = ACTIONS(2897),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym___extension__] = ACTIONS(2897),
    [anon_sym_typedef] = ACTIONS(2897),
    [anon_sym_extern] = ACTIONS(2897),
    [anon_sym___attribute__] = ACTIONS(2897),
    [anon_sym_COLON_COLON] = ACTIONS(2899),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2899),
    [anon_sym___declspec] = ACTIONS(2897),
    [anon_sym___based] = ACTIONS(2897),
    [anon_sym___cdecl] = ACTIONS(2897),
    [anon_sym___clrcall] = ACTIONS(2897),
    [anon_sym___stdcall] = ACTIONS(2897),
    [anon_sym___fastcall] = ACTIONS(2897),
    [anon_sym___thiscall] = ACTIONS(2897),
    [anon_sym___vectorcall] = ACTIONS(2897),
    [anon_sym_LBRACE] = ACTIONS(2899),
    [anon_sym_RBRACE] = ACTIONS(2899),
    [anon_sym_signed] = ACTIONS(2897),
    [anon_sym_unsigned] = ACTIONS(2897),
    [anon_sym_long] = ACTIONS(2897),
    [anon_sym_short] = ACTIONS(2897),
    [anon_sym_LBRACK] = ACTIONS(2897),
    [anon_sym_static] = ACTIONS(2897),
    [anon_sym_register] = ACTIONS(2897),
    [anon_sym_inline] = ACTIONS(2897),
    [anon_sym___inline] = ACTIONS(2897),
    [anon_sym___inline__] = ACTIONS(2897),
    [anon_sym___forceinline] = ACTIONS(2897),
    [anon_sym_thread_local] = ACTIONS(2897),
    [anon_sym___thread] = ACTIONS(2897),
    [anon_sym_const] = ACTIONS(2897),
    [anon_sym_constexpr] = ACTIONS(2897),
    [anon_sym_volatile] = ACTIONS(2897),
    [anon_sym_restrict] = ACTIONS(2897),
    [anon_sym___restrict__] = ACTIONS(2897),
    [anon_sym__Atomic] = ACTIONS(2897),
    [anon_sym__Noreturn] = ACTIONS(2897),
    [anon_sym_noreturn] = ACTIONS(2897),
    [anon_sym_mutable] = ACTIONS(2897),
    [anon_sym_constinit] = ACTIONS(2897),
    [anon_sym_consteval] = ACTIONS(2897),
    [anon_sym_PROGMEM] = ACTIONS(2897),
    [aux_sym_primitive_type_token1] = ACTIONS(2897),
    [anon_sym_byte] = ACTIONS(2897),
    [anon_sym_word] = ACTIONS(2897),
    [anon_sym_enum] = ACTIONS(2897),
    [anon_sym_class] = ACTIONS(2897),
    [anon_sym_struct] = ACTIONS(2897),
    [anon_sym_union] = ACTIONS(2897),
    [anon_sym_if] = ACTIONS(2897),
    [anon_sym_switch] = ACTIONS(2897),
    [anon_sym_case] = ACTIONS(2897),
    [anon_sym_default] = ACTIONS(2897),
    [anon_sym_while] = ACTIONS(2897),
    [anon_sym_do] = ACTIONS(2897),
    [anon_sym_for] = ACTIONS(2897),
    [anon_sym_return] = ACTIONS(2897),
    [anon_sym_break] = ACTIONS(2897),
    [anon_sym_continue] = ACTIONS(2897),
    [anon_sym_goto] = ACTIONS(2897),
    [anon_sym___try] = ACTIONS(2897),
    [anon_sym___leave] = ACTIONS(2897),
    [anon_sym_not] = ACTIONS(2897),
    [anon_sym_compl] = ACTIONS(2897),
    [anon_sym_DASH_DASH] = ACTIONS(2899),
    [anon_sym_PLUS_PLUS] = ACTIONS(2899),
    [anon_sym_sizeof] = ACTIONS(2897),
    [anon_sym___alignof__] = ACTIONS(2897),
    [anon_sym___alignof] = ACTIONS(2897),
    [anon_sym__alignof] = ACTIONS(2897),
    [anon_sym_alignof] = ACTIONS(2897),
    [anon_sym__Alignof] = ACTIONS(2897),
    [anon_sym_offsetof] = ACTIONS(2897),
    [anon_sym__Generic] = ACTIONS(2897),
    [anon_sym_asm] = ACTIONS(2897),
    [anon_sym___asm__] = ACTIONS(2897),
    [aux_sym_number_literal_token1] = ACTIONS(2899),
    [aux_sym_number_literal_token2] = ACTIONS(2897),
    [anon_sym_L_SQUOTE] = ACTIONS(2899),
    [anon_sym_u_SQUOTE] = ACTIONS(2899),
    [anon_sym_U_SQUOTE] = ACTIONS(2899),
    [anon_sym_u8_SQUOTE] = ACTIONS(2899),
    [anon_sym_SQUOTE] = ACTIONS(2899),
    [anon_sym_L_DQUOTE] = ACTIONS(2899),
    [anon_sym_u_DQUOTE] = ACTIONS(2899),
    [anon_sym_U_DQUOTE] = ACTIONS(2899),
    [anon_sym_u8_DQUOTE] = ACTIONS(2899),
    [anon_sym_DQUOTE] = ACTIONS(2899),
    [sym_true] = ACTIONS(2897),
    [sym_false] = ACTIONS(2897),
    [anon_sym_NULL] = ACTIONS(2897),
    [anon_sym_nullptr] = ACTIONS(2897),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2897),
    [anon_sym_decltype] = ACTIONS(2897),
    [anon_sym_virtual] = ACTIONS(2897),
    [anon_sym_alignas] = ACTIONS(2897),
    [anon_sym_explicit] = ACTIONS(2897),
    [anon_sym_typename] = ACTIONS(2897),
    [anon_sym_template] = ACTIONS(2897),
    [anon_sym_operator] = ACTIONS(2897),
    [anon_sym_try] = ACTIONS(2897),
    [anon_sym_delete] = ACTIONS(2897),
    [anon_sym_throw] = ACTIONS(2897),
    [anon_sym_namespace] = ACTIONS(2897),
    [anon_sym_using] = ACTIONS(2897),
    [anon_sym_static_assert] = ACTIONS(2897),
    [anon_sym_concept] = ACTIONS(2897),
    [anon_sym_co_return] = ACTIONS(2897),
    [anon_sym_co_yield] = ACTIONS(2897),
    [anon_sym_R_DQUOTE] = ACTIONS(2899),
    [anon_sym_LR_DQUOTE] = ACTIONS(2899),
    [anon_sym_uR_DQUOTE] = ACTIONS(2899),
    [anon_sym_UR_DQUOTE] = ACTIONS(2899),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2899),
    [anon_sym_co_await] = ACTIONS(2897),
    [anon_sym_new] = ACTIONS(2897),
    [anon_sym_requires] = ACTIONS(2897),
    [sym_this] = ACTIONS(2897),
  },
  [741] = {
    [sym_identifier] = ACTIONS(3068),
    [aux_sym_preproc_include_token1] = ACTIONS(3068),
    [aux_sym_preproc_def_token1] = ACTIONS(3068),
    [aux_sym_preproc_if_token1] = ACTIONS(3068),
    [aux_sym_preproc_if_token2] = ACTIONS(3068),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3068),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3068),
    [sym_preproc_directive] = ACTIONS(3068),
    [anon_sym_LPAREN2] = ACTIONS(3070),
    [anon_sym_BANG] = ACTIONS(3070),
    [anon_sym_TILDE] = ACTIONS(3070),
    [anon_sym_DASH] = ACTIONS(3068),
    [anon_sym_PLUS] = ACTIONS(3068),
    [anon_sym_STAR] = ACTIONS(3070),
    [anon_sym_AMP_AMP] = ACTIONS(3070),
    [anon_sym_AMP] = ACTIONS(3068),
    [anon_sym_SEMI] = ACTIONS(3070),
    [anon_sym___extension__] = ACTIONS(3068),
    [anon_sym_typedef] = ACTIONS(3068),
    [anon_sym_extern] = ACTIONS(3068),
    [anon_sym___attribute__] = ACTIONS(3068),
    [anon_sym_COLON_COLON] = ACTIONS(3070),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3070),
    [anon_sym___declspec] = ACTIONS(3068),
    [anon_sym___based] = ACTIONS(3068),
    [anon_sym___cdecl] = ACTIONS(3068),
    [anon_sym___clrcall] = ACTIONS(3068),
    [anon_sym___stdcall] = ACTIONS(3068),
    [anon_sym___fastcall] = ACTIONS(3068),
    [anon_sym___thiscall] = ACTIONS(3068),
    [anon_sym___vectorcall] = ACTIONS(3068),
    [anon_sym_LBRACE] = ACTIONS(3070),
    [anon_sym_signed] = ACTIONS(3068),
    [anon_sym_unsigned] = ACTIONS(3068),
    [anon_sym_long] = ACTIONS(3068),
    [anon_sym_short] = ACTIONS(3068),
    [anon_sym_LBRACK] = ACTIONS(3068),
    [anon_sym_static] = ACTIONS(3068),
    [anon_sym_register] = ACTIONS(3068),
    [anon_sym_inline] = ACTIONS(3068),
    [anon_sym___inline] = ACTIONS(3068),
    [anon_sym___inline__] = ACTIONS(3068),
    [anon_sym___forceinline] = ACTIONS(3068),
    [anon_sym_thread_local] = ACTIONS(3068),
    [anon_sym___thread] = ACTIONS(3068),
    [anon_sym_const] = ACTIONS(3068),
    [anon_sym_constexpr] = ACTIONS(3068),
    [anon_sym_volatile] = ACTIONS(3068),
    [anon_sym_restrict] = ACTIONS(3068),
    [anon_sym___restrict__] = ACTIONS(3068),
    [anon_sym__Atomic] = ACTIONS(3068),
    [anon_sym__Noreturn] = ACTIONS(3068),
    [anon_sym_noreturn] = ACTIONS(3068),
    [anon_sym_mutable] = ACTIONS(3068),
    [anon_sym_constinit] = ACTIONS(3068),
    [anon_sym_consteval] = ACTIONS(3068),
    [anon_sym_PROGMEM] = ACTIONS(3068),
    [aux_sym_primitive_type_token1] = ACTIONS(3068),
    [anon_sym_byte] = ACTIONS(3068),
    [anon_sym_word] = ACTIONS(3068),
    [anon_sym_enum] = ACTIONS(3068),
    [anon_sym_class] = ACTIONS(3068),
    [anon_sym_struct] = ACTIONS(3068),
    [anon_sym_union] = ACTIONS(3068),
    [anon_sym_if] = ACTIONS(3068),
    [anon_sym_switch] = ACTIONS(3068),
    [anon_sym_case] = ACTIONS(3068),
    [anon_sym_default] = ACTIONS(3068),
    [anon_sym_while] = ACTIONS(3068),
    [anon_sym_do] = ACTIONS(3068),
    [anon_sym_for] = ACTIONS(3068),
    [anon_sym_return] = ACTIONS(3068),
    [anon_sym_break] = ACTIONS(3068),
    [anon_sym_continue] = ACTIONS(3068),
    [anon_sym_goto] = ACTIONS(3068),
    [anon_sym___try] = ACTIONS(3068),
    [anon_sym___leave] = ACTIONS(3068),
    [anon_sym_not] = ACTIONS(3068),
    [anon_sym_compl] = ACTIONS(3068),
    [anon_sym_DASH_DASH] = ACTIONS(3070),
    [anon_sym_PLUS_PLUS] = ACTIONS(3070),
    [anon_sym_sizeof] = ACTIONS(3068),
    [anon_sym___alignof__] = ACTIONS(3068),
    [anon_sym___alignof] = ACTIONS(3068),
    [anon_sym__alignof] = ACTIONS(3068),
    [anon_sym_alignof] = ACTIONS(3068),
    [anon_sym__Alignof] = ACTIONS(3068),
    [anon_sym_offsetof] = ACTIONS(3068),
    [anon_sym__Generic] = ACTIONS(3068),
    [anon_sym_asm] = ACTIONS(3068),
    [anon_sym___asm__] = ACTIONS(3068),
    [aux_sym_number_literal_token1] = ACTIONS(3070),
    [aux_sym_number_literal_token2] = ACTIONS(3068),
    [anon_sym_L_SQUOTE] = ACTIONS(3070),
    [anon_sym_u_SQUOTE] = ACTIONS(3070),
    [anon_sym_U_SQUOTE] = ACTIONS(3070),
    [anon_sym_u8_SQUOTE] = ACTIONS(3070),
    [anon_sym_SQUOTE] = ACTIONS(3070),
    [anon_sym_L_DQUOTE] = ACTIONS(3070),
    [anon_sym_u_DQUOTE] = ACTIONS(3070),
    [anon_sym_U_DQUOTE] = ACTIONS(3070),
    [anon_sym_u8_DQUOTE] = ACTIONS(3070),
    [anon_sym_DQUOTE] = ACTIONS(3070),
    [sym_true] = ACTIONS(3068),
    [sym_false] = ACTIONS(3068),
    [anon_sym_NULL] = ACTIONS(3068),
    [anon_sym_nullptr] = ACTIONS(3068),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3068),
    [anon_sym_decltype] = ACTIONS(3068),
    [anon_sym_virtual] = ACTIONS(3068),
    [anon_sym_alignas] = ACTIONS(3068),
    [anon_sym_explicit] = ACTIONS(3068),
    [anon_sym_typename] = ACTIONS(3068),
    [anon_sym_template] = ACTIONS(3068),
    [anon_sym_operator] = ACTIONS(3068),
    [anon_sym_try] = ACTIONS(3068),
    [anon_sym_delete] = ACTIONS(3068),
    [anon_sym_throw] = ACTIONS(3068),
    [anon_sym_namespace] = ACTIONS(3068),
    [anon_sym_using] = ACTIONS(3068),
    [anon_sym_static_assert] = ACTIONS(3068),
    [anon_sym_concept] = ACTIONS(3068),
    [anon_sym_co_return] = ACTIONS(3068),
    [anon_sym_co_yield] = ACTIONS(3068),
    [anon_sym_R_DQUOTE] = ACTIONS(3070),
    [anon_sym_LR_DQUOTE] = ACTIONS(3070),
    [anon_sym_uR_DQUOTE] = ACTIONS(3070),
    [anon_sym_UR_DQUOTE] = ACTIONS(3070),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3070),
    [anon_sym_co_await] = ACTIONS(3068),
    [anon_sym_new] = ACTIONS(3068),
    [anon_sym_requires] = ACTIONS(3068),
    [sym_this] = ACTIONS(3068),
  },
  [742] = {
    [sym_identifier] = ACTIONS(3068),
    [aux_sym_preproc_include_token1] = ACTIONS(3068),
    [aux_sym_preproc_def_token1] = ACTIONS(3068),
    [aux_sym_preproc_if_token1] = ACTIONS(3068),
    [aux_sym_preproc_if_token2] = ACTIONS(3068),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3068),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3068),
    [sym_preproc_directive] = ACTIONS(3068),
    [anon_sym_LPAREN2] = ACTIONS(3070),
    [anon_sym_BANG] = ACTIONS(3070),
    [anon_sym_TILDE] = ACTIONS(3070),
    [anon_sym_DASH] = ACTIONS(3068),
    [anon_sym_PLUS] = ACTIONS(3068),
    [anon_sym_STAR] = ACTIONS(3070),
    [anon_sym_AMP_AMP] = ACTIONS(3070),
    [anon_sym_AMP] = ACTIONS(3068),
    [anon_sym_SEMI] = ACTIONS(3070),
    [anon_sym___extension__] = ACTIONS(3068),
    [anon_sym_typedef] = ACTIONS(3068),
    [anon_sym_extern] = ACTIONS(3068),
    [anon_sym___attribute__] = ACTIONS(3068),
    [anon_sym_COLON_COLON] = ACTIONS(3070),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3070),
    [anon_sym___declspec] = ACTIONS(3068),
    [anon_sym___based] = ACTIONS(3068),
    [anon_sym___cdecl] = ACTIONS(3068),
    [anon_sym___clrcall] = ACTIONS(3068),
    [anon_sym___stdcall] = ACTIONS(3068),
    [anon_sym___fastcall] = ACTIONS(3068),
    [anon_sym___thiscall] = ACTIONS(3068),
    [anon_sym___vectorcall] = ACTIONS(3068),
    [anon_sym_LBRACE] = ACTIONS(3070),
    [anon_sym_signed] = ACTIONS(3068),
    [anon_sym_unsigned] = ACTIONS(3068),
    [anon_sym_long] = ACTIONS(3068),
    [anon_sym_short] = ACTIONS(3068),
    [anon_sym_LBRACK] = ACTIONS(3068),
    [anon_sym_static] = ACTIONS(3068),
    [anon_sym_register] = ACTIONS(3068),
    [anon_sym_inline] = ACTIONS(3068),
    [anon_sym___inline] = ACTIONS(3068),
    [anon_sym___inline__] = ACTIONS(3068),
    [anon_sym___forceinline] = ACTIONS(3068),
    [anon_sym_thread_local] = ACTIONS(3068),
    [anon_sym___thread] = ACTIONS(3068),
    [anon_sym_const] = ACTIONS(3068),
    [anon_sym_constexpr] = ACTIONS(3068),
    [anon_sym_volatile] = ACTIONS(3068),
    [anon_sym_restrict] = ACTIONS(3068),
    [anon_sym___restrict__] = ACTIONS(3068),
    [anon_sym__Atomic] = ACTIONS(3068),
    [anon_sym__Noreturn] = ACTIONS(3068),
    [anon_sym_noreturn] = ACTIONS(3068),
    [anon_sym_mutable] = ACTIONS(3068),
    [anon_sym_constinit] = ACTIONS(3068),
    [anon_sym_consteval] = ACTIONS(3068),
    [anon_sym_PROGMEM] = ACTIONS(3068),
    [aux_sym_primitive_type_token1] = ACTIONS(3068),
    [anon_sym_byte] = ACTIONS(3068),
    [anon_sym_word] = ACTIONS(3068),
    [anon_sym_enum] = ACTIONS(3068),
    [anon_sym_class] = ACTIONS(3068),
    [anon_sym_struct] = ACTIONS(3068),
    [anon_sym_union] = ACTIONS(3068),
    [anon_sym_if] = ACTIONS(3068),
    [anon_sym_switch] = ACTIONS(3068),
    [anon_sym_case] = ACTIONS(3068),
    [anon_sym_default] = ACTIONS(3068),
    [anon_sym_while] = ACTIONS(3068),
    [anon_sym_do] = ACTIONS(3068),
    [anon_sym_for] = ACTIONS(3068),
    [anon_sym_return] = ACTIONS(3068),
    [anon_sym_break] = ACTIONS(3068),
    [anon_sym_continue] = ACTIONS(3068),
    [anon_sym_goto] = ACTIONS(3068),
    [anon_sym___try] = ACTIONS(3068),
    [anon_sym___leave] = ACTIONS(3068),
    [anon_sym_not] = ACTIONS(3068),
    [anon_sym_compl] = ACTIONS(3068),
    [anon_sym_DASH_DASH] = ACTIONS(3070),
    [anon_sym_PLUS_PLUS] = ACTIONS(3070),
    [anon_sym_sizeof] = ACTIONS(3068),
    [anon_sym___alignof__] = ACTIONS(3068),
    [anon_sym___alignof] = ACTIONS(3068),
    [anon_sym__alignof] = ACTIONS(3068),
    [anon_sym_alignof] = ACTIONS(3068),
    [anon_sym__Alignof] = ACTIONS(3068),
    [anon_sym_offsetof] = ACTIONS(3068),
    [anon_sym__Generic] = ACTIONS(3068),
    [anon_sym_asm] = ACTIONS(3068),
    [anon_sym___asm__] = ACTIONS(3068),
    [aux_sym_number_literal_token1] = ACTIONS(3070),
    [aux_sym_number_literal_token2] = ACTIONS(3068),
    [anon_sym_L_SQUOTE] = ACTIONS(3070),
    [anon_sym_u_SQUOTE] = ACTIONS(3070),
    [anon_sym_U_SQUOTE] = ACTIONS(3070),
    [anon_sym_u8_SQUOTE] = ACTIONS(3070),
    [anon_sym_SQUOTE] = ACTIONS(3070),
    [anon_sym_L_DQUOTE] = ACTIONS(3070),
    [anon_sym_u_DQUOTE] = ACTIONS(3070),
    [anon_sym_U_DQUOTE] = ACTIONS(3070),
    [anon_sym_u8_DQUOTE] = ACTIONS(3070),
    [anon_sym_DQUOTE] = ACTIONS(3070),
    [sym_true] = ACTIONS(3068),
    [sym_false] = ACTIONS(3068),
    [anon_sym_NULL] = ACTIONS(3068),
    [anon_sym_nullptr] = ACTIONS(3068),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3068),
    [anon_sym_decltype] = ACTIONS(3068),
    [anon_sym_virtual] = ACTIONS(3068),
    [anon_sym_alignas] = ACTIONS(3068),
    [anon_sym_explicit] = ACTIONS(3068),
    [anon_sym_typename] = ACTIONS(3068),
    [anon_sym_template] = ACTIONS(3068),
    [anon_sym_operator] = ACTIONS(3068),
    [anon_sym_try] = ACTIONS(3068),
    [anon_sym_delete] = ACTIONS(3068),
    [anon_sym_throw] = ACTIONS(3068),
    [anon_sym_namespace] = ACTIONS(3068),
    [anon_sym_using] = ACTIONS(3068),
    [anon_sym_static_assert] = ACTIONS(3068),
    [anon_sym_concept] = ACTIONS(3068),
    [anon_sym_co_return] = ACTIONS(3068),
    [anon_sym_co_yield] = ACTIONS(3068),
    [anon_sym_R_DQUOTE] = ACTIONS(3070),
    [anon_sym_LR_DQUOTE] = ACTIONS(3070),
    [anon_sym_uR_DQUOTE] = ACTIONS(3070),
    [anon_sym_UR_DQUOTE] = ACTIONS(3070),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3070),
    [anon_sym_co_await] = ACTIONS(3068),
    [anon_sym_new] = ACTIONS(3068),
    [anon_sym_requires] = ACTIONS(3068),
    [sym_this] = ACTIONS(3068),
  },
  [743] = {
    [sym_identifier] = ACTIONS(2901),
    [aux_sym_preproc_include_token1] = ACTIONS(2901),
    [aux_sym_preproc_def_token1] = ACTIONS(2901),
    [aux_sym_preproc_if_token1] = ACTIONS(2901),
    [aux_sym_preproc_if_token2] = ACTIONS(2901),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2901),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2901),
    [sym_preproc_directive] = ACTIONS(2901),
    [anon_sym_LPAREN2] = ACTIONS(2903),
    [anon_sym_BANG] = ACTIONS(2903),
    [anon_sym_TILDE] = ACTIONS(2903),
    [anon_sym_DASH] = ACTIONS(2901),
    [anon_sym_PLUS] = ACTIONS(2901),
    [anon_sym_STAR] = ACTIONS(2903),
    [anon_sym_AMP_AMP] = ACTIONS(2903),
    [anon_sym_AMP] = ACTIONS(2901),
    [anon_sym_SEMI] = ACTIONS(2903),
    [anon_sym___extension__] = ACTIONS(2901),
    [anon_sym_typedef] = ACTIONS(2901),
    [anon_sym_extern] = ACTIONS(2901),
    [anon_sym___attribute__] = ACTIONS(2901),
    [anon_sym_COLON_COLON] = ACTIONS(2903),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2903),
    [anon_sym___declspec] = ACTIONS(2901),
    [anon_sym___based] = ACTIONS(2901),
    [anon_sym___cdecl] = ACTIONS(2901),
    [anon_sym___clrcall] = ACTIONS(2901),
    [anon_sym___stdcall] = ACTIONS(2901),
    [anon_sym___fastcall] = ACTIONS(2901),
    [anon_sym___thiscall] = ACTIONS(2901),
    [anon_sym___vectorcall] = ACTIONS(2901),
    [anon_sym_LBRACE] = ACTIONS(2903),
    [anon_sym_signed] = ACTIONS(2901),
    [anon_sym_unsigned] = ACTIONS(2901),
    [anon_sym_long] = ACTIONS(2901),
    [anon_sym_short] = ACTIONS(2901),
    [anon_sym_LBRACK] = ACTIONS(2901),
    [anon_sym_static] = ACTIONS(2901),
    [anon_sym_register] = ACTIONS(2901),
    [anon_sym_inline] = ACTIONS(2901),
    [anon_sym___inline] = ACTIONS(2901),
    [anon_sym___inline__] = ACTIONS(2901),
    [anon_sym___forceinline] = ACTIONS(2901),
    [anon_sym_thread_local] = ACTIONS(2901),
    [anon_sym___thread] = ACTIONS(2901),
    [anon_sym_const] = ACTIONS(2901),
    [anon_sym_constexpr] = ACTIONS(2901),
    [anon_sym_volatile] = ACTIONS(2901),
    [anon_sym_restrict] = ACTIONS(2901),
    [anon_sym___restrict__] = ACTIONS(2901),
    [anon_sym__Atomic] = ACTIONS(2901),
    [anon_sym__Noreturn] = ACTIONS(2901),
    [anon_sym_noreturn] = ACTIONS(2901),
    [anon_sym_mutable] = ACTIONS(2901),
    [anon_sym_constinit] = ACTIONS(2901),
    [anon_sym_consteval] = ACTIONS(2901),
    [anon_sym_PROGMEM] = ACTIONS(2901),
    [aux_sym_primitive_type_token1] = ACTIONS(2901),
    [anon_sym_byte] = ACTIONS(2901),
    [anon_sym_word] = ACTIONS(2901),
    [anon_sym_enum] = ACTIONS(2901),
    [anon_sym_class] = ACTIONS(2901),
    [anon_sym_struct] = ACTIONS(2901),
    [anon_sym_union] = ACTIONS(2901),
    [anon_sym_if] = ACTIONS(2901),
    [anon_sym_switch] = ACTIONS(2901),
    [anon_sym_case] = ACTIONS(2901),
    [anon_sym_default] = ACTIONS(2901),
    [anon_sym_while] = ACTIONS(2901),
    [anon_sym_do] = ACTIONS(2901),
    [anon_sym_for] = ACTIONS(2901),
    [anon_sym_return] = ACTIONS(2901),
    [anon_sym_break] = ACTIONS(2901),
    [anon_sym_continue] = ACTIONS(2901),
    [anon_sym_goto] = ACTIONS(2901),
    [anon_sym___try] = ACTIONS(2901),
    [anon_sym___leave] = ACTIONS(2901),
    [anon_sym_not] = ACTIONS(2901),
    [anon_sym_compl] = ACTIONS(2901),
    [anon_sym_DASH_DASH] = ACTIONS(2903),
    [anon_sym_PLUS_PLUS] = ACTIONS(2903),
    [anon_sym_sizeof] = ACTIONS(2901),
    [anon_sym___alignof__] = ACTIONS(2901),
    [anon_sym___alignof] = ACTIONS(2901),
    [anon_sym__alignof] = ACTIONS(2901),
    [anon_sym_alignof] = ACTIONS(2901),
    [anon_sym__Alignof] = ACTIONS(2901),
    [anon_sym_offsetof] = ACTIONS(2901),
    [anon_sym__Generic] = ACTIONS(2901),
    [anon_sym_asm] = ACTIONS(2901),
    [anon_sym___asm__] = ACTIONS(2901),
    [aux_sym_number_literal_token1] = ACTIONS(2903),
    [aux_sym_number_literal_token2] = ACTIONS(2901),
    [anon_sym_L_SQUOTE] = ACTIONS(2903),
    [anon_sym_u_SQUOTE] = ACTIONS(2903),
    [anon_sym_U_SQUOTE] = ACTIONS(2903),
    [anon_sym_u8_SQUOTE] = ACTIONS(2903),
    [anon_sym_SQUOTE] = ACTIONS(2903),
    [anon_sym_L_DQUOTE] = ACTIONS(2903),
    [anon_sym_u_DQUOTE] = ACTIONS(2903),
    [anon_sym_U_DQUOTE] = ACTIONS(2903),
    [anon_sym_u8_DQUOTE] = ACTIONS(2903),
    [anon_sym_DQUOTE] = ACTIONS(2903),
    [sym_true] = ACTIONS(2901),
    [sym_false] = ACTIONS(2901),
    [anon_sym_NULL] = ACTIONS(2901),
    [anon_sym_nullptr] = ACTIONS(2901),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2901),
    [anon_sym_decltype] = ACTIONS(2901),
    [anon_sym_virtual] = ACTIONS(2901),
    [anon_sym_alignas] = ACTIONS(2901),
    [anon_sym_explicit] = ACTIONS(2901),
    [anon_sym_typename] = ACTIONS(2901),
    [anon_sym_template] = ACTIONS(2901),
    [anon_sym_operator] = ACTIONS(2901),
    [anon_sym_try] = ACTIONS(2901),
    [anon_sym_delete] = ACTIONS(2901),
    [anon_sym_throw] = ACTIONS(2901),
    [anon_sym_namespace] = ACTIONS(2901),
    [anon_sym_using] = ACTIONS(2901),
    [anon_sym_static_assert] = ACTIONS(2901),
    [anon_sym_concept] = ACTIONS(2901),
    [anon_sym_co_return] = ACTIONS(2901),
    [anon_sym_co_yield] = ACTIONS(2901),
    [anon_sym_R_DQUOTE] = ACTIONS(2903),
    [anon_sym_LR_DQUOTE] = ACTIONS(2903),
    [anon_sym_uR_DQUOTE] = ACTIONS(2903),
    [anon_sym_UR_DQUOTE] = ACTIONS(2903),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2903),
    [anon_sym_co_await] = ACTIONS(2901),
    [anon_sym_new] = ACTIONS(2901),
    [anon_sym_requires] = ACTIONS(2901),
    [sym_this] = ACTIONS(2901),
  },
  [744] = {
    [sym_identifier] = ACTIONS(2897),
    [aux_sym_preproc_include_token1] = ACTIONS(2897),
    [aux_sym_preproc_def_token1] = ACTIONS(2897),
    [aux_sym_preproc_if_token1] = ACTIONS(2897),
    [aux_sym_preproc_if_token2] = ACTIONS(2897),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2897),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2897),
    [sym_preproc_directive] = ACTIONS(2897),
    [anon_sym_LPAREN2] = ACTIONS(2899),
    [anon_sym_BANG] = ACTIONS(2899),
    [anon_sym_TILDE] = ACTIONS(2899),
    [anon_sym_DASH] = ACTIONS(2897),
    [anon_sym_PLUS] = ACTIONS(2897),
    [anon_sym_STAR] = ACTIONS(2899),
    [anon_sym_AMP_AMP] = ACTIONS(2899),
    [anon_sym_AMP] = ACTIONS(2897),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym___extension__] = ACTIONS(2897),
    [anon_sym_typedef] = ACTIONS(2897),
    [anon_sym_extern] = ACTIONS(2897),
    [anon_sym___attribute__] = ACTIONS(2897),
    [anon_sym_COLON_COLON] = ACTIONS(2899),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2899),
    [anon_sym___declspec] = ACTIONS(2897),
    [anon_sym___based] = ACTIONS(2897),
    [anon_sym___cdecl] = ACTIONS(2897),
    [anon_sym___clrcall] = ACTIONS(2897),
    [anon_sym___stdcall] = ACTIONS(2897),
    [anon_sym___fastcall] = ACTIONS(2897),
    [anon_sym___thiscall] = ACTIONS(2897),
    [anon_sym___vectorcall] = ACTIONS(2897),
    [anon_sym_LBRACE] = ACTIONS(2899),
    [anon_sym_signed] = ACTIONS(2897),
    [anon_sym_unsigned] = ACTIONS(2897),
    [anon_sym_long] = ACTIONS(2897),
    [anon_sym_short] = ACTIONS(2897),
    [anon_sym_LBRACK] = ACTIONS(2897),
    [anon_sym_static] = ACTIONS(2897),
    [anon_sym_register] = ACTIONS(2897),
    [anon_sym_inline] = ACTIONS(2897),
    [anon_sym___inline] = ACTIONS(2897),
    [anon_sym___inline__] = ACTIONS(2897),
    [anon_sym___forceinline] = ACTIONS(2897),
    [anon_sym_thread_local] = ACTIONS(2897),
    [anon_sym___thread] = ACTIONS(2897),
    [anon_sym_const] = ACTIONS(2897),
    [anon_sym_constexpr] = ACTIONS(2897),
    [anon_sym_volatile] = ACTIONS(2897),
    [anon_sym_restrict] = ACTIONS(2897),
    [anon_sym___restrict__] = ACTIONS(2897),
    [anon_sym__Atomic] = ACTIONS(2897),
    [anon_sym__Noreturn] = ACTIONS(2897),
    [anon_sym_noreturn] = ACTIONS(2897),
    [anon_sym_mutable] = ACTIONS(2897),
    [anon_sym_constinit] = ACTIONS(2897),
    [anon_sym_consteval] = ACTIONS(2897),
    [anon_sym_PROGMEM] = ACTIONS(2897),
    [aux_sym_primitive_type_token1] = ACTIONS(2897),
    [anon_sym_byte] = ACTIONS(2897),
    [anon_sym_word] = ACTIONS(2897),
    [anon_sym_enum] = ACTIONS(2897),
    [anon_sym_class] = ACTIONS(2897),
    [anon_sym_struct] = ACTIONS(2897),
    [anon_sym_union] = ACTIONS(2897),
    [anon_sym_if] = ACTIONS(2897),
    [anon_sym_switch] = ACTIONS(2897),
    [anon_sym_case] = ACTIONS(2897),
    [anon_sym_default] = ACTIONS(2897),
    [anon_sym_while] = ACTIONS(2897),
    [anon_sym_do] = ACTIONS(2897),
    [anon_sym_for] = ACTIONS(2897),
    [anon_sym_return] = ACTIONS(2897),
    [anon_sym_break] = ACTIONS(2897),
    [anon_sym_continue] = ACTIONS(2897),
    [anon_sym_goto] = ACTIONS(2897),
    [anon_sym___try] = ACTIONS(2897),
    [anon_sym___leave] = ACTIONS(2897),
    [anon_sym_not] = ACTIONS(2897),
    [anon_sym_compl] = ACTIONS(2897),
    [anon_sym_DASH_DASH] = ACTIONS(2899),
    [anon_sym_PLUS_PLUS] = ACTIONS(2899),
    [anon_sym_sizeof] = ACTIONS(2897),
    [anon_sym___alignof__] = ACTIONS(2897),
    [anon_sym___alignof] = ACTIONS(2897),
    [anon_sym__alignof] = ACTIONS(2897),
    [anon_sym_alignof] = ACTIONS(2897),
    [anon_sym__Alignof] = ACTIONS(2897),
    [anon_sym_offsetof] = ACTIONS(2897),
    [anon_sym__Generic] = ACTIONS(2897),
    [anon_sym_asm] = ACTIONS(2897),
    [anon_sym___asm__] = ACTIONS(2897),
    [aux_sym_number_literal_token1] = ACTIONS(2899),
    [aux_sym_number_literal_token2] = ACTIONS(2897),
    [anon_sym_L_SQUOTE] = ACTIONS(2899),
    [anon_sym_u_SQUOTE] = ACTIONS(2899),
    [anon_sym_U_SQUOTE] = ACTIONS(2899),
    [anon_sym_u8_SQUOTE] = ACTIONS(2899),
    [anon_sym_SQUOTE] = ACTIONS(2899),
    [anon_sym_L_DQUOTE] = ACTIONS(2899),
    [anon_sym_u_DQUOTE] = ACTIONS(2899),
    [anon_sym_U_DQUOTE] = ACTIONS(2899),
    [anon_sym_u8_DQUOTE] = ACTIONS(2899),
    [anon_sym_DQUOTE] = ACTIONS(2899),
    [sym_true] = ACTIONS(2897),
    [sym_false] = ACTIONS(2897),
    [anon_sym_NULL] = ACTIONS(2897),
    [anon_sym_nullptr] = ACTIONS(2897),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2897),
    [anon_sym_decltype] = ACTIONS(2897),
    [anon_sym_virtual] = ACTIONS(2897),
    [anon_sym_alignas] = ACTIONS(2897),
    [anon_sym_explicit] = ACTIONS(2897),
    [anon_sym_typename] = ACTIONS(2897),
    [anon_sym_template] = ACTIONS(2897),
    [anon_sym_operator] = ACTIONS(2897),
    [anon_sym_try] = ACTIONS(2897),
    [anon_sym_delete] = ACTIONS(2897),
    [anon_sym_throw] = ACTIONS(2897),
    [anon_sym_namespace] = ACTIONS(2897),
    [anon_sym_using] = ACTIONS(2897),
    [anon_sym_static_assert] = ACTIONS(2897),
    [anon_sym_concept] = ACTIONS(2897),
    [anon_sym_co_return] = ACTIONS(2897),
    [anon_sym_co_yield] = ACTIONS(2897),
    [anon_sym_R_DQUOTE] = ACTIONS(2899),
    [anon_sym_LR_DQUOTE] = ACTIONS(2899),
    [anon_sym_uR_DQUOTE] = ACTIONS(2899),
    [anon_sym_UR_DQUOTE] = ACTIONS(2899),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2899),
    [anon_sym_co_await] = ACTIONS(2897),
    [anon_sym_new] = ACTIONS(2897),
    [anon_sym_requires] = ACTIONS(2897),
    [sym_this] = ACTIONS(2897),
  },
  [745] = {
    [sym_identifier] = ACTIONS(2813),
    [aux_sym_preproc_include_token1] = ACTIONS(2813),
    [aux_sym_preproc_def_token1] = ACTIONS(2813),
    [aux_sym_preproc_if_token1] = ACTIONS(2813),
    [aux_sym_preproc_if_token2] = ACTIONS(2813),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2813),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2813),
    [sym_preproc_directive] = ACTIONS(2813),
    [anon_sym_LPAREN2] = ACTIONS(2815),
    [anon_sym_BANG] = ACTIONS(2815),
    [anon_sym_TILDE] = ACTIONS(2815),
    [anon_sym_DASH] = ACTIONS(2813),
    [anon_sym_PLUS] = ACTIONS(2813),
    [anon_sym_STAR] = ACTIONS(2815),
    [anon_sym_AMP_AMP] = ACTIONS(2815),
    [anon_sym_AMP] = ACTIONS(2813),
    [anon_sym_SEMI] = ACTIONS(2815),
    [anon_sym___extension__] = ACTIONS(2813),
    [anon_sym_typedef] = ACTIONS(2813),
    [anon_sym_extern] = ACTIONS(2813),
    [anon_sym___attribute__] = ACTIONS(2813),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2815),
    [anon_sym___declspec] = ACTIONS(2813),
    [anon_sym___based] = ACTIONS(2813),
    [anon_sym___cdecl] = ACTIONS(2813),
    [anon_sym___clrcall] = ACTIONS(2813),
    [anon_sym___stdcall] = ACTIONS(2813),
    [anon_sym___fastcall] = ACTIONS(2813),
    [anon_sym___thiscall] = ACTIONS(2813),
    [anon_sym___vectorcall] = ACTIONS(2813),
    [anon_sym_LBRACE] = ACTIONS(2815),
    [anon_sym_signed] = ACTIONS(2813),
    [anon_sym_unsigned] = ACTIONS(2813),
    [anon_sym_long] = ACTIONS(2813),
    [anon_sym_short] = ACTIONS(2813),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_static] = ACTIONS(2813),
    [anon_sym_register] = ACTIONS(2813),
    [anon_sym_inline] = ACTIONS(2813),
    [anon_sym___inline] = ACTIONS(2813),
    [anon_sym___inline__] = ACTIONS(2813),
    [anon_sym___forceinline] = ACTIONS(2813),
    [anon_sym_thread_local] = ACTIONS(2813),
    [anon_sym___thread] = ACTIONS(2813),
    [anon_sym_const] = ACTIONS(2813),
    [anon_sym_constexpr] = ACTIONS(2813),
    [anon_sym_volatile] = ACTIONS(2813),
    [anon_sym_restrict] = ACTIONS(2813),
    [anon_sym___restrict__] = ACTIONS(2813),
    [anon_sym__Atomic] = ACTIONS(2813),
    [anon_sym__Noreturn] = ACTIONS(2813),
    [anon_sym_noreturn] = ACTIONS(2813),
    [anon_sym_mutable] = ACTIONS(2813),
    [anon_sym_constinit] = ACTIONS(2813),
    [anon_sym_consteval] = ACTIONS(2813),
    [anon_sym_PROGMEM] = ACTIONS(2813),
    [aux_sym_primitive_type_token1] = ACTIONS(2813),
    [anon_sym_byte] = ACTIONS(2813),
    [anon_sym_word] = ACTIONS(2813),
    [anon_sym_enum] = ACTIONS(2813),
    [anon_sym_class] = ACTIONS(2813),
    [anon_sym_struct] = ACTIONS(2813),
    [anon_sym_union] = ACTIONS(2813),
    [anon_sym_if] = ACTIONS(2813),
    [anon_sym_switch] = ACTIONS(2813),
    [anon_sym_case] = ACTIONS(2813),
    [anon_sym_default] = ACTIONS(2813),
    [anon_sym_while] = ACTIONS(2813),
    [anon_sym_do] = ACTIONS(2813),
    [anon_sym_for] = ACTIONS(2813),
    [anon_sym_return] = ACTIONS(2813),
    [anon_sym_break] = ACTIONS(2813),
    [anon_sym_continue] = ACTIONS(2813),
    [anon_sym_goto] = ACTIONS(2813),
    [anon_sym___try] = ACTIONS(2813),
    [anon_sym___leave] = ACTIONS(2813),
    [anon_sym_not] = ACTIONS(2813),
    [anon_sym_compl] = ACTIONS(2813),
    [anon_sym_DASH_DASH] = ACTIONS(2815),
    [anon_sym_PLUS_PLUS] = ACTIONS(2815),
    [anon_sym_sizeof] = ACTIONS(2813),
    [anon_sym___alignof__] = ACTIONS(2813),
    [anon_sym___alignof] = ACTIONS(2813),
    [anon_sym__alignof] = ACTIONS(2813),
    [anon_sym_alignof] = ACTIONS(2813),
    [anon_sym__Alignof] = ACTIONS(2813),
    [anon_sym_offsetof] = ACTIONS(2813),
    [anon_sym__Generic] = ACTIONS(2813),
    [anon_sym_asm] = ACTIONS(2813),
    [anon_sym___asm__] = ACTIONS(2813),
    [aux_sym_number_literal_token1] = ACTIONS(2815),
    [aux_sym_number_literal_token2] = ACTIONS(2813),
    [anon_sym_L_SQUOTE] = ACTIONS(2815),
    [anon_sym_u_SQUOTE] = ACTIONS(2815),
    [anon_sym_U_SQUOTE] = ACTIONS(2815),
    [anon_sym_u8_SQUOTE] = ACTIONS(2815),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_L_DQUOTE] = ACTIONS(2815),
    [anon_sym_u_DQUOTE] = ACTIONS(2815),
    [anon_sym_U_DQUOTE] = ACTIONS(2815),
    [anon_sym_u8_DQUOTE] = ACTIONS(2815),
    [anon_sym_DQUOTE] = ACTIONS(2815),
    [sym_true] = ACTIONS(2813),
    [sym_false] = ACTIONS(2813),
    [anon_sym_NULL] = ACTIONS(2813),
    [anon_sym_nullptr] = ACTIONS(2813),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2813),
    [anon_sym_decltype] = ACTIONS(2813),
    [anon_sym_virtual] = ACTIONS(2813),
    [anon_sym_alignas] = ACTIONS(2813),
    [anon_sym_explicit] = ACTIONS(2813),
    [anon_sym_typename] = ACTIONS(2813),
    [anon_sym_template] = ACTIONS(2813),
    [anon_sym_operator] = ACTIONS(2813),
    [anon_sym_try] = ACTIONS(2813),
    [anon_sym_delete] = ACTIONS(2813),
    [anon_sym_throw] = ACTIONS(2813),
    [anon_sym_namespace] = ACTIONS(2813),
    [anon_sym_using] = ACTIONS(2813),
    [anon_sym_static_assert] = ACTIONS(2813),
    [anon_sym_concept] = ACTIONS(2813),
    [anon_sym_co_return] = ACTIONS(2813),
    [anon_sym_co_yield] = ACTIONS(2813),
    [anon_sym_R_DQUOTE] = ACTIONS(2815),
    [anon_sym_LR_DQUOTE] = ACTIONS(2815),
    [anon_sym_uR_DQUOTE] = ACTIONS(2815),
    [anon_sym_UR_DQUOTE] = ACTIONS(2815),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2815),
    [anon_sym_co_await] = ACTIONS(2813),
    [anon_sym_new] = ACTIONS(2813),
    [anon_sym_requires] = ACTIONS(2813),
    [sym_this] = ACTIONS(2813),
  },
  [746] = {
    [sym_identifier] = ACTIONS(2893),
    [aux_sym_preproc_include_token1] = ACTIONS(2893),
    [aux_sym_preproc_def_token1] = ACTIONS(2893),
    [aux_sym_preproc_if_token1] = ACTIONS(2893),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2893),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2893),
    [sym_preproc_directive] = ACTIONS(2893),
    [anon_sym_LPAREN2] = ACTIONS(2895),
    [anon_sym_BANG] = ACTIONS(2895),
    [anon_sym_TILDE] = ACTIONS(2895),
    [anon_sym_DASH] = ACTIONS(2893),
    [anon_sym_PLUS] = ACTIONS(2893),
    [anon_sym_STAR] = ACTIONS(2895),
    [anon_sym_AMP_AMP] = ACTIONS(2895),
    [anon_sym_AMP] = ACTIONS(2893),
    [anon_sym_SEMI] = ACTIONS(2895),
    [anon_sym___extension__] = ACTIONS(2893),
    [anon_sym_typedef] = ACTIONS(2893),
    [anon_sym_extern] = ACTIONS(2893),
    [anon_sym___attribute__] = ACTIONS(2893),
    [anon_sym_COLON_COLON] = ACTIONS(2895),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2895),
    [anon_sym___declspec] = ACTIONS(2893),
    [anon_sym___based] = ACTIONS(2893),
    [anon_sym___cdecl] = ACTIONS(2893),
    [anon_sym___clrcall] = ACTIONS(2893),
    [anon_sym___stdcall] = ACTIONS(2893),
    [anon_sym___fastcall] = ACTIONS(2893),
    [anon_sym___thiscall] = ACTIONS(2893),
    [anon_sym___vectorcall] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(2895),
    [anon_sym_RBRACE] = ACTIONS(2895),
    [anon_sym_signed] = ACTIONS(2893),
    [anon_sym_unsigned] = ACTIONS(2893),
    [anon_sym_long] = ACTIONS(2893),
    [anon_sym_short] = ACTIONS(2893),
    [anon_sym_LBRACK] = ACTIONS(2893),
    [anon_sym_static] = ACTIONS(2893),
    [anon_sym_register] = ACTIONS(2893),
    [anon_sym_inline] = ACTIONS(2893),
    [anon_sym___inline] = ACTIONS(2893),
    [anon_sym___inline__] = ACTIONS(2893),
    [anon_sym___forceinline] = ACTIONS(2893),
    [anon_sym_thread_local] = ACTIONS(2893),
    [anon_sym___thread] = ACTIONS(2893),
    [anon_sym_const] = ACTIONS(2893),
    [anon_sym_constexpr] = ACTIONS(2893),
    [anon_sym_volatile] = ACTIONS(2893),
    [anon_sym_restrict] = ACTIONS(2893),
    [anon_sym___restrict__] = ACTIONS(2893),
    [anon_sym__Atomic] = ACTIONS(2893),
    [anon_sym__Noreturn] = ACTIONS(2893),
    [anon_sym_noreturn] = ACTIONS(2893),
    [anon_sym_mutable] = ACTIONS(2893),
    [anon_sym_constinit] = ACTIONS(2893),
    [anon_sym_consteval] = ACTIONS(2893),
    [anon_sym_PROGMEM] = ACTIONS(2893),
    [aux_sym_primitive_type_token1] = ACTIONS(2893),
    [anon_sym_byte] = ACTIONS(2893),
    [anon_sym_word] = ACTIONS(2893),
    [anon_sym_enum] = ACTIONS(2893),
    [anon_sym_class] = ACTIONS(2893),
    [anon_sym_struct] = ACTIONS(2893),
    [anon_sym_union] = ACTIONS(2893),
    [anon_sym_if] = ACTIONS(2893),
    [anon_sym_switch] = ACTIONS(2893),
    [anon_sym_case] = ACTIONS(2893),
    [anon_sym_default] = ACTIONS(2893),
    [anon_sym_while] = ACTIONS(2893),
    [anon_sym_do] = ACTIONS(2893),
    [anon_sym_for] = ACTIONS(2893),
    [anon_sym_return] = ACTIONS(2893),
    [anon_sym_break] = ACTIONS(2893),
    [anon_sym_continue] = ACTIONS(2893),
    [anon_sym_goto] = ACTIONS(2893),
    [anon_sym___try] = ACTIONS(2893),
    [anon_sym___leave] = ACTIONS(2893),
    [anon_sym_not] = ACTIONS(2893),
    [anon_sym_compl] = ACTIONS(2893),
    [anon_sym_DASH_DASH] = ACTIONS(2895),
    [anon_sym_PLUS_PLUS] = ACTIONS(2895),
    [anon_sym_sizeof] = ACTIONS(2893),
    [anon_sym___alignof__] = ACTIONS(2893),
    [anon_sym___alignof] = ACTIONS(2893),
    [anon_sym__alignof] = ACTIONS(2893),
    [anon_sym_alignof] = ACTIONS(2893),
    [anon_sym__Alignof] = ACTIONS(2893),
    [anon_sym_offsetof] = ACTIONS(2893),
    [anon_sym__Generic] = ACTIONS(2893),
    [anon_sym_asm] = ACTIONS(2893),
    [anon_sym___asm__] = ACTIONS(2893),
    [aux_sym_number_literal_token1] = ACTIONS(2895),
    [aux_sym_number_literal_token2] = ACTIONS(2893),
    [anon_sym_L_SQUOTE] = ACTIONS(2895),
    [anon_sym_u_SQUOTE] = ACTIONS(2895),
    [anon_sym_U_SQUOTE] = ACTIONS(2895),
    [anon_sym_u8_SQUOTE] = ACTIONS(2895),
    [anon_sym_SQUOTE] = ACTIONS(2895),
    [anon_sym_L_DQUOTE] = ACTIONS(2895),
    [anon_sym_u_DQUOTE] = ACTIONS(2895),
    [anon_sym_U_DQUOTE] = ACTIONS(2895),
    [anon_sym_u8_DQUOTE] = ACTIONS(2895),
    [anon_sym_DQUOTE] = ACTIONS(2895),
    [sym_true] = ACTIONS(2893),
    [sym_false] = ACTIONS(2893),
    [anon_sym_NULL] = ACTIONS(2893),
    [anon_sym_nullptr] = ACTIONS(2893),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2893),
    [anon_sym_decltype] = ACTIONS(2893),
    [anon_sym_virtual] = ACTIONS(2893),
    [anon_sym_alignas] = ACTIONS(2893),
    [anon_sym_explicit] = ACTIONS(2893),
    [anon_sym_typename] = ACTIONS(2893),
    [anon_sym_template] = ACTIONS(2893),
    [anon_sym_operator] = ACTIONS(2893),
    [anon_sym_try] = ACTIONS(2893),
    [anon_sym_delete] = ACTIONS(2893),
    [anon_sym_throw] = ACTIONS(2893),
    [anon_sym_namespace] = ACTIONS(2893),
    [anon_sym_using] = ACTIONS(2893),
    [anon_sym_static_assert] = ACTIONS(2893),
    [anon_sym_concept] = ACTIONS(2893),
    [anon_sym_co_return] = ACTIONS(2893),
    [anon_sym_co_yield] = ACTIONS(2893),
    [anon_sym_R_DQUOTE] = ACTIONS(2895),
    [anon_sym_LR_DQUOTE] = ACTIONS(2895),
    [anon_sym_uR_DQUOTE] = ACTIONS(2895),
    [anon_sym_UR_DQUOTE] = ACTIONS(2895),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2895),
    [anon_sym_co_await] = ACTIONS(2893),
    [anon_sym_new] = ACTIONS(2893),
    [anon_sym_requires] = ACTIONS(2893),
    [sym_this] = ACTIONS(2893),
  },
  [747] = {
    [sym_identifier] = ACTIONS(2893),
    [aux_sym_preproc_include_token1] = ACTIONS(2893),
    [aux_sym_preproc_def_token1] = ACTIONS(2893),
    [aux_sym_preproc_if_token1] = ACTIONS(2893),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2893),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2893),
    [sym_preproc_directive] = ACTIONS(2893),
    [anon_sym_LPAREN2] = ACTIONS(2895),
    [anon_sym_BANG] = ACTIONS(2895),
    [anon_sym_TILDE] = ACTIONS(2895),
    [anon_sym_DASH] = ACTIONS(2893),
    [anon_sym_PLUS] = ACTIONS(2893),
    [anon_sym_STAR] = ACTIONS(2895),
    [anon_sym_AMP_AMP] = ACTIONS(2895),
    [anon_sym_AMP] = ACTIONS(2893),
    [anon_sym_SEMI] = ACTIONS(2895),
    [anon_sym___extension__] = ACTIONS(2893),
    [anon_sym_typedef] = ACTIONS(2893),
    [anon_sym_extern] = ACTIONS(2893),
    [anon_sym___attribute__] = ACTIONS(2893),
    [anon_sym_COLON_COLON] = ACTIONS(2895),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2895),
    [anon_sym___declspec] = ACTIONS(2893),
    [anon_sym___based] = ACTIONS(2893),
    [anon_sym___cdecl] = ACTIONS(2893),
    [anon_sym___clrcall] = ACTIONS(2893),
    [anon_sym___stdcall] = ACTIONS(2893),
    [anon_sym___fastcall] = ACTIONS(2893),
    [anon_sym___thiscall] = ACTIONS(2893),
    [anon_sym___vectorcall] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(2895),
    [anon_sym_RBRACE] = ACTIONS(2895),
    [anon_sym_signed] = ACTIONS(2893),
    [anon_sym_unsigned] = ACTIONS(2893),
    [anon_sym_long] = ACTIONS(2893),
    [anon_sym_short] = ACTIONS(2893),
    [anon_sym_LBRACK] = ACTIONS(2893),
    [anon_sym_static] = ACTIONS(2893),
    [anon_sym_register] = ACTIONS(2893),
    [anon_sym_inline] = ACTIONS(2893),
    [anon_sym___inline] = ACTIONS(2893),
    [anon_sym___inline__] = ACTIONS(2893),
    [anon_sym___forceinline] = ACTIONS(2893),
    [anon_sym_thread_local] = ACTIONS(2893),
    [anon_sym___thread] = ACTIONS(2893),
    [anon_sym_const] = ACTIONS(2893),
    [anon_sym_constexpr] = ACTIONS(2893),
    [anon_sym_volatile] = ACTIONS(2893),
    [anon_sym_restrict] = ACTIONS(2893),
    [anon_sym___restrict__] = ACTIONS(2893),
    [anon_sym__Atomic] = ACTIONS(2893),
    [anon_sym__Noreturn] = ACTIONS(2893),
    [anon_sym_noreturn] = ACTIONS(2893),
    [anon_sym_mutable] = ACTIONS(2893),
    [anon_sym_constinit] = ACTIONS(2893),
    [anon_sym_consteval] = ACTIONS(2893),
    [anon_sym_PROGMEM] = ACTIONS(2893),
    [aux_sym_primitive_type_token1] = ACTIONS(2893),
    [anon_sym_byte] = ACTIONS(2893),
    [anon_sym_word] = ACTIONS(2893),
    [anon_sym_enum] = ACTIONS(2893),
    [anon_sym_class] = ACTIONS(2893),
    [anon_sym_struct] = ACTIONS(2893),
    [anon_sym_union] = ACTIONS(2893),
    [anon_sym_if] = ACTIONS(2893),
    [anon_sym_switch] = ACTIONS(2893),
    [anon_sym_case] = ACTIONS(2893),
    [anon_sym_default] = ACTIONS(2893),
    [anon_sym_while] = ACTIONS(2893),
    [anon_sym_do] = ACTIONS(2893),
    [anon_sym_for] = ACTIONS(2893),
    [anon_sym_return] = ACTIONS(2893),
    [anon_sym_break] = ACTIONS(2893),
    [anon_sym_continue] = ACTIONS(2893),
    [anon_sym_goto] = ACTIONS(2893),
    [anon_sym___try] = ACTIONS(2893),
    [anon_sym___leave] = ACTIONS(2893),
    [anon_sym_not] = ACTIONS(2893),
    [anon_sym_compl] = ACTIONS(2893),
    [anon_sym_DASH_DASH] = ACTIONS(2895),
    [anon_sym_PLUS_PLUS] = ACTIONS(2895),
    [anon_sym_sizeof] = ACTIONS(2893),
    [anon_sym___alignof__] = ACTIONS(2893),
    [anon_sym___alignof] = ACTIONS(2893),
    [anon_sym__alignof] = ACTIONS(2893),
    [anon_sym_alignof] = ACTIONS(2893),
    [anon_sym__Alignof] = ACTIONS(2893),
    [anon_sym_offsetof] = ACTIONS(2893),
    [anon_sym__Generic] = ACTIONS(2893),
    [anon_sym_asm] = ACTIONS(2893),
    [anon_sym___asm__] = ACTIONS(2893),
    [aux_sym_number_literal_token1] = ACTIONS(2895),
    [aux_sym_number_literal_token2] = ACTIONS(2893),
    [anon_sym_L_SQUOTE] = ACTIONS(2895),
    [anon_sym_u_SQUOTE] = ACTIONS(2895),
    [anon_sym_U_SQUOTE] = ACTIONS(2895),
    [anon_sym_u8_SQUOTE] = ACTIONS(2895),
    [anon_sym_SQUOTE] = ACTIONS(2895),
    [anon_sym_L_DQUOTE] = ACTIONS(2895),
    [anon_sym_u_DQUOTE] = ACTIONS(2895),
    [anon_sym_U_DQUOTE] = ACTIONS(2895),
    [anon_sym_u8_DQUOTE] = ACTIONS(2895),
    [anon_sym_DQUOTE] = ACTIONS(2895),
    [sym_true] = ACTIONS(2893),
    [sym_false] = ACTIONS(2893),
    [anon_sym_NULL] = ACTIONS(2893),
    [anon_sym_nullptr] = ACTIONS(2893),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2893),
    [anon_sym_decltype] = ACTIONS(2893),
    [anon_sym_virtual] = ACTIONS(2893),
    [anon_sym_alignas] = ACTIONS(2893),
    [anon_sym_explicit] = ACTIONS(2893),
    [anon_sym_typename] = ACTIONS(2893),
    [anon_sym_template] = ACTIONS(2893),
    [anon_sym_operator] = ACTIONS(2893),
    [anon_sym_try] = ACTIONS(2893),
    [anon_sym_delete] = ACTIONS(2893),
    [anon_sym_throw] = ACTIONS(2893),
    [anon_sym_namespace] = ACTIONS(2893),
    [anon_sym_using] = ACTIONS(2893),
    [anon_sym_static_assert] = ACTIONS(2893),
    [anon_sym_concept] = ACTIONS(2893),
    [anon_sym_co_return] = ACTIONS(2893),
    [anon_sym_co_yield] = ACTIONS(2893),
    [anon_sym_R_DQUOTE] = ACTIONS(2895),
    [anon_sym_LR_DQUOTE] = ACTIONS(2895),
    [anon_sym_uR_DQUOTE] = ACTIONS(2895),
    [anon_sym_UR_DQUOTE] = ACTIONS(2895),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2895),
    [anon_sym_co_await] = ACTIONS(2893),
    [anon_sym_new] = ACTIONS(2893),
    [anon_sym_requires] = ACTIONS(2893),
    [sym_this] = ACTIONS(2893),
  },
  [748] = {
    [sym_identifier] = ACTIONS(2813),
    [aux_sym_preproc_include_token1] = ACTIONS(2813),
    [aux_sym_preproc_def_token1] = ACTIONS(2813),
    [aux_sym_preproc_if_token1] = ACTIONS(2813),
    [aux_sym_preproc_if_token2] = ACTIONS(2813),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2813),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2813),
    [sym_preproc_directive] = ACTIONS(2813),
    [anon_sym_LPAREN2] = ACTIONS(2815),
    [anon_sym_BANG] = ACTIONS(2815),
    [anon_sym_TILDE] = ACTIONS(2815),
    [anon_sym_DASH] = ACTIONS(2813),
    [anon_sym_PLUS] = ACTIONS(2813),
    [anon_sym_STAR] = ACTIONS(2815),
    [anon_sym_AMP_AMP] = ACTIONS(2815),
    [anon_sym_AMP] = ACTIONS(2813),
    [anon_sym_SEMI] = ACTIONS(2815),
    [anon_sym___extension__] = ACTIONS(2813),
    [anon_sym_typedef] = ACTIONS(2813),
    [anon_sym_extern] = ACTIONS(2813),
    [anon_sym___attribute__] = ACTIONS(2813),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2815),
    [anon_sym___declspec] = ACTIONS(2813),
    [anon_sym___based] = ACTIONS(2813),
    [anon_sym___cdecl] = ACTIONS(2813),
    [anon_sym___clrcall] = ACTIONS(2813),
    [anon_sym___stdcall] = ACTIONS(2813),
    [anon_sym___fastcall] = ACTIONS(2813),
    [anon_sym___thiscall] = ACTIONS(2813),
    [anon_sym___vectorcall] = ACTIONS(2813),
    [anon_sym_LBRACE] = ACTIONS(2815),
    [anon_sym_signed] = ACTIONS(2813),
    [anon_sym_unsigned] = ACTIONS(2813),
    [anon_sym_long] = ACTIONS(2813),
    [anon_sym_short] = ACTIONS(2813),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_static] = ACTIONS(2813),
    [anon_sym_register] = ACTIONS(2813),
    [anon_sym_inline] = ACTIONS(2813),
    [anon_sym___inline] = ACTIONS(2813),
    [anon_sym___inline__] = ACTIONS(2813),
    [anon_sym___forceinline] = ACTIONS(2813),
    [anon_sym_thread_local] = ACTIONS(2813),
    [anon_sym___thread] = ACTIONS(2813),
    [anon_sym_const] = ACTIONS(2813),
    [anon_sym_constexpr] = ACTIONS(2813),
    [anon_sym_volatile] = ACTIONS(2813),
    [anon_sym_restrict] = ACTIONS(2813),
    [anon_sym___restrict__] = ACTIONS(2813),
    [anon_sym__Atomic] = ACTIONS(2813),
    [anon_sym__Noreturn] = ACTIONS(2813),
    [anon_sym_noreturn] = ACTIONS(2813),
    [anon_sym_mutable] = ACTIONS(2813),
    [anon_sym_constinit] = ACTIONS(2813),
    [anon_sym_consteval] = ACTIONS(2813),
    [anon_sym_PROGMEM] = ACTIONS(2813),
    [aux_sym_primitive_type_token1] = ACTIONS(2813),
    [anon_sym_byte] = ACTIONS(2813),
    [anon_sym_word] = ACTIONS(2813),
    [anon_sym_enum] = ACTIONS(2813),
    [anon_sym_class] = ACTIONS(2813),
    [anon_sym_struct] = ACTIONS(2813),
    [anon_sym_union] = ACTIONS(2813),
    [anon_sym_if] = ACTIONS(2813),
    [anon_sym_switch] = ACTIONS(2813),
    [anon_sym_case] = ACTIONS(2813),
    [anon_sym_default] = ACTIONS(2813),
    [anon_sym_while] = ACTIONS(2813),
    [anon_sym_do] = ACTIONS(2813),
    [anon_sym_for] = ACTIONS(2813),
    [anon_sym_return] = ACTIONS(2813),
    [anon_sym_break] = ACTIONS(2813),
    [anon_sym_continue] = ACTIONS(2813),
    [anon_sym_goto] = ACTIONS(2813),
    [anon_sym___try] = ACTIONS(2813),
    [anon_sym___leave] = ACTIONS(2813),
    [anon_sym_not] = ACTIONS(2813),
    [anon_sym_compl] = ACTIONS(2813),
    [anon_sym_DASH_DASH] = ACTIONS(2815),
    [anon_sym_PLUS_PLUS] = ACTIONS(2815),
    [anon_sym_sizeof] = ACTIONS(2813),
    [anon_sym___alignof__] = ACTIONS(2813),
    [anon_sym___alignof] = ACTIONS(2813),
    [anon_sym__alignof] = ACTIONS(2813),
    [anon_sym_alignof] = ACTIONS(2813),
    [anon_sym__Alignof] = ACTIONS(2813),
    [anon_sym_offsetof] = ACTIONS(2813),
    [anon_sym__Generic] = ACTIONS(2813),
    [anon_sym_asm] = ACTIONS(2813),
    [anon_sym___asm__] = ACTIONS(2813),
    [aux_sym_number_literal_token1] = ACTIONS(2815),
    [aux_sym_number_literal_token2] = ACTIONS(2813),
    [anon_sym_L_SQUOTE] = ACTIONS(2815),
    [anon_sym_u_SQUOTE] = ACTIONS(2815),
    [anon_sym_U_SQUOTE] = ACTIONS(2815),
    [anon_sym_u8_SQUOTE] = ACTIONS(2815),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_L_DQUOTE] = ACTIONS(2815),
    [anon_sym_u_DQUOTE] = ACTIONS(2815),
    [anon_sym_U_DQUOTE] = ACTIONS(2815),
    [anon_sym_u8_DQUOTE] = ACTIONS(2815),
    [anon_sym_DQUOTE] = ACTIONS(2815),
    [sym_true] = ACTIONS(2813),
    [sym_false] = ACTIONS(2813),
    [anon_sym_NULL] = ACTIONS(2813),
    [anon_sym_nullptr] = ACTIONS(2813),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2813),
    [anon_sym_decltype] = ACTIONS(2813),
    [anon_sym_virtual] = ACTIONS(2813),
    [anon_sym_alignas] = ACTIONS(2813),
    [anon_sym_explicit] = ACTIONS(2813),
    [anon_sym_typename] = ACTIONS(2813),
    [anon_sym_template] = ACTIONS(2813),
    [anon_sym_operator] = ACTIONS(2813),
    [anon_sym_try] = ACTIONS(2813),
    [anon_sym_delete] = ACTIONS(2813),
    [anon_sym_throw] = ACTIONS(2813),
    [anon_sym_namespace] = ACTIONS(2813),
    [anon_sym_using] = ACTIONS(2813),
    [anon_sym_static_assert] = ACTIONS(2813),
    [anon_sym_concept] = ACTIONS(2813),
    [anon_sym_co_return] = ACTIONS(2813),
    [anon_sym_co_yield] = ACTIONS(2813),
    [anon_sym_R_DQUOTE] = ACTIONS(2815),
    [anon_sym_LR_DQUOTE] = ACTIONS(2815),
    [anon_sym_uR_DQUOTE] = ACTIONS(2815),
    [anon_sym_UR_DQUOTE] = ACTIONS(2815),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2815),
    [anon_sym_co_await] = ACTIONS(2813),
    [anon_sym_new] = ACTIONS(2813),
    [anon_sym_requires] = ACTIONS(2813),
    [sym_this] = ACTIONS(2813),
  },
  [749] = {
    [sym_identifier] = ACTIONS(3136),
    [aux_sym_preproc_include_token1] = ACTIONS(3136),
    [aux_sym_preproc_def_token1] = ACTIONS(3136),
    [aux_sym_preproc_if_token1] = ACTIONS(3136),
    [aux_sym_preproc_if_token2] = ACTIONS(3136),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3136),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3136),
    [sym_preproc_directive] = ACTIONS(3136),
    [anon_sym_LPAREN2] = ACTIONS(3138),
    [anon_sym_BANG] = ACTIONS(3138),
    [anon_sym_TILDE] = ACTIONS(3138),
    [anon_sym_DASH] = ACTIONS(3136),
    [anon_sym_PLUS] = ACTIONS(3136),
    [anon_sym_STAR] = ACTIONS(3138),
    [anon_sym_AMP_AMP] = ACTIONS(3138),
    [anon_sym_AMP] = ACTIONS(3136),
    [anon_sym_SEMI] = ACTIONS(3138),
    [anon_sym___extension__] = ACTIONS(3136),
    [anon_sym_typedef] = ACTIONS(3136),
    [anon_sym_extern] = ACTIONS(3136),
    [anon_sym___attribute__] = ACTIONS(3136),
    [anon_sym_COLON_COLON] = ACTIONS(3138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3138),
    [anon_sym___declspec] = ACTIONS(3136),
    [anon_sym___based] = ACTIONS(3136),
    [anon_sym___cdecl] = ACTIONS(3136),
    [anon_sym___clrcall] = ACTIONS(3136),
    [anon_sym___stdcall] = ACTIONS(3136),
    [anon_sym___fastcall] = ACTIONS(3136),
    [anon_sym___thiscall] = ACTIONS(3136),
    [anon_sym___vectorcall] = ACTIONS(3136),
    [anon_sym_LBRACE] = ACTIONS(3138),
    [anon_sym_signed] = ACTIONS(3136),
    [anon_sym_unsigned] = ACTIONS(3136),
    [anon_sym_long] = ACTIONS(3136),
    [anon_sym_short] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3136),
    [anon_sym_static] = ACTIONS(3136),
    [anon_sym_register] = ACTIONS(3136),
    [anon_sym_inline] = ACTIONS(3136),
    [anon_sym___inline] = ACTIONS(3136),
    [anon_sym___inline__] = ACTIONS(3136),
    [anon_sym___forceinline] = ACTIONS(3136),
    [anon_sym_thread_local] = ACTIONS(3136),
    [anon_sym___thread] = ACTIONS(3136),
    [anon_sym_const] = ACTIONS(3136),
    [anon_sym_constexpr] = ACTIONS(3136),
    [anon_sym_volatile] = ACTIONS(3136),
    [anon_sym_restrict] = ACTIONS(3136),
    [anon_sym___restrict__] = ACTIONS(3136),
    [anon_sym__Atomic] = ACTIONS(3136),
    [anon_sym__Noreturn] = ACTIONS(3136),
    [anon_sym_noreturn] = ACTIONS(3136),
    [anon_sym_mutable] = ACTIONS(3136),
    [anon_sym_constinit] = ACTIONS(3136),
    [anon_sym_consteval] = ACTIONS(3136),
    [anon_sym_PROGMEM] = ACTIONS(3136),
    [aux_sym_primitive_type_token1] = ACTIONS(3136),
    [anon_sym_byte] = ACTIONS(3136),
    [anon_sym_word] = ACTIONS(3136),
    [anon_sym_enum] = ACTIONS(3136),
    [anon_sym_class] = ACTIONS(3136),
    [anon_sym_struct] = ACTIONS(3136),
    [anon_sym_union] = ACTIONS(3136),
    [anon_sym_if] = ACTIONS(3136),
    [anon_sym_switch] = ACTIONS(3136),
    [anon_sym_case] = ACTIONS(3136),
    [anon_sym_default] = ACTIONS(3136),
    [anon_sym_while] = ACTIONS(3136),
    [anon_sym_do] = ACTIONS(3136),
    [anon_sym_for] = ACTIONS(3136),
    [anon_sym_return] = ACTIONS(3136),
    [anon_sym_break] = ACTIONS(3136),
    [anon_sym_continue] = ACTIONS(3136),
    [anon_sym_goto] = ACTIONS(3136),
    [anon_sym___try] = ACTIONS(3136),
    [anon_sym___leave] = ACTIONS(3136),
    [anon_sym_not] = ACTIONS(3136),
    [anon_sym_compl] = ACTIONS(3136),
    [anon_sym_DASH_DASH] = ACTIONS(3138),
    [anon_sym_PLUS_PLUS] = ACTIONS(3138),
    [anon_sym_sizeof] = ACTIONS(3136),
    [anon_sym___alignof__] = ACTIONS(3136),
    [anon_sym___alignof] = ACTIONS(3136),
    [anon_sym__alignof] = ACTIONS(3136),
    [anon_sym_alignof] = ACTIONS(3136),
    [anon_sym__Alignof] = ACTIONS(3136),
    [anon_sym_offsetof] = ACTIONS(3136),
    [anon_sym__Generic] = ACTIONS(3136),
    [anon_sym_asm] = ACTIONS(3136),
    [anon_sym___asm__] = ACTIONS(3136),
    [aux_sym_number_literal_token1] = ACTIONS(3138),
    [aux_sym_number_literal_token2] = ACTIONS(3136),
    [anon_sym_L_SQUOTE] = ACTIONS(3138),
    [anon_sym_u_SQUOTE] = ACTIONS(3138),
    [anon_sym_U_SQUOTE] = ACTIONS(3138),
    [anon_sym_u8_SQUOTE] = ACTIONS(3138),
    [anon_sym_SQUOTE] = ACTIONS(3138),
    [anon_sym_L_DQUOTE] = ACTIONS(3138),
    [anon_sym_u_DQUOTE] = ACTIONS(3138),
    [anon_sym_U_DQUOTE] = ACTIONS(3138),
    [anon_sym_u8_DQUOTE] = ACTIONS(3138),
    [anon_sym_DQUOTE] = ACTIONS(3138),
    [sym_true] = ACTIONS(3136),
    [sym_false] = ACTIONS(3136),
    [anon_sym_NULL] = ACTIONS(3136),
    [anon_sym_nullptr] = ACTIONS(3136),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3136),
    [anon_sym_decltype] = ACTIONS(3136),
    [anon_sym_virtual] = ACTIONS(3136),
    [anon_sym_alignas] = ACTIONS(3136),
    [anon_sym_explicit] = ACTIONS(3136),
    [anon_sym_typename] = ACTIONS(3136),
    [anon_sym_template] = ACTIONS(3136),
    [anon_sym_operator] = ACTIONS(3136),
    [anon_sym_try] = ACTIONS(3136),
    [anon_sym_delete] = ACTIONS(3136),
    [anon_sym_throw] = ACTIONS(3136),
    [anon_sym_namespace] = ACTIONS(3136),
    [anon_sym_using] = ACTIONS(3136),
    [anon_sym_static_assert] = ACTIONS(3136),
    [anon_sym_concept] = ACTIONS(3136),
    [anon_sym_co_return] = ACTIONS(3136),
    [anon_sym_co_yield] = ACTIONS(3136),
    [anon_sym_R_DQUOTE] = ACTIONS(3138),
    [anon_sym_LR_DQUOTE] = ACTIONS(3138),
    [anon_sym_uR_DQUOTE] = ACTIONS(3138),
    [anon_sym_UR_DQUOTE] = ACTIONS(3138),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3138),
    [anon_sym_co_await] = ACTIONS(3136),
    [anon_sym_new] = ACTIONS(3136),
    [anon_sym_requires] = ACTIONS(3136),
    [sym_this] = ACTIONS(3136),
  },
  [750] = {
    [sym_identifier] = ACTIONS(2889),
    [aux_sym_preproc_include_token1] = ACTIONS(2889),
    [aux_sym_preproc_def_token1] = ACTIONS(2889),
    [aux_sym_preproc_if_token1] = ACTIONS(2889),
    [aux_sym_preproc_if_token2] = ACTIONS(2889),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2889),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2889),
    [sym_preproc_directive] = ACTIONS(2889),
    [anon_sym_LPAREN2] = ACTIONS(2891),
    [anon_sym_BANG] = ACTIONS(2891),
    [anon_sym_TILDE] = ACTIONS(2891),
    [anon_sym_DASH] = ACTIONS(2889),
    [anon_sym_PLUS] = ACTIONS(2889),
    [anon_sym_STAR] = ACTIONS(2891),
    [anon_sym_AMP_AMP] = ACTIONS(2891),
    [anon_sym_AMP] = ACTIONS(2889),
    [anon_sym_SEMI] = ACTIONS(2891),
    [anon_sym___extension__] = ACTIONS(2889),
    [anon_sym_typedef] = ACTIONS(2889),
    [anon_sym_extern] = ACTIONS(2889),
    [anon_sym___attribute__] = ACTIONS(2889),
    [anon_sym_COLON_COLON] = ACTIONS(2891),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2891),
    [anon_sym___declspec] = ACTIONS(2889),
    [anon_sym___based] = ACTIONS(2889),
    [anon_sym___cdecl] = ACTIONS(2889),
    [anon_sym___clrcall] = ACTIONS(2889),
    [anon_sym___stdcall] = ACTIONS(2889),
    [anon_sym___fastcall] = ACTIONS(2889),
    [anon_sym___thiscall] = ACTIONS(2889),
    [anon_sym___vectorcall] = ACTIONS(2889),
    [anon_sym_LBRACE] = ACTIONS(2891),
    [anon_sym_signed] = ACTIONS(2889),
    [anon_sym_unsigned] = ACTIONS(2889),
    [anon_sym_long] = ACTIONS(2889),
    [anon_sym_short] = ACTIONS(2889),
    [anon_sym_LBRACK] = ACTIONS(2889),
    [anon_sym_static] = ACTIONS(2889),
    [anon_sym_register] = ACTIONS(2889),
    [anon_sym_inline] = ACTIONS(2889),
    [anon_sym___inline] = ACTIONS(2889),
    [anon_sym___inline__] = ACTIONS(2889),
    [anon_sym___forceinline] = ACTIONS(2889),
    [anon_sym_thread_local] = ACTIONS(2889),
    [anon_sym___thread] = ACTIONS(2889),
    [anon_sym_const] = ACTIONS(2889),
    [anon_sym_constexpr] = ACTIONS(2889),
    [anon_sym_volatile] = ACTIONS(2889),
    [anon_sym_restrict] = ACTIONS(2889),
    [anon_sym___restrict__] = ACTIONS(2889),
    [anon_sym__Atomic] = ACTIONS(2889),
    [anon_sym__Noreturn] = ACTIONS(2889),
    [anon_sym_noreturn] = ACTIONS(2889),
    [anon_sym_mutable] = ACTIONS(2889),
    [anon_sym_constinit] = ACTIONS(2889),
    [anon_sym_consteval] = ACTIONS(2889),
    [anon_sym_PROGMEM] = ACTIONS(2889),
    [aux_sym_primitive_type_token1] = ACTIONS(2889),
    [anon_sym_byte] = ACTIONS(2889),
    [anon_sym_word] = ACTIONS(2889),
    [anon_sym_enum] = ACTIONS(2889),
    [anon_sym_class] = ACTIONS(2889),
    [anon_sym_struct] = ACTIONS(2889),
    [anon_sym_union] = ACTIONS(2889),
    [anon_sym_if] = ACTIONS(2889),
    [anon_sym_switch] = ACTIONS(2889),
    [anon_sym_case] = ACTIONS(2889),
    [anon_sym_default] = ACTIONS(2889),
    [anon_sym_while] = ACTIONS(2889),
    [anon_sym_do] = ACTIONS(2889),
    [anon_sym_for] = ACTIONS(2889),
    [anon_sym_return] = ACTIONS(2889),
    [anon_sym_break] = ACTIONS(2889),
    [anon_sym_continue] = ACTIONS(2889),
    [anon_sym_goto] = ACTIONS(2889),
    [anon_sym___try] = ACTIONS(2889),
    [anon_sym___leave] = ACTIONS(2889),
    [anon_sym_not] = ACTIONS(2889),
    [anon_sym_compl] = ACTIONS(2889),
    [anon_sym_DASH_DASH] = ACTIONS(2891),
    [anon_sym_PLUS_PLUS] = ACTIONS(2891),
    [anon_sym_sizeof] = ACTIONS(2889),
    [anon_sym___alignof__] = ACTIONS(2889),
    [anon_sym___alignof] = ACTIONS(2889),
    [anon_sym__alignof] = ACTIONS(2889),
    [anon_sym_alignof] = ACTIONS(2889),
    [anon_sym__Alignof] = ACTIONS(2889),
    [anon_sym_offsetof] = ACTIONS(2889),
    [anon_sym__Generic] = ACTIONS(2889),
    [anon_sym_asm] = ACTIONS(2889),
    [anon_sym___asm__] = ACTIONS(2889),
    [aux_sym_number_literal_token1] = ACTIONS(2891),
    [aux_sym_number_literal_token2] = ACTIONS(2889),
    [anon_sym_L_SQUOTE] = ACTIONS(2891),
    [anon_sym_u_SQUOTE] = ACTIONS(2891),
    [anon_sym_U_SQUOTE] = ACTIONS(2891),
    [anon_sym_u8_SQUOTE] = ACTIONS(2891),
    [anon_sym_SQUOTE] = ACTIONS(2891),
    [anon_sym_L_DQUOTE] = ACTIONS(2891),
    [anon_sym_u_DQUOTE] = ACTIONS(2891),
    [anon_sym_U_DQUOTE] = ACTIONS(2891),
    [anon_sym_u8_DQUOTE] = ACTIONS(2891),
    [anon_sym_DQUOTE] = ACTIONS(2891),
    [sym_true] = ACTIONS(2889),
    [sym_false] = ACTIONS(2889),
    [anon_sym_NULL] = ACTIONS(2889),
    [anon_sym_nullptr] = ACTIONS(2889),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2889),
    [anon_sym_decltype] = ACTIONS(2889),
    [anon_sym_virtual] = ACTIONS(2889),
    [anon_sym_alignas] = ACTIONS(2889),
    [anon_sym_explicit] = ACTIONS(2889),
    [anon_sym_typename] = ACTIONS(2889),
    [anon_sym_template] = ACTIONS(2889),
    [anon_sym_operator] = ACTIONS(2889),
    [anon_sym_try] = ACTIONS(2889),
    [anon_sym_delete] = ACTIONS(2889),
    [anon_sym_throw] = ACTIONS(2889),
    [anon_sym_namespace] = ACTIONS(2889),
    [anon_sym_using] = ACTIONS(2889),
    [anon_sym_static_assert] = ACTIONS(2889),
    [anon_sym_concept] = ACTIONS(2889),
    [anon_sym_co_return] = ACTIONS(2889),
    [anon_sym_co_yield] = ACTIONS(2889),
    [anon_sym_R_DQUOTE] = ACTIONS(2891),
    [anon_sym_LR_DQUOTE] = ACTIONS(2891),
    [anon_sym_uR_DQUOTE] = ACTIONS(2891),
    [anon_sym_UR_DQUOTE] = ACTIONS(2891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2891),
    [anon_sym_co_await] = ACTIONS(2889),
    [anon_sym_new] = ACTIONS(2889),
    [anon_sym_requires] = ACTIONS(2889),
    [sym_this] = ACTIONS(2889),
  },
  [751] = {
    [sym_identifier] = ACTIONS(2813),
    [aux_sym_preproc_include_token1] = ACTIONS(2813),
    [aux_sym_preproc_def_token1] = ACTIONS(2813),
    [aux_sym_preproc_if_token1] = ACTIONS(2813),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2813),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2813),
    [sym_preproc_directive] = ACTIONS(2813),
    [anon_sym_LPAREN2] = ACTIONS(2815),
    [anon_sym_BANG] = ACTIONS(2815),
    [anon_sym_TILDE] = ACTIONS(2815),
    [anon_sym_DASH] = ACTIONS(2813),
    [anon_sym_PLUS] = ACTIONS(2813),
    [anon_sym_STAR] = ACTIONS(2815),
    [anon_sym_AMP_AMP] = ACTIONS(2815),
    [anon_sym_AMP] = ACTIONS(2813),
    [anon_sym_SEMI] = ACTIONS(2815),
    [anon_sym___extension__] = ACTIONS(2813),
    [anon_sym_typedef] = ACTIONS(2813),
    [anon_sym_extern] = ACTIONS(2813),
    [anon_sym___attribute__] = ACTIONS(2813),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2815),
    [anon_sym___declspec] = ACTIONS(2813),
    [anon_sym___based] = ACTIONS(2813),
    [anon_sym___cdecl] = ACTIONS(2813),
    [anon_sym___clrcall] = ACTIONS(2813),
    [anon_sym___stdcall] = ACTIONS(2813),
    [anon_sym___fastcall] = ACTIONS(2813),
    [anon_sym___thiscall] = ACTIONS(2813),
    [anon_sym___vectorcall] = ACTIONS(2813),
    [anon_sym_LBRACE] = ACTIONS(2815),
    [anon_sym_RBRACE] = ACTIONS(2815),
    [anon_sym_signed] = ACTIONS(2813),
    [anon_sym_unsigned] = ACTIONS(2813),
    [anon_sym_long] = ACTIONS(2813),
    [anon_sym_short] = ACTIONS(2813),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_static] = ACTIONS(2813),
    [anon_sym_register] = ACTIONS(2813),
    [anon_sym_inline] = ACTIONS(2813),
    [anon_sym___inline] = ACTIONS(2813),
    [anon_sym___inline__] = ACTIONS(2813),
    [anon_sym___forceinline] = ACTIONS(2813),
    [anon_sym_thread_local] = ACTIONS(2813),
    [anon_sym___thread] = ACTIONS(2813),
    [anon_sym_const] = ACTIONS(2813),
    [anon_sym_constexpr] = ACTIONS(2813),
    [anon_sym_volatile] = ACTIONS(2813),
    [anon_sym_restrict] = ACTIONS(2813),
    [anon_sym___restrict__] = ACTIONS(2813),
    [anon_sym__Atomic] = ACTIONS(2813),
    [anon_sym__Noreturn] = ACTIONS(2813),
    [anon_sym_noreturn] = ACTIONS(2813),
    [anon_sym_mutable] = ACTIONS(2813),
    [anon_sym_constinit] = ACTIONS(2813),
    [anon_sym_consteval] = ACTIONS(2813),
    [anon_sym_PROGMEM] = ACTIONS(2813),
    [aux_sym_primitive_type_token1] = ACTIONS(2813),
    [anon_sym_byte] = ACTIONS(2813),
    [anon_sym_word] = ACTIONS(2813),
    [anon_sym_enum] = ACTIONS(2813),
    [anon_sym_class] = ACTIONS(2813),
    [anon_sym_struct] = ACTIONS(2813),
    [anon_sym_union] = ACTIONS(2813),
    [anon_sym_if] = ACTIONS(2813),
    [anon_sym_switch] = ACTIONS(2813),
    [anon_sym_case] = ACTIONS(2813),
    [anon_sym_default] = ACTIONS(2813),
    [anon_sym_while] = ACTIONS(2813),
    [anon_sym_do] = ACTIONS(2813),
    [anon_sym_for] = ACTIONS(2813),
    [anon_sym_return] = ACTIONS(2813),
    [anon_sym_break] = ACTIONS(2813),
    [anon_sym_continue] = ACTIONS(2813),
    [anon_sym_goto] = ACTIONS(2813),
    [anon_sym___try] = ACTIONS(2813),
    [anon_sym___leave] = ACTIONS(2813),
    [anon_sym_not] = ACTIONS(2813),
    [anon_sym_compl] = ACTIONS(2813),
    [anon_sym_DASH_DASH] = ACTIONS(2815),
    [anon_sym_PLUS_PLUS] = ACTIONS(2815),
    [anon_sym_sizeof] = ACTIONS(2813),
    [anon_sym___alignof__] = ACTIONS(2813),
    [anon_sym___alignof] = ACTIONS(2813),
    [anon_sym__alignof] = ACTIONS(2813),
    [anon_sym_alignof] = ACTIONS(2813),
    [anon_sym__Alignof] = ACTIONS(2813),
    [anon_sym_offsetof] = ACTIONS(2813),
    [anon_sym__Generic] = ACTIONS(2813),
    [anon_sym_asm] = ACTIONS(2813),
    [anon_sym___asm__] = ACTIONS(2813),
    [aux_sym_number_literal_token1] = ACTIONS(2815),
    [aux_sym_number_literal_token2] = ACTIONS(2813),
    [anon_sym_L_SQUOTE] = ACTIONS(2815),
    [anon_sym_u_SQUOTE] = ACTIONS(2815),
    [anon_sym_U_SQUOTE] = ACTIONS(2815),
    [anon_sym_u8_SQUOTE] = ACTIONS(2815),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_L_DQUOTE] = ACTIONS(2815),
    [anon_sym_u_DQUOTE] = ACTIONS(2815),
    [anon_sym_U_DQUOTE] = ACTIONS(2815),
    [anon_sym_u8_DQUOTE] = ACTIONS(2815),
    [anon_sym_DQUOTE] = ACTIONS(2815),
    [sym_true] = ACTIONS(2813),
    [sym_false] = ACTIONS(2813),
    [anon_sym_NULL] = ACTIONS(2813),
    [anon_sym_nullptr] = ACTIONS(2813),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2813),
    [anon_sym_decltype] = ACTIONS(2813),
    [anon_sym_virtual] = ACTIONS(2813),
    [anon_sym_alignas] = ACTIONS(2813),
    [anon_sym_explicit] = ACTIONS(2813),
    [anon_sym_typename] = ACTIONS(2813),
    [anon_sym_template] = ACTIONS(2813),
    [anon_sym_operator] = ACTIONS(2813),
    [anon_sym_try] = ACTIONS(2813),
    [anon_sym_delete] = ACTIONS(2813),
    [anon_sym_throw] = ACTIONS(2813),
    [anon_sym_namespace] = ACTIONS(2813),
    [anon_sym_using] = ACTIONS(2813),
    [anon_sym_static_assert] = ACTIONS(2813),
    [anon_sym_concept] = ACTIONS(2813),
    [anon_sym_co_return] = ACTIONS(2813),
    [anon_sym_co_yield] = ACTIONS(2813),
    [anon_sym_R_DQUOTE] = ACTIONS(2815),
    [anon_sym_LR_DQUOTE] = ACTIONS(2815),
    [anon_sym_uR_DQUOTE] = ACTIONS(2815),
    [anon_sym_UR_DQUOTE] = ACTIONS(2815),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2815),
    [anon_sym_co_await] = ACTIONS(2813),
    [anon_sym_new] = ACTIONS(2813),
    [anon_sym_requires] = ACTIONS(2813),
    [sym_this] = ACTIONS(2813),
  },
  [752] = {
    [sym_identifier] = ACTIONS(2813),
    [aux_sym_preproc_include_token1] = ACTIONS(2813),
    [aux_sym_preproc_def_token1] = ACTIONS(2813),
    [aux_sym_preproc_if_token1] = ACTIONS(2813),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2813),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2813),
    [sym_preproc_directive] = ACTIONS(2813),
    [anon_sym_LPAREN2] = ACTIONS(2815),
    [anon_sym_BANG] = ACTIONS(2815),
    [anon_sym_TILDE] = ACTIONS(2815),
    [anon_sym_DASH] = ACTIONS(2813),
    [anon_sym_PLUS] = ACTIONS(2813),
    [anon_sym_STAR] = ACTIONS(2815),
    [anon_sym_AMP_AMP] = ACTIONS(2815),
    [anon_sym_AMP] = ACTIONS(2813),
    [anon_sym_SEMI] = ACTIONS(2815),
    [anon_sym___extension__] = ACTIONS(2813),
    [anon_sym_typedef] = ACTIONS(2813),
    [anon_sym_extern] = ACTIONS(2813),
    [anon_sym___attribute__] = ACTIONS(2813),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2815),
    [anon_sym___declspec] = ACTIONS(2813),
    [anon_sym___based] = ACTIONS(2813),
    [anon_sym___cdecl] = ACTIONS(2813),
    [anon_sym___clrcall] = ACTIONS(2813),
    [anon_sym___stdcall] = ACTIONS(2813),
    [anon_sym___fastcall] = ACTIONS(2813),
    [anon_sym___thiscall] = ACTIONS(2813),
    [anon_sym___vectorcall] = ACTIONS(2813),
    [anon_sym_LBRACE] = ACTIONS(2815),
    [anon_sym_RBRACE] = ACTIONS(2815),
    [anon_sym_signed] = ACTIONS(2813),
    [anon_sym_unsigned] = ACTIONS(2813),
    [anon_sym_long] = ACTIONS(2813),
    [anon_sym_short] = ACTIONS(2813),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_static] = ACTIONS(2813),
    [anon_sym_register] = ACTIONS(2813),
    [anon_sym_inline] = ACTIONS(2813),
    [anon_sym___inline] = ACTIONS(2813),
    [anon_sym___inline__] = ACTIONS(2813),
    [anon_sym___forceinline] = ACTIONS(2813),
    [anon_sym_thread_local] = ACTIONS(2813),
    [anon_sym___thread] = ACTIONS(2813),
    [anon_sym_const] = ACTIONS(2813),
    [anon_sym_constexpr] = ACTIONS(2813),
    [anon_sym_volatile] = ACTIONS(2813),
    [anon_sym_restrict] = ACTIONS(2813),
    [anon_sym___restrict__] = ACTIONS(2813),
    [anon_sym__Atomic] = ACTIONS(2813),
    [anon_sym__Noreturn] = ACTIONS(2813),
    [anon_sym_noreturn] = ACTIONS(2813),
    [anon_sym_mutable] = ACTIONS(2813),
    [anon_sym_constinit] = ACTIONS(2813),
    [anon_sym_consteval] = ACTIONS(2813),
    [anon_sym_PROGMEM] = ACTIONS(2813),
    [aux_sym_primitive_type_token1] = ACTIONS(2813),
    [anon_sym_byte] = ACTIONS(2813),
    [anon_sym_word] = ACTIONS(2813),
    [anon_sym_enum] = ACTIONS(2813),
    [anon_sym_class] = ACTIONS(2813),
    [anon_sym_struct] = ACTIONS(2813),
    [anon_sym_union] = ACTIONS(2813),
    [anon_sym_if] = ACTIONS(2813),
    [anon_sym_switch] = ACTIONS(2813),
    [anon_sym_case] = ACTIONS(2813),
    [anon_sym_default] = ACTIONS(2813),
    [anon_sym_while] = ACTIONS(2813),
    [anon_sym_do] = ACTIONS(2813),
    [anon_sym_for] = ACTIONS(2813),
    [anon_sym_return] = ACTIONS(2813),
    [anon_sym_break] = ACTIONS(2813),
    [anon_sym_continue] = ACTIONS(2813),
    [anon_sym_goto] = ACTIONS(2813),
    [anon_sym___try] = ACTIONS(2813),
    [anon_sym___leave] = ACTIONS(2813),
    [anon_sym_not] = ACTIONS(2813),
    [anon_sym_compl] = ACTIONS(2813),
    [anon_sym_DASH_DASH] = ACTIONS(2815),
    [anon_sym_PLUS_PLUS] = ACTIONS(2815),
    [anon_sym_sizeof] = ACTIONS(2813),
    [anon_sym___alignof__] = ACTIONS(2813),
    [anon_sym___alignof] = ACTIONS(2813),
    [anon_sym__alignof] = ACTIONS(2813),
    [anon_sym_alignof] = ACTIONS(2813),
    [anon_sym__Alignof] = ACTIONS(2813),
    [anon_sym_offsetof] = ACTIONS(2813),
    [anon_sym__Generic] = ACTIONS(2813),
    [anon_sym_asm] = ACTIONS(2813),
    [anon_sym___asm__] = ACTIONS(2813),
    [aux_sym_number_literal_token1] = ACTIONS(2815),
    [aux_sym_number_literal_token2] = ACTIONS(2813),
    [anon_sym_L_SQUOTE] = ACTIONS(2815),
    [anon_sym_u_SQUOTE] = ACTIONS(2815),
    [anon_sym_U_SQUOTE] = ACTIONS(2815),
    [anon_sym_u8_SQUOTE] = ACTIONS(2815),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_L_DQUOTE] = ACTIONS(2815),
    [anon_sym_u_DQUOTE] = ACTIONS(2815),
    [anon_sym_U_DQUOTE] = ACTIONS(2815),
    [anon_sym_u8_DQUOTE] = ACTIONS(2815),
    [anon_sym_DQUOTE] = ACTIONS(2815),
    [sym_true] = ACTIONS(2813),
    [sym_false] = ACTIONS(2813),
    [anon_sym_NULL] = ACTIONS(2813),
    [anon_sym_nullptr] = ACTIONS(2813),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2813),
    [anon_sym_decltype] = ACTIONS(2813),
    [anon_sym_virtual] = ACTIONS(2813),
    [anon_sym_alignas] = ACTIONS(2813),
    [anon_sym_explicit] = ACTIONS(2813),
    [anon_sym_typename] = ACTIONS(2813),
    [anon_sym_template] = ACTIONS(2813),
    [anon_sym_operator] = ACTIONS(2813),
    [anon_sym_try] = ACTIONS(2813),
    [anon_sym_delete] = ACTIONS(2813),
    [anon_sym_throw] = ACTIONS(2813),
    [anon_sym_namespace] = ACTIONS(2813),
    [anon_sym_using] = ACTIONS(2813),
    [anon_sym_static_assert] = ACTIONS(2813),
    [anon_sym_concept] = ACTIONS(2813),
    [anon_sym_co_return] = ACTIONS(2813),
    [anon_sym_co_yield] = ACTIONS(2813),
    [anon_sym_R_DQUOTE] = ACTIONS(2815),
    [anon_sym_LR_DQUOTE] = ACTIONS(2815),
    [anon_sym_uR_DQUOTE] = ACTIONS(2815),
    [anon_sym_UR_DQUOTE] = ACTIONS(2815),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2815),
    [anon_sym_co_await] = ACTIONS(2813),
    [anon_sym_new] = ACTIONS(2813),
    [anon_sym_requires] = ACTIONS(2813),
    [sym_this] = ACTIONS(2813),
  },
  [753] = {
    [sym_identifier] = ACTIONS(2809),
    [aux_sym_preproc_include_token1] = ACTIONS(2809),
    [aux_sym_preproc_def_token1] = ACTIONS(2809),
    [aux_sym_preproc_if_token1] = ACTIONS(2809),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2809),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2809),
    [sym_preproc_directive] = ACTIONS(2809),
    [anon_sym_LPAREN2] = ACTIONS(2811),
    [anon_sym_BANG] = ACTIONS(2811),
    [anon_sym_TILDE] = ACTIONS(2811),
    [anon_sym_DASH] = ACTIONS(2809),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_STAR] = ACTIONS(2811),
    [anon_sym_AMP_AMP] = ACTIONS(2811),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2811),
    [anon_sym___extension__] = ACTIONS(2809),
    [anon_sym_typedef] = ACTIONS(2809),
    [anon_sym_extern] = ACTIONS(2809),
    [anon_sym___attribute__] = ACTIONS(2809),
    [anon_sym_COLON_COLON] = ACTIONS(2811),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2811),
    [anon_sym___declspec] = ACTIONS(2809),
    [anon_sym___based] = ACTIONS(2809),
    [anon_sym___cdecl] = ACTIONS(2809),
    [anon_sym___clrcall] = ACTIONS(2809),
    [anon_sym___stdcall] = ACTIONS(2809),
    [anon_sym___fastcall] = ACTIONS(2809),
    [anon_sym___thiscall] = ACTIONS(2809),
    [anon_sym___vectorcall] = ACTIONS(2809),
    [anon_sym_LBRACE] = ACTIONS(2811),
    [anon_sym_RBRACE] = ACTIONS(2811),
    [anon_sym_signed] = ACTIONS(2809),
    [anon_sym_unsigned] = ACTIONS(2809),
    [anon_sym_long] = ACTIONS(2809),
    [anon_sym_short] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2809),
    [anon_sym_static] = ACTIONS(2809),
    [anon_sym_register] = ACTIONS(2809),
    [anon_sym_inline] = ACTIONS(2809),
    [anon_sym___inline] = ACTIONS(2809),
    [anon_sym___inline__] = ACTIONS(2809),
    [anon_sym___forceinline] = ACTIONS(2809),
    [anon_sym_thread_local] = ACTIONS(2809),
    [anon_sym___thread] = ACTIONS(2809),
    [anon_sym_const] = ACTIONS(2809),
    [anon_sym_constexpr] = ACTIONS(2809),
    [anon_sym_volatile] = ACTIONS(2809),
    [anon_sym_restrict] = ACTIONS(2809),
    [anon_sym___restrict__] = ACTIONS(2809),
    [anon_sym__Atomic] = ACTIONS(2809),
    [anon_sym__Noreturn] = ACTIONS(2809),
    [anon_sym_noreturn] = ACTIONS(2809),
    [anon_sym_mutable] = ACTIONS(2809),
    [anon_sym_constinit] = ACTIONS(2809),
    [anon_sym_consteval] = ACTIONS(2809),
    [anon_sym_PROGMEM] = ACTIONS(2809),
    [aux_sym_primitive_type_token1] = ACTIONS(2809),
    [anon_sym_byte] = ACTIONS(2809),
    [anon_sym_word] = ACTIONS(2809),
    [anon_sym_enum] = ACTIONS(2809),
    [anon_sym_class] = ACTIONS(2809),
    [anon_sym_struct] = ACTIONS(2809),
    [anon_sym_union] = ACTIONS(2809),
    [anon_sym_if] = ACTIONS(2809),
    [anon_sym_switch] = ACTIONS(2809),
    [anon_sym_case] = ACTIONS(2809),
    [anon_sym_default] = ACTIONS(2809),
    [anon_sym_while] = ACTIONS(2809),
    [anon_sym_do] = ACTIONS(2809),
    [anon_sym_for] = ACTIONS(2809),
    [anon_sym_return] = ACTIONS(2809),
    [anon_sym_break] = ACTIONS(2809),
    [anon_sym_continue] = ACTIONS(2809),
    [anon_sym_goto] = ACTIONS(2809),
    [anon_sym___try] = ACTIONS(2809),
    [anon_sym___leave] = ACTIONS(2809),
    [anon_sym_not] = ACTIONS(2809),
    [anon_sym_compl] = ACTIONS(2809),
    [anon_sym_DASH_DASH] = ACTIONS(2811),
    [anon_sym_PLUS_PLUS] = ACTIONS(2811),
    [anon_sym_sizeof] = ACTIONS(2809),
    [anon_sym___alignof__] = ACTIONS(2809),
    [anon_sym___alignof] = ACTIONS(2809),
    [anon_sym__alignof] = ACTIONS(2809),
    [anon_sym_alignof] = ACTIONS(2809),
    [anon_sym__Alignof] = ACTIONS(2809),
    [anon_sym_offsetof] = ACTIONS(2809),
    [anon_sym__Generic] = ACTIONS(2809),
    [anon_sym_asm] = ACTIONS(2809),
    [anon_sym___asm__] = ACTIONS(2809),
    [aux_sym_number_literal_token1] = ACTIONS(2811),
    [aux_sym_number_literal_token2] = ACTIONS(2809),
    [anon_sym_L_SQUOTE] = ACTIONS(2811),
    [anon_sym_u_SQUOTE] = ACTIONS(2811),
    [anon_sym_U_SQUOTE] = ACTIONS(2811),
    [anon_sym_u8_SQUOTE] = ACTIONS(2811),
    [anon_sym_SQUOTE] = ACTIONS(2811),
    [anon_sym_L_DQUOTE] = ACTIONS(2811),
    [anon_sym_u_DQUOTE] = ACTIONS(2811),
    [anon_sym_U_DQUOTE] = ACTIONS(2811),
    [anon_sym_u8_DQUOTE] = ACTIONS(2811),
    [anon_sym_DQUOTE] = ACTIONS(2811),
    [sym_true] = ACTIONS(2809),
    [sym_false] = ACTIONS(2809),
    [anon_sym_NULL] = ACTIONS(2809),
    [anon_sym_nullptr] = ACTIONS(2809),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2809),
    [anon_sym_decltype] = ACTIONS(2809),
    [anon_sym_virtual] = ACTIONS(2809),
    [anon_sym_alignas] = ACTIONS(2809),
    [anon_sym_explicit] = ACTIONS(2809),
    [anon_sym_typename] = ACTIONS(2809),
    [anon_sym_template] = ACTIONS(2809),
    [anon_sym_operator] = ACTIONS(2809),
    [anon_sym_try] = ACTIONS(2809),
    [anon_sym_delete] = ACTIONS(2809),
    [anon_sym_throw] = ACTIONS(2809),
    [anon_sym_namespace] = ACTIONS(2809),
    [anon_sym_using] = ACTIONS(2809),
    [anon_sym_static_assert] = ACTIONS(2809),
    [anon_sym_concept] = ACTIONS(2809),
    [anon_sym_co_return] = ACTIONS(2809),
    [anon_sym_co_yield] = ACTIONS(2809),
    [anon_sym_R_DQUOTE] = ACTIONS(2811),
    [anon_sym_LR_DQUOTE] = ACTIONS(2811),
    [anon_sym_uR_DQUOTE] = ACTIONS(2811),
    [anon_sym_UR_DQUOTE] = ACTIONS(2811),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2811),
    [anon_sym_co_await] = ACTIONS(2809),
    [anon_sym_new] = ACTIONS(2809),
    [anon_sym_requires] = ACTIONS(2809),
    [sym_this] = ACTIONS(2809),
  },
  [754] = {
    [sym_identifier] = ACTIONS(3136),
    [aux_sym_preproc_include_token1] = ACTIONS(3136),
    [aux_sym_preproc_def_token1] = ACTIONS(3136),
    [aux_sym_preproc_if_token1] = ACTIONS(3136),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3136),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3136),
    [sym_preproc_directive] = ACTIONS(3136),
    [anon_sym_LPAREN2] = ACTIONS(3138),
    [anon_sym_BANG] = ACTIONS(3138),
    [anon_sym_TILDE] = ACTIONS(3138),
    [anon_sym_DASH] = ACTIONS(3136),
    [anon_sym_PLUS] = ACTIONS(3136),
    [anon_sym_STAR] = ACTIONS(3138),
    [anon_sym_AMP_AMP] = ACTIONS(3138),
    [anon_sym_AMP] = ACTIONS(3136),
    [anon_sym_SEMI] = ACTIONS(3138),
    [anon_sym___extension__] = ACTIONS(3136),
    [anon_sym_typedef] = ACTIONS(3136),
    [anon_sym_extern] = ACTIONS(3136),
    [anon_sym___attribute__] = ACTIONS(3136),
    [anon_sym_COLON_COLON] = ACTIONS(3138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3138),
    [anon_sym___declspec] = ACTIONS(3136),
    [anon_sym___based] = ACTIONS(3136),
    [anon_sym___cdecl] = ACTIONS(3136),
    [anon_sym___clrcall] = ACTIONS(3136),
    [anon_sym___stdcall] = ACTIONS(3136),
    [anon_sym___fastcall] = ACTIONS(3136),
    [anon_sym___thiscall] = ACTIONS(3136),
    [anon_sym___vectorcall] = ACTIONS(3136),
    [anon_sym_LBRACE] = ACTIONS(3138),
    [anon_sym_RBRACE] = ACTIONS(3138),
    [anon_sym_signed] = ACTIONS(3136),
    [anon_sym_unsigned] = ACTIONS(3136),
    [anon_sym_long] = ACTIONS(3136),
    [anon_sym_short] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3136),
    [anon_sym_static] = ACTIONS(3136),
    [anon_sym_register] = ACTIONS(3136),
    [anon_sym_inline] = ACTIONS(3136),
    [anon_sym___inline] = ACTIONS(3136),
    [anon_sym___inline__] = ACTIONS(3136),
    [anon_sym___forceinline] = ACTIONS(3136),
    [anon_sym_thread_local] = ACTIONS(3136),
    [anon_sym___thread] = ACTIONS(3136),
    [anon_sym_const] = ACTIONS(3136),
    [anon_sym_constexpr] = ACTIONS(3136),
    [anon_sym_volatile] = ACTIONS(3136),
    [anon_sym_restrict] = ACTIONS(3136),
    [anon_sym___restrict__] = ACTIONS(3136),
    [anon_sym__Atomic] = ACTIONS(3136),
    [anon_sym__Noreturn] = ACTIONS(3136),
    [anon_sym_noreturn] = ACTIONS(3136),
    [anon_sym_mutable] = ACTIONS(3136),
    [anon_sym_constinit] = ACTIONS(3136),
    [anon_sym_consteval] = ACTIONS(3136),
    [anon_sym_PROGMEM] = ACTIONS(3136),
    [aux_sym_primitive_type_token1] = ACTIONS(3136),
    [anon_sym_byte] = ACTIONS(3136),
    [anon_sym_word] = ACTIONS(3136),
    [anon_sym_enum] = ACTIONS(3136),
    [anon_sym_class] = ACTIONS(3136),
    [anon_sym_struct] = ACTIONS(3136),
    [anon_sym_union] = ACTIONS(3136),
    [anon_sym_if] = ACTIONS(3136),
    [anon_sym_switch] = ACTIONS(3136),
    [anon_sym_case] = ACTIONS(3136),
    [anon_sym_default] = ACTIONS(3136),
    [anon_sym_while] = ACTIONS(3136),
    [anon_sym_do] = ACTIONS(3136),
    [anon_sym_for] = ACTIONS(3136),
    [anon_sym_return] = ACTIONS(3136),
    [anon_sym_break] = ACTIONS(3136),
    [anon_sym_continue] = ACTIONS(3136),
    [anon_sym_goto] = ACTIONS(3136),
    [anon_sym___try] = ACTIONS(3136),
    [anon_sym___leave] = ACTIONS(3136),
    [anon_sym_not] = ACTIONS(3136),
    [anon_sym_compl] = ACTIONS(3136),
    [anon_sym_DASH_DASH] = ACTIONS(3138),
    [anon_sym_PLUS_PLUS] = ACTIONS(3138),
    [anon_sym_sizeof] = ACTIONS(3136),
    [anon_sym___alignof__] = ACTIONS(3136),
    [anon_sym___alignof] = ACTIONS(3136),
    [anon_sym__alignof] = ACTIONS(3136),
    [anon_sym_alignof] = ACTIONS(3136),
    [anon_sym__Alignof] = ACTIONS(3136),
    [anon_sym_offsetof] = ACTIONS(3136),
    [anon_sym__Generic] = ACTIONS(3136),
    [anon_sym_asm] = ACTIONS(3136),
    [anon_sym___asm__] = ACTIONS(3136),
    [aux_sym_number_literal_token1] = ACTIONS(3138),
    [aux_sym_number_literal_token2] = ACTIONS(3136),
    [anon_sym_L_SQUOTE] = ACTIONS(3138),
    [anon_sym_u_SQUOTE] = ACTIONS(3138),
    [anon_sym_U_SQUOTE] = ACTIONS(3138),
    [anon_sym_u8_SQUOTE] = ACTIONS(3138),
    [anon_sym_SQUOTE] = ACTIONS(3138),
    [anon_sym_L_DQUOTE] = ACTIONS(3138),
    [anon_sym_u_DQUOTE] = ACTIONS(3138),
    [anon_sym_U_DQUOTE] = ACTIONS(3138),
    [anon_sym_u8_DQUOTE] = ACTIONS(3138),
    [anon_sym_DQUOTE] = ACTIONS(3138),
    [sym_true] = ACTIONS(3136),
    [sym_false] = ACTIONS(3136),
    [anon_sym_NULL] = ACTIONS(3136),
    [anon_sym_nullptr] = ACTIONS(3136),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3136),
    [anon_sym_decltype] = ACTIONS(3136),
    [anon_sym_virtual] = ACTIONS(3136),
    [anon_sym_alignas] = ACTIONS(3136),
    [anon_sym_explicit] = ACTIONS(3136),
    [anon_sym_typename] = ACTIONS(3136),
    [anon_sym_template] = ACTIONS(3136),
    [anon_sym_operator] = ACTIONS(3136),
    [anon_sym_try] = ACTIONS(3136),
    [anon_sym_delete] = ACTIONS(3136),
    [anon_sym_throw] = ACTIONS(3136),
    [anon_sym_namespace] = ACTIONS(3136),
    [anon_sym_using] = ACTIONS(3136),
    [anon_sym_static_assert] = ACTIONS(3136),
    [anon_sym_concept] = ACTIONS(3136),
    [anon_sym_co_return] = ACTIONS(3136),
    [anon_sym_co_yield] = ACTIONS(3136),
    [anon_sym_R_DQUOTE] = ACTIONS(3138),
    [anon_sym_LR_DQUOTE] = ACTIONS(3138),
    [anon_sym_uR_DQUOTE] = ACTIONS(3138),
    [anon_sym_UR_DQUOTE] = ACTIONS(3138),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3138),
    [anon_sym_co_await] = ACTIONS(3136),
    [anon_sym_new] = ACTIONS(3136),
    [anon_sym_requires] = ACTIONS(3136),
    [sym_this] = ACTIONS(3136),
  },
  [755] = {
    [sym_identifier] = ACTIONS(2877),
    [aux_sym_preproc_include_token1] = ACTIONS(2877),
    [aux_sym_preproc_def_token1] = ACTIONS(2877),
    [aux_sym_preproc_if_token1] = ACTIONS(2877),
    [aux_sym_preproc_if_token2] = ACTIONS(2877),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2877),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2877),
    [sym_preproc_directive] = ACTIONS(2877),
    [anon_sym_LPAREN2] = ACTIONS(2879),
    [anon_sym_BANG] = ACTIONS(2879),
    [anon_sym_TILDE] = ACTIONS(2879),
    [anon_sym_DASH] = ACTIONS(2877),
    [anon_sym_PLUS] = ACTIONS(2877),
    [anon_sym_STAR] = ACTIONS(2879),
    [anon_sym_AMP_AMP] = ACTIONS(2879),
    [anon_sym_AMP] = ACTIONS(2877),
    [anon_sym_SEMI] = ACTIONS(2879),
    [anon_sym___extension__] = ACTIONS(2877),
    [anon_sym_typedef] = ACTIONS(2877),
    [anon_sym_extern] = ACTIONS(2877),
    [anon_sym___attribute__] = ACTIONS(2877),
    [anon_sym_COLON_COLON] = ACTIONS(2879),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2879),
    [anon_sym___declspec] = ACTIONS(2877),
    [anon_sym___based] = ACTIONS(2877),
    [anon_sym___cdecl] = ACTIONS(2877),
    [anon_sym___clrcall] = ACTIONS(2877),
    [anon_sym___stdcall] = ACTIONS(2877),
    [anon_sym___fastcall] = ACTIONS(2877),
    [anon_sym___thiscall] = ACTIONS(2877),
    [anon_sym___vectorcall] = ACTIONS(2877),
    [anon_sym_LBRACE] = ACTIONS(2879),
    [anon_sym_signed] = ACTIONS(2877),
    [anon_sym_unsigned] = ACTIONS(2877),
    [anon_sym_long] = ACTIONS(2877),
    [anon_sym_short] = ACTIONS(2877),
    [anon_sym_LBRACK] = ACTIONS(2877),
    [anon_sym_static] = ACTIONS(2877),
    [anon_sym_register] = ACTIONS(2877),
    [anon_sym_inline] = ACTIONS(2877),
    [anon_sym___inline] = ACTIONS(2877),
    [anon_sym___inline__] = ACTIONS(2877),
    [anon_sym___forceinline] = ACTIONS(2877),
    [anon_sym_thread_local] = ACTIONS(2877),
    [anon_sym___thread] = ACTIONS(2877),
    [anon_sym_const] = ACTIONS(2877),
    [anon_sym_constexpr] = ACTIONS(2877),
    [anon_sym_volatile] = ACTIONS(2877),
    [anon_sym_restrict] = ACTIONS(2877),
    [anon_sym___restrict__] = ACTIONS(2877),
    [anon_sym__Atomic] = ACTIONS(2877),
    [anon_sym__Noreturn] = ACTIONS(2877),
    [anon_sym_noreturn] = ACTIONS(2877),
    [anon_sym_mutable] = ACTIONS(2877),
    [anon_sym_constinit] = ACTIONS(2877),
    [anon_sym_consteval] = ACTIONS(2877),
    [anon_sym_PROGMEM] = ACTIONS(2877),
    [aux_sym_primitive_type_token1] = ACTIONS(2877),
    [anon_sym_byte] = ACTIONS(2877),
    [anon_sym_word] = ACTIONS(2877),
    [anon_sym_enum] = ACTIONS(2877),
    [anon_sym_class] = ACTIONS(2877),
    [anon_sym_struct] = ACTIONS(2877),
    [anon_sym_union] = ACTIONS(2877),
    [anon_sym_if] = ACTIONS(2877),
    [anon_sym_switch] = ACTIONS(2877),
    [anon_sym_case] = ACTIONS(2877),
    [anon_sym_default] = ACTIONS(2877),
    [anon_sym_while] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_for] = ACTIONS(2877),
    [anon_sym_return] = ACTIONS(2877),
    [anon_sym_break] = ACTIONS(2877),
    [anon_sym_continue] = ACTIONS(2877),
    [anon_sym_goto] = ACTIONS(2877),
    [anon_sym___try] = ACTIONS(2877),
    [anon_sym___leave] = ACTIONS(2877),
    [anon_sym_not] = ACTIONS(2877),
    [anon_sym_compl] = ACTIONS(2877),
    [anon_sym_DASH_DASH] = ACTIONS(2879),
    [anon_sym_PLUS_PLUS] = ACTIONS(2879),
    [anon_sym_sizeof] = ACTIONS(2877),
    [anon_sym___alignof__] = ACTIONS(2877),
    [anon_sym___alignof] = ACTIONS(2877),
    [anon_sym__alignof] = ACTIONS(2877),
    [anon_sym_alignof] = ACTIONS(2877),
    [anon_sym__Alignof] = ACTIONS(2877),
    [anon_sym_offsetof] = ACTIONS(2877),
    [anon_sym__Generic] = ACTIONS(2877),
    [anon_sym_asm] = ACTIONS(2877),
    [anon_sym___asm__] = ACTIONS(2877),
    [aux_sym_number_literal_token1] = ACTIONS(2879),
    [aux_sym_number_literal_token2] = ACTIONS(2877),
    [anon_sym_L_SQUOTE] = ACTIONS(2879),
    [anon_sym_u_SQUOTE] = ACTIONS(2879),
    [anon_sym_U_SQUOTE] = ACTIONS(2879),
    [anon_sym_u8_SQUOTE] = ACTIONS(2879),
    [anon_sym_SQUOTE] = ACTIONS(2879),
    [anon_sym_L_DQUOTE] = ACTIONS(2879),
    [anon_sym_u_DQUOTE] = ACTIONS(2879),
    [anon_sym_U_DQUOTE] = ACTIONS(2879),
    [anon_sym_u8_DQUOTE] = ACTIONS(2879),
    [anon_sym_DQUOTE] = ACTIONS(2879),
    [sym_true] = ACTIONS(2877),
    [sym_false] = ACTIONS(2877),
    [anon_sym_NULL] = ACTIONS(2877),
    [anon_sym_nullptr] = ACTIONS(2877),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2877),
    [anon_sym_decltype] = ACTIONS(2877),
    [anon_sym_virtual] = ACTIONS(2877),
    [anon_sym_alignas] = ACTIONS(2877),
    [anon_sym_explicit] = ACTIONS(2877),
    [anon_sym_typename] = ACTIONS(2877),
    [anon_sym_template] = ACTIONS(2877),
    [anon_sym_operator] = ACTIONS(2877),
    [anon_sym_try] = ACTIONS(2877),
    [anon_sym_delete] = ACTIONS(2877),
    [anon_sym_throw] = ACTIONS(2877),
    [anon_sym_namespace] = ACTIONS(2877),
    [anon_sym_using] = ACTIONS(2877),
    [anon_sym_static_assert] = ACTIONS(2877),
    [anon_sym_concept] = ACTIONS(2877),
    [anon_sym_co_return] = ACTIONS(2877),
    [anon_sym_co_yield] = ACTIONS(2877),
    [anon_sym_R_DQUOTE] = ACTIONS(2879),
    [anon_sym_LR_DQUOTE] = ACTIONS(2879),
    [anon_sym_uR_DQUOTE] = ACTIONS(2879),
    [anon_sym_UR_DQUOTE] = ACTIONS(2879),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2879),
    [anon_sym_co_await] = ACTIONS(2877),
    [anon_sym_new] = ACTIONS(2877),
    [anon_sym_requires] = ACTIONS(2877),
    [sym_this] = ACTIONS(2877),
  },
  [756] = {
    [sym_identifier] = ACTIONS(2801),
    [aux_sym_preproc_include_token1] = ACTIONS(2801),
    [aux_sym_preproc_def_token1] = ACTIONS(2801),
    [aux_sym_preproc_if_token1] = ACTIONS(2801),
    [aux_sym_preproc_if_token2] = ACTIONS(2801),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2801),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2801),
    [sym_preproc_directive] = ACTIONS(2801),
    [anon_sym_LPAREN2] = ACTIONS(2803),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2801),
    [anon_sym_PLUS] = ACTIONS(2801),
    [anon_sym_STAR] = ACTIONS(2803),
    [anon_sym_AMP_AMP] = ACTIONS(2803),
    [anon_sym_AMP] = ACTIONS(2801),
    [anon_sym_SEMI] = ACTIONS(2803),
    [anon_sym___extension__] = ACTIONS(2801),
    [anon_sym_typedef] = ACTIONS(2801),
    [anon_sym_extern] = ACTIONS(2801),
    [anon_sym___attribute__] = ACTIONS(2801),
    [anon_sym_COLON_COLON] = ACTIONS(2803),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2803),
    [anon_sym___declspec] = ACTIONS(2801),
    [anon_sym___based] = ACTIONS(2801),
    [anon_sym___cdecl] = ACTIONS(2801),
    [anon_sym___clrcall] = ACTIONS(2801),
    [anon_sym___stdcall] = ACTIONS(2801),
    [anon_sym___fastcall] = ACTIONS(2801),
    [anon_sym___thiscall] = ACTIONS(2801),
    [anon_sym___vectorcall] = ACTIONS(2801),
    [anon_sym_LBRACE] = ACTIONS(2803),
    [anon_sym_signed] = ACTIONS(2801),
    [anon_sym_unsigned] = ACTIONS(2801),
    [anon_sym_long] = ACTIONS(2801),
    [anon_sym_short] = ACTIONS(2801),
    [anon_sym_LBRACK] = ACTIONS(2801),
    [anon_sym_static] = ACTIONS(2801),
    [anon_sym_register] = ACTIONS(2801),
    [anon_sym_inline] = ACTIONS(2801),
    [anon_sym___inline] = ACTIONS(2801),
    [anon_sym___inline__] = ACTIONS(2801),
    [anon_sym___forceinline] = ACTIONS(2801),
    [anon_sym_thread_local] = ACTIONS(2801),
    [anon_sym___thread] = ACTIONS(2801),
    [anon_sym_const] = ACTIONS(2801),
    [anon_sym_constexpr] = ACTIONS(2801),
    [anon_sym_volatile] = ACTIONS(2801),
    [anon_sym_restrict] = ACTIONS(2801),
    [anon_sym___restrict__] = ACTIONS(2801),
    [anon_sym__Atomic] = ACTIONS(2801),
    [anon_sym__Noreturn] = ACTIONS(2801),
    [anon_sym_noreturn] = ACTIONS(2801),
    [anon_sym_mutable] = ACTIONS(2801),
    [anon_sym_constinit] = ACTIONS(2801),
    [anon_sym_consteval] = ACTIONS(2801),
    [anon_sym_PROGMEM] = ACTIONS(2801),
    [aux_sym_primitive_type_token1] = ACTIONS(2801),
    [anon_sym_byte] = ACTIONS(2801),
    [anon_sym_word] = ACTIONS(2801),
    [anon_sym_enum] = ACTIONS(2801),
    [anon_sym_class] = ACTIONS(2801),
    [anon_sym_struct] = ACTIONS(2801),
    [anon_sym_union] = ACTIONS(2801),
    [anon_sym_if] = ACTIONS(2801),
    [anon_sym_switch] = ACTIONS(2801),
    [anon_sym_case] = ACTIONS(2801),
    [anon_sym_default] = ACTIONS(2801),
    [anon_sym_while] = ACTIONS(2801),
    [anon_sym_do] = ACTIONS(2801),
    [anon_sym_for] = ACTIONS(2801),
    [anon_sym_return] = ACTIONS(2801),
    [anon_sym_break] = ACTIONS(2801),
    [anon_sym_continue] = ACTIONS(2801),
    [anon_sym_goto] = ACTIONS(2801),
    [anon_sym___try] = ACTIONS(2801),
    [anon_sym___leave] = ACTIONS(2801),
    [anon_sym_not] = ACTIONS(2801),
    [anon_sym_compl] = ACTIONS(2801),
    [anon_sym_DASH_DASH] = ACTIONS(2803),
    [anon_sym_PLUS_PLUS] = ACTIONS(2803),
    [anon_sym_sizeof] = ACTIONS(2801),
    [anon_sym___alignof__] = ACTIONS(2801),
    [anon_sym___alignof] = ACTIONS(2801),
    [anon_sym__alignof] = ACTIONS(2801),
    [anon_sym_alignof] = ACTIONS(2801),
    [anon_sym__Alignof] = ACTIONS(2801),
    [anon_sym_offsetof] = ACTIONS(2801),
    [anon_sym__Generic] = ACTIONS(2801),
    [anon_sym_asm] = ACTIONS(2801),
    [anon_sym___asm__] = ACTIONS(2801),
    [aux_sym_number_literal_token1] = ACTIONS(2803),
    [aux_sym_number_literal_token2] = ACTIONS(2801),
    [anon_sym_L_SQUOTE] = ACTIONS(2803),
    [anon_sym_u_SQUOTE] = ACTIONS(2803),
    [anon_sym_U_SQUOTE] = ACTIONS(2803),
    [anon_sym_u8_SQUOTE] = ACTIONS(2803),
    [anon_sym_SQUOTE] = ACTIONS(2803),
    [anon_sym_L_DQUOTE] = ACTIONS(2803),
    [anon_sym_u_DQUOTE] = ACTIONS(2803),
    [anon_sym_U_DQUOTE] = ACTIONS(2803),
    [anon_sym_u8_DQUOTE] = ACTIONS(2803),
    [anon_sym_DQUOTE] = ACTIONS(2803),
    [sym_true] = ACTIONS(2801),
    [sym_false] = ACTIONS(2801),
    [anon_sym_NULL] = ACTIONS(2801),
    [anon_sym_nullptr] = ACTIONS(2801),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2801),
    [anon_sym_decltype] = ACTIONS(2801),
    [anon_sym_virtual] = ACTIONS(2801),
    [anon_sym_alignas] = ACTIONS(2801),
    [anon_sym_explicit] = ACTIONS(2801),
    [anon_sym_typename] = ACTIONS(2801),
    [anon_sym_template] = ACTIONS(2801),
    [anon_sym_operator] = ACTIONS(2801),
    [anon_sym_try] = ACTIONS(2801),
    [anon_sym_delete] = ACTIONS(2801),
    [anon_sym_throw] = ACTIONS(2801),
    [anon_sym_namespace] = ACTIONS(2801),
    [anon_sym_using] = ACTIONS(2801),
    [anon_sym_static_assert] = ACTIONS(2801),
    [anon_sym_concept] = ACTIONS(2801),
    [anon_sym_co_return] = ACTIONS(2801),
    [anon_sym_co_yield] = ACTIONS(2801),
    [anon_sym_R_DQUOTE] = ACTIONS(2803),
    [anon_sym_LR_DQUOTE] = ACTIONS(2803),
    [anon_sym_uR_DQUOTE] = ACTIONS(2803),
    [anon_sym_UR_DQUOTE] = ACTIONS(2803),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2803),
    [anon_sym_co_await] = ACTIONS(2801),
    [anon_sym_new] = ACTIONS(2801),
    [anon_sym_requires] = ACTIONS(2801),
    [sym_this] = ACTIONS(2801),
  },
  [757] = {
    [sym_identifier] = ACTIONS(2805),
    [aux_sym_preproc_include_token1] = ACTIONS(2805),
    [aux_sym_preproc_def_token1] = ACTIONS(2805),
    [aux_sym_preproc_if_token1] = ACTIONS(2805),
    [aux_sym_preproc_if_token2] = ACTIONS(2805),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2805),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2805),
    [sym_preproc_directive] = ACTIONS(2805),
    [anon_sym_LPAREN2] = ACTIONS(2807),
    [anon_sym_BANG] = ACTIONS(2807),
    [anon_sym_TILDE] = ACTIONS(2807),
    [anon_sym_DASH] = ACTIONS(2805),
    [anon_sym_PLUS] = ACTIONS(2805),
    [anon_sym_STAR] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2805),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym___extension__] = ACTIONS(2805),
    [anon_sym_typedef] = ACTIONS(2805),
    [anon_sym_extern] = ACTIONS(2805),
    [anon_sym___attribute__] = ACTIONS(2805),
    [anon_sym_COLON_COLON] = ACTIONS(2807),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2807),
    [anon_sym___declspec] = ACTIONS(2805),
    [anon_sym___based] = ACTIONS(2805),
    [anon_sym___cdecl] = ACTIONS(2805),
    [anon_sym___clrcall] = ACTIONS(2805),
    [anon_sym___stdcall] = ACTIONS(2805),
    [anon_sym___fastcall] = ACTIONS(2805),
    [anon_sym___thiscall] = ACTIONS(2805),
    [anon_sym___vectorcall] = ACTIONS(2805),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_signed] = ACTIONS(2805),
    [anon_sym_unsigned] = ACTIONS(2805),
    [anon_sym_long] = ACTIONS(2805),
    [anon_sym_short] = ACTIONS(2805),
    [anon_sym_LBRACK] = ACTIONS(2805),
    [anon_sym_static] = ACTIONS(2805),
    [anon_sym_register] = ACTIONS(2805),
    [anon_sym_inline] = ACTIONS(2805),
    [anon_sym___inline] = ACTIONS(2805),
    [anon_sym___inline__] = ACTIONS(2805),
    [anon_sym___forceinline] = ACTIONS(2805),
    [anon_sym_thread_local] = ACTIONS(2805),
    [anon_sym___thread] = ACTIONS(2805),
    [anon_sym_const] = ACTIONS(2805),
    [anon_sym_constexpr] = ACTIONS(2805),
    [anon_sym_volatile] = ACTIONS(2805),
    [anon_sym_restrict] = ACTIONS(2805),
    [anon_sym___restrict__] = ACTIONS(2805),
    [anon_sym__Atomic] = ACTIONS(2805),
    [anon_sym__Noreturn] = ACTIONS(2805),
    [anon_sym_noreturn] = ACTIONS(2805),
    [anon_sym_mutable] = ACTIONS(2805),
    [anon_sym_constinit] = ACTIONS(2805),
    [anon_sym_consteval] = ACTIONS(2805),
    [anon_sym_PROGMEM] = ACTIONS(2805),
    [aux_sym_primitive_type_token1] = ACTIONS(2805),
    [anon_sym_byte] = ACTIONS(2805),
    [anon_sym_word] = ACTIONS(2805),
    [anon_sym_enum] = ACTIONS(2805),
    [anon_sym_class] = ACTIONS(2805),
    [anon_sym_struct] = ACTIONS(2805),
    [anon_sym_union] = ACTIONS(2805),
    [anon_sym_if] = ACTIONS(2805),
    [anon_sym_switch] = ACTIONS(2805),
    [anon_sym_case] = ACTIONS(2805),
    [anon_sym_default] = ACTIONS(2805),
    [anon_sym_while] = ACTIONS(2805),
    [anon_sym_do] = ACTIONS(2805),
    [anon_sym_for] = ACTIONS(2805),
    [anon_sym_return] = ACTIONS(2805),
    [anon_sym_break] = ACTIONS(2805),
    [anon_sym_continue] = ACTIONS(2805),
    [anon_sym_goto] = ACTIONS(2805),
    [anon_sym___try] = ACTIONS(2805),
    [anon_sym___leave] = ACTIONS(2805),
    [anon_sym_not] = ACTIONS(2805),
    [anon_sym_compl] = ACTIONS(2805),
    [anon_sym_DASH_DASH] = ACTIONS(2807),
    [anon_sym_PLUS_PLUS] = ACTIONS(2807),
    [anon_sym_sizeof] = ACTIONS(2805),
    [anon_sym___alignof__] = ACTIONS(2805),
    [anon_sym___alignof] = ACTIONS(2805),
    [anon_sym__alignof] = ACTIONS(2805),
    [anon_sym_alignof] = ACTIONS(2805),
    [anon_sym__Alignof] = ACTIONS(2805),
    [anon_sym_offsetof] = ACTIONS(2805),
    [anon_sym__Generic] = ACTIONS(2805),
    [anon_sym_asm] = ACTIONS(2805),
    [anon_sym___asm__] = ACTIONS(2805),
    [aux_sym_number_literal_token1] = ACTIONS(2807),
    [aux_sym_number_literal_token2] = ACTIONS(2805),
    [anon_sym_L_SQUOTE] = ACTIONS(2807),
    [anon_sym_u_SQUOTE] = ACTIONS(2807),
    [anon_sym_U_SQUOTE] = ACTIONS(2807),
    [anon_sym_u8_SQUOTE] = ACTIONS(2807),
    [anon_sym_SQUOTE] = ACTIONS(2807),
    [anon_sym_L_DQUOTE] = ACTIONS(2807),
    [anon_sym_u_DQUOTE] = ACTIONS(2807),
    [anon_sym_U_DQUOTE] = ACTIONS(2807),
    [anon_sym_u8_DQUOTE] = ACTIONS(2807),
    [anon_sym_DQUOTE] = ACTIONS(2807),
    [sym_true] = ACTIONS(2805),
    [sym_false] = ACTIONS(2805),
    [anon_sym_NULL] = ACTIONS(2805),
    [anon_sym_nullptr] = ACTIONS(2805),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2805),
    [anon_sym_decltype] = ACTIONS(2805),
    [anon_sym_virtual] = ACTIONS(2805),
    [anon_sym_alignas] = ACTIONS(2805),
    [anon_sym_explicit] = ACTIONS(2805),
    [anon_sym_typename] = ACTIONS(2805),
    [anon_sym_template] = ACTIONS(2805),
    [anon_sym_operator] = ACTIONS(2805),
    [anon_sym_try] = ACTIONS(2805),
    [anon_sym_delete] = ACTIONS(2805),
    [anon_sym_throw] = ACTIONS(2805),
    [anon_sym_namespace] = ACTIONS(2805),
    [anon_sym_using] = ACTIONS(2805),
    [anon_sym_static_assert] = ACTIONS(2805),
    [anon_sym_concept] = ACTIONS(2805),
    [anon_sym_co_return] = ACTIONS(2805),
    [anon_sym_co_yield] = ACTIONS(2805),
    [anon_sym_R_DQUOTE] = ACTIONS(2807),
    [anon_sym_LR_DQUOTE] = ACTIONS(2807),
    [anon_sym_uR_DQUOTE] = ACTIONS(2807),
    [anon_sym_UR_DQUOTE] = ACTIONS(2807),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2807),
    [anon_sym_co_await] = ACTIONS(2805),
    [anon_sym_new] = ACTIONS(2805),
    [anon_sym_requires] = ACTIONS(2805),
    [sym_this] = ACTIONS(2805),
  },
  [758] = {
    [sym_identifier] = ACTIONS(2885),
    [aux_sym_preproc_include_token1] = ACTIONS(2885),
    [aux_sym_preproc_def_token1] = ACTIONS(2885),
    [aux_sym_preproc_if_token1] = ACTIONS(2885),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2885),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2885),
    [sym_preproc_directive] = ACTIONS(2885),
    [anon_sym_LPAREN2] = ACTIONS(2887),
    [anon_sym_BANG] = ACTIONS(2887),
    [anon_sym_TILDE] = ACTIONS(2887),
    [anon_sym_DASH] = ACTIONS(2885),
    [anon_sym_PLUS] = ACTIONS(2885),
    [anon_sym_STAR] = ACTIONS(2887),
    [anon_sym_AMP_AMP] = ACTIONS(2887),
    [anon_sym_AMP] = ACTIONS(2885),
    [anon_sym_SEMI] = ACTIONS(2887),
    [anon_sym___extension__] = ACTIONS(2885),
    [anon_sym_typedef] = ACTIONS(2885),
    [anon_sym_extern] = ACTIONS(2885),
    [anon_sym___attribute__] = ACTIONS(2885),
    [anon_sym_COLON_COLON] = ACTIONS(2887),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2887),
    [anon_sym___declspec] = ACTIONS(2885),
    [anon_sym___based] = ACTIONS(2885),
    [anon_sym___cdecl] = ACTIONS(2885),
    [anon_sym___clrcall] = ACTIONS(2885),
    [anon_sym___stdcall] = ACTIONS(2885),
    [anon_sym___fastcall] = ACTIONS(2885),
    [anon_sym___thiscall] = ACTIONS(2885),
    [anon_sym___vectorcall] = ACTIONS(2885),
    [anon_sym_LBRACE] = ACTIONS(2887),
    [anon_sym_RBRACE] = ACTIONS(2887),
    [anon_sym_signed] = ACTIONS(2885),
    [anon_sym_unsigned] = ACTIONS(2885),
    [anon_sym_long] = ACTIONS(2885),
    [anon_sym_short] = ACTIONS(2885),
    [anon_sym_LBRACK] = ACTIONS(2885),
    [anon_sym_static] = ACTIONS(2885),
    [anon_sym_register] = ACTIONS(2885),
    [anon_sym_inline] = ACTIONS(2885),
    [anon_sym___inline] = ACTIONS(2885),
    [anon_sym___inline__] = ACTIONS(2885),
    [anon_sym___forceinline] = ACTIONS(2885),
    [anon_sym_thread_local] = ACTIONS(2885),
    [anon_sym___thread] = ACTIONS(2885),
    [anon_sym_const] = ACTIONS(2885),
    [anon_sym_constexpr] = ACTIONS(2885),
    [anon_sym_volatile] = ACTIONS(2885),
    [anon_sym_restrict] = ACTIONS(2885),
    [anon_sym___restrict__] = ACTIONS(2885),
    [anon_sym__Atomic] = ACTIONS(2885),
    [anon_sym__Noreturn] = ACTIONS(2885),
    [anon_sym_noreturn] = ACTIONS(2885),
    [anon_sym_mutable] = ACTIONS(2885),
    [anon_sym_constinit] = ACTIONS(2885),
    [anon_sym_consteval] = ACTIONS(2885),
    [anon_sym_PROGMEM] = ACTIONS(2885),
    [aux_sym_primitive_type_token1] = ACTIONS(2885),
    [anon_sym_byte] = ACTIONS(2885),
    [anon_sym_word] = ACTIONS(2885),
    [anon_sym_enum] = ACTIONS(2885),
    [anon_sym_class] = ACTIONS(2885),
    [anon_sym_struct] = ACTIONS(2885),
    [anon_sym_union] = ACTIONS(2885),
    [anon_sym_if] = ACTIONS(2885),
    [anon_sym_switch] = ACTIONS(2885),
    [anon_sym_case] = ACTIONS(2885),
    [anon_sym_default] = ACTIONS(2885),
    [anon_sym_while] = ACTIONS(2885),
    [anon_sym_do] = ACTIONS(2885),
    [anon_sym_for] = ACTIONS(2885),
    [anon_sym_return] = ACTIONS(2885),
    [anon_sym_break] = ACTIONS(2885),
    [anon_sym_continue] = ACTIONS(2885),
    [anon_sym_goto] = ACTIONS(2885),
    [anon_sym___try] = ACTIONS(2885),
    [anon_sym___leave] = ACTIONS(2885),
    [anon_sym_not] = ACTIONS(2885),
    [anon_sym_compl] = ACTIONS(2885),
    [anon_sym_DASH_DASH] = ACTIONS(2887),
    [anon_sym_PLUS_PLUS] = ACTIONS(2887),
    [anon_sym_sizeof] = ACTIONS(2885),
    [anon_sym___alignof__] = ACTIONS(2885),
    [anon_sym___alignof] = ACTIONS(2885),
    [anon_sym__alignof] = ACTIONS(2885),
    [anon_sym_alignof] = ACTIONS(2885),
    [anon_sym__Alignof] = ACTIONS(2885),
    [anon_sym_offsetof] = ACTIONS(2885),
    [anon_sym__Generic] = ACTIONS(2885),
    [anon_sym_asm] = ACTIONS(2885),
    [anon_sym___asm__] = ACTIONS(2885),
    [aux_sym_number_literal_token1] = ACTIONS(2887),
    [aux_sym_number_literal_token2] = ACTIONS(2885),
    [anon_sym_L_SQUOTE] = ACTIONS(2887),
    [anon_sym_u_SQUOTE] = ACTIONS(2887),
    [anon_sym_U_SQUOTE] = ACTIONS(2887),
    [anon_sym_u8_SQUOTE] = ACTIONS(2887),
    [anon_sym_SQUOTE] = ACTIONS(2887),
    [anon_sym_L_DQUOTE] = ACTIONS(2887),
    [anon_sym_u_DQUOTE] = ACTIONS(2887),
    [anon_sym_U_DQUOTE] = ACTIONS(2887),
    [anon_sym_u8_DQUOTE] = ACTIONS(2887),
    [anon_sym_DQUOTE] = ACTIONS(2887),
    [sym_true] = ACTIONS(2885),
    [sym_false] = ACTIONS(2885),
    [anon_sym_NULL] = ACTIONS(2885),
    [anon_sym_nullptr] = ACTIONS(2885),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2885),
    [anon_sym_decltype] = ACTIONS(2885),
    [anon_sym_virtual] = ACTIONS(2885),
    [anon_sym_alignas] = ACTIONS(2885),
    [anon_sym_explicit] = ACTIONS(2885),
    [anon_sym_typename] = ACTIONS(2885),
    [anon_sym_template] = ACTIONS(2885),
    [anon_sym_operator] = ACTIONS(2885),
    [anon_sym_try] = ACTIONS(2885),
    [anon_sym_delete] = ACTIONS(2885),
    [anon_sym_throw] = ACTIONS(2885),
    [anon_sym_namespace] = ACTIONS(2885),
    [anon_sym_using] = ACTIONS(2885),
    [anon_sym_static_assert] = ACTIONS(2885),
    [anon_sym_concept] = ACTIONS(2885),
    [anon_sym_co_return] = ACTIONS(2885),
    [anon_sym_co_yield] = ACTIONS(2885),
    [anon_sym_R_DQUOTE] = ACTIONS(2887),
    [anon_sym_LR_DQUOTE] = ACTIONS(2887),
    [anon_sym_uR_DQUOTE] = ACTIONS(2887),
    [anon_sym_UR_DQUOTE] = ACTIONS(2887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2887),
    [anon_sym_co_await] = ACTIONS(2885),
    [anon_sym_new] = ACTIONS(2885),
    [anon_sym_requires] = ACTIONS(2885),
    [sym_this] = ACTIONS(2885),
  },
  [759] = {
    [sym_identifier] = ACTIONS(2889),
    [aux_sym_preproc_include_token1] = ACTIONS(2889),
    [aux_sym_preproc_def_token1] = ACTIONS(2889),
    [aux_sym_preproc_if_token1] = ACTIONS(2889),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2889),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2889),
    [sym_preproc_directive] = ACTIONS(2889),
    [anon_sym_LPAREN2] = ACTIONS(2891),
    [anon_sym_BANG] = ACTIONS(2891),
    [anon_sym_TILDE] = ACTIONS(2891),
    [anon_sym_DASH] = ACTIONS(2889),
    [anon_sym_PLUS] = ACTIONS(2889),
    [anon_sym_STAR] = ACTIONS(2891),
    [anon_sym_AMP_AMP] = ACTIONS(2891),
    [anon_sym_AMP] = ACTIONS(2889),
    [anon_sym_SEMI] = ACTIONS(2891),
    [anon_sym___extension__] = ACTIONS(2889),
    [anon_sym_typedef] = ACTIONS(2889),
    [anon_sym_extern] = ACTIONS(2889),
    [anon_sym___attribute__] = ACTIONS(2889),
    [anon_sym_COLON_COLON] = ACTIONS(2891),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2891),
    [anon_sym___declspec] = ACTIONS(2889),
    [anon_sym___based] = ACTIONS(2889),
    [anon_sym___cdecl] = ACTIONS(2889),
    [anon_sym___clrcall] = ACTIONS(2889),
    [anon_sym___stdcall] = ACTIONS(2889),
    [anon_sym___fastcall] = ACTIONS(2889),
    [anon_sym___thiscall] = ACTIONS(2889),
    [anon_sym___vectorcall] = ACTIONS(2889),
    [anon_sym_LBRACE] = ACTIONS(2891),
    [anon_sym_RBRACE] = ACTIONS(2891),
    [anon_sym_signed] = ACTIONS(2889),
    [anon_sym_unsigned] = ACTIONS(2889),
    [anon_sym_long] = ACTIONS(2889),
    [anon_sym_short] = ACTIONS(2889),
    [anon_sym_LBRACK] = ACTIONS(2889),
    [anon_sym_static] = ACTIONS(2889),
    [anon_sym_register] = ACTIONS(2889),
    [anon_sym_inline] = ACTIONS(2889),
    [anon_sym___inline] = ACTIONS(2889),
    [anon_sym___inline__] = ACTIONS(2889),
    [anon_sym___forceinline] = ACTIONS(2889),
    [anon_sym_thread_local] = ACTIONS(2889),
    [anon_sym___thread] = ACTIONS(2889),
    [anon_sym_const] = ACTIONS(2889),
    [anon_sym_constexpr] = ACTIONS(2889),
    [anon_sym_volatile] = ACTIONS(2889),
    [anon_sym_restrict] = ACTIONS(2889),
    [anon_sym___restrict__] = ACTIONS(2889),
    [anon_sym__Atomic] = ACTIONS(2889),
    [anon_sym__Noreturn] = ACTIONS(2889),
    [anon_sym_noreturn] = ACTIONS(2889),
    [anon_sym_mutable] = ACTIONS(2889),
    [anon_sym_constinit] = ACTIONS(2889),
    [anon_sym_consteval] = ACTIONS(2889),
    [anon_sym_PROGMEM] = ACTIONS(2889),
    [aux_sym_primitive_type_token1] = ACTIONS(2889),
    [anon_sym_byte] = ACTIONS(2889),
    [anon_sym_word] = ACTIONS(2889),
    [anon_sym_enum] = ACTIONS(2889),
    [anon_sym_class] = ACTIONS(2889),
    [anon_sym_struct] = ACTIONS(2889),
    [anon_sym_union] = ACTIONS(2889),
    [anon_sym_if] = ACTIONS(2889),
    [anon_sym_switch] = ACTIONS(2889),
    [anon_sym_case] = ACTIONS(2889),
    [anon_sym_default] = ACTIONS(2889),
    [anon_sym_while] = ACTIONS(2889),
    [anon_sym_do] = ACTIONS(2889),
    [anon_sym_for] = ACTIONS(2889),
    [anon_sym_return] = ACTIONS(2889),
    [anon_sym_break] = ACTIONS(2889),
    [anon_sym_continue] = ACTIONS(2889),
    [anon_sym_goto] = ACTIONS(2889),
    [anon_sym___try] = ACTIONS(2889),
    [anon_sym___leave] = ACTIONS(2889),
    [anon_sym_not] = ACTIONS(2889),
    [anon_sym_compl] = ACTIONS(2889),
    [anon_sym_DASH_DASH] = ACTIONS(2891),
    [anon_sym_PLUS_PLUS] = ACTIONS(2891),
    [anon_sym_sizeof] = ACTIONS(2889),
    [anon_sym___alignof__] = ACTIONS(2889),
    [anon_sym___alignof] = ACTIONS(2889),
    [anon_sym__alignof] = ACTIONS(2889),
    [anon_sym_alignof] = ACTIONS(2889),
    [anon_sym__Alignof] = ACTIONS(2889),
    [anon_sym_offsetof] = ACTIONS(2889),
    [anon_sym__Generic] = ACTIONS(2889),
    [anon_sym_asm] = ACTIONS(2889),
    [anon_sym___asm__] = ACTIONS(2889),
    [aux_sym_number_literal_token1] = ACTIONS(2891),
    [aux_sym_number_literal_token2] = ACTIONS(2889),
    [anon_sym_L_SQUOTE] = ACTIONS(2891),
    [anon_sym_u_SQUOTE] = ACTIONS(2891),
    [anon_sym_U_SQUOTE] = ACTIONS(2891),
    [anon_sym_u8_SQUOTE] = ACTIONS(2891),
    [anon_sym_SQUOTE] = ACTIONS(2891),
    [anon_sym_L_DQUOTE] = ACTIONS(2891),
    [anon_sym_u_DQUOTE] = ACTIONS(2891),
    [anon_sym_U_DQUOTE] = ACTIONS(2891),
    [anon_sym_u8_DQUOTE] = ACTIONS(2891),
    [anon_sym_DQUOTE] = ACTIONS(2891),
    [sym_true] = ACTIONS(2889),
    [sym_false] = ACTIONS(2889),
    [anon_sym_NULL] = ACTIONS(2889),
    [anon_sym_nullptr] = ACTIONS(2889),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2889),
    [anon_sym_decltype] = ACTIONS(2889),
    [anon_sym_virtual] = ACTIONS(2889),
    [anon_sym_alignas] = ACTIONS(2889),
    [anon_sym_explicit] = ACTIONS(2889),
    [anon_sym_typename] = ACTIONS(2889),
    [anon_sym_template] = ACTIONS(2889),
    [anon_sym_operator] = ACTIONS(2889),
    [anon_sym_try] = ACTIONS(2889),
    [anon_sym_delete] = ACTIONS(2889),
    [anon_sym_throw] = ACTIONS(2889),
    [anon_sym_namespace] = ACTIONS(2889),
    [anon_sym_using] = ACTIONS(2889),
    [anon_sym_static_assert] = ACTIONS(2889),
    [anon_sym_concept] = ACTIONS(2889),
    [anon_sym_co_return] = ACTIONS(2889),
    [anon_sym_co_yield] = ACTIONS(2889),
    [anon_sym_R_DQUOTE] = ACTIONS(2891),
    [anon_sym_LR_DQUOTE] = ACTIONS(2891),
    [anon_sym_uR_DQUOTE] = ACTIONS(2891),
    [anon_sym_UR_DQUOTE] = ACTIONS(2891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2891),
    [anon_sym_co_await] = ACTIONS(2889),
    [anon_sym_new] = ACTIONS(2889),
    [anon_sym_requires] = ACTIONS(2889),
    [sym_this] = ACTIONS(2889),
  },
  [760] = {
    [sym_identifier] = ACTIONS(2809),
    [aux_sym_preproc_include_token1] = ACTIONS(2809),
    [aux_sym_preproc_def_token1] = ACTIONS(2809),
    [aux_sym_preproc_if_token1] = ACTIONS(2809),
    [aux_sym_preproc_if_token2] = ACTIONS(2809),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2809),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2809),
    [sym_preproc_directive] = ACTIONS(2809),
    [anon_sym_LPAREN2] = ACTIONS(2811),
    [anon_sym_BANG] = ACTIONS(2811),
    [anon_sym_TILDE] = ACTIONS(2811),
    [anon_sym_DASH] = ACTIONS(2809),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_STAR] = ACTIONS(2811),
    [anon_sym_AMP_AMP] = ACTIONS(2811),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2811),
    [anon_sym___extension__] = ACTIONS(2809),
    [anon_sym_typedef] = ACTIONS(2809),
    [anon_sym_extern] = ACTIONS(2809),
    [anon_sym___attribute__] = ACTIONS(2809),
    [anon_sym_COLON_COLON] = ACTIONS(2811),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2811),
    [anon_sym___declspec] = ACTIONS(2809),
    [anon_sym___based] = ACTIONS(2809),
    [anon_sym___cdecl] = ACTIONS(2809),
    [anon_sym___clrcall] = ACTIONS(2809),
    [anon_sym___stdcall] = ACTIONS(2809),
    [anon_sym___fastcall] = ACTIONS(2809),
    [anon_sym___thiscall] = ACTIONS(2809),
    [anon_sym___vectorcall] = ACTIONS(2809),
    [anon_sym_LBRACE] = ACTIONS(2811),
    [anon_sym_signed] = ACTIONS(2809),
    [anon_sym_unsigned] = ACTIONS(2809),
    [anon_sym_long] = ACTIONS(2809),
    [anon_sym_short] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2809),
    [anon_sym_static] = ACTIONS(2809),
    [anon_sym_register] = ACTIONS(2809),
    [anon_sym_inline] = ACTIONS(2809),
    [anon_sym___inline] = ACTIONS(2809),
    [anon_sym___inline__] = ACTIONS(2809),
    [anon_sym___forceinline] = ACTIONS(2809),
    [anon_sym_thread_local] = ACTIONS(2809),
    [anon_sym___thread] = ACTIONS(2809),
    [anon_sym_const] = ACTIONS(2809),
    [anon_sym_constexpr] = ACTIONS(2809),
    [anon_sym_volatile] = ACTIONS(2809),
    [anon_sym_restrict] = ACTIONS(2809),
    [anon_sym___restrict__] = ACTIONS(2809),
    [anon_sym__Atomic] = ACTIONS(2809),
    [anon_sym__Noreturn] = ACTIONS(2809),
    [anon_sym_noreturn] = ACTIONS(2809),
    [anon_sym_mutable] = ACTIONS(2809),
    [anon_sym_constinit] = ACTIONS(2809),
    [anon_sym_consteval] = ACTIONS(2809),
    [anon_sym_PROGMEM] = ACTIONS(2809),
    [aux_sym_primitive_type_token1] = ACTIONS(2809),
    [anon_sym_byte] = ACTIONS(2809),
    [anon_sym_word] = ACTIONS(2809),
    [anon_sym_enum] = ACTIONS(2809),
    [anon_sym_class] = ACTIONS(2809),
    [anon_sym_struct] = ACTIONS(2809),
    [anon_sym_union] = ACTIONS(2809),
    [anon_sym_if] = ACTIONS(2809),
    [anon_sym_switch] = ACTIONS(2809),
    [anon_sym_case] = ACTIONS(2809),
    [anon_sym_default] = ACTIONS(2809),
    [anon_sym_while] = ACTIONS(2809),
    [anon_sym_do] = ACTIONS(2809),
    [anon_sym_for] = ACTIONS(2809),
    [anon_sym_return] = ACTIONS(2809),
    [anon_sym_break] = ACTIONS(2809),
    [anon_sym_continue] = ACTIONS(2809),
    [anon_sym_goto] = ACTIONS(2809),
    [anon_sym___try] = ACTIONS(2809),
    [anon_sym___leave] = ACTIONS(2809),
    [anon_sym_not] = ACTIONS(2809),
    [anon_sym_compl] = ACTIONS(2809),
    [anon_sym_DASH_DASH] = ACTIONS(2811),
    [anon_sym_PLUS_PLUS] = ACTIONS(2811),
    [anon_sym_sizeof] = ACTIONS(2809),
    [anon_sym___alignof__] = ACTIONS(2809),
    [anon_sym___alignof] = ACTIONS(2809),
    [anon_sym__alignof] = ACTIONS(2809),
    [anon_sym_alignof] = ACTIONS(2809),
    [anon_sym__Alignof] = ACTIONS(2809),
    [anon_sym_offsetof] = ACTIONS(2809),
    [anon_sym__Generic] = ACTIONS(2809),
    [anon_sym_asm] = ACTIONS(2809),
    [anon_sym___asm__] = ACTIONS(2809),
    [aux_sym_number_literal_token1] = ACTIONS(2811),
    [aux_sym_number_literal_token2] = ACTIONS(2809),
    [anon_sym_L_SQUOTE] = ACTIONS(2811),
    [anon_sym_u_SQUOTE] = ACTIONS(2811),
    [anon_sym_U_SQUOTE] = ACTIONS(2811),
    [anon_sym_u8_SQUOTE] = ACTIONS(2811),
    [anon_sym_SQUOTE] = ACTIONS(2811),
    [anon_sym_L_DQUOTE] = ACTIONS(2811),
    [anon_sym_u_DQUOTE] = ACTIONS(2811),
    [anon_sym_U_DQUOTE] = ACTIONS(2811),
    [anon_sym_u8_DQUOTE] = ACTIONS(2811),
    [anon_sym_DQUOTE] = ACTIONS(2811),
    [sym_true] = ACTIONS(2809),
    [sym_false] = ACTIONS(2809),
    [anon_sym_NULL] = ACTIONS(2809),
    [anon_sym_nullptr] = ACTIONS(2809),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2809),
    [anon_sym_decltype] = ACTIONS(2809),
    [anon_sym_virtual] = ACTIONS(2809),
    [anon_sym_alignas] = ACTIONS(2809),
    [anon_sym_explicit] = ACTIONS(2809),
    [anon_sym_typename] = ACTIONS(2809),
    [anon_sym_template] = ACTIONS(2809),
    [anon_sym_operator] = ACTIONS(2809),
    [anon_sym_try] = ACTIONS(2809),
    [anon_sym_delete] = ACTIONS(2809),
    [anon_sym_throw] = ACTIONS(2809),
    [anon_sym_namespace] = ACTIONS(2809),
    [anon_sym_using] = ACTIONS(2809),
    [anon_sym_static_assert] = ACTIONS(2809),
    [anon_sym_concept] = ACTIONS(2809),
    [anon_sym_co_return] = ACTIONS(2809),
    [anon_sym_co_yield] = ACTIONS(2809),
    [anon_sym_R_DQUOTE] = ACTIONS(2811),
    [anon_sym_LR_DQUOTE] = ACTIONS(2811),
    [anon_sym_uR_DQUOTE] = ACTIONS(2811),
    [anon_sym_UR_DQUOTE] = ACTIONS(2811),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2811),
    [anon_sym_co_await] = ACTIONS(2809),
    [anon_sym_new] = ACTIONS(2809),
    [anon_sym_requires] = ACTIONS(2809),
    [sym_this] = ACTIONS(2809),
  },
  [761] = {
    [sym_catch_clause] = STATE(368),
    [aux_sym_constructor_try_statement_repeat1] = STATE(368),
    [ts_builtin_sym_end] = ACTIONS(2494),
    [sym_identifier] = ACTIONS(2492),
    [aux_sym_preproc_include_token1] = ACTIONS(2492),
    [aux_sym_preproc_def_token1] = ACTIONS(2492),
    [aux_sym_preproc_if_token1] = ACTIONS(2492),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2492),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2492),
    [sym_preproc_directive] = ACTIONS(2492),
    [anon_sym_LPAREN2] = ACTIONS(2494),
    [anon_sym_BANG] = ACTIONS(2494),
    [anon_sym_TILDE] = ACTIONS(2494),
    [anon_sym_DASH] = ACTIONS(2492),
    [anon_sym_PLUS] = ACTIONS(2492),
    [anon_sym_STAR] = ACTIONS(2494),
    [anon_sym_AMP_AMP] = ACTIONS(2494),
    [anon_sym_AMP] = ACTIONS(2492),
    [anon_sym___extension__] = ACTIONS(2492),
    [anon_sym_typedef] = ACTIONS(2492),
    [anon_sym_extern] = ACTIONS(2492),
    [anon_sym___attribute__] = ACTIONS(2492),
    [anon_sym_COLON_COLON] = ACTIONS(2494),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2494),
    [anon_sym___declspec] = ACTIONS(2492),
    [anon_sym___based] = ACTIONS(2492),
    [anon_sym___cdecl] = ACTIONS(2492),
    [anon_sym___clrcall] = ACTIONS(2492),
    [anon_sym___stdcall] = ACTIONS(2492),
    [anon_sym___fastcall] = ACTIONS(2492),
    [anon_sym___thiscall] = ACTIONS(2492),
    [anon_sym___vectorcall] = ACTIONS(2492),
    [anon_sym_LBRACE] = ACTIONS(2494),
    [anon_sym_signed] = ACTIONS(2492),
    [anon_sym_unsigned] = ACTIONS(2492),
    [anon_sym_long] = ACTIONS(2492),
    [anon_sym_short] = ACTIONS(2492),
    [anon_sym_LBRACK] = ACTIONS(2492),
    [anon_sym_static] = ACTIONS(2492),
    [anon_sym_register] = ACTIONS(2492),
    [anon_sym_inline] = ACTIONS(2492),
    [anon_sym___inline] = ACTIONS(2492),
    [anon_sym___inline__] = ACTIONS(2492),
    [anon_sym___forceinline] = ACTIONS(2492),
    [anon_sym_thread_local] = ACTIONS(2492),
    [anon_sym___thread] = ACTIONS(2492),
    [anon_sym_const] = ACTIONS(2492),
    [anon_sym_constexpr] = ACTIONS(2492),
    [anon_sym_volatile] = ACTIONS(2492),
    [anon_sym_restrict] = ACTIONS(2492),
    [anon_sym___restrict__] = ACTIONS(2492),
    [anon_sym__Atomic] = ACTIONS(2492),
    [anon_sym__Noreturn] = ACTIONS(2492),
    [anon_sym_noreturn] = ACTIONS(2492),
    [anon_sym_mutable] = ACTIONS(2492),
    [anon_sym_constinit] = ACTIONS(2492),
    [anon_sym_consteval] = ACTIONS(2492),
    [anon_sym_PROGMEM] = ACTIONS(2492),
    [aux_sym_primitive_type_token1] = ACTIONS(2492),
    [anon_sym_byte] = ACTIONS(2492),
    [anon_sym_word] = ACTIONS(2492),
    [anon_sym_enum] = ACTIONS(2492),
    [anon_sym_class] = ACTIONS(2492),
    [anon_sym_struct] = ACTIONS(2492),
    [anon_sym_union] = ACTIONS(2492),
    [anon_sym_if] = ACTIONS(2492),
    [anon_sym_switch] = ACTIONS(2492),
    [anon_sym_case] = ACTIONS(2492),
    [anon_sym_default] = ACTIONS(2492),
    [anon_sym_while] = ACTIONS(2492),
    [anon_sym_do] = ACTIONS(2492),
    [anon_sym_for] = ACTIONS(2492),
    [anon_sym_return] = ACTIONS(2492),
    [anon_sym_break] = ACTIONS(2492),
    [anon_sym_continue] = ACTIONS(2492),
    [anon_sym_goto] = ACTIONS(2492),
    [anon_sym_not] = ACTIONS(2492),
    [anon_sym_compl] = ACTIONS(2492),
    [anon_sym_DASH_DASH] = ACTIONS(2494),
    [anon_sym_PLUS_PLUS] = ACTIONS(2494),
    [anon_sym_sizeof] = ACTIONS(2492),
    [anon_sym___alignof__] = ACTIONS(2492),
    [anon_sym___alignof] = ACTIONS(2492),
    [anon_sym__alignof] = ACTIONS(2492),
    [anon_sym_alignof] = ACTIONS(2492),
    [anon_sym__Alignof] = ACTIONS(2492),
    [anon_sym_offsetof] = ACTIONS(2492),
    [anon_sym__Generic] = ACTIONS(2492),
    [anon_sym_asm] = ACTIONS(2492),
    [anon_sym___asm__] = ACTIONS(2492),
    [aux_sym_number_literal_token1] = ACTIONS(2494),
    [aux_sym_number_literal_token2] = ACTIONS(2492),
    [anon_sym_L_SQUOTE] = ACTIONS(2494),
    [anon_sym_u_SQUOTE] = ACTIONS(2494),
    [anon_sym_U_SQUOTE] = ACTIONS(2494),
    [anon_sym_u8_SQUOTE] = ACTIONS(2494),
    [anon_sym_SQUOTE] = ACTIONS(2494),
    [anon_sym_L_DQUOTE] = ACTIONS(2494),
    [anon_sym_u_DQUOTE] = ACTIONS(2494),
    [anon_sym_U_DQUOTE] = ACTIONS(2494),
    [anon_sym_u8_DQUOTE] = ACTIONS(2494),
    [anon_sym_DQUOTE] = ACTIONS(2494),
    [sym_true] = ACTIONS(2492),
    [sym_false] = ACTIONS(2492),
    [anon_sym_NULL] = ACTIONS(2492),
    [anon_sym_nullptr] = ACTIONS(2492),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2492),
    [anon_sym_decltype] = ACTIONS(2492),
    [anon_sym_virtual] = ACTIONS(2492),
    [anon_sym_alignas] = ACTIONS(2492),
    [anon_sym_explicit] = ACTIONS(2492),
    [anon_sym_typename] = ACTIONS(2492),
    [anon_sym_template] = ACTIONS(2492),
    [anon_sym_operator] = ACTIONS(2492),
    [anon_sym_try] = ACTIONS(2492),
    [anon_sym_delete] = ACTIONS(2492),
    [anon_sym_throw] = ACTIONS(2492),
    [anon_sym_namespace] = ACTIONS(2492),
    [anon_sym_using] = ACTIONS(2492),
    [anon_sym_static_assert] = ACTIONS(2492),
    [anon_sym_concept] = ACTIONS(2492),
    [anon_sym_co_return] = ACTIONS(2492),
    [anon_sym_co_yield] = ACTIONS(2492),
    [anon_sym_catch] = ACTIONS(2961),
    [anon_sym_R_DQUOTE] = ACTIONS(2494),
    [anon_sym_LR_DQUOTE] = ACTIONS(2494),
    [anon_sym_uR_DQUOTE] = ACTIONS(2494),
    [anon_sym_UR_DQUOTE] = ACTIONS(2494),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2494),
    [anon_sym_co_await] = ACTIONS(2492),
    [anon_sym_new] = ACTIONS(2492),
    [anon_sym_requires] = ACTIONS(2492),
    [sym_this] = ACTIONS(2492),
  },
  [762] = {
    [sym_identifier] = ACTIONS(3086),
    [aux_sym_preproc_include_token1] = ACTIONS(3086),
    [aux_sym_preproc_def_token1] = ACTIONS(3086),
    [aux_sym_preproc_if_token1] = ACTIONS(3086),
    [aux_sym_preproc_if_token2] = ACTIONS(3086),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3086),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3086),
    [sym_preproc_directive] = ACTIONS(3086),
    [anon_sym_LPAREN2] = ACTIONS(3088),
    [anon_sym_BANG] = ACTIONS(3088),
    [anon_sym_TILDE] = ACTIONS(3088),
    [anon_sym_DASH] = ACTIONS(3086),
    [anon_sym_PLUS] = ACTIONS(3086),
    [anon_sym_STAR] = ACTIONS(3088),
    [anon_sym_AMP_AMP] = ACTIONS(3088),
    [anon_sym_AMP] = ACTIONS(3086),
    [anon_sym_SEMI] = ACTIONS(3088),
    [anon_sym___extension__] = ACTIONS(3086),
    [anon_sym_typedef] = ACTIONS(3086),
    [anon_sym_extern] = ACTIONS(3086),
    [anon_sym___attribute__] = ACTIONS(3086),
    [anon_sym_COLON_COLON] = ACTIONS(3088),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3088),
    [anon_sym___declspec] = ACTIONS(3086),
    [anon_sym___based] = ACTIONS(3086),
    [anon_sym___cdecl] = ACTIONS(3086),
    [anon_sym___clrcall] = ACTIONS(3086),
    [anon_sym___stdcall] = ACTIONS(3086),
    [anon_sym___fastcall] = ACTIONS(3086),
    [anon_sym___thiscall] = ACTIONS(3086),
    [anon_sym___vectorcall] = ACTIONS(3086),
    [anon_sym_LBRACE] = ACTIONS(3088),
    [anon_sym_signed] = ACTIONS(3086),
    [anon_sym_unsigned] = ACTIONS(3086),
    [anon_sym_long] = ACTIONS(3086),
    [anon_sym_short] = ACTIONS(3086),
    [anon_sym_LBRACK] = ACTIONS(3086),
    [anon_sym_static] = ACTIONS(3086),
    [anon_sym_register] = ACTIONS(3086),
    [anon_sym_inline] = ACTIONS(3086),
    [anon_sym___inline] = ACTIONS(3086),
    [anon_sym___inline__] = ACTIONS(3086),
    [anon_sym___forceinline] = ACTIONS(3086),
    [anon_sym_thread_local] = ACTIONS(3086),
    [anon_sym___thread] = ACTIONS(3086),
    [anon_sym_const] = ACTIONS(3086),
    [anon_sym_constexpr] = ACTIONS(3086),
    [anon_sym_volatile] = ACTIONS(3086),
    [anon_sym_restrict] = ACTIONS(3086),
    [anon_sym___restrict__] = ACTIONS(3086),
    [anon_sym__Atomic] = ACTIONS(3086),
    [anon_sym__Noreturn] = ACTIONS(3086),
    [anon_sym_noreturn] = ACTIONS(3086),
    [anon_sym_mutable] = ACTIONS(3086),
    [anon_sym_constinit] = ACTIONS(3086),
    [anon_sym_consteval] = ACTIONS(3086),
    [anon_sym_PROGMEM] = ACTIONS(3086),
    [aux_sym_primitive_type_token1] = ACTIONS(3086),
    [anon_sym_byte] = ACTIONS(3086),
    [anon_sym_word] = ACTIONS(3086),
    [anon_sym_enum] = ACTIONS(3086),
    [anon_sym_class] = ACTIONS(3086),
    [anon_sym_struct] = ACTIONS(3086),
    [anon_sym_union] = ACTIONS(3086),
    [anon_sym_if] = ACTIONS(3086),
    [anon_sym_switch] = ACTIONS(3086),
    [anon_sym_case] = ACTIONS(3086),
    [anon_sym_default] = ACTIONS(3086),
    [anon_sym_while] = ACTIONS(3086),
    [anon_sym_do] = ACTIONS(3086),
    [anon_sym_for] = ACTIONS(3086),
    [anon_sym_return] = ACTIONS(3086),
    [anon_sym_break] = ACTIONS(3086),
    [anon_sym_continue] = ACTIONS(3086),
    [anon_sym_goto] = ACTIONS(3086),
    [anon_sym___try] = ACTIONS(3086),
    [anon_sym___leave] = ACTIONS(3086),
    [anon_sym_not] = ACTIONS(3086),
    [anon_sym_compl] = ACTIONS(3086),
    [anon_sym_DASH_DASH] = ACTIONS(3088),
    [anon_sym_PLUS_PLUS] = ACTIONS(3088),
    [anon_sym_sizeof] = ACTIONS(3086),
    [anon_sym___alignof__] = ACTIONS(3086),
    [anon_sym___alignof] = ACTIONS(3086),
    [anon_sym__alignof] = ACTIONS(3086),
    [anon_sym_alignof] = ACTIONS(3086),
    [anon_sym__Alignof] = ACTIONS(3086),
    [anon_sym_offsetof] = ACTIONS(3086),
    [anon_sym__Generic] = ACTIONS(3086),
    [anon_sym_asm] = ACTIONS(3086),
    [anon_sym___asm__] = ACTIONS(3086),
    [aux_sym_number_literal_token1] = ACTIONS(3088),
    [aux_sym_number_literal_token2] = ACTIONS(3086),
    [anon_sym_L_SQUOTE] = ACTIONS(3088),
    [anon_sym_u_SQUOTE] = ACTIONS(3088),
    [anon_sym_U_SQUOTE] = ACTIONS(3088),
    [anon_sym_u8_SQUOTE] = ACTIONS(3088),
    [anon_sym_SQUOTE] = ACTIONS(3088),
    [anon_sym_L_DQUOTE] = ACTIONS(3088),
    [anon_sym_u_DQUOTE] = ACTIONS(3088),
    [anon_sym_U_DQUOTE] = ACTIONS(3088),
    [anon_sym_u8_DQUOTE] = ACTIONS(3088),
    [anon_sym_DQUOTE] = ACTIONS(3088),
    [sym_true] = ACTIONS(3086),
    [sym_false] = ACTIONS(3086),
    [anon_sym_NULL] = ACTIONS(3086),
    [anon_sym_nullptr] = ACTIONS(3086),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3086),
    [anon_sym_decltype] = ACTIONS(3086),
    [anon_sym_virtual] = ACTIONS(3086),
    [anon_sym_alignas] = ACTIONS(3086),
    [anon_sym_explicit] = ACTIONS(3086),
    [anon_sym_typename] = ACTIONS(3086),
    [anon_sym_template] = ACTIONS(3086),
    [anon_sym_operator] = ACTIONS(3086),
    [anon_sym_try] = ACTIONS(3086),
    [anon_sym_delete] = ACTIONS(3086),
    [anon_sym_throw] = ACTIONS(3086),
    [anon_sym_namespace] = ACTIONS(3086),
    [anon_sym_using] = ACTIONS(3086),
    [anon_sym_static_assert] = ACTIONS(3086),
    [anon_sym_concept] = ACTIONS(3086),
    [anon_sym_co_return] = ACTIONS(3086),
    [anon_sym_co_yield] = ACTIONS(3086),
    [anon_sym_R_DQUOTE] = ACTIONS(3088),
    [anon_sym_LR_DQUOTE] = ACTIONS(3088),
    [anon_sym_uR_DQUOTE] = ACTIONS(3088),
    [anon_sym_UR_DQUOTE] = ACTIONS(3088),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3088),
    [anon_sym_co_await] = ACTIONS(3086),
    [anon_sym_new] = ACTIONS(3086),
    [anon_sym_requires] = ACTIONS(3086),
    [sym_this] = ACTIONS(3086),
  },
  [763] = {
    [sym_identifier] = ACTIONS(2885),
    [aux_sym_preproc_include_token1] = ACTIONS(2885),
    [aux_sym_preproc_def_token1] = ACTIONS(2885),
    [aux_sym_preproc_if_token1] = ACTIONS(2885),
    [aux_sym_preproc_if_token2] = ACTIONS(2885),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2885),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2885),
    [sym_preproc_directive] = ACTIONS(2885),
    [anon_sym_LPAREN2] = ACTIONS(2887),
    [anon_sym_BANG] = ACTIONS(2887),
    [anon_sym_TILDE] = ACTIONS(2887),
    [anon_sym_DASH] = ACTIONS(2885),
    [anon_sym_PLUS] = ACTIONS(2885),
    [anon_sym_STAR] = ACTIONS(2887),
    [anon_sym_AMP_AMP] = ACTIONS(2887),
    [anon_sym_AMP] = ACTIONS(2885),
    [anon_sym_SEMI] = ACTIONS(2887),
    [anon_sym___extension__] = ACTIONS(2885),
    [anon_sym_typedef] = ACTIONS(2885),
    [anon_sym_extern] = ACTIONS(2885),
    [anon_sym___attribute__] = ACTIONS(2885),
    [anon_sym_COLON_COLON] = ACTIONS(2887),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2887),
    [anon_sym___declspec] = ACTIONS(2885),
    [anon_sym___based] = ACTIONS(2885),
    [anon_sym___cdecl] = ACTIONS(2885),
    [anon_sym___clrcall] = ACTIONS(2885),
    [anon_sym___stdcall] = ACTIONS(2885),
    [anon_sym___fastcall] = ACTIONS(2885),
    [anon_sym___thiscall] = ACTIONS(2885),
    [anon_sym___vectorcall] = ACTIONS(2885),
    [anon_sym_LBRACE] = ACTIONS(2887),
    [anon_sym_signed] = ACTIONS(2885),
    [anon_sym_unsigned] = ACTIONS(2885),
    [anon_sym_long] = ACTIONS(2885),
    [anon_sym_short] = ACTIONS(2885),
    [anon_sym_LBRACK] = ACTIONS(2885),
    [anon_sym_static] = ACTIONS(2885),
    [anon_sym_register] = ACTIONS(2885),
    [anon_sym_inline] = ACTIONS(2885),
    [anon_sym___inline] = ACTIONS(2885),
    [anon_sym___inline__] = ACTIONS(2885),
    [anon_sym___forceinline] = ACTIONS(2885),
    [anon_sym_thread_local] = ACTIONS(2885),
    [anon_sym___thread] = ACTIONS(2885),
    [anon_sym_const] = ACTIONS(2885),
    [anon_sym_constexpr] = ACTIONS(2885),
    [anon_sym_volatile] = ACTIONS(2885),
    [anon_sym_restrict] = ACTIONS(2885),
    [anon_sym___restrict__] = ACTIONS(2885),
    [anon_sym__Atomic] = ACTIONS(2885),
    [anon_sym__Noreturn] = ACTIONS(2885),
    [anon_sym_noreturn] = ACTIONS(2885),
    [anon_sym_mutable] = ACTIONS(2885),
    [anon_sym_constinit] = ACTIONS(2885),
    [anon_sym_consteval] = ACTIONS(2885),
    [anon_sym_PROGMEM] = ACTIONS(2885),
    [aux_sym_primitive_type_token1] = ACTIONS(2885),
    [anon_sym_byte] = ACTIONS(2885),
    [anon_sym_word] = ACTIONS(2885),
    [anon_sym_enum] = ACTIONS(2885),
    [anon_sym_class] = ACTIONS(2885),
    [anon_sym_struct] = ACTIONS(2885),
    [anon_sym_union] = ACTIONS(2885),
    [anon_sym_if] = ACTIONS(2885),
    [anon_sym_switch] = ACTIONS(2885),
    [anon_sym_case] = ACTIONS(2885),
    [anon_sym_default] = ACTIONS(2885),
    [anon_sym_while] = ACTIONS(2885),
    [anon_sym_do] = ACTIONS(2885),
    [anon_sym_for] = ACTIONS(2885),
    [anon_sym_return] = ACTIONS(2885),
    [anon_sym_break] = ACTIONS(2885),
    [anon_sym_continue] = ACTIONS(2885),
    [anon_sym_goto] = ACTIONS(2885),
    [anon_sym___try] = ACTIONS(2885),
    [anon_sym___leave] = ACTIONS(2885),
    [anon_sym_not] = ACTIONS(2885),
    [anon_sym_compl] = ACTIONS(2885),
    [anon_sym_DASH_DASH] = ACTIONS(2887),
    [anon_sym_PLUS_PLUS] = ACTIONS(2887),
    [anon_sym_sizeof] = ACTIONS(2885),
    [anon_sym___alignof__] = ACTIONS(2885),
    [anon_sym___alignof] = ACTIONS(2885),
    [anon_sym__alignof] = ACTIONS(2885),
    [anon_sym_alignof] = ACTIONS(2885),
    [anon_sym__Alignof] = ACTIONS(2885),
    [anon_sym_offsetof] = ACTIONS(2885),
    [anon_sym__Generic] = ACTIONS(2885),
    [anon_sym_asm] = ACTIONS(2885),
    [anon_sym___asm__] = ACTIONS(2885),
    [aux_sym_number_literal_token1] = ACTIONS(2887),
    [aux_sym_number_literal_token2] = ACTIONS(2885),
    [anon_sym_L_SQUOTE] = ACTIONS(2887),
    [anon_sym_u_SQUOTE] = ACTIONS(2887),
    [anon_sym_U_SQUOTE] = ACTIONS(2887),
    [anon_sym_u8_SQUOTE] = ACTIONS(2887),
    [anon_sym_SQUOTE] = ACTIONS(2887),
    [anon_sym_L_DQUOTE] = ACTIONS(2887),
    [anon_sym_u_DQUOTE] = ACTIONS(2887),
    [anon_sym_U_DQUOTE] = ACTIONS(2887),
    [anon_sym_u8_DQUOTE] = ACTIONS(2887),
    [anon_sym_DQUOTE] = ACTIONS(2887),
    [sym_true] = ACTIONS(2885),
    [sym_false] = ACTIONS(2885),
    [anon_sym_NULL] = ACTIONS(2885),
    [anon_sym_nullptr] = ACTIONS(2885),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2885),
    [anon_sym_decltype] = ACTIONS(2885),
    [anon_sym_virtual] = ACTIONS(2885),
    [anon_sym_alignas] = ACTIONS(2885),
    [anon_sym_explicit] = ACTIONS(2885),
    [anon_sym_typename] = ACTIONS(2885),
    [anon_sym_template] = ACTIONS(2885),
    [anon_sym_operator] = ACTIONS(2885),
    [anon_sym_try] = ACTIONS(2885),
    [anon_sym_delete] = ACTIONS(2885),
    [anon_sym_throw] = ACTIONS(2885),
    [anon_sym_namespace] = ACTIONS(2885),
    [anon_sym_using] = ACTIONS(2885),
    [anon_sym_static_assert] = ACTIONS(2885),
    [anon_sym_concept] = ACTIONS(2885),
    [anon_sym_co_return] = ACTIONS(2885),
    [anon_sym_co_yield] = ACTIONS(2885),
    [anon_sym_R_DQUOTE] = ACTIONS(2887),
    [anon_sym_LR_DQUOTE] = ACTIONS(2887),
    [anon_sym_uR_DQUOTE] = ACTIONS(2887),
    [anon_sym_UR_DQUOTE] = ACTIONS(2887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2887),
    [anon_sym_co_await] = ACTIONS(2885),
    [anon_sym_new] = ACTIONS(2885),
    [anon_sym_requires] = ACTIONS(2885),
    [sym_this] = ACTIONS(2885),
  },
  [764] = {
    [sym_identifier] = ACTIONS(2967),
    [aux_sym_preproc_include_token1] = ACTIONS(2967),
    [aux_sym_preproc_def_token1] = ACTIONS(2967),
    [aux_sym_preproc_if_token1] = ACTIONS(2967),
    [aux_sym_preproc_if_token2] = ACTIONS(2967),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2967),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2967),
    [sym_preproc_directive] = ACTIONS(2967),
    [anon_sym_LPAREN2] = ACTIONS(2969),
    [anon_sym_BANG] = ACTIONS(2969),
    [anon_sym_TILDE] = ACTIONS(2969),
    [anon_sym_DASH] = ACTIONS(2967),
    [anon_sym_PLUS] = ACTIONS(2967),
    [anon_sym_STAR] = ACTIONS(2969),
    [anon_sym_AMP_AMP] = ACTIONS(2969),
    [anon_sym_AMP] = ACTIONS(2967),
    [anon_sym_SEMI] = ACTIONS(2969),
    [anon_sym___extension__] = ACTIONS(2967),
    [anon_sym_typedef] = ACTIONS(2967),
    [anon_sym_extern] = ACTIONS(2967),
    [anon_sym___attribute__] = ACTIONS(2967),
    [anon_sym_COLON_COLON] = ACTIONS(2969),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2969),
    [anon_sym___declspec] = ACTIONS(2967),
    [anon_sym___based] = ACTIONS(2967),
    [anon_sym___cdecl] = ACTIONS(2967),
    [anon_sym___clrcall] = ACTIONS(2967),
    [anon_sym___stdcall] = ACTIONS(2967),
    [anon_sym___fastcall] = ACTIONS(2967),
    [anon_sym___thiscall] = ACTIONS(2967),
    [anon_sym___vectorcall] = ACTIONS(2967),
    [anon_sym_LBRACE] = ACTIONS(2969),
    [anon_sym_signed] = ACTIONS(2967),
    [anon_sym_unsigned] = ACTIONS(2967),
    [anon_sym_long] = ACTIONS(2967),
    [anon_sym_short] = ACTIONS(2967),
    [anon_sym_LBRACK] = ACTIONS(2967),
    [anon_sym_static] = ACTIONS(2967),
    [anon_sym_register] = ACTIONS(2967),
    [anon_sym_inline] = ACTIONS(2967),
    [anon_sym___inline] = ACTIONS(2967),
    [anon_sym___inline__] = ACTIONS(2967),
    [anon_sym___forceinline] = ACTIONS(2967),
    [anon_sym_thread_local] = ACTIONS(2967),
    [anon_sym___thread] = ACTIONS(2967),
    [anon_sym_const] = ACTIONS(2967),
    [anon_sym_constexpr] = ACTIONS(2967),
    [anon_sym_volatile] = ACTIONS(2967),
    [anon_sym_restrict] = ACTIONS(2967),
    [anon_sym___restrict__] = ACTIONS(2967),
    [anon_sym__Atomic] = ACTIONS(2967),
    [anon_sym__Noreturn] = ACTIONS(2967),
    [anon_sym_noreturn] = ACTIONS(2967),
    [anon_sym_mutable] = ACTIONS(2967),
    [anon_sym_constinit] = ACTIONS(2967),
    [anon_sym_consteval] = ACTIONS(2967),
    [anon_sym_PROGMEM] = ACTIONS(2967),
    [aux_sym_primitive_type_token1] = ACTIONS(2967),
    [anon_sym_byte] = ACTIONS(2967),
    [anon_sym_word] = ACTIONS(2967),
    [anon_sym_enum] = ACTIONS(2967),
    [anon_sym_class] = ACTIONS(2967),
    [anon_sym_struct] = ACTIONS(2967),
    [anon_sym_union] = ACTIONS(2967),
    [anon_sym_if] = ACTIONS(2967),
    [anon_sym_switch] = ACTIONS(2967),
    [anon_sym_case] = ACTIONS(2967),
    [anon_sym_default] = ACTIONS(2967),
    [anon_sym_while] = ACTIONS(2967),
    [anon_sym_do] = ACTIONS(2967),
    [anon_sym_for] = ACTIONS(2967),
    [anon_sym_return] = ACTIONS(2967),
    [anon_sym_break] = ACTIONS(2967),
    [anon_sym_continue] = ACTIONS(2967),
    [anon_sym_goto] = ACTIONS(2967),
    [anon_sym___try] = ACTIONS(2967),
    [anon_sym___leave] = ACTIONS(2967),
    [anon_sym_not] = ACTIONS(2967),
    [anon_sym_compl] = ACTIONS(2967),
    [anon_sym_DASH_DASH] = ACTIONS(2969),
    [anon_sym_PLUS_PLUS] = ACTIONS(2969),
    [anon_sym_sizeof] = ACTIONS(2967),
    [anon_sym___alignof__] = ACTIONS(2967),
    [anon_sym___alignof] = ACTIONS(2967),
    [anon_sym__alignof] = ACTIONS(2967),
    [anon_sym_alignof] = ACTIONS(2967),
    [anon_sym__Alignof] = ACTIONS(2967),
    [anon_sym_offsetof] = ACTIONS(2967),
    [anon_sym__Generic] = ACTIONS(2967),
    [anon_sym_asm] = ACTIONS(2967),
    [anon_sym___asm__] = ACTIONS(2967),
    [aux_sym_number_literal_token1] = ACTIONS(2969),
    [aux_sym_number_literal_token2] = ACTIONS(2967),
    [anon_sym_L_SQUOTE] = ACTIONS(2969),
    [anon_sym_u_SQUOTE] = ACTIONS(2969),
    [anon_sym_U_SQUOTE] = ACTIONS(2969),
    [anon_sym_u8_SQUOTE] = ACTIONS(2969),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_L_DQUOTE] = ACTIONS(2969),
    [anon_sym_u_DQUOTE] = ACTIONS(2969),
    [anon_sym_U_DQUOTE] = ACTIONS(2969),
    [anon_sym_u8_DQUOTE] = ACTIONS(2969),
    [anon_sym_DQUOTE] = ACTIONS(2969),
    [sym_true] = ACTIONS(2967),
    [sym_false] = ACTIONS(2967),
    [anon_sym_NULL] = ACTIONS(2967),
    [anon_sym_nullptr] = ACTIONS(2967),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2967),
    [anon_sym_decltype] = ACTIONS(2967),
    [anon_sym_virtual] = ACTIONS(2967),
    [anon_sym_alignas] = ACTIONS(2967),
    [anon_sym_explicit] = ACTIONS(2967),
    [anon_sym_typename] = ACTIONS(2967),
    [anon_sym_template] = ACTIONS(2967),
    [anon_sym_operator] = ACTIONS(2967),
    [anon_sym_try] = ACTIONS(2967),
    [anon_sym_delete] = ACTIONS(2967),
    [anon_sym_throw] = ACTIONS(2967),
    [anon_sym_namespace] = ACTIONS(2967),
    [anon_sym_using] = ACTIONS(2967),
    [anon_sym_static_assert] = ACTIONS(2967),
    [anon_sym_concept] = ACTIONS(2967),
    [anon_sym_co_return] = ACTIONS(2967),
    [anon_sym_co_yield] = ACTIONS(2967),
    [anon_sym_R_DQUOTE] = ACTIONS(2969),
    [anon_sym_LR_DQUOTE] = ACTIONS(2969),
    [anon_sym_uR_DQUOTE] = ACTIONS(2969),
    [anon_sym_UR_DQUOTE] = ACTIONS(2969),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2969),
    [anon_sym_co_await] = ACTIONS(2967),
    [anon_sym_new] = ACTIONS(2967),
    [anon_sym_requires] = ACTIONS(2967),
    [sym_this] = ACTIONS(2967),
  },
  [765] = {
    [sym_identifier] = ACTIONS(2979),
    [aux_sym_preproc_include_token1] = ACTIONS(2979),
    [aux_sym_preproc_def_token1] = ACTIONS(2979),
    [aux_sym_preproc_if_token1] = ACTIONS(2979),
    [aux_sym_preproc_if_token2] = ACTIONS(2979),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2979),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2979),
    [sym_preproc_directive] = ACTIONS(2979),
    [anon_sym_LPAREN2] = ACTIONS(2981),
    [anon_sym_BANG] = ACTIONS(2981),
    [anon_sym_TILDE] = ACTIONS(2981),
    [anon_sym_DASH] = ACTIONS(2979),
    [anon_sym_PLUS] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(2981),
    [anon_sym_AMP] = ACTIONS(2979),
    [anon_sym_SEMI] = ACTIONS(2981),
    [anon_sym___extension__] = ACTIONS(2979),
    [anon_sym_typedef] = ACTIONS(2979),
    [anon_sym_extern] = ACTIONS(2979),
    [anon_sym___attribute__] = ACTIONS(2979),
    [anon_sym_COLON_COLON] = ACTIONS(2981),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2981),
    [anon_sym___declspec] = ACTIONS(2979),
    [anon_sym___based] = ACTIONS(2979),
    [anon_sym___cdecl] = ACTIONS(2979),
    [anon_sym___clrcall] = ACTIONS(2979),
    [anon_sym___stdcall] = ACTIONS(2979),
    [anon_sym___fastcall] = ACTIONS(2979),
    [anon_sym___thiscall] = ACTIONS(2979),
    [anon_sym___vectorcall] = ACTIONS(2979),
    [anon_sym_LBRACE] = ACTIONS(2981),
    [anon_sym_signed] = ACTIONS(2979),
    [anon_sym_unsigned] = ACTIONS(2979),
    [anon_sym_long] = ACTIONS(2979),
    [anon_sym_short] = ACTIONS(2979),
    [anon_sym_LBRACK] = ACTIONS(2979),
    [anon_sym_static] = ACTIONS(2979),
    [anon_sym_register] = ACTIONS(2979),
    [anon_sym_inline] = ACTIONS(2979),
    [anon_sym___inline] = ACTIONS(2979),
    [anon_sym___inline__] = ACTIONS(2979),
    [anon_sym___forceinline] = ACTIONS(2979),
    [anon_sym_thread_local] = ACTIONS(2979),
    [anon_sym___thread] = ACTIONS(2979),
    [anon_sym_const] = ACTIONS(2979),
    [anon_sym_constexpr] = ACTIONS(2979),
    [anon_sym_volatile] = ACTIONS(2979),
    [anon_sym_restrict] = ACTIONS(2979),
    [anon_sym___restrict__] = ACTIONS(2979),
    [anon_sym__Atomic] = ACTIONS(2979),
    [anon_sym__Noreturn] = ACTIONS(2979),
    [anon_sym_noreturn] = ACTIONS(2979),
    [anon_sym_mutable] = ACTIONS(2979),
    [anon_sym_constinit] = ACTIONS(2979),
    [anon_sym_consteval] = ACTIONS(2979),
    [anon_sym_PROGMEM] = ACTIONS(2979),
    [aux_sym_primitive_type_token1] = ACTIONS(2979),
    [anon_sym_byte] = ACTIONS(2979),
    [anon_sym_word] = ACTIONS(2979),
    [anon_sym_enum] = ACTIONS(2979),
    [anon_sym_class] = ACTIONS(2979),
    [anon_sym_struct] = ACTIONS(2979),
    [anon_sym_union] = ACTIONS(2979),
    [anon_sym_if] = ACTIONS(2979),
    [anon_sym_switch] = ACTIONS(2979),
    [anon_sym_case] = ACTIONS(2979),
    [anon_sym_default] = ACTIONS(2979),
    [anon_sym_while] = ACTIONS(2979),
    [anon_sym_do] = ACTIONS(2979),
    [anon_sym_for] = ACTIONS(2979),
    [anon_sym_return] = ACTIONS(2979),
    [anon_sym_break] = ACTIONS(2979),
    [anon_sym_continue] = ACTIONS(2979),
    [anon_sym_goto] = ACTIONS(2979),
    [anon_sym___try] = ACTIONS(2979),
    [anon_sym___leave] = ACTIONS(2979),
    [anon_sym_not] = ACTIONS(2979),
    [anon_sym_compl] = ACTIONS(2979),
    [anon_sym_DASH_DASH] = ACTIONS(2981),
    [anon_sym_PLUS_PLUS] = ACTIONS(2981),
    [anon_sym_sizeof] = ACTIONS(2979),
    [anon_sym___alignof__] = ACTIONS(2979),
    [anon_sym___alignof] = ACTIONS(2979),
    [anon_sym__alignof] = ACTIONS(2979),
    [anon_sym_alignof] = ACTIONS(2979),
    [anon_sym__Alignof] = ACTIONS(2979),
    [anon_sym_offsetof] = ACTIONS(2979),
    [anon_sym__Generic] = ACTIONS(2979),
    [anon_sym_asm] = ACTIONS(2979),
    [anon_sym___asm__] = ACTIONS(2979),
    [aux_sym_number_literal_token1] = ACTIONS(2981),
    [aux_sym_number_literal_token2] = ACTIONS(2979),
    [anon_sym_L_SQUOTE] = ACTIONS(2981),
    [anon_sym_u_SQUOTE] = ACTIONS(2981),
    [anon_sym_U_SQUOTE] = ACTIONS(2981),
    [anon_sym_u8_SQUOTE] = ACTIONS(2981),
    [anon_sym_SQUOTE] = ACTIONS(2981),
    [anon_sym_L_DQUOTE] = ACTIONS(2981),
    [anon_sym_u_DQUOTE] = ACTIONS(2981),
    [anon_sym_U_DQUOTE] = ACTIONS(2981),
    [anon_sym_u8_DQUOTE] = ACTIONS(2981),
    [anon_sym_DQUOTE] = ACTIONS(2981),
    [sym_true] = ACTIONS(2979),
    [sym_false] = ACTIONS(2979),
    [anon_sym_NULL] = ACTIONS(2979),
    [anon_sym_nullptr] = ACTIONS(2979),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2979),
    [anon_sym_decltype] = ACTIONS(2979),
    [anon_sym_virtual] = ACTIONS(2979),
    [anon_sym_alignas] = ACTIONS(2979),
    [anon_sym_explicit] = ACTIONS(2979),
    [anon_sym_typename] = ACTIONS(2979),
    [anon_sym_template] = ACTIONS(2979),
    [anon_sym_operator] = ACTIONS(2979),
    [anon_sym_try] = ACTIONS(2979),
    [anon_sym_delete] = ACTIONS(2979),
    [anon_sym_throw] = ACTIONS(2979),
    [anon_sym_namespace] = ACTIONS(2979),
    [anon_sym_using] = ACTIONS(2979),
    [anon_sym_static_assert] = ACTIONS(2979),
    [anon_sym_concept] = ACTIONS(2979),
    [anon_sym_co_return] = ACTIONS(2979),
    [anon_sym_co_yield] = ACTIONS(2979),
    [anon_sym_R_DQUOTE] = ACTIONS(2981),
    [anon_sym_LR_DQUOTE] = ACTIONS(2981),
    [anon_sym_uR_DQUOTE] = ACTIONS(2981),
    [anon_sym_UR_DQUOTE] = ACTIONS(2981),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2981),
    [anon_sym_co_await] = ACTIONS(2979),
    [anon_sym_new] = ACTIONS(2979),
    [anon_sym_requires] = ACTIONS(2979),
    [sym_this] = ACTIONS(2979),
  },
  [766] = {
    [sym_identifier] = ACTIONS(3174),
    [aux_sym_preproc_include_token1] = ACTIONS(3174),
    [aux_sym_preproc_def_token1] = ACTIONS(3174),
    [aux_sym_preproc_if_token1] = ACTIONS(3174),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3174),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3174),
    [sym_preproc_directive] = ACTIONS(3174),
    [anon_sym_LPAREN2] = ACTIONS(3176),
    [anon_sym_BANG] = ACTIONS(3176),
    [anon_sym_TILDE] = ACTIONS(3176),
    [anon_sym_DASH] = ACTIONS(3174),
    [anon_sym_PLUS] = ACTIONS(3174),
    [anon_sym_STAR] = ACTIONS(3176),
    [anon_sym_AMP_AMP] = ACTIONS(3176),
    [anon_sym_AMP] = ACTIONS(3174),
    [anon_sym_SEMI] = ACTIONS(3176),
    [anon_sym___extension__] = ACTIONS(3174),
    [anon_sym_typedef] = ACTIONS(3174),
    [anon_sym_extern] = ACTIONS(3174),
    [anon_sym___attribute__] = ACTIONS(3174),
    [anon_sym_COLON_COLON] = ACTIONS(3176),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3176),
    [anon_sym___declspec] = ACTIONS(3174),
    [anon_sym___based] = ACTIONS(3174),
    [anon_sym___cdecl] = ACTIONS(3174),
    [anon_sym___clrcall] = ACTIONS(3174),
    [anon_sym___stdcall] = ACTIONS(3174),
    [anon_sym___fastcall] = ACTIONS(3174),
    [anon_sym___thiscall] = ACTIONS(3174),
    [anon_sym___vectorcall] = ACTIONS(3174),
    [anon_sym_LBRACE] = ACTIONS(3176),
    [anon_sym_RBRACE] = ACTIONS(3176),
    [anon_sym_signed] = ACTIONS(3174),
    [anon_sym_unsigned] = ACTIONS(3174),
    [anon_sym_long] = ACTIONS(3174),
    [anon_sym_short] = ACTIONS(3174),
    [anon_sym_LBRACK] = ACTIONS(3174),
    [anon_sym_static] = ACTIONS(3174),
    [anon_sym_register] = ACTIONS(3174),
    [anon_sym_inline] = ACTIONS(3174),
    [anon_sym___inline] = ACTIONS(3174),
    [anon_sym___inline__] = ACTIONS(3174),
    [anon_sym___forceinline] = ACTIONS(3174),
    [anon_sym_thread_local] = ACTIONS(3174),
    [anon_sym___thread] = ACTIONS(3174),
    [anon_sym_const] = ACTIONS(3174),
    [anon_sym_constexpr] = ACTIONS(3174),
    [anon_sym_volatile] = ACTIONS(3174),
    [anon_sym_restrict] = ACTIONS(3174),
    [anon_sym___restrict__] = ACTIONS(3174),
    [anon_sym__Atomic] = ACTIONS(3174),
    [anon_sym__Noreturn] = ACTIONS(3174),
    [anon_sym_noreturn] = ACTIONS(3174),
    [anon_sym_mutable] = ACTIONS(3174),
    [anon_sym_constinit] = ACTIONS(3174),
    [anon_sym_consteval] = ACTIONS(3174),
    [anon_sym_PROGMEM] = ACTIONS(3174),
    [aux_sym_primitive_type_token1] = ACTIONS(3174),
    [anon_sym_byte] = ACTIONS(3174),
    [anon_sym_word] = ACTIONS(3174),
    [anon_sym_enum] = ACTIONS(3174),
    [anon_sym_class] = ACTIONS(3174),
    [anon_sym_struct] = ACTIONS(3174),
    [anon_sym_union] = ACTIONS(3174),
    [anon_sym_if] = ACTIONS(3174),
    [anon_sym_switch] = ACTIONS(3174),
    [anon_sym_case] = ACTIONS(3174),
    [anon_sym_default] = ACTIONS(3174),
    [anon_sym_while] = ACTIONS(3174),
    [anon_sym_do] = ACTIONS(3174),
    [anon_sym_for] = ACTIONS(3174),
    [anon_sym_return] = ACTIONS(3174),
    [anon_sym_break] = ACTIONS(3174),
    [anon_sym_continue] = ACTIONS(3174),
    [anon_sym_goto] = ACTIONS(3174),
    [anon_sym___try] = ACTIONS(3174),
    [anon_sym___leave] = ACTIONS(3174),
    [anon_sym_not] = ACTIONS(3174),
    [anon_sym_compl] = ACTIONS(3174),
    [anon_sym_DASH_DASH] = ACTIONS(3176),
    [anon_sym_PLUS_PLUS] = ACTIONS(3176),
    [anon_sym_sizeof] = ACTIONS(3174),
    [anon_sym___alignof__] = ACTIONS(3174),
    [anon_sym___alignof] = ACTIONS(3174),
    [anon_sym__alignof] = ACTIONS(3174),
    [anon_sym_alignof] = ACTIONS(3174),
    [anon_sym__Alignof] = ACTIONS(3174),
    [anon_sym_offsetof] = ACTIONS(3174),
    [anon_sym__Generic] = ACTIONS(3174),
    [anon_sym_asm] = ACTIONS(3174),
    [anon_sym___asm__] = ACTIONS(3174),
    [aux_sym_number_literal_token1] = ACTIONS(3176),
    [aux_sym_number_literal_token2] = ACTIONS(3174),
    [anon_sym_L_SQUOTE] = ACTIONS(3176),
    [anon_sym_u_SQUOTE] = ACTIONS(3176),
    [anon_sym_U_SQUOTE] = ACTIONS(3176),
    [anon_sym_u8_SQUOTE] = ACTIONS(3176),
    [anon_sym_SQUOTE] = ACTIONS(3176),
    [anon_sym_L_DQUOTE] = ACTIONS(3176),
    [anon_sym_u_DQUOTE] = ACTIONS(3176),
    [anon_sym_U_DQUOTE] = ACTIONS(3176),
    [anon_sym_u8_DQUOTE] = ACTIONS(3176),
    [anon_sym_DQUOTE] = ACTIONS(3176),
    [sym_true] = ACTIONS(3174),
    [sym_false] = ACTIONS(3174),
    [anon_sym_NULL] = ACTIONS(3174),
    [anon_sym_nullptr] = ACTIONS(3174),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3174),
    [anon_sym_decltype] = ACTIONS(3174),
    [anon_sym_virtual] = ACTIONS(3174),
    [anon_sym_alignas] = ACTIONS(3174),
    [anon_sym_explicit] = ACTIONS(3174),
    [anon_sym_typename] = ACTIONS(3174),
    [anon_sym_template] = ACTIONS(3174),
    [anon_sym_operator] = ACTIONS(3174),
    [anon_sym_try] = ACTIONS(3174),
    [anon_sym_delete] = ACTIONS(3174),
    [anon_sym_throw] = ACTIONS(3174),
    [anon_sym_namespace] = ACTIONS(3174),
    [anon_sym_using] = ACTIONS(3174),
    [anon_sym_static_assert] = ACTIONS(3174),
    [anon_sym_concept] = ACTIONS(3174),
    [anon_sym_co_return] = ACTIONS(3174),
    [anon_sym_co_yield] = ACTIONS(3174),
    [anon_sym_R_DQUOTE] = ACTIONS(3176),
    [anon_sym_LR_DQUOTE] = ACTIONS(3176),
    [anon_sym_uR_DQUOTE] = ACTIONS(3176),
    [anon_sym_UR_DQUOTE] = ACTIONS(3176),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3176),
    [anon_sym_co_await] = ACTIONS(3174),
    [anon_sym_new] = ACTIONS(3174),
    [anon_sym_requires] = ACTIONS(3174),
    [sym_this] = ACTIONS(3174),
  },
  [767] = {
    [sym_identifier] = ACTIONS(3024),
    [aux_sym_preproc_include_token1] = ACTIONS(3024),
    [aux_sym_preproc_def_token1] = ACTIONS(3024),
    [aux_sym_preproc_if_token1] = ACTIONS(3024),
    [aux_sym_preproc_if_token2] = ACTIONS(3024),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3024),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3024),
    [sym_preproc_directive] = ACTIONS(3024),
    [anon_sym_LPAREN2] = ACTIONS(3026),
    [anon_sym_BANG] = ACTIONS(3026),
    [anon_sym_TILDE] = ACTIONS(3026),
    [anon_sym_DASH] = ACTIONS(3024),
    [anon_sym_PLUS] = ACTIONS(3024),
    [anon_sym_STAR] = ACTIONS(3026),
    [anon_sym_AMP_AMP] = ACTIONS(3026),
    [anon_sym_AMP] = ACTIONS(3024),
    [anon_sym_SEMI] = ACTIONS(3026),
    [anon_sym___extension__] = ACTIONS(3024),
    [anon_sym_typedef] = ACTIONS(3024),
    [anon_sym_extern] = ACTIONS(3024),
    [anon_sym___attribute__] = ACTIONS(3024),
    [anon_sym_COLON_COLON] = ACTIONS(3026),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3026),
    [anon_sym___declspec] = ACTIONS(3024),
    [anon_sym___based] = ACTIONS(3024),
    [anon_sym___cdecl] = ACTIONS(3024),
    [anon_sym___clrcall] = ACTIONS(3024),
    [anon_sym___stdcall] = ACTIONS(3024),
    [anon_sym___fastcall] = ACTIONS(3024),
    [anon_sym___thiscall] = ACTIONS(3024),
    [anon_sym___vectorcall] = ACTIONS(3024),
    [anon_sym_LBRACE] = ACTIONS(3026),
    [anon_sym_signed] = ACTIONS(3024),
    [anon_sym_unsigned] = ACTIONS(3024),
    [anon_sym_long] = ACTIONS(3024),
    [anon_sym_short] = ACTIONS(3024),
    [anon_sym_LBRACK] = ACTIONS(3024),
    [anon_sym_static] = ACTIONS(3024),
    [anon_sym_register] = ACTIONS(3024),
    [anon_sym_inline] = ACTIONS(3024),
    [anon_sym___inline] = ACTIONS(3024),
    [anon_sym___inline__] = ACTIONS(3024),
    [anon_sym___forceinline] = ACTIONS(3024),
    [anon_sym_thread_local] = ACTIONS(3024),
    [anon_sym___thread] = ACTIONS(3024),
    [anon_sym_const] = ACTIONS(3024),
    [anon_sym_constexpr] = ACTIONS(3024),
    [anon_sym_volatile] = ACTIONS(3024),
    [anon_sym_restrict] = ACTIONS(3024),
    [anon_sym___restrict__] = ACTIONS(3024),
    [anon_sym__Atomic] = ACTIONS(3024),
    [anon_sym__Noreturn] = ACTIONS(3024),
    [anon_sym_noreturn] = ACTIONS(3024),
    [anon_sym_mutable] = ACTIONS(3024),
    [anon_sym_constinit] = ACTIONS(3024),
    [anon_sym_consteval] = ACTIONS(3024),
    [anon_sym_PROGMEM] = ACTIONS(3024),
    [aux_sym_primitive_type_token1] = ACTIONS(3024),
    [anon_sym_byte] = ACTIONS(3024),
    [anon_sym_word] = ACTIONS(3024),
    [anon_sym_enum] = ACTIONS(3024),
    [anon_sym_class] = ACTIONS(3024),
    [anon_sym_struct] = ACTIONS(3024),
    [anon_sym_union] = ACTIONS(3024),
    [anon_sym_if] = ACTIONS(3024),
    [anon_sym_switch] = ACTIONS(3024),
    [anon_sym_case] = ACTIONS(3024),
    [anon_sym_default] = ACTIONS(3024),
    [anon_sym_while] = ACTIONS(3024),
    [anon_sym_do] = ACTIONS(3024),
    [anon_sym_for] = ACTIONS(3024),
    [anon_sym_return] = ACTIONS(3024),
    [anon_sym_break] = ACTIONS(3024),
    [anon_sym_continue] = ACTIONS(3024),
    [anon_sym_goto] = ACTIONS(3024),
    [anon_sym___try] = ACTIONS(3024),
    [anon_sym___leave] = ACTIONS(3024),
    [anon_sym_not] = ACTIONS(3024),
    [anon_sym_compl] = ACTIONS(3024),
    [anon_sym_DASH_DASH] = ACTIONS(3026),
    [anon_sym_PLUS_PLUS] = ACTIONS(3026),
    [anon_sym_sizeof] = ACTIONS(3024),
    [anon_sym___alignof__] = ACTIONS(3024),
    [anon_sym___alignof] = ACTIONS(3024),
    [anon_sym__alignof] = ACTIONS(3024),
    [anon_sym_alignof] = ACTIONS(3024),
    [anon_sym__Alignof] = ACTIONS(3024),
    [anon_sym_offsetof] = ACTIONS(3024),
    [anon_sym__Generic] = ACTIONS(3024),
    [anon_sym_asm] = ACTIONS(3024),
    [anon_sym___asm__] = ACTIONS(3024),
    [aux_sym_number_literal_token1] = ACTIONS(3026),
    [aux_sym_number_literal_token2] = ACTIONS(3024),
    [anon_sym_L_SQUOTE] = ACTIONS(3026),
    [anon_sym_u_SQUOTE] = ACTIONS(3026),
    [anon_sym_U_SQUOTE] = ACTIONS(3026),
    [anon_sym_u8_SQUOTE] = ACTIONS(3026),
    [anon_sym_SQUOTE] = ACTIONS(3026),
    [anon_sym_L_DQUOTE] = ACTIONS(3026),
    [anon_sym_u_DQUOTE] = ACTIONS(3026),
    [anon_sym_U_DQUOTE] = ACTIONS(3026),
    [anon_sym_u8_DQUOTE] = ACTIONS(3026),
    [anon_sym_DQUOTE] = ACTIONS(3026),
    [sym_true] = ACTIONS(3024),
    [sym_false] = ACTIONS(3024),
    [anon_sym_NULL] = ACTIONS(3024),
    [anon_sym_nullptr] = ACTIONS(3024),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3024),
    [anon_sym_decltype] = ACTIONS(3024),
    [anon_sym_virtual] = ACTIONS(3024),
    [anon_sym_alignas] = ACTIONS(3024),
    [anon_sym_explicit] = ACTIONS(3024),
    [anon_sym_typename] = ACTIONS(3024),
    [anon_sym_template] = ACTIONS(3024),
    [anon_sym_operator] = ACTIONS(3024),
    [anon_sym_try] = ACTIONS(3024),
    [anon_sym_delete] = ACTIONS(3024),
    [anon_sym_throw] = ACTIONS(3024),
    [anon_sym_namespace] = ACTIONS(3024),
    [anon_sym_using] = ACTIONS(3024),
    [anon_sym_static_assert] = ACTIONS(3024),
    [anon_sym_concept] = ACTIONS(3024),
    [anon_sym_co_return] = ACTIONS(3024),
    [anon_sym_co_yield] = ACTIONS(3024),
    [anon_sym_R_DQUOTE] = ACTIONS(3026),
    [anon_sym_LR_DQUOTE] = ACTIONS(3026),
    [anon_sym_uR_DQUOTE] = ACTIONS(3026),
    [anon_sym_UR_DQUOTE] = ACTIONS(3026),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3026),
    [anon_sym_co_await] = ACTIONS(3024),
    [anon_sym_new] = ACTIONS(3024),
    [anon_sym_requires] = ACTIONS(3024),
    [sym_this] = ACTIONS(3024),
  },
  [768] = {
    [sym_identifier] = ACTIONS(3028),
    [aux_sym_preproc_include_token1] = ACTIONS(3028),
    [aux_sym_preproc_def_token1] = ACTIONS(3028),
    [aux_sym_preproc_if_token1] = ACTIONS(3028),
    [aux_sym_preproc_if_token2] = ACTIONS(3028),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3028),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3028),
    [sym_preproc_directive] = ACTIONS(3028),
    [anon_sym_LPAREN2] = ACTIONS(3030),
    [anon_sym_BANG] = ACTIONS(3030),
    [anon_sym_TILDE] = ACTIONS(3030),
    [anon_sym_DASH] = ACTIONS(3028),
    [anon_sym_PLUS] = ACTIONS(3028),
    [anon_sym_STAR] = ACTIONS(3030),
    [anon_sym_AMP_AMP] = ACTIONS(3030),
    [anon_sym_AMP] = ACTIONS(3028),
    [anon_sym_SEMI] = ACTIONS(3030),
    [anon_sym___extension__] = ACTIONS(3028),
    [anon_sym_typedef] = ACTIONS(3028),
    [anon_sym_extern] = ACTIONS(3028),
    [anon_sym___attribute__] = ACTIONS(3028),
    [anon_sym_COLON_COLON] = ACTIONS(3030),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3030),
    [anon_sym___declspec] = ACTIONS(3028),
    [anon_sym___based] = ACTIONS(3028),
    [anon_sym___cdecl] = ACTIONS(3028),
    [anon_sym___clrcall] = ACTIONS(3028),
    [anon_sym___stdcall] = ACTIONS(3028),
    [anon_sym___fastcall] = ACTIONS(3028),
    [anon_sym___thiscall] = ACTIONS(3028),
    [anon_sym___vectorcall] = ACTIONS(3028),
    [anon_sym_LBRACE] = ACTIONS(3030),
    [anon_sym_signed] = ACTIONS(3028),
    [anon_sym_unsigned] = ACTIONS(3028),
    [anon_sym_long] = ACTIONS(3028),
    [anon_sym_short] = ACTIONS(3028),
    [anon_sym_LBRACK] = ACTIONS(3028),
    [anon_sym_static] = ACTIONS(3028),
    [anon_sym_register] = ACTIONS(3028),
    [anon_sym_inline] = ACTIONS(3028),
    [anon_sym___inline] = ACTIONS(3028),
    [anon_sym___inline__] = ACTIONS(3028),
    [anon_sym___forceinline] = ACTIONS(3028),
    [anon_sym_thread_local] = ACTIONS(3028),
    [anon_sym___thread] = ACTIONS(3028),
    [anon_sym_const] = ACTIONS(3028),
    [anon_sym_constexpr] = ACTIONS(3028),
    [anon_sym_volatile] = ACTIONS(3028),
    [anon_sym_restrict] = ACTIONS(3028),
    [anon_sym___restrict__] = ACTIONS(3028),
    [anon_sym__Atomic] = ACTIONS(3028),
    [anon_sym__Noreturn] = ACTIONS(3028),
    [anon_sym_noreturn] = ACTIONS(3028),
    [anon_sym_mutable] = ACTIONS(3028),
    [anon_sym_constinit] = ACTIONS(3028),
    [anon_sym_consteval] = ACTIONS(3028),
    [anon_sym_PROGMEM] = ACTIONS(3028),
    [aux_sym_primitive_type_token1] = ACTIONS(3028),
    [anon_sym_byte] = ACTIONS(3028),
    [anon_sym_word] = ACTIONS(3028),
    [anon_sym_enum] = ACTIONS(3028),
    [anon_sym_class] = ACTIONS(3028),
    [anon_sym_struct] = ACTIONS(3028),
    [anon_sym_union] = ACTIONS(3028),
    [anon_sym_if] = ACTIONS(3028),
    [anon_sym_switch] = ACTIONS(3028),
    [anon_sym_case] = ACTIONS(3028),
    [anon_sym_default] = ACTIONS(3028),
    [anon_sym_while] = ACTIONS(3028),
    [anon_sym_do] = ACTIONS(3028),
    [anon_sym_for] = ACTIONS(3028),
    [anon_sym_return] = ACTIONS(3028),
    [anon_sym_break] = ACTIONS(3028),
    [anon_sym_continue] = ACTIONS(3028),
    [anon_sym_goto] = ACTIONS(3028),
    [anon_sym___try] = ACTIONS(3028),
    [anon_sym___leave] = ACTIONS(3028),
    [anon_sym_not] = ACTIONS(3028),
    [anon_sym_compl] = ACTIONS(3028),
    [anon_sym_DASH_DASH] = ACTIONS(3030),
    [anon_sym_PLUS_PLUS] = ACTIONS(3030),
    [anon_sym_sizeof] = ACTIONS(3028),
    [anon_sym___alignof__] = ACTIONS(3028),
    [anon_sym___alignof] = ACTIONS(3028),
    [anon_sym__alignof] = ACTIONS(3028),
    [anon_sym_alignof] = ACTIONS(3028),
    [anon_sym__Alignof] = ACTIONS(3028),
    [anon_sym_offsetof] = ACTIONS(3028),
    [anon_sym__Generic] = ACTIONS(3028),
    [anon_sym_asm] = ACTIONS(3028),
    [anon_sym___asm__] = ACTIONS(3028),
    [aux_sym_number_literal_token1] = ACTIONS(3030),
    [aux_sym_number_literal_token2] = ACTIONS(3028),
    [anon_sym_L_SQUOTE] = ACTIONS(3030),
    [anon_sym_u_SQUOTE] = ACTIONS(3030),
    [anon_sym_U_SQUOTE] = ACTIONS(3030),
    [anon_sym_u8_SQUOTE] = ACTIONS(3030),
    [anon_sym_SQUOTE] = ACTIONS(3030),
    [anon_sym_L_DQUOTE] = ACTIONS(3030),
    [anon_sym_u_DQUOTE] = ACTIONS(3030),
    [anon_sym_U_DQUOTE] = ACTIONS(3030),
    [anon_sym_u8_DQUOTE] = ACTIONS(3030),
    [anon_sym_DQUOTE] = ACTIONS(3030),
    [sym_true] = ACTIONS(3028),
    [sym_false] = ACTIONS(3028),
    [anon_sym_NULL] = ACTIONS(3028),
    [anon_sym_nullptr] = ACTIONS(3028),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3028),
    [anon_sym_decltype] = ACTIONS(3028),
    [anon_sym_virtual] = ACTIONS(3028),
    [anon_sym_alignas] = ACTIONS(3028),
    [anon_sym_explicit] = ACTIONS(3028),
    [anon_sym_typename] = ACTIONS(3028),
    [anon_sym_template] = ACTIONS(3028),
    [anon_sym_operator] = ACTIONS(3028),
    [anon_sym_try] = ACTIONS(3028),
    [anon_sym_delete] = ACTIONS(3028),
    [anon_sym_throw] = ACTIONS(3028),
    [anon_sym_namespace] = ACTIONS(3028),
    [anon_sym_using] = ACTIONS(3028),
    [anon_sym_static_assert] = ACTIONS(3028),
    [anon_sym_concept] = ACTIONS(3028),
    [anon_sym_co_return] = ACTIONS(3028),
    [anon_sym_co_yield] = ACTIONS(3028),
    [anon_sym_R_DQUOTE] = ACTIONS(3030),
    [anon_sym_LR_DQUOTE] = ACTIONS(3030),
    [anon_sym_uR_DQUOTE] = ACTIONS(3030),
    [anon_sym_UR_DQUOTE] = ACTIONS(3030),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3030),
    [anon_sym_co_await] = ACTIONS(3028),
    [anon_sym_new] = ACTIONS(3028),
    [anon_sym_requires] = ACTIONS(3028),
    [sym_this] = ACTIONS(3028),
  },
  [769] = {
    [sym_identifier] = ACTIONS(3036),
    [aux_sym_preproc_include_token1] = ACTIONS(3036),
    [aux_sym_preproc_def_token1] = ACTIONS(3036),
    [aux_sym_preproc_if_token1] = ACTIONS(3036),
    [aux_sym_preproc_if_token2] = ACTIONS(3036),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3036),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3036),
    [sym_preproc_directive] = ACTIONS(3036),
    [anon_sym_LPAREN2] = ACTIONS(3038),
    [anon_sym_BANG] = ACTIONS(3038),
    [anon_sym_TILDE] = ACTIONS(3038),
    [anon_sym_DASH] = ACTIONS(3036),
    [anon_sym_PLUS] = ACTIONS(3036),
    [anon_sym_STAR] = ACTIONS(3038),
    [anon_sym_AMP_AMP] = ACTIONS(3038),
    [anon_sym_AMP] = ACTIONS(3036),
    [anon_sym_SEMI] = ACTIONS(3038),
    [anon_sym___extension__] = ACTIONS(3036),
    [anon_sym_typedef] = ACTIONS(3036),
    [anon_sym_extern] = ACTIONS(3036),
    [anon_sym___attribute__] = ACTIONS(3036),
    [anon_sym_COLON_COLON] = ACTIONS(3038),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3038),
    [anon_sym___declspec] = ACTIONS(3036),
    [anon_sym___based] = ACTIONS(3036),
    [anon_sym___cdecl] = ACTIONS(3036),
    [anon_sym___clrcall] = ACTIONS(3036),
    [anon_sym___stdcall] = ACTIONS(3036),
    [anon_sym___fastcall] = ACTIONS(3036),
    [anon_sym___thiscall] = ACTIONS(3036),
    [anon_sym___vectorcall] = ACTIONS(3036),
    [anon_sym_LBRACE] = ACTIONS(3038),
    [anon_sym_signed] = ACTIONS(3036),
    [anon_sym_unsigned] = ACTIONS(3036),
    [anon_sym_long] = ACTIONS(3036),
    [anon_sym_short] = ACTIONS(3036),
    [anon_sym_LBRACK] = ACTIONS(3036),
    [anon_sym_static] = ACTIONS(3036),
    [anon_sym_register] = ACTIONS(3036),
    [anon_sym_inline] = ACTIONS(3036),
    [anon_sym___inline] = ACTIONS(3036),
    [anon_sym___inline__] = ACTIONS(3036),
    [anon_sym___forceinline] = ACTIONS(3036),
    [anon_sym_thread_local] = ACTIONS(3036),
    [anon_sym___thread] = ACTIONS(3036),
    [anon_sym_const] = ACTIONS(3036),
    [anon_sym_constexpr] = ACTIONS(3036),
    [anon_sym_volatile] = ACTIONS(3036),
    [anon_sym_restrict] = ACTIONS(3036),
    [anon_sym___restrict__] = ACTIONS(3036),
    [anon_sym__Atomic] = ACTIONS(3036),
    [anon_sym__Noreturn] = ACTIONS(3036),
    [anon_sym_noreturn] = ACTIONS(3036),
    [anon_sym_mutable] = ACTIONS(3036),
    [anon_sym_constinit] = ACTIONS(3036),
    [anon_sym_consteval] = ACTIONS(3036),
    [anon_sym_PROGMEM] = ACTIONS(3036),
    [aux_sym_primitive_type_token1] = ACTIONS(3036),
    [anon_sym_byte] = ACTIONS(3036),
    [anon_sym_word] = ACTIONS(3036),
    [anon_sym_enum] = ACTIONS(3036),
    [anon_sym_class] = ACTIONS(3036),
    [anon_sym_struct] = ACTIONS(3036),
    [anon_sym_union] = ACTIONS(3036),
    [anon_sym_if] = ACTIONS(3036),
    [anon_sym_switch] = ACTIONS(3036),
    [anon_sym_case] = ACTIONS(3036),
    [anon_sym_default] = ACTIONS(3036),
    [anon_sym_while] = ACTIONS(3036),
    [anon_sym_do] = ACTIONS(3036),
    [anon_sym_for] = ACTIONS(3036),
    [anon_sym_return] = ACTIONS(3036),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_continue] = ACTIONS(3036),
    [anon_sym_goto] = ACTIONS(3036),
    [anon_sym___try] = ACTIONS(3036),
    [anon_sym___leave] = ACTIONS(3036),
    [anon_sym_not] = ACTIONS(3036),
    [anon_sym_compl] = ACTIONS(3036),
    [anon_sym_DASH_DASH] = ACTIONS(3038),
    [anon_sym_PLUS_PLUS] = ACTIONS(3038),
    [anon_sym_sizeof] = ACTIONS(3036),
    [anon_sym___alignof__] = ACTIONS(3036),
    [anon_sym___alignof] = ACTIONS(3036),
    [anon_sym__alignof] = ACTIONS(3036),
    [anon_sym_alignof] = ACTIONS(3036),
    [anon_sym__Alignof] = ACTIONS(3036),
    [anon_sym_offsetof] = ACTIONS(3036),
    [anon_sym__Generic] = ACTIONS(3036),
    [anon_sym_asm] = ACTIONS(3036),
    [anon_sym___asm__] = ACTIONS(3036),
    [aux_sym_number_literal_token1] = ACTIONS(3038),
    [aux_sym_number_literal_token2] = ACTIONS(3036),
    [anon_sym_L_SQUOTE] = ACTIONS(3038),
    [anon_sym_u_SQUOTE] = ACTIONS(3038),
    [anon_sym_U_SQUOTE] = ACTIONS(3038),
    [anon_sym_u8_SQUOTE] = ACTIONS(3038),
    [anon_sym_SQUOTE] = ACTIONS(3038),
    [anon_sym_L_DQUOTE] = ACTIONS(3038),
    [anon_sym_u_DQUOTE] = ACTIONS(3038),
    [anon_sym_U_DQUOTE] = ACTIONS(3038),
    [anon_sym_u8_DQUOTE] = ACTIONS(3038),
    [anon_sym_DQUOTE] = ACTIONS(3038),
    [sym_true] = ACTIONS(3036),
    [sym_false] = ACTIONS(3036),
    [anon_sym_NULL] = ACTIONS(3036),
    [anon_sym_nullptr] = ACTIONS(3036),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3036),
    [anon_sym_decltype] = ACTIONS(3036),
    [anon_sym_virtual] = ACTIONS(3036),
    [anon_sym_alignas] = ACTIONS(3036),
    [anon_sym_explicit] = ACTIONS(3036),
    [anon_sym_typename] = ACTIONS(3036),
    [anon_sym_template] = ACTIONS(3036),
    [anon_sym_operator] = ACTIONS(3036),
    [anon_sym_try] = ACTIONS(3036),
    [anon_sym_delete] = ACTIONS(3036),
    [anon_sym_throw] = ACTIONS(3036),
    [anon_sym_namespace] = ACTIONS(3036),
    [anon_sym_using] = ACTIONS(3036),
    [anon_sym_static_assert] = ACTIONS(3036),
    [anon_sym_concept] = ACTIONS(3036),
    [anon_sym_co_return] = ACTIONS(3036),
    [anon_sym_co_yield] = ACTIONS(3036),
    [anon_sym_R_DQUOTE] = ACTIONS(3038),
    [anon_sym_LR_DQUOTE] = ACTIONS(3038),
    [anon_sym_uR_DQUOTE] = ACTIONS(3038),
    [anon_sym_UR_DQUOTE] = ACTIONS(3038),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3038),
    [anon_sym_co_await] = ACTIONS(3036),
    [anon_sym_new] = ACTIONS(3036),
    [anon_sym_requires] = ACTIONS(3036),
    [sym_this] = ACTIONS(3036),
  },
  [770] = {
    [sym_identifier] = ACTIONS(3040),
    [aux_sym_preproc_include_token1] = ACTIONS(3040),
    [aux_sym_preproc_def_token1] = ACTIONS(3040),
    [aux_sym_preproc_if_token1] = ACTIONS(3040),
    [aux_sym_preproc_if_token2] = ACTIONS(3040),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3040),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3040),
    [sym_preproc_directive] = ACTIONS(3040),
    [anon_sym_LPAREN2] = ACTIONS(3042),
    [anon_sym_BANG] = ACTIONS(3042),
    [anon_sym_TILDE] = ACTIONS(3042),
    [anon_sym_DASH] = ACTIONS(3040),
    [anon_sym_PLUS] = ACTIONS(3040),
    [anon_sym_STAR] = ACTIONS(3042),
    [anon_sym_AMP_AMP] = ACTIONS(3042),
    [anon_sym_AMP] = ACTIONS(3040),
    [anon_sym_SEMI] = ACTIONS(3042),
    [anon_sym___extension__] = ACTIONS(3040),
    [anon_sym_typedef] = ACTIONS(3040),
    [anon_sym_extern] = ACTIONS(3040),
    [anon_sym___attribute__] = ACTIONS(3040),
    [anon_sym_COLON_COLON] = ACTIONS(3042),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3042),
    [anon_sym___declspec] = ACTIONS(3040),
    [anon_sym___based] = ACTIONS(3040),
    [anon_sym___cdecl] = ACTIONS(3040),
    [anon_sym___clrcall] = ACTIONS(3040),
    [anon_sym___stdcall] = ACTIONS(3040),
    [anon_sym___fastcall] = ACTIONS(3040),
    [anon_sym___thiscall] = ACTIONS(3040),
    [anon_sym___vectorcall] = ACTIONS(3040),
    [anon_sym_LBRACE] = ACTIONS(3042),
    [anon_sym_signed] = ACTIONS(3040),
    [anon_sym_unsigned] = ACTIONS(3040),
    [anon_sym_long] = ACTIONS(3040),
    [anon_sym_short] = ACTIONS(3040),
    [anon_sym_LBRACK] = ACTIONS(3040),
    [anon_sym_static] = ACTIONS(3040),
    [anon_sym_register] = ACTIONS(3040),
    [anon_sym_inline] = ACTIONS(3040),
    [anon_sym___inline] = ACTIONS(3040),
    [anon_sym___inline__] = ACTIONS(3040),
    [anon_sym___forceinline] = ACTIONS(3040),
    [anon_sym_thread_local] = ACTIONS(3040),
    [anon_sym___thread] = ACTIONS(3040),
    [anon_sym_const] = ACTIONS(3040),
    [anon_sym_constexpr] = ACTIONS(3040),
    [anon_sym_volatile] = ACTIONS(3040),
    [anon_sym_restrict] = ACTIONS(3040),
    [anon_sym___restrict__] = ACTIONS(3040),
    [anon_sym__Atomic] = ACTIONS(3040),
    [anon_sym__Noreturn] = ACTIONS(3040),
    [anon_sym_noreturn] = ACTIONS(3040),
    [anon_sym_mutable] = ACTIONS(3040),
    [anon_sym_constinit] = ACTIONS(3040),
    [anon_sym_consteval] = ACTIONS(3040),
    [anon_sym_PROGMEM] = ACTIONS(3040),
    [aux_sym_primitive_type_token1] = ACTIONS(3040),
    [anon_sym_byte] = ACTIONS(3040),
    [anon_sym_word] = ACTIONS(3040),
    [anon_sym_enum] = ACTIONS(3040),
    [anon_sym_class] = ACTIONS(3040),
    [anon_sym_struct] = ACTIONS(3040),
    [anon_sym_union] = ACTIONS(3040),
    [anon_sym_if] = ACTIONS(3040),
    [anon_sym_switch] = ACTIONS(3040),
    [anon_sym_case] = ACTIONS(3040),
    [anon_sym_default] = ACTIONS(3040),
    [anon_sym_while] = ACTIONS(3040),
    [anon_sym_do] = ACTIONS(3040),
    [anon_sym_for] = ACTIONS(3040),
    [anon_sym_return] = ACTIONS(3040),
    [anon_sym_break] = ACTIONS(3040),
    [anon_sym_continue] = ACTIONS(3040),
    [anon_sym_goto] = ACTIONS(3040),
    [anon_sym___try] = ACTIONS(3040),
    [anon_sym___leave] = ACTIONS(3040),
    [anon_sym_not] = ACTIONS(3040),
    [anon_sym_compl] = ACTIONS(3040),
    [anon_sym_DASH_DASH] = ACTIONS(3042),
    [anon_sym_PLUS_PLUS] = ACTIONS(3042),
    [anon_sym_sizeof] = ACTIONS(3040),
    [anon_sym___alignof__] = ACTIONS(3040),
    [anon_sym___alignof] = ACTIONS(3040),
    [anon_sym__alignof] = ACTIONS(3040),
    [anon_sym_alignof] = ACTIONS(3040),
    [anon_sym__Alignof] = ACTIONS(3040),
    [anon_sym_offsetof] = ACTIONS(3040),
    [anon_sym__Generic] = ACTIONS(3040),
    [anon_sym_asm] = ACTIONS(3040),
    [anon_sym___asm__] = ACTIONS(3040),
    [aux_sym_number_literal_token1] = ACTIONS(3042),
    [aux_sym_number_literal_token2] = ACTIONS(3040),
    [anon_sym_L_SQUOTE] = ACTIONS(3042),
    [anon_sym_u_SQUOTE] = ACTIONS(3042),
    [anon_sym_U_SQUOTE] = ACTIONS(3042),
    [anon_sym_u8_SQUOTE] = ACTIONS(3042),
    [anon_sym_SQUOTE] = ACTIONS(3042),
    [anon_sym_L_DQUOTE] = ACTIONS(3042),
    [anon_sym_u_DQUOTE] = ACTIONS(3042),
    [anon_sym_U_DQUOTE] = ACTIONS(3042),
    [anon_sym_u8_DQUOTE] = ACTIONS(3042),
    [anon_sym_DQUOTE] = ACTIONS(3042),
    [sym_true] = ACTIONS(3040),
    [sym_false] = ACTIONS(3040),
    [anon_sym_NULL] = ACTIONS(3040),
    [anon_sym_nullptr] = ACTIONS(3040),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3040),
    [anon_sym_decltype] = ACTIONS(3040),
    [anon_sym_virtual] = ACTIONS(3040),
    [anon_sym_alignas] = ACTIONS(3040),
    [anon_sym_explicit] = ACTIONS(3040),
    [anon_sym_typename] = ACTIONS(3040),
    [anon_sym_template] = ACTIONS(3040),
    [anon_sym_operator] = ACTIONS(3040),
    [anon_sym_try] = ACTIONS(3040),
    [anon_sym_delete] = ACTIONS(3040),
    [anon_sym_throw] = ACTIONS(3040),
    [anon_sym_namespace] = ACTIONS(3040),
    [anon_sym_using] = ACTIONS(3040),
    [anon_sym_static_assert] = ACTIONS(3040),
    [anon_sym_concept] = ACTIONS(3040),
    [anon_sym_co_return] = ACTIONS(3040),
    [anon_sym_co_yield] = ACTIONS(3040),
    [anon_sym_R_DQUOTE] = ACTIONS(3042),
    [anon_sym_LR_DQUOTE] = ACTIONS(3042),
    [anon_sym_uR_DQUOTE] = ACTIONS(3042),
    [anon_sym_UR_DQUOTE] = ACTIONS(3042),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3042),
    [anon_sym_co_await] = ACTIONS(3040),
    [anon_sym_new] = ACTIONS(3040),
    [anon_sym_requires] = ACTIONS(3040),
    [sym_this] = ACTIONS(3040),
  },
  [771] = {
    [sym_identifier] = ACTIONS(2941),
    [aux_sym_preproc_include_token1] = ACTIONS(2941),
    [aux_sym_preproc_def_token1] = ACTIONS(2941),
    [aux_sym_preproc_if_token1] = ACTIONS(2941),
    [aux_sym_preproc_if_token2] = ACTIONS(2941),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2941),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2941),
    [sym_preproc_directive] = ACTIONS(2941),
    [anon_sym_LPAREN2] = ACTIONS(2943),
    [anon_sym_BANG] = ACTIONS(2943),
    [anon_sym_TILDE] = ACTIONS(2943),
    [anon_sym_DASH] = ACTIONS(2941),
    [anon_sym_PLUS] = ACTIONS(2941),
    [anon_sym_STAR] = ACTIONS(2943),
    [anon_sym_AMP_AMP] = ACTIONS(2943),
    [anon_sym_AMP] = ACTIONS(2941),
    [anon_sym_SEMI] = ACTIONS(2943),
    [anon_sym___extension__] = ACTIONS(2941),
    [anon_sym_typedef] = ACTIONS(2941),
    [anon_sym_extern] = ACTIONS(2941),
    [anon_sym___attribute__] = ACTIONS(2941),
    [anon_sym_COLON_COLON] = ACTIONS(2943),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2943),
    [anon_sym___declspec] = ACTIONS(2941),
    [anon_sym___based] = ACTIONS(2941),
    [anon_sym___cdecl] = ACTIONS(2941),
    [anon_sym___clrcall] = ACTIONS(2941),
    [anon_sym___stdcall] = ACTIONS(2941),
    [anon_sym___fastcall] = ACTIONS(2941),
    [anon_sym___thiscall] = ACTIONS(2941),
    [anon_sym___vectorcall] = ACTIONS(2941),
    [anon_sym_LBRACE] = ACTIONS(2943),
    [anon_sym_signed] = ACTIONS(2941),
    [anon_sym_unsigned] = ACTIONS(2941),
    [anon_sym_long] = ACTIONS(2941),
    [anon_sym_short] = ACTIONS(2941),
    [anon_sym_LBRACK] = ACTIONS(2941),
    [anon_sym_static] = ACTIONS(2941),
    [anon_sym_register] = ACTIONS(2941),
    [anon_sym_inline] = ACTIONS(2941),
    [anon_sym___inline] = ACTIONS(2941),
    [anon_sym___inline__] = ACTIONS(2941),
    [anon_sym___forceinline] = ACTIONS(2941),
    [anon_sym_thread_local] = ACTIONS(2941),
    [anon_sym___thread] = ACTIONS(2941),
    [anon_sym_const] = ACTIONS(2941),
    [anon_sym_constexpr] = ACTIONS(2941),
    [anon_sym_volatile] = ACTIONS(2941),
    [anon_sym_restrict] = ACTIONS(2941),
    [anon_sym___restrict__] = ACTIONS(2941),
    [anon_sym__Atomic] = ACTIONS(2941),
    [anon_sym__Noreturn] = ACTIONS(2941),
    [anon_sym_noreturn] = ACTIONS(2941),
    [anon_sym_mutable] = ACTIONS(2941),
    [anon_sym_constinit] = ACTIONS(2941),
    [anon_sym_consteval] = ACTIONS(2941),
    [anon_sym_PROGMEM] = ACTIONS(2941),
    [aux_sym_primitive_type_token1] = ACTIONS(2941),
    [anon_sym_byte] = ACTIONS(2941),
    [anon_sym_word] = ACTIONS(2941),
    [anon_sym_enum] = ACTIONS(2941),
    [anon_sym_class] = ACTIONS(2941),
    [anon_sym_struct] = ACTIONS(2941),
    [anon_sym_union] = ACTIONS(2941),
    [anon_sym_if] = ACTIONS(2941),
    [anon_sym_switch] = ACTIONS(2941),
    [anon_sym_case] = ACTIONS(2941),
    [anon_sym_default] = ACTIONS(2941),
    [anon_sym_while] = ACTIONS(2941),
    [anon_sym_do] = ACTIONS(2941),
    [anon_sym_for] = ACTIONS(2941),
    [anon_sym_return] = ACTIONS(2941),
    [anon_sym_break] = ACTIONS(2941),
    [anon_sym_continue] = ACTIONS(2941),
    [anon_sym_goto] = ACTIONS(2941),
    [anon_sym___try] = ACTIONS(2941),
    [anon_sym___leave] = ACTIONS(2941),
    [anon_sym_not] = ACTIONS(2941),
    [anon_sym_compl] = ACTIONS(2941),
    [anon_sym_DASH_DASH] = ACTIONS(2943),
    [anon_sym_PLUS_PLUS] = ACTIONS(2943),
    [anon_sym_sizeof] = ACTIONS(2941),
    [anon_sym___alignof__] = ACTIONS(2941),
    [anon_sym___alignof] = ACTIONS(2941),
    [anon_sym__alignof] = ACTIONS(2941),
    [anon_sym_alignof] = ACTIONS(2941),
    [anon_sym__Alignof] = ACTIONS(2941),
    [anon_sym_offsetof] = ACTIONS(2941),
    [anon_sym__Generic] = ACTIONS(2941),
    [anon_sym_asm] = ACTIONS(2941),
    [anon_sym___asm__] = ACTIONS(2941),
    [aux_sym_number_literal_token1] = ACTIONS(2943),
    [aux_sym_number_literal_token2] = ACTIONS(2941),
    [anon_sym_L_SQUOTE] = ACTIONS(2943),
    [anon_sym_u_SQUOTE] = ACTIONS(2943),
    [anon_sym_U_SQUOTE] = ACTIONS(2943),
    [anon_sym_u8_SQUOTE] = ACTIONS(2943),
    [anon_sym_SQUOTE] = ACTIONS(2943),
    [anon_sym_L_DQUOTE] = ACTIONS(2943),
    [anon_sym_u_DQUOTE] = ACTIONS(2943),
    [anon_sym_U_DQUOTE] = ACTIONS(2943),
    [anon_sym_u8_DQUOTE] = ACTIONS(2943),
    [anon_sym_DQUOTE] = ACTIONS(2943),
    [sym_true] = ACTIONS(2941),
    [sym_false] = ACTIONS(2941),
    [anon_sym_NULL] = ACTIONS(2941),
    [anon_sym_nullptr] = ACTIONS(2941),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2941),
    [anon_sym_decltype] = ACTIONS(2941),
    [anon_sym_virtual] = ACTIONS(2941),
    [anon_sym_alignas] = ACTIONS(2941),
    [anon_sym_explicit] = ACTIONS(2941),
    [anon_sym_typename] = ACTIONS(2941),
    [anon_sym_template] = ACTIONS(2941),
    [anon_sym_operator] = ACTIONS(2941),
    [anon_sym_try] = ACTIONS(2941),
    [anon_sym_delete] = ACTIONS(2941),
    [anon_sym_throw] = ACTIONS(2941),
    [anon_sym_namespace] = ACTIONS(2941),
    [anon_sym_using] = ACTIONS(2941),
    [anon_sym_static_assert] = ACTIONS(2941),
    [anon_sym_concept] = ACTIONS(2941),
    [anon_sym_co_return] = ACTIONS(2941),
    [anon_sym_co_yield] = ACTIONS(2941),
    [anon_sym_R_DQUOTE] = ACTIONS(2943),
    [anon_sym_LR_DQUOTE] = ACTIONS(2943),
    [anon_sym_uR_DQUOTE] = ACTIONS(2943),
    [anon_sym_UR_DQUOTE] = ACTIONS(2943),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2943),
    [anon_sym_co_await] = ACTIONS(2941),
    [anon_sym_new] = ACTIONS(2941),
    [anon_sym_requires] = ACTIONS(2941),
    [sym_this] = ACTIONS(2941),
  },
  [772] = {
    [sym_identifier] = ACTIONS(3105),
    [aux_sym_preproc_include_token1] = ACTIONS(3105),
    [aux_sym_preproc_def_token1] = ACTIONS(3105),
    [aux_sym_preproc_if_token1] = ACTIONS(3105),
    [aux_sym_preproc_if_token2] = ACTIONS(3105),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3105),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3105),
    [sym_preproc_directive] = ACTIONS(3105),
    [anon_sym_LPAREN2] = ACTIONS(3107),
    [anon_sym_BANG] = ACTIONS(3107),
    [anon_sym_TILDE] = ACTIONS(3107),
    [anon_sym_DASH] = ACTIONS(3105),
    [anon_sym_PLUS] = ACTIONS(3105),
    [anon_sym_STAR] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3107),
    [anon_sym_AMP] = ACTIONS(3105),
    [anon_sym_SEMI] = ACTIONS(3107),
    [anon_sym___extension__] = ACTIONS(3105),
    [anon_sym_typedef] = ACTIONS(3105),
    [anon_sym_extern] = ACTIONS(3105),
    [anon_sym___attribute__] = ACTIONS(3105),
    [anon_sym_COLON_COLON] = ACTIONS(3107),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3107),
    [anon_sym___declspec] = ACTIONS(3105),
    [anon_sym___based] = ACTIONS(3105),
    [anon_sym___cdecl] = ACTIONS(3105),
    [anon_sym___clrcall] = ACTIONS(3105),
    [anon_sym___stdcall] = ACTIONS(3105),
    [anon_sym___fastcall] = ACTIONS(3105),
    [anon_sym___thiscall] = ACTIONS(3105),
    [anon_sym___vectorcall] = ACTIONS(3105),
    [anon_sym_LBRACE] = ACTIONS(3107),
    [anon_sym_signed] = ACTIONS(3105),
    [anon_sym_unsigned] = ACTIONS(3105),
    [anon_sym_long] = ACTIONS(3105),
    [anon_sym_short] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(3105),
    [anon_sym_static] = ACTIONS(3105),
    [anon_sym_register] = ACTIONS(3105),
    [anon_sym_inline] = ACTIONS(3105),
    [anon_sym___inline] = ACTIONS(3105),
    [anon_sym___inline__] = ACTIONS(3105),
    [anon_sym___forceinline] = ACTIONS(3105),
    [anon_sym_thread_local] = ACTIONS(3105),
    [anon_sym___thread] = ACTIONS(3105),
    [anon_sym_const] = ACTIONS(3105),
    [anon_sym_constexpr] = ACTIONS(3105),
    [anon_sym_volatile] = ACTIONS(3105),
    [anon_sym_restrict] = ACTIONS(3105),
    [anon_sym___restrict__] = ACTIONS(3105),
    [anon_sym__Atomic] = ACTIONS(3105),
    [anon_sym__Noreturn] = ACTIONS(3105),
    [anon_sym_noreturn] = ACTIONS(3105),
    [anon_sym_mutable] = ACTIONS(3105),
    [anon_sym_constinit] = ACTIONS(3105),
    [anon_sym_consteval] = ACTIONS(3105),
    [anon_sym_PROGMEM] = ACTIONS(3105),
    [aux_sym_primitive_type_token1] = ACTIONS(3105),
    [anon_sym_byte] = ACTIONS(3105),
    [anon_sym_word] = ACTIONS(3105),
    [anon_sym_enum] = ACTIONS(3105),
    [anon_sym_class] = ACTIONS(3105),
    [anon_sym_struct] = ACTIONS(3105),
    [anon_sym_union] = ACTIONS(3105),
    [anon_sym_if] = ACTIONS(3105),
    [anon_sym_switch] = ACTIONS(3105),
    [anon_sym_case] = ACTIONS(3105),
    [anon_sym_default] = ACTIONS(3105),
    [anon_sym_while] = ACTIONS(3105),
    [anon_sym_do] = ACTIONS(3105),
    [anon_sym_for] = ACTIONS(3105),
    [anon_sym_return] = ACTIONS(3105),
    [anon_sym_break] = ACTIONS(3105),
    [anon_sym_continue] = ACTIONS(3105),
    [anon_sym_goto] = ACTIONS(3105),
    [anon_sym___try] = ACTIONS(3105),
    [anon_sym___leave] = ACTIONS(3105),
    [anon_sym_not] = ACTIONS(3105),
    [anon_sym_compl] = ACTIONS(3105),
    [anon_sym_DASH_DASH] = ACTIONS(3107),
    [anon_sym_PLUS_PLUS] = ACTIONS(3107),
    [anon_sym_sizeof] = ACTIONS(3105),
    [anon_sym___alignof__] = ACTIONS(3105),
    [anon_sym___alignof] = ACTIONS(3105),
    [anon_sym__alignof] = ACTIONS(3105),
    [anon_sym_alignof] = ACTIONS(3105),
    [anon_sym__Alignof] = ACTIONS(3105),
    [anon_sym_offsetof] = ACTIONS(3105),
    [anon_sym__Generic] = ACTIONS(3105),
    [anon_sym_asm] = ACTIONS(3105),
    [anon_sym___asm__] = ACTIONS(3105),
    [aux_sym_number_literal_token1] = ACTIONS(3107),
    [aux_sym_number_literal_token2] = ACTIONS(3105),
    [anon_sym_L_SQUOTE] = ACTIONS(3107),
    [anon_sym_u_SQUOTE] = ACTIONS(3107),
    [anon_sym_U_SQUOTE] = ACTIONS(3107),
    [anon_sym_u8_SQUOTE] = ACTIONS(3107),
    [anon_sym_SQUOTE] = ACTIONS(3107),
    [anon_sym_L_DQUOTE] = ACTIONS(3107),
    [anon_sym_u_DQUOTE] = ACTIONS(3107),
    [anon_sym_U_DQUOTE] = ACTIONS(3107),
    [anon_sym_u8_DQUOTE] = ACTIONS(3107),
    [anon_sym_DQUOTE] = ACTIONS(3107),
    [sym_true] = ACTIONS(3105),
    [sym_false] = ACTIONS(3105),
    [anon_sym_NULL] = ACTIONS(3105),
    [anon_sym_nullptr] = ACTIONS(3105),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3105),
    [anon_sym_decltype] = ACTIONS(3105),
    [anon_sym_virtual] = ACTIONS(3105),
    [anon_sym_alignas] = ACTIONS(3105),
    [anon_sym_explicit] = ACTIONS(3105),
    [anon_sym_typename] = ACTIONS(3105),
    [anon_sym_template] = ACTIONS(3105),
    [anon_sym_operator] = ACTIONS(3105),
    [anon_sym_try] = ACTIONS(3105),
    [anon_sym_delete] = ACTIONS(3105),
    [anon_sym_throw] = ACTIONS(3105),
    [anon_sym_namespace] = ACTIONS(3105),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_static_assert] = ACTIONS(3105),
    [anon_sym_concept] = ACTIONS(3105),
    [anon_sym_co_return] = ACTIONS(3105),
    [anon_sym_co_yield] = ACTIONS(3105),
    [anon_sym_R_DQUOTE] = ACTIONS(3107),
    [anon_sym_LR_DQUOTE] = ACTIONS(3107),
    [anon_sym_uR_DQUOTE] = ACTIONS(3107),
    [anon_sym_UR_DQUOTE] = ACTIONS(3107),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3107),
    [anon_sym_co_await] = ACTIONS(3105),
    [anon_sym_new] = ACTIONS(3105),
    [anon_sym_requires] = ACTIONS(3105),
    [sym_this] = ACTIONS(3105),
  },
  [773] = {
    [sym_identifier] = ACTIONS(2979),
    [aux_sym_preproc_include_token1] = ACTIONS(2979),
    [aux_sym_preproc_def_token1] = ACTIONS(2979),
    [aux_sym_preproc_if_token1] = ACTIONS(2979),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2979),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2979),
    [sym_preproc_directive] = ACTIONS(2979),
    [anon_sym_LPAREN2] = ACTIONS(2981),
    [anon_sym_BANG] = ACTIONS(2981),
    [anon_sym_TILDE] = ACTIONS(2981),
    [anon_sym_DASH] = ACTIONS(2979),
    [anon_sym_PLUS] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(2981),
    [anon_sym_AMP] = ACTIONS(2979),
    [anon_sym_SEMI] = ACTIONS(2981),
    [anon_sym___extension__] = ACTIONS(2979),
    [anon_sym_typedef] = ACTIONS(2979),
    [anon_sym_extern] = ACTIONS(2979),
    [anon_sym___attribute__] = ACTIONS(2979),
    [anon_sym_COLON_COLON] = ACTIONS(2981),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2981),
    [anon_sym___declspec] = ACTIONS(2979),
    [anon_sym___based] = ACTIONS(2979),
    [anon_sym___cdecl] = ACTIONS(2979),
    [anon_sym___clrcall] = ACTIONS(2979),
    [anon_sym___stdcall] = ACTIONS(2979),
    [anon_sym___fastcall] = ACTIONS(2979),
    [anon_sym___thiscall] = ACTIONS(2979),
    [anon_sym___vectorcall] = ACTIONS(2979),
    [anon_sym_LBRACE] = ACTIONS(2981),
    [anon_sym_RBRACE] = ACTIONS(2981),
    [anon_sym_signed] = ACTIONS(2979),
    [anon_sym_unsigned] = ACTIONS(2979),
    [anon_sym_long] = ACTIONS(2979),
    [anon_sym_short] = ACTIONS(2979),
    [anon_sym_LBRACK] = ACTIONS(2979),
    [anon_sym_static] = ACTIONS(2979),
    [anon_sym_register] = ACTIONS(2979),
    [anon_sym_inline] = ACTIONS(2979),
    [anon_sym___inline] = ACTIONS(2979),
    [anon_sym___inline__] = ACTIONS(2979),
    [anon_sym___forceinline] = ACTIONS(2979),
    [anon_sym_thread_local] = ACTIONS(2979),
    [anon_sym___thread] = ACTIONS(2979),
    [anon_sym_const] = ACTIONS(2979),
    [anon_sym_constexpr] = ACTIONS(2979),
    [anon_sym_volatile] = ACTIONS(2979),
    [anon_sym_restrict] = ACTIONS(2979),
    [anon_sym___restrict__] = ACTIONS(2979),
    [anon_sym__Atomic] = ACTIONS(2979),
    [anon_sym__Noreturn] = ACTIONS(2979),
    [anon_sym_noreturn] = ACTIONS(2979),
    [anon_sym_mutable] = ACTIONS(2979),
    [anon_sym_constinit] = ACTIONS(2979),
    [anon_sym_consteval] = ACTIONS(2979),
    [anon_sym_PROGMEM] = ACTIONS(2979),
    [aux_sym_primitive_type_token1] = ACTIONS(2979),
    [anon_sym_byte] = ACTIONS(2979),
    [anon_sym_word] = ACTIONS(2979),
    [anon_sym_enum] = ACTIONS(2979),
    [anon_sym_class] = ACTIONS(2979),
    [anon_sym_struct] = ACTIONS(2979),
    [anon_sym_union] = ACTIONS(2979),
    [anon_sym_if] = ACTIONS(2979),
    [anon_sym_switch] = ACTIONS(2979),
    [anon_sym_case] = ACTIONS(2979),
    [anon_sym_default] = ACTIONS(2979),
    [anon_sym_while] = ACTIONS(2979),
    [anon_sym_do] = ACTIONS(2979),
    [anon_sym_for] = ACTIONS(2979),
    [anon_sym_return] = ACTIONS(2979),
    [anon_sym_break] = ACTIONS(2979),
    [anon_sym_continue] = ACTIONS(2979),
    [anon_sym_goto] = ACTIONS(2979),
    [anon_sym___try] = ACTIONS(2979),
    [anon_sym___leave] = ACTIONS(2979),
    [anon_sym_not] = ACTIONS(2979),
    [anon_sym_compl] = ACTIONS(2979),
    [anon_sym_DASH_DASH] = ACTIONS(2981),
    [anon_sym_PLUS_PLUS] = ACTIONS(2981),
    [anon_sym_sizeof] = ACTIONS(2979),
    [anon_sym___alignof__] = ACTIONS(2979),
    [anon_sym___alignof] = ACTIONS(2979),
    [anon_sym__alignof] = ACTIONS(2979),
    [anon_sym_alignof] = ACTIONS(2979),
    [anon_sym__Alignof] = ACTIONS(2979),
    [anon_sym_offsetof] = ACTIONS(2979),
    [anon_sym__Generic] = ACTIONS(2979),
    [anon_sym_asm] = ACTIONS(2979),
    [anon_sym___asm__] = ACTIONS(2979),
    [aux_sym_number_literal_token1] = ACTIONS(2981),
    [aux_sym_number_literal_token2] = ACTIONS(2979),
    [anon_sym_L_SQUOTE] = ACTIONS(2981),
    [anon_sym_u_SQUOTE] = ACTIONS(2981),
    [anon_sym_U_SQUOTE] = ACTIONS(2981),
    [anon_sym_u8_SQUOTE] = ACTIONS(2981),
    [anon_sym_SQUOTE] = ACTIONS(2981),
    [anon_sym_L_DQUOTE] = ACTIONS(2981),
    [anon_sym_u_DQUOTE] = ACTIONS(2981),
    [anon_sym_U_DQUOTE] = ACTIONS(2981),
    [anon_sym_u8_DQUOTE] = ACTIONS(2981),
    [anon_sym_DQUOTE] = ACTIONS(2981),
    [sym_true] = ACTIONS(2979),
    [sym_false] = ACTIONS(2979),
    [anon_sym_NULL] = ACTIONS(2979),
    [anon_sym_nullptr] = ACTIONS(2979),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2979),
    [anon_sym_decltype] = ACTIONS(2979),
    [anon_sym_virtual] = ACTIONS(2979),
    [anon_sym_alignas] = ACTIONS(2979),
    [anon_sym_explicit] = ACTIONS(2979),
    [anon_sym_typename] = ACTIONS(2979),
    [anon_sym_template] = ACTIONS(2979),
    [anon_sym_operator] = ACTIONS(2979),
    [anon_sym_try] = ACTIONS(2979),
    [anon_sym_delete] = ACTIONS(2979),
    [anon_sym_throw] = ACTIONS(2979),
    [anon_sym_namespace] = ACTIONS(2979),
    [anon_sym_using] = ACTIONS(2979),
    [anon_sym_static_assert] = ACTIONS(2979),
    [anon_sym_concept] = ACTIONS(2979),
    [anon_sym_co_return] = ACTIONS(2979),
    [anon_sym_co_yield] = ACTIONS(2979),
    [anon_sym_R_DQUOTE] = ACTIONS(2981),
    [anon_sym_LR_DQUOTE] = ACTIONS(2981),
    [anon_sym_uR_DQUOTE] = ACTIONS(2981),
    [anon_sym_UR_DQUOTE] = ACTIONS(2981),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2981),
    [anon_sym_co_await] = ACTIONS(2979),
    [anon_sym_new] = ACTIONS(2979),
    [anon_sym_requires] = ACTIONS(2979),
    [sym_this] = ACTIONS(2979),
  },
  [774] = {
    [sym_identifier] = ACTIONS(3122),
    [aux_sym_preproc_include_token1] = ACTIONS(3122),
    [aux_sym_preproc_def_token1] = ACTIONS(3122),
    [aux_sym_preproc_if_token1] = ACTIONS(3122),
    [aux_sym_preproc_if_token2] = ACTIONS(3122),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3122),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3122),
    [sym_preproc_directive] = ACTIONS(3122),
    [anon_sym_LPAREN2] = ACTIONS(3124),
    [anon_sym_BANG] = ACTIONS(3124),
    [anon_sym_TILDE] = ACTIONS(3124),
    [anon_sym_DASH] = ACTIONS(3122),
    [anon_sym_PLUS] = ACTIONS(3122),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP_AMP] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3122),
    [anon_sym_SEMI] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(3122),
    [anon_sym_typedef] = ACTIONS(3122),
    [anon_sym_extern] = ACTIONS(3122),
    [anon_sym___attribute__] = ACTIONS(3122),
    [anon_sym_COLON_COLON] = ACTIONS(3124),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3124),
    [anon_sym___declspec] = ACTIONS(3122),
    [anon_sym___based] = ACTIONS(3122),
    [anon_sym___cdecl] = ACTIONS(3122),
    [anon_sym___clrcall] = ACTIONS(3122),
    [anon_sym___stdcall] = ACTIONS(3122),
    [anon_sym___fastcall] = ACTIONS(3122),
    [anon_sym___thiscall] = ACTIONS(3122),
    [anon_sym___vectorcall] = ACTIONS(3122),
    [anon_sym_LBRACE] = ACTIONS(3124),
    [anon_sym_signed] = ACTIONS(3122),
    [anon_sym_unsigned] = ACTIONS(3122),
    [anon_sym_long] = ACTIONS(3122),
    [anon_sym_short] = ACTIONS(3122),
    [anon_sym_LBRACK] = ACTIONS(3122),
    [anon_sym_static] = ACTIONS(3122),
    [anon_sym_register] = ACTIONS(3122),
    [anon_sym_inline] = ACTIONS(3122),
    [anon_sym___inline] = ACTIONS(3122),
    [anon_sym___inline__] = ACTIONS(3122),
    [anon_sym___forceinline] = ACTIONS(3122),
    [anon_sym_thread_local] = ACTIONS(3122),
    [anon_sym___thread] = ACTIONS(3122),
    [anon_sym_const] = ACTIONS(3122),
    [anon_sym_constexpr] = ACTIONS(3122),
    [anon_sym_volatile] = ACTIONS(3122),
    [anon_sym_restrict] = ACTIONS(3122),
    [anon_sym___restrict__] = ACTIONS(3122),
    [anon_sym__Atomic] = ACTIONS(3122),
    [anon_sym__Noreturn] = ACTIONS(3122),
    [anon_sym_noreturn] = ACTIONS(3122),
    [anon_sym_mutable] = ACTIONS(3122),
    [anon_sym_constinit] = ACTIONS(3122),
    [anon_sym_consteval] = ACTIONS(3122),
    [anon_sym_PROGMEM] = ACTIONS(3122),
    [aux_sym_primitive_type_token1] = ACTIONS(3122),
    [anon_sym_byte] = ACTIONS(3122),
    [anon_sym_word] = ACTIONS(3122),
    [anon_sym_enum] = ACTIONS(3122),
    [anon_sym_class] = ACTIONS(3122),
    [anon_sym_struct] = ACTIONS(3122),
    [anon_sym_union] = ACTIONS(3122),
    [anon_sym_if] = ACTIONS(3122),
    [anon_sym_switch] = ACTIONS(3122),
    [anon_sym_case] = ACTIONS(3122),
    [anon_sym_default] = ACTIONS(3122),
    [anon_sym_while] = ACTIONS(3122),
    [anon_sym_do] = ACTIONS(3122),
    [anon_sym_for] = ACTIONS(3122),
    [anon_sym_return] = ACTIONS(3122),
    [anon_sym_break] = ACTIONS(3122),
    [anon_sym_continue] = ACTIONS(3122),
    [anon_sym_goto] = ACTIONS(3122),
    [anon_sym___try] = ACTIONS(3122),
    [anon_sym___leave] = ACTIONS(3122),
    [anon_sym_not] = ACTIONS(3122),
    [anon_sym_compl] = ACTIONS(3122),
    [anon_sym_DASH_DASH] = ACTIONS(3124),
    [anon_sym_PLUS_PLUS] = ACTIONS(3124),
    [anon_sym_sizeof] = ACTIONS(3122),
    [anon_sym___alignof__] = ACTIONS(3122),
    [anon_sym___alignof] = ACTIONS(3122),
    [anon_sym__alignof] = ACTIONS(3122),
    [anon_sym_alignof] = ACTIONS(3122),
    [anon_sym__Alignof] = ACTIONS(3122),
    [anon_sym_offsetof] = ACTIONS(3122),
    [anon_sym__Generic] = ACTIONS(3122),
    [anon_sym_asm] = ACTIONS(3122),
    [anon_sym___asm__] = ACTIONS(3122),
    [aux_sym_number_literal_token1] = ACTIONS(3124),
    [aux_sym_number_literal_token2] = ACTIONS(3122),
    [anon_sym_L_SQUOTE] = ACTIONS(3124),
    [anon_sym_u_SQUOTE] = ACTIONS(3124),
    [anon_sym_U_SQUOTE] = ACTIONS(3124),
    [anon_sym_u8_SQUOTE] = ACTIONS(3124),
    [anon_sym_SQUOTE] = ACTIONS(3124),
    [anon_sym_L_DQUOTE] = ACTIONS(3124),
    [anon_sym_u_DQUOTE] = ACTIONS(3124),
    [anon_sym_U_DQUOTE] = ACTIONS(3124),
    [anon_sym_u8_DQUOTE] = ACTIONS(3124),
    [anon_sym_DQUOTE] = ACTIONS(3124),
    [sym_true] = ACTIONS(3122),
    [sym_false] = ACTIONS(3122),
    [anon_sym_NULL] = ACTIONS(3122),
    [anon_sym_nullptr] = ACTIONS(3122),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3122),
    [anon_sym_decltype] = ACTIONS(3122),
    [anon_sym_virtual] = ACTIONS(3122),
    [anon_sym_alignas] = ACTIONS(3122),
    [anon_sym_explicit] = ACTIONS(3122),
    [anon_sym_typename] = ACTIONS(3122),
    [anon_sym_template] = ACTIONS(3122),
    [anon_sym_operator] = ACTIONS(3122),
    [anon_sym_try] = ACTIONS(3122),
    [anon_sym_delete] = ACTIONS(3122),
    [anon_sym_throw] = ACTIONS(3122),
    [anon_sym_namespace] = ACTIONS(3122),
    [anon_sym_using] = ACTIONS(3122),
    [anon_sym_static_assert] = ACTIONS(3122),
    [anon_sym_concept] = ACTIONS(3122),
    [anon_sym_co_return] = ACTIONS(3122),
    [anon_sym_co_yield] = ACTIONS(3122),
    [anon_sym_R_DQUOTE] = ACTIONS(3124),
    [anon_sym_LR_DQUOTE] = ACTIONS(3124),
    [anon_sym_uR_DQUOTE] = ACTIONS(3124),
    [anon_sym_UR_DQUOTE] = ACTIONS(3124),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3124),
    [anon_sym_co_await] = ACTIONS(3122),
    [anon_sym_new] = ACTIONS(3122),
    [anon_sym_requires] = ACTIONS(3122),
    [sym_this] = ACTIONS(3122),
  },
  [775] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_RBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [776] = {
    [sym_identifier] = ACTIONS(2989),
    [aux_sym_preproc_include_token1] = ACTIONS(2989),
    [aux_sym_preproc_def_token1] = ACTIONS(2989),
    [aux_sym_preproc_if_token1] = ACTIONS(2989),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2989),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2989),
    [sym_preproc_directive] = ACTIONS(2989),
    [anon_sym_LPAREN2] = ACTIONS(2991),
    [anon_sym_BANG] = ACTIONS(2991),
    [anon_sym_TILDE] = ACTIONS(2991),
    [anon_sym_DASH] = ACTIONS(2989),
    [anon_sym_PLUS] = ACTIONS(2989),
    [anon_sym_STAR] = ACTIONS(2991),
    [anon_sym_AMP_AMP] = ACTIONS(2991),
    [anon_sym_AMP] = ACTIONS(2989),
    [anon_sym_SEMI] = ACTIONS(2991),
    [anon_sym___extension__] = ACTIONS(2989),
    [anon_sym_typedef] = ACTIONS(2989),
    [anon_sym_extern] = ACTIONS(2989),
    [anon_sym___attribute__] = ACTIONS(2989),
    [anon_sym_COLON_COLON] = ACTIONS(2991),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2991),
    [anon_sym___declspec] = ACTIONS(2989),
    [anon_sym___based] = ACTIONS(2989),
    [anon_sym___cdecl] = ACTIONS(2989),
    [anon_sym___clrcall] = ACTIONS(2989),
    [anon_sym___stdcall] = ACTIONS(2989),
    [anon_sym___fastcall] = ACTIONS(2989),
    [anon_sym___thiscall] = ACTIONS(2989),
    [anon_sym___vectorcall] = ACTIONS(2989),
    [anon_sym_LBRACE] = ACTIONS(2991),
    [anon_sym_RBRACE] = ACTIONS(2991),
    [anon_sym_signed] = ACTIONS(2989),
    [anon_sym_unsigned] = ACTIONS(2989),
    [anon_sym_long] = ACTIONS(2989),
    [anon_sym_short] = ACTIONS(2989),
    [anon_sym_LBRACK] = ACTIONS(2989),
    [anon_sym_static] = ACTIONS(2989),
    [anon_sym_register] = ACTIONS(2989),
    [anon_sym_inline] = ACTIONS(2989),
    [anon_sym___inline] = ACTIONS(2989),
    [anon_sym___inline__] = ACTIONS(2989),
    [anon_sym___forceinline] = ACTIONS(2989),
    [anon_sym_thread_local] = ACTIONS(2989),
    [anon_sym___thread] = ACTIONS(2989),
    [anon_sym_const] = ACTIONS(2989),
    [anon_sym_constexpr] = ACTIONS(2989),
    [anon_sym_volatile] = ACTIONS(2989),
    [anon_sym_restrict] = ACTIONS(2989),
    [anon_sym___restrict__] = ACTIONS(2989),
    [anon_sym__Atomic] = ACTIONS(2989),
    [anon_sym__Noreturn] = ACTIONS(2989),
    [anon_sym_noreturn] = ACTIONS(2989),
    [anon_sym_mutable] = ACTIONS(2989),
    [anon_sym_constinit] = ACTIONS(2989),
    [anon_sym_consteval] = ACTIONS(2989),
    [anon_sym_PROGMEM] = ACTIONS(2989),
    [aux_sym_primitive_type_token1] = ACTIONS(2989),
    [anon_sym_byte] = ACTIONS(2989),
    [anon_sym_word] = ACTIONS(2989),
    [anon_sym_enum] = ACTIONS(2989),
    [anon_sym_class] = ACTIONS(2989),
    [anon_sym_struct] = ACTIONS(2989),
    [anon_sym_union] = ACTIONS(2989),
    [anon_sym_if] = ACTIONS(2989),
    [anon_sym_switch] = ACTIONS(2989),
    [anon_sym_case] = ACTIONS(2989),
    [anon_sym_default] = ACTIONS(2989),
    [anon_sym_while] = ACTIONS(2989),
    [anon_sym_do] = ACTIONS(2989),
    [anon_sym_for] = ACTIONS(2989),
    [anon_sym_return] = ACTIONS(2989),
    [anon_sym_break] = ACTIONS(2989),
    [anon_sym_continue] = ACTIONS(2989),
    [anon_sym_goto] = ACTIONS(2989),
    [anon_sym___try] = ACTIONS(2989),
    [anon_sym___leave] = ACTIONS(2989),
    [anon_sym_not] = ACTIONS(2989),
    [anon_sym_compl] = ACTIONS(2989),
    [anon_sym_DASH_DASH] = ACTIONS(2991),
    [anon_sym_PLUS_PLUS] = ACTIONS(2991),
    [anon_sym_sizeof] = ACTIONS(2989),
    [anon_sym___alignof__] = ACTIONS(2989),
    [anon_sym___alignof] = ACTIONS(2989),
    [anon_sym__alignof] = ACTIONS(2989),
    [anon_sym_alignof] = ACTIONS(2989),
    [anon_sym__Alignof] = ACTIONS(2989),
    [anon_sym_offsetof] = ACTIONS(2989),
    [anon_sym__Generic] = ACTIONS(2989),
    [anon_sym_asm] = ACTIONS(2989),
    [anon_sym___asm__] = ACTIONS(2989),
    [aux_sym_number_literal_token1] = ACTIONS(2991),
    [aux_sym_number_literal_token2] = ACTIONS(2989),
    [anon_sym_L_SQUOTE] = ACTIONS(2991),
    [anon_sym_u_SQUOTE] = ACTIONS(2991),
    [anon_sym_U_SQUOTE] = ACTIONS(2991),
    [anon_sym_u8_SQUOTE] = ACTIONS(2991),
    [anon_sym_SQUOTE] = ACTIONS(2991),
    [anon_sym_L_DQUOTE] = ACTIONS(2991),
    [anon_sym_u_DQUOTE] = ACTIONS(2991),
    [anon_sym_U_DQUOTE] = ACTIONS(2991),
    [anon_sym_u8_DQUOTE] = ACTIONS(2991),
    [anon_sym_DQUOTE] = ACTIONS(2991),
    [sym_true] = ACTIONS(2989),
    [sym_false] = ACTIONS(2989),
    [anon_sym_NULL] = ACTIONS(2989),
    [anon_sym_nullptr] = ACTIONS(2989),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2989),
    [anon_sym_decltype] = ACTIONS(2989),
    [anon_sym_virtual] = ACTIONS(2989),
    [anon_sym_alignas] = ACTIONS(2989),
    [anon_sym_explicit] = ACTIONS(2989),
    [anon_sym_typename] = ACTIONS(2989),
    [anon_sym_template] = ACTIONS(2989),
    [anon_sym_operator] = ACTIONS(2989),
    [anon_sym_try] = ACTIONS(2989),
    [anon_sym_delete] = ACTIONS(2989),
    [anon_sym_throw] = ACTIONS(2989),
    [anon_sym_namespace] = ACTIONS(2989),
    [anon_sym_using] = ACTIONS(2989),
    [anon_sym_static_assert] = ACTIONS(2989),
    [anon_sym_concept] = ACTIONS(2989),
    [anon_sym_co_return] = ACTIONS(2989),
    [anon_sym_co_yield] = ACTIONS(2989),
    [anon_sym_R_DQUOTE] = ACTIONS(2991),
    [anon_sym_LR_DQUOTE] = ACTIONS(2991),
    [anon_sym_uR_DQUOTE] = ACTIONS(2991),
    [anon_sym_UR_DQUOTE] = ACTIONS(2991),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2991),
    [anon_sym_co_await] = ACTIONS(2989),
    [anon_sym_new] = ACTIONS(2989),
    [anon_sym_requires] = ACTIONS(2989),
    [sym_this] = ACTIONS(2989),
  },
  [777] = {
    [sym_identifier] = ACTIONS(3060),
    [aux_sym_preproc_include_token1] = ACTIONS(3060),
    [aux_sym_preproc_def_token1] = ACTIONS(3060),
    [aux_sym_preproc_if_token1] = ACTIONS(3060),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3060),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3060),
    [sym_preproc_directive] = ACTIONS(3060),
    [anon_sym_LPAREN2] = ACTIONS(3062),
    [anon_sym_BANG] = ACTIONS(3062),
    [anon_sym_TILDE] = ACTIONS(3062),
    [anon_sym_DASH] = ACTIONS(3060),
    [anon_sym_PLUS] = ACTIONS(3060),
    [anon_sym_STAR] = ACTIONS(3062),
    [anon_sym_AMP_AMP] = ACTIONS(3062),
    [anon_sym_AMP] = ACTIONS(3060),
    [anon_sym_SEMI] = ACTIONS(3062),
    [anon_sym___extension__] = ACTIONS(3060),
    [anon_sym_typedef] = ACTIONS(3060),
    [anon_sym_extern] = ACTIONS(3060),
    [anon_sym___attribute__] = ACTIONS(3060),
    [anon_sym_COLON_COLON] = ACTIONS(3062),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3062),
    [anon_sym___declspec] = ACTIONS(3060),
    [anon_sym___based] = ACTIONS(3060),
    [anon_sym___cdecl] = ACTIONS(3060),
    [anon_sym___clrcall] = ACTIONS(3060),
    [anon_sym___stdcall] = ACTIONS(3060),
    [anon_sym___fastcall] = ACTIONS(3060),
    [anon_sym___thiscall] = ACTIONS(3060),
    [anon_sym___vectorcall] = ACTIONS(3060),
    [anon_sym_LBRACE] = ACTIONS(3062),
    [anon_sym_RBRACE] = ACTIONS(3062),
    [anon_sym_signed] = ACTIONS(3060),
    [anon_sym_unsigned] = ACTIONS(3060),
    [anon_sym_long] = ACTIONS(3060),
    [anon_sym_short] = ACTIONS(3060),
    [anon_sym_LBRACK] = ACTIONS(3060),
    [anon_sym_static] = ACTIONS(3060),
    [anon_sym_register] = ACTIONS(3060),
    [anon_sym_inline] = ACTIONS(3060),
    [anon_sym___inline] = ACTIONS(3060),
    [anon_sym___inline__] = ACTIONS(3060),
    [anon_sym___forceinline] = ACTIONS(3060),
    [anon_sym_thread_local] = ACTIONS(3060),
    [anon_sym___thread] = ACTIONS(3060),
    [anon_sym_const] = ACTIONS(3060),
    [anon_sym_constexpr] = ACTIONS(3060),
    [anon_sym_volatile] = ACTIONS(3060),
    [anon_sym_restrict] = ACTIONS(3060),
    [anon_sym___restrict__] = ACTIONS(3060),
    [anon_sym__Atomic] = ACTIONS(3060),
    [anon_sym__Noreturn] = ACTIONS(3060),
    [anon_sym_noreturn] = ACTIONS(3060),
    [anon_sym_mutable] = ACTIONS(3060),
    [anon_sym_constinit] = ACTIONS(3060),
    [anon_sym_consteval] = ACTIONS(3060),
    [anon_sym_PROGMEM] = ACTIONS(3060),
    [aux_sym_primitive_type_token1] = ACTIONS(3060),
    [anon_sym_byte] = ACTIONS(3060),
    [anon_sym_word] = ACTIONS(3060),
    [anon_sym_enum] = ACTIONS(3060),
    [anon_sym_class] = ACTIONS(3060),
    [anon_sym_struct] = ACTIONS(3060),
    [anon_sym_union] = ACTIONS(3060),
    [anon_sym_if] = ACTIONS(3060),
    [anon_sym_switch] = ACTIONS(3060),
    [anon_sym_case] = ACTIONS(3060),
    [anon_sym_default] = ACTIONS(3060),
    [anon_sym_while] = ACTIONS(3060),
    [anon_sym_do] = ACTIONS(3060),
    [anon_sym_for] = ACTIONS(3060),
    [anon_sym_return] = ACTIONS(3060),
    [anon_sym_break] = ACTIONS(3060),
    [anon_sym_continue] = ACTIONS(3060),
    [anon_sym_goto] = ACTIONS(3060),
    [anon_sym___try] = ACTIONS(3060),
    [anon_sym___leave] = ACTIONS(3060),
    [anon_sym_not] = ACTIONS(3060),
    [anon_sym_compl] = ACTIONS(3060),
    [anon_sym_DASH_DASH] = ACTIONS(3062),
    [anon_sym_PLUS_PLUS] = ACTIONS(3062),
    [anon_sym_sizeof] = ACTIONS(3060),
    [anon_sym___alignof__] = ACTIONS(3060),
    [anon_sym___alignof] = ACTIONS(3060),
    [anon_sym__alignof] = ACTIONS(3060),
    [anon_sym_alignof] = ACTIONS(3060),
    [anon_sym__Alignof] = ACTIONS(3060),
    [anon_sym_offsetof] = ACTIONS(3060),
    [anon_sym__Generic] = ACTIONS(3060),
    [anon_sym_asm] = ACTIONS(3060),
    [anon_sym___asm__] = ACTIONS(3060),
    [aux_sym_number_literal_token1] = ACTIONS(3062),
    [aux_sym_number_literal_token2] = ACTIONS(3060),
    [anon_sym_L_SQUOTE] = ACTIONS(3062),
    [anon_sym_u_SQUOTE] = ACTIONS(3062),
    [anon_sym_U_SQUOTE] = ACTIONS(3062),
    [anon_sym_u8_SQUOTE] = ACTIONS(3062),
    [anon_sym_SQUOTE] = ACTIONS(3062),
    [anon_sym_L_DQUOTE] = ACTIONS(3062),
    [anon_sym_u_DQUOTE] = ACTIONS(3062),
    [anon_sym_U_DQUOTE] = ACTIONS(3062),
    [anon_sym_u8_DQUOTE] = ACTIONS(3062),
    [anon_sym_DQUOTE] = ACTIONS(3062),
    [sym_true] = ACTIONS(3060),
    [sym_false] = ACTIONS(3060),
    [anon_sym_NULL] = ACTIONS(3060),
    [anon_sym_nullptr] = ACTIONS(3060),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3060),
    [anon_sym_decltype] = ACTIONS(3060),
    [anon_sym_virtual] = ACTIONS(3060),
    [anon_sym_alignas] = ACTIONS(3060),
    [anon_sym_explicit] = ACTIONS(3060),
    [anon_sym_typename] = ACTIONS(3060),
    [anon_sym_template] = ACTIONS(3060),
    [anon_sym_operator] = ACTIONS(3060),
    [anon_sym_try] = ACTIONS(3060),
    [anon_sym_delete] = ACTIONS(3060),
    [anon_sym_throw] = ACTIONS(3060),
    [anon_sym_namespace] = ACTIONS(3060),
    [anon_sym_using] = ACTIONS(3060),
    [anon_sym_static_assert] = ACTIONS(3060),
    [anon_sym_concept] = ACTIONS(3060),
    [anon_sym_co_return] = ACTIONS(3060),
    [anon_sym_co_yield] = ACTIONS(3060),
    [anon_sym_R_DQUOTE] = ACTIONS(3062),
    [anon_sym_LR_DQUOTE] = ACTIONS(3062),
    [anon_sym_uR_DQUOTE] = ACTIONS(3062),
    [anon_sym_UR_DQUOTE] = ACTIONS(3062),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3062),
    [anon_sym_co_await] = ACTIONS(3060),
    [anon_sym_new] = ACTIONS(3060),
    [anon_sym_requires] = ACTIONS(3060),
    [sym_this] = ACTIONS(3060),
  },
  [778] = {
    [sym_identifier] = ACTIONS(2993),
    [aux_sym_preproc_include_token1] = ACTIONS(2993),
    [aux_sym_preproc_def_token1] = ACTIONS(2993),
    [aux_sym_preproc_if_token1] = ACTIONS(2993),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2993),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2993),
    [sym_preproc_directive] = ACTIONS(2993),
    [anon_sym_LPAREN2] = ACTIONS(2995),
    [anon_sym_BANG] = ACTIONS(2995),
    [anon_sym_TILDE] = ACTIONS(2995),
    [anon_sym_DASH] = ACTIONS(2993),
    [anon_sym_PLUS] = ACTIONS(2993),
    [anon_sym_STAR] = ACTIONS(2995),
    [anon_sym_AMP_AMP] = ACTIONS(2995),
    [anon_sym_AMP] = ACTIONS(2993),
    [anon_sym_SEMI] = ACTIONS(2995),
    [anon_sym___extension__] = ACTIONS(2993),
    [anon_sym_typedef] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(2993),
    [anon_sym___attribute__] = ACTIONS(2993),
    [anon_sym_COLON_COLON] = ACTIONS(2995),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2995),
    [anon_sym___declspec] = ACTIONS(2993),
    [anon_sym___based] = ACTIONS(2993),
    [anon_sym___cdecl] = ACTIONS(2993),
    [anon_sym___clrcall] = ACTIONS(2993),
    [anon_sym___stdcall] = ACTIONS(2993),
    [anon_sym___fastcall] = ACTIONS(2993),
    [anon_sym___thiscall] = ACTIONS(2993),
    [anon_sym___vectorcall] = ACTIONS(2993),
    [anon_sym_LBRACE] = ACTIONS(2995),
    [anon_sym_RBRACE] = ACTIONS(2995),
    [anon_sym_signed] = ACTIONS(2993),
    [anon_sym_unsigned] = ACTIONS(2993),
    [anon_sym_long] = ACTIONS(2993),
    [anon_sym_short] = ACTIONS(2993),
    [anon_sym_LBRACK] = ACTIONS(2993),
    [anon_sym_static] = ACTIONS(2993),
    [anon_sym_register] = ACTIONS(2993),
    [anon_sym_inline] = ACTIONS(2993),
    [anon_sym___inline] = ACTIONS(2993),
    [anon_sym___inline__] = ACTIONS(2993),
    [anon_sym___forceinline] = ACTIONS(2993),
    [anon_sym_thread_local] = ACTIONS(2993),
    [anon_sym___thread] = ACTIONS(2993),
    [anon_sym_const] = ACTIONS(2993),
    [anon_sym_constexpr] = ACTIONS(2993),
    [anon_sym_volatile] = ACTIONS(2993),
    [anon_sym_restrict] = ACTIONS(2993),
    [anon_sym___restrict__] = ACTIONS(2993),
    [anon_sym__Atomic] = ACTIONS(2993),
    [anon_sym__Noreturn] = ACTIONS(2993),
    [anon_sym_noreturn] = ACTIONS(2993),
    [anon_sym_mutable] = ACTIONS(2993),
    [anon_sym_constinit] = ACTIONS(2993),
    [anon_sym_consteval] = ACTIONS(2993),
    [anon_sym_PROGMEM] = ACTIONS(2993),
    [aux_sym_primitive_type_token1] = ACTIONS(2993),
    [anon_sym_byte] = ACTIONS(2993),
    [anon_sym_word] = ACTIONS(2993),
    [anon_sym_enum] = ACTIONS(2993),
    [anon_sym_class] = ACTIONS(2993),
    [anon_sym_struct] = ACTIONS(2993),
    [anon_sym_union] = ACTIONS(2993),
    [anon_sym_if] = ACTIONS(2993),
    [anon_sym_switch] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2993),
    [anon_sym_default] = ACTIONS(2993),
    [anon_sym_while] = ACTIONS(2993),
    [anon_sym_do] = ACTIONS(2993),
    [anon_sym_for] = ACTIONS(2993),
    [anon_sym_return] = ACTIONS(2993),
    [anon_sym_break] = ACTIONS(2993),
    [anon_sym_continue] = ACTIONS(2993),
    [anon_sym_goto] = ACTIONS(2993),
    [anon_sym___try] = ACTIONS(2993),
    [anon_sym___leave] = ACTIONS(2993),
    [anon_sym_not] = ACTIONS(2993),
    [anon_sym_compl] = ACTIONS(2993),
    [anon_sym_DASH_DASH] = ACTIONS(2995),
    [anon_sym_PLUS_PLUS] = ACTIONS(2995),
    [anon_sym_sizeof] = ACTIONS(2993),
    [anon_sym___alignof__] = ACTIONS(2993),
    [anon_sym___alignof] = ACTIONS(2993),
    [anon_sym__alignof] = ACTIONS(2993),
    [anon_sym_alignof] = ACTIONS(2993),
    [anon_sym__Alignof] = ACTIONS(2993),
    [anon_sym_offsetof] = ACTIONS(2993),
    [anon_sym__Generic] = ACTIONS(2993),
    [anon_sym_asm] = ACTIONS(2993),
    [anon_sym___asm__] = ACTIONS(2993),
    [aux_sym_number_literal_token1] = ACTIONS(2995),
    [aux_sym_number_literal_token2] = ACTIONS(2993),
    [anon_sym_L_SQUOTE] = ACTIONS(2995),
    [anon_sym_u_SQUOTE] = ACTIONS(2995),
    [anon_sym_U_SQUOTE] = ACTIONS(2995),
    [anon_sym_u8_SQUOTE] = ACTIONS(2995),
    [anon_sym_SQUOTE] = ACTIONS(2995),
    [anon_sym_L_DQUOTE] = ACTIONS(2995),
    [anon_sym_u_DQUOTE] = ACTIONS(2995),
    [anon_sym_U_DQUOTE] = ACTIONS(2995),
    [anon_sym_u8_DQUOTE] = ACTIONS(2995),
    [anon_sym_DQUOTE] = ACTIONS(2995),
    [sym_true] = ACTIONS(2993),
    [sym_false] = ACTIONS(2993),
    [anon_sym_NULL] = ACTIONS(2993),
    [anon_sym_nullptr] = ACTIONS(2993),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2993),
    [anon_sym_decltype] = ACTIONS(2993),
    [anon_sym_virtual] = ACTIONS(2993),
    [anon_sym_alignas] = ACTIONS(2993),
    [anon_sym_explicit] = ACTIONS(2993),
    [anon_sym_typename] = ACTIONS(2993),
    [anon_sym_template] = ACTIONS(2993),
    [anon_sym_operator] = ACTIONS(2993),
    [anon_sym_try] = ACTIONS(2993),
    [anon_sym_delete] = ACTIONS(2993),
    [anon_sym_throw] = ACTIONS(2993),
    [anon_sym_namespace] = ACTIONS(2993),
    [anon_sym_using] = ACTIONS(2993),
    [anon_sym_static_assert] = ACTIONS(2993),
    [anon_sym_concept] = ACTIONS(2993),
    [anon_sym_co_return] = ACTIONS(2993),
    [anon_sym_co_yield] = ACTIONS(2993),
    [anon_sym_R_DQUOTE] = ACTIONS(2995),
    [anon_sym_LR_DQUOTE] = ACTIONS(2995),
    [anon_sym_uR_DQUOTE] = ACTIONS(2995),
    [anon_sym_UR_DQUOTE] = ACTIONS(2995),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2995),
    [anon_sym_co_await] = ACTIONS(2993),
    [anon_sym_new] = ACTIONS(2993),
    [anon_sym_requires] = ACTIONS(2993),
    [sym_this] = ACTIONS(2993),
  },
  [779] = {
    [sym_identifier] = ACTIONS(3132),
    [aux_sym_preproc_include_token1] = ACTIONS(3132),
    [aux_sym_preproc_def_token1] = ACTIONS(3132),
    [aux_sym_preproc_if_token1] = ACTIONS(3132),
    [aux_sym_preproc_if_token2] = ACTIONS(3132),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3132),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3132),
    [sym_preproc_directive] = ACTIONS(3132),
    [anon_sym_LPAREN2] = ACTIONS(3134),
    [anon_sym_BANG] = ACTIONS(3134),
    [anon_sym_TILDE] = ACTIONS(3134),
    [anon_sym_DASH] = ACTIONS(3132),
    [anon_sym_PLUS] = ACTIONS(3132),
    [anon_sym_STAR] = ACTIONS(3134),
    [anon_sym_AMP_AMP] = ACTIONS(3134),
    [anon_sym_AMP] = ACTIONS(3132),
    [anon_sym_SEMI] = ACTIONS(3134),
    [anon_sym___extension__] = ACTIONS(3132),
    [anon_sym_typedef] = ACTIONS(3132),
    [anon_sym_extern] = ACTIONS(3132),
    [anon_sym___attribute__] = ACTIONS(3132),
    [anon_sym_COLON_COLON] = ACTIONS(3134),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3134),
    [anon_sym___declspec] = ACTIONS(3132),
    [anon_sym___based] = ACTIONS(3132),
    [anon_sym___cdecl] = ACTIONS(3132),
    [anon_sym___clrcall] = ACTIONS(3132),
    [anon_sym___stdcall] = ACTIONS(3132),
    [anon_sym___fastcall] = ACTIONS(3132),
    [anon_sym___thiscall] = ACTIONS(3132),
    [anon_sym___vectorcall] = ACTIONS(3132),
    [anon_sym_LBRACE] = ACTIONS(3134),
    [anon_sym_signed] = ACTIONS(3132),
    [anon_sym_unsigned] = ACTIONS(3132),
    [anon_sym_long] = ACTIONS(3132),
    [anon_sym_short] = ACTIONS(3132),
    [anon_sym_LBRACK] = ACTIONS(3132),
    [anon_sym_static] = ACTIONS(3132),
    [anon_sym_register] = ACTIONS(3132),
    [anon_sym_inline] = ACTIONS(3132),
    [anon_sym___inline] = ACTIONS(3132),
    [anon_sym___inline__] = ACTIONS(3132),
    [anon_sym___forceinline] = ACTIONS(3132),
    [anon_sym_thread_local] = ACTIONS(3132),
    [anon_sym___thread] = ACTIONS(3132),
    [anon_sym_const] = ACTIONS(3132),
    [anon_sym_constexpr] = ACTIONS(3132),
    [anon_sym_volatile] = ACTIONS(3132),
    [anon_sym_restrict] = ACTIONS(3132),
    [anon_sym___restrict__] = ACTIONS(3132),
    [anon_sym__Atomic] = ACTIONS(3132),
    [anon_sym__Noreturn] = ACTIONS(3132),
    [anon_sym_noreturn] = ACTIONS(3132),
    [anon_sym_mutable] = ACTIONS(3132),
    [anon_sym_constinit] = ACTIONS(3132),
    [anon_sym_consteval] = ACTIONS(3132),
    [anon_sym_PROGMEM] = ACTIONS(3132),
    [aux_sym_primitive_type_token1] = ACTIONS(3132),
    [anon_sym_byte] = ACTIONS(3132),
    [anon_sym_word] = ACTIONS(3132),
    [anon_sym_enum] = ACTIONS(3132),
    [anon_sym_class] = ACTIONS(3132),
    [anon_sym_struct] = ACTIONS(3132),
    [anon_sym_union] = ACTIONS(3132),
    [anon_sym_if] = ACTIONS(3132),
    [anon_sym_switch] = ACTIONS(3132),
    [anon_sym_case] = ACTIONS(3132),
    [anon_sym_default] = ACTIONS(3132),
    [anon_sym_while] = ACTIONS(3132),
    [anon_sym_do] = ACTIONS(3132),
    [anon_sym_for] = ACTIONS(3132),
    [anon_sym_return] = ACTIONS(3132),
    [anon_sym_break] = ACTIONS(3132),
    [anon_sym_continue] = ACTIONS(3132),
    [anon_sym_goto] = ACTIONS(3132),
    [anon_sym___try] = ACTIONS(3132),
    [anon_sym___leave] = ACTIONS(3132),
    [anon_sym_not] = ACTIONS(3132),
    [anon_sym_compl] = ACTIONS(3132),
    [anon_sym_DASH_DASH] = ACTIONS(3134),
    [anon_sym_PLUS_PLUS] = ACTIONS(3134),
    [anon_sym_sizeof] = ACTIONS(3132),
    [anon_sym___alignof__] = ACTIONS(3132),
    [anon_sym___alignof] = ACTIONS(3132),
    [anon_sym__alignof] = ACTIONS(3132),
    [anon_sym_alignof] = ACTIONS(3132),
    [anon_sym__Alignof] = ACTIONS(3132),
    [anon_sym_offsetof] = ACTIONS(3132),
    [anon_sym__Generic] = ACTIONS(3132),
    [anon_sym_asm] = ACTIONS(3132),
    [anon_sym___asm__] = ACTIONS(3132),
    [aux_sym_number_literal_token1] = ACTIONS(3134),
    [aux_sym_number_literal_token2] = ACTIONS(3132),
    [anon_sym_L_SQUOTE] = ACTIONS(3134),
    [anon_sym_u_SQUOTE] = ACTIONS(3134),
    [anon_sym_U_SQUOTE] = ACTIONS(3134),
    [anon_sym_u8_SQUOTE] = ACTIONS(3134),
    [anon_sym_SQUOTE] = ACTIONS(3134),
    [anon_sym_L_DQUOTE] = ACTIONS(3134),
    [anon_sym_u_DQUOTE] = ACTIONS(3134),
    [anon_sym_U_DQUOTE] = ACTIONS(3134),
    [anon_sym_u8_DQUOTE] = ACTIONS(3134),
    [anon_sym_DQUOTE] = ACTIONS(3134),
    [sym_true] = ACTIONS(3132),
    [sym_false] = ACTIONS(3132),
    [anon_sym_NULL] = ACTIONS(3132),
    [anon_sym_nullptr] = ACTIONS(3132),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3132),
    [anon_sym_decltype] = ACTIONS(3132),
    [anon_sym_virtual] = ACTIONS(3132),
    [anon_sym_alignas] = ACTIONS(3132),
    [anon_sym_explicit] = ACTIONS(3132),
    [anon_sym_typename] = ACTIONS(3132),
    [anon_sym_template] = ACTIONS(3132),
    [anon_sym_operator] = ACTIONS(3132),
    [anon_sym_try] = ACTIONS(3132),
    [anon_sym_delete] = ACTIONS(3132),
    [anon_sym_throw] = ACTIONS(3132),
    [anon_sym_namespace] = ACTIONS(3132),
    [anon_sym_using] = ACTIONS(3132),
    [anon_sym_static_assert] = ACTIONS(3132),
    [anon_sym_concept] = ACTIONS(3132),
    [anon_sym_co_return] = ACTIONS(3132),
    [anon_sym_co_yield] = ACTIONS(3132),
    [anon_sym_R_DQUOTE] = ACTIONS(3134),
    [anon_sym_LR_DQUOTE] = ACTIONS(3134),
    [anon_sym_uR_DQUOTE] = ACTIONS(3134),
    [anon_sym_UR_DQUOTE] = ACTIONS(3134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3134),
    [anon_sym_co_await] = ACTIONS(3132),
    [anon_sym_new] = ACTIONS(3132),
    [anon_sym_requires] = ACTIONS(3132),
    [sym_this] = ACTIONS(3132),
  },
  [780] = {
    [sym_identifier] = ACTIONS(2989),
    [aux_sym_preproc_include_token1] = ACTIONS(2989),
    [aux_sym_preproc_def_token1] = ACTIONS(2989),
    [aux_sym_preproc_if_token1] = ACTIONS(2989),
    [aux_sym_preproc_if_token2] = ACTIONS(2989),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2989),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2989),
    [sym_preproc_directive] = ACTIONS(2989),
    [anon_sym_LPAREN2] = ACTIONS(2991),
    [anon_sym_BANG] = ACTIONS(2991),
    [anon_sym_TILDE] = ACTIONS(2991),
    [anon_sym_DASH] = ACTIONS(2989),
    [anon_sym_PLUS] = ACTIONS(2989),
    [anon_sym_STAR] = ACTIONS(2991),
    [anon_sym_AMP_AMP] = ACTIONS(2991),
    [anon_sym_AMP] = ACTIONS(2989),
    [anon_sym_SEMI] = ACTIONS(2991),
    [anon_sym___extension__] = ACTIONS(2989),
    [anon_sym_typedef] = ACTIONS(2989),
    [anon_sym_extern] = ACTIONS(2989),
    [anon_sym___attribute__] = ACTIONS(2989),
    [anon_sym_COLON_COLON] = ACTIONS(2991),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2991),
    [anon_sym___declspec] = ACTIONS(2989),
    [anon_sym___based] = ACTIONS(2989),
    [anon_sym___cdecl] = ACTIONS(2989),
    [anon_sym___clrcall] = ACTIONS(2989),
    [anon_sym___stdcall] = ACTIONS(2989),
    [anon_sym___fastcall] = ACTIONS(2989),
    [anon_sym___thiscall] = ACTIONS(2989),
    [anon_sym___vectorcall] = ACTIONS(2989),
    [anon_sym_LBRACE] = ACTIONS(2991),
    [anon_sym_signed] = ACTIONS(2989),
    [anon_sym_unsigned] = ACTIONS(2989),
    [anon_sym_long] = ACTIONS(2989),
    [anon_sym_short] = ACTIONS(2989),
    [anon_sym_LBRACK] = ACTIONS(2989),
    [anon_sym_static] = ACTIONS(2989),
    [anon_sym_register] = ACTIONS(2989),
    [anon_sym_inline] = ACTIONS(2989),
    [anon_sym___inline] = ACTIONS(2989),
    [anon_sym___inline__] = ACTIONS(2989),
    [anon_sym___forceinline] = ACTIONS(2989),
    [anon_sym_thread_local] = ACTIONS(2989),
    [anon_sym___thread] = ACTIONS(2989),
    [anon_sym_const] = ACTIONS(2989),
    [anon_sym_constexpr] = ACTIONS(2989),
    [anon_sym_volatile] = ACTIONS(2989),
    [anon_sym_restrict] = ACTIONS(2989),
    [anon_sym___restrict__] = ACTIONS(2989),
    [anon_sym__Atomic] = ACTIONS(2989),
    [anon_sym__Noreturn] = ACTIONS(2989),
    [anon_sym_noreturn] = ACTIONS(2989),
    [anon_sym_mutable] = ACTIONS(2989),
    [anon_sym_constinit] = ACTIONS(2989),
    [anon_sym_consteval] = ACTIONS(2989),
    [anon_sym_PROGMEM] = ACTIONS(2989),
    [aux_sym_primitive_type_token1] = ACTIONS(2989),
    [anon_sym_byte] = ACTIONS(2989),
    [anon_sym_word] = ACTIONS(2989),
    [anon_sym_enum] = ACTIONS(2989),
    [anon_sym_class] = ACTIONS(2989),
    [anon_sym_struct] = ACTIONS(2989),
    [anon_sym_union] = ACTIONS(2989),
    [anon_sym_if] = ACTIONS(2989),
    [anon_sym_switch] = ACTIONS(2989),
    [anon_sym_case] = ACTIONS(2989),
    [anon_sym_default] = ACTIONS(2989),
    [anon_sym_while] = ACTIONS(2989),
    [anon_sym_do] = ACTIONS(2989),
    [anon_sym_for] = ACTIONS(2989),
    [anon_sym_return] = ACTIONS(2989),
    [anon_sym_break] = ACTIONS(2989),
    [anon_sym_continue] = ACTIONS(2989),
    [anon_sym_goto] = ACTIONS(2989),
    [anon_sym___try] = ACTIONS(2989),
    [anon_sym___leave] = ACTIONS(2989),
    [anon_sym_not] = ACTIONS(2989),
    [anon_sym_compl] = ACTIONS(2989),
    [anon_sym_DASH_DASH] = ACTIONS(2991),
    [anon_sym_PLUS_PLUS] = ACTIONS(2991),
    [anon_sym_sizeof] = ACTIONS(2989),
    [anon_sym___alignof__] = ACTIONS(2989),
    [anon_sym___alignof] = ACTIONS(2989),
    [anon_sym__alignof] = ACTIONS(2989),
    [anon_sym_alignof] = ACTIONS(2989),
    [anon_sym__Alignof] = ACTIONS(2989),
    [anon_sym_offsetof] = ACTIONS(2989),
    [anon_sym__Generic] = ACTIONS(2989),
    [anon_sym_asm] = ACTIONS(2989),
    [anon_sym___asm__] = ACTIONS(2989),
    [aux_sym_number_literal_token1] = ACTIONS(2991),
    [aux_sym_number_literal_token2] = ACTIONS(2989),
    [anon_sym_L_SQUOTE] = ACTIONS(2991),
    [anon_sym_u_SQUOTE] = ACTIONS(2991),
    [anon_sym_U_SQUOTE] = ACTIONS(2991),
    [anon_sym_u8_SQUOTE] = ACTIONS(2991),
    [anon_sym_SQUOTE] = ACTIONS(2991),
    [anon_sym_L_DQUOTE] = ACTIONS(2991),
    [anon_sym_u_DQUOTE] = ACTIONS(2991),
    [anon_sym_U_DQUOTE] = ACTIONS(2991),
    [anon_sym_u8_DQUOTE] = ACTIONS(2991),
    [anon_sym_DQUOTE] = ACTIONS(2991),
    [sym_true] = ACTIONS(2989),
    [sym_false] = ACTIONS(2989),
    [anon_sym_NULL] = ACTIONS(2989),
    [anon_sym_nullptr] = ACTIONS(2989),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2989),
    [anon_sym_decltype] = ACTIONS(2989),
    [anon_sym_virtual] = ACTIONS(2989),
    [anon_sym_alignas] = ACTIONS(2989),
    [anon_sym_explicit] = ACTIONS(2989),
    [anon_sym_typename] = ACTIONS(2989),
    [anon_sym_template] = ACTIONS(2989),
    [anon_sym_operator] = ACTIONS(2989),
    [anon_sym_try] = ACTIONS(2989),
    [anon_sym_delete] = ACTIONS(2989),
    [anon_sym_throw] = ACTIONS(2989),
    [anon_sym_namespace] = ACTIONS(2989),
    [anon_sym_using] = ACTIONS(2989),
    [anon_sym_static_assert] = ACTIONS(2989),
    [anon_sym_concept] = ACTIONS(2989),
    [anon_sym_co_return] = ACTIONS(2989),
    [anon_sym_co_yield] = ACTIONS(2989),
    [anon_sym_R_DQUOTE] = ACTIONS(2991),
    [anon_sym_LR_DQUOTE] = ACTIONS(2991),
    [anon_sym_uR_DQUOTE] = ACTIONS(2991),
    [anon_sym_UR_DQUOTE] = ACTIONS(2991),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2991),
    [anon_sym_co_await] = ACTIONS(2989),
    [anon_sym_new] = ACTIONS(2989),
    [anon_sym_requires] = ACTIONS(2989),
    [sym_this] = ACTIONS(2989),
  },
  [781] = {
    [sym_catch_clause] = STATE(368),
    [aux_sym_constructor_try_statement_repeat1] = STATE(368),
    [ts_builtin_sym_end] = ACTIONS(2490),
    [sym_identifier] = ACTIONS(2488),
    [aux_sym_preproc_include_token1] = ACTIONS(2488),
    [aux_sym_preproc_def_token1] = ACTIONS(2488),
    [aux_sym_preproc_if_token1] = ACTIONS(2488),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2488),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2488),
    [sym_preproc_directive] = ACTIONS(2488),
    [anon_sym_LPAREN2] = ACTIONS(2490),
    [anon_sym_BANG] = ACTIONS(2490),
    [anon_sym_TILDE] = ACTIONS(2490),
    [anon_sym_DASH] = ACTIONS(2488),
    [anon_sym_PLUS] = ACTIONS(2488),
    [anon_sym_STAR] = ACTIONS(2490),
    [anon_sym_AMP_AMP] = ACTIONS(2490),
    [anon_sym_AMP] = ACTIONS(2488),
    [anon_sym___extension__] = ACTIONS(2488),
    [anon_sym_typedef] = ACTIONS(2488),
    [anon_sym_extern] = ACTIONS(2488),
    [anon_sym___attribute__] = ACTIONS(2488),
    [anon_sym_COLON_COLON] = ACTIONS(2490),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2490),
    [anon_sym___declspec] = ACTIONS(2488),
    [anon_sym___based] = ACTIONS(2488),
    [anon_sym___cdecl] = ACTIONS(2488),
    [anon_sym___clrcall] = ACTIONS(2488),
    [anon_sym___stdcall] = ACTIONS(2488),
    [anon_sym___fastcall] = ACTIONS(2488),
    [anon_sym___thiscall] = ACTIONS(2488),
    [anon_sym___vectorcall] = ACTIONS(2488),
    [anon_sym_LBRACE] = ACTIONS(2490),
    [anon_sym_signed] = ACTIONS(2488),
    [anon_sym_unsigned] = ACTIONS(2488),
    [anon_sym_long] = ACTIONS(2488),
    [anon_sym_short] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(2488),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_register] = ACTIONS(2488),
    [anon_sym_inline] = ACTIONS(2488),
    [anon_sym___inline] = ACTIONS(2488),
    [anon_sym___inline__] = ACTIONS(2488),
    [anon_sym___forceinline] = ACTIONS(2488),
    [anon_sym_thread_local] = ACTIONS(2488),
    [anon_sym___thread] = ACTIONS(2488),
    [anon_sym_const] = ACTIONS(2488),
    [anon_sym_constexpr] = ACTIONS(2488),
    [anon_sym_volatile] = ACTIONS(2488),
    [anon_sym_restrict] = ACTIONS(2488),
    [anon_sym___restrict__] = ACTIONS(2488),
    [anon_sym__Atomic] = ACTIONS(2488),
    [anon_sym__Noreturn] = ACTIONS(2488),
    [anon_sym_noreturn] = ACTIONS(2488),
    [anon_sym_mutable] = ACTIONS(2488),
    [anon_sym_constinit] = ACTIONS(2488),
    [anon_sym_consteval] = ACTIONS(2488),
    [anon_sym_PROGMEM] = ACTIONS(2488),
    [aux_sym_primitive_type_token1] = ACTIONS(2488),
    [anon_sym_byte] = ACTIONS(2488),
    [anon_sym_word] = ACTIONS(2488),
    [anon_sym_enum] = ACTIONS(2488),
    [anon_sym_class] = ACTIONS(2488),
    [anon_sym_struct] = ACTIONS(2488),
    [anon_sym_union] = ACTIONS(2488),
    [anon_sym_if] = ACTIONS(2488),
    [anon_sym_switch] = ACTIONS(2488),
    [anon_sym_case] = ACTIONS(2488),
    [anon_sym_default] = ACTIONS(2488),
    [anon_sym_while] = ACTIONS(2488),
    [anon_sym_do] = ACTIONS(2488),
    [anon_sym_for] = ACTIONS(2488),
    [anon_sym_return] = ACTIONS(2488),
    [anon_sym_break] = ACTIONS(2488),
    [anon_sym_continue] = ACTIONS(2488),
    [anon_sym_goto] = ACTIONS(2488),
    [anon_sym_not] = ACTIONS(2488),
    [anon_sym_compl] = ACTIONS(2488),
    [anon_sym_DASH_DASH] = ACTIONS(2490),
    [anon_sym_PLUS_PLUS] = ACTIONS(2490),
    [anon_sym_sizeof] = ACTIONS(2488),
    [anon_sym___alignof__] = ACTIONS(2488),
    [anon_sym___alignof] = ACTIONS(2488),
    [anon_sym__alignof] = ACTIONS(2488),
    [anon_sym_alignof] = ACTIONS(2488),
    [anon_sym__Alignof] = ACTIONS(2488),
    [anon_sym_offsetof] = ACTIONS(2488),
    [anon_sym__Generic] = ACTIONS(2488),
    [anon_sym_asm] = ACTIONS(2488),
    [anon_sym___asm__] = ACTIONS(2488),
    [aux_sym_number_literal_token1] = ACTIONS(2490),
    [aux_sym_number_literal_token2] = ACTIONS(2488),
    [anon_sym_L_SQUOTE] = ACTIONS(2490),
    [anon_sym_u_SQUOTE] = ACTIONS(2490),
    [anon_sym_U_SQUOTE] = ACTIONS(2490),
    [anon_sym_u8_SQUOTE] = ACTIONS(2490),
    [anon_sym_SQUOTE] = ACTIONS(2490),
    [anon_sym_L_DQUOTE] = ACTIONS(2490),
    [anon_sym_u_DQUOTE] = ACTIONS(2490),
    [anon_sym_U_DQUOTE] = ACTIONS(2490),
    [anon_sym_u8_DQUOTE] = ACTIONS(2490),
    [anon_sym_DQUOTE] = ACTIONS(2490),
    [sym_true] = ACTIONS(2488),
    [sym_false] = ACTIONS(2488),
    [anon_sym_NULL] = ACTIONS(2488),
    [anon_sym_nullptr] = ACTIONS(2488),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2488),
    [anon_sym_decltype] = ACTIONS(2488),
    [anon_sym_virtual] = ACTIONS(2488),
    [anon_sym_alignas] = ACTIONS(2488),
    [anon_sym_explicit] = ACTIONS(2488),
    [anon_sym_typename] = ACTIONS(2488),
    [anon_sym_template] = ACTIONS(2488),
    [anon_sym_operator] = ACTIONS(2488),
    [anon_sym_try] = ACTIONS(2488),
    [anon_sym_delete] = ACTIONS(2488),
    [anon_sym_throw] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_using] = ACTIONS(2488),
    [anon_sym_static_assert] = ACTIONS(2488),
    [anon_sym_concept] = ACTIONS(2488),
    [anon_sym_co_return] = ACTIONS(2488),
    [anon_sym_co_yield] = ACTIONS(2488),
    [anon_sym_catch] = ACTIONS(2961),
    [anon_sym_R_DQUOTE] = ACTIONS(2490),
    [anon_sym_LR_DQUOTE] = ACTIONS(2490),
    [anon_sym_uR_DQUOTE] = ACTIONS(2490),
    [anon_sym_UR_DQUOTE] = ACTIONS(2490),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2490),
    [anon_sym_co_await] = ACTIONS(2488),
    [anon_sym_new] = ACTIONS(2488),
    [anon_sym_requires] = ACTIONS(2488),
    [sym_this] = ACTIONS(2488),
  },
  [782] = {
    [sym_identifier] = ACTIONS(3148),
    [aux_sym_preproc_include_token1] = ACTIONS(3148),
    [aux_sym_preproc_def_token1] = ACTIONS(3148),
    [aux_sym_preproc_if_token1] = ACTIONS(3148),
    [aux_sym_preproc_if_token2] = ACTIONS(3148),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3148),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3148),
    [sym_preproc_directive] = ACTIONS(3148),
    [anon_sym_LPAREN2] = ACTIONS(3150),
    [anon_sym_BANG] = ACTIONS(3150),
    [anon_sym_TILDE] = ACTIONS(3150),
    [anon_sym_DASH] = ACTIONS(3148),
    [anon_sym_PLUS] = ACTIONS(3148),
    [anon_sym_STAR] = ACTIONS(3150),
    [anon_sym_AMP_AMP] = ACTIONS(3150),
    [anon_sym_AMP] = ACTIONS(3148),
    [anon_sym_SEMI] = ACTIONS(3150),
    [anon_sym___extension__] = ACTIONS(3148),
    [anon_sym_typedef] = ACTIONS(3148),
    [anon_sym_extern] = ACTIONS(3148),
    [anon_sym___attribute__] = ACTIONS(3148),
    [anon_sym_COLON_COLON] = ACTIONS(3150),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3150),
    [anon_sym___declspec] = ACTIONS(3148),
    [anon_sym___based] = ACTIONS(3148),
    [anon_sym___cdecl] = ACTIONS(3148),
    [anon_sym___clrcall] = ACTIONS(3148),
    [anon_sym___stdcall] = ACTIONS(3148),
    [anon_sym___fastcall] = ACTIONS(3148),
    [anon_sym___thiscall] = ACTIONS(3148),
    [anon_sym___vectorcall] = ACTIONS(3148),
    [anon_sym_LBRACE] = ACTIONS(3150),
    [anon_sym_signed] = ACTIONS(3148),
    [anon_sym_unsigned] = ACTIONS(3148),
    [anon_sym_long] = ACTIONS(3148),
    [anon_sym_short] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_static] = ACTIONS(3148),
    [anon_sym_register] = ACTIONS(3148),
    [anon_sym_inline] = ACTIONS(3148),
    [anon_sym___inline] = ACTIONS(3148),
    [anon_sym___inline__] = ACTIONS(3148),
    [anon_sym___forceinline] = ACTIONS(3148),
    [anon_sym_thread_local] = ACTIONS(3148),
    [anon_sym___thread] = ACTIONS(3148),
    [anon_sym_const] = ACTIONS(3148),
    [anon_sym_constexpr] = ACTIONS(3148),
    [anon_sym_volatile] = ACTIONS(3148),
    [anon_sym_restrict] = ACTIONS(3148),
    [anon_sym___restrict__] = ACTIONS(3148),
    [anon_sym__Atomic] = ACTIONS(3148),
    [anon_sym__Noreturn] = ACTIONS(3148),
    [anon_sym_noreturn] = ACTIONS(3148),
    [anon_sym_mutable] = ACTIONS(3148),
    [anon_sym_constinit] = ACTIONS(3148),
    [anon_sym_consteval] = ACTIONS(3148),
    [anon_sym_PROGMEM] = ACTIONS(3148),
    [aux_sym_primitive_type_token1] = ACTIONS(3148),
    [anon_sym_byte] = ACTIONS(3148),
    [anon_sym_word] = ACTIONS(3148),
    [anon_sym_enum] = ACTIONS(3148),
    [anon_sym_class] = ACTIONS(3148),
    [anon_sym_struct] = ACTIONS(3148),
    [anon_sym_union] = ACTIONS(3148),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_switch] = ACTIONS(3148),
    [anon_sym_case] = ACTIONS(3148),
    [anon_sym_default] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_for] = ACTIONS(3148),
    [anon_sym_return] = ACTIONS(3148),
    [anon_sym_break] = ACTIONS(3148),
    [anon_sym_continue] = ACTIONS(3148),
    [anon_sym_goto] = ACTIONS(3148),
    [anon_sym___try] = ACTIONS(3148),
    [anon_sym___leave] = ACTIONS(3148),
    [anon_sym_not] = ACTIONS(3148),
    [anon_sym_compl] = ACTIONS(3148),
    [anon_sym_DASH_DASH] = ACTIONS(3150),
    [anon_sym_PLUS_PLUS] = ACTIONS(3150),
    [anon_sym_sizeof] = ACTIONS(3148),
    [anon_sym___alignof__] = ACTIONS(3148),
    [anon_sym___alignof] = ACTIONS(3148),
    [anon_sym__alignof] = ACTIONS(3148),
    [anon_sym_alignof] = ACTIONS(3148),
    [anon_sym__Alignof] = ACTIONS(3148),
    [anon_sym_offsetof] = ACTIONS(3148),
    [anon_sym__Generic] = ACTIONS(3148),
    [anon_sym_asm] = ACTIONS(3148),
    [anon_sym___asm__] = ACTIONS(3148),
    [aux_sym_number_literal_token1] = ACTIONS(3150),
    [aux_sym_number_literal_token2] = ACTIONS(3148),
    [anon_sym_L_SQUOTE] = ACTIONS(3150),
    [anon_sym_u_SQUOTE] = ACTIONS(3150),
    [anon_sym_U_SQUOTE] = ACTIONS(3150),
    [anon_sym_u8_SQUOTE] = ACTIONS(3150),
    [anon_sym_SQUOTE] = ACTIONS(3150),
    [anon_sym_L_DQUOTE] = ACTIONS(3150),
    [anon_sym_u_DQUOTE] = ACTIONS(3150),
    [anon_sym_U_DQUOTE] = ACTIONS(3150),
    [anon_sym_u8_DQUOTE] = ACTIONS(3150),
    [anon_sym_DQUOTE] = ACTIONS(3150),
    [sym_true] = ACTIONS(3148),
    [sym_false] = ACTIONS(3148),
    [anon_sym_NULL] = ACTIONS(3148),
    [anon_sym_nullptr] = ACTIONS(3148),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3148),
    [anon_sym_decltype] = ACTIONS(3148),
    [anon_sym_virtual] = ACTIONS(3148),
    [anon_sym_alignas] = ACTIONS(3148),
    [anon_sym_explicit] = ACTIONS(3148),
    [anon_sym_typename] = ACTIONS(3148),
    [anon_sym_template] = ACTIONS(3148),
    [anon_sym_operator] = ACTIONS(3148),
    [anon_sym_try] = ACTIONS(3148),
    [anon_sym_delete] = ACTIONS(3148),
    [anon_sym_throw] = ACTIONS(3148),
    [anon_sym_namespace] = ACTIONS(3148),
    [anon_sym_using] = ACTIONS(3148),
    [anon_sym_static_assert] = ACTIONS(3148),
    [anon_sym_concept] = ACTIONS(3148),
    [anon_sym_co_return] = ACTIONS(3148),
    [anon_sym_co_yield] = ACTIONS(3148),
    [anon_sym_R_DQUOTE] = ACTIONS(3150),
    [anon_sym_LR_DQUOTE] = ACTIONS(3150),
    [anon_sym_uR_DQUOTE] = ACTIONS(3150),
    [anon_sym_UR_DQUOTE] = ACTIONS(3150),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3150),
    [anon_sym_co_await] = ACTIONS(3148),
    [anon_sym_new] = ACTIONS(3148),
    [anon_sym_requires] = ACTIONS(3148),
    [sym_this] = ACTIONS(3148),
  },
  [783] = {
    [sym_identifier] = ACTIONS(3126),
    [aux_sym_preproc_include_token1] = ACTIONS(3126),
    [aux_sym_preproc_def_token1] = ACTIONS(3126),
    [aux_sym_preproc_if_token1] = ACTIONS(3126),
    [aux_sym_preproc_if_token2] = ACTIONS(3126),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3126),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3126),
    [sym_preproc_directive] = ACTIONS(3126),
    [anon_sym_LPAREN2] = ACTIONS(3128),
    [anon_sym_BANG] = ACTIONS(3128),
    [anon_sym_TILDE] = ACTIONS(3128),
    [anon_sym_DASH] = ACTIONS(3126),
    [anon_sym_PLUS] = ACTIONS(3126),
    [anon_sym_STAR] = ACTIONS(3128),
    [anon_sym_AMP_AMP] = ACTIONS(3128),
    [anon_sym_AMP] = ACTIONS(3126),
    [anon_sym_SEMI] = ACTIONS(3128),
    [anon_sym___extension__] = ACTIONS(3126),
    [anon_sym_typedef] = ACTIONS(3126),
    [anon_sym_extern] = ACTIONS(3126),
    [anon_sym___attribute__] = ACTIONS(3126),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3128),
    [anon_sym___declspec] = ACTIONS(3126),
    [anon_sym___based] = ACTIONS(3126),
    [anon_sym___cdecl] = ACTIONS(3126),
    [anon_sym___clrcall] = ACTIONS(3126),
    [anon_sym___stdcall] = ACTIONS(3126),
    [anon_sym___fastcall] = ACTIONS(3126),
    [anon_sym___thiscall] = ACTIONS(3126),
    [anon_sym___vectorcall] = ACTIONS(3126),
    [anon_sym_LBRACE] = ACTIONS(3128),
    [anon_sym_signed] = ACTIONS(3126),
    [anon_sym_unsigned] = ACTIONS(3126),
    [anon_sym_long] = ACTIONS(3126),
    [anon_sym_short] = ACTIONS(3126),
    [anon_sym_LBRACK] = ACTIONS(3126),
    [anon_sym_static] = ACTIONS(3126),
    [anon_sym_register] = ACTIONS(3126),
    [anon_sym_inline] = ACTIONS(3126),
    [anon_sym___inline] = ACTIONS(3126),
    [anon_sym___inline__] = ACTIONS(3126),
    [anon_sym___forceinline] = ACTIONS(3126),
    [anon_sym_thread_local] = ACTIONS(3126),
    [anon_sym___thread] = ACTIONS(3126),
    [anon_sym_const] = ACTIONS(3126),
    [anon_sym_constexpr] = ACTIONS(3126),
    [anon_sym_volatile] = ACTIONS(3126),
    [anon_sym_restrict] = ACTIONS(3126),
    [anon_sym___restrict__] = ACTIONS(3126),
    [anon_sym__Atomic] = ACTIONS(3126),
    [anon_sym__Noreturn] = ACTIONS(3126),
    [anon_sym_noreturn] = ACTIONS(3126),
    [anon_sym_mutable] = ACTIONS(3126),
    [anon_sym_constinit] = ACTIONS(3126),
    [anon_sym_consteval] = ACTIONS(3126),
    [anon_sym_PROGMEM] = ACTIONS(3126),
    [aux_sym_primitive_type_token1] = ACTIONS(3126),
    [anon_sym_byte] = ACTIONS(3126),
    [anon_sym_word] = ACTIONS(3126),
    [anon_sym_enum] = ACTIONS(3126),
    [anon_sym_class] = ACTIONS(3126),
    [anon_sym_struct] = ACTIONS(3126),
    [anon_sym_union] = ACTIONS(3126),
    [anon_sym_if] = ACTIONS(3126),
    [anon_sym_switch] = ACTIONS(3126),
    [anon_sym_case] = ACTIONS(3126),
    [anon_sym_default] = ACTIONS(3126),
    [anon_sym_while] = ACTIONS(3126),
    [anon_sym_do] = ACTIONS(3126),
    [anon_sym_for] = ACTIONS(3126),
    [anon_sym_return] = ACTIONS(3126),
    [anon_sym_break] = ACTIONS(3126),
    [anon_sym_continue] = ACTIONS(3126),
    [anon_sym_goto] = ACTIONS(3126),
    [anon_sym___try] = ACTIONS(3126),
    [anon_sym___leave] = ACTIONS(3126),
    [anon_sym_not] = ACTIONS(3126),
    [anon_sym_compl] = ACTIONS(3126),
    [anon_sym_DASH_DASH] = ACTIONS(3128),
    [anon_sym_PLUS_PLUS] = ACTIONS(3128),
    [anon_sym_sizeof] = ACTIONS(3126),
    [anon_sym___alignof__] = ACTIONS(3126),
    [anon_sym___alignof] = ACTIONS(3126),
    [anon_sym__alignof] = ACTIONS(3126),
    [anon_sym_alignof] = ACTIONS(3126),
    [anon_sym__Alignof] = ACTIONS(3126),
    [anon_sym_offsetof] = ACTIONS(3126),
    [anon_sym__Generic] = ACTIONS(3126),
    [anon_sym_asm] = ACTIONS(3126),
    [anon_sym___asm__] = ACTIONS(3126),
    [aux_sym_number_literal_token1] = ACTIONS(3128),
    [aux_sym_number_literal_token2] = ACTIONS(3126),
    [anon_sym_L_SQUOTE] = ACTIONS(3128),
    [anon_sym_u_SQUOTE] = ACTIONS(3128),
    [anon_sym_U_SQUOTE] = ACTIONS(3128),
    [anon_sym_u8_SQUOTE] = ACTIONS(3128),
    [anon_sym_SQUOTE] = ACTIONS(3128),
    [anon_sym_L_DQUOTE] = ACTIONS(3128),
    [anon_sym_u_DQUOTE] = ACTIONS(3128),
    [anon_sym_U_DQUOTE] = ACTIONS(3128),
    [anon_sym_u8_DQUOTE] = ACTIONS(3128),
    [anon_sym_DQUOTE] = ACTIONS(3128),
    [sym_true] = ACTIONS(3126),
    [sym_false] = ACTIONS(3126),
    [anon_sym_NULL] = ACTIONS(3126),
    [anon_sym_nullptr] = ACTIONS(3126),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3126),
    [anon_sym_decltype] = ACTIONS(3126),
    [anon_sym_virtual] = ACTIONS(3126),
    [anon_sym_alignas] = ACTIONS(3126),
    [anon_sym_explicit] = ACTIONS(3126),
    [anon_sym_typename] = ACTIONS(3126),
    [anon_sym_template] = ACTIONS(3126),
    [anon_sym_operator] = ACTIONS(3126),
    [anon_sym_try] = ACTIONS(3126),
    [anon_sym_delete] = ACTIONS(3126),
    [anon_sym_throw] = ACTIONS(3126),
    [anon_sym_namespace] = ACTIONS(3126),
    [anon_sym_using] = ACTIONS(3126),
    [anon_sym_static_assert] = ACTIONS(3126),
    [anon_sym_concept] = ACTIONS(3126),
    [anon_sym_co_return] = ACTIONS(3126),
    [anon_sym_co_yield] = ACTIONS(3126),
    [anon_sym_R_DQUOTE] = ACTIONS(3128),
    [anon_sym_LR_DQUOTE] = ACTIONS(3128),
    [anon_sym_uR_DQUOTE] = ACTIONS(3128),
    [anon_sym_UR_DQUOTE] = ACTIONS(3128),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3128),
    [anon_sym_co_await] = ACTIONS(3126),
    [anon_sym_new] = ACTIONS(3126),
    [anon_sym_requires] = ACTIONS(3126),
    [sym_this] = ACTIONS(3126),
  },
  [784] = {
    [sym_identifier] = ACTIONS(2993),
    [aux_sym_preproc_include_token1] = ACTIONS(2993),
    [aux_sym_preproc_def_token1] = ACTIONS(2993),
    [aux_sym_preproc_if_token1] = ACTIONS(2993),
    [aux_sym_preproc_if_token2] = ACTIONS(2993),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2993),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2993),
    [sym_preproc_directive] = ACTIONS(2993),
    [anon_sym_LPAREN2] = ACTIONS(2995),
    [anon_sym_BANG] = ACTIONS(2995),
    [anon_sym_TILDE] = ACTIONS(2995),
    [anon_sym_DASH] = ACTIONS(2993),
    [anon_sym_PLUS] = ACTIONS(2993),
    [anon_sym_STAR] = ACTIONS(2995),
    [anon_sym_AMP_AMP] = ACTIONS(2995),
    [anon_sym_AMP] = ACTIONS(2993),
    [anon_sym_SEMI] = ACTIONS(2995),
    [anon_sym___extension__] = ACTIONS(2993),
    [anon_sym_typedef] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(2993),
    [anon_sym___attribute__] = ACTIONS(2993),
    [anon_sym_COLON_COLON] = ACTIONS(2995),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2995),
    [anon_sym___declspec] = ACTIONS(2993),
    [anon_sym___based] = ACTIONS(2993),
    [anon_sym___cdecl] = ACTIONS(2993),
    [anon_sym___clrcall] = ACTIONS(2993),
    [anon_sym___stdcall] = ACTIONS(2993),
    [anon_sym___fastcall] = ACTIONS(2993),
    [anon_sym___thiscall] = ACTIONS(2993),
    [anon_sym___vectorcall] = ACTIONS(2993),
    [anon_sym_LBRACE] = ACTIONS(2995),
    [anon_sym_signed] = ACTIONS(2993),
    [anon_sym_unsigned] = ACTIONS(2993),
    [anon_sym_long] = ACTIONS(2993),
    [anon_sym_short] = ACTIONS(2993),
    [anon_sym_LBRACK] = ACTIONS(2993),
    [anon_sym_static] = ACTIONS(2993),
    [anon_sym_register] = ACTIONS(2993),
    [anon_sym_inline] = ACTIONS(2993),
    [anon_sym___inline] = ACTIONS(2993),
    [anon_sym___inline__] = ACTIONS(2993),
    [anon_sym___forceinline] = ACTIONS(2993),
    [anon_sym_thread_local] = ACTIONS(2993),
    [anon_sym___thread] = ACTIONS(2993),
    [anon_sym_const] = ACTIONS(2993),
    [anon_sym_constexpr] = ACTIONS(2993),
    [anon_sym_volatile] = ACTIONS(2993),
    [anon_sym_restrict] = ACTIONS(2993),
    [anon_sym___restrict__] = ACTIONS(2993),
    [anon_sym__Atomic] = ACTIONS(2993),
    [anon_sym__Noreturn] = ACTIONS(2993),
    [anon_sym_noreturn] = ACTIONS(2993),
    [anon_sym_mutable] = ACTIONS(2993),
    [anon_sym_constinit] = ACTIONS(2993),
    [anon_sym_consteval] = ACTIONS(2993),
    [anon_sym_PROGMEM] = ACTIONS(2993),
    [aux_sym_primitive_type_token1] = ACTIONS(2993),
    [anon_sym_byte] = ACTIONS(2993),
    [anon_sym_word] = ACTIONS(2993),
    [anon_sym_enum] = ACTIONS(2993),
    [anon_sym_class] = ACTIONS(2993),
    [anon_sym_struct] = ACTIONS(2993),
    [anon_sym_union] = ACTIONS(2993),
    [anon_sym_if] = ACTIONS(2993),
    [anon_sym_switch] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2993),
    [anon_sym_default] = ACTIONS(2993),
    [anon_sym_while] = ACTIONS(2993),
    [anon_sym_do] = ACTIONS(2993),
    [anon_sym_for] = ACTIONS(2993),
    [anon_sym_return] = ACTIONS(2993),
    [anon_sym_break] = ACTIONS(2993),
    [anon_sym_continue] = ACTIONS(2993),
    [anon_sym_goto] = ACTIONS(2993),
    [anon_sym___try] = ACTIONS(2993),
    [anon_sym___leave] = ACTIONS(2993),
    [anon_sym_not] = ACTIONS(2993),
    [anon_sym_compl] = ACTIONS(2993),
    [anon_sym_DASH_DASH] = ACTIONS(2995),
    [anon_sym_PLUS_PLUS] = ACTIONS(2995),
    [anon_sym_sizeof] = ACTIONS(2993),
    [anon_sym___alignof__] = ACTIONS(2993),
    [anon_sym___alignof] = ACTIONS(2993),
    [anon_sym__alignof] = ACTIONS(2993),
    [anon_sym_alignof] = ACTIONS(2993),
    [anon_sym__Alignof] = ACTIONS(2993),
    [anon_sym_offsetof] = ACTIONS(2993),
    [anon_sym__Generic] = ACTIONS(2993),
    [anon_sym_asm] = ACTIONS(2993),
    [anon_sym___asm__] = ACTIONS(2993),
    [aux_sym_number_literal_token1] = ACTIONS(2995),
    [aux_sym_number_literal_token2] = ACTIONS(2993),
    [anon_sym_L_SQUOTE] = ACTIONS(2995),
    [anon_sym_u_SQUOTE] = ACTIONS(2995),
    [anon_sym_U_SQUOTE] = ACTIONS(2995),
    [anon_sym_u8_SQUOTE] = ACTIONS(2995),
    [anon_sym_SQUOTE] = ACTIONS(2995),
    [anon_sym_L_DQUOTE] = ACTIONS(2995),
    [anon_sym_u_DQUOTE] = ACTIONS(2995),
    [anon_sym_U_DQUOTE] = ACTIONS(2995),
    [anon_sym_u8_DQUOTE] = ACTIONS(2995),
    [anon_sym_DQUOTE] = ACTIONS(2995),
    [sym_true] = ACTIONS(2993),
    [sym_false] = ACTIONS(2993),
    [anon_sym_NULL] = ACTIONS(2993),
    [anon_sym_nullptr] = ACTIONS(2993),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2993),
    [anon_sym_decltype] = ACTIONS(2993),
    [anon_sym_virtual] = ACTIONS(2993),
    [anon_sym_alignas] = ACTIONS(2993),
    [anon_sym_explicit] = ACTIONS(2993),
    [anon_sym_typename] = ACTIONS(2993),
    [anon_sym_template] = ACTIONS(2993),
    [anon_sym_operator] = ACTIONS(2993),
    [anon_sym_try] = ACTIONS(2993),
    [anon_sym_delete] = ACTIONS(2993),
    [anon_sym_throw] = ACTIONS(2993),
    [anon_sym_namespace] = ACTIONS(2993),
    [anon_sym_using] = ACTIONS(2993),
    [anon_sym_static_assert] = ACTIONS(2993),
    [anon_sym_concept] = ACTIONS(2993),
    [anon_sym_co_return] = ACTIONS(2993),
    [anon_sym_co_yield] = ACTIONS(2993),
    [anon_sym_R_DQUOTE] = ACTIONS(2995),
    [anon_sym_LR_DQUOTE] = ACTIONS(2995),
    [anon_sym_uR_DQUOTE] = ACTIONS(2995),
    [anon_sym_UR_DQUOTE] = ACTIONS(2995),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2995),
    [anon_sym_co_await] = ACTIONS(2993),
    [anon_sym_new] = ACTIONS(2993),
    [anon_sym_requires] = ACTIONS(2993),
    [sym_this] = ACTIONS(2993),
  },
  [785] = {
    [sym_identifier] = ACTIONS(3126),
    [aux_sym_preproc_include_token1] = ACTIONS(3126),
    [aux_sym_preproc_def_token1] = ACTIONS(3126),
    [aux_sym_preproc_if_token1] = ACTIONS(3126),
    [aux_sym_preproc_if_token2] = ACTIONS(3126),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3126),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3126),
    [sym_preproc_directive] = ACTIONS(3126),
    [anon_sym_LPAREN2] = ACTIONS(3128),
    [anon_sym_BANG] = ACTIONS(3128),
    [anon_sym_TILDE] = ACTIONS(3128),
    [anon_sym_DASH] = ACTIONS(3126),
    [anon_sym_PLUS] = ACTIONS(3126),
    [anon_sym_STAR] = ACTIONS(3128),
    [anon_sym_AMP_AMP] = ACTIONS(3128),
    [anon_sym_AMP] = ACTIONS(3126),
    [anon_sym_SEMI] = ACTIONS(3128),
    [anon_sym___extension__] = ACTIONS(3126),
    [anon_sym_typedef] = ACTIONS(3126),
    [anon_sym_extern] = ACTIONS(3126),
    [anon_sym___attribute__] = ACTIONS(3126),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3128),
    [anon_sym___declspec] = ACTIONS(3126),
    [anon_sym___based] = ACTIONS(3126),
    [anon_sym___cdecl] = ACTIONS(3126),
    [anon_sym___clrcall] = ACTIONS(3126),
    [anon_sym___stdcall] = ACTIONS(3126),
    [anon_sym___fastcall] = ACTIONS(3126),
    [anon_sym___thiscall] = ACTIONS(3126),
    [anon_sym___vectorcall] = ACTIONS(3126),
    [anon_sym_LBRACE] = ACTIONS(3128),
    [anon_sym_signed] = ACTIONS(3126),
    [anon_sym_unsigned] = ACTIONS(3126),
    [anon_sym_long] = ACTIONS(3126),
    [anon_sym_short] = ACTIONS(3126),
    [anon_sym_LBRACK] = ACTIONS(3126),
    [anon_sym_static] = ACTIONS(3126),
    [anon_sym_register] = ACTIONS(3126),
    [anon_sym_inline] = ACTIONS(3126),
    [anon_sym___inline] = ACTIONS(3126),
    [anon_sym___inline__] = ACTIONS(3126),
    [anon_sym___forceinline] = ACTIONS(3126),
    [anon_sym_thread_local] = ACTIONS(3126),
    [anon_sym___thread] = ACTIONS(3126),
    [anon_sym_const] = ACTIONS(3126),
    [anon_sym_constexpr] = ACTIONS(3126),
    [anon_sym_volatile] = ACTIONS(3126),
    [anon_sym_restrict] = ACTIONS(3126),
    [anon_sym___restrict__] = ACTIONS(3126),
    [anon_sym__Atomic] = ACTIONS(3126),
    [anon_sym__Noreturn] = ACTIONS(3126),
    [anon_sym_noreturn] = ACTIONS(3126),
    [anon_sym_mutable] = ACTIONS(3126),
    [anon_sym_constinit] = ACTIONS(3126),
    [anon_sym_consteval] = ACTIONS(3126),
    [anon_sym_PROGMEM] = ACTIONS(3126),
    [aux_sym_primitive_type_token1] = ACTIONS(3126),
    [anon_sym_byte] = ACTIONS(3126),
    [anon_sym_word] = ACTIONS(3126),
    [anon_sym_enum] = ACTIONS(3126),
    [anon_sym_class] = ACTIONS(3126),
    [anon_sym_struct] = ACTIONS(3126),
    [anon_sym_union] = ACTIONS(3126),
    [anon_sym_if] = ACTIONS(3126),
    [anon_sym_switch] = ACTIONS(3126),
    [anon_sym_case] = ACTIONS(3126),
    [anon_sym_default] = ACTIONS(3126),
    [anon_sym_while] = ACTIONS(3126),
    [anon_sym_do] = ACTIONS(3126),
    [anon_sym_for] = ACTIONS(3126),
    [anon_sym_return] = ACTIONS(3126),
    [anon_sym_break] = ACTIONS(3126),
    [anon_sym_continue] = ACTIONS(3126),
    [anon_sym_goto] = ACTIONS(3126),
    [anon_sym___try] = ACTIONS(3126),
    [anon_sym___leave] = ACTIONS(3126),
    [anon_sym_not] = ACTIONS(3126),
    [anon_sym_compl] = ACTIONS(3126),
    [anon_sym_DASH_DASH] = ACTIONS(3128),
    [anon_sym_PLUS_PLUS] = ACTIONS(3128),
    [anon_sym_sizeof] = ACTIONS(3126),
    [anon_sym___alignof__] = ACTIONS(3126),
    [anon_sym___alignof] = ACTIONS(3126),
    [anon_sym__alignof] = ACTIONS(3126),
    [anon_sym_alignof] = ACTIONS(3126),
    [anon_sym__Alignof] = ACTIONS(3126),
    [anon_sym_offsetof] = ACTIONS(3126),
    [anon_sym__Generic] = ACTIONS(3126),
    [anon_sym_asm] = ACTIONS(3126),
    [anon_sym___asm__] = ACTIONS(3126),
    [aux_sym_number_literal_token1] = ACTIONS(3128),
    [aux_sym_number_literal_token2] = ACTIONS(3126),
    [anon_sym_L_SQUOTE] = ACTIONS(3128),
    [anon_sym_u_SQUOTE] = ACTIONS(3128),
    [anon_sym_U_SQUOTE] = ACTIONS(3128),
    [anon_sym_u8_SQUOTE] = ACTIONS(3128),
    [anon_sym_SQUOTE] = ACTIONS(3128),
    [anon_sym_L_DQUOTE] = ACTIONS(3128),
    [anon_sym_u_DQUOTE] = ACTIONS(3128),
    [anon_sym_U_DQUOTE] = ACTIONS(3128),
    [anon_sym_u8_DQUOTE] = ACTIONS(3128),
    [anon_sym_DQUOTE] = ACTIONS(3128),
    [sym_true] = ACTIONS(3126),
    [sym_false] = ACTIONS(3126),
    [anon_sym_NULL] = ACTIONS(3126),
    [anon_sym_nullptr] = ACTIONS(3126),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3126),
    [anon_sym_decltype] = ACTIONS(3126),
    [anon_sym_virtual] = ACTIONS(3126),
    [anon_sym_alignas] = ACTIONS(3126),
    [anon_sym_explicit] = ACTIONS(3126),
    [anon_sym_typename] = ACTIONS(3126),
    [anon_sym_template] = ACTIONS(3126),
    [anon_sym_operator] = ACTIONS(3126),
    [anon_sym_try] = ACTIONS(3126),
    [anon_sym_delete] = ACTIONS(3126),
    [anon_sym_throw] = ACTIONS(3126),
    [anon_sym_namespace] = ACTIONS(3126),
    [anon_sym_using] = ACTIONS(3126),
    [anon_sym_static_assert] = ACTIONS(3126),
    [anon_sym_concept] = ACTIONS(3126),
    [anon_sym_co_return] = ACTIONS(3126),
    [anon_sym_co_yield] = ACTIONS(3126),
    [anon_sym_R_DQUOTE] = ACTIONS(3128),
    [anon_sym_LR_DQUOTE] = ACTIONS(3128),
    [anon_sym_uR_DQUOTE] = ACTIONS(3128),
    [anon_sym_UR_DQUOTE] = ACTIONS(3128),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3128),
    [anon_sym_co_await] = ACTIONS(3126),
    [anon_sym_new] = ACTIONS(3126),
    [anon_sym_requires] = ACTIONS(3126),
    [sym_this] = ACTIONS(3126),
  },
  [786] = {
    [sym_identifier] = ACTIONS(3152),
    [aux_sym_preproc_include_token1] = ACTIONS(3152),
    [aux_sym_preproc_def_token1] = ACTIONS(3152),
    [aux_sym_preproc_if_token1] = ACTIONS(3152),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3152),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3152),
    [sym_preproc_directive] = ACTIONS(3152),
    [anon_sym_LPAREN2] = ACTIONS(3154),
    [anon_sym_BANG] = ACTIONS(3154),
    [anon_sym_TILDE] = ACTIONS(3154),
    [anon_sym_DASH] = ACTIONS(3152),
    [anon_sym_PLUS] = ACTIONS(3152),
    [anon_sym_STAR] = ACTIONS(3154),
    [anon_sym_AMP_AMP] = ACTIONS(3154),
    [anon_sym_AMP] = ACTIONS(3152),
    [anon_sym_SEMI] = ACTIONS(3154),
    [anon_sym___extension__] = ACTIONS(3152),
    [anon_sym_typedef] = ACTIONS(3152),
    [anon_sym_extern] = ACTIONS(3152),
    [anon_sym___attribute__] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3154),
    [anon_sym___declspec] = ACTIONS(3152),
    [anon_sym___based] = ACTIONS(3152),
    [anon_sym___cdecl] = ACTIONS(3152),
    [anon_sym___clrcall] = ACTIONS(3152),
    [anon_sym___stdcall] = ACTIONS(3152),
    [anon_sym___fastcall] = ACTIONS(3152),
    [anon_sym___thiscall] = ACTIONS(3152),
    [anon_sym___vectorcall] = ACTIONS(3152),
    [anon_sym_LBRACE] = ACTIONS(3154),
    [anon_sym_RBRACE] = ACTIONS(3154),
    [anon_sym_signed] = ACTIONS(3152),
    [anon_sym_unsigned] = ACTIONS(3152),
    [anon_sym_long] = ACTIONS(3152),
    [anon_sym_short] = ACTIONS(3152),
    [anon_sym_LBRACK] = ACTIONS(3152),
    [anon_sym_static] = ACTIONS(3152),
    [anon_sym_register] = ACTIONS(3152),
    [anon_sym_inline] = ACTIONS(3152),
    [anon_sym___inline] = ACTIONS(3152),
    [anon_sym___inline__] = ACTIONS(3152),
    [anon_sym___forceinline] = ACTIONS(3152),
    [anon_sym_thread_local] = ACTIONS(3152),
    [anon_sym___thread] = ACTIONS(3152),
    [anon_sym_const] = ACTIONS(3152),
    [anon_sym_constexpr] = ACTIONS(3152),
    [anon_sym_volatile] = ACTIONS(3152),
    [anon_sym_restrict] = ACTIONS(3152),
    [anon_sym___restrict__] = ACTIONS(3152),
    [anon_sym__Atomic] = ACTIONS(3152),
    [anon_sym__Noreturn] = ACTIONS(3152),
    [anon_sym_noreturn] = ACTIONS(3152),
    [anon_sym_mutable] = ACTIONS(3152),
    [anon_sym_constinit] = ACTIONS(3152),
    [anon_sym_consteval] = ACTIONS(3152),
    [anon_sym_PROGMEM] = ACTIONS(3152),
    [aux_sym_primitive_type_token1] = ACTIONS(3152),
    [anon_sym_byte] = ACTIONS(3152),
    [anon_sym_word] = ACTIONS(3152),
    [anon_sym_enum] = ACTIONS(3152),
    [anon_sym_class] = ACTIONS(3152),
    [anon_sym_struct] = ACTIONS(3152),
    [anon_sym_union] = ACTIONS(3152),
    [anon_sym_if] = ACTIONS(3152),
    [anon_sym_switch] = ACTIONS(3152),
    [anon_sym_case] = ACTIONS(3152),
    [anon_sym_default] = ACTIONS(3152),
    [anon_sym_while] = ACTIONS(3152),
    [anon_sym_do] = ACTIONS(3152),
    [anon_sym_for] = ACTIONS(3152),
    [anon_sym_return] = ACTIONS(3152),
    [anon_sym_break] = ACTIONS(3152),
    [anon_sym_continue] = ACTIONS(3152),
    [anon_sym_goto] = ACTIONS(3152),
    [anon_sym___try] = ACTIONS(3152),
    [anon_sym___leave] = ACTIONS(3152),
    [anon_sym_not] = ACTIONS(3152),
    [anon_sym_compl] = ACTIONS(3152),
    [anon_sym_DASH_DASH] = ACTIONS(3154),
    [anon_sym_PLUS_PLUS] = ACTIONS(3154),
    [anon_sym_sizeof] = ACTIONS(3152),
    [anon_sym___alignof__] = ACTIONS(3152),
    [anon_sym___alignof] = ACTIONS(3152),
    [anon_sym__alignof] = ACTIONS(3152),
    [anon_sym_alignof] = ACTIONS(3152),
    [anon_sym__Alignof] = ACTIONS(3152),
    [anon_sym_offsetof] = ACTIONS(3152),
    [anon_sym__Generic] = ACTIONS(3152),
    [anon_sym_asm] = ACTIONS(3152),
    [anon_sym___asm__] = ACTIONS(3152),
    [aux_sym_number_literal_token1] = ACTIONS(3154),
    [aux_sym_number_literal_token2] = ACTIONS(3152),
    [anon_sym_L_SQUOTE] = ACTIONS(3154),
    [anon_sym_u_SQUOTE] = ACTIONS(3154),
    [anon_sym_U_SQUOTE] = ACTIONS(3154),
    [anon_sym_u8_SQUOTE] = ACTIONS(3154),
    [anon_sym_SQUOTE] = ACTIONS(3154),
    [anon_sym_L_DQUOTE] = ACTIONS(3154),
    [anon_sym_u_DQUOTE] = ACTIONS(3154),
    [anon_sym_U_DQUOTE] = ACTIONS(3154),
    [anon_sym_u8_DQUOTE] = ACTIONS(3154),
    [anon_sym_DQUOTE] = ACTIONS(3154),
    [sym_true] = ACTIONS(3152),
    [sym_false] = ACTIONS(3152),
    [anon_sym_NULL] = ACTIONS(3152),
    [anon_sym_nullptr] = ACTIONS(3152),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3152),
    [anon_sym_decltype] = ACTIONS(3152),
    [anon_sym_virtual] = ACTIONS(3152),
    [anon_sym_alignas] = ACTIONS(3152),
    [anon_sym_explicit] = ACTIONS(3152),
    [anon_sym_typename] = ACTIONS(3152),
    [anon_sym_template] = ACTIONS(3152),
    [anon_sym_operator] = ACTIONS(3152),
    [anon_sym_try] = ACTIONS(3152),
    [anon_sym_delete] = ACTIONS(3152),
    [anon_sym_throw] = ACTIONS(3152),
    [anon_sym_namespace] = ACTIONS(3152),
    [anon_sym_using] = ACTIONS(3152),
    [anon_sym_static_assert] = ACTIONS(3152),
    [anon_sym_concept] = ACTIONS(3152),
    [anon_sym_co_return] = ACTIONS(3152),
    [anon_sym_co_yield] = ACTIONS(3152),
    [anon_sym_R_DQUOTE] = ACTIONS(3154),
    [anon_sym_LR_DQUOTE] = ACTIONS(3154),
    [anon_sym_uR_DQUOTE] = ACTIONS(3154),
    [anon_sym_UR_DQUOTE] = ACTIONS(3154),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3154),
    [anon_sym_co_await] = ACTIONS(3152),
    [anon_sym_new] = ACTIONS(3152),
    [anon_sym_requires] = ACTIONS(3152),
    [sym_this] = ACTIONS(3152),
  },
  [787] = {
    [sym_identifier] = ACTIONS(3148),
    [aux_sym_preproc_include_token1] = ACTIONS(3148),
    [aux_sym_preproc_def_token1] = ACTIONS(3148),
    [aux_sym_preproc_if_token1] = ACTIONS(3148),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3148),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3148),
    [sym_preproc_directive] = ACTIONS(3148),
    [anon_sym_LPAREN2] = ACTIONS(3150),
    [anon_sym_BANG] = ACTIONS(3150),
    [anon_sym_TILDE] = ACTIONS(3150),
    [anon_sym_DASH] = ACTIONS(3148),
    [anon_sym_PLUS] = ACTIONS(3148),
    [anon_sym_STAR] = ACTIONS(3150),
    [anon_sym_AMP_AMP] = ACTIONS(3150),
    [anon_sym_AMP] = ACTIONS(3148),
    [anon_sym_SEMI] = ACTIONS(3150),
    [anon_sym___extension__] = ACTIONS(3148),
    [anon_sym_typedef] = ACTIONS(3148),
    [anon_sym_extern] = ACTIONS(3148),
    [anon_sym___attribute__] = ACTIONS(3148),
    [anon_sym_COLON_COLON] = ACTIONS(3150),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3150),
    [anon_sym___declspec] = ACTIONS(3148),
    [anon_sym___based] = ACTIONS(3148),
    [anon_sym___cdecl] = ACTIONS(3148),
    [anon_sym___clrcall] = ACTIONS(3148),
    [anon_sym___stdcall] = ACTIONS(3148),
    [anon_sym___fastcall] = ACTIONS(3148),
    [anon_sym___thiscall] = ACTIONS(3148),
    [anon_sym___vectorcall] = ACTIONS(3148),
    [anon_sym_LBRACE] = ACTIONS(3150),
    [anon_sym_RBRACE] = ACTIONS(3150),
    [anon_sym_signed] = ACTIONS(3148),
    [anon_sym_unsigned] = ACTIONS(3148),
    [anon_sym_long] = ACTIONS(3148),
    [anon_sym_short] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_static] = ACTIONS(3148),
    [anon_sym_register] = ACTIONS(3148),
    [anon_sym_inline] = ACTIONS(3148),
    [anon_sym___inline] = ACTIONS(3148),
    [anon_sym___inline__] = ACTIONS(3148),
    [anon_sym___forceinline] = ACTIONS(3148),
    [anon_sym_thread_local] = ACTIONS(3148),
    [anon_sym___thread] = ACTIONS(3148),
    [anon_sym_const] = ACTIONS(3148),
    [anon_sym_constexpr] = ACTIONS(3148),
    [anon_sym_volatile] = ACTIONS(3148),
    [anon_sym_restrict] = ACTIONS(3148),
    [anon_sym___restrict__] = ACTIONS(3148),
    [anon_sym__Atomic] = ACTIONS(3148),
    [anon_sym__Noreturn] = ACTIONS(3148),
    [anon_sym_noreturn] = ACTIONS(3148),
    [anon_sym_mutable] = ACTIONS(3148),
    [anon_sym_constinit] = ACTIONS(3148),
    [anon_sym_consteval] = ACTIONS(3148),
    [anon_sym_PROGMEM] = ACTIONS(3148),
    [aux_sym_primitive_type_token1] = ACTIONS(3148),
    [anon_sym_byte] = ACTIONS(3148),
    [anon_sym_word] = ACTIONS(3148),
    [anon_sym_enum] = ACTIONS(3148),
    [anon_sym_class] = ACTIONS(3148),
    [anon_sym_struct] = ACTIONS(3148),
    [anon_sym_union] = ACTIONS(3148),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_switch] = ACTIONS(3148),
    [anon_sym_case] = ACTIONS(3148),
    [anon_sym_default] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_for] = ACTIONS(3148),
    [anon_sym_return] = ACTIONS(3148),
    [anon_sym_break] = ACTIONS(3148),
    [anon_sym_continue] = ACTIONS(3148),
    [anon_sym_goto] = ACTIONS(3148),
    [anon_sym___try] = ACTIONS(3148),
    [anon_sym___leave] = ACTIONS(3148),
    [anon_sym_not] = ACTIONS(3148),
    [anon_sym_compl] = ACTIONS(3148),
    [anon_sym_DASH_DASH] = ACTIONS(3150),
    [anon_sym_PLUS_PLUS] = ACTIONS(3150),
    [anon_sym_sizeof] = ACTIONS(3148),
    [anon_sym___alignof__] = ACTIONS(3148),
    [anon_sym___alignof] = ACTIONS(3148),
    [anon_sym__alignof] = ACTIONS(3148),
    [anon_sym_alignof] = ACTIONS(3148),
    [anon_sym__Alignof] = ACTIONS(3148),
    [anon_sym_offsetof] = ACTIONS(3148),
    [anon_sym__Generic] = ACTIONS(3148),
    [anon_sym_asm] = ACTIONS(3148),
    [anon_sym___asm__] = ACTIONS(3148),
    [aux_sym_number_literal_token1] = ACTIONS(3150),
    [aux_sym_number_literal_token2] = ACTIONS(3148),
    [anon_sym_L_SQUOTE] = ACTIONS(3150),
    [anon_sym_u_SQUOTE] = ACTIONS(3150),
    [anon_sym_U_SQUOTE] = ACTIONS(3150),
    [anon_sym_u8_SQUOTE] = ACTIONS(3150),
    [anon_sym_SQUOTE] = ACTIONS(3150),
    [anon_sym_L_DQUOTE] = ACTIONS(3150),
    [anon_sym_u_DQUOTE] = ACTIONS(3150),
    [anon_sym_U_DQUOTE] = ACTIONS(3150),
    [anon_sym_u8_DQUOTE] = ACTIONS(3150),
    [anon_sym_DQUOTE] = ACTIONS(3150),
    [sym_true] = ACTIONS(3148),
    [sym_false] = ACTIONS(3148),
    [anon_sym_NULL] = ACTIONS(3148),
    [anon_sym_nullptr] = ACTIONS(3148),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3148),
    [anon_sym_decltype] = ACTIONS(3148),
    [anon_sym_virtual] = ACTIONS(3148),
    [anon_sym_alignas] = ACTIONS(3148),
    [anon_sym_explicit] = ACTIONS(3148),
    [anon_sym_typename] = ACTIONS(3148),
    [anon_sym_template] = ACTIONS(3148),
    [anon_sym_operator] = ACTIONS(3148),
    [anon_sym_try] = ACTIONS(3148),
    [anon_sym_delete] = ACTIONS(3148),
    [anon_sym_throw] = ACTIONS(3148),
    [anon_sym_namespace] = ACTIONS(3148),
    [anon_sym_using] = ACTIONS(3148),
    [anon_sym_static_assert] = ACTIONS(3148),
    [anon_sym_concept] = ACTIONS(3148),
    [anon_sym_co_return] = ACTIONS(3148),
    [anon_sym_co_yield] = ACTIONS(3148),
    [anon_sym_R_DQUOTE] = ACTIONS(3150),
    [anon_sym_LR_DQUOTE] = ACTIONS(3150),
    [anon_sym_uR_DQUOTE] = ACTIONS(3150),
    [anon_sym_UR_DQUOTE] = ACTIONS(3150),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3150),
    [anon_sym_co_await] = ACTIONS(3148),
    [anon_sym_new] = ACTIONS(3148),
    [anon_sym_requires] = ACTIONS(3148),
    [sym_this] = ACTIONS(3148),
  },
  [788] = {
    [sym_identifier] = ACTIONS(2985),
    [aux_sym_preproc_include_token1] = ACTIONS(2985),
    [aux_sym_preproc_def_token1] = ACTIONS(2985),
    [aux_sym_preproc_if_token1] = ACTIONS(2985),
    [aux_sym_preproc_if_token2] = ACTIONS(2985),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2985),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2985),
    [sym_preproc_directive] = ACTIONS(2985),
    [anon_sym_LPAREN2] = ACTIONS(2987),
    [anon_sym_BANG] = ACTIONS(2987),
    [anon_sym_TILDE] = ACTIONS(2987),
    [anon_sym_DASH] = ACTIONS(2985),
    [anon_sym_PLUS] = ACTIONS(2985),
    [anon_sym_STAR] = ACTIONS(2987),
    [anon_sym_AMP_AMP] = ACTIONS(2987),
    [anon_sym_AMP] = ACTIONS(2985),
    [anon_sym_SEMI] = ACTIONS(2987),
    [anon_sym___extension__] = ACTIONS(2985),
    [anon_sym_typedef] = ACTIONS(2985),
    [anon_sym_extern] = ACTIONS(2985),
    [anon_sym___attribute__] = ACTIONS(2985),
    [anon_sym_COLON_COLON] = ACTIONS(2987),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2987),
    [anon_sym___declspec] = ACTIONS(2985),
    [anon_sym___based] = ACTIONS(2985),
    [anon_sym___cdecl] = ACTIONS(2985),
    [anon_sym___clrcall] = ACTIONS(2985),
    [anon_sym___stdcall] = ACTIONS(2985),
    [anon_sym___fastcall] = ACTIONS(2985),
    [anon_sym___thiscall] = ACTIONS(2985),
    [anon_sym___vectorcall] = ACTIONS(2985),
    [anon_sym_LBRACE] = ACTIONS(2987),
    [anon_sym_signed] = ACTIONS(2985),
    [anon_sym_unsigned] = ACTIONS(2985),
    [anon_sym_long] = ACTIONS(2985),
    [anon_sym_short] = ACTIONS(2985),
    [anon_sym_LBRACK] = ACTIONS(2985),
    [anon_sym_static] = ACTIONS(2985),
    [anon_sym_register] = ACTIONS(2985),
    [anon_sym_inline] = ACTIONS(2985),
    [anon_sym___inline] = ACTIONS(2985),
    [anon_sym___inline__] = ACTIONS(2985),
    [anon_sym___forceinline] = ACTIONS(2985),
    [anon_sym_thread_local] = ACTIONS(2985),
    [anon_sym___thread] = ACTIONS(2985),
    [anon_sym_const] = ACTIONS(2985),
    [anon_sym_constexpr] = ACTIONS(2985),
    [anon_sym_volatile] = ACTIONS(2985),
    [anon_sym_restrict] = ACTIONS(2985),
    [anon_sym___restrict__] = ACTIONS(2985),
    [anon_sym__Atomic] = ACTIONS(2985),
    [anon_sym__Noreturn] = ACTIONS(2985),
    [anon_sym_noreturn] = ACTIONS(2985),
    [anon_sym_mutable] = ACTIONS(2985),
    [anon_sym_constinit] = ACTIONS(2985),
    [anon_sym_consteval] = ACTIONS(2985),
    [anon_sym_PROGMEM] = ACTIONS(2985),
    [aux_sym_primitive_type_token1] = ACTIONS(2985),
    [anon_sym_byte] = ACTIONS(2985),
    [anon_sym_word] = ACTIONS(2985),
    [anon_sym_enum] = ACTIONS(2985),
    [anon_sym_class] = ACTIONS(2985),
    [anon_sym_struct] = ACTIONS(2985),
    [anon_sym_union] = ACTIONS(2985),
    [anon_sym_if] = ACTIONS(2985),
    [anon_sym_switch] = ACTIONS(2985),
    [anon_sym_case] = ACTIONS(2985),
    [anon_sym_default] = ACTIONS(2985),
    [anon_sym_while] = ACTIONS(2985),
    [anon_sym_do] = ACTIONS(2985),
    [anon_sym_for] = ACTIONS(2985),
    [anon_sym_return] = ACTIONS(2985),
    [anon_sym_break] = ACTIONS(2985),
    [anon_sym_continue] = ACTIONS(2985),
    [anon_sym_goto] = ACTIONS(2985),
    [anon_sym___try] = ACTIONS(2985),
    [anon_sym___leave] = ACTIONS(2985),
    [anon_sym_not] = ACTIONS(2985),
    [anon_sym_compl] = ACTIONS(2985),
    [anon_sym_DASH_DASH] = ACTIONS(2987),
    [anon_sym_PLUS_PLUS] = ACTIONS(2987),
    [anon_sym_sizeof] = ACTIONS(2985),
    [anon_sym___alignof__] = ACTIONS(2985),
    [anon_sym___alignof] = ACTIONS(2985),
    [anon_sym__alignof] = ACTIONS(2985),
    [anon_sym_alignof] = ACTIONS(2985),
    [anon_sym__Alignof] = ACTIONS(2985),
    [anon_sym_offsetof] = ACTIONS(2985),
    [anon_sym__Generic] = ACTIONS(2985),
    [anon_sym_asm] = ACTIONS(2985),
    [anon_sym___asm__] = ACTIONS(2985),
    [aux_sym_number_literal_token1] = ACTIONS(2987),
    [aux_sym_number_literal_token2] = ACTIONS(2985),
    [anon_sym_L_SQUOTE] = ACTIONS(2987),
    [anon_sym_u_SQUOTE] = ACTIONS(2987),
    [anon_sym_U_SQUOTE] = ACTIONS(2987),
    [anon_sym_u8_SQUOTE] = ACTIONS(2987),
    [anon_sym_SQUOTE] = ACTIONS(2987),
    [anon_sym_L_DQUOTE] = ACTIONS(2987),
    [anon_sym_u_DQUOTE] = ACTIONS(2987),
    [anon_sym_U_DQUOTE] = ACTIONS(2987),
    [anon_sym_u8_DQUOTE] = ACTIONS(2987),
    [anon_sym_DQUOTE] = ACTIONS(2987),
    [sym_true] = ACTIONS(2985),
    [sym_false] = ACTIONS(2985),
    [anon_sym_NULL] = ACTIONS(2985),
    [anon_sym_nullptr] = ACTIONS(2985),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2985),
    [anon_sym_decltype] = ACTIONS(2985),
    [anon_sym_virtual] = ACTIONS(2985),
    [anon_sym_alignas] = ACTIONS(2985),
    [anon_sym_explicit] = ACTIONS(2985),
    [anon_sym_typename] = ACTIONS(2985),
    [anon_sym_template] = ACTIONS(2985),
    [anon_sym_operator] = ACTIONS(2985),
    [anon_sym_try] = ACTIONS(2985),
    [anon_sym_delete] = ACTIONS(2985),
    [anon_sym_throw] = ACTIONS(2985),
    [anon_sym_namespace] = ACTIONS(2985),
    [anon_sym_using] = ACTIONS(2985),
    [anon_sym_static_assert] = ACTIONS(2985),
    [anon_sym_concept] = ACTIONS(2985),
    [anon_sym_co_return] = ACTIONS(2985),
    [anon_sym_co_yield] = ACTIONS(2985),
    [anon_sym_R_DQUOTE] = ACTIONS(2987),
    [anon_sym_LR_DQUOTE] = ACTIONS(2987),
    [anon_sym_uR_DQUOTE] = ACTIONS(2987),
    [anon_sym_UR_DQUOTE] = ACTIONS(2987),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2987),
    [anon_sym_co_await] = ACTIONS(2985),
    [anon_sym_new] = ACTIONS(2985),
    [anon_sym_requires] = ACTIONS(2985),
    [sym_this] = ACTIONS(2985),
  },
  [789] = {
    [sym_identifier] = ACTIONS(3048),
    [aux_sym_preproc_include_token1] = ACTIONS(3048),
    [aux_sym_preproc_def_token1] = ACTIONS(3048),
    [aux_sym_preproc_if_token1] = ACTIONS(3048),
    [aux_sym_preproc_if_token2] = ACTIONS(3048),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3048),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3048),
    [sym_preproc_directive] = ACTIONS(3048),
    [anon_sym_LPAREN2] = ACTIONS(3050),
    [anon_sym_BANG] = ACTIONS(3050),
    [anon_sym_TILDE] = ACTIONS(3050),
    [anon_sym_DASH] = ACTIONS(3048),
    [anon_sym_PLUS] = ACTIONS(3048),
    [anon_sym_STAR] = ACTIONS(3050),
    [anon_sym_AMP_AMP] = ACTIONS(3050),
    [anon_sym_AMP] = ACTIONS(3048),
    [anon_sym_SEMI] = ACTIONS(3050),
    [anon_sym___extension__] = ACTIONS(3048),
    [anon_sym_typedef] = ACTIONS(3048),
    [anon_sym_extern] = ACTIONS(3048),
    [anon_sym___attribute__] = ACTIONS(3048),
    [anon_sym_COLON_COLON] = ACTIONS(3050),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3050),
    [anon_sym___declspec] = ACTIONS(3048),
    [anon_sym___based] = ACTIONS(3048),
    [anon_sym___cdecl] = ACTIONS(3048),
    [anon_sym___clrcall] = ACTIONS(3048),
    [anon_sym___stdcall] = ACTIONS(3048),
    [anon_sym___fastcall] = ACTIONS(3048),
    [anon_sym___thiscall] = ACTIONS(3048),
    [anon_sym___vectorcall] = ACTIONS(3048),
    [anon_sym_LBRACE] = ACTIONS(3050),
    [anon_sym_signed] = ACTIONS(3048),
    [anon_sym_unsigned] = ACTIONS(3048),
    [anon_sym_long] = ACTIONS(3048),
    [anon_sym_short] = ACTIONS(3048),
    [anon_sym_LBRACK] = ACTIONS(3048),
    [anon_sym_static] = ACTIONS(3048),
    [anon_sym_register] = ACTIONS(3048),
    [anon_sym_inline] = ACTIONS(3048),
    [anon_sym___inline] = ACTIONS(3048),
    [anon_sym___inline__] = ACTIONS(3048),
    [anon_sym___forceinline] = ACTIONS(3048),
    [anon_sym_thread_local] = ACTIONS(3048),
    [anon_sym___thread] = ACTIONS(3048),
    [anon_sym_const] = ACTIONS(3048),
    [anon_sym_constexpr] = ACTIONS(3048),
    [anon_sym_volatile] = ACTIONS(3048),
    [anon_sym_restrict] = ACTIONS(3048),
    [anon_sym___restrict__] = ACTIONS(3048),
    [anon_sym__Atomic] = ACTIONS(3048),
    [anon_sym__Noreturn] = ACTIONS(3048),
    [anon_sym_noreturn] = ACTIONS(3048),
    [anon_sym_mutable] = ACTIONS(3048),
    [anon_sym_constinit] = ACTIONS(3048),
    [anon_sym_consteval] = ACTIONS(3048),
    [anon_sym_PROGMEM] = ACTIONS(3048),
    [aux_sym_primitive_type_token1] = ACTIONS(3048),
    [anon_sym_byte] = ACTIONS(3048),
    [anon_sym_word] = ACTIONS(3048),
    [anon_sym_enum] = ACTIONS(3048),
    [anon_sym_class] = ACTIONS(3048),
    [anon_sym_struct] = ACTIONS(3048),
    [anon_sym_union] = ACTIONS(3048),
    [anon_sym_if] = ACTIONS(3048),
    [anon_sym_switch] = ACTIONS(3048),
    [anon_sym_case] = ACTIONS(3048),
    [anon_sym_default] = ACTIONS(3048),
    [anon_sym_while] = ACTIONS(3048),
    [anon_sym_do] = ACTIONS(3048),
    [anon_sym_for] = ACTIONS(3048),
    [anon_sym_return] = ACTIONS(3048),
    [anon_sym_break] = ACTIONS(3048),
    [anon_sym_continue] = ACTIONS(3048),
    [anon_sym_goto] = ACTIONS(3048),
    [anon_sym___try] = ACTIONS(3048),
    [anon_sym___leave] = ACTIONS(3048),
    [anon_sym_not] = ACTIONS(3048),
    [anon_sym_compl] = ACTIONS(3048),
    [anon_sym_DASH_DASH] = ACTIONS(3050),
    [anon_sym_PLUS_PLUS] = ACTIONS(3050),
    [anon_sym_sizeof] = ACTIONS(3048),
    [anon_sym___alignof__] = ACTIONS(3048),
    [anon_sym___alignof] = ACTIONS(3048),
    [anon_sym__alignof] = ACTIONS(3048),
    [anon_sym_alignof] = ACTIONS(3048),
    [anon_sym__Alignof] = ACTIONS(3048),
    [anon_sym_offsetof] = ACTIONS(3048),
    [anon_sym__Generic] = ACTIONS(3048),
    [anon_sym_asm] = ACTIONS(3048),
    [anon_sym___asm__] = ACTIONS(3048),
    [aux_sym_number_literal_token1] = ACTIONS(3050),
    [aux_sym_number_literal_token2] = ACTIONS(3048),
    [anon_sym_L_SQUOTE] = ACTIONS(3050),
    [anon_sym_u_SQUOTE] = ACTIONS(3050),
    [anon_sym_U_SQUOTE] = ACTIONS(3050),
    [anon_sym_u8_SQUOTE] = ACTIONS(3050),
    [anon_sym_SQUOTE] = ACTIONS(3050),
    [anon_sym_L_DQUOTE] = ACTIONS(3050),
    [anon_sym_u_DQUOTE] = ACTIONS(3050),
    [anon_sym_U_DQUOTE] = ACTIONS(3050),
    [anon_sym_u8_DQUOTE] = ACTIONS(3050),
    [anon_sym_DQUOTE] = ACTIONS(3050),
    [sym_true] = ACTIONS(3048),
    [sym_false] = ACTIONS(3048),
    [anon_sym_NULL] = ACTIONS(3048),
    [anon_sym_nullptr] = ACTIONS(3048),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3048),
    [anon_sym_decltype] = ACTIONS(3048),
    [anon_sym_virtual] = ACTIONS(3048),
    [anon_sym_alignas] = ACTIONS(3048),
    [anon_sym_explicit] = ACTIONS(3048),
    [anon_sym_typename] = ACTIONS(3048),
    [anon_sym_template] = ACTIONS(3048),
    [anon_sym_operator] = ACTIONS(3048),
    [anon_sym_try] = ACTIONS(3048),
    [anon_sym_delete] = ACTIONS(3048),
    [anon_sym_throw] = ACTIONS(3048),
    [anon_sym_namespace] = ACTIONS(3048),
    [anon_sym_using] = ACTIONS(3048),
    [anon_sym_static_assert] = ACTIONS(3048),
    [anon_sym_concept] = ACTIONS(3048),
    [anon_sym_co_return] = ACTIONS(3048),
    [anon_sym_co_yield] = ACTIONS(3048),
    [anon_sym_R_DQUOTE] = ACTIONS(3050),
    [anon_sym_LR_DQUOTE] = ACTIONS(3050),
    [anon_sym_uR_DQUOTE] = ACTIONS(3050),
    [anon_sym_UR_DQUOTE] = ACTIONS(3050),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3050),
    [anon_sym_co_await] = ACTIONS(3048),
    [anon_sym_new] = ACTIONS(3048),
    [anon_sym_requires] = ACTIONS(3048),
    [sym_this] = ACTIONS(3048),
  },
  [790] = {
    [sym_identifier] = ACTIONS(3002),
    [aux_sym_preproc_include_token1] = ACTIONS(3002),
    [aux_sym_preproc_def_token1] = ACTIONS(3002),
    [aux_sym_preproc_if_token1] = ACTIONS(3002),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3002),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3002),
    [sym_preproc_directive] = ACTIONS(3002),
    [anon_sym_LPAREN2] = ACTIONS(3004),
    [anon_sym_BANG] = ACTIONS(3004),
    [anon_sym_TILDE] = ACTIONS(3004),
    [anon_sym_DASH] = ACTIONS(3002),
    [anon_sym_PLUS] = ACTIONS(3002),
    [anon_sym_STAR] = ACTIONS(3004),
    [anon_sym_AMP_AMP] = ACTIONS(3004),
    [anon_sym_AMP] = ACTIONS(3002),
    [anon_sym_SEMI] = ACTIONS(3004),
    [anon_sym___extension__] = ACTIONS(3002),
    [anon_sym_typedef] = ACTIONS(3002),
    [anon_sym_extern] = ACTIONS(3002),
    [anon_sym___attribute__] = ACTIONS(3002),
    [anon_sym_COLON_COLON] = ACTIONS(3004),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3004),
    [anon_sym___declspec] = ACTIONS(3002),
    [anon_sym___based] = ACTIONS(3002),
    [anon_sym___cdecl] = ACTIONS(3002),
    [anon_sym___clrcall] = ACTIONS(3002),
    [anon_sym___stdcall] = ACTIONS(3002),
    [anon_sym___fastcall] = ACTIONS(3002),
    [anon_sym___thiscall] = ACTIONS(3002),
    [anon_sym___vectorcall] = ACTIONS(3002),
    [anon_sym_LBRACE] = ACTIONS(3004),
    [anon_sym_RBRACE] = ACTIONS(3004),
    [anon_sym_signed] = ACTIONS(3002),
    [anon_sym_unsigned] = ACTIONS(3002),
    [anon_sym_long] = ACTIONS(3002),
    [anon_sym_short] = ACTIONS(3002),
    [anon_sym_LBRACK] = ACTIONS(3002),
    [anon_sym_static] = ACTIONS(3002),
    [anon_sym_register] = ACTIONS(3002),
    [anon_sym_inline] = ACTIONS(3002),
    [anon_sym___inline] = ACTIONS(3002),
    [anon_sym___inline__] = ACTIONS(3002),
    [anon_sym___forceinline] = ACTIONS(3002),
    [anon_sym_thread_local] = ACTIONS(3002),
    [anon_sym___thread] = ACTIONS(3002),
    [anon_sym_const] = ACTIONS(3002),
    [anon_sym_constexpr] = ACTIONS(3002),
    [anon_sym_volatile] = ACTIONS(3002),
    [anon_sym_restrict] = ACTIONS(3002),
    [anon_sym___restrict__] = ACTIONS(3002),
    [anon_sym__Atomic] = ACTIONS(3002),
    [anon_sym__Noreturn] = ACTIONS(3002),
    [anon_sym_noreturn] = ACTIONS(3002),
    [anon_sym_mutable] = ACTIONS(3002),
    [anon_sym_constinit] = ACTIONS(3002),
    [anon_sym_consteval] = ACTIONS(3002),
    [anon_sym_PROGMEM] = ACTIONS(3002),
    [aux_sym_primitive_type_token1] = ACTIONS(3002),
    [anon_sym_byte] = ACTIONS(3002),
    [anon_sym_word] = ACTIONS(3002),
    [anon_sym_enum] = ACTIONS(3002),
    [anon_sym_class] = ACTIONS(3002),
    [anon_sym_struct] = ACTIONS(3002),
    [anon_sym_union] = ACTIONS(3002),
    [anon_sym_if] = ACTIONS(3002),
    [anon_sym_switch] = ACTIONS(3002),
    [anon_sym_case] = ACTIONS(3002),
    [anon_sym_default] = ACTIONS(3002),
    [anon_sym_while] = ACTIONS(3002),
    [anon_sym_do] = ACTIONS(3002),
    [anon_sym_for] = ACTIONS(3002),
    [anon_sym_return] = ACTIONS(3002),
    [anon_sym_break] = ACTIONS(3002),
    [anon_sym_continue] = ACTIONS(3002),
    [anon_sym_goto] = ACTIONS(3002),
    [anon_sym___try] = ACTIONS(3002),
    [anon_sym___leave] = ACTIONS(3002),
    [anon_sym_not] = ACTIONS(3002),
    [anon_sym_compl] = ACTIONS(3002),
    [anon_sym_DASH_DASH] = ACTIONS(3004),
    [anon_sym_PLUS_PLUS] = ACTIONS(3004),
    [anon_sym_sizeof] = ACTIONS(3002),
    [anon_sym___alignof__] = ACTIONS(3002),
    [anon_sym___alignof] = ACTIONS(3002),
    [anon_sym__alignof] = ACTIONS(3002),
    [anon_sym_alignof] = ACTIONS(3002),
    [anon_sym__Alignof] = ACTIONS(3002),
    [anon_sym_offsetof] = ACTIONS(3002),
    [anon_sym__Generic] = ACTIONS(3002),
    [anon_sym_asm] = ACTIONS(3002),
    [anon_sym___asm__] = ACTIONS(3002),
    [aux_sym_number_literal_token1] = ACTIONS(3004),
    [aux_sym_number_literal_token2] = ACTIONS(3002),
    [anon_sym_L_SQUOTE] = ACTIONS(3004),
    [anon_sym_u_SQUOTE] = ACTIONS(3004),
    [anon_sym_U_SQUOTE] = ACTIONS(3004),
    [anon_sym_u8_SQUOTE] = ACTIONS(3004),
    [anon_sym_SQUOTE] = ACTIONS(3004),
    [anon_sym_L_DQUOTE] = ACTIONS(3004),
    [anon_sym_u_DQUOTE] = ACTIONS(3004),
    [anon_sym_U_DQUOTE] = ACTIONS(3004),
    [anon_sym_u8_DQUOTE] = ACTIONS(3004),
    [anon_sym_DQUOTE] = ACTIONS(3004),
    [sym_true] = ACTIONS(3002),
    [sym_false] = ACTIONS(3002),
    [anon_sym_NULL] = ACTIONS(3002),
    [anon_sym_nullptr] = ACTIONS(3002),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3002),
    [anon_sym_decltype] = ACTIONS(3002),
    [anon_sym_virtual] = ACTIONS(3002),
    [anon_sym_alignas] = ACTIONS(3002),
    [anon_sym_explicit] = ACTIONS(3002),
    [anon_sym_typename] = ACTIONS(3002),
    [anon_sym_template] = ACTIONS(3002),
    [anon_sym_operator] = ACTIONS(3002),
    [anon_sym_try] = ACTIONS(3002),
    [anon_sym_delete] = ACTIONS(3002),
    [anon_sym_throw] = ACTIONS(3002),
    [anon_sym_namespace] = ACTIONS(3002),
    [anon_sym_using] = ACTIONS(3002),
    [anon_sym_static_assert] = ACTIONS(3002),
    [anon_sym_concept] = ACTIONS(3002),
    [anon_sym_co_return] = ACTIONS(3002),
    [anon_sym_co_yield] = ACTIONS(3002),
    [anon_sym_R_DQUOTE] = ACTIONS(3004),
    [anon_sym_LR_DQUOTE] = ACTIONS(3004),
    [anon_sym_uR_DQUOTE] = ACTIONS(3004),
    [anon_sym_UR_DQUOTE] = ACTIONS(3004),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3004),
    [anon_sym_co_await] = ACTIONS(3002),
    [anon_sym_new] = ACTIONS(3002),
    [anon_sym_requires] = ACTIONS(3002),
    [sym_this] = ACTIONS(3002),
  },
  [791] = {
    [sym_identifier] = ACTIONS(3012),
    [aux_sym_preproc_include_token1] = ACTIONS(3012),
    [aux_sym_preproc_def_token1] = ACTIONS(3012),
    [aux_sym_preproc_if_token1] = ACTIONS(3012),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3012),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3012),
    [sym_preproc_directive] = ACTIONS(3012),
    [anon_sym_LPAREN2] = ACTIONS(3014),
    [anon_sym_BANG] = ACTIONS(3014),
    [anon_sym_TILDE] = ACTIONS(3014),
    [anon_sym_DASH] = ACTIONS(3012),
    [anon_sym_PLUS] = ACTIONS(3012),
    [anon_sym_STAR] = ACTIONS(3014),
    [anon_sym_AMP_AMP] = ACTIONS(3014),
    [anon_sym_AMP] = ACTIONS(3012),
    [anon_sym_SEMI] = ACTIONS(3014),
    [anon_sym___extension__] = ACTIONS(3012),
    [anon_sym_typedef] = ACTIONS(3012),
    [anon_sym_extern] = ACTIONS(3012),
    [anon_sym___attribute__] = ACTIONS(3012),
    [anon_sym_COLON_COLON] = ACTIONS(3014),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3014),
    [anon_sym___declspec] = ACTIONS(3012),
    [anon_sym___based] = ACTIONS(3012),
    [anon_sym___cdecl] = ACTIONS(3012),
    [anon_sym___clrcall] = ACTIONS(3012),
    [anon_sym___stdcall] = ACTIONS(3012),
    [anon_sym___fastcall] = ACTIONS(3012),
    [anon_sym___thiscall] = ACTIONS(3012),
    [anon_sym___vectorcall] = ACTIONS(3012),
    [anon_sym_LBRACE] = ACTIONS(3014),
    [anon_sym_RBRACE] = ACTIONS(3014),
    [anon_sym_signed] = ACTIONS(3012),
    [anon_sym_unsigned] = ACTIONS(3012),
    [anon_sym_long] = ACTIONS(3012),
    [anon_sym_short] = ACTIONS(3012),
    [anon_sym_LBRACK] = ACTIONS(3012),
    [anon_sym_static] = ACTIONS(3012),
    [anon_sym_register] = ACTIONS(3012),
    [anon_sym_inline] = ACTIONS(3012),
    [anon_sym___inline] = ACTIONS(3012),
    [anon_sym___inline__] = ACTIONS(3012),
    [anon_sym___forceinline] = ACTIONS(3012),
    [anon_sym_thread_local] = ACTIONS(3012),
    [anon_sym___thread] = ACTIONS(3012),
    [anon_sym_const] = ACTIONS(3012),
    [anon_sym_constexpr] = ACTIONS(3012),
    [anon_sym_volatile] = ACTIONS(3012),
    [anon_sym_restrict] = ACTIONS(3012),
    [anon_sym___restrict__] = ACTIONS(3012),
    [anon_sym__Atomic] = ACTIONS(3012),
    [anon_sym__Noreturn] = ACTIONS(3012),
    [anon_sym_noreturn] = ACTIONS(3012),
    [anon_sym_mutable] = ACTIONS(3012),
    [anon_sym_constinit] = ACTIONS(3012),
    [anon_sym_consteval] = ACTIONS(3012),
    [anon_sym_PROGMEM] = ACTIONS(3012),
    [aux_sym_primitive_type_token1] = ACTIONS(3012),
    [anon_sym_byte] = ACTIONS(3012),
    [anon_sym_word] = ACTIONS(3012),
    [anon_sym_enum] = ACTIONS(3012),
    [anon_sym_class] = ACTIONS(3012),
    [anon_sym_struct] = ACTIONS(3012),
    [anon_sym_union] = ACTIONS(3012),
    [anon_sym_if] = ACTIONS(3012),
    [anon_sym_switch] = ACTIONS(3012),
    [anon_sym_case] = ACTIONS(3012),
    [anon_sym_default] = ACTIONS(3012),
    [anon_sym_while] = ACTIONS(3012),
    [anon_sym_do] = ACTIONS(3012),
    [anon_sym_for] = ACTIONS(3012),
    [anon_sym_return] = ACTIONS(3012),
    [anon_sym_break] = ACTIONS(3012),
    [anon_sym_continue] = ACTIONS(3012),
    [anon_sym_goto] = ACTIONS(3012),
    [anon_sym___try] = ACTIONS(3012),
    [anon_sym___leave] = ACTIONS(3012),
    [anon_sym_not] = ACTIONS(3012),
    [anon_sym_compl] = ACTIONS(3012),
    [anon_sym_DASH_DASH] = ACTIONS(3014),
    [anon_sym_PLUS_PLUS] = ACTIONS(3014),
    [anon_sym_sizeof] = ACTIONS(3012),
    [anon_sym___alignof__] = ACTIONS(3012),
    [anon_sym___alignof] = ACTIONS(3012),
    [anon_sym__alignof] = ACTIONS(3012),
    [anon_sym_alignof] = ACTIONS(3012),
    [anon_sym__Alignof] = ACTIONS(3012),
    [anon_sym_offsetof] = ACTIONS(3012),
    [anon_sym__Generic] = ACTIONS(3012),
    [anon_sym_asm] = ACTIONS(3012),
    [anon_sym___asm__] = ACTIONS(3012),
    [aux_sym_number_literal_token1] = ACTIONS(3014),
    [aux_sym_number_literal_token2] = ACTIONS(3012),
    [anon_sym_L_SQUOTE] = ACTIONS(3014),
    [anon_sym_u_SQUOTE] = ACTIONS(3014),
    [anon_sym_U_SQUOTE] = ACTIONS(3014),
    [anon_sym_u8_SQUOTE] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [anon_sym_L_DQUOTE] = ACTIONS(3014),
    [anon_sym_u_DQUOTE] = ACTIONS(3014),
    [anon_sym_U_DQUOTE] = ACTIONS(3014),
    [anon_sym_u8_DQUOTE] = ACTIONS(3014),
    [anon_sym_DQUOTE] = ACTIONS(3014),
    [sym_true] = ACTIONS(3012),
    [sym_false] = ACTIONS(3012),
    [anon_sym_NULL] = ACTIONS(3012),
    [anon_sym_nullptr] = ACTIONS(3012),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3012),
    [anon_sym_decltype] = ACTIONS(3012),
    [anon_sym_virtual] = ACTIONS(3012),
    [anon_sym_alignas] = ACTIONS(3012),
    [anon_sym_explicit] = ACTIONS(3012),
    [anon_sym_typename] = ACTIONS(3012),
    [anon_sym_template] = ACTIONS(3012),
    [anon_sym_operator] = ACTIONS(3012),
    [anon_sym_try] = ACTIONS(3012),
    [anon_sym_delete] = ACTIONS(3012),
    [anon_sym_throw] = ACTIONS(3012),
    [anon_sym_namespace] = ACTIONS(3012),
    [anon_sym_using] = ACTIONS(3012),
    [anon_sym_static_assert] = ACTIONS(3012),
    [anon_sym_concept] = ACTIONS(3012),
    [anon_sym_co_return] = ACTIONS(3012),
    [anon_sym_co_yield] = ACTIONS(3012),
    [anon_sym_R_DQUOTE] = ACTIONS(3014),
    [anon_sym_LR_DQUOTE] = ACTIONS(3014),
    [anon_sym_uR_DQUOTE] = ACTIONS(3014),
    [anon_sym_UR_DQUOTE] = ACTIONS(3014),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3014),
    [anon_sym_co_await] = ACTIONS(3012),
    [anon_sym_new] = ACTIONS(3012),
    [anon_sym_requires] = ACTIONS(3012),
    [sym_this] = ACTIONS(3012),
  },
  [792] = {
    [sym_identifier] = ACTIONS(3044),
    [aux_sym_preproc_include_token1] = ACTIONS(3044),
    [aux_sym_preproc_def_token1] = ACTIONS(3044),
    [aux_sym_preproc_if_token1] = ACTIONS(3044),
    [aux_sym_preproc_if_token2] = ACTIONS(3044),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3044),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3044),
    [sym_preproc_directive] = ACTIONS(3044),
    [anon_sym_LPAREN2] = ACTIONS(3046),
    [anon_sym_BANG] = ACTIONS(3046),
    [anon_sym_TILDE] = ACTIONS(3046),
    [anon_sym_DASH] = ACTIONS(3044),
    [anon_sym_PLUS] = ACTIONS(3044),
    [anon_sym_STAR] = ACTIONS(3046),
    [anon_sym_AMP_AMP] = ACTIONS(3046),
    [anon_sym_AMP] = ACTIONS(3044),
    [anon_sym_SEMI] = ACTIONS(3046),
    [anon_sym___extension__] = ACTIONS(3044),
    [anon_sym_typedef] = ACTIONS(3044),
    [anon_sym_extern] = ACTIONS(3044),
    [anon_sym___attribute__] = ACTIONS(3044),
    [anon_sym_COLON_COLON] = ACTIONS(3046),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3046),
    [anon_sym___declspec] = ACTIONS(3044),
    [anon_sym___based] = ACTIONS(3044),
    [anon_sym___cdecl] = ACTIONS(3044),
    [anon_sym___clrcall] = ACTIONS(3044),
    [anon_sym___stdcall] = ACTIONS(3044),
    [anon_sym___fastcall] = ACTIONS(3044),
    [anon_sym___thiscall] = ACTIONS(3044),
    [anon_sym___vectorcall] = ACTIONS(3044),
    [anon_sym_LBRACE] = ACTIONS(3046),
    [anon_sym_signed] = ACTIONS(3044),
    [anon_sym_unsigned] = ACTIONS(3044),
    [anon_sym_long] = ACTIONS(3044),
    [anon_sym_short] = ACTIONS(3044),
    [anon_sym_LBRACK] = ACTIONS(3044),
    [anon_sym_static] = ACTIONS(3044),
    [anon_sym_register] = ACTIONS(3044),
    [anon_sym_inline] = ACTIONS(3044),
    [anon_sym___inline] = ACTIONS(3044),
    [anon_sym___inline__] = ACTIONS(3044),
    [anon_sym___forceinline] = ACTIONS(3044),
    [anon_sym_thread_local] = ACTIONS(3044),
    [anon_sym___thread] = ACTIONS(3044),
    [anon_sym_const] = ACTIONS(3044),
    [anon_sym_constexpr] = ACTIONS(3044),
    [anon_sym_volatile] = ACTIONS(3044),
    [anon_sym_restrict] = ACTIONS(3044),
    [anon_sym___restrict__] = ACTIONS(3044),
    [anon_sym__Atomic] = ACTIONS(3044),
    [anon_sym__Noreturn] = ACTIONS(3044),
    [anon_sym_noreturn] = ACTIONS(3044),
    [anon_sym_mutable] = ACTIONS(3044),
    [anon_sym_constinit] = ACTIONS(3044),
    [anon_sym_consteval] = ACTIONS(3044),
    [anon_sym_PROGMEM] = ACTIONS(3044),
    [aux_sym_primitive_type_token1] = ACTIONS(3044),
    [anon_sym_byte] = ACTIONS(3044),
    [anon_sym_word] = ACTIONS(3044),
    [anon_sym_enum] = ACTIONS(3044),
    [anon_sym_class] = ACTIONS(3044),
    [anon_sym_struct] = ACTIONS(3044),
    [anon_sym_union] = ACTIONS(3044),
    [anon_sym_if] = ACTIONS(3044),
    [anon_sym_switch] = ACTIONS(3044),
    [anon_sym_case] = ACTIONS(3044),
    [anon_sym_default] = ACTIONS(3044),
    [anon_sym_while] = ACTIONS(3044),
    [anon_sym_do] = ACTIONS(3044),
    [anon_sym_for] = ACTIONS(3044),
    [anon_sym_return] = ACTIONS(3044),
    [anon_sym_break] = ACTIONS(3044),
    [anon_sym_continue] = ACTIONS(3044),
    [anon_sym_goto] = ACTIONS(3044),
    [anon_sym___try] = ACTIONS(3044),
    [anon_sym___leave] = ACTIONS(3044),
    [anon_sym_not] = ACTIONS(3044),
    [anon_sym_compl] = ACTIONS(3044),
    [anon_sym_DASH_DASH] = ACTIONS(3046),
    [anon_sym_PLUS_PLUS] = ACTIONS(3046),
    [anon_sym_sizeof] = ACTIONS(3044),
    [anon_sym___alignof__] = ACTIONS(3044),
    [anon_sym___alignof] = ACTIONS(3044),
    [anon_sym__alignof] = ACTIONS(3044),
    [anon_sym_alignof] = ACTIONS(3044),
    [anon_sym__Alignof] = ACTIONS(3044),
    [anon_sym_offsetof] = ACTIONS(3044),
    [anon_sym__Generic] = ACTIONS(3044),
    [anon_sym_asm] = ACTIONS(3044),
    [anon_sym___asm__] = ACTIONS(3044),
    [aux_sym_number_literal_token1] = ACTIONS(3046),
    [aux_sym_number_literal_token2] = ACTIONS(3044),
    [anon_sym_L_SQUOTE] = ACTIONS(3046),
    [anon_sym_u_SQUOTE] = ACTIONS(3046),
    [anon_sym_U_SQUOTE] = ACTIONS(3046),
    [anon_sym_u8_SQUOTE] = ACTIONS(3046),
    [anon_sym_SQUOTE] = ACTIONS(3046),
    [anon_sym_L_DQUOTE] = ACTIONS(3046),
    [anon_sym_u_DQUOTE] = ACTIONS(3046),
    [anon_sym_U_DQUOTE] = ACTIONS(3046),
    [anon_sym_u8_DQUOTE] = ACTIONS(3046),
    [anon_sym_DQUOTE] = ACTIONS(3046),
    [sym_true] = ACTIONS(3044),
    [sym_false] = ACTIONS(3044),
    [anon_sym_NULL] = ACTIONS(3044),
    [anon_sym_nullptr] = ACTIONS(3044),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3044),
    [anon_sym_decltype] = ACTIONS(3044),
    [anon_sym_virtual] = ACTIONS(3044),
    [anon_sym_alignas] = ACTIONS(3044),
    [anon_sym_explicit] = ACTIONS(3044),
    [anon_sym_typename] = ACTIONS(3044),
    [anon_sym_template] = ACTIONS(3044),
    [anon_sym_operator] = ACTIONS(3044),
    [anon_sym_try] = ACTIONS(3044),
    [anon_sym_delete] = ACTIONS(3044),
    [anon_sym_throw] = ACTIONS(3044),
    [anon_sym_namespace] = ACTIONS(3044),
    [anon_sym_using] = ACTIONS(3044),
    [anon_sym_static_assert] = ACTIONS(3044),
    [anon_sym_concept] = ACTIONS(3044),
    [anon_sym_co_return] = ACTIONS(3044),
    [anon_sym_co_yield] = ACTIONS(3044),
    [anon_sym_R_DQUOTE] = ACTIONS(3046),
    [anon_sym_LR_DQUOTE] = ACTIONS(3046),
    [anon_sym_uR_DQUOTE] = ACTIONS(3046),
    [anon_sym_UR_DQUOTE] = ACTIONS(3046),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3046),
    [anon_sym_co_await] = ACTIONS(3044),
    [anon_sym_new] = ACTIONS(3044),
    [anon_sym_requires] = ACTIONS(3044),
    [sym_this] = ACTIONS(3044),
  },
  [793] = {
    [sym_identifier] = ACTIONS(3056),
    [aux_sym_preproc_include_token1] = ACTIONS(3056),
    [aux_sym_preproc_def_token1] = ACTIONS(3056),
    [aux_sym_preproc_if_token1] = ACTIONS(3056),
    [aux_sym_preproc_if_token2] = ACTIONS(3056),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3056),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3056),
    [sym_preproc_directive] = ACTIONS(3056),
    [anon_sym_LPAREN2] = ACTIONS(3058),
    [anon_sym_BANG] = ACTIONS(3058),
    [anon_sym_TILDE] = ACTIONS(3058),
    [anon_sym_DASH] = ACTIONS(3056),
    [anon_sym_PLUS] = ACTIONS(3056),
    [anon_sym_STAR] = ACTIONS(3058),
    [anon_sym_AMP_AMP] = ACTIONS(3058),
    [anon_sym_AMP] = ACTIONS(3056),
    [anon_sym_SEMI] = ACTIONS(3058),
    [anon_sym___extension__] = ACTIONS(3056),
    [anon_sym_typedef] = ACTIONS(3056),
    [anon_sym_extern] = ACTIONS(3056),
    [anon_sym___attribute__] = ACTIONS(3056),
    [anon_sym_COLON_COLON] = ACTIONS(3058),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3058),
    [anon_sym___declspec] = ACTIONS(3056),
    [anon_sym___based] = ACTIONS(3056),
    [anon_sym___cdecl] = ACTIONS(3056),
    [anon_sym___clrcall] = ACTIONS(3056),
    [anon_sym___stdcall] = ACTIONS(3056),
    [anon_sym___fastcall] = ACTIONS(3056),
    [anon_sym___thiscall] = ACTIONS(3056),
    [anon_sym___vectorcall] = ACTIONS(3056),
    [anon_sym_LBRACE] = ACTIONS(3058),
    [anon_sym_signed] = ACTIONS(3056),
    [anon_sym_unsigned] = ACTIONS(3056),
    [anon_sym_long] = ACTIONS(3056),
    [anon_sym_short] = ACTIONS(3056),
    [anon_sym_LBRACK] = ACTIONS(3056),
    [anon_sym_static] = ACTIONS(3056),
    [anon_sym_register] = ACTIONS(3056),
    [anon_sym_inline] = ACTIONS(3056),
    [anon_sym___inline] = ACTIONS(3056),
    [anon_sym___inline__] = ACTIONS(3056),
    [anon_sym___forceinline] = ACTIONS(3056),
    [anon_sym_thread_local] = ACTIONS(3056),
    [anon_sym___thread] = ACTIONS(3056),
    [anon_sym_const] = ACTIONS(3056),
    [anon_sym_constexpr] = ACTIONS(3056),
    [anon_sym_volatile] = ACTIONS(3056),
    [anon_sym_restrict] = ACTIONS(3056),
    [anon_sym___restrict__] = ACTIONS(3056),
    [anon_sym__Atomic] = ACTIONS(3056),
    [anon_sym__Noreturn] = ACTIONS(3056),
    [anon_sym_noreturn] = ACTIONS(3056),
    [anon_sym_mutable] = ACTIONS(3056),
    [anon_sym_constinit] = ACTIONS(3056),
    [anon_sym_consteval] = ACTIONS(3056),
    [anon_sym_PROGMEM] = ACTIONS(3056),
    [aux_sym_primitive_type_token1] = ACTIONS(3056),
    [anon_sym_byte] = ACTIONS(3056),
    [anon_sym_word] = ACTIONS(3056),
    [anon_sym_enum] = ACTIONS(3056),
    [anon_sym_class] = ACTIONS(3056),
    [anon_sym_struct] = ACTIONS(3056),
    [anon_sym_union] = ACTIONS(3056),
    [anon_sym_if] = ACTIONS(3056),
    [anon_sym_switch] = ACTIONS(3056),
    [anon_sym_case] = ACTIONS(3056),
    [anon_sym_default] = ACTIONS(3056),
    [anon_sym_while] = ACTIONS(3056),
    [anon_sym_do] = ACTIONS(3056),
    [anon_sym_for] = ACTIONS(3056),
    [anon_sym_return] = ACTIONS(3056),
    [anon_sym_break] = ACTIONS(3056),
    [anon_sym_continue] = ACTIONS(3056),
    [anon_sym_goto] = ACTIONS(3056),
    [anon_sym___try] = ACTIONS(3056),
    [anon_sym___leave] = ACTIONS(3056),
    [anon_sym_not] = ACTIONS(3056),
    [anon_sym_compl] = ACTIONS(3056),
    [anon_sym_DASH_DASH] = ACTIONS(3058),
    [anon_sym_PLUS_PLUS] = ACTIONS(3058),
    [anon_sym_sizeof] = ACTIONS(3056),
    [anon_sym___alignof__] = ACTIONS(3056),
    [anon_sym___alignof] = ACTIONS(3056),
    [anon_sym__alignof] = ACTIONS(3056),
    [anon_sym_alignof] = ACTIONS(3056),
    [anon_sym__Alignof] = ACTIONS(3056),
    [anon_sym_offsetof] = ACTIONS(3056),
    [anon_sym__Generic] = ACTIONS(3056),
    [anon_sym_asm] = ACTIONS(3056),
    [anon_sym___asm__] = ACTIONS(3056),
    [aux_sym_number_literal_token1] = ACTIONS(3058),
    [aux_sym_number_literal_token2] = ACTIONS(3056),
    [anon_sym_L_SQUOTE] = ACTIONS(3058),
    [anon_sym_u_SQUOTE] = ACTIONS(3058),
    [anon_sym_U_SQUOTE] = ACTIONS(3058),
    [anon_sym_u8_SQUOTE] = ACTIONS(3058),
    [anon_sym_SQUOTE] = ACTIONS(3058),
    [anon_sym_L_DQUOTE] = ACTIONS(3058),
    [anon_sym_u_DQUOTE] = ACTIONS(3058),
    [anon_sym_U_DQUOTE] = ACTIONS(3058),
    [anon_sym_u8_DQUOTE] = ACTIONS(3058),
    [anon_sym_DQUOTE] = ACTIONS(3058),
    [sym_true] = ACTIONS(3056),
    [sym_false] = ACTIONS(3056),
    [anon_sym_NULL] = ACTIONS(3056),
    [anon_sym_nullptr] = ACTIONS(3056),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3056),
    [anon_sym_decltype] = ACTIONS(3056),
    [anon_sym_virtual] = ACTIONS(3056),
    [anon_sym_alignas] = ACTIONS(3056),
    [anon_sym_explicit] = ACTIONS(3056),
    [anon_sym_typename] = ACTIONS(3056),
    [anon_sym_template] = ACTIONS(3056),
    [anon_sym_operator] = ACTIONS(3056),
    [anon_sym_try] = ACTIONS(3056),
    [anon_sym_delete] = ACTIONS(3056),
    [anon_sym_throw] = ACTIONS(3056),
    [anon_sym_namespace] = ACTIONS(3056),
    [anon_sym_using] = ACTIONS(3056),
    [anon_sym_static_assert] = ACTIONS(3056),
    [anon_sym_concept] = ACTIONS(3056),
    [anon_sym_co_return] = ACTIONS(3056),
    [anon_sym_co_yield] = ACTIONS(3056),
    [anon_sym_R_DQUOTE] = ACTIONS(3058),
    [anon_sym_LR_DQUOTE] = ACTIONS(3058),
    [anon_sym_uR_DQUOTE] = ACTIONS(3058),
    [anon_sym_UR_DQUOTE] = ACTIONS(3058),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3058),
    [anon_sym_co_await] = ACTIONS(3056),
    [anon_sym_new] = ACTIONS(3056),
    [anon_sym_requires] = ACTIONS(3056),
    [sym_this] = ACTIONS(3056),
  },
  [794] = {
    [sym_identifier] = ACTIONS(3064),
    [aux_sym_preproc_include_token1] = ACTIONS(3064),
    [aux_sym_preproc_def_token1] = ACTIONS(3064),
    [aux_sym_preproc_if_token1] = ACTIONS(3064),
    [aux_sym_preproc_if_token2] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3064),
    [sym_preproc_directive] = ACTIONS(3064),
    [anon_sym_LPAREN2] = ACTIONS(3066),
    [anon_sym_BANG] = ACTIONS(3066),
    [anon_sym_TILDE] = ACTIONS(3066),
    [anon_sym_DASH] = ACTIONS(3064),
    [anon_sym_PLUS] = ACTIONS(3064),
    [anon_sym_STAR] = ACTIONS(3066),
    [anon_sym_AMP_AMP] = ACTIONS(3066),
    [anon_sym_AMP] = ACTIONS(3064),
    [anon_sym_SEMI] = ACTIONS(3066),
    [anon_sym___extension__] = ACTIONS(3064),
    [anon_sym_typedef] = ACTIONS(3064),
    [anon_sym_extern] = ACTIONS(3064),
    [anon_sym___attribute__] = ACTIONS(3064),
    [anon_sym_COLON_COLON] = ACTIONS(3066),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3066),
    [anon_sym___declspec] = ACTIONS(3064),
    [anon_sym___based] = ACTIONS(3064),
    [anon_sym___cdecl] = ACTIONS(3064),
    [anon_sym___clrcall] = ACTIONS(3064),
    [anon_sym___stdcall] = ACTIONS(3064),
    [anon_sym___fastcall] = ACTIONS(3064),
    [anon_sym___thiscall] = ACTIONS(3064),
    [anon_sym___vectorcall] = ACTIONS(3064),
    [anon_sym_LBRACE] = ACTIONS(3066),
    [anon_sym_signed] = ACTIONS(3064),
    [anon_sym_unsigned] = ACTIONS(3064),
    [anon_sym_long] = ACTIONS(3064),
    [anon_sym_short] = ACTIONS(3064),
    [anon_sym_LBRACK] = ACTIONS(3064),
    [anon_sym_static] = ACTIONS(3064),
    [anon_sym_register] = ACTIONS(3064),
    [anon_sym_inline] = ACTIONS(3064),
    [anon_sym___inline] = ACTIONS(3064),
    [anon_sym___inline__] = ACTIONS(3064),
    [anon_sym___forceinline] = ACTIONS(3064),
    [anon_sym_thread_local] = ACTIONS(3064),
    [anon_sym___thread] = ACTIONS(3064),
    [anon_sym_const] = ACTIONS(3064),
    [anon_sym_constexpr] = ACTIONS(3064),
    [anon_sym_volatile] = ACTIONS(3064),
    [anon_sym_restrict] = ACTIONS(3064),
    [anon_sym___restrict__] = ACTIONS(3064),
    [anon_sym__Atomic] = ACTIONS(3064),
    [anon_sym__Noreturn] = ACTIONS(3064),
    [anon_sym_noreturn] = ACTIONS(3064),
    [anon_sym_mutable] = ACTIONS(3064),
    [anon_sym_constinit] = ACTIONS(3064),
    [anon_sym_consteval] = ACTIONS(3064),
    [anon_sym_PROGMEM] = ACTIONS(3064),
    [aux_sym_primitive_type_token1] = ACTIONS(3064),
    [anon_sym_byte] = ACTIONS(3064),
    [anon_sym_word] = ACTIONS(3064),
    [anon_sym_enum] = ACTIONS(3064),
    [anon_sym_class] = ACTIONS(3064),
    [anon_sym_struct] = ACTIONS(3064),
    [anon_sym_union] = ACTIONS(3064),
    [anon_sym_if] = ACTIONS(3064),
    [anon_sym_switch] = ACTIONS(3064),
    [anon_sym_case] = ACTIONS(3064),
    [anon_sym_default] = ACTIONS(3064),
    [anon_sym_while] = ACTIONS(3064),
    [anon_sym_do] = ACTIONS(3064),
    [anon_sym_for] = ACTIONS(3064),
    [anon_sym_return] = ACTIONS(3064),
    [anon_sym_break] = ACTIONS(3064),
    [anon_sym_continue] = ACTIONS(3064),
    [anon_sym_goto] = ACTIONS(3064),
    [anon_sym___try] = ACTIONS(3064),
    [anon_sym___leave] = ACTIONS(3064),
    [anon_sym_not] = ACTIONS(3064),
    [anon_sym_compl] = ACTIONS(3064),
    [anon_sym_DASH_DASH] = ACTIONS(3066),
    [anon_sym_PLUS_PLUS] = ACTIONS(3066),
    [anon_sym_sizeof] = ACTIONS(3064),
    [anon_sym___alignof__] = ACTIONS(3064),
    [anon_sym___alignof] = ACTIONS(3064),
    [anon_sym__alignof] = ACTIONS(3064),
    [anon_sym_alignof] = ACTIONS(3064),
    [anon_sym__Alignof] = ACTIONS(3064),
    [anon_sym_offsetof] = ACTIONS(3064),
    [anon_sym__Generic] = ACTIONS(3064),
    [anon_sym_asm] = ACTIONS(3064),
    [anon_sym___asm__] = ACTIONS(3064),
    [aux_sym_number_literal_token1] = ACTIONS(3066),
    [aux_sym_number_literal_token2] = ACTIONS(3064),
    [anon_sym_L_SQUOTE] = ACTIONS(3066),
    [anon_sym_u_SQUOTE] = ACTIONS(3066),
    [anon_sym_U_SQUOTE] = ACTIONS(3066),
    [anon_sym_u8_SQUOTE] = ACTIONS(3066),
    [anon_sym_SQUOTE] = ACTIONS(3066),
    [anon_sym_L_DQUOTE] = ACTIONS(3066),
    [anon_sym_u_DQUOTE] = ACTIONS(3066),
    [anon_sym_U_DQUOTE] = ACTIONS(3066),
    [anon_sym_u8_DQUOTE] = ACTIONS(3066),
    [anon_sym_DQUOTE] = ACTIONS(3066),
    [sym_true] = ACTIONS(3064),
    [sym_false] = ACTIONS(3064),
    [anon_sym_NULL] = ACTIONS(3064),
    [anon_sym_nullptr] = ACTIONS(3064),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3064),
    [anon_sym_decltype] = ACTIONS(3064),
    [anon_sym_virtual] = ACTIONS(3064),
    [anon_sym_alignas] = ACTIONS(3064),
    [anon_sym_explicit] = ACTIONS(3064),
    [anon_sym_typename] = ACTIONS(3064),
    [anon_sym_template] = ACTIONS(3064),
    [anon_sym_operator] = ACTIONS(3064),
    [anon_sym_try] = ACTIONS(3064),
    [anon_sym_delete] = ACTIONS(3064),
    [anon_sym_throw] = ACTIONS(3064),
    [anon_sym_namespace] = ACTIONS(3064),
    [anon_sym_using] = ACTIONS(3064),
    [anon_sym_static_assert] = ACTIONS(3064),
    [anon_sym_concept] = ACTIONS(3064),
    [anon_sym_co_return] = ACTIONS(3064),
    [anon_sym_co_yield] = ACTIONS(3064),
    [anon_sym_R_DQUOTE] = ACTIONS(3066),
    [anon_sym_LR_DQUOTE] = ACTIONS(3066),
    [anon_sym_uR_DQUOTE] = ACTIONS(3066),
    [anon_sym_UR_DQUOTE] = ACTIONS(3066),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3066),
    [anon_sym_co_await] = ACTIONS(3064),
    [anon_sym_new] = ACTIONS(3064),
    [anon_sym_requires] = ACTIONS(3064),
    [sym_this] = ACTIONS(3064),
  },
  [795] = {
    [sym_identifier] = ACTIONS(3044),
    [aux_sym_preproc_include_token1] = ACTIONS(3044),
    [aux_sym_preproc_def_token1] = ACTIONS(3044),
    [aux_sym_preproc_if_token1] = ACTIONS(3044),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3044),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3044),
    [sym_preproc_directive] = ACTIONS(3044),
    [anon_sym_LPAREN2] = ACTIONS(3046),
    [anon_sym_BANG] = ACTIONS(3046),
    [anon_sym_TILDE] = ACTIONS(3046),
    [anon_sym_DASH] = ACTIONS(3044),
    [anon_sym_PLUS] = ACTIONS(3044),
    [anon_sym_STAR] = ACTIONS(3046),
    [anon_sym_AMP_AMP] = ACTIONS(3046),
    [anon_sym_AMP] = ACTIONS(3044),
    [anon_sym_SEMI] = ACTIONS(3046),
    [anon_sym___extension__] = ACTIONS(3044),
    [anon_sym_typedef] = ACTIONS(3044),
    [anon_sym_extern] = ACTIONS(3044),
    [anon_sym___attribute__] = ACTIONS(3044),
    [anon_sym_COLON_COLON] = ACTIONS(3046),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3046),
    [anon_sym___declspec] = ACTIONS(3044),
    [anon_sym___based] = ACTIONS(3044),
    [anon_sym___cdecl] = ACTIONS(3044),
    [anon_sym___clrcall] = ACTIONS(3044),
    [anon_sym___stdcall] = ACTIONS(3044),
    [anon_sym___fastcall] = ACTIONS(3044),
    [anon_sym___thiscall] = ACTIONS(3044),
    [anon_sym___vectorcall] = ACTIONS(3044),
    [anon_sym_LBRACE] = ACTIONS(3046),
    [anon_sym_RBRACE] = ACTIONS(3046),
    [anon_sym_signed] = ACTIONS(3044),
    [anon_sym_unsigned] = ACTIONS(3044),
    [anon_sym_long] = ACTIONS(3044),
    [anon_sym_short] = ACTIONS(3044),
    [anon_sym_LBRACK] = ACTIONS(3044),
    [anon_sym_static] = ACTIONS(3044),
    [anon_sym_register] = ACTIONS(3044),
    [anon_sym_inline] = ACTIONS(3044),
    [anon_sym___inline] = ACTIONS(3044),
    [anon_sym___inline__] = ACTIONS(3044),
    [anon_sym___forceinline] = ACTIONS(3044),
    [anon_sym_thread_local] = ACTIONS(3044),
    [anon_sym___thread] = ACTIONS(3044),
    [anon_sym_const] = ACTIONS(3044),
    [anon_sym_constexpr] = ACTIONS(3044),
    [anon_sym_volatile] = ACTIONS(3044),
    [anon_sym_restrict] = ACTIONS(3044),
    [anon_sym___restrict__] = ACTIONS(3044),
    [anon_sym__Atomic] = ACTIONS(3044),
    [anon_sym__Noreturn] = ACTIONS(3044),
    [anon_sym_noreturn] = ACTIONS(3044),
    [anon_sym_mutable] = ACTIONS(3044),
    [anon_sym_constinit] = ACTIONS(3044),
    [anon_sym_consteval] = ACTIONS(3044),
    [anon_sym_PROGMEM] = ACTIONS(3044),
    [aux_sym_primitive_type_token1] = ACTIONS(3044),
    [anon_sym_byte] = ACTIONS(3044),
    [anon_sym_word] = ACTIONS(3044),
    [anon_sym_enum] = ACTIONS(3044),
    [anon_sym_class] = ACTIONS(3044),
    [anon_sym_struct] = ACTIONS(3044),
    [anon_sym_union] = ACTIONS(3044),
    [anon_sym_if] = ACTIONS(3044),
    [anon_sym_switch] = ACTIONS(3044),
    [anon_sym_case] = ACTIONS(3044),
    [anon_sym_default] = ACTIONS(3044),
    [anon_sym_while] = ACTIONS(3044),
    [anon_sym_do] = ACTIONS(3044),
    [anon_sym_for] = ACTIONS(3044),
    [anon_sym_return] = ACTIONS(3044),
    [anon_sym_break] = ACTIONS(3044),
    [anon_sym_continue] = ACTIONS(3044),
    [anon_sym_goto] = ACTIONS(3044),
    [anon_sym___try] = ACTIONS(3044),
    [anon_sym___leave] = ACTIONS(3044),
    [anon_sym_not] = ACTIONS(3044),
    [anon_sym_compl] = ACTIONS(3044),
    [anon_sym_DASH_DASH] = ACTIONS(3046),
    [anon_sym_PLUS_PLUS] = ACTIONS(3046),
    [anon_sym_sizeof] = ACTIONS(3044),
    [anon_sym___alignof__] = ACTIONS(3044),
    [anon_sym___alignof] = ACTIONS(3044),
    [anon_sym__alignof] = ACTIONS(3044),
    [anon_sym_alignof] = ACTIONS(3044),
    [anon_sym__Alignof] = ACTIONS(3044),
    [anon_sym_offsetof] = ACTIONS(3044),
    [anon_sym__Generic] = ACTIONS(3044),
    [anon_sym_asm] = ACTIONS(3044),
    [anon_sym___asm__] = ACTIONS(3044),
    [aux_sym_number_literal_token1] = ACTIONS(3046),
    [aux_sym_number_literal_token2] = ACTIONS(3044),
    [anon_sym_L_SQUOTE] = ACTIONS(3046),
    [anon_sym_u_SQUOTE] = ACTIONS(3046),
    [anon_sym_U_SQUOTE] = ACTIONS(3046),
    [anon_sym_u8_SQUOTE] = ACTIONS(3046),
    [anon_sym_SQUOTE] = ACTIONS(3046),
    [anon_sym_L_DQUOTE] = ACTIONS(3046),
    [anon_sym_u_DQUOTE] = ACTIONS(3046),
    [anon_sym_U_DQUOTE] = ACTIONS(3046),
    [anon_sym_u8_DQUOTE] = ACTIONS(3046),
    [anon_sym_DQUOTE] = ACTIONS(3046),
    [sym_true] = ACTIONS(3044),
    [sym_false] = ACTIONS(3044),
    [anon_sym_NULL] = ACTIONS(3044),
    [anon_sym_nullptr] = ACTIONS(3044),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3044),
    [anon_sym_decltype] = ACTIONS(3044),
    [anon_sym_virtual] = ACTIONS(3044),
    [anon_sym_alignas] = ACTIONS(3044),
    [anon_sym_explicit] = ACTIONS(3044),
    [anon_sym_typename] = ACTIONS(3044),
    [anon_sym_template] = ACTIONS(3044),
    [anon_sym_operator] = ACTIONS(3044),
    [anon_sym_try] = ACTIONS(3044),
    [anon_sym_delete] = ACTIONS(3044),
    [anon_sym_throw] = ACTIONS(3044),
    [anon_sym_namespace] = ACTIONS(3044),
    [anon_sym_using] = ACTIONS(3044),
    [anon_sym_static_assert] = ACTIONS(3044),
    [anon_sym_concept] = ACTIONS(3044),
    [anon_sym_co_return] = ACTIONS(3044),
    [anon_sym_co_yield] = ACTIONS(3044),
    [anon_sym_R_DQUOTE] = ACTIONS(3046),
    [anon_sym_LR_DQUOTE] = ACTIONS(3046),
    [anon_sym_uR_DQUOTE] = ACTIONS(3046),
    [anon_sym_UR_DQUOTE] = ACTIONS(3046),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3046),
    [anon_sym_co_await] = ACTIONS(3044),
    [anon_sym_new] = ACTIONS(3044),
    [anon_sym_requires] = ACTIONS(3044),
    [sym_this] = ACTIONS(3044),
  },
  [796] = {
    [sym_identifier] = ACTIONS(3144),
    [aux_sym_preproc_include_token1] = ACTIONS(3144),
    [aux_sym_preproc_def_token1] = ACTIONS(3144),
    [aux_sym_preproc_if_token1] = ACTIONS(3144),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3144),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3144),
    [sym_preproc_directive] = ACTIONS(3144),
    [anon_sym_LPAREN2] = ACTIONS(3146),
    [anon_sym_BANG] = ACTIONS(3146),
    [anon_sym_TILDE] = ACTIONS(3146),
    [anon_sym_DASH] = ACTIONS(3144),
    [anon_sym_PLUS] = ACTIONS(3144),
    [anon_sym_STAR] = ACTIONS(3146),
    [anon_sym_AMP_AMP] = ACTIONS(3146),
    [anon_sym_AMP] = ACTIONS(3144),
    [anon_sym_SEMI] = ACTIONS(3146),
    [anon_sym___extension__] = ACTIONS(3144),
    [anon_sym_typedef] = ACTIONS(3144),
    [anon_sym_extern] = ACTIONS(3144),
    [anon_sym___attribute__] = ACTIONS(3144),
    [anon_sym_COLON_COLON] = ACTIONS(3146),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3146),
    [anon_sym___declspec] = ACTIONS(3144),
    [anon_sym___based] = ACTIONS(3144),
    [anon_sym___cdecl] = ACTIONS(3144),
    [anon_sym___clrcall] = ACTIONS(3144),
    [anon_sym___stdcall] = ACTIONS(3144),
    [anon_sym___fastcall] = ACTIONS(3144),
    [anon_sym___thiscall] = ACTIONS(3144),
    [anon_sym___vectorcall] = ACTIONS(3144),
    [anon_sym_LBRACE] = ACTIONS(3146),
    [anon_sym_RBRACE] = ACTIONS(3146),
    [anon_sym_signed] = ACTIONS(3144),
    [anon_sym_unsigned] = ACTIONS(3144),
    [anon_sym_long] = ACTIONS(3144),
    [anon_sym_short] = ACTIONS(3144),
    [anon_sym_LBRACK] = ACTIONS(3144),
    [anon_sym_static] = ACTIONS(3144),
    [anon_sym_register] = ACTIONS(3144),
    [anon_sym_inline] = ACTIONS(3144),
    [anon_sym___inline] = ACTIONS(3144),
    [anon_sym___inline__] = ACTIONS(3144),
    [anon_sym___forceinline] = ACTIONS(3144),
    [anon_sym_thread_local] = ACTIONS(3144),
    [anon_sym___thread] = ACTIONS(3144),
    [anon_sym_const] = ACTIONS(3144),
    [anon_sym_constexpr] = ACTIONS(3144),
    [anon_sym_volatile] = ACTIONS(3144),
    [anon_sym_restrict] = ACTIONS(3144),
    [anon_sym___restrict__] = ACTIONS(3144),
    [anon_sym__Atomic] = ACTIONS(3144),
    [anon_sym__Noreturn] = ACTIONS(3144),
    [anon_sym_noreturn] = ACTIONS(3144),
    [anon_sym_mutable] = ACTIONS(3144),
    [anon_sym_constinit] = ACTIONS(3144),
    [anon_sym_consteval] = ACTIONS(3144),
    [anon_sym_PROGMEM] = ACTIONS(3144),
    [aux_sym_primitive_type_token1] = ACTIONS(3144),
    [anon_sym_byte] = ACTIONS(3144),
    [anon_sym_word] = ACTIONS(3144),
    [anon_sym_enum] = ACTIONS(3144),
    [anon_sym_class] = ACTIONS(3144),
    [anon_sym_struct] = ACTIONS(3144),
    [anon_sym_union] = ACTIONS(3144),
    [anon_sym_if] = ACTIONS(3144),
    [anon_sym_switch] = ACTIONS(3144),
    [anon_sym_case] = ACTIONS(3144),
    [anon_sym_default] = ACTIONS(3144),
    [anon_sym_while] = ACTIONS(3144),
    [anon_sym_do] = ACTIONS(3144),
    [anon_sym_for] = ACTIONS(3144),
    [anon_sym_return] = ACTIONS(3144),
    [anon_sym_break] = ACTIONS(3144),
    [anon_sym_continue] = ACTIONS(3144),
    [anon_sym_goto] = ACTIONS(3144),
    [anon_sym___try] = ACTIONS(3144),
    [anon_sym___leave] = ACTIONS(3144),
    [anon_sym_not] = ACTIONS(3144),
    [anon_sym_compl] = ACTIONS(3144),
    [anon_sym_DASH_DASH] = ACTIONS(3146),
    [anon_sym_PLUS_PLUS] = ACTIONS(3146),
    [anon_sym_sizeof] = ACTIONS(3144),
    [anon_sym___alignof__] = ACTIONS(3144),
    [anon_sym___alignof] = ACTIONS(3144),
    [anon_sym__alignof] = ACTIONS(3144),
    [anon_sym_alignof] = ACTIONS(3144),
    [anon_sym__Alignof] = ACTIONS(3144),
    [anon_sym_offsetof] = ACTIONS(3144),
    [anon_sym__Generic] = ACTIONS(3144),
    [anon_sym_asm] = ACTIONS(3144),
    [anon_sym___asm__] = ACTIONS(3144),
    [aux_sym_number_literal_token1] = ACTIONS(3146),
    [aux_sym_number_literal_token2] = ACTIONS(3144),
    [anon_sym_L_SQUOTE] = ACTIONS(3146),
    [anon_sym_u_SQUOTE] = ACTIONS(3146),
    [anon_sym_U_SQUOTE] = ACTIONS(3146),
    [anon_sym_u8_SQUOTE] = ACTIONS(3146),
    [anon_sym_SQUOTE] = ACTIONS(3146),
    [anon_sym_L_DQUOTE] = ACTIONS(3146),
    [anon_sym_u_DQUOTE] = ACTIONS(3146),
    [anon_sym_U_DQUOTE] = ACTIONS(3146),
    [anon_sym_u8_DQUOTE] = ACTIONS(3146),
    [anon_sym_DQUOTE] = ACTIONS(3146),
    [sym_true] = ACTIONS(3144),
    [sym_false] = ACTIONS(3144),
    [anon_sym_NULL] = ACTIONS(3144),
    [anon_sym_nullptr] = ACTIONS(3144),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3144),
    [anon_sym_decltype] = ACTIONS(3144),
    [anon_sym_virtual] = ACTIONS(3144),
    [anon_sym_alignas] = ACTIONS(3144),
    [anon_sym_explicit] = ACTIONS(3144),
    [anon_sym_typename] = ACTIONS(3144),
    [anon_sym_template] = ACTIONS(3144),
    [anon_sym_operator] = ACTIONS(3144),
    [anon_sym_try] = ACTIONS(3144),
    [anon_sym_delete] = ACTIONS(3144),
    [anon_sym_throw] = ACTIONS(3144),
    [anon_sym_namespace] = ACTIONS(3144),
    [anon_sym_using] = ACTIONS(3144),
    [anon_sym_static_assert] = ACTIONS(3144),
    [anon_sym_concept] = ACTIONS(3144),
    [anon_sym_co_return] = ACTIONS(3144),
    [anon_sym_co_yield] = ACTIONS(3144),
    [anon_sym_R_DQUOTE] = ACTIONS(3146),
    [anon_sym_LR_DQUOTE] = ACTIONS(3146),
    [anon_sym_uR_DQUOTE] = ACTIONS(3146),
    [anon_sym_UR_DQUOTE] = ACTIONS(3146),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3146),
    [anon_sym_co_await] = ACTIONS(3144),
    [anon_sym_new] = ACTIONS(3144),
    [anon_sym_requires] = ACTIONS(3144),
    [sym_this] = ACTIONS(3144),
  },
  [797] = {
    [sym_identifier] = ACTIONS(3024),
    [aux_sym_preproc_include_token1] = ACTIONS(3024),
    [aux_sym_preproc_def_token1] = ACTIONS(3024),
    [aux_sym_preproc_if_token1] = ACTIONS(3024),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3024),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3024),
    [sym_preproc_directive] = ACTIONS(3024),
    [anon_sym_LPAREN2] = ACTIONS(3026),
    [anon_sym_BANG] = ACTIONS(3026),
    [anon_sym_TILDE] = ACTIONS(3026),
    [anon_sym_DASH] = ACTIONS(3024),
    [anon_sym_PLUS] = ACTIONS(3024),
    [anon_sym_STAR] = ACTIONS(3026),
    [anon_sym_AMP_AMP] = ACTIONS(3026),
    [anon_sym_AMP] = ACTIONS(3024),
    [anon_sym_SEMI] = ACTIONS(3026),
    [anon_sym___extension__] = ACTIONS(3024),
    [anon_sym_typedef] = ACTIONS(3024),
    [anon_sym_extern] = ACTIONS(3024),
    [anon_sym___attribute__] = ACTIONS(3024),
    [anon_sym_COLON_COLON] = ACTIONS(3026),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3026),
    [anon_sym___declspec] = ACTIONS(3024),
    [anon_sym___based] = ACTIONS(3024),
    [anon_sym___cdecl] = ACTIONS(3024),
    [anon_sym___clrcall] = ACTIONS(3024),
    [anon_sym___stdcall] = ACTIONS(3024),
    [anon_sym___fastcall] = ACTIONS(3024),
    [anon_sym___thiscall] = ACTIONS(3024),
    [anon_sym___vectorcall] = ACTIONS(3024),
    [anon_sym_LBRACE] = ACTIONS(3026),
    [anon_sym_RBRACE] = ACTIONS(3026),
    [anon_sym_signed] = ACTIONS(3024),
    [anon_sym_unsigned] = ACTIONS(3024),
    [anon_sym_long] = ACTIONS(3024),
    [anon_sym_short] = ACTIONS(3024),
    [anon_sym_LBRACK] = ACTIONS(3024),
    [anon_sym_static] = ACTIONS(3024),
    [anon_sym_register] = ACTIONS(3024),
    [anon_sym_inline] = ACTIONS(3024),
    [anon_sym___inline] = ACTIONS(3024),
    [anon_sym___inline__] = ACTIONS(3024),
    [anon_sym___forceinline] = ACTIONS(3024),
    [anon_sym_thread_local] = ACTIONS(3024),
    [anon_sym___thread] = ACTIONS(3024),
    [anon_sym_const] = ACTIONS(3024),
    [anon_sym_constexpr] = ACTIONS(3024),
    [anon_sym_volatile] = ACTIONS(3024),
    [anon_sym_restrict] = ACTIONS(3024),
    [anon_sym___restrict__] = ACTIONS(3024),
    [anon_sym__Atomic] = ACTIONS(3024),
    [anon_sym__Noreturn] = ACTIONS(3024),
    [anon_sym_noreturn] = ACTIONS(3024),
    [anon_sym_mutable] = ACTIONS(3024),
    [anon_sym_constinit] = ACTIONS(3024),
    [anon_sym_consteval] = ACTIONS(3024),
    [anon_sym_PROGMEM] = ACTIONS(3024),
    [aux_sym_primitive_type_token1] = ACTIONS(3024),
    [anon_sym_byte] = ACTIONS(3024),
    [anon_sym_word] = ACTIONS(3024),
    [anon_sym_enum] = ACTIONS(3024),
    [anon_sym_class] = ACTIONS(3024),
    [anon_sym_struct] = ACTIONS(3024),
    [anon_sym_union] = ACTIONS(3024),
    [anon_sym_if] = ACTIONS(3024),
    [anon_sym_switch] = ACTIONS(3024),
    [anon_sym_case] = ACTIONS(3024),
    [anon_sym_default] = ACTIONS(3024),
    [anon_sym_while] = ACTIONS(3024),
    [anon_sym_do] = ACTIONS(3024),
    [anon_sym_for] = ACTIONS(3024),
    [anon_sym_return] = ACTIONS(3024),
    [anon_sym_break] = ACTIONS(3024),
    [anon_sym_continue] = ACTIONS(3024),
    [anon_sym_goto] = ACTIONS(3024),
    [anon_sym___try] = ACTIONS(3024),
    [anon_sym___leave] = ACTIONS(3024),
    [anon_sym_not] = ACTIONS(3024),
    [anon_sym_compl] = ACTIONS(3024),
    [anon_sym_DASH_DASH] = ACTIONS(3026),
    [anon_sym_PLUS_PLUS] = ACTIONS(3026),
    [anon_sym_sizeof] = ACTIONS(3024),
    [anon_sym___alignof__] = ACTIONS(3024),
    [anon_sym___alignof] = ACTIONS(3024),
    [anon_sym__alignof] = ACTIONS(3024),
    [anon_sym_alignof] = ACTIONS(3024),
    [anon_sym__Alignof] = ACTIONS(3024),
    [anon_sym_offsetof] = ACTIONS(3024),
    [anon_sym__Generic] = ACTIONS(3024),
    [anon_sym_asm] = ACTIONS(3024),
    [anon_sym___asm__] = ACTIONS(3024),
    [aux_sym_number_literal_token1] = ACTIONS(3026),
    [aux_sym_number_literal_token2] = ACTIONS(3024),
    [anon_sym_L_SQUOTE] = ACTIONS(3026),
    [anon_sym_u_SQUOTE] = ACTIONS(3026),
    [anon_sym_U_SQUOTE] = ACTIONS(3026),
    [anon_sym_u8_SQUOTE] = ACTIONS(3026),
    [anon_sym_SQUOTE] = ACTIONS(3026),
    [anon_sym_L_DQUOTE] = ACTIONS(3026),
    [anon_sym_u_DQUOTE] = ACTIONS(3026),
    [anon_sym_U_DQUOTE] = ACTIONS(3026),
    [anon_sym_u8_DQUOTE] = ACTIONS(3026),
    [anon_sym_DQUOTE] = ACTIONS(3026),
    [sym_true] = ACTIONS(3024),
    [sym_false] = ACTIONS(3024),
    [anon_sym_NULL] = ACTIONS(3024),
    [anon_sym_nullptr] = ACTIONS(3024),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3024),
    [anon_sym_decltype] = ACTIONS(3024),
    [anon_sym_virtual] = ACTIONS(3024),
    [anon_sym_alignas] = ACTIONS(3024),
    [anon_sym_explicit] = ACTIONS(3024),
    [anon_sym_typename] = ACTIONS(3024),
    [anon_sym_template] = ACTIONS(3024),
    [anon_sym_operator] = ACTIONS(3024),
    [anon_sym_try] = ACTIONS(3024),
    [anon_sym_delete] = ACTIONS(3024),
    [anon_sym_throw] = ACTIONS(3024),
    [anon_sym_namespace] = ACTIONS(3024),
    [anon_sym_using] = ACTIONS(3024),
    [anon_sym_static_assert] = ACTIONS(3024),
    [anon_sym_concept] = ACTIONS(3024),
    [anon_sym_co_return] = ACTIONS(3024),
    [anon_sym_co_yield] = ACTIONS(3024),
    [anon_sym_R_DQUOTE] = ACTIONS(3026),
    [anon_sym_LR_DQUOTE] = ACTIONS(3026),
    [anon_sym_uR_DQUOTE] = ACTIONS(3026),
    [anon_sym_UR_DQUOTE] = ACTIONS(3026),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3026),
    [anon_sym_co_await] = ACTIONS(3024),
    [anon_sym_new] = ACTIONS(3024),
    [anon_sym_requires] = ACTIONS(3024),
    [sym_this] = ACTIONS(3024),
  },
  [798] = {
    [sym_identifier] = ACTIONS(3028),
    [aux_sym_preproc_include_token1] = ACTIONS(3028),
    [aux_sym_preproc_def_token1] = ACTIONS(3028),
    [aux_sym_preproc_if_token1] = ACTIONS(3028),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3028),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3028),
    [sym_preproc_directive] = ACTIONS(3028),
    [anon_sym_LPAREN2] = ACTIONS(3030),
    [anon_sym_BANG] = ACTIONS(3030),
    [anon_sym_TILDE] = ACTIONS(3030),
    [anon_sym_DASH] = ACTIONS(3028),
    [anon_sym_PLUS] = ACTIONS(3028),
    [anon_sym_STAR] = ACTIONS(3030),
    [anon_sym_AMP_AMP] = ACTIONS(3030),
    [anon_sym_AMP] = ACTIONS(3028),
    [anon_sym_SEMI] = ACTIONS(3030),
    [anon_sym___extension__] = ACTIONS(3028),
    [anon_sym_typedef] = ACTIONS(3028),
    [anon_sym_extern] = ACTIONS(3028),
    [anon_sym___attribute__] = ACTIONS(3028),
    [anon_sym_COLON_COLON] = ACTIONS(3030),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3030),
    [anon_sym___declspec] = ACTIONS(3028),
    [anon_sym___based] = ACTIONS(3028),
    [anon_sym___cdecl] = ACTIONS(3028),
    [anon_sym___clrcall] = ACTIONS(3028),
    [anon_sym___stdcall] = ACTIONS(3028),
    [anon_sym___fastcall] = ACTIONS(3028),
    [anon_sym___thiscall] = ACTIONS(3028),
    [anon_sym___vectorcall] = ACTIONS(3028),
    [anon_sym_LBRACE] = ACTIONS(3030),
    [anon_sym_RBRACE] = ACTIONS(3030),
    [anon_sym_signed] = ACTIONS(3028),
    [anon_sym_unsigned] = ACTIONS(3028),
    [anon_sym_long] = ACTIONS(3028),
    [anon_sym_short] = ACTIONS(3028),
    [anon_sym_LBRACK] = ACTIONS(3028),
    [anon_sym_static] = ACTIONS(3028),
    [anon_sym_register] = ACTIONS(3028),
    [anon_sym_inline] = ACTIONS(3028),
    [anon_sym___inline] = ACTIONS(3028),
    [anon_sym___inline__] = ACTIONS(3028),
    [anon_sym___forceinline] = ACTIONS(3028),
    [anon_sym_thread_local] = ACTIONS(3028),
    [anon_sym___thread] = ACTIONS(3028),
    [anon_sym_const] = ACTIONS(3028),
    [anon_sym_constexpr] = ACTIONS(3028),
    [anon_sym_volatile] = ACTIONS(3028),
    [anon_sym_restrict] = ACTIONS(3028),
    [anon_sym___restrict__] = ACTIONS(3028),
    [anon_sym__Atomic] = ACTIONS(3028),
    [anon_sym__Noreturn] = ACTIONS(3028),
    [anon_sym_noreturn] = ACTIONS(3028),
    [anon_sym_mutable] = ACTIONS(3028),
    [anon_sym_constinit] = ACTIONS(3028),
    [anon_sym_consteval] = ACTIONS(3028),
    [anon_sym_PROGMEM] = ACTIONS(3028),
    [aux_sym_primitive_type_token1] = ACTIONS(3028),
    [anon_sym_byte] = ACTIONS(3028),
    [anon_sym_word] = ACTIONS(3028),
    [anon_sym_enum] = ACTIONS(3028),
    [anon_sym_class] = ACTIONS(3028),
    [anon_sym_struct] = ACTIONS(3028),
    [anon_sym_union] = ACTIONS(3028),
    [anon_sym_if] = ACTIONS(3028),
    [anon_sym_switch] = ACTIONS(3028),
    [anon_sym_case] = ACTIONS(3028),
    [anon_sym_default] = ACTIONS(3028),
    [anon_sym_while] = ACTIONS(3028),
    [anon_sym_do] = ACTIONS(3028),
    [anon_sym_for] = ACTIONS(3028),
    [anon_sym_return] = ACTIONS(3028),
    [anon_sym_break] = ACTIONS(3028),
    [anon_sym_continue] = ACTIONS(3028),
    [anon_sym_goto] = ACTIONS(3028),
    [anon_sym___try] = ACTIONS(3028),
    [anon_sym___leave] = ACTIONS(3028),
    [anon_sym_not] = ACTIONS(3028),
    [anon_sym_compl] = ACTIONS(3028),
    [anon_sym_DASH_DASH] = ACTIONS(3030),
    [anon_sym_PLUS_PLUS] = ACTIONS(3030),
    [anon_sym_sizeof] = ACTIONS(3028),
    [anon_sym___alignof__] = ACTIONS(3028),
    [anon_sym___alignof] = ACTIONS(3028),
    [anon_sym__alignof] = ACTIONS(3028),
    [anon_sym_alignof] = ACTIONS(3028),
    [anon_sym__Alignof] = ACTIONS(3028),
    [anon_sym_offsetof] = ACTIONS(3028),
    [anon_sym__Generic] = ACTIONS(3028),
    [anon_sym_asm] = ACTIONS(3028),
    [anon_sym___asm__] = ACTIONS(3028),
    [aux_sym_number_literal_token1] = ACTIONS(3030),
    [aux_sym_number_literal_token2] = ACTIONS(3028),
    [anon_sym_L_SQUOTE] = ACTIONS(3030),
    [anon_sym_u_SQUOTE] = ACTIONS(3030),
    [anon_sym_U_SQUOTE] = ACTIONS(3030),
    [anon_sym_u8_SQUOTE] = ACTIONS(3030),
    [anon_sym_SQUOTE] = ACTIONS(3030),
    [anon_sym_L_DQUOTE] = ACTIONS(3030),
    [anon_sym_u_DQUOTE] = ACTIONS(3030),
    [anon_sym_U_DQUOTE] = ACTIONS(3030),
    [anon_sym_u8_DQUOTE] = ACTIONS(3030),
    [anon_sym_DQUOTE] = ACTIONS(3030),
    [sym_true] = ACTIONS(3028),
    [sym_false] = ACTIONS(3028),
    [anon_sym_NULL] = ACTIONS(3028),
    [anon_sym_nullptr] = ACTIONS(3028),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3028),
    [anon_sym_decltype] = ACTIONS(3028),
    [anon_sym_virtual] = ACTIONS(3028),
    [anon_sym_alignas] = ACTIONS(3028),
    [anon_sym_explicit] = ACTIONS(3028),
    [anon_sym_typename] = ACTIONS(3028),
    [anon_sym_template] = ACTIONS(3028),
    [anon_sym_operator] = ACTIONS(3028),
    [anon_sym_try] = ACTIONS(3028),
    [anon_sym_delete] = ACTIONS(3028),
    [anon_sym_throw] = ACTIONS(3028),
    [anon_sym_namespace] = ACTIONS(3028),
    [anon_sym_using] = ACTIONS(3028),
    [anon_sym_static_assert] = ACTIONS(3028),
    [anon_sym_concept] = ACTIONS(3028),
    [anon_sym_co_return] = ACTIONS(3028),
    [anon_sym_co_yield] = ACTIONS(3028),
    [anon_sym_R_DQUOTE] = ACTIONS(3030),
    [anon_sym_LR_DQUOTE] = ACTIONS(3030),
    [anon_sym_uR_DQUOTE] = ACTIONS(3030),
    [anon_sym_UR_DQUOTE] = ACTIONS(3030),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3030),
    [anon_sym_co_await] = ACTIONS(3028),
    [anon_sym_new] = ACTIONS(3028),
    [anon_sym_requires] = ACTIONS(3028),
    [sym_this] = ACTIONS(3028),
  },
  [799] = {
    [sym_identifier] = ACTIONS(3036),
    [aux_sym_preproc_include_token1] = ACTIONS(3036),
    [aux_sym_preproc_def_token1] = ACTIONS(3036),
    [aux_sym_preproc_if_token1] = ACTIONS(3036),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3036),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3036),
    [sym_preproc_directive] = ACTIONS(3036),
    [anon_sym_LPAREN2] = ACTIONS(3038),
    [anon_sym_BANG] = ACTIONS(3038),
    [anon_sym_TILDE] = ACTIONS(3038),
    [anon_sym_DASH] = ACTIONS(3036),
    [anon_sym_PLUS] = ACTIONS(3036),
    [anon_sym_STAR] = ACTIONS(3038),
    [anon_sym_AMP_AMP] = ACTIONS(3038),
    [anon_sym_AMP] = ACTIONS(3036),
    [anon_sym_SEMI] = ACTIONS(3038),
    [anon_sym___extension__] = ACTIONS(3036),
    [anon_sym_typedef] = ACTIONS(3036),
    [anon_sym_extern] = ACTIONS(3036),
    [anon_sym___attribute__] = ACTIONS(3036),
    [anon_sym_COLON_COLON] = ACTIONS(3038),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3038),
    [anon_sym___declspec] = ACTIONS(3036),
    [anon_sym___based] = ACTIONS(3036),
    [anon_sym___cdecl] = ACTIONS(3036),
    [anon_sym___clrcall] = ACTIONS(3036),
    [anon_sym___stdcall] = ACTIONS(3036),
    [anon_sym___fastcall] = ACTIONS(3036),
    [anon_sym___thiscall] = ACTIONS(3036),
    [anon_sym___vectorcall] = ACTIONS(3036),
    [anon_sym_LBRACE] = ACTIONS(3038),
    [anon_sym_RBRACE] = ACTIONS(3038),
    [anon_sym_signed] = ACTIONS(3036),
    [anon_sym_unsigned] = ACTIONS(3036),
    [anon_sym_long] = ACTIONS(3036),
    [anon_sym_short] = ACTIONS(3036),
    [anon_sym_LBRACK] = ACTIONS(3036),
    [anon_sym_static] = ACTIONS(3036),
    [anon_sym_register] = ACTIONS(3036),
    [anon_sym_inline] = ACTIONS(3036),
    [anon_sym___inline] = ACTIONS(3036),
    [anon_sym___inline__] = ACTIONS(3036),
    [anon_sym___forceinline] = ACTIONS(3036),
    [anon_sym_thread_local] = ACTIONS(3036),
    [anon_sym___thread] = ACTIONS(3036),
    [anon_sym_const] = ACTIONS(3036),
    [anon_sym_constexpr] = ACTIONS(3036),
    [anon_sym_volatile] = ACTIONS(3036),
    [anon_sym_restrict] = ACTIONS(3036),
    [anon_sym___restrict__] = ACTIONS(3036),
    [anon_sym__Atomic] = ACTIONS(3036),
    [anon_sym__Noreturn] = ACTIONS(3036),
    [anon_sym_noreturn] = ACTIONS(3036),
    [anon_sym_mutable] = ACTIONS(3036),
    [anon_sym_constinit] = ACTIONS(3036),
    [anon_sym_consteval] = ACTIONS(3036),
    [anon_sym_PROGMEM] = ACTIONS(3036),
    [aux_sym_primitive_type_token1] = ACTIONS(3036),
    [anon_sym_byte] = ACTIONS(3036),
    [anon_sym_word] = ACTIONS(3036),
    [anon_sym_enum] = ACTIONS(3036),
    [anon_sym_class] = ACTIONS(3036),
    [anon_sym_struct] = ACTIONS(3036),
    [anon_sym_union] = ACTIONS(3036),
    [anon_sym_if] = ACTIONS(3036),
    [anon_sym_switch] = ACTIONS(3036),
    [anon_sym_case] = ACTIONS(3036),
    [anon_sym_default] = ACTIONS(3036),
    [anon_sym_while] = ACTIONS(3036),
    [anon_sym_do] = ACTIONS(3036),
    [anon_sym_for] = ACTIONS(3036),
    [anon_sym_return] = ACTIONS(3036),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_continue] = ACTIONS(3036),
    [anon_sym_goto] = ACTIONS(3036),
    [anon_sym___try] = ACTIONS(3036),
    [anon_sym___leave] = ACTIONS(3036),
    [anon_sym_not] = ACTIONS(3036),
    [anon_sym_compl] = ACTIONS(3036),
    [anon_sym_DASH_DASH] = ACTIONS(3038),
    [anon_sym_PLUS_PLUS] = ACTIONS(3038),
    [anon_sym_sizeof] = ACTIONS(3036),
    [anon_sym___alignof__] = ACTIONS(3036),
    [anon_sym___alignof] = ACTIONS(3036),
    [anon_sym__alignof] = ACTIONS(3036),
    [anon_sym_alignof] = ACTIONS(3036),
    [anon_sym__Alignof] = ACTIONS(3036),
    [anon_sym_offsetof] = ACTIONS(3036),
    [anon_sym__Generic] = ACTIONS(3036),
    [anon_sym_asm] = ACTIONS(3036),
    [anon_sym___asm__] = ACTIONS(3036),
    [aux_sym_number_literal_token1] = ACTIONS(3038),
    [aux_sym_number_literal_token2] = ACTIONS(3036),
    [anon_sym_L_SQUOTE] = ACTIONS(3038),
    [anon_sym_u_SQUOTE] = ACTIONS(3038),
    [anon_sym_U_SQUOTE] = ACTIONS(3038),
    [anon_sym_u8_SQUOTE] = ACTIONS(3038),
    [anon_sym_SQUOTE] = ACTIONS(3038),
    [anon_sym_L_DQUOTE] = ACTIONS(3038),
    [anon_sym_u_DQUOTE] = ACTIONS(3038),
    [anon_sym_U_DQUOTE] = ACTIONS(3038),
    [anon_sym_u8_DQUOTE] = ACTIONS(3038),
    [anon_sym_DQUOTE] = ACTIONS(3038),
    [sym_true] = ACTIONS(3036),
    [sym_false] = ACTIONS(3036),
    [anon_sym_NULL] = ACTIONS(3036),
    [anon_sym_nullptr] = ACTIONS(3036),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3036),
    [anon_sym_decltype] = ACTIONS(3036),
    [anon_sym_virtual] = ACTIONS(3036),
    [anon_sym_alignas] = ACTIONS(3036),
    [anon_sym_explicit] = ACTIONS(3036),
    [anon_sym_typename] = ACTIONS(3036),
    [anon_sym_template] = ACTIONS(3036),
    [anon_sym_operator] = ACTIONS(3036),
    [anon_sym_try] = ACTIONS(3036),
    [anon_sym_delete] = ACTIONS(3036),
    [anon_sym_throw] = ACTIONS(3036),
    [anon_sym_namespace] = ACTIONS(3036),
    [anon_sym_using] = ACTIONS(3036),
    [anon_sym_static_assert] = ACTIONS(3036),
    [anon_sym_concept] = ACTIONS(3036),
    [anon_sym_co_return] = ACTIONS(3036),
    [anon_sym_co_yield] = ACTIONS(3036),
    [anon_sym_R_DQUOTE] = ACTIONS(3038),
    [anon_sym_LR_DQUOTE] = ACTIONS(3038),
    [anon_sym_uR_DQUOTE] = ACTIONS(3038),
    [anon_sym_UR_DQUOTE] = ACTIONS(3038),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3038),
    [anon_sym_co_await] = ACTIONS(3036),
    [anon_sym_new] = ACTIONS(3036),
    [anon_sym_requires] = ACTIONS(3036),
    [sym_this] = ACTIONS(3036),
  },
  [800] = {
    [sym_identifier] = ACTIONS(3111),
    [aux_sym_preproc_include_token1] = ACTIONS(3111),
    [aux_sym_preproc_def_token1] = ACTIONS(3111),
    [aux_sym_preproc_if_token1] = ACTIONS(3111),
    [aux_sym_preproc_if_token2] = ACTIONS(3111),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3111),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3111),
    [sym_preproc_directive] = ACTIONS(3111),
    [anon_sym_LPAREN2] = ACTIONS(3113),
    [anon_sym_BANG] = ACTIONS(3113),
    [anon_sym_TILDE] = ACTIONS(3113),
    [anon_sym_DASH] = ACTIONS(3111),
    [anon_sym_PLUS] = ACTIONS(3111),
    [anon_sym_STAR] = ACTIONS(3113),
    [anon_sym_AMP_AMP] = ACTIONS(3113),
    [anon_sym_AMP] = ACTIONS(3111),
    [anon_sym_SEMI] = ACTIONS(3113),
    [anon_sym___extension__] = ACTIONS(3111),
    [anon_sym_typedef] = ACTIONS(3111),
    [anon_sym_extern] = ACTIONS(3111),
    [anon_sym___attribute__] = ACTIONS(3111),
    [anon_sym_COLON_COLON] = ACTIONS(3113),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3113),
    [anon_sym___declspec] = ACTIONS(3111),
    [anon_sym___based] = ACTIONS(3111),
    [anon_sym___cdecl] = ACTIONS(3111),
    [anon_sym___clrcall] = ACTIONS(3111),
    [anon_sym___stdcall] = ACTIONS(3111),
    [anon_sym___fastcall] = ACTIONS(3111),
    [anon_sym___thiscall] = ACTIONS(3111),
    [anon_sym___vectorcall] = ACTIONS(3111),
    [anon_sym_LBRACE] = ACTIONS(3113),
    [anon_sym_signed] = ACTIONS(3111),
    [anon_sym_unsigned] = ACTIONS(3111),
    [anon_sym_long] = ACTIONS(3111),
    [anon_sym_short] = ACTIONS(3111),
    [anon_sym_LBRACK] = ACTIONS(3111),
    [anon_sym_static] = ACTIONS(3111),
    [anon_sym_register] = ACTIONS(3111),
    [anon_sym_inline] = ACTIONS(3111),
    [anon_sym___inline] = ACTIONS(3111),
    [anon_sym___inline__] = ACTIONS(3111),
    [anon_sym___forceinline] = ACTIONS(3111),
    [anon_sym_thread_local] = ACTIONS(3111),
    [anon_sym___thread] = ACTIONS(3111),
    [anon_sym_const] = ACTIONS(3111),
    [anon_sym_constexpr] = ACTIONS(3111),
    [anon_sym_volatile] = ACTIONS(3111),
    [anon_sym_restrict] = ACTIONS(3111),
    [anon_sym___restrict__] = ACTIONS(3111),
    [anon_sym__Atomic] = ACTIONS(3111),
    [anon_sym__Noreturn] = ACTIONS(3111),
    [anon_sym_noreturn] = ACTIONS(3111),
    [anon_sym_mutable] = ACTIONS(3111),
    [anon_sym_constinit] = ACTIONS(3111),
    [anon_sym_consteval] = ACTIONS(3111),
    [anon_sym_PROGMEM] = ACTIONS(3111),
    [aux_sym_primitive_type_token1] = ACTIONS(3111),
    [anon_sym_byte] = ACTIONS(3111),
    [anon_sym_word] = ACTIONS(3111),
    [anon_sym_enum] = ACTIONS(3111),
    [anon_sym_class] = ACTIONS(3111),
    [anon_sym_struct] = ACTIONS(3111),
    [anon_sym_union] = ACTIONS(3111),
    [anon_sym_if] = ACTIONS(3111),
    [anon_sym_switch] = ACTIONS(3111),
    [anon_sym_case] = ACTIONS(3111),
    [anon_sym_default] = ACTIONS(3111),
    [anon_sym_while] = ACTIONS(3111),
    [anon_sym_do] = ACTIONS(3111),
    [anon_sym_for] = ACTIONS(3111),
    [anon_sym_return] = ACTIONS(3111),
    [anon_sym_break] = ACTIONS(3111),
    [anon_sym_continue] = ACTIONS(3111),
    [anon_sym_goto] = ACTIONS(3111),
    [anon_sym___try] = ACTIONS(3111),
    [anon_sym___leave] = ACTIONS(3111),
    [anon_sym_not] = ACTIONS(3111),
    [anon_sym_compl] = ACTIONS(3111),
    [anon_sym_DASH_DASH] = ACTIONS(3113),
    [anon_sym_PLUS_PLUS] = ACTIONS(3113),
    [anon_sym_sizeof] = ACTIONS(3111),
    [anon_sym___alignof__] = ACTIONS(3111),
    [anon_sym___alignof] = ACTIONS(3111),
    [anon_sym__alignof] = ACTIONS(3111),
    [anon_sym_alignof] = ACTIONS(3111),
    [anon_sym__Alignof] = ACTIONS(3111),
    [anon_sym_offsetof] = ACTIONS(3111),
    [anon_sym__Generic] = ACTIONS(3111),
    [anon_sym_asm] = ACTIONS(3111),
    [anon_sym___asm__] = ACTIONS(3111),
    [aux_sym_number_literal_token1] = ACTIONS(3113),
    [aux_sym_number_literal_token2] = ACTIONS(3111),
    [anon_sym_L_SQUOTE] = ACTIONS(3113),
    [anon_sym_u_SQUOTE] = ACTIONS(3113),
    [anon_sym_U_SQUOTE] = ACTIONS(3113),
    [anon_sym_u8_SQUOTE] = ACTIONS(3113),
    [anon_sym_SQUOTE] = ACTIONS(3113),
    [anon_sym_L_DQUOTE] = ACTIONS(3113),
    [anon_sym_u_DQUOTE] = ACTIONS(3113),
    [anon_sym_U_DQUOTE] = ACTIONS(3113),
    [anon_sym_u8_DQUOTE] = ACTIONS(3113),
    [anon_sym_DQUOTE] = ACTIONS(3113),
    [sym_true] = ACTIONS(3111),
    [sym_false] = ACTIONS(3111),
    [anon_sym_NULL] = ACTIONS(3111),
    [anon_sym_nullptr] = ACTIONS(3111),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3111),
    [anon_sym_decltype] = ACTIONS(3111),
    [anon_sym_virtual] = ACTIONS(3111),
    [anon_sym_alignas] = ACTIONS(3111),
    [anon_sym_explicit] = ACTIONS(3111),
    [anon_sym_typename] = ACTIONS(3111),
    [anon_sym_template] = ACTIONS(3111),
    [anon_sym_operator] = ACTIONS(3111),
    [anon_sym_try] = ACTIONS(3111),
    [anon_sym_delete] = ACTIONS(3111),
    [anon_sym_throw] = ACTIONS(3111),
    [anon_sym_namespace] = ACTIONS(3111),
    [anon_sym_using] = ACTIONS(3111),
    [anon_sym_static_assert] = ACTIONS(3111),
    [anon_sym_concept] = ACTIONS(3111),
    [anon_sym_co_return] = ACTIONS(3111),
    [anon_sym_co_yield] = ACTIONS(3111),
    [anon_sym_R_DQUOTE] = ACTIONS(3113),
    [anon_sym_LR_DQUOTE] = ACTIONS(3113),
    [anon_sym_uR_DQUOTE] = ACTIONS(3113),
    [anon_sym_UR_DQUOTE] = ACTIONS(3113),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3113),
    [anon_sym_co_await] = ACTIONS(3111),
    [anon_sym_new] = ACTIONS(3111),
    [anon_sym_requires] = ACTIONS(3111),
    [sym_this] = ACTIONS(3111),
  },
  [801] = {
    [sym_identifier] = ACTIONS(3040),
    [aux_sym_preproc_include_token1] = ACTIONS(3040),
    [aux_sym_preproc_def_token1] = ACTIONS(3040),
    [aux_sym_preproc_if_token1] = ACTIONS(3040),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3040),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3040),
    [sym_preproc_directive] = ACTIONS(3040),
    [anon_sym_LPAREN2] = ACTIONS(3042),
    [anon_sym_BANG] = ACTIONS(3042),
    [anon_sym_TILDE] = ACTIONS(3042),
    [anon_sym_DASH] = ACTIONS(3040),
    [anon_sym_PLUS] = ACTIONS(3040),
    [anon_sym_STAR] = ACTIONS(3042),
    [anon_sym_AMP_AMP] = ACTIONS(3042),
    [anon_sym_AMP] = ACTIONS(3040),
    [anon_sym_SEMI] = ACTIONS(3042),
    [anon_sym___extension__] = ACTIONS(3040),
    [anon_sym_typedef] = ACTIONS(3040),
    [anon_sym_extern] = ACTIONS(3040),
    [anon_sym___attribute__] = ACTIONS(3040),
    [anon_sym_COLON_COLON] = ACTIONS(3042),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3042),
    [anon_sym___declspec] = ACTIONS(3040),
    [anon_sym___based] = ACTIONS(3040),
    [anon_sym___cdecl] = ACTIONS(3040),
    [anon_sym___clrcall] = ACTIONS(3040),
    [anon_sym___stdcall] = ACTIONS(3040),
    [anon_sym___fastcall] = ACTIONS(3040),
    [anon_sym___thiscall] = ACTIONS(3040),
    [anon_sym___vectorcall] = ACTIONS(3040),
    [anon_sym_LBRACE] = ACTIONS(3042),
    [anon_sym_RBRACE] = ACTIONS(3042),
    [anon_sym_signed] = ACTIONS(3040),
    [anon_sym_unsigned] = ACTIONS(3040),
    [anon_sym_long] = ACTIONS(3040),
    [anon_sym_short] = ACTIONS(3040),
    [anon_sym_LBRACK] = ACTIONS(3040),
    [anon_sym_static] = ACTIONS(3040),
    [anon_sym_register] = ACTIONS(3040),
    [anon_sym_inline] = ACTIONS(3040),
    [anon_sym___inline] = ACTIONS(3040),
    [anon_sym___inline__] = ACTIONS(3040),
    [anon_sym___forceinline] = ACTIONS(3040),
    [anon_sym_thread_local] = ACTIONS(3040),
    [anon_sym___thread] = ACTIONS(3040),
    [anon_sym_const] = ACTIONS(3040),
    [anon_sym_constexpr] = ACTIONS(3040),
    [anon_sym_volatile] = ACTIONS(3040),
    [anon_sym_restrict] = ACTIONS(3040),
    [anon_sym___restrict__] = ACTIONS(3040),
    [anon_sym__Atomic] = ACTIONS(3040),
    [anon_sym__Noreturn] = ACTIONS(3040),
    [anon_sym_noreturn] = ACTIONS(3040),
    [anon_sym_mutable] = ACTIONS(3040),
    [anon_sym_constinit] = ACTIONS(3040),
    [anon_sym_consteval] = ACTIONS(3040),
    [anon_sym_PROGMEM] = ACTIONS(3040),
    [aux_sym_primitive_type_token1] = ACTIONS(3040),
    [anon_sym_byte] = ACTIONS(3040),
    [anon_sym_word] = ACTIONS(3040),
    [anon_sym_enum] = ACTIONS(3040),
    [anon_sym_class] = ACTIONS(3040),
    [anon_sym_struct] = ACTIONS(3040),
    [anon_sym_union] = ACTIONS(3040),
    [anon_sym_if] = ACTIONS(3040),
    [anon_sym_switch] = ACTIONS(3040),
    [anon_sym_case] = ACTIONS(3040),
    [anon_sym_default] = ACTIONS(3040),
    [anon_sym_while] = ACTIONS(3040),
    [anon_sym_do] = ACTIONS(3040),
    [anon_sym_for] = ACTIONS(3040),
    [anon_sym_return] = ACTIONS(3040),
    [anon_sym_break] = ACTIONS(3040),
    [anon_sym_continue] = ACTIONS(3040),
    [anon_sym_goto] = ACTIONS(3040),
    [anon_sym___try] = ACTIONS(3040),
    [anon_sym___leave] = ACTIONS(3040),
    [anon_sym_not] = ACTIONS(3040),
    [anon_sym_compl] = ACTIONS(3040),
    [anon_sym_DASH_DASH] = ACTIONS(3042),
    [anon_sym_PLUS_PLUS] = ACTIONS(3042),
    [anon_sym_sizeof] = ACTIONS(3040),
    [anon_sym___alignof__] = ACTIONS(3040),
    [anon_sym___alignof] = ACTIONS(3040),
    [anon_sym__alignof] = ACTIONS(3040),
    [anon_sym_alignof] = ACTIONS(3040),
    [anon_sym__Alignof] = ACTIONS(3040),
    [anon_sym_offsetof] = ACTIONS(3040),
    [anon_sym__Generic] = ACTIONS(3040),
    [anon_sym_asm] = ACTIONS(3040),
    [anon_sym___asm__] = ACTIONS(3040),
    [aux_sym_number_literal_token1] = ACTIONS(3042),
    [aux_sym_number_literal_token2] = ACTIONS(3040),
    [anon_sym_L_SQUOTE] = ACTIONS(3042),
    [anon_sym_u_SQUOTE] = ACTIONS(3042),
    [anon_sym_U_SQUOTE] = ACTIONS(3042),
    [anon_sym_u8_SQUOTE] = ACTIONS(3042),
    [anon_sym_SQUOTE] = ACTIONS(3042),
    [anon_sym_L_DQUOTE] = ACTIONS(3042),
    [anon_sym_u_DQUOTE] = ACTIONS(3042),
    [anon_sym_U_DQUOTE] = ACTIONS(3042),
    [anon_sym_u8_DQUOTE] = ACTIONS(3042),
    [anon_sym_DQUOTE] = ACTIONS(3042),
    [sym_true] = ACTIONS(3040),
    [sym_false] = ACTIONS(3040),
    [anon_sym_NULL] = ACTIONS(3040),
    [anon_sym_nullptr] = ACTIONS(3040),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3040),
    [anon_sym_decltype] = ACTIONS(3040),
    [anon_sym_virtual] = ACTIONS(3040),
    [anon_sym_alignas] = ACTIONS(3040),
    [anon_sym_explicit] = ACTIONS(3040),
    [anon_sym_typename] = ACTIONS(3040),
    [anon_sym_template] = ACTIONS(3040),
    [anon_sym_operator] = ACTIONS(3040),
    [anon_sym_try] = ACTIONS(3040),
    [anon_sym_delete] = ACTIONS(3040),
    [anon_sym_throw] = ACTIONS(3040),
    [anon_sym_namespace] = ACTIONS(3040),
    [anon_sym_using] = ACTIONS(3040),
    [anon_sym_static_assert] = ACTIONS(3040),
    [anon_sym_concept] = ACTIONS(3040),
    [anon_sym_co_return] = ACTIONS(3040),
    [anon_sym_co_yield] = ACTIONS(3040),
    [anon_sym_R_DQUOTE] = ACTIONS(3042),
    [anon_sym_LR_DQUOTE] = ACTIONS(3042),
    [anon_sym_uR_DQUOTE] = ACTIONS(3042),
    [anon_sym_UR_DQUOTE] = ACTIONS(3042),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3042),
    [anon_sym_co_await] = ACTIONS(3040),
    [anon_sym_new] = ACTIONS(3040),
    [anon_sym_requires] = ACTIONS(3040),
    [sym_this] = ACTIONS(3040),
  },
  [802] = {
    [sym_identifier] = ACTIONS(3170),
    [aux_sym_preproc_include_token1] = ACTIONS(3170),
    [aux_sym_preproc_def_token1] = ACTIONS(3170),
    [aux_sym_preproc_if_token1] = ACTIONS(3170),
    [aux_sym_preproc_if_token2] = ACTIONS(3170),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3170),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3170),
    [sym_preproc_directive] = ACTIONS(3170),
    [anon_sym_LPAREN2] = ACTIONS(3172),
    [anon_sym_BANG] = ACTIONS(3172),
    [anon_sym_TILDE] = ACTIONS(3172),
    [anon_sym_DASH] = ACTIONS(3170),
    [anon_sym_PLUS] = ACTIONS(3170),
    [anon_sym_STAR] = ACTIONS(3172),
    [anon_sym_AMP_AMP] = ACTIONS(3172),
    [anon_sym_AMP] = ACTIONS(3170),
    [anon_sym_SEMI] = ACTIONS(3172),
    [anon_sym___extension__] = ACTIONS(3170),
    [anon_sym_typedef] = ACTIONS(3170),
    [anon_sym_extern] = ACTIONS(3170),
    [anon_sym___attribute__] = ACTIONS(3170),
    [anon_sym_COLON_COLON] = ACTIONS(3172),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3172),
    [anon_sym___declspec] = ACTIONS(3170),
    [anon_sym___based] = ACTIONS(3170),
    [anon_sym___cdecl] = ACTIONS(3170),
    [anon_sym___clrcall] = ACTIONS(3170),
    [anon_sym___stdcall] = ACTIONS(3170),
    [anon_sym___fastcall] = ACTIONS(3170),
    [anon_sym___thiscall] = ACTIONS(3170),
    [anon_sym___vectorcall] = ACTIONS(3170),
    [anon_sym_LBRACE] = ACTIONS(3172),
    [anon_sym_signed] = ACTIONS(3170),
    [anon_sym_unsigned] = ACTIONS(3170),
    [anon_sym_long] = ACTIONS(3170),
    [anon_sym_short] = ACTIONS(3170),
    [anon_sym_LBRACK] = ACTIONS(3170),
    [anon_sym_static] = ACTIONS(3170),
    [anon_sym_register] = ACTIONS(3170),
    [anon_sym_inline] = ACTIONS(3170),
    [anon_sym___inline] = ACTIONS(3170),
    [anon_sym___inline__] = ACTIONS(3170),
    [anon_sym___forceinline] = ACTIONS(3170),
    [anon_sym_thread_local] = ACTIONS(3170),
    [anon_sym___thread] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3170),
    [anon_sym_constexpr] = ACTIONS(3170),
    [anon_sym_volatile] = ACTIONS(3170),
    [anon_sym_restrict] = ACTIONS(3170),
    [anon_sym___restrict__] = ACTIONS(3170),
    [anon_sym__Atomic] = ACTIONS(3170),
    [anon_sym__Noreturn] = ACTIONS(3170),
    [anon_sym_noreturn] = ACTIONS(3170),
    [anon_sym_mutable] = ACTIONS(3170),
    [anon_sym_constinit] = ACTIONS(3170),
    [anon_sym_consteval] = ACTIONS(3170),
    [anon_sym_PROGMEM] = ACTIONS(3170),
    [aux_sym_primitive_type_token1] = ACTIONS(3170),
    [anon_sym_byte] = ACTIONS(3170),
    [anon_sym_word] = ACTIONS(3170),
    [anon_sym_enum] = ACTIONS(3170),
    [anon_sym_class] = ACTIONS(3170),
    [anon_sym_struct] = ACTIONS(3170),
    [anon_sym_union] = ACTIONS(3170),
    [anon_sym_if] = ACTIONS(3170),
    [anon_sym_switch] = ACTIONS(3170),
    [anon_sym_case] = ACTIONS(3170),
    [anon_sym_default] = ACTIONS(3170),
    [anon_sym_while] = ACTIONS(3170),
    [anon_sym_do] = ACTIONS(3170),
    [anon_sym_for] = ACTIONS(3170),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_break] = ACTIONS(3170),
    [anon_sym_continue] = ACTIONS(3170),
    [anon_sym_goto] = ACTIONS(3170),
    [anon_sym___try] = ACTIONS(3170),
    [anon_sym___leave] = ACTIONS(3170),
    [anon_sym_not] = ACTIONS(3170),
    [anon_sym_compl] = ACTIONS(3170),
    [anon_sym_DASH_DASH] = ACTIONS(3172),
    [anon_sym_PLUS_PLUS] = ACTIONS(3172),
    [anon_sym_sizeof] = ACTIONS(3170),
    [anon_sym___alignof__] = ACTIONS(3170),
    [anon_sym___alignof] = ACTIONS(3170),
    [anon_sym__alignof] = ACTIONS(3170),
    [anon_sym_alignof] = ACTIONS(3170),
    [anon_sym__Alignof] = ACTIONS(3170),
    [anon_sym_offsetof] = ACTIONS(3170),
    [anon_sym__Generic] = ACTIONS(3170),
    [anon_sym_asm] = ACTIONS(3170),
    [anon_sym___asm__] = ACTIONS(3170),
    [aux_sym_number_literal_token1] = ACTIONS(3172),
    [aux_sym_number_literal_token2] = ACTIONS(3170),
    [anon_sym_L_SQUOTE] = ACTIONS(3172),
    [anon_sym_u_SQUOTE] = ACTIONS(3172),
    [anon_sym_U_SQUOTE] = ACTIONS(3172),
    [anon_sym_u8_SQUOTE] = ACTIONS(3172),
    [anon_sym_SQUOTE] = ACTIONS(3172),
    [anon_sym_L_DQUOTE] = ACTIONS(3172),
    [anon_sym_u_DQUOTE] = ACTIONS(3172),
    [anon_sym_U_DQUOTE] = ACTIONS(3172),
    [anon_sym_u8_DQUOTE] = ACTIONS(3172),
    [anon_sym_DQUOTE] = ACTIONS(3172),
    [sym_true] = ACTIONS(3170),
    [sym_false] = ACTIONS(3170),
    [anon_sym_NULL] = ACTIONS(3170),
    [anon_sym_nullptr] = ACTIONS(3170),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3170),
    [anon_sym_decltype] = ACTIONS(3170),
    [anon_sym_virtual] = ACTIONS(3170),
    [anon_sym_alignas] = ACTIONS(3170),
    [anon_sym_explicit] = ACTIONS(3170),
    [anon_sym_typename] = ACTIONS(3170),
    [anon_sym_template] = ACTIONS(3170),
    [anon_sym_operator] = ACTIONS(3170),
    [anon_sym_try] = ACTIONS(3170),
    [anon_sym_delete] = ACTIONS(3170),
    [anon_sym_throw] = ACTIONS(3170),
    [anon_sym_namespace] = ACTIONS(3170),
    [anon_sym_using] = ACTIONS(3170),
    [anon_sym_static_assert] = ACTIONS(3170),
    [anon_sym_concept] = ACTIONS(3170),
    [anon_sym_co_return] = ACTIONS(3170),
    [anon_sym_co_yield] = ACTIONS(3170),
    [anon_sym_R_DQUOTE] = ACTIONS(3172),
    [anon_sym_LR_DQUOTE] = ACTIONS(3172),
    [anon_sym_uR_DQUOTE] = ACTIONS(3172),
    [anon_sym_UR_DQUOTE] = ACTIONS(3172),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3172),
    [anon_sym_co_await] = ACTIONS(3170),
    [anon_sym_new] = ACTIONS(3170),
    [anon_sym_requires] = ACTIONS(3170),
    [sym_this] = ACTIONS(3170),
  },
  [803] = {
    [sym_identifier] = ACTIONS(2801),
    [aux_sym_preproc_include_token1] = ACTIONS(2801),
    [aux_sym_preproc_def_token1] = ACTIONS(2801),
    [aux_sym_preproc_if_token1] = ACTIONS(2801),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2801),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2801),
    [sym_preproc_directive] = ACTIONS(2801),
    [anon_sym_LPAREN2] = ACTIONS(2803),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2801),
    [anon_sym_PLUS] = ACTIONS(2801),
    [anon_sym_STAR] = ACTIONS(2803),
    [anon_sym_AMP_AMP] = ACTIONS(2803),
    [anon_sym_AMP] = ACTIONS(2801),
    [anon_sym_SEMI] = ACTIONS(2803),
    [anon_sym___extension__] = ACTIONS(2801),
    [anon_sym_typedef] = ACTIONS(2801),
    [anon_sym_extern] = ACTIONS(2801),
    [anon_sym___attribute__] = ACTIONS(2801),
    [anon_sym_COLON_COLON] = ACTIONS(2803),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2803),
    [anon_sym___declspec] = ACTIONS(2801),
    [anon_sym___based] = ACTIONS(2801),
    [anon_sym___cdecl] = ACTIONS(2801),
    [anon_sym___clrcall] = ACTIONS(2801),
    [anon_sym___stdcall] = ACTIONS(2801),
    [anon_sym___fastcall] = ACTIONS(2801),
    [anon_sym___thiscall] = ACTIONS(2801),
    [anon_sym___vectorcall] = ACTIONS(2801),
    [anon_sym_LBRACE] = ACTIONS(2803),
    [anon_sym_RBRACE] = ACTIONS(2803),
    [anon_sym_signed] = ACTIONS(2801),
    [anon_sym_unsigned] = ACTIONS(2801),
    [anon_sym_long] = ACTIONS(2801),
    [anon_sym_short] = ACTIONS(2801),
    [anon_sym_LBRACK] = ACTIONS(2801),
    [anon_sym_static] = ACTIONS(2801),
    [anon_sym_register] = ACTIONS(2801),
    [anon_sym_inline] = ACTIONS(2801),
    [anon_sym___inline] = ACTIONS(2801),
    [anon_sym___inline__] = ACTIONS(2801),
    [anon_sym___forceinline] = ACTIONS(2801),
    [anon_sym_thread_local] = ACTIONS(2801),
    [anon_sym___thread] = ACTIONS(2801),
    [anon_sym_const] = ACTIONS(2801),
    [anon_sym_constexpr] = ACTIONS(2801),
    [anon_sym_volatile] = ACTIONS(2801),
    [anon_sym_restrict] = ACTIONS(2801),
    [anon_sym___restrict__] = ACTIONS(2801),
    [anon_sym__Atomic] = ACTIONS(2801),
    [anon_sym__Noreturn] = ACTIONS(2801),
    [anon_sym_noreturn] = ACTIONS(2801),
    [anon_sym_mutable] = ACTIONS(2801),
    [anon_sym_constinit] = ACTIONS(2801),
    [anon_sym_consteval] = ACTIONS(2801),
    [anon_sym_PROGMEM] = ACTIONS(2801),
    [aux_sym_primitive_type_token1] = ACTIONS(2801),
    [anon_sym_byte] = ACTIONS(2801),
    [anon_sym_word] = ACTIONS(2801),
    [anon_sym_enum] = ACTIONS(2801),
    [anon_sym_class] = ACTIONS(2801),
    [anon_sym_struct] = ACTIONS(2801),
    [anon_sym_union] = ACTIONS(2801),
    [anon_sym_if] = ACTIONS(2801),
    [anon_sym_switch] = ACTIONS(2801),
    [anon_sym_case] = ACTIONS(2801),
    [anon_sym_default] = ACTIONS(2801),
    [anon_sym_while] = ACTIONS(2801),
    [anon_sym_do] = ACTIONS(2801),
    [anon_sym_for] = ACTIONS(2801),
    [anon_sym_return] = ACTIONS(2801),
    [anon_sym_break] = ACTIONS(2801),
    [anon_sym_continue] = ACTIONS(2801),
    [anon_sym_goto] = ACTIONS(2801),
    [anon_sym___try] = ACTIONS(2801),
    [anon_sym___leave] = ACTIONS(2801),
    [anon_sym_not] = ACTIONS(2801),
    [anon_sym_compl] = ACTIONS(2801),
    [anon_sym_DASH_DASH] = ACTIONS(2803),
    [anon_sym_PLUS_PLUS] = ACTIONS(2803),
    [anon_sym_sizeof] = ACTIONS(2801),
    [anon_sym___alignof__] = ACTIONS(2801),
    [anon_sym___alignof] = ACTIONS(2801),
    [anon_sym__alignof] = ACTIONS(2801),
    [anon_sym_alignof] = ACTIONS(2801),
    [anon_sym__Alignof] = ACTIONS(2801),
    [anon_sym_offsetof] = ACTIONS(2801),
    [anon_sym__Generic] = ACTIONS(2801),
    [anon_sym_asm] = ACTIONS(2801),
    [anon_sym___asm__] = ACTIONS(2801),
    [aux_sym_number_literal_token1] = ACTIONS(2803),
    [aux_sym_number_literal_token2] = ACTIONS(2801),
    [anon_sym_L_SQUOTE] = ACTIONS(2803),
    [anon_sym_u_SQUOTE] = ACTIONS(2803),
    [anon_sym_U_SQUOTE] = ACTIONS(2803),
    [anon_sym_u8_SQUOTE] = ACTIONS(2803),
    [anon_sym_SQUOTE] = ACTIONS(2803),
    [anon_sym_L_DQUOTE] = ACTIONS(2803),
    [anon_sym_u_DQUOTE] = ACTIONS(2803),
    [anon_sym_U_DQUOTE] = ACTIONS(2803),
    [anon_sym_u8_DQUOTE] = ACTIONS(2803),
    [anon_sym_DQUOTE] = ACTIONS(2803),
    [sym_true] = ACTIONS(2801),
    [sym_false] = ACTIONS(2801),
    [anon_sym_NULL] = ACTIONS(2801),
    [anon_sym_nullptr] = ACTIONS(2801),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2801),
    [anon_sym_decltype] = ACTIONS(2801),
    [anon_sym_virtual] = ACTIONS(2801),
    [anon_sym_alignas] = ACTIONS(2801),
    [anon_sym_explicit] = ACTIONS(2801),
    [anon_sym_typename] = ACTIONS(2801),
    [anon_sym_template] = ACTIONS(2801),
    [anon_sym_operator] = ACTIONS(2801),
    [anon_sym_try] = ACTIONS(2801),
    [anon_sym_delete] = ACTIONS(2801),
    [anon_sym_throw] = ACTIONS(2801),
    [anon_sym_namespace] = ACTIONS(2801),
    [anon_sym_using] = ACTIONS(2801),
    [anon_sym_static_assert] = ACTIONS(2801),
    [anon_sym_concept] = ACTIONS(2801),
    [anon_sym_co_return] = ACTIONS(2801),
    [anon_sym_co_yield] = ACTIONS(2801),
    [anon_sym_R_DQUOTE] = ACTIONS(2803),
    [anon_sym_LR_DQUOTE] = ACTIONS(2803),
    [anon_sym_uR_DQUOTE] = ACTIONS(2803),
    [anon_sym_UR_DQUOTE] = ACTIONS(2803),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2803),
    [anon_sym_co_await] = ACTIONS(2801),
    [anon_sym_new] = ACTIONS(2801),
    [anon_sym_requires] = ACTIONS(2801),
    [sym_this] = ACTIONS(2801),
  },
  [804] = {
    [sym_identifier] = ACTIONS(2805),
    [aux_sym_preproc_include_token1] = ACTIONS(2805),
    [aux_sym_preproc_def_token1] = ACTIONS(2805),
    [aux_sym_preproc_if_token1] = ACTIONS(2805),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2805),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2805),
    [sym_preproc_directive] = ACTIONS(2805),
    [anon_sym_LPAREN2] = ACTIONS(2807),
    [anon_sym_BANG] = ACTIONS(2807),
    [anon_sym_TILDE] = ACTIONS(2807),
    [anon_sym_DASH] = ACTIONS(2805),
    [anon_sym_PLUS] = ACTIONS(2805),
    [anon_sym_STAR] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2805),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym___extension__] = ACTIONS(2805),
    [anon_sym_typedef] = ACTIONS(2805),
    [anon_sym_extern] = ACTIONS(2805),
    [anon_sym___attribute__] = ACTIONS(2805),
    [anon_sym_COLON_COLON] = ACTIONS(2807),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2807),
    [anon_sym___declspec] = ACTIONS(2805),
    [anon_sym___based] = ACTIONS(2805),
    [anon_sym___cdecl] = ACTIONS(2805),
    [anon_sym___clrcall] = ACTIONS(2805),
    [anon_sym___stdcall] = ACTIONS(2805),
    [anon_sym___fastcall] = ACTIONS(2805),
    [anon_sym___thiscall] = ACTIONS(2805),
    [anon_sym___vectorcall] = ACTIONS(2805),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_RBRACE] = ACTIONS(2807),
    [anon_sym_signed] = ACTIONS(2805),
    [anon_sym_unsigned] = ACTIONS(2805),
    [anon_sym_long] = ACTIONS(2805),
    [anon_sym_short] = ACTIONS(2805),
    [anon_sym_LBRACK] = ACTIONS(2805),
    [anon_sym_static] = ACTIONS(2805),
    [anon_sym_register] = ACTIONS(2805),
    [anon_sym_inline] = ACTIONS(2805),
    [anon_sym___inline] = ACTIONS(2805),
    [anon_sym___inline__] = ACTIONS(2805),
    [anon_sym___forceinline] = ACTIONS(2805),
    [anon_sym_thread_local] = ACTIONS(2805),
    [anon_sym___thread] = ACTIONS(2805),
    [anon_sym_const] = ACTIONS(2805),
    [anon_sym_constexpr] = ACTIONS(2805),
    [anon_sym_volatile] = ACTIONS(2805),
    [anon_sym_restrict] = ACTIONS(2805),
    [anon_sym___restrict__] = ACTIONS(2805),
    [anon_sym__Atomic] = ACTIONS(2805),
    [anon_sym__Noreturn] = ACTIONS(2805),
    [anon_sym_noreturn] = ACTIONS(2805),
    [anon_sym_mutable] = ACTIONS(2805),
    [anon_sym_constinit] = ACTIONS(2805),
    [anon_sym_consteval] = ACTIONS(2805),
    [anon_sym_PROGMEM] = ACTIONS(2805),
    [aux_sym_primitive_type_token1] = ACTIONS(2805),
    [anon_sym_byte] = ACTIONS(2805),
    [anon_sym_word] = ACTIONS(2805),
    [anon_sym_enum] = ACTIONS(2805),
    [anon_sym_class] = ACTIONS(2805),
    [anon_sym_struct] = ACTIONS(2805),
    [anon_sym_union] = ACTIONS(2805),
    [anon_sym_if] = ACTIONS(2805),
    [anon_sym_switch] = ACTIONS(2805),
    [anon_sym_case] = ACTIONS(2805),
    [anon_sym_default] = ACTIONS(2805),
    [anon_sym_while] = ACTIONS(2805),
    [anon_sym_do] = ACTIONS(2805),
    [anon_sym_for] = ACTIONS(2805),
    [anon_sym_return] = ACTIONS(2805),
    [anon_sym_break] = ACTIONS(2805),
    [anon_sym_continue] = ACTIONS(2805),
    [anon_sym_goto] = ACTIONS(2805),
    [anon_sym___try] = ACTIONS(2805),
    [anon_sym___leave] = ACTIONS(2805),
    [anon_sym_not] = ACTIONS(2805),
    [anon_sym_compl] = ACTIONS(2805),
    [anon_sym_DASH_DASH] = ACTIONS(2807),
    [anon_sym_PLUS_PLUS] = ACTIONS(2807),
    [anon_sym_sizeof] = ACTIONS(2805),
    [anon_sym___alignof__] = ACTIONS(2805),
    [anon_sym___alignof] = ACTIONS(2805),
    [anon_sym__alignof] = ACTIONS(2805),
    [anon_sym_alignof] = ACTIONS(2805),
    [anon_sym__Alignof] = ACTIONS(2805),
    [anon_sym_offsetof] = ACTIONS(2805),
    [anon_sym__Generic] = ACTIONS(2805),
    [anon_sym_asm] = ACTIONS(2805),
    [anon_sym___asm__] = ACTIONS(2805),
    [aux_sym_number_literal_token1] = ACTIONS(2807),
    [aux_sym_number_literal_token2] = ACTIONS(2805),
    [anon_sym_L_SQUOTE] = ACTIONS(2807),
    [anon_sym_u_SQUOTE] = ACTIONS(2807),
    [anon_sym_U_SQUOTE] = ACTIONS(2807),
    [anon_sym_u8_SQUOTE] = ACTIONS(2807),
    [anon_sym_SQUOTE] = ACTIONS(2807),
    [anon_sym_L_DQUOTE] = ACTIONS(2807),
    [anon_sym_u_DQUOTE] = ACTIONS(2807),
    [anon_sym_U_DQUOTE] = ACTIONS(2807),
    [anon_sym_u8_DQUOTE] = ACTIONS(2807),
    [anon_sym_DQUOTE] = ACTIONS(2807),
    [sym_true] = ACTIONS(2805),
    [sym_false] = ACTIONS(2805),
    [anon_sym_NULL] = ACTIONS(2805),
    [anon_sym_nullptr] = ACTIONS(2805),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2805),
    [anon_sym_decltype] = ACTIONS(2805),
    [anon_sym_virtual] = ACTIONS(2805),
    [anon_sym_alignas] = ACTIONS(2805),
    [anon_sym_explicit] = ACTIONS(2805),
    [anon_sym_typename] = ACTIONS(2805),
    [anon_sym_template] = ACTIONS(2805),
    [anon_sym_operator] = ACTIONS(2805),
    [anon_sym_try] = ACTIONS(2805),
    [anon_sym_delete] = ACTIONS(2805),
    [anon_sym_throw] = ACTIONS(2805),
    [anon_sym_namespace] = ACTIONS(2805),
    [anon_sym_using] = ACTIONS(2805),
    [anon_sym_static_assert] = ACTIONS(2805),
    [anon_sym_concept] = ACTIONS(2805),
    [anon_sym_co_return] = ACTIONS(2805),
    [anon_sym_co_yield] = ACTIONS(2805),
    [anon_sym_R_DQUOTE] = ACTIONS(2807),
    [anon_sym_LR_DQUOTE] = ACTIONS(2807),
    [anon_sym_uR_DQUOTE] = ACTIONS(2807),
    [anon_sym_UR_DQUOTE] = ACTIONS(2807),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2807),
    [anon_sym_co_await] = ACTIONS(2805),
    [anon_sym_new] = ACTIONS(2805),
    [anon_sym_requires] = ACTIONS(2805),
    [sym_this] = ACTIONS(2805),
  },
  [805] = {
    [sym_identifier] = ACTIONS(2941),
    [aux_sym_preproc_include_token1] = ACTIONS(2941),
    [aux_sym_preproc_def_token1] = ACTIONS(2941),
    [aux_sym_preproc_if_token1] = ACTIONS(2941),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2941),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2941),
    [sym_preproc_directive] = ACTIONS(2941),
    [anon_sym_LPAREN2] = ACTIONS(2943),
    [anon_sym_BANG] = ACTIONS(2943),
    [anon_sym_TILDE] = ACTIONS(2943),
    [anon_sym_DASH] = ACTIONS(2941),
    [anon_sym_PLUS] = ACTIONS(2941),
    [anon_sym_STAR] = ACTIONS(2943),
    [anon_sym_AMP_AMP] = ACTIONS(2943),
    [anon_sym_AMP] = ACTIONS(2941),
    [anon_sym_SEMI] = ACTIONS(2943),
    [anon_sym___extension__] = ACTIONS(2941),
    [anon_sym_typedef] = ACTIONS(2941),
    [anon_sym_extern] = ACTIONS(2941),
    [anon_sym___attribute__] = ACTIONS(2941),
    [anon_sym_COLON_COLON] = ACTIONS(2943),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2943),
    [anon_sym___declspec] = ACTIONS(2941),
    [anon_sym___based] = ACTIONS(2941),
    [anon_sym___cdecl] = ACTIONS(2941),
    [anon_sym___clrcall] = ACTIONS(2941),
    [anon_sym___stdcall] = ACTIONS(2941),
    [anon_sym___fastcall] = ACTIONS(2941),
    [anon_sym___thiscall] = ACTIONS(2941),
    [anon_sym___vectorcall] = ACTIONS(2941),
    [anon_sym_LBRACE] = ACTIONS(2943),
    [anon_sym_RBRACE] = ACTIONS(2943),
    [anon_sym_signed] = ACTIONS(2941),
    [anon_sym_unsigned] = ACTIONS(2941),
    [anon_sym_long] = ACTIONS(2941),
    [anon_sym_short] = ACTIONS(2941),
    [anon_sym_LBRACK] = ACTIONS(2941),
    [anon_sym_static] = ACTIONS(2941),
    [anon_sym_register] = ACTIONS(2941),
    [anon_sym_inline] = ACTIONS(2941),
    [anon_sym___inline] = ACTIONS(2941),
    [anon_sym___inline__] = ACTIONS(2941),
    [anon_sym___forceinline] = ACTIONS(2941),
    [anon_sym_thread_local] = ACTIONS(2941),
    [anon_sym___thread] = ACTIONS(2941),
    [anon_sym_const] = ACTIONS(2941),
    [anon_sym_constexpr] = ACTIONS(2941),
    [anon_sym_volatile] = ACTIONS(2941),
    [anon_sym_restrict] = ACTIONS(2941),
    [anon_sym___restrict__] = ACTIONS(2941),
    [anon_sym__Atomic] = ACTIONS(2941),
    [anon_sym__Noreturn] = ACTIONS(2941),
    [anon_sym_noreturn] = ACTIONS(2941),
    [anon_sym_mutable] = ACTIONS(2941),
    [anon_sym_constinit] = ACTIONS(2941),
    [anon_sym_consteval] = ACTIONS(2941),
    [anon_sym_PROGMEM] = ACTIONS(2941),
    [aux_sym_primitive_type_token1] = ACTIONS(2941),
    [anon_sym_byte] = ACTIONS(2941),
    [anon_sym_word] = ACTIONS(2941),
    [anon_sym_enum] = ACTIONS(2941),
    [anon_sym_class] = ACTIONS(2941),
    [anon_sym_struct] = ACTIONS(2941),
    [anon_sym_union] = ACTIONS(2941),
    [anon_sym_if] = ACTIONS(2941),
    [anon_sym_switch] = ACTIONS(2941),
    [anon_sym_case] = ACTIONS(2941),
    [anon_sym_default] = ACTIONS(2941),
    [anon_sym_while] = ACTIONS(2941),
    [anon_sym_do] = ACTIONS(2941),
    [anon_sym_for] = ACTIONS(2941),
    [anon_sym_return] = ACTIONS(2941),
    [anon_sym_break] = ACTIONS(2941),
    [anon_sym_continue] = ACTIONS(2941),
    [anon_sym_goto] = ACTIONS(2941),
    [anon_sym___try] = ACTIONS(2941),
    [anon_sym___leave] = ACTIONS(2941),
    [anon_sym_not] = ACTIONS(2941),
    [anon_sym_compl] = ACTIONS(2941),
    [anon_sym_DASH_DASH] = ACTIONS(2943),
    [anon_sym_PLUS_PLUS] = ACTIONS(2943),
    [anon_sym_sizeof] = ACTIONS(2941),
    [anon_sym___alignof__] = ACTIONS(2941),
    [anon_sym___alignof] = ACTIONS(2941),
    [anon_sym__alignof] = ACTIONS(2941),
    [anon_sym_alignof] = ACTIONS(2941),
    [anon_sym__Alignof] = ACTIONS(2941),
    [anon_sym_offsetof] = ACTIONS(2941),
    [anon_sym__Generic] = ACTIONS(2941),
    [anon_sym_asm] = ACTIONS(2941),
    [anon_sym___asm__] = ACTIONS(2941),
    [aux_sym_number_literal_token1] = ACTIONS(2943),
    [aux_sym_number_literal_token2] = ACTIONS(2941),
    [anon_sym_L_SQUOTE] = ACTIONS(2943),
    [anon_sym_u_SQUOTE] = ACTIONS(2943),
    [anon_sym_U_SQUOTE] = ACTIONS(2943),
    [anon_sym_u8_SQUOTE] = ACTIONS(2943),
    [anon_sym_SQUOTE] = ACTIONS(2943),
    [anon_sym_L_DQUOTE] = ACTIONS(2943),
    [anon_sym_u_DQUOTE] = ACTIONS(2943),
    [anon_sym_U_DQUOTE] = ACTIONS(2943),
    [anon_sym_u8_DQUOTE] = ACTIONS(2943),
    [anon_sym_DQUOTE] = ACTIONS(2943),
    [sym_true] = ACTIONS(2941),
    [sym_false] = ACTIONS(2941),
    [anon_sym_NULL] = ACTIONS(2941),
    [anon_sym_nullptr] = ACTIONS(2941),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2941),
    [anon_sym_decltype] = ACTIONS(2941),
    [anon_sym_virtual] = ACTIONS(2941),
    [anon_sym_alignas] = ACTIONS(2941),
    [anon_sym_explicit] = ACTIONS(2941),
    [anon_sym_typename] = ACTIONS(2941),
    [anon_sym_template] = ACTIONS(2941),
    [anon_sym_operator] = ACTIONS(2941),
    [anon_sym_try] = ACTIONS(2941),
    [anon_sym_delete] = ACTIONS(2941),
    [anon_sym_throw] = ACTIONS(2941),
    [anon_sym_namespace] = ACTIONS(2941),
    [anon_sym_using] = ACTIONS(2941),
    [anon_sym_static_assert] = ACTIONS(2941),
    [anon_sym_concept] = ACTIONS(2941),
    [anon_sym_co_return] = ACTIONS(2941),
    [anon_sym_co_yield] = ACTIONS(2941),
    [anon_sym_R_DQUOTE] = ACTIONS(2943),
    [anon_sym_LR_DQUOTE] = ACTIONS(2943),
    [anon_sym_uR_DQUOTE] = ACTIONS(2943),
    [anon_sym_UR_DQUOTE] = ACTIONS(2943),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2943),
    [anon_sym_co_await] = ACTIONS(2941),
    [anon_sym_new] = ACTIONS(2941),
    [anon_sym_requires] = ACTIONS(2941),
    [sym_this] = ACTIONS(2941),
  },
  [806] = {
    [sym_identifier] = ACTIONS(3105),
    [aux_sym_preproc_include_token1] = ACTIONS(3105),
    [aux_sym_preproc_def_token1] = ACTIONS(3105),
    [aux_sym_preproc_if_token1] = ACTIONS(3105),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3105),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3105),
    [sym_preproc_directive] = ACTIONS(3105),
    [anon_sym_LPAREN2] = ACTIONS(3107),
    [anon_sym_BANG] = ACTIONS(3107),
    [anon_sym_TILDE] = ACTIONS(3107),
    [anon_sym_DASH] = ACTIONS(3105),
    [anon_sym_PLUS] = ACTIONS(3105),
    [anon_sym_STAR] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3107),
    [anon_sym_AMP] = ACTIONS(3105),
    [anon_sym_SEMI] = ACTIONS(3107),
    [anon_sym___extension__] = ACTIONS(3105),
    [anon_sym_typedef] = ACTIONS(3105),
    [anon_sym_extern] = ACTIONS(3105),
    [anon_sym___attribute__] = ACTIONS(3105),
    [anon_sym_COLON_COLON] = ACTIONS(3107),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3107),
    [anon_sym___declspec] = ACTIONS(3105),
    [anon_sym___based] = ACTIONS(3105),
    [anon_sym___cdecl] = ACTIONS(3105),
    [anon_sym___clrcall] = ACTIONS(3105),
    [anon_sym___stdcall] = ACTIONS(3105),
    [anon_sym___fastcall] = ACTIONS(3105),
    [anon_sym___thiscall] = ACTIONS(3105),
    [anon_sym___vectorcall] = ACTIONS(3105),
    [anon_sym_LBRACE] = ACTIONS(3107),
    [anon_sym_RBRACE] = ACTIONS(3107),
    [anon_sym_signed] = ACTIONS(3105),
    [anon_sym_unsigned] = ACTIONS(3105),
    [anon_sym_long] = ACTIONS(3105),
    [anon_sym_short] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(3105),
    [anon_sym_static] = ACTIONS(3105),
    [anon_sym_register] = ACTIONS(3105),
    [anon_sym_inline] = ACTIONS(3105),
    [anon_sym___inline] = ACTIONS(3105),
    [anon_sym___inline__] = ACTIONS(3105),
    [anon_sym___forceinline] = ACTIONS(3105),
    [anon_sym_thread_local] = ACTIONS(3105),
    [anon_sym___thread] = ACTIONS(3105),
    [anon_sym_const] = ACTIONS(3105),
    [anon_sym_constexpr] = ACTIONS(3105),
    [anon_sym_volatile] = ACTIONS(3105),
    [anon_sym_restrict] = ACTIONS(3105),
    [anon_sym___restrict__] = ACTIONS(3105),
    [anon_sym__Atomic] = ACTIONS(3105),
    [anon_sym__Noreturn] = ACTIONS(3105),
    [anon_sym_noreturn] = ACTIONS(3105),
    [anon_sym_mutable] = ACTIONS(3105),
    [anon_sym_constinit] = ACTIONS(3105),
    [anon_sym_consteval] = ACTIONS(3105),
    [anon_sym_PROGMEM] = ACTIONS(3105),
    [aux_sym_primitive_type_token1] = ACTIONS(3105),
    [anon_sym_byte] = ACTIONS(3105),
    [anon_sym_word] = ACTIONS(3105),
    [anon_sym_enum] = ACTIONS(3105),
    [anon_sym_class] = ACTIONS(3105),
    [anon_sym_struct] = ACTIONS(3105),
    [anon_sym_union] = ACTIONS(3105),
    [anon_sym_if] = ACTIONS(3105),
    [anon_sym_switch] = ACTIONS(3105),
    [anon_sym_case] = ACTIONS(3105),
    [anon_sym_default] = ACTIONS(3105),
    [anon_sym_while] = ACTIONS(3105),
    [anon_sym_do] = ACTIONS(3105),
    [anon_sym_for] = ACTIONS(3105),
    [anon_sym_return] = ACTIONS(3105),
    [anon_sym_break] = ACTIONS(3105),
    [anon_sym_continue] = ACTIONS(3105),
    [anon_sym_goto] = ACTIONS(3105),
    [anon_sym___try] = ACTIONS(3105),
    [anon_sym___leave] = ACTIONS(3105),
    [anon_sym_not] = ACTIONS(3105),
    [anon_sym_compl] = ACTIONS(3105),
    [anon_sym_DASH_DASH] = ACTIONS(3107),
    [anon_sym_PLUS_PLUS] = ACTIONS(3107),
    [anon_sym_sizeof] = ACTIONS(3105),
    [anon_sym___alignof__] = ACTIONS(3105),
    [anon_sym___alignof] = ACTIONS(3105),
    [anon_sym__alignof] = ACTIONS(3105),
    [anon_sym_alignof] = ACTIONS(3105),
    [anon_sym__Alignof] = ACTIONS(3105),
    [anon_sym_offsetof] = ACTIONS(3105),
    [anon_sym__Generic] = ACTIONS(3105),
    [anon_sym_asm] = ACTIONS(3105),
    [anon_sym___asm__] = ACTIONS(3105),
    [aux_sym_number_literal_token1] = ACTIONS(3107),
    [aux_sym_number_literal_token2] = ACTIONS(3105),
    [anon_sym_L_SQUOTE] = ACTIONS(3107),
    [anon_sym_u_SQUOTE] = ACTIONS(3107),
    [anon_sym_U_SQUOTE] = ACTIONS(3107),
    [anon_sym_u8_SQUOTE] = ACTIONS(3107),
    [anon_sym_SQUOTE] = ACTIONS(3107),
    [anon_sym_L_DQUOTE] = ACTIONS(3107),
    [anon_sym_u_DQUOTE] = ACTIONS(3107),
    [anon_sym_U_DQUOTE] = ACTIONS(3107),
    [anon_sym_u8_DQUOTE] = ACTIONS(3107),
    [anon_sym_DQUOTE] = ACTIONS(3107),
    [sym_true] = ACTIONS(3105),
    [sym_false] = ACTIONS(3105),
    [anon_sym_NULL] = ACTIONS(3105),
    [anon_sym_nullptr] = ACTIONS(3105),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3105),
    [anon_sym_decltype] = ACTIONS(3105),
    [anon_sym_virtual] = ACTIONS(3105),
    [anon_sym_alignas] = ACTIONS(3105),
    [anon_sym_explicit] = ACTIONS(3105),
    [anon_sym_typename] = ACTIONS(3105),
    [anon_sym_template] = ACTIONS(3105),
    [anon_sym_operator] = ACTIONS(3105),
    [anon_sym_try] = ACTIONS(3105),
    [anon_sym_delete] = ACTIONS(3105),
    [anon_sym_throw] = ACTIONS(3105),
    [anon_sym_namespace] = ACTIONS(3105),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_static_assert] = ACTIONS(3105),
    [anon_sym_concept] = ACTIONS(3105),
    [anon_sym_co_return] = ACTIONS(3105),
    [anon_sym_co_yield] = ACTIONS(3105),
    [anon_sym_R_DQUOTE] = ACTIONS(3107),
    [anon_sym_LR_DQUOTE] = ACTIONS(3107),
    [anon_sym_uR_DQUOTE] = ACTIONS(3107),
    [anon_sym_UR_DQUOTE] = ACTIONS(3107),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3107),
    [anon_sym_co_await] = ACTIONS(3105),
    [anon_sym_new] = ACTIONS(3105),
    [anon_sym_requires] = ACTIONS(3105),
    [sym_this] = ACTIONS(3105),
  },
  [807] = {
    [sym_identifier] = ACTIONS(3122),
    [aux_sym_preproc_include_token1] = ACTIONS(3122),
    [aux_sym_preproc_def_token1] = ACTIONS(3122),
    [aux_sym_preproc_if_token1] = ACTIONS(3122),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3122),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3122),
    [sym_preproc_directive] = ACTIONS(3122),
    [anon_sym_LPAREN2] = ACTIONS(3124),
    [anon_sym_BANG] = ACTIONS(3124),
    [anon_sym_TILDE] = ACTIONS(3124),
    [anon_sym_DASH] = ACTIONS(3122),
    [anon_sym_PLUS] = ACTIONS(3122),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP_AMP] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3122),
    [anon_sym_SEMI] = ACTIONS(3124),
    [anon_sym___extension__] = ACTIONS(3122),
    [anon_sym_typedef] = ACTIONS(3122),
    [anon_sym_extern] = ACTIONS(3122),
    [anon_sym___attribute__] = ACTIONS(3122),
    [anon_sym_COLON_COLON] = ACTIONS(3124),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3124),
    [anon_sym___declspec] = ACTIONS(3122),
    [anon_sym___based] = ACTIONS(3122),
    [anon_sym___cdecl] = ACTIONS(3122),
    [anon_sym___clrcall] = ACTIONS(3122),
    [anon_sym___stdcall] = ACTIONS(3122),
    [anon_sym___fastcall] = ACTIONS(3122),
    [anon_sym___thiscall] = ACTIONS(3122),
    [anon_sym___vectorcall] = ACTIONS(3122),
    [anon_sym_LBRACE] = ACTIONS(3124),
    [anon_sym_RBRACE] = ACTIONS(3124),
    [anon_sym_signed] = ACTIONS(3122),
    [anon_sym_unsigned] = ACTIONS(3122),
    [anon_sym_long] = ACTIONS(3122),
    [anon_sym_short] = ACTIONS(3122),
    [anon_sym_LBRACK] = ACTIONS(3122),
    [anon_sym_static] = ACTIONS(3122),
    [anon_sym_register] = ACTIONS(3122),
    [anon_sym_inline] = ACTIONS(3122),
    [anon_sym___inline] = ACTIONS(3122),
    [anon_sym___inline__] = ACTIONS(3122),
    [anon_sym___forceinline] = ACTIONS(3122),
    [anon_sym_thread_local] = ACTIONS(3122),
    [anon_sym___thread] = ACTIONS(3122),
    [anon_sym_const] = ACTIONS(3122),
    [anon_sym_constexpr] = ACTIONS(3122),
    [anon_sym_volatile] = ACTIONS(3122),
    [anon_sym_restrict] = ACTIONS(3122),
    [anon_sym___restrict__] = ACTIONS(3122),
    [anon_sym__Atomic] = ACTIONS(3122),
    [anon_sym__Noreturn] = ACTIONS(3122),
    [anon_sym_noreturn] = ACTIONS(3122),
    [anon_sym_mutable] = ACTIONS(3122),
    [anon_sym_constinit] = ACTIONS(3122),
    [anon_sym_consteval] = ACTIONS(3122),
    [anon_sym_PROGMEM] = ACTIONS(3122),
    [aux_sym_primitive_type_token1] = ACTIONS(3122),
    [anon_sym_byte] = ACTIONS(3122),
    [anon_sym_word] = ACTIONS(3122),
    [anon_sym_enum] = ACTIONS(3122),
    [anon_sym_class] = ACTIONS(3122),
    [anon_sym_struct] = ACTIONS(3122),
    [anon_sym_union] = ACTIONS(3122),
    [anon_sym_if] = ACTIONS(3122),
    [anon_sym_switch] = ACTIONS(3122),
    [anon_sym_case] = ACTIONS(3122),
    [anon_sym_default] = ACTIONS(3122),
    [anon_sym_while] = ACTIONS(3122),
    [anon_sym_do] = ACTIONS(3122),
    [anon_sym_for] = ACTIONS(3122),
    [anon_sym_return] = ACTIONS(3122),
    [anon_sym_break] = ACTIONS(3122),
    [anon_sym_continue] = ACTIONS(3122),
    [anon_sym_goto] = ACTIONS(3122),
    [anon_sym___try] = ACTIONS(3122),
    [anon_sym___leave] = ACTIONS(3122),
    [anon_sym_not] = ACTIONS(3122),
    [anon_sym_compl] = ACTIONS(3122),
    [anon_sym_DASH_DASH] = ACTIONS(3124),
    [anon_sym_PLUS_PLUS] = ACTIONS(3124),
    [anon_sym_sizeof] = ACTIONS(3122),
    [anon_sym___alignof__] = ACTIONS(3122),
    [anon_sym___alignof] = ACTIONS(3122),
    [anon_sym__alignof] = ACTIONS(3122),
    [anon_sym_alignof] = ACTIONS(3122),
    [anon_sym__Alignof] = ACTIONS(3122),
    [anon_sym_offsetof] = ACTIONS(3122),
    [anon_sym__Generic] = ACTIONS(3122),
    [anon_sym_asm] = ACTIONS(3122),
    [anon_sym___asm__] = ACTIONS(3122),
    [aux_sym_number_literal_token1] = ACTIONS(3124),
    [aux_sym_number_literal_token2] = ACTIONS(3122),
    [anon_sym_L_SQUOTE] = ACTIONS(3124),
    [anon_sym_u_SQUOTE] = ACTIONS(3124),
    [anon_sym_U_SQUOTE] = ACTIONS(3124),
    [anon_sym_u8_SQUOTE] = ACTIONS(3124),
    [anon_sym_SQUOTE] = ACTIONS(3124),
    [anon_sym_L_DQUOTE] = ACTIONS(3124),
    [anon_sym_u_DQUOTE] = ACTIONS(3124),
    [anon_sym_U_DQUOTE] = ACTIONS(3124),
    [anon_sym_u8_DQUOTE] = ACTIONS(3124),
    [anon_sym_DQUOTE] = ACTIONS(3124),
    [sym_true] = ACTIONS(3122),
    [sym_false] = ACTIONS(3122),
    [anon_sym_NULL] = ACTIONS(3122),
    [anon_sym_nullptr] = ACTIONS(3122),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3122),
    [anon_sym_decltype] = ACTIONS(3122),
    [anon_sym_virtual] = ACTIONS(3122),
    [anon_sym_alignas] = ACTIONS(3122),
    [anon_sym_explicit] = ACTIONS(3122),
    [anon_sym_typename] = ACTIONS(3122),
    [anon_sym_template] = ACTIONS(3122),
    [anon_sym_operator] = ACTIONS(3122),
    [anon_sym_try] = ACTIONS(3122),
    [anon_sym_delete] = ACTIONS(3122),
    [anon_sym_throw] = ACTIONS(3122),
    [anon_sym_namespace] = ACTIONS(3122),
    [anon_sym_using] = ACTIONS(3122),
    [anon_sym_static_assert] = ACTIONS(3122),
    [anon_sym_concept] = ACTIONS(3122),
    [anon_sym_co_return] = ACTIONS(3122),
    [anon_sym_co_yield] = ACTIONS(3122),
    [anon_sym_R_DQUOTE] = ACTIONS(3124),
    [anon_sym_LR_DQUOTE] = ACTIONS(3124),
    [anon_sym_uR_DQUOTE] = ACTIONS(3124),
    [anon_sym_UR_DQUOTE] = ACTIONS(3124),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3124),
    [anon_sym_co_await] = ACTIONS(3122),
    [anon_sym_new] = ACTIONS(3122),
    [anon_sym_requires] = ACTIONS(3122),
    [sym_this] = ACTIONS(3122),
  },
  [808] = {
    [sym_identifier] = ACTIONS(3132),
    [aux_sym_preproc_include_token1] = ACTIONS(3132),
    [aux_sym_preproc_def_token1] = ACTIONS(3132),
    [aux_sym_preproc_if_token1] = ACTIONS(3132),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3132),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3132),
    [sym_preproc_directive] = ACTIONS(3132),
    [anon_sym_LPAREN2] = ACTIONS(3134),
    [anon_sym_BANG] = ACTIONS(3134),
    [anon_sym_TILDE] = ACTIONS(3134),
    [anon_sym_DASH] = ACTIONS(3132),
    [anon_sym_PLUS] = ACTIONS(3132),
    [anon_sym_STAR] = ACTIONS(3134),
    [anon_sym_AMP_AMP] = ACTIONS(3134),
    [anon_sym_AMP] = ACTIONS(3132),
    [anon_sym_SEMI] = ACTIONS(3134),
    [anon_sym___extension__] = ACTIONS(3132),
    [anon_sym_typedef] = ACTIONS(3132),
    [anon_sym_extern] = ACTIONS(3132),
    [anon_sym___attribute__] = ACTIONS(3132),
    [anon_sym_COLON_COLON] = ACTIONS(3134),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3134),
    [anon_sym___declspec] = ACTIONS(3132),
    [anon_sym___based] = ACTIONS(3132),
    [anon_sym___cdecl] = ACTIONS(3132),
    [anon_sym___clrcall] = ACTIONS(3132),
    [anon_sym___stdcall] = ACTIONS(3132),
    [anon_sym___fastcall] = ACTIONS(3132),
    [anon_sym___thiscall] = ACTIONS(3132),
    [anon_sym___vectorcall] = ACTIONS(3132),
    [anon_sym_LBRACE] = ACTIONS(3134),
    [anon_sym_RBRACE] = ACTIONS(3134),
    [anon_sym_signed] = ACTIONS(3132),
    [anon_sym_unsigned] = ACTIONS(3132),
    [anon_sym_long] = ACTIONS(3132),
    [anon_sym_short] = ACTIONS(3132),
    [anon_sym_LBRACK] = ACTIONS(3132),
    [anon_sym_static] = ACTIONS(3132),
    [anon_sym_register] = ACTIONS(3132),
    [anon_sym_inline] = ACTIONS(3132),
    [anon_sym___inline] = ACTIONS(3132),
    [anon_sym___inline__] = ACTIONS(3132),
    [anon_sym___forceinline] = ACTIONS(3132),
    [anon_sym_thread_local] = ACTIONS(3132),
    [anon_sym___thread] = ACTIONS(3132),
    [anon_sym_const] = ACTIONS(3132),
    [anon_sym_constexpr] = ACTIONS(3132),
    [anon_sym_volatile] = ACTIONS(3132),
    [anon_sym_restrict] = ACTIONS(3132),
    [anon_sym___restrict__] = ACTIONS(3132),
    [anon_sym__Atomic] = ACTIONS(3132),
    [anon_sym__Noreturn] = ACTIONS(3132),
    [anon_sym_noreturn] = ACTIONS(3132),
    [anon_sym_mutable] = ACTIONS(3132),
    [anon_sym_constinit] = ACTIONS(3132),
    [anon_sym_consteval] = ACTIONS(3132),
    [anon_sym_PROGMEM] = ACTIONS(3132),
    [aux_sym_primitive_type_token1] = ACTIONS(3132),
    [anon_sym_byte] = ACTIONS(3132),
    [anon_sym_word] = ACTIONS(3132),
    [anon_sym_enum] = ACTIONS(3132),
    [anon_sym_class] = ACTIONS(3132),
    [anon_sym_struct] = ACTIONS(3132),
    [anon_sym_union] = ACTIONS(3132),
    [anon_sym_if] = ACTIONS(3132),
    [anon_sym_switch] = ACTIONS(3132),
    [anon_sym_case] = ACTIONS(3132),
    [anon_sym_default] = ACTIONS(3132),
    [anon_sym_while] = ACTIONS(3132),
    [anon_sym_do] = ACTIONS(3132),
    [anon_sym_for] = ACTIONS(3132),
    [anon_sym_return] = ACTIONS(3132),
    [anon_sym_break] = ACTIONS(3132),
    [anon_sym_continue] = ACTIONS(3132),
    [anon_sym_goto] = ACTIONS(3132),
    [anon_sym___try] = ACTIONS(3132),
    [anon_sym___leave] = ACTIONS(3132),
    [anon_sym_not] = ACTIONS(3132),
    [anon_sym_compl] = ACTIONS(3132),
    [anon_sym_DASH_DASH] = ACTIONS(3134),
    [anon_sym_PLUS_PLUS] = ACTIONS(3134),
    [anon_sym_sizeof] = ACTIONS(3132),
    [anon_sym___alignof__] = ACTIONS(3132),
    [anon_sym___alignof] = ACTIONS(3132),
    [anon_sym__alignof] = ACTIONS(3132),
    [anon_sym_alignof] = ACTIONS(3132),
    [anon_sym__Alignof] = ACTIONS(3132),
    [anon_sym_offsetof] = ACTIONS(3132),
    [anon_sym__Generic] = ACTIONS(3132),
    [anon_sym_asm] = ACTIONS(3132),
    [anon_sym___asm__] = ACTIONS(3132),
    [aux_sym_number_literal_token1] = ACTIONS(3134),
    [aux_sym_number_literal_token2] = ACTIONS(3132),
    [anon_sym_L_SQUOTE] = ACTIONS(3134),
    [anon_sym_u_SQUOTE] = ACTIONS(3134),
    [anon_sym_U_SQUOTE] = ACTIONS(3134),
    [anon_sym_u8_SQUOTE] = ACTIONS(3134),
    [anon_sym_SQUOTE] = ACTIONS(3134),
    [anon_sym_L_DQUOTE] = ACTIONS(3134),
    [anon_sym_u_DQUOTE] = ACTIONS(3134),
    [anon_sym_U_DQUOTE] = ACTIONS(3134),
    [anon_sym_u8_DQUOTE] = ACTIONS(3134),
    [anon_sym_DQUOTE] = ACTIONS(3134),
    [sym_true] = ACTIONS(3132),
    [sym_false] = ACTIONS(3132),
    [anon_sym_NULL] = ACTIONS(3132),
    [anon_sym_nullptr] = ACTIONS(3132),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3132),
    [anon_sym_decltype] = ACTIONS(3132),
    [anon_sym_virtual] = ACTIONS(3132),
    [anon_sym_alignas] = ACTIONS(3132),
    [anon_sym_explicit] = ACTIONS(3132),
    [anon_sym_typename] = ACTIONS(3132),
    [anon_sym_template] = ACTIONS(3132),
    [anon_sym_operator] = ACTIONS(3132),
    [anon_sym_try] = ACTIONS(3132),
    [anon_sym_delete] = ACTIONS(3132),
    [anon_sym_throw] = ACTIONS(3132),
    [anon_sym_namespace] = ACTIONS(3132),
    [anon_sym_using] = ACTIONS(3132),
    [anon_sym_static_assert] = ACTIONS(3132),
    [anon_sym_concept] = ACTIONS(3132),
    [anon_sym_co_return] = ACTIONS(3132),
    [anon_sym_co_yield] = ACTIONS(3132),
    [anon_sym_R_DQUOTE] = ACTIONS(3134),
    [anon_sym_LR_DQUOTE] = ACTIONS(3134),
    [anon_sym_uR_DQUOTE] = ACTIONS(3134),
    [anon_sym_UR_DQUOTE] = ACTIONS(3134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3134),
    [anon_sym_co_await] = ACTIONS(3132),
    [anon_sym_new] = ACTIONS(3132),
    [anon_sym_requires] = ACTIONS(3132),
    [sym_this] = ACTIONS(3132),
  },
  [809] = {
    [sym_identifier] = ACTIONS(3126),
    [aux_sym_preproc_include_token1] = ACTIONS(3126),
    [aux_sym_preproc_def_token1] = ACTIONS(3126),
    [aux_sym_preproc_if_token1] = ACTIONS(3126),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3126),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3126),
    [sym_preproc_directive] = ACTIONS(3126),
    [anon_sym_LPAREN2] = ACTIONS(3128),
    [anon_sym_BANG] = ACTIONS(3128),
    [anon_sym_TILDE] = ACTIONS(3128),
    [anon_sym_DASH] = ACTIONS(3126),
    [anon_sym_PLUS] = ACTIONS(3126),
    [anon_sym_STAR] = ACTIONS(3128),
    [anon_sym_AMP_AMP] = ACTIONS(3128),
    [anon_sym_AMP] = ACTIONS(3126),
    [anon_sym_SEMI] = ACTIONS(3128),
    [anon_sym___extension__] = ACTIONS(3126),
    [anon_sym_typedef] = ACTIONS(3126),
    [anon_sym_extern] = ACTIONS(3126),
    [anon_sym___attribute__] = ACTIONS(3126),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3128),
    [anon_sym___declspec] = ACTIONS(3126),
    [anon_sym___based] = ACTIONS(3126),
    [anon_sym___cdecl] = ACTIONS(3126),
    [anon_sym___clrcall] = ACTIONS(3126),
    [anon_sym___stdcall] = ACTIONS(3126),
    [anon_sym___fastcall] = ACTIONS(3126),
    [anon_sym___thiscall] = ACTIONS(3126),
    [anon_sym___vectorcall] = ACTIONS(3126),
    [anon_sym_LBRACE] = ACTIONS(3128),
    [anon_sym_RBRACE] = ACTIONS(3128),
    [anon_sym_signed] = ACTIONS(3126),
    [anon_sym_unsigned] = ACTIONS(3126),
    [anon_sym_long] = ACTIONS(3126),
    [anon_sym_short] = ACTIONS(3126),
    [anon_sym_LBRACK] = ACTIONS(3126),
    [anon_sym_static] = ACTIONS(3126),
    [anon_sym_register] = ACTIONS(3126),
    [anon_sym_inline] = ACTIONS(3126),
    [anon_sym___inline] = ACTIONS(3126),
    [anon_sym___inline__] = ACTIONS(3126),
    [anon_sym___forceinline] = ACTIONS(3126),
    [anon_sym_thread_local] = ACTIONS(3126),
    [anon_sym___thread] = ACTIONS(3126),
    [anon_sym_const] = ACTIONS(3126),
    [anon_sym_constexpr] = ACTIONS(3126),
    [anon_sym_volatile] = ACTIONS(3126),
    [anon_sym_restrict] = ACTIONS(3126),
    [anon_sym___restrict__] = ACTIONS(3126),
    [anon_sym__Atomic] = ACTIONS(3126),
    [anon_sym__Noreturn] = ACTIONS(3126),
    [anon_sym_noreturn] = ACTIONS(3126),
    [anon_sym_mutable] = ACTIONS(3126),
    [anon_sym_constinit] = ACTIONS(3126),
    [anon_sym_consteval] = ACTIONS(3126),
    [anon_sym_PROGMEM] = ACTIONS(3126),
    [aux_sym_primitive_type_token1] = ACTIONS(3126),
    [anon_sym_byte] = ACTIONS(3126),
    [anon_sym_word] = ACTIONS(3126),
    [anon_sym_enum] = ACTIONS(3126),
    [anon_sym_class] = ACTIONS(3126),
    [anon_sym_struct] = ACTIONS(3126),
    [anon_sym_union] = ACTIONS(3126),
    [anon_sym_if] = ACTIONS(3126),
    [anon_sym_switch] = ACTIONS(3126),
    [anon_sym_case] = ACTIONS(3126),
    [anon_sym_default] = ACTIONS(3126),
    [anon_sym_while] = ACTIONS(3126),
    [anon_sym_do] = ACTIONS(3126),
    [anon_sym_for] = ACTIONS(3126),
    [anon_sym_return] = ACTIONS(3126),
    [anon_sym_break] = ACTIONS(3126),
    [anon_sym_continue] = ACTIONS(3126),
    [anon_sym_goto] = ACTIONS(3126),
    [anon_sym___try] = ACTIONS(3126),
    [anon_sym___leave] = ACTIONS(3126),
    [anon_sym_not] = ACTIONS(3126),
    [anon_sym_compl] = ACTIONS(3126),
    [anon_sym_DASH_DASH] = ACTIONS(3128),
    [anon_sym_PLUS_PLUS] = ACTIONS(3128),
    [anon_sym_sizeof] = ACTIONS(3126),
    [anon_sym___alignof__] = ACTIONS(3126),
    [anon_sym___alignof] = ACTIONS(3126),
    [anon_sym__alignof] = ACTIONS(3126),
    [anon_sym_alignof] = ACTIONS(3126),
    [anon_sym__Alignof] = ACTIONS(3126),
    [anon_sym_offsetof] = ACTIONS(3126),
    [anon_sym__Generic] = ACTIONS(3126),
    [anon_sym_asm] = ACTIONS(3126),
    [anon_sym___asm__] = ACTIONS(3126),
    [aux_sym_number_literal_token1] = ACTIONS(3128),
    [aux_sym_number_literal_token2] = ACTIONS(3126),
    [anon_sym_L_SQUOTE] = ACTIONS(3128),
    [anon_sym_u_SQUOTE] = ACTIONS(3128),
    [anon_sym_U_SQUOTE] = ACTIONS(3128),
    [anon_sym_u8_SQUOTE] = ACTIONS(3128),
    [anon_sym_SQUOTE] = ACTIONS(3128),
    [anon_sym_L_DQUOTE] = ACTIONS(3128),
    [anon_sym_u_DQUOTE] = ACTIONS(3128),
    [anon_sym_U_DQUOTE] = ACTIONS(3128),
    [anon_sym_u8_DQUOTE] = ACTIONS(3128),
    [anon_sym_DQUOTE] = ACTIONS(3128),
    [sym_true] = ACTIONS(3126),
    [sym_false] = ACTIONS(3126),
    [anon_sym_NULL] = ACTIONS(3126),
    [anon_sym_nullptr] = ACTIONS(3126),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3126),
    [anon_sym_decltype] = ACTIONS(3126),
    [anon_sym_virtual] = ACTIONS(3126),
    [anon_sym_alignas] = ACTIONS(3126),
    [anon_sym_explicit] = ACTIONS(3126),
    [anon_sym_typename] = ACTIONS(3126),
    [anon_sym_template] = ACTIONS(3126),
    [anon_sym_operator] = ACTIONS(3126),
    [anon_sym_try] = ACTIONS(3126),
    [anon_sym_delete] = ACTIONS(3126),
    [anon_sym_throw] = ACTIONS(3126),
    [anon_sym_namespace] = ACTIONS(3126),
    [anon_sym_using] = ACTIONS(3126),
    [anon_sym_static_assert] = ACTIONS(3126),
    [anon_sym_concept] = ACTIONS(3126),
    [anon_sym_co_return] = ACTIONS(3126),
    [anon_sym_co_yield] = ACTIONS(3126),
    [anon_sym_R_DQUOTE] = ACTIONS(3128),
    [anon_sym_LR_DQUOTE] = ACTIONS(3128),
    [anon_sym_uR_DQUOTE] = ACTIONS(3128),
    [anon_sym_UR_DQUOTE] = ACTIONS(3128),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3128),
    [anon_sym_co_await] = ACTIONS(3126),
    [anon_sym_new] = ACTIONS(3126),
    [anon_sym_requires] = ACTIONS(3126),
    [sym_this] = ACTIONS(3126),
  },
  [810] = {
    [sym_identifier] = ACTIONS(3126),
    [aux_sym_preproc_include_token1] = ACTIONS(3126),
    [aux_sym_preproc_def_token1] = ACTIONS(3126),
    [aux_sym_preproc_if_token1] = ACTIONS(3126),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3126),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3126),
    [sym_preproc_directive] = ACTIONS(3126),
    [anon_sym_LPAREN2] = ACTIONS(3128),
    [anon_sym_BANG] = ACTIONS(3128),
    [anon_sym_TILDE] = ACTIONS(3128),
    [anon_sym_DASH] = ACTIONS(3126),
    [anon_sym_PLUS] = ACTIONS(3126),
    [anon_sym_STAR] = ACTIONS(3128),
    [anon_sym_AMP_AMP] = ACTIONS(3128),
    [anon_sym_AMP] = ACTIONS(3126),
    [anon_sym_SEMI] = ACTIONS(3128),
    [anon_sym___extension__] = ACTIONS(3126),
    [anon_sym_typedef] = ACTIONS(3126),
    [anon_sym_extern] = ACTIONS(3126),
    [anon_sym___attribute__] = ACTIONS(3126),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3128),
    [anon_sym___declspec] = ACTIONS(3126),
    [anon_sym___based] = ACTIONS(3126),
    [anon_sym___cdecl] = ACTIONS(3126),
    [anon_sym___clrcall] = ACTIONS(3126),
    [anon_sym___stdcall] = ACTIONS(3126),
    [anon_sym___fastcall] = ACTIONS(3126),
    [anon_sym___thiscall] = ACTIONS(3126),
    [anon_sym___vectorcall] = ACTIONS(3126),
    [anon_sym_LBRACE] = ACTIONS(3128),
    [anon_sym_RBRACE] = ACTIONS(3128),
    [anon_sym_signed] = ACTIONS(3126),
    [anon_sym_unsigned] = ACTIONS(3126),
    [anon_sym_long] = ACTIONS(3126),
    [anon_sym_short] = ACTIONS(3126),
    [anon_sym_LBRACK] = ACTIONS(3126),
    [anon_sym_static] = ACTIONS(3126),
    [anon_sym_register] = ACTIONS(3126),
    [anon_sym_inline] = ACTIONS(3126),
    [anon_sym___inline] = ACTIONS(3126),
    [anon_sym___inline__] = ACTIONS(3126),
    [anon_sym___forceinline] = ACTIONS(3126),
    [anon_sym_thread_local] = ACTIONS(3126),
    [anon_sym___thread] = ACTIONS(3126),
    [anon_sym_const] = ACTIONS(3126),
    [anon_sym_constexpr] = ACTIONS(3126),
    [anon_sym_volatile] = ACTIONS(3126),
    [anon_sym_restrict] = ACTIONS(3126),
    [anon_sym___restrict__] = ACTIONS(3126),
    [anon_sym__Atomic] = ACTIONS(3126),
    [anon_sym__Noreturn] = ACTIONS(3126),
    [anon_sym_noreturn] = ACTIONS(3126),
    [anon_sym_mutable] = ACTIONS(3126),
    [anon_sym_constinit] = ACTIONS(3126),
    [anon_sym_consteval] = ACTIONS(3126),
    [anon_sym_PROGMEM] = ACTIONS(3126),
    [aux_sym_primitive_type_token1] = ACTIONS(3126),
    [anon_sym_byte] = ACTIONS(3126),
    [anon_sym_word] = ACTIONS(3126),
    [anon_sym_enum] = ACTIONS(3126),
    [anon_sym_class] = ACTIONS(3126),
    [anon_sym_struct] = ACTIONS(3126),
    [anon_sym_union] = ACTIONS(3126),
    [anon_sym_if] = ACTIONS(3126),
    [anon_sym_switch] = ACTIONS(3126),
    [anon_sym_case] = ACTIONS(3126),
    [anon_sym_default] = ACTIONS(3126),
    [anon_sym_while] = ACTIONS(3126),
    [anon_sym_do] = ACTIONS(3126),
    [anon_sym_for] = ACTIONS(3126),
    [anon_sym_return] = ACTIONS(3126),
    [anon_sym_break] = ACTIONS(3126),
    [anon_sym_continue] = ACTIONS(3126),
    [anon_sym_goto] = ACTIONS(3126),
    [anon_sym___try] = ACTIONS(3126),
    [anon_sym___leave] = ACTIONS(3126),
    [anon_sym_not] = ACTIONS(3126),
    [anon_sym_compl] = ACTIONS(3126),
    [anon_sym_DASH_DASH] = ACTIONS(3128),
    [anon_sym_PLUS_PLUS] = ACTIONS(3128),
    [anon_sym_sizeof] = ACTIONS(3126),
    [anon_sym___alignof__] = ACTIONS(3126),
    [anon_sym___alignof] = ACTIONS(3126),
    [anon_sym__alignof] = ACTIONS(3126),
    [anon_sym_alignof] = ACTIONS(3126),
    [anon_sym__Alignof] = ACTIONS(3126),
    [anon_sym_offsetof] = ACTIONS(3126),
    [anon_sym__Generic] = ACTIONS(3126),
    [anon_sym_asm] = ACTIONS(3126),
    [anon_sym___asm__] = ACTIONS(3126),
    [aux_sym_number_literal_token1] = ACTIONS(3128),
    [aux_sym_number_literal_token2] = ACTIONS(3126),
    [anon_sym_L_SQUOTE] = ACTIONS(3128),
    [anon_sym_u_SQUOTE] = ACTIONS(3128),
    [anon_sym_U_SQUOTE] = ACTIONS(3128),
    [anon_sym_u8_SQUOTE] = ACTIONS(3128),
    [anon_sym_SQUOTE] = ACTIONS(3128),
    [anon_sym_L_DQUOTE] = ACTIONS(3128),
    [anon_sym_u_DQUOTE] = ACTIONS(3128),
    [anon_sym_U_DQUOTE] = ACTIONS(3128),
    [anon_sym_u8_DQUOTE] = ACTIONS(3128),
    [anon_sym_DQUOTE] = ACTIONS(3128),
    [sym_true] = ACTIONS(3126),
    [sym_false] = ACTIONS(3126),
    [anon_sym_NULL] = ACTIONS(3126),
    [anon_sym_nullptr] = ACTIONS(3126),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3126),
    [anon_sym_decltype] = ACTIONS(3126),
    [anon_sym_virtual] = ACTIONS(3126),
    [anon_sym_alignas] = ACTIONS(3126),
    [anon_sym_explicit] = ACTIONS(3126),
    [anon_sym_typename] = ACTIONS(3126),
    [anon_sym_template] = ACTIONS(3126),
    [anon_sym_operator] = ACTIONS(3126),
    [anon_sym_try] = ACTIONS(3126),
    [anon_sym_delete] = ACTIONS(3126),
    [anon_sym_throw] = ACTIONS(3126),
    [anon_sym_namespace] = ACTIONS(3126),
    [anon_sym_using] = ACTIONS(3126),
    [anon_sym_static_assert] = ACTIONS(3126),
    [anon_sym_concept] = ACTIONS(3126),
    [anon_sym_co_return] = ACTIONS(3126),
    [anon_sym_co_yield] = ACTIONS(3126),
    [anon_sym_R_DQUOTE] = ACTIONS(3128),
    [anon_sym_LR_DQUOTE] = ACTIONS(3128),
    [anon_sym_uR_DQUOTE] = ACTIONS(3128),
    [anon_sym_UR_DQUOTE] = ACTIONS(3128),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3128),
    [anon_sym_co_await] = ACTIONS(3126),
    [anon_sym_new] = ACTIONS(3126),
    [anon_sym_requires] = ACTIONS(3126),
    [sym_this] = ACTIONS(3126),
  },
  [811] = {
    [sym_identifier] = ACTIONS(3012),
    [aux_sym_preproc_include_token1] = ACTIONS(3012),
    [aux_sym_preproc_def_token1] = ACTIONS(3012),
    [aux_sym_preproc_if_token1] = ACTIONS(3012),
    [aux_sym_preproc_if_token2] = ACTIONS(3012),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3012),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3012),
    [sym_preproc_directive] = ACTIONS(3012),
    [anon_sym_LPAREN2] = ACTIONS(3014),
    [anon_sym_BANG] = ACTIONS(3014),
    [anon_sym_TILDE] = ACTIONS(3014),
    [anon_sym_DASH] = ACTIONS(3012),
    [anon_sym_PLUS] = ACTIONS(3012),
    [anon_sym_STAR] = ACTIONS(3014),
    [anon_sym_AMP_AMP] = ACTIONS(3014),
    [anon_sym_AMP] = ACTIONS(3012),
    [anon_sym_SEMI] = ACTIONS(3014),
    [anon_sym___extension__] = ACTIONS(3012),
    [anon_sym_typedef] = ACTIONS(3012),
    [anon_sym_extern] = ACTIONS(3012),
    [anon_sym___attribute__] = ACTIONS(3012),
    [anon_sym_COLON_COLON] = ACTIONS(3014),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3014),
    [anon_sym___declspec] = ACTIONS(3012),
    [anon_sym___based] = ACTIONS(3012),
    [anon_sym___cdecl] = ACTIONS(3012),
    [anon_sym___clrcall] = ACTIONS(3012),
    [anon_sym___stdcall] = ACTIONS(3012),
    [anon_sym___fastcall] = ACTIONS(3012),
    [anon_sym___thiscall] = ACTIONS(3012),
    [anon_sym___vectorcall] = ACTIONS(3012),
    [anon_sym_LBRACE] = ACTIONS(3014),
    [anon_sym_signed] = ACTIONS(3012),
    [anon_sym_unsigned] = ACTIONS(3012),
    [anon_sym_long] = ACTIONS(3012),
    [anon_sym_short] = ACTIONS(3012),
    [anon_sym_LBRACK] = ACTIONS(3012),
    [anon_sym_static] = ACTIONS(3012),
    [anon_sym_register] = ACTIONS(3012),
    [anon_sym_inline] = ACTIONS(3012),
    [anon_sym___inline] = ACTIONS(3012),
    [anon_sym___inline__] = ACTIONS(3012),
    [anon_sym___forceinline] = ACTIONS(3012),
    [anon_sym_thread_local] = ACTIONS(3012),
    [anon_sym___thread] = ACTIONS(3012),
    [anon_sym_const] = ACTIONS(3012),
    [anon_sym_constexpr] = ACTIONS(3012),
    [anon_sym_volatile] = ACTIONS(3012),
    [anon_sym_restrict] = ACTIONS(3012),
    [anon_sym___restrict__] = ACTIONS(3012),
    [anon_sym__Atomic] = ACTIONS(3012),
    [anon_sym__Noreturn] = ACTIONS(3012),
    [anon_sym_noreturn] = ACTIONS(3012),
    [anon_sym_mutable] = ACTIONS(3012),
    [anon_sym_constinit] = ACTIONS(3012),
    [anon_sym_consteval] = ACTIONS(3012),
    [anon_sym_PROGMEM] = ACTIONS(3012),
    [aux_sym_primitive_type_token1] = ACTIONS(3012),
    [anon_sym_byte] = ACTIONS(3012),
    [anon_sym_word] = ACTIONS(3012),
    [anon_sym_enum] = ACTIONS(3012),
    [anon_sym_class] = ACTIONS(3012),
    [anon_sym_struct] = ACTIONS(3012),
    [anon_sym_union] = ACTIONS(3012),
    [anon_sym_if] = ACTIONS(3012),
    [anon_sym_switch] = ACTIONS(3012),
    [anon_sym_case] = ACTIONS(3012),
    [anon_sym_default] = ACTIONS(3012),
    [anon_sym_while] = ACTIONS(3012),
    [anon_sym_do] = ACTIONS(3012),
    [anon_sym_for] = ACTIONS(3012),
    [anon_sym_return] = ACTIONS(3012),
    [anon_sym_break] = ACTIONS(3012),
    [anon_sym_continue] = ACTIONS(3012),
    [anon_sym_goto] = ACTIONS(3012),
    [anon_sym___try] = ACTIONS(3012),
    [anon_sym___leave] = ACTIONS(3012),
    [anon_sym_not] = ACTIONS(3012),
    [anon_sym_compl] = ACTIONS(3012),
    [anon_sym_DASH_DASH] = ACTIONS(3014),
    [anon_sym_PLUS_PLUS] = ACTIONS(3014),
    [anon_sym_sizeof] = ACTIONS(3012),
    [anon_sym___alignof__] = ACTIONS(3012),
    [anon_sym___alignof] = ACTIONS(3012),
    [anon_sym__alignof] = ACTIONS(3012),
    [anon_sym_alignof] = ACTIONS(3012),
    [anon_sym__Alignof] = ACTIONS(3012),
    [anon_sym_offsetof] = ACTIONS(3012),
    [anon_sym__Generic] = ACTIONS(3012),
    [anon_sym_asm] = ACTIONS(3012),
    [anon_sym___asm__] = ACTIONS(3012),
    [aux_sym_number_literal_token1] = ACTIONS(3014),
    [aux_sym_number_literal_token2] = ACTIONS(3012),
    [anon_sym_L_SQUOTE] = ACTIONS(3014),
    [anon_sym_u_SQUOTE] = ACTIONS(3014),
    [anon_sym_U_SQUOTE] = ACTIONS(3014),
    [anon_sym_u8_SQUOTE] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [anon_sym_L_DQUOTE] = ACTIONS(3014),
    [anon_sym_u_DQUOTE] = ACTIONS(3014),
    [anon_sym_U_DQUOTE] = ACTIONS(3014),
    [anon_sym_u8_DQUOTE] = ACTIONS(3014),
    [anon_sym_DQUOTE] = ACTIONS(3014),
    [sym_true] = ACTIONS(3012),
    [sym_false] = ACTIONS(3012),
    [anon_sym_NULL] = ACTIONS(3012),
    [anon_sym_nullptr] = ACTIONS(3012),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3012),
    [anon_sym_decltype] = ACTIONS(3012),
    [anon_sym_virtual] = ACTIONS(3012),
    [anon_sym_alignas] = ACTIONS(3012),
    [anon_sym_explicit] = ACTIONS(3012),
    [anon_sym_typename] = ACTIONS(3012),
    [anon_sym_template] = ACTIONS(3012),
    [anon_sym_operator] = ACTIONS(3012),
    [anon_sym_try] = ACTIONS(3012),
    [anon_sym_delete] = ACTIONS(3012),
    [anon_sym_throw] = ACTIONS(3012),
    [anon_sym_namespace] = ACTIONS(3012),
    [anon_sym_using] = ACTIONS(3012),
    [anon_sym_static_assert] = ACTIONS(3012),
    [anon_sym_concept] = ACTIONS(3012),
    [anon_sym_co_return] = ACTIONS(3012),
    [anon_sym_co_yield] = ACTIONS(3012),
    [anon_sym_R_DQUOTE] = ACTIONS(3014),
    [anon_sym_LR_DQUOTE] = ACTIONS(3014),
    [anon_sym_uR_DQUOTE] = ACTIONS(3014),
    [anon_sym_UR_DQUOTE] = ACTIONS(3014),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3014),
    [anon_sym_co_await] = ACTIONS(3012),
    [anon_sym_new] = ACTIONS(3012),
    [anon_sym_requires] = ACTIONS(3012),
    [sym_this] = ACTIONS(3012),
  },
  [812] = {
    [ts_builtin_sym_end] = ACTIONS(2879),
    [sym_identifier] = ACTIONS(2877),
    [aux_sym_preproc_include_token1] = ACTIONS(2877),
    [aux_sym_preproc_def_token1] = ACTIONS(2877),
    [anon_sym_COMMA] = ACTIONS(2879),
    [aux_sym_preproc_if_token1] = ACTIONS(2877),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2877),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2877),
    [sym_preproc_directive] = ACTIONS(2877),
    [anon_sym_LPAREN2] = ACTIONS(2879),
    [anon_sym_BANG] = ACTIONS(2879),
    [anon_sym_TILDE] = ACTIONS(2879),
    [anon_sym_DASH] = ACTIONS(2877),
    [anon_sym_PLUS] = ACTIONS(2877),
    [anon_sym_STAR] = ACTIONS(2879),
    [anon_sym_AMP_AMP] = ACTIONS(2879),
    [anon_sym_AMP] = ACTIONS(2877),
    [anon_sym___extension__] = ACTIONS(2877),
    [anon_sym_typedef] = ACTIONS(2877),
    [anon_sym_extern] = ACTIONS(2877),
    [anon_sym___attribute__] = ACTIONS(2877),
    [anon_sym_COLON_COLON] = ACTIONS(2879),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2879),
    [anon_sym___declspec] = ACTIONS(2877),
    [anon_sym___based] = ACTIONS(2877),
    [anon_sym___cdecl] = ACTIONS(2877),
    [anon_sym___clrcall] = ACTIONS(2877),
    [anon_sym___stdcall] = ACTIONS(2877),
    [anon_sym___fastcall] = ACTIONS(2877),
    [anon_sym___thiscall] = ACTIONS(2877),
    [anon_sym___vectorcall] = ACTIONS(2877),
    [anon_sym_LBRACE] = ACTIONS(2879),
    [anon_sym_RBRACE] = ACTIONS(2879),
    [anon_sym_signed] = ACTIONS(2877),
    [anon_sym_unsigned] = ACTIONS(2877),
    [anon_sym_long] = ACTIONS(2877),
    [anon_sym_short] = ACTIONS(2877),
    [anon_sym_LBRACK] = ACTIONS(2877),
    [anon_sym_static] = ACTIONS(2877),
    [anon_sym_register] = ACTIONS(2877),
    [anon_sym_inline] = ACTIONS(2877),
    [anon_sym___inline] = ACTIONS(2877),
    [anon_sym___inline__] = ACTIONS(2877),
    [anon_sym___forceinline] = ACTIONS(2877),
    [anon_sym_thread_local] = ACTIONS(2877),
    [anon_sym___thread] = ACTIONS(2877),
    [anon_sym_const] = ACTIONS(2877),
    [anon_sym_constexpr] = ACTIONS(2877),
    [anon_sym_volatile] = ACTIONS(2877),
    [anon_sym_restrict] = ACTIONS(2877),
    [anon_sym___restrict__] = ACTIONS(2877),
    [anon_sym__Atomic] = ACTIONS(2877),
    [anon_sym__Noreturn] = ACTIONS(2877),
    [anon_sym_noreturn] = ACTIONS(2877),
    [anon_sym_mutable] = ACTIONS(2877),
    [anon_sym_constinit] = ACTIONS(2877),
    [anon_sym_consteval] = ACTIONS(2877),
    [anon_sym_PROGMEM] = ACTIONS(2877),
    [aux_sym_primitive_type_token1] = ACTIONS(2877),
    [anon_sym_byte] = ACTIONS(2877),
    [anon_sym_word] = ACTIONS(2877),
    [anon_sym_enum] = ACTIONS(2877),
    [anon_sym_class] = ACTIONS(2877),
    [anon_sym_struct] = ACTIONS(2877),
    [anon_sym_union] = ACTIONS(2877),
    [anon_sym_if] = ACTIONS(2877),
    [anon_sym_switch] = ACTIONS(2877),
    [anon_sym_case] = ACTIONS(2877),
    [anon_sym_default] = ACTIONS(2877),
    [anon_sym_while] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_for] = ACTIONS(2877),
    [anon_sym_return] = ACTIONS(2877),
    [anon_sym_break] = ACTIONS(2877),
    [anon_sym_continue] = ACTIONS(2877),
    [anon_sym_goto] = ACTIONS(2877),
    [anon_sym_not] = ACTIONS(2877),
    [anon_sym_compl] = ACTIONS(2877),
    [anon_sym_DASH_DASH] = ACTIONS(2879),
    [anon_sym_PLUS_PLUS] = ACTIONS(2879),
    [anon_sym_sizeof] = ACTIONS(2877),
    [anon_sym___alignof__] = ACTIONS(2877),
    [anon_sym___alignof] = ACTIONS(2877),
    [anon_sym__alignof] = ACTIONS(2877),
    [anon_sym_alignof] = ACTIONS(2877),
    [anon_sym__Alignof] = ACTIONS(2877),
    [anon_sym_offsetof] = ACTIONS(2877),
    [anon_sym__Generic] = ACTIONS(2877),
    [anon_sym_asm] = ACTIONS(2877),
    [anon_sym___asm__] = ACTIONS(2877),
    [aux_sym_number_literal_token1] = ACTIONS(2879),
    [aux_sym_number_literal_token2] = ACTIONS(2877),
    [anon_sym_L_SQUOTE] = ACTIONS(2879),
    [anon_sym_u_SQUOTE] = ACTIONS(2879),
    [anon_sym_U_SQUOTE] = ACTIONS(2879),
    [anon_sym_u8_SQUOTE] = ACTIONS(2879),
    [anon_sym_SQUOTE] = ACTIONS(2879),
    [anon_sym_L_DQUOTE] = ACTIONS(2879),
    [anon_sym_u_DQUOTE] = ACTIONS(2879),
    [anon_sym_U_DQUOTE] = ACTIONS(2879),
    [anon_sym_u8_DQUOTE] = ACTIONS(2879),
    [anon_sym_DQUOTE] = ACTIONS(2879),
    [sym_true] = ACTIONS(2877),
    [sym_false] = ACTIONS(2877),
    [anon_sym_NULL] = ACTIONS(2877),
    [anon_sym_nullptr] = ACTIONS(2877),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2877),
    [anon_sym_decltype] = ACTIONS(2877),
    [anon_sym_virtual] = ACTIONS(2877),
    [anon_sym_alignas] = ACTIONS(2877),
    [anon_sym_explicit] = ACTIONS(2877),
    [anon_sym_typename] = ACTIONS(2877),
    [anon_sym_template] = ACTIONS(2877),
    [anon_sym_operator] = ACTIONS(2877),
    [anon_sym_try] = ACTIONS(2877),
    [anon_sym_delete] = ACTIONS(2877),
    [anon_sym_throw] = ACTIONS(2877),
    [anon_sym_namespace] = ACTIONS(2877),
    [anon_sym_using] = ACTIONS(2877),
    [anon_sym_static_assert] = ACTIONS(2877),
    [anon_sym_concept] = ACTIONS(2877),
    [anon_sym_co_return] = ACTIONS(2877),
    [anon_sym_co_yield] = ACTIONS(2877),
    [anon_sym_R_DQUOTE] = ACTIONS(2879),
    [anon_sym_LR_DQUOTE] = ACTIONS(2879),
    [anon_sym_uR_DQUOTE] = ACTIONS(2879),
    [anon_sym_UR_DQUOTE] = ACTIONS(2879),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2879),
    [anon_sym_co_await] = ACTIONS(2877),
    [anon_sym_new] = ACTIONS(2877),
    [anon_sym_requires] = ACTIONS(2877),
    [sym_this] = ACTIONS(2877),
  },
  [813] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(3868),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(3905),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1885),
    [anon_sym_COMMA] = ACTIONS(1885),
    [anon_sym_RPAREN] = ACTIONS(1885),
    [anon_sym_LPAREN2] = ACTIONS(1885),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(1883),
    [anon_sym_PLUS] = ACTIONS(1883),
    [anon_sym_STAR] = ACTIONS(1885),
    [anon_sym_SLASH] = ACTIONS(1883),
    [anon_sym_PERCENT] = ACTIONS(1885),
    [anon_sym_PIPE_PIPE] = ACTIONS(1885),
    [anon_sym_AMP_AMP] = ACTIONS(1885),
    [anon_sym_PIPE] = ACTIONS(1883),
    [anon_sym_CARET] = ACTIONS(1885),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym_EQ_EQ] = ACTIONS(1885),
    [anon_sym_BANG_EQ] = ACTIONS(1885),
    [anon_sym_GT] = ACTIONS(1883),
    [anon_sym_GT_EQ] = ACTIONS(1885),
    [anon_sym_LT_EQ] = ACTIONS(1883),
    [anon_sym_LT] = ACTIONS(1883),
    [anon_sym_LT_LT] = ACTIONS(1885),
    [anon_sym_GT_GT] = ACTIONS(1885),
    [anon_sym_SEMI] = ACTIONS(1885),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_RBRACE] = ACTIONS(1885),
    [anon_sym_LBRACK] = ACTIONS(1885),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_QMARK] = ACTIONS(1885),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_LT_EQ_GT] = ACTIONS(1885),
    [anon_sym_or] = ACTIONS(1883),
    [anon_sym_and] = ACTIONS(1883),
    [anon_sym_bitor] = ACTIONS(1883),
    [anon_sym_xor] = ACTIONS(1883),
    [anon_sym_bitand] = ACTIONS(1883),
    [anon_sym_not_eq] = ACTIONS(1883),
    [anon_sym_DASH_DASH] = ACTIONS(1885),
    [anon_sym_PLUS_PLUS] = ACTIONS(1885),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(1883),
    [anon_sym_DOT_STAR] = ACTIONS(1885),
    [anon_sym_DASH_GT] = ACTIONS(1885),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [814] = {
    [ts_builtin_sym_end] = ACTIONS(3172),
    [sym_identifier] = ACTIONS(3170),
    [aux_sym_preproc_include_token1] = ACTIONS(3170),
    [aux_sym_preproc_def_token1] = ACTIONS(3170),
    [anon_sym_COMMA] = ACTIONS(3172),
    [aux_sym_preproc_if_token1] = ACTIONS(3170),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3170),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3170),
    [sym_preproc_directive] = ACTIONS(3170),
    [anon_sym_LPAREN2] = ACTIONS(3172),
    [anon_sym_BANG] = ACTIONS(3172),
    [anon_sym_TILDE] = ACTIONS(3172),
    [anon_sym_DASH] = ACTIONS(3170),
    [anon_sym_PLUS] = ACTIONS(3170),
    [anon_sym_STAR] = ACTIONS(3172),
    [anon_sym_AMP_AMP] = ACTIONS(3172),
    [anon_sym_AMP] = ACTIONS(3170),
    [anon_sym___extension__] = ACTIONS(3170),
    [anon_sym_typedef] = ACTIONS(3170),
    [anon_sym_extern] = ACTIONS(3170),
    [anon_sym___attribute__] = ACTIONS(3170),
    [anon_sym_COLON_COLON] = ACTIONS(3172),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3172),
    [anon_sym___declspec] = ACTIONS(3170),
    [anon_sym___based] = ACTIONS(3170),
    [anon_sym___cdecl] = ACTIONS(3170),
    [anon_sym___clrcall] = ACTIONS(3170),
    [anon_sym___stdcall] = ACTIONS(3170),
    [anon_sym___fastcall] = ACTIONS(3170),
    [anon_sym___thiscall] = ACTIONS(3170),
    [anon_sym___vectorcall] = ACTIONS(3170),
    [anon_sym_LBRACE] = ACTIONS(3172),
    [anon_sym_RBRACE] = ACTIONS(3172),
    [anon_sym_signed] = ACTIONS(3170),
    [anon_sym_unsigned] = ACTIONS(3170),
    [anon_sym_long] = ACTIONS(3170),
    [anon_sym_short] = ACTIONS(3170),
    [anon_sym_LBRACK] = ACTIONS(3170),
    [anon_sym_static] = ACTIONS(3170),
    [anon_sym_register] = ACTIONS(3170),
    [anon_sym_inline] = ACTIONS(3170),
    [anon_sym___inline] = ACTIONS(3170),
    [anon_sym___inline__] = ACTIONS(3170),
    [anon_sym___forceinline] = ACTIONS(3170),
    [anon_sym_thread_local] = ACTIONS(3170),
    [anon_sym___thread] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3170),
    [anon_sym_constexpr] = ACTIONS(3170),
    [anon_sym_volatile] = ACTIONS(3170),
    [anon_sym_restrict] = ACTIONS(3170),
    [anon_sym___restrict__] = ACTIONS(3170),
    [anon_sym__Atomic] = ACTIONS(3170),
    [anon_sym__Noreturn] = ACTIONS(3170),
    [anon_sym_noreturn] = ACTIONS(3170),
    [anon_sym_mutable] = ACTIONS(3170),
    [anon_sym_constinit] = ACTIONS(3170),
    [anon_sym_consteval] = ACTIONS(3170),
    [anon_sym_PROGMEM] = ACTIONS(3170),
    [aux_sym_primitive_type_token1] = ACTIONS(3170),
    [anon_sym_byte] = ACTIONS(3170),
    [anon_sym_word] = ACTIONS(3170),
    [anon_sym_enum] = ACTIONS(3170),
    [anon_sym_class] = ACTIONS(3170),
    [anon_sym_struct] = ACTIONS(3170),
    [anon_sym_union] = ACTIONS(3170),
    [anon_sym_if] = ACTIONS(3170),
    [anon_sym_switch] = ACTIONS(3170),
    [anon_sym_case] = ACTIONS(3170),
    [anon_sym_default] = ACTIONS(3170),
    [anon_sym_while] = ACTIONS(3170),
    [anon_sym_do] = ACTIONS(3170),
    [anon_sym_for] = ACTIONS(3170),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_break] = ACTIONS(3170),
    [anon_sym_continue] = ACTIONS(3170),
    [anon_sym_goto] = ACTIONS(3170),
    [anon_sym_not] = ACTIONS(3170),
    [anon_sym_compl] = ACTIONS(3170),
    [anon_sym_DASH_DASH] = ACTIONS(3172),
    [anon_sym_PLUS_PLUS] = ACTIONS(3172),
    [anon_sym_sizeof] = ACTIONS(3170),
    [anon_sym___alignof__] = ACTIONS(3170),
    [anon_sym___alignof] = ACTIONS(3170),
    [anon_sym__alignof] = ACTIONS(3170),
    [anon_sym_alignof] = ACTIONS(3170),
    [anon_sym__Alignof] = ACTIONS(3170),
    [anon_sym_offsetof] = ACTIONS(3170),
    [anon_sym__Generic] = ACTIONS(3170),
    [anon_sym_asm] = ACTIONS(3170),
    [anon_sym___asm__] = ACTIONS(3170),
    [aux_sym_number_literal_token1] = ACTIONS(3172),
    [aux_sym_number_literal_token2] = ACTIONS(3170),
    [anon_sym_L_SQUOTE] = ACTIONS(3172),
    [anon_sym_u_SQUOTE] = ACTIONS(3172),
    [anon_sym_U_SQUOTE] = ACTIONS(3172),
    [anon_sym_u8_SQUOTE] = ACTIONS(3172),
    [anon_sym_SQUOTE] = ACTIONS(3172),
    [anon_sym_L_DQUOTE] = ACTIONS(3172),
    [anon_sym_u_DQUOTE] = ACTIONS(3172),
    [anon_sym_U_DQUOTE] = ACTIONS(3172),
    [anon_sym_u8_DQUOTE] = ACTIONS(3172),
    [anon_sym_DQUOTE] = ACTIONS(3172),
    [sym_true] = ACTIONS(3170),
    [sym_false] = ACTIONS(3170),
    [anon_sym_NULL] = ACTIONS(3170),
    [anon_sym_nullptr] = ACTIONS(3170),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3170),
    [anon_sym_decltype] = ACTIONS(3170),
    [anon_sym_virtual] = ACTIONS(3170),
    [anon_sym_alignas] = ACTIONS(3170),
    [anon_sym_explicit] = ACTIONS(3170),
    [anon_sym_typename] = ACTIONS(3170),
    [anon_sym_template] = ACTIONS(3170),
    [anon_sym_operator] = ACTIONS(3170),
    [anon_sym_try] = ACTIONS(3170),
    [anon_sym_delete] = ACTIONS(3170),
    [anon_sym_throw] = ACTIONS(3170),
    [anon_sym_namespace] = ACTIONS(3170),
    [anon_sym_using] = ACTIONS(3170),
    [anon_sym_static_assert] = ACTIONS(3170),
    [anon_sym_concept] = ACTIONS(3170),
    [anon_sym_co_return] = ACTIONS(3170),
    [anon_sym_co_yield] = ACTIONS(3170),
    [anon_sym_R_DQUOTE] = ACTIONS(3172),
    [anon_sym_LR_DQUOTE] = ACTIONS(3172),
    [anon_sym_uR_DQUOTE] = ACTIONS(3172),
    [anon_sym_UR_DQUOTE] = ACTIONS(3172),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3172),
    [anon_sym_co_await] = ACTIONS(3170),
    [anon_sym_new] = ACTIONS(3170),
    [anon_sym_requires] = ACTIONS(3170),
    [sym_this] = ACTIONS(3170),
  },
  [815] = {
    [ts_builtin_sym_end] = ACTIONS(3107),
    [sym_identifier] = ACTIONS(3105),
    [aux_sym_preproc_include_token1] = ACTIONS(3105),
    [aux_sym_preproc_def_token1] = ACTIONS(3105),
    [aux_sym_preproc_if_token1] = ACTIONS(3105),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3105),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3105),
    [sym_preproc_directive] = ACTIONS(3105),
    [anon_sym_LPAREN2] = ACTIONS(3107),
    [anon_sym_BANG] = ACTIONS(3107),
    [anon_sym_TILDE] = ACTIONS(3107),
    [anon_sym_DASH] = ACTIONS(3105),
    [anon_sym_PLUS] = ACTIONS(3105),
    [anon_sym_STAR] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3107),
    [anon_sym_AMP] = ACTIONS(3105),
    [anon_sym_SEMI] = ACTIONS(3332),
    [anon_sym___extension__] = ACTIONS(3105),
    [anon_sym_typedef] = ACTIONS(3105),
    [anon_sym_extern] = ACTIONS(3105),
    [anon_sym___attribute__] = ACTIONS(3105),
    [anon_sym_COLON_COLON] = ACTIONS(3107),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3107),
    [anon_sym___declspec] = ACTIONS(3105),
    [anon_sym___based] = ACTIONS(3105),
    [anon_sym___cdecl] = ACTIONS(3105),
    [anon_sym___clrcall] = ACTIONS(3105),
    [anon_sym___stdcall] = ACTIONS(3105),
    [anon_sym___fastcall] = ACTIONS(3105),
    [anon_sym___thiscall] = ACTIONS(3105),
    [anon_sym___vectorcall] = ACTIONS(3105),
    [anon_sym_LBRACE] = ACTIONS(3107),
    [anon_sym_signed] = ACTIONS(3105),
    [anon_sym_unsigned] = ACTIONS(3105),
    [anon_sym_long] = ACTIONS(3105),
    [anon_sym_short] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(3105),
    [anon_sym_static] = ACTIONS(3105),
    [anon_sym_register] = ACTIONS(3105),
    [anon_sym_inline] = ACTIONS(3105),
    [anon_sym___inline] = ACTIONS(3105),
    [anon_sym___inline__] = ACTIONS(3105),
    [anon_sym___forceinline] = ACTIONS(3105),
    [anon_sym_thread_local] = ACTIONS(3105),
    [anon_sym___thread] = ACTIONS(3105),
    [anon_sym_const] = ACTIONS(3105),
    [anon_sym_constexpr] = ACTIONS(3105),
    [anon_sym_volatile] = ACTIONS(3105),
    [anon_sym_restrict] = ACTIONS(3105),
    [anon_sym___restrict__] = ACTIONS(3105),
    [anon_sym__Atomic] = ACTIONS(3105),
    [anon_sym__Noreturn] = ACTIONS(3105),
    [anon_sym_noreturn] = ACTIONS(3105),
    [anon_sym_mutable] = ACTIONS(3105),
    [anon_sym_constinit] = ACTIONS(3105),
    [anon_sym_consteval] = ACTIONS(3105),
    [anon_sym_PROGMEM] = ACTIONS(3105),
    [aux_sym_primitive_type_token1] = ACTIONS(3105),
    [anon_sym_byte] = ACTIONS(3105),
    [anon_sym_word] = ACTIONS(3105),
    [anon_sym_enum] = ACTIONS(3105),
    [anon_sym_class] = ACTIONS(3105),
    [anon_sym_struct] = ACTIONS(3105),
    [anon_sym_union] = ACTIONS(3105),
    [anon_sym_if] = ACTIONS(3105),
    [anon_sym_switch] = ACTIONS(3105),
    [anon_sym_case] = ACTIONS(3105),
    [anon_sym_default] = ACTIONS(3105),
    [anon_sym_while] = ACTIONS(3105),
    [anon_sym_do] = ACTIONS(3105),
    [anon_sym_for] = ACTIONS(3105),
    [anon_sym_return] = ACTIONS(3105),
    [anon_sym_break] = ACTIONS(3105),
    [anon_sym_continue] = ACTIONS(3105),
    [anon_sym_goto] = ACTIONS(3105),
    [anon_sym_not] = ACTIONS(3105),
    [anon_sym_compl] = ACTIONS(3105),
    [anon_sym_DASH_DASH] = ACTIONS(3107),
    [anon_sym_PLUS_PLUS] = ACTIONS(3107),
    [anon_sym_sizeof] = ACTIONS(3105),
    [anon_sym___alignof__] = ACTIONS(3105),
    [anon_sym___alignof] = ACTIONS(3105),
    [anon_sym__alignof] = ACTIONS(3105),
    [anon_sym_alignof] = ACTIONS(3105),
    [anon_sym__Alignof] = ACTIONS(3105),
    [anon_sym_offsetof] = ACTIONS(3105),
    [anon_sym__Generic] = ACTIONS(3105),
    [anon_sym_asm] = ACTIONS(3105),
    [anon_sym___asm__] = ACTIONS(3105),
    [aux_sym_number_literal_token1] = ACTIONS(3107),
    [aux_sym_number_literal_token2] = ACTIONS(3105),
    [anon_sym_L_SQUOTE] = ACTIONS(3107),
    [anon_sym_u_SQUOTE] = ACTIONS(3107),
    [anon_sym_U_SQUOTE] = ACTIONS(3107),
    [anon_sym_u8_SQUOTE] = ACTIONS(3107),
    [anon_sym_SQUOTE] = ACTIONS(3107),
    [anon_sym_L_DQUOTE] = ACTIONS(3107),
    [anon_sym_u_DQUOTE] = ACTIONS(3107),
    [anon_sym_U_DQUOTE] = ACTIONS(3107),
    [anon_sym_u8_DQUOTE] = ACTIONS(3107),
    [anon_sym_DQUOTE] = ACTIONS(3107),
    [sym_true] = ACTIONS(3105),
    [sym_false] = ACTIONS(3105),
    [anon_sym_NULL] = ACTIONS(3105),
    [anon_sym_nullptr] = ACTIONS(3105),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3105),
    [anon_sym_decltype] = ACTIONS(3105),
    [anon_sym_virtual] = ACTIONS(3105),
    [anon_sym_alignas] = ACTIONS(3105),
    [anon_sym_explicit] = ACTIONS(3105),
    [anon_sym_typename] = ACTIONS(3105),
    [anon_sym_template] = ACTIONS(3105),
    [anon_sym_operator] = ACTIONS(3105),
    [anon_sym_try] = ACTIONS(3105),
    [anon_sym_delete] = ACTIONS(3105),
    [anon_sym_throw] = ACTIONS(3105),
    [anon_sym_namespace] = ACTIONS(3105),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_static_assert] = ACTIONS(3105),
    [anon_sym_concept] = ACTIONS(3105),
    [anon_sym_co_return] = ACTIONS(3105),
    [anon_sym_co_yield] = ACTIONS(3105),
    [anon_sym_R_DQUOTE] = ACTIONS(3107),
    [anon_sym_LR_DQUOTE] = ACTIONS(3107),
    [anon_sym_uR_DQUOTE] = ACTIONS(3107),
    [anon_sym_UR_DQUOTE] = ACTIONS(3107),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3107),
    [anon_sym_co_await] = ACTIONS(3105),
    [anon_sym_new] = ACTIONS(3105),
    [anon_sym_requires] = ACTIONS(3105),
    [sym_this] = ACTIONS(3105),
  },
  [816] = {
    [ts_builtin_sym_end] = ACTIONS(2939),
    [sym_identifier] = ACTIONS(2937),
    [aux_sym_preproc_include_token1] = ACTIONS(2937),
    [aux_sym_preproc_def_token1] = ACTIONS(2937),
    [aux_sym_preproc_if_token1] = ACTIONS(2937),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2937),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2937),
    [sym_preproc_directive] = ACTIONS(2937),
    [anon_sym_LPAREN2] = ACTIONS(2939),
    [anon_sym_BANG] = ACTIONS(2939),
    [anon_sym_TILDE] = ACTIONS(2939),
    [anon_sym_DASH] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(2937),
    [anon_sym_STAR] = ACTIONS(2939),
    [anon_sym_AMP_AMP] = ACTIONS(2939),
    [anon_sym_AMP] = ACTIONS(2937),
    [anon_sym_SEMI] = ACTIONS(3334),
    [anon_sym___extension__] = ACTIONS(2937),
    [anon_sym_typedef] = ACTIONS(2937),
    [anon_sym_extern] = ACTIONS(2937),
    [anon_sym___attribute__] = ACTIONS(2937),
    [anon_sym_COLON_COLON] = ACTIONS(2939),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2939),
    [anon_sym___declspec] = ACTIONS(2937),
    [anon_sym___based] = ACTIONS(2937),
    [anon_sym___cdecl] = ACTIONS(2937),
    [anon_sym___clrcall] = ACTIONS(2937),
    [anon_sym___stdcall] = ACTIONS(2937),
    [anon_sym___fastcall] = ACTIONS(2937),
    [anon_sym___thiscall] = ACTIONS(2937),
    [anon_sym___vectorcall] = ACTIONS(2937),
    [anon_sym_LBRACE] = ACTIONS(2939),
    [anon_sym_signed] = ACTIONS(2937),
    [anon_sym_unsigned] = ACTIONS(2937),
    [anon_sym_long] = ACTIONS(2937),
    [anon_sym_short] = ACTIONS(2937),
    [anon_sym_LBRACK] = ACTIONS(2937),
    [anon_sym_static] = ACTIONS(2937),
    [anon_sym_register] = ACTIONS(2937),
    [anon_sym_inline] = ACTIONS(2937),
    [anon_sym___inline] = ACTIONS(2937),
    [anon_sym___inline__] = ACTIONS(2937),
    [anon_sym___forceinline] = ACTIONS(2937),
    [anon_sym_thread_local] = ACTIONS(2937),
    [anon_sym___thread] = ACTIONS(2937),
    [anon_sym_const] = ACTIONS(2937),
    [anon_sym_constexpr] = ACTIONS(2937),
    [anon_sym_volatile] = ACTIONS(2937),
    [anon_sym_restrict] = ACTIONS(2937),
    [anon_sym___restrict__] = ACTIONS(2937),
    [anon_sym__Atomic] = ACTIONS(2937),
    [anon_sym__Noreturn] = ACTIONS(2937),
    [anon_sym_noreturn] = ACTIONS(2937),
    [anon_sym_mutable] = ACTIONS(2937),
    [anon_sym_constinit] = ACTIONS(2937),
    [anon_sym_consteval] = ACTIONS(2937),
    [anon_sym_PROGMEM] = ACTIONS(2937),
    [aux_sym_primitive_type_token1] = ACTIONS(2937),
    [anon_sym_byte] = ACTIONS(2937),
    [anon_sym_word] = ACTIONS(2937),
    [anon_sym_enum] = ACTIONS(2937),
    [anon_sym_class] = ACTIONS(2937),
    [anon_sym_struct] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [anon_sym_if] = ACTIONS(2937),
    [anon_sym_switch] = ACTIONS(2937),
    [anon_sym_case] = ACTIONS(2937),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_while] = ACTIONS(2937),
    [anon_sym_do] = ACTIONS(2937),
    [anon_sym_for] = ACTIONS(2937),
    [anon_sym_return] = ACTIONS(2937),
    [anon_sym_break] = ACTIONS(2937),
    [anon_sym_continue] = ACTIONS(2937),
    [anon_sym_goto] = ACTIONS(2937),
    [anon_sym_not] = ACTIONS(2937),
    [anon_sym_compl] = ACTIONS(2937),
    [anon_sym_DASH_DASH] = ACTIONS(2939),
    [anon_sym_PLUS_PLUS] = ACTIONS(2939),
    [anon_sym_sizeof] = ACTIONS(2937),
    [anon_sym___alignof__] = ACTIONS(2937),
    [anon_sym___alignof] = ACTIONS(2937),
    [anon_sym__alignof] = ACTIONS(2937),
    [anon_sym_alignof] = ACTIONS(2937),
    [anon_sym__Alignof] = ACTIONS(2937),
    [anon_sym_offsetof] = ACTIONS(2937),
    [anon_sym__Generic] = ACTIONS(2937),
    [anon_sym_asm] = ACTIONS(2937),
    [anon_sym___asm__] = ACTIONS(2937),
    [aux_sym_number_literal_token1] = ACTIONS(2939),
    [aux_sym_number_literal_token2] = ACTIONS(2937),
    [anon_sym_L_SQUOTE] = ACTIONS(2939),
    [anon_sym_u_SQUOTE] = ACTIONS(2939),
    [anon_sym_U_SQUOTE] = ACTIONS(2939),
    [anon_sym_u8_SQUOTE] = ACTIONS(2939),
    [anon_sym_SQUOTE] = ACTIONS(2939),
    [anon_sym_L_DQUOTE] = ACTIONS(2939),
    [anon_sym_u_DQUOTE] = ACTIONS(2939),
    [anon_sym_U_DQUOTE] = ACTIONS(2939),
    [anon_sym_u8_DQUOTE] = ACTIONS(2939),
    [anon_sym_DQUOTE] = ACTIONS(2939),
    [sym_true] = ACTIONS(2937),
    [sym_false] = ACTIONS(2937),
    [anon_sym_NULL] = ACTIONS(2937),
    [anon_sym_nullptr] = ACTIONS(2937),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2937),
    [anon_sym_decltype] = ACTIONS(2937),
    [anon_sym_virtual] = ACTIONS(2937),
    [anon_sym_alignas] = ACTIONS(2937),
    [anon_sym_explicit] = ACTIONS(2937),
    [anon_sym_typename] = ACTIONS(2937),
    [anon_sym_template] = ACTIONS(2937),
    [anon_sym_operator] = ACTIONS(2937),
    [anon_sym_try] = ACTIONS(2937),
    [anon_sym_delete] = ACTIONS(2937),
    [anon_sym_throw] = ACTIONS(2937),
    [anon_sym_namespace] = ACTIONS(2937),
    [anon_sym_using] = ACTIONS(2937),
    [anon_sym_static_assert] = ACTIONS(2937),
    [anon_sym_concept] = ACTIONS(2937),
    [anon_sym_co_return] = ACTIONS(2937),
    [anon_sym_co_yield] = ACTIONS(2937),
    [anon_sym_R_DQUOTE] = ACTIONS(2939),
    [anon_sym_LR_DQUOTE] = ACTIONS(2939),
    [anon_sym_uR_DQUOTE] = ACTIONS(2939),
    [anon_sym_UR_DQUOTE] = ACTIONS(2939),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2939),
    [anon_sym_co_await] = ACTIONS(2937),
    [anon_sym_new] = ACTIONS(2937),
    [anon_sym_requires] = ACTIONS(2937),
    [sym_this] = ACTIONS(2937),
  },
  [817] = {
    [ts_builtin_sym_end] = ACTIONS(3124),
    [sym_identifier] = ACTIONS(3122),
    [aux_sym_preproc_include_token1] = ACTIONS(3122),
    [aux_sym_preproc_def_token1] = ACTIONS(3122),
    [aux_sym_preproc_if_token1] = ACTIONS(3122),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3122),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3122),
    [sym_preproc_directive] = ACTIONS(3122),
    [anon_sym_LPAREN2] = ACTIONS(3124),
    [anon_sym_BANG] = ACTIONS(3124),
    [anon_sym_TILDE] = ACTIONS(3124),
    [anon_sym_DASH] = ACTIONS(3122),
    [anon_sym_PLUS] = ACTIONS(3122),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP_AMP] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3122),
    [anon_sym_SEMI] = ACTIONS(3336),
    [anon_sym___extension__] = ACTIONS(3122),
    [anon_sym_typedef] = ACTIONS(3122),
    [anon_sym_extern] = ACTIONS(3122),
    [anon_sym___attribute__] = ACTIONS(3122),
    [anon_sym_COLON_COLON] = ACTIONS(3124),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3124),
    [anon_sym___declspec] = ACTIONS(3122),
    [anon_sym___based] = ACTIONS(3122),
    [anon_sym___cdecl] = ACTIONS(3122),
    [anon_sym___clrcall] = ACTIONS(3122),
    [anon_sym___stdcall] = ACTIONS(3122),
    [anon_sym___fastcall] = ACTIONS(3122),
    [anon_sym___thiscall] = ACTIONS(3122),
    [anon_sym___vectorcall] = ACTIONS(3122),
    [anon_sym_LBRACE] = ACTIONS(3124),
    [anon_sym_signed] = ACTIONS(3122),
    [anon_sym_unsigned] = ACTIONS(3122),
    [anon_sym_long] = ACTIONS(3122),
    [anon_sym_short] = ACTIONS(3122),
    [anon_sym_LBRACK] = ACTIONS(3122),
    [anon_sym_static] = ACTIONS(3122),
    [anon_sym_register] = ACTIONS(3122),
    [anon_sym_inline] = ACTIONS(3122),
    [anon_sym___inline] = ACTIONS(3122),
    [anon_sym___inline__] = ACTIONS(3122),
    [anon_sym___forceinline] = ACTIONS(3122),
    [anon_sym_thread_local] = ACTIONS(3122),
    [anon_sym___thread] = ACTIONS(3122),
    [anon_sym_const] = ACTIONS(3122),
    [anon_sym_constexpr] = ACTIONS(3122),
    [anon_sym_volatile] = ACTIONS(3122),
    [anon_sym_restrict] = ACTIONS(3122),
    [anon_sym___restrict__] = ACTIONS(3122),
    [anon_sym__Atomic] = ACTIONS(3122),
    [anon_sym__Noreturn] = ACTIONS(3122),
    [anon_sym_noreturn] = ACTIONS(3122),
    [anon_sym_mutable] = ACTIONS(3122),
    [anon_sym_constinit] = ACTIONS(3122),
    [anon_sym_consteval] = ACTIONS(3122),
    [anon_sym_PROGMEM] = ACTIONS(3122),
    [aux_sym_primitive_type_token1] = ACTIONS(3122),
    [anon_sym_byte] = ACTIONS(3122),
    [anon_sym_word] = ACTIONS(3122),
    [anon_sym_enum] = ACTIONS(3122),
    [anon_sym_class] = ACTIONS(3122),
    [anon_sym_struct] = ACTIONS(3122),
    [anon_sym_union] = ACTIONS(3122),
    [anon_sym_if] = ACTIONS(3122),
    [anon_sym_switch] = ACTIONS(3122),
    [anon_sym_case] = ACTIONS(3122),
    [anon_sym_default] = ACTIONS(3122),
    [anon_sym_while] = ACTIONS(3122),
    [anon_sym_do] = ACTIONS(3122),
    [anon_sym_for] = ACTIONS(3122),
    [anon_sym_return] = ACTIONS(3122),
    [anon_sym_break] = ACTIONS(3122),
    [anon_sym_continue] = ACTIONS(3122),
    [anon_sym_goto] = ACTIONS(3122),
    [anon_sym_not] = ACTIONS(3122),
    [anon_sym_compl] = ACTIONS(3122),
    [anon_sym_DASH_DASH] = ACTIONS(3124),
    [anon_sym_PLUS_PLUS] = ACTIONS(3124),
    [anon_sym_sizeof] = ACTIONS(3122),
    [anon_sym___alignof__] = ACTIONS(3122),
    [anon_sym___alignof] = ACTIONS(3122),
    [anon_sym__alignof] = ACTIONS(3122),
    [anon_sym_alignof] = ACTIONS(3122),
    [anon_sym__Alignof] = ACTIONS(3122),
    [anon_sym_offsetof] = ACTIONS(3122),
    [anon_sym__Generic] = ACTIONS(3122),
    [anon_sym_asm] = ACTIONS(3122),
    [anon_sym___asm__] = ACTIONS(3122),
    [aux_sym_number_literal_token1] = ACTIONS(3124),
    [aux_sym_number_literal_token2] = ACTIONS(3122),
    [anon_sym_L_SQUOTE] = ACTIONS(3124),
    [anon_sym_u_SQUOTE] = ACTIONS(3124),
    [anon_sym_U_SQUOTE] = ACTIONS(3124),
    [anon_sym_u8_SQUOTE] = ACTIONS(3124),
    [anon_sym_SQUOTE] = ACTIONS(3124),
    [anon_sym_L_DQUOTE] = ACTIONS(3124),
    [anon_sym_u_DQUOTE] = ACTIONS(3124),
    [anon_sym_U_DQUOTE] = ACTIONS(3124),
    [anon_sym_u8_DQUOTE] = ACTIONS(3124),
    [anon_sym_DQUOTE] = ACTIONS(3124),
    [sym_true] = ACTIONS(3122),
    [sym_false] = ACTIONS(3122),
    [anon_sym_NULL] = ACTIONS(3122),
    [anon_sym_nullptr] = ACTIONS(3122),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3122),
    [anon_sym_decltype] = ACTIONS(3122),
    [anon_sym_virtual] = ACTIONS(3122),
    [anon_sym_alignas] = ACTIONS(3122),
    [anon_sym_explicit] = ACTIONS(3122),
    [anon_sym_typename] = ACTIONS(3122),
    [anon_sym_template] = ACTIONS(3122),
    [anon_sym_operator] = ACTIONS(3122),
    [anon_sym_try] = ACTIONS(3122),
    [anon_sym_delete] = ACTIONS(3122),
    [anon_sym_throw] = ACTIONS(3122),
    [anon_sym_namespace] = ACTIONS(3122),
    [anon_sym_using] = ACTIONS(3122),
    [anon_sym_static_assert] = ACTIONS(3122),
    [anon_sym_concept] = ACTIONS(3122),
    [anon_sym_co_return] = ACTIONS(3122),
    [anon_sym_co_yield] = ACTIONS(3122),
    [anon_sym_R_DQUOTE] = ACTIONS(3124),
    [anon_sym_LR_DQUOTE] = ACTIONS(3124),
    [anon_sym_uR_DQUOTE] = ACTIONS(3124),
    [anon_sym_UR_DQUOTE] = ACTIONS(3124),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3124),
    [anon_sym_co_await] = ACTIONS(3122),
    [anon_sym_new] = ACTIONS(3122),
    [anon_sym_requires] = ACTIONS(3122),
    [sym_this] = ACTIONS(3122),
  },
  [818] = {
    [ts_builtin_sym_end] = ACTIONS(2987),
    [sym_identifier] = ACTIONS(2985),
    [aux_sym_preproc_include_token1] = ACTIONS(2985),
    [aux_sym_preproc_def_token1] = ACTIONS(2985),
    [aux_sym_preproc_if_token1] = ACTIONS(2985),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2985),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2985),
    [sym_preproc_directive] = ACTIONS(2985),
    [anon_sym_LPAREN2] = ACTIONS(2987),
    [anon_sym_BANG] = ACTIONS(2987),
    [anon_sym_TILDE] = ACTIONS(2987),
    [anon_sym_DASH] = ACTIONS(2985),
    [anon_sym_PLUS] = ACTIONS(2985),
    [anon_sym_STAR] = ACTIONS(2987),
    [anon_sym_AMP_AMP] = ACTIONS(2987),
    [anon_sym_AMP] = ACTIONS(2985),
    [anon_sym_SEMI] = ACTIONS(3338),
    [anon_sym___extension__] = ACTIONS(2985),
    [anon_sym_typedef] = ACTIONS(2985),
    [anon_sym_extern] = ACTIONS(2985),
    [anon_sym___attribute__] = ACTIONS(2985),
    [anon_sym_COLON_COLON] = ACTIONS(2987),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2987),
    [anon_sym___declspec] = ACTIONS(2985),
    [anon_sym___based] = ACTIONS(2985),
    [anon_sym___cdecl] = ACTIONS(2985),
    [anon_sym___clrcall] = ACTIONS(2985),
    [anon_sym___stdcall] = ACTIONS(2985),
    [anon_sym___fastcall] = ACTIONS(2985),
    [anon_sym___thiscall] = ACTIONS(2985),
    [anon_sym___vectorcall] = ACTIONS(2985),
    [anon_sym_LBRACE] = ACTIONS(2987),
    [anon_sym_signed] = ACTIONS(2985),
    [anon_sym_unsigned] = ACTIONS(2985),
    [anon_sym_long] = ACTIONS(2985),
    [anon_sym_short] = ACTIONS(2985),
    [anon_sym_LBRACK] = ACTIONS(2985),
    [anon_sym_static] = ACTIONS(2985),
    [anon_sym_register] = ACTIONS(2985),
    [anon_sym_inline] = ACTIONS(2985),
    [anon_sym___inline] = ACTIONS(2985),
    [anon_sym___inline__] = ACTIONS(2985),
    [anon_sym___forceinline] = ACTIONS(2985),
    [anon_sym_thread_local] = ACTIONS(2985),
    [anon_sym___thread] = ACTIONS(2985),
    [anon_sym_const] = ACTIONS(2985),
    [anon_sym_constexpr] = ACTIONS(2985),
    [anon_sym_volatile] = ACTIONS(2985),
    [anon_sym_restrict] = ACTIONS(2985),
    [anon_sym___restrict__] = ACTIONS(2985),
    [anon_sym__Atomic] = ACTIONS(2985),
    [anon_sym__Noreturn] = ACTIONS(2985),
    [anon_sym_noreturn] = ACTIONS(2985),
    [anon_sym_mutable] = ACTIONS(2985),
    [anon_sym_constinit] = ACTIONS(2985),
    [anon_sym_consteval] = ACTIONS(2985),
    [anon_sym_PROGMEM] = ACTIONS(2985),
    [aux_sym_primitive_type_token1] = ACTIONS(2985),
    [anon_sym_byte] = ACTIONS(2985),
    [anon_sym_word] = ACTIONS(2985),
    [anon_sym_enum] = ACTIONS(2985),
    [anon_sym_class] = ACTIONS(2985),
    [anon_sym_struct] = ACTIONS(2985),
    [anon_sym_union] = ACTIONS(2985),
    [anon_sym_if] = ACTIONS(2985),
    [anon_sym_switch] = ACTIONS(2985),
    [anon_sym_case] = ACTIONS(2985),
    [anon_sym_default] = ACTIONS(2985),
    [anon_sym_while] = ACTIONS(2985),
    [anon_sym_do] = ACTIONS(2985),
    [anon_sym_for] = ACTIONS(2985),
    [anon_sym_return] = ACTIONS(2985),
    [anon_sym_break] = ACTIONS(2985),
    [anon_sym_continue] = ACTIONS(2985),
    [anon_sym_goto] = ACTIONS(2985),
    [anon_sym_not] = ACTIONS(2985),
    [anon_sym_compl] = ACTIONS(2985),
    [anon_sym_DASH_DASH] = ACTIONS(2987),
    [anon_sym_PLUS_PLUS] = ACTIONS(2987),
    [anon_sym_sizeof] = ACTIONS(2985),
    [anon_sym___alignof__] = ACTIONS(2985),
    [anon_sym___alignof] = ACTIONS(2985),
    [anon_sym__alignof] = ACTIONS(2985),
    [anon_sym_alignof] = ACTIONS(2985),
    [anon_sym__Alignof] = ACTIONS(2985),
    [anon_sym_offsetof] = ACTIONS(2985),
    [anon_sym__Generic] = ACTIONS(2985),
    [anon_sym_asm] = ACTIONS(2985),
    [anon_sym___asm__] = ACTIONS(2985),
    [aux_sym_number_literal_token1] = ACTIONS(2987),
    [aux_sym_number_literal_token2] = ACTIONS(2985),
    [anon_sym_L_SQUOTE] = ACTIONS(2987),
    [anon_sym_u_SQUOTE] = ACTIONS(2987),
    [anon_sym_U_SQUOTE] = ACTIONS(2987),
    [anon_sym_u8_SQUOTE] = ACTIONS(2987),
    [anon_sym_SQUOTE] = ACTIONS(2987),
    [anon_sym_L_DQUOTE] = ACTIONS(2987),
    [anon_sym_u_DQUOTE] = ACTIONS(2987),
    [anon_sym_U_DQUOTE] = ACTIONS(2987),
    [anon_sym_u8_DQUOTE] = ACTIONS(2987),
    [anon_sym_DQUOTE] = ACTIONS(2987),
    [sym_true] = ACTIONS(2985),
    [sym_false] = ACTIONS(2985),
    [anon_sym_NULL] = ACTIONS(2985),
    [anon_sym_nullptr] = ACTIONS(2985),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2985),
    [anon_sym_decltype] = ACTIONS(2985),
    [anon_sym_virtual] = ACTIONS(2985),
    [anon_sym_alignas] = ACTIONS(2985),
    [anon_sym_explicit] = ACTIONS(2985),
    [anon_sym_typename] = ACTIONS(2985),
    [anon_sym_template] = ACTIONS(2985),
    [anon_sym_operator] = ACTIONS(2985),
    [anon_sym_try] = ACTIONS(2985),
    [anon_sym_delete] = ACTIONS(2985),
    [anon_sym_throw] = ACTIONS(2985),
    [anon_sym_namespace] = ACTIONS(2985),
    [anon_sym_using] = ACTIONS(2985),
    [anon_sym_static_assert] = ACTIONS(2985),
    [anon_sym_concept] = ACTIONS(2985),
    [anon_sym_co_return] = ACTIONS(2985),
    [anon_sym_co_yield] = ACTIONS(2985),
    [anon_sym_R_DQUOTE] = ACTIONS(2987),
    [anon_sym_LR_DQUOTE] = ACTIONS(2987),
    [anon_sym_uR_DQUOTE] = ACTIONS(2987),
    [anon_sym_UR_DQUOTE] = ACTIONS(2987),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2987),
    [anon_sym_co_await] = ACTIONS(2985),
    [anon_sym_new] = ACTIONS(2985),
    [anon_sym_requires] = ACTIONS(2985),
    [sym_this] = ACTIONS(2985),
  },
  [819] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(3868),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3440),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3440),
    [sym_call_expression] = STATE(3440),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3440),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3440),
    [sym_initializer_list] = STATE(3905),
    [sym_number_literal] = STATE(4352),
    [sym_char_literal] = STATE(4352),
    [sym_concatenated_string] = STATE(4364),
    [sym_string_literal] = STATE(3640),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3641),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3440),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3440),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1885),
    [anon_sym_COMMA] = ACTIONS(1885),
    [anon_sym_LPAREN2] = ACTIONS(1885),
    [anon_sym_BANG] = ACTIONS(3342),
    [anon_sym_TILDE] = ACTIONS(3344),
    [anon_sym_DASH] = ACTIONS(1883),
    [anon_sym_PLUS] = ACTIONS(1883),
    [anon_sym_STAR] = ACTIONS(1885),
    [anon_sym_SLASH] = ACTIONS(1883),
    [anon_sym_PERCENT] = ACTIONS(1885),
    [anon_sym_PIPE_PIPE] = ACTIONS(1885),
    [anon_sym_AMP_AMP] = ACTIONS(1885),
    [anon_sym_PIPE] = ACTIONS(1883),
    [anon_sym_CARET] = ACTIONS(1885),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym_EQ_EQ] = ACTIONS(1885),
    [anon_sym_BANG_EQ] = ACTIONS(1885),
    [anon_sym_GT] = ACTIONS(1883),
    [anon_sym_GT_EQ] = ACTIONS(1885),
    [anon_sym_LT_EQ] = ACTIONS(1883),
    [anon_sym_LT] = ACTIONS(1883),
    [anon_sym_LT_LT] = ACTIONS(1885),
    [anon_sym_GT_GT] = ACTIONS(1885),
    [anon_sym_SEMI] = ACTIONS(1885),
    [anon_sym___attribute__] = ACTIONS(1883),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(1885),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_QMARK] = ACTIONS(1885),
    [anon_sym_not] = ACTIONS(3342),
    [anon_sym_compl] = ACTIONS(3342),
    [anon_sym_LT_EQ_GT] = ACTIONS(1885),
    [anon_sym_or] = ACTIONS(1883),
    [anon_sym_and] = ACTIONS(1883),
    [anon_sym_bitor] = ACTIONS(1883),
    [anon_sym_xor] = ACTIONS(1883),
    [anon_sym_bitand] = ACTIONS(1883),
    [anon_sym_not_eq] = ACTIONS(1883),
    [anon_sym_DASH_DASH] = ACTIONS(1885),
    [anon_sym_PLUS_PLUS] = ACTIONS(1885),
    [anon_sym_sizeof] = ACTIONS(3348),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(1883),
    [anon_sym_DOT_STAR] = ACTIONS(1885),
    [anon_sym_DASH_GT] = ACTIONS(1885),
    [aux_sym_number_literal_token1] = ACTIONS(3350),
    [aux_sym_number_literal_token2] = ACTIONS(3352),
    [anon_sym_L_SQUOTE] = ACTIONS(3354),
    [anon_sym_u_SQUOTE] = ACTIONS(3354),
    [anon_sym_U_SQUOTE] = ACTIONS(3354),
    [anon_sym_u8_SQUOTE] = ACTIONS(3354),
    [anon_sym_SQUOTE] = ACTIONS(3354),
    [anon_sym_L_DQUOTE] = ACTIONS(3356),
    [anon_sym_u_DQUOTE] = ACTIONS(3356),
    [anon_sym_U_DQUOTE] = ACTIONS(3356),
    [anon_sym_u8_DQUOTE] = ACTIONS(3356),
    [anon_sym_DQUOTE] = ACTIONS(3356),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3358),
    [anon_sym_R_DQUOTE] = ACTIONS(3360),
    [anon_sym_LR_DQUOTE] = ACTIONS(3360),
    [anon_sym_uR_DQUOTE] = ACTIONS(3360),
    [anon_sym_UR_DQUOTE] = ACTIONS(3360),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3360),
    [anon_sym_co_await] = ACTIONS(3362),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [820] = {
    [sym_preproc_def] = STATE(837),
    [sym_preproc_function_def] = STATE(837),
    [sym_preproc_call] = STATE(837),
    [sym_preproc_if_in_field_declaration_list] = STATE(837),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(837),
    [sym_type_definition] = STATE(837),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(5536),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(3150),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6010),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym__field_declaration_list_item] = STATE(837),
    [sym_field_declaration] = STATE(837),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1811),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(837),
    [sym_operator_cast] = STATE(6536),
    [sym_inline_method_definition] = STATE(837),
    [sym__constructor_specifiers] = STATE(1811),
    [sym_operator_cast_definition] = STATE(837),
    [sym_operator_cast_declaration] = STATE(837),
    [sym_constructor_or_destructor_definition] = STATE(837),
    [sym_constructor_or_destructor_declaration] = STATE(837),
    [sym_friend_declaration] = STATE(837),
    [sym_access_specifier] = STATE(7802),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(2618),
    [sym_template_function] = STATE(6098),
    [sym_using_declaration] = STATE(837),
    [sym_alias_declaration] = STATE(837),
    [sym_static_assert_declaration] = STATE(837),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5301),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_qualified_operator_cast_identifier] = STATE(6536),
    [sym_operator_name] = STATE(6098),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(837),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1961),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1811),
    [sym_identifier] = ACTIONS(2823),
    [aux_sym_preproc_def_token1] = ACTIONS(3364),
    [aux_sym_preproc_if_token1] = ACTIONS(3366),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3368),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3368),
    [sym_preproc_directive] = ACTIONS(3370),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(3372),
    [anon_sym_typedef] = ACTIONS(3374),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(2853),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_RBRACE] = ACTIONS(3376),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2857),
    [anon_sym_class] = ACTIONS(2859),
    [anon_sym_struct] = ACTIONS(2861),
    [anon_sym_union] = ACTIONS(2863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(2865),
    [anon_sym_template] = ACTIONS(3378),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3380),
    [anon_sym_public] = ACTIONS(2871),
    [anon_sym_private] = ACTIONS(2871),
    [anon_sym_protected] = ACTIONS(2871),
    [anon_sym_using] = ACTIONS(3382),
    [anon_sym_static_assert] = ACTIONS(3384),
  },
  [821] = {
    [ts_builtin_sym_end] = ACTIONS(3088),
    [sym_identifier] = ACTIONS(3086),
    [aux_sym_preproc_include_token1] = ACTIONS(3086),
    [aux_sym_preproc_def_token1] = ACTIONS(3086),
    [aux_sym_preproc_if_token1] = ACTIONS(3086),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3086),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3086),
    [sym_preproc_directive] = ACTIONS(3086),
    [anon_sym_LPAREN2] = ACTIONS(3088),
    [anon_sym_BANG] = ACTIONS(3088),
    [anon_sym_TILDE] = ACTIONS(3088),
    [anon_sym_DASH] = ACTIONS(3086),
    [anon_sym_PLUS] = ACTIONS(3086),
    [anon_sym_STAR] = ACTIONS(3088),
    [anon_sym_AMP_AMP] = ACTIONS(3088),
    [anon_sym_AMP] = ACTIONS(3086),
    [anon_sym___extension__] = ACTIONS(3086),
    [anon_sym_typedef] = ACTIONS(3086),
    [anon_sym_extern] = ACTIONS(3086),
    [anon_sym___attribute__] = ACTIONS(3086),
    [anon_sym_COLON_COLON] = ACTIONS(3088),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3088),
    [anon_sym___declspec] = ACTIONS(3086),
    [anon_sym___based] = ACTIONS(3086),
    [anon_sym___cdecl] = ACTIONS(3086),
    [anon_sym___clrcall] = ACTIONS(3086),
    [anon_sym___stdcall] = ACTIONS(3086),
    [anon_sym___fastcall] = ACTIONS(3086),
    [anon_sym___thiscall] = ACTIONS(3086),
    [anon_sym___vectorcall] = ACTIONS(3086),
    [anon_sym_LBRACE] = ACTIONS(3088),
    [anon_sym_signed] = ACTIONS(3086),
    [anon_sym_unsigned] = ACTIONS(3086),
    [anon_sym_long] = ACTIONS(3086),
    [anon_sym_short] = ACTIONS(3086),
    [anon_sym_LBRACK] = ACTIONS(3086),
    [anon_sym_static] = ACTIONS(3086),
    [anon_sym_register] = ACTIONS(3086),
    [anon_sym_inline] = ACTIONS(3086),
    [anon_sym___inline] = ACTIONS(3086),
    [anon_sym___inline__] = ACTIONS(3086),
    [anon_sym___forceinline] = ACTIONS(3086),
    [anon_sym_thread_local] = ACTIONS(3086),
    [anon_sym___thread] = ACTIONS(3086),
    [anon_sym_const] = ACTIONS(3086),
    [anon_sym_constexpr] = ACTIONS(3086),
    [anon_sym_volatile] = ACTIONS(3086),
    [anon_sym_restrict] = ACTIONS(3086),
    [anon_sym___restrict__] = ACTIONS(3086),
    [anon_sym__Atomic] = ACTIONS(3086),
    [anon_sym__Noreturn] = ACTIONS(3086),
    [anon_sym_noreturn] = ACTIONS(3086),
    [anon_sym_mutable] = ACTIONS(3086),
    [anon_sym_constinit] = ACTIONS(3086),
    [anon_sym_consteval] = ACTIONS(3086),
    [anon_sym_PROGMEM] = ACTIONS(3086),
    [aux_sym_primitive_type_token1] = ACTIONS(3086),
    [anon_sym_byte] = ACTIONS(3086),
    [anon_sym_word] = ACTIONS(3086),
    [anon_sym_enum] = ACTIONS(3086),
    [anon_sym_class] = ACTIONS(3086),
    [anon_sym_struct] = ACTIONS(3086),
    [anon_sym_union] = ACTIONS(3086),
    [anon_sym_if] = ACTIONS(3086),
    [anon_sym_switch] = ACTIONS(3086),
    [anon_sym_case] = ACTIONS(3086),
    [anon_sym_default] = ACTIONS(3086),
    [anon_sym_while] = ACTIONS(3086),
    [anon_sym_do] = ACTIONS(3086),
    [anon_sym_for] = ACTIONS(3086),
    [anon_sym_return] = ACTIONS(3086),
    [anon_sym_break] = ACTIONS(3086),
    [anon_sym_continue] = ACTIONS(3086),
    [anon_sym_goto] = ACTIONS(3086),
    [anon_sym_not] = ACTIONS(3086),
    [anon_sym_compl] = ACTIONS(3086),
    [anon_sym_DASH_DASH] = ACTIONS(3088),
    [anon_sym_PLUS_PLUS] = ACTIONS(3088),
    [anon_sym_sizeof] = ACTIONS(3086),
    [anon_sym___alignof__] = ACTIONS(3086),
    [anon_sym___alignof] = ACTIONS(3086),
    [anon_sym__alignof] = ACTIONS(3086),
    [anon_sym_alignof] = ACTIONS(3086),
    [anon_sym__Alignof] = ACTIONS(3086),
    [anon_sym_offsetof] = ACTIONS(3086),
    [anon_sym__Generic] = ACTIONS(3086),
    [anon_sym_asm] = ACTIONS(3086),
    [anon_sym___asm__] = ACTIONS(3086),
    [aux_sym_number_literal_token1] = ACTIONS(3088),
    [aux_sym_number_literal_token2] = ACTIONS(3086),
    [anon_sym_L_SQUOTE] = ACTIONS(3088),
    [anon_sym_u_SQUOTE] = ACTIONS(3088),
    [anon_sym_U_SQUOTE] = ACTIONS(3088),
    [anon_sym_u8_SQUOTE] = ACTIONS(3088),
    [anon_sym_SQUOTE] = ACTIONS(3088),
    [anon_sym_L_DQUOTE] = ACTIONS(3088),
    [anon_sym_u_DQUOTE] = ACTIONS(3088),
    [anon_sym_U_DQUOTE] = ACTIONS(3088),
    [anon_sym_u8_DQUOTE] = ACTIONS(3088),
    [anon_sym_DQUOTE] = ACTIONS(3088),
    [sym_true] = ACTIONS(3086),
    [sym_false] = ACTIONS(3086),
    [anon_sym_NULL] = ACTIONS(3086),
    [anon_sym_nullptr] = ACTIONS(3086),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3086),
    [anon_sym_decltype] = ACTIONS(3086),
    [anon_sym_virtual] = ACTIONS(3086),
    [anon_sym_alignas] = ACTIONS(3086),
    [anon_sym_explicit] = ACTIONS(3086),
    [anon_sym_typename] = ACTIONS(3086),
    [anon_sym_template] = ACTIONS(3086),
    [anon_sym_operator] = ACTIONS(3086),
    [anon_sym_try] = ACTIONS(3086),
    [anon_sym_delete] = ACTIONS(3086),
    [anon_sym_throw] = ACTIONS(3086),
    [anon_sym_namespace] = ACTIONS(3086),
    [anon_sym_using] = ACTIONS(3086),
    [anon_sym_static_assert] = ACTIONS(3086),
    [anon_sym_concept] = ACTIONS(3086),
    [anon_sym_co_return] = ACTIONS(3086),
    [anon_sym_co_yield] = ACTIONS(3086),
    [anon_sym_R_DQUOTE] = ACTIONS(3088),
    [anon_sym_LR_DQUOTE] = ACTIONS(3088),
    [anon_sym_uR_DQUOTE] = ACTIONS(3088),
    [anon_sym_UR_DQUOTE] = ACTIONS(3088),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3088),
    [anon_sym_co_await] = ACTIONS(3086),
    [anon_sym_new] = ACTIONS(3086),
    [anon_sym_requires] = ACTIONS(3086),
    [sym_this] = ACTIONS(3086),
  },
  [822] = {
    [ts_builtin_sym_end] = ACTIONS(3096),
    [sym_identifier] = ACTIONS(3094),
    [aux_sym_preproc_include_token1] = ACTIONS(3094),
    [aux_sym_preproc_def_token1] = ACTIONS(3094),
    [aux_sym_preproc_if_token1] = ACTIONS(3094),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3094),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3094),
    [sym_preproc_directive] = ACTIONS(3094),
    [anon_sym_LPAREN2] = ACTIONS(3096),
    [anon_sym_BANG] = ACTIONS(3096),
    [anon_sym_TILDE] = ACTIONS(3096),
    [anon_sym_DASH] = ACTIONS(3094),
    [anon_sym_PLUS] = ACTIONS(3094),
    [anon_sym_STAR] = ACTIONS(3096),
    [anon_sym_AMP_AMP] = ACTIONS(3096),
    [anon_sym_AMP] = ACTIONS(3094),
    [anon_sym___extension__] = ACTIONS(3094),
    [anon_sym_typedef] = ACTIONS(3094),
    [anon_sym_extern] = ACTIONS(3094),
    [anon_sym___attribute__] = ACTIONS(3094),
    [anon_sym_COLON_COLON] = ACTIONS(3096),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3096),
    [anon_sym___declspec] = ACTIONS(3094),
    [anon_sym___based] = ACTIONS(3094),
    [anon_sym___cdecl] = ACTIONS(3094),
    [anon_sym___clrcall] = ACTIONS(3094),
    [anon_sym___stdcall] = ACTIONS(3094),
    [anon_sym___fastcall] = ACTIONS(3094),
    [anon_sym___thiscall] = ACTIONS(3094),
    [anon_sym___vectorcall] = ACTIONS(3094),
    [anon_sym_LBRACE] = ACTIONS(3096),
    [anon_sym_signed] = ACTIONS(3094),
    [anon_sym_unsigned] = ACTIONS(3094),
    [anon_sym_long] = ACTIONS(3094),
    [anon_sym_short] = ACTIONS(3094),
    [anon_sym_LBRACK] = ACTIONS(3094),
    [anon_sym_static] = ACTIONS(3094),
    [anon_sym_register] = ACTIONS(3094),
    [anon_sym_inline] = ACTIONS(3094),
    [anon_sym___inline] = ACTIONS(3094),
    [anon_sym___inline__] = ACTIONS(3094),
    [anon_sym___forceinline] = ACTIONS(3094),
    [anon_sym_thread_local] = ACTIONS(3094),
    [anon_sym___thread] = ACTIONS(3094),
    [anon_sym_const] = ACTIONS(3094),
    [anon_sym_constexpr] = ACTIONS(3094),
    [anon_sym_volatile] = ACTIONS(3094),
    [anon_sym_restrict] = ACTIONS(3094),
    [anon_sym___restrict__] = ACTIONS(3094),
    [anon_sym__Atomic] = ACTIONS(3094),
    [anon_sym__Noreturn] = ACTIONS(3094),
    [anon_sym_noreturn] = ACTIONS(3094),
    [anon_sym_mutable] = ACTIONS(3094),
    [anon_sym_constinit] = ACTIONS(3094),
    [anon_sym_consteval] = ACTIONS(3094),
    [anon_sym_PROGMEM] = ACTIONS(3094),
    [aux_sym_primitive_type_token1] = ACTIONS(3094),
    [anon_sym_byte] = ACTIONS(3094),
    [anon_sym_word] = ACTIONS(3094),
    [anon_sym_enum] = ACTIONS(3094),
    [anon_sym_class] = ACTIONS(3094),
    [anon_sym_struct] = ACTIONS(3094),
    [anon_sym_union] = ACTIONS(3094),
    [anon_sym_if] = ACTIONS(3094),
    [anon_sym_switch] = ACTIONS(3094),
    [anon_sym_case] = ACTIONS(3094),
    [anon_sym_default] = ACTIONS(3094),
    [anon_sym_while] = ACTIONS(3094),
    [anon_sym_do] = ACTIONS(3094),
    [anon_sym_for] = ACTIONS(3094),
    [anon_sym_return] = ACTIONS(3094),
    [anon_sym_break] = ACTIONS(3094),
    [anon_sym_continue] = ACTIONS(3094),
    [anon_sym_goto] = ACTIONS(3094),
    [anon_sym_not] = ACTIONS(3094),
    [anon_sym_compl] = ACTIONS(3094),
    [anon_sym_DASH_DASH] = ACTIONS(3096),
    [anon_sym_PLUS_PLUS] = ACTIONS(3096),
    [anon_sym_sizeof] = ACTIONS(3094),
    [anon_sym___alignof__] = ACTIONS(3094),
    [anon_sym___alignof] = ACTIONS(3094),
    [anon_sym__alignof] = ACTIONS(3094),
    [anon_sym_alignof] = ACTIONS(3094),
    [anon_sym__Alignof] = ACTIONS(3094),
    [anon_sym_offsetof] = ACTIONS(3094),
    [anon_sym__Generic] = ACTIONS(3094),
    [anon_sym_asm] = ACTIONS(3094),
    [anon_sym___asm__] = ACTIONS(3094),
    [aux_sym_number_literal_token1] = ACTIONS(3096),
    [aux_sym_number_literal_token2] = ACTIONS(3094),
    [anon_sym_L_SQUOTE] = ACTIONS(3096),
    [anon_sym_u_SQUOTE] = ACTIONS(3096),
    [anon_sym_U_SQUOTE] = ACTIONS(3096),
    [anon_sym_u8_SQUOTE] = ACTIONS(3096),
    [anon_sym_SQUOTE] = ACTIONS(3096),
    [anon_sym_L_DQUOTE] = ACTIONS(3096),
    [anon_sym_u_DQUOTE] = ACTIONS(3096),
    [anon_sym_U_DQUOTE] = ACTIONS(3096),
    [anon_sym_u8_DQUOTE] = ACTIONS(3096),
    [anon_sym_DQUOTE] = ACTIONS(3096),
    [sym_true] = ACTIONS(3094),
    [sym_false] = ACTIONS(3094),
    [anon_sym_NULL] = ACTIONS(3094),
    [anon_sym_nullptr] = ACTIONS(3094),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3094),
    [anon_sym_decltype] = ACTIONS(3094),
    [anon_sym_virtual] = ACTIONS(3094),
    [anon_sym_alignas] = ACTIONS(3094),
    [anon_sym_explicit] = ACTIONS(3094),
    [anon_sym_typename] = ACTIONS(3094),
    [anon_sym_template] = ACTIONS(3094),
    [anon_sym_operator] = ACTIONS(3094),
    [anon_sym_try] = ACTIONS(3094),
    [anon_sym_delete] = ACTIONS(3094),
    [anon_sym_throw] = ACTIONS(3094),
    [anon_sym_namespace] = ACTIONS(3094),
    [anon_sym_using] = ACTIONS(3094),
    [anon_sym_static_assert] = ACTIONS(3094),
    [anon_sym_concept] = ACTIONS(3094),
    [anon_sym_co_return] = ACTIONS(3094),
    [anon_sym_co_yield] = ACTIONS(3094),
    [anon_sym_R_DQUOTE] = ACTIONS(3096),
    [anon_sym_LR_DQUOTE] = ACTIONS(3096),
    [anon_sym_uR_DQUOTE] = ACTIONS(3096),
    [anon_sym_UR_DQUOTE] = ACTIONS(3096),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3096),
    [anon_sym_co_await] = ACTIONS(3094),
    [anon_sym_new] = ACTIONS(3094),
    [anon_sym_requires] = ACTIONS(3094),
    [sym_this] = ACTIONS(3094),
  },
  [823] = {
    [ts_builtin_sym_end] = ACTIONS(2973),
    [sym_identifier] = ACTIONS(2971),
    [aux_sym_preproc_include_token1] = ACTIONS(2971),
    [aux_sym_preproc_def_token1] = ACTIONS(2971),
    [aux_sym_preproc_if_token1] = ACTIONS(2971),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2971),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2971),
    [sym_preproc_directive] = ACTIONS(2971),
    [anon_sym_LPAREN2] = ACTIONS(2973),
    [anon_sym_BANG] = ACTIONS(2973),
    [anon_sym_TILDE] = ACTIONS(2973),
    [anon_sym_DASH] = ACTIONS(2971),
    [anon_sym_PLUS] = ACTIONS(2971),
    [anon_sym_STAR] = ACTIONS(2973),
    [anon_sym_AMP_AMP] = ACTIONS(2973),
    [anon_sym_AMP] = ACTIONS(2971),
    [anon_sym___extension__] = ACTIONS(2971),
    [anon_sym_typedef] = ACTIONS(2971),
    [anon_sym_extern] = ACTIONS(2971),
    [anon_sym___attribute__] = ACTIONS(2971),
    [anon_sym_COLON_COLON] = ACTIONS(2973),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2973),
    [anon_sym___declspec] = ACTIONS(2971),
    [anon_sym___based] = ACTIONS(2971),
    [anon_sym___cdecl] = ACTIONS(2971),
    [anon_sym___clrcall] = ACTIONS(2971),
    [anon_sym___stdcall] = ACTIONS(2971),
    [anon_sym___fastcall] = ACTIONS(2971),
    [anon_sym___thiscall] = ACTIONS(2971),
    [anon_sym___vectorcall] = ACTIONS(2971),
    [anon_sym_LBRACE] = ACTIONS(2973),
    [anon_sym_signed] = ACTIONS(2971),
    [anon_sym_unsigned] = ACTIONS(2971),
    [anon_sym_long] = ACTIONS(2971),
    [anon_sym_short] = ACTIONS(2971),
    [anon_sym_LBRACK] = ACTIONS(2971),
    [anon_sym_static] = ACTIONS(2971),
    [anon_sym_register] = ACTIONS(2971),
    [anon_sym_inline] = ACTIONS(2971),
    [anon_sym___inline] = ACTIONS(2971),
    [anon_sym___inline__] = ACTIONS(2971),
    [anon_sym___forceinline] = ACTIONS(2971),
    [anon_sym_thread_local] = ACTIONS(2971),
    [anon_sym___thread] = ACTIONS(2971),
    [anon_sym_const] = ACTIONS(2971),
    [anon_sym_constexpr] = ACTIONS(2971),
    [anon_sym_volatile] = ACTIONS(2971),
    [anon_sym_restrict] = ACTIONS(2971),
    [anon_sym___restrict__] = ACTIONS(2971),
    [anon_sym__Atomic] = ACTIONS(2971),
    [anon_sym__Noreturn] = ACTIONS(2971),
    [anon_sym_noreturn] = ACTIONS(2971),
    [anon_sym_mutable] = ACTIONS(2971),
    [anon_sym_constinit] = ACTIONS(2971),
    [anon_sym_consteval] = ACTIONS(2971),
    [anon_sym_PROGMEM] = ACTIONS(2971),
    [aux_sym_primitive_type_token1] = ACTIONS(2971),
    [anon_sym_byte] = ACTIONS(2971),
    [anon_sym_word] = ACTIONS(2971),
    [anon_sym_enum] = ACTIONS(2971),
    [anon_sym_class] = ACTIONS(2971),
    [anon_sym_struct] = ACTIONS(2971),
    [anon_sym_union] = ACTIONS(2971),
    [anon_sym_if] = ACTIONS(2971),
    [anon_sym_switch] = ACTIONS(2971),
    [anon_sym_case] = ACTIONS(2971),
    [anon_sym_default] = ACTIONS(2971),
    [anon_sym_while] = ACTIONS(2971),
    [anon_sym_do] = ACTIONS(2971),
    [anon_sym_for] = ACTIONS(2971),
    [anon_sym_return] = ACTIONS(2971),
    [anon_sym_break] = ACTIONS(2971),
    [anon_sym_continue] = ACTIONS(2971),
    [anon_sym_goto] = ACTIONS(2971),
    [anon_sym_not] = ACTIONS(2971),
    [anon_sym_compl] = ACTIONS(2971),
    [anon_sym_DASH_DASH] = ACTIONS(2973),
    [anon_sym_PLUS_PLUS] = ACTIONS(2973),
    [anon_sym_sizeof] = ACTIONS(2971),
    [anon_sym___alignof__] = ACTIONS(2971),
    [anon_sym___alignof] = ACTIONS(2971),
    [anon_sym__alignof] = ACTIONS(2971),
    [anon_sym_alignof] = ACTIONS(2971),
    [anon_sym__Alignof] = ACTIONS(2971),
    [anon_sym_offsetof] = ACTIONS(2971),
    [anon_sym__Generic] = ACTIONS(2971),
    [anon_sym_asm] = ACTIONS(2971),
    [anon_sym___asm__] = ACTIONS(2971),
    [aux_sym_number_literal_token1] = ACTIONS(2973),
    [aux_sym_number_literal_token2] = ACTIONS(2971),
    [anon_sym_L_SQUOTE] = ACTIONS(2973),
    [anon_sym_u_SQUOTE] = ACTIONS(2973),
    [anon_sym_U_SQUOTE] = ACTIONS(2973),
    [anon_sym_u8_SQUOTE] = ACTIONS(2973),
    [anon_sym_SQUOTE] = ACTIONS(2973),
    [anon_sym_L_DQUOTE] = ACTIONS(2973),
    [anon_sym_u_DQUOTE] = ACTIONS(2973),
    [anon_sym_U_DQUOTE] = ACTIONS(2973),
    [anon_sym_u8_DQUOTE] = ACTIONS(2973),
    [anon_sym_DQUOTE] = ACTIONS(2973),
    [sym_true] = ACTIONS(2971),
    [sym_false] = ACTIONS(2971),
    [anon_sym_NULL] = ACTIONS(2971),
    [anon_sym_nullptr] = ACTIONS(2971),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2971),
    [anon_sym_decltype] = ACTIONS(2971),
    [anon_sym_virtual] = ACTIONS(2971),
    [anon_sym_alignas] = ACTIONS(2971),
    [anon_sym_explicit] = ACTIONS(2971),
    [anon_sym_typename] = ACTIONS(2971),
    [anon_sym_template] = ACTIONS(2971),
    [anon_sym_operator] = ACTIONS(2971),
    [anon_sym_try] = ACTIONS(2971),
    [anon_sym_delete] = ACTIONS(2971),
    [anon_sym_throw] = ACTIONS(2971),
    [anon_sym_namespace] = ACTIONS(2971),
    [anon_sym_using] = ACTIONS(2971),
    [anon_sym_static_assert] = ACTIONS(2971),
    [anon_sym_concept] = ACTIONS(2971),
    [anon_sym_co_return] = ACTIONS(2971),
    [anon_sym_co_yield] = ACTIONS(2971),
    [anon_sym_R_DQUOTE] = ACTIONS(2973),
    [anon_sym_LR_DQUOTE] = ACTIONS(2973),
    [anon_sym_uR_DQUOTE] = ACTIONS(2973),
    [anon_sym_UR_DQUOTE] = ACTIONS(2973),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2973),
    [anon_sym_co_await] = ACTIONS(2971),
    [anon_sym_new] = ACTIONS(2971),
    [anon_sym_requires] = ACTIONS(2971),
    [sym_this] = ACTIONS(2971),
  },
  [824] = {
    [ts_builtin_sym_end] = ACTIONS(3103),
    [sym_identifier] = ACTIONS(3101),
    [aux_sym_preproc_include_token1] = ACTIONS(3101),
    [aux_sym_preproc_def_token1] = ACTIONS(3101),
    [aux_sym_preproc_if_token1] = ACTIONS(3101),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3101),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3101),
    [sym_preproc_directive] = ACTIONS(3101),
    [anon_sym_LPAREN2] = ACTIONS(3103),
    [anon_sym_BANG] = ACTIONS(3103),
    [anon_sym_TILDE] = ACTIONS(3103),
    [anon_sym_DASH] = ACTIONS(3101),
    [anon_sym_PLUS] = ACTIONS(3101),
    [anon_sym_STAR] = ACTIONS(3103),
    [anon_sym_AMP_AMP] = ACTIONS(3103),
    [anon_sym_AMP] = ACTIONS(3101),
    [anon_sym___extension__] = ACTIONS(3101),
    [anon_sym_typedef] = ACTIONS(3101),
    [anon_sym_extern] = ACTIONS(3101),
    [anon_sym___attribute__] = ACTIONS(3101),
    [anon_sym_COLON_COLON] = ACTIONS(3103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3103),
    [anon_sym___declspec] = ACTIONS(3101),
    [anon_sym___based] = ACTIONS(3101),
    [anon_sym___cdecl] = ACTIONS(3101),
    [anon_sym___clrcall] = ACTIONS(3101),
    [anon_sym___stdcall] = ACTIONS(3101),
    [anon_sym___fastcall] = ACTIONS(3101),
    [anon_sym___thiscall] = ACTIONS(3101),
    [anon_sym___vectorcall] = ACTIONS(3101),
    [anon_sym_LBRACE] = ACTIONS(3103),
    [anon_sym_signed] = ACTIONS(3101),
    [anon_sym_unsigned] = ACTIONS(3101),
    [anon_sym_long] = ACTIONS(3101),
    [anon_sym_short] = ACTIONS(3101),
    [anon_sym_LBRACK] = ACTIONS(3101),
    [anon_sym_static] = ACTIONS(3101),
    [anon_sym_register] = ACTIONS(3101),
    [anon_sym_inline] = ACTIONS(3101),
    [anon_sym___inline] = ACTIONS(3101),
    [anon_sym___inline__] = ACTIONS(3101),
    [anon_sym___forceinline] = ACTIONS(3101),
    [anon_sym_thread_local] = ACTIONS(3101),
    [anon_sym___thread] = ACTIONS(3101),
    [anon_sym_const] = ACTIONS(3101),
    [anon_sym_constexpr] = ACTIONS(3101),
    [anon_sym_volatile] = ACTIONS(3101),
    [anon_sym_restrict] = ACTIONS(3101),
    [anon_sym___restrict__] = ACTIONS(3101),
    [anon_sym__Atomic] = ACTIONS(3101),
    [anon_sym__Noreturn] = ACTIONS(3101),
    [anon_sym_noreturn] = ACTIONS(3101),
    [anon_sym_mutable] = ACTIONS(3101),
    [anon_sym_constinit] = ACTIONS(3101),
    [anon_sym_consteval] = ACTIONS(3101),
    [anon_sym_PROGMEM] = ACTIONS(3101),
    [aux_sym_primitive_type_token1] = ACTIONS(3101),
    [anon_sym_byte] = ACTIONS(3101),
    [anon_sym_word] = ACTIONS(3101),
    [anon_sym_enum] = ACTIONS(3101),
    [anon_sym_class] = ACTIONS(3101),
    [anon_sym_struct] = ACTIONS(3101),
    [anon_sym_union] = ACTIONS(3101),
    [anon_sym_if] = ACTIONS(3101),
    [anon_sym_switch] = ACTIONS(3101),
    [anon_sym_case] = ACTIONS(3101),
    [anon_sym_default] = ACTIONS(3101),
    [anon_sym_while] = ACTIONS(3101),
    [anon_sym_do] = ACTIONS(3101),
    [anon_sym_for] = ACTIONS(3101),
    [anon_sym_return] = ACTIONS(3101),
    [anon_sym_break] = ACTIONS(3101),
    [anon_sym_continue] = ACTIONS(3101),
    [anon_sym_goto] = ACTIONS(3101),
    [anon_sym_not] = ACTIONS(3101),
    [anon_sym_compl] = ACTIONS(3101),
    [anon_sym_DASH_DASH] = ACTIONS(3103),
    [anon_sym_PLUS_PLUS] = ACTIONS(3103),
    [anon_sym_sizeof] = ACTIONS(3101),
    [anon_sym___alignof__] = ACTIONS(3101),
    [anon_sym___alignof] = ACTIONS(3101),
    [anon_sym__alignof] = ACTIONS(3101),
    [anon_sym_alignof] = ACTIONS(3101),
    [anon_sym__Alignof] = ACTIONS(3101),
    [anon_sym_offsetof] = ACTIONS(3101),
    [anon_sym__Generic] = ACTIONS(3101),
    [anon_sym_asm] = ACTIONS(3101),
    [anon_sym___asm__] = ACTIONS(3101),
    [aux_sym_number_literal_token1] = ACTIONS(3103),
    [aux_sym_number_literal_token2] = ACTIONS(3101),
    [anon_sym_L_SQUOTE] = ACTIONS(3103),
    [anon_sym_u_SQUOTE] = ACTIONS(3103),
    [anon_sym_U_SQUOTE] = ACTIONS(3103),
    [anon_sym_u8_SQUOTE] = ACTIONS(3103),
    [anon_sym_SQUOTE] = ACTIONS(3103),
    [anon_sym_L_DQUOTE] = ACTIONS(3103),
    [anon_sym_u_DQUOTE] = ACTIONS(3103),
    [anon_sym_U_DQUOTE] = ACTIONS(3103),
    [anon_sym_u8_DQUOTE] = ACTIONS(3103),
    [anon_sym_DQUOTE] = ACTIONS(3103),
    [sym_true] = ACTIONS(3101),
    [sym_false] = ACTIONS(3101),
    [anon_sym_NULL] = ACTIONS(3101),
    [anon_sym_nullptr] = ACTIONS(3101),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3101),
    [anon_sym_decltype] = ACTIONS(3101),
    [anon_sym_virtual] = ACTIONS(3101),
    [anon_sym_alignas] = ACTIONS(3101),
    [anon_sym_explicit] = ACTIONS(3101),
    [anon_sym_typename] = ACTIONS(3101),
    [anon_sym_template] = ACTIONS(3101),
    [anon_sym_operator] = ACTIONS(3101),
    [anon_sym_try] = ACTIONS(3101),
    [anon_sym_delete] = ACTIONS(3101),
    [anon_sym_throw] = ACTIONS(3101),
    [anon_sym_namespace] = ACTIONS(3101),
    [anon_sym_using] = ACTIONS(3101),
    [anon_sym_static_assert] = ACTIONS(3101),
    [anon_sym_concept] = ACTIONS(3101),
    [anon_sym_co_return] = ACTIONS(3101),
    [anon_sym_co_yield] = ACTIONS(3101),
    [anon_sym_R_DQUOTE] = ACTIONS(3103),
    [anon_sym_LR_DQUOTE] = ACTIONS(3103),
    [anon_sym_uR_DQUOTE] = ACTIONS(3103),
    [anon_sym_UR_DQUOTE] = ACTIONS(3103),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3103),
    [anon_sym_co_await] = ACTIONS(3101),
    [anon_sym_new] = ACTIONS(3101),
    [anon_sym_requires] = ACTIONS(3101),
    [sym_this] = ACTIONS(3101),
  },
  [825] = {
    [ts_builtin_sym_end] = ACTIONS(3034),
    [sym_identifier] = ACTIONS(3032),
    [aux_sym_preproc_include_token1] = ACTIONS(3032),
    [aux_sym_preproc_def_token1] = ACTIONS(3032),
    [aux_sym_preproc_if_token1] = ACTIONS(3032),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3032),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3032),
    [sym_preproc_directive] = ACTIONS(3032),
    [anon_sym_LPAREN2] = ACTIONS(3034),
    [anon_sym_BANG] = ACTIONS(3034),
    [anon_sym_TILDE] = ACTIONS(3034),
    [anon_sym_DASH] = ACTIONS(3032),
    [anon_sym_PLUS] = ACTIONS(3032),
    [anon_sym_STAR] = ACTIONS(3034),
    [anon_sym_AMP_AMP] = ACTIONS(3034),
    [anon_sym_AMP] = ACTIONS(3032),
    [anon_sym___extension__] = ACTIONS(3032),
    [anon_sym_typedef] = ACTIONS(3032),
    [anon_sym_extern] = ACTIONS(3032),
    [anon_sym___attribute__] = ACTIONS(3032),
    [anon_sym_COLON_COLON] = ACTIONS(3034),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3034),
    [anon_sym___declspec] = ACTIONS(3032),
    [anon_sym___based] = ACTIONS(3032),
    [anon_sym___cdecl] = ACTIONS(3032),
    [anon_sym___clrcall] = ACTIONS(3032),
    [anon_sym___stdcall] = ACTIONS(3032),
    [anon_sym___fastcall] = ACTIONS(3032),
    [anon_sym___thiscall] = ACTIONS(3032),
    [anon_sym___vectorcall] = ACTIONS(3032),
    [anon_sym_LBRACE] = ACTIONS(3034),
    [anon_sym_signed] = ACTIONS(3032),
    [anon_sym_unsigned] = ACTIONS(3032),
    [anon_sym_long] = ACTIONS(3032),
    [anon_sym_short] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(3032),
    [anon_sym_static] = ACTIONS(3032),
    [anon_sym_register] = ACTIONS(3032),
    [anon_sym_inline] = ACTIONS(3032),
    [anon_sym___inline] = ACTIONS(3032),
    [anon_sym___inline__] = ACTIONS(3032),
    [anon_sym___forceinline] = ACTIONS(3032),
    [anon_sym_thread_local] = ACTIONS(3032),
    [anon_sym___thread] = ACTIONS(3032),
    [anon_sym_const] = ACTIONS(3032),
    [anon_sym_constexpr] = ACTIONS(3032),
    [anon_sym_volatile] = ACTIONS(3032),
    [anon_sym_restrict] = ACTIONS(3032),
    [anon_sym___restrict__] = ACTIONS(3032),
    [anon_sym__Atomic] = ACTIONS(3032),
    [anon_sym__Noreturn] = ACTIONS(3032),
    [anon_sym_noreturn] = ACTIONS(3032),
    [anon_sym_mutable] = ACTIONS(3032),
    [anon_sym_constinit] = ACTIONS(3032),
    [anon_sym_consteval] = ACTIONS(3032),
    [anon_sym_PROGMEM] = ACTIONS(3032),
    [aux_sym_primitive_type_token1] = ACTIONS(3032),
    [anon_sym_byte] = ACTIONS(3032),
    [anon_sym_word] = ACTIONS(3032),
    [anon_sym_enum] = ACTIONS(3032),
    [anon_sym_class] = ACTIONS(3032),
    [anon_sym_struct] = ACTIONS(3032),
    [anon_sym_union] = ACTIONS(3032),
    [anon_sym_if] = ACTIONS(3032),
    [anon_sym_switch] = ACTIONS(3032),
    [anon_sym_case] = ACTIONS(3032),
    [anon_sym_default] = ACTIONS(3032),
    [anon_sym_while] = ACTIONS(3032),
    [anon_sym_do] = ACTIONS(3032),
    [anon_sym_for] = ACTIONS(3032),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_break] = ACTIONS(3032),
    [anon_sym_continue] = ACTIONS(3032),
    [anon_sym_goto] = ACTIONS(3032),
    [anon_sym_not] = ACTIONS(3032),
    [anon_sym_compl] = ACTIONS(3032),
    [anon_sym_DASH_DASH] = ACTIONS(3034),
    [anon_sym_PLUS_PLUS] = ACTIONS(3034),
    [anon_sym_sizeof] = ACTIONS(3032),
    [anon_sym___alignof__] = ACTIONS(3032),
    [anon_sym___alignof] = ACTIONS(3032),
    [anon_sym__alignof] = ACTIONS(3032),
    [anon_sym_alignof] = ACTIONS(3032),
    [anon_sym__Alignof] = ACTIONS(3032),
    [anon_sym_offsetof] = ACTIONS(3032),
    [anon_sym__Generic] = ACTIONS(3032),
    [anon_sym_asm] = ACTIONS(3032),
    [anon_sym___asm__] = ACTIONS(3032),
    [aux_sym_number_literal_token1] = ACTIONS(3034),
    [aux_sym_number_literal_token2] = ACTIONS(3032),
    [anon_sym_L_SQUOTE] = ACTIONS(3034),
    [anon_sym_u_SQUOTE] = ACTIONS(3034),
    [anon_sym_U_SQUOTE] = ACTIONS(3034),
    [anon_sym_u8_SQUOTE] = ACTIONS(3034),
    [anon_sym_SQUOTE] = ACTIONS(3034),
    [anon_sym_L_DQUOTE] = ACTIONS(3034),
    [anon_sym_u_DQUOTE] = ACTIONS(3034),
    [anon_sym_U_DQUOTE] = ACTIONS(3034),
    [anon_sym_u8_DQUOTE] = ACTIONS(3034),
    [anon_sym_DQUOTE] = ACTIONS(3034),
    [sym_true] = ACTIONS(3032),
    [sym_false] = ACTIONS(3032),
    [anon_sym_NULL] = ACTIONS(3032),
    [anon_sym_nullptr] = ACTIONS(3032),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3032),
    [anon_sym_decltype] = ACTIONS(3032),
    [anon_sym_virtual] = ACTIONS(3032),
    [anon_sym_alignas] = ACTIONS(3032),
    [anon_sym_explicit] = ACTIONS(3032),
    [anon_sym_typename] = ACTIONS(3032),
    [anon_sym_template] = ACTIONS(3032),
    [anon_sym_operator] = ACTIONS(3032),
    [anon_sym_try] = ACTIONS(3032),
    [anon_sym_delete] = ACTIONS(3032),
    [anon_sym_throw] = ACTIONS(3032),
    [anon_sym_namespace] = ACTIONS(3032),
    [anon_sym_using] = ACTIONS(3032),
    [anon_sym_static_assert] = ACTIONS(3032),
    [anon_sym_concept] = ACTIONS(3032),
    [anon_sym_co_return] = ACTIONS(3032),
    [anon_sym_co_yield] = ACTIONS(3032),
    [anon_sym_R_DQUOTE] = ACTIONS(3034),
    [anon_sym_LR_DQUOTE] = ACTIONS(3034),
    [anon_sym_uR_DQUOTE] = ACTIONS(3034),
    [anon_sym_UR_DQUOTE] = ACTIONS(3034),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3034),
    [anon_sym_co_await] = ACTIONS(3032),
    [anon_sym_new] = ACTIONS(3032),
    [anon_sym_requires] = ACTIONS(3032),
    [sym_this] = ACTIONS(3032),
  },
  [826] = {
    [ts_builtin_sym_end] = ACTIONS(3004),
    [sym_identifier] = ACTIONS(3002),
    [aux_sym_preproc_include_token1] = ACTIONS(3002),
    [aux_sym_preproc_def_token1] = ACTIONS(3002),
    [aux_sym_preproc_if_token1] = ACTIONS(3002),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3002),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3002),
    [sym_preproc_directive] = ACTIONS(3002),
    [anon_sym_LPAREN2] = ACTIONS(3004),
    [anon_sym_BANG] = ACTIONS(3004),
    [anon_sym_TILDE] = ACTIONS(3004),
    [anon_sym_DASH] = ACTIONS(3002),
    [anon_sym_PLUS] = ACTIONS(3002),
    [anon_sym_STAR] = ACTIONS(3004),
    [anon_sym_AMP_AMP] = ACTIONS(3004),
    [anon_sym_AMP] = ACTIONS(3002),
    [anon_sym___extension__] = ACTIONS(3002),
    [anon_sym_typedef] = ACTIONS(3002),
    [anon_sym_extern] = ACTIONS(3002),
    [anon_sym___attribute__] = ACTIONS(3002),
    [anon_sym_COLON_COLON] = ACTIONS(3004),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3004),
    [anon_sym___declspec] = ACTIONS(3002),
    [anon_sym___based] = ACTIONS(3002),
    [anon_sym___cdecl] = ACTIONS(3002),
    [anon_sym___clrcall] = ACTIONS(3002),
    [anon_sym___stdcall] = ACTIONS(3002),
    [anon_sym___fastcall] = ACTIONS(3002),
    [anon_sym___thiscall] = ACTIONS(3002),
    [anon_sym___vectorcall] = ACTIONS(3002),
    [anon_sym_LBRACE] = ACTIONS(3004),
    [anon_sym_signed] = ACTIONS(3002),
    [anon_sym_unsigned] = ACTIONS(3002),
    [anon_sym_long] = ACTIONS(3002),
    [anon_sym_short] = ACTIONS(3002),
    [anon_sym_LBRACK] = ACTIONS(3002),
    [anon_sym_static] = ACTIONS(3002),
    [anon_sym_register] = ACTIONS(3002),
    [anon_sym_inline] = ACTIONS(3002),
    [anon_sym___inline] = ACTIONS(3002),
    [anon_sym___inline__] = ACTIONS(3002),
    [anon_sym___forceinline] = ACTIONS(3002),
    [anon_sym_thread_local] = ACTIONS(3002),
    [anon_sym___thread] = ACTIONS(3002),
    [anon_sym_const] = ACTIONS(3002),
    [anon_sym_constexpr] = ACTIONS(3002),
    [anon_sym_volatile] = ACTIONS(3002),
    [anon_sym_restrict] = ACTIONS(3002),
    [anon_sym___restrict__] = ACTIONS(3002),
    [anon_sym__Atomic] = ACTIONS(3002),
    [anon_sym__Noreturn] = ACTIONS(3002),
    [anon_sym_noreturn] = ACTIONS(3002),
    [anon_sym_mutable] = ACTIONS(3002),
    [anon_sym_constinit] = ACTIONS(3002),
    [anon_sym_consteval] = ACTIONS(3002),
    [anon_sym_PROGMEM] = ACTIONS(3002),
    [aux_sym_primitive_type_token1] = ACTIONS(3002),
    [anon_sym_byte] = ACTIONS(3002),
    [anon_sym_word] = ACTIONS(3002),
    [anon_sym_enum] = ACTIONS(3002),
    [anon_sym_class] = ACTIONS(3002),
    [anon_sym_struct] = ACTIONS(3002),
    [anon_sym_union] = ACTIONS(3002),
    [anon_sym_if] = ACTIONS(3002),
    [anon_sym_switch] = ACTIONS(3002),
    [anon_sym_case] = ACTIONS(3002),
    [anon_sym_default] = ACTIONS(3002),
    [anon_sym_while] = ACTIONS(3002),
    [anon_sym_do] = ACTIONS(3002),
    [anon_sym_for] = ACTIONS(3002),
    [anon_sym_return] = ACTIONS(3002),
    [anon_sym_break] = ACTIONS(3002),
    [anon_sym_continue] = ACTIONS(3002),
    [anon_sym_goto] = ACTIONS(3002),
    [anon_sym_not] = ACTIONS(3002),
    [anon_sym_compl] = ACTIONS(3002),
    [anon_sym_DASH_DASH] = ACTIONS(3004),
    [anon_sym_PLUS_PLUS] = ACTIONS(3004),
    [anon_sym_sizeof] = ACTIONS(3002),
    [anon_sym___alignof__] = ACTIONS(3002),
    [anon_sym___alignof] = ACTIONS(3002),
    [anon_sym__alignof] = ACTIONS(3002),
    [anon_sym_alignof] = ACTIONS(3002),
    [anon_sym__Alignof] = ACTIONS(3002),
    [anon_sym_offsetof] = ACTIONS(3002),
    [anon_sym__Generic] = ACTIONS(3002),
    [anon_sym_asm] = ACTIONS(3002),
    [anon_sym___asm__] = ACTIONS(3002),
    [aux_sym_number_literal_token1] = ACTIONS(3004),
    [aux_sym_number_literal_token2] = ACTIONS(3002),
    [anon_sym_L_SQUOTE] = ACTIONS(3004),
    [anon_sym_u_SQUOTE] = ACTIONS(3004),
    [anon_sym_U_SQUOTE] = ACTIONS(3004),
    [anon_sym_u8_SQUOTE] = ACTIONS(3004),
    [anon_sym_SQUOTE] = ACTIONS(3004),
    [anon_sym_L_DQUOTE] = ACTIONS(3004),
    [anon_sym_u_DQUOTE] = ACTIONS(3004),
    [anon_sym_U_DQUOTE] = ACTIONS(3004),
    [anon_sym_u8_DQUOTE] = ACTIONS(3004),
    [anon_sym_DQUOTE] = ACTIONS(3004),
    [sym_true] = ACTIONS(3002),
    [sym_false] = ACTIONS(3002),
    [anon_sym_NULL] = ACTIONS(3002),
    [anon_sym_nullptr] = ACTIONS(3002),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3002),
    [anon_sym_decltype] = ACTIONS(3002),
    [anon_sym_virtual] = ACTIONS(3002),
    [anon_sym_alignas] = ACTIONS(3002),
    [anon_sym_explicit] = ACTIONS(3002),
    [anon_sym_typename] = ACTIONS(3002),
    [anon_sym_template] = ACTIONS(3002),
    [anon_sym_operator] = ACTIONS(3002),
    [anon_sym_try] = ACTIONS(3002),
    [anon_sym_delete] = ACTIONS(3002),
    [anon_sym_throw] = ACTIONS(3002),
    [anon_sym_namespace] = ACTIONS(3002),
    [anon_sym_using] = ACTIONS(3002),
    [anon_sym_static_assert] = ACTIONS(3002),
    [anon_sym_concept] = ACTIONS(3002),
    [anon_sym_co_return] = ACTIONS(3002),
    [anon_sym_co_yield] = ACTIONS(3002),
    [anon_sym_R_DQUOTE] = ACTIONS(3004),
    [anon_sym_LR_DQUOTE] = ACTIONS(3004),
    [anon_sym_uR_DQUOTE] = ACTIONS(3004),
    [anon_sym_UR_DQUOTE] = ACTIONS(3004),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3004),
    [anon_sym_co_await] = ACTIONS(3002),
    [anon_sym_new] = ACTIONS(3002),
    [anon_sym_requires] = ACTIONS(3002),
    [sym_this] = ACTIONS(3002),
  },
  [827] = {
    [ts_builtin_sym_end] = ACTIONS(3014),
    [sym_identifier] = ACTIONS(3012),
    [aux_sym_preproc_include_token1] = ACTIONS(3012),
    [aux_sym_preproc_def_token1] = ACTIONS(3012),
    [aux_sym_preproc_if_token1] = ACTIONS(3012),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3012),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3012),
    [sym_preproc_directive] = ACTIONS(3012),
    [anon_sym_LPAREN2] = ACTIONS(3014),
    [anon_sym_BANG] = ACTIONS(3014),
    [anon_sym_TILDE] = ACTIONS(3014),
    [anon_sym_DASH] = ACTIONS(3012),
    [anon_sym_PLUS] = ACTIONS(3012),
    [anon_sym_STAR] = ACTIONS(3014),
    [anon_sym_AMP_AMP] = ACTIONS(3014),
    [anon_sym_AMP] = ACTIONS(3012),
    [anon_sym___extension__] = ACTIONS(3012),
    [anon_sym_typedef] = ACTIONS(3012),
    [anon_sym_extern] = ACTIONS(3012),
    [anon_sym___attribute__] = ACTIONS(3012),
    [anon_sym_COLON_COLON] = ACTIONS(3014),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3014),
    [anon_sym___declspec] = ACTIONS(3012),
    [anon_sym___based] = ACTIONS(3012),
    [anon_sym___cdecl] = ACTIONS(3012),
    [anon_sym___clrcall] = ACTIONS(3012),
    [anon_sym___stdcall] = ACTIONS(3012),
    [anon_sym___fastcall] = ACTIONS(3012),
    [anon_sym___thiscall] = ACTIONS(3012),
    [anon_sym___vectorcall] = ACTIONS(3012),
    [anon_sym_LBRACE] = ACTIONS(3014),
    [anon_sym_signed] = ACTIONS(3012),
    [anon_sym_unsigned] = ACTIONS(3012),
    [anon_sym_long] = ACTIONS(3012),
    [anon_sym_short] = ACTIONS(3012),
    [anon_sym_LBRACK] = ACTIONS(3012),
    [anon_sym_static] = ACTIONS(3012),
    [anon_sym_register] = ACTIONS(3012),
    [anon_sym_inline] = ACTIONS(3012),
    [anon_sym___inline] = ACTIONS(3012),
    [anon_sym___inline__] = ACTIONS(3012),
    [anon_sym___forceinline] = ACTIONS(3012),
    [anon_sym_thread_local] = ACTIONS(3012),
    [anon_sym___thread] = ACTIONS(3012),
    [anon_sym_const] = ACTIONS(3012),
    [anon_sym_constexpr] = ACTIONS(3012),
    [anon_sym_volatile] = ACTIONS(3012),
    [anon_sym_restrict] = ACTIONS(3012),
    [anon_sym___restrict__] = ACTIONS(3012),
    [anon_sym__Atomic] = ACTIONS(3012),
    [anon_sym__Noreturn] = ACTIONS(3012),
    [anon_sym_noreturn] = ACTIONS(3012),
    [anon_sym_mutable] = ACTIONS(3012),
    [anon_sym_constinit] = ACTIONS(3012),
    [anon_sym_consteval] = ACTIONS(3012),
    [anon_sym_PROGMEM] = ACTIONS(3012),
    [aux_sym_primitive_type_token1] = ACTIONS(3012),
    [anon_sym_byte] = ACTIONS(3012),
    [anon_sym_word] = ACTIONS(3012),
    [anon_sym_enum] = ACTIONS(3012),
    [anon_sym_class] = ACTIONS(3012),
    [anon_sym_struct] = ACTIONS(3012),
    [anon_sym_union] = ACTIONS(3012),
    [anon_sym_if] = ACTIONS(3012),
    [anon_sym_switch] = ACTIONS(3012),
    [anon_sym_case] = ACTIONS(3012),
    [anon_sym_default] = ACTIONS(3012),
    [anon_sym_while] = ACTIONS(3012),
    [anon_sym_do] = ACTIONS(3012),
    [anon_sym_for] = ACTIONS(3012),
    [anon_sym_return] = ACTIONS(3012),
    [anon_sym_break] = ACTIONS(3012),
    [anon_sym_continue] = ACTIONS(3012),
    [anon_sym_goto] = ACTIONS(3012),
    [anon_sym_not] = ACTIONS(3012),
    [anon_sym_compl] = ACTIONS(3012),
    [anon_sym_DASH_DASH] = ACTIONS(3014),
    [anon_sym_PLUS_PLUS] = ACTIONS(3014),
    [anon_sym_sizeof] = ACTIONS(3012),
    [anon_sym___alignof__] = ACTIONS(3012),
    [anon_sym___alignof] = ACTIONS(3012),
    [anon_sym__alignof] = ACTIONS(3012),
    [anon_sym_alignof] = ACTIONS(3012),
    [anon_sym__Alignof] = ACTIONS(3012),
    [anon_sym_offsetof] = ACTIONS(3012),
    [anon_sym__Generic] = ACTIONS(3012),
    [anon_sym_asm] = ACTIONS(3012),
    [anon_sym___asm__] = ACTIONS(3012),
    [aux_sym_number_literal_token1] = ACTIONS(3014),
    [aux_sym_number_literal_token2] = ACTIONS(3012),
    [anon_sym_L_SQUOTE] = ACTIONS(3014),
    [anon_sym_u_SQUOTE] = ACTIONS(3014),
    [anon_sym_U_SQUOTE] = ACTIONS(3014),
    [anon_sym_u8_SQUOTE] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [anon_sym_L_DQUOTE] = ACTIONS(3014),
    [anon_sym_u_DQUOTE] = ACTIONS(3014),
    [anon_sym_U_DQUOTE] = ACTIONS(3014),
    [anon_sym_u8_DQUOTE] = ACTIONS(3014),
    [anon_sym_DQUOTE] = ACTIONS(3014),
    [sym_true] = ACTIONS(3012),
    [sym_false] = ACTIONS(3012),
    [anon_sym_NULL] = ACTIONS(3012),
    [anon_sym_nullptr] = ACTIONS(3012),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3012),
    [anon_sym_decltype] = ACTIONS(3012),
    [anon_sym_virtual] = ACTIONS(3012),
    [anon_sym_alignas] = ACTIONS(3012),
    [anon_sym_explicit] = ACTIONS(3012),
    [anon_sym_typename] = ACTIONS(3012),
    [anon_sym_template] = ACTIONS(3012),
    [anon_sym_operator] = ACTIONS(3012),
    [anon_sym_try] = ACTIONS(3012),
    [anon_sym_delete] = ACTIONS(3012),
    [anon_sym_throw] = ACTIONS(3012),
    [anon_sym_namespace] = ACTIONS(3012),
    [anon_sym_using] = ACTIONS(3012),
    [anon_sym_static_assert] = ACTIONS(3012),
    [anon_sym_concept] = ACTIONS(3012),
    [anon_sym_co_return] = ACTIONS(3012),
    [anon_sym_co_yield] = ACTIONS(3012),
    [anon_sym_R_DQUOTE] = ACTIONS(3014),
    [anon_sym_LR_DQUOTE] = ACTIONS(3014),
    [anon_sym_uR_DQUOTE] = ACTIONS(3014),
    [anon_sym_UR_DQUOTE] = ACTIONS(3014),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3014),
    [anon_sym_co_await] = ACTIONS(3012),
    [anon_sym_new] = ACTIONS(3012),
    [anon_sym_requires] = ACTIONS(3012),
    [sym_this] = ACTIONS(3012),
  },
  [828] = {
    [ts_builtin_sym_end] = ACTIONS(3018),
    [sym_identifier] = ACTIONS(3016),
    [aux_sym_preproc_include_token1] = ACTIONS(3016),
    [aux_sym_preproc_def_token1] = ACTIONS(3016),
    [aux_sym_preproc_if_token1] = ACTIONS(3016),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3016),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3016),
    [sym_preproc_directive] = ACTIONS(3016),
    [anon_sym_LPAREN2] = ACTIONS(3018),
    [anon_sym_BANG] = ACTIONS(3018),
    [anon_sym_TILDE] = ACTIONS(3018),
    [anon_sym_DASH] = ACTIONS(3016),
    [anon_sym_PLUS] = ACTIONS(3016),
    [anon_sym_STAR] = ACTIONS(3018),
    [anon_sym_AMP_AMP] = ACTIONS(3018),
    [anon_sym_AMP] = ACTIONS(3016),
    [anon_sym___extension__] = ACTIONS(3016),
    [anon_sym_typedef] = ACTIONS(3016),
    [anon_sym_extern] = ACTIONS(3016),
    [anon_sym___attribute__] = ACTIONS(3016),
    [anon_sym_COLON_COLON] = ACTIONS(3018),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3018),
    [anon_sym___declspec] = ACTIONS(3016),
    [anon_sym___based] = ACTIONS(3016),
    [anon_sym___cdecl] = ACTIONS(3016),
    [anon_sym___clrcall] = ACTIONS(3016),
    [anon_sym___stdcall] = ACTIONS(3016),
    [anon_sym___fastcall] = ACTIONS(3016),
    [anon_sym___thiscall] = ACTIONS(3016),
    [anon_sym___vectorcall] = ACTIONS(3016),
    [anon_sym_LBRACE] = ACTIONS(3018),
    [anon_sym_signed] = ACTIONS(3016),
    [anon_sym_unsigned] = ACTIONS(3016),
    [anon_sym_long] = ACTIONS(3016),
    [anon_sym_short] = ACTIONS(3016),
    [anon_sym_LBRACK] = ACTIONS(3016),
    [anon_sym_static] = ACTIONS(3016),
    [anon_sym_register] = ACTIONS(3016),
    [anon_sym_inline] = ACTIONS(3016),
    [anon_sym___inline] = ACTIONS(3016),
    [anon_sym___inline__] = ACTIONS(3016),
    [anon_sym___forceinline] = ACTIONS(3016),
    [anon_sym_thread_local] = ACTIONS(3016),
    [anon_sym___thread] = ACTIONS(3016),
    [anon_sym_const] = ACTIONS(3016),
    [anon_sym_constexpr] = ACTIONS(3016),
    [anon_sym_volatile] = ACTIONS(3016),
    [anon_sym_restrict] = ACTIONS(3016),
    [anon_sym___restrict__] = ACTIONS(3016),
    [anon_sym__Atomic] = ACTIONS(3016),
    [anon_sym__Noreturn] = ACTIONS(3016),
    [anon_sym_noreturn] = ACTIONS(3016),
    [anon_sym_mutable] = ACTIONS(3016),
    [anon_sym_constinit] = ACTIONS(3016),
    [anon_sym_consteval] = ACTIONS(3016),
    [anon_sym_PROGMEM] = ACTIONS(3016),
    [aux_sym_primitive_type_token1] = ACTIONS(3016),
    [anon_sym_byte] = ACTIONS(3016),
    [anon_sym_word] = ACTIONS(3016),
    [anon_sym_enum] = ACTIONS(3016),
    [anon_sym_class] = ACTIONS(3016),
    [anon_sym_struct] = ACTIONS(3016),
    [anon_sym_union] = ACTIONS(3016),
    [anon_sym_if] = ACTIONS(3016),
    [anon_sym_switch] = ACTIONS(3016),
    [anon_sym_case] = ACTIONS(3016),
    [anon_sym_default] = ACTIONS(3016),
    [anon_sym_while] = ACTIONS(3016),
    [anon_sym_do] = ACTIONS(3016),
    [anon_sym_for] = ACTIONS(3016),
    [anon_sym_return] = ACTIONS(3016),
    [anon_sym_break] = ACTIONS(3016),
    [anon_sym_continue] = ACTIONS(3016),
    [anon_sym_goto] = ACTIONS(3016),
    [anon_sym_not] = ACTIONS(3016),
    [anon_sym_compl] = ACTIONS(3016),
    [anon_sym_DASH_DASH] = ACTIONS(3018),
    [anon_sym_PLUS_PLUS] = ACTIONS(3018),
    [anon_sym_sizeof] = ACTIONS(3016),
    [anon_sym___alignof__] = ACTIONS(3016),
    [anon_sym___alignof] = ACTIONS(3016),
    [anon_sym__alignof] = ACTIONS(3016),
    [anon_sym_alignof] = ACTIONS(3016),
    [anon_sym__Alignof] = ACTIONS(3016),
    [anon_sym_offsetof] = ACTIONS(3016),
    [anon_sym__Generic] = ACTIONS(3016),
    [anon_sym_asm] = ACTIONS(3016),
    [anon_sym___asm__] = ACTIONS(3016),
    [aux_sym_number_literal_token1] = ACTIONS(3018),
    [aux_sym_number_literal_token2] = ACTIONS(3016),
    [anon_sym_L_SQUOTE] = ACTIONS(3018),
    [anon_sym_u_SQUOTE] = ACTIONS(3018),
    [anon_sym_U_SQUOTE] = ACTIONS(3018),
    [anon_sym_u8_SQUOTE] = ACTIONS(3018),
    [anon_sym_SQUOTE] = ACTIONS(3018),
    [anon_sym_L_DQUOTE] = ACTIONS(3018),
    [anon_sym_u_DQUOTE] = ACTIONS(3018),
    [anon_sym_U_DQUOTE] = ACTIONS(3018),
    [anon_sym_u8_DQUOTE] = ACTIONS(3018),
    [anon_sym_DQUOTE] = ACTIONS(3018),
    [sym_true] = ACTIONS(3016),
    [sym_false] = ACTIONS(3016),
    [anon_sym_NULL] = ACTIONS(3016),
    [anon_sym_nullptr] = ACTIONS(3016),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3016),
    [anon_sym_decltype] = ACTIONS(3016),
    [anon_sym_virtual] = ACTIONS(3016),
    [anon_sym_alignas] = ACTIONS(3016),
    [anon_sym_explicit] = ACTIONS(3016),
    [anon_sym_typename] = ACTIONS(3016),
    [anon_sym_template] = ACTIONS(3016),
    [anon_sym_operator] = ACTIONS(3016),
    [anon_sym_try] = ACTIONS(3016),
    [anon_sym_delete] = ACTIONS(3016),
    [anon_sym_throw] = ACTIONS(3016),
    [anon_sym_namespace] = ACTIONS(3016),
    [anon_sym_using] = ACTIONS(3016),
    [anon_sym_static_assert] = ACTIONS(3016),
    [anon_sym_concept] = ACTIONS(3016),
    [anon_sym_co_return] = ACTIONS(3016),
    [anon_sym_co_yield] = ACTIONS(3016),
    [anon_sym_R_DQUOTE] = ACTIONS(3018),
    [anon_sym_LR_DQUOTE] = ACTIONS(3018),
    [anon_sym_uR_DQUOTE] = ACTIONS(3018),
    [anon_sym_UR_DQUOTE] = ACTIONS(3018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3018),
    [anon_sym_co_await] = ACTIONS(3016),
    [anon_sym_new] = ACTIONS(3016),
    [anon_sym_requires] = ACTIONS(3016),
    [sym_this] = ACTIONS(3016),
  },
  [829] = {
    [sym_preproc_def] = STATE(839),
    [sym_preproc_function_def] = STATE(839),
    [sym_preproc_call] = STATE(839),
    [sym_preproc_if_in_field_declaration_list] = STATE(839),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(839),
    [sym_type_definition] = STATE(839),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(5543),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(3150),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6014),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym__field_declaration_list_item] = STATE(839),
    [sym_field_declaration] = STATE(839),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1892),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(839),
    [sym_operator_cast] = STATE(6512),
    [sym_inline_method_definition] = STATE(839),
    [sym__constructor_specifiers] = STATE(1892),
    [sym_operator_cast_definition] = STATE(839),
    [sym_operator_cast_declaration] = STATE(839),
    [sym_constructor_or_destructor_definition] = STATE(839),
    [sym_constructor_or_destructor_declaration] = STATE(839),
    [sym_friend_declaration] = STATE(839),
    [sym_access_specifier] = STATE(7720),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(2618),
    [sym_template_function] = STATE(6098),
    [sym_using_declaration] = STATE(839),
    [sym_alias_declaration] = STATE(839),
    [sym_static_assert_declaration] = STATE(839),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5301),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_qualified_operator_cast_identifier] = STATE(6512),
    [sym_operator_name] = STATE(6098),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(839),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1961),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1892),
    [sym_identifier] = ACTIONS(2823),
    [aux_sym_preproc_def_token1] = ACTIONS(3386),
    [aux_sym_preproc_if_token1] = ACTIONS(3388),
    [aux_sym_preproc_if_token2] = ACTIONS(3390),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3392),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3392),
    [sym_preproc_directive] = ACTIONS(3394),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(3396),
    [anon_sym_typedef] = ACTIONS(3398),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(2853),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2857),
    [anon_sym_class] = ACTIONS(2859),
    [anon_sym_struct] = ACTIONS(2861),
    [anon_sym_union] = ACTIONS(2863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(2865),
    [anon_sym_template] = ACTIONS(3400),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3402),
    [anon_sym_public] = ACTIONS(2871),
    [anon_sym_private] = ACTIONS(2871),
    [anon_sym_protected] = ACTIONS(2871),
    [anon_sym_using] = ACTIONS(3404),
    [anon_sym_static_assert] = ACTIONS(3406),
  },
  [830] = {
    [ts_builtin_sym_end] = ACTIONS(3092),
    [sym_identifier] = ACTIONS(3090),
    [aux_sym_preproc_include_token1] = ACTIONS(3090),
    [aux_sym_preproc_def_token1] = ACTIONS(3090),
    [aux_sym_preproc_if_token1] = ACTIONS(3090),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3090),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3090),
    [sym_preproc_directive] = ACTIONS(3090),
    [anon_sym_LPAREN2] = ACTIONS(3092),
    [anon_sym_BANG] = ACTIONS(3092),
    [anon_sym_TILDE] = ACTIONS(3092),
    [anon_sym_DASH] = ACTIONS(3090),
    [anon_sym_PLUS] = ACTIONS(3090),
    [anon_sym_STAR] = ACTIONS(3092),
    [anon_sym_AMP_AMP] = ACTIONS(3092),
    [anon_sym_AMP] = ACTIONS(3090),
    [anon_sym___extension__] = ACTIONS(3090),
    [anon_sym_typedef] = ACTIONS(3090),
    [anon_sym_extern] = ACTIONS(3090),
    [anon_sym___attribute__] = ACTIONS(3090),
    [anon_sym_COLON_COLON] = ACTIONS(3092),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3092),
    [anon_sym___declspec] = ACTIONS(3090),
    [anon_sym___based] = ACTIONS(3090),
    [anon_sym___cdecl] = ACTIONS(3090),
    [anon_sym___clrcall] = ACTIONS(3090),
    [anon_sym___stdcall] = ACTIONS(3090),
    [anon_sym___fastcall] = ACTIONS(3090),
    [anon_sym___thiscall] = ACTIONS(3090),
    [anon_sym___vectorcall] = ACTIONS(3090),
    [anon_sym_LBRACE] = ACTIONS(3092),
    [anon_sym_signed] = ACTIONS(3090),
    [anon_sym_unsigned] = ACTIONS(3090),
    [anon_sym_long] = ACTIONS(3090),
    [anon_sym_short] = ACTIONS(3090),
    [anon_sym_LBRACK] = ACTIONS(3090),
    [anon_sym_static] = ACTIONS(3090),
    [anon_sym_register] = ACTIONS(3090),
    [anon_sym_inline] = ACTIONS(3090),
    [anon_sym___inline] = ACTIONS(3090),
    [anon_sym___inline__] = ACTIONS(3090),
    [anon_sym___forceinline] = ACTIONS(3090),
    [anon_sym_thread_local] = ACTIONS(3090),
    [anon_sym___thread] = ACTIONS(3090),
    [anon_sym_const] = ACTIONS(3090),
    [anon_sym_constexpr] = ACTIONS(3090),
    [anon_sym_volatile] = ACTIONS(3090),
    [anon_sym_restrict] = ACTIONS(3090),
    [anon_sym___restrict__] = ACTIONS(3090),
    [anon_sym__Atomic] = ACTIONS(3090),
    [anon_sym__Noreturn] = ACTIONS(3090),
    [anon_sym_noreturn] = ACTIONS(3090),
    [anon_sym_mutable] = ACTIONS(3090),
    [anon_sym_constinit] = ACTIONS(3090),
    [anon_sym_consteval] = ACTIONS(3090),
    [anon_sym_PROGMEM] = ACTIONS(3090),
    [aux_sym_primitive_type_token1] = ACTIONS(3090),
    [anon_sym_byte] = ACTIONS(3090),
    [anon_sym_word] = ACTIONS(3090),
    [anon_sym_enum] = ACTIONS(3090),
    [anon_sym_class] = ACTIONS(3090),
    [anon_sym_struct] = ACTIONS(3090),
    [anon_sym_union] = ACTIONS(3090),
    [anon_sym_if] = ACTIONS(3090),
    [anon_sym_switch] = ACTIONS(3090),
    [anon_sym_case] = ACTIONS(3090),
    [anon_sym_default] = ACTIONS(3090),
    [anon_sym_while] = ACTIONS(3090),
    [anon_sym_do] = ACTIONS(3090),
    [anon_sym_for] = ACTIONS(3090),
    [anon_sym_return] = ACTIONS(3090),
    [anon_sym_break] = ACTIONS(3090),
    [anon_sym_continue] = ACTIONS(3090),
    [anon_sym_goto] = ACTIONS(3090),
    [anon_sym_not] = ACTIONS(3090),
    [anon_sym_compl] = ACTIONS(3090),
    [anon_sym_DASH_DASH] = ACTIONS(3092),
    [anon_sym_PLUS_PLUS] = ACTIONS(3092),
    [anon_sym_sizeof] = ACTIONS(3090),
    [anon_sym___alignof__] = ACTIONS(3090),
    [anon_sym___alignof] = ACTIONS(3090),
    [anon_sym__alignof] = ACTIONS(3090),
    [anon_sym_alignof] = ACTIONS(3090),
    [anon_sym__Alignof] = ACTIONS(3090),
    [anon_sym_offsetof] = ACTIONS(3090),
    [anon_sym__Generic] = ACTIONS(3090),
    [anon_sym_asm] = ACTIONS(3090),
    [anon_sym___asm__] = ACTIONS(3090),
    [aux_sym_number_literal_token1] = ACTIONS(3092),
    [aux_sym_number_literal_token2] = ACTIONS(3090),
    [anon_sym_L_SQUOTE] = ACTIONS(3092),
    [anon_sym_u_SQUOTE] = ACTIONS(3092),
    [anon_sym_U_SQUOTE] = ACTIONS(3092),
    [anon_sym_u8_SQUOTE] = ACTIONS(3092),
    [anon_sym_SQUOTE] = ACTIONS(3092),
    [anon_sym_L_DQUOTE] = ACTIONS(3092),
    [anon_sym_u_DQUOTE] = ACTIONS(3092),
    [anon_sym_U_DQUOTE] = ACTIONS(3092),
    [anon_sym_u8_DQUOTE] = ACTIONS(3092),
    [anon_sym_DQUOTE] = ACTIONS(3092),
    [sym_true] = ACTIONS(3090),
    [sym_false] = ACTIONS(3090),
    [anon_sym_NULL] = ACTIONS(3090),
    [anon_sym_nullptr] = ACTIONS(3090),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3090),
    [anon_sym_decltype] = ACTIONS(3090),
    [anon_sym_virtual] = ACTIONS(3090),
    [anon_sym_alignas] = ACTIONS(3090),
    [anon_sym_explicit] = ACTIONS(3090),
    [anon_sym_typename] = ACTIONS(3090),
    [anon_sym_template] = ACTIONS(3090),
    [anon_sym_operator] = ACTIONS(3090),
    [anon_sym_try] = ACTIONS(3090),
    [anon_sym_delete] = ACTIONS(3090),
    [anon_sym_throw] = ACTIONS(3090),
    [anon_sym_namespace] = ACTIONS(3090),
    [anon_sym_using] = ACTIONS(3090),
    [anon_sym_static_assert] = ACTIONS(3090),
    [anon_sym_concept] = ACTIONS(3090),
    [anon_sym_co_return] = ACTIONS(3090),
    [anon_sym_co_yield] = ACTIONS(3090),
    [anon_sym_R_DQUOTE] = ACTIONS(3092),
    [anon_sym_LR_DQUOTE] = ACTIONS(3092),
    [anon_sym_uR_DQUOTE] = ACTIONS(3092),
    [anon_sym_UR_DQUOTE] = ACTIONS(3092),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3092),
    [anon_sym_co_await] = ACTIONS(3090),
    [anon_sym_new] = ACTIONS(3090),
    [anon_sym_requires] = ACTIONS(3090),
    [sym_this] = ACTIONS(3090),
  },
  [831] = {
    [ts_builtin_sym_end] = ACTIONS(2959),
    [sym_identifier] = ACTIONS(2957),
    [aux_sym_preproc_include_token1] = ACTIONS(2957),
    [aux_sym_preproc_def_token1] = ACTIONS(2957),
    [aux_sym_preproc_if_token1] = ACTIONS(2957),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2957),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2957),
    [sym_preproc_directive] = ACTIONS(2957),
    [anon_sym_LPAREN2] = ACTIONS(2959),
    [anon_sym_BANG] = ACTIONS(2959),
    [anon_sym_TILDE] = ACTIONS(2959),
    [anon_sym_DASH] = ACTIONS(2957),
    [anon_sym_PLUS] = ACTIONS(2957),
    [anon_sym_STAR] = ACTIONS(2959),
    [anon_sym_AMP_AMP] = ACTIONS(2959),
    [anon_sym_AMP] = ACTIONS(2957),
    [anon_sym___extension__] = ACTIONS(2957),
    [anon_sym_typedef] = ACTIONS(2957),
    [anon_sym_extern] = ACTIONS(2957),
    [anon_sym___attribute__] = ACTIONS(2957),
    [anon_sym_COLON_COLON] = ACTIONS(2959),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2959),
    [anon_sym___declspec] = ACTIONS(2957),
    [anon_sym___based] = ACTIONS(2957),
    [anon_sym___cdecl] = ACTIONS(2957),
    [anon_sym___clrcall] = ACTIONS(2957),
    [anon_sym___stdcall] = ACTIONS(2957),
    [anon_sym___fastcall] = ACTIONS(2957),
    [anon_sym___thiscall] = ACTIONS(2957),
    [anon_sym___vectorcall] = ACTIONS(2957),
    [anon_sym_LBRACE] = ACTIONS(2959),
    [anon_sym_signed] = ACTIONS(2957),
    [anon_sym_unsigned] = ACTIONS(2957),
    [anon_sym_long] = ACTIONS(2957),
    [anon_sym_short] = ACTIONS(2957),
    [anon_sym_LBRACK] = ACTIONS(2957),
    [anon_sym_static] = ACTIONS(2957),
    [anon_sym_register] = ACTIONS(2957),
    [anon_sym_inline] = ACTIONS(2957),
    [anon_sym___inline] = ACTIONS(2957),
    [anon_sym___inline__] = ACTIONS(2957),
    [anon_sym___forceinline] = ACTIONS(2957),
    [anon_sym_thread_local] = ACTIONS(2957),
    [anon_sym___thread] = ACTIONS(2957),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_constexpr] = ACTIONS(2957),
    [anon_sym_volatile] = ACTIONS(2957),
    [anon_sym_restrict] = ACTIONS(2957),
    [anon_sym___restrict__] = ACTIONS(2957),
    [anon_sym__Atomic] = ACTIONS(2957),
    [anon_sym__Noreturn] = ACTIONS(2957),
    [anon_sym_noreturn] = ACTIONS(2957),
    [anon_sym_mutable] = ACTIONS(2957),
    [anon_sym_constinit] = ACTIONS(2957),
    [anon_sym_consteval] = ACTIONS(2957),
    [anon_sym_PROGMEM] = ACTIONS(2957),
    [aux_sym_primitive_type_token1] = ACTIONS(2957),
    [anon_sym_byte] = ACTIONS(2957),
    [anon_sym_word] = ACTIONS(2957),
    [anon_sym_enum] = ACTIONS(2957),
    [anon_sym_class] = ACTIONS(2957),
    [anon_sym_struct] = ACTIONS(2957),
    [anon_sym_union] = ACTIONS(2957),
    [anon_sym_if] = ACTIONS(2957),
    [anon_sym_switch] = ACTIONS(2957),
    [anon_sym_case] = ACTIONS(2957),
    [anon_sym_default] = ACTIONS(2957),
    [anon_sym_while] = ACTIONS(2957),
    [anon_sym_do] = ACTIONS(2957),
    [anon_sym_for] = ACTIONS(2957),
    [anon_sym_return] = ACTIONS(2957),
    [anon_sym_break] = ACTIONS(2957),
    [anon_sym_continue] = ACTIONS(2957),
    [anon_sym_goto] = ACTIONS(2957),
    [anon_sym_not] = ACTIONS(2957),
    [anon_sym_compl] = ACTIONS(2957),
    [anon_sym_DASH_DASH] = ACTIONS(2959),
    [anon_sym_PLUS_PLUS] = ACTIONS(2959),
    [anon_sym_sizeof] = ACTIONS(2957),
    [anon_sym___alignof__] = ACTIONS(2957),
    [anon_sym___alignof] = ACTIONS(2957),
    [anon_sym__alignof] = ACTIONS(2957),
    [anon_sym_alignof] = ACTIONS(2957),
    [anon_sym__Alignof] = ACTIONS(2957),
    [anon_sym_offsetof] = ACTIONS(2957),
    [anon_sym__Generic] = ACTIONS(2957),
    [anon_sym_asm] = ACTIONS(2957),
    [anon_sym___asm__] = ACTIONS(2957),
    [aux_sym_number_literal_token1] = ACTIONS(2959),
    [aux_sym_number_literal_token2] = ACTIONS(2957),
    [anon_sym_L_SQUOTE] = ACTIONS(2959),
    [anon_sym_u_SQUOTE] = ACTIONS(2959),
    [anon_sym_U_SQUOTE] = ACTIONS(2959),
    [anon_sym_u8_SQUOTE] = ACTIONS(2959),
    [anon_sym_SQUOTE] = ACTIONS(2959),
    [anon_sym_L_DQUOTE] = ACTIONS(2959),
    [anon_sym_u_DQUOTE] = ACTIONS(2959),
    [anon_sym_U_DQUOTE] = ACTIONS(2959),
    [anon_sym_u8_DQUOTE] = ACTIONS(2959),
    [anon_sym_DQUOTE] = ACTIONS(2959),
    [sym_true] = ACTIONS(2957),
    [sym_false] = ACTIONS(2957),
    [anon_sym_NULL] = ACTIONS(2957),
    [anon_sym_nullptr] = ACTIONS(2957),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2957),
    [anon_sym_decltype] = ACTIONS(2957),
    [anon_sym_virtual] = ACTIONS(2957),
    [anon_sym_alignas] = ACTIONS(2957),
    [anon_sym_explicit] = ACTIONS(2957),
    [anon_sym_typename] = ACTIONS(2957),
    [anon_sym_template] = ACTIONS(2957),
    [anon_sym_operator] = ACTIONS(2957),
    [anon_sym_try] = ACTIONS(2957),
    [anon_sym_delete] = ACTIONS(2957),
    [anon_sym_throw] = ACTIONS(2957),
    [anon_sym_namespace] = ACTIONS(2957),
    [anon_sym_using] = ACTIONS(2957),
    [anon_sym_static_assert] = ACTIONS(2957),
    [anon_sym_concept] = ACTIONS(2957),
    [anon_sym_co_return] = ACTIONS(2957),
    [anon_sym_co_yield] = ACTIONS(2957),
    [anon_sym_R_DQUOTE] = ACTIONS(2959),
    [anon_sym_LR_DQUOTE] = ACTIONS(2959),
    [anon_sym_uR_DQUOTE] = ACTIONS(2959),
    [anon_sym_UR_DQUOTE] = ACTIONS(2959),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2959),
    [anon_sym_co_await] = ACTIONS(2957),
    [anon_sym_new] = ACTIONS(2957),
    [anon_sym_requires] = ACTIONS(2957),
    [sym_this] = ACTIONS(2957),
  },
  [832] = {
    [ts_builtin_sym_end] = ACTIONS(3046),
    [sym_identifier] = ACTIONS(3044),
    [aux_sym_preproc_include_token1] = ACTIONS(3044),
    [aux_sym_preproc_def_token1] = ACTIONS(3044),
    [aux_sym_preproc_if_token1] = ACTIONS(3044),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3044),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3044),
    [sym_preproc_directive] = ACTIONS(3044),
    [anon_sym_LPAREN2] = ACTIONS(3046),
    [anon_sym_BANG] = ACTIONS(3046),
    [anon_sym_TILDE] = ACTIONS(3046),
    [anon_sym_DASH] = ACTIONS(3044),
    [anon_sym_PLUS] = ACTIONS(3044),
    [anon_sym_STAR] = ACTIONS(3046),
    [anon_sym_AMP_AMP] = ACTIONS(3046),
    [anon_sym_AMP] = ACTIONS(3044),
    [anon_sym___extension__] = ACTIONS(3044),
    [anon_sym_typedef] = ACTIONS(3044),
    [anon_sym_extern] = ACTIONS(3044),
    [anon_sym___attribute__] = ACTIONS(3044),
    [anon_sym_COLON_COLON] = ACTIONS(3046),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3046),
    [anon_sym___declspec] = ACTIONS(3044),
    [anon_sym___based] = ACTIONS(3044),
    [anon_sym___cdecl] = ACTIONS(3044),
    [anon_sym___clrcall] = ACTIONS(3044),
    [anon_sym___stdcall] = ACTIONS(3044),
    [anon_sym___fastcall] = ACTIONS(3044),
    [anon_sym___thiscall] = ACTIONS(3044),
    [anon_sym___vectorcall] = ACTIONS(3044),
    [anon_sym_LBRACE] = ACTIONS(3046),
    [anon_sym_signed] = ACTIONS(3044),
    [anon_sym_unsigned] = ACTIONS(3044),
    [anon_sym_long] = ACTIONS(3044),
    [anon_sym_short] = ACTIONS(3044),
    [anon_sym_LBRACK] = ACTIONS(3044),
    [anon_sym_static] = ACTIONS(3044),
    [anon_sym_register] = ACTIONS(3044),
    [anon_sym_inline] = ACTIONS(3044),
    [anon_sym___inline] = ACTIONS(3044),
    [anon_sym___inline__] = ACTIONS(3044),
    [anon_sym___forceinline] = ACTIONS(3044),
    [anon_sym_thread_local] = ACTIONS(3044),
    [anon_sym___thread] = ACTIONS(3044),
    [anon_sym_const] = ACTIONS(3044),
    [anon_sym_constexpr] = ACTIONS(3044),
    [anon_sym_volatile] = ACTIONS(3044),
    [anon_sym_restrict] = ACTIONS(3044),
    [anon_sym___restrict__] = ACTIONS(3044),
    [anon_sym__Atomic] = ACTIONS(3044),
    [anon_sym__Noreturn] = ACTIONS(3044),
    [anon_sym_noreturn] = ACTIONS(3044),
    [anon_sym_mutable] = ACTIONS(3044),
    [anon_sym_constinit] = ACTIONS(3044),
    [anon_sym_consteval] = ACTIONS(3044),
    [anon_sym_PROGMEM] = ACTIONS(3044),
    [aux_sym_primitive_type_token1] = ACTIONS(3044),
    [anon_sym_byte] = ACTIONS(3044),
    [anon_sym_word] = ACTIONS(3044),
    [anon_sym_enum] = ACTIONS(3044),
    [anon_sym_class] = ACTIONS(3044),
    [anon_sym_struct] = ACTIONS(3044),
    [anon_sym_union] = ACTIONS(3044),
    [anon_sym_if] = ACTIONS(3044),
    [anon_sym_switch] = ACTIONS(3044),
    [anon_sym_case] = ACTIONS(3044),
    [anon_sym_default] = ACTIONS(3044),
    [anon_sym_while] = ACTIONS(3044),
    [anon_sym_do] = ACTIONS(3044),
    [anon_sym_for] = ACTIONS(3044),
    [anon_sym_return] = ACTIONS(3044),
    [anon_sym_break] = ACTIONS(3044),
    [anon_sym_continue] = ACTIONS(3044),
    [anon_sym_goto] = ACTIONS(3044),
    [anon_sym_not] = ACTIONS(3044),
    [anon_sym_compl] = ACTIONS(3044),
    [anon_sym_DASH_DASH] = ACTIONS(3046),
    [anon_sym_PLUS_PLUS] = ACTIONS(3046),
    [anon_sym_sizeof] = ACTIONS(3044),
    [anon_sym___alignof__] = ACTIONS(3044),
    [anon_sym___alignof] = ACTIONS(3044),
    [anon_sym__alignof] = ACTIONS(3044),
    [anon_sym_alignof] = ACTIONS(3044),
    [anon_sym__Alignof] = ACTIONS(3044),
    [anon_sym_offsetof] = ACTIONS(3044),
    [anon_sym__Generic] = ACTIONS(3044),
    [anon_sym_asm] = ACTIONS(3044),
    [anon_sym___asm__] = ACTIONS(3044),
    [aux_sym_number_literal_token1] = ACTIONS(3046),
    [aux_sym_number_literal_token2] = ACTIONS(3044),
    [anon_sym_L_SQUOTE] = ACTIONS(3046),
    [anon_sym_u_SQUOTE] = ACTIONS(3046),
    [anon_sym_U_SQUOTE] = ACTIONS(3046),
    [anon_sym_u8_SQUOTE] = ACTIONS(3046),
    [anon_sym_SQUOTE] = ACTIONS(3046),
    [anon_sym_L_DQUOTE] = ACTIONS(3046),
    [anon_sym_u_DQUOTE] = ACTIONS(3046),
    [anon_sym_U_DQUOTE] = ACTIONS(3046),
    [anon_sym_u8_DQUOTE] = ACTIONS(3046),
    [anon_sym_DQUOTE] = ACTIONS(3046),
    [sym_true] = ACTIONS(3044),
    [sym_false] = ACTIONS(3044),
    [anon_sym_NULL] = ACTIONS(3044),
    [anon_sym_nullptr] = ACTIONS(3044),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3044),
    [anon_sym_decltype] = ACTIONS(3044),
    [anon_sym_virtual] = ACTIONS(3044),
    [anon_sym_alignas] = ACTIONS(3044),
    [anon_sym_explicit] = ACTIONS(3044),
    [anon_sym_typename] = ACTIONS(3044),
    [anon_sym_template] = ACTIONS(3044),
    [anon_sym_operator] = ACTIONS(3044),
    [anon_sym_try] = ACTIONS(3044),
    [anon_sym_delete] = ACTIONS(3044),
    [anon_sym_throw] = ACTIONS(3044),
    [anon_sym_namespace] = ACTIONS(3044),
    [anon_sym_using] = ACTIONS(3044),
    [anon_sym_static_assert] = ACTIONS(3044),
    [anon_sym_concept] = ACTIONS(3044),
    [anon_sym_co_return] = ACTIONS(3044),
    [anon_sym_co_yield] = ACTIONS(3044),
    [anon_sym_R_DQUOTE] = ACTIONS(3046),
    [anon_sym_LR_DQUOTE] = ACTIONS(3046),
    [anon_sym_uR_DQUOTE] = ACTIONS(3046),
    [anon_sym_UR_DQUOTE] = ACTIONS(3046),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3046),
    [anon_sym_co_await] = ACTIONS(3044),
    [anon_sym_new] = ACTIONS(3044),
    [anon_sym_requires] = ACTIONS(3044),
    [sym_this] = ACTIONS(3044),
  },
  [833] = {
    [ts_builtin_sym_end] = ACTIONS(2815),
    [sym_identifier] = ACTIONS(2813),
    [aux_sym_preproc_include_token1] = ACTIONS(2813),
    [aux_sym_preproc_def_token1] = ACTIONS(2813),
    [aux_sym_preproc_if_token1] = ACTIONS(2813),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2813),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2813),
    [sym_preproc_directive] = ACTIONS(2813),
    [anon_sym_LPAREN2] = ACTIONS(2815),
    [anon_sym_BANG] = ACTIONS(2815),
    [anon_sym_TILDE] = ACTIONS(2815),
    [anon_sym_DASH] = ACTIONS(2813),
    [anon_sym_PLUS] = ACTIONS(2813),
    [anon_sym_STAR] = ACTIONS(2815),
    [anon_sym_AMP_AMP] = ACTIONS(2815),
    [anon_sym_AMP] = ACTIONS(2813),
    [anon_sym___extension__] = ACTIONS(2813),
    [anon_sym_typedef] = ACTIONS(2813),
    [anon_sym_extern] = ACTIONS(2813),
    [anon_sym___attribute__] = ACTIONS(2813),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2815),
    [anon_sym___declspec] = ACTIONS(2813),
    [anon_sym___based] = ACTIONS(2813),
    [anon_sym___cdecl] = ACTIONS(2813),
    [anon_sym___clrcall] = ACTIONS(2813),
    [anon_sym___stdcall] = ACTIONS(2813),
    [anon_sym___fastcall] = ACTIONS(2813),
    [anon_sym___thiscall] = ACTIONS(2813),
    [anon_sym___vectorcall] = ACTIONS(2813),
    [anon_sym_LBRACE] = ACTIONS(2815),
    [anon_sym_signed] = ACTIONS(2813),
    [anon_sym_unsigned] = ACTIONS(2813),
    [anon_sym_long] = ACTIONS(2813),
    [anon_sym_short] = ACTIONS(2813),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_static] = ACTIONS(2813),
    [anon_sym_register] = ACTIONS(2813),
    [anon_sym_inline] = ACTIONS(2813),
    [anon_sym___inline] = ACTIONS(2813),
    [anon_sym___inline__] = ACTIONS(2813),
    [anon_sym___forceinline] = ACTIONS(2813),
    [anon_sym_thread_local] = ACTIONS(2813),
    [anon_sym___thread] = ACTIONS(2813),
    [anon_sym_const] = ACTIONS(2813),
    [anon_sym_constexpr] = ACTIONS(2813),
    [anon_sym_volatile] = ACTIONS(2813),
    [anon_sym_restrict] = ACTIONS(2813),
    [anon_sym___restrict__] = ACTIONS(2813),
    [anon_sym__Atomic] = ACTIONS(2813),
    [anon_sym__Noreturn] = ACTIONS(2813),
    [anon_sym_noreturn] = ACTIONS(2813),
    [anon_sym_mutable] = ACTIONS(2813),
    [anon_sym_constinit] = ACTIONS(2813),
    [anon_sym_consteval] = ACTIONS(2813),
    [anon_sym_PROGMEM] = ACTIONS(2813),
    [aux_sym_primitive_type_token1] = ACTIONS(2813),
    [anon_sym_byte] = ACTIONS(2813),
    [anon_sym_word] = ACTIONS(2813),
    [anon_sym_enum] = ACTIONS(2813),
    [anon_sym_class] = ACTIONS(2813),
    [anon_sym_struct] = ACTIONS(2813),
    [anon_sym_union] = ACTIONS(2813),
    [anon_sym_if] = ACTIONS(2813),
    [anon_sym_switch] = ACTIONS(2813),
    [anon_sym_case] = ACTIONS(2813),
    [anon_sym_default] = ACTIONS(2813),
    [anon_sym_while] = ACTIONS(2813),
    [anon_sym_do] = ACTIONS(2813),
    [anon_sym_for] = ACTIONS(2813),
    [anon_sym_return] = ACTIONS(2813),
    [anon_sym_break] = ACTIONS(2813),
    [anon_sym_continue] = ACTIONS(2813),
    [anon_sym_goto] = ACTIONS(2813),
    [anon_sym_not] = ACTIONS(2813),
    [anon_sym_compl] = ACTIONS(2813),
    [anon_sym_DASH_DASH] = ACTIONS(2815),
    [anon_sym_PLUS_PLUS] = ACTIONS(2815),
    [anon_sym_sizeof] = ACTIONS(2813),
    [anon_sym___alignof__] = ACTIONS(2813),
    [anon_sym___alignof] = ACTIONS(2813),
    [anon_sym__alignof] = ACTIONS(2813),
    [anon_sym_alignof] = ACTIONS(2813),
    [anon_sym__Alignof] = ACTIONS(2813),
    [anon_sym_offsetof] = ACTIONS(2813),
    [anon_sym__Generic] = ACTIONS(2813),
    [anon_sym_asm] = ACTIONS(2813),
    [anon_sym___asm__] = ACTIONS(2813),
    [aux_sym_number_literal_token1] = ACTIONS(2815),
    [aux_sym_number_literal_token2] = ACTIONS(2813),
    [anon_sym_L_SQUOTE] = ACTIONS(2815),
    [anon_sym_u_SQUOTE] = ACTIONS(2815),
    [anon_sym_U_SQUOTE] = ACTIONS(2815),
    [anon_sym_u8_SQUOTE] = ACTIONS(2815),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_L_DQUOTE] = ACTIONS(2815),
    [anon_sym_u_DQUOTE] = ACTIONS(2815),
    [anon_sym_U_DQUOTE] = ACTIONS(2815),
    [anon_sym_u8_DQUOTE] = ACTIONS(2815),
    [anon_sym_DQUOTE] = ACTIONS(2815),
    [sym_true] = ACTIONS(2813),
    [sym_false] = ACTIONS(2813),
    [anon_sym_NULL] = ACTIONS(2813),
    [anon_sym_nullptr] = ACTIONS(2813),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2813),
    [anon_sym_decltype] = ACTIONS(2813),
    [anon_sym_virtual] = ACTIONS(2813),
    [anon_sym_alignas] = ACTIONS(2813),
    [anon_sym_explicit] = ACTIONS(2813),
    [anon_sym_typename] = ACTIONS(2813),
    [anon_sym_template] = ACTIONS(2813),
    [anon_sym_operator] = ACTIONS(2813),
    [anon_sym_try] = ACTIONS(2813),
    [anon_sym_delete] = ACTIONS(2813),
    [anon_sym_throw] = ACTIONS(2813),
    [anon_sym_namespace] = ACTIONS(2813),
    [anon_sym_using] = ACTIONS(2813),
    [anon_sym_static_assert] = ACTIONS(2813),
    [anon_sym_concept] = ACTIONS(2813),
    [anon_sym_co_return] = ACTIONS(2813),
    [anon_sym_co_yield] = ACTIONS(2813),
    [anon_sym_R_DQUOTE] = ACTIONS(2815),
    [anon_sym_LR_DQUOTE] = ACTIONS(2815),
    [anon_sym_uR_DQUOTE] = ACTIONS(2815),
    [anon_sym_UR_DQUOTE] = ACTIONS(2815),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2815),
    [anon_sym_co_await] = ACTIONS(2813),
    [anon_sym_new] = ACTIONS(2813),
    [anon_sym_requires] = ACTIONS(2813),
    [sym_this] = ACTIONS(2813),
  },
  [834] = {
    [sym_preproc_def] = STATE(883),
    [sym_preproc_function_def] = STATE(883),
    [sym_preproc_call] = STATE(883),
    [sym_preproc_if_in_field_declaration_list] = STATE(883),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(883),
    [sym_type_definition] = STATE(883),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(5536),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(3150),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6010),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym__field_declaration_list_item] = STATE(883),
    [sym_field_declaration] = STATE(883),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1811),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(883),
    [sym_operator_cast] = STATE(6536),
    [sym_inline_method_definition] = STATE(883),
    [sym__constructor_specifiers] = STATE(1811),
    [sym_operator_cast_definition] = STATE(883),
    [sym_operator_cast_declaration] = STATE(883),
    [sym_constructor_or_destructor_definition] = STATE(883),
    [sym_constructor_or_destructor_declaration] = STATE(883),
    [sym_friend_declaration] = STATE(883),
    [sym_access_specifier] = STATE(7802),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(2618),
    [sym_template_function] = STATE(6098),
    [sym_using_declaration] = STATE(883),
    [sym_alias_declaration] = STATE(883),
    [sym_static_assert_declaration] = STATE(883),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5301),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_qualified_operator_cast_identifier] = STATE(6536),
    [sym_operator_name] = STATE(6098),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(883),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1961),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1811),
    [sym_identifier] = ACTIONS(2823),
    [aux_sym_preproc_def_token1] = ACTIONS(3364),
    [aux_sym_preproc_if_token1] = ACTIONS(3366),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3368),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3368),
    [sym_preproc_directive] = ACTIONS(3370),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(3372),
    [anon_sym_typedef] = ACTIONS(3374),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(2853),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_RBRACE] = ACTIONS(3408),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2857),
    [anon_sym_class] = ACTIONS(2859),
    [anon_sym_struct] = ACTIONS(2861),
    [anon_sym_union] = ACTIONS(2863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(2865),
    [anon_sym_template] = ACTIONS(3378),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3380),
    [anon_sym_public] = ACTIONS(2871),
    [anon_sym_private] = ACTIONS(2871),
    [anon_sym_protected] = ACTIONS(2871),
    [anon_sym_using] = ACTIONS(3382),
    [anon_sym_static_assert] = ACTIONS(3384),
  },
  [835] = {
    [ts_builtin_sym_end] = ACTIONS(3026),
    [sym_identifier] = ACTIONS(3024),
    [aux_sym_preproc_include_token1] = ACTIONS(3024),
    [aux_sym_preproc_def_token1] = ACTIONS(3024),
    [aux_sym_preproc_if_token1] = ACTIONS(3024),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3024),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3024),
    [sym_preproc_directive] = ACTIONS(3024),
    [anon_sym_LPAREN2] = ACTIONS(3026),
    [anon_sym_BANG] = ACTIONS(3026),
    [anon_sym_TILDE] = ACTIONS(3026),
    [anon_sym_DASH] = ACTIONS(3024),
    [anon_sym_PLUS] = ACTIONS(3024),
    [anon_sym_STAR] = ACTIONS(3026),
    [anon_sym_AMP_AMP] = ACTIONS(3026),
    [anon_sym_AMP] = ACTIONS(3024),
    [anon_sym___extension__] = ACTIONS(3024),
    [anon_sym_typedef] = ACTIONS(3024),
    [anon_sym_extern] = ACTIONS(3024),
    [anon_sym___attribute__] = ACTIONS(3024),
    [anon_sym_COLON_COLON] = ACTIONS(3026),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3026),
    [anon_sym___declspec] = ACTIONS(3024),
    [anon_sym___based] = ACTIONS(3024),
    [anon_sym___cdecl] = ACTIONS(3024),
    [anon_sym___clrcall] = ACTIONS(3024),
    [anon_sym___stdcall] = ACTIONS(3024),
    [anon_sym___fastcall] = ACTIONS(3024),
    [anon_sym___thiscall] = ACTIONS(3024),
    [anon_sym___vectorcall] = ACTIONS(3024),
    [anon_sym_LBRACE] = ACTIONS(3026),
    [anon_sym_signed] = ACTIONS(3024),
    [anon_sym_unsigned] = ACTIONS(3024),
    [anon_sym_long] = ACTIONS(3024),
    [anon_sym_short] = ACTIONS(3024),
    [anon_sym_LBRACK] = ACTIONS(3024),
    [anon_sym_static] = ACTIONS(3024),
    [anon_sym_register] = ACTIONS(3024),
    [anon_sym_inline] = ACTIONS(3024),
    [anon_sym___inline] = ACTIONS(3024),
    [anon_sym___inline__] = ACTIONS(3024),
    [anon_sym___forceinline] = ACTIONS(3024),
    [anon_sym_thread_local] = ACTIONS(3024),
    [anon_sym___thread] = ACTIONS(3024),
    [anon_sym_const] = ACTIONS(3024),
    [anon_sym_constexpr] = ACTIONS(3024),
    [anon_sym_volatile] = ACTIONS(3024),
    [anon_sym_restrict] = ACTIONS(3024),
    [anon_sym___restrict__] = ACTIONS(3024),
    [anon_sym__Atomic] = ACTIONS(3024),
    [anon_sym__Noreturn] = ACTIONS(3024),
    [anon_sym_noreturn] = ACTIONS(3024),
    [anon_sym_mutable] = ACTIONS(3024),
    [anon_sym_constinit] = ACTIONS(3024),
    [anon_sym_consteval] = ACTIONS(3024),
    [anon_sym_PROGMEM] = ACTIONS(3024),
    [aux_sym_primitive_type_token1] = ACTIONS(3024),
    [anon_sym_byte] = ACTIONS(3024),
    [anon_sym_word] = ACTIONS(3024),
    [anon_sym_enum] = ACTIONS(3024),
    [anon_sym_class] = ACTIONS(3024),
    [anon_sym_struct] = ACTIONS(3024),
    [anon_sym_union] = ACTIONS(3024),
    [anon_sym_if] = ACTIONS(3024),
    [anon_sym_switch] = ACTIONS(3024),
    [anon_sym_case] = ACTIONS(3024),
    [anon_sym_default] = ACTIONS(3024),
    [anon_sym_while] = ACTIONS(3024),
    [anon_sym_do] = ACTIONS(3024),
    [anon_sym_for] = ACTIONS(3024),
    [anon_sym_return] = ACTIONS(3024),
    [anon_sym_break] = ACTIONS(3024),
    [anon_sym_continue] = ACTIONS(3024),
    [anon_sym_goto] = ACTIONS(3024),
    [anon_sym_not] = ACTIONS(3024),
    [anon_sym_compl] = ACTIONS(3024),
    [anon_sym_DASH_DASH] = ACTIONS(3026),
    [anon_sym_PLUS_PLUS] = ACTIONS(3026),
    [anon_sym_sizeof] = ACTIONS(3024),
    [anon_sym___alignof__] = ACTIONS(3024),
    [anon_sym___alignof] = ACTIONS(3024),
    [anon_sym__alignof] = ACTIONS(3024),
    [anon_sym_alignof] = ACTIONS(3024),
    [anon_sym__Alignof] = ACTIONS(3024),
    [anon_sym_offsetof] = ACTIONS(3024),
    [anon_sym__Generic] = ACTIONS(3024),
    [anon_sym_asm] = ACTIONS(3024),
    [anon_sym___asm__] = ACTIONS(3024),
    [aux_sym_number_literal_token1] = ACTIONS(3026),
    [aux_sym_number_literal_token2] = ACTIONS(3024),
    [anon_sym_L_SQUOTE] = ACTIONS(3026),
    [anon_sym_u_SQUOTE] = ACTIONS(3026),
    [anon_sym_U_SQUOTE] = ACTIONS(3026),
    [anon_sym_u8_SQUOTE] = ACTIONS(3026),
    [anon_sym_SQUOTE] = ACTIONS(3026),
    [anon_sym_L_DQUOTE] = ACTIONS(3026),
    [anon_sym_u_DQUOTE] = ACTIONS(3026),
    [anon_sym_U_DQUOTE] = ACTIONS(3026),
    [anon_sym_u8_DQUOTE] = ACTIONS(3026),
    [anon_sym_DQUOTE] = ACTIONS(3026),
    [sym_true] = ACTIONS(3024),
    [sym_false] = ACTIONS(3024),
    [anon_sym_NULL] = ACTIONS(3024),
    [anon_sym_nullptr] = ACTIONS(3024),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3024),
    [anon_sym_decltype] = ACTIONS(3024),
    [anon_sym_virtual] = ACTIONS(3024),
    [anon_sym_alignas] = ACTIONS(3024),
    [anon_sym_explicit] = ACTIONS(3024),
    [anon_sym_typename] = ACTIONS(3024),
    [anon_sym_template] = ACTIONS(3024),
    [anon_sym_operator] = ACTIONS(3024),
    [anon_sym_try] = ACTIONS(3024),
    [anon_sym_delete] = ACTIONS(3024),
    [anon_sym_throw] = ACTIONS(3024),
    [anon_sym_namespace] = ACTIONS(3024),
    [anon_sym_using] = ACTIONS(3024),
    [anon_sym_static_assert] = ACTIONS(3024),
    [anon_sym_concept] = ACTIONS(3024),
    [anon_sym_co_return] = ACTIONS(3024),
    [anon_sym_co_yield] = ACTIONS(3024),
    [anon_sym_R_DQUOTE] = ACTIONS(3026),
    [anon_sym_LR_DQUOTE] = ACTIONS(3026),
    [anon_sym_uR_DQUOTE] = ACTIONS(3026),
    [anon_sym_UR_DQUOTE] = ACTIONS(3026),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3026),
    [anon_sym_co_await] = ACTIONS(3024),
    [anon_sym_new] = ACTIONS(3024),
    [anon_sym_requires] = ACTIONS(3024),
    [sym_this] = ACTIONS(3024),
  },
  [836] = {
    [ts_builtin_sym_end] = ACTIONS(3158),
    [sym_identifier] = ACTIONS(3156),
    [aux_sym_preproc_include_token1] = ACTIONS(3156),
    [aux_sym_preproc_def_token1] = ACTIONS(3156),
    [aux_sym_preproc_if_token1] = ACTIONS(3156),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3156),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3156),
    [sym_preproc_directive] = ACTIONS(3156),
    [anon_sym_LPAREN2] = ACTIONS(3158),
    [anon_sym_BANG] = ACTIONS(3158),
    [anon_sym_TILDE] = ACTIONS(3158),
    [anon_sym_DASH] = ACTIONS(3156),
    [anon_sym_PLUS] = ACTIONS(3156),
    [anon_sym_STAR] = ACTIONS(3158),
    [anon_sym_AMP_AMP] = ACTIONS(3158),
    [anon_sym_AMP] = ACTIONS(3156),
    [anon_sym___extension__] = ACTIONS(3156),
    [anon_sym_typedef] = ACTIONS(3156),
    [anon_sym_extern] = ACTIONS(3156),
    [anon_sym___attribute__] = ACTIONS(3156),
    [anon_sym_COLON_COLON] = ACTIONS(3158),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3158),
    [anon_sym___declspec] = ACTIONS(3156),
    [anon_sym___based] = ACTIONS(3156),
    [anon_sym___cdecl] = ACTIONS(3156),
    [anon_sym___clrcall] = ACTIONS(3156),
    [anon_sym___stdcall] = ACTIONS(3156),
    [anon_sym___fastcall] = ACTIONS(3156),
    [anon_sym___thiscall] = ACTIONS(3156),
    [anon_sym___vectorcall] = ACTIONS(3156),
    [anon_sym_LBRACE] = ACTIONS(3158),
    [anon_sym_signed] = ACTIONS(3156),
    [anon_sym_unsigned] = ACTIONS(3156),
    [anon_sym_long] = ACTIONS(3156),
    [anon_sym_short] = ACTIONS(3156),
    [anon_sym_LBRACK] = ACTIONS(3156),
    [anon_sym_static] = ACTIONS(3156),
    [anon_sym_register] = ACTIONS(3156),
    [anon_sym_inline] = ACTIONS(3156),
    [anon_sym___inline] = ACTIONS(3156),
    [anon_sym___inline__] = ACTIONS(3156),
    [anon_sym___forceinline] = ACTIONS(3156),
    [anon_sym_thread_local] = ACTIONS(3156),
    [anon_sym___thread] = ACTIONS(3156),
    [anon_sym_const] = ACTIONS(3156),
    [anon_sym_constexpr] = ACTIONS(3156),
    [anon_sym_volatile] = ACTIONS(3156),
    [anon_sym_restrict] = ACTIONS(3156),
    [anon_sym___restrict__] = ACTIONS(3156),
    [anon_sym__Atomic] = ACTIONS(3156),
    [anon_sym__Noreturn] = ACTIONS(3156),
    [anon_sym_noreturn] = ACTIONS(3156),
    [anon_sym_mutable] = ACTIONS(3156),
    [anon_sym_constinit] = ACTIONS(3156),
    [anon_sym_consteval] = ACTIONS(3156),
    [anon_sym_PROGMEM] = ACTIONS(3156),
    [aux_sym_primitive_type_token1] = ACTIONS(3156),
    [anon_sym_byte] = ACTIONS(3156),
    [anon_sym_word] = ACTIONS(3156),
    [anon_sym_enum] = ACTIONS(3156),
    [anon_sym_class] = ACTIONS(3156),
    [anon_sym_struct] = ACTIONS(3156),
    [anon_sym_union] = ACTIONS(3156),
    [anon_sym_if] = ACTIONS(3156),
    [anon_sym_switch] = ACTIONS(3156),
    [anon_sym_case] = ACTIONS(3156),
    [anon_sym_default] = ACTIONS(3156),
    [anon_sym_while] = ACTIONS(3156),
    [anon_sym_do] = ACTIONS(3156),
    [anon_sym_for] = ACTIONS(3156),
    [anon_sym_return] = ACTIONS(3156),
    [anon_sym_break] = ACTIONS(3156),
    [anon_sym_continue] = ACTIONS(3156),
    [anon_sym_goto] = ACTIONS(3156),
    [anon_sym_not] = ACTIONS(3156),
    [anon_sym_compl] = ACTIONS(3156),
    [anon_sym_DASH_DASH] = ACTIONS(3158),
    [anon_sym_PLUS_PLUS] = ACTIONS(3158),
    [anon_sym_sizeof] = ACTIONS(3156),
    [anon_sym___alignof__] = ACTIONS(3156),
    [anon_sym___alignof] = ACTIONS(3156),
    [anon_sym__alignof] = ACTIONS(3156),
    [anon_sym_alignof] = ACTIONS(3156),
    [anon_sym__Alignof] = ACTIONS(3156),
    [anon_sym_offsetof] = ACTIONS(3156),
    [anon_sym__Generic] = ACTIONS(3156),
    [anon_sym_asm] = ACTIONS(3156),
    [anon_sym___asm__] = ACTIONS(3156),
    [aux_sym_number_literal_token1] = ACTIONS(3158),
    [aux_sym_number_literal_token2] = ACTIONS(3156),
    [anon_sym_L_SQUOTE] = ACTIONS(3158),
    [anon_sym_u_SQUOTE] = ACTIONS(3158),
    [anon_sym_U_SQUOTE] = ACTIONS(3158),
    [anon_sym_u8_SQUOTE] = ACTIONS(3158),
    [anon_sym_SQUOTE] = ACTIONS(3158),
    [anon_sym_L_DQUOTE] = ACTIONS(3158),
    [anon_sym_u_DQUOTE] = ACTIONS(3158),
    [anon_sym_U_DQUOTE] = ACTIONS(3158),
    [anon_sym_u8_DQUOTE] = ACTIONS(3158),
    [anon_sym_DQUOTE] = ACTIONS(3158),
    [sym_true] = ACTIONS(3156),
    [sym_false] = ACTIONS(3156),
    [anon_sym_NULL] = ACTIONS(3156),
    [anon_sym_nullptr] = ACTIONS(3156),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3156),
    [anon_sym_decltype] = ACTIONS(3156),
    [anon_sym_virtual] = ACTIONS(3156),
    [anon_sym_alignas] = ACTIONS(3156),
    [anon_sym_explicit] = ACTIONS(3156),
    [anon_sym_typename] = ACTIONS(3156),
    [anon_sym_template] = ACTIONS(3156),
    [anon_sym_operator] = ACTIONS(3156),
    [anon_sym_try] = ACTIONS(3156),
    [anon_sym_delete] = ACTIONS(3156),
    [anon_sym_throw] = ACTIONS(3156),
    [anon_sym_namespace] = ACTIONS(3156),
    [anon_sym_using] = ACTIONS(3156),
    [anon_sym_static_assert] = ACTIONS(3156),
    [anon_sym_concept] = ACTIONS(3156),
    [anon_sym_co_return] = ACTIONS(3156),
    [anon_sym_co_yield] = ACTIONS(3156),
    [anon_sym_R_DQUOTE] = ACTIONS(3158),
    [anon_sym_LR_DQUOTE] = ACTIONS(3158),
    [anon_sym_uR_DQUOTE] = ACTIONS(3158),
    [anon_sym_UR_DQUOTE] = ACTIONS(3158),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3158),
    [anon_sym_co_await] = ACTIONS(3156),
    [anon_sym_new] = ACTIONS(3156),
    [anon_sym_requires] = ACTIONS(3156),
    [sym_this] = ACTIONS(3156),
  },
  [837] = {
    [sym_preproc_def] = STATE(883),
    [sym_preproc_function_def] = STATE(883),
    [sym_preproc_call] = STATE(883),
    [sym_preproc_if_in_field_declaration_list] = STATE(883),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(883),
    [sym_type_definition] = STATE(883),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(5536),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(3150),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6010),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym__field_declaration_list_item] = STATE(883),
    [sym_field_declaration] = STATE(883),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1811),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(883),
    [sym_operator_cast] = STATE(6536),
    [sym_inline_method_definition] = STATE(883),
    [sym__constructor_specifiers] = STATE(1811),
    [sym_operator_cast_definition] = STATE(883),
    [sym_operator_cast_declaration] = STATE(883),
    [sym_constructor_or_destructor_definition] = STATE(883),
    [sym_constructor_or_destructor_declaration] = STATE(883),
    [sym_friend_declaration] = STATE(883),
    [sym_access_specifier] = STATE(7802),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(2618),
    [sym_template_function] = STATE(6098),
    [sym_using_declaration] = STATE(883),
    [sym_alias_declaration] = STATE(883),
    [sym_static_assert_declaration] = STATE(883),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5301),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_qualified_operator_cast_identifier] = STATE(6536),
    [sym_operator_name] = STATE(6098),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(883),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1961),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1811),
    [sym_identifier] = ACTIONS(2823),
    [aux_sym_preproc_def_token1] = ACTIONS(3364),
    [aux_sym_preproc_if_token1] = ACTIONS(3366),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3368),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3368),
    [sym_preproc_directive] = ACTIONS(3370),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(3372),
    [anon_sym_typedef] = ACTIONS(3374),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(2853),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_RBRACE] = ACTIONS(3410),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2857),
    [anon_sym_class] = ACTIONS(2859),
    [anon_sym_struct] = ACTIONS(2861),
    [anon_sym_union] = ACTIONS(2863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(2865),
    [anon_sym_template] = ACTIONS(3378),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3380),
    [anon_sym_public] = ACTIONS(2871),
    [anon_sym_private] = ACTIONS(2871),
    [anon_sym_protected] = ACTIONS(2871),
    [anon_sym_using] = ACTIONS(3382),
    [anon_sym_static_assert] = ACTIONS(3384),
  },
  [838] = {
    [sym_preproc_def] = STATE(843),
    [sym_preproc_function_def] = STATE(843),
    [sym_preproc_call] = STATE(843),
    [sym_preproc_if_in_field_declaration_list] = STATE(843),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(843),
    [sym_type_definition] = STATE(843),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(5536),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(3150),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6010),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym__field_declaration_list_item] = STATE(843),
    [sym_field_declaration] = STATE(843),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1811),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(843),
    [sym_operator_cast] = STATE(6536),
    [sym_inline_method_definition] = STATE(843),
    [sym__constructor_specifiers] = STATE(1811),
    [sym_operator_cast_definition] = STATE(843),
    [sym_operator_cast_declaration] = STATE(843),
    [sym_constructor_or_destructor_definition] = STATE(843),
    [sym_constructor_or_destructor_declaration] = STATE(843),
    [sym_friend_declaration] = STATE(843),
    [sym_access_specifier] = STATE(7802),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(2618),
    [sym_template_function] = STATE(6098),
    [sym_using_declaration] = STATE(843),
    [sym_alias_declaration] = STATE(843),
    [sym_static_assert_declaration] = STATE(843),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5301),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_qualified_operator_cast_identifier] = STATE(6536),
    [sym_operator_name] = STATE(6098),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(843),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1961),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1811),
    [sym_identifier] = ACTIONS(2823),
    [aux_sym_preproc_def_token1] = ACTIONS(3364),
    [aux_sym_preproc_if_token1] = ACTIONS(3366),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3368),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3368),
    [sym_preproc_directive] = ACTIONS(3370),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(3372),
    [anon_sym_typedef] = ACTIONS(3374),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(2853),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_RBRACE] = ACTIONS(3412),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2857),
    [anon_sym_class] = ACTIONS(2859),
    [anon_sym_struct] = ACTIONS(2861),
    [anon_sym_union] = ACTIONS(2863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(2865),
    [anon_sym_template] = ACTIONS(3378),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3380),
    [anon_sym_public] = ACTIONS(2871),
    [anon_sym_private] = ACTIONS(2871),
    [anon_sym_protected] = ACTIONS(2871),
    [anon_sym_using] = ACTIONS(3382),
    [anon_sym_static_assert] = ACTIONS(3384),
  },
  [839] = {
    [sym_preproc_def] = STATE(847),
    [sym_preproc_function_def] = STATE(847),
    [sym_preproc_call] = STATE(847),
    [sym_preproc_if_in_field_declaration_list] = STATE(847),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(847),
    [sym_type_definition] = STATE(847),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(5543),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(3150),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6014),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym__field_declaration_list_item] = STATE(847),
    [sym_field_declaration] = STATE(847),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1892),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(847),
    [sym_operator_cast] = STATE(6512),
    [sym_inline_method_definition] = STATE(847),
    [sym__constructor_specifiers] = STATE(1892),
    [sym_operator_cast_definition] = STATE(847),
    [sym_operator_cast_declaration] = STATE(847),
    [sym_constructor_or_destructor_definition] = STATE(847),
    [sym_constructor_or_destructor_declaration] = STATE(847),
    [sym_friend_declaration] = STATE(847),
    [sym_access_specifier] = STATE(7720),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(2618),
    [sym_template_function] = STATE(6098),
    [sym_using_declaration] = STATE(847),
    [sym_alias_declaration] = STATE(847),
    [sym_static_assert_declaration] = STATE(847),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5301),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_qualified_operator_cast_identifier] = STATE(6512),
    [sym_operator_name] = STATE(6098),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(847),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1961),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1892),
    [sym_identifier] = ACTIONS(2823),
    [aux_sym_preproc_def_token1] = ACTIONS(3386),
    [aux_sym_preproc_if_token1] = ACTIONS(3388),
    [aux_sym_preproc_if_token2] = ACTIONS(3414),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3392),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3392),
    [sym_preproc_directive] = ACTIONS(3394),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(3396),
    [anon_sym_typedef] = ACTIONS(3398),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(2853),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2857),
    [anon_sym_class] = ACTIONS(2859),
    [anon_sym_struct] = ACTIONS(2861),
    [anon_sym_union] = ACTIONS(2863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(2865),
    [anon_sym_template] = ACTIONS(3400),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3402),
    [anon_sym_public] = ACTIONS(2871),
    [anon_sym_private] = ACTIONS(2871),
    [anon_sym_protected] = ACTIONS(2871),
    [anon_sym_using] = ACTIONS(3404),
    [anon_sym_static_assert] = ACTIONS(3406),
  },
  [840] = {
    [sym_preproc_def] = STATE(883),
    [sym_preproc_function_def] = STATE(883),
    [sym_preproc_call] = STATE(883),
    [sym_preproc_if_in_field_declaration_list] = STATE(883),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(883),
    [sym_type_definition] = STATE(883),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(5536),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(3150),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6010),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym__field_declaration_list_item] = STATE(883),
    [sym_field_declaration] = STATE(883),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1811),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(883),
    [sym_operator_cast] = STATE(6536),
    [sym_inline_method_definition] = STATE(883),
    [sym__constructor_specifiers] = STATE(1811),
    [sym_operator_cast_definition] = STATE(883),
    [sym_operator_cast_declaration] = STATE(883),
    [sym_constructor_or_destructor_definition] = STATE(883),
    [sym_constructor_or_destructor_declaration] = STATE(883),
    [sym_friend_declaration] = STATE(883),
    [sym_access_specifier] = STATE(7802),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(2618),
    [sym_template_function] = STATE(6098),
    [sym_using_declaration] = STATE(883),
    [sym_alias_declaration] = STATE(883),
    [sym_static_assert_declaration] = STATE(883),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5301),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_qualified_operator_cast_identifier] = STATE(6536),
    [sym_operator_name] = STATE(6098),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(883),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1961),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1811),
    [sym_identifier] = ACTIONS(2823),
    [aux_sym_preproc_def_token1] = ACTIONS(3364),
    [aux_sym_preproc_if_token1] = ACTIONS(3366),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3368),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3368),
    [sym_preproc_directive] = ACTIONS(3370),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(3372),
    [anon_sym_typedef] = ACTIONS(3374),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(2853),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_RBRACE] = ACTIONS(3416),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2857),
    [anon_sym_class] = ACTIONS(2859),
    [anon_sym_struct] = ACTIONS(2861),
    [anon_sym_union] = ACTIONS(2863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(2865),
    [anon_sym_template] = ACTIONS(3378),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3380),
    [anon_sym_public] = ACTIONS(2871),
    [anon_sym_private] = ACTIONS(2871),
    [anon_sym_protected] = ACTIONS(2871),
    [anon_sym_using] = ACTIONS(3382),
    [anon_sym_static_assert] = ACTIONS(3384),
  },
  [841] = {
    [ts_builtin_sym_end] = ACTIONS(3030),
    [sym_identifier] = ACTIONS(3028),
    [aux_sym_preproc_include_token1] = ACTIONS(3028),
    [aux_sym_preproc_def_token1] = ACTIONS(3028),
    [aux_sym_preproc_if_token1] = ACTIONS(3028),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3028),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3028),
    [sym_preproc_directive] = ACTIONS(3028),
    [anon_sym_LPAREN2] = ACTIONS(3030),
    [anon_sym_BANG] = ACTIONS(3030),
    [anon_sym_TILDE] = ACTIONS(3030),
    [anon_sym_DASH] = ACTIONS(3028),
    [anon_sym_PLUS] = ACTIONS(3028),
    [anon_sym_STAR] = ACTIONS(3030),
    [anon_sym_AMP_AMP] = ACTIONS(3030),
    [anon_sym_AMP] = ACTIONS(3028),
    [anon_sym___extension__] = ACTIONS(3028),
    [anon_sym_typedef] = ACTIONS(3028),
    [anon_sym_extern] = ACTIONS(3028),
    [anon_sym___attribute__] = ACTIONS(3028),
    [anon_sym_COLON_COLON] = ACTIONS(3030),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3030),
    [anon_sym___declspec] = ACTIONS(3028),
    [anon_sym___based] = ACTIONS(3028),
    [anon_sym___cdecl] = ACTIONS(3028),
    [anon_sym___clrcall] = ACTIONS(3028),
    [anon_sym___stdcall] = ACTIONS(3028),
    [anon_sym___fastcall] = ACTIONS(3028),
    [anon_sym___thiscall] = ACTIONS(3028),
    [anon_sym___vectorcall] = ACTIONS(3028),
    [anon_sym_LBRACE] = ACTIONS(3030),
    [anon_sym_signed] = ACTIONS(3028),
    [anon_sym_unsigned] = ACTIONS(3028),
    [anon_sym_long] = ACTIONS(3028),
    [anon_sym_short] = ACTIONS(3028),
    [anon_sym_LBRACK] = ACTIONS(3028),
    [anon_sym_static] = ACTIONS(3028),
    [anon_sym_register] = ACTIONS(3028),
    [anon_sym_inline] = ACTIONS(3028),
    [anon_sym___inline] = ACTIONS(3028),
    [anon_sym___inline__] = ACTIONS(3028),
    [anon_sym___forceinline] = ACTIONS(3028),
    [anon_sym_thread_local] = ACTIONS(3028),
    [anon_sym___thread] = ACTIONS(3028),
    [anon_sym_const] = ACTIONS(3028),
    [anon_sym_constexpr] = ACTIONS(3028),
    [anon_sym_volatile] = ACTIONS(3028),
    [anon_sym_restrict] = ACTIONS(3028),
    [anon_sym___restrict__] = ACTIONS(3028),
    [anon_sym__Atomic] = ACTIONS(3028),
    [anon_sym__Noreturn] = ACTIONS(3028),
    [anon_sym_noreturn] = ACTIONS(3028),
    [anon_sym_mutable] = ACTIONS(3028),
    [anon_sym_constinit] = ACTIONS(3028),
    [anon_sym_consteval] = ACTIONS(3028),
    [anon_sym_PROGMEM] = ACTIONS(3028),
    [aux_sym_primitive_type_token1] = ACTIONS(3028),
    [anon_sym_byte] = ACTIONS(3028),
    [anon_sym_word] = ACTIONS(3028),
    [anon_sym_enum] = ACTIONS(3028),
    [anon_sym_class] = ACTIONS(3028),
    [anon_sym_struct] = ACTIONS(3028),
    [anon_sym_union] = ACTIONS(3028),
    [anon_sym_if] = ACTIONS(3028),
    [anon_sym_switch] = ACTIONS(3028),
    [anon_sym_case] = ACTIONS(3028),
    [anon_sym_default] = ACTIONS(3028),
    [anon_sym_while] = ACTIONS(3028),
    [anon_sym_do] = ACTIONS(3028),
    [anon_sym_for] = ACTIONS(3028),
    [anon_sym_return] = ACTIONS(3028),
    [anon_sym_break] = ACTIONS(3028),
    [anon_sym_continue] = ACTIONS(3028),
    [anon_sym_goto] = ACTIONS(3028),
    [anon_sym_not] = ACTIONS(3028),
    [anon_sym_compl] = ACTIONS(3028),
    [anon_sym_DASH_DASH] = ACTIONS(3030),
    [anon_sym_PLUS_PLUS] = ACTIONS(3030),
    [anon_sym_sizeof] = ACTIONS(3028),
    [anon_sym___alignof__] = ACTIONS(3028),
    [anon_sym___alignof] = ACTIONS(3028),
    [anon_sym__alignof] = ACTIONS(3028),
    [anon_sym_alignof] = ACTIONS(3028),
    [anon_sym__Alignof] = ACTIONS(3028),
    [anon_sym_offsetof] = ACTIONS(3028),
    [anon_sym__Generic] = ACTIONS(3028),
    [anon_sym_asm] = ACTIONS(3028),
    [anon_sym___asm__] = ACTIONS(3028),
    [aux_sym_number_literal_token1] = ACTIONS(3030),
    [aux_sym_number_literal_token2] = ACTIONS(3028),
    [anon_sym_L_SQUOTE] = ACTIONS(3030),
    [anon_sym_u_SQUOTE] = ACTIONS(3030),
    [anon_sym_U_SQUOTE] = ACTIONS(3030),
    [anon_sym_u8_SQUOTE] = ACTIONS(3030),
    [anon_sym_SQUOTE] = ACTIONS(3030),
    [anon_sym_L_DQUOTE] = ACTIONS(3030),
    [anon_sym_u_DQUOTE] = ACTIONS(3030),
    [anon_sym_U_DQUOTE] = ACTIONS(3030),
    [anon_sym_u8_DQUOTE] = ACTIONS(3030),
    [anon_sym_DQUOTE] = ACTIONS(3030),
    [sym_true] = ACTIONS(3028),
    [sym_false] = ACTIONS(3028),
    [anon_sym_NULL] = ACTIONS(3028),
    [anon_sym_nullptr] = ACTIONS(3028),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3028),
    [anon_sym_decltype] = ACTIONS(3028),
    [anon_sym_virtual] = ACTIONS(3028),
    [anon_sym_alignas] = ACTIONS(3028),
    [anon_sym_explicit] = ACTIONS(3028),
    [anon_sym_typename] = ACTIONS(3028),
    [anon_sym_template] = ACTIONS(3028),
    [anon_sym_operator] = ACTIONS(3028),
    [anon_sym_try] = ACTIONS(3028),
    [anon_sym_delete] = ACTIONS(3028),
    [anon_sym_throw] = ACTIONS(3028),
    [anon_sym_namespace] = ACTIONS(3028),
    [anon_sym_using] = ACTIONS(3028),
    [anon_sym_static_assert] = ACTIONS(3028),
    [anon_sym_concept] = ACTIONS(3028),
    [anon_sym_co_return] = ACTIONS(3028),
    [anon_sym_co_yield] = ACTIONS(3028),
    [anon_sym_R_DQUOTE] = ACTIONS(3030),
    [anon_sym_LR_DQUOTE] = ACTIONS(3030),
    [anon_sym_uR_DQUOTE] = ACTIONS(3030),
    [anon_sym_UR_DQUOTE] = ACTIONS(3030),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3030),
    [anon_sym_co_await] = ACTIONS(3028),
    [anon_sym_new] = ACTIONS(3028),
    [anon_sym_requires] = ACTIONS(3028),
    [sym_this] = ACTIONS(3028),
  },
  [842] = {
    [sym_preproc_def] = STATE(883),
    [sym_preproc_function_def] = STATE(883),
    [sym_preproc_call] = STATE(883),
    [sym_preproc_if_in_field_declaration_list] = STATE(883),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(883),
    [sym_type_definition] = STATE(883),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(5536),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(3150),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6010),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym__field_declaration_list_item] = STATE(883),
    [sym_field_declaration] = STATE(883),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1811),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(883),
    [sym_operator_cast] = STATE(6536),
    [sym_inline_method_definition] = STATE(883),
    [sym__constructor_specifiers] = STATE(1811),
    [sym_operator_cast_definition] = STATE(883),
    [sym_operator_cast_declaration] = STATE(883),
    [sym_constructor_or_destructor_definition] = STATE(883),
    [sym_constructor_or_destructor_declaration] = STATE(883),
    [sym_friend_declaration] = STATE(883),
    [sym_access_specifier] = STATE(7802),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(2618),
    [sym_template_function] = STATE(6098),
    [sym_using_declaration] = STATE(883),
    [sym_alias_declaration] = STATE(883),
    [sym_static_assert_declaration] = STATE(883),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5301),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_qualified_operator_cast_identifier] = STATE(6536),
    [sym_operator_name] = STATE(6098),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(883),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1961),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1811),
    [sym_identifier] = ACTIONS(2823),
    [aux_sym_preproc_def_token1] = ACTIONS(3364),
    [aux_sym_preproc_if_token1] = ACTIONS(3366),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3368),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3368),
    [sym_preproc_directive] = ACTIONS(3370),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(3372),
    [anon_sym_typedef] = ACTIONS(3374),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(2853),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_RBRACE] = ACTIONS(3418),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2857),
    [anon_sym_class] = ACTIONS(2859),
    [anon_sym_struct] = ACTIONS(2861),
    [anon_sym_union] = ACTIONS(2863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(2865),
    [anon_sym_template] = ACTIONS(3378),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3380),
    [anon_sym_public] = ACTIONS(2871),
    [anon_sym_private] = ACTIONS(2871),
    [anon_sym_protected] = ACTIONS(2871),
    [anon_sym_using] = ACTIONS(3382),
    [anon_sym_static_assert] = ACTIONS(3384),
  },
  [843] = {
    [sym_preproc_def] = STATE(883),
    [sym_preproc_function_def] = STATE(883),
    [sym_preproc_call] = STATE(883),
    [sym_preproc_if_in_field_declaration_list] = STATE(883),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(883),
    [sym_type_definition] = STATE(883),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(5536),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(3150),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6010),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym__field_declaration_list_item] = STATE(883),
    [sym_field_declaration] = STATE(883),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1811),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(883),
    [sym_operator_cast] = STATE(6536),
    [sym_inline_method_definition] = STATE(883),
    [sym__constructor_specifiers] = STATE(1811),
    [sym_operator_cast_definition] = STATE(883),
    [sym_operator_cast_declaration] = STATE(883),
    [sym_constructor_or_destructor_definition] = STATE(883),
    [sym_constructor_or_destructor_declaration] = STATE(883),
    [sym_friend_declaration] = STATE(883),
    [sym_access_specifier] = STATE(7802),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(2618),
    [sym_template_function] = STATE(6098),
    [sym_using_declaration] = STATE(883),
    [sym_alias_declaration] = STATE(883),
    [sym_static_assert_declaration] = STATE(883),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5301),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_qualified_operator_cast_identifier] = STATE(6536),
    [sym_operator_name] = STATE(6098),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(883),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1961),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1811),
    [sym_identifier] = ACTIONS(2823),
    [aux_sym_preproc_def_token1] = ACTIONS(3364),
    [aux_sym_preproc_if_token1] = ACTIONS(3366),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3368),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3368),
    [sym_preproc_directive] = ACTIONS(3370),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(3372),
    [anon_sym_typedef] = ACTIONS(3374),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(2853),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_RBRACE] = ACTIONS(3420),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2857),
    [anon_sym_class] = ACTIONS(2859),
    [anon_sym_struct] = ACTIONS(2861),
    [anon_sym_union] = ACTIONS(2863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(2865),
    [anon_sym_template] = ACTIONS(3378),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3380),
    [anon_sym_public] = ACTIONS(2871),
    [anon_sym_private] = ACTIONS(2871),
    [anon_sym_protected] = ACTIONS(2871),
    [anon_sym_using] = ACTIONS(3382),
    [anon_sym_static_assert] = ACTIONS(3384),
  },
  [844] = {
    [ts_builtin_sym_end] = ACTIONS(3038),
    [sym_identifier] = ACTIONS(3036),
    [aux_sym_preproc_include_token1] = ACTIONS(3036),
    [aux_sym_preproc_def_token1] = ACTIONS(3036),
    [aux_sym_preproc_if_token1] = ACTIONS(3036),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3036),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3036),
    [sym_preproc_directive] = ACTIONS(3036),
    [anon_sym_LPAREN2] = ACTIONS(3038),
    [anon_sym_BANG] = ACTIONS(3038),
    [anon_sym_TILDE] = ACTIONS(3038),
    [anon_sym_DASH] = ACTIONS(3036),
    [anon_sym_PLUS] = ACTIONS(3036),
    [anon_sym_STAR] = ACTIONS(3038),
    [anon_sym_AMP_AMP] = ACTIONS(3038),
    [anon_sym_AMP] = ACTIONS(3036),
    [anon_sym___extension__] = ACTIONS(3036),
    [anon_sym_typedef] = ACTIONS(3036),
    [anon_sym_extern] = ACTIONS(3036),
    [anon_sym___attribute__] = ACTIONS(3036),
    [anon_sym_COLON_COLON] = ACTIONS(3038),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3038),
    [anon_sym___declspec] = ACTIONS(3036),
    [anon_sym___based] = ACTIONS(3036),
    [anon_sym___cdecl] = ACTIONS(3036),
    [anon_sym___clrcall] = ACTIONS(3036),
    [anon_sym___stdcall] = ACTIONS(3036),
    [anon_sym___fastcall] = ACTIONS(3036),
    [anon_sym___thiscall] = ACTIONS(3036),
    [anon_sym___vectorcall] = ACTIONS(3036),
    [anon_sym_LBRACE] = ACTIONS(3038),
    [anon_sym_signed] = ACTIONS(3036),
    [anon_sym_unsigned] = ACTIONS(3036),
    [anon_sym_long] = ACTIONS(3036),
    [anon_sym_short] = ACTIONS(3036),
    [anon_sym_LBRACK] = ACTIONS(3036),
    [anon_sym_static] = ACTIONS(3036),
    [anon_sym_register] = ACTIONS(3036),
    [anon_sym_inline] = ACTIONS(3036),
    [anon_sym___inline] = ACTIONS(3036),
    [anon_sym___inline__] = ACTIONS(3036),
    [anon_sym___forceinline] = ACTIONS(3036),
    [anon_sym_thread_local] = ACTIONS(3036),
    [anon_sym___thread] = ACTIONS(3036),
    [anon_sym_const] = ACTIONS(3036),
    [anon_sym_constexpr] = ACTIONS(3036),
    [anon_sym_volatile] = ACTIONS(3036),
    [anon_sym_restrict] = ACTIONS(3036),
    [anon_sym___restrict__] = ACTIONS(3036),
    [anon_sym__Atomic] = ACTIONS(3036),
    [anon_sym__Noreturn] = ACTIONS(3036),
    [anon_sym_noreturn] = ACTIONS(3036),
    [anon_sym_mutable] = ACTIONS(3036),
    [anon_sym_constinit] = ACTIONS(3036),
    [anon_sym_consteval] = ACTIONS(3036),
    [anon_sym_PROGMEM] = ACTIONS(3036),
    [aux_sym_primitive_type_token1] = ACTIONS(3036),
    [anon_sym_byte] = ACTIONS(3036),
    [anon_sym_word] = ACTIONS(3036),
    [anon_sym_enum] = ACTIONS(3036),
    [anon_sym_class] = ACTIONS(3036),
    [anon_sym_struct] = ACTIONS(3036),
    [anon_sym_union] = ACTIONS(3036),
    [anon_sym_if] = ACTIONS(3036),
    [anon_sym_switch] = ACTIONS(3036),
    [anon_sym_case] = ACTIONS(3036),
    [anon_sym_default] = ACTIONS(3036),
    [anon_sym_while] = ACTIONS(3036),
    [anon_sym_do] = ACTIONS(3036),
    [anon_sym_for] = ACTIONS(3036),
    [anon_sym_return] = ACTIONS(3036),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_continue] = ACTIONS(3036),
    [anon_sym_goto] = ACTIONS(3036),
    [anon_sym_not] = ACTIONS(3036),
    [anon_sym_compl] = ACTIONS(3036),
    [anon_sym_DASH_DASH] = ACTIONS(3038),
    [anon_sym_PLUS_PLUS] = ACTIONS(3038),
    [anon_sym_sizeof] = ACTIONS(3036),
    [anon_sym___alignof__] = ACTIONS(3036),
    [anon_sym___alignof] = ACTIONS(3036),
    [anon_sym__alignof] = ACTIONS(3036),
    [anon_sym_alignof] = ACTIONS(3036),
    [anon_sym__Alignof] = ACTIONS(3036),
    [anon_sym_offsetof] = ACTIONS(3036),
    [anon_sym__Generic] = ACTIONS(3036),
    [anon_sym_asm] = ACTIONS(3036),
    [anon_sym___asm__] = ACTIONS(3036),
    [aux_sym_number_literal_token1] = ACTIONS(3038),
    [aux_sym_number_literal_token2] = ACTIONS(3036),
    [anon_sym_L_SQUOTE] = ACTIONS(3038),
    [anon_sym_u_SQUOTE] = ACTIONS(3038),
    [anon_sym_U_SQUOTE] = ACTIONS(3038),
    [anon_sym_u8_SQUOTE] = ACTIONS(3038),
    [anon_sym_SQUOTE] = ACTIONS(3038),
    [anon_sym_L_DQUOTE] = ACTIONS(3038),
    [anon_sym_u_DQUOTE] = ACTIONS(3038),
    [anon_sym_U_DQUOTE] = ACTIONS(3038),
    [anon_sym_u8_DQUOTE] = ACTIONS(3038),
    [anon_sym_DQUOTE] = ACTIONS(3038),
    [sym_true] = ACTIONS(3036),
    [sym_false] = ACTIONS(3036),
    [anon_sym_NULL] = ACTIONS(3036),
    [anon_sym_nullptr] = ACTIONS(3036),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3036),
    [anon_sym_decltype] = ACTIONS(3036),
    [anon_sym_virtual] = ACTIONS(3036),
    [anon_sym_alignas] = ACTIONS(3036),
    [anon_sym_explicit] = ACTIONS(3036),
    [anon_sym_typename] = ACTIONS(3036),
    [anon_sym_template] = ACTIONS(3036),
    [anon_sym_operator] = ACTIONS(3036),
    [anon_sym_try] = ACTIONS(3036),
    [anon_sym_delete] = ACTIONS(3036),
    [anon_sym_throw] = ACTIONS(3036),
    [anon_sym_namespace] = ACTIONS(3036),
    [anon_sym_using] = ACTIONS(3036),
    [anon_sym_static_assert] = ACTIONS(3036),
    [anon_sym_concept] = ACTIONS(3036),
    [anon_sym_co_return] = ACTIONS(3036),
    [anon_sym_co_yield] = ACTIONS(3036),
    [anon_sym_R_DQUOTE] = ACTIONS(3038),
    [anon_sym_LR_DQUOTE] = ACTIONS(3038),
    [anon_sym_uR_DQUOTE] = ACTIONS(3038),
    [anon_sym_UR_DQUOTE] = ACTIONS(3038),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3038),
    [anon_sym_co_await] = ACTIONS(3036),
    [anon_sym_new] = ACTIONS(3036),
    [anon_sym_requires] = ACTIONS(3036),
    [sym_this] = ACTIONS(3036),
  },
  [845] = {
    [sym_preproc_def] = STATE(902),
    [sym_preproc_function_def] = STATE(902),
    [sym_preproc_call] = STATE(902),
    [sym_preproc_if_in_field_declaration_list] = STATE(902),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(902),
    [sym_type_definition] = STATE(902),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(5536),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(3150),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6010),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym__field_declaration_list_item] = STATE(902),
    [sym_field_declaration] = STATE(902),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1811),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(902),
    [sym_operator_cast] = STATE(6536),
    [sym_inline_method_definition] = STATE(902),
    [sym__constructor_specifiers] = STATE(1811),
    [sym_operator_cast_definition] = STATE(902),
    [sym_operator_cast_declaration] = STATE(902),
    [sym_constructor_or_destructor_definition] = STATE(902),
    [sym_constructor_or_destructor_declaration] = STATE(902),
    [sym_friend_declaration] = STATE(902),
    [sym_access_specifier] = STATE(7802),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(2618),
    [sym_template_function] = STATE(6098),
    [sym_using_declaration] = STATE(902),
    [sym_alias_declaration] = STATE(902),
    [sym_static_assert_declaration] = STATE(902),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5301),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_qualified_operator_cast_identifier] = STATE(6536),
    [sym_operator_name] = STATE(6098),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(902),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1961),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1811),
    [sym_identifier] = ACTIONS(2823),
    [aux_sym_preproc_def_token1] = ACTIONS(3364),
    [aux_sym_preproc_if_token1] = ACTIONS(3366),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3368),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3368),
    [sym_preproc_directive] = ACTIONS(3370),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(3372),
    [anon_sym_typedef] = ACTIONS(3374),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(2853),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_RBRACE] = ACTIONS(3422),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2857),
    [anon_sym_class] = ACTIONS(2859),
    [anon_sym_struct] = ACTIONS(2861),
    [anon_sym_union] = ACTIONS(2863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(2865),
    [anon_sym_template] = ACTIONS(3378),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3380),
    [anon_sym_public] = ACTIONS(2871),
    [anon_sym_private] = ACTIONS(2871),
    [anon_sym_protected] = ACTIONS(2871),
    [anon_sym_using] = ACTIONS(3382),
    [anon_sym_static_assert] = ACTIONS(3384),
  },
  [846] = {
    [ts_builtin_sym_end] = ACTIONS(3042),
    [sym_identifier] = ACTIONS(3040),
    [aux_sym_preproc_include_token1] = ACTIONS(3040),
    [aux_sym_preproc_def_token1] = ACTIONS(3040),
    [aux_sym_preproc_if_token1] = ACTIONS(3040),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3040),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3040),
    [sym_preproc_directive] = ACTIONS(3040),
    [anon_sym_LPAREN2] = ACTIONS(3042),
    [anon_sym_BANG] = ACTIONS(3042),
    [anon_sym_TILDE] = ACTIONS(3042),
    [anon_sym_DASH] = ACTIONS(3040),
    [anon_sym_PLUS] = ACTIONS(3040),
    [anon_sym_STAR] = ACTIONS(3042),
    [anon_sym_AMP_AMP] = ACTIONS(3042),
    [anon_sym_AMP] = ACTIONS(3040),
    [anon_sym___extension__] = ACTIONS(3040),
    [anon_sym_typedef] = ACTIONS(3040),
    [anon_sym_extern] = ACTIONS(3040),
    [anon_sym___attribute__] = ACTIONS(3040),
    [anon_sym_COLON_COLON] = ACTIONS(3042),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3042),
    [anon_sym___declspec] = ACTIONS(3040),
    [anon_sym___based] = ACTIONS(3040),
    [anon_sym___cdecl] = ACTIONS(3040),
    [anon_sym___clrcall] = ACTIONS(3040),
    [anon_sym___stdcall] = ACTIONS(3040),
    [anon_sym___fastcall] = ACTIONS(3040),
    [anon_sym___thiscall] = ACTIONS(3040),
    [anon_sym___vectorcall] = ACTIONS(3040),
    [anon_sym_LBRACE] = ACTIONS(3042),
    [anon_sym_signed] = ACTIONS(3040),
    [anon_sym_unsigned] = ACTIONS(3040),
    [anon_sym_long] = ACTIONS(3040),
    [anon_sym_short] = ACTIONS(3040),
    [anon_sym_LBRACK] = ACTIONS(3040),
    [anon_sym_static] = ACTIONS(3040),
    [anon_sym_register] = ACTIONS(3040),
    [anon_sym_inline] = ACTIONS(3040),
    [anon_sym___inline] = ACTIONS(3040),
    [anon_sym___inline__] = ACTIONS(3040),
    [anon_sym___forceinline] = ACTIONS(3040),
    [anon_sym_thread_local] = ACTIONS(3040),
    [anon_sym___thread] = ACTIONS(3040),
    [anon_sym_const] = ACTIONS(3040),
    [anon_sym_constexpr] = ACTIONS(3040),
    [anon_sym_volatile] = ACTIONS(3040),
    [anon_sym_restrict] = ACTIONS(3040),
    [anon_sym___restrict__] = ACTIONS(3040),
    [anon_sym__Atomic] = ACTIONS(3040),
    [anon_sym__Noreturn] = ACTIONS(3040),
    [anon_sym_noreturn] = ACTIONS(3040),
    [anon_sym_mutable] = ACTIONS(3040),
    [anon_sym_constinit] = ACTIONS(3040),
    [anon_sym_consteval] = ACTIONS(3040),
    [anon_sym_PROGMEM] = ACTIONS(3040),
    [aux_sym_primitive_type_token1] = ACTIONS(3040),
    [anon_sym_byte] = ACTIONS(3040),
    [anon_sym_word] = ACTIONS(3040),
    [anon_sym_enum] = ACTIONS(3040),
    [anon_sym_class] = ACTIONS(3040),
    [anon_sym_struct] = ACTIONS(3040),
    [anon_sym_union] = ACTIONS(3040),
    [anon_sym_if] = ACTIONS(3040),
    [anon_sym_switch] = ACTIONS(3040),
    [anon_sym_case] = ACTIONS(3040),
    [anon_sym_default] = ACTIONS(3040),
    [anon_sym_while] = ACTIONS(3040),
    [anon_sym_do] = ACTIONS(3040),
    [anon_sym_for] = ACTIONS(3040),
    [anon_sym_return] = ACTIONS(3040),
    [anon_sym_break] = ACTIONS(3040),
    [anon_sym_continue] = ACTIONS(3040),
    [anon_sym_goto] = ACTIONS(3040),
    [anon_sym_not] = ACTIONS(3040),
    [anon_sym_compl] = ACTIONS(3040),
    [anon_sym_DASH_DASH] = ACTIONS(3042),
    [anon_sym_PLUS_PLUS] = ACTIONS(3042),
    [anon_sym_sizeof] = ACTIONS(3040),
    [anon_sym___alignof__] = ACTIONS(3040),
    [anon_sym___alignof] = ACTIONS(3040),
    [anon_sym__alignof] = ACTIONS(3040),
    [anon_sym_alignof] = ACTIONS(3040),
    [anon_sym__Alignof] = ACTIONS(3040),
    [anon_sym_offsetof] = ACTIONS(3040),
    [anon_sym__Generic] = ACTIONS(3040),
    [anon_sym_asm] = ACTIONS(3040),
    [anon_sym___asm__] = ACTIONS(3040),
    [aux_sym_number_literal_token1] = ACTIONS(3042),
    [aux_sym_number_literal_token2] = ACTIONS(3040),
    [anon_sym_L_SQUOTE] = ACTIONS(3042),
    [anon_sym_u_SQUOTE] = ACTIONS(3042),
    [anon_sym_U_SQUOTE] = ACTIONS(3042),
    [anon_sym_u8_SQUOTE] = ACTIONS(3042),
    [anon_sym_SQUOTE] = ACTIONS(3042),
    [anon_sym_L_DQUOTE] = ACTIONS(3042),
    [anon_sym_u_DQUOTE] = ACTIONS(3042),
    [anon_sym_U_DQUOTE] = ACTIONS(3042),
    [anon_sym_u8_DQUOTE] = ACTIONS(3042),
    [anon_sym_DQUOTE] = ACTIONS(3042),
    [sym_true] = ACTIONS(3040),
    [sym_false] = ACTIONS(3040),
    [anon_sym_NULL] = ACTIONS(3040),
    [anon_sym_nullptr] = ACTIONS(3040),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3040),
    [anon_sym_decltype] = ACTIONS(3040),
    [anon_sym_virtual] = ACTIONS(3040),
    [anon_sym_alignas] = ACTIONS(3040),
    [anon_sym_explicit] = ACTIONS(3040),
    [anon_sym_typename] = ACTIONS(3040),
    [anon_sym_template] = ACTIONS(3040),
    [anon_sym_operator] = ACTIONS(3040),
    [anon_sym_try] = ACTIONS(3040),
    [anon_sym_delete] = ACTIONS(3040),
    [anon_sym_throw] = ACTIONS(3040),
    [anon_sym_namespace] = ACTIONS(3040),
    [anon_sym_using] = ACTIONS(3040),
    [anon_sym_static_assert] = ACTIONS(3040),
    [anon_sym_concept] = ACTIONS(3040),
    [anon_sym_co_return] = ACTIONS(3040),
    [anon_sym_co_yield] = ACTIONS(3040),
    [anon_sym_R_DQUOTE] = ACTIONS(3042),
    [anon_sym_LR_DQUOTE] = ACTIONS(3042),
    [anon_sym_uR_DQUOTE] = ACTIONS(3042),
    [anon_sym_UR_DQUOTE] = ACTIONS(3042),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3042),
    [anon_sym_co_await] = ACTIONS(3040),
    [anon_sym_new] = ACTIONS(3040),
    [anon_sym_requires] = ACTIONS(3040),
    [sym_this] = ACTIONS(3040),
  },
  [847] = {
    [sym_preproc_def] = STATE(847),
    [sym_preproc_function_def] = STATE(847),
    [sym_preproc_call] = STATE(847),
    [sym_preproc_if_in_field_declaration_list] = STATE(847),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(847),
    [sym_type_definition] = STATE(847),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(5543),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(3150),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6014),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym__field_declaration_list_item] = STATE(847),
    [sym_field_declaration] = STATE(847),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1892),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(847),
    [sym_operator_cast] = STATE(6512),
    [sym_inline_method_definition] = STATE(847),
    [sym__constructor_specifiers] = STATE(1892),
    [sym_operator_cast_definition] = STATE(847),
    [sym_operator_cast_declaration] = STATE(847),
    [sym_constructor_or_destructor_definition] = STATE(847),
    [sym_constructor_or_destructor_declaration] = STATE(847),
    [sym_friend_declaration] = STATE(847),
    [sym_access_specifier] = STATE(7720),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(2618),
    [sym_template_function] = STATE(6098),
    [sym_using_declaration] = STATE(847),
    [sym_alias_declaration] = STATE(847),
    [sym_static_assert_declaration] = STATE(847),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5301),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_qualified_operator_cast_identifier] = STATE(6512),
    [sym_operator_name] = STATE(6098),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(847),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1961),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1892),
    [sym_identifier] = ACTIONS(3216),
    [aux_sym_preproc_def_token1] = ACTIONS(3424),
    [aux_sym_preproc_if_token1] = ACTIONS(3427),
    [aux_sym_preproc_if_token2] = ACTIONS(3225),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3430),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3430),
    [sym_preproc_directive] = ACTIONS(3433),
    [anon_sym_LPAREN2] = ACTIONS(3233),
    [anon_sym_TILDE] = ACTIONS(3236),
    [anon_sym_STAR] = ACTIONS(3239),
    [anon_sym_AMP_AMP] = ACTIONS(3242),
    [anon_sym_AMP] = ACTIONS(3245),
    [anon_sym___extension__] = ACTIONS(3436),
    [anon_sym_typedef] = ACTIONS(3439),
    [anon_sym_extern] = ACTIONS(3254),
    [anon_sym___attribute__] = ACTIONS(3257),
    [anon_sym_COLON_COLON] = ACTIONS(3260),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3263),
    [anon_sym___declspec] = ACTIONS(3266),
    [anon_sym___based] = ACTIONS(3269),
    [anon_sym_signed] = ACTIONS(3272),
    [anon_sym_unsigned] = ACTIONS(3272),
    [anon_sym_long] = ACTIONS(3272),
    [anon_sym_short] = ACTIONS(3272),
    [anon_sym_LBRACK] = ACTIONS(3275),
    [anon_sym_static] = ACTIONS(3254),
    [anon_sym_register] = ACTIONS(3254),
    [anon_sym_inline] = ACTIONS(3254),
    [anon_sym___inline] = ACTIONS(3254),
    [anon_sym___inline__] = ACTIONS(3254),
    [anon_sym___forceinline] = ACTIONS(3254),
    [anon_sym_thread_local] = ACTIONS(3254),
    [anon_sym___thread] = ACTIONS(3254),
    [anon_sym_const] = ACTIONS(3278),
    [anon_sym_constexpr] = ACTIONS(3278),
    [anon_sym_volatile] = ACTIONS(3278),
    [anon_sym_restrict] = ACTIONS(3278),
    [anon_sym___restrict__] = ACTIONS(3278),
    [anon_sym__Atomic] = ACTIONS(3278),
    [anon_sym__Noreturn] = ACTIONS(3278),
    [anon_sym_noreturn] = ACTIONS(3278),
    [anon_sym_mutable] = ACTIONS(3278),
    [anon_sym_constinit] = ACTIONS(3278),
    [anon_sym_consteval] = ACTIONS(3278),
    [anon_sym_PROGMEM] = ACTIONS(3278),
    [aux_sym_primitive_type_token1] = ACTIONS(3281),
    [anon_sym_byte] = ACTIONS(3281),
    [anon_sym_word] = ACTIONS(3281),
    [anon_sym_enum] = ACTIONS(3284),
    [anon_sym_class] = ACTIONS(3287),
    [anon_sym_struct] = ACTIONS(3290),
    [anon_sym_union] = ACTIONS(3293),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3296),
    [anon_sym_decltype] = ACTIONS(3299),
    [anon_sym_virtual] = ACTIONS(3302),
    [anon_sym_alignas] = ACTIONS(3305),
    [anon_sym_explicit] = ACTIONS(3308),
    [anon_sym_typename] = ACTIONS(3311),
    [anon_sym_template] = ACTIONS(3442),
    [anon_sym_operator] = ACTIONS(3317),
    [anon_sym_friend] = ACTIONS(3445),
    [anon_sym_public] = ACTIONS(3323),
    [anon_sym_private] = ACTIONS(3323),
    [anon_sym_protected] = ACTIONS(3323),
    [anon_sym_using] = ACTIONS(3448),
    [anon_sym_static_assert] = ACTIONS(3451),
  },
  [848] = {
    [ts_builtin_sym_end] = ACTIONS(2943),
    [sym_identifier] = ACTIONS(2941),
    [aux_sym_preproc_include_token1] = ACTIONS(2941),
    [aux_sym_preproc_def_token1] = ACTIONS(2941),
    [aux_sym_preproc_if_token1] = ACTIONS(2941),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2941),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2941),
    [sym_preproc_directive] = ACTIONS(2941),
    [anon_sym_LPAREN2] = ACTIONS(2943),
    [anon_sym_BANG] = ACTIONS(2943),
    [anon_sym_TILDE] = ACTIONS(2943),
    [anon_sym_DASH] = ACTIONS(2941),
    [anon_sym_PLUS] = ACTIONS(2941),
    [anon_sym_STAR] = ACTIONS(2943),
    [anon_sym_AMP_AMP] = ACTIONS(2943),
    [anon_sym_AMP] = ACTIONS(2941),
    [anon_sym___extension__] = ACTIONS(2941),
    [anon_sym_typedef] = ACTIONS(2941),
    [anon_sym_extern] = ACTIONS(2941),
    [anon_sym___attribute__] = ACTIONS(2941),
    [anon_sym_COLON_COLON] = ACTIONS(2943),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2943),
    [anon_sym___declspec] = ACTIONS(2941),
    [anon_sym___based] = ACTIONS(2941),
    [anon_sym___cdecl] = ACTIONS(2941),
    [anon_sym___clrcall] = ACTIONS(2941),
    [anon_sym___stdcall] = ACTIONS(2941),
    [anon_sym___fastcall] = ACTIONS(2941),
    [anon_sym___thiscall] = ACTIONS(2941),
    [anon_sym___vectorcall] = ACTIONS(2941),
    [anon_sym_LBRACE] = ACTIONS(2943),
    [anon_sym_signed] = ACTIONS(2941),
    [anon_sym_unsigned] = ACTIONS(2941),
    [anon_sym_long] = ACTIONS(2941),
    [anon_sym_short] = ACTIONS(2941),
    [anon_sym_LBRACK] = ACTIONS(2941),
    [anon_sym_static] = ACTIONS(2941),
    [anon_sym_register] = ACTIONS(2941),
    [anon_sym_inline] = ACTIONS(2941),
    [anon_sym___inline] = ACTIONS(2941),
    [anon_sym___inline__] = ACTIONS(2941),
    [anon_sym___forceinline] = ACTIONS(2941),
    [anon_sym_thread_local] = ACTIONS(2941),
    [anon_sym___thread] = ACTIONS(2941),
    [anon_sym_const] = ACTIONS(2941),
    [anon_sym_constexpr] = ACTIONS(2941),
    [anon_sym_volatile] = ACTIONS(2941),
    [anon_sym_restrict] = ACTIONS(2941),
    [anon_sym___restrict__] = ACTIONS(2941),
    [anon_sym__Atomic] = ACTIONS(2941),
    [anon_sym__Noreturn] = ACTIONS(2941),
    [anon_sym_noreturn] = ACTIONS(2941),
    [anon_sym_mutable] = ACTIONS(2941),
    [anon_sym_constinit] = ACTIONS(2941),
    [anon_sym_consteval] = ACTIONS(2941),
    [anon_sym_PROGMEM] = ACTIONS(2941),
    [aux_sym_primitive_type_token1] = ACTIONS(2941),
    [anon_sym_byte] = ACTIONS(2941),
    [anon_sym_word] = ACTIONS(2941),
    [anon_sym_enum] = ACTIONS(2941),
    [anon_sym_class] = ACTIONS(2941),
    [anon_sym_struct] = ACTIONS(2941),
    [anon_sym_union] = ACTIONS(2941),
    [anon_sym_if] = ACTIONS(2941),
    [anon_sym_switch] = ACTIONS(2941),
    [anon_sym_case] = ACTIONS(2941),
    [anon_sym_default] = ACTIONS(2941),
    [anon_sym_while] = ACTIONS(2941),
    [anon_sym_do] = ACTIONS(2941),
    [anon_sym_for] = ACTIONS(2941),
    [anon_sym_return] = ACTIONS(2941),
    [anon_sym_break] = ACTIONS(2941),
    [anon_sym_continue] = ACTIONS(2941),
    [anon_sym_goto] = ACTIONS(2941),
    [anon_sym_not] = ACTIONS(2941),
    [anon_sym_compl] = ACTIONS(2941),
    [anon_sym_DASH_DASH] = ACTIONS(2943),
    [anon_sym_PLUS_PLUS] = ACTIONS(2943),
    [anon_sym_sizeof] = ACTIONS(2941),
    [anon_sym___alignof__] = ACTIONS(2941),
    [anon_sym___alignof] = ACTIONS(2941),
    [anon_sym__alignof] = ACTIONS(2941),
    [anon_sym_alignof] = ACTIONS(2941),
    [anon_sym__Alignof] = ACTIONS(2941),
    [anon_sym_offsetof] = ACTIONS(2941),
    [anon_sym__Generic] = ACTIONS(2941),
    [anon_sym_asm] = ACTIONS(2941),
    [anon_sym___asm__] = ACTIONS(2941),
    [aux_sym_number_literal_token1] = ACTIONS(2943),
    [aux_sym_number_literal_token2] = ACTIONS(2941),
    [anon_sym_L_SQUOTE] = ACTIONS(2943),
    [anon_sym_u_SQUOTE] = ACTIONS(2943),
    [anon_sym_U_SQUOTE] = ACTIONS(2943),
    [anon_sym_u8_SQUOTE] = ACTIONS(2943),
    [anon_sym_SQUOTE] = ACTIONS(2943),
    [anon_sym_L_DQUOTE] = ACTIONS(2943),
    [anon_sym_u_DQUOTE] = ACTIONS(2943),
    [anon_sym_U_DQUOTE] = ACTIONS(2943),
    [anon_sym_u8_DQUOTE] = ACTIONS(2943),
    [anon_sym_DQUOTE] = ACTIONS(2943),
    [sym_true] = ACTIONS(2941),
    [sym_false] = ACTIONS(2941),
    [anon_sym_NULL] = ACTIONS(2941),
    [anon_sym_nullptr] = ACTIONS(2941),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2941),
    [anon_sym_decltype] = ACTIONS(2941),
    [anon_sym_virtual] = ACTIONS(2941),
    [anon_sym_alignas] = ACTIONS(2941),
    [anon_sym_explicit] = ACTIONS(2941),
    [anon_sym_typename] = ACTIONS(2941),
    [anon_sym_template] = ACTIONS(2941),
    [anon_sym_operator] = ACTIONS(2941),
    [anon_sym_try] = ACTIONS(2941),
    [anon_sym_delete] = ACTIONS(2941),
    [anon_sym_throw] = ACTIONS(2941),
    [anon_sym_namespace] = ACTIONS(2941),
    [anon_sym_using] = ACTIONS(2941),
    [anon_sym_static_assert] = ACTIONS(2941),
    [anon_sym_concept] = ACTIONS(2941),
    [anon_sym_co_return] = ACTIONS(2941),
    [anon_sym_co_yield] = ACTIONS(2941),
    [anon_sym_R_DQUOTE] = ACTIONS(2943),
    [anon_sym_LR_DQUOTE] = ACTIONS(2943),
    [anon_sym_uR_DQUOTE] = ACTIONS(2943),
    [anon_sym_UR_DQUOTE] = ACTIONS(2943),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2943),
    [anon_sym_co_await] = ACTIONS(2941),
    [anon_sym_new] = ACTIONS(2941),
    [anon_sym_requires] = ACTIONS(2941),
    [sym_this] = ACTIONS(2941),
  },
  [849] = {
    [ts_builtin_sym_end] = ACTIONS(3062),
    [sym_identifier] = ACTIONS(3060),
    [aux_sym_preproc_include_token1] = ACTIONS(3060),
    [aux_sym_preproc_def_token1] = ACTIONS(3060),
    [aux_sym_preproc_if_token1] = ACTIONS(3060),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3060),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3060),
    [sym_preproc_directive] = ACTIONS(3060),
    [anon_sym_LPAREN2] = ACTIONS(3062),
    [anon_sym_BANG] = ACTIONS(3062),
    [anon_sym_TILDE] = ACTIONS(3062),
    [anon_sym_DASH] = ACTIONS(3060),
    [anon_sym_PLUS] = ACTIONS(3060),
    [anon_sym_STAR] = ACTIONS(3062),
    [anon_sym_AMP_AMP] = ACTIONS(3062),
    [anon_sym_AMP] = ACTIONS(3060),
    [anon_sym___extension__] = ACTIONS(3060),
    [anon_sym_typedef] = ACTIONS(3060),
    [anon_sym_extern] = ACTIONS(3060),
    [anon_sym___attribute__] = ACTIONS(3060),
    [anon_sym_COLON_COLON] = ACTIONS(3062),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3062),
    [anon_sym___declspec] = ACTIONS(3060),
    [anon_sym___based] = ACTIONS(3060),
    [anon_sym___cdecl] = ACTIONS(3060),
    [anon_sym___clrcall] = ACTIONS(3060),
    [anon_sym___stdcall] = ACTIONS(3060),
    [anon_sym___fastcall] = ACTIONS(3060),
    [anon_sym___thiscall] = ACTIONS(3060),
    [anon_sym___vectorcall] = ACTIONS(3060),
    [anon_sym_LBRACE] = ACTIONS(3062),
    [anon_sym_signed] = ACTIONS(3060),
    [anon_sym_unsigned] = ACTIONS(3060),
    [anon_sym_long] = ACTIONS(3060),
    [anon_sym_short] = ACTIONS(3060),
    [anon_sym_LBRACK] = ACTIONS(3060),
    [anon_sym_static] = ACTIONS(3060),
    [anon_sym_register] = ACTIONS(3060),
    [anon_sym_inline] = ACTIONS(3060),
    [anon_sym___inline] = ACTIONS(3060),
    [anon_sym___inline__] = ACTIONS(3060),
    [anon_sym___forceinline] = ACTIONS(3060),
    [anon_sym_thread_local] = ACTIONS(3060),
    [anon_sym___thread] = ACTIONS(3060),
    [anon_sym_const] = ACTIONS(3060),
    [anon_sym_constexpr] = ACTIONS(3060),
    [anon_sym_volatile] = ACTIONS(3060),
    [anon_sym_restrict] = ACTIONS(3060),
    [anon_sym___restrict__] = ACTIONS(3060),
    [anon_sym__Atomic] = ACTIONS(3060),
    [anon_sym__Noreturn] = ACTIONS(3060),
    [anon_sym_noreturn] = ACTIONS(3060),
    [anon_sym_mutable] = ACTIONS(3060),
    [anon_sym_constinit] = ACTIONS(3060),
    [anon_sym_consteval] = ACTIONS(3060),
    [anon_sym_PROGMEM] = ACTIONS(3060),
    [aux_sym_primitive_type_token1] = ACTIONS(3060),
    [anon_sym_byte] = ACTIONS(3060),
    [anon_sym_word] = ACTIONS(3060),
    [anon_sym_enum] = ACTIONS(3060),
    [anon_sym_class] = ACTIONS(3060),
    [anon_sym_struct] = ACTIONS(3060),
    [anon_sym_union] = ACTIONS(3060),
    [anon_sym_if] = ACTIONS(3060),
    [anon_sym_switch] = ACTIONS(3060),
    [anon_sym_case] = ACTIONS(3060),
    [anon_sym_default] = ACTIONS(3060),
    [anon_sym_while] = ACTIONS(3060),
    [anon_sym_do] = ACTIONS(3060),
    [anon_sym_for] = ACTIONS(3060),
    [anon_sym_return] = ACTIONS(3060),
    [anon_sym_break] = ACTIONS(3060),
    [anon_sym_continue] = ACTIONS(3060),
    [anon_sym_goto] = ACTIONS(3060),
    [anon_sym_not] = ACTIONS(3060),
    [anon_sym_compl] = ACTIONS(3060),
    [anon_sym_DASH_DASH] = ACTIONS(3062),
    [anon_sym_PLUS_PLUS] = ACTIONS(3062),
    [anon_sym_sizeof] = ACTIONS(3060),
    [anon_sym___alignof__] = ACTIONS(3060),
    [anon_sym___alignof] = ACTIONS(3060),
    [anon_sym__alignof] = ACTIONS(3060),
    [anon_sym_alignof] = ACTIONS(3060),
    [anon_sym__Alignof] = ACTIONS(3060),
    [anon_sym_offsetof] = ACTIONS(3060),
    [anon_sym__Generic] = ACTIONS(3060),
    [anon_sym_asm] = ACTIONS(3060),
    [anon_sym___asm__] = ACTIONS(3060),
    [aux_sym_number_literal_token1] = ACTIONS(3062),
    [aux_sym_number_literal_token2] = ACTIONS(3060),
    [anon_sym_L_SQUOTE] = ACTIONS(3062),
    [anon_sym_u_SQUOTE] = ACTIONS(3062),
    [anon_sym_U_SQUOTE] = ACTIONS(3062),
    [anon_sym_u8_SQUOTE] = ACTIONS(3062),
    [anon_sym_SQUOTE] = ACTIONS(3062),
    [anon_sym_L_DQUOTE] = ACTIONS(3062),
    [anon_sym_u_DQUOTE] = ACTIONS(3062),
    [anon_sym_U_DQUOTE] = ACTIONS(3062),
    [anon_sym_u8_DQUOTE] = ACTIONS(3062),
    [anon_sym_DQUOTE] = ACTIONS(3062),
    [sym_true] = ACTIONS(3060),
    [sym_false] = ACTIONS(3060),
    [anon_sym_NULL] = ACTIONS(3060),
    [anon_sym_nullptr] = ACTIONS(3060),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3060),
    [anon_sym_decltype] = ACTIONS(3060),
    [anon_sym_virtual] = ACTIONS(3060),
    [anon_sym_alignas] = ACTIONS(3060),
    [anon_sym_explicit] = ACTIONS(3060),
    [anon_sym_typename] = ACTIONS(3060),
    [anon_sym_template] = ACTIONS(3060),
    [anon_sym_operator] = ACTIONS(3060),
    [anon_sym_try] = ACTIONS(3060),
    [anon_sym_delete] = ACTIONS(3060),
    [anon_sym_throw] = ACTIONS(3060),
    [anon_sym_namespace] = ACTIONS(3060),
    [anon_sym_using] = ACTIONS(3060),
    [anon_sym_static_assert] = ACTIONS(3060),
    [anon_sym_concept] = ACTIONS(3060),
    [anon_sym_co_return] = ACTIONS(3060),
    [anon_sym_co_yield] = ACTIONS(3060),
    [anon_sym_R_DQUOTE] = ACTIONS(3062),
    [anon_sym_LR_DQUOTE] = ACTIONS(3062),
    [anon_sym_uR_DQUOTE] = ACTIONS(3062),
    [anon_sym_UR_DQUOTE] = ACTIONS(3062),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3062),
    [anon_sym_co_await] = ACTIONS(3060),
    [anon_sym_new] = ACTIONS(3060),
    [anon_sym_requires] = ACTIONS(3060),
    [sym_this] = ACTIONS(3060),
  },
  [850] = {
    [ts_builtin_sym_end] = ACTIONS(3074),
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [aux_sym_number_literal_token1] = ACTIONS(3074),
    [aux_sym_number_literal_token2] = ACTIONS(3072),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [851] = {
    [ts_builtin_sym_end] = ACTIONS(3134),
    [sym_identifier] = ACTIONS(3132),
    [aux_sym_preproc_include_token1] = ACTIONS(3132),
    [aux_sym_preproc_def_token1] = ACTIONS(3132),
    [aux_sym_preproc_if_token1] = ACTIONS(3132),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3132),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3132),
    [sym_preproc_directive] = ACTIONS(3132),
    [anon_sym_LPAREN2] = ACTIONS(3134),
    [anon_sym_BANG] = ACTIONS(3134),
    [anon_sym_TILDE] = ACTIONS(3134),
    [anon_sym_DASH] = ACTIONS(3132),
    [anon_sym_PLUS] = ACTIONS(3132),
    [anon_sym_STAR] = ACTIONS(3134),
    [anon_sym_AMP_AMP] = ACTIONS(3134),
    [anon_sym_AMP] = ACTIONS(3132),
    [anon_sym___extension__] = ACTIONS(3132),
    [anon_sym_typedef] = ACTIONS(3132),
    [anon_sym_extern] = ACTIONS(3132),
    [anon_sym___attribute__] = ACTIONS(3132),
    [anon_sym_COLON_COLON] = ACTIONS(3134),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3134),
    [anon_sym___declspec] = ACTIONS(3132),
    [anon_sym___based] = ACTIONS(3132),
    [anon_sym___cdecl] = ACTIONS(3132),
    [anon_sym___clrcall] = ACTIONS(3132),
    [anon_sym___stdcall] = ACTIONS(3132),
    [anon_sym___fastcall] = ACTIONS(3132),
    [anon_sym___thiscall] = ACTIONS(3132),
    [anon_sym___vectorcall] = ACTIONS(3132),
    [anon_sym_LBRACE] = ACTIONS(3134),
    [anon_sym_signed] = ACTIONS(3132),
    [anon_sym_unsigned] = ACTIONS(3132),
    [anon_sym_long] = ACTIONS(3132),
    [anon_sym_short] = ACTIONS(3132),
    [anon_sym_LBRACK] = ACTIONS(3132),
    [anon_sym_static] = ACTIONS(3132),
    [anon_sym_register] = ACTIONS(3132),
    [anon_sym_inline] = ACTIONS(3132),
    [anon_sym___inline] = ACTIONS(3132),
    [anon_sym___inline__] = ACTIONS(3132),
    [anon_sym___forceinline] = ACTIONS(3132),
    [anon_sym_thread_local] = ACTIONS(3132),
    [anon_sym___thread] = ACTIONS(3132),
    [anon_sym_const] = ACTIONS(3132),
    [anon_sym_constexpr] = ACTIONS(3132),
    [anon_sym_volatile] = ACTIONS(3132),
    [anon_sym_restrict] = ACTIONS(3132),
    [anon_sym___restrict__] = ACTIONS(3132),
    [anon_sym__Atomic] = ACTIONS(3132),
    [anon_sym__Noreturn] = ACTIONS(3132),
    [anon_sym_noreturn] = ACTIONS(3132),
    [anon_sym_mutable] = ACTIONS(3132),
    [anon_sym_constinit] = ACTIONS(3132),
    [anon_sym_consteval] = ACTIONS(3132),
    [anon_sym_PROGMEM] = ACTIONS(3132),
    [aux_sym_primitive_type_token1] = ACTIONS(3132),
    [anon_sym_byte] = ACTIONS(3132),
    [anon_sym_word] = ACTIONS(3132),
    [anon_sym_enum] = ACTIONS(3132),
    [anon_sym_class] = ACTIONS(3132),
    [anon_sym_struct] = ACTIONS(3132),
    [anon_sym_union] = ACTIONS(3132),
    [anon_sym_if] = ACTIONS(3132),
    [anon_sym_switch] = ACTIONS(3132),
    [anon_sym_case] = ACTIONS(3132),
    [anon_sym_default] = ACTIONS(3132),
    [anon_sym_while] = ACTIONS(3132),
    [anon_sym_do] = ACTIONS(3132),
    [anon_sym_for] = ACTIONS(3132),
    [anon_sym_return] = ACTIONS(3132),
    [anon_sym_break] = ACTIONS(3132),
    [anon_sym_continue] = ACTIONS(3132),
    [anon_sym_goto] = ACTIONS(3132),
    [anon_sym_not] = ACTIONS(3132),
    [anon_sym_compl] = ACTIONS(3132),
    [anon_sym_DASH_DASH] = ACTIONS(3134),
    [anon_sym_PLUS_PLUS] = ACTIONS(3134),
    [anon_sym_sizeof] = ACTIONS(3132),
    [anon_sym___alignof__] = ACTIONS(3132),
    [anon_sym___alignof] = ACTIONS(3132),
    [anon_sym__alignof] = ACTIONS(3132),
    [anon_sym_alignof] = ACTIONS(3132),
    [anon_sym__Alignof] = ACTIONS(3132),
    [anon_sym_offsetof] = ACTIONS(3132),
    [anon_sym__Generic] = ACTIONS(3132),
    [anon_sym_asm] = ACTIONS(3132),
    [anon_sym___asm__] = ACTIONS(3132),
    [aux_sym_number_literal_token1] = ACTIONS(3134),
    [aux_sym_number_literal_token2] = ACTIONS(3132),
    [anon_sym_L_SQUOTE] = ACTIONS(3134),
    [anon_sym_u_SQUOTE] = ACTIONS(3134),
    [anon_sym_U_SQUOTE] = ACTIONS(3134),
    [anon_sym_u8_SQUOTE] = ACTIONS(3134),
    [anon_sym_SQUOTE] = ACTIONS(3134),
    [anon_sym_L_DQUOTE] = ACTIONS(3134),
    [anon_sym_u_DQUOTE] = ACTIONS(3134),
    [anon_sym_U_DQUOTE] = ACTIONS(3134),
    [anon_sym_u8_DQUOTE] = ACTIONS(3134),
    [anon_sym_DQUOTE] = ACTIONS(3134),
    [sym_true] = ACTIONS(3132),
    [sym_false] = ACTIONS(3132),
    [anon_sym_NULL] = ACTIONS(3132),
    [anon_sym_nullptr] = ACTIONS(3132),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3132),
    [anon_sym_decltype] = ACTIONS(3132),
    [anon_sym_virtual] = ACTIONS(3132),
    [anon_sym_alignas] = ACTIONS(3132),
    [anon_sym_explicit] = ACTIONS(3132),
    [anon_sym_typename] = ACTIONS(3132),
    [anon_sym_template] = ACTIONS(3132),
    [anon_sym_operator] = ACTIONS(3132),
    [anon_sym_try] = ACTIONS(3132),
    [anon_sym_delete] = ACTIONS(3132),
    [anon_sym_throw] = ACTIONS(3132),
    [anon_sym_namespace] = ACTIONS(3132),
    [anon_sym_using] = ACTIONS(3132),
    [anon_sym_static_assert] = ACTIONS(3132),
    [anon_sym_concept] = ACTIONS(3132),
    [anon_sym_co_return] = ACTIONS(3132),
    [anon_sym_co_yield] = ACTIONS(3132),
    [anon_sym_R_DQUOTE] = ACTIONS(3134),
    [anon_sym_LR_DQUOTE] = ACTIONS(3134),
    [anon_sym_uR_DQUOTE] = ACTIONS(3134),
    [anon_sym_UR_DQUOTE] = ACTIONS(3134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3134),
    [anon_sym_co_await] = ACTIONS(3132),
    [anon_sym_new] = ACTIONS(3132),
    [anon_sym_requires] = ACTIONS(3132),
    [sym_this] = ACTIONS(3132),
  },
  [852] = {
    [ts_builtin_sym_end] = ACTIONS(2807),
    [sym_identifier] = ACTIONS(2805),
    [aux_sym_preproc_include_token1] = ACTIONS(2805),
    [aux_sym_preproc_def_token1] = ACTIONS(2805),
    [aux_sym_preproc_if_token1] = ACTIONS(2805),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2805),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2805),
    [sym_preproc_directive] = ACTIONS(2805),
    [anon_sym_LPAREN2] = ACTIONS(2807),
    [anon_sym_BANG] = ACTIONS(2807),
    [anon_sym_TILDE] = ACTIONS(2807),
    [anon_sym_DASH] = ACTIONS(2805),
    [anon_sym_PLUS] = ACTIONS(2805),
    [anon_sym_STAR] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2805),
    [anon_sym___extension__] = ACTIONS(2805),
    [anon_sym_typedef] = ACTIONS(2805),
    [anon_sym_extern] = ACTIONS(2805),
    [anon_sym___attribute__] = ACTIONS(2805),
    [anon_sym_COLON_COLON] = ACTIONS(2807),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2807),
    [anon_sym___declspec] = ACTIONS(2805),
    [anon_sym___based] = ACTIONS(2805),
    [anon_sym___cdecl] = ACTIONS(2805),
    [anon_sym___clrcall] = ACTIONS(2805),
    [anon_sym___stdcall] = ACTIONS(2805),
    [anon_sym___fastcall] = ACTIONS(2805),
    [anon_sym___thiscall] = ACTIONS(2805),
    [anon_sym___vectorcall] = ACTIONS(2805),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_signed] = ACTIONS(2805),
    [anon_sym_unsigned] = ACTIONS(2805),
    [anon_sym_long] = ACTIONS(2805),
    [anon_sym_short] = ACTIONS(2805),
    [anon_sym_LBRACK] = ACTIONS(2805),
    [anon_sym_static] = ACTIONS(2805),
    [anon_sym_register] = ACTIONS(2805),
    [anon_sym_inline] = ACTIONS(2805),
    [anon_sym___inline] = ACTIONS(2805),
    [anon_sym___inline__] = ACTIONS(2805),
    [anon_sym___forceinline] = ACTIONS(2805),
    [anon_sym_thread_local] = ACTIONS(2805),
    [anon_sym___thread] = ACTIONS(2805),
    [anon_sym_const] = ACTIONS(2805),
    [anon_sym_constexpr] = ACTIONS(2805),
    [anon_sym_volatile] = ACTIONS(2805),
    [anon_sym_restrict] = ACTIONS(2805),
    [anon_sym___restrict__] = ACTIONS(2805),
    [anon_sym__Atomic] = ACTIONS(2805),
    [anon_sym__Noreturn] = ACTIONS(2805),
    [anon_sym_noreturn] = ACTIONS(2805),
    [anon_sym_mutable] = ACTIONS(2805),
    [anon_sym_constinit] = ACTIONS(2805),
    [anon_sym_consteval] = ACTIONS(2805),
    [anon_sym_PROGMEM] = ACTIONS(2805),
    [aux_sym_primitive_type_token1] = ACTIONS(2805),
    [anon_sym_byte] = ACTIONS(2805),
    [anon_sym_word] = ACTIONS(2805),
    [anon_sym_enum] = ACTIONS(2805),
    [anon_sym_class] = ACTIONS(2805),
    [anon_sym_struct] = ACTIONS(2805),
    [anon_sym_union] = ACTIONS(2805),
    [anon_sym_if] = ACTIONS(2805),
    [anon_sym_switch] = ACTIONS(2805),
    [anon_sym_case] = ACTIONS(2805),
    [anon_sym_default] = ACTIONS(2805),
    [anon_sym_while] = ACTIONS(2805),
    [anon_sym_do] = ACTIONS(2805),
    [anon_sym_for] = ACTIONS(2805),
    [anon_sym_return] = ACTIONS(2805),
    [anon_sym_break] = ACTIONS(2805),
    [anon_sym_continue] = ACTIONS(2805),
    [anon_sym_goto] = ACTIONS(2805),
    [anon_sym_not] = ACTIONS(2805),
    [anon_sym_compl] = ACTIONS(2805),
    [anon_sym_DASH_DASH] = ACTIONS(2807),
    [anon_sym_PLUS_PLUS] = ACTIONS(2807),
    [anon_sym_sizeof] = ACTIONS(2805),
    [anon_sym___alignof__] = ACTIONS(2805),
    [anon_sym___alignof] = ACTIONS(2805),
    [anon_sym__alignof] = ACTIONS(2805),
    [anon_sym_alignof] = ACTIONS(2805),
    [anon_sym__Alignof] = ACTIONS(2805),
    [anon_sym_offsetof] = ACTIONS(2805),
    [anon_sym__Generic] = ACTIONS(2805),
    [anon_sym_asm] = ACTIONS(2805),
    [anon_sym___asm__] = ACTIONS(2805),
    [aux_sym_number_literal_token1] = ACTIONS(2807),
    [aux_sym_number_literal_token2] = ACTIONS(2805),
    [anon_sym_L_SQUOTE] = ACTIONS(2807),
    [anon_sym_u_SQUOTE] = ACTIONS(2807),
    [anon_sym_U_SQUOTE] = ACTIONS(2807),
    [anon_sym_u8_SQUOTE] = ACTIONS(2807),
    [anon_sym_SQUOTE] = ACTIONS(2807),
    [anon_sym_L_DQUOTE] = ACTIONS(2807),
    [anon_sym_u_DQUOTE] = ACTIONS(2807),
    [anon_sym_U_DQUOTE] = ACTIONS(2807),
    [anon_sym_u8_DQUOTE] = ACTIONS(2807),
    [anon_sym_DQUOTE] = ACTIONS(2807),
    [sym_true] = ACTIONS(2805),
    [sym_false] = ACTIONS(2805),
    [anon_sym_NULL] = ACTIONS(2805),
    [anon_sym_nullptr] = ACTIONS(2805),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2805),
    [anon_sym_decltype] = ACTIONS(2805),
    [anon_sym_virtual] = ACTIONS(2805),
    [anon_sym_alignas] = ACTIONS(2805),
    [anon_sym_explicit] = ACTIONS(2805),
    [anon_sym_typename] = ACTIONS(2805),
    [anon_sym_template] = ACTIONS(2805),
    [anon_sym_operator] = ACTIONS(2805),
    [anon_sym_try] = ACTIONS(2805),
    [anon_sym_delete] = ACTIONS(2805),
    [anon_sym_throw] = ACTIONS(2805),
    [anon_sym_namespace] = ACTIONS(2805),
    [anon_sym_using] = ACTIONS(2805),
    [anon_sym_static_assert] = ACTIONS(2805),
    [anon_sym_concept] = ACTIONS(2805),
    [anon_sym_co_return] = ACTIONS(2805),
    [anon_sym_co_yield] = ACTIONS(2805),
    [anon_sym_R_DQUOTE] = ACTIONS(2807),
    [anon_sym_LR_DQUOTE] = ACTIONS(2807),
    [anon_sym_uR_DQUOTE] = ACTIONS(2807),
    [anon_sym_UR_DQUOTE] = ACTIONS(2807),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2807),
    [anon_sym_co_await] = ACTIONS(2805),
    [anon_sym_new] = ACTIONS(2805),
    [anon_sym_requires] = ACTIONS(2805),
    [sym_this] = ACTIONS(2805),
  },
  [853] = {
    [ts_builtin_sym_end] = ACTIONS(2811),
    [sym_identifier] = ACTIONS(2809),
    [aux_sym_preproc_include_token1] = ACTIONS(2809),
    [aux_sym_preproc_def_token1] = ACTIONS(2809),
    [aux_sym_preproc_if_token1] = ACTIONS(2809),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2809),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2809),
    [sym_preproc_directive] = ACTIONS(2809),
    [anon_sym_LPAREN2] = ACTIONS(2811),
    [anon_sym_BANG] = ACTIONS(2811),
    [anon_sym_TILDE] = ACTIONS(2811),
    [anon_sym_DASH] = ACTIONS(2809),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_STAR] = ACTIONS(2811),
    [anon_sym_AMP_AMP] = ACTIONS(2811),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym___extension__] = ACTIONS(2809),
    [anon_sym_typedef] = ACTIONS(2809),
    [anon_sym_extern] = ACTIONS(2809),
    [anon_sym___attribute__] = ACTIONS(2809),
    [anon_sym_COLON_COLON] = ACTIONS(2811),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2811),
    [anon_sym___declspec] = ACTIONS(2809),
    [anon_sym___based] = ACTIONS(2809),
    [anon_sym___cdecl] = ACTIONS(2809),
    [anon_sym___clrcall] = ACTIONS(2809),
    [anon_sym___stdcall] = ACTIONS(2809),
    [anon_sym___fastcall] = ACTIONS(2809),
    [anon_sym___thiscall] = ACTIONS(2809),
    [anon_sym___vectorcall] = ACTIONS(2809),
    [anon_sym_LBRACE] = ACTIONS(2811),
    [anon_sym_signed] = ACTIONS(2809),
    [anon_sym_unsigned] = ACTIONS(2809),
    [anon_sym_long] = ACTIONS(2809),
    [anon_sym_short] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2809),
    [anon_sym_static] = ACTIONS(2809),
    [anon_sym_register] = ACTIONS(2809),
    [anon_sym_inline] = ACTIONS(2809),
    [anon_sym___inline] = ACTIONS(2809),
    [anon_sym___inline__] = ACTIONS(2809),
    [anon_sym___forceinline] = ACTIONS(2809),
    [anon_sym_thread_local] = ACTIONS(2809),
    [anon_sym___thread] = ACTIONS(2809),
    [anon_sym_const] = ACTIONS(2809),
    [anon_sym_constexpr] = ACTIONS(2809),
    [anon_sym_volatile] = ACTIONS(2809),
    [anon_sym_restrict] = ACTIONS(2809),
    [anon_sym___restrict__] = ACTIONS(2809),
    [anon_sym__Atomic] = ACTIONS(2809),
    [anon_sym__Noreturn] = ACTIONS(2809),
    [anon_sym_noreturn] = ACTIONS(2809),
    [anon_sym_mutable] = ACTIONS(2809),
    [anon_sym_constinit] = ACTIONS(2809),
    [anon_sym_consteval] = ACTIONS(2809),
    [anon_sym_PROGMEM] = ACTIONS(2809),
    [aux_sym_primitive_type_token1] = ACTIONS(2809),
    [anon_sym_byte] = ACTIONS(2809),
    [anon_sym_word] = ACTIONS(2809),
    [anon_sym_enum] = ACTIONS(2809),
    [anon_sym_class] = ACTIONS(2809),
    [anon_sym_struct] = ACTIONS(2809),
    [anon_sym_union] = ACTIONS(2809),
    [anon_sym_if] = ACTIONS(2809),
    [anon_sym_switch] = ACTIONS(2809),
    [anon_sym_case] = ACTIONS(2809),
    [anon_sym_default] = ACTIONS(2809),
    [anon_sym_while] = ACTIONS(2809),
    [anon_sym_do] = ACTIONS(2809),
    [anon_sym_for] = ACTIONS(2809),
    [anon_sym_return] = ACTIONS(2809),
    [anon_sym_break] = ACTIONS(2809),
    [anon_sym_continue] = ACTIONS(2809),
    [anon_sym_goto] = ACTIONS(2809),
    [anon_sym_not] = ACTIONS(2809),
    [anon_sym_compl] = ACTIONS(2809),
    [anon_sym_DASH_DASH] = ACTIONS(2811),
    [anon_sym_PLUS_PLUS] = ACTIONS(2811),
    [anon_sym_sizeof] = ACTIONS(2809),
    [anon_sym___alignof__] = ACTIONS(2809),
    [anon_sym___alignof] = ACTIONS(2809),
    [anon_sym__alignof] = ACTIONS(2809),
    [anon_sym_alignof] = ACTIONS(2809),
    [anon_sym__Alignof] = ACTIONS(2809),
    [anon_sym_offsetof] = ACTIONS(2809),
    [anon_sym__Generic] = ACTIONS(2809),
    [anon_sym_asm] = ACTIONS(2809),
    [anon_sym___asm__] = ACTIONS(2809),
    [aux_sym_number_literal_token1] = ACTIONS(2811),
    [aux_sym_number_literal_token2] = ACTIONS(2809),
    [anon_sym_L_SQUOTE] = ACTIONS(2811),
    [anon_sym_u_SQUOTE] = ACTIONS(2811),
    [anon_sym_U_SQUOTE] = ACTIONS(2811),
    [anon_sym_u8_SQUOTE] = ACTIONS(2811),
    [anon_sym_SQUOTE] = ACTIONS(2811),
    [anon_sym_L_DQUOTE] = ACTIONS(2811),
    [anon_sym_u_DQUOTE] = ACTIONS(2811),
    [anon_sym_U_DQUOTE] = ACTIONS(2811),
    [anon_sym_u8_DQUOTE] = ACTIONS(2811),
    [anon_sym_DQUOTE] = ACTIONS(2811),
    [sym_true] = ACTIONS(2809),
    [sym_false] = ACTIONS(2809),
    [anon_sym_NULL] = ACTIONS(2809),
    [anon_sym_nullptr] = ACTIONS(2809),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2809),
    [anon_sym_decltype] = ACTIONS(2809),
    [anon_sym_virtual] = ACTIONS(2809),
    [anon_sym_alignas] = ACTIONS(2809),
    [anon_sym_explicit] = ACTIONS(2809),
    [anon_sym_typename] = ACTIONS(2809),
    [anon_sym_template] = ACTIONS(2809),
    [anon_sym_operator] = ACTIONS(2809),
    [anon_sym_try] = ACTIONS(2809),
    [anon_sym_delete] = ACTIONS(2809),
    [anon_sym_throw] = ACTIONS(2809),
    [anon_sym_namespace] = ACTIONS(2809),
    [anon_sym_using] = ACTIONS(2809),
    [anon_sym_static_assert] = ACTIONS(2809),
    [anon_sym_concept] = ACTIONS(2809),
    [anon_sym_co_return] = ACTIONS(2809),
    [anon_sym_co_yield] = ACTIONS(2809),
    [anon_sym_R_DQUOTE] = ACTIONS(2811),
    [anon_sym_LR_DQUOTE] = ACTIONS(2811),
    [anon_sym_uR_DQUOTE] = ACTIONS(2811),
    [anon_sym_UR_DQUOTE] = ACTIONS(2811),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2811),
    [anon_sym_co_await] = ACTIONS(2809),
    [anon_sym_new] = ACTIONS(2809),
    [anon_sym_requires] = ACTIONS(2809),
    [sym_this] = ACTIONS(2809),
  },
  [854] = {
    [sym_preproc_def] = STATE(834),
    [sym_preproc_function_def] = STATE(834),
    [sym_preproc_call] = STATE(834),
    [sym_preproc_if_in_field_declaration_list] = STATE(834),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(834),
    [sym_type_definition] = STATE(834),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(5536),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(3150),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6010),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym__field_declaration_list_item] = STATE(834),
    [sym_field_declaration] = STATE(834),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1811),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(834),
    [sym_operator_cast] = STATE(6536),
    [sym_inline_method_definition] = STATE(834),
    [sym__constructor_specifiers] = STATE(1811),
    [sym_operator_cast_definition] = STATE(834),
    [sym_operator_cast_declaration] = STATE(834),
    [sym_constructor_or_destructor_definition] = STATE(834),
    [sym_constructor_or_destructor_declaration] = STATE(834),
    [sym_friend_declaration] = STATE(834),
    [sym_access_specifier] = STATE(7802),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(2618),
    [sym_template_function] = STATE(6098),
    [sym_using_declaration] = STATE(834),
    [sym_alias_declaration] = STATE(834),
    [sym_static_assert_declaration] = STATE(834),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5301),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_qualified_operator_cast_identifier] = STATE(6536),
    [sym_operator_name] = STATE(6098),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(834),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1961),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1811),
    [sym_identifier] = ACTIONS(2823),
    [aux_sym_preproc_def_token1] = ACTIONS(3364),
    [aux_sym_preproc_if_token1] = ACTIONS(3366),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3368),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3368),
    [sym_preproc_directive] = ACTIONS(3370),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(3372),
    [anon_sym_typedef] = ACTIONS(3374),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(2853),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_RBRACE] = ACTIONS(3454),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2857),
    [anon_sym_class] = ACTIONS(2859),
    [anon_sym_struct] = ACTIONS(2861),
    [anon_sym_union] = ACTIONS(2863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(2865),
    [anon_sym_template] = ACTIONS(3378),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3380),
    [anon_sym_public] = ACTIONS(2871),
    [anon_sym_private] = ACTIONS(2871),
    [anon_sym_protected] = ACTIONS(2871),
    [anon_sym_using] = ACTIONS(3382),
    [anon_sym_static_assert] = ACTIONS(3384),
  },
  [855] = {
    [ts_builtin_sym_end] = ACTIONS(2927),
    [sym_identifier] = ACTIONS(2925),
    [aux_sym_preproc_include_token1] = ACTIONS(2925),
    [aux_sym_preproc_def_token1] = ACTIONS(2925),
    [aux_sym_preproc_if_token1] = ACTIONS(2925),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2925),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2925),
    [sym_preproc_directive] = ACTIONS(2925),
    [anon_sym_LPAREN2] = ACTIONS(2927),
    [anon_sym_BANG] = ACTIONS(2927),
    [anon_sym_TILDE] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(2925),
    [anon_sym_PLUS] = ACTIONS(2925),
    [anon_sym_STAR] = ACTIONS(2927),
    [anon_sym_AMP_AMP] = ACTIONS(2927),
    [anon_sym_AMP] = ACTIONS(2925),
    [anon_sym___extension__] = ACTIONS(2925),
    [anon_sym_typedef] = ACTIONS(2925),
    [anon_sym_extern] = ACTIONS(2925),
    [anon_sym___attribute__] = ACTIONS(2925),
    [anon_sym_COLON_COLON] = ACTIONS(2927),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2927),
    [anon_sym___declspec] = ACTIONS(2925),
    [anon_sym___based] = ACTIONS(2925),
    [anon_sym___cdecl] = ACTIONS(2925),
    [anon_sym___clrcall] = ACTIONS(2925),
    [anon_sym___stdcall] = ACTIONS(2925),
    [anon_sym___fastcall] = ACTIONS(2925),
    [anon_sym___thiscall] = ACTIONS(2925),
    [anon_sym___vectorcall] = ACTIONS(2925),
    [anon_sym_LBRACE] = ACTIONS(2927),
    [anon_sym_signed] = ACTIONS(2925),
    [anon_sym_unsigned] = ACTIONS(2925),
    [anon_sym_long] = ACTIONS(2925),
    [anon_sym_short] = ACTIONS(2925),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_static] = ACTIONS(2925),
    [anon_sym_register] = ACTIONS(2925),
    [anon_sym_inline] = ACTIONS(2925),
    [anon_sym___inline] = ACTIONS(2925),
    [anon_sym___inline__] = ACTIONS(2925),
    [anon_sym___forceinline] = ACTIONS(2925),
    [anon_sym_thread_local] = ACTIONS(2925),
    [anon_sym___thread] = ACTIONS(2925),
    [anon_sym_const] = ACTIONS(2925),
    [anon_sym_constexpr] = ACTIONS(2925),
    [anon_sym_volatile] = ACTIONS(2925),
    [anon_sym_restrict] = ACTIONS(2925),
    [anon_sym___restrict__] = ACTIONS(2925),
    [anon_sym__Atomic] = ACTIONS(2925),
    [anon_sym__Noreturn] = ACTIONS(2925),
    [anon_sym_noreturn] = ACTIONS(2925),
    [anon_sym_mutable] = ACTIONS(2925),
    [anon_sym_constinit] = ACTIONS(2925),
    [anon_sym_consteval] = ACTIONS(2925),
    [anon_sym_PROGMEM] = ACTIONS(2925),
    [aux_sym_primitive_type_token1] = ACTIONS(2925),
    [anon_sym_byte] = ACTIONS(2925),
    [anon_sym_word] = ACTIONS(2925),
    [anon_sym_enum] = ACTIONS(2925),
    [anon_sym_class] = ACTIONS(2925),
    [anon_sym_struct] = ACTIONS(2925),
    [anon_sym_union] = ACTIONS(2925),
    [anon_sym_if] = ACTIONS(2925),
    [anon_sym_switch] = ACTIONS(2925),
    [anon_sym_case] = ACTIONS(2925),
    [anon_sym_default] = ACTIONS(2925),
    [anon_sym_while] = ACTIONS(2925),
    [anon_sym_do] = ACTIONS(2925),
    [anon_sym_for] = ACTIONS(2925),
    [anon_sym_return] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(2925),
    [anon_sym_continue] = ACTIONS(2925),
    [anon_sym_goto] = ACTIONS(2925),
    [anon_sym_not] = ACTIONS(2925),
    [anon_sym_compl] = ACTIONS(2925),
    [anon_sym_DASH_DASH] = ACTIONS(2927),
    [anon_sym_PLUS_PLUS] = ACTIONS(2927),
    [anon_sym_sizeof] = ACTIONS(2925),
    [anon_sym___alignof__] = ACTIONS(2925),
    [anon_sym___alignof] = ACTIONS(2925),
    [anon_sym__alignof] = ACTIONS(2925),
    [anon_sym_alignof] = ACTIONS(2925),
    [anon_sym__Alignof] = ACTIONS(2925),
    [anon_sym_offsetof] = ACTIONS(2925),
    [anon_sym__Generic] = ACTIONS(2925),
    [anon_sym_asm] = ACTIONS(2925),
    [anon_sym___asm__] = ACTIONS(2925),
    [aux_sym_number_literal_token1] = ACTIONS(2927),
    [aux_sym_number_literal_token2] = ACTIONS(2925),
    [anon_sym_L_SQUOTE] = ACTIONS(2927),
    [anon_sym_u_SQUOTE] = ACTIONS(2927),
    [anon_sym_U_SQUOTE] = ACTIONS(2927),
    [anon_sym_u8_SQUOTE] = ACTIONS(2927),
    [anon_sym_SQUOTE] = ACTIONS(2927),
    [anon_sym_L_DQUOTE] = ACTIONS(2927),
    [anon_sym_u_DQUOTE] = ACTIONS(2927),
    [anon_sym_U_DQUOTE] = ACTIONS(2927),
    [anon_sym_u8_DQUOTE] = ACTIONS(2927),
    [anon_sym_DQUOTE] = ACTIONS(2927),
    [sym_true] = ACTIONS(2925),
    [sym_false] = ACTIONS(2925),
    [anon_sym_NULL] = ACTIONS(2925),
    [anon_sym_nullptr] = ACTIONS(2925),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2925),
    [anon_sym_decltype] = ACTIONS(2925),
    [anon_sym_virtual] = ACTIONS(2925),
    [anon_sym_alignas] = ACTIONS(2925),
    [anon_sym_explicit] = ACTIONS(2925),
    [anon_sym_typename] = ACTIONS(2925),
    [anon_sym_template] = ACTIONS(2925),
    [anon_sym_operator] = ACTIONS(2925),
    [anon_sym_try] = ACTIONS(2925),
    [anon_sym_delete] = ACTIONS(2925),
    [anon_sym_throw] = ACTIONS(2925),
    [anon_sym_namespace] = ACTIONS(2925),
    [anon_sym_using] = ACTIONS(2925),
    [anon_sym_static_assert] = ACTIONS(2925),
    [anon_sym_concept] = ACTIONS(2925),
    [anon_sym_co_return] = ACTIONS(2925),
    [anon_sym_co_yield] = ACTIONS(2925),
    [anon_sym_R_DQUOTE] = ACTIONS(2927),
    [anon_sym_LR_DQUOTE] = ACTIONS(2927),
    [anon_sym_uR_DQUOTE] = ACTIONS(2927),
    [anon_sym_UR_DQUOTE] = ACTIONS(2927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2927),
    [anon_sym_co_await] = ACTIONS(2925),
    [anon_sym_new] = ACTIONS(2925),
    [anon_sym_requires] = ACTIONS(2925),
    [sym_this] = ACTIONS(2925),
  },
  [856] = {
    [ts_builtin_sym_end] = ACTIONS(3146),
    [sym_identifier] = ACTIONS(3144),
    [aux_sym_preproc_include_token1] = ACTIONS(3144),
    [aux_sym_preproc_def_token1] = ACTIONS(3144),
    [aux_sym_preproc_if_token1] = ACTIONS(3144),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3144),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3144),
    [sym_preproc_directive] = ACTIONS(3144),
    [anon_sym_LPAREN2] = ACTIONS(3146),
    [anon_sym_BANG] = ACTIONS(3146),
    [anon_sym_TILDE] = ACTIONS(3146),
    [anon_sym_DASH] = ACTIONS(3144),
    [anon_sym_PLUS] = ACTIONS(3144),
    [anon_sym_STAR] = ACTIONS(3146),
    [anon_sym_AMP_AMP] = ACTIONS(3146),
    [anon_sym_AMP] = ACTIONS(3144),
    [anon_sym___extension__] = ACTIONS(3144),
    [anon_sym_typedef] = ACTIONS(3144),
    [anon_sym_extern] = ACTIONS(3144),
    [anon_sym___attribute__] = ACTIONS(3144),
    [anon_sym_COLON_COLON] = ACTIONS(3146),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3146),
    [anon_sym___declspec] = ACTIONS(3144),
    [anon_sym___based] = ACTIONS(3144),
    [anon_sym___cdecl] = ACTIONS(3144),
    [anon_sym___clrcall] = ACTIONS(3144),
    [anon_sym___stdcall] = ACTIONS(3144),
    [anon_sym___fastcall] = ACTIONS(3144),
    [anon_sym___thiscall] = ACTIONS(3144),
    [anon_sym___vectorcall] = ACTIONS(3144),
    [anon_sym_LBRACE] = ACTIONS(3146),
    [anon_sym_signed] = ACTIONS(3144),
    [anon_sym_unsigned] = ACTIONS(3144),
    [anon_sym_long] = ACTIONS(3144),
    [anon_sym_short] = ACTIONS(3144),
    [anon_sym_LBRACK] = ACTIONS(3144),
    [anon_sym_static] = ACTIONS(3144),
    [anon_sym_register] = ACTIONS(3144),
    [anon_sym_inline] = ACTIONS(3144),
    [anon_sym___inline] = ACTIONS(3144),
    [anon_sym___inline__] = ACTIONS(3144),
    [anon_sym___forceinline] = ACTIONS(3144),
    [anon_sym_thread_local] = ACTIONS(3144),
    [anon_sym___thread] = ACTIONS(3144),
    [anon_sym_const] = ACTIONS(3144),
    [anon_sym_constexpr] = ACTIONS(3144),
    [anon_sym_volatile] = ACTIONS(3144),
    [anon_sym_restrict] = ACTIONS(3144),
    [anon_sym___restrict__] = ACTIONS(3144),
    [anon_sym__Atomic] = ACTIONS(3144),
    [anon_sym__Noreturn] = ACTIONS(3144),
    [anon_sym_noreturn] = ACTIONS(3144),
    [anon_sym_mutable] = ACTIONS(3144),
    [anon_sym_constinit] = ACTIONS(3144),
    [anon_sym_consteval] = ACTIONS(3144),
    [anon_sym_PROGMEM] = ACTIONS(3144),
    [aux_sym_primitive_type_token1] = ACTIONS(3144),
    [anon_sym_byte] = ACTIONS(3144),
    [anon_sym_word] = ACTIONS(3144),
    [anon_sym_enum] = ACTIONS(3144),
    [anon_sym_class] = ACTIONS(3144),
    [anon_sym_struct] = ACTIONS(3144),
    [anon_sym_union] = ACTIONS(3144),
    [anon_sym_if] = ACTIONS(3144),
    [anon_sym_switch] = ACTIONS(3144),
    [anon_sym_case] = ACTIONS(3144),
    [anon_sym_default] = ACTIONS(3144),
    [anon_sym_while] = ACTIONS(3144),
    [anon_sym_do] = ACTIONS(3144),
    [anon_sym_for] = ACTIONS(3144),
    [anon_sym_return] = ACTIONS(3144),
    [anon_sym_break] = ACTIONS(3144),
    [anon_sym_continue] = ACTIONS(3144),
    [anon_sym_goto] = ACTIONS(3144),
    [anon_sym_not] = ACTIONS(3144),
    [anon_sym_compl] = ACTIONS(3144),
    [anon_sym_DASH_DASH] = ACTIONS(3146),
    [anon_sym_PLUS_PLUS] = ACTIONS(3146),
    [anon_sym_sizeof] = ACTIONS(3144),
    [anon_sym___alignof__] = ACTIONS(3144),
    [anon_sym___alignof] = ACTIONS(3144),
    [anon_sym__alignof] = ACTIONS(3144),
    [anon_sym_alignof] = ACTIONS(3144),
    [anon_sym__Alignof] = ACTIONS(3144),
    [anon_sym_offsetof] = ACTIONS(3144),
    [anon_sym__Generic] = ACTIONS(3144),
    [anon_sym_asm] = ACTIONS(3144),
    [anon_sym___asm__] = ACTIONS(3144),
    [aux_sym_number_literal_token1] = ACTIONS(3146),
    [aux_sym_number_literal_token2] = ACTIONS(3144),
    [anon_sym_L_SQUOTE] = ACTIONS(3146),
    [anon_sym_u_SQUOTE] = ACTIONS(3146),
    [anon_sym_U_SQUOTE] = ACTIONS(3146),
    [anon_sym_u8_SQUOTE] = ACTIONS(3146),
    [anon_sym_SQUOTE] = ACTIONS(3146),
    [anon_sym_L_DQUOTE] = ACTIONS(3146),
    [anon_sym_u_DQUOTE] = ACTIONS(3146),
    [anon_sym_U_DQUOTE] = ACTIONS(3146),
    [anon_sym_u8_DQUOTE] = ACTIONS(3146),
    [anon_sym_DQUOTE] = ACTIONS(3146),
    [sym_true] = ACTIONS(3144),
    [sym_false] = ACTIONS(3144),
    [anon_sym_NULL] = ACTIONS(3144),
    [anon_sym_nullptr] = ACTIONS(3144),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3144),
    [anon_sym_decltype] = ACTIONS(3144),
    [anon_sym_virtual] = ACTIONS(3144),
    [anon_sym_alignas] = ACTIONS(3144),
    [anon_sym_explicit] = ACTIONS(3144),
    [anon_sym_typename] = ACTIONS(3144),
    [anon_sym_template] = ACTIONS(3144),
    [anon_sym_operator] = ACTIONS(3144),
    [anon_sym_try] = ACTIONS(3144),
    [anon_sym_delete] = ACTIONS(3144),
    [anon_sym_throw] = ACTIONS(3144),
    [anon_sym_namespace] = ACTIONS(3144),
    [anon_sym_using] = ACTIONS(3144),
    [anon_sym_static_assert] = ACTIONS(3144),
    [anon_sym_concept] = ACTIONS(3144),
    [anon_sym_co_return] = ACTIONS(3144),
    [anon_sym_co_yield] = ACTIONS(3144),
    [anon_sym_R_DQUOTE] = ACTIONS(3146),
    [anon_sym_LR_DQUOTE] = ACTIONS(3146),
    [anon_sym_uR_DQUOTE] = ACTIONS(3146),
    [anon_sym_UR_DQUOTE] = ACTIONS(3146),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3146),
    [anon_sym_co_await] = ACTIONS(3144),
    [anon_sym_new] = ACTIONS(3144),
    [anon_sym_requires] = ACTIONS(3144),
    [sym_this] = ACTIONS(3144),
  },
  [857] = {
    [ts_builtin_sym_end] = ACTIONS(2803),
    [sym_identifier] = ACTIONS(2801),
    [aux_sym_preproc_include_token1] = ACTIONS(2801),
    [aux_sym_preproc_def_token1] = ACTIONS(2801),
    [aux_sym_preproc_if_token1] = ACTIONS(2801),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2801),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2801),
    [sym_preproc_directive] = ACTIONS(2801),
    [anon_sym_LPAREN2] = ACTIONS(2803),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2801),
    [anon_sym_PLUS] = ACTIONS(2801),
    [anon_sym_STAR] = ACTIONS(2803),
    [anon_sym_AMP_AMP] = ACTIONS(2803),
    [anon_sym_AMP] = ACTIONS(2801),
    [anon_sym___extension__] = ACTIONS(2801),
    [anon_sym_typedef] = ACTIONS(2801),
    [anon_sym_extern] = ACTIONS(2801),
    [anon_sym___attribute__] = ACTIONS(2801),
    [anon_sym_COLON_COLON] = ACTIONS(2803),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2803),
    [anon_sym___declspec] = ACTIONS(2801),
    [anon_sym___based] = ACTIONS(2801),
    [anon_sym___cdecl] = ACTIONS(2801),
    [anon_sym___clrcall] = ACTIONS(2801),
    [anon_sym___stdcall] = ACTIONS(2801),
    [anon_sym___fastcall] = ACTIONS(2801),
    [anon_sym___thiscall] = ACTIONS(2801),
    [anon_sym___vectorcall] = ACTIONS(2801),
    [anon_sym_LBRACE] = ACTIONS(2803),
    [anon_sym_signed] = ACTIONS(2801),
    [anon_sym_unsigned] = ACTIONS(2801),
    [anon_sym_long] = ACTIONS(2801),
    [anon_sym_short] = ACTIONS(2801),
    [anon_sym_LBRACK] = ACTIONS(2801),
    [anon_sym_static] = ACTIONS(2801),
    [anon_sym_register] = ACTIONS(2801),
    [anon_sym_inline] = ACTIONS(2801),
    [anon_sym___inline] = ACTIONS(2801),
    [anon_sym___inline__] = ACTIONS(2801),
    [anon_sym___forceinline] = ACTIONS(2801),
    [anon_sym_thread_local] = ACTIONS(2801),
    [anon_sym___thread] = ACTIONS(2801),
    [anon_sym_const] = ACTIONS(2801),
    [anon_sym_constexpr] = ACTIONS(2801),
    [anon_sym_volatile] = ACTIONS(2801),
    [anon_sym_restrict] = ACTIONS(2801),
    [anon_sym___restrict__] = ACTIONS(2801),
    [anon_sym__Atomic] = ACTIONS(2801),
    [anon_sym__Noreturn] = ACTIONS(2801),
    [anon_sym_noreturn] = ACTIONS(2801),
    [anon_sym_mutable] = ACTIONS(2801),
    [anon_sym_constinit] = ACTIONS(2801),
    [anon_sym_consteval] = ACTIONS(2801),
    [anon_sym_PROGMEM] = ACTIONS(2801),
    [aux_sym_primitive_type_token1] = ACTIONS(2801),
    [anon_sym_byte] = ACTIONS(2801),
    [anon_sym_word] = ACTIONS(2801),
    [anon_sym_enum] = ACTIONS(2801),
    [anon_sym_class] = ACTIONS(2801),
    [anon_sym_struct] = ACTIONS(2801),
    [anon_sym_union] = ACTIONS(2801),
    [anon_sym_if] = ACTIONS(2801),
    [anon_sym_switch] = ACTIONS(2801),
    [anon_sym_case] = ACTIONS(2801),
    [anon_sym_default] = ACTIONS(2801),
    [anon_sym_while] = ACTIONS(2801),
    [anon_sym_do] = ACTIONS(2801),
    [anon_sym_for] = ACTIONS(2801),
    [anon_sym_return] = ACTIONS(2801),
    [anon_sym_break] = ACTIONS(2801),
    [anon_sym_continue] = ACTIONS(2801),
    [anon_sym_goto] = ACTIONS(2801),
    [anon_sym_not] = ACTIONS(2801),
    [anon_sym_compl] = ACTIONS(2801),
    [anon_sym_DASH_DASH] = ACTIONS(2803),
    [anon_sym_PLUS_PLUS] = ACTIONS(2803),
    [anon_sym_sizeof] = ACTIONS(2801),
    [anon_sym___alignof__] = ACTIONS(2801),
    [anon_sym___alignof] = ACTIONS(2801),
    [anon_sym__alignof] = ACTIONS(2801),
    [anon_sym_alignof] = ACTIONS(2801),
    [anon_sym__Alignof] = ACTIONS(2801),
    [anon_sym_offsetof] = ACTIONS(2801),
    [anon_sym__Generic] = ACTIONS(2801),
    [anon_sym_asm] = ACTIONS(2801),
    [anon_sym___asm__] = ACTIONS(2801),
    [aux_sym_number_literal_token1] = ACTIONS(2803),
    [aux_sym_number_literal_token2] = ACTIONS(2801),
    [anon_sym_L_SQUOTE] = ACTIONS(2803),
    [anon_sym_u_SQUOTE] = ACTIONS(2803),
    [anon_sym_U_SQUOTE] = ACTIONS(2803),
    [anon_sym_u8_SQUOTE] = ACTIONS(2803),
    [anon_sym_SQUOTE] = ACTIONS(2803),
    [anon_sym_L_DQUOTE] = ACTIONS(2803),
    [anon_sym_u_DQUOTE] = ACTIONS(2803),
    [anon_sym_U_DQUOTE] = ACTIONS(2803),
    [anon_sym_u8_DQUOTE] = ACTIONS(2803),
    [anon_sym_DQUOTE] = ACTIONS(2803),
    [sym_true] = ACTIONS(2801),
    [sym_false] = ACTIONS(2801),
    [anon_sym_NULL] = ACTIONS(2801),
    [anon_sym_nullptr] = ACTIONS(2801),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2801),
    [anon_sym_decltype] = ACTIONS(2801),
    [anon_sym_virtual] = ACTIONS(2801),
    [anon_sym_alignas] = ACTIONS(2801),
    [anon_sym_explicit] = ACTIONS(2801),
    [anon_sym_typename] = ACTIONS(2801),
    [anon_sym_template] = ACTIONS(2801),
    [anon_sym_operator] = ACTIONS(2801),
    [anon_sym_try] = ACTIONS(2801),
    [anon_sym_delete] = ACTIONS(2801),
    [anon_sym_throw] = ACTIONS(2801),
    [anon_sym_namespace] = ACTIONS(2801),
    [anon_sym_using] = ACTIONS(2801),
    [anon_sym_static_assert] = ACTIONS(2801),
    [anon_sym_concept] = ACTIONS(2801),
    [anon_sym_co_return] = ACTIONS(2801),
    [anon_sym_co_yield] = ACTIONS(2801),
    [anon_sym_R_DQUOTE] = ACTIONS(2803),
    [anon_sym_LR_DQUOTE] = ACTIONS(2803),
    [anon_sym_uR_DQUOTE] = ACTIONS(2803),
    [anon_sym_UR_DQUOTE] = ACTIONS(2803),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2803),
    [anon_sym_co_await] = ACTIONS(2801),
    [anon_sym_new] = ACTIONS(2801),
    [anon_sym_requires] = ACTIONS(2801),
    [sym_this] = ACTIONS(2801),
  },
  [858] = {
    [sym_preproc_def] = STATE(883),
    [sym_preproc_function_def] = STATE(883),
    [sym_preproc_call] = STATE(883),
    [sym_preproc_if_in_field_declaration_list] = STATE(883),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(883),
    [sym_type_definition] = STATE(883),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(5536),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(3150),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6010),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym__field_declaration_list_item] = STATE(883),
    [sym_field_declaration] = STATE(883),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1811),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(883),
    [sym_operator_cast] = STATE(6536),
    [sym_inline_method_definition] = STATE(883),
    [sym__constructor_specifiers] = STATE(1811),
    [sym_operator_cast_definition] = STATE(883),
    [sym_operator_cast_declaration] = STATE(883),
    [sym_constructor_or_destructor_definition] = STATE(883),
    [sym_constructor_or_destructor_declaration] = STATE(883),
    [sym_friend_declaration] = STATE(883),
    [sym_access_specifier] = STATE(7802),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(2618),
    [sym_template_function] = STATE(6098),
    [sym_using_declaration] = STATE(883),
    [sym_alias_declaration] = STATE(883),
    [sym_static_assert_declaration] = STATE(883),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5301),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_qualified_operator_cast_identifier] = STATE(6536),
    [sym_operator_name] = STATE(6098),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(883),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1961),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1811),
    [sym_identifier] = ACTIONS(2823),
    [aux_sym_preproc_def_token1] = ACTIONS(3364),
    [aux_sym_preproc_if_token1] = ACTIONS(3366),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3368),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3368),
    [sym_preproc_directive] = ACTIONS(3370),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(3372),
    [anon_sym_typedef] = ACTIONS(3374),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(2853),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_RBRACE] = ACTIONS(3456),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2857),
    [anon_sym_class] = ACTIONS(2859),
    [anon_sym_struct] = ACTIONS(2861),
    [anon_sym_union] = ACTIONS(2863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(2865),
    [anon_sym_template] = ACTIONS(3378),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3380),
    [anon_sym_public] = ACTIONS(2871),
    [anon_sym_private] = ACTIONS(2871),
    [anon_sym_protected] = ACTIONS(2871),
    [anon_sym_using] = ACTIONS(3382),
    [anon_sym_static_assert] = ACTIONS(3384),
  },
  [859] = {
    [sym_primitive_type] = STATE(6669),
    [sym__expression] = STATE(4347),
    [sym__expression_not_binary] = STATE(4648),
    [sym__string] = STATE(4648),
    [sym_conditional_expression] = STATE(4648),
    [sym_assignment_expression] = STATE(4648),
    [sym_pointer_expression] = STATE(3663),
    [sym_unary_expression] = STATE(4648),
    [sym_binary_expression] = STATE(4648),
    [sym_update_expression] = STATE(4648),
    [sym_cast_expression] = STATE(4648),
    [sym_sizeof_expression] = STATE(4648),
    [sym_alignof_expression] = STATE(4648),
    [sym_offsetof_expression] = STATE(4648),
    [sym_generic_expression] = STATE(4648),
    [sym_subscript_expression] = STATE(3663),
    [sym_call_expression] = STATE(3663),
    [sym_gnu_asm_expression] = STATE(4648),
    [sym_field_expression] = STATE(3663),
    [sym_compound_literal_expression] = STATE(4648),
    [sym_parenthesized_expression] = STATE(3663),
    [sym_initializer_list] = STATE(4660),
    [sym_number_literal] = STATE(4573),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4565),
    [sym_string_literal] = STATE(3707),
    [sym_null] = STATE(4648),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7442),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(4648),
    [sym_raw_string_literal] = STATE(3709),
    [sym_co_await_expression] = STATE(4648),
    [sym_new_expression] = STATE(4648),
    [sym_delete_expression] = STATE(4648),
    [sym_requires_clause] = STATE(4648),
    [sym_requires_expression] = STATE(4648),
    [sym_lambda_expression] = STATE(4648),
    [sym_lambda_capture_specifier] = STATE(5768),
    [sym_fold_expression] = STATE(4648),
    [sym_parameter_pack_expansion] = STATE(4648),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5512),
    [sym_qualified_identifier] = STATE(3663),
    [sym_qualified_type_identifier] = STATE(7442),
    [sym_user_defined_literal] = STATE(3663),
    [sym_identifier] = ACTIONS(3458),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1885),
    [anon_sym_COMMA] = ACTIONS(1885),
    [anon_sym_LPAREN2] = ACTIONS(1885),
    [anon_sym_BANG] = ACTIONS(2579),
    [anon_sym_TILDE] = ACTIONS(2577),
    [anon_sym_DASH] = ACTIONS(1883),
    [anon_sym_PLUS] = ACTIONS(1883),
    [anon_sym_STAR] = ACTIONS(1885),
    [anon_sym_SLASH] = ACTIONS(1883),
    [anon_sym_PERCENT] = ACTIONS(1885),
    [anon_sym_PIPE_PIPE] = ACTIONS(1885),
    [anon_sym_AMP_AMP] = ACTIONS(1885),
    [anon_sym_PIPE] = ACTIONS(1883),
    [anon_sym_CARET] = ACTIONS(1885),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym_EQ_EQ] = ACTIONS(1885),
    [anon_sym_BANG_EQ] = ACTIONS(1885),
    [anon_sym_GT] = ACTIONS(1883),
    [anon_sym_GT_EQ] = ACTIONS(1883),
    [anon_sym_LT_EQ] = ACTIONS(1883),
    [anon_sym_LT] = ACTIONS(1883),
    [anon_sym_LT_LT] = ACTIONS(1885),
    [anon_sym_GT_GT] = ACTIONS(1883),
    [anon_sym_COLON_COLON] = ACTIONS(2583),
    [anon_sym_LBRACE] = ACTIONS(3460),
    [anon_sym_LBRACK] = ACTIONS(1885),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_QMARK] = ACTIONS(1885),
    [anon_sym_not] = ACTIONS(2579),
    [anon_sym_compl] = ACTIONS(2579),
    [anon_sym_LT_EQ_GT] = ACTIONS(1885),
    [anon_sym_or] = ACTIONS(1883),
    [anon_sym_and] = ACTIONS(1883),
    [anon_sym_bitor] = ACTIONS(1883),
    [anon_sym_xor] = ACTIONS(1883),
    [anon_sym_bitand] = ACTIONS(1883),
    [anon_sym_not_eq] = ACTIONS(1883),
    [anon_sym_DASH_DASH] = ACTIONS(1885),
    [anon_sym_PLUS_PLUS] = ACTIONS(1885),
    [anon_sym_sizeof] = ACTIONS(2599),
    [anon_sym___alignof__] = ACTIONS(2601),
    [anon_sym___alignof] = ACTIONS(2601),
    [anon_sym__alignof] = ACTIONS(2601),
    [anon_sym_alignof] = ACTIONS(2601),
    [anon_sym__Alignof] = ACTIONS(2601),
    [anon_sym_offsetof] = ACTIONS(2603),
    [anon_sym__Generic] = ACTIONS(2605),
    [anon_sym_asm] = ACTIONS(2607),
    [anon_sym___asm__] = ACTIONS(2607),
    [anon_sym_DOT] = ACTIONS(1883),
    [anon_sym_DOT_STAR] = ACTIONS(1885),
    [anon_sym_DASH_GT] = ACTIONS(1885),
    [aux_sym_number_literal_token1] = ACTIONS(2609),
    [aux_sym_number_literal_token2] = ACTIONS(2611),
    [anon_sym_L_SQUOTE] = ACTIONS(2613),
    [anon_sym_u_SQUOTE] = ACTIONS(2613),
    [anon_sym_U_SQUOTE] = ACTIONS(2613),
    [anon_sym_u8_SQUOTE] = ACTIONS(2613),
    [anon_sym_SQUOTE] = ACTIONS(2613),
    [anon_sym_L_DQUOTE] = ACTIONS(2615),
    [anon_sym_u_DQUOTE] = ACTIONS(2615),
    [anon_sym_U_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8_DQUOTE] = ACTIONS(2615),
    [anon_sym_DQUOTE] = ACTIONS(2615),
    [sym_true] = ACTIONS(2617),
    [sym_false] = ACTIONS(2617),
    [anon_sym_NULL] = ACTIONS(2619),
    [anon_sym_nullptr] = ACTIONS(2619),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_GT2] = ACTIONS(1885),
    [anon_sym_delete] = ACTIONS(2629),
    [anon_sym_R_DQUOTE] = ACTIONS(2631),
    [anon_sym_LR_DQUOTE] = ACTIONS(2631),
    [anon_sym_uR_DQUOTE] = ACTIONS(2631),
    [anon_sym_UR_DQUOTE] = ACTIONS(2631),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2631),
    [anon_sym_co_await] = ACTIONS(2633),
    [anon_sym_new] = ACTIONS(2635),
    [anon_sym_requires] = ACTIONS(2637),
    [sym_this] = ACTIONS(2617),
  },
  [860] = {
    [ts_builtin_sym_end] = ACTIONS(2947),
    [sym_identifier] = ACTIONS(2945),
    [aux_sym_preproc_include_token1] = ACTIONS(2945),
    [aux_sym_preproc_def_token1] = ACTIONS(2945),
    [aux_sym_preproc_if_token1] = ACTIONS(2945),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2945),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2945),
    [sym_preproc_directive] = ACTIONS(2945),
    [anon_sym_LPAREN2] = ACTIONS(2947),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2947),
    [anon_sym_DASH] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(2945),
    [anon_sym_STAR] = ACTIONS(2947),
    [anon_sym_AMP_AMP] = ACTIONS(2947),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym___extension__] = ACTIONS(2945),
    [anon_sym_typedef] = ACTIONS(2945),
    [anon_sym_extern] = ACTIONS(2945),
    [anon_sym___attribute__] = ACTIONS(2945),
    [anon_sym_COLON_COLON] = ACTIONS(2947),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2947),
    [anon_sym___declspec] = ACTIONS(2945),
    [anon_sym___based] = ACTIONS(2945),
    [anon_sym___cdecl] = ACTIONS(2945),
    [anon_sym___clrcall] = ACTIONS(2945),
    [anon_sym___stdcall] = ACTIONS(2945),
    [anon_sym___fastcall] = ACTIONS(2945),
    [anon_sym___thiscall] = ACTIONS(2945),
    [anon_sym___vectorcall] = ACTIONS(2945),
    [anon_sym_LBRACE] = ACTIONS(2947),
    [anon_sym_signed] = ACTIONS(2945),
    [anon_sym_unsigned] = ACTIONS(2945),
    [anon_sym_long] = ACTIONS(2945),
    [anon_sym_short] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(2945),
    [anon_sym_static] = ACTIONS(2945),
    [anon_sym_register] = ACTIONS(2945),
    [anon_sym_inline] = ACTIONS(2945),
    [anon_sym___inline] = ACTIONS(2945),
    [anon_sym___inline__] = ACTIONS(2945),
    [anon_sym___forceinline] = ACTIONS(2945),
    [anon_sym_thread_local] = ACTIONS(2945),
    [anon_sym___thread] = ACTIONS(2945),
    [anon_sym_const] = ACTIONS(2945),
    [anon_sym_constexpr] = ACTIONS(2945),
    [anon_sym_volatile] = ACTIONS(2945),
    [anon_sym_restrict] = ACTIONS(2945),
    [anon_sym___restrict__] = ACTIONS(2945),
    [anon_sym__Atomic] = ACTIONS(2945),
    [anon_sym__Noreturn] = ACTIONS(2945),
    [anon_sym_noreturn] = ACTIONS(2945),
    [anon_sym_mutable] = ACTIONS(2945),
    [anon_sym_constinit] = ACTIONS(2945),
    [anon_sym_consteval] = ACTIONS(2945),
    [anon_sym_PROGMEM] = ACTIONS(2945),
    [aux_sym_primitive_type_token1] = ACTIONS(2945),
    [anon_sym_byte] = ACTIONS(2945),
    [anon_sym_word] = ACTIONS(2945),
    [anon_sym_enum] = ACTIONS(2945),
    [anon_sym_class] = ACTIONS(2945),
    [anon_sym_struct] = ACTIONS(2945),
    [anon_sym_union] = ACTIONS(2945),
    [anon_sym_if] = ACTIONS(2945),
    [anon_sym_switch] = ACTIONS(2945),
    [anon_sym_case] = ACTIONS(2945),
    [anon_sym_default] = ACTIONS(2945),
    [anon_sym_while] = ACTIONS(2945),
    [anon_sym_do] = ACTIONS(2945),
    [anon_sym_for] = ACTIONS(2945),
    [anon_sym_return] = ACTIONS(2945),
    [anon_sym_break] = ACTIONS(2945),
    [anon_sym_continue] = ACTIONS(2945),
    [anon_sym_goto] = ACTIONS(2945),
    [anon_sym_not] = ACTIONS(2945),
    [anon_sym_compl] = ACTIONS(2945),
    [anon_sym_DASH_DASH] = ACTIONS(2947),
    [anon_sym_PLUS_PLUS] = ACTIONS(2947),
    [anon_sym_sizeof] = ACTIONS(2945),
    [anon_sym___alignof__] = ACTIONS(2945),
    [anon_sym___alignof] = ACTIONS(2945),
    [anon_sym__alignof] = ACTIONS(2945),
    [anon_sym_alignof] = ACTIONS(2945),
    [anon_sym__Alignof] = ACTIONS(2945),
    [anon_sym_offsetof] = ACTIONS(2945),
    [anon_sym__Generic] = ACTIONS(2945),
    [anon_sym_asm] = ACTIONS(2945),
    [anon_sym___asm__] = ACTIONS(2945),
    [aux_sym_number_literal_token1] = ACTIONS(2947),
    [aux_sym_number_literal_token2] = ACTIONS(2945),
    [anon_sym_L_SQUOTE] = ACTIONS(2947),
    [anon_sym_u_SQUOTE] = ACTIONS(2947),
    [anon_sym_U_SQUOTE] = ACTIONS(2947),
    [anon_sym_u8_SQUOTE] = ACTIONS(2947),
    [anon_sym_SQUOTE] = ACTIONS(2947),
    [anon_sym_L_DQUOTE] = ACTIONS(2947),
    [anon_sym_u_DQUOTE] = ACTIONS(2947),
    [anon_sym_U_DQUOTE] = ACTIONS(2947),
    [anon_sym_u8_DQUOTE] = ACTIONS(2947),
    [anon_sym_DQUOTE] = ACTIONS(2947),
    [sym_true] = ACTIONS(2945),
    [sym_false] = ACTIONS(2945),
    [anon_sym_NULL] = ACTIONS(2945),
    [anon_sym_nullptr] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2945),
    [anon_sym_decltype] = ACTIONS(2945),
    [anon_sym_virtual] = ACTIONS(2945),
    [anon_sym_alignas] = ACTIONS(2945),
    [anon_sym_explicit] = ACTIONS(2945),
    [anon_sym_typename] = ACTIONS(2945),
    [anon_sym_template] = ACTIONS(2945),
    [anon_sym_operator] = ACTIONS(2945),
    [anon_sym_try] = ACTIONS(2945),
    [anon_sym_delete] = ACTIONS(2945),
    [anon_sym_throw] = ACTIONS(2945),
    [anon_sym_namespace] = ACTIONS(2945),
    [anon_sym_using] = ACTIONS(2945),
    [anon_sym_static_assert] = ACTIONS(2945),
    [anon_sym_concept] = ACTIONS(2945),
    [anon_sym_co_return] = ACTIONS(2945),
    [anon_sym_co_yield] = ACTIONS(2945),
    [anon_sym_R_DQUOTE] = ACTIONS(2947),
    [anon_sym_LR_DQUOTE] = ACTIONS(2947),
    [anon_sym_uR_DQUOTE] = ACTIONS(2947),
    [anon_sym_UR_DQUOTE] = ACTIONS(2947),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2947),
    [anon_sym_co_await] = ACTIONS(2945),
    [anon_sym_new] = ACTIONS(2945),
    [anon_sym_requires] = ACTIONS(2945),
    [sym_this] = ACTIONS(2945),
  },
  [861] = {
    [sym_preproc_def] = STATE(912),
    [sym_preproc_function_def] = STATE(912),
    [sym_preproc_call] = STATE(912),
    [sym_preproc_if_in_field_declaration_list] = STATE(912),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(912),
    [sym_type_definition] = STATE(912),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(5536),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(3150),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6010),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym__field_declaration_list_item] = STATE(912),
    [sym_field_declaration] = STATE(912),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1811),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(912),
    [sym_operator_cast] = STATE(6536),
    [sym_inline_method_definition] = STATE(912),
    [sym__constructor_specifiers] = STATE(1811),
    [sym_operator_cast_definition] = STATE(912),
    [sym_operator_cast_declaration] = STATE(912),
    [sym_constructor_or_destructor_definition] = STATE(912),
    [sym_constructor_or_destructor_declaration] = STATE(912),
    [sym_friend_declaration] = STATE(912),
    [sym_access_specifier] = STATE(7802),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(2618),
    [sym_template_function] = STATE(6098),
    [sym_using_declaration] = STATE(912),
    [sym_alias_declaration] = STATE(912),
    [sym_static_assert_declaration] = STATE(912),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5301),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_qualified_operator_cast_identifier] = STATE(6536),
    [sym_operator_name] = STATE(6098),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(912),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1961),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1811),
    [sym_identifier] = ACTIONS(2823),
    [aux_sym_preproc_def_token1] = ACTIONS(3364),
    [aux_sym_preproc_if_token1] = ACTIONS(3366),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3368),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3368),
    [sym_preproc_directive] = ACTIONS(3370),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(3372),
    [anon_sym_typedef] = ACTIONS(3374),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(2853),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_RBRACE] = ACTIONS(3462),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2857),
    [anon_sym_class] = ACTIONS(2859),
    [anon_sym_struct] = ACTIONS(2861),
    [anon_sym_union] = ACTIONS(2863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(2865),
    [anon_sym_template] = ACTIONS(3378),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3380),
    [anon_sym_public] = ACTIONS(2871),
    [anon_sym_private] = ACTIONS(2871),
    [anon_sym_protected] = ACTIONS(2871),
    [anon_sym_using] = ACTIONS(3382),
    [anon_sym_static_assert] = ACTIONS(3384),
  },
  [862] = {
    [ts_builtin_sym_end] = ACTIONS(3176),
    [sym_identifier] = ACTIONS(3174),
    [aux_sym_preproc_include_token1] = ACTIONS(3174),
    [aux_sym_preproc_def_token1] = ACTIONS(3174),
    [aux_sym_preproc_if_token1] = ACTIONS(3174),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3174),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3174),
    [sym_preproc_directive] = ACTIONS(3174),
    [anon_sym_LPAREN2] = ACTIONS(3176),
    [anon_sym_BANG] = ACTIONS(3176),
    [anon_sym_TILDE] = ACTIONS(3176),
    [anon_sym_DASH] = ACTIONS(3174),
    [anon_sym_PLUS] = ACTIONS(3174),
    [anon_sym_STAR] = ACTIONS(3176),
    [anon_sym_AMP_AMP] = ACTIONS(3176),
    [anon_sym_AMP] = ACTIONS(3174),
    [anon_sym___extension__] = ACTIONS(3174),
    [anon_sym_typedef] = ACTIONS(3174),
    [anon_sym_extern] = ACTIONS(3174),
    [anon_sym___attribute__] = ACTIONS(3174),
    [anon_sym_COLON_COLON] = ACTIONS(3176),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3176),
    [anon_sym___declspec] = ACTIONS(3174),
    [anon_sym___based] = ACTIONS(3174),
    [anon_sym___cdecl] = ACTIONS(3174),
    [anon_sym___clrcall] = ACTIONS(3174),
    [anon_sym___stdcall] = ACTIONS(3174),
    [anon_sym___fastcall] = ACTIONS(3174),
    [anon_sym___thiscall] = ACTIONS(3174),
    [anon_sym___vectorcall] = ACTIONS(3174),
    [anon_sym_LBRACE] = ACTIONS(3176),
    [anon_sym_signed] = ACTIONS(3174),
    [anon_sym_unsigned] = ACTIONS(3174),
    [anon_sym_long] = ACTIONS(3174),
    [anon_sym_short] = ACTIONS(3174),
    [anon_sym_LBRACK] = ACTIONS(3174),
    [anon_sym_static] = ACTIONS(3174),
    [anon_sym_register] = ACTIONS(3174),
    [anon_sym_inline] = ACTIONS(3174),
    [anon_sym___inline] = ACTIONS(3174),
    [anon_sym___inline__] = ACTIONS(3174),
    [anon_sym___forceinline] = ACTIONS(3174),
    [anon_sym_thread_local] = ACTIONS(3174),
    [anon_sym___thread] = ACTIONS(3174),
    [anon_sym_const] = ACTIONS(3174),
    [anon_sym_constexpr] = ACTIONS(3174),
    [anon_sym_volatile] = ACTIONS(3174),
    [anon_sym_restrict] = ACTIONS(3174),
    [anon_sym___restrict__] = ACTIONS(3174),
    [anon_sym__Atomic] = ACTIONS(3174),
    [anon_sym__Noreturn] = ACTIONS(3174),
    [anon_sym_noreturn] = ACTIONS(3174),
    [anon_sym_mutable] = ACTIONS(3174),
    [anon_sym_constinit] = ACTIONS(3174),
    [anon_sym_consteval] = ACTIONS(3174),
    [anon_sym_PROGMEM] = ACTIONS(3174),
    [aux_sym_primitive_type_token1] = ACTIONS(3174),
    [anon_sym_byte] = ACTIONS(3174),
    [anon_sym_word] = ACTIONS(3174),
    [anon_sym_enum] = ACTIONS(3174),
    [anon_sym_class] = ACTIONS(3174),
    [anon_sym_struct] = ACTIONS(3174),
    [anon_sym_union] = ACTIONS(3174),
    [anon_sym_if] = ACTIONS(3174),
    [anon_sym_switch] = ACTIONS(3174),
    [anon_sym_case] = ACTIONS(3174),
    [anon_sym_default] = ACTIONS(3174),
    [anon_sym_while] = ACTIONS(3174),
    [anon_sym_do] = ACTIONS(3174),
    [anon_sym_for] = ACTIONS(3174),
    [anon_sym_return] = ACTIONS(3174),
    [anon_sym_break] = ACTIONS(3174),
    [anon_sym_continue] = ACTIONS(3174),
    [anon_sym_goto] = ACTIONS(3174),
    [anon_sym_not] = ACTIONS(3174),
    [anon_sym_compl] = ACTIONS(3174),
    [anon_sym_DASH_DASH] = ACTIONS(3176),
    [anon_sym_PLUS_PLUS] = ACTIONS(3176),
    [anon_sym_sizeof] = ACTIONS(3174),
    [anon_sym___alignof__] = ACTIONS(3174),
    [anon_sym___alignof] = ACTIONS(3174),
    [anon_sym__alignof] = ACTIONS(3174),
    [anon_sym_alignof] = ACTIONS(3174),
    [anon_sym__Alignof] = ACTIONS(3174),
    [anon_sym_offsetof] = ACTIONS(3174),
    [anon_sym__Generic] = ACTIONS(3174),
    [anon_sym_asm] = ACTIONS(3174),
    [anon_sym___asm__] = ACTIONS(3174),
    [aux_sym_number_literal_token1] = ACTIONS(3176),
    [aux_sym_number_literal_token2] = ACTIONS(3174),
    [anon_sym_L_SQUOTE] = ACTIONS(3176),
    [anon_sym_u_SQUOTE] = ACTIONS(3176),
    [anon_sym_U_SQUOTE] = ACTIONS(3176),
    [anon_sym_u8_SQUOTE] = ACTIONS(3176),
    [anon_sym_SQUOTE] = ACTIONS(3176),
    [anon_sym_L_DQUOTE] = ACTIONS(3176),
    [anon_sym_u_DQUOTE] = ACTIONS(3176),
    [anon_sym_U_DQUOTE] = ACTIONS(3176),
    [anon_sym_u8_DQUOTE] = ACTIONS(3176),
    [anon_sym_DQUOTE] = ACTIONS(3176),
    [sym_true] = ACTIONS(3174),
    [sym_false] = ACTIONS(3174),
    [anon_sym_NULL] = ACTIONS(3174),
    [anon_sym_nullptr] = ACTIONS(3174),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3174),
    [anon_sym_decltype] = ACTIONS(3174),
    [anon_sym_virtual] = ACTIONS(3174),
    [anon_sym_alignas] = ACTIONS(3174),
    [anon_sym_explicit] = ACTIONS(3174),
    [anon_sym_typename] = ACTIONS(3174),
    [anon_sym_template] = ACTIONS(3174),
    [anon_sym_operator] = ACTIONS(3174),
    [anon_sym_try] = ACTIONS(3174),
    [anon_sym_delete] = ACTIONS(3174),
    [anon_sym_throw] = ACTIONS(3174),
    [anon_sym_namespace] = ACTIONS(3174),
    [anon_sym_using] = ACTIONS(3174),
    [anon_sym_static_assert] = ACTIONS(3174),
    [anon_sym_concept] = ACTIONS(3174),
    [anon_sym_co_return] = ACTIONS(3174),
    [anon_sym_co_yield] = ACTIONS(3174),
    [anon_sym_R_DQUOTE] = ACTIONS(3176),
    [anon_sym_LR_DQUOTE] = ACTIONS(3176),
    [anon_sym_uR_DQUOTE] = ACTIONS(3176),
    [anon_sym_UR_DQUOTE] = ACTIONS(3176),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3176),
    [anon_sym_co_await] = ACTIONS(3174),
    [anon_sym_new] = ACTIONS(3174),
    [anon_sym_requires] = ACTIONS(3174),
    [sym_this] = ACTIONS(3174),
  },
  [863] = {
    [sym_preproc_def] = STATE(894),
    [sym_preproc_function_def] = STATE(894),
    [sym_preproc_call] = STATE(894),
    [sym_preproc_if_in_field_declaration_list] = STATE(894),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(894),
    [sym_type_definition] = STATE(894),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(5536),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(3150),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6010),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym__field_declaration_list_item] = STATE(894),
    [sym_field_declaration] = STATE(894),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1811),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(894),
    [sym_operator_cast] = STATE(6536),
    [sym_inline_method_definition] = STATE(894),
    [sym__constructor_specifiers] = STATE(1811),
    [sym_operator_cast_definition] = STATE(894),
    [sym_operator_cast_declaration] = STATE(894),
    [sym_constructor_or_destructor_definition] = STATE(894),
    [sym_constructor_or_destructor_declaration] = STATE(894),
    [sym_friend_declaration] = STATE(894),
    [sym_access_specifier] = STATE(7802),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(2618),
    [sym_template_function] = STATE(6098),
    [sym_using_declaration] = STATE(894),
    [sym_alias_declaration] = STATE(894),
    [sym_static_assert_declaration] = STATE(894),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5301),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_qualified_operator_cast_identifier] = STATE(6536),
    [sym_operator_name] = STATE(6098),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(894),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1961),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1811),
    [sym_identifier] = ACTIONS(2823),
    [aux_sym_preproc_def_token1] = ACTIONS(3364),
    [aux_sym_preproc_if_token1] = ACTIONS(3366),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3368),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3368),
    [sym_preproc_directive] = ACTIONS(3370),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(3372),
    [anon_sym_typedef] = ACTIONS(3374),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(2853),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_RBRACE] = ACTIONS(3464),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2857),
    [anon_sym_class] = ACTIONS(2859),
    [anon_sym_struct] = ACTIONS(2861),
    [anon_sym_union] = ACTIONS(2863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(2865),
    [anon_sym_template] = ACTIONS(3378),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3380),
    [anon_sym_public] = ACTIONS(2871),
    [anon_sym_private] = ACTIONS(2871),
    [anon_sym_protected] = ACTIONS(2871),
    [anon_sym_using] = ACTIONS(3382),
    [anon_sym_static_assert] = ACTIONS(3384),
  },
  [864] = {
    [ts_builtin_sym_end] = ACTIONS(3070),
    [sym_identifier] = ACTIONS(3068),
    [aux_sym_preproc_include_token1] = ACTIONS(3068),
    [aux_sym_preproc_def_token1] = ACTIONS(3068),
    [aux_sym_preproc_if_token1] = ACTIONS(3068),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3068),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3068),
    [sym_preproc_directive] = ACTIONS(3068),
    [anon_sym_LPAREN2] = ACTIONS(3070),
    [anon_sym_BANG] = ACTIONS(3070),
    [anon_sym_TILDE] = ACTIONS(3070),
    [anon_sym_DASH] = ACTIONS(3068),
    [anon_sym_PLUS] = ACTIONS(3068),
    [anon_sym_STAR] = ACTIONS(3070),
    [anon_sym_AMP_AMP] = ACTIONS(3070),
    [anon_sym_AMP] = ACTIONS(3068),
    [anon_sym___extension__] = ACTIONS(3068),
    [anon_sym_typedef] = ACTIONS(3068),
    [anon_sym_extern] = ACTIONS(3068),
    [anon_sym___attribute__] = ACTIONS(3068),
    [anon_sym_COLON_COLON] = ACTIONS(3070),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3070),
    [anon_sym___declspec] = ACTIONS(3068),
    [anon_sym___based] = ACTIONS(3068),
    [anon_sym___cdecl] = ACTIONS(3068),
    [anon_sym___clrcall] = ACTIONS(3068),
    [anon_sym___stdcall] = ACTIONS(3068),
    [anon_sym___fastcall] = ACTIONS(3068),
    [anon_sym___thiscall] = ACTIONS(3068),
    [anon_sym___vectorcall] = ACTIONS(3068),
    [anon_sym_LBRACE] = ACTIONS(3070),
    [anon_sym_signed] = ACTIONS(3068),
    [anon_sym_unsigned] = ACTIONS(3068),
    [anon_sym_long] = ACTIONS(3068),
    [anon_sym_short] = ACTIONS(3068),
    [anon_sym_LBRACK] = ACTIONS(3068),
    [anon_sym_static] = ACTIONS(3068),
    [anon_sym_register] = ACTIONS(3068),
    [anon_sym_inline] = ACTIONS(3068),
    [anon_sym___inline] = ACTIONS(3068),
    [anon_sym___inline__] = ACTIONS(3068),
    [anon_sym___forceinline] = ACTIONS(3068),
    [anon_sym_thread_local] = ACTIONS(3068),
    [anon_sym___thread] = ACTIONS(3068),
    [anon_sym_const] = ACTIONS(3068),
    [anon_sym_constexpr] = ACTIONS(3068),
    [anon_sym_volatile] = ACTIONS(3068),
    [anon_sym_restrict] = ACTIONS(3068),
    [anon_sym___restrict__] = ACTIONS(3068),
    [anon_sym__Atomic] = ACTIONS(3068),
    [anon_sym__Noreturn] = ACTIONS(3068),
    [anon_sym_noreturn] = ACTIONS(3068),
    [anon_sym_mutable] = ACTIONS(3068),
    [anon_sym_constinit] = ACTIONS(3068),
    [anon_sym_consteval] = ACTIONS(3068),
    [anon_sym_PROGMEM] = ACTIONS(3068),
    [aux_sym_primitive_type_token1] = ACTIONS(3068),
    [anon_sym_byte] = ACTIONS(3068),
    [anon_sym_word] = ACTIONS(3068),
    [anon_sym_enum] = ACTIONS(3068),
    [anon_sym_class] = ACTIONS(3068),
    [anon_sym_struct] = ACTIONS(3068),
    [anon_sym_union] = ACTIONS(3068),
    [anon_sym_if] = ACTIONS(3068),
    [anon_sym_switch] = ACTIONS(3068),
    [anon_sym_case] = ACTIONS(3068),
    [anon_sym_default] = ACTIONS(3068),
    [anon_sym_while] = ACTIONS(3068),
    [anon_sym_do] = ACTIONS(3068),
    [anon_sym_for] = ACTIONS(3068),
    [anon_sym_return] = ACTIONS(3068),
    [anon_sym_break] = ACTIONS(3068),
    [anon_sym_continue] = ACTIONS(3068),
    [anon_sym_goto] = ACTIONS(3068),
    [anon_sym_not] = ACTIONS(3068),
    [anon_sym_compl] = ACTIONS(3068),
    [anon_sym_DASH_DASH] = ACTIONS(3070),
    [anon_sym_PLUS_PLUS] = ACTIONS(3070),
    [anon_sym_sizeof] = ACTIONS(3068),
    [anon_sym___alignof__] = ACTIONS(3068),
    [anon_sym___alignof] = ACTIONS(3068),
    [anon_sym__alignof] = ACTIONS(3068),
    [anon_sym_alignof] = ACTIONS(3068),
    [anon_sym__Alignof] = ACTIONS(3068),
    [anon_sym_offsetof] = ACTIONS(3068),
    [anon_sym__Generic] = ACTIONS(3068),
    [anon_sym_asm] = ACTIONS(3068),
    [anon_sym___asm__] = ACTIONS(3068),
    [aux_sym_number_literal_token1] = ACTIONS(3070),
    [aux_sym_number_literal_token2] = ACTIONS(3068),
    [anon_sym_L_SQUOTE] = ACTIONS(3070),
    [anon_sym_u_SQUOTE] = ACTIONS(3070),
    [anon_sym_U_SQUOTE] = ACTIONS(3070),
    [anon_sym_u8_SQUOTE] = ACTIONS(3070),
    [anon_sym_SQUOTE] = ACTIONS(3070),
    [anon_sym_L_DQUOTE] = ACTIONS(3070),
    [anon_sym_u_DQUOTE] = ACTIONS(3070),
    [anon_sym_U_DQUOTE] = ACTIONS(3070),
    [anon_sym_u8_DQUOTE] = ACTIONS(3070),
    [anon_sym_DQUOTE] = ACTIONS(3070),
    [sym_true] = ACTIONS(3068),
    [sym_false] = ACTIONS(3068),
    [anon_sym_NULL] = ACTIONS(3068),
    [anon_sym_nullptr] = ACTIONS(3068),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3068),
    [anon_sym_decltype] = ACTIONS(3068),
    [anon_sym_virtual] = ACTIONS(3068),
    [anon_sym_alignas] = ACTIONS(3068),
    [anon_sym_explicit] = ACTIONS(3068),
    [anon_sym_typename] = ACTIONS(3068),
    [anon_sym_template] = ACTIONS(3068),
    [anon_sym_operator] = ACTIONS(3068),
    [anon_sym_try] = ACTIONS(3068),
    [anon_sym_delete] = ACTIONS(3068),
    [anon_sym_throw] = ACTIONS(3068),
    [anon_sym_namespace] = ACTIONS(3068),
    [anon_sym_using] = ACTIONS(3068),
    [anon_sym_static_assert] = ACTIONS(3068),
    [anon_sym_concept] = ACTIONS(3068),
    [anon_sym_co_return] = ACTIONS(3068),
    [anon_sym_co_yield] = ACTIONS(3068),
    [anon_sym_R_DQUOTE] = ACTIONS(3070),
    [anon_sym_LR_DQUOTE] = ACTIONS(3070),
    [anon_sym_uR_DQUOTE] = ACTIONS(3070),
    [anon_sym_UR_DQUOTE] = ACTIONS(3070),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3070),
    [anon_sym_co_await] = ACTIONS(3068),
    [anon_sym_new] = ACTIONS(3068),
    [anon_sym_requires] = ACTIONS(3068),
    [sym_this] = ACTIONS(3068),
  },
  [865] = {
    [ts_builtin_sym_end] = ACTIONS(3128),
    [sym_identifier] = ACTIONS(3126),
    [aux_sym_preproc_include_token1] = ACTIONS(3126),
    [aux_sym_preproc_def_token1] = ACTIONS(3126),
    [aux_sym_preproc_if_token1] = ACTIONS(3126),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3126),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3126),
    [sym_preproc_directive] = ACTIONS(3126),
    [anon_sym_LPAREN2] = ACTIONS(3128),
    [anon_sym_BANG] = ACTIONS(3128),
    [anon_sym_TILDE] = ACTIONS(3128),
    [anon_sym_DASH] = ACTIONS(3126),
    [anon_sym_PLUS] = ACTIONS(3126),
    [anon_sym_STAR] = ACTIONS(3128),
    [anon_sym_AMP_AMP] = ACTIONS(3128),
    [anon_sym_AMP] = ACTIONS(3126),
    [anon_sym___extension__] = ACTIONS(3126),
    [anon_sym_typedef] = ACTIONS(3126),
    [anon_sym_extern] = ACTIONS(3126),
    [anon_sym___attribute__] = ACTIONS(3126),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3128),
    [anon_sym___declspec] = ACTIONS(3126),
    [anon_sym___based] = ACTIONS(3126),
    [anon_sym___cdecl] = ACTIONS(3126),
    [anon_sym___clrcall] = ACTIONS(3126),
    [anon_sym___stdcall] = ACTIONS(3126),
    [anon_sym___fastcall] = ACTIONS(3126),
    [anon_sym___thiscall] = ACTIONS(3126),
    [anon_sym___vectorcall] = ACTIONS(3126),
    [anon_sym_LBRACE] = ACTIONS(3128),
    [anon_sym_signed] = ACTIONS(3126),
    [anon_sym_unsigned] = ACTIONS(3126),
    [anon_sym_long] = ACTIONS(3126),
    [anon_sym_short] = ACTIONS(3126),
    [anon_sym_LBRACK] = ACTIONS(3126),
    [anon_sym_static] = ACTIONS(3126),
    [anon_sym_register] = ACTIONS(3126),
    [anon_sym_inline] = ACTIONS(3126),
    [anon_sym___inline] = ACTIONS(3126),
    [anon_sym___inline__] = ACTIONS(3126),
    [anon_sym___forceinline] = ACTIONS(3126),
    [anon_sym_thread_local] = ACTIONS(3126),
    [anon_sym___thread] = ACTIONS(3126),
    [anon_sym_const] = ACTIONS(3126),
    [anon_sym_constexpr] = ACTIONS(3126),
    [anon_sym_volatile] = ACTIONS(3126),
    [anon_sym_restrict] = ACTIONS(3126),
    [anon_sym___restrict__] = ACTIONS(3126),
    [anon_sym__Atomic] = ACTIONS(3126),
    [anon_sym__Noreturn] = ACTIONS(3126),
    [anon_sym_noreturn] = ACTIONS(3126),
    [anon_sym_mutable] = ACTIONS(3126),
    [anon_sym_constinit] = ACTIONS(3126),
    [anon_sym_consteval] = ACTIONS(3126),
    [anon_sym_PROGMEM] = ACTIONS(3126),
    [aux_sym_primitive_type_token1] = ACTIONS(3126),
    [anon_sym_byte] = ACTIONS(3126),
    [anon_sym_word] = ACTIONS(3126),
    [anon_sym_enum] = ACTIONS(3126),
    [anon_sym_class] = ACTIONS(3126),
    [anon_sym_struct] = ACTIONS(3126),
    [anon_sym_union] = ACTIONS(3126),
    [anon_sym_if] = ACTIONS(3126),
    [anon_sym_switch] = ACTIONS(3126),
    [anon_sym_case] = ACTIONS(3126),
    [anon_sym_default] = ACTIONS(3126),
    [anon_sym_while] = ACTIONS(3126),
    [anon_sym_do] = ACTIONS(3126),
    [anon_sym_for] = ACTIONS(3126),
    [anon_sym_return] = ACTIONS(3126),
    [anon_sym_break] = ACTIONS(3126),
    [anon_sym_continue] = ACTIONS(3126),
    [anon_sym_goto] = ACTIONS(3126),
    [anon_sym_not] = ACTIONS(3126),
    [anon_sym_compl] = ACTIONS(3126),
    [anon_sym_DASH_DASH] = ACTIONS(3128),
    [anon_sym_PLUS_PLUS] = ACTIONS(3128),
    [anon_sym_sizeof] = ACTIONS(3126),
    [anon_sym___alignof__] = ACTIONS(3126),
    [anon_sym___alignof] = ACTIONS(3126),
    [anon_sym__alignof] = ACTIONS(3126),
    [anon_sym_alignof] = ACTIONS(3126),
    [anon_sym__Alignof] = ACTIONS(3126),
    [anon_sym_offsetof] = ACTIONS(3126),
    [anon_sym__Generic] = ACTIONS(3126),
    [anon_sym_asm] = ACTIONS(3126),
    [anon_sym___asm__] = ACTIONS(3126),
    [aux_sym_number_literal_token1] = ACTIONS(3128),
    [aux_sym_number_literal_token2] = ACTIONS(3126),
    [anon_sym_L_SQUOTE] = ACTIONS(3128),
    [anon_sym_u_SQUOTE] = ACTIONS(3128),
    [anon_sym_U_SQUOTE] = ACTIONS(3128),
    [anon_sym_u8_SQUOTE] = ACTIONS(3128),
    [anon_sym_SQUOTE] = ACTIONS(3128),
    [anon_sym_L_DQUOTE] = ACTIONS(3128),
    [anon_sym_u_DQUOTE] = ACTIONS(3128),
    [anon_sym_U_DQUOTE] = ACTIONS(3128),
    [anon_sym_u8_DQUOTE] = ACTIONS(3128),
    [anon_sym_DQUOTE] = ACTIONS(3128),
    [sym_true] = ACTIONS(3126),
    [sym_false] = ACTIONS(3126),
    [anon_sym_NULL] = ACTIONS(3126),
    [anon_sym_nullptr] = ACTIONS(3126),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3126),
    [anon_sym_decltype] = ACTIONS(3126),
    [anon_sym_virtual] = ACTIONS(3126),
    [anon_sym_alignas] = ACTIONS(3126),
    [anon_sym_explicit] = ACTIONS(3126),
    [anon_sym_typename] = ACTIONS(3126),
    [anon_sym_template] = ACTIONS(3126),
    [anon_sym_operator] = ACTIONS(3126),
    [anon_sym_try] = ACTIONS(3126),
    [anon_sym_delete] = ACTIONS(3126),
    [anon_sym_throw] = ACTIONS(3126),
    [anon_sym_namespace] = ACTIONS(3126),
    [anon_sym_using] = ACTIONS(3126),
    [anon_sym_static_assert] = ACTIONS(3126),
    [anon_sym_concept] = ACTIONS(3126),
    [anon_sym_co_return] = ACTIONS(3126),
    [anon_sym_co_yield] = ACTIONS(3126),
    [anon_sym_R_DQUOTE] = ACTIONS(3128),
    [anon_sym_LR_DQUOTE] = ACTIONS(3128),
    [anon_sym_uR_DQUOTE] = ACTIONS(3128),
    [anon_sym_UR_DQUOTE] = ACTIONS(3128),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3128),
    [anon_sym_co_await] = ACTIONS(3126),
    [anon_sym_new] = ACTIONS(3126),
    [anon_sym_requires] = ACTIONS(3126),
    [sym_this] = ACTIONS(3126),
  },
  [866] = {
    [ts_builtin_sym_end] = ACTIONS(3466),
    [sym_identifier] = ACTIONS(3468),
    [aux_sym_preproc_include_token1] = ACTIONS(3468),
    [aux_sym_preproc_def_token1] = ACTIONS(3468),
    [aux_sym_preproc_if_token1] = ACTIONS(3468),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3468),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3468),
    [sym_preproc_directive] = ACTIONS(3468),
    [anon_sym_LPAREN2] = ACTIONS(3466),
    [anon_sym_BANG] = ACTIONS(3466),
    [anon_sym_TILDE] = ACTIONS(3466),
    [anon_sym_DASH] = ACTIONS(3468),
    [anon_sym_PLUS] = ACTIONS(3468),
    [anon_sym_STAR] = ACTIONS(3466),
    [anon_sym_AMP_AMP] = ACTIONS(3466),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym___extension__] = ACTIONS(3468),
    [anon_sym_typedef] = ACTIONS(3468),
    [anon_sym_extern] = ACTIONS(3468),
    [anon_sym___attribute__] = ACTIONS(3468),
    [anon_sym_COLON_COLON] = ACTIONS(3466),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3466),
    [anon_sym___declspec] = ACTIONS(3468),
    [anon_sym___based] = ACTIONS(3468),
    [anon_sym___cdecl] = ACTIONS(3468),
    [anon_sym___clrcall] = ACTIONS(3468),
    [anon_sym___stdcall] = ACTIONS(3468),
    [anon_sym___fastcall] = ACTIONS(3468),
    [anon_sym___thiscall] = ACTIONS(3468),
    [anon_sym___vectorcall] = ACTIONS(3468),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_signed] = ACTIONS(3468),
    [anon_sym_unsigned] = ACTIONS(3468),
    [anon_sym_long] = ACTIONS(3468),
    [anon_sym_short] = ACTIONS(3468),
    [anon_sym_LBRACK] = ACTIONS(3468),
    [anon_sym_static] = ACTIONS(3468),
    [anon_sym_register] = ACTIONS(3468),
    [anon_sym_inline] = ACTIONS(3468),
    [anon_sym___inline] = ACTIONS(3468),
    [anon_sym___inline__] = ACTIONS(3468),
    [anon_sym___forceinline] = ACTIONS(3468),
    [anon_sym_thread_local] = ACTIONS(3468),
    [anon_sym___thread] = ACTIONS(3468),
    [anon_sym_const] = ACTIONS(3468),
    [anon_sym_constexpr] = ACTIONS(3468),
    [anon_sym_volatile] = ACTIONS(3468),
    [anon_sym_restrict] = ACTIONS(3468),
    [anon_sym___restrict__] = ACTIONS(3468),
    [anon_sym__Atomic] = ACTIONS(3468),
    [anon_sym__Noreturn] = ACTIONS(3468),
    [anon_sym_noreturn] = ACTIONS(3468),
    [anon_sym_mutable] = ACTIONS(3468),
    [anon_sym_constinit] = ACTIONS(3468),
    [anon_sym_consteval] = ACTIONS(3468),
    [anon_sym_PROGMEM] = ACTIONS(3468),
    [aux_sym_primitive_type_token1] = ACTIONS(3468),
    [anon_sym_byte] = ACTIONS(3468),
    [anon_sym_word] = ACTIONS(3468),
    [anon_sym_enum] = ACTIONS(3468),
    [anon_sym_class] = ACTIONS(3468),
    [anon_sym_struct] = ACTIONS(3468),
    [anon_sym_union] = ACTIONS(3468),
    [anon_sym_if] = ACTIONS(3468),
    [anon_sym_switch] = ACTIONS(3468),
    [anon_sym_case] = ACTIONS(3468),
    [anon_sym_default] = ACTIONS(3468),
    [anon_sym_while] = ACTIONS(3468),
    [anon_sym_do] = ACTIONS(3468),
    [anon_sym_for] = ACTIONS(3468),
    [anon_sym_return] = ACTIONS(3468),
    [anon_sym_break] = ACTIONS(3468),
    [anon_sym_continue] = ACTIONS(3468),
    [anon_sym_goto] = ACTIONS(3468),
    [anon_sym_not] = ACTIONS(3468),
    [anon_sym_compl] = ACTIONS(3468),
    [anon_sym_DASH_DASH] = ACTIONS(3466),
    [anon_sym_PLUS_PLUS] = ACTIONS(3466),
    [anon_sym_sizeof] = ACTIONS(3468),
    [anon_sym___alignof__] = ACTIONS(3468),
    [anon_sym___alignof] = ACTIONS(3468),
    [anon_sym__alignof] = ACTIONS(3468),
    [anon_sym_alignof] = ACTIONS(3468),
    [anon_sym__Alignof] = ACTIONS(3468),
    [anon_sym_offsetof] = ACTIONS(3468),
    [anon_sym__Generic] = ACTIONS(3468),
    [anon_sym_asm] = ACTIONS(3468),
    [anon_sym___asm__] = ACTIONS(3468),
    [aux_sym_number_literal_token1] = ACTIONS(3466),
    [aux_sym_number_literal_token2] = ACTIONS(3468),
    [anon_sym_L_SQUOTE] = ACTIONS(3466),
    [anon_sym_u_SQUOTE] = ACTIONS(3466),
    [anon_sym_U_SQUOTE] = ACTIONS(3466),
    [anon_sym_u8_SQUOTE] = ACTIONS(3466),
    [anon_sym_SQUOTE] = ACTIONS(3466),
    [anon_sym_L_DQUOTE] = ACTIONS(3466),
    [anon_sym_u_DQUOTE] = ACTIONS(3466),
    [anon_sym_U_DQUOTE] = ACTIONS(3466),
    [anon_sym_u8_DQUOTE] = ACTIONS(3466),
    [anon_sym_DQUOTE] = ACTIONS(3466),
    [sym_true] = ACTIONS(3468),
    [sym_false] = ACTIONS(3468),
    [anon_sym_NULL] = ACTIONS(3468),
    [anon_sym_nullptr] = ACTIONS(3468),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3468),
    [anon_sym_decltype] = ACTIONS(3468),
    [anon_sym_virtual] = ACTIONS(3468),
    [anon_sym_alignas] = ACTIONS(3468),
    [anon_sym_explicit] = ACTIONS(3468),
    [anon_sym_typename] = ACTIONS(3468),
    [anon_sym_template] = ACTIONS(3468),
    [anon_sym_operator] = ACTIONS(3468),
    [anon_sym_try] = ACTIONS(3468),
    [anon_sym_delete] = ACTIONS(3468),
    [anon_sym_throw] = ACTIONS(3468),
    [anon_sym_namespace] = ACTIONS(3468),
    [anon_sym_using] = ACTIONS(3468),
    [anon_sym_static_assert] = ACTIONS(3468),
    [anon_sym_concept] = ACTIONS(3468),
    [anon_sym_co_return] = ACTIONS(3468),
    [anon_sym_co_yield] = ACTIONS(3468),
    [anon_sym_R_DQUOTE] = ACTIONS(3466),
    [anon_sym_LR_DQUOTE] = ACTIONS(3466),
    [anon_sym_uR_DQUOTE] = ACTIONS(3466),
    [anon_sym_UR_DQUOTE] = ACTIONS(3466),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3466),
    [anon_sym_co_await] = ACTIONS(3468),
    [anon_sym_new] = ACTIONS(3468),
    [anon_sym_requires] = ACTIONS(3468),
    [sym_this] = ACTIONS(3468),
  },
  [867] = {
    [ts_builtin_sym_end] = ACTIONS(3470),
    [sym_identifier] = ACTIONS(3472),
    [aux_sym_preproc_include_token1] = ACTIONS(3472),
    [aux_sym_preproc_def_token1] = ACTIONS(3472),
    [aux_sym_preproc_if_token1] = ACTIONS(3472),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3472),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3472),
    [sym_preproc_directive] = ACTIONS(3472),
    [anon_sym_LPAREN2] = ACTIONS(3470),
    [anon_sym_BANG] = ACTIONS(3470),
    [anon_sym_TILDE] = ACTIONS(3470),
    [anon_sym_DASH] = ACTIONS(3472),
    [anon_sym_PLUS] = ACTIONS(3472),
    [anon_sym_STAR] = ACTIONS(3470),
    [anon_sym_AMP_AMP] = ACTIONS(3470),
    [anon_sym_AMP] = ACTIONS(3472),
    [anon_sym___extension__] = ACTIONS(3472),
    [anon_sym_typedef] = ACTIONS(3472),
    [anon_sym_extern] = ACTIONS(3472),
    [anon_sym___attribute__] = ACTIONS(3472),
    [anon_sym_COLON_COLON] = ACTIONS(3470),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3470),
    [anon_sym___declspec] = ACTIONS(3472),
    [anon_sym___based] = ACTIONS(3472),
    [anon_sym___cdecl] = ACTIONS(3472),
    [anon_sym___clrcall] = ACTIONS(3472),
    [anon_sym___stdcall] = ACTIONS(3472),
    [anon_sym___fastcall] = ACTIONS(3472),
    [anon_sym___thiscall] = ACTIONS(3472),
    [anon_sym___vectorcall] = ACTIONS(3472),
    [anon_sym_LBRACE] = ACTIONS(3470),
    [anon_sym_signed] = ACTIONS(3472),
    [anon_sym_unsigned] = ACTIONS(3472),
    [anon_sym_long] = ACTIONS(3472),
    [anon_sym_short] = ACTIONS(3472),
    [anon_sym_LBRACK] = ACTIONS(3472),
    [anon_sym_static] = ACTIONS(3472),
    [anon_sym_register] = ACTIONS(3472),
    [anon_sym_inline] = ACTIONS(3472),
    [anon_sym___inline] = ACTIONS(3472),
    [anon_sym___inline__] = ACTIONS(3472),
    [anon_sym___forceinline] = ACTIONS(3472),
    [anon_sym_thread_local] = ACTIONS(3472),
    [anon_sym___thread] = ACTIONS(3472),
    [anon_sym_const] = ACTIONS(3472),
    [anon_sym_constexpr] = ACTIONS(3472),
    [anon_sym_volatile] = ACTIONS(3472),
    [anon_sym_restrict] = ACTIONS(3472),
    [anon_sym___restrict__] = ACTIONS(3472),
    [anon_sym__Atomic] = ACTIONS(3472),
    [anon_sym__Noreturn] = ACTIONS(3472),
    [anon_sym_noreturn] = ACTIONS(3472),
    [anon_sym_mutable] = ACTIONS(3472),
    [anon_sym_constinit] = ACTIONS(3472),
    [anon_sym_consteval] = ACTIONS(3472),
    [anon_sym_PROGMEM] = ACTIONS(3472),
    [aux_sym_primitive_type_token1] = ACTIONS(3472),
    [anon_sym_byte] = ACTIONS(3472),
    [anon_sym_word] = ACTIONS(3472),
    [anon_sym_enum] = ACTIONS(3472),
    [anon_sym_class] = ACTIONS(3472),
    [anon_sym_struct] = ACTIONS(3472),
    [anon_sym_union] = ACTIONS(3472),
    [anon_sym_if] = ACTIONS(3472),
    [anon_sym_switch] = ACTIONS(3472),
    [anon_sym_case] = ACTIONS(3472),
    [anon_sym_default] = ACTIONS(3472),
    [anon_sym_while] = ACTIONS(3472),
    [anon_sym_do] = ACTIONS(3472),
    [anon_sym_for] = ACTIONS(3472),
    [anon_sym_return] = ACTIONS(3472),
    [anon_sym_break] = ACTIONS(3472),
    [anon_sym_continue] = ACTIONS(3472),
    [anon_sym_goto] = ACTIONS(3472),
    [anon_sym_not] = ACTIONS(3472),
    [anon_sym_compl] = ACTIONS(3472),
    [anon_sym_DASH_DASH] = ACTIONS(3470),
    [anon_sym_PLUS_PLUS] = ACTIONS(3470),
    [anon_sym_sizeof] = ACTIONS(3472),
    [anon_sym___alignof__] = ACTIONS(3472),
    [anon_sym___alignof] = ACTIONS(3472),
    [anon_sym__alignof] = ACTIONS(3472),
    [anon_sym_alignof] = ACTIONS(3472),
    [anon_sym__Alignof] = ACTIONS(3472),
    [anon_sym_offsetof] = ACTIONS(3472),
    [anon_sym__Generic] = ACTIONS(3472),
    [anon_sym_asm] = ACTIONS(3472),
    [anon_sym___asm__] = ACTIONS(3472),
    [aux_sym_number_literal_token1] = ACTIONS(3470),
    [aux_sym_number_literal_token2] = ACTIONS(3472),
    [anon_sym_L_SQUOTE] = ACTIONS(3470),
    [anon_sym_u_SQUOTE] = ACTIONS(3470),
    [anon_sym_U_SQUOTE] = ACTIONS(3470),
    [anon_sym_u8_SQUOTE] = ACTIONS(3470),
    [anon_sym_SQUOTE] = ACTIONS(3470),
    [anon_sym_L_DQUOTE] = ACTIONS(3470),
    [anon_sym_u_DQUOTE] = ACTIONS(3470),
    [anon_sym_U_DQUOTE] = ACTIONS(3470),
    [anon_sym_u8_DQUOTE] = ACTIONS(3470),
    [anon_sym_DQUOTE] = ACTIONS(3470),
    [sym_true] = ACTIONS(3472),
    [sym_false] = ACTIONS(3472),
    [anon_sym_NULL] = ACTIONS(3472),
    [anon_sym_nullptr] = ACTIONS(3472),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3472),
    [anon_sym_decltype] = ACTIONS(3472),
    [anon_sym_virtual] = ACTIONS(3472),
    [anon_sym_alignas] = ACTIONS(3472),
    [anon_sym_explicit] = ACTIONS(3472),
    [anon_sym_typename] = ACTIONS(3472),
    [anon_sym_template] = ACTIONS(3472),
    [anon_sym_operator] = ACTIONS(3472),
    [anon_sym_try] = ACTIONS(3472),
    [anon_sym_delete] = ACTIONS(3472),
    [anon_sym_throw] = ACTIONS(3472),
    [anon_sym_namespace] = ACTIONS(3472),
    [anon_sym_using] = ACTIONS(3472),
    [anon_sym_static_assert] = ACTIONS(3472),
    [anon_sym_concept] = ACTIONS(3472),
    [anon_sym_co_return] = ACTIONS(3472),
    [anon_sym_co_yield] = ACTIONS(3472),
    [anon_sym_R_DQUOTE] = ACTIONS(3470),
    [anon_sym_LR_DQUOTE] = ACTIONS(3470),
    [anon_sym_uR_DQUOTE] = ACTIONS(3470),
    [anon_sym_UR_DQUOTE] = ACTIONS(3470),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3470),
    [anon_sym_co_await] = ACTIONS(3472),
    [anon_sym_new] = ACTIONS(3472),
    [anon_sym_requires] = ACTIONS(3472),
    [sym_this] = ACTIONS(3472),
  },
  [868] = {
    [ts_builtin_sym_end] = ACTIONS(3128),
    [sym_identifier] = ACTIONS(3126),
    [aux_sym_preproc_include_token1] = ACTIONS(3126),
    [aux_sym_preproc_def_token1] = ACTIONS(3126),
    [aux_sym_preproc_if_token1] = ACTIONS(3126),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3126),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3126),
    [sym_preproc_directive] = ACTIONS(3126),
    [anon_sym_LPAREN2] = ACTIONS(3128),
    [anon_sym_BANG] = ACTIONS(3128),
    [anon_sym_TILDE] = ACTIONS(3128),
    [anon_sym_DASH] = ACTIONS(3126),
    [anon_sym_PLUS] = ACTIONS(3126),
    [anon_sym_STAR] = ACTIONS(3128),
    [anon_sym_AMP_AMP] = ACTIONS(3128),
    [anon_sym_AMP] = ACTIONS(3126),
    [anon_sym___extension__] = ACTIONS(3126),
    [anon_sym_typedef] = ACTIONS(3126),
    [anon_sym_extern] = ACTIONS(3126),
    [anon_sym___attribute__] = ACTIONS(3126),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3128),
    [anon_sym___declspec] = ACTIONS(3126),
    [anon_sym___based] = ACTIONS(3126),
    [anon_sym___cdecl] = ACTIONS(3126),
    [anon_sym___clrcall] = ACTIONS(3126),
    [anon_sym___stdcall] = ACTIONS(3126),
    [anon_sym___fastcall] = ACTIONS(3126),
    [anon_sym___thiscall] = ACTIONS(3126),
    [anon_sym___vectorcall] = ACTIONS(3126),
    [anon_sym_LBRACE] = ACTIONS(3128),
    [anon_sym_signed] = ACTIONS(3126),
    [anon_sym_unsigned] = ACTIONS(3126),
    [anon_sym_long] = ACTIONS(3126),
    [anon_sym_short] = ACTIONS(3126),
    [anon_sym_LBRACK] = ACTIONS(3126),
    [anon_sym_static] = ACTIONS(3126),
    [anon_sym_register] = ACTIONS(3126),
    [anon_sym_inline] = ACTIONS(3126),
    [anon_sym___inline] = ACTIONS(3126),
    [anon_sym___inline__] = ACTIONS(3126),
    [anon_sym___forceinline] = ACTIONS(3126),
    [anon_sym_thread_local] = ACTIONS(3126),
    [anon_sym___thread] = ACTIONS(3126),
    [anon_sym_const] = ACTIONS(3126),
    [anon_sym_constexpr] = ACTIONS(3126),
    [anon_sym_volatile] = ACTIONS(3126),
    [anon_sym_restrict] = ACTIONS(3126),
    [anon_sym___restrict__] = ACTIONS(3126),
    [anon_sym__Atomic] = ACTIONS(3126),
    [anon_sym__Noreturn] = ACTIONS(3126),
    [anon_sym_noreturn] = ACTIONS(3126),
    [anon_sym_mutable] = ACTIONS(3126),
    [anon_sym_constinit] = ACTIONS(3126),
    [anon_sym_consteval] = ACTIONS(3126),
    [anon_sym_PROGMEM] = ACTIONS(3126),
    [aux_sym_primitive_type_token1] = ACTIONS(3126),
    [anon_sym_byte] = ACTIONS(3126),
    [anon_sym_word] = ACTIONS(3126),
    [anon_sym_enum] = ACTIONS(3126),
    [anon_sym_class] = ACTIONS(3126),
    [anon_sym_struct] = ACTIONS(3126),
    [anon_sym_union] = ACTIONS(3126),
    [anon_sym_if] = ACTIONS(3126),
    [anon_sym_switch] = ACTIONS(3126),
    [anon_sym_case] = ACTIONS(3126),
    [anon_sym_default] = ACTIONS(3126),
    [anon_sym_while] = ACTIONS(3126),
    [anon_sym_do] = ACTIONS(3126),
    [anon_sym_for] = ACTIONS(3126),
    [anon_sym_return] = ACTIONS(3126),
    [anon_sym_break] = ACTIONS(3126),
    [anon_sym_continue] = ACTIONS(3126),
    [anon_sym_goto] = ACTIONS(3126),
    [anon_sym_not] = ACTIONS(3126),
    [anon_sym_compl] = ACTIONS(3126),
    [anon_sym_DASH_DASH] = ACTIONS(3128),
    [anon_sym_PLUS_PLUS] = ACTIONS(3128),
    [anon_sym_sizeof] = ACTIONS(3126),
    [anon_sym___alignof__] = ACTIONS(3126),
    [anon_sym___alignof] = ACTIONS(3126),
    [anon_sym__alignof] = ACTIONS(3126),
    [anon_sym_alignof] = ACTIONS(3126),
    [anon_sym__Alignof] = ACTIONS(3126),
    [anon_sym_offsetof] = ACTIONS(3126),
    [anon_sym__Generic] = ACTIONS(3126),
    [anon_sym_asm] = ACTIONS(3126),
    [anon_sym___asm__] = ACTIONS(3126),
    [aux_sym_number_literal_token1] = ACTIONS(3128),
    [aux_sym_number_literal_token2] = ACTIONS(3126),
    [anon_sym_L_SQUOTE] = ACTIONS(3128),
    [anon_sym_u_SQUOTE] = ACTIONS(3128),
    [anon_sym_U_SQUOTE] = ACTIONS(3128),
    [anon_sym_u8_SQUOTE] = ACTIONS(3128),
    [anon_sym_SQUOTE] = ACTIONS(3128),
    [anon_sym_L_DQUOTE] = ACTIONS(3128),
    [anon_sym_u_DQUOTE] = ACTIONS(3128),
    [anon_sym_U_DQUOTE] = ACTIONS(3128),
    [anon_sym_u8_DQUOTE] = ACTIONS(3128),
    [anon_sym_DQUOTE] = ACTIONS(3128),
    [sym_true] = ACTIONS(3126),
    [sym_false] = ACTIONS(3126),
    [anon_sym_NULL] = ACTIONS(3126),
    [anon_sym_nullptr] = ACTIONS(3126),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3126),
    [anon_sym_decltype] = ACTIONS(3126),
    [anon_sym_virtual] = ACTIONS(3126),
    [anon_sym_alignas] = ACTIONS(3126),
    [anon_sym_explicit] = ACTIONS(3126),
    [anon_sym_typename] = ACTIONS(3126),
    [anon_sym_template] = ACTIONS(3126),
    [anon_sym_operator] = ACTIONS(3126),
    [anon_sym_try] = ACTIONS(3126),
    [anon_sym_delete] = ACTIONS(3126),
    [anon_sym_throw] = ACTIONS(3126),
    [anon_sym_namespace] = ACTIONS(3126),
    [anon_sym_using] = ACTIONS(3126),
    [anon_sym_static_assert] = ACTIONS(3126),
    [anon_sym_concept] = ACTIONS(3126),
    [anon_sym_co_return] = ACTIONS(3126),
    [anon_sym_co_yield] = ACTIONS(3126),
    [anon_sym_R_DQUOTE] = ACTIONS(3128),
    [anon_sym_LR_DQUOTE] = ACTIONS(3128),
    [anon_sym_uR_DQUOTE] = ACTIONS(3128),
    [anon_sym_UR_DQUOTE] = ACTIONS(3128),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3128),
    [anon_sym_co_await] = ACTIONS(3126),
    [anon_sym_new] = ACTIONS(3126),
    [anon_sym_requires] = ACTIONS(3126),
    [sym_this] = ACTIONS(3126),
  },
  [869] = {
    [ts_builtin_sym_end] = ACTIONS(3022),
    [sym_identifier] = ACTIONS(3020),
    [aux_sym_preproc_include_token1] = ACTIONS(3020),
    [aux_sym_preproc_def_token1] = ACTIONS(3020),
    [aux_sym_preproc_if_token1] = ACTIONS(3020),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3020),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3020),
    [sym_preproc_directive] = ACTIONS(3020),
    [anon_sym_LPAREN2] = ACTIONS(3022),
    [anon_sym_BANG] = ACTIONS(3022),
    [anon_sym_TILDE] = ACTIONS(3022),
    [anon_sym_DASH] = ACTIONS(3020),
    [anon_sym_PLUS] = ACTIONS(3020),
    [anon_sym_STAR] = ACTIONS(3022),
    [anon_sym_AMP_AMP] = ACTIONS(3022),
    [anon_sym_AMP] = ACTIONS(3020),
    [anon_sym___extension__] = ACTIONS(3020),
    [anon_sym_typedef] = ACTIONS(3020),
    [anon_sym_extern] = ACTIONS(3020),
    [anon_sym___attribute__] = ACTIONS(3020),
    [anon_sym_COLON_COLON] = ACTIONS(3022),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3022),
    [anon_sym___declspec] = ACTIONS(3020),
    [anon_sym___based] = ACTIONS(3020),
    [anon_sym___cdecl] = ACTIONS(3020),
    [anon_sym___clrcall] = ACTIONS(3020),
    [anon_sym___stdcall] = ACTIONS(3020),
    [anon_sym___fastcall] = ACTIONS(3020),
    [anon_sym___thiscall] = ACTIONS(3020),
    [anon_sym___vectorcall] = ACTIONS(3020),
    [anon_sym_LBRACE] = ACTIONS(3022),
    [anon_sym_signed] = ACTIONS(3020),
    [anon_sym_unsigned] = ACTIONS(3020),
    [anon_sym_long] = ACTIONS(3020),
    [anon_sym_short] = ACTIONS(3020),
    [anon_sym_LBRACK] = ACTIONS(3020),
    [anon_sym_static] = ACTIONS(3020),
    [anon_sym_register] = ACTIONS(3020),
    [anon_sym_inline] = ACTIONS(3020),
    [anon_sym___inline] = ACTIONS(3020),
    [anon_sym___inline__] = ACTIONS(3020),
    [anon_sym___forceinline] = ACTIONS(3020),
    [anon_sym_thread_local] = ACTIONS(3020),
    [anon_sym___thread] = ACTIONS(3020),
    [anon_sym_const] = ACTIONS(3020),
    [anon_sym_constexpr] = ACTIONS(3020),
    [anon_sym_volatile] = ACTIONS(3020),
    [anon_sym_restrict] = ACTIONS(3020),
    [anon_sym___restrict__] = ACTIONS(3020),
    [anon_sym__Atomic] = ACTIONS(3020),
    [anon_sym__Noreturn] = ACTIONS(3020),
    [anon_sym_noreturn] = ACTIONS(3020),
    [anon_sym_mutable] = ACTIONS(3020),
    [anon_sym_constinit] = ACTIONS(3020),
    [anon_sym_consteval] = ACTIONS(3020),
    [anon_sym_PROGMEM] = ACTIONS(3020),
    [aux_sym_primitive_type_token1] = ACTIONS(3020),
    [anon_sym_byte] = ACTIONS(3020),
    [anon_sym_word] = ACTIONS(3020),
    [anon_sym_enum] = ACTIONS(3020),
    [anon_sym_class] = ACTIONS(3020),
    [anon_sym_struct] = ACTIONS(3020),
    [anon_sym_union] = ACTIONS(3020),
    [anon_sym_if] = ACTIONS(3020),
    [anon_sym_switch] = ACTIONS(3020),
    [anon_sym_case] = ACTIONS(3020),
    [anon_sym_default] = ACTIONS(3020),
    [anon_sym_while] = ACTIONS(3020),
    [anon_sym_do] = ACTIONS(3020),
    [anon_sym_for] = ACTIONS(3020),
    [anon_sym_return] = ACTIONS(3020),
    [anon_sym_break] = ACTIONS(3020),
    [anon_sym_continue] = ACTIONS(3020),
    [anon_sym_goto] = ACTIONS(3020),
    [anon_sym_not] = ACTIONS(3020),
    [anon_sym_compl] = ACTIONS(3020),
    [anon_sym_DASH_DASH] = ACTIONS(3022),
    [anon_sym_PLUS_PLUS] = ACTIONS(3022),
    [anon_sym_sizeof] = ACTIONS(3020),
    [anon_sym___alignof__] = ACTIONS(3020),
    [anon_sym___alignof] = ACTIONS(3020),
    [anon_sym__alignof] = ACTIONS(3020),
    [anon_sym_alignof] = ACTIONS(3020),
    [anon_sym__Alignof] = ACTIONS(3020),
    [anon_sym_offsetof] = ACTIONS(3020),
    [anon_sym__Generic] = ACTIONS(3020),
    [anon_sym_asm] = ACTIONS(3020),
    [anon_sym___asm__] = ACTIONS(3020),
    [aux_sym_number_literal_token1] = ACTIONS(3022),
    [aux_sym_number_literal_token2] = ACTIONS(3020),
    [anon_sym_L_SQUOTE] = ACTIONS(3022),
    [anon_sym_u_SQUOTE] = ACTIONS(3022),
    [anon_sym_U_SQUOTE] = ACTIONS(3022),
    [anon_sym_u8_SQUOTE] = ACTIONS(3022),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [anon_sym_L_DQUOTE] = ACTIONS(3022),
    [anon_sym_u_DQUOTE] = ACTIONS(3022),
    [anon_sym_U_DQUOTE] = ACTIONS(3022),
    [anon_sym_u8_DQUOTE] = ACTIONS(3022),
    [anon_sym_DQUOTE] = ACTIONS(3022),
    [sym_true] = ACTIONS(3020),
    [sym_false] = ACTIONS(3020),
    [anon_sym_NULL] = ACTIONS(3020),
    [anon_sym_nullptr] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3020),
    [anon_sym_decltype] = ACTIONS(3020),
    [anon_sym_virtual] = ACTIONS(3020),
    [anon_sym_alignas] = ACTIONS(3020),
    [anon_sym_explicit] = ACTIONS(3020),
    [anon_sym_typename] = ACTIONS(3020),
    [anon_sym_template] = ACTIONS(3020),
    [anon_sym_operator] = ACTIONS(3020),
    [anon_sym_try] = ACTIONS(3020),
    [anon_sym_delete] = ACTIONS(3020),
    [anon_sym_throw] = ACTIONS(3020),
    [anon_sym_namespace] = ACTIONS(3020),
    [anon_sym_using] = ACTIONS(3020),
    [anon_sym_static_assert] = ACTIONS(3020),
    [anon_sym_concept] = ACTIONS(3020),
    [anon_sym_co_return] = ACTIONS(3020),
    [anon_sym_co_yield] = ACTIONS(3020),
    [anon_sym_R_DQUOTE] = ACTIONS(3022),
    [anon_sym_LR_DQUOTE] = ACTIONS(3022),
    [anon_sym_uR_DQUOTE] = ACTIONS(3022),
    [anon_sym_UR_DQUOTE] = ACTIONS(3022),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3022),
    [anon_sym_co_await] = ACTIONS(3020),
    [anon_sym_new] = ACTIONS(3020),
    [anon_sym_requires] = ACTIONS(3020),
    [sym_this] = ACTIONS(3020),
  },
  [870] = {
    [ts_builtin_sym_end] = ACTIONS(2887),
    [sym_identifier] = ACTIONS(2885),
    [aux_sym_preproc_include_token1] = ACTIONS(2885),
    [aux_sym_preproc_def_token1] = ACTIONS(2885),
    [aux_sym_preproc_if_token1] = ACTIONS(2885),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2885),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2885),
    [sym_preproc_directive] = ACTIONS(2885),
    [anon_sym_LPAREN2] = ACTIONS(2887),
    [anon_sym_BANG] = ACTIONS(2887),
    [anon_sym_TILDE] = ACTIONS(2887),
    [anon_sym_DASH] = ACTIONS(2885),
    [anon_sym_PLUS] = ACTIONS(2885),
    [anon_sym_STAR] = ACTIONS(2887),
    [anon_sym_AMP_AMP] = ACTIONS(2887),
    [anon_sym_AMP] = ACTIONS(2885),
    [anon_sym___extension__] = ACTIONS(2885),
    [anon_sym_typedef] = ACTIONS(2885),
    [anon_sym_extern] = ACTIONS(2885),
    [anon_sym___attribute__] = ACTIONS(2885),
    [anon_sym_COLON_COLON] = ACTIONS(2887),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2887),
    [anon_sym___declspec] = ACTIONS(2885),
    [anon_sym___based] = ACTIONS(2885),
    [anon_sym___cdecl] = ACTIONS(2885),
    [anon_sym___clrcall] = ACTIONS(2885),
    [anon_sym___stdcall] = ACTIONS(2885),
    [anon_sym___fastcall] = ACTIONS(2885),
    [anon_sym___thiscall] = ACTIONS(2885),
    [anon_sym___vectorcall] = ACTIONS(2885),
    [anon_sym_LBRACE] = ACTIONS(2887),
    [anon_sym_signed] = ACTIONS(2885),
    [anon_sym_unsigned] = ACTIONS(2885),
    [anon_sym_long] = ACTIONS(2885),
    [anon_sym_short] = ACTIONS(2885),
    [anon_sym_LBRACK] = ACTIONS(2885),
    [anon_sym_static] = ACTIONS(2885),
    [anon_sym_register] = ACTIONS(2885),
    [anon_sym_inline] = ACTIONS(2885),
    [anon_sym___inline] = ACTIONS(2885),
    [anon_sym___inline__] = ACTIONS(2885),
    [anon_sym___forceinline] = ACTIONS(2885),
    [anon_sym_thread_local] = ACTIONS(2885),
    [anon_sym___thread] = ACTIONS(2885),
    [anon_sym_const] = ACTIONS(2885),
    [anon_sym_constexpr] = ACTIONS(2885),
    [anon_sym_volatile] = ACTIONS(2885),
    [anon_sym_restrict] = ACTIONS(2885),
    [anon_sym___restrict__] = ACTIONS(2885),
    [anon_sym__Atomic] = ACTIONS(2885),
    [anon_sym__Noreturn] = ACTIONS(2885),
    [anon_sym_noreturn] = ACTIONS(2885),
    [anon_sym_mutable] = ACTIONS(2885),
    [anon_sym_constinit] = ACTIONS(2885),
    [anon_sym_consteval] = ACTIONS(2885),
    [anon_sym_PROGMEM] = ACTIONS(2885),
    [aux_sym_primitive_type_token1] = ACTIONS(2885),
    [anon_sym_byte] = ACTIONS(2885),
    [anon_sym_word] = ACTIONS(2885),
    [anon_sym_enum] = ACTIONS(2885),
    [anon_sym_class] = ACTIONS(2885),
    [anon_sym_struct] = ACTIONS(2885),
    [anon_sym_union] = ACTIONS(2885),
    [anon_sym_if] = ACTIONS(2885),
    [anon_sym_switch] = ACTIONS(2885),
    [anon_sym_case] = ACTIONS(2885),
    [anon_sym_default] = ACTIONS(2885),
    [anon_sym_while] = ACTIONS(2885),
    [anon_sym_do] = ACTIONS(2885),
    [anon_sym_for] = ACTIONS(2885),
    [anon_sym_return] = ACTIONS(2885),
    [anon_sym_break] = ACTIONS(2885),
    [anon_sym_continue] = ACTIONS(2885),
    [anon_sym_goto] = ACTIONS(2885),
    [anon_sym_not] = ACTIONS(2885),
    [anon_sym_compl] = ACTIONS(2885),
    [anon_sym_DASH_DASH] = ACTIONS(2887),
    [anon_sym_PLUS_PLUS] = ACTIONS(2887),
    [anon_sym_sizeof] = ACTIONS(2885),
    [anon_sym___alignof__] = ACTIONS(2885),
    [anon_sym___alignof] = ACTIONS(2885),
    [anon_sym__alignof] = ACTIONS(2885),
    [anon_sym_alignof] = ACTIONS(2885),
    [anon_sym__Alignof] = ACTIONS(2885),
    [anon_sym_offsetof] = ACTIONS(2885),
    [anon_sym__Generic] = ACTIONS(2885),
    [anon_sym_asm] = ACTIONS(2885),
    [anon_sym___asm__] = ACTIONS(2885),
    [aux_sym_number_literal_token1] = ACTIONS(2887),
    [aux_sym_number_literal_token2] = ACTIONS(2885),
    [anon_sym_L_SQUOTE] = ACTIONS(2887),
    [anon_sym_u_SQUOTE] = ACTIONS(2887),
    [anon_sym_U_SQUOTE] = ACTIONS(2887),
    [anon_sym_u8_SQUOTE] = ACTIONS(2887),
    [anon_sym_SQUOTE] = ACTIONS(2887),
    [anon_sym_L_DQUOTE] = ACTIONS(2887),
    [anon_sym_u_DQUOTE] = ACTIONS(2887),
    [anon_sym_U_DQUOTE] = ACTIONS(2887),
    [anon_sym_u8_DQUOTE] = ACTIONS(2887),
    [anon_sym_DQUOTE] = ACTIONS(2887),
    [sym_true] = ACTIONS(2885),
    [sym_false] = ACTIONS(2885),
    [anon_sym_NULL] = ACTIONS(2885),
    [anon_sym_nullptr] = ACTIONS(2885),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2885),
    [anon_sym_decltype] = ACTIONS(2885),
    [anon_sym_virtual] = ACTIONS(2885),
    [anon_sym_alignas] = ACTIONS(2885),
    [anon_sym_explicit] = ACTIONS(2885),
    [anon_sym_typename] = ACTIONS(2885),
    [anon_sym_template] = ACTIONS(2885),
    [anon_sym_operator] = ACTIONS(2885),
    [anon_sym_try] = ACTIONS(2885),
    [anon_sym_delete] = ACTIONS(2885),
    [anon_sym_throw] = ACTIONS(2885),
    [anon_sym_namespace] = ACTIONS(2885),
    [anon_sym_using] = ACTIONS(2885),
    [anon_sym_static_assert] = ACTIONS(2885),
    [anon_sym_concept] = ACTIONS(2885),
    [anon_sym_co_return] = ACTIONS(2885),
    [anon_sym_co_yield] = ACTIONS(2885),
    [anon_sym_R_DQUOTE] = ACTIONS(2887),
    [anon_sym_LR_DQUOTE] = ACTIONS(2887),
    [anon_sym_uR_DQUOTE] = ACTIONS(2887),
    [anon_sym_UR_DQUOTE] = ACTIONS(2887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2887),
    [anon_sym_co_await] = ACTIONS(2885),
    [anon_sym_new] = ACTIONS(2885),
    [anon_sym_requires] = ACTIONS(2885),
    [sym_this] = ACTIONS(2885),
  },
  [871] = {
    [ts_builtin_sym_end] = ACTIONS(2951),
    [sym_identifier] = ACTIONS(2949),
    [aux_sym_preproc_include_token1] = ACTIONS(2949),
    [aux_sym_preproc_def_token1] = ACTIONS(2949),
    [aux_sym_preproc_if_token1] = ACTIONS(2949),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2949),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2949),
    [sym_preproc_directive] = ACTIONS(2949),
    [anon_sym_LPAREN2] = ACTIONS(2951),
    [anon_sym_BANG] = ACTIONS(2951),
    [anon_sym_TILDE] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2949),
    [anon_sym_STAR] = ACTIONS(2951),
    [anon_sym_AMP_AMP] = ACTIONS(2951),
    [anon_sym_AMP] = ACTIONS(2949),
    [anon_sym___extension__] = ACTIONS(2949),
    [anon_sym_typedef] = ACTIONS(2949),
    [anon_sym_extern] = ACTIONS(2949),
    [anon_sym___attribute__] = ACTIONS(2949),
    [anon_sym_COLON_COLON] = ACTIONS(2951),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2951),
    [anon_sym___declspec] = ACTIONS(2949),
    [anon_sym___based] = ACTIONS(2949),
    [anon_sym___cdecl] = ACTIONS(2949),
    [anon_sym___clrcall] = ACTIONS(2949),
    [anon_sym___stdcall] = ACTIONS(2949),
    [anon_sym___fastcall] = ACTIONS(2949),
    [anon_sym___thiscall] = ACTIONS(2949),
    [anon_sym___vectorcall] = ACTIONS(2949),
    [anon_sym_LBRACE] = ACTIONS(2951),
    [anon_sym_signed] = ACTIONS(2949),
    [anon_sym_unsigned] = ACTIONS(2949),
    [anon_sym_long] = ACTIONS(2949),
    [anon_sym_short] = ACTIONS(2949),
    [anon_sym_LBRACK] = ACTIONS(2949),
    [anon_sym_static] = ACTIONS(2949),
    [anon_sym_register] = ACTIONS(2949),
    [anon_sym_inline] = ACTIONS(2949),
    [anon_sym___inline] = ACTIONS(2949),
    [anon_sym___inline__] = ACTIONS(2949),
    [anon_sym___forceinline] = ACTIONS(2949),
    [anon_sym_thread_local] = ACTIONS(2949),
    [anon_sym___thread] = ACTIONS(2949),
    [anon_sym_const] = ACTIONS(2949),
    [anon_sym_constexpr] = ACTIONS(2949),
    [anon_sym_volatile] = ACTIONS(2949),
    [anon_sym_restrict] = ACTIONS(2949),
    [anon_sym___restrict__] = ACTIONS(2949),
    [anon_sym__Atomic] = ACTIONS(2949),
    [anon_sym__Noreturn] = ACTIONS(2949),
    [anon_sym_noreturn] = ACTIONS(2949),
    [anon_sym_mutable] = ACTIONS(2949),
    [anon_sym_constinit] = ACTIONS(2949),
    [anon_sym_consteval] = ACTIONS(2949),
    [anon_sym_PROGMEM] = ACTIONS(2949),
    [aux_sym_primitive_type_token1] = ACTIONS(2949),
    [anon_sym_byte] = ACTIONS(2949),
    [anon_sym_word] = ACTIONS(2949),
    [anon_sym_enum] = ACTIONS(2949),
    [anon_sym_class] = ACTIONS(2949),
    [anon_sym_struct] = ACTIONS(2949),
    [anon_sym_union] = ACTIONS(2949),
    [anon_sym_if] = ACTIONS(2949),
    [anon_sym_switch] = ACTIONS(2949),
    [anon_sym_case] = ACTIONS(2949),
    [anon_sym_default] = ACTIONS(2949),
    [anon_sym_while] = ACTIONS(2949),
    [anon_sym_do] = ACTIONS(2949),
    [anon_sym_for] = ACTIONS(2949),
    [anon_sym_return] = ACTIONS(2949),
    [anon_sym_break] = ACTIONS(2949),
    [anon_sym_continue] = ACTIONS(2949),
    [anon_sym_goto] = ACTIONS(2949),
    [anon_sym_not] = ACTIONS(2949),
    [anon_sym_compl] = ACTIONS(2949),
    [anon_sym_DASH_DASH] = ACTIONS(2951),
    [anon_sym_PLUS_PLUS] = ACTIONS(2951),
    [anon_sym_sizeof] = ACTIONS(2949),
    [anon_sym___alignof__] = ACTIONS(2949),
    [anon_sym___alignof] = ACTIONS(2949),
    [anon_sym__alignof] = ACTIONS(2949),
    [anon_sym_alignof] = ACTIONS(2949),
    [anon_sym__Alignof] = ACTIONS(2949),
    [anon_sym_offsetof] = ACTIONS(2949),
    [anon_sym__Generic] = ACTIONS(2949),
    [anon_sym_asm] = ACTIONS(2949),
    [anon_sym___asm__] = ACTIONS(2949),
    [aux_sym_number_literal_token1] = ACTIONS(2951),
    [aux_sym_number_literal_token2] = ACTIONS(2949),
    [anon_sym_L_SQUOTE] = ACTIONS(2951),
    [anon_sym_u_SQUOTE] = ACTIONS(2951),
    [anon_sym_U_SQUOTE] = ACTIONS(2951),
    [anon_sym_u8_SQUOTE] = ACTIONS(2951),
    [anon_sym_SQUOTE] = ACTIONS(2951),
    [anon_sym_L_DQUOTE] = ACTIONS(2951),
    [anon_sym_u_DQUOTE] = ACTIONS(2951),
    [anon_sym_U_DQUOTE] = ACTIONS(2951),
    [anon_sym_u8_DQUOTE] = ACTIONS(2951),
    [anon_sym_DQUOTE] = ACTIONS(2951),
    [sym_true] = ACTIONS(2949),
    [sym_false] = ACTIONS(2949),
    [anon_sym_NULL] = ACTIONS(2949),
    [anon_sym_nullptr] = ACTIONS(2949),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2949),
    [anon_sym_decltype] = ACTIONS(2949),
    [anon_sym_virtual] = ACTIONS(2949),
    [anon_sym_alignas] = ACTIONS(2949),
    [anon_sym_explicit] = ACTIONS(2949),
    [anon_sym_typename] = ACTIONS(2949),
    [anon_sym_template] = ACTIONS(2949),
    [anon_sym_operator] = ACTIONS(2949),
    [anon_sym_try] = ACTIONS(2949),
    [anon_sym_delete] = ACTIONS(2949),
    [anon_sym_throw] = ACTIONS(2949),
    [anon_sym_namespace] = ACTIONS(2949),
    [anon_sym_using] = ACTIONS(2949),
    [anon_sym_static_assert] = ACTIONS(2949),
    [anon_sym_concept] = ACTIONS(2949),
    [anon_sym_co_return] = ACTIONS(2949),
    [anon_sym_co_yield] = ACTIONS(2949),
    [anon_sym_R_DQUOTE] = ACTIONS(2951),
    [anon_sym_LR_DQUOTE] = ACTIONS(2951),
    [anon_sym_uR_DQUOTE] = ACTIONS(2951),
    [anon_sym_UR_DQUOTE] = ACTIONS(2951),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2951),
    [anon_sym_co_await] = ACTIONS(2949),
    [anon_sym_new] = ACTIONS(2949),
    [anon_sym_requires] = ACTIONS(2949),
    [sym_this] = ACTIONS(2949),
  },
  [872] = {
    [ts_builtin_sym_end] = ACTIONS(3010),
    [sym_identifier] = ACTIONS(3008),
    [aux_sym_preproc_include_token1] = ACTIONS(3008),
    [aux_sym_preproc_def_token1] = ACTIONS(3008),
    [aux_sym_preproc_if_token1] = ACTIONS(3008),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3008),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3008),
    [sym_preproc_directive] = ACTIONS(3008),
    [anon_sym_LPAREN2] = ACTIONS(3010),
    [anon_sym_BANG] = ACTIONS(3010),
    [anon_sym_TILDE] = ACTIONS(3010),
    [anon_sym_DASH] = ACTIONS(3008),
    [anon_sym_PLUS] = ACTIONS(3008),
    [anon_sym_STAR] = ACTIONS(3010),
    [anon_sym_AMP_AMP] = ACTIONS(3010),
    [anon_sym_AMP] = ACTIONS(3008),
    [anon_sym___extension__] = ACTIONS(3008),
    [anon_sym_typedef] = ACTIONS(3008),
    [anon_sym_extern] = ACTIONS(3008),
    [anon_sym___attribute__] = ACTIONS(3008),
    [anon_sym_COLON_COLON] = ACTIONS(3010),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3010),
    [anon_sym___declspec] = ACTIONS(3008),
    [anon_sym___based] = ACTIONS(3008),
    [anon_sym___cdecl] = ACTIONS(3008),
    [anon_sym___clrcall] = ACTIONS(3008),
    [anon_sym___stdcall] = ACTIONS(3008),
    [anon_sym___fastcall] = ACTIONS(3008),
    [anon_sym___thiscall] = ACTIONS(3008),
    [anon_sym___vectorcall] = ACTIONS(3008),
    [anon_sym_LBRACE] = ACTIONS(3010),
    [anon_sym_signed] = ACTIONS(3008),
    [anon_sym_unsigned] = ACTIONS(3008),
    [anon_sym_long] = ACTIONS(3008),
    [anon_sym_short] = ACTIONS(3008),
    [anon_sym_LBRACK] = ACTIONS(3008),
    [anon_sym_static] = ACTIONS(3008),
    [anon_sym_register] = ACTIONS(3008),
    [anon_sym_inline] = ACTIONS(3008),
    [anon_sym___inline] = ACTIONS(3008),
    [anon_sym___inline__] = ACTIONS(3008),
    [anon_sym___forceinline] = ACTIONS(3008),
    [anon_sym_thread_local] = ACTIONS(3008),
    [anon_sym___thread] = ACTIONS(3008),
    [anon_sym_const] = ACTIONS(3008),
    [anon_sym_constexpr] = ACTIONS(3008),
    [anon_sym_volatile] = ACTIONS(3008),
    [anon_sym_restrict] = ACTIONS(3008),
    [anon_sym___restrict__] = ACTIONS(3008),
    [anon_sym__Atomic] = ACTIONS(3008),
    [anon_sym__Noreturn] = ACTIONS(3008),
    [anon_sym_noreturn] = ACTIONS(3008),
    [anon_sym_mutable] = ACTIONS(3008),
    [anon_sym_constinit] = ACTIONS(3008),
    [anon_sym_consteval] = ACTIONS(3008),
    [anon_sym_PROGMEM] = ACTIONS(3008),
    [aux_sym_primitive_type_token1] = ACTIONS(3008),
    [anon_sym_byte] = ACTIONS(3008),
    [anon_sym_word] = ACTIONS(3008),
    [anon_sym_enum] = ACTIONS(3008),
    [anon_sym_class] = ACTIONS(3008),
    [anon_sym_struct] = ACTIONS(3008),
    [anon_sym_union] = ACTIONS(3008),
    [anon_sym_if] = ACTIONS(3008),
    [anon_sym_switch] = ACTIONS(3008),
    [anon_sym_case] = ACTIONS(3008),
    [anon_sym_default] = ACTIONS(3008),
    [anon_sym_while] = ACTIONS(3008),
    [anon_sym_do] = ACTIONS(3008),
    [anon_sym_for] = ACTIONS(3008),
    [anon_sym_return] = ACTIONS(3008),
    [anon_sym_break] = ACTIONS(3008),
    [anon_sym_continue] = ACTIONS(3008),
    [anon_sym_goto] = ACTIONS(3008),
    [anon_sym_not] = ACTIONS(3008),
    [anon_sym_compl] = ACTIONS(3008),
    [anon_sym_DASH_DASH] = ACTIONS(3010),
    [anon_sym_PLUS_PLUS] = ACTIONS(3010),
    [anon_sym_sizeof] = ACTIONS(3008),
    [anon_sym___alignof__] = ACTIONS(3008),
    [anon_sym___alignof] = ACTIONS(3008),
    [anon_sym__alignof] = ACTIONS(3008),
    [anon_sym_alignof] = ACTIONS(3008),
    [anon_sym__Alignof] = ACTIONS(3008),
    [anon_sym_offsetof] = ACTIONS(3008),
    [anon_sym__Generic] = ACTIONS(3008),
    [anon_sym_asm] = ACTIONS(3008),
    [anon_sym___asm__] = ACTIONS(3008),
    [aux_sym_number_literal_token1] = ACTIONS(3010),
    [aux_sym_number_literal_token2] = ACTIONS(3008),
    [anon_sym_L_SQUOTE] = ACTIONS(3010),
    [anon_sym_u_SQUOTE] = ACTIONS(3010),
    [anon_sym_U_SQUOTE] = ACTIONS(3010),
    [anon_sym_u8_SQUOTE] = ACTIONS(3010),
    [anon_sym_SQUOTE] = ACTIONS(3010),
    [anon_sym_L_DQUOTE] = ACTIONS(3010),
    [anon_sym_u_DQUOTE] = ACTIONS(3010),
    [anon_sym_U_DQUOTE] = ACTIONS(3010),
    [anon_sym_u8_DQUOTE] = ACTIONS(3010),
    [anon_sym_DQUOTE] = ACTIONS(3010),
    [sym_true] = ACTIONS(3008),
    [sym_false] = ACTIONS(3008),
    [anon_sym_NULL] = ACTIONS(3008),
    [anon_sym_nullptr] = ACTIONS(3008),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3008),
    [anon_sym_decltype] = ACTIONS(3008),
    [anon_sym_virtual] = ACTIONS(3008),
    [anon_sym_alignas] = ACTIONS(3008),
    [anon_sym_explicit] = ACTIONS(3008),
    [anon_sym_typename] = ACTIONS(3008),
    [anon_sym_template] = ACTIONS(3008),
    [anon_sym_operator] = ACTIONS(3008),
    [anon_sym_try] = ACTIONS(3008),
    [anon_sym_delete] = ACTIONS(3008),
    [anon_sym_throw] = ACTIONS(3008),
    [anon_sym_namespace] = ACTIONS(3008),
    [anon_sym_using] = ACTIONS(3008),
    [anon_sym_static_assert] = ACTIONS(3008),
    [anon_sym_concept] = ACTIONS(3008),
    [anon_sym_co_return] = ACTIONS(3008),
    [anon_sym_co_yield] = ACTIONS(3008),
    [anon_sym_R_DQUOTE] = ACTIONS(3010),
    [anon_sym_LR_DQUOTE] = ACTIONS(3010),
    [anon_sym_uR_DQUOTE] = ACTIONS(3010),
    [anon_sym_UR_DQUOTE] = ACTIONS(3010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3010),
    [anon_sym_co_await] = ACTIONS(3008),
    [anon_sym_new] = ACTIONS(3008),
    [anon_sym_requires] = ACTIONS(3008),
    [sym_this] = ACTIONS(3008),
  },
  [873] = {
    [ts_builtin_sym_end] = ACTIONS(3084),
    [sym_identifier] = ACTIONS(3082),
    [aux_sym_preproc_include_token1] = ACTIONS(3082),
    [aux_sym_preproc_def_token1] = ACTIONS(3082),
    [aux_sym_preproc_if_token1] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3082),
    [sym_preproc_directive] = ACTIONS(3082),
    [anon_sym_LPAREN2] = ACTIONS(3084),
    [anon_sym_BANG] = ACTIONS(3084),
    [anon_sym_TILDE] = ACTIONS(3084),
    [anon_sym_DASH] = ACTIONS(3082),
    [anon_sym_PLUS] = ACTIONS(3082),
    [anon_sym_STAR] = ACTIONS(3084),
    [anon_sym_AMP_AMP] = ACTIONS(3084),
    [anon_sym_AMP] = ACTIONS(3082),
    [anon_sym___extension__] = ACTIONS(3082),
    [anon_sym_typedef] = ACTIONS(3082),
    [anon_sym_extern] = ACTIONS(3082),
    [anon_sym___attribute__] = ACTIONS(3082),
    [anon_sym_COLON_COLON] = ACTIONS(3084),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3084),
    [anon_sym___declspec] = ACTIONS(3082),
    [anon_sym___based] = ACTIONS(3082),
    [anon_sym___cdecl] = ACTIONS(3082),
    [anon_sym___clrcall] = ACTIONS(3082),
    [anon_sym___stdcall] = ACTIONS(3082),
    [anon_sym___fastcall] = ACTIONS(3082),
    [anon_sym___thiscall] = ACTIONS(3082),
    [anon_sym___vectorcall] = ACTIONS(3082),
    [anon_sym_LBRACE] = ACTIONS(3084),
    [anon_sym_signed] = ACTIONS(3082),
    [anon_sym_unsigned] = ACTIONS(3082),
    [anon_sym_long] = ACTIONS(3082),
    [anon_sym_short] = ACTIONS(3082),
    [anon_sym_LBRACK] = ACTIONS(3082),
    [anon_sym_static] = ACTIONS(3082),
    [anon_sym_register] = ACTIONS(3082),
    [anon_sym_inline] = ACTIONS(3082),
    [anon_sym___inline] = ACTIONS(3082),
    [anon_sym___inline__] = ACTIONS(3082),
    [anon_sym___forceinline] = ACTIONS(3082),
    [anon_sym_thread_local] = ACTIONS(3082),
    [anon_sym___thread] = ACTIONS(3082),
    [anon_sym_const] = ACTIONS(3082),
    [anon_sym_constexpr] = ACTIONS(3082),
    [anon_sym_volatile] = ACTIONS(3082),
    [anon_sym_restrict] = ACTIONS(3082),
    [anon_sym___restrict__] = ACTIONS(3082),
    [anon_sym__Atomic] = ACTIONS(3082),
    [anon_sym__Noreturn] = ACTIONS(3082),
    [anon_sym_noreturn] = ACTIONS(3082),
    [anon_sym_mutable] = ACTIONS(3082),
    [anon_sym_constinit] = ACTIONS(3082),
    [anon_sym_consteval] = ACTIONS(3082),
    [anon_sym_PROGMEM] = ACTIONS(3082),
    [aux_sym_primitive_type_token1] = ACTIONS(3082),
    [anon_sym_byte] = ACTIONS(3082),
    [anon_sym_word] = ACTIONS(3082),
    [anon_sym_enum] = ACTIONS(3082),
    [anon_sym_class] = ACTIONS(3082),
    [anon_sym_struct] = ACTIONS(3082),
    [anon_sym_union] = ACTIONS(3082),
    [anon_sym_if] = ACTIONS(3082),
    [anon_sym_switch] = ACTIONS(3082),
    [anon_sym_case] = ACTIONS(3082),
    [anon_sym_default] = ACTIONS(3082),
    [anon_sym_while] = ACTIONS(3082),
    [anon_sym_do] = ACTIONS(3082),
    [anon_sym_for] = ACTIONS(3082),
    [anon_sym_return] = ACTIONS(3082),
    [anon_sym_break] = ACTIONS(3082),
    [anon_sym_continue] = ACTIONS(3082),
    [anon_sym_goto] = ACTIONS(3082),
    [anon_sym_not] = ACTIONS(3082),
    [anon_sym_compl] = ACTIONS(3082),
    [anon_sym_DASH_DASH] = ACTIONS(3084),
    [anon_sym_PLUS_PLUS] = ACTIONS(3084),
    [anon_sym_sizeof] = ACTIONS(3082),
    [anon_sym___alignof__] = ACTIONS(3082),
    [anon_sym___alignof] = ACTIONS(3082),
    [anon_sym__alignof] = ACTIONS(3082),
    [anon_sym_alignof] = ACTIONS(3082),
    [anon_sym__Alignof] = ACTIONS(3082),
    [anon_sym_offsetof] = ACTIONS(3082),
    [anon_sym__Generic] = ACTIONS(3082),
    [anon_sym_asm] = ACTIONS(3082),
    [anon_sym___asm__] = ACTIONS(3082),
    [aux_sym_number_literal_token1] = ACTIONS(3084),
    [aux_sym_number_literal_token2] = ACTIONS(3082),
    [anon_sym_L_SQUOTE] = ACTIONS(3084),
    [anon_sym_u_SQUOTE] = ACTIONS(3084),
    [anon_sym_U_SQUOTE] = ACTIONS(3084),
    [anon_sym_u8_SQUOTE] = ACTIONS(3084),
    [anon_sym_SQUOTE] = ACTIONS(3084),
    [anon_sym_L_DQUOTE] = ACTIONS(3084),
    [anon_sym_u_DQUOTE] = ACTIONS(3084),
    [anon_sym_U_DQUOTE] = ACTIONS(3084),
    [anon_sym_u8_DQUOTE] = ACTIONS(3084),
    [anon_sym_DQUOTE] = ACTIONS(3084),
    [sym_true] = ACTIONS(3082),
    [sym_false] = ACTIONS(3082),
    [anon_sym_NULL] = ACTIONS(3082),
    [anon_sym_nullptr] = ACTIONS(3082),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3082),
    [anon_sym_decltype] = ACTIONS(3082),
    [anon_sym_virtual] = ACTIONS(3082),
    [anon_sym_alignas] = ACTIONS(3082),
    [anon_sym_explicit] = ACTIONS(3082),
    [anon_sym_typename] = ACTIONS(3082),
    [anon_sym_template] = ACTIONS(3082),
    [anon_sym_operator] = ACTIONS(3082),
    [anon_sym_try] = ACTIONS(3082),
    [anon_sym_delete] = ACTIONS(3082),
    [anon_sym_throw] = ACTIONS(3082),
    [anon_sym_namespace] = ACTIONS(3082),
    [anon_sym_using] = ACTIONS(3082),
    [anon_sym_static_assert] = ACTIONS(3082),
    [anon_sym_concept] = ACTIONS(3082),
    [anon_sym_co_return] = ACTIONS(3082),
    [anon_sym_co_yield] = ACTIONS(3082),
    [anon_sym_R_DQUOTE] = ACTIONS(3084),
    [anon_sym_LR_DQUOTE] = ACTIONS(3084),
    [anon_sym_uR_DQUOTE] = ACTIONS(3084),
    [anon_sym_UR_DQUOTE] = ACTIONS(3084),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3084),
    [anon_sym_co_await] = ACTIONS(3082),
    [anon_sym_new] = ACTIONS(3082),
    [anon_sym_requires] = ACTIONS(3082),
    [sym_this] = ACTIONS(3082),
  },
  [874] = {
    [ts_builtin_sym_end] = ACTIONS(3080),
    [sym_identifier] = ACTIONS(3078),
    [aux_sym_preproc_include_token1] = ACTIONS(3078),
    [aux_sym_preproc_def_token1] = ACTIONS(3078),
    [aux_sym_preproc_if_token1] = ACTIONS(3078),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3078),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3078),
    [sym_preproc_directive] = ACTIONS(3078),
    [anon_sym_LPAREN2] = ACTIONS(3080),
    [anon_sym_BANG] = ACTIONS(3080),
    [anon_sym_TILDE] = ACTIONS(3080),
    [anon_sym_DASH] = ACTIONS(3078),
    [anon_sym_PLUS] = ACTIONS(3078),
    [anon_sym_STAR] = ACTIONS(3080),
    [anon_sym_AMP_AMP] = ACTIONS(3080),
    [anon_sym_AMP] = ACTIONS(3078),
    [anon_sym___extension__] = ACTIONS(3078),
    [anon_sym_typedef] = ACTIONS(3078),
    [anon_sym_extern] = ACTIONS(3078),
    [anon_sym___attribute__] = ACTIONS(3078),
    [anon_sym_COLON_COLON] = ACTIONS(3080),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3080),
    [anon_sym___declspec] = ACTIONS(3078),
    [anon_sym___based] = ACTIONS(3078),
    [anon_sym___cdecl] = ACTIONS(3078),
    [anon_sym___clrcall] = ACTIONS(3078),
    [anon_sym___stdcall] = ACTIONS(3078),
    [anon_sym___fastcall] = ACTIONS(3078),
    [anon_sym___thiscall] = ACTIONS(3078),
    [anon_sym___vectorcall] = ACTIONS(3078),
    [anon_sym_LBRACE] = ACTIONS(3080),
    [anon_sym_signed] = ACTIONS(3078),
    [anon_sym_unsigned] = ACTIONS(3078),
    [anon_sym_long] = ACTIONS(3078),
    [anon_sym_short] = ACTIONS(3078),
    [anon_sym_LBRACK] = ACTIONS(3078),
    [anon_sym_static] = ACTIONS(3078),
    [anon_sym_register] = ACTIONS(3078),
    [anon_sym_inline] = ACTIONS(3078),
    [anon_sym___inline] = ACTIONS(3078),
    [anon_sym___inline__] = ACTIONS(3078),
    [anon_sym___forceinline] = ACTIONS(3078),
    [anon_sym_thread_local] = ACTIONS(3078),
    [anon_sym___thread] = ACTIONS(3078),
    [anon_sym_const] = ACTIONS(3078),
    [anon_sym_constexpr] = ACTIONS(3078),
    [anon_sym_volatile] = ACTIONS(3078),
    [anon_sym_restrict] = ACTIONS(3078),
    [anon_sym___restrict__] = ACTIONS(3078),
    [anon_sym__Atomic] = ACTIONS(3078),
    [anon_sym__Noreturn] = ACTIONS(3078),
    [anon_sym_noreturn] = ACTIONS(3078),
    [anon_sym_mutable] = ACTIONS(3078),
    [anon_sym_constinit] = ACTIONS(3078),
    [anon_sym_consteval] = ACTIONS(3078),
    [anon_sym_PROGMEM] = ACTIONS(3078),
    [aux_sym_primitive_type_token1] = ACTIONS(3078),
    [anon_sym_byte] = ACTIONS(3078),
    [anon_sym_word] = ACTIONS(3078),
    [anon_sym_enum] = ACTIONS(3078),
    [anon_sym_class] = ACTIONS(3078),
    [anon_sym_struct] = ACTIONS(3078),
    [anon_sym_union] = ACTIONS(3078),
    [anon_sym_if] = ACTIONS(3078),
    [anon_sym_switch] = ACTIONS(3078),
    [anon_sym_case] = ACTIONS(3078),
    [anon_sym_default] = ACTIONS(3078),
    [anon_sym_while] = ACTIONS(3078),
    [anon_sym_do] = ACTIONS(3078),
    [anon_sym_for] = ACTIONS(3078),
    [anon_sym_return] = ACTIONS(3078),
    [anon_sym_break] = ACTIONS(3078),
    [anon_sym_continue] = ACTIONS(3078),
    [anon_sym_goto] = ACTIONS(3078),
    [anon_sym_not] = ACTIONS(3078),
    [anon_sym_compl] = ACTIONS(3078),
    [anon_sym_DASH_DASH] = ACTIONS(3080),
    [anon_sym_PLUS_PLUS] = ACTIONS(3080),
    [anon_sym_sizeof] = ACTIONS(3078),
    [anon_sym___alignof__] = ACTIONS(3078),
    [anon_sym___alignof] = ACTIONS(3078),
    [anon_sym__alignof] = ACTIONS(3078),
    [anon_sym_alignof] = ACTIONS(3078),
    [anon_sym__Alignof] = ACTIONS(3078),
    [anon_sym_offsetof] = ACTIONS(3078),
    [anon_sym__Generic] = ACTIONS(3078),
    [anon_sym_asm] = ACTIONS(3078),
    [anon_sym___asm__] = ACTIONS(3078),
    [aux_sym_number_literal_token1] = ACTIONS(3080),
    [aux_sym_number_literal_token2] = ACTIONS(3078),
    [anon_sym_L_SQUOTE] = ACTIONS(3080),
    [anon_sym_u_SQUOTE] = ACTIONS(3080),
    [anon_sym_U_SQUOTE] = ACTIONS(3080),
    [anon_sym_u8_SQUOTE] = ACTIONS(3080),
    [anon_sym_SQUOTE] = ACTIONS(3080),
    [anon_sym_L_DQUOTE] = ACTIONS(3080),
    [anon_sym_u_DQUOTE] = ACTIONS(3080),
    [anon_sym_U_DQUOTE] = ACTIONS(3080),
    [anon_sym_u8_DQUOTE] = ACTIONS(3080),
    [anon_sym_DQUOTE] = ACTIONS(3080),
    [sym_true] = ACTIONS(3078),
    [sym_false] = ACTIONS(3078),
    [anon_sym_NULL] = ACTIONS(3078),
    [anon_sym_nullptr] = ACTIONS(3078),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3078),
    [anon_sym_decltype] = ACTIONS(3078),
    [anon_sym_virtual] = ACTIONS(3078),
    [anon_sym_alignas] = ACTIONS(3078),
    [anon_sym_explicit] = ACTIONS(3078),
    [anon_sym_typename] = ACTIONS(3078),
    [anon_sym_template] = ACTIONS(3078),
    [anon_sym_operator] = ACTIONS(3078),
    [anon_sym_try] = ACTIONS(3078),
    [anon_sym_delete] = ACTIONS(3078),
    [anon_sym_throw] = ACTIONS(3078),
    [anon_sym_namespace] = ACTIONS(3078),
    [anon_sym_using] = ACTIONS(3078),
    [anon_sym_static_assert] = ACTIONS(3078),
    [anon_sym_concept] = ACTIONS(3078),
    [anon_sym_co_return] = ACTIONS(3078),
    [anon_sym_co_yield] = ACTIONS(3078),
    [anon_sym_R_DQUOTE] = ACTIONS(3080),
    [anon_sym_LR_DQUOTE] = ACTIONS(3080),
    [anon_sym_uR_DQUOTE] = ACTIONS(3080),
    [anon_sym_UR_DQUOTE] = ACTIONS(3080),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3080),
    [anon_sym_co_await] = ACTIONS(3078),
    [anon_sym_new] = ACTIONS(3078),
    [anon_sym_requires] = ACTIONS(3078),
    [sym_this] = ACTIONS(3078),
  },
  [875] = {
    [ts_builtin_sym_end] = ACTIONS(2977),
    [sym_identifier] = ACTIONS(2975),
    [aux_sym_preproc_include_token1] = ACTIONS(2975),
    [aux_sym_preproc_def_token1] = ACTIONS(2975),
    [aux_sym_preproc_if_token1] = ACTIONS(2975),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2975),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2975),
    [sym_preproc_directive] = ACTIONS(2975),
    [anon_sym_LPAREN2] = ACTIONS(2977),
    [anon_sym_BANG] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2975),
    [anon_sym_PLUS] = ACTIONS(2975),
    [anon_sym_STAR] = ACTIONS(2977),
    [anon_sym_AMP_AMP] = ACTIONS(2977),
    [anon_sym_AMP] = ACTIONS(2975),
    [anon_sym___extension__] = ACTIONS(2975),
    [anon_sym_typedef] = ACTIONS(2975),
    [anon_sym_extern] = ACTIONS(2975),
    [anon_sym___attribute__] = ACTIONS(2975),
    [anon_sym_COLON_COLON] = ACTIONS(2977),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2977),
    [anon_sym___declspec] = ACTIONS(2975),
    [anon_sym___based] = ACTIONS(2975),
    [anon_sym___cdecl] = ACTIONS(2975),
    [anon_sym___clrcall] = ACTIONS(2975),
    [anon_sym___stdcall] = ACTIONS(2975),
    [anon_sym___fastcall] = ACTIONS(2975),
    [anon_sym___thiscall] = ACTIONS(2975),
    [anon_sym___vectorcall] = ACTIONS(2975),
    [anon_sym_LBRACE] = ACTIONS(2977),
    [anon_sym_signed] = ACTIONS(2975),
    [anon_sym_unsigned] = ACTIONS(2975),
    [anon_sym_long] = ACTIONS(2975),
    [anon_sym_short] = ACTIONS(2975),
    [anon_sym_LBRACK] = ACTIONS(2975),
    [anon_sym_static] = ACTIONS(2975),
    [anon_sym_register] = ACTIONS(2975),
    [anon_sym_inline] = ACTIONS(2975),
    [anon_sym___inline] = ACTIONS(2975),
    [anon_sym___inline__] = ACTIONS(2975),
    [anon_sym___forceinline] = ACTIONS(2975),
    [anon_sym_thread_local] = ACTIONS(2975),
    [anon_sym___thread] = ACTIONS(2975),
    [anon_sym_const] = ACTIONS(2975),
    [anon_sym_constexpr] = ACTIONS(2975),
    [anon_sym_volatile] = ACTIONS(2975),
    [anon_sym_restrict] = ACTIONS(2975),
    [anon_sym___restrict__] = ACTIONS(2975),
    [anon_sym__Atomic] = ACTIONS(2975),
    [anon_sym__Noreturn] = ACTIONS(2975),
    [anon_sym_noreturn] = ACTIONS(2975),
    [anon_sym_mutable] = ACTIONS(2975),
    [anon_sym_constinit] = ACTIONS(2975),
    [anon_sym_consteval] = ACTIONS(2975),
    [anon_sym_PROGMEM] = ACTIONS(2975),
    [aux_sym_primitive_type_token1] = ACTIONS(2975),
    [anon_sym_byte] = ACTIONS(2975),
    [anon_sym_word] = ACTIONS(2975),
    [anon_sym_enum] = ACTIONS(2975),
    [anon_sym_class] = ACTIONS(2975),
    [anon_sym_struct] = ACTIONS(2975),
    [anon_sym_union] = ACTIONS(2975),
    [anon_sym_if] = ACTIONS(2975),
    [anon_sym_switch] = ACTIONS(2975),
    [anon_sym_case] = ACTIONS(2975),
    [anon_sym_default] = ACTIONS(2975),
    [anon_sym_while] = ACTIONS(2975),
    [anon_sym_do] = ACTIONS(2975),
    [anon_sym_for] = ACTIONS(2975),
    [anon_sym_return] = ACTIONS(2975),
    [anon_sym_break] = ACTIONS(2975),
    [anon_sym_continue] = ACTIONS(2975),
    [anon_sym_goto] = ACTIONS(2975),
    [anon_sym_not] = ACTIONS(2975),
    [anon_sym_compl] = ACTIONS(2975),
    [anon_sym_DASH_DASH] = ACTIONS(2977),
    [anon_sym_PLUS_PLUS] = ACTIONS(2977),
    [anon_sym_sizeof] = ACTIONS(2975),
    [anon_sym___alignof__] = ACTIONS(2975),
    [anon_sym___alignof] = ACTIONS(2975),
    [anon_sym__alignof] = ACTIONS(2975),
    [anon_sym_alignof] = ACTIONS(2975),
    [anon_sym__Alignof] = ACTIONS(2975),
    [anon_sym_offsetof] = ACTIONS(2975),
    [anon_sym__Generic] = ACTIONS(2975),
    [anon_sym_asm] = ACTIONS(2975),
    [anon_sym___asm__] = ACTIONS(2975),
    [aux_sym_number_literal_token1] = ACTIONS(2977),
    [aux_sym_number_literal_token2] = ACTIONS(2975),
    [anon_sym_L_SQUOTE] = ACTIONS(2977),
    [anon_sym_u_SQUOTE] = ACTIONS(2977),
    [anon_sym_U_SQUOTE] = ACTIONS(2977),
    [anon_sym_u8_SQUOTE] = ACTIONS(2977),
    [anon_sym_SQUOTE] = ACTIONS(2977),
    [anon_sym_L_DQUOTE] = ACTIONS(2977),
    [anon_sym_u_DQUOTE] = ACTIONS(2977),
    [anon_sym_U_DQUOTE] = ACTIONS(2977),
    [anon_sym_u8_DQUOTE] = ACTIONS(2977),
    [anon_sym_DQUOTE] = ACTIONS(2977),
    [sym_true] = ACTIONS(2975),
    [sym_false] = ACTIONS(2975),
    [anon_sym_NULL] = ACTIONS(2975),
    [anon_sym_nullptr] = ACTIONS(2975),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2975),
    [anon_sym_decltype] = ACTIONS(2975),
    [anon_sym_virtual] = ACTIONS(2975),
    [anon_sym_alignas] = ACTIONS(2975),
    [anon_sym_explicit] = ACTIONS(2975),
    [anon_sym_typename] = ACTIONS(2975),
    [anon_sym_template] = ACTIONS(2975),
    [anon_sym_operator] = ACTIONS(2975),
    [anon_sym_try] = ACTIONS(2975),
    [anon_sym_delete] = ACTIONS(2975),
    [anon_sym_throw] = ACTIONS(2975),
    [anon_sym_namespace] = ACTIONS(2975),
    [anon_sym_using] = ACTIONS(2975),
    [anon_sym_static_assert] = ACTIONS(2975),
    [anon_sym_concept] = ACTIONS(2975),
    [anon_sym_co_return] = ACTIONS(2975),
    [anon_sym_co_yield] = ACTIONS(2975),
    [anon_sym_R_DQUOTE] = ACTIONS(2977),
    [anon_sym_LR_DQUOTE] = ACTIONS(2977),
    [anon_sym_uR_DQUOTE] = ACTIONS(2977),
    [anon_sym_UR_DQUOTE] = ACTIONS(2977),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2977),
    [anon_sym_co_await] = ACTIONS(2975),
    [anon_sym_new] = ACTIONS(2975),
    [anon_sym_requires] = ACTIONS(2975),
    [sym_this] = ACTIONS(2975),
  },
  [876] = {
    [ts_builtin_sym_end] = ACTIONS(3474),
    [sym_identifier] = ACTIONS(3476),
    [aux_sym_preproc_include_token1] = ACTIONS(3476),
    [aux_sym_preproc_def_token1] = ACTIONS(3476),
    [aux_sym_preproc_if_token1] = ACTIONS(3476),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3476),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3476),
    [sym_preproc_directive] = ACTIONS(3476),
    [anon_sym_LPAREN2] = ACTIONS(3474),
    [anon_sym_BANG] = ACTIONS(3474),
    [anon_sym_TILDE] = ACTIONS(3474),
    [anon_sym_DASH] = ACTIONS(3476),
    [anon_sym_PLUS] = ACTIONS(3476),
    [anon_sym_STAR] = ACTIONS(3474),
    [anon_sym_AMP_AMP] = ACTIONS(3474),
    [anon_sym_AMP] = ACTIONS(3476),
    [anon_sym___extension__] = ACTIONS(3476),
    [anon_sym_typedef] = ACTIONS(3476),
    [anon_sym_extern] = ACTIONS(3476),
    [anon_sym___attribute__] = ACTIONS(3476),
    [anon_sym_COLON_COLON] = ACTIONS(3474),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3474),
    [anon_sym___declspec] = ACTIONS(3476),
    [anon_sym___based] = ACTIONS(3476),
    [anon_sym___cdecl] = ACTIONS(3476),
    [anon_sym___clrcall] = ACTIONS(3476),
    [anon_sym___stdcall] = ACTIONS(3476),
    [anon_sym___fastcall] = ACTIONS(3476),
    [anon_sym___thiscall] = ACTIONS(3476),
    [anon_sym___vectorcall] = ACTIONS(3476),
    [anon_sym_LBRACE] = ACTIONS(3474),
    [anon_sym_signed] = ACTIONS(3476),
    [anon_sym_unsigned] = ACTIONS(3476),
    [anon_sym_long] = ACTIONS(3476),
    [anon_sym_short] = ACTIONS(3476),
    [anon_sym_LBRACK] = ACTIONS(3476),
    [anon_sym_static] = ACTIONS(3476),
    [anon_sym_register] = ACTIONS(3476),
    [anon_sym_inline] = ACTIONS(3476),
    [anon_sym___inline] = ACTIONS(3476),
    [anon_sym___inline__] = ACTIONS(3476),
    [anon_sym___forceinline] = ACTIONS(3476),
    [anon_sym_thread_local] = ACTIONS(3476),
    [anon_sym___thread] = ACTIONS(3476),
    [anon_sym_const] = ACTIONS(3476),
    [anon_sym_constexpr] = ACTIONS(3476),
    [anon_sym_volatile] = ACTIONS(3476),
    [anon_sym_restrict] = ACTIONS(3476),
    [anon_sym___restrict__] = ACTIONS(3476),
    [anon_sym__Atomic] = ACTIONS(3476),
    [anon_sym__Noreturn] = ACTIONS(3476),
    [anon_sym_noreturn] = ACTIONS(3476),
    [anon_sym_mutable] = ACTIONS(3476),
    [anon_sym_constinit] = ACTIONS(3476),
    [anon_sym_consteval] = ACTIONS(3476),
    [anon_sym_PROGMEM] = ACTIONS(3476),
    [aux_sym_primitive_type_token1] = ACTIONS(3476),
    [anon_sym_byte] = ACTIONS(3476),
    [anon_sym_word] = ACTIONS(3476),
    [anon_sym_enum] = ACTIONS(3476),
    [anon_sym_class] = ACTIONS(3476),
    [anon_sym_struct] = ACTIONS(3476),
    [anon_sym_union] = ACTIONS(3476),
    [anon_sym_if] = ACTIONS(3476),
    [anon_sym_switch] = ACTIONS(3476),
    [anon_sym_case] = ACTIONS(3476),
    [anon_sym_default] = ACTIONS(3476),
    [anon_sym_while] = ACTIONS(3476),
    [anon_sym_do] = ACTIONS(3476),
    [anon_sym_for] = ACTIONS(3476),
    [anon_sym_return] = ACTIONS(3476),
    [anon_sym_break] = ACTIONS(3476),
    [anon_sym_continue] = ACTIONS(3476),
    [anon_sym_goto] = ACTIONS(3476),
    [anon_sym_not] = ACTIONS(3476),
    [anon_sym_compl] = ACTIONS(3476),
    [anon_sym_DASH_DASH] = ACTIONS(3474),
    [anon_sym_PLUS_PLUS] = ACTIONS(3474),
    [anon_sym_sizeof] = ACTIONS(3476),
    [anon_sym___alignof__] = ACTIONS(3476),
    [anon_sym___alignof] = ACTIONS(3476),
    [anon_sym__alignof] = ACTIONS(3476),
    [anon_sym_alignof] = ACTIONS(3476),
    [anon_sym__Alignof] = ACTIONS(3476),
    [anon_sym_offsetof] = ACTIONS(3476),
    [anon_sym__Generic] = ACTIONS(3476),
    [anon_sym_asm] = ACTIONS(3476),
    [anon_sym___asm__] = ACTIONS(3476),
    [aux_sym_number_literal_token1] = ACTIONS(3474),
    [aux_sym_number_literal_token2] = ACTIONS(3476),
    [anon_sym_L_SQUOTE] = ACTIONS(3474),
    [anon_sym_u_SQUOTE] = ACTIONS(3474),
    [anon_sym_U_SQUOTE] = ACTIONS(3474),
    [anon_sym_u8_SQUOTE] = ACTIONS(3474),
    [anon_sym_SQUOTE] = ACTIONS(3474),
    [anon_sym_L_DQUOTE] = ACTIONS(3474),
    [anon_sym_u_DQUOTE] = ACTIONS(3474),
    [anon_sym_U_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [sym_true] = ACTIONS(3476),
    [sym_false] = ACTIONS(3476),
    [anon_sym_NULL] = ACTIONS(3476),
    [anon_sym_nullptr] = ACTIONS(3476),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3476),
    [anon_sym_decltype] = ACTIONS(3476),
    [anon_sym_virtual] = ACTIONS(3476),
    [anon_sym_alignas] = ACTIONS(3476),
    [anon_sym_explicit] = ACTIONS(3476),
    [anon_sym_typename] = ACTIONS(3476),
    [anon_sym_template] = ACTIONS(3476),
    [anon_sym_operator] = ACTIONS(3476),
    [anon_sym_try] = ACTIONS(3476),
    [anon_sym_delete] = ACTIONS(3476),
    [anon_sym_throw] = ACTIONS(3476),
    [anon_sym_namespace] = ACTIONS(3476),
    [anon_sym_using] = ACTIONS(3476),
    [anon_sym_static_assert] = ACTIONS(3476),
    [anon_sym_concept] = ACTIONS(3476),
    [anon_sym_co_return] = ACTIONS(3476),
    [anon_sym_co_yield] = ACTIONS(3476),
    [anon_sym_R_DQUOTE] = ACTIONS(3474),
    [anon_sym_LR_DQUOTE] = ACTIONS(3474),
    [anon_sym_uR_DQUOTE] = ACTIONS(3474),
    [anon_sym_UR_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3474),
    [anon_sym_co_await] = ACTIONS(3476),
    [anon_sym_new] = ACTIONS(3476),
    [anon_sym_requires] = ACTIONS(3476),
    [sym_this] = ACTIONS(3476),
  },
  [877] = {
    [ts_builtin_sym_end] = ACTIONS(2895),
    [sym_identifier] = ACTIONS(2893),
    [aux_sym_preproc_include_token1] = ACTIONS(2893),
    [aux_sym_preproc_def_token1] = ACTIONS(2893),
    [aux_sym_preproc_if_token1] = ACTIONS(2893),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2893),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2893),
    [sym_preproc_directive] = ACTIONS(2893),
    [anon_sym_LPAREN2] = ACTIONS(2895),
    [anon_sym_BANG] = ACTIONS(2895),
    [anon_sym_TILDE] = ACTIONS(2895),
    [anon_sym_DASH] = ACTIONS(2893),
    [anon_sym_PLUS] = ACTIONS(2893),
    [anon_sym_STAR] = ACTIONS(2895),
    [anon_sym_AMP_AMP] = ACTIONS(2895),
    [anon_sym_AMP] = ACTIONS(2893),
    [anon_sym___extension__] = ACTIONS(2893),
    [anon_sym_typedef] = ACTIONS(2893),
    [anon_sym_extern] = ACTIONS(2893),
    [anon_sym___attribute__] = ACTIONS(2893),
    [anon_sym_COLON_COLON] = ACTIONS(2895),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2895),
    [anon_sym___declspec] = ACTIONS(2893),
    [anon_sym___based] = ACTIONS(2893),
    [anon_sym___cdecl] = ACTIONS(2893),
    [anon_sym___clrcall] = ACTIONS(2893),
    [anon_sym___stdcall] = ACTIONS(2893),
    [anon_sym___fastcall] = ACTIONS(2893),
    [anon_sym___thiscall] = ACTIONS(2893),
    [anon_sym___vectorcall] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(2895),
    [anon_sym_signed] = ACTIONS(2893),
    [anon_sym_unsigned] = ACTIONS(2893),
    [anon_sym_long] = ACTIONS(2893),
    [anon_sym_short] = ACTIONS(2893),
    [anon_sym_LBRACK] = ACTIONS(2893),
    [anon_sym_static] = ACTIONS(2893),
    [anon_sym_register] = ACTIONS(2893),
    [anon_sym_inline] = ACTIONS(2893),
    [anon_sym___inline] = ACTIONS(2893),
    [anon_sym___inline__] = ACTIONS(2893),
    [anon_sym___forceinline] = ACTIONS(2893),
    [anon_sym_thread_local] = ACTIONS(2893),
    [anon_sym___thread] = ACTIONS(2893),
    [anon_sym_const] = ACTIONS(2893),
    [anon_sym_constexpr] = ACTIONS(2893),
    [anon_sym_volatile] = ACTIONS(2893),
    [anon_sym_restrict] = ACTIONS(2893),
    [anon_sym___restrict__] = ACTIONS(2893),
    [anon_sym__Atomic] = ACTIONS(2893),
    [anon_sym__Noreturn] = ACTIONS(2893),
    [anon_sym_noreturn] = ACTIONS(2893),
    [anon_sym_mutable] = ACTIONS(2893),
    [anon_sym_constinit] = ACTIONS(2893),
    [anon_sym_consteval] = ACTIONS(2893),
    [anon_sym_PROGMEM] = ACTIONS(2893),
    [aux_sym_primitive_type_token1] = ACTIONS(2893),
    [anon_sym_byte] = ACTIONS(2893),
    [anon_sym_word] = ACTIONS(2893),
    [anon_sym_enum] = ACTIONS(2893),
    [anon_sym_class] = ACTIONS(2893),
    [anon_sym_struct] = ACTIONS(2893),
    [anon_sym_union] = ACTIONS(2893),
    [anon_sym_if] = ACTIONS(2893),
    [anon_sym_switch] = ACTIONS(2893),
    [anon_sym_case] = ACTIONS(2893),
    [anon_sym_default] = ACTIONS(2893),
    [anon_sym_while] = ACTIONS(2893),
    [anon_sym_do] = ACTIONS(2893),
    [anon_sym_for] = ACTIONS(2893),
    [anon_sym_return] = ACTIONS(2893),
    [anon_sym_break] = ACTIONS(2893),
    [anon_sym_continue] = ACTIONS(2893),
    [anon_sym_goto] = ACTIONS(2893),
    [anon_sym_not] = ACTIONS(2893),
    [anon_sym_compl] = ACTIONS(2893),
    [anon_sym_DASH_DASH] = ACTIONS(2895),
    [anon_sym_PLUS_PLUS] = ACTIONS(2895),
    [anon_sym_sizeof] = ACTIONS(2893),
    [anon_sym___alignof__] = ACTIONS(2893),
    [anon_sym___alignof] = ACTIONS(2893),
    [anon_sym__alignof] = ACTIONS(2893),
    [anon_sym_alignof] = ACTIONS(2893),
    [anon_sym__Alignof] = ACTIONS(2893),
    [anon_sym_offsetof] = ACTIONS(2893),
    [anon_sym__Generic] = ACTIONS(2893),
    [anon_sym_asm] = ACTIONS(2893),
    [anon_sym___asm__] = ACTIONS(2893),
    [aux_sym_number_literal_token1] = ACTIONS(2895),
    [aux_sym_number_literal_token2] = ACTIONS(2893),
    [anon_sym_L_SQUOTE] = ACTIONS(2895),
    [anon_sym_u_SQUOTE] = ACTIONS(2895),
    [anon_sym_U_SQUOTE] = ACTIONS(2895),
    [anon_sym_u8_SQUOTE] = ACTIONS(2895),
    [anon_sym_SQUOTE] = ACTIONS(2895),
    [anon_sym_L_DQUOTE] = ACTIONS(2895),
    [anon_sym_u_DQUOTE] = ACTIONS(2895),
    [anon_sym_U_DQUOTE] = ACTIONS(2895),
    [anon_sym_u8_DQUOTE] = ACTIONS(2895),
    [anon_sym_DQUOTE] = ACTIONS(2895),
    [sym_true] = ACTIONS(2893),
    [sym_false] = ACTIONS(2893),
    [anon_sym_NULL] = ACTIONS(2893),
    [anon_sym_nullptr] = ACTIONS(2893),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2893),
    [anon_sym_decltype] = ACTIONS(2893),
    [anon_sym_virtual] = ACTIONS(2893),
    [anon_sym_alignas] = ACTIONS(2893),
    [anon_sym_explicit] = ACTIONS(2893),
    [anon_sym_typename] = ACTIONS(2893),
    [anon_sym_template] = ACTIONS(2893),
    [anon_sym_operator] = ACTIONS(2893),
    [anon_sym_try] = ACTIONS(2893),
    [anon_sym_delete] = ACTIONS(2893),
    [anon_sym_throw] = ACTIONS(2893),
    [anon_sym_namespace] = ACTIONS(2893),
    [anon_sym_using] = ACTIONS(2893),
    [anon_sym_static_assert] = ACTIONS(2893),
    [anon_sym_concept] = ACTIONS(2893),
    [anon_sym_co_return] = ACTIONS(2893),
    [anon_sym_co_yield] = ACTIONS(2893),
    [anon_sym_R_DQUOTE] = ACTIONS(2895),
    [anon_sym_LR_DQUOTE] = ACTIONS(2895),
    [anon_sym_uR_DQUOTE] = ACTIONS(2895),
    [anon_sym_UR_DQUOTE] = ACTIONS(2895),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2895),
    [anon_sym_co_await] = ACTIONS(2893),
    [anon_sym_new] = ACTIONS(2893),
    [anon_sym_requires] = ACTIONS(2893),
    [sym_this] = ACTIONS(2893),
  },
  [878] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(3868),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_initializer_list] = STATE(3905),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1885),
    [anon_sym_COMMA] = ACTIONS(1885),
    [anon_sym_LPAREN2] = ACTIONS(1885),
    [anon_sym_BANG] = ACTIONS(3480),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(1883),
    [anon_sym_PLUS] = ACTIONS(1883),
    [anon_sym_STAR] = ACTIONS(1885),
    [anon_sym_SLASH] = ACTIONS(1883),
    [anon_sym_PERCENT] = ACTIONS(1885),
    [anon_sym_PIPE_PIPE] = ACTIONS(1885),
    [anon_sym_AMP_AMP] = ACTIONS(1885),
    [anon_sym_PIPE] = ACTIONS(1883),
    [anon_sym_CARET] = ACTIONS(1885),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym_EQ_EQ] = ACTIONS(1885),
    [anon_sym_BANG_EQ] = ACTIONS(1885),
    [anon_sym_GT] = ACTIONS(1883),
    [anon_sym_GT_EQ] = ACTIONS(1885),
    [anon_sym_LT_EQ] = ACTIONS(1883),
    [anon_sym_LT] = ACTIONS(1883),
    [anon_sym_LT_LT] = ACTIONS(1885),
    [anon_sym_GT_GT] = ACTIONS(1885),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(1885),
    [anon_sym_RBRACK] = ACTIONS(1885),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_QMARK] = ACTIONS(1885),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_LT_EQ_GT] = ACTIONS(1885),
    [anon_sym_or] = ACTIONS(1883),
    [anon_sym_and] = ACTIONS(1883),
    [anon_sym_bitor] = ACTIONS(1883),
    [anon_sym_xor] = ACTIONS(1883),
    [anon_sym_bitand] = ACTIONS(1883),
    [anon_sym_not_eq] = ACTIONS(1883),
    [anon_sym_DASH_DASH] = ACTIONS(1885),
    [anon_sym_PLUS_PLUS] = ACTIONS(1885),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(1883),
    [anon_sym_DOT_STAR] = ACTIONS(1885),
    [anon_sym_DASH_GT] = ACTIONS(1885),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [879] = {
    [ts_builtin_sym_end] = ACTIONS(2895),
    [sym_identifier] = ACTIONS(2893),
    [aux_sym_preproc_include_token1] = ACTIONS(2893),
    [aux_sym_preproc_def_token1] = ACTIONS(2893),
    [aux_sym_preproc_if_token1] = ACTIONS(2893),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2893),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2893),
    [sym_preproc_directive] = ACTIONS(2893),
    [anon_sym_LPAREN2] = ACTIONS(2895),
    [anon_sym_BANG] = ACTIONS(2895),
    [anon_sym_TILDE] = ACTIONS(2895),
    [anon_sym_DASH] = ACTIONS(2893),
    [anon_sym_PLUS] = ACTIONS(2893),
    [anon_sym_STAR] = ACTIONS(2895),
    [anon_sym_AMP_AMP] = ACTIONS(2895),
    [anon_sym_AMP] = ACTIONS(2893),
    [anon_sym___extension__] = ACTIONS(2893),
    [anon_sym_typedef] = ACTIONS(2893),
    [anon_sym_extern] = ACTIONS(2893),
    [anon_sym___attribute__] = ACTIONS(2893),
    [anon_sym_COLON_COLON] = ACTIONS(2895),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2895),
    [anon_sym___declspec] = ACTIONS(2893),
    [anon_sym___based] = ACTIONS(2893),
    [anon_sym___cdecl] = ACTIONS(2893),
    [anon_sym___clrcall] = ACTIONS(2893),
    [anon_sym___stdcall] = ACTIONS(2893),
    [anon_sym___fastcall] = ACTIONS(2893),
    [anon_sym___thiscall] = ACTIONS(2893),
    [anon_sym___vectorcall] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(2895),
    [anon_sym_signed] = ACTIONS(2893),
    [anon_sym_unsigned] = ACTIONS(2893),
    [anon_sym_long] = ACTIONS(2893),
    [anon_sym_short] = ACTIONS(2893),
    [anon_sym_LBRACK] = ACTIONS(2893),
    [anon_sym_static] = ACTIONS(2893),
    [anon_sym_register] = ACTIONS(2893),
    [anon_sym_inline] = ACTIONS(2893),
    [anon_sym___inline] = ACTIONS(2893),
    [anon_sym___inline__] = ACTIONS(2893),
    [anon_sym___forceinline] = ACTIONS(2893),
    [anon_sym_thread_local] = ACTIONS(2893),
    [anon_sym___thread] = ACTIONS(2893),
    [anon_sym_const] = ACTIONS(2893),
    [anon_sym_constexpr] = ACTIONS(2893),
    [anon_sym_volatile] = ACTIONS(2893),
    [anon_sym_restrict] = ACTIONS(2893),
    [anon_sym___restrict__] = ACTIONS(2893),
    [anon_sym__Atomic] = ACTIONS(2893),
    [anon_sym__Noreturn] = ACTIONS(2893),
    [anon_sym_noreturn] = ACTIONS(2893),
    [anon_sym_mutable] = ACTIONS(2893),
    [anon_sym_constinit] = ACTIONS(2893),
    [anon_sym_consteval] = ACTIONS(2893),
    [anon_sym_PROGMEM] = ACTIONS(2893),
    [aux_sym_primitive_type_token1] = ACTIONS(2893),
    [anon_sym_byte] = ACTIONS(2893),
    [anon_sym_word] = ACTIONS(2893),
    [anon_sym_enum] = ACTIONS(2893),
    [anon_sym_class] = ACTIONS(2893),
    [anon_sym_struct] = ACTIONS(2893),
    [anon_sym_union] = ACTIONS(2893),
    [anon_sym_if] = ACTIONS(2893),
    [anon_sym_switch] = ACTIONS(2893),
    [anon_sym_case] = ACTIONS(2893),
    [anon_sym_default] = ACTIONS(2893),
    [anon_sym_while] = ACTIONS(2893),
    [anon_sym_do] = ACTIONS(2893),
    [anon_sym_for] = ACTIONS(2893),
    [anon_sym_return] = ACTIONS(2893),
    [anon_sym_break] = ACTIONS(2893),
    [anon_sym_continue] = ACTIONS(2893),
    [anon_sym_goto] = ACTIONS(2893),
    [anon_sym_not] = ACTIONS(2893),
    [anon_sym_compl] = ACTIONS(2893),
    [anon_sym_DASH_DASH] = ACTIONS(2895),
    [anon_sym_PLUS_PLUS] = ACTIONS(2895),
    [anon_sym_sizeof] = ACTIONS(2893),
    [anon_sym___alignof__] = ACTIONS(2893),
    [anon_sym___alignof] = ACTIONS(2893),
    [anon_sym__alignof] = ACTIONS(2893),
    [anon_sym_alignof] = ACTIONS(2893),
    [anon_sym__Alignof] = ACTIONS(2893),
    [anon_sym_offsetof] = ACTIONS(2893),
    [anon_sym__Generic] = ACTIONS(2893),
    [anon_sym_asm] = ACTIONS(2893),
    [anon_sym___asm__] = ACTIONS(2893),
    [aux_sym_number_literal_token1] = ACTIONS(2895),
    [aux_sym_number_literal_token2] = ACTIONS(2893),
    [anon_sym_L_SQUOTE] = ACTIONS(2895),
    [anon_sym_u_SQUOTE] = ACTIONS(2895),
    [anon_sym_U_SQUOTE] = ACTIONS(2895),
    [anon_sym_u8_SQUOTE] = ACTIONS(2895),
    [anon_sym_SQUOTE] = ACTIONS(2895),
    [anon_sym_L_DQUOTE] = ACTIONS(2895),
    [anon_sym_u_DQUOTE] = ACTIONS(2895),
    [anon_sym_U_DQUOTE] = ACTIONS(2895),
    [anon_sym_u8_DQUOTE] = ACTIONS(2895),
    [anon_sym_DQUOTE] = ACTIONS(2895),
    [sym_true] = ACTIONS(2893),
    [sym_false] = ACTIONS(2893),
    [anon_sym_NULL] = ACTIONS(2893),
    [anon_sym_nullptr] = ACTIONS(2893),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2893),
    [anon_sym_decltype] = ACTIONS(2893),
    [anon_sym_virtual] = ACTIONS(2893),
    [anon_sym_alignas] = ACTIONS(2893),
    [anon_sym_explicit] = ACTIONS(2893),
    [anon_sym_typename] = ACTIONS(2893),
    [anon_sym_template] = ACTIONS(2893),
    [anon_sym_operator] = ACTIONS(2893),
    [anon_sym_try] = ACTIONS(2893),
    [anon_sym_delete] = ACTIONS(2893),
    [anon_sym_throw] = ACTIONS(2893),
    [anon_sym_namespace] = ACTIONS(2893),
    [anon_sym_using] = ACTIONS(2893),
    [anon_sym_static_assert] = ACTIONS(2893),
    [anon_sym_concept] = ACTIONS(2893),
    [anon_sym_co_return] = ACTIONS(2893),
    [anon_sym_co_yield] = ACTIONS(2893),
    [anon_sym_R_DQUOTE] = ACTIONS(2895),
    [anon_sym_LR_DQUOTE] = ACTIONS(2895),
    [anon_sym_uR_DQUOTE] = ACTIONS(2895),
    [anon_sym_UR_DQUOTE] = ACTIONS(2895),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2895),
    [anon_sym_co_await] = ACTIONS(2893),
    [anon_sym_new] = ACTIONS(2893),
    [anon_sym_requires] = ACTIONS(2893),
    [sym_this] = ACTIONS(2893),
  },
  [880] = {
    [ts_builtin_sym_end] = ACTIONS(3054),
    [sym_identifier] = ACTIONS(3052),
    [aux_sym_preproc_include_token1] = ACTIONS(3052),
    [aux_sym_preproc_def_token1] = ACTIONS(3052),
    [aux_sym_preproc_if_token1] = ACTIONS(3052),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3052),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3052),
    [sym_preproc_directive] = ACTIONS(3052),
    [anon_sym_LPAREN2] = ACTIONS(3054),
    [anon_sym_BANG] = ACTIONS(3054),
    [anon_sym_TILDE] = ACTIONS(3054),
    [anon_sym_DASH] = ACTIONS(3052),
    [anon_sym_PLUS] = ACTIONS(3052),
    [anon_sym_STAR] = ACTIONS(3054),
    [anon_sym_AMP_AMP] = ACTIONS(3054),
    [anon_sym_AMP] = ACTIONS(3052),
    [anon_sym___extension__] = ACTIONS(3052),
    [anon_sym_typedef] = ACTIONS(3052),
    [anon_sym_extern] = ACTIONS(3052),
    [anon_sym___attribute__] = ACTIONS(3052),
    [anon_sym_COLON_COLON] = ACTIONS(3054),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3054),
    [anon_sym___declspec] = ACTIONS(3052),
    [anon_sym___based] = ACTIONS(3052),
    [anon_sym___cdecl] = ACTIONS(3052),
    [anon_sym___clrcall] = ACTIONS(3052),
    [anon_sym___stdcall] = ACTIONS(3052),
    [anon_sym___fastcall] = ACTIONS(3052),
    [anon_sym___thiscall] = ACTIONS(3052),
    [anon_sym___vectorcall] = ACTIONS(3052),
    [anon_sym_LBRACE] = ACTIONS(3054),
    [anon_sym_signed] = ACTIONS(3052),
    [anon_sym_unsigned] = ACTIONS(3052),
    [anon_sym_long] = ACTIONS(3052),
    [anon_sym_short] = ACTIONS(3052),
    [anon_sym_LBRACK] = ACTIONS(3052),
    [anon_sym_static] = ACTIONS(3052),
    [anon_sym_register] = ACTIONS(3052),
    [anon_sym_inline] = ACTIONS(3052),
    [anon_sym___inline] = ACTIONS(3052),
    [anon_sym___inline__] = ACTIONS(3052),
    [anon_sym___forceinline] = ACTIONS(3052),
    [anon_sym_thread_local] = ACTIONS(3052),
    [anon_sym___thread] = ACTIONS(3052),
    [anon_sym_const] = ACTIONS(3052),
    [anon_sym_constexpr] = ACTIONS(3052),
    [anon_sym_volatile] = ACTIONS(3052),
    [anon_sym_restrict] = ACTIONS(3052),
    [anon_sym___restrict__] = ACTIONS(3052),
    [anon_sym__Atomic] = ACTIONS(3052),
    [anon_sym__Noreturn] = ACTIONS(3052),
    [anon_sym_noreturn] = ACTIONS(3052),
    [anon_sym_mutable] = ACTIONS(3052),
    [anon_sym_constinit] = ACTIONS(3052),
    [anon_sym_consteval] = ACTIONS(3052),
    [anon_sym_PROGMEM] = ACTIONS(3052),
    [aux_sym_primitive_type_token1] = ACTIONS(3052),
    [anon_sym_byte] = ACTIONS(3052),
    [anon_sym_word] = ACTIONS(3052),
    [anon_sym_enum] = ACTIONS(3052),
    [anon_sym_class] = ACTIONS(3052),
    [anon_sym_struct] = ACTIONS(3052),
    [anon_sym_union] = ACTIONS(3052),
    [anon_sym_if] = ACTIONS(3052),
    [anon_sym_switch] = ACTIONS(3052),
    [anon_sym_case] = ACTIONS(3052),
    [anon_sym_default] = ACTIONS(3052),
    [anon_sym_while] = ACTIONS(3052),
    [anon_sym_do] = ACTIONS(3052),
    [anon_sym_for] = ACTIONS(3052),
    [anon_sym_return] = ACTIONS(3052),
    [anon_sym_break] = ACTIONS(3052),
    [anon_sym_continue] = ACTIONS(3052),
    [anon_sym_goto] = ACTIONS(3052),
    [anon_sym_not] = ACTIONS(3052),
    [anon_sym_compl] = ACTIONS(3052),
    [anon_sym_DASH_DASH] = ACTIONS(3054),
    [anon_sym_PLUS_PLUS] = ACTIONS(3054),
    [anon_sym_sizeof] = ACTIONS(3052),
    [anon_sym___alignof__] = ACTIONS(3052),
    [anon_sym___alignof] = ACTIONS(3052),
    [anon_sym__alignof] = ACTIONS(3052),
    [anon_sym_alignof] = ACTIONS(3052),
    [anon_sym__Alignof] = ACTIONS(3052),
    [anon_sym_offsetof] = ACTIONS(3052),
    [anon_sym__Generic] = ACTIONS(3052),
    [anon_sym_asm] = ACTIONS(3052),
    [anon_sym___asm__] = ACTIONS(3052),
    [aux_sym_number_literal_token1] = ACTIONS(3054),
    [aux_sym_number_literal_token2] = ACTIONS(3052),
    [anon_sym_L_SQUOTE] = ACTIONS(3054),
    [anon_sym_u_SQUOTE] = ACTIONS(3054),
    [anon_sym_U_SQUOTE] = ACTIONS(3054),
    [anon_sym_u8_SQUOTE] = ACTIONS(3054),
    [anon_sym_SQUOTE] = ACTIONS(3054),
    [anon_sym_L_DQUOTE] = ACTIONS(3054),
    [anon_sym_u_DQUOTE] = ACTIONS(3054),
    [anon_sym_U_DQUOTE] = ACTIONS(3054),
    [anon_sym_u8_DQUOTE] = ACTIONS(3054),
    [anon_sym_DQUOTE] = ACTIONS(3054),
    [sym_true] = ACTIONS(3052),
    [sym_false] = ACTIONS(3052),
    [anon_sym_NULL] = ACTIONS(3052),
    [anon_sym_nullptr] = ACTIONS(3052),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3052),
    [anon_sym_decltype] = ACTIONS(3052),
    [anon_sym_virtual] = ACTIONS(3052),
    [anon_sym_alignas] = ACTIONS(3052),
    [anon_sym_explicit] = ACTIONS(3052),
    [anon_sym_typename] = ACTIONS(3052),
    [anon_sym_template] = ACTIONS(3052),
    [anon_sym_operator] = ACTIONS(3052),
    [anon_sym_try] = ACTIONS(3052),
    [anon_sym_delete] = ACTIONS(3052),
    [anon_sym_throw] = ACTIONS(3052),
    [anon_sym_namespace] = ACTIONS(3052),
    [anon_sym_using] = ACTIONS(3052),
    [anon_sym_static_assert] = ACTIONS(3052),
    [anon_sym_concept] = ACTIONS(3052),
    [anon_sym_co_return] = ACTIONS(3052),
    [anon_sym_co_yield] = ACTIONS(3052),
    [anon_sym_R_DQUOTE] = ACTIONS(3054),
    [anon_sym_LR_DQUOTE] = ACTIONS(3054),
    [anon_sym_uR_DQUOTE] = ACTIONS(3054),
    [anon_sym_UR_DQUOTE] = ACTIONS(3054),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3054),
    [anon_sym_co_await] = ACTIONS(3052),
    [anon_sym_new] = ACTIONS(3052),
    [anon_sym_requires] = ACTIONS(3052),
    [sym_this] = ACTIONS(3052),
  },
  [881] = {
    [ts_builtin_sym_end] = ACTIONS(3162),
    [sym_identifier] = ACTIONS(3160),
    [aux_sym_preproc_include_token1] = ACTIONS(3160),
    [aux_sym_preproc_def_token1] = ACTIONS(3160),
    [aux_sym_preproc_if_token1] = ACTIONS(3160),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3160),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3160),
    [sym_preproc_directive] = ACTIONS(3160),
    [anon_sym_LPAREN2] = ACTIONS(3162),
    [anon_sym_BANG] = ACTIONS(3162),
    [anon_sym_TILDE] = ACTIONS(3162),
    [anon_sym_DASH] = ACTIONS(3160),
    [anon_sym_PLUS] = ACTIONS(3160),
    [anon_sym_STAR] = ACTIONS(3162),
    [anon_sym_AMP_AMP] = ACTIONS(3162),
    [anon_sym_AMP] = ACTIONS(3160),
    [anon_sym___extension__] = ACTIONS(3160),
    [anon_sym_typedef] = ACTIONS(3160),
    [anon_sym_extern] = ACTIONS(3160),
    [anon_sym___attribute__] = ACTIONS(3160),
    [anon_sym_COLON_COLON] = ACTIONS(3162),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3162),
    [anon_sym___declspec] = ACTIONS(3160),
    [anon_sym___based] = ACTIONS(3160),
    [anon_sym___cdecl] = ACTIONS(3160),
    [anon_sym___clrcall] = ACTIONS(3160),
    [anon_sym___stdcall] = ACTIONS(3160),
    [anon_sym___fastcall] = ACTIONS(3160),
    [anon_sym___thiscall] = ACTIONS(3160),
    [anon_sym___vectorcall] = ACTIONS(3160),
    [anon_sym_LBRACE] = ACTIONS(3162),
    [anon_sym_signed] = ACTIONS(3160),
    [anon_sym_unsigned] = ACTIONS(3160),
    [anon_sym_long] = ACTIONS(3160),
    [anon_sym_short] = ACTIONS(3160),
    [anon_sym_LBRACK] = ACTIONS(3160),
    [anon_sym_static] = ACTIONS(3160),
    [anon_sym_register] = ACTIONS(3160),
    [anon_sym_inline] = ACTIONS(3160),
    [anon_sym___inline] = ACTIONS(3160),
    [anon_sym___inline__] = ACTIONS(3160),
    [anon_sym___forceinline] = ACTIONS(3160),
    [anon_sym_thread_local] = ACTIONS(3160),
    [anon_sym___thread] = ACTIONS(3160),
    [anon_sym_const] = ACTIONS(3160),
    [anon_sym_constexpr] = ACTIONS(3160),
    [anon_sym_volatile] = ACTIONS(3160),
    [anon_sym_restrict] = ACTIONS(3160),
    [anon_sym___restrict__] = ACTIONS(3160),
    [anon_sym__Atomic] = ACTIONS(3160),
    [anon_sym__Noreturn] = ACTIONS(3160),
    [anon_sym_noreturn] = ACTIONS(3160),
    [anon_sym_mutable] = ACTIONS(3160),
    [anon_sym_constinit] = ACTIONS(3160),
    [anon_sym_consteval] = ACTIONS(3160),
    [anon_sym_PROGMEM] = ACTIONS(3160),
    [aux_sym_primitive_type_token1] = ACTIONS(3160),
    [anon_sym_byte] = ACTIONS(3160),
    [anon_sym_word] = ACTIONS(3160),
    [anon_sym_enum] = ACTIONS(3160),
    [anon_sym_class] = ACTIONS(3160),
    [anon_sym_struct] = ACTIONS(3160),
    [anon_sym_union] = ACTIONS(3160),
    [anon_sym_if] = ACTIONS(3160),
    [anon_sym_switch] = ACTIONS(3160),
    [anon_sym_case] = ACTIONS(3160),
    [anon_sym_default] = ACTIONS(3160),
    [anon_sym_while] = ACTIONS(3160),
    [anon_sym_do] = ACTIONS(3160),
    [anon_sym_for] = ACTIONS(3160),
    [anon_sym_return] = ACTIONS(3160),
    [anon_sym_break] = ACTIONS(3160),
    [anon_sym_continue] = ACTIONS(3160),
    [anon_sym_goto] = ACTIONS(3160),
    [anon_sym_not] = ACTIONS(3160),
    [anon_sym_compl] = ACTIONS(3160),
    [anon_sym_DASH_DASH] = ACTIONS(3162),
    [anon_sym_PLUS_PLUS] = ACTIONS(3162),
    [anon_sym_sizeof] = ACTIONS(3160),
    [anon_sym___alignof__] = ACTIONS(3160),
    [anon_sym___alignof] = ACTIONS(3160),
    [anon_sym__alignof] = ACTIONS(3160),
    [anon_sym_alignof] = ACTIONS(3160),
    [anon_sym__Alignof] = ACTIONS(3160),
    [anon_sym_offsetof] = ACTIONS(3160),
    [anon_sym__Generic] = ACTIONS(3160),
    [anon_sym_asm] = ACTIONS(3160),
    [anon_sym___asm__] = ACTIONS(3160),
    [aux_sym_number_literal_token1] = ACTIONS(3162),
    [aux_sym_number_literal_token2] = ACTIONS(3160),
    [anon_sym_L_SQUOTE] = ACTIONS(3162),
    [anon_sym_u_SQUOTE] = ACTIONS(3162),
    [anon_sym_U_SQUOTE] = ACTIONS(3162),
    [anon_sym_u8_SQUOTE] = ACTIONS(3162),
    [anon_sym_SQUOTE] = ACTIONS(3162),
    [anon_sym_L_DQUOTE] = ACTIONS(3162),
    [anon_sym_u_DQUOTE] = ACTIONS(3162),
    [anon_sym_U_DQUOTE] = ACTIONS(3162),
    [anon_sym_u8_DQUOTE] = ACTIONS(3162),
    [anon_sym_DQUOTE] = ACTIONS(3162),
    [sym_true] = ACTIONS(3160),
    [sym_false] = ACTIONS(3160),
    [anon_sym_NULL] = ACTIONS(3160),
    [anon_sym_nullptr] = ACTIONS(3160),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3160),
    [anon_sym_decltype] = ACTIONS(3160),
    [anon_sym_virtual] = ACTIONS(3160),
    [anon_sym_alignas] = ACTIONS(3160),
    [anon_sym_explicit] = ACTIONS(3160),
    [anon_sym_typename] = ACTIONS(3160),
    [anon_sym_template] = ACTIONS(3160),
    [anon_sym_operator] = ACTIONS(3160),
    [anon_sym_try] = ACTIONS(3160),
    [anon_sym_delete] = ACTIONS(3160),
    [anon_sym_throw] = ACTIONS(3160),
    [anon_sym_namespace] = ACTIONS(3160),
    [anon_sym_using] = ACTIONS(3160),
    [anon_sym_static_assert] = ACTIONS(3160),
    [anon_sym_concept] = ACTIONS(3160),
    [anon_sym_co_return] = ACTIONS(3160),
    [anon_sym_co_yield] = ACTIONS(3160),
    [anon_sym_R_DQUOTE] = ACTIONS(3162),
    [anon_sym_LR_DQUOTE] = ACTIONS(3162),
    [anon_sym_uR_DQUOTE] = ACTIONS(3162),
    [anon_sym_UR_DQUOTE] = ACTIONS(3162),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3162),
    [anon_sym_co_await] = ACTIONS(3160),
    [anon_sym_new] = ACTIONS(3160),
    [anon_sym_requires] = ACTIONS(3160),
    [sym_this] = ACTIONS(3160),
  },
  [882] = {
    [ts_builtin_sym_end] = ACTIONS(2907),
    [sym_identifier] = ACTIONS(2905),
    [aux_sym_preproc_include_token1] = ACTIONS(2905),
    [aux_sym_preproc_def_token1] = ACTIONS(2905),
    [aux_sym_preproc_if_token1] = ACTIONS(2905),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2905),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2905),
    [sym_preproc_directive] = ACTIONS(2905),
    [anon_sym_LPAREN2] = ACTIONS(2907),
    [anon_sym_BANG] = ACTIONS(2907),
    [anon_sym_TILDE] = ACTIONS(2907),
    [anon_sym_DASH] = ACTIONS(2905),
    [anon_sym_PLUS] = ACTIONS(2905),
    [anon_sym_STAR] = ACTIONS(2907),
    [anon_sym_AMP_AMP] = ACTIONS(2907),
    [anon_sym_AMP] = ACTIONS(2905),
    [anon_sym___extension__] = ACTIONS(2905),
    [anon_sym_typedef] = ACTIONS(2905),
    [anon_sym_extern] = ACTIONS(2905),
    [anon_sym___attribute__] = ACTIONS(2905),
    [anon_sym_COLON_COLON] = ACTIONS(2907),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2907),
    [anon_sym___declspec] = ACTIONS(2905),
    [anon_sym___based] = ACTIONS(2905),
    [anon_sym___cdecl] = ACTIONS(2905),
    [anon_sym___clrcall] = ACTIONS(2905),
    [anon_sym___stdcall] = ACTIONS(2905),
    [anon_sym___fastcall] = ACTIONS(2905),
    [anon_sym___thiscall] = ACTIONS(2905),
    [anon_sym___vectorcall] = ACTIONS(2905),
    [anon_sym_LBRACE] = ACTIONS(2907),
    [anon_sym_signed] = ACTIONS(2905),
    [anon_sym_unsigned] = ACTIONS(2905),
    [anon_sym_long] = ACTIONS(2905),
    [anon_sym_short] = ACTIONS(2905),
    [anon_sym_LBRACK] = ACTIONS(2905),
    [anon_sym_static] = ACTIONS(2905),
    [anon_sym_register] = ACTIONS(2905),
    [anon_sym_inline] = ACTIONS(2905),
    [anon_sym___inline] = ACTIONS(2905),
    [anon_sym___inline__] = ACTIONS(2905),
    [anon_sym___forceinline] = ACTIONS(2905),
    [anon_sym_thread_local] = ACTIONS(2905),
    [anon_sym___thread] = ACTIONS(2905),
    [anon_sym_const] = ACTIONS(2905),
    [anon_sym_constexpr] = ACTIONS(2905),
    [anon_sym_volatile] = ACTIONS(2905),
    [anon_sym_restrict] = ACTIONS(2905),
    [anon_sym___restrict__] = ACTIONS(2905),
    [anon_sym__Atomic] = ACTIONS(2905),
    [anon_sym__Noreturn] = ACTIONS(2905),
    [anon_sym_noreturn] = ACTIONS(2905),
    [anon_sym_mutable] = ACTIONS(2905),
    [anon_sym_constinit] = ACTIONS(2905),
    [anon_sym_consteval] = ACTIONS(2905),
    [anon_sym_PROGMEM] = ACTIONS(2905),
    [aux_sym_primitive_type_token1] = ACTIONS(2905),
    [anon_sym_byte] = ACTIONS(2905),
    [anon_sym_word] = ACTIONS(2905),
    [anon_sym_enum] = ACTIONS(2905),
    [anon_sym_class] = ACTIONS(2905),
    [anon_sym_struct] = ACTIONS(2905),
    [anon_sym_union] = ACTIONS(2905),
    [anon_sym_if] = ACTIONS(2905),
    [anon_sym_switch] = ACTIONS(2905),
    [anon_sym_case] = ACTIONS(2905),
    [anon_sym_default] = ACTIONS(2905),
    [anon_sym_while] = ACTIONS(2905),
    [anon_sym_do] = ACTIONS(2905),
    [anon_sym_for] = ACTIONS(2905),
    [anon_sym_return] = ACTIONS(2905),
    [anon_sym_break] = ACTIONS(2905),
    [anon_sym_continue] = ACTIONS(2905),
    [anon_sym_goto] = ACTIONS(2905),
    [anon_sym_not] = ACTIONS(2905),
    [anon_sym_compl] = ACTIONS(2905),
    [anon_sym_DASH_DASH] = ACTIONS(2907),
    [anon_sym_PLUS_PLUS] = ACTIONS(2907),
    [anon_sym_sizeof] = ACTIONS(2905),
    [anon_sym___alignof__] = ACTIONS(2905),
    [anon_sym___alignof] = ACTIONS(2905),
    [anon_sym__alignof] = ACTIONS(2905),
    [anon_sym_alignof] = ACTIONS(2905),
    [anon_sym__Alignof] = ACTIONS(2905),
    [anon_sym_offsetof] = ACTIONS(2905),
    [anon_sym__Generic] = ACTIONS(2905),
    [anon_sym_asm] = ACTIONS(2905),
    [anon_sym___asm__] = ACTIONS(2905),
    [aux_sym_number_literal_token1] = ACTIONS(2907),
    [aux_sym_number_literal_token2] = ACTIONS(2905),
    [anon_sym_L_SQUOTE] = ACTIONS(2907),
    [anon_sym_u_SQUOTE] = ACTIONS(2907),
    [anon_sym_U_SQUOTE] = ACTIONS(2907),
    [anon_sym_u8_SQUOTE] = ACTIONS(2907),
    [anon_sym_SQUOTE] = ACTIONS(2907),
    [anon_sym_L_DQUOTE] = ACTIONS(2907),
    [anon_sym_u_DQUOTE] = ACTIONS(2907),
    [anon_sym_U_DQUOTE] = ACTIONS(2907),
    [anon_sym_u8_DQUOTE] = ACTIONS(2907),
    [anon_sym_DQUOTE] = ACTIONS(2907),
    [sym_true] = ACTIONS(2905),
    [sym_false] = ACTIONS(2905),
    [anon_sym_NULL] = ACTIONS(2905),
    [anon_sym_nullptr] = ACTIONS(2905),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2905),
    [anon_sym_decltype] = ACTIONS(2905),
    [anon_sym_virtual] = ACTIONS(2905),
    [anon_sym_alignas] = ACTIONS(2905),
    [anon_sym_explicit] = ACTIONS(2905),
    [anon_sym_typename] = ACTIONS(2905),
    [anon_sym_template] = ACTIONS(2905),
    [anon_sym_operator] = ACTIONS(2905),
    [anon_sym_try] = ACTIONS(2905),
    [anon_sym_delete] = ACTIONS(2905),
    [anon_sym_throw] = ACTIONS(2905),
    [anon_sym_namespace] = ACTIONS(2905),
    [anon_sym_using] = ACTIONS(2905),
    [anon_sym_static_assert] = ACTIONS(2905),
    [anon_sym_concept] = ACTIONS(2905),
    [anon_sym_co_return] = ACTIONS(2905),
    [anon_sym_co_yield] = ACTIONS(2905),
    [anon_sym_R_DQUOTE] = ACTIONS(2907),
    [anon_sym_LR_DQUOTE] = ACTIONS(2907),
    [anon_sym_uR_DQUOTE] = ACTIONS(2907),
    [anon_sym_UR_DQUOTE] = ACTIONS(2907),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2907),
    [anon_sym_co_await] = ACTIONS(2905),
    [anon_sym_new] = ACTIONS(2905),
    [anon_sym_requires] = ACTIONS(2905),
    [sym_this] = ACTIONS(2905),
  },
  [883] = {
    [sym_preproc_def] = STATE(883),
    [sym_preproc_function_def] = STATE(883),
    [sym_preproc_call] = STATE(883),
    [sym_preproc_if_in_field_declaration_list] = STATE(883),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(883),
    [sym_type_definition] = STATE(883),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(5536),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(3150),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6010),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym__field_declaration_list_item] = STATE(883),
    [sym_field_declaration] = STATE(883),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1811),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(883),
    [sym_operator_cast] = STATE(6536),
    [sym_inline_method_definition] = STATE(883),
    [sym__constructor_specifiers] = STATE(1811),
    [sym_operator_cast_definition] = STATE(883),
    [sym_operator_cast_declaration] = STATE(883),
    [sym_constructor_or_destructor_definition] = STATE(883),
    [sym_constructor_or_destructor_declaration] = STATE(883),
    [sym_friend_declaration] = STATE(883),
    [sym_access_specifier] = STATE(7802),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(2618),
    [sym_template_function] = STATE(6098),
    [sym_using_declaration] = STATE(883),
    [sym_alias_declaration] = STATE(883),
    [sym_static_assert_declaration] = STATE(883),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5301),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_qualified_operator_cast_identifier] = STATE(6536),
    [sym_operator_name] = STATE(6098),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(883),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1961),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1811),
    [sym_identifier] = ACTIONS(3216),
    [aux_sym_preproc_def_token1] = ACTIONS(3494),
    [aux_sym_preproc_if_token1] = ACTIONS(3497),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3500),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3500),
    [sym_preproc_directive] = ACTIONS(3503),
    [anon_sym_LPAREN2] = ACTIONS(3233),
    [anon_sym_TILDE] = ACTIONS(3236),
    [anon_sym_STAR] = ACTIONS(3239),
    [anon_sym_AMP_AMP] = ACTIONS(3242),
    [anon_sym_AMP] = ACTIONS(3245),
    [anon_sym___extension__] = ACTIONS(3506),
    [anon_sym_typedef] = ACTIONS(3509),
    [anon_sym_extern] = ACTIONS(3254),
    [anon_sym___attribute__] = ACTIONS(3257),
    [anon_sym_COLON_COLON] = ACTIONS(3260),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3263),
    [anon_sym___declspec] = ACTIONS(3266),
    [anon_sym___based] = ACTIONS(3269),
    [anon_sym_RBRACE] = ACTIONS(3512),
    [anon_sym_signed] = ACTIONS(3272),
    [anon_sym_unsigned] = ACTIONS(3272),
    [anon_sym_long] = ACTIONS(3272),
    [anon_sym_short] = ACTIONS(3272),
    [anon_sym_LBRACK] = ACTIONS(3275),
    [anon_sym_static] = ACTIONS(3254),
    [anon_sym_register] = ACTIONS(3254),
    [anon_sym_inline] = ACTIONS(3254),
    [anon_sym___inline] = ACTIONS(3254),
    [anon_sym___inline__] = ACTIONS(3254),
    [anon_sym___forceinline] = ACTIONS(3254),
    [anon_sym_thread_local] = ACTIONS(3254),
    [anon_sym___thread] = ACTIONS(3254),
    [anon_sym_const] = ACTIONS(3278),
    [anon_sym_constexpr] = ACTIONS(3278),
    [anon_sym_volatile] = ACTIONS(3278),
    [anon_sym_restrict] = ACTIONS(3278),
    [anon_sym___restrict__] = ACTIONS(3278),
    [anon_sym__Atomic] = ACTIONS(3278),
    [anon_sym__Noreturn] = ACTIONS(3278),
    [anon_sym_noreturn] = ACTIONS(3278),
    [anon_sym_mutable] = ACTIONS(3278),
    [anon_sym_constinit] = ACTIONS(3278),
    [anon_sym_consteval] = ACTIONS(3278),
    [anon_sym_PROGMEM] = ACTIONS(3278),
    [aux_sym_primitive_type_token1] = ACTIONS(3281),
    [anon_sym_byte] = ACTIONS(3281),
    [anon_sym_word] = ACTIONS(3281),
    [anon_sym_enum] = ACTIONS(3284),
    [anon_sym_class] = ACTIONS(3287),
    [anon_sym_struct] = ACTIONS(3290),
    [anon_sym_union] = ACTIONS(3293),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3296),
    [anon_sym_decltype] = ACTIONS(3299),
    [anon_sym_virtual] = ACTIONS(3302),
    [anon_sym_alignas] = ACTIONS(3305),
    [anon_sym_explicit] = ACTIONS(3308),
    [anon_sym_typename] = ACTIONS(3311),
    [anon_sym_template] = ACTIONS(3514),
    [anon_sym_operator] = ACTIONS(3317),
    [anon_sym_friend] = ACTIONS(3517),
    [anon_sym_public] = ACTIONS(3323),
    [anon_sym_private] = ACTIONS(3323),
    [anon_sym_protected] = ACTIONS(3323),
    [anon_sym_using] = ACTIONS(3520),
    [anon_sym_static_assert] = ACTIONS(3523),
  },
  [884] = {
    [ts_builtin_sym_end] = ACTIONS(3166),
    [sym_identifier] = ACTIONS(3164),
    [aux_sym_preproc_include_token1] = ACTIONS(3164),
    [aux_sym_preproc_def_token1] = ACTIONS(3164),
    [aux_sym_preproc_if_token1] = ACTIONS(3164),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3164),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3164),
    [sym_preproc_directive] = ACTIONS(3164),
    [anon_sym_LPAREN2] = ACTIONS(3166),
    [anon_sym_BANG] = ACTIONS(3166),
    [anon_sym_TILDE] = ACTIONS(3166),
    [anon_sym_DASH] = ACTIONS(3164),
    [anon_sym_PLUS] = ACTIONS(3164),
    [anon_sym_STAR] = ACTIONS(3166),
    [anon_sym_AMP_AMP] = ACTIONS(3166),
    [anon_sym_AMP] = ACTIONS(3164),
    [anon_sym___extension__] = ACTIONS(3164),
    [anon_sym_typedef] = ACTIONS(3164),
    [anon_sym_extern] = ACTIONS(3164),
    [anon_sym___attribute__] = ACTIONS(3164),
    [anon_sym_COLON_COLON] = ACTIONS(3166),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3166),
    [anon_sym___declspec] = ACTIONS(3164),
    [anon_sym___based] = ACTIONS(3164),
    [anon_sym___cdecl] = ACTIONS(3164),
    [anon_sym___clrcall] = ACTIONS(3164),
    [anon_sym___stdcall] = ACTIONS(3164),
    [anon_sym___fastcall] = ACTIONS(3164),
    [anon_sym___thiscall] = ACTIONS(3164),
    [anon_sym___vectorcall] = ACTIONS(3164),
    [anon_sym_LBRACE] = ACTIONS(3166),
    [anon_sym_signed] = ACTIONS(3164),
    [anon_sym_unsigned] = ACTIONS(3164),
    [anon_sym_long] = ACTIONS(3164),
    [anon_sym_short] = ACTIONS(3164),
    [anon_sym_LBRACK] = ACTIONS(3164),
    [anon_sym_static] = ACTIONS(3164),
    [anon_sym_register] = ACTIONS(3164),
    [anon_sym_inline] = ACTIONS(3164),
    [anon_sym___inline] = ACTIONS(3164),
    [anon_sym___inline__] = ACTIONS(3164),
    [anon_sym___forceinline] = ACTIONS(3164),
    [anon_sym_thread_local] = ACTIONS(3164),
    [anon_sym___thread] = ACTIONS(3164),
    [anon_sym_const] = ACTIONS(3164),
    [anon_sym_constexpr] = ACTIONS(3164),
    [anon_sym_volatile] = ACTIONS(3164),
    [anon_sym_restrict] = ACTIONS(3164),
    [anon_sym___restrict__] = ACTIONS(3164),
    [anon_sym__Atomic] = ACTIONS(3164),
    [anon_sym__Noreturn] = ACTIONS(3164),
    [anon_sym_noreturn] = ACTIONS(3164),
    [anon_sym_mutable] = ACTIONS(3164),
    [anon_sym_constinit] = ACTIONS(3164),
    [anon_sym_consteval] = ACTIONS(3164),
    [anon_sym_PROGMEM] = ACTIONS(3164),
    [aux_sym_primitive_type_token1] = ACTIONS(3164),
    [anon_sym_byte] = ACTIONS(3164),
    [anon_sym_word] = ACTIONS(3164),
    [anon_sym_enum] = ACTIONS(3164),
    [anon_sym_class] = ACTIONS(3164),
    [anon_sym_struct] = ACTIONS(3164),
    [anon_sym_union] = ACTIONS(3164),
    [anon_sym_if] = ACTIONS(3164),
    [anon_sym_switch] = ACTIONS(3164),
    [anon_sym_case] = ACTIONS(3164),
    [anon_sym_default] = ACTIONS(3164),
    [anon_sym_while] = ACTIONS(3164),
    [anon_sym_do] = ACTIONS(3164),
    [anon_sym_for] = ACTIONS(3164),
    [anon_sym_return] = ACTIONS(3164),
    [anon_sym_break] = ACTIONS(3164),
    [anon_sym_continue] = ACTIONS(3164),
    [anon_sym_goto] = ACTIONS(3164),
    [anon_sym_not] = ACTIONS(3164),
    [anon_sym_compl] = ACTIONS(3164),
    [anon_sym_DASH_DASH] = ACTIONS(3166),
    [anon_sym_PLUS_PLUS] = ACTIONS(3166),
    [anon_sym_sizeof] = ACTIONS(3164),
    [anon_sym___alignof__] = ACTIONS(3164),
    [anon_sym___alignof] = ACTIONS(3164),
    [anon_sym__alignof] = ACTIONS(3164),
    [anon_sym_alignof] = ACTIONS(3164),
    [anon_sym__Alignof] = ACTIONS(3164),
    [anon_sym_offsetof] = ACTIONS(3164),
    [anon_sym__Generic] = ACTIONS(3164),
    [anon_sym_asm] = ACTIONS(3164),
    [anon_sym___asm__] = ACTIONS(3164),
    [aux_sym_number_literal_token1] = ACTIONS(3166),
    [aux_sym_number_literal_token2] = ACTIONS(3164),
    [anon_sym_L_SQUOTE] = ACTIONS(3166),
    [anon_sym_u_SQUOTE] = ACTIONS(3166),
    [anon_sym_U_SQUOTE] = ACTIONS(3166),
    [anon_sym_u8_SQUOTE] = ACTIONS(3166),
    [anon_sym_SQUOTE] = ACTIONS(3166),
    [anon_sym_L_DQUOTE] = ACTIONS(3166),
    [anon_sym_u_DQUOTE] = ACTIONS(3166),
    [anon_sym_U_DQUOTE] = ACTIONS(3166),
    [anon_sym_u8_DQUOTE] = ACTIONS(3166),
    [anon_sym_DQUOTE] = ACTIONS(3166),
    [sym_true] = ACTIONS(3164),
    [sym_false] = ACTIONS(3164),
    [anon_sym_NULL] = ACTIONS(3164),
    [anon_sym_nullptr] = ACTIONS(3164),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3164),
    [anon_sym_decltype] = ACTIONS(3164),
    [anon_sym_virtual] = ACTIONS(3164),
    [anon_sym_alignas] = ACTIONS(3164),
    [anon_sym_explicit] = ACTIONS(3164),
    [anon_sym_typename] = ACTIONS(3164),
    [anon_sym_template] = ACTIONS(3164),
    [anon_sym_operator] = ACTIONS(3164),
    [anon_sym_try] = ACTIONS(3164),
    [anon_sym_delete] = ACTIONS(3164),
    [anon_sym_throw] = ACTIONS(3164),
    [anon_sym_namespace] = ACTIONS(3164),
    [anon_sym_using] = ACTIONS(3164),
    [anon_sym_static_assert] = ACTIONS(3164),
    [anon_sym_concept] = ACTIONS(3164),
    [anon_sym_co_return] = ACTIONS(3164),
    [anon_sym_co_yield] = ACTIONS(3164),
    [anon_sym_R_DQUOTE] = ACTIONS(3166),
    [anon_sym_LR_DQUOTE] = ACTIONS(3166),
    [anon_sym_uR_DQUOTE] = ACTIONS(3166),
    [anon_sym_UR_DQUOTE] = ACTIONS(3166),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3166),
    [anon_sym_co_await] = ACTIONS(3164),
    [anon_sym_new] = ACTIONS(3164),
    [anon_sym_requires] = ACTIONS(3164),
    [sym_this] = ACTIONS(3164),
  },
  [885] = {
    [ts_builtin_sym_end] = ACTIONS(2903),
    [sym_identifier] = ACTIONS(2901),
    [aux_sym_preproc_include_token1] = ACTIONS(2901),
    [aux_sym_preproc_def_token1] = ACTIONS(2901),
    [aux_sym_preproc_if_token1] = ACTIONS(2901),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2901),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2901),
    [sym_preproc_directive] = ACTIONS(2901),
    [anon_sym_LPAREN2] = ACTIONS(2903),
    [anon_sym_BANG] = ACTIONS(2903),
    [anon_sym_TILDE] = ACTIONS(2903),
    [anon_sym_DASH] = ACTIONS(2901),
    [anon_sym_PLUS] = ACTIONS(2901),
    [anon_sym_STAR] = ACTIONS(2903),
    [anon_sym_AMP_AMP] = ACTIONS(2903),
    [anon_sym_AMP] = ACTIONS(2901),
    [anon_sym___extension__] = ACTIONS(2901),
    [anon_sym_typedef] = ACTIONS(2901),
    [anon_sym_extern] = ACTIONS(2901),
    [anon_sym___attribute__] = ACTIONS(2901),
    [anon_sym_COLON_COLON] = ACTIONS(2903),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2903),
    [anon_sym___declspec] = ACTIONS(2901),
    [anon_sym___based] = ACTIONS(2901),
    [anon_sym___cdecl] = ACTIONS(2901),
    [anon_sym___clrcall] = ACTIONS(2901),
    [anon_sym___stdcall] = ACTIONS(2901),
    [anon_sym___fastcall] = ACTIONS(2901),
    [anon_sym___thiscall] = ACTIONS(2901),
    [anon_sym___vectorcall] = ACTIONS(2901),
    [anon_sym_LBRACE] = ACTIONS(2903),
    [anon_sym_signed] = ACTIONS(2901),
    [anon_sym_unsigned] = ACTIONS(2901),
    [anon_sym_long] = ACTIONS(2901),
    [anon_sym_short] = ACTIONS(2901),
    [anon_sym_LBRACK] = ACTIONS(2901),
    [anon_sym_static] = ACTIONS(2901),
    [anon_sym_register] = ACTIONS(2901),
    [anon_sym_inline] = ACTIONS(2901),
    [anon_sym___inline] = ACTIONS(2901),
    [anon_sym___inline__] = ACTIONS(2901),
    [anon_sym___forceinline] = ACTIONS(2901),
    [anon_sym_thread_local] = ACTIONS(2901),
    [anon_sym___thread] = ACTIONS(2901),
    [anon_sym_const] = ACTIONS(2901),
    [anon_sym_constexpr] = ACTIONS(2901),
    [anon_sym_volatile] = ACTIONS(2901),
    [anon_sym_restrict] = ACTIONS(2901),
    [anon_sym___restrict__] = ACTIONS(2901),
    [anon_sym__Atomic] = ACTIONS(2901),
    [anon_sym__Noreturn] = ACTIONS(2901),
    [anon_sym_noreturn] = ACTIONS(2901),
    [anon_sym_mutable] = ACTIONS(2901),
    [anon_sym_constinit] = ACTIONS(2901),
    [anon_sym_consteval] = ACTIONS(2901),
    [anon_sym_PROGMEM] = ACTIONS(2901),
    [aux_sym_primitive_type_token1] = ACTIONS(2901),
    [anon_sym_byte] = ACTIONS(2901),
    [anon_sym_word] = ACTIONS(2901),
    [anon_sym_enum] = ACTIONS(2901),
    [anon_sym_class] = ACTIONS(2901),
    [anon_sym_struct] = ACTIONS(2901),
    [anon_sym_union] = ACTIONS(2901),
    [anon_sym_if] = ACTIONS(2901),
    [anon_sym_switch] = ACTIONS(2901),
    [anon_sym_case] = ACTIONS(2901),
    [anon_sym_default] = ACTIONS(2901),
    [anon_sym_while] = ACTIONS(2901),
    [anon_sym_do] = ACTIONS(2901),
    [anon_sym_for] = ACTIONS(2901),
    [anon_sym_return] = ACTIONS(2901),
    [anon_sym_break] = ACTIONS(2901),
    [anon_sym_continue] = ACTIONS(2901),
    [anon_sym_goto] = ACTIONS(2901),
    [anon_sym_not] = ACTIONS(2901),
    [anon_sym_compl] = ACTIONS(2901),
    [anon_sym_DASH_DASH] = ACTIONS(2903),
    [anon_sym_PLUS_PLUS] = ACTIONS(2903),
    [anon_sym_sizeof] = ACTIONS(2901),
    [anon_sym___alignof__] = ACTIONS(2901),
    [anon_sym___alignof] = ACTIONS(2901),
    [anon_sym__alignof] = ACTIONS(2901),
    [anon_sym_alignof] = ACTIONS(2901),
    [anon_sym__Alignof] = ACTIONS(2901),
    [anon_sym_offsetof] = ACTIONS(2901),
    [anon_sym__Generic] = ACTIONS(2901),
    [anon_sym_asm] = ACTIONS(2901),
    [anon_sym___asm__] = ACTIONS(2901),
    [aux_sym_number_literal_token1] = ACTIONS(2903),
    [aux_sym_number_literal_token2] = ACTIONS(2901),
    [anon_sym_L_SQUOTE] = ACTIONS(2903),
    [anon_sym_u_SQUOTE] = ACTIONS(2903),
    [anon_sym_U_SQUOTE] = ACTIONS(2903),
    [anon_sym_u8_SQUOTE] = ACTIONS(2903),
    [anon_sym_SQUOTE] = ACTIONS(2903),
    [anon_sym_L_DQUOTE] = ACTIONS(2903),
    [anon_sym_u_DQUOTE] = ACTIONS(2903),
    [anon_sym_U_DQUOTE] = ACTIONS(2903),
    [anon_sym_u8_DQUOTE] = ACTIONS(2903),
    [anon_sym_DQUOTE] = ACTIONS(2903),
    [sym_true] = ACTIONS(2901),
    [sym_false] = ACTIONS(2901),
    [anon_sym_NULL] = ACTIONS(2901),
    [anon_sym_nullptr] = ACTIONS(2901),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2901),
    [anon_sym_decltype] = ACTIONS(2901),
    [anon_sym_virtual] = ACTIONS(2901),
    [anon_sym_alignas] = ACTIONS(2901),
    [anon_sym_explicit] = ACTIONS(2901),
    [anon_sym_typename] = ACTIONS(2901),
    [anon_sym_template] = ACTIONS(2901),
    [anon_sym_operator] = ACTIONS(2901),
    [anon_sym_try] = ACTIONS(2901),
    [anon_sym_delete] = ACTIONS(2901),
    [anon_sym_throw] = ACTIONS(2901),
    [anon_sym_namespace] = ACTIONS(2901),
    [anon_sym_using] = ACTIONS(2901),
    [anon_sym_static_assert] = ACTIONS(2901),
    [anon_sym_concept] = ACTIONS(2901),
    [anon_sym_co_return] = ACTIONS(2901),
    [anon_sym_co_yield] = ACTIONS(2901),
    [anon_sym_R_DQUOTE] = ACTIONS(2903),
    [anon_sym_LR_DQUOTE] = ACTIONS(2903),
    [anon_sym_uR_DQUOTE] = ACTIONS(2903),
    [anon_sym_UR_DQUOTE] = ACTIONS(2903),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2903),
    [anon_sym_co_await] = ACTIONS(2901),
    [anon_sym_new] = ACTIONS(2901),
    [anon_sym_requires] = ACTIONS(2901),
    [sym_this] = ACTIONS(2901),
  },
  [886] = {
    [ts_builtin_sym_end] = ACTIONS(2931),
    [sym_identifier] = ACTIONS(2929),
    [aux_sym_preproc_include_token1] = ACTIONS(2929),
    [aux_sym_preproc_def_token1] = ACTIONS(2929),
    [aux_sym_preproc_if_token1] = ACTIONS(2929),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2929),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2929),
    [sym_preproc_directive] = ACTIONS(2929),
    [anon_sym_LPAREN2] = ACTIONS(2931),
    [anon_sym_BANG] = ACTIONS(2931),
    [anon_sym_TILDE] = ACTIONS(2931),
    [anon_sym_DASH] = ACTIONS(2929),
    [anon_sym_PLUS] = ACTIONS(2929),
    [anon_sym_STAR] = ACTIONS(2931),
    [anon_sym_AMP_AMP] = ACTIONS(2931),
    [anon_sym_AMP] = ACTIONS(2929),
    [anon_sym___extension__] = ACTIONS(2929),
    [anon_sym_typedef] = ACTIONS(2929),
    [anon_sym_extern] = ACTIONS(2929),
    [anon_sym___attribute__] = ACTIONS(2929),
    [anon_sym_COLON_COLON] = ACTIONS(2931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2931),
    [anon_sym___declspec] = ACTIONS(2929),
    [anon_sym___based] = ACTIONS(2929),
    [anon_sym___cdecl] = ACTIONS(2929),
    [anon_sym___clrcall] = ACTIONS(2929),
    [anon_sym___stdcall] = ACTIONS(2929),
    [anon_sym___fastcall] = ACTIONS(2929),
    [anon_sym___thiscall] = ACTIONS(2929),
    [anon_sym___vectorcall] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [anon_sym_signed] = ACTIONS(2929),
    [anon_sym_unsigned] = ACTIONS(2929),
    [anon_sym_long] = ACTIONS(2929),
    [anon_sym_short] = ACTIONS(2929),
    [anon_sym_LBRACK] = ACTIONS(2929),
    [anon_sym_static] = ACTIONS(2929),
    [anon_sym_register] = ACTIONS(2929),
    [anon_sym_inline] = ACTIONS(2929),
    [anon_sym___inline] = ACTIONS(2929),
    [anon_sym___inline__] = ACTIONS(2929),
    [anon_sym___forceinline] = ACTIONS(2929),
    [anon_sym_thread_local] = ACTIONS(2929),
    [anon_sym___thread] = ACTIONS(2929),
    [anon_sym_const] = ACTIONS(2929),
    [anon_sym_constexpr] = ACTIONS(2929),
    [anon_sym_volatile] = ACTIONS(2929),
    [anon_sym_restrict] = ACTIONS(2929),
    [anon_sym___restrict__] = ACTIONS(2929),
    [anon_sym__Atomic] = ACTIONS(2929),
    [anon_sym__Noreturn] = ACTIONS(2929),
    [anon_sym_noreturn] = ACTIONS(2929),
    [anon_sym_mutable] = ACTIONS(2929),
    [anon_sym_constinit] = ACTIONS(2929),
    [anon_sym_consteval] = ACTIONS(2929),
    [anon_sym_PROGMEM] = ACTIONS(2929),
    [aux_sym_primitive_type_token1] = ACTIONS(2929),
    [anon_sym_byte] = ACTIONS(2929),
    [anon_sym_word] = ACTIONS(2929),
    [anon_sym_enum] = ACTIONS(2929),
    [anon_sym_class] = ACTIONS(2929),
    [anon_sym_struct] = ACTIONS(2929),
    [anon_sym_union] = ACTIONS(2929),
    [anon_sym_if] = ACTIONS(2929),
    [anon_sym_switch] = ACTIONS(2929),
    [anon_sym_case] = ACTIONS(2929),
    [anon_sym_default] = ACTIONS(2929),
    [anon_sym_while] = ACTIONS(2929),
    [anon_sym_do] = ACTIONS(2929),
    [anon_sym_for] = ACTIONS(2929),
    [anon_sym_return] = ACTIONS(2929),
    [anon_sym_break] = ACTIONS(2929),
    [anon_sym_continue] = ACTIONS(2929),
    [anon_sym_goto] = ACTIONS(2929),
    [anon_sym_not] = ACTIONS(2929),
    [anon_sym_compl] = ACTIONS(2929),
    [anon_sym_DASH_DASH] = ACTIONS(2931),
    [anon_sym_PLUS_PLUS] = ACTIONS(2931),
    [anon_sym_sizeof] = ACTIONS(2929),
    [anon_sym___alignof__] = ACTIONS(2929),
    [anon_sym___alignof] = ACTIONS(2929),
    [anon_sym__alignof] = ACTIONS(2929),
    [anon_sym_alignof] = ACTIONS(2929),
    [anon_sym__Alignof] = ACTIONS(2929),
    [anon_sym_offsetof] = ACTIONS(2929),
    [anon_sym__Generic] = ACTIONS(2929),
    [anon_sym_asm] = ACTIONS(2929),
    [anon_sym___asm__] = ACTIONS(2929),
    [aux_sym_number_literal_token1] = ACTIONS(2931),
    [aux_sym_number_literal_token2] = ACTIONS(2929),
    [anon_sym_L_SQUOTE] = ACTIONS(2931),
    [anon_sym_u_SQUOTE] = ACTIONS(2931),
    [anon_sym_U_SQUOTE] = ACTIONS(2931),
    [anon_sym_u8_SQUOTE] = ACTIONS(2931),
    [anon_sym_SQUOTE] = ACTIONS(2931),
    [anon_sym_L_DQUOTE] = ACTIONS(2931),
    [anon_sym_u_DQUOTE] = ACTIONS(2931),
    [anon_sym_U_DQUOTE] = ACTIONS(2931),
    [anon_sym_u8_DQUOTE] = ACTIONS(2931),
    [anon_sym_DQUOTE] = ACTIONS(2931),
    [sym_true] = ACTIONS(2929),
    [sym_false] = ACTIONS(2929),
    [anon_sym_NULL] = ACTIONS(2929),
    [anon_sym_nullptr] = ACTIONS(2929),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2929),
    [anon_sym_decltype] = ACTIONS(2929),
    [anon_sym_virtual] = ACTIONS(2929),
    [anon_sym_alignas] = ACTIONS(2929),
    [anon_sym_explicit] = ACTIONS(2929),
    [anon_sym_typename] = ACTIONS(2929),
    [anon_sym_template] = ACTIONS(2929),
    [anon_sym_operator] = ACTIONS(2929),
    [anon_sym_try] = ACTIONS(2929),
    [anon_sym_delete] = ACTIONS(2929),
    [anon_sym_throw] = ACTIONS(2929),
    [anon_sym_namespace] = ACTIONS(2929),
    [anon_sym_using] = ACTIONS(2929),
    [anon_sym_static_assert] = ACTIONS(2929),
    [anon_sym_concept] = ACTIONS(2929),
    [anon_sym_co_return] = ACTIONS(2929),
    [anon_sym_co_yield] = ACTIONS(2929),
    [anon_sym_R_DQUOTE] = ACTIONS(2931),
    [anon_sym_LR_DQUOTE] = ACTIONS(2931),
    [anon_sym_uR_DQUOTE] = ACTIONS(2931),
    [anon_sym_UR_DQUOTE] = ACTIONS(2931),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2931),
    [anon_sym_co_await] = ACTIONS(2929),
    [anon_sym_new] = ACTIONS(2929),
    [anon_sym_requires] = ACTIONS(2929),
    [sym_this] = ACTIONS(2929),
  },
  [887] = {
    [sym_preproc_def] = STATE(883),
    [sym_preproc_function_def] = STATE(883),
    [sym_preproc_call] = STATE(883),
    [sym_preproc_if_in_field_declaration_list] = STATE(883),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(883),
    [sym_type_definition] = STATE(883),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(5536),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(3150),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6010),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym__field_declaration_list_item] = STATE(883),
    [sym_field_declaration] = STATE(883),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1811),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(883),
    [sym_operator_cast] = STATE(6536),
    [sym_inline_method_definition] = STATE(883),
    [sym__constructor_specifiers] = STATE(1811),
    [sym_operator_cast_definition] = STATE(883),
    [sym_operator_cast_declaration] = STATE(883),
    [sym_constructor_or_destructor_definition] = STATE(883),
    [sym_constructor_or_destructor_declaration] = STATE(883),
    [sym_friend_declaration] = STATE(883),
    [sym_access_specifier] = STATE(7802),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(2618),
    [sym_template_function] = STATE(6098),
    [sym_using_declaration] = STATE(883),
    [sym_alias_declaration] = STATE(883),
    [sym_static_assert_declaration] = STATE(883),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5301),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_qualified_operator_cast_identifier] = STATE(6536),
    [sym_operator_name] = STATE(6098),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(883),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1961),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1811),
    [sym_identifier] = ACTIONS(2823),
    [aux_sym_preproc_def_token1] = ACTIONS(3364),
    [aux_sym_preproc_if_token1] = ACTIONS(3366),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3368),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3368),
    [sym_preproc_directive] = ACTIONS(3370),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(3372),
    [anon_sym_typedef] = ACTIONS(3374),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(2853),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_RBRACE] = ACTIONS(3526),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2857),
    [anon_sym_class] = ACTIONS(2859),
    [anon_sym_struct] = ACTIONS(2861),
    [anon_sym_union] = ACTIONS(2863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(2865),
    [anon_sym_template] = ACTIONS(3378),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3380),
    [anon_sym_public] = ACTIONS(2871),
    [anon_sym_private] = ACTIONS(2871),
    [anon_sym_protected] = ACTIONS(2871),
    [anon_sym_using] = ACTIONS(3382),
    [anon_sym_static_assert] = ACTIONS(3384),
  },
  [888] = {
    [ts_builtin_sym_end] = ACTIONS(3138),
    [sym_identifier] = ACTIONS(3136),
    [aux_sym_preproc_include_token1] = ACTIONS(3136),
    [aux_sym_preproc_def_token1] = ACTIONS(3136),
    [aux_sym_preproc_if_token1] = ACTIONS(3136),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3136),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3136),
    [sym_preproc_directive] = ACTIONS(3136),
    [anon_sym_LPAREN2] = ACTIONS(3138),
    [anon_sym_BANG] = ACTIONS(3138),
    [anon_sym_TILDE] = ACTIONS(3138),
    [anon_sym_DASH] = ACTIONS(3136),
    [anon_sym_PLUS] = ACTIONS(3136),
    [anon_sym_STAR] = ACTIONS(3138),
    [anon_sym_AMP_AMP] = ACTIONS(3138),
    [anon_sym_AMP] = ACTIONS(3136),
    [anon_sym___extension__] = ACTIONS(3136),
    [anon_sym_typedef] = ACTIONS(3136),
    [anon_sym_extern] = ACTIONS(3136),
    [anon_sym___attribute__] = ACTIONS(3136),
    [anon_sym_COLON_COLON] = ACTIONS(3138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3138),
    [anon_sym___declspec] = ACTIONS(3136),
    [anon_sym___based] = ACTIONS(3136),
    [anon_sym___cdecl] = ACTIONS(3136),
    [anon_sym___clrcall] = ACTIONS(3136),
    [anon_sym___stdcall] = ACTIONS(3136),
    [anon_sym___fastcall] = ACTIONS(3136),
    [anon_sym___thiscall] = ACTIONS(3136),
    [anon_sym___vectorcall] = ACTIONS(3136),
    [anon_sym_LBRACE] = ACTIONS(3138),
    [anon_sym_signed] = ACTIONS(3136),
    [anon_sym_unsigned] = ACTIONS(3136),
    [anon_sym_long] = ACTIONS(3136),
    [anon_sym_short] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(3136),
    [anon_sym_static] = ACTIONS(3136),
    [anon_sym_register] = ACTIONS(3136),
    [anon_sym_inline] = ACTIONS(3136),
    [anon_sym___inline] = ACTIONS(3136),
    [anon_sym___inline__] = ACTIONS(3136),
    [anon_sym___forceinline] = ACTIONS(3136),
    [anon_sym_thread_local] = ACTIONS(3136),
    [anon_sym___thread] = ACTIONS(3136),
    [anon_sym_const] = ACTIONS(3136),
    [anon_sym_constexpr] = ACTIONS(3136),
    [anon_sym_volatile] = ACTIONS(3136),
    [anon_sym_restrict] = ACTIONS(3136),
    [anon_sym___restrict__] = ACTIONS(3136),
    [anon_sym__Atomic] = ACTIONS(3136),
    [anon_sym__Noreturn] = ACTIONS(3136),
    [anon_sym_noreturn] = ACTIONS(3136),
    [anon_sym_mutable] = ACTIONS(3136),
    [anon_sym_constinit] = ACTIONS(3136),
    [anon_sym_consteval] = ACTIONS(3136),
    [anon_sym_PROGMEM] = ACTIONS(3136),
    [aux_sym_primitive_type_token1] = ACTIONS(3136),
    [anon_sym_byte] = ACTIONS(3136),
    [anon_sym_word] = ACTIONS(3136),
    [anon_sym_enum] = ACTIONS(3136),
    [anon_sym_class] = ACTIONS(3136),
    [anon_sym_struct] = ACTIONS(3136),
    [anon_sym_union] = ACTIONS(3136),
    [anon_sym_if] = ACTIONS(3136),
    [anon_sym_switch] = ACTIONS(3136),
    [anon_sym_case] = ACTIONS(3136),
    [anon_sym_default] = ACTIONS(3136),
    [anon_sym_while] = ACTIONS(3136),
    [anon_sym_do] = ACTIONS(3136),
    [anon_sym_for] = ACTIONS(3136),
    [anon_sym_return] = ACTIONS(3136),
    [anon_sym_break] = ACTIONS(3136),
    [anon_sym_continue] = ACTIONS(3136),
    [anon_sym_goto] = ACTIONS(3136),
    [anon_sym_not] = ACTIONS(3136),
    [anon_sym_compl] = ACTIONS(3136),
    [anon_sym_DASH_DASH] = ACTIONS(3138),
    [anon_sym_PLUS_PLUS] = ACTIONS(3138),
    [anon_sym_sizeof] = ACTIONS(3136),
    [anon_sym___alignof__] = ACTIONS(3136),
    [anon_sym___alignof] = ACTIONS(3136),
    [anon_sym__alignof] = ACTIONS(3136),
    [anon_sym_alignof] = ACTIONS(3136),
    [anon_sym__Alignof] = ACTIONS(3136),
    [anon_sym_offsetof] = ACTIONS(3136),
    [anon_sym__Generic] = ACTIONS(3136),
    [anon_sym_asm] = ACTIONS(3136),
    [anon_sym___asm__] = ACTIONS(3136),
    [aux_sym_number_literal_token1] = ACTIONS(3138),
    [aux_sym_number_literal_token2] = ACTIONS(3136),
    [anon_sym_L_SQUOTE] = ACTIONS(3138),
    [anon_sym_u_SQUOTE] = ACTIONS(3138),
    [anon_sym_U_SQUOTE] = ACTIONS(3138),
    [anon_sym_u8_SQUOTE] = ACTIONS(3138),
    [anon_sym_SQUOTE] = ACTIONS(3138),
    [anon_sym_L_DQUOTE] = ACTIONS(3138),
    [anon_sym_u_DQUOTE] = ACTIONS(3138),
    [anon_sym_U_DQUOTE] = ACTIONS(3138),
    [anon_sym_u8_DQUOTE] = ACTIONS(3138),
    [anon_sym_DQUOTE] = ACTIONS(3138),
    [sym_true] = ACTIONS(3136),
    [sym_false] = ACTIONS(3136),
    [anon_sym_NULL] = ACTIONS(3136),
    [anon_sym_nullptr] = ACTIONS(3136),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3136),
    [anon_sym_decltype] = ACTIONS(3136),
    [anon_sym_virtual] = ACTIONS(3136),
    [anon_sym_alignas] = ACTIONS(3136),
    [anon_sym_explicit] = ACTIONS(3136),
    [anon_sym_typename] = ACTIONS(3136),
    [anon_sym_template] = ACTIONS(3136),
    [anon_sym_operator] = ACTIONS(3136),
    [anon_sym_try] = ACTIONS(3136),
    [anon_sym_delete] = ACTIONS(3136),
    [anon_sym_throw] = ACTIONS(3136),
    [anon_sym_namespace] = ACTIONS(3136),
    [anon_sym_using] = ACTIONS(3136),
    [anon_sym_static_assert] = ACTIONS(3136),
    [anon_sym_concept] = ACTIONS(3136),
    [anon_sym_co_return] = ACTIONS(3136),
    [anon_sym_co_yield] = ACTIONS(3136),
    [anon_sym_R_DQUOTE] = ACTIONS(3138),
    [anon_sym_LR_DQUOTE] = ACTIONS(3138),
    [anon_sym_uR_DQUOTE] = ACTIONS(3138),
    [anon_sym_UR_DQUOTE] = ACTIONS(3138),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3138),
    [anon_sym_co_await] = ACTIONS(3136),
    [anon_sym_new] = ACTIONS(3136),
    [anon_sym_requires] = ACTIONS(3136),
    [sym_this] = ACTIONS(3136),
  },
  [889] = {
    [ts_builtin_sym_end] = ACTIONS(2899),
    [sym_identifier] = ACTIONS(2897),
    [aux_sym_preproc_include_token1] = ACTIONS(2897),
    [aux_sym_preproc_def_token1] = ACTIONS(2897),
    [aux_sym_preproc_if_token1] = ACTIONS(2897),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2897),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2897),
    [sym_preproc_directive] = ACTIONS(2897),
    [anon_sym_LPAREN2] = ACTIONS(2899),
    [anon_sym_BANG] = ACTIONS(2899),
    [anon_sym_TILDE] = ACTIONS(2899),
    [anon_sym_DASH] = ACTIONS(2897),
    [anon_sym_PLUS] = ACTIONS(2897),
    [anon_sym_STAR] = ACTIONS(2899),
    [anon_sym_AMP_AMP] = ACTIONS(2899),
    [anon_sym_AMP] = ACTIONS(2897),
    [anon_sym___extension__] = ACTIONS(2897),
    [anon_sym_typedef] = ACTIONS(2897),
    [anon_sym_extern] = ACTIONS(2897),
    [anon_sym___attribute__] = ACTIONS(2897),
    [anon_sym_COLON_COLON] = ACTIONS(2899),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2899),
    [anon_sym___declspec] = ACTIONS(2897),
    [anon_sym___based] = ACTIONS(2897),
    [anon_sym___cdecl] = ACTIONS(2897),
    [anon_sym___clrcall] = ACTIONS(2897),
    [anon_sym___stdcall] = ACTIONS(2897),
    [anon_sym___fastcall] = ACTIONS(2897),
    [anon_sym___thiscall] = ACTIONS(2897),
    [anon_sym___vectorcall] = ACTIONS(2897),
    [anon_sym_LBRACE] = ACTIONS(2899),
    [anon_sym_signed] = ACTIONS(2897),
    [anon_sym_unsigned] = ACTIONS(2897),
    [anon_sym_long] = ACTIONS(2897),
    [anon_sym_short] = ACTIONS(2897),
    [anon_sym_LBRACK] = ACTIONS(2897),
    [anon_sym_static] = ACTIONS(2897),
    [anon_sym_register] = ACTIONS(2897),
    [anon_sym_inline] = ACTIONS(2897),
    [anon_sym___inline] = ACTIONS(2897),
    [anon_sym___inline__] = ACTIONS(2897),
    [anon_sym___forceinline] = ACTIONS(2897),
    [anon_sym_thread_local] = ACTIONS(2897),
    [anon_sym___thread] = ACTIONS(2897),
    [anon_sym_const] = ACTIONS(2897),
    [anon_sym_constexpr] = ACTIONS(2897),
    [anon_sym_volatile] = ACTIONS(2897),
    [anon_sym_restrict] = ACTIONS(2897),
    [anon_sym___restrict__] = ACTIONS(2897),
    [anon_sym__Atomic] = ACTIONS(2897),
    [anon_sym__Noreturn] = ACTIONS(2897),
    [anon_sym_noreturn] = ACTIONS(2897),
    [anon_sym_mutable] = ACTIONS(2897),
    [anon_sym_constinit] = ACTIONS(2897),
    [anon_sym_consteval] = ACTIONS(2897),
    [anon_sym_PROGMEM] = ACTIONS(2897),
    [aux_sym_primitive_type_token1] = ACTIONS(2897),
    [anon_sym_byte] = ACTIONS(2897),
    [anon_sym_word] = ACTIONS(2897),
    [anon_sym_enum] = ACTIONS(2897),
    [anon_sym_class] = ACTIONS(2897),
    [anon_sym_struct] = ACTIONS(2897),
    [anon_sym_union] = ACTIONS(2897),
    [anon_sym_if] = ACTIONS(2897),
    [anon_sym_switch] = ACTIONS(2897),
    [anon_sym_case] = ACTIONS(2897),
    [anon_sym_default] = ACTIONS(2897),
    [anon_sym_while] = ACTIONS(2897),
    [anon_sym_do] = ACTIONS(2897),
    [anon_sym_for] = ACTIONS(2897),
    [anon_sym_return] = ACTIONS(2897),
    [anon_sym_break] = ACTIONS(2897),
    [anon_sym_continue] = ACTIONS(2897),
    [anon_sym_goto] = ACTIONS(2897),
    [anon_sym_not] = ACTIONS(2897),
    [anon_sym_compl] = ACTIONS(2897),
    [anon_sym_DASH_DASH] = ACTIONS(2899),
    [anon_sym_PLUS_PLUS] = ACTIONS(2899),
    [anon_sym_sizeof] = ACTIONS(2897),
    [anon_sym___alignof__] = ACTIONS(2897),
    [anon_sym___alignof] = ACTIONS(2897),
    [anon_sym__alignof] = ACTIONS(2897),
    [anon_sym_alignof] = ACTIONS(2897),
    [anon_sym__Alignof] = ACTIONS(2897),
    [anon_sym_offsetof] = ACTIONS(2897),
    [anon_sym__Generic] = ACTIONS(2897),
    [anon_sym_asm] = ACTIONS(2897),
    [anon_sym___asm__] = ACTIONS(2897),
    [aux_sym_number_literal_token1] = ACTIONS(2899),
    [aux_sym_number_literal_token2] = ACTIONS(2897),
    [anon_sym_L_SQUOTE] = ACTIONS(2899),
    [anon_sym_u_SQUOTE] = ACTIONS(2899),
    [anon_sym_U_SQUOTE] = ACTIONS(2899),
    [anon_sym_u8_SQUOTE] = ACTIONS(2899),
    [anon_sym_SQUOTE] = ACTIONS(2899),
    [anon_sym_L_DQUOTE] = ACTIONS(2899),
    [anon_sym_u_DQUOTE] = ACTIONS(2899),
    [anon_sym_U_DQUOTE] = ACTIONS(2899),
    [anon_sym_u8_DQUOTE] = ACTIONS(2899),
    [anon_sym_DQUOTE] = ACTIONS(2899),
    [sym_true] = ACTIONS(2897),
    [sym_false] = ACTIONS(2897),
    [anon_sym_NULL] = ACTIONS(2897),
    [anon_sym_nullptr] = ACTIONS(2897),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2897),
    [anon_sym_decltype] = ACTIONS(2897),
    [anon_sym_virtual] = ACTIONS(2897),
    [anon_sym_alignas] = ACTIONS(2897),
    [anon_sym_explicit] = ACTIONS(2897),
    [anon_sym_typename] = ACTIONS(2897),
    [anon_sym_template] = ACTIONS(2897),
    [anon_sym_operator] = ACTIONS(2897),
    [anon_sym_try] = ACTIONS(2897),
    [anon_sym_delete] = ACTIONS(2897),
    [anon_sym_throw] = ACTIONS(2897),
    [anon_sym_namespace] = ACTIONS(2897),
    [anon_sym_using] = ACTIONS(2897),
    [anon_sym_static_assert] = ACTIONS(2897),
    [anon_sym_concept] = ACTIONS(2897),
    [anon_sym_co_return] = ACTIONS(2897),
    [anon_sym_co_yield] = ACTIONS(2897),
    [anon_sym_R_DQUOTE] = ACTIONS(2899),
    [anon_sym_LR_DQUOTE] = ACTIONS(2899),
    [anon_sym_uR_DQUOTE] = ACTIONS(2899),
    [anon_sym_UR_DQUOTE] = ACTIONS(2899),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2899),
    [anon_sym_co_await] = ACTIONS(2897),
    [anon_sym_new] = ACTIONS(2897),
    [anon_sym_requires] = ACTIONS(2897),
    [sym_this] = ACTIONS(2897),
  },
  [890] = {
    [ts_builtin_sym_end] = ACTIONS(3528),
    [sym_identifier] = ACTIONS(3530),
    [aux_sym_preproc_include_token1] = ACTIONS(3530),
    [aux_sym_preproc_def_token1] = ACTIONS(3530),
    [aux_sym_preproc_if_token1] = ACTIONS(3530),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3530),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3530),
    [sym_preproc_directive] = ACTIONS(3530),
    [anon_sym_LPAREN2] = ACTIONS(3528),
    [anon_sym_BANG] = ACTIONS(3528),
    [anon_sym_TILDE] = ACTIONS(3528),
    [anon_sym_DASH] = ACTIONS(3530),
    [anon_sym_PLUS] = ACTIONS(3530),
    [anon_sym_STAR] = ACTIONS(3528),
    [anon_sym_AMP_AMP] = ACTIONS(3528),
    [anon_sym_AMP] = ACTIONS(3530),
    [anon_sym___extension__] = ACTIONS(3530),
    [anon_sym_typedef] = ACTIONS(3530),
    [anon_sym_extern] = ACTIONS(3530),
    [anon_sym___attribute__] = ACTIONS(3530),
    [anon_sym_COLON_COLON] = ACTIONS(3528),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3528),
    [anon_sym___declspec] = ACTIONS(3530),
    [anon_sym___based] = ACTIONS(3530),
    [anon_sym___cdecl] = ACTIONS(3530),
    [anon_sym___clrcall] = ACTIONS(3530),
    [anon_sym___stdcall] = ACTIONS(3530),
    [anon_sym___fastcall] = ACTIONS(3530),
    [anon_sym___thiscall] = ACTIONS(3530),
    [anon_sym___vectorcall] = ACTIONS(3530),
    [anon_sym_LBRACE] = ACTIONS(3528),
    [anon_sym_signed] = ACTIONS(3530),
    [anon_sym_unsigned] = ACTIONS(3530),
    [anon_sym_long] = ACTIONS(3530),
    [anon_sym_short] = ACTIONS(3530),
    [anon_sym_LBRACK] = ACTIONS(3530),
    [anon_sym_static] = ACTIONS(3530),
    [anon_sym_register] = ACTIONS(3530),
    [anon_sym_inline] = ACTIONS(3530),
    [anon_sym___inline] = ACTIONS(3530),
    [anon_sym___inline__] = ACTIONS(3530),
    [anon_sym___forceinline] = ACTIONS(3530),
    [anon_sym_thread_local] = ACTIONS(3530),
    [anon_sym___thread] = ACTIONS(3530),
    [anon_sym_const] = ACTIONS(3530),
    [anon_sym_constexpr] = ACTIONS(3530),
    [anon_sym_volatile] = ACTIONS(3530),
    [anon_sym_restrict] = ACTIONS(3530),
    [anon_sym___restrict__] = ACTIONS(3530),
    [anon_sym__Atomic] = ACTIONS(3530),
    [anon_sym__Noreturn] = ACTIONS(3530),
    [anon_sym_noreturn] = ACTIONS(3530),
    [anon_sym_mutable] = ACTIONS(3530),
    [anon_sym_constinit] = ACTIONS(3530),
    [anon_sym_consteval] = ACTIONS(3530),
    [anon_sym_PROGMEM] = ACTIONS(3530),
    [aux_sym_primitive_type_token1] = ACTIONS(3530),
    [anon_sym_byte] = ACTIONS(3530),
    [anon_sym_word] = ACTIONS(3530),
    [anon_sym_enum] = ACTIONS(3530),
    [anon_sym_class] = ACTIONS(3530),
    [anon_sym_struct] = ACTIONS(3530),
    [anon_sym_union] = ACTIONS(3530),
    [anon_sym_if] = ACTIONS(3530),
    [anon_sym_switch] = ACTIONS(3530),
    [anon_sym_case] = ACTIONS(3530),
    [anon_sym_default] = ACTIONS(3530),
    [anon_sym_while] = ACTIONS(3530),
    [anon_sym_do] = ACTIONS(3530),
    [anon_sym_for] = ACTIONS(3530),
    [anon_sym_return] = ACTIONS(3530),
    [anon_sym_break] = ACTIONS(3530),
    [anon_sym_continue] = ACTIONS(3530),
    [anon_sym_goto] = ACTIONS(3530),
    [anon_sym_not] = ACTIONS(3530),
    [anon_sym_compl] = ACTIONS(3530),
    [anon_sym_DASH_DASH] = ACTIONS(3528),
    [anon_sym_PLUS_PLUS] = ACTIONS(3528),
    [anon_sym_sizeof] = ACTIONS(3530),
    [anon_sym___alignof__] = ACTIONS(3530),
    [anon_sym___alignof] = ACTIONS(3530),
    [anon_sym__alignof] = ACTIONS(3530),
    [anon_sym_alignof] = ACTIONS(3530),
    [anon_sym__Alignof] = ACTIONS(3530),
    [anon_sym_offsetof] = ACTIONS(3530),
    [anon_sym__Generic] = ACTIONS(3530),
    [anon_sym_asm] = ACTIONS(3530),
    [anon_sym___asm__] = ACTIONS(3530),
    [aux_sym_number_literal_token1] = ACTIONS(3528),
    [aux_sym_number_literal_token2] = ACTIONS(3530),
    [anon_sym_L_SQUOTE] = ACTIONS(3528),
    [anon_sym_u_SQUOTE] = ACTIONS(3528),
    [anon_sym_U_SQUOTE] = ACTIONS(3528),
    [anon_sym_u8_SQUOTE] = ACTIONS(3528),
    [anon_sym_SQUOTE] = ACTIONS(3528),
    [anon_sym_L_DQUOTE] = ACTIONS(3528),
    [anon_sym_u_DQUOTE] = ACTIONS(3528),
    [anon_sym_U_DQUOTE] = ACTIONS(3528),
    [anon_sym_u8_DQUOTE] = ACTIONS(3528),
    [anon_sym_DQUOTE] = ACTIONS(3528),
    [sym_true] = ACTIONS(3530),
    [sym_false] = ACTIONS(3530),
    [anon_sym_NULL] = ACTIONS(3530),
    [anon_sym_nullptr] = ACTIONS(3530),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3530),
    [anon_sym_decltype] = ACTIONS(3530),
    [anon_sym_virtual] = ACTIONS(3530),
    [anon_sym_alignas] = ACTIONS(3530),
    [anon_sym_explicit] = ACTIONS(3530),
    [anon_sym_typename] = ACTIONS(3530),
    [anon_sym_template] = ACTIONS(3530),
    [anon_sym_operator] = ACTIONS(3530),
    [anon_sym_try] = ACTIONS(3530),
    [anon_sym_delete] = ACTIONS(3530),
    [anon_sym_throw] = ACTIONS(3530),
    [anon_sym_namespace] = ACTIONS(3530),
    [anon_sym_using] = ACTIONS(3530),
    [anon_sym_static_assert] = ACTIONS(3530),
    [anon_sym_concept] = ACTIONS(3530),
    [anon_sym_co_return] = ACTIONS(3530),
    [anon_sym_co_yield] = ACTIONS(3530),
    [anon_sym_R_DQUOTE] = ACTIONS(3528),
    [anon_sym_LR_DQUOTE] = ACTIONS(3528),
    [anon_sym_uR_DQUOTE] = ACTIONS(3528),
    [anon_sym_UR_DQUOTE] = ACTIONS(3528),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3528),
    [anon_sym_co_await] = ACTIONS(3530),
    [anon_sym_new] = ACTIONS(3530),
    [anon_sym_requires] = ACTIONS(3530),
    [sym_this] = ACTIONS(3530),
  },
  [891] = {
    [ts_builtin_sym_end] = ACTIONS(3070),
    [sym_identifier] = ACTIONS(3068),
    [aux_sym_preproc_include_token1] = ACTIONS(3068),
    [aux_sym_preproc_def_token1] = ACTIONS(3068),
    [aux_sym_preproc_if_token1] = ACTIONS(3068),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3068),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3068),
    [sym_preproc_directive] = ACTIONS(3068),
    [anon_sym_LPAREN2] = ACTIONS(3070),
    [anon_sym_BANG] = ACTIONS(3070),
    [anon_sym_TILDE] = ACTIONS(3070),
    [anon_sym_DASH] = ACTIONS(3068),
    [anon_sym_PLUS] = ACTIONS(3068),
    [anon_sym_STAR] = ACTIONS(3070),
    [anon_sym_AMP_AMP] = ACTIONS(3070),
    [anon_sym_AMP] = ACTIONS(3068),
    [anon_sym___extension__] = ACTIONS(3068),
    [anon_sym_typedef] = ACTIONS(3068),
    [anon_sym_extern] = ACTIONS(3068),
    [anon_sym___attribute__] = ACTIONS(3068),
    [anon_sym_COLON_COLON] = ACTIONS(3070),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3070),
    [anon_sym___declspec] = ACTIONS(3068),
    [anon_sym___based] = ACTIONS(3068),
    [anon_sym___cdecl] = ACTIONS(3068),
    [anon_sym___clrcall] = ACTIONS(3068),
    [anon_sym___stdcall] = ACTIONS(3068),
    [anon_sym___fastcall] = ACTIONS(3068),
    [anon_sym___thiscall] = ACTIONS(3068),
    [anon_sym___vectorcall] = ACTIONS(3068),
    [anon_sym_LBRACE] = ACTIONS(3070),
    [anon_sym_signed] = ACTIONS(3068),
    [anon_sym_unsigned] = ACTIONS(3068),
    [anon_sym_long] = ACTIONS(3068),
    [anon_sym_short] = ACTIONS(3068),
    [anon_sym_LBRACK] = ACTIONS(3068),
    [anon_sym_static] = ACTIONS(3068),
    [anon_sym_register] = ACTIONS(3068),
    [anon_sym_inline] = ACTIONS(3068),
    [anon_sym___inline] = ACTIONS(3068),
    [anon_sym___inline__] = ACTIONS(3068),
    [anon_sym___forceinline] = ACTIONS(3068),
    [anon_sym_thread_local] = ACTIONS(3068),
    [anon_sym___thread] = ACTIONS(3068),
    [anon_sym_const] = ACTIONS(3068),
    [anon_sym_constexpr] = ACTIONS(3068),
    [anon_sym_volatile] = ACTIONS(3068),
    [anon_sym_restrict] = ACTIONS(3068),
    [anon_sym___restrict__] = ACTIONS(3068),
    [anon_sym__Atomic] = ACTIONS(3068),
    [anon_sym__Noreturn] = ACTIONS(3068),
    [anon_sym_noreturn] = ACTIONS(3068),
    [anon_sym_mutable] = ACTIONS(3068),
    [anon_sym_constinit] = ACTIONS(3068),
    [anon_sym_consteval] = ACTIONS(3068),
    [anon_sym_PROGMEM] = ACTIONS(3068),
    [aux_sym_primitive_type_token1] = ACTIONS(3068),
    [anon_sym_byte] = ACTIONS(3068),
    [anon_sym_word] = ACTIONS(3068),
    [anon_sym_enum] = ACTIONS(3068),
    [anon_sym_class] = ACTIONS(3068),
    [anon_sym_struct] = ACTIONS(3068),
    [anon_sym_union] = ACTIONS(3068),
    [anon_sym_if] = ACTIONS(3068),
    [anon_sym_switch] = ACTIONS(3068),
    [anon_sym_case] = ACTIONS(3068),
    [anon_sym_default] = ACTIONS(3068),
    [anon_sym_while] = ACTIONS(3068),
    [anon_sym_do] = ACTIONS(3068),
    [anon_sym_for] = ACTIONS(3068),
    [anon_sym_return] = ACTIONS(3068),
    [anon_sym_break] = ACTIONS(3068),
    [anon_sym_continue] = ACTIONS(3068),
    [anon_sym_goto] = ACTIONS(3068),
    [anon_sym_not] = ACTIONS(3068),
    [anon_sym_compl] = ACTIONS(3068),
    [anon_sym_DASH_DASH] = ACTIONS(3070),
    [anon_sym_PLUS_PLUS] = ACTIONS(3070),
    [anon_sym_sizeof] = ACTIONS(3068),
    [anon_sym___alignof__] = ACTIONS(3068),
    [anon_sym___alignof] = ACTIONS(3068),
    [anon_sym__alignof] = ACTIONS(3068),
    [anon_sym_alignof] = ACTIONS(3068),
    [anon_sym__Alignof] = ACTIONS(3068),
    [anon_sym_offsetof] = ACTIONS(3068),
    [anon_sym__Generic] = ACTIONS(3068),
    [anon_sym_asm] = ACTIONS(3068),
    [anon_sym___asm__] = ACTIONS(3068),
    [aux_sym_number_literal_token1] = ACTIONS(3070),
    [aux_sym_number_literal_token2] = ACTIONS(3068),
    [anon_sym_L_SQUOTE] = ACTIONS(3070),
    [anon_sym_u_SQUOTE] = ACTIONS(3070),
    [anon_sym_U_SQUOTE] = ACTIONS(3070),
    [anon_sym_u8_SQUOTE] = ACTIONS(3070),
    [anon_sym_SQUOTE] = ACTIONS(3070),
    [anon_sym_L_DQUOTE] = ACTIONS(3070),
    [anon_sym_u_DQUOTE] = ACTIONS(3070),
    [anon_sym_U_DQUOTE] = ACTIONS(3070),
    [anon_sym_u8_DQUOTE] = ACTIONS(3070),
    [anon_sym_DQUOTE] = ACTIONS(3070),
    [sym_true] = ACTIONS(3068),
    [sym_false] = ACTIONS(3068),
    [anon_sym_NULL] = ACTIONS(3068),
    [anon_sym_nullptr] = ACTIONS(3068),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3068),
    [anon_sym_decltype] = ACTIONS(3068),
    [anon_sym_virtual] = ACTIONS(3068),
    [anon_sym_alignas] = ACTIONS(3068),
    [anon_sym_explicit] = ACTIONS(3068),
    [anon_sym_typename] = ACTIONS(3068),
    [anon_sym_template] = ACTIONS(3068),
    [anon_sym_operator] = ACTIONS(3068),
    [anon_sym_try] = ACTIONS(3068),
    [anon_sym_delete] = ACTIONS(3068),
    [anon_sym_throw] = ACTIONS(3068),
    [anon_sym_namespace] = ACTIONS(3068),
    [anon_sym_using] = ACTIONS(3068),
    [anon_sym_static_assert] = ACTIONS(3068),
    [anon_sym_concept] = ACTIONS(3068),
    [anon_sym_co_return] = ACTIONS(3068),
    [anon_sym_co_yield] = ACTIONS(3068),
    [anon_sym_R_DQUOTE] = ACTIONS(3070),
    [anon_sym_LR_DQUOTE] = ACTIONS(3070),
    [anon_sym_uR_DQUOTE] = ACTIONS(3070),
    [anon_sym_UR_DQUOTE] = ACTIONS(3070),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3070),
    [anon_sym_co_await] = ACTIONS(3068),
    [anon_sym_new] = ACTIONS(3068),
    [anon_sym_requires] = ACTIONS(3068),
    [sym_this] = ACTIONS(3068),
  },
  [892] = {
    [sym_preproc_def] = STATE(840),
    [sym_preproc_function_def] = STATE(840),
    [sym_preproc_call] = STATE(840),
    [sym_preproc_if_in_field_declaration_list] = STATE(840),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(840),
    [sym_type_definition] = STATE(840),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(5536),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(3150),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6010),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym__field_declaration_list_item] = STATE(840),
    [sym_field_declaration] = STATE(840),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1811),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(840),
    [sym_operator_cast] = STATE(6536),
    [sym_inline_method_definition] = STATE(840),
    [sym__constructor_specifiers] = STATE(1811),
    [sym_operator_cast_definition] = STATE(840),
    [sym_operator_cast_declaration] = STATE(840),
    [sym_constructor_or_destructor_definition] = STATE(840),
    [sym_constructor_or_destructor_declaration] = STATE(840),
    [sym_friend_declaration] = STATE(840),
    [sym_access_specifier] = STATE(7802),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(2618),
    [sym_template_function] = STATE(6098),
    [sym_using_declaration] = STATE(840),
    [sym_alias_declaration] = STATE(840),
    [sym_static_assert_declaration] = STATE(840),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5301),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_qualified_operator_cast_identifier] = STATE(6536),
    [sym_operator_name] = STATE(6098),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(840),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1961),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1811),
    [sym_identifier] = ACTIONS(2823),
    [aux_sym_preproc_def_token1] = ACTIONS(3364),
    [aux_sym_preproc_if_token1] = ACTIONS(3366),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3368),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3368),
    [sym_preproc_directive] = ACTIONS(3370),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(3372),
    [anon_sym_typedef] = ACTIONS(3374),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(2853),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_RBRACE] = ACTIONS(3532),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2857),
    [anon_sym_class] = ACTIONS(2859),
    [anon_sym_struct] = ACTIONS(2861),
    [anon_sym_union] = ACTIONS(2863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(2865),
    [anon_sym_template] = ACTIONS(3378),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3380),
    [anon_sym_public] = ACTIONS(2871),
    [anon_sym_private] = ACTIONS(2871),
    [anon_sym_protected] = ACTIONS(2871),
    [anon_sym_using] = ACTIONS(3382),
    [anon_sym_static_assert] = ACTIONS(3384),
  },
  [893] = {
    [sym_preproc_def] = STATE(887),
    [sym_preproc_function_def] = STATE(887),
    [sym_preproc_call] = STATE(887),
    [sym_preproc_if_in_field_declaration_list] = STATE(887),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(887),
    [sym_type_definition] = STATE(887),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(5536),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(3150),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6010),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym__field_declaration_list_item] = STATE(887),
    [sym_field_declaration] = STATE(887),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1811),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(887),
    [sym_operator_cast] = STATE(6536),
    [sym_inline_method_definition] = STATE(887),
    [sym__constructor_specifiers] = STATE(1811),
    [sym_operator_cast_definition] = STATE(887),
    [sym_operator_cast_declaration] = STATE(887),
    [sym_constructor_or_destructor_definition] = STATE(887),
    [sym_constructor_or_destructor_declaration] = STATE(887),
    [sym_friend_declaration] = STATE(887),
    [sym_access_specifier] = STATE(7802),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(2618),
    [sym_template_function] = STATE(6098),
    [sym_using_declaration] = STATE(887),
    [sym_alias_declaration] = STATE(887),
    [sym_static_assert_declaration] = STATE(887),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5301),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_qualified_operator_cast_identifier] = STATE(6536),
    [sym_operator_name] = STATE(6098),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(887),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1961),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1811),
    [sym_identifier] = ACTIONS(2823),
    [aux_sym_preproc_def_token1] = ACTIONS(3364),
    [aux_sym_preproc_if_token1] = ACTIONS(3366),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3368),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3368),
    [sym_preproc_directive] = ACTIONS(3370),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(3372),
    [anon_sym_typedef] = ACTIONS(3374),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(2853),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_RBRACE] = ACTIONS(3534),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2857),
    [anon_sym_class] = ACTIONS(2859),
    [anon_sym_struct] = ACTIONS(2861),
    [anon_sym_union] = ACTIONS(2863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(2865),
    [anon_sym_template] = ACTIONS(3378),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3380),
    [anon_sym_public] = ACTIONS(2871),
    [anon_sym_private] = ACTIONS(2871),
    [anon_sym_protected] = ACTIONS(2871),
    [anon_sym_using] = ACTIONS(3382),
    [anon_sym_static_assert] = ACTIONS(3384),
  },
  [894] = {
    [sym_preproc_def] = STATE(883),
    [sym_preproc_function_def] = STATE(883),
    [sym_preproc_call] = STATE(883),
    [sym_preproc_if_in_field_declaration_list] = STATE(883),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(883),
    [sym_type_definition] = STATE(883),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(5536),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(3150),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6010),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym__field_declaration_list_item] = STATE(883),
    [sym_field_declaration] = STATE(883),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1811),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(883),
    [sym_operator_cast] = STATE(6536),
    [sym_inline_method_definition] = STATE(883),
    [sym__constructor_specifiers] = STATE(1811),
    [sym_operator_cast_definition] = STATE(883),
    [sym_operator_cast_declaration] = STATE(883),
    [sym_constructor_or_destructor_definition] = STATE(883),
    [sym_constructor_or_destructor_declaration] = STATE(883),
    [sym_friend_declaration] = STATE(883),
    [sym_access_specifier] = STATE(7802),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(2618),
    [sym_template_function] = STATE(6098),
    [sym_using_declaration] = STATE(883),
    [sym_alias_declaration] = STATE(883),
    [sym_static_assert_declaration] = STATE(883),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5301),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_qualified_operator_cast_identifier] = STATE(6536),
    [sym_operator_name] = STATE(6098),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(883),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1961),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1811),
    [sym_identifier] = ACTIONS(2823),
    [aux_sym_preproc_def_token1] = ACTIONS(3364),
    [aux_sym_preproc_if_token1] = ACTIONS(3366),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3368),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3368),
    [sym_preproc_directive] = ACTIONS(3370),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(3372),
    [anon_sym_typedef] = ACTIONS(3374),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(2853),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_RBRACE] = ACTIONS(3536),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2857),
    [anon_sym_class] = ACTIONS(2859),
    [anon_sym_struct] = ACTIONS(2861),
    [anon_sym_union] = ACTIONS(2863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(2865),
    [anon_sym_template] = ACTIONS(3378),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3380),
    [anon_sym_public] = ACTIONS(2871),
    [anon_sym_private] = ACTIONS(2871),
    [anon_sym_protected] = ACTIONS(2871),
    [anon_sym_using] = ACTIONS(3382),
    [anon_sym_static_assert] = ACTIONS(3384),
  },
  [895] = {
    [ts_builtin_sym_end] = ACTIONS(2891),
    [sym_identifier] = ACTIONS(2889),
    [aux_sym_preproc_include_token1] = ACTIONS(2889),
    [aux_sym_preproc_def_token1] = ACTIONS(2889),
    [aux_sym_preproc_if_token1] = ACTIONS(2889),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2889),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2889),
    [sym_preproc_directive] = ACTIONS(2889),
    [anon_sym_LPAREN2] = ACTIONS(2891),
    [anon_sym_BANG] = ACTIONS(2891),
    [anon_sym_TILDE] = ACTIONS(2891),
    [anon_sym_DASH] = ACTIONS(2889),
    [anon_sym_PLUS] = ACTIONS(2889),
    [anon_sym_STAR] = ACTIONS(2891),
    [anon_sym_AMP_AMP] = ACTIONS(2891),
    [anon_sym_AMP] = ACTIONS(2889),
    [anon_sym___extension__] = ACTIONS(2889),
    [anon_sym_typedef] = ACTIONS(2889),
    [anon_sym_extern] = ACTIONS(2889),
    [anon_sym___attribute__] = ACTIONS(2889),
    [anon_sym_COLON_COLON] = ACTIONS(2891),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2891),
    [anon_sym___declspec] = ACTIONS(2889),
    [anon_sym___based] = ACTIONS(2889),
    [anon_sym___cdecl] = ACTIONS(2889),
    [anon_sym___clrcall] = ACTIONS(2889),
    [anon_sym___stdcall] = ACTIONS(2889),
    [anon_sym___fastcall] = ACTIONS(2889),
    [anon_sym___thiscall] = ACTIONS(2889),
    [anon_sym___vectorcall] = ACTIONS(2889),
    [anon_sym_LBRACE] = ACTIONS(2891),
    [anon_sym_signed] = ACTIONS(2889),
    [anon_sym_unsigned] = ACTIONS(2889),
    [anon_sym_long] = ACTIONS(2889),
    [anon_sym_short] = ACTIONS(2889),
    [anon_sym_LBRACK] = ACTIONS(2889),
    [anon_sym_static] = ACTIONS(2889),
    [anon_sym_register] = ACTIONS(2889),
    [anon_sym_inline] = ACTIONS(2889),
    [anon_sym___inline] = ACTIONS(2889),
    [anon_sym___inline__] = ACTIONS(2889),
    [anon_sym___forceinline] = ACTIONS(2889),
    [anon_sym_thread_local] = ACTIONS(2889),
    [anon_sym___thread] = ACTIONS(2889),
    [anon_sym_const] = ACTIONS(2889),
    [anon_sym_constexpr] = ACTIONS(2889),
    [anon_sym_volatile] = ACTIONS(2889),
    [anon_sym_restrict] = ACTIONS(2889),
    [anon_sym___restrict__] = ACTIONS(2889),
    [anon_sym__Atomic] = ACTIONS(2889),
    [anon_sym__Noreturn] = ACTIONS(2889),
    [anon_sym_noreturn] = ACTIONS(2889),
    [anon_sym_mutable] = ACTIONS(2889),
    [anon_sym_constinit] = ACTIONS(2889),
    [anon_sym_consteval] = ACTIONS(2889),
    [anon_sym_PROGMEM] = ACTIONS(2889),
    [aux_sym_primitive_type_token1] = ACTIONS(2889),
    [anon_sym_byte] = ACTIONS(2889),
    [anon_sym_word] = ACTIONS(2889),
    [anon_sym_enum] = ACTIONS(2889),
    [anon_sym_class] = ACTIONS(2889),
    [anon_sym_struct] = ACTIONS(2889),
    [anon_sym_union] = ACTIONS(2889),
    [anon_sym_if] = ACTIONS(2889),
    [anon_sym_switch] = ACTIONS(2889),
    [anon_sym_case] = ACTIONS(2889),
    [anon_sym_default] = ACTIONS(2889),
    [anon_sym_while] = ACTIONS(2889),
    [anon_sym_do] = ACTIONS(2889),
    [anon_sym_for] = ACTIONS(2889),
    [anon_sym_return] = ACTIONS(2889),
    [anon_sym_break] = ACTIONS(2889),
    [anon_sym_continue] = ACTIONS(2889),
    [anon_sym_goto] = ACTIONS(2889),
    [anon_sym_not] = ACTIONS(2889),
    [anon_sym_compl] = ACTIONS(2889),
    [anon_sym_DASH_DASH] = ACTIONS(2891),
    [anon_sym_PLUS_PLUS] = ACTIONS(2891),
    [anon_sym_sizeof] = ACTIONS(2889),
    [anon_sym___alignof__] = ACTIONS(2889),
    [anon_sym___alignof] = ACTIONS(2889),
    [anon_sym__alignof] = ACTIONS(2889),
    [anon_sym_alignof] = ACTIONS(2889),
    [anon_sym__Alignof] = ACTIONS(2889),
    [anon_sym_offsetof] = ACTIONS(2889),
    [anon_sym__Generic] = ACTIONS(2889),
    [anon_sym_asm] = ACTIONS(2889),
    [anon_sym___asm__] = ACTIONS(2889),
    [aux_sym_number_literal_token1] = ACTIONS(2891),
    [aux_sym_number_literal_token2] = ACTIONS(2889),
    [anon_sym_L_SQUOTE] = ACTIONS(2891),
    [anon_sym_u_SQUOTE] = ACTIONS(2891),
    [anon_sym_U_SQUOTE] = ACTIONS(2891),
    [anon_sym_u8_SQUOTE] = ACTIONS(2891),
    [anon_sym_SQUOTE] = ACTIONS(2891),
    [anon_sym_L_DQUOTE] = ACTIONS(2891),
    [anon_sym_u_DQUOTE] = ACTIONS(2891),
    [anon_sym_U_DQUOTE] = ACTIONS(2891),
    [anon_sym_u8_DQUOTE] = ACTIONS(2891),
    [anon_sym_DQUOTE] = ACTIONS(2891),
    [sym_true] = ACTIONS(2889),
    [sym_false] = ACTIONS(2889),
    [anon_sym_NULL] = ACTIONS(2889),
    [anon_sym_nullptr] = ACTIONS(2889),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2889),
    [anon_sym_decltype] = ACTIONS(2889),
    [anon_sym_virtual] = ACTIONS(2889),
    [anon_sym_alignas] = ACTIONS(2889),
    [anon_sym_explicit] = ACTIONS(2889),
    [anon_sym_typename] = ACTIONS(2889),
    [anon_sym_template] = ACTIONS(2889),
    [anon_sym_operator] = ACTIONS(2889),
    [anon_sym_try] = ACTIONS(2889),
    [anon_sym_delete] = ACTIONS(2889),
    [anon_sym_throw] = ACTIONS(2889),
    [anon_sym_namespace] = ACTIONS(2889),
    [anon_sym_using] = ACTIONS(2889),
    [anon_sym_static_assert] = ACTIONS(2889),
    [anon_sym_concept] = ACTIONS(2889),
    [anon_sym_co_return] = ACTIONS(2889),
    [anon_sym_co_yield] = ACTIONS(2889),
    [anon_sym_R_DQUOTE] = ACTIONS(2891),
    [anon_sym_LR_DQUOTE] = ACTIONS(2891),
    [anon_sym_uR_DQUOTE] = ACTIONS(2891),
    [anon_sym_UR_DQUOTE] = ACTIONS(2891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2891),
    [anon_sym_co_await] = ACTIONS(2889),
    [anon_sym_new] = ACTIONS(2889),
    [anon_sym_requires] = ACTIONS(2889),
    [sym_this] = ACTIONS(2889),
  },
  [896] = {
    [ts_builtin_sym_end] = ACTIONS(2995),
    [sym_identifier] = ACTIONS(2993),
    [aux_sym_preproc_include_token1] = ACTIONS(2993),
    [aux_sym_preproc_def_token1] = ACTIONS(2993),
    [aux_sym_preproc_if_token1] = ACTIONS(2993),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2993),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2993),
    [sym_preproc_directive] = ACTIONS(2993),
    [anon_sym_LPAREN2] = ACTIONS(2995),
    [anon_sym_BANG] = ACTIONS(2995),
    [anon_sym_TILDE] = ACTIONS(2995),
    [anon_sym_DASH] = ACTIONS(2993),
    [anon_sym_PLUS] = ACTIONS(2993),
    [anon_sym_STAR] = ACTIONS(2995),
    [anon_sym_AMP_AMP] = ACTIONS(2995),
    [anon_sym_AMP] = ACTIONS(2993),
    [anon_sym___extension__] = ACTIONS(2993),
    [anon_sym_typedef] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(2993),
    [anon_sym___attribute__] = ACTIONS(2993),
    [anon_sym_COLON_COLON] = ACTIONS(2995),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2995),
    [anon_sym___declspec] = ACTIONS(2993),
    [anon_sym___based] = ACTIONS(2993),
    [anon_sym___cdecl] = ACTIONS(2993),
    [anon_sym___clrcall] = ACTIONS(2993),
    [anon_sym___stdcall] = ACTIONS(2993),
    [anon_sym___fastcall] = ACTIONS(2993),
    [anon_sym___thiscall] = ACTIONS(2993),
    [anon_sym___vectorcall] = ACTIONS(2993),
    [anon_sym_LBRACE] = ACTIONS(2995),
    [anon_sym_signed] = ACTIONS(2993),
    [anon_sym_unsigned] = ACTIONS(2993),
    [anon_sym_long] = ACTIONS(2993),
    [anon_sym_short] = ACTIONS(2993),
    [anon_sym_LBRACK] = ACTIONS(2993),
    [anon_sym_static] = ACTIONS(2993),
    [anon_sym_register] = ACTIONS(2993),
    [anon_sym_inline] = ACTIONS(2993),
    [anon_sym___inline] = ACTIONS(2993),
    [anon_sym___inline__] = ACTIONS(2993),
    [anon_sym___forceinline] = ACTIONS(2993),
    [anon_sym_thread_local] = ACTIONS(2993),
    [anon_sym___thread] = ACTIONS(2993),
    [anon_sym_const] = ACTIONS(2993),
    [anon_sym_constexpr] = ACTIONS(2993),
    [anon_sym_volatile] = ACTIONS(2993),
    [anon_sym_restrict] = ACTIONS(2993),
    [anon_sym___restrict__] = ACTIONS(2993),
    [anon_sym__Atomic] = ACTIONS(2993),
    [anon_sym__Noreturn] = ACTIONS(2993),
    [anon_sym_noreturn] = ACTIONS(2993),
    [anon_sym_mutable] = ACTIONS(2993),
    [anon_sym_constinit] = ACTIONS(2993),
    [anon_sym_consteval] = ACTIONS(2993),
    [anon_sym_PROGMEM] = ACTIONS(2993),
    [aux_sym_primitive_type_token1] = ACTIONS(2993),
    [anon_sym_byte] = ACTIONS(2993),
    [anon_sym_word] = ACTIONS(2993),
    [anon_sym_enum] = ACTIONS(2993),
    [anon_sym_class] = ACTIONS(2993),
    [anon_sym_struct] = ACTIONS(2993),
    [anon_sym_union] = ACTIONS(2993),
    [anon_sym_if] = ACTIONS(2993),
    [anon_sym_switch] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2993),
    [anon_sym_default] = ACTIONS(2993),
    [anon_sym_while] = ACTIONS(2993),
    [anon_sym_do] = ACTIONS(2993),
    [anon_sym_for] = ACTIONS(2993),
    [anon_sym_return] = ACTIONS(2993),
    [anon_sym_break] = ACTIONS(2993),
    [anon_sym_continue] = ACTIONS(2993),
    [anon_sym_goto] = ACTIONS(2993),
    [anon_sym_not] = ACTIONS(2993),
    [anon_sym_compl] = ACTIONS(2993),
    [anon_sym_DASH_DASH] = ACTIONS(2995),
    [anon_sym_PLUS_PLUS] = ACTIONS(2995),
    [anon_sym_sizeof] = ACTIONS(2993),
    [anon_sym___alignof__] = ACTIONS(2993),
    [anon_sym___alignof] = ACTIONS(2993),
    [anon_sym__alignof] = ACTIONS(2993),
    [anon_sym_alignof] = ACTIONS(2993),
    [anon_sym__Alignof] = ACTIONS(2993),
    [anon_sym_offsetof] = ACTIONS(2993),
    [anon_sym__Generic] = ACTIONS(2993),
    [anon_sym_asm] = ACTIONS(2993),
    [anon_sym___asm__] = ACTIONS(2993),
    [aux_sym_number_literal_token1] = ACTIONS(2995),
    [aux_sym_number_literal_token2] = ACTIONS(2993),
    [anon_sym_L_SQUOTE] = ACTIONS(2995),
    [anon_sym_u_SQUOTE] = ACTIONS(2995),
    [anon_sym_U_SQUOTE] = ACTIONS(2995),
    [anon_sym_u8_SQUOTE] = ACTIONS(2995),
    [anon_sym_SQUOTE] = ACTIONS(2995),
    [anon_sym_L_DQUOTE] = ACTIONS(2995),
    [anon_sym_u_DQUOTE] = ACTIONS(2995),
    [anon_sym_U_DQUOTE] = ACTIONS(2995),
    [anon_sym_u8_DQUOTE] = ACTIONS(2995),
    [anon_sym_DQUOTE] = ACTIONS(2995),
    [sym_true] = ACTIONS(2993),
    [sym_false] = ACTIONS(2993),
    [anon_sym_NULL] = ACTIONS(2993),
    [anon_sym_nullptr] = ACTIONS(2993),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2993),
    [anon_sym_decltype] = ACTIONS(2993),
    [anon_sym_virtual] = ACTIONS(2993),
    [anon_sym_alignas] = ACTIONS(2993),
    [anon_sym_explicit] = ACTIONS(2993),
    [anon_sym_typename] = ACTIONS(2993),
    [anon_sym_template] = ACTIONS(2993),
    [anon_sym_operator] = ACTIONS(2993),
    [anon_sym_try] = ACTIONS(2993),
    [anon_sym_delete] = ACTIONS(2993),
    [anon_sym_throw] = ACTIONS(2993),
    [anon_sym_namespace] = ACTIONS(2993),
    [anon_sym_using] = ACTIONS(2993),
    [anon_sym_static_assert] = ACTIONS(2993),
    [anon_sym_concept] = ACTIONS(2993),
    [anon_sym_co_return] = ACTIONS(2993),
    [anon_sym_co_yield] = ACTIONS(2993),
    [anon_sym_R_DQUOTE] = ACTIONS(2995),
    [anon_sym_LR_DQUOTE] = ACTIONS(2995),
    [anon_sym_uR_DQUOTE] = ACTIONS(2995),
    [anon_sym_UR_DQUOTE] = ACTIONS(2995),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2995),
    [anon_sym_co_await] = ACTIONS(2993),
    [anon_sym_new] = ACTIONS(2993),
    [anon_sym_requires] = ACTIONS(2993),
    [sym_this] = ACTIONS(2993),
  },
  [897] = {
    [ts_builtin_sym_end] = ACTIONS(2815),
    [sym_identifier] = ACTIONS(2813),
    [aux_sym_preproc_include_token1] = ACTIONS(2813),
    [aux_sym_preproc_def_token1] = ACTIONS(2813),
    [aux_sym_preproc_if_token1] = ACTIONS(2813),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2813),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2813),
    [sym_preproc_directive] = ACTIONS(2813),
    [anon_sym_LPAREN2] = ACTIONS(2815),
    [anon_sym_BANG] = ACTIONS(2815),
    [anon_sym_TILDE] = ACTIONS(2815),
    [anon_sym_DASH] = ACTIONS(2813),
    [anon_sym_PLUS] = ACTIONS(2813),
    [anon_sym_STAR] = ACTIONS(2815),
    [anon_sym_AMP_AMP] = ACTIONS(2815),
    [anon_sym_AMP] = ACTIONS(2813),
    [anon_sym___extension__] = ACTIONS(2813),
    [anon_sym_typedef] = ACTIONS(2813),
    [anon_sym_extern] = ACTIONS(2813),
    [anon_sym___attribute__] = ACTIONS(2813),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2815),
    [anon_sym___declspec] = ACTIONS(2813),
    [anon_sym___based] = ACTIONS(2813),
    [anon_sym___cdecl] = ACTIONS(2813),
    [anon_sym___clrcall] = ACTIONS(2813),
    [anon_sym___stdcall] = ACTIONS(2813),
    [anon_sym___fastcall] = ACTIONS(2813),
    [anon_sym___thiscall] = ACTIONS(2813),
    [anon_sym___vectorcall] = ACTIONS(2813),
    [anon_sym_LBRACE] = ACTIONS(2815),
    [anon_sym_signed] = ACTIONS(2813),
    [anon_sym_unsigned] = ACTIONS(2813),
    [anon_sym_long] = ACTIONS(2813),
    [anon_sym_short] = ACTIONS(2813),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_static] = ACTIONS(2813),
    [anon_sym_register] = ACTIONS(2813),
    [anon_sym_inline] = ACTIONS(2813),
    [anon_sym___inline] = ACTIONS(2813),
    [anon_sym___inline__] = ACTIONS(2813),
    [anon_sym___forceinline] = ACTIONS(2813),
    [anon_sym_thread_local] = ACTIONS(2813),
    [anon_sym___thread] = ACTIONS(2813),
    [anon_sym_const] = ACTIONS(2813),
    [anon_sym_constexpr] = ACTIONS(2813),
    [anon_sym_volatile] = ACTIONS(2813),
    [anon_sym_restrict] = ACTIONS(2813),
    [anon_sym___restrict__] = ACTIONS(2813),
    [anon_sym__Atomic] = ACTIONS(2813),
    [anon_sym__Noreturn] = ACTIONS(2813),
    [anon_sym_noreturn] = ACTIONS(2813),
    [anon_sym_mutable] = ACTIONS(2813),
    [anon_sym_constinit] = ACTIONS(2813),
    [anon_sym_consteval] = ACTIONS(2813),
    [anon_sym_PROGMEM] = ACTIONS(2813),
    [aux_sym_primitive_type_token1] = ACTIONS(2813),
    [anon_sym_byte] = ACTIONS(2813),
    [anon_sym_word] = ACTIONS(2813),
    [anon_sym_enum] = ACTIONS(2813),
    [anon_sym_class] = ACTIONS(2813),
    [anon_sym_struct] = ACTIONS(2813),
    [anon_sym_union] = ACTIONS(2813),
    [anon_sym_if] = ACTIONS(2813),
    [anon_sym_switch] = ACTIONS(2813),
    [anon_sym_case] = ACTIONS(2813),
    [anon_sym_default] = ACTIONS(2813),
    [anon_sym_while] = ACTIONS(2813),
    [anon_sym_do] = ACTIONS(2813),
    [anon_sym_for] = ACTIONS(2813),
    [anon_sym_return] = ACTIONS(2813),
    [anon_sym_break] = ACTIONS(2813),
    [anon_sym_continue] = ACTIONS(2813),
    [anon_sym_goto] = ACTIONS(2813),
    [anon_sym_not] = ACTIONS(2813),
    [anon_sym_compl] = ACTIONS(2813),
    [anon_sym_DASH_DASH] = ACTIONS(2815),
    [anon_sym_PLUS_PLUS] = ACTIONS(2815),
    [anon_sym_sizeof] = ACTIONS(2813),
    [anon_sym___alignof__] = ACTIONS(2813),
    [anon_sym___alignof] = ACTIONS(2813),
    [anon_sym__alignof] = ACTIONS(2813),
    [anon_sym_alignof] = ACTIONS(2813),
    [anon_sym__Alignof] = ACTIONS(2813),
    [anon_sym_offsetof] = ACTIONS(2813),
    [anon_sym__Generic] = ACTIONS(2813),
    [anon_sym_asm] = ACTIONS(2813),
    [anon_sym___asm__] = ACTIONS(2813),
    [aux_sym_number_literal_token1] = ACTIONS(2815),
    [aux_sym_number_literal_token2] = ACTIONS(2813),
    [anon_sym_L_SQUOTE] = ACTIONS(2815),
    [anon_sym_u_SQUOTE] = ACTIONS(2815),
    [anon_sym_U_SQUOTE] = ACTIONS(2815),
    [anon_sym_u8_SQUOTE] = ACTIONS(2815),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_L_DQUOTE] = ACTIONS(2815),
    [anon_sym_u_DQUOTE] = ACTIONS(2815),
    [anon_sym_U_DQUOTE] = ACTIONS(2815),
    [anon_sym_u8_DQUOTE] = ACTIONS(2815),
    [anon_sym_DQUOTE] = ACTIONS(2815),
    [sym_true] = ACTIONS(2813),
    [sym_false] = ACTIONS(2813),
    [anon_sym_NULL] = ACTIONS(2813),
    [anon_sym_nullptr] = ACTIONS(2813),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2813),
    [anon_sym_decltype] = ACTIONS(2813),
    [anon_sym_virtual] = ACTIONS(2813),
    [anon_sym_alignas] = ACTIONS(2813),
    [anon_sym_explicit] = ACTIONS(2813),
    [anon_sym_typename] = ACTIONS(2813),
    [anon_sym_template] = ACTIONS(2813),
    [anon_sym_operator] = ACTIONS(2813),
    [anon_sym_try] = ACTIONS(2813),
    [anon_sym_delete] = ACTIONS(2813),
    [anon_sym_throw] = ACTIONS(2813),
    [anon_sym_namespace] = ACTIONS(2813),
    [anon_sym_using] = ACTIONS(2813),
    [anon_sym_static_assert] = ACTIONS(2813),
    [anon_sym_concept] = ACTIONS(2813),
    [anon_sym_co_return] = ACTIONS(2813),
    [anon_sym_co_yield] = ACTIONS(2813),
    [anon_sym_R_DQUOTE] = ACTIONS(2815),
    [anon_sym_LR_DQUOTE] = ACTIONS(2815),
    [anon_sym_uR_DQUOTE] = ACTIONS(2815),
    [anon_sym_UR_DQUOTE] = ACTIONS(2815),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2815),
    [anon_sym_co_await] = ACTIONS(2813),
    [anon_sym_new] = ACTIONS(2813),
    [anon_sym_requires] = ACTIONS(2813),
    [sym_this] = ACTIONS(2813),
  },
  [898] = {
    [ts_builtin_sym_end] = ACTIONS(2991),
    [sym_identifier] = ACTIONS(2989),
    [aux_sym_preproc_include_token1] = ACTIONS(2989),
    [aux_sym_preproc_def_token1] = ACTIONS(2989),
    [aux_sym_preproc_if_token1] = ACTIONS(2989),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2989),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2989),
    [sym_preproc_directive] = ACTIONS(2989),
    [anon_sym_LPAREN2] = ACTIONS(2991),
    [anon_sym_BANG] = ACTIONS(2991),
    [anon_sym_TILDE] = ACTIONS(2991),
    [anon_sym_DASH] = ACTIONS(2989),
    [anon_sym_PLUS] = ACTIONS(2989),
    [anon_sym_STAR] = ACTIONS(2991),
    [anon_sym_AMP_AMP] = ACTIONS(2991),
    [anon_sym_AMP] = ACTIONS(2989),
    [anon_sym___extension__] = ACTIONS(2989),
    [anon_sym_typedef] = ACTIONS(2989),
    [anon_sym_extern] = ACTIONS(2989),
    [anon_sym___attribute__] = ACTIONS(2989),
    [anon_sym_COLON_COLON] = ACTIONS(2991),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2991),
    [anon_sym___declspec] = ACTIONS(2989),
    [anon_sym___based] = ACTIONS(2989),
    [anon_sym___cdecl] = ACTIONS(2989),
    [anon_sym___clrcall] = ACTIONS(2989),
    [anon_sym___stdcall] = ACTIONS(2989),
    [anon_sym___fastcall] = ACTIONS(2989),
    [anon_sym___thiscall] = ACTIONS(2989),
    [anon_sym___vectorcall] = ACTIONS(2989),
    [anon_sym_LBRACE] = ACTIONS(2991),
    [anon_sym_signed] = ACTIONS(2989),
    [anon_sym_unsigned] = ACTIONS(2989),
    [anon_sym_long] = ACTIONS(2989),
    [anon_sym_short] = ACTIONS(2989),
    [anon_sym_LBRACK] = ACTIONS(2989),
    [anon_sym_static] = ACTIONS(2989),
    [anon_sym_register] = ACTIONS(2989),
    [anon_sym_inline] = ACTIONS(2989),
    [anon_sym___inline] = ACTIONS(2989),
    [anon_sym___inline__] = ACTIONS(2989),
    [anon_sym___forceinline] = ACTIONS(2989),
    [anon_sym_thread_local] = ACTIONS(2989),
    [anon_sym___thread] = ACTIONS(2989),
    [anon_sym_const] = ACTIONS(2989),
    [anon_sym_constexpr] = ACTIONS(2989),
    [anon_sym_volatile] = ACTIONS(2989),
    [anon_sym_restrict] = ACTIONS(2989),
    [anon_sym___restrict__] = ACTIONS(2989),
    [anon_sym__Atomic] = ACTIONS(2989),
    [anon_sym__Noreturn] = ACTIONS(2989),
    [anon_sym_noreturn] = ACTIONS(2989),
    [anon_sym_mutable] = ACTIONS(2989),
    [anon_sym_constinit] = ACTIONS(2989),
    [anon_sym_consteval] = ACTIONS(2989),
    [anon_sym_PROGMEM] = ACTIONS(2989),
    [aux_sym_primitive_type_token1] = ACTIONS(2989),
    [anon_sym_byte] = ACTIONS(2989),
    [anon_sym_word] = ACTIONS(2989),
    [anon_sym_enum] = ACTIONS(2989),
    [anon_sym_class] = ACTIONS(2989),
    [anon_sym_struct] = ACTIONS(2989),
    [anon_sym_union] = ACTIONS(2989),
    [anon_sym_if] = ACTIONS(2989),
    [anon_sym_switch] = ACTIONS(2989),
    [anon_sym_case] = ACTIONS(2989),
    [anon_sym_default] = ACTIONS(2989),
    [anon_sym_while] = ACTIONS(2989),
    [anon_sym_do] = ACTIONS(2989),
    [anon_sym_for] = ACTIONS(2989),
    [anon_sym_return] = ACTIONS(2989),
    [anon_sym_break] = ACTIONS(2989),
    [anon_sym_continue] = ACTIONS(2989),
    [anon_sym_goto] = ACTIONS(2989),
    [anon_sym_not] = ACTIONS(2989),
    [anon_sym_compl] = ACTIONS(2989),
    [anon_sym_DASH_DASH] = ACTIONS(2991),
    [anon_sym_PLUS_PLUS] = ACTIONS(2991),
    [anon_sym_sizeof] = ACTIONS(2989),
    [anon_sym___alignof__] = ACTIONS(2989),
    [anon_sym___alignof] = ACTIONS(2989),
    [anon_sym__alignof] = ACTIONS(2989),
    [anon_sym_alignof] = ACTIONS(2989),
    [anon_sym__Alignof] = ACTIONS(2989),
    [anon_sym_offsetof] = ACTIONS(2989),
    [anon_sym__Generic] = ACTIONS(2989),
    [anon_sym_asm] = ACTIONS(2989),
    [anon_sym___asm__] = ACTIONS(2989),
    [aux_sym_number_literal_token1] = ACTIONS(2991),
    [aux_sym_number_literal_token2] = ACTIONS(2989),
    [anon_sym_L_SQUOTE] = ACTIONS(2991),
    [anon_sym_u_SQUOTE] = ACTIONS(2991),
    [anon_sym_U_SQUOTE] = ACTIONS(2991),
    [anon_sym_u8_SQUOTE] = ACTIONS(2991),
    [anon_sym_SQUOTE] = ACTIONS(2991),
    [anon_sym_L_DQUOTE] = ACTIONS(2991),
    [anon_sym_u_DQUOTE] = ACTIONS(2991),
    [anon_sym_U_DQUOTE] = ACTIONS(2991),
    [anon_sym_u8_DQUOTE] = ACTIONS(2991),
    [anon_sym_DQUOTE] = ACTIONS(2991),
    [sym_true] = ACTIONS(2989),
    [sym_false] = ACTIONS(2989),
    [anon_sym_NULL] = ACTIONS(2989),
    [anon_sym_nullptr] = ACTIONS(2989),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2989),
    [anon_sym_decltype] = ACTIONS(2989),
    [anon_sym_virtual] = ACTIONS(2989),
    [anon_sym_alignas] = ACTIONS(2989),
    [anon_sym_explicit] = ACTIONS(2989),
    [anon_sym_typename] = ACTIONS(2989),
    [anon_sym_template] = ACTIONS(2989),
    [anon_sym_operator] = ACTIONS(2989),
    [anon_sym_try] = ACTIONS(2989),
    [anon_sym_delete] = ACTIONS(2989),
    [anon_sym_throw] = ACTIONS(2989),
    [anon_sym_namespace] = ACTIONS(2989),
    [anon_sym_using] = ACTIONS(2989),
    [anon_sym_static_assert] = ACTIONS(2989),
    [anon_sym_concept] = ACTIONS(2989),
    [anon_sym_co_return] = ACTIONS(2989),
    [anon_sym_co_yield] = ACTIONS(2989),
    [anon_sym_R_DQUOTE] = ACTIONS(2991),
    [anon_sym_LR_DQUOTE] = ACTIONS(2991),
    [anon_sym_uR_DQUOTE] = ACTIONS(2991),
    [anon_sym_UR_DQUOTE] = ACTIONS(2991),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2991),
    [anon_sym_co_await] = ACTIONS(2989),
    [anon_sym_new] = ACTIONS(2989),
    [anon_sym_requires] = ACTIONS(2989),
    [sym_this] = ACTIONS(2989),
  },
  [899] = {
    [ts_builtin_sym_end] = ACTIONS(3058),
    [sym_identifier] = ACTIONS(3056),
    [aux_sym_preproc_include_token1] = ACTIONS(3056),
    [aux_sym_preproc_def_token1] = ACTIONS(3056),
    [aux_sym_preproc_if_token1] = ACTIONS(3056),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3056),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3056),
    [sym_preproc_directive] = ACTIONS(3056),
    [anon_sym_LPAREN2] = ACTIONS(3058),
    [anon_sym_BANG] = ACTIONS(3058),
    [anon_sym_TILDE] = ACTIONS(3058),
    [anon_sym_DASH] = ACTIONS(3056),
    [anon_sym_PLUS] = ACTIONS(3056),
    [anon_sym_STAR] = ACTIONS(3058),
    [anon_sym_AMP_AMP] = ACTIONS(3058),
    [anon_sym_AMP] = ACTIONS(3056),
    [anon_sym___extension__] = ACTIONS(3056),
    [anon_sym_typedef] = ACTIONS(3056),
    [anon_sym_extern] = ACTIONS(3056),
    [anon_sym___attribute__] = ACTIONS(3056),
    [anon_sym_COLON_COLON] = ACTIONS(3058),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3058),
    [anon_sym___declspec] = ACTIONS(3056),
    [anon_sym___based] = ACTIONS(3056),
    [anon_sym___cdecl] = ACTIONS(3056),
    [anon_sym___clrcall] = ACTIONS(3056),
    [anon_sym___stdcall] = ACTIONS(3056),
    [anon_sym___fastcall] = ACTIONS(3056),
    [anon_sym___thiscall] = ACTIONS(3056),
    [anon_sym___vectorcall] = ACTIONS(3056),
    [anon_sym_LBRACE] = ACTIONS(3058),
    [anon_sym_signed] = ACTIONS(3056),
    [anon_sym_unsigned] = ACTIONS(3056),
    [anon_sym_long] = ACTIONS(3056),
    [anon_sym_short] = ACTIONS(3056),
    [anon_sym_LBRACK] = ACTIONS(3056),
    [anon_sym_static] = ACTIONS(3056),
    [anon_sym_register] = ACTIONS(3056),
    [anon_sym_inline] = ACTIONS(3056),
    [anon_sym___inline] = ACTIONS(3056),
    [anon_sym___inline__] = ACTIONS(3056),
    [anon_sym___forceinline] = ACTIONS(3056),
    [anon_sym_thread_local] = ACTIONS(3056),
    [anon_sym___thread] = ACTIONS(3056),
    [anon_sym_const] = ACTIONS(3056),
    [anon_sym_constexpr] = ACTIONS(3056),
    [anon_sym_volatile] = ACTIONS(3056),
    [anon_sym_restrict] = ACTIONS(3056),
    [anon_sym___restrict__] = ACTIONS(3056),
    [anon_sym__Atomic] = ACTIONS(3056),
    [anon_sym__Noreturn] = ACTIONS(3056),
    [anon_sym_noreturn] = ACTIONS(3056),
    [anon_sym_mutable] = ACTIONS(3056),
    [anon_sym_constinit] = ACTIONS(3056),
    [anon_sym_consteval] = ACTIONS(3056),
    [anon_sym_PROGMEM] = ACTIONS(3056),
    [aux_sym_primitive_type_token1] = ACTIONS(3056),
    [anon_sym_byte] = ACTIONS(3056),
    [anon_sym_word] = ACTIONS(3056),
    [anon_sym_enum] = ACTIONS(3056),
    [anon_sym_class] = ACTIONS(3056),
    [anon_sym_struct] = ACTIONS(3056),
    [anon_sym_union] = ACTIONS(3056),
    [anon_sym_if] = ACTIONS(3056),
    [anon_sym_switch] = ACTIONS(3056),
    [anon_sym_case] = ACTIONS(3056),
    [anon_sym_default] = ACTIONS(3056),
    [anon_sym_while] = ACTIONS(3056),
    [anon_sym_do] = ACTIONS(3056),
    [anon_sym_for] = ACTIONS(3056),
    [anon_sym_return] = ACTIONS(3056),
    [anon_sym_break] = ACTIONS(3056),
    [anon_sym_continue] = ACTIONS(3056),
    [anon_sym_goto] = ACTIONS(3056),
    [anon_sym_not] = ACTIONS(3056),
    [anon_sym_compl] = ACTIONS(3056),
    [anon_sym_DASH_DASH] = ACTIONS(3058),
    [anon_sym_PLUS_PLUS] = ACTIONS(3058),
    [anon_sym_sizeof] = ACTIONS(3056),
    [anon_sym___alignof__] = ACTIONS(3056),
    [anon_sym___alignof] = ACTIONS(3056),
    [anon_sym__alignof] = ACTIONS(3056),
    [anon_sym_alignof] = ACTIONS(3056),
    [anon_sym__Alignof] = ACTIONS(3056),
    [anon_sym_offsetof] = ACTIONS(3056),
    [anon_sym__Generic] = ACTIONS(3056),
    [anon_sym_asm] = ACTIONS(3056),
    [anon_sym___asm__] = ACTIONS(3056),
    [aux_sym_number_literal_token1] = ACTIONS(3058),
    [aux_sym_number_literal_token2] = ACTIONS(3056),
    [anon_sym_L_SQUOTE] = ACTIONS(3058),
    [anon_sym_u_SQUOTE] = ACTIONS(3058),
    [anon_sym_U_SQUOTE] = ACTIONS(3058),
    [anon_sym_u8_SQUOTE] = ACTIONS(3058),
    [anon_sym_SQUOTE] = ACTIONS(3058),
    [anon_sym_L_DQUOTE] = ACTIONS(3058),
    [anon_sym_u_DQUOTE] = ACTIONS(3058),
    [anon_sym_U_DQUOTE] = ACTIONS(3058),
    [anon_sym_u8_DQUOTE] = ACTIONS(3058),
    [anon_sym_DQUOTE] = ACTIONS(3058),
    [sym_true] = ACTIONS(3056),
    [sym_false] = ACTIONS(3056),
    [anon_sym_NULL] = ACTIONS(3056),
    [anon_sym_nullptr] = ACTIONS(3056),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3056),
    [anon_sym_decltype] = ACTIONS(3056),
    [anon_sym_virtual] = ACTIONS(3056),
    [anon_sym_alignas] = ACTIONS(3056),
    [anon_sym_explicit] = ACTIONS(3056),
    [anon_sym_typename] = ACTIONS(3056),
    [anon_sym_template] = ACTIONS(3056),
    [anon_sym_operator] = ACTIONS(3056),
    [anon_sym_try] = ACTIONS(3056),
    [anon_sym_delete] = ACTIONS(3056),
    [anon_sym_throw] = ACTIONS(3056),
    [anon_sym_namespace] = ACTIONS(3056),
    [anon_sym_using] = ACTIONS(3056),
    [anon_sym_static_assert] = ACTIONS(3056),
    [anon_sym_concept] = ACTIONS(3056),
    [anon_sym_co_return] = ACTIONS(3056),
    [anon_sym_co_yield] = ACTIONS(3056),
    [anon_sym_R_DQUOTE] = ACTIONS(3058),
    [anon_sym_LR_DQUOTE] = ACTIONS(3058),
    [anon_sym_uR_DQUOTE] = ACTIONS(3058),
    [anon_sym_UR_DQUOTE] = ACTIONS(3058),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3058),
    [anon_sym_co_await] = ACTIONS(3056),
    [anon_sym_new] = ACTIONS(3056),
    [anon_sym_requires] = ACTIONS(3056),
    [sym_this] = ACTIONS(3056),
  },
  [900] = {
    [ts_builtin_sym_end] = ACTIONS(2981),
    [sym_identifier] = ACTIONS(2979),
    [aux_sym_preproc_include_token1] = ACTIONS(2979),
    [aux_sym_preproc_def_token1] = ACTIONS(2979),
    [aux_sym_preproc_if_token1] = ACTIONS(2979),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2979),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2979),
    [sym_preproc_directive] = ACTIONS(2979),
    [anon_sym_LPAREN2] = ACTIONS(2981),
    [anon_sym_BANG] = ACTIONS(2981),
    [anon_sym_TILDE] = ACTIONS(2981),
    [anon_sym_DASH] = ACTIONS(2979),
    [anon_sym_PLUS] = ACTIONS(2979),
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(2981),
    [anon_sym_AMP] = ACTIONS(2979),
    [anon_sym___extension__] = ACTIONS(2979),
    [anon_sym_typedef] = ACTIONS(2979),
    [anon_sym_extern] = ACTIONS(2979),
    [anon_sym___attribute__] = ACTIONS(2979),
    [anon_sym_COLON_COLON] = ACTIONS(2981),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2981),
    [anon_sym___declspec] = ACTIONS(2979),
    [anon_sym___based] = ACTIONS(2979),
    [anon_sym___cdecl] = ACTIONS(2979),
    [anon_sym___clrcall] = ACTIONS(2979),
    [anon_sym___stdcall] = ACTIONS(2979),
    [anon_sym___fastcall] = ACTIONS(2979),
    [anon_sym___thiscall] = ACTIONS(2979),
    [anon_sym___vectorcall] = ACTIONS(2979),
    [anon_sym_LBRACE] = ACTIONS(2981),
    [anon_sym_signed] = ACTIONS(2979),
    [anon_sym_unsigned] = ACTIONS(2979),
    [anon_sym_long] = ACTIONS(2979),
    [anon_sym_short] = ACTIONS(2979),
    [anon_sym_LBRACK] = ACTIONS(2979),
    [anon_sym_static] = ACTIONS(2979),
    [anon_sym_register] = ACTIONS(2979),
    [anon_sym_inline] = ACTIONS(2979),
    [anon_sym___inline] = ACTIONS(2979),
    [anon_sym___inline__] = ACTIONS(2979),
    [anon_sym___forceinline] = ACTIONS(2979),
    [anon_sym_thread_local] = ACTIONS(2979),
    [anon_sym___thread] = ACTIONS(2979),
    [anon_sym_const] = ACTIONS(2979),
    [anon_sym_constexpr] = ACTIONS(2979),
    [anon_sym_volatile] = ACTIONS(2979),
    [anon_sym_restrict] = ACTIONS(2979),
    [anon_sym___restrict__] = ACTIONS(2979),
    [anon_sym__Atomic] = ACTIONS(2979),
    [anon_sym__Noreturn] = ACTIONS(2979),
    [anon_sym_noreturn] = ACTIONS(2979),
    [anon_sym_mutable] = ACTIONS(2979),
    [anon_sym_constinit] = ACTIONS(2979),
    [anon_sym_consteval] = ACTIONS(2979),
    [anon_sym_PROGMEM] = ACTIONS(2979),
    [aux_sym_primitive_type_token1] = ACTIONS(2979),
    [anon_sym_byte] = ACTIONS(2979),
    [anon_sym_word] = ACTIONS(2979),
    [anon_sym_enum] = ACTIONS(2979),
    [anon_sym_class] = ACTIONS(2979),
    [anon_sym_struct] = ACTIONS(2979),
    [anon_sym_union] = ACTIONS(2979),
    [anon_sym_if] = ACTIONS(2979),
    [anon_sym_switch] = ACTIONS(2979),
    [anon_sym_case] = ACTIONS(2979),
    [anon_sym_default] = ACTIONS(2979),
    [anon_sym_while] = ACTIONS(2979),
    [anon_sym_do] = ACTIONS(2979),
    [anon_sym_for] = ACTIONS(2979),
    [anon_sym_return] = ACTIONS(2979),
    [anon_sym_break] = ACTIONS(2979),
    [anon_sym_continue] = ACTIONS(2979),
    [anon_sym_goto] = ACTIONS(2979),
    [anon_sym_not] = ACTIONS(2979),
    [anon_sym_compl] = ACTIONS(2979),
    [anon_sym_DASH_DASH] = ACTIONS(2981),
    [anon_sym_PLUS_PLUS] = ACTIONS(2981),
    [anon_sym_sizeof] = ACTIONS(2979),
    [anon_sym___alignof__] = ACTIONS(2979),
    [anon_sym___alignof] = ACTIONS(2979),
    [anon_sym__alignof] = ACTIONS(2979),
    [anon_sym_alignof] = ACTIONS(2979),
    [anon_sym__Alignof] = ACTIONS(2979),
    [anon_sym_offsetof] = ACTIONS(2979),
    [anon_sym__Generic] = ACTIONS(2979),
    [anon_sym_asm] = ACTIONS(2979),
    [anon_sym___asm__] = ACTIONS(2979),
    [aux_sym_number_literal_token1] = ACTIONS(2981),
    [aux_sym_number_literal_token2] = ACTIONS(2979),
    [anon_sym_L_SQUOTE] = ACTIONS(2981),
    [anon_sym_u_SQUOTE] = ACTIONS(2981),
    [anon_sym_U_SQUOTE] = ACTIONS(2981),
    [anon_sym_u8_SQUOTE] = ACTIONS(2981),
    [anon_sym_SQUOTE] = ACTIONS(2981),
    [anon_sym_L_DQUOTE] = ACTIONS(2981),
    [anon_sym_u_DQUOTE] = ACTIONS(2981),
    [anon_sym_U_DQUOTE] = ACTIONS(2981),
    [anon_sym_u8_DQUOTE] = ACTIONS(2981),
    [anon_sym_DQUOTE] = ACTIONS(2981),
    [sym_true] = ACTIONS(2979),
    [sym_false] = ACTIONS(2979),
    [anon_sym_NULL] = ACTIONS(2979),
    [anon_sym_nullptr] = ACTIONS(2979),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2979),
    [anon_sym_decltype] = ACTIONS(2979),
    [anon_sym_virtual] = ACTIONS(2979),
    [anon_sym_alignas] = ACTIONS(2979),
    [anon_sym_explicit] = ACTIONS(2979),
    [anon_sym_typename] = ACTIONS(2979),
    [anon_sym_template] = ACTIONS(2979),
    [anon_sym_operator] = ACTIONS(2979),
    [anon_sym_try] = ACTIONS(2979),
    [anon_sym_delete] = ACTIONS(2979),
    [anon_sym_throw] = ACTIONS(2979),
    [anon_sym_namespace] = ACTIONS(2979),
    [anon_sym_using] = ACTIONS(2979),
    [anon_sym_static_assert] = ACTIONS(2979),
    [anon_sym_concept] = ACTIONS(2979),
    [anon_sym_co_return] = ACTIONS(2979),
    [anon_sym_co_yield] = ACTIONS(2979),
    [anon_sym_R_DQUOTE] = ACTIONS(2981),
    [anon_sym_LR_DQUOTE] = ACTIONS(2981),
    [anon_sym_uR_DQUOTE] = ACTIONS(2981),
    [anon_sym_UR_DQUOTE] = ACTIONS(2981),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2981),
    [anon_sym_co_await] = ACTIONS(2979),
    [anon_sym_new] = ACTIONS(2979),
    [anon_sym_requires] = ACTIONS(2979),
    [sym_this] = ACTIONS(2979),
  },
  [901] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4489),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3679),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3679),
    [sym_call_expression] = STATE(3679),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3679),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3679),
    [sym_initializer_list] = STATE(3905),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3679),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3679),
    [sym_identifier] = ACTIONS(3538),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1885),
    [anon_sym_COMMA] = ACTIONS(1885),
    [anon_sym_LPAREN2] = ACTIONS(1885),
    [anon_sym_BANG] = ACTIONS(3540),
    [anon_sym_TILDE] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(1883),
    [anon_sym_PLUS] = ACTIONS(1883),
    [anon_sym_STAR] = ACTIONS(1885),
    [anon_sym_SLASH] = ACTIONS(1883),
    [anon_sym_PERCENT] = ACTIONS(1885),
    [anon_sym_PIPE_PIPE] = ACTIONS(1885),
    [anon_sym_AMP_AMP] = ACTIONS(1885),
    [anon_sym_PIPE] = ACTIONS(1883),
    [anon_sym_CARET] = ACTIONS(1885),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym_EQ_EQ] = ACTIONS(1885),
    [anon_sym_BANG_EQ] = ACTIONS(1885),
    [anon_sym_GT] = ACTIONS(1883),
    [anon_sym_GT_EQ] = ACTIONS(1885),
    [anon_sym_LT_EQ] = ACTIONS(1883),
    [anon_sym_LT] = ACTIONS(1883),
    [anon_sym_LT_LT] = ACTIONS(1885),
    [anon_sym_GT_GT] = ACTIONS(1885),
    [anon_sym_COLON_COLON] = ACTIONS(3544),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(1885),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_COLON] = ACTIONS(1883),
    [anon_sym_QMARK] = ACTIONS(1885),
    [anon_sym_not] = ACTIONS(3540),
    [anon_sym_compl] = ACTIONS(3540),
    [anon_sym_LT_EQ_GT] = ACTIONS(1885),
    [anon_sym_or] = ACTIONS(1883),
    [anon_sym_and] = ACTIONS(1883),
    [anon_sym_bitor] = ACTIONS(1883),
    [anon_sym_xor] = ACTIONS(1883),
    [anon_sym_bitand] = ACTIONS(1883),
    [anon_sym_not_eq] = ACTIONS(1883),
    [anon_sym_DASH_DASH] = ACTIONS(1885),
    [anon_sym_PLUS_PLUS] = ACTIONS(1885),
    [anon_sym_sizeof] = ACTIONS(3546),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(1883),
    [anon_sym_DOT_STAR] = ACTIONS(1885),
    [anon_sym_DASH_GT] = ACTIONS(1885),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3548),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3550),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [902] = {
    [sym_preproc_def] = STATE(883),
    [sym_preproc_function_def] = STATE(883),
    [sym_preproc_call] = STATE(883),
    [sym_preproc_if_in_field_declaration_list] = STATE(883),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(883),
    [sym_type_definition] = STATE(883),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(5536),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(3150),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6010),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym__field_declaration_list_item] = STATE(883),
    [sym_field_declaration] = STATE(883),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1811),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(883),
    [sym_operator_cast] = STATE(6536),
    [sym_inline_method_definition] = STATE(883),
    [sym__constructor_specifiers] = STATE(1811),
    [sym_operator_cast_definition] = STATE(883),
    [sym_operator_cast_declaration] = STATE(883),
    [sym_constructor_or_destructor_definition] = STATE(883),
    [sym_constructor_or_destructor_declaration] = STATE(883),
    [sym_friend_declaration] = STATE(883),
    [sym_access_specifier] = STATE(7802),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(2618),
    [sym_template_function] = STATE(6098),
    [sym_using_declaration] = STATE(883),
    [sym_alias_declaration] = STATE(883),
    [sym_static_assert_declaration] = STATE(883),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5301),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_qualified_operator_cast_identifier] = STATE(6536),
    [sym_operator_name] = STATE(6098),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(883),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1961),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1811),
    [sym_identifier] = ACTIONS(2823),
    [aux_sym_preproc_def_token1] = ACTIONS(3364),
    [aux_sym_preproc_if_token1] = ACTIONS(3366),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3368),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3368),
    [sym_preproc_directive] = ACTIONS(3370),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(3372),
    [anon_sym_typedef] = ACTIONS(3374),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(2853),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_RBRACE] = ACTIONS(3552),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2857),
    [anon_sym_class] = ACTIONS(2859),
    [anon_sym_struct] = ACTIONS(2861),
    [anon_sym_union] = ACTIONS(2863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(2865),
    [anon_sym_template] = ACTIONS(3378),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3380),
    [anon_sym_public] = ACTIONS(2871),
    [anon_sym_private] = ACTIONS(2871),
    [anon_sym_protected] = ACTIONS(2871),
    [anon_sym_using] = ACTIONS(3382),
    [anon_sym_static_assert] = ACTIONS(3384),
  },
  [903] = {
    [ts_builtin_sym_end] = ACTIONS(3554),
    [sym_identifier] = ACTIONS(3556),
    [aux_sym_preproc_include_token1] = ACTIONS(3556),
    [aux_sym_preproc_def_token1] = ACTIONS(3556),
    [aux_sym_preproc_if_token1] = ACTIONS(3556),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3556),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3556),
    [sym_preproc_directive] = ACTIONS(3556),
    [anon_sym_LPAREN2] = ACTIONS(3554),
    [anon_sym_BANG] = ACTIONS(3554),
    [anon_sym_TILDE] = ACTIONS(3554),
    [anon_sym_DASH] = ACTIONS(3556),
    [anon_sym_PLUS] = ACTIONS(3556),
    [anon_sym_STAR] = ACTIONS(3554),
    [anon_sym_AMP_AMP] = ACTIONS(3554),
    [anon_sym_AMP] = ACTIONS(3556),
    [anon_sym___extension__] = ACTIONS(3556),
    [anon_sym_typedef] = ACTIONS(3556),
    [anon_sym_extern] = ACTIONS(3556),
    [anon_sym___attribute__] = ACTIONS(3556),
    [anon_sym_COLON_COLON] = ACTIONS(3554),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3554),
    [anon_sym___declspec] = ACTIONS(3556),
    [anon_sym___based] = ACTIONS(3556),
    [anon_sym___cdecl] = ACTIONS(3556),
    [anon_sym___clrcall] = ACTIONS(3556),
    [anon_sym___stdcall] = ACTIONS(3556),
    [anon_sym___fastcall] = ACTIONS(3556),
    [anon_sym___thiscall] = ACTIONS(3556),
    [anon_sym___vectorcall] = ACTIONS(3556),
    [anon_sym_LBRACE] = ACTIONS(3554),
    [anon_sym_signed] = ACTIONS(3556),
    [anon_sym_unsigned] = ACTIONS(3556),
    [anon_sym_long] = ACTIONS(3556),
    [anon_sym_short] = ACTIONS(3556),
    [anon_sym_LBRACK] = ACTIONS(3556),
    [anon_sym_static] = ACTIONS(3556),
    [anon_sym_register] = ACTIONS(3556),
    [anon_sym_inline] = ACTIONS(3556),
    [anon_sym___inline] = ACTIONS(3556),
    [anon_sym___inline__] = ACTIONS(3556),
    [anon_sym___forceinline] = ACTIONS(3556),
    [anon_sym_thread_local] = ACTIONS(3556),
    [anon_sym___thread] = ACTIONS(3556),
    [anon_sym_const] = ACTIONS(3556),
    [anon_sym_constexpr] = ACTIONS(3556),
    [anon_sym_volatile] = ACTIONS(3556),
    [anon_sym_restrict] = ACTIONS(3556),
    [anon_sym___restrict__] = ACTIONS(3556),
    [anon_sym__Atomic] = ACTIONS(3556),
    [anon_sym__Noreturn] = ACTIONS(3556),
    [anon_sym_noreturn] = ACTIONS(3556),
    [anon_sym_mutable] = ACTIONS(3556),
    [anon_sym_constinit] = ACTIONS(3556),
    [anon_sym_consteval] = ACTIONS(3556),
    [anon_sym_PROGMEM] = ACTIONS(3556),
    [aux_sym_primitive_type_token1] = ACTIONS(3556),
    [anon_sym_byte] = ACTIONS(3556),
    [anon_sym_word] = ACTIONS(3556),
    [anon_sym_enum] = ACTIONS(3556),
    [anon_sym_class] = ACTIONS(3556),
    [anon_sym_struct] = ACTIONS(3556),
    [anon_sym_union] = ACTIONS(3556),
    [anon_sym_if] = ACTIONS(3556),
    [anon_sym_switch] = ACTIONS(3556),
    [anon_sym_case] = ACTIONS(3556),
    [anon_sym_default] = ACTIONS(3556),
    [anon_sym_while] = ACTIONS(3556),
    [anon_sym_do] = ACTIONS(3556),
    [anon_sym_for] = ACTIONS(3556),
    [anon_sym_return] = ACTIONS(3556),
    [anon_sym_break] = ACTIONS(3556),
    [anon_sym_continue] = ACTIONS(3556),
    [anon_sym_goto] = ACTIONS(3556),
    [anon_sym_not] = ACTIONS(3556),
    [anon_sym_compl] = ACTIONS(3556),
    [anon_sym_DASH_DASH] = ACTIONS(3554),
    [anon_sym_PLUS_PLUS] = ACTIONS(3554),
    [anon_sym_sizeof] = ACTIONS(3556),
    [anon_sym___alignof__] = ACTIONS(3556),
    [anon_sym___alignof] = ACTIONS(3556),
    [anon_sym__alignof] = ACTIONS(3556),
    [anon_sym_alignof] = ACTIONS(3556),
    [anon_sym__Alignof] = ACTIONS(3556),
    [anon_sym_offsetof] = ACTIONS(3556),
    [anon_sym__Generic] = ACTIONS(3556),
    [anon_sym_asm] = ACTIONS(3556),
    [anon_sym___asm__] = ACTIONS(3556),
    [aux_sym_number_literal_token1] = ACTIONS(3554),
    [aux_sym_number_literal_token2] = ACTIONS(3556),
    [anon_sym_L_SQUOTE] = ACTIONS(3554),
    [anon_sym_u_SQUOTE] = ACTIONS(3554),
    [anon_sym_U_SQUOTE] = ACTIONS(3554),
    [anon_sym_u8_SQUOTE] = ACTIONS(3554),
    [anon_sym_SQUOTE] = ACTIONS(3554),
    [anon_sym_L_DQUOTE] = ACTIONS(3554),
    [anon_sym_u_DQUOTE] = ACTIONS(3554),
    [anon_sym_U_DQUOTE] = ACTIONS(3554),
    [anon_sym_u8_DQUOTE] = ACTIONS(3554),
    [anon_sym_DQUOTE] = ACTIONS(3554),
    [sym_true] = ACTIONS(3556),
    [sym_false] = ACTIONS(3556),
    [anon_sym_NULL] = ACTIONS(3556),
    [anon_sym_nullptr] = ACTIONS(3556),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3556),
    [anon_sym_decltype] = ACTIONS(3556),
    [anon_sym_virtual] = ACTIONS(3556),
    [anon_sym_alignas] = ACTIONS(3556),
    [anon_sym_explicit] = ACTIONS(3556),
    [anon_sym_typename] = ACTIONS(3556),
    [anon_sym_template] = ACTIONS(3556),
    [anon_sym_operator] = ACTIONS(3556),
    [anon_sym_try] = ACTIONS(3556),
    [anon_sym_delete] = ACTIONS(3556),
    [anon_sym_throw] = ACTIONS(3556),
    [anon_sym_namespace] = ACTIONS(3556),
    [anon_sym_using] = ACTIONS(3556),
    [anon_sym_static_assert] = ACTIONS(3556),
    [anon_sym_concept] = ACTIONS(3556),
    [anon_sym_co_return] = ACTIONS(3556),
    [anon_sym_co_yield] = ACTIONS(3556),
    [anon_sym_R_DQUOTE] = ACTIONS(3554),
    [anon_sym_LR_DQUOTE] = ACTIONS(3554),
    [anon_sym_uR_DQUOTE] = ACTIONS(3554),
    [anon_sym_UR_DQUOTE] = ACTIONS(3554),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3554),
    [anon_sym_co_await] = ACTIONS(3556),
    [anon_sym_new] = ACTIONS(3556),
    [anon_sym_requires] = ACTIONS(3556),
    [sym_this] = ACTIONS(3556),
  },
  [904] = {
    [sym_preproc_def] = STATE(842),
    [sym_preproc_function_def] = STATE(842),
    [sym_preproc_call] = STATE(842),
    [sym_preproc_if_in_field_declaration_list] = STATE(842),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(842),
    [sym_type_definition] = STATE(842),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(5536),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(3150),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6010),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym__field_declaration_list_item] = STATE(842),
    [sym_field_declaration] = STATE(842),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1811),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(842),
    [sym_operator_cast] = STATE(6536),
    [sym_inline_method_definition] = STATE(842),
    [sym__constructor_specifiers] = STATE(1811),
    [sym_operator_cast_definition] = STATE(842),
    [sym_operator_cast_declaration] = STATE(842),
    [sym_constructor_or_destructor_definition] = STATE(842),
    [sym_constructor_or_destructor_declaration] = STATE(842),
    [sym_friend_declaration] = STATE(842),
    [sym_access_specifier] = STATE(7802),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(2618),
    [sym_template_function] = STATE(6098),
    [sym_using_declaration] = STATE(842),
    [sym_alias_declaration] = STATE(842),
    [sym_static_assert_declaration] = STATE(842),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5301),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_qualified_operator_cast_identifier] = STATE(6536),
    [sym_operator_name] = STATE(6098),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(842),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1961),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1811),
    [sym_identifier] = ACTIONS(2823),
    [aux_sym_preproc_def_token1] = ACTIONS(3364),
    [aux_sym_preproc_if_token1] = ACTIONS(3366),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3368),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3368),
    [sym_preproc_directive] = ACTIONS(3370),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(3372),
    [anon_sym_typedef] = ACTIONS(3374),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(2853),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_RBRACE] = ACTIONS(3558),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2857),
    [anon_sym_class] = ACTIONS(2859),
    [anon_sym_struct] = ACTIONS(2861),
    [anon_sym_union] = ACTIONS(2863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(2865),
    [anon_sym_template] = ACTIONS(3378),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3380),
    [anon_sym_public] = ACTIONS(2871),
    [anon_sym_private] = ACTIONS(2871),
    [anon_sym_protected] = ACTIONS(2871),
    [anon_sym_using] = ACTIONS(3382),
    [anon_sym_static_assert] = ACTIONS(3384),
  },
  [905] = {
    [ts_builtin_sym_end] = ACTIONS(2969),
    [sym_identifier] = ACTIONS(2967),
    [aux_sym_preproc_include_token1] = ACTIONS(2967),
    [aux_sym_preproc_def_token1] = ACTIONS(2967),
    [aux_sym_preproc_if_token1] = ACTIONS(2967),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2967),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2967),
    [sym_preproc_directive] = ACTIONS(2967),
    [anon_sym_LPAREN2] = ACTIONS(2969),
    [anon_sym_BANG] = ACTIONS(2969),
    [anon_sym_TILDE] = ACTIONS(2969),
    [anon_sym_DASH] = ACTIONS(2967),
    [anon_sym_PLUS] = ACTIONS(2967),
    [anon_sym_STAR] = ACTIONS(2969),
    [anon_sym_AMP_AMP] = ACTIONS(2969),
    [anon_sym_AMP] = ACTIONS(2967),
    [anon_sym___extension__] = ACTIONS(2967),
    [anon_sym_typedef] = ACTIONS(2967),
    [anon_sym_extern] = ACTIONS(2967),
    [anon_sym___attribute__] = ACTIONS(2967),
    [anon_sym_COLON_COLON] = ACTIONS(2969),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2969),
    [anon_sym___declspec] = ACTIONS(2967),
    [anon_sym___based] = ACTIONS(2967),
    [anon_sym___cdecl] = ACTIONS(2967),
    [anon_sym___clrcall] = ACTIONS(2967),
    [anon_sym___stdcall] = ACTIONS(2967),
    [anon_sym___fastcall] = ACTIONS(2967),
    [anon_sym___thiscall] = ACTIONS(2967),
    [anon_sym___vectorcall] = ACTIONS(2967),
    [anon_sym_LBRACE] = ACTIONS(2969),
    [anon_sym_signed] = ACTIONS(2967),
    [anon_sym_unsigned] = ACTIONS(2967),
    [anon_sym_long] = ACTIONS(2967),
    [anon_sym_short] = ACTIONS(2967),
    [anon_sym_LBRACK] = ACTIONS(2967),
    [anon_sym_static] = ACTIONS(2967),
    [anon_sym_register] = ACTIONS(2967),
    [anon_sym_inline] = ACTIONS(2967),
    [anon_sym___inline] = ACTIONS(2967),
    [anon_sym___inline__] = ACTIONS(2967),
    [anon_sym___forceinline] = ACTIONS(2967),
    [anon_sym_thread_local] = ACTIONS(2967),
    [anon_sym___thread] = ACTIONS(2967),
    [anon_sym_const] = ACTIONS(2967),
    [anon_sym_constexpr] = ACTIONS(2967),
    [anon_sym_volatile] = ACTIONS(2967),
    [anon_sym_restrict] = ACTIONS(2967),
    [anon_sym___restrict__] = ACTIONS(2967),
    [anon_sym__Atomic] = ACTIONS(2967),
    [anon_sym__Noreturn] = ACTIONS(2967),
    [anon_sym_noreturn] = ACTIONS(2967),
    [anon_sym_mutable] = ACTIONS(2967),
    [anon_sym_constinit] = ACTIONS(2967),
    [anon_sym_consteval] = ACTIONS(2967),
    [anon_sym_PROGMEM] = ACTIONS(2967),
    [aux_sym_primitive_type_token1] = ACTIONS(2967),
    [anon_sym_byte] = ACTIONS(2967),
    [anon_sym_word] = ACTIONS(2967),
    [anon_sym_enum] = ACTIONS(2967),
    [anon_sym_class] = ACTIONS(2967),
    [anon_sym_struct] = ACTIONS(2967),
    [anon_sym_union] = ACTIONS(2967),
    [anon_sym_if] = ACTIONS(2967),
    [anon_sym_switch] = ACTIONS(2967),
    [anon_sym_case] = ACTIONS(2967),
    [anon_sym_default] = ACTIONS(2967),
    [anon_sym_while] = ACTIONS(2967),
    [anon_sym_do] = ACTIONS(2967),
    [anon_sym_for] = ACTIONS(2967),
    [anon_sym_return] = ACTIONS(2967),
    [anon_sym_break] = ACTIONS(2967),
    [anon_sym_continue] = ACTIONS(2967),
    [anon_sym_goto] = ACTIONS(2967),
    [anon_sym_not] = ACTIONS(2967),
    [anon_sym_compl] = ACTIONS(2967),
    [anon_sym_DASH_DASH] = ACTIONS(2969),
    [anon_sym_PLUS_PLUS] = ACTIONS(2969),
    [anon_sym_sizeof] = ACTIONS(2967),
    [anon_sym___alignof__] = ACTIONS(2967),
    [anon_sym___alignof] = ACTIONS(2967),
    [anon_sym__alignof] = ACTIONS(2967),
    [anon_sym_alignof] = ACTIONS(2967),
    [anon_sym__Alignof] = ACTIONS(2967),
    [anon_sym_offsetof] = ACTIONS(2967),
    [anon_sym__Generic] = ACTIONS(2967),
    [anon_sym_asm] = ACTIONS(2967),
    [anon_sym___asm__] = ACTIONS(2967),
    [aux_sym_number_literal_token1] = ACTIONS(2969),
    [aux_sym_number_literal_token2] = ACTIONS(2967),
    [anon_sym_L_SQUOTE] = ACTIONS(2969),
    [anon_sym_u_SQUOTE] = ACTIONS(2969),
    [anon_sym_U_SQUOTE] = ACTIONS(2969),
    [anon_sym_u8_SQUOTE] = ACTIONS(2969),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_L_DQUOTE] = ACTIONS(2969),
    [anon_sym_u_DQUOTE] = ACTIONS(2969),
    [anon_sym_U_DQUOTE] = ACTIONS(2969),
    [anon_sym_u8_DQUOTE] = ACTIONS(2969),
    [anon_sym_DQUOTE] = ACTIONS(2969),
    [sym_true] = ACTIONS(2967),
    [sym_false] = ACTIONS(2967),
    [anon_sym_NULL] = ACTIONS(2967),
    [anon_sym_nullptr] = ACTIONS(2967),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2967),
    [anon_sym_decltype] = ACTIONS(2967),
    [anon_sym_virtual] = ACTIONS(2967),
    [anon_sym_alignas] = ACTIONS(2967),
    [anon_sym_explicit] = ACTIONS(2967),
    [anon_sym_typename] = ACTIONS(2967),
    [anon_sym_template] = ACTIONS(2967),
    [anon_sym_operator] = ACTIONS(2967),
    [anon_sym_try] = ACTIONS(2967),
    [anon_sym_delete] = ACTIONS(2967),
    [anon_sym_throw] = ACTIONS(2967),
    [anon_sym_namespace] = ACTIONS(2967),
    [anon_sym_using] = ACTIONS(2967),
    [anon_sym_static_assert] = ACTIONS(2967),
    [anon_sym_concept] = ACTIONS(2967),
    [anon_sym_co_return] = ACTIONS(2967),
    [anon_sym_co_yield] = ACTIONS(2967),
    [anon_sym_R_DQUOTE] = ACTIONS(2969),
    [anon_sym_LR_DQUOTE] = ACTIONS(2969),
    [anon_sym_uR_DQUOTE] = ACTIONS(2969),
    [anon_sym_UR_DQUOTE] = ACTIONS(2969),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2969),
    [anon_sym_co_await] = ACTIONS(2967),
    [anon_sym_new] = ACTIONS(2967),
    [anon_sym_requires] = ACTIONS(2967),
    [sym_this] = ACTIONS(2967),
  },
  [906] = {
    [ts_builtin_sym_end] = ACTIONS(3066),
    [sym_identifier] = ACTIONS(3064),
    [aux_sym_preproc_include_token1] = ACTIONS(3064),
    [aux_sym_preproc_def_token1] = ACTIONS(3064),
    [aux_sym_preproc_if_token1] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3064),
    [sym_preproc_directive] = ACTIONS(3064),
    [anon_sym_LPAREN2] = ACTIONS(3066),
    [anon_sym_BANG] = ACTIONS(3066),
    [anon_sym_TILDE] = ACTIONS(3066),
    [anon_sym_DASH] = ACTIONS(3064),
    [anon_sym_PLUS] = ACTIONS(3064),
    [anon_sym_STAR] = ACTIONS(3066),
    [anon_sym_AMP_AMP] = ACTIONS(3066),
    [anon_sym_AMP] = ACTIONS(3064),
    [anon_sym___extension__] = ACTIONS(3064),
    [anon_sym_typedef] = ACTIONS(3064),
    [anon_sym_extern] = ACTIONS(3064),
    [anon_sym___attribute__] = ACTIONS(3064),
    [anon_sym_COLON_COLON] = ACTIONS(3066),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3066),
    [anon_sym___declspec] = ACTIONS(3064),
    [anon_sym___based] = ACTIONS(3064),
    [anon_sym___cdecl] = ACTIONS(3064),
    [anon_sym___clrcall] = ACTIONS(3064),
    [anon_sym___stdcall] = ACTIONS(3064),
    [anon_sym___fastcall] = ACTIONS(3064),
    [anon_sym___thiscall] = ACTIONS(3064),
    [anon_sym___vectorcall] = ACTIONS(3064),
    [anon_sym_LBRACE] = ACTIONS(3066),
    [anon_sym_signed] = ACTIONS(3064),
    [anon_sym_unsigned] = ACTIONS(3064),
    [anon_sym_long] = ACTIONS(3064),
    [anon_sym_short] = ACTIONS(3064),
    [anon_sym_LBRACK] = ACTIONS(3064),
    [anon_sym_static] = ACTIONS(3064),
    [anon_sym_register] = ACTIONS(3064),
    [anon_sym_inline] = ACTIONS(3064),
    [anon_sym___inline] = ACTIONS(3064),
    [anon_sym___inline__] = ACTIONS(3064),
    [anon_sym___forceinline] = ACTIONS(3064),
    [anon_sym_thread_local] = ACTIONS(3064),
    [anon_sym___thread] = ACTIONS(3064),
    [anon_sym_const] = ACTIONS(3064),
    [anon_sym_constexpr] = ACTIONS(3064),
    [anon_sym_volatile] = ACTIONS(3064),
    [anon_sym_restrict] = ACTIONS(3064),
    [anon_sym___restrict__] = ACTIONS(3064),
    [anon_sym__Atomic] = ACTIONS(3064),
    [anon_sym__Noreturn] = ACTIONS(3064),
    [anon_sym_noreturn] = ACTIONS(3064),
    [anon_sym_mutable] = ACTIONS(3064),
    [anon_sym_constinit] = ACTIONS(3064),
    [anon_sym_consteval] = ACTIONS(3064),
    [anon_sym_PROGMEM] = ACTIONS(3064),
    [aux_sym_primitive_type_token1] = ACTIONS(3064),
    [anon_sym_byte] = ACTIONS(3064),
    [anon_sym_word] = ACTIONS(3064),
    [anon_sym_enum] = ACTIONS(3064),
    [anon_sym_class] = ACTIONS(3064),
    [anon_sym_struct] = ACTIONS(3064),
    [anon_sym_union] = ACTIONS(3064),
    [anon_sym_if] = ACTIONS(3064),
    [anon_sym_switch] = ACTIONS(3064),
    [anon_sym_case] = ACTIONS(3064),
    [anon_sym_default] = ACTIONS(3064),
    [anon_sym_while] = ACTIONS(3064),
    [anon_sym_do] = ACTIONS(3064),
    [anon_sym_for] = ACTIONS(3064),
    [anon_sym_return] = ACTIONS(3064),
    [anon_sym_break] = ACTIONS(3064),
    [anon_sym_continue] = ACTIONS(3064),
    [anon_sym_goto] = ACTIONS(3064),
    [anon_sym_not] = ACTIONS(3064),
    [anon_sym_compl] = ACTIONS(3064),
    [anon_sym_DASH_DASH] = ACTIONS(3066),
    [anon_sym_PLUS_PLUS] = ACTIONS(3066),
    [anon_sym_sizeof] = ACTIONS(3064),
    [anon_sym___alignof__] = ACTIONS(3064),
    [anon_sym___alignof] = ACTIONS(3064),
    [anon_sym__alignof] = ACTIONS(3064),
    [anon_sym_alignof] = ACTIONS(3064),
    [anon_sym__Alignof] = ACTIONS(3064),
    [anon_sym_offsetof] = ACTIONS(3064),
    [anon_sym__Generic] = ACTIONS(3064),
    [anon_sym_asm] = ACTIONS(3064),
    [anon_sym___asm__] = ACTIONS(3064),
    [aux_sym_number_literal_token1] = ACTIONS(3066),
    [aux_sym_number_literal_token2] = ACTIONS(3064),
    [anon_sym_L_SQUOTE] = ACTIONS(3066),
    [anon_sym_u_SQUOTE] = ACTIONS(3066),
    [anon_sym_U_SQUOTE] = ACTIONS(3066),
    [anon_sym_u8_SQUOTE] = ACTIONS(3066),
    [anon_sym_SQUOTE] = ACTIONS(3066),
    [anon_sym_L_DQUOTE] = ACTIONS(3066),
    [anon_sym_u_DQUOTE] = ACTIONS(3066),
    [anon_sym_U_DQUOTE] = ACTIONS(3066),
    [anon_sym_u8_DQUOTE] = ACTIONS(3066),
    [anon_sym_DQUOTE] = ACTIONS(3066),
    [sym_true] = ACTIONS(3064),
    [sym_false] = ACTIONS(3064),
    [anon_sym_NULL] = ACTIONS(3064),
    [anon_sym_nullptr] = ACTIONS(3064),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3064),
    [anon_sym_decltype] = ACTIONS(3064),
    [anon_sym_virtual] = ACTIONS(3064),
    [anon_sym_alignas] = ACTIONS(3064),
    [anon_sym_explicit] = ACTIONS(3064),
    [anon_sym_typename] = ACTIONS(3064),
    [anon_sym_template] = ACTIONS(3064),
    [anon_sym_operator] = ACTIONS(3064),
    [anon_sym_try] = ACTIONS(3064),
    [anon_sym_delete] = ACTIONS(3064),
    [anon_sym_throw] = ACTIONS(3064),
    [anon_sym_namespace] = ACTIONS(3064),
    [anon_sym_using] = ACTIONS(3064),
    [anon_sym_static_assert] = ACTIONS(3064),
    [anon_sym_concept] = ACTIONS(3064),
    [anon_sym_co_return] = ACTIONS(3064),
    [anon_sym_co_yield] = ACTIONS(3064),
    [anon_sym_R_DQUOTE] = ACTIONS(3066),
    [anon_sym_LR_DQUOTE] = ACTIONS(3066),
    [anon_sym_uR_DQUOTE] = ACTIONS(3066),
    [anon_sym_UR_DQUOTE] = ACTIONS(3066),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3066),
    [anon_sym_co_await] = ACTIONS(3064),
    [anon_sym_new] = ACTIONS(3064),
    [anon_sym_requires] = ACTIONS(3064),
    [sym_this] = ACTIONS(3064),
  },
  [907] = {
    [ts_builtin_sym_end] = ACTIONS(3154),
    [sym_identifier] = ACTIONS(3152),
    [aux_sym_preproc_include_token1] = ACTIONS(3152),
    [aux_sym_preproc_def_token1] = ACTIONS(3152),
    [aux_sym_preproc_if_token1] = ACTIONS(3152),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3152),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3152),
    [sym_preproc_directive] = ACTIONS(3152),
    [anon_sym_LPAREN2] = ACTIONS(3154),
    [anon_sym_BANG] = ACTIONS(3154),
    [anon_sym_TILDE] = ACTIONS(3154),
    [anon_sym_DASH] = ACTIONS(3152),
    [anon_sym_PLUS] = ACTIONS(3152),
    [anon_sym_STAR] = ACTIONS(3154),
    [anon_sym_AMP_AMP] = ACTIONS(3154),
    [anon_sym_AMP] = ACTIONS(3152),
    [anon_sym___extension__] = ACTIONS(3152),
    [anon_sym_typedef] = ACTIONS(3152),
    [anon_sym_extern] = ACTIONS(3152),
    [anon_sym___attribute__] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3154),
    [anon_sym___declspec] = ACTIONS(3152),
    [anon_sym___based] = ACTIONS(3152),
    [anon_sym___cdecl] = ACTIONS(3152),
    [anon_sym___clrcall] = ACTIONS(3152),
    [anon_sym___stdcall] = ACTIONS(3152),
    [anon_sym___fastcall] = ACTIONS(3152),
    [anon_sym___thiscall] = ACTIONS(3152),
    [anon_sym___vectorcall] = ACTIONS(3152),
    [anon_sym_LBRACE] = ACTIONS(3154),
    [anon_sym_signed] = ACTIONS(3152),
    [anon_sym_unsigned] = ACTIONS(3152),
    [anon_sym_long] = ACTIONS(3152),
    [anon_sym_short] = ACTIONS(3152),
    [anon_sym_LBRACK] = ACTIONS(3152),
    [anon_sym_static] = ACTIONS(3152),
    [anon_sym_register] = ACTIONS(3152),
    [anon_sym_inline] = ACTIONS(3152),
    [anon_sym___inline] = ACTIONS(3152),
    [anon_sym___inline__] = ACTIONS(3152),
    [anon_sym___forceinline] = ACTIONS(3152),
    [anon_sym_thread_local] = ACTIONS(3152),
    [anon_sym___thread] = ACTIONS(3152),
    [anon_sym_const] = ACTIONS(3152),
    [anon_sym_constexpr] = ACTIONS(3152),
    [anon_sym_volatile] = ACTIONS(3152),
    [anon_sym_restrict] = ACTIONS(3152),
    [anon_sym___restrict__] = ACTIONS(3152),
    [anon_sym__Atomic] = ACTIONS(3152),
    [anon_sym__Noreturn] = ACTIONS(3152),
    [anon_sym_noreturn] = ACTIONS(3152),
    [anon_sym_mutable] = ACTIONS(3152),
    [anon_sym_constinit] = ACTIONS(3152),
    [anon_sym_consteval] = ACTIONS(3152),
    [anon_sym_PROGMEM] = ACTIONS(3152),
    [aux_sym_primitive_type_token1] = ACTIONS(3152),
    [anon_sym_byte] = ACTIONS(3152),
    [anon_sym_word] = ACTIONS(3152),
    [anon_sym_enum] = ACTIONS(3152),
    [anon_sym_class] = ACTIONS(3152),
    [anon_sym_struct] = ACTIONS(3152),
    [anon_sym_union] = ACTIONS(3152),
    [anon_sym_if] = ACTIONS(3152),
    [anon_sym_switch] = ACTIONS(3152),
    [anon_sym_case] = ACTIONS(3152),
    [anon_sym_default] = ACTIONS(3152),
    [anon_sym_while] = ACTIONS(3152),
    [anon_sym_do] = ACTIONS(3152),
    [anon_sym_for] = ACTIONS(3152),
    [anon_sym_return] = ACTIONS(3152),
    [anon_sym_break] = ACTIONS(3152),
    [anon_sym_continue] = ACTIONS(3152),
    [anon_sym_goto] = ACTIONS(3152),
    [anon_sym_not] = ACTIONS(3152),
    [anon_sym_compl] = ACTIONS(3152),
    [anon_sym_DASH_DASH] = ACTIONS(3154),
    [anon_sym_PLUS_PLUS] = ACTIONS(3154),
    [anon_sym_sizeof] = ACTIONS(3152),
    [anon_sym___alignof__] = ACTIONS(3152),
    [anon_sym___alignof] = ACTIONS(3152),
    [anon_sym__alignof] = ACTIONS(3152),
    [anon_sym_alignof] = ACTIONS(3152),
    [anon_sym__Alignof] = ACTIONS(3152),
    [anon_sym_offsetof] = ACTIONS(3152),
    [anon_sym__Generic] = ACTIONS(3152),
    [anon_sym_asm] = ACTIONS(3152),
    [anon_sym___asm__] = ACTIONS(3152),
    [aux_sym_number_literal_token1] = ACTIONS(3154),
    [aux_sym_number_literal_token2] = ACTIONS(3152),
    [anon_sym_L_SQUOTE] = ACTIONS(3154),
    [anon_sym_u_SQUOTE] = ACTIONS(3154),
    [anon_sym_U_SQUOTE] = ACTIONS(3154),
    [anon_sym_u8_SQUOTE] = ACTIONS(3154),
    [anon_sym_SQUOTE] = ACTIONS(3154),
    [anon_sym_L_DQUOTE] = ACTIONS(3154),
    [anon_sym_u_DQUOTE] = ACTIONS(3154),
    [anon_sym_U_DQUOTE] = ACTIONS(3154),
    [anon_sym_u8_DQUOTE] = ACTIONS(3154),
    [anon_sym_DQUOTE] = ACTIONS(3154),
    [sym_true] = ACTIONS(3152),
    [sym_false] = ACTIONS(3152),
    [anon_sym_NULL] = ACTIONS(3152),
    [anon_sym_nullptr] = ACTIONS(3152),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3152),
    [anon_sym_decltype] = ACTIONS(3152),
    [anon_sym_virtual] = ACTIONS(3152),
    [anon_sym_alignas] = ACTIONS(3152),
    [anon_sym_explicit] = ACTIONS(3152),
    [anon_sym_typename] = ACTIONS(3152),
    [anon_sym_template] = ACTIONS(3152),
    [anon_sym_operator] = ACTIONS(3152),
    [anon_sym_try] = ACTIONS(3152),
    [anon_sym_delete] = ACTIONS(3152),
    [anon_sym_throw] = ACTIONS(3152),
    [anon_sym_namespace] = ACTIONS(3152),
    [anon_sym_using] = ACTIONS(3152),
    [anon_sym_static_assert] = ACTIONS(3152),
    [anon_sym_concept] = ACTIONS(3152),
    [anon_sym_co_return] = ACTIONS(3152),
    [anon_sym_co_yield] = ACTIONS(3152),
    [anon_sym_R_DQUOTE] = ACTIONS(3154),
    [anon_sym_LR_DQUOTE] = ACTIONS(3154),
    [anon_sym_uR_DQUOTE] = ACTIONS(3154),
    [anon_sym_UR_DQUOTE] = ACTIONS(3154),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3154),
    [anon_sym_co_await] = ACTIONS(3152),
    [anon_sym_new] = ACTIONS(3152),
    [anon_sym_requires] = ACTIONS(3152),
    [sym_this] = ACTIONS(3152),
  },
  [908] = {
    [ts_builtin_sym_end] = ACTIONS(3150),
    [sym_identifier] = ACTIONS(3148),
    [aux_sym_preproc_include_token1] = ACTIONS(3148),
    [aux_sym_preproc_def_token1] = ACTIONS(3148),
    [aux_sym_preproc_if_token1] = ACTIONS(3148),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3148),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3148),
    [sym_preproc_directive] = ACTIONS(3148),
    [anon_sym_LPAREN2] = ACTIONS(3150),
    [anon_sym_BANG] = ACTIONS(3150),
    [anon_sym_TILDE] = ACTIONS(3150),
    [anon_sym_DASH] = ACTIONS(3148),
    [anon_sym_PLUS] = ACTIONS(3148),
    [anon_sym_STAR] = ACTIONS(3150),
    [anon_sym_AMP_AMP] = ACTIONS(3150),
    [anon_sym_AMP] = ACTIONS(3148),
    [anon_sym___extension__] = ACTIONS(3148),
    [anon_sym_typedef] = ACTIONS(3148),
    [anon_sym_extern] = ACTIONS(3148),
    [anon_sym___attribute__] = ACTIONS(3148),
    [anon_sym_COLON_COLON] = ACTIONS(3150),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3150),
    [anon_sym___declspec] = ACTIONS(3148),
    [anon_sym___based] = ACTIONS(3148),
    [anon_sym___cdecl] = ACTIONS(3148),
    [anon_sym___clrcall] = ACTIONS(3148),
    [anon_sym___stdcall] = ACTIONS(3148),
    [anon_sym___fastcall] = ACTIONS(3148),
    [anon_sym___thiscall] = ACTIONS(3148),
    [anon_sym___vectorcall] = ACTIONS(3148),
    [anon_sym_LBRACE] = ACTIONS(3150),
    [anon_sym_signed] = ACTIONS(3148),
    [anon_sym_unsigned] = ACTIONS(3148),
    [anon_sym_long] = ACTIONS(3148),
    [anon_sym_short] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_static] = ACTIONS(3148),
    [anon_sym_register] = ACTIONS(3148),
    [anon_sym_inline] = ACTIONS(3148),
    [anon_sym___inline] = ACTIONS(3148),
    [anon_sym___inline__] = ACTIONS(3148),
    [anon_sym___forceinline] = ACTIONS(3148),
    [anon_sym_thread_local] = ACTIONS(3148),
    [anon_sym___thread] = ACTIONS(3148),
    [anon_sym_const] = ACTIONS(3148),
    [anon_sym_constexpr] = ACTIONS(3148),
    [anon_sym_volatile] = ACTIONS(3148),
    [anon_sym_restrict] = ACTIONS(3148),
    [anon_sym___restrict__] = ACTIONS(3148),
    [anon_sym__Atomic] = ACTIONS(3148),
    [anon_sym__Noreturn] = ACTIONS(3148),
    [anon_sym_noreturn] = ACTIONS(3148),
    [anon_sym_mutable] = ACTIONS(3148),
    [anon_sym_constinit] = ACTIONS(3148),
    [anon_sym_consteval] = ACTIONS(3148),
    [anon_sym_PROGMEM] = ACTIONS(3148),
    [aux_sym_primitive_type_token1] = ACTIONS(3148),
    [anon_sym_byte] = ACTIONS(3148),
    [anon_sym_word] = ACTIONS(3148),
    [anon_sym_enum] = ACTIONS(3148),
    [anon_sym_class] = ACTIONS(3148),
    [anon_sym_struct] = ACTIONS(3148),
    [anon_sym_union] = ACTIONS(3148),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_switch] = ACTIONS(3148),
    [anon_sym_case] = ACTIONS(3148),
    [anon_sym_default] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_for] = ACTIONS(3148),
    [anon_sym_return] = ACTIONS(3148),
    [anon_sym_break] = ACTIONS(3148),
    [anon_sym_continue] = ACTIONS(3148),
    [anon_sym_goto] = ACTIONS(3148),
    [anon_sym_not] = ACTIONS(3148),
    [anon_sym_compl] = ACTIONS(3148),
    [anon_sym_DASH_DASH] = ACTIONS(3150),
    [anon_sym_PLUS_PLUS] = ACTIONS(3150),
    [anon_sym_sizeof] = ACTIONS(3148),
    [anon_sym___alignof__] = ACTIONS(3148),
    [anon_sym___alignof] = ACTIONS(3148),
    [anon_sym__alignof] = ACTIONS(3148),
    [anon_sym_alignof] = ACTIONS(3148),
    [anon_sym__Alignof] = ACTIONS(3148),
    [anon_sym_offsetof] = ACTIONS(3148),
    [anon_sym__Generic] = ACTIONS(3148),
    [anon_sym_asm] = ACTIONS(3148),
    [anon_sym___asm__] = ACTIONS(3148),
    [aux_sym_number_literal_token1] = ACTIONS(3150),
    [aux_sym_number_literal_token2] = ACTIONS(3148),
    [anon_sym_L_SQUOTE] = ACTIONS(3150),
    [anon_sym_u_SQUOTE] = ACTIONS(3150),
    [anon_sym_U_SQUOTE] = ACTIONS(3150),
    [anon_sym_u8_SQUOTE] = ACTIONS(3150),
    [anon_sym_SQUOTE] = ACTIONS(3150),
    [anon_sym_L_DQUOTE] = ACTIONS(3150),
    [anon_sym_u_DQUOTE] = ACTIONS(3150),
    [anon_sym_U_DQUOTE] = ACTIONS(3150),
    [anon_sym_u8_DQUOTE] = ACTIONS(3150),
    [anon_sym_DQUOTE] = ACTIONS(3150),
    [sym_true] = ACTIONS(3148),
    [sym_false] = ACTIONS(3148),
    [anon_sym_NULL] = ACTIONS(3148),
    [anon_sym_nullptr] = ACTIONS(3148),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3148),
    [anon_sym_decltype] = ACTIONS(3148),
    [anon_sym_virtual] = ACTIONS(3148),
    [anon_sym_alignas] = ACTIONS(3148),
    [anon_sym_explicit] = ACTIONS(3148),
    [anon_sym_typename] = ACTIONS(3148),
    [anon_sym_template] = ACTIONS(3148),
    [anon_sym_operator] = ACTIONS(3148),
    [anon_sym_try] = ACTIONS(3148),
    [anon_sym_delete] = ACTIONS(3148),
    [anon_sym_throw] = ACTIONS(3148),
    [anon_sym_namespace] = ACTIONS(3148),
    [anon_sym_using] = ACTIONS(3148),
    [anon_sym_static_assert] = ACTIONS(3148),
    [anon_sym_concept] = ACTIONS(3148),
    [anon_sym_co_return] = ACTIONS(3148),
    [anon_sym_co_yield] = ACTIONS(3148),
    [anon_sym_R_DQUOTE] = ACTIONS(3150),
    [anon_sym_LR_DQUOTE] = ACTIONS(3150),
    [anon_sym_uR_DQUOTE] = ACTIONS(3150),
    [anon_sym_UR_DQUOTE] = ACTIONS(3150),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3150),
    [anon_sym_co_await] = ACTIONS(3148),
    [anon_sym_new] = ACTIONS(3148),
    [anon_sym_requires] = ACTIONS(3148),
    [sym_this] = ACTIONS(3148),
  },
  [909] = {
    [ts_builtin_sym_end] = ACTIONS(3050),
    [sym_identifier] = ACTIONS(3048),
    [aux_sym_preproc_include_token1] = ACTIONS(3048),
    [aux_sym_preproc_def_token1] = ACTIONS(3048),
    [aux_sym_preproc_if_token1] = ACTIONS(3048),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3048),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3048),
    [sym_preproc_directive] = ACTIONS(3048),
    [anon_sym_LPAREN2] = ACTIONS(3050),
    [anon_sym_BANG] = ACTIONS(3050),
    [anon_sym_TILDE] = ACTIONS(3050),
    [anon_sym_DASH] = ACTIONS(3048),
    [anon_sym_PLUS] = ACTIONS(3048),
    [anon_sym_STAR] = ACTIONS(3050),
    [anon_sym_AMP_AMP] = ACTIONS(3050),
    [anon_sym_AMP] = ACTIONS(3048),
    [anon_sym___extension__] = ACTIONS(3048),
    [anon_sym_typedef] = ACTIONS(3048),
    [anon_sym_extern] = ACTIONS(3048),
    [anon_sym___attribute__] = ACTIONS(3048),
    [anon_sym_COLON_COLON] = ACTIONS(3050),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3050),
    [anon_sym___declspec] = ACTIONS(3048),
    [anon_sym___based] = ACTIONS(3048),
    [anon_sym___cdecl] = ACTIONS(3048),
    [anon_sym___clrcall] = ACTIONS(3048),
    [anon_sym___stdcall] = ACTIONS(3048),
    [anon_sym___fastcall] = ACTIONS(3048),
    [anon_sym___thiscall] = ACTIONS(3048),
    [anon_sym___vectorcall] = ACTIONS(3048),
    [anon_sym_LBRACE] = ACTIONS(3050),
    [anon_sym_signed] = ACTIONS(3048),
    [anon_sym_unsigned] = ACTIONS(3048),
    [anon_sym_long] = ACTIONS(3048),
    [anon_sym_short] = ACTIONS(3048),
    [anon_sym_LBRACK] = ACTIONS(3048),
    [anon_sym_static] = ACTIONS(3048),
    [anon_sym_register] = ACTIONS(3048),
    [anon_sym_inline] = ACTIONS(3048),
    [anon_sym___inline] = ACTIONS(3048),
    [anon_sym___inline__] = ACTIONS(3048),
    [anon_sym___forceinline] = ACTIONS(3048),
    [anon_sym_thread_local] = ACTIONS(3048),
    [anon_sym___thread] = ACTIONS(3048),
    [anon_sym_const] = ACTIONS(3048),
    [anon_sym_constexpr] = ACTIONS(3048),
    [anon_sym_volatile] = ACTIONS(3048),
    [anon_sym_restrict] = ACTIONS(3048),
    [anon_sym___restrict__] = ACTIONS(3048),
    [anon_sym__Atomic] = ACTIONS(3048),
    [anon_sym__Noreturn] = ACTIONS(3048),
    [anon_sym_noreturn] = ACTIONS(3048),
    [anon_sym_mutable] = ACTIONS(3048),
    [anon_sym_constinit] = ACTIONS(3048),
    [anon_sym_consteval] = ACTIONS(3048),
    [anon_sym_PROGMEM] = ACTIONS(3048),
    [aux_sym_primitive_type_token1] = ACTIONS(3048),
    [anon_sym_byte] = ACTIONS(3048),
    [anon_sym_word] = ACTIONS(3048),
    [anon_sym_enum] = ACTIONS(3048),
    [anon_sym_class] = ACTIONS(3048),
    [anon_sym_struct] = ACTIONS(3048),
    [anon_sym_union] = ACTIONS(3048),
    [anon_sym_if] = ACTIONS(3048),
    [anon_sym_switch] = ACTIONS(3048),
    [anon_sym_case] = ACTIONS(3048),
    [anon_sym_default] = ACTIONS(3048),
    [anon_sym_while] = ACTIONS(3048),
    [anon_sym_do] = ACTIONS(3048),
    [anon_sym_for] = ACTIONS(3048),
    [anon_sym_return] = ACTIONS(3048),
    [anon_sym_break] = ACTIONS(3048),
    [anon_sym_continue] = ACTIONS(3048),
    [anon_sym_goto] = ACTIONS(3048),
    [anon_sym_not] = ACTIONS(3048),
    [anon_sym_compl] = ACTIONS(3048),
    [anon_sym_DASH_DASH] = ACTIONS(3050),
    [anon_sym_PLUS_PLUS] = ACTIONS(3050),
    [anon_sym_sizeof] = ACTIONS(3048),
    [anon_sym___alignof__] = ACTIONS(3048),
    [anon_sym___alignof] = ACTIONS(3048),
    [anon_sym__alignof] = ACTIONS(3048),
    [anon_sym_alignof] = ACTIONS(3048),
    [anon_sym__Alignof] = ACTIONS(3048),
    [anon_sym_offsetof] = ACTIONS(3048),
    [anon_sym__Generic] = ACTIONS(3048),
    [anon_sym_asm] = ACTIONS(3048),
    [anon_sym___asm__] = ACTIONS(3048),
    [aux_sym_number_literal_token1] = ACTIONS(3050),
    [aux_sym_number_literal_token2] = ACTIONS(3048),
    [anon_sym_L_SQUOTE] = ACTIONS(3050),
    [anon_sym_u_SQUOTE] = ACTIONS(3050),
    [anon_sym_U_SQUOTE] = ACTIONS(3050),
    [anon_sym_u8_SQUOTE] = ACTIONS(3050),
    [anon_sym_SQUOTE] = ACTIONS(3050),
    [anon_sym_L_DQUOTE] = ACTIONS(3050),
    [anon_sym_u_DQUOTE] = ACTIONS(3050),
    [anon_sym_U_DQUOTE] = ACTIONS(3050),
    [anon_sym_u8_DQUOTE] = ACTIONS(3050),
    [anon_sym_DQUOTE] = ACTIONS(3050),
    [sym_true] = ACTIONS(3048),
    [sym_false] = ACTIONS(3048),
    [anon_sym_NULL] = ACTIONS(3048),
    [anon_sym_nullptr] = ACTIONS(3048),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3048),
    [anon_sym_decltype] = ACTIONS(3048),
    [anon_sym_virtual] = ACTIONS(3048),
    [anon_sym_alignas] = ACTIONS(3048),
    [anon_sym_explicit] = ACTIONS(3048),
    [anon_sym_typename] = ACTIONS(3048),
    [anon_sym_template] = ACTIONS(3048),
    [anon_sym_operator] = ACTIONS(3048),
    [anon_sym_try] = ACTIONS(3048),
    [anon_sym_delete] = ACTIONS(3048),
    [anon_sym_throw] = ACTIONS(3048),
    [anon_sym_namespace] = ACTIONS(3048),
    [anon_sym_using] = ACTIONS(3048),
    [anon_sym_static_assert] = ACTIONS(3048),
    [anon_sym_concept] = ACTIONS(3048),
    [anon_sym_co_return] = ACTIONS(3048),
    [anon_sym_co_yield] = ACTIONS(3048),
    [anon_sym_R_DQUOTE] = ACTIONS(3050),
    [anon_sym_LR_DQUOTE] = ACTIONS(3050),
    [anon_sym_uR_DQUOTE] = ACTIONS(3050),
    [anon_sym_UR_DQUOTE] = ACTIONS(3050),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3050),
    [anon_sym_co_await] = ACTIONS(3048),
    [anon_sym_new] = ACTIONS(3048),
    [anon_sym_requires] = ACTIONS(3048),
    [sym_this] = ACTIONS(3048),
  },
  [910] = {
    [ts_builtin_sym_end] = ACTIONS(3113),
    [sym_identifier] = ACTIONS(3111),
    [aux_sym_preproc_include_token1] = ACTIONS(3111),
    [aux_sym_preproc_def_token1] = ACTIONS(3111),
    [aux_sym_preproc_if_token1] = ACTIONS(3111),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3111),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3111),
    [sym_preproc_directive] = ACTIONS(3111),
    [anon_sym_LPAREN2] = ACTIONS(3113),
    [anon_sym_BANG] = ACTIONS(3113),
    [anon_sym_TILDE] = ACTIONS(3113),
    [anon_sym_DASH] = ACTIONS(3111),
    [anon_sym_PLUS] = ACTIONS(3111),
    [anon_sym_STAR] = ACTIONS(3113),
    [anon_sym_AMP_AMP] = ACTIONS(3113),
    [anon_sym_AMP] = ACTIONS(3111),
    [anon_sym___extension__] = ACTIONS(3111),
    [anon_sym_typedef] = ACTIONS(3111),
    [anon_sym_extern] = ACTIONS(3111),
    [anon_sym___attribute__] = ACTIONS(3111),
    [anon_sym_COLON_COLON] = ACTIONS(3113),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3113),
    [anon_sym___declspec] = ACTIONS(3111),
    [anon_sym___based] = ACTIONS(3111),
    [anon_sym___cdecl] = ACTIONS(3111),
    [anon_sym___clrcall] = ACTIONS(3111),
    [anon_sym___stdcall] = ACTIONS(3111),
    [anon_sym___fastcall] = ACTIONS(3111),
    [anon_sym___thiscall] = ACTIONS(3111),
    [anon_sym___vectorcall] = ACTIONS(3111),
    [anon_sym_LBRACE] = ACTIONS(3113),
    [anon_sym_signed] = ACTIONS(3111),
    [anon_sym_unsigned] = ACTIONS(3111),
    [anon_sym_long] = ACTIONS(3111),
    [anon_sym_short] = ACTIONS(3111),
    [anon_sym_LBRACK] = ACTIONS(3111),
    [anon_sym_static] = ACTIONS(3111),
    [anon_sym_register] = ACTIONS(3111),
    [anon_sym_inline] = ACTIONS(3111),
    [anon_sym___inline] = ACTIONS(3111),
    [anon_sym___inline__] = ACTIONS(3111),
    [anon_sym___forceinline] = ACTIONS(3111),
    [anon_sym_thread_local] = ACTIONS(3111),
    [anon_sym___thread] = ACTIONS(3111),
    [anon_sym_const] = ACTIONS(3111),
    [anon_sym_constexpr] = ACTIONS(3111),
    [anon_sym_volatile] = ACTIONS(3111),
    [anon_sym_restrict] = ACTIONS(3111),
    [anon_sym___restrict__] = ACTIONS(3111),
    [anon_sym__Atomic] = ACTIONS(3111),
    [anon_sym__Noreturn] = ACTIONS(3111),
    [anon_sym_noreturn] = ACTIONS(3111),
    [anon_sym_mutable] = ACTIONS(3111),
    [anon_sym_constinit] = ACTIONS(3111),
    [anon_sym_consteval] = ACTIONS(3111),
    [anon_sym_PROGMEM] = ACTIONS(3111),
    [aux_sym_primitive_type_token1] = ACTIONS(3111),
    [anon_sym_byte] = ACTIONS(3111),
    [anon_sym_word] = ACTIONS(3111),
    [anon_sym_enum] = ACTIONS(3111),
    [anon_sym_class] = ACTIONS(3111),
    [anon_sym_struct] = ACTIONS(3111),
    [anon_sym_union] = ACTIONS(3111),
    [anon_sym_if] = ACTIONS(3111),
    [anon_sym_switch] = ACTIONS(3111),
    [anon_sym_case] = ACTIONS(3111),
    [anon_sym_default] = ACTIONS(3111),
    [anon_sym_while] = ACTIONS(3111),
    [anon_sym_do] = ACTIONS(3111),
    [anon_sym_for] = ACTIONS(3111),
    [anon_sym_return] = ACTIONS(3111),
    [anon_sym_break] = ACTIONS(3111),
    [anon_sym_continue] = ACTIONS(3111),
    [anon_sym_goto] = ACTIONS(3111),
    [anon_sym_not] = ACTIONS(3111),
    [anon_sym_compl] = ACTIONS(3111),
    [anon_sym_DASH_DASH] = ACTIONS(3113),
    [anon_sym_PLUS_PLUS] = ACTIONS(3113),
    [anon_sym_sizeof] = ACTIONS(3111),
    [anon_sym___alignof__] = ACTIONS(3111),
    [anon_sym___alignof] = ACTIONS(3111),
    [anon_sym__alignof] = ACTIONS(3111),
    [anon_sym_alignof] = ACTIONS(3111),
    [anon_sym__Alignof] = ACTIONS(3111),
    [anon_sym_offsetof] = ACTIONS(3111),
    [anon_sym__Generic] = ACTIONS(3111),
    [anon_sym_asm] = ACTIONS(3111),
    [anon_sym___asm__] = ACTIONS(3111),
    [aux_sym_number_literal_token1] = ACTIONS(3113),
    [aux_sym_number_literal_token2] = ACTIONS(3111),
    [anon_sym_L_SQUOTE] = ACTIONS(3113),
    [anon_sym_u_SQUOTE] = ACTIONS(3113),
    [anon_sym_U_SQUOTE] = ACTIONS(3113),
    [anon_sym_u8_SQUOTE] = ACTIONS(3113),
    [anon_sym_SQUOTE] = ACTIONS(3113),
    [anon_sym_L_DQUOTE] = ACTIONS(3113),
    [anon_sym_u_DQUOTE] = ACTIONS(3113),
    [anon_sym_U_DQUOTE] = ACTIONS(3113),
    [anon_sym_u8_DQUOTE] = ACTIONS(3113),
    [anon_sym_DQUOTE] = ACTIONS(3113),
    [sym_true] = ACTIONS(3111),
    [sym_false] = ACTIONS(3111),
    [anon_sym_NULL] = ACTIONS(3111),
    [anon_sym_nullptr] = ACTIONS(3111),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3111),
    [anon_sym_decltype] = ACTIONS(3111),
    [anon_sym_virtual] = ACTIONS(3111),
    [anon_sym_alignas] = ACTIONS(3111),
    [anon_sym_explicit] = ACTIONS(3111),
    [anon_sym_typename] = ACTIONS(3111),
    [anon_sym_template] = ACTIONS(3111),
    [anon_sym_operator] = ACTIONS(3111),
    [anon_sym_try] = ACTIONS(3111),
    [anon_sym_delete] = ACTIONS(3111),
    [anon_sym_throw] = ACTIONS(3111),
    [anon_sym_namespace] = ACTIONS(3111),
    [anon_sym_using] = ACTIONS(3111),
    [anon_sym_static_assert] = ACTIONS(3111),
    [anon_sym_concept] = ACTIONS(3111),
    [anon_sym_co_return] = ACTIONS(3111),
    [anon_sym_co_yield] = ACTIONS(3111),
    [anon_sym_R_DQUOTE] = ACTIONS(3113),
    [anon_sym_LR_DQUOTE] = ACTIONS(3113),
    [anon_sym_uR_DQUOTE] = ACTIONS(3113),
    [anon_sym_UR_DQUOTE] = ACTIONS(3113),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3113),
    [anon_sym_co_await] = ACTIONS(3111),
    [anon_sym_new] = ACTIONS(3111),
    [anon_sym_requires] = ACTIONS(3111),
    [sym_this] = ACTIONS(3111),
  },
  [911] = {
    [sym_preproc_def] = STATE(858),
    [sym_preproc_function_def] = STATE(858),
    [sym_preproc_call] = STATE(858),
    [sym_preproc_if_in_field_declaration_list] = STATE(858),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(858),
    [sym_type_definition] = STATE(858),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(5536),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(3150),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6010),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym__field_declaration_list_item] = STATE(858),
    [sym_field_declaration] = STATE(858),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1811),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(858),
    [sym_operator_cast] = STATE(6536),
    [sym_inline_method_definition] = STATE(858),
    [sym__constructor_specifiers] = STATE(1811),
    [sym_operator_cast_definition] = STATE(858),
    [sym_operator_cast_declaration] = STATE(858),
    [sym_constructor_or_destructor_definition] = STATE(858),
    [sym_constructor_or_destructor_declaration] = STATE(858),
    [sym_friend_declaration] = STATE(858),
    [sym_access_specifier] = STATE(7802),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(2618),
    [sym_template_function] = STATE(6098),
    [sym_using_declaration] = STATE(858),
    [sym_alias_declaration] = STATE(858),
    [sym_static_assert_declaration] = STATE(858),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5301),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_qualified_operator_cast_identifier] = STATE(6536),
    [sym_operator_name] = STATE(6098),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(858),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1961),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1811),
    [sym_identifier] = ACTIONS(2823),
    [aux_sym_preproc_def_token1] = ACTIONS(3364),
    [aux_sym_preproc_if_token1] = ACTIONS(3366),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3368),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3368),
    [sym_preproc_directive] = ACTIONS(3370),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(3372),
    [anon_sym_typedef] = ACTIONS(3374),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(2853),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_RBRACE] = ACTIONS(3560),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2857),
    [anon_sym_class] = ACTIONS(2859),
    [anon_sym_struct] = ACTIONS(2861),
    [anon_sym_union] = ACTIONS(2863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(2865),
    [anon_sym_template] = ACTIONS(3378),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3380),
    [anon_sym_public] = ACTIONS(2871),
    [anon_sym_private] = ACTIONS(2871),
    [anon_sym_protected] = ACTIONS(2871),
    [anon_sym_using] = ACTIONS(3382),
    [anon_sym_static_assert] = ACTIONS(3384),
  },
  [912] = {
    [sym_preproc_def] = STATE(883),
    [sym_preproc_function_def] = STATE(883),
    [sym_preproc_call] = STATE(883),
    [sym_preproc_if_in_field_declaration_list] = STATE(883),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(883),
    [sym_type_definition] = STATE(883),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(5536),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(3150),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6010),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym__field_declaration_list_item] = STATE(883),
    [sym_field_declaration] = STATE(883),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1811),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(883),
    [sym_operator_cast] = STATE(6536),
    [sym_inline_method_definition] = STATE(883),
    [sym__constructor_specifiers] = STATE(1811),
    [sym_operator_cast_definition] = STATE(883),
    [sym_operator_cast_declaration] = STATE(883),
    [sym_constructor_or_destructor_definition] = STATE(883),
    [sym_constructor_or_destructor_declaration] = STATE(883),
    [sym_friend_declaration] = STATE(883),
    [sym_access_specifier] = STATE(7802),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(2618),
    [sym_template_function] = STATE(6098),
    [sym_using_declaration] = STATE(883),
    [sym_alias_declaration] = STATE(883),
    [sym_static_assert_declaration] = STATE(883),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5301),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_qualified_operator_cast_identifier] = STATE(6536),
    [sym_operator_name] = STATE(6098),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(883),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1961),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1811),
    [sym_identifier] = ACTIONS(2823),
    [aux_sym_preproc_def_token1] = ACTIONS(3364),
    [aux_sym_preproc_if_token1] = ACTIONS(3366),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3368),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3368),
    [sym_preproc_directive] = ACTIONS(3370),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(3372),
    [anon_sym_typedef] = ACTIONS(3374),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(2853),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_RBRACE] = ACTIONS(3562),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2857),
    [anon_sym_class] = ACTIONS(2859),
    [anon_sym_struct] = ACTIONS(2861),
    [anon_sym_union] = ACTIONS(2863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(2865),
    [anon_sym_template] = ACTIONS(3378),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3380),
    [anon_sym_public] = ACTIONS(2871),
    [anon_sym_private] = ACTIONS(2871),
    [anon_sym_protected] = ACTIONS(2871),
    [anon_sym_using] = ACTIONS(3382),
    [anon_sym_static_assert] = ACTIONS(3384),
  },
  [913] = {
    [ts_builtin_sym_end] = ACTIONS(2955),
    [sym_identifier] = ACTIONS(2953),
    [aux_sym_preproc_include_token1] = ACTIONS(2953),
    [aux_sym_preproc_def_token1] = ACTIONS(2953),
    [aux_sym_preproc_if_token1] = ACTIONS(2953),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2953),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2953),
    [sym_preproc_directive] = ACTIONS(2953),
    [anon_sym_LPAREN2] = ACTIONS(2955),
    [anon_sym_BANG] = ACTIONS(2955),
    [anon_sym_TILDE] = ACTIONS(2955),
    [anon_sym_DASH] = ACTIONS(2953),
    [anon_sym_PLUS] = ACTIONS(2953),
    [anon_sym_STAR] = ACTIONS(2955),
    [anon_sym_AMP_AMP] = ACTIONS(2955),
    [anon_sym_AMP] = ACTIONS(2953),
    [anon_sym___extension__] = ACTIONS(2953),
    [anon_sym_typedef] = ACTIONS(2953),
    [anon_sym_extern] = ACTIONS(2953),
    [anon_sym___attribute__] = ACTIONS(2953),
    [anon_sym_COLON_COLON] = ACTIONS(2955),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2955),
    [anon_sym___declspec] = ACTIONS(2953),
    [anon_sym___based] = ACTIONS(2953),
    [anon_sym___cdecl] = ACTIONS(2953),
    [anon_sym___clrcall] = ACTIONS(2953),
    [anon_sym___stdcall] = ACTIONS(2953),
    [anon_sym___fastcall] = ACTIONS(2953),
    [anon_sym___thiscall] = ACTIONS(2953),
    [anon_sym___vectorcall] = ACTIONS(2953),
    [anon_sym_LBRACE] = ACTIONS(2955),
    [anon_sym_signed] = ACTIONS(2953),
    [anon_sym_unsigned] = ACTIONS(2953),
    [anon_sym_long] = ACTIONS(2953),
    [anon_sym_short] = ACTIONS(2953),
    [anon_sym_LBRACK] = ACTIONS(2953),
    [anon_sym_static] = ACTIONS(2953),
    [anon_sym_register] = ACTIONS(2953),
    [anon_sym_inline] = ACTIONS(2953),
    [anon_sym___inline] = ACTIONS(2953),
    [anon_sym___inline__] = ACTIONS(2953),
    [anon_sym___forceinline] = ACTIONS(2953),
    [anon_sym_thread_local] = ACTIONS(2953),
    [anon_sym___thread] = ACTIONS(2953),
    [anon_sym_const] = ACTIONS(2953),
    [anon_sym_constexpr] = ACTIONS(2953),
    [anon_sym_volatile] = ACTIONS(2953),
    [anon_sym_restrict] = ACTIONS(2953),
    [anon_sym___restrict__] = ACTIONS(2953),
    [anon_sym__Atomic] = ACTIONS(2953),
    [anon_sym__Noreturn] = ACTIONS(2953),
    [anon_sym_noreturn] = ACTIONS(2953),
    [anon_sym_mutable] = ACTIONS(2953),
    [anon_sym_constinit] = ACTIONS(2953),
    [anon_sym_consteval] = ACTIONS(2953),
    [anon_sym_PROGMEM] = ACTIONS(2953),
    [aux_sym_primitive_type_token1] = ACTIONS(2953),
    [anon_sym_byte] = ACTIONS(2953),
    [anon_sym_word] = ACTIONS(2953),
    [anon_sym_enum] = ACTIONS(2953),
    [anon_sym_class] = ACTIONS(2953),
    [anon_sym_struct] = ACTIONS(2953),
    [anon_sym_union] = ACTIONS(2953),
    [anon_sym_if] = ACTIONS(2953),
    [anon_sym_switch] = ACTIONS(2953),
    [anon_sym_case] = ACTIONS(2953),
    [anon_sym_default] = ACTIONS(2953),
    [anon_sym_while] = ACTIONS(2953),
    [anon_sym_do] = ACTIONS(2953),
    [anon_sym_for] = ACTIONS(2953),
    [anon_sym_return] = ACTIONS(2953),
    [anon_sym_break] = ACTIONS(2953),
    [anon_sym_continue] = ACTIONS(2953),
    [anon_sym_goto] = ACTIONS(2953),
    [anon_sym_not] = ACTIONS(2953),
    [anon_sym_compl] = ACTIONS(2953),
    [anon_sym_DASH_DASH] = ACTIONS(2955),
    [anon_sym_PLUS_PLUS] = ACTIONS(2955),
    [anon_sym_sizeof] = ACTIONS(2953),
    [anon_sym___alignof__] = ACTIONS(2953),
    [anon_sym___alignof] = ACTIONS(2953),
    [anon_sym__alignof] = ACTIONS(2953),
    [anon_sym_alignof] = ACTIONS(2953),
    [anon_sym__Alignof] = ACTIONS(2953),
    [anon_sym_offsetof] = ACTIONS(2953),
    [anon_sym__Generic] = ACTIONS(2953),
    [anon_sym_asm] = ACTIONS(2953),
    [anon_sym___asm__] = ACTIONS(2953),
    [aux_sym_number_literal_token1] = ACTIONS(2955),
    [aux_sym_number_literal_token2] = ACTIONS(2953),
    [anon_sym_L_SQUOTE] = ACTIONS(2955),
    [anon_sym_u_SQUOTE] = ACTIONS(2955),
    [anon_sym_U_SQUOTE] = ACTIONS(2955),
    [anon_sym_u8_SQUOTE] = ACTIONS(2955),
    [anon_sym_SQUOTE] = ACTIONS(2955),
    [anon_sym_L_DQUOTE] = ACTIONS(2955),
    [anon_sym_u_DQUOTE] = ACTIONS(2955),
    [anon_sym_U_DQUOTE] = ACTIONS(2955),
    [anon_sym_u8_DQUOTE] = ACTIONS(2955),
    [anon_sym_DQUOTE] = ACTIONS(2955),
    [sym_true] = ACTIONS(2953),
    [sym_false] = ACTIONS(2953),
    [anon_sym_NULL] = ACTIONS(2953),
    [anon_sym_nullptr] = ACTIONS(2953),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2953),
    [anon_sym_decltype] = ACTIONS(2953),
    [anon_sym_virtual] = ACTIONS(2953),
    [anon_sym_alignas] = ACTIONS(2953),
    [anon_sym_explicit] = ACTIONS(2953),
    [anon_sym_typename] = ACTIONS(2953),
    [anon_sym_template] = ACTIONS(2953),
    [anon_sym_operator] = ACTIONS(2953),
    [anon_sym_try] = ACTIONS(2953),
    [anon_sym_delete] = ACTIONS(2953),
    [anon_sym_throw] = ACTIONS(2953),
    [anon_sym_namespace] = ACTIONS(2953),
    [anon_sym_using] = ACTIONS(2953),
    [anon_sym_static_assert] = ACTIONS(2953),
    [anon_sym_concept] = ACTIONS(2953),
    [anon_sym_co_return] = ACTIONS(2953),
    [anon_sym_co_yield] = ACTIONS(2953),
    [anon_sym_R_DQUOTE] = ACTIONS(2955),
    [anon_sym_LR_DQUOTE] = ACTIONS(2955),
    [anon_sym_uR_DQUOTE] = ACTIONS(2955),
    [anon_sym_UR_DQUOTE] = ACTIONS(2955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2955),
    [anon_sym_co_await] = ACTIONS(2953),
    [anon_sym_new] = ACTIONS(2953),
    [anon_sym_requires] = ACTIONS(2953),
    [sym_this] = ACTIONS(2953),
  },
  [914] = {
    [ts_builtin_sym_end] = ACTIONS(3180),
    [sym_identifier] = ACTIONS(3178),
    [aux_sym_preproc_include_token1] = ACTIONS(3178),
    [aux_sym_preproc_def_token1] = ACTIONS(3178),
    [aux_sym_preproc_if_token1] = ACTIONS(3178),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3178),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3178),
    [sym_preproc_directive] = ACTIONS(3178),
    [anon_sym_LPAREN2] = ACTIONS(3180),
    [anon_sym_BANG] = ACTIONS(3180),
    [anon_sym_TILDE] = ACTIONS(3180),
    [anon_sym_DASH] = ACTIONS(3178),
    [anon_sym_PLUS] = ACTIONS(3178),
    [anon_sym_STAR] = ACTIONS(3180),
    [anon_sym_AMP_AMP] = ACTIONS(3180),
    [anon_sym_AMP] = ACTIONS(3178),
    [anon_sym___extension__] = ACTIONS(3178),
    [anon_sym_typedef] = ACTIONS(3178),
    [anon_sym_extern] = ACTIONS(3178),
    [anon_sym___attribute__] = ACTIONS(3178),
    [anon_sym_COLON_COLON] = ACTIONS(3180),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3180),
    [anon_sym___declspec] = ACTIONS(3178),
    [anon_sym___based] = ACTIONS(3178),
    [anon_sym___cdecl] = ACTIONS(3178),
    [anon_sym___clrcall] = ACTIONS(3178),
    [anon_sym___stdcall] = ACTIONS(3178),
    [anon_sym___fastcall] = ACTIONS(3178),
    [anon_sym___thiscall] = ACTIONS(3178),
    [anon_sym___vectorcall] = ACTIONS(3178),
    [anon_sym_LBRACE] = ACTIONS(3180),
    [anon_sym_signed] = ACTIONS(3178),
    [anon_sym_unsigned] = ACTIONS(3178),
    [anon_sym_long] = ACTIONS(3178),
    [anon_sym_short] = ACTIONS(3178),
    [anon_sym_LBRACK] = ACTIONS(3178),
    [anon_sym_static] = ACTIONS(3178),
    [anon_sym_register] = ACTIONS(3178),
    [anon_sym_inline] = ACTIONS(3178),
    [anon_sym___inline] = ACTIONS(3178),
    [anon_sym___inline__] = ACTIONS(3178),
    [anon_sym___forceinline] = ACTIONS(3178),
    [anon_sym_thread_local] = ACTIONS(3178),
    [anon_sym___thread] = ACTIONS(3178),
    [anon_sym_const] = ACTIONS(3178),
    [anon_sym_constexpr] = ACTIONS(3178),
    [anon_sym_volatile] = ACTIONS(3178),
    [anon_sym_restrict] = ACTIONS(3178),
    [anon_sym___restrict__] = ACTIONS(3178),
    [anon_sym__Atomic] = ACTIONS(3178),
    [anon_sym__Noreturn] = ACTIONS(3178),
    [anon_sym_noreturn] = ACTIONS(3178),
    [anon_sym_mutable] = ACTIONS(3178),
    [anon_sym_constinit] = ACTIONS(3178),
    [anon_sym_consteval] = ACTIONS(3178),
    [anon_sym_PROGMEM] = ACTIONS(3178),
    [aux_sym_primitive_type_token1] = ACTIONS(3178),
    [anon_sym_byte] = ACTIONS(3178),
    [anon_sym_word] = ACTIONS(3178),
    [anon_sym_enum] = ACTIONS(3178),
    [anon_sym_class] = ACTIONS(3178),
    [anon_sym_struct] = ACTIONS(3178),
    [anon_sym_union] = ACTIONS(3178),
    [anon_sym_if] = ACTIONS(3178),
    [anon_sym_switch] = ACTIONS(3178),
    [anon_sym_case] = ACTIONS(3178),
    [anon_sym_default] = ACTIONS(3178),
    [anon_sym_while] = ACTIONS(3178),
    [anon_sym_do] = ACTIONS(3178),
    [anon_sym_for] = ACTIONS(3178),
    [anon_sym_return] = ACTIONS(3178),
    [anon_sym_break] = ACTIONS(3178),
    [anon_sym_continue] = ACTIONS(3178),
    [anon_sym_goto] = ACTIONS(3178),
    [anon_sym_not] = ACTIONS(3178),
    [anon_sym_compl] = ACTIONS(3178),
    [anon_sym_DASH_DASH] = ACTIONS(3180),
    [anon_sym_PLUS_PLUS] = ACTIONS(3180),
    [anon_sym_sizeof] = ACTIONS(3178),
    [anon_sym___alignof__] = ACTIONS(3178),
    [anon_sym___alignof] = ACTIONS(3178),
    [anon_sym__alignof] = ACTIONS(3178),
    [anon_sym_alignof] = ACTIONS(3178),
    [anon_sym__Alignof] = ACTIONS(3178),
    [anon_sym_offsetof] = ACTIONS(3178),
    [anon_sym__Generic] = ACTIONS(3178),
    [anon_sym_asm] = ACTIONS(3178),
    [anon_sym___asm__] = ACTIONS(3178),
    [aux_sym_number_literal_token1] = ACTIONS(3180),
    [aux_sym_number_literal_token2] = ACTIONS(3178),
    [anon_sym_L_SQUOTE] = ACTIONS(3180),
    [anon_sym_u_SQUOTE] = ACTIONS(3180),
    [anon_sym_U_SQUOTE] = ACTIONS(3180),
    [anon_sym_u8_SQUOTE] = ACTIONS(3180),
    [anon_sym_SQUOTE] = ACTIONS(3180),
    [anon_sym_L_DQUOTE] = ACTIONS(3180),
    [anon_sym_u_DQUOTE] = ACTIONS(3180),
    [anon_sym_U_DQUOTE] = ACTIONS(3180),
    [anon_sym_u8_DQUOTE] = ACTIONS(3180),
    [anon_sym_DQUOTE] = ACTIONS(3180),
    [sym_true] = ACTIONS(3178),
    [sym_false] = ACTIONS(3178),
    [anon_sym_NULL] = ACTIONS(3178),
    [anon_sym_nullptr] = ACTIONS(3178),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3178),
    [anon_sym_decltype] = ACTIONS(3178),
    [anon_sym_virtual] = ACTIONS(3178),
    [anon_sym_alignas] = ACTIONS(3178),
    [anon_sym_explicit] = ACTIONS(3178),
    [anon_sym_typename] = ACTIONS(3178),
    [anon_sym_template] = ACTIONS(3178),
    [anon_sym_operator] = ACTIONS(3178),
    [anon_sym_try] = ACTIONS(3178),
    [anon_sym_delete] = ACTIONS(3178),
    [anon_sym_throw] = ACTIONS(3178),
    [anon_sym_namespace] = ACTIONS(3178),
    [anon_sym_using] = ACTIONS(3178),
    [anon_sym_static_assert] = ACTIONS(3178),
    [anon_sym_concept] = ACTIONS(3178),
    [anon_sym_co_return] = ACTIONS(3178),
    [anon_sym_co_yield] = ACTIONS(3178),
    [anon_sym_R_DQUOTE] = ACTIONS(3180),
    [anon_sym_LR_DQUOTE] = ACTIONS(3180),
    [anon_sym_uR_DQUOTE] = ACTIONS(3180),
    [anon_sym_UR_DQUOTE] = ACTIONS(3180),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3180),
    [anon_sym_co_await] = ACTIONS(3178),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_requires] = ACTIONS(3178),
    [sym_this] = ACTIONS(3178),
  },
  [915] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4512),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3564),
    [anon_sym_COMMA] = ACTIONS(3564),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3480),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(3568),
    [anon_sym_PERCENT] = ACTIONS(3564),
    [anon_sym_PIPE_PIPE] = ACTIONS(3564),
    [anon_sym_AMP_AMP] = ACTIONS(3564),
    [anon_sym_PIPE] = ACTIONS(3568),
    [anon_sym_CARET] = ACTIONS(3564),
    [anon_sym_AMP] = ACTIONS(1413),
    [anon_sym_EQ_EQ] = ACTIONS(3564),
    [anon_sym_BANG_EQ] = ACTIONS(3564),
    [anon_sym_GT] = ACTIONS(3568),
    [anon_sym_GT_EQ] = ACTIONS(3564),
    [anon_sym_LT_EQ] = ACTIONS(3568),
    [anon_sym_LT] = ACTIONS(3568),
    [anon_sym_LT_LT] = ACTIONS(3564),
    [anon_sym_GT_GT] = ACTIONS(3564),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(3564),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_QMARK] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_LT_EQ_GT] = ACTIONS(3564),
    [anon_sym_or] = ACTIONS(3568),
    [anon_sym_and] = ACTIONS(3568),
    [anon_sym_bitor] = ACTIONS(3568),
    [anon_sym_xor] = ACTIONS(3568),
    [anon_sym_bitand] = ACTIONS(3568),
    [anon_sym_not_eq] = ACTIONS(3568),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(3568),
    [anon_sym_DOT_STAR] = ACTIONS(3564),
    [anon_sym_DASH_GT] = ACTIONS(3564),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [916] = {
    [sym__declaration_modifiers] = STATE(1983),
    [sym__declaration_specifiers] = STATE(6059),
    [sym_attribute_specifier] = STATE(1983),
    [sym_attribute_declaration] = STATE(1983),
    [sym_ms_declspec_modifier] = STATE(1983),
    [sym_storage_class_specifier] = STATE(1983),
    [sym_type_qualifier] = STATE(1983),
    [sym__type_specifier] = STATE(4062),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(3443),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(1983),
    [sym_alignas_specifier] = STATE(1983),
    [sym_dependent_type] = STATE(2629),
    [sym_template_type] = STATE(2618),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(6333),
    [sym_qualified_type_identifier] = STATE(2825),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1983),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2855),
    [sym_identifier] = ACTIONS(3572),
    [anon_sym_COMMA] = ACTIONS(3574),
    [anon_sym_BANG] = ACTIONS(3576),
    [anon_sym_TILDE] = ACTIONS(3574),
    [anon_sym_DASH] = ACTIONS(3576),
    [anon_sym_PLUS] = ACTIONS(3576),
    [anon_sym_STAR] = ACTIONS(3576),
    [anon_sym_SLASH] = ACTIONS(3576),
    [anon_sym_PERCENT] = ACTIONS(3576),
    [anon_sym_PIPE_PIPE] = ACTIONS(3574),
    [anon_sym_AMP_AMP] = ACTIONS(3574),
    [anon_sym_PIPE] = ACTIONS(3576),
    [anon_sym_CARET] = ACTIONS(3576),
    [anon_sym_AMP] = ACTIONS(3576),
    [anon_sym_EQ_EQ] = ACTIONS(3574),
    [anon_sym_BANG_EQ] = ACTIONS(3574),
    [anon_sym_GT] = ACTIONS(3576),
    [anon_sym_GT_EQ] = ACTIONS(3574),
    [anon_sym_LT_EQ] = ACTIONS(3576),
    [anon_sym_LT] = ACTIONS(3576),
    [anon_sym_LT_LT] = ACTIONS(3576),
    [anon_sym_GT_GT] = ACTIONS(3576),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3578),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(3580),
    [anon_sym_unsigned] = ACTIONS(3580),
    [anon_sym_long] = ACTIONS(3580),
    [anon_sym_short] = ACTIONS(3580),
    [anon_sym_EQ] = ACTIONS(3576),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(3582),
    [anon_sym_class] = ACTIONS(3584),
    [anon_sym_struct] = ACTIONS(3586),
    [anon_sym_union] = ACTIONS(3588),
    [anon_sym_STAR_EQ] = ACTIONS(3574),
    [anon_sym_SLASH_EQ] = ACTIONS(3574),
    [anon_sym_PERCENT_EQ] = ACTIONS(3574),
    [anon_sym_PLUS_EQ] = ACTIONS(3574),
    [anon_sym_DASH_EQ] = ACTIONS(3574),
    [anon_sym_LT_LT_EQ] = ACTIONS(3574),
    [anon_sym_GT_GT_EQ] = ACTIONS(3574),
    [anon_sym_AMP_EQ] = ACTIONS(3574),
    [anon_sym_CARET_EQ] = ACTIONS(3574),
    [anon_sym_PIPE_EQ] = ACTIONS(3574),
    [anon_sym_and_eq] = ACTIONS(3576),
    [anon_sym_or_eq] = ACTIONS(3576),
    [anon_sym_xor_eq] = ACTIONS(3576),
    [anon_sym_not] = ACTIONS(3576),
    [anon_sym_compl] = ACTIONS(3576),
    [anon_sym_LT_EQ_GT] = ACTIONS(3574),
    [anon_sym_or] = ACTIONS(3576),
    [anon_sym_and] = ACTIONS(3576),
    [anon_sym_bitor] = ACTIONS(3576),
    [anon_sym_xor] = ACTIONS(3576),
    [anon_sym_bitand] = ACTIONS(3576),
    [anon_sym_not_eq] = ACTIONS(3576),
    [anon_sym_DASH_DASH] = ACTIONS(3574),
    [anon_sym_PLUS_PLUS] = ACTIONS(3574),
    [anon_sym_DASH_GT] = ACTIONS(3576),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(3590),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3592),
    [anon_sym_co_await] = ACTIONS(3576),
    [anon_sym_new] = ACTIONS(3592),
    [anon_sym_DASH_GT_STAR] = ACTIONS(3574),
    [anon_sym_LPAREN_RPAREN] = ACTIONS(3574),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3574),
    [anon_sym_DQUOTE_DQUOTE] = ACTIONS(3594),
  },
  [917] = {
    [sym__declaration_modifiers] = STATE(1983),
    [sym__declaration_specifiers] = STATE(6059),
    [sym_attribute_specifier] = STATE(1983),
    [sym_attribute_declaration] = STATE(1983),
    [sym_ms_declspec_modifier] = STATE(1983),
    [sym_storage_class_specifier] = STATE(1983),
    [sym_type_qualifier] = STATE(1983),
    [sym__type_specifier] = STATE(4062),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(3443),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(1983),
    [sym_alignas_specifier] = STATE(1983),
    [sym_dependent_type] = STATE(2629),
    [sym_template_type] = STATE(2618),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(6333),
    [sym_qualified_type_identifier] = STATE(2825),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1983),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2855),
    [sym_identifier] = ACTIONS(3572),
    [anon_sym_COMMA] = ACTIONS(3596),
    [anon_sym_BANG] = ACTIONS(3598),
    [anon_sym_TILDE] = ACTIONS(3596),
    [anon_sym_DASH] = ACTIONS(3598),
    [anon_sym_PLUS] = ACTIONS(3598),
    [anon_sym_STAR] = ACTIONS(3598),
    [anon_sym_SLASH] = ACTIONS(3598),
    [anon_sym_PERCENT] = ACTIONS(3598),
    [anon_sym_PIPE_PIPE] = ACTIONS(3596),
    [anon_sym_AMP_AMP] = ACTIONS(3596),
    [anon_sym_PIPE] = ACTIONS(3598),
    [anon_sym_CARET] = ACTIONS(3598),
    [anon_sym_AMP] = ACTIONS(3598),
    [anon_sym_EQ_EQ] = ACTIONS(3596),
    [anon_sym_BANG_EQ] = ACTIONS(3596),
    [anon_sym_GT] = ACTIONS(3598),
    [anon_sym_GT_EQ] = ACTIONS(3596),
    [anon_sym_LT_EQ] = ACTIONS(3598),
    [anon_sym_LT] = ACTIONS(3598),
    [anon_sym_LT_LT] = ACTIONS(3598),
    [anon_sym_GT_GT] = ACTIONS(3598),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3578),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(3580),
    [anon_sym_unsigned] = ACTIONS(3580),
    [anon_sym_long] = ACTIONS(3580),
    [anon_sym_short] = ACTIONS(3580),
    [anon_sym_EQ] = ACTIONS(3598),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(3582),
    [anon_sym_class] = ACTIONS(3584),
    [anon_sym_struct] = ACTIONS(3586),
    [anon_sym_union] = ACTIONS(3588),
    [anon_sym_STAR_EQ] = ACTIONS(3596),
    [anon_sym_SLASH_EQ] = ACTIONS(3596),
    [anon_sym_PERCENT_EQ] = ACTIONS(3596),
    [anon_sym_PLUS_EQ] = ACTIONS(3596),
    [anon_sym_DASH_EQ] = ACTIONS(3596),
    [anon_sym_LT_LT_EQ] = ACTIONS(3596),
    [anon_sym_GT_GT_EQ] = ACTIONS(3596),
    [anon_sym_AMP_EQ] = ACTIONS(3596),
    [anon_sym_CARET_EQ] = ACTIONS(3596),
    [anon_sym_PIPE_EQ] = ACTIONS(3596),
    [anon_sym_and_eq] = ACTIONS(3598),
    [anon_sym_or_eq] = ACTIONS(3598),
    [anon_sym_xor_eq] = ACTIONS(3598),
    [anon_sym_not] = ACTIONS(3598),
    [anon_sym_compl] = ACTIONS(3598),
    [anon_sym_LT_EQ_GT] = ACTIONS(3596),
    [anon_sym_or] = ACTIONS(3598),
    [anon_sym_and] = ACTIONS(3598),
    [anon_sym_bitor] = ACTIONS(3598),
    [anon_sym_xor] = ACTIONS(3598),
    [anon_sym_bitand] = ACTIONS(3598),
    [anon_sym_not_eq] = ACTIONS(3598),
    [anon_sym_DASH_DASH] = ACTIONS(3596),
    [anon_sym_PLUS_PLUS] = ACTIONS(3596),
    [anon_sym_DASH_GT] = ACTIONS(3598),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(3590),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3600),
    [anon_sym_co_await] = ACTIONS(3598),
    [anon_sym_new] = ACTIONS(3600),
    [anon_sym_DASH_GT_STAR] = ACTIONS(3596),
    [anon_sym_LPAREN_RPAREN] = ACTIONS(3596),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3596),
    [anon_sym_DQUOTE_DQUOTE] = ACTIONS(3602),
  },
  [918] = {
    [sym_function_definition] = STATE(1894),
    [sym_declaration] = STATE(1894),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4558),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(3150),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1856),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(5962),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2804),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym__empty_declaration] = STATE(1894),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1838),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(1894),
    [sym_operator_cast] = STATE(6510),
    [sym__constructor_specifiers] = STATE(1838),
    [sym_operator_cast_definition] = STATE(1894),
    [sym_operator_cast_declaration] = STATE(1894),
    [sym_constructor_or_destructor_definition] = STATE(1894),
    [sym_constructor_or_destructor_declaration] = STATE(1894),
    [sym_friend_declaration] = STATE(1894),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(2618),
    [sym_template_function] = STATE(6098),
    [sym_alias_declaration] = STATE(1894),
    [sym_concept_definition] = STATE(1894),
    [sym_requires_clause] = STATE(927),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5344),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_qualified_operator_cast_identifier] = STATE(6510),
    [sym_operator_name] = STATE(6098),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1838),
    [sym_identifier] = ACTIONS(3604),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3606),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(2867),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(2869),
    [anon_sym_using] = ACTIONS(3608),
    [anon_sym_concept] = ACTIONS(3610),
    [anon_sym_requires] = ACTIONS(3612),
  },
  [919] = {
    [sym_function_definition] = STATE(908),
    [sym_declaration] = STATE(908),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4612),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(3150),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1846),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6007),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2794),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym__empty_declaration] = STATE(908),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1903),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(908),
    [sym_operator_cast] = STATE(6513),
    [sym__constructor_specifiers] = STATE(1903),
    [sym_operator_cast_definition] = STATE(908),
    [sym_operator_cast_declaration] = STATE(908),
    [sym_constructor_or_destructor_definition] = STATE(908),
    [sym_constructor_or_destructor_declaration] = STATE(908),
    [sym_friend_declaration] = STATE(908),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(2618),
    [sym_template_function] = STATE(6098),
    [sym_alias_declaration] = STATE(908),
    [sym_concept_definition] = STATE(908),
    [sym_requires_clause] = STATE(932),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5344),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_qualified_operator_cast_identifier] = STATE(6513),
    [sym_operator_name] = STATE(6098),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1903),
    [sym_identifier] = ACTIONS(3604),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3606),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(3614),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3616),
    [anon_sym_using] = ACTIONS(3618),
    [anon_sym_concept] = ACTIONS(147),
    [anon_sym_requires] = ACTIONS(3612),
  },
  [920] = {
    [sym_function_definition] = STATE(787),
    [sym_declaration] = STATE(787),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4541),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(3150),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(5959),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2759),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym__empty_declaration] = STATE(787),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1815),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(787),
    [sym_operator_cast] = STATE(6505),
    [sym__constructor_specifiers] = STATE(1815),
    [sym_operator_cast_definition] = STATE(787),
    [sym_operator_cast_declaration] = STATE(787),
    [sym_constructor_or_destructor_definition] = STATE(787),
    [sym_constructor_or_destructor_declaration] = STATE(787),
    [sym_friend_declaration] = STATE(787),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(2618),
    [sym_template_function] = STATE(6098),
    [sym_alias_declaration] = STATE(787),
    [sym_concept_definition] = STATE(787),
    [sym_requires_clause] = STATE(928),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5344),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_qualified_operator_cast_identifier] = STATE(6505),
    [sym_operator_name] = STATE(6098),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1815),
    [sym_identifier] = ACTIONS(3604),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3606),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(3620),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3622),
    [anon_sym_using] = ACTIONS(3624),
    [anon_sym_concept] = ACTIONS(233),
    [anon_sym_requires] = ACTIONS(3612),
  },
  [921] = {
    [sym_function_definition] = STATE(2134),
    [sym_declaration] = STATE(2134),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4516),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(3150),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1857),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6014),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2790),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym__empty_declaration] = STATE(2134),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1892),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(2134),
    [sym_operator_cast] = STATE(6512),
    [sym__constructor_specifiers] = STATE(1892),
    [sym_operator_cast_definition] = STATE(2134),
    [sym_operator_cast_declaration] = STATE(2134),
    [sym_constructor_or_destructor_definition] = STATE(2134),
    [sym_constructor_or_destructor_declaration] = STATE(2134),
    [sym_friend_declaration] = STATE(2134),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(2618),
    [sym_template_function] = STATE(6098),
    [sym_alias_declaration] = STATE(2134),
    [sym_concept_definition] = STATE(2134),
    [sym_requires_clause] = STATE(930),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5344),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_qualified_operator_cast_identifier] = STATE(6512),
    [sym_operator_name] = STATE(6098),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1892),
    [sym_identifier] = ACTIONS(3604),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3606),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(3400),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3402),
    [anon_sym_using] = ACTIONS(3626),
    [anon_sym_concept] = ACTIONS(3628),
    [anon_sym_requires] = ACTIONS(3612),
  },
  [922] = {
    [sym_function_definition] = STATE(782),
    [sym_declaration] = STATE(782),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4602),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(3150),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1850),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(5966),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2750),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym__empty_declaration] = STATE(782),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1813),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(782),
    [sym_operator_cast] = STATE(6517),
    [sym__constructor_specifiers] = STATE(1813),
    [sym_operator_cast_definition] = STATE(782),
    [sym_operator_cast_declaration] = STATE(782),
    [sym_constructor_or_destructor_definition] = STATE(782),
    [sym_constructor_or_destructor_declaration] = STATE(782),
    [sym_friend_declaration] = STATE(782),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(2618),
    [sym_template_function] = STATE(6098),
    [sym_alias_declaration] = STATE(782),
    [sym_concept_definition] = STATE(782),
    [sym_requires_clause] = STATE(931),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5344),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_qualified_operator_cast_identifier] = STATE(6517),
    [sym_operator_name] = STATE(6098),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1813),
    [sym_identifier] = ACTIONS(3604),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3606),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(3630),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3632),
    [anon_sym_using] = ACTIONS(3634),
    [anon_sym_concept] = ACTIONS(717),
    [anon_sym_requires] = ACTIONS(3612),
  },
  [923] = {
    [sym_function_definition] = STATE(412),
    [sym_declaration] = STATE(412),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4637),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(3150),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1849),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6030),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2782),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym__empty_declaration] = STATE(412),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1930),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(412),
    [sym_operator_cast] = STATE(6494),
    [sym__constructor_specifiers] = STATE(1930),
    [sym_operator_cast_definition] = STATE(412),
    [sym_operator_cast_declaration] = STATE(412),
    [sym_constructor_or_destructor_definition] = STATE(412),
    [sym_constructor_or_destructor_declaration] = STATE(412),
    [sym_friend_declaration] = STATE(412),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(2618),
    [sym_template_function] = STATE(6098),
    [sym_alias_declaration] = STATE(412),
    [sym_concept_definition] = STATE(412),
    [sym_requires_clause] = STATE(929),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5344),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_qualified_operator_cast_identifier] = STATE(6494),
    [sym_operator_name] = STATE(6098),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1930),
    [sym_identifier] = ACTIONS(3604),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3606),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(3636),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3638),
    [anon_sym_using] = ACTIONS(3640),
    [anon_sym_concept] = ACTIONS(329),
    [anon_sym_requires] = ACTIONS(3612),
  },
  [924] = {
    [sym_function_definition] = STATE(2065),
    [sym_declaration] = STATE(2065),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4569),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(3150),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1852),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6010),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2754),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym__empty_declaration] = STATE(2065),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1811),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(2065),
    [sym_operator_cast] = STATE(6536),
    [sym__constructor_specifiers] = STATE(1811),
    [sym_operator_cast_definition] = STATE(2065),
    [sym_operator_cast_declaration] = STATE(2065),
    [sym_constructor_or_destructor_definition] = STATE(2065),
    [sym_constructor_or_destructor_declaration] = STATE(2065),
    [sym_friend_declaration] = STATE(2065),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(2618),
    [sym_template_function] = STATE(6098),
    [sym_alias_declaration] = STATE(2065),
    [sym_concept_definition] = STATE(2065),
    [sym_requires_clause] = STATE(933),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5344),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_qualified_operator_cast_identifier] = STATE(6536),
    [sym_operator_name] = STATE(6098),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1811),
    [sym_identifier] = ACTIONS(3604),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3606),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(3378),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3380),
    [anon_sym_using] = ACTIONS(3642),
    [anon_sym_concept] = ACTIONS(3644),
    [anon_sym_requires] = ACTIONS(3612),
  },
  [925] = {
    [sym_identifier] = ACTIONS(3646),
    [anon_sym_COMMA] = ACTIONS(3648),
    [anon_sym_RPAREN] = ACTIONS(3648),
    [anon_sym_LPAREN2] = ACTIONS(3648),
    [anon_sym_BANG] = ACTIONS(3648),
    [anon_sym_TILDE] = ACTIONS(3648),
    [anon_sym_DASH] = ACTIONS(3646),
    [anon_sym_PLUS] = ACTIONS(3646),
    [anon_sym_STAR] = ACTIONS(3648),
    [anon_sym_AMP_AMP] = ACTIONS(3648),
    [anon_sym_AMP] = ACTIONS(3646),
    [anon_sym_SEMI] = ACTIONS(3648),
    [anon_sym___extension__] = ACTIONS(3646),
    [anon_sym_extern] = ACTIONS(3646),
    [anon_sym___attribute__] = ACTIONS(3646),
    [anon_sym_COLON_COLON] = ACTIONS(3648),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3648),
    [anon_sym___declspec] = ACTIONS(3646),
    [anon_sym___based] = ACTIONS(3646),
    [anon_sym_LBRACE] = ACTIONS(3648),
    [anon_sym_signed] = ACTIONS(3646),
    [anon_sym_unsigned] = ACTIONS(3646),
    [anon_sym_long] = ACTIONS(3646),
    [anon_sym_short] = ACTIONS(3646),
    [anon_sym_LBRACK] = ACTIONS(3646),
    [anon_sym_EQ] = ACTIONS(3648),
    [anon_sym_static] = ACTIONS(3646),
    [anon_sym_register] = ACTIONS(3646),
    [anon_sym_inline] = ACTIONS(3646),
    [anon_sym___inline] = ACTIONS(3646),
    [anon_sym___inline__] = ACTIONS(3646),
    [anon_sym___forceinline] = ACTIONS(3646),
    [anon_sym_thread_local] = ACTIONS(3646),
    [anon_sym___thread] = ACTIONS(3646),
    [anon_sym_const] = ACTIONS(3646),
    [anon_sym_constexpr] = ACTIONS(3646),
    [anon_sym_volatile] = ACTIONS(3646),
    [anon_sym_restrict] = ACTIONS(3646),
    [anon_sym___restrict__] = ACTIONS(3646),
    [anon_sym__Atomic] = ACTIONS(3646),
    [anon_sym__Noreturn] = ACTIONS(3646),
    [anon_sym_noreturn] = ACTIONS(3646),
    [anon_sym_mutable] = ACTIONS(3646),
    [anon_sym_constinit] = ACTIONS(3646),
    [anon_sym_consteval] = ACTIONS(3646),
    [anon_sym_PROGMEM] = ACTIONS(3646),
    [aux_sym_primitive_type_token1] = ACTIONS(3646),
    [anon_sym_byte] = ACTIONS(3646),
    [anon_sym_word] = ACTIONS(3646),
    [anon_sym_enum] = ACTIONS(3646),
    [anon_sym_class] = ACTIONS(3646),
    [anon_sym_struct] = ACTIONS(3646),
    [anon_sym_union] = ACTIONS(3646),
    [anon_sym_if] = ACTIONS(3646),
    [anon_sym_switch] = ACTIONS(3646),
    [anon_sym_case] = ACTIONS(3646),
    [anon_sym_default] = ACTIONS(3646),
    [anon_sym_while] = ACTIONS(3646),
    [anon_sym_do] = ACTIONS(3646),
    [anon_sym_for] = ACTIONS(3646),
    [anon_sym_return] = ACTIONS(3646),
    [anon_sym_break] = ACTIONS(3646),
    [anon_sym_continue] = ACTIONS(3646),
    [anon_sym_goto] = ACTIONS(3646),
    [anon_sym___try] = ACTIONS(3646),
    [anon_sym___leave] = ACTIONS(3646),
    [anon_sym_not] = ACTIONS(3646),
    [anon_sym_compl] = ACTIONS(3646),
    [anon_sym_DASH_DASH] = ACTIONS(3648),
    [anon_sym_PLUS_PLUS] = ACTIONS(3648),
    [anon_sym_sizeof] = ACTIONS(3646),
    [anon_sym___alignof__] = ACTIONS(3646),
    [anon_sym___alignof] = ACTIONS(3646),
    [anon_sym__alignof] = ACTIONS(3646),
    [anon_sym_alignof] = ACTIONS(3646),
    [anon_sym__Alignof] = ACTIONS(3646),
    [anon_sym_offsetof] = ACTIONS(3646),
    [anon_sym__Generic] = ACTIONS(3646),
    [anon_sym_asm] = ACTIONS(3646),
    [anon_sym___asm__] = ACTIONS(3646),
    [aux_sym_number_literal_token1] = ACTIONS(3648),
    [aux_sym_number_literal_token2] = ACTIONS(3646),
    [anon_sym_L_SQUOTE] = ACTIONS(3648),
    [anon_sym_u_SQUOTE] = ACTIONS(3648),
    [anon_sym_U_SQUOTE] = ACTIONS(3648),
    [anon_sym_u8_SQUOTE] = ACTIONS(3648),
    [anon_sym_SQUOTE] = ACTIONS(3648),
    [anon_sym_L_DQUOTE] = ACTIONS(3648),
    [anon_sym_u_DQUOTE] = ACTIONS(3648),
    [anon_sym_U_DQUOTE] = ACTIONS(3648),
    [anon_sym_u8_DQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE] = ACTIONS(3648),
    [sym_true] = ACTIONS(3646),
    [sym_false] = ACTIONS(3646),
    [anon_sym_NULL] = ACTIONS(3646),
    [anon_sym_nullptr] = ACTIONS(3646),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3646),
    [anon_sym_decltype] = ACTIONS(3646),
    [anon_sym_virtual] = ACTIONS(3646),
    [anon_sym_alignas] = ACTIONS(3646),
    [anon_sym_explicit] = ACTIONS(3646),
    [anon_sym_typename] = ACTIONS(3646),
    [anon_sym_template] = ACTIONS(3646),
    [anon_sym_GT2] = ACTIONS(3648),
    [anon_sym_operator] = ACTIONS(3646),
    [anon_sym_try] = ACTIONS(3646),
    [anon_sym_delete] = ACTIONS(3646),
    [anon_sym_throw] = ACTIONS(3646),
    [anon_sym_co_return] = ACTIONS(3646),
    [anon_sym_co_yield] = ACTIONS(3646),
    [anon_sym_R_DQUOTE] = ACTIONS(3648),
    [anon_sym_LR_DQUOTE] = ACTIONS(3648),
    [anon_sym_uR_DQUOTE] = ACTIONS(3648),
    [anon_sym_UR_DQUOTE] = ACTIONS(3648),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3648),
    [anon_sym_co_await] = ACTIONS(3646),
    [anon_sym_new] = ACTIONS(3646),
    [anon_sym_requires] = ACTIONS(3646),
    [sym_this] = ACTIONS(3646),
  },
  [926] = {
    [sym_identifier] = ACTIONS(3650),
    [anon_sym_COMMA] = ACTIONS(3652),
    [anon_sym_RPAREN] = ACTIONS(3652),
    [anon_sym_LPAREN2] = ACTIONS(3652),
    [anon_sym_BANG] = ACTIONS(3652),
    [anon_sym_TILDE] = ACTIONS(3652),
    [anon_sym_DASH] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3650),
    [anon_sym_STAR] = ACTIONS(3652),
    [anon_sym_AMP_AMP] = ACTIONS(3652),
    [anon_sym_AMP] = ACTIONS(3650),
    [anon_sym_SEMI] = ACTIONS(3652),
    [anon_sym___extension__] = ACTIONS(3650),
    [anon_sym_extern] = ACTIONS(3650),
    [anon_sym___attribute__] = ACTIONS(3650),
    [anon_sym_COLON_COLON] = ACTIONS(3652),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3652),
    [anon_sym___declspec] = ACTIONS(3650),
    [anon_sym___based] = ACTIONS(3650),
    [anon_sym_LBRACE] = ACTIONS(3652),
    [anon_sym_signed] = ACTIONS(3650),
    [anon_sym_unsigned] = ACTIONS(3650),
    [anon_sym_long] = ACTIONS(3650),
    [anon_sym_short] = ACTIONS(3650),
    [anon_sym_LBRACK] = ACTIONS(3650),
    [anon_sym_EQ] = ACTIONS(3652),
    [anon_sym_static] = ACTIONS(3650),
    [anon_sym_register] = ACTIONS(3650),
    [anon_sym_inline] = ACTIONS(3650),
    [anon_sym___inline] = ACTIONS(3650),
    [anon_sym___inline__] = ACTIONS(3650),
    [anon_sym___forceinline] = ACTIONS(3650),
    [anon_sym_thread_local] = ACTIONS(3650),
    [anon_sym___thread] = ACTIONS(3650),
    [anon_sym_const] = ACTIONS(3650),
    [anon_sym_constexpr] = ACTIONS(3650),
    [anon_sym_volatile] = ACTIONS(3650),
    [anon_sym_restrict] = ACTIONS(3650),
    [anon_sym___restrict__] = ACTIONS(3650),
    [anon_sym__Atomic] = ACTIONS(3650),
    [anon_sym__Noreturn] = ACTIONS(3650),
    [anon_sym_noreturn] = ACTIONS(3650),
    [anon_sym_mutable] = ACTIONS(3650),
    [anon_sym_constinit] = ACTIONS(3650),
    [anon_sym_consteval] = ACTIONS(3650),
    [anon_sym_PROGMEM] = ACTIONS(3650),
    [aux_sym_primitive_type_token1] = ACTIONS(3650),
    [anon_sym_byte] = ACTIONS(3650),
    [anon_sym_word] = ACTIONS(3650),
    [anon_sym_enum] = ACTIONS(3650),
    [anon_sym_class] = ACTIONS(3650),
    [anon_sym_struct] = ACTIONS(3650),
    [anon_sym_union] = ACTIONS(3650),
    [anon_sym_if] = ACTIONS(3650),
    [anon_sym_switch] = ACTIONS(3650),
    [anon_sym_case] = ACTIONS(3650),
    [anon_sym_default] = ACTIONS(3650),
    [anon_sym_while] = ACTIONS(3650),
    [anon_sym_do] = ACTIONS(3650),
    [anon_sym_for] = ACTIONS(3650),
    [anon_sym_return] = ACTIONS(3650),
    [anon_sym_break] = ACTIONS(3650),
    [anon_sym_continue] = ACTIONS(3650),
    [anon_sym_goto] = ACTIONS(3650),
    [anon_sym___try] = ACTIONS(3650),
    [anon_sym___leave] = ACTIONS(3650),
    [anon_sym_not] = ACTIONS(3650),
    [anon_sym_compl] = ACTIONS(3650),
    [anon_sym_DASH_DASH] = ACTIONS(3652),
    [anon_sym_PLUS_PLUS] = ACTIONS(3652),
    [anon_sym_sizeof] = ACTIONS(3650),
    [anon_sym___alignof__] = ACTIONS(3650),
    [anon_sym___alignof] = ACTIONS(3650),
    [anon_sym__alignof] = ACTIONS(3650),
    [anon_sym_alignof] = ACTIONS(3650),
    [anon_sym__Alignof] = ACTIONS(3650),
    [anon_sym_offsetof] = ACTIONS(3650),
    [anon_sym__Generic] = ACTIONS(3650),
    [anon_sym_asm] = ACTIONS(3650),
    [anon_sym___asm__] = ACTIONS(3650),
    [aux_sym_number_literal_token1] = ACTIONS(3652),
    [aux_sym_number_literal_token2] = ACTIONS(3650),
    [anon_sym_L_SQUOTE] = ACTIONS(3652),
    [anon_sym_u_SQUOTE] = ACTIONS(3652),
    [anon_sym_U_SQUOTE] = ACTIONS(3652),
    [anon_sym_u8_SQUOTE] = ACTIONS(3652),
    [anon_sym_SQUOTE] = ACTIONS(3652),
    [anon_sym_L_DQUOTE] = ACTIONS(3652),
    [anon_sym_u_DQUOTE] = ACTIONS(3652),
    [anon_sym_U_DQUOTE] = ACTIONS(3652),
    [anon_sym_u8_DQUOTE] = ACTIONS(3652),
    [anon_sym_DQUOTE] = ACTIONS(3652),
    [sym_true] = ACTIONS(3650),
    [sym_false] = ACTIONS(3650),
    [anon_sym_NULL] = ACTIONS(3650),
    [anon_sym_nullptr] = ACTIONS(3650),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3650),
    [anon_sym_decltype] = ACTIONS(3650),
    [anon_sym_virtual] = ACTIONS(3650),
    [anon_sym_alignas] = ACTIONS(3650),
    [anon_sym_explicit] = ACTIONS(3650),
    [anon_sym_typename] = ACTIONS(3650),
    [anon_sym_template] = ACTIONS(3650),
    [anon_sym_GT2] = ACTIONS(3652),
    [anon_sym_operator] = ACTIONS(3650),
    [anon_sym_try] = ACTIONS(3650),
    [anon_sym_delete] = ACTIONS(3650),
    [anon_sym_throw] = ACTIONS(3650),
    [anon_sym_co_return] = ACTIONS(3650),
    [anon_sym_co_yield] = ACTIONS(3650),
    [anon_sym_R_DQUOTE] = ACTIONS(3652),
    [anon_sym_LR_DQUOTE] = ACTIONS(3652),
    [anon_sym_uR_DQUOTE] = ACTIONS(3652),
    [anon_sym_UR_DQUOTE] = ACTIONS(3652),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3652),
    [anon_sym_co_await] = ACTIONS(3650),
    [anon_sym_new] = ACTIONS(3650),
    [anon_sym_requires] = ACTIONS(3650),
    [sym_this] = ACTIONS(3650),
  },
  [927] = {
    [sym_function_definition] = STATE(1859),
    [sym_declaration] = STATE(1859),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4558),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(3150),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1856),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(5962),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2804),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym__empty_declaration] = STATE(1859),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1838),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(1859),
    [sym_operator_cast] = STATE(6510),
    [sym__constructor_specifiers] = STATE(1838),
    [sym_operator_cast_definition] = STATE(1859),
    [sym_operator_cast_declaration] = STATE(1859),
    [sym_constructor_or_destructor_definition] = STATE(1859),
    [sym_constructor_or_destructor_declaration] = STATE(1859),
    [sym_friend_declaration] = STATE(1859),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(2618),
    [sym_template_function] = STATE(6098),
    [sym_alias_declaration] = STATE(1859),
    [sym_concept_definition] = STATE(1859),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5344),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_qualified_operator_cast_identifier] = STATE(6510),
    [sym_operator_name] = STATE(6098),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1838),
    [sym_identifier] = ACTIONS(3604),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3606),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(2867),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(2869),
    [anon_sym_using] = ACTIONS(3608),
    [anon_sym_concept] = ACTIONS(3610),
  },
  [928] = {
    [sym_function_definition] = STATE(758),
    [sym_declaration] = STATE(758),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4541),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(3150),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1925),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(5959),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2759),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym__empty_declaration] = STATE(758),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1815),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(758),
    [sym_operator_cast] = STATE(6505),
    [sym__constructor_specifiers] = STATE(1815),
    [sym_operator_cast_definition] = STATE(758),
    [sym_operator_cast_declaration] = STATE(758),
    [sym_constructor_or_destructor_definition] = STATE(758),
    [sym_constructor_or_destructor_declaration] = STATE(758),
    [sym_friend_declaration] = STATE(758),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(2618),
    [sym_template_function] = STATE(6098),
    [sym_alias_declaration] = STATE(758),
    [sym_concept_definition] = STATE(758),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5344),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_qualified_operator_cast_identifier] = STATE(6505),
    [sym_operator_name] = STATE(6098),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1815),
    [sym_identifier] = ACTIONS(3604),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3606),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(3620),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3622),
    [anon_sym_using] = ACTIONS(3624),
    [anon_sym_concept] = ACTIONS(233),
  },
  [929] = {
    [sym_function_definition] = STATE(337),
    [sym_declaration] = STATE(337),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4637),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(3150),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1849),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6030),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2782),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym__empty_declaration] = STATE(337),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1930),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(337),
    [sym_operator_cast] = STATE(6494),
    [sym__constructor_specifiers] = STATE(1930),
    [sym_operator_cast_definition] = STATE(337),
    [sym_operator_cast_declaration] = STATE(337),
    [sym_constructor_or_destructor_definition] = STATE(337),
    [sym_constructor_or_destructor_declaration] = STATE(337),
    [sym_friend_declaration] = STATE(337),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(2618),
    [sym_template_function] = STATE(6098),
    [sym_alias_declaration] = STATE(337),
    [sym_concept_definition] = STATE(337),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5344),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_qualified_operator_cast_identifier] = STATE(6494),
    [sym_operator_name] = STATE(6098),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1930),
    [sym_identifier] = ACTIONS(3604),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3606),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(3636),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3638),
    [anon_sym_using] = ACTIONS(3640),
    [anon_sym_concept] = ACTIONS(329),
  },
  [930] = {
    [sym_function_definition] = STATE(2162),
    [sym_declaration] = STATE(2162),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4516),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(3150),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1857),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6014),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2790),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym__empty_declaration] = STATE(2162),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1892),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(2162),
    [sym_operator_cast] = STATE(6512),
    [sym__constructor_specifiers] = STATE(1892),
    [sym_operator_cast_definition] = STATE(2162),
    [sym_operator_cast_declaration] = STATE(2162),
    [sym_constructor_or_destructor_definition] = STATE(2162),
    [sym_constructor_or_destructor_declaration] = STATE(2162),
    [sym_friend_declaration] = STATE(2162),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(2618),
    [sym_template_function] = STATE(6098),
    [sym_alias_declaration] = STATE(2162),
    [sym_concept_definition] = STATE(2162),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5344),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_qualified_operator_cast_identifier] = STATE(6512),
    [sym_operator_name] = STATE(6098),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1892),
    [sym_identifier] = ACTIONS(3604),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3606),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(3400),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3402),
    [anon_sym_using] = ACTIONS(3626),
    [anon_sym_concept] = ACTIONS(3628),
  },
  [931] = {
    [sym_function_definition] = STATE(763),
    [sym_declaration] = STATE(763),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4602),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(3150),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1850),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(5966),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2750),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym__empty_declaration] = STATE(763),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1813),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(763),
    [sym_operator_cast] = STATE(6517),
    [sym__constructor_specifiers] = STATE(1813),
    [sym_operator_cast_definition] = STATE(763),
    [sym_operator_cast_declaration] = STATE(763),
    [sym_constructor_or_destructor_definition] = STATE(763),
    [sym_constructor_or_destructor_declaration] = STATE(763),
    [sym_friend_declaration] = STATE(763),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(2618),
    [sym_template_function] = STATE(6098),
    [sym_alias_declaration] = STATE(763),
    [sym_concept_definition] = STATE(763),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5344),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_qualified_operator_cast_identifier] = STATE(6517),
    [sym_operator_name] = STATE(6098),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1813),
    [sym_identifier] = ACTIONS(3604),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3606),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(3630),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3632),
    [anon_sym_using] = ACTIONS(3634),
    [anon_sym_concept] = ACTIONS(717),
  },
  [932] = {
    [sym_function_definition] = STATE(870),
    [sym_declaration] = STATE(870),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4612),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(3150),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1846),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6007),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2794),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym__empty_declaration] = STATE(870),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1903),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(870),
    [sym_operator_cast] = STATE(6513),
    [sym__constructor_specifiers] = STATE(1903),
    [sym_operator_cast_definition] = STATE(870),
    [sym_operator_cast_declaration] = STATE(870),
    [sym_constructor_or_destructor_definition] = STATE(870),
    [sym_constructor_or_destructor_declaration] = STATE(870),
    [sym_friend_declaration] = STATE(870),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(2618),
    [sym_template_function] = STATE(6098),
    [sym_alias_declaration] = STATE(870),
    [sym_concept_definition] = STATE(870),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5344),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_qualified_operator_cast_identifier] = STATE(6513),
    [sym_operator_name] = STATE(6098),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1903),
    [sym_identifier] = ACTIONS(3604),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3606),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(3614),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3616),
    [anon_sym_using] = ACTIONS(3618),
    [anon_sym_concept] = ACTIONS(147),
  },
  [933] = {
    [sym_function_definition] = STATE(2167),
    [sym_declaration] = STATE(2167),
    [sym__declaration_modifiers] = STATE(3150),
    [sym__declaration_specifiers] = STATE(4569),
    [sym_attribute_specifier] = STATE(3150),
    [sym_attribute_declaration] = STATE(3150),
    [sym_ms_declspec_modifier] = STATE(3150),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(1852),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6010),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3150),
    [sym_type_qualifier] = STATE(3150),
    [sym__type_specifier] = STATE(2754),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym__empty_declaration] = STATE(2167),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(3150),
    [sym_alignas_specifier] = STATE(3150),
    [sym_explicit_function_specifier] = STATE(1811),
    [sym_dependent_type] = STATE(2629),
    [sym_template_declaration] = STATE(2167),
    [sym_operator_cast] = STATE(6536),
    [sym__constructor_specifiers] = STATE(1811),
    [sym_operator_cast_definition] = STATE(2167),
    [sym_operator_cast_declaration] = STATE(2167),
    [sym_constructor_or_destructor_definition] = STATE(2167),
    [sym_constructor_or_destructor_declaration] = STATE(2167),
    [sym_friend_declaration] = STATE(2167),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(2618),
    [sym_template_function] = STATE(6098),
    [sym_alias_declaration] = STATE(2167),
    [sym_concept_definition] = STATE(2167),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5344),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_qualified_operator_cast_identifier] = STATE(6536),
    [sym_operator_name] = STATE(6098),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1811),
    [sym_identifier] = ACTIONS(3604),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3606),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(3378),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3380),
    [anon_sym_using] = ACTIONS(3642),
    [anon_sym_concept] = ACTIONS(3644),
  },
  [934] = {
    [sym_type_qualifier] = STATE(1799),
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4554),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [aux_sym__type_definition_type_repeat1] = STATE(1799),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3654),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym___extension__] = ACTIONS(3656),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(3658),
    [anon_sym_const] = ACTIONS(3656),
    [anon_sym_constexpr] = ACTIONS(3656),
    [anon_sym_volatile] = ACTIONS(3656),
    [anon_sym_restrict] = ACTIONS(3656),
    [anon_sym___restrict__] = ACTIONS(3656),
    [anon_sym__Atomic] = ACTIONS(3656),
    [anon_sym__Noreturn] = ACTIONS(3656),
    [anon_sym_noreturn] = ACTIONS(3656),
    [anon_sym_mutable] = ACTIONS(3656),
    [anon_sym_constinit] = ACTIONS(3656),
    [anon_sym_consteval] = ACTIONS(3656),
    [anon_sym_PROGMEM] = ACTIONS(3656),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [935] = {
    [sym_type_qualifier] = STATE(952),
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4546),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [aux_sym__type_definition_type_repeat1] = STATE(952),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3660),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym___extension__] = ACTIONS(3656),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(3662),
    [anon_sym_const] = ACTIONS(3656),
    [anon_sym_constexpr] = ACTIONS(3656),
    [anon_sym_volatile] = ACTIONS(3656),
    [anon_sym_restrict] = ACTIONS(3656),
    [anon_sym___restrict__] = ACTIONS(3656),
    [anon_sym__Atomic] = ACTIONS(3656),
    [anon_sym__Noreturn] = ACTIONS(3656),
    [anon_sym_noreturn] = ACTIONS(3656),
    [anon_sym_mutable] = ACTIONS(3656),
    [anon_sym_constinit] = ACTIONS(3656),
    [anon_sym_consteval] = ACTIONS(3656),
    [anon_sym_PROGMEM] = ACTIONS(3656),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [936] = {
    [sym_type_qualifier] = STATE(943),
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4500),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [aux_sym__type_definition_type_repeat1] = STATE(943),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3664),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym___extension__] = ACTIONS(3656),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(3666),
    [anon_sym_const] = ACTIONS(3656),
    [anon_sym_constexpr] = ACTIONS(3656),
    [anon_sym_volatile] = ACTIONS(3656),
    [anon_sym_restrict] = ACTIONS(3656),
    [anon_sym___restrict__] = ACTIONS(3656),
    [anon_sym__Atomic] = ACTIONS(3656),
    [anon_sym__Noreturn] = ACTIONS(3656),
    [anon_sym_noreturn] = ACTIONS(3656),
    [anon_sym_mutable] = ACTIONS(3656),
    [anon_sym_constinit] = ACTIONS(3656),
    [anon_sym_consteval] = ACTIONS(3656),
    [anon_sym_PROGMEM] = ACTIONS(3656),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [937] = {
    [sym_type_qualifier] = STATE(945),
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4619),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [aux_sym__type_definition_type_repeat1] = STATE(945),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3668),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym___extension__] = ACTIONS(3656),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(3670),
    [anon_sym_const] = ACTIONS(3656),
    [anon_sym_constexpr] = ACTIONS(3656),
    [anon_sym_volatile] = ACTIONS(3656),
    [anon_sym_restrict] = ACTIONS(3656),
    [anon_sym___restrict__] = ACTIONS(3656),
    [anon_sym__Atomic] = ACTIONS(3656),
    [anon_sym__Noreturn] = ACTIONS(3656),
    [anon_sym_noreturn] = ACTIONS(3656),
    [anon_sym_mutable] = ACTIONS(3656),
    [anon_sym_constinit] = ACTIONS(3656),
    [anon_sym_consteval] = ACTIONS(3656),
    [anon_sym_PROGMEM] = ACTIONS(3656),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [938] = {
    [sym_type_qualifier] = STATE(1799),
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4630),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [aux_sym__type_definition_type_repeat1] = STATE(1799),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym___extension__] = ACTIONS(3656),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(3674),
    [anon_sym_const] = ACTIONS(3656),
    [anon_sym_constexpr] = ACTIONS(3656),
    [anon_sym_volatile] = ACTIONS(3656),
    [anon_sym_restrict] = ACTIONS(3656),
    [anon_sym___restrict__] = ACTIONS(3656),
    [anon_sym__Atomic] = ACTIONS(3656),
    [anon_sym__Noreturn] = ACTIONS(3656),
    [anon_sym_noreturn] = ACTIONS(3656),
    [anon_sym_mutable] = ACTIONS(3656),
    [anon_sym_constinit] = ACTIONS(3656),
    [anon_sym_consteval] = ACTIONS(3656),
    [anon_sym_PROGMEM] = ACTIONS(3656),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [939] = {
    [sym_type_qualifier] = STATE(1799),
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4510),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [aux_sym__type_definition_type_repeat1] = STATE(1799),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3676),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym___extension__] = ACTIONS(3656),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(3678),
    [anon_sym_const] = ACTIONS(3656),
    [anon_sym_constexpr] = ACTIONS(3656),
    [anon_sym_volatile] = ACTIONS(3656),
    [anon_sym_restrict] = ACTIONS(3656),
    [anon_sym___restrict__] = ACTIONS(3656),
    [anon_sym__Atomic] = ACTIONS(3656),
    [anon_sym__Noreturn] = ACTIONS(3656),
    [anon_sym_noreturn] = ACTIONS(3656),
    [anon_sym_mutable] = ACTIONS(3656),
    [anon_sym_constinit] = ACTIONS(3656),
    [anon_sym_consteval] = ACTIONS(3656),
    [anon_sym_PROGMEM] = ACTIONS(3656),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [940] = {
    [sym_type_qualifier] = STATE(939),
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4567),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [aux_sym__type_definition_type_repeat1] = STATE(939),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3680),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym___extension__] = ACTIONS(3656),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(3682),
    [anon_sym_const] = ACTIONS(3656),
    [anon_sym_constexpr] = ACTIONS(3656),
    [anon_sym_volatile] = ACTIONS(3656),
    [anon_sym_restrict] = ACTIONS(3656),
    [anon_sym___restrict__] = ACTIONS(3656),
    [anon_sym__Atomic] = ACTIONS(3656),
    [anon_sym__Noreturn] = ACTIONS(3656),
    [anon_sym_noreturn] = ACTIONS(3656),
    [anon_sym_mutable] = ACTIONS(3656),
    [anon_sym_constinit] = ACTIONS(3656),
    [anon_sym_consteval] = ACTIONS(3656),
    [anon_sym_PROGMEM] = ACTIONS(3656),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [941] = {
    [sym_type_qualifier] = STATE(1799),
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4592),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [aux_sym__type_definition_type_repeat1] = STATE(1799),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym___extension__] = ACTIONS(3656),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(3686),
    [anon_sym_const] = ACTIONS(3656),
    [anon_sym_constexpr] = ACTIONS(3656),
    [anon_sym_volatile] = ACTIONS(3656),
    [anon_sym_restrict] = ACTIONS(3656),
    [anon_sym___restrict__] = ACTIONS(3656),
    [anon_sym__Atomic] = ACTIONS(3656),
    [anon_sym__Noreturn] = ACTIONS(3656),
    [anon_sym_noreturn] = ACTIONS(3656),
    [anon_sym_mutable] = ACTIONS(3656),
    [anon_sym_constinit] = ACTIONS(3656),
    [anon_sym_consteval] = ACTIONS(3656),
    [anon_sym_PROGMEM] = ACTIONS(3656),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [942] = {
    [sym_type_qualifier] = STATE(950),
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4591),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [aux_sym__type_definition_type_repeat1] = STATE(950),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3688),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym___extension__] = ACTIONS(3656),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(3690),
    [anon_sym_const] = ACTIONS(3656),
    [anon_sym_constexpr] = ACTIONS(3656),
    [anon_sym_volatile] = ACTIONS(3656),
    [anon_sym_restrict] = ACTIONS(3656),
    [anon_sym___restrict__] = ACTIONS(3656),
    [anon_sym__Atomic] = ACTIONS(3656),
    [anon_sym__Noreturn] = ACTIONS(3656),
    [anon_sym_noreturn] = ACTIONS(3656),
    [anon_sym_mutable] = ACTIONS(3656),
    [anon_sym_constinit] = ACTIONS(3656),
    [anon_sym_consteval] = ACTIONS(3656),
    [anon_sym_PROGMEM] = ACTIONS(3656),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [943] = {
    [sym_type_qualifier] = STATE(1799),
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4556),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [aux_sym__type_definition_type_repeat1] = STATE(1799),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3692),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym___extension__] = ACTIONS(3656),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(3694),
    [anon_sym_const] = ACTIONS(3656),
    [anon_sym_constexpr] = ACTIONS(3656),
    [anon_sym_volatile] = ACTIONS(3656),
    [anon_sym_restrict] = ACTIONS(3656),
    [anon_sym___restrict__] = ACTIONS(3656),
    [anon_sym__Atomic] = ACTIONS(3656),
    [anon_sym__Noreturn] = ACTIONS(3656),
    [anon_sym_noreturn] = ACTIONS(3656),
    [anon_sym_mutable] = ACTIONS(3656),
    [anon_sym_constinit] = ACTIONS(3656),
    [anon_sym_consteval] = ACTIONS(3656),
    [anon_sym_PROGMEM] = ACTIONS(3656),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [944] = {
    [sym_type_qualifier] = STATE(941),
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4513),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [aux_sym__type_definition_type_repeat1] = STATE(941),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3696),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym___extension__] = ACTIONS(3656),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(3698),
    [anon_sym_const] = ACTIONS(3656),
    [anon_sym_constexpr] = ACTIONS(3656),
    [anon_sym_volatile] = ACTIONS(3656),
    [anon_sym_restrict] = ACTIONS(3656),
    [anon_sym___restrict__] = ACTIONS(3656),
    [anon_sym__Atomic] = ACTIONS(3656),
    [anon_sym__Noreturn] = ACTIONS(3656),
    [anon_sym_noreturn] = ACTIONS(3656),
    [anon_sym_mutable] = ACTIONS(3656),
    [anon_sym_constinit] = ACTIONS(3656),
    [anon_sym_consteval] = ACTIONS(3656),
    [anon_sym_PROGMEM] = ACTIONS(3656),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [945] = {
    [sym_type_qualifier] = STATE(1799),
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4552),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [aux_sym__type_definition_type_repeat1] = STATE(1799),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym___extension__] = ACTIONS(3656),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(3702),
    [anon_sym_const] = ACTIONS(3656),
    [anon_sym_constexpr] = ACTIONS(3656),
    [anon_sym_volatile] = ACTIONS(3656),
    [anon_sym_restrict] = ACTIONS(3656),
    [anon_sym___restrict__] = ACTIONS(3656),
    [anon_sym__Atomic] = ACTIONS(3656),
    [anon_sym__Noreturn] = ACTIONS(3656),
    [anon_sym_noreturn] = ACTIONS(3656),
    [anon_sym_mutable] = ACTIONS(3656),
    [anon_sym_constinit] = ACTIONS(3656),
    [anon_sym_consteval] = ACTIONS(3656),
    [anon_sym_PROGMEM] = ACTIONS(3656),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [946] = {
    [sym_type_qualifier] = STATE(941),
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4513),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [aux_sym__type_definition_type_repeat1] = STATE(941),
    [sym_identifier] = ACTIONS(3704),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3696),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym___extension__] = ACTIONS(3656),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(3698),
    [anon_sym_const] = ACTIONS(3656),
    [anon_sym_constexpr] = ACTIONS(3656),
    [anon_sym_volatile] = ACTIONS(3656),
    [anon_sym_restrict] = ACTIONS(3656),
    [anon_sym___restrict__] = ACTIONS(3656),
    [anon_sym__Atomic] = ACTIONS(3656),
    [anon_sym__Noreturn] = ACTIONS(3656),
    [anon_sym_noreturn] = ACTIONS(3656),
    [anon_sym_mutable] = ACTIONS(3656),
    [anon_sym_constinit] = ACTIONS(3656),
    [anon_sym_consteval] = ACTIONS(3656),
    [anon_sym_PROGMEM] = ACTIONS(3656),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [947] = {
    [sym_type_qualifier] = STATE(949),
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4497),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [aux_sym__type_definition_type_repeat1] = STATE(949),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3706),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym___extension__] = ACTIONS(3656),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(3708),
    [anon_sym_const] = ACTIONS(3656),
    [anon_sym_constexpr] = ACTIONS(3656),
    [anon_sym_volatile] = ACTIONS(3656),
    [anon_sym_restrict] = ACTIONS(3656),
    [anon_sym___restrict__] = ACTIONS(3656),
    [anon_sym__Atomic] = ACTIONS(3656),
    [anon_sym__Noreturn] = ACTIONS(3656),
    [anon_sym_noreturn] = ACTIONS(3656),
    [anon_sym_mutable] = ACTIONS(3656),
    [anon_sym_constinit] = ACTIONS(3656),
    [anon_sym_consteval] = ACTIONS(3656),
    [anon_sym_PROGMEM] = ACTIONS(3656),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [948] = {
    [sym_type_qualifier] = STATE(953),
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4631),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [aux_sym__type_definition_type_repeat1] = STATE(953),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym___extension__] = ACTIONS(3656),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(3712),
    [anon_sym_const] = ACTIONS(3656),
    [anon_sym_constexpr] = ACTIONS(3656),
    [anon_sym_volatile] = ACTIONS(3656),
    [anon_sym_restrict] = ACTIONS(3656),
    [anon_sym___restrict__] = ACTIONS(3656),
    [anon_sym__Atomic] = ACTIONS(3656),
    [anon_sym__Noreturn] = ACTIONS(3656),
    [anon_sym_noreturn] = ACTIONS(3656),
    [anon_sym_mutable] = ACTIONS(3656),
    [anon_sym_constinit] = ACTIONS(3656),
    [anon_sym_consteval] = ACTIONS(3656),
    [anon_sym_PROGMEM] = ACTIONS(3656),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [949] = {
    [sym_type_qualifier] = STATE(1799),
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4603),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [aux_sym__type_definition_type_repeat1] = STATE(1799),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3714),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym___extension__] = ACTIONS(3656),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(3716),
    [anon_sym_const] = ACTIONS(3656),
    [anon_sym_constexpr] = ACTIONS(3656),
    [anon_sym_volatile] = ACTIONS(3656),
    [anon_sym_restrict] = ACTIONS(3656),
    [anon_sym___restrict__] = ACTIONS(3656),
    [anon_sym__Atomic] = ACTIONS(3656),
    [anon_sym__Noreturn] = ACTIONS(3656),
    [anon_sym_noreturn] = ACTIONS(3656),
    [anon_sym_mutable] = ACTIONS(3656),
    [anon_sym_constinit] = ACTIONS(3656),
    [anon_sym_consteval] = ACTIONS(3656),
    [anon_sym_PROGMEM] = ACTIONS(3656),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [950] = {
    [sym_type_qualifier] = STATE(1799),
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4515),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [aux_sym__type_definition_type_repeat1] = STATE(1799),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3718),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym___extension__] = ACTIONS(3656),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(3720),
    [anon_sym_const] = ACTIONS(3656),
    [anon_sym_constexpr] = ACTIONS(3656),
    [anon_sym_volatile] = ACTIONS(3656),
    [anon_sym_restrict] = ACTIONS(3656),
    [anon_sym___restrict__] = ACTIONS(3656),
    [anon_sym__Atomic] = ACTIONS(3656),
    [anon_sym__Noreturn] = ACTIONS(3656),
    [anon_sym_noreturn] = ACTIONS(3656),
    [anon_sym_mutable] = ACTIONS(3656),
    [anon_sym_constinit] = ACTIONS(3656),
    [anon_sym_consteval] = ACTIONS(3656),
    [anon_sym_PROGMEM] = ACTIONS(3656),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [951] = {
    [sym_type_qualifier] = STATE(938),
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4642),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [aux_sym__type_definition_type_repeat1] = STATE(938),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3722),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym___extension__] = ACTIONS(3656),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(3724),
    [anon_sym_const] = ACTIONS(3656),
    [anon_sym_constexpr] = ACTIONS(3656),
    [anon_sym_volatile] = ACTIONS(3656),
    [anon_sym_restrict] = ACTIONS(3656),
    [anon_sym___restrict__] = ACTIONS(3656),
    [anon_sym__Atomic] = ACTIONS(3656),
    [anon_sym__Noreturn] = ACTIONS(3656),
    [anon_sym_noreturn] = ACTIONS(3656),
    [anon_sym_mutable] = ACTIONS(3656),
    [anon_sym_constinit] = ACTIONS(3656),
    [anon_sym_consteval] = ACTIONS(3656),
    [anon_sym_PROGMEM] = ACTIONS(3656),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [952] = {
    [sym_type_qualifier] = STATE(1799),
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4548),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [aux_sym__type_definition_type_repeat1] = STATE(1799),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3726),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym___extension__] = ACTIONS(3656),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(3728),
    [anon_sym_const] = ACTIONS(3656),
    [anon_sym_constexpr] = ACTIONS(3656),
    [anon_sym_volatile] = ACTIONS(3656),
    [anon_sym_restrict] = ACTIONS(3656),
    [anon_sym___restrict__] = ACTIONS(3656),
    [anon_sym__Atomic] = ACTIONS(3656),
    [anon_sym__Noreturn] = ACTIONS(3656),
    [anon_sym_noreturn] = ACTIONS(3656),
    [anon_sym_mutable] = ACTIONS(3656),
    [anon_sym_constinit] = ACTIONS(3656),
    [anon_sym_consteval] = ACTIONS(3656),
    [anon_sym_PROGMEM] = ACTIONS(3656),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [953] = {
    [sym_type_qualifier] = STATE(1799),
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4622),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [aux_sym__type_definition_type_repeat1] = STATE(1799),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3730),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym___extension__] = ACTIONS(3656),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(3732),
    [anon_sym_const] = ACTIONS(3656),
    [anon_sym_constexpr] = ACTIONS(3656),
    [anon_sym_volatile] = ACTIONS(3656),
    [anon_sym_restrict] = ACTIONS(3656),
    [anon_sym___restrict__] = ACTIONS(3656),
    [anon_sym__Atomic] = ACTIONS(3656),
    [anon_sym__Noreturn] = ACTIONS(3656),
    [anon_sym_noreturn] = ACTIONS(3656),
    [anon_sym_mutable] = ACTIONS(3656),
    [anon_sym_constinit] = ACTIONS(3656),
    [anon_sym_consteval] = ACTIONS(3656),
    [anon_sym_PROGMEM] = ACTIONS(3656),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [954] = {
    [sym_type_qualifier] = STATE(934),
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4621),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [aux_sym__type_definition_type_repeat1] = STATE(934),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3734),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym___extension__] = ACTIONS(3656),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(3736),
    [anon_sym_const] = ACTIONS(3656),
    [anon_sym_constexpr] = ACTIONS(3656),
    [anon_sym_volatile] = ACTIONS(3656),
    [anon_sym_restrict] = ACTIONS(3656),
    [anon_sym___restrict__] = ACTIONS(3656),
    [anon_sym__Atomic] = ACTIONS(3656),
    [anon_sym__Noreturn] = ACTIONS(3656),
    [anon_sym_noreturn] = ACTIONS(3656),
    [anon_sym_mutable] = ACTIONS(3656),
    [anon_sym_constinit] = ACTIONS(3656),
    [anon_sym_consteval] = ACTIONS(3656),
    [anon_sym_PROGMEM] = ACTIONS(3656),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [955] = {
    [sym_identifier] = ACTIONS(3738),
    [anon_sym_LPAREN2] = ACTIONS(3741),
    [anon_sym_BANG] = ACTIONS(3744),
    [anon_sym_TILDE] = ACTIONS(3741),
    [anon_sym_DASH] = ACTIONS(3746),
    [anon_sym_PLUS] = ACTIONS(3746),
    [anon_sym_STAR] = ACTIONS(3741),
    [anon_sym_AMP_AMP] = ACTIONS(3748),
    [anon_sym_AMP] = ACTIONS(3738),
    [anon_sym_SEMI] = ACTIONS(3744),
    [anon_sym___extension__] = ACTIONS(3750),
    [anon_sym_extern] = ACTIONS(3750),
    [anon_sym___attribute__] = ACTIONS(3750),
    [anon_sym_COLON_COLON] = ACTIONS(3741),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3741),
    [anon_sym___declspec] = ACTIONS(3750),
    [anon_sym___based] = ACTIONS(3750),
    [anon_sym_LBRACE] = ACTIONS(3744),
    [anon_sym_signed] = ACTIONS(3750),
    [anon_sym_unsigned] = ACTIONS(3750),
    [anon_sym_long] = ACTIONS(3750),
    [anon_sym_short] = ACTIONS(3750),
    [anon_sym_LBRACK] = ACTIONS(3738),
    [anon_sym_static] = ACTIONS(3750),
    [anon_sym_register] = ACTIONS(3750),
    [anon_sym_inline] = ACTIONS(3750),
    [anon_sym___inline] = ACTIONS(3750),
    [anon_sym___inline__] = ACTIONS(3750),
    [anon_sym___forceinline] = ACTIONS(3750),
    [anon_sym_thread_local] = ACTIONS(3750),
    [anon_sym___thread] = ACTIONS(3750),
    [anon_sym_const] = ACTIONS(3750),
    [anon_sym_constexpr] = ACTIONS(3750),
    [anon_sym_volatile] = ACTIONS(3750),
    [anon_sym_restrict] = ACTIONS(3750),
    [anon_sym___restrict__] = ACTIONS(3750),
    [anon_sym__Atomic] = ACTIONS(3750),
    [anon_sym__Noreturn] = ACTIONS(3750),
    [anon_sym_noreturn] = ACTIONS(3750),
    [anon_sym_mutable] = ACTIONS(3750),
    [anon_sym_constinit] = ACTIONS(3750),
    [anon_sym_consteval] = ACTIONS(3750),
    [anon_sym_PROGMEM] = ACTIONS(3750),
    [aux_sym_primitive_type_token1] = ACTIONS(3738),
    [anon_sym_byte] = ACTIONS(3738),
    [anon_sym_word] = ACTIONS(3738),
    [anon_sym_enum] = ACTIONS(3750),
    [anon_sym_class] = ACTIONS(3750),
    [anon_sym_struct] = ACTIONS(3750),
    [anon_sym_union] = ACTIONS(3750),
    [anon_sym_if] = ACTIONS(3746),
    [anon_sym_switch] = ACTIONS(3746),
    [anon_sym_case] = ACTIONS(3746),
    [anon_sym_default] = ACTIONS(3746),
    [anon_sym_while] = ACTIONS(3746),
    [anon_sym_do] = ACTIONS(3746),
    [anon_sym_for] = ACTIONS(3746),
    [anon_sym_return] = ACTIONS(3746),
    [anon_sym_break] = ACTIONS(3746),
    [anon_sym_continue] = ACTIONS(3746),
    [anon_sym_goto] = ACTIONS(3746),
    [anon_sym___try] = ACTIONS(3746),
    [anon_sym___leave] = ACTIONS(3746),
    [anon_sym_not] = ACTIONS(3746),
    [anon_sym_compl] = ACTIONS(3746),
    [anon_sym_DASH_DASH] = ACTIONS(3744),
    [anon_sym_PLUS_PLUS] = ACTIONS(3744),
    [anon_sym_sizeof] = ACTIONS(3746),
    [anon_sym___alignof__] = ACTIONS(3746),
    [anon_sym___alignof] = ACTIONS(3746),
    [anon_sym__alignof] = ACTIONS(3746),
    [anon_sym_alignof] = ACTIONS(3746),
    [anon_sym__Alignof] = ACTIONS(3746),
    [anon_sym_offsetof] = ACTIONS(3746),
    [anon_sym__Generic] = ACTIONS(3746),
    [anon_sym_asm] = ACTIONS(3746),
    [anon_sym___asm__] = ACTIONS(3746),
    [aux_sym_number_literal_token1] = ACTIONS(3744),
    [aux_sym_number_literal_token2] = ACTIONS(3746),
    [anon_sym_L_SQUOTE] = ACTIONS(3744),
    [anon_sym_u_SQUOTE] = ACTIONS(3744),
    [anon_sym_U_SQUOTE] = ACTIONS(3744),
    [anon_sym_u8_SQUOTE] = ACTIONS(3744),
    [anon_sym_SQUOTE] = ACTIONS(3744),
    [anon_sym_L_DQUOTE] = ACTIONS(3744),
    [anon_sym_u_DQUOTE] = ACTIONS(3744),
    [anon_sym_U_DQUOTE] = ACTIONS(3744),
    [anon_sym_u8_DQUOTE] = ACTIONS(3744),
    [anon_sym_DQUOTE] = ACTIONS(3744),
    [sym_true] = ACTIONS(3746),
    [sym_false] = ACTIONS(3746),
    [anon_sym_NULL] = ACTIONS(3746),
    [anon_sym_nullptr] = ACTIONS(3746),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3750),
    [anon_sym_decltype] = ACTIONS(3738),
    [anon_sym_virtual] = ACTIONS(3750),
    [anon_sym_alignas] = ACTIONS(3750),
    [anon_sym_explicit] = ACTIONS(3750),
    [anon_sym_typename] = ACTIONS(3750),
    [anon_sym_template] = ACTIONS(3738),
    [anon_sym_operator] = ACTIONS(3750),
    [anon_sym_try] = ACTIONS(3746),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_throw] = ACTIONS(3746),
    [anon_sym_co_return] = ACTIONS(3746),
    [anon_sym_co_yield] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(3744),
    [anon_sym_LR_DQUOTE] = ACTIONS(3744),
    [anon_sym_uR_DQUOTE] = ACTIONS(3744),
    [anon_sym_UR_DQUOTE] = ACTIONS(3744),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3744),
    [anon_sym_co_await] = ACTIONS(3746),
    [anon_sym_new] = ACTIONS(3746),
    [anon_sym_requires] = ACTIONS(3746),
    [sym_this] = ACTIONS(3746),
  },
  [956] = {
    [sym_catch_clause] = STATE(956),
    [aux_sym_constructor_try_statement_repeat1] = STATE(956),
    [sym_identifier] = ACTIONS(2475),
    [anon_sym_LPAREN2] = ACTIONS(2477),
    [anon_sym_BANG] = ACTIONS(2477),
    [anon_sym_TILDE] = ACTIONS(2477),
    [anon_sym_DASH] = ACTIONS(2475),
    [anon_sym_PLUS] = ACTIONS(2475),
    [anon_sym_STAR] = ACTIONS(2477),
    [anon_sym_AMP] = ACTIONS(2477),
    [anon_sym_SEMI] = ACTIONS(2477),
    [anon_sym___extension__] = ACTIONS(2475),
    [anon_sym_typedef] = ACTIONS(2475),
    [anon_sym_extern] = ACTIONS(2475),
    [anon_sym___attribute__] = ACTIONS(2475),
    [anon_sym_COLON_COLON] = ACTIONS(2477),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2477),
    [anon_sym___declspec] = ACTIONS(2475),
    [anon_sym_LBRACE] = ACTIONS(2477),
    [anon_sym_signed] = ACTIONS(2475),
    [anon_sym_unsigned] = ACTIONS(2475),
    [anon_sym_long] = ACTIONS(2475),
    [anon_sym_short] = ACTIONS(2475),
    [anon_sym_LBRACK] = ACTIONS(2475),
    [anon_sym_static] = ACTIONS(2475),
    [anon_sym_register] = ACTIONS(2475),
    [anon_sym_inline] = ACTIONS(2475),
    [anon_sym___inline] = ACTIONS(2475),
    [anon_sym___inline__] = ACTIONS(2475),
    [anon_sym___forceinline] = ACTIONS(2475),
    [anon_sym_thread_local] = ACTIONS(2475),
    [anon_sym___thread] = ACTIONS(2475),
    [anon_sym_const] = ACTIONS(2475),
    [anon_sym_constexpr] = ACTIONS(2475),
    [anon_sym_volatile] = ACTIONS(2475),
    [anon_sym_restrict] = ACTIONS(2475),
    [anon_sym___restrict__] = ACTIONS(2475),
    [anon_sym__Atomic] = ACTIONS(2475),
    [anon_sym__Noreturn] = ACTIONS(2475),
    [anon_sym_noreturn] = ACTIONS(2475),
    [anon_sym_mutable] = ACTIONS(2475),
    [anon_sym_constinit] = ACTIONS(2475),
    [anon_sym_consteval] = ACTIONS(2475),
    [anon_sym_PROGMEM] = ACTIONS(2475),
    [aux_sym_primitive_type_token1] = ACTIONS(2475),
    [anon_sym_byte] = ACTIONS(2475),
    [anon_sym_word] = ACTIONS(2475),
    [anon_sym_enum] = ACTIONS(2475),
    [anon_sym_class] = ACTIONS(2475),
    [anon_sym_struct] = ACTIONS(2475),
    [anon_sym_union] = ACTIONS(2475),
    [anon_sym_if] = ACTIONS(2475),
    [anon_sym_else] = ACTIONS(2475),
    [anon_sym_switch] = ACTIONS(2475),
    [anon_sym_while] = ACTIONS(2475),
    [anon_sym_do] = ACTIONS(2475),
    [anon_sym_for] = ACTIONS(2475),
    [anon_sym_return] = ACTIONS(2475),
    [anon_sym_break] = ACTIONS(2475),
    [anon_sym_continue] = ACTIONS(2475),
    [anon_sym_goto] = ACTIONS(2475),
    [anon_sym___try] = ACTIONS(2475),
    [anon_sym___leave] = ACTIONS(2475),
    [anon_sym_not] = ACTIONS(2475),
    [anon_sym_compl] = ACTIONS(2475),
    [anon_sym_DASH_DASH] = ACTIONS(2477),
    [anon_sym_PLUS_PLUS] = ACTIONS(2477),
    [anon_sym_sizeof] = ACTIONS(2475),
    [anon_sym___alignof__] = ACTIONS(2475),
    [anon_sym___alignof] = ACTIONS(2475),
    [anon_sym__alignof] = ACTIONS(2475),
    [anon_sym_alignof] = ACTIONS(2475),
    [anon_sym__Alignof] = ACTIONS(2475),
    [anon_sym_offsetof] = ACTIONS(2475),
    [anon_sym__Generic] = ACTIONS(2475),
    [anon_sym_asm] = ACTIONS(2475),
    [anon_sym___asm__] = ACTIONS(2475),
    [aux_sym_number_literal_token1] = ACTIONS(2477),
    [aux_sym_number_literal_token2] = ACTIONS(2475),
    [anon_sym_L_SQUOTE] = ACTIONS(2477),
    [anon_sym_u_SQUOTE] = ACTIONS(2477),
    [anon_sym_U_SQUOTE] = ACTIONS(2477),
    [anon_sym_u8_SQUOTE] = ACTIONS(2477),
    [anon_sym_SQUOTE] = ACTIONS(2477),
    [anon_sym_L_DQUOTE] = ACTIONS(2477),
    [anon_sym_u_DQUOTE] = ACTIONS(2477),
    [anon_sym_U_DQUOTE] = ACTIONS(2477),
    [anon_sym_u8_DQUOTE] = ACTIONS(2477),
    [anon_sym_DQUOTE] = ACTIONS(2477),
    [sym_true] = ACTIONS(2475),
    [sym_false] = ACTIONS(2475),
    [anon_sym_NULL] = ACTIONS(2475),
    [anon_sym_nullptr] = ACTIONS(2475),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2475),
    [anon_sym_decltype] = ACTIONS(2475),
    [anon_sym_virtual] = ACTIONS(2475),
    [anon_sym_alignas] = ACTIONS(2475),
    [anon_sym_typename] = ACTIONS(2475),
    [anon_sym_template] = ACTIONS(2475),
    [anon_sym_try] = ACTIONS(2475),
    [anon_sym_delete] = ACTIONS(2475),
    [anon_sym_throw] = ACTIONS(2475),
    [anon_sym_co_return] = ACTIONS(2475),
    [anon_sym_co_yield] = ACTIONS(2475),
    [anon_sym_catch] = ACTIONS(3752),
    [anon_sym_R_DQUOTE] = ACTIONS(2477),
    [anon_sym_LR_DQUOTE] = ACTIONS(2477),
    [anon_sym_uR_DQUOTE] = ACTIONS(2477),
    [anon_sym_UR_DQUOTE] = ACTIONS(2477),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2477),
    [anon_sym_co_await] = ACTIONS(2475),
    [anon_sym_new] = ACTIONS(2475),
    [anon_sym_requires] = ACTIONS(2475),
    [sym_this] = ACTIONS(2475),
  },
  [957] = {
    [sym_ms_based_modifier] = STATE(8318),
    [sym__declarator] = STATE(6220),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6098),
    [sym_array_declarator] = STATE(6098),
    [sym_primitive_type] = STATE(6848),
    [sym__expression] = STATE(3149),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7357),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3242),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5535),
    [sym_qualified_identifier] = STATE(3247),
    [sym_qualified_type_identifier] = STATE(7357),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(3526),
    [sym_identifier] = ACTIONS(2935),
    [anon_sym_LPAREN2] = ACTIONS(1811),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1815),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(1821),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(1829),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_operator] = ACTIONS(1871),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [958] = {
    [sym_catch_clause] = STATE(956),
    [aux_sym_constructor_try_statement_repeat1] = STATE(956),
    [sym_identifier] = ACTIONS(2482),
    [anon_sym_LPAREN2] = ACTIONS(2484),
    [anon_sym_BANG] = ACTIONS(2484),
    [anon_sym_TILDE] = ACTIONS(2484),
    [anon_sym_DASH] = ACTIONS(2482),
    [anon_sym_PLUS] = ACTIONS(2482),
    [anon_sym_STAR] = ACTIONS(2484),
    [anon_sym_AMP] = ACTIONS(2484),
    [anon_sym_SEMI] = ACTIONS(2484),
    [anon_sym___extension__] = ACTIONS(2482),
    [anon_sym_typedef] = ACTIONS(2482),
    [anon_sym_extern] = ACTIONS(2482),
    [anon_sym___attribute__] = ACTIONS(2482),
    [anon_sym_COLON_COLON] = ACTIONS(2484),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2484),
    [anon_sym___declspec] = ACTIONS(2482),
    [anon_sym_LBRACE] = ACTIONS(2484),
    [anon_sym_signed] = ACTIONS(2482),
    [anon_sym_unsigned] = ACTIONS(2482),
    [anon_sym_long] = ACTIONS(2482),
    [anon_sym_short] = ACTIONS(2482),
    [anon_sym_LBRACK] = ACTIONS(2482),
    [anon_sym_static] = ACTIONS(2482),
    [anon_sym_register] = ACTIONS(2482),
    [anon_sym_inline] = ACTIONS(2482),
    [anon_sym___inline] = ACTIONS(2482),
    [anon_sym___inline__] = ACTIONS(2482),
    [anon_sym___forceinline] = ACTIONS(2482),
    [anon_sym_thread_local] = ACTIONS(2482),
    [anon_sym___thread] = ACTIONS(2482),
    [anon_sym_const] = ACTIONS(2482),
    [anon_sym_constexpr] = ACTIONS(2482),
    [anon_sym_volatile] = ACTIONS(2482),
    [anon_sym_restrict] = ACTIONS(2482),
    [anon_sym___restrict__] = ACTIONS(2482),
    [anon_sym__Atomic] = ACTIONS(2482),
    [anon_sym__Noreturn] = ACTIONS(2482),
    [anon_sym_noreturn] = ACTIONS(2482),
    [anon_sym_mutable] = ACTIONS(2482),
    [anon_sym_constinit] = ACTIONS(2482),
    [anon_sym_consteval] = ACTIONS(2482),
    [anon_sym_PROGMEM] = ACTIONS(2482),
    [aux_sym_primitive_type_token1] = ACTIONS(2482),
    [anon_sym_byte] = ACTIONS(2482),
    [anon_sym_word] = ACTIONS(2482),
    [anon_sym_enum] = ACTIONS(2482),
    [anon_sym_class] = ACTIONS(2482),
    [anon_sym_struct] = ACTIONS(2482),
    [anon_sym_union] = ACTIONS(2482),
    [anon_sym_if] = ACTIONS(2482),
    [anon_sym_else] = ACTIONS(2482),
    [anon_sym_switch] = ACTIONS(2482),
    [anon_sym_while] = ACTIONS(2482),
    [anon_sym_do] = ACTIONS(2482),
    [anon_sym_for] = ACTIONS(2482),
    [anon_sym_return] = ACTIONS(2482),
    [anon_sym_break] = ACTIONS(2482),
    [anon_sym_continue] = ACTIONS(2482),
    [anon_sym_goto] = ACTIONS(2482),
    [anon_sym___try] = ACTIONS(2482),
    [anon_sym___leave] = ACTIONS(2482),
    [anon_sym_not] = ACTIONS(2482),
    [anon_sym_compl] = ACTIONS(2482),
    [anon_sym_DASH_DASH] = ACTIONS(2484),
    [anon_sym_PLUS_PLUS] = ACTIONS(2484),
    [anon_sym_sizeof] = ACTIONS(2482),
    [anon_sym___alignof__] = ACTIONS(2482),
    [anon_sym___alignof] = ACTIONS(2482),
    [anon_sym__alignof] = ACTIONS(2482),
    [anon_sym_alignof] = ACTIONS(2482),
    [anon_sym__Alignof] = ACTIONS(2482),
    [anon_sym_offsetof] = ACTIONS(2482),
    [anon_sym__Generic] = ACTIONS(2482),
    [anon_sym_asm] = ACTIONS(2482),
    [anon_sym___asm__] = ACTIONS(2482),
    [aux_sym_number_literal_token1] = ACTIONS(2484),
    [aux_sym_number_literal_token2] = ACTIONS(2482),
    [anon_sym_L_SQUOTE] = ACTIONS(2484),
    [anon_sym_u_SQUOTE] = ACTIONS(2484),
    [anon_sym_U_SQUOTE] = ACTIONS(2484),
    [anon_sym_u8_SQUOTE] = ACTIONS(2484),
    [anon_sym_SQUOTE] = ACTIONS(2484),
    [anon_sym_L_DQUOTE] = ACTIONS(2484),
    [anon_sym_u_DQUOTE] = ACTIONS(2484),
    [anon_sym_U_DQUOTE] = ACTIONS(2484),
    [anon_sym_u8_DQUOTE] = ACTIONS(2484),
    [anon_sym_DQUOTE] = ACTIONS(2484),
    [sym_true] = ACTIONS(2482),
    [sym_false] = ACTIONS(2482),
    [anon_sym_NULL] = ACTIONS(2482),
    [anon_sym_nullptr] = ACTIONS(2482),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2482),
    [anon_sym_decltype] = ACTIONS(2482),
    [anon_sym_virtual] = ACTIONS(2482),
    [anon_sym_alignas] = ACTIONS(2482),
    [anon_sym_typename] = ACTIONS(2482),
    [anon_sym_template] = ACTIONS(2482),
    [anon_sym_try] = ACTIONS(2482),
    [anon_sym_delete] = ACTIONS(2482),
    [anon_sym_throw] = ACTIONS(2482),
    [anon_sym_co_return] = ACTIONS(2482),
    [anon_sym_co_yield] = ACTIONS(2482),
    [anon_sym_catch] = ACTIONS(3755),
    [anon_sym_R_DQUOTE] = ACTIONS(2484),
    [anon_sym_LR_DQUOTE] = ACTIONS(2484),
    [anon_sym_uR_DQUOTE] = ACTIONS(2484),
    [anon_sym_UR_DQUOTE] = ACTIONS(2484),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2484),
    [anon_sym_co_await] = ACTIONS(2482),
    [anon_sym_new] = ACTIONS(2482),
    [anon_sym_requires] = ACTIONS(2482),
    [sym_this] = ACTIONS(2482),
  },
  [959] = {
    [sym_ms_based_modifier] = STATE(8318),
    [sym__declarator] = STATE(6220),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6098),
    [sym_array_declarator] = STATE(6098),
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2440),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3290),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5554),
    [sym_qualified_identifier] = STATE(3310),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_operator_name] = STATE(6098),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(2911),
    [anon_sym_LPAREN2] = ACTIONS(2913),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_TILDE] = ACTIONS(2915),
    [anon_sym_DASH] = ACTIONS(1931),
    [anon_sym_PLUS] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(1935),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(1829),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1931),
    [anon_sym_compl] = ACTIONS(1931),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_sizeof] = ACTIONS(1937),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_operator] = ACTIONS(1871),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [960] = {
    [sym_identifier] = ACTIONS(1961),
    [anon_sym_LPAREN2] = ACTIONS(1959),
    [anon_sym_BANG] = ACTIONS(1959),
    [anon_sym_TILDE] = ACTIONS(1959),
    [anon_sym_DASH] = ACTIONS(1961),
    [anon_sym_PLUS] = ACTIONS(1961),
    [anon_sym_STAR] = ACTIONS(1959),
    [anon_sym_AMP] = ACTIONS(1959),
    [anon_sym_SEMI] = ACTIONS(1959),
    [anon_sym___extension__] = ACTIONS(1961),
    [anon_sym_typedef] = ACTIONS(1961),
    [anon_sym_extern] = ACTIONS(1961),
    [anon_sym___attribute__] = ACTIONS(1961),
    [anon_sym_COLON_COLON] = ACTIONS(1959),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1959),
    [anon_sym___declspec] = ACTIONS(1961),
    [anon_sym_LBRACE] = ACTIONS(1959),
    [anon_sym_signed] = ACTIONS(1961),
    [anon_sym_unsigned] = ACTIONS(1961),
    [anon_sym_long] = ACTIONS(1961),
    [anon_sym_short] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1961),
    [anon_sym_static] = ACTIONS(1961),
    [anon_sym_register] = ACTIONS(1961),
    [anon_sym_inline] = ACTIONS(1961),
    [anon_sym___inline] = ACTIONS(1961),
    [anon_sym___inline__] = ACTIONS(1961),
    [anon_sym___forceinline] = ACTIONS(1961),
    [anon_sym_thread_local] = ACTIONS(1961),
    [anon_sym___thread] = ACTIONS(1961),
    [anon_sym_const] = ACTIONS(1961),
    [anon_sym_constexpr] = ACTIONS(1961),
    [anon_sym_volatile] = ACTIONS(1961),
    [anon_sym_restrict] = ACTIONS(1961),
    [anon_sym___restrict__] = ACTIONS(1961),
    [anon_sym__Atomic] = ACTIONS(1961),
    [anon_sym__Noreturn] = ACTIONS(1961),
    [anon_sym_noreturn] = ACTIONS(1961),
    [anon_sym_mutable] = ACTIONS(1961),
    [anon_sym_constinit] = ACTIONS(1961),
    [anon_sym_consteval] = ACTIONS(1961),
    [anon_sym_PROGMEM] = ACTIONS(1961),
    [aux_sym_primitive_type_token1] = ACTIONS(1961),
    [anon_sym_byte] = ACTIONS(1961),
    [anon_sym_word] = ACTIONS(1961),
    [anon_sym_enum] = ACTIONS(1961),
    [anon_sym_class] = ACTIONS(1961),
    [anon_sym_struct] = ACTIONS(1961),
    [anon_sym_union] = ACTIONS(1961),
    [anon_sym_if] = ACTIONS(1961),
    [anon_sym_else] = ACTIONS(1961),
    [anon_sym_switch] = ACTIONS(1961),
    [anon_sym_while] = ACTIONS(1961),
    [anon_sym_do] = ACTIONS(1961),
    [anon_sym_for] = ACTIONS(1961),
    [anon_sym_return] = ACTIONS(1961),
    [anon_sym_break] = ACTIONS(1961),
    [anon_sym_continue] = ACTIONS(1961),
    [anon_sym_goto] = ACTIONS(1961),
    [anon_sym___try] = ACTIONS(1961),
    [anon_sym___leave] = ACTIONS(1961),
    [anon_sym_not] = ACTIONS(1961),
    [anon_sym_compl] = ACTIONS(1961),
    [anon_sym_DASH_DASH] = ACTIONS(1959),
    [anon_sym_PLUS_PLUS] = ACTIONS(1959),
    [anon_sym_sizeof] = ACTIONS(1961),
    [anon_sym___alignof__] = ACTIONS(1961),
    [anon_sym___alignof] = ACTIONS(1961),
    [anon_sym__alignof] = ACTIONS(1961),
    [anon_sym_alignof] = ACTIONS(1961),
    [anon_sym__Alignof] = ACTIONS(1961),
    [anon_sym_offsetof] = ACTIONS(1961),
    [anon_sym__Generic] = ACTIONS(1961),
    [anon_sym_asm] = ACTIONS(1961),
    [anon_sym___asm__] = ACTIONS(1961),
    [aux_sym_number_literal_token1] = ACTIONS(1959),
    [aux_sym_number_literal_token2] = ACTIONS(1961),
    [anon_sym_L_SQUOTE] = ACTIONS(1959),
    [anon_sym_u_SQUOTE] = ACTIONS(1959),
    [anon_sym_U_SQUOTE] = ACTIONS(1959),
    [anon_sym_u8_SQUOTE] = ACTIONS(1959),
    [anon_sym_SQUOTE] = ACTIONS(1959),
    [anon_sym_L_DQUOTE] = ACTIONS(1959),
    [anon_sym_u_DQUOTE] = ACTIONS(1959),
    [anon_sym_U_DQUOTE] = ACTIONS(1959),
    [anon_sym_u8_DQUOTE] = ACTIONS(1959),
    [anon_sym_DQUOTE] = ACTIONS(1959),
    [sym_true] = ACTIONS(1961),
    [sym_false] = ACTIONS(1961),
    [anon_sym_NULL] = ACTIONS(1961),
    [anon_sym_nullptr] = ACTIONS(1961),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1961),
    [anon_sym_decltype] = ACTIONS(1961),
    [anon_sym_virtual] = ACTIONS(1961),
    [anon_sym_alignas] = ACTIONS(1961),
    [anon_sym_typename] = ACTIONS(1961),
    [anon_sym_template] = ACTIONS(1961),
    [anon_sym_try] = ACTIONS(1961),
    [anon_sym_delete] = ACTIONS(1961),
    [anon_sym_throw] = ACTIONS(1961),
    [anon_sym_co_return] = ACTIONS(1961),
    [anon_sym_co_yield] = ACTIONS(1961),
    [anon_sym_catch] = ACTIONS(1961),
    [anon_sym_R_DQUOTE] = ACTIONS(1959),
    [anon_sym_LR_DQUOTE] = ACTIONS(1959),
    [anon_sym_uR_DQUOTE] = ACTIONS(1959),
    [anon_sym_UR_DQUOTE] = ACTIONS(1959),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1959),
    [anon_sym_co_await] = ACTIONS(1961),
    [anon_sym_new] = ACTIONS(1961),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1961),
  },
  [961] = {
    [sym_else_clause] = STATE(1023),
    [sym_identifier] = ACTIONS(2523),
    [anon_sym_LPAREN2] = ACTIONS(2525),
    [anon_sym_BANG] = ACTIONS(2525),
    [anon_sym_TILDE] = ACTIONS(2525),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_PLUS] = ACTIONS(2523),
    [anon_sym_STAR] = ACTIONS(2525),
    [anon_sym_AMP] = ACTIONS(2525),
    [anon_sym_SEMI] = ACTIONS(2525),
    [anon_sym___extension__] = ACTIONS(2523),
    [anon_sym_typedef] = ACTIONS(2523),
    [anon_sym_extern] = ACTIONS(2523),
    [anon_sym___attribute__] = ACTIONS(2523),
    [anon_sym_COLON_COLON] = ACTIONS(2525),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2525),
    [anon_sym___declspec] = ACTIONS(2523),
    [anon_sym_LBRACE] = ACTIONS(2525),
    [anon_sym_signed] = ACTIONS(2523),
    [anon_sym_unsigned] = ACTIONS(2523),
    [anon_sym_long] = ACTIONS(2523),
    [anon_sym_short] = ACTIONS(2523),
    [anon_sym_LBRACK] = ACTIONS(2523),
    [anon_sym_static] = ACTIONS(2523),
    [anon_sym_register] = ACTIONS(2523),
    [anon_sym_inline] = ACTIONS(2523),
    [anon_sym___inline] = ACTIONS(2523),
    [anon_sym___inline__] = ACTIONS(2523),
    [anon_sym___forceinline] = ACTIONS(2523),
    [anon_sym_thread_local] = ACTIONS(2523),
    [anon_sym___thread] = ACTIONS(2523),
    [anon_sym_const] = ACTIONS(2523),
    [anon_sym_constexpr] = ACTIONS(2523),
    [anon_sym_volatile] = ACTIONS(2523),
    [anon_sym_restrict] = ACTIONS(2523),
    [anon_sym___restrict__] = ACTIONS(2523),
    [anon_sym__Atomic] = ACTIONS(2523),
    [anon_sym__Noreturn] = ACTIONS(2523),
    [anon_sym_noreturn] = ACTIONS(2523),
    [anon_sym_mutable] = ACTIONS(2523),
    [anon_sym_constinit] = ACTIONS(2523),
    [anon_sym_consteval] = ACTIONS(2523),
    [anon_sym_PROGMEM] = ACTIONS(2523),
    [aux_sym_primitive_type_token1] = ACTIONS(2523),
    [anon_sym_byte] = ACTIONS(2523),
    [anon_sym_word] = ACTIONS(2523),
    [anon_sym_enum] = ACTIONS(2523),
    [anon_sym_class] = ACTIONS(2523),
    [anon_sym_struct] = ACTIONS(2523),
    [anon_sym_union] = ACTIONS(2523),
    [anon_sym_if] = ACTIONS(2523),
    [anon_sym_else] = ACTIONS(3757),
    [anon_sym_switch] = ACTIONS(2523),
    [anon_sym_while] = ACTIONS(2523),
    [anon_sym_do] = ACTIONS(2523),
    [anon_sym_for] = ACTIONS(2523),
    [anon_sym_return] = ACTIONS(2523),
    [anon_sym_break] = ACTIONS(2523),
    [anon_sym_continue] = ACTIONS(2523),
    [anon_sym_goto] = ACTIONS(2523),
    [anon_sym___try] = ACTIONS(2523),
    [anon_sym___leave] = ACTIONS(2523),
    [anon_sym_not] = ACTIONS(2523),
    [anon_sym_compl] = ACTIONS(2523),
    [anon_sym_DASH_DASH] = ACTIONS(2525),
    [anon_sym_PLUS_PLUS] = ACTIONS(2525),
    [anon_sym_sizeof] = ACTIONS(2523),
    [anon_sym___alignof__] = ACTIONS(2523),
    [anon_sym___alignof] = ACTIONS(2523),
    [anon_sym__alignof] = ACTIONS(2523),
    [anon_sym_alignof] = ACTIONS(2523),
    [anon_sym__Alignof] = ACTIONS(2523),
    [anon_sym_offsetof] = ACTIONS(2523),
    [anon_sym__Generic] = ACTIONS(2523),
    [anon_sym_asm] = ACTIONS(2523),
    [anon_sym___asm__] = ACTIONS(2523),
    [aux_sym_number_literal_token1] = ACTIONS(2525),
    [aux_sym_number_literal_token2] = ACTIONS(2523),
    [anon_sym_L_SQUOTE] = ACTIONS(2525),
    [anon_sym_u_SQUOTE] = ACTIONS(2525),
    [anon_sym_U_SQUOTE] = ACTIONS(2525),
    [anon_sym_u8_SQUOTE] = ACTIONS(2525),
    [anon_sym_SQUOTE] = ACTIONS(2525),
    [anon_sym_L_DQUOTE] = ACTIONS(2525),
    [anon_sym_u_DQUOTE] = ACTIONS(2525),
    [anon_sym_U_DQUOTE] = ACTIONS(2525),
    [anon_sym_u8_DQUOTE] = ACTIONS(2525),
    [anon_sym_DQUOTE] = ACTIONS(2525),
    [sym_true] = ACTIONS(2523),
    [sym_false] = ACTIONS(2523),
    [anon_sym_NULL] = ACTIONS(2523),
    [anon_sym_nullptr] = ACTIONS(2523),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2523),
    [anon_sym_decltype] = ACTIONS(2523),
    [anon_sym_virtual] = ACTIONS(2523),
    [anon_sym_alignas] = ACTIONS(2523),
    [anon_sym_typename] = ACTIONS(2523),
    [anon_sym_template] = ACTIONS(2523),
    [anon_sym_try] = ACTIONS(2523),
    [anon_sym_delete] = ACTIONS(2523),
    [anon_sym_throw] = ACTIONS(2523),
    [anon_sym_co_return] = ACTIONS(2523),
    [anon_sym_co_yield] = ACTIONS(2523),
    [anon_sym_R_DQUOTE] = ACTIONS(2525),
    [anon_sym_LR_DQUOTE] = ACTIONS(2525),
    [anon_sym_uR_DQUOTE] = ACTIONS(2525),
    [anon_sym_UR_DQUOTE] = ACTIONS(2525),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2525),
    [anon_sym_co_await] = ACTIONS(2523),
    [anon_sym_new] = ACTIONS(2523),
    [anon_sym_requires] = ACTIONS(2523),
    [sym_this] = ACTIONS(2523),
  },
  [962] = {
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_LPAREN2] = ACTIONS(1955),
    [anon_sym_BANG] = ACTIONS(1955),
    [anon_sym_TILDE] = ACTIONS(1955),
    [anon_sym_DASH] = ACTIONS(1957),
    [anon_sym_PLUS] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(1955),
    [anon_sym_AMP] = ACTIONS(1955),
    [anon_sym_SEMI] = ACTIONS(1955),
    [anon_sym___extension__] = ACTIONS(1957),
    [anon_sym_typedef] = ACTIONS(1957),
    [anon_sym_extern] = ACTIONS(1957),
    [anon_sym___attribute__] = ACTIONS(1957),
    [anon_sym_COLON_COLON] = ACTIONS(1955),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1955),
    [anon_sym___declspec] = ACTIONS(1957),
    [anon_sym_LBRACE] = ACTIONS(1955),
    [anon_sym_signed] = ACTIONS(1957),
    [anon_sym_unsigned] = ACTIONS(1957),
    [anon_sym_long] = ACTIONS(1957),
    [anon_sym_short] = ACTIONS(1957),
    [anon_sym_LBRACK] = ACTIONS(1957),
    [anon_sym_static] = ACTIONS(1957),
    [anon_sym_register] = ACTIONS(1957),
    [anon_sym_inline] = ACTIONS(1957),
    [anon_sym___inline] = ACTIONS(1957),
    [anon_sym___inline__] = ACTIONS(1957),
    [anon_sym___forceinline] = ACTIONS(1957),
    [anon_sym_thread_local] = ACTIONS(1957),
    [anon_sym___thread] = ACTIONS(1957),
    [anon_sym_const] = ACTIONS(1957),
    [anon_sym_constexpr] = ACTIONS(1957),
    [anon_sym_volatile] = ACTIONS(1957),
    [anon_sym_restrict] = ACTIONS(1957),
    [anon_sym___restrict__] = ACTIONS(1957),
    [anon_sym__Atomic] = ACTIONS(1957),
    [anon_sym__Noreturn] = ACTIONS(1957),
    [anon_sym_noreturn] = ACTIONS(1957),
    [anon_sym_mutable] = ACTIONS(1957),
    [anon_sym_constinit] = ACTIONS(1957),
    [anon_sym_consteval] = ACTIONS(1957),
    [anon_sym_PROGMEM] = ACTIONS(1957),
    [aux_sym_primitive_type_token1] = ACTIONS(1957),
    [anon_sym_byte] = ACTIONS(1957),
    [anon_sym_word] = ACTIONS(1957),
    [anon_sym_enum] = ACTIONS(1957),
    [anon_sym_class] = ACTIONS(1957),
    [anon_sym_struct] = ACTIONS(1957),
    [anon_sym_union] = ACTIONS(1957),
    [anon_sym_if] = ACTIONS(1957),
    [anon_sym_else] = ACTIONS(1957),
    [anon_sym_switch] = ACTIONS(1957),
    [anon_sym_while] = ACTIONS(1957),
    [anon_sym_do] = ACTIONS(1957),
    [anon_sym_for] = ACTIONS(1957),
    [anon_sym_return] = ACTIONS(1957),
    [anon_sym_break] = ACTIONS(1957),
    [anon_sym_continue] = ACTIONS(1957),
    [anon_sym_goto] = ACTIONS(1957),
    [anon_sym___try] = ACTIONS(1957),
    [anon_sym___leave] = ACTIONS(1957),
    [anon_sym_not] = ACTIONS(1957),
    [anon_sym_compl] = ACTIONS(1957),
    [anon_sym_DASH_DASH] = ACTIONS(1955),
    [anon_sym_PLUS_PLUS] = ACTIONS(1955),
    [anon_sym_sizeof] = ACTIONS(1957),
    [anon_sym___alignof__] = ACTIONS(1957),
    [anon_sym___alignof] = ACTIONS(1957),
    [anon_sym__alignof] = ACTIONS(1957),
    [anon_sym_alignof] = ACTIONS(1957),
    [anon_sym__Alignof] = ACTIONS(1957),
    [anon_sym_offsetof] = ACTIONS(1957),
    [anon_sym__Generic] = ACTIONS(1957),
    [anon_sym_asm] = ACTIONS(1957),
    [anon_sym___asm__] = ACTIONS(1957),
    [aux_sym_number_literal_token1] = ACTIONS(1955),
    [aux_sym_number_literal_token2] = ACTIONS(1957),
    [anon_sym_L_SQUOTE] = ACTIONS(1955),
    [anon_sym_u_SQUOTE] = ACTIONS(1955),
    [anon_sym_U_SQUOTE] = ACTIONS(1955),
    [anon_sym_u8_SQUOTE] = ACTIONS(1955),
    [anon_sym_SQUOTE] = ACTIONS(1955),
    [anon_sym_L_DQUOTE] = ACTIONS(1955),
    [anon_sym_u_DQUOTE] = ACTIONS(1955),
    [anon_sym_U_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8_DQUOTE] = ACTIONS(1955),
    [anon_sym_DQUOTE] = ACTIONS(1955),
    [sym_true] = ACTIONS(1957),
    [sym_false] = ACTIONS(1957),
    [anon_sym_NULL] = ACTIONS(1957),
    [anon_sym_nullptr] = ACTIONS(1957),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1957),
    [anon_sym_decltype] = ACTIONS(1957),
    [anon_sym_virtual] = ACTIONS(1957),
    [anon_sym_alignas] = ACTIONS(1957),
    [anon_sym_typename] = ACTIONS(1957),
    [anon_sym_template] = ACTIONS(1957),
    [anon_sym_try] = ACTIONS(1957),
    [anon_sym_delete] = ACTIONS(1957),
    [anon_sym_throw] = ACTIONS(1957),
    [anon_sym_co_return] = ACTIONS(1957),
    [anon_sym_co_yield] = ACTIONS(1957),
    [anon_sym_catch] = ACTIONS(1957),
    [anon_sym_R_DQUOTE] = ACTIONS(1955),
    [anon_sym_LR_DQUOTE] = ACTIONS(1955),
    [anon_sym_uR_DQUOTE] = ACTIONS(1955),
    [anon_sym_UR_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1955),
    [anon_sym_co_await] = ACTIONS(1957),
    [anon_sym_new] = ACTIONS(1957),
    [anon_sym_requires] = ACTIONS(1957),
    [sym_this] = ACTIONS(1957),
  },
  [963] = {
    [sym_string_literal] = STATE(2617),
    [sym_template_argument_list] = STATE(1740),
    [sym_raw_string_literal] = STATE(2617),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2716),
    [sym_identifier] = ACTIONS(3759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3761),
    [anon_sym_COMMA] = ACTIONS(3761),
    [anon_sym_LPAREN2] = ACTIONS(3763),
    [anon_sym_TILDE] = ACTIONS(3767),
    [anon_sym_DASH] = ACTIONS(3769),
    [anon_sym_PLUS] = ACTIONS(3769),
    [anon_sym_STAR] = ACTIONS(3771),
    [anon_sym_SLASH] = ACTIONS(3769),
    [anon_sym_PERCENT] = ACTIONS(3769),
    [anon_sym_PIPE_PIPE] = ACTIONS(3761),
    [anon_sym_AMP_AMP] = ACTIONS(3774),
    [anon_sym_PIPE] = ACTIONS(3769),
    [anon_sym_CARET] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(3771),
    [anon_sym_EQ_EQ] = ACTIONS(3761),
    [anon_sym_BANG_EQ] = ACTIONS(3761),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3761),
    [anon_sym_LT_EQ] = ACTIONS(3769),
    [anon_sym_LT] = ACTIONS(3777),
    [anon_sym_LT_LT] = ACTIONS(3769),
    [anon_sym_GT_GT] = ACTIONS(3769),
    [anon_sym_SEMI] = ACTIONS(3774),
    [anon_sym___extension__] = ACTIONS(3759),
    [anon_sym_extern] = ACTIONS(3759),
    [anon_sym___attribute__] = ACTIONS(3759),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3782),
    [anon_sym___declspec] = ACTIONS(3759),
    [anon_sym___based] = ACTIONS(3759),
    [anon_sym___cdecl] = ACTIONS(3759),
    [anon_sym___clrcall] = ACTIONS(3759),
    [anon_sym___stdcall] = ACTIONS(3759),
    [anon_sym___fastcall] = ACTIONS(3759),
    [anon_sym___thiscall] = ACTIONS(3759),
    [anon_sym___vectorcall] = ACTIONS(3759),
    [anon_sym_LBRACE] = ACTIONS(3785),
    [anon_sym_RBRACE] = ACTIONS(3761),
    [anon_sym_signed] = ACTIONS(3787),
    [anon_sym_unsigned] = ACTIONS(3787),
    [anon_sym_long] = ACTIONS(3787),
    [anon_sym_short] = ACTIONS(3787),
    [anon_sym_LBRACK] = ACTIONS(3789),
    [anon_sym_EQ] = ACTIONS(3793),
    [anon_sym_static] = ACTIONS(3759),
    [anon_sym_register] = ACTIONS(3759),
    [anon_sym_inline] = ACTIONS(3759),
    [anon_sym___inline] = ACTIONS(3759),
    [anon_sym___inline__] = ACTIONS(3759),
    [anon_sym___forceinline] = ACTIONS(3759),
    [anon_sym_thread_local] = ACTIONS(3759),
    [anon_sym___thread] = ACTIONS(3759),
    [anon_sym_const] = ACTIONS(3759),
    [anon_sym_constexpr] = ACTIONS(3759),
    [anon_sym_volatile] = ACTIONS(3759),
    [anon_sym_restrict] = ACTIONS(3759),
    [anon_sym___restrict__] = ACTIONS(3759),
    [anon_sym__Atomic] = ACTIONS(3759),
    [anon_sym__Noreturn] = ACTIONS(3759),
    [anon_sym_noreturn] = ACTIONS(3759),
    [anon_sym_mutable] = ACTIONS(3759),
    [anon_sym_constinit] = ACTIONS(3759),
    [anon_sym_consteval] = ACTIONS(3759),
    [anon_sym_PROGMEM] = ACTIONS(3759),
    [anon_sym_COLON] = ACTIONS(3795),
    [anon_sym_QMARK] = ACTIONS(3761),
    [anon_sym_STAR_EQ] = ACTIONS(3797),
    [anon_sym_SLASH_EQ] = ACTIONS(3797),
    [anon_sym_PERCENT_EQ] = ACTIONS(3797),
    [anon_sym_PLUS_EQ] = ACTIONS(3797),
    [anon_sym_DASH_EQ] = ACTIONS(3797),
    [anon_sym_LT_LT_EQ] = ACTIONS(3797),
    [anon_sym_GT_GT_EQ] = ACTIONS(3797),
    [anon_sym_AMP_EQ] = ACTIONS(3797),
    [anon_sym_CARET_EQ] = ACTIONS(3797),
    [anon_sym_PIPE_EQ] = ACTIONS(3797),
    [anon_sym_and_eq] = ACTIONS(3793),
    [anon_sym_or_eq] = ACTIONS(3793),
    [anon_sym_xor_eq] = ACTIONS(3793),
    [anon_sym_LT_EQ_GT] = ACTIONS(3761),
    [anon_sym_or] = ACTIONS(3769),
    [anon_sym_and] = ACTIONS(3769),
    [anon_sym_bitor] = ACTIONS(3769),
    [anon_sym_xor] = ACTIONS(3769),
    [anon_sym_bitand] = ACTIONS(3769),
    [anon_sym_not_eq] = ACTIONS(3769),
    [anon_sym_DASH_DASH] = ACTIONS(3761),
    [anon_sym_PLUS_PLUS] = ACTIONS(3761),
    [anon_sym_DOT] = ACTIONS(3769),
    [anon_sym_DOT_STAR] = ACTIONS(3761),
    [anon_sym_DASH_GT] = ACTIONS(3761),
    [anon_sym_L_DQUOTE] = ACTIONS(3204),
    [anon_sym_u_DQUOTE] = ACTIONS(3204),
    [anon_sym_U_DQUOTE] = ACTIONS(3204),
    [anon_sym_u8_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3204),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3759),
    [anon_sym_decltype] = ACTIONS(3759),
    [anon_sym_virtual] = ACTIONS(3759),
    [anon_sym_alignas] = ACTIONS(3759),
    [anon_sym_template] = ACTIONS(3759),
    [anon_sym_operator] = ACTIONS(3759),
    [anon_sym_R_DQUOTE] = ACTIONS(3208),
    [anon_sym_LR_DQUOTE] = ACTIONS(3208),
    [anon_sym_uR_DQUOTE] = ACTIONS(3208),
    [anon_sym_UR_DQUOTE] = ACTIONS(3208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3208),
  },
  [964] = {
    [sym_else_clause] = STATE(1018),
    [sym_identifier] = ACTIONS(2496),
    [anon_sym_LPAREN2] = ACTIONS(2498),
    [anon_sym_BANG] = ACTIONS(2498),
    [anon_sym_TILDE] = ACTIONS(2498),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_STAR] = ACTIONS(2498),
    [anon_sym_AMP] = ACTIONS(2498),
    [anon_sym_SEMI] = ACTIONS(2498),
    [anon_sym___extension__] = ACTIONS(2496),
    [anon_sym_typedef] = ACTIONS(2496),
    [anon_sym_extern] = ACTIONS(2496),
    [anon_sym___attribute__] = ACTIONS(2496),
    [anon_sym_COLON_COLON] = ACTIONS(2498),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2498),
    [anon_sym___declspec] = ACTIONS(2496),
    [anon_sym_LBRACE] = ACTIONS(2498),
    [anon_sym_signed] = ACTIONS(2496),
    [anon_sym_unsigned] = ACTIONS(2496),
    [anon_sym_long] = ACTIONS(2496),
    [anon_sym_short] = ACTIONS(2496),
    [anon_sym_LBRACK] = ACTIONS(2496),
    [anon_sym_static] = ACTIONS(2496),
    [anon_sym_register] = ACTIONS(2496),
    [anon_sym_inline] = ACTIONS(2496),
    [anon_sym___inline] = ACTIONS(2496),
    [anon_sym___inline__] = ACTIONS(2496),
    [anon_sym___forceinline] = ACTIONS(2496),
    [anon_sym_thread_local] = ACTIONS(2496),
    [anon_sym___thread] = ACTIONS(2496),
    [anon_sym_const] = ACTIONS(2496),
    [anon_sym_constexpr] = ACTIONS(2496),
    [anon_sym_volatile] = ACTIONS(2496),
    [anon_sym_restrict] = ACTIONS(2496),
    [anon_sym___restrict__] = ACTIONS(2496),
    [anon_sym__Atomic] = ACTIONS(2496),
    [anon_sym__Noreturn] = ACTIONS(2496),
    [anon_sym_noreturn] = ACTIONS(2496),
    [anon_sym_mutable] = ACTIONS(2496),
    [anon_sym_constinit] = ACTIONS(2496),
    [anon_sym_consteval] = ACTIONS(2496),
    [anon_sym_PROGMEM] = ACTIONS(2496),
    [aux_sym_primitive_type_token1] = ACTIONS(2496),
    [anon_sym_byte] = ACTIONS(2496),
    [anon_sym_word] = ACTIONS(2496),
    [anon_sym_enum] = ACTIONS(2496),
    [anon_sym_class] = ACTIONS(2496),
    [anon_sym_struct] = ACTIONS(2496),
    [anon_sym_union] = ACTIONS(2496),
    [anon_sym_if] = ACTIONS(2496),
    [anon_sym_else] = ACTIONS(3757),
    [anon_sym_switch] = ACTIONS(2496),
    [anon_sym_while] = ACTIONS(2496),
    [anon_sym_do] = ACTIONS(2496),
    [anon_sym_for] = ACTIONS(2496),
    [anon_sym_return] = ACTIONS(2496),
    [anon_sym_break] = ACTIONS(2496),
    [anon_sym_continue] = ACTIONS(2496),
    [anon_sym_goto] = ACTIONS(2496),
    [anon_sym___try] = ACTIONS(2496),
    [anon_sym___leave] = ACTIONS(2496),
    [anon_sym_not] = ACTIONS(2496),
    [anon_sym_compl] = ACTIONS(2496),
    [anon_sym_DASH_DASH] = ACTIONS(2498),
    [anon_sym_PLUS_PLUS] = ACTIONS(2498),
    [anon_sym_sizeof] = ACTIONS(2496),
    [anon_sym___alignof__] = ACTIONS(2496),
    [anon_sym___alignof] = ACTIONS(2496),
    [anon_sym__alignof] = ACTIONS(2496),
    [anon_sym_alignof] = ACTIONS(2496),
    [anon_sym__Alignof] = ACTIONS(2496),
    [anon_sym_offsetof] = ACTIONS(2496),
    [anon_sym__Generic] = ACTIONS(2496),
    [anon_sym_asm] = ACTIONS(2496),
    [anon_sym___asm__] = ACTIONS(2496),
    [aux_sym_number_literal_token1] = ACTIONS(2498),
    [aux_sym_number_literal_token2] = ACTIONS(2496),
    [anon_sym_L_SQUOTE] = ACTIONS(2498),
    [anon_sym_u_SQUOTE] = ACTIONS(2498),
    [anon_sym_U_SQUOTE] = ACTIONS(2498),
    [anon_sym_u8_SQUOTE] = ACTIONS(2498),
    [anon_sym_SQUOTE] = ACTIONS(2498),
    [anon_sym_L_DQUOTE] = ACTIONS(2498),
    [anon_sym_u_DQUOTE] = ACTIONS(2498),
    [anon_sym_U_DQUOTE] = ACTIONS(2498),
    [anon_sym_u8_DQUOTE] = ACTIONS(2498),
    [anon_sym_DQUOTE] = ACTIONS(2498),
    [sym_true] = ACTIONS(2496),
    [sym_false] = ACTIONS(2496),
    [anon_sym_NULL] = ACTIONS(2496),
    [anon_sym_nullptr] = ACTIONS(2496),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2496),
    [anon_sym_decltype] = ACTIONS(2496),
    [anon_sym_virtual] = ACTIONS(2496),
    [anon_sym_alignas] = ACTIONS(2496),
    [anon_sym_typename] = ACTIONS(2496),
    [anon_sym_template] = ACTIONS(2496),
    [anon_sym_try] = ACTIONS(2496),
    [anon_sym_delete] = ACTIONS(2496),
    [anon_sym_throw] = ACTIONS(2496),
    [anon_sym_co_return] = ACTIONS(2496),
    [anon_sym_co_yield] = ACTIONS(2496),
    [anon_sym_R_DQUOTE] = ACTIONS(2498),
    [anon_sym_LR_DQUOTE] = ACTIONS(2498),
    [anon_sym_uR_DQUOTE] = ACTIONS(2498),
    [anon_sym_UR_DQUOTE] = ACTIONS(2498),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2498),
    [anon_sym_co_await] = ACTIONS(2496),
    [anon_sym_new] = ACTIONS(2496),
    [anon_sym_requires] = ACTIONS(2496),
    [sym_this] = ACTIONS(2496),
  },
  [965] = {
    [sym_identifier] = ACTIONS(2527),
    [anon_sym_LPAREN2] = ACTIONS(2529),
    [anon_sym_BANG] = ACTIONS(2529),
    [anon_sym_TILDE] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2527),
    [anon_sym_PLUS] = ACTIONS(2527),
    [anon_sym_STAR] = ACTIONS(2529),
    [anon_sym_AMP] = ACTIONS(2529),
    [anon_sym_SEMI] = ACTIONS(2529),
    [anon_sym___extension__] = ACTIONS(2527),
    [anon_sym_typedef] = ACTIONS(2527),
    [anon_sym_extern] = ACTIONS(2527),
    [anon_sym___attribute__] = ACTIONS(2527),
    [anon_sym_COLON_COLON] = ACTIONS(2529),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2529),
    [anon_sym___declspec] = ACTIONS(2527),
    [anon_sym_LBRACE] = ACTIONS(2529),
    [anon_sym_signed] = ACTIONS(2527),
    [anon_sym_unsigned] = ACTIONS(2527),
    [anon_sym_long] = ACTIONS(2527),
    [anon_sym_short] = ACTIONS(2527),
    [anon_sym_LBRACK] = ACTIONS(2527),
    [anon_sym_static] = ACTIONS(2527),
    [anon_sym_register] = ACTIONS(2527),
    [anon_sym_inline] = ACTIONS(2527),
    [anon_sym___inline] = ACTIONS(2527),
    [anon_sym___inline__] = ACTIONS(2527),
    [anon_sym___forceinline] = ACTIONS(2527),
    [anon_sym_thread_local] = ACTIONS(2527),
    [anon_sym___thread] = ACTIONS(2527),
    [anon_sym_const] = ACTIONS(2527),
    [anon_sym_constexpr] = ACTIONS(2527),
    [anon_sym_volatile] = ACTIONS(2527),
    [anon_sym_restrict] = ACTIONS(2527),
    [anon_sym___restrict__] = ACTIONS(2527),
    [anon_sym__Atomic] = ACTIONS(2527),
    [anon_sym__Noreturn] = ACTIONS(2527),
    [anon_sym_noreturn] = ACTIONS(2527),
    [anon_sym_mutable] = ACTIONS(2527),
    [anon_sym_constinit] = ACTIONS(2527),
    [anon_sym_consteval] = ACTIONS(2527),
    [anon_sym_PROGMEM] = ACTIONS(2527),
    [aux_sym_primitive_type_token1] = ACTIONS(2527),
    [anon_sym_byte] = ACTIONS(2527),
    [anon_sym_word] = ACTIONS(2527),
    [anon_sym_enum] = ACTIONS(2527),
    [anon_sym_class] = ACTIONS(2527),
    [anon_sym_struct] = ACTIONS(2527),
    [anon_sym_union] = ACTIONS(2527),
    [anon_sym_if] = ACTIONS(2527),
    [anon_sym_else] = ACTIONS(2527),
    [anon_sym_switch] = ACTIONS(2527),
    [anon_sym_while] = ACTIONS(2527),
    [anon_sym_do] = ACTIONS(2527),
    [anon_sym_for] = ACTIONS(2527),
    [anon_sym_return] = ACTIONS(2527),
    [anon_sym_break] = ACTIONS(2527),
    [anon_sym_continue] = ACTIONS(2527),
    [anon_sym_goto] = ACTIONS(2527),
    [anon_sym___try] = ACTIONS(2527),
    [anon_sym___leave] = ACTIONS(2527),
    [anon_sym_not] = ACTIONS(2527),
    [anon_sym_compl] = ACTIONS(2527),
    [anon_sym_DASH_DASH] = ACTIONS(2529),
    [anon_sym_PLUS_PLUS] = ACTIONS(2529),
    [anon_sym_sizeof] = ACTIONS(2527),
    [anon_sym___alignof__] = ACTIONS(2527),
    [anon_sym___alignof] = ACTIONS(2527),
    [anon_sym__alignof] = ACTIONS(2527),
    [anon_sym_alignof] = ACTIONS(2527),
    [anon_sym__Alignof] = ACTIONS(2527),
    [anon_sym_offsetof] = ACTIONS(2527),
    [anon_sym__Generic] = ACTIONS(2527),
    [anon_sym_asm] = ACTIONS(2527),
    [anon_sym___asm__] = ACTIONS(2527),
    [aux_sym_number_literal_token1] = ACTIONS(2529),
    [aux_sym_number_literal_token2] = ACTIONS(2527),
    [anon_sym_L_SQUOTE] = ACTIONS(2529),
    [anon_sym_u_SQUOTE] = ACTIONS(2529),
    [anon_sym_U_SQUOTE] = ACTIONS(2529),
    [anon_sym_u8_SQUOTE] = ACTIONS(2529),
    [anon_sym_SQUOTE] = ACTIONS(2529),
    [anon_sym_L_DQUOTE] = ACTIONS(2529),
    [anon_sym_u_DQUOTE] = ACTIONS(2529),
    [anon_sym_U_DQUOTE] = ACTIONS(2529),
    [anon_sym_u8_DQUOTE] = ACTIONS(2529),
    [anon_sym_DQUOTE] = ACTIONS(2529),
    [sym_true] = ACTIONS(2527),
    [sym_false] = ACTIONS(2527),
    [anon_sym_NULL] = ACTIONS(2527),
    [anon_sym_nullptr] = ACTIONS(2527),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2527),
    [anon_sym_decltype] = ACTIONS(2527),
    [anon_sym_virtual] = ACTIONS(2527),
    [anon_sym_alignas] = ACTIONS(2527),
    [anon_sym_typename] = ACTIONS(2527),
    [anon_sym_template] = ACTIONS(2527),
    [anon_sym_try] = ACTIONS(2527),
    [anon_sym_delete] = ACTIONS(2527),
    [anon_sym_throw] = ACTIONS(2527),
    [anon_sym_co_return] = ACTIONS(2527),
    [anon_sym_co_yield] = ACTIONS(2527),
    [anon_sym_catch] = ACTIONS(2527),
    [anon_sym_R_DQUOTE] = ACTIONS(2529),
    [anon_sym_LR_DQUOTE] = ACTIONS(2529),
    [anon_sym_uR_DQUOTE] = ACTIONS(2529),
    [anon_sym_UR_DQUOTE] = ACTIONS(2529),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2529),
    [anon_sym_co_await] = ACTIONS(2527),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_requires] = ACTIONS(2527),
    [sym_this] = ACTIONS(2527),
  },
  [966] = {
    [sym_identifier] = ACTIONS(2665),
    [anon_sym_LPAREN2] = ACTIONS(2667),
    [anon_sym_BANG] = ACTIONS(2667),
    [anon_sym_TILDE] = ACTIONS(2667),
    [anon_sym_DASH] = ACTIONS(2665),
    [anon_sym_PLUS] = ACTIONS(2665),
    [anon_sym_STAR] = ACTIONS(2667),
    [anon_sym_AMP] = ACTIONS(2667),
    [anon_sym_SEMI] = ACTIONS(2667),
    [anon_sym___extension__] = ACTIONS(2665),
    [anon_sym_typedef] = ACTIONS(2665),
    [anon_sym_extern] = ACTIONS(2665),
    [anon_sym___attribute__] = ACTIONS(2665),
    [anon_sym_COLON_COLON] = ACTIONS(2667),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2667),
    [anon_sym___declspec] = ACTIONS(2665),
    [anon_sym_LBRACE] = ACTIONS(2667),
    [anon_sym_signed] = ACTIONS(2665),
    [anon_sym_unsigned] = ACTIONS(2665),
    [anon_sym_long] = ACTIONS(2665),
    [anon_sym_short] = ACTIONS(2665),
    [anon_sym_LBRACK] = ACTIONS(2665),
    [anon_sym_static] = ACTIONS(2665),
    [anon_sym_register] = ACTIONS(2665),
    [anon_sym_inline] = ACTIONS(2665),
    [anon_sym___inline] = ACTIONS(2665),
    [anon_sym___inline__] = ACTIONS(2665),
    [anon_sym___forceinline] = ACTIONS(2665),
    [anon_sym_thread_local] = ACTIONS(2665),
    [anon_sym___thread] = ACTIONS(2665),
    [anon_sym_const] = ACTIONS(2665),
    [anon_sym_constexpr] = ACTIONS(2665),
    [anon_sym_volatile] = ACTIONS(2665),
    [anon_sym_restrict] = ACTIONS(2665),
    [anon_sym___restrict__] = ACTIONS(2665),
    [anon_sym__Atomic] = ACTIONS(2665),
    [anon_sym__Noreturn] = ACTIONS(2665),
    [anon_sym_noreturn] = ACTIONS(2665),
    [anon_sym_mutable] = ACTIONS(2665),
    [anon_sym_constinit] = ACTIONS(2665),
    [anon_sym_consteval] = ACTIONS(2665),
    [anon_sym_PROGMEM] = ACTIONS(2665),
    [aux_sym_primitive_type_token1] = ACTIONS(2665),
    [anon_sym_byte] = ACTIONS(2665),
    [anon_sym_word] = ACTIONS(2665),
    [anon_sym_enum] = ACTIONS(2665),
    [anon_sym_class] = ACTIONS(2665),
    [anon_sym_struct] = ACTIONS(2665),
    [anon_sym_union] = ACTIONS(2665),
    [anon_sym_if] = ACTIONS(2665),
    [anon_sym_else] = ACTIONS(2665),
    [anon_sym_switch] = ACTIONS(2665),
    [anon_sym_while] = ACTIONS(2665),
    [anon_sym_do] = ACTIONS(2665),
    [anon_sym_for] = ACTIONS(2665),
    [anon_sym_return] = ACTIONS(2665),
    [anon_sym_break] = ACTIONS(2665),
    [anon_sym_continue] = ACTIONS(2665),
    [anon_sym_goto] = ACTIONS(2665),
    [anon_sym___try] = ACTIONS(2665),
    [anon_sym___leave] = ACTIONS(2665),
    [anon_sym_not] = ACTIONS(2665),
    [anon_sym_compl] = ACTIONS(2665),
    [anon_sym_DASH_DASH] = ACTIONS(2667),
    [anon_sym_PLUS_PLUS] = ACTIONS(2667),
    [anon_sym_sizeof] = ACTIONS(2665),
    [anon_sym___alignof__] = ACTIONS(2665),
    [anon_sym___alignof] = ACTIONS(2665),
    [anon_sym__alignof] = ACTIONS(2665),
    [anon_sym_alignof] = ACTIONS(2665),
    [anon_sym__Alignof] = ACTIONS(2665),
    [anon_sym_offsetof] = ACTIONS(2665),
    [anon_sym__Generic] = ACTIONS(2665),
    [anon_sym_asm] = ACTIONS(2665),
    [anon_sym___asm__] = ACTIONS(2665),
    [aux_sym_number_literal_token1] = ACTIONS(2667),
    [aux_sym_number_literal_token2] = ACTIONS(2665),
    [anon_sym_L_SQUOTE] = ACTIONS(2667),
    [anon_sym_u_SQUOTE] = ACTIONS(2667),
    [anon_sym_U_SQUOTE] = ACTIONS(2667),
    [anon_sym_u8_SQUOTE] = ACTIONS(2667),
    [anon_sym_SQUOTE] = ACTIONS(2667),
    [anon_sym_L_DQUOTE] = ACTIONS(2667),
    [anon_sym_u_DQUOTE] = ACTIONS(2667),
    [anon_sym_U_DQUOTE] = ACTIONS(2667),
    [anon_sym_u8_DQUOTE] = ACTIONS(2667),
    [anon_sym_DQUOTE] = ACTIONS(2667),
    [sym_true] = ACTIONS(2665),
    [sym_false] = ACTIONS(2665),
    [anon_sym_NULL] = ACTIONS(2665),
    [anon_sym_nullptr] = ACTIONS(2665),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2665),
    [anon_sym_decltype] = ACTIONS(2665),
    [anon_sym_virtual] = ACTIONS(2665),
    [anon_sym_alignas] = ACTIONS(2665),
    [anon_sym_typename] = ACTIONS(2665),
    [anon_sym_template] = ACTIONS(2665),
    [anon_sym_try] = ACTIONS(2665),
    [anon_sym_delete] = ACTIONS(2665),
    [anon_sym_throw] = ACTIONS(2665),
    [anon_sym_co_return] = ACTIONS(2665),
    [anon_sym_co_yield] = ACTIONS(2665),
    [anon_sym_R_DQUOTE] = ACTIONS(2667),
    [anon_sym_LR_DQUOTE] = ACTIONS(2667),
    [anon_sym_uR_DQUOTE] = ACTIONS(2667),
    [anon_sym_UR_DQUOTE] = ACTIONS(2667),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2667),
    [anon_sym_co_await] = ACTIONS(2665),
    [anon_sym_new] = ACTIONS(2665),
    [anon_sym_requires] = ACTIONS(2665),
    [sym_this] = ACTIONS(2665),
  },
  [967] = {
    [sym_identifier] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2645),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [968] = {
    [sym_identifier] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2681),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [969] = {
    [sym_identifier] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2681),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [970] = {
    [sym_identifier] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2681),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [971] = {
    [sym_identifier] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2645),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [972] = {
    [sym_identifier] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2645),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [973] = {
    [sym_identifier] = ACTIONS(3738),
    [anon_sym_LPAREN2] = ACTIONS(3744),
    [anon_sym_BANG] = ACTIONS(3744),
    [anon_sym_TILDE] = ACTIONS(3744),
    [anon_sym_DASH] = ACTIONS(3746),
    [anon_sym_PLUS] = ACTIONS(3746),
    [anon_sym_STAR] = ACTIONS(3744),
    [anon_sym_AMP] = ACTIONS(3744),
    [anon_sym_SEMI] = ACTIONS(3744),
    [anon_sym___extension__] = ACTIONS(3750),
    [anon_sym_extern] = ACTIONS(3750),
    [anon_sym___attribute__] = ACTIONS(3750),
    [anon_sym_COLON_COLON] = ACTIONS(3741),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3741),
    [anon_sym___declspec] = ACTIONS(3750),
    [anon_sym_LBRACE] = ACTIONS(3744),
    [anon_sym_signed] = ACTIONS(3750),
    [anon_sym_unsigned] = ACTIONS(3750),
    [anon_sym_long] = ACTIONS(3750),
    [anon_sym_short] = ACTIONS(3750),
    [anon_sym_LBRACK] = ACTIONS(3746),
    [anon_sym_static] = ACTIONS(3750),
    [anon_sym_register] = ACTIONS(3750),
    [anon_sym_inline] = ACTIONS(3750),
    [anon_sym___inline] = ACTIONS(3750),
    [anon_sym___inline__] = ACTIONS(3750),
    [anon_sym___forceinline] = ACTIONS(3750),
    [anon_sym_thread_local] = ACTIONS(3750),
    [anon_sym___thread] = ACTIONS(3750),
    [anon_sym_const] = ACTIONS(3750),
    [anon_sym_constexpr] = ACTIONS(3750),
    [anon_sym_volatile] = ACTIONS(3750),
    [anon_sym_restrict] = ACTIONS(3750),
    [anon_sym___restrict__] = ACTIONS(3750),
    [anon_sym__Atomic] = ACTIONS(3750),
    [anon_sym__Noreturn] = ACTIONS(3750),
    [anon_sym_noreturn] = ACTIONS(3750),
    [anon_sym_mutable] = ACTIONS(3750),
    [anon_sym_constinit] = ACTIONS(3750),
    [anon_sym_consteval] = ACTIONS(3750),
    [anon_sym_PROGMEM] = ACTIONS(3750),
    [aux_sym_primitive_type_token1] = ACTIONS(3738),
    [anon_sym_byte] = ACTIONS(3738),
    [anon_sym_word] = ACTIONS(3738),
    [anon_sym_enum] = ACTIONS(3750),
    [anon_sym_class] = ACTIONS(3750),
    [anon_sym_struct] = ACTIONS(3750),
    [anon_sym_union] = ACTIONS(3750),
    [anon_sym_if] = ACTIONS(3746),
    [anon_sym_switch] = ACTIONS(3746),
    [anon_sym_case] = ACTIONS(3746),
    [anon_sym_default] = ACTIONS(3746),
    [anon_sym_while] = ACTIONS(3746),
    [anon_sym_do] = ACTIONS(3746),
    [anon_sym_for] = ACTIONS(3746),
    [anon_sym_return] = ACTIONS(3746),
    [anon_sym_break] = ACTIONS(3746),
    [anon_sym_continue] = ACTIONS(3746),
    [anon_sym_goto] = ACTIONS(3746),
    [anon_sym___try] = ACTIONS(3746),
    [anon_sym___leave] = ACTIONS(3746),
    [anon_sym_not] = ACTIONS(3746),
    [anon_sym_compl] = ACTIONS(3746),
    [anon_sym_DASH_DASH] = ACTIONS(3744),
    [anon_sym_PLUS_PLUS] = ACTIONS(3744),
    [anon_sym_sizeof] = ACTIONS(3746),
    [anon_sym___alignof__] = ACTIONS(3746),
    [anon_sym___alignof] = ACTIONS(3746),
    [anon_sym__alignof] = ACTIONS(3746),
    [anon_sym_alignof] = ACTIONS(3746),
    [anon_sym__Alignof] = ACTIONS(3746),
    [anon_sym_offsetof] = ACTIONS(3746),
    [anon_sym__Generic] = ACTIONS(3746),
    [anon_sym_asm] = ACTIONS(3746),
    [anon_sym___asm__] = ACTIONS(3746),
    [aux_sym_number_literal_token1] = ACTIONS(3744),
    [aux_sym_number_literal_token2] = ACTIONS(3746),
    [anon_sym_L_SQUOTE] = ACTIONS(3744),
    [anon_sym_u_SQUOTE] = ACTIONS(3744),
    [anon_sym_U_SQUOTE] = ACTIONS(3744),
    [anon_sym_u8_SQUOTE] = ACTIONS(3744),
    [anon_sym_SQUOTE] = ACTIONS(3744),
    [anon_sym_L_DQUOTE] = ACTIONS(3744),
    [anon_sym_u_DQUOTE] = ACTIONS(3744),
    [anon_sym_U_DQUOTE] = ACTIONS(3744),
    [anon_sym_u8_DQUOTE] = ACTIONS(3744),
    [anon_sym_DQUOTE] = ACTIONS(3744),
    [sym_true] = ACTIONS(3746),
    [sym_false] = ACTIONS(3746),
    [anon_sym_NULL] = ACTIONS(3746),
    [anon_sym_nullptr] = ACTIONS(3746),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3750),
    [anon_sym_decltype] = ACTIONS(3738),
    [anon_sym_virtual] = ACTIONS(3750),
    [anon_sym_alignas] = ACTIONS(3750),
    [anon_sym_typename] = ACTIONS(3750),
    [anon_sym_template] = ACTIONS(3738),
    [anon_sym_try] = ACTIONS(3746),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_throw] = ACTIONS(3746),
    [anon_sym_co_return] = ACTIONS(3746),
    [anon_sym_co_yield] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(3744),
    [anon_sym_LR_DQUOTE] = ACTIONS(3744),
    [anon_sym_uR_DQUOTE] = ACTIONS(3744),
    [anon_sym_UR_DQUOTE] = ACTIONS(3744),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3744),
    [anon_sym_co_await] = ACTIONS(3746),
    [anon_sym_new] = ACTIONS(3746),
    [anon_sym_requires] = ACTIONS(3746),
    [sym_this] = ACTIONS(3746),
  },
  [974] = {
    [sym_identifier] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2681),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [975] = {
    [sym_identifier] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2681),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [976] = {
    [sym_identifier] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2681),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [977] = {
    [sym_identifier] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2681),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [978] = {
    [sym_identifier] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2681),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [979] = {
    [sym_identifier] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2681),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [980] = {
    [sym_identifier] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2645),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [981] = {
    [sym_identifier] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2681),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [982] = {
    [sym_identifier] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2681),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [983] = {
    [sym_identifier] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2681),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [984] = {
    [sym_identifier] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2681),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [985] = {
    [sym_identifier] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2681),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [986] = {
    [sym_identifier] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2645),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [987] = {
    [sym_identifier] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2645),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [988] = {
    [sym_identifier] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2645),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [989] = {
    [sym_identifier] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2645),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [990] = {
    [sym_identifier] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2645),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [991] = {
    [sym_identifier] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2645),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [992] = {
    [sym_identifier] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2681),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [993] = {
    [sym_identifier] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2681),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [994] = {
    [sym_identifier] = ACTIONS(2735),
    [anon_sym_LPAREN2] = ACTIONS(2737),
    [anon_sym_BANG] = ACTIONS(2737),
    [anon_sym_TILDE] = ACTIONS(2737),
    [anon_sym_DASH] = ACTIONS(2735),
    [anon_sym_PLUS] = ACTIONS(2735),
    [anon_sym_STAR] = ACTIONS(2737),
    [anon_sym_AMP] = ACTIONS(2737),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym___extension__] = ACTIONS(2735),
    [anon_sym_typedef] = ACTIONS(2735),
    [anon_sym_extern] = ACTIONS(2735),
    [anon_sym___attribute__] = ACTIONS(2735),
    [anon_sym_COLON_COLON] = ACTIONS(2737),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2737),
    [anon_sym___declspec] = ACTIONS(2735),
    [anon_sym_LBRACE] = ACTIONS(2737),
    [anon_sym_signed] = ACTIONS(2735),
    [anon_sym_unsigned] = ACTIONS(2735),
    [anon_sym_long] = ACTIONS(2735),
    [anon_sym_short] = ACTIONS(2735),
    [anon_sym_LBRACK] = ACTIONS(2735),
    [anon_sym_static] = ACTIONS(2735),
    [anon_sym_register] = ACTIONS(2735),
    [anon_sym_inline] = ACTIONS(2735),
    [anon_sym___inline] = ACTIONS(2735),
    [anon_sym___inline__] = ACTIONS(2735),
    [anon_sym___forceinline] = ACTIONS(2735),
    [anon_sym_thread_local] = ACTIONS(2735),
    [anon_sym___thread] = ACTIONS(2735),
    [anon_sym_const] = ACTIONS(2735),
    [anon_sym_constexpr] = ACTIONS(2735),
    [anon_sym_volatile] = ACTIONS(2735),
    [anon_sym_restrict] = ACTIONS(2735),
    [anon_sym___restrict__] = ACTIONS(2735),
    [anon_sym__Atomic] = ACTIONS(2735),
    [anon_sym__Noreturn] = ACTIONS(2735),
    [anon_sym_noreturn] = ACTIONS(2735),
    [anon_sym_mutable] = ACTIONS(2735),
    [anon_sym_constinit] = ACTIONS(2735),
    [anon_sym_consteval] = ACTIONS(2735),
    [anon_sym_PROGMEM] = ACTIONS(2735),
    [aux_sym_primitive_type_token1] = ACTIONS(2735),
    [anon_sym_byte] = ACTIONS(2735),
    [anon_sym_word] = ACTIONS(2735),
    [anon_sym_enum] = ACTIONS(2735),
    [anon_sym_class] = ACTIONS(2735),
    [anon_sym_struct] = ACTIONS(2735),
    [anon_sym_union] = ACTIONS(2735),
    [anon_sym_if] = ACTIONS(2735),
    [anon_sym_else] = ACTIONS(2735),
    [anon_sym_switch] = ACTIONS(2735),
    [anon_sym_while] = ACTIONS(2735),
    [anon_sym_do] = ACTIONS(2735),
    [anon_sym_for] = ACTIONS(2735),
    [anon_sym_return] = ACTIONS(2735),
    [anon_sym_break] = ACTIONS(2735),
    [anon_sym_continue] = ACTIONS(2735),
    [anon_sym_goto] = ACTIONS(2735),
    [anon_sym___try] = ACTIONS(2735),
    [anon_sym___leave] = ACTIONS(2735),
    [anon_sym_not] = ACTIONS(2735),
    [anon_sym_compl] = ACTIONS(2735),
    [anon_sym_DASH_DASH] = ACTIONS(2737),
    [anon_sym_PLUS_PLUS] = ACTIONS(2737),
    [anon_sym_sizeof] = ACTIONS(2735),
    [anon_sym___alignof__] = ACTIONS(2735),
    [anon_sym___alignof] = ACTIONS(2735),
    [anon_sym__alignof] = ACTIONS(2735),
    [anon_sym_alignof] = ACTIONS(2735),
    [anon_sym__Alignof] = ACTIONS(2735),
    [anon_sym_offsetof] = ACTIONS(2735),
    [anon_sym__Generic] = ACTIONS(2735),
    [anon_sym_asm] = ACTIONS(2735),
    [anon_sym___asm__] = ACTIONS(2735),
    [aux_sym_number_literal_token1] = ACTIONS(2737),
    [aux_sym_number_literal_token2] = ACTIONS(2735),
    [anon_sym_L_SQUOTE] = ACTIONS(2737),
    [anon_sym_u_SQUOTE] = ACTIONS(2737),
    [anon_sym_U_SQUOTE] = ACTIONS(2737),
    [anon_sym_u8_SQUOTE] = ACTIONS(2737),
    [anon_sym_SQUOTE] = ACTIONS(2737),
    [anon_sym_L_DQUOTE] = ACTIONS(2737),
    [anon_sym_u_DQUOTE] = ACTIONS(2737),
    [anon_sym_U_DQUOTE] = ACTIONS(2737),
    [anon_sym_u8_DQUOTE] = ACTIONS(2737),
    [anon_sym_DQUOTE] = ACTIONS(2737),
    [sym_true] = ACTIONS(2735),
    [sym_false] = ACTIONS(2735),
    [anon_sym_NULL] = ACTIONS(2735),
    [anon_sym_nullptr] = ACTIONS(2735),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2735),
    [anon_sym_decltype] = ACTIONS(2735),
    [anon_sym_virtual] = ACTIONS(2735),
    [anon_sym_alignas] = ACTIONS(2735),
    [anon_sym_typename] = ACTIONS(2735),
    [anon_sym_template] = ACTIONS(2735),
    [anon_sym_try] = ACTIONS(2735),
    [anon_sym_delete] = ACTIONS(2735),
    [anon_sym_throw] = ACTIONS(2735),
    [anon_sym_co_return] = ACTIONS(2735),
    [anon_sym_co_yield] = ACTIONS(2735),
    [anon_sym_R_DQUOTE] = ACTIONS(2737),
    [anon_sym_LR_DQUOTE] = ACTIONS(2737),
    [anon_sym_uR_DQUOTE] = ACTIONS(2737),
    [anon_sym_UR_DQUOTE] = ACTIONS(2737),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2737),
    [anon_sym_co_await] = ACTIONS(2735),
    [anon_sym_new] = ACTIONS(2735),
    [anon_sym_requires] = ACTIONS(2735),
    [sym_this] = ACTIONS(2735),
  },
  [995] = {
    [sym_identifier] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2645),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [996] = {
    [sym_identifier] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2645),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [997] = {
    [sym_identifier] = ACTIONS(2739),
    [anon_sym_LPAREN2] = ACTIONS(2741),
    [anon_sym_BANG] = ACTIONS(2741),
    [anon_sym_TILDE] = ACTIONS(2741),
    [anon_sym_DASH] = ACTIONS(2739),
    [anon_sym_PLUS] = ACTIONS(2739),
    [anon_sym_STAR] = ACTIONS(2741),
    [anon_sym_AMP] = ACTIONS(2741),
    [anon_sym_SEMI] = ACTIONS(2741),
    [anon_sym___extension__] = ACTIONS(2739),
    [anon_sym_typedef] = ACTIONS(2739),
    [anon_sym_extern] = ACTIONS(2739),
    [anon_sym___attribute__] = ACTIONS(2739),
    [anon_sym_COLON_COLON] = ACTIONS(2741),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2741),
    [anon_sym___declspec] = ACTIONS(2739),
    [anon_sym_LBRACE] = ACTIONS(2741),
    [anon_sym_signed] = ACTIONS(2739),
    [anon_sym_unsigned] = ACTIONS(2739),
    [anon_sym_long] = ACTIONS(2739),
    [anon_sym_short] = ACTIONS(2739),
    [anon_sym_LBRACK] = ACTIONS(2739),
    [anon_sym_static] = ACTIONS(2739),
    [anon_sym_register] = ACTIONS(2739),
    [anon_sym_inline] = ACTIONS(2739),
    [anon_sym___inline] = ACTIONS(2739),
    [anon_sym___inline__] = ACTIONS(2739),
    [anon_sym___forceinline] = ACTIONS(2739),
    [anon_sym_thread_local] = ACTIONS(2739),
    [anon_sym___thread] = ACTIONS(2739),
    [anon_sym_const] = ACTIONS(2739),
    [anon_sym_constexpr] = ACTIONS(2739),
    [anon_sym_volatile] = ACTIONS(2739),
    [anon_sym_restrict] = ACTIONS(2739),
    [anon_sym___restrict__] = ACTIONS(2739),
    [anon_sym__Atomic] = ACTIONS(2739),
    [anon_sym__Noreturn] = ACTIONS(2739),
    [anon_sym_noreturn] = ACTIONS(2739),
    [anon_sym_mutable] = ACTIONS(2739),
    [anon_sym_constinit] = ACTIONS(2739),
    [anon_sym_consteval] = ACTIONS(2739),
    [anon_sym_PROGMEM] = ACTIONS(2739),
    [aux_sym_primitive_type_token1] = ACTIONS(2739),
    [anon_sym_byte] = ACTIONS(2739),
    [anon_sym_word] = ACTIONS(2739),
    [anon_sym_enum] = ACTIONS(2739),
    [anon_sym_class] = ACTIONS(2739),
    [anon_sym_struct] = ACTIONS(2739),
    [anon_sym_union] = ACTIONS(2739),
    [anon_sym_if] = ACTIONS(2739),
    [anon_sym_else] = ACTIONS(2739),
    [anon_sym_switch] = ACTIONS(2739),
    [anon_sym_while] = ACTIONS(2739),
    [anon_sym_do] = ACTIONS(2739),
    [anon_sym_for] = ACTIONS(2739),
    [anon_sym_return] = ACTIONS(2739),
    [anon_sym_break] = ACTIONS(2739),
    [anon_sym_continue] = ACTIONS(2739),
    [anon_sym_goto] = ACTIONS(2739),
    [anon_sym___try] = ACTIONS(2739),
    [anon_sym___leave] = ACTIONS(2739),
    [anon_sym_not] = ACTIONS(2739),
    [anon_sym_compl] = ACTIONS(2739),
    [anon_sym_DASH_DASH] = ACTIONS(2741),
    [anon_sym_PLUS_PLUS] = ACTIONS(2741),
    [anon_sym_sizeof] = ACTIONS(2739),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2739),
    [anon_sym__Generic] = ACTIONS(2739),
    [anon_sym_asm] = ACTIONS(2739),
    [anon_sym___asm__] = ACTIONS(2739),
    [aux_sym_number_literal_token1] = ACTIONS(2741),
    [aux_sym_number_literal_token2] = ACTIONS(2739),
    [anon_sym_L_SQUOTE] = ACTIONS(2741),
    [anon_sym_u_SQUOTE] = ACTIONS(2741),
    [anon_sym_U_SQUOTE] = ACTIONS(2741),
    [anon_sym_u8_SQUOTE] = ACTIONS(2741),
    [anon_sym_SQUOTE] = ACTIONS(2741),
    [anon_sym_L_DQUOTE] = ACTIONS(2741),
    [anon_sym_u_DQUOTE] = ACTIONS(2741),
    [anon_sym_U_DQUOTE] = ACTIONS(2741),
    [anon_sym_u8_DQUOTE] = ACTIONS(2741),
    [anon_sym_DQUOTE] = ACTIONS(2741),
    [sym_true] = ACTIONS(2739),
    [sym_false] = ACTIONS(2739),
    [anon_sym_NULL] = ACTIONS(2739),
    [anon_sym_nullptr] = ACTIONS(2739),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2739),
    [anon_sym_decltype] = ACTIONS(2739),
    [anon_sym_virtual] = ACTIONS(2739),
    [anon_sym_alignas] = ACTIONS(2739),
    [anon_sym_typename] = ACTIONS(2739),
    [anon_sym_template] = ACTIONS(2739),
    [anon_sym_try] = ACTIONS(2739),
    [anon_sym_delete] = ACTIONS(2739),
    [anon_sym_throw] = ACTIONS(2739),
    [anon_sym_co_return] = ACTIONS(2739),
    [anon_sym_co_yield] = ACTIONS(2739),
    [anon_sym_R_DQUOTE] = ACTIONS(2741),
    [anon_sym_LR_DQUOTE] = ACTIONS(2741),
    [anon_sym_uR_DQUOTE] = ACTIONS(2741),
    [anon_sym_UR_DQUOTE] = ACTIONS(2741),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2741),
    [anon_sym_co_await] = ACTIONS(2739),
    [anon_sym_new] = ACTIONS(2739),
    [anon_sym_requires] = ACTIONS(2739),
    [sym_this] = ACTIONS(2739),
  },
  [998] = {
    [sym_identifier] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2681),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [999] = {
    [sym_identifier] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2681),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [1000] = {
    [sym_identifier] = ACTIONS(2557),
    [anon_sym_LPAREN2] = ACTIONS(2562),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2557),
    [anon_sym_PLUS] = ACTIONS(2557),
    [anon_sym_STAR] = ACTIONS(2562),
    [anon_sym_AMP] = ACTIONS(2562),
    [anon_sym_SEMI] = ACTIONS(2562),
    [anon_sym___extension__] = ACTIONS(2557),
    [anon_sym_typedef] = ACTIONS(2557),
    [anon_sym_extern] = ACTIONS(2557),
    [anon_sym___attribute__] = ACTIONS(2557),
    [anon_sym_COLON_COLON] = ACTIONS(2562),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2562),
    [anon_sym___declspec] = ACTIONS(2557),
    [anon_sym_LBRACE] = ACTIONS(2562),
    [anon_sym_signed] = ACTIONS(2557),
    [anon_sym_unsigned] = ACTIONS(2557),
    [anon_sym_long] = ACTIONS(2557),
    [anon_sym_short] = ACTIONS(2557),
    [anon_sym_LBRACK] = ACTIONS(2557),
    [anon_sym_static] = ACTIONS(2557),
    [anon_sym_register] = ACTIONS(2557),
    [anon_sym_inline] = ACTIONS(2557),
    [anon_sym___inline] = ACTIONS(2557),
    [anon_sym___inline__] = ACTIONS(2557),
    [anon_sym___forceinline] = ACTIONS(2557),
    [anon_sym_thread_local] = ACTIONS(2557),
    [anon_sym___thread] = ACTIONS(2557),
    [anon_sym_const] = ACTIONS(2557),
    [anon_sym_constexpr] = ACTIONS(2557),
    [anon_sym_volatile] = ACTIONS(2557),
    [anon_sym_restrict] = ACTIONS(2557),
    [anon_sym___restrict__] = ACTIONS(2557),
    [anon_sym__Atomic] = ACTIONS(2557),
    [anon_sym__Noreturn] = ACTIONS(2557),
    [anon_sym_noreturn] = ACTIONS(2557),
    [anon_sym_mutable] = ACTIONS(2557),
    [anon_sym_constinit] = ACTIONS(2557),
    [anon_sym_consteval] = ACTIONS(2557),
    [anon_sym_PROGMEM] = ACTIONS(2557),
    [aux_sym_primitive_type_token1] = ACTIONS(2557),
    [anon_sym_byte] = ACTIONS(2557),
    [anon_sym_word] = ACTIONS(2557),
    [anon_sym_enum] = ACTIONS(2557),
    [anon_sym_class] = ACTIONS(2557),
    [anon_sym_struct] = ACTIONS(2557),
    [anon_sym_union] = ACTIONS(2557),
    [anon_sym_if] = ACTIONS(2557),
    [anon_sym_else] = ACTIONS(2557),
    [anon_sym_switch] = ACTIONS(2557),
    [anon_sym_while] = ACTIONS(2557),
    [anon_sym_do] = ACTIONS(2557),
    [anon_sym_for] = ACTIONS(2557),
    [anon_sym_return] = ACTIONS(2557),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_continue] = ACTIONS(2557),
    [anon_sym_goto] = ACTIONS(2557),
    [anon_sym___try] = ACTIONS(2557),
    [anon_sym___leave] = ACTIONS(2557),
    [anon_sym_not] = ACTIONS(2557),
    [anon_sym_compl] = ACTIONS(2557),
    [anon_sym_DASH_DASH] = ACTIONS(2562),
    [anon_sym_PLUS_PLUS] = ACTIONS(2562),
    [anon_sym_sizeof] = ACTIONS(2557),
    [anon_sym___alignof__] = ACTIONS(2557),
    [anon_sym___alignof] = ACTIONS(2557),
    [anon_sym__alignof] = ACTIONS(2557),
    [anon_sym_alignof] = ACTIONS(2557),
    [anon_sym__Alignof] = ACTIONS(2557),
    [anon_sym_offsetof] = ACTIONS(2557),
    [anon_sym__Generic] = ACTIONS(2557),
    [anon_sym_asm] = ACTIONS(2557),
    [anon_sym___asm__] = ACTIONS(2557),
    [aux_sym_number_literal_token1] = ACTIONS(2562),
    [aux_sym_number_literal_token2] = ACTIONS(2557),
    [anon_sym_L_SQUOTE] = ACTIONS(2562),
    [anon_sym_u_SQUOTE] = ACTIONS(2562),
    [anon_sym_U_SQUOTE] = ACTIONS(2562),
    [anon_sym_u8_SQUOTE] = ACTIONS(2562),
    [anon_sym_SQUOTE] = ACTIONS(2562),
    [anon_sym_L_DQUOTE] = ACTIONS(2562),
    [anon_sym_u_DQUOTE] = ACTIONS(2562),
    [anon_sym_U_DQUOTE] = ACTIONS(2562),
    [anon_sym_u8_DQUOTE] = ACTIONS(2562),
    [anon_sym_DQUOTE] = ACTIONS(2562),
    [sym_true] = ACTIONS(2557),
    [sym_false] = ACTIONS(2557),
    [anon_sym_NULL] = ACTIONS(2557),
    [anon_sym_nullptr] = ACTIONS(2557),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2557),
    [anon_sym_decltype] = ACTIONS(2557),
    [anon_sym_virtual] = ACTIONS(2557),
    [anon_sym_alignas] = ACTIONS(2557),
    [anon_sym_typename] = ACTIONS(2557),
    [anon_sym_template] = ACTIONS(2557),
    [anon_sym_try] = ACTIONS(2557),
    [anon_sym_delete] = ACTIONS(2557),
    [anon_sym_throw] = ACTIONS(2557),
    [anon_sym_co_return] = ACTIONS(2557),
    [anon_sym_co_yield] = ACTIONS(2557),
    [anon_sym_R_DQUOTE] = ACTIONS(2562),
    [anon_sym_LR_DQUOTE] = ACTIONS(2562),
    [anon_sym_uR_DQUOTE] = ACTIONS(2562),
    [anon_sym_UR_DQUOTE] = ACTIONS(2562),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2562),
    [anon_sym_co_await] = ACTIONS(2557),
    [anon_sym_new] = ACTIONS(2557),
    [anon_sym_requires] = ACTIONS(2557),
    [sym_this] = ACTIONS(2557),
  },
  [1001] = {
    [sym_identifier] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2645),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [1002] = {
    [sym_identifier] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2645),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [1003] = {
    [sym_identifier] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2645),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [1004] = {
    [sym_identifier] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2681),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [1005] = {
    [sym_identifier] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2681),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [1006] = {
    [sym__declaration_modifiers] = STATE(1967),
    [sym__declaration_specifiers] = STATE(4118),
    [sym_attribute_specifier] = STATE(1967),
    [sym_attribute_declaration] = STATE(1967),
    [sym_ms_declspec_modifier] = STATE(1967),
    [sym_ms_based_modifier] = STATE(8318),
    [sym_ms_call_modifier] = STATE(4529),
    [sym__declarator] = STATE(6389),
    [sym__abstract_declarator] = STATE(6559),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_abstract_parenthesized_declarator] = STATE(6031),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_abstract_pointer_declarator] = STATE(6031),
    [sym_function_declarator] = STATE(6098),
    [sym_abstract_function_declarator] = STATE(6031),
    [sym_array_declarator] = STATE(6098),
    [sym_abstract_array_declarator] = STATE(6031),
    [sym_storage_class_specifier] = STATE(1967),
    [sym_type_qualifier] = STATE(1967),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_parameter_list] = STATE(3698),
    [sym_parameter_declaration] = STATE(6918),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(1967),
    [sym_alignas_specifier] = STATE(1967),
    [sym_dependent_type] = STATE(2629),
    [sym_optional_parameter_declaration] = STATE(6918),
    [sym_variadic_parameter_declaration] = STATE(6918),
    [sym_reference_declarator] = STATE(6098),
    [sym_abstract_reference_declarator] = STATE(6031),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym__function_declarator_seq] = STATE(6035),
    [sym_template_type] = STATE(2618),
    [sym_template_function] = STATE(6098),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5516),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_operator_name] = STATE(6098),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1967),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [sym_identifier] = ACTIONS(3799),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1801),
    [anon_sym_RPAREN] = ACTIONS(3801),
    [anon_sym_LPAREN2] = ACTIONS(3803),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(3805),
    [anon_sym_AMP_AMP] = ACTIONS(3807),
    [anon_sym_AMP] = ACTIONS(3809),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3811),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(1825),
    [anon_sym___clrcall] = ACTIONS(1825),
    [anon_sym___stdcall] = ACTIONS(1825),
    [anon_sym___fastcall] = ACTIONS(1825),
    [anon_sym___thiscall] = ACTIONS(1825),
    [anon_sym___vectorcall] = ACTIONS(1825),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(3813),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(1755),
    [anon_sym_class] = ACTIONS(1757),
    [anon_sym_struct] = ACTIONS(1759),
    [anon_sym_union] = ACTIONS(1761),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(1787),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_operator] = ACTIONS(1871),
  },
  [1007] = {
    [sym_identifier] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2645),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [1008] = {
    [sym_string_literal] = STATE(2617),
    [sym_template_argument_list] = STATE(1740),
    [sym_raw_string_literal] = STATE(2617),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2716),
    [sym_identifier] = ACTIONS(3759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3761),
    [anon_sym_COMMA] = ACTIONS(3761),
    [anon_sym_LPAREN2] = ACTIONS(3763),
    [anon_sym_TILDE] = ACTIONS(3767),
    [anon_sym_DASH] = ACTIONS(3769),
    [anon_sym_PLUS] = ACTIONS(3769),
    [anon_sym_STAR] = ACTIONS(3771),
    [anon_sym_SLASH] = ACTIONS(3769),
    [anon_sym_PERCENT] = ACTIONS(3769),
    [anon_sym_PIPE_PIPE] = ACTIONS(3761),
    [anon_sym_AMP_AMP] = ACTIONS(3774),
    [anon_sym_PIPE] = ACTIONS(3769),
    [anon_sym_CARET] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(3771),
    [anon_sym_EQ_EQ] = ACTIONS(3761),
    [anon_sym_BANG_EQ] = ACTIONS(3761),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3761),
    [anon_sym_LT_EQ] = ACTIONS(3769),
    [anon_sym_LT] = ACTIONS(3777),
    [anon_sym_LT_LT] = ACTIONS(3769),
    [anon_sym_GT_GT] = ACTIONS(3769),
    [anon_sym_SEMI] = ACTIONS(3774),
    [anon_sym___extension__] = ACTIONS(3759),
    [anon_sym_extern] = ACTIONS(3759),
    [anon_sym___attribute__] = ACTIONS(3759),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3782),
    [anon_sym___declspec] = ACTIONS(3759),
    [anon_sym___based] = ACTIONS(3759),
    [anon_sym___cdecl] = ACTIONS(3759),
    [anon_sym___clrcall] = ACTIONS(3759),
    [anon_sym___stdcall] = ACTIONS(3759),
    [anon_sym___fastcall] = ACTIONS(3759),
    [anon_sym___thiscall] = ACTIONS(3759),
    [anon_sym___vectorcall] = ACTIONS(3759),
    [anon_sym_LBRACE] = ACTIONS(3785),
    [anon_sym_signed] = ACTIONS(3787),
    [anon_sym_unsigned] = ACTIONS(3787),
    [anon_sym_long] = ACTIONS(3787),
    [anon_sym_short] = ACTIONS(3787),
    [anon_sym_LBRACK] = ACTIONS(3789),
    [anon_sym_EQ] = ACTIONS(3793),
    [anon_sym_static] = ACTIONS(3759),
    [anon_sym_register] = ACTIONS(3759),
    [anon_sym_inline] = ACTIONS(3759),
    [anon_sym___inline] = ACTIONS(3759),
    [anon_sym___inline__] = ACTIONS(3759),
    [anon_sym___forceinline] = ACTIONS(3759),
    [anon_sym_thread_local] = ACTIONS(3759),
    [anon_sym___thread] = ACTIONS(3759),
    [anon_sym_const] = ACTIONS(3759),
    [anon_sym_constexpr] = ACTIONS(3759),
    [anon_sym_volatile] = ACTIONS(3759),
    [anon_sym_restrict] = ACTIONS(3759),
    [anon_sym___restrict__] = ACTIONS(3759),
    [anon_sym__Atomic] = ACTIONS(3759),
    [anon_sym__Noreturn] = ACTIONS(3759),
    [anon_sym_noreturn] = ACTIONS(3759),
    [anon_sym_mutable] = ACTIONS(3759),
    [anon_sym_constinit] = ACTIONS(3759),
    [anon_sym_consteval] = ACTIONS(3759),
    [anon_sym_PROGMEM] = ACTIONS(3759),
    [anon_sym_COLON] = ACTIONS(3815),
    [anon_sym_QMARK] = ACTIONS(3761),
    [anon_sym_STAR_EQ] = ACTIONS(3797),
    [anon_sym_SLASH_EQ] = ACTIONS(3797),
    [anon_sym_PERCENT_EQ] = ACTIONS(3797),
    [anon_sym_PLUS_EQ] = ACTIONS(3797),
    [anon_sym_DASH_EQ] = ACTIONS(3797),
    [anon_sym_LT_LT_EQ] = ACTIONS(3797),
    [anon_sym_GT_GT_EQ] = ACTIONS(3797),
    [anon_sym_AMP_EQ] = ACTIONS(3797),
    [anon_sym_CARET_EQ] = ACTIONS(3797),
    [anon_sym_PIPE_EQ] = ACTIONS(3797),
    [anon_sym_and_eq] = ACTIONS(3793),
    [anon_sym_or_eq] = ACTIONS(3793),
    [anon_sym_xor_eq] = ACTIONS(3793),
    [anon_sym_LT_EQ_GT] = ACTIONS(3761),
    [anon_sym_or] = ACTIONS(3769),
    [anon_sym_and] = ACTIONS(3769),
    [anon_sym_bitor] = ACTIONS(3769),
    [anon_sym_xor] = ACTIONS(3769),
    [anon_sym_bitand] = ACTIONS(3769),
    [anon_sym_not_eq] = ACTIONS(3769),
    [anon_sym_DASH_DASH] = ACTIONS(3761),
    [anon_sym_PLUS_PLUS] = ACTIONS(3761),
    [anon_sym_DOT] = ACTIONS(3769),
    [anon_sym_DOT_STAR] = ACTIONS(3761),
    [anon_sym_DASH_GT] = ACTIONS(3761),
    [anon_sym_L_DQUOTE] = ACTIONS(3204),
    [anon_sym_u_DQUOTE] = ACTIONS(3204),
    [anon_sym_U_DQUOTE] = ACTIONS(3204),
    [anon_sym_u8_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3204),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3759),
    [anon_sym_decltype] = ACTIONS(3759),
    [anon_sym_virtual] = ACTIONS(3759),
    [anon_sym_alignas] = ACTIONS(3759),
    [anon_sym_template] = ACTIONS(3759),
    [anon_sym_operator] = ACTIONS(3759),
    [anon_sym_R_DQUOTE] = ACTIONS(3208),
    [anon_sym_LR_DQUOTE] = ACTIONS(3208),
    [anon_sym_uR_DQUOTE] = ACTIONS(3208),
    [anon_sym_UR_DQUOTE] = ACTIONS(3208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3208),
  },
  [1009] = {
    [sym_identifier] = ACTIONS(2679),
    [anon_sym_LPAREN2] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2679),
    [anon_sym_PLUS] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_AMP] = ACTIONS(2681),
    [anon_sym_SEMI] = ACTIONS(2681),
    [anon_sym___extension__] = ACTIONS(2679),
    [anon_sym_typedef] = ACTIONS(2679),
    [anon_sym_extern] = ACTIONS(2679),
    [anon_sym___attribute__] = ACTIONS(2679),
    [anon_sym_COLON_COLON] = ACTIONS(2681),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2681),
    [anon_sym___declspec] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2679),
    [anon_sym_unsigned] = ACTIONS(2679),
    [anon_sym_long] = ACTIONS(2679),
    [anon_sym_short] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2679),
    [anon_sym_register] = ACTIONS(2679),
    [anon_sym_inline] = ACTIONS(2679),
    [anon_sym___inline] = ACTIONS(2679),
    [anon_sym___inline__] = ACTIONS(2679),
    [anon_sym___forceinline] = ACTIONS(2679),
    [anon_sym_thread_local] = ACTIONS(2679),
    [anon_sym___thread] = ACTIONS(2679),
    [anon_sym_const] = ACTIONS(2679),
    [anon_sym_constexpr] = ACTIONS(2679),
    [anon_sym_volatile] = ACTIONS(2679),
    [anon_sym_restrict] = ACTIONS(2679),
    [anon_sym___restrict__] = ACTIONS(2679),
    [anon_sym__Atomic] = ACTIONS(2679),
    [anon_sym__Noreturn] = ACTIONS(2679),
    [anon_sym_noreturn] = ACTIONS(2679),
    [anon_sym_mutable] = ACTIONS(2679),
    [anon_sym_constinit] = ACTIONS(2679),
    [anon_sym_consteval] = ACTIONS(2679),
    [anon_sym_PROGMEM] = ACTIONS(2679),
    [aux_sym_primitive_type_token1] = ACTIONS(2679),
    [anon_sym_byte] = ACTIONS(2679),
    [anon_sym_word] = ACTIONS(2679),
    [anon_sym_enum] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2679),
    [anon_sym_struct] = ACTIONS(2679),
    [anon_sym_union] = ACTIONS(2679),
    [anon_sym_if] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2679),
    [anon_sym_switch] = ACTIONS(2679),
    [anon_sym_while] = ACTIONS(2679),
    [anon_sym_do] = ACTIONS(2679),
    [anon_sym_for] = ACTIONS(2679),
    [anon_sym_return] = ACTIONS(2679),
    [anon_sym_break] = ACTIONS(2679),
    [anon_sym_continue] = ACTIONS(2679),
    [anon_sym_goto] = ACTIONS(2679),
    [anon_sym___try] = ACTIONS(2679),
    [anon_sym___leave] = ACTIONS(2679),
    [anon_sym_not] = ACTIONS(2679),
    [anon_sym_compl] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2681),
    [anon_sym_sizeof] = ACTIONS(2679),
    [anon_sym___alignof__] = ACTIONS(2679),
    [anon_sym___alignof] = ACTIONS(2679),
    [anon_sym__alignof] = ACTIONS(2679),
    [anon_sym_alignof] = ACTIONS(2679),
    [anon_sym__Alignof] = ACTIONS(2679),
    [anon_sym_offsetof] = ACTIONS(2679),
    [anon_sym__Generic] = ACTIONS(2679),
    [anon_sym_asm] = ACTIONS(2679),
    [anon_sym___asm__] = ACTIONS(2679),
    [aux_sym_number_literal_token1] = ACTIONS(2681),
    [aux_sym_number_literal_token2] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2681),
    [anon_sym_u_SQUOTE] = ACTIONS(2681),
    [anon_sym_U_SQUOTE] = ACTIONS(2681),
    [anon_sym_u8_SQUOTE] = ACTIONS(2681),
    [anon_sym_SQUOTE] = ACTIONS(2681),
    [anon_sym_L_DQUOTE] = ACTIONS(2681),
    [anon_sym_u_DQUOTE] = ACTIONS(2681),
    [anon_sym_U_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8_DQUOTE] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2681),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [anon_sym_NULL] = ACTIONS(2679),
    [anon_sym_nullptr] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2679),
    [anon_sym_decltype] = ACTIONS(2679),
    [anon_sym_virtual] = ACTIONS(2679),
    [anon_sym_alignas] = ACTIONS(2679),
    [anon_sym_typename] = ACTIONS(2679),
    [anon_sym_template] = ACTIONS(2679),
    [anon_sym_try] = ACTIONS(2679),
    [anon_sym_delete] = ACTIONS(2679),
    [anon_sym_throw] = ACTIONS(2679),
    [anon_sym_co_return] = ACTIONS(2679),
    [anon_sym_co_yield] = ACTIONS(2679),
    [anon_sym_R_DQUOTE] = ACTIONS(2681),
    [anon_sym_LR_DQUOTE] = ACTIONS(2681),
    [anon_sym_uR_DQUOTE] = ACTIONS(2681),
    [anon_sym_UR_DQUOTE] = ACTIONS(2681),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2681),
    [anon_sym_co_await] = ACTIONS(2679),
    [anon_sym_new] = ACTIONS(2679),
    [anon_sym_requires] = ACTIONS(2679),
    [sym_this] = ACTIONS(2679),
  },
  [1010] = {
    [sym_identifier] = ACTIONS(2683),
    [anon_sym_LPAREN2] = ACTIONS(2685),
    [anon_sym_BANG] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2685),
    [anon_sym_DASH] = ACTIONS(2683),
    [anon_sym_PLUS] = ACTIONS(2683),
    [anon_sym_STAR] = ACTIONS(2685),
    [anon_sym_AMP] = ACTIONS(2685),
    [anon_sym_SEMI] = ACTIONS(2685),
    [anon_sym___extension__] = ACTIONS(2683),
    [anon_sym_typedef] = ACTIONS(2683),
    [anon_sym_extern] = ACTIONS(2683),
    [anon_sym___attribute__] = ACTIONS(2683),
    [anon_sym_COLON_COLON] = ACTIONS(2685),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2685),
    [anon_sym___declspec] = ACTIONS(2683),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_signed] = ACTIONS(2683),
    [anon_sym_unsigned] = ACTIONS(2683),
    [anon_sym_long] = ACTIONS(2683),
    [anon_sym_short] = ACTIONS(2683),
    [anon_sym_LBRACK] = ACTIONS(2683),
    [anon_sym_static] = ACTIONS(2683),
    [anon_sym_register] = ACTIONS(2683),
    [anon_sym_inline] = ACTIONS(2683),
    [anon_sym___inline] = ACTIONS(2683),
    [anon_sym___inline__] = ACTIONS(2683),
    [anon_sym___forceinline] = ACTIONS(2683),
    [anon_sym_thread_local] = ACTIONS(2683),
    [anon_sym___thread] = ACTIONS(2683),
    [anon_sym_const] = ACTIONS(2683),
    [anon_sym_constexpr] = ACTIONS(2683),
    [anon_sym_volatile] = ACTIONS(2683),
    [anon_sym_restrict] = ACTIONS(2683),
    [anon_sym___restrict__] = ACTIONS(2683),
    [anon_sym__Atomic] = ACTIONS(2683),
    [anon_sym__Noreturn] = ACTIONS(2683),
    [anon_sym_noreturn] = ACTIONS(2683),
    [anon_sym_mutable] = ACTIONS(2683),
    [anon_sym_constinit] = ACTIONS(2683),
    [anon_sym_consteval] = ACTIONS(2683),
    [anon_sym_PROGMEM] = ACTIONS(2683),
    [aux_sym_primitive_type_token1] = ACTIONS(2683),
    [anon_sym_byte] = ACTIONS(2683),
    [anon_sym_word] = ACTIONS(2683),
    [anon_sym_enum] = ACTIONS(2683),
    [anon_sym_class] = ACTIONS(2683),
    [anon_sym_struct] = ACTIONS(2683),
    [anon_sym_union] = ACTIONS(2683),
    [anon_sym_if] = ACTIONS(2683),
    [anon_sym_else] = ACTIONS(2683),
    [anon_sym_switch] = ACTIONS(2683),
    [anon_sym_while] = ACTIONS(2683),
    [anon_sym_do] = ACTIONS(2683),
    [anon_sym_for] = ACTIONS(2683),
    [anon_sym_return] = ACTIONS(2683),
    [anon_sym_break] = ACTIONS(2683),
    [anon_sym_continue] = ACTIONS(2683),
    [anon_sym_goto] = ACTIONS(2683),
    [anon_sym___try] = ACTIONS(2683),
    [anon_sym___leave] = ACTIONS(2683),
    [anon_sym_not] = ACTIONS(2683),
    [anon_sym_compl] = ACTIONS(2683),
    [anon_sym_DASH_DASH] = ACTIONS(2685),
    [anon_sym_PLUS_PLUS] = ACTIONS(2685),
    [anon_sym_sizeof] = ACTIONS(2683),
    [anon_sym___alignof__] = ACTIONS(2683),
    [anon_sym___alignof] = ACTIONS(2683),
    [anon_sym__alignof] = ACTIONS(2683),
    [anon_sym_alignof] = ACTIONS(2683),
    [anon_sym__Alignof] = ACTIONS(2683),
    [anon_sym_offsetof] = ACTIONS(2683),
    [anon_sym__Generic] = ACTIONS(2683),
    [anon_sym_asm] = ACTIONS(2683),
    [anon_sym___asm__] = ACTIONS(2683),
    [aux_sym_number_literal_token1] = ACTIONS(2685),
    [aux_sym_number_literal_token2] = ACTIONS(2683),
    [anon_sym_L_SQUOTE] = ACTIONS(2685),
    [anon_sym_u_SQUOTE] = ACTIONS(2685),
    [anon_sym_U_SQUOTE] = ACTIONS(2685),
    [anon_sym_u8_SQUOTE] = ACTIONS(2685),
    [anon_sym_SQUOTE] = ACTIONS(2685),
    [anon_sym_L_DQUOTE] = ACTIONS(2685),
    [anon_sym_u_DQUOTE] = ACTIONS(2685),
    [anon_sym_U_DQUOTE] = ACTIONS(2685),
    [anon_sym_u8_DQUOTE] = ACTIONS(2685),
    [anon_sym_DQUOTE] = ACTIONS(2685),
    [sym_true] = ACTIONS(2683),
    [sym_false] = ACTIONS(2683),
    [anon_sym_NULL] = ACTIONS(2683),
    [anon_sym_nullptr] = ACTIONS(2683),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2683),
    [anon_sym_decltype] = ACTIONS(2683),
    [anon_sym_virtual] = ACTIONS(2683),
    [anon_sym_alignas] = ACTIONS(2683),
    [anon_sym_typename] = ACTIONS(2683),
    [anon_sym_template] = ACTIONS(2683),
    [anon_sym_try] = ACTIONS(2683),
    [anon_sym_delete] = ACTIONS(2683),
    [anon_sym_throw] = ACTIONS(2683),
    [anon_sym_co_return] = ACTIONS(2683),
    [anon_sym_co_yield] = ACTIONS(2683),
    [anon_sym_R_DQUOTE] = ACTIONS(2685),
    [anon_sym_LR_DQUOTE] = ACTIONS(2685),
    [anon_sym_uR_DQUOTE] = ACTIONS(2685),
    [anon_sym_UR_DQUOTE] = ACTIONS(2685),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2685),
    [anon_sym_co_await] = ACTIONS(2683),
    [anon_sym_new] = ACTIONS(2683),
    [anon_sym_requires] = ACTIONS(2683),
    [sym_this] = ACTIONS(2683),
  },
  [1011] = {
    [sym_identifier] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2645),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [1012] = {
    [sym_identifier] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2645),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [1013] = {
    [sym_identifier] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2645),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [1014] = {
    [sym_identifier] = ACTIONS(2507),
    [anon_sym_LPAREN2] = ACTIONS(2512),
    [anon_sym_BANG] = ACTIONS(2512),
    [anon_sym_TILDE] = ACTIONS(2512),
    [anon_sym_DASH] = ACTIONS(2507),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_STAR] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2512),
    [anon_sym_SEMI] = ACTIONS(2512),
    [anon_sym___extension__] = ACTIONS(2507),
    [anon_sym_typedef] = ACTIONS(2507),
    [anon_sym_extern] = ACTIONS(2507),
    [anon_sym___attribute__] = ACTIONS(2507),
    [anon_sym_COLON_COLON] = ACTIONS(2512),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2512),
    [anon_sym___declspec] = ACTIONS(2507),
    [anon_sym_LBRACE] = ACTIONS(2512),
    [anon_sym_signed] = ACTIONS(2507),
    [anon_sym_unsigned] = ACTIONS(2507),
    [anon_sym_long] = ACTIONS(2507),
    [anon_sym_short] = ACTIONS(2507),
    [anon_sym_LBRACK] = ACTIONS(2507),
    [anon_sym_static] = ACTIONS(2507),
    [anon_sym_register] = ACTIONS(2507),
    [anon_sym_inline] = ACTIONS(2507),
    [anon_sym___inline] = ACTIONS(2507),
    [anon_sym___inline__] = ACTIONS(2507),
    [anon_sym___forceinline] = ACTIONS(2507),
    [anon_sym_thread_local] = ACTIONS(2507),
    [anon_sym___thread] = ACTIONS(2507),
    [anon_sym_const] = ACTIONS(2507),
    [anon_sym_constexpr] = ACTIONS(2507),
    [anon_sym_volatile] = ACTIONS(2507),
    [anon_sym_restrict] = ACTIONS(2507),
    [anon_sym___restrict__] = ACTIONS(2507),
    [anon_sym__Atomic] = ACTIONS(2507),
    [anon_sym__Noreturn] = ACTIONS(2507),
    [anon_sym_noreturn] = ACTIONS(2507),
    [anon_sym_mutable] = ACTIONS(2507),
    [anon_sym_constinit] = ACTIONS(2507),
    [anon_sym_consteval] = ACTIONS(2507),
    [anon_sym_PROGMEM] = ACTIONS(2507),
    [aux_sym_primitive_type_token1] = ACTIONS(2507),
    [anon_sym_byte] = ACTIONS(2507),
    [anon_sym_word] = ACTIONS(2507),
    [anon_sym_enum] = ACTIONS(2507),
    [anon_sym_class] = ACTIONS(2507),
    [anon_sym_struct] = ACTIONS(2507),
    [anon_sym_union] = ACTIONS(2507),
    [anon_sym_if] = ACTIONS(2507),
    [anon_sym_else] = ACTIONS(2507),
    [anon_sym_switch] = ACTIONS(2507),
    [anon_sym_while] = ACTIONS(2507),
    [anon_sym_do] = ACTIONS(2507),
    [anon_sym_for] = ACTIONS(2507),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_break] = ACTIONS(2507),
    [anon_sym_continue] = ACTIONS(2507),
    [anon_sym_goto] = ACTIONS(2507),
    [anon_sym___try] = ACTIONS(2507),
    [anon_sym___leave] = ACTIONS(2507),
    [anon_sym_not] = ACTIONS(2507),
    [anon_sym_compl] = ACTIONS(2507),
    [anon_sym_DASH_DASH] = ACTIONS(2512),
    [anon_sym_PLUS_PLUS] = ACTIONS(2512),
    [anon_sym_sizeof] = ACTIONS(2507),
    [anon_sym___alignof__] = ACTIONS(2507),
    [anon_sym___alignof] = ACTIONS(2507),
    [anon_sym__alignof] = ACTIONS(2507),
    [anon_sym_alignof] = ACTIONS(2507),
    [anon_sym__Alignof] = ACTIONS(2507),
    [anon_sym_offsetof] = ACTIONS(2507),
    [anon_sym__Generic] = ACTIONS(2507),
    [anon_sym_asm] = ACTIONS(2507),
    [anon_sym___asm__] = ACTIONS(2507),
    [aux_sym_number_literal_token1] = ACTIONS(2512),
    [aux_sym_number_literal_token2] = ACTIONS(2507),
    [anon_sym_L_SQUOTE] = ACTIONS(2512),
    [anon_sym_u_SQUOTE] = ACTIONS(2512),
    [anon_sym_U_SQUOTE] = ACTIONS(2512),
    [anon_sym_u8_SQUOTE] = ACTIONS(2512),
    [anon_sym_SQUOTE] = ACTIONS(2512),
    [anon_sym_L_DQUOTE] = ACTIONS(2512),
    [anon_sym_u_DQUOTE] = ACTIONS(2512),
    [anon_sym_U_DQUOTE] = ACTIONS(2512),
    [anon_sym_u8_DQUOTE] = ACTIONS(2512),
    [anon_sym_DQUOTE] = ACTIONS(2512),
    [sym_true] = ACTIONS(2507),
    [sym_false] = ACTIONS(2507),
    [anon_sym_NULL] = ACTIONS(2507),
    [anon_sym_nullptr] = ACTIONS(2507),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2507),
    [anon_sym_decltype] = ACTIONS(2507),
    [anon_sym_virtual] = ACTIONS(2507),
    [anon_sym_alignas] = ACTIONS(2507),
    [anon_sym_typename] = ACTIONS(2507),
    [anon_sym_template] = ACTIONS(2507),
    [anon_sym_try] = ACTIONS(2507),
    [anon_sym_delete] = ACTIONS(2507),
    [anon_sym_throw] = ACTIONS(2507),
    [anon_sym_co_return] = ACTIONS(2507),
    [anon_sym_co_yield] = ACTIONS(2507),
    [anon_sym_R_DQUOTE] = ACTIONS(2512),
    [anon_sym_LR_DQUOTE] = ACTIONS(2512),
    [anon_sym_uR_DQUOTE] = ACTIONS(2512),
    [anon_sym_UR_DQUOTE] = ACTIONS(2512),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2512),
    [anon_sym_co_await] = ACTIONS(2507),
    [anon_sym_new] = ACTIONS(2507),
    [anon_sym_requires] = ACTIONS(2507),
    [sym_this] = ACTIONS(2507),
  },
  [1015] = {
    [sym_identifier] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2645),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [1016] = {
    [sym_identifier] = ACTIONS(2747),
    [anon_sym_LPAREN2] = ACTIONS(2749),
    [anon_sym_BANG] = ACTIONS(2749),
    [anon_sym_TILDE] = ACTIONS(2749),
    [anon_sym_DASH] = ACTIONS(2747),
    [anon_sym_PLUS] = ACTIONS(2747),
    [anon_sym_STAR] = ACTIONS(2749),
    [anon_sym_AMP] = ACTIONS(2749),
    [anon_sym_SEMI] = ACTIONS(2749),
    [anon_sym___extension__] = ACTIONS(2747),
    [anon_sym_typedef] = ACTIONS(2747),
    [anon_sym_extern] = ACTIONS(2747),
    [anon_sym___attribute__] = ACTIONS(2747),
    [anon_sym_COLON_COLON] = ACTIONS(2749),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2749),
    [anon_sym___declspec] = ACTIONS(2747),
    [anon_sym_LBRACE] = ACTIONS(2749),
    [anon_sym_signed] = ACTIONS(2747),
    [anon_sym_unsigned] = ACTIONS(2747),
    [anon_sym_long] = ACTIONS(2747),
    [anon_sym_short] = ACTIONS(2747),
    [anon_sym_LBRACK] = ACTIONS(2747),
    [anon_sym_static] = ACTIONS(2747),
    [anon_sym_register] = ACTIONS(2747),
    [anon_sym_inline] = ACTIONS(2747),
    [anon_sym___inline] = ACTIONS(2747),
    [anon_sym___inline__] = ACTIONS(2747),
    [anon_sym___forceinline] = ACTIONS(2747),
    [anon_sym_thread_local] = ACTIONS(2747),
    [anon_sym___thread] = ACTIONS(2747),
    [anon_sym_const] = ACTIONS(2747),
    [anon_sym_constexpr] = ACTIONS(2747),
    [anon_sym_volatile] = ACTIONS(2747),
    [anon_sym_restrict] = ACTIONS(2747),
    [anon_sym___restrict__] = ACTIONS(2747),
    [anon_sym__Atomic] = ACTIONS(2747),
    [anon_sym__Noreturn] = ACTIONS(2747),
    [anon_sym_noreturn] = ACTIONS(2747),
    [anon_sym_mutable] = ACTIONS(2747),
    [anon_sym_constinit] = ACTIONS(2747),
    [anon_sym_consteval] = ACTIONS(2747),
    [anon_sym_PROGMEM] = ACTIONS(2747),
    [aux_sym_primitive_type_token1] = ACTIONS(2747),
    [anon_sym_byte] = ACTIONS(2747),
    [anon_sym_word] = ACTIONS(2747),
    [anon_sym_enum] = ACTIONS(2747),
    [anon_sym_class] = ACTIONS(2747),
    [anon_sym_struct] = ACTIONS(2747),
    [anon_sym_union] = ACTIONS(2747),
    [anon_sym_if] = ACTIONS(2747),
    [anon_sym_else] = ACTIONS(2747),
    [anon_sym_switch] = ACTIONS(2747),
    [anon_sym_while] = ACTIONS(2747),
    [anon_sym_do] = ACTIONS(2747),
    [anon_sym_for] = ACTIONS(2747),
    [anon_sym_return] = ACTIONS(2747),
    [anon_sym_break] = ACTIONS(2747),
    [anon_sym_continue] = ACTIONS(2747),
    [anon_sym_goto] = ACTIONS(2747),
    [anon_sym___try] = ACTIONS(2747),
    [anon_sym___leave] = ACTIONS(2747),
    [anon_sym_not] = ACTIONS(2747),
    [anon_sym_compl] = ACTIONS(2747),
    [anon_sym_DASH_DASH] = ACTIONS(2749),
    [anon_sym_PLUS_PLUS] = ACTIONS(2749),
    [anon_sym_sizeof] = ACTIONS(2747),
    [anon_sym___alignof__] = ACTIONS(2747),
    [anon_sym___alignof] = ACTIONS(2747),
    [anon_sym__alignof] = ACTIONS(2747),
    [anon_sym_alignof] = ACTIONS(2747),
    [anon_sym__Alignof] = ACTIONS(2747),
    [anon_sym_offsetof] = ACTIONS(2747),
    [anon_sym__Generic] = ACTIONS(2747),
    [anon_sym_asm] = ACTIONS(2747),
    [anon_sym___asm__] = ACTIONS(2747),
    [aux_sym_number_literal_token1] = ACTIONS(2749),
    [aux_sym_number_literal_token2] = ACTIONS(2747),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2749),
    [anon_sym_u_DQUOTE] = ACTIONS(2749),
    [anon_sym_U_DQUOTE] = ACTIONS(2749),
    [anon_sym_u8_DQUOTE] = ACTIONS(2749),
    [anon_sym_DQUOTE] = ACTIONS(2749),
    [sym_true] = ACTIONS(2747),
    [sym_false] = ACTIONS(2747),
    [anon_sym_NULL] = ACTIONS(2747),
    [anon_sym_nullptr] = ACTIONS(2747),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2747),
    [anon_sym_decltype] = ACTIONS(2747),
    [anon_sym_virtual] = ACTIONS(2747),
    [anon_sym_alignas] = ACTIONS(2747),
    [anon_sym_typename] = ACTIONS(2747),
    [anon_sym_template] = ACTIONS(2747),
    [anon_sym_try] = ACTIONS(2747),
    [anon_sym_delete] = ACTIONS(2747),
    [anon_sym_throw] = ACTIONS(2747),
    [anon_sym_co_return] = ACTIONS(2747),
    [anon_sym_co_yield] = ACTIONS(2747),
    [anon_sym_R_DQUOTE] = ACTIONS(2749),
    [anon_sym_LR_DQUOTE] = ACTIONS(2749),
    [anon_sym_uR_DQUOTE] = ACTIONS(2749),
    [anon_sym_UR_DQUOTE] = ACTIONS(2749),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2749),
    [anon_sym_co_await] = ACTIONS(2747),
    [anon_sym_new] = ACTIONS(2747),
    [anon_sym_requires] = ACTIONS(2747),
    [sym_this] = ACTIONS(2747),
  },
  [1017] = {
    [sym_identifier] = ACTIONS(2761),
    [anon_sym_LPAREN2] = ACTIONS(2763),
    [anon_sym_BANG] = ACTIONS(2763),
    [anon_sym_TILDE] = ACTIONS(2763),
    [anon_sym_DASH] = ACTIONS(2761),
    [anon_sym_PLUS] = ACTIONS(2761),
    [anon_sym_STAR] = ACTIONS(2763),
    [anon_sym_AMP] = ACTIONS(2763),
    [anon_sym_SEMI] = ACTIONS(2763),
    [anon_sym___extension__] = ACTIONS(2761),
    [anon_sym_typedef] = ACTIONS(2761),
    [anon_sym_extern] = ACTIONS(2761),
    [anon_sym___attribute__] = ACTIONS(2761),
    [anon_sym_COLON_COLON] = ACTIONS(2763),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2763),
    [anon_sym___declspec] = ACTIONS(2761),
    [anon_sym_LBRACE] = ACTIONS(2763),
    [anon_sym_signed] = ACTIONS(2761),
    [anon_sym_unsigned] = ACTIONS(2761),
    [anon_sym_long] = ACTIONS(2761),
    [anon_sym_short] = ACTIONS(2761),
    [anon_sym_LBRACK] = ACTIONS(2761),
    [anon_sym_static] = ACTIONS(2761),
    [anon_sym_register] = ACTIONS(2761),
    [anon_sym_inline] = ACTIONS(2761),
    [anon_sym___inline] = ACTIONS(2761),
    [anon_sym___inline__] = ACTIONS(2761),
    [anon_sym___forceinline] = ACTIONS(2761),
    [anon_sym_thread_local] = ACTIONS(2761),
    [anon_sym___thread] = ACTIONS(2761),
    [anon_sym_const] = ACTIONS(2761),
    [anon_sym_constexpr] = ACTIONS(2761),
    [anon_sym_volatile] = ACTIONS(2761),
    [anon_sym_restrict] = ACTIONS(2761),
    [anon_sym___restrict__] = ACTIONS(2761),
    [anon_sym__Atomic] = ACTIONS(2761),
    [anon_sym__Noreturn] = ACTIONS(2761),
    [anon_sym_noreturn] = ACTIONS(2761),
    [anon_sym_mutable] = ACTIONS(2761),
    [anon_sym_constinit] = ACTIONS(2761),
    [anon_sym_consteval] = ACTIONS(2761),
    [anon_sym_PROGMEM] = ACTIONS(2761),
    [aux_sym_primitive_type_token1] = ACTIONS(2761),
    [anon_sym_byte] = ACTIONS(2761),
    [anon_sym_word] = ACTIONS(2761),
    [anon_sym_enum] = ACTIONS(2761),
    [anon_sym_class] = ACTIONS(2761),
    [anon_sym_struct] = ACTIONS(2761),
    [anon_sym_union] = ACTIONS(2761),
    [anon_sym_if] = ACTIONS(2761),
    [anon_sym_else] = ACTIONS(2761),
    [anon_sym_switch] = ACTIONS(2761),
    [anon_sym_while] = ACTIONS(2761),
    [anon_sym_do] = ACTIONS(2761),
    [anon_sym_for] = ACTIONS(2761),
    [anon_sym_return] = ACTIONS(2761),
    [anon_sym_break] = ACTIONS(2761),
    [anon_sym_continue] = ACTIONS(2761),
    [anon_sym_goto] = ACTIONS(2761),
    [anon_sym___try] = ACTIONS(2761),
    [anon_sym___leave] = ACTIONS(2761),
    [anon_sym_not] = ACTIONS(2761),
    [anon_sym_compl] = ACTIONS(2761),
    [anon_sym_DASH_DASH] = ACTIONS(2763),
    [anon_sym_PLUS_PLUS] = ACTIONS(2763),
    [anon_sym_sizeof] = ACTIONS(2761),
    [anon_sym___alignof__] = ACTIONS(2761),
    [anon_sym___alignof] = ACTIONS(2761),
    [anon_sym__alignof] = ACTIONS(2761),
    [anon_sym_alignof] = ACTIONS(2761),
    [anon_sym__Alignof] = ACTIONS(2761),
    [anon_sym_offsetof] = ACTIONS(2761),
    [anon_sym__Generic] = ACTIONS(2761),
    [anon_sym_asm] = ACTIONS(2761),
    [anon_sym___asm__] = ACTIONS(2761),
    [aux_sym_number_literal_token1] = ACTIONS(2763),
    [aux_sym_number_literal_token2] = ACTIONS(2761),
    [anon_sym_L_SQUOTE] = ACTIONS(2763),
    [anon_sym_u_SQUOTE] = ACTIONS(2763),
    [anon_sym_U_SQUOTE] = ACTIONS(2763),
    [anon_sym_u8_SQUOTE] = ACTIONS(2763),
    [anon_sym_SQUOTE] = ACTIONS(2763),
    [anon_sym_L_DQUOTE] = ACTIONS(2763),
    [anon_sym_u_DQUOTE] = ACTIONS(2763),
    [anon_sym_U_DQUOTE] = ACTIONS(2763),
    [anon_sym_u8_DQUOTE] = ACTIONS(2763),
    [anon_sym_DQUOTE] = ACTIONS(2763),
    [sym_true] = ACTIONS(2761),
    [sym_false] = ACTIONS(2761),
    [anon_sym_NULL] = ACTIONS(2761),
    [anon_sym_nullptr] = ACTIONS(2761),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2761),
    [anon_sym_decltype] = ACTIONS(2761),
    [anon_sym_virtual] = ACTIONS(2761),
    [anon_sym_alignas] = ACTIONS(2761),
    [anon_sym_typename] = ACTIONS(2761),
    [anon_sym_template] = ACTIONS(2761),
    [anon_sym_try] = ACTIONS(2761),
    [anon_sym_delete] = ACTIONS(2761),
    [anon_sym_throw] = ACTIONS(2761),
    [anon_sym_co_return] = ACTIONS(2761),
    [anon_sym_co_yield] = ACTIONS(2761),
    [anon_sym_R_DQUOTE] = ACTIONS(2763),
    [anon_sym_LR_DQUOTE] = ACTIONS(2763),
    [anon_sym_uR_DQUOTE] = ACTIONS(2763),
    [anon_sym_UR_DQUOTE] = ACTIONS(2763),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2763),
    [anon_sym_co_await] = ACTIONS(2761),
    [anon_sym_new] = ACTIONS(2761),
    [anon_sym_requires] = ACTIONS(2761),
    [sym_this] = ACTIONS(2761),
  },
  [1018] = {
    [sym_identifier] = ACTIONS(2765),
    [anon_sym_LPAREN2] = ACTIONS(2767),
    [anon_sym_BANG] = ACTIONS(2767),
    [anon_sym_TILDE] = ACTIONS(2767),
    [anon_sym_DASH] = ACTIONS(2765),
    [anon_sym_PLUS] = ACTIONS(2765),
    [anon_sym_STAR] = ACTIONS(2767),
    [anon_sym_AMP] = ACTIONS(2767),
    [anon_sym_SEMI] = ACTIONS(2767),
    [anon_sym___extension__] = ACTIONS(2765),
    [anon_sym_typedef] = ACTIONS(2765),
    [anon_sym_extern] = ACTIONS(2765),
    [anon_sym___attribute__] = ACTIONS(2765),
    [anon_sym_COLON_COLON] = ACTIONS(2767),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2767),
    [anon_sym___declspec] = ACTIONS(2765),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_signed] = ACTIONS(2765),
    [anon_sym_unsigned] = ACTIONS(2765),
    [anon_sym_long] = ACTIONS(2765),
    [anon_sym_short] = ACTIONS(2765),
    [anon_sym_LBRACK] = ACTIONS(2765),
    [anon_sym_static] = ACTIONS(2765),
    [anon_sym_register] = ACTIONS(2765),
    [anon_sym_inline] = ACTIONS(2765),
    [anon_sym___inline] = ACTIONS(2765),
    [anon_sym___inline__] = ACTIONS(2765),
    [anon_sym___forceinline] = ACTIONS(2765),
    [anon_sym_thread_local] = ACTIONS(2765),
    [anon_sym___thread] = ACTIONS(2765),
    [anon_sym_const] = ACTIONS(2765),
    [anon_sym_constexpr] = ACTIONS(2765),
    [anon_sym_volatile] = ACTIONS(2765),
    [anon_sym_restrict] = ACTIONS(2765),
    [anon_sym___restrict__] = ACTIONS(2765),
    [anon_sym__Atomic] = ACTIONS(2765),
    [anon_sym__Noreturn] = ACTIONS(2765),
    [anon_sym_noreturn] = ACTIONS(2765),
    [anon_sym_mutable] = ACTIONS(2765),
    [anon_sym_constinit] = ACTIONS(2765),
    [anon_sym_consteval] = ACTIONS(2765),
    [anon_sym_PROGMEM] = ACTIONS(2765),
    [aux_sym_primitive_type_token1] = ACTIONS(2765),
    [anon_sym_byte] = ACTIONS(2765),
    [anon_sym_word] = ACTIONS(2765),
    [anon_sym_enum] = ACTIONS(2765),
    [anon_sym_class] = ACTIONS(2765),
    [anon_sym_struct] = ACTIONS(2765),
    [anon_sym_union] = ACTIONS(2765),
    [anon_sym_if] = ACTIONS(2765),
    [anon_sym_else] = ACTIONS(2765),
    [anon_sym_switch] = ACTIONS(2765),
    [anon_sym_while] = ACTIONS(2765),
    [anon_sym_do] = ACTIONS(2765),
    [anon_sym_for] = ACTIONS(2765),
    [anon_sym_return] = ACTIONS(2765),
    [anon_sym_break] = ACTIONS(2765),
    [anon_sym_continue] = ACTIONS(2765),
    [anon_sym_goto] = ACTIONS(2765),
    [anon_sym___try] = ACTIONS(2765),
    [anon_sym___leave] = ACTIONS(2765),
    [anon_sym_not] = ACTIONS(2765),
    [anon_sym_compl] = ACTIONS(2765),
    [anon_sym_DASH_DASH] = ACTIONS(2767),
    [anon_sym_PLUS_PLUS] = ACTIONS(2767),
    [anon_sym_sizeof] = ACTIONS(2765),
    [anon_sym___alignof__] = ACTIONS(2765),
    [anon_sym___alignof] = ACTIONS(2765),
    [anon_sym__alignof] = ACTIONS(2765),
    [anon_sym_alignof] = ACTIONS(2765),
    [anon_sym__Alignof] = ACTIONS(2765),
    [anon_sym_offsetof] = ACTIONS(2765),
    [anon_sym__Generic] = ACTIONS(2765),
    [anon_sym_asm] = ACTIONS(2765),
    [anon_sym___asm__] = ACTIONS(2765),
    [aux_sym_number_literal_token1] = ACTIONS(2767),
    [aux_sym_number_literal_token2] = ACTIONS(2765),
    [anon_sym_L_SQUOTE] = ACTIONS(2767),
    [anon_sym_u_SQUOTE] = ACTIONS(2767),
    [anon_sym_U_SQUOTE] = ACTIONS(2767),
    [anon_sym_u8_SQUOTE] = ACTIONS(2767),
    [anon_sym_SQUOTE] = ACTIONS(2767),
    [anon_sym_L_DQUOTE] = ACTIONS(2767),
    [anon_sym_u_DQUOTE] = ACTIONS(2767),
    [anon_sym_U_DQUOTE] = ACTIONS(2767),
    [anon_sym_u8_DQUOTE] = ACTIONS(2767),
    [anon_sym_DQUOTE] = ACTIONS(2767),
    [sym_true] = ACTIONS(2765),
    [sym_false] = ACTIONS(2765),
    [anon_sym_NULL] = ACTIONS(2765),
    [anon_sym_nullptr] = ACTIONS(2765),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2765),
    [anon_sym_decltype] = ACTIONS(2765),
    [anon_sym_virtual] = ACTIONS(2765),
    [anon_sym_alignas] = ACTIONS(2765),
    [anon_sym_typename] = ACTIONS(2765),
    [anon_sym_template] = ACTIONS(2765),
    [anon_sym_try] = ACTIONS(2765),
    [anon_sym_delete] = ACTIONS(2765),
    [anon_sym_throw] = ACTIONS(2765),
    [anon_sym_co_return] = ACTIONS(2765),
    [anon_sym_co_yield] = ACTIONS(2765),
    [anon_sym_R_DQUOTE] = ACTIONS(2767),
    [anon_sym_LR_DQUOTE] = ACTIONS(2767),
    [anon_sym_uR_DQUOTE] = ACTIONS(2767),
    [anon_sym_UR_DQUOTE] = ACTIONS(2767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2767),
    [anon_sym_co_await] = ACTIONS(2765),
    [anon_sym_new] = ACTIONS(2765),
    [anon_sym_requires] = ACTIONS(2765),
    [sym_this] = ACTIONS(2765),
  },
  [1019] = {
    [sym_identifier] = ACTIONS(2769),
    [anon_sym_LPAREN2] = ACTIONS(2771),
    [anon_sym_BANG] = ACTIONS(2771),
    [anon_sym_TILDE] = ACTIONS(2771),
    [anon_sym_DASH] = ACTIONS(2769),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_STAR] = ACTIONS(2771),
    [anon_sym_AMP] = ACTIONS(2771),
    [anon_sym_SEMI] = ACTIONS(2771),
    [anon_sym___extension__] = ACTIONS(2769),
    [anon_sym_typedef] = ACTIONS(2769),
    [anon_sym_extern] = ACTIONS(2769),
    [anon_sym___attribute__] = ACTIONS(2769),
    [anon_sym_COLON_COLON] = ACTIONS(2771),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2771),
    [anon_sym___declspec] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(2771),
    [anon_sym_signed] = ACTIONS(2769),
    [anon_sym_unsigned] = ACTIONS(2769),
    [anon_sym_long] = ACTIONS(2769),
    [anon_sym_short] = ACTIONS(2769),
    [anon_sym_LBRACK] = ACTIONS(2769),
    [anon_sym_static] = ACTIONS(2769),
    [anon_sym_register] = ACTIONS(2769),
    [anon_sym_inline] = ACTIONS(2769),
    [anon_sym___inline] = ACTIONS(2769),
    [anon_sym___inline__] = ACTIONS(2769),
    [anon_sym___forceinline] = ACTIONS(2769),
    [anon_sym_thread_local] = ACTIONS(2769),
    [anon_sym___thread] = ACTIONS(2769),
    [anon_sym_const] = ACTIONS(2769),
    [anon_sym_constexpr] = ACTIONS(2769),
    [anon_sym_volatile] = ACTIONS(2769),
    [anon_sym_restrict] = ACTIONS(2769),
    [anon_sym___restrict__] = ACTIONS(2769),
    [anon_sym__Atomic] = ACTIONS(2769),
    [anon_sym__Noreturn] = ACTIONS(2769),
    [anon_sym_noreturn] = ACTIONS(2769),
    [anon_sym_mutable] = ACTIONS(2769),
    [anon_sym_constinit] = ACTIONS(2769),
    [anon_sym_consteval] = ACTIONS(2769),
    [anon_sym_PROGMEM] = ACTIONS(2769),
    [aux_sym_primitive_type_token1] = ACTIONS(2769),
    [anon_sym_byte] = ACTIONS(2769),
    [anon_sym_word] = ACTIONS(2769),
    [anon_sym_enum] = ACTIONS(2769),
    [anon_sym_class] = ACTIONS(2769),
    [anon_sym_struct] = ACTIONS(2769),
    [anon_sym_union] = ACTIONS(2769),
    [anon_sym_if] = ACTIONS(2769),
    [anon_sym_else] = ACTIONS(2769),
    [anon_sym_switch] = ACTIONS(2769),
    [anon_sym_while] = ACTIONS(2769),
    [anon_sym_do] = ACTIONS(2769),
    [anon_sym_for] = ACTIONS(2769),
    [anon_sym_return] = ACTIONS(2769),
    [anon_sym_break] = ACTIONS(2769),
    [anon_sym_continue] = ACTIONS(2769),
    [anon_sym_goto] = ACTIONS(2769),
    [anon_sym___try] = ACTIONS(2769),
    [anon_sym___leave] = ACTIONS(2769),
    [anon_sym_not] = ACTIONS(2769),
    [anon_sym_compl] = ACTIONS(2769),
    [anon_sym_DASH_DASH] = ACTIONS(2771),
    [anon_sym_PLUS_PLUS] = ACTIONS(2771),
    [anon_sym_sizeof] = ACTIONS(2769),
    [anon_sym___alignof__] = ACTIONS(2769),
    [anon_sym___alignof] = ACTIONS(2769),
    [anon_sym__alignof] = ACTIONS(2769),
    [anon_sym_alignof] = ACTIONS(2769),
    [anon_sym__Alignof] = ACTIONS(2769),
    [anon_sym_offsetof] = ACTIONS(2769),
    [anon_sym__Generic] = ACTIONS(2769),
    [anon_sym_asm] = ACTIONS(2769),
    [anon_sym___asm__] = ACTIONS(2769),
    [aux_sym_number_literal_token1] = ACTIONS(2771),
    [aux_sym_number_literal_token2] = ACTIONS(2769),
    [anon_sym_L_SQUOTE] = ACTIONS(2771),
    [anon_sym_u_SQUOTE] = ACTIONS(2771),
    [anon_sym_U_SQUOTE] = ACTIONS(2771),
    [anon_sym_u8_SQUOTE] = ACTIONS(2771),
    [anon_sym_SQUOTE] = ACTIONS(2771),
    [anon_sym_L_DQUOTE] = ACTIONS(2771),
    [anon_sym_u_DQUOTE] = ACTIONS(2771),
    [anon_sym_U_DQUOTE] = ACTIONS(2771),
    [anon_sym_u8_DQUOTE] = ACTIONS(2771),
    [anon_sym_DQUOTE] = ACTIONS(2771),
    [sym_true] = ACTIONS(2769),
    [sym_false] = ACTIONS(2769),
    [anon_sym_NULL] = ACTIONS(2769),
    [anon_sym_nullptr] = ACTIONS(2769),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2769),
    [anon_sym_decltype] = ACTIONS(2769),
    [anon_sym_virtual] = ACTIONS(2769),
    [anon_sym_alignas] = ACTIONS(2769),
    [anon_sym_typename] = ACTIONS(2769),
    [anon_sym_template] = ACTIONS(2769),
    [anon_sym_try] = ACTIONS(2769),
    [anon_sym_delete] = ACTIONS(2769),
    [anon_sym_throw] = ACTIONS(2769),
    [anon_sym_co_return] = ACTIONS(2769),
    [anon_sym_co_yield] = ACTIONS(2769),
    [anon_sym_R_DQUOTE] = ACTIONS(2771),
    [anon_sym_LR_DQUOTE] = ACTIONS(2771),
    [anon_sym_uR_DQUOTE] = ACTIONS(2771),
    [anon_sym_UR_DQUOTE] = ACTIONS(2771),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2771),
    [anon_sym_co_await] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2769),
    [anon_sym_requires] = ACTIONS(2769),
    [sym_this] = ACTIONS(2769),
  },
  [1020] = {
    [sym_identifier] = ACTIONS(2773),
    [anon_sym_LPAREN2] = ACTIONS(2775),
    [anon_sym_BANG] = ACTIONS(2775),
    [anon_sym_TILDE] = ACTIONS(2775),
    [anon_sym_DASH] = ACTIONS(2773),
    [anon_sym_PLUS] = ACTIONS(2773),
    [anon_sym_STAR] = ACTIONS(2775),
    [anon_sym_AMP] = ACTIONS(2775),
    [anon_sym_SEMI] = ACTIONS(2775),
    [anon_sym___extension__] = ACTIONS(2773),
    [anon_sym_typedef] = ACTIONS(2773),
    [anon_sym_extern] = ACTIONS(2773),
    [anon_sym___attribute__] = ACTIONS(2773),
    [anon_sym_COLON_COLON] = ACTIONS(2775),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2775),
    [anon_sym___declspec] = ACTIONS(2773),
    [anon_sym_LBRACE] = ACTIONS(2775),
    [anon_sym_signed] = ACTIONS(2773),
    [anon_sym_unsigned] = ACTIONS(2773),
    [anon_sym_long] = ACTIONS(2773),
    [anon_sym_short] = ACTIONS(2773),
    [anon_sym_LBRACK] = ACTIONS(2773),
    [anon_sym_static] = ACTIONS(2773),
    [anon_sym_register] = ACTIONS(2773),
    [anon_sym_inline] = ACTIONS(2773),
    [anon_sym___inline] = ACTIONS(2773),
    [anon_sym___inline__] = ACTIONS(2773),
    [anon_sym___forceinline] = ACTIONS(2773),
    [anon_sym_thread_local] = ACTIONS(2773),
    [anon_sym___thread] = ACTIONS(2773),
    [anon_sym_const] = ACTIONS(2773),
    [anon_sym_constexpr] = ACTIONS(2773),
    [anon_sym_volatile] = ACTIONS(2773),
    [anon_sym_restrict] = ACTIONS(2773),
    [anon_sym___restrict__] = ACTIONS(2773),
    [anon_sym__Atomic] = ACTIONS(2773),
    [anon_sym__Noreturn] = ACTIONS(2773),
    [anon_sym_noreturn] = ACTIONS(2773),
    [anon_sym_mutable] = ACTIONS(2773),
    [anon_sym_constinit] = ACTIONS(2773),
    [anon_sym_consteval] = ACTIONS(2773),
    [anon_sym_PROGMEM] = ACTIONS(2773),
    [aux_sym_primitive_type_token1] = ACTIONS(2773),
    [anon_sym_byte] = ACTIONS(2773),
    [anon_sym_word] = ACTIONS(2773),
    [anon_sym_enum] = ACTIONS(2773),
    [anon_sym_class] = ACTIONS(2773),
    [anon_sym_struct] = ACTIONS(2773),
    [anon_sym_union] = ACTIONS(2773),
    [anon_sym_if] = ACTIONS(2773),
    [anon_sym_else] = ACTIONS(2773),
    [anon_sym_switch] = ACTIONS(2773),
    [anon_sym_while] = ACTIONS(2773),
    [anon_sym_do] = ACTIONS(2773),
    [anon_sym_for] = ACTIONS(2773),
    [anon_sym_return] = ACTIONS(2773),
    [anon_sym_break] = ACTIONS(2773),
    [anon_sym_continue] = ACTIONS(2773),
    [anon_sym_goto] = ACTIONS(2773),
    [anon_sym___try] = ACTIONS(2773),
    [anon_sym___leave] = ACTIONS(2773),
    [anon_sym_not] = ACTIONS(2773),
    [anon_sym_compl] = ACTIONS(2773),
    [anon_sym_DASH_DASH] = ACTIONS(2775),
    [anon_sym_PLUS_PLUS] = ACTIONS(2775),
    [anon_sym_sizeof] = ACTIONS(2773),
    [anon_sym___alignof__] = ACTIONS(2773),
    [anon_sym___alignof] = ACTIONS(2773),
    [anon_sym__alignof] = ACTIONS(2773),
    [anon_sym_alignof] = ACTIONS(2773),
    [anon_sym__Alignof] = ACTIONS(2773),
    [anon_sym_offsetof] = ACTIONS(2773),
    [anon_sym__Generic] = ACTIONS(2773),
    [anon_sym_asm] = ACTIONS(2773),
    [anon_sym___asm__] = ACTIONS(2773),
    [aux_sym_number_literal_token1] = ACTIONS(2775),
    [aux_sym_number_literal_token2] = ACTIONS(2773),
    [anon_sym_L_SQUOTE] = ACTIONS(2775),
    [anon_sym_u_SQUOTE] = ACTIONS(2775),
    [anon_sym_U_SQUOTE] = ACTIONS(2775),
    [anon_sym_u8_SQUOTE] = ACTIONS(2775),
    [anon_sym_SQUOTE] = ACTIONS(2775),
    [anon_sym_L_DQUOTE] = ACTIONS(2775),
    [anon_sym_u_DQUOTE] = ACTIONS(2775),
    [anon_sym_U_DQUOTE] = ACTIONS(2775),
    [anon_sym_u8_DQUOTE] = ACTIONS(2775),
    [anon_sym_DQUOTE] = ACTIONS(2775),
    [sym_true] = ACTIONS(2773),
    [sym_false] = ACTIONS(2773),
    [anon_sym_NULL] = ACTIONS(2773),
    [anon_sym_nullptr] = ACTIONS(2773),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2773),
    [anon_sym_decltype] = ACTIONS(2773),
    [anon_sym_virtual] = ACTIONS(2773),
    [anon_sym_alignas] = ACTIONS(2773),
    [anon_sym_typename] = ACTIONS(2773),
    [anon_sym_template] = ACTIONS(2773),
    [anon_sym_try] = ACTIONS(2773),
    [anon_sym_delete] = ACTIONS(2773),
    [anon_sym_throw] = ACTIONS(2773),
    [anon_sym_co_return] = ACTIONS(2773),
    [anon_sym_co_yield] = ACTIONS(2773),
    [anon_sym_R_DQUOTE] = ACTIONS(2775),
    [anon_sym_LR_DQUOTE] = ACTIONS(2775),
    [anon_sym_uR_DQUOTE] = ACTIONS(2775),
    [anon_sym_UR_DQUOTE] = ACTIONS(2775),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2775),
    [anon_sym_co_await] = ACTIONS(2773),
    [anon_sym_new] = ACTIONS(2773),
    [anon_sym_requires] = ACTIONS(2773),
    [sym_this] = ACTIONS(2773),
  },
  [1021] = {
    [sym_identifier] = ACTIONS(2783),
    [anon_sym_LPAREN2] = ACTIONS(2785),
    [anon_sym_BANG] = ACTIONS(2785),
    [anon_sym_TILDE] = ACTIONS(2785),
    [anon_sym_DASH] = ACTIONS(2783),
    [anon_sym_PLUS] = ACTIONS(2783),
    [anon_sym_STAR] = ACTIONS(2785),
    [anon_sym_AMP] = ACTIONS(2785),
    [anon_sym_SEMI] = ACTIONS(2785),
    [anon_sym___extension__] = ACTIONS(2783),
    [anon_sym_typedef] = ACTIONS(2783),
    [anon_sym_extern] = ACTIONS(2783),
    [anon_sym___attribute__] = ACTIONS(2783),
    [anon_sym_COLON_COLON] = ACTIONS(2785),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2785),
    [anon_sym___declspec] = ACTIONS(2783),
    [anon_sym_LBRACE] = ACTIONS(2785),
    [anon_sym_signed] = ACTIONS(2783),
    [anon_sym_unsigned] = ACTIONS(2783),
    [anon_sym_long] = ACTIONS(2783),
    [anon_sym_short] = ACTIONS(2783),
    [anon_sym_LBRACK] = ACTIONS(2783),
    [anon_sym_static] = ACTIONS(2783),
    [anon_sym_register] = ACTIONS(2783),
    [anon_sym_inline] = ACTIONS(2783),
    [anon_sym___inline] = ACTIONS(2783),
    [anon_sym___inline__] = ACTIONS(2783),
    [anon_sym___forceinline] = ACTIONS(2783),
    [anon_sym_thread_local] = ACTIONS(2783),
    [anon_sym___thread] = ACTIONS(2783),
    [anon_sym_const] = ACTIONS(2783),
    [anon_sym_constexpr] = ACTIONS(2783),
    [anon_sym_volatile] = ACTIONS(2783),
    [anon_sym_restrict] = ACTIONS(2783),
    [anon_sym___restrict__] = ACTIONS(2783),
    [anon_sym__Atomic] = ACTIONS(2783),
    [anon_sym__Noreturn] = ACTIONS(2783),
    [anon_sym_noreturn] = ACTIONS(2783),
    [anon_sym_mutable] = ACTIONS(2783),
    [anon_sym_constinit] = ACTIONS(2783),
    [anon_sym_consteval] = ACTIONS(2783),
    [anon_sym_PROGMEM] = ACTIONS(2783),
    [aux_sym_primitive_type_token1] = ACTIONS(2783),
    [anon_sym_byte] = ACTIONS(2783),
    [anon_sym_word] = ACTIONS(2783),
    [anon_sym_enum] = ACTIONS(2783),
    [anon_sym_class] = ACTIONS(2783),
    [anon_sym_struct] = ACTIONS(2783),
    [anon_sym_union] = ACTIONS(2783),
    [anon_sym_if] = ACTIONS(2783),
    [anon_sym_else] = ACTIONS(2783),
    [anon_sym_switch] = ACTIONS(2783),
    [anon_sym_while] = ACTIONS(2783),
    [anon_sym_do] = ACTIONS(2783),
    [anon_sym_for] = ACTIONS(2783),
    [anon_sym_return] = ACTIONS(2783),
    [anon_sym_break] = ACTIONS(2783),
    [anon_sym_continue] = ACTIONS(2783),
    [anon_sym_goto] = ACTIONS(2783),
    [anon_sym___try] = ACTIONS(2783),
    [anon_sym___leave] = ACTIONS(2783),
    [anon_sym_not] = ACTIONS(2783),
    [anon_sym_compl] = ACTIONS(2783),
    [anon_sym_DASH_DASH] = ACTIONS(2785),
    [anon_sym_PLUS_PLUS] = ACTIONS(2785),
    [anon_sym_sizeof] = ACTIONS(2783),
    [anon_sym___alignof__] = ACTIONS(2783),
    [anon_sym___alignof] = ACTIONS(2783),
    [anon_sym__alignof] = ACTIONS(2783),
    [anon_sym_alignof] = ACTIONS(2783),
    [anon_sym__Alignof] = ACTIONS(2783),
    [anon_sym_offsetof] = ACTIONS(2783),
    [anon_sym__Generic] = ACTIONS(2783),
    [anon_sym_asm] = ACTIONS(2783),
    [anon_sym___asm__] = ACTIONS(2783),
    [aux_sym_number_literal_token1] = ACTIONS(2785),
    [aux_sym_number_literal_token2] = ACTIONS(2783),
    [anon_sym_L_SQUOTE] = ACTIONS(2785),
    [anon_sym_u_SQUOTE] = ACTIONS(2785),
    [anon_sym_U_SQUOTE] = ACTIONS(2785),
    [anon_sym_u8_SQUOTE] = ACTIONS(2785),
    [anon_sym_SQUOTE] = ACTIONS(2785),
    [anon_sym_L_DQUOTE] = ACTIONS(2785),
    [anon_sym_u_DQUOTE] = ACTIONS(2785),
    [anon_sym_U_DQUOTE] = ACTIONS(2785),
    [anon_sym_u8_DQUOTE] = ACTIONS(2785),
    [anon_sym_DQUOTE] = ACTIONS(2785),
    [sym_true] = ACTIONS(2783),
    [sym_false] = ACTIONS(2783),
    [anon_sym_NULL] = ACTIONS(2783),
    [anon_sym_nullptr] = ACTIONS(2783),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2783),
    [anon_sym_decltype] = ACTIONS(2783),
    [anon_sym_virtual] = ACTIONS(2783),
    [anon_sym_alignas] = ACTIONS(2783),
    [anon_sym_typename] = ACTIONS(2783),
    [anon_sym_template] = ACTIONS(2783),
    [anon_sym_try] = ACTIONS(2783),
    [anon_sym_delete] = ACTIONS(2783),
    [anon_sym_throw] = ACTIONS(2783),
    [anon_sym_co_return] = ACTIONS(2783),
    [anon_sym_co_yield] = ACTIONS(2783),
    [anon_sym_R_DQUOTE] = ACTIONS(2785),
    [anon_sym_LR_DQUOTE] = ACTIONS(2785),
    [anon_sym_uR_DQUOTE] = ACTIONS(2785),
    [anon_sym_UR_DQUOTE] = ACTIONS(2785),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2785),
    [anon_sym_co_await] = ACTIONS(2783),
    [anon_sym_new] = ACTIONS(2783),
    [anon_sym_requires] = ACTIONS(2783),
    [sym_this] = ACTIONS(2783),
  },
  [1022] = {
    [sym_identifier] = ACTIONS(2643),
    [anon_sym_LPAREN2] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(2643),
    [anon_sym_STAR] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2645),
    [anon_sym_SEMI] = ACTIONS(2645),
    [anon_sym___extension__] = ACTIONS(2643),
    [anon_sym_typedef] = ACTIONS(2643),
    [anon_sym_extern] = ACTIONS(2643),
    [anon_sym___attribute__] = ACTIONS(2643),
    [anon_sym_COLON_COLON] = ACTIONS(2645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2645),
    [anon_sym___declspec] = ACTIONS(2643),
    [anon_sym_LBRACE] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2643),
    [anon_sym_unsigned] = ACTIONS(2643),
    [anon_sym_long] = ACTIONS(2643),
    [anon_sym_short] = ACTIONS(2643),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2643),
    [anon_sym_register] = ACTIONS(2643),
    [anon_sym_inline] = ACTIONS(2643),
    [anon_sym___inline] = ACTIONS(2643),
    [anon_sym___inline__] = ACTIONS(2643),
    [anon_sym___forceinline] = ACTIONS(2643),
    [anon_sym_thread_local] = ACTIONS(2643),
    [anon_sym___thread] = ACTIONS(2643),
    [anon_sym_const] = ACTIONS(2643),
    [anon_sym_constexpr] = ACTIONS(2643),
    [anon_sym_volatile] = ACTIONS(2643),
    [anon_sym_restrict] = ACTIONS(2643),
    [anon_sym___restrict__] = ACTIONS(2643),
    [anon_sym__Atomic] = ACTIONS(2643),
    [anon_sym__Noreturn] = ACTIONS(2643),
    [anon_sym_noreturn] = ACTIONS(2643),
    [anon_sym_mutable] = ACTIONS(2643),
    [anon_sym_constinit] = ACTIONS(2643),
    [anon_sym_consteval] = ACTIONS(2643),
    [anon_sym_PROGMEM] = ACTIONS(2643),
    [aux_sym_primitive_type_token1] = ACTIONS(2643),
    [anon_sym_byte] = ACTIONS(2643),
    [anon_sym_word] = ACTIONS(2643),
    [anon_sym_enum] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2643),
    [anon_sym_struct] = ACTIONS(2643),
    [anon_sym_union] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2643),
    [anon_sym_switch] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2643),
    [anon_sym_do] = ACTIONS(2643),
    [anon_sym_for] = ACTIONS(2643),
    [anon_sym_return] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2643),
    [anon_sym_continue] = ACTIONS(2643),
    [anon_sym_goto] = ACTIONS(2643),
    [anon_sym___try] = ACTIONS(2643),
    [anon_sym___leave] = ACTIONS(2643),
    [anon_sym_not] = ACTIONS(2643),
    [anon_sym_compl] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2645),
    [anon_sym_sizeof] = ACTIONS(2643),
    [anon_sym___alignof__] = ACTIONS(2643),
    [anon_sym___alignof] = ACTIONS(2643),
    [anon_sym__alignof] = ACTIONS(2643),
    [anon_sym_alignof] = ACTIONS(2643),
    [anon_sym__Alignof] = ACTIONS(2643),
    [anon_sym_offsetof] = ACTIONS(2643),
    [anon_sym__Generic] = ACTIONS(2643),
    [anon_sym_asm] = ACTIONS(2643),
    [anon_sym___asm__] = ACTIONS(2643),
    [aux_sym_number_literal_token1] = ACTIONS(2645),
    [aux_sym_number_literal_token2] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2645),
    [anon_sym_u_SQUOTE] = ACTIONS(2645),
    [anon_sym_U_SQUOTE] = ACTIONS(2645),
    [anon_sym_u8_SQUOTE] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(2645),
    [anon_sym_L_DQUOTE] = ACTIONS(2645),
    [anon_sym_u_DQUOTE] = ACTIONS(2645),
    [anon_sym_U_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8_DQUOTE] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(2645),
    [sym_true] = ACTIONS(2643),
    [sym_false] = ACTIONS(2643),
    [anon_sym_NULL] = ACTIONS(2643),
    [anon_sym_nullptr] = ACTIONS(2643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2643),
    [anon_sym_decltype] = ACTIONS(2643),
    [anon_sym_virtual] = ACTIONS(2643),
    [anon_sym_alignas] = ACTIONS(2643),
    [anon_sym_typename] = ACTIONS(2643),
    [anon_sym_template] = ACTIONS(2643),
    [anon_sym_try] = ACTIONS(2643),
    [anon_sym_delete] = ACTIONS(2643),
    [anon_sym_throw] = ACTIONS(2643),
    [anon_sym_co_return] = ACTIONS(2643),
    [anon_sym_co_yield] = ACTIONS(2643),
    [anon_sym_R_DQUOTE] = ACTIONS(2645),
    [anon_sym_LR_DQUOTE] = ACTIONS(2645),
    [anon_sym_uR_DQUOTE] = ACTIONS(2645),
    [anon_sym_UR_DQUOTE] = ACTIONS(2645),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2645),
    [anon_sym_co_await] = ACTIONS(2643),
    [anon_sym_new] = ACTIONS(2643),
    [anon_sym_requires] = ACTIONS(2643),
    [sym_this] = ACTIONS(2643),
  },
  [1023] = {
    [sym_identifier] = ACTIONS(2779),
    [anon_sym_LPAREN2] = ACTIONS(2781),
    [anon_sym_BANG] = ACTIONS(2781),
    [anon_sym_TILDE] = ACTIONS(2781),
    [anon_sym_DASH] = ACTIONS(2779),
    [anon_sym_PLUS] = ACTIONS(2779),
    [anon_sym_STAR] = ACTIONS(2781),
    [anon_sym_AMP] = ACTIONS(2781),
    [anon_sym_SEMI] = ACTIONS(2781),
    [anon_sym___extension__] = ACTIONS(2779),
    [anon_sym_typedef] = ACTIONS(2779),
    [anon_sym_extern] = ACTIONS(2779),
    [anon_sym___attribute__] = ACTIONS(2779),
    [anon_sym_COLON_COLON] = ACTIONS(2781),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2781),
    [anon_sym___declspec] = ACTIONS(2779),
    [anon_sym_LBRACE] = ACTIONS(2781),
    [anon_sym_signed] = ACTIONS(2779),
    [anon_sym_unsigned] = ACTIONS(2779),
    [anon_sym_long] = ACTIONS(2779),
    [anon_sym_short] = ACTIONS(2779),
    [anon_sym_LBRACK] = ACTIONS(2779),
    [anon_sym_static] = ACTIONS(2779),
    [anon_sym_register] = ACTIONS(2779),
    [anon_sym_inline] = ACTIONS(2779),
    [anon_sym___inline] = ACTIONS(2779),
    [anon_sym___inline__] = ACTIONS(2779),
    [anon_sym___forceinline] = ACTIONS(2779),
    [anon_sym_thread_local] = ACTIONS(2779),
    [anon_sym___thread] = ACTIONS(2779),
    [anon_sym_const] = ACTIONS(2779),
    [anon_sym_constexpr] = ACTIONS(2779),
    [anon_sym_volatile] = ACTIONS(2779),
    [anon_sym_restrict] = ACTIONS(2779),
    [anon_sym___restrict__] = ACTIONS(2779),
    [anon_sym__Atomic] = ACTIONS(2779),
    [anon_sym__Noreturn] = ACTIONS(2779),
    [anon_sym_noreturn] = ACTIONS(2779),
    [anon_sym_mutable] = ACTIONS(2779),
    [anon_sym_constinit] = ACTIONS(2779),
    [anon_sym_consteval] = ACTIONS(2779),
    [anon_sym_PROGMEM] = ACTIONS(2779),
    [aux_sym_primitive_type_token1] = ACTIONS(2779),
    [anon_sym_byte] = ACTIONS(2779),
    [anon_sym_word] = ACTIONS(2779),
    [anon_sym_enum] = ACTIONS(2779),
    [anon_sym_class] = ACTIONS(2779),
    [anon_sym_struct] = ACTIONS(2779),
    [anon_sym_union] = ACTIONS(2779),
    [anon_sym_if] = ACTIONS(2779),
    [anon_sym_else] = ACTIONS(2779),
    [anon_sym_switch] = ACTIONS(2779),
    [anon_sym_while] = ACTIONS(2779),
    [anon_sym_do] = ACTIONS(2779),
    [anon_sym_for] = ACTIONS(2779),
    [anon_sym_return] = ACTIONS(2779),
    [anon_sym_break] = ACTIONS(2779),
    [anon_sym_continue] = ACTIONS(2779),
    [anon_sym_goto] = ACTIONS(2779),
    [anon_sym___try] = ACTIONS(2779),
    [anon_sym___leave] = ACTIONS(2779),
    [anon_sym_not] = ACTIONS(2779),
    [anon_sym_compl] = ACTIONS(2779),
    [anon_sym_DASH_DASH] = ACTIONS(2781),
    [anon_sym_PLUS_PLUS] = ACTIONS(2781),
    [anon_sym_sizeof] = ACTIONS(2779),
    [anon_sym___alignof__] = ACTIONS(2779),
    [anon_sym___alignof] = ACTIONS(2779),
    [anon_sym__alignof] = ACTIONS(2779),
    [anon_sym_alignof] = ACTIONS(2779),
    [anon_sym__Alignof] = ACTIONS(2779),
    [anon_sym_offsetof] = ACTIONS(2779),
    [anon_sym__Generic] = ACTIONS(2779),
    [anon_sym_asm] = ACTIONS(2779),
    [anon_sym___asm__] = ACTIONS(2779),
    [aux_sym_number_literal_token1] = ACTIONS(2781),
    [aux_sym_number_literal_token2] = ACTIONS(2779),
    [anon_sym_L_SQUOTE] = ACTIONS(2781),
    [anon_sym_u_SQUOTE] = ACTIONS(2781),
    [anon_sym_U_SQUOTE] = ACTIONS(2781),
    [anon_sym_u8_SQUOTE] = ACTIONS(2781),
    [anon_sym_SQUOTE] = ACTIONS(2781),
    [anon_sym_L_DQUOTE] = ACTIONS(2781),
    [anon_sym_u_DQUOTE] = ACTIONS(2781),
    [anon_sym_U_DQUOTE] = ACTIONS(2781),
    [anon_sym_u8_DQUOTE] = ACTIONS(2781),
    [anon_sym_DQUOTE] = ACTIONS(2781),
    [sym_true] = ACTIONS(2779),
    [sym_false] = ACTIONS(2779),
    [anon_sym_NULL] = ACTIONS(2779),
    [anon_sym_nullptr] = ACTIONS(2779),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2779),
    [anon_sym_decltype] = ACTIONS(2779),
    [anon_sym_virtual] = ACTIONS(2779),
    [anon_sym_alignas] = ACTIONS(2779),
    [anon_sym_typename] = ACTIONS(2779),
    [anon_sym_template] = ACTIONS(2779),
    [anon_sym_try] = ACTIONS(2779),
    [anon_sym_delete] = ACTIONS(2779),
    [anon_sym_throw] = ACTIONS(2779),
    [anon_sym_co_return] = ACTIONS(2779),
    [anon_sym_co_yield] = ACTIONS(2779),
    [anon_sym_R_DQUOTE] = ACTIONS(2781),
    [anon_sym_LR_DQUOTE] = ACTIONS(2781),
    [anon_sym_uR_DQUOTE] = ACTIONS(2781),
    [anon_sym_UR_DQUOTE] = ACTIONS(2781),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2781),
    [anon_sym_co_await] = ACTIONS(2779),
    [anon_sym_new] = ACTIONS(2779),
    [anon_sym_requires] = ACTIONS(2779),
    [sym_this] = ACTIONS(2779),
  },
  [1024] = {
    [sym_identifier] = ACTIONS(2755),
    [anon_sym_LPAREN2] = ACTIONS(2757),
    [anon_sym_BANG] = ACTIONS(2757),
    [anon_sym_TILDE] = ACTIONS(2757),
    [anon_sym_DASH] = ACTIONS(2755),
    [anon_sym_PLUS] = ACTIONS(2755),
    [anon_sym_STAR] = ACTIONS(2757),
    [anon_sym_AMP] = ACTIONS(2757),
    [anon_sym_SEMI] = ACTIONS(2757),
    [anon_sym___extension__] = ACTIONS(2755),
    [anon_sym_typedef] = ACTIONS(2755),
    [anon_sym_extern] = ACTIONS(2755),
    [anon_sym___attribute__] = ACTIONS(2755),
    [anon_sym_COLON_COLON] = ACTIONS(2757),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2757),
    [anon_sym___declspec] = ACTIONS(2755),
    [anon_sym_LBRACE] = ACTIONS(2757),
    [anon_sym_signed] = ACTIONS(2755),
    [anon_sym_unsigned] = ACTIONS(2755),
    [anon_sym_long] = ACTIONS(2755),
    [anon_sym_short] = ACTIONS(2755),
    [anon_sym_LBRACK] = ACTIONS(2755),
    [anon_sym_static] = ACTIONS(2755),
    [anon_sym_register] = ACTIONS(2755),
    [anon_sym_inline] = ACTIONS(2755),
    [anon_sym___inline] = ACTIONS(2755),
    [anon_sym___inline__] = ACTIONS(2755),
    [anon_sym___forceinline] = ACTIONS(2755),
    [anon_sym_thread_local] = ACTIONS(2755),
    [anon_sym___thread] = ACTIONS(2755),
    [anon_sym_const] = ACTIONS(2755),
    [anon_sym_constexpr] = ACTIONS(2755),
    [anon_sym_volatile] = ACTIONS(2755),
    [anon_sym_restrict] = ACTIONS(2755),
    [anon_sym___restrict__] = ACTIONS(2755),
    [anon_sym__Atomic] = ACTIONS(2755),
    [anon_sym__Noreturn] = ACTIONS(2755),
    [anon_sym_noreturn] = ACTIONS(2755),
    [anon_sym_mutable] = ACTIONS(2755),
    [anon_sym_constinit] = ACTIONS(2755),
    [anon_sym_consteval] = ACTIONS(2755),
    [anon_sym_PROGMEM] = ACTIONS(2755),
    [aux_sym_primitive_type_token1] = ACTIONS(2755),
    [anon_sym_byte] = ACTIONS(2755),
    [anon_sym_word] = ACTIONS(2755),
    [anon_sym_enum] = ACTIONS(2755),
    [anon_sym_class] = ACTIONS(2755),
    [anon_sym_struct] = ACTIONS(2755),
    [anon_sym_union] = ACTIONS(2755),
    [anon_sym_if] = ACTIONS(2755),
    [anon_sym_else] = ACTIONS(2755),
    [anon_sym_switch] = ACTIONS(2755),
    [anon_sym_while] = ACTIONS(2755),
    [anon_sym_do] = ACTIONS(2755),
    [anon_sym_for] = ACTIONS(2755),
    [anon_sym_return] = ACTIONS(2755),
    [anon_sym_break] = ACTIONS(2755),
    [anon_sym_continue] = ACTIONS(2755),
    [anon_sym_goto] = ACTIONS(2755),
    [anon_sym___try] = ACTIONS(2755),
    [anon_sym___leave] = ACTIONS(2755),
    [anon_sym_not] = ACTIONS(2755),
    [anon_sym_compl] = ACTIONS(2755),
    [anon_sym_DASH_DASH] = ACTIONS(2757),
    [anon_sym_PLUS_PLUS] = ACTIONS(2757),
    [anon_sym_sizeof] = ACTIONS(2755),
    [anon_sym___alignof__] = ACTIONS(2755),
    [anon_sym___alignof] = ACTIONS(2755),
    [anon_sym__alignof] = ACTIONS(2755),
    [anon_sym_alignof] = ACTIONS(2755),
    [anon_sym__Alignof] = ACTIONS(2755),
    [anon_sym_offsetof] = ACTIONS(2755),
    [anon_sym__Generic] = ACTIONS(2755),
    [anon_sym_asm] = ACTIONS(2755),
    [anon_sym___asm__] = ACTIONS(2755),
    [aux_sym_number_literal_token1] = ACTIONS(2757),
    [aux_sym_number_literal_token2] = ACTIONS(2755),
    [anon_sym_L_SQUOTE] = ACTIONS(2757),
    [anon_sym_u_SQUOTE] = ACTIONS(2757),
    [anon_sym_U_SQUOTE] = ACTIONS(2757),
    [anon_sym_u8_SQUOTE] = ACTIONS(2757),
    [anon_sym_SQUOTE] = ACTIONS(2757),
    [anon_sym_L_DQUOTE] = ACTIONS(2757),
    [anon_sym_u_DQUOTE] = ACTIONS(2757),
    [anon_sym_U_DQUOTE] = ACTIONS(2757),
    [anon_sym_u8_DQUOTE] = ACTIONS(2757),
    [anon_sym_DQUOTE] = ACTIONS(2757),
    [sym_true] = ACTIONS(2755),
    [sym_false] = ACTIONS(2755),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2755),
    [anon_sym_decltype] = ACTIONS(2755),
    [anon_sym_virtual] = ACTIONS(2755),
    [anon_sym_alignas] = ACTIONS(2755),
    [anon_sym_typename] = ACTIONS(2755),
    [anon_sym_template] = ACTIONS(2755),
    [anon_sym_try] = ACTIONS(2755),
    [anon_sym_delete] = ACTIONS(2755),
    [anon_sym_throw] = ACTIONS(2755),
    [anon_sym_co_return] = ACTIONS(2755),
    [anon_sym_co_yield] = ACTIONS(2755),
    [anon_sym_R_DQUOTE] = ACTIONS(2757),
    [anon_sym_LR_DQUOTE] = ACTIONS(2757),
    [anon_sym_uR_DQUOTE] = ACTIONS(2757),
    [anon_sym_UR_DQUOTE] = ACTIONS(2757),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2757),
    [anon_sym_co_await] = ACTIONS(2755),
    [anon_sym_new] = ACTIONS(2755),
    [anon_sym_requires] = ACTIONS(2755),
    [sym_this] = ACTIONS(2755),
  },
  [1025] = {
    [sym_identifier] = ACTIONS(2751),
    [anon_sym_LPAREN2] = ACTIONS(2753),
    [anon_sym_BANG] = ACTIONS(2753),
    [anon_sym_TILDE] = ACTIONS(2753),
    [anon_sym_DASH] = ACTIONS(2751),
    [anon_sym_PLUS] = ACTIONS(2751),
    [anon_sym_STAR] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2753),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym___extension__] = ACTIONS(2751),
    [anon_sym_typedef] = ACTIONS(2751),
    [anon_sym_extern] = ACTIONS(2751),
    [anon_sym___attribute__] = ACTIONS(2751),
    [anon_sym_COLON_COLON] = ACTIONS(2753),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2753),
    [anon_sym___declspec] = ACTIONS(2751),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_signed] = ACTIONS(2751),
    [anon_sym_unsigned] = ACTIONS(2751),
    [anon_sym_long] = ACTIONS(2751),
    [anon_sym_short] = ACTIONS(2751),
    [anon_sym_LBRACK] = ACTIONS(2751),
    [anon_sym_static] = ACTIONS(2751),
    [anon_sym_register] = ACTIONS(2751),
    [anon_sym_inline] = ACTIONS(2751),
    [anon_sym___inline] = ACTIONS(2751),
    [anon_sym___inline__] = ACTIONS(2751),
    [anon_sym___forceinline] = ACTIONS(2751),
    [anon_sym_thread_local] = ACTIONS(2751),
    [anon_sym___thread] = ACTIONS(2751),
    [anon_sym_const] = ACTIONS(2751),
    [anon_sym_constexpr] = ACTIONS(2751),
    [anon_sym_volatile] = ACTIONS(2751),
    [anon_sym_restrict] = ACTIONS(2751),
    [anon_sym___restrict__] = ACTIONS(2751),
    [anon_sym__Atomic] = ACTIONS(2751),
    [anon_sym__Noreturn] = ACTIONS(2751),
    [anon_sym_noreturn] = ACTIONS(2751),
    [anon_sym_mutable] = ACTIONS(2751),
    [anon_sym_constinit] = ACTIONS(2751),
    [anon_sym_consteval] = ACTIONS(2751),
    [anon_sym_PROGMEM] = ACTIONS(2751),
    [aux_sym_primitive_type_token1] = ACTIONS(2751),
    [anon_sym_byte] = ACTIONS(2751),
    [anon_sym_word] = ACTIONS(2751),
    [anon_sym_enum] = ACTIONS(2751),
    [anon_sym_class] = ACTIONS(2751),
    [anon_sym_struct] = ACTIONS(2751),
    [anon_sym_union] = ACTIONS(2751),
    [anon_sym_if] = ACTIONS(2751),
    [anon_sym_else] = ACTIONS(2751),
    [anon_sym_switch] = ACTIONS(2751),
    [anon_sym_while] = ACTIONS(2751),
    [anon_sym_do] = ACTIONS(2751),
    [anon_sym_for] = ACTIONS(2751),
    [anon_sym_return] = ACTIONS(2751),
    [anon_sym_break] = ACTIONS(2751),
    [anon_sym_continue] = ACTIONS(2751),
    [anon_sym_goto] = ACTIONS(2751),
    [anon_sym___try] = ACTIONS(2751),
    [anon_sym___leave] = ACTIONS(2751),
    [anon_sym_not] = ACTIONS(2751),
    [anon_sym_compl] = ACTIONS(2751),
    [anon_sym_DASH_DASH] = ACTIONS(2753),
    [anon_sym_PLUS_PLUS] = ACTIONS(2753),
    [anon_sym_sizeof] = ACTIONS(2751),
    [anon_sym___alignof__] = ACTIONS(2751),
    [anon_sym___alignof] = ACTIONS(2751),
    [anon_sym__alignof] = ACTIONS(2751),
    [anon_sym_alignof] = ACTIONS(2751),
    [anon_sym__Alignof] = ACTIONS(2751),
    [anon_sym_offsetof] = ACTIONS(2751),
    [anon_sym__Generic] = ACTIONS(2751),
    [anon_sym_asm] = ACTIONS(2751),
    [anon_sym___asm__] = ACTIONS(2751),
    [aux_sym_number_literal_token1] = ACTIONS(2753),
    [aux_sym_number_literal_token2] = ACTIONS(2751),
    [anon_sym_L_SQUOTE] = ACTIONS(2753),
    [anon_sym_u_SQUOTE] = ACTIONS(2753),
    [anon_sym_U_SQUOTE] = ACTIONS(2753),
    [anon_sym_u8_SQUOTE] = ACTIONS(2753),
    [anon_sym_SQUOTE] = ACTIONS(2753),
    [anon_sym_L_DQUOTE] = ACTIONS(2753),
    [anon_sym_u_DQUOTE] = ACTIONS(2753),
    [anon_sym_U_DQUOTE] = ACTIONS(2753),
    [anon_sym_u8_DQUOTE] = ACTIONS(2753),
    [anon_sym_DQUOTE] = ACTIONS(2753),
    [sym_true] = ACTIONS(2751),
    [sym_false] = ACTIONS(2751),
    [anon_sym_NULL] = ACTIONS(2751),
    [anon_sym_nullptr] = ACTIONS(2751),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2751),
    [anon_sym_decltype] = ACTIONS(2751),
    [anon_sym_virtual] = ACTIONS(2751),
    [anon_sym_alignas] = ACTIONS(2751),
    [anon_sym_typename] = ACTIONS(2751),
    [anon_sym_template] = ACTIONS(2751),
    [anon_sym_try] = ACTIONS(2751),
    [anon_sym_delete] = ACTIONS(2751),
    [anon_sym_throw] = ACTIONS(2751),
    [anon_sym_co_return] = ACTIONS(2751),
    [anon_sym_co_yield] = ACTIONS(2751),
    [anon_sym_R_DQUOTE] = ACTIONS(2753),
    [anon_sym_LR_DQUOTE] = ACTIONS(2753),
    [anon_sym_uR_DQUOTE] = ACTIONS(2753),
    [anon_sym_UR_DQUOTE] = ACTIONS(2753),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2753),
    [anon_sym_co_await] = ACTIONS(2751),
    [anon_sym_new] = ACTIONS(2751),
    [anon_sym_requires] = ACTIONS(2751),
    [sym_this] = ACTIONS(2751),
  },
  [1026] = {
    [sym_identifier] = ACTIONS(2717),
    [anon_sym_LPAREN2] = ACTIONS(2719),
    [anon_sym_BANG] = ACTIONS(2719),
    [anon_sym_TILDE] = ACTIONS(2719),
    [anon_sym_DASH] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym_SEMI] = ACTIONS(2719),
    [anon_sym___extension__] = ACTIONS(2717),
    [anon_sym_typedef] = ACTIONS(2717),
    [anon_sym_extern] = ACTIONS(2717),
    [anon_sym___attribute__] = ACTIONS(2717),
    [anon_sym_COLON_COLON] = ACTIONS(2719),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2719),
    [anon_sym___declspec] = ACTIONS(2717),
    [anon_sym_LBRACE] = ACTIONS(2719),
    [anon_sym_signed] = ACTIONS(2717),
    [anon_sym_unsigned] = ACTIONS(2717),
    [anon_sym_long] = ACTIONS(2717),
    [anon_sym_short] = ACTIONS(2717),
    [anon_sym_LBRACK] = ACTIONS(2717),
    [anon_sym_static] = ACTIONS(2717),
    [anon_sym_register] = ACTIONS(2717),
    [anon_sym_inline] = ACTIONS(2717),
    [anon_sym___inline] = ACTIONS(2717),
    [anon_sym___inline__] = ACTIONS(2717),
    [anon_sym___forceinline] = ACTIONS(2717),
    [anon_sym_thread_local] = ACTIONS(2717),
    [anon_sym___thread] = ACTIONS(2717),
    [anon_sym_const] = ACTIONS(2717),
    [anon_sym_constexpr] = ACTIONS(2717),
    [anon_sym_volatile] = ACTIONS(2717),
    [anon_sym_restrict] = ACTIONS(2717),
    [anon_sym___restrict__] = ACTIONS(2717),
    [anon_sym__Atomic] = ACTIONS(2717),
    [anon_sym__Noreturn] = ACTIONS(2717),
    [anon_sym_noreturn] = ACTIONS(2717),
    [anon_sym_mutable] = ACTIONS(2717),
    [anon_sym_constinit] = ACTIONS(2717),
    [anon_sym_consteval] = ACTIONS(2717),
    [anon_sym_PROGMEM] = ACTIONS(2717),
    [aux_sym_primitive_type_token1] = ACTIONS(2717),
    [anon_sym_byte] = ACTIONS(2717),
    [anon_sym_word] = ACTIONS(2717),
    [anon_sym_enum] = ACTIONS(2717),
    [anon_sym_class] = ACTIONS(2717),
    [anon_sym_struct] = ACTIONS(2717),
    [anon_sym_union] = ACTIONS(2717),
    [anon_sym_if] = ACTIONS(2717),
    [anon_sym_else] = ACTIONS(2717),
    [anon_sym_switch] = ACTIONS(2717),
    [anon_sym_while] = ACTIONS(2717),
    [anon_sym_do] = ACTIONS(2717),
    [anon_sym_for] = ACTIONS(2717),
    [anon_sym_return] = ACTIONS(2717),
    [anon_sym_break] = ACTIONS(2717),
    [anon_sym_continue] = ACTIONS(2717),
    [anon_sym_goto] = ACTIONS(2717),
    [anon_sym___try] = ACTIONS(2717),
    [anon_sym___leave] = ACTIONS(2717),
    [anon_sym_not] = ACTIONS(2717),
    [anon_sym_compl] = ACTIONS(2717),
    [anon_sym_DASH_DASH] = ACTIONS(2719),
    [anon_sym_PLUS_PLUS] = ACTIONS(2719),
    [anon_sym_sizeof] = ACTIONS(2717),
    [anon_sym___alignof__] = ACTIONS(2717),
    [anon_sym___alignof] = ACTIONS(2717),
    [anon_sym__alignof] = ACTIONS(2717),
    [anon_sym_alignof] = ACTIONS(2717),
    [anon_sym__Alignof] = ACTIONS(2717),
    [anon_sym_offsetof] = ACTIONS(2717),
    [anon_sym__Generic] = ACTIONS(2717),
    [anon_sym_asm] = ACTIONS(2717),
    [anon_sym___asm__] = ACTIONS(2717),
    [aux_sym_number_literal_token1] = ACTIONS(2719),
    [aux_sym_number_literal_token2] = ACTIONS(2717),
    [anon_sym_L_SQUOTE] = ACTIONS(2719),
    [anon_sym_u_SQUOTE] = ACTIONS(2719),
    [anon_sym_U_SQUOTE] = ACTIONS(2719),
    [anon_sym_u8_SQUOTE] = ACTIONS(2719),
    [anon_sym_SQUOTE] = ACTIONS(2719),
    [anon_sym_L_DQUOTE] = ACTIONS(2719),
    [anon_sym_u_DQUOTE] = ACTIONS(2719),
    [anon_sym_U_DQUOTE] = ACTIONS(2719),
    [anon_sym_u8_DQUOTE] = ACTIONS(2719),
    [anon_sym_DQUOTE] = ACTIONS(2719),
    [sym_true] = ACTIONS(2717),
    [sym_false] = ACTIONS(2717),
    [anon_sym_NULL] = ACTIONS(2717),
    [anon_sym_nullptr] = ACTIONS(2717),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2717),
    [anon_sym_decltype] = ACTIONS(2717),
    [anon_sym_virtual] = ACTIONS(2717),
    [anon_sym_alignas] = ACTIONS(2717),
    [anon_sym_typename] = ACTIONS(2717),
    [anon_sym_template] = ACTIONS(2717),
    [anon_sym_try] = ACTIONS(2717),
    [anon_sym_delete] = ACTIONS(2717),
    [anon_sym_throw] = ACTIONS(2717),
    [anon_sym_co_return] = ACTIONS(2717),
    [anon_sym_co_yield] = ACTIONS(2717),
    [anon_sym_R_DQUOTE] = ACTIONS(2719),
    [anon_sym_LR_DQUOTE] = ACTIONS(2719),
    [anon_sym_uR_DQUOTE] = ACTIONS(2719),
    [anon_sym_UR_DQUOTE] = ACTIONS(2719),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2719),
    [anon_sym_co_await] = ACTIONS(2717),
    [anon_sym_new] = ACTIONS(2717),
    [anon_sym_requires] = ACTIONS(2717),
    [sym_this] = ACTIONS(2717),
  },
  [1027] = {
    [sym_identifier] = ACTIONS(2713),
    [anon_sym_LPAREN2] = ACTIONS(2715),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_DASH] = ACTIONS(2713),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_STAR] = ACTIONS(2715),
    [anon_sym_AMP] = ACTIONS(2715),
    [anon_sym_SEMI] = ACTIONS(2715),
    [anon_sym___extension__] = ACTIONS(2713),
    [anon_sym_typedef] = ACTIONS(2713),
    [anon_sym_extern] = ACTIONS(2713),
    [anon_sym___attribute__] = ACTIONS(2713),
    [anon_sym_COLON_COLON] = ACTIONS(2715),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2715),
    [anon_sym___declspec] = ACTIONS(2713),
    [anon_sym_LBRACE] = ACTIONS(2715),
    [anon_sym_signed] = ACTIONS(2713),
    [anon_sym_unsigned] = ACTIONS(2713),
    [anon_sym_long] = ACTIONS(2713),
    [anon_sym_short] = ACTIONS(2713),
    [anon_sym_LBRACK] = ACTIONS(2713),
    [anon_sym_static] = ACTIONS(2713),
    [anon_sym_register] = ACTIONS(2713),
    [anon_sym_inline] = ACTIONS(2713),
    [anon_sym___inline] = ACTIONS(2713),
    [anon_sym___inline__] = ACTIONS(2713),
    [anon_sym___forceinline] = ACTIONS(2713),
    [anon_sym_thread_local] = ACTIONS(2713),
    [anon_sym___thread] = ACTIONS(2713),
    [anon_sym_const] = ACTIONS(2713),
    [anon_sym_constexpr] = ACTIONS(2713),
    [anon_sym_volatile] = ACTIONS(2713),
    [anon_sym_restrict] = ACTIONS(2713),
    [anon_sym___restrict__] = ACTIONS(2713),
    [anon_sym__Atomic] = ACTIONS(2713),
    [anon_sym__Noreturn] = ACTIONS(2713),
    [anon_sym_noreturn] = ACTIONS(2713),
    [anon_sym_mutable] = ACTIONS(2713),
    [anon_sym_constinit] = ACTIONS(2713),
    [anon_sym_consteval] = ACTIONS(2713),
    [anon_sym_PROGMEM] = ACTIONS(2713),
    [aux_sym_primitive_type_token1] = ACTIONS(2713),
    [anon_sym_byte] = ACTIONS(2713),
    [anon_sym_word] = ACTIONS(2713),
    [anon_sym_enum] = ACTIONS(2713),
    [anon_sym_class] = ACTIONS(2713),
    [anon_sym_struct] = ACTIONS(2713),
    [anon_sym_union] = ACTIONS(2713),
    [anon_sym_if] = ACTIONS(2713),
    [anon_sym_else] = ACTIONS(2713),
    [anon_sym_switch] = ACTIONS(2713),
    [anon_sym_while] = ACTIONS(2713),
    [anon_sym_do] = ACTIONS(2713),
    [anon_sym_for] = ACTIONS(2713),
    [anon_sym_return] = ACTIONS(2713),
    [anon_sym_break] = ACTIONS(2713),
    [anon_sym_continue] = ACTIONS(2713),
    [anon_sym_goto] = ACTIONS(2713),
    [anon_sym___try] = ACTIONS(2713),
    [anon_sym___leave] = ACTIONS(2713),
    [anon_sym_not] = ACTIONS(2713),
    [anon_sym_compl] = ACTIONS(2713),
    [anon_sym_DASH_DASH] = ACTIONS(2715),
    [anon_sym_PLUS_PLUS] = ACTIONS(2715),
    [anon_sym_sizeof] = ACTIONS(2713),
    [anon_sym___alignof__] = ACTIONS(2713),
    [anon_sym___alignof] = ACTIONS(2713),
    [anon_sym__alignof] = ACTIONS(2713),
    [anon_sym_alignof] = ACTIONS(2713),
    [anon_sym__Alignof] = ACTIONS(2713),
    [anon_sym_offsetof] = ACTIONS(2713),
    [anon_sym__Generic] = ACTIONS(2713),
    [anon_sym_asm] = ACTIONS(2713),
    [anon_sym___asm__] = ACTIONS(2713),
    [aux_sym_number_literal_token1] = ACTIONS(2715),
    [aux_sym_number_literal_token2] = ACTIONS(2713),
    [anon_sym_L_SQUOTE] = ACTIONS(2715),
    [anon_sym_u_SQUOTE] = ACTIONS(2715),
    [anon_sym_U_SQUOTE] = ACTIONS(2715),
    [anon_sym_u8_SQUOTE] = ACTIONS(2715),
    [anon_sym_SQUOTE] = ACTIONS(2715),
    [anon_sym_L_DQUOTE] = ACTIONS(2715),
    [anon_sym_u_DQUOTE] = ACTIONS(2715),
    [anon_sym_U_DQUOTE] = ACTIONS(2715),
    [anon_sym_u8_DQUOTE] = ACTIONS(2715),
    [anon_sym_DQUOTE] = ACTIONS(2715),
    [sym_true] = ACTIONS(2713),
    [sym_false] = ACTIONS(2713),
    [anon_sym_NULL] = ACTIONS(2713),
    [anon_sym_nullptr] = ACTIONS(2713),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2713),
    [anon_sym_decltype] = ACTIONS(2713),
    [anon_sym_virtual] = ACTIONS(2713),
    [anon_sym_alignas] = ACTIONS(2713),
    [anon_sym_typename] = ACTIONS(2713),
    [anon_sym_template] = ACTIONS(2713),
    [anon_sym_try] = ACTIONS(2713),
    [anon_sym_delete] = ACTIONS(2713),
    [anon_sym_throw] = ACTIONS(2713),
    [anon_sym_co_return] = ACTIONS(2713),
    [anon_sym_co_yield] = ACTIONS(2713),
    [anon_sym_R_DQUOTE] = ACTIONS(2715),
    [anon_sym_LR_DQUOTE] = ACTIONS(2715),
    [anon_sym_uR_DQUOTE] = ACTIONS(2715),
    [anon_sym_UR_DQUOTE] = ACTIONS(2715),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2715),
    [anon_sym_co_await] = ACTIONS(2713),
    [anon_sym_new] = ACTIONS(2713),
    [anon_sym_requires] = ACTIONS(2713),
    [sym_this] = ACTIONS(2713),
  },
  [1028] = {
    [sym_identifier] = ACTIONS(2709),
    [anon_sym_LPAREN2] = ACTIONS(2711),
    [anon_sym_BANG] = ACTIONS(2711),
    [anon_sym_TILDE] = ACTIONS(2711),
    [anon_sym_DASH] = ACTIONS(2709),
    [anon_sym_PLUS] = ACTIONS(2709),
    [anon_sym_STAR] = ACTIONS(2711),
    [anon_sym_AMP] = ACTIONS(2711),
    [anon_sym_SEMI] = ACTIONS(2711),
    [anon_sym___extension__] = ACTIONS(2709),
    [anon_sym_typedef] = ACTIONS(2709),
    [anon_sym_extern] = ACTIONS(2709),
    [anon_sym___attribute__] = ACTIONS(2709),
    [anon_sym_COLON_COLON] = ACTIONS(2711),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2711),
    [anon_sym___declspec] = ACTIONS(2709),
    [anon_sym_LBRACE] = ACTIONS(2711),
    [anon_sym_signed] = ACTIONS(2709),
    [anon_sym_unsigned] = ACTIONS(2709),
    [anon_sym_long] = ACTIONS(2709),
    [anon_sym_short] = ACTIONS(2709),
    [anon_sym_LBRACK] = ACTIONS(2709),
    [anon_sym_static] = ACTIONS(2709),
    [anon_sym_register] = ACTIONS(2709),
    [anon_sym_inline] = ACTIONS(2709),
    [anon_sym___inline] = ACTIONS(2709),
    [anon_sym___inline__] = ACTIONS(2709),
    [anon_sym___forceinline] = ACTIONS(2709),
    [anon_sym_thread_local] = ACTIONS(2709),
    [anon_sym___thread] = ACTIONS(2709),
    [anon_sym_const] = ACTIONS(2709),
    [anon_sym_constexpr] = ACTIONS(2709),
    [anon_sym_volatile] = ACTIONS(2709),
    [anon_sym_restrict] = ACTIONS(2709),
    [anon_sym___restrict__] = ACTIONS(2709),
    [anon_sym__Atomic] = ACTIONS(2709),
    [anon_sym__Noreturn] = ACTIONS(2709),
    [anon_sym_noreturn] = ACTIONS(2709),
    [anon_sym_mutable] = ACTIONS(2709),
    [anon_sym_constinit] = ACTIONS(2709),
    [anon_sym_consteval] = ACTIONS(2709),
    [anon_sym_PROGMEM] = ACTIONS(2709),
    [aux_sym_primitive_type_token1] = ACTIONS(2709),
    [anon_sym_byte] = ACTIONS(2709),
    [anon_sym_word] = ACTIONS(2709),
    [anon_sym_enum] = ACTIONS(2709),
    [anon_sym_class] = ACTIONS(2709),
    [anon_sym_struct] = ACTIONS(2709),
    [anon_sym_union] = ACTIONS(2709),
    [anon_sym_if] = ACTIONS(2709),
    [anon_sym_else] = ACTIONS(2709),
    [anon_sym_switch] = ACTIONS(2709),
    [anon_sym_while] = ACTIONS(2709),
    [anon_sym_do] = ACTIONS(2709),
    [anon_sym_for] = ACTIONS(2709),
    [anon_sym_return] = ACTIONS(2709),
    [anon_sym_break] = ACTIONS(2709),
    [anon_sym_continue] = ACTIONS(2709),
    [anon_sym_goto] = ACTIONS(2709),
    [anon_sym___try] = ACTIONS(2709),
    [anon_sym___leave] = ACTIONS(2709),
    [anon_sym_not] = ACTIONS(2709),
    [anon_sym_compl] = ACTIONS(2709),
    [anon_sym_DASH_DASH] = ACTIONS(2711),
    [anon_sym_PLUS_PLUS] = ACTIONS(2711),
    [anon_sym_sizeof] = ACTIONS(2709),
    [anon_sym___alignof__] = ACTIONS(2709),
    [anon_sym___alignof] = ACTIONS(2709),
    [anon_sym__alignof] = ACTIONS(2709),
    [anon_sym_alignof] = ACTIONS(2709),
    [anon_sym__Alignof] = ACTIONS(2709),
    [anon_sym_offsetof] = ACTIONS(2709),
    [anon_sym__Generic] = ACTIONS(2709),
    [anon_sym_asm] = ACTIONS(2709),
    [anon_sym___asm__] = ACTIONS(2709),
    [aux_sym_number_literal_token1] = ACTIONS(2711),
    [aux_sym_number_literal_token2] = ACTIONS(2709),
    [anon_sym_L_SQUOTE] = ACTIONS(2711),
    [anon_sym_u_SQUOTE] = ACTIONS(2711),
    [anon_sym_U_SQUOTE] = ACTIONS(2711),
    [anon_sym_u8_SQUOTE] = ACTIONS(2711),
    [anon_sym_SQUOTE] = ACTIONS(2711),
    [anon_sym_L_DQUOTE] = ACTIONS(2711),
    [anon_sym_u_DQUOTE] = ACTIONS(2711),
    [anon_sym_U_DQUOTE] = ACTIONS(2711),
    [anon_sym_u8_DQUOTE] = ACTIONS(2711),
    [anon_sym_DQUOTE] = ACTIONS(2711),
    [sym_true] = ACTIONS(2709),
    [sym_false] = ACTIONS(2709),
    [anon_sym_NULL] = ACTIONS(2709),
    [anon_sym_nullptr] = ACTIONS(2709),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2709),
    [anon_sym_decltype] = ACTIONS(2709),
    [anon_sym_virtual] = ACTIONS(2709),
    [anon_sym_alignas] = ACTIONS(2709),
    [anon_sym_typename] = ACTIONS(2709),
    [anon_sym_template] = ACTIONS(2709),
    [anon_sym_try] = ACTIONS(2709),
    [anon_sym_delete] = ACTIONS(2709),
    [anon_sym_throw] = ACTIONS(2709),
    [anon_sym_co_return] = ACTIONS(2709),
    [anon_sym_co_yield] = ACTIONS(2709),
    [anon_sym_R_DQUOTE] = ACTIONS(2711),
    [anon_sym_LR_DQUOTE] = ACTIONS(2711),
    [anon_sym_uR_DQUOTE] = ACTIONS(2711),
    [anon_sym_UR_DQUOTE] = ACTIONS(2711),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2711),
    [anon_sym_co_await] = ACTIONS(2709),
    [anon_sym_new] = ACTIONS(2709),
    [anon_sym_requires] = ACTIONS(2709),
    [sym_this] = ACTIONS(2709),
  },
  [1029] = {
    [sym_identifier] = ACTIONS(2705),
    [anon_sym_LPAREN2] = ACTIONS(2707),
    [anon_sym_BANG] = ACTIONS(2707),
    [anon_sym_TILDE] = ACTIONS(2707),
    [anon_sym_DASH] = ACTIONS(2705),
    [anon_sym_PLUS] = ACTIONS(2705),
    [anon_sym_STAR] = ACTIONS(2707),
    [anon_sym_AMP] = ACTIONS(2707),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym___extension__] = ACTIONS(2705),
    [anon_sym_typedef] = ACTIONS(2705),
    [anon_sym_extern] = ACTIONS(2705),
    [anon_sym___attribute__] = ACTIONS(2705),
    [anon_sym_COLON_COLON] = ACTIONS(2707),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2707),
    [anon_sym___declspec] = ACTIONS(2705),
    [anon_sym_LBRACE] = ACTIONS(2707),
    [anon_sym_signed] = ACTIONS(2705),
    [anon_sym_unsigned] = ACTIONS(2705),
    [anon_sym_long] = ACTIONS(2705),
    [anon_sym_short] = ACTIONS(2705),
    [anon_sym_LBRACK] = ACTIONS(2705),
    [anon_sym_static] = ACTIONS(2705),
    [anon_sym_register] = ACTIONS(2705),
    [anon_sym_inline] = ACTIONS(2705),
    [anon_sym___inline] = ACTIONS(2705),
    [anon_sym___inline__] = ACTIONS(2705),
    [anon_sym___forceinline] = ACTIONS(2705),
    [anon_sym_thread_local] = ACTIONS(2705),
    [anon_sym___thread] = ACTIONS(2705),
    [anon_sym_const] = ACTIONS(2705),
    [anon_sym_constexpr] = ACTIONS(2705),
    [anon_sym_volatile] = ACTIONS(2705),
    [anon_sym_restrict] = ACTIONS(2705),
    [anon_sym___restrict__] = ACTIONS(2705),
    [anon_sym__Atomic] = ACTIONS(2705),
    [anon_sym__Noreturn] = ACTIONS(2705),
    [anon_sym_noreturn] = ACTIONS(2705),
    [anon_sym_mutable] = ACTIONS(2705),
    [anon_sym_constinit] = ACTIONS(2705),
    [anon_sym_consteval] = ACTIONS(2705),
    [anon_sym_PROGMEM] = ACTIONS(2705),
    [aux_sym_primitive_type_token1] = ACTIONS(2705),
    [anon_sym_byte] = ACTIONS(2705),
    [anon_sym_word] = ACTIONS(2705),
    [anon_sym_enum] = ACTIONS(2705),
    [anon_sym_class] = ACTIONS(2705),
    [anon_sym_struct] = ACTIONS(2705),
    [anon_sym_union] = ACTIONS(2705),
    [anon_sym_if] = ACTIONS(2705),
    [anon_sym_else] = ACTIONS(2705),
    [anon_sym_switch] = ACTIONS(2705),
    [anon_sym_while] = ACTIONS(2705),
    [anon_sym_do] = ACTIONS(2705),
    [anon_sym_for] = ACTIONS(2705),
    [anon_sym_return] = ACTIONS(2705),
    [anon_sym_break] = ACTIONS(2705),
    [anon_sym_continue] = ACTIONS(2705),
    [anon_sym_goto] = ACTIONS(2705),
    [anon_sym___try] = ACTIONS(2705),
    [anon_sym___leave] = ACTIONS(2705),
    [anon_sym_not] = ACTIONS(2705),
    [anon_sym_compl] = ACTIONS(2705),
    [anon_sym_DASH_DASH] = ACTIONS(2707),
    [anon_sym_PLUS_PLUS] = ACTIONS(2707),
    [anon_sym_sizeof] = ACTIONS(2705),
    [anon_sym___alignof__] = ACTIONS(2705),
    [anon_sym___alignof] = ACTIONS(2705),
    [anon_sym__alignof] = ACTIONS(2705),
    [anon_sym_alignof] = ACTIONS(2705),
    [anon_sym__Alignof] = ACTIONS(2705),
    [anon_sym_offsetof] = ACTIONS(2705),
    [anon_sym__Generic] = ACTIONS(2705),
    [anon_sym_asm] = ACTIONS(2705),
    [anon_sym___asm__] = ACTIONS(2705),
    [aux_sym_number_literal_token1] = ACTIONS(2707),
    [aux_sym_number_literal_token2] = ACTIONS(2705),
    [anon_sym_L_SQUOTE] = ACTIONS(2707),
    [anon_sym_u_SQUOTE] = ACTIONS(2707),
    [anon_sym_U_SQUOTE] = ACTIONS(2707),
    [anon_sym_u8_SQUOTE] = ACTIONS(2707),
    [anon_sym_SQUOTE] = ACTIONS(2707),
    [anon_sym_L_DQUOTE] = ACTIONS(2707),
    [anon_sym_u_DQUOTE] = ACTIONS(2707),
    [anon_sym_U_DQUOTE] = ACTIONS(2707),
    [anon_sym_u8_DQUOTE] = ACTIONS(2707),
    [anon_sym_DQUOTE] = ACTIONS(2707),
    [sym_true] = ACTIONS(2705),
    [sym_false] = ACTIONS(2705),
    [anon_sym_NULL] = ACTIONS(2705),
    [anon_sym_nullptr] = ACTIONS(2705),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2705),
    [anon_sym_decltype] = ACTIONS(2705),
    [anon_sym_virtual] = ACTIONS(2705),
    [anon_sym_alignas] = ACTIONS(2705),
    [anon_sym_typename] = ACTIONS(2705),
    [anon_sym_template] = ACTIONS(2705),
    [anon_sym_try] = ACTIONS(2705),
    [anon_sym_delete] = ACTIONS(2705),
    [anon_sym_throw] = ACTIONS(2705),
    [anon_sym_co_return] = ACTIONS(2705),
    [anon_sym_co_yield] = ACTIONS(2705),
    [anon_sym_R_DQUOTE] = ACTIONS(2707),
    [anon_sym_LR_DQUOTE] = ACTIONS(2707),
    [anon_sym_uR_DQUOTE] = ACTIONS(2707),
    [anon_sym_UR_DQUOTE] = ACTIONS(2707),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2707),
    [anon_sym_co_await] = ACTIONS(2705),
    [anon_sym_new] = ACTIONS(2705),
    [anon_sym_requires] = ACTIONS(2705),
    [sym_this] = ACTIONS(2705),
  },
  [1030] = {
    [sym_identifier] = ACTIONS(2701),
    [anon_sym_LPAREN2] = ACTIONS(2703),
    [anon_sym_BANG] = ACTIONS(2703),
    [anon_sym_TILDE] = ACTIONS(2703),
    [anon_sym_DASH] = ACTIONS(2701),
    [anon_sym_PLUS] = ACTIONS(2701),
    [anon_sym_STAR] = ACTIONS(2703),
    [anon_sym_AMP] = ACTIONS(2703),
    [anon_sym_SEMI] = ACTIONS(2703),
    [anon_sym___extension__] = ACTIONS(2701),
    [anon_sym_typedef] = ACTIONS(2701),
    [anon_sym_extern] = ACTIONS(2701),
    [anon_sym___attribute__] = ACTIONS(2701),
    [anon_sym_COLON_COLON] = ACTIONS(2703),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2703),
    [anon_sym___declspec] = ACTIONS(2701),
    [anon_sym_LBRACE] = ACTIONS(2703),
    [anon_sym_signed] = ACTIONS(2701),
    [anon_sym_unsigned] = ACTIONS(2701),
    [anon_sym_long] = ACTIONS(2701),
    [anon_sym_short] = ACTIONS(2701),
    [anon_sym_LBRACK] = ACTIONS(2701),
    [anon_sym_static] = ACTIONS(2701),
    [anon_sym_register] = ACTIONS(2701),
    [anon_sym_inline] = ACTIONS(2701),
    [anon_sym___inline] = ACTIONS(2701),
    [anon_sym___inline__] = ACTIONS(2701),
    [anon_sym___forceinline] = ACTIONS(2701),
    [anon_sym_thread_local] = ACTIONS(2701),
    [anon_sym___thread] = ACTIONS(2701),
    [anon_sym_const] = ACTIONS(2701),
    [anon_sym_constexpr] = ACTIONS(2701),
    [anon_sym_volatile] = ACTIONS(2701),
    [anon_sym_restrict] = ACTIONS(2701),
    [anon_sym___restrict__] = ACTIONS(2701),
    [anon_sym__Atomic] = ACTIONS(2701),
    [anon_sym__Noreturn] = ACTIONS(2701),
    [anon_sym_noreturn] = ACTIONS(2701),
    [anon_sym_mutable] = ACTIONS(2701),
    [anon_sym_constinit] = ACTIONS(2701),
    [anon_sym_consteval] = ACTIONS(2701),
    [anon_sym_PROGMEM] = ACTIONS(2701),
    [aux_sym_primitive_type_token1] = ACTIONS(2701),
    [anon_sym_byte] = ACTIONS(2701),
    [anon_sym_word] = ACTIONS(2701),
    [anon_sym_enum] = ACTIONS(2701),
    [anon_sym_class] = ACTIONS(2701),
    [anon_sym_struct] = ACTIONS(2701),
    [anon_sym_union] = ACTIONS(2701),
    [anon_sym_if] = ACTIONS(2701),
    [anon_sym_else] = ACTIONS(2701),
    [anon_sym_switch] = ACTIONS(2701),
    [anon_sym_while] = ACTIONS(2701),
    [anon_sym_do] = ACTIONS(2701),
    [anon_sym_for] = ACTIONS(2701),
    [anon_sym_return] = ACTIONS(2701),
    [anon_sym_break] = ACTIONS(2701),
    [anon_sym_continue] = ACTIONS(2701),
    [anon_sym_goto] = ACTIONS(2701),
    [anon_sym___try] = ACTIONS(2701),
    [anon_sym___leave] = ACTIONS(2701),
    [anon_sym_not] = ACTIONS(2701),
    [anon_sym_compl] = ACTIONS(2701),
    [anon_sym_DASH_DASH] = ACTIONS(2703),
    [anon_sym_PLUS_PLUS] = ACTIONS(2703),
    [anon_sym_sizeof] = ACTIONS(2701),
    [anon_sym___alignof__] = ACTIONS(2701),
    [anon_sym___alignof] = ACTIONS(2701),
    [anon_sym__alignof] = ACTIONS(2701),
    [anon_sym_alignof] = ACTIONS(2701),
    [anon_sym__Alignof] = ACTIONS(2701),
    [anon_sym_offsetof] = ACTIONS(2701),
    [anon_sym__Generic] = ACTIONS(2701),
    [anon_sym_asm] = ACTIONS(2701),
    [anon_sym___asm__] = ACTIONS(2701),
    [aux_sym_number_literal_token1] = ACTIONS(2703),
    [aux_sym_number_literal_token2] = ACTIONS(2701),
    [anon_sym_L_SQUOTE] = ACTIONS(2703),
    [anon_sym_u_SQUOTE] = ACTIONS(2703),
    [anon_sym_U_SQUOTE] = ACTIONS(2703),
    [anon_sym_u8_SQUOTE] = ACTIONS(2703),
    [anon_sym_SQUOTE] = ACTIONS(2703),
    [anon_sym_L_DQUOTE] = ACTIONS(2703),
    [anon_sym_u_DQUOTE] = ACTIONS(2703),
    [anon_sym_U_DQUOTE] = ACTIONS(2703),
    [anon_sym_u8_DQUOTE] = ACTIONS(2703),
    [anon_sym_DQUOTE] = ACTIONS(2703),
    [sym_true] = ACTIONS(2701),
    [sym_false] = ACTIONS(2701),
    [anon_sym_NULL] = ACTIONS(2701),
    [anon_sym_nullptr] = ACTIONS(2701),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2701),
    [anon_sym_decltype] = ACTIONS(2701),
    [anon_sym_virtual] = ACTIONS(2701),
    [anon_sym_alignas] = ACTIONS(2701),
    [anon_sym_typename] = ACTIONS(2701),
    [anon_sym_template] = ACTIONS(2701),
    [anon_sym_try] = ACTIONS(2701),
    [anon_sym_delete] = ACTIONS(2701),
    [anon_sym_throw] = ACTIONS(2701),
    [anon_sym_co_return] = ACTIONS(2701),
    [anon_sym_co_yield] = ACTIONS(2701),
    [anon_sym_R_DQUOTE] = ACTIONS(2703),
    [anon_sym_LR_DQUOTE] = ACTIONS(2703),
    [anon_sym_uR_DQUOTE] = ACTIONS(2703),
    [anon_sym_UR_DQUOTE] = ACTIONS(2703),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2703),
    [anon_sym_co_await] = ACTIONS(2701),
    [anon_sym_new] = ACTIONS(2701),
    [anon_sym_requires] = ACTIONS(2701),
    [sym_this] = ACTIONS(2701),
  },
  [1031] = {
    [sym_identifier] = ACTIONS(2695),
    [anon_sym_LPAREN2] = ACTIONS(2697),
    [anon_sym_BANG] = ACTIONS(2697),
    [anon_sym_TILDE] = ACTIONS(2697),
    [anon_sym_DASH] = ACTIONS(2695),
    [anon_sym_PLUS] = ACTIONS(2695),
    [anon_sym_STAR] = ACTIONS(2697),
    [anon_sym_AMP] = ACTIONS(2697),
    [anon_sym_SEMI] = ACTIONS(2697),
    [anon_sym___extension__] = ACTIONS(2695),
    [anon_sym_typedef] = ACTIONS(2695),
    [anon_sym_extern] = ACTIONS(2695),
    [anon_sym___attribute__] = ACTIONS(2695),
    [anon_sym_COLON_COLON] = ACTIONS(2697),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2697),
    [anon_sym___declspec] = ACTIONS(2695),
    [anon_sym_LBRACE] = ACTIONS(2697),
    [anon_sym_signed] = ACTIONS(2695),
    [anon_sym_unsigned] = ACTIONS(2695),
    [anon_sym_long] = ACTIONS(2695),
    [anon_sym_short] = ACTIONS(2695),
    [anon_sym_LBRACK] = ACTIONS(2695),
    [anon_sym_static] = ACTIONS(2695),
    [anon_sym_register] = ACTIONS(2695),
    [anon_sym_inline] = ACTIONS(2695),
    [anon_sym___inline] = ACTIONS(2695),
    [anon_sym___inline__] = ACTIONS(2695),
    [anon_sym___forceinline] = ACTIONS(2695),
    [anon_sym_thread_local] = ACTIONS(2695),
    [anon_sym___thread] = ACTIONS(2695),
    [anon_sym_const] = ACTIONS(2695),
    [anon_sym_constexpr] = ACTIONS(2695),
    [anon_sym_volatile] = ACTIONS(2695),
    [anon_sym_restrict] = ACTIONS(2695),
    [anon_sym___restrict__] = ACTIONS(2695),
    [anon_sym__Atomic] = ACTIONS(2695),
    [anon_sym__Noreturn] = ACTIONS(2695),
    [anon_sym_noreturn] = ACTIONS(2695),
    [anon_sym_mutable] = ACTIONS(2695),
    [anon_sym_constinit] = ACTIONS(2695),
    [anon_sym_consteval] = ACTIONS(2695),
    [anon_sym_PROGMEM] = ACTIONS(2695),
    [aux_sym_primitive_type_token1] = ACTIONS(2695),
    [anon_sym_byte] = ACTIONS(2695),
    [anon_sym_word] = ACTIONS(2695),
    [anon_sym_enum] = ACTIONS(2695),
    [anon_sym_class] = ACTIONS(2695),
    [anon_sym_struct] = ACTIONS(2695),
    [anon_sym_union] = ACTIONS(2695),
    [anon_sym_if] = ACTIONS(2695),
    [anon_sym_else] = ACTIONS(2695),
    [anon_sym_switch] = ACTIONS(2695),
    [anon_sym_while] = ACTIONS(2695),
    [anon_sym_do] = ACTIONS(2695),
    [anon_sym_for] = ACTIONS(2695),
    [anon_sym_return] = ACTIONS(2695),
    [anon_sym_break] = ACTIONS(2695),
    [anon_sym_continue] = ACTIONS(2695),
    [anon_sym_goto] = ACTIONS(2695),
    [anon_sym___try] = ACTIONS(2695),
    [anon_sym___leave] = ACTIONS(2695),
    [anon_sym_not] = ACTIONS(2695),
    [anon_sym_compl] = ACTIONS(2695),
    [anon_sym_DASH_DASH] = ACTIONS(2697),
    [anon_sym_PLUS_PLUS] = ACTIONS(2697),
    [anon_sym_sizeof] = ACTIONS(2695),
    [anon_sym___alignof__] = ACTIONS(2695),
    [anon_sym___alignof] = ACTIONS(2695),
    [anon_sym__alignof] = ACTIONS(2695),
    [anon_sym_alignof] = ACTIONS(2695),
    [anon_sym__Alignof] = ACTIONS(2695),
    [anon_sym_offsetof] = ACTIONS(2695),
    [anon_sym__Generic] = ACTIONS(2695),
    [anon_sym_asm] = ACTIONS(2695),
    [anon_sym___asm__] = ACTIONS(2695),
    [aux_sym_number_literal_token1] = ACTIONS(2697),
    [aux_sym_number_literal_token2] = ACTIONS(2695),
    [anon_sym_L_SQUOTE] = ACTIONS(2697),
    [anon_sym_u_SQUOTE] = ACTIONS(2697),
    [anon_sym_U_SQUOTE] = ACTIONS(2697),
    [anon_sym_u8_SQUOTE] = ACTIONS(2697),
    [anon_sym_SQUOTE] = ACTIONS(2697),
    [anon_sym_L_DQUOTE] = ACTIONS(2697),
    [anon_sym_u_DQUOTE] = ACTIONS(2697),
    [anon_sym_U_DQUOTE] = ACTIONS(2697),
    [anon_sym_u8_DQUOTE] = ACTIONS(2697),
    [anon_sym_DQUOTE] = ACTIONS(2697),
    [sym_true] = ACTIONS(2695),
    [sym_false] = ACTIONS(2695),
    [anon_sym_NULL] = ACTIONS(2695),
    [anon_sym_nullptr] = ACTIONS(2695),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2695),
    [anon_sym_decltype] = ACTIONS(2695),
    [anon_sym_virtual] = ACTIONS(2695),
    [anon_sym_alignas] = ACTIONS(2695),
    [anon_sym_typename] = ACTIONS(2695),
    [anon_sym_template] = ACTIONS(2695),
    [anon_sym_try] = ACTIONS(2695),
    [anon_sym_delete] = ACTIONS(2695),
    [anon_sym_throw] = ACTIONS(2695),
    [anon_sym_co_return] = ACTIONS(2695),
    [anon_sym_co_yield] = ACTIONS(2695),
    [anon_sym_R_DQUOTE] = ACTIONS(2697),
    [anon_sym_LR_DQUOTE] = ACTIONS(2697),
    [anon_sym_uR_DQUOTE] = ACTIONS(2697),
    [anon_sym_UR_DQUOTE] = ACTIONS(2697),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2697),
    [anon_sym_co_await] = ACTIONS(2695),
    [anon_sym_new] = ACTIONS(2695),
    [anon_sym_requires] = ACTIONS(2695),
    [sym_this] = ACTIONS(2695),
  },
  [1032] = {
    [sym_identifier] = ACTIONS(2723),
    [anon_sym_LPAREN2] = ACTIONS(2725),
    [anon_sym_BANG] = ACTIONS(2725),
    [anon_sym_TILDE] = ACTIONS(2725),
    [anon_sym_DASH] = ACTIONS(2723),
    [anon_sym_PLUS] = ACTIONS(2723),
    [anon_sym_STAR] = ACTIONS(2725),
    [anon_sym_AMP] = ACTIONS(2725),
    [anon_sym_SEMI] = ACTIONS(2725),
    [anon_sym___extension__] = ACTIONS(2723),
    [anon_sym_typedef] = ACTIONS(2723),
    [anon_sym_extern] = ACTIONS(2723),
    [anon_sym___attribute__] = ACTIONS(2723),
    [anon_sym_COLON_COLON] = ACTIONS(2725),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2725),
    [anon_sym___declspec] = ACTIONS(2723),
    [anon_sym_LBRACE] = ACTIONS(2725),
    [anon_sym_signed] = ACTIONS(2723),
    [anon_sym_unsigned] = ACTIONS(2723),
    [anon_sym_long] = ACTIONS(2723),
    [anon_sym_short] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_static] = ACTIONS(2723),
    [anon_sym_register] = ACTIONS(2723),
    [anon_sym_inline] = ACTIONS(2723),
    [anon_sym___inline] = ACTIONS(2723),
    [anon_sym___inline__] = ACTIONS(2723),
    [anon_sym___forceinline] = ACTIONS(2723),
    [anon_sym_thread_local] = ACTIONS(2723),
    [anon_sym___thread] = ACTIONS(2723),
    [anon_sym_const] = ACTIONS(2723),
    [anon_sym_constexpr] = ACTIONS(2723),
    [anon_sym_volatile] = ACTIONS(2723),
    [anon_sym_restrict] = ACTIONS(2723),
    [anon_sym___restrict__] = ACTIONS(2723),
    [anon_sym__Atomic] = ACTIONS(2723),
    [anon_sym__Noreturn] = ACTIONS(2723),
    [anon_sym_noreturn] = ACTIONS(2723),
    [anon_sym_mutable] = ACTIONS(2723),
    [anon_sym_constinit] = ACTIONS(2723),
    [anon_sym_consteval] = ACTIONS(2723),
    [anon_sym_PROGMEM] = ACTIONS(2723),
    [aux_sym_primitive_type_token1] = ACTIONS(2723),
    [anon_sym_byte] = ACTIONS(2723),
    [anon_sym_word] = ACTIONS(2723),
    [anon_sym_enum] = ACTIONS(2723),
    [anon_sym_class] = ACTIONS(2723),
    [anon_sym_struct] = ACTIONS(2723),
    [anon_sym_union] = ACTIONS(2723),
    [anon_sym_if] = ACTIONS(2723),
    [anon_sym_else] = ACTIONS(2723),
    [anon_sym_switch] = ACTIONS(2723),
    [anon_sym_while] = ACTIONS(2723),
    [anon_sym_do] = ACTIONS(2723),
    [anon_sym_for] = ACTIONS(2723),
    [anon_sym_return] = ACTIONS(2723),
    [anon_sym_break] = ACTIONS(2723),
    [anon_sym_continue] = ACTIONS(2723),
    [anon_sym_goto] = ACTIONS(2723),
    [anon_sym___try] = ACTIONS(2723),
    [anon_sym___leave] = ACTIONS(2723),
    [anon_sym_not] = ACTIONS(2723),
    [anon_sym_compl] = ACTIONS(2723),
    [anon_sym_DASH_DASH] = ACTIONS(2725),
    [anon_sym_PLUS_PLUS] = ACTIONS(2725),
    [anon_sym_sizeof] = ACTIONS(2723),
    [anon_sym___alignof__] = ACTIONS(2723),
    [anon_sym___alignof] = ACTIONS(2723),
    [anon_sym__alignof] = ACTIONS(2723),
    [anon_sym_alignof] = ACTIONS(2723),
    [anon_sym__Alignof] = ACTIONS(2723),
    [anon_sym_offsetof] = ACTIONS(2723),
    [anon_sym__Generic] = ACTIONS(2723),
    [anon_sym_asm] = ACTIONS(2723),
    [anon_sym___asm__] = ACTIONS(2723),
    [aux_sym_number_literal_token1] = ACTIONS(2725),
    [aux_sym_number_literal_token2] = ACTIONS(2723),
    [anon_sym_L_SQUOTE] = ACTIONS(2725),
    [anon_sym_u_SQUOTE] = ACTIONS(2725),
    [anon_sym_U_SQUOTE] = ACTIONS(2725),
    [anon_sym_u8_SQUOTE] = ACTIONS(2725),
    [anon_sym_SQUOTE] = ACTIONS(2725),
    [anon_sym_L_DQUOTE] = ACTIONS(2725),
    [anon_sym_u_DQUOTE] = ACTIONS(2725),
    [anon_sym_U_DQUOTE] = ACTIONS(2725),
    [anon_sym_u8_DQUOTE] = ACTIONS(2725),
    [anon_sym_DQUOTE] = ACTIONS(2725),
    [sym_true] = ACTIONS(2723),
    [sym_false] = ACTIONS(2723),
    [anon_sym_NULL] = ACTIONS(2723),
    [anon_sym_nullptr] = ACTIONS(2723),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2723),
    [anon_sym_decltype] = ACTIONS(2723),
    [anon_sym_virtual] = ACTIONS(2723),
    [anon_sym_alignas] = ACTIONS(2723),
    [anon_sym_typename] = ACTIONS(2723),
    [anon_sym_template] = ACTIONS(2723),
    [anon_sym_try] = ACTIONS(2723),
    [anon_sym_delete] = ACTIONS(2723),
    [anon_sym_throw] = ACTIONS(2723),
    [anon_sym_co_return] = ACTIONS(2723),
    [anon_sym_co_yield] = ACTIONS(2723),
    [anon_sym_R_DQUOTE] = ACTIONS(2725),
    [anon_sym_LR_DQUOTE] = ACTIONS(2725),
    [anon_sym_uR_DQUOTE] = ACTIONS(2725),
    [anon_sym_UR_DQUOTE] = ACTIONS(2725),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2725),
    [anon_sym_co_await] = ACTIONS(2723),
    [anon_sym_new] = ACTIONS(2723),
    [anon_sym_requires] = ACTIONS(2723),
    [sym_this] = ACTIONS(2723),
  },
  [1033] = {
    [sym_string_literal] = STATE(2617),
    [sym_template_argument_list] = STATE(1740),
    [sym_raw_string_literal] = STATE(2617),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2716),
    [sym_identifier] = ACTIONS(3759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3761),
    [anon_sym_COMMA] = ACTIONS(3761),
    [anon_sym_LPAREN2] = ACTIONS(3763),
    [anon_sym_TILDE] = ACTIONS(3767),
    [anon_sym_DASH] = ACTIONS(3769),
    [anon_sym_PLUS] = ACTIONS(3769),
    [anon_sym_STAR] = ACTIONS(3771),
    [anon_sym_SLASH] = ACTIONS(3769),
    [anon_sym_PERCENT] = ACTIONS(3769),
    [anon_sym_PIPE_PIPE] = ACTIONS(3761),
    [anon_sym_AMP_AMP] = ACTIONS(3774),
    [anon_sym_PIPE] = ACTIONS(3769),
    [anon_sym_CARET] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(3771),
    [anon_sym_EQ_EQ] = ACTIONS(3761),
    [anon_sym_BANG_EQ] = ACTIONS(3761),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3761),
    [anon_sym_LT_EQ] = ACTIONS(3769),
    [anon_sym_LT] = ACTIONS(3777),
    [anon_sym_LT_LT] = ACTIONS(3769),
    [anon_sym_GT_GT] = ACTIONS(3769),
    [anon_sym_SEMI] = ACTIONS(3774),
    [anon_sym___extension__] = ACTIONS(3759),
    [anon_sym_extern] = ACTIONS(3759),
    [anon_sym___attribute__] = ACTIONS(3759),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3782),
    [anon_sym___declspec] = ACTIONS(3759),
    [anon_sym___based] = ACTIONS(3759),
    [anon_sym___cdecl] = ACTIONS(3759),
    [anon_sym___clrcall] = ACTIONS(3759),
    [anon_sym___stdcall] = ACTIONS(3759),
    [anon_sym___fastcall] = ACTIONS(3759),
    [anon_sym___thiscall] = ACTIONS(3759),
    [anon_sym___vectorcall] = ACTIONS(3759),
    [anon_sym_LBRACE] = ACTIONS(3785),
    [anon_sym_signed] = ACTIONS(3787),
    [anon_sym_unsigned] = ACTIONS(3787),
    [anon_sym_long] = ACTIONS(3787),
    [anon_sym_short] = ACTIONS(3787),
    [anon_sym_LBRACK] = ACTIONS(3789),
    [anon_sym_EQ] = ACTIONS(3793),
    [anon_sym_static] = ACTIONS(3759),
    [anon_sym_register] = ACTIONS(3759),
    [anon_sym_inline] = ACTIONS(3759),
    [anon_sym___inline] = ACTIONS(3759),
    [anon_sym___inline__] = ACTIONS(3759),
    [anon_sym___forceinline] = ACTIONS(3759),
    [anon_sym_thread_local] = ACTIONS(3759),
    [anon_sym___thread] = ACTIONS(3759),
    [anon_sym_const] = ACTIONS(3759),
    [anon_sym_constexpr] = ACTIONS(3759),
    [anon_sym_volatile] = ACTIONS(3759),
    [anon_sym_restrict] = ACTIONS(3759),
    [anon_sym___restrict__] = ACTIONS(3759),
    [anon_sym__Atomic] = ACTIONS(3759),
    [anon_sym__Noreturn] = ACTIONS(3759),
    [anon_sym_noreturn] = ACTIONS(3759),
    [anon_sym_mutable] = ACTIONS(3759),
    [anon_sym_constinit] = ACTIONS(3759),
    [anon_sym_consteval] = ACTIONS(3759),
    [anon_sym_PROGMEM] = ACTIONS(3759),
    [anon_sym_COLON] = ACTIONS(3817),
    [anon_sym_QMARK] = ACTIONS(3761),
    [anon_sym_STAR_EQ] = ACTIONS(3797),
    [anon_sym_SLASH_EQ] = ACTIONS(3797),
    [anon_sym_PERCENT_EQ] = ACTIONS(3797),
    [anon_sym_PLUS_EQ] = ACTIONS(3797),
    [anon_sym_DASH_EQ] = ACTIONS(3797),
    [anon_sym_LT_LT_EQ] = ACTIONS(3797),
    [anon_sym_GT_GT_EQ] = ACTIONS(3797),
    [anon_sym_AMP_EQ] = ACTIONS(3797),
    [anon_sym_CARET_EQ] = ACTIONS(3797),
    [anon_sym_PIPE_EQ] = ACTIONS(3797),
    [anon_sym_and_eq] = ACTIONS(3793),
    [anon_sym_or_eq] = ACTIONS(3793),
    [anon_sym_xor_eq] = ACTIONS(3793),
    [anon_sym_LT_EQ_GT] = ACTIONS(3761),
    [anon_sym_or] = ACTIONS(3769),
    [anon_sym_and] = ACTIONS(3769),
    [anon_sym_bitor] = ACTIONS(3769),
    [anon_sym_xor] = ACTIONS(3769),
    [anon_sym_bitand] = ACTIONS(3769),
    [anon_sym_not_eq] = ACTIONS(3769),
    [anon_sym_DASH_DASH] = ACTIONS(3761),
    [anon_sym_PLUS_PLUS] = ACTIONS(3761),
    [anon_sym_DOT] = ACTIONS(3769),
    [anon_sym_DOT_STAR] = ACTIONS(3761),
    [anon_sym_DASH_GT] = ACTIONS(3761),
    [anon_sym_L_DQUOTE] = ACTIONS(3204),
    [anon_sym_u_DQUOTE] = ACTIONS(3204),
    [anon_sym_U_DQUOTE] = ACTIONS(3204),
    [anon_sym_u8_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3204),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3759),
    [anon_sym_decltype] = ACTIONS(3759),
    [anon_sym_virtual] = ACTIONS(3759),
    [anon_sym_alignas] = ACTIONS(3759),
    [anon_sym_template] = ACTIONS(3759),
    [anon_sym_operator] = ACTIONS(3759),
    [anon_sym_R_DQUOTE] = ACTIONS(3208),
    [anon_sym_LR_DQUOTE] = ACTIONS(3208),
    [anon_sym_uR_DQUOTE] = ACTIONS(3208),
    [anon_sym_UR_DQUOTE] = ACTIONS(3208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3208),
  },
  [1034] = {
    [sym_identifier] = ACTIONS(2723),
    [anon_sym_LPAREN2] = ACTIONS(2725),
    [anon_sym_BANG] = ACTIONS(2725),
    [anon_sym_TILDE] = ACTIONS(2725),
    [anon_sym_DASH] = ACTIONS(2723),
    [anon_sym_PLUS] = ACTIONS(2723),
    [anon_sym_STAR] = ACTIONS(2725),
    [anon_sym_AMP] = ACTIONS(2725),
    [anon_sym_SEMI] = ACTIONS(2725),
    [anon_sym___extension__] = ACTIONS(2723),
    [anon_sym_typedef] = ACTIONS(2723),
    [anon_sym_extern] = ACTIONS(2723),
    [anon_sym___attribute__] = ACTIONS(2723),
    [anon_sym_COLON_COLON] = ACTIONS(2725),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2725),
    [anon_sym___declspec] = ACTIONS(2723),
    [anon_sym_LBRACE] = ACTIONS(2725),
    [anon_sym_signed] = ACTIONS(2723),
    [anon_sym_unsigned] = ACTIONS(2723),
    [anon_sym_long] = ACTIONS(2723),
    [anon_sym_short] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_static] = ACTIONS(2723),
    [anon_sym_register] = ACTIONS(2723),
    [anon_sym_inline] = ACTIONS(2723),
    [anon_sym___inline] = ACTIONS(2723),
    [anon_sym___inline__] = ACTIONS(2723),
    [anon_sym___forceinline] = ACTIONS(2723),
    [anon_sym_thread_local] = ACTIONS(2723),
    [anon_sym___thread] = ACTIONS(2723),
    [anon_sym_const] = ACTIONS(2723),
    [anon_sym_constexpr] = ACTIONS(2723),
    [anon_sym_volatile] = ACTIONS(2723),
    [anon_sym_restrict] = ACTIONS(2723),
    [anon_sym___restrict__] = ACTIONS(2723),
    [anon_sym__Atomic] = ACTIONS(2723),
    [anon_sym__Noreturn] = ACTIONS(2723),
    [anon_sym_noreturn] = ACTIONS(2723),
    [anon_sym_mutable] = ACTIONS(2723),
    [anon_sym_constinit] = ACTIONS(2723),
    [anon_sym_consteval] = ACTIONS(2723),
    [anon_sym_PROGMEM] = ACTIONS(2723),
    [aux_sym_primitive_type_token1] = ACTIONS(2723),
    [anon_sym_byte] = ACTIONS(2723),
    [anon_sym_word] = ACTIONS(2723),
    [anon_sym_enum] = ACTIONS(2723),
    [anon_sym_class] = ACTIONS(2723),
    [anon_sym_struct] = ACTIONS(2723),
    [anon_sym_union] = ACTIONS(2723),
    [anon_sym_if] = ACTIONS(2723),
    [anon_sym_else] = ACTIONS(2723),
    [anon_sym_switch] = ACTIONS(2723),
    [anon_sym_while] = ACTIONS(2723),
    [anon_sym_do] = ACTIONS(2723),
    [anon_sym_for] = ACTIONS(2723),
    [anon_sym_return] = ACTIONS(2723),
    [anon_sym_break] = ACTIONS(2723),
    [anon_sym_continue] = ACTIONS(2723),
    [anon_sym_goto] = ACTIONS(2723),
    [anon_sym___try] = ACTIONS(2723),
    [anon_sym___leave] = ACTIONS(2723),
    [anon_sym_not] = ACTIONS(2723),
    [anon_sym_compl] = ACTIONS(2723),
    [anon_sym_DASH_DASH] = ACTIONS(2725),
    [anon_sym_PLUS_PLUS] = ACTIONS(2725),
    [anon_sym_sizeof] = ACTIONS(2723),
    [anon_sym___alignof__] = ACTIONS(2723),
    [anon_sym___alignof] = ACTIONS(2723),
    [anon_sym__alignof] = ACTIONS(2723),
    [anon_sym_alignof] = ACTIONS(2723),
    [anon_sym__Alignof] = ACTIONS(2723),
    [anon_sym_offsetof] = ACTIONS(2723),
    [anon_sym__Generic] = ACTIONS(2723),
    [anon_sym_asm] = ACTIONS(2723),
    [anon_sym___asm__] = ACTIONS(2723),
    [aux_sym_number_literal_token1] = ACTIONS(2725),
    [aux_sym_number_literal_token2] = ACTIONS(2723),
    [anon_sym_L_SQUOTE] = ACTIONS(2725),
    [anon_sym_u_SQUOTE] = ACTIONS(2725),
    [anon_sym_U_SQUOTE] = ACTIONS(2725),
    [anon_sym_u8_SQUOTE] = ACTIONS(2725),
    [anon_sym_SQUOTE] = ACTIONS(2725),
    [anon_sym_L_DQUOTE] = ACTIONS(2725),
    [anon_sym_u_DQUOTE] = ACTIONS(2725),
    [anon_sym_U_DQUOTE] = ACTIONS(2725),
    [anon_sym_u8_DQUOTE] = ACTIONS(2725),
    [anon_sym_DQUOTE] = ACTIONS(2725),
    [sym_true] = ACTIONS(2723),
    [sym_false] = ACTIONS(2723),
    [anon_sym_NULL] = ACTIONS(2723),
    [anon_sym_nullptr] = ACTIONS(2723),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2723),
    [anon_sym_decltype] = ACTIONS(2723),
    [anon_sym_virtual] = ACTIONS(2723),
    [anon_sym_alignas] = ACTIONS(2723),
    [anon_sym_typename] = ACTIONS(2723),
    [anon_sym_template] = ACTIONS(2723),
    [anon_sym_try] = ACTIONS(2723),
    [anon_sym_delete] = ACTIONS(2723),
    [anon_sym_throw] = ACTIONS(2723),
    [anon_sym_co_return] = ACTIONS(2723),
    [anon_sym_co_yield] = ACTIONS(2723),
    [anon_sym_R_DQUOTE] = ACTIONS(2725),
    [anon_sym_LR_DQUOTE] = ACTIONS(2725),
    [anon_sym_uR_DQUOTE] = ACTIONS(2725),
    [anon_sym_UR_DQUOTE] = ACTIONS(2725),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2725),
    [anon_sym_co_await] = ACTIONS(2723),
    [anon_sym_new] = ACTIONS(2723),
    [anon_sym_requires] = ACTIONS(2723),
    [sym_this] = ACTIONS(2723),
  },
  [1035] = {
    [sym_identifier] = ACTIONS(2691),
    [anon_sym_LPAREN2] = ACTIONS(2693),
    [anon_sym_BANG] = ACTIONS(2693),
    [anon_sym_TILDE] = ACTIONS(2693),
    [anon_sym_DASH] = ACTIONS(2691),
    [anon_sym_PLUS] = ACTIONS(2691),
    [anon_sym_STAR] = ACTIONS(2693),
    [anon_sym_AMP] = ACTIONS(2693),
    [anon_sym_SEMI] = ACTIONS(2693),
    [anon_sym___extension__] = ACTIONS(2691),
    [anon_sym_typedef] = ACTIONS(2691),
    [anon_sym_extern] = ACTIONS(2691),
    [anon_sym___attribute__] = ACTIONS(2691),
    [anon_sym_COLON_COLON] = ACTIONS(2693),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2693),
    [anon_sym___declspec] = ACTIONS(2691),
    [anon_sym_LBRACE] = ACTIONS(2693),
    [anon_sym_signed] = ACTIONS(2691),
    [anon_sym_unsigned] = ACTIONS(2691),
    [anon_sym_long] = ACTIONS(2691),
    [anon_sym_short] = ACTIONS(2691),
    [anon_sym_LBRACK] = ACTIONS(2691),
    [anon_sym_static] = ACTIONS(2691),
    [anon_sym_register] = ACTIONS(2691),
    [anon_sym_inline] = ACTIONS(2691),
    [anon_sym___inline] = ACTIONS(2691),
    [anon_sym___inline__] = ACTIONS(2691),
    [anon_sym___forceinline] = ACTIONS(2691),
    [anon_sym_thread_local] = ACTIONS(2691),
    [anon_sym___thread] = ACTIONS(2691),
    [anon_sym_const] = ACTIONS(2691),
    [anon_sym_constexpr] = ACTIONS(2691),
    [anon_sym_volatile] = ACTIONS(2691),
    [anon_sym_restrict] = ACTIONS(2691),
    [anon_sym___restrict__] = ACTIONS(2691),
    [anon_sym__Atomic] = ACTIONS(2691),
    [anon_sym__Noreturn] = ACTIONS(2691),
    [anon_sym_noreturn] = ACTIONS(2691),
    [anon_sym_mutable] = ACTIONS(2691),
    [anon_sym_constinit] = ACTIONS(2691),
    [anon_sym_consteval] = ACTIONS(2691),
    [anon_sym_PROGMEM] = ACTIONS(2691),
    [aux_sym_primitive_type_token1] = ACTIONS(2691),
    [anon_sym_byte] = ACTIONS(2691),
    [anon_sym_word] = ACTIONS(2691),
    [anon_sym_enum] = ACTIONS(2691),
    [anon_sym_class] = ACTIONS(2691),
    [anon_sym_struct] = ACTIONS(2691),
    [anon_sym_union] = ACTIONS(2691),
    [anon_sym_if] = ACTIONS(2691),
    [anon_sym_else] = ACTIONS(2691),
    [anon_sym_switch] = ACTIONS(2691),
    [anon_sym_while] = ACTIONS(2691),
    [anon_sym_do] = ACTIONS(2691),
    [anon_sym_for] = ACTIONS(2691),
    [anon_sym_return] = ACTIONS(2691),
    [anon_sym_break] = ACTIONS(2691),
    [anon_sym_continue] = ACTIONS(2691),
    [anon_sym_goto] = ACTIONS(2691),
    [anon_sym___try] = ACTIONS(2691),
    [anon_sym___leave] = ACTIONS(2691),
    [anon_sym_not] = ACTIONS(2691),
    [anon_sym_compl] = ACTIONS(2691),
    [anon_sym_DASH_DASH] = ACTIONS(2693),
    [anon_sym_PLUS_PLUS] = ACTIONS(2693),
    [anon_sym_sizeof] = ACTIONS(2691),
    [anon_sym___alignof__] = ACTIONS(2691),
    [anon_sym___alignof] = ACTIONS(2691),
    [anon_sym__alignof] = ACTIONS(2691),
    [anon_sym_alignof] = ACTIONS(2691),
    [anon_sym__Alignof] = ACTIONS(2691),
    [anon_sym_offsetof] = ACTIONS(2691),
    [anon_sym__Generic] = ACTIONS(2691),
    [anon_sym_asm] = ACTIONS(2691),
    [anon_sym___asm__] = ACTIONS(2691),
    [aux_sym_number_literal_token1] = ACTIONS(2693),
    [aux_sym_number_literal_token2] = ACTIONS(2691),
    [anon_sym_L_SQUOTE] = ACTIONS(2693),
    [anon_sym_u_SQUOTE] = ACTIONS(2693),
    [anon_sym_U_SQUOTE] = ACTIONS(2693),
    [anon_sym_u8_SQUOTE] = ACTIONS(2693),
    [anon_sym_SQUOTE] = ACTIONS(2693),
    [anon_sym_L_DQUOTE] = ACTIONS(2693),
    [anon_sym_u_DQUOTE] = ACTIONS(2693),
    [anon_sym_U_DQUOTE] = ACTIONS(2693),
    [anon_sym_u8_DQUOTE] = ACTIONS(2693),
    [anon_sym_DQUOTE] = ACTIONS(2693),
    [sym_true] = ACTIONS(2691),
    [sym_false] = ACTIONS(2691),
    [anon_sym_NULL] = ACTIONS(2691),
    [anon_sym_nullptr] = ACTIONS(2691),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2691),
    [anon_sym_decltype] = ACTIONS(2691),
    [anon_sym_virtual] = ACTIONS(2691),
    [anon_sym_alignas] = ACTIONS(2691),
    [anon_sym_typename] = ACTIONS(2691),
    [anon_sym_template] = ACTIONS(2691),
    [anon_sym_try] = ACTIONS(2691),
    [anon_sym_delete] = ACTIONS(2691),
    [anon_sym_throw] = ACTIONS(2691),
    [anon_sym_co_return] = ACTIONS(2691),
    [anon_sym_co_yield] = ACTIONS(2691),
    [anon_sym_R_DQUOTE] = ACTIONS(2693),
    [anon_sym_LR_DQUOTE] = ACTIONS(2693),
    [anon_sym_uR_DQUOTE] = ACTIONS(2693),
    [anon_sym_UR_DQUOTE] = ACTIONS(2693),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2693),
    [anon_sym_co_await] = ACTIONS(2691),
    [anon_sym_new] = ACTIONS(2691),
    [anon_sym_requires] = ACTIONS(2691),
    [sym_this] = ACTIONS(2691),
  },
  [1036] = {
    [sym_identifier] = ACTIONS(2687),
    [anon_sym_LPAREN2] = ACTIONS(2689),
    [anon_sym_BANG] = ACTIONS(2689),
    [anon_sym_TILDE] = ACTIONS(2689),
    [anon_sym_DASH] = ACTIONS(2687),
    [anon_sym_PLUS] = ACTIONS(2687),
    [anon_sym_STAR] = ACTIONS(2689),
    [anon_sym_AMP] = ACTIONS(2689),
    [anon_sym_SEMI] = ACTIONS(2689),
    [anon_sym___extension__] = ACTIONS(2687),
    [anon_sym_typedef] = ACTIONS(2687),
    [anon_sym_extern] = ACTIONS(2687),
    [anon_sym___attribute__] = ACTIONS(2687),
    [anon_sym_COLON_COLON] = ACTIONS(2689),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2689),
    [anon_sym___declspec] = ACTIONS(2687),
    [anon_sym_LBRACE] = ACTIONS(2689),
    [anon_sym_signed] = ACTIONS(2687),
    [anon_sym_unsigned] = ACTIONS(2687),
    [anon_sym_long] = ACTIONS(2687),
    [anon_sym_short] = ACTIONS(2687),
    [anon_sym_LBRACK] = ACTIONS(2687),
    [anon_sym_static] = ACTIONS(2687),
    [anon_sym_register] = ACTIONS(2687),
    [anon_sym_inline] = ACTIONS(2687),
    [anon_sym___inline] = ACTIONS(2687),
    [anon_sym___inline__] = ACTIONS(2687),
    [anon_sym___forceinline] = ACTIONS(2687),
    [anon_sym_thread_local] = ACTIONS(2687),
    [anon_sym___thread] = ACTIONS(2687),
    [anon_sym_const] = ACTIONS(2687),
    [anon_sym_constexpr] = ACTIONS(2687),
    [anon_sym_volatile] = ACTIONS(2687),
    [anon_sym_restrict] = ACTIONS(2687),
    [anon_sym___restrict__] = ACTIONS(2687),
    [anon_sym__Atomic] = ACTIONS(2687),
    [anon_sym__Noreturn] = ACTIONS(2687),
    [anon_sym_noreturn] = ACTIONS(2687),
    [anon_sym_mutable] = ACTIONS(2687),
    [anon_sym_constinit] = ACTIONS(2687),
    [anon_sym_consteval] = ACTIONS(2687),
    [anon_sym_PROGMEM] = ACTIONS(2687),
    [aux_sym_primitive_type_token1] = ACTIONS(2687),
    [anon_sym_byte] = ACTIONS(2687),
    [anon_sym_word] = ACTIONS(2687),
    [anon_sym_enum] = ACTIONS(2687),
    [anon_sym_class] = ACTIONS(2687),
    [anon_sym_struct] = ACTIONS(2687),
    [anon_sym_union] = ACTIONS(2687),
    [anon_sym_if] = ACTIONS(2687),
    [anon_sym_else] = ACTIONS(2687),
    [anon_sym_switch] = ACTIONS(2687),
    [anon_sym_while] = ACTIONS(2687),
    [anon_sym_do] = ACTIONS(2687),
    [anon_sym_for] = ACTIONS(2687),
    [anon_sym_return] = ACTIONS(2687),
    [anon_sym_break] = ACTIONS(2687),
    [anon_sym_continue] = ACTIONS(2687),
    [anon_sym_goto] = ACTIONS(2687),
    [anon_sym___try] = ACTIONS(2687),
    [anon_sym___leave] = ACTIONS(2687),
    [anon_sym_not] = ACTIONS(2687),
    [anon_sym_compl] = ACTIONS(2687),
    [anon_sym_DASH_DASH] = ACTIONS(2689),
    [anon_sym_PLUS_PLUS] = ACTIONS(2689),
    [anon_sym_sizeof] = ACTIONS(2687),
    [anon_sym___alignof__] = ACTIONS(2687),
    [anon_sym___alignof] = ACTIONS(2687),
    [anon_sym__alignof] = ACTIONS(2687),
    [anon_sym_alignof] = ACTIONS(2687),
    [anon_sym__Alignof] = ACTIONS(2687),
    [anon_sym_offsetof] = ACTIONS(2687),
    [anon_sym__Generic] = ACTIONS(2687),
    [anon_sym_asm] = ACTIONS(2687),
    [anon_sym___asm__] = ACTIONS(2687),
    [aux_sym_number_literal_token1] = ACTIONS(2689),
    [aux_sym_number_literal_token2] = ACTIONS(2687),
    [anon_sym_L_SQUOTE] = ACTIONS(2689),
    [anon_sym_u_SQUOTE] = ACTIONS(2689),
    [anon_sym_U_SQUOTE] = ACTIONS(2689),
    [anon_sym_u8_SQUOTE] = ACTIONS(2689),
    [anon_sym_SQUOTE] = ACTIONS(2689),
    [anon_sym_L_DQUOTE] = ACTIONS(2689),
    [anon_sym_u_DQUOTE] = ACTIONS(2689),
    [anon_sym_U_DQUOTE] = ACTIONS(2689),
    [anon_sym_u8_DQUOTE] = ACTIONS(2689),
    [anon_sym_DQUOTE] = ACTIONS(2689),
    [sym_true] = ACTIONS(2687),
    [sym_false] = ACTIONS(2687),
    [anon_sym_NULL] = ACTIONS(2687),
    [anon_sym_nullptr] = ACTIONS(2687),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2687),
    [anon_sym_decltype] = ACTIONS(2687),
    [anon_sym_virtual] = ACTIONS(2687),
    [anon_sym_alignas] = ACTIONS(2687),
    [anon_sym_typename] = ACTIONS(2687),
    [anon_sym_template] = ACTIONS(2687),
    [anon_sym_try] = ACTIONS(2687),
    [anon_sym_delete] = ACTIONS(2687),
    [anon_sym_throw] = ACTIONS(2687),
    [anon_sym_co_return] = ACTIONS(2687),
    [anon_sym_co_yield] = ACTIONS(2687),
    [anon_sym_R_DQUOTE] = ACTIONS(2689),
    [anon_sym_LR_DQUOTE] = ACTIONS(2689),
    [anon_sym_uR_DQUOTE] = ACTIONS(2689),
    [anon_sym_UR_DQUOTE] = ACTIONS(2689),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2689),
    [anon_sym_co_await] = ACTIONS(2687),
    [anon_sym_new] = ACTIONS(2687),
    [anon_sym_requires] = ACTIONS(2687),
    [sym_this] = ACTIONS(2687),
  },
  [1037] = {
    [sym_identifier] = ACTIONS(3646),
    [anon_sym_LPAREN2] = ACTIONS(3648),
    [anon_sym_BANG] = ACTIONS(3648),
    [anon_sym_TILDE] = ACTIONS(3648),
    [anon_sym_DASH] = ACTIONS(3646),
    [anon_sym_PLUS] = ACTIONS(3646),
    [anon_sym_STAR] = ACTIONS(3648),
    [anon_sym_AMP] = ACTIONS(3648),
    [anon_sym_SEMI] = ACTIONS(3648),
    [anon_sym___extension__] = ACTIONS(3646),
    [anon_sym_extern] = ACTIONS(3646),
    [anon_sym___attribute__] = ACTIONS(3646),
    [anon_sym_COLON_COLON] = ACTIONS(3648),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3648),
    [anon_sym___declspec] = ACTIONS(3646),
    [anon_sym_LBRACE] = ACTIONS(3648),
    [anon_sym_signed] = ACTIONS(3646),
    [anon_sym_unsigned] = ACTIONS(3646),
    [anon_sym_long] = ACTIONS(3646),
    [anon_sym_short] = ACTIONS(3646),
    [anon_sym_LBRACK] = ACTIONS(3646),
    [anon_sym_static] = ACTIONS(3646),
    [anon_sym_register] = ACTIONS(3646),
    [anon_sym_inline] = ACTIONS(3646),
    [anon_sym___inline] = ACTIONS(3646),
    [anon_sym___inline__] = ACTIONS(3646),
    [anon_sym___forceinline] = ACTIONS(3646),
    [anon_sym_thread_local] = ACTIONS(3646),
    [anon_sym___thread] = ACTIONS(3646),
    [anon_sym_const] = ACTIONS(3646),
    [anon_sym_constexpr] = ACTIONS(3646),
    [anon_sym_volatile] = ACTIONS(3646),
    [anon_sym_restrict] = ACTIONS(3646),
    [anon_sym___restrict__] = ACTIONS(3646),
    [anon_sym__Atomic] = ACTIONS(3646),
    [anon_sym__Noreturn] = ACTIONS(3646),
    [anon_sym_noreturn] = ACTIONS(3646),
    [anon_sym_mutable] = ACTIONS(3646),
    [anon_sym_constinit] = ACTIONS(3646),
    [anon_sym_consteval] = ACTIONS(3646),
    [anon_sym_PROGMEM] = ACTIONS(3646),
    [aux_sym_primitive_type_token1] = ACTIONS(3646),
    [anon_sym_byte] = ACTIONS(3646),
    [anon_sym_word] = ACTIONS(3646),
    [anon_sym_enum] = ACTIONS(3646),
    [anon_sym_class] = ACTIONS(3646),
    [anon_sym_struct] = ACTIONS(3646),
    [anon_sym_union] = ACTIONS(3646),
    [anon_sym_if] = ACTIONS(3646),
    [anon_sym_switch] = ACTIONS(3646),
    [anon_sym_case] = ACTIONS(3646),
    [anon_sym_default] = ACTIONS(3646),
    [anon_sym_while] = ACTIONS(3646),
    [anon_sym_do] = ACTIONS(3646),
    [anon_sym_for] = ACTIONS(3646),
    [anon_sym_return] = ACTIONS(3646),
    [anon_sym_break] = ACTIONS(3646),
    [anon_sym_continue] = ACTIONS(3646),
    [anon_sym_goto] = ACTIONS(3646),
    [anon_sym___try] = ACTIONS(3646),
    [anon_sym___leave] = ACTIONS(3646),
    [anon_sym_not] = ACTIONS(3646),
    [anon_sym_compl] = ACTIONS(3646),
    [anon_sym_DASH_DASH] = ACTIONS(3648),
    [anon_sym_PLUS_PLUS] = ACTIONS(3648),
    [anon_sym_sizeof] = ACTIONS(3646),
    [anon_sym___alignof__] = ACTIONS(3646),
    [anon_sym___alignof] = ACTIONS(3646),
    [anon_sym__alignof] = ACTIONS(3646),
    [anon_sym_alignof] = ACTIONS(3646),
    [anon_sym__Alignof] = ACTIONS(3646),
    [anon_sym_offsetof] = ACTIONS(3646),
    [anon_sym__Generic] = ACTIONS(3646),
    [anon_sym_asm] = ACTIONS(3646),
    [anon_sym___asm__] = ACTIONS(3646),
    [aux_sym_number_literal_token1] = ACTIONS(3648),
    [aux_sym_number_literal_token2] = ACTIONS(3646),
    [anon_sym_L_SQUOTE] = ACTIONS(3648),
    [anon_sym_u_SQUOTE] = ACTIONS(3648),
    [anon_sym_U_SQUOTE] = ACTIONS(3648),
    [anon_sym_u8_SQUOTE] = ACTIONS(3648),
    [anon_sym_SQUOTE] = ACTIONS(3648),
    [anon_sym_L_DQUOTE] = ACTIONS(3648),
    [anon_sym_u_DQUOTE] = ACTIONS(3648),
    [anon_sym_U_DQUOTE] = ACTIONS(3648),
    [anon_sym_u8_DQUOTE] = ACTIONS(3648),
    [anon_sym_DQUOTE] = ACTIONS(3648),
    [sym_true] = ACTIONS(3646),
    [sym_false] = ACTIONS(3646),
    [anon_sym_NULL] = ACTIONS(3646),
    [anon_sym_nullptr] = ACTIONS(3646),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3646),
    [anon_sym_decltype] = ACTIONS(3646),
    [anon_sym_virtual] = ACTIONS(3646),
    [anon_sym_alignas] = ACTIONS(3646),
    [anon_sym_typename] = ACTIONS(3646),
    [anon_sym_template] = ACTIONS(3646),
    [anon_sym_try] = ACTIONS(3646),
    [anon_sym_delete] = ACTIONS(3646),
    [anon_sym_throw] = ACTIONS(3646),
    [anon_sym_co_return] = ACTIONS(3646),
    [anon_sym_co_yield] = ACTIONS(3646),
    [anon_sym_R_DQUOTE] = ACTIONS(3648),
    [anon_sym_LR_DQUOTE] = ACTIONS(3648),
    [anon_sym_uR_DQUOTE] = ACTIONS(3648),
    [anon_sym_UR_DQUOTE] = ACTIONS(3648),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3648),
    [anon_sym_co_await] = ACTIONS(3646),
    [anon_sym_new] = ACTIONS(3646),
    [anon_sym_requires] = ACTIONS(3646),
    [sym_this] = ACTIONS(3646),
  },
  [1038] = {
    [sym_string_literal] = STATE(2617),
    [sym_template_argument_list] = STATE(1740),
    [sym_raw_string_literal] = STATE(2617),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2716),
    [sym_identifier] = ACTIONS(3759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3761),
    [anon_sym_COMMA] = ACTIONS(3761),
    [anon_sym_LPAREN2] = ACTIONS(3763),
    [anon_sym_TILDE] = ACTIONS(3767),
    [anon_sym_DASH] = ACTIONS(3769),
    [anon_sym_PLUS] = ACTIONS(3769),
    [anon_sym_STAR] = ACTIONS(3771),
    [anon_sym_SLASH] = ACTIONS(3769),
    [anon_sym_PERCENT] = ACTIONS(3769),
    [anon_sym_PIPE_PIPE] = ACTIONS(3761),
    [anon_sym_AMP_AMP] = ACTIONS(3774),
    [anon_sym_PIPE] = ACTIONS(3769),
    [anon_sym_CARET] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(3771),
    [anon_sym_EQ_EQ] = ACTIONS(3761),
    [anon_sym_BANG_EQ] = ACTIONS(3761),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3761),
    [anon_sym_LT_EQ] = ACTIONS(3769),
    [anon_sym_LT] = ACTIONS(3777),
    [anon_sym_LT_LT] = ACTIONS(3769),
    [anon_sym_GT_GT] = ACTIONS(3769),
    [anon_sym_SEMI] = ACTIONS(3774),
    [anon_sym___extension__] = ACTIONS(3759),
    [anon_sym_extern] = ACTIONS(3759),
    [anon_sym___attribute__] = ACTIONS(3759),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3782),
    [anon_sym___declspec] = ACTIONS(3759),
    [anon_sym___based] = ACTIONS(3759),
    [anon_sym___cdecl] = ACTIONS(3759),
    [anon_sym___clrcall] = ACTIONS(3759),
    [anon_sym___stdcall] = ACTIONS(3759),
    [anon_sym___fastcall] = ACTIONS(3759),
    [anon_sym___thiscall] = ACTIONS(3759),
    [anon_sym___vectorcall] = ACTIONS(3759),
    [anon_sym_LBRACE] = ACTIONS(3785),
    [anon_sym_signed] = ACTIONS(3787),
    [anon_sym_unsigned] = ACTIONS(3787),
    [anon_sym_long] = ACTIONS(3787),
    [anon_sym_short] = ACTIONS(3787),
    [anon_sym_LBRACK] = ACTIONS(3789),
    [anon_sym_EQ] = ACTIONS(3793),
    [anon_sym_static] = ACTIONS(3759),
    [anon_sym_register] = ACTIONS(3759),
    [anon_sym_inline] = ACTIONS(3759),
    [anon_sym___inline] = ACTIONS(3759),
    [anon_sym___inline__] = ACTIONS(3759),
    [anon_sym___forceinline] = ACTIONS(3759),
    [anon_sym_thread_local] = ACTIONS(3759),
    [anon_sym___thread] = ACTIONS(3759),
    [anon_sym_const] = ACTIONS(3759),
    [anon_sym_constexpr] = ACTIONS(3759),
    [anon_sym_volatile] = ACTIONS(3759),
    [anon_sym_restrict] = ACTIONS(3759),
    [anon_sym___restrict__] = ACTIONS(3759),
    [anon_sym__Atomic] = ACTIONS(3759),
    [anon_sym__Noreturn] = ACTIONS(3759),
    [anon_sym_noreturn] = ACTIONS(3759),
    [anon_sym_mutable] = ACTIONS(3759),
    [anon_sym_constinit] = ACTIONS(3759),
    [anon_sym_consteval] = ACTIONS(3759),
    [anon_sym_PROGMEM] = ACTIONS(3759),
    [anon_sym_COLON] = ACTIONS(3819),
    [anon_sym_QMARK] = ACTIONS(3761),
    [anon_sym_STAR_EQ] = ACTIONS(3797),
    [anon_sym_SLASH_EQ] = ACTIONS(3797),
    [anon_sym_PERCENT_EQ] = ACTIONS(3797),
    [anon_sym_PLUS_EQ] = ACTIONS(3797),
    [anon_sym_DASH_EQ] = ACTIONS(3797),
    [anon_sym_LT_LT_EQ] = ACTIONS(3797),
    [anon_sym_GT_GT_EQ] = ACTIONS(3797),
    [anon_sym_AMP_EQ] = ACTIONS(3797),
    [anon_sym_CARET_EQ] = ACTIONS(3797),
    [anon_sym_PIPE_EQ] = ACTIONS(3797),
    [anon_sym_and_eq] = ACTIONS(3793),
    [anon_sym_or_eq] = ACTIONS(3793),
    [anon_sym_xor_eq] = ACTIONS(3793),
    [anon_sym_LT_EQ_GT] = ACTIONS(3761),
    [anon_sym_or] = ACTIONS(3769),
    [anon_sym_and] = ACTIONS(3769),
    [anon_sym_bitor] = ACTIONS(3769),
    [anon_sym_xor] = ACTIONS(3769),
    [anon_sym_bitand] = ACTIONS(3769),
    [anon_sym_not_eq] = ACTIONS(3769),
    [anon_sym_DASH_DASH] = ACTIONS(3761),
    [anon_sym_PLUS_PLUS] = ACTIONS(3761),
    [anon_sym_DOT] = ACTIONS(3769),
    [anon_sym_DOT_STAR] = ACTIONS(3761),
    [anon_sym_DASH_GT] = ACTIONS(3761),
    [anon_sym_L_DQUOTE] = ACTIONS(3204),
    [anon_sym_u_DQUOTE] = ACTIONS(3204),
    [anon_sym_U_DQUOTE] = ACTIONS(3204),
    [anon_sym_u8_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3204),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3759),
    [anon_sym_decltype] = ACTIONS(3759),
    [anon_sym_virtual] = ACTIONS(3759),
    [anon_sym_alignas] = ACTIONS(3759),
    [anon_sym_template] = ACTIONS(3759),
    [anon_sym_operator] = ACTIONS(3759),
    [anon_sym_R_DQUOTE] = ACTIONS(3208),
    [anon_sym_LR_DQUOTE] = ACTIONS(3208),
    [anon_sym_uR_DQUOTE] = ACTIONS(3208),
    [anon_sym_UR_DQUOTE] = ACTIONS(3208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3208),
  },
  [1039] = {
    [sym_identifier] = ACTIONS(2675),
    [anon_sym_LPAREN2] = ACTIONS(2677),
    [anon_sym_BANG] = ACTIONS(2677),
    [anon_sym_TILDE] = ACTIONS(2677),
    [anon_sym_DASH] = ACTIONS(2675),
    [anon_sym_PLUS] = ACTIONS(2675),
    [anon_sym_STAR] = ACTIONS(2677),
    [anon_sym_AMP] = ACTIONS(2677),
    [anon_sym_SEMI] = ACTIONS(2677),
    [anon_sym___extension__] = ACTIONS(2675),
    [anon_sym_typedef] = ACTIONS(2675),
    [anon_sym_extern] = ACTIONS(2675),
    [anon_sym___attribute__] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(2677),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2677),
    [anon_sym___declspec] = ACTIONS(2675),
    [anon_sym_LBRACE] = ACTIONS(2677),
    [anon_sym_signed] = ACTIONS(2675),
    [anon_sym_unsigned] = ACTIONS(2675),
    [anon_sym_long] = ACTIONS(2675),
    [anon_sym_short] = ACTIONS(2675),
    [anon_sym_LBRACK] = ACTIONS(2675),
    [anon_sym_static] = ACTIONS(2675),
    [anon_sym_register] = ACTIONS(2675),
    [anon_sym_inline] = ACTIONS(2675),
    [anon_sym___inline] = ACTIONS(2675),
    [anon_sym___inline__] = ACTIONS(2675),
    [anon_sym___forceinline] = ACTIONS(2675),
    [anon_sym_thread_local] = ACTIONS(2675),
    [anon_sym___thread] = ACTIONS(2675),
    [anon_sym_const] = ACTIONS(2675),
    [anon_sym_constexpr] = ACTIONS(2675),
    [anon_sym_volatile] = ACTIONS(2675),
    [anon_sym_restrict] = ACTIONS(2675),
    [anon_sym___restrict__] = ACTIONS(2675),
    [anon_sym__Atomic] = ACTIONS(2675),
    [anon_sym__Noreturn] = ACTIONS(2675),
    [anon_sym_noreturn] = ACTIONS(2675),
    [anon_sym_mutable] = ACTIONS(2675),
    [anon_sym_constinit] = ACTIONS(2675),
    [anon_sym_consteval] = ACTIONS(2675),
    [anon_sym_PROGMEM] = ACTIONS(2675),
    [aux_sym_primitive_type_token1] = ACTIONS(2675),
    [anon_sym_byte] = ACTIONS(2675),
    [anon_sym_word] = ACTIONS(2675),
    [anon_sym_enum] = ACTIONS(2675),
    [anon_sym_class] = ACTIONS(2675),
    [anon_sym_struct] = ACTIONS(2675),
    [anon_sym_union] = ACTIONS(2675),
    [anon_sym_if] = ACTIONS(2675),
    [anon_sym_else] = ACTIONS(2675),
    [anon_sym_switch] = ACTIONS(2675),
    [anon_sym_while] = ACTIONS(2675),
    [anon_sym_do] = ACTIONS(2675),
    [anon_sym_for] = ACTIONS(2675),
    [anon_sym_return] = ACTIONS(2675),
    [anon_sym_break] = ACTIONS(2675),
    [anon_sym_continue] = ACTIONS(2675),
    [anon_sym_goto] = ACTIONS(2675),
    [anon_sym___try] = ACTIONS(2675),
    [anon_sym___leave] = ACTIONS(2675),
    [anon_sym_not] = ACTIONS(2675),
    [anon_sym_compl] = ACTIONS(2675),
    [anon_sym_DASH_DASH] = ACTIONS(2677),
    [anon_sym_PLUS_PLUS] = ACTIONS(2677),
    [anon_sym_sizeof] = ACTIONS(2675),
    [anon_sym___alignof__] = ACTIONS(2675),
    [anon_sym___alignof] = ACTIONS(2675),
    [anon_sym__alignof] = ACTIONS(2675),
    [anon_sym_alignof] = ACTIONS(2675),
    [anon_sym__Alignof] = ACTIONS(2675),
    [anon_sym_offsetof] = ACTIONS(2675),
    [anon_sym__Generic] = ACTIONS(2675),
    [anon_sym_asm] = ACTIONS(2675),
    [anon_sym___asm__] = ACTIONS(2675),
    [aux_sym_number_literal_token1] = ACTIONS(2677),
    [aux_sym_number_literal_token2] = ACTIONS(2675),
    [anon_sym_L_SQUOTE] = ACTIONS(2677),
    [anon_sym_u_SQUOTE] = ACTIONS(2677),
    [anon_sym_U_SQUOTE] = ACTIONS(2677),
    [anon_sym_u8_SQUOTE] = ACTIONS(2677),
    [anon_sym_SQUOTE] = ACTIONS(2677),
    [anon_sym_L_DQUOTE] = ACTIONS(2677),
    [anon_sym_u_DQUOTE] = ACTIONS(2677),
    [anon_sym_U_DQUOTE] = ACTIONS(2677),
    [anon_sym_u8_DQUOTE] = ACTIONS(2677),
    [anon_sym_DQUOTE] = ACTIONS(2677),
    [sym_true] = ACTIONS(2675),
    [sym_false] = ACTIONS(2675),
    [anon_sym_NULL] = ACTIONS(2675),
    [anon_sym_nullptr] = ACTIONS(2675),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2675),
    [anon_sym_decltype] = ACTIONS(2675),
    [anon_sym_virtual] = ACTIONS(2675),
    [anon_sym_alignas] = ACTIONS(2675),
    [anon_sym_typename] = ACTIONS(2675),
    [anon_sym_template] = ACTIONS(2675),
    [anon_sym_try] = ACTIONS(2675),
    [anon_sym_delete] = ACTIONS(2675),
    [anon_sym_throw] = ACTIONS(2675),
    [anon_sym_co_return] = ACTIONS(2675),
    [anon_sym_co_yield] = ACTIONS(2675),
    [anon_sym_R_DQUOTE] = ACTIONS(2677),
    [anon_sym_LR_DQUOTE] = ACTIONS(2677),
    [anon_sym_uR_DQUOTE] = ACTIONS(2677),
    [anon_sym_UR_DQUOTE] = ACTIONS(2677),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2677),
    [anon_sym_co_await] = ACTIONS(2675),
    [anon_sym_new] = ACTIONS(2675),
    [anon_sym_requires] = ACTIONS(2675),
    [sym_this] = ACTIONS(2675),
  },
  [1040] = {
    [sym_identifier] = ACTIONS(2669),
    [anon_sym_LPAREN2] = ACTIONS(2671),
    [anon_sym_BANG] = ACTIONS(2671),
    [anon_sym_TILDE] = ACTIONS(2671),
    [anon_sym_DASH] = ACTIONS(2669),
    [anon_sym_PLUS] = ACTIONS(2669),
    [anon_sym_STAR] = ACTIONS(2671),
    [anon_sym_AMP] = ACTIONS(2671),
    [anon_sym_SEMI] = ACTIONS(2671),
    [anon_sym___extension__] = ACTIONS(2669),
    [anon_sym_typedef] = ACTIONS(2669),
    [anon_sym_extern] = ACTIONS(2669),
    [anon_sym___attribute__] = ACTIONS(2669),
    [anon_sym_COLON_COLON] = ACTIONS(2671),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2671),
    [anon_sym___declspec] = ACTIONS(2669),
    [anon_sym_LBRACE] = ACTIONS(2671),
    [anon_sym_signed] = ACTIONS(2669),
    [anon_sym_unsigned] = ACTIONS(2669),
    [anon_sym_long] = ACTIONS(2669),
    [anon_sym_short] = ACTIONS(2669),
    [anon_sym_LBRACK] = ACTIONS(2669),
    [anon_sym_static] = ACTIONS(2669),
    [anon_sym_register] = ACTIONS(2669),
    [anon_sym_inline] = ACTIONS(2669),
    [anon_sym___inline] = ACTIONS(2669),
    [anon_sym___inline__] = ACTIONS(2669),
    [anon_sym___forceinline] = ACTIONS(2669),
    [anon_sym_thread_local] = ACTIONS(2669),
    [anon_sym___thread] = ACTIONS(2669),
    [anon_sym_const] = ACTIONS(2669),
    [anon_sym_constexpr] = ACTIONS(2669),
    [anon_sym_volatile] = ACTIONS(2669),
    [anon_sym_restrict] = ACTIONS(2669),
    [anon_sym___restrict__] = ACTIONS(2669),
    [anon_sym__Atomic] = ACTIONS(2669),
    [anon_sym__Noreturn] = ACTIONS(2669),
    [anon_sym_noreturn] = ACTIONS(2669),
    [anon_sym_mutable] = ACTIONS(2669),
    [anon_sym_constinit] = ACTIONS(2669),
    [anon_sym_consteval] = ACTIONS(2669),
    [anon_sym_PROGMEM] = ACTIONS(2669),
    [aux_sym_primitive_type_token1] = ACTIONS(2669),
    [anon_sym_byte] = ACTIONS(2669),
    [anon_sym_word] = ACTIONS(2669),
    [anon_sym_enum] = ACTIONS(2669),
    [anon_sym_class] = ACTIONS(2669),
    [anon_sym_struct] = ACTIONS(2669),
    [anon_sym_union] = ACTIONS(2669),
    [anon_sym_if] = ACTIONS(2669),
    [anon_sym_else] = ACTIONS(2669),
    [anon_sym_switch] = ACTIONS(2669),
    [anon_sym_while] = ACTIONS(2669),
    [anon_sym_do] = ACTIONS(2669),
    [anon_sym_for] = ACTIONS(2669),
    [anon_sym_return] = ACTIONS(2669),
    [anon_sym_break] = ACTIONS(2669),
    [anon_sym_continue] = ACTIONS(2669),
    [anon_sym_goto] = ACTIONS(2669),
    [anon_sym___try] = ACTIONS(2669),
    [anon_sym___leave] = ACTIONS(2669),
    [anon_sym_not] = ACTIONS(2669),
    [anon_sym_compl] = ACTIONS(2669),
    [anon_sym_DASH_DASH] = ACTIONS(2671),
    [anon_sym_PLUS_PLUS] = ACTIONS(2671),
    [anon_sym_sizeof] = ACTIONS(2669),
    [anon_sym___alignof__] = ACTIONS(2669),
    [anon_sym___alignof] = ACTIONS(2669),
    [anon_sym__alignof] = ACTIONS(2669),
    [anon_sym_alignof] = ACTIONS(2669),
    [anon_sym__Alignof] = ACTIONS(2669),
    [anon_sym_offsetof] = ACTIONS(2669),
    [anon_sym__Generic] = ACTIONS(2669),
    [anon_sym_asm] = ACTIONS(2669),
    [anon_sym___asm__] = ACTIONS(2669),
    [aux_sym_number_literal_token1] = ACTIONS(2671),
    [aux_sym_number_literal_token2] = ACTIONS(2669),
    [anon_sym_L_SQUOTE] = ACTIONS(2671),
    [anon_sym_u_SQUOTE] = ACTIONS(2671),
    [anon_sym_U_SQUOTE] = ACTIONS(2671),
    [anon_sym_u8_SQUOTE] = ACTIONS(2671),
    [anon_sym_SQUOTE] = ACTIONS(2671),
    [anon_sym_L_DQUOTE] = ACTIONS(2671),
    [anon_sym_u_DQUOTE] = ACTIONS(2671),
    [anon_sym_U_DQUOTE] = ACTIONS(2671),
    [anon_sym_u8_DQUOTE] = ACTIONS(2671),
    [anon_sym_DQUOTE] = ACTIONS(2671),
    [sym_true] = ACTIONS(2669),
    [sym_false] = ACTIONS(2669),
    [anon_sym_NULL] = ACTIONS(2669),
    [anon_sym_nullptr] = ACTIONS(2669),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2669),
    [anon_sym_decltype] = ACTIONS(2669),
    [anon_sym_virtual] = ACTIONS(2669),
    [anon_sym_alignas] = ACTIONS(2669),
    [anon_sym_typename] = ACTIONS(2669),
    [anon_sym_template] = ACTIONS(2669),
    [anon_sym_try] = ACTIONS(2669),
    [anon_sym_delete] = ACTIONS(2669),
    [anon_sym_throw] = ACTIONS(2669),
    [anon_sym_co_return] = ACTIONS(2669),
    [anon_sym_co_yield] = ACTIONS(2669),
    [anon_sym_R_DQUOTE] = ACTIONS(2671),
    [anon_sym_LR_DQUOTE] = ACTIONS(2671),
    [anon_sym_uR_DQUOTE] = ACTIONS(2671),
    [anon_sym_UR_DQUOTE] = ACTIONS(2671),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2671),
    [anon_sym_co_await] = ACTIONS(2669),
    [anon_sym_new] = ACTIONS(2669),
    [anon_sym_requires] = ACTIONS(2669),
    [sym_this] = ACTIONS(2669),
  },
  [1041] = {
    [sym_identifier] = ACTIONS(2661),
    [anon_sym_LPAREN2] = ACTIONS(2663),
    [anon_sym_BANG] = ACTIONS(2663),
    [anon_sym_TILDE] = ACTIONS(2663),
    [anon_sym_DASH] = ACTIONS(2661),
    [anon_sym_PLUS] = ACTIONS(2661),
    [anon_sym_STAR] = ACTIONS(2663),
    [anon_sym_AMP] = ACTIONS(2663),
    [anon_sym_SEMI] = ACTIONS(2663),
    [anon_sym___extension__] = ACTIONS(2661),
    [anon_sym_typedef] = ACTIONS(2661),
    [anon_sym_extern] = ACTIONS(2661),
    [anon_sym___attribute__] = ACTIONS(2661),
    [anon_sym_COLON_COLON] = ACTIONS(2663),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2663),
    [anon_sym___declspec] = ACTIONS(2661),
    [anon_sym_LBRACE] = ACTIONS(2663),
    [anon_sym_signed] = ACTIONS(2661),
    [anon_sym_unsigned] = ACTIONS(2661),
    [anon_sym_long] = ACTIONS(2661),
    [anon_sym_short] = ACTIONS(2661),
    [anon_sym_LBRACK] = ACTIONS(2661),
    [anon_sym_static] = ACTIONS(2661),
    [anon_sym_register] = ACTIONS(2661),
    [anon_sym_inline] = ACTIONS(2661),
    [anon_sym___inline] = ACTIONS(2661),
    [anon_sym___inline__] = ACTIONS(2661),
    [anon_sym___forceinline] = ACTIONS(2661),
    [anon_sym_thread_local] = ACTIONS(2661),
    [anon_sym___thread] = ACTIONS(2661),
    [anon_sym_const] = ACTIONS(2661),
    [anon_sym_constexpr] = ACTIONS(2661),
    [anon_sym_volatile] = ACTIONS(2661),
    [anon_sym_restrict] = ACTIONS(2661),
    [anon_sym___restrict__] = ACTIONS(2661),
    [anon_sym__Atomic] = ACTIONS(2661),
    [anon_sym__Noreturn] = ACTIONS(2661),
    [anon_sym_noreturn] = ACTIONS(2661),
    [anon_sym_mutable] = ACTIONS(2661),
    [anon_sym_constinit] = ACTIONS(2661),
    [anon_sym_consteval] = ACTIONS(2661),
    [anon_sym_PROGMEM] = ACTIONS(2661),
    [aux_sym_primitive_type_token1] = ACTIONS(2661),
    [anon_sym_byte] = ACTIONS(2661),
    [anon_sym_word] = ACTIONS(2661),
    [anon_sym_enum] = ACTIONS(2661),
    [anon_sym_class] = ACTIONS(2661),
    [anon_sym_struct] = ACTIONS(2661),
    [anon_sym_union] = ACTIONS(2661),
    [anon_sym_if] = ACTIONS(2661),
    [anon_sym_else] = ACTIONS(2661),
    [anon_sym_switch] = ACTIONS(2661),
    [anon_sym_while] = ACTIONS(2661),
    [anon_sym_do] = ACTIONS(2661),
    [anon_sym_for] = ACTIONS(2661),
    [anon_sym_return] = ACTIONS(2661),
    [anon_sym_break] = ACTIONS(2661),
    [anon_sym_continue] = ACTIONS(2661),
    [anon_sym_goto] = ACTIONS(2661),
    [anon_sym___try] = ACTIONS(2661),
    [anon_sym___leave] = ACTIONS(2661),
    [anon_sym_not] = ACTIONS(2661),
    [anon_sym_compl] = ACTIONS(2661),
    [anon_sym_DASH_DASH] = ACTIONS(2663),
    [anon_sym_PLUS_PLUS] = ACTIONS(2663),
    [anon_sym_sizeof] = ACTIONS(2661),
    [anon_sym___alignof__] = ACTIONS(2661),
    [anon_sym___alignof] = ACTIONS(2661),
    [anon_sym__alignof] = ACTIONS(2661),
    [anon_sym_alignof] = ACTIONS(2661),
    [anon_sym__Alignof] = ACTIONS(2661),
    [anon_sym_offsetof] = ACTIONS(2661),
    [anon_sym__Generic] = ACTIONS(2661),
    [anon_sym_asm] = ACTIONS(2661),
    [anon_sym___asm__] = ACTIONS(2661),
    [aux_sym_number_literal_token1] = ACTIONS(2663),
    [aux_sym_number_literal_token2] = ACTIONS(2661),
    [anon_sym_L_SQUOTE] = ACTIONS(2663),
    [anon_sym_u_SQUOTE] = ACTIONS(2663),
    [anon_sym_U_SQUOTE] = ACTIONS(2663),
    [anon_sym_u8_SQUOTE] = ACTIONS(2663),
    [anon_sym_SQUOTE] = ACTIONS(2663),
    [anon_sym_L_DQUOTE] = ACTIONS(2663),
    [anon_sym_u_DQUOTE] = ACTIONS(2663),
    [anon_sym_U_DQUOTE] = ACTIONS(2663),
    [anon_sym_u8_DQUOTE] = ACTIONS(2663),
    [anon_sym_DQUOTE] = ACTIONS(2663),
    [sym_true] = ACTIONS(2661),
    [sym_false] = ACTIONS(2661),
    [anon_sym_NULL] = ACTIONS(2661),
    [anon_sym_nullptr] = ACTIONS(2661),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2661),
    [anon_sym_decltype] = ACTIONS(2661),
    [anon_sym_virtual] = ACTIONS(2661),
    [anon_sym_alignas] = ACTIONS(2661),
    [anon_sym_typename] = ACTIONS(2661),
    [anon_sym_template] = ACTIONS(2661),
    [anon_sym_try] = ACTIONS(2661),
    [anon_sym_delete] = ACTIONS(2661),
    [anon_sym_throw] = ACTIONS(2661),
    [anon_sym_co_return] = ACTIONS(2661),
    [anon_sym_co_yield] = ACTIONS(2661),
    [anon_sym_R_DQUOTE] = ACTIONS(2663),
    [anon_sym_LR_DQUOTE] = ACTIONS(2663),
    [anon_sym_uR_DQUOTE] = ACTIONS(2663),
    [anon_sym_UR_DQUOTE] = ACTIONS(2663),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2663),
    [anon_sym_co_await] = ACTIONS(2661),
    [anon_sym_new] = ACTIONS(2661),
    [anon_sym_requires] = ACTIONS(2661),
    [sym_this] = ACTIONS(2661),
  },
  [1042] = {
    [sym_identifier] = ACTIONS(2657),
    [anon_sym_LPAREN2] = ACTIONS(2659),
    [anon_sym_BANG] = ACTIONS(2659),
    [anon_sym_TILDE] = ACTIONS(2659),
    [anon_sym_DASH] = ACTIONS(2657),
    [anon_sym_PLUS] = ACTIONS(2657),
    [anon_sym_STAR] = ACTIONS(2659),
    [anon_sym_AMP] = ACTIONS(2659),
    [anon_sym_SEMI] = ACTIONS(2659),
    [anon_sym___extension__] = ACTIONS(2657),
    [anon_sym_typedef] = ACTIONS(2657),
    [anon_sym_extern] = ACTIONS(2657),
    [anon_sym___attribute__] = ACTIONS(2657),
    [anon_sym_COLON_COLON] = ACTIONS(2659),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2659),
    [anon_sym___declspec] = ACTIONS(2657),
    [anon_sym_LBRACE] = ACTIONS(2659),
    [anon_sym_signed] = ACTIONS(2657),
    [anon_sym_unsigned] = ACTIONS(2657),
    [anon_sym_long] = ACTIONS(2657),
    [anon_sym_short] = ACTIONS(2657),
    [anon_sym_LBRACK] = ACTIONS(2657),
    [anon_sym_static] = ACTIONS(2657),
    [anon_sym_register] = ACTIONS(2657),
    [anon_sym_inline] = ACTIONS(2657),
    [anon_sym___inline] = ACTIONS(2657),
    [anon_sym___inline__] = ACTIONS(2657),
    [anon_sym___forceinline] = ACTIONS(2657),
    [anon_sym_thread_local] = ACTIONS(2657),
    [anon_sym___thread] = ACTIONS(2657),
    [anon_sym_const] = ACTIONS(2657),
    [anon_sym_constexpr] = ACTIONS(2657),
    [anon_sym_volatile] = ACTIONS(2657),
    [anon_sym_restrict] = ACTIONS(2657),
    [anon_sym___restrict__] = ACTIONS(2657),
    [anon_sym__Atomic] = ACTIONS(2657),
    [anon_sym__Noreturn] = ACTIONS(2657),
    [anon_sym_noreturn] = ACTIONS(2657),
    [anon_sym_mutable] = ACTIONS(2657),
    [anon_sym_constinit] = ACTIONS(2657),
    [anon_sym_consteval] = ACTIONS(2657),
    [anon_sym_PROGMEM] = ACTIONS(2657),
    [aux_sym_primitive_type_token1] = ACTIONS(2657),
    [anon_sym_byte] = ACTIONS(2657),
    [anon_sym_word] = ACTIONS(2657),
    [anon_sym_enum] = ACTIONS(2657),
    [anon_sym_class] = ACTIONS(2657),
    [anon_sym_struct] = ACTIONS(2657),
    [anon_sym_union] = ACTIONS(2657),
    [anon_sym_if] = ACTIONS(2657),
    [anon_sym_else] = ACTIONS(2657),
    [anon_sym_switch] = ACTIONS(2657),
    [anon_sym_while] = ACTIONS(2657),
    [anon_sym_do] = ACTIONS(2657),
    [anon_sym_for] = ACTIONS(2657),
    [anon_sym_return] = ACTIONS(2657),
    [anon_sym_break] = ACTIONS(2657),
    [anon_sym_continue] = ACTIONS(2657),
    [anon_sym_goto] = ACTIONS(2657),
    [anon_sym___try] = ACTIONS(2657),
    [anon_sym___leave] = ACTIONS(2657),
    [anon_sym_not] = ACTIONS(2657),
    [anon_sym_compl] = ACTIONS(2657),
    [anon_sym_DASH_DASH] = ACTIONS(2659),
    [anon_sym_PLUS_PLUS] = ACTIONS(2659),
    [anon_sym_sizeof] = ACTIONS(2657),
    [anon_sym___alignof__] = ACTIONS(2657),
    [anon_sym___alignof] = ACTIONS(2657),
    [anon_sym__alignof] = ACTIONS(2657),
    [anon_sym_alignof] = ACTIONS(2657),
    [anon_sym__Alignof] = ACTIONS(2657),
    [anon_sym_offsetof] = ACTIONS(2657),
    [anon_sym__Generic] = ACTIONS(2657),
    [anon_sym_asm] = ACTIONS(2657),
    [anon_sym___asm__] = ACTIONS(2657),
    [aux_sym_number_literal_token1] = ACTIONS(2659),
    [aux_sym_number_literal_token2] = ACTIONS(2657),
    [anon_sym_L_SQUOTE] = ACTIONS(2659),
    [anon_sym_u_SQUOTE] = ACTIONS(2659),
    [anon_sym_U_SQUOTE] = ACTIONS(2659),
    [anon_sym_u8_SQUOTE] = ACTIONS(2659),
    [anon_sym_SQUOTE] = ACTIONS(2659),
    [anon_sym_L_DQUOTE] = ACTIONS(2659),
    [anon_sym_u_DQUOTE] = ACTIONS(2659),
    [anon_sym_U_DQUOTE] = ACTIONS(2659),
    [anon_sym_u8_DQUOTE] = ACTIONS(2659),
    [anon_sym_DQUOTE] = ACTIONS(2659),
    [sym_true] = ACTIONS(2657),
    [sym_false] = ACTIONS(2657),
    [anon_sym_NULL] = ACTIONS(2657),
    [anon_sym_nullptr] = ACTIONS(2657),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2657),
    [anon_sym_decltype] = ACTIONS(2657),
    [anon_sym_virtual] = ACTIONS(2657),
    [anon_sym_alignas] = ACTIONS(2657),
    [anon_sym_typename] = ACTIONS(2657),
    [anon_sym_template] = ACTIONS(2657),
    [anon_sym_try] = ACTIONS(2657),
    [anon_sym_delete] = ACTIONS(2657),
    [anon_sym_throw] = ACTIONS(2657),
    [anon_sym_co_return] = ACTIONS(2657),
    [anon_sym_co_yield] = ACTIONS(2657),
    [anon_sym_R_DQUOTE] = ACTIONS(2659),
    [anon_sym_LR_DQUOTE] = ACTIONS(2659),
    [anon_sym_uR_DQUOTE] = ACTIONS(2659),
    [anon_sym_UR_DQUOTE] = ACTIONS(2659),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2659),
    [anon_sym_co_await] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(2657),
    [anon_sym_requires] = ACTIONS(2657),
    [sym_this] = ACTIONS(2657),
  },
  [1043] = {
    [sym_identifier] = ACTIONS(2653),
    [anon_sym_LPAREN2] = ACTIONS(2655),
    [anon_sym_BANG] = ACTIONS(2655),
    [anon_sym_TILDE] = ACTIONS(2655),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_AMP] = ACTIONS(2655),
    [anon_sym_SEMI] = ACTIONS(2655),
    [anon_sym___extension__] = ACTIONS(2653),
    [anon_sym_typedef] = ACTIONS(2653),
    [anon_sym_extern] = ACTIONS(2653),
    [anon_sym___attribute__] = ACTIONS(2653),
    [anon_sym_COLON_COLON] = ACTIONS(2655),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2655),
    [anon_sym___declspec] = ACTIONS(2653),
    [anon_sym_LBRACE] = ACTIONS(2655),
    [anon_sym_signed] = ACTIONS(2653),
    [anon_sym_unsigned] = ACTIONS(2653),
    [anon_sym_long] = ACTIONS(2653),
    [anon_sym_short] = ACTIONS(2653),
    [anon_sym_LBRACK] = ACTIONS(2653),
    [anon_sym_static] = ACTIONS(2653),
    [anon_sym_register] = ACTIONS(2653),
    [anon_sym_inline] = ACTIONS(2653),
    [anon_sym___inline] = ACTIONS(2653),
    [anon_sym___inline__] = ACTIONS(2653),
    [anon_sym___forceinline] = ACTIONS(2653),
    [anon_sym_thread_local] = ACTIONS(2653),
    [anon_sym___thread] = ACTIONS(2653),
    [anon_sym_const] = ACTIONS(2653),
    [anon_sym_constexpr] = ACTIONS(2653),
    [anon_sym_volatile] = ACTIONS(2653),
    [anon_sym_restrict] = ACTIONS(2653),
    [anon_sym___restrict__] = ACTIONS(2653),
    [anon_sym__Atomic] = ACTIONS(2653),
    [anon_sym__Noreturn] = ACTIONS(2653),
    [anon_sym_noreturn] = ACTIONS(2653),
    [anon_sym_mutable] = ACTIONS(2653),
    [anon_sym_constinit] = ACTIONS(2653),
    [anon_sym_consteval] = ACTIONS(2653),
    [anon_sym_PROGMEM] = ACTIONS(2653),
    [aux_sym_primitive_type_token1] = ACTIONS(2653),
    [anon_sym_byte] = ACTIONS(2653),
    [anon_sym_word] = ACTIONS(2653),
    [anon_sym_enum] = ACTIONS(2653),
    [anon_sym_class] = ACTIONS(2653),
    [anon_sym_struct] = ACTIONS(2653),
    [anon_sym_union] = ACTIONS(2653),
    [anon_sym_if] = ACTIONS(2653),
    [anon_sym_else] = ACTIONS(2653),
    [anon_sym_switch] = ACTIONS(2653),
    [anon_sym_while] = ACTIONS(2653),
    [anon_sym_do] = ACTIONS(2653),
    [anon_sym_for] = ACTIONS(2653),
    [anon_sym_return] = ACTIONS(2653),
    [anon_sym_break] = ACTIONS(2653),
    [anon_sym_continue] = ACTIONS(2653),
    [anon_sym_goto] = ACTIONS(2653),
    [anon_sym___try] = ACTIONS(2653),
    [anon_sym___leave] = ACTIONS(2653),
    [anon_sym_not] = ACTIONS(2653),
    [anon_sym_compl] = ACTIONS(2653),
    [anon_sym_DASH_DASH] = ACTIONS(2655),
    [anon_sym_PLUS_PLUS] = ACTIONS(2655),
    [anon_sym_sizeof] = ACTIONS(2653),
    [anon_sym___alignof__] = ACTIONS(2653),
    [anon_sym___alignof] = ACTIONS(2653),
    [anon_sym__alignof] = ACTIONS(2653),
    [anon_sym_alignof] = ACTIONS(2653),
    [anon_sym__Alignof] = ACTIONS(2653),
    [anon_sym_offsetof] = ACTIONS(2653),
    [anon_sym__Generic] = ACTIONS(2653),
    [anon_sym_asm] = ACTIONS(2653),
    [anon_sym___asm__] = ACTIONS(2653),
    [aux_sym_number_literal_token1] = ACTIONS(2655),
    [aux_sym_number_literal_token2] = ACTIONS(2653),
    [anon_sym_L_SQUOTE] = ACTIONS(2655),
    [anon_sym_u_SQUOTE] = ACTIONS(2655),
    [anon_sym_U_SQUOTE] = ACTIONS(2655),
    [anon_sym_u8_SQUOTE] = ACTIONS(2655),
    [anon_sym_SQUOTE] = ACTIONS(2655),
    [anon_sym_L_DQUOTE] = ACTIONS(2655),
    [anon_sym_u_DQUOTE] = ACTIONS(2655),
    [anon_sym_U_DQUOTE] = ACTIONS(2655),
    [anon_sym_u8_DQUOTE] = ACTIONS(2655),
    [anon_sym_DQUOTE] = ACTIONS(2655),
    [sym_true] = ACTIONS(2653),
    [sym_false] = ACTIONS(2653),
    [anon_sym_NULL] = ACTIONS(2653),
    [anon_sym_nullptr] = ACTIONS(2653),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2653),
    [anon_sym_decltype] = ACTIONS(2653),
    [anon_sym_virtual] = ACTIONS(2653),
    [anon_sym_alignas] = ACTIONS(2653),
    [anon_sym_typename] = ACTIONS(2653),
    [anon_sym_template] = ACTIONS(2653),
    [anon_sym_try] = ACTIONS(2653),
    [anon_sym_delete] = ACTIONS(2653),
    [anon_sym_throw] = ACTIONS(2653),
    [anon_sym_co_return] = ACTIONS(2653),
    [anon_sym_co_yield] = ACTIONS(2653),
    [anon_sym_R_DQUOTE] = ACTIONS(2655),
    [anon_sym_LR_DQUOTE] = ACTIONS(2655),
    [anon_sym_uR_DQUOTE] = ACTIONS(2655),
    [anon_sym_UR_DQUOTE] = ACTIONS(2655),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2655),
    [anon_sym_co_await] = ACTIONS(2653),
    [anon_sym_new] = ACTIONS(2653),
    [anon_sym_requires] = ACTIONS(2653),
    [sym_this] = ACTIONS(2653),
  },
  [1044] = {
    [sym_identifier] = ACTIONS(2797),
    [anon_sym_LPAREN2] = ACTIONS(2799),
    [anon_sym_BANG] = ACTIONS(2799),
    [anon_sym_TILDE] = ACTIONS(2799),
    [anon_sym_DASH] = ACTIONS(2797),
    [anon_sym_PLUS] = ACTIONS(2797),
    [anon_sym_STAR] = ACTIONS(2799),
    [anon_sym_AMP] = ACTIONS(2799),
    [anon_sym_SEMI] = ACTIONS(2799),
    [anon_sym___extension__] = ACTIONS(2797),
    [anon_sym_typedef] = ACTIONS(2797),
    [anon_sym_extern] = ACTIONS(2797),
    [anon_sym___attribute__] = ACTIONS(2797),
    [anon_sym_COLON_COLON] = ACTIONS(2799),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2799),
    [anon_sym___declspec] = ACTIONS(2797),
    [anon_sym_LBRACE] = ACTIONS(2799),
    [anon_sym_signed] = ACTIONS(2797),
    [anon_sym_unsigned] = ACTIONS(2797),
    [anon_sym_long] = ACTIONS(2797),
    [anon_sym_short] = ACTIONS(2797),
    [anon_sym_LBRACK] = ACTIONS(2797),
    [anon_sym_static] = ACTIONS(2797),
    [anon_sym_register] = ACTIONS(2797),
    [anon_sym_inline] = ACTIONS(2797),
    [anon_sym___inline] = ACTIONS(2797),
    [anon_sym___inline__] = ACTIONS(2797),
    [anon_sym___forceinline] = ACTIONS(2797),
    [anon_sym_thread_local] = ACTIONS(2797),
    [anon_sym___thread] = ACTIONS(2797),
    [anon_sym_const] = ACTIONS(2797),
    [anon_sym_constexpr] = ACTIONS(2797),
    [anon_sym_volatile] = ACTIONS(2797),
    [anon_sym_restrict] = ACTIONS(2797),
    [anon_sym___restrict__] = ACTIONS(2797),
    [anon_sym__Atomic] = ACTIONS(2797),
    [anon_sym__Noreturn] = ACTIONS(2797),
    [anon_sym_noreturn] = ACTIONS(2797),
    [anon_sym_mutable] = ACTIONS(2797),
    [anon_sym_constinit] = ACTIONS(2797),
    [anon_sym_consteval] = ACTIONS(2797),
    [anon_sym_PROGMEM] = ACTIONS(2797),
    [aux_sym_primitive_type_token1] = ACTIONS(2797),
    [anon_sym_byte] = ACTIONS(2797),
    [anon_sym_word] = ACTIONS(2797),
    [anon_sym_enum] = ACTIONS(2797),
    [anon_sym_class] = ACTIONS(2797),
    [anon_sym_struct] = ACTIONS(2797),
    [anon_sym_union] = ACTIONS(2797),
    [anon_sym_if] = ACTIONS(2797),
    [anon_sym_else] = ACTIONS(2797),
    [anon_sym_switch] = ACTIONS(2797),
    [anon_sym_while] = ACTIONS(2797),
    [anon_sym_do] = ACTIONS(2797),
    [anon_sym_for] = ACTIONS(2797),
    [anon_sym_return] = ACTIONS(2797),
    [anon_sym_break] = ACTIONS(2797),
    [anon_sym_continue] = ACTIONS(2797),
    [anon_sym_goto] = ACTIONS(2797),
    [anon_sym___try] = ACTIONS(2797),
    [anon_sym___leave] = ACTIONS(2797),
    [anon_sym_not] = ACTIONS(2797),
    [anon_sym_compl] = ACTIONS(2797),
    [anon_sym_DASH_DASH] = ACTIONS(2799),
    [anon_sym_PLUS_PLUS] = ACTIONS(2799),
    [anon_sym_sizeof] = ACTIONS(2797),
    [anon_sym___alignof__] = ACTIONS(2797),
    [anon_sym___alignof] = ACTIONS(2797),
    [anon_sym__alignof] = ACTIONS(2797),
    [anon_sym_alignof] = ACTIONS(2797),
    [anon_sym__Alignof] = ACTIONS(2797),
    [anon_sym_offsetof] = ACTIONS(2797),
    [anon_sym__Generic] = ACTIONS(2797),
    [anon_sym_asm] = ACTIONS(2797),
    [anon_sym___asm__] = ACTIONS(2797),
    [aux_sym_number_literal_token1] = ACTIONS(2799),
    [aux_sym_number_literal_token2] = ACTIONS(2797),
    [anon_sym_L_SQUOTE] = ACTIONS(2799),
    [anon_sym_u_SQUOTE] = ACTIONS(2799),
    [anon_sym_U_SQUOTE] = ACTIONS(2799),
    [anon_sym_u8_SQUOTE] = ACTIONS(2799),
    [anon_sym_SQUOTE] = ACTIONS(2799),
    [anon_sym_L_DQUOTE] = ACTIONS(2799),
    [anon_sym_u_DQUOTE] = ACTIONS(2799),
    [anon_sym_U_DQUOTE] = ACTIONS(2799),
    [anon_sym_u8_DQUOTE] = ACTIONS(2799),
    [anon_sym_DQUOTE] = ACTIONS(2799),
    [sym_true] = ACTIONS(2797),
    [sym_false] = ACTIONS(2797),
    [anon_sym_NULL] = ACTIONS(2797),
    [anon_sym_nullptr] = ACTIONS(2797),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2797),
    [anon_sym_decltype] = ACTIONS(2797),
    [anon_sym_virtual] = ACTIONS(2797),
    [anon_sym_alignas] = ACTIONS(2797),
    [anon_sym_typename] = ACTIONS(2797),
    [anon_sym_template] = ACTIONS(2797),
    [anon_sym_try] = ACTIONS(2797),
    [anon_sym_delete] = ACTIONS(2797),
    [anon_sym_throw] = ACTIONS(2797),
    [anon_sym_co_return] = ACTIONS(2797),
    [anon_sym_co_yield] = ACTIONS(2797),
    [anon_sym_R_DQUOTE] = ACTIONS(2799),
    [anon_sym_LR_DQUOTE] = ACTIONS(2799),
    [anon_sym_uR_DQUOTE] = ACTIONS(2799),
    [anon_sym_UR_DQUOTE] = ACTIONS(2799),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2799),
    [anon_sym_co_await] = ACTIONS(2797),
    [anon_sym_new] = ACTIONS(2797),
    [anon_sym_requires] = ACTIONS(2797),
    [sym_this] = ACTIONS(2797),
  },
  [1045] = {
    [sym_identifier] = ACTIONS(2731),
    [anon_sym_LPAREN2] = ACTIONS(2733),
    [anon_sym_BANG] = ACTIONS(2733),
    [anon_sym_TILDE] = ACTIONS(2733),
    [anon_sym_DASH] = ACTIONS(2731),
    [anon_sym_PLUS] = ACTIONS(2731),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_AMP] = ACTIONS(2733),
    [anon_sym_SEMI] = ACTIONS(2733),
    [anon_sym___extension__] = ACTIONS(2731),
    [anon_sym_typedef] = ACTIONS(2731),
    [anon_sym_extern] = ACTIONS(2731),
    [anon_sym___attribute__] = ACTIONS(2731),
    [anon_sym_COLON_COLON] = ACTIONS(2733),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2733),
    [anon_sym___declspec] = ACTIONS(2731),
    [anon_sym_LBRACE] = ACTIONS(2733),
    [anon_sym_signed] = ACTIONS(2731),
    [anon_sym_unsigned] = ACTIONS(2731),
    [anon_sym_long] = ACTIONS(2731),
    [anon_sym_short] = ACTIONS(2731),
    [anon_sym_LBRACK] = ACTIONS(2731),
    [anon_sym_static] = ACTIONS(2731),
    [anon_sym_register] = ACTIONS(2731),
    [anon_sym_inline] = ACTIONS(2731),
    [anon_sym___inline] = ACTIONS(2731),
    [anon_sym___inline__] = ACTIONS(2731),
    [anon_sym___forceinline] = ACTIONS(2731),
    [anon_sym_thread_local] = ACTIONS(2731),
    [anon_sym___thread] = ACTIONS(2731),
    [anon_sym_const] = ACTIONS(2731),
    [anon_sym_constexpr] = ACTIONS(2731),
    [anon_sym_volatile] = ACTIONS(2731),
    [anon_sym_restrict] = ACTIONS(2731),
    [anon_sym___restrict__] = ACTIONS(2731),
    [anon_sym__Atomic] = ACTIONS(2731),
    [anon_sym__Noreturn] = ACTIONS(2731),
    [anon_sym_noreturn] = ACTIONS(2731),
    [anon_sym_mutable] = ACTIONS(2731),
    [anon_sym_constinit] = ACTIONS(2731),
    [anon_sym_consteval] = ACTIONS(2731),
    [anon_sym_PROGMEM] = ACTIONS(2731),
    [aux_sym_primitive_type_token1] = ACTIONS(2731),
    [anon_sym_byte] = ACTIONS(2731),
    [anon_sym_word] = ACTIONS(2731),
    [anon_sym_enum] = ACTIONS(2731),
    [anon_sym_class] = ACTIONS(2731),
    [anon_sym_struct] = ACTIONS(2731),
    [anon_sym_union] = ACTIONS(2731),
    [anon_sym_if] = ACTIONS(2731),
    [anon_sym_else] = ACTIONS(2731),
    [anon_sym_switch] = ACTIONS(2731),
    [anon_sym_while] = ACTIONS(2731),
    [anon_sym_do] = ACTIONS(2731),
    [anon_sym_for] = ACTIONS(2731),
    [anon_sym_return] = ACTIONS(2731),
    [anon_sym_break] = ACTIONS(2731),
    [anon_sym_continue] = ACTIONS(2731),
    [anon_sym_goto] = ACTIONS(2731),
    [anon_sym___try] = ACTIONS(2731),
    [anon_sym___leave] = ACTIONS(2731),
    [anon_sym_not] = ACTIONS(2731),
    [anon_sym_compl] = ACTIONS(2731),
    [anon_sym_DASH_DASH] = ACTIONS(2733),
    [anon_sym_PLUS_PLUS] = ACTIONS(2733),
    [anon_sym_sizeof] = ACTIONS(2731),
    [anon_sym___alignof__] = ACTIONS(2731),
    [anon_sym___alignof] = ACTIONS(2731),
    [anon_sym__alignof] = ACTIONS(2731),
    [anon_sym_alignof] = ACTIONS(2731),
    [anon_sym__Alignof] = ACTIONS(2731),
    [anon_sym_offsetof] = ACTIONS(2731),
    [anon_sym__Generic] = ACTIONS(2731),
    [anon_sym_asm] = ACTIONS(2731),
    [anon_sym___asm__] = ACTIONS(2731),
    [aux_sym_number_literal_token1] = ACTIONS(2733),
    [aux_sym_number_literal_token2] = ACTIONS(2731),
    [anon_sym_L_SQUOTE] = ACTIONS(2733),
    [anon_sym_u_SQUOTE] = ACTIONS(2733),
    [anon_sym_U_SQUOTE] = ACTIONS(2733),
    [anon_sym_u8_SQUOTE] = ACTIONS(2733),
    [anon_sym_SQUOTE] = ACTIONS(2733),
    [anon_sym_L_DQUOTE] = ACTIONS(2733),
    [anon_sym_u_DQUOTE] = ACTIONS(2733),
    [anon_sym_U_DQUOTE] = ACTIONS(2733),
    [anon_sym_u8_DQUOTE] = ACTIONS(2733),
    [anon_sym_DQUOTE] = ACTIONS(2733),
    [sym_true] = ACTIONS(2731),
    [sym_false] = ACTIONS(2731),
    [anon_sym_NULL] = ACTIONS(2731),
    [anon_sym_nullptr] = ACTIONS(2731),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2731),
    [anon_sym_decltype] = ACTIONS(2731),
    [anon_sym_virtual] = ACTIONS(2731),
    [anon_sym_alignas] = ACTIONS(2731),
    [anon_sym_typename] = ACTIONS(2731),
    [anon_sym_template] = ACTIONS(2731),
    [anon_sym_try] = ACTIONS(2731),
    [anon_sym_delete] = ACTIONS(2731),
    [anon_sym_throw] = ACTIONS(2731),
    [anon_sym_co_return] = ACTIONS(2731),
    [anon_sym_co_yield] = ACTIONS(2731),
    [anon_sym_R_DQUOTE] = ACTIONS(2733),
    [anon_sym_LR_DQUOTE] = ACTIONS(2733),
    [anon_sym_uR_DQUOTE] = ACTIONS(2733),
    [anon_sym_UR_DQUOTE] = ACTIONS(2733),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2733),
    [anon_sym_co_await] = ACTIONS(2731),
    [anon_sym_new] = ACTIONS(2731),
    [anon_sym_requires] = ACTIONS(2731),
    [sym_this] = ACTIONS(2731),
  },
  [1046] = {
    [sym_identifier] = ACTIONS(2639),
    [anon_sym_LPAREN2] = ACTIONS(2641),
    [anon_sym_BANG] = ACTIONS(2641),
    [anon_sym_TILDE] = ACTIONS(2641),
    [anon_sym_DASH] = ACTIONS(2639),
    [anon_sym_PLUS] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(2641),
    [anon_sym_AMP] = ACTIONS(2641),
    [anon_sym_SEMI] = ACTIONS(2641),
    [anon_sym___extension__] = ACTIONS(2639),
    [anon_sym_typedef] = ACTIONS(2639),
    [anon_sym_extern] = ACTIONS(2639),
    [anon_sym___attribute__] = ACTIONS(2639),
    [anon_sym_COLON_COLON] = ACTIONS(2641),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2641),
    [anon_sym___declspec] = ACTIONS(2639),
    [anon_sym_LBRACE] = ACTIONS(2641),
    [anon_sym_signed] = ACTIONS(2639),
    [anon_sym_unsigned] = ACTIONS(2639),
    [anon_sym_long] = ACTIONS(2639),
    [anon_sym_short] = ACTIONS(2639),
    [anon_sym_LBRACK] = ACTIONS(2639),
    [anon_sym_static] = ACTIONS(2639),
    [anon_sym_register] = ACTIONS(2639),
    [anon_sym_inline] = ACTIONS(2639),
    [anon_sym___inline] = ACTIONS(2639),
    [anon_sym___inline__] = ACTIONS(2639),
    [anon_sym___forceinline] = ACTIONS(2639),
    [anon_sym_thread_local] = ACTIONS(2639),
    [anon_sym___thread] = ACTIONS(2639),
    [anon_sym_const] = ACTIONS(2639),
    [anon_sym_constexpr] = ACTIONS(2639),
    [anon_sym_volatile] = ACTIONS(2639),
    [anon_sym_restrict] = ACTIONS(2639),
    [anon_sym___restrict__] = ACTIONS(2639),
    [anon_sym__Atomic] = ACTIONS(2639),
    [anon_sym__Noreturn] = ACTIONS(2639),
    [anon_sym_noreturn] = ACTIONS(2639),
    [anon_sym_mutable] = ACTIONS(2639),
    [anon_sym_constinit] = ACTIONS(2639),
    [anon_sym_consteval] = ACTIONS(2639),
    [anon_sym_PROGMEM] = ACTIONS(2639),
    [aux_sym_primitive_type_token1] = ACTIONS(2639),
    [anon_sym_byte] = ACTIONS(2639),
    [anon_sym_word] = ACTIONS(2639),
    [anon_sym_enum] = ACTIONS(2639),
    [anon_sym_class] = ACTIONS(2639),
    [anon_sym_struct] = ACTIONS(2639),
    [anon_sym_union] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2639),
    [anon_sym_else] = ACTIONS(2639),
    [anon_sym_switch] = ACTIONS(2639),
    [anon_sym_while] = ACTIONS(2639),
    [anon_sym_do] = ACTIONS(2639),
    [anon_sym_for] = ACTIONS(2639),
    [anon_sym_return] = ACTIONS(2639),
    [anon_sym_break] = ACTIONS(2639),
    [anon_sym_continue] = ACTIONS(2639),
    [anon_sym_goto] = ACTIONS(2639),
    [anon_sym___try] = ACTIONS(2639),
    [anon_sym___leave] = ACTIONS(2639),
    [anon_sym_not] = ACTIONS(2639),
    [anon_sym_compl] = ACTIONS(2639),
    [anon_sym_DASH_DASH] = ACTIONS(2641),
    [anon_sym_PLUS_PLUS] = ACTIONS(2641),
    [anon_sym_sizeof] = ACTIONS(2639),
    [anon_sym___alignof__] = ACTIONS(2639),
    [anon_sym___alignof] = ACTIONS(2639),
    [anon_sym__alignof] = ACTIONS(2639),
    [anon_sym_alignof] = ACTIONS(2639),
    [anon_sym__Alignof] = ACTIONS(2639),
    [anon_sym_offsetof] = ACTIONS(2639),
    [anon_sym__Generic] = ACTIONS(2639),
    [anon_sym_asm] = ACTIONS(2639),
    [anon_sym___asm__] = ACTIONS(2639),
    [aux_sym_number_literal_token1] = ACTIONS(2641),
    [aux_sym_number_literal_token2] = ACTIONS(2639),
    [anon_sym_L_SQUOTE] = ACTIONS(2641),
    [anon_sym_u_SQUOTE] = ACTIONS(2641),
    [anon_sym_U_SQUOTE] = ACTIONS(2641),
    [anon_sym_u8_SQUOTE] = ACTIONS(2641),
    [anon_sym_SQUOTE] = ACTIONS(2641),
    [anon_sym_L_DQUOTE] = ACTIONS(2641),
    [anon_sym_u_DQUOTE] = ACTIONS(2641),
    [anon_sym_U_DQUOTE] = ACTIONS(2641),
    [anon_sym_u8_DQUOTE] = ACTIONS(2641),
    [anon_sym_DQUOTE] = ACTIONS(2641),
    [sym_true] = ACTIONS(2639),
    [sym_false] = ACTIONS(2639),
    [anon_sym_NULL] = ACTIONS(2639),
    [anon_sym_nullptr] = ACTIONS(2639),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2639),
    [anon_sym_decltype] = ACTIONS(2639),
    [anon_sym_virtual] = ACTIONS(2639),
    [anon_sym_alignas] = ACTIONS(2639),
    [anon_sym_typename] = ACTIONS(2639),
    [anon_sym_template] = ACTIONS(2639),
    [anon_sym_try] = ACTIONS(2639),
    [anon_sym_delete] = ACTIONS(2639),
    [anon_sym_throw] = ACTIONS(2639),
    [anon_sym_co_return] = ACTIONS(2639),
    [anon_sym_co_yield] = ACTIONS(2639),
    [anon_sym_R_DQUOTE] = ACTIONS(2641),
    [anon_sym_LR_DQUOTE] = ACTIONS(2641),
    [anon_sym_uR_DQUOTE] = ACTIONS(2641),
    [anon_sym_UR_DQUOTE] = ACTIONS(2641),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2641),
    [anon_sym_co_await] = ACTIONS(2639),
    [anon_sym_new] = ACTIONS(2639),
    [anon_sym_requires] = ACTIONS(2639),
    [sym_this] = ACTIONS(2639),
  },
  [1047] = {
    [sym_identifier] = ACTIONS(2639),
    [anon_sym_LPAREN2] = ACTIONS(2641),
    [anon_sym_BANG] = ACTIONS(2641),
    [anon_sym_TILDE] = ACTIONS(2641),
    [anon_sym_DASH] = ACTIONS(2639),
    [anon_sym_PLUS] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(2641),
    [anon_sym_AMP] = ACTIONS(2641),
    [anon_sym_SEMI] = ACTIONS(2641),
    [anon_sym___extension__] = ACTIONS(2639),
    [anon_sym_typedef] = ACTIONS(2639),
    [anon_sym_extern] = ACTIONS(2639),
    [anon_sym___attribute__] = ACTIONS(2639),
    [anon_sym_COLON_COLON] = ACTIONS(2641),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2641),
    [anon_sym___declspec] = ACTIONS(2639),
    [anon_sym_LBRACE] = ACTIONS(2641),
    [anon_sym_signed] = ACTIONS(2639),
    [anon_sym_unsigned] = ACTIONS(2639),
    [anon_sym_long] = ACTIONS(2639),
    [anon_sym_short] = ACTIONS(2639),
    [anon_sym_LBRACK] = ACTIONS(2639),
    [anon_sym_static] = ACTIONS(2639),
    [anon_sym_register] = ACTIONS(2639),
    [anon_sym_inline] = ACTIONS(2639),
    [anon_sym___inline] = ACTIONS(2639),
    [anon_sym___inline__] = ACTIONS(2639),
    [anon_sym___forceinline] = ACTIONS(2639),
    [anon_sym_thread_local] = ACTIONS(2639),
    [anon_sym___thread] = ACTIONS(2639),
    [anon_sym_const] = ACTIONS(2639),
    [anon_sym_constexpr] = ACTIONS(2639),
    [anon_sym_volatile] = ACTIONS(2639),
    [anon_sym_restrict] = ACTIONS(2639),
    [anon_sym___restrict__] = ACTIONS(2639),
    [anon_sym__Atomic] = ACTIONS(2639),
    [anon_sym__Noreturn] = ACTIONS(2639),
    [anon_sym_noreturn] = ACTIONS(2639),
    [anon_sym_mutable] = ACTIONS(2639),
    [anon_sym_constinit] = ACTIONS(2639),
    [anon_sym_consteval] = ACTIONS(2639),
    [anon_sym_PROGMEM] = ACTIONS(2639),
    [aux_sym_primitive_type_token1] = ACTIONS(2639),
    [anon_sym_byte] = ACTIONS(2639),
    [anon_sym_word] = ACTIONS(2639),
    [anon_sym_enum] = ACTIONS(2639),
    [anon_sym_class] = ACTIONS(2639),
    [anon_sym_struct] = ACTIONS(2639),
    [anon_sym_union] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2639),
    [anon_sym_else] = ACTIONS(2639),
    [anon_sym_switch] = ACTIONS(2639),
    [anon_sym_while] = ACTIONS(2639),
    [anon_sym_do] = ACTIONS(2639),
    [anon_sym_for] = ACTIONS(2639),
    [anon_sym_return] = ACTIONS(2639),
    [anon_sym_break] = ACTIONS(2639),
    [anon_sym_continue] = ACTIONS(2639),
    [anon_sym_goto] = ACTIONS(2639),
    [anon_sym___try] = ACTIONS(2639),
    [anon_sym___leave] = ACTIONS(2639),
    [anon_sym_not] = ACTIONS(2639),
    [anon_sym_compl] = ACTIONS(2639),
    [anon_sym_DASH_DASH] = ACTIONS(2641),
    [anon_sym_PLUS_PLUS] = ACTIONS(2641),
    [anon_sym_sizeof] = ACTIONS(2639),
    [anon_sym___alignof__] = ACTIONS(2639),
    [anon_sym___alignof] = ACTIONS(2639),
    [anon_sym__alignof] = ACTIONS(2639),
    [anon_sym_alignof] = ACTIONS(2639),
    [anon_sym__Alignof] = ACTIONS(2639),
    [anon_sym_offsetof] = ACTIONS(2639),
    [anon_sym__Generic] = ACTIONS(2639),
    [anon_sym_asm] = ACTIONS(2639),
    [anon_sym___asm__] = ACTIONS(2639),
    [aux_sym_number_literal_token1] = ACTIONS(2641),
    [aux_sym_number_literal_token2] = ACTIONS(2639),
    [anon_sym_L_SQUOTE] = ACTIONS(2641),
    [anon_sym_u_SQUOTE] = ACTIONS(2641),
    [anon_sym_U_SQUOTE] = ACTIONS(2641),
    [anon_sym_u8_SQUOTE] = ACTIONS(2641),
    [anon_sym_SQUOTE] = ACTIONS(2641),
    [anon_sym_L_DQUOTE] = ACTIONS(2641),
    [anon_sym_u_DQUOTE] = ACTIONS(2641),
    [anon_sym_U_DQUOTE] = ACTIONS(2641),
    [anon_sym_u8_DQUOTE] = ACTIONS(2641),
    [anon_sym_DQUOTE] = ACTIONS(2641),
    [sym_true] = ACTIONS(2639),
    [sym_false] = ACTIONS(2639),
    [anon_sym_NULL] = ACTIONS(2639),
    [anon_sym_nullptr] = ACTIONS(2639),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2639),
    [anon_sym_decltype] = ACTIONS(2639),
    [anon_sym_virtual] = ACTIONS(2639),
    [anon_sym_alignas] = ACTIONS(2639),
    [anon_sym_typename] = ACTIONS(2639),
    [anon_sym_template] = ACTIONS(2639),
    [anon_sym_try] = ACTIONS(2639),
    [anon_sym_delete] = ACTIONS(2639),
    [anon_sym_throw] = ACTIONS(2639),
    [anon_sym_co_return] = ACTIONS(2639),
    [anon_sym_co_yield] = ACTIONS(2639),
    [anon_sym_R_DQUOTE] = ACTIONS(2641),
    [anon_sym_LR_DQUOTE] = ACTIONS(2641),
    [anon_sym_uR_DQUOTE] = ACTIONS(2641),
    [anon_sym_UR_DQUOTE] = ACTIONS(2641),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2641),
    [anon_sym_co_await] = ACTIONS(2639),
    [anon_sym_new] = ACTIONS(2639),
    [anon_sym_requires] = ACTIONS(2639),
    [sym_this] = ACTIONS(2639),
  },
  [1048] = {
    [sym_identifier] = ACTIONS(3650),
    [anon_sym_LPAREN2] = ACTIONS(3652),
    [anon_sym_BANG] = ACTIONS(3652),
    [anon_sym_TILDE] = ACTIONS(3652),
    [anon_sym_DASH] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3650),
    [anon_sym_STAR] = ACTIONS(3652),
    [anon_sym_AMP] = ACTIONS(3652),
    [anon_sym_SEMI] = ACTIONS(3652),
    [anon_sym___extension__] = ACTIONS(3650),
    [anon_sym_extern] = ACTIONS(3650),
    [anon_sym___attribute__] = ACTIONS(3650),
    [anon_sym_COLON_COLON] = ACTIONS(3652),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3652),
    [anon_sym___declspec] = ACTIONS(3650),
    [anon_sym_LBRACE] = ACTIONS(3652),
    [anon_sym_signed] = ACTIONS(3650),
    [anon_sym_unsigned] = ACTIONS(3650),
    [anon_sym_long] = ACTIONS(3650),
    [anon_sym_short] = ACTIONS(3650),
    [anon_sym_LBRACK] = ACTIONS(3650),
    [anon_sym_static] = ACTIONS(3650),
    [anon_sym_register] = ACTIONS(3650),
    [anon_sym_inline] = ACTIONS(3650),
    [anon_sym___inline] = ACTIONS(3650),
    [anon_sym___inline__] = ACTIONS(3650),
    [anon_sym___forceinline] = ACTIONS(3650),
    [anon_sym_thread_local] = ACTIONS(3650),
    [anon_sym___thread] = ACTIONS(3650),
    [anon_sym_const] = ACTIONS(3650),
    [anon_sym_constexpr] = ACTIONS(3650),
    [anon_sym_volatile] = ACTIONS(3650),
    [anon_sym_restrict] = ACTIONS(3650),
    [anon_sym___restrict__] = ACTIONS(3650),
    [anon_sym__Atomic] = ACTIONS(3650),
    [anon_sym__Noreturn] = ACTIONS(3650),
    [anon_sym_noreturn] = ACTIONS(3650),
    [anon_sym_mutable] = ACTIONS(3650),
    [anon_sym_constinit] = ACTIONS(3650),
    [anon_sym_consteval] = ACTIONS(3650),
    [anon_sym_PROGMEM] = ACTIONS(3650),
    [aux_sym_primitive_type_token1] = ACTIONS(3650),
    [anon_sym_byte] = ACTIONS(3650),
    [anon_sym_word] = ACTIONS(3650),
    [anon_sym_enum] = ACTIONS(3650),
    [anon_sym_class] = ACTIONS(3650),
    [anon_sym_struct] = ACTIONS(3650),
    [anon_sym_union] = ACTIONS(3650),
    [anon_sym_if] = ACTIONS(3650),
    [anon_sym_switch] = ACTIONS(3650),
    [anon_sym_case] = ACTIONS(3650),
    [anon_sym_default] = ACTIONS(3650),
    [anon_sym_while] = ACTIONS(3650),
    [anon_sym_do] = ACTIONS(3650),
    [anon_sym_for] = ACTIONS(3650),
    [anon_sym_return] = ACTIONS(3650),
    [anon_sym_break] = ACTIONS(3650),
    [anon_sym_continue] = ACTIONS(3650),
    [anon_sym_goto] = ACTIONS(3650),
    [anon_sym___try] = ACTIONS(3650),
    [anon_sym___leave] = ACTIONS(3650),
    [anon_sym_not] = ACTIONS(3650),
    [anon_sym_compl] = ACTIONS(3650),
    [anon_sym_DASH_DASH] = ACTIONS(3652),
    [anon_sym_PLUS_PLUS] = ACTIONS(3652),
    [anon_sym_sizeof] = ACTIONS(3650),
    [anon_sym___alignof__] = ACTIONS(3650),
    [anon_sym___alignof] = ACTIONS(3650),
    [anon_sym__alignof] = ACTIONS(3650),
    [anon_sym_alignof] = ACTIONS(3650),
    [anon_sym__Alignof] = ACTIONS(3650),
    [anon_sym_offsetof] = ACTIONS(3650),
    [anon_sym__Generic] = ACTIONS(3650),
    [anon_sym_asm] = ACTIONS(3650),
    [anon_sym___asm__] = ACTIONS(3650),
    [aux_sym_number_literal_token1] = ACTIONS(3652),
    [aux_sym_number_literal_token2] = ACTIONS(3650),
    [anon_sym_L_SQUOTE] = ACTIONS(3652),
    [anon_sym_u_SQUOTE] = ACTIONS(3652),
    [anon_sym_U_SQUOTE] = ACTIONS(3652),
    [anon_sym_u8_SQUOTE] = ACTIONS(3652),
    [anon_sym_SQUOTE] = ACTIONS(3652),
    [anon_sym_L_DQUOTE] = ACTIONS(3652),
    [anon_sym_u_DQUOTE] = ACTIONS(3652),
    [anon_sym_U_DQUOTE] = ACTIONS(3652),
    [anon_sym_u8_DQUOTE] = ACTIONS(3652),
    [anon_sym_DQUOTE] = ACTIONS(3652),
    [sym_true] = ACTIONS(3650),
    [sym_false] = ACTIONS(3650),
    [anon_sym_NULL] = ACTIONS(3650),
    [anon_sym_nullptr] = ACTIONS(3650),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3650),
    [anon_sym_decltype] = ACTIONS(3650),
    [anon_sym_virtual] = ACTIONS(3650),
    [anon_sym_alignas] = ACTIONS(3650),
    [anon_sym_typename] = ACTIONS(3650),
    [anon_sym_template] = ACTIONS(3650),
    [anon_sym_try] = ACTIONS(3650),
    [anon_sym_delete] = ACTIONS(3650),
    [anon_sym_throw] = ACTIONS(3650),
    [anon_sym_co_return] = ACTIONS(3650),
    [anon_sym_co_yield] = ACTIONS(3650),
    [anon_sym_R_DQUOTE] = ACTIONS(3652),
    [anon_sym_LR_DQUOTE] = ACTIONS(3652),
    [anon_sym_uR_DQUOTE] = ACTIONS(3652),
    [anon_sym_UR_DQUOTE] = ACTIONS(3652),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3652),
    [anon_sym_co_await] = ACTIONS(3650),
    [anon_sym_new] = ACTIONS(3650),
    [anon_sym_requires] = ACTIONS(3650),
    [sym_this] = ACTIONS(3650),
  },
  [1049] = {
    [sym_primitive_type] = STATE(6626),
    [sym_expression_statement] = STATE(2642),
    [sym__expression] = STATE(4476),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8104),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_type_requirement] = STATE(1061),
    [sym_compound_requirement] = STATE(1061),
    [sym__requirement] = STATE(1061),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_requirement_seq_repeat1] = STATE(1061),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(3821),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3823),
    [anon_sym_RBRACE] = ACTIONS(3825),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_typename] = ACTIONS(3827),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1050] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4261),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(7126),
    [sym_initializer_pair] = STATE(7126),
    [sym_subscript_designator] = STATE(6468),
    [sym_subscript_range_designator] = STATE(6468),
    [sym_field_designator] = STATE(6468),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_initializer_pair_repeat1] = STATE(6468),
    [sym_identifier] = ACTIONS(3829),
    [anon_sym_COMMA] = ACTIONS(3831),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_RBRACE] = ACTIONS(3833),
    [anon_sym_LBRACK] = ACTIONS(3835),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1051] = {
    [sym_primitive_type] = STATE(6626),
    [sym_expression_statement] = STATE(2642),
    [sym__expression] = STATE(4476),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8104),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_type_requirement] = STATE(1066),
    [sym_compound_requirement] = STATE(1066),
    [sym__requirement] = STATE(1066),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_requirement_seq_repeat1] = STATE(1066),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(3821),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3823),
    [anon_sym_RBRACE] = ACTIONS(3837),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_typename] = ACTIONS(3827),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1052] = {
    [sym_primitive_type] = STATE(6626),
    [sym_expression_statement] = STATE(2642),
    [sym__expression] = STATE(4476),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8104),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_type_requirement] = STATE(1075),
    [sym_compound_requirement] = STATE(1075),
    [sym__requirement] = STATE(1075),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_requirement_seq_repeat1] = STATE(1075),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(3821),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3823),
    [anon_sym_RBRACE] = ACTIONS(3839),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_typename] = ACTIONS(3827),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1053] = {
    [sym_primitive_type] = STATE(6626),
    [sym_expression_statement] = STATE(2642),
    [sym__expression] = STATE(4476),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8104),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_type_requirement] = STATE(1052),
    [sym_compound_requirement] = STATE(1052),
    [sym__requirement] = STATE(1052),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_requirement_seq_repeat1] = STATE(1052),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(3821),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3823),
    [anon_sym_RBRACE] = ACTIONS(3841),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_typename] = ACTIONS(3827),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1054] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4287),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(6866),
    [sym_initializer_pair] = STATE(6866),
    [sym_subscript_designator] = STATE(6468),
    [sym_subscript_range_designator] = STATE(6468),
    [sym_field_designator] = STATE(6468),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_initializer_pair_repeat1] = STATE(6468),
    [sym_identifier] = ACTIONS(3829),
    [anon_sym_COMMA] = ACTIONS(3843),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_RBRACE] = ACTIONS(3845),
    [anon_sym_LBRACK] = ACTIONS(3835),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1055] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4321),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(7040),
    [sym_initializer_pair] = STATE(7040),
    [sym_subscript_designator] = STATE(6468),
    [sym_subscript_range_designator] = STATE(6468),
    [sym_field_designator] = STATE(6468),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_initializer_pair_repeat1] = STATE(6468),
    [sym_identifier] = ACTIONS(3829),
    [anon_sym_COMMA] = ACTIONS(3847),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_RBRACE] = ACTIONS(3849),
    [anon_sym_LBRACK] = ACTIONS(3835),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1056] = {
    [sym_string_literal] = STATE(2617),
    [sym_template_argument_list] = STATE(1740),
    [sym_raw_string_literal] = STATE(2617),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2716),
    [sym_identifier] = ACTIONS(3759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3761),
    [anon_sym_LPAREN2] = ACTIONS(3763),
    [anon_sym_TILDE] = ACTIONS(3767),
    [anon_sym_DASH] = ACTIONS(3769),
    [anon_sym_PLUS] = ACTIONS(3769),
    [anon_sym_STAR] = ACTIONS(3771),
    [anon_sym_SLASH] = ACTIONS(3769),
    [anon_sym_PERCENT] = ACTIONS(3769),
    [anon_sym_PIPE_PIPE] = ACTIONS(3761),
    [anon_sym_AMP_AMP] = ACTIONS(3774),
    [anon_sym_PIPE] = ACTIONS(3769),
    [anon_sym_CARET] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(3771),
    [anon_sym_EQ_EQ] = ACTIONS(3761),
    [anon_sym_BANG_EQ] = ACTIONS(3761),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3761),
    [anon_sym_LT_EQ] = ACTIONS(3769),
    [anon_sym_LT] = ACTIONS(3777),
    [anon_sym_LT_LT] = ACTIONS(3769),
    [anon_sym_GT_GT] = ACTIONS(3769),
    [anon_sym_SEMI] = ACTIONS(3774),
    [anon_sym___extension__] = ACTIONS(3759),
    [anon_sym_extern] = ACTIONS(3759),
    [anon_sym___attribute__] = ACTIONS(3759),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3782),
    [anon_sym___declspec] = ACTIONS(3759),
    [anon_sym___based] = ACTIONS(3759),
    [anon_sym___cdecl] = ACTIONS(3759),
    [anon_sym___clrcall] = ACTIONS(3759),
    [anon_sym___stdcall] = ACTIONS(3759),
    [anon_sym___fastcall] = ACTIONS(3759),
    [anon_sym___thiscall] = ACTIONS(3759),
    [anon_sym___vectorcall] = ACTIONS(3759),
    [anon_sym_LBRACE] = ACTIONS(3785),
    [anon_sym_signed] = ACTIONS(3787),
    [anon_sym_unsigned] = ACTIONS(3787),
    [anon_sym_long] = ACTIONS(3787),
    [anon_sym_short] = ACTIONS(3787),
    [anon_sym_LBRACK] = ACTIONS(3789),
    [anon_sym_EQ] = ACTIONS(3793),
    [anon_sym_static] = ACTIONS(3759),
    [anon_sym_register] = ACTIONS(3759),
    [anon_sym_inline] = ACTIONS(3759),
    [anon_sym___inline] = ACTIONS(3759),
    [anon_sym___inline__] = ACTIONS(3759),
    [anon_sym___forceinline] = ACTIONS(3759),
    [anon_sym_thread_local] = ACTIONS(3759),
    [anon_sym___thread] = ACTIONS(3759),
    [anon_sym_const] = ACTIONS(3759),
    [anon_sym_constexpr] = ACTIONS(3759),
    [anon_sym_volatile] = ACTIONS(3759),
    [anon_sym_restrict] = ACTIONS(3759),
    [anon_sym___restrict__] = ACTIONS(3759),
    [anon_sym__Atomic] = ACTIONS(3759),
    [anon_sym__Noreturn] = ACTIONS(3759),
    [anon_sym_noreturn] = ACTIONS(3759),
    [anon_sym_mutable] = ACTIONS(3759),
    [anon_sym_constinit] = ACTIONS(3759),
    [anon_sym_consteval] = ACTIONS(3759),
    [anon_sym_PROGMEM] = ACTIONS(3759),
    [anon_sym_COLON] = ACTIONS(3851),
    [anon_sym_QMARK] = ACTIONS(3761),
    [anon_sym_STAR_EQ] = ACTIONS(3797),
    [anon_sym_SLASH_EQ] = ACTIONS(3797),
    [anon_sym_PERCENT_EQ] = ACTIONS(3797),
    [anon_sym_PLUS_EQ] = ACTIONS(3797),
    [anon_sym_DASH_EQ] = ACTIONS(3797),
    [anon_sym_LT_LT_EQ] = ACTIONS(3797),
    [anon_sym_GT_GT_EQ] = ACTIONS(3797),
    [anon_sym_AMP_EQ] = ACTIONS(3797),
    [anon_sym_CARET_EQ] = ACTIONS(3797),
    [anon_sym_PIPE_EQ] = ACTIONS(3797),
    [anon_sym_and_eq] = ACTIONS(3793),
    [anon_sym_or_eq] = ACTIONS(3793),
    [anon_sym_xor_eq] = ACTIONS(3793),
    [anon_sym_LT_EQ_GT] = ACTIONS(3761),
    [anon_sym_or] = ACTIONS(3769),
    [anon_sym_and] = ACTIONS(3769),
    [anon_sym_bitor] = ACTIONS(3769),
    [anon_sym_xor] = ACTIONS(3769),
    [anon_sym_bitand] = ACTIONS(3769),
    [anon_sym_not_eq] = ACTIONS(3769),
    [anon_sym_DASH_DASH] = ACTIONS(3761),
    [anon_sym_PLUS_PLUS] = ACTIONS(3761),
    [anon_sym_DOT] = ACTIONS(3769),
    [anon_sym_DOT_STAR] = ACTIONS(3761),
    [anon_sym_DASH_GT] = ACTIONS(3761),
    [anon_sym_L_DQUOTE] = ACTIONS(3204),
    [anon_sym_u_DQUOTE] = ACTIONS(3204),
    [anon_sym_U_DQUOTE] = ACTIONS(3204),
    [anon_sym_u8_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3204),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3759),
    [anon_sym_decltype] = ACTIONS(3759),
    [anon_sym_virtual] = ACTIONS(3759),
    [anon_sym_alignas] = ACTIONS(3759),
    [anon_sym_template] = ACTIONS(3759),
    [anon_sym_operator] = ACTIONS(3759),
    [anon_sym_R_DQUOTE] = ACTIONS(3208),
    [anon_sym_LR_DQUOTE] = ACTIONS(3208),
    [anon_sym_uR_DQUOTE] = ACTIONS(3208),
    [anon_sym_UR_DQUOTE] = ACTIONS(3208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3208),
  },
  [1057] = {
    [sym_primitive_type] = STATE(6626),
    [sym_expression_statement] = STATE(2642),
    [sym__expression] = STATE(4476),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8104),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_type_requirement] = STATE(1075),
    [sym_compound_requirement] = STATE(1075),
    [sym__requirement] = STATE(1075),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_requirement_seq_repeat1] = STATE(1075),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(3821),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3823),
    [anon_sym_RBRACE] = ACTIONS(3853),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_typename] = ACTIONS(3827),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1058] = {
    [sym_primitive_type] = STATE(6626),
    [sym_expression_statement] = STATE(2642),
    [sym__expression] = STATE(4476),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8104),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_type_requirement] = STATE(1075),
    [sym_compound_requirement] = STATE(1075),
    [sym__requirement] = STATE(1075),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_requirement_seq_repeat1] = STATE(1075),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(3821),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3823),
    [anon_sym_RBRACE] = ACTIONS(3855),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_typename] = ACTIONS(3827),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1059] = {
    [sym_primitive_type] = STATE(6626),
    [sym_expression_statement] = STATE(2642),
    [sym__expression] = STATE(4476),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8104),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_type_requirement] = STATE(1075),
    [sym_compound_requirement] = STATE(1075),
    [sym__requirement] = STATE(1075),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_requirement_seq_repeat1] = STATE(1075),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(3821),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3823),
    [anon_sym_RBRACE] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_typename] = ACTIONS(3827),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1060] = {
    [sym_primitive_type] = STATE(6626),
    [sym_expression_statement] = STATE(2642),
    [sym__expression] = STATE(4476),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8104),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_type_requirement] = STATE(1058),
    [sym_compound_requirement] = STATE(1058),
    [sym__requirement] = STATE(1058),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_requirement_seq_repeat1] = STATE(1058),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(3821),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3823),
    [anon_sym_RBRACE] = ACTIONS(3859),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_typename] = ACTIONS(3827),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1061] = {
    [sym_primitive_type] = STATE(6626),
    [sym_expression_statement] = STATE(2642),
    [sym__expression] = STATE(4476),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8104),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_type_requirement] = STATE(1075),
    [sym_compound_requirement] = STATE(1075),
    [sym__requirement] = STATE(1075),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_requirement_seq_repeat1] = STATE(1075),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(3821),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3823),
    [anon_sym_RBRACE] = ACTIONS(3861),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_typename] = ACTIONS(3827),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1062] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4247),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(6884),
    [sym_initializer_pair] = STATE(6884),
    [sym_subscript_designator] = STATE(6468),
    [sym_subscript_range_designator] = STATE(6468),
    [sym_field_designator] = STATE(6468),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_initializer_pair_repeat1] = STATE(6468),
    [sym_identifier] = ACTIONS(3829),
    [anon_sym_COMMA] = ACTIONS(3863),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_RBRACE] = ACTIONS(3865),
    [anon_sym_LBRACK] = ACTIONS(3835),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1063] = {
    [sym_primitive_type] = STATE(6626),
    [sym_expression_statement] = STATE(2642),
    [sym__expression] = STATE(4476),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8104),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_type_requirement] = STATE(1075),
    [sym_compound_requirement] = STATE(1075),
    [sym__requirement] = STATE(1075),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_requirement_seq_repeat1] = STATE(1075),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(3821),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3823),
    [anon_sym_RBRACE] = ACTIONS(3867),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_typename] = ACTIONS(3827),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1064] = {
    [sym_primitive_type] = STATE(6626),
    [sym_expression_statement] = STATE(2642),
    [sym__expression] = STATE(4476),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8104),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_type_requirement] = STATE(1069),
    [sym_compound_requirement] = STATE(1069),
    [sym__requirement] = STATE(1069),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_requirement_seq_repeat1] = STATE(1069),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(3821),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3823),
    [anon_sym_RBRACE] = ACTIONS(3869),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_typename] = ACTIONS(3827),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1065] = {
    [sym_primitive_type] = STATE(6626),
    [sym_expression_statement] = STATE(2642),
    [sym__expression] = STATE(4476),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8104),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_type_requirement] = STATE(1059),
    [sym_compound_requirement] = STATE(1059),
    [sym__requirement] = STATE(1059),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_requirement_seq_repeat1] = STATE(1059),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(3821),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3823),
    [anon_sym_RBRACE] = ACTIONS(3871),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_typename] = ACTIONS(3827),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1066] = {
    [sym_primitive_type] = STATE(6626),
    [sym_expression_statement] = STATE(2642),
    [sym__expression] = STATE(4476),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8104),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_type_requirement] = STATE(1075),
    [sym_compound_requirement] = STATE(1075),
    [sym__requirement] = STATE(1075),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_requirement_seq_repeat1] = STATE(1075),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(3821),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3823),
    [anon_sym_RBRACE] = ACTIONS(3873),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_typename] = ACTIONS(3827),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1067] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4312),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(7205),
    [sym_initializer_pair] = STATE(7205),
    [sym_subscript_designator] = STATE(6468),
    [sym_subscript_range_designator] = STATE(6468),
    [sym_field_designator] = STATE(6468),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_initializer_pair_repeat1] = STATE(6468),
    [sym_identifier] = ACTIONS(3829),
    [anon_sym_COMMA] = ACTIONS(3875),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_RBRACE] = ACTIONS(3877),
    [anon_sym_LBRACK] = ACTIONS(3835),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1068] = {
    [sym_primitive_type] = STATE(6626),
    [sym_expression_statement] = STATE(2642),
    [sym__expression] = STATE(4476),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8104),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_type_requirement] = STATE(1063),
    [sym_compound_requirement] = STATE(1063),
    [sym__requirement] = STATE(1063),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_requirement_seq_repeat1] = STATE(1063),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(3821),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3823),
    [anon_sym_RBRACE] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_typename] = ACTIONS(3827),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1069] = {
    [sym_primitive_type] = STATE(6626),
    [sym_expression_statement] = STATE(2642),
    [sym__expression] = STATE(4476),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8104),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_type_requirement] = STATE(1075),
    [sym_compound_requirement] = STATE(1075),
    [sym__requirement] = STATE(1075),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_requirement_seq_repeat1] = STATE(1075),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(3821),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3823),
    [anon_sym_RBRACE] = ACTIONS(3881),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_typename] = ACTIONS(3827),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1070] = {
    [sym_primitive_type] = STATE(6626),
    [sym_expression_statement] = STATE(2642),
    [sym__expression] = STATE(4476),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8104),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_type_requirement] = STATE(1057),
    [sym_compound_requirement] = STATE(1057),
    [sym__requirement] = STATE(1057),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_requirement_seq_repeat1] = STATE(1057),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(3821),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3823),
    [anon_sym_RBRACE] = ACTIONS(3883),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_typename] = ACTIONS(3827),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1071] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4263),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(7023),
    [sym_initializer_pair] = STATE(7023),
    [sym_subscript_designator] = STATE(6468),
    [sym_subscript_range_designator] = STATE(6468),
    [sym_field_designator] = STATE(6468),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_initializer_pair_repeat1] = STATE(6468),
    [sym_identifier] = ACTIONS(3829),
    [anon_sym_COMMA] = ACTIONS(167),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_RBRACE] = ACTIONS(3885),
    [anon_sym_LBRACK] = ACTIONS(3835),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1072] = {
    [sym_primitive_type] = STATE(6626),
    [sym_expression_statement] = STATE(2642),
    [sym__expression] = STATE(4476),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8104),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_type_requirement] = STATE(1075),
    [sym_compound_requirement] = STATE(1075),
    [sym__requirement] = STATE(1075),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_requirement_seq_repeat1] = STATE(1075),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(3821),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3823),
    [anon_sym_RBRACE] = ACTIONS(3887),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_typename] = ACTIONS(3827),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1073] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4236),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(7162),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(7336),
    [sym_initializer_pair] = STATE(7336),
    [sym_subscript_designator] = STATE(6468),
    [sym_subscript_range_designator] = STATE(6468),
    [sym_field_designator] = STATE(6468),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_initializer_pair_repeat1] = STATE(6468),
    [sym_identifier] = ACTIONS(3829),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_RBRACE] = ACTIONS(3889),
    [anon_sym_LBRACK] = ACTIONS(3835),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1074] = {
    [sym_primitive_type] = STATE(6626),
    [sym_expression_statement] = STATE(2642),
    [sym__expression] = STATE(4476),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8104),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_type_requirement] = STATE(1072),
    [sym_compound_requirement] = STATE(1072),
    [sym__requirement] = STATE(1072),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_requirement_seq_repeat1] = STATE(1072),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(3821),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3823),
    [anon_sym_RBRACE] = ACTIONS(3891),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_typename] = ACTIONS(3827),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1075] = {
    [sym_primitive_type] = STATE(6626),
    [sym_expression_statement] = STATE(2642),
    [sym__expression] = STATE(4476),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8104),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_type_requirement] = STATE(1075),
    [sym_compound_requirement] = STATE(1075),
    [sym__requirement] = STATE(1075),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_requirement_seq_repeat1] = STATE(1075),
    [sym_identifier] = ACTIONS(3893),
    [anon_sym_LPAREN2] = ACTIONS(3896),
    [anon_sym_BANG] = ACTIONS(3899),
    [anon_sym_TILDE] = ACTIONS(3899),
    [anon_sym_DASH] = ACTIONS(3902),
    [anon_sym_PLUS] = ACTIONS(3902),
    [anon_sym_STAR] = ACTIONS(3905),
    [anon_sym_AMP] = ACTIONS(3905),
    [anon_sym_SEMI] = ACTIONS(3908),
    [anon_sym_COLON_COLON] = ACTIONS(3911),
    [anon_sym_LBRACE] = ACTIONS(3914),
    [anon_sym_RBRACE] = ACTIONS(3917),
    [anon_sym_LBRACK] = ACTIONS(3919),
    [aux_sym_primitive_type_token1] = ACTIONS(3922),
    [anon_sym_byte] = ACTIONS(3922),
    [anon_sym_word] = ACTIONS(3922),
    [anon_sym_not] = ACTIONS(3902),
    [anon_sym_compl] = ACTIONS(3902),
    [anon_sym_DASH_DASH] = ACTIONS(3925),
    [anon_sym_PLUS_PLUS] = ACTIONS(3925),
    [anon_sym_sizeof] = ACTIONS(3928),
    [anon_sym___alignof__] = ACTIONS(3931),
    [anon_sym___alignof] = ACTIONS(3931),
    [anon_sym__alignof] = ACTIONS(3931),
    [anon_sym_alignof] = ACTIONS(3931),
    [anon_sym__Alignof] = ACTIONS(3931),
    [anon_sym_offsetof] = ACTIONS(3934),
    [anon_sym__Generic] = ACTIONS(3937),
    [anon_sym_asm] = ACTIONS(3940),
    [anon_sym___asm__] = ACTIONS(3940),
    [aux_sym_number_literal_token1] = ACTIONS(3943),
    [aux_sym_number_literal_token2] = ACTIONS(3946),
    [anon_sym_L_SQUOTE] = ACTIONS(3949),
    [anon_sym_u_SQUOTE] = ACTIONS(3949),
    [anon_sym_U_SQUOTE] = ACTIONS(3949),
    [anon_sym_u8_SQUOTE] = ACTIONS(3949),
    [anon_sym_SQUOTE] = ACTIONS(3949),
    [anon_sym_L_DQUOTE] = ACTIONS(3952),
    [anon_sym_u_DQUOTE] = ACTIONS(3952),
    [anon_sym_U_DQUOTE] = ACTIONS(3952),
    [anon_sym_u8_DQUOTE] = ACTIONS(3952),
    [anon_sym_DQUOTE] = ACTIONS(3952),
    [sym_true] = ACTIONS(3955),
    [sym_false] = ACTIONS(3955),
    [anon_sym_NULL] = ACTIONS(3958),
    [anon_sym_nullptr] = ACTIONS(3958),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3961),
    [anon_sym_typename] = ACTIONS(3964),
    [anon_sym_template] = ACTIONS(3967),
    [anon_sym_delete] = ACTIONS(3970),
    [anon_sym_R_DQUOTE] = ACTIONS(3973),
    [anon_sym_LR_DQUOTE] = ACTIONS(3973),
    [anon_sym_uR_DQUOTE] = ACTIONS(3973),
    [anon_sym_UR_DQUOTE] = ACTIONS(3973),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3973),
    [anon_sym_co_await] = ACTIONS(3976),
    [anon_sym_new] = ACTIONS(3979),
    [anon_sym_requires] = ACTIONS(3982),
    [sym_this] = ACTIONS(3955),
  },
  [1076] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4358),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(7336),
    [sym_initializer_pair] = STATE(7336),
    [sym_subscript_designator] = STATE(6468),
    [sym_subscript_range_designator] = STATE(6468),
    [sym_field_designator] = STATE(6468),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_initializer_pair_repeat1] = STATE(6468),
    [sym_identifier] = ACTIONS(3829),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_RBRACE] = ACTIONS(3889),
    [anon_sym_LBRACK] = ACTIONS(3835),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1077] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4358),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(7336),
    [sym_initializer_pair] = STATE(7336),
    [sym_subscript_designator] = STATE(6468),
    [sym_subscript_range_designator] = STATE(6468),
    [sym_field_designator] = STATE(6468),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_initializer_pair_repeat1] = STATE(6468),
    [sym_identifier] = ACTIONS(3829),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_RBRACE] = ACTIONS(3985),
    [anon_sym_LBRACK] = ACTIONS(3835),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1078] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4358),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(7336),
    [sym_initializer_pair] = STATE(7336),
    [sym_subscript_designator] = STATE(6468),
    [sym_subscript_range_designator] = STATE(6468),
    [sym_field_designator] = STATE(6468),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_initializer_pair_repeat1] = STATE(6468),
    [sym_identifier] = ACTIONS(3829),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_RBRACE] = ACTIONS(3987),
    [anon_sym_LBRACK] = ACTIONS(3835),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1079] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4358),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(7336),
    [sym_initializer_pair] = STATE(7336),
    [sym_subscript_designator] = STATE(6468),
    [sym_subscript_range_designator] = STATE(6468),
    [sym_field_designator] = STATE(6468),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_initializer_pair_repeat1] = STATE(6468),
    [sym_identifier] = ACTIONS(3829),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_RBRACE] = ACTIONS(3989),
    [anon_sym_LBRACK] = ACTIONS(3835),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1080] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4358),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(7336),
    [sym_initializer_pair] = STATE(7336),
    [sym_subscript_designator] = STATE(6468),
    [sym_subscript_range_designator] = STATE(6468),
    [sym_field_designator] = STATE(6468),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_initializer_pair_repeat1] = STATE(6468),
    [sym_identifier] = ACTIONS(3829),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_RBRACE] = ACTIONS(3991),
    [anon_sym_LBRACK] = ACTIONS(3835),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1081] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4358),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(7336),
    [sym_initializer_pair] = STATE(7336),
    [sym_subscript_designator] = STATE(6468),
    [sym_subscript_range_designator] = STATE(6468),
    [sym_field_designator] = STATE(6468),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_initializer_pair_repeat1] = STATE(6468),
    [sym_identifier] = ACTIONS(3829),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_RBRACE] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(3835),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1082] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4358),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(7336),
    [sym_initializer_pair] = STATE(7336),
    [sym_subscript_designator] = STATE(6468),
    [sym_subscript_range_designator] = STATE(6468),
    [sym_field_designator] = STATE(6468),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_initializer_pair_repeat1] = STATE(6468),
    [sym_identifier] = ACTIONS(3829),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_RBRACE] = ACTIONS(3995),
    [anon_sym_LBRACK] = ACTIONS(3835),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1083] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4358),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(7336),
    [sym_initializer_pair] = STATE(7336),
    [sym_subscript_designator] = STATE(6468),
    [sym_subscript_range_designator] = STATE(6468),
    [sym_field_designator] = STATE(6468),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_initializer_pair_repeat1] = STATE(6468),
    [sym_identifier] = ACTIONS(3829),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_RBRACE] = ACTIONS(3997),
    [anon_sym_LBRACK] = ACTIONS(3835),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1084] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4358),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(7336),
    [sym_initializer_pair] = STATE(7336),
    [sym_subscript_designator] = STATE(6468),
    [sym_subscript_range_designator] = STATE(6468),
    [sym_field_designator] = STATE(6468),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_initializer_pair_repeat1] = STATE(6468),
    [sym_identifier] = ACTIONS(3829),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_RBRACE] = ACTIONS(3999),
    [anon_sym_LBRACK] = ACTIONS(3835),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1085] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4358),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(7336),
    [sym_initializer_pair] = STATE(7336),
    [sym_subscript_designator] = STATE(6468),
    [sym_subscript_range_designator] = STATE(6468),
    [sym_field_designator] = STATE(6468),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_initializer_pair_repeat1] = STATE(6468),
    [sym_identifier] = ACTIONS(3829),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_RBRACE] = ACTIONS(4001),
    [anon_sym_LBRACK] = ACTIONS(3835),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1086] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4358),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(7336),
    [sym_initializer_pair] = STATE(7336),
    [sym_subscript_designator] = STATE(6468),
    [sym_subscript_range_designator] = STATE(6468),
    [sym_field_designator] = STATE(6468),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_initializer_pair_repeat1] = STATE(6468),
    [sym_identifier] = ACTIONS(3829),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_RBRACE] = ACTIONS(4003),
    [anon_sym_LBRACK] = ACTIONS(3835),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1087] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4358),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(7336),
    [sym_initializer_pair] = STATE(7336),
    [sym_subscript_designator] = STATE(6468),
    [sym_subscript_range_designator] = STATE(6468),
    [sym_field_designator] = STATE(6468),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_initializer_pair_repeat1] = STATE(6468),
    [sym_identifier] = ACTIONS(3829),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_RBRACE] = ACTIONS(4005),
    [anon_sym_LBRACK] = ACTIONS(3835),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1088] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4358),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(7336),
    [sym_initializer_pair] = STATE(7336),
    [sym_subscript_designator] = STATE(6468),
    [sym_subscript_range_designator] = STATE(6468),
    [sym_field_designator] = STATE(6468),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [aux_sym_initializer_pair_repeat1] = STATE(6468),
    [sym_identifier] = ACTIONS(3829),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(3835),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(217),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1089] = {
    [sym_compound_statement] = STATE(7238),
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4232),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(7238),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_RPAREN] = ACTIONS(4007),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym___extension__] = ACTIONS(4009),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(1807),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1090] = {
    [sym_compound_statement] = STATE(7113),
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4262),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(7113),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_RPAREN] = ACTIONS(4011),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym___extension__] = ACTIONS(4013),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(1807),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1091] = {
    [sym_compound_statement] = STATE(6877),
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4228),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(6877),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_RPAREN] = ACTIONS(4015),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym___extension__] = ACTIONS(4017),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(1807),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1092] = {
    [sym_compound_statement] = STATE(7016),
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4289),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(7016),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_RPAREN] = ACTIONS(4019),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym___extension__] = ACTIONS(4021),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(1807),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1093] = {
    [sym_compound_statement] = STATE(7031),
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4291),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(7031),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_RPAREN] = ACTIONS(4023),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym___extension__] = ACTIONS(4025),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(1807),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1094] = {
    [sym_string_literal] = STATE(2617),
    [sym_template_argument_list] = STATE(1779),
    [sym_raw_string_literal] = STATE(2617),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2716),
    [sym_identifier] = ACTIONS(3759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3761),
    [anon_sym_COMMA] = ACTIONS(3761),
    [anon_sym_RPAREN] = ACTIONS(3761),
    [anon_sym_LPAREN2] = ACTIONS(3774),
    [anon_sym_TILDE] = ACTIONS(3767),
    [anon_sym_DASH] = ACTIONS(3769),
    [anon_sym_PLUS] = ACTIONS(3769),
    [anon_sym_STAR] = ACTIONS(3771),
    [anon_sym_SLASH] = ACTIONS(3769),
    [anon_sym_PERCENT] = ACTIONS(3769),
    [anon_sym_PIPE_PIPE] = ACTIONS(3761),
    [anon_sym_AMP_AMP] = ACTIONS(3774),
    [anon_sym_PIPE] = ACTIONS(3769),
    [anon_sym_CARET] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(3771),
    [anon_sym_EQ_EQ] = ACTIONS(3761),
    [anon_sym_BANG_EQ] = ACTIONS(3761),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3761),
    [anon_sym_LT_EQ] = ACTIONS(3769),
    [anon_sym_LT] = ACTIONS(3777),
    [anon_sym_LT_LT] = ACTIONS(3769),
    [anon_sym_GT_GT] = ACTIONS(3769),
    [anon_sym_SEMI] = ACTIONS(3761),
    [anon_sym___extension__] = ACTIONS(3759),
    [anon_sym_extern] = ACTIONS(3759),
    [anon_sym___attribute__] = ACTIONS(3759),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3767),
    [anon_sym___declspec] = ACTIONS(3759),
    [anon_sym___based] = ACTIONS(3759),
    [anon_sym_LBRACE] = ACTIONS(3785),
    [anon_sym_signed] = ACTIONS(3787),
    [anon_sym_unsigned] = ACTIONS(3787),
    [anon_sym_long] = ACTIONS(3787),
    [anon_sym_short] = ACTIONS(3787),
    [anon_sym_LBRACK] = ACTIONS(3771),
    [anon_sym_EQ] = ACTIONS(3793),
    [anon_sym_static] = ACTIONS(3759),
    [anon_sym_register] = ACTIONS(3759),
    [anon_sym_inline] = ACTIONS(3759),
    [anon_sym___inline] = ACTIONS(3759),
    [anon_sym___inline__] = ACTIONS(3759),
    [anon_sym___forceinline] = ACTIONS(3759),
    [anon_sym_thread_local] = ACTIONS(3759),
    [anon_sym___thread] = ACTIONS(3759),
    [anon_sym_const] = ACTIONS(3759),
    [anon_sym_constexpr] = ACTIONS(3759),
    [anon_sym_volatile] = ACTIONS(3759),
    [anon_sym_restrict] = ACTIONS(3759),
    [anon_sym___restrict__] = ACTIONS(3759),
    [anon_sym__Atomic] = ACTIONS(3759),
    [anon_sym__Noreturn] = ACTIONS(3759),
    [anon_sym_noreturn] = ACTIONS(3759),
    [anon_sym_mutable] = ACTIONS(3759),
    [anon_sym_constinit] = ACTIONS(3759),
    [anon_sym_consteval] = ACTIONS(3759),
    [anon_sym_PROGMEM] = ACTIONS(3759),
    [anon_sym_QMARK] = ACTIONS(3761),
    [anon_sym_STAR_EQ] = ACTIONS(3797),
    [anon_sym_SLASH_EQ] = ACTIONS(3797),
    [anon_sym_PERCENT_EQ] = ACTIONS(3797),
    [anon_sym_PLUS_EQ] = ACTIONS(3797),
    [anon_sym_DASH_EQ] = ACTIONS(3797),
    [anon_sym_LT_LT_EQ] = ACTIONS(3797),
    [anon_sym_GT_GT_EQ] = ACTIONS(3797),
    [anon_sym_AMP_EQ] = ACTIONS(3797),
    [anon_sym_CARET_EQ] = ACTIONS(3797),
    [anon_sym_PIPE_EQ] = ACTIONS(3797),
    [anon_sym_and_eq] = ACTIONS(3793),
    [anon_sym_or_eq] = ACTIONS(3793),
    [anon_sym_xor_eq] = ACTIONS(3793),
    [anon_sym_LT_EQ_GT] = ACTIONS(3761),
    [anon_sym_or] = ACTIONS(3769),
    [anon_sym_and] = ACTIONS(3769),
    [anon_sym_bitor] = ACTIONS(3769),
    [anon_sym_xor] = ACTIONS(3769),
    [anon_sym_bitand] = ACTIONS(3769),
    [anon_sym_not_eq] = ACTIONS(3769),
    [anon_sym_DASH_DASH] = ACTIONS(3761),
    [anon_sym_PLUS_PLUS] = ACTIONS(3761),
    [anon_sym_DOT] = ACTIONS(3769),
    [anon_sym_DOT_STAR] = ACTIONS(3761),
    [anon_sym_DASH_GT] = ACTIONS(3761),
    [anon_sym_L_DQUOTE] = ACTIONS(3204),
    [anon_sym_u_DQUOTE] = ACTIONS(3204),
    [anon_sym_U_DQUOTE] = ACTIONS(3204),
    [anon_sym_u8_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3204),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3759),
    [anon_sym_decltype] = ACTIONS(3759),
    [anon_sym_virtual] = ACTIONS(3759),
    [anon_sym_alignas] = ACTIONS(3759),
    [anon_sym_template] = ACTIONS(3759),
    [anon_sym_operator] = ACTIONS(3759),
    [anon_sym_R_DQUOTE] = ACTIONS(3208),
    [anon_sym_LR_DQUOTE] = ACTIONS(3208),
    [anon_sym_uR_DQUOTE] = ACTIONS(3208),
    [anon_sym_UR_DQUOTE] = ACTIONS(3208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3208),
  },
  [1095] = {
    [sym_compound_statement] = STATE(7176),
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4308),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(7176),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_RPAREN] = ACTIONS(4027),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym___extension__] = ACTIONS(4029),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(1807),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1096] = {
    [sym_compound_statement] = STATE(7122),
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4301),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(7122),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_RPAREN] = ACTIONS(4031),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym___extension__] = ACTIONS(4033),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(1807),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1097] = {
    [sym_string_literal] = STATE(2617),
    [sym_template_argument_list] = STATE(1779),
    [sym_raw_string_literal] = STATE(2617),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2716),
    [sym_identifier] = ACTIONS(3759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3761),
    [anon_sym_COMMA] = ACTIONS(3761),
    [anon_sym_LPAREN2] = ACTIONS(3774),
    [anon_sym_TILDE] = ACTIONS(3767),
    [anon_sym_DASH] = ACTIONS(3769),
    [anon_sym_PLUS] = ACTIONS(3769),
    [anon_sym_STAR] = ACTIONS(3771),
    [anon_sym_SLASH] = ACTIONS(3769),
    [anon_sym_PERCENT] = ACTIONS(3769),
    [anon_sym_PIPE_PIPE] = ACTIONS(3761),
    [anon_sym_AMP_AMP] = ACTIONS(3774),
    [anon_sym_PIPE] = ACTIONS(3769),
    [anon_sym_CARET] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(3771),
    [anon_sym_EQ_EQ] = ACTIONS(3761),
    [anon_sym_BANG_EQ] = ACTIONS(3761),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3761),
    [anon_sym_LT_EQ] = ACTIONS(3769),
    [anon_sym_LT] = ACTIONS(3777),
    [anon_sym_LT_LT] = ACTIONS(3769),
    [anon_sym_GT_GT] = ACTIONS(3769),
    [anon_sym_SEMI] = ACTIONS(3761),
    [anon_sym___extension__] = ACTIONS(3759),
    [anon_sym_extern] = ACTIONS(3759),
    [anon_sym___attribute__] = ACTIONS(3759),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3767),
    [anon_sym___declspec] = ACTIONS(3759),
    [anon_sym___based] = ACTIONS(3759),
    [anon_sym_LBRACE] = ACTIONS(3785),
    [anon_sym_signed] = ACTIONS(3787),
    [anon_sym_unsigned] = ACTIONS(3787),
    [anon_sym_long] = ACTIONS(3787),
    [anon_sym_short] = ACTIONS(3787),
    [anon_sym_LBRACK] = ACTIONS(3771),
    [anon_sym_EQ] = ACTIONS(3793),
    [anon_sym_static] = ACTIONS(3759),
    [anon_sym_register] = ACTIONS(3759),
    [anon_sym_inline] = ACTIONS(3759),
    [anon_sym___inline] = ACTIONS(3759),
    [anon_sym___inline__] = ACTIONS(3759),
    [anon_sym___forceinline] = ACTIONS(3759),
    [anon_sym_thread_local] = ACTIONS(3759),
    [anon_sym___thread] = ACTIONS(3759),
    [anon_sym_const] = ACTIONS(3759),
    [anon_sym_constexpr] = ACTIONS(3759),
    [anon_sym_volatile] = ACTIONS(3759),
    [anon_sym_restrict] = ACTIONS(3759),
    [anon_sym___restrict__] = ACTIONS(3759),
    [anon_sym__Atomic] = ACTIONS(3759),
    [anon_sym__Noreturn] = ACTIONS(3759),
    [anon_sym_noreturn] = ACTIONS(3759),
    [anon_sym_mutable] = ACTIONS(3759),
    [anon_sym_constinit] = ACTIONS(3759),
    [anon_sym_consteval] = ACTIONS(3759),
    [anon_sym_PROGMEM] = ACTIONS(3759),
    [anon_sym_COLON] = ACTIONS(3819),
    [anon_sym_QMARK] = ACTIONS(3761),
    [anon_sym_STAR_EQ] = ACTIONS(3797),
    [anon_sym_SLASH_EQ] = ACTIONS(3797),
    [anon_sym_PERCENT_EQ] = ACTIONS(3797),
    [anon_sym_PLUS_EQ] = ACTIONS(3797),
    [anon_sym_DASH_EQ] = ACTIONS(3797),
    [anon_sym_LT_LT_EQ] = ACTIONS(3797),
    [anon_sym_GT_GT_EQ] = ACTIONS(3797),
    [anon_sym_AMP_EQ] = ACTIONS(3797),
    [anon_sym_CARET_EQ] = ACTIONS(3797),
    [anon_sym_PIPE_EQ] = ACTIONS(3797),
    [anon_sym_and_eq] = ACTIONS(3793),
    [anon_sym_or_eq] = ACTIONS(3793),
    [anon_sym_xor_eq] = ACTIONS(3793),
    [anon_sym_LT_EQ_GT] = ACTIONS(3761),
    [anon_sym_or] = ACTIONS(3769),
    [anon_sym_and] = ACTIONS(3769),
    [anon_sym_bitor] = ACTIONS(3769),
    [anon_sym_xor] = ACTIONS(3769),
    [anon_sym_bitand] = ACTIONS(3769),
    [anon_sym_not_eq] = ACTIONS(3769),
    [anon_sym_DASH_DASH] = ACTIONS(3761),
    [anon_sym_PLUS_PLUS] = ACTIONS(3761),
    [anon_sym_DOT] = ACTIONS(3769),
    [anon_sym_DOT_STAR] = ACTIONS(3761),
    [anon_sym_DASH_GT] = ACTIONS(3761),
    [anon_sym_L_DQUOTE] = ACTIONS(3204),
    [anon_sym_u_DQUOTE] = ACTIONS(3204),
    [anon_sym_U_DQUOTE] = ACTIONS(3204),
    [anon_sym_u8_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3204),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3759),
    [anon_sym_decltype] = ACTIONS(3759),
    [anon_sym_virtual] = ACTIONS(3759),
    [anon_sym_alignas] = ACTIONS(3759),
    [anon_sym_template] = ACTIONS(3759),
    [anon_sym_operator] = ACTIONS(3759),
    [anon_sym_R_DQUOTE] = ACTIONS(3208),
    [anon_sym_LR_DQUOTE] = ACTIONS(3208),
    [anon_sym_uR_DQUOTE] = ACTIONS(3208),
    [anon_sym_UR_DQUOTE] = ACTIONS(3208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3208),
  },
  [1098] = {
    [sym_string_literal] = STATE(2405),
    [sym_template_argument_list] = STATE(1726),
    [sym_raw_string_literal] = STATE(2405),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2716),
    [sym_identifier] = ACTIONS(3759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3774),
    [anon_sym_COMMA] = ACTIONS(3774),
    [anon_sym_RPAREN] = ACTIONS(3774),
    [anon_sym_LPAREN2] = ACTIONS(3774),
    [anon_sym_TILDE] = ACTIONS(3767),
    [anon_sym_DASH] = ACTIONS(3769),
    [anon_sym_PLUS] = ACTIONS(3769),
    [anon_sym_STAR] = ACTIONS(3771),
    [anon_sym_SLASH] = ACTIONS(3769),
    [anon_sym_PERCENT] = ACTIONS(3769),
    [anon_sym_PIPE_PIPE] = ACTIONS(3761),
    [anon_sym_AMP_AMP] = ACTIONS(3774),
    [anon_sym_PIPE] = ACTIONS(3769),
    [anon_sym_CARET] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(3771),
    [anon_sym_EQ_EQ] = ACTIONS(3761),
    [anon_sym_BANG_EQ] = ACTIONS(3761),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3761),
    [anon_sym_LT_EQ] = ACTIONS(3769),
    [anon_sym_LT] = ACTIONS(4035),
    [anon_sym_LT_LT] = ACTIONS(3769),
    [anon_sym_GT_GT] = ACTIONS(3769),
    [anon_sym___extension__] = ACTIONS(3759),
    [anon_sym_extern] = ACTIONS(3759),
    [anon_sym___attribute__] = ACTIONS(3759),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3767),
    [anon_sym___declspec] = ACTIONS(3759),
    [anon_sym___based] = ACTIONS(3759),
    [anon_sym_LBRACE] = ACTIONS(3785),
    [anon_sym_signed] = ACTIONS(3787),
    [anon_sym_unsigned] = ACTIONS(3787),
    [anon_sym_long] = ACTIONS(3787),
    [anon_sym_short] = ACTIONS(3787),
    [anon_sym_LBRACK] = ACTIONS(3771),
    [anon_sym_EQ] = ACTIONS(3771),
    [anon_sym_static] = ACTIONS(3759),
    [anon_sym_register] = ACTIONS(3759),
    [anon_sym_inline] = ACTIONS(3759),
    [anon_sym___inline] = ACTIONS(3759),
    [anon_sym___inline__] = ACTIONS(3759),
    [anon_sym___forceinline] = ACTIONS(3759),
    [anon_sym_thread_local] = ACTIONS(3759),
    [anon_sym___thread] = ACTIONS(3759),
    [anon_sym_const] = ACTIONS(3759),
    [anon_sym_constexpr] = ACTIONS(3759),
    [anon_sym_volatile] = ACTIONS(3759),
    [anon_sym_restrict] = ACTIONS(3759),
    [anon_sym___restrict__] = ACTIONS(3759),
    [anon_sym__Atomic] = ACTIONS(3759),
    [anon_sym__Noreturn] = ACTIONS(3759),
    [anon_sym_noreturn] = ACTIONS(3759),
    [anon_sym_mutable] = ACTIONS(3759),
    [anon_sym_constinit] = ACTIONS(3759),
    [anon_sym_consteval] = ACTIONS(3759),
    [anon_sym_PROGMEM] = ACTIONS(3759),
    [anon_sym_QMARK] = ACTIONS(3761),
    [anon_sym_STAR_EQ] = ACTIONS(3761),
    [anon_sym_SLASH_EQ] = ACTIONS(3761),
    [anon_sym_PERCENT_EQ] = ACTIONS(3761),
    [anon_sym_PLUS_EQ] = ACTIONS(3761),
    [anon_sym_DASH_EQ] = ACTIONS(3761),
    [anon_sym_LT_LT_EQ] = ACTIONS(3761),
    [anon_sym_GT_GT_EQ] = ACTIONS(3761),
    [anon_sym_AMP_EQ] = ACTIONS(3761),
    [anon_sym_CARET_EQ] = ACTIONS(3761),
    [anon_sym_PIPE_EQ] = ACTIONS(3761),
    [anon_sym_and_eq] = ACTIONS(4038),
    [anon_sym_or_eq] = ACTIONS(4038),
    [anon_sym_xor_eq] = ACTIONS(4038),
    [anon_sym_LT_EQ_GT] = ACTIONS(3761),
    [anon_sym_or] = ACTIONS(3769),
    [anon_sym_and] = ACTIONS(3769),
    [anon_sym_bitor] = ACTIONS(3769),
    [anon_sym_xor] = ACTIONS(3769),
    [anon_sym_bitand] = ACTIONS(3769),
    [anon_sym_not_eq] = ACTIONS(3769),
    [anon_sym_DASH_DASH] = ACTIONS(3761),
    [anon_sym_PLUS_PLUS] = ACTIONS(3761),
    [anon_sym_DOT] = ACTIONS(3769),
    [anon_sym_DOT_STAR] = ACTIONS(3761),
    [anon_sym_DASH_GT] = ACTIONS(3769),
    [anon_sym_L_DQUOTE] = ACTIONS(4040),
    [anon_sym_u_DQUOTE] = ACTIONS(4040),
    [anon_sym_U_DQUOTE] = ACTIONS(4040),
    [anon_sym_u8_DQUOTE] = ACTIONS(4040),
    [anon_sym_DQUOTE] = ACTIONS(4040),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3759),
    [anon_sym_decltype] = ACTIONS(3759),
    [anon_sym_virtual] = ACTIONS(3759),
    [anon_sym_alignas] = ACTIONS(3759),
    [anon_sym_template] = ACTIONS(3759),
    [anon_sym_operator] = ACTIONS(3759),
    [anon_sym_R_DQUOTE] = ACTIONS(4042),
    [anon_sym_LR_DQUOTE] = ACTIONS(4042),
    [anon_sym_uR_DQUOTE] = ACTIONS(4042),
    [anon_sym_UR_DQUOTE] = ACTIONS(4042),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4042),
    [anon_sym_DASH_GT_STAR] = ACTIONS(3761),
  },
  [1099] = {
    [sym_string_literal] = STATE(2617),
    [sym_template_argument_list] = STATE(1779),
    [sym_raw_string_literal] = STATE(2617),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2716),
    [sym_identifier] = ACTIONS(3759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3761),
    [anon_sym_COMMA] = ACTIONS(3761),
    [anon_sym_LPAREN2] = ACTIONS(3774),
    [anon_sym_TILDE] = ACTIONS(3767),
    [anon_sym_DASH] = ACTIONS(3769),
    [anon_sym_PLUS] = ACTIONS(3769),
    [anon_sym_STAR] = ACTIONS(3771),
    [anon_sym_SLASH] = ACTIONS(3769),
    [anon_sym_PERCENT] = ACTIONS(3769),
    [anon_sym_PIPE_PIPE] = ACTIONS(3761),
    [anon_sym_AMP_AMP] = ACTIONS(3774),
    [anon_sym_PIPE] = ACTIONS(3769),
    [anon_sym_CARET] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(3771),
    [anon_sym_EQ_EQ] = ACTIONS(3761),
    [anon_sym_BANG_EQ] = ACTIONS(3761),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3761),
    [anon_sym_LT_EQ] = ACTIONS(3769),
    [anon_sym_LT] = ACTIONS(3777),
    [anon_sym_LT_LT] = ACTIONS(3769),
    [anon_sym_GT_GT] = ACTIONS(3769),
    [anon_sym_SEMI] = ACTIONS(3761),
    [anon_sym___extension__] = ACTIONS(3759),
    [anon_sym_extern] = ACTIONS(3759),
    [anon_sym___attribute__] = ACTIONS(3759),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3767),
    [anon_sym___declspec] = ACTIONS(3759),
    [anon_sym___based] = ACTIONS(3759),
    [anon_sym_LBRACE] = ACTIONS(3785),
    [anon_sym_signed] = ACTIONS(3787),
    [anon_sym_unsigned] = ACTIONS(3787),
    [anon_sym_long] = ACTIONS(3787),
    [anon_sym_short] = ACTIONS(3787),
    [anon_sym_LBRACK] = ACTIONS(3771),
    [anon_sym_EQ] = ACTIONS(3793),
    [anon_sym_static] = ACTIONS(3759),
    [anon_sym_register] = ACTIONS(3759),
    [anon_sym_inline] = ACTIONS(3759),
    [anon_sym___inline] = ACTIONS(3759),
    [anon_sym___inline__] = ACTIONS(3759),
    [anon_sym___forceinline] = ACTIONS(3759),
    [anon_sym_thread_local] = ACTIONS(3759),
    [anon_sym___thread] = ACTIONS(3759),
    [anon_sym_const] = ACTIONS(3759),
    [anon_sym_constexpr] = ACTIONS(3759),
    [anon_sym_volatile] = ACTIONS(3759),
    [anon_sym_restrict] = ACTIONS(3759),
    [anon_sym___restrict__] = ACTIONS(3759),
    [anon_sym__Atomic] = ACTIONS(3759),
    [anon_sym__Noreturn] = ACTIONS(3759),
    [anon_sym_noreturn] = ACTIONS(3759),
    [anon_sym_mutable] = ACTIONS(3759),
    [anon_sym_constinit] = ACTIONS(3759),
    [anon_sym_consteval] = ACTIONS(3759),
    [anon_sym_PROGMEM] = ACTIONS(3759),
    [anon_sym_COLON] = ACTIONS(3815),
    [anon_sym_QMARK] = ACTIONS(3761),
    [anon_sym_STAR_EQ] = ACTIONS(3797),
    [anon_sym_SLASH_EQ] = ACTIONS(3797),
    [anon_sym_PERCENT_EQ] = ACTIONS(3797),
    [anon_sym_PLUS_EQ] = ACTIONS(3797),
    [anon_sym_DASH_EQ] = ACTIONS(3797),
    [anon_sym_LT_LT_EQ] = ACTIONS(3797),
    [anon_sym_GT_GT_EQ] = ACTIONS(3797),
    [anon_sym_AMP_EQ] = ACTIONS(3797),
    [anon_sym_CARET_EQ] = ACTIONS(3797),
    [anon_sym_PIPE_EQ] = ACTIONS(3797),
    [anon_sym_and_eq] = ACTIONS(3793),
    [anon_sym_or_eq] = ACTIONS(3793),
    [anon_sym_xor_eq] = ACTIONS(3793),
    [anon_sym_LT_EQ_GT] = ACTIONS(3761),
    [anon_sym_or] = ACTIONS(3769),
    [anon_sym_and] = ACTIONS(3769),
    [anon_sym_bitor] = ACTIONS(3769),
    [anon_sym_xor] = ACTIONS(3769),
    [anon_sym_bitand] = ACTIONS(3769),
    [anon_sym_not_eq] = ACTIONS(3769),
    [anon_sym_DASH_DASH] = ACTIONS(3761),
    [anon_sym_PLUS_PLUS] = ACTIONS(3761),
    [anon_sym_DOT] = ACTIONS(3769),
    [anon_sym_DOT_STAR] = ACTIONS(3761),
    [anon_sym_DASH_GT] = ACTIONS(3761),
    [anon_sym_L_DQUOTE] = ACTIONS(3204),
    [anon_sym_u_DQUOTE] = ACTIONS(3204),
    [anon_sym_U_DQUOTE] = ACTIONS(3204),
    [anon_sym_u8_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3204),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3759),
    [anon_sym_decltype] = ACTIONS(3759),
    [anon_sym_virtual] = ACTIONS(3759),
    [anon_sym_alignas] = ACTIONS(3759),
    [anon_sym_template] = ACTIONS(3759),
    [anon_sym_operator] = ACTIONS(3759),
    [anon_sym_R_DQUOTE] = ACTIONS(3208),
    [anon_sym_LR_DQUOTE] = ACTIONS(3208),
    [anon_sym_uR_DQUOTE] = ACTIONS(3208),
    [anon_sym_UR_DQUOTE] = ACTIONS(3208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3208),
  },
  [1100] = {
    [sym_string_literal] = STATE(2617),
    [sym_template_argument_list] = STATE(1779),
    [sym_raw_string_literal] = STATE(2617),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2716),
    [sym_identifier] = ACTIONS(3759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3761),
    [anon_sym_COMMA] = ACTIONS(3761),
    [anon_sym_LPAREN2] = ACTIONS(3774),
    [anon_sym_TILDE] = ACTIONS(3767),
    [anon_sym_DASH] = ACTIONS(3769),
    [anon_sym_PLUS] = ACTIONS(3769),
    [anon_sym_STAR] = ACTIONS(3771),
    [anon_sym_SLASH] = ACTIONS(3769),
    [anon_sym_PERCENT] = ACTIONS(3769),
    [anon_sym_PIPE_PIPE] = ACTIONS(3761),
    [anon_sym_AMP_AMP] = ACTIONS(3774),
    [anon_sym_PIPE] = ACTIONS(3769),
    [anon_sym_CARET] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(3771),
    [anon_sym_EQ_EQ] = ACTIONS(3761),
    [anon_sym_BANG_EQ] = ACTIONS(3761),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3761),
    [anon_sym_LT_EQ] = ACTIONS(3769),
    [anon_sym_LT] = ACTIONS(3777),
    [anon_sym_LT_LT] = ACTIONS(3769),
    [anon_sym_GT_GT] = ACTIONS(3769),
    [anon_sym_SEMI] = ACTIONS(3761),
    [anon_sym___extension__] = ACTIONS(3759),
    [anon_sym_extern] = ACTIONS(3759),
    [anon_sym___attribute__] = ACTIONS(3759),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3767),
    [anon_sym___declspec] = ACTIONS(3759),
    [anon_sym___based] = ACTIONS(3759),
    [anon_sym_LBRACE] = ACTIONS(3785),
    [anon_sym_signed] = ACTIONS(3787),
    [anon_sym_unsigned] = ACTIONS(3787),
    [anon_sym_long] = ACTIONS(3787),
    [anon_sym_short] = ACTIONS(3787),
    [anon_sym_LBRACK] = ACTIONS(3771),
    [anon_sym_EQ] = ACTIONS(3793),
    [anon_sym_static] = ACTIONS(3759),
    [anon_sym_register] = ACTIONS(3759),
    [anon_sym_inline] = ACTIONS(3759),
    [anon_sym___inline] = ACTIONS(3759),
    [anon_sym___inline__] = ACTIONS(3759),
    [anon_sym___forceinline] = ACTIONS(3759),
    [anon_sym_thread_local] = ACTIONS(3759),
    [anon_sym___thread] = ACTIONS(3759),
    [anon_sym_const] = ACTIONS(3759),
    [anon_sym_constexpr] = ACTIONS(3759),
    [anon_sym_volatile] = ACTIONS(3759),
    [anon_sym_restrict] = ACTIONS(3759),
    [anon_sym___restrict__] = ACTIONS(3759),
    [anon_sym__Atomic] = ACTIONS(3759),
    [anon_sym__Noreturn] = ACTIONS(3759),
    [anon_sym_noreturn] = ACTIONS(3759),
    [anon_sym_mutable] = ACTIONS(3759),
    [anon_sym_constinit] = ACTIONS(3759),
    [anon_sym_consteval] = ACTIONS(3759),
    [anon_sym_PROGMEM] = ACTIONS(3759),
    [anon_sym_COLON] = ACTIONS(3851),
    [anon_sym_QMARK] = ACTIONS(3761),
    [anon_sym_STAR_EQ] = ACTIONS(3797),
    [anon_sym_SLASH_EQ] = ACTIONS(3797),
    [anon_sym_PERCENT_EQ] = ACTIONS(3797),
    [anon_sym_PLUS_EQ] = ACTIONS(3797),
    [anon_sym_DASH_EQ] = ACTIONS(3797),
    [anon_sym_LT_LT_EQ] = ACTIONS(3797),
    [anon_sym_GT_GT_EQ] = ACTIONS(3797),
    [anon_sym_AMP_EQ] = ACTIONS(3797),
    [anon_sym_CARET_EQ] = ACTIONS(3797),
    [anon_sym_PIPE_EQ] = ACTIONS(3797),
    [anon_sym_and_eq] = ACTIONS(3793),
    [anon_sym_or_eq] = ACTIONS(3793),
    [anon_sym_xor_eq] = ACTIONS(3793),
    [anon_sym_LT_EQ_GT] = ACTIONS(3761),
    [anon_sym_or] = ACTIONS(3769),
    [anon_sym_and] = ACTIONS(3769),
    [anon_sym_bitor] = ACTIONS(3769),
    [anon_sym_xor] = ACTIONS(3769),
    [anon_sym_bitand] = ACTIONS(3769),
    [anon_sym_not_eq] = ACTIONS(3769),
    [anon_sym_DASH_DASH] = ACTIONS(3761),
    [anon_sym_PLUS_PLUS] = ACTIONS(3761),
    [anon_sym_DOT] = ACTIONS(3769),
    [anon_sym_DOT_STAR] = ACTIONS(3761),
    [anon_sym_DASH_GT] = ACTIONS(3761),
    [anon_sym_L_DQUOTE] = ACTIONS(3204),
    [anon_sym_u_DQUOTE] = ACTIONS(3204),
    [anon_sym_U_DQUOTE] = ACTIONS(3204),
    [anon_sym_u8_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3204),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3759),
    [anon_sym_decltype] = ACTIONS(3759),
    [anon_sym_virtual] = ACTIONS(3759),
    [anon_sym_alignas] = ACTIONS(3759),
    [anon_sym_template] = ACTIONS(3759),
    [anon_sym_operator] = ACTIONS(3759),
    [anon_sym_R_DQUOTE] = ACTIONS(3208),
    [anon_sym_LR_DQUOTE] = ACTIONS(3208),
    [anon_sym_uR_DQUOTE] = ACTIONS(3208),
    [anon_sym_UR_DQUOTE] = ACTIONS(3208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3208),
  },
  [1101] = {
    [sym_string_literal] = STATE(2617),
    [sym_template_argument_list] = STATE(1779),
    [sym_raw_string_literal] = STATE(2617),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2716),
    [sym_identifier] = ACTIONS(3759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3761),
    [anon_sym_COMMA] = ACTIONS(3761),
    [anon_sym_LPAREN2] = ACTIONS(3774),
    [anon_sym_TILDE] = ACTIONS(3767),
    [anon_sym_DASH] = ACTIONS(3769),
    [anon_sym_PLUS] = ACTIONS(3769),
    [anon_sym_STAR] = ACTIONS(3771),
    [anon_sym_SLASH] = ACTIONS(3769),
    [anon_sym_PERCENT] = ACTIONS(3769),
    [anon_sym_PIPE_PIPE] = ACTIONS(3761),
    [anon_sym_AMP_AMP] = ACTIONS(3774),
    [anon_sym_PIPE] = ACTIONS(3769),
    [anon_sym_CARET] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(3771),
    [anon_sym_EQ_EQ] = ACTIONS(3761),
    [anon_sym_BANG_EQ] = ACTIONS(3761),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3761),
    [anon_sym_LT_EQ] = ACTIONS(3769),
    [anon_sym_LT] = ACTIONS(3777),
    [anon_sym_LT_LT] = ACTIONS(3769),
    [anon_sym_GT_GT] = ACTIONS(3769),
    [anon_sym_SEMI] = ACTIONS(3761),
    [anon_sym___extension__] = ACTIONS(3759),
    [anon_sym_extern] = ACTIONS(3759),
    [anon_sym___attribute__] = ACTIONS(3759),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3767),
    [anon_sym___declspec] = ACTIONS(3759),
    [anon_sym___based] = ACTIONS(3759),
    [anon_sym_LBRACE] = ACTIONS(3785),
    [anon_sym_signed] = ACTIONS(3787),
    [anon_sym_unsigned] = ACTIONS(3787),
    [anon_sym_long] = ACTIONS(3787),
    [anon_sym_short] = ACTIONS(3787),
    [anon_sym_LBRACK] = ACTIONS(3771),
    [anon_sym_EQ] = ACTIONS(3793),
    [anon_sym_static] = ACTIONS(3759),
    [anon_sym_register] = ACTIONS(3759),
    [anon_sym_inline] = ACTIONS(3759),
    [anon_sym___inline] = ACTIONS(3759),
    [anon_sym___inline__] = ACTIONS(3759),
    [anon_sym___forceinline] = ACTIONS(3759),
    [anon_sym_thread_local] = ACTIONS(3759),
    [anon_sym___thread] = ACTIONS(3759),
    [anon_sym_const] = ACTIONS(3759),
    [anon_sym_constexpr] = ACTIONS(3759),
    [anon_sym_volatile] = ACTIONS(3759),
    [anon_sym_restrict] = ACTIONS(3759),
    [anon_sym___restrict__] = ACTIONS(3759),
    [anon_sym__Atomic] = ACTIONS(3759),
    [anon_sym__Noreturn] = ACTIONS(3759),
    [anon_sym_noreturn] = ACTIONS(3759),
    [anon_sym_mutable] = ACTIONS(3759),
    [anon_sym_constinit] = ACTIONS(3759),
    [anon_sym_consteval] = ACTIONS(3759),
    [anon_sym_PROGMEM] = ACTIONS(3759),
    [anon_sym_COLON] = ACTIONS(4044),
    [anon_sym_QMARK] = ACTIONS(3761),
    [anon_sym_STAR_EQ] = ACTIONS(3797),
    [anon_sym_SLASH_EQ] = ACTIONS(3797),
    [anon_sym_PERCENT_EQ] = ACTIONS(3797),
    [anon_sym_PLUS_EQ] = ACTIONS(3797),
    [anon_sym_DASH_EQ] = ACTIONS(3797),
    [anon_sym_LT_LT_EQ] = ACTIONS(3797),
    [anon_sym_GT_GT_EQ] = ACTIONS(3797),
    [anon_sym_AMP_EQ] = ACTIONS(3797),
    [anon_sym_CARET_EQ] = ACTIONS(3797),
    [anon_sym_PIPE_EQ] = ACTIONS(3797),
    [anon_sym_and_eq] = ACTIONS(3793),
    [anon_sym_or_eq] = ACTIONS(3793),
    [anon_sym_xor_eq] = ACTIONS(3793),
    [anon_sym_LT_EQ_GT] = ACTIONS(3761),
    [anon_sym_or] = ACTIONS(3769),
    [anon_sym_and] = ACTIONS(3769),
    [anon_sym_bitor] = ACTIONS(3769),
    [anon_sym_xor] = ACTIONS(3769),
    [anon_sym_bitand] = ACTIONS(3769),
    [anon_sym_not_eq] = ACTIONS(3769),
    [anon_sym_DASH_DASH] = ACTIONS(3761),
    [anon_sym_PLUS_PLUS] = ACTIONS(3761),
    [anon_sym_DOT] = ACTIONS(3769),
    [anon_sym_DOT_STAR] = ACTIONS(3761),
    [anon_sym_DASH_GT] = ACTIONS(3761),
    [anon_sym_L_DQUOTE] = ACTIONS(3204),
    [anon_sym_u_DQUOTE] = ACTIONS(3204),
    [anon_sym_U_DQUOTE] = ACTIONS(3204),
    [anon_sym_u8_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3204),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3759),
    [anon_sym_decltype] = ACTIONS(3759),
    [anon_sym_virtual] = ACTIONS(3759),
    [anon_sym_alignas] = ACTIONS(3759),
    [anon_sym_template] = ACTIONS(3759),
    [anon_sym_operator] = ACTIONS(3759),
    [anon_sym_R_DQUOTE] = ACTIONS(3208),
    [anon_sym_LR_DQUOTE] = ACTIONS(3208),
    [anon_sym_uR_DQUOTE] = ACTIONS(3208),
    [anon_sym_UR_DQUOTE] = ACTIONS(3208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3208),
  },
  [1102] = {
    [sym_string_literal] = STATE(2617),
    [sym_template_argument_list] = STATE(1779),
    [sym_raw_string_literal] = STATE(2617),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2716),
    [sym_identifier] = ACTIONS(3759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3761),
    [anon_sym_COMMA] = ACTIONS(3761),
    [anon_sym_LPAREN2] = ACTIONS(3774),
    [anon_sym_TILDE] = ACTIONS(3767),
    [anon_sym_DASH] = ACTIONS(3769),
    [anon_sym_PLUS] = ACTIONS(3769),
    [anon_sym_STAR] = ACTIONS(3771),
    [anon_sym_SLASH] = ACTIONS(3769),
    [anon_sym_PERCENT] = ACTIONS(3769),
    [anon_sym_PIPE_PIPE] = ACTIONS(3761),
    [anon_sym_AMP_AMP] = ACTIONS(3774),
    [anon_sym_PIPE] = ACTIONS(3769),
    [anon_sym_CARET] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(3771),
    [anon_sym_EQ_EQ] = ACTIONS(3761),
    [anon_sym_BANG_EQ] = ACTIONS(3761),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3761),
    [anon_sym_LT_EQ] = ACTIONS(3769),
    [anon_sym_LT] = ACTIONS(3777),
    [anon_sym_LT_LT] = ACTIONS(3769),
    [anon_sym_GT_GT] = ACTIONS(3769),
    [anon_sym_SEMI] = ACTIONS(3761),
    [anon_sym___extension__] = ACTIONS(3759),
    [anon_sym_extern] = ACTIONS(3759),
    [anon_sym___attribute__] = ACTIONS(3759),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3767),
    [anon_sym___declspec] = ACTIONS(3759),
    [anon_sym___based] = ACTIONS(3759),
    [anon_sym_LBRACE] = ACTIONS(3785),
    [anon_sym_signed] = ACTIONS(3787),
    [anon_sym_unsigned] = ACTIONS(3787),
    [anon_sym_long] = ACTIONS(3787),
    [anon_sym_short] = ACTIONS(3787),
    [anon_sym_LBRACK] = ACTIONS(3771),
    [anon_sym_EQ] = ACTIONS(3793),
    [anon_sym_static] = ACTIONS(3759),
    [anon_sym_register] = ACTIONS(3759),
    [anon_sym_inline] = ACTIONS(3759),
    [anon_sym___inline] = ACTIONS(3759),
    [anon_sym___inline__] = ACTIONS(3759),
    [anon_sym___forceinline] = ACTIONS(3759),
    [anon_sym_thread_local] = ACTIONS(3759),
    [anon_sym___thread] = ACTIONS(3759),
    [anon_sym_const] = ACTIONS(3759),
    [anon_sym_constexpr] = ACTIONS(3759),
    [anon_sym_volatile] = ACTIONS(3759),
    [anon_sym_restrict] = ACTIONS(3759),
    [anon_sym___restrict__] = ACTIONS(3759),
    [anon_sym__Atomic] = ACTIONS(3759),
    [anon_sym__Noreturn] = ACTIONS(3759),
    [anon_sym_noreturn] = ACTIONS(3759),
    [anon_sym_mutable] = ACTIONS(3759),
    [anon_sym_constinit] = ACTIONS(3759),
    [anon_sym_consteval] = ACTIONS(3759),
    [anon_sym_PROGMEM] = ACTIONS(3759),
    [anon_sym_COLON] = ACTIONS(3817),
    [anon_sym_QMARK] = ACTIONS(3761),
    [anon_sym_STAR_EQ] = ACTIONS(3797),
    [anon_sym_SLASH_EQ] = ACTIONS(3797),
    [anon_sym_PERCENT_EQ] = ACTIONS(3797),
    [anon_sym_PLUS_EQ] = ACTIONS(3797),
    [anon_sym_DASH_EQ] = ACTIONS(3797),
    [anon_sym_LT_LT_EQ] = ACTIONS(3797),
    [anon_sym_GT_GT_EQ] = ACTIONS(3797),
    [anon_sym_AMP_EQ] = ACTIONS(3797),
    [anon_sym_CARET_EQ] = ACTIONS(3797),
    [anon_sym_PIPE_EQ] = ACTIONS(3797),
    [anon_sym_and_eq] = ACTIONS(3793),
    [anon_sym_or_eq] = ACTIONS(3793),
    [anon_sym_xor_eq] = ACTIONS(3793),
    [anon_sym_LT_EQ_GT] = ACTIONS(3761),
    [anon_sym_or] = ACTIONS(3769),
    [anon_sym_and] = ACTIONS(3769),
    [anon_sym_bitor] = ACTIONS(3769),
    [anon_sym_xor] = ACTIONS(3769),
    [anon_sym_bitand] = ACTIONS(3769),
    [anon_sym_not_eq] = ACTIONS(3769),
    [anon_sym_DASH_DASH] = ACTIONS(3761),
    [anon_sym_PLUS_PLUS] = ACTIONS(3761),
    [anon_sym_DOT] = ACTIONS(3769),
    [anon_sym_DOT_STAR] = ACTIONS(3761),
    [anon_sym_DASH_GT] = ACTIONS(3761),
    [anon_sym_L_DQUOTE] = ACTIONS(3204),
    [anon_sym_u_DQUOTE] = ACTIONS(3204),
    [anon_sym_U_DQUOTE] = ACTIONS(3204),
    [anon_sym_u8_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3204),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3759),
    [anon_sym_decltype] = ACTIONS(3759),
    [anon_sym_virtual] = ACTIONS(3759),
    [anon_sym_alignas] = ACTIONS(3759),
    [anon_sym_template] = ACTIONS(3759),
    [anon_sym_operator] = ACTIONS(3759),
    [anon_sym_R_DQUOTE] = ACTIONS(3208),
    [anon_sym_LR_DQUOTE] = ACTIONS(3208),
    [anon_sym_uR_DQUOTE] = ACTIONS(3208),
    [anon_sym_UR_DQUOTE] = ACTIONS(3208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3208),
  },
  [1103] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4183),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3440),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3440),
    [sym_call_expression] = STATE(3440),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3440),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3440),
    [sym_initializer_list] = STATE(6557),
    [sym_number_literal] = STATE(4352),
    [sym_char_literal] = STATE(4352),
    [sym_concatenated_string] = STATE(4364),
    [sym_string_literal] = STATE(3640),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3641),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3440),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3440),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_LPAREN2] = ACTIONS(4046),
    [anon_sym_BANG] = ACTIONS(3344),
    [anon_sym_TILDE] = ACTIONS(3344),
    [anon_sym_DASH] = ACTIONS(3342),
    [anon_sym_PLUS] = ACTIONS(3342),
    [anon_sym_STAR] = ACTIONS(4048),
    [anon_sym_AMP] = ACTIONS(4048),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_default] = ACTIONS(4050),
    [anon_sym_not] = ACTIONS(3342),
    [anon_sym_compl] = ACTIONS(3342),
    [anon_sym_DASH_DASH] = ACTIONS(4052),
    [anon_sym_PLUS_PLUS] = ACTIONS(4052),
    [anon_sym_sizeof] = ACTIONS(3348),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3352),
    [aux_sym_number_literal_token2] = ACTIONS(3352),
    [anon_sym_L_SQUOTE] = ACTIONS(3354),
    [anon_sym_u_SQUOTE] = ACTIONS(3354),
    [anon_sym_U_SQUOTE] = ACTIONS(3354),
    [anon_sym_u8_SQUOTE] = ACTIONS(3354),
    [anon_sym_SQUOTE] = ACTIONS(3354),
    [anon_sym_L_DQUOTE] = ACTIONS(3356),
    [anon_sym_u_DQUOTE] = ACTIONS(3356),
    [anon_sym_U_DQUOTE] = ACTIONS(3356),
    [anon_sym_u8_DQUOTE] = ACTIONS(3356),
    [anon_sym_DQUOTE] = ACTIONS(3356),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(4054),
    [anon_sym_0] = ACTIONS(4056),
    [anon_sym_R_DQUOTE] = ACTIONS(3360),
    [anon_sym_LR_DQUOTE] = ACTIONS(3360),
    [anon_sym_uR_DQUOTE] = ACTIONS(3360),
    [anon_sym_UR_DQUOTE] = ACTIONS(3360),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3360),
    [anon_sym_co_await] = ACTIONS(3362),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1104] = {
    [sym_primitive_type] = STATE(6853),
    [sym__expression] = STATE(3258),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7464),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym__unary_left_fold] = STATE(8432),
    [sym__unary_right_fold] = STATE(8431),
    [sym__binary_fold] = STATE(8419),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(7464),
    [sym_user_defined_literal] = STATE(3374),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1741),
    [anon_sym_LPAREN2] = ACTIONS(1745),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [1105] = {
    [sym_primitive_type] = STATE(6853),
    [sym__expression] = STATE(3352),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7464),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym__unary_left_fold] = STATE(8307),
    [sym__unary_right_fold] = STATE(7922),
    [sym__binary_fold] = STATE(8399),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(7464),
    [sym_user_defined_literal] = STATE(3374),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1741),
    [anon_sym_LPAREN2] = ACTIONS(1745),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [1106] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4492),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(7998),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(7998),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(4058),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1107] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4179),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3440),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3440),
    [sym_call_expression] = STATE(3440),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3440),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3440),
    [sym_initializer_list] = STATE(6577),
    [sym_number_literal] = STATE(4352),
    [sym_char_literal] = STATE(4352),
    [sym_concatenated_string] = STATE(4364),
    [sym_string_literal] = STATE(3640),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3641),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3440),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3440),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_LPAREN2] = ACTIONS(4046),
    [anon_sym_BANG] = ACTIONS(3344),
    [anon_sym_TILDE] = ACTIONS(3344),
    [anon_sym_DASH] = ACTIONS(3342),
    [anon_sym_PLUS] = ACTIONS(3342),
    [anon_sym_STAR] = ACTIONS(4048),
    [anon_sym_AMP] = ACTIONS(4048),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_default] = ACTIONS(4060),
    [anon_sym_not] = ACTIONS(3342),
    [anon_sym_compl] = ACTIONS(3342),
    [anon_sym_DASH_DASH] = ACTIONS(4052),
    [anon_sym_PLUS_PLUS] = ACTIONS(4052),
    [anon_sym_sizeof] = ACTIONS(3348),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3352),
    [aux_sym_number_literal_token2] = ACTIONS(3352),
    [anon_sym_L_SQUOTE] = ACTIONS(3354),
    [anon_sym_u_SQUOTE] = ACTIONS(3354),
    [anon_sym_U_SQUOTE] = ACTIONS(3354),
    [anon_sym_u8_SQUOTE] = ACTIONS(3354),
    [anon_sym_SQUOTE] = ACTIONS(3354),
    [anon_sym_L_DQUOTE] = ACTIONS(3356),
    [anon_sym_u_DQUOTE] = ACTIONS(3356),
    [anon_sym_U_DQUOTE] = ACTIONS(3356),
    [anon_sym_u8_DQUOTE] = ACTIONS(3356),
    [anon_sym_DQUOTE] = ACTIONS(3356),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(4062),
    [anon_sym_0] = ACTIONS(4064),
    [anon_sym_R_DQUOTE] = ACTIONS(3360),
    [anon_sym_LR_DQUOTE] = ACTIONS(3360),
    [anon_sym_uR_DQUOTE] = ACTIONS(3360),
    [anon_sym_UR_DQUOTE] = ACTIONS(3360),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3360),
    [anon_sym_co_await] = ACTIONS(3362),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1108] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4483),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(7641),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(7641),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(4066),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1109] = {
    [sym_primitive_type] = STATE(6853),
    [sym__expression] = STATE(3336),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7464),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym__unary_left_fold] = STATE(8217),
    [sym__unary_right_fold] = STATE(8305),
    [sym__binary_fold] = STATE(8302),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(7464),
    [sym_user_defined_literal] = STATE(3374),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1741),
    [anon_sym_LPAREN2] = ACTIONS(1745),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [1110] = {
    [sym_primitive_type] = STATE(6853),
    [sym__expression] = STATE(3252),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7464),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym__unary_left_fold] = STATE(7751),
    [sym__unary_right_fold] = STATE(7755),
    [sym__binary_fold] = STATE(7758),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(7464),
    [sym_user_defined_literal] = STATE(3374),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1741),
    [anon_sym_LPAREN2] = ACTIONS(1745),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [1111] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4351),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8068),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(8068),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(4068),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1112] = {
    [sym_string_literal] = STATE(2617),
    [sym_template_argument_list] = STATE(1777),
    [sym_raw_string_literal] = STATE(2617),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2716),
    [sym_identifier] = ACTIONS(3759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3774),
    [anon_sym_COMMA] = ACTIONS(3774),
    [anon_sym_RPAREN] = ACTIONS(3774),
    [anon_sym_LPAREN2] = ACTIONS(3774),
    [anon_sym_TILDE] = ACTIONS(3767),
    [anon_sym_DASH] = ACTIONS(3769),
    [anon_sym_PLUS] = ACTIONS(3769),
    [anon_sym_STAR] = ACTIONS(3771),
    [anon_sym_SLASH] = ACTIONS(3769),
    [anon_sym_PERCENT] = ACTIONS(3769),
    [anon_sym_PIPE_PIPE] = ACTIONS(3761),
    [anon_sym_AMP_AMP] = ACTIONS(3774),
    [anon_sym_PIPE] = ACTIONS(3769),
    [anon_sym_CARET] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(3771),
    [anon_sym_EQ_EQ] = ACTIONS(3761),
    [anon_sym_BANG_EQ] = ACTIONS(3761),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3761),
    [anon_sym_LT_EQ] = ACTIONS(3769),
    [anon_sym_LT] = ACTIONS(3777),
    [anon_sym_LT_LT] = ACTIONS(3769),
    [anon_sym_GT_GT] = ACTIONS(3769),
    [anon_sym___extension__] = ACTIONS(3759),
    [anon_sym_extern] = ACTIONS(3759),
    [anon_sym___attribute__] = ACTIONS(3759),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3767),
    [anon_sym___declspec] = ACTIONS(3759),
    [anon_sym___based] = ACTIONS(3759),
    [anon_sym_LBRACE] = ACTIONS(3785),
    [anon_sym_signed] = ACTIONS(3787),
    [anon_sym_unsigned] = ACTIONS(3787),
    [anon_sym_long] = ACTIONS(3787),
    [anon_sym_short] = ACTIONS(3787),
    [anon_sym_LBRACK] = ACTIONS(3771),
    [anon_sym_EQ] = ACTIONS(3759),
    [anon_sym_static] = ACTIONS(3759),
    [anon_sym_register] = ACTIONS(3759),
    [anon_sym_inline] = ACTIONS(3759),
    [anon_sym___inline] = ACTIONS(3759),
    [anon_sym___inline__] = ACTIONS(3759),
    [anon_sym___forceinline] = ACTIONS(3759),
    [anon_sym_thread_local] = ACTIONS(3759),
    [anon_sym___thread] = ACTIONS(3759),
    [anon_sym_const] = ACTIONS(3759),
    [anon_sym_constexpr] = ACTIONS(3759),
    [anon_sym_volatile] = ACTIONS(3759),
    [anon_sym_restrict] = ACTIONS(3759),
    [anon_sym___restrict__] = ACTIONS(3759),
    [anon_sym__Atomic] = ACTIONS(3759),
    [anon_sym__Noreturn] = ACTIONS(3759),
    [anon_sym_noreturn] = ACTIONS(3759),
    [anon_sym_mutable] = ACTIONS(3759),
    [anon_sym_constinit] = ACTIONS(3759),
    [anon_sym_consteval] = ACTIONS(3759),
    [anon_sym_PROGMEM] = ACTIONS(3759),
    [anon_sym_QMARK] = ACTIONS(3761),
    [anon_sym_STAR_EQ] = ACTIONS(3797),
    [anon_sym_SLASH_EQ] = ACTIONS(3797),
    [anon_sym_PERCENT_EQ] = ACTIONS(3797),
    [anon_sym_PLUS_EQ] = ACTIONS(3797),
    [anon_sym_DASH_EQ] = ACTIONS(3797),
    [anon_sym_LT_LT_EQ] = ACTIONS(3797),
    [anon_sym_GT_GT_EQ] = ACTIONS(3797),
    [anon_sym_AMP_EQ] = ACTIONS(3797),
    [anon_sym_CARET_EQ] = ACTIONS(3797),
    [anon_sym_PIPE_EQ] = ACTIONS(3797),
    [anon_sym_and_eq] = ACTIONS(3793),
    [anon_sym_or_eq] = ACTIONS(3793),
    [anon_sym_xor_eq] = ACTIONS(3793),
    [anon_sym_LT_EQ_GT] = ACTIONS(3761),
    [anon_sym_or] = ACTIONS(3769),
    [anon_sym_and] = ACTIONS(3769),
    [anon_sym_bitor] = ACTIONS(3769),
    [anon_sym_xor] = ACTIONS(3769),
    [anon_sym_bitand] = ACTIONS(3769),
    [anon_sym_not_eq] = ACTIONS(3769),
    [anon_sym_DASH_DASH] = ACTIONS(3761),
    [anon_sym_PLUS_PLUS] = ACTIONS(3761),
    [anon_sym_DOT] = ACTIONS(3769),
    [anon_sym_DOT_STAR] = ACTIONS(3761),
    [anon_sym_DASH_GT] = ACTIONS(3761),
    [anon_sym_L_DQUOTE] = ACTIONS(3204),
    [anon_sym_u_DQUOTE] = ACTIONS(3204),
    [anon_sym_U_DQUOTE] = ACTIONS(3204),
    [anon_sym_u8_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3204),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3759),
    [anon_sym_decltype] = ACTIONS(3759),
    [anon_sym_virtual] = ACTIONS(3759),
    [anon_sym_alignas] = ACTIONS(3759),
    [anon_sym_template] = ACTIONS(3759),
    [anon_sym_operator] = ACTIONS(3759),
    [anon_sym_R_DQUOTE] = ACTIONS(3208),
    [anon_sym_LR_DQUOTE] = ACTIONS(3208),
    [anon_sym_uR_DQUOTE] = ACTIONS(3208),
    [anon_sym_UR_DQUOTE] = ACTIONS(3208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3208),
  },
  [1113] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4448),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8084),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(8084),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(4070),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1114] = {
    [sym_primitive_type] = STATE(6853),
    [sym__expression] = STATE(3195),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7464),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym__unary_left_fold] = STATE(7683),
    [sym__unary_right_fold] = STATE(7679),
    [sym__binary_fold] = STATE(7678),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(7464),
    [sym_user_defined_literal] = STATE(3374),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1741),
    [anon_sym_LPAREN2] = ACTIONS(1745),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [1115] = {
    [sym_primitive_type] = STATE(6853),
    [sym__expression] = STATE(3282),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7464),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym__unary_left_fold] = STATE(8098),
    [sym__unary_right_fold] = STATE(8099),
    [sym__binary_fold] = STATE(8101),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(7464),
    [sym_user_defined_literal] = STATE(3374),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1741),
    [anon_sym_LPAREN2] = ACTIONS(1745),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [1116] = {
    [sym_primitive_type] = STATE(6853),
    [sym__expression] = STATE(3250),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7464),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym__unary_left_fold] = STATE(8124),
    [sym__unary_right_fold] = STATE(8123),
    [sym__binary_fold] = STATE(8122),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(7464),
    [sym_user_defined_literal] = STATE(3374),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1741),
    [anon_sym_LPAREN2] = ACTIONS(1745),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [1117] = {
    [sym_primitive_type] = STATE(6853),
    [sym__expression] = STATE(3203),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7464),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym__unary_left_fold] = STATE(8289),
    [sym__unary_right_fold] = STATE(8288),
    [sym__binary_fold] = STATE(8287),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(7464),
    [sym_user_defined_literal] = STATE(3374),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1741),
    [anon_sym_LPAREN2] = ACTIONS(1745),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [1118] = {
    [sym_primitive_type] = STATE(6853),
    [sym__expression] = STATE(3212),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7464),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym__unary_left_fold] = STATE(8050),
    [sym__unary_right_fold] = STATE(8049),
    [sym__binary_fold] = STATE(8048),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(7464),
    [sym_user_defined_literal] = STATE(3374),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1741),
    [anon_sym_LPAREN2] = ACTIONS(1745),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [1119] = {
    [sym_compound_statement] = STATE(7588),
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4488),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(7588),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym___extension__] = ACTIONS(4072),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(1807),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1120] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4418),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8135),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(8135),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1121] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4163),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3440),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3440),
    [sym_call_expression] = STATE(3440),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3440),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3440),
    [sym_initializer_list] = STATE(6586),
    [sym_number_literal] = STATE(4352),
    [sym_char_literal] = STATE(4352),
    [sym_concatenated_string] = STATE(4364),
    [sym_string_literal] = STATE(3640),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3641),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3440),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3440),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_LPAREN2] = ACTIONS(4046),
    [anon_sym_BANG] = ACTIONS(3344),
    [anon_sym_TILDE] = ACTIONS(3344),
    [anon_sym_DASH] = ACTIONS(3342),
    [anon_sym_PLUS] = ACTIONS(3342),
    [anon_sym_STAR] = ACTIONS(4048),
    [anon_sym_AMP] = ACTIONS(4048),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_default] = ACTIONS(4076),
    [anon_sym_not] = ACTIONS(3342),
    [anon_sym_compl] = ACTIONS(3342),
    [anon_sym_DASH_DASH] = ACTIONS(4052),
    [anon_sym_PLUS_PLUS] = ACTIONS(4052),
    [anon_sym_sizeof] = ACTIONS(3348),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3352),
    [aux_sym_number_literal_token2] = ACTIONS(3352),
    [anon_sym_L_SQUOTE] = ACTIONS(3354),
    [anon_sym_u_SQUOTE] = ACTIONS(3354),
    [anon_sym_U_SQUOTE] = ACTIONS(3354),
    [anon_sym_u8_SQUOTE] = ACTIONS(3354),
    [anon_sym_SQUOTE] = ACTIONS(3354),
    [anon_sym_L_DQUOTE] = ACTIONS(3356),
    [anon_sym_u_DQUOTE] = ACTIONS(3356),
    [anon_sym_U_DQUOTE] = ACTIONS(3356),
    [anon_sym_u8_DQUOTE] = ACTIONS(3356),
    [anon_sym_DQUOTE] = ACTIONS(3356),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(4078),
    [anon_sym_0] = ACTIONS(4080),
    [anon_sym_R_DQUOTE] = ACTIONS(3360),
    [anon_sym_LR_DQUOTE] = ACTIONS(3360),
    [anon_sym_uR_DQUOTE] = ACTIONS(3360),
    [anon_sym_UR_DQUOTE] = ACTIONS(3360),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3360),
    [anon_sym_co_await] = ACTIONS(3362),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1122] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4127),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(2961),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(2961),
    [sym_call_expression] = STATE(2961),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(2961),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(2961),
    [sym_number_literal] = STATE(4149),
    [sym_char_literal] = STATE(4149),
    [sym_concatenated_string] = STATE(4150),
    [sym_string_literal] = STATE(3034),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3026),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2961),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(2961),
    [sym_identifier] = ACTIONS(4082),
    [anon_sym_LPAREN2] = ACTIONS(4084),
    [anon_sym_BANG] = ACTIONS(3190),
    [anon_sym_TILDE] = ACTIONS(3190),
    [anon_sym_DASH] = ACTIONS(3188),
    [anon_sym_PLUS] = ACTIONS(3188),
    [anon_sym_STAR] = ACTIONS(4084),
    [anon_sym_AMP_AMP] = ACTIONS(4084),
    [anon_sym_AMP] = ACTIONS(4086),
    [anon_sym_LT] = ACTIONS(4084),
    [anon_sym_COLON_COLON] = ACTIONS(3192),
    [anon_sym_LBRACE] = ACTIONS(4084),
    [anon_sym_LBRACK] = ACTIONS(4084),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3188),
    [anon_sym_compl] = ACTIONS(3188),
    [anon_sym_DASH_DASH] = ACTIONS(4088),
    [anon_sym_PLUS_PLUS] = ACTIONS(4088),
    [anon_sym_sizeof] = ACTIONS(3196),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3198),
    [aux_sym_number_literal_token2] = ACTIONS(3200),
    [anon_sym_L_SQUOTE] = ACTIONS(3202),
    [anon_sym_u_SQUOTE] = ACTIONS(3202),
    [anon_sym_U_SQUOTE] = ACTIONS(3202),
    [anon_sym_u8_SQUOTE] = ACTIONS(3202),
    [anon_sym_SQUOTE] = ACTIONS(3202),
    [anon_sym_L_DQUOTE] = ACTIONS(3204),
    [anon_sym_u_DQUOTE] = ACTIONS(3204),
    [anon_sym_U_DQUOTE] = ACTIONS(3204),
    [anon_sym_u8_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3204),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3206),
    [anon_sym_R_DQUOTE] = ACTIONS(3208),
    [anon_sym_LR_DQUOTE] = ACTIONS(3208),
    [anon_sym_uR_DQUOTE] = ACTIONS(3208),
    [anon_sym_UR_DQUOTE] = ACTIONS(3208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3208),
    [anon_sym_co_await] = ACTIONS(3210),
    [anon_sym_new] = ACTIONS(3212),
    [anon_sym_requires] = ACTIONS(3214),
    [sym_this] = ACTIONS(219),
  },
  [1123] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4283),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_lambda_default_capture] = STATE(7462),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(4090),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(4092),
    [anon_sym_EQ] = ACTIONS(4094),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1124] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(3172),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(3292),
    [sym_char_literal] = STATE(3292),
    [sym_concatenated_string] = STATE(3308),
    [sym_string_literal] = STATE(2343),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2348),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1969),
    [anon_sym_LPAREN2] = ACTIONS(4084),
    [anon_sym_BANG] = ACTIONS(1973),
    [anon_sym_TILDE] = ACTIONS(1973),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_STAR] = ACTIONS(4084),
    [anon_sym_AMP_AMP] = ACTIONS(4084),
    [anon_sym_AMP] = ACTIONS(4086),
    [anon_sym_LT] = ACTIONS(4084),
    [anon_sym_COLON_COLON] = ACTIONS(1975),
    [anon_sym_LBRACE] = ACTIONS(4084),
    [anon_sym_LBRACK] = ACTIONS(4084),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1971),
    [anon_sym_compl] = ACTIONS(1971),
    [anon_sym_DASH_DASH] = ACTIONS(4096),
    [anon_sym_PLUS_PLUS] = ACTIONS(4096),
    [anon_sym_sizeof] = ACTIONS(1977),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1979),
    [aux_sym_number_literal_token2] = ACTIONS(1981),
    [anon_sym_L_SQUOTE] = ACTIONS(1983),
    [anon_sym_u_SQUOTE] = ACTIONS(1983),
    [anon_sym_U_SQUOTE] = ACTIONS(1983),
    [anon_sym_u8_SQUOTE] = ACTIONS(1983),
    [anon_sym_SQUOTE] = ACTIONS(1983),
    [anon_sym_L_DQUOTE] = ACTIONS(1985),
    [anon_sym_u_DQUOTE] = ACTIONS(1985),
    [anon_sym_U_DQUOTE] = ACTIONS(1985),
    [anon_sym_u8_DQUOTE] = ACTIONS(1985),
    [anon_sym_DQUOTE] = ACTIONS(1985),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1987),
    [anon_sym_R_DQUOTE] = ACTIONS(1989),
    [anon_sym_LR_DQUOTE] = ACTIONS(1989),
    [anon_sym_uR_DQUOTE] = ACTIONS(1989),
    [anon_sym_UR_DQUOTE] = ACTIONS(1989),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1989),
    [anon_sym_co_await] = ACTIONS(1991),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1125] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4283),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_lambda_default_capture] = STATE(7462),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(4090),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(4098),
    [anon_sym_EQ] = ACTIONS(4094),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1126] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4283),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_lambda_default_capture] = STATE(7462),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(4090),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(4100),
    [anon_sym_EQ] = ACTIONS(4094),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1127] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2775),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2832),
    [sym_char_literal] = STATE(2832),
    [sym_concatenated_string] = STATE(2831),
    [sym_string_literal] = STATE(1997),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(1998),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4084),
    [anon_sym_BANG] = ACTIONS(1889),
    [anon_sym_TILDE] = ACTIONS(1889),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_STAR] = ACTIONS(4084),
    [anon_sym_AMP_AMP] = ACTIONS(4084),
    [anon_sym_AMP] = ACTIONS(4086),
    [anon_sym_LT] = ACTIONS(4084),
    [anon_sym_COLON_COLON] = ACTIONS(1891),
    [anon_sym_LBRACE] = ACTIONS(4084),
    [anon_sym_LBRACK] = ACTIONS(4084),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1887),
    [anon_sym_compl] = ACTIONS(1887),
    [anon_sym_DASH_DASH] = ACTIONS(4102),
    [anon_sym_PLUS_PLUS] = ACTIONS(4102),
    [anon_sym_sizeof] = ACTIONS(1895),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1905),
    [aux_sym_number_literal_token2] = ACTIONS(1907),
    [anon_sym_L_SQUOTE] = ACTIONS(1909),
    [anon_sym_u_SQUOTE] = ACTIONS(1909),
    [anon_sym_U_SQUOTE] = ACTIONS(1909),
    [anon_sym_u8_SQUOTE] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(1909),
    [anon_sym_L_DQUOTE] = ACTIONS(1911),
    [anon_sym_u_DQUOTE] = ACTIONS(1911),
    [anon_sym_U_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8_DQUOTE] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(1911),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1919),
    [anon_sym_R_DQUOTE] = ACTIONS(1921),
    [anon_sym_LR_DQUOTE] = ACTIONS(1921),
    [anon_sym_uR_DQUOTE] = ACTIONS(1921),
    [anon_sym_UR_DQUOTE] = ACTIONS(1921),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1921),
    [anon_sym_co_await] = ACTIONS(1923),
    [anon_sym_new] = ACTIONS(1925),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1128] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4283),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_lambda_default_capture] = STATE(7462),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(4090),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(4104),
    [anon_sym_EQ] = ACTIONS(4094),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1129] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4427),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(4084),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(4084),
    [anon_sym_AMP_AMP] = ACTIONS(4084),
    [anon_sym_AMP] = ACTIONS(4086),
    [anon_sym_LT] = ACTIONS(4084),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACE] = ACTIONS(4084),
    [anon_sym_LBRACK] = ACTIONS(4084),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1130] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4244),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3440),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3440),
    [sym_call_expression] = STATE(3440),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3440),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3440),
    [sym_number_literal] = STATE(4352),
    [sym_char_literal] = STATE(4352),
    [sym_concatenated_string] = STATE(4364),
    [sym_string_literal] = STATE(3640),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3641),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3440),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3440),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_LPAREN2] = ACTIONS(4084),
    [anon_sym_BANG] = ACTIONS(3344),
    [anon_sym_TILDE] = ACTIONS(3344),
    [anon_sym_DASH] = ACTIONS(3342),
    [anon_sym_PLUS] = ACTIONS(3342),
    [anon_sym_STAR] = ACTIONS(4084),
    [anon_sym_AMP_AMP] = ACTIONS(4084),
    [anon_sym_AMP] = ACTIONS(4086),
    [anon_sym_LT] = ACTIONS(4084),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_LBRACE] = ACTIONS(4084),
    [anon_sym_LBRACK] = ACTIONS(4084),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3342),
    [anon_sym_compl] = ACTIONS(3342),
    [anon_sym_DASH_DASH] = ACTIONS(4052),
    [anon_sym_PLUS_PLUS] = ACTIONS(4052),
    [anon_sym_sizeof] = ACTIONS(3348),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3350),
    [aux_sym_number_literal_token2] = ACTIONS(3352),
    [anon_sym_L_SQUOTE] = ACTIONS(3354),
    [anon_sym_u_SQUOTE] = ACTIONS(3354),
    [anon_sym_U_SQUOTE] = ACTIONS(3354),
    [anon_sym_u8_SQUOTE] = ACTIONS(3354),
    [anon_sym_SQUOTE] = ACTIONS(3354),
    [anon_sym_L_DQUOTE] = ACTIONS(3356),
    [anon_sym_u_DQUOTE] = ACTIONS(3356),
    [anon_sym_U_DQUOTE] = ACTIONS(3356),
    [anon_sym_u8_DQUOTE] = ACTIONS(3356),
    [anon_sym_DQUOTE] = ACTIONS(3356),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3358),
    [anon_sym_R_DQUOTE] = ACTIONS(3360),
    [anon_sym_LR_DQUOTE] = ACTIONS(3360),
    [anon_sym_uR_DQUOTE] = ACTIONS(3360),
    [anon_sym_UR_DQUOTE] = ACTIONS(3360),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3360),
    [anon_sym_co_await] = ACTIONS(3362),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1131] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4283),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_lambda_default_capture] = STATE(7462),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(4090),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(4106),
    [anon_sym_EQ] = ACTIONS(4094),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1132] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2771),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2832),
    [sym_char_literal] = STATE(2832),
    [sym_concatenated_string] = STATE(2831),
    [sym_string_literal] = STATE(1997),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(1998),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4084),
    [anon_sym_BANG] = ACTIONS(1889),
    [anon_sym_TILDE] = ACTIONS(1889),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_STAR] = ACTIONS(4084),
    [anon_sym_AMP_AMP] = ACTIONS(4084),
    [anon_sym_AMP] = ACTIONS(4086),
    [anon_sym_LT] = ACTIONS(4084),
    [anon_sym_COLON_COLON] = ACTIONS(1891),
    [anon_sym_LBRACE] = ACTIONS(4084),
    [anon_sym_LBRACK] = ACTIONS(4084),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1887),
    [anon_sym_compl] = ACTIONS(1887),
    [anon_sym_DASH_DASH] = ACTIONS(4102),
    [anon_sym_PLUS_PLUS] = ACTIONS(4102),
    [anon_sym_sizeof] = ACTIONS(1895),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1905),
    [aux_sym_number_literal_token2] = ACTIONS(1907),
    [anon_sym_L_SQUOTE] = ACTIONS(1909),
    [anon_sym_u_SQUOTE] = ACTIONS(1909),
    [anon_sym_U_SQUOTE] = ACTIONS(1909),
    [anon_sym_u8_SQUOTE] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(1909),
    [anon_sym_L_DQUOTE] = ACTIONS(1911),
    [anon_sym_u_DQUOTE] = ACTIONS(1911),
    [anon_sym_U_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8_DQUOTE] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(1911),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1919),
    [anon_sym_R_DQUOTE] = ACTIONS(1921),
    [anon_sym_LR_DQUOTE] = ACTIONS(1921),
    [anon_sym_uR_DQUOTE] = ACTIONS(1921),
    [anon_sym_UR_DQUOTE] = ACTIONS(1921),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1921),
    [anon_sym_co_await] = ACTIONS(1923),
    [anon_sym_new] = ACTIONS(1925),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1133] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4283),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_lambda_default_capture] = STATE(7462),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(4090),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(4108),
    [anon_sym_EQ] = ACTIONS(4094),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1134] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4250),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_lambda_default_capture] = STATE(7462),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(4110),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(4090),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(4092),
    [anon_sym_EQ] = ACTIONS(4094),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1135] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4283),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_lambda_default_capture] = STATE(7462),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(4110),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(4090),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(4092),
    [anon_sym_EQ] = ACTIONS(4094),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1136] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4216),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(4084),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(4084),
    [anon_sym_AMP_AMP] = ACTIONS(4084),
    [anon_sym_AMP] = ACTIONS(4086),
    [anon_sym_LT] = ACTIONS(4084),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(4084),
    [anon_sym_LBRACK] = ACTIONS(4084),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1137] = {
    [sym_primitive_type] = STATE(6848),
    [sym__expression] = STATE(3091),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7357),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(7357),
    [sym_user_defined_literal] = STATE(3526),
    [sym_identifier] = ACTIONS(1965),
    [anon_sym_LPAREN2] = ACTIONS(4084),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(4084),
    [anon_sym_AMP_AMP] = ACTIONS(4084),
    [anon_sym_AMP] = ACTIONS(4086),
    [anon_sym_LT] = ACTIONS(4084),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_LBRACE] = ACTIONS(4084),
    [anon_sym_LBRACK] = ACTIONS(4084),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [1138] = {
    [sym_primitive_type] = STATE(6613),
    [sym__expression] = STATE(3301),
    [sym__expression_not_binary] = STATE(3637),
    [sym__string] = STATE(3637),
    [sym_conditional_expression] = STATE(3637),
    [sym_assignment_expression] = STATE(3637),
    [sym_pointer_expression] = STATE(3637),
    [sym_unary_expression] = STATE(3637),
    [sym_binary_expression] = STATE(3637),
    [sym_update_expression] = STATE(3637),
    [sym_cast_expression] = STATE(3637),
    [sym_sizeof_expression] = STATE(3637),
    [sym_alignof_expression] = STATE(3637),
    [sym_offsetof_expression] = STATE(3637),
    [sym_generic_expression] = STATE(3637),
    [sym_subscript_expression] = STATE(3637),
    [sym_call_expression] = STATE(3637),
    [sym_gnu_asm_expression] = STATE(3637),
    [sym_field_expression] = STATE(3637),
    [sym_compound_literal_expression] = STATE(3637),
    [sym_parenthesized_expression] = STATE(3637),
    [sym_number_literal] = STATE(3416),
    [sym_char_literal] = STATE(3416),
    [sym_concatenated_string] = STATE(3415),
    [sym_string_literal] = STATE(2430),
    [sym_null] = STATE(3637),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7434),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3637),
    [sym_raw_string_literal] = STATE(2419),
    [sym_co_await_expression] = STATE(3637),
    [sym_new_expression] = STATE(3637),
    [sym_delete_expression] = STATE(3637),
    [sym_requires_clause] = STATE(3637),
    [sym_requires_expression] = STATE(3637),
    [sym_lambda_expression] = STATE(3637),
    [sym_lambda_capture_specifier] = STATE(5725),
    [sym_fold_expression] = STATE(3637),
    [sym_parameter_pack_expansion] = STATE(3637),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5512),
    [sym_qualified_identifier] = STATE(3637),
    [sym_qualified_type_identifier] = STATE(7434),
    [sym_user_defined_literal] = STATE(3637),
    [sym_identifier] = ACTIONS(2228),
    [anon_sym_LPAREN2] = ACTIONS(4084),
    [anon_sym_BANG] = ACTIONS(2232),
    [anon_sym_TILDE] = ACTIONS(2232),
    [anon_sym_DASH] = ACTIONS(2230),
    [anon_sym_PLUS] = ACTIONS(2230),
    [anon_sym_STAR] = ACTIONS(4084),
    [anon_sym_AMP_AMP] = ACTIONS(4084),
    [anon_sym_AMP] = ACTIONS(4086),
    [anon_sym_LT] = ACTIONS(4084),
    [anon_sym_COLON_COLON] = ACTIONS(2234),
    [anon_sym_LBRACE] = ACTIONS(4084),
    [anon_sym_LBRACK] = ACTIONS(4084),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2230),
    [anon_sym_compl] = ACTIONS(2230),
    [anon_sym_DASH_DASH] = ACTIONS(4112),
    [anon_sym_PLUS_PLUS] = ACTIONS(4112),
    [anon_sym_sizeof] = ACTIONS(2238),
    [anon_sym___alignof__] = ACTIONS(2240),
    [anon_sym___alignof] = ACTIONS(2240),
    [anon_sym__alignof] = ACTIONS(2240),
    [anon_sym_alignof] = ACTIONS(2240),
    [anon_sym__Alignof] = ACTIONS(2240),
    [anon_sym_offsetof] = ACTIONS(2242),
    [anon_sym__Generic] = ACTIONS(2244),
    [anon_sym_asm] = ACTIONS(2246),
    [anon_sym___asm__] = ACTIONS(2246),
    [aux_sym_number_literal_token1] = ACTIONS(2248),
    [aux_sym_number_literal_token2] = ACTIONS(2250),
    [anon_sym_L_SQUOTE] = ACTIONS(2252),
    [anon_sym_u_SQUOTE] = ACTIONS(2252),
    [anon_sym_U_SQUOTE] = ACTIONS(2252),
    [anon_sym_u8_SQUOTE] = ACTIONS(2252),
    [anon_sym_SQUOTE] = ACTIONS(2252),
    [anon_sym_L_DQUOTE] = ACTIONS(2254),
    [anon_sym_u_DQUOTE] = ACTIONS(2254),
    [anon_sym_U_DQUOTE] = ACTIONS(2254),
    [anon_sym_u8_DQUOTE] = ACTIONS(2254),
    [anon_sym_DQUOTE] = ACTIONS(2254),
    [sym_true] = ACTIONS(2256),
    [sym_false] = ACTIONS(2256),
    [anon_sym_NULL] = ACTIONS(2258),
    [anon_sym_nullptr] = ACTIONS(2258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2260),
    [anon_sym_R_DQUOTE] = ACTIONS(2262),
    [anon_sym_LR_DQUOTE] = ACTIONS(2262),
    [anon_sym_uR_DQUOTE] = ACTIONS(2262),
    [anon_sym_UR_DQUOTE] = ACTIONS(2262),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2262),
    [anon_sym_co_await] = ACTIONS(2264),
    [anon_sym_new] = ACTIONS(2266),
    [anon_sym_requires] = ACTIONS(2268),
    [sym_this] = ACTIONS(2256),
  },
  [1139] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4283),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_lambda_default_capture] = STATE(7462),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(4090),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(4114),
    [anon_sym_EQ] = ACTIONS(4094),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1140] = {
    [sym_primitive_type] = STATE(6613),
    [sym__expression] = STATE(3326),
    [sym__expression_not_binary] = STATE(3637),
    [sym__string] = STATE(3637),
    [sym_conditional_expression] = STATE(3637),
    [sym_assignment_expression] = STATE(3637),
    [sym_pointer_expression] = STATE(3637),
    [sym_unary_expression] = STATE(3637),
    [sym_binary_expression] = STATE(3637),
    [sym_update_expression] = STATE(3637),
    [sym_cast_expression] = STATE(3637),
    [sym_sizeof_expression] = STATE(3637),
    [sym_alignof_expression] = STATE(3637),
    [sym_offsetof_expression] = STATE(3637),
    [sym_generic_expression] = STATE(3637),
    [sym_subscript_expression] = STATE(3637),
    [sym_call_expression] = STATE(3637),
    [sym_gnu_asm_expression] = STATE(3637),
    [sym_field_expression] = STATE(3637),
    [sym_compound_literal_expression] = STATE(3637),
    [sym_parenthesized_expression] = STATE(3637),
    [sym_number_literal] = STATE(3416),
    [sym_char_literal] = STATE(3416),
    [sym_concatenated_string] = STATE(3415),
    [sym_string_literal] = STATE(2430),
    [sym_null] = STATE(3637),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7434),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3637),
    [sym_raw_string_literal] = STATE(2419),
    [sym_co_await_expression] = STATE(3637),
    [sym_new_expression] = STATE(3637),
    [sym_delete_expression] = STATE(3637),
    [sym_requires_clause] = STATE(3637),
    [sym_requires_expression] = STATE(3637),
    [sym_lambda_expression] = STATE(3637),
    [sym_lambda_capture_specifier] = STATE(5725),
    [sym_fold_expression] = STATE(3637),
    [sym_parameter_pack_expansion] = STATE(3637),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5512),
    [sym_qualified_identifier] = STATE(3637),
    [sym_qualified_type_identifier] = STATE(7434),
    [sym_user_defined_literal] = STATE(3637),
    [sym_identifier] = ACTIONS(2228),
    [anon_sym_LPAREN2] = ACTIONS(4084),
    [anon_sym_BANG] = ACTIONS(2232),
    [anon_sym_TILDE] = ACTIONS(2232),
    [anon_sym_DASH] = ACTIONS(2230),
    [anon_sym_PLUS] = ACTIONS(2230),
    [anon_sym_STAR] = ACTIONS(4084),
    [anon_sym_AMP_AMP] = ACTIONS(4084),
    [anon_sym_AMP] = ACTIONS(4086),
    [anon_sym_LT] = ACTIONS(4084),
    [anon_sym_COLON_COLON] = ACTIONS(2234),
    [anon_sym_LBRACE] = ACTIONS(4084),
    [anon_sym_LBRACK] = ACTIONS(4084),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2230),
    [anon_sym_compl] = ACTIONS(2230),
    [anon_sym_DASH_DASH] = ACTIONS(4112),
    [anon_sym_PLUS_PLUS] = ACTIONS(4112),
    [anon_sym_sizeof] = ACTIONS(2238),
    [anon_sym___alignof__] = ACTIONS(2240),
    [anon_sym___alignof] = ACTIONS(2240),
    [anon_sym__alignof] = ACTIONS(2240),
    [anon_sym_alignof] = ACTIONS(2240),
    [anon_sym__Alignof] = ACTIONS(2240),
    [anon_sym_offsetof] = ACTIONS(2242),
    [anon_sym__Generic] = ACTIONS(2244),
    [anon_sym_asm] = ACTIONS(2246),
    [anon_sym___asm__] = ACTIONS(2246),
    [aux_sym_number_literal_token1] = ACTIONS(2248),
    [aux_sym_number_literal_token2] = ACTIONS(2250),
    [anon_sym_L_SQUOTE] = ACTIONS(2252),
    [anon_sym_u_SQUOTE] = ACTIONS(2252),
    [anon_sym_U_SQUOTE] = ACTIONS(2252),
    [anon_sym_u8_SQUOTE] = ACTIONS(2252),
    [anon_sym_SQUOTE] = ACTIONS(2252),
    [anon_sym_L_DQUOTE] = ACTIONS(2254),
    [anon_sym_u_DQUOTE] = ACTIONS(2254),
    [anon_sym_U_DQUOTE] = ACTIONS(2254),
    [anon_sym_u8_DQUOTE] = ACTIONS(2254),
    [anon_sym_DQUOTE] = ACTIONS(2254),
    [sym_true] = ACTIONS(2256),
    [sym_false] = ACTIONS(2256),
    [anon_sym_NULL] = ACTIONS(2258),
    [anon_sym_nullptr] = ACTIONS(2258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2260),
    [anon_sym_R_DQUOTE] = ACTIONS(2262),
    [anon_sym_LR_DQUOTE] = ACTIONS(2262),
    [anon_sym_uR_DQUOTE] = ACTIONS(2262),
    [anon_sym_UR_DQUOTE] = ACTIONS(2262),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2262),
    [anon_sym_co_await] = ACTIONS(2264),
    [anon_sym_new] = ACTIONS(2266),
    [anon_sym_requires] = ACTIONS(2268),
    [sym_this] = ACTIONS(2256),
  },
  [1141] = {
    [sym_primitive_type] = STATE(6848),
    [sym__expression] = STATE(3136),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7357),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(7357),
    [sym_user_defined_literal] = STATE(3526),
    [sym_identifier] = ACTIONS(1965),
    [anon_sym_LPAREN2] = ACTIONS(4084),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(4084),
    [anon_sym_AMP_AMP] = ACTIONS(4084),
    [anon_sym_AMP] = ACTIONS(4086),
    [anon_sym_LT] = ACTIONS(4084),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_LBRACE] = ACTIONS(4084),
    [anon_sym_LBRACK] = ACTIONS(4084),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [1142] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4283),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_lambda_default_capture] = STATE(7462),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(4090),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(4116),
    [anon_sym_EQ] = ACTIONS(4094),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1143] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4409),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(4084),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(4084),
    [anon_sym_AMP_AMP] = ACTIONS(4084),
    [anon_sym_AMP] = ACTIONS(4086),
    [anon_sym_LT] = ACTIONS(4084),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACE] = ACTIONS(4084),
    [anon_sym_LBRACK] = ACTIONS(4084),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1144] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4283),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_lambda_default_capture] = STATE(7462),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(4090),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(4118),
    [anon_sym_EQ] = ACTIONS(4094),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1145] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2973),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4084),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_TILDE] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1931),
    [anon_sym_PLUS] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(4084),
    [anon_sym_AMP_AMP] = ACTIONS(4084),
    [anon_sym_AMP] = ACTIONS(4086),
    [anon_sym_LT] = ACTIONS(4084),
    [anon_sym_COLON_COLON] = ACTIONS(1935),
    [anon_sym_LBRACE] = ACTIONS(4084),
    [anon_sym_LBRACK] = ACTIONS(4084),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1931),
    [anon_sym_compl] = ACTIONS(1931),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_sizeof] = ACTIONS(1937),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1146] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4200),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(4084),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(4084),
    [anon_sym_AMP_AMP] = ACTIONS(4084),
    [anon_sym_AMP] = ACTIONS(4086),
    [anon_sym_LT] = ACTIONS(4084),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(4084),
    [anon_sym_LBRACK] = ACTIONS(4084),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1147] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4283),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_lambda_default_capture] = STATE(7462),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(4090),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(4120),
    [anon_sym_EQ] = ACTIONS(4094),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1148] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4407),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3679),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3679),
    [sym_call_expression] = STATE(3679),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3679),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3679),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3679),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3679),
    [sym_identifier] = ACTIONS(3538),
    [anon_sym_LPAREN2] = ACTIONS(4084),
    [anon_sym_BANG] = ACTIONS(3542),
    [anon_sym_TILDE] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3540),
    [anon_sym_PLUS] = ACTIONS(3540),
    [anon_sym_STAR] = ACTIONS(4084),
    [anon_sym_AMP_AMP] = ACTIONS(4084),
    [anon_sym_AMP] = ACTIONS(4086),
    [anon_sym_LT] = ACTIONS(4084),
    [anon_sym_COLON_COLON] = ACTIONS(3544),
    [anon_sym_LBRACE] = ACTIONS(4084),
    [anon_sym_LBRACK] = ACTIONS(4084),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3540),
    [anon_sym_compl] = ACTIONS(3540),
    [anon_sym_DASH_DASH] = ACTIONS(4122),
    [anon_sym_PLUS_PLUS] = ACTIONS(4122),
    [anon_sym_sizeof] = ACTIONS(3546),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3548),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3550),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1149] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4283),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_lambda_default_capture] = STATE(7462),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(4090),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(4124),
    [anon_sym_EQ] = ACTIONS(4094),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1150] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4403),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3679),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3679),
    [sym_call_expression] = STATE(3679),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3679),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3679),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3679),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3679),
    [sym_identifier] = ACTIONS(3538),
    [anon_sym_LPAREN2] = ACTIONS(4084),
    [anon_sym_BANG] = ACTIONS(3542),
    [anon_sym_TILDE] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3540),
    [anon_sym_PLUS] = ACTIONS(3540),
    [anon_sym_STAR] = ACTIONS(4084),
    [anon_sym_AMP_AMP] = ACTIONS(4084),
    [anon_sym_AMP] = ACTIONS(4086),
    [anon_sym_LT] = ACTIONS(4084),
    [anon_sym_COLON_COLON] = ACTIONS(3544),
    [anon_sym_LBRACE] = ACTIONS(4084),
    [anon_sym_LBRACK] = ACTIONS(4084),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3540),
    [anon_sym_compl] = ACTIONS(3540),
    [anon_sym_DASH_DASH] = ACTIONS(4122),
    [anon_sym_PLUS_PLUS] = ACTIONS(4122),
    [anon_sym_sizeof] = ACTIONS(3546),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3548),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3550),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1151] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4250),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_lambda_default_capture] = STATE(7462),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(4090),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(4092),
    [anon_sym_EQ] = ACTIONS(4094),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1152] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4283),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_lambda_default_capture] = STATE(7462),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(4090),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(4126),
    [anon_sym_EQ] = ACTIONS(4094),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1153] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4129),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(2961),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(2961),
    [sym_call_expression] = STATE(2961),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(2961),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(2961),
    [sym_number_literal] = STATE(4149),
    [sym_char_literal] = STATE(4149),
    [sym_concatenated_string] = STATE(4150),
    [sym_string_literal] = STATE(3034),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3026),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2961),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(2961),
    [sym_identifier] = ACTIONS(4082),
    [anon_sym_LPAREN2] = ACTIONS(4084),
    [anon_sym_BANG] = ACTIONS(3190),
    [anon_sym_TILDE] = ACTIONS(3190),
    [anon_sym_DASH] = ACTIONS(3188),
    [anon_sym_PLUS] = ACTIONS(3188),
    [anon_sym_STAR] = ACTIONS(4084),
    [anon_sym_AMP_AMP] = ACTIONS(4084),
    [anon_sym_AMP] = ACTIONS(4086),
    [anon_sym_LT] = ACTIONS(4084),
    [anon_sym_COLON_COLON] = ACTIONS(3192),
    [anon_sym_LBRACE] = ACTIONS(4084),
    [anon_sym_LBRACK] = ACTIONS(4084),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3188),
    [anon_sym_compl] = ACTIONS(3188),
    [anon_sym_DASH_DASH] = ACTIONS(4088),
    [anon_sym_PLUS_PLUS] = ACTIONS(4088),
    [anon_sym_sizeof] = ACTIONS(3196),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3198),
    [aux_sym_number_literal_token2] = ACTIONS(3200),
    [anon_sym_L_SQUOTE] = ACTIONS(3202),
    [anon_sym_u_SQUOTE] = ACTIONS(3202),
    [anon_sym_U_SQUOTE] = ACTIONS(3202),
    [anon_sym_u8_SQUOTE] = ACTIONS(3202),
    [anon_sym_SQUOTE] = ACTIONS(3202),
    [anon_sym_L_DQUOTE] = ACTIONS(3204),
    [anon_sym_u_DQUOTE] = ACTIONS(3204),
    [anon_sym_U_DQUOTE] = ACTIONS(3204),
    [anon_sym_u8_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3204),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3206),
    [anon_sym_R_DQUOTE] = ACTIONS(3208),
    [anon_sym_LR_DQUOTE] = ACTIONS(3208),
    [anon_sym_uR_DQUOTE] = ACTIONS(3208),
    [anon_sym_UR_DQUOTE] = ACTIONS(3208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3208),
    [anon_sym_co_await] = ACTIONS(3210),
    [anon_sym_new] = ACTIONS(3212),
    [anon_sym_requires] = ACTIONS(3214),
    [sym_this] = ACTIONS(219),
  },
  [1154] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2974),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4084),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_TILDE] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1931),
    [anon_sym_PLUS] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(4084),
    [anon_sym_AMP_AMP] = ACTIONS(4084),
    [anon_sym_AMP] = ACTIONS(4086),
    [anon_sym_LT] = ACTIONS(4084),
    [anon_sym_COLON_COLON] = ACTIONS(1935),
    [anon_sym_LBRACE] = ACTIONS(4084),
    [anon_sym_LBRACK] = ACTIONS(4084),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1931),
    [anon_sym_compl] = ACTIONS(1931),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_sizeof] = ACTIONS(1937),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1155] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4283),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_lambda_default_capture] = STATE(7462),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(4090),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(4128),
    [anon_sym_EQ] = ACTIONS(4094),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1156] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4283),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_lambda_default_capture] = STATE(7462),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(4090),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(4130),
    [anon_sym_EQ] = ACTIONS(4094),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1157] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4339),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_initializer_list] = STATE(6927),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(4132),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1158] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4283),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_lambda_default_capture] = STATE(7462),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(4090),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(4134),
    [anon_sym_EQ] = ACTIONS(4094),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1159] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(3217),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4084),
    [anon_sym_BANG] = ACTIONS(2218),
    [anon_sym_TILDE] = ACTIONS(2218),
    [anon_sym_DASH] = ACTIONS(2216),
    [anon_sym_PLUS] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(4084),
    [anon_sym_AMP_AMP] = ACTIONS(4084),
    [anon_sym_AMP] = ACTIONS(4086),
    [anon_sym_LT] = ACTIONS(4084),
    [anon_sym_COLON_COLON] = ACTIONS(2220),
    [anon_sym_LBRACE] = ACTIONS(4084),
    [anon_sym_LBRACK] = ACTIONS(4084),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2216),
    [anon_sym_compl] = ACTIONS(2216),
    [anon_sym_DASH_DASH] = ACTIONS(4136),
    [anon_sym_PLUS_PLUS] = ACTIONS(4136),
    [anon_sym_sizeof] = ACTIONS(2222),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2224),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(2226),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1160] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4283),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_lambda_default_capture] = STATE(7462),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(4090),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(4138),
    [anon_sym_EQ] = ACTIONS(4094),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1161] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(3196),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4084),
    [anon_sym_BANG] = ACTIONS(2218),
    [anon_sym_TILDE] = ACTIONS(2218),
    [anon_sym_DASH] = ACTIONS(2216),
    [anon_sym_PLUS] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(4084),
    [anon_sym_AMP_AMP] = ACTIONS(4084),
    [anon_sym_AMP] = ACTIONS(4086),
    [anon_sym_LT] = ACTIONS(4084),
    [anon_sym_COLON_COLON] = ACTIONS(2220),
    [anon_sym_LBRACE] = ACTIONS(4084),
    [anon_sym_LBRACK] = ACTIONS(4084),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2216),
    [anon_sym_compl] = ACTIONS(2216),
    [anon_sym_DASH_DASH] = ACTIONS(4136),
    [anon_sym_PLUS_PLUS] = ACTIONS(4136),
    [anon_sym_sizeof] = ACTIONS(2222),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2224),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(2226),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1162] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4283),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_lambda_default_capture] = STATE(7462),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(4090),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(4140),
    [anon_sym_EQ] = ACTIONS(4094),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1163] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4283),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_lambda_default_capture] = STATE(7462),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(4090),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(4142),
    [anon_sym_EQ] = ACTIONS(4094),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1164] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4283),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_lambda_default_capture] = STATE(7462),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(4090),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(4144),
    [anon_sym_EQ] = ACTIONS(4094),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1165] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4283),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_lambda_default_capture] = STATE(7462),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(4090),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(4146),
    [anon_sym_EQ] = ACTIONS(4094),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1166] = {
    [sym_primitive_type] = STATE(6853),
    [sym__expression] = STATE(3620),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7464),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(7464),
    [sym_user_defined_literal] = STATE(3374),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_LPAREN2] = ACTIONS(4084),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(4084),
    [anon_sym_AMP_AMP] = ACTIONS(4084),
    [anon_sym_AMP] = ACTIONS(4086),
    [anon_sym_LT] = ACTIONS(4084),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACE] = ACTIONS(4084),
    [anon_sym_LBRACK] = ACTIONS(4084),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [1167] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4238),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3440),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3440),
    [sym_call_expression] = STATE(3440),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3440),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3440),
    [sym_number_literal] = STATE(4352),
    [sym_char_literal] = STATE(4352),
    [sym_concatenated_string] = STATE(4364),
    [sym_string_literal] = STATE(3640),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3641),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3440),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3440),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_LPAREN2] = ACTIONS(4084),
    [anon_sym_BANG] = ACTIONS(3344),
    [anon_sym_TILDE] = ACTIONS(3344),
    [anon_sym_DASH] = ACTIONS(3342),
    [anon_sym_PLUS] = ACTIONS(3342),
    [anon_sym_STAR] = ACTIONS(4084),
    [anon_sym_AMP_AMP] = ACTIONS(4084),
    [anon_sym_AMP] = ACTIONS(4086),
    [anon_sym_LT] = ACTIONS(4084),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_LBRACE] = ACTIONS(4084),
    [anon_sym_LBRACK] = ACTIONS(4084),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3342),
    [anon_sym_compl] = ACTIONS(3342),
    [anon_sym_DASH_DASH] = ACTIONS(4052),
    [anon_sym_PLUS_PLUS] = ACTIONS(4052),
    [anon_sym_sizeof] = ACTIONS(3348),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3350),
    [aux_sym_number_literal_token2] = ACTIONS(3352),
    [anon_sym_L_SQUOTE] = ACTIONS(3354),
    [anon_sym_u_SQUOTE] = ACTIONS(3354),
    [anon_sym_U_SQUOTE] = ACTIONS(3354),
    [anon_sym_u8_SQUOTE] = ACTIONS(3354),
    [anon_sym_SQUOTE] = ACTIONS(3354),
    [anon_sym_L_DQUOTE] = ACTIONS(3356),
    [anon_sym_u_DQUOTE] = ACTIONS(3356),
    [anon_sym_U_DQUOTE] = ACTIONS(3356),
    [anon_sym_u8_DQUOTE] = ACTIONS(3356),
    [anon_sym_DQUOTE] = ACTIONS(3356),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3358),
    [anon_sym_R_DQUOTE] = ACTIONS(3360),
    [anon_sym_LR_DQUOTE] = ACTIONS(3360),
    [anon_sym_uR_DQUOTE] = ACTIONS(3360),
    [anon_sym_UR_DQUOTE] = ACTIONS(3360),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3360),
    [anon_sym_co_await] = ACTIONS(3362),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1168] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4283),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_lambda_default_capture] = STATE(7462),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(4090),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(4148),
    [anon_sym_EQ] = ACTIONS(4094),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1169] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4283),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_lambda_default_capture] = STATE(7462),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(4090),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(4150),
    [anon_sym_EQ] = ACTIONS(4094),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1170] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4547),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(7902),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4152),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1171] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4547),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(7902),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4155),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1172] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4280),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_initializer_list] = STATE(7057),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(4158),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1173] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4547),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(7902),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4160),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1174] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4547),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(7902),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4163),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1175] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4547),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(7902),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4166),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1176] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4547),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(7902),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4169),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1177] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4547),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(7902),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4172),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1178] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4547),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(7902),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4175),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1179] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4547),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(7902),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4178),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1180] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4547),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(7902),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4181),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1181] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4547),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(7902),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4184),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1182] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4283),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_lambda_default_capture] = STATE(7462),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(4090),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(4187),
    [anon_sym_EQ] = ACTIONS(4094),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1183] = {
    [sym_primitive_type] = STATE(6853),
    [sym__expression] = STATE(3585),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7464),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(7464),
    [sym_user_defined_literal] = STATE(3374),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_LPAREN2] = ACTIONS(4084),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(4084),
    [anon_sym_AMP_AMP] = ACTIONS(4084),
    [anon_sym_AMP] = ACTIONS(4086),
    [anon_sym_LT] = ACTIONS(4084),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACE] = ACTIONS(4084),
    [anon_sym_LBRACK] = ACTIONS(4084),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [1184] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4283),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_lambda_default_capture] = STATE(7462),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(4090),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(4189),
    [anon_sym_EQ] = ACTIONS(4094),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1185] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4283),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_lambda_default_capture] = STATE(7462),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(4090),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(4191),
    [anon_sym_EQ] = ACTIONS(4094),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1186] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4283),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_lambda_default_capture] = STATE(7462),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(4090),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(4193),
    [anon_sym_EQ] = ACTIONS(4094),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1187] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(3175),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(3292),
    [sym_char_literal] = STATE(3292),
    [sym_concatenated_string] = STATE(3308),
    [sym_string_literal] = STATE(2343),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2348),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1969),
    [anon_sym_LPAREN2] = ACTIONS(4084),
    [anon_sym_BANG] = ACTIONS(1973),
    [anon_sym_TILDE] = ACTIONS(1973),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_STAR] = ACTIONS(4084),
    [anon_sym_AMP_AMP] = ACTIONS(4084),
    [anon_sym_AMP] = ACTIONS(4086),
    [anon_sym_LT] = ACTIONS(4084),
    [anon_sym_COLON_COLON] = ACTIONS(1975),
    [anon_sym_LBRACE] = ACTIONS(4084),
    [anon_sym_LBRACK] = ACTIONS(4084),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1971),
    [anon_sym_compl] = ACTIONS(1971),
    [anon_sym_DASH_DASH] = ACTIONS(4096),
    [anon_sym_PLUS_PLUS] = ACTIONS(4096),
    [anon_sym_sizeof] = ACTIONS(1977),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1979),
    [aux_sym_number_literal_token2] = ACTIONS(1981),
    [anon_sym_L_SQUOTE] = ACTIONS(1983),
    [anon_sym_u_SQUOTE] = ACTIONS(1983),
    [anon_sym_U_SQUOTE] = ACTIONS(1983),
    [anon_sym_u8_SQUOTE] = ACTIONS(1983),
    [anon_sym_SQUOTE] = ACTIONS(1983),
    [anon_sym_L_DQUOTE] = ACTIONS(1985),
    [anon_sym_u_DQUOTE] = ACTIONS(1985),
    [anon_sym_U_DQUOTE] = ACTIONS(1985),
    [anon_sym_u8_DQUOTE] = ACTIONS(1985),
    [anon_sym_DQUOTE] = ACTIONS(1985),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1987),
    [anon_sym_R_DQUOTE] = ACTIONS(1989),
    [anon_sym_LR_DQUOTE] = ACTIONS(1989),
    [anon_sym_uR_DQUOTE] = ACTIONS(1989),
    [anon_sym_UR_DQUOTE] = ACTIONS(1989),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1989),
    [anon_sym_co_await] = ACTIONS(1991),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1188] = {
    [sym_primitive_type] = STATE(6669),
    [sym__expression] = STATE(4378),
    [sym__expression_not_binary] = STATE(4648),
    [sym__string] = STATE(4648),
    [sym_conditional_expression] = STATE(4648),
    [sym_assignment_expression] = STATE(4648),
    [sym_pointer_expression] = STATE(3663),
    [sym_unary_expression] = STATE(4648),
    [sym_binary_expression] = STATE(4648),
    [sym_update_expression] = STATE(4648),
    [sym_cast_expression] = STATE(4648),
    [sym_sizeof_expression] = STATE(4648),
    [sym_alignof_expression] = STATE(4648),
    [sym_offsetof_expression] = STATE(4648),
    [sym_generic_expression] = STATE(4648),
    [sym_subscript_expression] = STATE(3663),
    [sym_call_expression] = STATE(3663),
    [sym_gnu_asm_expression] = STATE(4648),
    [sym_field_expression] = STATE(3663),
    [sym_compound_literal_expression] = STATE(4648),
    [sym_parenthesized_expression] = STATE(3663),
    [sym_number_literal] = STATE(4573),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4565),
    [sym_string_literal] = STATE(3707),
    [sym_null] = STATE(4648),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7442),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(4648),
    [sym_raw_string_literal] = STATE(3709),
    [sym_co_await_expression] = STATE(4648),
    [sym_new_expression] = STATE(4648),
    [sym_delete_expression] = STATE(4648),
    [sym_requires_clause] = STATE(4648),
    [sym_requires_expression] = STATE(4648),
    [sym_lambda_expression] = STATE(4648),
    [sym_lambda_capture_specifier] = STATE(5768),
    [sym_fold_expression] = STATE(4648),
    [sym_parameter_pack_expansion] = STATE(4648),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5512),
    [sym_qualified_identifier] = STATE(3663),
    [sym_qualified_type_identifier] = STATE(7442),
    [sym_user_defined_literal] = STATE(3663),
    [sym_identifier] = ACTIONS(3458),
    [anon_sym_LPAREN2] = ACTIONS(4084),
    [anon_sym_BANG] = ACTIONS(2577),
    [anon_sym_TILDE] = ACTIONS(2577),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_STAR] = ACTIONS(4084),
    [anon_sym_AMP_AMP] = ACTIONS(4084),
    [anon_sym_AMP] = ACTIONS(4086),
    [anon_sym_LT] = ACTIONS(4084),
    [anon_sym_COLON_COLON] = ACTIONS(2583),
    [anon_sym_LBRACE] = ACTIONS(4084),
    [anon_sym_LBRACK] = ACTIONS(4084),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2579),
    [anon_sym_compl] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(2597),
    [anon_sym_PLUS_PLUS] = ACTIONS(2597),
    [anon_sym_sizeof] = ACTIONS(2599),
    [anon_sym___alignof__] = ACTIONS(2601),
    [anon_sym___alignof] = ACTIONS(2601),
    [anon_sym__alignof] = ACTIONS(2601),
    [anon_sym_alignof] = ACTIONS(2601),
    [anon_sym__Alignof] = ACTIONS(2601),
    [anon_sym_offsetof] = ACTIONS(2603),
    [anon_sym__Generic] = ACTIONS(2605),
    [anon_sym_asm] = ACTIONS(2607),
    [anon_sym___asm__] = ACTIONS(2607),
    [aux_sym_number_literal_token1] = ACTIONS(2609),
    [aux_sym_number_literal_token2] = ACTIONS(2611),
    [anon_sym_L_SQUOTE] = ACTIONS(2613),
    [anon_sym_u_SQUOTE] = ACTIONS(2613),
    [anon_sym_U_SQUOTE] = ACTIONS(2613),
    [anon_sym_u8_SQUOTE] = ACTIONS(2613),
    [anon_sym_SQUOTE] = ACTIONS(2613),
    [anon_sym_L_DQUOTE] = ACTIONS(2615),
    [anon_sym_u_DQUOTE] = ACTIONS(2615),
    [anon_sym_U_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8_DQUOTE] = ACTIONS(2615),
    [anon_sym_DQUOTE] = ACTIONS(2615),
    [sym_true] = ACTIONS(2617),
    [sym_false] = ACTIONS(2617),
    [anon_sym_NULL] = ACTIONS(2619),
    [anon_sym_nullptr] = ACTIONS(2619),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2629),
    [anon_sym_R_DQUOTE] = ACTIONS(2631),
    [anon_sym_LR_DQUOTE] = ACTIONS(2631),
    [anon_sym_uR_DQUOTE] = ACTIONS(2631),
    [anon_sym_UR_DQUOTE] = ACTIONS(2631),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2631),
    [anon_sym_co_await] = ACTIONS(2633),
    [anon_sym_new] = ACTIONS(2635),
    [anon_sym_requires] = ACTIONS(2637),
    [sym_this] = ACTIONS(2617),
  },
  [1189] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4283),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_lambda_default_capture] = STATE(7462),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(4090),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(4195),
    [anon_sym_EQ] = ACTIONS(4094),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1190] = {
    [sym_primitive_type] = STATE(6669),
    [sym__expression] = STATE(4353),
    [sym__expression_not_binary] = STATE(4648),
    [sym__string] = STATE(4648),
    [sym_conditional_expression] = STATE(4648),
    [sym_assignment_expression] = STATE(4648),
    [sym_pointer_expression] = STATE(3663),
    [sym_unary_expression] = STATE(4648),
    [sym_binary_expression] = STATE(4648),
    [sym_update_expression] = STATE(4648),
    [sym_cast_expression] = STATE(4648),
    [sym_sizeof_expression] = STATE(4648),
    [sym_alignof_expression] = STATE(4648),
    [sym_offsetof_expression] = STATE(4648),
    [sym_generic_expression] = STATE(4648),
    [sym_subscript_expression] = STATE(3663),
    [sym_call_expression] = STATE(3663),
    [sym_gnu_asm_expression] = STATE(4648),
    [sym_field_expression] = STATE(3663),
    [sym_compound_literal_expression] = STATE(4648),
    [sym_parenthesized_expression] = STATE(3663),
    [sym_number_literal] = STATE(4573),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4565),
    [sym_string_literal] = STATE(3707),
    [sym_null] = STATE(4648),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7442),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(4648),
    [sym_raw_string_literal] = STATE(3709),
    [sym_co_await_expression] = STATE(4648),
    [sym_new_expression] = STATE(4648),
    [sym_delete_expression] = STATE(4648),
    [sym_requires_clause] = STATE(4648),
    [sym_requires_expression] = STATE(4648),
    [sym_lambda_expression] = STATE(4648),
    [sym_lambda_capture_specifier] = STATE(5768),
    [sym_fold_expression] = STATE(4648),
    [sym_parameter_pack_expansion] = STATE(4648),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5512),
    [sym_qualified_identifier] = STATE(3663),
    [sym_qualified_type_identifier] = STATE(7442),
    [sym_user_defined_literal] = STATE(3663),
    [sym_identifier] = ACTIONS(3458),
    [anon_sym_LPAREN2] = ACTIONS(4084),
    [anon_sym_BANG] = ACTIONS(2577),
    [anon_sym_TILDE] = ACTIONS(2577),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_STAR] = ACTIONS(4084),
    [anon_sym_AMP_AMP] = ACTIONS(4084),
    [anon_sym_AMP] = ACTIONS(4086),
    [anon_sym_LT] = ACTIONS(4084),
    [anon_sym_COLON_COLON] = ACTIONS(2583),
    [anon_sym_LBRACE] = ACTIONS(4084),
    [anon_sym_LBRACK] = ACTIONS(4084),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2579),
    [anon_sym_compl] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(2597),
    [anon_sym_PLUS_PLUS] = ACTIONS(2597),
    [anon_sym_sizeof] = ACTIONS(2599),
    [anon_sym___alignof__] = ACTIONS(2601),
    [anon_sym___alignof] = ACTIONS(2601),
    [anon_sym__alignof] = ACTIONS(2601),
    [anon_sym_alignof] = ACTIONS(2601),
    [anon_sym__Alignof] = ACTIONS(2601),
    [anon_sym_offsetof] = ACTIONS(2603),
    [anon_sym__Generic] = ACTIONS(2605),
    [anon_sym_asm] = ACTIONS(2607),
    [anon_sym___asm__] = ACTIONS(2607),
    [aux_sym_number_literal_token1] = ACTIONS(2609),
    [aux_sym_number_literal_token2] = ACTIONS(2611),
    [anon_sym_L_SQUOTE] = ACTIONS(2613),
    [anon_sym_u_SQUOTE] = ACTIONS(2613),
    [anon_sym_U_SQUOTE] = ACTIONS(2613),
    [anon_sym_u8_SQUOTE] = ACTIONS(2613),
    [anon_sym_SQUOTE] = ACTIONS(2613),
    [anon_sym_L_DQUOTE] = ACTIONS(2615),
    [anon_sym_u_DQUOTE] = ACTIONS(2615),
    [anon_sym_U_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8_DQUOTE] = ACTIONS(2615),
    [anon_sym_DQUOTE] = ACTIONS(2615),
    [sym_true] = ACTIONS(2617),
    [sym_false] = ACTIONS(2617),
    [anon_sym_NULL] = ACTIONS(2619),
    [anon_sym_nullptr] = ACTIONS(2619),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2629),
    [anon_sym_R_DQUOTE] = ACTIONS(2631),
    [anon_sym_LR_DQUOTE] = ACTIONS(2631),
    [anon_sym_uR_DQUOTE] = ACTIONS(2631),
    [anon_sym_UR_DQUOTE] = ACTIONS(2631),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2631),
    [anon_sym_co_await] = ACTIONS(2633),
    [anon_sym_new] = ACTIONS(2635),
    [anon_sym_requires] = ACTIONS(2637),
    [sym_this] = ACTIONS(2617),
  },
  [1191] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4257),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_initializer_list] = STATE(7080),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(4197),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1192] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4446),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8360),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3679),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3679),
    [sym_call_expression] = STATE(3679),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3679),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3679),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3679),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3679),
    [sym_identifier] = ACTIONS(3538),
    [anon_sym_LPAREN2] = ACTIONS(4199),
    [anon_sym_BANG] = ACTIONS(3542),
    [anon_sym_TILDE] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3540),
    [anon_sym_PLUS] = ACTIONS(3540),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(3544),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_COLON] = ACTIONS(4203),
    [anon_sym_not] = ACTIONS(3540),
    [anon_sym_compl] = ACTIONS(3540),
    [anon_sym_DASH_DASH] = ACTIONS(4122),
    [anon_sym_PLUS_PLUS] = ACTIONS(4122),
    [anon_sym_sizeof] = ACTIONS(3546),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3548),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3550),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1193] = {
    [sym_primitive_type] = STATE(6848),
    [sym__expression] = STATE(3064),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_initializer_list] = STATE(3357),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7357),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(7357),
    [sym_user_defined_literal] = STATE(3526),
    [sym_identifier] = ACTIONS(1965),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_LBRACE] = ACTIONS(1967),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [1194] = {
    [sym_primitive_type] = STATE(6669),
    [sym__expression] = STATE(4347),
    [sym__expression_not_binary] = STATE(4648),
    [sym__string] = STATE(4648),
    [sym_conditional_expression] = STATE(4648),
    [sym_assignment_expression] = STATE(4648),
    [sym_pointer_expression] = STATE(3663),
    [sym_unary_expression] = STATE(4648),
    [sym_binary_expression] = STATE(4648),
    [sym_update_expression] = STATE(4648),
    [sym_cast_expression] = STATE(4648),
    [sym_sizeof_expression] = STATE(4648),
    [sym_alignof_expression] = STATE(4648),
    [sym_offsetof_expression] = STATE(4648),
    [sym_generic_expression] = STATE(4648),
    [sym_subscript_expression] = STATE(3663),
    [sym_call_expression] = STATE(3663),
    [sym_gnu_asm_expression] = STATE(4648),
    [sym_field_expression] = STATE(3663),
    [sym_compound_literal_expression] = STATE(4648),
    [sym_parenthesized_expression] = STATE(3663),
    [sym_initializer_list] = STATE(4660),
    [sym_number_literal] = STATE(4573),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4565),
    [sym_string_literal] = STATE(3707),
    [sym_null] = STATE(4648),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7442),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(4648),
    [sym_raw_string_literal] = STATE(3709),
    [sym_co_await_expression] = STATE(4648),
    [sym_new_expression] = STATE(4648),
    [sym_delete_expression] = STATE(4648),
    [sym_requires_clause] = STATE(4648),
    [sym_requires_expression] = STATE(4648),
    [sym_lambda_expression] = STATE(4648),
    [sym_lambda_capture_specifier] = STATE(5768),
    [sym_fold_expression] = STATE(4648),
    [sym_parameter_pack_expansion] = STATE(4648),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5512),
    [sym_qualified_identifier] = STATE(3663),
    [sym_qualified_type_identifier] = STATE(7442),
    [sym_user_defined_literal] = STATE(3663),
    [sym_identifier] = ACTIONS(3458),
    [anon_sym_LPAREN2] = ACTIONS(2575),
    [anon_sym_BANG] = ACTIONS(2577),
    [anon_sym_TILDE] = ACTIONS(2577),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON_COLON] = ACTIONS(2583),
    [anon_sym_LBRACE] = ACTIONS(3460),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2579),
    [anon_sym_compl] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(2597),
    [anon_sym_PLUS_PLUS] = ACTIONS(2597),
    [anon_sym_sizeof] = ACTIONS(2599),
    [anon_sym___alignof__] = ACTIONS(2601),
    [anon_sym___alignof] = ACTIONS(2601),
    [anon_sym__alignof] = ACTIONS(2601),
    [anon_sym_alignof] = ACTIONS(2601),
    [anon_sym__Alignof] = ACTIONS(2601),
    [anon_sym_offsetof] = ACTIONS(2603),
    [anon_sym__Generic] = ACTIONS(2605),
    [anon_sym_asm] = ACTIONS(2607),
    [anon_sym___asm__] = ACTIONS(2607),
    [aux_sym_number_literal_token1] = ACTIONS(2609),
    [aux_sym_number_literal_token2] = ACTIONS(2611),
    [anon_sym_L_SQUOTE] = ACTIONS(2613),
    [anon_sym_u_SQUOTE] = ACTIONS(2613),
    [anon_sym_U_SQUOTE] = ACTIONS(2613),
    [anon_sym_u8_SQUOTE] = ACTIONS(2613),
    [anon_sym_SQUOTE] = ACTIONS(2613),
    [anon_sym_L_DQUOTE] = ACTIONS(2615),
    [anon_sym_u_DQUOTE] = ACTIONS(2615),
    [anon_sym_U_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8_DQUOTE] = ACTIONS(2615),
    [anon_sym_DQUOTE] = ACTIONS(2615),
    [sym_true] = ACTIONS(2617),
    [sym_false] = ACTIONS(2617),
    [anon_sym_NULL] = ACTIONS(2619),
    [anon_sym_nullptr] = ACTIONS(2619),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2629),
    [anon_sym_R_DQUOTE] = ACTIONS(2631),
    [anon_sym_LR_DQUOTE] = ACTIONS(2631),
    [anon_sym_uR_DQUOTE] = ACTIONS(2631),
    [anon_sym_UR_DQUOTE] = ACTIONS(2631),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2631),
    [anon_sym_co_await] = ACTIONS(2633),
    [anon_sym_new] = ACTIONS(2635),
    [anon_sym_requires] = ACTIONS(2637),
    [sym_this] = ACTIONS(2617),
  },
  [1195] = {
    [sym_primitive_type] = STATE(6669),
    [sym__expression] = STATE(4395),
    [sym__expression_not_binary] = STATE(4648),
    [sym__string] = STATE(4648),
    [sym_conditional_expression] = STATE(4648),
    [sym_assignment_expression] = STATE(4648),
    [sym_pointer_expression] = STATE(3663),
    [sym_unary_expression] = STATE(4648),
    [sym_binary_expression] = STATE(4648),
    [sym_update_expression] = STATE(4648),
    [sym_cast_expression] = STATE(4648),
    [sym_sizeof_expression] = STATE(4648),
    [sym_alignof_expression] = STATE(4648),
    [sym_offsetof_expression] = STATE(4648),
    [sym_generic_expression] = STATE(4648),
    [sym_subscript_expression] = STATE(3663),
    [sym_call_expression] = STATE(3663),
    [sym_gnu_asm_expression] = STATE(4648),
    [sym_field_expression] = STATE(3663),
    [sym_compound_literal_expression] = STATE(4648),
    [sym_parenthesized_expression] = STATE(3663),
    [sym_initializer_list] = STATE(4652),
    [sym_number_literal] = STATE(4573),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4565),
    [sym_string_literal] = STATE(3707),
    [sym_null] = STATE(4648),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7442),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(4648),
    [sym_raw_string_literal] = STATE(3709),
    [sym_co_await_expression] = STATE(4648),
    [sym_new_expression] = STATE(4648),
    [sym_delete_expression] = STATE(4648),
    [sym_requires_clause] = STATE(4648),
    [sym_requires_expression] = STATE(4648),
    [sym_lambda_expression] = STATE(4648),
    [sym_lambda_capture_specifier] = STATE(5768),
    [sym_fold_expression] = STATE(4648),
    [sym_parameter_pack_expansion] = STATE(4648),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5512),
    [sym_qualified_identifier] = STATE(3663),
    [sym_qualified_type_identifier] = STATE(7442),
    [sym_user_defined_literal] = STATE(3663),
    [sym_identifier] = ACTIONS(3458),
    [anon_sym_LPAREN2] = ACTIONS(2575),
    [anon_sym_BANG] = ACTIONS(2577),
    [anon_sym_TILDE] = ACTIONS(2577),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON_COLON] = ACTIONS(2583),
    [anon_sym_LBRACE] = ACTIONS(3460),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2579),
    [anon_sym_compl] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(2597),
    [anon_sym_PLUS_PLUS] = ACTIONS(2597),
    [anon_sym_sizeof] = ACTIONS(2599),
    [anon_sym___alignof__] = ACTIONS(2601),
    [anon_sym___alignof] = ACTIONS(2601),
    [anon_sym__alignof] = ACTIONS(2601),
    [anon_sym_alignof] = ACTIONS(2601),
    [anon_sym__Alignof] = ACTIONS(2601),
    [anon_sym_offsetof] = ACTIONS(2603),
    [anon_sym__Generic] = ACTIONS(2605),
    [anon_sym_asm] = ACTIONS(2607),
    [anon_sym___asm__] = ACTIONS(2607),
    [aux_sym_number_literal_token1] = ACTIONS(2609),
    [aux_sym_number_literal_token2] = ACTIONS(2611),
    [anon_sym_L_SQUOTE] = ACTIONS(2613),
    [anon_sym_u_SQUOTE] = ACTIONS(2613),
    [anon_sym_U_SQUOTE] = ACTIONS(2613),
    [anon_sym_u8_SQUOTE] = ACTIONS(2613),
    [anon_sym_SQUOTE] = ACTIONS(2613),
    [anon_sym_L_DQUOTE] = ACTIONS(2615),
    [anon_sym_u_DQUOTE] = ACTIONS(2615),
    [anon_sym_U_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8_DQUOTE] = ACTIONS(2615),
    [anon_sym_DQUOTE] = ACTIONS(2615),
    [sym_true] = ACTIONS(2617),
    [sym_false] = ACTIONS(2617),
    [anon_sym_NULL] = ACTIONS(2619),
    [anon_sym_nullptr] = ACTIONS(2619),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2629),
    [anon_sym_R_DQUOTE] = ACTIONS(2631),
    [anon_sym_LR_DQUOTE] = ACTIONS(2631),
    [anon_sym_uR_DQUOTE] = ACTIONS(2631),
    [anon_sym_UR_DQUOTE] = ACTIONS(2631),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2631),
    [anon_sym_co_await] = ACTIONS(2633),
    [anon_sym_new] = ACTIONS(2635),
    [anon_sym_requires] = ACTIONS(2637),
    [sym_this] = ACTIONS(2617),
  },
  [1196] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4259),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3440),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3440),
    [sym_call_expression] = STATE(3440),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3440),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3440),
    [sym_initializer_list] = STATE(7114),
    [sym_number_literal] = STATE(4352),
    [sym_char_literal] = STATE(4352),
    [sym_concatenated_string] = STATE(4364),
    [sym_string_literal] = STATE(3640),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3641),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3440),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3440),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_LPAREN2] = ACTIONS(4046),
    [anon_sym_BANG] = ACTIONS(3344),
    [anon_sym_TILDE] = ACTIONS(3344),
    [anon_sym_DASH] = ACTIONS(3342),
    [anon_sym_PLUS] = ACTIONS(3342),
    [anon_sym_STAR] = ACTIONS(4048),
    [anon_sym_AMP] = ACTIONS(4048),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3342),
    [anon_sym_compl] = ACTIONS(3342),
    [anon_sym_DASH_DASH] = ACTIONS(4052),
    [anon_sym_PLUS_PLUS] = ACTIONS(4052),
    [anon_sym_sizeof] = ACTIONS(3348),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3350),
    [aux_sym_number_literal_token2] = ACTIONS(3352),
    [anon_sym_L_SQUOTE] = ACTIONS(3354),
    [anon_sym_u_SQUOTE] = ACTIONS(3354),
    [anon_sym_U_SQUOTE] = ACTIONS(3354),
    [anon_sym_u8_SQUOTE] = ACTIONS(3354),
    [anon_sym_SQUOTE] = ACTIONS(3354),
    [anon_sym_L_DQUOTE] = ACTIONS(3356),
    [anon_sym_u_DQUOTE] = ACTIONS(3356),
    [anon_sym_U_DQUOTE] = ACTIONS(3356),
    [anon_sym_u8_DQUOTE] = ACTIONS(3356),
    [anon_sym_DQUOTE] = ACTIONS(3356),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3358),
    [anon_sym_R_DQUOTE] = ACTIONS(3360),
    [anon_sym_LR_DQUOTE] = ACTIONS(3360),
    [anon_sym_uR_DQUOTE] = ACTIONS(3360),
    [anon_sym_UR_DQUOTE] = ACTIONS(3360),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3360),
    [anon_sym_co_await] = ACTIONS(3362),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1197] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4298),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(7162),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4205),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1198] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4355),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(7299),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1199] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4489),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3679),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3679),
    [sym_call_expression] = STATE(3679),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3679),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3679),
    [sym_initializer_list] = STATE(3905),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3679),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3679),
    [sym_identifier] = ACTIONS(3538),
    [anon_sym_LPAREN2] = ACTIONS(4199),
    [anon_sym_BANG] = ACTIONS(3542),
    [anon_sym_TILDE] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3540),
    [anon_sym_PLUS] = ACTIONS(3540),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(3544),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3540),
    [anon_sym_compl] = ACTIONS(3540),
    [anon_sym_DASH_DASH] = ACTIONS(4122),
    [anon_sym_PLUS_PLUS] = ACTIONS(4122),
    [anon_sym_sizeof] = ACTIONS(3546),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3548),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3550),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1200] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4452),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8206),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_RPAREN] = ACTIONS(4208),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1201] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4193),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(3933),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1202] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4441),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(7659),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3679),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3679),
    [sym_call_expression] = STATE(3679),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3679),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3679),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3679),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3679),
    [sym_identifier] = ACTIONS(3538),
    [anon_sym_LPAREN2] = ACTIONS(4199),
    [anon_sym_BANG] = ACTIONS(3542),
    [anon_sym_TILDE] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3540),
    [anon_sym_PLUS] = ACTIONS(3540),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(3544),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_COLON] = ACTIONS(4210),
    [anon_sym_not] = ACTIONS(3540),
    [anon_sym_compl] = ACTIONS(3540),
    [anon_sym_DASH_DASH] = ACTIONS(4122),
    [anon_sym_PLUS_PLUS] = ACTIONS(4122),
    [anon_sym_sizeof] = ACTIONS(3546),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3548),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3550),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1203] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4367),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(7759),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3679),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3679),
    [sym_call_expression] = STATE(3679),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3679),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3679),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3679),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3679),
    [sym_identifier] = ACTIONS(3538),
    [anon_sym_LPAREN2] = ACTIONS(4199),
    [anon_sym_BANG] = ACTIONS(3542),
    [anon_sym_TILDE] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3540),
    [anon_sym_PLUS] = ACTIONS(3540),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(3544),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_COLON] = ACTIONS(4212),
    [anon_sym_not] = ACTIONS(3540),
    [anon_sym_compl] = ACTIONS(3540),
    [anon_sym_DASH_DASH] = ACTIONS(4122),
    [anon_sym_PLUS_PLUS] = ACTIONS(4122),
    [anon_sym_sizeof] = ACTIONS(3546),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3548),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3550),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1204] = {
    [sym_primitive_type] = STATE(6853),
    [sym__expression] = STATE(3651),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_initializer_list] = STATE(3870),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7464),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(7464),
    [sym_user_defined_literal] = STATE(3374),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_LPAREN2] = ACTIONS(1745),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACE] = ACTIONS(2473),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [1205] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4436),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(7797),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_RPAREN] = ACTIONS(4214),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1206] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2440),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_COMMA] = ACTIONS(4216),
    [anon_sym_LPAREN2] = ACTIONS(4218),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_TILDE] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1931),
    [anon_sym_PLUS] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(1935),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(4216),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1931),
    [anon_sym_compl] = ACTIONS(1931),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_sizeof] = ACTIONS(1937),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1207] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4397),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8393),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_RPAREN] = ACTIONS(4220),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1208] = {
    [sym_primitive_type] = STATE(6853),
    [sym__expression] = STATE(3557),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_initializer_list] = STATE(3896),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7464),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(7464),
    [sym_user_defined_literal] = STATE(3374),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_LPAREN2] = ACTIONS(1745),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACE] = ACTIONS(2473),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [1209] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4547),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(7902),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1210] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(3868),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(3905),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1211] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4410),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(7952),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_RPAREN] = ACTIONS(4222),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1212] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(3249),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_comma_expression] = STATE(8291),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym__assignment_expression_lhs] = STATE(8285),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4218),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_TILDE] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1931),
    [anon_sym_PLUS] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(1935),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1931),
    [anon_sym_compl] = ACTIONS(1931),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_sizeof] = ACTIONS(1937),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1213] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4376),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(7951),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3679),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3679),
    [sym_call_expression] = STATE(3679),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3679),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3679),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3679),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3679),
    [sym_identifier] = ACTIONS(3538),
    [anon_sym_LPAREN2] = ACTIONS(4199),
    [anon_sym_BANG] = ACTIONS(3542),
    [anon_sym_TILDE] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3540),
    [anon_sym_PLUS] = ACTIONS(3540),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(3544),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_COLON] = ACTIONS(4224),
    [anon_sym_not] = ACTIONS(3540),
    [anon_sym_compl] = ACTIONS(3540),
    [anon_sym_DASH_DASH] = ACTIONS(4122),
    [anon_sym_PLUS_PLUS] = ACTIONS(4122),
    [anon_sym_sizeof] = ACTIONS(3546),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3548),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3550),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1214] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(3199),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_initializer_list] = STATE(2567),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4226),
    [anon_sym_BANG] = ACTIONS(2218),
    [anon_sym_TILDE] = ACTIONS(2218),
    [anon_sym_DASH] = ACTIONS(2216),
    [anon_sym_PLUS] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(2220),
    [anon_sym_LBRACE] = ACTIONS(1893),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2216),
    [anon_sym_compl] = ACTIONS(2216),
    [anon_sym_DASH_DASH] = ACTIONS(4136),
    [anon_sym_PLUS_PLUS] = ACTIONS(4136),
    [anon_sym_sizeof] = ACTIONS(2222),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2224),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(2226),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1215] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4570),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(8395),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1216] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4393),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(7348),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1217] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4450),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(7791),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3679),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3679),
    [sym_call_expression] = STATE(3679),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3679),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3679),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3679),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3679),
    [sym_identifier] = ACTIONS(3538),
    [anon_sym_LPAREN2] = ACTIONS(4199),
    [anon_sym_BANG] = ACTIONS(3542),
    [anon_sym_TILDE] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3540),
    [anon_sym_PLUS] = ACTIONS(3540),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(3544),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_COLON] = ACTIONS(4228),
    [anon_sym_not] = ACTIONS(3540),
    [anon_sym_compl] = ACTIONS(3540),
    [anon_sym_DASH_DASH] = ACTIONS(4122),
    [anon_sym_PLUS_PLUS] = ACTIONS(4122),
    [anon_sym_sizeof] = ACTIONS(3546),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3548),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3550),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1218] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4453),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8274),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_RPAREN] = ACTIONS(4230),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1219] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4474),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8308),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3679),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3679),
    [sym_call_expression] = STATE(3679),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3679),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3679),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3679),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3679),
    [sym_identifier] = ACTIONS(3538),
    [anon_sym_LPAREN2] = ACTIONS(4199),
    [anon_sym_BANG] = ACTIONS(3542),
    [anon_sym_TILDE] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3540),
    [anon_sym_PLUS] = ACTIONS(3540),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(3544),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_COLON] = ACTIONS(4232),
    [anon_sym_not] = ACTIONS(3540),
    [anon_sym_compl] = ACTIONS(3540),
    [anon_sym_DASH_DASH] = ACTIONS(4122),
    [anon_sym_PLUS_PLUS] = ACTIONS(4122),
    [anon_sym_sizeof] = ACTIONS(3546),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3548),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3550),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1220] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4490),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(7948),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3679),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3679),
    [sym_call_expression] = STATE(3679),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3679),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3679),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3679),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3679),
    [sym_identifier] = ACTIONS(3538),
    [anon_sym_LPAREN2] = ACTIONS(4199),
    [anon_sym_BANG] = ACTIONS(3542),
    [anon_sym_TILDE] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3540),
    [anon_sym_PLUS] = ACTIONS(3540),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(3544),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_COLON] = ACTIONS(4234),
    [anon_sym_not] = ACTIONS(3540),
    [anon_sym_compl] = ACTIONS(3540),
    [anon_sym_DASH_DASH] = ACTIONS(4122),
    [anon_sym_PLUS_PLUS] = ACTIONS(4122),
    [anon_sym_sizeof] = ACTIONS(3546),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3548),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3550),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1221] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4382),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3679),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3679),
    [sym_call_expression] = STATE(3679),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3679),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3679),
    [sym_initializer_list] = STATE(3933),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3679),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3679),
    [sym_identifier] = ACTIONS(3538),
    [anon_sym_LPAREN2] = ACTIONS(4199),
    [anon_sym_BANG] = ACTIONS(3542),
    [anon_sym_TILDE] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3540),
    [anon_sym_PLUS] = ACTIONS(3540),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(3544),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3540),
    [anon_sym_compl] = ACTIONS(3540),
    [anon_sym_DASH_DASH] = ACTIONS(4122),
    [anon_sym_PLUS_PLUS] = ACTIONS(4122),
    [anon_sym_sizeof] = ACTIONS(3546),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3548),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3550),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1222] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(3868),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(2961),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(2961),
    [sym_call_expression] = STATE(2961),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(2961),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(2961),
    [sym_initializer_list] = STATE(3905),
    [sym_number_literal] = STATE(4149),
    [sym_char_literal] = STATE(4149),
    [sym_concatenated_string] = STATE(4150),
    [sym_string_literal] = STATE(3034),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3026),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2961),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(2961),
    [sym_identifier] = ACTIONS(4082),
    [anon_sym_LPAREN2] = ACTIONS(4236),
    [anon_sym_BANG] = ACTIONS(3190),
    [anon_sym_TILDE] = ACTIONS(3190),
    [anon_sym_DASH] = ACTIONS(3188),
    [anon_sym_PLUS] = ACTIONS(3188),
    [anon_sym_STAR] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(4238),
    [anon_sym_COLON_COLON] = ACTIONS(3192),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3188),
    [anon_sym_compl] = ACTIONS(3188),
    [anon_sym_DASH_DASH] = ACTIONS(4088),
    [anon_sym_PLUS_PLUS] = ACTIONS(4088),
    [anon_sym_sizeof] = ACTIONS(3196),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3198),
    [aux_sym_number_literal_token2] = ACTIONS(3200),
    [anon_sym_L_SQUOTE] = ACTIONS(3202),
    [anon_sym_u_SQUOTE] = ACTIONS(3202),
    [anon_sym_U_SQUOTE] = ACTIONS(3202),
    [anon_sym_u8_SQUOTE] = ACTIONS(3202),
    [anon_sym_SQUOTE] = ACTIONS(3202),
    [anon_sym_L_DQUOTE] = ACTIONS(3204),
    [anon_sym_u_DQUOTE] = ACTIONS(3204),
    [anon_sym_U_DQUOTE] = ACTIONS(3204),
    [anon_sym_u8_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3204),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3206),
    [anon_sym_R_DQUOTE] = ACTIONS(3208),
    [anon_sym_LR_DQUOTE] = ACTIONS(3208),
    [anon_sym_uR_DQUOTE] = ACTIONS(3208),
    [anon_sym_UR_DQUOTE] = ACTIONS(3208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3208),
    [anon_sym_co_await] = ACTIONS(3210),
    [anon_sym_new] = ACTIONS(3212),
    [anon_sym_requires] = ACTIONS(3214),
    [sym_this] = ACTIONS(219),
  },
  [1223] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2464),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_initializer_list] = STATE(2567),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4218),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_TILDE] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1931),
    [anon_sym_PLUS] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(1935),
    [anon_sym_LBRACE] = ACTIONS(1893),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1931),
    [anon_sym_compl] = ACTIONS(1931),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_sizeof] = ACTIONS(1937),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1224] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4131),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(2961),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(2961),
    [sym_call_expression] = STATE(2961),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(2961),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(2961),
    [sym_initializer_list] = STATE(3933),
    [sym_number_literal] = STATE(4149),
    [sym_char_literal] = STATE(4149),
    [sym_concatenated_string] = STATE(4150),
    [sym_string_literal] = STATE(3034),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3026),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2961),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(2961),
    [sym_identifier] = ACTIONS(4082),
    [anon_sym_LPAREN2] = ACTIONS(4236),
    [anon_sym_BANG] = ACTIONS(3190),
    [anon_sym_TILDE] = ACTIONS(3190),
    [anon_sym_DASH] = ACTIONS(3188),
    [anon_sym_PLUS] = ACTIONS(3188),
    [anon_sym_STAR] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(4238),
    [anon_sym_COLON_COLON] = ACTIONS(3192),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3188),
    [anon_sym_compl] = ACTIONS(3188),
    [anon_sym_DASH_DASH] = ACTIONS(4088),
    [anon_sym_PLUS_PLUS] = ACTIONS(4088),
    [anon_sym_sizeof] = ACTIONS(3196),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3198),
    [aux_sym_number_literal_token2] = ACTIONS(3200),
    [anon_sym_L_SQUOTE] = ACTIONS(3202),
    [anon_sym_u_SQUOTE] = ACTIONS(3202),
    [anon_sym_U_SQUOTE] = ACTIONS(3202),
    [anon_sym_u8_SQUOTE] = ACTIONS(3202),
    [anon_sym_SQUOTE] = ACTIONS(3202),
    [anon_sym_L_DQUOTE] = ACTIONS(3204),
    [anon_sym_u_DQUOTE] = ACTIONS(3204),
    [anon_sym_U_DQUOTE] = ACTIONS(3204),
    [anon_sym_u8_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3204),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3206),
    [anon_sym_R_DQUOTE] = ACTIONS(3208),
    [anon_sym_LR_DQUOTE] = ACTIONS(3208),
    [anon_sym_uR_DQUOTE] = ACTIONS(3208),
    [anon_sym_UR_DQUOTE] = ACTIONS(3208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3208),
    [anon_sym_co_await] = ACTIONS(3210),
    [anon_sym_new] = ACTIONS(3212),
    [anon_sym_requires] = ACTIONS(3214),
    [sym_this] = ACTIONS(219),
  },
  [1225] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4380),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8295),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3679),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3679),
    [sym_call_expression] = STATE(3679),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3679),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3679),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3679),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3679),
    [sym_identifier] = ACTIONS(3538),
    [anon_sym_LPAREN2] = ACTIONS(4199),
    [anon_sym_BANG] = ACTIONS(3542),
    [anon_sym_TILDE] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3540),
    [anon_sym_PLUS] = ACTIONS(3540),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(3544),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_COLON] = ACTIONS(4240),
    [anon_sym_not] = ACTIONS(3540),
    [anon_sym_compl] = ACTIONS(3540),
    [anon_sym_DASH_DASH] = ACTIONS(4122),
    [anon_sym_PLUS_PLUS] = ACTIONS(4122),
    [anon_sym_sizeof] = ACTIONS(3546),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3548),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3550),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1226] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4499),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(8267),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1227] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4356),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(7656),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3679),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3679),
    [sym_call_expression] = STATE(3679),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3679),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3679),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3679),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3679),
    [sym_identifier] = ACTIONS(3538),
    [anon_sym_LPAREN2] = ACTIONS(4199),
    [anon_sym_BANG] = ACTIONS(3542),
    [anon_sym_TILDE] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3540),
    [anon_sym_PLUS] = ACTIONS(3540),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(3544),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_COLON] = ACTIONS(4242),
    [anon_sym_not] = ACTIONS(3540),
    [anon_sym_compl] = ACTIONS(3540),
    [anon_sym_DASH_DASH] = ACTIONS(4122),
    [anon_sym_PLUS_PLUS] = ACTIONS(4122),
    [anon_sym_sizeof] = ACTIONS(3546),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3548),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3550),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1228] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2464),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_initializer_list] = STATE(2567),
    [sym_number_literal] = STATE(2832),
    [sym_char_literal] = STATE(2832),
    [sym_concatenated_string] = STATE(2831),
    [sym_string_literal] = STATE(1997),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(1998),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4244),
    [anon_sym_BANG] = ACTIONS(1889),
    [anon_sym_TILDE] = ACTIONS(1889),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_STAR] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(4238),
    [anon_sym_COLON_COLON] = ACTIONS(1891),
    [anon_sym_LBRACE] = ACTIONS(1893),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1887),
    [anon_sym_compl] = ACTIONS(1887),
    [anon_sym_DASH_DASH] = ACTIONS(4102),
    [anon_sym_PLUS_PLUS] = ACTIONS(4102),
    [anon_sym_sizeof] = ACTIONS(1895),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1905),
    [aux_sym_number_literal_token2] = ACTIONS(1907),
    [anon_sym_L_SQUOTE] = ACTIONS(1909),
    [anon_sym_u_SQUOTE] = ACTIONS(1909),
    [anon_sym_U_SQUOTE] = ACTIONS(1909),
    [anon_sym_u8_SQUOTE] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(1909),
    [anon_sym_L_DQUOTE] = ACTIONS(1911),
    [anon_sym_u_DQUOTE] = ACTIONS(1911),
    [anon_sym_U_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8_DQUOTE] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(1911),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1919),
    [anon_sym_R_DQUOTE] = ACTIONS(1921),
    [anon_sym_LR_DQUOTE] = ACTIONS(1921),
    [anon_sym_uR_DQUOTE] = ACTIONS(1921),
    [anon_sym_UR_DQUOTE] = ACTIONS(1921),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1921),
    [anon_sym_co_await] = ACTIONS(1923),
    [anon_sym_new] = ACTIONS(1925),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1229] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4469),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8337),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3679),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3679),
    [sym_call_expression] = STATE(3679),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3679),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3679),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3679),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3679),
    [sym_identifier] = ACTIONS(3538),
    [anon_sym_LPAREN2] = ACTIONS(4199),
    [anon_sym_BANG] = ACTIONS(3542),
    [anon_sym_TILDE] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3540),
    [anon_sym_PLUS] = ACTIONS(3540),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(3544),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_COLON] = ACTIONS(4246),
    [anon_sym_not] = ACTIONS(3540),
    [anon_sym_compl] = ACTIONS(3540),
    [anon_sym_DASH_DASH] = ACTIONS(4122),
    [anon_sym_PLUS_PLUS] = ACTIONS(4122),
    [anon_sym_sizeof] = ACTIONS(3546),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3548),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3550),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1230] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4443),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(7338),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1231] = {
    [sym_primitive_type] = STATE(6613),
    [sym__expression] = STATE(3245),
    [sym__expression_not_binary] = STATE(3637),
    [sym__string] = STATE(3637),
    [sym_conditional_expression] = STATE(3637),
    [sym_assignment_expression] = STATE(3637),
    [sym_pointer_expression] = STATE(3637),
    [sym_unary_expression] = STATE(3637),
    [sym_binary_expression] = STATE(3637),
    [sym_update_expression] = STATE(3637),
    [sym_cast_expression] = STATE(3637),
    [sym_sizeof_expression] = STATE(3637),
    [sym_alignof_expression] = STATE(3637),
    [sym_offsetof_expression] = STATE(3637),
    [sym_generic_expression] = STATE(3637),
    [sym_subscript_expression] = STATE(3637),
    [sym_call_expression] = STATE(3637),
    [sym_gnu_asm_expression] = STATE(3637),
    [sym_field_expression] = STATE(3637),
    [sym_compound_literal_expression] = STATE(3637),
    [sym_parenthesized_expression] = STATE(3637),
    [sym_initializer_list] = STATE(3550),
    [sym_number_literal] = STATE(3416),
    [sym_char_literal] = STATE(3416),
    [sym_concatenated_string] = STATE(3415),
    [sym_string_literal] = STATE(2430),
    [sym_null] = STATE(3637),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7434),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3637),
    [sym_raw_string_literal] = STATE(2419),
    [sym_co_await_expression] = STATE(3637),
    [sym_new_expression] = STATE(3637),
    [sym_delete_expression] = STATE(3637),
    [sym_requires_clause] = STATE(3637),
    [sym_requires_expression] = STATE(3637),
    [sym_lambda_expression] = STATE(3637),
    [sym_lambda_capture_specifier] = STATE(5725),
    [sym_fold_expression] = STATE(3637),
    [sym_parameter_pack_expansion] = STATE(3637),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5512),
    [sym_qualified_identifier] = STATE(3637),
    [sym_qualified_type_identifier] = STATE(7434),
    [sym_user_defined_literal] = STATE(3637),
    [sym_identifier] = ACTIONS(2228),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_BANG] = ACTIONS(2232),
    [anon_sym_TILDE] = ACTIONS(2232),
    [anon_sym_DASH] = ACTIONS(2230),
    [anon_sym_PLUS] = ACTIONS(2230),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON_COLON] = ACTIONS(2234),
    [anon_sym_LBRACE] = ACTIONS(2236),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2230),
    [anon_sym_compl] = ACTIONS(2230),
    [anon_sym_DASH_DASH] = ACTIONS(4112),
    [anon_sym_PLUS_PLUS] = ACTIONS(4112),
    [anon_sym_sizeof] = ACTIONS(2238),
    [anon_sym___alignof__] = ACTIONS(2240),
    [anon_sym___alignof] = ACTIONS(2240),
    [anon_sym__alignof] = ACTIONS(2240),
    [anon_sym_alignof] = ACTIONS(2240),
    [anon_sym__Alignof] = ACTIONS(2240),
    [anon_sym_offsetof] = ACTIONS(2242),
    [anon_sym__Generic] = ACTIONS(2244),
    [anon_sym_asm] = ACTIONS(2246),
    [anon_sym___asm__] = ACTIONS(2246),
    [aux_sym_number_literal_token1] = ACTIONS(2248),
    [aux_sym_number_literal_token2] = ACTIONS(2250),
    [anon_sym_L_SQUOTE] = ACTIONS(2252),
    [anon_sym_u_SQUOTE] = ACTIONS(2252),
    [anon_sym_U_SQUOTE] = ACTIONS(2252),
    [anon_sym_u8_SQUOTE] = ACTIONS(2252),
    [anon_sym_SQUOTE] = ACTIONS(2252),
    [anon_sym_L_DQUOTE] = ACTIONS(2254),
    [anon_sym_u_DQUOTE] = ACTIONS(2254),
    [anon_sym_U_DQUOTE] = ACTIONS(2254),
    [anon_sym_u8_DQUOTE] = ACTIONS(2254),
    [anon_sym_DQUOTE] = ACTIONS(2254),
    [sym_true] = ACTIONS(2256),
    [sym_false] = ACTIONS(2256),
    [anon_sym_NULL] = ACTIONS(2258),
    [anon_sym_nullptr] = ACTIONS(2258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2260),
    [anon_sym_R_DQUOTE] = ACTIONS(2262),
    [anon_sym_LR_DQUOTE] = ACTIONS(2262),
    [anon_sym_uR_DQUOTE] = ACTIONS(2262),
    [anon_sym_UR_DQUOTE] = ACTIONS(2262),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2262),
    [anon_sym_co_await] = ACTIONS(2264),
    [anon_sym_new] = ACTIONS(2266),
    [anon_sym_requires] = ACTIONS(2268),
    [sym_this] = ACTIONS(2256),
  },
  [1232] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4454),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(7811),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_RPAREN] = ACTIONS(4250),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1233] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4482),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_initializer_list] = STATE(7491),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1234] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(3868),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_initializer_list] = STATE(3905),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1235] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4494),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_initializer_list] = STATE(3933),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1236] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4461),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8000),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3679),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3679),
    [sym_call_expression] = STATE(3679),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3679),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3679),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3679),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3679),
    [sym_identifier] = ACTIONS(3538),
    [anon_sym_LPAREN2] = ACTIONS(4199),
    [anon_sym_BANG] = ACTIONS(3542),
    [anon_sym_TILDE] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3540),
    [anon_sym_PLUS] = ACTIONS(3540),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(3544),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_COLON] = ACTIONS(4252),
    [anon_sym_not] = ACTIONS(3540),
    [anon_sym_compl] = ACTIONS(3540),
    [anon_sym_DASH_DASH] = ACTIONS(4122),
    [anon_sym_PLUS_PLUS] = ACTIONS(4122),
    [anon_sym_sizeof] = ACTIONS(3546),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3548),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3550),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1237] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4387),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8108),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3679),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3679),
    [sym_call_expression] = STATE(3679),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3679),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3679),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3679),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3679),
    [sym_identifier] = ACTIONS(3538),
    [anon_sym_LPAREN2] = ACTIONS(4199),
    [anon_sym_BANG] = ACTIONS(3542),
    [anon_sym_TILDE] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3540),
    [anon_sym_PLUS] = ACTIONS(3540),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(3544),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_COLON] = ACTIONS(4254),
    [anon_sym_not] = ACTIONS(3540),
    [anon_sym_compl] = ACTIONS(3540),
    [anon_sym_DASH_DASH] = ACTIONS(4122),
    [anon_sym_PLUS_PLUS] = ACTIONS(4122),
    [anon_sym_sizeof] = ACTIONS(3546),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3548),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3550),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1238] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4294),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3440),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3440),
    [sym_call_expression] = STATE(3440),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3440),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3440),
    [sym_initializer_list] = STATE(3933),
    [sym_number_literal] = STATE(4352),
    [sym_char_literal] = STATE(4352),
    [sym_concatenated_string] = STATE(4364),
    [sym_string_literal] = STATE(3640),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3641),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3440),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3440),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_LPAREN2] = ACTIONS(4046),
    [anon_sym_BANG] = ACTIONS(3344),
    [anon_sym_TILDE] = ACTIONS(3344),
    [anon_sym_DASH] = ACTIONS(3342),
    [anon_sym_PLUS] = ACTIONS(3342),
    [anon_sym_STAR] = ACTIONS(4048),
    [anon_sym_AMP] = ACTIONS(4048),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3342),
    [anon_sym_compl] = ACTIONS(3342),
    [anon_sym_DASH_DASH] = ACTIONS(4052),
    [anon_sym_PLUS_PLUS] = ACTIONS(4052),
    [anon_sym_sizeof] = ACTIONS(3348),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3350),
    [aux_sym_number_literal_token2] = ACTIONS(3352),
    [anon_sym_L_SQUOTE] = ACTIONS(3354),
    [anon_sym_u_SQUOTE] = ACTIONS(3354),
    [anon_sym_U_SQUOTE] = ACTIONS(3354),
    [anon_sym_u8_SQUOTE] = ACTIONS(3354),
    [anon_sym_SQUOTE] = ACTIONS(3354),
    [anon_sym_L_DQUOTE] = ACTIONS(3356),
    [anon_sym_u_DQUOTE] = ACTIONS(3356),
    [anon_sym_U_DQUOTE] = ACTIONS(3356),
    [anon_sym_u8_DQUOTE] = ACTIONS(3356),
    [anon_sym_DQUOTE] = ACTIONS(3356),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3358),
    [anon_sym_R_DQUOTE] = ACTIONS(3360),
    [anon_sym_LR_DQUOTE] = ACTIONS(3360),
    [anon_sym_uR_DQUOTE] = ACTIONS(3360),
    [anon_sym_UR_DQUOTE] = ACTIONS(3360),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3360),
    [anon_sym_co_await] = ACTIONS(3362),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1239] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(3868),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3440),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3440),
    [sym_call_expression] = STATE(3440),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3440),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3440),
    [sym_initializer_list] = STATE(3905),
    [sym_number_literal] = STATE(4352),
    [sym_char_literal] = STATE(4352),
    [sym_concatenated_string] = STATE(4364),
    [sym_string_literal] = STATE(3640),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3641),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3440),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3440),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_LPAREN2] = ACTIONS(4046),
    [anon_sym_BANG] = ACTIONS(3344),
    [anon_sym_TILDE] = ACTIONS(3344),
    [anon_sym_DASH] = ACTIONS(3342),
    [anon_sym_PLUS] = ACTIONS(3342),
    [anon_sym_STAR] = ACTIONS(4048),
    [anon_sym_AMP] = ACTIONS(4048),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3342),
    [anon_sym_compl] = ACTIONS(3342),
    [anon_sym_DASH_DASH] = ACTIONS(4052),
    [anon_sym_PLUS_PLUS] = ACTIONS(4052),
    [anon_sym_sizeof] = ACTIONS(3348),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3350),
    [aux_sym_number_literal_token2] = ACTIONS(3352),
    [anon_sym_L_SQUOTE] = ACTIONS(3354),
    [anon_sym_u_SQUOTE] = ACTIONS(3354),
    [anon_sym_U_SQUOTE] = ACTIONS(3354),
    [anon_sym_u8_SQUOTE] = ACTIONS(3354),
    [anon_sym_SQUOTE] = ACTIONS(3354),
    [anon_sym_L_DQUOTE] = ACTIONS(3356),
    [anon_sym_u_DQUOTE] = ACTIONS(3356),
    [anon_sym_U_DQUOTE] = ACTIONS(3356),
    [anon_sym_u8_DQUOTE] = ACTIONS(3356),
    [anon_sym_DQUOTE] = ACTIONS(3356),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3358),
    [anon_sym_R_DQUOTE] = ACTIONS(3360),
    [anon_sym_LR_DQUOTE] = ACTIONS(3360),
    [anon_sym_uR_DQUOTE] = ACTIONS(3360),
    [anon_sym_UR_DQUOTE] = ACTIONS(3360),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3360),
    [anon_sym_co_await] = ACTIONS(3362),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1240] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2464),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_initializer_list] = STATE(2567),
    [sym_number_literal] = STATE(3292),
    [sym_char_literal] = STATE(3292),
    [sym_concatenated_string] = STATE(3308),
    [sym_string_literal] = STATE(2343),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2348),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1969),
    [anon_sym_LPAREN2] = ACTIONS(4256),
    [anon_sym_BANG] = ACTIONS(1973),
    [anon_sym_TILDE] = ACTIONS(1973),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_STAR] = ACTIONS(4048),
    [anon_sym_AMP] = ACTIONS(4048),
    [anon_sym_COLON_COLON] = ACTIONS(1975),
    [anon_sym_LBRACE] = ACTIONS(1893),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1971),
    [anon_sym_compl] = ACTIONS(1971),
    [anon_sym_DASH_DASH] = ACTIONS(4096),
    [anon_sym_PLUS_PLUS] = ACTIONS(4096),
    [anon_sym_sizeof] = ACTIONS(1977),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1979),
    [aux_sym_number_literal_token2] = ACTIONS(1981),
    [anon_sym_L_SQUOTE] = ACTIONS(1983),
    [anon_sym_u_SQUOTE] = ACTIONS(1983),
    [anon_sym_U_SQUOTE] = ACTIONS(1983),
    [anon_sym_u8_SQUOTE] = ACTIONS(1983),
    [anon_sym_SQUOTE] = ACTIONS(1983),
    [anon_sym_L_DQUOTE] = ACTIONS(1985),
    [anon_sym_u_DQUOTE] = ACTIONS(1985),
    [anon_sym_U_DQUOTE] = ACTIONS(1985),
    [anon_sym_u8_DQUOTE] = ACTIONS(1985),
    [anon_sym_DQUOTE] = ACTIONS(1985),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1987),
    [anon_sym_R_DQUOTE] = ACTIONS(1989),
    [anon_sym_LR_DQUOTE] = ACTIONS(1989),
    [anon_sym_uR_DQUOTE] = ACTIONS(1989),
    [anon_sym_UR_DQUOTE] = ACTIONS(1989),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1989),
    [anon_sym_co_await] = ACTIONS(1991),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1241] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4445),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(8198),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3679),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3679),
    [sym_call_expression] = STATE(3679),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3679),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3679),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3679),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3679),
    [sym_identifier] = ACTIONS(3538),
    [anon_sym_LPAREN2] = ACTIONS(4199),
    [anon_sym_BANG] = ACTIONS(3542),
    [anon_sym_TILDE] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3540),
    [anon_sym_PLUS] = ACTIONS(3540),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(3544),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_COLON] = ACTIONS(4258),
    [anon_sym_not] = ACTIONS(3540),
    [anon_sym_compl] = ACTIONS(3540),
    [anon_sym_DASH_DASH] = ACTIONS(4122),
    [anon_sym_PLUS_PLUS] = ACTIONS(4122),
    [anon_sym_sizeof] = ACTIONS(3546),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3548),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3550),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1242] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4256),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_initializer_list] = STATE(7338),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1243] = {
    [sym_primitive_type] = STATE(6613),
    [sym__expression] = STATE(3330),
    [sym__expression_not_binary] = STATE(3637),
    [sym__string] = STATE(3637),
    [sym_conditional_expression] = STATE(3637),
    [sym_assignment_expression] = STATE(3637),
    [sym_pointer_expression] = STATE(3637),
    [sym_unary_expression] = STATE(3637),
    [sym_binary_expression] = STATE(3637),
    [sym_update_expression] = STATE(3637),
    [sym_cast_expression] = STATE(3637),
    [sym_sizeof_expression] = STATE(3637),
    [sym_alignof_expression] = STATE(3637),
    [sym_offsetof_expression] = STATE(3637),
    [sym_generic_expression] = STATE(3637),
    [sym_subscript_expression] = STATE(3637),
    [sym_call_expression] = STATE(3637),
    [sym_gnu_asm_expression] = STATE(3637),
    [sym_field_expression] = STATE(3637),
    [sym_compound_literal_expression] = STATE(3637),
    [sym_parenthesized_expression] = STATE(3637),
    [sym_number_literal] = STATE(3416),
    [sym_char_literal] = STATE(3416),
    [sym_concatenated_string] = STATE(3415),
    [sym_string_literal] = STATE(2430),
    [sym_null] = STATE(3637),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7434),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3637),
    [sym_raw_string_literal] = STATE(2419),
    [sym_co_await_expression] = STATE(3637),
    [sym_new_expression] = STATE(3637),
    [sym_delete_expression] = STATE(3637),
    [sym_requires_clause] = STATE(3637),
    [sym_requires_expression] = STATE(3637),
    [sym_lambda_expression] = STATE(3637),
    [sym_lambda_capture_specifier] = STATE(5725),
    [sym_fold_expression] = STATE(3637),
    [sym_parameter_pack_expansion] = STATE(3637),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5512),
    [sym_qualified_identifier] = STATE(3637),
    [sym_qualified_type_identifier] = STATE(7434),
    [sym_user_defined_literal] = STATE(3637),
    [sym_identifier] = ACTIONS(2228),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4260),
    [anon_sym_LPAREN2] = ACTIONS(4262),
    [anon_sym_BANG] = ACTIONS(2232),
    [anon_sym_TILDE] = ACTIONS(2232),
    [anon_sym_DASH] = ACTIONS(2230),
    [anon_sym_PLUS] = ACTIONS(2230),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON_COLON] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2230),
    [anon_sym_compl] = ACTIONS(2230),
    [anon_sym_DASH_DASH] = ACTIONS(4112),
    [anon_sym_PLUS_PLUS] = ACTIONS(4112),
    [anon_sym_sizeof] = ACTIONS(2238),
    [anon_sym___alignof__] = ACTIONS(2240),
    [anon_sym___alignof] = ACTIONS(2240),
    [anon_sym__alignof] = ACTIONS(2240),
    [anon_sym_alignof] = ACTIONS(2240),
    [anon_sym__Alignof] = ACTIONS(2240),
    [anon_sym_offsetof] = ACTIONS(2242),
    [anon_sym__Generic] = ACTIONS(2244),
    [anon_sym_asm] = ACTIONS(2246),
    [anon_sym___asm__] = ACTIONS(2246),
    [aux_sym_number_literal_token1] = ACTIONS(2248),
    [aux_sym_number_literal_token2] = ACTIONS(2250),
    [anon_sym_L_SQUOTE] = ACTIONS(2252),
    [anon_sym_u_SQUOTE] = ACTIONS(2252),
    [anon_sym_U_SQUOTE] = ACTIONS(2252),
    [anon_sym_u8_SQUOTE] = ACTIONS(2252),
    [anon_sym_SQUOTE] = ACTIONS(2252),
    [anon_sym_L_DQUOTE] = ACTIONS(2254),
    [anon_sym_u_DQUOTE] = ACTIONS(2254),
    [anon_sym_U_DQUOTE] = ACTIONS(2254),
    [anon_sym_u8_DQUOTE] = ACTIONS(2254),
    [anon_sym_DQUOTE] = ACTIONS(2254),
    [sym_true] = ACTIONS(2256),
    [sym_false] = ACTIONS(2256),
    [anon_sym_NULL] = ACTIONS(2258),
    [anon_sym_nullptr] = ACTIONS(2258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2260),
    [anon_sym_R_DQUOTE] = ACTIONS(2262),
    [anon_sym_LR_DQUOTE] = ACTIONS(2262),
    [anon_sym_uR_DQUOTE] = ACTIONS(2262),
    [anon_sym_UR_DQUOTE] = ACTIONS(2262),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2262),
    [anon_sym_co_await] = ACTIONS(2264),
    [anon_sym_new] = ACTIONS(2266),
    [anon_sym_requires] = ACTIONS(2268),
    [sym_this] = ACTIONS(2256),
  },
  [1244] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4521),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_RPAREN] = ACTIONS(4264),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1245] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4451),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(7162),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3679),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3679),
    [sym_call_expression] = STATE(3679),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3679),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3679),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3679),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3679),
    [sym_identifier] = ACTIONS(3538),
    [anon_sym_LPAREN2] = ACTIONS(4199),
    [anon_sym_BANG] = ACTIONS(3542),
    [anon_sym_TILDE] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3540),
    [anon_sym_PLUS] = ACTIONS(3540),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(3544),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3540),
    [anon_sym_compl] = ACTIONS(3540),
    [anon_sym_DASH_DASH] = ACTIONS(4122),
    [anon_sym_PLUS_PLUS] = ACTIONS(4122),
    [anon_sym_sizeof] = ACTIONS(3546),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3548),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3550),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1246] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2440),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4218),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_TILDE] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1931),
    [anon_sym_PLUS] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(1935),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(4266),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1931),
    [anon_sym_compl] = ACTIONS(1931),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_sizeof] = ACTIONS(1937),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1247] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2440),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4218),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_TILDE] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1931),
    [anon_sym_PLUS] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(1935),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(4268),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1931),
    [anon_sym_compl] = ACTIONS(1931),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_sizeof] = ACTIONS(1937),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1248] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4560),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(4270),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1249] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2440),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4218),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_TILDE] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1931),
    [anon_sym_PLUS] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(1935),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(4272),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1931),
    [anon_sym_compl] = ACTIONS(1931),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_sizeof] = ACTIONS(1937),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1250] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4495),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(4274),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1251] = {
    [sym_primitive_type] = STATE(6853),
    [sym__expression] = STATE(3613),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7464),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(7464),
    [sym_user_defined_literal] = STATE(3374),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4276),
    [anon_sym_LPAREN2] = ACTIONS(4278),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [1252] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4234),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3440),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3440),
    [sym_call_expression] = STATE(3440),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3440),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3440),
    [sym_number_literal] = STATE(4352),
    [sym_char_literal] = STATE(4352),
    [sym_concatenated_string] = STATE(4364),
    [sym_string_literal] = STATE(3640),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3641),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3440),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3440),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_LPAREN2] = ACTIONS(4046),
    [anon_sym_BANG] = ACTIONS(3344),
    [anon_sym_TILDE] = ACTIONS(3344),
    [anon_sym_DASH] = ACTIONS(3342),
    [anon_sym_PLUS] = ACTIONS(3342),
    [anon_sym_STAR] = ACTIONS(4048),
    [anon_sym_AMP] = ACTIONS(4048),
    [anon_sym_SEMI] = ACTIONS(4280),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_LBRACK] = ACTIONS(4282),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3342),
    [anon_sym_compl] = ACTIONS(3342),
    [anon_sym_DASH_DASH] = ACTIONS(4052),
    [anon_sym_PLUS_PLUS] = ACTIONS(4052),
    [anon_sym_sizeof] = ACTIONS(3348),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3350),
    [aux_sym_number_literal_token2] = ACTIONS(3352),
    [anon_sym_L_SQUOTE] = ACTIONS(3354),
    [anon_sym_u_SQUOTE] = ACTIONS(3354),
    [anon_sym_U_SQUOTE] = ACTIONS(3354),
    [anon_sym_u8_SQUOTE] = ACTIONS(3354),
    [anon_sym_SQUOTE] = ACTIONS(3354),
    [anon_sym_L_DQUOTE] = ACTIONS(3356),
    [anon_sym_u_DQUOTE] = ACTIONS(3356),
    [anon_sym_U_DQUOTE] = ACTIONS(3356),
    [anon_sym_u8_DQUOTE] = ACTIONS(3356),
    [anon_sym_DQUOTE] = ACTIONS(3356),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3358),
    [anon_sym_R_DQUOTE] = ACTIONS(3360),
    [anon_sym_LR_DQUOTE] = ACTIONS(3360),
    [anon_sym_uR_DQUOTE] = ACTIONS(3360),
    [anon_sym_UR_DQUOTE] = ACTIONS(3360),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3360),
    [anon_sym_co_await] = ACTIONS(3362),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1253] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2440),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4218),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_TILDE] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1931),
    [anon_sym_PLUS] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(1935),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(4284),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1931),
    [anon_sym_compl] = ACTIONS(1931),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_sizeof] = ACTIONS(1937),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1254] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2440),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4218),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_TILDE] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1931),
    [anon_sym_PLUS] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(1935),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(4286),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1931),
    [anon_sym_compl] = ACTIONS(1931),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_sizeof] = ACTIONS(1937),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1255] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2440),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4218),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_TILDE] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1931),
    [anon_sym_PLUS] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(1935),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(4288),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1931),
    [anon_sym_compl] = ACTIONS(1931),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_sizeof] = ACTIONS(1937),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1256] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4598),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4290),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1257] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2440),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4218),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_TILDE] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1931),
    [anon_sym_PLUS] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(1935),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(4292),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1931),
    [anon_sym_compl] = ACTIONS(1931),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_sizeof] = ACTIONS(1937),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1258] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4557),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4294),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1259] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2440),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4218),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_TILDE] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1931),
    [anon_sym_PLUS] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(1935),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(4296),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1931),
    [anon_sym_compl] = ACTIONS(1931),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_sizeof] = ACTIONS(1937),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1260] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4571),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4298),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1261] = {
    [sym_primitive_type] = STATE(6853),
    [sym__expression] = STATE(3587),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7464),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(7464),
    [sym_user_defined_literal] = STATE(3374),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4300),
    [anon_sym_LPAREN2] = ACTIONS(1745),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [1262] = {
    [sym_primitive_type] = STATE(6853),
    [sym__expression] = STATE(3589),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7464),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(7464),
    [sym_user_defined_literal] = STATE(3374),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4303),
    [anon_sym_LPAREN2] = ACTIONS(1745),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [1263] = {
    [sym_primitive_type] = STATE(6853),
    [sym__expression] = STATE(3590),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7464),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(7464),
    [sym_user_defined_literal] = STATE(3374),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4306),
    [anon_sym_LPAREN2] = ACTIONS(1745),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [1264] = {
    [sym_primitive_type] = STATE(6853),
    [sym__expression] = STATE(3596),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7464),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(7464),
    [sym_user_defined_literal] = STATE(3374),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4309),
    [anon_sym_LPAREN2] = ACTIONS(1745),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [1265] = {
    [sym_primitive_type] = STATE(6853),
    [sym__expression] = STATE(3598),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7464),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(7464),
    [sym_user_defined_literal] = STATE(3374),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4312),
    [anon_sym_LPAREN2] = ACTIONS(1745),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [1266] = {
    [sym_primitive_type] = STATE(6853),
    [sym__expression] = STATE(3599),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7464),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(7464),
    [sym_user_defined_literal] = STATE(3374),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4315),
    [anon_sym_LPAREN2] = ACTIONS(1745),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [1267] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4534),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4318),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1268] = {
    [sym_primitive_type] = STATE(6853),
    [sym__expression] = STATE(3581),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7464),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(7464),
    [sym_user_defined_literal] = STATE(3374),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4320),
    [anon_sym_LPAREN2] = ACTIONS(1745),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [1269] = {
    [sym_primitive_type] = STATE(6853),
    [sym__expression] = STATE(3581),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7464),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(7464),
    [sym_user_defined_literal] = STATE(3374),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4323),
    [anon_sym_LPAREN2] = ACTIONS(1745),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [1270] = {
    [sym_primitive_type] = STATE(6853),
    [sym__expression] = STATE(3583),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7464),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(7464),
    [sym_user_defined_literal] = STATE(3374),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4326),
    [anon_sym_LPAREN2] = ACTIONS(1745),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [1271] = {
    [sym_primitive_type] = STATE(6853),
    [sym__expression] = STATE(3583),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7464),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(7464),
    [sym_user_defined_literal] = STATE(3374),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4329),
    [anon_sym_LPAREN2] = ACTIONS(1745),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [1272] = {
    [sym_primitive_type] = STATE(6853),
    [sym__expression] = STATE(3583),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7464),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(7464),
    [sym_user_defined_literal] = STATE(3374),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4332),
    [anon_sym_LPAREN2] = ACTIONS(1745),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [1273] = {
    [sym_primitive_type] = STATE(6853),
    [sym__expression] = STATE(3583),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7464),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(7464),
    [sym_user_defined_literal] = STATE(3374),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4335),
    [anon_sym_LPAREN2] = ACTIONS(1745),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [1274] = {
    [sym_primitive_type] = STATE(6853),
    [sym__expression] = STATE(3587),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7464),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(7464),
    [sym_user_defined_literal] = STATE(3374),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4338),
    [anon_sym_LPAREN2] = ACTIONS(1745),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [1275] = {
    [sym_primitive_type] = STATE(6853),
    [sym__expression] = STATE(3587),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7464),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(7464),
    [sym_user_defined_literal] = STATE(3374),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4341),
    [anon_sym_LPAREN2] = ACTIONS(1745),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [1276] = {
    [sym_primitive_type] = STATE(6853),
    [sym__expression] = STATE(3589),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7464),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(7464),
    [sym_user_defined_literal] = STATE(3374),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4344),
    [anon_sym_LPAREN2] = ACTIONS(1745),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [1277] = {
    [sym_primitive_type] = STATE(6853),
    [sym__expression] = STATE(3590),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7464),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(7464),
    [sym_user_defined_literal] = STATE(3374),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4347),
    [anon_sym_LPAREN2] = ACTIONS(1745),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [1278] = {
    [sym_primitive_type] = STATE(6853),
    [sym__expression] = STATE(3596),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7464),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(7464),
    [sym_user_defined_literal] = STATE(3374),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1745),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [1279] = {
    [sym_primitive_type] = STATE(6853),
    [sym__expression] = STATE(3598),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7464),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(7464),
    [sym_user_defined_literal] = STATE(3374),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4353),
    [anon_sym_LPAREN2] = ACTIONS(1745),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [1280] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2440),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4218),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_TILDE] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1931),
    [anon_sym_PLUS] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(1935),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(4356),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1931),
    [anon_sym_compl] = ACTIONS(1931),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_sizeof] = ACTIONS(1937),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1281] = {
    [sym_primitive_type] = STATE(6853),
    [sym__expression] = STATE(3599),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7464),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(7464),
    [sym_user_defined_literal] = STATE(3374),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4358),
    [anon_sym_LPAREN2] = ACTIONS(1745),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [1282] = {
    [sym_primitive_type] = STATE(6853),
    [sym__expression] = STATE(3601),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7464),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(7464),
    [sym_user_defined_literal] = STATE(3374),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4361),
    [anon_sym_LPAREN2] = ACTIONS(1745),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [1283] = {
    [sym_primitive_type] = STATE(6853),
    [sym__expression] = STATE(3601),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7464),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(7464),
    [sym_user_defined_literal] = STATE(3374),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4364),
    [anon_sym_LPAREN2] = ACTIONS(1745),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [1284] = {
    [sym_primitive_type] = STATE(6853),
    [sym__expression] = STATE(3601),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7464),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(7464),
    [sym_user_defined_literal] = STATE(3374),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4367),
    [anon_sym_LPAREN2] = ACTIONS(1745),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [1285] = {
    [sym_primitive_type] = STATE(6853),
    [sym__expression] = STATE(3602),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7464),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(7464),
    [sym_user_defined_literal] = STATE(3374),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4370),
    [anon_sym_LPAREN2] = ACTIONS(1745),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [1286] = {
    [sym_primitive_type] = STATE(6853),
    [sym__expression] = STATE(3602),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7464),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(7464),
    [sym_user_defined_literal] = STATE(3374),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4373),
    [anon_sym_LPAREN2] = ACTIONS(1745),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [1287] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2462),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2832),
    [sym_char_literal] = STATE(2832),
    [sym_concatenated_string] = STATE(2831),
    [sym_string_literal] = STATE(1997),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(1998),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4376),
    [anon_sym_LPAREN2] = ACTIONS(4378),
    [anon_sym_BANG] = ACTIONS(1889),
    [anon_sym_TILDE] = ACTIONS(1889),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_STAR] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(4238),
    [anon_sym_COLON_COLON] = ACTIONS(1891),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1887),
    [anon_sym_compl] = ACTIONS(1887),
    [anon_sym_DASH_DASH] = ACTIONS(4102),
    [anon_sym_PLUS_PLUS] = ACTIONS(4102),
    [anon_sym_sizeof] = ACTIONS(1895),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1905),
    [aux_sym_number_literal_token2] = ACTIONS(1907),
    [anon_sym_L_SQUOTE] = ACTIONS(1909),
    [anon_sym_u_SQUOTE] = ACTIONS(1909),
    [anon_sym_U_SQUOTE] = ACTIONS(1909),
    [anon_sym_u8_SQUOTE] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(1909),
    [anon_sym_L_DQUOTE] = ACTIONS(1911),
    [anon_sym_u_DQUOTE] = ACTIONS(1911),
    [anon_sym_U_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8_DQUOTE] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(1911),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1919),
    [anon_sym_R_DQUOTE] = ACTIONS(1921),
    [anon_sym_LR_DQUOTE] = ACTIONS(1921),
    [anon_sym_uR_DQUOTE] = ACTIONS(1921),
    [anon_sym_UR_DQUOTE] = ACTIONS(1921),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1921),
    [anon_sym_co_await] = ACTIONS(1923),
    [anon_sym_new] = ACTIONS(1925),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1288] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4617),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4380),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1289] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4605),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4382),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1290] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4298),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_comma_expression] = STATE(7162),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1291] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2462),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(3292),
    [sym_char_literal] = STATE(3292),
    [sym_concatenated_string] = STATE(3308),
    [sym_string_literal] = STATE(2343),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2348),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1969),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4376),
    [anon_sym_LPAREN2] = ACTIONS(4384),
    [anon_sym_BANG] = ACTIONS(1973),
    [anon_sym_TILDE] = ACTIONS(1973),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_STAR] = ACTIONS(4048),
    [anon_sym_AMP] = ACTIONS(4048),
    [anon_sym_COLON_COLON] = ACTIONS(1975),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1971),
    [anon_sym_compl] = ACTIONS(1971),
    [anon_sym_DASH_DASH] = ACTIONS(4096),
    [anon_sym_PLUS_PLUS] = ACTIONS(4096),
    [anon_sym_sizeof] = ACTIONS(1977),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1979),
    [aux_sym_number_literal_token2] = ACTIONS(1981),
    [anon_sym_L_SQUOTE] = ACTIONS(1983),
    [anon_sym_u_SQUOTE] = ACTIONS(1983),
    [anon_sym_U_SQUOTE] = ACTIONS(1983),
    [anon_sym_u8_SQUOTE] = ACTIONS(1983),
    [anon_sym_SQUOTE] = ACTIONS(1983),
    [anon_sym_L_DQUOTE] = ACTIONS(1985),
    [anon_sym_u_DQUOTE] = ACTIONS(1985),
    [anon_sym_U_DQUOTE] = ACTIONS(1985),
    [anon_sym_u8_DQUOTE] = ACTIONS(1985),
    [anon_sym_DQUOTE] = ACTIONS(1985),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1987),
    [anon_sym_R_DQUOTE] = ACTIONS(1989),
    [anon_sym_LR_DQUOTE] = ACTIONS(1989),
    [anon_sym_uR_DQUOTE] = ACTIONS(1989),
    [anon_sym_UR_DQUOTE] = ACTIONS(1989),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1989),
    [anon_sym_co_await] = ACTIONS(1991),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1292] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4593),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4386),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1293] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4566),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4388),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1294] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4564),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4390),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1295] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(3860),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4392),
    [anon_sym_LPAREN2] = ACTIONS(4394),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1296] = {
    [sym_primitive_type] = STATE(6848),
    [sym__expression] = STATE(3121),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7357),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(7357),
    [sym_user_defined_literal] = STATE(3526),
    [sym_identifier] = ACTIONS(1965),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4300),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [1297] = {
    [sym_primitive_type] = STATE(6848),
    [sym__expression] = STATE(3096),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7357),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(7357),
    [sym_user_defined_literal] = STATE(3526),
    [sym_identifier] = ACTIONS(1965),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4303),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [1298] = {
    [sym_primitive_type] = STATE(6848),
    [sym__expression] = STATE(3139),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7357),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(7357),
    [sym_user_defined_literal] = STATE(3526),
    [sym_identifier] = ACTIONS(1965),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4306),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [1299] = {
    [sym_primitive_type] = STATE(6848),
    [sym__expression] = STATE(3140),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7357),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(7357),
    [sym_user_defined_literal] = STATE(3526),
    [sym_identifier] = ACTIONS(1965),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4309),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [1300] = {
    [sym_primitive_type] = STATE(6848),
    [sym__expression] = STATE(3141),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7357),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(7357),
    [sym_user_defined_literal] = STATE(3526),
    [sym_identifier] = ACTIONS(1965),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4312),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [1301] = {
    [sym_primitive_type] = STATE(6848),
    [sym__expression] = STATE(3142),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7357),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(7357),
    [sym_user_defined_literal] = STATE(3526),
    [sym_identifier] = ACTIONS(1965),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4315),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [1302] = {
    [sym_primitive_type] = STATE(6848),
    [sym__expression] = STATE(3104),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7357),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(7357),
    [sym_user_defined_literal] = STATE(3526),
    [sym_identifier] = ACTIONS(1965),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4320),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [1303] = {
    [sym_primitive_type] = STATE(6848),
    [sym__expression] = STATE(3104),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7357),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(7357),
    [sym_user_defined_literal] = STATE(3526),
    [sym_identifier] = ACTIONS(1965),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4323),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [1304] = {
    [sym_primitive_type] = STATE(6848),
    [sym__expression] = STATE(3108),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7357),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(7357),
    [sym_user_defined_literal] = STATE(3526),
    [sym_identifier] = ACTIONS(1965),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4326),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [1305] = {
    [sym_primitive_type] = STATE(6848),
    [sym__expression] = STATE(3108),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7357),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(7357),
    [sym_user_defined_literal] = STATE(3526),
    [sym_identifier] = ACTIONS(1965),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4329),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [1306] = {
    [sym_primitive_type] = STATE(6848),
    [sym__expression] = STATE(3108),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7357),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(7357),
    [sym_user_defined_literal] = STATE(3526),
    [sym_identifier] = ACTIONS(1965),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4332),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [1307] = {
    [sym_primitive_type] = STATE(6848),
    [sym__expression] = STATE(3108),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7357),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(7357),
    [sym_user_defined_literal] = STATE(3526),
    [sym_identifier] = ACTIONS(1965),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4335),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [1308] = {
    [sym_primitive_type] = STATE(6848),
    [sym__expression] = STATE(3121),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7357),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(7357),
    [sym_user_defined_literal] = STATE(3526),
    [sym_identifier] = ACTIONS(1965),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4338),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [1309] = {
    [sym_primitive_type] = STATE(6848),
    [sym__expression] = STATE(3121),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7357),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(7357),
    [sym_user_defined_literal] = STATE(3526),
    [sym_identifier] = ACTIONS(1965),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4341),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [1310] = {
    [sym_primitive_type] = STATE(6848),
    [sym__expression] = STATE(3096),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7357),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(7357),
    [sym_user_defined_literal] = STATE(3526),
    [sym_identifier] = ACTIONS(1965),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4344),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [1311] = {
    [sym_primitive_type] = STATE(6848),
    [sym__expression] = STATE(3139),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7357),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(7357),
    [sym_user_defined_literal] = STATE(3526),
    [sym_identifier] = ACTIONS(1965),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4347),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [1312] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2440),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4218),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_TILDE] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1931),
    [anon_sym_PLUS] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(1935),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(4396),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1931),
    [anon_sym_compl] = ACTIONS(1931),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_sizeof] = ACTIONS(1937),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1313] = {
    [sym_primitive_type] = STATE(6848),
    [sym__expression] = STATE(3140),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7357),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(7357),
    [sym_user_defined_literal] = STATE(3526),
    [sym_identifier] = ACTIONS(1965),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [1314] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2440),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4218),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_TILDE] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1931),
    [anon_sym_PLUS] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(1935),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(4398),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1931),
    [anon_sym_compl] = ACTIONS(1931),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_sizeof] = ACTIONS(1937),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1315] = {
    [sym_primitive_type] = STATE(6848),
    [sym__expression] = STATE(3141),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7357),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(7357),
    [sym_user_defined_literal] = STATE(3526),
    [sym_identifier] = ACTIONS(1965),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4353),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [1316] = {
    [sym_primitive_type] = STATE(6848),
    [sym__expression] = STATE(3142),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7357),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(7357),
    [sym_user_defined_literal] = STATE(3526),
    [sym_identifier] = ACTIONS(1965),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4358),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [1317] = {
    [sym_primitive_type] = STATE(6848),
    [sym__expression] = STATE(3144),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7357),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(7357),
    [sym_user_defined_literal] = STATE(3526),
    [sym_identifier] = ACTIONS(1965),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4361),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [1318] = {
    [sym_primitive_type] = STATE(6848),
    [sym__expression] = STATE(3144),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7357),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(7357),
    [sym_user_defined_literal] = STATE(3526),
    [sym_identifier] = ACTIONS(1965),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4364),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [1319] = {
    [sym_primitive_type] = STATE(6848),
    [sym__expression] = STATE(3144),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7357),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(7357),
    [sym_user_defined_literal] = STATE(3526),
    [sym_identifier] = ACTIONS(1965),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4367),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [1320] = {
    [sym_primitive_type] = STATE(6848),
    [sym__expression] = STATE(3145),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7357),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(7357),
    [sym_user_defined_literal] = STATE(3526),
    [sym_identifier] = ACTIONS(1965),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4370),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [1321] = {
    [sym_primitive_type] = STATE(6848),
    [sym__expression] = STATE(3145),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7357),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(7357),
    [sym_user_defined_literal] = STATE(3526),
    [sym_identifier] = ACTIONS(1965),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4373),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [1322] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4626),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(4400),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1323] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4632),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(4402),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1324] = {
    [sym_primitive_type] = STATE(6848),
    [sym__expression] = STATE(3127),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7357),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(7357),
    [sym_user_defined_literal] = STATE(3526),
    [sym_identifier] = ACTIONS(1965),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4404),
    [anon_sym_LPAREN2] = ACTIONS(4406),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [1325] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2462),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4376),
    [anon_sym_LPAREN2] = ACTIONS(4408),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_TILDE] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1931),
    [anon_sym_PLUS] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(1935),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1931),
    [anon_sym_compl] = ACTIONS(1931),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_sizeof] = ACTIONS(1937),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1326] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4623),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(4410),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1327] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4634),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(4412),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1328] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2440),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4218),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_TILDE] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1931),
    [anon_sym_PLUS] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(1935),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(4414),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1931),
    [anon_sym_compl] = ACTIONS(1931),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_sizeof] = ACTIONS(1937),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1329] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(3860),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(2961),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(2961),
    [sym_call_expression] = STATE(2961),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(2961),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(2961),
    [sym_number_literal] = STATE(4149),
    [sym_char_literal] = STATE(4149),
    [sym_concatenated_string] = STATE(4150),
    [sym_string_literal] = STATE(3034),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3026),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2961),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(2961),
    [sym_identifier] = ACTIONS(4082),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4392),
    [anon_sym_LPAREN2] = ACTIONS(4416),
    [anon_sym_BANG] = ACTIONS(3190),
    [anon_sym_TILDE] = ACTIONS(3190),
    [anon_sym_DASH] = ACTIONS(3188),
    [anon_sym_PLUS] = ACTIONS(3188),
    [anon_sym_STAR] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(4238),
    [anon_sym_COLON_COLON] = ACTIONS(3192),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3188),
    [anon_sym_compl] = ACTIONS(3188),
    [anon_sym_DASH_DASH] = ACTIONS(4088),
    [anon_sym_PLUS_PLUS] = ACTIONS(4088),
    [anon_sym_sizeof] = ACTIONS(3196),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3198),
    [aux_sym_number_literal_token2] = ACTIONS(3200),
    [anon_sym_L_SQUOTE] = ACTIONS(3202),
    [anon_sym_u_SQUOTE] = ACTIONS(3202),
    [anon_sym_U_SQUOTE] = ACTIONS(3202),
    [anon_sym_u8_SQUOTE] = ACTIONS(3202),
    [anon_sym_SQUOTE] = ACTIONS(3202),
    [anon_sym_L_DQUOTE] = ACTIONS(3204),
    [anon_sym_u_DQUOTE] = ACTIONS(3204),
    [anon_sym_U_DQUOTE] = ACTIONS(3204),
    [anon_sym_u8_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3204),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3206),
    [anon_sym_R_DQUOTE] = ACTIONS(3208),
    [anon_sym_LR_DQUOTE] = ACTIONS(3208),
    [anon_sym_uR_DQUOTE] = ACTIONS(3208),
    [anon_sym_UR_DQUOTE] = ACTIONS(3208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3208),
    [anon_sym_co_await] = ACTIONS(3210),
    [anon_sym_new] = ACTIONS(3212),
    [anon_sym_requires] = ACTIONS(3214),
    [sym_this] = ACTIONS(219),
  },
  [1330] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(3322),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4376),
    [anon_sym_LPAREN2] = ACTIONS(4418),
    [anon_sym_BANG] = ACTIONS(2218),
    [anon_sym_TILDE] = ACTIONS(2218),
    [anon_sym_DASH] = ACTIONS(2216),
    [anon_sym_PLUS] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(2220),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2216),
    [anon_sym_compl] = ACTIONS(2216),
    [anon_sym_DASH_DASH] = ACTIONS(4136),
    [anon_sym_PLUS_PLUS] = ACTIONS(4136),
    [anon_sym_sizeof] = ACTIONS(2222),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2224),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(2226),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1331] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4605),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4420),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1332] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2440),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4218),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_TILDE] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1931),
    [anon_sym_PLUS] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(1935),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(4422),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1931),
    [anon_sym_compl] = ACTIONS(1931),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_sizeof] = ACTIONS(1937),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1333] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2440),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4218),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_TILDE] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1931),
    [anon_sym_PLUS] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(1935),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(4424),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1931),
    [anon_sym_compl] = ACTIONS(1931),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_sizeof] = ACTIONS(1937),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1334] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2440),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4218),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_TILDE] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1931),
    [anon_sym_PLUS] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(1935),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(4426),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1931),
    [anon_sym_compl] = ACTIONS(1931),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_sizeof] = ACTIONS(1937),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1335] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4234),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3440),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3440),
    [sym_call_expression] = STATE(3440),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3440),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3440),
    [sym_number_literal] = STATE(4352),
    [sym_char_literal] = STATE(4352),
    [sym_concatenated_string] = STATE(4364),
    [sym_string_literal] = STATE(3640),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3641),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3440),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3440),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_LPAREN2] = ACTIONS(4046),
    [anon_sym_BANG] = ACTIONS(3344),
    [anon_sym_TILDE] = ACTIONS(3344),
    [anon_sym_DASH] = ACTIONS(3342),
    [anon_sym_PLUS] = ACTIONS(3342),
    [anon_sym_STAR] = ACTIONS(4048),
    [anon_sym_AMP] = ACTIONS(4048),
    [anon_sym_SEMI] = ACTIONS(4428),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_LBRACK] = ACTIONS(4282),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3342),
    [anon_sym_compl] = ACTIONS(3342),
    [anon_sym_DASH_DASH] = ACTIONS(4052),
    [anon_sym_PLUS_PLUS] = ACTIONS(4052),
    [anon_sym_sizeof] = ACTIONS(3348),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3350),
    [aux_sym_number_literal_token2] = ACTIONS(3352),
    [anon_sym_L_SQUOTE] = ACTIONS(3354),
    [anon_sym_u_SQUOTE] = ACTIONS(3354),
    [anon_sym_U_SQUOTE] = ACTIONS(3354),
    [anon_sym_u8_SQUOTE] = ACTIONS(3354),
    [anon_sym_SQUOTE] = ACTIONS(3354),
    [anon_sym_L_DQUOTE] = ACTIONS(3356),
    [anon_sym_u_DQUOTE] = ACTIONS(3356),
    [anon_sym_U_DQUOTE] = ACTIONS(3356),
    [anon_sym_u8_DQUOTE] = ACTIONS(3356),
    [anon_sym_DQUOTE] = ACTIONS(3356),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3358),
    [anon_sym_R_DQUOTE] = ACTIONS(3360),
    [anon_sym_LR_DQUOTE] = ACTIONS(3360),
    [anon_sym_uR_DQUOTE] = ACTIONS(3360),
    [anon_sym_UR_DQUOTE] = ACTIONS(3360),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3360),
    [anon_sym_co_await] = ACTIONS(3362),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1336] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4234),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3440),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3440),
    [sym_call_expression] = STATE(3440),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3440),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3440),
    [sym_number_literal] = STATE(4352),
    [sym_char_literal] = STATE(4352),
    [sym_concatenated_string] = STATE(4364),
    [sym_string_literal] = STATE(3640),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3641),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3440),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3440),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_LPAREN2] = ACTIONS(4046),
    [anon_sym_BANG] = ACTIONS(3344),
    [anon_sym_TILDE] = ACTIONS(3344),
    [anon_sym_DASH] = ACTIONS(3342),
    [anon_sym_PLUS] = ACTIONS(3342),
    [anon_sym_STAR] = ACTIONS(4048),
    [anon_sym_AMP] = ACTIONS(4048),
    [anon_sym_SEMI] = ACTIONS(4430),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_LBRACK] = ACTIONS(4282),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3342),
    [anon_sym_compl] = ACTIONS(3342),
    [anon_sym_DASH_DASH] = ACTIONS(4052),
    [anon_sym_PLUS_PLUS] = ACTIONS(4052),
    [anon_sym_sizeof] = ACTIONS(3348),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3350),
    [aux_sym_number_literal_token2] = ACTIONS(3352),
    [anon_sym_L_SQUOTE] = ACTIONS(3354),
    [anon_sym_u_SQUOTE] = ACTIONS(3354),
    [anon_sym_U_SQUOTE] = ACTIONS(3354),
    [anon_sym_u8_SQUOTE] = ACTIONS(3354),
    [anon_sym_SQUOTE] = ACTIONS(3354),
    [anon_sym_L_DQUOTE] = ACTIONS(3356),
    [anon_sym_u_DQUOTE] = ACTIONS(3356),
    [anon_sym_U_DQUOTE] = ACTIONS(3356),
    [anon_sym_u8_DQUOTE] = ACTIONS(3356),
    [anon_sym_DQUOTE] = ACTIONS(3356),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3358),
    [anon_sym_R_DQUOTE] = ACTIONS(3360),
    [anon_sym_LR_DQUOTE] = ACTIONS(3360),
    [anon_sym_uR_DQUOTE] = ACTIONS(3360),
    [anon_sym_UR_DQUOTE] = ACTIONS(3360),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3360),
    [anon_sym_co_await] = ACTIONS(3362),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1337] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2440),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4218),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_TILDE] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1931),
    [anon_sym_PLUS] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(1935),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(4432),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1931),
    [anon_sym_compl] = ACTIONS(1931),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_sizeof] = ACTIONS(1937),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1338] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4498),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(4434),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1339] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4503),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(4436),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1340] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4439),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3679),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3679),
    [sym_call_expression] = STATE(3679),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3679),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3679),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3679),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3679),
    [sym_identifier] = ACTIONS(3538),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4392),
    [anon_sym_LPAREN2] = ACTIONS(4438),
    [anon_sym_BANG] = ACTIONS(3542),
    [anon_sym_TILDE] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3540),
    [anon_sym_PLUS] = ACTIONS(3540),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(3544),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3540),
    [anon_sym_compl] = ACTIONS(3540),
    [anon_sym_DASH_DASH] = ACTIONS(4122),
    [anon_sym_PLUS_PLUS] = ACTIONS(4122),
    [anon_sym_sizeof] = ACTIONS(3546),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3548),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3550),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1341] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2440),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4218),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_TILDE] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1931),
    [anon_sym_PLUS] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(1935),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(4440),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1931),
    [anon_sym_compl] = ACTIONS(1931),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_sizeof] = ACTIONS(1937),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1342] = {
    [sym_primitive_type] = STATE(6669),
    [sym__expression] = STATE(4426),
    [sym__expression_not_binary] = STATE(4648),
    [sym__string] = STATE(4648),
    [sym_conditional_expression] = STATE(4648),
    [sym_assignment_expression] = STATE(4648),
    [sym_pointer_expression] = STATE(3663),
    [sym_unary_expression] = STATE(4648),
    [sym_binary_expression] = STATE(4648),
    [sym_update_expression] = STATE(4648),
    [sym_cast_expression] = STATE(4648),
    [sym_sizeof_expression] = STATE(4648),
    [sym_alignof_expression] = STATE(4648),
    [sym_offsetof_expression] = STATE(4648),
    [sym_generic_expression] = STATE(4648),
    [sym_subscript_expression] = STATE(3663),
    [sym_call_expression] = STATE(3663),
    [sym_gnu_asm_expression] = STATE(4648),
    [sym_field_expression] = STATE(3663),
    [sym_compound_literal_expression] = STATE(4648),
    [sym_parenthesized_expression] = STATE(3663),
    [sym_number_literal] = STATE(4573),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4565),
    [sym_string_literal] = STATE(3707),
    [sym_null] = STATE(4648),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7442),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(4648),
    [sym_raw_string_literal] = STATE(3709),
    [sym_co_await_expression] = STATE(4648),
    [sym_new_expression] = STATE(4648),
    [sym_delete_expression] = STATE(4648),
    [sym_requires_clause] = STATE(4648),
    [sym_requires_expression] = STATE(4648),
    [sym_lambda_expression] = STATE(4648),
    [sym_lambda_capture_specifier] = STATE(5768),
    [sym_fold_expression] = STATE(4648),
    [sym_parameter_pack_expansion] = STATE(4648),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5512),
    [sym_qualified_identifier] = STATE(3663),
    [sym_qualified_type_identifier] = STATE(7442),
    [sym_user_defined_literal] = STATE(3663),
    [sym_identifier] = ACTIONS(3458),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4442),
    [anon_sym_LPAREN2] = ACTIONS(4444),
    [anon_sym_BANG] = ACTIONS(2577),
    [anon_sym_TILDE] = ACTIONS(2577),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON_COLON] = ACTIONS(2583),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2579),
    [anon_sym_compl] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(2597),
    [anon_sym_PLUS_PLUS] = ACTIONS(2597),
    [anon_sym_sizeof] = ACTIONS(2599),
    [anon_sym___alignof__] = ACTIONS(2601),
    [anon_sym___alignof] = ACTIONS(2601),
    [anon_sym__alignof] = ACTIONS(2601),
    [anon_sym_alignof] = ACTIONS(2601),
    [anon_sym__Alignof] = ACTIONS(2601),
    [anon_sym_offsetof] = ACTIONS(2603),
    [anon_sym__Generic] = ACTIONS(2605),
    [anon_sym_asm] = ACTIONS(2607),
    [anon_sym___asm__] = ACTIONS(2607),
    [aux_sym_number_literal_token1] = ACTIONS(2609),
    [aux_sym_number_literal_token2] = ACTIONS(2611),
    [anon_sym_L_SQUOTE] = ACTIONS(2613),
    [anon_sym_u_SQUOTE] = ACTIONS(2613),
    [anon_sym_U_SQUOTE] = ACTIONS(2613),
    [anon_sym_u8_SQUOTE] = ACTIONS(2613),
    [anon_sym_SQUOTE] = ACTIONS(2613),
    [anon_sym_L_DQUOTE] = ACTIONS(2615),
    [anon_sym_u_DQUOTE] = ACTIONS(2615),
    [anon_sym_U_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8_DQUOTE] = ACTIONS(2615),
    [anon_sym_DQUOTE] = ACTIONS(2615),
    [sym_true] = ACTIONS(2617),
    [sym_false] = ACTIONS(2617),
    [anon_sym_NULL] = ACTIONS(2619),
    [anon_sym_nullptr] = ACTIONS(2619),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2629),
    [anon_sym_R_DQUOTE] = ACTIONS(2631),
    [anon_sym_LR_DQUOTE] = ACTIONS(2631),
    [anon_sym_uR_DQUOTE] = ACTIONS(2631),
    [anon_sym_UR_DQUOTE] = ACTIONS(2631),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2631),
    [anon_sym_co_await] = ACTIONS(2633),
    [anon_sym_new] = ACTIONS(2635),
    [anon_sym_requires] = ACTIONS(2637),
    [sym_this] = ACTIONS(2617),
  },
  [1343] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2440),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4218),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_TILDE] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1931),
    [anon_sym_PLUS] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(1935),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(4446),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1931),
    [anon_sym_compl] = ACTIONS(1931),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_sizeof] = ACTIONS(1937),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1344] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4522),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(4448),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1345] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4523),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(4450),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1346] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2440),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4218),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_TILDE] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1931),
    [anon_sym_PLUS] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(1935),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(4452),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1931),
    [anon_sym_compl] = ACTIONS(1931),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_sizeof] = ACTIONS(1937),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1347] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(3860),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4392),
    [anon_sym_LPAREN2] = ACTIONS(4454),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1348] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(3860),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3440),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3440),
    [sym_call_expression] = STATE(3440),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3440),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3440),
    [sym_number_literal] = STATE(4352),
    [sym_char_literal] = STATE(4352),
    [sym_concatenated_string] = STATE(4364),
    [sym_string_literal] = STATE(3640),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3641),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3440),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3440),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4392),
    [anon_sym_LPAREN2] = ACTIONS(4456),
    [anon_sym_BANG] = ACTIONS(3344),
    [anon_sym_TILDE] = ACTIONS(3344),
    [anon_sym_DASH] = ACTIONS(3342),
    [anon_sym_PLUS] = ACTIONS(3342),
    [anon_sym_STAR] = ACTIONS(4048),
    [anon_sym_AMP] = ACTIONS(4048),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3342),
    [anon_sym_compl] = ACTIONS(3342),
    [anon_sym_DASH_DASH] = ACTIONS(4052),
    [anon_sym_PLUS_PLUS] = ACTIONS(4052),
    [anon_sym_sizeof] = ACTIONS(3348),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3350),
    [aux_sym_number_literal_token2] = ACTIONS(3352),
    [anon_sym_L_SQUOTE] = ACTIONS(3354),
    [anon_sym_u_SQUOTE] = ACTIONS(3354),
    [anon_sym_U_SQUOTE] = ACTIONS(3354),
    [anon_sym_u8_SQUOTE] = ACTIONS(3354),
    [anon_sym_SQUOTE] = ACTIONS(3354),
    [anon_sym_L_DQUOTE] = ACTIONS(3356),
    [anon_sym_u_DQUOTE] = ACTIONS(3356),
    [anon_sym_U_DQUOTE] = ACTIONS(3356),
    [anon_sym_u8_DQUOTE] = ACTIONS(3356),
    [anon_sym_DQUOTE] = ACTIONS(3356),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3358),
    [anon_sym_R_DQUOTE] = ACTIONS(3360),
    [anon_sym_LR_DQUOTE] = ACTIONS(3360),
    [anon_sym_uR_DQUOTE] = ACTIONS(3360),
    [anon_sym_UR_DQUOTE] = ACTIONS(3360),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3360),
    [anon_sym_co_await] = ACTIONS(3362),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1349] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2440),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4218),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_TILDE] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1931),
    [anon_sym_PLUS] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(1935),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_RBRACK] = ACTIONS(4458),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1931),
    [anon_sym_compl] = ACTIONS(1931),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_sizeof] = ACTIONS(1937),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1350] = {
    [sym_primitive_type] = STATE(6848),
    [sym__expression] = STATE(3093),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7357),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(7357),
    [sym_user_defined_literal] = STATE(3526),
    [sym_identifier] = ACTIONS(1965),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [1351] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2909),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4218),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_TILDE] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1931),
    [anon_sym_PLUS] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(1935),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1931),
    [anon_sym_compl] = ACTIONS(1931),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_sizeof] = ACTIONS(1937),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1352] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4311),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3440),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3440),
    [sym_call_expression] = STATE(3440),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3440),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3440),
    [sym_number_literal] = STATE(4352),
    [sym_char_literal] = STATE(4352),
    [sym_concatenated_string] = STATE(4364),
    [sym_string_literal] = STATE(3640),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3641),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3440),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3440),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_LPAREN2] = ACTIONS(4046),
    [anon_sym_BANG] = ACTIONS(3344),
    [anon_sym_TILDE] = ACTIONS(3344),
    [anon_sym_DASH] = ACTIONS(3342),
    [anon_sym_PLUS] = ACTIONS(3342),
    [anon_sym_STAR] = ACTIONS(4048),
    [anon_sym_AMP] = ACTIONS(4048),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_LBRACK] = ACTIONS(4460),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3342),
    [anon_sym_compl] = ACTIONS(3342),
    [anon_sym_DASH_DASH] = ACTIONS(4052),
    [anon_sym_PLUS_PLUS] = ACTIONS(4052),
    [anon_sym_sizeof] = ACTIONS(3348),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3350),
    [aux_sym_number_literal_token2] = ACTIONS(3352),
    [anon_sym_L_SQUOTE] = ACTIONS(3354),
    [anon_sym_u_SQUOTE] = ACTIONS(3354),
    [anon_sym_U_SQUOTE] = ACTIONS(3354),
    [anon_sym_u8_SQUOTE] = ACTIONS(3354),
    [anon_sym_SQUOTE] = ACTIONS(3354),
    [anon_sym_L_DQUOTE] = ACTIONS(3356),
    [anon_sym_u_DQUOTE] = ACTIONS(3356),
    [anon_sym_U_DQUOTE] = ACTIONS(3356),
    [anon_sym_u8_DQUOTE] = ACTIONS(3356),
    [anon_sym_DQUOTE] = ACTIONS(3356),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3358),
    [anon_sym_R_DQUOTE] = ACTIONS(3360),
    [anon_sym_LR_DQUOTE] = ACTIONS(3360),
    [anon_sym_uR_DQUOTE] = ACTIONS(3360),
    [anon_sym_UR_DQUOTE] = ACTIONS(3360),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3360),
    [anon_sym_co_await] = ACTIONS(3362),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1353] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(3897),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3440),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3440),
    [sym_call_expression] = STATE(3440),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3440),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3440),
    [sym_number_literal] = STATE(4352),
    [sym_char_literal] = STATE(4352),
    [sym_concatenated_string] = STATE(4364),
    [sym_string_literal] = STATE(3640),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3641),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3440),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3440),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_LPAREN2] = ACTIONS(4046),
    [anon_sym_BANG] = ACTIONS(3344),
    [anon_sym_TILDE] = ACTIONS(3344),
    [anon_sym_DASH] = ACTIONS(3342),
    [anon_sym_PLUS] = ACTIONS(3342),
    [anon_sym_STAR] = ACTIONS(4048),
    [anon_sym_AMP] = ACTIONS(4048),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3342),
    [anon_sym_compl] = ACTIONS(3342),
    [anon_sym_DASH_DASH] = ACTIONS(4052),
    [anon_sym_PLUS_PLUS] = ACTIONS(4052),
    [anon_sym_sizeof] = ACTIONS(3348),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3350),
    [aux_sym_number_literal_token2] = ACTIONS(3352),
    [anon_sym_L_SQUOTE] = ACTIONS(3354),
    [anon_sym_u_SQUOTE] = ACTIONS(3354),
    [anon_sym_U_SQUOTE] = ACTIONS(3354),
    [anon_sym_u8_SQUOTE] = ACTIONS(3354),
    [anon_sym_SQUOTE] = ACTIONS(3354),
    [anon_sym_L_DQUOTE] = ACTIONS(3356),
    [anon_sym_u_DQUOTE] = ACTIONS(3356),
    [anon_sym_U_DQUOTE] = ACTIONS(3356),
    [anon_sym_u8_DQUOTE] = ACTIONS(3356),
    [anon_sym_DQUOTE] = ACTIONS(3356),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3358),
    [anon_sym_R_DQUOTE] = ACTIONS(3360),
    [anon_sym_LR_DQUOTE] = ACTIONS(3360),
    [anon_sym_uR_DQUOTE] = ACTIONS(3360),
    [anon_sym_UR_DQUOTE] = ACTIONS(3360),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3360),
    [anon_sym_co_await] = ACTIONS(3362),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1354] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4234),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3440),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3440),
    [sym_call_expression] = STATE(3440),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3440),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3440),
    [sym_number_literal] = STATE(4352),
    [sym_char_literal] = STATE(4352),
    [sym_concatenated_string] = STATE(4364),
    [sym_string_literal] = STATE(3640),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3641),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3440),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3440),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_LPAREN2] = ACTIONS(4046),
    [anon_sym_BANG] = ACTIONS(3344),
    [anon_sym_TILDE] = ACTIONS(3344),
    [anon_sym_DASH] = ACTIONS(3342),
    [anon_sym_PLUS] = ACTIONS(3342),
    [anon_sym_STAR] = ACTIONS(4048),
    [anon_sym_AMP] = ACTIONS(4048),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_LBRACK] = ACTIONS(4282),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3342),
    [anon_sym_compl] = ACTIONS(3342),
    [anon_sym_DASH_DASH] = ACTIONS(4052),
    [anon_sym_PLUS_PLUS] = ACTIONS(4052),
    [anon_sym_sizeof] = ACTIONS(3348),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3350),
    [aux_sym_number_literal_token2] = ACTIONS(3352),
    [anon_sym_L_SQUOTE] = ACTIONS(3354),
    [anon_sym_u_SQUOTE] = ACTIONS(3354),
    [anon_sym_U_SQUOTE] = ACTIONS(3354),
    [anon_sym_u8_SQUOTE] = ACTIONS(3354),
    [anon_sym_SQUOTE] = ACTIONS(3354),
    [anon_sym_L_DQUOTE] = ACTIONS(3356),
    [anon_sym_u_DQUOTE] = ACTIONS(3356),
    [anon_sym_U_DQUOTE] = ACTIONS(3356),
    [anon_sym_u8_DQUOTE] = ACTIONS(3356),
    [anon_sym_DQUOTE] = ACTIONS(3356),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3358),
    [anon_sym_R_DQUOTE] = ACTIONS(3360),
    [anon_sym_LR_DQUOTE] = ACTIONS(3360),
    [anon_sym_uR_DQUOTE] = ACTIONS(3360),
    [anon_sym_UR_DQUOTE] = ACTIONS(3360),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3360),
    [anon_sym_co_await] = ACTIONS(3362),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1355] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4584),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1356] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4641),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1357] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4639),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1358] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4578),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1359] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4107),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(2961),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(2961),
    [sym_call_expression] = STATE(2961),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(2961),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(2961),
    [sym_number_literal] = STATE(4149),
    [sym_char_literal] = STATE(4149),
    [sym_concatenated_string] = STATE(4150),
    [sym_string_literal] = STATE(3034),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3026),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2961),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(2961),
    [sym_identifier] = ACTIONS(4082),
    [anon_sym_LPAREN2] = ACTIONS(4236),
    [anon_sym_BANG] = ACTIONS(3190),
    [anon_sym_TILDE] = ACTIONS(3190),
    [anon_sym_DASH] = ACTIONS(3188),
    [anon_sym_PLUS] = ACTIONS(3188),
    [anon_sym_STAR] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(4238),
    [anon_sym_COLON_COLON] = ACTIONS(3192),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3188),
    [anon_sym_compl] = ACTIONS(3188),
    [anon_sym_DASH_DASH] = ACTIONS(4088),
    [anon_sym_PLUS_PLUS] = ACTIONS(4088),
    [anon_sym_sizeof] = ACTIONS(3196),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3198),
    [aux_sym_number_literal_token2] = ACTIONS(3200),
    [anon_sym_L_SQUOTE] = ACTIONS(3202),
    [anon_sym_u_SQUOTE] = ACTIONS(3202),
    [anon_sym_U_SQUOTE] = ACTIONS(3202),
    [anon_sym_u8_SQUOTE] = ACTIONS(3202),
    [anon_sym_SQUOTE] = ACTIONS(3202),
    [anon_sym_L_DQUOTE] = ACTIONS(3204),
    [anon_sym_u_DQUOTE] = ACTIONS(3204),
    [anon_sym_U_DQUOTE] = ACTIONS(3204),
    [anon_sym_u8_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3204),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3206),
    [anon_sym_R_DQUOTE] = ACTIONS(3208),
    [anon_sym_LR_DQUOTE] = ACTIONS(3208),
    [anon_sym_uR_DQUOTE] = ACTIONS(3208),
    [anon_sym_UR_DQUOTE] = ACTIONS(3208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3208),
    [anon_sym_co_await] = ACTIONS(3210),
    [anon_sym_new] = ACTIONS(3212),
    [anon_sym_requires] = ACTIONS(3214),
    [sym_this] = ACTIONS(219),
  },
  [1360] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4484),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(4462),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1361] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4624),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1362] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4459),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1363] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(3897),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1364] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4460),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1365] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4605),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1366] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2463),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(3292),
    [sym_char_literal] = STATE(3292),
    [sym_concatenated_string] = STATE(3308),
    [sym_string_literal] = STATE(2343),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2348),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1969),
    [anon_sym_LPAREN2] = ACTIONS(4256),
    [anon_sym_BANG] = ACTIONS(1973),
    [anon_sym_TILDE] = ACTIONS(1973),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_STAR] = ACTIONS(4048),
    [anon_sym_AMP] = ACTIONS(4048),
    [anon_sym_COLON_COLON] = ACTIONS(1975),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1971),
    [anon_sym_compl] = ACTIONS(1971),
    [anon_sym_DASH_DASH] = ACTIONS(4096),
    [anon_sym_PLUS_PLUS] = ACTIONS(4096),
    [anon_sym_sizeof] = ACTIONS(1977),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1979),
    [aux_sym_number_literal_token2] = ACTIONS(1981),
    [anon_sym_L_SQUOTE] = ACTIONS(1983),
    [anon_sym_u_SQUOTE] = ACTIONS(1983),
    [anon_sym_U_SQUOTE] = ACTIONS(1983),
    [anon_sym_u8_SQUOTE] = ACTIONS(1983),
    [anon_sym_SQUOTE] = ACTIONS(1983),
    [anon_sym_L_DQUOTE] = ACTIONS(1985),
    [anon_sym_u_DQUOTE] = ACTIONS(1985),
    [anon_sym_U_DQUOTE] = ACTIONS(1985),
    [anon_sym_u8_DQUOTE] = ACTIONS(1985),
    [anon_sym_DQUOTE] = ACTIONS(1985),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1987),
    [anon_sym_R_DQUOTE] = ACTIONS(1989),
    [anon_sym_LR_DQUOTE] = ACTIONS(1989),
    [anon_sym_uR_DQUOTE] = ACTIONS(1989),
    [anon_sym_UR_DQUOTE] = ACTIONS(1989),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1989),
    [anon_sym_co_await] = ACTIONS(1991),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1367] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4217),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1368] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4462),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1369] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4463),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1370] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4464),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1371] = {
    [sym_primitive_type] = STATE(6613),
    [sym__expression] = STATE(3317),
    [sym__expression_not_binary] = STATE(3637),
    [sym__string] = STATE(3637),
    [sym_conditional_expression] = STATE(3637),
    [sym_assignment_expression] = STATE(3637),
    [sym_pointer_expression] = STATE(3637),
    [sym_unary_expression] = STATE(3637),
    [sym_binary_expression] = STATE(3637),
    [sym_update_expression] = STATE(3637),
    [sym_cast_expression] = STATE(3637),
    [sym_sizeof_expression] = STATE(3637),
    [sym_alignof_expression] = STATE(3637),
    [sym_offsetof_expression] = STATE(3637),
    [sym_generic_expression] = STATE(3637),
    [sym_subscript_expression] = STATE(3637),
    [sym_call_expression] = STATE(3637),
    [sym_gnu_asm_expression] = STATE(3637),
    [sym_field_expression] = STATE(3637),
    [sym_compound_literal_expression] = STATE(3637),
    [sym_parenthesized_expression] = STATE(3637),
    [sym_number_literal] = STATE(3416),
    [sym_char_literal] = STATE(3416),
    [sym_concatenated_string] = STATE(3415),
    [sym_string_literal] = STATE(2430),
    [sym_null] = STATE(3637),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7434),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3637),
    [sym_raw_string_literal] = STATE(2419),
    [sym_co_await_expression] = STATE(3637),
    [sym_new_expression] = STATE(3637),
    [sym_delete_expression] = STATE(3637),
    [sym_requires_clause] = STATE(3637),
    [sym_requires_expression] = STATE(3637),
    [sym_lambda_expression] = STATE(3637),
    [sym_lambda_capture_specifier] = STATE(5725),
    [sym_fold_expression] = STATE(3637),
    [sym_parameter_pack_expansion] = STATE(3637),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5512),
    [sym_qualified_identifier] = STATE(3637),
    [sym_qualified_type_identifier] = STATE(7434),
    [sym_user_defined_literal] = STATE(3637),
    [sym_identifier] = ACTIONS(2228),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_BANG] = ACTIONS(2232),
    [anon_sym_TILDE] = ACTIONS(2232),
    [anon_sym_DASH] = ACTIONS(2230),
    [anon_sym_PLUS] = ACTIONS(2230),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON_COLON] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2230),
    [anon_sym_compl] = ACTIONS(2230),
    [anon_sym_DASH_DASH] = ACTIONS(4112),
    [anon_sym_PLUS_PLUS] = ACTIONS(4112),
    [anon_sym_sizeof] = ACTIONS(2238),
    [anon_sym___alignof__] = ACTIONS(2240),
    [anon_sym___alignof] = ACTIONS(2240),
    [anon_sym__alignof] = ACTIONS(2240),
    [anon_sym_alignof] = ACTIONS(2240),
    [anon_sym__Alignof] = ACTIONS(2240),
    [anon_sym_offsetof] = ACTIONS(2242),
    [anon_sym__Generic] = ACTIONS(2244),
    [anon_sym_asm] = ACTIONS(2246),
    [anon_sym___asm__] = ACTIONS(2246),
    [aux_sym_number_literal_token1] = ACTIONS(2248),
    [aux_sym_number_literal_token2] = ACTIONS(2250),
    [anon_sym_L_SQUOTE] = ACTIONS(2252),
    [anon_sym_u_SQUOTE] = ACTIONS(2252),
    [anon_sym_U_SQUOTE] = ACTIONS(2252),
    [anon_sym_u8_SQUOTE] = ACTIONS(2252),
    [anon_sym_SQUOTE] = ACTIONS(2252),
    [anon_sym_L_DQUOTE] = ACTIONS(2254),
    [anon_sym_u_DQUOTE] = ACTIONS(2254),
    [anon_sym_U_DQUOTE] = ACTIONS(2254),
    [anon_sym_u8_DQUOTE] = ACTIONS(2254),
    [anon_sym_DQUOTE] = ACTIONS(2254),
    [sym_true] = ACTIONS(2256),
    [sym_false] = ACTIONS(2256),
    [anon_sym_NULL] = ACTIONS(2258),
    [anon_sym_nullptr] = ACTIONS(2258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2260),
    [anon_sym_R_DQUOTE] = ACTIONS(2262),
    [anon_sym_LR_DQUOTE] = ACTIONS(2262),
    [anon_sym_uR_DQUOTE] = ACTIONS(2262),
    [anon_sym_UR_DQUOTE] = ACTIONS(2262),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2262),
    [anon_sym_co_await] = ACTIONS(2264),
    [anon_sym_new] = ACTIONS(2266),
    [anon_sym_requires] = ACTIONS(2268),
    [sym_this] = ACTIONS(2256),
  },
  [1372] = {
    [sym_primitive_type] = STATE(6853),
    [sym__expression] = STATE(3608),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7464),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(7464),
    [sym_user_defined_literal] = STATE(3374),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_LPAREN2] = ACTIONS(1745),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [1373] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4532),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1374] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4479),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1375] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4553),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1376] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(3895),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1377] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4368),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1378] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(3171),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(3292),
    [sym_char_literal] = STATE(3292),
    [sym_concatenated_string] = STATE(3308),
    [sym_string_literal] = STATE(2343),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2348),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1969),
    [anon_sym_LPAREN2] = ACTIONS(4256),
    [anon_sym_BANG] = ACTIONS(1973),
    [anon_sym_TILDE] = ACTIONS(1973),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_STAR] = ACTIONS(4048),
    [anon_sym_AMP] = ACTIONS(4048),
    [anon_sym_COLON_COLON] = ACTIONS(1975),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1971),
    [anon_sym_compl] = ACTIONS(1971),
    [anon_sym_DASH_DASH] = ACTIONS(4096),
    [anon_sym_PLUS_PLUS] = ACTIONS(4096),
    [anon_sym_sizeof] = ACTIONS(1977),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1979),
    [aux_sym_number_literal_token2] = ACTIONS(1981),
    [anon_sym_L_SQUOTE] = ACTIONS(1983),
    [anon_sym_u_SQUOTE] = ACTIONS(1983),
    [anon_sym_U_SQUOTE] = ACTIONS(1983),
    [anon_sym_u8_SQUOTE] = ACTIONS(1983),
    [anon_sym_SQUOTE] = ACTIONS(1983),
    [anon_sym_L_DQUOTE] = ACTIONS(1985),
    [anon_sym_u_DQUOTE] = ACTIONS(1985),
    [anon_sym_U_DQUOTE] = ACTIONS(1985),
    [anon_sym_u8_DQUOTE] = ACTIONS(1985),
    [anon_sym_DQUOTE] = ACTIONS(1985),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1987),
    [anon_sym_R_DQUOTE] = ACTIONS(1989),
    [anon_sym_LR_DQUOTE] = ACTIONS(1989),
    [anon_sym_uR_DQUOTE] = ACTIONS(1989),
    [anon_sym_UR_DQUOTE] = ACTIONS(1989),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1989),
    [anon_sym_co_await] = ACTIONS(1991),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1379] = {
    [sym_primitive_type] = STATE(6669),
    [sym__expression] = STATE(4432),
    [sym__expression_not_binary] = STATE(4648),
    [sym__string] = STATE(4648),
    [sym_conditional_expression] = STATE(4648),
    [sym_assignment_expression] = STATE(4648),
    [sym_pointer_expression] = STATE(3663),
    [sym_unary_expression] = STATE(4648),
    [sym_binary_expression] = STATE(4648),
    [sym_update_expression] = STATE(4648),
    [sym_cast_expression] = STATE(4648),
    [sym_sizeof_expression] = STATE(4648),
    [sym_alignof_expression] = STATE(4648),
    [sym_offsetof_expression] = STATE(4648),
    [sym_generic_expression] = STATE(4648),
    [sym_subscript_expression] = STATE(3663),
    [sym_call_expression] = STATE(3663),
    [sym_gnu_asm_expression] = STATE(4648),
    [sym_field_expression] = STATE(3663),
    [sym_compound_literal_expression] = STATE(4648),
    [sym_parenthesized_expression] = STATE(3663),
    [sym_number_literal] = STATE(4573),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4565),
    [sym_string_literal] = STATE(3707),
    [sym_null] = STATE(4648),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7442),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(4648),
    [sym_raw_string_literal] = STATE(3709),
    [sym_co_await_expression] = STATE(4648),
    [sym_new_expression] = STATE(4648),
    [sym_delete_expression] = STATE(4648),
    [sym_requires_clause] = STATE(4648),
    [sym_requires_expression] = STATE(4648),
    [sym_lambda_expression] = STATE(4648),
    [sym_lambda_capture_specifier] = STATE(5768),
    [sym_fold_expression] = STATE(4648),
    [sym_parameter_pack_expansion] = STATE(4648),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5512),
    [sym_qualified_identifier] = STATE(3663),
    [sym_qualified_type_identifier] = STATE(7442),
    [sym_user_defined_literal] = STATE(3663),
    [sym_identifier] = ACTIONS(3458),
    [anon_sym_LPAREN2] = ACTIONS(2575),
    [anon_sym_BANG] = ACTIONS(2577),
    [anon_sym_TILDE] = ACTIONS(2577),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON_COLON] = ACTIONS(2583),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2579),
    [anon_sym_compl] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(2597),
    [anon_sym_PLUS_PLUS] = ACTIONS(2597),
    [anon_sym_sizeof] = ACTIONS(2599),
    [anon_sym___alignof__] = ACTIONS(2601),
    [anon_sym___alignof] = ACTIONS(2601),
    [anon_sym__alignof] = ACTIONS(2601),
    [anon_sym_alignof] = ACTIONS(2601),
    [anon_sym__Alignof] = ACTIONS(2601),
    [anon_sym_offsetof] = ACTIONS(2603),
    [anon_sym__Generic] = ACTIONS(2605),
    [anon_sym_asm] = ACTIONS(2607),
    [anon_sym___asm__] = ACTIONS(2607),
    [aux_sym_number_literal_token1] = ACTIONS(2609),
    [aux_sym_number_literal_token2] = ACTIONS(2611),
    [anon_sym_L_SQUOTE] = ACTIONS(2613),
    [anon_sym_u_SQUOTE] = ACTIONS(2613),
    [anon_sym_U_SQUOTE] = ACTIONS(2613),
    [anon_sym_u8_SQUOTE] = ACTIONS(2613),
    [anon_sym_SQUOTE] = ACTIONS(2613),
    [anon_sym_L_DQUOTE] = ACTIONS(2615),
    [anon_sym_u_DQUOTE] = ACTIONS(2615),
    [anon_sym_U_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8_DQUOTE] = ACTIONS(2615),
    [anon_sym_DQUOTE] = ACTIONS(2615),
    [sym_true] = ACTIONS(2617),
    [sym_false] = ACTIONS(2617),
    [anon_sym_NULL] = ACTIONS(2619),
    [anon_sym_nullptr] = ACTIONS(2619),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2629),
    [anon_sym_R_DQUOTE] = ACTIONS(2631),
    [anon_sym_LR_DQUOTE] = ACTIONS(2631),
    [anon_sym_uR_DQUOTE] = ACTIONS(2631),
    [anon_sym_UR_DQUOTE] = ACTIONS(2631),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2631),
    [anon_sym_co_await] = ACTIONS(2633),
    [anon_sym_new] = ACTIONS(2635),
    [anon_sym_requires] = ACTIONS(2637),
    [sym_this] = ACTIONS(2617),
  },
  [1380] = {
    [sym_primitive_type] = STATE(6669),
    [sym__expression] = STATE(4430),
    [sym__expression_not_binary] = STATE(4648),
    [sym__string] = STATE(4648),
    [sym_conditional_expression] = STATE(4648),
    [sym_assignment_expression] = STATE(4648),
    [sym_pointer_expression] = STATE(3663),
    [sym_unary_expression] = STATE(4648),
    [sym_binary_expression] = STATE(4648),
    [sym_update_expression] = STATE(4648),
    [sym_cast_expression] = STATE(4648),
    [sym_sizeof_expression] = STATE(4648),
    [sym_alignof_expression] = STATE(4648),
    [sym_offsetof_expression] = STATE(4648),
    [sym_generic_expression] = STATE(4648),
    [sym_subscript_expression] = STATE(3663),
    [sym_call_expression] = STATE(3663),
    [sym_gnu_asm_expression] = STATE(4648),
    [sym_field_expression] = STATE(3663),
    [sym_compound_literal_expression] = STATE(4648),
    [sym_parenthesized_expression] = STATE(3663),
    [sym_number_literal] = STATE(4573),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4565),
    [sym_string_literal] = STATE(3707),
    [sym_null] = STATE(4648),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7442),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(4648),
    [sym_raw_string_literal] = STATE(3709),
    [sym_co_await_expression] = STATE(4648),
    [sym_new_expression] = STATE(4648),
    [sym_delete_expression] = STATE(4648),
    [sym_requires_clause] = STATE(4648),
    [sym_requires_expression] = STATE(4648),
    [sym_lambda_expression] = STATE(4648),
    [sym_lambda_capture_specifier] = STATE(5768),
    [sym_fold_expression] = STATE(4648),
    [sym_parameter_pack_expansion] = STATE(4648),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5512),
    [sym_qualified_identifier] = STATE(3663),
    [sym_qualified_type_identifier] = STATE(7442),
    [sym_user_defined_literal] = STATE(3663),
    [sym_identifier] = ACTIONS(3458),
    [anon_sym_LPAREN2] = ACTIONS(2575),
    [anon_sym_BANG] = ACTIONS(2577),
    [anon_sym_TILDE] = ACTIONS(2577),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON_COLON] = ACTIONS(2583),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2579),
    [anon_sym_compl] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(2597),
    [anon_sym_PLUS_PLUS] = ACTIONS(2597),
    [anon_sym_sizeof] = ACTIONS(2599),
    [anon_sym___alignof__] = ACTIONS(2601),
    [anon_sym___alignof] = ACTIONS(2601),
    [anon_sym__alignof] = ACTIONS(2601),
    [anon_sym_alignof] = ACTIONS(2601),
    [anon_sym__Alignof] = ACTIONS(2601),
    [anon_sym_offsetof] = ACTIONS(2603),
    [anon_sym__Generic] = ACTIONS(2605),
    [anon_sym_asm] = ACTIONS(2607),
    [anon_sym___asm__] = ACTIONS(2607),
    [aux_sym_number_literal_token1] = ACTIONS(2609),
    [aux_sym_number_literal_token2] = ACTIONS(2611),
    [anon_sym_L_SQUOTE] = ACTIONS(2613),
    [anon_sym_u_SQUOTE] = ACTIONS(2613),
    [anon_sym_U_SQUOTE] = ACTIONS(2613),
    [anon_sym_u8_SQUOTE] = ACTIONS(2613),
    [anon_sym_SQUOTE] = ACTIONS(2613),
    [anon_sym_L_DQUOTE] = ACTIONS(2615),
    [anon_sym_u_DQUOTE] = ACTIONS(2615),
    [anon_sym_U_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8_DQUOTE] = ACTIONS(2615),
    [anon_sym_DQUOTE] = ACTIONS(2615),
    [sym_true] = ACTIONS(2617),
    [sym_false] = ACTIONS(2617),
    [anon_sym_NULL] = ACTIONS(2619),
    [anon_sym_nullptr] = ACTIONS(2619),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2629),
    [anon_sym_R_DQUOTE] = ACTIONS(2631),
    [anon_sym_LR_DQUOTE] = ACTIONS(2631),
    [anon_sym_uR_DQUOTE] = ACTIONS(2631),
    [anon_sym_UR_DQUOTE] = ACTIONS(2631),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2631),
    [anon_sym_co_await] = ACTIONS(2633),
    [anon_sym_new] = ACTIONS(2635),
    [anon_sym_requires] = ACTIONS(2637),
    [sym_this] = ACTIONS(2617),
  },
  [1381] = {
    [sym_primitive_type] = STATE(6848),
    [sym__expression] = STATE(3120),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7357),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(7357),
    [sym_user_defined_literal] = STATE(3526),
    [sym_identifier] = ACTIONS(1965),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [1382] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4249),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3440),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3440),
    [sym_call_expression] = STATE(3440),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3440),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3440),
    [sym_number_literal] = STATE(4352),
    [sym_char_literal] = STATE(4352),
    [sym_concatenated_string] = STATE(4364),
    [sym_string_literal] = STATE(3640),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3641),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3440),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3440),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_LPAREN2] = ACTIONS(4046),
    [anon_sym_BANG] = ACTIONS(3344),
    [anon_sym_TILDE] = ACTIONS(3344),
    [anon_sym_DASH] = ACTIONS(3342),
    [anon_sym_PLUS] = ACTIONS(3342),
    [anon_sym_STAR] = ACTIONS(4048),
    [anon_sym_AMP] = ACTIONS(4048),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3342),
    [anon_sym_compl] = ACTIONS(3342),
    [anon_sym_DASH_DASH] = ACTIONS(4052),
    [anon_sym_PLUS_PLUS] = ACTIONS(4052),
    [anon_sym_sizeof] = ACTIONS(3348),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3350),
    [aux_sym_number_literal_token2] = ACTIONS(3352),
    [anon_sym_L_SQUOTE] = ACTIONS(3354),
    [anon_sym_u_SQUOTE] = ACTIONS(3354),
    [anon_sym_U_SQUOTE] = ACTIONS(3354),
    [anon_sym_u8_SQUOTE] = ACTIONS(3354),
    [anon_sym_SQUOTE] = ACTIONS(3354),
    [anon_sym_L_DQUOTE] = ACTIONS(3356),
    [anon_sym_u_DQUOTE] = ACTIONS(3356),
    [anon_sym_U_DQUOTE] = ACTIONS(3356),
    [anon_sym_u8_DQUOTE] = ACTIONS(3356),
    [anon_sym_DQUOTE] = ACTIONS(3356),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3358),
    [anon_sym_R_DQUOTE] = ACTIONS(3360),
    [anon_sym_LR_DQUOTE] = ACTIONS(3360),
    [anon_sym_uR_DQUOTE] = ACTIONS(3360),
    [anon_sym_UR_DQUOTE] = ACTIONS(3360),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3360),
    [anon_sym_co_await] = ACTIONS(3362),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1383] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4414),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1384] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4620),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1385] = {
    [sym_primitive_type] = STATE(6613),
    [sym__expression] = STATE(3246),
    [sym__expression_not_binary] = STATE(3637),
    [sym__string] = STATE(3637),
    [sym_conditional_expression] = STATE(3637),
    [sym_assignment_expression] = STATE(3637),
    [sym_pointer_expression] = STATE(3637),
    [sym_unary_expression] = STATE(3637),
    [sym_binary_expression] = STATE(3637),
    [sym_update_expression] = STATE(3637),
    [sym_cast_expression] = STATE(3637),
    [sym_sizeof_expression] = STATE(3637),
    [sym_alignof_expression] = STATE(3637),
    [sym_offsetof_expression] = STATE(3637),
    [sym_generic_expression] = STATE(3637),
    [sym_subscript_expression] = STATE(3637),
    [sym_call_expression] = STATE(3637),
    [sym_gnu_asm_expression] = STATE(3637),
    [sym_field_expression] = STATE(3637),
    [sym_compound_literal_expression] = STATE(3637),
    [sym_parenthesized_expression] = STATE(3637),
    [sym_number_literal] = STATE(3416),
    [sym_char_literal] = STATE(3416),
    [sym_concatenated_string] = STATE(3415),
    [sym_string_literal] = STATE(2430),
    [sym_null] = STATE(3637),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7434),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3637),
    [sym_raw_string_literal] = STATE(2419),
    [sym_co_await_expression] = STATE(3637),
    [sym_new_expression] = STATE(3637),
    [sym_delete_expression] = STATE(3637),
    [sym_requires_clause] = STATE(3637),
    [sym_requires_expression] = STATE(3637),
    [sym_lambda_expression] = STATE(3637),
    [sym_lambda_capture_specifier] = STATE(5725),
    [sym_fold_expression] = STATE(3637),
    [sym_parameter_pack_expansion] = STATE(3637),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5512),
    [sym_qualified_identifier] = STATE(3637),
    [sym_qualified_type_identifier] = STATE(7434),
    [sym_user_defined_literal] = STATE(3637),
    [sym_identifier] = ACTIONS(2228),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_BANG] = ACTIONS(2232),
    [anon_sym_TILDE] = ACTIONS(2232),
    [anon_sym_DASH] = ACTIONS(2230),
    [anon_sym_PLUS] = ACTIONS(2230),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON_COLON] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2230),
    [anon_sym_compl] = ACTIONS(2230),
    [anon_sym_DASH_DASH] = ACTIONS(4112),
    [anon_sym_PLUS_PLUS] = ACTIONS(4112),
    [anon_sym_sizeof] = ACTIONS(2238),
    [anon_sym___alignof__] = ACTIONS(2240),
    [anon_sym___alignof] = ACTIONS(2240),
    [anon_sym__alignof] = ACTIONS(2240),
    [anon_sym_alignof] = ACTIONS(2240),
    [anon_sym__Alignof] = ACTIONS(2240),
    [anon_sym_offsetof] = ACTIONS(2242),
    [anon_sym__Generic] = ACTIONS(2244),
    [anon_sym_asm] = ACTIONS(2246),
    [anon_sym___asm__] = ACTIONS(2246),
    [aux_sym_number_literal_token1] = ACTIONS(2248),
    [aux_sym_number_literal_token2] = ACTIONS(2250),
    [anon_sym_L_SQUOTE] = ACTIONS(2252),
    [anon_sym_u_SQUOTE] = ACTIONS(2252),
    [anon_sym_U_SQUOTE] = ACTIONS(2252),
    [anon_sym_u8_SQUOTE] = ACTIONS(2252),
    [anon_sym_SQUOTE] = ACTIONS(2252),
    [anon_sym_L_DQUOTE] = ACTIONS(2254),
    [anon_sym_u_DQUOTE] = ACTIONS(2254),
    [anon_sym_U_DQUOTE] = ACTIONS(2254),
    [anon_sym_u8_DQUOTE] = ACTIONS(2254),
    [anon_sym_DQUOTE] = ACTIONS(2254),
    [sym_true] = ACTIONS(2256),
    [sym_false] = ACTIONS(2256),
    [anon_sym_NULL] = ACTIONS(2258),
    [anon_sym_nullptr] = ACTIONS(2258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2260),
    [anon_sym_R_DQUOTE] = ACTIONS(2262),
    [anon_sym_LR_DQUOTE] = ACTIONS(2262),
    [anon_sym_uR_DQUOTE] = ACTIONS(2262),
    [anon_sym_UR_DQUOTE] = ACTIONS(2262),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2262),
    [anon_sym_co_await] = ACTIONS(2264),
    [anon_sym_new] = ACTIONS(2266),
    [anon_sym_requires] = ACTIONS(2268),
    [sym_this] = ACTIONS(2256),
  },
  [1386] = {
    [sym_primitive_type] = STATE(6613),
    [sym__expression] = STATE(3328),
    [sym__expression_not_binary] = STATE(3637),
    [sym__string] = STATE(3637),
    [sym_conditional_expression] = STATE(3637),
    [sym_assignment_expression] = STATE(3637),
    [sym_pointer_expression] = STATE(3637),
    [sym_unary_expression] = STATE(3637),
    [sym_binary_expression] = STATE(3637),
    [sym_update_expression] = STATE(3637),
    [sym_cast_expression] = STATE(3637),
    [sym_sizeof_expression] = STATE(3637),
    [sym_alignof_expression] = STATE(3637),
    [sym_offsetof_expression] = STATE(3637),
    [sym_generic_expression] = STATE(3637),
    [sym_subscript_expression] = STATE(3637),
    [sym_call_expression] = STATE(3637),
    [sym_gnu_asm_expression] = STATE(3637),
    [sym_field_expression] = STATE(3637),
    [sym_compound_literal_expression] = STATE(3637),
    [sym_parenthesized_expression] = STATE(3637),
    [sym_number_literal] = STATE(3416),
    [sym_char_literal] = STATE(3416),
    [sym_concatenated_string] = STATE(3415),
    [sym_string_literal] = STATE(2430),
    [sym_null] = STATE(3637),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7434),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3637),
    [sym_raw_string_literal] = STATE(2419),
    [sym_co_await_expression] = STATE(3637),
    [sym_new_expression] = STATE(3637),
    [sym_delete_expression] = STATE(3637),
    [sym_requires_clause] = STATE(3637),
    [sym_requires_expression] = STATE(3637),
    [sym_lambda_expression] = STATE(3637),
    [sym_lambda_capture_specifier] = STATE(5725),
    [sym_fold_expression] = STATE(3637),
    [sym_parameter_pack_expansion] = STATE(3637),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5512),
    [sym_qualified_identifier] = STATE(3637),
    [sym_qualified_type_identifier] = STATE(7434),
    [sym_user_defined_literal] = STATE(3637),
    [sym_identifier] = ACTIONS(2228),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_BANG] = ACTIONS(2232),
    [anon_sym_TILDE] = ACTIONS(2232),
    [anon_sym_DASH] = ACTIONS(2230),
    [anon_sym_PLUS] = ACTIONS(2230),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON_COLON] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2230),
    [anon_sym_compl] = ACTIONS(2230),
    [anon_sym_DASH_DASH] = ACTIONS(4112),
    [anon_sym_PLUS_PLUS] = ACTIONS(4112),
    [anon_sym_sizeof] = ACTIONS(2238),
    [anon_sym___alignof__] = ACTIONS(2240),
    [anon_sym___alignof] = ACTIONS(2240),
    [anon_sym__alignof] = ACTIONS(2240),
    [anon_sym_alignof] = ACTIONS(2240),
    [anon_sym__Alignof] = ACTIONS(2240),
    [anon_sym_offsetof] = ACTIONS(2242),
    [anon_sym__Generic] = ACTIONS(2244),
    [anon_sym_asm] = ACTIONS(2246),
    [anon_sym___asm__] = ACTIONS(2246),
    [aux_sym_number_literal_token1] = ACTIONS(2248),
    [aux_sym_number_literal_token2] = ACTIONS(2250),
    [anon_sym_L_SQUOTE] = ACTIONS(2252),
    [anon_sym_u_SQUOTE] = ACTIONS(2252),
    [anon_sym_U_SQUOTE] = ACTIONS(2252),
    [anon_sym_u8_SQUOTE] = ACTIONS(2252),
    [anon_sym_SQUOTE] = ACTIONS(2252),
    [anon_sym_L_DQUOTE] = ACTIONS(2254),
    [anon_sym_u_DQUOTE] = ACTIONS(2254),
    [anon_sym_U_DQUOTE] = ACTIONS(2254),
    [anon_sym_u8_DQUOTE] = ACTIONS(2254),
    [anon_sym_DQUOTE] = ACTIONS(2254),
    [sym_true] = ACTIONS(2256),
    [sym_false] = ACTIONS(2256),
    [anon_sym_NULL] = ACTIONS(2258),
    [anon_sym_nullptr] = ACTIONS(2258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2260),
    [anon_sym_R_DQUOTE] = ACTIONS(2262),
    [anon_sym_LR_DQUOTE] = ACTIONS(2262),
    [anon_sym_uR_DQUOTE] = ACTIONS(2262),
    [anon_sym_UR_DQUOTE] = ACTIONS(2262),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2262),
    [anon_sym_co_await] = ACTIONS(2264),
    [anon_sym_new] = ACTIONS(2266),
    [anon_sym_requires] = ACTIONS(2268),
    [sym_this] = ACTIONS(2256),
  },
  [1387] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4208),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1388] = {
    [sym_primitive_type] = STATE(6848),
    [sym__expression] = STATE(3177),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7357),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(7357),
    [sym_user_defined_literal] = STATE(3526),
    [sym_identifier] = ACTIONS(1965),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [1389] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4465),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1390] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4466),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1391] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4472),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1392] = {
    [sym_primitive_type] = STATE(6669),
    [sym__expression] = STATE(4374),
    [sym__expression_not_binary] = STATE(4648),
    [sym__string] = STATE(4648),
    [sym_conditional_expression] = STATE(4648),
    [sym_assignment_expression] = STATE(4648),
    [sym_pointer_expression] = STATE(3663),
    [sym_unary_expression] = STATE(4648),
    [sym_binary_expression] = STATE(4648),
    [sym_update_expression] = STATE(4648),
    [sym_cast_expression] = STATE(4648),
    [sym_sizeof_expression] = STATE(4648),
    [sym_alignof_expression] = STATE(4648),
    [sym_offsetof_expression] = STATE(4648),
    [sym_generic_expression] = STATE(4648),
    [sym_subscript_expression] = STATE(3663),
    [sym_call_expression] = STATE(3663),
    [sym_gnu_asm_expression] = STATE(4648),
    [sym_field_expression] = STATE(3663),
    [sym_compound_literal_expression] = STATE(4648),
    [sym_parenthesized_expression] = STATE(3663),
    [sym_number_literal] = STATE(4573),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4565),
    [sym_string_literal] = STATE(3707),
    [sym_null] = STATE(4648),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7442),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(4648),
    [sym_raw_string_literal] = STATE(3709),
    [sym_co_await_expression] = STATE(4648),
    [sym_new_expression] = STATE(4648),
    [sym_delete_expression] = STATE(4648),
    [sym_requires_clause] = STATE(4648),
    [sym_requires_expression] = STATE(4648),
    [sym_lambda_expression] = STATE(4648),
    [sym_lambda_capture_specifier] = STATE(5768),
    [sym_fold_expression] = STATE(4648),
    [sym_parameter_pack_expansion] = STATE(4648),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5512),
    [sym_qualified_identifier] = STATE(3663),
    [sym_qualified_type_identifier] = STATE(7442),
    [sym_user_defined_literal] = STATE(3663),
    [sym_identifier] = ACTIONS(3458),
    [anon_sym_LPAREN2] = ACTIONS(2575),
    [anon_sym_BANG] = ACTIONS(2577),
    [anon_sym_TILDE] = ACTIONS(2577),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON_COLON] = ACTIONS(2583),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2579),
    [anon_sym_compl] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(2597),
    [anon_sym_PLUS_PLUS] = ACTIONS(2597),
    [anon_sym_sizeof] = ACTIONS(2599),
    [anon_sym___alignof__] = ACTIONS(2601),
    [anon_sym___alignof] = ACTIONS(2601),
    [anon_sym__alignof] = ACTIONS(2601),
    [anon_sym_alignof] = ACTIONS(2601),
    [anon_sym__Alignof] = ACTIONS(2601),
    [anon_sym_offsetof] = ACTIONS(2603),
    [anon_sym__Generic] = ACTIONS(2605),
    [anon_sym_asm] = ACTIONS(2607),
    [anon_sym___asm__] = ACTIONS(2607),
    [aux_sym_number_literal_token1] = ACTIONS(2609),
    [aux_sym_number_literal_token2] = ACTIONS(2611),
    [anon_sym_L_SQUOTE] = ACTIONS(2613),
    [anon_sym_u_SQUOTE] = ACTIONS(2613),
    [anon_sym_U_SQUOTE] = ACTIONS(2613),
    [anon_sym_u8_SQUOTE] = ACTIONS(2613),
    [anon_sym_SQUOTE] = ACTIONS(2613),
    [anon_sym_L_DQUOTE] = ACTIONS(2615),
    [anon_sym_u_DQUOTE] = ACTIONS(2615),
    [anon_sym_U_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8_DQUOTE] = ACTIONS(2615),
    [anon_sym_DQUOTE] = ACTIONS(2615),
    [sym_true] = ACTIONS(2617),
    [sym_false] = ACTIONS(2617),
    [anon_sym_NULL] = ACTIONS(2619),
    [anon_sym_nullptr] = ACTIONS(2619),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2629),
    [anon_sym_R_DQUOTE] = ACTIONS(2631),
    [anon_sym_LR_DQUOTE] = ACTIONS(2631),
    [anon_sym_uR_DQUOTE] = ACTIONS(2631),
    [anon_sym_UR_DQUOTE] = ACTIONS(2631),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2631),
    [anon_sym_co_await] = ACTIONS(2633),
    [anon_sym_new] = ACTIONS(2635),
    [anon_sym_requires] = ACTIONS(2637),
    [sym_this] = ACTIONS(2617),
  },
  [1393] = {
    [sym_primitive_type] = STATE(6669),
    [sym__expression] = STATE(4373),
    [sym__expression_not_binary] = STATE(4648),
    [sym__string] = STATE(4648),
    [sym_conditional_expression] = STATE(4648),
    [sym_assignment_expression] = STATE(4648),
    [sym_pointer_expression] = STATE(3663),
    [sym_unary_expression] = STATE(4648),
    [sym_binary_expression] = STATE(4648),
    [sym_update_expression] = STATE(4648),
    [sym_cast_expression] = STATE(4648),
    [sym_sizeof_expression] = STATE(4648),
    [sym_alignof_expression] = STATE(4648),
    [sym_offsetof_expression] = STATE(4648),
    [sym_generic_expression] = STATE(4648),
    [sym_subscript_expression] = STATE(3663),
    [sym_call_expression] = STATE(3663),
    [sym_gnu_asm_expression] = STATE(4648),
    [sym_field_expression] = STATE(3663),
    [sym_compound_literal_expression] = STATE(4648),
    [sym_parenthesized_expression] = STATE(3663),
    [sym_number_literal] = STATE(4573),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4565),
    [sym_string_literal] = STATE(3707),
    [sym_null] = STATE(4648),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7442),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(4648),
    [sym_raw_string_literal] = STATE(3709),
    [sym_co_await_expression] = STATE(4648),
    [sym_new_expression] = STATE(4648),
    [sym_delete_expression] = STATE(4648),
    [sym_requires_clause] = STATE(4648),
    [sym_requires_expression] = STATE(4648),
    [sym_lambda_expression] = STATE(4648),
    [sym_lambda_capture_specifier] = STATE(5768),
    [sym_fold_expression] = STATE(4648),
    [sym_parameter_pack_expansion] = STATE(4648),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5512),
    [sym_qualified_identifier] = STATE(3663),
    [sym_qualified_type_identifier] = STATE(7442),
    [sym_user_defined_literal] = STATE(3663),
    [sym_identifier] = ACTIONS(3458),
    [anon_sym_LPAREN2] = ACTIONS(2575),
    [anon_sym_BANG] = ACTIONS(2577),
    [anon_sym_TILDE] = ACTIONS(2577),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON_COLON] = ACTIONS(2583),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2579),
    [anon_sym_compl] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(2597),
    [anon_sym_PLUS_PLUS] = ACTIONS(2597),
    [anon_sym_sizeof] = ACTIONS(2599),
    [anon_sym___alignof__] = ACTIONS(2601),
    [anon_sym___alignof] = ACTIONS(2601),
    [anon_sym__alignof] = ACTIONS(2601),
    [anon_sym_alignof] = ACTIONS(2601),
    [anon_sym__Alignof] = ACTIONS(2601),
    [anon_sym_offsetof] = ACTIONS(2603),
    [anon_sym__Generic] = ACTIONS(2605),
    [anon_sym_asm] = ACTIONS(2607),
    [anon_sym___asm__] = ACTIONS(2607),
    [aux_sym_number_literal_token1] = ACTIONS(2609),
    [aux_sym_number_literal_token2] = ACTIONS(2611),
    [anon_sym_L_SQUOTE] = ACTIONS(2613),
    [anon_sym_u_SQUOTE] = ACTIONS(2613),
    [anon_sym_U_SQUOTE] = ACTIONS(2613),
    [anon_sym_u8_SQUOTE] = ACTIONS(2613),
    [anon_sym_SQUOTE] = ACTIONS(2613),
    [anon_sym_L_DQUOTE] = ACTIONS(2615),
    [anon_sym_u_DQUOTE] = ACTIONS(2615),
    [anon_sym_U_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8_DQUOTE] = ACTIONS(2615),
    [anon_sym_DQUOTE] = ACTIONS(2615),
    [sym_true] = ACTIONS(2617),
    [sym_false] = ACTIONS(2617),
    [anon_sym_NULL] = ACTIONS(2619),
    [anon_sym_nullptr] = ACTIONS(2619),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2629),
    [anon_sym_R_DQUOTE] = ACTIONS(2631),
    [anon_sym_LR_DQUOTE] = ACTIONS(2631),
    [anon_sym_uR_DQUOTE] = ACTIONS(2631),
    [anon_sym_UR_DQUOTE] = ACTIONS(2631),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2631),
    [anon_sym_co_await] = ACTIONS(2633),
    [anon_sym_new] = ACTIONS(2635),
    [anon_sym_requires] = ACTIONS(2637),
    [sym_this] = ACTIONS(2617),
  },
  [1394] = {
    [sym_primitive_type] = STATE(6669),
    [sym__expression] = STATE(4372),
    [sym__expression_not_binary] = STATE(4648),
    [sym__string] = STATE(4648),
    [sym_conditional_expression] = STATE(4648),
    [sym_assignment_expression] = STATE(4648),
    [sym_pointer_expression] = STATE(3663),
    [sym_unary_expression] = STATE(4648),
    [sym_binary_expression] = STATE(4648),
    [sym_update_expression] = STATE(4648),
    [sym_cast_expression] = STATE(4648),
    [sym_sizeof_expression] = STATE(4648),
    [sym_alignof_expression] = STATE(4648),
    [sym_offsetof_expression] = STATE(4648),
    [sym_generic_expression] = STATE(4648),
    [sym_subscript_expression] = STATE(3663),
    [sym_call_expression] = STATE(3663),
    [sym_gnu_asm_expression] = STATE(4648),
    [sym_field_expression] = STATE(3663),
    [sym_compound_literal_expression] = STATE(4648),
    [sym_parenthesized_expression] = STATE(3663),
    [sym_number_literal] = STATE(4573),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4565),
    [sym_string_literal] = STATE(3707),
    [sym_null] = STATE(4648),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7442),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(4648),
    [sym_raw_string_literal] = STATE(3709),
    [sym_co_await_expression] = STATE(4648),
    [sym_new_expression] = STATE(4648),
    [sym_delete_expression] = STATE(4648),
    [sym_requires_clause] = STATE(4648),
    [sym_requires_expression] = STATE(4648),
    [sym_lambda_expression] = STATE(4648),
    [sym_lambda_capture_specifier] = STATE(5768),
    [sym_fold_expression] = STATE(4648),
    [sym_parameter_pack_expansion] = STATE(4648),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5512),
    [sym_qualified_identifier] = STATE(3663),
    [sym_qualified_type_identifier] = STATE(7442),
    [sym_user_defined_literal] = STATE(3663),
    [sym_identifier] = ACTIONS(3458),
    [anon_sym_LPAREN2] = ACTIONS(2575),
    [anon_sym_BANG] = ACTIONS(2577),
    [anon_sym_TILDE] = ACTIONS(2577),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON_COLON] = ACTIONS(2583),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2579),
    [anon_sym_compl] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(2597),
    [anon_sym_PLUS_PLUS] = ACTIONS(2597),
    [anon_sym_sizeof] = ACTIONS(2599),
    [anon_sym___alignof__] = ACTIONS(2601),
    [anon_sym___alignof] = ACTIONS(2601),
    [anon_sym__alignof] = ACTIONS(2601),
    [anon_sym_alignof] = ACTIONS(2601),
    [anon_sym__Alignof] = ACTIONS(2601),
    [anon_sym_offsetof] = ACTIONS(2603),
    [anon_sym__Generic] = ACTIONS(2605),
    [anon_sym_asm] = ACTIONS(2607),
    [anon_sym___asm__] = ACTIONS(2607),
    [aux_sym_number_literal_token1] = ACTIONS(2609),
    [aux_sym_number_literal_token2] = ACTIONS(2611),
    [anon_sym_L_SQUOTE] = ACTIONS(2613),
    [anon_sym_u_SQUOTE] = ACTIONS(2613),
    [anon_sym_U_SQUOTE] = ACTIONS(2613),
    [anon_sym_u8_SQUOTE] = ACTIONS(2613),
    [anon_sym_SQUOTE] = ACTIONS(2613),
    [anon_sym_L_DQUOTE] = ACTIONS(2615),
    [anon_sym_u_DQUOTE] = ACTIONS(2615),
    [anon_sym_U_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8_DQUOTE] = ACTIONS(2615),
    [anon_sym_DQUOTE] = ACTIONS(2615),
    [sym_true] = ACTIONS(2617),
    [sym_false] = ACTIONS(2617),
    [anon_sym_NULL] = ACTIONS(2619),
    [anon_sym_nullptr] = ACTIONS(2619),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2629),
    [anon_sym_R_DQUOTE] = ACTIONS(2631),
    [anon_sym_LR_DQUOTE] = ACTIONS(2631),
    [anon_sym_uR_DQUOTE] = ACTIONS(2631),
    [anon_sym_UR_DQUOTE] = ACTIONS(2631),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2631),
    [anon_sym_co_await] = ACTIONS(2633),
    [anon_sym_new] = ACTIONS(2635),
    [anon_sym_requires] = ACTIONS(2637),
    [sym_this] = ACTIONS(2617),
  },
  [1395] = {
    [sym_primitive_type] = STATE(6669),
    [sym__expression] = STATE(4371),
    [sym__expression_not_binary] = STATE(4648),
    [sym__string] = STATE(4648),
    [sym_conditional_expression] = STATE(4648),
    [sym_assignment_expression] = STATE(4648),
    [sym_pointer_expression] = STATE(3663),
    [sym_unary_expression] = STATE(4648),
    [sym_binary_expression] = STATE(4648),
    [sym_update_expression] = STATE(4648),
    [sym_cast_expression] = STATE(4648),
    [sym_sizeof_expression] = STATE(4648),
    [sym_alignof_expression] = STATE(4648),
    [sym_offsetof_expression] = STATE(4648),
    [sym_generic_expression] = STATE(4648),
    [sym_subscript_expression] = STATE(3663),
    [sym_call_expression] = STATE(3663),
    [sym_gnu_asm_expression] = STATE(4648),
    [sym_field_expression] = STATE(3663),
    [sym_compound_literal_expression] = STATE(4648),
    [sym_parenthesized_expression] = STATE(3663),
    [sym_number_literal] = STATE(4573),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4565),
    [sym_string_literal] = STATE(3707),
    [sym_null] = STATE(4648),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7442),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(4648),
    [sym_raw_string_literal] = STATE(3709),
    [sym_co_await_expression] = STATE(4648),
    [sym_new_expression] = STATE(4648),
    [sym_delete_expression] = STATE(4648),
    [sym_requires_clause] = STATE(4648),
    [sym_requires_expression] = STATE(4648),
    [sym_lambda_expression] = STATE(4648),
    [sym_lambda_capture_specifier] = STATE(5768),
    [sym_fold_expression] = STATE(4648),
    [sym_parameter_pack_expansion] = STATE(4648),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5512),
    [sym_qualified_identifier] = STATE(3663),
    [sym_qualified_type_identifier] = STATE(7442),
    [sym_user_defined_literal] = STATE(3663),
    [sym_identifier] = ACTIONS(3458),
    [anon_sym_LPAREN2] = ACTIONS(2575),
    [anon_sym_BANG] = ACTIONS(2577),
    [anon_sym_TILDE] = ACTIONS(2577),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON_COLON] = ACTIONS(2583),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2579),
    [anon_sym_compl] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(2597),
    [anon_sym_PLUS_PLUS] = ACTIONS(2597),
    [anon_sym_sizeof] = ACTIONS(2599),
    [anon_sym___alignof__] = ACTIONS(2601),
    [anon_sym___alignof] = ACTIONS(2601),
    [anon_sym__alignof] = ACTIONS(2601),
    [anon_sym_alignof] = ACTIONS(2601),
    [anon_sym__Alignof] = ACTIONS(2601),
    [anon_sym_offsetof] = ACTIONS(2603),
    [anon_sym__Generic] = ACTIONS(2605),
    [anon_sym_asm] = ACTIONS(2607),
    [anon_sym___asm__] = ACTIONS(2607),
    [aux_sym_number_literal_token1] = ACTIONS(2609),
    [aux_sym_number_literal_token2] = ACTIONS(2611),
    [anon_sym_L_SQUOTE] = ACTIONS(2613),
    [anon_sym_u_SQUOTE] = ACTIONS(2613),
    [anon_sym_U_SQUOTE] = ACTIONS(2613),
    [anon_sym_u8_SQUOTE] = ACTIONS(2613),
    [anon_sym_SQUOTE] = ACTIONS(2613),
    [anon_sym_L_DQUOTE] = ACTIONS(2615),
    [anon_sym_u_DQUOTE] = ACTIONS(2615),
    [anon_sym_U_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8_DQUOTE] = ACTIONS(2615),
    [anon_sym_DQUOTE] = ACTIONS(2615),
    [sym_true] = ACTIONS(2617),
    [sym_false] = ACTIONS(2617),
    [anon_sym_NULL] = ACTIONS(2619),
    [anon_sym_nullptr] = ACTIONS(2619),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2629),
    [anon_sym_R_DQUOTE] = ACTIONS(2631),
    [anon_sym_LR_DQUOTE] = ACTIONS(2631),
    [anon_sym_uR_DQUOTE] = ACTIONS(2631),
    [anon_sym_UR_DQUOTE] = ACTIONS(2631),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2631),
    [anon_sym_co_await] = ACTIONS(2633),
    [anon_sym_new] = ACTIONS(2635),
    [anon_sym_requires] = ACTIONS(2637),
    [sym_this] = ACTIONS(2617),
  },
  [1396] = {
    [sym_primitive_type] = STATE(6669),
    [sym__expression] = STATE(4362),
    [sym__expression_not_binary] = STATE(4648),
    [sym__string] = STATE(4648),
    [sym_conditional_expression] = STATE(4648),
    [sym_assignment_expression] = STATE(4648),
    [sym_pointer_expression] = STATE(3663),
    [sym_unary_expression] = STATE(4648),
    [sym_binary_expression] = STATE(4648),
    [sym_update_expression] = STATE(4648),
    [sym_cast_expression] = STATE(4648),
    [sym_sizeof_expression] = STATE(4648),
    [sym_alignof_expression] = STATE(4648),
    [sym_offsetof_expression] = STATE(4648),
    [sym_generic_expression] = STATE(4648),
    [sym_subscript_expression] = STATE(3663),
    [sym_call_expression] = STATE(3663),
    [sym_gnu_asm_expression] = STATE(4648),
    [sym_field_expression] = STATE(3663),
    [sym_compound_literal_expression] = STATE(4648),
    [sym_parenthesized_expression] = STATE(3663),
    [sym_number_literal] = STATE(4573),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4565),
    [sym_string_literal] = STATE(3707),
    [sym_null] = STATE(4648),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7442),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(4648),
    [sym_raw_string_literal] = STATE(3709),
    [sym_co_await_expression] = STATE(4648),
    [sym_new_expression] = STATE(4648),
    [sym_delete_expression] = STATE(4648),
    [sym_requires_clause] = STATE(4648),
    [sym_requires_expression] = STATE(4648),
    [sym_lambda_expression] = STATE(4648),
    [sym_lambda_capture_specifier] = STATE(5768),
    [sym_fold_expression] = STATE(4648),
    [sym_parameter_pack_expansion] = STATE(4648),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5512),
    [sym_qualified_identifier] = STATE(3663),
    [sym_qualified_type_identifier] = STATE(7442),
    [sym_user_defined_literal] = STATE(3663),
    [sym_identifier] = ACTIONS(3458),
    [anon_sym_LPAREN2] = ACTIONS(2575),
    [anon_sym_BANG] = ACTIONS(2577),
    [anon_sym_TILDE] = ACTIONS(2577),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON_COLON] = ACTIONS(2583),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2579),
    [anon_sym_compl] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(2597),
    [anon_sym_PLUS_PLUS] = ACTIONS(2597),
    [anon_sym_sizeof] = ACTIONS(2599),
    [anon_sym___alignof__] = ACTIONS(2601),
    [anon_sym___alignof] = ACTIONS(2601),
    [anon_sym__alignof] = ACTIONS(2601),
    [anon_sym_alignof] = ACTIONS(2601),
    [anon_sym__Alignof] = ACTIONS(2601),
    [anon_sym_offsetof] = ACTIONS(2603),
    [anon_sym__Generic] = ACTIONS(2605),
    [anon_sym_asm] = ACTIONS(2607),
    [anon_sym___asm__] = ACTIONS(2607),
    [aux_sym_number_literal_token1] = ACTIONS(2609),
    [aux_sym_number_literal_token2] = ACTIONS(2611),
    [anon_sym_L_SQUOTE] = ACTIONS(2613),
    [anon_sym_u_SQUOTE] = ACTIONS(2613),
    [anon_sym_U_SQUOTE] = ACTIONS(2613),
    [anon_sym_u8_SQUOTE] = ACTIONS(2613),
    [anon_sym_SQUOTE] = ACTIONS(2613),
    [anon_sym_L_DQUOTE] = ACTIONS(2615),
    [anon_sym_u_DQUOTE] = ACTIONS(2615),
    [anon_sym_U_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8_DQUOTE] = ACTIONS(2615),
    [anon_sym_DQUOTE] = ACTIONS(2615),
    [sym_true] = ACTIONS(2617),
    [sym_false] = ACTIONS(2617),
    [anon_sym_NULL] = ACTIONS(2619),
    [anon_sym_nullptr] = ACTIONS(2619),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2629),
    [anon_sym_R_DQUOTE] = ACTIONS(2631),
    [anon_sym_LR_DQUOTE] = ACTIONS(2631),
    [anon_sym_uR_DQUOTE] = ACTIONS(2631),
    [anon_sym_UR_DQUOTE] = ACTIONS(2631),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2631),
    [anon_sym_co_await] = ACTIONS(2633),
    [anon_sym_new] = ACTIONS(2635),
    [anon_sym_requires] = ACTIONS(2637),
    [sym_this] = ACTIONS(2617),
  },
  [1397] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4473),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1398] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(3885),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1399] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4485),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1400] = {
    [sym_primitive_type] = STATE(6597),
    [sym__expression] = STATE(4599),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1401] = {
    [sym_primitive_type] = STATE(6669),
    [sym__expression] = STATE(4360),
    [sym__expression_not_binary] = STATE(4648),
    [sym__string] = STATE(4648),
    [sym_conditional_expression] = STATE(4648),
    [sym_assignment_expression] = STATE(4648),
    [sym_pointer_expression] = STATE(3663),
    [sym_unary_expression] = STATE(4648),
    [sym_binary_expression] = STATE(4648),
    [sym_update_expression] = STATE(4648),
    [sym_cast_expression] = STATE(4648),
    [sym_sizeof_expression] = STATE(4648),
    [sym_alignof_expression] = STATE(4648),
    [sym_offsetof_expression] = STATE(4648),
    [sym_generic_expression] = STATE(4648),
    [sym_subscript_expression] = STATE(3663),
    [sym_call_expression] = STATE(3663),
    [sym_gnu_asm_expression] = STATE(4648),
    [sym_field_expression] = STATE(3663),
    [sym_compound_literal_expression] = STATE(4648),
    [sym_parenthesized_expression] = STATE(3663),
    [sym_number_literal] = STATE(4573),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4565),
    [sym_string_literal] = STATE(3707),
    [sym_null] = STATE(4648),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7442),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(4648),
    [sym_raw_string_literal] = STATE(3709),
    [sym_co_await_expression] = STATE(4648),
    [sym_new_expression] = STATE(4648),
    [sym_delete_expression] = STATE(4648),
    [sym_requires_clause] = STATE(4648),
    [sym_requires_expression] = STATE(4648),
    [sym_lambda_expression] = STATE(4648),
    [sym_lambda_capture_specifier] = STATE(5768),
    [sym_fold_expression] = STATE(4648),
    [sym_parameter_pack_expansion] = STATE(4648),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5512),
    [sym_qualified_identifier] = STATE(3663),
    [sym_qualified_type_identifier] = STATE(7442),
    [sym_user_defined_literal] = STATE(3663),
    [sym_identifier] = ACTIONS(3458),
    [anon_sym_LPAREN2] = ACTIONS(2575),
    [anon_sym_BANG] = ACTIONS(2577),
    [anon_sym_TILDE] = ACTIONS(2577),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON_COLON] = ACTIONS(2583),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2579),
    [anon_sym_compl] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(2597),
    [anon_sym_PLUS_PLUS] = ACTIONS(2597),
    [anon_sym_sizeof] = ACTIONS(2599),
    [anon_sym___alignof__] = ACTIONS(2601),
    [anon_sym___alignof] = ACTIONS(2601),
    [anon_sym__alignof] = ACTIONS(2601),
    [anon_sym_alignof] = ACTIONS(2601),
    [anon_sym__Alignof] = ACTIONS(2601),
    [anon_sym_offsetof] = ACTIONS(2603),
    [anon_sym__Generic] = ACTIONS(2605),
    [anon_sym_asm] = ACTIONS(2607),
    [anon_sym___asm__] = ACTIONS(2607),
    [aux_sym_number_literal_token1] = ACTIONS(2609),
    [aux_sym_number_literal_token2] = ACTIONS(2611),
    [anon_sym_L_SQUOTE] = ACTIONS(2613),
    [anon_sym_u_SQUOTE] = ACTIONS(2613),
    [anon_sym_U_SQUOTE] = ACTIONS(2613),
    [anon_sym_u8_SQUOTE] = ACTIONS(2613),
    [anon_sym_SQUOTE] = ACTIONS(2613),
    [anon_sym_L_DQUOTE] = ACTIONS(2615),
    [anon_sym_u_DQUOTE] = ACTIONS(2615),
    [anon_sym_U_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8_DQUOTE] = ACTIONS(2615),
    [anon_sym_DQUOTE] = ACTIONS(2615),
    [sym_true] = ACTIONS(2617),
    [sym_false] = ACTIONS(2617),
    [anon_sym_NULL] = ACTIONS(2619),
    [anon_sym_nullptr] = ACTIONS(2619),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2629),
    [anon_sym_R_DQUOTE] = ACTIONS(2631),
    [anon_sym_LR_DQUOTE] = ACTIONS(2631),
    [anon_sym_uR_DQUOTE] = ACTIONS(2631),
    [anon_sym_UR_DQUOTE] = ACTIONS(2631),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2631),
    [anon_sym_co_await] = ACTIONS(2633),
    [anon_sym_new] = ACTIONS(2635),
    [anon_sym_requires] = ACTIONS(2637),
    [sym_this] = ACTIONS(2617),
  },
  [1402] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4585),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1403] = {
    [sym_primitive_type] = STATE(6669),
    [sym__expression] = STATE(4359),
    [sym__expression_not_binary] = STATE(4648),
    [sym__string] = STATE(4648),
    [sym_conditional_expression] = STATE(4648),
    [sym_assignment_expression] = STATE(4648),
    [sym_pointer_expression] = STATE(3663),
    [sym_unary_expression] = STATE(4648),
    [sym_binary_expression] = STATE(4648),
    [sym_update_expression] = STATE(4648),
    [sym_cast_expression] = STATE(4648),
    [sym_sizeof_expression] = STATE(4648),
    [sym_alignof_expression] = STATE(4648),
    [sym_offsetof_expression] = STATE(4648),
    [sym_generic_expression] = STATE(4648),
    [sym_subscript_expression] = STATE(3663),
    [sym_call_expression] = STATE(3663),
    [sym_gnu_asm_expression] = STATE(4648),
    [sym_field_expression] = STATE(3663),
    [sym_compound_literal_expression] = STATE(4648),
    [sym_parenthesized_expression] = STATE(3663),
    [sym_number_literal] = STATE(4573),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4565),
    [sym_string_literal] = STATE(3707),
    [sym_null] = STATE(4648),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7442),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(4648),
    [sym_raw_string_literal] = STATE(3709),
    [sym_co_await_expression] = STATE(4648),
    [sym_new_expression] = STATE(4648),
    [sym_delete_expression] = STATE(4648),
    [sym_requires_clause] = STATE(4648),
    [sym_requires_expression] = STATE(4648),
    [sym_lambda_expression] = STATE(4648),
    [sym_lambda_capture_specifier] = STATE(5768),
    [sym_fold_expression] = STATE(4648),
    [sym_parameter_pack_expansion] = STATE(4648),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5512),
    [sym_qualified_identifier] = STATE(3663),
    [sym_qualified_type_identifier] = STATE(7442),
    [sym_user_defined_literal] = STATE(3663),
    [sym_identifier] = ACTIONS(3458),
    [anon_sym_LPAREN2] = ACTIONS(2575),
    [anon_sym_BANG] = ACTIONS(2577),
    [anon_sym_TILDE] = ACTIONS(2577),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON_COLON] = ACTIONS(2583),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2579),
    [anon_sym_compl] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(2597),
    [anon_sym_PLUS_PLUS] = ACTIONS(2597),
    [anon_sym_sizeof] = ACTIONS(2599),
    [anon_sym___alignof__] = ACTIONS(2601),
    [anon_sym___alignof] = ACTIONS(2601),
    [anon_sym__alignof] = ACTIONS(2601),
    [anon_sym_alignof] = ACTIONS(2601),
    [anon_sym__Alignof] = ACTIONS(2601),
    [anon_sym_offsetof] = ACTIONS(2603),
    [anon_sym__Generic] = ACTIONS(2605),
    [anon_sym_asm] = ACTIONS(2607),
    [anon_sym___asm__] = ACTIONS(2607),
    [aux_sym_number_literal_token1] = ACTIONS(2609),
    [aux_sym_number_literal_token2] = ACTIONS(2611),
    [anon_sym_L_SQUOTE] = ACTIONS(2613),
    [anon_sym_u_SQUOTE] = ACTIONS(2613),
    [anon_sym_U_SQUOTE] = ACTIONS(2613),
    [anon_sym_u8_SQUOTE] = ACTIONS(2613),
    [anon_sym_SQUOTE] = ACTIONS(2613),
    [anon_sym_L_DQUOTE] = ACTIONS(2615),
    [anon_sym_u_DQUOTE] = ACTIONS(2615),
    [anon_sym_U_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8_DQUOTE] = ACTIONS(2615),
    [anon_sym_DQUOTE] = ACTIONS(2615),
    [sym_true] = ACTIONS(2617),
    [sym_false] = ACTIONS(2617),
    [anon_sym_NULL] = ACTIONS(2619),
    [anon_sym_nullptr] = ACTIONS(2619),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2629),
    [anon_sym_R_DQUOTE] = ACTIONS(2631),
    [anon_sym_LR_DQUOTE] = ACTIONS(2631),
    [anon_sym_uR_DQUOTE] = ACTIONS(2631),
    [anon_sym_UR_DQUOTE] = ACTIONS(2631),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2631),
    [anon_sym_co_await] = ACTIONS(2633),
    [anon_sym_new] = ACTIONS(2635),
    [anon_sym_requires] = ACTIONS(2637),
    [sym_this] = ACTIONS(2617),
  },
  [1404] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4408),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1405] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4245),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1406] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4511),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3679),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3679),
    [sym_call_expression] = STATE(3679),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3679),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3679),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3679),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3679),
    [sym_identifier] = ACTIONS(3538),
    [anon_sym_LPAREN2] = ACTIONS(4199),
    [anon_sym_BANG] = ACTIONS(3542),
    [anon_sym_TILDE] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3540),
    [anon_sym_PLUS] = ACTIONS(3540),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(3544),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3540),
    [anon_sym_compl] = ACTIONS(3540),
    [anon_sym_DASH_DASH] = ACTIONS(4122),
    [anon_sym_PLUS_PLUS] = ACTIONS(4122),
    [anon_sym_sizeof] = ACTIONS(3546),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3548),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3550),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1407] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4416),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(4464),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1408] = {
    [sym_primitive_type] = STATE(6853),
    [sym__expression] = STATE(3588),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7464),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(7464),
    [sym_user_defined_literal] = STATE(3374),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_LPAREN2] = ACTIONS(1745),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [1409] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4616),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1410] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4607),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1411] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(3173),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(3292),
    [sym_char_literal] = STATE(3292),
    [sym_concatenated_string] = STATE(3308),
    [sym_string_literal] = STATE(2343),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2348),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1969),
    [anon_sym_LPAREN2] = ACTIONS(4256),
    [anon_sym_BANG] = ACTIONS(1973),
    [anon_sym_TILDE] = ACTIONS(1973),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_STAR] = ACTIONS(4048),
    [anon_sym_AMP] = ACTIONS(4048),
    [anon_sym_COLON_COLON] = ACTIONS(1975),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1971),
    [anon_sym_compl] = ACTIONS(1971),
    [anon_sym_DASH_DASH] = ACTIONS(4096),
    [anon_sym_PLUS_PLUS] = ACTIONS(4096),
    [anon_sym_sizeof] = ACTIONS(1977),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1979),
    [aux_sym_number_literal_token2] = ACTIONS(1981),
    [anon_sym_L_SQUOTE] = ACTIONS(1983),
    [anon_sym_u_SQUOTE] = ACTIONS(1983),
    [anon_sym_U_SQUOTE] = ACTIONS(1983),
    [anon_sym_u8_SQUOTE] = ACTIONS(1983),
    [anon_sym_SQUOTE] = ACTIONS(1983),
    [anon_sym_L_DQUOTE] = ACTIONS(1985),
    [anon_sym_u_DQUOTE] = ACTIONS(1985),
    [anon_sym_U_DQUOTE] = ACTIONS(1985),
    [anon_sym_u8_DQUOTE] = ACTIONS(1985),
    [anon_sym_DQUOTE] = ACTIONS(1985),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1987),
    [anon_sym_R_DQUOTE] = ACTIONS(1989),
    [anon_sym_LR_DQUOTE] = ACTIONS(1989),
    [anon_sym_uR_DQUOTE] = ACTIONS(1989),
    [anon_sym_UR_DQUOTE] = ACTIONS(1989),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1989),
    [anon_sym_co_await] = ACTIONS(1991),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1412] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4600),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3679),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3679),
    [sym_call_expression] = STATE(3679),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3679),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3679),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3679),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3679),
    [sym_identifier] = ACTIONS(3538),
    [anon_sym_LPAREN2] = ACTIONS(4199),
    [anon_sym_BANG] = ACTIONS(3542),
    [anon_sym_TILDE] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3540),
    [anon_sym_PLUS] = ACTIONS(3540),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(3544),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3540),
    [anon_sym_compl] = ACTIONS(3540),
    [anon_sym_DASH_DASH] = ACTIONS(4122),
    [anon_sym_PLUS_PLUS] = ACTIONS(4122),
    [anon_sym_sizeof] = ACTIONS(3546),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3548),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3550),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1413] = {
    [sym_primitive_type] = STATE(6669),
    [sym__expression] = STATE(4357),
    [sym__expression_not_binary] = STATE(4648),
    [sym__string] = STATE(4648),
    [sym_conditional_expression] = STATE(4648),
    [sym_assignment_expression] = STATE(4648),
    [sym_pointer_expression] = STATE(3663),
    [sym_unary_expression] = STATE(4648),
    [sym_binary_expression] = STATE(4648),
    [sym_update_expression] = STATE(4648),
    [sym_cast_expression] = STATE(4648),
    [sym_sizeof_expression] = STATE(4648),
    [sym_alignof_expression] = STATE(4648),
    [sym_offsetof_expression] = STATE(4648),
    [sym_generic_expression] = STATE(4648),
    [sym_subscript_expression] = STATE(3663),
    [sym_call_expression] = STATE(3663),
    [sym_gnu_asm_expression] = STATE(4648),
    [sym_field_expression] = STATE(3663),
    [sym_compound_literal_expression] = STATE(4648),
    [sym_parenthesized_expression] = STATE(3663),
    [sym_number_literal] = STATE(4573),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4565),
    [sym_string_literal] = STATE(3707),
    [sym_null] = STATE(4648),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7442),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(4648),
    [sym_raw_string_literal] = STATE(3709),
    [sym_co_await_expression] = STATE(4648),
    [sym_new_expression] = STATE(4648),
    [sym_delete_expression] = STATE(4648),
    [sym_requires_clause] = STATE(4648),
    [sym_requires_expression] = STATE(4648),
    [sym_lambda_expression] = STATE(4648),
    [sym_lambda_capture_specifier] = STATE(5768),
    [sym_fold_expression] = STATE(4648),
    [sym_parameter_pack_expansion] = STATE(4648),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5512),
    [sym_qualified_identifier] = STATE(3663),
    [sym_qualified_type_identifier] = STATE(7442),
    [sym_user_defined_literal] = STATE(3663),
    [sym_identifier] = ACTIONS(3458),
    [anon_sym_LPAREN2] = ACTIONS(2575),
    [anon_sym_BANG] = ACTIONS(2577),
    [anon_sym_TILDE] = ACTIONS(2577),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON_COLON] = ACTIONS(2583),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2579),
    [anon_sym_compl] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(2597),
    [anon_sym_PLUS_PLUS] = ACTIONS(2597),
    [anon_sym_sizeof] = ACTIONS(2599),
    [anon_sym___alignof__] = ACTIONS(2601),
    [anon_sym___alignof] = ACTIONS(2601),
    [anon_sym__alignof] = ACTIONS(2601),
    [anon_sym_alignof] = ACTIONS(2601),
    [anon_sym__Alignof] = ACTIONS(2601),
    [anon_sym_offsetof] = ACTIONS(2603),
    [anon_sym__Generic] = ACTIONS(2605),
    [anon_sym_asm] = ACTIONS(2607),
    [anon_sym___asm__] = ACTIONS(2607),
    [aux_sym_number_literal_token1] = ACTIONS(2609),
    [aux_sym_number_literal_token2] = ACTIONS(2611),
    [anon_sym_L_SQUOTE] = ACTIONS(2613),
    [anon_sym_u_SQUOTE] = ACTIONS(2613),
    [anon_sym_U_SQUOTE] = ACTIONS(2613),
    [anon_sym_u8_SQUOTE] = ACTIONS(2613),
    [anon_sym_SQUOTE] = ACTIONS(2613),
    [anon_sym_L_DQUOTE] = ACTIONS(2615),
    [anon_sym_u_DQUOTE] = ACTIONS(2615),
    [anon_sym_U_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8_DQUOTE] = ACTIONS(2615),
    [anon_sym_DQUOTE] = ACTIONS(2615),
    [sym_true] = ACTIONS(2617),
    [sym_false] = ACTIONS(2617),
    [anon_sym_NULL] = ACTIONS(2619),
    [anon_sym_nullptr] = ACTIONS(2619),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2629),
    [anon_sym_R_DQUOTE] = ACTIONS(2631),
    [anon_sym_LR_DQUOTE] = ACTIONS(2631),
    [anon_sym_uR_DQUOTE] = ACTIONS(2631),
    [anon_sym_UR_DQUOTE] = ACTIONS(2631),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2631),
    [anon_sym_co_await] = ACTIONS(2633),
    [anon_sym_new] = ACTIONS(2635),
    [anon_sym_requires] = ACTIONS(2637),
    [sym_this] = ACTIONS(2617),
  },
  [1414] = {
    [sym_primitive_type] = STATE(6669),
    [sym__expression] = STATE(4354),
    [sym__expression_not_binary] = STATE(4648),
    [sym__string] = STATE(4648),
    [sym_conditional_expression] = STATE(4648),
    [sym_assignment_expression] = STATE(4648),
    [sym_pointer_expression] = STATE(3663),
    [sym_unary_expression] = STATE(4648),
    [sym_binary_expression] = STATE(4648),
    [sym_update_expression] = STATE(4648),
    [sym_cast_expression] = STATE(4648),
    [sym_sizeof_expression] = STATE(4648),
    [sym_alignof_expression] = STATE(4648),
    [sym_offsetof_expression] = STATE(4648),
    [sym_generic_expression] = STATE(4648),
    [sym_subscript_expression] = STATE(3663),
    [sym_call_expression] = STATE(3663),
    [sym_gnu_asm_expression] = STATE(4648),
    [sym_field_expression] = STATE(3663),
    [sym_compound_literal_expression] = STATE(4648),
    [sym_parenthesized_expression] = STATE(3663),
    [sym_number_literal] = STATE(4573),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4565),
    [sym_string_literal] = STATE(3707),
    [sym_null] = STATE(4648),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7442),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(4648),
    [sym_raw_string_literal] = STATE(3709),
    [sym_co_await_expression] = STATE(4648),
    [sym_new_expression] = STATE(4648),
    [sym_delete_expression] = STATE(4648),
    [sym_requires_clause] = STATE(4648),
    [sym_requires_expression] = STATE(4648),
    [sym_lambda_expression] = STATE(4648),
    [sym_lambda_capture_specifier] = STATE(5768),
    [sym_fold_expression] = STATE(4648),
    [sym_parameter_pack_expansion] = STATE(4648),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5512),
    [sym_qualified_identifier] = STATE(3663),
    [sym_qualified_type_identifier] = STATE(7442),
    [sym_user_defined_literal] = STATE(3663),
    [sym_identifier] = ACTIONS(3458),
    [anon_sym_LPAREN2] = ACTIONS(2575),
    [anon_sym_BANG] = ACTIONS(2577),
    [anon_sym_TILDE] = ACTIONS(2577),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON_COLON] = ACTIONS(2583),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2579),
    [anon_sym_compl] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(2597),
    [anon_sym_PLUS_PLUS] = ACTIONS(2597),
    [anon_sym_sizeof] = ACTIONS(2599),
    [anon_sym___alignof__] = ACTIONS(2601),
    [anon_sym___alignof] = ACTIONS(2601),
    [anon_sym__alignof] = ACTIONS(2601),
    [anon_sym_alignof] = ACTIONS(2601),
    [anon_sym__Alignof] = ACTIONS(2601),
    [anon_sym_offsetof] = ACTIONS(2603),
    [anon_sym__Generic] = ACTIONS(2605),
    [anon_sym_asm] = ACTIONS(2607),
    [anon_sym___asm__] = ACTIONS(2607),
    [aux_sym_number_literal_token1] = ACTIONS(2609),
    [aux_sym_number_literal_token2] = ACTIONS(2611),
    [anon_sym_L_SQUOTE] = ACTIONS(2613),
    [anon_sym_u_SQUOTE] = ACTIONS(2613),
    [anon_sym_U_SQUOTE] = ACTIONS(2613),
    [anon_sym_u8_SQUOTE] = ACTIONS(2613),
    [anon_sym_SQUOTE] = ACTIONS(2613),
    [anon_sym_L_DQUOTE] = ACTIONS(2615),
    [anon_sym_u_DQUOTE] = ACTIONS(2615),
    [anon_sym_U_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8_DQUOTE] = ACTIONS(2615),
    [anon_sym_DQUOTE] = ACTIONS(2615),
    [sym_true] = ACTIONS(2617),
    [sym_false] = ACTIONS(2617),
    [anon_sym_NULL] = ACTIONS(2619),
    [anon_sym_nullptr] = ACTIONS(2619),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2629),
    [anon_sym_R_DQUOTE] = ACTIONS(2631),
    [anon_sym_LR_DQUOTE] = ACTIONS(2631),
    [anon_sym_uR_DQUOTE] = ACTIONS(2631),
    [anon_sym_UR_DQUOTE] = ACTIONS(2631),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2631),
    [anon_sym_co_await] = ACTIONS(2633),
    [anon_sym_new] = ACTIONS(2635),
    [anon_sym_requires] = ACTIONS(2637),
    [sym_this] = ACTIONS(2617),
  },
  [1415] = {
    [sym_primitive_type] = STATE(6613),
    [sym__expression] = STATE(3351),
    [sym__expression_not_binary] = STATE(3637),
    [sym__string] = STATE(3637),
    [sym_conditional_expression] = STATE(3637),
    [sym_assignment_expression] = STATE(3637),
    [sym_pointer_expression] = STATE(3637),
    [sym_unary_expression] = STATE(3637),
    [sym_binary_expression] = STATE(3637),
    [sym_update_expression] = STATE(3637),
    [sym_cast_expression] = STATE(3637),
    [sym_sizeof_expression] = STATE(3637),
    [sym_alignof_expression] = STATE(3637),
    [sym_offsetof_expression] = STATE(3637),
    [sym_generic_expression] = STATE(3637),
    [sym_subscript_expression] = STATE(3637),
    [sym_call_expression] = STATE(3637),
    [sym_gnu_asm_expression] = STATE(3637),
    [sym_field_expression] = STATE(3637),
    [sym_compound_literal_expression] = STATE(3637),
    [sym_parenthesized_expression] = STATE(3637),
    [sym_number_literal] = STATE(3416),
    [sym_char_literal] = STATE(3416),
    [sym_concatenated_string] = STATE(3415),
    [sym_string_literal] = STATE(2430),
    [sym_null] = STATE(3637),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7434),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3637),
    [sym_raw_string_literal] = STATE(2419),
    [sym_co_await_expression] = STATE(3637),
    [sym_new_expression] = STATE(3637),
    [sym_delete_expression] = STATE(3637),
    [sym_requires_clause] = STATE(3637),
    [sym_requires_expression] = STATE(3637),
    [sym_lambda_expression] = STATE(3637),
    [sym_lambda_capture_specifier] = STATE(5725),
    [sym_fold_expression] = STATE(3637),
    [sym_parameter_pack_expansion] = STATE(3637),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5512),
    [sym_qualified_identifier] = STATE(3637),
    [sym_qualified_type_identifier] = STATE(7434),
    [sym_user_defined_literal] = STATE(3637),
    [sym_identifier] = ACTIONS(2228),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_BANG] = ACTIONS(2232),
    [anon_sym_TILDE] = ACTIONS(2232),
    [anon_sym_DASH] = ACTIONS(2230),
    [anon_sym_PLUS] = ACTIONS(2230),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON_COLON] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2230),
    [anon_sym_compl] = ACTIONS(2230),
    [anon_sym_DASH_DASH] = ACTIONS(4112),
    [anon_sym_PLUS_PLUS] = ACTIONS(4112),
    [anon_sym_sizeof] = ACTIONS(2238),
    [anon_sym___alignof__] = ACTIONS(2240),
    [anon_sym___alignof] = ACTIONS(2240),
    [anon_sym__alignof] = ACTIONS(2240),
    [anon_sym_alignof] = ACTIONS(2240),
    [anon_sym__Alignof] = ACTIONS(2240),
    [anon_sym_offsetof] = ACTIONS(2242),
    [anon_sym__Generic] = ACTIONS(2244),
    [anon_sym_asm] = ACTIONS(2246),
    [anon_sym___asm__] = ACTIONS(2246),
    [aux_sym_number_literal_token1] = ACTIONS(2248),
    [aux_sym_number_literal_token2] = ACTIONS(2250),
    [anon_sym_L_SQUOTE] = ACTIONS(2252),
    [anon_sym_u_SQUOTE] = ACTIONS(2252),
    [anon_sym_U_SQUOTE] = ACTIONS(2252),
    [anon_sym_u8_SQUOTE] = ACTIONS(2252),
    [anon_sym_SQUOTE] = ACTIONS(2252),
    [anon_sym_L_DQUOTE] = ACTIONS(2254),
    [anon_sym_u_DQUOTE] = ACTIONS(2254),
    [anon_sym_U_DQUOTE] = ACTIONS(2254),
    [anon_sym_u8_DQUOTE] = ACTIONS(2254),
    [anon_sym_DQUOTE] = ACTIONS(2254),
    [sym_true] = ACTIONS(2256),
    [sym_false] = ACTIONS(2256),
    [anon_sym_NULL] = ACTIONS(2258),
    [anon_sym_nullptr] = ACTIONS(2258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2260),
    [anon_sym_R_DQUOTE] = ACTIONS(2262),
    [anon_sym_LR_DQUOTE] = ACTIONS(2262),
    [anon_sym_uR_DQUOTE] = ACTIONS(2262),
    [anon_sym_UR_DQUOTE] = ACTIONS(2262),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2262),
    [anon_sym_co_await] = ACTIONS(2264),
    [anon_sym_new] = ACTIONS(2266),
    [anon_sym_requires] = ACTIONS(2268),
    [sym_this] = ACTIONS(2256),
  },
  [1416] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(3062),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(3292),
    [sym_char_literal] = STATE(3292),
    [sym_concatenated_string] = STATE(3308),
    [sym_string_literal] = STATE(2343),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2348),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1969),
    [anon_sym_LPAREN2] = ACTIONS(4256),
    [anon_sym_BANG] = ACTIONS(1973),
    [anon_sym_TILDE] = ACTIONS(1973),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_STAR] = ACTIONS(4048),
    [anon_sym_AMP] = ACTIONS(4048),
    [anon_sym_COLON_COLON] = ACTIONS(1975),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1971),
    [anon_sym_compl] = ACTIONS(1971),
    [anon_sym_DASH_DASH] = ACTIONS(4096),
    [anon_sym_PLUS_PLUS] = ACTIONS(4096),
    [anon_sym_sizeof] = ACTIONS(1977),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1979),
    [aux_sym_number_literal_token2] = ACTIONS(1981),
    [anon_sym_L_SQUOTE] = ACTIONS(1983),
    [anon_sym_u_SQUOTE] = ACTIONS(1983),
    [anon_sym_U_SQUOTE] = ACTIONS(1983),
    [anon_sym_u8_SQUOTE] = ACTIONS(1983),
    [anon_sym_SQUOTE] = ACTIONS(1983),
    [anon_sym_L_DQUOTE] = ACTIONS(1985),
    [anon_sym_u_DQUOTE] = ACTIONS(1985),
    [anon_sym_U_DQUOTE] = ACTIONS(1985),
    [anon_sym_u8_DQUOTE] = ACTIONS(1985),
    [anon_sym_DQUOTE] = ACTIONS(1985),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1987),
    [anon_sym_R_DQUOTE] = ACTIONS(1989),
    [anon_sym_LR_DQUOTE] = ACTIONS(1989),
    [anon_sym_uR_DQUOTE] = ACTIONS(1989),
    [anon_sym_UR_DQUOTE] = ACTIONS(1989),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1989),
    [anon_sym_co_await] = ACTIONS(1991),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1417] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4106),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(2961),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(2961),
    [sym_call_expression] = STATE(2961),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(2961),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(2961),
    [sym_number_literal] = STATE(4149),
    [sym_char_literal] = STATE(4149),
    [sym_concatenated_string] = STATE(4150),
    [sym_string_literal] = STATE(3034),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3026),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2961),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(2961),
    [sym_identifier] = ACTIONS(4082),
    [anon_sym_LPAREN2] = ACTIONS(4236),
    [anon_sym_BANG] = ACTIONS(3190),
    [anon_sym_TILDE] = ACTIONS(3190),
    [anon_sym_DASH] = ACTIONS(3188),
    [anon_sym_PLUS] = ACTIONS(3188),
    [anon_sym_STAR] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(4238),
    [anon_sym_COLON_COLON] = ACTIONS(3192),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3188),
    [anon_sym_compl] = ACTIONS(3188),
    [anon_sym_DASH_DASH] = ACTIONS(4088),
    [anon_sym_PLUS_PLUS] = ACTIONS(4088),
    [anon_sym_sizeof] = ACTIONS(3196),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3198),
    [aux_sym_number_literal_token2] = ACTIONS(3200),
    [anon_sym_L_SQUOTE] = ACTIONS(3202),
    [anon_sym_u_SQUOTE] = ACTIONS(3202),
    [anon_sym_U_SQUOTE] = ACTIONS(3202),
    [anon_sym_u8_SQUOTE] = ACTIONS(3202),
    [anon_sym_SQUOTE] = ACTIONS(3202),
    [anon_sym_L_DQUOTE] = ACTIONS(3204),
    [anon_sym_u_DQUOTE] = ACTIONS(3204),
    [anon_sym_U_DQUOTE] = ACTIONS(3204),
    [anon_sym_u8_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3204),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3206),
    [anon_sym_R_DQUOTE] = ACTIONS(3208),
    [anon_sym_LR_DQUOTE] = ACTIONS(3208),
    [anon_sym_uR_DQUOTE] = ACTIONS(3208),
    [anon_sym_UR_DQUOTE] = ACTIONS(3208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3208),
    [anon_sym_co_await] = ACTIONS(3210),
    [anon_sym_new] = ACTIONS(3212),
    [anon_sym_requires] = ACTIONS(3214),
    [sym_this] = ACTIONS(219),
  },
  [1418] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4625),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1419] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(3885),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(2961),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(2961),
    [sym_call_expression] = STATE(2961),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(2961),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(2961),
    [sym_number_literal] = STATE(4149),
    [sym_char_literal] = STATE(4149),
    [sym_concatenated_string] = STATE(4150),
    [sym_string_literal] = STATE(3034),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3026),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2961),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(2961),
    [sym_identifier] = ACTIONS(4082),
    [anon_sym_LPAREN2] = ACTIONS(4236),
    [anon_sym_BANG] = ACTIONS(3190),
    [anon_sym_TILDE] = ACTIONS(3190),
    [anon_sym_DASH] = ACTIONS(3188),
    [anon_sym_PLUS] = ACTIONS(3188),
    [anon_sym_STAR] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(4238),
    [anon_sym_COLON_COLON] = ACTIONS(3192),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3188),
    [anon_sym_compl] = ACTIONS(3188),
    [anon_sym_DASH_DASH] = ACTIONS(4088),
    [anon_sym_PLUS_PLUS] = ACTIONS(4088),
    [anon_sym_sizeof] = ACTIONS(3196),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3198),
    [aux_sym_number_literal_token2] = ACTIONS(3200),
    [anon_sym_L_SQUOTE] = ACTIONS(3202),
    [anon_sym_u_SQUOTE] = ACTIONS(3202),
    [anon_sym_U_SQUOTE] = ACTIONS(3202),
    [anon_sym_u8_SQUOTE] = ACTIONS(3202),
    [anon_sym_SQUOTE] = ACTIONS(3202),
    [anon_sym_L_DQUOTE] = ACTIONS(3204),
    [anon_sym_u_DQUOTE] = ACTIONS(3204),
    [anon_sym_U_DQUOTE] = ACTIONS(3204),
    [anon_sym_u8_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3204),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3206),
    [anon_sym_R_DQUOTE] = ACTIONS(3208),
    [anon_sym_LR_DQUOTE] = ACTIONS(3208),
    [anon_sym_uR_DQUOTE] = ACTIONS(3208),
    [anon_sym_UR_DQUOTE] = ACTIONS(3208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3208),
    [anon_sym_co_await] = ACTIONS(3210),
    [anon_sym_new] = ACTIONS(3212),
    [anon_sym_requires] = ACTIONS(3214),
    [sym_this] = ACTIONS(219),
  },
  [1420] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2440),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2832),
    [sym_char_literal] = STATE(2832),
    [sym_concatenated_string] = STATE(2831),
    [sym_string_literal] = STATE(1997),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(1998),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4244),
    [anon_sym_BANG] = ACTIONS(1889),
    [anon_sym_TILDE] = ACTIONS(1889),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_STAR] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(4238),
    [anon_sym_COLON_COLON] = ACTIONS(1891),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1887),
    [anon_sym_compl] = ACTIONS(1887),
    [anon_sym_DASH_DASH] = ACTIONS(4102),
    [anon_sym_PLUS_PLUS] = ACTIONS(4102),
    [anon_sym_sizeof] = ACTIONS(1895),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1905),
    [aux_sym_number_literal_token2] = ACTIONS(1907),
    [anon_sym_L_SQUOTE] = ACTIONS(1909),
    [anon_sym_u_SQUOTE] = ACTIONS(1909),
    [anon_sym_U_SQUOTE] = ACTIONS(1909),
    [anon_sym_u8_SQUOTE] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(1909),
    [anon_sym_L_DQUOTE] = ACTIONS(1911),
    [anon_sym_u_DQUOTE] = ACTIONS(1911),
    [anon_sym_U_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8_DQUOTE] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(1911),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1919),
    [anon_sym_R_DQUOTE] = ACTIONS(1921),
    [anon_sym_LR_DQUOTE] = ACTIONS(1921),
    [anon_sym_uR_DQUOTE] = ACTIONS(1921),
    [anon_sym_UR_DQUOTE] = ACTIONS(1921),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1921),
    [anon_sym_co_await] = ACTIONS(1923),
    [anon_sym_new] = ACTIONS(1925),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1421] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4121),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(2961),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(2961),
    [sym_call_expression] = STATE(2961),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(2961),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(2961),
    [sym_number_literal] = STATE(4149),
    [sym_char_literal] = STATE(4149),
    [sym_concatenated_string] = STATE(4150),
    [sym_string_literal] = STATE(3034),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3026),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2961),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(2961),
    [sym_identifier] = ACTIONS(4082),
    [anon_sym_LPAREN2] = ACTIONS(4236),
    [anon_sym_BANG] = ACTIONS(3190),
    [anon_sym_TILDE] = ACTIONS(3190),
    [anon_sym_DASH] = ACTIONS(3188),
    [anon_sym_PLUS] = ACTIONS(3188),
    [anon_sym_STAR] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(4238),
    [anon_sym_COLON_COLON] = ACTIONS(3192),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3188),
    [anon_sym_compl] = ACTIONS(3188),
    [anon_sym_DASH_DASH] = ACTIONS(4088),
    [anon_sym_PLUS_PLUS] = ACTIONS(4088),
    [anon_sym_sizeof] = ACTIONS(3196),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3198),
    [aux_sym_number_literal_token2] = ACTIONS(3200),
    [anon_sym_L_SQUOTE] = ACTIONS(3202),
    [anon_sym_u_SQUOTE] = ACTIONS(3202),
    [anon_sym_U_SQUOTE] = ACTIONS(3202),
    [anon_sym_u8_SQUOTE] = ACTIONS(3202),
    [anon_sym_SQUOTE] = ACTIONS(3202),
    [anon_sym_L_DQUOTE] = ACTIONS(3204),
    [anon_sym_u_DQUOTE] = ACTIONS(3204),
    [anon_sym_U_DQUOTE] = ACTIONS(3204),
    [anon_sym_u8_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3204),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3206),
    [anon_sym_R_DQUOTE] = ACTIONS(3208),
    [anon_sym_LR_DQUOTE] = ACTIONS(3208),
    [anon_sym_uR_DQUOTE] = ACTIONS(3208),
    [anon_sym_UR_DQUOTE] = ACTIONS(3208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3208),
    [anon_sym_co_await] = ACTIONS(3210),
    [anon_sym_new] = ACTIONS(3212),
    [anon_sym_requires] = ACTIONS(3214),
    [sym_this] = ACTIONS(219),
  },
  [1422] = {
    [sym_primitive_type] = STATE(6669),
    [sym__expression] = STATE(4349),
    [sym__expression_not_binary] = STATE(4648),
    [sym__string] = STATE(4648),
    [sym_conditional_expression] = STATE(4648),
    [sym_assignment_expression] = STATE(4648),
    [sym_pointer_expression] = STATE(3663),
    [sym_unary_expression] = STATE(4648),
    [sym_binary_expression] = STATE(4648),
    [sym_update_expression] = STATE(4648),
    [sym_cast_expression] = STATE(4648),
    [sym_sizeof_expression] = STATE(4648),
    [sym_alignof_expression] = STATE(4648),
    [sym_offsetof_expression] = STATE(4648),
    [sym_generic_expression] = STATE(4648),
    [sym_subscript_expression] = STATE(3663),
    [sym_call_expression] = STATE(3663),
    [sym_gnu_asm_expression] = STATE(4648),
    [sym_field_expression] = STATE(3663),
    [sym_compound_literal_expression] = STATE(4648),
    [sym_parenthesized_expression] = STATE(3663),
    [sym_number_literal] = STATE(4573),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4565),
    [sym_string_literal] = STATE(3707),
    [sym_null] = STATE(4648),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7442),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(4648),
    [sym_raw_string_literal] = STATE(3709),
    [sym_co_await_expression] = STATE(4648),
    [sym_new_expression] = STATE(4648),
    [sym_delete_expression] = STATE(4648),
    [sym_requires_clause] = STATE(4648),
    [sym_requires_expression] = STATE(4648),
    [sym_lambda_expression] = STATE(4648),
    [sym_lambda_capture_specifier] = STATE(5768),
    [sym_fold_expression] = STATE(4648),
    [sym_parameter_pack_expansion] = STATE(4648),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5512),
    [sym_qualified_identifier] = STATE(3663),
    [sym_qualified_type_identifier] = STATE(7442),
    [sym_user_defined_literal] = STATE(3663),
    [sym_identifier] = ACTIONS(3458),
    [anon_sym_LPAREN2] = ACTIONS(2575),
    [anon_sym_BANG] = ACTIONS(2577),
    [anon_sym_TILDE] = ACTIONS(2577),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON_COLON] = ACTIONS(2583),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2579),
    [anon_sym_compl] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(2597),
    [anon_sym_PLUS_PLUS] = ACTIONS(2597),
    [anon_sym_sizeof] = ACTIONS(2599),
    [anon_sym___alignof__] = ACTIONS(2601),
    [anon_sym___alignof] = ACTIONS(2601),
    [anon_sym__alignof] = ACTIONS(2601),
    [anon_sym_alignof] = ACTIONS(2601),
    [anon_sym__Alignof] = ACTIONS(2601),
    [anon_sym_offsetof] = ACTIONS(2603),
    [anon_sym__Generic] = ACTIONS(2605),
    [anon_sym_asm] = ACTIONS(2607),
    [anon_sym___asm__] = ACTIONS(2607),
    [aux_sym_number_literal_token1] = ACTIONS(2609),
    [aux_sym_number_literal_token2] = ACTIONS(2611),
    [anon_sym_L_SQUOTE] = ACTIONS(2613),
    [anon_sym_u_SQUOTE] = ACTIONS(2613),
    [anon_sym_U_SQUOTE] = ACTIONS(2613),
    [anon_sym_u8_SQUOTE] = ACTIONS(2613),
    [anon_sym_SQUOTE] = ACTIONS(2613),
    [anon_sym_L_DQUOTE] = ACTIONS(2615),
    [anon_sym_u_DQUOTE] = ACTIONS(2615),
    [anon_sym_U_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8_DQUOTE] = ACTIONS(2615),
    [anon_sym_DQUOTE] = ACTIONS(2615),
    [sym_true] = ACTIONS(2617),
    [sym_false] = ACTIONS(2617),
    [anon_sym_NULL] = ACTIONS(2619),
    [anon_sym_nullptr] = ACTIONS(2619),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2629),
    [anon_sym_R_DQUOTE] = ACTIONS(2631),
    [anon_sym_LR_DQUOTE] = ACTIONS(2631),
    [anon_sym_uR_DQUOTE] = ACTIONS(2631),
    [anon_sym_UR_DQUOTE] = ACTIONS(2631),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2631),
    [anon_sym_co_await] = ACTIONS(2633),
    [anon_sym_new] = ACTIONS(2635),
    [anon_sym_requires] = ACTIONS(2637),
    [sym_this] = ACTIONS(2617),
  },
  [1423] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4363),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1424] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4112),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(2961),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(2961),
    [sym_call_expression] = STATE(2961),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(2961),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(2961),
    [sym_number_literal] = STATE(4149),
    [sym_char_literal] = STATE(4149),
    [sym_concatenated_string] = STATE(4150),
    [sym_string_literal] = STATE(3034),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3026),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2961),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(2961),
    [sym_identifier] = ACTIONS(4082),
    [anon_sym_LPAREN2] = ACTIONS(4236),
    [anon_sym_BANG] = ACTIONS(3190),
    [anon_sym_TILDE] = ACTIONS(3190),
    [anon_sym_DASH] = ACTIONS(3188),
    [anon_sym_PLUS] = ACTIONS(3188),
    [anon_sym_STAR] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(4238),
    [anon_sym_COLON_COLON] = ACTIONS(3192),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3188),
    [anon_sym_compl] = ACTIONS(3188),
    [anon_sym_DASH_DASH] = ACTIONS(4088),
    [anon_sym_PLUS_PLUS] = ACTIONS(4088),
    [anon_sym_sizeof] = ACTIONS(3196),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3198),
    [aux_sym_number_literal_token2] = ACTIONS(3200),
    [anon_sym_L_SQUOTE] = ACTIONS(3202),
    [anon_sym_u_SQUOTE] = ACTIONS(3202),
    [anon_sym_U_SQUOTE] = ACTIONS(3202),
    [anon_sym_u8_SQUOTE] = ACTIONS(3202),
    [anon_sym_SQUOTE] = ACTIONS(3202),
    [anon_sym_L_DQUOTE] = ACTIONS(3204),
    [anon_sym_u_DQUOTE] = ACTIONS(3204),
    [anon_sym_U_DQUOTE] = ACTIONS(3204),
    [anon_sym_u8_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3204),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3206),
    [anon_sym_R_DQUOTE] = ACTIONS(3208),
    [anon_sym_LR_DQUOTE] = ACTIONS(3208),
    [anon_sym_uR_DQUOTE] = ACTIONS(3208),
    [anon_sym_UR_DQUOTE] = ACTIONS(3208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3208),
    [anon_sym_co_await] = ACTIONS(3210),
    [anon_sym_new] = ACTIONS(3212),
    [anon_sym_requires] = ACTIONS(3214),
    [sym_this] = ACTIONS(219),
  },
  [1425] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4644),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3679),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3679),
    [sym_call_expression] = STATE(3679),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3679),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3679),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3679),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3679),
    [sym_identifier] = ACTIONS(3538),
    [anon_sym_LPAREN2] = ACTIONS(4199),
    [anon_sym_BANG] = ACTIONS(3542),
    [anon_sym_TILDE] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3540),
    [anon_sym_PLUS] = ACTIONS(3540),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(3544),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3540),
    [anon_sym_compl] = ACTIONS(3540),
    [anon_sym_DASH_DASH] = ACTIONS(4122),
    [anon_sym_PLUS_PLUS] = ACTIONS(4122),
    [anon_sym_sizeof] = ACTIONS(3546),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3548),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3550),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1426] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(3795),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1427] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2916),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4218),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_TILDE] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1931),
    [anon_sym_PLUS] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(1935),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1931),
    [anon_sym_compl] = ACTIONS(1931),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_sizeof] = ACTIONS(1937),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1428] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(3176),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(3292),
    [sym_char_literal] = STATE(3292),
    [sym_concatenated_string] = STATE(3308),
    [sym_string_literal] = STATE(2343),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2348),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1969),
    [anon_sym_LPAREN2] = ACTIONS(4256),
    [anon_sym_BANG] = ACTIONS(1973),
    [anon_sym_TILDE] = ACTIONS(1973),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_STAR] = ACTIONS(4048),
    [anon_sym_AMP] = ACTIONS(4048),
    [anon_sym_COLON_COLON] = ACTIONS(1975),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1971),
    [anon_sym_compl] = ACTIONS(1971),
    [anon_sym_DASH_DASH] = ACTIONS(4096),
    [anon_sym_PLUS_PLUS] = ACTIONS(4096),
    [anon_sym_sizeof] = ACTIONS(1977),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1979),
    [aux_sym_number_literal_token2] = ACTIONS(1981),
    [anon_sym_L_SQUOTE] = ACTIONS(1983),
    [anon_sym_u_SQUOTE] = ACTIONS(1983),
    [anon_sym_U_SQUOTE] = ACTIONS(1983),
    [anon_sym_u8_SQUOTE] = ACTIONS(1983),
    [anon_sym_SQUOTE] = ACTIONS(1983),
    [anon_sym_L_DQUOTE] = ACTIONS(1985),
    [anon_sym_u_DQUOTE] = ACTIONS(1985),
    [anon_sym_U_DQUOTE] = ACTIONS(1985),
    [anon_sym_u8_DQUOTE] = ACTIONS(1985),
    [anon_sym_DQUOTE] = ACTIONS(1985),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1987),
    [anon_sym_R_DQUOTE] = ACTIONS(1989),
    [anon_sym_LR_DQUOTE] = ACTIONS(1989),
    [anon_sym_uR_DQUOTE] = ACTIONS(1989),
    [anon_sym_UR_DQUOTE] = ACTIONS(1989),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1989),
    [anon_sym_co_await] = ACTIONS(1991),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1429] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4365),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1430] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2440),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(3292),
    [sym_char_literal] = STATE(3292),
    [sym_concatenated_string] = STATE(3308),
    [sym_string_literal] = STATE(2343),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2348),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1969),
    [anon_sym_LPAREN2] = ACTIONS(4256),
    [anon_sym_BANG] = ACTIONS(1973),
    [anon_sym_TILDE] = ACTIONS(1973),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_STAR] = ACTIONS(4048),
    [anon_sym_AMP] = ACTIONS(4048),
    [anon_sym_COLON_COLON] = ACTIONS(1975),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1971),
    [anon_sym_compl] = ACTIONS(1971),
    [anon_sym_DASH_DASH] = ACTIONS(4096),
    [anon_sym_PLUS_PLUS] = ACTIONS(4096),
    [anon_sym_sizeof] = ACTIONS(1977),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1979),
    [aux_sym_number_literal_token2] = ACTIONS(1981),
    [anon_sym_L_SQUOTE] = ACTIONS(1983),
    [anon_sym_u_SQUOTE] = ACTIONS(1983),
    [anon_sym_U_SQUOTE] = ACTIONS(1983),
    [anon_sym_u8_SQUOTE] = ACTIONS(1983),
    [anon_sym_SQUOTE] = ACTIONS(1983),
    [anon_sym_L_DQUOTE] = ACTIONS(1985),
    [anon_sym_u_DQUOTE] = ACTIONS(1985),
    [anon_sym_U_DQUOTE] = ACTIONS(1985),
    [anon_sym_u8_DQUOTE] = ACTIONS(1985),
    [anon_sym_DQUOTE] = ACTIONS(1985),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1987),
    [anon_sym_R_DQUOTE] = ACTIONS(1989),
    [anon_sym_LR_DQUOTE] = ACTIONS(1989),
    [anon_sym_uR_DQUOTE] = ACTIONS(1989),
    [anon_sym_UR_DQUOTE] = ACTIONS(1989),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1989),
    [anon_sym_co_await] = ACTIONS(1991),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1431] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4606),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1432] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4486),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1433] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4645),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1434] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4113),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(2961),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(2961),
    [sym_call_expression] = STATE(2961),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(2961),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(2961),
    [sym_number_literal] = STATE(4149),
    [sym_char_literal] = STATE(4149),
    [sym_concatenated_string] = STATE(4150),
    [sym_string_literal] = STATE(3034),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3026),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2961),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(2961),
    [sym_identifier] = ACTIONS(4082),
    [anon_sym_LPAREN2] = ACTIONS(4236),
    [anon_sym_BANG] = ACTIONS(3190),
    [anon_sym_TILDE] = ACTIONS(3190),
    [anon_sym_DASH] = ACTIONS(3188),
    [anon_sym_PLUS] = ACTIONS(3188),
    [anon_sym_STAR] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(4238),
    [anon_sym_COLON_COLON] = ACTIONS(3192),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3188),
    [anon_sym_compl] = ACTIONS(3188),
    [anon_sym_DASH_DASH] = ACTIONS(4088),
    [anon_sym_PLUS_PLUS] = ACTIONS(4088),
    [anon_sym_sizeof] = ACTIONS(3196),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3198),
    [aux_sym_number_literal_token2] = ACTIONS(3200),
    [anon_sym_L_SQUOTE] = ACTIONS(3202),
    [anon_sym_u_SQUOTE] = ACTIONS(3202),
    [anon_sym_U_SQUOTE] = ACTIONS(3202),
    [anon_sym_u8_SQUOTE] = ACTIONS(3202),
    [anon_sym_SQUOTE] = ACTIONS(3202),
    [anon_sym_L_DQUOTE] = ACTIONS(3204),
    [anon_sym_u_DQUOTE] = ACTIONS(3204),
    [anon_sym_U_DQUOTE] = ACTIONS(3204),
    [anon_sym_u8_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3204),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3206),
    [anon_sym_R_DQUOTE] = ACTIONS(3208),
    [anon_sym_LR_DQUOTE] = ACTIONS(3208),
    [anon_sym_uR_DQUOTE] = ACTIONS(3208),
    [anon_sym_UR_DQUOTE] = ACTIONS(3208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3208),
    [anon_sym_co_await] = ACTIONS(3210),
    [anon_sym_new] = ACTIONS(3212),
    [anon_sym_requires] = ACTIONS(3214),
    [sym_this] = ACTIONS(219),
  },
  [1435] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4583),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1436] = {
    [sym_primitive_type] = STATE(6613),
    [sym__expression] = STATE(3227),
    [sym__expression_not_binary] = STATE(3637),
    [sym__string] = STATE(3637),
    [sym_conditional_expression] = STATE(3637),
    [sym_assignment_expression] = STATE(3637),
    [sym_pointer_expression] = STATE(3637),
    [sym_unary_expression] = STATE(3637),
    [sym_binary_expression] = STATE(3637),
    [sym_update_expression] = STATE(3637),
    [sym_cast_expression] = STATE(3637),
    [sym_sizeof_expression] = STATE(3637),
    [sym_alignof_expression] = STATE(3637),
    [sym_offsetof_expression] = STATE(3637),
    [sym_generic_expression] = STATE(3637),
    [sym_subscript_expression] = STATE(3637),
    [sym_call_expression] = STATE(3637),
    [sym_gnu_asm_expression] = STATE(3637),
    [sym_field_expression] = STATE(3637),
    [sym_compound_literal_expression] = STATE(3637),
    [sym_parenthesized_expression] = STATE(3637),
    [sym_number_literal] = STATE(3416),
    [sym_char_literal] = STATE(3416),
    [sym_concatenated_string] = STATE(3415),
    [sym_string_literal] = STATE(2430),
    [sym_null] = STATE(3637),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7434),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3637),
    [sym_raw_string_literal] = STATE(2419),
    [sym_co_await_expression] = STATE(3637),
    [sym_new_expression] = STATE(3637),
    [sym_delete_expression] = STATE(3637),
    [sym_requires_clause] = STATE(3637),
    [sym_requires_expression] = STATE(3637),
    [sym_lambda_expression] = STATE(3637),
    [sym_lambda_capture_specifier] = STATE(5725),
    [sym_fold_expression] = STATE(3637),
    [sym_parameter_pack_expansion] = STATE(3637),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5512),
    [sym_qualified_identifier] = STATE(3637),
    [sym_qualified_type_identifier] = STATE(7434),
    [sym_user_defined_literal] = STATE(3637),
    [sym_identifier] = ACTIONS(2228),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_BANG] = ACTIONS(2232),
    [anon_sym_TILDE] = ACTIONS(2232),
    [anon_sym_DASH] = ACTIONS(2230),
    [anon_sym_PLUS] = ACTIONS(2230),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON_COLON] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2230),
    [anon_sym_compl] = ACTIONS(2230),
    [anon_sym_DASH_DASH] = ACTIONS(4112),
    [anon_sym_PLUS_PLUS] = ACTIONS(4112),
    [anon_sym_sizeof] = ACTIONS(2238),
    [anon_sym___alignof__] = ACTIONS(2240),
    [anon_sym___alignof] = ACTIONS(2240),
    [anon_sym__alignof] = ACTIONS(2240),
    [anon_sym_alignof] = ACTIONS(2240),
    [anon_sym__Alignof] = ACTIONS(2240),
    [anon_sym_offsetof] = ACTIONS(2242),
    [anon_sym__Generic] = ACTIONS(2244),
    [anon_sym_asm] = ACTIONS(2246),
    [anon_sym___asm__] = ACTIONS(2246),
    [aux_sym_number_literal_token1] = ACTIONS(2248),
    [aux_sym_number_literal_token2] = ACTIONS(2250),
    [anon_sym_L_SQUOTE] = ACTIONS(2252),
    [anon_sym_u_SQUOTE] = ACTIONS(2252),
    [anon_sym_U_SQUOTE] = ACTIONS(2252),
    [anon_sym_u8_SQUOTE] = ACTIONS(2252),
    [anon_sym_SQUOTE] = ACTIONS(2252),
    [anon_sym_L_DQUOTE] = ACTIONS(2254),
    [anon_sym_u_DQUOTE] = ACTIONS(2254),
    [anon_sym_U_DQUOTE] = ACTIONS(2254),
    [anon_sym_u8_DQUOTE] = ACTIONS(2254),
    [anon_sym_DQUOTE] = ACTIONS(2254),
    [sym_true] = ACTIONS(2256),
    [sym_false] = ACTIONS(2256),
    [anon_sym_NULL] = ACTIONS(2258),
    [anon_sym_nullptr] = ACTIONS(2258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2260),
    [anon_sym_R_DQUOTE] = ACTIONS(2262),
    [anon_sym_LR_DQUOTE] = ACTIONS(2262),
    [anon_sym_uR_DQUOTE] = ACTIONS(2262),
    [anon_sym_UR_DQUOTE] = ACTIONS(2262),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2262),
    [anon_sym_co_await] = ACTIONS(2264),
    [anon_sym_new] = ACTIONS(2266),
    [anon_sym_requires] = ACTIONS(2268),
    [sym_this] = ACTIONS(2256),
  },
  [1437] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4543),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1438] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4266),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1439] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4260),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1440] = {
    [sym_primitive_type] = STATE(6613),
    [sym__expression] = STATE(3295),
    [sym__expression_not_binary] = STATE(3637),
    [sym__string] = STATE(3637),
    [sym_conditional_expression] = STATE(3637),
    [sym_assignment_expression] = STATE(3637),
    [sym_pointer_expression] = STATE(3637),
    [sym_unary_expression] = STATE(3637),
    [sym_binary_expression] = STATE(3637),
    [sym_update_expression] = STATE(3637),
    [sym_cast_expression] = STATE(3637),
    [sym_sizeof_expression] = STATE(3637),
    [sym_alignof_expression] = STATE(3637),
    [sym_offsetof_expression] = STATE(3637),
    [sym_generic_expression] = STATE(3637),
    [sym_subscript_expression] = STATE(3637),
    [sym_call_expression] = STATE(3637),
    [sym_gnu_asm_expression] = STATE(3637),
    [sym_field_expression] = STATE(3637),
    [sym_compound_literal_expression] = STATE(3637),
    [sym_parenthesized_expression] = STATE(3637),
    [sym_number_literal] = STATE(3416),
    [sym_char_literal] = STATE(3416),
    [sym_concatenated_string] = STATE(3415),
    [sym_string_literal] = STATE(2430),
    [sym_null] = STATE(3637),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7434),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3637),
    [sym_raw_string_literal] = STATE(2419),
    [sym_co_await_expression] = STATE(3637),
    [sym_new_expression] = STATE(3637),
    [sym_delete_expression] = STATE(3637),
    [sym_requires_clause] = STATE(3637),
    [sym_requires_expression] = STATE(3637),
    [sym_lambda_expression] = STATE(3637),
    [sym_lambda_capture_specifier] = STATE(5725),
    [sym_fold_expression] = STATE(3637),
    [sym_parameter_pack_expansion] = STATE(3637),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5512),
    [sym_qualified_identifier] = STATE(3637),
    [sym_qualified_type_identifier] = STATE(7434),
    [sym_user_defined_literal] = STATE(3637),
    [sym_identifier] = ACTIONS(2228),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_BANG] = ACTIONS(2232),
    [anon_sym_TILDE] = ACTIONS(2232),
    [anon_sym_DASH] = ACTIONS(2230),
    [anon_sym_PLUS] = ACTIONS(2230),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON_COLON] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(4466),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2230),
    [anon_sym_compl] = ACTIONS(2230),
    [anon_sym_DASH_DASH] = ACTIONS(4112),
    [anon_sym_PLUS_PLUS] = ACTIONS(4112),
    [anon_sym_sizeof] = ACTIONS(2238),
    [anon_sym___alignof__] = ACTIONS(2240),
    [anon_sym___alignof] = ACTIONS(2240),
    [anon_sym__alignof] = ACTIONS(2240),
    [anon_sym_alignof] = ACTIONS(2240),
    [anon_sym__Alignof] = ACTIONS(2240),
    [anon_sym_offsetof] = ACTIONS(2242),
    [anon_sym__Generic] = ACTIONS(2244),
    [anon_sym_asm] = ACTIONS(2246),
    [anon_sym___asm__] = ACTIONS(2246),
    [aux_sym_number_literal_token1] = ACTIONS(2248),
    [aux_sym_number_literal_token2] = ACTIONS(2250),
    [anon_sym_L_SQUOTE] = ACTIONS(2252),
    [anon_sym_u_SQUOTE] = ACTIONS(2252),
    [anon_sym_U_SQUOTE] = ACTIONS(2252),
    [anon_sym_u8_SQUOTE] = ACTIONS(2252),
    [anon_sym_SQUOTE] = ACTIONS(2252),
    [anon_sym_L_DQUOTE] = ACTIONS(2254),
    [anon_sym_u_DQUOTE] = ACTIONS(2254),
    [anon_sym_U_DQUOTE] = ACTIONS(2254),
    [anon_sym_u8_DQUOTE] = ACTIONS(2254),
    [anon_sym_DQUOTE] = ACTIONS(2254),
    [sym_true] = ACTIONS(2256),
    [sym_false] = ACTIONS(2256),
    [anon_sym_NULL] = ACTIONS(2258),
    [anon_sym_nullptr] = ACTIONS(2258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2260),
    [anon_sym_R_DQUOTE] = ACTIONS(2262),
    [anon_sym_LR_DQUOTE] = ACTIONS(2262),
    [anon_sym_uR_DQUOTE] = ACTIONS(2262),
    [anon_sym_UR_DQUOTE] = ACTIONS(2262),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2262),
    [anon_sym_co_await] = ACTIONS(2264),
    [anon_sym_new] = ACTIONS(2266),
    [anon_sym_requires] = ACTIONS(2268),
    [sym_this] = ACTIONS(2256),
  },
  [1441] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4509),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1442] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(3155),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(3292),
    [sym_char_literal] = STATE(3292),
    [sym_concatenated_string] = STATE(3308),
    [sym_string_literal] = STATE(2343),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2348),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1969),
    [anon_sym_LPAREN2] = ACTIONS(4256),
    [anon_sym_BANG] = ACTIONS(1973),
    [anon_sym_TILDE] = ACTIONS(1973),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_STAR] = ACTIONS(4048),
    [anon_sym_AMP] = ACTIONS(4048),
    [anon_sym_COLON_COLON] = ACTIONS(1975),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1971),
    [anon_sym_compl] = ACTIONS(1971),
    [anon_sym_DASH_DASH] = ACTIONS(4096),
    [anon_sym_PLUS_PLUS] = ACTIONS(4096),
    [anon_sym_sizeof] = ACTIONS(1977),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1979),
    [aux_sym_number_literal_token2] = ACTIONS(1981),
    [anon_sym_L_SQUOTE] = ACTIONS(1983),
    [anon_sym_u_SQUOTE] = ACTIONS(1983),
    [anon_sym_U_SQUOTE] = ACTIONS(1983),
    [anon_sym_u8_SQUOTE] = ACTIONS(1983),
    [anon_sym_SQUOTE] = ACTIONS(1983),
    [anon_sym_L_DQUOTE] = ACTIONS(1985),
    [anon_sym_u_DQUOTE] = ACTIONS(1985),
    [anon_sym_U_DQUOTE] = ACTIONS(1985),
    [anon_sym_u8_DQUOTE] = ACTIONS(1985),
    [anon_sym_DQUOTE] = ACTIONS(1985),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1987),
    [anon_sym_R_DQUOTE] = ACTIONS(1989),
    [anon_sym_LR_DQUOTE] = ACTIONS(1989),
    [anon_sym_uR_DQUOTE] = ACTIONS(1989),
    [anon_sym_UR_DQUOTE] = ACTIONS(1989),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1989),
    [anon_sym_co_await] = ACTIONS(1991),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1443] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(3161),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(3292),
    [sym_char_literal] = STATE(3292),
    [sym_concatenated_string] = STATE(3308),
    [sym_string_literal] = STATE(2343),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2348),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1969),
    [anon_sym_LPAREN2] = ACTIONS(4256),
    [anon_sym_BANG] = ACTIONS(1973),
    [anon_sym_TILDE] = ACTIONS(1973),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_STAR] = ACTIONS(4048),
    [anon_sym_AMP] = ACTIONS(4048),
    [anon_sym_COLON_COLON] = ACTIONS(1975),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1971),
    [anon_sym_compl] = ACTIONS(1971),
    [anon_sym_DASH_DASH] = ACTIONS(4096),
    [anon_sym_PLUS_PLUS] = ACTIONS(4096),
    [anon_sym_sizeof] = ACTIONS(1977),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1979),
    [aux_sym_number_literal_token2] = ACTIONS(1981),
    [anon_sym_L_SQUOTE] = ACTIONS(1983),
    [anon_sym_u_SQUOTE] = ACTIONS(1983),
    [anon_sym_U_SQUOTE] = ACTIONS(1983),
    [anon_sym_u8_SQUOTE] = ACTIONS(1983),
    [anon_sym_SQUOTE] = ACTIONS(1983),
    [anon_sym_L_DQUOTE] = ACTIONS(1985),
    [anon_sym_u_DQUOTE] = ACTIONS(1985),
    [anon_sym_U_DQUOTE] = ACTIONS(1985),
    [anon_sym_u8_DQUOTE] = ACTIONS(1985),
    [anon_sym_DQUOTE] = ACTIONS(1985),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1987),
    [anon_sym_R_DQUOTE] = ACTIONS(1989),
    [anon_sym_LR_DQUOTE] = ACTIONS(1989),
    [anon_sym_uR_DQUOTE] = ACTIONS(1989),
    [anon_sym_UR_DQUOTE] = ACTIONS(1989),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1989),
    [anon_sym_co_await] = ACTIONS(1991),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1444] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(3160),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(3292),
    [sym_char_literal] = STATE(3292),
    [sym_concatenated_string] = STATE(3308),
    [sym_string_literal] = STATE(2343),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2348),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1969),
    [anon_sym_LPAREN2] = ACTIONS(4256),
    [anon_sym_BANG] = ACTIONS(1973),
    [anon_sym_TILDE] = ACTIONS(1973),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_STAR] = ACTIONS(4048),
    [anon_sym_AMP] = ACTIONS(4048),
    [anon_sym_COLON_COLON] = ACTIONS(1975),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1971),
    [anon_sym_compl] = ACTIONS(1971),
    [anon_sym_DASH_DASH] = ACTIONS(4096),
    [anon_sym_PLUS_PLUS] = ACTIONS(4096),
    [anon_sym_sizeof] = ACTIONS(1977),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1979),
    [aux_sym_number_literal_token2] = ACTIONS(1981),
    [anon_sym_L_SQUOTE] = ACTIONS(1983),
    [anon_sym_u_SQUOTE] = ACTIONS(1983),
    [anon_sym_U_SQUOTE] = ACTIONS(1983),
    [anon_sym_u8_SQUOTE] = ACTIONS(1983),
    [anon_sym_SQUOTE] = ACTIONS(1983),
    [anon_sym_L_DQUOTE] = ACTIONS(1985),
    [anon_sym_u_DQUOTE] = ACTIONS(1985),
    [anon_sym_U_DQUOTE] = ACTIONS(1985),
    [anon_sym_u8_DQUOTE] = ACTIONS(1985),
    [anon_sym_DQUOTE] = ACTIONS(1985),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1987),
    [anon_sym_R_DQUOTE] = ACTIONS(1989),
    [anon_sym_LR_DQUOTE] = ACTIONS(1989),
    [anon_sym_uR_DQUOTE] = ACTIONS(1989),
    [anon_sym_UR_DQUOTE] = ACTIONS(1989),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1989),
    [anon_sym_co_await] = ACTIONS(1991),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1445] = {
    [sym_primitive_type] = STATE(6669),
    [sym__expression] = STATE(4429),
    [sym__expression_not_binary] = STATE(4648),
    [sym__string] = STATE(4648),
    [sym_conditional_expression] = STATE(4648),
    [sym_assignment_expression] = STATE(4648),
    [sym_pointer_expression] = STATE(3663),
    [sym_unary_expression] = STATE(4648),
    [sym_binary_expression] = STATE(4648),
    [sym_update_expression] = STATE(4648),
    [sym_cast_expression] = STATE(4648),
    [sym_sizeof_expression] = STATE(4648),
    [sym_alignof_expression] = STATE(4648),
    [sym_offsetof_expression] = STATE(4648),
    [sym_generic_expression] = STATE(4648),
    [sym_subscript_expression] = STATE(3663),
    [sym_call_expression] = STATE(3663),
    [sym_gnu_asm_expression] = STATE(4648),
    [sym_field_expression] = STATE(3663),
    [sym_compound_literal_expression] = STATE(4648),
    [sym_parenthesized_expression] = STATE(3663),
    [sym_number_literal] = STATE(4573),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4565),
    [sym_string_literal] = STATE(3707),
    [sym_null] = STATE(4648),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7442),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(4648),
    [sym_raw_string_literal] = STATE(3709),
    [sym_co_await_expression] = STATE(4648),
    [sym_new_expression] = STATE(4648),
    [sym_delete_expression] = STATE(4648),
    [sym_requires_clause] = STATE(4648),
    [sym_requires_expression] = STATE(4648),
    [sym_lambda_expression] = STATE(4648),
    [sym_lambda_capture_specifier] = STATE(5768),
    [sym_fold_expression] = STATE(4648),
    [sym_parameter_pack_expansion] = STATE(4648),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5512),
    [sym_qualified_identifier] = STATE(3663),
    [sym_qualified_type_identifier] = STATE(7442),
    [sym_user_defined_literal] = STATE(3663),
    [sym_identifier] = ACTIONS(3458),
    [anon_sym_LPAREN2] = ACTIONS(2575),
    [anon_sym_BANG] = ACTIONS(2577),
    [anon_sym_TILDE] = ACTIONS(2577),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON_COLON] = ACTIONS(2583),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2579),
    [anon_sym_compl] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(2597),
    [anon_sym_PLUS_PLUS] = ACTIONS(2597),
    [anon_sym_sizeof] = ACTIONS(2599),
    [anon_sym___alignof__] = ACTIONS(2601),
    [anon_sym___alignof] = ACTIONS(2601),
    [anon_sym__alignof] = ACTIONS(2601),
    [anon_sym_alignof] = ACTIONS(2601),
    [anon_sym__Alignof] = ACTIONS(2601),
    [anon_sym_offsetof] = ACTIONS(2603),
    [anon_sym__Generic] = ACTIONS(2605),
    [anon_sym_asm] = ACTIONS(2607),
    [anon_sym___asm__] = ACTIONS(2607),
    [aux_sym_number_literal_token1] = ACTIONS(2609),
    [aux_sym_number_literal_token2] = ACTIONS(2611),
    [anon_sym_L_SQUOTE] = ACTIONS(2613),
    [anon_sym_u_SQUOTE] = ACTIONS(2613),
    [anon_sym_U_SQUOTE] = ACTIONS(2613),
    [anon_sym_u8_SQUOTE] = ACTIONS(2613),
    [anon_sym_SQUOTE] = ACTIONS(2613),
    [anon_sym_L_DQUOTE] = ACTIONS(2615),
    [anon_sym_u_DQUOTE] = ACTIONS(2615),
    [anon_sym_U_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8_DQUOTE] = ACTIONS(2615),
    [anon_sym_DQUOTE] = ACTIONS(2615),
    [sym_true] = ACTIONS(2617),
    [sym_false] = ACTIONS(2617),
    [anon_sym_NULL] = ACTIONS(2619),
    [anon_sym_nullptr] = ACTIONS(2619),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2629),
    [anon_sym_R_DQUOTE] = ACTIONS(2631),
    [anon_sym_LR_DQUOTE] = ACTIONS(2631),
    [anon_sym_uR_DQUOTE] = ACTIONS(2631),
    [anon_sym_UR_DQUOTE] = ACTIONS(2631),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2631),
    [anon_sym_co_await] = ACTIONS(2633),
    [anon_sym_new] = ACTIONS(2635),
    [anon_sym_requires] = ACTIONS(2637),
    [sym_this] = ACTIONS(2617),
  },
  [1446] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2808),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2832),
    [sym_char_literal] = STATE(2832),
    [sym_concatenated_string] = STATE(2831),
    [sym_string_literal] = STATE(1997),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(1998),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4244),
    [anon_sym_BANG] = ACTIONS(1889),
    [anon_sym_TILDE] = ACTIONS(1889),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_STAR] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(4238),
    [anon_sym_COLON_COLON] = ACTIONS(1891),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1887),
    [anon_sym_compl] = ACTIONS(1887),
    [anon_sym_DASH_DASH] = ACTIONS(4102),
    [anon_sym_PLUS_PLUS] = ACTIONS(4102),
    [anon_sym_sizeof] = ACTIONS(1895),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1905),
    [aux_sym_number_literal_token2] = ACTIONS(1907),
    [anon_sym_L_SQUOTE] = ACTIONS(1909),
    [anon_sym_u_SQUOTE] = ACTIONS(1909),
    [anon_sym_U_SQUOTE] = ACTIONS(1909),
    [anon_sym_u8_SQUOTE] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(1909),
    [anon_sym_L_DQUOTE] = ACTIONS(1911),
    [anon_sym_u_DQUOTE] = ACTIONS(1911),
    [anon_sym_U_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8_DQUOTE] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(1911),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1919),
    [anon_sym_R_DQUOTE] = ACTIONS(1921),
    [anon_sym_LR_DQUOTE] = ACTIONS(1921),
    [anon_sym_uR_DQUOTE] = ACTIONS(1921),
    [anon_sym_UR_DQUOTE] = ACTIONS(1921),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1921),
    [anon_sym_co_await] = ACTIONS(1923),
    [anon_sym_new] = ACTIONS(1925),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1447] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4508),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1448] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2441),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2832),
    [sym_char_literal] = STATE(2832),
    [sym_concatenated_string] = STATE(2831),
    [sym_string_literal] = STATE(1997),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(1998),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4244),
    [anon_sym_BANG] = ACTIONS(1889),
    [anon_sym_TILDE] = ACTIONS(1889),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_STAR] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(4238),
    [anon_sym_COLON_COLON] = ACTIONS(1891),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1887),
    [anon_sym_compl] = ACTIONS(1887),
    [anon_sym_DASH_DASH] = ACTIONS(4102),
    [anon_sym_PLUS_PLUS] = ACTIONS(4102),
    [anon_sym_sizeof] = ACTIONS(1895),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1905),
    [aux_sym_number_literal_token2] = ACTIONS(1907),
    [anon_sym_L_SQUOTE] = ACTIONS(1909),
    [anon_sym_u_SQUOTE] = ACTIONS(1909),
    [anon_sym_U_SQUOTE] = ACTIONS(1909),
    [anon_sym_u8_SQUOTE] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(1909),
    [anon_sym_L_DQUOTE] = ACTIONS(1911),
    [anon_sym_u_DQUOTE] = ACTIONS(1911),
    [anon_sym_U_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8_DQUOTE] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(1911),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1919),
    [anon_sym_R_DQUOTE] = ACTIONS(1921),
    [anon_sym_LR_DQUOTE] = ACTIONS(1921),
    [anon_sym_uR_DQUOTE] = ACTIONS(1921),
    [anon_sym_UR_DQUOTE] = ACTIONS(1921),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1921),
    [anon_sym_co_await] = ACTIONS(1923),
    [anon_sym_new] = ACTIONS(1925),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1449] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2789),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2832),
    [sym_char_literal] = STATE(2832),
    [sym_concatenated_string] = STATE(2831),
    [sym_string_literal] = STATE(1997),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(1998),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4244),
    [anon_sym_BANG] = ACTIONS(1889),
    [anon_sym_TILDE] = ACTIONS(1889),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_STAR] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(4238),
    [anon_sym_COLON_COLON] = ACTIONS(1891),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1887),
    [anon_sym_compl] = ACTIONS(1887),
    [anon_sym_DASH_DASH] = ACTIONS(4102),
    [anon_sym_PLUS_PLUS] = ACTIONS(4102),
    [anon_sym_sizeof] = ACTIONS(1895),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1905),
    [aux_sym_number_literal_token2] = ACTIONS(1907),
    [anon_sym_L_SQUOTE] = ACTIONS(1909),
    [anon_sym_u_SQUOTE] = ACTIONS(1909),
    [anon_sym_U_SQUOTE] = ACTIONS(1909),
    [anon_sym_u8_SQUOTE] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(1909),
    [anon_sym_L_DQUOTE] = ACTIONS(1911),
    [anon_sym_u_DQUOTE] = ACTIONS(1911),
    [anon_sym_U_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8_DQUOTE] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(1911),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1919),
    [anon_sym_R_DQUOTE] = ACTIONS(1921),
    [anon_sym_LR_DQUOTE] = ACTIONS(1921),
    [anon_sym_uR_DQUOTE] = ACTIONS(1921),
    [anon_sym_UR_DQUOTE] = ACTIONS(1921),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1921),
    [anon_sym_co_await] = ACTIONS(1923),
    [anon_sym_new] = ACTIONS(1925),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1450] = {
    [sym_primitive_type] = STATE(6669),
    [sym__expression] = STATE(4442),
    [sym__expression_not_binary] = STATE(4648),
    [sym__string] = STATE(4648),
    [sym_conditional_expression] = STATE(4648),
    [sym_assignment_expression] = STATE(4648),
    [sym_pointer_expression] = STATE(3663),
    [sym_unary_expression] = STATE(4648),
    [sym_binary_expression] = STATE(4648),
    [sym_update_expression] = STATE(4648),
    [sym_cast_expression] = STATE(4648),
    [sym_sizeof_expression] = STATE(4648),
    [sym_alignof_expression] = STATE(4648),
    [sym_offsetof_expression] = STATE(4648),
    [sym_generic_expression] = STATE(4648),
    [sym_subscript_expression] = STATE(3663),
    [sym_call_expression] = STATE(3663),
    [sym_gnu_asm_expression] = STATE(4648),
    [sym_field_expression] = STATE(3663),
    [sym_compound_literal_expression] = STATE(4648),
    [sym_parenthesized_expression] = STATE(3663),
    [sym_number_literal] = STATE(4573),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4565),
    [sym_string_literal] = STATE(3707),
    [sym_null] = STATE(4648),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7442),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(4648),
    [sym_raw_string_literal] = STATE(3709),
    [sym_co_await_expression] = STATE(4648),
    [sym_new_expression] = STATE(4648),
    [sym_delete_expression] = STATE(4648),
    [sym_requires_clause] = STATE(4648),
    [sym_requires_expression] = STATE(4648),
    [sym_lambda_expression] = STATE(4648),
    [sym_lambda_capture_specifier] = STATE(5768),
    [sym_fold_expression] = STATE(4648),
    [sym_parameter_pack_expansion] = STATE(4648),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5512),
    [sym_qualified_identifier] = STATE(3663),
    [sym_qualified_type_identifier] = STATE(7442),
    [sym_user_defined_literal] = STATE(3663),
    [sym_identifier] = ACTIONS(3458),
    [anon_sym_LPAREN2] = ACTIONS(2575),
    [anon_sym_BANG] = ACTIONS(2577),
    [anon_sym_TILDE] = ACTIONS(2577),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON_COLON] = ACTIONS(2583),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2579),
    [anon_sym_compl] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(2597),
    [anon_sym_PLUS_PLUS] = ACTIONS(2597),
    [anon_sym_sizeof] = ACTIONS(2599),
    [anon_sym___alignof__] = ACTIONS(2601),
    [anon_sym___alignof] = ACTIONS(2601),
    [anon_sym__alignof] = ACTIONS(2601),
    [anon_sym_alignof] = ACTIONS(2601),
    [anon_sym__Alignof] = ACTIONS(2601),
    [anon_sym_offsetof] = ACTIONS(2603),
    [anon_sym__Generic] = ACTIONS(2605),
    [anon_sym_asm] = ACTIONS(2607),
    [anon_sym___asm__] = ACTIONS(2607),
    [aux_sym_number_literal_token1] = ACTIONS(2609),
    [aux_sym_number_literal_token2] = ACTIONS(2611),
    [anon_sym_L_SQUOTE] = ACTIONS(2613),
    [anon_sym_u_SQUOTE] = ACTIONS(2613),
    [anon_sym_U_SQUOTE] = ACTIONS(2613),
    [anon_sym_u8_SQUOTE] = ACTIONS(2613),
    [anon_sym_SQUOTE] = ACTIONS(2613),
    [anon_sym_L_DQUOTE] = ACTIONS(2615),
    [anon_sym_u_DQUOTE] = ACTIONS(2615),
    [anon_sym_U_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8_DQUOTE] = ACTIONS(2615),
    [anon_sym_DQUOTE] = ACTIONS(2615),
    [sym_true] = ACTIONS(2617),
    [sym_false] = ACTIONS(2617),
    [anon_sym_NULL] = ACTIONS(2619),
    [anon_sym_nullptr] = ACTIONS(2619),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2629),
    [anon_sym_R_DQUOTE] = ACTIONS(2631),
    [anon_sym_LR_DQUOTE] = ACTIONS(2631),
    [anon_sym_uR_DQUOTE] = ACTIONS(2631),
    [anon_sym_UR_DQUOTE] = ACTIONS(2631),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2631),
    [anon_sym_co_await] = ACTIONS(2633),
    [anon_sym_new] = ACTIONS(2635),
    [anon_sym_requires] = ACTIONS(2637),
    [sym_this] = ACTIONS(2617),
  },
  [1451] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2788),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2832),
    [sym_char_literal] = STATE(2832),
    [sym_concatenated_string] = STATE(2831),
    [sym_string_literal] = STATE(1997),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(1998),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4244),
    [anon_sym_BANG] = ACTIONS(1889),
    [anon_sym_TILDE] = ACTIONS(1889),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_STAR] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(4238),
    [anon_sym_COLON_COLON] = ACTIONS(1891),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1887),
    [anon_sym_compl] = ACTIONS(1887),
    [anon_sym_DASH_DASH] = ACTIONS(4102),
    [anon_sym_PLUS_PLUS] = ACTIONS(4102),
    [anon_sym_sizeof] = ACTIONS(1895),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1905),
    [aux_sym_number_literal_token2] = ACTIONS(1907),
    [anon_sym_L_SQUOTE] = ACTIONS(1909),
    [anon_sym_u_SQUOTE] = ACTIONS(1909),
    [anon_sym_U_SQUOTE] = ACTIONS(1909),
    [anon_sym_u8_SQUOTE] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(1909),
    [anon_sym_L_DQUOTE] = ACTIONS(1911),
    [anon_sym_u_DQUOTE] = ACTIONS(1911),
    [anon_sym_U_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8_DQUOTE] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(1911),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1919),
    [anon_sym_R_DQUOTE] = ACTIONS(1921),
    [anon_sym_LR_DQUOTE] = ACTIONS(1921),
    [anon_sym_uR_DQUOTE] = ACTIONS(1921),
    [anon_sym_UR_DQUOTE] = ACTIONS(1921),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1921),
    [anon_sym_co_await] = ACTIONS(1923),
    [anon_sym_new] = ACTIONS(1925),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1452] = {
    [sym_primitive_type] = STATE(6613),
    [sym__expression] = STATE(3337),
    [sym__expression_not_binary] = STATE(3637),
    [sym__string] = STATE(3637),
    [sym_conditional_expression] = STATE(3637),
    [sym_assignment_expression] = STATE(3637),
    [sym_pointer_expression] = STATE(3637),
    [sym_unary_expression] = STATE(3637),
    [sym_binary_expression] = STATE(3637),
    [sym_update_expression] = STATE(3637),
    [sym_cast_expression] = STATE(3637),
    [sym_sizeof_expression] = STATE(3637),
    [sym_alignof_expression] = STATE(3637),
    [sym_offsetof_expression] = STATE(3637),
    [sym_generic_expression] = STATE(3637),
    [sym_subscript_expression] = STATE(3637),
    [sym_call_expression] = STATE(3637),
    [sym_gnu_asm_expression] = STATE(3637),
    [sym_field_expression] = STATE(3637),
    [sym_compound_literal_expression] = STATE(3637),
    [sym_parenthesized_expression] = STATE(3637),
    [sym_number_literal] = STATE(3416),
    [sym_char_literal] = STATE(3416),
    [sym_concatenated_string] = STATE(3415),
    [sym_string_literal] = STATE(2430),
    [sym_null] = STATE(3637),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7434),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3637),
    [sym_raw_string_literal] = STATE(2419),
    [sym_co_await_expression] = STATE(3637),
    [sym_new_expression] = STATE(3637),
    [sym_delete_expression] = STATE(3637),
    [sym_requires_clause] = STATE(3637),
    [sym_requires_expression] = STATE(3637),
    [sym_lambda_expression] = STATE(3637),
    [sym_lambda_capture_specifier] = STATE(5725),
    [sym_fold_expression] = STATE(3637),
    [sym_parameter_pack_expansion] = STATE(3637),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5512),
    [sym_qualified_identifier] = STATE(3637),
    [sym_qualified_type_identifier] = STATE(7434),
    [sym_user_defined_literal] = STATE(3637),
    [sym_identifier] = ACTIONS(2228),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_BANG] = ACTIONS(2232),
    [anon_sym_TILDE] = ACTIONS(2232),
    [anon_sym_DASH] = ACTIONS(2230),
    [anon_sym_PLUS] = ACTIONS(2230),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON_COLON] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2230),
    [anon_sym_compl] = ACTIONS(2230),
    [anon_sym_DASH_DASH] = ACTIONS(4112),
    [anon_sym_PLUS_PLUS] = ACTIONS(4112),
    [anon_sym_sizeof] = ACTIONS(2238),
    [anon_sym___alignof__] = ACTIONS(2240),
    [anon_sym___alignof] = ACTIONS(2240),
    [anon_sym__alignof] = ACTIONS(2240),
    [anon_sym_alignof] = ACTIONS(2240),
    [anon_sym__Alignof] = ACTIONS(2240),
    [anon_sym_offsetof] = ACTIONS(2242),
    [anon_sym__Generic] = ACTIONS(2244),
    [anon_sym_asm] = ACTIONS(2246),
    [anon_sym___asm__] = ACTIONS(2246),
    [aux_sym_number_literal_token1] = ACTIONS(2248),
    [aux_sym_number_literal_token2] = ACTIONS(2250),
    [anon_sym_L_SQUOTE] = ACTIONS(2252),
    [anon_sym_u_SQUOTE] = ACTIONS(2252),
    [anon_sym_U_SQUOTE] = ACTIONS(2252),
    [anon_sym_u8_SQUOTE] = ACTIONS(2252),
    [anon_sym_SQUOTE] = ACTIONS(2252),
    [anon_sym_L_DQUOTE] = ACTIONS(2254),
    [anon_sym_u_DQUOTE] = ACTIONS(2254),
    [anon_sym_U_DQUOTE] = ACTIONS(2254),
    [anon_sym_u8_DQUOTE] = ACTIONS(2254),
    [anon_sym_DQUOTE] = ACTIONS(2254),
    [sym_true] = ACTIONS(2256),
    [sym_false] = ACTIONS(2256),
    [anon_sym_NULL] = ACTIONS(2258),
    [anon_sym_nullptr] = ACTIONS(2258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2260),
    [anon_sym_R_DQUOTE] = ACTIONS(2262),
    [anon_sym_LR_DQUOTE] = ACTIONS(2262),
    [anon_sym_uR_DQUOTE] = ACTIONS(2262),
    [anon_sym_UR_DQUOTE] = ACTIONS(2262),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2262),
    [anon_sym_co_await] = ACTIONS(2264),
    [anon_sym_new] = ACTIONS(2266),
    [anon_sym_requires] = ACTIONS(2268),
    [sym_this] = ACTIONS(2256),
  },
  [1453] = {
    [sym_primitive_type] = STATE(6613),
    [sym__expression] = STATE(3335),
    [sym__expression_not_binary] = STATE(3637),
    [sym__string] = STATE(3637),
    [sym_conditional_expression] = STATE(3637),
    [sym_assignment_expression] = STATE(3637),
    [sym_pointer_expression] = STATE(3637),
    [sym_unary_expression] = STATE(3637),
    [sym_binary_expression] = STATE(3637),
    [sym_update_expression] = STATE(3637),
    [sym_cast_expression] = STATE(3637),
    [sym_sizeof_expression] = STATE(3637),
    [sym_alignof_expression] = STATE(3637),
    [sym_offsetof_expression] = STATE(3637),
    [sym_generic_expression] = STATE(3637),
    [sym_subscript_expression] = STATE(3637),
    [sym_call_expression] = STATE(3637),
    [sym_gnu_asm_expression] = STATE(3637),
    [sym_field_expression] = STATE(3637),
    [sym_compound_literal_expression] = STATE(3637),
    [sym_parenthesized_expression] = STATE(3637),
    [sym_number_literal] = STATE(3416),
    [sym_char_literal] = STATE(3416),
    [sym_concatenated_string] = STATE(3415),
    [sym_string_literal] = STATE(2430),
    [sym_null] = STATE(3637),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7434),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3637),
    [sym_raw_string_literal] = STATE(2419),
    [sym_co_await_expression] = STATE(3637),
    [sym_new_expression] = STATE(3637),
    [sym_delete_expression] = STATE(3637),
    [sym_requires_clause] = STATE(3637),
    [sym_requires_expression] = STATE(3637),
    [sym_lambda_expression] = STATE(3637),
    [sym_lambda_capture_specifier] = STATE(5725),
    [sym_fold_expression] = STATE(3637),
    [sym_parameter_pack_expansion] = STATE(3637),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5512),
    [sym_qualified_identifier] = STATE(3637),
    [sym_qualified_type_identifier] = STATE(7434),
    [sym_user_defined_literal] = STATE(3637),
    [sym_identifier] = ACTIONS(2228),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_BANG] = ACTIONS(2232),
    [anon_sym_TILDE] = ACTIONS(2232),
    [anon_sym_DASH] = ACTIONS(2230),
    [anon_sym_PLUS] = ACTIONS(2230),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON_COLON] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(4468),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2230),
    [anon_sym_compl] = ACTIONS(2230),
    [anon_sym_DASH_DASH] = ACTIONS(4112),
    [anon_sym_PLUS_PLUS] = ACTIONS(4112),
    [anon_sym_sizeof] = ACTIONS(2238),
    [anon_sym___alignof__] = ACTIONS(2240),
    [anon_sym___alignof] = ACTIONS(2240),
    [anon_sym__alignof] = ACTIONS(2240),
    [anon_sym_alignof] = ACTIONS(2240),
    [anon_sym__Alignof] = ACTIONS(2240),
    [anon_sym_offsetof] = ACTIONS(2242),
    [anon_sym__Generic] = ACTIONS(2244),
    [anon_sym_asm] = ACTIONS(2246),
    [anon_sym___asm__] = ACTIONS(2246),
    [aux_sym_number_literal_token1] = ACTIONS(2248),
    [aux_sym_number_literal_token2] = ACTIONS(2250),
    [anon_sym_L_SQUOTE] = ACTIONS(2252),
    [anon_sym_u_SQUOTE] = ACTIONS(2252),
    [anon_sym_U_SQUOTE] = ACTIONS(2252),
    [anon_sym_u8_SQUOTE] = ACTIONS(2252),
    [anon_sym_SQUOTE] = ACTIONS(2252),
    [anon_sym_L_DQUOTE] = ACTIONS(2254),
    [anon_sym_u_DQUOTE] = ACTIONS(2254),
    [anon_sym_U_DQUOTE] = ACTIONS(2254),
    [anon_sym_u8_DQUOTE] = ACTIONS(2254),
    [anon_sym_DQUOTE] = ACTIONS(2254),
    [sym_true] = ACTIONS(2256),
    [sym_false] = ACTIONS(2256),
    [anon_sym_NULL] = ACTIONS(2258),
    [anon_sym_nullptr] = ACTIONS(2258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2260),
    [anon_sym_R_DQUOTE] = ACTIONS(2262),
    [anon_sym_LR_DQUOTE] = ACTIONS(2262),
    [anon_sym_uR_DQUOTE] = ACTIONS(2262),
    [anon_sym_UR_DQUOTE] = ACTIONS(2262),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2262),
    [anon_sym_co_await] = ACTIONS(2264),
    [anon_sym_new] = ACTIONS(2266),
    [anon_sym_requires] = ACTIONS(2268),
    [sym_this] = ACTIONS(2256),
  },
  [1454] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4116),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(2961),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(2961),
    [sym_call_expression] = STATE(2961),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(2961),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(2961),
    [sym_number_literal] = STATE(4149),
    [sym_char_literal] = STATE(4149),
    [sym_concatenated_string] = STATE(4150),
    [sym_string_literal] = STATE(3034),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3026),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2961),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(2961),
    [sym_identifier] = ACTIONS(4082),
    [anon_sym_LPAREN2] = ACTIONS(4236),
    [anon_sym_BANG] = ACTIONS(3190),
    [anon_sym_TILDE] = ACTIONS(3190),
    [anon_sym_DASH] = ACTIONS(3188),
    [anon_sym_PLUS] = ACTIONS(3188),
    [anon_sym_STAR] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(4238),
    [anon_sym_COLON_COLON] = ACTIONS(3192),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3188),
    [anon_sym_compl] = ACTIONS(3188),
    [anon_sym_DASH_DASH] = ACTIONS(4088),
    [anon_sym_PLUS_PLUS] = ACTIONS(4088),
    [anon_sym_sizeof] = ACTIONS(3196),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3198),
    [aux_sym_number_literal_token2] = ACTIONS(3200),
    [anon_sym_L_SQUOTE] = ACTIONS(3202),
    [anon_sym_u_SQUOTE] = ACTIONS(3202),
    [anon_sym_U_SQUOTE] = ACTIONS(3202),
    [anon_sym_u8_SQUOTE] = ACTIONS(3202),
    [anon_sym_SQUOTE] = ACTIONS(3202),
    [anon_sym_L_DQUOTE] = ACTIONS(3204),
    [anon_sym_u_DQUOTE] = ACTIONS(3204),
    [anon_sym_U_DQUOTE] = ACTIONS(3204),
    [anon_sym_u8_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3204),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3206),
    [anon_sym_R_DQUOTE] = ACTIONS(3208),
    [anon_sym_LR_DQUOTE] = ACTIONS(3208),
    [anon_sym_uR_DQUOTE] = ACTIONS(3208),
    [anon_sym_UR_DQUOTE] = ACTIONS(3208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3208),
    [anon_sym_co_await] = ACTIONS(3210),
    [anon_sym_new] = ACTIONS(3212),
    [anon_sym_requires] = ACTIONS(3214),
    [sym_this] = ACTIONS(219),
  },
  [1455] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4501),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1456] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2903),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4218),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_TILDE] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1931),
    [anon_sym_PLUS] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(1935),
    [anon_sym_LBRACK] = ACTIONS(4470),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1931),
    [anon_sym_compl] = ACTIONS(1931),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_sizeof] = ACTIONS(1937),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1457] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4119),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(2961),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(2961),
    [sym_call_expression] = STATE(2961),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(2961),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(2961),
    [sym_number_literal] = STATE(4149),
    [sym_char_literal] = STATE(4149),
    [sym_concatenated_string] = STATE(4150),
    [sym_string_literal] = STATE(3034),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3026),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2961),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(2961),
    [sym_identifier] = ACTIONS(4082),
    [anon_sym_LPAREN2] = ACTIONS(4236),
    [anon_sym_BANG] = ACTIONS(3190),
    [anon_sym_TILDE] = ACTIONS(3190),
    [anon_sym_DASH] = ACTIONS(3188),
    [anon_sym_PLUS] = ACTIONS(3188),
    [anon_sym_STAR] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(4238),
    [anon_sym_COLON_COLON] = ACTIONS(3192),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3188),
    [anon_sym_compl] = ACTIONS(3188),
    [anon_sym_DASH_DASH] = ACTIONS(4088),
    [anon_sym_PLUS_PLUS] = ACTIONS(4088),
    [anon_sym_sizeof] = ACTIONS(3196),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3198),
    [aux_sym_number_literal_token2] = ACTIONS(3200),
    [anon_sym_L_SQUOTE] = ACTIONS(3202),
    [anon_sym_u_SQUOTE] = ACTIONS(3202),
    [anon_sym_U_SQUOTE] = ACTIONS(3202),
    [anon_sym_u8_SQUOTE] = ACTIONS(3202),
    [anon_sym_SQUOTE] = ACTIONS(3202),
    [anon_sym_L_DQUOTE] = ACTIONS(3204),
    [anon_sym_u_DQUOTE] = ACTIONS(3204),
    [anon_sym_U_DQUOTE] = ACTIONS(3204),
    [anon_sym_u8_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3204),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3206),
    [anon_sym_R_DQUOTE] = ACTIONS(3208),
    [anon_sym_LR_DQUOTE] = ACTIONS(3208),
    [anon_sym_uR_DQUOTE] = ACTIONS(3208),
    [anon_sym_UR_DQUOTE] = ACTIONS(3208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3208),
    [anon_sym_co_await] = ACTIONS(3210),
    [anon_sym_new] = ACTIONS(3212),
    [anon_sym_requires] = ACTIONS(3214),
    [sym_this] = ACTIONS(219),
  },
  [1458] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2437),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4218),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_TILDE] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1931),
    [anon_sym_PLUS] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(1935),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1931),
    [anon_sym_compl] = ACTIONS(1931),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_sizeof] = ACTIONS(1937),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1459] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4111),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(2961),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(2961),
    [sym_call_expression] = STATE(2961),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(2961),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(2961),
    [sym_number_literal] = STATE(4149),
    [sym_char_literal] = STATE(4149),
    [sym_concatenated_string] = STATE(4150),
    [sym_string_literal] = STATE(3034),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3026),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2961),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(2961),
    [sym_identifier] = ACTIONS(4082),
    [anon_sym_LPAREN2] = ACTIONS(4236),
    [anon_sym_BANG] = ACTIONS(3190),
    [anon_sym_TILDE] = ACTIONS(3190),
    [anon_sym_DASH] = ACTIONS(3188),
    [anon_sym_PLUS] = ACTIONS(3188),
    [anon_sym_STAR] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(4238),
    [anon_sym_COLON_COLON] = ACTIONS(3192),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3188),
    [anon_sym_compl] = ACTIONS(3188),
    [anon_sym_DASH_DASH] = ACTIONS(4088),
    [anon_sym_PLUS_PLUS] = ACTIONS(4088),
    [anon_sym_sizeof] = ACTIONS(3196),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3198),
    [aux_sym_number_literal_token2] = ACTIONS(3200),
    [anon_sym_L_SQUOTE] = ACTIONS(3202),
    [anon_sym_u_SQUOTE] = ACTIONS(3202),
    [anon_sym_U_SQUOTE] = ACTIONS(3202),
    [anon_sym_u8_SQUOTE] = ACTIONS(3202),
    [anon_sym_SQUOTE] = ACTIONS(3202),
    [anon_sym_L_DQUOTE] = ACTIONS(3204),
    [anon_sym_u_DQUOTE] = ACTIONS(3204),
    [anon_sym_U_DQUOTE] = ACTIONS(3204),
    [anon_sym_u8_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3204),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3206),
    [anon_sym_R_DQUOTE] = ACTIONS(3208),
    [anon_sym_LR_DQUOTE] = ACTIONS(3208),
    [anon_sym_uR_DQUOTE] = ACTIONS(3208),
    [anon_sym_UR_DQUOTE] = ACTIONS(3208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3208),
    [anon_sym_co_await] = ACTIONS(3210),
    [anon_sym_new] = ACTIONS(3212),
    [anon_sym_requires] = ACTIONS(3214),
    [sym_this] = ACTIONS(219),
  },
  [1460] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4267),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3440),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3440),
    [sym_call_expression] = STATE(3440),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3440),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3440),
    [sym_number_literal] = STATE(4352),
    [sym_char_literal] = STATE(4352),
    [sym_concatenated_string] = STATE(4364),
    [sym_string_literal] = STATE(3640),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3641),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3440),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3440),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_LPAREN2] = ACTIONS(4046),
    [anon_sym_BANG] = ACTIONS(3344),
    [anon_sym_TILDE] = ACTIONS(3344),
    [anon_sym_DASH] = ACTIONS(3342),
    [anon_sym_PLUS] = ACTIONS(3342),
    [anon_sym_STAR] = ACTIONS(4048),
    [anon_sym_AMP] = ACTIONS(4048),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3342),
    [anon_sym_compl] = ACTIONS(3342),
    [anon_sym_DASH_DASH] = ACTIONS(4052),
    [anon_sym_PLUS_PLUS] = ACTIONS(4052),
    [anon_sym_sizeof] = ACTIONS(3348),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3350),
    [aux_sym_number_literal_token2] = ACTIONS(3352),
    [anon_sym_L_SQUOTE] = ACTIONS(3354),
    [anon_sym_u_SQUOTE] = ACTIONS(3354),
    [anon_sym_U_SQUOTE] = ACTIONS(3354),
    [anon_sym_u8_SQUOTE] = ACTIONS(3354),
    [anon_sym_SQUOTE] = ACTIONS(3354),
    [anon_sym_L_DQUOTE] = ACTIONS(3356),
    [anon_sym_u_DQUOTE] = ACTIONS(3356),
    [anon_sym_U_DQUOTE] = ACTIONS(3356),
    [anon_sym_u8_DQUOTE] = ACTIONS(3356),
    [anon_sym_DQUOTE] = ACTIONS(3356),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3358),
    [anon_sym_R_DQUOTE] = ACTIONS(3360),
    [anon_sym_LR_DQUOTE] = ACTIONS(3360),
    [anon_sym_uR_DQUOTE] = ACTIONS(3360),
    [anon_sym_UR_DQUOTE] = ACTIONS(3360),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3360),
    [anon_sym_co_await] = ACTIONS(3362),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1461] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2907),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4218),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_TILDE] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1931),
    [anon_sym_PLUS] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(1935),
    [anon_sym_LBRACK] = ACTIONS(4472),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1931),
    [anon_sym_compl] = ACTIONS(1931),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_sizeof] = ACTIONS(1937),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1462] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4254),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1463] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4440),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3679),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3679),
    [sym_call_expression] = STATE(3679),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3679),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3679),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3679),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3679),
    [sym_identifier] = ACTIONS(3538),
    [anon_sym_LPAREN2] = ACTIONS(4199),
    [anon_sym_BANG] = ACTIONS(3542),
    [anon_sym_TILDE] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3540),
    [anon_sym_PLUS] = ACTIONS(3540),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(3544),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3540),
    [anon_sym_compl] = ACTIONS(3540),
    [anon_sym_DASH_DASH] = ACTIONS(4122),
    [anon_sym_PLUS_PLUS] = ACTIONS(4122),
    [anon_sym_sizeof] = ACTIONS(3546),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3548),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3550),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1464] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4419),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3679),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3679),
    [sym_call_expression] = STATE(3679),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3679),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3679),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3679),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3679),
    [sym_identifier] = ACTIONS(3538),
    [anon_sym_LPAREN2] = ACTIONS(4199),
    [anon_sym_BANG] = ACTIONS(3542),
    [anon_sym_TILDE] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3540),
    [anon_sym_PLUS] = ACTIONS(3540),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(3544),
    [anon_sym_LBRACK] = ACTIONS(4474),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3540),
    [anon_sym_compl] = ACTIONS(3540),
    [anon_sym_DASH_DASH] = ACTIONS(4122),
    [anon_sym_PLUS_PLUS] = ACTIONS(4122),
    [anon_sym_sizeof] = ACTIONS(3546),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3548),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3550),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1465] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2763),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2832),
    [sym_char_literal] = STATE(2832),
    [sym_concatenated_string] = STATE(2831),
    [sym_string_literal] = STATE(1997),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(1998),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4244),
    [anon_sym_BANG] = ACTIONS(1889),
    [anon_sym_TILDE] = ACTIONS(1889),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_STAR] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(4238),
    [anon_sym_COLON_COLON] = ACTIONS(1891),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1887),
    [anon_sym_compl] = ACTIONS(1887),
    [anon_sym_DASH_DASH] = ACTIONS(4102),
    [anon_sym_PLUS_PLUS] = ACTIONS(4102),
    [anon_sym_sizeof] = ACTIONS(1895),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1905),
    [aux_sym_number_literal_token2] = ACTIONS(1907),
    [anon_sym_L_SQUOTE] = ACTIONS(1909),
    [anon_sym_u_SQUOTE] = ACTIONS(1909),
    [anon_sym_U_SQUOTE] = ACTIONS(1909),
    [anon_sym_u8_SQUOTE] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(1909),
    [anon_sym_L_DQUOTE] = ACTIONS(1911),
    [anon_sym_u_DQUOTE] = ACTIONS(1911),
    [anon_sym_U_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8_DQUOTE] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(1911),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1919),
    [anon_sym_R_DQUOTE] = ACTIONS(1921),
    [anon_sym_LR_DQUOTE] = ACTIONS(1921),
    [anon_sym_uR_DQUOTE] = ACTIONS(1921),
    [anon_sym_UR_DQUOTE] = ACTIONS(1921),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1921),
    [anon_sym_co_await] = ACTIONS(1923),
    [anon_sym_new] = ACTIONS(1925),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1466] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4132),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(2961),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(2961),
    [sym_call_expression] = STATE(2961),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(2961),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(2961),
    [sym_number_literal] = STATE(4149),
    [sym_char_literal] = STATE(4149),
    [sym_concatenated_string] = STATE(4150),
    [sym_string_literal] = STATE(3034),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3026),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2961),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(2961),
    [sym_identifier] = ACTIONS(4082),
    [anon_sym_LPAREN2] = ACTIONS(4236),
    [anon_sym_BANG] = ACTIONS(3190),
    [anon_sym_TILDE] = ACTIONS(3190),
    [anon_sym_DASH] = ACTIONS(3188),
    [anon_sym_PLUS] = ACTIONS(3188),
    [anon_sym_STAR] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(4238),
    [anon_sym_COLON_COLON] = ACTIONS(3192),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3188),
    [anon_sym_compl] = ACTIONS(3188),
    [anon_sym_DASH_DASH] = ACTIONS(4088),
    [anon_sym_PLUS_PLUS] = ACTIONS(4088),
    [anon_sym_sizeof] = ACTIONS(3196),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3198),
    [aux_sym_number_literal_token2] = ACTIONS(3200),
    [anon_sym_L_SQUOTE] = ACTIONS(3202),
    [anon_sym_u_SQUOTE] = ACTIONS(3202),
    [anon_sym_U_SQUOTE] = ACTIONS(3202),
    [anon_sym_u8_SQUOTE] = ACTIONS(3202),
    [anon_sym_SQUOTE] = ACTIONS(3202),
    [anon_sym_L_DQUOTE] = ACTIONS(3204),
    [anon_sym_u_DQUOTE] = ACTIONS(3204),
    [anon_sym_U_DQUOTE] = ACTIONS(3204),
    [anon_sym_u8_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3204),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3206),
    [anon_sym_R_DQUOTE] = ACTIONS(3208),
    [anon_sym_LR_DQUOTE] = ACTIONS(3208),
    [anon_sym_uR_DQUOTE] = ACTIONS(3208),
    [anon_sym_UR_DQUOTE] = ACTIONS(3208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3208),
    [anon_sym_co_await] = ACTIONS(3210),
    [anon_sym_new] = ACTIONS(3212),
    [anon_sym_requires] = ACTIONS(3214),
    [sym_this] = ACTIONS(219),
  },
  [1467] = {
    [sym_primitive_type] = STATE(6848),
    [sym__expression] = STATE(3086),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7357),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(7357),
    [sym_user_defined_literal] = STATE(3526),
    [sym_identifier] = ACTIONS(1965),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_LBRACK] = ACTIONS(4476),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [1468] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4211),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(4478),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1469] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4264),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3440),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3440),
    [sym_call_expression] = STATE(3440),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3440),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3440),
    [sym_number_literal] = STATE(4352),
    [sym_char_literal] = STATE(4352),
    [sym_concatenated_string] = STATE(4364),
    [sym_string_literal] = STATE(3640),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3641),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3440),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3440),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_LPAREN2] = ACTIONS(4046),
    [anon_sym_BANG] = ACTIONS(3344),
    [anon_sym_TILDE] = ACTIONS(3344),
    [anon_sym_DASH] = ACTIONS(3342),
    [anon_sym_PLUS] = ACTIONS(3342),
    [anon_sym_STAR] = ACTIONS(4048),
    [anon_sym_AMP] = ACTIONS(4048),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3342),
    [anon_sym_compl] = ACTIONS(3342),
    [anon_sym_DASH_DASH] = ACTIONS(4052),
    [anon_sym_PLUS_PLUS] = ACTIONS(4052),
    [anon_sym_sizeof] = ACTIONS(3348),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3350),
    [aux_sym_number_literal_token2] = ACTIONS(3352),
    [anon_sym_L_SQUOTE] = ACTIONS(3354),
    [anon_sym_u_SQUOTE] = ACTIONS(3354),
    [anon_sym_U_SQUOTE] = ACTIONS(3354),
    [anon_sym_u8_SQUOTE] = ACTIONS(3354),
    [anon_sym_SQUOTE] = ACTIONS(3354),
    [anon_sym_L_DQUOTE] = ACTIONS(3356),
    [anon_sym_u_DQUOTE] = ACTIONS(3356),
    [anon_sym_U_DQUOTE] = ACTIONS(3356),
    [anon_sym_u8_DQUOTE] = ACTIONS(3356),
    [anon_sym_DQUOTE] = ACTIONS(3356),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3358),
    [anon_sym_R_DQUOTE] = ACTIONS(3360),
    [anon_sym_LR_DQUOTE] = ACTIONS(3360),
    [anon_sym_uR_DQUOTE] = ACTIONS(3360),
    [anon_sym_UR_DQUOTE] = ACTIONS(3360),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3360),
    [anon_sym_co_await] = ACTIONS(3362),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1470] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2773),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2832),
    [sym_char_literal] = STATE(2832),
    [sym_concatenated_string] = STATE(2831),
    [sym_string_literal] = STATE(1997),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(1998),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4244),
    [anon_sym_BANG] = ACTIONS(1889),
    [anon_sym_TILDE] = ACTIONS(1889),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_STAR] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(4238),
    [anon_sym_COLON_COLON] = ACTIONS(1891),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1887),
    [anon_sym_compl] = ACTIONS(1887),
    [anon_sym_DASH_DASH] = ACTIONS(4102),
    [anon_sym_PLUS_PLUS] = ACTIONS(4102),
    [anon_sym_sizeof] = ACTIONS(1895),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1905),
    [aux_sym_number_literal_token2] = ACTIONS(1907),
    [anon_sym_L_SQUOTE] = ACTIONS(1909),
    [anon_sym_u_SQUOTE] = ACTIONS(1909),
    [anon_sym_U_SQUOTE] = ACTIONS(1909),
    [anon_sym_u8_SQUOTE] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(1909),
    [anon_sym_L_DQUOTE] = ACTIONS(1911),
    [anon_sym_u_DQUOTE] = ACTIONS(1911),
    [anon_sym_U_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8_DQUOTE] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(1911),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1919),
    [anon_sym_R_DQUOTE] = ACTIONS(1921),
    [anon_sym_LR_DQUOTE] = ACTIONS(1921),
    [anon_sym_uR_DQUOTE] = ACTIONS(1921),
    [anon_sym_UR_DQUOTE] = ACTIONS(1921),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1921),
    [anon_sym_co_await] = ACTIONS(1923),
    [anon_sym_new] = ACTIONS(1925),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1471] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4438),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3679),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3679),
    [sym_call_expression] = STATE(3679),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3679),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3679),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3679),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3679),
    [sym_identifier] = ACTIONS(3538),
    [anon_sym_LPAREN2] = ACTIONS(4199),
    [anon_sym_BANG] = ACTIONS(3542),
    [anon_sym_TILDE] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3540),
    [anon_sym_PLUS] = ACTIONS(3540),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(3544),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3540),
    [anon_sym_compl] = ACTIONS(3540),
    [anon_sym_DASH_DASH] = ACTIONS(4122),
    [anon_sym_PLUS_PLUS] = ACTIONS(4122),
    [anon_sym_sizeof] = ACTIONS(3546),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3548),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3550),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1472] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4437),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3679),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3679),
    [sym_call_expression] = STATE(3679),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3679),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3679),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3679),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3679),
    [sym_identifier] = ACTIONS(3538),
    [anon_sym_LPAREN2] = ACTIONS(4199),
    [anon_sym_BANG] = ACTIONS(3542),
    [anon_sym_TILDE] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3540),
    [anon_sym_PLUS] = ACTIONS(3540),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(3544),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3540),
    [anon_sym_compl] = ACTIONS(3540),
    [anon_sym_DASH_DASH] = ACTIONS(4122),
    [anon_sym_PLUS_PLUS] = ACTIONS(4122),
    [anon_sym_sizeof] = ACTIONS(3546),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3548),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3550),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1473] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4415),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3679),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3679),
    [sym_call_expression] = STATE(3679),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3679),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3679),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3679),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3679),
    [sym_identifier] = ACTIONS(3538),
    [anon_sym_LPAREN2] = ACTIONS(4199),
    [anon_sym_BANG] = ACTIONS(3542),
    [anon_sym_TILDE] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3540),
    [anon_sym_PLUS] = ACTIONS(3540),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(3544),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3540),
    [anon_sym_compl] = ACTIONS(3540),
    [anon_sym_DASH_DASH] = ACTIONS(4122),
    [anon_sym_PLUS_PLUS] = ACTIONS(4122),
    [anon_sym_sizeof] = ACTIONS(3546),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3548),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3550),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1474] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(3072),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(3292),
    [sym_char_literal] = STATE(3292),
    [sym_concatenated_string] = STATE(3308),
    [sym_string_literal] = STATE(2343),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2348),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1969),
    [anon_sym_LPAREN2] = ACTIONS(4256),
    [anon_sym_BANG] = ACTIONS(1973),
    [anon_sym_TILDE] = ACTIONS(1973),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_STAR] = ACTIONS(4048),
    [anon_sym_AMP] = ACTIONS(4048),
    [anon_sym_COLON_COLON] = ACTIONS(1975),
    [anon_sym_LBRACK] = ACTIONS(4480),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1971),
    [anon_sym_compl] = ACTIONS(1971),
    [anon_sym_DASH_DASH] = ACTIONS(4096),
    [anon_sym_PLUS_PLUS] = ACTIONS(4096),
    [anon_sym_sizeof] = ACTIONS(1977),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1979),
    [aux_sym_number_literal_token2] = ACTIONS(1981),
    [anon_sym_L_SQUOTE] = ACTIONS(1983),
    [anon_sym_u_SQUOTE] = ACTIONS(1983),
    [anon_sym_U_SQUOTE] = ACTIONS(1983),
    [anon_sym_u8_SQUOTE] = ACTIONS(1983),
    [anon_sym_SQUOTE] = ACTIONS(1983),
    [anon_sym_L_DQUOTE] = ACTIONS(1985),
    [anon_sym_u_DQUOTE] = ACTIONS(1985),
    [anon_sym_U_DQUOTE] = ACTIONS(1985),
    [anon_sym_u8_DQUOTE] = ACTIONS(1985),
    [anon_sym_DQUOTE] = ACTIONS(1985),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1987),
    [anon_sym_R_DQUOTE] = ACTIONS(1989),
    [anon_sym_LR_DQUOTE] = ACTIONS(1989),
    [anon_sym_uR_DQUOTE] = ACTIONS(1989),
    [anon_sym_UR_DQUOTE] = ACTIONS(1989),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1989),
    [anon_sym_co_await] = ACTIONS(1991),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1475] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4562),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1476] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4404),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3679),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3679),
    [sym_call_expression] = STATE(3679),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3679),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3679),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3679),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3679),
    [sym_identifier] = ACTIONS(3538),
    [anon_sym_LPAREN2] = ACTIONS(4199),
    [anon_sym_BANG] = ACTIONS(3542),
    [anon_sym_TILDE] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3540),
    [anon_sym_PLUS] = ACTIONS(3540),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(3544),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3540),
    [anon_sym_compl] = ACTIONS(3540),
    [anon_sym_DASH_DASH] = ACTIONS(4122),
    [anon_sym_PLUS_PLUS] = ACTIONS(4122),
    [anon_sym_sizeof] = ACTIONS(3546),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3548),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3550),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1477] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(3897),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1478] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4402),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3679),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3679),
    [sym_call_expression] = STATE(3679),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3679),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3679),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3679),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3679),
    [sym_identifier] = ACTIONS(3538),
    [anon_sym_LPAREN2] = ACTIONS(4199),
    [anon_sym_BANG] = ACTIONS(3542),
    [anon_sym_TILDE] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3540),
    [anon_sym_PLUS] = ACTIONS(3540),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(3544),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3540),
    [anon_sym_compl] = ACTIONS(3540),
    [anon_sym_DASH_DASH] = ACTIONS(4122),
    [anon_sym_PLUS_PLUS] = ACTIONS(4122),
    [anon_sym_sizeof] = ACTIONS(3546),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3548),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3550),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1479] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4399),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3679),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3679),
    [sym_call_expression] = STATE(3679),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3679),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3679),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3679),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3679),
    [sym_identifier] = ACTIONS(3538),
    [anon_sym_LPAREN2] = ACTIONS(4199),
    [anon_sym_BANG] = ACTIONS(3542),
    [anon_sym_TILDE] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3540),
    [anon_sym_PLUS] = ACTIONS(3540),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(3544),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3540),
    [anon_sym_compl] = ACTIONS(3540),
    [anon_sym_DASH_DASH] = ACTIONS(4122),
    [anon_sym_PLUS_PLUS] = ACTIONS(4122),
    [anon_sym_sizeof] = ACTIONS(3546),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3548),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3550),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1480] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4394),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3679),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3679),
    [sym_call_expression] = STATE(3679),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3679),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3679),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3679),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3679),
    [sym_identifier] = ACTIONS(3538),
    [anon_sym_LPAREN2] = ACTIONS(4199),
    [anon_sym_BANG] = ACTIONS(3542),
    [anon_sym_TILDE] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3540),
    [anon_sym_PLUS] = ACTIONS(3540),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(3544),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3540),
    [anon_sym_compl] = ACTIONS(3540),
    [anon_sym_DASH_DASH] = ACTIONS(4122),
    [anon_sym_PLUS_PLUS] = ACTIONS(4122),
    [anon_sym_sizeof] = ACTIONS(3546),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3548),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3550),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1481] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4392),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3679),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3679),
    [sym_call_expression] = STATE(3679),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3679),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3679),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3679),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3679),
    [sym_identifier] = ACTIONS(3538),
    [anon_sym_LPAREN2] = ACTIONS(4199),
    [anon_sym_BANG] = ACTIONS(3542),
    [anon_sym_TILDE] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3540),
    [anon_sym_PLUS] = ACTIONS(3540),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(3544),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3540),
    [anon_sym_compl] = ACTIONS(3540),
    [anon_sym_DASH_DASH] = ACTIONS(4122),
    [anon_sym_PLUS_PLUS] = ACTIONS(4122),
    [anon_sym_sizeof] = ACTIONS(3546),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3548),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3550),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1482] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2810),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2832),
    [sym_char_literal] = STATE(2832),
    [sym_concatenated_string] = STATE(2831),
    [sym_string_literal] = STATE(1997),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(1998),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4244),
    [anon_sym_BANG] = ACTIONS(1889),
    [anon_sym_TILDE] = ACTIONS(1889),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_STAR] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(4238),
    [anon_sym_COLON_COLON] = ACTIONS(1891),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1887),
    [anon_sym_compl] = ACTIONS(1887),
    [anon_sym_DASH_DASH] = ACTIONS(4102),
    [anon_sym_PLUS_PLUS] = ACTIONS(4102),
    [anon_sym_sizeof] = ACTIONS(1895),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1905),
    [aux_sym_number_literal_token2] = ACTIONS(1907),
    [anon_sym_L_SQUOTE] = ACTIONS(1909),
    [anon_sym_u_SQUOTE] = ACTIONS(1909),
    [anon_sym_U_SQUOTE] = ACTIONS(1909),
    [anon_sym_u8_SQUOTE] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(1909),
    [anon_sym_L_DQUOTE] = ACTIONS(1911),
    [anon_sym_u_DQUOTE] = ACTIONS(1911),
    [anon_sym_U_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8_DQUOTE] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(1911),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1919),
    [anon_sym_R_DQUOTE] = ACTIONS(1921),
    [anon_sym_LR_DQUOTE] = ACTIONS(1921),
    [anon_sym_uR_DQUOTE] = ACTIONS(1921),
    [anon_sym_UR_DQUOTE] = ACTIONS(1921),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1921),
    [anon_sym_co_await] = ACTIONS(1923),
    [anon_sym_new] = ACTIONS(1925),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1483] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2792),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2832),
    [sym_char_literal] = STATE(2832),
    [sym_concatenated_string] = STATE(2831),
    [sym_string_literal] = STATE(1997),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(1998),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4244),
    [anon_sym_BANG] = ACTIONS(1889),
    [anon_sym_TILDE] = ACTIONS(1889),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_STAR] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(4238),
    [anon_sym_COLON_COLON] = ACTIONS(1891),
    [anon_sym_LBRACK] = ACTIONS(4482),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1887),
    [anon_sym_compl] = ACTIONS(1887),
    [anon_sym_DASH_DASH] = ACTIONS(4102),
    [anon_sym_PLUS_PLUS] = ACTIONS(4102),
    [anon_sym_sizeof] = ACTIONS(1895),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1905),
    [aux_sym_number_literal_token2] = ACTIONS(1907),
    [anon_sym_L_SQUOTE] = ACTIONS(1909),
    [anon_sym_u_SQUOTE] = ACTIONS(1909),
    [anon_sym_U_SQUOTE] = ACTIONS(1909),
    [anon_sym_u8_SQUOTE] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(1909),
    [anon_sym_L_DQUOTE] = ACTIONS(1911),
    [anon_sym_u_DQUOTE] = ACTIONS(1911),
    [anon_sym_U_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8_DQUOTE] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(1911),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1919),
    [anon_sym_R_DQUOTE] = ACTIONS(1921),
    [anon_sym_LR_DQUOTE] = ACTIONS(1921),
    [anon_sym_uR_DQUOTE] = ACTIONS(1921),
    [anon_sym_UR_DQUOTE] = ACTIONS(1921),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1921),
    [anon_sym_co_await] = ACTIONS(1923),
    [anon_sym_new] = ACTIONS(1925),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1484] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2437),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2832),
    [sym_char_literal] = STATE(2832),
    [sym_concatenated_string] = STATE(2831),
    [sym_string_literal] = STATE(1997),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(1998),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4244),
    [anon_sym_BANG] = ACTIONS(1889),
    [anon_sym_TILDE] = ACTIONS(1889),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_STAR] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(4238),
    [anon_sym_COLON_COLON] = ACTIONS(1891),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1887),
    [anon_sym_compl] = ACTIONS(1887),
    [anon_sym_DASH_DASH] = ACTIONS(4102),
    [anon_sym_PLUS_PLUS] = ACTIONS(4102),
    [anon_sym_sizeof] = ACTIONS(1895),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1905),
    [aux_sym_number_literal_token2] = ACTIONS(1907),
    [anon_sym_L_SQUOTE] = ACTIONS(1909),
    [anon_sym_u_SQUOTE] = ACTIONS(1909),
    [anon_sym_U_SQUOTE] = ACTIONS(1909),
    [anon_sym_u8_SQUOTE] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(1909),
    [anon_sym_L_DQUOTE] = ACTIONS(1911),
    [anon_sym_u_DQUOTE] = ACTIONS(1911),
    [anon_sym_U_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8_DQUOTE] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(1911),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1919),
    [anon_sym_R_DQUOTE] = ACTIONS(1921),
    [anon_sym_LR_DQUOTE] = ACTIONS(1921),
    [anon_sym_uR_DQUOTE] = ACTIONS(1921),
    [anon_sym_UR_DQUOTE] = ACTIONS(1921),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1921),
    [anon_sym_co_await] = ACTIONS(1923),
    [anon_sym_new] = ACTIONS(1925),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1485] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2807),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2832),
    [sym_char_literal] = STATE(2832),
    [sym_concatenated_string] = STATE(2831),
    [sym_string_literal] = STATE(1997),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(1998),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4244),
    [anon_sym_BANG] = ACTIONS(1889),
    [anon_sym_TILDE] = ACTIONS(1889),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_STAR] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(4238),
    [anon_sym_COLON_COLON] = ACTIONS(1891),
    [anon_sym_LBRACK] = ACTIONS(4484),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1887),
    [anon_sym_compl] = ACTIONS(1887),
    [anon_sym_DASH_DASH] = ACTIONS(4102),
    [anon_sym_PLUS_PLUS] = ACTIONS(4102),
    [anon_sym_sizeof] = ACTIONS(1895),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1905),
    [aux_sym_number_literal_token2] = ACTIONS(1907),
    [anon_sym_L_SQUOTE] = ACTIONS(1909),
    [anon_sym_u_SQUOTE] = ACTIONS(1909),
    [anon_sym_U_SQUOTE] = ACTIONS(1909),
    [anon_sym_u8_SQUOTE] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(1909),
    [anon_sym_L_DQUOTE] = ACTIONS(1911),
    [anon_sym_u_DQUOTE] = ACTIONS(1911),
    [anon_sym_U_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8_DQUOTE] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(1911),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1919),
    [anon_sym_R_DQUOTE] = ACTIONS(1921),
    [anon_sym_LR_DQUOTE] = ACTIONS(1921),
    [anon_sym_uR_DQUOTE] = ACTIONS(1921),
    [anon_sym_UR_DQUOTE] = ACTIONS(1921),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1921),
    [anon_sym_co_await] = ACTIONS(1923),
    [anon_sym_new] = ACTIONS(1925),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1486] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2437),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(3292),
    [sym_char_literal] = STATE(3292),
    [sym_concatenated_string] = STATE(3308),
    [sym_string_literal] = STATE(2343),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2348),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1969),
    [anon_sym_LPAREN2] = ACTIONS(4256),
    [anon_sym_BANG] = ACTIONS(1973),
    [anon_sym_TILDE] = ACTIONS(1973),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_STAR] = ACTIONS(4048),
    [anon_sym_AMP] = ACTIONS(4048),
    [anon_sym_COLON_COLON] = ACTIONS(1975),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1971),
    [anon_sym_compl] = ACTIONS(1971),
    [anon_sym_DASH_DASH] = ACTIONS(4096),
    [anon_sym_PLUS_PLUS] = ACTIONS(4096),
    [anon_sym_sizeof] = ACTIONS(1977),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1979),
    [aux_sym_number_literal_token2] = ACTIONS(1981),
    [anon_sym_L_SQUOTE] = ACTIONS(1983),
    [anon_sym_u_SQUOTE] = ACTIONS(1983),
    [anon_sym_U_SQUOTE] = ACTIONS(1983),
    [anon_sym_u8_SQUOTE] = ACTIONS(1983),
    [anon_sym_SQUOTE] = ACTIONS(1983),
    [anon_sym_L_DQUOTE] = ACTIONS(1985),
    [anon_sym_u_DQUOTE] = ACTIONS(1985),
    [anon_sym_U_DQUOTE] = ACTIONS(1985),
    [anon_sym_u8_DQUOTE] = ACTIONS(1985),
    [anon_sym_DQUOTE] = ACTIONS(1985),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1987),
    [anon_sym_R_DQUOTE] = ACTIONS(1989),
    [anon_sym_LR_DQUOTE] = ACTIONS(1989),
    [anon_sym_uR_DQUOTE] = ACTIONS(1989),
    [anon_sym_UR_DQUOTE] = ACTIONS(1989),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1989),
    [anon_sym_co_await] = ACTIONS(1991),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1487] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4377),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3679),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3679),
    [sym_call_expression] = STATE(3679),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3679),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3679),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3679),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3679),
    [sym_identifier] = ACTIONS(3538),
    [anon_sym_LPAREN2] = ACTIONS(4199),
    [anon_sym_BANG] = ACTIONS(3542),
    [anon_sym_TILDE] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3540),
    [anon_sym_PLUS] = ACTIONS(3540),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(3544),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3540),
    [anon_sym_compl] = ACTIONS(3540),
    [anon_sym_DASH_DASH] = ACTIONS(4122),
    [anon_sym_PLUS_PLUS] = ACTIONS(4122),
    [anon_sym_sizeof] = ACTIONS(3546),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3548),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3550),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1488] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4391),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3679),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3679),
    [sym_call_expression] = STATE(3679),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3679),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3679),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3679),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3679),
    [sym_identifier] = ACTIONS(3538),
    [anon_sym_LPAREN2] = ACTIONS(4199),
    [anon_sym_BANG] = ACTIONS(3542),
    [anon_sym_TILDE] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3540),
    [anon_sym_PLUS] = ACTIONS(3540),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(3544),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3540),
    [anon_sym_compl] = ACTIONS(3540),
    [anon_sym_DASH_DASH] = ACTIONS(4122),
    [anon_sym_PLUS_PLUS] = ACTIONS(4122),
    [anon_sym_sizeof] = ACTIONS(3546),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3548),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3550),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1489] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4389),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3679),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3679),
    [sym_call_expression] = STATE(3679),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3679),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3679),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3679),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3679),
    [sym_identifier] = ACTIONS(3538),
    [anon_sym_LPAREN2] = ACTIONS(4199),
    [anon_sym_BANG] = ACTIONS(3542),
    [anon_sym_TILDE] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3540),
    [anon_sym_PLUS] = ACTIONS(3540),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(3544),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3540),
    [anon_sym_compl] = ACTIONS(3540),
    [anon_sym_DASH_DASH] = ACTIONS(4122),
    [anon_sym_PLUS_PLUS] = ACTIONS(4122),
    [anon_sym_sizeof] = ACTIONS(3546),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3548),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3550),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1490] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4388),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3679),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3679),
    [sym_call_expression] = STATE(3679),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3679),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3679),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3679),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3679),
    [sym_identifier] = ACTIONS(3538),
    [anon_sym_LPAREN2] = ACTIONS(4199),
    [anon_sym_BANG] = ACTIONS(3542),
    [anon_sym_TILDE] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3540),
    [anon_sym_PLUS] = ACTIONS(3540),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(3544),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3540),
    [anon_sym_compl] = ACTIONS(3540),
    [anon_sym_DASH_DASH] = ACTIONS(4122),
    [anon_sym_PLUS_PLUS] = ACTIONS(4122),
    [anon_sym_sizeof] = ACTIONS(3546),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3548),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3550),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1491] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4386),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3679),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3679),
    [sym_call_expression] = STATE(3679),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3679),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3679),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3679),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3679),
    [sym_identifier] = ACTIONS(3538),
    [anon_sym_LPAREN2] = ACTIONS(4199),
    [anon_sym_BANG] = ACTIONS(3542),
    [anon_sym_TILDE] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3540),
    [anon_sym_PLUS] = ACTIONS(3540),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(3544),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3540),
    [anon_sym_compl] = ACTIONS(3540),
    [anon_sym_DASH_DASH] = ACTIONS(4122),
    [anon_sym_PLUS_PLUS] = ACTIONS(4122),
    [anon_sym_sizeof] = ACTIONS(3546),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3548),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3550),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1492] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4383),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3679),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3679),
    [sym_call_expression] = STATE(3679),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3679),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3679),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3679),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3679),
    [sym_identifier] = ACTIONS(3538),
    [anon_sym_LPAREN2] = ACTIONS(4199),
    [anon_sym_BANG] = ACTIONS(3542),
    [anon_sym_TILDE] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3540),
    [anon_sym_PLUS] = ACTIONS(3540),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(3544),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3540),
    [anon_sym_compl] = ACTIONS(3540),
    [anon_sym_DASH_DASH] = ACTIONS(4122),
    [anon_sym_PLUS_PLUS] = ACTIONS(4122),
    [anon_sym_sizeof] = ACTIONS(3546),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3548),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3550),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1493] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4381),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3679),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3679),
    [sym_call_expression] = STATE(3679),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3679),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3679),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3679),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3679),
    [sym_identifier] = ACTIONS(3538),
    [anon_sym_LPAREN2] = ACTIONS(4199),
    [anon_sym_BANG] = ACTIONS(3542),
    [anon_sym_TILDE] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3540),
    [anon_sym_PLUS] = ACTIONS(3540),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(3544),
    [anon_sym_LBRACK] = ACTIONS(4486),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3540),
    [anon_sym_compl] = ACTIONS(3540),
    [anon_sym_DASH_DASH] = ACTIONS(4122),
    [anon_sym_PLUS_PLUS] = ACTIONS(4122),
    [anon_sym_sizeof] = ACTIONS(3546),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3548),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3550),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1494] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2787),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2832),
    [sym_char_literal] = STATE(2832),
    [sym_concatenated_string] = STATE(2831),
    [sym_string_literal] = STATE(1997),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(1998),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4244),
    [anon_sym_BANG] = ACTIONS(1889),
    [anon_sym_TILDE] = ACTIONS(1889),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_STAR] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(4238),
    [anon_sym_COLON_COLON] = ACTIONS(1891),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1887),
    [anon_sym_compl] = ACTIONS(1887),
    [anon_sym_DASH_DASH] = ACTIONS(4102),
    [anon_sym_PLUS_PLUS] = ACTIONS(4102),
    [anon_sym_sizeof] = ACTIONS(1895),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1905),
    [aux_sym_number_literal_token2] = ACTIONS(1907),
    [anon_sym_L_SQUOTE] = ACTIONS(1909),
    [anon_sym_u_SQUOTE] = ACTIONS(1909),
    [anon_sym_U_SQUOTE] = ACTIONS(1909),
    [anon_sym_u8_SQUOTE] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(1909),
    [anon_sym_L_DQUOTE] = ACTIONS(1911),
    [anon_sym_u_DQUOTE] = ACTIONS(1911),
    [anon_sym_U_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8_DQUOTE] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(1911),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1919),
    [anon_sym_R_DQUOTE] = ACTIONS(1921),
    [anon_sym_LR_DQUOTE] = ACTIONS(1921),
    [anon_sym_uR_DQUOTE] = ACTIONS(1921),
    [anon_sym_UR_DQUOTE] = ACTIONS(1921),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1921),
    [anon_sym_co_await] = ACTIONS(1923),
    [anon_sym_new] = ACTIONS(1925),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1495] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2751),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2832),
    [sym_char_literal] = STATE(2832),
    [sym_concatenated_string] = STATE(2831),
    [sym_string_literal] = STATE(1997),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(1998),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4244),
    [anon_sym_BANG] = ACTIONS(1889),
    [anon_sym_TILDE] = ACTIONS(1889),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_STAR] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(4238),
    [anon_sym_COLON_COLON] = ACTIONS(1891),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1887),
    [anon_sym_compl] = ACTIONS(1887),
    [anon_sym_DASH_DASH] = ACTIONS(4102),
    [anon_sym_PLUS_PLUS] = ACTIONS(4102),
    [anon_sym_sizeof] = ACTIONS(1895),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1905),
    [aux_sym_number_literal_token2] = ACTIONS(1907),
    [anon_sym_L_SQUOTE] = ACTIONS(1909),
    [anon_sym_u_SQUOTE] = ACTIONS(1909),
    [anon_sym_U_SQUOTE] = ACTIONS(1909),
    [anon_sym_u8_SQUOTE] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(1909),
    [anon_sym_L_DQUOTE] = ACTIONS(1911),
    [anon_sym_u_DQUOTE] = ACTIONS(1911),
    [anon_sym_U_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8_DQUOTE] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(1911),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1919),
    [anon_sym_R_DQUOTE] = ACTIONS(1921),
    [anon_sym_LR_DQUOTE] = ACTIONS(1921),
    [anon_sym_uR_DQUOTE] = ACTIONS(1921),
    [anon_sym_UR_DQUOTE] = ACTIONS(1921),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1921),
    [anon_sym_co_await] = ACTIONS(1923),
    [anon_sym_new] = ACTIONS(1925),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1496] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4582),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1497] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2778),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2832),
    [sym_char_literal] = STATE(2832),
    [sym_concatenated_string] = STATE(2831),
    [sym_string_literal] = STATE(1997),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(1998),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4244),
    [anon_sym_BANG] = ACTIONS(1889),
    [anon_sym_TILDE] = ACTIONS(1889),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_STAR] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(4238),
    [anon_sym_COLON_COLON] = ACTIONS(1891),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1887),
    [anon_sym_compl] = ACTIONS(1887),
    [anon_sym_DASH_DASH] = ACTIONS(4102),
    [anon_sym_PLUS_PLUS] = ACTIONS(4102),
    [anon_sym_sizeof] = ACTIONS(1895),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1905),
    [aux_sym_number_literal_token2] = ACTIONS(1907),
    [anon_sym_L_SQUOTE] = ACTIONS(1909),
    [anon_sym_u_SQUOTE] = ACTIONS(1909),
    [anon_sym_U_SQUOTE] = ACTIONS(1909),
    [anon_sym_u8_SQUOTE] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(1909),
    [anon_sym_L_DQUOTE] = ACTIONS(1911),
    [anon_sym_u_DQUOTE] = ACTIONS(1911),
    [anon_sym_U_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8_DQUOTE] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(1911),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1919),
    [anon_sym_R_DQUOTE] = ACTIONS(1921),
    [anon_sym_LR_DQUOTE] = ACTIONS(1921),
    [anon_sym_uR_DQUOTE] = ACTIONS(1921),
    [anon_sym_UR_DQUOTE] = ACTIONS(1921),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1921),
    [anon_sym_co_await] = ACTIONS(1923),
    [anon_sym_new] = ACTIONS(1925),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1498] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(3063),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(3292),
    [sym_char_literal] = STATE(3292),
    [sym_concatenated_string] = STATE(3308),
    [sym_string_literal] = STATE(2343),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2348),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1969),
    [anon_sym_LPAREN2] = ACTIONS(4256),
    [anon_sym_BANG] = ACTIONS(1973),
    [anon_sym_TILDE] = ACTIONS(1973),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_STAR] = ACTIONS(4048),
    [anon_sym_AMP] = ACTIONS(4048),
    [anon_sym_COLON_COLON] = ACTIONS(1975),
    [anon_sym_LBRACK] = ACTIONS(4488),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1971),
    [anon_sym_compl] = ACTIONS(1971),
    [anon_sym_DASH_DASH] = ACTIONS(4096),
    [anon_sym_PLUS_PLUS] = ACTIONS(4096),
    [anon_sym_sizeof] = ACTIONS(1977),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1979),
    [aux_sym_number_literal_token2] = ACTIONS(1981),
    [anon_sym_L_SQUOTE] = ACTIONS(1983),
    [anon_sym_u_SQUOTE] = ACTIONS(1983),
    [anon_sym_U_SQUOTE] = ACTIONS(1983),
    [anon_sym_u8_SQUOTE] = ACTIONS(1983),
    [anon_sym_SQUOTE] = ACTIONS(1983),
    [anon_sym_L_DQUOTE] = ACTIONS(1985),
    [anon_sym_u_DQUOTE] = ACTIONS(1985),
    [anon_sym_U_DQUOTE] = ACTIONS(1985),
    [anon_sym_u8_DQUOTE] = ACTIONS(1985),
    [anon_sym_DQUOTE] = ACTIONS(1985),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1987),
    [anon_sym_R_DQUOTE] = ACTIONS(1989),
    [anon_sym_LR_DQUOTE] = ACTIONS(1989),
    [anon_sym_uR_DQUOTE] = ACTIONS(1989),
    [anon_sym_UR_DQUOTE] = ACTIONS(1989),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1989),
    [anon_sym_co_await] = ACTIONS(1991),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1499] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4520),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3679),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3679),
    [sym_call_expression] = STATE(3679),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3679),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3679),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3679),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3679),
    [sym_identifier] = ACTIONS(3538),
    [anon_sym_LPAREN2] = ACTIONS(4199),
    [anon_sym_BANG] = ACTIONS(3542),
    [anon_sym_TILDE] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3540),
    [anon_sym_PLUS] = ACTIONS(3540),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(3544),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3540),
    [anon_sym_compl] = ACTIONS(3540),
    [anon_sym_DASH_DASH] = ACTIONS(4122),
    [anon_sym_PLUS_PLUS] = ACTIONS(4122),
    [anon_sym_sizeof] = ACTIONS(3546),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3548),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3550),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1500] = {
    [sym_primitive_type] = STATE(6613),
    [sym__expression] = STATE(3225),
    [sym__expression_not_binary] = STATE(3637),
    [sym__string] = STATE(3637),
    [sym_conditional_expression] = STATE(3637),
    [sym_assignment_expression] = STATE(3637),
    [sym_pointer_expression] = STATE(3637),
    [sym_unary_expression] = STATE(3637),
    [sym_binary_expression] = STATE(3637),
    [sym_update_expression] = STATE(3637),
    [sym_cast_expression] = STATE(3637),
    [sym_sizeof_expression] = STATE(3637),
    [sym_alignof_expression] = STATE(3637),
    [sym_offsetof_expression] = STATE(3637),
    [sym_generic_expression] = STATE(3637),
    [sym_subscript_expression] = STATE(3637),
    [sym_call_expression] = STATE(3637),
    [sym_gnu_asm_expression] = STATE(3637),
    [sym_field_expression] = STATE(3637),
    [sym_compound_literal_expression] = STATE(3637),
    [sym_parenthesized_expression] = STATE(3637),
    [sym_number_literal] = STATE(3416),
    [sym_char_literal] = STATE(3416),
    [sym_concatenated_string] = STATE(3415),
    [sym_string_literal] = STATE(2430),
    [sym_null] = STATE(3637),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7434),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3637),
    [sym_raw_string_literal] = STATE(2419),
    [sym_co_await_expression] = STATE(3637),
    [sym_new_expression] = STATE(3637),
    [sym_delete_expression] = STATE(3637),
    [sym_requires_clause] = STATE(3637),
    [sym_requires_expression] = STATE(3637),
    [sym_lambda_expression] = STATE(3637),
    [sym_lambda_capture_specifier] = STATE(5725),
    [sym_fold_expression] = STATE(3637),
    [sym_parameter_pack_expansion] = STATE(3637),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5512),
    [sym_qualified_identifier] = STATE(3637),
    [sym_qualified_type_identifier] = STATE(7434),
    [sym_user_defined_literal] = STATE(3637),
    [sym_identifier] = ACTIONS(2228),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_BANG] = ACTIONS(2232),
    [anon_sym_TILDE] = ACTIONS(2232),
    [anon_sym_DASH] = ACTIONS(2230),
    [anon_sym_PLUS] = ACTIONS(2230),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON_COLON] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2230),
    [anon_sym_compl] = ACTIONS(2230),
    [anon_sym_DASH_DASH] = ACTIONS(4112),
    [anon_sym_PLUS_PLUS] = ACTIONS(4112),
    [anon_sym_sizeof] = ACTIONS(2238),
    [anon_sym___alignof__] = ACTIONS(2240),
    [anon_sym___alignof] = ACTIONS(2240),
    [anon_sym__alignof] = ACTIONS(2240),
    [anon_sym_alignof] = ACTIONS(2240),
    [anon_sym__Alignof] = ACTIONS(2240),
    [anon_sym_offsetof] = ACTIONS(2242),
    [anon_sym__Generic] = ACTIONS(2244),
    [anon_sym_asm] = ACTIONS(2246),
    [anon_sym___asm__] = ACTIONS(2246),
    [aux_sym_number_literal_token1] = ACTIONS(2248),
    [aux_sym_number_literal_token2] = ACTIONS(2250),
    [anon_sym_L_SQUOTE] = ACTIONS(2252),
    [anon_sym_u_SQUOTE] = ACTIONS(2252),
    [anon_sym_U_SQUOTE] = ACTIONS(2252),
    [anon_sym_u8_SQUOTE] = ACTIONS(2252),
    [anon_sym_SQUOTE] = ACTIONS(2252),
    [anon_sym_L_DQUOTE] = ACTIONS(2254),
    [anon_sym_u_DQUOTE] = ACTIONS(2254),
    [anon_sym_U_DQUOTE] = ACTIONS(2254),
    [anon_sym_u8_DQUOTE] = ACTIONS(2254),
    [anon_sym_DQUOTE] = ACTIONS(2254),
    [sym_true] = ACTIONS(2256),
    [sym_false] = ACTIONS(2256),
    [anon_sym_NULL] = ACTIONS(2258),
    [anon_sym_nullptr] = ACTIONS(2258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2260),
    [anon_sym_R_DQUOTE] = ACTIONS(2262),
    [anon_sym_LR_DQUOTE] = ACTIONS(2262),
    [anon_sym_uR_DQUOTE] = ACTIONS(2262),
    [anon_sym_UR_DQUOTE] = ACTIONS(2262),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2262),
    [anon_sym_co_await] = ACTIONS(2264),
    [anon_sym_new] = ACTIONS(2266),
    [anon_sym_requires] = ACTIONS(2268),
    [sym_this] = ACTIONS(2256),
  },
  [1501] = {
    [sym_primitive_type] = STATE(6848),
    [sym__expression] = STATE(3078),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7357),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(7357),
    [sym_user_defined_literal] = STATE(3526),
    [sym_identifier] = ACTIONS(1965),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [1502] = {
    [sym_primitive_type] = STATE(6613),
    [sym__expression] = STATE(3224),
    [sym__expression_not_binary] = STATE(3637),
    [sym__string] = STATE(3637),
    [sym_conditional_expression] = STATE(3637),
    [sym_assignment_expression] = STATE(3637),
    [sym_pointer_expression] = STATE(3637),
    [sym_unary_expression] = STATE(3637),
    [sym_binary_expression] = STATE(3637),
    [sym_update_expression] = STATE(3637),
    [sym_cast_expression] = STATE(3637),
    [sym_sizeof_expression] = STATE(3637),
    [sym_alignof_expression] = STATE(3637),
    [sym_offsetof_expression] = STATE(3637),
    [sym_generic_expression] = STATE(3637),
    [sym_subscript_expression] = STATE(3637),
    [sym_call_expression] = STATE(3637),
    [sym_gnu_asm_expression] = STATE(3637),
    [sym_field_expression] = STATE(3637),
    [sym_compound_literal_expression] = STATE(3637),
    [sym_parenthesized_expression] = STATE(3637),
    [sym_number_literal] = STATE(3416),
    [sym_char_literal] = STATE(3416),
    [sym_concatenated_string] = STATE(3415),
    [sym_string_literal] = STATE(2430),
    [sym_null] = STATE(3637),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7434),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3637),
    [sym_raw_string_literal] = STATE(2419),
    [sym_co_await_expression] = STATE(3637),
    [sym_new_expression] = STATE(3637),
    [sym_delete_expression] = STATE(3637),
    [sym_requires_clause] = STATE(3637),
    [sym_requires_expression] = STATE(3637),
    [sym_lambda_expression] = STATE(3637),
    [sym_lambda_capture_specifier] = STATE(5725),
    [sym_fold_expression] = STATE(3637),
    [sym_parameter_pack_expansion] = STATE(3637),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5512),
    [sym_qualified_identifier] = STATE(3637),
    [sym_qualified_type_identifier] = STATE(7434),
    [sym_user_defined_literal] = STATE(3637),
    [sym_identifier] = ACTIONS(2228),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_BANG] = ACTIONS(2232),
    [anon_sym_TILDE] = ACTIONS(2232),
    [anon_sym_DASH] = ACTIONS(2230),
    [anon_sym_PLUS] = ACTIONS(2230),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON_COLON] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2230),
    [anon_sym_compl] = ACTIONS(2230),
    [anon_sym_DASH_DASH] = ACTIONS(4112),
    [anon_sym_PLUS_PLUS] = ACTIONS(4112),
    [anon_sym_sizeof] = ACTIONS(2238),
    [anon_sym___alignof__] = ACTIONS(2240),
    [anon_sym___alignof] = ACTIONS(2240),
    [anon_sym__alignof] = ACTIONS(2240),
    [anon_sym_alignof] = ACTIONS(2240),
    [anon_sym__Alignof] = ACTIONS(2240),
    [anon_sym_offsetof] = ACTIONS(2242),
    [anon_sym__Generic] = ACTIONS(2244),
    [anon_sym_asm] = ACTIONS(2246),
    [anon_sym___asm__] = ACTIONS(2246),
    [aux_sym_number_literal_token1] = ACTIONS(2248),
    [aux_sym_number_literal_token2] = ACTIONS(2250),
    [anon_sym_L_SQUOTE] = ACTIONS(2252),
    [anon_sym_u_SQUOTE] = ACTIONS(2252),
    [anon_sym_U_SQUOTE] = ACTIONS(2252),
    [anon_sym_u8_SQUOTE] = ACTIONS(2252),
    [anon_sym_SQUOTE] = ACTIONS(2252),
    [anon_sym_L_DQUOTE] = ACTIONS(2254),
    [anon_sym_u_DQUOTE] = ACTIONS(2254),
    [anon_sym_U_DQUOTE] = ACTIONS(2254),
    [anon_sym_u8_DQUOTE] = ACTIONS(2254),
    [anon_sym_DQUOTE] = ACTIONS(2254),
    [sym_true] = ACTIONS(2256),
    [sym_false] = ACTIONS(2256),
    [anon_sym_NULL] = ACTIONS(2258),
    [anon_sym_nullptr] = ACTIONS(2258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2260),
    [anon_sym_R_DQUOTE] = ACTIONS(2262),
    [anon_sym_LR_DQUOTE] = ACTIONS(2262),
    [anon_sym_uR_DQUOTE] = ACTIONS(2262),
    [anon_sym_UR_DQUOTE] = ACTIONS(2262),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2262),
    [anon_sym_co_await] = ACTIONS(2264),
    [anon_sym_new] = ACTIONS(2266),
    [anon_sym_requires] = ACTIONS(2268),
    [sym_this] = ACTIONS(2256),
  },
  [1503] = {
    [sym_primitive_type] = STATE(6613),
    [sym__expression] = STATE(3223),
    [sym__expression_not_binary] = STATE(3637),
    [sym__string] = STATE(3637),
    [sym_conditional_expression] = STATE(3637),
    [sym_assignment_expression] = STATE(3637),
    [sym_pointer_expression] = STATE(3637),
    [sym_unary_expression] = STATE(3637),
    [sym_binary_expression] = STATE(3637),
    [sym_update_expression] = STATE(3637),
    [sym_cast_expression] = STATE(3637),
    [sym_sizeof_expression] = STATE(3637),
    [sym_alignof_expression] = STATE(3637),
    [sym_offsetof_expression] = STATE(3637),
    [sym_generic_expression] = STATE(3637),
    [sym_subscript_expression] = STATE(3637),
    [sym_call_expression] = STATE(3637),
    [sym_gnu_asm_expression] = STATE(3637),
    [sym_field_expression] = STATE(3637),
    [sym_compound_literal_expression] = STATE(3637),
    [sym_parenthesized_expression] = STATE(3637),
    [sym_number_literal] = STATE(3416),
    [sym_char_literal] = STATE(3416),
    [sym_concatenated_string] = STATE(3415),
    [sym_string_literal] = STATE(2430),
    [sym_null] = STATE(3637),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7434),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3637),
    [sym_raw_string_literal] = STATE(2419),
    [sym_co_await_expression] = STATE(3637),
    [sym_new_expression] = STATE(3637),
    [sym_delete_expression] = STATE(3637),
    [sym_requires_clause] = STATE(3637),
    [sym_requires_expression] = STATE(3637),
    [sym_lambda_expression] = STATE(3637),
    [sym_lambda_capture_specifier] = STATE(5725),
    [sym_fold_expression] = STATE(3637),
    [sym_parameter_pack_expansion] = STATE(3637),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5512),
    [sym_qualified_identifier] = STATE(3637),
    [sym_qualified_type_identifier] = STATE(7434),
    [sym_user_defined_literal] = STATE(3637),
    [sym_identifier] = ACTIONS(2228),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_BANG] = ACTIONS(2232),
    [anon_sym_TILDE] = ACTIONS(2232),
    [anon_sym_DASH] = ACTIONS(2230),
    [anon_sym_PLUS] = ACTIONS(2230),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON_COLON] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2230),
    [anon_sym_compl] = ACTIONS(2230),
    [anon_sym_DASH_DASH] = ACTIONS(4112),
    [anon_sym_PLUS_PLUS] = ACTIONS(4112),
    [anon_sym_sizeof] = ACTIONS(2238),
    [anon_sym___alignof__] = ACTIONS(2240),
    [anon_sym___alignof] = ACTIONS(2240),
    [anon_sym__alignof] = ACTIONS(2240),
    [anon_sym_alignof] = ACTIONS(2240),
    [anon_sym__Alignof] = ACTIONS(2240),
    [anon_sym_offsetof] = ACTIONS(2242),
    [anon_sym__Generic] = ACTIONS(2244),
    [anon_sym_asm] = ACTIONS(2246),
    [anon_sym___asm__] = ACTIONS(2246),
    [aux_sym_number_literal_token1] = ACTIONS(2248),
    [aux_sym_number_literal_token2] = ACTIONS(2250),
    [anon_sym_L_SQUOTE] = ACTIONS(2252),
    [anon_sym_u_SQUOTE] = ACTIONS(2252),
    [anon_sym_U_SQUOTE] = ACTIONS(2252),
    [anon_sym_u8_SQUOTE] = ACTIONS(2252),
    [anon_sym_SQUOTE] = ACTIONS(2252),
    [anon_sym_L_DQUOTE] = ACTIONS(2254),
    [anon_sym_u_DQUOTE] = ACTIONS(2254),
    [anon_sym_U_DQUOTE] = ACTIONS(2254),
    [anon_sym_u8_DQUOTE] = ACTIONS(2254),
    [anon_sym_DQUOTE] = ACTIONS(2254),
    [sym_true] = ACTIONS(2256),
    [sym_false] = ACTIONS(2256),
    [anon_sym_NULL] = ACTIONS(2258),
    [anon_sym_nullptr] = ACTIONS(2258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2260),
    [anon_sym_R_DQUOTE] = ACTIONS(2262),
    [anon_sym_LR_DQUOTE] = ACTIONS(2262),
    [anon_sym_uR_DQUOTE] = ACTIONS(2262),
    [anon_sym_UR_DQUOTE] = ACTIONS(2262),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2262),
    [anon_sym_co_await] = ACTIONS(2264),
    [anon_sym_new] = ACTIONS(2266),
    [anon_sym_requires] = ACTIONS(2268),
    [sym_this] = ACTIONS(2256),
  },
  [1504] = {
    [sym_primitive_type] = STATE(6613),
    [sym__expression] = STATE(3221),
    [sym__expression_not_binary] = STATE(3637),
    [sym__string] = STATE(3637),
    [sym_conditional_expression] = STATE(3637),
    [sym_assignment_expression] = STATE(3637),
    [sym_pointer_expression] = STATE(3637),
    [sym_unary_expression] = STATE(3637),
    [sym_binary_expression] = STATE(3637),
    [sym_update_expression] = STATE(3637),
    [sym_cast_expression] = STATE(3637),
    [sym_sizeof_expression] = STATE(3637),
    [sym_alignof_expression] = STATE(3637),
    [sym_offsetof_expression] = STATE(3637),
    [sym_generic_expression] = STATE(3637),
    [sym_subscript_expression] = STATE(3637),
    [sym_call_expression] = STATE(3637),
    [sym_gnu_asm_expression] = STATE(3637),
    [sym_field_expression] = STATE(3637),
    [sym_compound_literal_expression] = STATE(3637),
    [sym_parenthesized_expression] = STATE(3637),
    [sym_number_literal] = STATE(3416),
    [sym_char_literal] = STATE(3416),
    [sym_concatenated_string] = STATE(3415),
    [sym_string_literal] = STATE(2430),
    [sym_null] = STATE(3637),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7434),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3637),
    [sym_raw_string_literal] = STATE(2419),
    [sym_co_await_expression] = STATE(3637),
    [sym_new_expression] = STATE(3637),
    [sym_delete_expression] = STATE(3637),
    [sym_requires_clause] = STATE(3637),
    [sym_requires_expression] = STATE(3637),
    [sym_lambda_expression] = STATE(3637),
    [sym_lambda_capture_specifier] = STATE(5725),
    [sym_fold_expression] = STATE(3637),
    [sym_parameter_pack_expansion] = STATE(3637),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5512),
    [sym_qualified_identifier] = STATE(3637),
    [sym_qualified_type_identifier] = STATE(7434),
    [sym_user_defined_literal] = STATE(3637),
    [sym_identifier] = ACTIONS(2228),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_BANG] = ACTIONS(2232),
    [anon_sym_TILDE] = ACTIONS(2232),
    [anon_sym_DASH] = ACTIONS(2230),
    [anon_sym_PLUS] = ACTIONS(2230),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON_COLON] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2230),
    [anon_sym_compl] = ACTIONS(2230),
    [anon_sym_DASH_DASH] = ACTIONS(4112),
    [anon_sym_PLUS_PLUS] = ACTIONS(4112),
    [anon_sym_sizeof] = ACTIONS(2238),
    [anon_sym___alignof__] = ACTIONS(2240),
    [anon_sym___alignof] = ACTIONS(2240),
    [anon_sym__alignof] = ACTIONS(2240),
    [anon_sym_alignof] = ACTIONS(2240),
    [anon_sym__Alignof] = ACTIONS(2240),
    [anon_sym_offsetof] = ACTIONS(2242),
    [anon_sym__Generic] = ACTIONS(2244),
    [anon_sym_asm] = ACTIONS(2246),
    [anon_sym___asm__] = ACTIONS(2246),
    [aux_sym_number_literal_token1] = ACTIONS(2248),
    [aux_sym_number_literal_token2] = ACTIONS(2250),
    [anon_sym_L_SQUOTE] = ACTIONS(2252),
    [anon_sym_u_SQUOTE] = ACTIONS(2252),
    [anon_sym_U_SQUOTE] = ACTIONS(2252),
    [anon_sym_u8_SQUOTE] = ACTIONS(2252),
    [anon_sym_SQUOTE] = ACTIONS(2252),
    [anon_sym_L_DQUOTE] = ACTIONS(2254),
    [anon_sym_u_DQUOTE] = ACTIONS(2254),
    [anon_sym_U_DQUOTE] = ACTIONS(2254),
    [anon_sym_u8_DQUOTE] = ACTIONS(2254),
    [anon_sym_DQUOTE] = ACTIONS(2254),
    [sym_true] = ACTIONS(2256),
    [sym_false] = ACTIONS(2256),
    [anon_sym_NULL] = ACTIONS(2258),
    [anon_sym_nullptr] = ACTIONS(2258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2260),
    [anon_sym_R_DQUOTE] = ACTIONS(2262),
    [anon_sym_LR_DQUOTE] = ACTIONS(2262),
    [anon_sym_uR_DQUOTE] = ACTIONS(2262),
    [anon_sym_UR_DQUOTE] = ACTIONS(2262),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2262),
    [anon_sym_co_await] = ACTIONS(2264),
    [anon_sym_new] = ACTIONS(2266),
    [anon_sym_requires] = ACTIONS(2268),
    [sym_this] = ACTIONS(2256),
  },
  [1505] = {
    [sym_primitive_type] = STATE(6613),
    [sym__expression] = STATE(3220),
    [sym__expression_not_binary] = STATE(3637),
    [sym__string] = STATE(3637),
    [sym_conditional_expression] = STATE(3637),
    [sym_assignment_expression] = STATE(3637),
    [sym_pointer_expression] = STATE(3637),
    [sym_unary_expression] = STATE(3637),
    [sym_binary_expression] = STATE(3637),
    [sym_update_expression] = STATE(3637),
    [sym_cast_expression] = STATE(3637),
    [sym_sizeof_expression] = STATE(3637),
    [sym_alignof_expression] = STATE(3637),
    [sym_offsetof_expression] = STATE(3637),
    [sym_generic_expression] = STATE(3637),
    [sym_subscript_expression] = STATE(3637),
    [sym_call_expression] = STATE(3637),
    [sym_gnu_asm_expression] = STATE(3637),
    [sym_field_expression] = STATE(3637),
    [sym_compound_literal_expression] = STATE(3637),
    [sym_parenthesized_expression] = STATE(3637),
    [sym_number_literal] = STATE(3416),
    [sym_char_literal] = STATE(3416),
    [sym_concatenated_string] = STATE(3415),
    [sym_string_literal] = STATE(2430),
    [sym_null] = STATE(3637),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7434),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3637),
    [sym_raw_string_literal] = STATE(2419),
    [sym_co_await_expression] = STATE(3637),
    [sym_new_expression] = STATE(3637),
    [sym_delete_expression] = STATE(3637),
    [sym_requires_clause] = STATE(3637),
    [sym_requires_expression] = STATE(3637),
    [sym_lambda_expression] = STATE(3637),
    [sym_lambda_capture_specifier] = STATE(5725),
    [sym_fold_expression] = STATE(3637),
    [sym_parameter_pack_expansion] = STATE(3637),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5512),
    [sym_qualified_identifier] = STATE(3637),
    [sym_qualified_type_identifier] = STATE(7434),
    [sym_user_defined_literal] = STATE(3637),
    [sym_identifier] = ACTIONS(2228),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_BANG] = ACTIONS(2232),
    [anon_sym_TILDE] = ACTIONS(2232),
    [anon_sym_DASH] = ACTIONS(2230),
    [anon_sym_PLUS] = ACTIONS(2230),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON_COLON] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2230),
    [anon_sym_compl] = ACTIONS(2230),
    [anon_sym_DASH_DASH] = ACTIONS(4112),
    [anon_sym_PLUS_PLUS] = ACTIONS(4112),
    [anon_sym_sizeof] = ACTIONS(2238),
    [anon_sym___alignof__] = ACTIONS(2240),
    [anon_sym___alignof] = ACTIONS(2240),
    [anon_sym__alignof] = ACTIONS(2240),
    [anon_sym_alignof] = ACTIONS(2240),
    [anon_sym__Alignof] = ACTIONS(2240),
    [anon_sym_offsetof] = ACTIONS(2242),
    [anon_sym__Generic] = ACTIONS(2244),
    [anon_sym_asm] = ACTIONS(2246),
    [anon_sym___asm__] = ACTIONS(2246),
    [aux_sym_number_literal_token1] = ACTIONS(2248),
    [aux_sym_number_literal_token2] = ACTIONS(2250),
    [anon_sym_L_SQUOTE] = ACTIONS(2252),
    [anon_sym_u_SQUOTE] = ACTIONS(2252),
    [anon_sym_U_SQUOTE] = ACTIONS(2252),
    [anon_sym_u8_SQUOTE] = ACTIONS(2252),
    [anon_sym_SQUOTE] = ACTIONS(2252),
    [anon_sym_L_DQUOTE] = ACTIONS(2254),
    [anon_sym_u_DQUOTE] = ACTIONS(2254),
    [anon_sym_U_DQUOTE] = ACTIONS(2254),
    [anon_sym_u8_DQUOTE] = ACTIONS(2254),
    [anon_sym_DQUOTE] = ACTIONS(2254),
    [sym_true] = ACTIONS(2256),
    [sym_false] = ACTIONS(2256),
    [anon_sym_NULL] = ACTIONS(2258),
    [anon_sym_nullptr] = ACTIONS(2258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2260),
    [anon_sym_R_DQUOTE] = ACTIONS(2262),
    [anon_sym_LR_DQUOTE] = ACTIONS(2262),
    [anon_sym_uR_DQUOTE] = ACTIONS(2262),
    [anon_sym_UR_DQUOTE] = ACTIONS(2262),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2262),
    [anon_sym_co_await] = ACTIONS(2264),
    [anon_sym_new] = ACTIONS(2266),
    [anon_sym_requires] = ACTIONS(2268),
    [sym_this] = ACTIONS(2256),
  },
  [1506] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(3218),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4226),
    [anon_sym_BANG] = ACTIONS(2218),
    [anon_sym_TILDE] = ACTIONS(2218),
    [anon_sym_DASH] = ACTIONS(2216),
    [anon_sym_PLUS] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(2220),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2216),
    [anon_sym_compl] = ACTIONS(2216),
    [anon_sym_DASH_DASH] = ACTIONS(4136),
    [anon_sym_PLUS_PLUS] = ACTIONS(4136),
    [anon_sym_sizeof] = ACTIONS(2222),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2224),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(2226),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1507] = {
    [sym_primitive_type] = STATE(6613),
    [sym__expression] = STATE(3219),
    [sym__expression_not_binary] = STATE(3637),
    [sym__string] = STATE(3637),
    [sym_conditional_expression] = STATE(3637),
    [sym_assignment_expression] = STATE(3637),
    [sym_pointer_expression] = STATE(3637),
    [sym_unary_expression] = STATE(3637),
    [sym_binary_expression] = STATE(3637),
    [sym_update_expression] = STATE(3637),
    [sym_cast_expression] = STATE(3637),
    [sym_sizeof_expression] = STATE(3637),
    [sym_alignof_expression] = STATE(3637),
    [sym_offsetof_expression] = STATE(3637),
    [sym_generic_expression] = STATE(3637),
    [sym_subscript_expression] = STATE(3637),
    [sym_call_expression] = STATE(3637),
    [sym_gnu_asm_expression] = STATE(3637),
    [sym_field_expression] = STATE(3637),
    [sym_compound_literal_expression] = STATE(3637),
    [sym_parenthesized_expression] = STATE(3637),
    [sym_number_literal] = STATE(3416),
    [sym_char_literal] = STATE(3416),
    [sym_concatenated_string] = STATE(3415),
    [sym_string_literal] = STATE(2430),
    [sym_null] = STATE(3637),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7434),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3637),
    [sym_raw_string_literal] = STATE(2419),
    [sym_co_await_expression] = STATE(3637),
    [sym_new_expression] = STATE(3637),
    [sym_delete_expression] = STATE(3637),
    [sym_requires_clause] = STATE(3637),
    [sym_requires_expression] = STATE(3637),
    [sym_lambda_expression] = STATE(3637),
    [sym_lambda_capture_specifier] = STATE(5725),
    [sym_fold_expression] = STATE(3637),
    [sym_parameter_pack_expansion] = STATE(3637),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5512),
    [sym_qualified_identifier] = STATE(3637),
    [sym_qualified_type_identifier] = STATE(7434),
    [sym_user_defined_literal] = STATE(3637),
    [sym_identifier] = ACTIONS(2228),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_BANG] = ACTIONS(2232),
    [anon_sym_TILDE] = ACTIONS(2232),
    [anon_sym_DASH] = ACTIONS(2230),
    [anon_sym_PLUS] = ACTIONS(2230),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON_COLON] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2230),
    [anon_sym_compl] = ACTIONS(2230),
    [anon_sym_DASH_DASH] = ACTIONS(4112),
    [anon_sym_PLUS_PLUS] = ACTIONS(4112),
    [anon_sym_sizeof] = ACTIONS(2238),
    [anon_sym___alignof__] = ACTIONS(2240),
    [anon_sym___alignof] = ACTIONS(2240),
    [anon_sym__alignof] = ACTIONS(2240),
    [anon_sym_alignof] = ACTIONS(2240),
    [anon_sym__Alignof] = ACTIONS(2240),
    [anon_sym_offsetof] = ACTIONS(2242),
    [anon_sym__Generic] = ACTIONS(2244),
    [anon_sym_asm] = ACTIONS(2246),
    [anon_sym___asm__] = ACTIONS(2246),
    [aux_sym_number_literal_token1] = ACTIONS(2248),
    [aux_sym_number_literal_token2] = ACTIONS(2250),
    [anon_sym_L_SQUOTE] = ACTIONS(2252),
    [anon_sym_u_SQUOTE] = ACTIONS(2252),
    [anon_sym_U_SQUOTE] = ACTIONS(2252),
    [anon_sym_u8_SQUOTE] = ACTIONS(2252),
    [anon_sym_SQUOTE] = ACTIONS(2252),
    [anon_sym_L_DQUOTE] = ACTIONS(2254),
    [anon_sym_u_DQUOTE] = ACTIONS(2254),
    [anon_sym_U_DQUOTE] = ACTIONS(2254),
    [anon_sym_u8_DQUOTE] = ACTIONS(2254),
    [anon_sym_DQUOTE] = ACTIONS(2254),
    [sym_true] = ACTIONS(2256),
    [sym_false] = ACTIONS(2256),
    [anon_sym_NULL] = ACTIONS(2258),
    [anon_sym_nullptr] = ACTIONS(2258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2260),
    [anon_sym_R_DQUOTE] = ACTIONS(2262),
    [anon_sym_LR_DQUOTE] = ACTIONS(2262),
    [anon_sym_uR_DQUOTE] = ACTIONS(2262),
    [anon_sym_UR_DQUOTE] = ACTIONS(2262),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2262),
    [anon_sym_co_await] = ACTIONS(2264),
    [anon_sym_new] = ACTIONS(2266),
    [anon_sym_requires] = ACTIONS(2268),
    [sym_this] = ACTIONS(2256),
  },
  [1508] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(3183),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(3292),
    [sym_char_literal] = STATE(3292),
    [sym_concatenated_string] = STATE(3308),
    [sym_string_literal] = STATE(2343),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2348),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1969),
    [anon_sym_LPAREN2] = ACTIONS(4256),
    [anon_sym_BANG] = ACTIONS(1973),
    [anon_sym_TILDE] = ACTIONS(1973),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_STAR] = ACTIONS(4048),
    [anon_sym_AMP] = ACTIONS(4048),
    [anon_sym_COLON_COLON] = ACTIONS(1975),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1971),
    [anon_sym_compl] = ACTIONS(1971),
    [anon_sym_DASH_DASH] = ACTIONS(4096),
    [anon_sym_PLUS_PLUS] = ACTIONS(4096),
    [anon_sym_sizeof] = ACTIONS(1977),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1979),
    [aux_sym_number_literal_token2] = ACTIONS(1981),
    [anon_sym_L_SQUOTE] = ACTIONS(1983),
    [anon_sym_u_SQUOTE] = ACTIONS(1983),
    [anon_sym_U_SQUOTE] = ACTIONS(1983),
    [anon_sym_u8_SQUOTE] = ACTIONS(1983),
    [anon_sym_SQUOTE] = ACTIONS(1983),
    [anon_sym_L_DQUOTE] = ACTIONS(1985),
    [anon_sym_u_DQUOTE] = ACTIONS(1985),
    [anon_sym_U_DQUOTE] = ACTIONS(1985),
    [anon_sym_u8_DQUOTE] = ACTIONS(1985),
    [anon_sym_DQUOTE] = ACTIONS(1985),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1987),
    [anon_sym_R_DQUOTE] = ACTIONS(1989),
    [anon_sym_LR_DQUOTE] = ACTIONS(1989),
    [anon_sym_uR_DQUOTE] = ACTIONS(1989),
    [anon_sym_UR_DQUOTE] = ACTIONS(1989),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1989),
    [anon_sym_co_await] = ACTIONS(1991),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1509] = {
    [sym_primitive_type] = STATE(6613),
    [sym__expression] = STATE(3216),
    [sym__expression_not_binary] = STATE(3637),
    [sym__string] = STATE(3637),
    [sym_conditional_expression] = STATE(3637),
    [sym_assignment_expression] = STATE(3637),
    [sym_pointer_expression] = STATE(3637),
    [sym_unary_expression] = STATE(3637),
    [sym_binary_expression] = STATE(3637),
    [sym_update_expression] = STATE(3637),
    [sym_cast_expression] = STATE(3637),
    [sym_sizeof_expression] = STATE(3637),
    [sym_alignof_expression] = STATE(3637),
    [sym_offsetof_expression] = STATE(3637),
    [sym_generic_expression] = STATE(3637),
    [sym_subscript_expression] = STATE(3637),
    [sym_call_expression] = STATE(3637),
    [sym_gnu_asm_expression] = STATE(3637),
    [sym_field_expression] = STATE(3637),
    [sym_compound_literal_expression] = STATE(3637),
    [sym_parenthesized_expression] = STATE(3637),
    [sym_number_literal] = STATE(3416),
    [sym_char_literal] = STATE(3416),
    [sym_concatenated_string] = STATE(3415),
    [sym_string_literal] = STATE(2430),
    [sym_null] = STATE(3637),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7434),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3637),
    [sym_raw_string_literal] = STATE(2419),
    [sym_co_await_expression] = STATE(3637),
    [sym_new_expression] = STATE(3637),
    [sym_delete_expression] = STATE(3637),
    [sym_requires_clause] = STATE(3637),
    [sym_requires_expression] = STATE(3637),
    [sym_lambda_expression] = STATE(3637),
    [sym_lambda_capture_specifier] = STATE(5725),
    [sym_fold_expression] = STATE(3637),
    [sym_parameter_pack_expansion] = STATE(3637),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5512),
    [sym_qualified_identifier] = STATE(3637),
    [sym_qualified_type_identifier] = STATE(7434),
    [sym_user_defined_literal] = STATE(3637),
    [sym_identifier] = ACTIONS(2228),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_BANG] = ACTIONS(2232),
    [anon_sym_TILDE] = ACTIONS(2232),
    [anon_sym_DASH] = ACTIONS(2230),
    [anon_sym_PLUS] = ACTIONS(2230),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON_COLON] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2230),
    [anon_sym_compl] = ACTIONS(2230),
    [anon_sym_DASH_DASH] = ACTIONS(4112),
    [anon_sym_PLUS_PLUS] = ACTIONS(4112),
    [anon_sym_sizeof] = ACTIONS(2238),
    [anon_sym___alignof__] = ACTIONS(2240),
    [anon_sym___alignof] = ACTIONS(2240),
    [anon_sym__alignof] = ACTIONS(2240),
    [anon_sym_alignof] = ACTIONS(2240),
    [anon_sym__Alignof] = ACTIONS(2240),
    [anon_sym_offsetof] = ACTIONS(2242),
    [anon_sym__Generic] = ACTIONS(2244),
    [anon_sym_asm] = ACTIONS(2246),
    [anon_sym___asm__] = ACTIONS(2246),
    [aux_sym_number_literal_token1] = ACTIONS(2248),
    [aux_sym_number_literal_token2] = ACTIONS(2250),
    [anon_sym_L_SQUOTE] = ACTIONS(2252),
    [anon_sym_u_SQUOTE] = ACTIONS(2252),
    [anon_sym_U_SQUOTE] = ACTIONS(2252),
    [anon_sym_u8_SQUOTE] = ACTIONS(2252),
    [anon_sym_SQUOTE] = ACTIONS(2252),
    [anon_sym_L_DQUOTE] = ACTIONS(2254),
    [anon_sym_u_DQUOTE] = ACTIONS(2254),
    [anon_sym_U_DQUOTE] = ACTIONS(2254),
    [anon_sym_u8_DQUOTE] = ACTIONS(2254),
    [anon_sym_DQUOTE] = ACTIONS(2254),
    [sym_true] = ACTIONS(2256),
    [sym_false] = ACTIONS(2256),
    [anon_sym_NULL] = ACTIONS(2258),
    [anon_sym_nullptr] = ACTIONS(2258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2260),
    [anon_sym_R_DQUOTE] = ACTIONS(2262),
    [anon_sym_LR_DQUOTE] = ACTIONS(2262),
    [anon_sym_uR_DQUOTE] = ACTIONS(2262),
    [anon_sym_UR_DQUOTE] = ACTIONS(2262),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2262),
    [anon_sym_co_await] = ACTIONS(2264),
    [anon_sym_new] = ACTIONS(2266),
    [anon_sym_requires] = ACTIONS(2268),
    [sym_this] = ACTIONS(2256),
  },
  [1510] = {
    [sym_primitive_type] = STATE(6613),
    [sym__expression] = STATE(3215),
    [sym__expression_not_binary] = STATE(3637),
    [sym__string] = STATE(3637),
    [sym_conditional_expression] = STATE(3637),
    [sym_assignment_expression] = STATE(3637),
    [sym_pointer_expression] = STATE(3637),
    [sym_unary_expression] = STATE(3637),
    [sym_binary_expression] = STATE(3637),
    [sym_update_expression] = STATE(3637),
    [sym_cast_expression] = STATE(3637),
    [sym_sizeof_expression] = STATE(3637),
    [sym_alignof_expression] = STATE(3637),
    [sym_offsetof_expression] = STATE(3637),
    [sym_generic_expression] = STATE(3637),
    [sym_subscript_expression] = STATE(3637),
    [sym_call_expression] = STATE(3637),
    [sym_gnu_asm_expression] = STATE(3637),
    [sym_field_expression] = STATE(3637),
    [sym_compound_literal_expression] = STATE(3637),
    [sym_parenthesized_expression] = STATE(3637),
    [sym_number_literal] = STATE(3416),
    [sym_char_literal] = STATE(3416),
    [sym_concatenated_string] = STATE(3415),
    [sym_string_literal] = STATE(2430),
    [sym_null] = STATE(3637),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7434),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3637),
    [sym_raw_string_literal] = STATE(2419),
    [sym_co_await_expression] = STATE(3637),
    [sym_new_expression] = STATE(3637),
    [sym_delete_expression] = STATE(3637),
    [sym_requires_clause] = STATE(3637),
    [sym_requires_expression] = STATE(3637),
    [sym_lambda_expression] = STATE(3637),
    [sym_lambda_capture_specifier] = STATE(5725),
    [sym_fold_expression] = STATE(3637),
    [sym_parameter_pack_expansion] = STATE(3637),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5512),
    [sym_qualified_identifier] = STATE(3637),
    [sym_qualified_type_identifier] = STATE(7434),
    [sym_user_defined_literal] = STATE(3637),
    [sym_identifier] = ACTIONS(2228),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_BANG] = ACTIONS(2232),
    [anon_sym_TILDE] = ACTIONS(2232),
    [anon_sym_DASH] = ACTIONS(2230),
    [anon_sym_PLUS] = ACTIONS(2230),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON_COLON] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2230),
    [anon_sym_compl] = ACTIONS(2230),
    [anon_sym_DASH_DASH] = ACTIONS(4112),
    [anon_sym_PLUS_PLUS] = ACTIONS(4112),
    [anon_sym_sizeof] = ACTIONS(2238),
    [anon_sym___alignof__] = ACTIONS(2240),
    [anon_sym___alignof] = ACTIONS(2240),
    [anon_sym__alignof] = ACTIONS(2240),
    [anon_sym_alignof] = ACTIONS(2240),
    [anon_sym__Alignof] = ACTIONS(2240),
    [anon_sym_offsetof] = ACTIONS(2242),
    [anon_sym__Generic] = ACTIONS(2244),
    [anon_sym_asm] = ACTIONS(2246),
    [anon_sym___asm__] = ACTIONS(2246),
    [aux_sym_number_literal_token1] = ACTIONS(2248),
    [aux_sym_number_literal_token2] = ACTIONS(2250),
    [anon_sym_L_SQUOTE] = ACTIONS(2252),
    [anon_sym_u_SQUOTE] = ACTIONS(2252),
    [anon_sym_U_SQUOTE] = ACTIONS(2252),
    [anon_sym_u8_SQUOTE] = ACTIONS(2252),
    [anon_sym_SQUOTE] = ACTIONS(2252),
    [anon_sym_L_DQUOTE] = ACTIONS(2254),
    [anon_sym_u_DQUOTE] = ACTIONS(2254),
    [anon_sym_U_DQUOTE] = ACTIONS(2254),
    [anon_sym_u8_DQUOTE] = ACTIONS(2254),
    [anon_sym_DQUOTE] = ACTIONS(2254),
    [sym_true] = ACTIONS(2256),
    [sym_false] = ACTIONS(2256),
    [anon_sym_NULL] = ACTIONS(2258),
    [anon_sym_nullptr] = ACTIONS(2258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2260),
    [anon_sym_R_DQUOTE] = ACTIONS(2262),
    [anon_sym_LR_DQUOTE] = ACTIONS(2262),
    [anon_sym_uR_DQUOTE] = ACTIONS(2262),
    [anon_sym_UR_DQUOTE] = ACTIONS(2262),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2262),
    [anon_sym_co_await] = ACTIONS(2264),
    [anon_sym_new] = ACTIONS(2266),
    [anon_sym_requires] = ACTIONS(2268),
    [sym_this] = ACTIONS(2256),
  },
  [1511] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2777),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2832),
    [sym_char_literal] = STATE(2832),
    [sym_concatenated_string] = STATE(2831),
    [sym_string_literal] = STATE(1997),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(1998),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4244),
    [anon_sym_BANG] = ACTIONS(1889),
    [anon_sym_TILDE] = ACTIONS(1889),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_STAR] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(4238),
    [anon_sym_COLON_COLON] = ACTIONS(1891),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1887),
    [anon_sym_compl] = ACTIONS(1887),
    [anon_sym_DASH_DASH] = ACTIONS(4102),
    [anon_sym_PLUS_PLUS] = ACTIONS(4102),
    [anon_sym_sizeof] = ACTIONS(1895),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1905),
    [aux_sym_number_literal_token2] = ACTIONS(1907),
    [anon_sym_L_SQUOTE] = ACTIONS(1909),
    [anon_sym_u_SQUOTE] = ACTIONS(1909),
    [anon_sym_U_SQUOTE] = ACTIONS(1909),
    [anon_sym_u8_SQUOTE] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(1909),
    [anon_sym_L_DQUOTE] = ACTIONS(1911),
    [anon_sym_u_DQUOTE] = ACTIONS(1911),
    [anon_sym_U_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8_DQUOTE] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(1911),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1919),
    [anon_sym_R_DQUOTE] = ACTIONS(1921),
    [anon_sym_LR_DQUOTE] = ACTIONS(1921),
    [anon_sym_uR_DQUOTE] = ACTIONS(1921),
    [anon_sym_UR_DQUOTE] = ACTIONS(1921),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1921),
    [anon_sym_co_await] = ACTIONS(1923),
    [anon_sym_new] = ACTIONS(1925),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1512] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(3159),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(3292),
    [sym_char_literal] = STATE(3292),
    [sym_concatenated_string] = STATE(3308),
    [sym_string_literal] = STATE(2343),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2348),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1969),
    [anon_sym_LPAREN2] = ACTIONS(4256),
    [anon_sym_BANG] = ACTIONS(1973),
    [anon_sym_TILDE] = ACTIONS(1973),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_STAR] = ACTIONS(4048),
    [anon_sym_AMP] = ACTIONS(4048),
    [anon_sym_COLON_COLON] = ACTIONS(1975),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1971),
    [anon_sym_compl] = ACTIONS(1971),
    [anon_sym_DASH_DASH] = ACTIONS(4096),
    [anon_sym_PLUS_PLUS] = ACTIONS(4096),
    [anon_sym_sizeof] = ACTIONS(1977),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1979),
    [aux_sym_number_literal_token2] = ACTIONS(1981),
    [anon_sym_L_SQUOTE] = ACTIONS(1983),
    [anon_sym_u_SQUOTE] = ACTIONS(1983),
    [anon_sym_U_SQUOTE] = ACTIONS(1983),
    [anon_sym_u8_SQUOTE] = ACTIONS(1983),
    [anon_sym_SQUOTE] = ACTIONS(1983),
    [anon_sym_L_DQUOTE] = ACTIONS(1985),
    [anon_sym_u_DQUOTE] = ACTIONS(1985),
    [anon_sym_U_DQUOTE] = ACTIONS(1985),
    [anon_sym_u8_DQUOTE] = ACTIONS(1985),
    [anon_sym_DQUOTE] = ACTIONS(1985),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1987),
    [anon_sym_R_DQUOTE] = ACTIONS(1989),
    [anon_sym_LR_DQUOTE] = ACTIONS(1989),
    [anon_sym_uR_DQUOTE] = ACTIONS(1989),
    [anon_sym_UR_DQUOTE] = ACTIONS(1989),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1989),
    [anon_sym_co_await] = ACTIONS(1991),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1513] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(3194),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4226),
    [anon_sym_BANG] = ACTIONS(2218),
    [anon_sym_TILDE] = ACTIONS(2218),
    [anon_sym_DASH] = ACTIONS(2216),
    [anon_sym_PLUS] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(2220),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2216),
    [anon_sym_compl] = ACTIONS(2216),
    [anon_sym_DASH_DASH] = ACTIONS(4136),
    [anon_sym_PLUS_PLUS] = ACTIONS(4136),
    [anon_sym_sizeof] = ACTIONS(2222),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2224),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(2226),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1514] = {
    [sym_primitive_type] = STATE(6613),
    [sym__expression] = STATE(3214),
    [sym__expression_not_binary] = STATE(3637),
    [sym__string] = STATE(3637),
    [sym_conditional_expression] = STATE(3637),
    [sym_assignment_expression] = STATE(3637),
    [sym_pointer_expression] = STATE(3637),
    [sym_unary_expression] = STATE(3637),
    [sym_binary_expression] = STATE(3637),
    [sym_update_expression] = STATE(3637),
    [sym_cast_expression] = STATE(3637),
    [sym_sizeof_expression] = STATE(3637),
    [sym_alignof_expression] = STATE(3637),
    [sym_offsetof_expression] = STATE(3637),
    [sym_generic_expression] = STATE(3637),
    [sym_subscript_expression] = STATE(3637),
    [sym_call_expression] = STATE(3637),
    [sym_gnu_asm_expression] = STATE(3637),
    [sym_field_expression] = STATE(3637),
    [sym_compound_literal_expression] = STATE(3637),
    [sym_parenthesized_expression] = STATE(3637),
    [sym_number_literal] = STATE(3416),
    [sym_char_literal] = STATE(3416),
    [sym_concatenated_string] = STATE(3415),
    [sym_string_literal] = STATE(2430),
    [sym_null] = STATE(3637),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7434),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3637),
    [sym_raw_string_literal] = STATE(2419),
    [sym_co_await_expression] = STATE(3637),
    [sym_new_expression] = STATE(3637),
    [sym_delete_expression] = STATE(3637),
    [sym_requires_clause] = STATE(3637),
    [sym_requires_expression] = STATE(3637),
    [sym_lambda_expression] = STATE(3637),
    [sym_lambda_capture_specifier] = STATE(5725),
    [sym_fold_expression] = STATE(3637),
    [sym_parameter_pack_expansion] = STATE(3637),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5512),
    [sym_qualified_identifier] = STATE(3637),
    [sym_qualified_type_identifier] = STATE(7434),
    [sym_user_defined_literal] = STATE(3637),
    [sym_identifier] = ACTIONS(2228),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_BANG] = ACTIONS(2232),
    [anon_sym_TILDE] = ACTIONS(2232),
    [anon_sym_DASH] = ACTIONS(2230),
    [anon_sym_PLUS] = ACTIONS(2230),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON_COLON] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2230),
    [anon_sym_compl] = ACTIONS(2230),
    [anon_sym_DASH_DASH] = ACTIONS(4112),
    [anon_sym_PLUS_PLUS] = ACTIONS(4112),
    [anon_sym_sizeof] = ACTIONS(2238),
    [anon_sym___alignof__] = ACTIONS(2240),
    [anon_sym___alignof] = ACTIONS(2240),
    [anon_sym__alignof] = ACTIONS(2240),
    [anon_sym_alignof] = ACTIONS(2240),
    [anon_sym__Alignof] = ACTIONS(2240),
    [anon_sym_offsetof] = ACTIONS(2242),
    [anon_sym__Generic] = ACTIONS(2244),
    [anon_sym_asm] = ACTIONS(2246),
    [anon_sym___asm__] = ACTIONS(2246),
    [aux_sym_number_literal_token1] = ACTIONS(2248),
    [aux_sym_number_literal_token2] = ACTIONS(2250),
    [anon_sym_L_SQUOTE] = ACTIONS(2252),
    [anon_sym_u_SQUOTE] = ACTIONS(2252),
    [anon_sym_U_SQUOTE] = ACTIONS(2252),
    [anon_sym_u8_SQUOTE] = ACTIONS(2252),
    [anon_sym_SQUOTE] = ACTIONS(2252),
    [anon_sym_L_DQUOTE] = ACTIONS(2254),
    [anon_sym_u_DQUOTE] = ACTIONS(2254),
    [anon_sym_U_DQUOTE] = ACTIONS(2254),
    [anon_sym_u8_DQUOTE] = ACTIONS(2254),
    [anon_sym_DQUOTE] = ACTIONS(2254),
    [sym_true] = ACTIONS(2256),
    [sym_false] = ACTIONS(2256),
    [anon_sym_NULL] = ACTIONS(2258),
    [anon_sym_nullptr] = ACTIONS(2258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2260),
    [anon_sym_R_DQUOTE] = ACTIONS(2262),
    [anon_sym_LR_DQUOTE] = ACTIONS(2262),
    [anon_sym_uR_DQUOTE] = ACTIONS(2262),
    [anon_sym_UR_DQUOTE] = ACTIONS(2262),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2262),
    [anon_sym_co_await] = ACTIONS(2264),
    [anon_sym_new] = ACTIONS(2266),
    [anon_sym_requires] = ACTIONS(2268),
    [sym_this] = ACTIONS(2256),
  },
  [1515] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4108),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(2961),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(2961),
    [sym_call_expression] = STATE(2961),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(2961),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(2961),
    [sym_number_literal] = STATE(4149),
    [sym_char_literal] = STATE(4149),
    [sym_concatenated_string] = STATE(4150),
    [sym_string_literal] = STATE(3034),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3026),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2961),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(2961),
    [sym_identifier] = ACTIONS(4082),
    [anon_sym_LPAREN2] = ACTIONS(4236),
    [anon_sym_BANG] = ACTIONS(3190),
    [anon_sym_TILDE] = ACTIONS(3190),
    [anon_sym_DASH] = ACTIONS(3188),
    [anon_sym_PLUS] = ACTIONS(3188),
    [anon_sym_STAR] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(4238),
    [anon_sym_COLON_COLON] = ACTIONS(3192),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3188),
    [anon_sym_compl] = ACTIONS(3188),
    [anon_sym_DASH_DASH] = ACTIONS(4088),
    [anon_sym_PLUS_PLUS] = ACTIONS(4088),
    [anon_sym_sizeof] = ACTIONS(3196),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3198),
    [aux_sym_number_literal_token2] = ACTIONS(3200),
    [anon_sym_L_SQUOTE] = ACTIONS(3202),
    [anon_sym_u_SQUOTE] = ACTIONS(3202),
    [anon_sym_U_SQUOTE] = ACTIONS(3202),
    [anon_sym_u8_SQUOTE] = ACTIONS(3202),
    [anon_sym_SQUOTE] = ACTIONS(3202),
    [anon_sym_L_DQUOTE] = ACTIONS(3204),
    [anon_sym_u_DQUOTE] = ACTIONS(3204),
    [anon_sym_U_DQUOTE] = ACTIONS(3204),
    [anon_sym_u8_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3204),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3206),
    [anon_sym_R_DQUOTE] = ACTIONS(3208),
    [anon_sym_LR_DQUOTE] = ACTIONS(3208),
    [anon_sym_uR_DQUOTE] = ACTIONS(3208),
    [anon_sym_UR_DQUOTE] = ACTIONS(3208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3208),
    [anon_sym_co_await] = ACTIONS(3210),
    [anon_sym_new] = ACTIONS(3212),
    [anon_sym_requires] = ACTIONS(3214),
    [sym_this] = ACTIONS(219),
  },
  [1516] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(3202),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4226),
    [anon_sym_BANG] = ACTIONS(2218),
    [anon_sym_TILDE] = ACTIONS(2218),
    [anon_sym_DASH] = ACTIONS(2216),
    [anon_sym_PLUS] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(2220),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2216),
    [anon_sym_compl] = ACTIONS(2216),
    [anon_sym_DASH_DASH] = ACTIONS(4136),
    [anon_sym_PLUS_PLUS] = ACTIONS(4136),
    [anon_sym_sizeof] = ACTIONS(2222),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2224),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(2226),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1517] = {
    [sym_primitive_type] = STATE(6848),
    [sym__expression] = STATE(3145),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7357),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(7357),
    [sym_user_defined_literal] = STATE(3526),
    [sym_identifier] = ACTIONS(1965),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [1518] = {
    [sym_primitive_type] = STATE(6613),
    [sym__expression] = STATE(3209),
    [sym__expression_not_binary] = STATE(3637),
    [sym__string] = STATE(3637),
    [sym_conditional_expression] = STATE(3637),
    [sym_assignment_expression] = STATE(3637),
    [sym_pointer_expression] = STATE(3637),
    [sym_unary_expression] = STATE(3637),
    [sym_binary_expression] = STATE(3637),
    [sym_update_expression] = STATE(3637),
    [sym_cast_expression] = STATE(3637),
    [sym_sizeof_expression] = STATE(3637),
    [sym_alignof_expression] = STATE(3637),
    [sym_offsetof_expression] = STATE(3637),
    [sym_generic_expression] = STATE(3637),
    [sym_subscript_expression] = STATE(3637),
    [sym_call_expression] = STATE(3637),
    [sym_gnu_asm_expression] = STATE(3637),
    [sym_field_expression] = STATE(3637),
    [sym_compound_literal_expression] = STATE(3637),
    [sym_parenthesized_expression] = STATE(3637),
    [sym_number_literal] = STATE(3416),
    [sym_char_literal] = STATE(3416),
    [sym_concatenated_string] = STATE(3415),
    [sym_string_literal] = STATE(2430),
    [sym_null] = STATE(3637),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7434),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3637),
    [sym_raw_string_literal] = STATE(2419),
    [sym_co_await_expression] = STATE(3637),
    [sym_new_expression] = STATE(3637),
    [sym_delete_expression] = STATE(3637),
    [sym_requires_clause] = STATE(3637),
    [sym_requires_expression] = STATE(3637),
    [sym_lambda_expression] = STATE(3637),
    [sym_lambda_capture_specifier] = STATE(5725),
    [sym_fold_expression] = STATE(3637),
    [sym_parameter_pack_expansion] = STATE(3637),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5512),
    [sym_qualified_identifier] = STATE(3637),
    [sym_qualified_type_identifier] = STATE(7434),
    [sym_user_defined_literal] = STATE(3637),
    [sym_identifier] = ACTIONS(2228),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_BANG] = ACTIONS(2232),
    [anon_sym_TILDE] = ACTIONS(2232),
    [anon_sym_DASH] = ACTIONS(2230),
    [anon_sym_PLUS] = ACTIONS(2230),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON_COLON] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2230),
    [anon_sym_compl] = ACTIONS(2230),
    [anon_sym_DASH_DASH] = ACTIONS(4112),
    [anon_sym_PLUS_PLUS] = ACTIONS(4112),
    [anon_sym_sizeof] = ACTIONS(2238),
    [anon_sym___alignof__] = ACTIONS(2240),
    [anon_sym___alignof] = ACTIONS(2240),
    [anon_sym__alignof] = ACTIONS(2240),
    [anon_sym_alignof] = ACTIONS(2240),
    [anon_sym__Alignof] = ACTIONS(2240),
    [anon_sym_offsetof] = ACTIONS(2242),
    [anon_sym__Generic] = ACTIONS(2244),
    [anon_sym_asm] = ACTIONS(2246),
    [anon_sym___asm__] = ACTIONS(2246),
    [aux_sym_number_literal_token1] = ACTIONS(2248),
    [aux_sym_number_literal_token2] = ACTIONS(2250),
    [anon_sym_L_SQUOTE] = ACTIONS(2252),
    [anon_sym_u_SQUOTE] = ACTIONS(2252),
    [anon_sym_U_SQUOTE] = ACTIONS(2252),
    [anon_sym_u8_SQUOTE] = ACTIONS(2252),
    [anon_sym_SQUOTE] = ACTIONS(2252),
    [anon_sym_L_DQUOTE] = ACTIONS(2254),
    [anon_sym_u_DQUOTE] = ACTIONS(2254),
    [anon_sym_U_DQUOTE] = ACTIONS(2254),
    [anon_sym_u8_DQUOTE] = ACTIONS(2254),
    [anon_sym_DQUOTE] = ACTIONS(2254),
    [sym_true] = ACTIONS(2256),
    [sym_false] = ACTIONS(2256),
    [anon_sym_NULL] = ACTIONS(2258),
    [anon_sym_nullptr] = ACTIONS(2258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2260),
    [anon_sym_R_DQUOTE] = ACTIONS(2262),
    [anon_sym_LR_DQUOTE] = ACTIONS(2262),
    [anon_sym_uR_DQUOTE] = ACTIONS(2262),
    [anon_sym_UR_DQUOTE] = ACTIONS(2262),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2262),
    [anon_sym_co_await] = ACTIONS(2264),
    [anon_sym_new] = ACTIONS(2266),
    [anon_sym_requires] = ACTIONS(2268),
    [sym_this] = ACTIONS(2256),
  },
  [1519] = {
    [sym_primitive_type] = STATE(6853),
    [sym__expression] = STATE(3658),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7464),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(7464),
    [sym_user_defined_literal] = STATE(3374),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_LPAREN2] = ACTIONS(1745),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [1520] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(3300),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4226),
    [anon_sym_BANG] = ACTIONS(2218),
    [anon_sym_TILDE] = ACTIONS(2218),
    [anon_sym_DASH] = ACTIONS(2216),
    [anon_sym_PLUS] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(2220),
    [anon_sym_LBRACK] = ACTIONS(4490),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2216),
    [anon_sym_compl] = ACTIONS(2216),
    [anon_sym_DASH_DASH] = ACTIONS(4136),
    [anon_sym_PLUS_PLUS] = ACTIONS(4136),
    [anon_sym_sizeof] = ACTIONS(2222),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2224),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(2226),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1521] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(3333),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4226),
    [anon_sym_BANG] = ACTIONS(2218),
    [anon_sym_TILDE] = ACTIONS(2218),
    [anon_sym_DASH] = ACTIONS(2216),
    [anon_sym_PLUS] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(2220),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2216),
    [anon_sym_compl] = ACTIONS(2216),
    [anon_sym_DASH_DASH] = ACTIONS(4136),
    [anon_sym_PLUS_PLUS] = ACTIONS(4136),
    [anon_sym_sizeof] = ACTIONS(2222),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2224),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(2226),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1522] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(3323),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4226),
    [anon_sym_BANG] = ACTIONS(2218),
    [anon_sym_TILDE] = ACTIONS(2218),
    [anon_sym_DASH] = ACTIONS(2216),
    [anon_sym_PLUS] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(2220),
    [anon_sym_LBRACK] = ACTIONS(4492),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2216),
    [anon_sym_compl] = ACTIONS(2216),
    [anon_sym_DASH_DASH] = ACTIONS(4136),
    [anon_sym_PLUS_PLUS] = ACTIONS(4136),
    [anon_sym_sizeof] = ACTIONS(2222),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2224),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(2226),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1523] = {
    [sym_primitive_type] = STATE(6848),
    [sym__expression] = STATE(3144),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7357),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(7357),
    [sym_user_defined_literal] = STATE(3526),
    [sym_identifier] = ACTIONS(1965),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [1524] = {
    [sym_primitive_type] = STATE(6848),
    [sym__expression] = STATE(3142),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7357),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(7357),
    [sym_user_defined_literal] = STATE(3526),
    [sym_identifier] = ACTIONS(1965),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [1525] = {
    [sym_primitive_type] = STATE(6848),
    [sym__expression] = STATE(3141),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7357),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(7357),
    [sym_user_defined_literal] = STATE(3526),
    [sym_identifier] = ACTIONS(1965),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [1526] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(3182),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(3292),
    [sym_char_literal] = STATE(3292),
    [sym_concatenated_string] = STATE(3308),
    [sym_string_literal] = STATE(2343),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2348),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1969),
    [anon_sym_LPAREN2] = ACTIONS(4256),
    [anon_sym_BANG] = ACTIONS(1973),
    [anon_sym_TILDE] = ACTIONS(1973),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_STAR] = ACTIONS(4048),
    [anon_sym_AMP] = ACTIONS(4048),
    [anon_sym_COLON_COLON] = ACTIONS(1975),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1971),
    [anon_sym_compl] = ACTIONS(1971),
    [anon_sym_DASH_DASH] = ACTIONS(4096),
    [anon_sym_PLUS_PLUS] = ACTIONS(4096),
    [anon_sym_sizeof] = ACTIONS(1977),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1979),
    [aux_sym_number_literal_token2] = ACTIONS(1981),
    [anon_sym_L_SQUOTE] = ACTIONS(1983),
    [anon_sym_u_SQUOTE] = ACTIONS(1983),
    [anon_sym_U_SQUOTE] = ACTIONS(1983),
    [anon_sym_u8_SQUOTE] = ACTIONS(1983),
    [anon_sym_SQUOTE] = ACTIONS(1983),
    [anon_sym_L_DQUOTE] = ACTIONS(1985),
    [anon_sym_u_DQUOTE] = ACTIONS(1985),
    [anon_sym_U_DQUOTE] = ACTIONS(1985),
    [anon_sym_u8_DQUOTE] = ACTIONS(1985),
    [anon_sym_DQUOTE] = ACTIONS(1985),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1987),
    [anon_sym_R_DQUOTE] = ACTIONS(1989),
    [anon_sym_LR_DQUOTE] = ACTIONS(1989),
    [anon_sym_uR_DQUOTE] = ACTIONS(1989),
    [anon_sym_UR_DQUOTE] = ACTIONS(1989),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1989),
    [anon_sym_co_await] = ACTIONS(1991),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1527] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2776),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2832),
    [sym_char_literal] = STATE(2832),
    [sym_concatenated_string] = STATE(2831),
    [sym_string_literal] = STATE(1997),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(1998),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4244),
    [anon_sym_BANG] = ACTIONS(1889),
    [anon_sym_TILDE] = ACTIONS(1889),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_STAR] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(4238),
    [anon_sym_COLON_COLON] = ACTIONS(1891),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1887),
    [anon_sym_compl] = ACTIONS(1887),
    [anon_sym_DASH_DASH] = ACTIONS(4102),
    [anon_sym_PLUS_PLUS] = ACTIONS(4102),
    [anon_sym_sizeof] = ACTIONS(1895),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1905),
    [aux_sym_number_literal_token2] = ACTIONS(1907),
    [anon_sym_L_SQUOTE] = ACTIONS(1909),
    [anon_sym_u_SQUOTE] = ACTIONS(1909),
    [anon_sym_U_SQUOTE] = ACTIONS(1909),
    [anon_sym_u8_SQUOTE] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(1909),
    [anon_sym_L_DQUOTE] = ACTIONS(1911),
    [anon_sym_u_DQUOTE] = ACTIONS(1911),
    [anon_sym_U_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8_DQUOTE] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(1911),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1919),
    [anon_sym_R_DQUOTE] = ACTIONS(1921),
    [anon_sym_LR_DQUOTE] = ACTIONS(1921),
    [anon_sym_uR_DQUOTE] = ACTIONS(1921),
    [anon_sym_UR_DQUOTE] = ACTIONS(1921),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1921),
    [anon_sym_co_await] = ACTIONS(1923),
    [anon_sym_new] = ACTIONS(1925),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1528] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(3132),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(3292),
    [sym_char_literal] = STATE(3292),
    [sym_concatenated_string] = STATE(3308),
    [sym_string_literal] = STATE(2343),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2348),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1969),
    [anon_sym_LPAREN2] = ACTIONS(4256),
    [anon_sym_BANG] = ACTIONS(1973),
    [anon_sym_TILDE] = ACTIONS(1973),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_STAR] = ACTIONS(4048),
    [anon_sym_AMP] = ACTIONS(4048),
    [anon_sym_COLON_COLON] = ACTIONS(1975),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1971),
    [anon_sym_compl] = ACTIONS(1971),
    [anon_sym_DASH_DASH] = ACTIONS(4096),
    [anon_sym_PLUS_PLUS] = ACTIONS(4096),
    [anon_sym_sizeof] = ACTIONS(1977),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1979),
    [aux_sym_number_literal_token2] = ACTIONS(1981),
    [anon_sym_L_SQUOTE] = ACTIONS(1983),
    [anon_sym_u_SQUOTE] = ACTIONS(1983),
    [anon_sym_U_SQUOTE] = ACTIONS(1983),
    [anon_sym_u8_SQUOTE] = ACTIONS(1983),
    [anon_sym_SQUOTE] = ACTIONS(1983),
    [anon_sym_L_DQUOTE] = ACTIONS(1985),
    [anon_sym_u_DQUOTE] = ACTIONS(1985),
    [anon_sym_U_DQUOTE] = ACTIONS(1985),
    [anon_sym_u8_DQUOTE] = ACTIONS(1985),
    [anon_sym_DQUOTE] = ACTIONS(1985),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1987),
    [anon_sym_R_DQUOTE] = ACTIONS(1989),
    [anon_sym_LR_DQUOTE] = ACTIONS(1989),
    [anon_sym_uR_DQUOTE] = ACTIONS(1989),
    [anon_sym_UR_DQUOTE] = ACTIONS(1989),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1989),
    [anon_sym_co_await] = ACTIONS(1991),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1529] = {
    [sym_primitive_type] = STATE(6848),
    [sym__expression] = STATE(3140),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7357),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(7357),
    [sym_user_defined_literal] = STATE(3526),
    [sym_identifier] = ACTIONS(1965),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [1530] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(3213),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4226),
    [anon_sym_BANG] = ACTIONS(2218),
    [anon_sym_TILDE] = ACTIONS(2218),
    [anon_sym_DASH] = ACTIONS(2216),
    [anon_sym_PLUS] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(2220),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2216),
    [anon_sym_compl] = ACTIONS(2216),
    [anon_sym_DASH_DASH] = ACTIONS(4136),
    [anon_sym_PLUS_PLUS] = ACTIONS(4136),
    [anon_sym_sizeof] = ACTIONS(2222),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2224),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(2226),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1531] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(3236),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4226),
    [anon_sym_BANG] = ACTIONS(2218),
    [anon_sym_TILDE] = ACTIONS(2218),
    [anon_sym_DASH] = ACTIONS(2216),
    [anon_sym_PLUS] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(2220),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2216),
    [anon_sym_compl] = ACTIONS(2216),
    [anon_sym_DASH_DASH] = ACTIONS(4136),
    [anon_sym_PLUS_PLUS] = ACTIONS(4136),
    [anon_sym_sizeof] = ACTIONS(2222),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2224),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(2226),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1532] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2809),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2832),
    [sym_char_literal] = STATE(2832),
    [sym_concatenated_string] = STATE(2831),
    [sym_string_literal] = STATE(1997),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(1998),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4244),
    [anon_sym_BANG] = ACTIONS(1889),
    [anon_sym_TILDE] = ACTIONS(1889),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_STAR] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(4238),
    [anon_sym_COLON_COLON] = ACTIONS(1891),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1887),
    [anon_sym_compl] = ACTIONS(1887),
    [anon_sym_DASH_DASH] = ACTIONS(4102),
    [anon_sym_PLUS_PLUS] = ACTIONS(4102),
    [anon_sym_sizeof] = ACTIONS(1895),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1905),
    [aux_sym_number_literal_token2] = ACTIONS(1907),
    [anon_sym_L_SQUOTE] = ACTIONS(1909),
    [anon_sym_u_SQUOTE] = ACTIONS(1909),
    [anon_sym_U_SQUOTE] = ACTIONS(1909),
    [anon_sym_u8_SQUOTE] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(1909),
    [anon_sym_L_DQUOTE] = ACTIONS(1911),
    [anon_sym_u_DQUOTE] = ACTIONS(1911),
    [anon_sym_U_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8_DQUOTE] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(1911),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1919),
    [anon_sym_R_DQUOTE] = ACTIONS(1921),
    [anon_sym_LR_DQUOTE] = ACTIONS(1921),
    [anon_sym_uR_DQUOTE] = ACTIONS(1921),
    [anon_sym_UR_DQUOTE] = ACTIONS(1921),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1921),
    [anon_sym_co_await] = ACTIONS(1923),
    [anon_sym_new] = ACTIONS(1925),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1533] = {
    [sym_primitive_type] = STATE(6848),
    [sym__expression] = STATE(3139),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7357),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(7357),
    [sym_user_defined_literal] = STATE(3526),
    [sym_identifier] = ACTIONS(1965),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [1534] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2463),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2832),
    [sym_char_literal] = STATE(2832),
    [sym_concatenated_string] = STATE(2831),
    [sym_string_literal] = STATE(1997),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(1998),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4244),
    [anon_sym_BANG] = ACTIONS(1889),
    [anon_sym_TILDE] = ACTIONS(1889),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_STAR] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(4238),
    [anon_sym_COLON_COLON] = ACTIONS(1891),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1887),
    [anon_sym_compl] = ACTIONS(1887),
    [anon_sym_DASH_DASH] = ACTIONS(4102),
    [anon_sym_PLUS_PLUS] = ACTIONS(4102),
    [anon_sym_sizeof] = ACTIONS(1895),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1905),
    [aux_sym_number_literal_token2] = ACTIONS(1907),
    [anon_sym_L_SQUOTE] = ACTIONS(1909),
    [anon_sym_u_SQUOTE] = ACTIONS(1909),
    [anon_sym_U_SQUOTE] = ACTIONS(1909),
    [anon_sym_u8_SQUOTE] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(1909),
    [anon_sym_L_DQUOTE] = ACTIONS(1911),
    [anon_sym_u_DQUOTE] = ACTIONS(1911),
    [anon_sym_U_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8_DQUOTE] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(1911),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1919),
    [anon_sym_R_DQUOTE] = ACTIONS(1921),
    [anon_sym_LR_DQUOTE] = ACTIONS(1921),
    [anon_sym_uR_DQUOTE] = ACTIONS(1921),
    [anon_sym_UR_DQUOTE] = ACTIONS(1921),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1921),
    [anon_sym_co_await] = ACTIONS(1923),
    [anon_sym_new] = ACTIONS(1925),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1535] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(3251),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4226),
    [anon_sym_BANG] = ACTIONS(2218),
    [anon_sym_TILDE] = ACTIONS(2218),
    [anon_sym_DASH] = ACTIONS(2216),
    [anon_sym_PLUS] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(2220),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2216),
    [anon_sym_compl] = ACTIONS(2216),
    [anon_sym_DASH_DASH] = ACTIONS(4136),
    [anon_sym_PLUS_PLUS] = ACTIONS(4136),
    [anon_sym_sizeof] = ACTIONS(2222),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2224),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(2226),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1536] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4579),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1537] = {
    [sym_primitive_type] = STATE(6848),
    [sym__expression] = STATE(3096),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7357),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(7357),
    [sym_user_defined_literal] = STATE(3526),
    [sym_identifier] = ACTIONS(1965),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [1538] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(3253),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4226),
    [anon_sym_BANG] = ACTIONS(2218),
    [anon_sym_TILDE] = ACTIONS(2218),
    [anon_sym_DASH] = ACTIONS(2216),
    [anon_sym_PLUS] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(2220),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2216),
    [anon_sym_compl] = ACTIONS(2216),
    [anon_sym_DASH_DASH] = ACTIONS(4136),
    [anon_sym_PLUS_PLUS] = ACTIONS(4136),
    [anon_sym_sizeof] = ACTIONS(2222),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2224),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(2226),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1539] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(3895),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3440),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3440),
    [sym_call_expression] = STATE(3440),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3440),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3440),
    [sym_number_literal] = STATE(4352),
    [sym_char_literal] = STATE(4352),
    [sym_concatenated_string] = STATE(4364),
    [sym_string_literal] = STATE(3640),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3641),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3440),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3440),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_LPAREN2] = ACTIONS(4046),
    [anon_sym_BANG] = ACTIONS(3344),
    [anon_sym_TILDE] = ACTIONS(3344),
    [anon_sym_DASH] = ACTIONS(3342),
    [anon_sym_PLUS] = ACTIONS(3342),
    [anon_sym_STAR] = ACTIONS(4048),
    [anon_sym_AMP] = ACTIONS(4048),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3342),
    [anon_sym_compl] = ACTIONS(3342),
    [anon_sym_DASH_DASH] = ACTIONS(4052),
    [anon_sym_PLUS_PLUS] = ACTIONS(4052),
    [anon_sym_sizeof] = ACTIONS(3348),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3350),
    [aux_sym_number_literal_token2] = ACTIONS(3352),
    [anon_sym_L_SQUOTE] = ACTIONS(3354),
    [anon_sym_u_SQUOTE] = ACTIONS(3354),
    [anon_sym_U_SQUOTE] = ACTIONS(3354),
    [anon_sym_u8_SQUOTE] = ACTIONS(3354),
    [anon_sym_SQUOTE] = ACTIONS(3354),
    [anon_sym_L_DQUOTE] = ACTIONS(3356),
    [anon_sym_u_DQUOTE] = ACTIONS(3356),
    [anon_sym_U_DQUOTE] = ACTIONS(3356),
    [anon_sym_u8_DQUOTE] = ACTIONS(3356),
    [anon_sym_DQUOTE] = ACTIONS(3356),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3358),
    [anon_sym_R_DQUOTE] = ACTIONS(3360),
    [anon_sym_LR_DQUOTE] = ACTIONS(3360),
    [anon_sym_uR_DQUOTE] = ACTIONS(3360),
    [anon_sym_UR_DQUOTE] = ACTIONS(3360),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3360),
    [anon_sym_co_await] = ACTIONS(3362),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1540] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(3259),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4226),
    [anon_sym_BANG] = ACTIONS(2218),
    [anon_sym_TILDE] = ACTIONS(2218),
    [anon_sym_DASH] = ACTIONS(2216),
    [anon_sym_PLUS] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(2220),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2216),
    [anon_sym_compl] = ACTIONS(2216),
    [anon_sym_DASH_DASH] = ACTIONS(4136),
    [anon_sym_PLUS_PLUS] = ACTIONS(4136),
    [anon_sym_sizeof] = ACTIONS(2222),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2224),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(2226),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1541] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(3795),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3440),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3440),
    [sym_call_expression] = STATE(3440),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3440),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3440),
    [sym_number_literal] = STATE(4352),
    [sym_char_literal] = STATE(4352),
    [sym_concatenated_string] = STATE(4364),
    [sym_string_literal] = STATE(3640),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3641),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3440),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3440),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_LPAREN2] = ACTIONS(4046),
    [anon_sym_BANG] = ACTIONS(3344),
    [anon_sym_TILDE] = ACTIONS(3344),
    [anon_sym_DASH] = ACTIONS(3342),
    [anon_sym_PLUS] = ACTIONS(3342),
    [anon_sym_STAR] = ACTIONS(4048),
    [anon_sym_AMP] = ACTIONS(4048),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3342),
    [anon_sym_compl] = ACTIONS(3342),
    [anon_sym_DASH_DASH] = ACTIONS(4052),
    [anon_sym_PLUS_PLUS] = ACTIONS(4052),
    [anon_sym_sizeof] = ACTIONS(3348),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3350),
    [aux_sym_number_literal_token2] = ACTIONS(3352),
    [anon_sym_L_SQUOTE] = ACTIONS(3354),
    [anon_sym_u_SQUOTE] = ACTIONS(3354),
    [anon_sym_U_SQUOTE] = ACTIONS(3354),
    [anon_sym_u8_SQUOTE] = ACTIONS(3354),
    [anon_sym_SQUOTE] = ACTIONS(3354),
    [anon_sym_L_DQUOTE] = ACTIONS(3356),
    [anon_sym_u_DQUOTE] = ACTIONS(3356),
    [anon_sym_U_DQUOTE] = ACTIONS(3356),
    [anon_sym_u8_DQUOTE] = ACTIONS(3356),
    [anon_sym_DQUOTE] = ACTIONS(3356),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3358),
    [anon_sym_R_DQUOTE] = ACTIONS(3360),
    [anon_sym_LR_DQUOTE] = ACTIONS(3360),
    [anon_sym_uR_DQUOTE] = ACTIONS(3360),
    [anon_sym_UR_DQUOTE] = ACTIONS(3360),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3360),
    [anon_sym_co_await] = ACTIONS(3362),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1542] = {
    [sym_primitive_type] = STATE(6848),
    [sym__expression] = STATE(3121),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7357),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(7357),
    [sym_user_defined_literal] = STATE(3526),
    [sym_identifier] = ACTIONS(1965),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [1543] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(3272),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4226),
    [anon_sym_BANG] = ACTIONS(2218),
    [anon_sym_TILDE] = ACTIONS(2218),
    [anon_sym_DASH] = ACTIONS(2216),
    [anon_sym_PLUS] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(2220),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2216),
    [anon_sym_compl] = ACTIONS(2216),
    [anon_sym_DASH_DASH] = ACTIONS(4136),
    [anon_sym_PLUS_PLUS] = ACTIONS(4136),
    [anon_sym_sizeof] = ACTIONS(2222),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2224),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(2226),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1544] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2440),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4218),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_TILDE] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1931),
    [anon_sym_PLUS] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(1935),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1931),
    [anon_sym_compl] = ACTIONS(1931),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_sizeof] = ACTIONS(1937),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1545] = {
    [sym_primitive_type] = STATE(6848),
    [sym__expression] = STATE(3108),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7357),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(7357),
    [sym_user_defined_literal] = STATE(3526),
    [sym_identifier] = ACTIONS(1965),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [1546] = {
    [sym_primitive_type] = STATE(6848),
    [sym__expression] = STATE(3104),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7357),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(7357),
    [sym_user_defined_literal] = STATE(3526),
    [sym_identifier] = ACTIONS(1965),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [1547] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(3795),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1548] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4524),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1549] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(3274),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4226),
    [anon_sym_BANG] = ACTIONS(2218),
    [anon_sym_TILDE] = ACTIONS(2218),
    [anon_sym_DASH] = ACTIONS(2216),
    [anon_sym_PLUS] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(2220),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2216),
    [anon_sym_compl] = ACTIONS(2216),
    [anon_sym_DASH_DASH] = ACTIONS(4136),
    [anon_sym_PLUS_PLUS] = ACTIONS(4136),
    [anon_sym_sizeof] = ACTIONS(2222),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2224),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(2226),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1550] = {
    [sym_primitive_type] = STATE(6853),
    [sym__expression] = STATE(3581),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7464),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(7464),
    [sym_user_defined_literal] = STATE(3374),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_LPAREN2] = ACTIONS(1745),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [1551] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(3278),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4226),
    [anon_sym_BANG] = ACTIONS(2218),
    [anon_sym_TILDE] = ACTIONS(2218),
    [anon_sym_DASH] = ACTIONS(2216),
    [anon_sym_PLUS] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(2220),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2216),
    [anon_sym_compl] = ACTIONS(2216),
    [anon_sym_DASH_DASH] = ACTIONS(4136),
    [anon_sym_PLUS_PLUS] = ACTIONS(4136),
    [anon_sym_sizeof] = ACTIONS(2222),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2224),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(2226),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1552] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4458),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1553] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4299),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1554] = {
    [sym_primitive_type] = STATE(6853),
    [sym__expression] = STATE(3583),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7464),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(7464),
    [sym_user_defined_literal] = STATE(3374),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_LPAREN2] = ACTIONS(1745),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [1555] = {
    [sym_primitive_type] = STATE(6669),
    [sym__expression] = STATE(4401),
    [sym__expression_not_binary] = STATE(4648),
    [sym__string] = STATE(4648),
    [sym_conditional_expression] = STATE(4648),
    [sym_assignment_expression] = STATE(4648),
    [sym_pointer_expression] = STATE(3663),
    [sym_unary_expression] = STATE(4648),
    [sym_binary_expression] = STATE(4648),
    [sym_update_expression] = STATE(4648),
    [sym_cast_expression] = STATE(4648),
    [sym_sizeof_expression] = STATE(4648),
    [sym_alignof_expression] = STATE(4648),
    [sym_offsetof_expression] = STATE(4648),
    [sym_generic_expression] = STATE(4648),
    [sym_subscript_expression] = STATE(3663),
    [sym_call_expression] = STATE(3663),
    [sym_gnu_asm_expression] = STATE(4648),
    [sym_field_expression] = STATE(3663),
    [sym_compound_literal_expression] = STATE(4648),
    [sym_parenthesized_expression] = STATE(3663),
    [sym_number_literal] = STATE(4573),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4565),
    [sym_string_literal] = STATE(3707),
    [sym_null] = STATE(4648),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7442),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(4648),
    [sym_raw_string_literal] = STATE(3709),
    [sym_co_await_expression] = STATE(4648),
    [sym_new_expression] = STATE(4648),
    [sym_delete_expression] = STATE(4648),
    [sym_requires_clause] = STATE(4648),
    [sym_requires_expression] = STATE(4648),
    [sym_lambda_expression] = STATE(4648),
    [sym_lambda_capture_specifier] = STATE(5768),
    [sym_fold_expression] = STATE(4648),
    [sym_parameter_pack_expansion] = STATE(4648),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5512),
    [sym_qualified_identifier] = STATE(3663),
    [sym_qualified_type_identifier] = STATE(7442),
    [sym_user_defined_literal] = STATE(3663),
    [sym_identifier] = ACTIONS(3458),
    [anon_sym_LPAREN2] = ACTIONS(2575),
    [anon_sym_BANG] = ACTIONS(2577),
    [anon_sym_TILDE] = ACTIONS(2577),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON_COLON] = ACTIONS(2583),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2579),
    [anon_sym_compl] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(2597),
    [anon_sym_PLUS_PLUS] = ACTIONS(2597),
    [anon_sym_sizeof] = ACTIONS(2599),
    [anon_sym___alignof__] = ACTIONS(2601),
    [anon_sym___alignof] = ACTIONS(2601),
    [anon_sym__alignof] = ACTIONS(2601),
    [anon_sym_alignof] = ACTIONS(2601),
    [anon_sym__Alignof] = ACTIONS(2601),
    [anon_sym_offsetof] = ACTIONS(2603),
    [anon_sym__Generic] = ACTIONS(2605),
    [anon_sym_asm] = ACTIONS(2607),
    [anon_sym___asm__] = ACTIONS(2607),
    [aux_sym_number_literal_token1] = ACTIONS(2609),
    [aux_sym_number_literal_token2] = ACTIONS(2611),
    [anon_sym_L_SQUOTE] = ACTIONS(2613),
    [anon_sym_u_SQUOTE] = ACTIONS(2613),
    [anon_sym_U_SQUOTE] = ACTIONS(2613),
    [anon_sym_u8_SQUOTE] = ACTIONS(2613),
    [anon_sym_SQUOTE] = ACTIONS(2613),
    [anon_sym_L_DQUOTE] = ACTIONS(2615),
    [anon_sym_u_DQUOTE] = ACTIONS(2615),
    [anon_sym_U_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8_DQUOTE] = ACTIONS(2615),
    [anon_sym_DQUOTE] = ACTIONS(2615),
    [sym_true] = ACTIONS(2617),
    [sym_false] = ACTIONS(2617),
    [anon_sym_NULL] = ACTIONS(2619),
    [anon_sym_nullptr] = ACTIONS(2619),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2629),
    [anon_sym_R_DQUOTE] = ACTIONS(2631),
    [anon_sym_LR_DQUOTE] = ACTIONS(2631),
    [anon_sym_uR_DQUOTE] = ACTIONS(2631),
    [anon_sym_UR_DQUOTE] = ACTIONS(2631),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2631),
    [anon_sym_co_await] = ACTIONS(2633),
    [anon_sym_new] = ACTIONS(2635),
    [anon_sym_requires] = ACTIONS(2637),
    [sym_this] = ACTIONS(2617),
  },
  [1556] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(3281),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4226),
    [anon_sym_BANG] = ACTIONS(2218),
    [anon_sym_TILDE] = ACTIONS(2218),
    [anon_sym_DASH] = ACTIONS(2216),
    [anon_sym_PLUS] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(2220),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2216),
    [anon_sym_compl] = ACTIONS(2216),
    [anon_sym_DASH_DASH] = ACTIONS(4136),
    [anon_sym_PLUS_PLUS] = ACTIONS(4136),
    [anon_sym_sizeof] = ACTIONS(2222),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2224),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(2226),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1557] = {
    [sym_primitive_type] = STATE(6853),
    [sym__expression] = STATE(3609),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7464),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(7464),
    [sym_user_defined_literal] = STATE(3374),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_LPAREN2] = ACTIONS(1745),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [1558] = {
    [sym_primitive_type] = STATE(6853),
    [sym__expression] = STATE(3587),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7464),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(7464),
    [sym_user_defined_literal] = STATE(3374),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_LPAREN2] = ACTIONS(1745),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [1559] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4581),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1560] = {
    [sym_primitive_type] = STATE(6853),
    [sym__expression] = STATE(3589),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7464),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(7464),
    [sym_user_defined_literal] = STATE(3374),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_LPAREN2] = ACTIONS(1745),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [1561] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2479),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2832),
    [sym_char_literal] = STATE(2832),
    [sym_concatenated_string] = STATE(2831),
    [sym_string_literal] = STATE(1997),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(1998),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4244),
    [anon_sym_BANG] = ACTIONS(1889),
    [anon_sym_TILDE] = ACTIONS(1889),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_STAR] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(4238),
    [anon_sym_COLON_COLON] = ACTIONS(1891),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1887),
    [anon_sym_compl] = ACTIONS(1887),
    [anon_sym_DASH_DASH] = ACTIONS(4102),
    [anon_sym_PLUS_PLUS] = ACTIONS(4102),
    [anon_sym_sizeof] = ACTIONS(1895),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1905),
    [aux_sym_number_literal_token2] = ACTIONS(1907),
    [anon_sym_L_SQUOTE] = ACTIONS(1909),
    [anon_sym_u_SQUOTE] = ACTIONS(1909),
    [anon_sym_U_SQUOTE] = ACTIONS(1909),
    [anon_sym_u8_SQUOTE] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(1909),
    [anon_sym_L_DQUOTE] = ACTIONS(1911),
    [anon_sym_u_DQUOTE] = ACTIONS(1911),
    [anon_sym_U_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8_DQUOTE] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(1911),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1919),
    [anon_sym_R_DQUOTE] = ACTIONS(1921),
    [anon_sym_LR_DQUOTE] = ACTIONS(1921),
    [anon_sym_uR_DQUOTE] = ACTIONS(1921),
    [anon_sym_UR_DQUOTE] = ACTIONS(1921),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1921),
    [anon_sym_co_await] = ACTIONS(1923),
    [anon_sym_new] = ACTIONS(1925),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1562] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(3287),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4226),
    [anon_sym_BANG] = ACTIONS(2218),
    [anon_sym_TILDE] = ACTIONS(2218),
    [anon_sym_DASH] = ACTIONS(2216),
    [anon_sym_PLUS] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(2220),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2216),
    [anon_sym_compl] = ACTIONS(2216),
    [anon_sym_DASH_DASH] = ACTIONS(4136),
    [anon_sym_PLUS_PLUS] = ACTIONS(4136),
    [anon_sym_sizeof] = ACTIONS(2222),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2224),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(2226),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1563] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(3241),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4226),
    [anon_sym_BANG] = ACTIONS(2218),
    [anon_sym_TILDE] = ACTIONS(2218),
    [anon_sym_DASH] = ACTIONS(2216),
    [anon_sym_PLUS] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(2220),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2216),
    [anon_sym_compl] = ACTIONS(2216),
    [anon_sym_DASH_DASH] = ACTIONS(4136),
    [anon_sym_PLUS_PLUS] = ACTIONS(4136),
    [anon_sym_sizeof] = ACTIONS(2222),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2224),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(2226),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1564] = {
    [sym_primitive_type] = STATE(6853),
    [sym__expression] = STATE(3590),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7464),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(7464),
    [sym_user_defined_literal] = STATE(3374),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_LPAREN2] = ACTIONS(1745),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [1565] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4219),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(4494),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1566] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4491),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1567] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4536),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1568] = {
    [sym_primitive_type] = STATE(6853),
    [sym__expression] = STATE(3579),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7464),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(7464),
    [sym_user_defined_literal] = STATE(3374),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_LPAREN2] = ACTIONS(1745),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [1569] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4487),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1570] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4586),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1571] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4478),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1572] = {
    [sym_primitive_type] = STATE(6853),
    [sym__expression] = STATE(3596),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7464),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(7464),
    [sym_user_defined_literal] = STATE(3374),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_LPAREN2] = ACTIONS(1745),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [1573] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2910),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4218),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_TILDE] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1931),
    [anon_sym_PLUS] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(1935),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1931),
    [anon_sym_compl] = ACTIONS(1931),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_sizeof] = ACTIONS(1937),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1574] = {
    [sym_primitive_type] = STATE(6853),
    [sym__expression] = STATE(3654),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7464),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(7464),
    [sym_user_defined_literal] = STATE(3374),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_LPAREN2] = ACTIONS(1745),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(4496),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [1575] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4295),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1576] = {
    [sym_primitive_type] = STATE(6853),
    [sym__expression] = STATE(3628),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7464),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(7464),
    [sym_user_defined_literal] = STATE(3374),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_LPAREN2] = ACTIONS(1745),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [1577] = {
    [sym_primitive_type] = STATE(6853),
    [sym__expression] = STATE(3623),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7464),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(7464),
    [sym_user_defined_literal] = STATE(3374),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_LPAREN2] = ACTIONS(1745),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(4498),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [1578] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2913),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4218),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_TILDE] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1931),
    [anon_sym_PLUS] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(1935),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1931),
    [anon_sym_compl] = ACTIONS(1931),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_sizeof] = ACTIONS(1937),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1579] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2917),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4218),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_TILDE] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1931),
    [anon_sym_PLUS] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(1935),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1931),
    [anon_sym_compl] = ACTIONS(1931),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_sizeof] = ACTIONS(1937),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1580] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2921),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4218),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_TILDE] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1931),
    [anon_sym_PLUS] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(1935),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1931),
    [anon_sym_compl] = ACTIONS(1931),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_sizeof] = ACTIONS(1937),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1581] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4449),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1582] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4115),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(2961),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(2961),
    [sym_call_expression] = STATE(2961),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(2961),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(2961),
    [sym_number_literal] = STATE(4149),
    [sym_char_literal] = STATE(4149),
    [sym_concatenated_string] = STATE(4150),
    [sym_string_literal] = STATE(3034),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3026),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2961),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(2961),
    [sym_identifier] = ACTIONS(4082),
    [anon_sym_LPAREN2] = ACTIONS(4236),
    [anon_sym_BANG] = ACTIONS(3190),
    [anon_sym_TILDE] = ACTIONS(3190),
    [anon_sym_DASH] = ACTIONS(3188),
    [anon_sym_PLUS] = ACTIONS(3188),
    [anon_sym_STAR] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(4238),
    [anon_sym_COLON_COLON] = ACTIONS(3192),
    [anon_sym_LBRACK] = ACTIONS(4500),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3188),
    [anon_sym_compl] = ACTIONS(3188),
    [anon_sym_DASH_DASH] = ACTIONS(4088),
    [anon_sym_PLUS_PLUS] = ACTIONS(4088),
    [anon_sym_sizeof] = ACTIONS(3196),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3198),
    [aux_sym_number_literal_token2] = ACTIONS(3200),
    [anon_sym_L_SQUOTE] = ACTIONS(3202),
    [anon_sym_u_SQUOTE] = ACTIONS(3202),
    [anon_sym_U_SQUOTE] = ACTIONS(3202),
    [anon_sym_u8_SQUOTE] = ACTIONS(3202),
    [anon_sym_SQUOTE] = ACTIONS(3202),
    [anon_sym_L_DQUOTE] = ACTIONS(3204),
    [anon_sym_u_DQUOTE] = ACTIONS(3204),
    [anon_sym_U_DQUOTE] = ACTIONS(3204),
    [anon_sym_u8_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3204),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3206),
    [anon_sym_R_DQUOTE] = ACTIONS(3208),
    [anon_sym_LR_DQUOTE] = ACTIONS(3208),
    [anon_sym_uR_DQUOTE] = ACTIONS(3208),
    [anon_sym_UR_DQUOTE] = ACTIONS(3208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3208),
    [anon_sym_co_await] = ACTIONS(3210),
    [anon_sym_new] = ACTIONS(3212),
    [anon_sym_requires] = ACTIONS(3214),
    [sym_this] = ACTIONS(219),
  },
  [1583] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(3897),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(2961),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(2961),
    [sym_call_expression] = STATE(2961),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(2961),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(2961),
    [sym_number_literal] = STATE(4149),
    [sym_char_literal] = STATE(4149),
    [sym_concatenated_string] = STATE(4150),
    [sym_string_literal] = STATE(3034),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3026),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2961),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(2961),
    [sym_identifier] = ACTIONS(4082),
    [anon_sym_LPAREN2] = ACTIONS(4236),
    [anon_sym_BANG] = ACTIONS(3190),
    [anon_sym_TILDE] = ACTIONS(3190),
    [anon_sym_DASH] = ACTIONS(3188),
    [anon_sym_PLUS] = ACTIONS(3188),
    [anon_sym_STAR] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(4238),
    [anon_sym_COLON_COLON] = ACTIONS(3192),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3188),
    [anon_sym_compl] = ACTIONS(3188),
    [anon_sym_DASH_DASH] = ACTIONS(4088),
    [anon_sym_PLUS_PLUS] = ACTIONS(4088),
    [anon_sym_sizeof] = ACTIONS(3196),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3198),
    [aux_sym_number_literal_token2] = ACTIONS(3200),
    [anon_sym_L_SQUOTE] = ACTIONS(3202),
    [anon_sym_u_SQUOTE] = ACTIONS(3202),
    [anon_sym_U_SQUOTE] = ACTIONS(3202),
    [anon_sym_u8_SQUOTE] = ACTIONS(3202),
    [anon_sym_SQUOTE] = ACTIONS(3202),
    [anon_sym_L_DQUOTE] = ACTIONS(3204),
    [anon_sym_u_DQUOTE] = ACTIONS(3204),
    [anon_sym_U_DQUOTE] = ACTIONS(3204),
    [anon_sym_u8_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3204),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3206),
    [anon_sym_R_DQUOTE] = ACTIONS(3208),
    [anon_sym_LR_DQUOTE] = ACTIONS(3208),
    [anon_sym_uR_DQUOTE] = ACTIONS(3208),
    [anon_sym_UR_DQUOTE] = ACTIONS(3208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3208),
    [anon_sym_co_await] = ACTIONS(3210),
    [anon_sym_new] = ACTIONS(3212),
    [anon_sym_requires] = ACTIONS(3214),
    [sym_this] = ACTIONS(219),
  },
  [1584] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4328),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1585] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4123),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(2961),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(2961),
    [sym_call_expression] = STATE(2961),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(2961),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(2961),
    [sym_number_literal] = STATE(4149),
    [sym_char_literal] = STATE(4149),
    [sym_concatenated_string] = STATE(4150),
    [sym_string_literal] = STATE(3034),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3026),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2961),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(2961),
    [sym_identifier] = ACTIONS(4082),
    [anon_sym_LPAREN2] = ACTIONS(4236),
    [anon_sym_BANG] = ACTIONS(3190),
    [anon_sym_TILDE] = ACTIONS(3190),
    [anon_sym_DASH] = ACTIONS(3188),
    [anon_sym_PLUS] = ACTIONS(3188),
    [anon_sym_STAR] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(4238),
    [anon_sym_COLON_COLON] = ACTIONS(3192),
    [anon_sym_LBRACK] = ACTIONS(4502),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3188),
    [anon_sym_compl] = ACTIONS(3188),
    [anon_sym_DASH_DASH] = ACTIONS(4088),
    [anon_sym_PLUS_PLUS] = ACTIONS(4088),
    [anon_sym_sizeof] = ACTIONS(3196),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3198),
    [aux_sym_number_literal_token2] = ACTIONS(3200),
    [anon_sym_L_SQUOTE] = ACTIONS(3202),
    [anon_sym_u_SQUOTE] = ACTIONS(3202),
    [anon_sym_U_SQUOTE] = ACTIONS(3202),
    [anon_sym_u8_SQUOTE] = ACTIONS(3202),
    [anon_sym_SQUOTE] = ACTIONS(3202),
    [anon_sym_L_DQUOTE] = ACTIONS(3204),
    [anon_sym_u_DQUOTE] = ACTIONS(3204),
    [anon_sym_U_DQUOTE] = ACTIONS(3204),
    [anon_sym_u8_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3204),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3206),
    [anon_sym_R_DQUOTE] = ACTIONS(3208),
    [anon_sym_LR_DQUOTE] = ACTIONS(3208),
    [anon_sym_uR_DQUOTE] = ACTIONS(3208),
    [anon_sym_UR_DQUOTE] = ACTIONS(3208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3208),
    [anon_sym_co_await] = ACTIONS(3210),
    [anon_sym_new] = ACTIONS(3212),
    [anon_sym_requires] = ACTIONS(3214),
    [sym_this] = ACTIONS(219),
  },
  [1586] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4587),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1587] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4130),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(2961),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(2961),
    [sym_call_expression] = STATE(2961),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(2961),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(2961),
    [sym_number_literal] = STATE(4149),
    [sym_char_literal] = STATE(4149),
    [sym_concatenated_string] = STATE(4150),
    [sym_string_literal] = STATE(3034),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3026),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2961),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(2961),
    [sym_identifier] = ACTIONS(4082),
    [anon_sym_LPAREN2] = ACTIONS(4236),
    [anon_sym_BANG] = ACTIONS(3190),
    [anon_sym_TILDE] = ACTIONS(3190),
    [anon_sym_DASH] = ACTIONS(3188),
    [anon_sym_PLUS] = ACTIONS(3188),
    [anon_sym_STAR] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(4238),
    [anon_sym_COLON_COLON] = ACTIONS(3192),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3188),
    [anon_sym_compl] = ACTIONS(3188),
    [anon_sym_DASH_DASH] = ACTIONS(4088),
    [anon_sym_PLUS_PLUS] = ACTIONS(4088),
    [anon_sym_sizeof] = ACTIONS(3196),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3198),
    [aux_sym_number_literal_token2] = ACTIONS(3200),
    [anon_sym_L_SQUOTE] = ACTIONS(3202),
    [anon_sym_u_SQUOTE] = ACTIONS(3202),
    [anon_sym_U_SQUOTE] = ACTIONS(3202),
    [anon_sym_u8_SQUOTE] = ACTIONS(3202),
    [anon_sym_SQUOTE] = ACTIONS(3202),
    [anon_sym_L_DQUOTE] = ACTIONS(3204),
    [anon_sym_u_DQUOTE] = ACTIONS(3204),
    [anon_sym_U_DQUOTE] = ACTIONS(3204),
    [anon_sym_u8_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3204),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3206),
    [anon_sym_R_DQUOTE] = ACTIONS(3208),
    [anon_sym_LR_DQUOTE] = ACTIONS(3208),
    [anon_sym_uR_DQUOTE] = ACTIONS(3208),
    [anon_sym_UR_DQUOTE] = ACTIONS(3208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3208),
    [anon_sym_co_await] = ACTIONS(3210),
    [anon_sym_new] = ACTIONS(3212),
    [anon_sym_requires] = ACTIONS(3214),
    [sym_this] = ACTIONS(219),
  },
  [1588] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2922),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4218),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_TILDE] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1931),
    [anon_sym_PLUS] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(1935),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1931),
    [anon_sym_compl] = ACTIONS(1931),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_sizeof] = ACTIONS(1937),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1589] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2923),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4218),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_TILDE] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1931),
    [anon_sym_PLUS] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(1935),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1931),
    [anon_sym_compl] = ACTIONS(1931),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_sizeof] = ACTIONS(1937),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1590] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4369),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1591] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4230),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1592] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2926),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4218),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_TILDE] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1931),
    [anon_sym_PLUS] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(1935),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1931),
    [anon_sym_compl] = ACTIONS(1931),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_sizeof] = ACTIONS(1937),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1593] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4601),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1594] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4435),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1595] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4278),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1596] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4233),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3440),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3440),
    [sym_call_expression] = STATE(3440),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3440),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3440),
    [sym_number_literal] = STATE(4352),
    [sym_char_literal] = STATE(4352),
    [sym_concatenated_string] = STATE(4364),
    [sym_string_literal] = STATE(3640),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3641),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3440),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3440),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_LPAREN2] = ACTIONS(4046),
    [anon_sym_BANG] = ACTIONS(3344),
    [anon_sym_TILDE] = ACTIONS(3344),
    [anon_sym_DASH] = ACTIONS(3342),
    [anon_sym_PLUS] = ACTIONS(3342),
    [anon_sym_STAR] = ACTIONS(4048),
    [anon_sym_AMP] = ACTIONS(4048),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3342),
    [anon_sym_compl] = ACTIONS(3342),
    [anon_sym_DASH_DASH] = ACTIONS(4052),
    [anon_sym_PLUS_PLUS] = ACTIONS(4052),
    [anon_sym_sizeof] = ACTIONS(3348),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3350),
    [aux_sym_number_literal_token2] = ACTIONS(3352),
    [anon_sym_L_SQUOTE] = ACTIONS(3354),
    [anon_sym_u_SQUOTE] = ACTIONS(3354),
    [anon_sym_U_SQUOTE] = ACTIONS(3354),
    [anon_sym_u8_SQUOTE] = ACTIONS(3354),
    [anon_sym_SQUOTE] = ACTIONS(3354),
    [anon_sym_L_DQUOTE] = ACTIONS(3356),
    [anon_sym_u_DQUOTE] = ACTIONS(3356),
    [anon_sym_U_DQUOTE] = ACTIONS(3356),
    [anon_sym_u8_DQUOTE] = ACTIONS(3356),
    [anon_sym_DQUOTE] = ACTIONS(3356),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3358),
    [anon_sym_R_DQUOTE] = ACTIONS(3360),
    [anon_sym_LR_DQUOTE] = ACTIONS(3360),
    [anon_sym_uR_DQUOTE] = ACTIONS(3360),
    [anon_sym_UR_DQUOTE] = ACTIONS(3360),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3360),
    [anon_sym_co_await] = ACTIONS(3362),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1597] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2441),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(3292),
    [sym_char_literal] = STATE(3292),
    [sym_concatenated_string] = STATE(3308),
    [sym_string_literal] = STATE(2343),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2348),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1969),
    [anon_sym_LPAREN2] = ACTIONS(4256),
    [anon_sym_BANG] = ACTIONS(1973),
    [anon_sym_TILDE] = ACTIONS(1973),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_STAR] = ACTIONS(4048),
    [anon_sym_AMP] = ACTIONS(4048),
    [anon_sym_COLON_COLON] = ACTIONS(1975),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1971),
    [anon_sym_compl] = ACTIONS(1971),
    [anon_sym_DASH_DASH] = ACTIONS(4096),
    [anon_sym_PLUS_PLUS] = ACTIONS(4096),
    [anon_sym_sizeof] = ACTIONS(1977),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1979),
    [aux_sym_number_literal_token2] = ACTIONS(1981),
    [anon_sym_L_SQUOTE] = ACTIONS(1983),
    [anon_sym_u_SQUOTE] = ACTIONS(1983),
    [anon_sym_U_SQUOTE] = ACTIONS(1983),
    [anon_sym_u8_SQUOTE] = ACTIONS(1983),
    [anon_sym_SQUOTE] = ACTIONS(1983),
    [anon_sym_L_DQUOTE] = ACTIONS(1985),
    [anon_sym_u_DQUOTE] = ACTIONS(1985),
    [anon_sym_U_DQUOTE] = ACTIONS(1985),
    [anon_sym_u8_DQUOTE] = ACTIONS(1985),
    [anon_sym_DQUOTE] = ACTIONS(1985),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1987),
    [anon_sym_R_DQUOTE] = ACTIONS(1989),
    [anon_sym_LR_DQUOTE] = ACTIONS(1989),
    [anon_sym_uR_DQUOTE] = ACTIONS(1989),
    [anon_sym_UR_DQUOTE] = ACTIONS(1989),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1989),
    [anon_sym_co_await] = ACTIONS(1991),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1598] = {
    [sym_primitive_type] = STATE(6598),
    [sym__expression] = STATE(4627),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1599] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4633),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1600] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4609),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1601] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2928),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4218),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_TILDE] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1931),
    [anon_sym_PLUS] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(1935),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1931),
    [anon_sym_compl] = ACTIONS(1931),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_sizeof] = ACTIONS(1937),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1602] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4467),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3679),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3679),
    [sym_call_expression] = STATE(3679),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3679),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3679),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3679),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3679),
    [sym_identifier] = ACTIONS(3538),
    [anon_sym_LPAREN2] = ACTIONS(4199),
    [anon_sym_BANG] = ACTIONS(3542),
    [anon_sym_TILDE] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3540),
    [anon_sym_PLUS] = ACTIONS(3540),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(3544),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3540),
    [anon_sym_compl] = ACTIONS(3540),
    [anon_sym_DASH_DASH] = ACTIONS(4122),
    [anon_sym_PLUS_PLUS] = ACTIONS(4122),
    [anon_sym_sizeof] = ACTIONS(3546),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3548),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3550),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1603] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2441),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4218),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_TILDE] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1931),
    [anon_sym_PLUS] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(1935),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1931),
    [anon_sym_compl] = ACTIONS(1931),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_sizeof] = ACTIONS(1937),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1604] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(3319),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4226),
    [anon_sym_BANG] = ACTIONS(2218),
    [anon_sym_TILDE] = ACTIONS(2218),
    [anon_sym_DASH] = ACTIONS(2216),
    [anon_sym_PLUS] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(2220),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2216),
    [anon_sym_compl] = ACTIONS(2216),
    [anon_sym_DASH_DASH] = ACTIONS(4136),
    [anon_sym_PLUS_PLUS] = ACTIONS(4136),
    [anon_sym_sizeof] = ACTIONS(2222),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2224),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(2226),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1605] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(3314),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4226),
    [anon_sym_BANG] = ACTIONS(2218),
    [anon_sym_TILDE] = ACTIONS(2218),
    [anon_sym_DASH] = ACTIONS(2216),
    [anon_sym_PLUS] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(2220),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2216),
    [anon_sym_compl] = ACTIONS(2216),
    [anon_sym_DASH_DASH] = ACTIONS(4136),
    [anon_sym_PLUS_PLUS] = ACTIONS(4136),
    [anon_sym_sizeof] = ACTIONS(2222),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2224),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(2226),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1606] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2931),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4218),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_TILDE] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1931),
    [anon_sym_PLUS] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(1935),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1931),
    [anon_sym_compl] = ACTIONS(1931),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_sizeof] = ACTIONS(1937),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1607] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4537),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1608] = {
    [sym_primitive_type] = STATE(6669),
    [sym__expression] = STATE(4425),
    [sym__expression_not_binary] = STATE(4648),
    [sym__string] = STATE(4648),
    [sym_conditional_expression] = STATE(4648),
    [sym_assignment_expression] = STATE(4648),
    [sym_pointer_expression] = STATE(3663),
    [sym_unary_expression] = STATE(4648),
    [sym_binary_expression] = STATE(4648),
    [sym_update_expression] = STATE(4648),
    [sym_cast_expression] = STATE(4648),
    [sym_sizeof_expression] = STATE(4648),
    [sym_alignof_expression] = STATE(4648),
    [sym_offsetof_expression] = STATE(4648),
    [sym_generic_expression] = STATE(4648),
    [sym_subscript_expression] = STATE(3663),
    [sym_call_expression] = STATE(3663),
    [sym_gnu_asm_expression] = STATE(4648),
    [sym_field_expression] = STATE(3663),
    [sym_compound_literal_expression] = STATE(4648),
    [sym_parenthesized_expression] = STATE(3663),
    [sym_number_literal] = STATE(4573),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4565),
    [sym_string_literal] = STATE(3707),
    [sym_null] = STATE(4648),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7442),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(4648),
    [sym_raw_string_literal] = STATE(3709),
    [sym_co_await_expression] = STATE(4648),
    [sym_new_expression] = STATE(4648),
    [sym_delete_expression] = STATE(4648),
    [sym_requires_clause] = STATE(4648),
    [sym_requires_expression] = STATE(4648),
    [sym_lambda_expression] = STATE(4648),
    [sym_lambda_capture_specifier] = STATE(5768),
    [sym_fold_expression] = STATE(4648),
    [sym_parameter_pack_expansion] = STATE(4648),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5512),
    [sym_qualified_identifier] = STATE(3663),
    [sym_qualified_type_identifier] = STATE(7442),
    [sym_user_defined_literal] = STATE(3663),
    [sym_identifier] = ACTIONS(3458),
    [anon_sym_LPAREN2] = ACTIONS(2575),
    [anon_sym_BANG] = ACTIONS(2577),
    [anon_sym_TILDE] = ACTIONS(2577),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON_COLON] = ACTIONS(2583),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2579),
    [anon_sym_compl] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(2597),
    [anon_sym_PLUS_PLUS] = ACTIONS(2597),
    [anon_sym_sizeof] = ACTIONS(2599),
    [anon_sym___alignof__] = ACTIONS(2601),
    [anon_sym___alignof] = ACTIONS(2601),
    [anon_sym__alignof] = ACTIONS(2601),
    [anon_sym_alignof] = ACTIONS(2601),
    [anon_sym__Alignof] = ACTIONS(2601),
    [anon_sym_offsetof] = ACTIONS(2603),
    [anon_sym__Generic] = ACTIONS(2605),
    [anon_sym_asm] = ACTIONS(2607),
    [anon_sym___asm__] = ACTIONS(2607),
    [aux_sym_number_literal_token1] = ACTIONS(2609),
    [aux_sym_number_literal_token2] = ACTIONS(2611),
    [anon_sym_L_SQUOTE] = ACTIONS(2613),
    [anon_sym_u_SQUOTE] = ACTIONS(2613),
    [anon_sym_U_SQUOTE] = ACTIONS(2613),
    [anon_sym_u8_SQUOTE] = ACTIONS(2613),
    [anon_sym_SQUOTE] = ACTIONS(2613),
    [anon_sym_L_DQUOTE] = ACTIONS(2615),
    [anon_sym_u_DQUOTE] = ACTIONS(2615),
    [anon_sym_U_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8_DQUOTE] = ACTIONS(2615),
    [anon_sym_DQUOTE] = ACTIONS(2615),
    [sym_true] = ACTIONS(2617),
    [sym_false] = ACTIONS(2617),
    [anon_sym_NULL] = ACTIONS(2619),
    [anon_sym_nullptr] = ACTIONS(2619),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2629),
    [anon_sym_R_DQUOTE] = ACTIONS(2631),
    [anon_sym_LR_DQUOTE] = ACTIONS(2631),
    [anon_sym_uR_DQUOTE] = ACTIONS(2631),
    [anon_sym_UR_DQUOTE] = ACTIONS(2631),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2631),
    [anon_sym_co_await] = ACTIONS(2633),
    [anon_sym_new] = ACTIONS(2635),
    [anon_sym_requires] = ACTIONS(2637),
    [sym_this] = ACTIONS(2617),
  },
  [1609] = {
    [sym_primitive_type] = STATE(6853),
    [sym__expression] = STATE(3598),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7464),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(7464),
    [sym_user_defined_literal] = STATE(3374),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_LPAREN2] = ACTIONS(1745),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [1610] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4493),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1611] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4538),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1612] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4611),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1613] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(3895),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(2961),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(2961),
    [sym_call_expression] = STATE(2961),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(2961),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(2961),
    [sym_number_literal] = STATE(4149),
    [sym_char_literal] = STATE(4149),
    [sym_concatenated_string] = STATE(4150),
    [sym_string_literal] = STATE(3034),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3026),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2961),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(2961),
    [sym_identifier] = ACTIONS(4082),
    [anon_sym_LPAREN2] = ACTIONS(4236),
    [anon_sym_BANG] = ACTIONS(3190),
    [anon_sym_TILDE] = ACTIONS(3190),
    [anon_sym_DASH] = ACTIONS(3188),
    [anon_sym_PLUS] = ACTIONS(3188),
    [anon_sym_STAR] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(4238),
    [anon_sym_COLON_COLON] = ACTIONS(3192),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3188),
    [anon_sym_compl] = ACTIONS(3188),
    [anon_sym_DASH_DASH] = ACTIONS(4088),
    [anon_sym_PLUS_PLUS] = ACTIONS(4088),
    [anon_sym_sizeof] = ACTIONS(3196),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3198),
    [aux_sym_number_literal_token2] = ACTIONS(3200),
    [anon_sym_L_SQUOTE] = ACTIONS(3202),
    [anon_sym_u_SQUOTE] = ACTIONS(3202),
    [anon_sym_U_SQUOTE] = ACTIONS(3202),
    [anon_sym_u8_SQUOTE] = ACTIONS(3202),
    [anon_sym_SQUOTE] = ACTIONS(3202),
    [anon_sym_L_DQUOTE] = ACTIONS(3204),
    [anon_sym_u_DQUOTE] = ACTIONS(3204),
    [anon_sym_U_DQUOTE] = ACTIONS(3204),
    [anon_sym_u8_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3204),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3206),
    [anon_sym_R_DQUOTE] = ACTIONS(3208),
    [anon_sym_LR_DQUOTE] = ACTIONS(3208),
    [anon_sym_uR_DQUOTE] = ACTIONS(3208),
    [anon_sym_UR_DQUOTE] = ACTIONS(3208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3208),
    [anon_sym_co_await] = ACTIONS(3210),
    [anon_sym_new] = ACTIONS(3212),
    [anon_sym_requires] = ACTIONS(3214),
    [sym_this] = ACTIONS(219),
  },
  [1614] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4229),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1615] = {
    [sym_primitive_type] = STATE(6853),
    [sym__expression] = STATE(3599),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7464),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(7464),
    [sym_user_defined_literal] = STATE(3374),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_LPAREN2] = ACTIONS(1745),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [1616] = {
    [sym_primitive_type] = STATE(6853),
    [sym__expression] = STATE(3601),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7464),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(7464),
    [sym_user_defined_literal] = STATE(3374),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_LPAREN2] = ACTIONS(1745),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [1617] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(3795),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(2961),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(2961),
    [sym_call_expression] = STATE(2961),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(2961),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(2961),
    [sym_number_literal] = STATE(4149),
    [sym_char_literal] = STATE(4149),
    [sym_concatenated_string] = STATE(4150),
    [sym_string_literal] = STATE(3034),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3026),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2961),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(2961),
    [sym_identifier] = ACTIONS(4082),
    [anon_sym_LPAREN2] = ACTIONS(4236),
    [anon_sym_BANG] = ACTIONS(3190),
    [anon_sym_TILDE] = ACTIONS(3190),
    [anon_sym_DASH] = ACTIONS(3188),
    [anon_sym_PLUS] = ACTIONS(3188),
    [anon_sym_STAR] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(4238),
    [anon_sym_COLON_COLON] = ACTIONS(3192),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3188),
    [anon_sym_compl] = ACTIONS(3188),
    [anon_sym_DASH_DASH] = ACTIONS(4088),
    [anon_sym_PLUS_PLUS] = ACTIONS(4088),
    [anon_sym_sizeof] = ACTIONS(3196),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3198),
    [aux_sym_number_literal_token2] = ACTIONS(3200),
    [anon_sym_L_SQUOTE] = ACTIONS(3202),
    [anon_sym_u_SQUOTE] = ACTIONS(3202),
    [anon_sym_U_SQUOTE] = ACTIONS(3202),
    [anon_sym_u8_SQUOTE] = ACTIONS(3202),
    [anon_sym_SQUOTE] = ACTIONS(3202),
    [anon_sym_L_DQUOTE] = ACTIONS(3204),
    [anon_sym_u_DQUOTE] = ACTIONS(3204),
    [anon_sym_U_DQUOTE] = ACTIONS(3204),
    [anon_sym_u8_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3204),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3206),
    [anon_sym_R_DQUOTE] = ACTIONS(3208),
    [anon_sym_LR_DQUOTE] = ACTIONS(3208),
    [anon_sym_uR_DQUOTE] = ACTIONS(3208),
    [anon_sym_UR_DQUOTE] = ACTIONS(3208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3208),
    [anon_sym_co_await] = ACTIONS(3210),
    [anon_sym_new] = ACTIONS(3212),
    [anon_sym_requires] = ACTIONS(3214),
    [sym_this] = ACTIONS(219),
  },
  [1618] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2479),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(3292),
    [sym_char_literal] = STATE(3292),
    [sym_concatenated_string] = STATE(3308),
    [sym_string_literal] = STATE(2343),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2348),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1969),
    [anon_sym_LPAREN2] = ACTIONS(4256),
    [anon_sym_BANG] = ACTIONS(1973),
    [anon_sym_TILDE] = ACTIONS(1973),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_STAR] = ACTIONS(4048),
    [anon_sym_AMP] = ACTIONS(4048),
    [anon_sym_COLON_COLON] = ACTIONS(1975),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1971),
    [anon_sym_compl] = ACTIONS(1971),
    [anon_sym_DASH_DASH] = ACTIONS(4096),
    [anon_sym_PLUS_PLUS] = ACTIONS(4096),
    [anon_sym_sizeof] = ACTIONS(1977),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1979),
    [aux_sym_number_literal_token2] = ACTIONS(1981),
    [anon_sym_L_SQUOTE] = ACTIONS(1983),
    [anon_sym_u_SQUOTE] = ACTIONS(1983),
    [anon_sym_U_SQUOTE] = ACTIONS(1983),
    [anon_sym_u8_SQUOTE] = ACTIONS(1983),
    [anon_sym_SQUOTE] = ACTIONS(1983),
    [anon_sym_L_DQUOTE] = ACTIONS(1985),
    [anon_sym_u_DQUOTE] = ACTIONS(1985),
    [anon_sym_U_DQUOTE] = ACTIONS(1985),
    [anon_sym_u8_DQUOTE] = ACTIONS(1985),
    [anon_sym_DQUOTE] = ACTIONS(1985),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1987),
    [anon_sym_R_DQUOTE] = ACTIONS(1989),
    [anon_sym_LR_DQUOTE] = ACTIONS(1989),
    [anon_sym_uR_DQUOTE] = ACTIONS(1989),
    [anon_sym_UR_DQUOTE] = ACTIONS(1989),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1989),
    [anon_sym_co_await] = ACTIONS(1991),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1619] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4615),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1620] = {
    [sym_primitive_type] = STATE(6853),
    [sym__expression] = STATE(3602),
    [sym__expression_not_binary] = STATE(3836),
    [sym__string] = STATE(3836),
    [sym_conditional_expression] = STATE(3836),
    [sym_assignment_expression] = STATE(3836),
    [sym_pointer_expression] = STATE(3374),
    [sym_unary_expression] = STATE(3836),
    [sym_binary_expression] = STATE(3836),
    [sym_update_expression] = STATE(3836),
    [sym_cast_expression] = STATE(3836),
    [sym_sizeof_expression] = STATE(3836),
    [sym_alignof_expression] = STATE(3836),
    [sym_offsetof_expression] = STATE(3836),
    [sym_generic_expression] = STATE(3836),
    [sym_subscript_expression] = STATE(3374),
    [sym_call_expression] = STATE(3374),
    [sym_gnu_asm_expression] = STATE(3836),
    [sym_field_expression] = STATE(3374),
    [sym_compound_literal_expression] = STATE(3836),
    [sym_parenthesized_expression] = STATE(3374),
    [sym_number_literal] = STATE(3781),
    [sym_char_literal] = STATE(3781),
    [sym_concatenated_string] = STATE(3773),
    [sym_string_literal] = STATE(2498),
    [sym_null] = STATE(3836),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7464),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3836),
    [sym_raw_string_literal] = STATE(2497),
    [sym_co_await_expression] = STATE(3836),
    [sym_new_expression] = STATE(3836),
    [sym_delete_expression] = STATE(3836),
    [sym_requires_clause] = STATE(3836),
    [sym_requires_expression] = STATE(3836),
    [sym_lambda_expression] = STATE(3836),
    [sym_lambda_capture_specifier] = STATE(5723),
    [sym_fold_expression] = STATE(3836),
    [sym_parameter_pack_expansion] = STATE(3836),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3374),
    [sym_qualified_type_identifier] = STATE(7464),
    [sym_user_defined_literal] = STATE(3374),
    [sym_identifier] = ACTIONS(2471),
    [anon_sym_LPAREN2] = ACTIONS(1745),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_TILDE] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_compl] = ACTIONS(1749),
    [anon_sym_DASH_DASH] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1763),
    [anon_sym_sizeof] = ACTIONS(1765),
    [anon_sym___alignof__] = ACTIONS(1767),
    [anon_sym___alignof] = ACTIONS(1767),
    [anon_sym__alignof] = ACTIONS(1767),
    [anon_sym_alignof] = ACTIONS(1767),
    [anon_sym__Alignof] = ACTIONS(1767),
    [anon_sym_offsetof] = ACTIONS(1769),
    [anon_sym__Generic] = ACTIONS(1771),
    [anon_sym_asm] = ACTIONS(1773),
    [anon_sym___asm__] = ACTIONS(1773),
    [aux_sym_number_literal_token1] = ACTIONS(1775),
    [aux_sym_number_literal_token2] = ACTIONS(1777),
    [anon_sym_L_SQUOTE] = ACTIONS(1779),
    [anon_sym_u_SQUOTE] = ACTIONS(1779),
    [anon_sym_U_SQUOTE] = ACTIONS(1779),
    [anon_sym_u8_SQUOTE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [anon_sym_L_DQUOTE] = ACTIONS(1781),
    [anon_sym_u_DQUOTE] = ACTIONS(1781),
    [anon_sym_U_DQUOTE] = ACTIONS(1781),
    [anon_sym_u8_DQUOTE] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [sym_true] = ACTIONS(1783),
    [sym_false] = ACTIONS(1783),
    [anon_sym_NULL] = ACTIONS(1785),
    [anon_sym_nullptr] = ACTIONS(1785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_R_DQUOTE] = ACTIONS(1791),
    [anon_sym_LR_DQUOTE] = ACTIONS(1791),
    [anon_sym_uR_DQUOTE] = ACTIONS(1791),
    [anon_sym_UR_DQUOTE] = ACTIONS(1791),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1791),
    [anon_sym_co_await] = ACTIONS(1793),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_requires] = ACTIONS(1797),
    [sym_this] = ACTIONS(1783),
  },
  [1621] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4366),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1622] = {
    [sym_primitive_type] = STATE(6848),
    [sym__expression] = STATE(3149),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7357),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(7357),
    [sym_user_defined_literal] = STATE(3526),
    [sym_identifier] = ACTIONS(1965),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [1623] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4341),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1624] = {
    [sym_primitive_type] = STATE(6669),
    [sym__expression] = STATE(4370),
    [sym__expression_not_binary] = STATE(4648),
    [sym__string] = STATE(4648),
    [sym_conditional_expression] = STATE(4648),
    [sym_assignment_expression] = STATE(4648),
    [sym_pointer_expression] = STATE(3663),
    [sym_unary_expression] = STATE(4648),
    [sym_binary_expression] = STATE(4648),
    [sym_update_expression] = STATE(4648),
    [sym_cast_expression] = STATE(4648),
    [sym_sizeof_expression] = STATE(4648),
    [sym_alignof_expression] = STATE(4648),
    [sym_offsetof_expression] = STATE(4648),
    [sym_generic_expression] = STATE(4648),
    [sym_subscript_expression] = STATE(3663),
    [sym_call_expression] = STATE(3663),
    [sym_gnu_asm_expression] = STATE(4648),
    [sym_field_expression] = STATE(3663),
    [sym_compound_literal_expression] = STATE(4648),
    [sym_parenthesized_expression] = STATE(3663),
    [sym_number_literal] = STATE(4573),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4565),
    [sym_string_literal] = STATE(3707),
    [sym_null] = STATE(4648),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7442),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(4648),
    [sym_raw_string_literal] = STATE(3709),
    [sym_co_await_expression] = STATE(4648),
    [sym_new_expression] = STATE(4648),
    [sym_delete_expression] = STATE(4648),
    [sym_requires_clause] = STATE(4648),
    [sym_requires_expression] = STATE(4648),
    [sym_lambda_expression] = STATE(4648),
    [sym_lambda_capture_specifier] = STATE(5768),
    [sym_fold_expression] = STATE(4648),
    [sym_parameter_pack_expansion] = STATE(4648),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5512),
    [sym_qualified_identifier] = STATE(3663),
    [sym_qualified_type_identifier] = STATE(7442),
    [sym_user_defined_literal] = STATE(3663),
    [sym_identifier] = ACTIONS(3458),
    [anon_sym_LPAREN2] = ACTIONS(2575),
    [anon_sym_BANG] = ACTIONS(2577),
    [anon_sym_TILDE] = ACTIONS(2577),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON_COLON] = ACTIONS(2583),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2579),
    [anon_sym_compl] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(2597),
    [anon_sym_PLUS_PLUS] = ACTIONS(2597),
    [anon_sym_sizeof] = ACTIONS(2599),
    [anon_sym___alignof__] = ACTIONS(2601),
    [anon_sym___alignof] = ACTIONS(2601),
    [anon_sym__alignof] = ACTIONS(2601),
    [anon_sym_alignof] = ACTIONS(2601),
    [anon_sym__Alignof] = ACTIONS(2601),
    [anon_sym_offsetof] = ACTIONS(2603),
    [anon_sym__Generic] = ACTIONS(2605),
    [anon_sym_asm] = ACTIONS(2607),
    [anon_sym___asm__] = ACTIONS(2607),
    [aux_sym_number_literal_token1] = ACTIONS(2609),
    [aux_sym_number_literal_token2] = ACTIONS(2611),
    [anon_sym_L_SQUOTE] = ACTIONS(2613),
    [anon_sym_u_SQUOTE] = ACTIONS(2613),
    [anon_sym_U_SQUOTE] = ACTIONS(2613),
    [anon_sym_u8_SQUOTE] = ACTIONS(2613),
    [anon_sym_SQUOTE] = ACTIONS(2613),
    [anon_sym_L_DQUOTE] = ACTIONS(2615),
    [anon_sym_u_DQUOTE] = ACTIONS(2615),
    [anon_sym_U_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8_DQUOTE] = ACTIONS(2615),
    [anon_sym_DQUOTE] = ACTIONS(2615),
    [sym_true] = ACTIONS(2617),
    [sym_false] = ACTIONS(2617),
    [anon_sym_NULL] = ACTIONS(2619),
    [anon_sym_nullptr] = ACTIONS(2619),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2629),
    [anon_sym_R_DQUOTE] = ACTIONS(2631),
    [anon_sym_LR_DQUOTE] = ACTIONS(2631),
    [anon_sym_uR_DQUOTE] = ACTIONS(2631),
    [anon_sym_UR_DQUOTE] = ACTIONS(2631),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2631),
    [anon_sym_co_await] = ACTIONS(2633),
    [anon_sym_new] = ACTIONS(2635),
    [anon_sym_requires] = ACTIONS(2637),
    [sym_this] = ACTIONS(2617),
  },
  [1625] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4539),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1626] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4203),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1627] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(3885),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1628] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4195),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1629] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4540),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1630] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4206),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1631] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4213),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1632] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4215),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1633] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4190),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1634] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4187),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1635] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4198),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1636] = {
    [sym_primitive_type] = STATE(6848),
    [sym__expression] = STATE(3158),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7357),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(7357),
    [sym_user_defined_literal] = STATE(3526),
    [sym_identifier] = ACTIONS(1965),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_LBRACK] = ACTIONS(4504),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [1637] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4292),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1638] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4201),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1639] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4202),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1640] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4542),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1641] = {
    [sym_primitive_type] = STATE(6613),
    [sym__expression] = STATE(3318),
    [sym__expression_not_binary] = STATE(3637),
    [sym__string] = STATE(3637),
    [sym_conditional_expression] = STATE(3637),
    [sym_assignment_expression] = STATE(3637),
    [sym_pointer_expression] = STATE(3637),
    [sym_unary_expression] = STATE(3637),
    [sym_binary_expression] = STATE(3637),
    [sym_update_expression] = STATE(3637),
    [sym_cast_expression] = STATE(3637),
    [sym_sizeof_expression] = STATE(3637),
    [sym_alignof_expression] = STATE(3637),
    [sym_offsetof_expression] = STATE(3637),
    [sym_generic_expression] = STATE(3637),
    [sym_subscript_expression] = STATE(3637),
    [sym_call_expression] = STATE(3637),
    [sym_gnu_asm_expression] = STATE(3637),
    [sym_field_expression] = STATE(3637),
    [sym_compound_literal_expression] = STATE(3637),
    [sym_parenthesized_expression] = STATE(3637),
    [sym_number_literal] = STATE(3416),
    [sym_char_literal] = STATE(3416),
    [sym_concatenated_string] = STATE(3415),
    [sym_string_literal] = STATE(2430),
    [sym_null] = STATE(3637),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7434),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3637),
    [sym_raw_string_literal] = STATE(2419),
    [sym_co_await_expression] = STATE(3637),
    [sym_new_expression] = STATE(3637),
    [sym_delete_expression] = STATE(3637),
    [sym_requires_clause] = STATE(3637),
    [sym_requires_expression] = STATE(3637),
    [sym_lambda_expression] = STATE(3637),
    [sym_lambda_capture_specifier] = STATE(5725),
    [sym_fold_expression] = STATE(3637),
    [sym_parameter_pack_expansion] = STATE(3637),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5512),
    [sym_qualified_identifier] = STATE(3637),
    [sym_qualified_type_identifier] = STATE(7434),
    [sym_user_defined_literal] = STATE(3637),
    [sym_identifier] = ACTIONS(2228),
    [anon_sym_LPAREN2] = ACTIONS(4248),
    [anon_sym_BANG] = ACTIONS(2232),
    [anon_sym_TILDE] = ACTIONS(2232),
    [anon_sym_DASH] = ACTIONS(2230),
    [anon_sym_PLUS] = ACTIONS(2230),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON_COLON] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2230),
    [anon_sym_compl] = ACTIONS(2230),
    [anon_sym_DASH_DASH] = ACTIONS(4112),
    [anon_sym_PLUS_PLUS] = ACTIONS(4112),
    [anon_sym_sizeof] = ACTIONS(2238),
    [anon_sym___alignof__] = ACTIONS(2240),
    [anon_sym___alignof] = ACTIONS(2240),
    [anon_sym__alignof] = ACTIONS(2240),
    [anon_sym_alignof] = ACTIONS(2240),
    [anon_sym__Alignof] = ACTIONS(2240),
    [anon_sym_offsetof] = ACTIONS(2242),
    [anon_sym__Generic] = ACTIONS(2244),
    [anon_sym_asm] = ACTIONS(2246),
    [anon_sym___asm__] = ACTIONS(2246),
    [aux_sym_number_literal_token1] = ACTIONS(2248),
    [aux_sym_number_literal_token2] = ACTIONS(2250),
    [anon_sym_L_SQUOTE] = ACTIONS(2252),
    [anon_sym_u_SQUOTE] = ACTIONS(2252),
    [anon_sym_U_SQUOTE] = ACTIONS(2252),
    [anon_sym_u8_SQUOTE] = ACTIONS(2252),
    [anon_sym_SQUOTE] = ACTIONS(2252),
    [anon_sym_L_DQUOTE] = ACTIONS(2254),
    [anon_sym_u_DQUOTE] = ACTIONS(2254),
    [anon_sym_U_DQUOTE] = ACTIONS(2254),
    [anon_sym_u8_DQUOTE] = ACTIONS(2254),
    [anon_sym_DQUOTE] = ACTIONS(2254),
    [sym_true] = ACTIONS(2256),
    [sym_false] = ACTIONS(2256),
    [anon_sym_NULL] = ACTIONS(2258),
    [anon_sym_nullptr] = ACTIONS(2258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2260),
    [anon_sym_R_DQUOTE] = ACTIONS(2262),
    [anon_sym_LR_DQUOTE] = ACTIONS(2262),
    [anon_sym_uR_DQUOTE] = ACTIONS(2262),
    [anon_sym_UR_DQUOTE] = ACTIONS(2262),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2262),
    [anon_sym_co_await] = ACTIONS(2264),
    [anon_sym_new] = ACTIONS(2266),
    [anon_sym_requires] = ACTIONS(2268),
    [sym_this] = ACTIONS(2256),
  },
  [1642] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4326),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1643] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4506),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1644] = {
    [sym_primitive_type] = STATE(6669),
    [sym__expression] = STATE(4423),
    [sym__expression_not_binary] = STATE(4648),
    [sym__string] = STATE(4648),
    [sym_conditional_expression] = STATE(4648),
    [sym_assignment_expression] = STATE(4648),
    [sym_pointer_expression] = STATE(3663),
    [sym_unary_expression] = STATE(4648),
    [sym_binary_expression] = STATE(4648),
    [sym_update_expression] = STATE(4648),
    [sym_cast_expression] = STATE(4648),
    [sym_sizeof_expression] = STATE(4648),
    [sym_alignof_expression] = STATE(4648),
    [sym_offsetof_expression] = STATE(4648),
    [sym_generic_expression] = STATE(4648),
    [sym_subscript_expression] = STATE(3663),
    [sym_call_expression] = STATE(3663),
    [sym_gnu_asm_expression] = STATE(4648),
    [sym_field_expression] = STATE(3663),
    [sym_compound_literal_expression] = STATE(4648),
    [sym_parenthesized_expression] = STATE(3663),
    [sym_number_literal] = STATE(4573),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4565),
    [sym_string_literal] = STATE(3707),
    [sym_null] = STATE(4648),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7442),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(4648),
    [sym_raw_string_literal] = STATE(3709),
    [sym_co_await_expression] = STATE(4648),
    [sym_new_expression] = STATE(4648),
    [sym_delete_expression] = STATE(4648),
    [sym_requires_clause] = STATE(4648),
    [sym_requires_expression] = STATE(4648),
    [sym_lambda_expression] = STATE(4648),
    [sym_lambda_capture_specifier] = STATE(5768),
    [sym_fold_expression] = STATE(4648),
    [sym_parameter_pack_expansion] = STATE(4648),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5512),
    [sym_qualified_identifier] = STATE(3663),
    [sym_qualified_type_identifier] = STATE(7442),
    [sym_user_defined_literal] = STATE(3663),
    [sym_identifier] = ACTIONS(3458),
    [anon_sym_LPAREN2] = ACTIONS(2575),
    [anon_sym_BANG] = ACTIONS(2577),
    [anon_sym_TILDE] = ACTIONS(2577),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON_COLON] = ACTIONS(2583),
    [anon_sym_LBRACK] = ACTIONS(4506),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2579),
    [anon_sym_compl] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(2597),
    [anon_sym_PLUS_PLUS] = ACTIONS(2597),
    [anon_sym_sizeof] = ACTIONS(2599),
    [anon_sym___alignof__] = ACTIONS(2601),
    [anon_sym___alignof] = ACTIONS(2601),
    [anon_sym__alignof] = ACTIONS(2601),
    [anon_sym_alignof] = ACTIONS(2601),
    [anon_sym__Alignof] = ACTIONS(2601),
    [anon_sym_offsetof] = ACTIONS(2603),
    [anon_sym__Generic] = ACTIONS(2605),
    [anon_sym_asm] = ACTIONS(2607),
    [anon_sym___asm__] = ACTIONS(2607),
    [aux_sym_number_literal_token1] = ACTIONS(2609),
    [aux_sym_number_literal_token2] = ACTIONS(2611),
    [anon_sym_L_SQUOTE] = ACTIONS(2613),
    [anon_sym_u_SQUOTE] = ACTIONS(2613),
    [anon_sym_U_SQUOTE] = ACTIONS(2613),
    [anon_sym_u8_SQUOTE] = ACTIONS(2613),
    [anon_sym_SQUOTE] = ACTIONS(2613),
    [anon_sym_L_DQUOTE] = ACTIONS(2615),
    [anon_sym_u_DQUOTE] = ACTIONS(2615),
    [anon_sym_U_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8_DQUOTE] = ACTIONS(2615),
    [anon_sym_DQUOTE] = ACTIONS(2615),
    [sym_true] = ACTIONS(2617),
    [sym_false] = ACTIONS(2617),
    [anon_sym_NULL] = ACTIONS(2619),
    [anon_sym_nullptr] = ACTIONS(2619),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2629),
    [anon_sym_R_DQUOTE] = ACTIONS(2631),
    [anon_sym_LR_DQUOTE] = ACTIONS(2631),
    [anon_sym_uR_DQUOTE] = ACTIONS(2631),
    [anon_sym_UR_DQUOTE] = ACTIONS(2631),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2631),
    [anon_sym_co_await] = ACTIONS(2633),
    [anon_sym_new] = ACTIONS(2635),
    [anon_sym_requires] = ACTIONS(2637),
    [sym_this] = ACTIONS(2617),
  },
  [1645] = {
    [sym_primitive_type] = STATE(6669),
    [sym__expression] = STATE(4421),
    [sym__expression_not_binary] = STATE(4648),
    [sym__string] = STATE(4648),
    [sym_conditional_expression] = STATE(4648),
    [sym_assignment_expression] = STATE(4648),
    [sym_pointer_expression] = STATE(3663),
    [sym_unary_expression] = STATE(4648),
    [sym_binary_expression] = STATE(4648),
    [sym_update_expression] = STATE(4648),
    [sym_cast_expression] = STATE(4648),
    [sym_sizeof_expression] = STATE(4648),
    [sym_alignof_expression] = STATE(4648),
    [sym_offsetof_expression] = STATE(4648),
    [sym_generic_expression] = STATE(4648),
    [sym_subscript_expression] = STATE(3663),
    [sym_call_expression] = STATE(3663),
    [sym_gnu_asm_expression] = STATE(4648),
    [sym_field_expression] = STATE(3663),
    [sym_compound_literal_expression] = STATE(4648),
    [sym_parenthesized_expression] = STATE(3663),
    [sym_number_literal] = STATE(4573),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4565),
    [sym_string_literal] = STATE(3707),
    [sym_null] = STATE(4648),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7442),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(4648),
    [sym_raw_string_literal] = STATE(3709),
    [sym_co_await_expression] = STATE(4648),
    [sym_new_expression] = STATE(4648),
    [sym_delete_expression] = STATE(4648),
    [sym_requires_clause] = STATE(4648),
    [sym_requires_expression] = STATE(4648),
    [sym_lambda_expression] = STATE(4648),
    [sym_lambda_capture_specifier] = STATE(5768),
    [sym_fold_expression] = STATE(4648),
    [sym_parameter_pack_expansion] = STATE(4648),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5512),
    [sym_qualified_identifier] = STATE(3663),
    [sym_qualified_type_identifier] = STATE(7442),
    [sym_user_defined_literal] = STATE(3663),
    [sym_identifier] = ACTIONS(3458),
    [anon_sym_LPAREN2] = ACTIONS(2575),
    [anon_sym_BANG] = ACTIONS(2577),
    [anon_sym_TILDE] = ACTIONS(2577),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON_COLON] = ACTIONS(2583),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2579),
    [anon_sym_compl] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(2597),
    [anon_sym_PLUS_PLUS] = ACTIONS(2597),
    [anon_sym_sizeof] = ACTIONS(2599),
    [anon_sym___alignof__] = ACTIONS(2601),
    [anon_sym___alignof] = ACTIONS(2601),
    [anon_sym__alignof] = ACTIONS(2601),
    [anon_sym_alignof] = ACTIONS(2601),
    [anon_sym__Alignof] = ACTIONS(2601),
    [anon_sym_offsetof] = ACTIONS(2603),
    [anon_sym__Generic] = ACTIONS(2605),
    [anon_sym_asm] = ACTIONS(2607),
    [anon_sym___asm__] = ACTIONS(2607),
    [aux_sym_number_literal_token1] = ACTIONS(2609),
    [aux_sym_number_literal_token2] = ACTIONS(2611),
    [anon_sym_L_SQUOTE] = ACTIONS(2613),
    [anon_sym_u_SQUOTE] = ACTIONS(2613),
    [anon_sym_U_SQUOTE] = ACTIONS(2613),
    [anon_sym_u8_SQUOTE] = ACTIONS(2613),
    [anon_sym_SQUOTE] = ACTIONS(2613),
    [anon_sym_L_DQUOTE] = ACTIONS(2615),
    [anon_sym_u_DQUOTE] = ACTIONS(2615),
    [anon_sym_U_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8_DQUOTE] = ACTIONS(2615),
    [anon_sym_DQUOTE] = ACTIONS(2615),
    [sym_true] = ACTIONS(2617),
    [sym_false] = ACTIONS(2617),
    [anon_sym_NULL] = ACTIONS(2619),
    [anon_sym_nullptr] = ACTIONS(2619),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2629),
    [anon_sym_R_DQUOTE] = ACTIONS(2631),
    [anon_sym_LR_DQUOTE] = ACTIONS(2631),
    [anon_sym_uR_DQUOTE] = ACTIONS(2631),
    [anon_sym_UR_DQUOTE] = ACTIONS(2631),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2631),
    [anon_sym_co_await] = ACTIONS(2633),
    [anon_sym_new] = ACTIONS(2635),
    [anon_sym_requires] = ACTIONS(2637),
    [sym_this] = ACTIONS(2617),
  },
  [1646] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4577),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1647] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4559),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3679),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3679),
    [sym_call_expression] = STATE(3679),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3679),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3679),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3679),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3679),
    [sym_identifier] = ACTIONS(3538),
    [anon_sym_LPAREN2] = ACTIONS(4199),
    [anon_sym_BANG] = ACTIONS(3542),
    [anon_sym_TILDE] = ACTIONS(3542),
    [anon_sym_DASH] = ACTIONS(3540),
    [anon_sym_PLUS] = ACTIONS(3540),
    [anon_sym_STAR] = ACTIONS(4201),
    [anon_sym_AMP] = ACTIONS(4201),
    [anon_sym_COLON_COLON] = ACTIONS(3544),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3540),
    [anon_sym_compl] = ACTIONS(3540),
    [anon_sym_DASH_DASH] = ACTIONS(4122),
    [anon_sym_PLUS_PLUS] = ACTIONS(4122),
    [anon_sym_sizeof] = ACTIONS(3546),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3548),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3550),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1648] = {
    [sym_primitive_type] = STATE(6669),
    [sym__expression] = STATE(4400),
    [sym__expression_not_binary] = STATE(4648),
    [sym__string] = STATE(4648),
    [sym_conditional_expression] = STATE(4648),
    [sym_assignment_expression] = STATE(4648),
    [sym_pointer_expression] = STATE(3663),
    [sym_unary_expression] = STATE(4648),
    [sym_binary_expression] = STATE(4648),
    [sym_update_expression] = STATE(4648),
    [sym_cast_expression] = STATE(4648),
    [sym_sizeof_expression] = STATE(4648),
    [sym_alignof_expression] = STATE(4648),
    [sym_offsetof_expression] = STATE(4648),
    [sym_generic_expression] = STATE(4648),
    [sym_subscript_expression] = STATE(3663),
    [sym_call_expression] = STATE(3663),
    [sym_gnu_asm_expression] = STATE(4648),
    [sym_field_expression] = STATE(3663),
    [sym_compound_literal_expression] = STATE(4648),
    [sym_parenthesized_expression] = STATE(3663),
    [sym_number_literal] = STATE(4573),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4565),
    [sym_string_literal] = STATE(3707),
    [sym_null] = STATE(4648),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7442),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(4648),
    [sym_raw_string_literal] = STATE(3709),
    [sym_co_await_expression] = STATE(4648),
    [sym_new_expression] = STATE(4648),
    [sym_delete_expression] = STATE(4648),
    [sym_requires_clause] = STATE(4648),
    [sym_requires_expression] = STATE(4648),
    [sym_lambda_expression] = STATE(4648),
    [sym_lambda_capture_specifier] = STATE(5768),
    [sym_fold_expression] = STATE(4648),
    [sym_parameter_pack_expansion] = STATE(4648),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5512),
    [sym_qualified_identifier] = STATE(3663),
    [sym_qualified_type_identifier] = STATE(7442),
    [sym_user_defined_literal] = STATE(3663),
    [sym_identifier] = ACTIONS(3458),
    [anon_sym_LPAREN2] = ACTIONS(2575),
    [anon_sym_BANG] = ACTIONS(2577),
    [anon_sym_TILDE] = ACTIONS(2577),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON_COLON] = ACTIONS(2583),
    [anon_sym_LBRACK] = ACTIONS(4508),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2579),
    [anon_sym_compl] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(2597),
    [anon_sym_PLUS_PLUS] = ACTIONS(2597),
    [anon_sym_sizeof] = ACTIONS(2599),
    [anon_sym___alignof__] = ACTIONS(2601),
    [anon_sym___alignof] = ACTIONS(2601),
    [anon_sym__alignof] = ACTIONS(2601),
    [anon_sym_alignof] = ACTIONS(2601),
    [anon_sym__Alignof] = ACTIONS(2601),
    [anon_sym_offsetof] = ACTIONS(2603),
    [anon_sym__Generic] = ACTIONS(2605),
    [anon_sym_asm] = ACTIONS(2607),
    [anon_sym___asm__] = ACTIONS(2607),
    [aux_sym_number_literal_token1] = ACTIONS(2609),
    [aux_sym_number_literal_token2] = ACTIONS(2611),
    [anon_sym_L_SQUOTE] = ACTIONS(2613),
    [anon_sym_u_SQUOTE] = ACTIONS(2613),
    [anon_sym_U_SQUOTE] = ACTIONS(2613),
    [anon_sym_u8_SQUOTE] = ACTIONS(2613),
    [anon_sym_SQUOTE] = ACTIONS(2613),
    [anon_sym_L_DQUOTE] = ACTIONS(2615),
    [anon_sym_u_DQUOTE] = ACTIONS(2615),
    [anon_sym_U_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8_DQUOTE] = ACTIONS(2615),
    [anon_sym_DQUOTE] = ACTIONS(2615),
    [sym_true] = ACTIONS(2617),
    [sym_false] = ACTIONS(2617),
    [anon_sym_NULL] = ACTIONS(2619),
    [anon_sym_nullptr] = ACTIONS(2619),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2629),
    [anon_sym_R_DQUOTE] = ACTIONS(2631),
    [anon_sym_LR_DQUOTE] = ACTIONS(2631),
    [anon_sym_uR_DQUOTE] = ACTIONS(2631),
    [anon_sym_UR_DQUOTE] = ACTIONS(2631),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2631),
    [anon_sym_co_await] = ACTIONS(2633),
    [anon_sym_new] = ACTIONS(2635),
    [anon_sym_requires] = ACTIONS(2637),
    [sym_this] = ACTIONS(2617),
  },
  [1649] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4561),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1650] = {
    [sym_primitive_type] = STATE(6848),
    [sym__expression] = STATE(3157),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7357),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(7357),
    [sym_user_defined_literal] = STATE(3526),
    [sym_identifier] = ACTIONS(1965),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [1651] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4608),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1652] = {
    [sym_primitive_type] = STATE(6848),
    [sym__expression] = STATE(3157),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7357),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(7357),
    [sym_user_defined_literal] = STATE(3526),
    [sym_identifier] = ACTIONS(4510),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [1653] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4572),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1654] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4589),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1655] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(3895),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1656] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(3895),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(4512),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1657] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4555),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1658] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2463),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4218),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_TILDE] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1931),
    [anon_sym_PLUS] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(1935),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1931),
    [anon_sym_compl] = ACTIONS(1931),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_sizeof] = ACTIONS(1937),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1659] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4576),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3611),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3611),
    [sym_call_expression] = STATE(3611),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3611),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3611),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3611),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3611),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_LPAREN2] = ACTIONS(3566),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3482),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3480),
    [anon_sym_compl] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3570),
    [anon_sym_PLUS_PLUS] = ACTIONS(3570),
    [anon_sym_sizeof] = ACTIONS(3486),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3490),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1660] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2904),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4218),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_TILDE] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1931),
    [anon_sym_PLUS] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(1935),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1931),
    [anon_sym_compl] = ACTIONS(1931),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_sizeof] = ACTIONS(1937),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1661] = {
    [sym_primitive_type] = STATE(6848),
    [sym__expression] = STATE(3110),
    [sym__expression_not_binary] = STATE(3526),
    [sym__string] = STATE(3526),
    [sym_conditional_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_pointer_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_update_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_sizeof_expression] = STATE(3526),
    [sym_alignof_expression] = STATE(3526),
    [sym_offsetof_expression] = STATE(3526),
    [sym_generic_expression] = STATE(3526),
    [sym_subscript_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_gnu_asm_expression] = STATE(3526),
    [sym_field_expression] = STATE(3526),
    [sym_compound_literal_expression] = STATE(3526),
    [sym_parenthesized_expression] = STATE(3526),
    [sym_number_literal] = STATE(3237),
    [sym_char_literal] = STATE(3237),
    [sym_concatenated_string] = STATE(3307),
    [sym_string_literal] = STATE(2389),
    [sym_null] = STATE(3526),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7357),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3526),
    [sym_raw_string_literal] = STATE(2390),
    [sym_co_await_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_requires_clause] = STATE(3526),
    [sym_requires_expression] = STATE(3526),
    [sym_lambda_expression] = STATE(3526),
    [sym_lambda_capture_specifier] = STATE(5774),
    [sym_fold_expression] = STATE(3526),
    [sym_parameter_pack_expansion] = STATE(3526),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5538),
    [sym_qualified_identifier] = STATE(3526),
    [sym_qualified_type_identifier] = STATE(7357),
    [sym_user_defined_literal] = STATE(3526),
    [sym_identifier] = ACTIONS(1965),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1817),
    [anon_sym_compl] = ACTIONS(1817),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_sizeof] = ACTIONS(1843),
    [anon_sym___alignof__] = ACTIONS(1845),
    [anon_sym___alignof] = ACTIONS(1845),
    [anon_sym__alignof] = ACTIONS(1845),
    [anon_sym_alignof] = ACTIONS(1845),
    [anon_sym__Alignof] = ACTIONS(1845),
    [anon_sym_offsetof] = ACTIONS(1847),
    [anon_sym__Generic] = ACTIONS(1849),
    [anon_sym_asm] = ACTIONS(1851),
    [anon_sym___asm__] = ACTIONS(1851),
    [aux_sym_number_literal_token1] = ACTIONS(1853),
    [aux_sym_number_literal_token2] = ACTIONS(1855),
    [anon_sym_L_SQUOTE] = ACTIONS(1857),
    [anon_sym_u_SQUOTE] = ACTIONS(1857),
    [anon_sym_U_SQUOTE] = ACTIONS(1857),
    [anon_sym_u8_SQUOTE] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_L_DQUOTE] = ACTIONS(1859),
    [anon_sym_u_DQUOTE] = ACTIONS(1859),
    [anon_sym_U_DQUOTE] = ACTIONS(1859),
    [anon_sym_u8_DQUOTE] = ACTIONS(1859),
    [anon_sym_DQUOTE] = ACTIONS(1859),
    [sym_true] = ACTIONS(1861),
    [sym_false] = ACTIONS(1861),
    [anon_sym_NULL] = ACTIONS(1863),
    [anon_sym_nullptr] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1873),
    [anon_sym_R_DQUOTE] = ACTIONS(1875),
    [anon_sym_LR_DQUOTE] = ACTIONS(1875),
    [anon_sym_uR_DQUOTE] = ACTIONS(1875),
    [anon_sym_UR_DQUOTE] = ACTIONS(1875),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1875),
    [anon_sym_co_await] = ACTIONS(1877),
    [anon_sym_new] = ACTIONS(1879),
    [anon_sym_requires] = ACTIONS(1881),
    [sym_this] = ACTIONS(1861),
  },
  [1662] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4282),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1663] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2479),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(4514),
    [anon_sym_LPAREN2] = ACTIONS(4218),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_TILDE] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1931),
    [anon_sym_PLUS] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(1935),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1931),
    [anon_sym_compl] = ACTIONS(1931),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_sizeof] = ACTIONS(1937),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1664] = {
    [sym_primitive_type] = STATE(6669),
    [sym__expression] = STATE(4344),
    [sym__expression_not_binary] = STATE(4648),
    [sym__string] = STATE(4648),
    [sym_conditional_expression] = STATE(4648),
    [sym_assignment_expression] = STATE(4648),
    [sym_pointer_expression] = STATE(3663),
    [sym_unary_expression] = STATE(4648),
    [sym_binary_expression] = STATE(4648),
    [sym_update_expression] = STATE(4648),
    [sym_cast_expression] = STATE(4648),
    [sym_sizeof_expression] = STATE(4648),
    [sym_alignof_expression] = STATE(4648),
    [sym_offsetof_expression] = STATE(4648),
    [sym_generic_expression] = STATE(4648),
    [sym_subscript_expression] = STATE(3663),
    [sym_call_expression] = STATE(3663),
    [sym_gnu_asm_expression] = STATE(4648),
    [sym_field_expression] = STATE(3663),
    [sym_compound_literal_expression] = STATE(4648),
    [sym_parenthesized_expression] = STATE(3663),
    [sym_number_literal] = STATE(4573),
    [sym_char_literal] = STATE(4573),
    [sym_concatenated_string] = STATE(4565),
    [sym_string_literal] = STATE(3707),
    [sym_null] = STATE(4648),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7442),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(4648),
    [sym_raw_string_literal] = STATE(3709),
    [sym_co_await_expression] = STATE(4648),
    [sym_new_expression] = STATE(4648),
    [sym_delete_expression] = STATE(4648),
    [sym_requires_clause] = STATE(4648),
    [sym_requires_expression] = STATE(4648),
    [sym_lambda_expression] = STATE(4648),
    [sym_lambda_capture_specifier] = STATE(5768),
    [sym_fold_expression] = STATE(4648),
    [sym_parameter_pack_expansion] = STATE(4648),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5512),
    [sym_qualified_identifier] = STATE(3663),
    [sym_qualified_type_identifier] = STATE(7442),
    [sym_user_defined_literal] = STATE(3663),
    [sym_identifier] = ACTIONS(3458),
    [anon_sym_LPAREN2] = ACTIONS(2575),
    [anon_sym_BANG] = ACTIONS(2577),
    [anon_sym_TILDE] = ACTIONS(2577),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_AMP] = ACTIONS(2581),
    [anon_sym_COLON_COLON] = ACTIONS(2583),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(2579),
    [anon_sym_compl] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(2597),
    [anon_sym_PLUS_PLUS] = ACTIONS(2597),
    [anon_sym_sizeof] = ACTIONS(2599),
    [anon_sym___alignof__] = ACTIONS(2601),
    [anon_sym___alignof] = ACTIONS(2601),
    [anon_sym__alignof] = ACTIONS(2601),
    [anon_sym_alignof] = ACTIONS(2601),
    [anon_sym__Alignof] = ACTIONS(2601),
    [anon_sym_offsetof] = ACTIONS(2603),
    [anon_sym__Generic] = ACTIONS(2605),
    [anon_sym_asm] = ACTIONS(2607),
    [anon_sym___asm__] = ACTIONS(2607),
    [aux_sym_number_literal_token1] = ACTIONS(2609),
    [aux_sym_number_literal_token2] = ACTIONS(2611),
    [anon_sym_L_SQUOTE] = ACTIONS(2613),
    [anon_sym_u_SQUOTE] = ACTIONS(2613),
    [anon_sym_U_SQUOTE] = ACTIONS(2613),
    [anon_sym_u8_SQUOTE] = ACTIONS(2613),
    [anon_sym_SQUOTE] = ACTIONS(2613),
    [anon_sym_L_DQUOTE] = ACTIONS(2615),
    [anon_sym_u_DQUOTE] = ACTIONS(2615),
    [anon_sym_U_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8_DQUOTE] = ACTIONS(2615),
    [anon_sym_DQUOTE] = ACTIONS(2615),
    [sym_true] = ACTIONS(2617),
    [sym_false] = ACTIONS(2617),
    [anon_sym_NULL] = ACTIONS(2619),
    [anon_sym_nullptr] = ACTIONS(2619),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(2629),
    [anon_sym_R_DQUOTE] = ACTIONS(2631),
    [anon_sym_LR_DQUOTE] = ACTIONS(2631),
    [anon_sym_uR_DQUOTE] = ACTIONS(2631),
    [anon_sym_UR_DQUOTE] = ACTIONS(2631),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2631),
    [anon_sym_co_await] = ACTIONS(2633),
    [anon_sym_new] = ACTIONS(2635),
    [anon_sym_requires] = ACTIONS(2637),
    [sym_this] = ACTIONS(2617),
  },
  [1665] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4268),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3440),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3440),
    [sym_call_expression] = STATE(3440),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3440),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3440),
    [sym_number_literal] = STATE(4352),
    [sym_char_literal] = STATE(4352),
    [sym_concatenated_string] = STATE(4364),
    [sym_string_literal] = STATE(3640),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3641),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3440),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3440),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_LPAREN2] = ACTIONS(4046),
    [anon_sym_BANG] = ACTIONS(3344),
    [anon_sym_TILDE] = ACTIONS(3344),
    [anon_sym_DASH] = ACTIONS(3342),
    [anon_sym_PLUS] = ACTIONS(3342),
    [anon_sym_STAR] = ACTIONS(4048),
    [anon_sym_AMP] = ACTIONS(4048),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3342),
    [anon_sym_compl] = ACTIONS(3342),
    [anon_sym_DASH_DASH] = ACTIONS(4052),
    [anon_sym_PLUS_PLUS] = ACTIONS(4052),
    [anon_sym_sizeof] = ACTIONS(3348),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3350),
    [aux_sym_number_literal_token2] = ACTIONS(3352),
    [anon_sym_L_SQUOTE] = ACTIONS(3354),
    [anon_sym_u_SQUOTE] = ACTIONS(3354),
    [anon_sym_U_SQUOTE] = ACTIONS(3354),
    [anon_sym_u8_SQUOTE] = ACTIONS(3354),
    [anon_sym_SQUOTE] = ACTIONS(3354),
    [anon_sym_L_DQUOTE] = ACTIONS(3356),
    [anon_sym_u_DQUOTE] = ACTIONS(3356),
    [anon_sym_U_DQUOTE] = ACTIONS(3356),
    [anon_sym_u8_DQUOTE] = ACTIONS(3356),
    [anon_sym_DQUOTE] = ACTIONS(3356),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3358),
    [anon_sym_R_DQUOTE] = ACTIONS(3360),
    [anon_sym_LR_DQUOTE] = ACTIONS(3360),
    [anon_sym_uR_DQUOTE] = ACTIONS(3360),
    [anon_sym_UR_DQUOTE] = ACTIONS(3360),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3360),
    [anon_sym_co_await] = ACTIONS(3362),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1666] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4269),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3440),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3440),
    [sym_call_expression] = STATE(3440),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3440),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3440),
    [sym_number_literal] = STATE(4352),
    [sym_char_literal] = STATE(4352),
    [sym_concatenated_string] = STATE(4364),
    [sym_string_literal] = STATE(3640),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3641),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3440),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3440),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_LPAREN2] = ACTIONS(4046),
    [anon_sym_BANG] = ACTIONS(3344),
    [anon_sym_TILDE] = ACTIONS(3344),
    [anon_sym_DASH] = ACTIONS(3342),
    [anon_sym_PLUS] = ACTIONS(3342),
    [anon_sym_STAR] = ACTIONS(4048),
    [anon_sym_AMP] = ACTIONS(4048),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3342),
    [anon_sym_compl] = ACTIONS(3342),
    [anon_sym_DASH_DASH] = ACTIONS(4052),
    [anon_sym_PLUS_PLUS] = ACTIONS(4052),
    [anon_sym_sizeof] = ACTIONS(3348),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3350),
    [aux_sym_number_literal_token2] = ACTIONS(3352),
    [anon_sym_L_SQUOTE] = ACTIONS(3354),
    [anon_sym_u_SQUOTE] = ACTIONS(3354),
    [anon_sym_U_SQUOTE] = ACTIONS(3354),
    [anon_sym_u8_SQUOTE] = ACTIONS(3354),
    [anon_sym_SQUOTE] = ACTIONS(3354),
    [anon_sym_L_DQUOTE] = ACTIONS(3356),
    [anon_sym_u_DQUOTE] = ACTIONS(3356),
    [anon_sym_U_DQUOTE] = ACTIONS(3356),
    [anon_sym_u8_DQUOTE] = ACTIONS(3356),
    [anon_sym_DQUOTE] = ACTIONS(3356),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3358),
    [anon_sym_R_DQUOTE] = ACTIONS(3360),
    [anon_sym_LR_DQUOTE] = ACTIONS(3360),
    [anon_sym_uR_DQUOTE] = ACTIONS(3360),
    [anon_sym_UR_DQUOTE] = ACTIONS(3360),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3360),
    [anon_sym_co_await] = ACTIONS(3362),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1667] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(2479),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_concatenated_string] = STATE(2892),
    [sym_string_literal] = STATE(2048),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2046),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1929),
    [anon_sym_LPAREN2] = ACTIONS(4218),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_TILDE] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1931),
    [anon_sym_PLUS] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(1935),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1931),
    [anon_sym_compl] = ACTIONS(1931),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_sizeof] = ACTIONS(1937),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1939),
    [aux_sym_number_literal_token2] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1668] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4270),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3440),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3440),
    [sym_call_expression] = STATE(3440),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3440),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3440),
    [sym_number_literal] = STATE(4352),
    [sym_char_literal] = STATE(4352),
    [sym_concatenated_string] = STATE(4364),
    [sym_string_literal] = STATE(3640),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3641),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3440),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3440),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_LPAREN2] = ACTIONS(4046),
    [anon_sym_BANG] = ACTIONS(3344),
    [anon_sym_TILDE] = ACTIONS(3344),
    [anon_sym_DASH] = ACTIONS(3342),
    [anon_sym_PLUS] = ACTIONS(3342),
    [anon_sym_STAR] = ACTIONS(4048),
    [anon_sym_AMP] = ACTIONS(4048),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3342),
    [anon_sym_compl] = ACTIONS(3342),
    [anon_sym_DASH_DASH] = ACTIONS(4052),
    [anon_sym_PLUS_PLUS] = ACTIONS(4052),
    [anon_sym_sizeof] = ACTIONS(3348),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3350),
    [aux_sym_number_literal_token2] = ACTIONS(3352),
    [anon_sym_L_SQUOTE] = ACTIONS(3354),
    [anon_sym_u_SQUOTE] = ACTIONS(3354),
    [anon_sym_U_SQUOTE] = ACTIONS(3354),
    [anon_sym_u8_SQUOTE] = ACTIONS(3354),
    [anon_sym_SQUOTE] = ACTIONS(3354),
    [anon_sym_L_DQUOTE] = ACTIONS(3356),
    [anon_sym_u_DQUOTE] = ACTIONS(3356),
    [anon_sym_U_DQUOTE] = ACTIONS(3356),
    [anon_sym_u8_DQUOTE] = ACTIONS(3356),
    [anon_sym_DQUOTE] = ACTIONS(3356),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3358),
    [anon_sym_R_DQUOTE] = ACTIONS(3360),
    [anon_sym_LR_DQUOTE] = ACTIONS(3360),
    [anon_sym_uR_DQUOTE] = ACTIONS(3360),
    [anon_sym_UR_DQUOTE] = ACTIONS(3360),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3360),
    [anon_sym_co_await] = ACTIONS(3362),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1669] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4272),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3440),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3440),
    [sym_call_expression] = STATE(3440),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3440),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3440),
    [sym_number_literal] = STATE(4352),
    [sym_char_literal] = STATE(4352),
    [sym_concatenated_string] = STATE(4364),
    [sym_string_literal] = STATE(3640),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3641),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3440),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3440),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_LPAREN2] = ACTIONS(4046),
    [anon_sym_BANG] = ACTIONS(3344),
    [anon_sym_TILDE] = ACTIONS(3344),
    [anon_sym_DASH] = ACTIONS(3342),
    [anon_sym_PLUS] = ACTIONS(3342),
    [anon_sym_STAR] = ACTIONS(4048),
    [anon_sym_AMP] = ACTIONS(4048),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3342),
    [anon_sym_compl] = ACTIONS(3342),
    [anon_sym_DASH_DASH] = ACTIONS(4052),
    [anon_sym_PLUS_PLUS] = ACTIONS(4052),
    [anon_sym_sizeof] = ACTIONS(3348),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3350),
    [aux_sym_number_literal_token2] = ACTIONS(3352),
    [anon_sym_L_SQUOTE] = ACTIONS(3354),
    [anon_sym_u_SQUOTE] = ACTIONS(3354),
    [anon_sym_U_SQUOTE] = ACTIONS(3354),
    [anon_sym_u8_SQUOTE] = ACTIONS(3354),
    [anon_sym_SQUOTE] = ACTIONS(3354),
    [anon_sym_L_DQUOTE] = ACTIONS(3356),
    [anon_sym_u_DQUOTE] = ACTIONS(3356),
    [anon_sym_U_DQUOTE] = ACTIONS(3356),
    [anon_sym_u8_DQUOTE] = ACTIONS(3356),
    [anon_sym_DQUOTE] = ACTIONS(3356),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3358),
    [anon_sym_R_DQUOTE] = ACTIONS(3360),
    [anon_sym_LR_DQUOTE] = ACTIONS(3360),
    [anon_sym_uR_DQUOTE] = ACTIONS(3360),
    [anon_sym_UR_DQUOTE] = ACTIONS(3360),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3360),
    [anon_sym_co_await] = ACTIONS(3362),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1670] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4273),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3440),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3440),
    [sym_call_expression] = STATE(3440),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3440),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3440),
    [sym_number_literal] = STATE(4352),
    [sym_char_literal] = STATE(4352),
    [sym_concatenated_string] = STATE(4364),
    [sym_string_literal] = STATE(3640),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3641),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3440),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3440),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_LPAREN2] = ACTIONS(4046),
    [anon_sym_BANG] = ACTIONS(3344),
    [anon_sym_TILDE] = ACTIONS(3344),
    [anon_sym_DASH] = ACTIONS(3342),
    [anon_sym_PLUS] = ACTIONS(3342),
    [anon_sym_STAR] = ACTIONS(4048),
    [anon_sym_AMP] = ACTIONS(4048),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3342),
    [anon_sym_compl] = ACTIONS(3342),
    [anon_sym_DASH_DASH] = ACTIONS(4052),
    [anon_sym_PLUS_PLUS] = ACTIONS(4052),
    [anon_sym_sizeof] = ACTIONS(3348),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3350),
    [aux_sym_number_literal_token2] = ACTIONS(3352),
    [anon_sym_L_SQUOTE] = ACTIONS(3354),
    [anon_sym_u_SQUOTE] = ACTIONS(3354),
    [anon_sym_U_SQUOTE] = ACTIONS(3354),
    [anon_sym_u8_SQUOTE] = ACTIONS(3354),
    [anon_sym_SQUOTE] = ACTIONS(3354),
    [anon_sym_L_DQUOTE] = ACTIONS(3356),
    [anon_sym_u_DQUOTE] = ACTIONS(3356),
    [anon_sym_U_DQUOTE] = ACTIONS(3356),
    [anon_sym_u8_DQUOTE] = ACTIONS(3356),
    [anon_sym_DQUOTE] = ACTIONS(3356),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3358),
    [anon_sym_R_DQUOTE] = ACTIONS(3360),
    [anon_sym_LR_DQUOTE] = ACTIONS(3360),
    [anon_sym_uR_DQUOTE] = ACTIONS(3360),
    [anon_sym_UR_DQUOTE] = ACTIONS(3360),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3360),
    [anon_sym_co_await] = ACTIONS(3362),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1671] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4274),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3440),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3440),
    [sym_call_expression] = STATE(3440),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3440),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3440),
    [sym_number_literal] = STATE(4352),
    [sym_char_literal] = STATE(4352),
    [sym_concatenated_string] = STATE(4364),
    [sym_string_literal] = STATE(3640),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3641),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3440),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3440),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_LPAREN2] = ACTIONS(4046),
    [anon_sym_BANG] = ACTIONS(3344),
    [anon_sym_TILDE] = ACTIONS(3344),
    [anon_sym_DASH] = ACTIONS(3342),
    [anon_sym_PLUS] = ACTIONS(3342),
    [anon_sym_STAR] = ACTIONS(4048),
    [anon_sym_AMP] = ACTIONS(4048),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3342),
    [anon_sym_compl] = ACTIONS(3342),
    [anon_sym_DASH_DASH] = ACTIONS(4052),
    [anon_sym_PLUS_PLUS] = ACTIONS(4052),
    [anon_sym_sizeof] = ACTIONS(3348),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3350),
    [aux_sym_number_literal_token2] = ACTIONS(3352),
    [anon_sym_L_SQUOTE] = ACTIONS(3354),
    [anon_sym_u_SQUOTE] = ACTIONS(3354),
    [anon_sym_U_SQUOTE] = ACTIONS(3354),
    [anon_sym_u8_SQUOTE] = ACTIONS(3354),
    [anon_sym_SQUOTE] = ACTIONS(3354),
    [anon_sym_L_DQUOTE] = ACTIONS(3356),
    [anon_sym_u_DQUOTE] = ACTIONS(3356),
    [anon_sym_U_DQUOTE] = ACTIONS(3356),
    [anon_sym_u8_DQUOTE] = ACTIONS(3356),
    [anon_sym_DQUOTE] = ACTIONS(3356),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3358),
    [anon_sym_R_DQUOTE] = ACTIONS(3360),
    [anon_sym_LR_DQUOTE] = ACTIONS(3360),
    [anon_sym_uR_DQUOTE] = ACTIONS(3360),
    [anon_sym_UR_DQUOTE] = ACTIONS(3360),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3360),
    [anon_sym_co_await] = ACTIONS(3362),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1672] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4275),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3440),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3440),
    [sym_call_expression] = STATE(3440),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3440),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3440),
    [sym_number_literal] = STATE(4352),
    [sym_char_literal] = STATE(4352),
    [sym_concatenated_string] = STATE(4364),
    [sym_string_literal] = STATE(3640),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3641),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3440),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3440),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_LPAREN2] = ACTIONS(4046),
    [anon_sym_BANG] = ACTIONS(3344),
    [anon_sym_TILDE] = ACTIONS(3344),
    [anon_sym_DASH] = ACTIONS(3342),
    [anon_sym_PLUS] = ACTIONS(3342),
    [anon_sym_STAR] = ACTIONS(4048),
    [anon_sym_AMP] = ACTIONS(4048),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3342),
    [anon_sym_compl] = ACTIONS(3342),
    [anon_sym_DASH_DASH] = ACTIONS(4052),
    [anon_sym_PLUS_PLUS] = ACTIONS(4052),
    [anon_sym_sizeof] = ACTIONS(3348),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3350),
    [aux_sym_number_literal_token2] = ACTIONS(3352),
    [anon_sym_L_SQUOTE] = ACTIONS(3354),
    [anon_sym_u_SQUOTE] = ACTIONS(3354),
    [anon_sym_U_SQUOTE] = ACTIONS(3354),
    [anon_sym_u8_SQUOTE] = ACTIONS(3354),
    [anon_sym_SQUOTE] = ACTIONS(3354),
    [anon_sym_L_DQUOTE] = ACTIONS(3356),
    [anon_sym_u_DQUOTE] = ACTIONS(3356),
    [anon_sym_U_DQUOTE] = ACTIONS(3356),
    [anon_sym_u8_DQUOTE] = ACTIONS(3356),
    [anon_sym_DQUOTE] = ACTIONS(3356),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3358),
    [anon_sym_R_DQUOTE] = ACTIONS(3360),
    [anon_sym_LR_DQUOTE] = ACTIONS(3360),
    [anon_sym_uR_DQUOTE] = ACTIONS(3360),
    [anon_sym_UR_DQUOTE] = ACTIONS(3360),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3360),
    [anon_sym_co_await] = ACTIONS(3362),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1673] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4126),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(2961),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(2961),
    [sym_call_expression] = STATE(2961),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(2961),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(2961),
    [sym_number_literal] = STATE(4149),
    [sym_char_literal] = STATE(4149),
    [sym_concatenated_string] = STATE(4150),
    [sym_string_literal] = STATE(3034),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3026),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2961),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(2961),
    [sym_identifier] = ACTIONS(4082),
    [anon_sym_LPAREN2] = ACTIONS(4236),
    [anon_sym_BANG] = ACTIONS(3190),
    [anon_sym_TILDE] = ACTIONS(3190),
    [anon_sym_DASH] = ACTIONS(3188),
    [anon_sym_PLUS] = ACTIONS(3188),
    [anon_sym_STAR] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(4238),
    [anon_sym_COLON_COLON] = ACTIONS(3192),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3188),
    [anon_sym_compl] = ACTIONS(3188),
    [anon_sym_DASH_DASH] = ACTIONS(4088),
    [anon_sym_PLUS_PLUS] = ACTIONS(4088),
    [anon_sym_sizeof] = ACTIONS(3196),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3198),
    [aux_sym_number_literal_token2] = ACTIONS(3200),
    [anon_sym_L_SQUOTE] = ACTIONS(3202),
    [anon_sym_u_SQUOTE] = ACTIONS(3202),
    [anon_sym_U_SQUOTE] = ACTIONS(3202),
    [anon_sym_u8_SQUOTE] = ACTIONS(3202),
    [anon_sym_SQUOTE] = ACTIONS(3202),
    [anon_sym_L_DQUOTE] = ACTIONS(3204),
    [anon_sym_u_DQUOTE] = ACTIONS(3204),
    [anon_sym_U_DQUOTE] = ACTIONS(3204),
    [anon_sym_u8_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3204),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3206),
    [anon_sym_R_DQUOTE] = ACTIONS(3208),
    [anon_sym_LR_DQUOTE] = ACTIONS(3208),
    [anon_sym_uR_DQUOTE] = ACTIONS(3208),
    [anon_sym_UR_DQUOTE] = ACTIONS(3208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3208),
    [anon_sym_co_await] = ACTIONS(3210),
    [anon_sym_new] = ACTIONS(3212),
    [anon_sym_requires] = ACTIONS(3214),
    [sym_this] = ACTIONS(219),
  },
  [1674] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4276),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3440),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3440),
    [sym_call_expression] = STATE(3440),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3440),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3440),
    [sym_number_literal] = STATE(4352),
    [sym_char_literal] = STATE(4352),
    [sym_concatenated_string] = STATE(4364),
    [sym_string_literal] = STATE(3640),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3641),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3440),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3440),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_LPAREN2] = ACTIONS(4046),
    [anon_sym_BANG] = ACTIONS(3344),
    [anon_sym_TILDE] = ACTIONS(3344),
    [anon_sym_DASH] = ACTIONS(3342),
    [anon_sym_PLUS] = ACTIONS(3342),
    [anon_sym_STAR] = ACTIONS(4048),
    [anon_sym_AMP] = ACTIONS(4048),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3342),
    [anon_sym_compl] = ACTIONS(3342),
    [anon_sym_DASH_DASH] = ACTIONS(4052),
    [anon_sym_PLUS_PLUS] = ACTIONS(4052),
    [anon_sym_sizeof] = ACTIONS(3348),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3350),
    [aux_sym_number_literal_token2] = ACTIONS(3352),
    [anon_sym_L_SQUOTE] = ACTIONS(3354),
    [anon_sym_u_SQUOTE] = ACTIONS(3354),
    [anon_sym_U_SQUOTE] = ACTIONS(3354),
    [anon_sym_u8_SQUOTE] = ACTIONS(3354),
    [anon_sym_SQUOTE] = ACTIONS(3354),
    [anon_sym_L_DQUOTE] = ACTIONS(3356),
    [anon_sym_u_DQUOTE] = ACTIONS(3356),
    [anon_sym_U_DQUOTE] = ACTIONS(3356),
    [anon_sym_u8_DQUOTE] = ACTIONS(3356),
    [anon_sym_DQUOTE] = ACTIONS(3356),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3358),
    [anon_sym_R_DQUOTE] = ACTIONS(3360),
    [anon_sym_LR_DQUOTE] = ACTIONS(3360),
    [anon_sym_uR_DQUOTE] = ACTIONS(3360),
    [anon_sym_UR_DQUOTE] = ACTIONS(3360),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3360),
    [anon_sym_co_await] = ACTIONS(3362),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1675] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(3885),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3440),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3440),
    [sym_call_expression] = STATE(3440),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3440),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3440),
    [sym_number_literal] = STATE(4352),
    [sym_char_literal] = STATE(4352),
    [sym_concatenated_string] = STATE(4364),
    [sym_string_literal] = STATE(3640),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3641),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3440),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3440),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_LPAREN2] = ACTIONS(4046),
    [anon_sym_BANG] = ACTIONS(3344),
    [anon_sym_TILDE] = ACTIONS(3344),
    [anon_sym_DASH] = ACTIONS(3342),
    [anon_sym_PLUS] = ACTIONS(3342),
    [anon_sym_STAR] = ACTIONS(4048),
    [anon_sym_AMP] = ACTIONS(4048),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3342),
    [anon_sym_compl] = ACTIONS(3342),
    [anon_sym_DASH_DASH] = ACTIONS(4052),
    [anon_sym_PLUS_PLUS] = ACTIONS(4052),
    [anon_sym_sizeof] = ACTIONS(3348),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3350),
    [aux_sym_number_literal_token2] = ACTIONS(3352),
    [anon_sym_L_SQUOTE] = ACTIONS(3354),
    [anon_sym_u_SQUOTE] = ACTIONS(3354),
    [anon_sym_U_SQUOTE] = ACTIONS(3354),
    [anon_sym_u8_SQUOTE] = ACTIONS(3354),
    [anon_sym_SQUOTE] = ACTIONS(3354),
    [anon_sym_L_DQUOTE] = ACTIONS(3356),
    [anon_sym_u_DQUOTE] = ACTIONS(3356),
    [anon_sym_U_DQUOTE] = ACTIONS(3356),
    [anon_sym_u8_DQUOTE] = ACTIONS(3356),
    [anon_sym_DQUOTE] = ACTIONS(3356),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3358),
    [anon_sym_R_DQUOTE] = ACTIONS(3360),
    [anon_sym_LR_DQUOTE] = ACTIONS(3360),
    [anon_sym_uR_DQUOTE] = ACTIONS(3360),
    [anon_sym_UR_DQUOTE] = ACTIONS(3360),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3360),
    [anon_sym_co_await] = ACTIONS(3362),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1676] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4281),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3440),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3440),
    [sym_call_expression] = STATE(3440),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3440),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3440),
    [sym_number_literal] = STATE(4352),
    [sym_char_literal] = STATE(4352),
    [sym_concatenated_string] = STATE(4364),
    [sym_string_literal] = STATE(3640),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3641),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3440),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3440),
    [sym_identifier] = ACTIONS(3340),
    [anon_sym_LPAREN2] = ACTIONS(4046),
    [anon_sym_BANG] = ACTIONS(3344),
    [anon_sym_TILDE] = ACTIONS(3344),
    [anon_sym_DASH] = ACTIONS(3342),
    [anon_sym_PLUS] = ACTIONS(3342),
    [anon_sym_STAR] = ACTIONS(4048),
    [anon_sym_AMP] = ACTIONS(4048),
    [anon_sym_COLON_COLON] = ACTIONS(3346),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3342),
    [anon_sym_compl] = ACTIONS(3342),
    [anon_sym_DASH_DASH] = ACTIONS(4052),
    [anon_sym_PLUS_PLUS] = ACTIONS(4052),
    [anon_sym_sizeof] = ACTIONS(3348),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3350),
    [aux_sym_number_literal_token2] = ACTIONS(3352),
    [anon_sym_L_SQUOTE] = ACTIONS(3354),
    [anon_sym_u_SQUOTE] = ACTIONS(3354),
    [anon_sym_U_SQUOTE] = ACTIONS(3354),
    [anon_sym_u8_SQUOTE] = ACTIONS(3354),
    [anon_sym_SQUOTE] = ACTIONS(3354),
    [anon_sym_L_DQUOTE] = ACTIONS(3356),
    [anon_sym_u_DQUOTE] = ACTIONS(3356),
    [anon_sym_U_DQUOTE] = ACTIONS(3356),
    [anon_sym_u8_DQUOTE] = ACTIONS(3356),
    [anon_sym_DQUOTE] = ACTIONS(3356),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3358),
    [anon_sym_R_DQUOTE] = ACTIONS(3360),
    [anon_sym_LR_DQUOTE] = ACTIONS(3360),
    [anon_sym_uR_DQUOTE] = ACTIONS(3360),
    [anon_sym_UR_DQUOTE] = ACTIONS(3360),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3360),
    [anon_sym_co_await] = ACTIONS(3362),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1677] = {
    [sym_primitive_type] = STATE(6831),
    [sym__expression] = STATE(3129),
    [sym__expression_not_binary] = STATE(2520),
    [sym__string] = STATE(2520),
    [sym_conditional_expression] = STATE(2520),
    [sym_assignment_expression] = STATE(2520),
    [sym_pointer_expression] = STATE(2520),
    [sym_unary_expression] = STATE(2520),
    [sym_binary_expression] = STATE(2520),
    [sym_update_expression] = STATE(2520),
    [sym_cast_expression] = STATE(2520),
    [sym_sizeof_expression] = STATE(2520),
    [sym_alignof_expression] = STATE(2520),
    [sym_offsetof_expression] = STATE(2520),
    [sym_generic_expression] = STATE(2520),
    [sym_subscript_expression] = STATE(2520),
    [sym_call_expression] = STATE(2520),
    [sym_gnu_asm_expression] = STATE(2520),
    [sym_field_expression] = STATE(2520),
    [sym_compound_literal_expression] = STATE(2520),
    [sym_parenthesized_expression] = STATE(2520),
    [sym_number_literal] = STATE(3292),
    [sym_char_literal] = STATE(3292),
    [sym_concatenated_string] = STATE(3308),
    [sym_string_literal] = STATE(2343),
    [sym_null] = STATE(2520),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7517),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(2520),
    [sym_raw_string_literal] = STATE(2348),
    [sym_co_await_expression] = STATE(2520),
    [sym_new_expression] = STATE(2520),
    [sym_delete_expression] = STATE(2520),
    [sym_requires_clause] = STATE(2520),
    [sym_requires_expression] = STATE(2520),
    [sym_lambda_expression] = STATE(2520),
    [sym_lambda_capture_specifier] = STATE(5754),
    [sym_fold_expression] = STATE(2520),
    [sym_parameter_pack_expansion] = STATE(2520),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2520),
    [sym_qualified_type_identifier] = STATE(7517),
    [sym_user_defined_literal] = STATE(2520),
    [sym_identifier] = ACTIONS(1969),
    [anon_sym_LPAREN2] = ACTIONS(4256),
    [anon_sym_BANG] = ACTIONS(1973),
    [anon_sym_TILDE] = ACTIONS(1973),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_STAR] = ACTIONS(4048),
    [anon_sym_AMP] = ACTIONS(4048),
    [anon_sym_COLON_COLON] = ACTIONS(1975),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(1971),
    [anon_sym_compl] = ACTIONS(1971),
    [anon_sym_DASH_DASH] = ACTIONS(4096),
    [anon_sym_PLUS_PLUS] = ACTIONS(4096),
    [anon_sym_sizeof] = ACTIONS(1977),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1899),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [aux_sym_number_literal_token1] = ACTIONS(1979),
    [aux_sym_number_literal_token2] = ACTIONS(1981),
    [anon_sym_L_SQUOTE] = ACTIONS(1983),
    [anon_sym_u_SQUOTE] = ACTIONS(1983),
    [anon_sym_U_SQUOTE] = ACTIONS(1983),
    [anon_sym_u8_SQUOTE] = ACTIONS(1983),
    [anon_sym_SQUOTE] = ACTIONS(1983),
    [anon_sym_L_DQUOTE] = ACTIONS(1985),
    [anon_sym_u_DQUOTE] = ACTIONS(1985),
    [anon_sym_U_DQUOTE] = ACTIONS(1985),
    [anon_sym_u8_DQUOTE] = ACTIONS(1985),
    [anon_sym_DQUOTE] = ACTIONS(1985),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1915),
    [anon_sym_nullptr] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(1987),
    [anon_sym_R_DQUOTE] = ACTIONS(1989),
    [anon_sym_LR_DQUOTE] = ACTIONS(1989),
    [anon_sym_uR_DQUOTE] = ACTIONS(1989),
    [anon_sym_UR_DQUOTE] = ACTIONS(1989),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1989),
    [anon_sym_co_await] = ACTIONS(1991),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1927),
    [sym_this] = ACTIONS(1913),
  },
  [1678] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4128),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(2961),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(2961),
    [sym_call_expression] = STATE(2961),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(2961),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(2961),
    [sym_number_literal] = STATE(4149),
    [sym_char_literal] = STATE(4149),
    [sym_concatenated_string] = STATE(4150),
    [sym_string_literal] = STATE(3034),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3026),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(2961),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(2961),
    [sym_identifier] = ACTIONS(4082),
    [anon_sym_LPAREN2] = ACTIONS(4236),
    [anon_sym_BANG] = ACTIONS(3190),
    [anon_sym_TILDE] = ACTIONS(3190),
    [anon_sym_DASH] = ACTIONS(3188),
    [anon_sym_PLUS] = ACTIONS(3188),
    [anon_sym_STAR] = ACTIONS(4238),
    [anon_sym_AMP] = ACTIONS(4238),
    [anon_sym_COLON_COLON] = ACTIONS(3192),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(3188),
    [anon_sym_compl] = ACTIONS(3188),
    [anon_sym_DASH_DASH] = ACTIONS(4088),
    [anon_sym_PLUS_PLUS] = ACTIONS(4088),
    [anon_sym_sizeof] = ACTIONS(3196),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(3198),
    [aux_sym_number_literal_token2] = ACTIONS(3200),
    [anon_sym_L_SQUOTE] = ACTIONS(3202),
    [anon_sym_u_SQUOTE] = ACTIONS(3202),
    [anon_sym_U_SQUOTE] = ACTIONS(3202),
    [anon_sym_u8_SQUOTE] = ACTIONS(3202),
    [anon_sym_SQUOTE] = ACTIONS(3202),
    [anon_sym_L_DQUOTE] = ACTIONS(3204),
    [anon_sym_u_DQUOTE] = ACTIONS(3204),
    [anon_sym_U_DQUOTE] = ACTIONS(3204),
    [anon_sym_u8_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3204),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(3206),
    [anon_sym_R_DQUOTE] = ACTIONS(3208),
    [anon_sym_LR_DQUOTE] = ACTIONS(3208),
    [anon_sym_uR_DQUOTE] = ACTIONS(3208),
    [anon_sym_UR_DQUOTE] = ACTIONS(3208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3208),
    [anon_sym_co_await] = ACTIONS(3210),
    [anon_sym_new] = ACTIONS(3212),
    [anon_sym_requires] = ACTIONS(3214),
    [sym_this] = ACTIONS(219),
  },
  [1679] = {
    [sym_primitive_type] = STATE(6626),
    [sym__expression] = STATE(4575),
    [sym__expression_not_binary] = STATE(3950),
    [sym__string] = STATE(3950),
    [sym_conditional_expression] = STATE(3950),
    [sym_assignment_expression] = STATE(3950),
    [sym_pointer_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3950),
    [sym_binary_expression] = STATE(3950),
    [sym_update_expression] = STATE(3950),
    [sym_cast_expression] = STATE(3950),
    [sym_sizeof_expression] = STATE(3950),
    [sym_alignof_expression] = STATE(3950),
    [sym_offsetof_expression] = STATE(3950),
    [sym_generic_expression] = STATE(3950),
    [sym_subscript_expression] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_gnu_asm_expression] = STATE(3950),
    [sym_field_expression] = STATE(3234),
    [sym_compound_literal_expression] = STATE(3950),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_number_literal] = STATE(4174),
    [sym_char_literal] = STATE(4174),
    [sym_concatenated_string] = STATE(4175),
    [sym_string_literal] = STATE(3169),
    [sym_null] = STATE(3950),
    [sym_decltype] = STATE(8290),
    [sym__class_name] = STATE(7505),
    [sym_template_type] = STATE(2421),
    [sym_template_function] = STATE(3950),
    [sym_raw_string_literal] = STATE(3178),
    [sym_co_await_expression] = STATE(3950),
    [sym_new_expression] = STATE(3950),
    [sym_delete_expression] = STATE(3950),
    [sym_requires_clause] = STATE(3950),
    [sym_requires_expression] = STATE(3950),
    [sym_lambda_expression] = STATE(3950),
    [sym_lambda_capture_specifier] = STATE(5736),
    [sym_fold_expression] = STATE(3950),
    [sym_parameter_pack_expansion] = STATE(3950),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5539),
    [sym_qualified_identifier] = STATE(3234),
    [sym_qualified_type_identifier] = STATE(7505),
    [sym_user_defined_literal] = STATE(3234),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_COLON_COLON] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(95),
    [anon_sym_sizeof] = ACTIONS(97),
    [anon_sym___alignof__] = ACTIONS(99),
    [anon_sym___alignof] = ACTIONS(99),
    [anon_sym__alignof] = ACTIONS(99),
    [anon_sym_alignof] = ACTIONS(99),
    [anon_sym__Alignof] = ACTIONS(99),
    [anon_sym_offsetof] = ACTIONS(101),
    [anon_sym__Generic] = ACTIONS(103),
    [anon_sym_asm] = ACTIONS(105),
    [anon_sym___asm__] = ACTIONS(105),
    [aux_sym_number_literal_token1] = ACTIONS(107),
    [aux_sym_number_literal_token2] = ACTIONS(109),
    [anon_sym_L_SQUOTE] = ACTIONS(111),
    [anon_sym_u_SQUOTE] = ACTIONS(111),
    [anon_sym_U_SQUOTE] = ACTIONS(111),
    [anon_sym_u8_SQUOTE] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(111),
    [anon_sym_L_DQUOTE] = ACTIONS(113),
    [anon_sym_u_DQUOTE] = ACTIONS(113),
    [anon_sym_U_DQUOTE] = ACTIONS(113),
    [anon_sym_u8_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [anon_sym_NULL] = ACTIONS(117),
    [anon_sym_nullptr] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(219),
  },
  [1680] = {
    [sym__declaration_modifiers] = STATE(1967),
    [sym__declaration_specifiers] = STATE(4118),
    [sym_attribute_specifier] = STATE(1967),
    [sym_attribute_declaration] = STATE(1967),
    [sym_ms_declspec_modifier] = STATE(1967),
    [sym_ms_call_modifier] = STATE(6122),
    [sym__abstract_declarator] = STATE(6592),
    [sym_abstract_parenthesized_declarator] = STATE(6031),
    [sym_abstract_pointer_declarator] = STATE(6031),
    [sym_abstract_function_declarator] = STATE(6031),
    [sym_abstract_array_declarator] = STATE(6031),
    [sym_storage_class_specifier] = STATE(1967),
    [sym_type_qualifier] = STATE(1967),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_parameter_list] = STATE(3698),
    [sym_parameter_declaration] = STATE(6918),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(1967),
    [sym_alignas_specifier] = STATE(1967),
    [sym_dependent_type] = STATE(2629),
    [sym_optional_parameter_declaration] = STATE(6918),
    [sym_variadic_parameter_declaration] = STATE(6918),
    [sym_abstract_reference_declarator] = STATE(6031),
    [sym__function_declarator_seq] = STATE(6035),
    [sym_template_type] = STATE(2618),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(6380),
    [sym_qualified_type_identifier] = STATE(3260),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1967),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [sym_identifier] = ACTIONS(4516),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1801),
    [anon_sym_RPAREN] = ACTIONS(3801),
    [anon_sym_LPAREN2] = ACTIONS(4518),
    [anon_sym_STAR] = ACTIONS(4520),
    [anon_sym_AMP_AMP] = ACTIONS(4522),
    [anon_sym_AMP] = ACTIONS(4524),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4526),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___cdecl] = ACTIONS(1825),
    [anon_sym___clrcall] = ACTIONS(1825),
    [anon_sym___stdcall] = ACTIONS(1825),
    [anon_sym___fastcall] = ACTIONS(1825),
    [anon_sym___thiscall] = ACTIONS(1825),
    [anon_sym___vectorcall] = ACTIONS(1825),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(4528),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(1755),
    [anon_sym_class] = ACTIONS(1757),
    [anon_sym_struct] = ACTIONS(1759),
    [anon_sym_union] = ACTIONS(1761),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(1787),
    [anon_sym_template] = ACTIONS(1419),
  },
  [1681] = {
    [sym__declaration_modifiers] = STATE(1967),
    [sym__declaration_specifiers] = STATE(4118),
    [sym_attribute_specifier] = STATE(1967),
    [sym_attribute_declaration] = STATE(1967),
    [sym_ms_declspec_modifier] = STATE(1967),
    [sym_ms_call_modifier] = STATE(6139),
    [sym__abstract_declarator] = STATE(6559),
    [sym_abstract_parenthesized_declarator] = STATE(6031),
    [sym_abstract_pointer_declarator] = STATE(6031),
    [sym_abstract_function_declarator] = STATE(6031),
    [sym_abstract_array_declarator] = STATE(6031),
    [sym_storage_class_specifier] = STATE(1967),
    [sym_type_qualifier] = STATE(1967),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_parameter_list] = STATE(3698),
    [sym_parameter_declaration] = STATE(6918),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(1967),
    [sym_alignas_specifier] = STATE(1967),
    [sym_dependent_type] = STATE(2629),
    [sym_optional_parameter_declaration] = STATE(6918),
    [sym_variadic_parameter_declaration] = STATE(6918),
    [sym_abstract_reference_declarator] = STATE(6031),
    [sym__function_declarator_seq] = STATE(6035),
    [sym_template_type] = STATE(2618),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(6380),
    [sym_qualified_type_identifier] = STATE(3260),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1967),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [sym_identifier] = ACTIONS(4516),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1801),
    [anon_sym_RPAREN] = ACTIONS(3801),
    [anon_sym_LPAREN2] = ACTIONS(4518),
    [anon_sym_STAR] = ACTIONS(4520),
    [anon_sym_AMP_AMP] = ACTIONS(4522),
    [anon_sym_AMP] = ACTIONS(4524),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4526),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___cdecl] = ACTIONS(1825),
    [anon_sym___clrcall] = ACTIONS(1825),
    [anon_sym___stdcall] = ACTIONS(1825),
    [anon_sym___fastcall] = ACTIONS(1825),
    [anon_sym___thiscall] = ACTIONS(1825),
    [anon_sym___vectorcall] = ACTIONS(1825),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(4528),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(1755),
    [anon_sym_class] = ACTIONS(1757),
    [anon_sym_struct] = ACTIONS(1759),
    [anon_sym_union] = ACTIONS(1761),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(1787),
    [anon_sym_template] = ACTIONS(1419),
  },
  [1682] = {
    [sym_identifier] = ACTIONS(4530),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4532),
    [anon_sym_COMMA] = ACTIONS(4532),
    [anon_sym_RPAREN] = ACTIONS(4532),
    [anon_sym_LPAREN2] = ACTIONS(4532),
    [anon_sym_TILDE] = ACTIONS(4532),
    [anon_sym_DASH] = ACTIONS(4530),
    [anon_sym_PLUS] = ACTIONS(4530),
    [anon_sym_STAR] = ACTIONS(4530),
    [anon_sym_SLASH] = ACTIONS(4530),
    [anon_sym_PERCENT] = ACTIONS(4530),
    [anon_sym_PIPE_PIPE] = ACTIONS(4532),
    [anon_sym_AMP_AMP] = ACTIONS(4532),
    [anon_sym_PIPE] = ACTIONS(4530),
    [anon_sym_CARET] = ACTIONS(4530),
    [anon_sym_AMP] = ACTIONS(4530),
    [anon_sym_EQ_EQ] = ACTIONS(4532),
    [anon_sym_BANG_EQ] = ACTIONS(4532),
    [anon_sym_GT] = ACTIONS(4530),
    [anon_sym_GT_EQ] = ACTIONS(4532),
    [anon_sym_LT_EQ] = ACTIONS(4530),
    [anon_sym_LT] = ACTIONS(4530),
    [anon_sym_LT_LT] = ACTIONS(4530),
    [anon_sym_GT_GT] = ACTIONS(4530),
    [anon_sym_SEMI] = ACTIONS(4532),
    [anon_sym___extension__] = ACTIONS(4530),
    [anon_sym_extern] = ACTIONS(4530),
    [anon_sym___attribute__] = ACTIONS(4530),
    [anon_sym_COLON_COLON] = ACTIONS(4532),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4532),
    [anon_sym___declspec] = ACTIONS(4530),
    [anon_sym___based] = ACTIONS(4530),
    [anon_sym___cdecl] = ACTIONS(4530),
    [anon_sym___clrcall] = ACTIONS(4530),
    [anon_sym___stdcall] = ACTIONS(4530),
    [anon_sym___fastcall] = ACTIONS(4530),
    [anon_sym___thiscall] = ACTIONS(4530),
    [anon_sym___vectorcall] = ACTIONS(4530),
    [anon_sym_LBRACE] = ACTIONS(4532),
    [anon_sym_RBRACE] = ACTIONS(4532),
    [anon_sym_LBRACK] = ACTIONS(4530),
    [anon_sym_EQ] = ACTIONS(4530),
    [anon_sym_static] = ACTIONS(4530),
    [anon_sym_register] = ACTIONS(4530),
    [anon_sym_inline] = ACTIONS(4530),
    [anon_sym___inline] = ACTIONS(4530),
    [anon_sym___inline__] = ACTIONS(4530),
    [anon_sym___forceinline] = ACTIONS(4530),
    [anon_sym_thread_local] = ACTIONS(4530),
    [anon_sym___thread] = ACTIONS(4530),
    [anon_sym_const] = ACTIONS(4530),
    [anon_sym_constexpr] = ACTIONS(4530),
    [anon_sym_volatile] = ACTIONS(4530),
    [anon_sym_restrict] = ACTIONS(4530),
    [anon_sym___restrict__] = ACTIONS(4530),
    [anon_sym__Atomic] = ACTIONS(4530),
    [anon_sym__Noreturn] = ACTIONS(4530),
    [anon_sym_noreturn] = ACTIONS(4530),
    [anon_sym_mutable] = ACTIONS(4530),
    [anon_sym_constinit] = ACTIONS(4530),
    [anon_sym_consteval] = ACTIONS(4530),
    [anon_sym_PROGMEM] = ACTIONS(4530),
    [anon_sym_QMARK] = ACTIONS(4532),
    [anon_sym_STAR_EQ] = ACTIONS(4532),
    [anon_sym_SLASH_EQ] = ACTIONS(4532),
    [anon_sym_PERCENT_EQ] = ACTIONS(4532),
    [anon_sym_PLUS_EQ] = ACTIONS(4532),
    [anon_sym_DASH_EQ] = ACTIONS(4532),
    [anon_sym_LT_LT_EQ] = ACTIONS(4532),
    [anon_sym_GT_GT_EQ] = ACTIONS(4532),
    [anon_sym_AMP_EQ] = ACTIONS(4532),
    [anon_sym_CARET_EQ] = ACTIONS(4532),
    [anon_sym_PIPE_EQ] = ACTIONS(4532),
    [anon_sym_and_eq] = ACTIONS(4530),
    [anon_sym_or_eq] = ACTIONS(4530),
    [anon_sym_xor_eq] = ACTIONS(4530),
    [anon_sym_LT_EQ_GT] = ACTIONS(4532),
    [anon_sym_or] = ACTIONS(4530),
    [anon_sym_and] = ACTIONS(4530),
    [anon_sym_bitor] = ACTIONS(4530),
    [anon_sym_xor] = ACTIONS(4530),
    [anon_sym_bitand] = ACTIONS(4530),
    [anon_sym_not_eq] = ACTIONS(4530),
    [anon_sym_DASH_DASH] = ACTIONS(4532),
    [anon_sym_PLUS_PLUS] = ACTIONS(4532),
    [anon_sym_DOT] = ACTIONS(4530),
    [anon_sym_DOT_STAR] = ACTIONS(4532),
    [anon_sym_DASH_GT] = ACTIONS(4532),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4530),
    [anon_sym_decltype] = ACTIONS(4530),
    [anon_sym_virtual] = ACTIONS(4530),
    [anon_sym_alignas] = ACTIONS(4530),
    [anon_sym_template] = ACTIONS(4530),
    [anon_sym_operator] = ACTIONS(4530),
  },
  [1683] = {
    [sym_template_argument_list] = STATE(1690),
    [sym_identifier] = ACTIONS(4534),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4536),
    [anon_sym_COMMA] = ACTIONS(4536),
    [anon_sym_LPAREN2] = ACTIONS(4538),
    [anon_sym_TILDE] = ACTIONS(4541),
    [anon_sym_DASH] = ACTIONS(4543),
    [anon_sym_PLUS] = ACTIONS(4543),
    [anon_sym_STAR] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(4543),
    [anon_sym_PERCENT] = ACTIONS(4543),
    [anon_sym_PIPE_PIPE] = ACTIONS(4536),
    [anon_sym_AMP_AMP] = ACTIONS(4538),
    [anon_sym_PIPE] = ACTIONS(4543),
    [anon_sym_CARET] = ACTIONS(4543),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_EQ_EQ] = ACTIONS(4536),
    [anon_sym_BANG_EQ] = ACTIONS(4536),
    [anon_sym_GT] = ACTIONS(4543),
    [anon_sym_GT_EQ] = ACTIONS(4536),
    [anon_sym_LT_EQ] = ACTIONS(4543),
    [anon_sym_LT] = ACTIONS(4548),
    [anon_sym_LT_LT] = ACTIONS(4543),
    [anon_sym_GT_GT] = ACTIONS(4543),
    [anon_sym_SEMI] = ACTIONS(4538),
    [anon_sym___extension__] = ACTIONS(4534),
    [anon_sym_extern] = ACTIONS(4534),
    [anon_sym___attribute__] = ACTIONS(4534),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4538),
    [anon_sym___declspec] = ACTIONS(4534),
    [anon_sym___based] = ACTIONS(4534),
    [anon_sym___cdecl] = ACTIONS(4534),
    [anon_sym___clrcall] = ACTIONS(4534),
    [anon_sym___stdcall] = ACTIONS(4534),
    [anon_sym___fastcall] = ACTIONS(4534),
    [anon_sym___thiscall] = ACTIONS(4534),
    [anon_sym___vectorcall] = ACTIONS(4534),
    [anon_sym_LBRACE] = ACTIONS(4541),
    [anon_sym_RBRACE] = ACTIONS(4536),
    [anon_sym_LBRACK] = ACTIONS(4545),
    [anon_sym_EQ] = ACTIONS(4543),
    [anon_sym_static] = ACTIONS(4534),
    [anon_sym_register] = ACTIONS(4534),
    [anon_sym_inline] = ACTIONS(4534),
    [anon_sym___inline] = ACTIONS(4534),
    [anon_sym___inline__] = ACTIONS(4534),
    [anon_sym___forceinline] = ACTIONS(4534),
    [anon_sym_thread_local] = ACTIONS(4534),
    [anon_sym___thread] = ACTIONS(4534),
    [anon_sym_const] = ACTIONS(4534),
    [anon_sym_constexpr] = ACTIONS(4534),
    [anon_sym_volatile] = ACTIONS(4534),
    [anon_sym_restrict] = ACTIONS(4534),
    [anon_sym___restrict__] = ACTIONS(4534),
    [anon_sym__Atomic] = ACTIONS(4534),
    [anon_sym__Noreturn] = ACTIONS(4534),
    [anon_sym_noreturn] = ACTIONS(4534),
    [anon_sym_mutable] = ACTIONS(4534),
    [anon_sym_constinit] = ACTIONS(4534),
    [anon_sym_consteval] = ACTIONS(4534),
    [anon_sym_PROGMEM] = ACTIONS(4534),
    [anon_sym_QMARK] = ACTIONS(4536),
    [anon_sym_STAR_EQ] = ACTIONS(4536),
    [anon_sym_SLASH_EQ] = ACTIONS(4536),
    [anon_sym_PERCENT_EQ] = ACTIONS(4536),
    [anon_sym_PLUS_EQ] = ACTIONS(4536),
    [anon_sym_DASH_EQ] = ACTIONS(4536),
    [anon_sym_LT_LT_EQ] = ACTIONS(4536),
    [anon_sym_GT_GT_EQ] = ACTIONS(4536),
    [anon_sym_AMP_EQ] = ACTIONS(4536),
    [anon_sym_CARET_EQ] = ACTIONS(4536),
    [anon_sym_PIPE_EQ] = ACTIONS(4536),
    [anon_sym_and_eq] = ACTIONS(4543),
    [anon_sym_or_eq] = ACTIONS(4543),
    [anon_sym_xor_eq] = ACTIONS(4543),
    [anon_sym_LT_EQ_GT] = ACTIONS(4536),
    [anon_sym_or] = ACTIONS(4543),
    [anon_sym_and] = ACTIONS(4543),
    [anon_sym_bitor] = ACTIONS(4543),
    [anon_sym_xor] = ACTIONS(4543),
    [anon_sym_bitand] = ACTIONS(4543),
    [anon_sym_not_eq] = ACTIONS(4543),
    [anon_sym_DASH_DASH] = ACTIONS(4536),
    [anon_sym_PLUS_PLUS] = ACTIONS(4536),
    [anon_sym_DOT] = ACTIONS(4543),
    [anon_sym_DOT_STAR] = ACTIONS(4536),
    [anon_sym_DASH_GT] = ACTIONS(4536),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4534),
    [anon_sym_decltype] = ACTIONS(4534),
    [anon_sym_virtual] = ACTIONS(4534),
    [anon_sym_alignas] = ACTIONS(4534),
    [anon_sym_template] = ACTIONS(4534),
    [anon_sym_operator] = ACTIONS(4534),
  },
  [1684] = {
    [sym_identifier] = ACTIONS(4551),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4553),
    [anon_sym_COMMA] = ACTIONS(4553),
    [anon_sym_RPAREN] = ACTIONS(4553),
    [anon_sym_LPAREN2] = ACTIONS(4553),
    [anon_sym_TILDE] = ACTIONS(4553),
    [anon_sym_DASH] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(4551),
    [anon_sym_STAR] = ACTIONS(4551),
    [anon_sym_SLASH] = ACTIONS(4551),
    [anon_sym_PERCENT] = ACTIONS(4551),
    [anon_sym_PIPE_PIPE] = ACTIONS(4553),
    [anon_sym_AMP_AMP] = ACTIONS(4553),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4551),
    [anon_sym_AMP] = ACTIONS(4551),
    [anon_sym_EQ_EQ] = ACTIONS(4553),
    [anon_sym_BANG_EQ] = ACTIONS(4553),
    [anon_sym_GT] = ACTIONS(4551),
    [anon_sym_GT_EQ] = ACTIONS(4553),
    [anon_sym_LT_EQ] = ACTIONS(4551),
    [anon_sym_LT] = ACTIONS(4551),
    [anon_sym_LT_LT] = ACTIONS(4551),
    [anon_sym_GT_GT] = ACTIONS(4551),
    [anon_sym_SEMI] = ACTIONS(4553),
    [anon_sym___extension__] = ACTIONS(4551),
    [anon_sym_extern] = ACTIONS(4551),
    [anon_sym___attribute__] = ACTIONS(4551),
    [anon_sym_COLON_COLON] = ACTIONS(4553),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4553),
    [anon_sym___declspec] = ACTIONS(4551),
    [anon_sym___based] = ACTIONS(4551),
    [anon_sym___cdecl] = ACTIONS(4551),
    [anon_sym___clrcall] = ACTIONS(4551),
    [anon_sym___stdcall] = ACTIONS(4551),
    [anon_sym___fastcall] = ACTIONS(4551),
    [anon_sym___thiscall] = ACTIONS(4551),
    [anon_sym___vectorcall] = ACTIONS(4551),
    [anon_sym_LBRACE] = ACTIONS(4553),
    [anon_sym_RBRACE] = ACTIONS(4553),
    [anon_sym_LBRACK] = ACTIONS(4551),
    [anon_sym_EQ] = ACTIONS(4551),
    [anon_sym_static] = ACTIONS(4551),
    [anon_sym_register] = ACTIONS(4551),
    [anon_sym_inline] = ACTIONS(4551),
    [anon_sym___inline] = ACTIONS(4551),
    [anon_sym___inline__] = ACTIONS(4551),
    [anon_sym___forceinline] = ACTIONS(4551),
    [anon_sym_thread_local] = ACTIONS(4551),
    [anon_sym___thread] = ACTIONS(4551),
    [anon_sym_const] = ACTIONS(4551),
    [anon_sym_constexpr] = ACTIONS(4551),
    [anon_sym_volatile] = ACTIONS(4551),
    [anon_sym_restrict] = ACTIONS(4551),
    [anon_sym___restrict__] = ACTIONS(4551),
    [anon_sym__Atomic] = ACTIONS(4551),
    [anon_sym__Noreturn] = ACTIONS(4551),
    [anon_sym_noreturn] = ACTIONS(4551),
    [anon_sym_mutable] = ACTIONS(4551),
    [anon_sym_constinit] = ACTIONS(4551),
    [anon_sym_consteval] = ACTIONS(4551),
    [anon_sym_PROGMEM] = ACTIONS(4551),
    [anon_sym_QMARK] = ACTIONS(4553),
    [anon_sym_STAR_EQ] = ACTIONS(4553),
    [anon_sym_SLASH_EQ] = ACTIONS(4553),
    [anon_sym_PERCENT_EQ] = ACTIONS(4553),
    [anon_sym_PLUS_EQ] = ACTIONS(4553),
    [anon_sym_DASH_EQ] = ACTIONS(4553),
    [anon_sym_LT_LT_EQ] = ACTIONS(4553),
    [anon_sym_GT_GT_EQ] = ACTIONS(4553),
    [anon_sym_AMP_EQ] = ACTIONS(4553),
    [anon_sym_CARET_EQ] = ACTIONS(4553),
    [anon_sym_PIPE_EQ] = ACTIONS(4553),
    [anon_sym_and_eq] = ACTIONS(4551),
    [anon_sym_or_eq] = ACTIONS(4551),
    [anon_sym_xor_eq] = ACTIONS(4551),
    [anon_sym_LT_EQ_GT] = ACTIONS(4553),
    [anon_sym_or] = ACTIONS(4551),
    [anon_sym_and] = ACTIONS(4551),
    [anon_sym_bitor] = ACTIONS(4551),
    [anon_sym_xor] = ACTIONS(4551),
    [anon_sym_bitand] = ACTIONS(4551),
    [anon_sym_not_eq] = ACTIONS(4551),
    [anon_sym_DASH_DASH] = ACTIONS(4553),
    [anon_sym_PLUS_PLUS] = ACTIONS(4553),
    [anon_sym_DOT] = ACTIONS(4551),
    [anon_sym_DOT_STAR] = ACTIONS(4553),
    [anon_sym_DASH_GT] = ACTIONS(4553),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4551),
    [anon_sym_decltype] = ACTIONS(4551),
    [anon_sym_virtual] = ACTIONS(4551),
    [anon_sym_alignas] = ACTIONS(4551),
    [anon_sym_template] = ACTIONS(4551),
    [anon_sym_operator] = ACTIONS(4551),
  },
  [1685] = {
    [sym_identifier] = ACTIONS(4555),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4557),
    [anon_sym_COMMA] = ACTIONS(4557),
    [anon_sym_RPAREN] = ACTIONS(4557),
    [anon_sym_LPAREN2] = ACTIONS(4557),
    [anon_sym_TILDE] = ACTIONS(4557),
    [anon_sym_DASH] = ACTIONS(4555),
    [anon_sym_PLUS] = ACTIONS(4555),
    [anon_sym_STAR] = ACTIONS(4555),
    [anon_sym_SLASH] = ACTIONS(4555),
    [anon_sym_PERCENT] = ACTIONS(4555),
    [anon_sym_PIPE_PIPE] = ACTIONS(4557),
    [anon_sym_AMP_AMP] = ACTIONS(4557),
    [anon_sym_PIPE] = ACTIONS(4555),
    [anon_sym_CARET] = ACTIONS(4555),
    [anon_sym_AMP] = ACTIONS(4555),
    [anon_sym_EQ_EQ] = ACTIONS(4557),
    [anon_sym_BANG_EQ] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4555),
    [anon_sym_GT_EQ] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4555),
    [anon_sym_LT_LT] = ACTIONS(4555),
    [anon_sym_GT_GT] = ACTIONS(4555),
    [anon_sym_SEMI] = ACTIONS(4557),
    [anon_sym___extension__] = ACTIONS(4555),
    [anon_sym_extern] = ACTIONS(4555),
    [anon_sym___attribute__] = ACTIONS(4555),
    [anon_sym_COLON_COLON] = ACTIONS(4557),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4557),
    [anon_sym___declspec] = ACTIONS(4555),
    [anon_sym___based] = ACTIONS(4555),
    [anon_sym___cdecl] = ACTIONS(4555),
    [anon_sym___clrcall] = ACTIONS(4555),
    [anon_sym___stdcall] = ACTIONS(4555),
    [anon_sym___fastcall] = ACTIONS(4555),
    [anon_sym___thiscall] = ACTIONS(4555),
    [anon_sym___vectorcall] = ACTIONS(4555),
    [anon_sym_LBRACE] = ACTIONS(4557),
    [anon_sym_RBRACE] = ACTIONS(4557),
    [anon_sym_LBRACK] = ACTIONS(4555),
    [anon_sym_EQ] = ACTIONS(4555),
    [anon_sym_static] = ACTIONS(4555),
    [anon_sym_register] = ACTIONS(4555),
    [anon_sym_inline] = ACTIONS(4555),
    [anon_sym___inline] = ACTIONS(4555),
    [anon_sym___inline__] = ACTIONS(4555),
    [anon_sym___forceinline] = ACTIONS(4555),
    [anon_sym_thread_local] = ACTIONS(4555),
    [anon_sym___thread] = ACTIONS(4555),
    [anon_sym_const] = ACTIONS(4555),
    [anon_sym_constexpr] = ACTIONS(4555),
    [anon_sym_volatile] = ACTIONS(4555),
    [anon_sym_restrict] = ACTIONS(4555),
    [anon_sym___restrict__] = ACTIONS(4555),
    [anon_sym__Atomic] = ACTIONS(4555),
    [anon_sym__Noreturn] = ACTIONS(4555),
    [anon_sym_noreturn] = ACTIONS(4555),
    [anon_sym_mutable] = ACTIONS(4555),
    [anon_sym_constinit] = ACTIONS(4555),
    [anon_sym_consteval] = ACTIONS(4555),
    [anon_sym_PROGMEM] = ACTIONS(4555),
    [anon_sym_QMARK] = ACTIONS(4557),
    [anon_sym_STAR_EQ] = ACTIONS(4557),
    [anon_sym_SLASH_EQ] = ACTIONS(4557),
    [anon_sym_PERCENT_EQ] = ACTIONS(4557),
    [anon_sym_PLUS_EQ] = ACTIONS(4557),
    [anon_sym_DASH_EQ] = ACTIONS(4557),
    [anon_sym_LT_LT_EQ] = ACTIONS(4557),
    [anon_sym_GT_GT_EQ] = ACTIONS(4557),
    [anon_sym_AMP_EQ] = ACTIONS(4557),
    [anon_sym_CARET_EQ] = ACTIONS(4557),
    [anon_sym_PIPE_EQ] = ACTIONS(4557),
    [anon_sym_and_eq] = ACTIONS(4555),
    [anon_sym_or_eq] = ACTIONS(4555),
    [anon_sym_xor_eq] = ACTIONS(4555),
    [anon_sym_LT_EQ_GT] = ACTIONS(4557),
    [anon_sym_or] = ACTIONS(4555),
    [anon_sym_and] = ACTIONS(4555),
    [anon_sym_bitor] = ACTIONS(4555),
    [anon_sym_xor] = ACTIONS(4555),
    [anon_sym_bitand] = ACTIONS(4555),
    [anon_sym_not_eq] = ACTIONS(4555),
    [anon_sym_DASH_DASH] = ACTIONS(4557),
    [anon_sym_PLUS_PLUS] = ACTIONS(4557),
    [anon_sym_DOT] = ACTIONS(4555),
    [anon_sym_DOT_STAR] = ACTIONS(4557),
    [anon_sym_DASH_GT] = ACTIONS(4557),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4555),
    [anon_sym_decltype] = ACTIONS(4555),
    [anon_sym_virtual] = ACTIONS(4555),
    [anon_sym_alignas] = ACTIONS(4555),
    [anon_sym_template] = ACTIONS(4555),
    [anon_sym_operator] = ACTIONS(4555),
  },
  [1686] = {
    [sym_identifier] = ACTIONS(4559),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4561),
    [anon_sym_COMMA] = ACTIONS(4561),
    [anon_sym_RPAREN] = ACTIONS(4561),
    [anon_sym_LPAREN2] = ACTIONS(4561),
    [anon_sym_TILDE] = ACTIONS(4561),
    [anon_sym_DASH] = ACTIONS(4559),
    [anon_sym_PLUS] = ACTIONS(4559),
    [anon_sym_STAR] = ACTIONS(4559),
    [anon_sym_SLASH] = ACTIONS(4559),
    [anon_sym_PERCENT] = ACTIONS(4559),
    [anon_sym_PIPE_PIPE] = ACTIONS(4561),
    [anon_sym_AMP_AMP] = ACTIONS(4561),
    [anon_sym_PIPE] = ACTIONS(4559),
    [anon_sym_CARET] = ACTIONS(4559),
    [anon_sym_AMP] = ACTIONS(4559),
    [anon_sym_EQ_EQ] = ACTIONS(4561),
    [anon_sym_BANG_EQ] = ACTIONS(4561),
    [anon_sym_GT] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4561),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_LT] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4559),
    [anon_sym_GT_GT] = ACTIONS(4559),
    [anon_sym_SEMI] = ACTIONS(4561),
    [anon_sym___extension__] = ACTIONS(4559),
    [anon_sym_extern] = ACTIONS(4559),
    [anon_sym___attribute__] = ACTIONS(4559),
    [anon_sym_COLON_COLON] = ACTIONS(4561),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4561),
    [anon_sym___declspec] = ACTIONS(4559),
    [anon_sym___based] = ACTIONS(4559),
    [anon_sym___cdecl] = ACTIONS(4559),
    [anon_sym___clrcall] = ACTIONS(4559),
    [anon_sym___stdcall] = ACTIONS(4559),
    [anon_sym___fastcall] = ACTIONS(4559),
    [anon_sym___thiscall] = ACTIONS(4559),
    [anon_sym___vectorcall] = ACTIONS(4559),
    [anon_sym_LBRACE] = ACTIONS(4561),
    [anon_sym_RBRACE] = ACTIONS(4561),
    [anon_sym_LBRACK] = ACTIONS(4559),
    [anon_sym_EQ] = ACTIONS(4559),
    [anon_sym_static] = ACTIONS(4559),
    [anon_sym_register] = ACTIONS(4559),
    [anon_sym_inline] = ACTIONS(4559),
    [anon_sym___inline] = ACTIONS(4559),
    [anon_sym___inline__] = ACTIONS(4559),
    [anon_sym___forceinline] = ACTIONS(4559),
    [anon_sym_thread_local] = ACTIONS(4559),
    [anon_sym___thread] = ACTIONS(4559),
    [anon_sym_const] = ACTIONS(4559),
    [anon_sym_constexpr] = ACTIONS(4559),
    [anon_sym_volatile] = ACTIONS(4559),
    [anon_sym_restrict] = ACTIONS(4559),
    [anon_sym___restrict__] = ACTIONS(4559),
    [anon_sym__Atomic] = ACTIONS(4559),
    [anon_sym__Noreturn] = ACTIONS(4559),
    [anon_sym_noreturn] = ACTIONS(4559),
    [anon_sym_mutable] = ACTIONS(4559),
    [anon_sym_constinit] = ACTIONS(4559),
    [anon_sym_consteval] = ACTIONS(4559),
    [anon_sym_PROGMEM] = ACTIONS(4559),
    [anon_sym_QMARK] = ACTIONS(4561),
    [anon_sym_STAR_EQ] = ACTIONS(4561),
    [anon_sym_SLASH_EQ] = ACTIONS(4561),
    [anon_sym_PERCENT_EQ] = ACTIONS(4561),
    [anon_sym_PLUS_EQ] = ACTIONS(4561),
    [anon_sym_DASH_EQ] = ACTIONS(4561),
    [anon_sym_LT_LT_EQ] = ACTIONS(4561),
    [anon_sym_GT_GT_EQ] = ACTIONS(4561),
    [anon_sym_AMP_EQ] = ACTIONS(4561),
    [anon_sym_CARET_EQ] = ACTIONS(4561),
    [anon_sym_PIPE_EQ] = ACTIONS(4561),
    [anon_sym_and_eq] = ACTIONS(4559),
    [anon_sym_or_eq] = ACTIONS(4559),
    [anon_sym_xor_eq] = ACTIONS(4559),
    [anon_sym_LT_EQ_GT] = ACTIONS(4561),
    [anon_sym_or] = ACTIONS(4559),
    [anon_sym_and] = ACTIONS(4559),
    [anon_sym_bitor] = ACTIONS(4559),
    [anon_sym_xor] = ACTIONS(4559),
    [anon_sym_bitand] = ACTIONS(4559),
    [anon_sym_not_eq] = ACTIONS(4559),
    [anon_sym_DASH_DASH] = ACTIONS(4561),
    [anon_sym_PLUS_PLUS] = ACTIONS(4561),
    [anon_sym_DOT] = ACTIONS(4559),
    [anon_sym_DOT_STAR] = ACTIONS(4561),
    [anon_sym_DASH_GT] = ACTIONS(4561),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4559),
    [anon_sym_decltype] = ACTIONS(4559),
    [anon_sym_virtual] = ACTIONS(4559),
    [anon_sym_alignas] = ACTIONS(4559),
    [anon_sym_template] = ACTIONS(4559),
    [anon_sym_operator] = ACTIONS(4559),
  },
  [1687] = {
    [sym_identifier] = ACTIONS(4563),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4565),
    [anon_sym_COMMA] = ACTIONS(4565),
    [anon_sym_RPAREN] = ACTIONS(4565),
    [anon_sym_LPAREN2] = ACTIONS(4565),
    [anon_sym_TILDE] = ACTIONS(4565),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_STAR] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4563),
    [anon_sym_PERCENT] = ACTIONS(4563),
    [anon_sym_PIPE_PIPE] = ACTIONS(4565),
    [anon_sym_AMP_AMP] = ACTIONS(4565),
    [anon_sym_PIPE] = ACTIONS(4563),
    [anon_sym_CARET] = ACTIONS(4563),
    [anon_sym_AMP] = ACTIONS(4563),
    [anon_sym_EQ_EQ] = ACTIONS(4565),
    [anon_sym_BANG_EQ] = ACTIONS(4565),
    [anon_sym_GT] = ACTIONS(4563),
    [anon_sym_GT_EQ] = ACTIONS(4565),
    [anon_sym_LT_EQ] = ACTIONS(4563),
    [anon_sym_LT] = ACTIONS(4563),
    [anon_sym_LT_LT] = ACTIONS(4563),
    [anon_sym_GT_GT] = ACTIONS(4563),
    [anon_sym_SEMI] = ACTIONS(4565),
    [anon_sym___extension__] = ACTIONS(4563),
    [anon_sym_extern] = ACTIONS(4563),
    [anon_sym___attribute__] = ACTIONS(4563),
    [anon_sym_COLON_COLON] = ACTIONS(4565),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4565),
    [anon_sym___declspec] = ACTIONS(4563),
    [anon_sym___based] = ACTIONS(4563),
    [anon_sym___cdecl] = ACTIONS(4563),
    [anon_sym___clrcall] = ACTIONS(4563),
    [anon_sym___stdcall] = ACTIONS(4563),
    [anon_sym___fastcall] = ACTIONS(4563),
    [anon_sym___thiscall] = ACTIONS(4563),
    [anon_sym___vectorcall] = ACTIONS(4563),
    [anon_sym_LBRACE] = ACTIONS(4565),
    [anon_sym_RBRACE] = ACTIONS(4565),
    [anon_sym_LBRACK] = ACTIONS(4563),
    [anon_sym_EQ] = ACTIONS(4563),
    [anon_sym_static] = ACTIONS(4563),
    [anon_sym_register] = ACTIONS(4563),
    [anon_sym_inline] = ACTIONS(4563),
    [anon_sym___inline] = ACTIONS(4563),
    [anon_sym___inline__] = ACTIONS(4563),
    [anon_sym___forceinline] = ACTIONS(4563),
    [anon_sym_thread_local] = ACTIONS(4563),
    [anon_sym___thread] = ACTIONS(4563),
    [anon_sym_const] = ACTIONS(4563),
    [anon_sym_constexpr] = ACTIONS(4563),
    [anon_sym_volatile] = ACTIONS(4563),
    [anon_sym_restrict] = ACTIONS(4563),
    [anon_sym___restrict__] = ACTIONS(4563),
    [anon_sym__Atomic] = ACTIONS(4563),
    [anon_sym__Noreturn] = ACTIONS(4563),
    [anon_sym_noreturn] = ACTIONS(4563),
    [anon_sym_mutable] = ACTIONS(4563),
    [anon_sym_constinit] = ACTIONS(4563),
    [anon_sym_consteval] = ACTIONS(4563),
    [anon_sym_PROGMEM] = ACTIONS(4563),
    [anon_sym_QMARK] = ACTIONS(4565),
    [anon_sym_STAR_EQ] = ACTIONS(4565),
    [anon_sym_SLASH_EQ] = ACTIONS(4565),
    [anon_sym_PERCENT_EQ] = ACTIONS(4565),
    [anon_sym_PLUS_EQ] = ACTIONS(4565),
    [anon_sym_DASH_EQ] = ACTIONS(4565),
    [anon_sym_LT_LT_EQ] = ACTIONS(4565),
    [anon_sym_GT_GT_EQ] = ACTIONS(4565),
    [anon_sym_AMP_EQ] = ACTIONS(4565),
    [anon_sym_CARET_EQ] = ACTIONS(4565),
    [anon_sym_PIPE_EQ] = ACTIONS(4565),
    [anon_sym_and_eq] = ACTIONS(4563),
    [anon_sym_or_eq] = ACTIONS(4563),
    [anon_sym_xor_eq] = ACTIONS(4563),
    [anon_sym_LT_EQ_GT] = ACTIONS(4565),
    [anon_sym_or] = ACTIONS(4563),
    [anon_sym_and] = ACTIONS(4563),
    [anon_sym_bitor] = ACTIONS(4563),
    [anon_sym_xor] = ACTIONS(4563),
    [anon_sym_bitand] = ACTIONS(4563),
    [anon_sym_not_eq] = ACTIONS(4563),
    [anon_sym_DASH_DASH] = ACTIONS(4565),
    [anon_sym_PLUS_PLUS] = ACTIONS(4565),
    [anon_sym_DOT] = ACTIONS(4563),
    [anon_sym_DOT_STAR] = ACTIONS(4565),
    [anon_sym_DASH_GT] = ACTIONS(4565),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4563),
    [anon_sym_decltype] = ACTIONS(4563),
    [anon_sym_virtual] = ACTIONS(4563),
    [anon_sym_alignas] = ACTIONS(4563),
    [anon_sym_template] = ACTIONS(4563),
    [anon_sym_operator] = ACTIONS(4563),
  },
  [1688] = {
    [sym_identifier] = ACTIONS(4567),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4569),
    [anon_sym_COMMA] = ACTIONS(4569),
    [anon_sym_RPAREN] = ACTIONS(4569),
    [anon_sym_LPAREN2] = ACTIONS(4569),
    [anon_sym_TILDE] = ACTIONS(4569),
    [anon_sym_DASH] = ACTIONS(4567),
    [anon_sym_PLUS] = ACTIONS(4567),
    [anon_sym_STAR] = ACTIONS(4567),
    [anon_sym_SLASH] = ACTIONS(4567),
    [anon_sym_PERCENT] = ACTIONS(4567),
    [anon_sym_PIPE_PIPE] = ACTIONS(4569),
    [anon_sym_AMP_AMP] = ACTIONS(4569),
    [anon_sym_PIPE] = ACTIONS(4567),
    [anon_sym_CARET] = ACTIONS(4567),
    [anon_sym_AMP] = ACTIONS(4567),
    [anon_sym_EQ_EQ] = ACTIONS(4569),
    [anon_sym_BANG_EQ] = ACTIONS(4569),
    [anon_sym_GT] = ACTIONS(4567),
    [anon_sym_GT_EQ] = ACTIONS(4569),
    [anon_sym_LT_EQ] = ACTIONS(4567),
    [anon_sym_LT] = ACTIONS(4567),
    [anon_sym_LT_LT] = ACTIONS(4567),
    [anon_sym_GT_GT] = ACTIONS(4567),
    [anon_sym_SEMI] = ACTIONS(4569),
    [anon_sym___extension__] = ACTIONS(4567),
    [anon_sym_extern] = ACTIONS(4567),
    [anon_sym___attribute__] = ACTIONS(4567),
    [anon_sym_COLON_COLON] = ACTIONS(4569),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4569),
    [anon_sym___declspec] = ACTIONS(4567),
    [anon_sym___based] = ACTIONS(4567),
    [anon_sym___cdecl] = ACTIONS(4567),
    [anon_sym___clrcall] = ACTIONS(4567),
    [anon_sym___stdcall] = ACTIONS(4567),
    [anon_sym___fastcall] = ACTIONS(4567),
    [anon_sym___thiscall] = ACTIONS(4567),
    [anon_sym___vectorcall] = ACTIONS(4567),
    [anon_sym_LBRACE] = ACTIONS(4569),
    [anon_sym_RBRACE] = ACTIONS(4569),
    [anon_sym_LBRACK] = ACTIONS(4567),
    [anon_sym_EQ] = ACTIONS(4567),
    [anon_sym_static] = ACTIONS(4567),
    [anon_sym_register] = ACTIONS(4567),
    [anon_sym_inline] = ACTIONS(4567),
    [anon_sym___inline] = ACTIONS(4567),
    [anon_sym___inline__] = ACTIONS(4567),
    [anon_sym___forceinline] = ACTIONS(4567),
    [anon_sym_thread_local] = ACTIONS(4567),
    [anon_sym___thread] = ACTIONS(4567),
    [anon_sym_const] = ACTIONS(4567),
    [anon_sym_constexpr] = ACTIONS(4567),
    [anon_sym_volatile] = ACTIONS(4567),
    [anon_sym_restrict] = ACTIONS(4567),
    [anon_sym___restrict__] = ACTIONS(4567),
    [anon_sym__Atomic] = ACTIONS(4567),
    [anon_sym__Noreturn] = ACTIONS(4567),
    [anon_sym_noreturn] = ACTIONS(4567),
    [anon_sym_mutable] = ACTIONS(4567),
    [anon_sym_constinit] = ACTIONS(4567),
    [anon_sym_consteval] = ACTIONS(4567),
    [anon_sym_PROGMEM] = ACTIONS(4567),
    [anon_sym_QMARK] = ACTIONS(4569),
    [anon_sym_STAR_EQ] = ACTIONS(4569),
    [anon_sym_SLASH_EQ] = ACTIONS(4569),
    [anon_sym_PERCENT_EQ] = ACTIONS(4569),
    [anon_sym_PLUS_EQ] = ACTIONS(4569),
    [anon_sym_DASH_EQ] = ACTIONS(4569),
    [anon_sym_LT_LT_EQ] = ACTIONS(4569),
    [anon_sym_GT_GT_EQ] = ACTIONS(4569),
    [anon_sym_AMP_EQ] = ACTIONS(4569),
    [anon_sym_CARET_EQ] = ACTIONS(4569),
    [anon_sym_PIPE_EQ] = ACTIONS(4569),
    [anon_sym_and_eq] = ACTIONS(4567),
    [anon_sym_or_eq] = ACTIONS(4567),
    [anon_sym_xor_eq] = ACTIONS(4567),
    [anon_sym_LT_EQ_GT] = ACTIONS(4569),
    [anon_sym_or] = ACTIONS(4567),
    [anon_sym_and] = ACTIONS(4567),
    [anon_sym_bitor] = ACTIONS(4567),
    [anon_sym_xor] = ACTIONS(4567),
    [anon_sym_bitand] = ACTIONS(4567),
    [anon_sym_not_eq] = ACTIONS(4567),
    [anon_sym_DASH_DASH] = ACTIONS(4569),
    [anon_sym_PLUS_PLUS] = ACTIONS(4569),
    [anon_sym_DOT] = ACTIONS(4567),
    [anon_sym_DOT_STAR] = ACTIONS(4569),
    [anon_sym_DASH_GT] = ACTIONS(4569),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4567),
    [anon_sym_decltype] = ACTIONS(4567),
    [anon_sym_virtual] = ACTIONS(4567),
    [anon_sym_alignas] = ACTIONS(4567),
    [anon_sym_template] = ACTIONS(4567),
    [anon_sym_operator] = ACTIONS(4567),
  },
  [1689] = {
    [sym_identifier] = ACTIONS(4571),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4573),
    [anon_sym_COMMA] = ACTIONS(4573),
    [anon_sym_RPAREN] = ACTIONS(4573),
    [anon_sym_LPAREN2] = ACTIONS(4573),
    [anon_sym_TILDE] = ACTIONS(4573),
    [anon_sym_DASH] = ACTIONS(4571),
    [anon_sym_PLUS] = ACTIONS(4571),
    [anon_sym_STAR] = ACTIONS(4571),
    [anon_sym_SLASH] = ACTIONS(4571),
    [anon_sym_PERCENT] = ACTIONS(4571),
    [anon_sym_PIPE_PIPE] = ACTIONS(4573),
    [anon_sym_AMP_AMP] = ACTIONS(4573),
    [anon_sym_PIPE] = ACTIONS(4571),
    [anon_sym_CARET] = ACTIONS(4571),
    [anon_sym_AMP] = ACTIONS(4571),
    [anon_sym_EQ_EQ] = ACTIONS(4573),
    [anon_sym_BANG_EQ] = ACTIONS(4573),
    [anon_sym_GT] = ACTIONS(4571),
    [anon_sym_GT_EQ] = ACTIONS(4573),
    [anon_sym_LT_EQ] = ACTIONS(4571),
    [anon_sym_LT] = ACTIONS(4571),
    [anon_sym_LT_LT] = ACTIONS(4571),
    [anon_sym_GT_GT] = ACTIONS(4571),
    [anon_sym_SEMI] = ACTIONS(4573),
    [anon_sym___extension__] = ACTIONS(4571),
    [anon_sym_extern] = ACTIONS(4571),
    [anon_sym___attribute__] = ACTIONS(4571),
    [anon_sym_COLON_COLON] = ACTIONS(4573),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4573),
    [anon_sym___declspec] = ACTIONS(4571),
    [anon_sym___based] = ACTIONS(4571),
    [anon_sym___cdecl] = ACTIONS(4571),
    [anon_sym___clrcall] = ACTIONS(4571),
    [anon_sym___stdcall] = ACTIONS(4571),
    [anon_sym___fastcall] = ACTIONS(4571),
    [anon_sym___thiscall] = ACTIONS(4571),
    [anon_sym___vectorcall] = ACTIONS(4571),
    [anon_sym_LBRACE] = ACTIONS(4573),
    [anon_sym_RBRACE] = ACTIONS(4573),
    [anon_sym_LBRACK] = ACTIONS(4571),
    [anon_sym_EQ] = ACTIONS(4571),
    [anon_sym_static] = ACTIONS(4571),
    [anon_sym_register] = ACTIONS(4571),
    [anon_sym_inline] = ACTIONS(4571),
    [anon_sym___inline] = ACTIONS(4571),
    [anon_sym___inline__] = ACTIONS(4571),
    [anon_sym___forceinline] = ACTIONS(4571),
    [anon_sym_thread_local] = ACTIONS(4571),
    [anon_sym___thread] = ACTIONS(4571),
    [anon_sym_const] = ACTIONS(4571),
    [anon_sym_constexpr] = ACTIONS(4571),
    [anon_sym_volatile] = ACTIONS(4571),
    [anon_sym_restrict] = ACTIONS(4571),
    [anon_sym___restrict__] = ACTIONS(4571),
    [anon_sym__Atomic] = ACTIONS(4571),
    [anon_sym__Noreturn] = ACTIONS(4571),
    [anon_sym_noreturn] = ACTIONS(4571),
    [anon_sym_mutable] = ACTIONS(4571),
    [anon_sym_constinit] = ACTIONS(4571),
    [anon_sym_consteval] = ACTIONS(4571),
    [anon_sym_PROGMEM] = ACTIONS(4571),
    [anon_sym_QMARK] = ACTIONS(4573),
    [anon_sym_STAR_EQ] = ACTIONS(4573),
    [anon_sym_SLASH_EQ] = ACTIONS(4573),
    [anon_sym_PERCENT_EQ] = ACTIONS(4573),
    [anon_sym_PLUS_EQ] = ACTIONS(4573),
    [anon_sym_DASH_EQ] = ACTIONS(4573),
    [anon_sym_LT_LT_EQ] = ACTIONS(4573),
    [anon_sym_GT_GT_EQ] = ACTIONS(4573),
    [anon_sym_AMP_EQ] = ACTIONS(4573),
    [anon_sym_CARET_EQ] = ACTIONS(4573),
    [anon_sym_PIPE_EQ] = ACTIONS(4573),
    [anon_sym_and_eq] = ACTIONS(4571),
    [anon_sym_or_eq] = ACTIONS(4571),
    [anon_sym_xor_eq] = ACTIONS(4571),
    [anon_sym_LT_EQ_GT] = ACTIONS(4573),
    [anon_sym_or] = ACTIONS(4571),
    [anon_sym_and] = ACTIONS(4571),
    [anon_sym_bitor] = ACTIONS(4571),
    [anon_sym_xor] = ACTIONS(4571),
    [anon_sym_bitand] = ACTIONS(4571),
    [anon_sym_not_eq] = ACTIONS(4571),
    [anon_sym_DASH_DASH] = ACTIONS(4573),
    [anon_sym_PLUS_PLUS] = ACTIONS(4573),
    [anon_sym_DOT] = ACTIONS(4571),
    [anon_sym_DOT_STAR] = ACTIONS(4573),
    [anon_sym_DASH_GT] = ACTIONS(4573),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4571),
    [anon_sym_decltype] = ACTIONS(4571),
    [anon_sym_virtual] = ACTIONS(4571),
    [anon_sym_alignas] = ACTIONS(4571),
    [anon_sym_template] = ACTIONS(4571),
    [anon_sym_operator] = ACTIONS(4571),
  },
  [1690] = {
    [sym_identifier] = ACTIONS(4575),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4577),
    [anon_sym_COMMA] = ACTIONS(4577),
    [anon_sym_LPAREN2] = ACTIONS(4579),
    [anon_sym_TILDE] = ACTIONS(4582),
    [anon_sym_DASH] = ACTIONS(4584),
    [anon_sym_PLUS] = ACTIONS(4584),
    [anon_sym_STAR] = ACTIONS(4586),
    [anon_sym_SLASH] = ACTIONS(4584),
    [anon_sym_PERCENT] = ACTIONS(4584),
    [anon_sym_PIPE_PIPE] = ACTIONS(4577),
    [anon_sym_AMP_AMP] = ACTIONS(4579),
    [anon_sym_PIPE] = ACTIONS(4584),
    [anon_sym_CARET] = ACTIONS(4584),
    [anon_sym_AMP] = ACTIONS(4586),
    [anon_sym_EQ_EQ] = ACTIONS(4577),
    [anon_sym_BANG_EQ] = ACTIONS(4577),
    [anon_sym_GT] = ACTIONS(4584),
    [anon_sym_GT_EQ] = ACTIONS(4577),
    [anon_sym_LT_EQ] = ACTIONS(4584),
    [anon_sym_LT] = ACTIONS(4584),
    [anon_sym_LT_LT] = ACTIONS(4584),
    [anon_sym_GT_GT] = ACTIONS(4584),
    [anon_sym_SEMI] = ACTIONS(4579),
    [anon_sym___extension__] = ACTIONS(4575),
    [anon_sym_extern] = ACTIONS(4575),
    [anon_sym___attribute__] = ACTIONS(4575),
    [anon_sym_COLON_COLON] = ACTIONS(4582),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4579),
    [anon_sym___declspec] = ACTIONS(4575),
    [anon_sym___based] = ACTIONS(4575),
    [anon_sym___cdecl] = ACTIONS(4575),
    [anon_sym___clrcall] = ACTIONS(4575),
    [anon_sym___stdcall] = ACTIONS(4575),
    [anon_sym___fastcall] = ACTIONS(4575),
    [anon_sym___thiscall] = ACTIONS(4575),
    [anon_sym___vectorcall] = ACTIONS(4575),
    [anon_sym_LBRACE] = ACTIONS(4582),
    [anon_sym_RBRACE] = ACTIONS(4577),
    [anon_sym_LBRACK] = ACTIONS(4586),
    [anon_sym_EQ] = ACTIONS(4584),
    [anon_sym_static] = ACTIONS(4575),
    [anon_sym_register] = ACTIONS(4575),
    [anon_sym_inline] = ACTIONS(4575),
    [anon_sym___inline] = ACTIONS(4575),
    [anon_sym___inline__] = ACTIONS(4575),
    [anon_sym___forceinline] = ACTIONS(4575),
    [anon_sym_thread_local] = ACTIONS(4575),
    [anon_sym___thread] = ACTIONS(4575),
    [anon_sym_const] = ACTIONS(4575),
    [anon_sym_constexpr] = ACTIONS(4575),
    [anon_sym_volatile] = ACTIONS(4575),
    [anon_sym_restrict] = ACTIONS(4575),
    [anon_sym___restrict__] = ACTIONS(4575),
    [anon_sym__Atomic] = ACTIONS(4575),
    [anon_sym__Noreturn] = ACTIONS(4575),
    [anon_sym_noreturn] = ACTIONS(4575),
    [anon_sym_mutable] = ACTIONS(4575),
    [anon_sym_constinit] = ACTIONS(4575),
    [anon_sym_consteval] = ACTIONS(4575),
    [anon_sym_PROGMEM] = ACTIONS(4575),
    [anon_sym_QMARK] = ACTIONS(4577),
    [anon_sym_STAR_EQ] = ACTIONS(4577),
    [anon_sym_SLASH_EQ] = ACTIONS(4577),
    [anon_sym_PERCENT_EQ] = ACTIONS(4577),
    [anon_sym_PLUS_EQ] = ACTIONS(4577),
    [anon_sym_DASH_EQ] = ACTIONS(4577),
    [anon_sym_LT_LT_EQ] = ACTIONS(4577),
    [anon_sym_GT_GT_EQ] = ACTIONS(4577),
    [anon_sym_AMP_EQ] = ACTIONS(4577),
    [anon_sym_CARET_EQ] = ACTIONS(4577),
    [anon_sym_PIPE_EQ] = ACTIONS(4577),
    [anon_sym_and_eq] = ACTIONS(4584),
    [anon_sym_or_eq] = ACTIONS(4584),
    [anon_sym_xor_eq] = ACTIONS(4584),
    [anon_sym_LT_EQ_GT] = ACTIONS(4577),
    [anon_sym_or] = ACTIONS(4584),
    [anon_sym_and] = ACTIONS(4584),
    [anon_sym_bitor] = ACTIONS(4584),
    [anon_sym_xor] = ACTIONS(4584),
    [anon_sym_bitand] = ACTIONS(4584),
    [anon_sym_not_eq] = ACTIONS(4584),
    [anon_sym_DASH_DASH] = ACTIONS(4577),
    [anon_sym_PLUS_PLUS] = ACTIONS(4577),
    [anon_sym_DOT] = ACTIONS(4584),
    [anon_sym_DOT_STAR] = ACTIONS(4577),
    [anon_sym_DASH_GT] = ACTIONS(4577),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4575),
    [anon_sym_decltype] = ACTIONS(4575),
    [anon_sym_virtual] = ACTIONS(4575),
    [anon_sym_alignas] = ACTIONS(4575),
    [anon_sym_template] = ACTIONS(4575),
    [anon_sym_operator] = ACTIONS(4575),
  },
  [1691] = {
    [sym__declaration_modifiers] = STATE(1964),
    [sym__declaration_specifiers] = STATE(5148),
    [sym_attribute_specifier] = STATE(1964),
    [sym_attribute_declaration] = STATE(1964),
    [sym_ms_declspec_modifier] = STATE(1964),
    [sym_ms_based_modifier] = STATE(8318),
    [sym__declarator] = STATE(6425),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6098),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(1964),
    [sym_type_qualifier] = STATE(1964),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(1964),
    [sym_alignas_specifier] = STATE(1964),
    [sym_dependent_type] = STATE(2629),
    [sym_template_parameter_list] = STATE(923),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(4210),
    [sym_template_function] = STATE(6098),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5523),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_operator_name] = STATE(6098),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [sym_identifier] = ACTIONS(4589),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym_LT] = ACTIONS(4591),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4593),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_operator] = ACTIONS(1871),
  },
  [1692] = {
    [sym__declaration_modifiers] = STATE(1964),
    [sym__declaration_specifiers] = STATE(5077),
    [sym_attribute_specifier] = STATE(1964),
    [sym_attribute_declaration] = STATE(1964),
    [sym_ms_declspec_modifier] = STATE(1964),
    [sym_ms_based_modifier] = STATE(8318),
    [sym__declarator] = STATE(6422),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6098),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(1964),
    [sym_type_qualifier] = STATE(1964),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(1964),
    [sym_alignas_specifier] = STATE(1964),
    [sym_dependent_type] = STATE(2629),
    [sym_template_parameter_list] = STATE(919),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(4210),
    [sym_template_function] = STATE(6098),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5523),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_operator_name] = STATE(6098),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [sym_identifier] = ACTIONS(4589),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym_LT] = ACTIONS(4591),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4593),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_operator] = ACTIONS(1871),
  },
  [1693] = {
    [sym__declaration_modifiers] = STATE(1964),
    [sym__declaration_specifiers] = STATE(5128),
    [sym_attribute_specifier] = STATE(1964),
    [sym_attribute_declaration] = STATE(1964),
    [sym_ms_declspec_modifier] = STATE(1964),
    [sym_ms_based_modifier] = STATE(8318),
    [sym__declarator] = STATE(6430),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6098),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(1964),
    [sym_type_qualifier] = STATE(1964),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(1964),
    [sym_alignas_specifier] = STATE(1964),
    [sym_dependent_type] = STATE(2629),
    [sym_template_parameter_list] = STATE(922),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(4210),
    [sym_template_function] = STATE(6098),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5523),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_operator_name] = STATE(6098),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [sym_identifier] = ACTIONS(4589),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym_LT] = ACTIONS(4591),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4593),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_operator] = ACTIONS(1871),
  },
  [1694] = {
    [sym__declaration_modifiers] = STATE(1964),
    [sym__declaration_specifiers] = STATE(5097),
    [sym_attribute_specifier] = STATE(1964),
    [sym_attribute_declaration] = STATE(1964),
    [sym_ms_declspec_modifier] = STATE(1964),
    [sym_ms_based_modifier] = STATE(8318),
    [sym__declarator] = STATE(6386),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6098),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(1964),
    [sym_type_qualifier] = STATE(1964),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(1964),
    [sym_alignas_specifier] = STATE(1964),
    [sym_dependent_type] = STATE(2629),
    [sym_template_parameter_list] = STATE(920),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(4210),
    [sym_template_function] = STATE(6098),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5523),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_type_identifier] = STATE(3260),
    [sym_operator_name] = STATE(6098),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [sym_identifier] = ACTIONS(4589),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym_LT] = ACTIONS(4591),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4593),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_operator] = ACTIONS(1871),
  },
  [1695] = {
    [sym_identifier] = ACTIONS(3016),
    [anon_sym_LPAREN2] = ACTIONS(3018),
    [anon_sym_BANG] = ACTIONS(3018),
    [anon_sym_TILDE] = ACTIONS(3018),
    [anon_sym_DASH] = ACTIONS(3016),
    [anon_sym_PLUS] = ACTIONS(3016),
    [anon_sym_STAR] = ACTIONS(3018),
    [anon_sym_AMP] = ACTIONS(3018),
    [anon_sym___extension__] = ACTIONS(3016),
    [anon_sym_extern] = ACTIONS(3016),
    [anon_sym___attribute__] = ACTIONS(3016),
    [anon_sym_COLON_COLON] = ACTIONS(3018),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3018),
    [anon_sym___declspec] = ACTIONS(3016),
    [anon_sym_signed] = ACTIONS(3016),
    [anon_sym_unsigned] = ACTIONS(3016),
    [anon_sym_long] = ACTIONS(3016),
    [anon_sym_short] = ACTIONS(3016),
    [anon_sym_LBRACK] = ACTIONS(3016),
    [anon_sym_static] = ACTIONS(3016),
    [anon_sym_register] = ACTIONS(3016),
    [anon_sym_inline] = ACTIONS(3016),
    [anon_sym___inline] = ACTIONS(3016),
    [anon_sym___inline__] = ACTIONS(3016),
    [anon_sym___forceinline] = ACTIONS(3016),
    [anon_sym_thread_local] = ACTIONS(3016),
    [anon_sym___thread] = ACTIONS(3016),
    [anon_sym_const] = ACTIONS(3016),
    [anon_sym_constexpr] = ACTIONS(3016),
    [anon_sym_volatile] = ACTIONS(3016),
    [anon_sym_restrict] = ACTIONS(3016),
    [anon_sym___restrict__] = ACTIONS(3016),
    [anon_sym__Atomic] = ACTIONS(3016),
    [anon_sym__Noreturn] = ACTIONS(3016),
    [anon_sym_noreturn] = ACTIONS(3016),
    [anon_sym_mutable] = ACTIONS(3016),
    [anon_sym_constinit] = ACTIONS(3016),
    [anon_sym_consteval] = ACTIONS(3016),
    [anon_sym_PROGMEM] = ACTIONS(3016),
    [aux_sym_primitive_type_token1] = ACTIONS(3016),
    [anon_sym_byte] = ACTIONS(3016),
    [anon_sym_word] = ACTIONS(3016),
    [anon_sym_enum] = ACTIONS(3016),
    [anon_sym_class] = ACTIONS(3016),
    [anon_sym_struct] = ACTIONS(3016),
    [anon_sym_union] = ACTIONS(3016),
    [anon_sym_not] = ACTIONS(3016),
    [anon_sym_compl] = ACTIONS(3016),
    [anon_sym_DASH_DASH] = ACTIONS(3018),
    [anon_sym_PLUS_PLUS] = ACTIONS(3018),
    [anon_sym_sizeof] = ACTIONS(3016),
    [anon_sym___alignof__] = ACTIONS(3016),
    [anon_sym___alignof] = ACTIONS(3016),
    [anon_sym__alignof] = ACTIONS(3016),
    [anon_sym_alignof] = ACTIONS(3016),
    [anon_sym__Alignof] = ACTIONS(3016),
    [anon_sym_offsetof] = ACTIONS(3016),
    [anon_sym__Generic] = ACTIONS(3016),
    [anon_sym_asm] = ACTIONS(3016),
    [anon_sym___asm__] = ACTIONS(3016),
    [aux_sym_number_literal_token1] = ACTIONS(3018),
    [aux_sym_number_literal_token2] = ACTIONS(3016),
    [anon_sym_L_SQUOTE] = ACTIONS(3018),
    [anon_sym_u_SQUOTE] = ACTIONS(3018),
    [anon_sym_U_SQUOTE] = ACTIONS(3018),
    [anon_sym_u8_SQUOTE] = ACTIONS(3018),
    [anon_sym_SQUOTE] = ACTIONS(3018),
    [anon_sym_L_DQUOTE] = ACTIONS(3018),
    [anon_sym_u_DQUOTE] = ACTIONS(3018),
    [anon_sym_U_DQUOTE] = ACTIONS(3018),
    [anon_sym_u8_DQUOTE] = ACTIONS(3018),
    [anon_sym_DQUOTE] = ACTIONS(3018),
    [sym_true] = ACTIONS(3016),
    [sym_false] = ACTIONS(3016),
    [anon_sym_NULL] = ACTIONS(3016),
    [anon_sym_nullptr] = ACTIONS(3016),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3016),
    [anon_sym_decltype] = ACTIONS(3016),
    [anon_sym_virtual] = ACTIONS(3016),
    [anon_sym_alignas] = ACTIONS(3016),
    [anon_sym_typename] = ACTIONS(3016),
    [anon_sym_template] = ACTIONS(3016),
    [anon_sym_delete] = ACTIONS(3016),
    [anon_sym_R_DQUOTE] = ACTIONS(3018),
    [anon_sym_LR_DQUOTE] = ACTIONS(3018),
    [anon_sym_uR_DQUOTE] = ACTIONS(3018),
    [anon_sym_UR_DQUOTE] = ACTIONS(3018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3018),
    [anon_sym_co_await] = ACTIONS(3016),
    [anon_sym_new] = ACTIONS(3016),
    [anon_sym_requires] = ACTIONS(3016),
    [sym_this] = ACTIONS(3016),
  },
  [1696] = {
    [sym_identifier] = ACTIONS(2536),
    [anon_sym_LPAREN2] = ACTIONS(2541),
    [anon_sym_BANG] = ACTIONS(2541),
    [anon_sym_TILDE] = ACTIONS(2541),
    [anon_sym_DASH] = ACTIONS(2536),
    [anon_sym_PLUS] = ACTIONS(2536),
    [anon_sym_STAR] = ACTIONS(2541),
    [anon_sym_AMP] = ACTIONS(2541),
    [anon_sym___extension__] = ACTIONS(2536),
    [anon_sym_extern] = ACTIONS(2536),
    [anon_sym___attribute__] = ACTIONS(2536),
    [anon_sym_COLON_COLON] = ACTIONS(2541),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2541),
    [anon_sym___declspec] = ACTIONS(2536),
    [anon_sym_signed] = ACTIONS(2536),
    [anon_sym_unsigned] = ACTIONS(2536),
    [anon_sym_long] = ACTIONS(2536),
    [anon_sym_short] = ACTIONS(2536),
    [anon_sym_LBRACK] = ACTIONS(2536),
    [anon_sym_static] = ACTIONS(2536),
    [anon_sym_register] = ACTIONS(2536),
    [anon_sym_inline] = ACTIONS(2536),
    [anon_sym___inline] = ACTIONS(2536),
    [anon_sym___inline__] = ACTIONS(2536),
    [anon_sym___forceinline] = ACTIONS(2536),
    [anon_sym_thread_local] = ACTIONS(2536),
    [anon_sym___thread] = ACTIONS(2536),
    [anon_sym_const] = ACTIONS(2536),
    [anon_sym_constexpr] = ACTIONS(2536),
    [anon_sym_volatile] = ACTIONS(2536),
    [anon_sym_restrict] = ACTIONS(2536),
    [anon_sym___restrict__] = ACTIONS(2536),
    [anon_sym__Atomic] = ACTIONS(2536),
    [anon_sym__Noreturn] = ACTIONS(2536),
    [anon_sym_noreturn] = ACTIONS(2536),
    [anon_sym_mutable] = ACTIONS(2536),
    [anon_sym_constinit] = ACTIONS(2536),
    [anon_sym_consteval] = ACTIONS(2536),
    [anon_sym_PROGMEM] = ACTIONS(2536),
    [aux_sym_primitive_type_token1] = ACTIONS(2536),
    [anon_sym_byte] = ACTIONS(2536),
    [anon_sym_word] = ACTIONS(2536),
    [anon_sym_enum] = ACTIONS(2536),
    [anon_sym_class] = ACTIONS(2536),
    [anon_sym_struct] = ACTIONS(2536),
    [anon_sym_union] = ACTIONS(2536),
    [anon_sym_not] = ACTIONS(2536),
    [anon_sym_compl] = ACTIONS(2536),
    [anon_sym_DASH_DASH] = ACTIONS(2541),
    [anon_sym_PLUS_PLUS] = ACTIONS(2541),
    [anon_sym_sizeof] = ACTIONS(2536),
    [anon_sym___alignof__] = ACTIONS(2536),
    [anon_sym___alignof] = ACTIONS(2536),
    [anon_sym__alignof] = ACTIONS(2536),
    [anon_sym_alignof] = ACTIONS(2536),
    [anon_sym__Alignof] = ACTIONS(2536),
    [anon_sym_offsetof] = ACTIONS(2536),
    [anon_sym__Generic] = ACTIONS(2536),
    [anon_sym_asm] = ACTIONS(2536),
    [anon_sym___asm__] = ACTIONS(2536),
    [aux_sym_number_literal_token1] = ACTIONS(2541),
    [aux_sym_number_literal_token2] = ACTIONS(2536),
    [anon_sym_L_SQUOTE] = ACTIONS(2541),
    [anon_sym_u_SQUOTE] = ACTIONS(2541),
    [anon_sym_U_SQUOTE] = ACTIONS(2541),
    [anon_sym_u8_SQUOTE] = ACTIONS(2541),
    [anon_sym_SQUOTE] = ACTIONS(2541),
    [anon_sym_L_DQUOTE] = ACTIONS(2541),
    [anon_sym_u_DQUOTE] = ACTIONS(2541),
    [anon_sym_U_DQUOTE] = ACTIONS(2541),
    [anon_sym_u8_DQUOTE] = ACTIONS(2541),
    [anon_sym_DQUOTE] = ACTIONS(2541),
    [sym_true] = ACTIONS(2536),
    [sym_false] = ACTIONS(2536),
    [anon_sym_NULL] = ACTIONS(2536),
    [anon_sym_nullptr] = ACTIONS(2536),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2536),
    [anon_sym_decltype] = ACTIONS(2536),
    [anon_sym_virtual] = ACTIONS(2536),
    [anon_sym_alignas] = ACTIONS(2536),
    [anon_sym_typename] = ACTIONS(2536),
    [anon_sym_template] = ACTIONS(2536),
    [anon_sym_delete] = ACTIONS(2536),
    [anon_sym_R_DQUOTE] = ACTIONS(2541),
    [anon_sym_LR_DQUOTE] = ACTIONS(2541),
    [anon_sym_uR_DQUOTE] = ACTIONS(2541),
    [anon_sym_UR_DQUOTE] = ACTIONS(2541),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2541),
    [anon_sym_co_await] = ACTIONS(2536),
    [anon_sym_new] = ACTIONS(2536),
    [anon_sym_requires] = ACTIONS(2536),
    [sym_this] = ACTIONS(2536),
  },
  [1697] = {
    [sym_identifier] = ACTIONS(3086),
    [anon_sym_LPAREN2] = ACTIONS(3088),
    [anon_sym_BANG] = ACTIONS(3088),
    [anon_sym_TILDE] = ACTIONS(3088),
    [anon_sym_DASH] = ACTIONS(3086),
    [anon_sym_PLUS] = ACTIONS(3086),
    [anon_sym_STAR] = ACTIONS(3088),
    [anon_sym_AMP] = ACTIONS(3088),
    [anon_sym___extension__] = ACTIONS(3086),
    [anon_sym_extern] = ACTIONS(3086),
    [anon_sym___attribute__] = ACTIONS(3086),
    [anon_sym_COLON_COLON] = ACTIONS(3088),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3088),
    [anon_sym___declspec] = ACTIONS(3086),
    [anon_sym_signed] = ACTIONS(3086),
    [anon_sym_unsigned] = ACTIONS(3086),
    [anon_sym_long] = ACTIONS(3086),
    [anon_sym_short] = ACTIONS(3086),
    [anon_sym_LBRACK] = ACTIONS(3086),
    [anon_sym_static] = ACTIONS(3086),
    [anon_sym_register] = ACTIONS(3086),
    [anon_sym_inline] = ACTIONS(3086),
    [anon_sym___inline] = ACTIONS(3086),
    [anon_sym___inline__] = ACTIONS(3086),
    [anon_sym___forceinline] = ACTIONS(3086),
    [anon_sym_thread_local] = ACTIONS(3086),
    [anon_sym___thread] = ACTIONS(3086),
    [anon_sym_const] = ACTIONS(3086),
    [anon_sym_constexpr] = ACTIONS(3086),
    [anon_sym_volatile] = ACTIONS(3086),
    [anon_sym_restrict] = ACTIONS(3086),
    [anon_sym___restrict__] = ACTIONS(3086),
    [anon_sym__Atomic] = ACTIONS(3086),
    [anon_sym__Noreturn] = ACTIONS(3086),
    [anon_sym_noreturn] = ACTIONS(3086),
    [anon_sym_mutable] = ACTIONS(3086),
    [anon_sym_constinit] = ACTIONS(3086),
    [anon_sym_consteval] = ACTIONS(3086),
    [anon_sym_PROGMEM] = ACTIONS(3086),
    [aux_sym_primitive_type_token1] = ACTIONS(3086),
    [anon_sym_byte] = ACTIONS(3086),
    [anon_sym_word] = ACTIONS(3086),
    [anon_sym_enum] = ACTIONS(3086),
    [anon_sym_class] = ACTIONS(3086),
    [anon_sym_struct] = ACTIONS(3086),
    [anon_sym_union] = ACTIONS(3086),
    [anon_sym_not] = ACTIONS(3086),
    [anon_sym_compl] = ACTIONS(3086),
    [anon_sym_DASH_DASH] = ACTIONS(3088),
    [anon_sym_PLUS_PLUS] = ACTIONS(3088),
    [anon_sym_sizeof] = ACTIONS(3086),
    [anon_sym___alignof__] = ACTIONS(3086),
    [anon_sym___alignof] = ACTIONS(3086),
    [anon_sym__alignof] = ACTIONS(3086),
    [anon_sym_alignof] = ACTIONS(3086),
    [anon_sym__Alignof] = ACTIONS(3086),
    [anon_sym_offsetof] = ACTIONS(3086),
    [anon_sym__Generic] = ACTIONS(3086),
    [anon_sym_asm] = ACTIONS(3086),
    [anon_sym___asm__] = ACTIONS(3086),
    [aux_sym_number_literal_token1] = ACTIONS(3088),
    [aux_sym_number_literal_token2] = ACTIONS(3086),
    [anon_sym_L_SQUOTE] = ACTIONS(3088),
    [anon_sym_u_SQUOTE] = ACTIONS(3088),
    [anon_sym_U_SQUOTE] = ACTIONS(3088),
    [anon_sym_u8_SQUOTE] = ACTIONS(3088),
    [anon_sym_SQUOTE] = ACTIONS(3088),
    [anon_sym_L_DQUOTE] = ACTIONS(3088),
    [anon_sym_u_DQUOTE] = ACTIONS(3088),
    [anon_sym_U_DQUOTE] = ACTIONS(3088),
    [anon_sym_u8_DQUOTE] = ACTIONS(3088),
    [anon_sym_DQUOTE] = ACTIONS(3088),
    [sym_true] = ACTIONS(3086),
    [sym_false] = ACTIONS(3086),
    [anon_sym_NULL] = ACTIONS(3086),
    [anon_sym_nullptr] = ACTIONS(3086),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3086),
    [anon_sym_decltype] = ACTIONS(3086),
    [anon_sym_virtual] = ACTIONS(3086),
    [anon_sym_alignas] = ACTIONS(3086),
    [anon_sym_typename] = ACTIONS(3086),
    [anon_sym_template] = ACTIONS(3086),
    [anon_sym_delete] = ACTIONS(3086),
    [anon_sym_R_DQUOTE] = ACTIONS(3088),
    [anon_sym_LR_DQUOTE] = ACTIONS(3088),
    [anon_sym_uR_DQUOTE] = ACTIONS(3088),
    [anon_sym_UR_DQUOTE] = ACTIONS(3088),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3088),
    [anon_sym_co_await] = ACTIONS(3086),
    [anon_sym_new] = ACTIONS(3086),
    [anon_sym_requires] = ACTIONS(3086),
    [sym_this] = ACTIONS(3086),
  },
  [1698] = {
    [sym_template_argument_list] = STATE(1710),
    [sym_identifier] = ACTIONS(4534),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4538),
    [anon_sym_COMMA] = ACTIONS(4538),
    [anon_sym_RPAREN] = ACTIONS(4538),
    [anon_sym_LPAREN2] = ACTIONS(4538),
    [anon_sym_TILDE] = ACTIONS(4541),
    [anon_sym_DASH] = ACTIONS(4543),
    [anon_sym_PLUS] = ACTIONS(4543),
    [anon_sym_STAR] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(4543),
    [anon_sym_PERCENT] = ACTIONS(4543),
    [anon_sym_PIPE_PIPE] = ACTIONS(4536),
    [anon_sym_AMP_AMP] = ACTIONS(4538),
    [anon_sym_PIPE] = ACTIONS(4543),
    [anon_sym_CARET] = ACTIONS(4543),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_EQ_EQ] = ACTIONS(4536),
    [anon_sym_BANG_EQ] = ACTIONS(4536),
    [anon_sym_GT] = ACTIONS(4543),
    [anon_sym_GT_EQ] = ACTIONS(4536),
    [anon_sym_LT_EQ] = ACTIONS(4543),
    [anon_sym_LT] = ACTIONS(4595),
    [anon_sym_LT_LT] = ACTIONS(4543),
    [anon_sym_GT_GT] = ACTIONS(4543),
    [anon_sym___extension__] = ACTIONS(4534),
    [anon_sym_extern] = ACTIONS(4534),
    [anon_sym___attribute__] = ACTIONS(4534),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4541),
    [anon_sym___declspec] = ACTIONS(4534),
    [anon_sym___based] = ACTIONS(4534),
    [anon_sym_LBRACE] = ACTIONS(4541),
    [anon_sym_LBRACK] = ACTIONS(4545),
    [anon_sym_EQ] = ACTIONS(4545),
    [anon_sym_static] = ACTIONS(4534),
    [anon_sym_register] = ACTIONS(4534),
    [anon_sym_inline] = ACTIONS(4534),
    [anon_sym___inline] = ACTIONS(4534),
    [anon_sym___inline__] = ACTIONS(4534),
    [anon_sym___forceinline] = ACTIONS(4534),
    [anon_sym_thread_local] = ACTIONS(4534),
    [anon_sym___thread] = ACTIONS(4534),
    [anon_sym_const] = ACTIONS(4534),
    [anon_sym_constexpr] = ACTIONS(4534),
    [anon_sym_volatile] = ACTIONS(4534),
    [anon_sym_restrict] = ACTIONS(4534),
    [anon_sym___restrict__] = ACTIONS(4534),
    [anon_sym__Atomic] = ACTIONS(4534),
    [anon_sym__Noreturn] = ACTIONS(4534),
    [anon_sym_noreturn] = ACTIONS(4534),
    [anon_sym_mutable] = ACTIONS(4534),
    [anon_sym_constinit] = ACTIONS(4534),
    [anon_sym_consteval] = ACTIONS(4534),
    [anon_sym_PROGMEM] = ACTIONS(4534),
    [anon_sym_QMARK] = ACTIONS(4536),
    [anon_sym_STAR_EQ] = ACTIONS(4536),
    [anon_sym_SLASH_EQ] = ACTIONS(4536),
    [anon_sym_PERCENT_EQ] = ACTIONS(4536),
    [anon_sym_PLUS_EQ] = ACTIONS(4536),
    [anon_sym_DASH_EQ] = ACTIONS(4536),
    [anon_sym_LT_LT_EQ] = ACTIONS(4536),
    [anon_sym_GT_GT_EQ] = ACTIONS(4536),
    [anon_sym_AMP_EQ] = ACTIONS(4536),
    [anon_sym_CARET_EQ] = ACTIONS(4536),
    [anon_sym_PIPE_EQ] = ACTIONS(4536),
    [anon_sym_and_eq] = ACTIONS(4543),
    [anon_sym_or_eq] = ACTIONS(4543),
    [anon_sym_xor_eq] = ACTIONS(4543),
    [anon_sym_LT_EQ_GT] = ACTIONS(4536),
    [anon_sym_or] = ACTIONS(4543),
    [anon_sym_and] = ACTIONS(4543),
    [anon_sym_bitor] = ACTIONS(4543),
    [anon_sym_xor] = ACTIONS(4543),
    [anon_sym_bitand] = ACTIONS(4543),
    [anon_sym_not_eq] = ACTIONS(4543),
    [anon_sym_DASH_DASH] = ACTIONS(4536),
    [anon_sym_PLUS_PLUS] = ACTIONS(4536),
    [anon_sym_DOT] = ACTIONS(4543),
    [anon_sym_DOT_STAR] = ACTIONS(4536),
    [anon_sym_DASH_GT] = ACTIONS(4543),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4534),
    [anon_sym_decltype] = ACTIONS(4534),
    [anon_sym_virtual] = ACTIONS(4534),
    [anon_sym_alignas] = ACTIONS(4534),
    [anon_sym_template] = ACTIONS(4534),
    [anon_sym_operator] = ACTIONS(4534),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4536),
  },
  [1699] = {
    [sym_template_argument_list] = STATE(1709),
    [sym_identifier] = ACTIONS(4534),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4536),
    [anon_sym_COMMA] = ACTIONS(4536),
    [anon_sym_RPAREN] = ACTIONS(4536),
    [anon_sym_LPAREN2] = ACTIONS(4538),
    [anon_sym_TILDE] = ACTIONS(4541),
    [anon_sym_DASH] = ACTIONS(4543),
    [anon_sym_PLUS] = ACTIONS(4543),
    [anon_sym_STAR] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(4543),
    [anon_sym_PERCENT] = ACTIONS(4543),
    [anon_sym_PIPE_PIPE] = ACTIONS(4536),
    [anon_sym_AMP_AMP] = ACTIONS(4538),
    [anon_sym_PIPE] = ACTIONS(4543),
    [anon_sym_CARET] = ACTIONS(4543),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_EQ_EQ] = ACTIONS(4536),
    [anon_sym_BANG_EQ] = ACTIONS(4536),
    [anon_sym_GT] = ACTIONS(4543),
    [anon_sym_GT_EQ] = ACTIONS(4536),
    [anon_sym_LT_EQ] = ACTIONS(4543),
    [anon_sym_LT] = ACTIONS(4548),
    [anon_sym_LT_LT] = ACTIONS(4543),
    [anon_sym_GT_GT] = ACTIONS(4543),
    [anon_sym_SEMI] = ACTIONS(4536),
    [anon_sym___extension__] = ACTIONS(4534),
    [anon_sym_extern] = ACTIONS(4534),
    [anon_sym___attribute__] = ACTIONS(4534),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4541),
    [anon_sym___declspec] = ACTIONS(4534),
    [anon_sym___based] = ACTIONS(4534),
    [anon_sym_LBRACE] = ACTIONS(4541),
    [anon_sym_LBRACK] = ACTIONS(4545),
    [anon_sym_EQ] = ACTIONS(4543),
    [anon_sym_static] = ACTIONS(4534),
    [anon_sym_register] = ACTIONS(4534),
    [anon_sym_inline] = ACTIONS(4534),
    [anon_sym___inline] = ACTIONS(4534),
    [anon_sym___inline__] = ACTIONS(4534),
    [anon_sym___forceinline] = ACTIONS(4534),
    [anon_sym_thread_local] = ACTIONS(4534),
    [anon_sym___thread] = ACTIONS(4534),
    [anon_sym_const] = ACTIONS(4534),
    [anon_sym_constexpr] = ACTIONS(4534),
    [anon_sym_volatile] = ACTIONS(4534),
    [anon_sym_restrict] = ACTIONS(4534),
    [anon_sym___restrict__] = ACTIONS(4534),
    [anon_sym__Atomic] = ACTIONS(4534),
    [anon_sym__Noreturn] = ACTIONS(4534),
    [anon_sym_noreturn] = ACTIONS(4534),
    [anon_sym_mutable] = ACTIONS(4534),
    [anon_sym_constinit] = ACTIONS(4534),
    [anon_sym_consteval] = ACTIONS(4534),
    [anon_sym_PROGMEM] = ACTIONS(4534),
    [anon_sym_QMARK] = ACTIONS(4536),
    [anon_sym_STAR_EQ] = ACTIONS(4536),
    [anon_sym_SLASH_EQ] = ACTIONS(4536),
    [anon_sym_PERCENT_EQ] = ACTIONS(4536),
    [anon_sym_PLUS_EQ] = ACTIONS(4536),
    [anon_sym_DASH_EQ] = ACTIONS(4536),
    [anon_sym_LT_LT_EQ] = ACTIONS(4536),
    [anon_sym_GT_GT_EQ] = ACTIONS(4536),
    [anon_sym_AMP_EQ] = ACTIONS(4536),
    [anon_sym_CARET_EQ] = ACTIONS(4536),
    [anon_sym_PIPE_EQ] = ACTIONS(4536),
    [anon_sym_and_eq] = ACTIONS(4543),
    [anon_sym_or_eq] = ACTIONS(4543),
    [anon_sym_xor_eq] = ACTIONS(4543),
    [anon_sym_LT_EQ_GT] = ACTIONS(4536),
    [anon_sym_or] = ACTIONS(4543),
    [anon_sym_and] = ACTIONS(4543),
    [anon_sym_bitor] = ACTIONS(4543),
    [anon_sym_xor] = ACTIONS(4543),
    [anon_sym_bitand] = ACTIONS(4543),
    [anon_sym_not_eq] = ACTIONS(4543),
    [anon_sym_DASH_DASH] = ACTIONS(4536),
    [anon_sym_PLUS_PLUS] = ACTIONS(4536),
    [anon_sym_DOT] = ACTIONS(4543),
    [anon_sym_DOT_STAR] = ACTIONS(4536),
    [anon_sym_DASH_GT] = ACTIONS(4536),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4534),
    [anon_sym_decltype] = ACTIONS(4534),
    [anon_sym_virtual] = ACTIONS(4534),
    [anon_sym_alignas] = ACTIONS(4534),
    [anon_sym_template] = ACTIONS(4534),
    [anon_sym_operator] = ACTIONS(4534),
  },
  [1700] = {
    [sym_identifier] = ACTIONS(4530),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4532),
    [anon_sym_COMMA] = ACTIONS(4532),
    [anon_sym_RPAREN] = ACTIONS(4532),
    [anon_sym_LPAREN2] = ACTIONS(4532),
    [anon_sym_TILDE] = ACTIONS(4532),
    [anon_sym_DASH] = ACTIONS(4530),
    [anon_sym_PLUS] = ACTIONS(4530),
    [anon_sym_STAR] = ACTIONS(4530),
    [anon_sym_SLASH] = ACTIONS(4530),
    [anon_sym_PERCENT] = ACTIONS(4530),
    [anon_sym_PIPE_PIPE] = ACTIONS(4532),
    [anon_sym_AMP_AMP] = ACTIONS(4532),
    [anon_sym_PIPE] = ACTIONS(4530),
    [anon_sym_CARET] = ACTIONS(4530),
    [anon_sym_AMP] = ACTIONS(4530),
    [anon_sym_EQ_EQ] = ACTIONS(4532),
    [anon_sym_BANG_EQ] = ACTIONS(4532),
    [anon_sym_GT] = ACTIONS(4530),
    [anon_sym_GT_EQ] = ACTIONS(4532),
    [anon_sym_LT_EQ] = ACTIONS(4530),
    [anon_sym_LT] = ACTIONS(4530),
    [anon_sym_LT_LT] = ACTIONS(4530),
    [anon_sym_GT_GT] = ACTIONS(4530),
    [anon_sym___extension__] = ACTIONS(4530),
    [anon_sym_extern] = ACTIONS(4530),
    [anon_sym___attribute__] = ACTIONS(4530),
    [anon_sym_COLON_COLON] = ACTIONS(4532),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4532),
    [anon_sym___declspec] = ACTIONS(4530),
    [anon_sym___based] = ACTIONS(4530),
    [anon_sym_LBRACE] = ACTIONS(4532),
    [anon_sym_LBRACK] = ACTIONS(4530),
    [anon_sym_EQ] = ACTIONS(4530),
    [anon_sym_static] = ACTIONS(4530),
    [anon_sym_register] = ACTIONS(4530),
    [anon_sym_inline] = ACTIONS(4530),
    [anon_sym___inline] = ACTIONS(4530),
    [anon_sym___inline__] = ACTIONS(4530),
    [anon_sym___forceinline] = ACTIONS(4530),
    [anon_sym_thread_local] = ACTIONS(4530),
    [anon_sym___thread] = ACTIONS(4530),
    [anon_sym_const] = ACTIONS(4530),
    [anon_sym_constexpr] = ACTIONS(4530),
    [anon_sym_volatile] = ACTIONS(4530),
    [anon_sym_restrict] = ACTIONS(4530),
    [anon_sym___restrict__] = ACTIONS(4530),
    [anon_sym__Atomic] = ACTIONS(4530),
    [anon_sym__Noreturn] = ACTIONS(4530),
    [anon_sym_noreturn] = ACTIONS(4530),
    [anon_sym_mutable] = ACTIONS(4530),
    [anon_sym_constinit] = ACTIONS(4530),
    [anon_sym_consteval] = ACTIONS(4530),
    [anon_sym_PROGMEM] = ACTIONS(4530),
    [anon_sym_QMARK] = ACTIONS(4532),
    [anon_sym_STAR_EQ] = ACTIONS(4532),
    [anon_sym_SLASH_EQ] = ACTIONS(4532),
    [anon_sym_PERCENT_EQ] = ACTIONS(4532),
    [anon_sym_PLUS_EQ] = ACTIONS(4532),
    [anon_sym_DASH_EQ] = ACTIONS(4532),
    [anon_sym_LT_LT_EQ] = ACTIONS(4532),
    [anon_sym_GT_GT_EQ] = ACTIONS(4532),
    [anon_sym_AMP_EQ] = ACTIONS(4532),
    [anon_sym_CARET_EQ] = ACTIONS(4532),
    [anon_sym_PIPE_EQ] = ACTIONS(4532),
    [anon_sym_and_eq] = ACTIONS(4530),
    [anon_sym_or_eq] = ACTIONS(4530),
    [anon_sym_xor_eq] = ACTIONS(4530),
    [anon_sym_LT_EQ_GT] = ACTIONS(4532),
    [anon_sym_or] = ACTIONS(4530),
    [anon_sym_and] = ACTIONS(4530),
    [anon_sym_bitor] = ACTIONS(4530),
    [anon_sym_xor] = ACTIONS(4530),
    [anon_sym_bitand] = ACTIONS(4530),
    [anon_sym_not_eq] = ACTIONS(4530),
    [anon_sym_DASH_DASH] = ACTIONS(4532),
    [anon_sym_PLUS_PLUS] = ACTIONS(4532),
    [anon_sym_DOT] = ACTIONS(4530),
    [anon_sym_DOT_STAR] = ACTIONS(4532),
    [anon_sym_DASH_GT] = ACTIONS(4530),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4530),
    [anon_sym_decltype] = ACTIONS(4530),
    [anon_sym_virtual] = ACTIONS(4530),
    [anon_sym_alignas] = ACTIONS(4530),
    [anon_sym_template] = ACTIONS(4530),
    [anon_sym_operator] = ACTIONS(4530),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4532),
  },
  [1701] = {
    [sym_template_argument_list] = STATE(1712),
    [sym_identifier] = ACTIONS(4534),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4538),
    [anon_sym_COMMA] = ACTIONS(4538),
    [anon_sym_RPAREN] = ACTIONS(4538),
    [anon_sym_LPAREN2] = ACTIONS(4538),
    [anon_sym_TILDE] = ACTIONS(4541),
    [anon_sym_DASH] = ACTIONS(4543),
    [anon_sym_PLUS] = ACTIONS(4543),
    [anon_sym_STAR] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(4543),
    [anon_sym_PERCENT] = ACTIONS(4543),
    [anon_sym_PIPE_PIPE] = ACTIONS(4536),
    [anon_sym_AMP_AMP] = ACTIONS(4538),
    [anon_sym_PIPE] = ACTIONS(4543),
    [anon_sym_CARET] = ACTIONS(4543),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_EQ_EQ] = ACTIONS(4536),
    [anon_sym_BANG_EQ] = ACTIONS(4536),
    [anon_sym_GT] = ACTIONS(4543),
    [anon_sym_GT_EQ] = ACTIONS(4536),
    [anon_sym_LT_EQ] = ACTIONS(4543),
    [anon_sym_LT] = ACTIONS(4548),
    [anon_sym_LT_LT] = ACTIONS(4543),
    [anon_sym_GT_GT] = ACTIONS(4543),
    [anon_sym___extension__] = ACTIONS(4534),
    [anon_sym_extern] = ACTIONS(4534),
    [anon_sym___attribute__] = ACTIONS(4534),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4541),
    [anon_sym___declspec] = ACTIONS(4534),
    [anon_sym___based] = ACTIONS(4534),
    [anon_sym_LBRACE] = ACTIONS(4541),
    [anon_sym_LBRACK] = ACTIONS(4545),
    [anon_sym_EQ] = ACTIONS(4545),
    [anon_sym_static] = ACTIONS(4534),
    [anon_sym_register] = ACTIONS(4534),
    [anon_sym_inline] = ACTIONS(4534),
    [anon_sym___inline] = ACTIONS(4534),
    [anon_sym___inline__] = ACTIONS(4534),
    [anon_sym___forceinline] = ACTIONS(4534),
    [anon_sym_thread_local] = ACTIONS(4534),
    [anon_sym___thread] = ACTIONS(4534),
    [anon_sym_const] = ACTIONS(4534),
    [anon_sym_constexpr] = ACTIONS(4534),
    [anon_sym_volatile] = ACTIONS(4534),
    [anon_sym_restrict] = ACTIONS(4534),
    [anon_sym___restrict__] = ACTIONS(4534),
    [anon_sym__Atomic] = ACTIONS(4534),
    [anon_sym__Noreturn] = ACTIONS(4534),
    [anon_sym_noreturn] = ACTIONS(4534),
    [anon_sym_mutable] = ACTIONS(4534),
    [anon_sym_constinit] = ACTIONS(4534),
    [anon_sym_consteval] = ACTIONS(4534),
    [anon_sym_PROGMEM] = ACTIONS(4534),
    [anon_sym_QMARK] = ACTIONS(4536),
    [anon_sym_STAR_EQ] = ACTIONS(4536),
    [anon_sym_SLASH_EQ] = ACTIONS(4536),
    [anon_sym_PERCENT_EQ] = ACTIONS(4536),
    [anon_sym_PLUS_EQ] = ACTIONS(4536),
    [anon_sym_DASH_EQ] = ACTIONS(4536),
    [anon_sym_LT_LT_EQ] = ACTIONS(4536),
    [anon_sym_GT_GT_EQ] = ACTIONS(4536),
    [anon_sym_AMP_EQ] = ACTIONS(4536),
    [anon_sym_CARET_EQ] = ACTIONS(4536),
    [anon_sym_PIPE_EQ] = ACTIONS(4536),
    [anon_sym_and_eq] = ACTIONS(4543),
    [anon_sym_or_eq] = ACTIONS(4543),
    [anon_sym_xor_eq] = ACTIONS(4543),
    [anon_sym_LT_EQ_GT] = ACTIONS(4536),
    [anon_sym_or] = ACTIONS(4543),
    [anon_sym_and] = ACTIONS(4543),
    [anon_sym_bitor] = ACTIONS(4543),
    [anon_sym_xor] = ACTIONS(4543),
    [anon_sym_bitand] = ACTIONS(4543),
    [anon_sym_not_eq] = ACTIONS(4543),
    [anon_sym_DASH_DASH] = ACTIONS(4536),
    [anon_sym_PLUS_PLUS] = ACTIONS(4536),
    [anon_sym_DOT] = ACTIONS(4543),
    [anon_sym_DOT_STAR] = ACTIONS(4536),
    [anon_sym_DASH_GT] = ACTIONS(4536),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4534),
    [anon_sym_decltype] = ACTIONS(4534),
    [anon_sym_virtual] = ACTIONS(4534),
    [anon_sym_alignas] = ACTIONS(4534),
    [anon_sym_template] = ACTIONS(4534),
    [anon_sym_operator] = ACTIONS(4534),
  },
  [1702] = {
    [sym_identifier] = ACTIONS(4571),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4573),
    [anon_sym_COMMA] = ACTIONS(4573),
    [anon_sym_RPAREN] = ACTIONS(4573),
    [anon_sym_LPAREN2] = ACTIONS(4573),
    [anon_sym_TILDE] = ACTIONS(4573),
    [anon_sym_DASH] = ACTIONS(4571),
    [anon_sym_PLUS] = ACTIONS(4571),
    [anon_sym_STAR] = ACTIONS(4571),
    [anon_sym_SLASH] = ACTIONS(4571),
    [anon_sym_PERCENT] = ACTIONS(4571),
    [anon_sym_PIPE_PIPE] = ACTIONS(4573),
    [anon_sym_AMP_AMP] = ACTIONS(4573),
    [anon_sym_PIPE] = ACTIONS(4571),
    [anon_sym_CARET] = ACTIONS(4571),
    [anon_sym_AMP] = ACTIONS(4571),
    [anon_sym_EQ_EQ] = ACTIONS(4573),
    [anon_sym_BANG_EQ] = ACTIONS(4573),
    [anon_sym_GT] = ACTIONS(4571),
    [anon_sym_GT_EQ] = ACTIONS(4573),
    [anon_sym_LT_EQ] = ACTIONS(4571),
    [anon_sym_LT] = ACTIONS(4571),
    [anon_sym_LT_LT] = ACTIONS(4571),
    [anon_sym_GT_GT] = ACTIONS(4571),
    [anon_sym___extension__] = ACTIONS(4571),
    [anon_sym_extern] = ACTIONS(4571),
    [anon_sym___attribute__] = ACTIONS(4571),
    [anon_sym_COLON_COLON] = ACTIONS(4573),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4573),
    [anon_sym___declspec] = ACTIONS(4571),
    [anon_sym___based] = ACTIONS(4571),
    [anon_sym_LBRACE] = ACTIONS(4573),
    [anon_sym_LBRACK] = ACTIONS(4571),
    [anon_sym_EQ] = ACTIONS(4571),
    [anon_sym_static] = ACTIONS(4571),
    [anon_sym_register] = ACTIONS(4571),
    [anon_sym_inline] = ACTIONS(4571),
    [anon_sym___inline] = ACTIONS(4571),
    [anon_sym___inline__] = ACTIONS(4571),
    [anon_sym___forceinline] = ACTIONS(4571),
    [anon_sym_thread_local] = ACTIONS(4571),
    [anon_sym___thread] = ACTIONS(4571),
    [anon_sym_const] = ACTIONS(4571),
    [anon_sym_constexpr] = ACTIONS(4571),
    [anon_sym_volatile] = ACTIONS(4571),
    [anon_sym_restrict] = ACTIONS(4571),
    [anon_sym___restrict__] = ACTIONS(4571),
    [anon_sym__Atomic] = ACTIONS(4571),
    [anon_sym__Noreturn] = ACTIONS(4571),
    [anon_sym_noreturn] = ACTIONS(4571),
    [anon_sym_mutable] = ACTIONS(4571),
    [anon_sym_constinit] = ACTIONS(4571),
    [anon_sym_consteval] = ACTIONS(4571),
    [anon_sym_PROGMEM] = ACTIONS(4571),
    [anon_sym_QMARK] = ACTIONS(4573),
    [anon_sym_STAR_EQ] = ACTIONS(4573),
    [anon_sym_SLASH_EQ] = ACTIONS(4573),
    [anon_sym_PERCENT_EQ] = ACTIONS(4573),
    [anon_sym_PLUS_EQ] = ACTIONS(4573),
    [anon_sym_DASH_EQ] = ACTIONS(4573),
    [anon_sym_LT_LT_EQ] = ACTIONS(4573),
    [anon_sym_GT_GT_EQ] = ACTIONS(4573),
    [anon_sym_AMP_EQ] = ACTIONS(4573),
    [anon_sym_CARET_EQ] = ACTIONS(4573),
    [anon_sym_PIPE_EQ] = ACTIONS(4573),
    [anon_sym_and_eq] = ACTIONS(4571),
    [anon_sym_or_eq] = ACTIONS(4571),
    [anon_sym_xor_eq] = ACTIONS(4571),
    [anon_sym_LT_EQ_GT] = ACTIONS(4573),
    [anon_sym_or] = ACTIONS(4571),
    [anon_sym_and] = ACTIONS(4571),
    [anon_sym_bitor] = ACTIONS(4571),
    [anon_sym_xor] = ACTIONS(4571),
    [anon_sym_bitand] = ACTIONS(4571),
    [anon_sym_not_eq] = ACTIONS(4571),
    [anon_sym_DASH_DASH] = ACTIONS(4573),
    [anon_sym_PLUS_PLUS] = ACTIONS(4573),
    [anon_sym_DOT] = ACTIONS(4571),
    [anon_sym_DOT_STAR] = ACTIONS(4573),
    [anon_sym_DASH_GT] = ACTIONS(4571),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4571),
    [anon_sym_decltype] = ACTIONS(4571),
    [anon_sym_virtual] = ACTIONS(4571),
    [anon_sym_alignas] = ACTIONS(4571),
    [anon_sym_template] = ACTIONS(4571),
    [anon_sym_operator] = ACTIONS(4571),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4573),
  },
  [1703] = {
    [sym_identifier] = ACTIONS(4567),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4569),
    [anon_sym_COMMA] = ACTIONS(4569),
    [anon_sym_RPAREN] = ACTIONS(4569),
    [anon_sym_LPAREN2] = ACTIONS(4569),
    [anon_sym_TILDE] = ACTIONS(4569),
    [anon_sym_DASH] = ACTIONS(4567),
    [anon_sym_PLUS] = ACTIONS(4567),
    [anon_sym_STAR] = ACTIONS(4567),
    [anon_sym_SLASH] = ACTIONS(4567),
    [anon_sym_PERCENT] = ACTIONS(4567),
    [anon_sym_PIPE_PIPE] = ACTIONS(4569),
    [anon_sym_AMP_AMP] = ACTIONS(4569),
    [anon_sym_PIPE] = ACTIONS(4567),
    [anon_sym_CARET] = ACTIONS(4567),
    [anon_sym_AMP] = ACTIONS(4567),
    [anon_sym_EQ_EQ] = ACTIONS(4569),
    [anon_sym_BANG_EQ] = ACTIONS(4569),
    [anon_sym_GT] = ACTIONS(4567),
    [anon_sym_GT_EQ] = ACTIONS(4569),
    [anon_sym_LT_EQ] = ACTIONS(4567),
    [anon_sym_LT] = ACTIONS(4567),
    [anon_sym_LT_LT] = ACTIONS(4567),
    [anon_sym_GT_GT] = ACTIONS(4567),
    [anon_sym___extension__] = ACTIONS(4567),
    [anon_sym_extern] = ACTIONS(4567),
    [anon_sym___attribute__] = ACTIONS(4567),
    [anon_sym_COLON_COLON] = ACTIONS(4569),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4569),
    [anon_sym___declspec] = ACTIONS(4567),
    [anon_sym___based] = ACTIONS(4567),
    [anon_sym_LBRACE] = ACTIONS(4569),
    [anon_sym_LBRACK] = ACTIONS(4567),
    [anon_sym_EQ] = ACTIONS(4567),
    [anon_sym_static] = ACTIONS(4567),
    [anon_sym_register] = ACTIONS(4567),
    [anon_sym_inline] = ACTIONS(4567),
    [anon_sym___inline] = ACTIONS(4567),
    [anon_sym___inline__] = ACTIONS(4567),
    [anon_sym___forceinline] = ACTIONS(4567),
    [anon_sym_thread_local] = ACTIONS(4567),
    [anon_sym___thread] = ACTIONS(4567),
    [anon_sym_const] = ACTIONS(4567),
    [anon_sym_constexpr] = ACTIONS(4567),
    [anon_sym_volatile] = ACTIONS(4567),
    [anon_sym_restrict] = ACTIONS(4567),
    [anon_sym___restrict__] = ACTIONS(4567),
    [anon_sym__Atomic] = ACTIONS(4567),
    [anon_sym__Noreturn] = ACTIONS(4567),
    [anon_sym_noreturn] = ACTIONS(4567),
    [anon_sym_mutable] = ACTIONS(4567),
    [anon_sym_constinit] = ACTIONS(4567),
    [anon_sym_consteval] = ACTIONS(4567),
    [anon_sym_PROGMEM] = ACTIONS(4567),
    [anon_sym_QMARK] = ACTIONS(4569),
    [anon_sym_STAR_EQ] = ACTIONS(4569),
    [anon_sym_SLASH_EQ] = ACTIONS(4569),
    [anon_sym_PERCENT_EQ] = ACTIONS(4569),
    [anon_sym_PLUS_EQ] = ACTIONS(4569),
    [anon_sym_DASH_EQ] = ACTIONS(4569),
    [anon_sym_LT_LT_EQ] = ACTIONS(4569),
    [anon_sym_GT_GT_EQ] = ACTIONS(4569),
    [anon_sym_AMP_EQ] = ACTIONS(4569),
    [anon_sym_CARET_EQ] = ACTIONS(4569),
    [anon_sym_PIPE_EQ] = ACTIONS(4569),
    [anon_sym_and_eq] = ACTIONS(4567),
    [anon_sym_or_eq] = ACTIONS(4567),
    [anon_sym_xor_eq] = ACTIONS(4567),
    [anon_sym_LT_EQ_GT] = ACTIONS(4569),
    [anon_sym_or] = ACTIONS(4567),
    [anon_sym_and] = ACTIONS(4567),
    [anon_sym_bitor] = ACTIONS(4567),
    [anon_sym_xor] = ACTIONS(4567),
    [anon_sym_bitand] = ACTIONS(4567),
    [anon_sym_not_eq] = ACTIONS(4567),
    [anon_sym_DASH_DASH] = ACTIONS(4569),
    [anon_sym_PLUS_PLUS] = ACTIONS(4569),
    [anon_sym_DOT] = ACTIONS(4567),
    [anon_sym_DOT_STAR] = ACTIONS(4569),
    [anon_sym_DASH_GT] = ACTIONS(4567),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4567),
    [anon_sym_decltype] = ACTIONS(4567),
    [anon_sym_virtual] = ACTIONS(4567),
    [anon_sym_alignas] = ACTIONS(4567),
    [anon_sym_template] = ACTIONS(4567),
    [anon_sym_operator] = ACTIONS(4567),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4569),
  },
  [1704] = {
    [sym_identifier] = ACTIONS(4559),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4561),
    [anon_sym_COMMA] = ACTIONS(4561),
    [anon_sym_RPAREN] = ACTIONS(4561),
    [anon_sym_LPAREN2] = ACTIONS(4561),
    [anon_sym_TILDE] = ACTIONS(4561),
    [anon_sym_DASH] = ACTIONS(4559),
    [anon_sym_PLUS] = ACTIONS(4559),
    [anon_sym_STAR] = ACTIONS(4559),
    [anon_sym_SLASH] = ACTIONS(4559),
    [anon_sym_PERCENT] = ACTIONS(4559),
    [anon_sym_PIPE_PIPE] = ACTIONS(4561),
    [anon_sym_AMP_AMP] = ACTIONS(4561),
    [anon_sym_PIPE] = ACTIONS(4559),
    [anon_sym_CARET] = ACTIONS(4559),
    [anon_sym_AMP] = ACTIONS(4559),
    [anon_sym_EQ_EQ] = ACTIONS(4561),
    [anon_sym_BANG_EQ] = ACTIONS(4561),
    [anon_sym_GT] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4561),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_LT] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4559),
    [anon_sym_GT_GT] = ACTIONS(4559),
    [anon_sym___extension__] = ACTIONS(4559),
    [anon_sym_extern] = ACTIONS(4559),
    [anon_sym___attribute__] = ACTIONS(4559),
    [anon_sym_COLON_COLON] = ACTIONS(4561),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4561),
    [anon_sym___declspec] = ACTIONS(4559),
    [anon_sym___based] = ACTIONS(4559),
    [anon_sym_LBRACE] = ACTIONS(4561),
    [anon_sym_LBRACK] = ACTIONS(4559),
    [anon_sym_EQ] = ACTIONS(4559),
    [anon_sym_static] = ACTIONS(4559),
    [anon_sym_register] = ACTIONS(4559),
    [anon_sym_inline] = ACTIONS(4559),
    [anon_sym___inline] = ACTIONS(4559),
    [anon_sym___inline__] = ACTIONS(4559),
    [anon_sym___forceinline] = ACTIONS(4559),
    [anon_sym_thread_local] = ACTIONS(4559),
    [anon_sym___thread] = ACTIONS(4559),
    [anon_sym_const] = ACTIONS(4559),
    [anon_sym_constexpr] = ACTIONS(4559),
    [anon_sym_volatile] = ACTIONS(4559),
    [anon_sym_restrict] = ACTIONS(4559),
    [anon_sym___restrict__] = ACTIONS(4559),
    [anon_sym__Atomic] = ACTIONS(4559),
    [anon_sym__Noreturn] = ACTIONS(4559),
    [anon_sym_noreturn] = ACTIONS(4559),
    [anon_sym_mutable] = ACTIONS(4559),
    [anon_sym_constinit] = ACTIONS(4559),
    [anon_sym_consteval] = ACTIONS(4559),
    [anon_sym_PROGMEM] = ACTIONS(4559),
    [anon_sym_QMARK] = ACTIONS(4561),
    [anon_sym_STAR_EQ] = ACTIONS(4561),
    [anon_sym_SLASH_EQ] = ACTIONS(4561),
    [anon_sym_PERCENT_EQ] = ACTIONS(4561),
    [anon_sym_PLUS_EQ] = ACTIONS(4561),
    [anon_sym_DASH_EQ] = ACTIONS(4561),
    [anon_sym_LT_LT_EQ] = ACTIONS(4561),
    [anon_sym_GT_GT_EQ] = ACTIONS(4561),
    [anon_sym_AMP_EQ] = ACTIONS(4561),
    [anon_sym_CARET_EQ] = ACTIONS(4561),
    [anon_sym_PIPE_EQ] = ACTIONS(4561),
    [anon_sym_and_eq] = ACTIONS(4559),
    [anon_sym_or_eq] = ACTIONS(4559),
    [anon_sym_xor_eq] = ACTIONS(4559),
    [anon_sym_LT_EQ_GT] = ACTIONS(4561),
    [anon_sym_or] = ACTIONS(4559),
    [anon_sym_and] = ACTIONS(4559),
    [anon_sym_bitor] = ACTIONS(4559),
    [anon_sym_xor] = ACTIONS(4559),
    [anon_sym_bitand] = ACTIONS(4559),
    [anon_sym_not_eq] = ACTIONS(4559),
    [anon_sym_DASH_DASH] = ACTIONS(4561),
    [anon_sym_PLUS_PLUS] = ACTIONS(4561),
    [anon_sym_DOT] = ACTIONS(4559),
    [anon_sym_DOT_STAR] = ACTIONS(4561),
    [anon_sym_DASH_GT] = ACTIONS(4559),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4559),
    [anon_sym_decltype] = ACTIONS(4559),
    [anon_sym_virtual] = ACTIONS(4559),
    [anon_sym_alignas] = ACTIONS(4559),
    [anon_sym_template] = ACTIONS(4559),
    [anon_sym_operator] = ACTIONS(4559),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4561),
  },
  [1705] = {
    [sym_identifier] = ACTIONS(4563),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4565),
    [anon_sym_COMMA] = ACTIONS(4565),
    [anon_sym_RPAREN] = ACTIONS(4565),
    [anon_sym_LPAREN2] = ACTIONS(4565),
    [anon_sym_TILDE] = ACTIONS(4565),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_STAR] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4563),
    [anon_sym_PERCENT] = ACTIONS(4563),
    [anon_sym_PIPE_PIPE] = ACTIONS(4565),
    [anon_sym_AMP_AMP] = ACTIONS(4565),
    [anon_sym_PIPE] = ACTIONS(4563),
    [anon_sym_CARET] = ACTIONS(4563),
    [anon_sym_AMP] = ACTIONS(4563),
    [anon_sym_EQ_EQ] = ACTIONS(4565),
    [anon_sym_BANG_EQ] = ACTIONS(4565),
    [anon_sym_GT] = ACTIONS(4563),
    [anon_sym_GT_EQ] = ACTIONS(4565),
    [anon_sym_LT_EQ] = ACTIONS(4563),
    [anon_sym_LT] = ACTIONS(4563),
    [anon_sym_LT_LT] = ACTIONS(4563),
    [anon_sym_GT_GT] = ACTIONS(4563),
    [anon_sym___extension__] = ACTIONS(4563),
    [anon_sym_extern] = ACTIONS(4563),
    [anon_sym___attribute__] = ACTIONS(4563),
    [anon_sym_COLON_COLON] = ACTIONS(4565),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4565),
    [anon_sym___declspec] = ACTIONS(4563),
    [anon_sym___based] = ACTIONS(4563),
    [anon_sym_LBRACE] = ACTIONS(4565),
    [anon_sym_LBRACK] = ACTIONS(4563),
    [anon_sym_EQ] = ACTIONS(4563),
    [anon_sym_static] = ACTIONS(4563),
    [anon_sym_register] = ACTIONS(4563),
    [anon_sym_inline] = ACTIONS(4563),
    [anon_sym___inline] = ACTIONS(4563),
    [anon_sym___inline__] = ACTIONS(4563),
    [anon_sym___forceinline] = ACTIONS(4563),
    [anon_sym_thread_local] = ACTIONS(4563),
    [anon_sym___thread] = ACTIONS(4563),
    [anon_sym_const] = ACTIONS(4563),
    [anon_sym_constexpr] = ACTIONS(4563),
    [anon_sym_volatile] = ACTIONS(4563),
    [anon_sym_restrict] = ACTIONS(4563),
    [anon_sym___restrict__] = ACTIONS(4563),
    [anon_sym__Atomic] = ACTIONS(4563),
    [anon_sym__Noreturn] = ACTIONS(4563),
    [anon_sym_noreturn] = ACTIONS(4563),
    [anon_sym_mutable] = ACTIONS(4563),
    [anon_sym_constinit] = ACTIONS(4563),
    [anon_sym_consteval] = ACTIONS(4563),
    [anon_sym_PROGMEM] = ACTIONS(4563),
    [anon_sym_QMARK] = ACTIONS(4565),
    [anon_sym_STAR_EQ] = ACTIONS(4565),
    [anon_sym_SLASH_EQ] = ACTIONS(4565),
    [anon_sym_PERCENT_EQ] = ACTIONS(4565),
    [anon_sym_PLUS_EQ] = ACTIONS(4565),
    [anon_sym_DASH_EQ] = ACTIONS(4565),
    [anon_sym_LT_LT_EQ] = ACTIONS(4565),
    [anon_sym_GT_GT_EQ] = ACTIONS(4565),
    [anon_sym_AMP_EQ] = ACTIONS(4565),
    [anon_sym_CARET_EQ] = ACTIONS(4565),
    [anon_sym_PIPE_EQ] = ACTIONS(4565),
    [anon_sym_and_eq] = ACTIONS(4563),
    [anon_sym_or_eq] = ACTIONS(4563),
    [anon_sym_xor_eq] = ACTIONS(4563),
    [anon_sym_LT_EQ_GT] = ACTIONS(4565),
    [anon_sym_or] = ACTIONS(4563),
    [anon_sym_and] = ACTIONS(4563),
    [anon_sym_bitor] = ACTIONS(4563),
    [anon_sym_xor] = ACTIONS(4563),
    [anon_sym_bitand] = ACTIONS(4563),
    [anon_sym_not_eq] = ACTIONS(4563),
    [anon_sym_DASH_DASH] = ACTIONS(4565),
    [anon_sym_PLUS_PLUS] = ACTIONS(4565),
    [anon_sym_DOT] = ACTIONS(4563),
    [anon_sym_DOT_STAR] = ACTIONS(4565),
    [anon_sym_DASH_GT] = ACTIONS(4563),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4563),
    [anon_sym_decltype] = ACTIONS(4563),
    [anon_sym_virtual] = ACTIONS(4563),
    [anon_sym_alignas] = ACTIONS(4563),
    [anon_sym_template] = ACTIONS(4563),
    [anon_sym_operator] = ACTIONS(4563),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4565),
  },
  [1706] = {
    [sym_identifier] = ACTIONS(4555),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4557),
    [anon_sym_COMMA] = ACTIONS(4557),
    [anon_sym_RPAREN] = ACTIONS(4557),
    [anon_sym_LPAREN2] = ACTIONS(4557),
    [anon_sym_TILDE] = ACTIONS(4557),
    [anon_sym_DASH] = ACTIONS(4555),
    [anon_sym_PLUS] = ACTIONS(4555),
    [anon_sym_STAR] = ACTIONS(4555),
    [anon_sym_SLASH] = ACTIONS(4555),
    [anon_sym_PERCENT] = ACTIONS(4555),
    [anon_sym_PIPE_PIPE] = ACTIONS(4557),
    [anon_sym_AMP_AMP] = ACTIONS(4557),
    [anon_sym_PIPE] = ACTIONS(4555),
    [anon_sym_CARET] = ACTIONS(4555),
    [anon_sym_AMP] = ACTIONS(4555),
    [anon_sym_EQ_EQ] = ACTIONS(4557),
    [anon_sym_BANG_EQ] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4555),
    [anon_sym_GT_EQ] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4555),
    [anon_sym_LT_LT] = ACTIONS(4555),
    [anon_sym_GT_GT] = ACTIONS(4555),
    [anon_sym___extension__] = ACTIONS(4555),
    [anon_sym_extern] = ACTIONS(4555),
    [anon_sym___attribute__] = ACTIONS(4555),
    [anon_sym_COLON_COLON] = ACTIONS(4557),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4557),
    [anon_sym___declspec] = ACTIONS(4555),
    [anon_sym___based] = ACTIONS(4555),
    [anon_sym_LBRACE] = ACTIONS(4557),
    [anon_sym_LBRACK] = ACTIONS(4555),
    [anon_sym_EQ] = ACTIONS(4555),
    [anon_sym_static] = ACTIONS(4555),
    [anon_sym_register] = ACTIONS(4555),
    [anon_sym_inline] = ACTIONS(4555),
    [anon_sym___inline] = ACTIONS(4555),
    [anon_sym___inline__] = ACTIONS(4555),
    [anon_sym___forceinline] = ACTIONS(4555),
    [anon_sym_thread_local] = ACTIONS(4555),
    [anon_sym___thread] = ACTIONS(4555),
    [anon_sym_const] = ACTIONS(4555),
    [anon_sym_constexpr] = ACTIONS(4555),
    [anon_sym_volatile] = ACTIONS(4555),
    [anon_sym_restrict] = ACTIONS(4555),
    [anon_sym___restrict__] = ACTIONS(4555),
    [anon_sym__Atomic] = ACTIONS(4555),
    [anon_sym__Noreturn] = ACTIONS(4555),
    [anon_sym_noreturn] = ACTIONS(4555),
    [anon_sym_mutable] = ACTIONS(4555),
    [anon_sym_constinit] = ACTIONS(4555),
    [anon_sym_consteval] = ACTIONS(4555),
    [anon_sym_PROGMEM] = ACTIONS(4555),
    [anon_sym_QMARK] = ACTIONS(4557),
    [anon_sym_STAR_EQ] = ACTIONS(4557),
    [anon_sym_SLASH_EQ] = ACTIONS(4557),
    [anon_sym_PERCENT_EQ] = ACTIONS(4557),
    [anon_sym_PLUS_EQ] = ACTIONS(4557),
    [anon_sym_DASH_EQ] = ACTIONS(4557),
    [anon_sym_LT_LT_EQ] = ACTIONS(4557),
    [anon_sym_GT_GT_EQ] = ACTIONS(4557),
    [anon_sym_AMP_EQ] = ACTIONS(4557),
    [anon_sym_CARET_EQ] = ACTIONS(4557),
    [anon_sym_PIPE_EQ] = ACTIONS(4557),
    [anon_sym_and_eq] = ACTIONS(4555),
    [anon_sym_or_eq] = ACTIONS(4555),
    [anon_sym_xor_eq] = ACTIONS(4555),
    [anon_sym_LT_EQ_GT] = ACTIONS(4557),
    [anon_sym_or] = ACTIONS(4555),
    [anon_sym_and] = ACTIONS(4555),
    [anon_sym_bitor] = ACTIONS(4555),
    [anon_sym_xor] = ACTIONS(4555),
    [anon_sym_bitand] = ACTIONS(4555),
    [anon_sym_not_eq] = ACTIONS(4555),
    [anon_sym_DASH_DASH] = ACTIONS(4557),
    [anon_sym_PLUS_PLUS] = ACTIONS(4557),
    [anon_sym_DOT] = ACTIONS(4555),
    [anon_sym_DOT_STAR] = ACTIONS(4557),
    [anon_sym_DASH_GT] = ACTIONS(4555),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4555),
    [anon_sym_decltype] = ACTIONS(4555),
    [anon_sym_virtual] = ACTIONS(4555),
    [anon_sym_alignas] = ACTIONS(4555),
    [anon_sym_template] = ACTIONS(4555),
    [anon_sym_operator] = ACTIONS(4555),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4557),
  },
  [1707] = {
    [sym_identifier] = ACTIONS(4551),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4553),
    [anon_sym_COMMA] = ACTIONS(4553),
    [anon_sym_RPAREN] = ACTIONS(4553),
    [anon_sym_LPAREN2] = ACTIONS(4553),
    [anon_sym_TILDE] = ACTIONS(4553),
    [anon_sym_DASH] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(4551),
    [anon_sym_STAR] = ACTIONS(4551),
    [anon_sym_SLASH] = ACTIONS(4551),
    [anon_sym_PERCENT] = ACTIONS(4551),
    [anon_sym_PIPE_PIPE] = ACTIONS(4553),
    [anon_sym_AMP_AMP] = ACTIONS(4553),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4551),
    [anon_sym_AMP] = ACTIONS(4551),
    [anon_sym_EQ_EQ] = ACTIONS(4553),
    [anon_sym_BANG_EQ] = ACTIONS(4553),
    [anon_sym_GT] = ACTIONS(4551),
    [anon_sym_GT_EQ] = ACTIONS(4553),
    [anon_sym_LT_EQ] = ACTIONS(4551),
    [anon_sym_LT] = ACTIONS(4551),
    [anon_sym_LT_LT] = ACTIONS(4551),
    [anon_sym_GT_GT] = ACTIONS(4551),
    [anon_sym___extension__] = ACTIONS(4551),
    [anon_sym_extern] = ACTIONS(4551),
    [anon_sym___attribute__] = ACTIONS(4551),
    [anon_sym_COLON_COLON] = ACTIONS(4553),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4553),
    [anon_sym___declspec] = ACTIONS(4551),
    [anon_sym___based] = ACTIONS(4551),
    [anon_sym_LBRACE] = ACTIONS(4553),
    [anon_sym_LBRACK] = ACTIONS(4551),
    [anon_sym_EQ] = ACTIONS(4551),
    [anon_sym_static] = ACTIONS(4551),
    [anon_sym_register] = ACTIONS(4551),
    [anon_sym_inline] = ACTIONS(4551),
    [anon_sym___inline] = ACTIONS(4551),
    [anon_sym___inline__] = ACTIONS(4551),
    [anon_sym___forceinline] = ACTIONS(4551),
    [anon_sym_thread_local] = ACTIONS(4551),
    [anon_sym___thread] = ACTIONS(4551),
    [anon_sym_const] = ACTIONS(4551),
    [anon_sym_constexpr] = ACTIONS(4551),
    [anon_sym_volatile] = ACTIONS(4551),
    [anon_sym_restrict] = ACTIONS(4551),
    [anon_sym___restrict__] = ACTIONS(4551),
    [anon_sym__Atomic] = ACTIONS(4551),
    [anon_sym__Noreturn] = ACTIONS(4551),
    [anon_sym_noreturn] = ACTIONS(4551),
    [anon_sym_mutable] = ACTIONS(4551),
    [anon_sym_constinit] = ACTIONS(4551),
    [anon_sym_consteval] = ACTIONS(4551),
    [anon_sym_PROGMEM] = ACTIONS(4551),
    [anon_sym_QMARK] = ACTIONS(4553),
    [anon_sym_STAR_EQ] = ACTIONS(4553),
    [anon_sym_SLASH_EQ] = ACTIONS(4553),
    [anon_sym_PERCENT_EQ] = ACTIONS(4553),
    [anon_sym_PLUS_EQ] = ACTIONS(4553),
    [anon_sym_DASH_EQ] = ACTIONS(4553),
    [anon_sym_LT_LT_EQ] = ACTIONS(4553),
    [anon_sym_GT_GT_EQ] = ACTIONS(4553),
    [anon_sym_AMP_EQ] = ACTIONS(4553),
    [anon_sym_CARET_EQ] = ACTIONS(4553),
    [anon_sym_PIPE_EQ] = ACTIONS(4553),
    [anon_sym_and_eq] = ACTIONS(4551),
    [anon_sym_or_eq] = ACTIONS(4551),
    [anon_sym_xor_eq] = ACTIONS(4551),
    [anon_sym_LT_EQ_GT] = ACTIONS(4553),
    [anon_sym_or] = ACTIONS(4551),
    [anon_sym_and] = ACTIONS(4551),
    [anon_sym_bitor] = ACTIONS(4551),
    [anon_sym_xor] = ACTIONS(4551),
    [anon_sym_bitand] = ACTIONS(4551),
    [anon_sym_not_eq] = ACTIONS(4551),
    [anon_sym_DASH_DASH] = ACTIONS(4553),
    [anon_sym_PLUS_PLUS] = ACTIONS(4553),
    [anon_sym_DOT] = ACTIONS(4551),
    [anon_sym_DOT_STAR] = ACTIONS(4553),
    [anon_sym_DASH_GT] = ACTIONS(4551),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4551),
    [anon_sym_decltype] = ACTIONS(4551),
    [anon_sym_virtual] = ACTIONS(4551),
    [anon_sym_alignas] = ACTIONS(4551),
    [anon_sym_template] = ACTIONS(4551),
    [anon_sym_operator] = ACTIONS(4551),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4553),
  },
  [1708] = {
    [sym_string_literal] = STATE(2079),
    [sym_template_argument_list] = STATE(1828),
    [sym_raw_string_literal] = STATE(2079),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3761),
    [anon_sym_COMMA] = ACTIONS(3761),
    [anon_sym_RPAREN] = ACTIONS(3763),
    [anon_sym_LPAREN2] = ACTIONS(3763),
    [anon_sym_DASH] = ACTIONS(3769),
    [anon_sym_PLUS] = ACTIONS(3769),
    [anon_sym_STAR] = ACTIONS(3771),
    [anon_sym_SLASH] = ACTIONS(3769),
    [anon_sym_PERCENT] = ACTIONS(3769),
    [anon_sym_PIPE_PIPE] = ACTIONS(3761),
    [anon_sym_AMP_AMP] = ACTIONS(3774),
    [anon_sym_PIPE] = ACTIONS(3769),
    [anon_sym_CARET] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(3771),
    [anon_sym_EQ_EQ] = ACTIONS(3761),
    [anon_sym_BANG_EQ] = ACTIONS(3761),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3761),
    [anon_sym_LT_EQ] = ACTIONS(3769),
    [anon_sym_LT] = ACTIONS(4598),
    [anon_sym_LT_LT] = ACTIONS(3769),
    [anon_sym_GT_GT] = ACTIONS(3769),
    [anon_sym___extension__] = ACTIONS(3767),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4601),
    [anon_sym_LBRACE] = ACTIONS(3785),
    [anon_sym_signed] = ACTIONS(4603),
    [anon_sym_unsigned] = ACTIONS(4603),
    [anon_sym_long] = ACTIONS(4603),
    [anon_sym_short] = ACTIONS(4603),
    [anon_sym_LBRACK] = ACTIONS(3789),
    [anon_sym_EQ] = ACTIONS(3769),
    [anon_sym_const] = ACTIONS(3759),
    [anon_sym_constexpr] = ACTIONS(3767),
    [anon_sym_volatile] = ACTIONS(3767),
    [anon_sym_restrict] = ACTIONS(3767),
    [anon_sym___restrict__] = ACTIONS(3767),
    [anon_sym__Atomic] = ACTIONS(3767),
    [anon_sym__Noreturn] = ACTIONS(3767),
    [anon_sym_noreturn] = ACTIONS(3767),
    [anon_sym_mutable] = ACTIONS(3767),
    [anon_sym_constinit] = ACTIONS(3767),
    [anon_sym_consteval] = ACTIONS(3767),
    [anon_sym_PROGMEM] = ACTIONS(3767),
    [anon_sym_QMARK] = ACTIONS(3761),
    [anon_sym_STAR_EQ] = ACTIONS(3761),
    [anon_sym_SLASH_EQ] = ACTIONS(3761),
    [anon_sym_PERCENT_EQ] = ACTIONS(3761),
    [anon_sym_PLUS_EQ] = ACTIONS(3761),
    [anon_sym_DASH_EQ] = ACTIONS(3761),
    [anon_sym_LT_LT_EQ] = ACTIONS(3761),
    [anon_sym_GT_GT_EQ] = ACTIONS(3761),
    [anon_sym_AMP_EQ] = ACTIONS(3761),
    [anon_sym_CARET_EQ] = ACTIONS(3761),
    [anon_sym_PIPE_EQ] = ACTIONS(3761),
    [anon_sym_and_eq] = ACTIONS(3761),
    [anon_sym_or_eq] = ACTIONS(3761),
    [anon_sym_xor_eq] = ACTIONS(3761),
    [anon_sym_LT_EQ_GT] = ACTIONS(3761),
    [anon_sym_or] = ACTIONS(3769),
    [anon_sym_and] = ACTIONS(3769),
    [anon_sym_bitor] = ACTIONS(3761),
    [anon_sym_xor] = ACTIONS(3769),
    [anon_sym_bitand] = ACTIONS(3761),
    [anon_sym_not_eq] = ACTIONS(3761),
    [anon_sym_DASH_DASH] = ACTIONS(3761),
    [anon_sym_PLUS_PLUS] = ACTIONS(3761),
    [anon_sym_DOT] = ACTIONS(3769),
    [anon_sym_DOT_STAR] = ACTIONS(3761),
    [anon_sym_DASH_GT] = ACTIONS(3769),
    [anon_sym_L_DQUOTE] = ACTIONS(4605),
    [anon_sym_u_DQUOTE] = ACTIONS(4605),
    [anon_sym_U_DQUOTE] = ACTIONS(4605),
    [anon_sym_u8_DQUOTE] = ACTIONS(4605),
    [anon_sym_DQUOTE] = ACTIONS(4605),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3767),
    [anon_sym_decltype] = ACTIONS(3767),
    [anon_sym_R_DQUOTE] = ACTIONS(4607),
    [anon_sym_LR_DQUOTE] = ACTIONS(4607),
    [anon_sym_uR_DQUOTE] = ACTIONS(4607),
    [anon_sym_UR_DQUOTE] = ACTIONS(4607),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4607),
    [anon_sym_DASH_GT_STAR] = ACTIONS(3761),
  },
  [1709] = {
    [sym_identifier] = ACTIONS(4575),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4577),
    [anon_sym_COMMA] = ACTIONS(4577),
    [anon_sym_RPAREN] = ACTIONS(4577),
    [anon_sym_LPAREN2] = ACTIONS(4579),
    [anon_sym_TILDE] = ACTIONS(4582),
    [anon_sym_DASH] = ACTIONS(4584),
    [anon_sym_PLUS] = ACTIONS(4584),
    [anon_sym_STAR] = ACTIONS(4586),
    [anon_sym_SLASH] = ACTIONS(4584),
    [anon_sym_PERCENT] = ACTIONS(4584),
    [anon_sym_PIPE_PIPE] = ACTIONS(4577),
    [anon_sym_AMP_AMP] = ACTIONS(4579),
    [anon_sym_PIPE] = ACTIONS(4584),
    [anon_sym_CARET] = ACTIONS(4584),
    [anon_sym_AMP] = ACTIONS(4586),
    [anon_sym_EQ_EQ] = ACTIONS(4577),
    [anon_sym_BANG_EQ] = ACTIONS(4577),
    [anon_sym_GT] = ACTIONS(4584),
    [anon_sym_GT_EQ] = ACTIONS(4577),
    [anon_sym_LT_EQ] = ACTIONS(4584),
    [anon_sym_LT] = ACTIONS(4584),
    [anon_sym_LT_LT] = ACTIONS(4584),
    [anon_sym_GT_GT] = ACTIONS(4584),
    [anon_sym_SEMI] = ACTIONS(4577),
    [anon_sym___extension__] = ACTIONS(4575),
    [anon_sym_extern] = ACTIONS(4575),
    [anon_sym___attribute__] = ACTIONS(4575),
    [anon_sym_COLON_COLON] = ACTIONS(4582),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4582),
    [anon_sym___declspec] = ACTIONS(4575),
    [anon_sym___based] = ACTIONS(4575),
    [anon_sym_LBRACE] = ACTIONS(4582),
    [anon_sym_LBRACK] = ACTIONS(4586),
    [anon_sym_EQ] = ACTIONS(4584),
    [anon_sym_static] = ACTIONS(4575),
    [anon_sym_register] = ACTIONS(4575),
    [anon_sym_inline] = ACTIONS(4575),
    [anon_sym___inline] = ACTIONS(4575),
    [anon_sym___inline__] = ACTIONS(4575),
    [anon_sym___forceinline] = ACTIONS(4575),
    [anon_sym_thread_local] = ACTIONS(4575),
    [anon_sym___thread] = ACTIONS(4575),
    [anon_sym_const] = ACTIONS(4575),
    [anon_sym_constexpr] = ACTIONS(4575),
    [anon_sym_volatile] = ACTIONS(4575),
    [anon_sym_restrict] = ACTIONS(4575),
    [anon_sym___restrict__] = ACTIONS(4575),
    [anon_sym__Atomic] = ACTIONS(4575),
    [anon_sym__Noreturn] = ACTIONS(4575),
    [anon_sym_noreturn] = ACTIONS(4575),
    [anon_sym_mutable] = ACTIONS(4575),
    [anon_sym_constinit] = ACTIONS(4575),
    [anon_sym_consteval] = ACTIONS(4575),
    [anon_sym_PROGMEM] = ACTIONS(4575),
    [anon_sym_QMARK] = ACTIONS(4577),
    [anon_sym_STAR_EQ] = ACTIONS(4577),
    [anon_sym_SLASH_EQ] = ACTIONS(4577),
    [anon_sym_PERCENT_EQ] = ACTIONS(4577),
    [anon_sym_PLUS_EQ] = ACTIONS(4577),
    [anon_sym_DASH_EQ] = ACTIONS(4577),
    [anon_sym_LT_LT_EQ] = ACTIONS(4577),
    [anon_sym_GT_GT_EQ] = ACTIONS(4577),
    [anon_sym_AMP_EQ] = ACTIONS(4577),
    [anon_sym_CARET_EQ] = ACTIONS(4577),
    [anon_sym_PIPE_EQ] = ACTIONS(4577),
    [anon_sym_and_eq] = ACTIONS(4584),
    [anon_sym_or_eq] = ACTIONS(4584),
    [anon_sym_xor_eq] = ACTIONS(4584),
    [anon_sym_LT_EQ_GT] = ACTIONS(4577),
    [anon_sym_or] = ACTIONS(4584),
    [anon_sym_and] = ACTIONS(4584),
    [anon_sym_bitor] = ACTIONS(4584),
    [anon_sym_xor] = ACTIONS(4584),
    [anon_sym_bitand] = ACTIONS(4584),
    [anon_sym_not_eq] = ACTIONS(4584),
    [anon_sym_DASH_DASH] = ACTIONS(4577),
    [anon_sym_PLUS_PLUS] = ACTIONS(4577),
    [anon_sym_DOT] = ACTIONS(4584),
    [anon_sym_DOT_STAR] = ACTIONS(4577),
    [anon_sym_DASH_GT] = ACTIONS(4577),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4575),
    [anon_sym_decltype] = ACTIONS(4575),
    [anon_sym_virtual] = ACTIONS(4575),
    [anon_sym_alignas] = ACTIONS(4575),
    [anon_sym_template] = ACTIONS(4575),
    [anon_sym_operator] = ACTIONS(4575),
  },
  [1710] = {
    [sym_identifier] = ACTIONS(4575),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4579),
    [anon_sym_COMMA] = ACTIONS(4579),
    [anon_sym_RPAREN] = ACTIONS(4579),
    [anon_sym_LPAREN2] = ACTIONS(4579),
    [anon_sym_TILDE] = ACTIONS(4582),
    [anon_sym_DASH] = ACTIONS(4584),
    [anon_sym_PLUS] = ACTIONS(4584),
    [anon_sym_STAR] = ACTIONS(4586),
    [anon_sym_SLASH] = ACTIONS(4584),
    [anon_sym_PERCENT] = ACTIONS(4584),
    [anon_sym_PIPE_PIPE] = ACTIONS(4577),
    [anon_sym_AMP_AMP] = ACTIONS(4579),
    [anon_sym_PIPE] = ACTIONS(4584),
    [anon_sym_CARET] = ACTIONS(4584),
    [anon_sym_AMP] = ACTIONS(4586),
    [anon_sym_EQ_EQ] = ACTIONS(4577),
    [anon_sym_BANG_EQ] = ACTIONS(4577),
    [anon_sym_GT] = ACTIONS(4584),
    [anon_sym_GT_EQ] = ACTIONS(4577),
    [anon_sym_LT_EQ] = ACTIONS(4584),
    [anon_sym_LT] = ACTIONS(4584),
    [anon_sym_LT_LT] = ACTIONS(4584),
    [anon_sym_GT_GT] = ACTIONS(4584),
    [anon_sym___extension__] = ACTIONS(4575),
    [anon_sym_extern] = ACTIONS(4575),
    [anon_sym___attribute__] = ACTIONS(4575),
    [anon_sym_COLON_COLON] = ACTIONS(4582),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4582),
    [anon_sym___declspec] = ACTIONS(4575),
    [anon_sym___based] = ACTIONS(4575),
    [anon_sym_LBRACE] = ACTIONS(4582),
    [anon_sym_LBRACK] = ACTIONS(4586),
    [anon_sym_EQ] = ACTIONS(4586),
    [anon_sym_static] = ACTIONS(4575),
    [anon_sym_register] = ACTIONS(4575),
    [anon_sym_inline] = ACTIONS(4575),
    [anon_sym___inline] = ACTIONS(4575),
    [anon_sym___inline__] = ACTIONS(4575),
    [anon_sym___forceinline] = ACTIONS(4575),
    [anon_sym_thread_local] = ACTIONS(4575),
    [anon_sym___thread] = ACTIONS(4575),
    [anon_sym_const] = ACTIONS(4575),
    [anon_sym_constexpr] = ACTIONS(4575),
    [anon_sym_volatile] = ACTIONS(4575),
    [anon_sym_restrict] = ACTIONS(4575),
    [anon_sym___restrict__] = ACTIONS(4575),
    [anon_sym__Atomic] = ACTIONS(4575),
    [anon_sym__Noreturn] = ACTIONS(4575),
    [anon_sym_noreturn] = ACTIONS(4575),
    [anon_sym_mutable] = ACTIONS(4575),
    [anon_sym_constinit] = ACTIONS(4575),
    [anon_sym_consteval] = ACTIONS(4575),
    [anon_sym_PROGMEM] = ACTIONS(4575),
    [anon_sym_QMARK] = ACTIONS(4577),
    [anon_sym_STAR_EQ] = ACTIONS(4577),
    [anon_sym_SLASH_EQ] = ACTIONS(4577),
    [anon_sym_PERCENT_EQ] = ACTIONS(4577),
    [anon_sym_PLUS_EQ] = ACTIONS(4577),
    [anon_sym_DASH_EQ] = ACTIONS(4577),
    [anon_sym_LT_LT_EQ] = ACTIONS(4577),
    [anon_sym_GT_GT_EQ] = ACTIONS(4577),
    [anon_sym_AMP_EQ] = ACTIONS(4577),
    [anon_sym_CARET_EQ] = ACTIONS(4577),
    [anon_sym_PIPE_EQ] = ACTIONS(4577),
    [anon_sym_and_eq] = ACTIONS(4584),
    [anon_sym_or_eq] = ACTIONS(4584),
    [anon_sym_xor_eq] = ACTIONS(4584),
    [anon_sym_LT_EQ_GT] = ACTIONS(4577),
    [anon_sym_or] = ACTIONS(4584),
    [anon_sym_and] = ACTIONS(4584),
    [anon_sym_bitor] = ACTIONS(4584),
    [anon_sym_xor] = ACTIONS(4584),
    [anon_sym_bitand] = ACTIONS(4584),
    [anon_sym_not_eq] = ACTIONS(4584),
    [anon_sym_DASH_DASH] = ACTIONS(4577),
    [anon_sym_PLUS_PLUS] = ACTIONS(4577),
    [anon_sym_DOT] = ACTIONS(4584),
    [anon_sym_DOT_STAR] = ACTIONS(4577),
    [anon_sym_DASH_GT] = ACTIONS(4584),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4575),
    [anon_sym_decltype] = ACTIONS(4575),
    [anon_sym_virtual] = ACTIONS(4575),
    [anon_sym_alignas] = ACTIONS(4575),
    [anon_sym_template] = ACTIONS(4575),
    [anon_sym_operator] = ACTIONS(4575),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4577),
  },
  [1711] = {
    [sym_identifier] = ACTIONS(4555),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4557),
    [anon_sym_COMMA] = ACTIONS(4557),
    [anon_sym_RPAREN] = ACTIONS(4557),
    [anon_sym_LPAREN2] = ACTIONS(4557),
    [anon_sym_TILDE] = ACTIONS(4557),
    [anon_sym_DASH] = ACTIONS(4555),
    [anon_sym_PLUS] = ACTIONS(4555),
    [anon_sym_STAR] = ACTIONS(4557),
    [anon_sym_SLASH] = ACTIONS(4555),
    [anon_sym_PERCENT] = ACTIONS(4557),
    [anon_sym_PIPE_PIPE] = ACTIONS(4557),
    [anon_sym_AMP_AMP] = ACTIONS(4557),
    [anon_sym_PIPE] = ACTIONS(4555),
    [anon_sym_CARET] = ACTIONS(4557),
    [anon_sym_AMP] = ACTIONS(4555),
    [anon_sym_EQ_EQ] = ACTIONS(4557),
    [anon_sym_BANG_EQ] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4555),
    [anon_sym_GT_EQ] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4555),
    [anon_sym_LT_LT] = ACTIONS(4557),
    [anon_sym_GT_GT] = ACTIONS(4557),
    [anon_sym_SEMI] = ACTIONS(4557),
    [anon_sym___extension__] = ACTIONS(4555),
    [anon_sym_extern] = ACTIONS(4555),
    [anon_sym___attribute__] = ACTIONS(4555),
    [anon_sym_COLON_COLON] = ACTIONS(4557),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4557),
    [anon_sym___declspec] = ACTIONS(4555),
    [anon_sym___based] = ACTIONS(4555),
    [anon_sym___cdecl] = ACTIONS(4555),
    [anon_sym___clrcall] = ACTIONS(4555),
    [anon_sym___stdcall] = ACTIONS(4555),
    [anon_sym___fastcall] = ACTIONS(4555),
    [anon_sym___thiscall] = ACTIONS(4555),
    [anon_sym___vectorcall] = ACTIONS(4555),
    [anon_sym_LBRACE] = ACTIONS(4557),
    [anon_sym_RBRACE] = ACTIONS(4557),
    [anon_sym_LBRACK] = ACTIONS(4555),
    [anon_sym_EQ] = ACTIONS(4555),
    [anon_sym_static] = ACTIONS(4555),
    [anon_sym_register] = ACTIONS(4555),
    [anon_sym_inline] = ACTIONS(4555),
    [anon_sym___inline] = ACTIONS(4555),
    [anon_sym___inline__] = ACTIONS(4555),
    [anon_sym___forceinline] = ACTIONS(4555),
    [anon_sym_thread_local] = ACTIONS(4555),
    [anon_sym___thread] = ACTIONS(4555),
    [anon_sym_const] = ACTIONS(4555),
    [anon_sym_constexpr] = ACTIONS(4555),
    [anon_sym_volatile] = ACTIONS(4555),
    [anon_sym_restrict] = ACTIONS(4555),
    [anon_sym___restrict__] = ACTIONS(4555),
    [anon_sym__Atomic] = ACTIONS(4555),
    [anon_sym__Noreturn] = ACTIONS(4555),
    [anon_sym_noreturn] = ACTIONS(4555),
    [anon_sym_mutable] = ACTIONS(4555),
    [anon_sym_constinit] = ACTIONS(4555),
    [anon_sym_consteval] = ACTIONS(4555),
    [anon_sym_PROGMEM] = ACTIONS(4555),
    [anon_sym_COLON] = ACTIONS(4555),
    [anon_sym_QMARK] = ACTIONS(4557),
    [anon_sym_LT_EQ_GT] = ACTIONS(4557),
    [anon_sym_or] = ACTIONS(4555),
    [anon_sym_and] = ACTIONS(4555),
    [anon_sym_bitor] = ACTIONS(4555),
    [anon_sym_xor] = ACTIONS(4555),
    [anon_sym_bitand] = ACTIONS(4555),
    [anon_sym_not_eq] = ACTIONS(4555),
    [anon_sym_DASH_DASH] = ACTIONS(4557),
    [anon_sym_PLUS_PLUS] = ACTIONS(4557),
    [anon_sym_DOT] = ACTIONS(4555),
    [anon_sym_DOT_STAR] = ACTIONS(4557),
    [anon_sym_DASH_GT] = ACTIONS(4557),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4555),
    [anon_sym_decltype] = ACTIONS(4555),
    [anon_sym_final] = ACTIONS(4555),
    [anon_sym_override] = ACTIONS(4555),
    [anon_sym_virtual] = ACTIONS(4555),
    [anon_sym_alignas] = ACTIONS(4555),
    [anon_sym_template] = ACTIONS(4555),
    [anon_sym_operator] = ACTIONS(4555),
    [anon_sym_try] = ACTIONS(4555),
    [anon_sym_requires] = ACTIONS(4555),
  },
  [1712] = {
    [sym_identifier] = ACTIONS(4575),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4579),
    [anon_sym_COMMA] = ACTIONS(4579),
    [anon_sym_RPAREN] = ACTIONS(4579),
    [anon_sym_LPAREN2] = ACTIONS(4579),
    [anon_sym_TILDE] = ACTIONS(4582),
    [anon_sym_DASH] = ACTIONS(4584),
    [anon_sym_PLUS] = ACTIONS(4584),
    [anon_sym_STAR] = ACTIONS(4586),
    [anon_sym_SLASH] = ACTIONS(4584),
    [anon_sym_PERCENT] = ACTIONS(4584),
    [anon_sym_PIPE_PIPE] = ACTIONS(4577),
    [anon_sym_AMP_AMP] = ACTIONS(4579),
    [anon_sym_PIPE] = ACTIONS(4584),
    [anon_sym_CARET] = ACTIONS(4584),
    [anon_sym_AMP] = ACTIONS(4586),
    [anon_sym_EQ_EQ] = ACTIONS(4577),
    [anon_sym_BANG_EQ] = ACTIONS(4577),
    [anon_sym_GT] = ACTIONS(4584),
    [anon_sym_GT_EQ] = ACTIONS(4577),
    [anon_sym_LT_EQ] = ACTIONS(4584),
    [anon_sym_LT] = ACTIONS(4584),
    [anon_sym_LT_LT] = ACTIONS(4584),
    [anon_sym_GT_GT] = ACTIONS(4584),
    [anon_sym___extension__] = ACTIONS(4575),
    [anon_sym_extern] = ACTIONS(4575),
    [anon_sym___attribute__] = ACTIONS(4575),
    [anon_sym_COLON_COLON] = ACTIONS(4582),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4582),
    [anon_sym___declspec] = ACTIONS(4575),
    [anon_sym___based] = ACTIONS(4575),
    [anon_sym_LBRACE] = ACTIONS(4582),
    [anon_sym_LBRACK] = ACTIONS(4586),
    [anon_sym_EQ] = ACTIONS(4586),
    [anon_sym_static] = ACTIONS(4575),
    [anon_sym_register] = ACTIONS(4575),
    [anon_sym_inline] = ACTIONS(4575),
    [anon_sym___inline] = ACTIONS(4575),
    [anon_sym___inline__] = ACTIONS(4575),
    [anon_sym___forceinline] = ACTIONS(4575),
    [anon_sym_thread_local] = ACTIONS(4575),
    [anon_sym___thread] = ACTIONS(4575),
    [anon_sym_const] = ACTIONS(4575),
    [anon_sym_constexpr] = ACTIONS(4575),
    [anon_sym_volatile] = ACTIONS(4575),
    [anon_sym_restrict] = ACTIONS(4575),
    [anon_sym___restrict__] = ACTIONS(4575),
    [anon_sym__Atomic] = ACTIONS(4575),
    [anon_sym__Noreturn] = ACTIONS(4575),
    [anon_sym_noreturn] = ACTIONS(4575),
    [anon_sym_mutable] = ACTIONS(4575),
    [anon_sym_constinit] = ACTIONS(4575),
    [anon_sym_consteval] = ACTIONS(4575),
    [anon_sym_PROGMEM] = ACTIONS(4575),
    [anon_sym_QMARK] = ACTIONS(4577),
    [anon_sym_STAR_EQ] = ACTIONS(4577),
    [anon_sym_SLASH_EQ] = ACTIONS(4577),
    [anon_sym_PERCENT_EQ] = ACTIONS(4577),
    [anon_sym_PLUS_EQ] = ACTIONS(4577),
    [anon_sym_DASH_EQ] = ACTIONS(4577),
    [anon_sym_LT_LT_EQ] = ACTIONS(4577),
    [anon_sym_GT_GT_EQ] = ACTIONS(4577),
    [anon_sym_AMP_EQ] = ACTIONS(4577),
    [anon_sym_CARET_EQ] = ACTIONS(4577),
    [anon_sym_PIPE_EQ] = ACTIONS(4577),
    [anon_sym_and_eq] = ACTIONS(4584),
    [anon_sym_or_eq] = ACTIONS(4584),
    [anon_sym_xor_eq] = ACTIONS(4584),
    [anon_sym_LT_EQ_GT] = ACTIONS(4577),
    [anon_sym_or] = ACTIONS(4584),
    [anon_sym_and] = ACTIONS(4584),
    [anon_sym_bitor] = ACTIONS(4584),
    [anon_sym_xor] = ACTIONS(4584),
    [anon_sym_bitand] = ACTIONS(4584),
    [anon_sym_not_eq] = ACTIONS(4584),
    [anon_sym_DASH_DASH] = ACTIONS(4577),
    [anon_sym_PLUS_PLUS] = ACTIONS(4577),
    [anon_sym_DOT] = ACTIONS(4584),
    [anon_sym_DOT_STAR] = ACTIONS(4577),
    [anon_sym_DASH_GT] = ACTIONS(4577),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4575),
    [anon_sym_decltype] = ACTIONS(4575),
    [anon_sym_virtual] = ACTIONS(4575),
    [anon_sym_alignas] = ACTIONS(4575),
    [anon_sym_template] = ACTIONS(4575),
    [anon_sym_operator] = ACTIONS(4575),
  },
  [1713] = {
    [sym_identifier] = ACTIONS(4559),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4561),
    [anon_sym_COMMA] = ACTIONS(4561),
    [anon_sym_RPAREN] = ACTIONS(4561),
    [anon_sym_LPAREN2] = ACTIONS(4561),
    [anon_sym_TILDE] = ACTIONS(4561),
    [anon_sym_DASH] = ACTIONS(4559),
    [anon_sym_PLUS] = ACTIONS(4559),
    [anon_sym_STAR] = ACTIONS(4561),
    [anon_sym_SLASH] = ACTIONS(4559),
    [anon_sym_PERCENT] = ACTIONS(4561),
    [anon_sym_PIPE_PIPE] = ACTIONS(4561),
    [anon_sym_AMP_AMP] = ACTIONS(4561),
    [anon_sym_PIPE] = ACTIONS(4559),
    [anon_sym_CARET] = ACTIONS(4561),
    [anon_sym_AMP] = ACTIONS(4559),
    [anon_sym_EQ_EQ] = ACTIONS(4561),
    [anon_sym_BANG_EQ] = ACTIONS(4561),
    [anon_sym_GT] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4561),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_LT] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_SEMI] = ACTIONS(4561),
    [anon_sym___extension__] = ACTIONS(4559),
    [anon_sym_extern] = ACTIONS(4559),
    [anon_sym___attribute__] = ACTIONS(4559),
    [anon_sym_COLON_COLON] = ACTIONS(4561),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4561),
    [anon_sym___declspec] = ACTIONS(4559),
    [anon_sym___based] = ACTIONS(4559),
    [anon_sym___cdecl] = ACTIONS(4559),
    [anon_sym___clrcall] = ACTIONS(4559),
    [anon_sym___stdcall] = ACTIONS(4559),
    [anon_sym___fastcall] = ACTIONS(4559),
    [anon_sym___thiscall] = ACTIONS(4559),
    [anon_sym___vectorcall] = ACTIONS(4559),
    [anon_sym_LBRACE] = ACTIONS(4561),
    [anon_sym_RBRACE] = ACTIONS(4561),
    [anon_sym_LBRACK] = ACTIONS(4559),
    [anon_sym_EQ] = ACTIONS(4559),
    [anon_sym_static] = ACTIONS(4559),
    [anon_sym_register] = ACTIONS(4559),
    [anon_sym_inline] = ACTIONS(4559),
    [anon_sym___inline] = ACTIONS(4559),
    [anon_sym___inline__] = ACTIONS(4559),
    [anon_sym___forceinline] = ACTIONS(4559),
    [anon_sym_thread_local] = ACTIONS(4559),
    [anon_sym___thread] = ACTIONS(4559),
    [anon_sym_const] = ACTIONS(4559),
    [anon_sym_constexpr] = ACTIONS(4559),
    [anon_sym_volatile] = ACTIONS(4559),
    [anon_sym_restrict] = ACTIONS(4559),
    [anon_sym___restrict__] = ACTIONS(4559),
    [anon_sym__Atomic] = ACTIONS(4559),
    [anon_sym__Noreturn] = ACTIONS(4559),
    [anon_sym_noreturn] = ACTIONS(4559),
    [anon_sym_mutable] = ACTIONS(4559),
    [anon_sym_constinit] = ACTIONS(4559),
    [anon_sym_consteval] = ACTIONS(4559),
    [anon_sym_PROGMEM] = ACTIONS(4559),
    [anon_sym_COLON] = ACTIONS(4559),
    [anon_sym_QMARK] = ACTIONS(4561),
    [anon_sym_LT_EQ_GT] = ACTIONS(4561),
    [anon_sym_or] = ACTIONS(4559),
    [anon_sym_and] = ACTIONS(4559),
    [anon_sym_bitor] = ACTIONS(4559),
    [anon_sym_xor] = ACTIONS(4559),
    [anon_sym_bitand] = ACTIONS(4559),
    [anon_sym_not_eq] = ACTIONS(4559),
    [anon_sym_DASH_DASH] = ACTIONS(4561),
    [anon_sym_PLUS_PLUS] = ACTIONS(4561),
    [anon_sym_DOT] = ACTIONS(4559),
    [anon_sym_DOT_STAR] = ACTIONS(4561),
    [anon_sym_DASH_GT] = ACTIONS(4561),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4559),
    [anon_sym_decltype] = ACTIONS(4559),
    [anon_sym_final] = ACTIONS(4559),
    [anon_sym_override] = ACTIONS(4559),
    [anon_sym_virtual] = ACTIONS(4559),
    [anon_sym_alignas] = ACTIONS(4559),
    [anon_sym_template] = ACTIONS(4559),
    [anon_sym_operator] = ACTIONS(4559),
    [anon_sym_try] = ACTIONS(4559),
    [anon_sym_requires] = ACTIONS(4559),
  },
  [1714] = {
    [sym_identifier] = ACTIONS(4551),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4553),
    [anon_sym_COMMA] = ACTIONS(4553),
    [anon_sym_RPAREN] = ACTIONS(4553),
    [anon_sym_LPAREN2] = ACTIONS(4553),
    [anon_sym_TILDE] = ACTIONS(4553),
    [anon_sym_DASH] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(4551),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_SLASH] = ACTIONS(4551),
    [anon_sym_PERCENT] = ACTIONS(4553),
    [anon_sym_PIPE_PIPE] = ACTIONS(4553),
    [anon_sym_AMP_AMP] = ACTIONS(4553),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4553),
    [anon_sym_AMP] = ACTIONS(4551),
    [anon_sym_EQ_EQ] = ACTIONS(4553),
    [anon_sym_BANG_EQ] = ACTIONS(4553),
    [anon_sym_GT] = ACTIONS(4551),
    [anon_sym_GT_EQ] = ACTIONS(4553),
    [anon_sym_LT_EQ] = ACTIONS(4551),
    [anon_sym_LT] = ACTIONS(4551),
    [anon_sym_LT_LT] = ACTIONS(4553),
    [anon_sym_GT_GT] = ACTIONS(4553),
    [anon_sym_SEMI] = ACTIONS(4553),
    [anon_sym___extension__] = ACTIONS(4551),
    [anon_sym_extern] = ACTIONS(4551),
    [anon_sym___attribute__] = ACTIONS(4551),
    [anon_sym_COLON_COLON] = ACTIONS(4553),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4553),
    [anon_sym___declspec] = ACTIONS(4551),
    [anon_sym___based] = ACTIONS(4551),
    [anon_sym___cdecl] = ACTIONS(4551),
    [anon_sym___clrcall] = ACTIONS(4551),
    [anon_sym___stdcall] = ACTIONS(4551),
    [anon_sym___fastcall] = ACTIONS(4551),
    [anon_sym___thiscall] = ACTIONS(4551),
    [anon_sym___vectorcall] = ACTIONS(4551),
    [anon_sym_LBRACE] = ACTIONS(4553),
    [anon_sym_RBRACE] = ACTIONS(4553),
    [anon_sym_LBRACK] = ACTIONS(4551),
    [anon_sym_EQ] = ACTIONS(4551),
    [anon_sym_static] = ACTIONS(4551),
    [anon_sym_register] = ACTIONS(4551),
    [anon_sym_inline] = ACTIONS(4551),
    [anon_sym___inline] = ACTIONS(4551),
    [anon_sym___inline__] = ACTIONS(4551),
    [anon_sym___forceinline] = ACTIONS(4551),
    [anon_sym_thread_local] = ACTIONS(4551),
    [anon_sym___thread] = ACTIONS(4551),
    [anon_sym_const] = ACTIONS(4551),
    [anon_sym_constexpr] = ACTIONS(4551),
    [anon_sym_volatile] = ACTIONS(4551),
    [anon_sym_restrict] = ACTIONS(4551),
    [anon_sym___restrict__] = ACTIONS(4551),
    [anon_sym__Atomic] = ACTIONS(4551),
    [anon_sym__Noreturn] = ACTIONS(4551),
    [anon_sym_noreturn] = ACTIONS(4551),
    [anon_sym_mutable] = ACTIONS(4551),
    [anon_sym_constinit] = ACTIONS(4551),
    [anon_sym_consteval] = ACTIONS(4551),
    [anon_sym_PROGMEM] = ACTIONS(4551),
    [anon_sym_COLON] = ACTIONS(4551),
    [anon_sym_QMARK] = ACTIONS(4553),
    [anon_sym_LT_EQ_GT] = ACTIONS(4553),
    [anon_sym_or] = ACTIONS(4551),
    [anon_sym_and] = ACTIONS(4551),
    [anon_sym_bitor] = ACTIONS(4551),
    [anon_sym_xor] = ACTIONS(4551),
    [anon_sym_bitand] = ACTIONS(4551),
    [anon_sym_not_eq] = ACTIONS(4551),
    [anon_sym_DASH_DASH] = ACTIONS(4553),
    [anon_sym_PLUS_PLUS] = ACTIONS(4553),
    [anon_sym_DOT] = ACTIONS(4551),
    [anon_sym_DOT_STAR] = ACTIONS(4553),
    [anon_sym_DASH_GT] = ACTIONS(4553),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4551),
    [anon_sym_decltype] = ACTIONS(4551),
    [anon_sym_final] = ACTIONS(4551),
    [anon_sym_override] = ACTIONS(4551),
    [anon_sym_virtual] = ACTIONS(4551),
    [anon_sym_alignas] = ACTIONS(4551),
    [anon_sym_template] = ACTIONS(4551),
    [anon_sym_operator] = ACTIONS(4551),
    [anon_sym_try] = ACTIONS(4551),
    [anon_sym_requires] = ACTIONS(4551),
  },
  [1715] = {
    [sym_string_literal] = STATE(2079),
    [sym_template_argument_list] = STATE(2002),
    [sym_raw_string_literal] = STATE(2079),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3761),
    [anon_sym_COMMA] = ACTIONS(3761),
    [anon_sym_RPAREN] = ACTIONS(3774),
    [anon_sym_LPAREN2] = ACTIONS(3774),
    [anon_sym_DASH] = ACTIONS(3769),
    [anon_sym_PLUS] = ACTIONS(3769),
    [anon_sym_STAR] = ACTIONS(3771),
    [anon_sym_SLASH] = ACTIONS(3769),
    [anon_sym_PERCENT] = ACTIONS(3769),
    [anon_sym_PIPE_PIPE] = ACTIONS(3761),
    [anon_sym_AMP_AMP] = ACTIONS(3774),
    [anon_sym_PIPE] = ACTIONS(3769),
    [anon_sym_CARET] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(3771),
    [anon_sym_EQ_EQ] = ACTIONS(3761),
    [anon_sym_BANG_EQ] = ACTIONS(3761),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3761),
    [anon_sym_LT_EQ] = ACTIONS(3769),
    [anon_sym_LT] = ACTIONS(4609),
    [anon_sym_LT_LT] = ACTIONS(3769),
    [anon_sym_GT_GT] = ACTIONS(3769),
    [anon_sym___extension__] = ACTIONS(3767),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(3785),
    [anon_sym_signed] = ACTIONS(4603),
    [anon_sym_unsigned] = ACTIONS(4603),
    [anon_sym_long] = ACTIONS(4603),
    [anon_sym_short] = ACTIONS(4603),
    [anon_sym_LBRACK] = ACTIONS(3774),
    [anon_sym_EQ] = ACTIONS(3769),
    [anon_sym_const] = ACTIONS(3759),
    [anon_sym_constexpr] = ACTIONS(3767),
    [anon_sym_volatile] = ACTIONS(3767),
    [anon_sym_restrict] = ACTIONS(3767),
    [anon_sym___restrict__] = ACTIONS(3767),
    [anon_sym__Atomic] = ACTIONS(3767),
    [anon_sym__Noreturn] = ACTIONS(3767),
    [anon_sym_noreturn] = ACTIONS(3767),
    [anon_sym_mutable] = ACTIONS(3767),
    [anon_sym_constinit] = ACTIONS(3767),
    [anon_sym_consteval] = ACTIONS(3767),
    [anon_sym_PROGMEM] = ACTIONS(3767),
    [anon_sym_QMARK] = ACTIONS(3761),
    [anon_sym_STAR_EQ] = ACTIONS(3761),
    [anon_sym_SLASH_EQ] = ACTIONS(3761),
    [anon_sym_PERCENT_EQ] = ACTIONS(3761),
    [anon_sym_PLUS_EQ] = ACTIONS(3761),
    [anon_sym_DASH_EQ] = ACTIONS(3761),
    [anon_sym_LT_LT_EQ] = ACTIONS(3761),
    [anon_sym_GT_GT_EQ] = ACTIONS(3761),
    [anon_sym_AMP_EQ] = ACTIONS(3761),
    [anon_sym_CARET_EQ] = ACTIONS(3761),
    [anon_sym_PIPE_EQ] = ACTIONS(3761),
    [anon_sym_and_eq] = ACTIONS(3761),
    [anon_sym_or_eq] = ACTIONS(3761),
    [anon_sym_xor_eq] = ACTIONS(3761),
    [anon_sym_LT_EQ_GT] = ACTIONS(3761),
    [anon_sym_or] = ACTIONS(3769),
    [anon_sym_and] = ACTIONS(3769),
    [anon_sym_bitor] = ACTIONS(3761),
    [anon_sym_xor] = ACTIONS(3769),
    [anon_sym_bitand] = ACTIONS(3761),
    [anon_sym_not_eq] = ACTIONS(3761),
    [anon_sym_DASH_DASH] = ACTIONS(3761),
    [anon_sym_PLUS_PLUS] = ACTIONS(3761),
    [anon_sym_DOT] = ACTIONS(3769),
    [anon_sym_DOT_STAR] = ACTIONS(3761),
    [anon_sym_DASH_GT] = ACTIONS(3769),
    [anon_sym_L_DQUOTE] = ACTIONS(4605),
    [anon_sym_u_DQUOTE] = ACTIONS(4605),
    [anon_sym_U_DQUOTE] = ACTIONS(4605),
    [anon_sym_u8_DQUOTE] = ACTIONS(4605),
    [anon_sym_DQUOTE] = ACTIONS(4605),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3767),
    [anon_sym_decltype] = ACTIONS(3767),
    [anon_sym_R_DQUOTE] = ACTIONS(4607),
    [anon_sym_LR_DQUOTE] = ACTIONS(4607),
    [anon_sym_uR_DQUOTE] = ACTIONS(4607),
    [anon_sym_UR_DQUOTE] = ACTIONS(4607),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4607),
    [anon_sym_DASH_GT_STAR] = ACTIONS(3761),
  },
  [1716] = {
    [sym_identifier] = ACTIONS(4530),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4532),
    [anon_sym_COMMA] = ACTIONS(4532),
    [anon_sym_RPAREN] = ACTIONS(4532),
    [anon_sym_LPAREN2] = ACTIONS(4532),
    [anon_sym_TILDE] = ACTIONS(4532),
    [anon_sym_DASH] = ACTIONS(4530),
    [anon_sym_PLUS] = ACTIONS(4530),
    [anon_sym_STAR] = ACTIONS(4532),
    [anon_sym_SLASH] = ACTIONS(4530),
    [anon_sym_PERCENT] = ACTIONS(4532),
    [anon_sym_PIPE_PIPE] = ACTIONS(4532),
    [anon_sym_AMP_AMP] = ACTIONS(4532),
    [anon_sym_PIPE] = ACTIONS(4530),
    [anon_sym_CARET] = ACTIONS(4532),
    [anon_sym_AMP] = ACTIONS(4530),
    [anon_sym_EQ_EQ] = ACTIONS(4532),
    [anon_sym_BANG_EQ] = ACTIONS(4532),
    [anon_sym_GT] = ACTIONS(4530),
    [anon_sym_GT_EQ] = ACTIONS(4532),
    [anon_sym_LT_EQ] = ACTIONS(4530),
    [anon_sym_LT] = ACTIONS(4530),
    [anon_sym_LT_LT] = ACTIONS(4532),
    [anon_sym_GT_GT] = ACTIONS(4532),
    [anon_sym_SEMI] = ACTIONS(4532),
    [anon_sym___extension__] = ACTIONS(4530),
    [anon_sym_extern] = ACTIONS(4530),
    [anon_sym___attribute__] = ACTIONS(4530),
    [anon_sym_COLON_COLON] = ACTIONS(4532),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4532),
    [anon_sym___declspec] = ACTIONS(4530),
    [anon_sym___based] = ACTIONS(4530),
    [anon_sym___cdecl] = ACTIONS(4530),
    [anon_sym___clrcall] = ACTIONS(4530),
    [anon_sym___stdcall] = ACTIONS(4530),
    [anon_sym___fastcall] = ACTIONS(4530),
    [anon_sym___thiscall] = ACTIONS(4530),
    [anon_sym___vectorcall] = ACTIONS(4530),
    [anon_sym_LBRACE] = ACTIONS(4532),
    [anon_sym_RBRACE] = ACTIONS(4532),
    [anon_sym_LBRACK] = ACTIONS(4530),
    [anon_sym_EQ] = ACTIONS(4530),
    [anon_sym_static] = ACTIONS(4530),
    [anon_sym_register] = ACTIONS(4530),
    [anon_sym_inline] = ACTIONS(4530),
    [anon_sym___inline] = ACTIONS(4530),
    [anon_sym___inline__] = ACTIONS(4530),
    [anon_sym___forceinline] = ACTIONS(4530),
    [anon_sym_thread_local] = ACTIONS(4530),
    [anon_sym___thread] = ACTIONS(4530),
    [anon_sym_const] = ACTIONS(4530),
    [anon_sym_constexpr] = ACTIONS(4530),
    [anon_sym_volatile] = ACTIONS(4530),
    [anon_sym_restrict] = ACTIONS(4530),
    [anon_sym___restrict__] = ACTIONS(4530),
    [anon_sym__Atomic] = ACTIONS(4530),
    [anon_sym__Noreturn] = ACTIONS(4530),
    [anon_sym_noreturn] = ACTIONS(4530),
    [anon_sym_mutable] = ACTIONS(4530),
    [anon_sym_constinit] = ACTIONS(4530),
    [anon_sym_consteval] = ACTIONS(4530),
    [anon_sym_PROGMEM] = ACTIONS(4530),
    [anon_sym_COLON] = ACTIONS(4530),
    [anon_sym_QMARK] = ACTIONS(4532),
    [anon_sym_LT_EQ_GT] = ACTIONS(4532),
    [anon_sym_or] = ACTIONS(4530),
    [anon_sym_and] = ACTIONS(4530),
    [anon_sym_bitor] = ACTIONS(4530),
    [anon_sym_xor] = ACTIONS(4530),
    [anon_sym_bitand] = ACTIONS(4530),
    [anon_sym_not_eq] = ACTIONS(4530),
    [anon_sym_DASH_DASH] = ACTIONS(4532),
    [anon_sym_PLUS_PLUS] = ACTIONS(4532),
    [anon_sym_DOT] = ACTIONS(4530),
    [anon_sym_DOT_STAR] = ACTIONS(4532),
    [anon_sym_DASH_GT] = ACTIONS(4532),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4530),
    [anon_sym_decltype] = ACTIONS(4530),
    [anon_sym_final] = ACTIONS(4530),
    [anon_sym_override] = ACTIONS(4530),
    [anon_sym_virtual] = ACTIONS(4530),
    [anon_sym_alignas] = ACTIONS(4530),
    [anon_sym_template] = ACTIONS(4530),
    [anon_sym_operator] = ACTIONS(4530),
    [anon_sym_try] = ACTIONS(4530),
    [anon_sym_requires] = ACTIONS(4530),
  },
  [1717] = {
    [sym_identifier] = ACTIONS(4563),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4565),
    [anon_sym_COMMA] = ACTIONS(4565),
    [anon_sym_RPAREN] = ACTIONS(4565),
    [anon_sym_LPAREN2] = ACTIONS(4565),
    [anon_sym_TILDE] = ACTIONS(4565),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_STAR] = ACTIONS(4565),
    [anon_sym_SLASH] = ACTIONS(4563),
    [anon_sym_PERCENT] = ACTIONS(4565),
    [anon_sym_PIPE_PIPE] = ACTIONS(4565),
    [anon_sym_AMP_AMP] = ACTIONS(4565),
    [anon_sym_PIPE] = ACTIONS(4563),
    [anon_sym_CARET] = ACTIONS(4565),
    [anon_sym_AMP] = ACTIONS(4563),
    [anon_sym_EQ_EQ] = ACTIONS(4565),
    [anon_sym_BANG_EQ] = ACTIONS(4565),
    [anon_sym_GT] = ACTIONS(4563),
    [anon_sym_GT_EQ] = ACTIONS(4565),
    [anon_sym_LT_EQ] = ACTIONS(4563),
    [anon_sym_LT] = ACTIONS(4563),
    [anon_sym_LT_LT] = ACTIONS(4565),
    [anon_sym_GT_GT] = ACTIONS(4565),
    [anon_sym_SEMI] = ACTIONS(4565),
    [anon_sym___extension__] = ACTIONS(4563),
    [anon_sym_extern] = ACTIONS(4563),
    [anon_sym___attribute__] = ACTIONS(4563),
    [anon_sym_COLON_COLON] = ACTIONS(4565),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4565),
    [anon_sym___declspec] = ACTIONS(4563),
    [anon_sym___based] = ACTIONS(4563),
    [anon_sym___cdecl] = ACTIONS(4563),
    [anon_sym___clrcall] = ACTIONS(4563),
    [anon_sym___stdcall] = ACTIONS(4563),
    [anon_sym___fastcall] = ACTIONS(4563),
    [anon_sym___thiscall] = ACTIONS(4563),
    [anon_sym___vectorcall] = ACTIONS(4563),
    [anon_sym_LBRACE] = ACTIONS(4565),
    [anon_sym_RBRACE] = ACTIONS(4565),
    [anon_sym_LBRACK] = ACTIONS(4563),
    [anon_sym_EQ] = ACTIONS(4563),
    [anon_sym_static] = ACTIONS(4563),
    [anon_sym_register] = ACTIONS(4563),
    [anon_sym_inline] = ACTIONS(4563),
    [anon_sym___inline] = ACTIONS(4563),
    [anon_sym___inline__] = ACTIONS(4563),
    [anon_sym___forceinline] = ACTIONS(4563),
    [anon_sym_thread_local] = ACTIONS(4563),
    [anon_sym___thread] = ACTIONS(4563),
    [anon_sym_const] = ACTIONS(4563),
    [anon_sym_constexpr] = ACTIONS(4563),
    [anon_sym_volatile] = ACTIONS(4563),
    [anon_sym_restrict] = ACTIONS(4563),
    [anon_sym___restrict__] = ACTIONS(4563),
    [anon_sym__Atomic] = ACTIONS(4563),
    [anon_sym__Noreturn] = ACTIONS(4563),
    [anon_sym_noreturn] = ACTIONS(4563),
    [anon_sym_mutable] = ACTIONS(4563),
    [anon_sym_constinit] = ACTIONS(4563),
    [anon_sym_consteval] = ACTIONS(4563),
    [anon_sym_PROGMEM] = ACTIONS(4563),
    [anon_sym_COLON] = ACTIONS(4563),
    [anon_sym_QMARK] = ACTIONS(4565),
    [anon_sym_LT_EQ_GT] = ACTIONS(4565),
    [anon_sym_or] = ACTIONS(4563),
    [anon_sym_and] = ACTIONS(4563),
    [anon_sym_bitor] = ACTIONS(4563),
    [anon_sym_xor] = ACTIONS(4563),
    [anon_sym_bitand] = ACTIONS(4563),
    [anon_sym_not_eq] = ACTIONS(4563),
    [anon_sym_DASH_DASH] = ACTIONS(4565),
    [anon_sym_PLUS_PLUS] = ACTIONS(4565),
    [anon_sym_DOT] = ACTIONS(4563),
    [anon_sym_DOT_STAR] = ACTIONS(4565),
    [anon_sym_DASH_GT] = ACTIONS(4565),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4563),
    [anon_sym_decltype] = ACTIONS(4563),
    [anon_sym_final] = ACTIONS(4563),
    [anon_sym_override] = ACTIONS(4563),
    [anon_sym_virtual] = ACTIONS(4563),
    [anon_sym_alignas] = ACTIONS(4563),
    [anon_sym_template] = ACTIONS(4563),
    [anon_sym_operator] = ACTIONS(4563),
    [anon_sym_try] = ACTIONS(4563),
    [anon_sym_requires] = ACTIONS(4563),
  },
  [1718] = {
    [sym_identifier] = ACTIONS(4567),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4569),
    [anon_sym_COMMA] = ACTIONS(4569),
    [anon_sym_RPAREN] = ACTIONS(4569),
    [anon_sym_LPAREN2] = ACTIONS(4569),
    [anon_sym_TILDE] = ACTIONS(4569),
    [anon_sym_DASH] = ACTIONS(4567),
    [anon_sym_PLUS] = ACTIONS(4567),
    [anon_sym_STAR] = ACTIONS(4569),
    [anon_sym_SLASH] = ACTIONS(4567),
    [anon_sym_PERCENT] = ACTIONS(4569),
    [anon_sym_PIPE_PIPE] = ACTIONS(4569),
    [anon_sym_AMP_AMP] = ACTIONS(4569),
    [anon_sym_PIPE] = ACTIONS(4567),
    [anon_sym_CARET] = ACTIONS(4569),
    [anon_sym_AMP] = ACTIONS(4567),
    [anon_sym_EQ_EQ] = ACTIONS(4569),
    [anon_sym_BANG_EQ] = ACTIONS(4569),
    [anon_sym_GT] = ACTIONS(4567),
    [anon_sym_GT_EQ] = ACTIONS(4569),
    [anon_sym_LT_EQ] = ACTIONS(4567),
    [anon_sym_LT] = ACTIONS(4567),
    [anon_sym_LT_LT] = ACTIONS(4569),
    [anon_sym_GT_GT] = ACTIONS(4569),
    [anon_sym_SEMI] = ACTIONS(4569),
    [anon_sym___extension__] = ACTIONS(4567),
    [anon_sym_extern] = ACTIONS(4567),
    [anon_sym___attribute__] = ACTIONS(4567),
    [anon_sym_COLON_COLON] = ACTIONS(4569),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4569),
    [anon_sym___declspec] = ACTIONS(4567),
    [anon_sym___based] = ACTIONS(4567),
    [anon_sym___cdecl] = ACTIONS(4567),
    [anon_sym___clrcall] = ACTIONS(4567),
    [anon_sym___stdcall] = ACTIONS(4567),
    [anon_sym___fastcall] = ACTIONS(4567),
    [anon_sym___thiscall] = ACTIONS(4567),
    [anon_sym___vectorcall] = ACTIONS(4567),
    [anon_sym_LBRACE] = ACTIONS(4569),
    [anon_sym_RBRACE] = ACTIONS(4569),
    [anon_sym_LBRACK] = ACTIONS(4567),
    [anon_sym_EQ] = ACTIONS(4567),
    [anon_sym_static] = ACTIONS(4567),
    [anon_sym_register] = ACTIONS(4567),
    [anon_sym_inline] = ACTIONS(4567),
    [anon_sym___inline] = ACTIONS(4567),
    [anon_sym___inline__] = ACTIONS(4567),
    [anon_sym___forceinline] = ACTIONS(4567),
    [anon_sym_thread_local] = ACTIONS(4567),
    [anon_sym___thread] = ACTIONS(4567),
    [anon_sym_const] = ACTIONS(4567),
    [anon_sym_constexpr] = ACTIONS(4567),
    [anon_sym_volatile] = ACTIONS(4567),
    [anon_sym_restrict] = ACTIONS(4567),
    [anon_sym___restrict__] = ACTIONS(4567),
    [anon_sym__Atomic] = ACTIONS(4567),
    [anon_sym__Noreturn] = ACTIONS(4567),
    [anon_sym_noreturn] = ACTIONS(4567),
    [anon_sym_mutable] = ACTIONS(4567),
    [anon_sym_constinit] = ACTIONS(4567),
    [anon_sym_consteval] = ACTIONS(4567),
    [anon_sym_PROGMEM] = ACTIONS(4567),
    [anon_sym_COLON] = ACTIONS(4567),
    [anon_sym_QMARK] = ACTIONS(4569),
    [anon_sym_LT_EQ_GT] = ACTIONS(4569),
    [anon_sym_or] = ACTIONS(4567),
    [anon_sym_and] = ACTIONS(4567),
    [anon_sym_bitor] = ACTIONS(4567),
    [anon_sym_xor] = ACTIONS(4567),
    [anon_sym_bitand] = ACTIONS(4567),
    [anon_sym_not_eq] = ACTIONS(4567),
    [anon_sym_DASH_DASH] = ACTIONS(4569),
    [anon_sym_PLUS_PLUS] = ACTIONS(4569),
    [anon_sym_DOT] = ACTIONS(4567),
    [anon_sym_DOT_STAR] = ACTIONS(4569),
    [anon_sym_DASH_GT] = ACTIONS(4569),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4567),
    [anon_sym_decltype] = ACTIONS(4567),
    [anon_sym_final] = ACTIONS(4567),
    [anon_sym_override] = ACTIONS(4567),
    [anon_sym_virtual] = ACTIONS(4567),
    [anon_sym_alignas] = ACTIONS(4567),
    [anon_sym_template] = ACTIONS(4567),
    [anon_sym_operator] = ACTIONS(4567),
    [anon_sym_try] = ACTIONS(4567),
    [anon_sym_requires] = ACTIONS(4567),
  },
  [1719] = {
    [sym_identifier] = ACTIONS(4571),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4573),
    [anon_sym_COMMA] = ACTIONS(4573),
    [anon_sym_RPAREN] = ACTIONS(4573),
    [anon_sym_LPAREN2] = ACTIONS(4573),
    [anon_sym_TILDE] = ACTIONS(4573),
    [anon_sym_DASH] = ACTIONS(4571),
    [anon_sym_PLUS] = ACTIONS(4571),
    [anon_sym_STAR] = ACTIONS(4573),
    [anon_sym_SLASH] = ACTIONS(4571),
    [anon_sym_PERCENT] = ACTIONS(4573),
    [anon_sym_PIPE_PIPE] = ACTIONS(4573),
    [anon_sym_AMP_AMP] = ACTIONS(4573),
    [anon_sym_PIPE] = ACTIONS(4571),
    [anon_sym_CARET] = ACTIONS(4573),
    [anon_sym_AMP] = ACTIONS(4571),
    [anon_sym_EQ_EQ] = ACTIONS(4573),
    [anon_sym_BANG_EQ] = ACTIONS(4573),
    [anon_sym_GT] = ACTIONS(4571),
    [anon_sym_GT_EQ] = ACTIONS(4573),
    [anon_sym_LT_EQ] = ACTIONS(4571),
    [anon_sym_LT] = ACTIONS(4571),
    [anon_sym_LT_LT] = ACTIONS(4573),
    [anon_sym_GT_GT] = ACTIONS(4573),
    [anon_sym_SEMI] = ACTIONS(4573),
    [anon_sym___extension__] = ACTIONS(4571),
    [anon_sym_extern] = ACTIONS(4571),
    [anon_sym___attribute__] = ACTIONS(4571),
    [anon_sym_COLON_COLON] = ACTIONS(4573),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4573),
    [anon_sym___declspec] = ACTIONS(4571),
    [anon_sym___based] = ACTIONS(4571),
    [anon_sym___cdecl] = ACTIONS(4571),
    [anon_sym___clrcall] = ACTIONS(4571),
    [anon_sym___stdcall] = ACTIONS(4571),
    [anon_sym___fastcall] = ACTIONS(4571),
    [anon_sym___thiscall] = ACTIONS(4571),
    [anon_sym___vectorcall] = ACTIONS(4571),
    [anon_sym_LBRACE] = ACTIONS(4573),
    [anon_sym_RBRACE] = ACTIONS(4573),
    [anon_sym_LBRACK] = ACTIONS(4571),
    [anon_sym_EQ] = ACTIONS(4571),
    [anon_sym_static] = ACTIONS(4571),
    [anon_sym_register] = ACTIONS(4571),
    [anon_sym_inline] = ACTIONS(4571),
    [anon_sym___inline] = ACTIONS(4571),
    [anon_sym___inline__] = ACTIONS(4571),
    [anon_sym___forceinline] = ACTIONS(4571),
    [anon_sym_thread_local] = ACTIONS(4571),
    [anon_sym___thread] = ACTIONS(4571),
    [anon_sym_const] = ACTIONS(4571),
    [anon_sym_constexpr] = ACTIONS(4571),
    [anon_sym_volatile] = ACTIONS(4571),
    [anon_sym_restrict] = ACTIONS(4571),
    [anon_sym___restrict__] = ACTIONS(4571),
    [anon_sym__Atomic] = ACTIONS(4571),
    [anon_sym__Noreturn] = ACTIONS(4571),
    [anon_sym_noreturn] = ACTIONS(4571),
    [anon_sym_mutable] = ACTIONS(4571),
    [anon_sym_constinit] = ACTIONS(4571),
    [anon_sym_consteval] = ACTIONS(4571),
    [anon_sym_PROGMEM] = ACTIONS(4571),
    [anon_sym_COLON] = ACTIONS(4571),
    [anon_sym_QMARK] = ACTIONS(4573),
    [anon_sym_LT_EQ_GT] = ACTIONS(4573),
    [anon_sym_or] = ACTIONS(4571),
    [anon_sym_and] = ACTIONS(4571),
    [anon_sym_bitor] = ACTIONS(4571),
    [anon_sym_xor] = ACTIONS(4571),
    [anon_sym_bitand] = ACTIONS(4571),
    [anon_sym_not_eq] = ACTIONS(4571),
    [anon_sym_DASH_DASH] = ACTIONS(4573),
    [anon_sym_PLUS_PLUS] = ACTIONS(4573),
    [anon_sym_DOT] = ACTIONS(4571),
    [anon_sym_DOT_STAR] = ACTIONS(4573),
    [anon_sym_DASH_GT] = ACTIONS(4573),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4571),
    [anon_sym_decltype] = ACTIONS(4571),
    [anon_sym_final] = ACTIONS(4571),
    [anon_sym_override] = ACTIONS(4571),
    [anon_sym_virtual] = ACTIONS(4571),
    [anon_sym_alignas] = ACTIONS(4571),
    [anon_sym_template] = ACTIONS(4571),
    [anon_sym_operator] = ACTIONS(4571),
    [anon_sym_try] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4571),
  },
  [1720] = {
    [sym_string_literal] = STATE(3396),
    [sym_template_argument_list] = STATE(3068),
    [sym_raw_string_literal] = STATE(3396),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2537),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3774),
    [anon_sym_COMMA] = ACTIONS(3774),
    [anon_sym_LPAREN2] = ACTIONS(3774),
    [anon_sym_DASH] = ACTIONS(3769),
    [anon_sym_PLUS] = ACTIONS(3769),
    [anon_sym_STAR] = ACTIONS(3771),
    [anon_sym_SLASH] = ACTIONS(3769),
    [anon_sym_PERCENT] = ACTIONS(3769),
    [anon_sym_PIPE_PIPE] = ACTIONS(3761),
    [anon_sym_AMP_AMP] = ACTIONS(3774),
    [anon_sym_PIPE] = ACTIONS(3769),
    [anon_sym_CARET] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(3771),
    [anon_sym_EQ_EQ] = ACTIONS(3761),
    [anon_sym_BANG_EQ] = ACTIONS(3761),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3769),
    [anon_sym_LT_EQ] = ACTIONS(3769),
    [anon_sym_LT] = ACTIONS(4612),
    [anon_sym_LT_LT] = ACTIONS(3769),
    [anon_sym_GT_GT] = ACTIONS(3769),
    [anon_sym___extension__] = ACTIONS(3767),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(3785),
    [anon_sym_signed] = ACTIONS(4615),
    [anon_sym_unsigned] = ACTIONS(4615),
    [anon_sym_long] = ACTIONS(4615),
    [anon_sym_short] = ACTIONS(4615),
    [anon_sym_LBRACK] = ACTIONS(3774),
    [anon_sym_EQ] = ACTIONS(4617),
    [anon_sym_const] = ACTIONS(3759),
    [anon_sym_constexpr] = ACTIONS(3767),
    [anon_sym_volatile] = ACTIONS(3767),
    [anon_sym_restrict] = ACTIONS(3767),
    [anon_sym___restrict__] = ACTIONS(3767),
    [anon_sym__Atomic] = ACTIONS(3767),
    [anon_sym__Noreturn] = ACTIONS(3767),
    [anon_sym_noreturn] = ACTIONS(3767),
    [anon_sym_mutable] = ACTIONS(3767),
    [anon_sym_constinit] = ACTIONS(3767),
    [anon_sym_consteval] = ACTIONS(3767),
    [anon_sym_PROGMEM] = ACTIONS(3767),
    [anon_sym_QMARK] = ACTIONS(3761),
    [anon_sym_STAR_EQ] = ACTIONS(4619),
    [anon_sym_SLASH_EQ] = ACTIONS(4619),
    [anon_sym_PERCENT_EQ] = ACTIONS(4619),
    [anon_sym_PLUS_EQ] = ACTIONS(4619),
    [anon_sym_DASH_EQ] = ACTIONS(4619),
    [anon_sym_LT_LT_EQ] = ACTIONS(4619),
    [anon_sym_GT_GT_EQ] = ACTIONS(4617),
    [anon_sym_AMP_EQ] = ACTIONS(4619),
    [anon_sym_CARET_EQ] = ACTIONS(4619),
    [anon_sym_PIPE_EQ] = ACTIONS(4619),
    [anon_sym_and_eq] = ACTIONS(4619),
    [anon_sym_or_eq] = ACTIONS(4619),
    [anon_sym_xor_eq] = ACTIONS(4619),
    [anon_sym_LT_EQ_GT] = ACTIONS(3761),
    [anon_sym_or] = ACTIONS(3769),
    [anon_sym_and] = ACTIONS(3769),
    [anon_sym_bitor] = ACTIONS(3761),
    [anon_sym_xor] = ACTIONS(3769),
    [anon_sym_bitand] = ACTIONS(3761),
    [anon_sym_not_eq] = ACTIONS(3761),
    [anon_sym_DASH_DASH] = ACTIONS(3761),
    [anon_sym_PLUS_PLUS] = ACTIONS(3761),
    [anon_sym_DOT] = ACTIONS(3769),
    [anon_sym_DOT_STAR] = ACTIONS(3761),
    [anon_sym_DASH_GT] = ACTIONS(3761),
    [anon_sym_L_DQUOTE] = ACTIONS(4621),
    [anon_sym_u_DQUOTE] = ACTIONS(4621),
    [anon_sym_U_DQUOTE] = ACTIONS(4621),
    [anon_sym_u8_DQUOTE] = ACTIONS(4621),
    [anon_sym_DQUOTE] = ACTIONS(4621),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3767),
    [anon_sym_decltype] = ACTIONS(3767),
    [anon_sym_GT2] = ACTIONS(3774),
    [anon_sym_R_DQUOTE] = ACTIONS(4623),
    [anon_sym_LR_DQUOTE] = ACTIONS(4623),
    [anon_sym_uR_DQUOTE] = ACTIONS(4623),
    [anon_sym_UR_DQUOTE] = ACTIONS(4623),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4623),
  },
  [1721] = {
    [sym_identifier] = ACTIONS(4551),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4553),
    [anon_sym_COMMA] = ACTIONS(4553),
    [anon_sym_RPAREN] = ACTIONS(4553),
    [anon_sym_LPAREN2] = ACTIONS(4553),
    [anon_sym_TILDE] = ACTIONS(4553),
    [anon_sym_DASH] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(4551),
    [anon_sym_STAR] = ACTIONS(4551),
    [anon_sym_SLASH] = ACTIONS(4551),
    [anon_sym_PERCENT] = ACTIONS(4551),
    [anon_sym_PIPE_PIPE] = ACTIONS(4553),
    [anon_sym_AMP_AMP] = ACTIONS(4553),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4551),
    [anon_sym_AMP] = ACTIONS(4551),
    [anon_sym_EQ_EQ] = ACTIONS(4553),
    [anon_sym_BANG_EQ] = ACTIONS(4553),
    [anon_sym_GT] = ACTIONS(4551),
    [anon_sym_GT_EQ] = ACTIONS(4553),
    [anon_sym_LT_EQ] = ACTIONS(4551),
    [anon_sym_LT] = ACTIONS(4551),
    [anon_sym_LT_LT] = ACTIONS(4551),
    [anon_sym_GT_GT] = ACTIONS(4551),
    [anon_sym___extension__] = ACTIONS(4551),
    [anon_sym_extern] = ACTIONS(4551),
    [anon_sym___attribute__] = ACTIONS(4551),
    [anon_sym_COLON_COLON] = ACTIONS(4553),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4553),
    [anon_sym___declspec] = ACTIONS(4551),
    [anon_sym___based] = ACTIONS(4551),
    [anon_sym_LBRACE] = ACTIONS(4553),
    [anon_sym_LBRACK] = ACTIONS(4551),
    [anon_sym_EQ] = ACTIONS(4551),
    [anon_sym_static] = ACTIONS(4551),
    [anon_sym_register] = ACTIONS(4551),
    [anon_sym_inline] = ACTIONS(4551),
    [anon_sym___inline] = ACTIONS(4551),
    [anon_sym___inline__] = ACTIONS(4551),
    [anon_sym___forceinline] = ACTIONS(4551),
    [anon_sym_thread_local] = ACTIONS(4551),
    [anon_sym___thread] = ACTIONS(4551),
    [anon_sym_const] = ACTIONS(4551),
    [anon_sym_constexpr] = ACTIONS(4551),
    [anon_sym_volatile] = ACTIONS(4551),
    [anon_sym_restrict] = ACTIONS(4551),
    [anon_sym___restrict__] = ACTIONS(4551),
    [anon_sym__Atomic] = ACTIONS(4551),
    [anon_sym__Noreturn] = ACTIONS(4551),
    [anon_sym_noreturn] = ACTIONS(4551),
    [anon_sym_mutable] = ACTIONS(4551),
    [anon_sym_constinit] = ACTIONS(4551),
    [anon_sym_consteval] = ACTIONS(4551),
    [anon_sym_PROGMEM] = ACTIONS(4551),
    [anon_sym_QMARK] = ACTIONS(4553),
    [anon_sym_STAR_EQ] = ACTIONS(4553),
    [anon_sym_SLASH_EQ] = ACTIONS(4553),
    [anon_sym_PERCENT_EQ] = ACTIONS(4553),
    [anon_sym_PLUS_EQ] = ACTIONS(4553),
    [anon_sym_DASH_EQ] = ACTIONS(4553),
    [anon_sym_LT_LT_EQ] = ACTIONS(4553),
    [anon_sym_GT_GT_EQ] = ACTIONS(4553),
    [anon_sym_AMP_EQ] = ACTIONS(4553),
    [anon_sym_CARET_EQ] = ACTIONS(4553),
    [anon_sym_PIPE_EQ] = ACTIONS(4553),
    [anon_sym_LT_EQ_GT] = ACTIONS(4553),
    [anon_sym_or] = ACTIONS(4551),
    [anon_sym_and] = ACTIONS(4551),
    [anon_sym_bitor] = ACTIONS(4551),
    [anon_sym_xor] = ACTIONS(4551),
    [anon_sym_bitand] = ACTIONS(4551),
    [anon_sym_not_eq] = ACTIONS(4551),
    [anon_sym_DASH_DASH] = ACTIONS(4553),
    [anon_sym_PLUS_PLUS] = ACTIONS(4553),
    [anon_sym_DOT] = ACTIONS(4551),
    [anon_sym_DOT_STAR] = ACTIONS(4553),
    [anon_sym_DASH_GT] = ACTIONS(4551),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4551),
    [anon_sym_decltype] = ACTIONS(4551),
    [anon_sym_virtual] = ACTIONS(4551),
    [anon_sym_alignas] = ACTIONS(4551),
    [anon_sym_template] = ACTIONS(4551),
    [anon_sym_operator] = ACTIONS(4551),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4553),
  },
  [1722] = {
    [sym_identifier] = ACTIONS(4530),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4532),
    [anon_sym_COMMA] = ACTIONS(4532),
    [anon_sym_RPAREN] = ACTIONS(4532),
    [anon_sym_LPAREN2] = ACTIONS(4532),
    [anon_sym_TILDE] = ACTIONS(4532),
    [anon_sym_DASH] = ACTIONS(4530),
    [anon_sym_PLUS] = ACTIONS(4530),
    [anon_sym_STAR] = ACTIONS(4530),
    [anon_sym_SLASH] = ACTIONS(4530),
    [anon_sym_PERCENT] = ACTIONS(4530),
    [anon_sym_PIPE_PIPE] = ACTIONS(4532),
    [anon_sym_AMP_AMP] = ACTIONS(4532),
    [anon_sym_PIPE] = ACTIONS(4530),
    [anon_sym_CARET] = ACTIONS(4530),
    [anon_sym_AMP] = ACTIONS(4530),
    [anon_sym_EQ_EQ] = ACTIONS(4532),
    [anon_sym_BANG_EQ] = ACTIONS(4532),
    [anon_sym_GT] = ACTIONS(4530),
    [anon_sym_GT_EQ] = ACTIONS(4532),
    [anon_sym_LT_EQ] = ACTIONS(4530),
    [anon_sym_LT] = ACTIONS(4530),
    [anon_sym_LT_LT] = ACTIONS(4530),
    [anon_sym_GT_GT] = ACTIONS(4530),
    [anon_sym___extension__] = ACTIONS(4530),
    [anon_sym_extern] = ACTIONS(4530),
    [anon_sym___attribute__] = ACTIONS(4530),
    [anon_sym_COLON_COLON] = ACTIONS(4532),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4532),
    [anon_sym___declspec] = ACTIONS(4530),
    [anon_sym___based] = ACTIONS(4530),
    [anon_sym_LBRACE] = ACTIONS(4532),
    [anon_sym_LBRACK] = ACTIONS(4530),
    [anon_sym_EQ] = ACTIONS(4530),
    [anon_sym_static] = ACTIONS(4530),
    [anon_sym_register] = ACTIONS(4530),
    [anon_sym_inline] = ACTIONS(4530),
    [anon_sym___inline] = ACTIONS(4530),
    [anon_sym___inline__] = ACTIONS(4530),
    [anon_sym___forceinline] = ACTIONS(4530),
    [anon_sym_thread_local] = ACTIONS(4530),
    [anon_sym___thread] = ACTIONS(4530),
    [anon_sym_const] = ACTIONS(4530),
    [anon_sym_constexpr] = ACTIONS(4530),
    [anon_sym_volatile] = ACTIONS(4530),
    [anon_sym_restrict] = ACTIONS(4530),
    [anon_sym___restrict__] = ACTIONS(4530),
    [anon_sym__Atomic] = ACTIONS(4530),
    [anon_sym__Noreturn] = ACTIONS(4530),
    [anon_sym_noreturn] = ACTIONS(4530),
    [anon_sym_mutable] = ACTIONS(4530),
    [anon_sym_constinit] = ACTIONS(4530),
    [anon_sym_consteval] = ACTIONS(4530),
    [anon_sym_PROGMEM] = ACTIONS(4530),
    [anon_sym_QMARK] = ACTIONS(4532),
    [anon_sym_STAR_EQ] = ACTIONS(4532),
    [anon_sym_SLASH_EQ] = ACTIONS(4532),
    [anon_sym_PERCENT_EQ] = ACTIONS(4532),
    [anon_sym_PLUS_EQ] = ACTIONS(4532),
    [anon_sym_DASH_EQ] = ACTIONS(4532),
    [anon_sym_LT_LT_EQ] = ACTIONS(4532),
    [anon_sym_GT_GT_EQ] = ACTIONS(4532),
    [anon_sym_AMP_EQ] = ACTIONS(4532),
    [anon_sym_CARET_EQ] = ACTIONS(4532),
    [anon_sym_PIPE_EQ] = ACTIONS(4532),
    [anon_sym_LT_EQ_GT] = ACTIONS(4532),
    [anon_sym_or] = ACTIONS(4530),
    [anon_sym_and] = ACTIONS(4530),
    [anon_sym_bitor] = ACTIONS(4530),
    [anon_sym_xor] = ACTIONS(4530),
    [anon_sym_bitand] = ACTIONS(4530),
    [anon_sym_not_eq] = ACTIONS(4530),
    [anon_sym_DASH_DASH] = ACTIONS(4532),
    [anon_sym_PLUS_PLUS] = ACTIONS(4532),
    [anon_sym_DOT] = ACTIONS(4530),
    [anon_sym_DOT_STAR] = ACTIONS(4532),
    [anon_sym_DASH_GT] = ACTIONS(4530),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4530),
    [anon_sym_decltype] = ACTIONS(4530),
    [anon_sym_virtual] = ACTIONS(4530),
    [anon_sym_alignas] = ACTIONS(4530),
    [anon_sym_template] = ACTIONS(4530),
    [anon_sym_operator] = ACTIONS(4530),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4532),
  },
  [1723] = {
    [sym_identifier] = ACTIONS(4571),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4573),
    [anon_sym_COMMA] = ACTIONS(4573),
    [anon_sym_RPAREN] = ACTIONS(4573),
    [anon_sym_LPAREN2] = ACTIONS(4573),
    [anon_sym_TILDE] = ACTIONS(4573),
    [anon_sym_DASH] = ACTIONS(4571),
    [anon_sym_PLUS] = ACTIONS(4571),
    [anon_sym_STAR] = ACTIONS(4571),
    [anon_sym_SLASH] = ACTIONS(4571),
    [anon_sym_PERCENT] = ACTIONS(4571),
    [anon_sym_PIPE_PIPE] = ACTIONS(4573),
    [anon_sym_AMP_AMP] = ACTIONS(4573),
    [anon_sym_PIPE] = ACTIONS(4571),
    [anon_sym_CARET] = ACTIONS(4571),
    [anon_sym_AMP] = ACTIONS(4571),
    [anon_sym_EQ_EQ] = ACTIONS(4573),
    [anon_sym_BANG_EQ] = ACTIONS(4573),
    [anon_sym_GT] = ACTIONS(4571),
    [anon_sym_GT_EQ] = ACTIONS(4573),
    [anon_sym_LT_EQ] = ACTIONS(4571),
    [anon_sym_LT] = ACTIONS(4571),
    [anon_sym_LT_LT] = ACTIONS(4571),
    [anon_sym_GT_GT] = ACTIONS(4571),
    [anon_sym___extension__] = ACTIONS(4571),
    [anon_sym_extern] = ACTIONS(4571),
    [anon_sym___attribute__] = ACTIONS(4571),
    [anon_sym_COLON_COLON] = ACTIONS(4573),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4573),
    [anon_sym___declspec] = ACTIONS(4571),
    [anon_sym___based] = ACTIONS(4571),
    [anon_sym_LBRACE] = ACTIONS(4573),
    [anon_sym_LBRACK] = ACTIONS(4571),
    [anon_sym_EQ] = ACTIONS(4571),
    [anon_sym_static] = ACTIONS(4571),
    [anon_sym_register] = ACTIONS(4571),
    [anon_sym_inline] = ACTIONS(4571),
    [anon_sym___inline] = ACTIONS(4571),
    [anon_sym___inline__] = ACTIONS(4571),
    [anon_sym___forceinline] = ACTIONS(4571),
    [anon_sym_thread_local] = ACTIONS(4571),
    [anon_sym___thread] = ACTIONS(4571),
    [anon_sym_const] = ACTIONS(4571),
    [anon_sym_constexpr] = ACTIONS(4571),
    [anon_sym_volatile] = ACTIONS(4571),
    [anon_sym_restrict] = ACTIONS(4571),
    [anon_sym___restrict__] = ACTIONS(4571),
    [anon_sym__Atomic] = ACTIONS(4571),
    [anon_sym__Noreturn] = ACTIONS(4571),
    [anon_sym_noreturn] = ACTIONS(4571),
    [anon_sym_mutable] = ACTIONS(4571),
    [anon_sym_constinit] = ACTIONS(4571),
    [anon_sym_consteval] = ACTIONS(4571),
    [anon_sym_PROGMEM] = ACTIONS(4571),
    [anon_sym_QMARK] = ACTIONS(4573),
    [anon_sym_STAR_EQ] = ACTIONS(4573),
    [anon_sym_SLASH_EQ] = ACTIONS(4573),
    [anon_sym_PERCENT_EQ] = ACTIONS(4573),
    [anon_sym_PLUS_EQ] = ACTIONS(4573),
    [anon_sym_DASH_EQ] = ACTIONS(4573),
    [anon_sym_LT_LT_EQ] = ACTIONS(4573),
    [anon_sym_GT_GT_EQ] = ACTIONS(4573),
    [anon_sym_AMP_EQ] = ACTIONS(4573),
    [anon_sym_CARET_EQ] = ACTIONS(4573),
    [anon_sym_PIPE_EQ] = ACTIONS(4573),
    [anon_sym_LT_EQ_GT] = ACTIONS(4573),
    [anon_sym_or] = ACTIONS(4571),
    [anon_sym_and] = ACTIONS(4571),
    [anon_sym_bitor] = ACTIONS(4571),
    [anon_sym_xor] = ACTIONS(4571),
    [anon_sym_bitand] = ACTIONS(4571),
    [anon_sym_not_eq] = ACTIONS(4571),
    [anon_sym_DASH_DASH] = ACTIONS(4573),
    [anon_sym_PLUS_PLUS] = ACTIONS(4573),
    [anon_sym_DOT] = ACTIONS(4571),
    [anon_sym_DOT_STAR] = ACTIONS(4573),
    [anon_sym_DASH_GT] = ACTIONS(4571),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4571),
    [anon_sym_decltype] = ACTIONS(4571),
    [anon_sym_virtual] = ACTIONS(4571),
    [anon_sym_alignas] = ACTIONS(4571),
    [anon_sym_template] = ACTIONS(4571),
    [anon_sym_operator] = ACTIONS(4571),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4573),
  },
  [1724] = {
    [sym_identifier] = ACTIONS(4563),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4565),
    [anon_sym_COMMA] = ACTIONS(4565),
    [anon_sym_RPAREN] = ACTIONS(4565),
    [anon_sym_LPAREN2] = ACTIONS(4565),
    [anon_sym_TILDE] = ACTIONS(4565),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_STAR] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4563),
    [anon_sym_PERCENT] = ACTIONS(4563),
    [anon_sym_PIPE_PIPE] = ACTIONS(4565),
    [anon_sym_AMP_AMP] = ACTIONS(4565),
    [anon_sym_PIPE] = ACTIONS(4563),
    [anon_sym_CARET] = ACTIONS(4563),
    [anon_sym_AMP] = ACTIONS(4563),
    [anon_sym_EQ_EQ] = ACTIONS(4565),
    [anon_sym_BANG_EQ] = ACTIONS(4565),
    [anon_sym_GT] = ACTIONS(4563),
    [anon_sym_GT_EQ] = ACTIONS(4565),
    [anon_sym_LT_EQ] = ACTIONS(4563),
    [anon_sym_LT] = ACTIONS(4563),
    [anon_sym_LT_LT] = ACTIONS(4563),
    [anon_sym_GT_GT] = ACTIONS(4563),
    [anon_sym___extension__] = ACTIONS(4563),
    [anon_sym_extern] = ACTIONS(4563),
    [anon_sym___attribute__] = ACTIONS(4563),
    [anon_sym_COLON_COLON] = ACTIONS(4565),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4565),
    [anon_sym___declspec] = ACTIONS(4563),
    [anon_sym___based] = ACTIONS(4563),
    [anon_sym_LBRACE] = ACTIONS(4565),
    [anon_sym_LBRACK] = ACTIONS(4563),
    [anon_sym_EQ] = ACTIONS(4563),
    [anon_sym_static] = ACTIONS(4563),
    [anon_sym_register] = ACTIONS(4563),
    [anon_sym_inline] = ACTIONS(4563),
    [anon_sym___inline] = ACTIONS(4563),
    [anon_sym___inline__] = ACTIONS(4563),
    [anon_sym___forceinline] = ACTIONS(4563),
    [anon_sym_thread_local] = ACTIONS(4563),
    [anon_sym___thread] = ACTIONS(4563),
    [anon_sym_const] = ACTIONS(4563),
    [anon_sym_constexpr] = ACTIONS(4563),
    [anon_sym_volatile] = ACTIONS(4563),
    [anon_sym_restrict] = ACTIONS(4563),
    [anon_sym___restrict__] = ACTIONS(4563),
    [anon_sym__Atomic] = ACTIONS(4563),
    [anon_sym__Noreturn] = ACTIONS(4563),
    [anon_sym_noreturn] = ACTIONS(4563),
    [anon_sym_mutable] = ACTIONS(4563),
    [anon_sym_constinit] = ACTIONS(4563),
    [anon_sym_consteval] = ACTIONS(4563),
    [anon_sym_PROGMEM] = ACTIONS(4563),
    [anon_sym_QMARK] = ACTIONS(4565),
    [anon_sym_STAR_EQ] = ACTIONS(4565),
    [anon_sym_SLASH_EQ] = ACTIONS(4565),
    [anon_sym_PERCENT_EQ] = ACTIONS(4565),
    [anon_sym_PLUS_EQ] = ACTIONS(4565),
    [anon_sym_DASH_EQ] = ACTIONS(4565),
    [anon_sym_LT_LT_EQ] = ACTIONS(4565),
    [anon_sym_GT_GT_EQ] = ACTIONS(4565),
    [anon_sym_AMP_EQ] = ACTIONS(4565),
    [anon_sym_CARET_EQ] = ACTIONS(4565),
    [anon_sym_PIPE_EQ] = ACTIONS(4565),
    [anon_sym_LT_EQ_GT] = ACTIONS(4565),
    [anon_sym_or] = ACTIONS(4563),
    [anon_sym_and] = ACTIONS(4563),
    [anon_sym_bitor] = ACTIONS(4563),
    [anon_sym_xor] = ACTIONS(4563),
    [anon_sym_bitand] = ACTIONS(4563),
    [anon_sym_not_eq] = ACTIONS(4563),
    [anon_sym_DASH_DASH] = ACTIONS(4565),
    [anon_sym_PLUS_PLUS] = ACTIONS(4565),
    [anon_sym_DOT] = ACTIONS(4563),
    [anon_sym_DOT_STAR] = ACTIONS(4565),
    [anon_sym_DASH_GT] = ACTIONS(4563),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4563),
    [anon_sym_decltype] = ACTIONS(4563),
    [anon_sym_virtual] = ACTIONS(4563),
    [anon_sym_alignas] = ACTIONS(4563),
    [anon_sym_template] = ACTIONS(4563),
    [anon_sym_operator] = ACTIONS(4563),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4565),
  },
  [1725] = {
    [sym_identifier] = ACTIONS(4567),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4569),
    [anon_sym_COMMA] = ACTIONS(4569),
    [anon_sym_RPAREN] = ACTIONS(4569),
    [anon_sym_LPAREN2] = ACTIONS(4569),
    [anon_sym_TILDE] = ACTIONS(4569),
    [anon_sym_DASH] = ACTIONS(4567),
    [anon_sym_PLUS] = ACTIONS(4567),
    [anon_sym_STAR] = ACTIONS(4567),
    [anon_sym_SLASH] = ACTIONS(4567),
    [anon_sym_PERCENT] = ACTIONS(4567),
    [anon_sym_PIPE_PIPE] = ACTIONS(4569),
    [anon_sym_AMP_AMP] = ACTIONS(4569),
    [anon_sym_PIPE] = ACTIONS(4567),
    [anon_sym_CARET] = ACTIONS(4567),
    [anon_sym_AMP] = ACTIONS(4567),
    [anon_sym_EQ_EQ] = ACTIONS(4569),
    [anon_sym_BANG_EQ] = ACTIONS(4569),
    [anon_sym_GT] = ACTIONS(4567),
    [anon_sym_GT_EQ] = ACTIONS(4569),
    [anon_sym_LT_EQ] = ACTIONS(4567),
    [anon_sym_LT] = ACTIONS(4567),
    [anon_sym_LT_LT] = ACTIONS(4567),
    [anon_sym_GT_GT] = ACTIONS(4567),
    [anon_sym___extension__] = ACTIONS(4567),
    [anon_sym_extern] = ACTIONS(4567),
    [anon_sym___attribute__] = ACTIONS(4567),
    [anon_sym_COLON_COLON] = ACTIONS(4569),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4569),
    [anon_sym___declspec] = ACTIONS(4567),
    [anon_sym___based] = ACTIONS(4567),
    [anon_sym_LBRACE] = ACTIONS(4569),
    [anon_sym_LBRACK] = ACTIONS(4567),
    [anon_sym_EQ] = ACTIONS(4567),
    [anon_sym_static] = ACTIONS(4567),
    [anon_sym_register] = ACTIONS(4567),
    [anon_sym_inline] = ACTIONS(4567),
    [anon_sym___inline] = ACTIONS(4567),
    [anon_sym___inline__] = ACTIONS(4567),
    [anon_sym___forceinline] = ACTIONS(4567),
    [anon_sym_thread_local] = ACTIONS(4567),
    [anon_sym___thread] = ACTIONS(4567),
    [anon_sym_const] = ACTIONS(4567),
    [anon_sym_constexpr] = ACTIONS(4567),
    [anon_sym_volatile] = ACTIONS(4567),
    [anon_sym_restrict] = ACTIONS(4567),
    [anon_sym___restrict__] = ACTIONS(4567),
    [anon_sym__Atomic] = ACTIONS(4567),
    [anon_sym__Noreturn] = ACTIONS(4567),
    [anon_sym_noreturn] = ACTIONS(4567),
    [anon_sym_mutable] = ACTIONS(4567),
    [anon_sym_constinit] = ACTIONS(4567),
    [anon_sym_consteval] = ACTIONS(4567),
    [anon_sym_PROGMEM] = ACTIONS(4567),
    [anon_sym_QMARK] = ACTIONS(4569),
    [anon_sym_STAR_EQ] = ACTIONS(4569),
    [anon_sym_SLASH_EQ] = ACTIONS(4569),
    [anon_sym_PERCENT_EQ] = ACTIONS(4569),
    [anon_sym_PLUS_EQ] = ACTIONS(4569),
    [anon_sym_DASH_EQ] = ACTIONS(4569),
    [anon_sym_LT_LT_EQ] = ACTIONS(4569),
    [anon_sym_GT_GT_EQ] = ACTIONS(4569),
    [anon_sym_AMP_EQ] = ACTIONS(4569),
    [anon_sym_CARET_EQ] = ACTIONS(4569),
    [anon_sym_PIPE_EQ] = ACTIONS(4569),
    [anon_sym_LT_EQ_GT] = ACTIONS(4569),
    [anon_sym_or] = ACTIONS(4567),
    [anon_sym_and] = ACTIONS(4567),
    [anon_sym_bitor] = ACTIONS(4567),
    [anon_sym_xor] = ACTIONS(4567),
    [anon_sym_bitand] = ACTIONS(4567),
    [anon_sym_not_eq] = ACTIONS(4567),
    [anon_sym_DASH_DASH] = ACTIONS(4569),
    [anon_sym_PLUS_PLUS] = ACTIONS(4569),
    [anon_sym_DOT] = ACTIONS(4567),
    [anon_sym_DOT_STAR] = ACTIONS(4569),
    [anon_sym_DASH_GT] = ACTIONS(4567),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4567),
    [anon_sym_decltype] = ACTIONS(4567),
    [anon_sym_virtual] = ACTIONS(4567),
    [anon_sym_alignas] = ACTIONS(4567),
    [anon_sym_template] = ACTIONS(4567),
    [anon_sym_operator] = ACTIONS(4567),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4569),
  },
  [1726] = {
    [sym_identifier] = ACTIONS(4575),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4579),
    [anon_sym_COMMA] = ACTIONS(4579),
    [anon_sym_RPAREN] = ACTIONS(4579),
    [anon_sym_LPAREN2] = ACTIONS(4579),
    [anon_sym_TILDE] = ACTIONS(4582),
    [anon_sym_DASH] = ACTIONS(4584),
    [anon_sym_PLUS] = ACTIONS(4584),
    [anon_sym_STAR] = ACTIONS(4586),
    [anon_sym_SLASH] = ACTIONS(4584),
    [anon_sym_PERCENT] = ACTIONS(4584),
    [anon_sym_PIPE_PIPE] = ACTIONS(4577),
    [anon_sym_AMP_AMP] = ACTIONS(4579),
    [anon_sym_PIPE] = ACTIONS(4584),
    [anon_sym_CARET] = ACTIONS(4584),
    [anon_sym_AMP] = ACTIONS(4586),
    [anon_sym_EQ_EQ] = ACTIONS(4577),
    [anon_sym_BANG_EQ] = ACTIONS(4577),
    [anon_sym_GT] = ACTIONS(4584),
    [anon_sym_GT_EQ] = ACTIONS(4577),
    [anon_sym_LT_EQ] = ACTIONS(4584),
    [anon_sym_LT] = ACTIONS(4584),
    [anon_sym_LT_LT] = ACTIONS(4584),
    [anon_sym_GT_GT] = ACTIONS(4584),
    [anon_sym___extension__] = ACTIONS(4575),
    [anon_sym_extern] = ACTIONS(4575),
    [anon_sym___attribute__] = ACTIONS(4575),
    [anon_sym_COLON_COLON] = ACTIONS(4582),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4582),
    [anon_sym___declspec] = ACTIONS(4575),
    [anon_sym___based] = ACTIONS(4575),
    [anon_sym_LBRACE] = ACTIONS(4582),
    [anon_sym_LBRACK] = ACTIONS(4586),
    [anon_sym_EQ] = ACTIONS(4586),
    [anon_sym_static] = ACTIONS(4575),
    [anon_sym_register] = ACTIONS(4575),
    [anon_sym_inline] = ACTIONS(4575),
    [anon_sym___inline] = ACTIONS(4575),
    [anon_sym___inline__] = ACTIONS(4575),
    [anon_sym___forceinline] = ACTIONS(4575),
    [anon_sym_thread_local] = ACTIONS(4575),
    [anon_sym___thread] = ACTIONS(4575),
    [anon_sym_const] = ACTIONS(4575),
    [anon_sym_constexpr] = ACTIONS(4575),
    [anon_sym_volatile] = ACTIONS(4575),
    [anon_sym_restrict] = ACTIONS(4575),
    [anon_sym___restrict__] = ACTIONS(4575),
    [anon_sym__Atomic] = ACTIONS(4575),
    [anon_sym__Noreturn] = ACTIONS(4575),
    [anon_sym_noreturn] = ACTIONS(4575),
    [anon_sym_mutable] = ACTIONS(4575),
    [anon_sym_constinit] = ACTIONS(4575),
    [anon_sym_consteval] = ACTIONS(4575),
    [anon_sym_PROGMEM] = ACTIONS(4575),
    [anon_sym_QMARK] = ACTIONS(4577),
    [anon_sym_STAR_EQ] = ACTIONS(4577),
    [anon_sym_SLASH_EQ] = ACTIONS(4577),
    [anon_sym_PERCENT_EQ] = ACTIONS(4577),
    [anon_sym_PLUS_EQ] = ACTIONS(4577),
    [anon_sym_DASH_EQ] = ACTIONS(4577),
    [anon_sym_LT_LT_EQ] = ACTIONS(4577),
    [anon_sym_GT_GT_EQ] = ACTIONS(4577),
    [anon_sym_AMP_EQ] = ACTIONS(4577),
    [anon_sym_CARET_EQ] = ACTIONS(4577),
    [anon_sym_PIPE_EQ] = ACTIONS(4577),
    [anon_sym_LT_EQ_GT] = ACTIONS(4577),
    [anon_sym_or] = ACTIONS(4584),
    [anon_sym_and] = ACTIONS(4584),
    [anon_sym_bitor] = ACTIONS(4584),
    [anon_sym_xor] = ACTIONS(4584),
    [anon_sym_bitand] = ACTIONS(4584),
    [anon_sym_not_eq] = ACTIONS(4584),
    [anon_sym_DASH_DASH] = ACTIONS(4577),
    [anon_sym_PLUS_PLUS] = ACTIONS(4577),
    [anon_sym_DOT] = ACTIONS(4584),
    [anon_sym_DOT_STAR] = ACTIONS(4577),
    [anon_sym_DASH_GT] = ACTIONS(4584),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4575),
    [anon_sym_decltype] = ACTIONS(4575),
    [anon_sym_virtual] = ACTIONS(4575),
    [anon_sym_alignas] = ACTIONS(4575),
    [anon_sym_template] = ACTIONS(4575),
    [anon_sym_operator] = ACTIONS(4575),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4577),
  },
  [1727] = {
    [sym_identifier] = ACTIONS(4555),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4557),
    [anon_sym_COMMA] = ACTIONS(4557),
    [anon_sym_RPAREN] = ACTIONS(4557),
    [anon_sym_LPAREN2] = ACTIONS(4557),
    [anon_sym_TILDE] = ACTIONS(4557),
    [anon_sym_DASH] = ACTIONS(4555),
    [anon_sym_PLUS] = ACTIONS(4555),
    [anon_sym_STAR] = ACTIONS(4555),
    [anon_sym_SLASH] = ACTIONS(4555),
    [anon_sym_PERCENT] = ACTIONS(4555),
    [anon_sym_PIPE_PIPE] = ACTIONS(4557),
    [anon_sym_AMP_AMP] = ACTIONS(4557),
    [anon_sym_PIPE] = ACTIONS(4555),
    [anon_sym_CARET] = ACTIONS(4555),
    [anon_sym_AMP] = ACTIONS(4555),
    [anon_sym_EQ_EQ] = ACTIONS(4557),
    [anon_sym_BANG_EQ] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4555),
    [anon_sym_GT_EQ] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4555),
    [anon_sym_LT_LT] = ACTIONS(4555),
    [anon_sym_GT_GT] = ACTIONS(4555),
    [anon_sym___extension__] = ACTIONS(4555),
    [anon_sym_extern] = ACTIONS(4555),
    [anon_sym___attribute__] = ACTIONS(4555),
    [anon_sym_COLON_COLON] = ACTIONS(4557),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4557),
    [anon_sym___declspec] = ACTIONS(4555),
    [anon_sym___based] = ACTIONS(4555),
    [anon_sym_LBRACE] = ACTIONS(4557),
    [anon_sym_LBRACK] = ACTIONS(4555),
    [anon_sym_EQ] = ACTIONS(4555),
    [anon_sym_static] = ACTIONS(4555),
    [anon_sym_register] = ACTIONS(4555),
    [anon_sym_inline] = ACTIONS(4555),
    [anon_sym___inline] = ACTIONS(4555),
    [anon_sym___inline__] = ACTIONS(4555),
    [anon_sym___forceinline] = ACTIONS(4555),
    [anon_sym_thread_local] = ACTIONS(4555),
    [anon_sym___thread] = ACTIONS(4555),
    [anon_sym_const] = ACTIONS(4555),
    [anon_sym_constexpr] = ACTIONS(4555),
    [anon_sym_volatile] = ACTIONS(4555),
    [anon_sym_restrict] = ACTIONS(4555),
    [anon_sym___restrict__] = ACTIONS(4555),
    [anon_sym__Atomic] = ACTIONS(4555),
    [anon_sym__Noreturn] = ACTIONS(4555),
    [anon_sym_noreturn] = ACTIONS(4555),
    [anon_sym_mutable] = ACTIONS(4555),
    [anon_sym_constinit] = ACTIONS(4555),
    [anon_sym_consteval] = ACTIONS(4555),
    [anon_sym_PROGMEM] = ACTIONS(4555),
    [anon_sym_QMARK] = ACTIONS(4557),
    [anon_sym_STAR_EQ] = ACTIONS(4557),
    [anon_sym_SLASH_EQ] = ACTIONS(4557),
    [anon_sym_PERCENT_EQ] = ACTIONS(4557),
    [anon_sym_PLUS_EQ] = ACTIONS(4557),
    [anon_sym_DASH_EQ] = ACTIONS(4557),
    [anon_sym_LT_LT_EQ] = ACTIONS(4557),
    [anon_sym_GT_GT_EQ] = ACTIONS(4557),
    [anon_sym_AMP_EQ] = ACTIONS(4557),
    [anon_sym_CARET_EQ] = ACTIONS(4557),
    [anon_sym_PIPE_EQ] = ACTIONS(4557),
    [anon_sym_LT_EQ_GT] = ACTIONS(4557),
    [anon_sym_or] = ACTIONS(4555),
    [anon_sym_and] = ACTIONS(4555),
    [anon_sym_bitor] = ACTIONS(4555),
    [anon_sym_xor] = ACTIONS(4555),
    [anon_sym_bitand] = ACTIONS(4555),
    [anon_sym_not_eq] = ACTIONS(4555),
    [anon_sym_DASH_DASH] = ACTIONS(4557),
    [anon_sym_PLUS_PLUS] = ACTIONS(4557),
    [anon_sym_DOT] = ACTIONS(4555),
    [anon_sym_DOT_STAR] = ACTIONS(4557),
    [anon_sym_DASH_GT] = ACTIONS(4555),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4555),
    [anon_sym_decltype] = ACTIONS(4555),
    [anon_sym_virtual] = ACTIONS(4555),
    [anon_sym_alignas] = ACTIONS(4555),
    [anon_sym_template] = ACTIONS(4555),
    [anon_sym_operator] = ACTIONS(4555),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4557),
  },
  [1728] = {
    [sym_identifier] = ACTIONS(4559),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4561),
    [anon_sym_COMMA] = ACTIONS(4561),
    [anon_sym_RPAREN] = ACTIONS(4561),
    [anon_sym_LPAREN2] = ACTIONS(4561),
    [anon_sym_TILDE] = ACTIONS(4561),
    [anon_sym_DASH] = ACTIONS(4559),
    [anon_sym_PLUS] = ACTIONS(4559),
    [anon_sym_STAR] = ACTIONS(4559),
    [anon_sym_SLASH] = ACTIONS(4559),
    [anon_sym_PERCENT] = ACTIONS(4559),
    [anon_sym_PIPE_PIPE] = ACTIONS(4561),
    [anon_sym_AMP_AMP] = ACTIONS(4561),
    [anon_sym_PIPE] = ACTIONS(4559),
    [anon_sym_CARET] = ACTIONS(4559),
    [anon_sym_AMP] = ACTIONS(4559),
    [anon_sym_EQ_EQ] = ACTIONS(4561),
    [anon_sym_BANG_EQ] = ACTIONS(4561),
    [anon_sym_GT] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4561),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_LT] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4559),
    [anon_sym_GT_GT] = ACTIONS(4559),
    [anon_sym___extension__] = ACTIONS(4559),
    [anon_sym_extern] = ACTIONS(4559),
    [anon_sym___attribute__] = ACTIONS(4559),
    [anon_sym_COLON_COLON] = ACTIONS(4561),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4561),
    [anon_sym___declspec] = ACTIONS(4559),
    [anon_sym___based] = ACTIONS(4559),
    [anon_sym_LBRACE] = ACTIONS(4561),
    [anon_sym_LBRACK] = ACTIONS(4559),
    [anon_sym_EQ] = ACTIONS(4559),
    [anon_sym_static] = ACTIONS(4559),
    [anon_sym_register] = ACTIONS(4559),
    [anon_sym_inline] = ACTIONS(4559),
    [anon_sym___inline] = ACTIONS(4559),
    [anon_sym___inline__] = ACTIONS(4559),
    [anon_sym___forceinline] = ACTIONS(4559),
    [anon_sym_thread_local] = ACTIONS(4559),
    [anon_sym___thread] = ACTIONS(4559),
    [anon_sym_const] = ACTIONS(4559),
    [anon_sym_constexpr] = ACTIONS(4559),
    [anon_sym_volatile] = ACTIONS(4559),
    [anon_sym_restrict] = ACTIONS(4559),
    [anon_sym___restrict__] = ACTIONS(4559),
    [anon_sym__Atomic] = ACTIONS(4559),
    [anon_sym__Noreturn] = ACTIONS(4559),
    [anon_sym_noreturn] = ACTIONS(4559),
    [anon_sym_mutable] = ACTIONS(4559),
    [anon_sym_constinit] = ACTIONS(4559),
    [anon_sym_consteval] = ACTIONS(4559),
    [anon_sym_PROGMEM] = ACTIONS(4559),
    [anon_sym_QMARK] = ACTIONS(4561),
    [anon_sym_STAR_EQ] = ACTIONS(4561),
    [anon_sym_SLASH_EQ] = ACTIONS(4561),
    [anon_sym_PERCENT_EQ] = ACTIONS(4561),
    [anon_sym_PLUS_EQ] = ACTIONS(4561),
    [anon_sym_DASH_EQ] = ACTIONS(4561),
    [anon_sym_LT_LT_EQ] = ACTIONS(4561),
    [anon_sym_GT_GT_EQ] = ACTIONS(4561),
    [anon_sym_AMP_EQ] = ACTIONS(4561),
    [anon_sym_CARET_EQ] = ACTIONS(4561),
    [anon_sym_PIPE_EQ] = ACTIONS(4561),
    [anon_sym_LT_EQ_GT] = ACTIONS(4561),
    [anon_sym_or] = ACTIONS(4559),
    [anon_sym_and] = ACTIONS(4559),
    [anon_sym_bitor] = ACTIONS(4559),
    [anon_sym_xor] = ACTIONS(4559),
    [anon_sym_bitand] = ACTIONS(4559),
    [anon_sym_not_eq] = ACTIONS(4559),
    [anon_sym_DASH_DASH] = ACTIONS(4561),
    [anon_sym_PLUS_PLUS] = ACTIONS(4561),
    [anon_sym_DOT] = ACTIONS(4559),
    [anon_sym_DOT_STAR] = ACTIONS(4561),
    [anon_sym_DASH_GT] = ACTIONS(4559),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4559),
    [anon_sym_decltype] = ACTIONS(4559),
    [anon_sym_virtual] = ACTIONS(4559),
    [anon_sym_alignas] = ACTIONS(4559),
    [anon_sym_template] = ACTIONS(4559),
    [anon_sym_operator] = ACTIONS(4559),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4561),
  },
  [1729] = {
    [sym_function_definition] = STATE(420),
    [sym_declaration] = STATE(420),
    [sym__declaration_modifiers] = STATE(1964),
    [sym__declaration_specifiers] = STATE(4637),
    [sym_attribute_specifier] = STATE(1964),
    [sym_attribute_declaration] = STATE(1964),
    [sym_ms_declspec_modifier] = STATE(1964),
    [sym_ms_call_modifier] = STATE(1849),
    [sym_declaration_list] = STATE(420),
    [sym_storage_class_specifier] = STATE(1964),
    [sym_type_qualifier] = STATE(1964),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(1964),
    [sym_alignas_specifier] = STATE(1964),
    [sym_dependent_type] = STATE(2629),
    [sym_template_type] = STATE(2618),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(6346),
    [sym_qualified_type_identifier] = STATE(3260),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [sym_identifier] = ACTIONS(4625),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4627),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(4629),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1419),
  },
  [1730] = {
    [sym_function_definition] = STATE(691),
    [sym_declaration] = STATE(691),
    [sym__declaration_modifiers] = STATE(1964),
    [sym__declaration_specifiers] = STATE(4602),
    [sym_attribute_specifier] = STATE(1964),
    [sym_attribute_declaration] = STATE(1964),
    [sym_ms_declspec_modifier] = STATE(1964),
    [sym_ms_call_modifier] = STATE(1850),
    [sym_declaration_list] = STATE(691),
    [sym_storage_class_specifier] = STATE(1964),
    [sym_type_qualifier] = STATE(1964),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(1964),
    [sym_alignas_specifier] = STATE(1964),
    [sym_dependent_type] = STATE(2629),
    [sym_template_type] = STATE(2618),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(6346),
    [sym_qualified_type_identifier] = STATE(3260),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [sym_identifier] = ACTIONS(4625),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4627),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(4631),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1419),
  },
  [1731] = {
    [sym_function_definition] = STATE(725),
    [sym_declaration] = STATE(725),
    [sym__declaration_modifiers] = STATE(1964),
    [sym__declaration_specifiers] = STATE(4541),
    [sym_attribute_specifier] = STATE(1964),
    [sym_attribute_declaration] = STATE(1964),
    [sym_ms_declspec_modifier] = STATE(1964),
    [sym_ms_call_modifier] = STATE(1925),
    [sym_declaration_list] = STATE(725),
    [sym_storage_class_specifier] = STATE(1964),
    [sym_type_qualifier] = STATE(1964),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(1964),
    [sym_alignas_specifier] = STATE(1964),
    [sym_dependent_type] = STATE(2629),
    [sym_template_type] = STATE(2618),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(6346),
    [sym_qualified_type_identifier] = STATE(3260),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [sym_identifier] = ACTIONS(4625),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4627),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(4633),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1419),
  },
  [1732] = {
    [sym_function_definition] = STATE(914),
    [sym_declaration] = STATE(914),
    [sym__declaration_modifiers] = STATE(1964),
    [sym__declaration_specifiers] = STATE(4612),
    [sym_attribute_specifier] = STATE(1964),
    [sym_attribute_declaration] = STATE(1964),
    [sym_ms_declspec_modifier] = STATE(1964),
    [sym_ms_call_modifier] = STATE(1846),
    [sym_declaration_list] = STATE(914),
    [sym_storage_class_specifier] = STATE(1964),
    [sym_type_qualifier] = STATE(1964),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(1964),
    [sym_alignas_specifier] = STATE(1964),
    [sym_dependent_type] = STATE(2629),
    [sym_template_type] = STATE(2618),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(6346),
    [sym_qualified_type_identifier] = STATE(3260),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [sym_identifier] = ACTIONS(4625),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4627),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(4635),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1419),
  },
  [1733] = {
    [sym_function_definition] = STATE(2094),
    [sym_declaration] = STATE(2094),
    [sym__declaration_modifiers] = STATE(1964),
    [sym__declaration_specifiers] = STATE(4569),
    [sym_attribute_specifier] = STATE(1964),
    [sym_attribute_declaration] = STATE(1964),
    [sym_ms_declspec_modifier] = STATE(1964),
    [sym_ms_call_modifier] = STATE(1852),
    [sym_storage_class_specifier] = STATE(1964),
    [sym_type_qualifier] = STATE(1964),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(8228),
    [sym_virtual] = STATE(1964),
    [sym_alignas_specifier] = STATE(1964),
    [sym_dependent_type] = STATE(2629),
    [sym_template_type] = STATE(3945),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(6346),
    [sym_qualified_type_identifier] = STATE(3948),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [sym_identifier] = ACTIONS(4637),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4627),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(4639),
    [anon_sym_struct] = ACTIONS(4641),
    [anon_sym_union] = ACTIONS(4643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1419),
  },
  [1734] = {
    [sym_function_definition] = STATE(2187),
    [sym_declaration] = STATE(2187),
    [sym__declaration_modifiers] = STATE(1964),
    [sym__declaration_specifiers] = STATE(4516),
    [sym_attribute_specifier] = STATE(1964),
    [sym_attribute_declaration] = STATE(1964),
    [sym_ms_declspec_modifier] = STATE(1964),
    [sym_ms_call_modifier] = STATE(1857),
    [sym_storage_class_specifier] = STATE(1964),
    [sym_type_qualifier] = STATE(1964),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(8321),
    [sym_virtual] = STATE(1964),
    [sym_alignas_specifier] = STATE(1964),
    [sym_dependent_type] = STATE(2629),
    [sym_template_type] = STATE(3945),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(6346),
    [sym_qualified_type_identifier] = STATE(3948),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [sym_identifier] = ACTIONS(4637),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4627),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(4645),
    [anon_sym_struct] = ACTIONS(4647),
    [anon_sym_union] = ACTIONS(4649),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1419),
  },
  [1735] = {
    [sym_function_definition] = STATE(384),
    [sym_declaration] = STATE(384),
    [sym__declaration_modifiers] = STATE(1964),
    [sym__declaration_specifiers] = STATE(4637),
    [sym_attribute_specifier] = STATE(1964),
    [sym_attribute_declaration] = STATE(1964),
    [sym_ms_declspec_modifier] = STATE(1964),
    [sym_ms_call_modifier] = STATE(1849),
    [sym_storage_class_specifier] = STATE(1964),
    [sym_type_qualifier] = STATE(1964),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7872),
    [sym_virtual] = STATE(1964),
    [sym_alignas_specifier] = STATE(1964),
    [sym_dependent_type] = STATE(2629),
    [sym_template_type] = STATE(3945),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(6346),
    [sym_qualified_type_identifier] = STATE(3948),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [sym_identifier] = ACTIONS(4637),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4627),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(4651),
    [anon_sym_struct] = ACTIONS(4653),
    [anon_sym_union] = ACTIONS(4655),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1419),
  },
  [1736] = {
    [sym_function_definition] = STATE(849),
    [sym_declaration] = STATE(849),
    [sym__declaration_modifiers] = STATE(1964),
    [sym__declaration_specifiers] = STATE(4612),
    [sym_attribute_specifier] = STATE(1964),
    [sym_attribute_declaration] = STATE(1964),
    [sym_ms_declspec_modifier] = STATE(1964),
    [sym_ms_call_modifier] = STATE(1846),
    [sym_storage_class_specifier] = STATE(1964),
    [sym_type_qualifier] = STATE(1964),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7600),
    [sym_virtual] = STATE(1964),
    [sym_alignas_specifier] = STATE(1964),
    [sym_dependent_type] = STATE(2629),
    [sym_template_type] = STATE(3945),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(6346),
    [sym_qualified_type_identifier] = STATE(3948),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [sym_identifier] = ACTIONS(4637),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4627),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(4657),
    [anon_sym_struct] = ACTIONS(4659),
    [anon_sym_union] = ACTIONS(4661),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1419),
  },
  [1737] = {
    [sym_function_definition] = STATE(692),
    [sym_declaration] = STATE(692),
    [sym__declaration_modifiers] = STATE(1964),
    [sym__declaration_specifiers] = STATE(4602),
    [sym_attribute_specifier] = STATE(1964),
    [sym_attribute_declaration] = STATE(1964),
    [sym_ms_declspec_modifier] = STATE(1964),
    [sym_ms_call_modifier] = STATE(1850),
    [sym_storage_class_specifier] = STATE(1964),
    [sym_type_qualifier] = STATE(1964),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7970),
    [sym_virtual] = STATE(1964),
    [sym_alignas_specifier] = STATE(1964),
    [sym_dependent_type] = STATE(2629),
    [sym_template_type] = STATE(3945),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(6346),
    [sym_qualified_type_identifier] = STATE(3948),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [sym_identifier] = ACTIONS(4637),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4627),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(4663),
    [anon_sym_struct] = ACTIONS(4665),
    [anon_sym_union] = ACTIONS(4667),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1419),
  },
  [1738] = {
    [sym_function_definition] = STATE(777),
    [sym_declaration] = STATE(777),
    [sym__declaration_modifiers] = STATE(1964),
    [sym__declaration_specifiers] = STATE(4541),
    [sym_attribute_specifier] = STATE(1964),
    [sym_attribute_declaration] = STATE(1964),
    [sym_ms_declspec_modifier] = STATE(1964),
    [sym_ms_call_modifier] = STATE(1925),
    [sym_storage_class_specifier] = STATE(1964),
    [sym_type_qualifier] = STATE(1964),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(8086),
    [sym_virtual] = STATE(1964),
    [sym_alignas_specifier] = STATE(1964),
    [sym_dependent_type] = STATE(2629),
    [sym_template_type] = STATE(3945),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(6346),
    [sym_qualified_type_identifier] = STATE(3948),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [sym_identifier] = ACTIONS(4637),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4627),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(4669),
    [anon_sym_struct] = ACTIONS(4671),
    [anon_sym_union] = ACTIONS(4673),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1419),
  },
  [1739] = {
    [sym_function_definition] = STATE(1868),
    [sym_declaration] = STATE(1868),
    [sym__declaration_modifiers] = STATE(1964),
    [sym__declaration_specifiers] = STATE(4558),
    [sym_attribute_specifier] = STATE(1964),
    [sym_attribute_declaration] = STATE(1964),
    [sym_ms_declspec_modifier] = STATE(1964),
    [sym_ms_call_modifier] = STATE(1856),
    [sym_storage_class_specifier] = STATE(1964),
    [sym_type_qualifier] = STATE(1964),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym__class_name] = STATE(7670),
    [sym_virtual] = STATE(1964),
    [sym_alignas_specifier] = STATE(1964),
    [sym_dependent_type] = STATE(2629),
    [sym_template_type] = STATE(3945),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(6346),
    [sym_qualified_type_identifier] = STATE(3948),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [sym_identifier] = ACTIONS(4637),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4627),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym___cdecl] = ACTIONS(49),
    [anon_sym___clrcall] = ACTIONS(49),
    [anon_sym___stdcall] = ACTIONS(49),
    [anon_sym___fastcall] = ACTIONS(49),
    [anon_sym___thiscall] = ACTIONS(49),
    [anon_sym___vectorcall] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(4675),
    [anon_sym_struct] = ACTIONS(4677),
    [anon_sym_union] = ACTIONS(4679),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1419),
  },
  [1740] = {
    [sym_identifier] = ACTIONS(4575),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4577),
    [anon_sym_COMMA] = ACTIONS(4577),
    [anon_sym_LPAREN2] = ACTIONS(4579),
    [anon_sym_TILDE] = ACTIONS(4582),
    [anon_sym_DASH] = ACTIONS(4584),
    [anon_sym_PLUS] = ACTIONS(4584),
    [anon_sym_STAR] = ACTIONS(4579),
    [anon_sym_SLASH] = ACTIONS(4584),
    [anon_sym_PERCENT] = ACTIONS(4577),
    [anon_sym_PIPE_PIPE] = ACTIONS(4577),
    [anon_sym_AMP_AMP] = ACTIONS(4579),
    [anon_sym_PIPE] = ACTIONS(4584),
    [anon_sym_CARET] = ACTIONS(4577),
    [anon_sym_AMP] = ACTIONS(4586),
    [anon_sym_EQ_EQ] = ACTIONS(4577),
    [anon_sym_BANG_EQ] = ACTIONS(4577),
    [anon_sym_GT] = ACTIONS(4584),
    [anon_sym_GT_EQ] = ACTIONS(4577),
    [anon_sym_LT_EQ] = ACTIONS(4584),
    [anon_sym_LT] = ACTIONS(4584),
    [anon_sym_LT_LT] = ACTIONS(4577),
    [anon_sym_GT_GT] = ACTIONS(4577),
    [anon_sym_SEMI] = ACTIONS(4579),
    [anon_sym___extension__] = ACTIONS(4575),
    [anon_sym_extern] = ACTIONS(4575),
    [anon_sym___attribute__] = ACTIONS(4575),
    [anon_sym_COLON_COLON] = ACTIONS(4582),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4579),
    [anon_sym___declspec] = ACTIONS(4575),
    [anon_sym___based] = ACTIONS(4575),
    [anon_sym___cdecl] = ACTIONS(4575),
    [anon_sym___clrcall] = ACTIONS(4575),
    [anon_sym___stdcall] = ACTIONS(4575),
    [anon_sym___fastcall] = ACTIONS(4575),
    [anon_sym___thiscall] = ACTIONS(4575),
    [anon_sym___vectorcall] = ACTIONS(4575),
    [anon_sym_LBRACE] = ACTIONS(4582),
    [anon_sym_RBRACE] = ACTIONS(4577),
    [anon_sym_LBRACK] = ACTIONS(4586),
    [anon_sym_static] = ACTIONS(4575),
    [anon_sym_register] = ACTIONS(4575),
    [anon_sym_inline] = ACTIONS(4575),
    [anon_sym___inline] = ACTIONS(4575),
    [anon_sym___inline__] = ACTIONS(4575),
    [anon_sym___forceinline] = ACTIONS(4575),
    [anon_sym_thread_local] = ACTIONS(4575),
    [anon_sym___thread] = ACTIONS(4575),
    [anon_sym_const] = ACTIONS(4575),
    [anon_sym_constexpr] = ACTIONS(4575),
    [anon_sym_volatile] = ACTIONS(4575),
    [anon_sym_restrict] = ACTIONS(4575),
    [anon_sym___restrict__] = ACTIONS(4575),
    [anon_sym__Atomic] = ACTIONS(4575),
    [anon_sym__Noreturn] = ACTIONS(4575),
    [anon_sym_noreturn] = ACTIONS(4575),
    [anon_sym_mutable] = ACTIONS(4575),
    [anon_sym_constinit] = ACTIONS(4575),
    [anon_sym_consteval] = ACTIONS(4575),
    [anon_sym_PROGMEM] = ACTIONS(4575),
    [anon_sym_QMARK] = ACTIONS(4577),
    [anon_sym_LT_EQ_GT] = ACTIONS(4577),
    [anon_sym_or] = ACTIONS(4584),
    [anon_sym_and] = ACTIONS(4584),
    [anon_sym_bitor] = ACTIONS(4584),
    [anon_sym_xor] = ACTIONS(4584),
    [anon_sym_bitand] = ACTIONS(4584),
    [anon_sym_not_eq] = ACTIONS(4584),
    [anon_sym_DASH_DASH] = ACTIONS(4577),
    [anon_sym_PLUS_PLUS] = ACTIONS(4577),
    [anon_sym_DOT] = ACTIONS(4584),
    [anon_sym_DOT_STAR] = ACTIONS(4577),
    [anon_sym_DASH_GT] = ACTIONS(4577),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4575),
    [anon_sym_decltype] = ACTIONS(4575),
    [anon_sym_virtual] = ACTIONS(4575),
    [anon_sym_alignas] = ACTIONS(4575),
    [anon_sym_template] = ACTIONS(4575),
    [anon_sym_operator] = ACTIONS(4575),
  },
  [1741] = {
    [sym_identifier] = ACTIONS(4575),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4582),
    [anon_sym_COMMA] = ACTIONS(4582),
    [anon_sym_RPAREN] = ACTIONS(4582),
    [anon_sym_LPAREN2] = ACTIONS(4582),
    [anon_sym_TILDE] = ACTIONS(4582),
    [anon_sym_STAR] = ACTIONS(4582),
    [anon_sym_PIPE_PIPE] = ACTIONS(4582),
    [anon_sym_AMP_AMP] = ACTIONS(4582),
    [anon_sym_AMP] = ACTIONS(4575),
    [anon_sym_SEMI] = ACTIONS(4582),
    [anon_sym___extension__] = ACTIONS(4575),
    [anon_sym_extern] = ACTIONS(4575),
    [anon_sym___attribute__] = ACTIONS(4575),
    [anon_sym_COLON_COLON] = ACTIONS(4582),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4582),
    [anon_sym___declspec] = ACTIONS(4575),
    [anon_sym___based] = ACTIONS(4575),
    [anon_sym___cdecl] = ACTIONS(4575),
    [anon_sym___clrcall] = ACTIONS(4575),
    [anon_sym___stdcall] = ACTIONS(4575),
    [anon_sym___fastcall] = ACTIONS(4575),
    [anon_sym___thiscall] = ACTIONS(4575),
    [anon_sym___vectorcall] = ACTIONS(4575),
    [anon_sym_LBRACE] = ACTIONS(4582),
    [anon_sym_signed] = ACTIONS(4575),
    [anon_sym_unsigned] = ACTIONS(4575),
    [anon_sym_long] = ACTIONS(4575),
    [anon_sym_short] = ACTIONS(4575),
    [anon_sym_LBRACK] = ACTIONS(4575),
    [anon_sym_EQ] = ACTIONS(4582),
    [anon_sym_static] = ACTIONS(4575),
    [anon_sym_register] = ACTIONS(4575),
    [anon_sym_inline] = ACTIONS(4575),
    [anon_sym___inline] = ACTIONS(4575),
    [anon_sym___inline__] = ACTIONS(4575),
    [anon_sym___forceinline] = ACTIONS(4575),
    [anon_sym_thread_local] = ACTIONS(4575),
    [anon_sym___thread] = ACTIONS(4575),
    [anon_sym_const] = ACTIONS(4575),
    [anon_sym_constexpr] = ACTIONS(4575),
    [anon_sym_volatile] = ACTIONS(4575),
    [anon_sym_restrict] = ACTIONS(4575),
    [anon_sym___restrict__] = ACTIONS(4575),
    [anon_sym__Atomic] = ACTIONS(4575),
    [anon_sym__Noreturn] = ACTIONS(4575),
    [anon_sym_noreturn] = ACTIONS(4575),
    [anon_sym_mutable] = ACTIONS(4575),
    [anon_sym_constinit] = ACTIONS(4575),
    [anon_sym_consteval] = ACTIONS(4575),
    [anon_sym_PROGMEM] = ACTIONS(4575),
    [aux_sym_primitive_type_token1] = ACTIONS(4575),
    [anon_sym_byte] = ACTIONS(4575),
    [anon_sym_word] = ACTIONS(4575),
    [anon_sym_enum] = ACTIONS(4575),
    [anon_sym_class] = ACTIONS(4575),
    [anon_sym_struct] = ACTIONS(4575),
    [anon_sym_union] = ACTIONS(4575),
    [anon_sym_COLON] = ACTIONS(4575),
    [anon_sym_or] = ACTIONS(4575),
    [anon_sym_and] = ACTIONS(4575),
    [anon_sym_asm] = ACTIONS(4575),
    [anon_sym___asm__] = ACTIONS(4575),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4575),
    [anon_sym_decltype] = ACTIONS(4575),
    [anon_sym_final] = ACTIONS(4575),
    [anon_sym_override] = ACTIONS(4575),
    [anon_sym_virtual] = ACTIONS(4575),
    [anon_sym_alignas] = ACTIONS(4575),
    [anon_sym_explicit] = ACTIONS(4575),
    [anon_sym_typename] = ACTIONS(4575),
    [anon_sym_template] = ACTIONS(4575),
    [anon_sym_GT2] = ACTIONS(4582),
    [anon_sym_operator] = ACTIONS(4575),
    [anon_sym_try] = ACTIONS(4575),
    [anon_sym_friend] = ACTIONS(4575),
    [anon_sym_using] = ACTIONS(4575),
    [anon_sym_concept] = ACTIONS(4575),
    [anon_sym_requires] = ACTIONS(4575),
  },
  [1742] = {
    [sym__declaration_modifiers] = STATE(1967),
    [sym__declaration_specifiers] = STATE(4134),
    [sym_attribute_specifier] = STATE(1967),
    [sym_attribute_declaration] = STATE(1967),
    [sym_ms_declspec_modifier] = STATE(1967),
    [sym_storage_class_specifier] = STATE(1967),
    [sym_type_qualifier] = STATE(1967),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_parameter_declaration] = STATE(6903),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(1967),
    [sym_alignas_specifier] = STATE(1967),
    [sym_dependent_type] = STATE(2629),
    [sym_type_parameter_declaration] = STATE(6903),
    [sym_variadic_type_parameter_declaration] = STATE(6903),
    [sym_optional_type_parameter_declaration] = STATE(6903),
    [sym_template_template_parameter_declaration] = STATE(6903),
    [sym_optional_parameter_declaration] = STATE(6903),
    [sym_variadic_parameter_declaration] = STATE(6903),
    [sym_template_type] = STATE(2618),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(6380),
    [sym_qualified_type_identifier] = STATE(3260),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1967),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [sym_identifier] = ACTIONS(4516),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4526),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(1755),
    [anon_sym_class] = ACTIONS(4681),
    [anon_sym_struct] = ACTIONS(1759),
    [anon_sym_union] = ACTIONS(1761),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(4683),
    [anon_sym_template] = ACTIONS(4685),
    [anon_sym_GT2] = ACTIONS(4687),
  },
  [1743] = {
    [sym__declaration_modifiers] = STATE(1967),
    [sym__declaration_specifiers] = STATE(4134),
    [sym_attribute_specifier] = STATE(1967),
    [sym_attribute_declaration] = STATE(1967),
    [sym_ms_declspec_modifier] = STATE(1967),
    [sym_storage_class_specifier] = STATE(1967),
    [sym_type_qualifier] = STATE(1967),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_parameter_declaration] = STATE(7017),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(1967),
    [sym_alignas_specifier] = STATE(1967),
    [sym_dependent_type] = STATE(2629),
    [sym_type_parameter_declaration] = STATE(7017),
    [sym_variadic_type_parameter_declaration] = STATE(7017),
    [sym_optional_type_parameter_declaration] = STATE(7017),
    [sym_template_template_parameter_declaration] = STATE(7017),
    [sym_optional_parameter_declaration] = STATE(7017),
    [sym_variadic_parameter_declaration] = STATE(7017),
    [sym_template_type] = STATE(2618),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(6380),
    [sym_qualified_type_identifier] = STATE(3260),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1967),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [sym_identifier] = ACTIONS(4516),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4526),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(1755),
    [anon_sym_class] = ACTIONS(4681),
    [anon_sym_struct] = ACTIONS(1759),
    [anon_sym_union] = ACTIONS(1761),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(4683),
    [anon_sym_template] = ACTIONS(4685),
    [anon_sym_GT2] = ACTIONS(4689),
  },
  [1744] = {
    [sym_identifier] = ACTIONS(4691),
    [anon_sym_COMMA] = ACTIONS(4693),
    [anon_sym_RPAREN] = ACTIONS(4693),
    [anon_sym_LPAREN2] = ACTIONS(4693),
    [anon_sym_TILDE] = ACTIONS(4693),
    [anon_sym_STAR] = ACTIONS(4693),
    [anon_sym_PIPE_PIPE] = ACTIONS(4693),
    [anon_sym_AMP_AMP] = ACTIONS(4693),
    [anon_sym_AMP] = ACTIONS(4691),
    [anon_sym_SEMI] = ACTIONS(4693),
    [anon_sym___extension__] = ACTIONS(4691),
    [anon_sym_extern] = ACTIONS(4691),
    [anon_sym___attribute__] = ACTIONS(4691),
    [anon_sym_COLON_COLON] = ACTIONS(4693),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4693),
    [anon_sym___declspec] = ACTIONS(4691),
    [anon_sym___based] = ACTIONS(4691),
    [anon_sym___cdecl] = ACTIONS(4691),
    [anon_sym___clrcall] = ACTIONS(4691),
    [anon_sym___stdcall] = ACTIONS(4691),
    [anon_sym___fastcall] = ACTIONS(4691),
    [anon_sym___thiscall] = ACTIONS(4691),
    [anon_sym___vectorcall] = ACTIONS(4691),
    [anon_sym_LBRACE] = ACTIONS(4693),
    [anon_sym_signed] = ACTIONS(4691),
    [anon_sym_unsigned] = ACTIONS(4691),
    [anon_sym_long] = ACTIONS(4691),
    [anon_sym_short] = ACTIONS(4691),
    [anon_sym_LBRACK] = ACTIONS(4691),
    [anon_sym_EQ] = ACTIONS(4693),
    [anon_sym_static] = ACTIONS(4691),
    [anon_sym_register] = ACTIONS(4691),
    [anon_sym_inline] = ACTIONS(4691),
    [anon_sym___inline] = ACTIONS(4691),
    [anon_sym___inline__] = ACTIONS(4691),
    [anon_sym___forceinline] = ACTIONS(4691),
    [anon_sym_thread_local] = ACTIONS(4691),
    [anon_sym___thread] = ACTIONS(4691),
    [anon_sym_const] = ACTIONS(4691),
    [anon_sym_constexpr] = ACTIONS(4691),
    [anon_sym_volatile] = ACTIONS(4691),
    [anon_sym_restrict] = ACTIONS(4691),
    [anon_sym___restrict__] = ACTIONS(4691),
    [anon_sym__Atomic] = ACTIONS(4691),
    [anon_sym__Noreturn] = ACTIONS(4691),
    [anon_sym_noreturn] = ACTIONS(4691),
    [anon_sym_mutable] = ACTIONS(4691),
    [anon_sym_constinit] = ACTIONS(4691),
    [anon_sym_consteval] = ACTIONS(4691),
    [anon_sym_PROGMEM] = ACTIONS(4691),
    [aux_sym_primitive_type_token1] = ACTIONS(4691),
    [anon_sym_byte] = ACTIONS(4691),
    [anon_sym_word] = ACTIONS(4691),
    [anon_sym_enum] = ACTIONS(4691),
    [anon_sym_class] = ACTIONS(4691),
    [anon_sym_struct] = ACTIONS(4691),
    [anon_sym_union] = ACTIONS(4691),
    [anon_sym_or] = ACTIONS(4691),
    [anon_sym_and] = ACTIONS(4691),
    [anon_sym_asm] = ACTIONS(4691),
    [anon_sym___asm__] = ACTIONS(4691),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4691),
    [anon_sym_decltype] = ACTIONS(4691),
    [anon_sym_final] = ACTIONS(4691),
    [anon_sym_override] = ACTIONS(4691),
    [anon_sym_virtual] = ACTIONS(4691),
    [anon_sym_alignas] = ACTIONS(4691),
    [anon_sym_explicit] = ACTIONS(4691),
    [anon_sym_typename] = ACTIONS(4691),
    [anon_sym_template] = ACTIONS(4691),
    [anon_sym_GT2] = ACTIONS(4693),
    [anon_sym_operator] = ACTIONS(4691),
    [anon_sym_try] = ACTIONS(4691),
    [anon_sym_friend] = ACTIONS(4691),
    [anon_sym_using] = ACTIONS(4691),
    [anon_sym_concept] = ACTIONS(4691),
    [anon_sym_requires] = ACTIONS(4691),
  },
  [1745] = {
    [sym_identifier] = ACTIONS(4695),
    [anon_sym_COMMA] = ACTIONS(4697),
    [anon_sym_RPAREN] = ACTIONS(4697),
    [anon_sym_LPAREN2] = ACTIONS(4697),
    [anon_sym_TILDE] = ACTIONS(4697),
    [anon_sym_STAR] = ACTIONS(4697),
    [anon_sym_PIPE_PIPE] = ACTIONS(4697),
    [anon_sym_AMP_AMP] = ACTIONS(4697),
    [anon_sym_AMP] = ACTIONS(4695),
    [anon_sym_SEMI] = ACTIONS(4697),
    [anon_sym___extension__] = ACTIONS(4695),
    [anon_sym_extern] = ACTIONS(4695),
    [anon_sym___attribute__] = ACTIONS(4695),
    [anon_sym_COLON_COLON] = ACTIONS(4697),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4697),
    [anon_sym___declspec] = ACTIONS(4695),
    [anon_sym___based] = ACTIONS(4695),
    [anon_sym___cdecl] = ACTIONS(4695),
    [anon_sym___clrcall] = ACTIONS(4695),
    [anon_sym___stdcall] = ACTIONS(4695),
    [anon_sym___fastcall] = ACTIONS(4695),
    [anon_sym___thiscall] = ACTIONS(4695),
    [anon_sym___vectorcall] = ACTIONS(4695),
    [anon_sym_LBRACE] = ACTIONS(4697),
    [anon_sym_signed] = ACTIONS(4695),
    [anon_sym_unsigned] = ACTIONS(4695),
    [anon_sym_long] = ACTIONS(4695),
    [anon_sym_short] = ACTIONS(4695),
    [anon_sym_LBRACK] = ACTIONS(4695),
    [anon_sym_EQ] = ACTIONS(4697),
    [anon_sym_static] = ACTIONS(4695),
    [anon_sym_register] = ACTIONS(4695),
    [anon_sym_inline] = ACTIONS(4695),
    [anon_sym___inline] = ACTIONS(4695),
    [anon_sym___inline__] = ACTIONS(4695),
    [anon_sym___forceinline] = ACTIONS(4695),
    [anon_sym_thread_local] = ACTIONS(4695),
    [anon_sym___thread] = ACTIONS(4695),
    [anon_sym_const] = ACTIONS(4695),
    [anon_sym_constexpr] = ACTIONS(4695),
    [anon_sym_volatile] = ACTIONS(4695),
    [anon_sym_restrict] = ACTIONS(4695),
    [anon_sym___restrict__] = ACTIONS(4695),
    [anon_sym__Atomic] = ACTIONS(4695),
    [anon_sym__Noreturn] = ACTIONS(4695),
    [anon_sym_noreturn] = ACTIONS(4695),
    [anon_sym_mutable] = ACTIONS(4695),
    [anon_sym_constinit] = ACTIONS(4695),
    [anon_sym_consteval] = ACTIONS(4695),
    [anon_sym_PROGMEM] = ACTIONS(4695),
    [aux_sym_primitive_type_token1] = ACTIONS(4695),
    [anon_sym_byte] = ACTIONS(4695),
    [anon_sym_word] = ACTIONS(4695),
    [anon_sym_enum] = ACTIONS(4695),
    [anon_sym_class] = ACTIONS(4695),
    [anon_sym_struct] = ACTIONS(4695),
    [anon_sym_union] = ACTIONS(4695),
    [anon_sym_or] = ACTIONS(4695),
    [anon_sym_and] = ACTIONS(4695),
    [anon_sym_asm] = ACTIONS(4695),
    [anon_sym___asm__] = ACTIONS(4695),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4695),
    [anon_sym_decltype] = ACTIONS(4695),
    [anon_sym_final] = ACTIONS(4695),
    [anon_sym_override] = ACTIONS(4695),
    [anon_sym_virtual] = ACTIONS(4695),
    [anon_sym_alignas] = ACTIONS(4695),
    [anon_sym_explicit] = ACTIONS(4695),
    [anon_sym_typename] = ACTIONS(4695),
    [anon_sym_template] = ACTIONS(4695),
    [anon_sym_GT2] = ACTIONS(4697),
    [anon_sym_operator] = ACTIONS(4695),
    [anon_sym_try] = ACTIONS(4695),
    [anon_sym_friend] = ACTIONS(4695),
    [anon_sym_using] = ACTIONS(4695),
    [anon_sym_concept] = ACTIONS(4695),
    [anon_sym_requires] = ACTIONS(4695),
  },
  [1746] = {
    [sym_identifier] = ACTIONS(4699),
    [anon_sym_COMMA] = ACTIONS(4701),
    [anon_sym_RPAREN] = ACTIONS(4701),
    [anon_sym_LPAREN2] = ACTIONS(4701),
    [anon_sym_TILDE] = ACTIONS(4701),
    [anon_sym_STAR] = ACTIONS(4701),
    [anon_sym_PIPE_PIPE] = ACTIONS(4701),
    [anon_sym_AMP_AMP] = ACTIONS(4701),
    [anon_sym_AMP] = ACTIONS(4699),
    [anon_sym_SEMI] = ACTIONS(4701),
    [anon_sym___extension__] = ACTIONS(4699),
    [anon_sym_extern] = ACTIONS(4699),
    [anon_sym___attribute__] = ACTIONS(4699),
    [anon_sym_COLON_COLON] = ACTIONS(4701),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4701),
    [anon_sym___declspec] = ACTIONS(4699),
    [anon_sym___based] = ACTIONS(4699),
    [anon_sym___cdecl] = ACTIONS(4699),
    [anon_sym___clrcall] = ACTIONS(4699),
    [anon_sym___stdcall] = ACTIONS(4699),
    [anon_sym___fastcall] = ACTIONS(4699),
    [anon_sym___thiscall] = ACTIONS(4699),
    [anon_sym___vectorcall] = ACTIONS(4699),
    [anon_sym_LBRACE] = ACTIONS(4701),
    [anon_sym_signed] = ACTIONS(4699),
    [anon_sym_unsigned] = ACTIONS(4699),
    [anon_sym_long] = ACTIONS(4699),
    [anon_sym_short] = ACTIONS(4699),
    [anon_sym_LBRACK] = ACTIONS(4699),
    [anon_sym_EQ] = ACTIONS(4701),
    [anon_sym_static] = ACTIONS(4699),
    [anon_sym_register] = ACTIONS(4699),
    [anon_sym_inline] = ACTIONS(4699),
    [anon_sym___inline] = ACTIONS(4699),
    [anon_sym___inline__] = ACTIONS(4699),
    [anon_sym___forceinline] = ACTIONS(4699),
    [anon_sym_thread_local] = ACTIONS(4699),
    [anon_sym___thread] = ACTIONS(4699),
    [anon_sym_const] = ACTIONS(4699),
    [anon_sym_constexpr] = ACTIONS(4699),
    [anon_sym_volatile] = ACTIONS(4699),
    [anon_sym_restrict] = ACTIONS(4699),
    [anon_sym___restrict__] = ACTIONS(4699),
    [anon_sym__Atomic] = ACTIONS(4699),
    [anon_sym__Noreturn] = ACTIONS(4699),
    [anon_sym_noreturn] = ACTIONS(4699),
    [anon_sym_mutable] = ACTIONS(4699),
    [anon_sym_constinit] = ACTIONS(4699),
    [anon_sym_consteval] = ACTIONS(4699),
    [anon_sym_PROGMEM] = ACTIONS(4699),
    [aux_sym_primitive_type_token1] = ACTIONS(4699),
    [anon_sym_byte] = ACTIONS(4699),
    [anon_sym_word] = ACTIONS(4699),
    [anon_sym_enum] = ACTIONS(4699),
    [anon_sym_class] = ACTIONS(4699),
    [anon_sym_struct] = ACTIONS(4699),
    [anon_sym_union] = ACTIONS(4699),
    [anon_sym_or] = ACTIONS(4699),
    [anon_sym_and] = ACTIONS(4699),
    [anon_sym_asm] = ACTIONS(4699),
    [anon_sym___asm__] = ACTIONS(4699),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4699),
    [anon_sym_decltype] = ACTIONS(4699),
    [anon_sym_final] = ACTIONS(4699),
    [anon_sym_override] = ACTIONS(4699),
    [anon_sym_virtual] = ACTIONS(4699),
    [anon_sym_alignas] = ACTIONS(4699),
    [anon_sym_explicit] = ACTIONS(4699),
    [anon_sym_typename] = ACTIONS(4699),
    [anon_sym_template] = ACTIONS(4699),
    [anon_sym_GT2] = ACTIONS(4701),
    [anon_sym_operator] = ACTIONS(4699),
    [anon_sym_try] = ACTIONS(4699),
    [anon_sym_friend] = ACTIONS(4699),
    [anon_sym_using] = ACTIONS(4699),
    [anon_sym_concept] = ACTIONS(4699),
    [anon_sym_requires] = ACTIONS(4699),
  },
  [1747] = {
    [sym_identifier] = ACTIONS(4703),
    [anon_sym_COMMA] = ACTIONS(4705),
    [anon_sym_RPAREN] = ACTIONS(4705),
    [anon_sym_LPAREN2] = ACTIONS(4705),
    [anon_sym_TILDE] = ACTIONS(4705),
    [anon_sym_STAR] = ACTIONS(4705),
    [anon_sym_PIPE_PIPE] = ACTIONS(4705),
    [anon_sym_AMP_AMP] = ACTIONS(4705),
    [anon_sym_AMP] = ACTIONS(4703),
    [anon_sym_SEMI] = ACTIONS(4705),
    [anon_sym___extension__] = ACTIONS(4703),
    [anon_sym_extern] = ACTIONS(4703),
    [anon_sym___attribute__] = ACTIONS(4703),
    [anon_sym_COLON_COLON] = ACTIONS(4705),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4705),
    [anon_sym___declspec] = ACTIONS(4703),
    [anon_sym___based] = ACTIONS(4703),
    [anon_sym___cdecl] = ACTIONS(4703),
    [anon_sym___clrcall] = ACTIONS(4703),
    [anon_sym___stdcall] = ACTIONS(4703),
    [anon_sym___fastcall] = ACTIONS(4703),
    [anon_sym___thiscall] = ACTIONS(4703),
    [anon_sym___vectorcall] = ACTIONS(4703),
    [anon_sym_LBRACE] = ACTIONS(4705),
    [anon_sym_signed] = ACTIONS(4703),
    [anon_sym_unsigned] = ACTIONS(4703),
    [anon_sym_long] = ACTIONS(4703),
    [anon_sym_short] = ACTIONS(4703),
    [anon_sym_LBRACK] = ACTIONS(4703),
    [anon_sym_EQ] = ACTIONS(4705),
    [anon_sym_static] = ACTIONS(4703),
    [anon_sym_register] = ACTIONS(4703),
    [anon_sym_inline] = ACTIONS(4703),
    [anon_sym___inline] = ACTIONS(4703),
    [anon_sym___inline__] = ACTIONS(4703),
    [anon_sym___forceinline] = ACTIONS(4703),
    [anon_sym_thread_local] = ACTIONS(4703),
    [anon_sym___thread] = ACTIONS(4703),
    [anon_sym_const] = ACTIONS(4703),
    [anon_sym_constexpr] = ACTIONS(4703),
    [anon_sym_volatile] = ACTIONS(4703),
    [anon_sym_restrict] = ACTIONS(4703),
    [anon_sym___restrict__] = ACTIONS(4703),
    [anon_sym__Atomic] = ACTIONS(4703),
    [anon_sym__Noreturn] = ACTIONS(4703),
    [anon_sym_noreturn] = ACTIONS(4703),
    [anon_sym_mutable] = ACTIONS(4703),
    [anon_sym_constinit] = ACTIONS(4703),
    [anon_sym_consteval] = ACTIONS(4703),
    [anon_sym_PROGMEM] = ACTIONS(4703),
    [aux_sym_primitive_type_token1] = ACTIONS(4703),
    [anon_sym_byte] = ACTIONS(4703),
    [anon_sym_word] = ACTIONS(4703),
    [anon_sym_enum] = ACTIONS(4703),
    [anon_sym_class] = ACTIONS(4703),
    [anon_sym_struct] = ACTIONS(4703),
    [anon_sym_union] = ACTIONS(4703),
    [anon_sym_or] = ACTIONS(4703),
    [anon_sym_and] = ACTIONS(4703),
    [anon_sym_asm] = ACTIONS(4703),
    [anon_sym___asm__] = ACTIONS(4703),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4703),
    [anon_sym_decltype] = ACTIONS(4703),
    [anon_sym_final] = ACTIONS(4703),
    [anon_sym_override] = ACTIONS(4703),
    [anon_sym_virtual] = ACTIONS(4703),
    [anon_sym_alignas] = ACTIONS(4703),
    [anon_sym_explicit] = ACTIONS(4703),
    [anon_sym_typename] = ACTIONS(4703),
    [anon_sym_template] = ACTIONS(4703),
    [anon_sym_GT2] = ACTIONS(4705),
    [anon_sym_operator] = ACTIONS(4703),
    [anon_sym_try] = ACTIONS(4703),
    [anon_sym_friend] = ACTIONS(4703),
    [anon_sym_using] = ACTIONS(4703),
    [anon_sym_concept] = ACTIONS(4703),
    [anon_sym_requires] = ACTIONS(4703),
  },
  [1748] = {
    [sym_identifier] = ACTIONS(4691),
    [anon_sym_COMMA] = ACTIONS(4693),
    [anon_sym_RPAREN] = ACTIONS(4693),
    [anon_sym_LPAREN2] = ACTIONS(4693),
    [anon_sym_TILDE] = ACTIONS(4693),
    [anon_sym_STAR] = ACTIONS(4693),
    [anon_sym_PIPE_PIPE] = ACTIONS(4693),
    [anon_sym_AMP_AMP] = ACTIONS(4693),
    [anon_sym_AMP] = ACTIONS(4691),
    [anon_sym_SEMI] = ACTIONS(4693),
    [anon_sym___extension__] = ACTIONS(4691),
    [anon_sym_extern] = ACTIONS(4691),
    [anon_sym___attribute__] = ACTIONS(4691),
    [anon_sym_COLON_COLON] = ACTIONS(4693),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4693),
    [anon_sym___declspec] = ACTIONS(4691),
    [anon_sym___based] = ACTIONS(4691),
    [anon_sym___cdecl] = ACTIONS(4691),
    [anon_sym___clrcall] = ACTIONS(4691),
    [anon_sym___stdcall] = ACTIONS(4691),
    [anon_sym___fastcall] = ACTIONS(4691),
    [anon_sym___thiscall] = ACTIONS(4691),
    [anon_sym___vectorcall] = ACTIONS(4691),
    [anon_sym_LBRACE] = ACTIONS(4693),
    [anon_sym_signed] = ACTIONS(4691),
    [anon_sym_unsigned] = ACTIONS(4691),
    [anon_sym_long] = ACTIONS(4691),
    [anon_sym_short] = ACTIONS(4691),
    [anon_sym_LBRACK] = ACTIONS(4691),
    [anon_sym_EQ] = ACTIONS(4693),
    [anon_sym_static] = ACTIONS(4691),
    [anon_sym_register] = ACTIONS(4691),
    [anon_sym_inline] = ACTIONS(4691),
    [anon_sym___inline] = ACTIONS(4691),
    [anon_sym___inline__] = ACTIONS(4691),
    [anon_sym___forceinline] = ACTIONS(4691),
    [anon_sym_thread_local] = ACTIONS(4691),
    [anon_sym___thread] = ACTIONS(4691),
    [anon_sym_const] = ACTIONS(4691),
    [anon_sym_constexpr] = ACTIONS(4691),
    [anon_sym_volatile] = ACTIONS(4691),
    [anon_sym_restrict] = ACTIONS(4691),
    [anon_sym___restrict__] = ACTIONS(4691),
    [anon_sym__Atomic] = ACTIONS(4691),
    [anon_sym__Noreturn] = ACTIONS(4691),
    [anon_sym_noreturn] = ACTIONS(4691),
    [anon_sym_mutable] = ACTIONS(4691),
    [anon_sym_constinit] = ACTIONS(4691),
    [anon_sym_consteval] = ACTIONS(4691),
    [anon_sym_PROGMEM] = ACTIONS(4691),
    [aux_sym_primitive_type_token1] = ACTIONS(4691),
    [anon_sym_byte] = ACTIONS(4691),
    [anon_sym_word] = ACTIONS(4691),
    [anon_sym_enum] = ACTIONS(4691),
    [anon_sym_class] = ACTIONS(4691),
    [anon_sym_struct] = ACTIONS(4691),
    [anon_sym_union] = ACTIONS(4691),
    [anon_sym_or] = ACTIONS(4691),
    [anon_sym_and] = ACTIONS(4691),
    [anon_sym_asm] = ACTIONS(4691),
    [anon_sym___asm__] = ACTIONS(4691),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4691),
    [anon_sym_decltype] = ACTIONS(4691),
    [anon_sym_final] = ACTIONS(4691),
    [anon_sym_override] = ACTIONS(4691),
    [anon_sym_virtual] = ACTIONS(4691),
    [anon_sym_alignas] = ACTIONS(4691),
    [anon_sym_explicit] = ACTIONS(4691),
    [anon_sym_typename] = ACTIONS(4691),
    [anon_sym_template] = ACTIONS(4691),
    [anon_sym_GT2] = ACTIONS(4693),
    [anon_sym_operator] = ACTIONS(4691),
    [anon_sym_try] = ACTIONS(4691),
    [anon_sym_friend] = ACTIONS(4691),
    [anon_sym_using] = ACTIONS(4691),
    [anon_sym_concept] = ACTIONS(4691),
    [anon_sym_requires] = ACTIONS(4691),
  },
  [1749] = {
    [sym_identifier] = ACTIONS(4707),
    [anon_sym_COMMA] = ACTIONS(4709),
    [anon_sym_RPAREN] = ACTIONS(4709),
    [anon_sym_LPAREN2] = ACTIONS(4709),
    [anon_sym_TILDE] = ACTIONS(4709),
    [anon_sym_STAR] = ACTIONS(4709),
    [anon_sym_PIPE_PIPE] = ACTIONS(4709),
    [anon_sym_AMP_AMP] = ACTIONS(4709),
    [anon_sym_AMP] = ACTIONS(4707),
    [anon_sym_SEMI] = ACTIONS(4709),
    [anon_sym___extension__] = ACTIONS(4707),
    [anon_sym_extern] = ACTIONS(4707),
    [anon_sym___attribute__] = ACTIONS(4707),
    [anon_sym_COLON_COLON] = ACTIONS(4709),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4709),
    [anon_sym___declspec] = ACTIONS(4707),
    [anon_sym___based] = ACTIONS(4707),
    [anon_sym___cdecl] = ACTIONS(4707),
    [anon_sym___clrcall] = ACTIONS(4707),
    [anon_sym___stdcall] = ACTIONS(4707),
    [anon_sym___fastcall] = ACTIONS(4707),
    [anon_sym___thiscall] = ACTIONS(4707),
    [anon_sym___vectorcall] = ACTIONS(4707),
    [anon_sym_LBRACE] = ACTIONS(4709),
    [anon_sym_signed] = ACTIONS(4707),
    [anon_sym_unsigned] = ACTIONS(4707),
    [anon_sym_long] = ACTIONS(4707),
    [anon_sym_short] = ACTIONS(4707),
    [anon_sym_LBRACK] = ACTIONS(4707),
    [anon_sym_EQ] = ACTIONS(4709),
    [anon_sym_static] = ACTIONS(4707),
    [anon_sym_register] = ACTIONS(4707),
    [anon_sym_inline] = ACTIONS(4707),
    [anon_sym___inline] = ACTIONS(4707),
    [anon_sym___inline__] = ACTIONS(4707),
    [anon_sym___forceinline] = ACTIONS(4707),
    [anon_sym_thread_local] = ACTIONS(4707),
    [anon_sym___thread] = ACTIONS(4707),
    [anon_sym_const] = ACTIONS(4707),
    [anon_sym_constexpr] = ACTIONS(4707),
    [anon_sym_volatile] = ACTIONS(4707),
    [anon_sym_restrict] = ACTIONS(4707),
    [anon_sym___restrict__] = ACTIONS(4707),
    [anon_sym__Atomic] = ACTIONS(4707),
    [anon_sym__Noreturn] = ACTIONS(4707),
    [anon_sym_noreturn] = ACTIONS(4707),
    [anon_sym_mutable] = ACTIONS(4707),
    [anon_sym_constinit] = ACTIONS(4707),
    [anon_sym_consteval] = ACTIONS(4707),
    [anon_sym_PROGMEM] = ACTIONS(4707),
    [aux_sym_primitive_type_token1] = ACTIONS(4707),
    [anon_sym_byte] = ACTIONS(4707),
    [anon_sym_word] = ACTIONS(4707),
    [anon_sym_enum] = ACTIONS(4707),
    [anon_sym_class] = ACTIONS(4707),
    [anon_sym_struct] = ACTIONS(4707),
    [anon_sym_union] = ACTIONS(4707),
    [anon_sym_or] = ACTIONS(4707),
    [anon_sym_and] = ACTIONS(4707),
    [anon_sym_asm] = ACTIONS(4707),
    [anon_sym___asm__] = ACTIONS(4707),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4707),
    [anon_sym_decltype] = ACTIONS(4707),
    [anon_sym_final] = ACTIONS(4707),
    [anon_sym_override] = ACTIONS(4707),
    [anon_sym_virtual] = ACTIONS(4707),
    [anon_sym_alignas] = ACTIONS(4707),
    [anon_sym_explicit] = ACTIONS(4707),
    [anon_sym_typename] = ACTIONS(4707),
    [anon_sym_template] = ACTIONS(4707),
    [anon_sym_GT2] = ACTIONS(4709),
    [anon_sym_operator] = ACTIONS(4707),
    [anon_sym_try] = ACTIONS(4707),
    [anon_sym_friend] = ACTIONS(4707),
    [anon_sym_using] = ACTIONS(4707),
    [anon_sym_concept] = ACTIONS(4707),
    [anon_sym_requires] = ACTIONS(4707),
  },
  [1750] = {
    [sym__declaration_modifiers] = STATE(1967),
    [sym__declaration_specifiers] = STATE(4134),
    [sym_attribute_specifier] = STATE(1967),
    [sym_attribute_declaration] = STATE(1967),
    [sym_ms_declspec_modifier] = STATE(1967),
    [sym_storage_class_specifier] = STATE(1967),
    [sym_type_qualifier] = STATE(1967),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_parameter_declaration] = STATE(7314),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(1967),
    [sym_alignas_specifier] = STATE(1967),
    [sym_dependent_type] = STATE(2629),
    [sym_type_parameter_declaration] = STATE(7314),
    [sym_variadic_type_parameter_declaration] = STATE(7314),
    [sym_optional_type_parameter_declaration] = STATE(7314),
    [sym_template_template_parameter_declaration] = STATE(7314),
    [sym_optional_parameter_declaration] = STATE(7314),
    [sym_variadic_parameter_declaration] = STATE(7314),
    [sym_template_type] = STATE(2618),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(6380),
    [sym_qualified_type_identifier] = STATE(3260),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1967),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [sym_identifier] = ACTIONS(4516),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4526),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(1755),
    [anon_sym_class] = ACTIONS(4681),
    [anon_sym_struct] = ACTIONS(1759),
    [anon_sym_union] = ACTIONS(1761),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(4683),
    [anon_sym_template] = ACTIONS(4685),
  },
  [1751] = {
    [sym_identifier] = ACTIONS(4711),
    [anon_sym_COMMA] = ACTIONS(4713),
    [anon_sym_RPAREN] = ACTIONS(4713),
    [anon_sym_LPAREN2] = ACTIONS(4713),
    [anon_sym_TILDE] = ACTIONS(4713),
    [anon_sym_STAR] = ACTIONS(4713),
    [anon_sym_PIPE_PIPE] = ACTIONS(4713),
    [anon_sym_AMP_AMP] = ACTIONS(4713),
    [anon_sym_AMP] = ACTIONS(4711),
    [anon_sym_SEMI] = ACTIONS(4713),
    [anon_sym___extension__] = ACTIONS(4711),
    [anon_sym_extern] = ACTIONS(4711),
    [anon_sym___attribute__] = ACTIONS(4711),
    [anon_sym_COLON_COLON] = ACTIONS(4713),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4713),
    [anon_sym___declspec] = ACTIONS(4711),
    [anon_sym___based] = ACTIONS(4711),
    [anon_sym___cdecl] = ACTIONS(4711),
    [anon_sym___clrcall] = ACTIONS(4711),
    [anon_sym___stdcall] = ACTIONS(4711),
    [anon_sym___fastcall] = ACTIONS(4711),
    [anon_sym___thiscall] = ACTIONS(4711),
    [anon_sym___vectorcall] = ACTIONS(4711),
    [anon_sym_LBRACE] = ACTIONS(4713),
    [anon_sym_signed] = ACTIONS(4711),
    [anon_sym_unsigned] = ACTIONS(4711),
    [anon_sym_long] = ACTIONS(4711),
    [anon_sym_short] = ACTIONS(4711),
    [anon_sym_LBRACK] = ACTIONS(4711),
    [anon_sym_EQ] = ACTIONS(4713),
    [anon_sym_static] = ACTIONS(4711),
    [anon_sym_register] = ACTIONS(4711),
    [anon_sym_inline] = ACTIONS(4711),
    [anon_sym___inline] = ACTIONS(4711),
    [anon_sym___inline__] = ACTIONS(4711),
    [anon_sym___forceinline] = ACTIONS(4711),
    [anon_sym_thread_local] = ACTIONS(4711),
    [anon_sym___thread] = ACTIONS(4711),
    [anon_sym_const] = ACTIONS(4711),
    [anon_sym_constexpr] = ACTIONS(4711),
    [anon_sym_volatile] = ACTIONS(4711),
    [anon_sym_restrict] = ACTIONS(4711),
    [anon_sym___restrict__] = ACTIONS(4711),
    [anon_sym__Atomic] = ACTIONS(4711),
    [anon_sym__Noreturn] = ACTIONS(4711),
    [anon_sym_noreturn] = ACTIONS(4711),
    [anon_sym_mutable] = ACTIONS(4711),
    [anon_sym_constinit] = ACTIONS(4711),
    [anon_sym_consteval] = ACTIONS(4711),
    [anon_sym_PROGMEM] = ACTIONS(4711),
    [aux_sym_primitive_type_token1] = ACTIONS(4711),
    [anon_sym_byte] = ACTIONS(4711),
    [anon_sym_word] = ACTIONS(4711),
    [anon_sym_enum] = ACTIONS(4711),
    [anon_sym_class] = ACTIONS(4711),
    [anon_sym_struct] = ACTIONS(4711),
    [anon_sym_union] = ACTIONS(4711),
    [anon_sym_or] = ACTIONS(4711),
    [anon_sym_and] = ACTIONS(4711),
    [anon_sym_asm] = ACTIONS(4711),
    [anon_sym___asm__] = ACTIONS(4711),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4711),
    [anon_sym_decltype] = ACTIONS(4711),
    [anon_sym_final] = ACTIONS(4711),
    [anon_sym_override] = ACTIONS(4711),
    [anon_sym_virtual] = ACTIONS(4711),
    [anon_sym_alignas] = ACTIONS(4711),
    [anon_sym_explicit] = ACTIONS(4711),
    [anon_sym_typename] = ACTIONS(4711),
    [anon_sym_template] = ACTIONS(4711),
    [anon_sym_GT2] = ACTIONS(4713),
    [anon_sym_operator] = ACTIONS(4711),
    [anon_sym_try] = ACTIONS(4711),
    [anon_sym_friend] = ACTIONS(4711),
    [anon_sym_using] = ACTIONS(4711),
    [anon_sym_concept] = ACTIONS(4711),
    [anon_sym_requires] = ACTIONS(4711),
  },
  [1752] = {
    [sym_identifier] = ACTIONS(4715),
    [anon_sym_COMMA] = ACTIONS(4717),
    [anon_sym_RPAREN] = ACTIONS(4717),
    [anon_sym_LPAREN2] = ACTIONS(4717),
    [anon_sym_TILDE] = ACTIONS(4717),
    [anon_sym_STAR] = ACTIONS(4717),
    [anon_sym_PIPE_PIPE] = ACTIONS(4717),
    [anon_sym_AMP_AMP] = ACTIONS(4717),
    [anon_sym_AMP] = ACTIONS(4715),
    [anon_sym_SEMI] = ACTIONS(4717),
    [anon_sym___extension__] = ACTIONS(4715),
    [anon_sym_extern] = ACTIONS(4715),
    [anon_sym___attribute__] = ACTIONS(4715),
    [anon_sym_COLON_COLON] = ACTIONS(4717),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4717),
    [anon_sym___declspec] = ACTIONS(4715),
    [anon_sym___based] = ACTIONS(4715),
    [anon_sym___cdecl] = ACTIONS(4715),
    [anon_sym___clrcall] = ACTIONS(4715),
    [anon_sym___stdcall] = ACTIONS(4715),
    [anon_sym___fastcall] = ACTIONS(4715),
    [anon_sym___thiscall] = ACTIONS(4715),
    [anon_sym___vectorcall] = ACTIONS(4715),
    [anon_sym_LBRACE] = ACTIONS(4717),
    [anon_sym_signed] = ACTIONS(4715),
    [anon_sym_unsigned] = ACTIONS(4715),
    [anon_sym_long] = ACTIONS(4715),
    [anon_sym_short] = ACTIONS(4715),
    [anon_sym_LBRACK] = ACTIONS(4715),
    [anon_sym_EQ] = ACTIONS(4717),
    [anon_sym_static] = ACTIONS(4715),
    [anon_sym_register] = ACTIONS(4715),
    [anon_sym_inline] = ACTIONS(4715),
    [anon_sym___inline] = ACTIONS(4715),
    [anon_sym___inline__] = ACTIONS(4715),
    [anon_sym___forceinline] = ACTIONS(4715),
    [anon_sym_thread_local] = ACTIONS(4715),
    [anon_sym___thread] = ACTIONS(4715),
    [anon_sym_const] = ACTIONS(4715),
    [anon_sym_constexpr] = ACTIONS(4715),
    [anon_sym_volatile] = ACTIONS(4715),
    [anon_sym_restrict] = ACTIONS(4715),
    [anon_sym___restrict__] = ACTIONS(4715),
    [anon_sym__Atomic] = ACTIONS(4715),
    [anon_sym__Noreturn] = ACTIONS(4715),
    [anon_sym_noreturn] = ACTIONS(4715),
    [anon_sym_mutable] = ACTIONS(4715),
    [anon_sym_constinit] = ACTIONS(4715),
    [anon_sym_consteval] = ACTIONS(4715),
    [anon_sym_PROGMEM] = ACTIONS(4715),
    [aux_sym_primitive_type_token1] = ACTIONS(4715),
    [anon_sym_byte] = ACTIONS(4715),
    [anon_sym_word] = ACTIONS(4715),
    [anon_sym_enum] = ACTIONS(4715),
    [anon_sym_class] = ACTIONS(4715),
    [anon_sym_struct] = ACTIONS(4715),
    [anon_sym_union] = ACTIONS(4715),
    [anon_sym_or] = ACTIONS(4715),
    [anon_sym_and] = ACTIONS(4715),
    [anon_sym_asm] = ACTIONS(4715),
    [anon_sym___asm__] = ACTIONS(4715),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4715),
    [anon_sym_decltype] = ACTIONS(4715),
    [anon_sym_final] = ACTIONS(4715),
    [anon_sym_override] = ACTIONS(4715),
    [anon_sym_virtual] = ACTIONS(4715),
    [anon_sym_alignas] = ACTIONS(4715),
    [anon_sym_explicit] = ACTIONS(4715),
    [anon_sym_typename] = ACTIONS(4715),
    [anon_sym_template] = ACTIONS(4715),
    [anon_sym_GT2] = ACTIONS(4717),
    [anon_sym_operator] = ACTIONS(4715),
    [anon_sym_try] = ACTIONS(4715),
    [anon_sym_friend] = ACTIONS(4715),
    [anon_sym_using] = ACTIONS(4715),
    [anon_sym_concept] = ACTIONS(4715),
    [anon_sym_requires] = ACTIONS(4715),
  },
  [1753] = {
    [sym_identifier] = ACTIONS(4719),
    [anon_sym_COMMA] = ACTIONS(4721),
    [anon_sym_RPAREN] = ACTIONS(4721),
    [anon_sym_LPAREN2] = ACTIONS(4721),
    [anon_sym_TILDE] = ACTIONS(4721),
    [anon_sym_STAR] = ACTIONS(4721),
    [anon_sym_PIPE_PIPE] = ACTIONS(4721),
    [anon_sym_AMP_AMP] = ACTIONS(4721),
    [anon_sym_AMP] = ACTIONS(4719),
    [anon_sym_SEMI] = ACTIONS(4721),
    [anon_sym___extension__] = ACTIONS(4719),
    [anon_sym_extern] = ACTIONS(4719),
    [anon_sym___attribute__] = ACTIONS(4719),
    [anon_sym_COLON_COLON] = ACTIONS(4721),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4721),
    [anon_sym___declspec] = ACTIONS(4719),
    [anon_sym___based] = ACTIONS(4719),
    [anon_sym___cdecl] = ACTIONS(4719),
    [anon_sym___clrcall] = ACTIONS(4719),
    [anon_sym___stdcall] = ACTIONS(4719),
    [anon_sym___fastcall] = ACTIONS(4719),
    [anon_sym___thiscall] = ACTIONS(4719),
    [anon_sym___vectorcall] = ACTIONS(4719),
    [anon_sym_LBRACE] = ACTIONS(4721),
    [anon_sym_signed] = ACTIONS(4719),
    [anon_sym_unsigned] = ACTIONS(4719),
    [anon_sym_long] = ACTIONS(4719),
    [anon_sym_short] = ACTIONS(4719),
    [anon_sym_LBRACK] = ACTIONS(4719),
    [anon_sym_EQ] = ACTIONS(4721),
    [anon_sym_static] = ACTIONS(4719),
    [anon_sym_register] = ACTIONS(4719),
    [anon_sym_inline] = ACTIONS(4719),
    [anon_sym___inline] = ACTIONS(4719),
    [anon_sym___inline__] = ACTIONS(4719),
    [anon_sym___forceinline] = ACTIONS(4719),
    [anon_sym_thread_local] = ACTIONS(4719),
    [anon_sym___thread] = ACTIONS(4719),
    [anon_sym_const] = ACTIONS(4719),
    [anon_sym_constexpr] = ACTIONS(4719),
    [anon_sym_volatile] = ACTIONS(4719),
    [anon_sym_restrict] = ACTIONS(4719),
    [anon_sym___restrict__] = ACTIONS(4719),
    [anon_sym__Atomic] = ACTIONS(4719),
    [anon_sym__Noreturn] = ACTIONS(4719),
    [anon_sym_noreturn] = ACTIONS(4719),
    [anon_sym_mutable] = ACTIONS(4719),
    [anon_sym_constinit] = ACTIONS(4719),
    [anon_sym_consteval] = ACTIONS(4719),
    [anon_sym_PROGMEM] = ACTIONS(4719),
    [aux_sym_primitive_type_token1] = ACTIONS(4719),
    [anon_sym_byte] = ACTIONS(4719),
    [anon_sym_word] = ACTIONS(4719),
    [anon_sym_enum] = ACTIONS(4719),
    [anon_sym_class] = ACTIONS(4719),
    [anon_sym_struct] = ACTIONS(4719),
    [anon_sym_union] = ACTIONS(4719),
    [anon_sym_or] = ACTIONS(4719),
    [anon_sym_and] = ACTIONS(4719),
    [anon_sym_asm] = ACTIONS(4719),
    [anon_sym___asm__] = ACTIONS(4719),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4719),
    [anon_sym_decltype] = ACTIONS(4719),
    [anon_sym_final] = ACTIONS(4719),
    [anon_sym_override] = ACTIONS(4719),
    [anon_sym_virtual] = ACTIONS(4719),
    [anon_sym_alignas] = ACTIONS(4719),
    [anon_sym_explicit] = ACTIONS(4719),
    [anon_sym_typename] = ACTIONS(4719),
    [anon_sym_template] = ACTIONS(4719),
    [anon_sym_GT2] = ACTIONS(4721),
    [anon_sym_operator] = ACTIONS(4719),
    [anon_sym_try] = ACTIONS(4719),
    [anon_sym_friend] = ACTIONS(4719),
    [anon_sym_using] = ACTIONS(4719),
    [anon_sym_concept] = ACTIONS(4719),
    [anon_sym_requires] = ACTIONS(4719),
  },
  [1754] = {
    [sym_identifier] = ACTIONS(4691),
    [anon_sym_COMMA] = ACTIONS(4693),
    [anon_sym_RPAREN] = ACTIONS(4693),
    [anon_sym_LPAREN2] = ACTIONS(4693),
    [anon_sym_TILDE] = ACTIONS(4693),
    [anon_sym_STAR] = ACTIONS(4693),
    [anon_sym_PIPE_PIPE] = ACTIONS(4693),
    [anon_sym_AMP_AMP] = ACTIONS(4693),
    [anon_sym_AMP] = ACTIONS(4691),
    [anon_sym_SEMI] = ACTIONS(4693),
    [anon_sym___extension__] = ACTIONS(4691),
    [anon_sym_extern] = ACTIONS(4691),
    [anon_sym___attribute__] = ACTIONS(4691),
    [anon_sym_COLON_COLON] = ACTIONS(4693),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4693),
    [anon_sym___declspec] = ACTIONS(4691),
    [anon_sym___based] = ACTIONS(4691),
    [anon_sym___cdecl] = ACTIONS(4691),
    [anon_sym___clrcall] = ACTIONS(4691),
    [anon_sym___stdcall] = ACTIONS(4691),
    [anon_sym___fastcall] = ACTIONS(4691),
    [anon_sym___thiscall] = ACTIONS(4691),
    [anon_sym___vectorcall] = ACTIONS(4691),
    [anon_sym_LBRACE] = ACTIONS(4693),
    [anon_sym_signed] = ACTIONS(4691),
    [anon_sym_unsigned] = ACTIONS(4691),
    [anon_sym_long] = ACTIONS(4691),
    [anon_sym_short] = ACTIONS(4691),
    [anon_sym_LBRACK] = ACTIONS(4691),
    [anon_sym_EQ] = ACTIONS(4693),
    [anon_sym_static] = ACTIONS(4691),
    [anon_sym_register] = ACTIONS(4691),
    [anon_sym_inline] = ACTIONS(4691),
    [anon_sym___inline] = ACTIONS(4691),
    [anon_sym___inline__] = ACTIONS(4691),
    [anon_sym___forceinline] = ACTIONS(4691),
    [anon_sym_thread_local] = ACTIONS(4691),
    [anon_sym___thread] = ACTIONS(4691),
    [anon_sym_const] = ACTIONS(4691),
    [anon_sym_constexpr] = ACTIONS(4691),
    [anon_sym_volatile] = ACTIONS(4691),
    [anon_sym_restrict] = ACTIONS(4691),
    [anon_sym___restrict__] = ACTIONS(4691),
    [anon_sym__Atomic] = ACTIONS(4691),
    [anon_sym__Noreturn] = ACTIONS(4691),
    [anon_sym_noreturn] = ACTIONS(4691),
    [anon_sym_mutable] = ACTIONS(4691),
    [anon_sym_constinit] = ACTIONS(4691),
    [anon_sym_consteval] = ACTIONS(4691),
    [anon_sym_PROGMEM] = ACTIONS(4691),
    [aux_sym_primitive_type_token1] = ACTIONS(4691),
    [anon_sym_byte] = ACTIONS(4691),
    [anon_sym_word] = ACTIONS(4691),
    [anon_sym_enum] = ACTIONS(4691),
    [anon_sym_class] = ACTIONS(4691),
    [anon_sym_struct] = ACTIONS(4691),
    [anon_sym_union] = ACTIONS(4691),
    [anon_sym_or] = ACTIONS(4691),
    [anon_sym_and] = ACTIONS(4691),
    [anon_sym_asm] = ACTIONS(4691),
    [anon_sym___asm__] = ACTIONS(4691),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4691),
    [anon_sym_decltype] = ACTIONS(4691),
    [anon_sym_final] = ACTIONS(4691),
    [anon_sym_override] = ACTIONS(4691),
    [anon_sym_virtual] = ACTIONS(4691),
    [anon_sym_alignas] = ACTIONS(4691),
    [anon_sym_explicit] = ACTIONS(4691),
    [anon_sym_typename] = ACTIONS(4691),
    [anon_sym_template] = ACTIONS(4691),
    [anon_sym_GT2] = ACTIONS(4693),
    [anon_sym_operator] = ACTIONS(4691),
    [anon_sym_try] = ACTIONS(4691),
    [anon_sym_friend] = ACTIONS(4691),
    [anon_sym_using] = ACTIONS(4691),
    [anon_sym_concept] = ACTIONS(4691),
    [anon_sym_requires] = ACTIONS(4691),
  },
  [1755] = {
    [sym_identifier] = ACTIONS(4723),
    [anon_sym_COMMA] = ACTIONS(4725),
    [anon_sym_RPAREN] = ACTIONS(4725),
    [anon_sym_LPAREN2] = ACTIONS(4725),
    [anon_sym_TILDE] = ACTIONS(4725),
    [anon_sym_STAR] = ACTIONS(4725),
    [anon_sym_PIPE_PIPE] = ACTIONS(4725),
    [anon_sym_AMP_AMP] = ACTIONS(4725),
    [anon_sym_AMP] = ACTIONS(4723),
    [anon_sym_SEMI] = ACTIONS(4725),
    [anon_sym___extension__] = ACTIONS(4723),
    [anon_sym_extern] = ACTIONS(4723),
    [anon_sym___attribute__] = ACTIONS(4723),
    [anon_sym_COLON_COLON] = ACTIONS(4725),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4725),
    [anon_sym___declspec] = ACTIONS(4723),
    [anon_sym___based] = ACTIONS(4723),
    [anon_sym___cdecl] = ACTIONS(4723),
    [anon_sym___clrcall] = ACTIONS(4723),
    [anon_sym___stdcall] = ACTIONS(4723),
    [anon_sym___fastcall] = ACTIONS(4723),
    [anon_sym___thiscall] = ACTIONS(4723),
    [anon_sym___vectorcall] = ACTIONS(4723),
    [anon_sym_LBRACE] = ACTIONS(4725),
    [anon_sym_signed] = ACTIONS(4723),
    [anon_sym_unsigned] = ACTIONS(4723),
    [anon_sym_long] = ACTIONS(4723),
    [anon_sym_short] = ACTIONS(4723),
    [anon_sym_LBRACK] = ACTIONS(4723),
    [anon_sym_EQ] = ACTIONS(4725),
    [anon_sym_static] = ACTIONS(4723),
    [anon_sym_register] = ACTIONS(4723),
    [anon_sym_inline] = ACTIONS(4723),
    [anon_sym___inline] = ACTIONS(4723),
    [anon_sym___inline__] = ACTIONS(4723),
    [anon_sym___forceinline] = ACTIONS(4723),
    [anon_sym_thread_local] = ACTIONS(4723),
    [anon_sym___thread] = ACTIONS(4723),
    [anon_sym_const] = ACTIONS(4723),
    [anon_sym_constexpr] = ACTIONS(4723),
    [anon_sym_volatile] = ACTIONS(4723),
    [anon_sym_restrict] = ACTIONS(4723),
    [anon_sym___restrict__] = ACTIONS(4723),
    [anon_sym__Atomic] = ACTIONS(4723),
    [anon_sym__Noreturn] = ACTIONS(4723),
    [anon_sym_noreturn] = ACTIONS(4723),
    [anon_sym_mutable] = ACTIONS(4723),
    [anon_sym_constinit] = ACTIONS(4723),
    [anon_sym_consteval] = ACTIONS(4723),
    [anon_sym_PROGMEM] = ACTIONS(4723),
    [aux_sym_primitive_type_token1] = ACTIONS(4723),
    [anon_sym_byte] = ACTIONS(4723),
    [anon_sym_word] = ACTIONS(4723),
    [anon_sym_enum] = ACTIONS(4723),
    [anon_sym_class] = ACTIONS(4723),
    [anon_sym_struct] = ACTIONS(4723),
    [anon_sym_union] = ACTIONS(4723),
    [anon_sym_or] = ACTIONS(4723),
    [anon_sym_and] = ACTIONS(4723),
    [anon_sym_asm] = ACTIONS(4723),
    [anon_sym___asm__] = ACTIONS(4723),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4723),
    [anon_sym_decltype] = ACTIONS(4723),
    [anon_sym_final] = ACTIONS(4723),
    [anon_sym_override] = ACTIONS(4723),
    [anon_sym_virtual] = ACTIONS(4723),
    [anon_sym_alignas] = ACTIONS(4723),
    [anon_sym_explicit] = ACTIONS(4723),
    [anon_sym_typename] = ACTIONS(4723),
    [anon_sym_template] = ACTIONS(4723),
    [anon_sym_GT2] = ACTIONS(4725),
    [anon_sym_operator] = ACTIONS(4723),
    [anon_sym_try] = ACTIONS(4723),
    [anon_sym_friend] = ACTIONS(4723),
    [anon_sym_using] = ACTIONS(4723),
    [anon_sym_concept] = ACTIONS(4723),
    [anon_sym_requires] = ACTIONS(4723),
  },
  [1756] = {
    [sym_identifier] = ACTIONS(4727),
    [anon_sym_COMMA] = ACTIONS(4729),
    [anon_sym_RPAREN] = ACTIONS(4729),
    [anon_sym_LPAREN2] = ACTIONS(4729),
    [anon_sym_TILDE] = ACTIONS(4729),
    [anon_sym_STAR] = ACTIONS(4729),
    [anon_sym_PIPE_PIPE] = ACTIONS(4729),
    [anon_sym_AMP_AMP] = ACTIONS(4729),
    [anon_sym_AMP] = ACTIONS(4727),
    [anon_sym_SEMI] = ACTIONS(4729),
    [anon_sym___extension__] = ACTIONS(4727),
    [anon_sym_extern] = ACTIONS(4727),
    [anon_sym___attribute__] = ACTIONS(4727),
    [anon_sym_COLON_COLON] = ACTIONS(4729),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4729),
    [anon_sym___declspec] = ACTIONS(4727),
    [anon_sym___based] = ACTIONS(4727),
    [anon_sym___cdecl] = ACTIONS(4727),
    [anon_sym___clrcall] = ACTIONS(4727),
    [anon_sym___stdcall] = ACTIONS(4727),
    [anon_sym___fastcall] = ACTIONS(4727),
    [anon_sym___thiscall] = ACTIONS(4727),
    [anon_sym___vectorcall] = ACTIONS(4727),
    [anon_sym_LBRACE] = ACTIONS(4729),
    [anon_sym_signed] = ACTIONS(4727),
    [anon_sym_unsigned] = ACTIONS(4727),
    [anon_sym_long] = ACTIONS(4727),
    [anon_sym_short] = ACTIONS(4727),
    [anon_sym_LBRACK] = ACTIONS(4727),
    [anon_sym_EQ] = ACTIONS(4729),
    [anon_sym_static] = ACTIONS(4727),
    [anon_sym_register] = ACTIONS(4727),
    [anon_sym_inline] = ACTIONS(4727),
    [anon_sym___inline] = ACTIONS(4727),
    [anon_sym___inline__] = ACTIONS(4727),
    [anon_sym___forceinline] = ACTIONS(4727),
    [anon_sym_thread_local] = ACTIONS(4727),
    [anon_sym___thread] = ACTIONS(4727),
    [anon_sym_const] = ACTIONS(4727),
    [anon_sym_constexpr] = ACTIONS(4727),
    [anon_sym_volatile] = ACTIONS(4727),
    [anon_sym_restrict] = ACTIONS(4727),
    [anon_sym___restrict__] = ACTIONS(4727),
    [anon_sym__Atomic] = ACTIONS(4727),
    [anon_sym__Noreturn] = ACTIONS(4727),
    [anon_sym_noreturn] = ACTIONS(4727),
    [anon_sym_mutable] = ACTIONS(4727),
    [anon_sym_constinit] = ACTIONS(4727),
    [anon_sym_consteval] = ACTIONS(4727),
    [anon_sym_PROGMEM] = ACTIONS(4727),
    [aux_sym_primitive_type_token1] = ACTIONS(4727),
    [anon_sym_byte] = ACTIONS(4727),
    [anon_sym_word] = ACTIONS(4727),
    [anon_sym_enum] = ACTIONS(4727),
    [anon_sym_class] = ACTIONS(4727),
    [anon_sym_struct] = ACTIONS(4727),
    [anon_sym_union] = ACTIONS(4727),
    [anon_sym_or] = ACTIONS(4727),
    [anon_sym_and] = ACTIONS(4727),
    [anon_sym_asm] = ACTIONS(4727),
    [anon_sym___asm__] = ACTIONS(4727),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4727),
    [anon_sym_decltype] = ACTIONS(4727),
    [anon_sym_final] = ACTIONS(4727),
    [anon_sym_override] = ACTIONS(4727),
    [anon_sym_virtual] = ACTIONS(4727),
    [anon_sym_alignas] = ACTIONS(4727),
    [anon_sym_explicit] = ACTIONS(4727),
    [anon_sym_typename] = ACTIONS(4727),
    [anon_sym_template] = ACTIONS(4727),
    [anon_sym_GT2] = ACTIONS(4729),
    [anon_sym_operator] = ACTIONS(4727),
    [anon_sym_try] = ACTIONS(4727),
    [anon_sym_friend] = ACTIONS(4727),
    [anon_sym_using] = ACTIONS(4727),
    [anon_sym_concept] = ACTIONS(4727),
    [anon_sym_requires] = ACTIONS(4727),
  },
  [1757] = {
    [sym_identifier] = ACTIONS(4731),
    [anon_sym_COMMA] = ACTIONS(4733),
    [anon_sym_RPAREN] = ACTIONS(4733),
    [anon_sym_LPAREN2] = ACTIONS(4733),
    [anon_sym_TILDE] = ACTIONS(4733),
    [anon_sym_STAR] = ACTIONS(4733),
    [anon_sym_PIPE_PIPE] = ACTIONS(4733),
    [anon_sym_AMP_AMP] = ACTIONS(4733),
    [anon_sym_AMP] = ACTIONS(4731),
    [anon_sym_SEMI] = ACTIONS(4733),
    [anon_sym___extension__] = ACTIONS(4731),
    [anon_sym_extern] = ACTIONS(4731),
    [anon_sym___attribute__] = ACTIONS(4731),
    [anon_sym_COLON_COLON] = ACTIONS(4733),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4733),
    [anon_sym___declspec] = ACTIONS(4731),
    [anon_sym___based] = ACTIONS(4731),
    [anon_sym___cdecl] = ACTIONS(4731),
    [anon_sym___clrcall] = ACTIONS(4731),
    [anon_sym___stdcall] = ACTIONS(4731),
    [anon_sym___fastcall] = ACTIONS(4731),
    [anon_sym___thiscall] = ACTIONS(4731),
    [anon_sym___vectorcall] = ACTIONS(4731),
    [anon_sym_LBRACE] = ACTIONS(4733),
    [anon_sym_signed] = ACTIONS(4731),
    [anon_sym_unsigned] = ACTIONS(4731),
    [anon_sym_long] = ACTIONS(4731),
    [anon_sym_short] = ACTIONS(4731),
    [anon_sym_LBRACK] = ACTIONS(4731),
    [anon_sym_EQ] = ACTIONS(4733),
    [anon_sym_static] = ACTIONS(4731),
    [anon_sym_register] = ACTIONS(4731),
    [anon_sym_inline] = ACTIONS(4731),
    [anon_sym___inline] = ACTIONS(4731),
    [anon_sym___inline__] = ACTIONS(4731),
    [anon_sym___forceinline] = ACTIONS(4731),
    [anon_sym_thread_local] = ACTIONS(4731),
    [anon_sym___thread] = ACTIONS(4731),
    [anon_sym_const] = ACTIONS(4731),
    [anon_sym_constexpr] = ACTIONS(4731),
    [anon_sym_volatile] = ACTIONS(4731),
    [anon_sym_restrict] = ACTIONS(4731),
    [anon_sym___restrict__] = ACTIONS(4731),
    [anon_sym__Atomic] = ACTIONS(4731),
    [anon_sym__Noreturn] = ACTIONS(4731),
    [anon_sym_noreturn] = ACTIONS(4731),
    [anon_sym_mutable] = ACTIONS(4731),
    [anon_sym_constinit] = ACTIONS(4731),
    [anon_sym_consteval] = ACTIONS(4731),
    [anon_sym_PROGMEM] = ACTIONS(4731),
    [aux_sym_primitive_type_token1] = ACTIONS(4731),
    [anon_sym_byte] = ACTIONS(4731),
    [anon_sym_word] = ACTIONS(4731),
    [anon_sym_enum] = ACTIONS(4731),
    [anon_sym_class] = ACTIONS(4731),
    [anon_sym_struct] = ACTIONS(4731),
    [anon_sym_union] = ACTIONS(4731),
    [anon_sym_or] = ACTIONS(4731),
    [anon_sym_and] = ACTIONS(4731),
    [anon_sym_asm] = ACTIONS(4731),
    [anon_sym___asm__] = ACTIONS(4731),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4731),
    [anon_sym_decltype] = ACTIONS(4731),
    [anon_sym_final] = ACTIONS(4731),
    [anon_sym_override] = ACTIONS(4731),
    [anon_sym_virtual] = ACTIONS(4731),
    [anon_sym_alignas] = ACTIONS(4731),
    [anon_sym_explicit] = ACTIONS(4731),
    [anon_sym_typename] = ACTIONS(4731),
    [anon_sym_template] = ACTIONS(4731),
    [anon_sym_GT2] = ACTIONS(4733),
    [anon_sym_operator] = ACTIONS(4731),
    [anon_sym_try] = ACTIONS(4731),
    [anon_sym_friend] = ACTIONS(4731),
    [anon_sym_using] = ACTIONS(4731),
    [anon_sym_concept] = ACTIONS(4731),
    [anon_sym_requires] = ACTIONS(4731),
  },
  [1758] = {
    [sym_identifier] = ACTIONS(4735),
    [anon_sym_COMMA] = ACTIONS(4737),
    [anon_sym_RPAREN] = ACTIONS(4737),
    [anon_sym_LPAREN2] = ACTIONS(4737),
    [anon_sym_TILDE] = ACTIONS(4737),
    [anon_sym_STAR] = ACTIONS(4737),
    [anon_sym_PIPE_PIPE] = ACTIONS(4737),
    [anon_sym_AMP_AMP] = ACTIONS(4737),
    [anon_sym_AMP] = ACTIONS(4735),
    [anon_sym_SEMI] = ACTIONS(4737),
    [anon_sym___extension__] = ACTIONS(4735),
    [anon_sym_extern] = ACTIONS(4735),
    [anon_sym___attribute__] = ACTIONS(4735),
    [anon_sym_COLON_COLON] = ACTIONS(4737),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4737),
    [anon_sym___declspec] = ACTIONS(4735),
    [anon_sym___based] = ACTIONS(4735),
    [anon_sym___cdecl] = ACTIONS(4735),
    [anon_sym___clrcall] = ACTIONS(4735),
    [anon_sym___stdcall] = ACTIONS(4735),
    [anon_sym___fastcall] = ACTIONS(4735),
    [anon_sym___thiscall] = ACTIONS(4735),
    [anon_sym___vectorcall] = ACTIONS(4735),
    [anon_sym_LBRACE] = ACTIONS(4737),
    [anon_sym_signed] = ACTIONS(4735),
    [anon_sym_unsigned] = ACTIONS(4735),
    [anon_sym_long] = ACTIONS(4735),
    [anon_sym_short] = ACTIONS(4735),
    [anon_sym_LBRACK] = ACTIONS(4735),
    [anon_sym_EQ] = ACTIONS(4737),
    [anon_sym_static] = ACTIONS(4735),
    [anon_sym_register] = ACTIONS(4735),
    [anon_sym_inline] = ACTIONS(4735),
    [anon_sym___inline] = ACTIONS(4735),
    [anon_sym___inline__] = ACTIONS(4735),
    [anon_sym___forceinline] = ACTIONS(4735),
    [anon_sym_thread_local] = ACTIONS(4735),
    [anon_sym___thread] = ACTIONS(4735),
    [anon_sym_const] = ACTIONS(4735),
    [anon_sym_constexpr] = ACTIONS(4735),
    [anon_sym_volatile] = ACTIONS(4735),
    [anon_sym_restrict] = ACTIONS(4735),
    [anon_sym___restrict__] = ACTIONS(4735),
    [anon_sym__Atomic] = ACTIONS(4735),
    [anon_sym__Noreturn] = ACTIONS(4735),
    [anon_sym_noreturn] = ACTIONS(4735),
    [anon_sym_mutable] = ACTIONS(4735),
    [anon_sym_constinit] = ACTIONS(4735),
    [anon_sym_consteval] = ACTIONS(4735),
    [anon_sym_PROGMEM] = ACTIONS(4735),
    [aux_sym_primitive_type_token1] = ACTIONS(4735),
    [anon_sym_byte] = ACTIONS(4735),
    [anon_sym_word] = ACTIONS(4735),
    [anon_sym_enum] = ACTIONS(4735),
    [anon_sym_class] = ACTIONS(4735),
    [anon_sym_struct] = ACTIONS(4735),
    [anon_sym_union] = ACTIONS(4735),
    [anon_sym_or] = ACTIONS(4735),
    [anon_sym_and] = ACTIONS(4735),
    [anon_sym_asm] = ACTIONS(4735),
    [anon_sym___asm__] = ACTIONS(4735),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4735),
    [anon_sym_decltype] = ACTIONS(4735),
    [anon_sym_final] = ACTIONS(4735),
    [anon_sym_override] = ACTIONS(4735),
    [anon_sym_virtual] = ACTIONS(4735),
    [anon_sym_alignas] = ACTIONS(4735),
    [anon_sym_explicit] = ACTIONS(4735),
    [anon_sym_typename] = ACTIONS(4735),
    [anon_sym_template] = ACTIONS(4735),
    [anon_sym_GT2] = ACTIONS(4737),
    [anon_sym_operator] = ACTIONS(4735),
    [anon_sym_try] = ACTIONS(4735),
    [anon_sym_friend] = ACTIONS(4735),
    [anon_sym_using] = ACTIONS(4735),
    [anon_sym_concept] = ACTIONS(4735),
    [anon_sym_requires] = ACTIONS(4735),
  },
  [1759] = {
    [sym_identifier] = ACTIONS(4739),
    [anon_sym_COMMA] = ACTIONS(4741),
    [anon_sym_RPAREN] = ACTIONS(4741),
    [anon_sym_LPAREN2] = ACTIONS(4741),
    [anon_sym_TILDE] = ACTIONS(4741),
    [anon_sym_STAR] = ACTIONS(4741),
    [anon_sym_PIPE_PIPE] = ACTIONS(4741),
    [anon_sym_AMP_AMP] = ACTIONS(4741),
    [anon_sym_AMP] = ACTIONS(4739),
    [anon_sym_SEMI] = ACTIONS(4741),
    [anon_sym___extension__] = ACTIONS(4739),
    [anon_sym_extern] = ACTIONS(4739),
    [anon_sym___attribute__] = ACTIONS(4739),
    [anon_sym_COLON_COLON] = ACTIONS(4741),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4741),
    [anon_sym___declspec] = ACTIONS(4739),
    [anon_sym___based] = ACTIONS(4739),
    [anon_sym___cdecl] = ACTIONS(4739),
    [anon_sym___clrcall] = ACTIONS(4739),
    [anon_sym___stdcall] = ACTIONS(4739),
    [anon_sym___fastcall] = ACTIONS(4739),
    [anon_sym___thiscall] = ACTIONS(4739),
    [anon_sym___vectorcall] = ACTIONS(4739),
    [anon_sym_LBRACE] = ACTIONS(4741),
    [anon_sym_signed] = ACTIONS(4739),
    [anon_sym_unsigned] = ACTIONS(4739),
    [anon_sym_long] = ACTIONS(4739),
    [anon_sym_short] = ACTIONS(4739),
    [anon_sym_LBRACK] = ACTIONS(4739),
    [anon_sym_EQ] = ACTIONS(4741),
    [anon_sym_static] = ACTIONS(4739),
    [anon_sym_register] = ACTIONS(4739),
    [anon_sym_inline] = ACTIONS(4739),
    [anon_sym___inline] = ACTIONS(4739),
    [anon_sym___inline__] = ACTIONS(4739),
    [anon_sym___forceinline] = ACTIONS(4739),
    [anon_sym_thread_local] = ACTIONS(4739),
    [anon_sym___thread] = ACTIONS(4739),
    [anon_sym_const] = ACTIONS(4739),
    [anon_sym_constexpr] = ACTIONS(4739),
    [anon_sym_volatile] = ACTIONS(4739),
    [anon_sym_restrict] = ACTIONS(4739),
    [anon_sym___restrict__] = ACTIONS(4739),
    [anon_sym__Atomic] = ACTIONS(4739),
    [anon_sym__Noreturn] = ACTIONS(4739),
    [anon_sym_noreturn] = ACTIONS(4739),
    [anon_sym_mutable] = ACTIONS(4739),
    [anon_sym_constinit] = ACTIONS(4739),
    [anon_sym_consteval] = ACTIONS(4739),
    [anon_sym_PROGMEM] = ACTIONS(4739),
    [aux_sym_primitive_type_token1] = ACTIONS(4739),
    [anon_sym_byte] = ACTIONS(4739),
    [anon_sym_word] = ACTIONS(4739),
    [anon_sym_enum] = ACTIONS(4739),
    [anon_sym_class] = ACTIONS(4739),
    [anon_sym_struct] = ACTIONS(4739),
    [anon_sym_union] = ACTIONS(4739),
    [anon_sym_or] = ACTIONS(4739),
    [anon_sym_and] = ACTIONS(4739),
    [anon_sym_asm] = ACTIONS(4739),
    [anon_sym___asm__] = ACTIONS(4739),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4739),
    [anon_sym_decltype] = ACTIONS(4739),
    [anon_sym_final] = ACTIONS(4739),
    [anon_sym_override] = ACTIONS(4739),
    [anon_sym_virtual] = ACTIONS(4739),
    [anon_sym_alignas] = ACTIONS(4739),
    [anon_sym_explicit] = ACTIONS(4739),
    [anon_sym_typename] = ACTIONS(4739),
    [anon_sym_template] = ACTIONS(4739),
    [anon_sym_GT2] = ACTIONS(4741),
    [anon_sym_operator] = ACTIONS(4739),
    [anon_sym_try] = ACTIONS(4739),
    [anon_sym_friend] = ACTIONS(4739),
    [anon_sym_using] = ACTIONS(4739),
    [anon_sym_concept] = ACTIONS(4739),
    [anon_sym_requires] = ACTIONS(4739),
  },
  [1760] = {
    [sym_string_literal] = STATE(1770),
    [sym_template_argument_list] = STATE(2395),
    [sym_raw_string_literal] = STATE(1770),
    [sym_identifier] = ACTIONS(3769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3761),
    [anon_sym_COMMA] = ACTIONS(3761),
    [anon_sym_RPAREN] = ACTIONS(3761),
    [aux_sym_preproc_if_token2] = ACTIONS(3761),
    [aux_sym_preproc_else_token1] = ACTIONS(3761),
    [aux_sym_preproc_elif_token1] = ACTIONS(3769),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3761),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3761),
    [anon_sym_LPAREN2] = ACTIONS(3761),
    [anon_sym_DASH] = ACTIONS(3769),
    [anon_sym_PLUS] = ACTIONS(3769),
    [anon_sym_STAR] = ACTIONS(3769),
    [anon_sym_SLASH] = ACTIONS(3769),
    [anon_sym_PERCENT] = ACTIONS(3769),
    [anon_sym_PIPE_PIPE] = ACTIONS(3761),
    [anon_sym_AMP_AMP] = ACTIONS(3761),
    [anon_sym_PIPE] = ACTIONS(3769),
    [anon_sym_CARET] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(3769),
    [anon_sym_EQ_EQ] = ACTIONS(3761),
    [anon_sym_BANG_EQ] = ACTIONS(3761),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3761),
    [anon_sym_LT_EQ] = ACTIONS(3769),
    [anon_sym_LT] = ACTIONS(4743),
    [anon_sym_LT_LT] = ACTIONS(3769),
    [anon_sym_GT_GT] = ACTIONS(3769),
    [anon_sym_SEMI] = ACTIONS(3761),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(3785),
    [anon_sym_RBRACE] = ACTIONS(3761),
    [anon_sym_LBRACK] = ACTIONS(3761),
    [anon_sym_RBRACK] = ACTIONS(3761),
    [anon_sym_EQ] = ACTIONS(3769),
    [anon_sym_COLON] = ACTIONS(3769),
    [anon_sym_QMARK] = ACTIONS(3761),
    [anon_sym_STAR_EQ] = ACTIONS(3761),
    [anon_sym_SLASH_EQ] = ACTIONS(3761),
    [anon_sym_PERCENT_EQ] = ACTIONS(3761),
    [anon_sym_PLUS_EQ] = ACTIONS(3761),
    [anon_sym_DASH_EQ] = ACTIONS(3761),
    [anon_sym_LT_LT_EQ] = ACTIONS(3761),
    [anon_sym_GT_GT_EQ] = ACTIONS(3761),
    [anon_sym_AMP_EQ] = ACTIONS(3761),
    [anon_sym_CARET_EQ] = ACTIONS(3761),
    [anon_sym_PIPE_EQ] = ACTIONS(3761),
    [anon_sym_and_eq] = ACTIONS(3769),
    [anon_sym_or_eq] = ACTIONS(3769),
    [anon_sym_xor_eq] = ACTIONS(3769),
    [anon_sym_LT_EQ_GT] = ACTIONS(3761),
    [anon_sym_or] = ACTIONS(3769),
    [anon_sym_and] = ACTIONS(3769),
    [anon_sym_bitor] = ACTIONS(3769),
    [anon_sym_xor] = ACTIONS(3769),
    [anon_sym_bitand] = ACTIONS(3769),
    [anon_sym_not_eq] = ACTIONS(3769),
    [anon_sym_DASH_DASH] = ACTIONS(3761),
    [anon_sym_PLUS_PLUS] = ACTIONS(3761),
    [anon_sym_DOT] = ACTIONS(3769),
    [anon_sym_DOT_STAR] = ACTIONS(3761),
    [anon_sym_DASH_GT] = ACTIONS(3761),
    [anon_sym_L_DQUOTE] = ACTIONS(1911),
    [anon_sym_u_DQUOTE] = ACTIONS(1911),
    [anon_sym_U_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8_DQUOTE] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(1911),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(1921),
    [anon_sym_LR_DQUOTE] = ACTIONS(1921),
    [anon_sym_uR_DQUOTE] = ACTIONS(1921),
    [anon_sym_UR_DQUOTE] = ACTIONS(1921),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1921),
  },
  [1761] = {
    [sym__declaration_modifiers] = STATE(1967),
    [sym__declaration_specifiers] = STATE(4118),
    [sym_attribute_specifier] = STATE(1967),
    [sym_attribute_declaration] = STATE(1967),
    [sym_ms_declspec_modifier] = STATE(1967),
    [sym_storage_class_specifier] = STATE(1967),
    [sym_type_qualifier] = STATE(1967),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_parameter_declaration] = STATE(7020),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(1967),
    [sym_alignas_specifier] = STATE(1967),
    [sym_dependent_type] = STATE(2629),
    [sym_optional_parameter_declaration] = STATE(7020),
    [sym_variadic_parameter_declaration] = STATE(7020),
    [sym_template_type] = STATE(2618),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(6380),
    [sym_qualified_type_identifier] = STATE(3260),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1967),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [sym_identifier] = ACTIONS(4516),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4746),
    [anon_sym_RPAREN] = ACTIONS(4748),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4526),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(1755),
    [anon_sym_class] = ACTIONS(1757),
    [anon_sym_struct] = ACTIONS(1759),
    [anon_sym_union] = ACTIONS(1761),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(1787),
    [anon_sym_template] = ACTIONS(1419),
  },
  [1762] = {
    [sym__declaration_modifiers] = STATE(1967),
    [sym__declaration_specifiers] = STATE(4118),
    [sym_attribute_specifier] = STATE(1967),
    [sym_attribute_declaration] = STATE(1967),
    [sym_ms_declspec_modifier] = STATE(1967),
    [sym_storage_class_specifier] = STATE(1967),
    [sym_type_qualifier] = STATE(1967),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_parameter_declaration] = STATE(6918),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(1967),
    [sym_alignas_specifier] = STATE(1967),
    [sym_dependent_type] = STATE(2629),
    [sym_optional_parameter_declaration] = STATE(6918),
    [sym_variadic_parameter_declaration] = STATE(6918),
    [sym_template_type] = STATE(2618),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(6380),
    [sym_qualified_type_identifier] = STATE(3260),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1967),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [sym_identifier] = ACTIONS(4516),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1801),
    [anon_sym_RPAREN] = ACTIONS(3801),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4526),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(1755),
    [anon_sym_class] = ACTIONS(1757),
    [anon_sym_struct] = ACTIONS(1759),
    [anon_sym_union] = ACTIONS(1761),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(1787),
    [anon_sym_template] = ACTIONS(1419),
  },
  [1763] = {
    [sym_identifier] = ACTIONS(4750),
    [anon_sym_LPAREN2] = ACTIONS(4752),
    [anon_sym_BANG] = ACTIONS(4752),
    [anon_sym_TILDE] = ACTIONS(4752),
    [anon_sym_DASH] = ACTIONS(4750),
    [anon_sym_PLUS] = ACTIONS(4750),
    [anon_sym_STAR] = ACTIONS(4752),
    [anon_sym_AMP] = ACTIONS(4752),
    [anon_sym_SEMI] = ACTIONS(4752),
    [anon_sym_COLON_COLON] = ACTIONS(4752),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4752),
    [anon_sym_LBRACE] = ACTIONS(4752),
    [anon_sym_LBRACK] = ACTIONS(4750),
    [aux_sym_primitive_type_token1] = ACTIONS(4750),
    [anon_sym_byte] = ACTIONS(4750),
    [anon_sym_word] = ACTIONS(4750),
    [anon_sym_if] = ACTIONS(4750),
    [anon_sym_switch] = ACTIONS(4750),
    [anon_sym_case] = ACTIONS(4750),
    [anon_sym_default] = ACTIONS(4750),
    [anon_sym_while] = ACTIONS(4750),
    [anon_sym_do] = ACTIONS(4750),
    [anon_sym_for] = ACTIONS(4750),
    [anon_sym_return] = ACTIONS(4750),
    [anon_sym_break] = ACTIONS(4750),
    [anon_sym_continue] = ACTIONS(4750),
    [anon_sym_goto] = ACTIONS(4750),
    [anon_sym___try] = ACTIONS(4750),
    [anon_sym___leave] = ACTIONS(4750),
    [anon_sym_not] = ACTIONS(4750),
    [anon_sym_compl] = ACTIONS(4750),
    [anon_sym_DASH_DASH] = ACTIONS(4752),
    [anon_sym_PLUS_PLUS] = ACTIONS(4752),
    [anon_sym_sizeof] = ACTIONS(4750),
    [anon_sym___alignof__] = ACTIONS(4750),
    [anon_sym___alignof] = ACTIONS(4750),
    [anon_sym__alignof] = ACTIONS(4750),
    [anon_sym_alignof] = ACTIONS(4750),
    [anon_sym__Alignof] = ACTIONS(4750),
    [anon_sym_offsetof] = ACTIONS(4750),
    [anon_sym__Generic] = ACTIONS(4750),
    [anon_sym_asm] = ACTIONS(4750),
    [anon_sym___asm__] = ACTIONS(4750),
    [aux_sym_number_literal_token1] = ACTIONS(4752),
    [aux_sym_number_literal_token2] = ACTIONS(4750),
    [anon_sym_L_SQUOTE] = ACTIONS(4752),
    [anon_sym_u_SQUOTE] = ACTIONS(4752),
    [anon_sym_U_SQUOTE] = ACTIONS(4752),
    [anon_sym_u8_SQUOTE] = ACTIONS(4752),
    [anon_sym_SQUOTE] = ACTIONS(4752),
    [anon_sym_L_DQUOTE] = ACTIONS(4752),
    [anon_sym_u_DQUOTE] = ACTIONS(4752),
    [anon_sym_U_DQUOTE] = ACTIONS(4752),
    [anon_sym_u8_DQUOTE] = ACTIONS(4752),
    [anon_sym_DQUOTE] = ACTIONS(4752),
    [sym_true] = ACTIONS(4750),
    [sym_false] = ACTIONS(4750),
    [anon_sym_NULL] = ACTIONS(4750),
    [anon_sym_nullptr] = ACTIONS(4750),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(4750),
    [anon_sym_template] = ACTIONS(4750),
    [anon_sym_try] = ACTIONS(4750),
    [anon_sym_delete] = ACTIONS(4750),
    [anon_sym_throw] = ACTIONS(4750),
    [anon_sym_co_return] = ACTIONS(4750),
    [anon_sym_co_yield] = ACTIONS(4750),
    [anon_sym_R_DQUOTE] = ACTIONS(4752),
    [anon_sym_LR_DQUOTE] = ACTIONS(4752),
    [anon_sym_uR_DQUOTE] = ACTIONS(4752),
    [anon_sym_UR_DQUOTE] = ACTIONS(4752),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4752),
    [anon_sym_co_await] = ACTIONS(4750),
    [anon_sym_new] = ACTIONS(4750),
    [anon_sym_requires] = ACTIONS(4750),
    [sym_this] = ACTIONS(4750),
  },
  [1764] = {
    [sym__declaration_modifiers] = STATE(1967),
    [sym__declaration_specifiers] = STATE(4118),
    [sym_attribute_specifier] = STATE(1967),
    [sym_attribute_declaration] = STATE(1967),
    [sym_ms_declspec_modifier] = STATE(1967),
    [sym_storage_class_specifier] = STATE(1967),
    [sym_type_qualifier] = STATE(1967),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_parameter_declaration] = STATE(7230),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(1967),
    [sym_alignas_specifier] = STATE(1967),
    [sym_dependent_type] = STATE(2629),
    [sym_optional_parameter_declaration] = STATE(7230),
    [sym_variadic_parameter_declaration] = STATE(7230),
    [sym_template_type] = STATE(2618),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(6380),
    [sym_qualified_type_identifier] = STATE(3260),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1967),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [sym_identifier] = ACTIONS(4516),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4754),
    [anon_sym_RPAREN] = ACTIONS(4756),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4526),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(1755),
    [anon_sym_class] = ACTIONS(1757),
    [anon_sym_struct] = ACTIONS(1759),
    [anon_sym_union] = ACTIONS(1761),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(1787),
    [anon_sym_template] = ACTIONS(1419),
  },
  [1765] = {
    [sym__declaration_modifiers] = STATE(1967),
    [sym__declaration_specifiers] = STATE(4118),
    [sym_attribute_specifier] = STATE(1967),
    [sym_attribute_declaration] = STATE(1967),
    [sym_ms_declspec_modifier] = STATE(1967),
    [sym_storage_class_specifier] = STATE(1967),
    [sym_type_qualifier] = STATE(1967),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_parameter_declaration] = STATE(6951),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(1967),
    [sym_alignas_specifier] = STATE(1967),
    [sym_dependent_type] = STATE(2629),
    [sym_optional_parameter_declaration] = STATE(6951),
    [sym_variadic_parameter_declaration] = STATE(6951),
    [sym_template_type] = STATE(2618),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(6380),
    [sym_qualified_type_identifier] = STATE(3260),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1967),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [sym_identifier] = ACTIONS(4516),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4758),
    [anon_sym_RPAREN] = ACTIONS(4760),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4526),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(1755),
    [anon_sym_class] = ACTIONS(1757),
    [anon_sym_struct] = ACTIONS(1759),
    [anon_sym_union] = ACTIONS(1761),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(1787),
    [anon_sym_template] = ACTIONS(1419),
  },
  [1766] = {
    [sym_identifier] = ACTIONS(4762),
    [anon_sym_LPAREN2] = ACTIONS(4764),
    [anon_sym_BANG] = ACTIONS(4764),
    [anon_sym_TILDE] = ACTIONS(4764),
    [anon_sym_DASH] = ACTIONS(4762),
    [anon_sym_PLUS] = ACTIONS(4762),
    [anon_sym_STAR] = ACTIONS(4764),
    [anon_sym_AMP] = ACTIONS(4764),
    [anon_sym_SEMI] = ACTIONS(4764),
    [anon_sym_COLON_COLON] = ACTIONS(4764),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4764),
    [anon_sym_LBRACE] = ACTIONS(4764),
    [anon_sym_LBRACK] = ACTIONS(4762),
    [aux_sym_primitive_type_token1] = ACTIONS(4762),
    [anon_sym_byte] = ACTIONS(4762),
    [anon_sym_word] = ACTIONS(4762),
    [anon_sym_if] = ACTIONS(4762),
    [anon_sym_switch] = ACTIONS(4762),
    [anon_sym_case] = ACTIONS(4762),
    [anon_sym_default] = ACTIONS(4762),
    [anon_sym_while] = ACTIONS(4762),
    [anon_sym_do] = ACTIONS(4762),
    [anon_sym_for] = ACTIONS(4762),
    [anon_sym_return] = ACTIONS(4762),
    [anon_sym_break] = ACTIONS(4762),
    [anon_sym_continue] = ACTIONS(4762),
    [anon_sym_goto] = ACTIONS(4762),
    [anon_sym___try] = ACTIONS(4762),
    [anon_sym___leave] = ACTIONS(4762),
    [anon_sym_not] = ACTIONS(4762),
    [anon_sym_compl] = ACTIONS(4762),
    [anon_sym_DASH_DASH] = ACTIONS(4764),
    [anon_sym_PLUS_PLUS] = ACTIONS(4764),
    [anon_sym_sizeof] = ACTIONS(4762),
    [anon_sym___alignof__] = ACTIONS(4762),
    [anon_sym___alignof] = ACTIONS(4762),
    [anon_sym__alignof] = ACTIONS(4762),
    [anon_sym_alignof] = ACTIONS(4762),
    [anon_sym__Alignof] = ACTIONS(4762),
    [anon_sym_offsetof] = ACTIONS(4762),
    [anon_sym__Generic] = ACTIONS(4762),
    [anon_sym_asm] = ACTIONS(4762),
    [anon_sym___asm__] = ACTIONS(4762),
    [aux_sym_number_literal_token1] = ACTIONS(4764),
    [aux_sym_number_literal_token2] = ACTIONS(4762),
    [anon_sym_L_SQUOTE] = ACTIONS(4764),
    [anon_sym_u_SQUOTE] = ACTIONS(4764),
    [anon_sym_U_SQUOTE] = ACTIONS(4764),
    [anon_sym_u8_SQUOTE] = ACTIONS(4764),
    [anon_sym_SQUOTE] = ACTIONS(4764),
    [anon_sym_L_DQUOTE] = ACTIONS(4764),
    [anon_sym_u_DQUOTE] = ACTIONS(4764),
    [anon_sym_U_DQUOTE] = ACTIONS(4764),
    [anon_sym_u8_DQUOTE] = ACTIONS(4764),
    [anon_sym_DQUOTE] = ACTIONS(4764),
    [sym_true] = ACTIONS(4762),
    [sym_false] = ACTIONS(4762),
    [anon_sym_NULL] = ACTIONS(4762),
    [anon_sym_nullptr] = ACTIONS(4762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(4762),
    [anon_sym_template] = ACTIONS(4762),
    [anon_sym_try] = ACTIONS(4762),
    [anon_sym_delete] = ACTIONS(4762),
    [anon_sym_throw] = ACTIONS(4762),
    [anon_sym_co_return] = ACTIONS(4762),
    [anon_sym_co_yield] = ACTIONS(4762),
    [anon_sym_R_DQUOTE] = ACTIONS(4764),
    [anon_sym_LR_DQUOTE] = ACTIONS(4764),
    [anon_sym_uR_DQUOTE] = ACTIONS(4764),
    [anon_sym_UR_DQUOTE] = ACTIONS(4764),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4764),
    [anon_sym_co_await] = ACTIONS(4762),
    [anon_sym_new] = ACTIONS(4762),
    [anon_sym_requires] = ACTIONS(4762),
    [sym_this] = ACTIONS(4762),
  },
  [1767] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1767),
    [sym_identifier] = ACTIONS(4766),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4768),
    [anon_sym_COMMA] = ACTIONS(4768),
    [anon_sym_RPAREN] = ACTIONS(4768),
    [aux_sym_preproc_if_token2] = ACTIONS(4768),
    [aux_sym_preproc_else_token1] = ACTIONS(4768),
    [aux_sym_preproc_elif_token1] = ACTIONS(4766),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4768),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4768),
    [anon_sym_LPAREN2] = ACTIONS(4768),
    [anon_sym_DASH] = ACTIONS(4766),
    [anon_sym_PLUS] = ACTIONS(4766),
    [anon_sym_STAR] = ACTIONS(4768),
    [anon_sym_SLASH] = ACTIONS(4766),
    [anon_sym_PERCENT] = ACTIONS(4768),
    [anon_sym_PIPE_PIPE] = ACTIONS(4768),
    [anon_sym_AMP_AMP] = ACTIONS(4768),
    [anon_sym_PIPE] = ACTIONS(4766),
    [anon_sym_CARET] = ACTIONS(4768),
    [anon_sym_AMP] = ACTIONS(4766),
    [anon_sym_EQ_EQ] = ACTIONS(4768),
    [anon_sym_BANG_EQ] = ACTIONS(4768),
    [anon_sym_GT] = ACTIONS(4766),
    [anon_sym_GT_EQ] = ACTIONS(4768),
    [anon_sym_LT_EQ] = ACTIONS(4766),
    [anon_sym_LT] = ACTIONS(4766),
    [anon_sym_LT_LT] = ACTIONS(4768),
    [anon_sym_GT_GT] = ACTIONS(4768),
    [anon_sym_SEMI] = ACTIONS(4768),
    [anon_sym___extension__] = ACTIONS(4766),
    [anon_sym___attribute__] = ACTIONS(4766),
    [anon_sym_LBRACE] = ACTIONS(4768),
    [anon_sym_RBRACE] = ACTIONS(4768),
    [anon_sym_signed] = ACTIONS(4770),
    [anon_sym_unsigned] = ACTIONS(4770),
    [anon_sym_long] = ACTIONS(4770),
    [anon_sym_short] = ACTIONS(4770),
    [anon_sym_LBRACK] = ACTIONS(4768),
    [anon_sym_RBRACK] = ACTIONS(4768),
    [anon_sym_const] = ACTIONS(4766),
    [anon_sym_constexpr] = ACTIONS(4766),
    [anon_sym_volatile] = ACTIONS(4766),
    [anon_sym_restrict] = ACTIONS(4766),
    [anon_sym___restrict__] = ACTIONS(4766),
    [anon_sym__Atomic] = ACTIONS(4766),
    [anon_sym__Noreturn] = ACTIONS(4766),
    [anon_sym_noreturn] = ACTIONS(4766),
    [anon_sym_mutable] = ACTIONS(4766),
    [anon_sym_constinit] = ACTIONS(4766),
    [anon_sym_consteval] = ACTIONS(4766),
    [anon_sym_PROGMEM] = ACTIONS(4766),
    [aux_sym_primitive_type_token1] = ACTIONS(4766),
    [anon_sym_byte] = ACTIONS(4766),
    [anon_sym_word] = ACTIONS(4766),
    [anon_sym_COLON] = ACTIONS(4768),
    [anon_sym_QMARK] = ACTIONS(4768),
    [anon_sym_LT_EQ_GT] = ACTIONS(4768),
    [anon_sym_or] = ACTIONS(4766),
    [anon_sym_and] = ACTIONS(4766),
    [anon_sym_bitor] = ACTIONS(4766),
    [anon_sym_xor] = ACTIONS(4766),
    [anon_sym_bitand] = ACTIONS(4766),
    [anon_sym_not_eq] = ACTIONS(4766),
    [anon_sym_DASH_DASH] = ACTIONS(4768),
    [anon_sym_PLUS_PLUS] = ACTIONS(4768),
    [anon_sym_DOT] = ACTIONS(4766),
    [anon_sym_DOT_STAR] = ACTIONS(4768),
    [anon_sym_DASH_GT] = ACTIONS(4768),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4766),
    [anon_sym_decltype] = ACTIONS(4766),
    [anon_sym_final] = ACTIONS(4766),
    [anon_sym_override] = ACTIONS(4766),
    [anon_sym_requires] = ACTIONS(4766),
  },
  [1768] = {
    [sym__declaration_modifiers] = STATE(1967),
    [sym__declaration_specifiers] = STATE(4118),
    [sym_attribute_specifier] = STATE(1967),
    [sym_attribute_declaration] = STATE(1967),
    [sym_ms_declspec_modifier] = STATE(1967),
    [sym_storage_class_specifier] = STATE(1967),
    [sym_type_qualifier] = STATE(1967),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_parameter_declaration] = STATE(7326),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(1967),
    [sym_alignas_specifier] = STATE(1967),
    [sym_dependent_type] = STATE(2629),
    [sym_optional_parameter_declaration] = STATE(7326),
    [sym_variadic_parameter_declaration] = STATE(7326),
    [sym_template_type] = STATE(2618),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(6380),
    [sym_qualified_type_identifier] = STATE(3260),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1967),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [sym_identifier] = ACTIONS(4516),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4773),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4526),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(1755),
    [anon_sym_class] = ACTIONS(1757),
    [anon_sym_struct] = ACTIONS(1759),
    [anon_sym_union] = ACTIONS(1761),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(1787),
    [anon_sym_template] = ACTIONS(1419),
  },
  [1769] = {
    [sym__declaration_modifiers] = STATE(1967),
    [sym__declaration_specifiers] = STATE(4118),
    [sym_attribute_specifier] = STATE(1967),
    [sym_attribute_declaration] = STATE(1967),
    [sym_ms_declspec_modifier] = STATE(1967),
    [sym_storage_class_specifier] = STATE(1967),
    [sym_type_qualifier] = STATE(1967),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_parameter_declaration] = STATE(6870),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(1967),
    [sym_alignas_specifier] = STATE(1967),
    [sym_dependent_type] = STATE(2629),
    [sym_optional_parameter_declaration] = STATE(6870),
    [sym_variadic_parameter_declaration] = STATE(6870),
    [sym_template_type] = STATE(2618),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(6380),
    [sym_qualified_type_identifier] = STATE(3260),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1967),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [sym_identifier] = ACTIONS(4516),
    [anon_sym_RPAREN] = ACTIONS(1743),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4526),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(1755),
    [anon_sym_class] = ACTIONS(1757),
    [anon_sym_struct] = ACTIONS(1759),
    [anon_sym_union] = ACTIONS(1761),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(1787),
    [anon_sym_template] = ACTIONS(1419),
  },
  [1770] = {
    [sym_string_literal] = STATE(1771),
    [sym_raw_string_literal] = STATE(1771),
    [aux_sym_concatenated_string_repeat1] = STATE(1771),
    [sym_identifier] = ACTIONS(4775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4777),
    [anon_sym_COMMA] = ACTIONS(4777),
    [anon_sym_RPAREN] = ACTIONS(4777),
    [aux_sym_preproc_if_token2] = ACTIONS(4777),
    [aux_sym_preproc_else_token1] = ACTIONS(4777),
    [aux_sym_preproc_elif_token1] = ACTIONS(4779),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4777),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4777),
    [anon_sym_LPAREN2] = ACTIONS(4777),
    [anon_sym_DASH] = ACTIONS(4779),
    [anon_sym_PLUS] = ACTIONS(4779),
    [anon_sym_STAR] = ACTIONS(4779),
    [anon_sym_SLASH] = ACTIONS(4779),
    [anon_sym_PERCENT] = ACTIONS(4779),
    [anon_sym_PIPE_PIPE] = ACTIONS(4777),
    [anon_sym_AMP_AMP] = ACTIONS(4777),
    [anon_sym_PIPE] = ACTIONS(4779),
    [anon_sym_CARET] = ACTIONS(4779),
    [anon_sym_AMP] = ACTIONS(4779),
    [anon_sym_EQ_EQ] = ACTIONS(4777),
    [anon_sym_BANG_EQ] = ACTIONS(4777),
    [anon_sym_GT] = ACTIONS(4779),
    [anon_sym_GT_EQ] = ACTIONS(4777),
    [anon_sym_LT_EQ] = ACTIONS(4779),
    [anon_sym_LT] = ACTIONS(4779),
    [anon_sym_LT_LT] = ACTIONS(4779),
    [anon_sym_GT_GT] = ACTIONS(4779),
    [anon_sym_SEMI] = ACTIONS(4777),
    [anon_sym_RBRACE] = ACTIONS(4777),
    [anon_sym_LBRACK] = ACTIONS(4777),
    [anon_sym_RBRACK] = ACTIONS(4777),
    [anon_sym_EQ] = ACTIONS(4779),
    [anon_sym_COLON] = ACTIONS(4777),
    [anon_sym_QMARK] = ACTIONS(4777),
    [anon_sym_STAR_EQ] = ACTIONS(4777),
    [anon_sym_SLASH_EQ] = ACTIONS(4777),
    [anon_sym_PERCENT_EQ] = ACTIONS(4777),
    [anon_sym_PLUS_EQ] = ACTIONS(4777),
    [anon_sym_DASH_EQ] = ACTIONS(4777),
    [anon_sym_LT_LT_EQ] = ACTIONS(4777),
    [anon_sym_GT_GT_EQ] = ACTIONS(4777),
    [anon_sym_AMP_EQ] = ACTIONS(4777),
    [anon_sym_CARET_EQ] = ACTIONS(4777),
    [anon_sym_PIPE_EQ] = ACTIONS(4777),
    [anon_sym_and_eq] = ACTIONS(4779),
    [anon_sym_or_eq] = ACTIONS(4779),
    [anon_sym_xor_eq] = ACTIONS(4779),
    [anon_sym_LT_EQ_GT] = ACTIONS(4777),
    [anon_sym_or] = ACTIONS(4779),
    [anon_sym_and] = ACTIONS(4779),
    [anon_sym_bitor] = ACTIONS(4779),
    [anon_sym_xor] = ACTIONS(4779),
    [anon_sym_bitand] = ACTIONS(4779),
    [anon_sym_not_eq] = ACTIONS(4779),
    [anon_sym_DASH_DASH] = ACTIONS(4777),
    [anon_sym_PLUS_PLUS] = ACTIONS(4777),
    [anon_sym_DOT] = ACTIONS(4779),
    [anon_sym_DOT_STAR] = ACTIONS(4777),
    [anon_sym_DASH_GT] = ACTIONS(4777),
    [anon_sym_L_DQUOTE] = ACTIONS(1911),
    [anon_sym_u_DQUOTE] = ACTIONS(1911),
    [anon_sym_U_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8_DQUOTE] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(1911),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(1921),
    [anon_sym_LR_DQUOTE] = ACTIONS(1921),
    [anon_sym_uR_DQUOTE] = ACTIONS(1921),
    [anon_sym_UR_DQUOTE] = ACTIONS(1921),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1921),
    [sym_literal_suffix] = ACTIONS(4779),
  },
  [1771] = {
    [sym_string_literal] = STATE(1772),
    [sym_raw_string_literal] = STATE(1772),
    [aux_sym_concatenated_string_repeat1] = STATE(1772),
    [sym_identifier] = ACTIONS(4781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4783),
    [anon_sym_COMMA] = ACTIONS(4783),
    [anon_sym_RPAREN] = ACTIONS(4783),
    [aux_sym_preproc_if_token2] = ACTIONS(4783),
    [aux_sym_preproc_else_token1] = ACTIONS(4783),
    [aux_sym_preproc_elif_token1] = ACTIONS(4785),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4783),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4783),
    [anon_sym_LPAREN2] = ACTIONS(4783),
    [anon_sym_DASH] = ACTIONS(4785),
    [anon_sym_PLUS] = ACTIONS(4785),
    [anon_sym_STAR] = ACTIONS(4785),
    [anon_sym_SLASH] = ACTIONS(4785),
    [anon_sym_PERCENT] = ACTIONS(4785),
    [anon_sym_PIPE_PIPE] = ACTIONS(4783),
    [anon_sym_AMP_AMP] = ACTIONS(4783),
    [anon_sym_PIPE] = ACTIONS(4785),
    [anon_sym_CARET] = ACTIONS(4785),
    [anon_sym_AMP] = ACTIONS(4785),
    [anon_sym_EQ_EQ] = ACTIONS(4783),
    [anon_sym_BANG_EQ] = ACTIONS(4783),
    [anon_sym_GT] = ACTIONS(4785),
    [anon_sym_GT_EQ] = ACTIONS(4783),
    [anon_sym_LT_EQ] = ACTIONS(4785),
    [anon_sym_LT] = ACTIONS(4785),
    [anon_sym_LT_LT] = ACTIONS(4785),
    [anon_sym_GT_GT] = ACTIONS(4785),
    [anon_sym_SEMI] = ACTIONS(4783),
    [anon_sym_RBRACE] = ACTIONS(4783),
    [anon_sym_LBRACK] = ACTIONS(4783),
    [anon_sym_RBRACK] = ACTIONS(4783),
    [anon_sym_EQ] = ACTIONS(4785),
    [anon_sym_COLON] = ACTIONS(4783),
    [anon_sym_QMARK] = ACTIONS(4783),
    [anon_sym_STAR_EQ] = ACTIONS(4783),
    [anon_sym_SLASH_EQ] = ACTIONS(4783),
    [anon_sym_PERCENT_EQ] = ACTIONS(4783),
    [anon_sym_PLUS_EQ] = ACTIONS(4783),
    [anon_sym_DASH_EQ] = ACTIONS(4783),
    [anon_sym_LT_LT_EQ] = ACTIONS(4783),
    [anon_sym_GT_GT_EQ] = ACTIONS(4783),
    [anon_sym_AMP_EQ] = ACTIONS(4783),
    [anon_sym_CARET_EQ] = ACTIONS(4783),
    [anon_sym_PIPE_EQ] = ACTIONS(4783),
    [anon_sym_and_eq] = ACTIONS(4785),
    [anon_sym_or_eq] = ACTIONS(4785),
    [anon_sym_xor_eq] = ACTIONS(4785),
    [anon_sym_LT_EQ_GT] = ACTIONS(4783),
    [anon_sym_or] = ACTIONS(4785),
    [anon_sym_and] = ACTIONS(4785),
    [anon_sym_bitor] = ACTIONS(4785),
    [anon_sym_xor] = ACTIONS(4785),
    [anon_sym_bitand] = ACTIONS(4785),
    [anon_sym_not_eq] = ACTIONS(4785),
    [anon_sym_DASH_DASH] = ACTIONS(4783),
    [anon_sym_PLUS_PLUS] = ACTIONS(4783),
    [anon_sym_DOT] = ACTIONS(4785),
    [anon_sym_DOT_STAR] = ACTIONS(4783),
    [anon_sym_DASH_GT] = ACTIONS(4783),
    [anon_sym_L_DQUOTE] = ACTIONS(1911),
    [anon_sym_u_DQUOTE] = ACTIONS(1911),
    [anon_sym_U_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8_DQUOTE] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(1911),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(1921),
    [anon_sym_LR_DQUOTE] = ACTIONS(1921),
    [anon_sym_uR_DQUOTE] = ACTIONS(1921),
    [anon_sym_UR_DQUOTE] = ACTIONS(1921),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1921),
    [sym_literal_suffix] = ACTIONS(4785),
  },
  [1772] = {
    [sym_string_literal] = STATE(1772),
    [sym_raw_string_literal] = STATE(1772),
    [aux_sym_concatenated_string_repeat1] = STATE(1772),
    [sym_identifier] = ACTIONS(4787),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4790),
    [anon_sym_COMMA] = ACTIONS(4790),
    [anon_sym_RPAREN] = ACTIONS(4790),
    [aux_sym_preproc_if_token2] = ACTIONS(4790),
    [aux_sym_preproc_else_token1] = ACTIONS(4790),
    [aux_sym_preproc_elif_token1] = ACTIONS(4792),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4790),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4790),
    [anon_sym_LPAREN2] = ACTIONS(4790),
    [anon_sym_DASH] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(4792),
    [anon_sym_STAR] = ACTIONS(4792),
    [anon_sym_SLASH] = ACTIONS(4792),
    [anon_sym_PERCENT] = ACTIONS(4792),
    [anon_sym_PIPE_PIPE] = ACTIONS(4790),
    [anon_sym_AMP_AMP] = ACTIONS(4790),
    [anon_sym_PIPE] = ACTIONS(4792),
    [anon_sym_CARET] = ACTIONS(4792),
    [anon_sym_AMP] = ACTIONS(4792),
    [anon_sym_EQ_EQ] = ACTIONS(4790),
    [anon_sym_BANG_EQ] = ACTIONS(4790),
    [anon_sym_GT] = ACTIONS(4792),
    [anon_sym_GT_EQ] = ACTIONS(4790),
    [anon_sym_LT_EQ] = ACTIONS(4792),
    [anon_sym_LT] = ACTIONS(4792),
    [anon_sym_LT_LT] = ACTIONS(4792),
    [anon_sym_GT_GT] = ACTIONS(4792),
    [anon_sym_SEMI] = ACTIONS(4790),
    [anon_sym_RBRACE] = ACTIONS(4790),
    [anon_sym_LBRACK] = ACTIONS(4790),
    [anon_sym_RBRACK] = ACTIONS(4790),
    [anon_sym_EQ] = ACTIONS(4792),
    [anon_sym_COLON] = ACTIONS(4790),
    [anon_sym_QMARK] = ACTIONS(4790),
    [anon_sym_STAR_EQ] = ACTIONS(4790),
    [anon_sym_SLASH_EQ] = ACTIONS(4790),
    [anon_sym_PERCENT_EQ] = ACTIONS(4790),
    [anon_sym_PLUS_EQ] = ACTIONS(4790),
    [anon_sym_DASH_EQ] = ACTIONS(4790),
    [anon_sym_LT_LT_EQ] = ACTIONS(4790),
    [anon_sym_GT_GT_EQ] = ACTIONS(4790),
    [anon_sym_AMP_EQ] = ACTIONS(4790),
    [anon_sym_CARET_EQ] = ACTIONS(4790),
    [anon_sym_PIPE_EQ] = ACTIONS(4790),
    [anon_sym_and_eq] = ACTIONS(4792),
    [anon_sym_or_eq] = ACTIONS(4792),
    [anon_sym_xor_eq] = ACTIONS(4792),
    [anon_sym_LT_EQ_GT] = ACTIONS(4790),
    [anon_sym_or] = ACTIONS(4792),
    [anon_sym_and] = ACTIONS(4792),
    [anon_sym_bitor] = ACTIONS(4792),
    [anon_sym_xor] = ACTIONS(4792),
    [anon_sym_bitand] = ACTIONS(4792),
    [anon_sym_not_eq] = ACTIONS(4792),
    [anon_sym_DASH_DASH] = ACTIONS(4790),
    [anon_sym_PLUS_PLUS] = ACTIONS(4790),
    [anon_sym_DOT] = ACTIONS(4792),
    [anon_sym_DOT_STAR] = ACTIONS(4790),
    [anon_sym_DASH_GT] = ACTIONS(4790),
    [anon_sym_L_DQUOTE] = ACTIONS(4794),
    [anon_sym_u_DQUOTE] = ACTIONS(4794),
    [anon_sym_U_DQUOTE] = ACTIONS(4794),
    [anon_sym_u8_DQUOTE] = ACTIONS(4794),
    [anon_sym_DQUOTE] = ACTIONS(4794),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4797),
    [anon_sym_LR_DQUOTE] = ACTIONS(4797),
    [anon_sym_uR_DQUOTE] = ACTIONS(4797),
    [anon_sym_UR_DQUOTE] = ACTIONS(4797),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4797),
    [sym_literal_suffix] = ACTIONS(4792),
  },
  [1773] = {
    [sym_catch_clause] = STATE(1778),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1778),
    [sym_identifier] = ACTIONS(2482),
    [aux_sym_preproc_def_token1] = ACTIONS(2482),
    [aux_sym_preproc_if_token1] = ACTIONS(2482),
    [aux_sym_preproc_if_token2] = ACTIONS(2482),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2482),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2482),
    [aux_sym_preproc_else_token1] = ACTIONS(2482),
    [aux_sym_preproc_elif_token1] = ACTIONS(2482),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2482),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2482),
    [sym_preproc_directive] = ACTIONS(2482),
    [anon_sym_LPAREN2] = ACTIONS(2484),
    [anon_sym_TILDE] = ACTIONS(2484),
    [anon_sym_STAR] = ACTIONS(2484),
    [anon_sym_AMP_AMP] = ACTIONS(2484),
    [anon_sym_AMP] = ACTIONS(2482),
    [anon_sym___extension__] = ACTIONS(2482),
    [anon_sym_typedef] = ACTIONS(2482),
    [anon_sym_extern] = ACTIONS(2482),
    [anon_sym___attribute__] = ACTIONS(2482),
    [anon_sym_COLON_COLON] = ACTIONS(2484),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2484),
    [anon_sym___declspec] = ACTIONS(2482),
    [anon_sym___based] = ACTIONS(2482),
    [anon_sym_signed] = ACTIONS(2482),
    [anon_sym_unsigned] = ACTIONS(2482),
    [anon_sym_long] = ACTIONS(2482),
    [anon_sym_short] = ACTIONS(2482),
    [anon_sym_LBRACK] = ACTIONS(2482),
    [anon_sym_static] = ACTIONS(2482),
    [anon_sym_register] = ACTIONS(2482),
    [anon_sym_inline] = ACTIONS(2482),
    [anon_sym___inline] = ACTIONS(2482),
    [anon_sym___inline__] = ACTIONS(2482),
    [anon_sym___forceinline] = ACTIONS(2482),
    [anon_sym_thread_local] = ACTIONS(2482),
    [anon_sym___thread] = ACTIONS(2482),
    [anon_sym_const] = ACTIONS(2482),
    [anon_sym_constexpr] = ACTIONS(2482),
    [anon_sym_volatile] = ACTIONS(2482),
    [anon_sym_restrict] = ACTIONS(2482),
    [anon_sym___restrict__] = ACTIONS(2482),
    [anon_sym__Atomic] = ACTIONS(2482),
    [anon_sym__Noreturn] = ACTIONS(2482),
    [anon_sym_noreturn] = ACTIONS(2482),
    [anon_sym_mutable] = ACTIONS(2482),
    [anon_sym_constinit] = ACTIONS(2482),
    [anon_sym_consteval] = ACTIONS(2482),
    [anon_sym_PROGMEM] = ACTIONS(2482),
    [aux_sym_primitive_type_token1] = ACTIONS(2482),
    [anon_sym_byte] = ACTIONS(2482),
    [anon_sym_word] = ACTIONS(2482),
    [anon_sym_enum] = ACTIONS(2482),
    [anon_sym_class] = ACTIONS(2482),
    [anon_sym_struct] = ACTIONS(2482),
    [anon_sym_union] = ACTIONS(2482),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2482),
    [anon_sym_decltype] = ACTIONS(2482),
    [anon_sym_virtual] = ACTIONS(2482),
    [anon_sym_alignas] = ACTIONS(2482),
    [anon_sym_explicit] = ACTIONS(2482),
    [anon_sym_typename] = ACTIONS(2482),
    [anon_sym_template] = ACTIONS(2482),
    [anon_sym_operator] = ACTIONS(2482),
    [anon_sym_friend] = ACTIONS(2482),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_using] = ACTIONS(2482),
    [anon_sym_static_assert] = ACTIONS(2482),
    [anon_sym_catch] = ACTIONS(4800),
  },
  [1774] = {
    [sym_catch_clause] = STATE(1778),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1778),
    [sym_identifier] = ACTIONS(2492),
    [aux_sym_preproc_def_token1] = ACTIONS(2492),
    [aux_sym_preproc_if_token1] = ACTIONS(2492),
    [aux_sym_preproc_if_token2] = ACTIONS(2492),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2492),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2492),
    [aux_sym_preproc_else_token1] = ACTIONS(2492),
    [aux_sym_preproc_elif_token1] = ACTIONS(2492),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2492),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2492),
    [sym_preproc_directive] = ACTIONS(2492),
    [anon_sym_LPAREN2] = ACTIONS(2494),
    [anon_sym_TILDE] = ACTIONS(2494),
    [anon_sym_STAR] = ACTIONS(2494),
    [anon_sym_AMP_AMP] = ACTIONS(2494),
    [anon_sym_AMP] = ACTIONS(2492),
    [anon_sym___extension__] = ACTIONS(2492),
    [anon_sym_typedef] = ACTIONS(2492),
    [anon_sym_extern] = ACTIONS(2492),
    [anon_sym___attribute__] = ACTIONS(2492),
    [anon_sym_COLON_COLON] = ACTIONS(2494),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2494),
    [anon_sym___declspec] = ACTIONS(2492),
    [anon_sym___based] = ACTIONS(2492),
    [anon_sym_signed] = ACTIONS(2492),
    [anon_sym_unsigned] = ACTIONS(2492),
    [anon_sym_long] = ACTIONS(2492),
    [anon_sym_short] = ACTIONS(2492),
    [anon_sym_LBRACK] = ACTIONS(2492),
    [anon_sym_static] = ACTIONS(2492),
    [anon_sym_register] = ACTIONS(2492),
    [anon_sym_inline] = ACTIONS(2492),
    [anon_sym___inline] = ACTIONS(2492),
    [anon_sym___inline__] = ACTIONS(2492),
    [anon_sym___forceinline] = ACTIONS(2492),
    [anon_sym_thread_local] = ACTIONS(2492),
    [anon_sym___thread] = ACTIONS(2492),
    [anon_sym_const] = ACTIONS(2492),
    [anon_sym_constexpr] = ACTIONS(2492),
    [anon_sym_volatile] = ACTIONS(2492),
    [anon_sym_restrict] = ACTIONS(2492),
    [anon_sym___restrict__] = ACTIONS(2492),
    [anon_sym__Atomic] = ACTIONS(2492),
    [anon_sym__Noreturn] = ACTIONS(2492),
    [anon_sym_noreturn] = ACTIONS(2492),
    [anon_sym_mutable] = ACTIONS(2492),
    [anon_sym_constinit] = ACTIONS(2492),
    [anon_sym_consteval] = ACTIONS(2492),
    [anon_sym_PROGMEM] = ACTIONS(2492),
    [aux_sym_primitive_type_token1] = ACTIONS(2492),
    [anon_sym_byte] = ACTIONS(2492),
    [anon_sym_word] = ACTIONS(2492),
    [anon_sym_enum] = ACTIONS(2492),
    [anon_sym_class] = ACTIONS(2492),
    [anon_sym_struct] = ACTIONS(2492),
    [anon_sym_union] = ACTIONS(2492),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2492),
    [anon_sym_decltype] = ACTIONS(2492),
    [anon_sym_virtual] = ACTIONS(2492),
    [anon_sym_alignas] = ACTIONS(2492),
    [anon_sym_explicit] = ACTIONS(2492),
    [anon_sym_typename] = ACTIONS(2492),
    [anon_sym_template] = ACTIONS(2492),
    [anon_sym_operator] = ACTIONS(2492),
    [anon_sym_friend] = ACTIONS(2492),
    [anon_sym_public] = ACTIONS(2492),
    [anon_sym_private] = ACTIONS(2492),
    [anon_sym_protected] = ACTIONS(2492),
    [anon_sym_using] = ACTIONS(2492),
    [anon_sym_static_assert] = ACTIONS(2492),
    [anon_sym_catch] = ACTIONS(4800),
  },
  [1775] = {
    [sym__declaration_modifiers] = STATE(1967),
    [sym__declaration_specifiers] = STATE(4118),
    [sym_attribute_specifier] = STATE(1967),
    [sym_attribute_declaration] = STATE(1967),
    [sym_ms_declspec_modifier] = STATE(1967),
    [sym_storage_class_specifier] = STATE(1967),
    [sym_type_qualifier] = STATE(1967),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_parameter_declaration] = STATE(7318),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(1967),
    [sym_alignas_specifier] = STATE(1967),
    [sym_dependent_type] = STATE(2629),
    [sym_optional_parameter_declaration] = STATE(7318),
    [sym_variadic_parameter_declaration] = STATE(7318),
    [sym_template_type] = STATE(2618),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(6380),
    [sym_qualified_type_identifier] = STATE(3260),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1967),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [sym_identifier] = ACTIONS(4516),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4526),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(1755),
    [anon_sym_class] = ACTIONS(1757),
    [anon_sym_struct] = ACTIONS(1759),
    [anon_sym_union] = ACTIONS(1761),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(1787),
    [anon_sym_template] = ACTIONS(1419),
  },
  [1776] = {
    [sym_catch_clause] = STATE(1778),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1778),
    [sym_identifier] = ACTIONS(2488),
    [aux_sym_preproc_def_token1] = ACTIONS(2488),
    [aux_sym_preproc_if_token1] = ACTIONS(2488),
    [aux_sym_preproc_if_token2] = ACTIONS(2488),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2488),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2488),
    [aux_sym_preproc_else_token1] = ACTIONS(2488),
    [aux_sym_preproc_elif_token1] = ACTIONS(2488),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2488),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2488),
    [sym_preproc_directive] = ACTIONS(2488),
    [anon_sym_LPAREN2] = ACTIONS(2490),
    [anon_sym_TILDE] = ACTIONS(2490),
    [anon_sym_STAR] = ACTIONS(2490),
    [anon_sym_AMP_AMP] = ACTIONS(2490),
    [anon_sym_AMP] = ACTIONS(2488),
    [anon_sym___extension__] = ACTIONS(2488),
    [anon_sym_typedef] = ACTIONS(2488),
    [anon_sym_extern] = ACTIONS(2488),
    [anon_sym___attribute__] = ACTIONS(2488),
    [anon_sym_COLON_COLON] = ACTIONS(2490),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2490),
    [anon_sym___declspec] = ACTIONS(2488),
    [anon_sym___based] = ACTIONS(2488),
    [anon_sym_signed] = ACTIONS(2488),
    [anon_sym_unsigned] = ACTIONS(2488),
    [anon_sym_long] = ACTIONS(2488),
    [anon_sym_short] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(2488),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_register] = ACTIONS(2488),
    [anon_sym_inline] = ACTIONS(2488),
    [anon_sym___inline] = ACTIONS(2488),
    [anon_sym___inline__] = ACTIONS(2488),
    [anon_sym___forceinline] = ACTIONS(2488),
    [anon_sym_thread_local] = ACTIONS(2488),
    [anon_sym___thread] = ACTIONS(2488),
    [anon_sym_const] = ACTIONS(2488),
    [anon_sym_constexpr] = ACTIONS(2488),
    [anon_sym_volatile] = ACTIONS(2488),
    [anon_sym_restrict] = ACTIONS(2488),
    [anon_sym___restrict__] = ACTIONS(2488),
    [anon_sym__Atomic] = ACTIONS(2488),
    [anon_sym__Noreturn] = ACTIONS(2488),
    [anon_sym_noreturn] = ACTIONS(2488),
    [anon_sym_mutable] = ACTIONS(2488),
    [anon_sym_constinit] = ACTIONS(2488),
    [anon_sym_consteval] = ACTIONS(2488),
    [anon_sym_PROGMEM] = ACTIONS(2488),
    [aux_sym_primitive_type_token1] = ACTIONS(2488),
    [anon_sym_byte] = ACTIONS(2488),
    [anon_sym_word] = ACTIONS(2488),
    [anon_sym_enum] = ACTIONS(2488),
    [anon_sym_class] = ACTIONS(2488),
    [anon_sym_struct] = ACTIONS(2488),
    [anon_sym_union] = ACTIONS(2488),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2488),
    [anon_sym_decltype] = ACTIONS(2488),
    [anon_sym_virtual] = ACTIONS(2488),
    [anon_sym_alignas] = ACTIONS(2488),
    [anon_sym_explicit] = ACTIONS(2488),
    [anon_sym_typename] = ACTIONS(2488),
    [anon_sym_template] = ACTIONS(2488),
    [anon_sym_operator] = ACTIONS(2488),
    [anon_sym_friend] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_using] = ACTIONS(2488),
    [anon_sym_static_assert] = ACTIONS(2488),
    [anon_sym_catch] = ACTIONS(4800),
  },
  [1777] = {
    [sym_identifier] = ACTIONS(4575),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4579),
    [anon_sym_COMMA] = ACTIONS(4579),
    [anon_sym_RPAREN] = ACTIONS(4579),
    [anon_sym_LPAREN2] = ACTIONS(4579),
    [anon_sym_TILDE] = ACTIONS(4582),
    [anon_sym_DASH] = ACTIONS(4584),
    [anon_sym_PLUS] = ACTIONS(4584),
    [anon_sym_STAR] = ACTIONS(4579),
    [anon_sym_SLASH] = ACTIONS(4584),
    [anon_sym_PERCENT] = ACTIONS(4577),
    [anon_sym_PIPE_PIPE] = ACTIONS(4577),
    [anon_sym_AMP_AMP] = ACTIONS(4579),
    [anon_sym_PIPE] = ACTIONS(4584),
    [anon_sym_CARET] = ACTIONS(4577),
    [anon_sym_AMP] = ACTIONS(4586),
    [anon_sym_EQ_EQ] = ACTIONS(4577),
    [anon_sym_BANG_EQ] = ACTIONS(4577),
    [anon_sym_GT] = ACTIONS(4584),
    [anon_sym_GT_EQ] = ACTIONS(4577),
    [anon_sym_LT_EQ] = ACTIONS(4584),
    [anon_sym_LT] = ACTIONS(4584),
    [anon_sym_LT_LT] = ACTIONS(4577),
    [anon_sym_GT_GT] = ACTIONS(4577),
    [anon_sym___extension__] = ACTIONS(4575),
    [anon_sym_extern] = ACTIONS(4575),
    [anon_sym___attribute__] = ACTIONS(4575),
    [anon_sym_COLON_COLON] = ACTIONS(4582),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4582),
    [anon_sym___declspec] = ACTIONS(4575),
    [anon_sym___based] = ACTIONS(4575),
    [anon_sym_LBRACE] = ACTIONS(4582),
    [anon_sym_LBRACK] = ACTIONS(4586),
    [anon_sym_EQ] = ACTIONS(4575),
    [anon_sym_static] = ACTIONS(4575),
    [anon_sym_register] = ACTIONS(4575),
    [anon_sym_inline] = ACTIONS(4575),
    [anon_sym___inline] = ACTIONS(4575),
    [anon_sym___inline__] = ACTIONS(4575),
    [anon_sym___forceinline] = ACTIONS(4575),
    [anon_sym_thread_local] = ACTIONS(4575),
    [anon_sym___thread] = ACTIONS(4575),
    [anon_sym_const] = ACTIONS(4575),
    [anon_sym_constexpr] = ACTIONS(4575),
    [anon_sym_volatile] = ACTIONS(4575),
    [anon_sym_restrict] = ACTIONS(4575),
    [anon_sym___restrict__] = ACTIONS(4575),
    [anon_sym__Atomic] = ACTIONS(4575),
    [anon_sym__Noreturn] = ACTIONS(4575),
    [anon_sym_noreturn] = ACTIONS(4575),
    [anon_sym_mutable] = ACTIONS(4575),
    [anon_sym_constinit] = ACTIONS(4575),
    [anon_sym_consteval] = ACTIONS(4575),
    [anon_sym_PROGMEM] = ACTIONS(4575),
    [anon_sym_QMARK] = ACTIONS(4577),
    [anon_sym_LT_EQ_GT] = ACTIONS(4577),
    [anon_sym_or] = ACTIONS(4584),
    [anon_sym_and] = ACTIONS(4584),
    [anon_sym_bitor] = ACTIONS(4584),
    [anon_sym_xor] = ACTIONS(4584),
    [anon_sym_bitand] = ACTIONS(4584),
    [anon_sym_not_eq] = ACTIONS(4584),
    [anon_sym_DASH_DASH] = ACTIONS(4577),
    [anon_sym_PLUS_PLUS] = ACTIONS(4577),
    [anon_sym_DOT] = ACTIONS(4584),
    [anon_sym_DOT_STAR] = ACTIONS(4577),
    [anon_sym_DASH_GT] = ACTIONS(4577),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4575),
    [anon_sym_decltype] = ACTIONS(4575),
    [anon_sym_virtual] = ACTIONS(4575),
    [anon_sym_alignas] = ACTIONS(4575),
    [anon_sym_template] = ACTIONS(4575),
    [anon_sym_operator] = ACTIONS(4575),
  },
  [1778] = {
    [sym_catch_clause] = STATE(1778),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1778),
    [sym_identifier] = ACTIONS(2475),
    [aux_sym_preproc_def_token1] = ACTIONS(2475),
    [aux_sym_preproc_if_token1] = ACTIONS(2475),
    [aux_sym_preproc_if_token2] = ACTIONS(2475),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2475),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2475),
    [aux_sym_preproc_else_token1] = ACTIONS(2475),
    [aux_sym_preproc_elif_token1] = ACTIONS(2475),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2475),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2475),
    [sym_preproc_directive] = ACTIONS(2475),
    [anon_sym_LPAREN2] = ACTIONS(2477),
    [anon_sym_TILDE] = ACTIONS(2477),
    [anon_sym_STAR] = ACTIONS(2477),
    [anon_sym_AMP_AMP] = ACTIONS(2477),
    [anon_sym_AMP] = ACTIONS(2475),
    [anon_sym___extension__] = ACTIONS(2475),
    [anon_sym_typedef] = ACTIONS(2475),
    [anon_sym_extern] = ACTIONS(2475),
    [anon_sym___attribute__] = ACTIONS(2475),
    [anon_sym_COLON_COLON] = ACTIONS(2477),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2477),
    [anon_sym___declspec] = ACTIONS(2475),
    [anon_sym___based] = ACTIONS(2475),
    [anon_sym_signed] = ACTIONS(2475),
    [anon_sym_unsigned] = ACTIONS(2475),
    [anon_sym_long] = ACTIONS(2475),
    [anon_sym_short] = ACTIONS(2475),
    [anon_sym_LBRACK] = ACTIONS(2475),
    [anon_sym_static] = ACTIONS(2475),
    [anon_sym_register] = ACTIONS(2475),
    [anon_sym_inline] = ACTIONS(2475),
    [anon_sym___inline] = ACTIONS(2475),
    [anon_sym___inline__] = ACTIONS(2475),
    [anon_sym___forceinline] = ACTIONS(2475),
    [anon_sym_thread_local] = ACTIONS(2475),
    [anon_sym___thread] = ACTIONS(2475),
    [anon_sym_const] = ACTIONS(2475),
    [anon_sym_constexpr] = ACTIONS(2475),
    [anon_sym_volatile] = ACTIONS(2475),
    [anon_sym_restrict] = ACTIONS(2475),
    [anon_sym___restrict__] = ACTIONS(2475),
    [anon_sym__Atomic] = ACTIONS(2475),
    [anon_sym__Noreturn] = ACTIONS(2475),
    [anon_sym_noreturn] = ACTIONS(2475),
    [anon_sym_mutable] = ACTIONS(2475),
    [anon_sym_constinit] = ACTIONS(2475),
    [anon_sym_consteval] = ACTIONS(2475),
    [anon_sym_PROGMEM] = ACTIONS(2475),
    [aux_sym_primitive_type_token1] = ACTIONS(2475),
    [anon_sym_byte] = ACTIONS(2475),
    [anon_sym_word] = ACTIONS(2475),
    [anon_sym_enum] = ACTIONS(2475),
    [anon_sym_class] = ACTIONS(2475),
    [anon_sym_struct] = ACTIONS(2475),
    [anon_sym_union] = ACTIONS(2475),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2475),
    [anon_sym_decltype] = ACTIONS(2475),
    [anon_sym_virtual] = ACTIONS(2475),
    [anon_sym_alignas] = ACTIONS(2475),
    [anon_sym_explicit] = ACTIONS(2475),
    [anon_sym_typename] = ACTIONS(2475),
    [anon_sym_template] = ACTIONS(2475),
    [anon_sym_operator] = ACTIONS(2475),
    [anon_sym_friend] = ACTIONS(2475),
    [anon_sym_public] = ACTIONS(2475),
    [anon_sym_private] = ACTIONS(2475),
    [anon_sym_protected] = ACTIONS(2475),
    [anon_sym_using] = ACTIONS(2475),
    [anon_sym_static_assert] = ACTIONS(2475),
    [anon_sym_catch] = ACTIONS(4802),
  },
  [1779] = {
    [sym_identifier] = ACTIONS(4575),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4577),
    [anon_sym_COMMA] = ACTIONS(4577),
    [anon_sym_RPAREN] = ACTIONS(4577),
    [anon_sym_LPAREN2] = ACTIONS(4579),
    [anon_sym_TILDE] = ACTIONS(4582),
    [anon_sym_DASH] = ACTIONS(4584),
    [anon_sym_PLUS] = ACTIONS(4584),
    [anon_sym_STAR] = ACTIONS(4579),
    [anon_sym_SLASH] = ACTIONS(4584),
    [anon_sym_PERCENT] = ACTIONS(4577),
    [anon_sym_PIPE_PIPE] = ACTIONS(4577),
    [anon_sym_AMP_AMP] = ACTIONS(4579),
    [anon_sym_PIPE] = ACTIONS(4584),
    [anon_sym_CARET] = ACTIONS(4577),
    [anon_sym_AMP] = ACTIONS(4586),
    [anon_sym_EQ_EQ] = ACTIONS(4577),
    [anon_sym_BANG_EQ] = ACTIONS(4577),
    [anon_sym_GT] = ACTIONS(4584),
    [anon_sym_GT_EQ] = ACTIONS(4577),
    [anon_sym_LT_EQ] = ACTIONS(4584),
    [anon_sym_LT] = ACTIONS(4584),
    [anon_sym_LT_LT] = ACTIONS(4577),
    [anon_sym_GT_GT] = ACTIONS(4577),
    [anon_sym_SEMI] = ACTIONS(4577),
    [anon_sym___extension__] = ACTIONS(4575),
    [anon_sym_extern] = ACTIONS(4575),
    [anon_sym___attribute__] = ACTIONS(4575),
    [anon_sym_COLON_COLON] = ACTIONS(4582),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4582),
    [anon_sym___declspec] = ACTIONS(4575),
    [anon_sym___based] = ACTIONS(4575),
    [anon_sym_LBRACE] = ACTIONS(4582),
    [anon_sym_LBRACK] = ACTIONS(4586),
    [anon_sym_static] = ACTIONS(4575),
    [anon_sym_register] = ACTIONS(4575),
    [anon_sym_inline] = ACTIONS(4575),
    [anon_sym___inline] = ACTIONS(4575),
    [anon_sym___inline__] = ACTIONS(4575),
    [anon_sym___forceinline] = ACTIONS(4575),
    [anon_sym_thread_local] = ACTIONS(4575),
    [anon_sym___thread] = ACTIONS(4575),
    [anon_sym_const] = ACTIONS(4575),
    [anon_sym_constexpr] = ACTIONS(4575),
    [anon_sym_volatile] = ACTIONS(4575),
    [anon_sym_restrict] = ACTIONS(4575),
    [anon_sym___restrict__] = ACTIONS(4575),
    [anon_sym__Atomic] = ACTIONS(4575),
    [anon_sym__Noreturn] = ACTIONS(4575),
    [anon_sym_noreturn] = ACTIONS(4575),
    [anon_sym_mutable] = ACTIONS(4575),
    [anon_sym_constinit] = ACTIONS(4575),
    [anon_sym_consteval] = ACTIONS(4575),
    [anon_sym_PROGMEM] = ACTIONS(4575),
    [anon_sym_QMARK] = ACTIONS(4577),
    [anon_sym_LT_EQ_GT] = ACTIONS(4577),
    [anon_sym_or] = ACTIONS(4584),
    [anon_sym_and] = ACTIONS(4584),
    [anon_sym_bitor] = ACTIONS(4584),
    [anon_sym_xor] = ACTIONS(4584),
    [anon_sym_bitand] = ACTIONS(4584),
    [anon_sym_not_eq] = ACTIONS(4584),
    [anon_sym_DASH_DASH] = ACTIONS(4577),
    [anon_sym_PLUS_PLUS] = ACTIONS(4577),
    [anon_sym_DOT] = ACTIONS(4584),
    [anon_sym_DOT_STAR] = ACTIONS(4577),
    [anon_sym_DASH_GT] = ACTIONS(4577),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4575),
    [anon_sym_decltype] = ACTIONS(4575),
    [anon_sym_virtual] = ACTIONS(4575),
    [anon_sym_alignas] = ACTIONS(4575),
    [anon_sym_template] = ACTIONS(4575),
    [anon_sym_operator] = ACTIONS(4575),
  },
  [1780] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4557),
    [anon_sym_COMMA] = ACTIONS(4557),
    [anon_sym_RPAREN] = ACTIONS(4557),
    [anon_sym_LPAREN2] = ACTIONS(4557),
    [anon_sym_DASH] = ACTIONS(4555),
    [anon_sym_PLUS] = ACTIONS(4555),
    [anon_sym_STAR] = ACTIONS(4555),
    [anon_sym_SLASH] = ACTIONS(4555),
    [anon_sym_PERCENT] = ACTIONS(4555),
    [anon_sym_PIPE_PIPE] = ACTIONS(4557),
    [anon_sym_AMP_AMP] = ACTIONS(4557),
    [anon_sym_PIPE] = ACTIONS(4555),
    [anon_sym_CARET] = ACTIONS(4555),
    [anon_sym_AMP] = ACTIONS(4555),
    [anon_sym_EQ_EQ] = ACTIONS(4557),
    [anon_sym_BANG_EQ] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4555),
    [anon_sym_GT_EQ] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4555),
    [anon_sym_LT_LT] = ACTIONS(4555),
    [anon_sym_GT_GT] = ACTIONS(4555),
    [anon_sym___extension__] = ACTIONS(4557),
    [anon_sym___attribute__] = ACTIONS(4557),
    [anon_sym_COLON_COLON] = ACTIONS(4557),
    [anon_sym_LBRACE] = ACTIONS(4557),
    [anon_sym_LBRACK] = ACTIONS(4557),
    [anon_sym_EQ] = ACTIONS(4555),
    [anon_sym_const] = ACTIONS(4555),
    [anon_sym_constexpr] = ACTIONS(4557),
    [anon_sym_volatile] = ACTIONS(4557),
    [anon_sym_restrict] = ACTIONS(4557),
    [anon_sym___restrict__] = ACTIONS(4557),
    [anon_sym__Atomic] = ACTIONS(4557),
    [anon_sym__Noreturn] = ACTIONS(4557),
    [anon_sym_noreturn] = ACTIONS(4557),
    [anon_sym_mutable] = ACTIONS(4557),
    [anon_sym_constinit] = ACTIONS(4557),
    [anon_sym_consteval] = ACTIONS(4557),
    [anon_sym_PROGMEM] = ACTIONS(4557),
    [anon_sym_COLON] = ACTIONS(4555),
    [anon_sym_QMARK] = ACTIONS(4557),
    [anon_sym_STAR_EQ] = ACTIONS(4557),
    [anon_sym_SLASH_EQ] = ACTIONS(4557),
    [anon_sym_PERCENT_EQ] = ACTIONS(4557),
    [anon_sym_PLUS_EQ] = ACTIONS(4557),
    [anon_sym_DASH_EQ] = ACTIONS(4557),
    [anon_sym_LT_LT_EQ] = ACTIONS(4557),
    [anon_sym_GT_GT_EQ] = ACTIONS(4557),
    [anon_sym_AMP_EQ] = ACTIONS(4557),
    [anon_sym_CARET_EQ] = ACTIONS(4557),
    [anon_sym_PIPE_EQ] = ACTIONS(4557),
    [anon_sym_and_eq] = ACTIONS(4557),
    [anon_sym_or_eq] = ACTIONS(4557),
    [anon_sym_xor_eq] = ACTIONS(4557),
    [anon_sym_LT_EQ_GT] = ACTIONS(4557),
    [anon_sym_or] = ACTIONS(4555),
    [anon_sym_and] = ACTIONS(4555),
    [anon_sym_bitor] = ACTIONS(4557),
    [anon_sym_xor] = ACTIONS(4555),
    [anon_sym_bitand] = ACTIONS(4557),
    [anon_sym_not_eq] = ACTIONS(4557),
    [anon_sym_DASH_DASH] = ACTIONS(4557),
    [anon_sym_PLUS_PLUS] = ACTIONS(4557),
    [anon_sym_DOT] = ACTIONS(4555),
    [anon_sym_DOT_STAR] = ACTIONS(4557),
    [anon_sym_DASH_GT] = ACTIONS(4555),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4557),
    [anon_sym_decltype] = ACTIONS(4557),
    [anon_sym_final] = ACTIONS(4557),
    [anon_sym_override] = ACTIONS(4557),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4557),
  },
  [1781] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4565),
    [anon_sym_COMMA] = ACTIONS(4565),
    [anon_sym_RPAREN] = ACTIONS(4565),
    [anon_sym_LPAREN2] = ACTIONS(4565),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_STAR] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4563),
    [anon_sym_PERCENT] = ACTIONS(4563),
    [anon_sym_PIPE_PIPE] = ACTIONS(4565),
    [anon_sym_AMP_AMP] = ACTIONS(4565),
    [anon_sym_PIPE] = ACTIONS(4563),
    [anon_sym_CARET] = ACTIONS(4563),
    [anon_sym_AMP] = ACTIONS(4563),
    [anon_sym_EQ_EQ] = ACTIONS(4565),
    [anon_sym_BANG_EQ] = ACTIONS(4565),
    [anon_sym_GT] = ACTIONS(4563),
    [anon_sym_GT_EQ] = ACTIONS(4565),
    [anon_sym_LT_EQ] = ACTIONS(4563),
    [anon_sym_LT] = ACTIONS(4563),
    [anon_sym_LT_LT] = ACTIONS(4563),
    [anon_sym_GT_GT] = ACTIONS(4563),
    [anon_sym___extension__] = ACTIONS(4565),
    [anon_sym___attribute__] = ACTIONS(4565),
    [anon_sym_COLON_COLON] = ACTIONS(4565),
    [anon_sym_LBRACE] = ACTIONS(4565),
    [anon_sym_LBRACK] = ACTIONS(4565),
    [anon_sym_EQ] = ACTIONS(4563),
    [anon_sym_const] = ACTIONS(4563),
    [anon_sym_constexpr] = ACTIONS(4565),
    [anon_sym_volatile] = ACTIONS(4565),
    [anon_sym_restrict] = ACTIONS(4565),
    [anon_sym___restrict__] = ACTIONS(4565),
    [anon_sym__Atomic] = ACTIONS(4565),
    [anon_sym__Noreturn] = ACTIONS(4565),
    [anon_sym_noreturn] = ACTIONS(4565),
    [anon_sym_mutable] = ACTIONS(4565),
    [anon_sym_constinit] = ACTIONS(4565),
    [anon_sym_consteval] = ACTIONS(4565),
    [anon_sym_PROGMEM] = ACTIONS(4565),
    [anon_sym_COLON] = ACTIONS(4563),
    [anon_sym_QMARK] = ACTIONS(4565),
    [anon_sym_STAR_EQ] = ACTIONS(4565),
    [anon_sym_SLASH_EQ] = ACTIONS(4565),
    [anon_sym_PERCENT_EQ] = ACTIONS(4565),
    [anon_sym_PLUS_EQ] = ACTIONS(4565),
    [anon_sym_DASH_EQ] = ACTIONS(4565),
    [anon_sym_LT_LT_EQ] = ACTIONS(4565),
    [anon_sym_GT_GT_EQ] = ACTIONS(4565),
    [anon_sym_AMP_EQ] = ACTIONS(4565),
    [anon_sym_CARET_EQ] = ACTIONS(4565),
    [anon_sym_PIPE_EQ] = ACTIONS(4565),
    [anon_sym_and_eq] = ACTIONS(4565),
    [anon_sym_or_eq] = ACTIONS(4565),
    [anon_sym_xor_eq] = ACTIONS(4565),
    [anon_sym_LT_EQ_GT] = ACTIONS(4565),
    [anon_sym_or] = ACTIONS(4563),
    [anon_sym_and] = ACTIONS(4563),
    [anon_sym_bitor] = ACTIONS(4565),
    [anon_sym_xor] = ACTIONS(4563),
    [anon_sym_bitand] = ACTIONS(4565),
    [anon_sym_not_eq] = ACTIONS(4565),
    [anon_sym_DASH_DASH] = ACTIONS(4565),
    [anon_sym_PLUS_PLUS] = ACTIONS(4565),
    [anon_sym_DOT] = ACTIONS(4563),
    [anon_sym_DOT_STAR] = ACTIONS(4565),
    [anon_sym_DASH_GT] = ACTIONS(4563),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4565),
    [anon_sym_decltype] = ACTIONS(4565),
    [anon_sym_final] = ACTIONS(4565),
    [anon_sym_override] = ACTIONS(4565),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4565),
  },
  [1782] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1782),
    [sym_identifier] = ACTIONS(4766),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4768),
    [anon_sym_COMMA] = ACTIONS(4768),
    [anon_sym_RPAREN] = ACTIONS(4768),
    [aux_sym_preproc_if_token2] = ACTIONS(4768),
    [aux_sym_preproc_else_token1] = ACTIONS(4768),
    [aux_sym_preproc_elif_token1] = ACTIONS(4766),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4768),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4768),
    [anon_sym_LPAREN2] = ACTIONS(4768),
    [anon_sym_DASH] = ACTIONS(4766),
    [anon_sym_PLUS] = ACTIONS(4766),
    [anon_sym_STAR] = ACTIONS(4766),
    [anon_sym_SLASH] = ACTIONS(4766),
    [anon_sym_PERCENT] = ACTIONS(4766),
    [anon_sym_PIPE_PIPE] = ACTIONS(4768),
    [anon_sym_AMP_AMP] = ACTIONS(4768),
    [anon_sym_PIPE] = ACTIONS(4766),
    [anon_sym_CARET] = ACTIONS(4766),
    [anon_sym_AMP] = ACTIONS(4766),
    [anon_sym_EQ_EQ] = ACTIONS(4768),
    [anon_sym_BANG_EQ] = ACTIONS(4768),
    [anon_sym_GT] = ACTIONS(4766),
    [anon_sym_GT_EQ] = ACTIONS(4768),
    [anon_sym_LT_EQ] = ACTIONS(4766),
    [anon_sym_LT] = ACTIONS(4766),
    [anon_sym_LT_LT] = ACTIONS(4766),
    [anon_sym_GT_GT] = ACTIONS(4766),
    [anon_sym_SEMI] = ACTIONS(4768),
    [anon_sym___attribute__] = ACTIONS(4766),
    [anon_sym_LBRACE] = ACTIONS(4768),
    [anon_sym_RBRACE] = ACTIONS(4768),
    [anon_sym_signed] = ACTIONS(4805),
    [anon_sym_unsigned] = ACTIONS(4805),
    [anon_sym_long] = ACTIONS(4805),
    [anon_sym_short] = ACTIONS(4805),
    [anon_sym_LBRACK] = ACTIONS(4768),
    [anon_sym_RBRACK] = ACTIONS(4768),
    [anon_sym_EQ] = ACTIONS(4766),
    [aux_sym_primitive_type_token1] = ACTIONS(4766),
    [anon_sym_byte] = ACTIONS(4766),
    [anon_sym_word] = ACTIONS(4766),
    [anon_sym_COLON] = ACTIONS(4768),
    [anon_sym_QMARK] = ACTIONS(4768),
    [anon_sym_STAR_EQ] = ACTIONS(4768),
    [anon_sym_SLASH_EQ] = ACTIONS(4768),
    [anon_sym_PERCENT_EQ] = ACTIONS(4768),
    [anon_sym_PLUS_EQ] = ACTIONS(4768),
    [anon_sym_DASH_EQ] = ACTIONS(4768),
    [anon_sym_LT_LT_EQ] = ACTIONS(4768),
    [anon_sym_GT_GT_EQ] = ACTIONS(4768),
    [anon_sym_AMP_EQ] = ACTIONS(4768),
    [anon_sym_CARET_EQ] = ACTIONS(4768),
    [anon_sym_PIPE_EQ] = ACTIONS(4768),
    [anon_sym_and_eq] = ACTIONS(4766),
    [anon_sym_or_eq] = ACTIONS(4766),
    [anon_sym_xor_eq] = ACTIONS(4766),
    [anon_sym_LT_EQ_GT] = ACTIONS(4768),
    [anon_sym_or] = ACTIONS(4766),
    [anon_sym_and] = ACTIONS(4766),
    [anon_sym_bitor] = ACTIONS(4766),
    [anon_sym_xor] = ACTIONS(4766),
    [anon_sym_bitand] = ACTIONS(4766),
    [anon_sym_not_eq] = ACTIONS(4766),
    [anon_sym_DASH_DASH] = ACTIONS(4768),
    [anon_sym_PLUS_PLUS] = ACTIONS(4768),
    [anon_sym_DOT] = ACTIONS(4766),
    [anon_sym_DOT_STAR] = ACTIONS(4768),
    [anon_sym_DASH_GT] = ACTIONS(4768),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4766),
    [anon_sym_decltype] = ACTIONS(4766),
  },
  [1783] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4561),
    [anon_sym_COMMA] = ACTIONS(4561),
    [anon_sym_RPAREN] = ACTIONS(4561),
    [anon_sym_LPAREN2] = ACTIONS(4561),
    [anon_sym_DASH] = ACTIONS(4559),
    [anon_sym_PLUS] = ACTIONS(4559),
    [anon_sym_STAR] = ACTIONS(4559),
    [anon_sym_SLASH] = ACTIONS(4559),
    [anon_sym_PERCENT] = ACTIONS(4559),
    [anon_sym_PIPE_PIPE] = ACTIONS(4561),
    [anon_sym_AMP_AMP] = ACTIONS(4561),
    [anon_sym_PIPE] = ACTIONS(4559),
    [anon_sym_CARET] = ACTIONS(4559),
    [anon_sym_AMP] = ACTIONS(4559),
    [anon_sym_EQ_EQ] = ACTIONS(4561),
    [anon_sym_BANG_EQ] = ACTIONS(4561),
    [anon_sym_GT] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4561),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_LT] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4559),
    [anon_sym_GT_GT] = ACTIONS(4559),
    [anon_sym___extension__] = ACTIONS(4561),
    [anon_sym___attribute__] = ACTIONS(4561),
    [anon_sym_COLON_COLON] = ACTIONS(4561),
    [anon_sym_LBRACE] = ACTIONS(4561),
    [anon_sym_LBRACK] = ACTIONS(4561),
    [anon_sym_EQ] = ACTIONS(4559),
    [anon_sym_const] = ACTIONS(4559),
    [anon_sym_constexpr] = ACTIONS(4561),
    [anon_sym_volatile] = ACTIONS(4561),
    [anon_sym_restrict] = ACTIONS(4561),
    [anon_sym___restrict__] = ACTIONS(4561),
    [anon_sym__Atomic] = ACTIONS(4561),
    [anon_sym__Noreturn] = ACTIONS(4561),
    [anon_sym_noreturn] = ACTIONS(4561),
    [anon_sym_mutable] = ACTIONS(4561),
    [anon_sym_constinit] = ACTIONS(4561),
    [anon_sym_consteval] = ACTIONS(4561),
    [anon_sym_PROGMEM] = ACTIONS(4561),
    [anon_sym_COLON] = ACTIONS(4559),
    [anon_sym_QMARK] = ACTIONS(4561),
    [anon_sym_STAR_EQ] = ACTIONS(4561),
    [anon_sym_SLASH_EQ] = ACTIONS(4561),
    [anon_sym_PERCENT_EQ] = ACTIONS(4561),
    [anon_sym_PLUS_EQ] = ACTIONS(4561),
    [anon_sym_DASH_EQ] = ACTIONS(4561),
    [anon_sym_LT_LT_EQ] = ACTIONS(4561),
    [anon_sym_GT_GT_EQ] = ACTIONS(4561),
    [anon_sym_AMP_EQ] = ACTIONS(4561),
    [anon_sym_CARET_EQ] = ACTIONS(4561),
    [anon_sym_PIPE_EQ] = ACTIONS(4561),
    [anon_sym_and_eq] = ACTIONS(4561),
    [anon_sym_or_eq] = ACTIONS(4561),
    [anon_sym_xor_eq] = ACTIONS(4561),
    [anon_sym_LT_EQ_GT] = ACTIONS(4561),
    [anon_sym_or] = ACTIONS(4559),
    [anon_sym_and] = ACTIONS(4559),
    [anon_sym_bitor] = ACTIONS(4561),
    [anon_sym_xor] = ACTIONS(4559),
    [anon_sym_bitand] = ACTIONS(4561),
    [anon_sym_not_eq] = ACTIONS(4561),
    [anon_sym_DASH_DASH] = ACTIONS(4561),
    [anon_sym_PLUS_PLUS] = ACTIONS(4561),
    [anon_sym_DOT] = ACTIONS(4559),
    [anon_sym_DOT_STAR] = ACTIONS(4561),
    [anon_sym_DASH_GT] = ACTIONS(4559),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4561),
    [anon_sym_decltype] = ACTIONS(4561),
    [anon_sym_final] = ACTIONS(4561),
    [anon_sym_override] = ACTIONS(4561),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4561),
  },
  [1784] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4532),
    [anon_sym_COMMA] = ACTIONS(4532),
    [anon_sym_RPAREN] = ACTIONS(4532),
    [anon_sym_LPAREN2] = ACTIONS(4532),
    [anon_sym_DASH] = ACTIONS(4530),
    [anon_sym_PLUS] = ACTIONS(4530),
    [anon_sym_STAR] = ACTIONS(4530),
    [anon_sym_SLASH] = ACTIONS(4530),
    [anon_sym_PERCENT] = ACTIONS(4530),
    [anon_sym_PIPE_PIPE] = ACTIONS(4532),
    [anon_sym_AMP_AMP] = ACTIONS(4532),
    [anon_sym_PIPE] = ACTIONS(4530),
    [anon_sym_CARET] = ACTIONS(4530),
    [anon_sym_AMP] = ACTIONS(4530),
    [anon_sym_EQ_EQ] = ACTIONS(4532),
    [anon_sym_BANG_EQ] = ACTIONS(4532),
    [anon_sym_GT] = ACTIONS(4530),
    [anon_sym_GT_EQ] = ACTIONS(4532),
    [anon_sym_LT_EQ] = ACTIONS(4530),
    [anon_sym_LT] = ACTIONS(4530),
    [anon_sym_LT_LT] = ACTIONS(4530),
    [anon_sym_GT_GT] = ACTIONS(4530),
    [anon_sym___extension__] = ACTIONS(4532),
    [anon_sym___attribute__] = ACTIONS(4532),
    [anon_sym_COLON_COLON] = ACTIONS(4532),
    [anon_sym_LBRACE] = ACTIONS(4532),
    [anon_sym_LBRACK] = ACTIONS(4532),
    [anon_sym_EQ] = ACTIONS(4530),
    [anon_sym_const] = ACTIONS(4530),
    [anon_sym_constexpr] = ACTIONS(4532),
    [anon_sym_volatile] = ACTIONS(4532),
    [anon_sym_restrict] = ACTIONS(4532),
    [anon_sym___restrict__] = ACTIONS(4532),
    [anon_sym__Atomic] = ACTIONS(4532),
    [anon_sym__Noreturn] = ACTIONS(4532),
    [anon_sym_noreturn] = ACTIONS(4532),
    [anon_sym_mutable] = ACTIONS(4532),
    [anon_sym_constinit] = ACTIONS(4532),
    [anon_sym_consteval] = ACTIONS(4532),
    [anon_sym_PROGMEM] = ACTIONS(4532),
    [anon_sym_COLON] = ACTIONS(4530),
    [anon_sym_QMARK] = ACTIONS(4532),
    [anon_sym_STAR_EQ] = ACTIONS(4532),
    [anon_sym_SLASH_EQ] = ACTIONS(4532),
    [anon_sym_PERCENT_EQ] = ACTIONS(4532),
    [anon_sym_PLUS_EQ] = ACTIONS(4532),
    [anon_sym_DASH_EQ] = ACTIONS(4532),
    [anon_sym_LT_LT_EQ] = ACTIONS(4532),
    [anon_sym_GT_GT_EQ] = ACTIONS(4532),
    [anon_sym_AMP_EQ] = ACTIONS(4532),
    [anon_sym_CARET_EQ] = ACTIONS(4532),
    [anon_sym_PIPE_EQ] = ACTIONS(4532),
    [anon_sym_and_eq] = ACTIONS(4532),
    [anon_sym_or_eq] = ACTIONS(4532),
    [anon_sym_xor_eq] = ACTIONS(4532),
    [anon_sym_LT_EQ_GT] = ACTIONS(4532),
    [anon_sym_or] = ACTIONS(4530),
    [anon_sym_and] = ACTIONS(4530),
    [anon_sym_bitor] = ACTIONS(4532),
    [anon_sym_xor] = ACTIONS(4530),
    [anon_sym_bitand] = ACTIONS(4532),
    [anon_sym_not_eq] = ACTIONS(4532),
    [anon_sym_DASH_DASH] = ACTIONS(4532),
    [anon_sym_PLUS_PLUS] = ACTIONS(4532),
    [anon_sym_DOT] = ACTIONS(4530),
    [anon_sym_DOT_STAR] = ACTIONS(4532),
    [anon_sym_DASH_GT] = ACTIONS(4530),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4532),
    [anon_sym_decltype] = ACTIONS(4532),
    [anon_sym_final] = ACTIONS(4532),
    [anon_sym_override] = ACTIONS(4532),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4532),
  },
  [1785] = {
    [sym_identifier] = ACTIONS(1957),
    [aux_sym_preproc_def_token1] = ACTIONS(1957),
    [anon_sym_COMMA] = ACTIONS(2743),
    [aux_sym_preproc_if_token1] = ACTIONS(1957),
    [aux_sym_preproc_if_token2] = ACTIONS(1957),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1957),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1957),
    [aux_sym_preproc_else_token1] = ACTIONS(1957),
    [aux_sym_preproc_elif_token1] = ACTIONS(1957),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1957),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1957),
    [sym_preproc_directive] = ACTIONS(1957),
    [anon_sym_LPAREN2] = ACTIONS(1955),
    [anon_sym_TILDE] = ACTIONS(1955),
    [anon_sym_STAR] = ACTIONS(1955),
    [anon_sym_AMP_AMP] = ACTIONS(1955),
    [anon_sym_AMP] = ACTIONS(1957),
    [anon_sym_SEMI] = ACTIONS(2743),
    [anon_sym___extension__] = ACTIONS(1957),
    [anon_sym_typedef] = ACTIONS(1957),
    [anon_sym_extern] = ACTIONS(1957),
    [anon_sym___attribute__] = ACTIONS(4808),
    [anon_sym_COLON_COLON] = ACTIONS(1955),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1955),
    [anon_sym___declspec] = ACTIONS(1957),
    [anon_sym___based] = ACTIONS(1957),
    [anon_sym_signed] = ACTIONS(1957),
    [anon_sym_unsigned] = ACTIONS(1957),
    [anon_sym_long] = ACTIONS(1957),
    [anon_sym_short] = ACTIONS(1957),
    [anon_sym_LBRACK] = ACTIONS(1957),
    [anon_sym_static] = ACTIONS(1957),
    [anon_sym_register] = ACTIONS(1957),
    [anon_sym_inline] = ACTIONS(1957),
    [anon_sym___inline] = ACTIONS(1957),
    [anon_sym___inline__] = ACTIONS(1957),
    [anon_sym___forceinline] = ACTIONS(1957),
    [anon_sym_thread_local] = ACTIONS(1957),
    [anon_sym___thread] = ACTIONS(1957),
    [anon_sym_const] = ACTIONS(1957),
    [anon_sym_constexpr] = ACTIONS(1957),
    [anon_sym_volatile] = ACTIONS(1957),
    [anon_sym_restrict] = ACTIONS(1957),
    [anon_sym___restrict__] = ACTIONS(1957),
    [anon_sym__Atomic] = ACTIONS(1957),
    [anon_sym__Noreturn] = ACTIONS(1957),
    [anon_sym_noreturn] = ACTIONS(1957),
    [anon_sym_mutable] = ACTIONS(1957),
    [anon_sym_constinit] = ACTIONS(1957),
    [anon_sym_consteval] = ACTIONS(1957),
    [anon_sym_PROGMEM] = ACTIONS(1957),
    [aux_sym_primitive_type_token1] = ACTIONS(1957),
    [anon_sym_byte] = ACTIONS(1957),
    [anon_sym_word] = ACTIONS(1957),
    [anon_sym_enum] = ACTIONS(1957),
    [anon_sym_class] = ACTIONS(1957),
    [anon_sym_struct] = ACTIONS(1957),
    [anon_sym_union] = ACTIONS(1957),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1957),
    [anon_sym_decltype] = ACTIONS(1957),
    [anon_sym_virtual] = ACTIONS(1957),
    [anon_sym_alignas] = ACTIONS(1957),
    [anon_sym_explicit] = ACTIONS(1957),
    [anon_sym_typename] = ACTIONS(1957),
    [anon_sym_template] = ACTIONS(1957),
    [anon_sym_operator] = ACTIONS(1957),
    [anon_sym_friend] = ACTIONS(1957),
    [anon_sym_public] = ACTIONS(1957),
    [anon_sym_private] = ACTIONS(1957),
    [anon_sym_protected] = ACTIONS(1957),
    [anon_sym_using] = ACTIONS(1957),
    [anon_sym_static_assert] = ACTIONS(1957),
  },
  [1786] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4569),
    [anon_sym_COMMA] = ACTIONS(4569),
    [anon_sym_RPAREN] = ACTIONS(4569),
    [anon_sym_LPAREN2] = ACTIONS(4569),
    [anon_sym_DASH] = ACTIONS(4567),
    [anon_sym_PLUS] = ACTIONS(4567),
    [anon_sym_STAR] = ACTIONS(4567),
    [anon_sym_SLASH] = ACTIONS(4567),
    [anon_sym_PERCENT] = ACTIONS(4567),
    [anon_sym_PIPE_PIPE] = ACTIONS(4569),
    [anon_sym_AMP_AMP] = ACTIONS(4569),
    [anon_sym_PIPE] = ACTIONS(4567),
    [anon_sym_CARET] = ACTIONS(4567),
    [anon_sym_AMP] = ACTIONS(4567),
    [anon_sym_EQ_EQ] = ACTIONS(4569),
    [anon_sym_BANG_EQ] = ACTIONS(4569),
    [anon_sym_GT] = ACTIONS(4567),
    [anon_sym_GT_EQ] = ACTIONS(4569),
    [anon_sym_LT_EQ] = ACTIONS(4567),
    [anon_sym_LT] = ACTIONS(4567),
    [anon_sym_LT_LT] = ACTIONS(4567),
    [anon_sym_GT_GT] = ACTIONS(4567),
    [anon_sym___extension__] = ACTIONS(4569),
    [anon_sym___attribute__] = ACTIONS(4569),
    [anon_sym_COLON_COLON] = ACTIONS(4569),
    [anon_sym_LBRACE] = ACTIONS(4569),
    [anon_sym_LBRACK] = ACTIONS(4569),
    [anon_sym_EQ] = ACTIONS(4567),
    [anon_sym_const] = ACTIONS(4567),
    [anon_sym_constexpr] = ACTIONS(4569),
    [anon_sym_volatile] = ACTIONS(4569),
    [anon_sym_restrict] = ACTIONS(4569),
    [anon_sym___restrict__] = ACTIONS(4569),
    [anon_sym__Atomic] = ACTIONS(4569),
    [anon_sym__Noreturn] = ACTIONS(4569),
    [anon_sym_noreturn] = ACTIONS(4569),
    [anon_sym_mutable] = ACTIONS(4569),
    [anon_sym_constinit] = ACTIONS(4569),
    [anon_sym_consteval] = ACTIONS(4569),
    [anon_sym_PROGMEM] = ACTIONS(4569),
    [anon_sym_COLON] = ACTIONS(4567),
    [anon_sym_QMARK] = ACTIONS(4569),
    [anon_sym_STAR_EQ] = ACTIONS(4569),
    [anon_sym_SLASH_EQ] = ACTIONS(4569),
    [anon_sym_PERCENT_EQ] = ACTIONS(4569),
    [anon_sym_PLUS_EQ] = ACTIONS(4569),
    [anon_sym_DASH_EQ] = ACTIONS(4569),
    [anon_sym_LT_LT_EQ] = ACTIONS(4569),
    [anon_sym_GT_GT_EQ] = ACTIONS(4569),
    [anon_sym_AMP_EQ] = ACTIONS(4569),
    [anon_sym_CARET_EQ] = ACTIONS(4569),
    [anon_sym_PIPE_EQ] = ACTIONS(4569),
    [anon_sym_and_eq] = ACTIONS(4569),
    [anon_sym_or_eq] = ACTIONS(4569),
    [anon_sym_xor_eq] = ACTIONS(4569),
    [anon_sym_LT_EQ_GT] = ACTIONS(4569),
    [anon_sym_or] = ACTIONS(4567),
    [anon_sym_and] = ACTIONS(4567),
    [anon_sym_bitor] = ACTIONS(4569),
    [anon_sym_xor] = ACTIONS(4567),
    [anon_sym_bitand] = ACTIONS(4569),
    [anon_sym_not_eq] = ACTIONS(4569),
    [anon_sym_DASH_DASH] = ACTIONS(4569),
    [anon_sym_PLUS_PLUS] = ACTIONS(4569),
    [anon_sym_DOT] = ACTIONS(4567),
    [anon_sym_DOT_STAR] = ACTIONS(4569),
    [anon_sym_DASH_GT] = ACTIONS(4567),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4569),
    [anon_sym_decltype] = ACTIONS(4569),
    [anon_sym_final] = ACTIONS(4569),
    [anon_sym_override] = ACTIONS(4569),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4569),
  },
  [1787] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4573),
    [anon_sym_COMMA] = ACTIONS(4573),
    [anon_sym_RPAREN] = ACTIONS(4573),
    [anon_sym_LPAREN2] = ACTIONS(4573),
    [anon_sym_DASH] = ACTIONS(4571),
    [anon_sym_PLUS] = ACTIONS(4571),
    [anon_sym_STAR] = ACTIONS(4571),
    [anon_sym_SLASH] = ACTIONS(4571),
    [anon_sym_PERCENT] = ACTIONS(4571),
    [anon_sym_PIPE_PIPE] = ACTIONS(4573),
    [anon_sym_AMP_AMP] = ACTIONS(4573),
    [anon_sym_PIPE] = ACTIONS(4571),
    [anon_sym_CARET] = ACTIONS(4571),
    [anon_sym_AMP] = ACTIONS(4571),
    [anon_sym_EQ_EQ] = ACTIONS(4573),
    [anon_sym_BANG_EQ] = ACTIONS(4573),
    [anon_sym_GT] = ACTIONS(4571),
    [anon_sym_GT_EQ] = ACTIONS(4573),
    [anon_sym_LT_EQ] = ACTIONS(4571),
    [anon_sym_LT] = ACTIONS(4571),
    [anon_sym_LT_LT] = ACTIONS(4571),
    [anon_sym_GT_GT] = ACTIONS(4571),
    [anon_sym___extension__] = ACTIONS(4573),
    [anon_sym___attribute__] = ACTIONS(4573),
    [anon_sym_COLON_COLON] = ACTIONS(4573),
    [anon_sym_LBRACE] = ACTIONS(4573),
    [anon_sym_LBRACK] = ACTIONS(4573),
    [anon_sym_EQ] = ACTIONS(4571),
    [anon_sym_const] = ACTIONS(4571),
    [anon_sym_constexpr] = ACTIONS(4573),
    [anon_sym_volatile] = ACTIONS(4573),
    [anon_sym_restrict] = ACTIONS(4573),
    [anon_sym___restrict__] = ACTIONS(4573),
    [anon_sym__Atomic] = ACTIONS(4573),
    [anon_sym__Noreturn] = ACTIONS(4573),
    [anon_sym_noreturn] = ACTIONS(4573),
    [anon_sym_mutable] = ACTIONS(4573),
    [anon_sym_constinit] = ACTIONS(4573),
    [anon_sym_consteval] = ACTIONS(4573),
    [anon_sym_PROGMEM] = ACTIONS(4573),
    [anon_sym_COLON] = ACTIONS(4571),
    [anon_sym_QMARK] = ACTIONS(4573),
    [anon_sym_STAR_EQ] = ACTIONS(4573),
    [anon_sym_SLASH_EQ] = ACTIONS(4573),
    [anon_sym_PERCENT_EQ] = ACTIONS(4573),
    [anon_sym_PLUS_EQ] = ACTIONS(4573),
    [anon_sym_DASH_EQ] = ACTIONS(4573),
    [anon_sym_LT_LT_EQ] = ACTIONS(4573),
    [anon_sym_GT_GT_EQ] = ACTIONS(4573),
    [anon_sym_AMP_EQ] = ACTIONS(4573),
    [anon_sym_CARET_EQ] = ACTIONS(4573),
    [anon_sym_PIPE_EQ] = ACTIONS(4573),
    [anon_sym_and_eq] = ACTIONS(4573),
    [anon_sym_or_eq] = ACTIONS(4573),
    [anon_sym_xor_eq] = ACTIONS(4573),
    [anon_sym_LT_EQ_GT] = ACTIONS(4573),
    [anon_sym_or] = ACTIONS(4571),
    [anon_sym_and] = ACTIONS(4571),
    [anon_sym_bitor] = ACTIONS(4573),
    [anon_sym_xor] = ACTIONS(4571),
    [anon_sym_bitand] = ACTIONS(4573),
    [anon_sym_not_eq] = ACTIONS(4573),
    [anon_sym_DASH_DASH] = ACTIONS(4573),
    [anon_sym_PLUS_PLUS] = ACTIONS(4573),
    [anon_sym_DOT] = ACTIONS(4571),
    [anon_sym_DOT_STAR] = ACTIONS(4573),
    [anon_sym_DASH_GT] = ACTIONS(4571),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4573),
    [anon_sym_decltype] = ACTIONS(4573),
    [anon_sym_final] = ACTIONS(4573),
    [anon_sym_override] = ACTIONS(4573),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4573),
  },
  [1788] = {
    [sym_identifier] = ACTIONS(1957),
    [aux_sym_preproc_def_token1] = ACTIONS(1957),
    [aux_sym_preproc_if_token1] = ACTIONS(1957),
    [aux_sym_preproc_if_token2] = ACTIONS(1957),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1957),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1957),
    [aux_sym_preproc_else_token1] = ACTIONS(1957),
    [aux_sym_preproc_elif_token1] = ACTIONS(1957),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1957),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1957),
    [sym_preproc_directive] = ACTIONS(1957),
    [anon_sym_LPAREN2] = ACTIONS(1955),
    [anon_sym_TILDE] = ACTIONS(1955),
    [anon_sym_STAR] = ACTIONS(1955),
    [anon_sym_AMP_AMP] = ACTIONS(1955),
    [anon_sym_AMP] = ACTIONS(1957),
    [anon_sym_SEMI] = ACTIONS(1955),
    [anon_sym___extension__] = ACTIONS(1957),
    [anon_sym_typedef] = ACTIONS(1957),
    [anon_sym_extern] = ACTIONS(1957),
    [anon_sym___attribute__] = ACTIONS(1957),
    [anon_sym_COLON_COLON] = ACTIONS(1955),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1955),
    [anon_sym___declspec] = ACTIONS(1957),
    [anon_sym___based] = ACTIONS(1957),
    [anon_sym_signed] = ACTIONS(1957),
    [anon_sym_unsigned] = ACTIONS(1957),
    [anon_sym_long] = ACTIONS(1957),
    [anon_sym_short] = ACTIONS(1957),
    [anon_sym_LBRACK] = ACTIONS(1957),
    [anon_sym_static] = ACTIONS(1957),
    [anon_sym_register] = ACTIONS(1957),
    [anon_sym_inline] = ACTIONS(1957),
    [anon_sym___inline] = ACTIONS(1957),
    [anon_sym___inline__] = ACTIONS(1957),
    [anon_sym___forceinline] = ACTIONS(1957),
    [anon_sym_thread_local] = ACTIONS(1957),
    [anon_sym___thread] = ACTIONS(1957),
    [anon_sym_const] = ACTIONS(1957),
    [anon_sym_constexpr] = ACTIONS(1957),
    [anon_sym_volatile] = ACTIONS(1957),
    [anon_sym_restrict] = ACTIONS(1957),
    [anon_sym___restrict__] = ACTIONS(1957),
    [anon_sym__Atomic] = ACTIONS(1957),
    [anon_sym__Noreturn] = ACTIONS(1957),
    [anon_sym_noreturn] = ACTIONS(1957),
    [anon_sym_mutable] = ACTIONS(1957),
    [anon_sym_constinit] = ACTIONS(1957),
    [anon_sym_consteval] = ACTIONS(1957),
    [anon_sym_PROGMEM] = ACTIONS(1957),
    [aux_sym_primitive_type_token1] = ACTIONS(1957),
    [anon_sym_byte] = ACTIONS(1957),
    [anon_sym_word] = ACTIONS(1957),
    [anon_sym_enum] = ACTIONS(1957),
    [anon_sym_class] = ACTIONS(1957),
    [anon_sym_struct] = ACTIONS(1957),
    [anon_sym_union] = ACTIONS(1957),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1957),
    [anon_sym_decltype] = ACTIONS(1957),
    [anon_sym_virtual] = ACTIONS(1957),
    [anon_sym_alignas] = ACTIONS(1957),
    [anon_sym_explicit] = ACTIONS(1957),
    [anon_sym_typename] = ACTIONS(1957),
    [anon_sym_template] = ACTIONS(1957),
    [anon_sym_operator] = ACTIONS(1957),
    [anon_sym_friend] = ACTIONS(1957),
    [anon_sym_public] = ACTIONS(1957),
    [anon_sym_private] = ACTIONS(1957),
    [anon_sym_protected] = ACTIONS(1957),
    [anon_sym_using] = ACTIONS(1957),
    [anon_sym_static_assert] = ACTIONS(1957),
    [anon_sym_catch] = ACTIONS(1957),
  },
  [1789] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4553),
    [anon_sym_COMMA] = ACTIONS(4553),
    [anon_sym_RPAREN] = ACTIONS(4553),
    [anon_sym_LPAREN2] = ACTIONS(4553),
    [anon_sym_DASH] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(4551),
    [anon_sym_STAR] = ACTIONS(4551),
    [anon_sym_SLASH] = ACTIONS(4551),
    [anon_sym_PERCENT] = ACTIONS(4551),
    [anon_sym_PIPE_PIPE] = ACTIONS(4553),
    [anon_sym_AMP_AMP] = ACTIONS(4553),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4551),
    [anon_sym_AMP] = ACTIONS(4551),
    [anon_sym_EQ_EQ] = ACTIONS(4553),
    [anon_sym_BANG_EQ] = ACTIONS(4553),
    [anon_sym_GT] = ACTIONS(4551),
    [anon_sym_GT_EQ] = ACTIONS(4553),
    [anon_sym_LT_EQ] = ACTIONS(4551),
    [anon_sym_LT] = ACTIONS(4551),
    [anon_sym_LT_LT] = ACTIONS(4551),
    [anon_sym_GT_GT] = ACTIONS(4551),
    [anon_sym___extension__] = ACTIONS(4553),
    [anon_sym___attribute__] = ACTIONS(4553),
    [anon_sym_COLON_COLON] = ACTIONS(4553),
    [anon_sym_LBRACE] = ACTIONS(4553),
    [anon_sym_LBRACK] = ACTIONS(4553),
    [anon_sym_EQ] = ACTIONS(4551),
    [anon_sym_const] = ACTIONS(4551),
    [anon_sym_constexpr] = ACTIONS(4553),
    [anon_sym_volatile] = ACTIONS(4553),
    [anon_sym_restrict] = ACTIONS(4553),
    [anon_sym___restrict__] = ACTIONS(4553),
    [anon_sym__Atomic] = ACTIONS(4553),
    [anon_sym__Noreturn] = ACTIONS(4553),
    [anon_sym_noreturn] = ACTIONS(4553),
    [anon_sym_mutable] = ACTIONS(4553),
    [anon_sym_constinit] = ACTIONS(4553),
    [anon_sym_consteval] = ACTIONS(4553),
    [anon_sym_PROGMEM] = ACTIONS(4553),
    [anon_sym_COLON] = ACTIONS(4551),
    [anon_sym_QMARK] = ACTIONS(4553),
    [anon_sym_STAR_EQ] = ACTIONS(4553),
    [anon_sym_SLASH_EQ] = ACTIONS(4553),
    [anon_sym_PERCENT_EQ] = ACTIONS(4553),
    [anon_sym_PLUS_EQ] = ACTIONS(4553),
    [anon_sym_DASH_EQ] = ACTIONS(4553),
    [anon_sym_LT_LT_EQ] = ACTIONS(4553),
    [anon_sym_GT_GT_EQ] = ACTIONS(4553),
    [anon_sym_AMP_EQ] = ACTIONS(4553),
    [anon_sym_CARET_EQ] = ACTIONS(4553),
    [anon_sym_PIPE_EQ] = ACTIONS(4553),
    [anon_sym_and_eq] = ACTIONS(4553),
    [anon_sym_or_eq] = ACTIONS(4553),
    [anon_sym_xor_eq] = ACTIONS(4553),
    [anon_sym_LT_EQ_GT] = ACTIONS(4553),
    [anon_sym_or] = ACTIONS(4551),
    [anon_sym_and] = ACTIONS(4551),
    [anon_sym_bitor] = ACTIONS(4553),
    [anon_sym_xor] = ACTIONS(4551),
    [anon_sym_bitand] = ACTIONS(4553),
    [anon_sym_not_eq] = ACTIONS(4553),
    [anon_sym_DASH_DASH] = ACTIONS(4553),
    [anon_sym_PLUS_PLUS] = ACTIONS(4553),
    [anon_sym_DOT] = ACTIONS(4551),
    [anon_sym_DOT_STAR] = ACTIONS(4553),
    [anon_sym_DASH_GT] = ACTIONS(4551),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4553),
    [anon_sym_decltype] = ACTIONS(4553),
    [anon_sym_final] = ACTIONS(4553),
    [anon_sym_override] = ACTIONS(4553),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4553),
  },
  [1790] = {
    [sym_identifier] = ACTIONS(1961),
    [aux_sym_preproc_def_token1] = ACTIONS(1961),
    [aux_sym_preproc_if_token1] = ACTIONS(1961),
    [aux_sym_preproc_if_token2] = ACTIONS(1961),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1961),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1961),
    [aux_sym_preproc_else_token1] = ACTIONS(1961),
    [aux_sym_preproc_elif_token1] = ACTIONS(1961),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1961),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1961),
    [sym_preproc_directive] = ACTIONS(1961),
    [anon_sym_LPAREN2] = ACTIONS(1959),
    [anon_sym_TILDE] = ACTIONS(1959),
    [anon_sym_STAR] = ACTIONS(1959),
    [anon_sym_AMP_AMP] = ACTIONS(1959),
    [anon_sym_AMP] = ACTIONS(1961),
    [anon_sym_SEMI] = ACTIONS(1959),
    [anon_sym___extension__] = ACTIONS(1961),
    [anon_sym_typedef] = ACTIONS(1961),
    [anon_sym_extern] = ACTIONS(1961),
    [anon_sym___attribute__] = ACTIONS(1961),
    [anon_sym_COLON_COLON] = ACTIONS(1959),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1959),
    [anon_sym___declspec] = ACTIONS(1961),
    [anon_sym___based] = ACTIONS(1961),
    [anon_sym_signed] = ACTIONS(1961),
    [anon_sym_unsigned] = ACTIONS(1961),
    [anon_sym_long] = ACTIONS(1961),
    [anon_sym_short] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1961),
    [anon_sym_static] = ACTIONS(1961),
    [anon_sym_register] = ACTIONS(1961),
    [anon_sym_inline] = ACTIONS(1961),
    [anon_sym___inline] = ACTIONS(1961),
    [anon_sym___inline__] = ACTIONS(1961),
    [anon_sym___forceinline] = ACTIONS(1961),
    [anon_sym_thread_local] = ACTIONS(1961),
    [anon_sym___thread] = ACTIONS(1961),
    [anon_sym_const] = ACTIONS(1961),
    [anon_sym_constexpr] = ACTIONS(1961),
    [anon_sym_volatile] = ACTIONS(1961),
    [anon_sym_restrict] = ACTIONS(1961),
    [anon_sym___restrict__] = ACTIONS(1961),
    [anon_sym__Atomic] = ACTIONS(1961),
    [anon_sym__Noreturn] = ACTIONS(1961),
    [anon_sym_noreturn] = ACTIONS(1961),
    [anon_sym_mutable] = ACTIONS(1961),
    [anon_sym_constinit] = ACTIONS(1961),
    [anon_sym_consteval] = ACTIONS(1961),
    [anon_sym_PROGMEM] = ACTIONS(1961),
    [aux_sym_primitive_type_token1] = ACTIONS(1961),
    [anon_sym_byte] = ACTIONS(1961),
    [anon_sym_word] = ACTIONS(1961),
    [anon_sym_enum] = ACTIONS(1961),
    [anon_sym_class] = ACTIONS(1961),
    [anon_sym_struct] = ACTIONS(1961),
    [anon_sym_union] = ACTIONS(1961),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1961),
    [anon_sym_decltype] = ACTIONS(1961),
    [anon_sym_virtual] = ACTIONS(1961),
    [anon_sym_alignas] = ACTIONS(1961),
    [anon_sym_explicit] = ACTIONS(1961),
    [anon_sym_typename] = ACTIONS(1961),
    [anon_sym_template] = ACTIONS(1961),
    [anon_sym_operator] = ACTIONS(1961),
    [anon_sym_friend] = ACTIONS(1961),
    [anon_sym_public] = ACTIONS(1961),
    [anon_sym_private] = ACTIONS(1961),
    [anon_sym_protected] = ACTIONS(1961),
    [anon_sym_using] = ACTIONS(1961),
    [anon_sym_static_assert] = ACTIONS(1961),
    [anon_sym_catch] = ACTIONS(1961),
  },
  [1791] = {
    [sym_identifier] = ACTIONS(1957),
    [aux_sym_preproc_def_token1] = ACTIONS(1957),
    [anon_sym_COMMA] = ACTIONS(2743),
    [aux_sym_preproc_if_token1] = ACTIONS(1957),
    [aux_sym_preproc_if_token2] = ACTIONS(1957),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1957),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1957),
    [aux_sym_preproc_else_token1] = ACTIONS(1957),
    [aux_sym_preproc_elif_token1] = ACTIONS(1957),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1957),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1957),
    [sym_preproc_directive] = ACTIONS(1957),
    [anon_sym_LPAREN2] = ACTIONS(1955),
    [anon_sym_TILDE] = ACTIONS(1955),
    [anon_sym_STAR] = ACTIONS(1955),
    [anon_sym_AMP_AMP] = ACTIONS(1955),
    [anon_sym_AMP] = ACTIONS(1957),
    [anon_sym_SEMI] = ACTIONS(2743),
    [anon_sym___extension__] = ACTIONS(1957),
    [anon_sym_typedef] = ACTIONS(1957),
    [anon_sym_extern] = ACTIONS(1957),
    [anon_sym___attribute__] = ACTIONS(1957),
    [anon_sym_COLON_COLON] = ACTIONS(1955),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1955),
    [anon_sym___declspec] = ACTIONS(1957),
    [anon_sym___based] = ACTIONS(1957),
    [anon_sym_signed] = ACTIONS(1957),
    [anon_sym_unsigned] = ACTIONS(1957),
    [anon_sym_long] = ACTIONS(1957),
    [anon_sym_short] = ACTIONS(1957),
    [anon_sym_LBRACK] = ACTIONS(1957),
    [anon_sym_static] = ACTIONS(1957),
    [anon_sym_register] = ACTIONS(1957),
    [anon_sym_inline] = ACTIONS(1957),
    [anon_sym___inline] = ACTIONS(1957),
    [anon_sym___inline__] = ACTIONS(1957),
    [anon_sym___forceinline] = ACTIONS(1957),
    [anon_sym_thread_local] = ACTIONS(1957),
    [anon_sym___thread] = ACTIONS(1957),
    [anon_sym_const] = ACTIONS(1957),
    [anon_sym_constexpr] = ACTIONS(1957),
    [anon_sym_volatile] = ACTIONS(1957),
    [anon_sym_restrict] = ACTIONS(1957),
    [anon_sym___restrict__] = ACTIONS(1957),
    [anon_sym__Atomic] = ACTIONS(1957),
    [anon_sym__Noreturn] = ACTIONS(1957),
    [anon_sym_noreturn] = ACTIONS(1957),
    [anon_sym_mutable] = ACTIONS(1957),
    [anon_sym_constinit] = ACTIONS(1957),
    [anon_sym_consteval] = ACTIONS(1957),
    [anon_sym_PROGMEM] = ACTIONS(1957),
    [aux_sym_primitive_type_token1] = ACTIONS(1957),
    [anon_sym_byte] = ACTIONS(1957),
    [anon_sym_word] = ACTIONS(1957),
    [anon_sym_enum] = ACTIONS(1957),
    [anon_sym_class] = ACTIONS(1957),
    [anon_sym_struct] = ACTIONS(1957),
    [anon_sym_union] = ACTIONS(1957),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1957),
    [anon_sym_decltype] = ACTIONS(1957),
    [anon_sym_virtual] = ACTIONS(1957),
    [anon_sym_alignas] = ACTIONS(1957),
    [anon_sym_explicit] = ACTIONS(1957),
    [anon_sym_typename] = ACTIONS(1957),
    [anon_sym_template] = ACTIONS(1957),
    [anon_sym_operator] = ACTIONS(1957),
    [anon_sym_friend] = ACTIONS(1957),
    [anon_sym_public] = ACTIONS(1957),
    [anon_sym_private] = ACTIONS(1957),
    [anon_sym_protected] = ACTIONS(1957),
    [anon_sym_using] = ACTIONS(1957),
    [anon_sym_static_assert] = ACTIONS(1957),
  },
  [1792] = {
    [sym_identifier] = ACTIONS(4810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4812),
    [anon_sym_COMMA] = ACTIONS(4812),
    [anon_sym_RPAREN] = ACTIONS(4812),
    [aux_sym_preproc_if_token2] = ACTIONS(4812),
    [aux_sym_preproc_else_token1] = ACTIONS(4812),
    [aux_sym_preproc_elif_token1] = ACTIONS(4810),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4812),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4812),
    [anon_sym_LPAREN2] = ACTIONS(4812),
    [anon_sym_DASH] = ACTIONS(4810),
    [anon_sym_PLUS] = ACTIONS(4810),
    [anon_sym_STAR] = ACTIONS(4810),
    [anon_sym_SLASH] = ACTIONS(4810),
    [anon_sym_PERCENT] = ACTIONS(4810),
    [anon_sym_PIPE_PIPE] = ACTIONS(4812),
    [anon_sym_AMP_AMP] = ACTIONS(4812),
    [anon_sym_PIPE] = ACTIONS(4810),
    [anon_sym_CARET] = ACTIONS(4810),
    [anon_sym_AMP] = ACTIONS(4810),
    [anon_sym_EQ_EQ] = ACTIONS(4812),
    [anon_sym_BANG_EQ] = ACTIONS(4812),
    [anon_sym_GT] = ACTIONS(4810),
    [anon_sym_GT_EQ] = ACTIONS(4812),
    [anon_sym_LT_EQ] = ACTIONS(4810),
    [anon_sym_LT] = ACTIONS(4810),
    [anon_sym_LT_LT] = ACTIONS(4810),
    [anon_sym_GT_GT] = ACTIONS(4810),
    [anon_sym_SEMI] = ACTIONS(4812),
    [anon_sym_RBRACE] = ACTIONS(4812),
    [anon_sym_LBRACK] = ACTIONS(4812),
    [anon_sym_RBRACK] = ACTIONS(4812),
    [anon_sym_EQ] = ACTIONS(4810),
    [anon_sym_COLON] = ACTIONS(4812),
    [anon_sym_QMARK] = ACTIONS(4812),
    [anon_sym_STAR_EQ] = ACTIONS(4812),
    [anon_sym_SLASH_EQ] = ACTIONS(4812),
    [anon_sym_PERCENT_EQ] = ACTIONS(4812),
    [anon_sym_PLUS_EQ] = ACTIONS(4812),
    [anon_sym_DASH_EQ] = ACTIONS(4812),
    [anon_sym_LT_LT_EQ] = ACTIONS(4812),
    [anon_sym_GT_GT_EQ] = ACTIONS(4812),
    [anon_sym_AMP_EQ] = ACTIONS(4812),
    [anon_sym_CARET_EQ] = ACTIONS(4812),
    [anon_sym_PIPE_EQ] = ACTIONS(4812),
    [anon_sym_and_eq] = ACTIONS(4810),
    [anon_sym_or_eq] = ACTIONS(4810),
    [anon_sym_xor_eq] = ACTIONS(4810),
    [anon_sym_LT_EQ_GT] = ACTIONS(4812),
    [anon_sym_or] = ACTIONS(4810),
    [anon_sym_and] = ACTIONS(4810),
    [anon_sym_bitor] = ACTIONS(4810),
    [anon_sym_xor] = ACTIONS(4810),
    [anon_sym_bitand] = ACTIONS(4810),
    [anon_sym_not_eq] = ACTIONS(4810),
    [anon_sym_DASH_DASH] = ACTIONS(4812),
    [anon_sym_PLUS_PLUS] = ACTIONS(4812),
    [anon_sym_DOT] = ACTIONS(4810),
    [anon_sym_DOT_STAR] = ACTIONS(4812),
    [anon_sym_DASH_GT] = ACTIONS(4812),
    [anon_sym_L_DQUOTE] = ACTIONS(4812),
    [anon_sym_u_DQUOTE] = ACTIONS(4812),
    [anon_sym_U_DQUOTE] = ACTIONS(4812),
    [anon_sym_u8_DQUOTE] = ACTIONS(4812),
    [anon_sym_DQUOTE] = ACTIONS(4812),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4812),
    [anon_sym_LR_DQUOTE] = ACTIONS(4812),
    [anon_sym_uR_DQUOTE] = ACTIONS(4812),
    [anon_sym_UR_DQUOTE] = ACTIONS(4812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4812),
    [sym_literal_suffix] = ACTIONS(4810),
  },
  [1793] = {
    [sym_identifier] = ACTIONS(2937),
    [aux_sym_preproc_def_token1] = ACTIONS(2937),
    [aux_sym_preproc_if_token1] = ACTIONS(2937),
    [aux_sym_preproc_if_token2] = ACTIONS(2937),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2937),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2937),
    [aux_sym_preproc_else_token1] = ACTIONS(2937),
    [aux_sym_preproc_elif_token1] = ACTIONS(2937),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2937),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2937),
    [sym_preproc_directive] = ACTIONS(2937),
    [anon_sym_LPAREN2] = ACTIONS(2939),
    [anon_sym_TILDE] = ACTIONS(2939),
    [anon_sym_STAR] = ACTIONS(2939),
    [anon_sym_AMP_AMP] = ACTIONS(2939),
    [anon_sym_AMP] = ACTIONS(2937),
    [anon_sym_SEMI] = ACTIONS(4814),
    [anon_sym___extension__] = ACTIONS(2937),
    [anon_sym_typedef] = ACTIONS(2937),
    [anon_sym_extern] = ACTIONS(2937),
    [anon_sym___attribute__] = ACTIONS(2937),
    [anon_sym_COLON_COLON] = ACTIONS(2939),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2939),
    [anon_sym___declspec] = ACTIONS(2937),
    [anon_sym___based] = ACTIONS(2937),
    [anon_sym_signed] = ACTIONS(2937),
    [anon_sym_unsigned] = ACTIONS(2937),
    [anon_sym_long] = ACTIONS(2937),
    [anon_sym_short] = ACTIONS(2937),
    [anon_sym_LBRACK] = ACTIONS(2937),
    [anon_sym_static] = ACTIONS(2937),
    [anon_sym_register] = ACTIONS(2937),
    [anon_sym_inline] = ACTIONS(2937),
    [anon_sym___inline] = ACTIONS(2937),
    [anon_sym___inline__] = ACTIONS(2937),
    [anon_sym___forceinline] = ACTIONS(2937),
    [anon_sym_thread_local] = ACTIONS(2937),
    [anon_sym___thread] = ACTIONS(2937),
    [anon_sym_const] = ACTIONS(2937),
    [anon_sym_constexpr] = ACTIONS(2937),
    [anon_sym_volatile] = ACTIONS(2937),
    [anon_sym_restrict] = ACTIONS(2937),
    [anon_sym___restrict__] = ACTIONS(2937),
    [anon_sym__Atomic] = ACTIONS(2937),
    [anon_sym__Noreturn] = ACTIONS(2937),
    [anon_sym_noreturn] = ACTIONS(2937),
    [anon_sym_mutable] = ACTIONS(2937),
    [anon_sym_constinit] = ACTIONS(2937),
    [anon_sym_consteval] = ACTIONS(2937),
    [anon_sym_PROGMEM] = ACTIONS(2937),
    [aux_sym_primitive_type_token1] = ACTIONS(2937),
    [anon_sym_byte] = ACTIONS(2937),
    [anon_sym_word] = ACTIONS(2937),
    [anon_sym_enum] = ACTIONS(2937),
    [anon_sym_class] = ACTIONS(2937),
    [anon_sym_struct] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2937),
    [anon_sym_decltype] = ACTIONS(2937),
    [anon_sym_virtual] = ACTIONS(2937),
    [anon_sym_alignas] = ACTIONS(2937),
    [anon_sym_explicit] = ACTIONS(2937),
    [anon_sym_typename] = ACTIONS(2937),
    [anon_sym_template] = ACTIONS(2937),
    [anon_sym_operator] = ACTIONS(2937),
    [anon_sym_friend] = ACTIONS(2937),
    [anon_sym_public] = ACTIONS(2937),
    [anon_sym_private] = ACTIONS(2937),
    [anon_sym_protected] = ACTIONS(2937),
    [anon_sym_using] = ACTIONS(2937),
    [anon_sym_static_assert] = ACTIONS(2937),
  },
  [1794] = {
    [sym_identifier] = ACTIONS(4816),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4818),
    [anon_sym_COMMA] = ACTIONS(4818),
    [anon_sym_RPAREN] = ACTIONS(4818),
    [aux_sym_preproc_if_token2] = ACTIONS(4818),
    [aux_sym_preproc_else_token1] = ACTIONS(4818),
    [aux_sym_preproc_elif_token1] = ACTIONS(4816),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4818),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4818),
    [anon_sym_LPAREN2] = ACTIONS(4818),
    [anon_sym_DASH] = ACTIONS(4816),
    [anon_sym_PLUS] = ACTIONS(4816),
    [anon_sym_STAR] = ACTIONS(4816),
    [anon_sym_SLASH] = ACTIONS(4816),
    [anon_sym_PERCENT] = ACTIONS(4816),
    [anon_sym_PIPE_PIPE] = ACTIONS(4818),
    [anon_sym_AMP_AMP] = ACTIONS(4818),
    [anon_sym_PIPE] = ACTIONS(4816),
    [anon_sym_CARET] = ACTIONS(4816),
    [anon_sym_AMP] = ACTIONS(4816),
    [anon_sym_EQ_EQ] = ACTIONS(4818),
    [anon_sym_BANG_EQ] = ACTIONS(4818),
    [anon_sym_GT] = ACTIONS(4816),
    [anon_sym_GT_EQ] = ACTIONS(4818),
    [anon_sym_LT_EQ] = ACTIONS(4816),
    [anon_sym_LT] = ACTIONS(4816),
    [anon_sym_LT_LT] = ACTIONS(4816),
    [anon_sym_GT_GT] = ACTIONS(4816),
    [anon_sym_SEMI] = ACTIONS(4818),
    [anon_sym_RBRACE] = ACTIONS(4818),
    [anon_sym_LBRACK] = ACTIONS(4818),
    [anon_sym_RBRACK] = ACTIONS(4818),
    [anon_sym_EQ] = ACTIONS(4816),
    [anon_sym_COLON] = ACTIONS(4818),
    [anon_sym_QMARK] = ACTIONS(4818),
    [anon_sym_STAR_EQ] = ACTIONS(4818),
    [anon_sym_SLASH_EQ] = ACTIONS(4818),
    [anon_sym_PERCENT_EQ] = ACTIONS(4818),
    [anon_sym_PLUS_EQ] = ACTIONS(4818),
    [anon_sym_DASH_EQ] = ACTIONS(4818),
    [anon_sym_LT_LT_EQ] = ACTIONS(4818),
    [anon_sym_GT_GT_EQ] = ACTIONS(4818),
    [anon_sym_AMP_EQ] = ACTIONS(4818),
    [anon_sym_CARET_EQ] = ACTIONS(4818),
    [anon_sym_PIPE_EQ] = ACTIONS(4818),
    [anon_sym_and_eq] = ACTIONS(4816),
    [anon_sym_or_eq] = ACTIONS(4816),
    [anon_sym_xor_eq] = ACTIONS(4816),
    [anon_sym_LT_EQ_GT] = ACTIONS(4818),
    [anon_sym_or] = ACTIONS(4816),
    [anon_sym_and] = ACTIONS(4816),
    [anon_sym_bitor] = ACTIONS(4816),
    [anon_sym_xor] = ACTIONS(4816),
    [anon_sym_bitand] = ACTIONS(4816),
    [anon_sym_not_eq] = ACTIONS(4816),
    [anon_sym_DASH_DASH] = ACTIONS(4818),
    [anon_sym_PLUS_PLUS] = ACTIONS(4818),
    [anon_sym_DOT] = ACTIONS(4816),
    [anon_sym_DOT_STAR] = ACTIONS(4818),
    [anon_sym_DASH_GT] = ACTIONS(4818),
    [anon_sym_L_DQUOTE] = ACTIONS(4818),
    [anon_sym_u_DQUOTE] = ACTIONS(4818),
    [anon_sym_U_DQUOTE] = ACTIONS(4818),
    [anon_sym_u8_DQUOTE] = ACTIONS(4818),
    [anon_sym_DQUOTE] = ACTIONS(4818),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4818),
    [anon_sym_LR_DQUOTE] = ACTIONS(4818),
    [anon_sym_uR_DQUOTE] = ACTIONS(4818),
    [anon_sym_UR_DQUOTE] = ACTIONS(4818),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4818),
    [sym_literal_suffix] = ACTIONS(4816),
  },
  [1795] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4565),
    [anon_sym_COMMA] = ACTIONS(4565),
    [anon_sym_LPAREN2] = ACTIONS(4565),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_STAR] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4563),
    [anon_sym_PERCENT] = ACTIONS(4563),
    [anon_sym_PIPE_PIPE] = ACTIONS(4565),
    [anon_sym_AMP_AMP] = ACTIONS(4565),
    [anon_sym_PIPE] = ACTIONS(4563),
    [anon_sym_CARET] = ACTIONS(4563),
    [anon_sym_AMP] = ACTIONS(4563),
    [anon_sym_EQ_EQ] = ACTIONS(4565),
    [anon_sym_BANG_EQ] = ACTIONS(4565),
    [anon_sym_GT] = ACTIONS(4563),
    [anon_sym_GT_EQ] = ACTIONS(4563),
    [anon_sym_LT_EQ] = ACTIONS(4563),
    [anon_sym_LT] = ACTIONS(4563),
    [anon_sym_LT_LT] = ACTIONS(4563),
    [anon_sym_GT_GT] = ACTIONS(4563),
    [anon_sym___extension__] = ACTIONS(4565),
    [anon_sym___attribute__] = ACTIONS(4565),
    [anon_sym_COLON_COLON] = ACTIONS(4565),
    [anon_sym_LBRACE] = ACTIONS(4565),
    [anon_sym_LBRACK] = ACTIONS(4565),
    [anon_sym_EQ] = ACTIONS(4563),
    [anon_sym_const] = ACTIONS(4563),
    [anon_sym_constexpr] = ACTIONS(4565),
    [anon_sym_volatile] = ACTIONS(4565),
    [anon_sym_restrict] = ACTIONS(4565),
    [anon_sym___restrict__] = ACTIONS(4565),
    [anon_sym__Atomic] = ACTIONS(4565),
    [anon_sym__Noreturn] = ACTIONS(4565),
    [anon_sym_noreturn] = ACTIONS(4565),
    [anon_sym_mutable] = ACTIONS(4565),
    [anon_sym_constinit] = ACTIONS(4565),
    [anon_sym_consteval] = ACTIONS(4565),
    [anon_sym_PROGMEM] = ACTIONS(4565),
    [anon_sym_COLON] = ACTIONS(4563),
    [anon_sym_QMARK] = ACTIONS(4565),
    [anon_sym_STAR_EQ] = ACTIONS(4565),
    [anon_sym_SLASH_EQ] = ACTIONS(4565),
    [anon_sym_PERCENT_EQ] = ACTIONS(4565),
    [anon_sym_PLUS_EQ] = ACTIONS(4565),
    [anon_sym_DASH_EQ] = ACTIONS(4565),
    [anon_sym_LT_LT_EQ] = ACTIONS(4565),
    [anon_sym_GT_GT_EQ] = ACTIONS(4563),
    [anon_sym_AMP_EQ] = ACTIONS(4565),
    [anon_sym_CARET_EQ] = ACTIONS(4565),
    [anon_sym_PIPE_EQ] = ACTIONS(4565),
    [anon_sym_and_eq] = ACTIONS(4565),
    [anon_sym_or_eq] = ACTIONS(4565),
    [anon_sym_xor_eq] = ACTIONS(4565),
    [anon_sym_LT_EQ_GT] = ACTIONS(4565),
    [anon_sym_or] = ACTIONS(4563),
    [anon_sym_and] = ACTIONS(4563),
    [anon_sym_bitor] = ACTIONS(4565),
    [anon_sym_xor] = ACTIONS(4563),
    [anon_sym_bitand] = ACTIONS(4565),
    [anon_sym_not_eq] = ACTIONS(4565),
    [anon_sym_DASH_DASH] = ACTIONS(4565),
    [anon_sym_PLUS_PLUS] = ACTIONS(4565),
    [anon_sym_DOT] = ACTIONS(4563),
    [anon_sym_DOT_STAR] = ACTIONS(4565),
    [anon_sym_DASH_GT] = ACTIONS(4565),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4565),
    [anon_sym_decltype] = ACTIONS(4565),
    [anon_sym_final] = ACTIONS(4565),
    [anon_sym_override] = ACTIONS(4565),
    [anon_sym_GT2] = ACTIONS(4565),
  },
  [1796] = {
    [sym_identifier] = ACTIONS(2527),
    [aux_sym_preproc_def_token1] = ACTIONS(2527),
    [aux_sym_preproc_if_token1] = ACTIONS(2527),
    [aux_sym_preproc_if_token2] = ACTIONS(2527),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2527),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2527),
    [aux_sym_preproc_else_token1] = ACTIONS(2527),
    [aux_sym_preproc_elif_token1] = ACTIONS(2527),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2527),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2527),
    [sym_preproc_directive] = ACTIONS(2527),
    [anon_sym_LPAREN2] = ACTIONS(2529),
    [anon_sym_TILDE] = ACTIONS(2529),
    [anon_sym_STAR] = ACTIONS(2529),
    [anon_sym_AMP_AMP] = ACTIONS(2529),
    [anon_sym_AMP] = ACTIONS(2527),
    [anon_sym___extension__] = ACTIONS(2527),
    [anon_sym_typedef] = ACTIONS(2527),
    [anon_sym_extern] = ACTIONS(2527),
    [anon_sym___attribute__] = ACTIONS(2527),
    [anon_sym_COLON_COLON] = ACTIONS(2529),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2529),
    [anon_sym___declspec] = ACTIONS(2527),
    [anon_sym___based] = ACTIONS(2527),
    [anon_sym_signed] = ACTIONS(2527),
    [anon_sym_unsigned] = ACTIONS(2527),
    [anon_sym_long] = ACTIONS(2527),
    [anon_sym_short] = ACTIONS(2527),
    [anon_sym_LBRACK] = ACTIONS(2527),
    [anon_sym_static] = ACTIONS(2527),
    [anon_sym_register] = ACTIONS(2527),
    [anon_sym_inline] = ACTIONS(2527),
    [anon_sym___inline] = ACTIONS(2527),
    [anon_sym___inline__] = ACTIONS(2527),
    [anon_sym___forceinline] = ACTIONS(2527),
    [anon_sym_thread_local] = ACTIONS(2527),
    [anon_sym___thread] = ACTIONS(2527),
    [anon_sym_const] = ACTIONS(2527),
    [anon_sym_constexpr] = ACTIONS(2527),
    [anon_sym_volatile] = ACTIONS(2527),
    [anon_sym_restrict] = ACTIONS(2527),
    [anon_sym___restrict__] = ACTIONS(2527),
    [anon_sym__Atomic] = ACTIONS(2527),
    [anon_sym__Noreturn] = ACTIONS(2527),
    [anon_sym_noreturn] = ACTIONS(2527),
    [anon_sym_mutable] = ACTIONS(2527),
    [anon_sym_constinit] = ACTIONS(2527),
    [anon_sym_consteval] = ACTIONS(2527),
    [anon_sym_PROGMEM] = ACTIONS(2527),
    [aux_sym_primitive_type_token1] = ACTIONS(2527),
    [anon_sym_byte] = ACTIONS(2527),
    [anon_sym_word] = ACTIONS(2527),
    [anon_sym_enum] = ACTIONS(2527),
    [anon_sym_class] = ACTIONS(2527),
    [anon_sym_struct] = ACTIONS(2527),
    [anon_sym_union] = ACTIONS(2527),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2527),
    [anon_sym_decltype] = ACTIONS(2527),
    [anon_sym_virtual] = ACTIONS(2527),
    [anon_sym_alignas] = ACTIONS(2527),
    [anon_sym_explicit] = ACTIONS(2527),
    [anon_sym_typename] = ACTIONS(2527),
    [anon_sym_template] = ACTIONS(2527),
    [anon_sym_operator] = ACTIONS(2527),
    [anon_sym_friend] = ACTIONS(2527),
    [anon_sym_public] = ACTIONS(2527),
    [anon_sym_private] = ACTIONS(2527),
    [anon_sym_protected] = ACTIONS(2527),
    [anon_sym_using] = ACTIONS(2527),
    [anon_sym_static_assert] = ACTIONS(2527),
    [anon_sym_catch] = ACTIONS(2527),
  },
  [1797] = {
    [sym_identifier] = ACTIONS(3105),
    [aux_sym_preproc_def_token1] = ACTIONS(3105),
    [aux_sym_preproc_if_token1] = ACTIONS(3105),
    [aux_sym_preproc_if_token2] = ACTIONS(3105),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3105),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3105),
    [aux_sym_preproc_else_token1] = ACTIONS(3105),
    [aux_sym_preproc_elif_token1] = ACTIONS(3105),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3105),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3105),
    [sym_preproc_directive] = ACTIONS(3105),
    [anon_sym_LPAREN2] = ACTIONS(3107),
    [anon_sym_TILDE] = ACTIONS(3107),
    [anon_sym_STAR] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3107),
    [anon_sym_AMP] = ACTIONS(3105),
    [anon_sym_SEMI] = ACTIONS(4820),
    [anon_sym___extension__] = ACTIONS(3105),
    [anon_sym_typedef] = ACTIONS(3105),
    [anon_sym_extern] = ACTIONS(3105),
    [anon_sym___attribute__] = ACTIONS(3105),
    [anon_sym_COLON_COLON] = ACTIONS(3107),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3107),
    [anon_sym___declspec] = ACTIONS(3105),
    [anon_sym___based] = ACTIONS(3105),
    [anon_sym_signed] = ACTIONS(3105),
    [anon_sym_unsigned] = ACTIONS(3105),
    [anon_sym_long] = ACTIONS(3105),
    [anon_sym_short] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(3105),
    [anon_sym_static] = ACTIONS(3105),
    [anon_sym_register] = ACTIONS(3105),
    [anon_sym_inline] = ACTIONS(3105),
    [anon_sym___inline] = ACTIONS(3105),
    [anon_sym___inline__] = ACTIONS(3105),
    [anon_sym___forceinline] = ACTIONS(3105),
    [anon_sym_thread_local] = ACTIONS(3105),
    [anon_sym___thread] = ACTIONS(3105),
    [anon_sym_const] = ACTIONS(3105),
    [anon_sym_constexpr] = ACTIONS(3105),
    [anon_sym_volatile] = ACTIONS(3105),
    [anon_sym_restrict] = ACTIONS(3105),
    [anon_sym___restrict__] = ACTIONS(3105),
    [anon_sym__Atomic] = ACTIONS(3105),
    [anon_sym__Noreturn] = ACTIONS(3105),
    [anon_sym_noreturn] = ACTIONS(3105),
    [anon_sym_mutable] = ACTIONS(3105),
    [anon_sym_constinit] = ACTIONS(3105),
    [anon_sym_consteval] = ACTIONS(3105),
    [anon_sym_PROGMEM] = ACTIONS(3105),
    [aux_sym_primitive_type_token1] = ACTIONS(3105),
    [anon_sym_byte] = ACTIONS(3105),
    [anon_sym_word] = ACTIONS(3105),
    [anon_sym_enum] = ACTIONS(3105),
    [anon_sym_class] = ACTIONS(3105),
    [anon_sym_struct] = ACTIONS(3105),
    [anon_sym_union] = ACTIONS(3105),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3105),
    [anon_sym_decltype] = ACTIONS(3105),
    [anon_sym_virtual] = ACTIONS(3105),
    [anon_sym_alignas] = ACTIONS(3105),
    [anon_sym_explicit] = ACTIONS(3105),
    [anon_sym_typename] = ACTIONS(3105),
    [anon_sym_template] = ACTIONS(3105),
    [anon_sym_operator] = ACTIONS(3105),
    [anon_sym_friend] = ACTIONS(3105),
    [anon_sym_public] = ACTIONS(3105),
    [anon_sym_private] = ACTIONS(3105),
    [anon_sym_protected] = ACTIONS(3105),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_static_assert] = ACTIONS(3105),
  },
  [1798] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4569),
    [anon_sym_COMMA] = ACTIONS(4569),
    [anon_sym_LPAREN2] = ACTIONS(4569),
    [anon_sym_DASH] = ACTIONS(4567),
    [anon_sym_PLUS] = ACTIONS(4567),
    [anon_sym_STAR] = ACTIONS(4567),
    [anon_sym_SLASH] = ACTIONS(4567),
    [anon_sym_PERCENT] = ACTIONS(4567),
    [anon_sym_PIPE_PIPE] = ACTIONS(4569),
    [anon_sym_AMP_AMP] = ACTIONS(4569),
    [anon_sym_PIPE] = ACTIONS(4567),
    [anon_sym_CARET] = ACTIONS(4567),
    [anon_sym_AMP] = ACTIONS(4567),
    [anon_sym_EQ_EQ] = ACTIONS(4569),
    [anon_sym_BANG_EQ] = ACTIONS(4569),
    [anon_sym_GT] = ACTIONS(4567),
    [anon_sym_GT_EQ] = ACTIONS(4567),
    [anon_sym_LT_EQ] = ACTIONS(4567),
    [anon_sym_LT] = ACTIONS(4567),
    [anon_sym_LT_LT] = ACTIONS(4567),
    [anon_sym_GT_GT] = ACTIONS(4567),
    [anon_sym___extension__] = ACTIONS(4569),
    [anon_sym___attribute__] = ACTIONS(4569),
    [anon_sym_COLON_COLON] = ACTIONS(4569),
    [anon_sym_LBRACE] = ACTIONS(4569),
    [anon_sym_LBRACK] = ACTIONS(4569),
    [anon_sym_EQ] = ACTIONS(4567),
    [anon_sym_const] = ACTIONS(4567),
    [anon_sym_constexpr] = ACTIONS(4569),
    [anon_sym_volatile] = ACTIONS(4569),
    [anon_sym_restrict] = ACTIONS(4569),
    [anon_sym___restrict__] = ACTIONS(4569),
    [anon_sym__Atomic] = ACTIONS(4569),
    [anon_sym__Noreturn] = ACTIONS(4569),
    [anon_sym_noreturn] = ACTIONS(4569),
    [anon_sym_mutable] = ACTIONS(4569),
    [anon_sym_constinit] = ACTIONS(4569),
    [anon_sym_consteval] = ACTIONS(4569),
    [anon_sym_PROGMEM] = ACTIONS(4569),
    [anon_sym_COLON] = ACTIONS(4567),
    [anon_sym_QMARK] = ACTIONS(4569),
    [anon_sym_STAR_EQ] = ACTIONS(4569),
    [anon_sym_SLASH_EQ] = ACTIONS(4569),
    [anon_sym_PERCENT_EQ] = ACTIONS(4569),
    [anon_sym_PLUS_EQ] = ACTIONS(4569),
    [anon_sym_DASH_EQ] = ACTIONS(4569),
    [anon_sym_LT_LT_EQ] = ACTIONS(4569),
    [anon_sym_GT_GT_EQ] = ACTIONS(4567),
    [anon_sym_AMP_EQ] = ACTIONS(4569),
    [anon_sym_CARET_EQ] = ACTIONS(4569),
    [anon_sym_PIPE_EQ] = ACTIONS(4569),
    [anon_sym_and_eq] = ACTIONS(4569),
    [anon_sym_or_eq] = ACTIONS(4569),
    [anon_sym_xor_eq] = ACTIONS(4569),
    [anon_sym_LT_EQ_GT] = ACTIONS(4569),
    [anon_sym_or] = ACTIONS(4567),
    [anon_sym_and] = ACTIONS(4567),
    [anon_sym_bitor] = ACTIONS(4569),
    [anon_sym_xor] = ACTIONS(4567),
    [anon_sym_bitand] = ACTIONS(4569),
    [anon_sym_not_eq] = ACTIONS(4569),
    [anon_sym_DASH_DASH] = ACTIONS(4569),
    [anon_sym_PLUS_PLUS] = ACTIONS(4569),
    [anon_sym_DOT] = ACTIONS(4567),
    [anon_sym_DOT_STAR] = ACTIONS(4569),
    [anon_sym_DASH_GT] = ACTIONS(4569),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4569),
    [anon_sym_decltype] = ACTIONS(4569),
    [anon_sym_final] = ACTIONS(4569),
    [anon_sym_override] = ACTIONS(4569),
    [anon_sym_GT2] = ACTIONS(4569),
  },
  [1799] = {
    [sym_type_qualifier] = STATE(1799),
    [aux_sym__type_definition_type_repeat1] = STATE(1799),
    [sym_identifier] = ACTIONS(4822),
    [anon_sym_LPAREN2] = ACTIONS(4824),
    [anon_sym_BANG] = ACTIONS(4824),
    [anon_sym_TILDE] = ACTIONS(4824),
    [anon_sym_DASH] = ACTIONS(4822),
    [anon_sym_PLUS] = ACTIONS(4822),
    [anon_sym_STAR] = ACTIONS(4824),
    [anon_sym_AMP] = ACTIONS(4824),
    [anon_sym___extension__] = ACTIONS(4826),
    [anon_sym_COLON_COLON] = ACTIONS(4824),
    [anon_sym_LBRACK] = ACTIONS(4824),
    [anon_sym_RBRACK] = ACTIONS(4824),
    [anon_sym_const] = ACTIONS(4826),
    [anon_sym_constexpr] = ACTIONS(4826),
    [anon_sym_volatile] = ACTIONS(4826),
    [anon_sym_restrict] = ACTIONS(4826),
    [anon_sym___restrict__] = ACTIONS(4826),
    [anon_sym__Atomic] = ACTIONS(4826),
    [anon_sym__Noreturn] = ACTIONS(4826),
    [anon_sym_noreturn] = ACTIONS(4826),
    [anon_sym_mutable] = ACTIONS(4826),
    [anon_sym_constinit] = ACTIONS(4826),
    [anon_sym_consteval] = ACTIONS(4826),
    [anon_sym_PROGMEM] = ACTIONS(4826),
    [aux_sym_primitive_type_token1] = ACTIONS(4822),
    [anon_sym_byte] = ACTIONS(4822),
    [anon_sym_word] = ACTIONS(4822),
    [anon_sym_not] = ACTIONS(4822),
    [anon_sym_compl] = ACTIONS(4822),
    [anon_sym_DASH_DASH] = ACTIONS(4824),
    [anon_sym_PLUS_PLUS] = ACTIONS(4824),
    [anon_sym_sizeof] = ACTIONS(4822),
    [anon_sym___alignof__] = ACTIONS(4822),
    [anon_sym___alignof] = ACTIONS(4822),
    [anon_sym__alignof] = ACTIONS(4822),
    [anon_sym_alignof] = ACTIONS(4822),
    [anon_sym__Alignof] = ACTIONS(4822),
    [anon_sym_offsetof] = ACTIONS(4822),
    [anon_sym__Generic] = ACTIONS(4822),
    [anon_sym_asm] = ACTIONS(4822),
    [anon_sym___asm__] = ACTIONS(4822),
    [aux_sym_number_literal_token1] = ACTIONS(4824),
    [aux_sym_number_literal_token2] = ACTIONS(4822),
    [anon_sym_L_SQUOTE] = ACTIONS(4824),
    [anon_sym_u_SQUOTE] = ACTIONS(4824),
    [anon_sym_U_SQUOTE] = ACTIONS(4824),
    [anon_sym_u8_SQUOTE] = ACTIONS(4824),
    [anon_sym_SQUOTE] = ACTIONS(4824),
    [anon_sym_L_DQUOTE] = ACTIONS(4824),
    [anon_sym_u_DQUOTE] = ACTIONS(4824),
    [anon_sym_U_DQUOTE] = ACTIONS(4824),
    [anon_sym_u8_DQUOTE] = ACTIONS(4824),
    [anon_sym_DQUOTE] = ACTIONS(4824),
    [sym_true] = ACTIONS(4822),
    [sym_false] = ACTIONS(4822),
    [anon_sym_NULL] = ACTIONS(4822),
    [anon_sym_nullptr] = ACTIONS(4822),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(4822),
    [anon_sym_template] = ACTIONS(4822),
    [anon_sym_delete] = ACTIONS(4822),
    [anon_sym_R_DQUOTE] = ACTIONS(4824),
    [anon_sym_LR_DQUOTE] = ACTIONS(4824),
    [anon_sym_uR_DQUOTE] = ACTIONS(4824),
    [anon_sym_UR_DQUOTE] = ACTIONS(4824),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4824),
    [anon_sym_co_await] = ACTIONS(4822),
    [anon_sym_new] = ACTIONS(4822),
    [anon_sym_requires] = ACTIONS(4822),
    [sym_this] = ACTIONS(4822),
  },
  [1800] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4573),
    [anon_sym_COMMA] = ACTIONS(4573),
    [anon_sym_LPAREN2] = ACTIONS(4573),
    [anon_sym_DASH] = ACTIONS(4571),
    [anon_sym_PLUS] = ACTIONS(4571),
    [anon_sym_STAR] = ACTIONS(4571),
    [anon_sym_SLASH] = ACTIONS(4571),
    [anon_sym_PERCENT] = ACTIONS(4571),
    [anon_sym_PIPE_PIPE] = ACTIONS(4573),
    [anon_sym_AMP_AMP] = ACTIONS(4573),
    [anon_sym_PIPE] = ACTIONS(4571),
    [anon_sym_CARET] = ACTIONS(4571),
    [anon_sym_AMP] = ACTIONS(4571),
    [anon_sym_EQ_EQ] = ACTIONS(4573),
    [anon_sym_BANG_EQ] = ACTIONS(4573),
    [anon_sym_GT] = ACTIONS(4571),
    [anon_sym_GT_EQ] = ACTIONS(4571),
    [anon_sym_LT_EQ] = ACTIONS(4571),
    [anon_sym_LT] = ACTIONS(4571),
    [anon_sym_LT_LT] = ACTIONS(4571),
    [anon_sym_GT_GT] = ACTIONS(4571),
    [anon_sym___extension__] = ACTIONS(4573),
    [anon_sym___attribute__] = ACTIONS(4573),
    [anon_sym_COLON_COLON] = ACTIONS(4573),
    [anon_sym_LBRACE] = ACTIONS(4573),
    [anon_sym_LBRACK] = ACTIONS(4573),
    [anon_sym_EQ] = ACTIONS(4571),
    [anon_sym_const] = ACTIONS(4571),
    [anon_sym_constexpr] = ACTIONS(4573),
    [anon_sym_volatile] = ACTIONS(4573),
    [anon_sym_restrict] = ACTIONS(4573),
    [anon_sym___restrict__] = ACTIONS(4573),
    [anon_sym__Atomic] = ACTIONS(4573),
    [anon_sym__Noreturn] = ACTIONS(4573),
    [anon_sym_noreturn] = ACTIONS(4573),
    [anon_sym_mutable] = ACTIONS(4573),
    [anon_sym_constinit] = ACTIONS(4573),
    [anon_sym_consteval] = ACTIONS(4573),
    [anon_sym_PROGMEM] = ACTIONS(4573),
    [anon_sym_COLON] = ACTIONS(4571),
    [anon_sym_QMARK] = ACTIONS(4573),
    [anon_sym_STAR_EQ] = ACTIONS(4573),
    [anon_sym_SLASH_EQ] = ACTIONS(4573),
    [anon_sym_PERCENT_EQ] = ACTIONS(4573),
    [anon_sym_PLUS_EQ] = ACTIONS(4573),
    [anon_sym_DASH_EQ] = ACTIONS(4573),
    [anon_sym_LT_LT_EQ] = ACTIONS(4573),
    [anon_sym_GT_GT_EQ] = ACTIONS(4571),
    [anon_sym_AMP_EQ] = ACTIONS(4573),
    [anon_sym_CARET_EQ] = ACTIONS(4573),
    [anon_sym_PIPE_EQ] = ACTIONS(4573),
    [anon_sym_and_eq] = ACTIONS(4573),
    [anon_sym_or_eq] = ACTIONS(4573),
    [anon_sym_xor_eq] = ACTIONS(4573),
    [anon_sym_LT_EQ_GT] = ACTIONS(4573),
    [anon_sym_or] = ACTIONS(4571),
    [anon_sym_and] = ACTIONS(4571),
    [anon_sym_bitor] = ACTIONS(4573),
    [anon_sym_xor] = ACTIONS(4571),
    [anon_sym_bitand] = ACTIONS(4573),
    [anon_sym_not_eq] = ACTIONS(4573),
    [anon_sym_DASH_DASH] = ACTIONS(4573),
    [anon_sym_PLUS_PLUS] = ACTIONS(4573),
    [anon_sym_DOT] = ACTIONS(4571),
    [anon_sym_DOT_STAR] = ACTIONS(4573),
    [anon_sym_DASH_GT] = ACTIONS(4573),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4573),
    [anon_sym_decltype] = ACTIONS(4573),
    [anon_sym_final] = ACTIONS(4573),
    [anon_sym_override] = ACTIONS(4573),
    [anon_sym_GT2] = ACTIONS(4573),
  },
  [1801] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4561),
    [anon_sym_COMMA] = ACTIONS(4561),
    [anon_sym_LPAREN2] = ACTIONS(4561),
    [anon_sym_DASH] = ACTIONS(4559),
    [anon_sym_PLUS] = ACTIONS(4559),
    [anon_sym_STAR] = ACTIONS(4559),
    [anon_sym_SLASH] = ACTIONS(4559),
    [anon_sym_PERCENT] = ACTIONS(4559),
    [anon_sym_PIPE_PIPE] = ACTIONS(4561),
    [anon_sym_AMP_AMP] = ACTIONS(4561),
    [anon_sym_PIPE] = ACTIONS(4559),
    [anon_sym_CARET] = ACTIONS(4559),
    [anon_sym_AMP] = ACTIONS(4559),
    [anon_sym_EQ_EQ] = ACTIONS(4561),
    [anon_sym_BANG_EQ] = ACTIONS(4561),
    [anon_sym_GT] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4559),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_LT] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4559),
    [anon_sym_GT_GT] = ACTIONS(4559),
    [anon_sym___extension__] = ACTIONS(4561),
    [anon_sym___attribute__] = ACTIONS(4561),
    [anon_sym_COLON_COLON] = ACTIONS(4561),
    [anon_sym_LBRACE] = ACTIONS(4561),
    [anon_sym_LBRACK] = ACTIONS(4561),
    [anon_sym_EQ] = ACTIONS(4559),
    [anon_sym_const] = ACTIONS(4559),
    [anon_sym_constexpr] = ACTIONS(4561),
    [anon_sym_volatile] = ACTIONS(4561),
    [anon_sym_restrict] = ACTIONS(4561),
    [anon_sym___restrict__] = ACTIONS(4561),
    [anon_sym__Atomic] = ACTIONS(4561),
    [anon_sym__Noreturn] = ACTIONS(4561),
    [anon_sym_noreturn] = ACTIONS(4561),
    [anon_sym_mutable] = ACTIONS(4561),
    [anon_sym_constinit] = ACTIONS(4561),
    [anon_sym_consteval] = ACTIONS(4561),
    [anon_sym_PROGMEM] = ACTIONS(4561),
    [anon_sym_COLON] = ACTIONS(4559),
    [anon_sym_QMARK] = ACTIONS(4561),
    [anon_sym_STAR_EQ] = ACTIONS(4561),
    [anon_sym_SLASH_EQ] = ACTIONS(4561),
    [anon_sym_PERCENT_EQ] = ACTIONS(4561),
    [anon_sym_PLUS_EQ] = ACTIONS(4561),
    [anon_sym_DASH_EQ] = ACTIONS(4561),
    [anon_sym_LT_LT_EQ] = ACTIONS(4561),
    [anon_sym_GT_GT_EQ] = ACTIONS(4559),
    [anon_sym_AMP_EQ] = ACTIONS(4561),
    [anon_sym_CARET_EQ] = ACTIONS(4561),
    [anon_sym_PIPE_EQ] = ACTIONS(4561),
    [anon_sym_and_eq] = ACTIONS(4561),
    [anon_sym_or_eq] = ACTIONS(4561),
    [anon_sym_xor_eq] = ACTIONS(4561),
    [anon_sym_LT_EQ_GT] = ACTIONS(4561),
    [anon_sym_or] = ACTIONS(4559),
    [anon_sym_and] = ACTIONS(4559),
    [anon_sym_bitor] = ACTIONS(4561),
    [anon_sym_xor] = ACTIONS(4559),
    [anon_sym_bitand] = ACTIONS(4561),
    [anon_sym_not_eq] = ACTIONS(4561),
    [anon_sym_DASH_DASH] = ACTIONS(4561),
    [anon_sym_PLUS_PLUS] = ACTIONS(4561),
    [anon_sym_DOT] = ACTIONS(4559),
    [anon_sym_DOT_STAR] = ACTIONS(4561),
    [anon_sym_DASH_GT] = ACTIONS(4561),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4561),
    [anon_sym_decltype] = ACTIONS(4561),
    [anon_sym_final] = ACTIONS(4561),
    [anon_sym_override] = ACTIONS(4561),
    [anon_sym_GT2] = ACTIONS(4561),
  },
  [1802] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4557),
    [anon_sym_COMMA] = ACTIONS(4557),
    [anon_sym_LPAREN2] = ACTIONS(4557),
    [anon_sym_DASH] = ACTIONS(4555),
    [anon_sym_PLUS] = ACTIONS(4555),
    [anon_sym_STAR] = ACTIONS(4555),
    [anon_sym_SLASH] = ACTIONS(4555),
    [anon_sym_PERCENT] = ACTIONS(4555),
    [anon_sym_PIPE_PIPE] = ACTIONS(4557),
    [anon_sym_AMP_AMP] = ACTIONS(4557),
    [anon_sym_PIPE] = ACTIONS(4555),
    [anon_sym_CARET] = ACTIONS(4555),
    [anon_sym_AMP] = ACTIONS(4555),
    [anon_sym_EQ_EQ] = ACTIONS(4557),
    [anon_sym_BANG_EQ] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4555),
    [anon_sym_GT_EQ] = ACTIONS(4555),
    [anon_sym_LT_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4555),
    [anon_sym_LT_LT] = ACTIONS(4555),
    [anon_sym_GT_GT] = ACTIONS(4555),
    [anon_sym___extension__] = ACTIONS(4557),
    [anon_sym___attribute__] = ACTIONS(4557),
    [anon_sym_COLON_COLON] = ACTIONS(4557),
    [anon_sym_LBRACE] = ACTIONS(4557),
    [anon_sym_LBRACK] = ACTIONS(4557),
    [anon_sym_EQ] = ACTIONS(4555),
    [anon_sym_const] = ACTIONS(4555),
    [anon_sym_constexpr] = ACTIONS(4557),
    [anon_sym_volatile] = ACTIONS(4557),
    [anon_sym_restrict] = ACTIONS(4557),
    [anon_sym___restrict__] = ACTIONS(4557),
    [anon_sym__Atomic] = ACTIONS(4557),
    [anon_sym__Noreturn] = ACTIONS(4557),
    [anon_sym_noreturn] = ACTIONS(4557),
    [anon_sym_mutable] = ACTIONS(4557),
    [anon_sym_constinit] = ACTIONS(4557),
    [anon_sym_consteval] = ACTIONS(4557),
    [anon_sym_PROGMEM] = ACTIONS(4557),
    [anon_sym_COLON] = ACTIONS(4555),
    [anon_sym_QMARK] = ACTIONS(4557),
    [anon_sym_STAR_EQ] = ACTIONS(4557),
    [anon_sym_SLASH_EQ] = ACTIONS(4557),
    [anon_sym_PERCENT_EQ] = ACTIONS(4557),
    [anon_sym_PLUS_EQ] = ACTIONS(4557),
    [anon_sym_DASH_EQ] = ACTIONS(4557),
    [anon_sym_LT_LT_EQ] = ACTIONS(4557),
    [anon_sym_GT_GT_EQ] = ACTIONS(4555),
    [anon_sym_AMP_EQ] = ACTIONS(4557),
    [anon_sym_CARET_EQ] = ACTIONS(4557),
    [anon_sym_PIPE_EQ] = ACTIONS(4557),
    [anon_sym_and_eq] = ACTIONS(4557),
    [anon_sym_or_eq] = ACTIONS(4557),
    [anon_sym_xor_eq] = ACTIONS(4557),
    [anon_sym_LT_EQ_GT] = ACTIONS(4557),
    [anon_sym_or] = ACTIONS(4555),
    [anon_sym_and] = ACTIONS(4555),
    [anon_sym_bitor] = ACTIONS(4557),
    [anon_sym_xor] = ACTIONS(4555),
    [anon_sym_bitand] = ACTIONS(4557),
    [anon_sym_not_eq] = ACTIONS(4557),
    [anon_sym_DASH_DASH] = ACTIONS(4557),
    [anon_sym_PLUS_PLUS] = ACTIONS(4557),
    [anon_sym_DOT] = ACTIONS(4555),
    [anon_sym_DOT_STAR] = ACTIONS(4557),
    [anon_sym_DASH_GT] = ACTIONS(4557),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4557),
    [anon_sym_decltype] = ACTIONS(4557),
    [anon_sym_final] = ACTIONS(4557),
    [anon_sym_override] = ACTIONS(4557),
    [anon_sym_GT2] = ACTIONS(4557),
  },
  [1803] = {
    [sym_identifier] = ACTIONS(4829),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4831),
    [anon_sym_COMMA] = ACTIONS(4831),
    [anon_sym_RPAREN] = ACTIONS(4831),
    [aux_sym_preproc_if_token2] = ACTIONS(4831),
    [aux_sym_preproc_else_token1] = ACTIONS(4831),
    [aux_sym_preproc_elif_token1] = ACTIONS(4829),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4831),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4831),
    [anon_sym_LPAREN2] = ACTIONS(4831),
    [anon_sym_DASH] = ACTIONS(4829),
    [anon_sym_PLUS] = ACTIONS(4829),
    [anon_sym_STAR] = ACTIONS(4829),
    [anon_sym_SLASH] = ACTIONS(4829),
    [anon_sym_PERCENT] = ACTIONS(4829),
    [anon_sym_PIPE_PIPE] = ACTIONS(4831),
    [anon_sym_AMP_AMP] = ACTIONS(4831),
    [anon_sym_PIPE] = ACTIONS(4829),
    [anon_sym_CARET] = ACTIONS(4829),
    [anon_sym_AMP] = ACTIONS(4829),
    [anon_sym_EQ_EQ] = ACTIONS(4831),
    [anon_sym_BANG_EQ] = ACTIONS(4831),
    [anon_sym_GT] = ACTIONS(4829),
    [anon_sym_GT_EQ] = ACTIONS(4831),
    [anon_sym_LT_EQ] = ACTIONS(4829),
    [anon_sym_LT] = ACTIONS(4829),
    [anon_sym_LT_LT] = ACTIONS(4829),
    [anon_sym_GT_GT] = ACTIONS(4829),
    [anon_sym_SEMI] = ACTIONS(4831),
    [anon_sym_RBRACE] = ACTIONS(4831),
    [anon_sym_LBRACK] = ACTIONS(4831),
    [anon_sym_RBRACK] = ACTIONS(4831),
    [anon_sym_EQ] = ACTIONS(4829),
    [anon_sym_COLON] = ACTIONS(4831),
    [anon_sym_QMARK] = ACTIONS(4831),
    [anon_sym_STAR_EQ] = ACTIONS(4831),
    [anon_sym_SLASH_EQ] = ACTIONS(4831),
    [anon_sym_PERCENT_EQ] = ACTIONS(4831),
    [anon_sym_PLUS_EQ] = ACTIONS(4831),
    [anon_sym_DASH_EQ] = ACTIONS(4831),
    [anon_sym_LT_LT_EQ] = ACTIONS(4831),
    [anon_sym_GT_GT_EQ] = ACTIONS(4831),
    [anon_sym_AMP_EQ] = ACTIONS(4831),
    [anon_sym_CARET_EQ] = ACTIONS(4831),
    [anon_sym_PIPE_EQ] = ACTIONS(4831),
    [anon_sym_and_eq] = ACTIONS(4829),
    [anon_sym_or_eq] = ACTIONS(4829),
    [anon_sym_xor_eq] = ACTIONS(4829),
    [anon_sym_LT_EQ_GT] = ACTIONS(4831),
    [anon_sym_or] = ACTIONS(4829),
    [anon_sym_and] = ACTIONS(4829),
    [anon_sym_bitor] = ACTIONS(4829),
    [anon_sym_xor] = ACTIONS(4829),
    [anon_sym_bitand] = ACTIONS(4829),
    [anon_sym_not_eq] = ACTIONS(4829),
    [anon_sym_DASH_DASH] = ACTIONS(4831),
    [anon_sym_PLUS_PLUS] = ACTIONS(4831),
    [anon_sym_DOT] = ACTIONS(4829),
    [anon_sym_DOT_STAR] = ACTIONS(4831),
    [anon_sym_DASH_GT] = ACTIONS(4831),
    [anon_sym_L_DQUOTE] = ACTIONS(4831),
    [anon_sym_u_DQUOTE] = ACTIONS(4831),
    [anon_sym_U_DQUOTE] = ACTIONS(4831),
    [anon_sym_u8_DQUOTE] = ACTIONS(4831),
    [anon_sym_DQUOTE] = ACTIONS(4831),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4831),
    [anon_sym_LR_DQUOTE] = ACTIONS(4831),
    [anon_sym_uR_DQUOTE] = ACTIONS(4831),
    [anon_sym_UR_DQUOTE] = ACTIONS(4831),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4831),
    [sym_literal_suffix] = ACTIONS(4829),
  },
  [1804] = {
    [sym_identifier] = ACTIONS(4833),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4835),
    [anon_sym_COMMA] = ACTIONS(4835),
    [anon_sym_RPAREN] = ACTIONS(4835),
    [aux_sym_preproc_if_token2] = ACTIONS(4835),
    [aux_sym_preproc_else_token1] = ACTIONS(4835),
    [aux_sym_preproc_elif_token1] = ACTIONS(4833),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4835),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4835),
    [anon_sym_LPAREN2] = ACTIONS(4835),
    [anon_sym_DASH] = ACTIONS(4833),
    [anon_sym_PLUS] = ACTIONS(4833),
    [anon_sym_STAR] = ACTIONS(4833),
    [anon_sym_SLASH] = ACTIONS(4833),
    [anon_sym_PERCENT] = ACTIONS(4833),
    [anon_sym_PIPE_PIPE] = ACTIONS(4835),
    [anon_sym_AMP_AMP] = ACTIONS(4835),
    [anon_sym_PIPE] = ACTIONS(4833),
    [anon_sym_CARET] = ACTIONS(4833),
    [anon_sym_AMP] = ACTIONS(4833),
    [anon_sym_EQ_EQ] = ACTIONS(4835),
    [anon_sym_BANG_EQ] = ACTIONS(4835),
    [anon_sym_GT] = ACTIONS(4833),
    [anon_sym_GT_EQ] = ACTIONS(4835),
    [anon_sym_LT_EQ] = ACTIONS(4833),
    [anon_sym_LT] = ACTIONS(4833),
    [anon_sym_LT_LT] = ACTIONS(4833),
    [anon_sym_GT_GT] = ACTIONS(4833),
    [anon_sym_SEMI] = ACTIONS(4835),
    [anon_sym_RBRACE] = ACTIONS(4835),
    [anon_sym_LBRACK] = ACTIONS(4835),
    [anon_sym_RBRACK] = ACTIONS(4835),
    [anon_sym_EQ] = ACTIONS(4833),
    [anon_sym_COLON] = ACTIONS(4835),
    [anon_sym_QMARK] = ACTIONS(4835),
    [anon_sym_STAR_EQ] = ACTIONS(4835),
    [anon_sym_SLASH_EQ] = ACTIONS(4835),
    [anon_sym_PERCENT_EQ] = ACTIONS(4835),
    [anon_sym_PLUS_EQ] = ACTIONS(4835),
    [anon_sym_DASH_EQ] = ACTIONS(4835),
    [anon_sym_LT_LT_EQ] = ACTIONS(4835),
    [anon_sym_GT_GT_EQ] = ACTIONS(4835),
    [anon_sym_AMP_EQ] = ACTIONS(4835),
    [anon_sym_CARET_EQ] = ACTIONS(4835),
    [anon_sym_PIPE_EQ] = ACTIONS(4835),
    [anon_sym_and_eq] = ACTIONS(4833),
    [anon_sym_or_eq] = ACTIONS(4833),
    [anon_sym_xor_eq] = ACTIONS(4833),
    [anon_sym_LT_EQ_GT] = ACTIONS(4835),
    [anon_sym_or] = ACTIONS(4833),
    [anon_sym_and] = ACTIONS(4833),
    [anon_sym_bitor] = ACTIONS(4833),
    [anon_sym_xor] = ACTIONS(4833),
    [anon_sym_bitand] = ACTIONS(4833),
    [anon_sym_not_eq] = ACTIONS(4833),
    [anon_sym_DASH_DASH] = ACTIONS(4835),
    [anon_sym_PLUS_PLUS] = ACTIONS(4835),
    [anon_sym_DOT] = ACTIONS(4833),
    [anon_sym_DOT_STAR] = ACTIONS(4835),
    [anon_sym_DASH_GT] = ACTIONS(4835),
    [anon_sym_L_DQUOTE] = ACTIONS(4835),
    [anon_sym_u_DQUOTE] = ACTIONS(4835),
    [anon_sym_U_DQUOTE] = ACTIONS(4835),
    [anon_sym_u8_DQUOTE] = ACTIONS(4835),
    [anon_sym_DQUOTE] = ACTIONS(4835),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4835),
    [anon_sym_LR_DQUOTE] = ACTIONS(4835),
    [anon_sym_uR_DQUOTE] = ACTIONS(4835),
    [anon_sym_UR_DQUOTE] = ACTIONS(4835),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4835),
    [sym_literal_suffix] = ACTIONS(4833),
  },
  [1805] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4553),
    [anon_sym_COMMA] = ACTIONS(4553),
    [anon_sym_LPAREN2] = ACTIONS(4553),
    [anon_sym_DASH] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(4551),
    [anon_sym_STAR] = ACTIONS(4551),
    [anon_sym_SLASH] = ACTIONS(4551),
    [anon_sym_PERCENT] = ACTIONS(4551),
    [anon_sym_PIPE_PIPE] = ACTIONS(4553),
    [anon_sym_AMP_AMP] = ACTIONS(4553),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4551),
    [anon_sym_AMP] = ACTIONS(4551),
    [anon_sym_EQ_EQ] = ACTIONS(4553),
    [anon_sym_BANG_EQ] = ACTIONS(4553),
    [anon_sym_GT] = ACTIONS(4551),
    [anon_sym_GT_EQ] = ACTIONS(4551),
    [anon_sym_LT_EQ] = ACTIONS(4551),
    [anon_sym_LT] = ACTIONS(4551),
    [anon_sym_LT_LT] = ACTIONS(4551),
    [anon_sym_GT_GT] = ACTIONS(4551),
    [anon_sym___extension__] = ACTIONS(4553),
    [anon_sym___attribute__] = ACTIONS(4553),
    [anon_sym_COLON_COLON] = ACTIONS(4553),
    [anon_sym_LBRACE] = ACTIONS(4553),
    [anon_sym_LBRACK] = ACTIONS(4553),
    [anon_sym_EQ] = ACTIONS(4551),
    [anon_sym_const] = ACTIONS(4551),
    [anon_sym_constexpr] = ACTIONS(4553),
    [anon_sym_volatile] = ACTIONS(4553),
    [anon_sym_restrict] = ACTIONS(4553),
    [anon_sym___restrict__] = ACTIONS(4553),
    [anon_sym__Atomic] = ACTIONS(4553),
    [anon_sym__Noreturn] = ACTIONS(4553),
    [anon_sym_noreturn] = ACTIONS(4553),
    [anon_sym_mutable] = ACTIONS(4553),
    [anon_sym_constinit] = ACTIONS(4553),
    [anon_sym_consteval] = ACTIONS(4553),
    [anon_sym_PROGMEM] = ACTIONS(4553),
    [anon_sym_COLON] = ACTIONS(4551),
    [anon_sym_QMARK] = ACTIONS(4553),
    [anon_sym_STAR_EQ] = ACTIONS(4553),
    [anon_sym_SLASH_EQ] = ACTIONS(4553),
    [anon_sym_PERCENT_EQ] = ACTIONS(4553),
    [anon_sym_PLUS_EQ] = ACTIONS(4553),
    [anon_sym_DASH_EQ] = ACTIONS(4553),
    [anon_sym_LT_LT_EQ] = ACTIONS(4553),
    [anon_sym_GT_GT_EQ] = ACTIONS(4551),
    [anon_sym_AMP_EQ] = ACTIONS(4553),
    [anon_sym_CARET_EQ] = ACTIONS(4553),
    [anon_sym_PIPE_EQ] = ACTIONS(4553),
    [anon_sym_and_eq] = ACTIONS(4553),
    [anon_sym_or_eq] = ACTIONS(4553),
    [anon_sym_xor_eq] = ACTIONS(4553),
    [anon_sym_LT_EQ_GT] = ACTIONS(4553),
    [anon_sym_or] = ACTIONS(4551),
    [anon_sym_and] = ACTIONS(4551),
    [anon_sym_bitor] = ACTIONS(4553),
    [anon_sym_xor] = ACTIONS(4551),
    [anon_sym_bitand] = ACTIONS(4553),
    [anon_sym_not_eq] = ACTIONS(4553),
    [anon_sym_DASH_DASH] = ACTIONS(4553),
    [anon_sym_PLUS_PLUS] = ACTIONS(4553),
    [anon_sym_DOT] = ACTIONS(4551),
    [anon_sym_DOT_STAR] = ACTIONS(4553),
    [anon_sym_DASH_GT] = ACTIONS(4553),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4553),
    [anon_sym_decltype] = ACTIONS(4553),
    [anon_sym_final] = ACTIONS(4553),
    [anon_sym_override] = ACTIONS(4553),
    [anon_sym_GT2] = ACTIONS(4553),
  },
  [1806] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4532),
    [anon_sym_COMMA] = ACTIONS(4532),
    [anon_sym_LPAREN2] = ACTIONS(4532),
    [anon_sym_DASH] = ACTIONS(4530),
    [anon_sym_PLUS] = ACTIONS(4530),
    [anon_sym_STAR] = ACTIONS(4530),
    [anon_sym_SLASH] = ACTIONS(4530),
    [anon_sym_PERCENT] = ACTIONS(4530),
    [anon_sym_PIPE_PIPE] = ACTIONS(4532),
    [anon_sym_AMP_AMP] = ACTIONS(4532),
    [anon_sym_PIPE] = ACTIONS(4530),
    [anon_sym_CARET] = ACTIONS(4530),
    [anon_sym_AMP] = ACTIONS(4530),
    [anon_sym_EQ_EQ] = ACTIONS(4532),
    [anon_sym_BANG_EQ] = ACTIONS(4532),
    [anon_sym_GT] = ACTIONS(4530),
    [anon_sym_GT_EQ] = ACTIONS(4530),
    [anon_sym_LT_EQ] = ACTIONS(4530),
    [anon_sym_LT] = ACTIONS(4530),
    [anon_sym_LT_LT] = ACTIONS(4530),
    [anon_sym_GT_GT] = ACTIONS(4530),
    [anon_sym___extension__] = ACTIONS(4532),
    [anon_sym___attribute__] = ACTIONS(4532),
    [anon_sym_COLON_COLON] = ACTIONS(4532),
    [anon_sym_LBRACE] = ACTIONS(4532),
    [anon_sym_LBRACK] = ACTIONS(4532),
    [anon_sym_EQ] = ACTIONS(4530),
    [anon_sym_const] = ACTIONS(4530),
    [anon_sym_constexpr] = ACTIONS(4532),
    [anon_sym_volatile] = ACTIONS(4532),
    [anon_sym_restrict] = ACTIONS(4532),
    [anon_sym___restrict__] = ACTIONS(4532),
    [anon_sym__Atomic] = ACTIONS(4532),
    [anon_sym__Noreturn] = ACTIONS(4532),
    [anon_sym_noreturn] = ACTIONS(4532),
    [anon_sym_mutable] = ACTIONS(4532),
    [anon_sym_constinit] = ACTIONS(4532),
    [anon_sym_consteval] = ACTIONS(4532),
    [anon_sym_PROGMEM] = ACTIONS(4532),
    [anon_sym_COLON] = ACTIONS(4530),
    [anon_sym_QMARK] = ACTIONS(4532),
    [anon_sym_STAR_EQ] = ACTIONS(4532),
    [anon_sym_SLASH_EQ] = ACTIONS(4532),
    [anon_sym_PERCENT_EQ] = ACTIONS(4532),
    [anon_sym_PLUS_EQ] = ACTIONS(4532),
    [anon_sym_DASH_EQ] = ACTIONS(4532),
    [anon_sym_LT_LT_EQ] = ACTIONS(4532),
    [anon_sym_GT_GT_EQ] = ACTIONS(4530),
    [anon_sym_AMP_EQ] = ACTIONS(4532),
    [anon_sym_CARET_EQ] = ACTIONS(4532),
    [anon_sym_PIPE_EQ] = ACTIONS(4532),
    [anon_sym_and_eq] = ACTIONS(4532),
    [anon_sym_or_eq] = ACTIONS(4532),
    [anon_sym_xor_eq] = ACTIONS(4532),
    [anon_sym_LT_EQ_GT] = ACTIONS(4532),
    [anon_sym_or] = ACTIONS(4530),
    [anon_sym_and] = ACTIONS(4530),
    [anon_sym_bitor] = ACTIONS(4532),
    [anon_sym_xor] = ACTIONS(4530),
    [anon_sym_bitand] = ACTIONS(4532),
    [anon_sym_not_eq] = ACTIONS(4532),
    [anon_sym_DASH_DASH] = ACTIONS(4532),
    [anon_sym_PLUS_PLUS] = ACTIONS(4532),
    [anon_sym_DOT] = ACTIONS(4530),
    [anon_sym_DOT_STAR] = ACTIONS(4532),
    [anon_sym_DASH_GT] = ACTIONS(4532),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4532),
    [anon_sym_decltype] = ACTIONS(4532),
    [anon_sym_final] = ACTIONS(4532),
    [anon_sym_override] = ACTIONS(4532),
    [anon_sym_GT2] = ACTIONS(4532),
  },
  [1807] = {
    [sym_identifier] = ACTIONS(2985),
    [aux_sym_preproc_def_token1] = ACTIONS(2985),
    [aux_sym_preproc_if_token1] = ACTIONS(2985),
    [aux_sym_preproc_if_token2] = ACTIONS(2985),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2985),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2985),
    [aux_sym_preproc_else_token1] = ACTIONS(2985),
    [aux_sym_preproc_elif_token1] = ACTIONS(2985),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2985),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2985),
    [sym_preproc_directive] = ACTIONS(2985),
    [anon_sym_LPAREN2] = ACTIONS(2987),
    [anon_sym_TILDE] = ACTIONS(2987),
    [anon_sym_STAR] = ACTIONS(2987),
    [anon_sym_AMP_AMP] = ACTIONS(2987),
    [anon_sym_AMP] = ACTIONS(2985),
    [anon_sym_SEMI] = ACTIONS(4837),
    [anon_sym___extension__] = ACTIONS(2985),
    [anon_sym_typedef] = ACTIONS(2985),
    [anon_sym_extern] = ACTIONS(2985),
    [anon_sym___attribute__] = ACTIONS(2985),
    [anon_sym_COLON_COLON] = ACTIONS(2987),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2987),
    [anon_sym___declspec] = ACTIONS(2985),
    [anon_sym___based] = ACTIONS(2985),
    [anon_sym_signed] = ACTIONS(2985),
    [anon_sym_unsigned] = ACTIONS(2985),
    [anon_sym_long] = ACTIONS(2985),
    [anon_sym_short] = ACTIONS(2985),
    [anon_sym_LBRACK] = ACTIONS(2985),
    [anon_sym_static] = ACTIONS(2985),
    [anon_sym_register] = ACTIONS(2985),
    [anon_sym_inline] = ACTIONS(2985),
    [anon_sym___inline] = ACTIONS(2985),
    [anon_sym___inline__] = ACTIONS(2985),
    [anon_sym___forceinline] = ACTIONS(2985),
    [anon_sym_thread_local] = ACTIONS(2985),
    [anon_sym___thread] = ACTIONS(2985),
    [anon_sym_const] = ACTIONS(2985),
    [anon_sym_constexpr] = ACTIONS(2985),
    [anon_sym_volatile] = ACTIONS(2985),
    [anon_sym_restrict] = ACTIONS(2985),
    [anon_sym___restrict__] = ACTIONS(2985),
    [anon_sym__Atomic] = ACTIONS(2985),
    [anon_sym__Noreturn] = ACTIONS(2985),
    [anon_sym_noreturn] = ACTIONS(2985),
    [anon_sym_mutable] = ACTIONS(2985),
    [anon_sym_constinit] = ACTIONS(2985),
    [anon_sym_consteval] = ACTIONS(2985),
    [anon_sym_PROGMEM] = ACTIONS(2985),
    [aux_sym_primitive_type_token1] = ACTIONS(2985),
    [anon_sym_byte] = ACTIONS(2985),
    [anon_sym_word] = ACTIONS(2985),
    [anon_sym_enum] = ACTIONS(2985),
    [anon_sym_class] = ACTIONS(2985),
    [anon_sym_struct] = ACTIONS(2985),
    [anon_sym_union] = ACTIONS(2985),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2985),
    [anon_sym_decltype] = ACTIONS(2985),
    [anon_sym_virtual] = ACTIONS(2985),
    [anon_sym_alignas] = ACTIONS(2985),
    [anon_sym_explicit] = ACTIONS(2985),
    [anon_sym_typename] = ACTIONS(2985),
    [anon_sym_template] = ACTIONS(2985),
    [anon_sym_operator] = ACTIONS(2985),
    [anon_sym_friend] = ACTIONS(2985),
    [anon_sym_public] = ACTIONS(2985),
    [anon_sym_private] = ACTIONS(2985),
    [anon_sym_protected] = ACTIONS(2985),
    [anon_sym_using] = ACTIONS(2985),
    [anon_sym_static_assert] = ACTIONS(2985),
  },
  [1808] = {
    [sym_identifier] = ACTIONS(3122),
    [aux_sym_preproc_def_token1] = ACTIONS(3122),
    [aux_sym_preproc_if_token1] = ACTIONS(3122),
    [aux_sym_preproc_if_token2] = ACTIONS(3122),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3122),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3122),
    [aux_sym_preproc_else_token1] = ACTIONS(3122),
    [aux_sym_preproc_elif_token1] = ACTIONS(3122),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3122),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3122),
    [sym_preproc_directive] = ACTIONS(3122),
    [anon_sym_LPAREN2] = ACTIONS(3124),
    [anon_sym_TILDE] = ACTIONS(3124),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP_AMP] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3122),
    [anon_sym_SEMI] = ACTIONS(4839),
    [anon_sym___extension__] = ACTIONS(3122),
    [anon_sym_typedef] = ACTIONS(3122),
    [anon_sym_extern] = ACTIONS(3122),
    [anon_sym___attribute__] = ACTIONS(3122),
    [anon_sym_COLON_COLON] = ACTIONS(3124),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3124),
    [anon_sym___declspec] = ACTIONS(3122),
    [anon_sym___based] = ACTIONS(3122),
    [anon_sym_signed] = ACTIONS(3122),
    [anon_sym_unsigned] = ACTIONS(3122),
    [anon_sym_long] = ACTIONS(3122),
    [anon_sym_short] = ACTIONS(3122),
    [anon_sym_LBRACK] = ACTIONS(3122),
    [anon_sym_static] = ACTIONS(3122),
    [anon_sym_register] = ACTIONS(3122),
    [anon_sym_inline] = ACTIONS(3122),
    [anon_sym___inline] = ACTIONS(3122),
    [anon_sym___inline__] = ACTIONS(3122),
    [anon_sym___forceinline] = ACTIONS(3122),
    [anon_sym_thread_local] = ACTIONS(3122),
    [anon_sym___thread] = ACTIONS(3122),
    [anon_sym_const] = ACTIONS(3122),
    [anon_sym_constexpr] = ACTIONS(3122),
    [anon_sym_volatile] = ACTIONS(3122),
    [anon_sym_restrict] = ACTIONS(3122),
    [anon_sym___restrict__] = ACTIONS(3122),
    [anon_sym__Atomic] = ACTIONS(3122),
    [anon_sym__Noreturn] = ACTIONS(3122),
    [anon_sym_noreturn] = ACTIONS(3122),
    [anon_sym_mutable] = ACTIONS(3122),
    [anon_sym_constinit] = ACTIONS(3122),
    [anon_sym_consteval] = ACTIONS(3122),
    [anon_sym_PROGMEM] = ACTIONS(3122),
    [aux_sym_primitive_type_token1] = ACTIONS(3122),
    [anon_sym_byte] = ACTIONS(3122),
    [anon_sym_word] = ACTIONS(3122),
    [anon_sym_enum] = ACTIONS(3122),
    [anon_sym_class] = ACTIONS(3122),
    [anon_sym_struct] = ACTIONS(3122),
    [anon_sym_union] = ACTIONS(3122),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3122),
    [anon_sym_decltype] = ACTIONS(3122),
    [anon_sym_virtual] = ACTIONS(3122),
    [anon_sym_alignas] = ACTIONS(3122),
    [anon_sym_explicit] = ACTIONS(3122),
    [anon_sym_typename] = ACTIONS(3122),
    [anon_sym_template] = ACTIONS(3122),
    [anon_sym_operator] = ACTIONS(3122),
    [anon_sym_friend] = ACTIONS(3122),
    [anon_sym_public] = ACTIONS(3122),
    [anon_sym_private] = ACTIONS(3122),
    [anon_sym_protected] = ACTIONS(3122),
    [anon_sym_using] = ACTIONS(3122),
    [anon_sym_static_assert] = ACTIONS(3122),
  },
  [1809] = {
    [sym_identifier] = ACTIONS(3024),
    [aux_sym_preproc_def_token1] = ACTIONS(3024),
    [aux_sym_preproc_if_token1] = ACTIONS(3024),
    [aux_sym_preproc_if_token2] = ACTIONS(3024),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3024),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3024),
    [aux_sym_preproc_else_token1] = ACTIONS(3024),
    [aux_sym_preproc_elif_token1] = ACTIONS(3024),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3024),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3024),
    [sym_preproc_directive] = ACTIONS(3024),
    [anon_sym_LPAREN2] = ACTIONS(3026),
    [anon_sym_TILDE] = ACTIONS(3026),
    [anon_sym_STAR] = ACTIONS(3026),
    [anon_sym_AMP_AMP] = ACTIONS(3026),
    [anon_sym_AMP] = ACTIONS(3024),
    [anon_sym___extension__] = ACTIONS(3024),
    [anon_sym_typedef] = ACTIONS(3024),
    [anon_sym_extern] = ACTIONS(3024),
    [anon_sym___attribute__] = ACTIONS(3024),
    [anon_sym_COLON_COLON] = ACTIONS(3026),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3026),
    [anon_sym___declspec] = ACTIONS(3024),
    [anon_sym___based] = ACTIONS(3024),
    [anon_sym_signed] = ACTIONS(3024),
    [anon_sym_unsigned] = ACTIONS(3024),
    [anon_sym_long] = ACTIONS(3024),
    [anon_sym_short] = ACTIONS(3024),
    [anon_sym_LBRACK] = ACTIONS(3024),
    [anon_sym_static] = ACTIONS(3024),
    [anon_sym_register] = ACTIONS(3024),
    [anon_sym_inline] = ACTIONS(3024),
    [anon_sym___inline] = ACTIONS(3024),
    [anon_sym___inline__] = ACTIONS(3024),
    [anon_sym___forceinline] = ACTIONS(3024),
    [anon_sym_thread_local] = ACTIONS(3024),
    [anon_sym___thread] = ACTIONS(3024),
    [anon_sym_const] = ACTIONS(3024),
    [anon_sym_constexpr] = ACTIONS(3024),
    [anon_sym_volatile] = ACTIONS(3024),
    [anon_sym_restrict] = ACTIONS(3024),
    [anon_sym___restrict__] = ACTIONS(3024),
    [anon_sym__Atomic] = ACTIONS(3024),
    [anon_sym__Noreturn] = ACTIONS(3024),
    [anon_sym_noreturn] = ACTIONS(3024),
    [anon_sym_mutable] = ACTIONS(3024),
    [anon_sym_constinit] = ACTIONS(3024),
    [anon_sym_consteval] = ACTIONS(3024),
    [anon_sym_PROGMEM] = ACTIONS(3024),
    [aux_sym_primitive_type_token1] = ACTIONS(3024),
    [anon_sym_byte] = ACTIONS(3024),
    [anon_sym_word] = ACTIONS(3024),
    [anon_sym_enum] = ACTIONS(3024),
    [anon_sym_class] = ACTIONS(3024),
    [anon_sym_struct] = ACTIONS(3024),
    [anon_sym_union] = ACTIONS(3024),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3024),
    [anon_sym_decltype] = ACTIONS(3024),
    [anon_sym_virtual] = ACTIONS(3024),
    [anon_sym_alignas] = ACTIONS(3024),
    [anon_sym_explicit] = ACTIONS(3024),
    [anon_sym_typename] = ACTIONS(3024),
    [anon_sym_template] = ACTIONS(3024),
    [anon_sym_operator] = ACTIONS(3024),
    [anon_sym_friend] = ACTIONS(3024),
    [anon_sym_public] = ACTIONS(3024),
    [anon_sym_private] = ACTIONS(3024),
    [anon_sym_protected] = ACTIONS(3024),
    [anon_sym_using] = ACTIONS(3024),
    [anon_sym_static_assert] = ACTIONS(3024),
  },
  [1810] = {
    [sym_identifier] = ACTIONS(2877),
    [aux_sym_preproc_def_token1] = ACTIONS(2877),
    [aux_sym_preproc_if_token1] = ACTIONS(2877),
    [aux_sym_preproc_if_token2] = ACTIONS(2877),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2877),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2877),
    [aux_sym_preproc_else_token1] = ACTIONS(2877),
    [aux_sym_preproc_elif_token1] = ACTIONS(2877),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2877),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2877),
    [sym_preproc_directive] = ACTIONS(2877),
    [anon_sym_LPAREN2] = ACTIONS(2879),
    [anon_sym_TILDE] = ACTIONS(2879),
    [anon_sym_STAR] = ACTIONS(2879),
    [anon_sym_AMP_AMP] = ACTIONS(2879),
    [anon_sym_AMP] = ACTIONS(2877),
    [anon_sym___extension__] = ACTIONS(2877),
    [anon_sym_typedef] = ACTIONS(2877),
    [anon_sym_extern] = ACTIONS(2877),
    [anon_sym___attribute__] = ACTIONS(2877),
    [anon_sym_COLON_COLON] = ACTIONS(2879),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2879),
    [anon_sym___declspec] = ACTIONS(2877),
    [anon_sym___based] = ACTIONS(2877),
    [anon_sym_signed] = ACTIONS(2877),
    [anon_sym_unsigned] = ACTIONS(2877),
    [anon_sym_long] = ACTIONS(2877),
    [anon_sym_short] = ACTIONS(2877),
    [anon_sym_LBRACK] = ACTIONS(2877),
    [anon_sym_static] = ACTIONS(2877),
    [anon_sym_register] = ACTIONS(2877),
    [anon_sym_inline] = ACTIONS(2877),
    [anon_sym___inline] = ACTIONS(2877),
    [anon_sym___inline__] = ACTIONS(2877),
    [anon_sym___forceinline] = ACTIONS(2877),
    [anon_sym_thread_local] = ACTIONS(2877),
    [anon_sym___thread] = ACTIONS(2877),
    [anon_sym_const] = ACTIONS(2877),
    [anon_sym_constexpr] = ACTIONS(2877),
    [anon_sym_volatile] = ACTIONS(2877),
    [anon_sym_restrict] = ACTIONS(2877),
    [anon_sym___restrict__] = ACTIONS(2877),
    [anon_sym__Atomic] = ACTIONS(2877),
    [anon_sym__Noreturn] = ACTIONS(2877),
    [anon_sym_noreturn] = ACTIONS(2877),
    [anon_sym_mutable] = ACTIONS(2877),
    [anon_sym_constinit] = ACTIONS(2877),
    [anon_sym_consteval] = ACTIONS(2877),
    [anon_sym_PROGMEM] = ACTIONS(2877),
    [aux_sym_primitive_type_token1] = ACTIONS(2877),
    [anon_sym_byte] = ACTIONS(2877),
    [anon_sym_word] = ACTIONS(2877),
    [anon_sym_enum] = ACTIONS(2877),
    [anon_sym_class] = ACTIONS(2877),
    [anon_sym_struct] = ACTIONS(2877),
    [anon_sym_union] = ACTIONS(2877),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2877),
    [anon_sym_decltype] = ACTIONS(2877),
    [anon_sym_virtual] = ACTIONS(2877),
    [anon_sym_alignas] = ACTIONS(2877),
    [anon_sym_explicit] = ACTIONS(2877),
    [anon_sym_typename] = ACTIONS(2877),
    [anon_sym_template] = ACTIONS(2877),
    [anon_sym_operator] = ACTIONS(2877),
    [anon_sym_friend] = ACTIONS(2877),
    [anon_sym_public] = ACTIONS(2877),
    [anon_sym_private] = ACTIONS(2877),
    [anon_sym_protected] = ACTIONS(2877),
    [anon_sym_using] = ACTIONS(2877),
    [anon_sym_static_assert] = ACTIONS(2877),
  },
  [1811] = {
    [sym__declaration_modifiers] = STATE(3458),
    [sym_attribute_specifier] = STATE(3458),
    [sym_attribute_declaration] = STATE(3458),
    [sym_ms_declspec_modifier] = STATE(3458),
    [sym_ms_based_modifier] = STATE(8318),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6018),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3458),
    [sym_type_qualifier] = STATE(3458),
    [sym_decltype] = STATE(8290),
    [sym_virtual] = STATE(3458),
    [sym_alignas_specifier] = STATE(3458),
    [sym_explicit_function_specifier] = STATE(3458),
    [sym_operator_cast] = STATE(6493),
    [sym__constructor_specifiers] = STATE(3458),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(8290),
    [sym_template_function] = STATE(6098),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5430),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_operator_cast_identifier] = STATE(6493),
    [sym_operator_name] = STATE(6098),
    [aux_sym_operator_cast_definition_repeat1] = STATE(3458),
    [sym_identifier] = ACTIONS(4841),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(4843),
    [anon_sym_extern] = ACTIONS(4845),
    [anon_sym___attribute__] = ACTIONS(4847),
    [anon_sym_COLON_COLON] = ACTIONS(4849),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4851),
    [anon_sym___declspec] = ACTIONS(4853),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(4845),
    [anon_sym_register] = ACTIONS(4845),
    [anon_sym_inline] = ACTIONS(4845),
    [anon_sym___inline] = ACTIONS(4845),
    [anon_sym___inline__] = ACTIONS(4845),
    [anon_sym___forceinline] = ACTIONS(4845),
    [anon_sym_thread_local] = ACTIONS(4845),
    [anon_sym___thread] = ACTIONS(4845),
    [anon_sym_const] = ACTIONS(4843),
    [anon_sym_constexpr] = ACTIONS(4843),
    [anon_sym_volatile] = ACTIONS(4843),
    [anon_sym_restrict] = ACTIONS(4843),
    [anon_sym___restrict__] = ACTIONS(4843),
    [anon_sym__Atomic] = ACTIONS(4843),
    [anon_sym__Noreturn] = ACTIONS(4843),
    [anon_sym_noreturn] = ACTIONS(4843),
    [anon_sym_mutable] = ACTIONS(4843),
    [anon_sym_constinit] = ACTIONS(4843),
    [anon_sym_consteval] = ACTIONS(4843),
    [anon_sym_PROGMEM] = ACTIONS(4843),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_virtual] = ACTIONS(4855),
    [anon_sym_alignas] = ACTIONS(4857),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_operator] = ACTIONS(133),
  },
  [1812] = {
    [sym_identifier] = ACTIONS(2723),
    [aux_sym_preproc_def_token1] = ACTIONS(2723),
    [aux_sym_preproc_if_token1] = ACTIONS(2723),
    [aux_sym_preproc_if_token2] = ACTIONS(2723),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2723),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2723),
    [aux_sym_preproc_else_token1] = ACTIONS(2723),
    [aux_sym_preproc_elif_token1] = ACTIONS(2723),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2723),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2723),
    [sym_preproc_directive] = ACTIONS(2723),
    [anon_sym_LPAREN2] = ACTIONS(2725),
    [anon_sym_TILDE] = ACTIONS(2725),
    [anon_sym_STAR] = ACTIONS(2725),
    [anon_sym_AMP_AMP] = ACTIONS(2725),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym___extension__] = ACTIONS(2723),
    [anon_sym_typedef] = ACTIONS(2723),
    [anon_sym_extern] = ACTIONS(2723),
    [anon_sym___attribute__] = ACTIONS(2723),
    [anon_sym_COLON_COLON] = ACTIONS(2725),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2725),
    [anon_sym___declspec] = ACTIONS(2723),
    [anon_sym___based] = ACTIONS(2723),
    [anon_sym_signed] = ACTIONS(2723),
    [anon_sym_unsigned] = ACTIONS(2723),
    [anon_sym_long] = ACTIONS(2723),
    [anon_sym_short] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_static] = ACTIONS(2723),
    [anon_sym_register] = ACTIONS(2723),
    [anon_sym_inline] = ACTIONS(2723),
    [anon_sym___inline] = ACTIONS(2723),
    [anon_sym___inline__] = ACTIONS(2723),
    [anon_sym___forceinline] = ACTIONS(2723),
    [anon_sym_thread_local] = ACTIONS(2723),
    [anon_sym___thread] = ACTIONS(2723),
    [anon_sym_const] = ACTIONS(2723),
    [anon_sym_constexpr] = ACTIONS(2723),
    [anon_sym_volatile] = ACTIONS(2723),
    [anon_sym_restrict] = ACTIONS(2723),
    [anon_sym___restrict__] = ACTIONS(2723),
    [anon_sym__Atomic] = ACTIONS(2723),
    [anon_sym__Noreturn] = ACTIONS(2723),
    [anon_sym_noreturn] = ACTIONS(2723),
    [anon_sym_mutable] = ACTIONS(2723),
    [anon_sym_constinit] = ACTIONS(2723),
    [anon_sym_consteval] = ACTIONS(2723),
    [anon_sym_PROGMEM] = ACTIONS(2723),
    [aux_sym_primitive_type_token1] = ACTIONS(2723),
    [anon_sym_byte] = ACTIONS(2723),
    [anon_sym_word] = ACTIONS(2723),
    [anon_sym_enum] = ACTIONS(2723),
    [anon_sym_class] = ACTIONS(2723),
    [anon_sym_struct] = ACTIONS(2723),
    [anon_sym_union] = ACTIONS(2723),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2723),
    [anon_sym_decltype] = ACTIONS(2723),
    [anon_sym_virtual] = ACTIONS(2723),
    [anon_sym_alignas] = ACTIONS(2723),
    [anon_sym_explicit] = ACTIONS(2723),
    [anon_sym_typename] = ACTIONS(2723),
    [anon_sym_template] = ACTIONS(2723),
    [anon_sym_operator] = ACTIONS(2723),
    [anon_sym_friend] = ACTIONS(2723),
    [anon_sym_public] = ACTIONS(2723),
    [anon_sym_private] = ACTIONS(2723),
    [anon_sym_protected] = ACTIONS(2723),
    [anon_sym_using] = ACTIONS(2723),
    [anon_sym_static_assert] = ACTIONS(2723),
  },
  [1813] = {
    [sym__declaration_modifiers] = STATE(3458),
    [sym_attribute_specifier] = STATE(3458),
    [sym_attribute_declaration] = STATE(3458),
    [sym_ms_declspec_modifier] = STATE(3458),
    [sym_ms_based_modifier] = STATE(8318),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(5976),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3458),
    [sym_type_qualifier] = STATE(3458),
    [sym_decltype] = STATE(8290),
    [sym_virtual] = STATE(3458),
    [sym_alignas_specifier] = STATE(3458),
    [sym_explicit_function_specifier] = STATE(3458),
    [sym_operator_cast] = STATE(6532),
    [sym__constructor_specifiers] = STATE(3458),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(8290),
    [sym_template_function] = STATE(6098),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5430),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_operator_cast_identifier] = STATE(6532),
    [sym_operator_name] = STATE(6098),
    [aux_sym_operator_cast_definition_repeat1] = STATE(3458),
    [sym_identifier] = ACTIONS(4841),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(4843),
    [anon_sym_extern] = ACTIONS(4845),
    [anon_sym___attribute__] = ACTIONS(4847),
    [anon_sym_COLON_COLON] = ACTIONS(4849),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4851),
    [anon_sym___declspec] = ACTIONS(4853),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(4845),
    [anon_sym_register] = ACTIONS(4845),
    [anon_sym_inline] = ACTIONS(4845),
    [anon_sym___inline] = ACTIONS(4845),
    [anon_sym___inline__] = ACTIONS(4845),
    [anon_sym___forceinline] = ACTIONS(4845),
    [anon_sym_thread_local] = ACTIONS(4845),
    [anon_sym___thread] = ACTIONS(4845),
    [anon_sym_const] = ACTIONS(4843),
    [anon_sym_constexpr] = ACTIONS(4843),
    [anon_sym_volatile] = ACTIONS(4843),
    [anon_sym_restrict] = ACTIONS(4843),
    [anon_sym___restrict__] = ACTIONS(4843),
    [anon_sym__Atomic] = ACTIONS(4843),
    [anon_sym__Noreturn] = ACTIONS(4843),
    [anon_sym_noreturn] = ACTIONS(4843),
    [anon_sym_mutable] = ACTIONS(4843),
    [anon_sym_constinit] = ACTIONS(4843),
    [anon_sym_consteval] = ACTIONS(4843),
    [anon_sym_PROGMEM] = ACTIONS(4843),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_virtual] = ACTIONS(4855),
    [anon_sym_alignas] = ACTIONS(4857),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_operator] = ACTIONS(133),
  },
  [1814] = {
    [sym_identifier] = ACTIONS(3008),
    [aux_sym_preproc_def_token1] = ACTIONS(3008),
    [aux_sym_preproc_if_token1] = ACTIONS(3008),
    [aux_sym_preproc_if_token2] = ACTIONS(3008),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3008),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3008),
    [aux_sym_preproc_else_token1] = ACTIONS(3008),
    [aux_sym_preproc_elif_token1] = ACTIONS(3008),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3008),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3008),
    [sym_preproc_directive] = ACTIONS(3008),
    [anon_sym_LPAREN2] = ACTIONS(3010),
    [anon_sym_TILDE] = ACTIONS(3010),
    [anon_sym_STAR] = ACTIONS(3010),
    [anon_sym_AMP_AMP] = ACTIONS(3010),
    [anon_sym_AMP] = ACTIONS(3008),
    [anon_sym___extension__] = ACTIONS(3008),
    [anon_sym_typedef] = ACTIONS(3008),
    [anon_sym_extern] = ACTIONS(3008),
    [anon_sym___attribute__] = ACTIONS(3008),
    [anon_sym_COLON_COLON] = ACTIONS(3010),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3010),
    [anon_sym___declspec] = ACTIONS(3008),
    [anon_sym___based] = ACTIONS(3008),
    [anon_sym_signed] = ACTIONS(3008),
    [anon_sym_unsigned] = ACTIONS(3008),
    [anon_sym_long] = ACTIONS(3008),
    [anon_sym_short] = ACTIONS(3008),
    [anon_sym_LBRACK] = ACTIONS(3008),
    [anon_sym_static] = ACTIONS(3008),
    [anon_sym_register] = ACTIONS(3008),
    [anon_sym_inline] = ACTIONS(3008),
    [anon_sym___inline] = ACTIONS(3008),
    [anon_sym___inline__] = ACTIONS(3008),
    [anon_sym___forceinline] = ACTIONS(3008),
    [anon_sym_thread_local] = ACTIONS(3008),
    [anon_sym___thread] = ACTIONS(3008),
    [anon_sym_const] = ACTIONS(3008),
    [anon_sym_constexpr] = ACTIONS(3008),
    [anon_sym_volatile] = ACTIONS(3008),
    [anon_sym_restrict] = ACTIONS(3008),
    [anon_sym___restrict__] = ACTIONS(3008),
    [anon_sym__Atomic] = ACTIONS(3008),
    [anon_sym__Noreturn] = ACTIONS(3008),
    [anon_sym_noreturn] = ACTIONS(3008),
    [anon_sym_mutable] = ACTIONS(3008),
    [anon_sym_constinit] = ACTIONS(3008),
    [anon_sym_consteval] = ACTIONS(3008),
    [anon_sym_PROGMEM] = ACTIONS(3008),
    [aux_sym_primitive_type_token1] = ACTIONS(3008),
    [anon_sym_byte] = ACTIONS(3008),
    [anon_sym_word] = ACTIONS(3008),
    [anon_sym_enum] = ACTIONS(3008),
    [anon_sym_class] = ACTIONS(3008),
    [anon_sym_struct] = ACTIONS(3008),
    [anon_sym_union] = ACTIONS(3008),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3008),
    [anon_sym_decltype] = ACTIONS(3008),
    [anon_sym_virtual] = ACTIONS(3008),
    [anon_sym_alignas] = ACTIONS(3008),
    [anon_sym_explicit] = ACTIONS(3008),
    [anon_sym_typename] = ACTIONS(3008),
    [anon_sym_template] = ACTIONS(3008),
    [anon_sym_operator] = ACTIONS(3008),
    [anon_sym_friend] = ACTIONS(3008),
    [anon_sym_public] = ACTIONS(3008),
    [anon_sym_private] = ACTIONS(3008),
    [anon_sym_protected] = ACTIONS(3008),
    [anon_sym_using] = ACTIONS(3008),
    [anon_sym_static_assert] = ACTIONS(3008),
  },
  [1815] = {
    [sym__declaration_modifiers] = STATE(3458),
    [sym_attribute_specifier] = STATE(3458),
    [sym_attribute_declaration] = STATE(3458),
    [sym_ms_declspec_modifier] = STATE(3458),
    [sym_ms_based_modifier] = STATE(8318),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6020),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3458),
    [sym_type_qualifier] = STATE(3458),
    [sym_decltype] = STATE(8290),
    [sym_virtual] = STATE(3458),
    [sym_alignas_specifier] = STATE(3458),
    [sym_explicit_function_specifier] = STATE(3458),
    [sym_operator_cast] = STATE(6508),
    [sym__constructor_specifiers] = STATE(3458),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(8290),
    [sym_template_function] = STATE(6098),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5430),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_operator_cast_identifier] = STATE(6508),
    [sym_operator_name] = STATE(6098),
    [aux_sym_operator_cast_definition_repeat1] = STATE(3458),
    [sym_identifier] = ACTIONS(4841),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(4843),
    [anon_sym_extern] = ACTIONS(4845),
    [anon_sym___attribute__] = ACTIONS(4847),
    [anon_sym_COLON_COLON] = ACTIONS(4849),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4851),
    [anon_sym___declspec] = ACTIONS(4853),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(4845),
    [anon_sym_register] = ACTIONS(4845),
    [anon_sym_inline] = ACTIONS(4845),
    [anon_sym___inline] = ACTIONS(4845),
    [anon_sym___inline__] = ACTIONS(4845),
    [anon_sym___forceinline] = ACTIONS(4845),
    [anon_sym_thread_local] = ACTIONS(4845),
    [anon_sym___thread] = ACTIONS(4845),
    [anon_sym_const] = ACTIONS(4843),
    [anon_sym_constexpr] = ACTIONS(4843),
    [anon_sym_volatile] = ACTIONS(4843),
    [anon_sym_restrict] = ACTIONS(4843),
    [anon_sym___restrict__] = ACTIONS(4843),
    [anon_sym__Atomic] = ACTIONS(4843),
    [anon_sym__Noreturn] = ACTIONS(4843),
    [anon_sym_noreturn] = ACTIONS(4843),
    [anon_sym_mutable] = ACTIONS(4843),
    [anon_sym_constinit] = ACTIONS(4843),
    [anon_sym_consteval] = ACTIONS(4843),
    [anon_sym_PROGMEM] = ACTIONS(4843),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_virtual] = ACTIONS(4855),
    [anon_sym_alignas] = ACTIONS(4857),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_operator] = ACTIONS(133),
  },
  [1816] = {
    [sym_identifier] = ACTIONS(3020),
    [aux_sym_preproc_def_token1] = ACTIONS(3020),
    [aux_sym_preproc_if_token1] = ACTIONS(3020),
    [aux_sym_preproc_if_token2] = ACTIONS(3020),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3020),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3020),
    [aux_sym_preproc_else_token1] = ACTIONS(3020),
    [aux_sym_preproc_elif_token1] = ACTIONS(3020),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3020),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3020),
    [sym_preproc_directive] = ACTIONS(3020),
    [anon_sym_LPAREN2] = ACTIONS(3022),
    [anon_sym_TILDE] = ACTIONS(3022),
    [anon_sym_STAR] = ACTIONS(3022),
    [anon_sym_AMP_AMP] = ACTIONS(3022),
    [anon_sym_AMP] = ACTIONS(3020),
    [anon_sym___extension__] = ACTIONS(3020),
    [anon_sym_typedef] = ACTIONS(3020),
    [anon_sym_extern] = ACTIONS(3020),
    [anon_sym___attribute__] = ACTIONS(3020),
    [anon_sym_COLON_COLON] = ACTIONS(3022),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3022),
    [anon_sym___declspec] = ACTIONS(3020),
    [anon_sym___based] = ACTIONS(3020),
    [anon_sym_signed] = ACTIONS(3020),
    [anon_sym_unsigned] = ACTIONS(3020),
    [anon_sym_long] = ACTIONS(3020),
    [anon_sym_short] = ACTIONS(3020),
    [anon_sym_LBRACK] = ACTIONS(3020),
    [anon_sym_static] = ACTIONS(3020),
    [anon_sym_register] = ACTIONS(3020),
    [anon_sym_inline] = ACTIONS(3020),
    [anon_sym___inline] = ACTIONS(3020),
    [anon_sym___inline__] = ACTIONS(3020),
    [anon_sym___forceinline] = ACTIONS(3020),
    [anon_sym_thread_local] = ACTIONS(3020),
    [anon_sym___thread] = ACTIONS(3020),
    [anon_sym_const] = ACTIONS(3020),
    [anon_sym_constexpr] = ACTIONS(3020),
    [anon_sym_volatile] = ACTIONS(3020),
    [anon_sym_restrict] = ACTIONS(3020),
    [anon_sym___restrict__] = ACTIONS(3020),
    [anon_sym__Atomic] = ACTIONS(3020),
    [anon_sym__Noreturn] = ACTIONS(3020),
    [anon_sym_noreturn] = ACTIONS(3020),
    [anon_sym_mutable] = ACTIONS(3020),
    [anon_sym_constinit] = ACTIONS(3020),
    [anon_sym_consteval] = ACTIONS(3020),
    [anon_sym_PROGMEM] = ACTIONS(3020),
    [aux_sym_primitive_type_token1] = ACTIONS(3020),
    [anon_sym_byte] = ACTIONS(3020),
    [anon_sym_word] = ACTIONS(3020),
    [anon_sym_enum] = ACTIONS(3020),
    [anon_sym_class] = ACTIONS(3020),
    [anon_sym_struct] = ACTIONS(3020),
    [anon_sym_union] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3020),
    [anon_sym_decltype] = ACTIONS(3020),
    [anon_sym_virtual] = ACTIONS(3020),
    [anon_sym_alignas] = ACTIONS(3020),
    [anon_sym_explicit] = ACTIONS(3020),
    [anon_sym_typename] = ACTIONS(3020),
    [anon_sym_template] = ACTIONS(3020),
    [anon_sym_operator] = ACTIONS(3020),
    [anon_sym_friend] = ACTIONS(3020),
    [anon_sym_public] = ACTIONS(3020),
    [anon_sym_private] = ACTIONS(3020),
    [anon_sym_protected] = ACTIONS(3020),
    [anon_sym_using] = ACTIONS(3020),
    [anon_sym_static_assert] = ACTIONS(3020),
  },
  [1817] = {
    [sym_identifier] = ACTIONS(3556),
    [aux_sym_preproc_def_token1] = ACTIONS(3556),
    [aux_sym_preproc_if_token1] = ACTIONS(3556),
    [aux_sym_preproc_if_token2] = ACTIONS(3556),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3556),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3556),
    [aux_sym_preproc_else_token1] = ACTIONS(3556),
    [aux_sym_preproc_elif_token1] = ACTIONS(3556),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3556),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3556),
    [sym_preproc_directive] = ACTIONS(3556),
    [anon_sym_LPAREN2] = ACTIONS(3554),
    [anon_sym_TILDE] = ACTIONS(3554),
    [anon_sym_STAR] = ACTIONS(3554),
    [anon_sym_AMP_AMP] = ACTIONS(3554),
    [anon_sym_AMP] = ACTIONS(3556),
    [anon_sym___extension__] = ACTIONS(3556),
    [anon_sym_typedef] = ACTIONS(3556),
    [anon_sym_extern] = ACTIONS(3556),
    [anon_sym___attribute__] = ACTIONS(3556),
    [anon_sym_COLON_COLON] = ACTIONS(3554),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3554),
    [anon_sym___declspec] = ACTIONS(3556),
    [anon_sym___based] = ACTIONS(3556),
    [anon_sym_signed] = ACTIONS(3556),
    [anon_sym_unsigned] = ACTIONS(3556),
    [anon_sym_long] = ACTIONS(3556),
    [anon_sym_short] = ACTIONS(3556),
    [anon_sym_LBRACK] = ACTIONS(3556),
    [anon_sym_static] = ACTIONS(3556),
    [anon_sym_register] = ACTIONS(3556),
    [anon_sym_inline] = ACTIONS(3556),
    [anon_sym___inline] = ACTIONS(3556),
    [anon_sym___inline__] = ACTIONS(3556),
    [anon_sym___forceinline] = ACTIONS(3556),
    [anon_sym_thread_local] = ACTIONS(3556),
    [anon_sym___thread] = ACTIONS(3556),
    [anon_sym_const] = ACTIONS(3556),
    [anon_sym_constexpr] = ACTIONS(3556),
    [anon_sym_volatile] = ACTIONS(3556),
    [anon_sym_restrict] = ACTIONS(3556),
    [anon_sym___restrict__] = ACTIONS(3556),
    [anon_sym__Atomic] = ACTIONS(3556),
    [anon_sym__Noreturn] = ACTIONS(3556),
    [anon_sym_noreturn] = ACTIONS(3556),
    [anon_sym_mutable] = ACTIONS(3556),
    [anon_sym_constinit] = ACTIONS(3556),
    [anon_sym_consteval] = ACTIONS(3556),
    [anon_sym_PROGMEM] = ACTIONS(3556),
    [aux_sym_primitive_type_token1] = ACTIONS(3556),
    [anon_sym_byte] = ACTIONS(3556),
    [anon_sym_word] = ACTIONS(3556),
    [anon_sym_enum] = ACTIONS(3556),
    [anon_sym_class] = ACTIONS(3556),
    [anon_sym_struct] = ACTIONS(3556),
    [anon_sym_union] = ACTIONS(3556),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3556),
    [anon_sym_decltype] = ACTIONS(3556),
    [anon_sym_virtual] = ACTIONS(3556),
    [anon_sym_alignas] = ACTIONS(3556),
    [anon_sym_explicit] = ACTIONS(3556),
    [anon_sym_typename] = ACTIONS(3556),
    [anon_sym_template] = ACTIONS(3556),
    [anon_sym_operator] = ACTIONS(3556),
    [anon_sym_friend] = ACTIONS(3556),
    [anon_sym_public] = ACTIONS(3556),
    [anon_sym_private] = ACTIONS(3556),
    [anon_sym_protected] = ACTIONS(3556),
    [anon_sym_using] = ACTIONS(3556),
    [anon_sym_static_assert] = ACTIONS(3556),
  },
  [1818] = {
    [sym_identifier] = ACTIONS(3016),
    [aux_sym_preproc_def_token1] = ACTIONS(3016),
    [aux_sym_preproc_if_token1] = ACTIONS(3016),
    [aux_sym_preproc_if_token2] = ACTIONS(3016),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3016),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3016),
    [aux_sym_preproc_else_token1] = ACTIONS(3016),
    [aux_sym_preproc_elif_token1] = ACTIONS(3016),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3016),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3016),
    [sym_preproc_directive] = ACTIONS(3016),
    [anon_sym_LPAREN2] = ACTIONS(3018),
    [anon_sym_TILDE] = ACTIONS(3018),
    [anon_sym_STAR] = ACTIONS(3018),
    [anon_sym_AMP_AMP] = ACTIONS(3018),
    [anon_sym_AMP] = ACTIONS(3016),
    [anon_sym___extension__] = ACTIONS(3016),
    [anon_sym_typedef] = ACTIONS(3016),
    [anon_sym_extern] = ACTIONS(3016),
    [anon_sym___attribute__] = ACTIONS(3016),
    [anon_sym_COLON_COLON] = ACTIONS(3018),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3018),
    [anon_sym___declspec] = ACTIONS(3016),
    [anon_sym___based] = ACTIONS(3016),
    [anon_sym_signed] = ACTIONS(3016),
    [anon_sym_unsigned] = ACTIONS(3016),
    [anon_sym_long] = ACTIONS(3016),
    [anon_sym_short] = ACTIONS(3016),
    [anon_sym_LBRACK] = ACTIONS(3016),
    [anon_sym_static] = ACTIONS(3016),
    [anon_sym_register] = ACTIONS(3016),
    [anon_sym_inline] = ACTIONS(3016),
    [anon_sym___inline] = ACTIONS(3016),
    [anon_sym___inline__] = ACTIONS(3016),
    [anon_sym___forceinline] = ACTIONS(3016),
    [anon_sym_thread_local] = ACTIONS(3016),
    [anon_sym___thread] = ACTIONS(3016),
    [anon_sym_const] = ACTIONS(3016),
    [anon_sym_constexpr] = ACTIONS(3016),
    [anon_sym_volatile] = ACTIONS(3016),
    [anon_sym_restrict] = ACTIONS(3016),
    [anon_sym___restrict__] = ACTIONS(3016),
    [anon_sym__Atomic] = ACTIONS(3016),
    [anon_sym__Noreturn] = ACTIONS(3016),
    [anon_sym_noreturn] = ACTIONS(3016),
    [anon_sym_mutable] = ACTIONS(3016),
    [anon_sym_constinit] = ACTIONS(3016),
    [anon_sym_consteval] = ACTIONS(3016),
    [anon_sym_PROGMEM] = ACTIONS(3016),
    [aux_sym_primitive_type_token1] = ACTIONS(3016),
    [anon_sym_byte] = ACTIONS(3016),
    [anon_sym_word] = ACTIONS(3016),
    [anon_sym_enum] = ACTIONS(3016),
    [anon_sym_class] = ACTIONS(3016),
    [anon_sym_struct] = ACTIONS(3016),
    [anon_sym_union] = ACTIONS(3016),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3016),
    [anon_sym_decltype] = ACTIONS(3016),
    [anon_sym_virtual] = ACTIONS(3016),
    [anon_sym_alignas] = ACTIONS(3016),
    [anon_sym_explicit] = ACTIONS(3016),
    [anon_sym_typename] = ACTIONS(3016),
    [anon_sym_template] = ACTIONS(3016),
    [anon_sym_operator] = ACTIONS(3016),
    [anon_sym_friend] = ACTIONS(3016),
    [anon_sym_public] = ACTIONS(3016),
    [anon_sym_private] = ACTIONS(3016),
    [anon_sym_protected] = ACTIONS(3016),
    [anon_sym_using] = ACTIONS(3016),
    [anon_sym_static_assert] = ACTIONS(3016),
  },
  [1819] = {
    [sym_identifier] = ACTIONS(2735),
    [aux_sym_preproc_def_token1] = ACTIONS(2735),
    [aux_sym_preproc_if_token1] = ACTIONS(2735),
    [aux_sym_preproc_if_token2] = ACTIONS(2735),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2735),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2735),
    [aux_sym_preproc_else_token1] = ACTIONS(2735),
    [aux_sym_preproc_elif_token1] = ACTIONS(2735),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2735),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2735),
    [sym_preproc_directive] = ACTIONS(2735),
    [anon_sym_LPAREN2] = ACTIONS(2737),
    [anon_sym_TILDE] = ACTIONS(2737),
    [anon_sym_STAR] = ACTIONS(2737),
    [anon_sym_AMP_AMP] = ACTIONS(2737),
    [anon_sym_AMP] = ACTIONS(2735),
    [anon_sym___extension__] = ACTIONS(2735),
    [anon_sym_typedef] = ACTIONS(2735),
    [anon_sym_extern] = ACTIONS(2735),
    [anon_sym___attribute__] = ACTIONS(2735),
    [anon_sym_COLON_COLON] = ACTIONS(2737),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2737),
    [anon_sym___declspec] = ACTIONS(2735),
    [anon_sym___based] = ACTIONS(2735),
    [anon_sym_signed] = ACTIONS(2735),
    [anon_sym_unsigned] = ACTIONS(2735),
    [anon_sym_long] = ACTIONS(2735),
    [anon_sym_short] = ACTIONS(2735),
    [anon_sym_LBRACK] = ACTIONS(2735),
    [anon_sym_static] = ACTIONS(2735),
    [anon_sym_register] = ACTIONS(2735),
    [anon_sym_inline] = ACTIONS(2735),
    [anon_sym___inline] = ACTIONS(2735),
    [anon_sym___inline__] = ACTIONS(2735),
    [anon_sym___forceinline] = ACTIONS(2735),
    [anon_sym_thread_local] = ACTIONS(2735),
    [anon_sym___thread] = ACTIONS(2735),
    [anon_sym_const] = ACTIONS(2735),
    [anon_sym_constexpr] = ACTIONS(2735),
    [anon_sym_volatile] = ACTIONS(2735),
    [anon_sym_restrict] = ACTIONS(2735),
    [anon_sym___restrict__] = ACTIONS(2735),
    [anon_sym__Atomic] = ACTIONS(2735),
    [anon_sym__Noreturn] = ACTIONS(2735),
    [anon_sym_noreturn] = ACTIONS(2735),
    [anon_sym_mutable] = ACTIONS(2735),
    [anon_sym_constinit] = ACTIONS(2735),
    [anon_sym_consteval] = ACTIONS(2735),
    [anon_sym_PROGMEM] = ACTIONS(2735),
    [aux_sym_primitive_type_token1] = ACTIONS(2735),
    [anon_sym_byte] = ACTIONS(2735),
    [anon_sym_word] = ACTIONS(2735),
    [anon_sym_enum] = ACTIONS(2735),
    [anon_sym_class] = ACTIONS(2735),
    [anon_sym_struct] = ACTIONS(2735),
    [anon_sym_union] = ACTIONS(2735),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2735),
    [anon_sym_decltype] = ACTIONS(2735),
    [anon_sym_virtual] = ACTIONS(2735),
    [anon_sym_alignas] = ACTIONS(2735),
    [anon_sym_explicit] = ACTIONS(2735),
    [anon_sym_typename] = ACTIONS(2735),
    [anon_sym_template] = ACTIONS(2735),
    [anon_sym_operator] = ACTIONS(2735),
    [anon_sym_friend] = ACTIONS(2735),
    [anon_sym_public] = ACTIONS(2735),
    [anon_sym_private] = ACTIONS(2735),
    [anon_sym_protected] = ACTIONS(2735),
    [anon_sym_using] = ACTIONS(2735),
    [anon_sym_static_assert] = ACTIONS(2735),
  },
  [1820] = {
    [sym_identifier] = ACTIONS(3068),
    [aux_sym_preproc_def_token1] = ACTIONS(3068),
    [aux_sym_preproc_if_token1] = ACTIONS(3068),
    [aux_sym_preproc_if_token2] = ACTIONS(3068),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3068),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3068),
    [aux_sym_preproc_else_token1] = ACTIONS(3068),
    [aux_sym_preproc_elif_token1] = ACTIONS(3068),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3068),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3068),
    [sym_preproc_directive] = ACTIONS(3068),
    [anon_sym_LPAREN2] = ACTIONS(3070),
    [anon_sym_TILDE] = ACTIONS(3070),
    [anon_sym_STAR] = ACTIONS(3070),
    [anon_sym_AMP_AMP] = ACTIONS(3070),
    [anon_sym_AMP] = ACTIONS(3068),
    [anon_sym___extension__] = ACTIONS(3068),
    [anon_sym_typedef] = ACTIONS(3068),
    [anon_sym_extern] = ACTIONS(3068),
    [anon_sym___attribute__] = ACTIONS(3068),
    [anon_sym_COLON_COLON] = ACTIONS(3070),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3070),
    [anon_sym___declspec] = ACTIONS(3068),
    [anon_sym___based] = ACTIONS(3068),
    [anon_sym_signed] = ACTIONS(3068),
    [anon_sym_unsigned] = ACTIONS(3068),
    [anon_sym_long] = ACTIONS(3068),
    [anon_sym_short] = ACTIONS(3068),
    [anon_sym_LBRACK] = ACTIONS(3068),
    [anon_sym_static] = ACTIONS(3068),
    [anon_sym_register] = ACTIONS(3068),
    [anon_sym_inline] = ACTIONS(3068),
    [anon_sym___inline] = ACTIONS(3068),
    [anon_sym___inline__] = ACTIONS(3068),
    [anon_sym___forceinline] = ACTIONS(3068),
    [anon_sym_thread_local] = ACTIONS(3068),
    [anon_sym___thread] = ACTIONS(3068),
    [anon_sym_const] = ACTIONS(3068),
    [anon_sym_constexpr] = ACTIONS(3068),
    [anon_sym_volatile] = ACTIONS(3068),
    [anon_sym_restrict] = ACTIONS(3068),
    [anon_sym___restrict__] = ACTIONS(3068),
    [anon_sym__Atomic] = ACTIONS(3068),
    [anon_sym__Noreturn] = ACTIONS(3068),
    [anon_sym_noreturn] = ACTIONS(3068),
    [anon_sym_mutable] = ACTIONS(3068),
    [anon_sym_constinit] = ACTIONS(3068),
    [anon_sym_consteval] = ACTIONS(3068),
    [anon_sym_PROGMEM] = ACTIONS(3068),
    [aux_sym_primitive_type_token1] = ACTIONS(3068),
    [anon_sym_byte] = ACTIONS(3068),
    [anon_sym_word] = ACTIONS(3068),
    [anon_sym_enum] = ACTIONS(3068),
    [anon_sym_class] = ACTIONS(3068),
    [anon_sym_struct] = ACTIONS(3068),
    [anon_sym_union] = ACTIONS(3068),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3068),
    [anon_sym_decltype] = ACTIONS(3068),
    [anon_sym_virtual] = ACTIONS(3068),
    [anon_sym_alignas] = ACTIONS(3068),
    [anon_sym_explicit] = ACTIONS(3068),
    [anon_sym_typename] = ACTIONS(3068),
    [anon_sym_template] = ACTIONS(3068),
    [anon_sym_operator] = ACTIONS(3068),
    [anon_sym_friend] = ACTIONS(3068),
    [anon_sym_public] = ACTIONS(3068),
    [anon_sym_private] = ACTIONS(3068),
    [anon_sym_protected] = ACTIONS(3068),
    [anon_sym_using] = ACTIONS(3068),
    [anon_sym_static_assert] = ACTIONS(3068),
  },
  [1821] = {
    [sym_identifier] = ACTIONS(3068),
    [aux_sym_preproc_def_token1] = ACTIONS(3068),
    [aux_sym_preproc_if_token1] = ACTIONS(3068),
    [aux_sym_preproc_if_token2] = ACTIONS(3068),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3068),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3068),
    [aux_sym_preproc_else_token1] = ACTIONS(3068),
    [aux_sym_preproc_elif_token1] = ACTIONS(3068),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3068),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3068),
    [sym_preproc_directive] = ACTIONS(3068),
    [anon_sym_LPAREN2] = ACTIONS(3070),
    [anon_sym_TILDE] = ACTIONS(3070),
    [anon_sym_STAR] = ACTIONS(3070),
    [anon_sym_AMP_AMP] = ACTIONS(3070),
    [anon_sym_AMP] = ACTIONS(3068),
    [anon_sym___extension__] = ACTIONS(3068),
    [anon_sym_typedef] = ACTIONS(3068),
    [anon_sym_extern] = ACTIONS(3068),
    [anon_sym___attribute__] = ACTIONS(3068),
    [anon_sym_COLON_COLON] = ACTIONS(3070),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3070),
    [anon_sym___declspec] = ACTIONS(3068),
    [anon_sym___based] = ACTIONS(3068),
    [anon_sym_signed] = ACTIONS(3068),
    [anon_sym_unsigned] = ACTIONS(3068),
    [anon_sym_long] = ACTIONS(3068),
    [anon_sym_short] = ACTIONS(3068),
    [anon_sym_LBRACK] = ACTIONS(3068),
    [anon_sym_static] = ACTIONS(3068),
    [anon_sym_register] = ACTIONS(3068),
    [anon_sym_inline] = ACTIONS(3068),
    [anon_sym___inline] = ACTIONS(3068),
    [anon_sym___inline__] = ACTIONS(3068),
    [anon_sym___forceinline] = ACTIONS(3068),
    [anon_sym_thread_local] = ACTIONS(3068),
    [anon_sym___thread] = ACTIONS(3068),
    [anon_sym_const] = ACTIONS(3068),
    [anon_sym_constexpr] = ACTIONS(3068),
    [anon_sym_volatile] = ACTIONS(3068),
    [anon_sym_restrict] = ACTIONS(3068),
    [anon_sym___restrict__] = ACTIONS(3068),
    [anon_sym__Atomic] = ACTIONS(3068),
    [anon_sym__Noreturn] = ACTIONS(3068),
    [anon_sym_noreturn] = ACTIONS(3068),
    [anon_sym_mutable] = ACTIONS(3068),
    [anon_sym_constinit] = ACTIONS(3068),
    [anon_sym_consteval] = ACTIONS(3068),
    [anon_sym_PROGMEM] = ACTIONS(3068),
    [aux_sym_primitive_type_token1] = ACTIONS(3068),
    [anon_sym_byte] = ACTIONS(3068),
    [anon_sym_word] = ACTIONS(3068),
    [anon_sym_enum] = ACTIONS(3068),
    [anon_sym_class] = ACTIONS(3068),
    [anon_sym_struct] = ACTIONS(3068),
    [anon_sym_union] = ACTIONS(3068),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3068),
    [anon_sym_decltype] = ACTIONS(3068),
    [anon_sym_virtual] = ACTIONS(3068),
    [anon_sym_alignas] = ACTIONS(3068),
    [anon_sym_explicit] = ACTIONS(3068),
    [anon_sym_typename] = ACTIONS(3068),
    [anon_sym_template] = ACTIONS(3068),
    [anon_sym_operator] = ACTIONS(3068),
    [anon_sym_friend] = ACTIONS(3068),
    [anon_sym_public] = ACTIONS(3068),
    [anon_sym_private] = ACTIONS(3068),
    [anon_sym_protected] = ACTIONS(3068),
    [anon_sym_using] = ACTIONS(3068),
    [anon_sym_static_assert] = ACTIONS(3068),
  },
  [1822] = {
    [sym_identifier] = ACTIONS(3078),
    [aux_sym_preproc_def_token1] = ACTIONS(3078),
    [aux_sym_preproc_if_token1] = ACTIONS(3078),
    [aux_sym_preproc_if_token2] = ACTIONS(3078),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3078),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3078),
    [aux_sym_preproc_else_token1] = ACTIONS(3078),
    [aux_sym_preproc_elif_token1] = ACTIONS(3078),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3078),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3078),
    [sym_preproc_directive] = ACTIONS(3078),
    [anon_sym_LPAREN2] = ACTIONS(3080),
    [anon_sym_TILDE] = ACTIONS(3080),
    [anon_sym_STAR] = ACTIONS(3080),
    [anon_sym_AMP_AMP] = ACTIONS(3080),
    [anon_sym_AMP] = ACTIONS(3078),
    [anon_sym___extension__] = ACTIONS(3078),
    [anon_sym_typedef] = ACTIONS(3078),
    [anon_sym_extern] = ACTIONS(3078),
    [anon_sym___attribute__] = ACTIONS(3078),
    [anon_sym_COLON_COLON] = ACTIONS(3080),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3080),
    [anon_sym___declspec] = ACTIONS(3078),
    [anon_sym___based] = ACTIONS(3078),
    [anon_sym_signed] = ACTIONS(3078),
    [anon_sym_unsigned] = ACTIONS(3078),
    [anon_sym_long] = ACTIONS(3078),
    [anon_sym_short] = ACTIONS(3078),
    [anon_sym_LBRACK] = ACTIONS(3078),
    [anon_sym_static] = ACTIONS(3078),
    [anon_sym_register] = ACTIONS(3078),
    [anon_sym_inline] = ACTIONS(3078),
    [anon_sym___inline] = ACTIONS(3078),
    [anon_sym___inline__] = ACTIONS(3078),
    [anon_sym___forceinline] = ACTIONS(3078),
    [anon_sym_thread_local] = ACTIONS(3078),
    [anon_sym___thread] = ACTIONS(3078),
    [anon_sym_const] = ACTIONS(3078),
    [anon_sym_constexpr] = ACTIONS(3078),
    [anon_sym_volatile] = ACTIONS(3078),
    [anon_sym_restrict] = ACTIONS(3078),
    [anon_sym___restrict__] = ACTIONS(3078),
    [anon_sym__Atomic] = ACTIONS(3078),
    [anon_sym__Noreturn] = ACTIONS(3078),
    [anon_sym_noreturn] = ACTIONS(3078),
    [anon_sym_mutable] = ACTIONS(3078),
    [anon_sym_constinit] = ACTIONS(3078),
    [anon_sym_consteval] = ACTIONS(3078),
    [anon_sym_PROGMEM] = ACTIONS(3078),
    [aux_sym_primitive_type_token1] = ACTIONS(3078),
    [anon_sym_byte] = ACTIONS(3078),
    [anon_sym_word] = ACTIONS(3078),
    [anon_sym_enum] = ACTIONS(3078),
    [anon_sym_class] = ACTIONS(3078),
    [anon_sym_struct] = ACTIONS(3078),
    [anon_sym_union] = ACTIONS(3078),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3078),
    [anon_sym_decltype] = ACTIONS(3078),
    [anon_sym_virtual] = ACTIONS(3078),
    [anon_sym_alignas] = ACTIONS(3078),
    [anon_sym_explicit] = ACTIONS(3078),
    [anon_sym_typename] = ACTIONS(3078),
    [anon_sym_template] = ACTIONS(3078),
    [anon_sym_operator] = ACTIONS(3078),
    [anon_sym_friend] = ACTIONS(3078),
    [anon_sym_public] = ACTIONS(3078),
    [anon_sym_private] = ACTIONS(3078),
    [anon_sym_protected] = ACTIONS(3078),
    [anon_sym_using] = ACTIONS(3078),
    [anon_sym_static_assert] = ACTIONS(3078),
  },
  [1823] = {
    [sym_identifier] = ACTIONS(3082),
    [aux_sym_preproc_def_token1] = ACTIONS(3082),
    [aux_sym_preproc_if_token1] = ACTIONS(3082),
    [aux_sym_preproc_if_token2] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3082),
    [aux_sym_preproc_else_token1] = ACTIONS(3082),
    [aux_sym_preproc_elif_token1] = ACTIONS(3082),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3082),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3082),
    [sym_preproc_directive] = ACTIONS(3082),
    [anon_sym_LPAREN2] = ACTIONS(3084),
    [anon_sym_TILDE] = ACTIONS(3084),
    [anon_sym_STAR] = ACTIONS(3084),
    [anon_sym_AMP_AMP] = ACTIONS(3084),
    [anon_sym_AMP] = ACTIONS(3082),
    [anon_sym___extension__] = ACTIONS(3082),
    [anon_sym_typedef] = ACTIONS(3082),
    [anon_sym_extern] = ACTIONS(3082),
    [anon_sym___attribute__] = ACTIONS(3082),
    [anon_sym_COLON_COLON] = ACTIONS(3084),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3084),
    [anon_sym___declspec] = ACTIONS(3082),
    [anon_sym___based] = ACTIONS(3082),
    [anon_sym_signed] = ACTIONS(3082),
    [anon_sym_unsigned] = ACTIONS(3082),
    [anon_sym_long] = ACTIONS(3082),
    [anon_sym_short] = ACTIONS(3082),
    [anon_sym_LBRACK] = ACTIONS(3082),
    [anon_sym_static] = ACTIONS(3082),
    [anon_sym_register] = ACTIONS(3082),
    [anon_sym_inline] = ACTIONS(3082),
    [anon_sym___inline] = ACTIONS(3082),
    [anon_sym___inline__] = ACTIONS(3082),
    [anon_sym___forceinline] = ACTIONS(3082),
    [anon_sym_thread_local] = ACTIONS(3082),
    [anon_sym___thread] = ACTIONS(3082),
    [anon_sym_const] = ACTIONS(3082),
    [anon_sym_constexpr] = ACTIONS(3082),
    [anon_sym_volatile] = ACTIONS(3082),
    [anon_sym_restrict] = ACTIONS(3082),
    [anon_sym___restrict__] = ACTIONS(3082),
    [anon_sym__Atomic] = ACTIONS(3082),
    [anon_sym__Noreturn] = ACTIONS(3082),
    [anon_sym_noreturn] = ACTIONS(3082),
    [anon_sym_mutable] = ACTIONS(3082),
    [anon_sym_constinit] = ACTIONS(3082),
    [anon_sym_consteval] = ACTIONS(3082),
    [anon_sym_PROGMEM] = ACTIONS(3082),
    [aux_sym_primitive_type_token1] = ACTIONS(3082),
    [anon_sym_byte] = ACTIONS(3082),
    [anon_sym_word] = ACTIONS(3082),
    [anon_sym_enum] = ACTIONS(3082),
    [anon_sym_class] = ACTIONS(3082),
    [anon_sym_struct] = ACTIONS(3082),
    [anon_sym_union] = ACTIONS(3082),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3082),
    [anon_sym_decltype] = ACTIONS(3082),
    [anon_sym_virtual] = ACTIONS(3082),
    [anon_sym_alignas] = ACTIONS(3082),
    [anon_sym_explicit] = ACTIONS(3082),
    [anon_sym_typename] = ACTIONS(3082),
    [anon_sym_template] = ACTIONS(3082),
    [anon_sym_operator] = ACTIONS(3082),
    [anon_sym_friend] = ACTIONS(3082),
    [anon_sym_public] = ACTIONS(3082),
    [anon_sym_private] = ACTIONS(3082),
    [anon_sym_protected] = ACTIONS(3082),
    [anon_sym_using] = ACTIONS(3082),
    [anon_sym_static_assert] = ACTIONS(3082),
  },
  [1824] = {
    [sym_identifier] = ACTIONS(3086),
    [aux_sym_preproc_def_token1] = ACTIONS(3086),
    [aux_sym_preproc_if_token1] = ACTIONS(3086),
    [aux_sym_preproc_if_token2] = ACTIONS(3086),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3086),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3086),
    [aux_sym_preproc_else_token1] = ACTIONS(3086),
    [aux_sym_preproc_elif_token1] = ACTIONS(3086),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3086),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3086),
    [sym_preproc_directive] = ACTIONS(3086),
    [anon_sym_LPAREN2] = ACTIONS(3088),
    [anon_sym_TILDE] = ACTIONS(3088),
    [anon_sym_STAR] = ACTIONS(3088),
    [anon_sym_AMP_AMP] = ACTIONS(3088),
    [anon_sym_AMP] = ACTIONS(3086),
    [anon_sym___extension__] = ACTIONS(3086),
    [anon_sym_typedef] = ACTIONS(3086),
    [anon_sym_extern] = ACTIONS(3086),
    [anon_sym___attribute__] = ACTIONS(3086),
    [anon_sym_COLON_COLON] = ACTIONS(3088),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3088),
    [anon_sym___declspec] = ACTIONS(3086),
    [anon_sym___based] = ACTIONS(3086),
    [anon_sym_signed] = ACTIONS(3086),
    [anon_sym_unsigned] = ACTIONS(3086),
    [anon_sym_long] = ACTIONS(3086),
    [anon_sym_short] = ACTIONS(3086),
    [anon_sym_LBRACK] = ACTIONS(3086),
    [anon_sym_static] = ACTIONS(3086),
    [anon_sym_register] = ACTIONS(3086),
    [anon_sym_inline] = ACTIONS(3086),
    [anon_sym___inline] = ACTIONS(3086),
    [anon_sym___inline__] = ACTIONS(3086),
    [anon_sym___forceinline] = ACTIONS(3086),
    [anon_sym_thread_local] = ACTIONS(3086),
    [anon_sym___thread] = ACTIONS(3086),
    [anon_sym_const] = ACTIONS(3086),
    [anon_sym_constexpr] = ACTIONS(3086),
    [anon_sym_volatile] = ACTIONS(3086),
    [anon_sym_restrict] = ACTIONS(3086),
    [anon_sym___restrict__] = ACTIONS(3086),
    [anon_sym__Atomic] = ACTIONS(3086),
    [anon_sym__Noreturn] = ACTIONS(3086),
    [anon_sym_noreturn] = ACTIONS(3086),
    [anon_sym_mutable] = ACTIONS(3086),
    [anon_sym_constinit] = ACTIONS(3086),
    [anon_sym_consteval] = ACTIONS(3086),
    [anon_sym_PROGMEM] = ACTIONS(3086),
    [aux_sym_primitive_type_token1] = ACTIONS(3086),
    [anon_sym_byte] = ACTIONS(3086),
    [anon_sym_word] = ACTIONS(3086),
    [anon_sym_enum] = ACTIONS(3086),
    [anon_sym_class] = ACTIONS(3086),
    [anon_sym_struct] = ACTIONS(3086),
    [anon_sym_union] = ACTIONS(3086),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3086),
    [anon_sym_decltype] = ACTIONS(3086),
    [anon_sym_virtual] = ACTIONS(3086),
    [anon_sym_alignas] = ACTIONS(3086),
    [anon_sym_explicit] = ACTIONS(3086),
    [anon_sym_typename] = ACTIONS(3086),
    [anon_sym_template] = ACTIONS(3086),
    [anon_sym_operator] = ACTIONS(3086),
    [anon_sym_friend] = ACTIONS(3086),
    [anon_sym_public] = ACTIONS(3086),
    [anon_sym_private] = ACTIONS(3086),
    [anon_sym_protected] = ACTIONS(3086),
    [anon_sym_using] = ACTIONS(3086),
    [anon_sym_static_assert] = ACTIONS(3086),
  },
  [1825] = {
    [sym_identifier] = ACTIONS(4859),
    [aux_sym_preproc_def_token1] = ACTIONS(4859),
    [aux_sym_preproc_if_token1] = ACTIONS(4859),
    [aux_sym_preproc_if_token2] = ACTIONS(4859),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4859),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4859),
    [aux_sym_preproc_else_token1] = ACTIONS(4859),
    [aux_sym_preproc_elif_token1] = ACTIONS(4859),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4859),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4859),
    [sym_preproc_directive] = ACTIONS(4859),
    [anon_sym_LPAREN2] = ACTIONS(4861),
    [anon_sym_TILDE] = ACTIONS(4861),
    [anon_sym_STAR] = ACTIONS(4861),
    [anon_sym_AMP_AMP] = ACTIONS(4861),
    [anon_sym_AMP] = ACTIONS(4859),
    [anon_sym___extension__] = ACTIONS(4859),
    [anon_sym_typedef] = ACTIONS(4859),
    [anon_sym_extern] = ACTIONS(4859),
    [anon_sym___attribute__] = ACTIONS(4859),
    [anon_sym_COLON_COLON] = ACTIONS(4861),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4861),
    [anon_sym___declspec] = ACTIONS(4859),
    [anon_sym___based] = ACTIONS(4859),
    [anon_sym_signed] = ACTIONS(4859),
    [anon_sym_unsigned] = ACTIONS(4859),
    [anon_sym_long] = ACTIONS(4859),
    [anon_sym_short] = ACTIONS(4859),
    [anon_sym_LBRACK] = ACTIONS(4859),
    [anon_sym_static] = ACTIONS(4859),
    [anon_sym_register] = ACTIONS(4859),
    [anon_sym_inline] = ACTIONS(4859),
    [anon_sym___inline] = ACTIONS(4859),
    [anon_sym___inline__] = ACTIONS(4859),
    [anon_sym___forceinline] = ACTIONS(4859),
    [anon_sym_thread_local] = ACTIONS(4859),
    [anon_sym___thread] = ACTIONS(4859),
    [anon_sym_const] = ACTIONS(4859),
    [anon_sym_constexpr] = ACTIONS(4859),
    [anon_sym_volatile] = ACTIONS(4859),
    [anon_sym_restrict] = ACTIONS(4859),
    [anon_sym___restrict__] = ACTIONS(4859),
    [anon_sym__Atomic] = ACTIONS(4859),
    [anon_sym__Noreturn] = ACTIONS(4859),
    [anon_sym_noreturn] = ACTIONS(4859),
    [anon_sym_mutable] = ACTIONS(4859),
    [anon_sym_constinit] = ACTIONS(4859),
    [anon_sym_consteval] = ACTIONS(4859),
    [anon_sym_PROGMEM] = ACTIONS(4859),
    [aux_sym_primitive_type_token1] = ACTIONS(4859),
    [anon_sym_byte] = ACTIONS(4859),
    [anon_sym_word] = ACTIONS(4859),
    [anon_sym_enum] = ACTIONS(4859),
    [anon_sym_class] = ACTIONS(4859),
    [anon_sym_struct] = ACTIONS(4859),
    [anon_sym_union] = ACTIONS(4859),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4859),
    [anon_sym_decltype] = ACTIONS(4859),
    [anon_sym_virtual] = ACTIONS(4859),
    [anon_sym_alignas] = ACTIONS(4859),
    [anon_sym_explicit] = ACTIONS(4859),
    [anon_sym_typename] = ACTIONS(4859),
    [anon_sym_template] = ACTIONS(4859),
    [anon_sym_operator] = ACTIONS(4859),
    [anon_sym_friend] = ACTIONS(4859),
    [anon_sym_public] = ACTIONS(4859),
    [anon_sym_private] = ACTIONS(4859),
    [anon_sym_protected] = ACTIONS(4859),
    [anon_sym_using] = ACTIONS(4859),
    [anon_sym_static_assert] = ACTIONS(4859),
  },
  [1826] = {
    [sym_identifier] = ACTIONS(4863),
    [aux_sym_preproc_def_token1] = ACTIONS(4863),
    [aux_sym_preproc_if_token1] = ACTIONS(4863),
    [aux_sym_preproc_if_token2] = ACTIONS(4863),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4863),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4863),
    [aux_sym_preproc_else_token1] = ACTIONS(4863),
    [aux_sym_preproc_elif_token1] = ACTIONS(4863),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4863),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4863),
    [sym_preproc_directive] = ACTIONS(4863),
    [anon_sym_LPAREN2] = ACTIONS(4865),
    [anon_sym_TILDE] = ACTIONS(4865),
    [anon_sym_STAR] = ACTIONS(4865),
    [anon_sym_AMP_AMP] = ACTIONS(4865),
    [anon_sym_AMP] = ACTIONS(4863),
    [anon_sym___extension__] = ACTIONS(4863),
    [anon_sym_typedef] = ACTIONS(4863),
    [anon_sym_extern] = ACTIONS(4863),
    [anon_sym___attribute__] = ACTIONS(4863),
    [anon_sym_COLON_COLON] = ACTIONS(4865),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4865),
    [anon_sym___declspec] = ACTIONS(4863),
    [anon_sym___based] = ACTIONS(4863),
    [anon_sym_signed] = ACTIONS(4863),
    [anon_sym_unsigned] = ACTIONS(4863),
    [anon_sym_long] = ACTIONS(4863),
    [anon_sym_short] = ACTIONS(4863),
    [anon_sym_LBRACK] = ACTIONS(4863),
    [anon_sym_static] = ACTIONS(4863),
    [anon_sym_register] = ACTIONS(4863),
    [anon_sym_inline] = ACTIONS(4863),
    [anon_sym___inline] = ACTIONS(4863),
    [anon_sym___inline__] = ACTIONS(4863),
    [anon_sym___forceinline] = ACTIONS(4863),
    [anon_sym_thread_local] = ACTIONS(4863),
    [anon_sym___thread] = ACTIONS(4863),
    [anon_sym_const] = ACTIONS(4863),
    [anon_sym_constexpr] = ACTIONS(4863),
    [anon_sym_volatile] = ACTIONS(4863),
    [anon_sym_restrict] = ACTIONS(4863),
    [anon_sym___restrict__] = ACTIONS(4863),
    [anon_sym__Atomic] = ACTIONS(4863),
    [anon_sym__Noreturn] = ACTIONS(4863),
    [anon_sym_noreturn] = ACTIONS(4863),
    [anon_sym_mutable] = ACTIONS(4863),
    [anon_sym_constinit] = ACTIONS(4863),
    [anon_sym_consteval] = ACTIONS(4863),
    [anon_sym_PROGMEM] = ACTIONS(4863),
    [aux_sym_primitive_type_token1] = ACTIONS(4863),
    [anon_sym_byte] = ACTIONS(4863),
    [anon_sym_word] = ACTIONS(4863),
    [anon_sym_enum] = ACTIONS(4863),
    [anon_sym_class] = ACTIONS(4863),
    [anon_sym_struct] = ACTIONS(4863),
    [anon_sym_union] = ACTIONS(4863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4863),
    [anon_sym_decltype] = ACTIONS(4863),
    [anon_sym_virtual] = ACTIONS(4863),
    [anon_sym_alignas] = ACTIONS(4863),
    [anon_sym_explicit] = ACTIONS(4863),
    [anon_sym_typename] = ACTIONS(4863),
    [anon_sym_template] = ACTIONS(4863),
    [anon_sym_operator] = ACTIONS(4863),
    [anon_sym_friend] = ACTIONS(4863),
    [anon_sym_public] = ACTIONS(4863),
    [anon_sym_private] = ACTIONS(4863),
    [anon_sym_protected] = ACTIONS(4863),
    [anon_sym_using] = ACTIONS(4863),
    [anon_sym_static_assert] = ACTIONS(4863),
  },
  [1827] = {
    [sym_identifier] = ACTIONS(4867),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4869),
    [anon_sym_COMMA] = ACTIONS(4869),
    [anon_sym_RPAREN] = ACTIONS(4869),
    [anon_sym_LPAREN2] = ACTIONS(4869),
    [anon_sym_DASH] = ACTIONS(4867),
    [anon_sym_PLUS] = ACTIONS(4867),
    [anon_sym_STAR] = ACTIONS(4869),
    [anon_sym_SLASH] = ACTIONS(4867),
    [anon_sym_PERCENT] = ACTIONS(4869),
    [anon_sym_PIPE_PIPE] = ACTIONS(4869),
    [anon_sym_AMP_AMP] = ACTIONS(4869),
    [anon_sym_PIPE] = ACTIONS(4867),
    [anon_sym_CARET] = ACTIONS(4869),
    [anon_sym_AMP] = ACTIONS(4867),
    [anon_sym_EQ_EQ] = ACTIONS(4869),
    [anon_sym_BANG_EQ] = ACTIONS(4869),
    [anon_sym_GT] = ACTIONS(4867),
    [anon_sym_GT_EQ] = ACTIONS(4869),
    [anon_sym_LT_EQ] = ACTIONS(4867),
    [anon_sym_LT] = ACTIONS(4867),
    [anon_sym_LT_LT] = ACTIONS(4869),
    [anon_sym_GT_GT] = ACTIONS(4869),
    [anon_sym_SEMI] = ACTIONS(4869),
    [anon_sym___extension__] = ACTIONS(4867),
    [anon_sym___attribute__] = ACTIONS(4867),
    [anon_sym_COLON_COLON] = ACTIONS(4869),
    [anon_sym___based] = ACTIONS(4867),
    [anon_sym_LBRACE] = ACTIONS(4869),
    [anon_sym_RBRACE] = ACTIONS(4869),
    [anon_sym_signed] = ACTIONS(4867),
    [anon_sym_unsigned] = ACTIONS(4867),
    [anon_sym_long] = ACTIONS(4867),
    [anon_sym_short] = ACTIONS(4867),
    [anon_sym_LBRACK] = ACTIONS(4869),
    [anon_sym_RBRACK] = ACTIONS(4869),
    [anon_sym_const] = ACTIONS(4867),
    [anon_sym_constexpr] = ACTIONS(4867),
    [anon_sym_volatile] = ACTIONS(4867),
    [anon_sym_restrict] = ACTIONS(4867),
    [anon_sym___restrict__] = ACTIONS(4867),
    [anon_sym__Atomic] = ACTIONS(4867),
    [anon_sym__Noreturn] = ACTIONS(4867),
    [anon_sym_noreturn] = ACTIONS(4867),
    [anon_sym_mutable] = ACTIONS(4867),
    [anon_sym_constinit] = ACTIONS(4867),
    [anon_sym_consteval] = ACTIONS(4867),
    [anon_sym_PROGMEM] = ACTIONS(4867),
    [aux_sym_primitive_type_token1] = ACTIONS(4867),
    [anon_sym_byte] = ACTIONS(4867),
    [anon_sym_word] = ACTIONS(4867),
    [anon_sym_COLON] = ACTIONS(4867),
    [anon_sym_QMARK] = ACTIONS(4869),
    [anon_sym_LT_EQ_GT] = ACTIONS(4869),
    [anon_sym_or] = ACTIONS(4867),
    [anon_sym_and] = ACTIONS(4867),
    [anon_sym_bitor] = ACTIONS(4867),
    [anon_sym_xor] = ACTIONS(4867),
    [anon_sym_bitand] = ACTIONS(4867),
    [anon_sym_not_eq] = ACTIONS(4867),
    [anon_sym_DASH_DASH] = ACTIONS(4869),
    [anon_sym_PLUS_PLUS] = ACTIONS(4869),
    [anon_sym_DOT] = ACTIONS(4867),
    [anon_sym_DOT_STAR] = ACTIONS(4869),
    [anon_sym_DASH_GT] = ACTIONS(4869),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4867),
    [anon_sym_decltype] = ACTIONS(4867),
    [anon_sym_final] = ACTIONS(4867),
    [anon_sym_override] = ACTIONS(4867),
    [anon_sym_requires] = ACTIONS(4867),
  },
  [1828] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4577),
    [anon_sym_COMMA] = ACTIONS(4577),
    [anon_sym_RPAREN] = ACTIONS(4579),
    [anon_sym_LPAREN2] = ACTIONS(4579),
    [anon_sym_DASH] = ACTIONS(4584),
    [anon_sym_PLUS] = ACTIONS(4584),
    [anon_sym_STAR] = ACTIONS(4586),
    [anon_sym_SLASH] = ACTIONS(4584),
    [anon_sym_PERCENT] = ACTIONS(4584),
    [anon_sym_PIPE_PIPE] = ACTIONS(4577),
    [anon_sym_AMP_AMP] = ACTIONS(4579),
    [anon_sym_PIPE] = ACTIONS(4584),
    [anon_sym_CARET] = ACTIONS(4584),
    [anon_sym_AMP] = ACTIONS(4586),
    [anon_sym_EQ_EQ] = ACTIONS(4577),
    [anon_sym_BANG_EQ] = ACTIONS(4577),
    [anon_sym_GT] = ACTIONS(4584),
    [anon_sym_GT_EQ] = ACTIONS(4577),
    [anon_sym_LT_EQ] = ACTIONS(4584),
    [anon_sym_LT] = ACTIONS(4584),
    [anon_sym_LT_LT] = ACTIONS(4584),
    [anon_sym_GT_GT] = ACTIONS(4584),
    [anon_sym_SEMI] = ACTIONS(4577),
    [anon_sym___extension__] = ACTIONS(4582),
    [anon_sym_COLON_COLON] = ACTIONS(4582),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4577),
    [anon_sym_LBRACE] = ACTIONS(4582),
    [anon_sym_LBRACK] = ACTIONS(4586),
    [anon_sym_EQ] = ACTIONS(4584),
    [anon_sym_const] = ACTIONS(4575),
    [anon_sym_constexpr] = ACTIONS(4582),
    [anon_sym_volatile] = ACTIONS(4582),
    [anon_sym_restrict] = ACTIONS(4582),
    [anon_sym___restrict__] = ACTIONS(4582),
    [anon_sym__Atomic] = ACTIONS(4582),
    [anon_sym__Noreturn] = ACTIONS(4582),
    [anon_sym_noreturn] = ACTIONS(4582),
    [anon_sym_mutable] = ACTIONS(4582),
    [anon_sym_constinit] = ACTIONS(4582),
    [anon_sym_consteval] = ACTIONS(4582),
    [anon_sym_PROGMEM] = ACTIONS(4582),
    [anon_sym_QMARK] = ACTIONS(4577),
    [anon_sym_STAR_EQ] = ACTIONS(4577),
    [anon_sym_SLASH_EQ] = ACTIONS(4577),
    [anon_sym_PERCENT_EQ] = ACTIONS(4577),
    [anon_sym_PLUS_EQ] = ACTIONS(4577),
    [anon_sym_DASH_EQ] = ACTIONS(4577),
    [anon_sym_LT_LT_EQ] = ACTIONS(4577),
    [anon_sym_GT_GT_EQ] = ACTIONS(4577),
    [anon_sym_AMP_EQ] = ACTIONS(4577),
    [anon_sym_CARET_EQ] = ACTIONS(4577),
    [anon_sym_PIPE_EQ] = ACTIONS(4577),
    [anon_sym_and_eq] = ACTIONS(4577),
    [anon_sym_or_eq] = ACTIONS(4577),
    [anon_sym_xor_eq] = ACTIONS(4577),
    [anon_sym_LT_EQ_GT] = ACTIONS(4577),
    [anon_sym_or] = ACTIONS(4584),
    [anon_sym_and] = ACTIONS(4584),
    [anon_sym_bitor] = ACTIONS(4577),
    [anon_sym_xor] = ACTIONS(4584),
    [anon_sym_bitand] = ACTIONS(4577),
    [anon_sym_not_eq] = ACTIONS(4577),
    [anon_sym_DASH_DASH] = ACTIONS(4577),
    [anon_sym_PLUS_PLUS] = ACTIONS(4577),
    [anon_sym_DOT] = ACTIONS(4584),
    [anon_sym_DOT_STAR] = ACTIONS(4577),
    [anon_sym_DASH_GT] = ACTIONS(4584),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4582),
    [anon_sym_decltype] = ACTIONS(4582),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4577),
  },
  [1829] = {
    [sym_decltype_auto] = STATE(1988),
    [sym_identifier] = ACTIONS(4871),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4873),
    [anon_sym_COMMA] = ACTIONS(4873),
    [anon_sym_RPAREN] = ACTIONS(4873),
    [anon_sym_LPAREN2] = ACTIONS(4873),
    [anon_sym_DASH] = ACTIONS(4871),
    [anon_sym_PLUS] = ACTIONS(4871),
    [anon_sym_STAR] = ACTIONS(4873),
    [anon_sym_SLASH] = ACTIONS(4871),
    [anon_sym_PERCENT] = ACTIONS(4873),
    [anon_sym_PIPE_PIPE] = ACTIONS(4873),
    [anon_sym_AMP_AMP] = ACTIONS(4873),
    [anon_sym_PIPE] = ACTIONS(4871),
    [anon_sym_CARET] = ACTIONS(4873),
    [anon_sym_AMP] = ACTIONS(4871),
    [anon_sym_EQ_EQ] = ACTIONS(4873),
    [anon_sym_BANG_EQ] = ACTIONS(4873),
    [anon_sym_GT] = ACTIONS(4871),
    [anon_sym_GT_EQ] = ACTIONS(4873),
    [anon_sym_LT_EQ] = ACTIONS(4871),
    [anon_sym_LT] = ACTIONS(4871),
    [anon_sym_LT_LT] = ACTIONS(4873),
    [anon_sym_GT_GT] = ACTIONS(4873),
    [anon_sym_SEMI] = ACTIONS(4873),
    [anon_sym___extension__] = ACTIONS(4871),
    [anon_sym___attribute__] = ACTIONS(4871),
    [anon_sym___based] = ACTIONS(4871),
    [anon_sym_LBRACE] = ACTIONS(4873),
    [anon_sym_RBRACE] = ACTIONS(4873),
    [anon_sym_signed] = ACTIONS(4871),
    [anon_sym_unsigned] = ACTIONS(4871),
    [anon_sym_long] = ACTIONS(4871),
    [anon_sym_short] = ACTIONS(4871),
    [anon_sym_LBRACK] = ACTIONS(4873),
    [anon_sym_RBRACK] = ACTIONS(4873),
    [anon_sym_const] = ACTIONS(4871),
    [anon_sym_constexpr] = ACTIONS(4871),
    [anon_sym_volatile] = ACTIONS(4871),
    [anon_sym_restrict] = ACTIONS(4871),
    [anon_sym___restrict__] = ACTIONS(4871),
    [anon_sym__Atomic] = ACTIONS(4871),
    [anon_sym__Noreturn] = ACTIONS(4871),
    [anon_sym_noreturn] = ACTIONS(4871),
    [anon_sym_mutable] = ACTIONS(4871),
    [anon_sym_constinit] = ACTIONS(4871),
    [anon_sym_consteval] = ACTIONS(4871),
    [anon_sym_PROGMEM] = ACTIONS(4871),
    [aux_sym_primitive_type_token1] = ACTIONS(4871),
    [anon_sym_byte] = ACTIONS(4871),
    [anon_sym_word] = ACTIONS(4871),
    [anon_sym_COLON] = ACTIONS(4873),
    [anon_sym_QMARK] = ACTIONS(4873),
    [anon_sym_LT_EQ_GT] = ACTIONS(4873),
    [anon_sym_or] = ACTIONS(4871),
    [anon_sym_and] = ACTIONS(4871),
    [anon_sym_bitor] = ACTIONS(4871),
    [anon_sym_xor] = ACTIONS(4871),
    [anon_sym_bitand] = ACTIONS(4871),
    [anon_sym_not_eq] = ACTIONS(4871),
    [anon_sym_DASH_DASH] = ACTIONS(4873),
    [anon_sym_PLUS_PLUS] = ACTIONS(4873),
    [anon_sym_DOT] = ACTIONS(4871),
    [anon_sym_DOT_STAR] = ACTIONS(4873),
    [anon_sym_DASH_GT] = ACTIONS(4873),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4875),
    [anon_sym_decltype] = ACTIONS(4877),
    [anon_sym_final] = ACTIONS(4871),
    [anon_sym_override] = ACTIONS(4871),
    [anon_sym_requires] = ACTIONS(4871),
  },
  [1830] = {
    [sym_identifier] = ACTIONS(2945),
    [aux_sym_preproc_def_token1] = ACTIONS(2945),
    [aux_sym_preproc_if_token1] = ACTIONS(2945),
    [aux_sym_preproc_if_token2] = ACTIONS(2945),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2945),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2945),
    [aux_sym_preproc_else_token1] = ACTIONS(2945),
    [aux_sym_preproc_elif_token1] = ACTIONS(2945),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2945),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2945),
    [sym_preproc_directive] = ACTIONS(2945),
    [anon_sym_LPAREN2] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2947),
    [anon_sym_STAR] = ACTIONS(2947),
    [anon_sym_AMP_AMP] = ACTIONS(2947),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym___extension__] = ACTIONS(2945),
    [anon_sym_typedef] = ACTIONS(2945),
    [anon_sym_extern] = ACTIONS(2945),
    [anon_sym___attribute__] = ACTIONS(2945),
    [anon_sym_COLON_COLON] = ACTIONS(2947),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2947),
    [anon_sym___declspec] = ACTIONS(2945),
    [anon_sym___based] = ACTIONS(2945),
    [anon_sym_signed] = ACTIONS(2945),
    [anon_sym_unsigned] = ACTIONS(2945),
    [anon_sym_long] = ACTIONS(2945),
    [anon_sym_short] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(2945),
    [anon_sym_static] = ACTIONS(2945),
    [anon_sym_register] = ACTIONS(2945),
    [anon_sym_inline] = ACTIONS(2945),
    [anon_sym___inline] = ACTIONS(2945),
    [anon_sym___inline__] = ACTIONS(2945),
    [anon_sym___forceinline] = ACTIONS(2945),
    [anon_sym_thread_local] = ACTIONS(2945),
    [anon_sym___thread] = ACTIONS(2945),
    [anon_sym_const] = ACTIONS(2945),
    [anon_sym_constexpr] = ACTIONS(2945),
    [anon_sym_volatile] = ACTIONS(2945),
    [anon_sym_restrict] = ACTIONS(2945),
    [anon_sym___restrict__] = ACTIONS(2945),
    [anon_sym__Atomic] = ACTIONS(2945),
    [anon_sym__Noreturn] = ACTIONS(2945),
    [anon_sym_noreturn] = ACTIONS(2945),
    [anon_sym_mutable] = ACTIONS(2945),
    [anon_sym_constinit] = ACTIONS(2945),
    [anon_sym_consteval] = ACTIONS(2945),
    [anon_sym_PROGMEM] = ACTIONS(2945),
    [aux_sym_primitive_type_token1] = ACTIONS(2945),
    [anon_sym_byte] = ACTIONS(2945),
    [anon_sym_word] = ACTIONS(2945),
    [anon_sym_enum] = ACTIONS(2945),
    [anon_sym_class] = ACTIONS(2945),
    [anon_sym_struct] = ACTIONS(2945),
    [anon_sym_union] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2945),
    [anon_sym_decltype] = ACTIONS(2945),
    [anon_sym_virtual] = ACTIONS(2945),
    [anon_sym_alignas] = ACTIONS(2945),
    [anon_sym_explicit] = ACTIONS(2945),
    [anon_sym_typename] = ACTIONS(2945),
    [anon_sym_template] = ACTIONS(2945),
    [anon_sym_operator] = ACTIONS(2945),
    [anon_sym_friend] = ACTIONS(2945),
    [anon_sym_public] = ACTIONS(2945),
    [anon_sym_private] = ACTIONS(2945),
    [anon_sym_protected] = ACTIONS(2945),
    [anon_sym_using] = ACTIONS(2945),
    [anon_sym_static_assert] = ACTIONS(2945),
  },
  [1831] = {
    [sym_identifier] = ACTIONS(2773),
    [aux_sym_preproc_def_token1] = ACTIONS(2773),
    [aux_sym_preproc_if_token1] = ACTIONS(2773),
    [aux_sym_preproc_if_token2] = ACTIONS(2773),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2773),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2773),
    [aux_sym_preproc_else_token1] = ACTIONS(2773),
    [aux_sym_preproc_elif_token1] = ACTIONS(2773),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2773),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2773),
    [sym_preproc_directive] = ACTIONS(2773),
    [anon_sym_LPAREN2] = ACTIONS(2775),
    [anon_sym_TILDE] = ACTIONS(2775),
    [anon_sym_STAR] = ACTIONS(2775),
    [anon_sym_AMP_AMP] = ACTIONS(2775),
    [anon_sym_AMP] = ACTIONS(2773),
    [anon_sym___extension__] = ACTIONS(2773),
    [anon_sym_typedef] = ACTIONS(2773),
    [anon_sym_extern] = ACTIONS(2773),
    [anon_sym___attribute__] = ACTIONS(2773),
    [anon_sym_COLON_COLON] = ACTIONS(2775),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2775),
    [anon_sym___declspec] = ACTIONS(2773),
    [anon_sym___based] = ACTIONS(2773),
    [anon_sym_signed] = ACTIONS(2773),
    [anon_sym_unsigned] = ACTIONS(2773),
    [anon_sym_long] = ACTIONS(2773),
    [anon_sym_short] = ACTIONS(2773),
    [anon_sym_LBRACK] = ACTIONS(2773),
    [anon_sym_static] = ACTIONS(2773),
    [anon_sym_register] = ACTIONS(2773),
    [anon_sym_inline] = ACTIONS(2773),
    [anon_sym___inline] = ACTIONS(2773),
    [anon_sym___inline__] = ACTIONS(2773),
    [anon_sym___forceinline] = ACTIONS(2773),
    [anon_sym_thread_local] = ACTIONS(2773),
    [anon_sym___thread] = ACTIONS(2773),
    [anon_sym_const] = ACTIONS(2773),
    [anon_sym_constexpr] = ACTIONS(2773),
    [anon_sym_volatile] = ACTIONS(2773),
    [anon_sym_restrict] = ACTIONS(2773),
    [anon_sym___restrict__] = ACTIONS(2773),
    [anon_sym__Atomic] = ACTIONS(2773),
    [anon_sym__Noreturn] = ACTIONS(2773),
    [anon_sym_noreturn] = ACTIONS(2773),
    [anon_sym_mutable] = ACTIONS(2773),
    [anon_sym_constinit] = ACTIONS(2773),
    [anon_sym_consteval] = ACTIONS(2773),
    [anon_sym_PROGMEM] = ACTIONS(2773),
    [aux_sym_primitive_type_token1] = ACTIONS(2773),
    [anon_sym_byte] = ACTIONS(2773),
    [anon_sym_word] = ACTIONS(2773),
    [anon_sym_enum] = ACTIONS(2773),
    [anon_sym_class] = ACTIONS(2773),
    [anon_sym_struct] = ACTIONS(2773),
    [anon_sym_union] = ACTIONS(2773),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2773),
    [anon_sym_decltype] = ACTIONS(2773),
    [anon_sym_virtual] = ACTIONS(2773),
    [anon_sym_alignas] = ACTIONS(2773),
    [anon_sym_explicit] = ACTIONS(2773),
    [anon_sym_typename] = ACTIONS(2773),
    [anon_sym_template] = ACTIONS(2773),
    [anon_sym_operator] = ACTIONS(2773),
    [anon_sym_friend] = ACTIONS(2773),
    [anon_sym_public] = ACTIONS(2773),
    [anon_sym_private] = ACTIONS(2773),
    [anon_sym_protected] = ACTIONS(2773),
    [anon_sym_using] = ACTIONS(2773),
    [anon_sym_static_assert] = ACTIONS(2773),
  },
  [1832] = {
    [sym_identifier] = ACTIONS(4530),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4532),
    [anon_sym_COMMA] = ACTIONS(4532),
    [anon_sym_RPAREN] = ACTIONS(4532),
    [anon_sym_LPAREN2] = ACTIONS(4532),
    [anon_sym_DASH] = ACTIONS(4530),
    [anon_sym_PLUS] = ACTIONS(4530),
    [anon_sym_STAR] = ACTIONS(4532),
    [anon_sym_SLASH] = ACTIONS(4530),
    [anon_sym_PERCENT] = ACTIONS(4532),
    [anon_sym_PIPE_PIPE] = ACTIONS(4532),
    [anon_sym_AMP_AMP] = ACTIONS(4532),
    [anon_sym_PIPE] = ACTIONS(4530),
    [anon_sym_CARET] = ACTIONS(4532),
    [anon_sym_AMP] = ACTIONS(4530),
    [anon_sym_EQ_EQ] = ACTIONS(4532),
    [anon_sym_BANG_EQ] = ACTIONS(4532),
    [anon_sym_GT] = ACTIONS(4530),
    [anon_sym_GT_EQ] = ACTIONS(4532),
    [anon_sym_LT_EQ] = ACTIONS(4530),
    [anon_sym_LT] = ACTIONS(4530),
    [anon_sym_LT_LT] = ACTIONS(4532),
    [anon_sym_GT_GT] = ACTIONS(4532),
    [anon_sym_SEMI] = ACTIONS(4532),
    [anon_sym___extension__] = ACTIONS(4530),
    [anon_sym___attribute__] = ACTIONS(4530),
    [anon_sym_COLON_COLON] = ACTIONS(4532),
    [anon_sym___based] = ACTIONS(4530),
    [anon_sym_LBRACE] = ACTIONS(4532),
    [anon_sym_RBRACE] = ACTIONS(4532),
    [anon_sym_signed] = ACTIONS(4530),
    [anon_sym_unsigned] = ACTIONS(4530),
    [anon_sym_long] = ACTIONS(4530),
    [anon_sym_short] = ACTIONS(4530),
    [anon_sym_LBRACK] = ACTIONS(4532),
    [anon_sym_RBRACK] = ACTIONS(4532),
    [anon_sym_const] = ACTIONS(4530),
    [anon_sym_constexpr] = ACTIONS(4530),
    [anon_sym_volatile] = ACTIONS(4530),
    [anon_sym_restrict] = ACTIONS(4530),
    [anon_sym___restrict__] = ACTIONS(4530),
    [anon_sym__Atomic] = ACTIONS(4530),
    [anon_sym__Noreturn] = ACTIONS(4530),
    [anon_sym_noreturn] = ACTIONS(4530),
    [anon_sym_mutable] = ACTIONS(4530),
    [anon_sym_constinit] = ACTIONS(4530),
    [anon_sym_consteval] = ACTIONS(4530),
    [anon_sym_PROGMEM] = ACTIONS(4530),
    [aux_sym_primitive_type_token1] = ACTIONS(4530),
    [anon_sym_byte] = ACTIONS(4530),
    [anon_sym_word] = ACTIONS(4530),
    [anon_sym_COLON] = ACTIONS(4530),
    [anon_sym_QMARK] = ACTIONS(4532),
    [anon_sym_LT_EQ_GT] = ACTIONS(4532),
    [anon_sym_or] = ACTIONS(4530),
    [anon_sym_and] = ACTIONS(4530),
    [anon_sym_bitor] = ACTIONS(4530),
    [anon_sym_xor] = ACTIONS(4530),
    [anon_sym_bitand] = ACTIONS(4530),
    [anon_sym_not_eq] = ACTIONS(4530),
    [anon_sym_DASH_DASH] = ACTIONS(4532),
    [anon_sym_PLUS_PLUS] = ACTIONS(4532),
    [anon_sym_DOT] = ACTIONS(4530),
    [anon_sym_DOT_STAR] = ACTIONS(4532),
    [anon_sym_DASH_GT] = ACTIONS(4532),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4530),
    [anon_sym_decltype] = ACTIONS(4530),
    [anon_sym_final] = ACTIONS(4530),
    [anon_sym_override] = ACTIONS(4530),
    [anon_sym_requires] = ACTIONS(4530),
  },
  [1833] = {
    [sym_identifier] = ACTIONS(3468),
    [aux_sym_preproc_def_token1] = ACTIONS(3468),
    [aux_sym_preproc_if_token1] = ACTIONS(3468),
    [aux_sym_preproc_if_token2] = ACTIONS(3468),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3468),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3468),
    [aux_sym_preproc_else_token1] = ACTIONS(3468),
    [aux_sym_preproc_elif_token1] = ACTIONS(3468),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3468),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3468),
    [sym_preproc_directive] = ACTIONS(3468),
    [anon_sym_LPAREN2] = ACTIONS(3466),
    [anon_sym_TILDE] = ACTIONS(3466),
    [anon_sym_STAR] = ACTIONS(3466),
    [anon_sym_AMP_AMP] = ACTIONS(3466),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym___extension__] = ACTIONS(3468),
    [anon_sym_typedef] = ACTIONS(3468),
    [anon_sym_extern] = ACTIONS(3468),
    [anon_sym___attribute__] = ACTIONS(3468),
    [anon_sym_COLON_COLON] = ACTIONS(3466),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3466),
    [anon_sym___declspec] = ACTIONS(3468),
    [anon_sym___based] = ACTIONS(3468),
    [anon_sym_signed] = ACTIONS(3468),
    [anon_sym_unsigned] = ACTIONS(3468),
    [anon_sym_long] = ACTIONS(3468),
    [anon_sym_short] = ACTIONS(3468),
    [anon_sym_LBRACK] = ACTIONS(3468),
    [anon_sym_static] = ACTIONS(3468),
    [anon_sym_register] = ACTIONS(3468),
    [anon_sym_inline] = ACTIONS(3468),
    [anon_sym___inline] = ACTIONS(3468),
    [anon_sym___inline__] = ACTIONS(3468),
    [anon_sym___forceinline] = ACTIONS(3468),
    [anon_sym_thread_local] = ACTIONS(3468),
    [anon_sym___thread] = ACTIONS(3468),
    [anon_sym_const] = ACTIONS(3468),
    [anon_sym_constexpr] = ACTIONS(3468),
    [anon_sym_volatile] = ACTIONS(3468),
    [anon_sym_restrict] = ACTIONS(3468),
    [anon_sym___restrict__] = ACTIONS(3468),
    [anon_sym__Atomic] = ACTIONS(3468),
    [anon_sym__Noreturn] = ACTIONS(3468),
    [anon_sym_noreturn] = ACTIONS(3468),
    [anon_sym_mutable] = ACTIONS(3468),
    [anon_sym_constinit] = ACTIONS(3468),
    [anon_sym_consteval] = ACTIONS(3468),
    [anon_sym_PROGMEM] = ACTIONS(3468),
    [aux_sym_primitive_type_token1] = ACTIONS(3468),
    [anon_sym_byte] = ACTIONS(3468),
    [anon_sym_word] = ACTIONS(3468),
    [anon_sym_enum] = ACTIONS(3468),
    [anon_sym_class] = ACTIONS(3468),
    [anon_sym_struct] = ACTIONS(3468),
    [anon_sym_union] = ACTIONS(3468),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3468),
    [anon_sym_decltype] = ACTIONS(3468),
    [anon_sym_virtual] = ACTIONS(3468),
    [anon_sym_alignas] = ACTIONS(3468),
    [anon_sym_explicit] = ACTIONS(3468),
    [anon_sym_typename] = ACTIONS(3468),
    [anon_sym_template] = ACTIONS(3468),
    [anon_sym_operator] = ACTIONS(3468),
    [anon_sym_friend] = ACTIONS(3468),
    [anon_sym_public] = ACTIONS(3468),
    [anon_sym_private] = ACTIONS(3468),
    [anon_sym_protected] = ACTIONS(3468),
    [anon_sym_using] = ACTIONS(3468),
    [anon_sym_static_assert] = ACTIONS(3468),
  },
  [1834] = {
    [sym_string_literal] = STATE(2617),
    [sym_template_argument_list] = STATE(3723),
    [sym_raw_string_literal] = STATE(2617),
    [sym_identifier] = ACTIONS(3769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3761),
    [anon_sym_COMMA] = ACTIONS(3761),
    [aux_sym_preproc_if_token2] = ACTIONS(3761),
    [aux_sym_preproc_else_token1] = ACTIONS(3761),
    [aux_sym_preproc_elif_token1] = ACTIONS(3769),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3761),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3761),
    [anon_sym_LPAREN2] = ACTIONS(3761),
    [anon_sym_DASH] = ACTIONS(3769),
    [anon_sym_PLUS] = ACTIONS(3769),
    [anon_sym_STAR] = ACTIONS(3769),
    [anon_sym_SLASH] = ACTIONS(3769),
    [anon_sym_PERCENT] = ACTIONS(3769),
    [anon_sym_PIPE_PIPE] = ACTIONS(3761),
    [anon_sym_AMP_AMP] = ACTIONS(3761),
    [anon_sym_PIPE] = ACTIONS(3769),
    [anon_sym_CARET] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(3769),
    [anon_sym_EQ_EQ] = ACTIONS(3761),
    [anon_sym_BANG_EQ] = ACTIONS(3761),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3761),
    [anon_sym_LT_EQ] = ACTIONS(3769),
    [anon_sym_LT] = ACTIONS(4879),
    [anon_sym_LT_LT] = ACTIONS(3769),
    [anon_sym_GT_GT] = ACTIONS(3769),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(3785),
    [anon_sym_LBRACK] = ACTIONS(3761),
    [anon_sym_EQ] = ACTIONS(4882),
    [anon_sym_QMARK] = ACTIONS(3761),
    [anon_sym_STAR_EQ] = ACTIONS(4884),
    [anon_sym_SLASH_EQ] = ACTIONS(4884),
    [anon_sym_PERCENT_EQ] = ACTIONS(4884),
    [anon_sym_PLUS_EQ] = ACTIONS(4884),
    [anon_sym_DASH_EQ] = ACTIONS(4884),
    [anon_sym_LT_LT_EQ] = ACTIONS(4884),
    [anon_sym_GT_GT_EQ] = ACTIONS(4884),
    [anon_sym_AMP_EQ] = ACTIONS(4884),
    [anon_sym_CARET_EQ] = ACTIONS(4884),
    [anon_sym_PIPE_EQ] = ACTIONS(4884),
    [anon_sym_and_eq] = ACTIONS(4882),
    [anon_sym_or_eq] = ACTIONS(4882),
    [anon_sym_xor_eq] = ACTIONS(4882),
    [anon_sym_LT_EQ_GT] = ACTIONS(3761),
    [anon_sym_or] = ACTIONS(3769),
    [anon_sym_and] = ACTIONS(3769),
    [anon_sym_bitor] = ACTIONS(3769),
    [anon_sym_xor] = ACTIONS(3769),
    [anon_sym_bitand] = ACTIONS(3769),
    [anon_sym_not_eq] = ACTIONS(3769),
    [anon_sym_DASH_DASH] = ACTIONS(3761),
    [anon_sym_PLUS_PLUS] = ACTIONS(3761),
    [anon_sym_DOT] = ACTIONS(3769),
    [anon_sym_DOT_STAR] = ACTIONS(3761),
    [anon_sym_DASH_GT] = ACTIONS(3761),
    [anon_sym_L_DQUOTE] = ACTIONS(3204),
    [anon_sym_u_DQUOTE] = ACTIONS(3204),
    [anon_sym_U_DQUOTE] = ACTIONS(3204),
    [anon_sym_u8_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3204),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3208),
    [anon_sym_LR_DQUOTE] = ACTIONS(3208),
    [anon_sym_uR_DQUOTE] = ACTIONS(3208),
    [anon_sym_UR_DQUOTE] = ACTIONS(3208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3208),
  },
  [1835] = {
    [sym_identifier] = ACTIONS(2925),
    [aux_sym_preproc_def_token1] = ACTIONS(2925),
    [aux_sym_preproc_if_token1] = ACTIONS(2925),
    [aux_sym_preproc_if_token2] = ACTIONS(2925),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2925),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2925),
    [aux_sym_preproc_else_token1] = ACTIONS(2925),
    [aux_sym_preproc_elif_token1] = ACTIONS(2925),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2925),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2925),
    [sym_preproc_directive] = ACTIONS(2925),
    [anon_sym_LPAREN2] = ACTIONS(2927),
    [anon_sym_TILDE] = ACTIONS(2927),
    [anon_sym_STAR] = ACTIONS(2927),
    [anon_sym_AMP_AMP] = ACTIONS(2927),
    [anon_sym_AMP] = ACTIONS(2925),
    [anon_sym___extension__] = ACTIONS(2925),
    [anon_sym_typedef] = ACTIONS(2925),
    [anon_sym_extern] = ACTIONS(2925),
    [anon_sym___attribute__] = ACTIONS(2925),
    [anon_sym_COLON_COLON] = ACTIONS(2927),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2927),
    [anon_sym___declspec] = ACTIONS(2925),
    [anon_sym___based] = ACTIONS(2925),
    [anon_sym_signed] = ACTIONS(2925),
    [anon_sym_unsigned] = ACTIONS(2925),
    [anon_sym_long] = ACTIONS(2925),
    [anon_sym_short] = ACTIONS(2925),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_static] = ACTIONS(2925),
    [anon_sym_register] = ACTIONS(2925),
    [anon_sym_inline] = ACTIONS(2925),
    [anon_sym___inline] = ACTIONS(2925),
    [anon_sym___inline__] = ACTIONS(2925),
    [anon_sym___forceinline] = ACTIONS(2925),
    [anon_sym_thread_local] = ACTIONS(2925),
    [anon_sym___thread] = ACTIONS(2925),
    [anon_sym_const] = ACTIONS(2925),
    [anon_sym_constexpr] = ACTIONS(2925),
    [anon_sym_volatile] = ACTIONS(2925),
    [anon_sym_restrict] = ACTIONS(2925),
    [anon_sym___restrict__] = ACTIONS(2925),
    [anon_sym__Atomic] = ACTIONS(2925),
    [anon_sym__Noreturn] = ACTIONS(2925),
    [anon_sym_noreturn] = ACTIONS(2925),
    [anon_sym_mutable] = ACTIONS(2925),
    [anon_sym_constinit] = ACTIONS(2925),
    [anon_sym_consteval] = ACTIONS(2925),
    [anon_sym_PROGMEM] = ACTIONS(2925),
    [aux_sym_primitive_type_token1] = ACTIONS(2925),
    [anon_sym_byte] = ACTIONS(2925),
    [anon_sym_word] = ACTIONS(2925),
    [anon_sym_enum] = ACTIONS(2925),
    [anon_sym_class] = ACTIONS(2925),
    [anon_sym_struct] = ACTIONS(2925),
    [anon_sym_union] = ACTIONS(2925),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2925),
    [anon_sym_decltype] = ACTIONS(2925),
    [anon_sym_virtual] = ACTIONS(2925),
    [anon_sym_alignas] = ACTIONS(2925),
    [anon_sym_explicit] = ACTIONS(2925),
    [anon_sym_typename] = ACTIONS(2925),
    [anon_sym_template] = ACTIONS(2925),
    [anon_sym_operator] = ACTIONS(2925),
    [anon_sym_friend] = ACTIONS(2925),
    [anon_sym_public] = ACTIONS(2925),
    [anon_sym_private] = ACTIONS(2925),
    [anon_sym_protected] = ACTIONS(2925),
    [anon_sym_using] = ACTIONS(2925),
    [anon_sym_static_assert] = ACTIONS(2925),
  },
  [1836] = {
    [sym_identifier] = ACTIONS(3472),
    [aux_sym_preproc_def_token1] = ACTIONS(3472),
    [aux_sym_preproc_if_token1] = ACTIONS(3472),
    [aux_sym_preproc_if_token2] = ACTIONS(3472),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3472),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3472),
    [aux_sym_preproc_else_token1] = ACTIONS(3472),
    [aux_sym_preproc_elif_token1] = ACTIONS(3472),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3472),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3472),
    [sym_preproc_directive] = ACTIONS(3472),
    [anon_sym_LPAREN2] = ACTIONS(3470),
    [anon_sym_TILDE] = ACTIONS(3470),
    [anon_sym_STAR] = ACTIONS(3470),
    [anon_sym_AMP_AMP] = ACTIONS(3470),
    [anon_sym_AMP] = ACTIONS(3472),
    [anon_sym___extension__] = ACTIONS(3472),
    [anon_sym_typedef] = ACTIONS(3472),
    [anon_sym_extern] = ACTIONS(3472),
    [anon_sym___attribute__] = ACTIONS(3472),
    [anon_sym_COLON_COLON] = ACTIONS(3470),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3470),
    [anon_sym___declspec] = ACTIONS(3472),
    [anon_sym___based] = ACTIONS(3472),
    [anon_sym_signed] = ACTIONS(3472),
    [anon_sym_unsigned] = ACTIONS(3472),
    [anon_sym_long] = ACTIONS(3472),
    [anon_sym_short] = ACTIONS(3472),
    [anon_sym_LBRACK] = ACTIONS(3472),
    [anon_sym_static] = ACTIONS(3472),
    [anon_sym_register] = ACTIONS(3472),
    [anon_sym_inline] = ACTIONS(3472),
    [anon_sym___inline] = ACTIONS(3472),
    [anon_sym___inline__] = ACTIONS(3472),
    [anon_sym___forceinline] = ACTIONS(3472),
    [anon_sym_thread_local] = ACTIONS(3472),
    [anon_sym___thread] = ACTIONS(3472),
    [anon_sym_const] = ACTIONS(3472),
    [anon_sym_constexpr] = ACTIONS(3472),
    [anon_sym_volatile] = ACTIONS(3472),
    [anon_sym_restrict] = ACTIONS(3472),
    [anon_sym___restrict__] = ACTIONS(3472),
    [anon_sym__Atomic] = ACTIONS(3472),
    [anon_sym__Noreturn] = ACTIONS(3472),
    [anon_sym_noreturn] = ACTIONS(3472),
    [anon_sym_mutable] = ACTIONS(3472),
    [anon_sym_constinit] = ACTIONS(3472),
    [anon_sym_consteval] = ACTIONS(3472),
    [anon_sym_PROGMEM] = ACTIONS(3472),
    [aux_sym_primitive_type_token1] = ACTIONS(3472),
    [anon_sym_byte] = ACTIONS(3472),
    [anon_sym_word] = ACTIONS(3472),
    [anon_sym_enum] = ACTIONS(3472),
    [anon_sym_class] = ACTIONS(3472),
    [anon_sym_struct] = ACTIONS(3472),
    [anon_sym_union] = ACTIONS(3472),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3472),
    [anon_sym_decltype] = ACTIONS(3472),
    [anon_sym_virtual] = ACTIONS(3472),
    [anon_sym_alignas] = ACTIONS(3472),
    [anon_sym_explicit] = ACTIONS(3472),
    [anon_sym_typename] = ACTIONS(3472),
    [anon_sym_template] = ACTIONS(3472),
    [anon_sym_operator] = ACTIONS(3472),
    [anon_sym_friend] = ACTIONS(3472),
    [anon_sym_public] = ACTIONS(3472),
    [anon_sym_private] = ACTIONS(3472),
    [anon_sym_protected] = ACTIONS(3472),
    [anon_sym_using] = ACTIONS(3472),
    [anon_sym_static_assert] = ACTIONS(3472),
  },
  [1837] = {
    [sym__declaration_modifiers] = STATE(1964),
    [sym__declaration_specifiers] = STATE(5157),
    [sym_attribute_specifier] = STATE(1964),
    [sym_attribute_declaration] = STATE(1964),
    [sym_ms_declspec_modifier] = STATE(1964),
    [sym_storage_class_specifier] = STATE(1964),
    [sym_type_qualifier] = STATE(1964),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(1964),
    [sym_alignas_specifier] = STATE(1964),
    [sym_dependent_type] = STATE(2629),
    [sym_template_type] = STATE(2618),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(6346),
    [sym_qualified_type_identifier] = STATE(3260),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [sym_identifier] = ACTIONS(4625),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4627),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1419),
  },
  [1838] = {
    [sym__declaration_modifiers] = STATE(3458),
    [sym_attribute_specifier] = STATE(3458),
    [sym_attribute_declaration] = STATE(3458),
    [sym_ms_declspec_modifier] = STATE(3458),
    [sym_ms_based_modifier] = STATE(8318),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(5941),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3458),
    [sym_type_qualifier] = STATE(3458),
    [sym_decltype] = STATE(8290),
    [sym_virtual] = STATE(3458),
    [sym_alignas_specifier] = STATE(3458),
    [sym_explicit_function_specifier] = STATE(3458),
    [sym_operator_cast] = STATE(6537),
    [sym__constructor_specifiers] = STATE(3458),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(8290),
    [sym_template_function] = STATE(6098),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5430),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_operator_cast_identifier] = STATE(6537),
    [sym_operator_name] = STATE(6098),
    [aux_sym_operator_cast_definition_repeat1] = STATE(3458),
    [sym_identifier] = ACTIONS(4841),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(4843),
    [anon_sym_extern] = ACTIONS(4845),
    [anon_sym___attribute__] = ACTIONS(4847),
    [anon_sym_COLON_COLON] = ACTIONS(4849),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4851),
    [anon_sym___declspec] = ACTIONS(4853),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(4845),
    [anon_sym_register] = ACTIONS(4845),
    [anon_sym_inline] = ACTIONS(4845),
    [anon_sym___inline] = ACTIONS(4845),
    [anon_sym___inline__] = ACTIONS(4845),
    [anon_sym___forceinline] = ACTIONS(4845),
    [anon_sym_thread_local] = ACTIONS(4845),
    [anon_sym___thread] = ACTIONS(4845),
    [anon_sym_const] = ACTIONS(4843),
    [anon_sym_constexpr] = ACTIONS(4843),
    [anon_sym_volatile] = ACTIONS(4843),
    [anon_sym_restrict] = ACTIONS(4843),
    [anon_sym___restrict__] = ACTIONS(4843),
    [anon_sym__Atomic] = ACTIONS(4843),
    [anon_sym__Noreturn] = ACTIONS(4843),
    [anon_sym_noreturn] = ACTIONS(4843),
    [anon_sym_mutable] = ACTIONS(4843),
    [anon_sym_constinit] = ACTIONS(4843),
    [anon_sym_consteval] = ACTIONS(4843),
    [anon_sym_PROGMEM] = ACTIONS(4843),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_virtual] = ACTIONS(4855),
    [anon_sym_alignas] = ACTIONS(4857),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_operator] = ACTIONS(133),
  },
  [1839] = {
    [sym_identifier] = ACTIONS(2731),
    [aux_sym_preproc_def_token1] = ACTIONS(2731),
    [aux_sym_preproc_if_token1] = ACTIONS(2731),
    [aux_sym_preproc_if_token2] = ACTIONS(2731),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2731),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2731),
    [aux_sym_preproc_else_token1] = ACTIONS(2731),
    [aux_sym_preproc_elif_token1] = ACTIONS(2731),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2731),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2731),
    [sym_preproc_directive] = ACTIONS(2731),
    [anon_sym_LPAREN2] = ACTIONS(2733),
    [anon_sym_TILDE] = ACTIONS(2733),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_AMP_AMP] = ACTIONS(2733),
    [anon_sym_AMP] = ACTIONS(2731),
    [anon_sym___extension__] = ACTIONS(2731),
    [anon_sym_typedef] = ACTIONS(2731),
    [anon_sym_extern] = ACTIONS(2731),
    [anon_sym___attribute__] = ACTIONS(2731),
    [anon_sym_COLON_COLON] = ACTIONS(2733),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2733),
    [anon_sym___declspec] = ACTIONS(2731),
    [anon_sym___based] = ACTIONS(2731),
    [anon_sym_signed] = ACTIONS(2731),
    [anon_sym_unsigned] = ACTIONS(2731),
    [anon_sym_long] = ACTIONS(2731),
    [anon_sym_short] = ACTIONS(2731),
    [anon_sym_LBRACK] = ACTIONS(2731),
    [anon_sym_static] = ACTIONS(2731),
    [anon_sym_register] = ACTIONS(2731),
    [anon_sym_inline] = ACTIONS(2731),
    [anon_sym___inline] = ACTIONS(2731),
    [anon_sym___inline__] = ACTIONS(2731),
    [anon_sym___forceinline] = ACTIONS(2731),
    [anon_sym_thread_local] = ACTIONS(2731),
    [anon_sym___thread] = ACTIONS(2731),
    [anon_sym_const] = ACTIONS(2731),
    [anon_sym_constexpr] = ACTIONS(2731),
    [anon_sym_volatile] = ACTIONS(2731),
    [anon_sym_restrict] = ACTIONS(2731),
    [anon_sym___restrict__] = ACTIONS(2731),
    [anon_sym__Atomic] = ACTIONS(2731),
    [anon_sym__Noreturn] = ACTIONS(2731),
    [anon_sym_noreturn] = ACTIONS(2731),
    [anon_sym_mutable] = ACTIONS(2731),
    [anon_sym_constinit] = ACTIONS(2731),
    [anon_sym_consteval] = ACTIONS(2731),
    [anon_sym_PROGMEM] = ACTIONS(2731),
    [aux_sym_primitive_type_token1] = ACTIONS(2731),
    [anon_sym_byte] = ACTIONS(2731),
    [anon_sym_word] = ACTIONS(2731),
    [anon_sym_enum] = ACTIONS(2731),
    [anon_sym_class] = ACTIONS(2731),
    [anon_sym_struct] = ACTIONS(2731),
    [anon_sym_union] = ACTIONS(2731),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2731),
    [anon_sym_decltype] = ACTIONS(2731),
    [anon_sym_virtual] = ACTIONS(2731),
    [anon_sym_alignas] = ACTIONS(2731),
    [anon_sym_explicit] = ACTIONS(2731),
    [anon_sym_typename] = ACTIONS(2731),
    [anon_sym_template] = ACTIONS(2731),
    [anon_sym_operator] = ACTIONS(2731),
    [anon_sym_friend] = ACTIONS(2731),
    [anon_sym_public] = ACTIONS(2731),
    [anon_sym_private] = ACTIONS(2731),
    [anon_sym_protected] = ACTIONS(2731),
    [anon_sym_using] = ACTIONS(2731),
    [anon_sym_static_assert] = ACTIONS(2731),
  },
  [1840] = {
    [sym_identifier] = ACTIONS(2905),
    [aux_sym_preproc_def_token1] = ACTIONS(2905),
    [aux_sym_preproc_if_token1] = ACTIONS(2905),
    [aux_sym_preproc_if_token2] = ACTIONS(2905),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2905),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2905),
    [aux_sym_preproc_else_token1] = ACTIONS(2905),
    [aux_sym_preproc_elif_token1] = ACTIONS(2905),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2905),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2905),
    [sym_preproc_directive] = ACTIONS(2905),
    [anon_sym_LPAREN2] = ACTIONS(2907),
    [anon_sym_TILDE] = ACTIONS(2907),
    [anon_sym_STAR] = ACTIONS(2907),
    [anon_sym_AMP_AMP] = ACTIONS(2907),
    [anon_sym_AMP] = ACTIONS(2905),
    [anon_sym___extension__] = ACTIONS(2905),
    [anon_sym_typedef] = ACTIONS(2905),
    [anon_sym_extern] = ACTIONS(2905),
    [anon_sym___attribute__] = ACTIONS(2905),
    [anon_sym_COLON_COLON] = ACTIONS(2907),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2907),
    [anon_sym___declspec] = ACTIONS(2905),
    [anon_sym___based] = ACTIONS(2905),
    [anon_sym_signed] = ACTIONS(2905),
    [anon_sym_unsigned] = ACTIONS(2905),
    [anon_sym_long] = ACTIONS(2905),
    [anon_sym_short] = ACTIONS(2905),
    [anon_sym_LBRACK] = ACTIONS(2905),
    [anon_sym_static] = ACTIONS(2905),
    [anon_sym_register] = ACTIONS(2905),
    [anon_sym_inline] = ACTIONS(2905),
    [anon_sym___inline] = ACTIONS(2905),
    [anon_sym___inline__] = ACTIONS(2905),
    [anon_sym___forceinline] = ACTIONS(2905),
    [anon_sym_thread_local] = ACTIONS(2905),
    [anon_sym___thread] = ACTIONS(2905),
    [anon_sym_const] = ACTIONS(2905),
    [anon_sym_constexpr] = ACTIONS(2905),
    [anon_sym_volatile] = ACTIONS(2905),
    [anon_sym_restrict] = ACTIONS(2905),
    [anon_sym___restrict__] = ACTIONS(2905),
    [anon_sym__Atomic] = ACTIONS(2905),
    [anon_sym__Noreturn] = ACTIONS(2905),
    [anon_sym_noreturn] = ACTIONS(2905),
    [anon_sym_mutable] = ACTIONS(2905),
    [anon_sym_constinit] = ACTIONS(2905),
    [anon_sym_consteval] = ACTIONS(2905),
    [anon_sym_PROGMEM] = ACTIONS(2905),
    [aux_sym_primitive_type_token1] = ACTIONS(2905),
    [anon_sym_byte] = ACTIONS(2905),
    [anon_sym_word] = ACTIONS(2905),
    [anon_sym_enum] = ACTIONS(2905),
    [anon_sym_class] = ACTIONS(2905),
    [anon_sym_struct] = ACTIONS(2905),
    [anon_sym_union] = ACTIONS(2905),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2905),
    [anon_sym_decltype] = ACTIONS(2905),
    [anon_sym_virtual] = ACTIONS(2905),
    [anon_sym_alignas] = ACTIONS(2905),
    [anon_sym_explicit] = ACTIONS(2905),
    [anon_sym_typename] = ACTIONS(2905),
    [anon_sym_template] = ACTIONS(2905),
    [anon_sym_operator] = ACTIONS(2905),
    [anon_sym_friend] = ACTIONS(2905),
    [anon_sym_public] = ACTIONS(2905),
    [anon_sym_private] = ACTIONS(2905),
    [anon_sym_protected] = ACTIONS(2905),
    [anon_sym_using] = ACTIONS(2905),
    [anon_sym_static_assert] = ACTIONS(2905),
  },
  [1841] = {
    [sym_identifier] = ACTIONS(4886),
    [aux_sym_preproc_def_token1] = ACTIONS(4886),
    [aux_sym_preproc_if_token1] = ACTIONS(4886),
    [aux_sym_preproc_if_token2] = ACTIONS(4886),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4886),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4886),
    [aux_sym_preproc_else_token1] = ACTIONS(4886),
    [aux_sym_preproc_elif_token1] = ACTIONS(4886),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4886),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4886),
    [sym_preproc_directive] = ACTIONS(4886),
    [anon_sym_LPAREN2] = ACTIONS(4888),
    [anon_sym_TILDE] = ACTIONS(4888),
    [anon_sym_STAR] = ACTIONS(4888),
    [anon_sym_AMP_AMP] = ACTIONS(4888),
    [anon_sym_AMP] = ACTIONS(4886),
    [anon_sym___extension__] = ACTIONS(4886),
    [anon_sym_typedef] = ACTIONS(4886),
    [anon_sym_extern] = ACTIONS(4886),
    [anon_sym___attribute__] = ACTIONS(4886),
    [anon_sym_COLON_COLON] = ACTIONS(4888),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4888),
    [anon_sym___declspec] = ACTIONS(4886),
    [anon_sym___based] = ACTIONS(4886),
    [anon_sym_signed] = ACTIONS(4886),
    [anon_sym_unsigned] = ACTIONS(4886),
    [anon_sym_long] = ACTIONS(4886),
    [anon_sym_short] = ACTIONS(4886),
    [anon_sym_LBRACK] = ACTIONS(4886),
    [anon_sym_static] = ACTIONS(4886),
    [anon_sym_register] = ACTIONS(4886),
    [anon_sym_inline] = ACTIONS(4886),
    [anon_sym___inline] = ACTIONS(4886),
    [anon_sym___inline__] = ACTIONS(4886),
    [anon_sym___forceinline] = ACTIONS(4886),
    [anon_sym_thread_local] = ACTIONS(4886),
    [anon_sym___thread] = ACTIONS(4886),
    [anon_sym_const] = ACTIONS(4886),
    [anon_sym_constexpr] = ACTIONS(4886),
    [anon_sym_volatile] = ACTIONS(4886),
    [anon_sym_restrict] = ACTIONS(4886),
    [anon_sym___restrict__] = ACTIONS(4886),
    [anon_sym__Atomic] = ACTIONS(4886),
    [anon_sym__Noreturn] = ACTIONS(4886),
    [anon_sym_noreturn] = ACTIONS(4886),
    [anon_sym_mutable] = ACTIONS(4886),
    [anon_sym_constinit] = ACTIONS(4886),
    [anon_sym_consteval] = ACTIONS(4886),
    [anon_sym_PROGMEM] = ACTIONS(4886),
    [aux_sym_primitive_type_token1] = ACTIONS(4886),
    [anon_sym_byte] = ACTIONS(4886),
    [anon_sym_word] = ACTIONS(4886),
    [anon_sym_enum] = ACTIONS(4886),
    [anon_sym_class] = ACTIONS(4886),
    [anon_sym_struct] = ACTIONS(4886),
    [anon_sym_union] = ACTIONS(4886),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4886),
    [anon_sym_decltype] = ACTIONS(4886),
    [anon_sym_virtual] = ACTIONS(4886),
    [anon_sym_alignas] = ACTIONS(4886),
    [anon_sym_explicit] = ACTIONS(4886),
    [anon_sym_typename] = ACTIONS(4886),
    [anon_sym_template] = ACTIONS(4886),
    [anon_sym_operator] = ACTIONS(4886),
    [anon_sym_friend] = ACTIONS(4886),
    [anon_sym_public] = ACTIONS(4886),
    [anon_sym_private] = ACTIONS(4886),
    [anon_sym_protected] = ACTIONS(4886),
    [anon_sym_using] = ACTIONS(4886),
    [anon_sym_static_assert] = ACTIONS(4886),
  },
  [1842] = {
    [sym_identifier] = ACTIONS(4890),
    [aux_sym_preproc_def_token1] = ACTIONS(4890),
    [aux_sym_preproc_if_token1] = ACTIONS(4890),
    [aux_sym_preproc_if_token2] = ACTIONS(4890),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4890),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4890),
    [aux_sym_preproc_else_token1] = ACTIONS(4890),
    [aux_sym_preproc_elif_token1] = ACTIONS(4890),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4890),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4890),
    [sym_preproc_directive] = ACTIONS(4890),
    [anon_sym_LPAREN2] = ACTIONS(4892),
    [anon_sym_TILDE] = ACTIONS(4892),
    [anon_sym_STAR] = ACTIONS(4892),
    [anon_sym_AMP_AMP] = ACTIONS(4892),
    [anon_sym_AMP] = ACTIONS(4890),
    [anon_sym___extension__] = ACTIONS(4890),
    [anon_sym_typedef] = ACTIONS(4890),
    [anon_sym_extern] = ACTIONS(4890),
    [anon_sym___attribute__] = ACTIONS(4890),
    [anon_sym_COLON_COLON] = ACTIONS(4892),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4892),
    [anon_sym___declspec] = ACTIONS(4890),
    [anon_sym___based] = ACTIONS(4890),
    [anon_sym_signed] = ACTIONS(4890),
    [anon_sym_unsigned] = ACTIONS(4890),
    [anon_sym_long] = ACTIONS(4890),
    [anon_sym_short] = ACTIONS(4890),
    [anon_sym_LBRACK] = ACTIONS(4890),
    [anon_sym_static] = ACTIONS(4890),
    [anon_sym_register] = ACTIONS(4890),
    [anon_sym_inline] = ACTIONS(4890),
    [anon_sym___inline] = ACTIONS(4890),
    [anon_sym___inline__] = ACTIONS(4890),
    [anon_sym___forceinline] = ACTIONS(4890),
    [anon_sym_thread_local] = ACTIONS(4890),
    [anon_sym___thread] = ACTIONS(4890),
    [anon_sym_const] = ACTIONS(4890),
    [anon_sym_constexpr] = ACTIONS(4890),
    [anon_sym_volatile] = ACTIONS(4890),
    [anon_sym_restrict] = ACTIONS(4890),
    [anon_sym___restrict__] = ACTIONS(4890),
    [anon_sym__Atomic] = ACTIONS(4890),
    [anon_sym__Noreturn] = ACTIONS(4890),
    [anon_sym_noreturn] = ACTIONS(4890),
    [anon_sym_mutable] = ACTIONS(4890),
    [anon_sym_constinit] = ACTIONS(4890),
    [anon_sym_consteval] = ACTIONS(4890),
    [anon_sym_PROGMEM] = ACTIONS(4890),
    [aux_sym_primitive_type_token1] = ACTIONS(4890),
    [anon_sym_byte] = ACTIONS(4890),
    [anon_sym_word] = ACTIONS(4890),
    [anon_sym_enum] = ACTIONS(4890),
    [anon_sym_class] = ACTIONS(4890),
    [anon_sym_struct] = ACTIONS(4890),
    [anon_sym_union] = ACTIONS(4890),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4890),
    [anon_sym_decltype] = ACTIONS(4890),
    [anon_sym_virtual] = ACTIONS(4890),
    [anon_sym_alignas] = ACTIONS(4890),
    [anon_sym_explicit] = ACTIONS(4890),
    [anon_sym_typename] = ACTIONS(4890),
    [anon_sym_template] = ACTIONS(4890),
    [anon_sym_operator] = ACTIONS(4890),
    [anon_sym_friend] = ACTIONS(4890),
    [anon_sym_public] = ACTIONS(4890),
    [anon_sym_private] = ACTIONS(4890),
    [anon_sym_protected] = ACTIONS(4890),
    [anon_sym_using] = ACTIONS(4890),
    [anon_sym_static_assert] = ACTIONS(4890),
  },
  [1843] = {
    [sym_identifier] = ACTIONS(2901),
    [aux_sym_preproc_def_token1] = ACTIONS(2901),
    [aux_sym_preproc_if_token1] = ACTIONS(2901),
    [aux_sym_preproc_if_token2] = ACTIONS(2901),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2901),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2901),
    [aux_sym_preproc_else_token1] = ACTIONS(2901),
    [aux_sym_preproc_elif_token1] = ACTIONS(2901),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2901),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2901),
    [sym_preproc_directive] = ACTIONS(2901),
    [anon_sym_LPAREN2] = ACTIONS(2903),
    [anon_sym_TILDE] = ACTIONS(2903),
    [anon_sym_STAR] = ACTIONS(2903),
    [anon_sym_AMP_AMP] = ACTIONS(2903),
    [anon_sym_AMP] = ACTIONS(2901),
    [anon_sym___extension__] = ACTIONS(2901),
    [anon_sym_typedef] = ACTIONS(2901),
    [anon_sym_extern] = ACTIONS(2901),
    [anon_sym___attribute__] = ACTIONS(2901),
    [anon_sym_COLON_COLON] = ACTIONS(2903),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2903),
    [anon_sym___declspec] = ACTIONS(2901),
    [anon_sym___based] = ACTIONS(2901),
    [anon_sym_signed] = ACTIONS(2901),
    [anon_sym_unsigned] = ACTIONS(2901),
    [anon_sym_long] = ACTIONS(2901),
    [anon_sym_short] = ACTIONS(2901),
    [anon_sym_LBRACK] = ACTIONS(2901),
    [anon_sym_static] = ACTIONS(2901),
    [anon_sym_register] = ACTIONS(2901),
    [anon_sym_inline] = ACTIONS(2901),
    [anon_sym___inline] = ACTIONS(2901),
    [anon_sym___inline__] = ACTIONS(2901),
    [anon_sym___forceinline] = ACTIONS(2901),
    [anon_sym_thread_local] = ACTIONS(2901),
    [anon_sym___thread] = ACTIONS(2901),
    [anon_sym_const] = ACTIONS(2901),
    [anon_sym_constexpr] = ACTIONS(2901),
    [anon_sym_volatile] = ACTIONS(2901),
    [anon_sym_restrict] = ACTIONS(2901),
    [anon_sym___restrict__] = ACTIONS(2901),
    [anon_sym__Atomic] = ACTIONS(2901),
    [anon_sym__Noreturn] = ACTIONS(2901),
    [anon_sym_noreturn] = ACTIONS(2901),
    [anon_sym_mutable] = ACTIONS(2901),
    [anon_sym_constinit] = ACTIONS(2901),
    [anon_sym_consteval] = ACTIONS(2901),
    [anon_sym_PROGMEM] = ACTIONS(2901),
    [aux_sym_primitive_type_token1] = ACTIONS(2901),
    [anon_sym_byte] = ACTIONS(2901),
    [anon_sym_word] = ACTIONS(2901),
    [anon_sym_enum] = ACTIONS(2901),
    [anon_sym_class] = ACTIONS(2901),
    [anon_sym_struct] = ACTIONS(2901),
    [anon_sym_union] = ACTIONS(2901),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2901),
    [anon_sym_decltype] = ACTIONS(2901),
    [anon_sym_virtual] = ACTIONS(2901),
    [anon_sym_alignas] = ACTIONS(2901),
    [anon_sym_explicit] = ACTIONS(2901),
    [anon_sym_typename] = ACTIONS(2901),
    [anon_sym_template] = ACTIONS(2901),
    [anon_sym_operator] = ACTIONS(2901),
    [anon_sym_friend] = ACTIONS(2901),
    [anon_sym_public] = ACTIONS(2901),
    [anon_sym_private] = ACTIONS(2901),
    [anon_sym_protected] = ACTIONS(2901),
    [anon_sym_using] = ACTIONS(2901),
    [anon_sym_static_assert] = ACTIONS(2901),
  },
  [1844] = {
    [sym_identifier] = ACTIONS(2897),
    [aux_sym_preproc_def_token1] = ACTIONS(2897),
    [aux_sym_preproc_if_token1] = ACTIONS(2897),
    [aux_sym_preproc_if_token2] = ACTIONS(2897),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2897),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2897),
    [aux_sym_preproc_else_token1] = ACTIONS(2897),
    [aux_sym_preproc_elif_token1] = ACTIONS(2897),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2897),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2897),
    [sym_preproc_directive] = ACTIONS(2897),
    [anon_sym_LPAREN2] = ACTIONS(2899),
    [anon_sym_TILDE] = ACTIONS(2899),
    [anon_sym_STAR] = ACTIONS(2899),
    [anon_sym_AMP_AMP] = ACTIONS(2899),
    [anon_sym_AMP] = ACTIONS(2897),
    [anon_sym___extension__] = ACTIONS(2897),
    [anon_sym_typedef] = ACTIONS(2897),
    [anon_sym_extern] = ACTIONS(2897),
    [anon_sym___attribute__] = ACTIONS(2897),
    [anon_sym_COLON_COLON] = ACTIONS(2899),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2899),
    [anon_sym___declspec] = ACTIONS(2897),
    [anon_sym___based] = ACTIONS(2897),
    [anon_sym_signed] = ACTIONS(2897),
    [anon_sym_unsigned] = ACTIONS(2897),
    [anon_sym_long] = ACTIONS(2897),
    [anon_sym_short] = ACTIONS(2897),
    [anon_sym_LBRACK] = ACTIONS(2897),
    [anon_sym_static] = ACTIONS(2897),
    [anon_sym_register] = ACTIONS(2897),
    [anon_sym_inline] = ACTIONS(2897),
    [anon_sym___inline] = ACTIONS(2897),
    [anon_sym___inline__] = ACTIONS(2897),
    [anon_sym___forceinline] = ACTIONS(2897),
    [anon_sym_thread_local] = ACTIONS(2897),
    [anon_sym___thread] = ACTIONS(2897),
    [anon_sym_const] = ACTIONS(2897),
    [anon_sym_constexpr] = ACTIONS(2897),
    [anon_sym_volatile] = ACTIONS(2897),
    [anon_sym_restrict] = ACTIONS(2897),
    [anon_sym___restrict__] = ACTIONS(2897),
    [anon_sym__Atomic] = ACTIONS(2897),
    [anon_sym__Noreturn] = ACTIONS(2897),
    [anon_sym_noreturn] = ACTIONS(2897),
    [anon_sym_mutable] = ACTIONS(2897),
    [anon_sym_constinit] = ACTIONS(2897),
    [anon_sym_consteval] = ACTIONS(2897),
    [anon_sym_PROGMEM] = ACTIONS(2897),
    [aux_sym_primitive_type_token1] = ACTIONS(2897),
    [anon_sym_byte] = ACTIONS(2897),
    [anon_sym_word] = ACTIONS(2897),
    [anon_sym_enum] = ACTIONS(2897),
    [anon_sym_class] = ACTIONS(2897),
    [anon_sym_struct] = ACTIONS(2897),
    [anon_sym_union] = ACTIONS(2897),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2897),
    [anon_sym_decltype] = ACTIONS(2897),
    [anon_sym_virtual] = ACTIONS(2897),
    [anon_sym_alignas] = ACTIONS(2897),
    [anon_sym_explicit] = ACTIONS(2897),
    [anon_sym_typename] = ACTIONS(2897),
    [anon_sym_template] = ACTIONS(2897),
    [anon_sym_operator] = ACTIONS(2897),
    [anon_sym_friend] = ACTIONS(2897),
    [anon_sym_public] = ACTIONS(2897),
    [anon_sym_private] = ACTIONS(2897),
    [anon_sym_protected] = ACTIONS(2897),
    [anon_sym_using] = ACTIONS(2897),
    [anon_sym_static_assert] = ACTIONS(2897),
  },
  [1845] = {
    [sym_identifier] = ACTIONS(4894),
    [aux_sym_preproc_def_token1] = ACTIONS(4894),
    [aux_sym_preproc_if_token1] = ACTIONS(4894),
    [aux_sym_preproc_if_token2] = ACTIONS(4894),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4894),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4894),
    [aux_sym_preproc_else_token1] = ACTIONS(4894),
    [aux_sym_preproc_elif_token1] = ACTIONS(4894),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4894),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4894),
    [sym_preproc_directive] = ACTIONS(4894),
    [anon_sym_LPAREN2] = ACTIONS(4896),
    [anon_sym_TILDE] = ACTIONS(4896),
    [anon_sym_STAR] = ACTIONS(4896),
    [anon_sym_AMP_AMP] = ACTIONS(4896),
    [anon_sym_AMP] = ACTIONS(4894),
    [anon_sym___extension__] = ACTIONS(4894),
    [anon_sym_typedef] = ACTIONS(4894),
    [anon_sym_extern] = ACTIONS(4894),
    [anon_sym___attribute__] = ACTIONS(4894),
    [anon_sym_COLON_COLON] = ACTIONS(4896),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4896),
    [anon_sym___declspec] = ACTIONS(4894),
    [anon_sym___based] = ACTIONS(4894),
    [anon_sym_signed] = ACTIONS(4894),
    [anon_sym_unsigned] = ACTIONS(4894),
    [anon_sym_long] = ACTIONS(4894),
    [anon_sym_short] = ACTIONS(4894),
    [anon_sym_LBRACK] = ACTIONS(4894),
    [anon_sym_static] = ACTIONS(4894),
    [anon_sym_register] = ACTIONS(4894),
    [anon_sym_inline] = ACTIONS(4894),
    [anon_sym___inline] = ACTIONS(4894),
    [anon_sym___inline__] = ACTIONS(4894),
    [anon_sym___forceinline] = ACTIONS(4894),
    [anon_sym_thread_local] = ACTIONS(4894),
    [anon_sym___thread] = ACTIONS(4894),
    [anon_sym_const] = ACTIONS(4894),
    [anon_sym_constexpr] = ACTIONS(4894),
    [anon_sym_volatile] = ACTIONS(4894),
    [anon_sym_restrict] = ACTIONS(4894),
    [anon_sym___restrict__] = ACTIONS(4894),
    [anon_sym__Atomic] = ACTIONS(4894),
    [anon_sym__Noreturn] = ACTIONS(4894),
    [anon_sym_noreturn] = ACTIONS(4894),
    [anon_sym_mutable] = ACTIONS(4894),
    [anon_sym_constinit] = ACTIONS(4894),
    [anon_sym_consteval] = ACTIONS(4894),
    [anon_sym_PROGMEM] = ACTIONS(4894),
    [aux_sym_primitive_type_token1] = ACTIONS(4894),
    [anon_sym_byte] = ACTIONS(4894),
    [anon_sym_word] = ACTIONS(4894),
    [anon_sym_enum] = ACTIONS(4894),
    [anon_sym_class] = ACTIONS(4894),
    [anon_sym_struct] = ACTIONS(4894),
    [anon_sym_union] = ACTIONS(4894),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4894),
    [anon_sym_decltype] = ACTIONS(4894),
    [anon_sym_virtual] = ACTIONS(4894),
    [anon_sym_alignas] = ACTIONS(4894),
    [anon_sym_explicit] = ACTIONS(4894),
    [anon_sym_typename] = ACTIONS(4894),
    [anon_sym_template] = ACTIONS(4894),
    [anon_sym_operator] = ACTIONS(4894),
    [anon_sym_friend] = ACTIONS(4894),
    [anon_sym_public] = ACTIONS(4894),
    [anon_sym_private] = ACTIONS(4894),
    [anon_sym_protected] = ACTIONS(4894),
    [anon_sym_using] = ACTIONS(4894),
    [anon_sym_static_assert] = ACTIONS(4894),
  },
  [1846] = {
    [sym__declaration_modifiers] = STATE(1964),
    [sym__declaration_specifiers] = STATE(4720),
    [sym_attribute_specifier] = STATE(1964),
    [sym_attribute_declaration] = STATE(1964),
    [sym_ms_declspec_modifier] = STATE(1964),
    [sym_storage_class_specifier] = STATE(1964),
    [sym_type_qualifier] = STATE(1964),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(1964),
    [sym_alignas_specifier] = STATE(1964),
    [sym_dependent_type] = STATE(2629),
    [sym_template_type] = STATE(2618),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(6346),
    [sym_qualified_type_identifier] = STATE(3260),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [sym_identifier] = ACTIONS(4625),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4627),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1419),
  },
  [1847] = {
    [sym_identifier] = ACTIONS(4898),
    [aux_sym_preproc_def_token1] = ACTIONS(4898),
    [aux_sym_preproc_if_token1] = ACTIONS(4898),
    [aux_sym_preproc_if_token2] = ACTIONS(4898),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4898),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4898),
    [aux_sym_preproc_else_token1] = ACTIONS(4898),
    [aux_sym_preproc_elif_token1] = ACTIONS(4898),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4898),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4898),
    [sym_preproc_directive] = ACTIONS(4898),
    [anon_sym_LPAREN2] = ACTIONS(4900),
    [anon_sym_TILDE] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_AMP_AMP] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4898),
    [anon_sym___extension__] = ACTIONS(4898),
    [anon_sym_typedef] = ACTIONS(4898),
    [anon_sym_extern] = ACTIONS(4898),
    [anon_sym___attribute__] = ACTIONS(4898),
    [anon_sym_COLON_COLON] = ACTIONS(4900),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4900),
    [anon_sym___declspec] = ACTIONS(4898),
    [anon_sym___based] = ACTIONS(4898),
    [anon_sym_signed] = ACTIONS(4898),
    [anon_sym_unsigned] = ACTIONS(4898),
    [anon_sym_long] = ACTIONS(4898),
    [anon_sym_short] = ACTIONS(4898),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_static] = ACTIONS(4898),
    [anon_sym_register] = ACTIONS(4898),
    [anon_sym_inline] = ACTIONS(4898),
    [anon_sym___inline] = ACTIONS(4898),
    [anon_sym___inline__] = ACTIONS(4898),
    [anon_sym___forceinline] = ACTIONS(4898),
    [anon_sym_thread_local] = ACTIONS(4898),
    [anon_sym___thread] = ACTIONS(4898),
    [anon_sym_const] = ACTIONS(4898),
    [anon_sym_constexpr] = ACTIONS(4898),
    [anon_sym_volatile] = ACTIONS(4898),
    [anon_sym_restrict] = ACTIONS(4898),
    [anon_sym___restrict__] = ACTIONS(4898),
    [anon_sym__Atomic] = ACTIONS(4898),
    [anon_sym__Noreturn] = ACTIONS(4898),
    [anon_sym_noreturn] = ACTIONS(4898),
    [anon_sym_mutable] = ACTIONS(4898),
    [anon_sym_constinit] = ACTIONS(4898),
    [anon_sym_consteval] = ACTIONS(4898),
    [anon_sym_PROGMEM] = ACTIONS(4898),
    [aux_sym_primitive_type_token1] = ACTIONS(4898),
    [anon_sym_byte] = ACTIONS(4898),
    [anon_sym_word] = ACTIONS(4898),
    [anon_sym_enum] = ACTIONS(4898),
    [anon_sym_class] = ACTIONS(4898),
    [anon_sym_struct] = ACTIONS(4898),
    [anon_sym_union] = ACTIONS(4898),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4898),
    [anon_sym_decltype] = ACTIONS(4898),
    [anon_sym_virtual] = ACTIONS(4898),
    [anon_sym_alignas] = ACTIONS(4898),
    [anon_sym_explicit] = ACTIONS(4898),
    [anon_sym_typename] = ACTIONS(4898),
    [anon_sym_template] = ACTIONS(4898),
    [anon_sym_operator] = ACTIONS(4898),
    [anon_sym_friend] = ACTIONS(4898),
    [anon_sym_public] = ACTIONS(4898),
    [anon_sym_private] = ACTIONS(4898),
    [anon_sym_protected] = ACTIONS(4898),
    [anon_sym_using] = ACTIONS(4898),
    [anon_sym_static_assert] = ACTIONS(4898),
  },
  [1848] = {
    [sym_identifier] = ACTIONS(2893),
    [aux_sym_preproc_def_token1] = ACTIONS(2893),
    [aux_sym_preproc_if_token1] = ACTIONS(2893),
    [aux_sym_preproc_if_token2] = ACTIONS(2893),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2893),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2893),
    [aux_sym_preproc_else_token1] = ACTIONS(2893),
    [aux_sym_preproc_elif_token1] = ACTIONS(2893),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2893),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2893),
    [sym_preproc_directive] = ACTIONS(2893),
    [anon_sym_LPAREN2] = ACTIONS(2895),
    [anon_sym_TILDE] = ACTIONS(2895),
    [anon_sym_STAR] = ACTIONS(2895),
    [anon_sym_AMP_AMP] = ACTIONS(2895),
    [anon_sym_AMP] = ACTIONS(2893),
    [anon_sym___extension__] = ACTIONS(2893),
    [anon_sym_typedef] = ACTIONS(2893),
    [anon_sym_extern] = ACTIONS(2893),
    [anon_sym___attribute__] = ACTIONS(2893),
    [anon_sym_COLON_COLON] = ACTIONS(2895),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2895),
    [anon_sym___declspec] = ACTIONS(2893),
    [anon_sym___based] = ACTIONS(2893),
    [anon_sym_signed] = ACTIONS(2893),
    [anon_sym_unsigned] = ACTIONS(2893),
    [anon_sym_long] = ACTIONS(2893),
    [anon_sym_short] = ACTIONS(2893),
    [anon_sym_LBRACK] = ACTIONS(2893),
    [anon_sym_static] = ACTIONS(2893),
    [anon_sym_register] = ACTIONS(2893),
    [anon_sym_inline] = ACTIONS(2893),
    [anon_sym___inline] = ACTIONS(2893),
    [anon_sym___inline__] = ACTIONS(2893),
    [anon_sym___forceinline] = ACTIONS(2893),
    [anon_sym_thread_local] = ACTIONS(2893),
    [anon_sym___thread] = ACTIONS(2893),
    [anon_sym_const] = ACTIONS(2893),
    [anon_sym_constexpr] = ACTIONS(2893),
    [anon_sym_volatile] = ACTIONS(2893),
    [anon_sym_restrict] = ACTIONS(2893),
    [anon_sym___restrict__] = ACTIONS(2893),
    [anon_sym__Atomic] = ACTIONS(2893),
    [anon_sym__Noreturn] = ACTIONS(2893),
    [anon_sym_noreturn] = ACTIONS(2893),
    [anon_sym_mutable] = ACTIONS(2893),
    [anon_sym_constinit] = ACTIONS(2893),
    [anon_sym_consteval] = ACTIONS(2893),
    [anon_sym_PROGMEM] = ACTIONS(2893),
    [aux_sym_primitive_type_token1] = ACTIONS(2893),
    [anon_sym_byte] = ACTIONS(2893),
    [anon_sym_word] = ACTIONS(2893),
    [anon_sym_enum] = ACTIONS(2893),
    [anon_sym_class] = ACTIONS(2893),
    [anon_sym_struct] = ACTIONS(2893),
    [anon_sym_union] = ACTIONS(2893),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2893),
    [anon_sym_decltype] = ACTIONS(2893),
    [anon_sym_virtual] = ACTIONS(2893),
    [anon_sym_alignas] = ACTIONS(2893),
    [anon_sym_explicit] = ACTIONS(2893),
    [anon_sym_typename] = ACTIONS(2893),
    [anon_sym_template] = ACTIONS(2893),
    [anon_sym_operator] = ACTIONS(2893),
    [anon_sym_friend] = ACTIONS(2893),
    [anon_sym_public] = ACTIONS(2893),
    [anon_sym_private] = ACTIONS(2893),
    [anon_sym_protected] = ACTIONS(2893),
    [anon_sym_using] = ACTIONS(2893),
    [anon_sym_static_assert] = ACTIONS(2893),
  },
  [1849] = {
    [sym__declaration_modifiers] = STATE(1964),
    [sym__declaration_specifiers] = STATE(4670),
    [sym_attribute_specifier] = STATE(1964),
    [sym_attribute_declaration] = STATE(1964),
    [sym_ms_declspec_modifier] = STATE(1964),
    [sym_storage_class_specifier] = STATE(1964),
    [sym_type_qualifier] = STATE(1964),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(1964),
    [sym_alignas_specifier] = STATE(1964),
    [sym_dependent_type] = STATE(2629),
    [sym_template_type] = STATE(2618),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(6346),
    [sym_qualified_type_identifier] = STATE(3260),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [sym_identifier] = ACTIONS(4625),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4627),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1419),
  },
  [1850] = {
    [sym__declaration_modifiers] = STATE(1964),
    [sym__declaration_specifiers] = STATE(4734),
    [sym_attribute_specifier] = STATE(1964),
    [sym_attribute_declaration] = STATE(1964),
    [sym_ms_declspec_modifier] = STATE(1964),
    [sym_storage_class_specifier] = STATE(1964),
    [sym_type_qualifier] = STATE(1964),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(1964),
    [sym_alignas_specifier] = STATE(1964),
    [sym_dependent_type] = STATE(2629),
    [sym_template_type] = STATE(2618),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(6346),
    [sym_qualified_type_identifier] = STATE(3260),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [sym_identifier] = ACTIONS(4625),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4627),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1419),
  },
  [1851] = {
    [sym_identifier] = ACTIONS(2893),
    [aux_sym_preproc_def_token1] = ACTIONS(2893),
    [aux_sym_preproc_if_token1] = ACTIONS(2893),
    [aux_sym_preproc_if_token2] = ACTIONS(2893),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2893),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2893),
    [aux_sym_preproc_else_token1] = ACTIONS(2893),
    [aux_sym_preproc_elif_token1] = ACTIONS(2893),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2893),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2893),
    [sym_preproc_directive] = ACTIONS(2893),
    [anon_sym_LPAREN2] = ACTIONS(2895),
    [anon_sym_TILDE] = ACTIONS(2895),
    [anon_sym_STAR] = ACTIONS(2895),
    [anon_sym_AMP_AMP] = ACTIONS(2895),
    [anon_sym_AMP] = ACTIONS(2893),
    [anon_sym___extension__] = ACTIONS(2893),
    [anon_sym_typedef] = ACTIONS(2893),
    [anon_sym_extern] = ACTIONS(2893),
    [anon_sym___attribute__] = ACTIONS(2893),
    [anon_sym_COLON_COLON] = ACTIONS(2895),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2895),
    [anon_sym___declspec] = ACTIONS(2893),
    [anon_sym___based] = ACTIONS(2893),
    [anon_sym_signed] = ACTIONS(2893),
    [anon_sym_unsigned] = ACTIONS(2893),
    [anon_sym_long] = ACTIONS(2893),
    [anon_sym_short] = ACTIONS(2893),
    [anon_sym_LBRACK] = ACTIONS(2893),
    [anon_sym_static] = ACTIONS(2893),
    [anon_sym_register] = ACTIONS(2893),
    [anon_sym_inline] = ACTIONS(2893),
    [anon_sym___inline] = ACTIONS(2893),
    [anon_sym___inline__] = ACTIONS(2893),
    [anon_sym___forceinline] = ACTIONS(2893),
    [anon_sym_thread_local] = ACTIONS(2893),
    [anon_sym___thread] = ACTIONS(2893),
    [anon_sym_const] = ACTIONS(2893),
    [anon_sym_constexpr] = ACTIONS(2893),
    [anon_sym_volatile] = ACTIONS(2893),
    [anon_sym_restrict] = ACTIONS(2893),
    [anon_sym___restrict__] = ACTIONS(2893),
    [anon_sym__Atomic] = ACTIONS(2893),
    [anon_sym__Noreturn] = ACTIONS(2893),
    [anon_sym_noreturn] = ACTIONS(2893),
    [anon_sym_mutable] = ACTIONS(2893),
    [anon_sym_constinit] = ACTIONS(2893),
    [anon_sym_consteval] = ACTIONS(2893),
    [anon_sym_PROGMEM] = ACTIONS(2893),
    [aux_sym_primitive_type_token1] = ACTIONS(2893),
    [anon_sym_byte] = ACTIONS(2893),
    [anon_sym_word] = ACTIONS(2893),
    [anon_sym_enum] = ACTIONS(2893),
    [anon_sym_class] = ACTIONS(2893),
    [anon_sym_struct] = ACTIONS(2893),
    [anon_sym_union] = ACTIONS(2893),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2893),
    [anon_sym_decltype] = ACTIONS(2893),
    [anon_sym_virtual] = ACTIONS(2893),
    [anon_sym_alignas] = ACTIONS(2893),
    [anon_sym_explicit] = ACTIONS(2893),
    [anon_sym_typename] = ACTIONS(2893),
    [anon_sym_template] = ACTIONS(2893),
    [anon_sym_operator] = ACTIONS(2893),
    [anon_sym_friend] = ACTIONS(2893),
    [anon_sym_public] = ACTIONS(2893),
    [anon_sym_private] = ACTIONS(2893),
    [anon_sym_protected] = ACTIONS(2893),
    [anon_sym_using] = ACTIONS(2893),
    [anon_sym_static_assert] = ACTIONS(2893),
  },
  [1852] = {
    [sym__declaration_modifiers] = STATE(1964),
    [sym__declaration_specifiers] = STATE(4719),
    [sym_attribute_specifier] = STATE(1964),
    [sym_attribute_declaration] = STATE(1964),
    [sym_ms_declspec_modifier] = STATE(1964),
    [sym_storage_class_specifier] = STATE(1964),
    [sym_type_qualifier] = STATE(1964),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(1964),
    [sym_alignas_specifier] = STATE(1964),
    [sym_dependent_type] = STATE(2629),
    [sym_template_type] = STATE(2618),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(6346),
    [sym_qualified_type_identifier] = STATE(3260),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [sym_identifier] = ACTIONS(4625),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4627),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1419),
  },
  [1853] = {
    [sym_identifier] = ACTIONS(2813),
    [aux_sym_preproc_def_token1] = ACTIONS(2813),
    [aux_sym_preproc_if_token1] = ACTIONS(2813),
    [aux_sym_preproc_if_token2] = ACTIONS(2813),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2813),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2813),
    [aux_sym_preproc_else_token1] = ACTIONS(2813),
    [aux_sym_preproc_elif_token1] = ACTIONS(2813),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2813),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2813),
    [sym_preproc_directive] = ACTIONS(2813),
    [anon_sym_LPAREN2] = ACTIONS(2815),
    [anon_sym_TILDE] = ACTIONS(2815),
    [anon_sym_STAR] = ACTIONS(2815),
    [anon_sym_AMP_AMP] = ACTIONS(2815),
    [anon_sym_AMP] = ACTIONS(2813),
    [anon_sym___extension__] = ACTIONS(2813),
    [anon_sym_typedef] = ACTIONS(2813),
    [anon_sym_extern] = ACTIONS(2813),
    [anon_sym___attribute__] = ACTIONS(2813),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2815),
    [anon_sym___declspec] = ACTIONS(2813),
    [anon_sym___based] = ACTIONS(2813),
    [anon_sym_signed] = ACTIONS(2813),
    [anon_sym_unsigned] = ACTIONS(2813),
    [anon_sym_long] = ACTIONS(2813),
    [anon_sym_short] = ACTIONS(2813),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_static] = ACTIONS(2813),
    [anon_sym_register] = ACTIONS(2813),
    [anon_sym_inline] = ACTIONS(2813),
    [anon_sym___inline] = ACTIONS(2813),
    [anon_sym___inline__] = ACTIONS(2813),
    [anon_sym___forceinline] = ACTIONS(2813),
    [anon_sym_thread_local] = ACTIONS(2813),
    [anon_sym___thread] = ACTIONS(2813),
    [anon_sym_const] = ACTIONS(2813),
    [anon_sym_constexpr] = ACTIONS(2813),
    [anon_sym_volatile] = ACTIONS(2813),
    [anon_sym_restrict] = ACTIONS(2813),
    [anon_sym___restrict__] = ACTIONS(2813),
    [anon_sym__Atomic] = ACTIONS(2813),
    [anon_sym__Noreturn] = ACTIONS(2813),
    [anon_sym_noreturn] = ACTIONS(2813),
    [anon_sym_mutable] = ACTIONS(2813),
    [anon_sym_constinit] = ACTIONS(2813),
    [anon_sym_consteval] = ACTIONS(2813),
    [anon_sym_PROGMEM] = ACTIONS(2813),
    [aux_sym_primitive_type_token1] = ACTIONS(2813),
    [anon_sym_byte] = ACTIONS(2813),
    [anon_sym_word] = ACTIONS(2813),
    [anon_sym_enum] = ACTIONS(2813),
    [anon_sym_class] = ACTIONS(2813),
    [anon_sym_struct] = ACTIONS(2813),
    [anon_sym_union] = ACTIONS(2813),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2813),
    [anon_sym_decltype] = ACTIONS(2813),
    [anon_sym_virtual] = ACTIONS(2813),
    [anon_sym_alignas] = ACTIONS(2813),
    [anon_sym_explicit] = ACTIONS(2813),
    [anon_sym_typename] = ACTIONS(2813),
    [anon_sym_template] = ACTIONS(2813),
    [anon_sym_operator] = ACTIONS(2813),
    [anon_sym_friend] = ACTIONS(2813),
    [anon_sym_public] = ACTIONS(2813),
    [anon_sym_private] = ACTIONS(2813),
    [anon_sym_protected] = ACTIONS(2813),
    [anon_sym_using] = ACTIONS(2813),
    [anon_sym_static_assert] = ACTIONS(2813),
  },
  [1854] = {
    [sym_identifier] = ACTIONS(2813),
    [aux_sym_preproc_def_token1] = ACTIONS(2813),
    [aux_sym_preproc_if_token1] = ACTIONS(2813),
    [aux_sym_preproc_if_token2] = ACTIONS(2813),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2813),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2813),
    [aux_sym_preproc_else_token1] = ACTIONS(2813),
    [aux_sym_preproc_elif_token1] = ACTIONS(2813),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2813),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2813),
    [sym_preproc_directive] = ACTIONS(2813),
    [anon_sym_LPAREN2] = ACTIONS(2815),
    [anon_sym_TILDE] = ACTIONS(2815),
    [anon_sym_STAR] = ACTIONS(2815),
    [anon_sym_AMP_AMP] = ACTIONS(2815),
    [anon_sym_AMP] = ACTIONS(2813),
    [anon_sym___extension__] = ACTIONS(2813),
    [anon_sym_typedef] = ACTIONS(2813),
    [anon_sym_extern] = ACTIONS(2813),
    [anon_sym___attribute__] = ACTIONS(2813),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2815),
    [anon_sym___declspec] = ACTIONS(2813),
    [anon_sym___based] = ACTIONS(2813),
    [anon_sym_signed] = ACTIONS(2813),
    [anon_sym_unsigned] = ACTIONS(2813),
    [anon_sym_long] = ACTIONS(2813),
    [anon_sym_short] = ACTIONS(2813),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_static] = ACTIONS(2813),
    [anon_sym_register] = ACTIONS(2813),
    [anon_sym_inline] = ACTIONS(2813),
    [anon_sym___inline] = ACTIONS(2813),
    [anon_sym___inline__] = ACTIONS(2813),
    [anon_sym___forceinline] = ACTIONS(2813),
    [anon_sym_thread_local] = ACTIONS(2813),
    [anon_sym___thread] = ACTIONS(2813),
    [anon_sym_const] = ACTIONS(2813),
    [anon_sym_constexpr] = ACTIONS(2813),
    [anon_sym_volatile] = ACTIONS(2813),
    [anon_sym_restrict] = ACTIONS(2813),
    [anon_sym___restrict__] = ACTIONS(2813),
    [anon_sym__Atomic] = ACTIONS(2813),
    [anon_sym__Noreturn] = ACTIONS(2813),
    [anon_sym_noreturn] = ACTIONS(2813),
    [anon_sym_mutable] = ACTIONS(2813),
    [anon_sym_constinit] = ACTIONS(2813),
    [anon_sym_consteval] = ACTIONS(2813),
    [anon_sym_PROGMEM] = ACTIONS(2813),
    [aux_sym_primitive_type_token1] = ACTIONS(2813),
    [anon_sym_byte] = ACTIONS(2813),
    [anon_sym_word] = ACTIONS(2813),
    [anon_sym_enum] = ACTIONS(2813),
    [anon_sym_class] = ACTIONS(2813),
    [anon_sym_struct] = ACTIONS(2813),
    [anon_sym_union] = ACTIONS(2813),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2813),
    [anon_sym_decltype] = ACTIONS(2813),
    [anon_sym_virtual] = ACTIONS(2813),
    [anon_sym_alignas] = ACTIONS(2813),
    [anon_sym_explicit] = ACTIONS(2813),
    [anon_sym_typename] = ACTIONS(2813),
    [anon_sym_template] = ACTIONS(2813),
    [anon_sym_operator] = ACTIONS(2813),
    [anon_sym_friend] = ACTIONS(2813),
    [anon_sym_public] = ACTIONS(2813),
    [anon_sym_private] = ACTIONS(2813),
    [anon_sym_protected] = ACTIONS(2813),
    [anon_sym_using] = ACTIONS(2813),
    [anon_sym_static_assert] = ACTIONS(2813),
  },
  [1855] = {
    [sym_attribute_specifier] = STATE(2346),
    [sym_field_declaration_list] = STATE(2268),
    [sym_virtual_specifier] = STATE(6810),
    [sym_base_class_clause] = STATE(7270),
    [sym_identifier] = ACTIONS(4902),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4904),
    [anon_sym_COMMA] = ACTIONS(4904),
    [anon_sym_RPAREN] = ACTIONS(4904),
    [aux_sym_preproc_if_token2] = ACTIONS(4904),
    [aux_sym_preproc_else_token1] = ACTIONS(4904),
    [aux_sym_preproc_elif_token1] = ACTIONS(4902),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4904),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4904),
    [anon_sym_LPAREN2] = ACTIONS(4904),
    [anon_sym_DASH] = ACTIONS(4902),
    [anon_sym_PLUS] = ACTIONS(4902),
    [anon_sym_STAR] = ACTIONS(4902),
    [anon_sym_SLASH] = ACTIONS(4902),
    [anon_sym_PERCENT] = ACTIONS(4902),
    [anon_sym_PIPE_PIPE] = ACTIONS(4904),
    [anon_sym_AMP_AMP] = ACTIONS(4904),
    [anon_sym_PIPE] = ACTIONS(4902),
    [anon_sym_CARET] = ACTIONS(4902),
    [anon_sym_AMP] = ACTIONS(4902),
    [anon_sym_EQ_EQ] = ACTIONS(4904),
    [anon_sym_BANG_EQ] = ACTIONS(4904),
    [anon_sym_GT] = ACTIONS(4902),
    [anon_sym_GT_EQ] = ACTIONS(4904),
    [anon_sym_LT_EQ] = ACTIONS(4902),
    [anon_sym_LT] = ACTIONS(4902),
    [anon_sym_LT_LT] = ACTIONS(4902),
    [anon_sym_GT_GT] = ACTIONS(4902),
    [anon_sym_SEMI] = ACTIONS(4904),
    [anon_sym___attribute__] = ACTIONS(4906),
    [anon_sym_LBRACE] = ACTIONS(4908),
    [anon_sym_RBRACE] = ACTIONS(4904),
    [anon_sym_LBRACK] = ACTIONS(4904),
    [anon_sym_RBRACK] = ACTIONS(4904),
    [anon_sym_EQ] = ACTIONS(4902),
    [anon_sym_COLON] = ACTIONS(4910),
    [anon_sym_QMARK] = ACTIONS(4904),
    [anon_sym_STAR_EQ] = ACTIONS(4904),
    [anon_sym_SLASH_EQ] = ACTIONS(4904),
    [anon_sym_PERCENT_EQ] = ACTIONS(4904),
    [anon_sym_PLUS_EQ] = ACTIONS(4904),
    [anon_sym_DASH_EQ] = ACTIONS(4904),
    [anon_sym_LT_LT_EQ] = ACTIONS(4904),
    [anon_sym_GT_GT_EQ] = ACTIONS(4904),
    [anon_sym_AMP_EQ] = ACTIONS(4904),
    [anon_sym_CARET_EQ] = ACTIONS(4904),
    [anon_sym_PIPE_EQ] = ACTIONS(4904),
    [anon_sym_and_eq] = ACTIONS(4902),
    [anon_sym_or_eq] = ACTIONS(4902),
    [anon_sym_xor_eq] = ACTIONS(4902),
    [anon_sym_LT_EQ_GT] = ACTIONS(4904),
    [anon_sym_or] = ACTIONS(4902),
    [anon_sym_and] = ACTIONS(4902),
    [anon_sym_bitor] = ACTIONS(4902),
    [anon_sym_xor] = ACTIONS(4902),
    [anon_sym_bitand] = ACTIONS(4902),
    [anon_sym_not_eq] = ACTIONS(4902),
    [anon_sym_DASH_DASH] = ACTIONS(4904),
    [anon_sym_PLUS_PLUS] = ACTIONS(4904),
    [anon_sym_DOT] = ACTIONS(4902),
    [anon_sym_DOT_STAR] = ACTIONS(4904),
    [anon_sym_DASH_GT] = ACTIONS(4904),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4902),
    [anon_sym_decltype] = ACTIONS(4902),
    [anon_sym_final] = ACTIONS(4912),
    [anon_sym_override] = ACTIONS(4912),
  },
  [1856] = {
    [sym__declaration_modifiers] = STATE(1964),
    [sym__declaration_specifiers] = STATE(4702),
    [sym_attribute_specifier] = STATE(1964),
    [sym_attribute_declaration] = STATE(1964),
    [sym_ms_declspec_modifier] = STATE(1964),
    [sym_storage_class_specifier] = STATE(1964),
    [sym_type_qualifier] = STATE(1964),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(1964),
    [sym_alignas_specifier] = STATE(1964),
    [sym_dependent_type] = STATE(2629),
    [sym_template_type] = STATE(2618),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(6346),
    [sym_qualified_type_identifier] = STATE(3260),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [sym_identifier] = ACTIONS(4625),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4627),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1419),
  },
  [1857] = {
    [sym__declaration_modifiers] = STATE(1964),
    [sym__declaration_specifiers] = STATE(4659),
    [sym_attribute_specifier] = STATE(1964),
    [sym_attribute_declaration] = STATE(1964),
    [sym_ms_declspec_modifier] = STATE(1964),
    [sym_storage_class_specifier] = STATE(1964),
    [sym_type_qualifier] = STATE(1964),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(1964),
    [sym_alignas_specifier] = STATE(1964),
    [sym_dependent_type] = STATE(2629),
    [sym_template_type] = STATE(2618),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(6346),
    [sym_qualified_type_identifier] = STATE(3260),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [sym_identifier] = ACTIONS(4625),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4627),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1419),
  },
  [1858] = {
    [sym_identifier] = ACTIONS(2809),
    [aux_sym_preproc_def_token1] = ACTIONS(2809),
    [aux_sym_preproc_if_token1] = ACTIONS(2809),
    [aux_sym_preproc_if_token2] = ACTIONS(2809),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2809),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2809),
    [aux_sym_preproc_else_token1] = ACTIONS(2809),
    [aux_sym_preproc_elif_token1] = ACTIONS(2809),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2809),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2809),
    [sym_preproc_directive] = ACTIONS(2809),
    [anon_sym_LPAREN2] = ACTIONS(2811),
    [anon_sym_TILDE] = ACTIONS(2811),
    [anon_sym_STAR] = ACTIONS(2811),
    [anon_sym_AMP_AMP] = ACTIONS(2811),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym___extension__] = ACTIONS(2809),
    [anon_sym_typedef] = ACTIONS(2809),
    [anon_sym_extern] = ACTIONS(2809),
    [anon_sym___attribute__] = ACTIONS(2809),
    [anon_sym_COLON_COLON] = ACTIONS(2811),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2811),
    [anon_sym___declspec] = ACTIONS(2809),
    [anon_sym___based] = ACTIONS(2809),
    [anon_sym_signed] = ACTIONS(2809),
    [anon_sym_unsigned] = ACTIONS(2809),
    [anon_sym_long] = ACTIONS(2809),
    [anon_sym_short] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2809),
    [anon_sym_static] = ACTIONS(2809),
    [anon_sym_register] = ACTIONS(2809),
    [anon_sym_inline] = ACTIONS(2809),
    [anon_sym___inline] = ACTIONS(2809),
    [anon_sym___inline__] = ACTIONS(2809),
    [anon_sym___forceinline] = ACTIONS(2809),
    [anon_sym_thread_local] = ACTIONS(2809),
    [anon_sym___thread] = ACTIONS(2809),
    [anon_sym_const] = ACTIONS(2809),
    [anon_sym_constexpr] = ACTIONS(2809),
    [anon_sym_volatile] = ACTIONS(2809),
    [anon_sym_restrict] = ACTIONS(2809),
    [anon_sym___restrict__] = ACTIONS(2809),
    [anon_sym__Atomic] = ACTIONS(2809),
    [anon_sym__Noreturn] = ACTIONS(2809),
    [anon_sym_noreturn] = ACTIONS(2809),
    [anon_sym_mutable] = ACTIONS(2809),
    [anon_sym_constinit] = ACTIONS(2809),
    [anon_sym_consteval] = ACTIONS(2809),
    [anon_sym_PROGMEM] = ACTIONS(2809),
    [aux_sym_primitive_type_token1] = ACTIONS(2809),
    [anon_sym_byte] = ACTIONS(2809),
    [anon_sym_word] = ACTIONS(2809),
    [anon_sym_enum] = ACTIONS(2809),
    [anon_sym_class] = ACTIONS(2809),
    [anon_sym_struct] = ACTIONS(2809),
    [anon_sym_union] = ACTIONS(2809),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2809),
    [anon_sym_decltype] = ACTIONS(2809),
    [anon_sym_virtual] = ACTIONS(2809),
    [anon_sym_alignas] = ACTIONS(2809),
    [anon_sym_explicit] = ACTIONS(2809),
    [anon_sym_typename] = ACTIONS(2809),
    [anon_sym_template] = ACTIONS(2809),
    [anon_sym_operator] = ACTIONS(2809),
    [anon_sym_friend] = ACTIONS(2809),
    [anon_sym_public] = ACTIONS(2809),
    [anon_sym_private] = ACTIONS(2809),
    [anon_sym_protected] = ACTIONS(2809),
    [anon_sym_using] = ACTIONS(2809),
    [anon_sym_static_assert] = ACTIONS(2809),
  },
  [1859] = {
    [sym_identifier] = ACTIONS(2885),
    [aux_sym_preproc_def_token1] = ACTIONS(2885),
    [aux_sym_preproc_if_token1] = ACTIONS(2885),
    [aux_sym_preproc_if_token2] = ACTIONS(2885),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2885),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2885),
    [aux_sym_preproc_else_token1] = ACTIONS(2885),
    [aux_sym_preproc_elif_token1] = ACTIONS(2885),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2885),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2885),
    [sym_preproc_directive] = ACTIONS(2885),
    [anon_sym_LPAREN2] = ACTIONS(2887),
    [anon_sym_TILDE] = ACTIONS(2887),
    [anon_sym_STAR] = ACTIONS(2887),
    [anon_sym_AMP_AMP] = ACTIONS(2887),
    [anon_sym_AMP] = ACTIONS(2885),
    [anon_sym___extension__] = ACTIONS(2885),
    [anon_sym_typedef] = ACTIONS(2885),
    [anon_sym_extern] = ACTIONS(2885),
    [anon_sym___attribute__] = ACTIONS(2885),
    [anon_sym_COLON_COLON] = ACTIONS(2887),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2887),
    [anon_sym___declspec] = ACTIONS(2885),
    [anon_sym___based] = ACTIONS(2885),
    [anon_sym_signed] = ACTIONS(2885),
    [anon_sym_unsigned] = ACTIONS(2885),
    [anon_sym_long] = ACTIONS(2885),
    [anon_sym_short] = ACTIONS(2885),
    [anon_sym_LBRACK] = ACTIONS(2885),
    [anon_sym_static] = ACTIONS(2885),
    [anon_sym_register] = ACTIONS(2885),
    [anon_sym_inline] = ACTIONS(2885),
    [anon_sym___inline] = ACTIONS(2885),
    [anon_sym___inline__] = ACTIONS(2885),
    [anon_sym___forceinline] = ACTIONS(2885),
    [anon_sym_thread_local] = ACTIONS(2885),
    [anon_sym___thread] = ACTIONS(2885),
    [anon_sym_const] = ACTIONS(2885),
    [anon_sym_constexpr] = ACTIONS(2885),
    [anon_sym_volatile] = ACTIONS(2885),
    [anon_sym_restrict] = ACTIONS(2885),
    [anon_sym___restrict__] = ACTIONS(2885),
    [anon_sym__Atomic] = ACTIONS(2885),
    [anon_sym__Noreturn] = ACTIONS(2885),
    [anon_sym_noreturn] = ACTIONS(2885),
    [anon_sym_mutable] = ACTIONS(2885),
    [anon_sym_constinit] = ACTIONS(2885),
    [anon_sym_consteval] = ACTIONS(2885),
    [anon_sym_PROGMEM] = ACTIONS(2885),
    [aux_sym_primitive_type_token1] = ACTIONS(2885),
    [anon_sym_byte] = ACTIONS(2885),
    [anon_sym_word] = ACTIONS(2885),
    [anon_sym_enum] = ACTIONS(2885),
    [anon_sym_class] = ACTIONS(2885),
    [anon_sym_struct] = ACTIONS(2885),
    [anon_sym_union] = ACTIONS(2885),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2885),
    [anon_sym_decltype] = ACTIONS(2885),
    [anon_sym_virtual] = ACTIONS(2885),
    [anon_sym_alignas] = ACTIONS(2885),
    [anon_sym_explicit] = ACTIONS(2885),
    [anon_sym_typename] = ACTIONS(2885),
    [anon_sym_template] = ACTIONS(2885),
    [anon_sym_operator] = ACTIONS(2885),
    [anon_sym_friend] = ACTIONS(2885),
    [anon_sym_public] = ACTIONS(2885),
    [anon_sym_private] = ACTIONS(2885),
    [anon_sym_protected] = ACTIONS(2885),
    [anon_sym_using] = ACTIONS(2885),
    [anon_sym_static_assert] = ACTIONS(2885),
  },
  [1860] = {
    [sym_identifier] = ACTIONS(4914),
    [aux_sym_preproc_def_token1] = ACTIONS(4914),
    [aux_sym_preproc_if_token1] = ACTIONS(4914),
    [aux_sym_preproc_if_token2] = ACTIONS(4914),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4914),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4914),
    [aux_sym_preproc_else_token1] = ACTIONS(4914),
    [aux_sym_preproc_elif_token1] = ACTIONS(4914),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4914),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4914),
    [sym_preproc_directive] = ACTIONS(4914),
    [anon_sym_LPAREN2] = ACTIONS(4916),
    [anon_sym_TILDE] = ACTIONS(4916),
    [anon_sym_STAR] = ACTIONS(4916),
    [anon_sym_AMP_AMP] = ACTIONS(4916),
    [anon_sym_AMP] = ACTIONS(4914),
    [anon_sym___extension__] = ACTIONS(4914),
    [anon_sym_typedef] = ACTIONS(4914),
    [anon_sym_extern] = ACTIONS(4914),
    [anon_sym___attribute__] = ACTIONS(4914),
    [anon_sym_COLON_COLON] = ACTIONS(4916),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4916),
    [anon_sym___declspec] = ACTIONS(4914),
    [anon_sym___based] = ACTIONS(4914),
    [anon_sym_signed] = ACTIONS(4914),
    [anon_sym_unsigned] = ACTIONS(4914),
    [anon_sym_long] = ACTIONS(4914),
    [anon_sym_short] = ACTIONS(4914),
    [anon_sym_LBRACK] = ACTIONS(4914),
    [anon_sym_static] = ACTIONS(4914),
    [anon_sym_register] = ACTIONS(4914),
    [anon_sym_inline] = ACTIONS(4914),
    [anon_sym___inline] = ACTIONS(4914),
    [anon_sym___inline__] = ACTIONS(4914),
    [anon_sym___forceinline] = ACTIONS(4914),
    [anon_sym_thread_local] = ACTIONS(4914),
    [anon_sym___thread] = ACTIONS(4914),
    [anon_sym_const] = ACTIONS(4914),
    [anon_sym_constexpr] = ACTIONS(4914),
    [anon_sym_volatile] = ACTIONS(4914),
    [anon_sym_restrict] = ACTIONS(4914),
    [anon_sym___restrict__] = ACTIONS(4914),
    [anon_sym__Atomic] = ACTIONS(4914),
    [anon_sym__Noreturn] = ACTIONS(4914),
    [anon_sym_noreturn] = ACTIONS(4914),
    [anon_sym_mutable] = ACTIONS(4914),
    [anon_sym_constinit] = ACTIONS(4914),
    [anon_sym_consteval] = ACTIONS(4914),
    [anon_sym_PROGMEM] = ACTIONS(4914),
    [aux_sym_primitive_type_token1] = ACTIONS(4914),
    [anon_sym_byte] = ACTIONS(4914),
    [anon_sym_word] = ACTIONS(4914),
    [anon_sym_enum] = ACTIONS(4914),
    [anon_sym_class] = ACTIONS(4914),
    [anon_sym_struct] = ACTIONS(4914),
    [anon_sym_union] = ACTIONS(4914),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4914),
    [anon_sym_decltype] = ACTIONS(4914),
    [anon_sym_virtual] = ACTIONS(4914),
    [anon_sym_alignas] = ACTIONS(4914),
    [anon_sym_explicit] = ACTIONS(4914),
    [anon_sym_typename] = ACTIONS(4914),
    [anon_sym_template] = ACTIONS(4914),
    [anon_sym_operator] = ACTIONS(4914),
    [anon_sym_friend] = ACTIONS(4914),
    [anon_sym_public] = ACTIONS(4914),
    [anon_sym_private] = ACTIONS(4914),
    [anon_sym_protected] = ACTIONS(4914),
    [anon_sym_using] = ACTIONS(4914),
    [anon_sym_static_assert] = ACTIONS(4914),
  },
  [1861] = {
    [sym_identifier] = ACTIONS(4914),
    [aux_sym_preproc_def_token1] = ACTIONS(4914),
    [aux_sym_preproc_if_token1] = ACTIONS(4914),
    [aux_sym_preproc_if_token2] = ACTIONS(4914),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4914),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4914),
    [aux_sym_preproc_else_token1] = ACTIONS(4914),
    [aux_sym_preproc_elif_token1] = ACTIONS(4914),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4914),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4914),
    [sym_preproc_directive] = ACTIONS(4914),
    [anon_sym_LPAREN2] = ACTIONS(4916),
    [anon_sym_TILDE] = ACTIONS(4916),
    [anon_sym_STAR] = ACTIONS(4916),
    [anon_sym_AMP_AMP] = ACTIONS(4916),
    [anon_sym_AMP] = ACTIONS(4914),
    [anon_sym___extension__] = ACTIONS(4914),
    [anon_sym_typedef] = ACTIONS(4914),
    [anon_sym_extern] = ACTIONS(4914),
    [anon_sym___attribute__] = ACTIONS(4914),
    [anon_sym_COLON_COLON] = ACTIONS(4916),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4916),
    [anon_sym___declspec] = ACTIONS(4914),
    [anon_sym___based] = ACTIONS(4914),
    [anon_sym_signed] = ACTIONS(4914),
    [anon_sym_unsigned] = ACTIONS(4914),
    [anon_sym_long] = ACTIONS(4914),
    [anon_sym_short] = ACTIONS(4914),
    [anon_sym_LBRACK] = ACTIONS(4914),
    [anon_sym_static] = ACTIONS(4914),
    [anon_sym_register] = ACTIONS(4914),
    [anon_sym_inline] = ACTIONS(4914),
    [anon_sym___inline] = ACTIONS(4914),
    [anon_sym___inline__] = ACTIONS(4914),
    [anon_sym___forceinline] = ACTIONS(4914),
    [anon_sym_thread_local] = ACTIONS(4914),
    [anon_sym___thread] = ACTIONS(4914),
    [anon_sym_const] = ACTIONS(4914),
    [anon_sym_constexpr] = ACTIONS(4914),
    [anon_sym_volatile] = ACTIONS(4914),
    [anon_sym_restrict] = ACTIONS(4914),
    [anon_sym___restrict__] = ACTIONS(4914),
    [anon_sym__Atomic] = ACTIONS(4914),
    [anon_sym__Noreturn] = ACTIONS(4914),
    [anon_sym_noreturn] = ACTIONS(4914),
    [anon_sym_mutable] = ACTIONS(4914),
    [anon_sym_constinit] = ACTIONS(4914),
    [anon_sym_consteval] = ACTIONS(4914),
    [anon_sym_PROGMEM] = ACTIONS(4914),
    [aux_sym_primitive_type_token1] = ACTIONS(4914),
    [anon_sym_byte] = ACTIONS(4914),
    [anon_sym_word] = ACTIONS(4914),
    [anon_sym_enum] = ACTIONS(4914),
    [anon_sym_class] = ACTIONS(4914),
    [anon_sym_struct] = ACTIONS(4914),
    [anon_sym_union] = ACTIONS(4914),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4914),
    [anon_sym_decltype] = ACTIONS(4914),
    [anon_sym_virtual] = ACTIONS(4914),
    [anon_sym_alignas] = ACTIONS(4914),
    [anon_sym_explicit] = ACTIONS(4914),
    [anon_sym_typename] = ACTIONS(4914),
    [anon_sym_template] = ACTIONS(4914),
    [anon_sym_operator] = ACTIONS(4914),
    [anon_sym_friend] = ACTIONS(4914),
    [anon_sym_public] = ACTIONS(4914),
    [anon_sym_private] = ACTIONS(4914),
    [anon_sym_protected] = ACTIONS(4914),
    [anon_sym_using] = ACTIONS(4914),
    [anon_sym_static_assert] = ACTIONS(4914),
  },
  [1862] = {
    [sym_identifier] = ACTIONS(2639),
    [aux_sym_preproc_def_token1] = ACTIONS(2639),
    [aux_sym_preproc_if_token1] = ACTIONS(2639),
    [aux_sym_preproc_if_token2] = ACTIONS(2639),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2639),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2639),
    [aux_sym_preproc_else_token1] = ACTIONS(2639),
    [aux_sym_preproc_elif_token1] = ACTIONS(2639),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2639),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2639),
    [sym_preproc_directive] = ACTIONS(2639),
    [anon_sym_LPAREN2] = ACTIONS(2641),
    [anon_sym_TILDE] = ACTIONS(2641),
    [anon_sym_STAR] = ACTIONS(2641),
    [anon_sym_AMP_AMP] = ACTIONS(2641),
    [anon_sym_AMP] = ACTIONS(2639),
    [anon_sym___extension__] = ACTIONS(2639),
    [anon_sym_typedef] = ACTIONS(2639),
    [anon_sym_extern] = ACTIONS(2639),
    [anon_sym___attribute__] = ACTIONS(2639),
    [anon_sym_COLON_COLON] = ACTIONS(2641),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2641),
    [anon_sym___declspec] = ACTIONS(2639),
    [anon_sym___based] = ACTIONS(2639),
    [anon_sym_signed] = ACTIONS(2639),
    [anon_sym_unsigned] = ACTIONS(2639),
    [anon_sym_long] = ACTIONS(2639),
    [anon_sym_short] = ACTIONS(2639),
    [anon_sym_LBRACK] = ACTIONS(2639),
    [anon_sym_static] = ACTIONS(2639),
    [anon_sym_register] = ACTIONS(2639),
    [anon_sym_inline] = ACTIONS(2639),
    [anon_sym___inline] = ACTIONS(2639),
    [anon_sym___inline__] = ACTIONS(2639),
    [anon_sym___forceinline] = ACTIONS(2639),
    [anon_sym_thread_local] = ACTIONS(2639),
    [anon_sym___thread] = ACTIONS(2639),
    [anon_sym_const] = ACTIONS(2639),
    [anon_sym_constexpr] = ACTIONS(2639),
    [anon_sym_volatile] = ACTIONS(2639),
    [anon_sym_restrict] = ACTIONS(2639),
    [anon_sym___restrict__] = ACTIONS(2639),
    [anon_sym__Atomic] = ACTIONS(2639),
    [anon_sym__Noreturn] = ACTIONS(2639),
    [anon_sym_noreturn] = ACTIONS(2639),
    [anon_sym_mutable] = ACTIONS(2639),
    [anon_sym_constinit] = ACTIONS(2639),
    [anon_sym_consteval] = ACTIONS(2639),
    [anon_sym_PROGMEM] = ACTIONS(2639),
    [aux_sym_primitive_type_token1] = ACTIONS(2639),
    [anon_sym_byte] = ACTIONS(2639),
    [anon_sym_word] = ACTIONS(2639),
    [anon_sym_enum] = ACTIONS(2639),
    [anon_sym_class] = ACTIONS(2639),
    [anon_sym_struct] = ACTIONS(2639),
    [anon_sym_union] = ACTIONS(2639),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2639),
    [anon_sym_decltype] = ACTIONS(2639),
    [anon_sym_virtual] = ACTIONS(2639),
    [anon_sym_alignas] = ACTIONS(2639),
    [anon_sym_explicit] = ACTIONS(2639),
    [anon_sym_typename] = ACTIONS(2639),
    [anon_sym_template] = ACTIONS(2639),
    [anon_sym_operator] = ACTIONS(2639),
    [anon_sym_friend] = ACTIONS(2639),
    [anon_sym_public] = ACTIONS(2639),
    [anon_sym_private] = ACTIONS(2639),
    [anon_sym_protected] = ACTIONS(2639),
    [anon_sym_using] = ACTIONS(2639),
    [anon_sym_static_assert] = ACTIONS(2639),
  },
  [1863] = {
    [sym_template_argument_list] = STATE(1828),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4536),
    [anon_sym_COMMA] = ACTIONS(4536),
    [anon_sym_RPAREN] = ACTIONS(4538),
    [anon_sym_LPAREN2] = ACTIONS(4538),
    [anon_sym_DASH] = ACTIONS(4543),
    [anon_sym_PLUS] = ACTIONS(4543),
    [anon_sym_STAR] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(4543),
    [anon_sym_PERCENT] = ACTIONS(4543),
    [anon_sym_PIPE_PIPE] = ACTIONS(4536),
    [anon_sym_AMP_AMP] = ACTIONS(4538),
    [anon_sym_PIPE] = ACTIONS(4543),
    [anon_sym_CARET] = ACTIONS(4543),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_EQ_EQ] = ACTIONS(4536),
    [anon_sym_BANG_EQ] = ACTIONS(4536),
    [anon_sym_GT] = ACTIONS(4543),
    [anon_sym_GT_EQ] = ACTIONS(4536),
    [anon_sym_LT_EQ] = ACTIONS(4543),
    [anon_sym_LT] = ACTIONS(4595),
    [anon_sym_LT_LT] = ACTIONS(4543),
    [anon_sym_GT_GT] = ACTIONS(4543),
    [anon_sym___extension__] = ACTIONS(4541),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4536),
    [anon_sym_LBRACE] = ACTIONS(4541),
    [anon_sym_LBRACK] = ACTIONS(4545),
    [anon_sym_EQ] = ACTIONS(4543),
    [anon_sym_const] = ACTIONS(4534),
    [anon_sym_constexpr] = ACTIONS(4541),
    [anon_sym_volatile] = ACTIONS(4541),
    [anon_sym_restrict] = ACTIONS(4541),
    [anon_sym___restrict__] = ACTIONS(4541),
    [anon_sym__Atomic] = ACTIONS(4541),
    [anon_sym__Noreturn] = ACTIONS(4541),
    [anon_sym_noreturn] = ACTIONS(4541),
    [anon_sym_mutable] = ACTIONS(4541),
    [anon_sym_constinit] = ACTIONS(4541),
    [anon_sym_consteval] = ACTIONS(4541),
    [anon_sym_PROGMEM] = ACTIONS(4541),
    [anon_sym_QMARK] = ACTIONS(4536),
    [anon_sym_STAR_EQ] = ACTIONS(4536),
    [anon_sym_SLASH_EQ] = ACTIONS(4536),
    [anon_sym_PERCENT_EQ] = ACTIONS(4536),
    [anon_sym_PLUS_EQ] = ACTIONS(4536),
    [anon_sym_DASH_EQ] = ACTIONS(4536),
    [anon_sym_LT_LT_EQ] = ACTIONS(4536),
    [anon_sym_GT_GT_EQ] = ACTIONS(4536),
    [anon_sym_AMP_EQ] = ACTIONS(4536),
    [anon_sym_CARET_EQ] = ACTIONS(4536),
    [anon_sym_PIPE_EQ] = ACTIONS(4536),
    [anon_sym_and_eq] = ACTIONS(4536),
    [anon_sym_or_eq] = ACTIONS(4536),
    [anon_sym_xor_eq] = ACTIONS(4536),
    [anon_sym_LT_EQ_GT] = ACTIONS(4536),
    [anon_sym_or] = ACTIONS(4543),
    [anon_sym_and] = ACTIONS(4543),
    [anon_sym_bitor] = ACTIONS(4536),
    [anon_sym_xor] = ACTIONS(4543),
    [anon_sym_bitand] = ACTIONS(4536),
    [anon_sym_not_eq] = ACTIONS(4536),
    [anon_sym_DASH_DASH] = ACTIONS(4536),
    [anon_sym_PLUS_PLUS] = ACTIONS(4536),
    [anon_sym_DOT] = ACTIONS(4543),
    [anon_sym_DOT_STAR] = ACTIONS(4536),
    [anon_sym_DASH_GT] = ACTIONS(4543),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4541),
    [anon_sym_decltype] = ACTIONS(4541),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4536),
  },
  [1864] = {
    [sym_identifier] = ACTIONS(2751),
    [aux_sym_preproc_def_token1] = ACTIONS(2751),
    [aux_sym_preproc_if_token1] = ACTIONS(2751),
    [aux_sym_preproc_if_token2] = ACTIONS(2751),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2751),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2751),
    [aux_sym_preproc_else_token1] = ACTIONS(2751),
    [aux_sym_preproc_elif_token1] = ACTIONS(2751),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2751),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2751),
    [sym_preproc_directive] = ACTIONS(2751),
    [anon_sym_LPAREN2] = ACTIONS(2753),
    [anon_sym_TILDE] = ACTIONS(2753),
    [anon_sym_STAR] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2751),
    [anon_sym___extension__] = ACTIONS(2751),
    [anon_sym_typedef] = ACTIONS(2751),
    [anon_sym_extern] = ACTIONS(2751),
    [anon_sym___attribute__] = ACTIONS(2751),
    [anon_sym_COLON_COLON] = ACTIONS(2753),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2753),
    [anon_sym___declspec] = ACTIONS(2751),
    [anon_sym___based] = ACTIONS(2751),
    [anon_sym_signed] = ACTIONS(2751),
    [anon_sym_unsigned] = ACTIONS(2751),
    [anon_sym_long] = ACTIONS(2751),
    [anon_sym_short] = ACTIONS(2751),
    [anon_sym_LBRACK] = ACTIONS(2751),
    [anon_sym_static] = ACTIONS(2751),
    [anon_sym_register] = ACTIONS(2751),
    [anon_sym_inline] = ACTIONS(2751),
    [anon_sym___inline] = ACTIONS(2751),
    [anon_sym___inline__] = ACTIONS(2751),
    [anon_sym___forceinline] = ACTIONS(2751),
    [anon_sym_thread_local] = ACTIONS(2751),
    [anon_sym___thread] = ACTIONS(2751),
    [anon_sym_const] = ACTIONS(2751),
    [anon_sym_constexpr] = ACTIONS(2751),
    [anon_sym_volatile] = ACTIONS(2751),
    [anon_sym_restrict] = ACTIONS(2751),
    [anon_sym___restrict__] = ACTIONS(2751),
    [anon_sym__Atomic] = ACTIONS(2751),
    [anon_sym__Noreturn] = ACTIONS(2751),
    [anon_sym_noreturn] = ACTIONS(2751),
    [anon_sym_mutable] = ACTIONS(2751),
    [anon_sym_constinit] = ACTIONS(2751),
    [anon_sym_consteval] = ACTIONS(2751),
    [anon_sym_PROGMEM] = ACTIONS(2751),
    [aux_sym_primitive_type_token1] = ACTIONS(2751),
    [anon_sym_byte] = ACTIONS(2751),
    [anon_sym_word] = ACTIONS(2751),
    [anon_sym_enum] = ACTIONS(2751),
    [anon_sym_class] = ACTIONS(2751),
    [anon_sym_struct] = ACTIONS(2751),
    [anon_sym_union] = ACTIONS(2751),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2751),
    [anon_sym_decltype] = ACTIONS(2751),
    [anon_sym_virtual] = ACTIONS(2751),
    [anon_sym_alignas] = ACTIONS(2751),
    [anon_sym_explicit] = ACTIONS(2751),
    [anon_sym_typename] = ACTIONS(2751),
    [anon_sym_template] = ACTIONS(2751),
    [anon_sym_operator] = ACTIONS(2751),
    [anon_sym_friend] = ACTIONS(2751),
    [anon_sym_public] = ACTIONS(2751),
    [anon_sym_private] = ACTIONS(2751),
    [anon_sym_protected] = ACTIONS(2751),
    [anon_sym_using] = ACTIONS(2751),
    [anon_sym_static_assert] = ACTIONS(2751),
  },
  [1865] = {
    [sym_identifier] = ACTIONS(4918),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4920),
    [anon_sym_COMMA] = ACTIONS(4920),
    [anon_sym_RPAREN] = ACTIONS(4920),
    [anon_sym_LPAREN2] = ACTIONS(4920),
    [anon_sym_DASH] = ACTIONS(4918),
    [anon_sym_PLUS] = ACTIONS(4918),
    [anon_sym_STAR] = ACTIONS(4920),
    [anon_sym_SLASH] = ACTIONS(4918),
    [anon_sym_PERCENT] = ACTIONS(4920),
    [anon_sym_PIPE_PIPE] = ACTIONS(4920),
    [anon_sym_AMP_AMP] = ACTIONS(4920),
    [anon_sym_PIPE] = ACTIONS(4918),
    [anon_sym_CARET] = ACTIONS(4920),
    [anon_sym_AMP] = ACTIONS(4918),
    [anon_sym_EQ_EQ] = ACTIONS(4920),
    [anon_sym_BANG_EQ] = ACTIONS(4920),
    [anon_sym_GT] = ACTIONS(4918),
    [anon_sym_GT_EQ] = ACTIONS(4920),
    [anon_sym_LT_EQ] = ACTIONS(4918),
    [anon_sym_LT] = ACTIONS(4918),
    [anon_sym_LT_LT] = ACTIONS(4920),
    [anon_sym_GT_GT] = ACTIONS(4920),
    [anon_sym_SEMI] = ACTIONS(4920),
    [anon_sym___extension__] = ACTIONS(4918),
    [anon_sym___attribute__] = ACTIONS(4918),
    [anon_sym_COLON_COLON] = ACTIONS(4922),
    [anon_sym___based] = ACTIONS(4918),
    [anon_sym_LBRACE] = ACTIONS(4920),
    [anon_sym_RBRACE] = ACTIONS(4920),
    [anon_sym_signed] = ACTIONS(4918),
    [anon_sym_unsigned] = ACTIONS(4918),
    [anon_sym_long] = ACTIONS(4918),
    [anon_sym_short] = ACTIONS(4918),
    [anon_sym_LBRACK] = ACTIONS(4920),
    [anon_sym_RBRACK] = ACTIONS(4920),
    [anon_sym_const] = ACTIONS(4918),
    [anon_sym_constexpr] = ACTIONS(4918),
    [anon_sym_volatile] = ACTIONS(4918),
    [anon_sym_restrict] = ACTIONS(4918),
    [anon_sym___restrict__] = ACTIONS(4918),
    [anon_sym__Atomic] = ACTIONS(4918),
    [anon_sym__Noreturn] = ACTIONS(4918),
    [anon_sym_noreturn] = ACTIONS(4918),
    [anon_sym_mutable] = ACTIONS(4918),
    [anon_sym_constinit] = ACTIONS(4918),
    [anon_sym_consteval] = ACTIONS(4918),
    [anon_sym_PROGMEM] = ACTIONS(4918),
    [aux_sym_primitive_type_token1] = ACTIONS(4918),
    [anon_sym_byte] = ACTIONS(4918),
    [anon_sym_word] = ACTIONS(4918),
    [anon_sym_COLON] = ACTIONS(4918),
    [anon_sym_QMARK] = ACTIONS(4920),
    [anon_sym_LT_EQ_GT] = ACTIONS(4920),
    [anon_sym_or] = ACTIONS(4918),
    [anon_sym_and] = ACTIONS(4918),
    [anon_sym_bitor] = ACTIONS(4918),
    [anon_sym_xor] = ACTIONS(4918),
    [anon_sym_bitand] = ACTIONS(4918),
    [anon_sym_not_eq] = ACTIONS(4918),
    [anon_sym_DASH_DASH] = ACTIONS(4920),
    [anon_sym_PLUS_PLUS] = ACTIONS(4920),
    [anon_sym_DOT] = ACTIONS(4918),
    [anon_sym_DOT_STAR] = ACTIONS(4920),
    [anon_sym_DASH_GT] = ACTIONS(4920),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4918),
    [anon_sym_decltype] = ACTIONS(4918),
    [anon_sym_final] = ACTIONS(4918),
    [anon_sym_override] = ACTIONS(4918),
    [anon_sym_requires] = ACTIONS(4918),
  },
  [1866] = {
    [sym__declaration_modifiers] = STATE(3458),
    [sym_attribute_specifier] = STATE(3458),
    [sym_attribute_declaration] = STATE(3458),
    [sym_ms_declspec_modifier] = STATE(3458),
    [sym_ms_based_modifier] = STATE(8318),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6066),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3458),
    [sym_type_qualifier] = STATE(3458),
    [sym_decltype] = STATE(8290),
    [sym_virtual] = STATE(3458),
    [sym_alignas_specifier] = STATE(3458),
    [sym_explicit_function_specifier] = STATE(3458),
    [sym_operator_cast] = STATE(6532),
    [sym__constructor_specifiers] = STATE(3458),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(8290),
    [sym_template_function] = STATE(6098),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5430),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_operator_cast_identifier] = STATE(6532),
    [sym_operator_name] = STATE(6098),
    [aux_sym_operator_cast_definition_repeat1] = STATE(3458),
    [sym_identifier] = ACTIONS(4841),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(4843),
    [anon_sym_extern] = ACTIONS(4845),
    [anon_sym___attribute__] = ACTIONS(4847),
    [anon_sym_COLON_COLON] = ACTIONS(4849),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4851),
    [anon_sym___declspec] = ACTIONS(4853),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(4845),
    [anon_sym_register] = ACTIONS(4845),
    [anon_sym_inline] = ACTIONS(4845),
    [anon_sym___inline] = ACTIONS(4845),
    [anon_sym___inline__] = ACTIONS(4845),
    [anon_sym___forceinline] = ACTIONS(4845),
    [anon_sym_thread_local] = ACTIONS(4845),
    [anon_sym___thread] = ACTIONS(4845),
    [anon_sym_const] = ACTIONS(4843),
    [anon_sym_constexpr] = ACTIONS(4843),
    [anon_sym_volatile] = ACTIONS(4843),
    [anon_sym_restrict] = ACTIONS(4843),
    [anon_sym___restrict__] = ACTIONS(4843),
    [anon_sym__Atomic] = ACTIONS(4843),
    [anon_sym__Noreturn] = ACTIONS(4843),
    [anon_sym_noreturn] = ACTIONS(4843),
    [anon_sym_mutable] = ACTIONS(4843),
    [anon_sym_constinit] = ACTIONS(4843),
    [anon_sym_consteval] = ACTIONS(4843),
    [anon_sym_PROGMEM] = ACTIONS(4843),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_virtual] = ACTIONS(4855),
    [anon_sym_alignas] = ACTIONS(4857),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_operator] = ACTIONS(133),
  },
  [1867] = {
    [sym_identifier] = ACTIONS(2639),
    [aux_sym_preproc_def_token1] = ACTIONS(2639),
    [aux_sym_preproc_if_token1] = ACTIONS(2639),
    [aux_sym_preproc_if_token2] = ACTIONS(2639),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2639),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2639),
    [aux_sym_preproc_else_token1] = ACTIONS(2639),
    [aux_sym_preproc_elif_token1] = ACTIONS(2639),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2639),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2639),
    [sym_preproc_directive] = ACTIONS(2639),
    [anon_sym_LPAREN2] = ACTIONS(2641),
    [anon_sym_TILDE] = ACTIONS(2641),
    [anon_sym_STAR] = ACTIONS(2641),
    [anon_sym_AMP_AMP] = ACTIONS(2641),
    [anon_sym_AMP] = ACTIONS(2639),
    [anon_sym___extension__] = ACTIONS(2639),
    [anon_sym_typedef] = ACTIONS(2639),
    [anon_sym_extern] = ACTIONS(2639),
    [anon_sym___attribute__] = ACTIONS(2639),
    [anon_sym_COLON_COLON] = ACTIONS(2641),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2641),
    [anon_sym___declspec] = ACTIONS(2639),
    [anon_sym___based] = ACTIONS(2639),
    [anon_sym_signed] = ACTIONS(2639),
    [anon_sym_unsigned] = ACTIONS(2639),
    [anon_sym_long] = ACTIONS(2639),
    [anon_sym_short] = ACTIONS(2639),
    [anon_sym_LBRACK] = ACTIONS(2639),
    [anon_sym_static] = ACTIONS(2639),
    [anon_sym_register] = ACTIONS(2639),
    [anon_sym_inline] = ACTIONS(2639),
    [anon_sym___inline] = ACTIONS(2639),
    [anon_sym___inline__] = ACTIONS(2639),
    [anon_sym___forceinline] = ACTIONS(2639),
    [anon_sym_thread_local] = ACTIONS(2639),
    [anon_sym___thread] = ACTIONS(2639),
    [anon_sym_const] = ACTIONS(2639),
    [anon_sym_constexpr] = ACTIONS(2639),
    [anon_sym_volatile] = ACTIONS(2639),
    [anon_sym_restrict] = ACTIONS(2639),
    [anon_sym___restrict__] = ACTIONS(2639),
    [anon_sym__Atomic] = ACTIONS(2639),
    [anon_sym__Noreturn] = ACTIONS(2639),
    [anon_sym_noreturn] = ACTIONS(2639),
    [anon_sym_mutable] = ACTIONS(2639),
    [anon_sym_constinit] = ACTIONS(2639),
    [anon_sym_consteval] = ACTIONS(2639),
    [anon_sym_PROGMEM] = ACTIONS(2639),
    [aux_sym_primitive_type_token1] = ACTIONS(2639),
    [anon_sym_byte] = ACTIONS(2639),
    [anon_sym_word] = ACTIONS(2639),
    [anon_sym_enum] = ACTIONS(2639),
    [anon_sym_class] = ACTIONS(2639),
    [anon_sym_struct] = ACTIONS(2639),
    [anon_sym_union] = ACTIONS(2639),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2639),
    [anon_sym_decltype] = ACTIONS(2639),
    [anon_sym_virtual] = ACTIONS(2639),
    [anon_sym_alignas] = ACTIONS(2639),
    [anon_sym_explicit] = ACTIONS(2639),
    [anon_sym_typename] = ACTIONS(2639),
    [anon_sym_template] = ACTIONS(2639),
    [anon_sym_operator] = ACTIONS(2639),
    [anon_sym_friend] = ACTIONS(2639),
    [anon_sym_public] = ACTIONS(2639),
    [anon_sym_private] = ACTIONS(2639),
    [anon_sym_protected] = ACTIONS(2639),
    [anon_sym_using] = ACTIONS(2639),
    [anon_sym_static_assert] = ACTIONS(2639),
  },
  [1868] = {
    [sym_identifier] = ACTIONS(3060),
    [aux_sym_preproc_def_token1] = ACTIONS(3060),
    [aux_sym_preproc_if_token1] = ACTIONS(3060),
    [aux_sym_preproc_if_token2] = ACTIONS(3060),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3060),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3060),
    [aux_sym_preproc_else_token1] = ACTIONS(3060),
    [aux_sym_preproc_elif_token1] = ACTIONS(3060),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3060),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3060),
    [sym_preproc_directive] = ACTIONS(3060),
    [anon_sym_LPAREN2] = ACTIONS(3062),
    [anon_sym_TILDE] = ACTIONS(3062),
    [anon_sym_STAR] = ACTIONS(3062),
    [anon_sym_AMP_AMP] = ACTIONS(3062),
    [anon_sym_AMP] = ACTIONS(3060),
    [anon_sym___extension__] = ACTIONS(3060),
    [anon_sym_typedef] = ACTIONS(3060),
    [anon_sym_extern] = ACTIONS(3060),
    [anon_sym___attribute__] = ACTIONS(3060),
    [anon_sym_COLON_COLON] = ACTIONS(3062),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3062),
    [anon_sym___declspec] = ACTIONS(3060),
    [anon_sym___based] = ACTIONS(3060),
    [anon_sym_signed] = ACTIONS(3060),
    [anon_sym_unsigned] = ACTIONS(3060),
    [anon_sym_long] = ACTIONS(3060),
    [anon_sym_short] = ACTIONS(3060),
    [anon_sym_LBRACK] = ACTIONS(3060),
    [anon_sym_static] = ACTIONS(3060),
    [anon_sym_register] = ACTIONS(3060),
    [anon_sym_inline] = ACTIONS(3060),
    [anon_sym___inline] = ACTIONS(3060),
    [anon_sym___inline__] = ACTIONS(3060),
    [anon_sym___forceinline] = ACTIONS(3060),
    [anon_sym_thread_local] = ACTIONS(3060),
    [anon_sym___thread] = ACTIONS(3060),
    [anon_sym_const] = ACTIONS(3060),
    [anon_sym_constexpr] = ACTIONS(3060),
    [anon_sym_volatile] = ACTIONS(3060),
    [anon_sym_restrict] = ACTIONS(3060),
    [anon_sym___restrict__] = ACTIONS(3060),
    [anon_sym__Atomic] = ACTIONS(3060),
    [anon_sym__Noreturn] = ACTIONS(3060),
    [anon_sym_noreturn] = ACTIONS(3060),
    [anon_sym_mutable] = ACTIONS(3060),
    [anon_sym_constinit] = ACTIONS(3060),
    [anon_sym_consteval] = ACTIONS(3060),
    [anon_sym_PROGMEM] = ACTIONS(3060),
    [aux_sym_primitive_type_token1] = ACTIONS(3060),
    [anon_sym_byte] = ACTIONS(3060),
    [anon_sym_word] = ACTIONS(3060),
    [anon_sym_enum] = ACTIONS(3060),
    [anon_sym_class] = ACTIONS(3060),
    [anon_sym_struct] = ACTIONS(3060),
    [anon_sym_union] = ACTIONS(3060),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3060),
    [anon_sym_decltype] = ACTIONS(3060),
    [anon_sym_virtual] = ACTIONS(3060),
    [anon_sym_alignas] = ACTIONS(3060),
    [anon_sym_explicit] = ACTIONS(3060),
    [anon_sym_typename] = ACTIONS(3060),
    [anon_sym_template] = ACTIONS(3060),
    [anon_sym_operator] = ACTIONS(3060),
    [anon_sym_friend] = ACTIONS(3060),
    [anon_sym_public] = ACTIONS(3060),
    [anon_sym_private] = ACTIONS(3060),
    [anon_sym_protected] = ACTIONS(3060),
    [anon_sym_using] = ACTIONS(3060),
    [anon_sym_static_assert] = ACTIONS(3060),
  },
  [1869] = {
    [sym_identifier] = ACTIONS(4918),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4920),
    [anon_sym_COMMA] = ACTIONS(4920),
    [anon_sym_RPAREN] = ACTIONS(4920),
    [anon_sym_LPAREN2] = ACTIONS(4920),
    [anon_sym_DASH] = ACTIONS(4918),
    [anon_sym_PLUS] = ACTIONS(4918),
    [anon_sym_STAR] = ACTIONS(4920),
    [anon_sym_SLASH] = ACTIONS(4918),
    [anon_sym_PERCENT] = ACTIONS(4920),
    [anon_sym_PIPE_PIPE] = ACTIONS(4920),
    [anon_sym_AMP_AMP] = ACTIONS(4920),
    [anon_sym_PIPE] = ACTIONS(4918),
    [anon_sym_CARET] = ACTIONS(4920),
    [anon_sym_AMP] = ACTIONS(4918),
    [anon_sym_EQ_EQ] = ACTIONS(4920),
    [anon_sym_BANG_EQ] = ACTIONS(4920),
    [anon_sym_GT] = ACTIONS(4918),
    [anon_sym_GT_EQ] = ACTIONS(4920),
    [anon_sym_LT_EQ] = ACTIONS(4918),
    [anon_sym_LT] = ACTIONS(4918),
    [anon_sym_LT_LT] = ACTIONS(4920),
    [anon_sym_GT_GT] = ACTIONS(4920),
    [anon_sym_SEMI] = ACTIONS(4920),
    [anon_sym___extension__] = ACTIONS(4918),
    [anon_sym___attribute__] = ACTIONS(4918),
    [anon_sym_COLON_COLON] = ACTIONS(4922),
    [anon_sym___based] = ACTIONS(4918),
    [anon_sym_LBRACE] = ACTIONS(4920),
    [anon_sym_RBRACE] = ACTIONS(4920),
    [anon_sym_signed] = ACTIONS(4918),
    [anon_sym_unsigned] = ACTIONS(4918),
    [anon_sym_long] = ACTIONS(4918),
    [anon_sym_short] = ACTIONS(4918),
    [anon_sym_LBRACK] = ACTIONS(4920),
    [anon_sym_RBRACK] = ACTIONS(4920),
    [anon_sym_const] = ACTIONS(4918),
    [anon_sym_constexpr] = ACTIONS(4918),
    [anon_sym_volatile] = ACTIONS(4918),
    [anon_sym_restrict] = ACTIONS(4918),
    [anon_sym___restrict__] = ACTIONS(4918),
    [anon_sym__Atomic] = ACTIONS(4918),
    [anon_sym__Noreturn] = ACTIONS(4918),
    [anon_sym_noreturn] = ACTIONS(4918),
    [anon_sym_mutable] = ACTIONS(4918),
    [anon_sym_constinit] = ACTIONS(4918),
    [anon_sym_consteval] = ACTIONS(4918),
    [anon_sym_PROGMEM] = ACTIONS(4918),
    [aux_sym_primitive_type_token1] = ACTIONS(4918),
    [anon_sym_byte] = ACTIONS(4918),
    [anon_sym_word] = ACTIONS(4918),
    [anon_sym_COLON] = ACTIONS(4918),
    [anon_sym_QMARK] = ACTIONS(4920),
    [anon_sym_LT_EQ_GT] = ACTIONS(4920),
    [anon_sym_or] = ACTIONS(4918),
    [anon_sym_and] = ACTIONS(4918),
    [anon_sym_bitor] = ACTIONS(4918),
    [anon_sym_xor] = ACTIONS(4918),
    [anon_sym_bitand] = ACTIONS(4918),
    [anon_sym_not_eq] = ACTIONS(4918),
    [anon_sym_DASH_DASH] = ACTIONS(4920),
    [anon_sym_PLUS_PLUS] = ACTIONS(4920),
    [anon_sym_DOT] = ACTIONS(4918),
    [anon_sym_DOT_STAR] = ACTIONS(4920),
    [anon_sym_DASH_GT] = ACTIONS(4920),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4918),
    [anon_sym_decltype] = ACTIONS(4918),
    [anon_sym_final] = ACTIONS(4918),
    [anon_sym_override] = ACTIONS(4918),
    [anon_sym_requires] = ACTIONS(4918),
  },
  [1870] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [aux_sym_preproc_else_token1] = ACTIONS(3072),
    [aux_sym_preproc_elif_token1] = ACTIONS(3072),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_friend] = ACTIONS(3072),
    [anon_sym_public] = ACTIONS(3072),
    [anon_sym_private] = ACTIONS(3072),
    [anon_sym_protected] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
  },
  [1871] = {
    [sym_identifier] = ACTIONS(2797),
    [aux_sym_preproc_def_token1] = ACTIONS(2797),
    [aux_sym_preproc_if_token1] = ACTIONS(2797),
    [aux_sym_preproc_if_token2] = ACTIONS(2797),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2797),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2797),
    [aux_sym_preproc_else_token1] = ACTIONS(2797),
    [aux_sym_preproc_elif_token1] = ACTIONS(2797),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2797),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2797),
    [sym_preproc_directive] = ACTIONS(2797),
    [anon_sym_LPAREN2] = ACTIONS(2799),
    [anon_sym_TILDE] = ACTIONS(2799),
    [anon_sym_STAR] = ACTIONS(2799),
    [anon_sym_AMP_AMP] = ACTIONS(2799),
    [anon_sym_AMP] = ACTIONS(2797),
    [anon_sym___extension__] = ACTIONS(2797),
    [anon_sym_typedef] = ACTIONS(2797),
    [anon_sym_extern] = ACTIONS(2797),
    [anon_sym___attribute__] = ACTIONS(2797),
    [anon_sym_COLON_COLON] = ACTIONS(2799),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2799),
    [anon_sym___declspec] = ACTIONS(2797),
    [anon_sym___based] = ACTIONS(2797),
    [anon_sym_signed] = ACTIONS(2797),
    [anon_sym_unsigned] = ACTIONS(2797),
    [anon_sym_long] = ACTIONS(2797),
    [anon_sym_short] = ACTIONS(2797),
    [anon_sym_LBRACK] = ACTIONS(2797),
    [anon_sym_static] = ACTIONS(2797),
    [anon_sym_register] = ACTIONS(2797),
    [anon_sym_inline] = ACTIONS(2797),
    [anon_sym___inline] = ACTIONS(2797),
    [anon_sym___inline__] = ACTIONS(2797),
    [anon_sym___forceinline] = ACTIONS(2797),
    [anon_sym_thread_local] = ACTIONS(2797),
    [anon_sym___thread] = ACTIONS(2797),
    [anon_sym_const] = ACTIONS(2797),
    [anon_sym_constexpr] = ACTIONS(2797),
    [anon_sym_volatile] = ACTIONS(2797),
    [anon_sym_restrict] = ACTIONS(2797),
    [anon_sym___restrict__] = ACTIONS(2797),
    [anon_sym__Atomic] = ACTIONS(2797),
    [anon_sym__Noreturn] = ACTIONS(2797),
    [anon_sym_noreturn] = ACTIONS(2797),
    [anon_sym_mutable] = ACTIONS(2797),
    [anon_sym_constinit] = ACTIONS(2797),
    [anon_sym_consteval] = ACTIONS(2797),
    [anon_sym_PROGMEM] = ACTIONS(2797),
    [aux_sym_primitive_type_token1] = ACTIONS(2797),
    [anon_sym_byte] = ACTIONS(2797),
    [anon_sym_word] = ACTIONS(2797),
    [anon_sym_enum] = ACTIONS(2797),
    [anon_sym_class] = ACTIONS(2797),
    [anon_sym_struct] = ACTIONS(2797),
    [anon_sym_union] = ACTIONS(2797),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2797),
    [anon_sym_decltype] = ACTIONS(2797),
    [anon_sym_virtual] = ACTIONS(2797),
    [anon_sym_alignas] = ACTIONS(2797),
    [anon_sym_explicit] = ACTIONS(2797),
    [anon_sym_typename] = ACTIONS(2797),
    [anon_sym_template] = ACTIONS(2797),
    [anon_sym_operator] = ACTIONS(2797),
    [anon_sym_friend] = ACTIONS(2797),
    [anon_sym_public] = ACTIONS(2797),
    [anon_sym_private] = ACTIONS(2797),
    [anon_sym_protected] = ACTIONS(2797),
    [anon_sym_using] = ACTIONS(2797),
    [anon_sym_static_assert] = ACTIONS(2797),
  },
  [1872] = {
    [sym_identifier] = ACTIONS(4914),
    [aux_sym_preproc_def_token1] = ACTIONS(4914),
    [aux_sym_preproc_if_token1] = ACTIONS(4914),
    [aux_sym_preproc_if_token2] = ACTIONS(4914),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4914),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4914),
    [aux_sym_preproc_else_token1] = ACTIONS(4914),
    [aux_sym_preproc_elif_token1] = ACTIONS(4914),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4914),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4914),
    [sym_preproc_directive] = ACTIONS(4914),
    [anon_sym_LPAREN2] = ACTIONS(4916),
    [anon_sym_TILDE] = ACTIONS(4916),
    [anon_sym_STAR] = ACTIONS(4916),
    [anon_sym_AMP_AMP] = ACTIONS(4916),
    [anon_sym_AMP] = ACTIONS(4914),
    [anon_sym___extension__] = ACTIONS(4914),
    [anon_sym_typedef] = ACTIONS(4914),
    [anon_sym_extern] = ACTIONS(4914),
    [anon_sym___attribute__] = ACTIONS(4914),
    [anon_sym_COLON_COLON] = ACTIONS(4916),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4916),
    [anon_sym___declspec] = ACTIONS(4914),
    [anon_sym___based] = ACTIONS(4914),
    [anon_sym_signed] = ACTIONS(4914),
    [anon_sym_unsigned] = ACTIONS(4914),
    [anon_sym_long] = ACTIONS(4914),
    [anon_sym_short] = ACTIONS(4914),
    [anon_sym_LBRACK] = ACTIONS(4914),
    [anon_sym_static] = ACTIONS(4914),
    [anon_sym_register] = ACTIONS(4914),
    [anon_sym_inline] = ACTIONS(4914),
    [anon_sym___inline] = ACTIONS(4914),
    [anon_sym___inline__] = ACTIONS(4914),
    [anon_sym___forceinline] = ACTIONS(4914),
    [anon_sym_thread_local] = ACTIONS(4914),
    [anon_sym___thread] = ACTIONS(4914),
    [anon_sym_const] = ACTIONS(4914),
    [anon_sym_constexpr] = ACTIONS(4914),
    [anon_sym_volatile] = ACTIONS(4914),
    [anon_sym_restrict] = ACTIONS(4914),
    [anon_sym___restrict__] = ACTIONS(4914),
    [anon_sym__Atomic] = ACTIONS(4914),
    [anon_sym__Noreturn] = ACTIONS(4914),
    [anon_sym_noreturn] = ACTIONS(4914),
    [anon_sym_mutable] = ACTIONS(4914),
    [anon_sym_constinit] = ACTIONS(4914),
    [anon_sym_consteval] = ACTIONS(4914),
    [anon_sym_PROGMEM] = ACTIONS(4914),
    [aux_sym_primitive_type_token1] = ACTIONS(4914),
    [anon_sym_byte] = ACTIONS(4914),
    [anon_sym_word] = ACTIONS(4914),
    [anon_sym_enum] = ACTIONS(4914),
    [anon_sym_class] = ACTIONS(4914),
    [anon_sym_struct] = ACTIONS(4914),
    [anon_sym_union] = ACTIONS(4914),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4914),
    [anon_sym_decltype] = ACTIONS(4914),
    [anon_sym_virtual] = ACTIONS(4914),
    [anon_sym_alignas] = ACTIONS(4914),
    [anon_sym_explicit] = ACTIONS(4914),
    [anon_sym_typename] = ACTIONS(4914),
    [anon_sym_template] = ACTIONS(4914),
    [anon_sym_operator] = ACTIONS(4914),
    [anon_sym_friend] = ACTIONS(4914),
    [anon_sym_public] = ACTIONS(4914),
    [anon_sym_private] = ACTIONS(4914),
    [anon_sym_protected] = ACTIONS(4914),
    [anon_sym_using] = ACTIONS(4914),
    [anon_sym_static_assert] = ACTIONS(4914),
  },
  [1873] = {
    [sym_identifier] = ACTIONS(2723),
    [aux_sym_preproc_def_token1] = ACTIONS(2723),
    [aux_sym_preproc_if_token1] = ACTIONS(2723),
    [aux_sym_preproc_if_token2] = ACTIONS(2723),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2723),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2723),
    [aux_sym_preproc_else_token1] = ACTIONS(2723),
    [aux_sym_preproc_elif_token1] = ACTIONS(2723),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2723),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2723),
    [sym_preproc_directive] = ACTIONS(2723),
    [anon_sym_LPAREN2] = ACTIONS(2725),
    [anon_sym_TILDE] = ACTIONS(2725),
    [anon_sym_STAR] = ACTIONS(2725),
    [anon_sym_AMP_AMP] = ACTIONS(2725),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym___extension__] = ACTIONS(2723),
    [anon_sym_typedef] = ACTIONS(2723),
    [anon_sym_extern] = ACTIONS(2723),
    [anon_sym___attribute__] = ACTIONS(2723),
    [anon_sym_COLON_COLON] = ACTIONS(2725),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2725),
    [anon_sym___declspec] = ACTIONS(2723),
    [anon_sym___based] = ACTIONS(2723),
    [anon_sym_signed] = ACTIONS(2723),
    [anon_sym_unsigned] = ACTIONS(2723),
    [anon_sym_long] = ACTIONS(2723),
    [anon_sym_short] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_static] = ACTIONS(2723),
    [anon_sym_register] = ACTIONS(2723),
    [anon_sym_inline] = ACTIONS(2723),
    [anon_sym___inline] = ACTIONS(2723),
    [anon_sym___inline__] = ACTIONS(2723),
    [anon_sym___forceinline] = ACTIONS(2723),
    [anon_sym_thread_local] = ACTIONS(2723),
    [anon_sym___thread] = ACTIONS(2723),
    [anon_sym_const] = ACTIONS(2723),
    [anon_sym_constexpr] = ACTIONS(2723),
    [anon_sym_volatile] = ACTIONS(2723),
    [anon_sym_restrict] = ACTIONS(2723),
    [anon_sym___restrict__] = ACTIONS(2723),
    [anon_sym__Atomic] = ACTIONS(2723),
    [anon_sym__Noreturn] = ACTIONS(2723),
    [anon_sym_noreturn] = ACTIONS(2723),
    [anon_sym_mutable] = ACTIONS(2723),
    [anon_sym_constinit] = ACTIONS(2723),
    [anon_sym_consteval] = ACTIONS(2723),
    [anon_sym_PROGMEM] = ACTIONS(2723),
    [aux_sym_primitive_type_token1] = ACTIONS(2723),
    [anon_sym_byte] = ACTIONS(2723),
    [anon_sym_word] = ACTIONS(2723),
    [anon_sym_enum] = ACTIONS(2723),
    [anon_sym_class] = ACTIONS(2723),
    [anon_sym_struct] = ACTIONS(2723),
    [anon_sym_union] = ACTIONS(2723),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2723),
    [anon_sym_decltype] = ACTIONS(2723),
    [anon_sym_virtual] = ACTIONS(2723),
    [anon_sym_alignas] = ACTIONS(2723),
    [anon_sym_explicit] = ACTIONS(2723),
    [anon_sym_typename] = ACTIONS(2723),
    [anon_sym_template] = ACTIONS(2723),
    [anon_sym_operator] = ACTIONS(2723),
    [anon_sym_friend] = ACTIONS(2723),
    [anon_sym_public] = ACTIONS(2723),
    [anon_sym_private] = ACTIONS(2723),
    [anon_sym_protected] = ACTIONS(2723),
    [anon_sym_using] = ACTIONS(2723),
    [anon_sym_static_assert] = ACTIONS(2723),
  },
  [1874] = {
    [sym_identifier] = ACTIONS(4924),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4926),
    [anon_sym_COMMA] = ACTIONS(4926),
    [anon_sym_RPAREN] = ACTIONS(4926),
    [anon_sym_LPAREN2] = ACTIONS(4926),
    [anon_sym_DASH] = ACTIONS(4924),
    [anon_sym_PLUS] = ACTIONS(4924),
    [anon_sym_STAR] = ACTIONS(4926),
    [anon_sym_SLASH] = ACTIONS(4924),
    [anon_sym_PERCENT] = ACTIONS(4926),
    [anon_sym_PIPE_PIPE] = ACTIONS(4926),
    [anon_sym_AMP_AMP] = ACTIONS(4926),
    [anon_sym_PIPE] = ACTIONS(4924),
    [anon_sym_CARET] = ACTIONS(4926),
    [anon_sym_AMP] = ACTIONS(4924),
    [anon_sym_EQ_EQ] = ACTIONS(4926),
    [anon_sym_BANG_EQ] = ACTIONS(4926),
    [anon_sym_GT] = ACTIONS(4924),
    [anon_sym_GT_EQ] = ACTIONS(4926),
    [anon_sym_LT_EQ] = ACTIONS(4924),
    [anon_sym_LT] = ACTIONS(4924),
    [anon_sym_LT_LT] = ACTIONS(4926),
    [anon_sym_GT_GT] = ACTIONS(4926),
    [anon_sym_SEMI] = ACTIONS(4926),
    [anon_sym___extension__] = ACTIONS(4924),
    [anon_sym___attribute__] = ACTIONS(4924),
    [anon_sym_COLON_COLON] = ACTIONS(4922),
    [anon_sym___based] = ACTIONS(4924),
    [anon_sym_LBRACE] = ACTIONS(4926),
    [anon_sym_RBRACE] = ACTIONS(4926),
    [anon_sym_signed] = ACTIONS(4924),
    [anon_sym_unsigned] = ACTIONS(4924),
    [anon_sym_long] = ACTIONS(4924),
    [anon_sym_short] = ACTIONS(4924),
    [anon_sym_LBRACK] = ACTIONS(4926),
    [anon_sym_RBRACK] = ACTIONS(4926),
    [anon_sym_const] = ACTIONS(4924),
    [anon_sym_constexpr] = ACTIONS(4924),
    [anon_sym_volatile] = ACTIONS(4924),
    [anon_sym_restrict] = ACTIONS(4924),
    [anon_sym___restrict__] = ACTIONS(4924),
    [anon_sym__Atomic] = ACTIONS(4924),
    [anon_sym__Noreturn] = ACTIONS(4924),
    [anon_sym_noreturn] = ACTIONS(4924),
    [anon_sym_mutable] = ACTIONS(4924),
    [anon_sym_constinit] = ACTIONS(4924),
    [anon_sym_consteval] = ACTIONS(4924),
    [anon_sym_PROGMEM] = ACTIONS(4924),
    [aux_sym_primitive_type_token1] = ACTIONS(4924),
    [anon_sym_byte] = ACTIONS(4924),
    [anon_sym_word] = ACTIONS(4924),
    [anon_sym_COLON] = ACTIONS(4924),
    [anon_sym_QMARK] = ACTIONS(4926),
    [anon_sym_LT_EQ_GT] = ACTIONS(4926),
    [anon_sym_or] = ACTIONS(4924),
    [anon_sym_and] = ACTIONS(4924),
    [anon_sym_bitor] = ACTIONS(4924),
    [anon_sym_xor] = ACTIONS(4924),
    [anon_sym_bitand] = ACTIONS(4924),
    [anon_sym_not_eq] = ACTIONS(4924),
    [anon_sym_DASH_DASH] = ACTIONS(4926),
    [anon_sym_PLUS_PLUS] = ACTIONS(4926),
    [anon_sym_DOT] = ACTIONS(4924),
    [anon_sym_DOT_STAR] = ACTIONS(4926),
    [anon_sym_DASH_GT] = ACTIONS(4926),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4924),
    [anon_sym_decltype] = ACTIONS(4924),
    [anon_sym_final] = ACTIONS(4924),
    [anon_sym_override] = ACTIONS(4924),
    [anon_sym_requires] = ACTIONS(4924),
  },
  [1875] = {
    [sym_identifier] = ACTIONS(4555),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4557),
    [anon_sym_COMMA] = ACTIONS(4557),
    [anon_sym_RPAREN] = ACTIONS(4557),
    [anon_sym_LPAREN2] = ACTIONS(4557),
    [anon_sym_DASH] = ACTIONS(4555),
    [anon_sym_PLUS] = ACTIONS(4555),
    [anon_sym_STAR] = ACTIONS(4557),
    [anon_sym_SLASH] = ACTIONS(4555),
    [anon_sym_PERCENT] = ACTIONS(4557),
    [anon_sym_PIPE_PIPE] = ACTIONS(4557),
    [anon_sym_AMP_AMP] = ACTIONS(4557),
    [anon_sym_PIPE] = ACTIONS(4555),
    [anon_sym_CARET] = ACTIONS(4557),
    [anon_sym_AMP] = ACTIONS(4555),
    [anon_sym_EQ_EQ] = ACTIONS(4557),
    [anon_sym_BANG_EQ] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4555),
    [anon_sym_GT_EQ] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4555),
    [anon_sym_LT_LT] = ACTIONS(4557),
    [anon_sym_GT_GT] = ACTIONS(4557),
    [anon_sym_SEMI] = ACTIONS(4557),
    [anon_sym___extension__] = ACTIONS(4555),
    [anon_sym___attribute__] = ACTIONS(4555),
    [anon_sym_COLON_COLON] = ACTIONS(4557),
    [anon_sym___based] = ACTIONS(4555),
    [anon_sym_LBRACE] = ACTIONS(4557),
    [anon_sym_RBRACE] = ACTIONS(4557),
    [anon_sym_signed] = ACTIONS(4555),
    [anon_sym_unsigned] = ACTIONS(4555),
    [anon_sym_long] = ACTIONS(4555),
    [anon_sym_short] = ACTIONS(4555),
    [anon_sym_LBRACK] = ACTIONS(4557),
    [anon_sym_RBRACK] = ACTIONS(4557),
    [anon_sym_const] = ACTIONS(4555),
    [anon_sym_constexpr] = ACTIONS(4555),
    [anon_sym_volatile] = ACTIONS(4555),
    [anon_sym_restrict] = ACTIONS(4555),
    [anon_sym___restrict__] = ACTIONS(4555),
    [anon_sym__Atomic] = ACTIONS(4555),
    [anon_sym__Noreturn] = ACTIONS(4555),
    [anon_sym_noreturn] = ACTIONS(4555),
    [anon_sym_mutable] = ACTIONS(4555),
    [anon_sym_constinit] = ACTIONS(4555),
    [anon_sym_consteval] = ACTIONS(4555),
    [anon_sym_PROGMEM] = ACTIONS(4555),
    [aux_sym_primitive_type_token1] = ACTIONS(4555),
    [anon_sym_byte] = ACTIONS(4555),
    [anon_sym_word] = ACTIONS(4555),
    [anon_sym_COLON] = ACTIONS(4555),
    [anon_sym_QMARK] = ACTIONS(4557),
    [anon_sym_LT_EQ_GT] = ACTIONS(4557),
    [anon_sym_or] = ACTIONS(4555),
    [anon_sym_and] = ACTIONS(4555),
    [anon_sym_bitor] = ACTIONS(4555),
    [anon_sym_xor] = ACTIONS(4555),
    [anon_sym_bitand] = ACTIONS(4555),
    [anon_sym_not_eq] = ACTIONS(4555),
    [anon_sym_DASH_DASH] = ACTIONS(4557),
    [anon_sym_PLUS_PLUS] = ACTIONS(4557),
    [anon_sym_DOT] = ACTIONS(4555),
    [anon_sym_DOT_STAR] = ACTIONS(4557),
    [anon_sym_DASH_GT] = ACTIONS(4557),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4555),
    [anon_sym_decltype] = ACTIONS(4555),
    [anon_sym_final] = ACTIONS(4555),
    [anon_sym_override] = ACTIONS(4555),
    [anon_sym_requires] = ACTIONS(4555),
  },
  [1876] = {
    [sym_identifier] = ACTIONS(4898),
    [aux_sym_preproc_def_token1] = ACTIONS(4898),
    [aux_sym_preproc_if_token1] = ACTIONS(4898),
    [aux_sym_preproc_if_token2] = ACTIONS(4898),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4898),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4898),
    [aux_sym_preproc_else_token1] = ACTIONS(4898),
    [aux_sym_preproc_elif_token1] = ACTIONS(4898),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4898),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4898),
    [sym_preproc_directive] = ACTIONS(4898),
    [anon_sym_LPAREN2] = ACTIONS(4900),
    [anon_sym_TILDE] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_AMP_AMP] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4898),
    [anon_sym___extension__] = ACTIONS(4898),
    [anon_sym_typedef] = ACTIONS(4898),
    [anon_sym_extern] = ACTIONS(4898),
    [anon_sym___attribute__] = ACTIONS(4898),
    [anon_sym_COLON_COLON] = ACTIONS(4900),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4900),
    [anon_sym___declspec] = ACTIONS(4898),
    [anon_sym___based] = ACTIONS(4898),
    [anon_sym_signed] = ACTIONS(4898),
    [anon_sym_unsigned] = ACTIONS(4898),
    [anon_sym_long] = ACTIONS(4898),
    [anon_sym_short] = ACTIONS(4898),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_static] = ACTIONS(4898),
    [anon_sym_register] = ACTIONS(4898),
    [anon_sym_inline] = ACTIONS(4898),
    [anon_sym___inline] = ACTIONS(4898),
    [anon_sym___inline__] = ACTIONS(4898),
    [anon_sym___forceinline] = ACTIONS(4898),
    [anon_sym_thread_local] = ACTIONS(4898),
    [anon_sym___thread] = ACTIONS(4898),
    [anon_sym_const] = ACTIONS(4898),
    [anon_sym_constexpr] = ACTIONS(4898),
    [anon_sym_volatile] = ACTIONS(4898),
    [anon_sym_restrict] = ACTIONS(4898),
    [anon_sym___restrict__] = ACTIONS(4898),
    [anon_sym__Atomic] = ACTIONS(4898),
    [anon_sym__Noreturn] = ACTIONS(4898),
    [anon_sym_noreturn] = ACTIONS(4898),
    [anon_sym_mutable] = ACTIONS(4898),
    [anon_sym_constinit] = ACTIONS(4898),
    [anon_sym_consteval] = ACTIONS(4898),
    [anon_sym_PROGMEM] = ACTIONS(4898),
    [aux_sym_primitive_type_token1] = ACTIONS(4898),
    [anon_sym_byte] = ACTIONS(4898),
    [anon_sym_word] = ACTIONS(4898),
    [anon_sym_enum] = ACTIONS(4898),
    [anon_sym_class] = ACTIONS(4898),
    [anon_sym_struct] = ACTIONS(4898),
    [anon_sym_union] = ACTIONS(4898),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4898),
    [anon_sym_decltype] = ACTIONS(4898),
    [anon_sym_virtual] = ACTIONS(4898),
    [anon_sym_alignas] = ACTIONS(4898),
    [anon_sym_explicit] = ACTIONS(4898),
    [anon_sym_typename] = ACTIONS(4898),
    [anon_sym_template] = ACTIONS(4898),
    [anon_sym_operator] = ACTIONS(4898),
    [anon_sym_friend] = ACTIONS(4898),
    [anon_sym_public] = ACTIONS(4898),
    [anon_sym_private] = ACTIONS(4898),
    [anon_sym_protected] = ACTIONS(4898),
    [anon_sym_using] = ACTIONS(4898),
    [anon_sym_static_assert] = ACTIONS(4898),
  },
  [1877] = {
    [sym_identifier] = ACTIONS(2783),
    [aux_sym_preproc_def_token1] = ACTIONS(2783),
    [aux_sym_preproc_if_token1] = ACTIONS(2783),
    [aux_sym_preproc_if_token2] = ACTIONS(2783),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2783),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2783),
    [aux_sym_preproc_else_token1] = ACTIONS(2783),
    [aux_sym_preproc_elif_token1] = ACTIONS(2783),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2783),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2783),
    [sym_preproc_directive] = ACTIONS(2783),
    [anon_sym_LPAREN2] = ACTIONS(2785),
    [anon_sym_TILDE] = ACTIONS(2785),
    [anon_sym_STAR] = ACTIONS(2785),
    [anon_sym_AMP_AMP] = ACTIONS(2785),
    [anon_sym_AMP] = ACTIONS(2783),
    [anon_sym___extension__] = ACTIONS(2783),
    [anon_sym_typedef] = ACTIONS(2783),
    [anon_sym_extern] = ACTIONS(2783),
    [anon_sym___attribute__] = ACTIONS(2783),
    [anon_sym_COLON_COLON] = ACTIONS(2785),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2785),
    [anon_sym___declspec] = ACTIONS(2783),
    [anon_sym___based] = ACTIONS(2783),
    [anon_sym_signed] = ACTIONS(2783),
    [anon_sym_unsigned] = ACTIONS(2783),
    [anon_sym_long] = ACTIONS(2783),
    [anon_sym_short] = ACTIONS(2783),
    [anon_sym_LBRACK] = ACTIONS(2783),
    [anon_sym_static] = ACTIONS(2783),
    [anon_sym_register] = ACTIONS(2783),
    [anon_sym_inline] = ACTIONS(2783),
    [anon_sym___inline] = ACTIONS(2783),
    [anon_sym___inline__] = ACTIONS(2783),
    [anon_sym___forceinline] = ACTIONS(2783),
    [anon_sym_thread_local] = ACTIONS(2783),
    [anon_sym___thread] = ACTIONS(2783),
    [anon_sym_const] = ACTIONS(2783),
    [anon_sym_constexpr] = ACTIONS(2783),
    [anon_sym_volatile] = ACTIONS(2783),
    [anon_sym_restrict] = ACTIONS(2783),
    [anon_sym___restrict__] = ACTIONS(2783),
    [anon_sym__Atomic] = ACTIONS(2783),
    [anon_sym__Noreturn] = ACTIONS(2783),
    [anon_sym_noreturn] = ACTIONS(2783),
    [anon_sym_mutable] = ACTIONS(2783),
    [anon_sym_constinit] = ACTIONS(2783),
    [anon_sym_consteval] = ACTIONS(2783),
    [anon_sym_PROGMEM] = ACTIONS(2783),
    [aux_sym_primitive_type_token1] = ACTIONS(2783),
    [anon_sym_byte] = ACTIONS(2783),
    [anon_sym_word] = ACTIONS(2783),
    [anon_sym_enum] = ACTIONS(2783),
    [anon_sym_class] = ACTIONS(2783),
    [anon_sym_struct] = ACTIONS(2783),
    [anon_sym_union] = ACTIONS(2783),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2783),
    [anon_sym_decltype] = ACTIONS(2783),
    [anon_sym_virtual] = ACTIONS(2783),
    [anon_sym_alignas] = ACTIONS(2783),
    [anon_sym_explicit] = ACTIONS(2783),
    [anon_sym_typename] = ACTIONS(2783),
    [anon_sym_template] = ACTIONS(2783),
    [anon_sym_operator] = ACTIONS(2783),
    [anon_sym_friend] = ACTIONS(2783),
    [anon_sym_public] = ACTIONS(2783),
    [anon_sym_private] = ACTIONS(2783),
    [anon_sym_protected] = ACTIONS(2783),
    [anon_sym_using] = ACTIONS(2783),
    [anon_sym_static_assert] = ACTIONS(2783),
  },
  [1878] = {
    [sym_identifier] = ACTIONS(3028),
    [aux_sym_preproc_def_token1] = ACTIONS(3028),
    [aux_sym_preproc_if_token1] = ACTIONS(3028),
    [aux_sym_preproc_if_token2] = ACTIONS(3028),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3028),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3028),
    [aux_sym_preproc_else_token1] = ACTIONS(3028),
    [aux_sym_preproc_elif_token1] = ACTIONS(3028),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3028),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3028),
    [sym_preproc_directive] = ACTIONS(3028),
    [anon_sym_LPAREN2] = ACTIONS(3030),
    [anon_sym_TILDE] = ACTIONS(3030),
    [anon_sym_STAR] = ACTIONS(3030),
    [anon_sym_AMP_AMP] = ACTIONS(3030),
    [anon_sym_AMP] = ACTIONS(3028),
    [anon_sym___extension__] = ACTIONS(3028),
    [anon_sym_typedef] = ACTIONS(3028),
    [anon_sym_extern] = ACTIONS(3028),
    [anon_sym___attribute__] = ACTIONS(3028),
    [anon_sym_COLON_COLON] = ACTIONS(3030),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3030),
    [anon_sym___declspec] = ACTIONS(3028),
    [anon_sym___based] = ACTIONS(3028),
    [anon_sym_signed] = ACTIONS(3028),
    [anon_sym_unsigned] = ACTIONS(3028),
    [anon_sym_long] = ACTIONS(3028),
    [anon_sym_short] = ACTIONS(3028),
    [anon_sym_LBRACK] = ACTIONS(3028),
    [anon_sym_static] = ACTIONS(3028),
    [anon_sym_register] = ACTIONS(3028),
    [anon_sym_inline] = ACTIONS(3028),
    [anon_sym___inline] = ACTIONS(3028),
    [anon_sym___inline__] = ACTIONS(3028),
    [anon_sym___forceinline] = ACTIONS(3028),
    [anon_sym_thread_local] = ACTIONS(3028),
    [anon_sym___thread] = ACTIONS(3028),
    [anon_sym_const] = ACTIONS(3028),
    [anon_sym_constexpr] = ACTIONS(3028),
    [anon_sym_volatile] = ACTIONS(3028),
    [anon_sym_restrict] = ACTIONS(3028),
    [anon_sym___restrict__] = ACTIONS(3028),
    [anon_sym__Atomic] = ACTIONS(3028),
    [anon_sym__Noreturn] = ACTIONS(3028),
    [anon_sym_noreturn] = ACTIONS(3028),
    [anon_sym_mutable] = ACTIONS(3028),
    [anon_sym_constinit] = ACTIONS(3028),
    [anon_sym_consteval] = ACTIONS(3028),
    [anon_sym_PROGMEM] = ACTIONS(3028),
    [aux_sym_primitive_type_token1] = ACTIONS(3028),
    [anon_sym_byte] = ACTIONS(3028),
    [anon_sym_word] = ACTIONS(3028),
    [anon_sym_enum] = ACTIONS(3028),
    [anon_sym_class] = ACTIONS(3028),
    [anon_sym_struct] = ACTIONS(3028),
    [anon_sym_union] = ACTIONS(3028),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3028),
    [anon_sym_decltype] = ACTIONS(3028),
    [anon_sym_virtual] = ACTIONS(3028),
    [anon_sym_alignas] = ACTIONS(3028),
    [anon_sym_explicit] = ACTIONS(3028),
    [anon_sym_typename] = ACTIONS(3028),
    [anon_sym_template] = ACTIONS(3028),
    [anon_sym_operator] = ACTIONS(3028),
    [anon_sym_friend] = ACTIONS(3028),
    [anon_sym_public] = ACTIONS(3028),
    [anon_sym_private] = ACTIONS(3028),
    [anon_sym_protected] = ACTIONS(3028),
    [anon_sym_using] = ACTIONS(3028),
    [anon_sym_static_assert] = ACTIONS(3028),
  },
  [1879] = {
    [sym_identifier] = ACTIONS(3036),
    [aux_sym_preproc_def_token1] = ACTIONS(3036),
    [aux_sym_preproc_if_token1] = ACTIONS(3036),
    [aux_sym_preproc_if_token2] = ACTIONS(3036),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3036),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3036),
    [aux_sym_preproc_else_token1] = ACTIONS(3036),
    [aux_sym_preproc_elif_token1] = ACTIONS(3036),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3036),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3036),
    [sym_preproc_directive] = ACTIONS(3036),
    [anon_sym_LPAREN2] = ACTIONS(3038),
    [anon_sym_TILDE] = ACTIONS(3038),
    [anon_sym_STAR] = ACTIONS(3038),
    [anon_sym_AMP_AMP] = ACTIONS(3038),
    [anon_sym_AMP] = ACTIONS(3036),
    [anon_sym___extension__] = ACTIONS(3036),
    [anon_sym_typedef] = ACTIONS(3036),
    [anon_sym_extern] = ACTIONS(3036),
    [anon_sym___attribute__] = ACTIONS(3036),
    [anon_sym_COLON_COLON] = ACTIONS(3038),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3038),
    [anon_sym___declspec] = ACTIONS(3036),
    [anon_sym___based] = ACTIONS(3036),
    [anon_sym_signed] = ACTIONS(3036),
    [anon_sym_unsigned] = ACTIONS(3036),
    [anon_sym_long] = ACTIONS(3036),
    [anon_sym_short] = ACTIONS(3036),
    [anon_sym_LBRACK] = ACTIONS(3036),
    [anon_sym_static] = ACTIONS(3036),
    [anon_sym_register] = ACTIONS(3036),
    [anon_sym_inline] = ACTIONS(3036),
    [anon_sym___inline] = ACTIONS(3036),
    [anon_sym___inline__] = ACTIONS(3036),
    [anon_sym___forceinline] = ACTIONS(3036),
    [anon_sym_thread_local] = ACTIONS(3036),
    [anon_sym___thread] = ACTIONS(3036),
    [anon_sym_const] = ACTIONS(3036),
    [anon_sym_constexpr] = ACTIONS(3036),
    [anon_sym_volatile] = ACTIONS(3036),
    [anon_sym_restrict] = ACTIONS(3036),
    [anon_sym___restrict__] = ACTIONS(3036),
    [anon_sym__Atomic] = ACTIONS(3036),
    [anon_sym__Noreturn] = ACTIONS(3036),
    [anon_sym_noreturn] = ACTIONS(3036),
    [anon_sym_mutable] = ACTIONS(3036),
    [anon_sym_constinit] = ACTIONS(3036),
    [anon_sym_consteval] = ACTIONS(3036),
    [anon_sym_PROGMEM] = ACTIONS(3036),
    [aux_sym_primitive_type_token1] = ACTIONS(3036),
    [anon_sym_byte] = ACTIONS(3036),
    [anon_sym_word] = ACTIONS(3036),
    [anon_sym_enum] = ACTIONS(3036),
    [anon_sym_class] = ACTIONS(3036),
    [anon_sym_struct] = ACTIONS(3036),
    [anon_sym_union] = ACTIONS(3036),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3036),
    [anon_sym_decltype] = ACTIONS(3036),
    [anon_sym_virtual] = ACTIONS(3036),
    [anon_sym_alignas] = ACTIONS(3036),
    [anon_sym_explicit] = ACTIONS(3036),
    [anon_sym_typename] = ACTIONS(3036),
    [anon_sym_template] = ACTIONS(3036),
    [anon_sym_operator] = ACTIONS(3036),
    [anon_sym_friend] = ACTIONS(3036),
    [anon_sym_public] = ACTIONS(3036),
    [anon_sym_private] = ACTIONS(3036),
    [anon_sym_protected] = ACTIONS(3036),
    [anon_sym_using] = ACTIONS(3036),
    [anon_sym_static_assert] = ACTIONS(3036),
  },
  [1880] = {
    [sym_identifier] = ACTIONS(4563),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4565),
    [anon_sym_COMMA] = ACTIONS(4565),
    [anon_sym_RPAREN] = ACTIONS(4565),
    [anon_sym_LPAREN2] = ACTIONS(4565),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_STAR] = ACTIONS(4565),
    [anon_sym_SLASH] = ACTIONS(4563),
    [anon_sym_PERCENT] = ACTIONS(4565),
    [anon_sym_PIPE_PIPE] = ACTIONS(4565),
    [anon_sym_AMP_AMP] = ACTIONS(4565),
    [anon_sym_PIPE] = ACTIONS(4563),
    [anon_sym_CARET] = ACTIONS(4565),
    [anon_sym_AMP] = ACTIONS(4563),
    [anon_sym_EQ_EQ] = ACTIONS(4565),
    [anon_sym_BANG_EQ] = ACTIONS(4565),
    [anon_sym_GT] = ACTIONS(4563),
    [anon_sym_GT_EQ] = ACTIONS(4565),
    [anon_sym_LT_EQ] = ACTIONS(4563),
    [anon_sym_LT] = ACTIONS(4563),
    [anon_sym_LT_LT] = ACTIONS(4565),
    [anon_sym_GT_GT] = ACTIONS(4565),
    [anon_sym_SEMI] = ACTIONS(4565),
    [anon_sym___extension__] = ACTIONS(4563),
    [anon_sym___attribute__] = ACTIONS(4563),
    [anon_sym_COLON_COLON] = ACTIONS(4565),
    [anon_sym___based] = ACTIONS(4563),
    [anon_sym_LBRACE] = ACTIONS(4565),
    [anon_sym_RBRACE] = ACTIONS(4565),
    [anon_sym_signed] = ACTIONS(4563),
    [anon_sym_unsigned] = ACTIONS(4563),
    [anon_sym_long] = ACTIONS(4563),
    [anon_sym_short] = ACTIONS(4563),
    [anon_sym_LBRACK] = ACTIONS(4565),
    [anon_sym_RBRACK] = ACTIONS(4565),
    [anon_sym_const] = ACTIONS(4563),
    [anon_sym_constexpr] = ACTIONS(4563),
    [anon_sym_volatile] = ACTIONS(4563),
    [anon_sym_restrict] = ACTIONS(4563),
    [anon_sym___restrict__] = ACTIONS(4563),
    [anon_sym__Atomic] = ACTIONS(4563),
    [anon_sym__Noreturn] = ACTIONS(4563),
    [anon_sym_noreturn] = ACTIONS(4563),
    [anon_sym_mutable] = ACTIONS(4563),
    [anon_sym_constinit] = ACTIONS(4563),
    [anon_sym_consteval] = ACTIONS(4563),
    [anon_sym_PROGMEM] = ACTIONS(4563),
    [aux_sym_primitive_type_token1] = ACTIONS(4563),
    [anon_sym_byte] = ACTIONS(4563),
    [anon_sym_word] = ACTIONS(4563),
    [anon_sym_COLON] = ACTIONS(4563),
    [anon_sym_QMARK] = ACTIONS(4565),
    [anon_sym_LT_EQ_GT] = ACTIONS(4565),
    [anon_sym_or] = ACTIONS(4563),
    [anon_sym_and] = ACTIONS(4563),
    [anon_sym_bitor] = ACTIONS(4563),
    [anon_sym_xor] = ACTIONS(4563),
    [anon_sym_bitand] = ACTIONS(4563),
    [anon_sym_not_eq] = ACTIONS(4563),
    [anon_sym_DASH_DASH] = ACTIONS(4565),
    [anon_sym_PLUS_PLUS] = ACTIONS(4565),
    [anon_sym_DOT] = ACTIONS(4563),
    [anon_sym_DOT_STAR] = ACTIONS(4565),
    [anon_sym_DASH_GT] = ACTIONS(4565),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4563),
    [anon_sym_decltype] = ACTIONS(4563),
    [anon_sym_final] = ACTIONS(4563),
    [anon_sym_override] = ACTIONS(4563),
    [anon_sym_requires] = ACTIONS(4563),
  },
  [1881] = {
    [sym_identifier] = ACTIONS(3040),
    [aux_sym_preproc_def_token1] = ACTIONS(3040),
    [aux_sym_preproc_if_token1] = ACTIONS(3040),
    [aux_sym_preproc_if_token2] = ACTIONS(3040),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3040),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3040),
    [aux_sym_preproc_else_token1] = ACTIONS(3040),
    [aux_sym_preproc_elif_token1] = ACTIONS(3040),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3040),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3040),
    [sym_preproc_directive] = ACTIONS(3040),
    [anon_sym_LPAREN2] = ACTIONS(3042),
    [anon_sym_TILDE] = ACTIONS(3042),
    [anon_sym_STAR] = ACTIONS(3042),
    [anon_sym_AMP_AMP] = ACTIONS(3042),
    [anon_sym_AMP] = ACTIONS(3040),
    [anon_sym___extension__] = ACTIONS(3040),
    [anon_sym_typedef] = ACTIONS(3040),
    [anon_sym_extern] = ACTIONS(3040),
    [anon_sym___attribute__] = ACTIONS(3040),
    [anon_sym_COLON_COLON] = ACTIONS(3042),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3042),
    [anon_sym___declspec] = ACTIONS(3040),
    [anon_sym___based] = ACTIONS(3040),
    [anon_sym_signed] = ACTIONS(3040),
    [anon_sym_unsigned] = ACTIONS(3040),
    [anon_sym_long] = ACTIONS(3040),
    [anon_sym_short] = ACTIONS(3040),
    [anon_sym_LBRACK] = ACTIONS(3040),
    [anon_sym_static] = ACTIONS(3040),
    [anon_sym_register] = ACTIONS(3040),
    [anon_sym_inline] = ACTIONS(3040),
    [anon_sym___inline] = ACTIONS(3040),
    [anon_sym___inline__] = ACTIONS(3040),
    [anon_sym___forceinline] = ACTIONS(3040),
    [anon_sym_thread_local] = ACTIONS(3040),
    [anon_sym___thread] = ACTIONS(3040),
    [anon_sym_const] = ACTIONS(3040),
    [anon_sym_constexpr] = ACTIONS(3040),
    [anon_sym_volatile] = ACTIONS(3040),
    [anon_sym_restrict] = ACTIONS(3040),
    [anon_sym___restrict__] = ACTIONS(3040),
    [anon_sym__Atomic] = ACTIONS(3040),
    [anon_sym__Noreturn] = ACTIONS(3040),
    [anon_sym_noreturn] = ACTIONS(3040),
    [anon_sym_mutable] = ACTIONS(3040),
    [anon_sym_constinit] = ACTIONS(3040),
    [anon_sym_consteval] = ACTIONS(3040),
    [anon_sym_PROGMEM] = ACTIONS(3040),
    [aux_sym_primitive_type_token1] = ACTIONS(3040),
    [anon_sym_byte] = ACTIONS(3040),
    [anon_sym_word] = ACTIONS(3040),
    [anon_sym_enum] = ACTIONS(3040),
    [anon_sym_class] = ACTIONS(3040),
    [anon_sym_struct] = ACTIONS(3040),
    [anon_sym_union] = ACTIONS(3040),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3040),
    [anon_sym_decltype] = ACTIONS(3040),
    [anon_sym_virtual] = ACTIONS(3040),
    [anon_sym_alignas] = ACTIONS(3040),
    [anon_sym_explicit] = ACTIONS(3040),
    [anon_sym_typename] = ACTIONS(3040),
    [anon_sym_template] = ACTIONS(3040),
    [anon_sym_operator] = ACTIONS(3040),
    [anon_sym_friend] = ACTIONS(3040),
    [anon_sym_public] = ACTIONS(3040),
    [anon_sym_private] = ACTIONS(3040),
    [anon_sym_protected] = ACTIONS(3040),
    [anon_sym_using] = ACTIONS(3040),
    [anon_sym_static_assert] = ACTIONS(3040),
  },
  [1882] = {
    [sym_identifier] = ACTIONS(2941),
    [aux_sym_preproc_def_token1] = ACTIONS(2941),
    [aux_sym_preproc_if_token1] = ACTIONS(2941),
    [aux_sym_preproc_if_token2] = ACTIONS(2941),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2941),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2941),
    [aux_sym_preproc_else_token1] = ACTIONS(2941),
    [aux_sym_preproc_elif_token1] = ACTIONS(2941),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2941),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2941),
    [sym_preproc_directive] = ACTIONS(2941),
    [anon_sym_LPAREN2] = ACTIONS(2943),
    [anon_sym_TILDE] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2943),
    [anon_sym_AMP_AMP] = ACTIONS(2943),
    [anon_sym_AMP] = ACTIONS(2941),
    [anon_sym___extension__] = ACTIONS(2941),
    [anon_sym_typedef] = ACTIONS(2941),
    [anon_sym_extern] = ACTIONS(2941),
    [anon_sym___attribute__] = ACTIONS(2941),
    [anon_sym_COLON_COLON] = ACTIONS(2943),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2943),
    [anon_sym___declspec] = ACTIONS(2941),
    [anon_sym___based] = ACTIONS(2941),
    [anon_sym_signed] = ACTIONS(2941),
    [anon_sym_unsigned] = ACTIONS(2941),
    [anon_sym_long] = ACTIONS(2941),
    [anon_sym_short] = ACTIONS(2941),
    [anon_sym_LBRACK] = ACTIONS(2941),
    [anon_sym_static] = ACTIONS(2941),
    [anon_sym_register] = ACTIONS(2941),
    [anon_sym_inline] = ACTIONS(2941),
    [anon_sym___inline] = ACTIONS(2941),
    [anon_sym___inline__] = ACTIONS(2941),
    [anon_sym___forceinline] = ACTIONS(2941),
    [anon_sym_thread_local] = ACTIONS(2941),
    [anon_sym___thread] = ACTIONS(2941),
    [anon_sym_const] = ACTIONS(2941),
    [anon_sym_constexpr] = ACTIONS(2941),
    [anon_sym_volatile] = ACTIONS(2941),
    [anon_sym_restrict] = ACTIONS(2941),
    [anon_sym___restrict__] = ACTIONS(2941),
    [anon_sym__Atomic] = ACTIONS(2941),
    [anon_sym__Noreturn] = ACTIONS(2941),
    [anon_sym_noreturn] = ACTIONS(2941),
    [anon_sym_mutable] = ACTIONS(2941),
    [anon_sym_constinit] = ACTIONS(2941),
    [anon_sym_consteval] = ACTIONS(2941),
    [anon_sym_PROGMEM] = ACTIONS(2941),
    [aux_sym_primitive_type_token1] = ACTIONS(2941),
    [anon_sym_byte] = ACTIONS(2941),
    [anon_sym_word] = ACTIONS(2941),
    [anon_sym_enum] = ACTIONS(2941),
    [anon_sym_class] = ACTIONS(2941),
    [anon_sym_struct] = ACTIONS(2941),
    [anon_sym_union] = ACTIONS(2941),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2941),
    [anon_sym_decltype] = ACTIONS(2941),
    [anon_sym_virtual] = ACTIONS(2941),
    [anon_sym_alignas] = ACTIONS(2941),
    [anon_sym_explicit] = ACTIONS(2941),
    [anon_sym_typename] = ACTIONS(2941),
    [anon_sym_template] = ACTIONS(2941),
    [anon_sym_operator] = ACTIONS(2941),
    [anon_sym_friend] = ACTIONS(2941),
    [anon_sym_public] = ACTIONS(2941),
    [anon_sym_private] = ACTIONS(2941),
    [anon_sym_protected] = ACTIONS(2941),
    [anon_sym_using] = ACTIONS(2941),
    [anon_sym_static_assert] = ACTIONS(2941),
  },
  [1883] = {
    [sym_identifier] = ACTIONS(4567),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4569),
    [anon_sym_COMMA] = ACTIONS(4569),
    [anon_sym_RPAREN] = ACTIONS(4569),
    [anon_sym_LPAREN2] = ACTIONS(4569),
    [anon_sym_DASH] = ACTIONS(4567),
    [anon_sym_PLUS] = ACTIONS(4567),
    [anon_sym_STAR] = ACTIONS(4569),
    [anon_sym_SLASH] = ACTIONS(4567),
    [anon_sym_PERCENT] = ACTIONS(4569),
    [anon_sym_PIPE_PIPE] = ACTIONS(4569),
    [anon_sym_AMP_AMP] = ACTIONS(4569),
    [anon_sym_PIPE] = ACTIONS(4567),
    [anon_sym_CARET] = ACTIONS(4569),
    [anon_sym_AMP] = ACTIONS(4567),
    [anon_sym_EQ_EQ] = ACTIONS(4569),
    [anon_sym_BANG_EQ] = ACTIONS(4569),
    [anon_sym_GT] = ACTIONS(4567),
    [anon_sym_GT_EQ] = ACTIONS(4569),
    [anon_sym_LT_EQ] = ACTIONS(4567),
    [anon_sym_LT] = ACTIONS(4567),
    [anon_sym_LT_LT] = ACTIONS(4569),
    [anon_sym_GT_GT] = ACTIONS(4569),
    [anon_sym_SEMI] = ACTIONS(4569),
    [anon_sym___extension__] = ACTIONS(4567),
    [anon_sym___attribute__] = ACTIONS(4567),
    [anon_sym_COLON_COLON] = ACTIONS(4569),
    [anon_sym___based] = ACTIONS(4567),
    [anon_sym_LBRACE] = ACTIONS(4569),
    [anon_sym_RBRACE] = ACTIONS(4569),
    [anon_sym_signed] = ACTIONS(4567),
    [anon_sym_unsigned] = ACTIONS(4567),
    [anon_sym_long] = ACTIONS(4567),
    [anon_sym_short] = ACTIONS(4567),
    [anon_sym_LBRACK] = ACTIONS(4569),
    [anon_sym_RBRACK] = ACTIONS(4569),
    [anon_sym_const] = ACTIONS(4567),
    [anon_sym_constexpr] = ACTIONS(4567),
    [anon_sym_volatile] = ACTIONS(4567),
    [anon_sym_restrict] = ACTIONS(4567),
    [anon_sym___restrict__] = ACTIONS(4567),
    [anon_sym__Atomic] = ACTIONS(4567),
    [anon_sym__Noreturn] = ACTIONS(4567),
    [anon_sym_noreturn] = ACTIONS(4567),
    [anon_sym_mutable] = ACTIONS(4567),
    [anon_sym_constinit] = ACTIONS(4567),
    [anon_sym_consteval] = ACTIONS(4567),
    [anon_sym_PROGMEM] = ACTIONS(4567),
    [aux_sym_primitive_type_token1] = ACTIONS(4567),
    [anon_sym_byte] = ACTIONS(4567),
    [anon_sym_word] = ACTIONS(4567),
    [anon_sym_COLON] = ACTIONS(4567),
    [anon_sym_QMARK] = ACTIONS(4569),
    [anon_sym_LT_EQ_GT] = ACTIONS(4569),
    [anon_sym_or] = ACTIONS(4567),
    [anon_sym_and] = ACTIONS(4567),
    [anon_sym_bitor] = ACTIONS(4567),
    [anon_sym_xor] = ACTIONS(4567),
    [anon_sym_bitand] = ACTIONS(4567),
    [anon_sym_not_eq] = ACTIONS(4567),
    [anon_sym_DASH_DASH] = ACTIONS(4569),
    [anon_sym_PLUS_PLUS] = ACTIONS(4569),
    [anon_sym_DOT] = ACTIONS(4567),
    [anon_sym_DOT_STAR] = ACTIONS(4569),
    [anon_sym_DASH_GT] = ACTIONS(4569),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4567),
    [anon_sym_decltype] = ACTIONS(4567),
    [anon_sym_final] = ACTIONS(4567),
    [anon_sym_override] = ACTIONS(4567),
    [anon_sym_requires] = ACTIONS(4567),
  },
  [1884] = {
    [sym_identifier] = ACTIONS(4571),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4573),
    [anon_sym_COMMA] = ACTIONS(4573),
    [anon_sym_RPAREN] = ACTIONS(4573),
    [anon_sym_LPAREN2] = ACTIONS(4573),
    [anon_sym_DASH] = ACTIONS(4571),
    [anon_sym_PLUS] = ACTIONS(4571),
    [anon_sym_STAR] = ACTIONS(4573),
    [anon_sym_SLASH] = ACTIONS(4571),
    [anon_sym_PERCENT] = ACTIONS(4573),
    [anon_sym_PIPE_PIPE] = ACTIONS(4573),
    [anon_sym_AMP_AMP] = ACTIONS(4573),
    [anon_sym_PIPE] = ACTIONS(4571),
    [anon_sym_CARET] = ACTIONS(4573),
    [anon_sym_AMP] = ACTIONS(4571),
    [anon_sym_EQ_EQ] = ACTIONS(4573),
    [anon_sym_BANG_EQ] = ACTIONS(4573),
    [anon_sym_GT] = ACTIONS(4571),
    [anon_sym_GT_EQ] = ACTIONS(4573),
    [anon_sym_LT_EQ] = ACTIONS(4571),
    [anon_sym_LT] = ACTIONS(4571),
    [anon_sym_LT_LT] = ACTIONS(4573),
    [anon_sym_GT_GT] = ACTIONS(4573),
    [anon_sym_SEMI] = ACTIONS(4573),
    [anon_sym___extension__] = ACTIONS(4571),
    [anon_sym___attribute__] = ACTIONS(4571),
    [anon_sym_COLON_COLON] = ACTIONS(4573),
    [anon_sym___based] = ACTIONS(4571),
    [anon_sym_LBRACE] = ACTIONS(4573),
    [anon_sym_RBRACE] = ACTIONS(4573),
    [anon_sym_signed] = ACTIONS(4571),
    [anon_sym_unsigned] = ACTIONS(4571),
    [anon_sym_long] = ACTIONS(4571),
    [anon_sym_short] = ACTIONS(4571),
    [anon_sym_LBRACK] = ACTIONS(4573),
    [anon_sym_RBRACK] = ACTIONS(4573),
    [anon_sym_const] = ACTIONS(4571),
    [anon_sym_constexpr] = ACTIONS(4571),
    [anon_sym_volatile] = ACTIONS(4571),
    [anon_sym_restrict] = ACTIONS(4571),
    [anon_sym___restrict__] = ACTIONS(4571),
    [anon_sym__Atomic] = ACTIONS(4571),
    [anon_sym__Noreturn] = ACTIONS(4571),
    [anon_sym_noreturn] = ACTIONS(4571),
    [anon_sym_mutable] = ACTIONS(4571),
    [anon_sym_constinit] = ACTIONS(4571),
    [anon_sym_consteval] = ACTIONS(4571),
    [anon_sym_PROGMEM] = ACTIONS(4571),
    [aux_sym_primitive_type_token1] = ACTIONS(4571),
    [anon_sym_byte] = ACTIONS(4571),
    [anon_sym_word] = ACTIONS(4571),
    [anon_sym_COLON] = ACTIONS(4571),
    [anon_sym_QMARK] = ACTIONS(4573),
    [anon_sym_LT_EQ_GT] = ACTIONS(4573),
    [anon_sym_or] = ACTIONS(4571),
    [anon_sym_and] = ACTIONS(4571),
    [anon_sym_bitor] = ACTIONS(4571),
    [anon_sym_xor] = ACTIONS(4571),
    [anon_sym_bitand] = ACTIONS(4571),
    [anon_sym_not_eq] = ACTIONS(4571),
    [anon_sym_DASH_DASH] = ACTIONS(4573),
    [anon_sym_PLUS_PLUS] = ACTIONS(4573),
    [anon_sym_DOT] = ACTIONS(4571),
    [anon_sym_DOT_STAR] = ACTIONS(4573),
    [anon_sym_DASH_GT] = ACTIONS(4573),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4571),
    [anon_sym_decltype] = ACTIONS(4571),
    [anon_sym_final] = ACTIONS(4571),
    [anon_sym_override] = ACTIONS(4571),
    [anon_sym_requires] = ACTIONS(4571),
  },
  [1885] = {
    [sym_identifier] = ACTIONS(3160),
    [aux_sym_preproc_def_token1] = ACTIONS(3160),
    [aux_sym_preproc_if_token1] = ACTIONS(3160),
    [aux_sym_preproc_if_token2] = ACTIONS(3160),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3160),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3160),
    [aux_sym_preproc_else_token1] = ACTIONS(3160),
    [aux_sym_preproc_elif_token1] = ACTIONS(3160),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3160),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3160),
    [sym_preproc_directive] = ACTIONS(3160),
    [anon_sym_LPAREN2] = ACTIONS(3162),
    [anon_sym_TILDE] = ACTIONS(3162),
    [anon_sym_STAR] = ACTIONS(3162),
    [anon_sym_AMP_AMP] = ACTIONS(3162),
    [anon_sym_AMP] = ACTIONS(3160),
    [anon_sym___extension__] = ACTIONS(3160),
    [anon_sym_typedef] = ACTIONS(3160),
    [anon_sym_extern] = ACTIONS(3160),
    [anon_sym___attribute__] = ACTIONS(3160),
    [anon_sym_COLON_COLON] = ACTIONS(3162),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3162),
    [anon_sym___declspec] = ACTIONS(3160),
    [anon_sym___based] = ACTIONS(3160),
    [anon_sym_signed] = ACTIONS(3160),
    [anon_sym_unsigned] = ACTIONS(3160),
    [anon_sym_long] = ACTIONS(3160),
    [anon_sym_short] = ACTIONS(3160),
    [anon_sym_LBRACK] = ACTIONS(3160),
    [anon_sym_static] = ACTIONS(3160),
    [anon_sym_register] = ACTIONS(3160),
    [anon_sym_inline] = ACTIONS(3160),
    [anon_sym___inline] = ACTIONS(3160),
    [anon_sym___inline__] = ACTIONS(3160),
    [anon_sym___forceinline] = ACTIONS(3160),
    [anon_sym_thread_local] = ACTIONS(3160),
    [anon_sym___thread] = ACTIONS(3160),
    [anon_sym_const] = ACTIONS(3160),
    [anon_sym_constexpr] = ACTIONS(3160),
    [anon_sym_volatile] = ACTIONS(3160),
    [anon_sym_restrict] = ACTIONS(3160),
    [anon_sym___restrict__] = ACTIONS(3160),
    [anon_sym__Atomic] = ACTIONS(3160),
    [anon_sym__Noreturn] = ACTIONS(3160),
    [anon_sym_noreturn] = ACTIONS(3160),
    [anon_sym_mutable] = ACTIONS(3160),
    [anon_sym_constinit] = ACTIONS(3160),
    [anon_sym_consteval] = ACTIONS(3160),
    [anon_sym_PROGMEM] = ACTIONS(3160),
    [aux_sym_primitive_type_token1] = ACTIONS(3160),
    [anon_sym_byte] = ACTIONS(3160),
    [anon_sym_word] = ACTIONS(3160),
    [anon_sym_enum] = ACTIONS(3160),
    [anon_sym_class] = ACTIONS(3160),
    [anon_sym_struct] = ACTIONS(3160),
    [anon_sym_union] = ACTIONS(3160),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3160),
    [anon_sym_decltype] = ACTIONS(3160),
    [anon_sym_virtual] = ACTIONS(3160),
    [anon_sym_alignas] = ACTIONS(3160),
    [anon_sym_explicit] = ACTIONS(3160),
    [anon_sym_typename] = ACTIONS(3160),
    [anon_sym_template] = ACTIONS(3160),
    [anon_sym_operator] = ACTIONS(3160),
    [anon_sym_friend] = ACTIONS(3160),
    [anon_sym_public] = ACTIONS(3160),
    [anon_sym_private] = ACTIONS(3160),
    [anon_sym_protected] = ACTIONS(3160),
    [anon_sym_using] = ACTIONS(3160),
    [anon_sym_static_assert] = ACTIONS(3160),
  },
  [1886] = {
    [sym_identifier] = ACTIONS(3164),
    [aux_sym_preproc_def_token1] = ACTIONS(3164),
    [aux_sym_preproc_if_token1] = ACTIONS(3164),
    [aux_sym_preproc_if_token2] = ACTIONS(3164),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3164),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3164),
    [aux_sym_preproc_else_token1] = ACTIONS(3164),
    [aux_sym_preproc_elif_token1] = ACTIONS(3164),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3164),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3164),
    [sym_preproc_directive] = ACTIONS(3164),
    [anon_sym_LPAREN2] = ACTIONS(3166),
    [anon_sym_TILDE] = ACTIONS(3166),
    [anon_sym_STAR] = ACTIONS(3166),
    [anon_sym_AMP_AMP] = ACTIONS(3166),
    [anon_sym_AMP] = ACTIONS(3164),
    [anon_sym___extension__] = ACTIONS(3164),
    [anon_sym_typedef] = ACTIONS(3164),
    [anon_sym_extern] = ACTIONS(3164),
    [anon_sym___attribute__] = ACTIONS(3164),
    [anon_sym_COLON_COLON] = ACTIONS(3166),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3166),
    [anon_sym___declspec] = ACTIONS(3164),
    [anon_sym___based] = ACTIONS(3164),
    [anon_sym_signed] = ACTIONS(3164),
    [anon_sym_unsigned] = ACTIONS(3164),
    [anon_sym_long] = ACTIONS(3164),
    [anon_sym_short] = ACTIONS(3164),
    [anon_sym_LBRACK] = ACTIONS(3164),
    [anon_sym_static] = ACTIONS(3164),
    [anon_sym_register] = ACTIONS(3164),
    [anon_sym_inline] = ACTIONS(3164),
    [anon_sym___inline] = ACTIONS(3164),
    [anon_sym___inline__] = ACTIONS(3164),
    [anon_sym___forceinline] = ACTIONS(3164),
    [anon_sym_thread_local] = ACTIONS(3164),
    [anon_sym___thread] = ACTIONS(3164),
    [anon_sym_const] = ACTIONS(3164),
    [anon_sym_constexpr] = ACTIONS(3164),
    [anon_sym_volatile] = ACTIONS(3164),
    [anon_sym_restrict] = ACTIONS(3164),
    [anon_sym___restrict__] = ACTIONS(3164),
    [anon_sym__Atomic] = ACTIONS(3164),
    [anon_sym__Noreturn] = ACTIONS(3164),
    [anon_sym_noreturn] = ACTIONS(3164),
    [anon_sym_mutable] = ACTIONS(3164),
    [anon_sym_constinit] = ACTIONS(3164),
    [anon_sym_consteval] = ACTIONS(3164),
    [anon_sym_PROGMEM] = ACTIONS(3164),
    [aux_sym_primitive_type_token1] = ACTIONS(3164),
    [anon_sym_byte] = ACTIONS(3164),
    [anon_sym_word] = ACTIONS(3164),
    [anon_sym_enum] = ACTIONS(3164),
    [anon_sym_class] = ACTIONS(3164),
    [anon_sym_struct] = ACTIONS(3164),
    [anon_sym_union] = ACTIONS(3164),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3164),
    [anon_sym_decltype] = ACTIONS(3164),
    [anon_sym_virtual] = ACTIONS(3164),
    [anon_sym_alignas] = ACTIONS(3164),
    [anon_sym_explicit] = ACTIONS(3164),
    [anon_sym_typename] = ACTIONS(3164),
    [anon_sym_template] = ACTIONS(3164),
    [anon_sym_operator] = ACTIONS(3164),
    [anon_sym_friend] = ACTIONS(3164),
    [anon_sym_public] = ACTIONS(3164),
    [anon_sym_private] = ACTIONS(3164),
    [anon_sym_protected] = ACTIONS(3164),
    [anon_sym_using] = ACTIONS(3164),
    [anon_sym_static_assert] = ACTIONS(3164),
  },
  [1887] = {
    [sym__declaration_modifiers] = STATE(3458),
    [sym_attribute_specifier] = STATE(3458),
    [sym_attribute_declaration] = STATE(3458),
    [sym_ms_declspec_modifier] = STATE(3458),
    [sym_ms_based_modifier] = STATE(8318),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6076),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3458),
    [sym_type_qualifier] = STATE(3458),
    [sym_decltype] = STATE(8290),
    [sym_virtual] = STATE(3458),
    [sym_alignas_specifier] = STATE(3458),
    [sym_explicit_function_specifier] = STATE(3458),
    [sym_operator_cast] = STATE(6498),
    [sym__constructor_specifiers] = STATE(3458),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(8290),
    [sym_template_function] = STATE(6098),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5430),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_operator_cast_identifier] = STATE(6498),
    [sym_operator_name] = STATE(6098),
    [aux_sym_operator_cast_definition_repeat1] = STATE(3458),
    [sym_identifier] = ACTIONS(4841),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(4843),
    [anon_sym_extern] = ACTIONS(4845),
    [anon_sym___attribute__] = ACTIONS(4847),
    [anon_sym_COLON_COLON] = ACTIONS(4849),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4851),
    [anon_sym___declspec] = ACTIONS(4853),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(4845),
    [anon_sym_register] = ACTIONS(4845),
    [anon_sym_inline] = ACTIONS(4845),
    [anon_sym___inline] = ACTIONS(4845),
    [anon_sym___inline__] = ACTIONS(4845),
    [anon_sym___forceinline] = ACTIONS(4845),
    [anon_sym_thread_local] = ACTIONS(4845),
    [anon_sym___thread] = ACTIONS(4845),
    [anon_sym_const] = ACTIONS(4843),
    [anon_sym_constexpr] = ACTIONS(4843),
    [anon_sym_volatile] = ACTIONS(4843),
    [anon_sym_restrict] = ACTIONS(4843),
    [anon_sym___restrict__] = ACTIONS(4843),
    [anon_sym__Atomic] = ACTIONS(4843),
    [anon_sym__Noreturn] = ACTIONS(4843),
    [anon_sym_noreturn] = ACTIONS(4843),
    [anon_sym_mutable] = ACTIONS(4843),
    [anon_sym_constinit] = ACTIONS(4843),
    [anon_sym_consteval] = ACTIONS(4843),
    [anon_sym_PROGMEM] = ACTIONS(4843),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_virtual] = ACTIONS(4855),
    [anon_sym_alignas] = ACTIONS(4857),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_operator] = ACTIONS(133),
  },
  [1888] = {
    [sym__declaration_modifiers] = STATE(3458),
    [sym_attribute_specifier] = STATE(3458),
    [sym_attribute_declaration] = STATE(3458),
    [sym_ms_declspec_modifier] = STATE(3458),
    [sym_ms_based_modifier] = STATE(8318),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6088),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3458),
    [sym_type_qualifier] = STATE(3458),
    [sym_decltype] = STATE(8290),
    [sym_virtual] = STATE(3458),
    [sym_alignas_specifier] = STATE(3458),
    [sym_explicit_function_specifier] = STATE(3458),
    [sym_operator_cast] = STATE(6508),
    [sym__constructor_specifiers] = STATE(3458),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(8290),
    [sym_template_function] = STATE(6098),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5430),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_operator_cast_identifier] = STATE(6508),
    [sym_operator_name] = STATE(6098),
    [aux_sym_operator_cast_definition_repeat1] = STATE(3458),
    [sym_identifier] = ACTIONS(4841),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(4843),
    [anon_sym_extern] = ACTIONS(4845),
    [anon_sym___attribute__] = ACTIONS(4847),
    [anon_sym_COLON_COLON] = ACTIONS(4849),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4851),
    [anon_sym___declspec] = ACTIONS(4853),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(4845),
    [anon_sym_register] = ACTIONS(4845),
    [anon_sym_inline] = ACTIONS(4845),
    [anon_sym___inline] = ACTIONS(4845),
    [anon_sym___inline__] = ACTIONS(4845),
    [anon_sym___forceinline] = ACTIONS(4845),
    [anon_sym_thread_local] = ACTIONS(4845),
    [anon_sym___thread] = ACTIONS(4845),
    [anon_sym_const] = ACTIONS(4843),
    [anon_sym_constexpr] = ACTIONS(4843),
    [anon_sym_volatile] = ACTIONS(4843),
    [anon_sym_restrict] = ACTIONS(4843),
    [anon_sym___restrict__] = ACTIONS(4843),
    [anon_sym__Atomic] = ACTIONS(4843),
    [anon_sym__Noreturn] = ACTIONS(4843),
    [anon_sym_noreturn] = ACTIONS(4843),
    [anon_sym_mutable] = ACTIONS(4843),
    [anon_sym_constinit] = ACTIONS(4843),
    [anon_sym_consteval] = ACTIONS(4843),
    [anon_sym_PROGMEM] = ACTIONS(4843),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_virtual] = ACTIONS(4855),
    [anon_sym_alignas] = ACTIONS(4857),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_operator] = ACTIONS(133),
  },
  [1889] = {
    [sym_identifier] = ACTIONS(3476),
    [aux_sym_preproc_def_token1] = ACTIONS(3476),
    [aux_sym_preproc_if_token1] = ACTIONS(3476),
    [aux_sym_preproc_if_token2] = ACTIONS(3476),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3476),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3476),
    [aux_sym_preproc_else_token1] = ACTIONS(3476),
    [aux_sym_preproc_elif_token1] = ACTIONS(3476),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3476),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3476),
    [sym_preproc_directive] = ACTIONS(3476),
    [anon_sym_LPAREN2] = ACTIONS(3474),
    [anon_sym_TILDE] = ACTIONS(3474),
    [anon_sym_STAR] = ACTIONS(3474),
    [anon_sym_AMP_AMP] = ACTIONS(3474),
    [anon_sym_AMP] = ACTIONS(3476),
    [anon_sym___extension__] = ACTIONS(3476),
    [anon_sym_typedef] = ACTIONS(3476),
    [anon_sym_extern] = ACTIONS(3476),
    [anon_sym___attribute__] = ACTIONS(3476),
    [anon_sym_COLON_COLON] = ACTIONS(3474),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3474),
    [anon_sym___declspec] = ACTIONS(3476),
    [anon_sym___based] = ACTIONS(3476),
    [anon_sym_signed] = ACTIONS(3476),
    [anon_sym_unsigned] = ACTIONS(3476),
    [anon_sym_long] = ACTIONS(3476),
    [anon_sym_short] = ACTIONS(3476),
    [anon_sym_LBRACK] = ACTIONS(3476),
    [anon_sym_static] = ACTIONS(3476),
    [anon_sym_register] = ACTIONS(3476),
    [anon_sym_inline] = ACTIONS(3476),
    [anon_sym___inline] = ACTIONS(3476),
    [anon_sym___inline__] = ACTIONS(3476),
    [anon_sym___forceinline] = ACTIONS(3476),
    [anon_sym_thread_local] = ACTIONS(3476),
    [anon_sym___thread] = ACTIONS(3476),
    [anon_sym_const] = ACTIONS(3476),
    [anon_sym_constexpr] = ACTIONS(3476),
    [anon_sym_volatile] = ACTIONS(3476),
    [anon_sym_restrict] = ACTIONS(3476),
    [anon_sym___restrict__] = ACTIONS(3476),
    [anon_sym__Atomic] = ACTIONS(3476),
    [anon_sym__Noreturn] = ACTIONS(3476),
    [anon_sym_noreturn] = ACTIONS(3476),
    [anon_sym_mutable] = ACTIONS(3476),
    [anon_sym_constinit] = ACTIONS(3476),
    [anon_sym_consteval] = ACTIONS(3476),
    [anon_sym_PROGMEM] = ACTIONS(3476),
    [aux_sym_primitive_type_token1] = ACTIONS(3476),
    [anon_sym_byte] = ACTIONS(3476),
    [anon_sym_word] = ACTIONS(3476),
    [anon_sym_enum] = ACTIONS(3476),
    [anon_sym_class] = ACTIONS(3476),
    [anon_sym_struct] = ACTIONS(3476),
    [anon_sym_union] = ACTIONS(3476),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3476),
    [anon_sym_decltype] = ACTIONS(3476),
    [anon_sym_virtual] = ACTIONS(3476),
    [anon_sym_alignas] = ACTIONS(3476),
    [anon_sym_explicit] = ACTIONS(3476),
    [anon_sym_typename] = ACTIONS(3476),
    [anon_sym_template] = ACTIONS(3476),
    [anon_sym_operator] = ACTIONS(3476),
    [anon_sym_friend] = ACTIONS(3476),
    [anon_sym_public] = ACTIONS(3476),
    [anon_sym_private] = ACTIONS(3476),
    [anon_sym_protected] = ACTIONS(3476),
    [anon_sym_using] = ACTIONS(3476),
    [anon_sym_static_assert] = ACTIONS(3476),
  },
  [1890] = {
    [sym_identifier] = ACTIONS(3126),
    [aux_sym_preproc_def_token1] = ACTIONS(3126),
    [aux_sym_preproc_if_token1] = ACTIONS(3126),
    [aux_sym_preproc_if_token2] = ACTIONS(3126),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3126),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3126),
    [aux_sym_preproc_else_token1] = ACTIONS(3126),
    [aux_sym_preproc_elif_token1] = ACTIONS(3126),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3126),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3126),
    [sym_preproc_directive] = ACTIONS(3126),
    [anon_sym_LPAREN2] = ACTIONS(3128),
    [anon_sym_TILDE] = ACTIONS(3128),
    [anon_sym_STAR] = ACTIONS(3128),
    [anon_sym_AMP_AMP] = ACTIONS(3128),
    [anon_sym_AMP] = ACTIONS(3126),
    [anon_sym___extension__] = ACTIONS(3126),
    [anon_sym_typedef] = ACTIONS(3126),
    [anon_sym_extern] = ACTIONS(3126),
    [anon_sym___attribute__] = ACTIONS(3126),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3128),
    [anon_sym___declspec] = ACTIONS(3126),
    [anon_sym___based] = ACTIONS(3126),
    [anon_sym_signed] = ACTIONS(3126),
    [anon_sym_unsigned] = ACTIONS(3126),
    [anon_sym_long] = ACTIONS(3126),
    [anon_sym_short] = ACTIONS(3126),
    [anon_sym_LBRACK] = ACTIONS(3126),
    [anon_sym_static] = ACTIONS(3126),
    [anon_sym_register] = ACTIONS(3126),
    [anon_sym_inline] = ACTIONS(3126),
    [anon_sym___inline] = ACTIONS(3126),
    [anon_sym___inline__] = ACTIONS(3126),
    [anon_sym___forceinline] = ACTIONS(3126),
    [anon_sym_thread_local] = ACTIONS(3126),
    [anon_sym___thread] = ACTIONS(3126),
    [anon_sym_const] = ACTIONS(3126),
    [anon_sym_constexpr] = ACTIONS(3126),
    [anon_sym_volatile] = ACTIONS(3126),
    [anon_sym_restrict] = ACTIONS(3126),
    [anon_sym___restrict__] = ACTIONS(3126),
    [anon_sym__Atomic] = ACTIONS(3126),
    [anon_sym__Noreturn] = ACTIONS(3126),
    [anon_sym_noreturn] = ACTIONS(3126),
    [anon_sym_mutable] = ACTIONS(3126),
    [anon_sym_constinit] = ACTIONS(3126),
    [anon_sym_consteval] = ACTIONS(3126),
    [anon_sym_PROGMEM] = ACTIONS(3126),
    [aux_sym_primitive_type_token1] = ACTIONS(3126),
    [anon_sym_byte] = ACTIONS(3126),
    [anon_sym_word] = ACTIONS(3126),
    [anon_sym_enum] = ACTIONS(3126),
    [anon_sym_class] = ACTIONS(3126),
    [anon_sym_struct] = ACTIONS(3126),
    [anon_sym_union] = ACTIONS(3126),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3126),
    [anon_sym_decltype] = ACTIONS(3126),
    [anon_sym_virtual] = ACTIONS(3126),
    [anon_sym_alignas] = ACTIONS(3126),
    [anon_sym_explicit] = ACTIONS(3126),
    [anon_sym_typename] = ACTIONS(3126),
    [anon_sym_template] = ACTIONS(3126),
    [anon_sym_operator] = ACTIONS(3126),
    [anon_sym_friend] = ACTIONS(3126),
    [anon_sym_public] = ACTIONS(3126),
    [anon_sym_private] = ACTIONS(3126),
    [anon_sym_protected] = ACTIONS(3126),
    [anon_sym_using] = ACTIONS(3126),
    [anon_sym_static_assert] = ACTIONS(3126),
  },
  [1891] = {
    [sym_identifier] = ACTIONS(3126),
    [aux_sym_preproc_def_token1] = ACTIONS(3126),
    [aux_sym_preproc_if_token1] = ACTIONS(3126),
    [aux_sym_preproc_if_token2] = ACTIONS(3126),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3126),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3126),
    [aux_sym_preproc_else_token1] = ACTIONS(3126),
    [aux_sym_preproc_elif_token1] = ACTIONS(3126),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3126),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3126),
    [sym_preproc_directive] = ACTIONS(3126),
    [anon_sym_LPAREN2] = ACTIONS(3128),
    [anon_sym_TILDE] = ACTIONS(3128),
    [anon_sym_STAR] = ACTIONS(3128),
    [anon_sym_AMP_AMP] = ACTIONS(3128),
    [anon_sym_AMP] = ACTIONS(3126),
    [anon_sym___extension__] = ACTIONS(3126),
    [anon_sym_typedef] = ACTIONS(3126),
    [anon_sym_extern] = ACTIONS(3126),
    [anon_sym___attribute__] = ACTIONS(3126),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3128),
    [anon_sym___declspec] = ACTIONS(3126),
    [anon_sym___based] = ACTIONS(3126),
    [anon_sym_signed] = ACTIONS(3126),
    [anon_sym_unsigned] = ACTIONS(3126),
    [anon_sym_long] = ACTIONS(3126),
    [anon_sym_short] = ACTIONS(3126),
    [anon_sym_LBRACK] = ACTIONS(3126),
    [anon_sym_static] = ACTIONS(3126),
    [anon_sym_register] = ACTIONS(3126),
    [anon_sym_inline] = ACTIONS(3126),
    [anon_sym___inline] = ACTIONS(3126),
    [anon_sym___inline__] = ACTIONS(3126),
    [anon_sym___forceinline] = ACTIONS(3126),
    [anon_sym_thread_local] = ACTIONS(3126),
    [anon_sym___thread] = ACTIONS(3126),
    [anon_sym_const] = ACTIONS(3126),
    [anon_sym_constexpr] = ACTIONS(3126),
    [anon_sym_volatile] = ACTIONS(3126),
    [anon_sym_restrict] = ACTIONS(3126),
    [anon_sym___restrict__] = ACTIONS(3126),
    [anon_sym__Atomic] = ACTIONS(3126),
    [anon_sym__Noreturn] = ACTIONS(3126),
    [anon_sym_noreturn] = ACTIONS(3126),
    [anon_sym_mutable] = ACTIONS(3126),
    [anon_sym_constinit] = ACTIONS(3126),
    [anon_sym_consteval] = ACTIONS(3126),
    [anon_sym_PROGMEM] = ACTIONS(3126),
    [aux_sym_primitive_type_token1] = ACTIONS(3126),
    [anon_sym_byte] = ACTIONS(3126),
    [anon_sym_word] = ACTIONS(3126),
    [anon_sym_enum] = ACTIONS(3126),
    [anon_sym_class] = ACTIONS(3126),
    [anon_sym_struct] = ACTIONS(3126),
    [anon_sym_union] = ACTIONS(3126),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3126),
    [anon_sym_decltype] = ACTIONS(3126),
    [anon_sym_virtual] = ACTIONS(3126),
    [anon_sym_alignas] = ACTIONS(3126),
    [anon_sym_explicit] = ACTIONS(3126),
    [anon_sym_typename] = ACTIONS(3126),
    [anon_sym_template] = ACTIONS(3126),
    [anon_sym_operator] = ACTIONS(3126),
    [anon_sym_friend] = ACTIONS(3126),
    [anon_sym_public] = ACTIONS(3126),
    [anon_sym_private] = ACTIONS(3126),
    [anon_sym_protected] = ACTIONS(3126),
    [anon_sym_using] = ACTIONS(3126),
    [anon_sym_static_assert] = ACTIONS(3126),
  },
  [1892] = {
    [sym__declaration_modifiers] = STATE(3458),
    [sym_attribute_specifier] = STATE(3458),
    [sym_attribute_declaration] = STATE(3458),
    [sym_ms_declspec_modifier] = STATE(3458),
    [sym_ms_based_modifier] = STATE(8318),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6023),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3458),
    [sym_type_qualifier] = STATE(3458),
    [sym_decltype] = STATE(8290),
    [sym_virtual] = STATE(3458),
    [sym_alignas_specifier] = STATE(3458),
    [sym_explicit_function_specifier] = STATE(3458),
    [sym_operator_cast] = STATE(6506),
    [sym__constructor_specifiers] = STATE(3458),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(8290),
    [sym_template_function] = STATE(6098),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5430),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_operator_cast_identifier] = STATE(6506),
    [sym_operator_name] = STATE(6098),
    [aux_sym_operator_cast_definition_repeat1] = STATE(3458),
    [sym_identifier] = ACTIONS(4841),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(4843),
    [anon_sym_extern] = ACTIONS(4845),
    [anon_sym___attribute__] = ACTIONS(4847),
    [anon_sym_COLON_COLON] = ACTIONS(4849),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4851),
    [anon_sym___declspec] = ACTIONS(4853),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(4845),
    [anon_sym_register] = ACTIONS(4845),
    [anon_sym_inline] = ACTIONS(4845),
    [anon_sym___inline] = ACTIONS(4845),
    [anon_sym___inline__] = ACTIONS(4845),
    [anon_sym___forceinline] = ACTIONS(4845),
    [anon_sym_thread_local] = ACTIONS(4845),
    [anon_sym___thread] = ACTIONS(4845),
    [anon_sym_const] = ACTIONS(4843),
    [anon_sym_constexpr] = ACTIONS(4843),
    [anon_sym_volatile] = ACTIONS(4843),
    [anon_sym_restrict] = ACTIONS(4843),
    [anon_sym___restrict__] = ACTIONS(4843),
    [anon_sym__Atomic] = ACTIONS(4843),
    [anon_sym__Noreturn] = ACTIONS(4843),
    [anon_sym_noreturn] = ACTIONS(4843),
    [anon_sym_mutable] = ACTIONS(4843),
    [anon_sym_constinit] = ACTIONS(4843),
    [anon_sym_consteval] = ACTIONS(4843),
    [anon_sym_PROGMEM] = ACTIONS(4843),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_virtual] = ACTIONS(4855),
    [anon_sym_alignas] = ACTIONS(4857),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_operator] = ACTIONS(133),
  },
  [1893] = {
    [sym_identifier] = ACTIONS(3132),
    [aux_sym_preproc_def_token1] = ACTIONS(3132),
    [aux_sym_preproc_if_token1] = ACTIONS(3132),
    [aux_sym_preproc_if_token2] = ACTIONS(3132),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3132),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3132),
    [aux_sym_preproc_else_token1] = ACTIONS(3132),
    [aux_sym_preproc_elif_token1] = ACTIONS(3132),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3132),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3132),
    [sym_preproc_directive] = ACTIONS(3132),
    [anon_sym_LPAREN2] = ACTIONS(3134),
    [anon_sym_TILDE] = ACTIONS(3134),
    [anon_sym_STAR] = ACTIONS(3134),
    [anon_sym_AMP_AMP] = ACTIONS(3134),
    [anon_sym_AMP] = ACTIONS(3132),
    [anon_sym___extension__] = ACTIONS(3132),
    [anon_sym_typedef] = ACTIONS(3132),
    [anon_sym_extern] = ACTIONS(3132),
    [anon_sym___attribute__] = ACTIONS(3132),
    [anon_sym_COLON_COLON] = ACTIONS(3134),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3134),
    [anon_sym___declspec] = ACTIONS(3132),
    [anon_sym___based] = ACTIONS(3132),
    [anon_sym_signed] = ACTIONS(3132),
    [anon_sym_unsigned] = ACTIONS(3132),
    [anon_sym_long] = ACTIONS(3132),
    [anon_sym_short] = ACTIONS(3132),
    [anon_sym_LBRACK] = ACTIONS(3132),
    [anon_sym_static] = ACTIONS(3132),
    [anon_sym_register] = ACTIONS(3132),
    [anon_sym_inline] = ACTIONS(3132),
    [anon_sym___inline] = ACTIONS(3132),
    [anon_sym___inline__] = ACTIONS(3132),
    [anon_sym___forceinline] = ACTIONS(3132),
    [anon_sym_thread_local] = ACTIONS(3132),
    [anon_sym___thread] = ACTIONS(3132),
    [anon_sym_const] = ACTIONS(3132),
    [anon_sym_constexpr] = ACTIONS(3132),
    [anon_sym_volatile] = ACTIONS(3132),
    [anon_sym_restrict] = ACTIONS(3132),
    [anon_sym___restrict__] = ACTIONS(3132),
    [anon_sym__Atomic] = ACTIONS(3132),
    [anon_sym__Noreturn] = ACTIONS(3132),
    [anon_sym_noreturn] = ACTIONS(3132),
    [anon_sym_mutable] = ACTIONS(3132),
    [anon_sym_constinit] = ACTIONS(3132),
    [anon_sym_consteval] = ACTIONS(3132),
    [anon_sym_PROGMEM] = ACTIONS(3132),
    [aux_sym_primitive_type_token1] = ACTIONS(3132),
    [anon_sym_byte] = ACTIONS(3132),
    [anon_sym_word] = ACTIONS(3132),
    [anon_sym_enum] = ACTIONS(3132),
    [anon_sym_class] = ACTIONS(3132),
    [anon_sym_struct] = ACTIONS(3132),
    [anon_sym_union] = ACTIONS(3132),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3132),
    [anon_sym_decltype] = ACTIONS(3132),
    [anon_sym_virtual] = ACTIONS(3132),
    [anon_sym_alignas] = ACTIONS(3132),
    [anon_sym_explicit] = ACTIONS(3132),
    [anon_sym_typename] = ACTIONS(3132),
    [anon_sym_template] = ACTIONS(3132),
    [anon_sym_operator] = ACTIONS(3132),
    [anon_sym_friend] = ACTIONS(3132),
    [anon_sym_public] = ACTIONS(3132),
    [anon_sym_private] = ACTIONS(3132),
    [anon_sym_protected] = ACTIONS(3132),
    [anon_sym_using] = ACTIONS(3132),
    [anon_sym_static_assert] = ACTIONS(3132),
  },
  [1894] = {
    [sym_identifier] = ACTIONS(3148),
    [aux_sym_preproc_def_token1] = ACTIONS(3148),
    [aux_sym_preproc_if_token1] = ACTIONS(3148),
    [aux_sym_preproc_if_token2] = ACTIONS(3148),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3148),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3148),
    [aux_sym_preproc_else_token1] = ACTIONS(3148),
    [aux_sym_preproc_elif_token1] = ACTIONS(3148),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3148),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3148),
    [sym_preproc_directive] = ACTIONS(3148),
    [anon_sym_LPAREN2] = ACTIONS(3150),
    [anon_sym_TILDE] = ACTIONS(3150),
    [anon_sym_STAR] = ACTIONS(3150),
    [anon_sym_AMP_AMP] = ACTIONS(3150),
    [anon_sym_AMP] = ACTIONS(3148),
    [anon_sym___extension__] = ACTIONS(3148),
    [anon_sym_typedef] = ACTIONS(3148),
    [anon_sym_extern] = ACTIONS(3148),
    [anon_sym___attribute__] = ACTIONS(3148),
    [anon_sym_COLON_COLON] = ACTIONS(3150),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3150),
    [anon_sym___declspec] = ACTIONS(3148),
    [anon_sym___based] = ACTIONS(3148),
    [anon_sym_signed] = ACTIONS(3148),
    [anon_sym_unsigned] = ACTIONS(3148),
    [anon_sym_long] = ACTIONS(3148),
    [anon_sym_short] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_static] = ACTIONS(3148),
    [anon_sym_register] = ACTIONS(3148),
    [anon_sym_inline] = ACTIONS(3148),
    [anon_sym___inline] = ACTIONS(3148),
    [anon_sym___inline__] = ACTIONS(3148),
    [anon_sym___forceinline] = ACTIONS(3148),
    [anon_sym_thread_local] = ACTIONS(3148),
    [anon_sym___thread] = ACTIONS(3148),
    [anon_sym_const] = ACTIONS(3148),
    [anon_sym_constexpr] = ACTIONS(3148),
    [anon_sym_volatile] = ACTIONS(3148),
    [anon_sym_restrict] = ACTIONS(3148),
    [anon_sym___restrict__] = ACTIONS(3148),
    [anon_sym__Atomic] = ACTIONS(3148),
    [anon_sym__Noreturn] = ACTIONS(3148),
    [anon_sym_noreturn] = ACTIONS(3148),
    [anon_sym_mutable] = ACTIONS(3148),
    [anon_sym_constinit] = ACTIONS(3148),
    [anon_sym_consteval] = ACTIONS(3148),
    [anon_sym_PROGMEM] = ACTIONS(3148),
    [aux_sym_primitive_type_token1] = ACTIONS(3148),
    [anon_sym_byte] = ACTIONS(3148),
    [anon_sym_word] = ACTIONS(3148),
    [anon_sym_enum] = ACTIONS(3148),
    [anon_sym_class] = ACTIONS(3148),
    [anon_sym_struct] = ACTIONS(3148),
    [anon_sym_union] = ACTIONS(3148),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3148),
    [anon_sym_decltype] = ACTIONS(3148),
    [anon_sym_virtual] = ACTIONS(3148),
    [anon_sym_alignas] = ACTIONS(3148),
    [anon_sym_explicit] = ACTIONS(3148),
    [anon_sym_typename] = ACTIONS(3148),
    [anon_sym_template] = ACTIONS(3148),
    [anon_sym_operator] = ACTIONS(3148),
    [anon_sym_friend] = ACTIONS(3148),
    [anon_sym_public] = ACTIONS(3148),
    [anon_sym_private] = ACTIONS(3148),
    [anon_sym_protected] = ACTIONS(3148),
    [anon_sym_using] = ACTIONS(3148),
    [anon_sym_static_assert] = ACTIONS(3148),
  },
  [1895] = {
    [sym_identifier] = ACTIONS(3170),
    [aux_sym_preproc_def_token1] = ACTIONS(3170),
    [aux_sym_preproc_if_token1] = ACTIONS(3170),
    [aux_sym_preproc_if_token2] = ACTIONS(3170),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3170),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3170),
    [aux_sym_preproc_else_token1] = ACTIONS(3170),
    [aux_sym_preproc_elif_token1] = ACTIONS(3170),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3170),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3170),
    [sym_preproc_directive] = ACTIONS(3170),
    [anon_sym_LPAREN2] = ACTIONS(3172),
    [anon_sym_TILDE] = ACTIONS(3172),
    [anon_sym_STAR] = ACTIONS(3172),
    [anon_sym_AMP_AMP] = ACTIONS(3172),
    [anon_sym_AMP] = ACTIONS(3170),
    [anon_sym___extension__] = ACTIONS(3170),
    [anon_sym_typedef] = ACTIONS(3170),
    [anon_sym_extern] = ACTIONS(3170),
    [anon_sym___attribute__] = ACTIONS(3170),
    [anon_sym_COLON_COLON] = ACTIONS(3172),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3172),
    [anon_sym___declspec] = ACTIONS(3170),
    [anon_sym___based] = ACTIONS(3170),
    [anon_sym_signed] = ACTIONS(3170),
    [anon_sym_unsigned] = ACTIONS(3170),
    [anon_sym_long] = ACTIONS(3170),
    [anon_sym_short] = ACTIONS(3170),
    [anon_sym_LBRACK] = ACTIONS(3170),
    [anon_sym_static] = ACTIONS(3170),
    [anon_sym_register] = ACTIONS(3170),
    [anon_sym_inline] = ACTIONS(3170),
    [anon_sym___inline] = ACTIONS(3170),
    [anon_sym___inline__] = ACTIONS(3170),
    [anon_sym___forceinline] = ACTIONS(3170),
    [anon_sym_thread_local] = ACTIONS(3170),
    [anon_sym___thread] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3170),
    [anon_sym_constexpr] = ACTIONS(3170),
    [anon_sym_volatile] = ACTIONS(3170),
    [anon_sym_restrict] = ACTIONS(3170),
    [anon_sym___restrict__] = ACTIONS(3170),
    [anon_sym__Atomic] = ACTIONS(3170),
    [anon_sym__Noreturn] = ACTIONS(3170),
    [anon_sym_noreturn] = ACTIONS(3170),
    [anon_sym_mutable] = ACTIONS(3170),
    [anon_sym_constinit] = ACTIONS(3170),
    [anon_sym_consteval] = ACTIONS(3170),
    [anon_sym_PROGMEM] = ACTIONS(3170),
    [aux_sym_primitive_type_token1] = ACTIONS(3170),
    [anon_sym_byte] = ACTIONS(3170),
    [anon_sym_word] = ACTIONS(3170),
    [anon_sym_enum] = ACTIONS(3170),
    [anon_sym_class] = ACTIONS(3170),
    [anon_sym_struct] = ACTIONS(3170),
    [anon_sym_union] = ACTIONS(3170),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3170),
    [anon_sym_decltype] = ACTIONS(3170),
    [anon_sym_virtual] = ACTIONS(3170),
    [anon_sym_alignas] = ACTIONS(3170),
    [anon_sym_explicit] = ACTIONS(3170),
    [anon_sym_typename] = ACTIONS(3170),
    [anon_sym_template] = ACTIONS(3170),
    [anon_sym_operator] = ACTIONS(3170),
    [anon_sym_friend] = ACTIONS(3170),
    [anon_sym_public] = ACTIONS(3170),
    [anon_sym_private] = ACTIONS(3170),
    [anon_sym_protected] = ACTIONS(3170),
    [anon_sym_using] = ACTIONS(3170),
    [anon_sym_static_assert] = ACTIONS(3170),
  },
  [1896] = {
    [sym_identifier] = ACTIONS(4928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4930),
    [anon_sym_COMMA] = ACTIONS(4930),
    [anon_sym_RPAREN] = ACTIONS(4930),
    [anon_sym_LPAREN2] = ACTIONS(4930),
    [anon_sym_DASH] = ACTIONS(4928),
    [anon_sym_PLUS] = ACTIONS(4928),
    [anon_sym_STAR] = ACTIONS(4930),
    [anon_sym_SLASH] = ACTIONS(4928),
    [anon_sym_PERCENT] = ACTIONS(4930),
    [anon_sym_PIPE_PIPE] = ACTIONS(4930),
    [anon_sym_AMP_AMP] = ACTIONS(4930),
    [anon_sym_PIPE] = ACTIONS(4928),
    [anon_sym_CARET] = ACTIONS(4930),
    [anon_sym_AMP] = ACTIONS(4928),
    [anon_sym_EQ_EQ] = ACTIONS(4930),
    [anon_sym_BANG_EQ] = ACTIONS(4930),
    [anon_sym_GT] = ACTIONS(4928),
    [anon_sym_GT_EQ] = ACTIONS(4930),
    [anon_sym_LT_EQ] = ACTIONS(4928),
    [anon_sym_LT] = ACTIONS(4928),
    [anon_sym_LT_LT] = ACTIONS(4930),
    [anon_sym_GT_GT] = ACTIONS(4930),
    [anon_sym_SEMI] = ACTIONS(4930),
    [anon_sym___extension__] = ACTIONS(4928),
    [anon_sym___attribute__] = ACTIONS(4928),
    [anon_sym_COLON_COLON] = ACTIONS(4930),
    [anon_sym___based] = ACTIONS(4928),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_RBRACE] = ACTIONS(4930),
    [anon_sym_signed] = ACTIONS(4928),
    [anon_sym_unsigned] = ACTIONS(4928),
    [anon_sym_long] = ACTIONS(4928),
    [anon_sym_short] = ACTIONS(4928),
    [anon_sym_LBRACK] = ACTIONS(4930),
    [anon_sym_RBRACK] = ACTIONS(4930),
    [anon_sym_const] = ACTIONS(4928),
    [anon_sym_constexpr] = ACTIONS(4928),
    [anon_sym_volatile] = ACTIONS(4928),
    [anon_sym_restrict] = ACTIONS(4928),
    [anon_sym___restrict__] = ACTIONS(4928),
    [anon_sym__Atomic] = ACTIONS(4928),
    [anon_sym__Noreturn] = ACTIONS(4928),
    [anon_sym_noreturn] = ACTIONS(4928),
    [anon_sym_mutable] = ACTIONS(4928),
    [anon_sym_constinit] = ACTIONS(4928),
    [anon_sym_consteval] = ACTIONS(4928),
    [anon_sym_PROGMEM] = ACTIONS(4928),
    [aux_sym_primitive_type_token1] = ACTIONS(4928),
    [anon_sym_byte] = ACTIONS(4928),
    [anon_sym_word] = ACTIONS(4928),
    [anon_sym_COLON] = ACTIONS(4928),
    [anon_sym_QMARK] = ACTIONS(4930),
    [anon_sym_LT_EQ_GT] = ACTIONS(4930),
    [anon_sym_or] = ACTIONS(4928),
    [anon_sym_and] = ACTIONS(4928),
    [anon_sym_bitor] = ACTIONS(4928),
    [anon_sym_xor] = ACTIONS(4928),
    [anon_sym_bitand] = ACTIONS(4928),
    [anon_sym_not_eq] = ACTIONS(4928),
    [anon_sym_DASH_DASH] = ACTIONS(4930),
    [anon_sym_PLUS_PLUS] = ACTIONS(4930),
    [anon_sym_DOT] = ACTIONS(4928),
    [anon_sym_DOT_STAR] = ACTIONS(4930),
    [anon_sym_DASH_GT] = ACTIONS(4930),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4928),
    [anon_sym_decltype] = ACTIONS(4928),
    [anon_sym_final] = ACTIONS(4928),
    [anon_sym_override] = ACTIONS(4928),
    [anon_sym_requires] = ACTIONS(4928),
  },
  [1897] = {
    [sym_identifier] = ACTIONS(3111),
    [aux_sym_preproc_def_token1] = ACTIONS(3111),
    [aux_sym_preproc_if_token1] = ACTIONS(3111),
    [aux_sym_preproc_if_token2] = ACTIONS(3111),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3111),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3111),
    [aux_sym_preproc_else_token1] = ACTIONS(3111),
    [aux_sym_preproc_elif_token1] = ACTIONS(3111),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3111),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3111),
    [sym_preproc_directive] = ACTIONS(3111),
    [anon_sym_LPAREN2] = ACTIONS(3113),
    [anon_sym_TILDE] = ACTIONS(3113),
    [anon_sym_STAR] = ACTIONS(3113),
    [anon_sym_AMP_AMP] = ACTIONS(3113),
    [anon_sym_AMP] = ACTIONS(3111),
    [anon_sym___extension__] = ACTIONS(3111),
    [anon_sym_typedef] = ACTIONS(3111),
    [anon_sym_extern] = ACTIONS(3111),
    [anon_sym___attribute__] = ACTIONS(3111),
    [anon_sym_COLON_COLON] = ACTIONS(3113),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3113),
    [anon_sym___declspec] = ACTIONS(3111),
    [anon_sym___based] = ACTIONS(3111),
    [anon_sym_signed] = ACTIONS(3111),
    [anon_sym_unsigned] = ACTIONS(3111),
    [anon_sym_long] = ACTIONS(3111),
    [anon_sym_short] = ACTIONS(3111),
    [anon_sym_LBRACK] = ACTIONS(3111),
    [anon_sym_static] = ACTIONS(3111),
    [anon_sym_register] = ACTIONS(3111),
    [anon_sym_inline] = ACTIONS(3111),
    [anon_sym___inline] = ACTIONS(3111),
    [anon_sym___inline__] = ACTIONS(3111),
    [anon_sym___forceinline] = ACTIONS(3111),
    [anon_sym_thread_local] = ACTIONS(3111),
    [anon_sym___thread] = ACTIONS(3111),
    [anon_sym_const] = ACTIONS(3111),
    [anon_sym_constexpr] = ACTIONS(3111),
    [anon_sym_volatile] = ACTIONS(3111),
    [anon_sym_restrict] = ACTIONS(3111),
    [anon_sym___restrict__] = ACTIONS(3111),
    [anon_sym__Atomic] = ACTIONS(3111),
    [anon_sym__Noreturn] = ACTIONS(3111),
    [anon_sym_noreturn] = ACTIONS(3111),
    [anon_sym_mutable] = ACTIONS(3111),
    [anon_sym_constinit] = ACTIONS(3111),
    [anon_sym_consteval] = ACTIONS(3111),
    [anon_sym_PROGMEM] = ACTIONS(3111),
    [aux_sym_primitive_type_token1] = ACTIONS(3111),
    [anon_sym_byte] = ACTIONS(3111),
    [anon_sym_word] = ACTIONS(3111),
    [anon_sym_enum] = ACTIONS(3111),
    [anon_sym_class] = ACTIONS(3111),
    [anon_sym_struct] = ACTIONS(3111),
    [anon_sym_union] = ACTIONS(3111),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3111),
    [anon_sym_decltype] = ACTIONS(3111),
    [anon_sym_virtual] = ACTIONS(3111),
    [anon_sym_alignas] = ACTIONS(3111),
    [anon_sym_explicit] = ACTIONS(3111),
    [anon_sym_typename] = ACTIONS(3111),
    [anon_sym_template] = ACTIONS(3111),
    [anon_sym_operator] = ACTIONS(3111),
    [anon_sym_friend] = ACTIONS(3111),
    [anon_sym_public] = ACTIONS(3111),
    [anon_sym_private] = ACTIONS(3111),
    [anon_sym_protected] = ACTIONS(3111),
    [anon_sym_using] = ACTIONS(3111),
    [anon_sym_static_assert] = ACTIONS(3111),
  },
  [1898] = {
    [sym_primitive_type] = STATE(2272),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1974),
    [sym_identifier] = ACTIONS(4932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4934),
    [anon_sym_COMMA] = ACTIONS(4934),
    [anon_sym_RPAREN] = ACTIONS(4934),
    [anon_sym_LPAREN2] = ACTIONS(4934),
    [anon_sym_DASH] = ACTIONS(4936),
    [anon_sym_PLUS] = ACTIONS(4936),
    [anon_sym_STAR] = ACTIONS(4934),
    [anon_sym_SLASH] = ACTIONS(4936),
    [anon_sym_PERCENT] = ACTIONS(4934),
    [anon_sym_PIPE_PIPE] = ACTIONS(4934),
    [anon_sym_AMP_AMP] = ACTIONS(4934),
    [anon_sym_PIPE] = ACTIONS(4936),
    [anon_sym_CARET] = ACTIONS(4934),
    [anon_sym_AMP] = ACTIONS(4936),
    [anon_sym_EQ_EQ] = ACTIONS(4934),
    [anon_sym_BANG_EQ] = ACTIONS(4934),
    [anon_sym_GT] = ACTIONS(4936),
    [anon_sym_GT_EQ] = ACTIONS(4934),
    [anon_sym_LT_EQ] = ACTIONS(4936),
    [anon_sym_LT] = ACTIONS(4936),
    [anon_sym_LT_LT] = ACTIONS(4934),
    [anon_sym_GT_GT] = ACTIONS(4934),
    [anon_sym_SEMI] = ACTIONS(4934),
    [anon_sym___extension__] = ACTIONS(4936),
    [anon_sym___attribute__] = ACTIONS(4936),
    [anon_sym_LBRACE] = ACTIONS(4934),
    [anon_sym_RBRACE] = ACTIONS(4934),
    [anon_sym_signed] = ACTIONS(4938),
    [anon_sym_unsigned] = ACTIONS(4938),
    [anon_sym_long] = ACTIONS(4938),
    [anon_sym_short] = ACTIONS(4938),
    [anon_sym_LBRACK] = ACTIONS(4934),
    [anon_sym_RBRACK] = ACTIONS(4934),
    [anon_sym_const] = ACTIONS(4936),
    [anon_sym_constexpr] = ACTIONS(4936),
    [anon_sym_volatile] = ACTIONS(4936),
    [anon_sym_restrict] = ACTIONS(4936),
    [anon_sym___restrict__] = ACTIONS(4936),
    [anon_sym__Atomic] = ACTIONS(4936),
    [anon_sym__Noreturn] = ACTIONS(4936),
    [anon_sym_noreturn] = ACTIONS(4936),
    [anon_sym_mutable] = ACTIONS(4936),
    [anon_sym_constinit] = ACTIONS(4936),
    [anon_sym_consteval] = ACTIONS(4936),
    [anon_sym_PROGMEM] = ACTIONS(4936),
    [aux_sym_primitive_type_token1] = ACTIONS(1831),
    [anon_sym_byte] = ACTIONS(1831),
    [anon_sym_word] = ACTIONS(1831),
    [anon_sym_COLON] = ACTIONS(4934),
    [anon_sym_QMARK] = ACTIONS(4934),
    [anon_sym_LT_EQ_GT] = ACTIONS(4934),
    [anon_sym_or] = ACTIONS(4936),
    [anon_sym_and] = ACTIONS(4936),
    [anon_sym_bitor] = ACTIONS(4936),
    [anon_sym_xor] = ACTIONS(4936),
    [anon_sym_bitand] = ACTIONS(4936),
    [anon_sym_not_eq] = ACTIONS(4936),
    [anon_sym_DASH_DASH] = ACTIONS(4934),
    [anon_sym_PLUS_PLUS] = ACTIONS(4934),
    [anon_sym_DOT] = ACTIONS(4936),
    [anon_sym_DOT_STAR] = ACTIONS(4934),
    [anon_sym_DASH_GT] = ACTIONS(4934),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4936),
    [anon_sym_decltype] = ACTIONS(4936),
    [anon_sym_final] = ACTIONS(4936),
    [anon_sym_override] = ACTIONS(4936),
    [anon_sym_requires] = ACTIONS(4936),
  },
  [1899] = {
    [sym_identifier] = ACTIONS(3064),
    [aux_sym_preproc_def_token1] = ACTIONS(3064),
    [aux_sym_preproc_if_token1] = ACTIONS(3064),
    [aux_sym_preproc_if_token2] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3064),
    [aux_sym_preproc_else_token1] = ACTIONS(3064),
    [aux_sym_preproc_elif_token1] = ACTIONS(3064),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3064),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3064),
    [sym_preproc_directive] = ACTIONS(3064),
    [anon_sym_LPAREN2] = ACTIONS(3066),
    [anon_sym_TILDE] = ACTIONS(3066),
    [anon_sym_STAR] = ACTIONS(3066),
    [anon_sym_AMP_AMP] = ACTIONS(3066),
    [anon_sym_AMP] = ACTIONS(3064),
    [anon_sym___extension__] = ACTIONS(3064),
    [anon_sym_typedef] = ACTIONS(3064),
    [anon_sym_extern] = ACTIONS(3064),
    [anon_sym___attribute__] = ACTIONS(3064),
    [anon_sym_COLON_COLON] = ACTIONS(3066),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3066),
    [anon_sym___declspec] = ACTIONS(3064),
    [anon_sym___based] = ACTIONS(3064),
    [anon_sym_signed] = ACTIONS(3064),
    [anon_sym_unsigned] = ACTIONS(3064),
    [anon_sym_long] = ACTIONS(3064),
    [anon_sym_short] = ACTIONS(3064),
    [anon_sym_LBRACK] = ACTIONS(3064),
    [anon_sym_static] = ACTIONS(3064),
    [anon_sym_register] = ACTIONS(3064),
    [anon_sym_inline] = ACTIONS(3064),
    [anon_sym___inline] = ACTIONS(3064),
    [anon_sym___inline__] = ACTIONS(3064),
    [anon_sym___forceinline] = ACTIONS(3064),
    [anon_sym_thread_local] = ACTIONS(3064),
    [anon_sym___thread] = ACTIONS(3064),
    [anon_sym_const] = ACTIONS(3064),
    [anon_sym_constexpr] = ACTIONS(3064),
    [anon_sym_volatile] = ACTIONS(3064),
    [anon_sym_restrict] = ACTIONS(3064),
    [anon_sym___restrict__] = ACTIONS(3064),
    [anon_sym__Atomic] = ACTIONS(3064),
    [anon_sym__Noreturn] = ACTIONS(3064),
    [anon_sym_noreturn] = ACTIONS(3064),
    [anon_sym_mutable] = ACTIONS(3064),
    [anon_sym_constinit] = ACTIONS(3064),
    [anon_sym_consteval] = ACTIONS(3064),
    [anon_sym_PROGMEM] = ACTIONS(3064),
    [aux_sym_primitive_type_token1] = ACTIONS(3064),
    [anon_sym_byte] = ACTIONS(3064),
    [anon_sym_word] = ACTIONS(3064),
    [anon_sym_enum] = ACTIONS(3064),
    [anon_sym_class] = ACTIONS(3064),
    [anon_sym_struct] = ACTIONS(3064),
    [anon_sym_union] = ACTIONS(3064),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3064),
    [anon_sym_decltype] = ACTIONS(3064),
    [anon_sym_virtual] = ACTIONS(3064),
    [anon_sym_alignas] = ACTIONS(3064),
    [anon_sym_explicit] = ACTIONS(3064),
    [anon_sym_typename] = ACTIONS(3064),
    [anon_sym_template] = ACTIONS(3064),
    [anon_sym_operator] = ACTIONS(3064),
    [anon_sym_friend] = ACTIONS(3064),
    [anon_sym_public] = ACTIONS(3064),
    [anon_sym_private] = ACTIONS(3064),
    [anon_sym_protected] = ACTIONS(3064),
    [anon_sym_using] = ACTIONS(3064),
    [anon_sym_static_assert] = ACTIONS(3064),
  },
  [1900] = {
    [sym__declaration_modifiers] = STATE(3458),
    [sym_attribute_specifier] = STATE(3458),
    [sym_attribute_declaration] = STATE(3458),
    [sym_ms_declspec_modifier] = STATE(3458),
    [sym_ms_based_modifier] = STATE(8318),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6138),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3458),
    [sym_type_qualifier] = STATE(3458),
    [sym_decltype] = STATE(8290),
    [sym_virtual] = STATE(3458),
    [sym_alignas_specifier] = STATE(3458),
    [sym_explicit_function_specifier] = STATE(3458),
    [sym_operator_cast] = STATE(6528),
    [sym__constructor_specifiers] = STATE(3458),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(8290),
    [sym_template_function] = STATE(6098),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5430),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_operator_cast_identifier] = STATE(6528),
    [sym_operator_name] = STATE(6098),
    [aux_sym_operator_cast_definition_repeat1] = STATE(3458),
    [sym_identifier] = ACTIONS(4841),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(4843),
    [anon_sym_extern] = ACTIONS(4845),
    [anon_sym___attribute__] = ACTIONS(4847),
    [anon_sym_COLON_COLON] = ACTIONS(4849),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4851),
    [anon_sym___declspec] = ACTIONS(4853),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(4845),
    [anon_sym_register] = ACTIONS(4845),
    [anon_sym_inline] = ACTIONS(4845),
    [anon_sym___inline] = ACTIONS(4845),
    [anon_sym___inline__] = ACTIONS(4845),
    [anon_sym___forceinline] = ACTIONS(4845),
    [anon_sym_thread_local] = ACTIONS(4845),
    [anon_sym___thread] = ACTIONS(4845),
    [anon_sym_const] = ACTIONS(4843),
    [anon_sym_constexpr] = ACTIONS(4843),
    [anon_sym_volatile] = ACTIONS(4843),
    [anon_sym_restrict] = ACTIONS(4843),
    [anon_sym___restrict__] = ACTIONS(4843),
    [anon_sym__Atomic] = ACTIONS(4843),
    [anon_sym__Noreturn] = ACTIONS(4843),
    [anon_sym_noreturn] = ACTIONS(4843),
    [anon_sym_mutable] = ACTIONS(4843),
    [anon_sym_constinit] = ACTIONS(4843),
    [anon_sym_consteval] = ACTIONS(4843),
    [anon_sym_PROGMEM] = ACTIONS(4843),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_virtual] = ACTIONS(4855),
    [anon_sym_alignas] = ACTIONS(4857),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_operator] = ACTIONS(133),
  },
  [1901] = {
    [sym_identifier] = ACTIONS(4940),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4942),
    [anon_sym_COMMA] = ACTIONS(4942),
    [anon_sym_RPAREN] = ACTIONS(4942),
    [anon_sym_LPAREN2] = ACTIONS(4942),
    [anon_sym_DASH] = ACTIONS(4940),
    [anon_sym_PLUS] = ACTIONS(4940),
    [anon_sym_STAR] = ACTIONS(4942),
    [anon_sym_SLASH] = ACTIONS(4940),
    [anon_sym_PERCENT] = ACTIONS(4942),
    [anon_sym_PIPE_PIPE] = ACTIONS(4942),
    [anon_sym_AMP_AMP] = ACTIONS(4942),
    [anon_sym_PIPE] = ACTIONS(4940),
    [anon_sym_CARET] = ACTIONS(4942),
    [anon_sym_AMP] = ACTIONS(4940),
    [anon_sym_EQ_EQ] = ACTIONS(4942),
    [anon_sym_BANG_EQ] = ACTIONS(4942),
    [anon_sym_GT] = ACTIONS(4940),
    [anon_sym_GT_EQ] = ACTIONS(4942),
    [anon_sym_LT_EQ] = ACTIONS(4940),
    [anon_sym_LT] = ACTIONS(4940),
    [anon_sym_LT_LT] = ACTIONS(4942),
    [anon_sym_GT_GT] = ACTIONS(4942),
    [anon_sym_SEMI] = ACTIONS(4942),
    [anon_sym___extension__] = ACTIONS(4940),
    [anon_sym___attribute__] = ACTIONS(4940),
    [anon_sym_COLON_COLON] = ACTIONS(4922),
    [anon_sym___based] = ACTIONS(4940),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_RBRACE] = ACTIONS(4942),
    [anon_sym_signed] = ACTIONS(4940),
    [anon_sym_unsigned] = ACTIONS(4940),
    [anon_sym_long] = ACTIONS(4940),
    [anon_sym_short] = ACTIONS(4940),
    [anon_sym_LBRACK] = ACTIONS(4942),
    [anon_sym_RBRACK] = ACTIONS(4942),
    [anon_sym_const] = ACTIONS(4940),
    [anon_sym_constexpr] = ACTIONS(4940),
    [anon_sym_volatile] = ACTIONS(4940),
    [anon_sym_restrict] = ACTIONS(4940),
    [anon_sym___restrict__] = ACTIONS(4940),
    [anon_sym__Atomic] = ACTIONS(4940),
    [anon_sym__Noreturn] = ACTIONS(4940),
    [anon_sym_noreturn] = ACTIONS(4940),
    [anon_sym_mutable] = ACTIONS(4940),
    [anon_sym_constinit] = ACTIONS(4940),
    [anon_sym_consteval] = ACTIONS(4940),
    [anon_sym_PROGMEM] = ACTIONS(4940),
    [aux_sym_primitive_type_token1] = ACTIONS(4940),
    [anon_sym_byte] = ACTIONS(4940),
    [anon_sym_word] = ACTIONS(4940),
    [anon_sym_COLON] = ACTIONS(4940),
    [anon_sym_QMARK] = ACTIONS(4942),
    [anon_sym_LT_EQ_GT] = ACTIONS(4942),
    [anon_sym_or] = ACTIONS(4940),
    [anon_sym_and] = ACTIONS(4940),
    [anon_sym_bitor] = ACTIONS(4940),
    [anon_sym_xor] = ACTIONS(4940),
    [anon_sym_bitand] = ACTIONS(4940),
    [anon_sym_not_eq] = ACTIONS(4940),
    [anon_sym_DASH_DASH] = ACTIONS(4942),
    [anon_sym_PLUS_PLUS] = ACTIONS(4942),
    [anon_sym_DOT] = ACTIONS(4940),
    [anon_sym_DOT_STAR] = ACTIONS(4942),
    [anon_sym_DASH_GT] = ACTIONS(4942),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4940),
    [anon_sym_decltype] = ACTIONS(4940),
    [anon_sym_final] = ACTIONS(4940),
    [anon_sym_override] = ACTIONS(4940),
    [anon_sym_requires] = ACTIONS(4940),
  },
  [1902] = {
    [sym_identifier] = ACTIONS(2967),
    [aux_sym_preproc_def_token1] = ACTIONS(2967),
    [aux_sym_preproc_if_token1] = ACTIONS(2967),
    [aux_sym_preproc_if_token2] = ACTIONS(2967),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2967),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2967),
    [aux_sym_preproc_else_token1] = ACTIONS(2967),
    [aux_sym_preproc_elif_token1] = ACTIONS(2967),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2967),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2967),
    [sym_preproc_directive] = ACTIONS(2967),
    [anon_sym_LPAREN2] = ACTIONS(2969),
    [anon_sym_TILDE] = ACTIONS(2969),
    [anon_sym_STAR] = ACTIONS(2969),
    [anon_sym_AMP_AMP] = ACTIONS(2969),
    [anon_sym_AMP] = ACTIONS(2967),
    [anon_sym___extension__] = ACTIONS(2967),
    [anon_sym_typedef] = ACTIONS(2967),
    [anon_sym_extern] = ACTIONS(2967),
    [anon_sym___attribute__] = ACTIONS(2967),
    [anon_sym_COLON_COLON] = ACTIONS(2969),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2969),
    [anon_sym___declspec] = ACTIONS(2967),
    [anon_sym___based] = ACTIONS(2967),
    [anon_sym_signed] = ACTIONS(2967),
    [anon_sym_unsigned] = ACTIONS(2967),
    [anon_sym_long] = ACTIONS(2967),
    [anon_sym_short] = ACTIONS(2967),
    [anon_sym_LBRACK] = ACTIONS(2967),
    [anon_sym_static] = ACTIONS(2967),
    [anon_sym_register] = ACTIONS(2967),
    [anon_sym_inline] = ACTIONS(2967),
    [anon_sym___inline] = ACTIONS(2967),
    [anon_sym___inline__] = ACTIONS(2967),
    [anon_sym___forceinline] = ACTIONS(2967),
    [anon_sym_thread_local] = ACTIONS(2967),
    [anon_sym___thread] = ACTIONS(2967),
    [anon_sym_const] = ACTIONS(2967),
    [anon_sym_constexpr] = ACTIONS(2967),
    [anon_sym_volatile] = ACTIONS(2967),
    [anon_sym_restrict] = ACTIONS(2967),
    [anon_sym___restrict__] = ACTIONS(2967),
    [anon_sym__Atomic] = ACTIONS(2967),
    [anon_sym__Noreturn] = ACTIONS(2967),
    [anon_sym_noreturn] = ACTIONS(2967),
    [anon_sym_mutable] = ACTIONS(2967),
    [anon_sym_constinit] = ACTIONS(2967),
    [anon_sym_consteval] = ACTIONS(2967),
    [anon_sym_PROGMEM] = ACTIONS(2967),
    [aux_sym_primitive_type_token1] = ACTIONS(2967),
    [anon_sym_byte] = ACTIONS(2967),
    [anon_sym_word] = ACTIONS(2967),
    [anon_sym_enum] = ACTIONS(2967),
    [anon_sym_class] = ACTIONS(2967),
    [anon_sym_struct] = ACTIONS(2967),
    [anon_sym_union] = ACTIONS(2967),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2967),
    [anon_sym_decltype] = ACTIONS(2967),
    [anon_sym_virtual] = ACTIONS(2967),
    [anon_sym_alignas] = ACTIONS(2967),
    [anon_sym_explicit] = ACTIONS(2967),
    [anon_sym_typename] = ACTIONS(2967),
    [anon_sym_template] = ACTIONS(2967),
    [anon_sym_operator] = ACTIONS(2967),
    [anon_sym_friend] = ACTIONS(2967),
    [anon_sym_public] = ACTIONS(2967),
    [anon_sym_private] = ACTIONS(2967),
    [anon_sym_protected] = ACTIONS(2967),
    [anon_sym_using] = ACTIONS(2967),
    [anon_sym_static_assert] = ACTIONS(2967),
  },
  [1903] = {
    [sym__declaration_modifiers] = STATE(3458),
    [sym_attribute_specifier] = STATE(3458),
    [sym_attribute_declaration] = STATE(3458),
    [sym_ms_declspec_modifier] = STATE(3458),
    [sym_ms_based_modifier] = STATE(8318),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(5957),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3458),
    [sym_type_qualifier] = STATE(3458),
    [sym_decltype] = STATE(8290),
    [sym_virtual] = STATE(3458),
    [sym_alignas_specifier] = STATE(3458),
    [sym_explicit_function_specifier] = STATE(3458),
    [sym_operator_cast] = STATE(6498),
    [sym__constructor_specifiers] = STATE(3458),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(8290),
    [sym_template_function] = STATE(6098),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5430),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_operator_cast_identifier] = STATE(6498),
    [sym_operator_name] = STATE(6098),
    [aux_sym_operator_cast_definition_repeat1] = STATE(3458),
    [sym_identifier] = ACTIONS(4841),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(4843),
    [anon_sym_extern] = ACTIONS(4845),
    [anon_sym___attribute__] = ACTIONS(4847),
    [anon_sym_COLON_COLON] = ACTIONS(4849),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4851),
    [anon_sym___declspec] = ACTIONS(4853),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(4845),
    [anon_sym_register] = ACTIONS(4845),
    [anon_sym_inline] = ACTIONS(4845),
    [anon_sym___inline] = ACTIONS(4845),
    [anon_sym___inline__] = ACTIONS(4845),
    [anon_sym___forceinline] = ACTIONS(4845),
    [anon_sym_thread_local] = ACTIONS(4845),
    [anon_sym___thread] = ACTIONS(4845),
    [anon_sym_const] = ACTIONS(4843),
    [anon_sym_constexpr] = ACTIONS(4843),
    [anon_sym_volatile] = ACTIONS(4843),
    [anon_sym_restrict] = ACTIONS(4843),
    [anon_sym___restrict__] = ACTIONS(4843),
    [anon_sym__Atomic] = ACTIONS(4843),
    [anon_sym__Noreturn] = ACTIONS(4843),
    [anon_sym_noreturn] = ACTIONS(4843),
    [anon_sym_mutable] = ACTIONS(4843),
    [anon_sym_constinit] = ACTIONS(4843),
    [anon_sym_consteval] = ACTIONS(4843),
    [anon_sym_PROGMEM] = ACTIONS(4843),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_virtual] = ACTIONS(4855),
    [anon_sym_alignas] = ACTIONS(4857),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_operator] = ACTIONS(133),
  },
  [1904] = {
    [sym_identifier] = ACTIONS(4944),
    [aux_sym_preproc_def_token1] = ACTIONS(4944),
    [aux_sym_preproc_if_token1] = ACTIONS(4944),
    [aux_sym_preproc_if_token2] = ACTIONS(4944),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4944),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4944),
    [aux_sym_preproc_else_token1] = ACTIONS(4944),
    [aux_sym_preproc_elif_token1] = ACTIONS(4944),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4944),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4944),
    [sym_preproc_directive] = ACTIONS(4944),
    [anon_sym_LPAREN2] = ACTIONS(4946),
    [anon_sym_TILDE] = ACTIONS(4946),
    [anon_sym_STAR] = ACTIONS(4946),
    [anon_sym_AMP_AMP] = ACTIONS(4946),
    [anon_sym_AMP] = ACTIONS(4944),
    [anon_sym___extension__] = ACTIONS(4944),
    [anon_sym_typedef] = ACTIONS(4944),
    [anon_sym_extern] = ACTIONS(4944),
    [anon_sym___attribute__] = ACTIONS(4944),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4946),
    [anon_sym___declspec] = ACTIONS(4944),
    [anon_sym___based] = ACTIONS(4944),
    [anon_sym_signed] = ACTIONS(4944),
    [anon_sym_unsigned] = ACTIONS(4944),
    [anon_sym_long] = ACTIONS(4944),
    [anon_sym_short] = ACTIONS(4944),
    [anon_sym_LBRACK] = ACTIONS(4944),
    [anon_sym_static] = ACTIONS(4944),
    [anon_sym_register] = ACTIONS(4944),
    [anon_sym_inline] = ACTIONS(4944),
    [anon_sym___inline] = ACTIONS(4944),
    [anon_sym___inline__] = ACTIONS(4944),
    [anon_sym___forceinline] = ACTIONS(4944),
    [anon_sym_thread_local] = ACTIONS(4944),
    [anon_sym___thread] = ACTIONS(4944),
    [anon_sym_const] = ACTIONS(4944),
    [anon_sym_constexpr] = ACTIONS(4944),
    [anon_sym_volatile] = ACTIONS(4944),
    [anon_sym_restrict] = ACTIONS(4944),
    [anon_sym___restrict__] = ACTIONS(4944),
    [anon_sym__Atomic] = ACTIONS(4944),
    [anon_sym__Noreturn] = ACTIONS(4944),
    [anon_sym_noreturn] = ACTIONS(4944),
    [anon_sym_mutable] = ACTIONS(4944),
    [anon_sym_constinit] = ACTIONS(4944),
    [anon_sym_consteval] = ACTIONS(4944),
    [anon_sym_PROGMEM] = ACTIONS(4944),
    [aux_sym_primitive_type_token1] = ACTIONS(4944),
    [anon_sym_byte] = ACTIONS(4944),
    [anon_sym_word] = ACTIONS(4944),
    [anon_sym_enum] = ACTIONS(4944),
    [anon_sym_class] = ACTIONS(4944),
    [anon_sym_struct] = ACTIONS(4944),
    [anon_sym_union] = ACTIONS(4944),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4944),
    [anon_sym_decltype] = ACTIONS(4944),
    [anon_sym_virtual] = ACTIONS(4944),
    [anon_sym_alignas] = ACTIONS(4944),
    [anon_sym_explicit] = ACTIONS(4944),
    [anon_sym_typename] = ACTIONS(4944),
    [anon_sym_template] = ACTIONS(4944),
    [anon_sym_operator] = ACTIONS(4944),
    [anon_sym_friend] = ACTIONS(4944),
    [anon_sym_public] = ACTIONS(4944),
    [anon_sym_private] = ACTIONS(4944),
    [anon_sym_protected] = ACTIONS(4944),
    [anon_sym_using] = ACTIONS(4944),
    [anon_sym_static_assert] = ACTIONS(4944),
  },
  [1905] = {
    [sym_identifier] = ACTIONS(4944),
    [aux_sym_preproc_def_token1] = ACTIONS(4944),
    [aux_sym_preproc_if_token1] = ACTIONS(4944),
    [aux_sym_preproc_if_token2] = ACTIONS(4944),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4944),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4944),
    [aux_sym_preproc_else_token1] = ACTIONS(4944),
    [aux_sym_preproc_elif_token1] = ACTIONS(4944),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4944),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4944),
    [sym_preproc_directive] = ACTIONS(4944),
    [anon_sym_LPAREN2] = ACTIONS(4946),
    [anon_sym_TILDE] = ACTIONS(4946),
    [anon_sym_STAR] = ACTIONS(4946),
    [anon_sym_AMP_AMP] = ACTIONS(4946),
    [anon_sym_AMP] = ACTIONS(4944),
    [anon_sym___extension__] = ACTIONS(4944),
    [anon_sym_typedef] = ACTIONS(4944),
    [anon_sym_extern] = ACTIONS(4944),
    [anon_sym___attribute__] = ACTIONS(4944),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4946),
    [anon_sym___declspec] = ACTIONS(4944),
    [anon_sym___based] = ACTIONS(4944),
    [anon_sym_signed] = ACTIONS(4944),
    [anon_sym_unsigned] = ACTIONS(4944),
    [anon_sym_long] = ACTIONS(4944),
    [anon_sym_short] = ACTIONS(4944),
    [anon_sym_LBRACK] = ACTIONS(4944),
    [anon_sym_static] = ACTIONS(4944),
    [anon_sym_register] = ACTIONS(4944),
    [anon_sym_inline] = ACTIONS(4944),
    [anon_sym___inline] = ACTIONS(4944),
    [anon_sym___inline__] = ACTIONS(4944),
    [anon_sym___forceinline] = ACTIONS(4944),
    [anon_sym_thread_local] = ACTIONS(4944),
    [anon_sym___thread] = ACTIONS(4944),
    [anon_sym_const] = ACTIONS(4944),
    [anon_sym_constexpr] = ACTIONS(4944),
    [anon_sym_volatile] = ACTIONS(4944),
    [anon_sym_restrict] = ACTIONS(4944),
    [anon_sym___restrict__] = ACTIONS(4944),
    [anon_sym__Atomic] = ACTIONS(4944),
    [anon_sym__Noreturn] = ACTIONS(4944),
    [anon_sym_noreturn] = ACTIONS(4944),
    [anon_sym_mutable] = ACTIONS(4944),
    [anon_sym_constinit] = ACTIONS(4944),
    [anon_sym_consteval] = ACTIONS(4944),
    [anon_sym_PROGMEM] = ACTIONS(4944),
    [aux_sym_primitive_type_token1] = ACTIONS(4944),
    [anon_sym_byte] = ACTIONS(4944),
    [anon_sym_word] = ACTIONS(4944),
    [anon_sym_enum] = ACTIONS(4944),
    [anon_sym_class] = ACTIONS(4944),
    [anon_sym_struct] = ACTIONS(4944),
    [anon_sym_union] = ACTIONS(4944),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4944),
    [anon_sym_decltype] = ACTIONS(4944),
    [anon_sym_virtual] = ACTIONS(4944),
    [anon_sym_alignas] = ACTIONS(4944),
    [anon_sym_explicit] = ACTIONS(4944),
    [anon_sym_typename] = ACTIONS(4944),
    [anon_sym_template] = ACTIONS(4944),
    [anon_sym_operator] = ACTIONS(4944),
    [anon_sym_friend] = ACTIONS(4944),
    [anon_sym_public] = ACTIONS(4944),
    [anon_sym_private] = ACTIONS(4944),
    [anon_sym_protected] = ACTIONS(4944),
    [anon_sym_using] = ACTIONS(4944),
    [anon_sym_static_assert] = ACTIONS(4944),
  },
  [1906] = {
    [sym_identifier] = ACTIONS(4948),
    [aux_sym_preproc_def_token1] = ACTIONS(4948),
    [aux_sym_preproc_if_token1] = ACTIONS(4948),
    [aux_sym_preproc_if_token2] = ACTIONS(4948),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4948),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4948),
    [aux_sym_preproc_else_token1] = ACTIONS(4948),
    [aux_sym_preproc_elif_token1] = ACTIONS(4948),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4948),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4948),
    [sym_preproc_directive] = ACTIONS(4948),
    [anon_sym_LPAREN2] = ACTIONS(4950),
    [anon_sym_TILDE] = ACTIONS(4950),
    [anon_sym_STAR] = ACTIONS(4950),
    [anon_sym_AMP_AMP] = ACTIONS(4950),
    [anon_sym_AMP] = ACTIONS(4948),
    [anon_sym___extension__] = ACTIONS(4948),
    [anon_sym_typedef] = ACTIONS(4948),
    [anon_sym_extern] = ACTIONS(4948),
    [anon_sym___attribute__] = ACTIONS(4948),
    [anon_sym_COLON_COLON] = ACTIONS(4950),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4950),
    [anon_sym___declspec] = ACTIONS(4948),
    [anon_sym___based] = ACTIONS(4948),
    [anon_sym_signed] = ACTIONS(4948),
    [anon_sym_unsigned] = ACTIONS(4948),
    [anon_sym_long] = ACTIONS(4948),
    [anon_sym_short] = ACTIONS(4948),
    [anon_sym_LBRACK] = ACTIONS(4948),
    [anon_sym_static] = ACTIONS(4948),
    [anon_sym_register] = ACTIONS(4948),
    [anon_sym_inline] = ACTIONS(4948),
    [anon_sym___inline] = ACTIONS(4948),
    [anon_sym___inline__] = ACTIONS(4948),
    [anon_sym___forceinline] = ACTIONS(4948),
    [anon_sym_thread_local] = ACTIONS(4948),
    [anon_sym___thread] = ACTIONS(4948),
    [anon_sym_const] = ACTIONS(4948),
    [anon_sym_constexpr] = ACTIONS(4948),
    [anon_sym_volatile] = ACTIONS(4948),
    [anon_sym_restrict] = ACTIONS(4948),
    [anon_sym___restrict__] = ACTIONS(4948),
    [anon_sym__Atomic] = ACTIONS(4948),
    [anon_sym__Noreturn] = ACTIONS(4948),
    [anon_sym_noreturn] = ACTIONS(4948),
    [anon_sym_mutable] = ACTIONS(4948),
    [anon_sym_constinit] = ACTIONS(4948),
    [anon_sym_consteval] = ACTIONS(4948),
    [anon_sym_PROGMEM] = ACTIONS(4948),
    [aux_sym_primitive_type_token1] = ACTIONS(4948),
    [anon_sym_byte] = ACTIONS(4948),
    [anon_sym_word] = ACTIONS(4948),
    [anon_sym_enum] = ACTIONS(4948),
    [anon_sym_class] = ACTIONS(4948),
    [anon_sym_struct] = ACTIONS(4948),
    [anon_sym_union] = ACTIONS(4948),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4948),
    [anon_sym_decltype] = ACTIONS(4948),
    [anon_sym_virtual] = ACTIONS(4948),
    [anon_sym_alignas] = ACTIONS(4948),
    [anon_sym_explicit] = ACTIONS(4948),
    [anon_sym_typename] = ACTIONS(4948),
    [anon_sym_template] = ACTIONS(4948),
    [anon_sym_operator] = ACTIONS(4948),
    [anon_sym_friend] = ACTIONS(4948),
    [anon_sym_public] = ACTIONS(4948),
    [anon_sym_private] = ACTIONS(4948),
    [anon_sym_protected] = ACTIONS(4948),
    [anon_sym_using] = ACTIONS(4948),
    [anon_sym_static_assert] = ACTIONS(4948),
  },
  [1907] = {
    [sym_identifier] = ACTIONS(4952),
    [aux_sym_preproc_def_token1] = ACTIONS(4952),
    [aux_sym_preproc_if_token1] = ACTIONS(4952),
    [aux_sym_preproc_if_token2] = ACTIONS(4952),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4952),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4952),
    [aux_sym_preproc_else_token1] = ACTIONS(4952),
    [aux_sym_preproc_elif_token1] = ACTIONS(4952),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4952),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4952),
    [sym_preproc_directive] = ACTIONS(4952),
    [anon_sym_LPAREN2] = ACTIONS(4954),
    [anon_sym_TILDE] = ACTIONS(4954),
    [anon_sym_STAR] = ACTIONS(4954),
    [anon_sym_AMP_AMP] = ACTIONS(4954),
    [anon_sym_AMP] = ACTIONS(4952),
    [anon_sym___extension__] = ACTIONS(4952),
    [anon_sym_typedef] = ACTIONS(4952),
    [anon_sym_extern] = ACTIONS(4952),
    [anon_sym___attribute__] = ACTIONS(4952),
    [anon_sym_COLON_COLON] = ACTIONS(4954),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4954),
    [anon_sym___declspec] = ACTIONS(4952),
    [anon_sym___based] = ACTIONS(4952),
    [anon_sym_signed] = ACTIONS(4952),
    [anon_sym_unsigned] = ACTIONS(4952),
    [anon_sym_long] = ACTIONS(4952),
    [anon_sym_short] = ACTIONS(4952),
    [anon_sym_LBRACK] = ACTIONS(4952),
    [anon_sym_static] = ACTIONS(4952),
    [anon_sym_register] = ACTIONS(4952),
    [anon_sym_inline] = ACTIONS(4952),
    [anon_sym___inline] = ACTIONS(4952),
    [anon_sym___inline__] = ACTIONS(4952),
    [anon_sym___forceinline] = ACTIONS(4952),
    [anon_sym_thread_local] = ACTIONS(4952),
    [anon_sym___thread] = ACTIONS(4952),
    [anon_sym_const] = ACTIONS(4952),
    [anon_sym_constexpr] = ACTIONS(4952),
    [anon_sym_volatile] = ACTIONS(4952),
    [anon_sym_restrict] = ACTIONS(4952),
    [anon_sym___restrict__] = ACTIONS(4952),
    [anon_sym__Atomic] = ACTIONS(4952),
    [anon_sym__Noreturn] = ACTIONS(4952),
    [anon_sym_noreturn] = ACTIONS(4952),
    [anon_sym_mutable] = ACTIONS(4952),
    [anon_sym_constinit] = ACTIONS(4952),
    [anon_sym_consteval] = ACTIONS(4952),
    [anon_sym_PROGMEM] = ACTIONS(4952),
    [aux_sym_primitive_type_token1] = ACTIONS(4952),
    [anon_sym_byte] = ACTIONS(4952),
    [anon_sym_word] = ACTIONS(4952),
    [anon_sym_enum] = ACTIONS(4952),
    [anon_sym_class] = ACTIONS(4952),
    [anon_sym_struct] = ACTIONS(4952),
    [anon_sym_union] = ACTIONS(4952),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4952),
    [anon_sym_decltype] = ACTIONS(4952),
    [anon_sym_virtual] = ACTIONS(4952),
    [anon_sym_alignas] = ACTIONS(4952),
    [anon_sym_explicit] = ACTIONS(4952),
    [anon_sym_typename] = ACTIONS(4952),
    [anon_sym_template] = ACTIONS(4952),
    [anon_sym_operator] = ACTIONS(4952),
    [anon_sym_friend] = ACTIONS(4952),
    [anon_sym_public] = ACTIONS(4952),
    [anon_sym_private] = ACTIONS(4952),
    [anon_sym_protected] = ACTIONS(4952),
    [anon_sym_using] = ACTIONS(4952),
    [anon_sym_static_assert] = ACTIONS(4952),
  },
  [1908] = {
    [sym_identifier] = ACTIONS(4956),
    [aux_sym_preproc_def_token1] = ACTIONS(4956),
    [aux_sym_preproc_if_token1] = ACTIONS(4956),
    [aux_sym_preproc_if_token2] = ACTIONS(4956),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4956),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4956),
    [aux_sym_preproc_else_token1] = ACTIONS(4956),
    [aux_sym_preproc_elif_token1] = ACTIONS(4956),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4956),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4956),
    [sym_preproc_directive] = ACTIONS(4956),
    [anon_sym_LPAREN2] = ACTIONS(4958),
    [anon_sym_TILDE] = ACTIONS(4958),
    [anon_sym_STAR] = ACTIONS(4958),
    [anon_sym_AMP_AMP] = ACTIONS(4958),
    [anon_sym_AMP] = ACTIONS(4956),
    [anon_sym___extension__] = ACTIONS(4956),
    [anon_sym_typedef] = ACTIONS(4956),
    [anon_sym_extern] = ACTIONS(4956),
    [anon_sym___attribute__] = ACTIONS(4956),
    [anon_sym_COLON_COLON] = ACTIONS(4958),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4958),
    [anon_sym___declspec] = ACTIONS(4956),
    [anon_sym___based] = ACTIONS(4956),
    [anon_sym_signed] = ACTIONS(4956),
    [anon_sym_unsigned] = ACTIONS(4956),
    [anon_sym_long] = ACTIONS(4956),
    [anon_sym_short] = ACTIONS(4956),
    [anon_sym_LBRACK] = ACTIONS(4956),
    [anon_sym_static] = ACTIONS(4956),
    [anon_sym_register] = ACTIONS(4956),
    [anon_sym_inline] = ACTIONS(4956),
    [anon_sym___inline] = ACTIONS(4956),
    [anon_sym___inline__] = ACTIONS(4956),
    [anon_sym___forceinline] = ACTIONS(4956),
    [anon_sym_thread_local] = ACTIONS(4956),
    [anon_sym___thread] = ACTIONS(4956),
    [anon_sym_const] = ACTIONS(4956),
    [anon_sym_constexpr] = ACTIONS(4956),
    [anon_sym_volatile] = ACTIONS(4956),
    [anon_sym_restrict] = ACTIONS(4956),
    [anon_sym___restrict__] = ACTIONS(4956),
    [anon_sym__Atomic] = ACTIONS(4956),
    [anon_sym__Noreturn] = ACTIONS(4956),
    [anon_sym_noreturn] = ACTIONS(4956),
    [anon_sym_mutable] = ACTIONS(4956),
    [anon_sym_constinit] = ACTIONS(4956),
    [anon_sym_consteval] = ACTIONS(4956),
    [anon_sym_PROGMEM] = ACTIONS(4956),
    [aux_sym_primitive_type_token1] = ACTIONS(4956),
    [anon_sym_byte] = ACTIONS(4956),
    [anon_sym_word] = ACTIONS(4956),
    [anon_sym_enum] = ACTIONS(4956),
    [anon_sym_class] = ACTIONS(4956),
    [anon_sym_struct] = ACTIONS(4956),
    [anon_sym_union] = ACTIONS(4956),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4956),
    [anon_sym_decltype] = ACTIONS(4956),
    [anon_sym_virtual] = ACTIONS(4956),
    [anon_sym_alignas] = ACTIONS(4956),
    [anon_sym_explicit] = ACTIONS(4956),
    [anon_sym_typename] = ACTIONS(4956),
    [anon_sym_template] = ACTIONS(4956),
    [anon_sym_operator] = ACTIONS(4956),
    [anon_sym_friend] = ACTIONS(4956),
    [anon_sym_public] = ACTIONS(4956),
    [anon_sym_private] = ACTIONS(4956),
    [anon_sym_protected] = ACTIONS(4956),
    [anon_sym_using] = ACTIONS(4956),
    [anon_sym_static_assert] = ACTIONS(4956),
  },
  [1909] = {
    [sym_identifier] = ACTIONS(4960),
    [aux_sym_preproc_def_token1] = ACTIONS(4960),
    [aux_sym_preproc_if_token1] = ACTIONS(4960),
    [aux_sym_preproc_if_token2] = ACTIONS(4960),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4960),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4960),
    [aux_sym_preproc_else_token1] = ACTIONS(4960),
    [aux_sym_preproc_elif_token1] = ACTIONS(4960),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4960),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4960),
    [sym_preproc_directive] = ACTIONS(4960),
    [anon_sym_LPAREN2] = ACTIONS(4962),
    [anon_sym_TILDE] = ACTIONS(4962),
    [anon_sym_STAR] = ACTIONS(4962),
    [anon_sym_AMP_AMP] = ACTIONS(4962),
    [anon_sym_AMP] = ACTIONS(4960),
    [anon_sym___extension__] = ACTIONS(4960),
    [anon_sym_typedef] = ACTIONS(4960),
    [anon_sym_extern] = ACTIONS(4960),
    [anon_sym___attribute__] = ACTIONS(4960),
    [anon_sym_COLON_COLON] = ACTIONS(4962),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4962),
    [anon_sym___declspec] = ACTIONS(4960),
    [anon_sym___based] = ACTIONS(4960),
    [anon_sym_signed] = ACTIONS(4960),
    [anon_sym_unsigned] = ACTIONS(4960),
    [anon_sym_long] = ACTIONS(4960),
    [anon_sym_short] = ACTIONS(4960),
    [anon_sym_LBRACK] = ACTIONS(4960),
    [anon_sym_static] = ACTIONS(4960),
    [anon_sym_register] = ACTIONS(4960),
    [anon_sym_inline] = ACTIONS(4960),
    [anon_sym___inline] = ACTIONS(4960),
    [anon_sym___inline__] = ACTIONS(4960),
    [anon_sym___forceinline] = ACTIONS(4960),
    [anon_sym_thread_local] = ACTIONS(4960),
    [anon_sym___thread] = ACTIONS(4960),
    [anon_sym_const] = ACTIONS(4960),
    [anon_sym_constexpr] = ACTIONS(4960),
    [anon_sym_volatile] = ACTIONS(4960),
    [anon_sym_restrict] = ACTIONS(4960),
    [anon_sym___restrict__] = ACTIONS(4960),
    [anon_sym__Atomic] = ACTIONS(4960),
    [anon_sym__Noreturn] = ACTIONS(4960),
    [anon_sym_noreturn] = ACTIONS(4960),
    [anon_sym_mutable] = ACTIONS(4960),
    [anon_sym_constinit] = ACTIONS(4960),
    [anon_sym_consteval] = ACTIONS(4960),
    [anon_sym_PROGMEM] = ACTIONS(4960),
    [aux_sym_primitive_type_token1] = ACTIONS(4960),
    [anon_sym_byte] = ACTIONS(4960),
    [anon_sym_word] = ACTIONS(4960),
    [anon_sym_enum] = ACTIONS(4960),
    [anon_sym_class] = ACTIONS(4960),
    [anon_sym_struct] = ACTIONS(4960),
    [anon_sym_union] = ACTIONS(4960),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4960),
    [anon_sym_decltype] = ACTIONS(4960),
    [anon_sym_virtual] = ACTIONS(4960),
    [anon_sym_alignas] = ACTIONS(4960),
    [anon_sym_explicit] = ACTIONS(4960),
    [anon_sym_typename] = ACTIONS(4960),
    [anon_sym_template] = ACTIONS(4960),
    [anon_sym_operator] = ACTIONS(4960),
    [anon_sym_friend] = ACTIONS(4960),
    [anon_sym_public] = ACTIONS(4960),
    [anon_sym_private] = ACTIONS(4960),
    [anon_sym_protected] = ACTIONS(4960),
    [anon_sym_using] = ACTIONS(4960),
    [anon_sym_static_assert] = ACTIONS(4960),
  },
  [1910] = {
    [sym_identifier] = ACTIONS(4956),
    [aux_sym_preproc_def_token1] = ACTIONS(4956),
    [aux_sym_preproc_if_token1] = ACTIONS(4956),
    [aux_sym_preproc_if_token2] = ACTIONS(4956),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4956),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4956),
    [aux_sym_preproc_else_token1] = ACTIONS(4956),
    [aux_sym_preproc_elif_token1] = ACTIONS(4956),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4956),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4956),
    [sym_preproc_directive] = ACTIONS(4956),
    [anon_sym_LPAREN2] = ACTIONS(4958),
    [anon_sym_TILDE] = ACTIONS(4958),
    [anon_sym_STAR] = ACTIONS(4958),
    [anon_sym_AMP_AMP] = ACTIONS(4958),
    [anon_sym_AMP] = ACTIONS(4956),
    [anon_sym___extension__] = ACTIONS(4956),
    [anon_sym_typedef] = ACTIONS(4956),
    [anon_sym_extern] = ACTIONS(4956),
    [anon_sym___attribute__] = ACTIONS(4956),
    [anon_sym_COLON_COLON] = ACTIONS(4958),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4958),
    [anon_sym___declspec] = ACTIONS(4956),
    [anon_sym___based] = ACTIONS(4956),
    [anon_sym_signed] = ACTIONS(4956),
    [anon_sym_unsigned] = ACTIONS(4956),
    [anon_sym_long] = ACTIONS(4956),
    [anon_sym_short] = ACTIONS(4956),
    [anon_sym_LBRACK] = ACTIONS(4956),
    [anon_sym_static] = ACTIONS(4956),
    [anon_sym_register] = ACTIONS(4956),
    [anon_sym_inline] = ACTIONS(4956),
    [anon_sym___inline] = ACTIONS(4956),
    [anon_sym___inline__] = ACTIONS(4956),
    [anon_sym___forceinline] = ACTIONS(4956),
    [anon_sym_thread_local] = ACTIONS(4956),
    [anon_sym___thread] = ACTIONS(4956),
    [anon_sym_const] = ACTIONS(4956),
    [anon_sym_constexpr] = ACTIONS(4956),
    [anon_sym_volatile] = ACTIONS(4956),
    [anon_sym_restrict] = ACTIONS(4956),
    [anon_sym___restrict__] = ACTIONS(4956),
    [anon_sym__Atomic] = ACTIONS(4956),
    [anon_sym__Noreturn] = ACTIONS(4956),
    [anon_sym_noreturn] = ACTIONS(4956),
    [anon_sym_mutable] = ACTIONS(4956),
    [anon_sym_constinit] = ACTIONS(4956),
    [anon_sym_consteval] = ACTIONS(4956),
    [anon_sym_PROGMEM] = ACTIONS(4956),
    [aux_sym_primitive_type_token1] = ACTIONS(4956),
    [anon_sym_byte] = ACTIONS(4956),
    [anon_sym_word] = ACTIONS(4956),
    [anon_sym_enum] = ACTIONS(4956),
    [anon_sym_class] = ACTIONS(4956),
    [anon_sym_struct] = ACTIONS(4956),
    [anon_sym_union] = ACTIONS(4956),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4956),
    [anon_sym_decltype] = ACTIONS(4956),
    [anon_sym_virtual] = ACTIONS(4956),
    [anon_sym_alignas] = ACTIONS(4956),
    [anon_sym_explicit] = ACTIONS(4956),
    [anon_sym_typename] = ACTIONS(4956),
    [anon_sym_template] = ACTIONS(4956),
    [anon_sym_operator] = ACTIONS(4956),
    [anon_sym_friend] = ACTIONS(4956),
    [anon_sym_public] = ACTIONS(4956),
    [anon_sym_private] = ACTIONS(4956),
    [anon_sym_protected] = ACTIONS(4956),
    [anon_sym_using] = ACTIONS(4956),
    [anon_sym_static_assert] = ACTIONS(4956),
  },
  [1911] = {
    [sym_identifier] = ACTIONS(4960),
    [aux_sym_preproc_def_token1] = ACTIONS(4960),
    [aux_sym_preproc_if_token1] = ACTIONS(4960),
    [aux_sym_preproc_if_token2] = ACTIONS(4960),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4960),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4960),
    [aux_sym_preproc_else_token1] = ACTIONS(4960),
    [aux_sym_preproc_elif_token1] = ACTIONS(4960),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4960),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4960),
    [sym_preproc_directive] = ACTIONS(4960),
    [anon_sym_LPAREN2] = ACTIONS(4962),
    [anon_sym_TILDE] = ACTIONS(4962),
    [anon_sym_STAR] = ACTIONS(4962),
    [anon_sym_AMP_AMP] = ACTIONS(4962),
    [anon_sym_AMP] = ACTIONS(4960),
    [anon_sym___extension__] = ACTIONS(4960),
    [anon_sym_typedef] = ACTIONS(4960),
    [anon_sym_extern] = ACTIONS(4960),
    [anon_sym___attribute__] = ACTIONS(4960),
    [anon_sym_COLON_COLON] = ACTIONS(4962),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4962),
    [anon_sym___declspec] = ACTIONS(4960),
    [anon_sym___based] = ACTIONS(4960),
    [anon_sym_signed] = ACTIONS(4960),
    [anon_sym_unsigned] = ACTIONS(4960),
    [anon_sym_long] = ACTIONS(4960),
    [anon_sym_short] = ACTIONS(4960),
    [anon_sym_LBRACK] = ACTIONS(4960),
    [anon_sym_static] = ACTIONS(4960),
    [anon_sym_register] = ACTIONS(4960),
    [anon_sym_inline] = ACTIONS(4960),
    [anon_sym___inline] = ACTIONS(4960),
    [anon_sym___inline__] = ACTIONS(4960),
    [anon_sym___forceinline] = ACTIONS(4960),
    [anon_sym_thread_local] = ACTIONS(4960),
    [anon_sym___thread] = ACTIONS(4960),
    [anon_sym_const] = ACTIONS(4960),
    [anon_sym_constexpr] = ACTIONS(4960),
    [anon_sym_volatile] = ACTIONS(4960),
    [anon_sym_restrict] = ACTIONS(4960),
    [anon_sym___restrict__] = ACTIONS(4960),
    [anon_sym__Atomic] = ACTIONS(4960),
    [anon_sym__Noreturn] = ACTIONS(4960),
    [anon_sym_noreturn] = ACTIONS(4960),
    [anon_sym_mutable] = ACTIONS(4960),
    [anon_sym_constinit] = ACTIONS(4960),
    [anon_sym_consteval] = ACTIONS(4960),
    [anon_sym_PROGMEM] = ACTIONS(4960),
    [aux_sym_primitive_type_token1] = ACTIONS(4960),
    [anon_sym_byte] = ACTIONS(4960),
    [anon_sym_word] = ACTIONS(4960),
    [anon_sym_enum] = ACTIONS(4960),
    [anon_sym_class] = ACTIONS(4960),
    [anon_sym_struct] = ACTIONS(4960),
    [anon_sym_union] = ACTIONS(4960),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4960),
    [anon_sym_decltype] = ACTIONS(4960),
    [anon_sym_virtual] = ACTIONS(4960),
    [anon_sym_alignas] = ACTIONS(4960),
    [anon_sym_explicit] = ACTIONS(4960),
    [anon_sym_typename] = ACTIONS(4960),
    [anon_sym_template] = ACTIONS(4960),
    [anon_sym_operator] = ACTIONS(4960),
    [anon_sym_friend] = ACTIONS(4960),
    [anon_sym_public] = ACTIONS(4960),
    [anon_sym_private] = ACTIONS(4960),
    [anon_sym_protected] = ACTIONS(4960),
    [anon_sym_using] = ACTIONS(4960),
    [anon_sym_static_assert] = ACTIONS(4960),
  },
  [1912] = {
    [sym_identifier] = ACTIONS(4964),
    [aux_sym_preproc_def_token1] = ACTIONS(4964),
    [aux_sym_preproc_if_token1] = ACTIONS(4964),
    [aux_sym_preproc_if_token2] = ACTIONS(4964),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4964),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4964),
    [aux_sym_preproc_else_token1] = ACTIONS(4964),
    [aux_sym_preproc_elif_token1] = ACTIONS(4964),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4964),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4964),
    [sym_preproc_directive] = ACTIONS(4964),
    [anon_sym_LPAREN2] = ACTIONS(4966),
    [anon_sym_TILDE] = ACTIONS(4966),
    [anon_sym_STAR] = ACTIONS(4966),
    [anon_sym_AMP_AMP] = ACTIONS(4966),
    [anon_sym_AMP] = ACTIONS(4964),
    [anon_sym___extension__] = ACTIONS(4964),
    [anon_sym_typedef] = ACTIONS(4964),
    [anon_sym_extern] = ACTIONS(4964),
    [anon_sym___attribute__] = ACTIONS(4964),
    [anon_sym_COLON_COLON] = ACTIONS(4966),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4966),
    [anon_sym___declspec] = ACTIONS(4964),
    [anon_sym___based] = ACTIONS(4964),
    [anon_sym_signed] = ACTIONS(4964),
    [anon_sym_unsigned] = ACTIONS(4964),
    [anon_sym_long] = ACTIONS(4964),
    [anon_sym_short] = ACTIONS(4964),
    [anon_sym_LBRACK] = ACTIONS(4964),
    [anon_sym_static] = ACTIONS(4964),
    [anon_sym_register] = ACTIONS(4964),
    [anon_sym_inline] = ACTIONS(4964),
    [anon_sym___inline] = ACTIONS(4964),
    [anon_sym___inline__] = ACTIONS(4964),
    [anon_sym___forceinline] = ACTIONS(4964),
    [anon_sym_thread_local] = ACTIONS(4964),
    [anon_sym___thread] = ACTIONS(4964),
    [anon_sym_const] = ACTIONS(4964),
    [anon_sym_constexpr] = ACTIONS(4964),
    [anon_sym_volatile] = ACTIONS(4964),
    [anon_sym_restrict] = ACTIONS(4964),
    [anon_sym___restrict__] = ACTIONS(4964),
    [anon_sym__Atomic] = ACTIONS(4964),
    [anon_sym__Noreturn] = ACTIONS(4964),
    [anon_sym_noreturn] = ACTIONS(4964),
    [anon_sym_mutable] = ACTIONS(4964),
    [anon_sym_constinit] = ACTIONS(4964),
    [anon_sym_consteval] = ACTIONS(4964),
    [anon_sym_PROGMEM] = ACTIONS(4964),
    [aux_sym_primitive_type_token1] = ACTIONS(4964),
    [anon_sym_byte] = ACTIONS(4964),
    [anon_sym_word] = ACTIONS(4964),
    [anon_sym_enum] = ACTIONS(4964),
    [anon_sym_class] = ACTIONS(4964),
    [anon_sym_struct] = ACTIONS(4964),
    [anon_sym_union] = ACTIONS(4964),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4964),
    [anon_sym_decltype] = ACTIONS(4964),
    [anon_sym_virtual] = ACTIONS(4964),
    [anon_sym_alignas] = ACTIONS(4964),
    [anon_sym_explicit] = ACTIONS(4964),
    [anon_sym_typename] = ACTIONS(4964),
    [anon_sym_template] = ACTIONS(4964),
    [anon_sym_operator] = ACTIONS(4964),
    [anon_sym_friend] = ACTIONS(4964),
    [anon_sym_public] = ACTIONS(4964),
    [anon_sym_private] = ACTIONS(4964),
    [anon_sym_protected] = ACTIONS(4964),
    [anon_sym_using] = ACTIONS(4964),
    [anon_sym_static_assert] = ACTIONS(4964),
  },
  [1913] = {
    [sym_identifier] = ACTIONS(4551),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4553),
    [anon_sym_COMMA] = ACTIONS(4553),
    [anon_sym_RPAREN] = ACTIONS(4553),
    [anon_sym_LPAREN2] = ACTIONS(4553),
    [anon_sym_DASH] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(4551),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_SLASH] = ACTIONS(4551),
    [anon_sym_PERCENT] = ACTIONS(4553),
    [anon_sym_PIPE_PIPE] = ACTIONS(4553),
    [anon_sym_AMP_AMP] = ACTIONS(4553),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4553),
    [anon_sym_AMP] = ACTIONS(4551),
    [anon_sym_EQ_EQ] = ACTIONS(4553),
    [anon_sym_BANG_EQ] = ACTIONS(4553),
    [anon_sym_GT] = ACTIONS(4551),
    [anon_sym_GT_EQ] = ACTIONS(4553),
    [anon_sym_LT_EQ] = ACTIONS(4551),
    [anon_sym_LT] = ACTIONS(4551),
    [anon_sym_LT_LT] = ACTIONS(4553),
    [anon_sym_GT_GT] = ACTIONS(4553),
    [anon_sym_SEMI] = ACTIONS(4553),
    [anon_sym___extension__] = ACTIONS(4551),
    [anon_sym___attribute__] = ACTIONS(4551),
    [anon_sym_COLON_COLON] = ACTIONS(4553),
    [anon_sym___based] = ACTIONS(4551),
    [anon_sym_LBRACE] = ACTIONS(4553),
    [anon_sym_RBRACE] = ACTIONS(4553),
    [anon_sym_signed] = ACTIONS(4551),
    [anon_sym_unsigned] = ACTIONS(4551),
    [anon_sym_long] = ACTIONS(4551),
    [anon_sym_short] = ACTIONS(4551),
    [anon_sym_LBRACK] = ACTIONS(4553),
    [anon_sym_RBRACK] = ACTIONS(4553),
    [anon_sym_const] = ACTIONS(4551),
    [anon_sym_constexpr] = ACTIONS(4551),
    [anon_sym_volatile] = ACTIONS(4551),
    [anon_sym_restrict] = ACTIONS(4551),
    [anon_sym___restrict__] = ACTIONS(4551),
    [anon_sym__Atomic] = ACTIONS(4551),
    [anon_sym__Noreturn] = ACTIONS(4551),
    [anon_sym_noreturn] = ACTIONS(4551),
    [anon_sym_mutable] = ACTIONS(4551),
    [anon_sym_constinit] = ACTIONS(4551),
    [anon_sym_consteval] = ACTIONS(4551),
    [anon_sym_PROGMEM] = ACTIONS(4551),
    [aux_sym_primitive_type_token1] = ACTIONS(4551),
    [anon_sym_byte] = ACTIONS(4551),
    [anon_sym_word] = ACTIONS(4551),
    [anon_sym_COLON] = ACTIONS(4551),
    [anon_sym_QMARK] = ACTIONS(4553),
    [anon_sym_LT_EQ_GT] = ACTIONS(4553),
    [anon_sym_or] = ACTIONS(4551),
    [anon_sym_and] = ACTIONS(4551),
    [anon_sym_bitor] = ACTIONS(4551),
    [anon_sym_xor] = ACTIONS(4551),
    [anon_sym_bitand] = ACTIONS(4551),
    [anon_sym_not_eq] = ACTIONS(4551),
    [anon_sym_DASH_DASH] = ACTIONS(4553),
    [anon_sym_PLUS_PLUS] = ACTIONS(4553),
    [anon_sym_DOT] = ACTIONS(4551),
    [anon_sym_DOT_STAR] = ACTIONS(4553),
    [anon_sym_DASH_GT] = ACTIONS(4553),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4551),
    [anon_sym_decltype] = ACTIONS(4551),
    [anon_sym_final] = ACTIONS(4551),
    [anon_sym_override] = ACTIONS(4551),
    [anon_sym_requires] = ACTIONS(4551),
  },
  [1914] = {
    [sym_identifier] = ACTIONS(4968),
    [aux_sym_preproc_def_token1] = ACTIONS(4968),
    [aux_sym_preproc_if_token1] = ACTIONS(4968),
    [aux_sym_preproc_if_token2] = ACTIONS(4968),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4968),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4968),
    [aux_sym_preproc_else_token1] = ACTIONS(4968),
    [aux_sym_preproc_elif_token1] = ACTIONS(4968),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4968),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4968),
    [sym_preproc_directive] = ACTIONS(4968),
    [anon_sym_LPAREN2] = ACTIONS(4970),
    [anon_sym_TILDE] = ACTIONS(4970),
    [anon_sym_STAR] = ACTIONS(4970),
    [anon_sym_AMP_AMP] = ACTIONS(4970),
    [anon_sym_AMP] = ACTIONS(4968),
    [anon_sym___extension__] = ACTIONS(4968),
    [anon_sym_typedef] = ACTIONS(4968),
    [anon_sym_extern] = ACTIONS(4968),
    [anon_sym___attribute__] = ACTIONS(4968),
    [anon_sym_COLON_COLON] = ACTIONS(4970),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4970),
    [anon_sym___declspec] = ACTIONS(4968),
    [anon_sym___based] = ACTIONS(4968),
    [anon_sym_signed] = ACTIONS(4968),
    [anon_sym_unsigned] = ACTIONS(4968),
    [anon_sym_long] = ACTIONS(4968),
    [anon_sym_short] = ACTIONS(4968),
    [anon_sym_LBRACK] = ACTIONS(4968),
    [anon_sym_static] = ACTIONS(4968),
    [anon_sym_register] = ACTIONS(4968),
    [anon_sym_inline] = ACTIONS(4968),
    [anon_sym___inline] = ACTIONS(4968),
    [anon_sym___inline__] = ACTIONS(4968),
    [anon_sym___forceinline] = ACTIONS(4968),
    [anon_sym_thread_local] = ACTIONS(4968),
    [anon_sym___thread] = ACTIONS(4968),
    [anon_sym_const] = ACTIONS(4968),
    [anon_sym_constexpr] = ACTIONS(4968),
    [anon_sym_volatile] = ACTIONS(4968),
    [anon_sym_restrict] = ACTIONS(4968),
    [anon_sym___restrict__] = ACTIONS(4968),
    [anon_sym__Atomic] = ACTIONS(4968),
    [anon_sym__Noreturn] = ACTIONS(4968),
    [anon_sym_noreturn] = ACTIONS(4968),
    [anon_sym_mutable] = ACTIONS(4968),
    [anon_sym_constinit] = ACTIONS(4968),
    [anon_sym_consteval] = ACTIONS(4968),
    [anon_sym_PROGMEM] = ACTIONS(4968),
    [aux_sym_primitive_type_token1] = ACTIONS(4968),
    [anon_sym_byte] = ACTIONS(4968),
    [anon_sym_word] = ACTIONS(4968),
    [anon_sym_enum] = ACTIONS(4968),
    [anon_sym_class] = ACTIONS(4968),
    [anon_sym_struct] = ACTIONS(4968),
    [anon_sym_union] = ACTIONS(4968),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4968),
    [anon_sym_decltype] = ACTIONS(4968),
    [anon_sym_virtual] = ACTIONS(4968),
    [anon_sym_alignas] = ACTIONS(4968),
    [anon_sym_explicit] = ACTIONS(4968),
    [anon_sym_typename] = ACTIONS(4968),
    [anon_sym_template] = ACTIONS(4968),
    [anon_sym_operator] = ACTIONS(4968),
    [anon_sym_friend] = ACTIONS(4968),
    [anon_sym_public] = ACTIONS(4968),
    [anon_sym_private] = ACTIONS(4968),
    [anon_sym_protected] = ACTIONS(4968),
    [anon_sym_using] = ACTIONS(4968),
    [anon_sym_static_assert] = ACTIONS(4968),
  },
  [1915] = {
    [sym_identifier] = ACTIONS(4972),
    [aux_sym_preproc_def_token1] = ACTIONS(4972),
    [aux_sym_preproc_if_token1] = ACTIONS(4972),
    [aux_sym_preproc_if_token2] = ACTIONS(4972),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4972),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4972),
    [aux_sym_preproc_else_token1] = ACTIONS(4972),
    [aux_sym_preproc_elif_token1] = ACTIONS(4972),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4972),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4972),
    [sym_preproc_directive] = ACTIONS(4972),
    [anon_sym_LPAREN2] = ACTIONS(4974),
    [anon_sym_TILDE] = ACTIONS(4974),
    [anon_sym_STAR] = ACTIONS(4974),
    [anon_sym_AMP_AMP] = ACTIONS(4974),
    [anon_sym_AMP] = ACTIONS(4972),
    [anon_sym___extension__] = ACTIONS(4972),
    [anon_sym_typedef] = ACTIONS(4972),
    [anon_sym_extern] = ACTIONS(4972),
    [anon_sym___attribute__] = ACTIONS(4972),
    [anon_sym_COLON_COLON] = ACTIONS(4974),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4974),
    [anon_sym___declspec] = ACTIONS(4972),
    [anon_sym___based] = ACTIONS(4972),
    [anon_sym_signed] = ACTIONS(4972),
    [anon_sym_unsigned] = ACTIONS(4972),
    [anon_sym_long] = ACTIONS(4972),
    [anon_sym_short] = ACTIONS(4972),
    [anon_sym_LBRACK] = ACTIONS(4972),
    [anon_sym_static] = ACTIONS(4972),
    [anon_sym_register] = ACTIONS(4972),
    [anon_sym_inline] = ACTIONS(4972),
    [anon_sym___inline] = ACTIONS(4972),
    [anon_sym___inline__] = ACTIONS(4972),
    [anon_sym___forceinline] = ACTIONS(4972),
    [anon_sym_thread_local] = ACTIONS(4972),
    [anon_sym___thread] = ACTIONS(4972),
    [anon_sym_const] = ACTIONS(4972),
    [anon_sym_constexpr] = ACTIONS(4972),
    [anon_sym_volatile] = ACTIONS(4972),
    [anon_sym_restrict] = ACTIONS(4972),
    [anon_sym___restrict__] = ACTIONS(4972),
    [anon_sym__Atomic] = ACTIONS(4972),
    [anon_sym__Noreturn] = ACTIONS(4972),
    [anon_sym_noreturn] = ACTIONS(4972),
    [anon_sym_mutable] = ACTIONS(4972),
    [anon_sym_constinit] = ACTIONS(4972),
    [anon_sym_consteval] = ACTIONS(4972),
    [anon_sym_PROGMEM] = ACTIONS(4972),
    [aux_sym_primitive_type_token1] = ACTIONS(4972),
    [anon_sym_byte] = ACTIONS(4972),
    [anon_sym_word] = ACTIONS(4972),
    [anon_sym_enum] = ACTIONS(4972),
    [anon_sym_class] = ACTIONS(4972),
    [anon_sym_struct] = ACTIONS(4972),
    [anon_sym_union] = ACTIONS(4972),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4972),
    [anon_sym_decltype] = ACTIONS(4972),
    [anon_sym_virtual] = ACTIONS(4972),
    [anon_sym_alignas] = ACTIONS(4972),
    [anon_sym_explicit] = ACTIONS(4972),
    [anon_sym_typename] = ACTIONS(4972),
    [anon_sym_template] = ACTIONS(4972),
    [anon_sym_operator] = ACTIONS(4972),
    [anon_sym_friend] = ACTIONS(4972),
    [anon_sym_public] = ACTIONS(4972),
    [anon_sym_private] = ACTIONS(4972),
    [anon_sym_protected] = ACTIONS(4972),
    [anon_sym_using] = ACTIONS(4972),
    [anon_sym_static_assert] = ACTIONS(4972),
  },
  [1916] = {
    [sym_identifier] = ACTIONS(4976),
    [aux_sym_preproc_def_token1] = ACTIONS(4976),
    [aux_sym_preproc_if_token1] = ACTIONS(4976),
    [aux_sym_preproc_if_token2] = ACTIONS(4976),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4976),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4976),
    [aux_sym_preproc_else_token1] = ACTIONS(4976),
    [aux_sym_preproc_elif_token1] = ACTIONS(4976),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4976),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4976),
    [sym_preproc_directive] = ACTIONS(4976),
    [anon_sym_LPAREN2] = ACTIONS(4978),
    [anon_sym_TILDE] = ACTIONS(4978),
    [anon_sym_STAR] = ACTIONS(4978),
    [anon_sym_AMP_AMP] = ACTIONS(4978),
    [anon_sym_AMP] = ACTIONS(4976),
    [anon_sym___extension__] = ACTIONS(4976),
    [anon_sym_typedef] = ACTIONS(4976),
    [anon_sym_extern] = ACTIONS(4976),
    [anon_sym___attribute__] = ACTIONS(4976),
    [anon_sym_COLON_COLON] = ACTIONS(4978),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4978),
    [anon_sym___declspec] = ACTIONS(4976),
    [anon_sym___based] = ACTIONS(4976),
    [anon_sym_signed] = ACTIONS(4976),
    [anon_sym_unsigned] = ACTIONS(4976),
    [anon_sym_long] = ACTIONS(4976),
    [anon_sym_short] = ACTIONS(4976),
    [anon_sym_LBRACK] = ACTIONS(4976),
    [anon_sym_static] = ACTIONS(4976),
    [anon_sym_register] = ACTIONS(4976),
    [anon_sym_inline] = ACTIONS(4976),
    [anon_sym___inline] = ACTIONS(4976),
    [anon_sym___inline__] = ACTIONS(4976),
    [anon_sym___forceinline] = ACTIONS(4976),
    [anon_sym_thread_local] = ACTIONS(4976),
    [anon_sym___thread] = ACTIONS(4976),
    [anon_sym_const] = ACTIONS(4976),
    [anon_sym_constexpr] = ACTIONS(4976),
    [anon_sym_volatile] = ACTIONS(4976),
    [anon_sym_restrict] = ACTIONS(4976),
    [anon_sym___restrict__] = ACTIONS(4976),
    [anon_sym__Atomic] = ACTIONS(4976),
    [anon_sym__Noreturn] = ACTIONS(4976),
    [anon_sym_noreturn] = ACTIONS(4976),
    [anon_sym_mutable] = ACTIONS(4976),
    [anon_sym_constinit] = ACTIONS(4976),
    [anon_sym_consteval] = ACTIONS(4976),
    [anon_sym_PROGMEM] = ACTIONS(4976),
    [aux_sym_primitive_type_token1] = ACTIONS(4976),
    [anon_sym_byte] = ACTIONS(4976),
    [anon_sym_word] = ACTIONS(4976),
    [anon_sym_enum] = ACTIONS(4976),
    [anon_sym_class] = ACTIONS(4976),
    [anon_sym_struct] = ACTIONS(4976),
    [anon_sym_union] = ACTIONS(4976),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4976),
    [anon_sym_decltype] = ACTIONS(4976),
    [anon_sym_virtual] = ACTIONS(4976),
    [anon_sym_alignas] = ACTIONS(4976),
    [anon_sym_explicit] = ACTIONS(4976),
    [anon_sym_typename] = ACTIONS(4976),
    [anon_sym_template] = ACTIONS(4976),
    [anon_sym_operator] = ACTIONS(4976),
    [anon_sym_friend] = ACTIONS(4976),
    [anon_sym_public] = ACTIONS(4976),
    [anon_sym_private] = ACTIONS(4976),
    [anon_sym_protected] = ACTIONS(4976),
    [anon_sym_using] = ACTIONS(4976),
    [anon_sym_static_assert] = ACTIONS(4976),
  },
  [1917] = {
    [sym_identifier] = ACTIONS(4980),
    [aux_sym_preproc_def_token1] = ACTIONS(4980),
    [aux_sym_preproc_if_token1] = ACTIONS(4980),
    [aux_sym_preproc_if_token2] = ACTIONS(4980),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4980),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4980),
    [aux_sym_preproc_else_token1] = ACTIONS(4980),
    [aux_sym_preproc_elif_token1] = ACTIONS(4980),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4980),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4980),
    [sym_preproc_directive] = ACTIONS(4980),
    [anon_sym_LPAREN2] = ACTIONS(4982),
    [anon_sym_TILDE] = ACTIONS(4982),
    [anon_sym_STAR] = ACTIONS(4982),
    [anon_sym_AMP_AMP] = ACTIONS(4982),
    [anon_sym_AMP] = ACTIONS(4980),
    [anon_sym___extension__] = ACTIONS(4980),
    [anon_sym_typedef] = ACTIONS(4980),
    [anon_sym_extern] = ACTIONS(4980),
    [anon_sym___attribute__] = ACTIONS(4980),
    [anon_sym_COLON_COLON] = ACTIONS(4982),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4982),
    [anon_sym___declspec] = ACTIONS(4980),
    [anon_sym___based] = ACTIONS(4980),
    [anon_sym_signed] = ACTIONS(4980),
    [anon_sym_unsigned] = ACTIONS(4980),
    [anon_sym_long] = ACTIONS(4980),
    [anon_sym_short] = ACTIONS(4980),
    [anon_sym_LBRACK] = ACTIONS(4980),
    [anon_sym_static] = ACTIONS(4980),
    [anon_sym_register] = ACTIONS(4980),
    [anon_sym_inline] = ACTIONS(4980),
    [anon_sym___inline] = ACTIONS(4980),
    [anon_sym___inline__] = ACTIONS(4980),
    [anon_sym___forceinline] = ACTIONS(4980),
    [anon_sym_thread_local] = ACTIONS(4980),
    [anon_sym___thread] = ACTIONS(4980),
    [anon_sym_const] = ACTIONS(4980),
    [anon_sym_constexpr] = ACTIONS(4980),
    [anon_sym_volatile] = ACTIONS(4980),
    [anon_sym_restrict] = ACTIONS(4980),
    [anon_sym___restrict__] = ACTIONS(4980),
    [anon_sym__Atomic] = ACTIONS(4980),
    [anon_sym__Noreturn] = ACTIONS(4980),
    [anon_sym_noreturn] = ACTIONS(4980),
    [anon_sym_mutable] = ACTIONS(4980),
    [anon_sym_constinit] = ACTIONS(4980),
    [anon_sym_consteval] = ACTIONS(4980),
    [anon_sym_PROGMEM] = ACTIONS(4980),
    [aux_sym_primitive_type_token1] = ACTIONS(4980),
    [anon_sym_byte] = ACTIONS(4980),
    [anon_sym_word] = ACTIONS(4980),
    [anon_sym_enum] = ACTIONS(4980),
    [anon_sym_class] = ACTIONS(4980),
    [anon_sym_struct] = ACTIONS(4980),
    [anon_sym_union] = ACTIONS(4980),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4980),
    [anon_sym_decltype] = ACTIONS(4980),
    [anon_sym_virtual] = ACTIONS(4980),
    [anon_sym_alignas] = ACTIONS(4980),
    [anon_sym_explicit] = ACTIONS(4980),
    [anon_sym_typename] = ACTIONS(4980),
    [anon_sym_template] = ACTIONS(4980),
    [anon_sym_operator] = ACTIONS(4980),
    [anon_sym_friend] = ACTIONS(4980),
    [anon_sym_public] = ACTIONS(4980),
    [anon_sym_private] = ACTIONS(4980),
    [anon_sym_protected] = ACTIONS(4980),
    [anon_sym_using] = ACTIONS(4980),
    [anon_sym_static_assert] = ACTIONS(4980),
  },
  [1918] = {
    [sym_identifier] = ACTIONS(4984),
    [aux_sym_preproc_def_token1] = ACTIONS(4984),
    [aux_sym_preproc_if_token1] = ACTIONS(4984),
    [aux_sym_preproc_if_token2] = ACTIONS(4984),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4984),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4984),
    [aux_sym_preproc_else_token1] = ACTIONS(4984),
    [aux_sym_preproc_elif_token1] = ACTIONS(4984),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4984),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4984),
    [sym_preproc_directive] = ACTIONS(4984),
    [anon_sym_LPAREN2] = ACTIONS(4986),
    [anon_sym_TILDE] = ACTIONS(4986),
    [anon_sym_STAR] = ACTIONS(4986),
    [anon_sym_AMP_AMP] = ACTIONS(4986),
    [anon_sym_AMP] = ACTIONS(4984),
    [anon_sym___extension__] = ACTIONS(4984),
    [anon_sym_typedef] = ACTIONS(4984),
    [anon_sym_extern] = ACTIONS(4984),
    [anon_sym___attribute__] = ACTIONS(4984),
    [anon_sym_COLON_COLON] = ACTIONS(4986),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4986),
    [anon_sym___declspec] = ACTIONS(4984),
    [anon_sym___based] = ACTIONS(4984),
    [anon_sym_signed] = ACTIONS(4984),
    [anon_sym_unsigned] = ACTIONS(4984),
    [anon_sym_long] = ACTIONS(4984),
    [anon_sym_short] = ACTIONS(4984),
    [anon_sym_LBRACK] = ACTIONS(4984),
    [anon_sym_static] = ACTIONS(4984),
    [anon_sym_register] = ACTIONS(4984),
    [anon_sym_inline] = ACTIONS(4984),
    [anon_sym___inline] = ACTIONS(4984),
    [anon_sym___inline__] = ACTIONS(4984),
    [anon_sym___forceinline] = ACTIONS(4984),
    [anon_sym_thread_local] = ACTIONS(4984),
    [anon_sym___thread] = ACTIONS(4984),
    [anon_sym_const] = ACTIONS(4984),
    [anon_sym_constexpr] = ACTIONS(4984),
    [anon_sym_volatile] = ACTIONS(4984),
    [anon_sym_restrict] = ACTIONS(4984),
    [anon_sym___restrict__] = ACTIONS(4984),
    [anon_sym__Atomic] = ACTIONS(4984),
    [anon_sym__Noreturn] = ACTIONS(4984),
    [anon_sym_noreturn] = ACTIONS(4984),
    [anon_sym_mutable] = ACTIONS(4984),
    [anon_sym_constinit] = ACTIONS(4984),
    [anon_sym_consteval] = ACTIONS(4984),
    [anon_sym_PROGMEM] = ACTIONS(4984),
    [aux_sym_primitive_type_token1] = ACTIONS(4984),
    [anon_sym_byte] = ACTIONS(4984),
    [anon_sym_word] = ACTIONS(4984),
    [anon_sym_enum] = ACTIONS(4984),
    [anon_sym_class] = ACTIONS(4984),
    [anon_sym_struct] = ACTIONS(4984),
    [anon_sym_union] = ACTIONS(4984),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4984),
    [anon_sym_decltype] = ACTIONS(4984),
    [anon_sym_virtual] = ACTIONS(4984),
    [anon_sym_alignas] = ACTIONS(4984),
    [anon_sym_explicit] = ACTIONS(4984),
    [anon_sym_typename] = ACTIONS(4984),
    [anon_sym_template] = ACTIONS(4984),
    [anon_sym_operator] = ACTIONS(4984),
    [anon_sym_friend] = ACTIONS(4984),
    [anon_sym_public] = ACTIONS(4984),
    [anon_sym_private] = ACTIONS(4984),
    [anon_sym_protected] = ACTIONS(4984),
    [anon_sym_using] = ACTIONS(4984),
    [anon_sym_static_assert] = ACTIONS(4984),
  },
  [1919] = {
    [sym_identifier] = ACTIONS(4988),
    [aux_sym_preproc_def_token1] = ACTIONS(4988),
    [aux_sym_preproc_if_token1] = ACTIONS(4988),
    [aux_sym_preproc_if_token2] = ACTIONS(4988),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4988),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4988),
    [aux_sym_preproc_else_token1] = ACTIONS(4988),
    [aux_sym_preproc_elif_token1] = ACTIONS(4988),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4988),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4988),
    [sym_preproc_directive] = ACTIONS(4988),
    [anon_sym_LPAREN2] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_STAR] = ACTIONS(4990),
    [anon_sym_AMP_AMP] = ACTIONS(4990),
    [anon_sym_AMP] = ACTIONS(4988),
    [anon_sym___extension__] = ACTIONS(4988),
    [anon_sym_typedef] = ACTIONS(4988),
    [anon_sym_extern] = ACTIONS(4988),
    [anon_sym___attribute__] = ACTIONS(4988),
    [anon_sym_COLON_COLON] = ACTIONS(4990),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4990),
    [anon_sym___declspec] = ACTIONS(4988),
    [anon_sym___based] = ACTIONS(4988),
    [anon_sym_signed] = ACTIONS(4988),
    [anon_sym_unsigned] = ACTIONS(4988),
    [anon_sym_long] = ACTIONS(4988),
    [anon_sym_short] = ACTIONS(4988),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_static] = ACTIONS(4988),
    [anon_sym_register] = ACTIONS(4988),
    [anon_sym_inline] = ACTIONS(4988),
    [anon_sym___inline] = ACTIONS(4988),
    [anon_sym___inline__] = ACTIONS(4988),
    [anon_sym___forceinline] = ACTIONS(4988),
    [anon_sym_thread_local] = ACTIONS(4988),
    [anon_sym___thread] = ACTIONS(4988),
    [anon_sym_const] = ACTIONS(4988),
    [anon_sym_constexpr] = ACTIONS(4988),
    [anon_sym_volatile] = ACTIONS(4988),
    [anon_sym_restrict] = ACTIONS(4988),
    [anon_sym___restrict__] = ACTIONS(4988),
    [anon_sym__Atomic] = ACTIONS(4988),
    [anon_sym__Noreturn] = ACTIONS(4988),
    [anon_sym_noreturn] = ACTIONS(4988),
    [anon_sym_mutable] = ACTIONS(4988),
    [anon_sym_constinit] = ACTIONS(4988),
    [anon_sym_consteval] = ACTIONS(4988),
    [anon_sym_PROGMEM] = ACTIONS(4988),
    [aux_sym_primitive_type_token1] = ACTIONS(4988),
    [anon_sym_byte] = ACTIONS(4988),
    [anon_sym_word] = ACTIONS(4988),
    [anon_sym_enum] = ACTIONS(4988),
    [anon_sym_class] = ACTIONS(4988),
    [anon_sym_struct] = ACTIONS(4988),
    [anon_sym_union] = ACTIONS(4988),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4988),
    [anon_sym_decltype] = ACTIONS(4988),
    [anon_sym_virtual] = ACTIONS(4988),
    [anon_sym_alignas] = ACTIONS(4988),
    [anon_sym_explicit] = ACTIONS(4988),
    [anon_sym_typename] = ACTIONS(4988),
    [anon_sym_template] = ACTIONS(4988),
    [anon_sym_operator] = ACTIONS(4988),
    [anon_sym_friend] = ACTIONS(4988),
    [anon_sym_public] = ACTIONS(4988),
    [anon_sym_private] = ACTIONS(4988),
    [anon_sym_protected] = ACTIONS(4988),
    [anon_sym_using] = ACTIONS(4988),
    [anon_sym_static_assert] = ACTIONS(4988),
  },
  [1920] = {
    [sym_identifier] = ACTIONS(4988),
    [aux_sym_preproc_def_token1] = ACTIONS(4988),
    [aux_sym_preproc_if_token1] = ACTIONS(4988),
    [aux_sym_preproc_if_token2] = ACTIONS(4988),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4988),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4988),
    [aux_sym_preproc_else_token1] = ACTIONS(4988),
    [aux_sym_preproc_elif_token1] = ACTIONS(4988),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4988),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4988),
    [sym_preproc_directive] = ACTIONS(4988),
    [anon_sym_LPAREN2] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_STAR] = ACTIONS(4990),
    [anon_sym_AMP_AMP] = ACTIONS(4990),
    [anon_sym_AMP] = ACTIONS(4988),
    [anon_sym___extension__] = ACTIONS(4988),
    [anon_sym_typedef] = ACTIONS(4988),
    [anon_sym_extern] = ACTIONS(4988),
    [anon_sym___attribute__] = ACTIONS(4988),
    [anon_sym_COLON_COLON] = ACTIONS(4990),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4990),
    [anon_sym___declspec] = ACTIONS(4988),
    [anon_sym___based] = ACTIONS(4988),
    [anon_sym_signed] = ACTIONS(4988),
    [anon_sym_unsigned] = ACTIONS(4988),
    [anon_sym_long] = ACTIONS(4988),
    [anon_sym_short] = ACTIONS(4988),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_static] = ACTIONS(4988),
    [anon_sym_register] = ACTIONS(4988),
    [anon_sym_inline] = ACTIONS(4988),
    [anon_sym___inline] = ACTIONS(4988),
    [anon_sym___inline__] = ACTIONS(4988),
    [anon_sym___forceinline] = ACTIONS(4988),
    [anon_sym_thread_local] = ACTIONS(4988),
    [anon_sym___thread] = ACTIONS(4988),
    [anon_sym_const] = ACTIONS(4988),
    [anon_sym_constexpr] = ACTIONS(4988),
    [anon_sym_volatile] = ACTIONS(4988),
    [anon_sym_restrict] = ACTIONS(4988),
    [anon_sym___restrict__] = ACTIONS(4988),
    [anon_sym__Atomic] = ACTIONS(4988),
    [anon_sym__Noreturn] = ACTIONS(4988),
    [anon_sym_noreturn] = ACTIONS(4988),
    [anon_sym_mutable] = ACTIONS(4988),
    [anon_sym_constinit] = ACTIONS(4988),
    [anon_sym_consteval] = ACTIONS(4988),
    [anon_sym_PROGMEM] = ACTIONS(4988),
    [aux_sym_primitive_type_token1] = ACTIONS(4988),
    [anon_sym_byte] = ACTIONS(4988),
    [anon_sym_word] = ACTIONS(4988),
    [anon_sym_enum] = ACTIONS(4988),
    [anon_sym_class] = ACTIONS(4988),
    [anon_sym_struct] = ACTIONS(4988),
    [anon_sym_union] = ACTIONS(4988),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4988),
    [anon_sym_decltype] = ACTIONS(4988),
    [anon_sym_virtual] = ACTIONS(4988),
    [anon_sym_alignas] = ACTIONS(4988),
    [anon_sym_explicit] = ACTIONS(4988),
    [anon_sym_typename] = ACTIONS(4988),
    [anon_sym_template] = ACTIONS(4988),
    [anon_sym_operator] = ACTIONS(4988),
    [anon_sym_friend] = ACTIONS(4988),
    [anon_sym_public] = ACTIONS(4988),
    [anon_sym_private] = ACTIONS(4988),
    [anon_sym_protected] = ACTIONS(4988),
    [anon_sym_using] = ACTIONS(4988),
    [anon_sym_static_assert] = ACTIONS(4988),
  },
  [1921] = {
    [sym_identifier] = ACTIONS(4992),
    [aux_sym_preproc_def_token1] = ACTIONS(4992),
    [aux_sym_preproc_if_token1] = ACTIONS(4992),
    [aux_sym_preproc_if_token2] = ACTIONS(4992),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4992),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4992),
    [aux_sym_preproc_else_token1] = ACTIONS(4992),
    [aux_sym_preproc_elif_token1] = ACTIONS(4992),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4992),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4992),
    [sym_preproc_directive] = ACTIONS(4992),
    [anon_sym_LPAREN2] = ACTIONS(4994),
    [anon_sym_TILDE] = ACTIONS(4994),
    [anon_sym_STAR] = ACTIONS(4994),
    [anon_sym_AMP_AMP] = ACTIONS(4994),
    [anon_sym_AMP] = ACTIONS(4992),
    [anon_sym___extension__] = ACTIONS(4992),
    [anon_sym_typedef] = ACTIONS(4992),
    [anon_sym_extern] = ACTIONS(4992),
    [anon_sym___attribute__] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4994),
    [anon_sym___declspec] = ACTIONS(4992),
    [anon_sym___based] = ACTIONS(4992),
    [anon_sym_signed] = ACTIONS(4992),
    [anon_sym_unsigned] = ACTIONS(4992),
    [anon_sym_long] = ACTIONS(4992),
    [anon_sym_short] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4992),
    [anon_sym_static] = ACTIONS(4992),
    [anon_sym_register] = ACTIONS(4992),
    [anon_sym_inline] = ACTIONS(4992),
    [anon_sym___inline] = ACTIONS(4992),
    [anon_sym___inline__] = ACTIONS(4992),
    [anon_sym___forceinline] = ACTIONS(4992),
    [anon_sym_thread_local] = ACTIONS(4992),
    [anon_sym___thread] = ACTIONS(4992),
    [anon_sym_const] = ACTIONS(4992),
    [anon_sym_constexpr] = ACTIONS(4992),
    [anon_sym_volatile] = ACTIONS(4992),
    [anon_sym_restrict] = ACTIONS(4992),
    [anon_sym___restrict__] = ACTIONS(4992),
    [anon_sym__Atomic] = ACTIONS(4992),
    [anon_sym__Noreturn] = ACTIONS(4992),
    [anon_sym_noreturn] = ACTIONS(4992),
    [anon_sym_mutable] = ACTIONS(4992),
    [anon_sym_constinit] = ACTIONS(4992),
    [anon_sym_consteval] = ACTIONS(4992),
    [anon_sym_PROGMEM] = ACTIONS(4992),
    [aux_sym_primitive_type_token1] = ACTIONS(4992),
    [anon_sym_byte] = ACTIONS(4992),
    [anon_sym_word] = ACTIONS(4992),
    [anon_sym_enum] = ACTIONS(4992),
    [anon_sym_class] = ACTIONS(4992),
    [anon_sym_struct] = ACTIONS(4992),
    [anon_sym_union] = ACTIONS(4992),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4992),
    [anon_sym_decltype] = ACTIONS(4992),
    [anon_sym_virtual] = ACTIONS(4992),
    [anon_sym_alignas] = ACTIONS(4992),
    [anon_sym_explicit] = ACTIONS(4992),
    [anon_sym_typename] = ACTIONS(4992),
    [anon_sym_template] = ACTIONS(4992),
    [anon_sym_operator] = ACTIONS(4992),
    [anon_sym_friend] = ACTIONS(4992),
    [anon_sym_public] = ACTIONS(4992),
    [anon_sym_private] = ACTIONS(4992),
    [anon_sym_protected] = ACTIONS(4992),
    [anon_sym_using] = ACTIONS(4992),
    [anon_sym_static_assert] = ACTIONS(4992),
  },
  [1922] = {
    [sym_identifier] = ACTIONS(4996),
    [aux_sym_preproc_def_token1] = ACTIONS(4996),
    [aux_sym_preproc_if_token1] = ACTIONS(4996),
    [aux_sym_preproc_if_token2] = ACTIONS(4996),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4996),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4996),
    [aux_sym_preproc_else_token1] = ACTIONS(4996),
    [aux_sym_preproc_elif_token1] = ACTIONS(4996),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4996),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4996),
    [sym_preproc_directive] = ACTIONS(4996),
    [anon_sym_LPAREN2] = ACTIONS(4998),
    [anon_sym_TILDE] = ACTIONS(4998),
    [anon_sym_STAR] = ACTIONS(4998),
    [anon_sym_AMP_AMP] = ACTIONS(4998),
    [anon_sym_AMP] = ACTIONS(4996),
    [anon_sym___extension__] = ACTIONS(4996),
    [anon_sym_typedef] = ACTIONS(4996),
    [anon_sym_extern] = ACTIONS(4996),
    [anon_sym___attribute__] = ACTIONS(4996),
    [anon_sym_COLON_COLON] = ACTIONS(4998),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4998),
    [anon_sym___declspec] = ACTIONS(4996),
    [anon_sym___based] = ACTIONS(4996),
    [anon_sym_signed] = ACTIONS(4996),
    [anon_sym_unsigned] = ACTIONS(4996),
    [anon_sym_long] = ACTIONS(4996),
    [anon_sym_short] = ACTIONS(4996),
    [anon_sym_LBRACK] = ACTIONS(4996),
    [anon_sym_static] = ACTIONS(4996),
    [anon_sym_register] = ACTIONS(4996),
    [anon_sym_inline] = ACTIONS(4996),
    [anon_sym___inline] = ACTIONS(4996),
    [anon_sym___inline__] = ACTIONS(4996),
    [anon_sym___forceinline] = ACTIONS(4996),
    [anon_sym_thread_local] = ACTIONS(4996),
    [anon_sym___thread] = ACTIONS(4996),
    [anon_sym_const] = ACTIONS(4996),
    [anon_sym_constexpr] = ACTIONS(4996),
    [anon_sym_volatile] = ACTIONS(4996),
    [anon_sym_restrict] = ACTIONS(4996),
    [anon_sym___restrict__] = ACTIONS(4996),
    [anon_sym__Atomic] = ACTIONS(4996),
    [anon_sym__Noreturn] = ACTIONS(4996),
    [anon_sym_noreturn] = ACTIONS(4996),
    [anon_sym_mutable] = ACTIONS(4996),
    [anon_sym_constinit] = ACTIONS(4996),
    [anon_sym_consteval] = ACTIONS(4996),
    [anon_sym_PROGMEM] = ACTIONS(4996),
    [aux_sym_primitive_type_token1] = ACTIONS(4996),
    [anon_sym_byte] = ACTIONS(4996),
    [anon_sym_word] = ACTIONS(4996),
    [anon_sym_enum] = ACTIONS(4996),
    [anon_sym_class] = ACTIONS(4996),
    [anon_sym_struct] = ACTIONS(4996),
    [anon_sym_union] = ACTIONS(4996),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4996),
    [anon_sym_decltype] = ACTIONS(4996),
    [anon_sym_virtual] = ACTIONS(4996),
    [anon_sym_alignas] = ACTIONS(4996),
    [anon_sym_explicit] = ACTIONS(4996),
    [anon_sym_typename] = ACTIONS(4996),
    [anon_sym_template] = ACTIONS(4996),
    [anon_sym_operator] = ACTIONS(4996),
    [anon_sym_friend] = ACTIONS(4996),
    [anon_sym_public] = ACTIONS(4996),
    [anon_sym_private] = ACTIONS(4996),
    [anon_sym_protected] = ACTIONS(4996),
    [anon_sym_using] = ACTIONS(4996),
    [anon_sym_static_assert] = ACTIONS(4996),
  },
  [1923] = {
    [sym_identifier] = ACTIONS(3056),
    [aux_sym_preproc_def_token1] = ACTIONS(3056),
    [aux_sym_preproc_if_token1] = ACTIONS(3056),
    [aux_sym_preproc_if_token2] = ACTIONS(3056),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3056),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3056),
    [aux_sym_preproc_else_token1] = ACTIONS(3056),
    [aux_sym_preproc_elif_token1] = ACTIONS(3056),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3056),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3056),
    [sym_preproc_directive] = ACTIONS(3056),
    [anon_sym_LPAREN2] = ACTIONS(3058),
    [anon_sym_TILDE] = ACTIONS(3058),
    [anon_sym_STAR] = ACTIONS(3058),
    [anon_sym_AMP_AMP] = ACTIONS(3058),
    [anon_sym_AMP] = ACTIONS(3056),
    [anon_sym___extension__] = ACTIONS(3056),
    [anon_sym_typedef] = ACTIONS(3056),
    [anon_sym_extern] = ACTIONS(3056),
    [anon_sym___attribute__] = ACTIONS(3056),
    [anon_sym_COLON_COLON] = ACTIONS(3058),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3058),
    [anon_sym___declspec] = ACTIONS(3056),
    [anon_sym___based] = ACTIONS(3056),
    [anon_sym_signed] = ACTIONS(3056),
    [anon_sym_unsigned] = ACTIONS(3056),
    [anon_sym_long] = ACTIONS(3056),
    [anon_sym_short] = ACTIONS(3056),
    [anon_sym_LBRACK] = ACTIONS(3056),
    [anon_sym_static] = ACTIONS(3056),
    [anon_sym_register] = ACTIONS(3056),
    [anon_sym_inline] = ACTIONS(3056),
    [anon_sym___inline] = ACTIONS(3056),
    [anon_sym___inline__] = ACTIONS(3056),
    [anon_sym___forceinline] = ACTIONS(3056),
    [anon_sym_thread_local] = ACTIONS(3056),
    [anon_sym___thread] = ACTIONS(3056),
    [anon_sym_const] = ACTIONS(3056),
    [anon_sym_constexpr] = ACTIONS(3056),
    [anon_sym_volatile] = ACTIONS(3056),
    [anon_sym_restrict] = ACTIONS(3056),
    [anon_sym___restrict__] = ACTIONS(3056),
    [anon_sym__Atomic] = ACTIONS(3056),
    [anon_sym__Noreturn] = ACTIONS(3056),
    [anon_sym_noreturn] = ACTIONS(3056),
    [anon_sym_mutable] = ACTIONS(3056),
    [anon_sym_constinit] = ACTIONS(3056),
    [anon_sym_consteval] = ACTIONS(3056),
    [anon_sym_PROGMEM] = ACTIONS(3056),
    [aux_sym_primitive_type_token1] = ACTIONS(3056),
    [anon_sym_byte] = ACTIONS(3056),
    [anon_sym_word] = ACTIONS(3056),
    [anon_sym_enum] = ACTIONS(3056),
    [anon_sym_class] = ACTIONS(3056),
    [anon_sym_struct] = ACTIONS(3056),
    [anon_sym_union] = ACTIONS(3056),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3056),
    [anon_sym_decltype] = ACTIONS(3056),
    [anon_sym_virtual] = ACTIONS(3056),
    [anon_sym_alignas] = ACTIONS(3056),
    [anon_sym_explicit] = ACTIONS(3056),
    [anon_sym_typename] = ACTIONS(3056),
    [anon_sym_template] = ACTIONS(3056),
    [anon_sym_operator] = ACTIONS(3056),
    [anon_sym_friend] = ACTIONS(3056),
    [anon_sym_public] = ACTIONS(3056),
    [anon_sym_private] = ACTIONS(3056),
    [anon_sym_protected] = ACTIONS(3056),
    [anon_sym_using] = ACTIONS(3056),
    [anon_sym_static_assert] = ACTIONS(3056),
  },
  [1924] = {
    [sym_identifier] = ACTIONS(5000),
    [aux_sym_preproc_def_token1] = ACTIONS(5000),
    [aux_sym_preproc_if_token1] = ACTIONS(5000),
    [aux_sym_preproc_if_token2] = ACTIONS(5000),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5000),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5000),
    [aux_sym_preproc_else_token1] = ACTIONS(5000),
    [aux_sym_preproc_elif_token1] = ACTIONS(5000),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5000),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5000),
    [sym_preproc_directive] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [anon_sym_STAR] = ACTIONS(5002),
    [anon_sym_AMP_AMP] = ACTIONS(5002),
    [anon_sym_AMP] = ACTIONS(5000),
    [anon_sym___extension__] = ACTIONS(5000),
    [anon_sym_typedef] = ACTIONS(5000),
    [anon_sym_extern] = ACTIONS(5000),
    [anon_sym___attribute__] = ACTIONS(5000),
    [anon_sym_COLON_COLON] = ACTIONS(5002),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5002),
    [anon_sym___declspec] = ACTIONS(5000),
    [anon_sym___based] = ACTIONS(5000),
    [anon_sym_signed] = ACTIONS(5000),
    [anon_sym_unsigned] = ACTIONS(5000),
    [anon_sym_long] = ACTIONS(5000),
    [anon_sym_short] = ACTIONS(5000),
    [anon_sym_LBRACK] = ACTIONS(5000),
    [anon_sym_static] = ACTIONS(5000),
    [anon_sym_register] = ACTIONS(5000),
    [anon_sym_inline] = ACTIONS(5000),
    [anon_sym___inline] = ACTIONS(5000),
    [anon_sym___inline__] = ACTIONS(5000),
    [anon_sym___forceinline] = ACTIONS(5000),
    [anon_sym_thread_local] = ACTIONS(5000),
    [anon_sym___thread] = ACTIONS(5000),
    [anon_sym_const] = ACTIONS(5000),
    [anon_sym_constexpr] = ACTIONS(5000),
    [anon_sym_volatile] = ACTIONS(5000),
    [anon_sym_restrict] = ACTIONS(5000),
    [anon_sym___restrict__] = ACTIONS(5000),
    [anon_sym__Atomic] = ACTIONS(5000),
    [anon_sym__Noreturn] = ACTIONS(5000),
    [anon_sym_noreturn] = ACTIONS(5000),
    [anon_sym_mutable] = ACTIONS(5000),
    [anon_sym_constinit] = ACTIONS(5000),
    [anon_sym_consteval] = ACTIONS(5000),
    [anon_sym_PROGMEM] = ACTIONS(5000),
    [aux_sym_primitive_type_token1] = ACTIONS(5000),
    [anon_sym_byte] = ACTIONS(5000),
    [anon_sym_word] = ACTIONS(5000),
    [anon_sym_enum] = ACTIONS(5000),
    [anon_sym_class] = ACTIONS(5000),
    [anon_sym_struct] = ACTIONS(5000),
    [anon_sym_union] = ACTIONS(5000),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5000),
    [anon_sym_decltype] = ACTIONS(5000),
    [anon_sym_virtual] = ACTIONS(5000),
    [anon_sym_alignas] = ACTIONS(5000),
    [anon_sym_explicit] = ACTIONS(5000),
    [anon_sym_typename] = ACTIONS(5000),
    [anon_sym_template] = ACTIONS(5000),
    [anon_sym_operator] = ACTIONS(5000),
    [anon_sym_friend] = ACTIONS(5000),
    [anon_sym_public] = ACTIONS(5000),
    [anon_sym_private] = ACTIONS(5000),
    [anon_sym_protected] = ACTIONS(5000),
    [anon_sym_using] = ACTIONS(5000),
    [anon_sym_static_assert] = ACTIONS(5000),
  },
  [1925] = {
    [sym__declaration_modifiers] = STATE(1964),
    [sym__declaration_specifiers] = STATE(4680),
    [sym_attribute_specifier] = STATE(1964),
    [sym_attribute_declaration] = STATE(1964),
    [sym_ms_declspec_modifier] = STATE(1964),
    [sym_storage_class_specifier] = STATE(1964),
    [sym_type_qualifier] = STATE(1964),
    [sym__type_specifier] = STATE(2473),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(1964),
    [sym_alignas_specifier] = STATE(1964),
    [sym_dependent_type] = STATE(2629),
    [sym_template_type] = STATE(2618),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(6346),
    [sym_qualified_type_identifier] = STATE(3260),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1964),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [sym_identifier] = ACTIONS(4625),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4627),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1419),
  },
  [1926] = {
    [sym_identifier] = ACTIONS(3052),
    [aux_sym_preproc_def_token1] = ACTIONS(3052),
    [aux_sym_preproc_if_token1] = ACTIONS(3052),
    [aux_sym_preproc_if_token2] = ACTIONS(3052),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3052),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3052),
    [aux_sym_preproc_else_token1] = ACTIONS(3052),
    [aux_sym_preproc_elif_token1] = ACTIONS(3052),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3052),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3052),
    [sym_preproc_directive] = ACTIONS(3052),
    [anon_sym_LPAREN2] = ACTIONS(3054),
    [anon_sym_TILDE] = ACTIONS(3054),
    [anon_sym_STAR] = ACTIONS(3054),
    [anon_sym_AMP_AMP] = ACTIONS(3054),
    [anon_sym_AMP] = ACTIONS(3052),
    [anon_sym___extension__] = ACTIONS(3052),
    [anon_sym_typedef] = ACTIONS(3052),
    [anon_sym_extern] = ACTIONS(3052),
    [anon_sym___attribute__] = ACTIONS(3052),
    [anon_sym_COLON_COLON] = ACTIONS(3054),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3054),
    [anon_sym___declspec] = ACTIONS(3052),
    [anon_sym___based] = ACTIONS(3052),
    [anon_sym_signed] = ACTIONS(3052),
    [anon_sym_unsigned] = ACTIONS(3052),
    [anon_sym_long] = ACTIONS(3052),
    [anon_sym_short] = ACTIONS(3052),
    [anon_sym_LBRACK] = ACTIONS(3052),
    [anon_sym_static] = ACTIONS(3052),
    [anon_sym_register] = ACTIONS(3052),
    [anon_sym_inline] = ACTIONS(3052),
    [anon_sym___inline] = ACTIONS(3052),
    [anon_sym___inline__] = ACTIONS(3052),
    [anon_sym___forceinline] = ACTIONS(3052),
    [anon_sym_thread_local] = ACTIONS(3052),
    [anon_sym___thread] = ACTIONS(3052),
    [anon_sym_const] = ACTIONS(3052),
    [anon_sym_constexpr] = ACTIONS(3052),
    [anon_sym_volatile] = ACTIONS(3052),
    [anon_sym_restrict] = ACTIONS(3052),
    [anon_sym___restrict__] = ACTIONS(3052),
    [anon_sym__Atomic] = ACTIONS(3052),
    [anon_sym__Noreturn] = ACTIONS(3052),
    [anon_sym_noreturn] = ACTIONS(3052),
    [anon_sym_mutable] = ACTIONS(3052),
    [anon_sym_constinit] = ACTIONS(3052),
    [anon_sym_consteval] = ACTIONS(3052),
    [anon_sym_PROGMEM] = ACTIONS(3052),
    [aux_sym_primitive_type_token1] = ACTIONS(3052),
    [anon_sym_byte] = ACTIONS(3052),
    [anon_sym_word] = ACTIONS(3052),
    [anon_sym_enum] = ACTIONS(3052),
    [anon_sym_class] = ACTIONS(3052),
    [anon_sym_struct] = ACTIONS(3052),
    [anon_sym_union] = ACTIONS(3052),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3052),
    [anon_sym_decltype] = ACTIONS(3052),
    [anon_sym_virtual] = ACTIONS(3052),
    [anon_sym_alignas] = ACTIONS(3052),
    [anon_sym_explicit] = ACTIONS(3052),
    [anon_sym_typename] = ACTIONS(3052),
    [anon_sym_template] = ACTIONS(3052),
    [anon_sym_operator] = ACTIONS(3052),
    [anon_sym_friend] = ACTIONS(3052),
    [anon_sym_public] = ACTIONS(3052),
    [anon_sym_private] = ACTIONS(3052),
    [anon_sym_protected] = ACTIONS(3052),
    [anon_sym_using] = ACTIONS(3052),
    [anon_sym_static_assert] = ACTIONS(3052),
  },
  [1927] = {
    [sym_identifier] = ACTIONS(3048),
    [aux_sym_preproc_def_token1] = ACTIONS(3048),
    [aux_sym_preproc_if_token1] = ACTIONS(3048),
    [aux_sym_preproc_if_token2] = ACTIONS(3048),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3048),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3048),
    [aux_sym_preproc_else_token1] = ACTIONS(3048),
    [aux_sym_preproc_elif_token1] = ACTIONS(3048),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3048),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3048),
    [sym_preproc_directive] = ACTIONS(3048),
    [anon_sym_LPAREN2] = ACTIONS(3050),
    [anon_sym_TILDE] = ACTIONS(3050),
    [anon_sym_STAR] = ACTIONS(3050),
    [anon_sym_AMP_AMP] = ACTIONS(3050),
    [anon_sym_AMP] = ACTIONS(3048),
    [anon_sym___extension__] = ACTIONS(3048),
    [anon_sym_typedef] = ACTIONS(3048),
    [anon_sym_extern] = ACTIONS(3048),
    [anon_sym___attribute__] = ACTIONS(3048),
    [anon_sym_COLON_COLON] = ACTIONS(3050),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3050),
    [anon_sym___declspec] = ACTIONS(3048),
    [anon_sym___based] = ACTIONS(3048),
    [anon_sym_signed] = ACTIONS(3048),
    [anon_sym_unsigned] = ACTIONS(3048),
    [anon_sym_long] = ACTIONS(3048),
    [anon_sym_short] = ACTIONS(3048),
    [anon_sym_LBRACK] = ACTIONS(3048),
    [anon_sym_static] = ACTIONS(3048),
    [anon_sym_register] = ACTIONS(3048),
    [anon_sym_inline] = ACTIONS(3048),
    [anon_sym___inline] = ACTIONS(3048),
    [anon_sym___inline__] = ACTIONS(3048),
    [anon_sym___forceinline] = ACTIONS(3048),
    [anon_sym_thread_local] = ACTIONS(3048),
    [anon_sym___thread] = ACTIONS(3048),
    [anon_sym_const] = ACTIONS(3048),
    [anon_sym_constexpr] = ACTIONS(3048),
    [anon_sym_volatile] = ACTIONS(3048),
    [anon_sym_restrict] = ACTIONS(3048),
    [anon_sym___restrict__] = ACTIONS(3048),
    [anon_sym__Atomic] = ACTIONS(3048),
    [anon_sym__Noreturn] = ACTIONS(3048),
    [anon_sym_noreturn] = ACTIONS(3048),
    [anon_sym_mutable] = ACTIONS(3048),
    [anon_sym_constinit] = ACTIONS(3048),
    [anon_sym_consteval] = ACTIONS(3048),
    [anon_sym_PROGMEM] = ACTIONS(3048),
    [aux_sym_primitive_type_token1] = ACTIONS(3048),
    [anon_sym_byte] = ACTIONS(3048),
    [anon_sym_word] = ACTIONS(3048),
    [anon_sym_enum] = ACTIONS(3048),
    [anon_sym_class] = ACTIONS(3048),
    [anon_sym_struct] = ACTIONS(3048),
    [anon_sym_union] = ACTIONS(3048),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3048),
    [anon_sym_decltype] = ACTIONS(3048),
    [anon_sym_virtual] = ACTIONS(3048),
    [anon_sym_alignas] = ACTIONS(3048),
    [anon_sym_explicit] = ACTIONS(3048),
    [anon_sym_typename] = ACTIONS(3048),
    [anon_sym_template] = ACTIONS(3048),
    [anon_sym_operator] = ACTIONS(3048),
    [anon_sym_friend] = ACTIONS(3048),
    [anon_sym_public] = ACTIONS(3048),
    [anon_sym_private] = ACTIONS(3048),
    [anon_sym_protected] = ACTIONS(3048),
    [anon_sym_using] = ACTIONS(3048),
    [anon_sym_static_assert] = ACTIONS(3048),
  },
  [1928] = {
    [sym_identifier] = ACTIONS(4559),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4561),
    [anon_sym_COMMA] = ACTIONS(4561),
    [anon_sym_RPAREN] = ACTIONS(4561),
    [anon_sym_LPAREN2] = ACTIONS(4561),
    [anon_sym_DASH] = ACTIONS(4559),
    [anon_sym_PLUS] = ACTIONS(4559),
    [anon_sym_STAR] = ACTIONS(4561),
    [anon_sym_SLASH] = ACTIONS(4559),
    [anon_sym_PERCENT] = ACTIONS(4561),
    [anon_sym_PIPE_PIPE] = ACTIONS(4561),
    [anon_sym_AMP_AMP] = ACTIONS(4561),
    [anon_sym_PIPE] = ACTIONS(4559),
    [anon_sym_CARET] = ACTIONS(4561),
    [anon_sym_AMP] = ACTIONS(4559),
    [anon_sym_EQ_EQ] = ACTIONS(4561),
    [anon_sym_BANG_EQ] = ACTIONS(4561),
    [anon_sym_GT] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4561),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_LT] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(4561),
    [anon_sym_SEMI] = ACTIONS(4561),
    [anon_sym___extension__] = ACTIONS(4559),
    [anon_sym___attribute__] = ACTIONS(4559),
    [anon_sym_COLON_COLON] = ACTIONS(4561),
    [anon_sym___based] = ACTIONS(4559),
    [anon_sym_LBRACE] = ACTIONS(4561),
    [anon_sym_RBRACE] = ACTIONS(4561),
    [anon_sym_signed] = ACTIONS(4559),
    [anon_sym_unsigned] = ACTIONS(4559),
    [anon_sym_long] = ACTIONS(4559),
    [anon_sym_short] = ACTIONS(4559),
    [anon_sym_LBRACK] = ACTIONS(4561),
    [anon_sym_RBRACK] = ACTIONS(4561),
    [anon_sym_const] = ACTIONS(4559),
    [anon_sym_constexpr] = ACTIONS(4559),
    [anon_sym_volatile] = ACTIONS(4559),
    [anon_sym_restrict] = ACTIONS(4559),
    [anon_sym___restrict__] = ACTIONS(4559),
    [anon_sym__Atomic] = ACTIONS(4559),
    [anon_sym__Noreturn] = ACTIONS(4559),
    [anon_sym_noreturn] = ACTIONS(4559),
    [anon_sym_mutable] = ACTIONS(4559),
    [anon_sym_constinit] = ACTIONS(4559),
    [anon_sym_consteval] = ACTIONS(4559),
    [anon_sym_PROGMEM] = ACTIONS(4559),
    [aux_sym_primitive_type_token1] = ACTIONS(4559),
    [anon_sym_byte] = ACTIONS(4559),
    [anon_sym_word] = ACTIONS(4559),
    [anon_sym_COLON] = ACTIONS(4559),
    [anon_sym_QMARK] = ACTIONS(4561),
    [anon_sym_LT_EQ_GT] = ACTIONS(4561),
    [anon_sym_or] = ACTIONS(4559),
    [anon_sym_and] = ACTIONS(4559),
    [anon_sym_bitor] = ACTIONS(4559),
    [anon_sym_xor] = ACTIONS(4559),
    [anon_sym_bitand] = ACTIONS(4559),
    [anon_sym_not_eq] = ACTIONS(4559),
    [anon_sym_DASH_DASH] = ACTIONS(4561),
    [anon_sym_PLUS_PLUS] = ACTIONS(4561),
    [anon_sym_DOT] = ACTIONS(4559),
    [anon_sym_DOT_STAR] = ACTIONS(4561),
    [anon_sym_DASH_GT] = ACTIONS(4561),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4559),
    [anon_sym_decltype] = ACTIONS(4559),
    [anon_sym_final] = ACTIONS(4559),
    [anon_sym_override] = ACTIONS(4559),
    [anon_sym_requires] = ACTIONS(4559),
  },
  [1929] = {
    [sym_identifier] = ACTIONS(5004),
    [aux_sym_preproc_def_token1] = ACTIONS(5004),
    [aux_sym_preproc_if_token1] = ACTIONS(5004),
    [aux_sym_preproc_if_token2] = ACTIONS(5004),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5004),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5004),
    [aux_sym_preproc_else_token1] = ACTIONS(5004),
    [aux_sym_preproc_elif_token1] = ACTIONS(5004),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5004),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5004),
    [sym_preproc_directive] = ACTIONS(5004),
    [anon_sym_LPAREN2] = ACTIONS(5006),
    [anon_sym_TILDE] = ACTIONS(5006),
    [anon_sym_STAR] = ACTIONS(5006),
    [anon_sym_AMP_AMP] = ACTIONS(5006),
    [anon_sym_AMP] = ACTIONS(5004),
    [anon_sym___extension__] = ACTIONS(5004),
    [anon_sym_typedef] = ACTIONS(5004),
    [anon_sym_extern] = ACTIONS(5004),
    [anon_sym___attribute__] = ACTIONS(5004),
    [anon_sym_COLON_COLON] = ACTIONS(5006),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5006),
    [anon_sym___declspec] = ACTIONS(5004),
    [anon_sym___based] = ACTIONS(5004),
    [anon_sym_signed] = ACTIONS(5004),
    [anon_sym_unsigned] = ACTIONS(5004),
    [anon_sym_long] = ACTIONS(5004),
    [anon_sym_short] = ACTIONS(5004),
    [anon_sym_LBRACK] = ACTIONS(5004),
    [anon_sym_static] = ACTIONS(5004),
    [anon_sym_register] = ACTIONS(5004),
    [anon_sym_inline] = ACTIONS(5004),
    [anon_sym___inline] = ACTIONS(5004),
    [anon_sym___inline__] = ACTIONS(5004),
    [anon_sym___forceinline] = ACTIONS(5004),
    [anon_sym_thread_local] = ACTIONS(5004),
    [anon_sym___thread] = ACTIONS(5004),
    [anon_sym_const] = ACTIONS(5004),
    [anon_sym_constexpr] = ACTIONS(5004),
    [anon_sym_volatile] = ACTIONS(5004),
    [anon_sym_restrict] = ACTIONS(5004),
    [anon_sym___restrict__] = ACTIONS(5004),
    [anon_sym__Atomic] = ACTIONS(5004),
    [anon_sym__Noreturn] = ACTIONS(5004),
    [anon_sym_noreturn] = ACTIONS(5004),
    [anon_sym_mutable] = ACTIONS(5004),
    [anon_sym_constinit] = ACTIONS(5004),
    [anon_sym_consteval] = ACTIONS(5004),
    [anon_sym_PROGMEM] = ACTIONS(5004),
    [aux_sym_primitive_type_token1] = ACTIONS(5004),
    [anon_sym_byte] = ACTIONS(5004),
    [anon_sym_word] = ACTIONS(5004),
    [anon_sym_enum] = ACTIONS(5004),
    [anon_sym_class] = ACTIONS(5004),
    [anon_sym_struct] = ACTIONS(5004),
    [anon_sym_union] = ACTIONS(5004),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5004),
    [anon_sym_decltype] = ACTIONS(5004),
    [anon_sym_virtual] = ACTIONS(5004),
    [anon_sym_alignas] = ACTIONS(5004),
    [anon_sym_explicit] = ACTIONS(5004),
    [anon_sym_typename] = ACTIONS(5004),
    [anon_sym_template] = ACTIONS(5004),
    [anon_sym_operator] = ACTIONS(5004),
    [anon_sym_friend] = ACTIONS(5004),
    [anon_sym_public] = ACTIONS(5004),
    [anon_sym_private] = ACTIONS(5004),
    [anon_sym_protected] = ACTIONS(5004),
    [anon_sym_using] = ACTIONS(5004),
    [anon_sym_static_assert] = ACTIONS(5004),
  },
  [1930] = {
    [sym__declaration_modifiers] = STATE(3458),
    [sym_attribute_specifier] = STATE(3458),
    [sym_attribute_declaration] = STATE(3458),
    [sym_ms_declspec_modifier] = STATE(3458),
    [sym_ms_based_modifier] = STATE(8318),
    [sym__declarator] = STATE(6483),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_function_declarator] = STATE(6015),
    [sym_array_declarator] = STATE(6098),
    [sym_storage_class_specifier] = STATE(3458),
    [sym_type_qualifier] = STATE(3458),
    [sym_decltype] = STATE(8290),
    [sym_virtual] = STATE(3458),
    [sym_alignas_specifier] = STATE(3458),
    [sym_explicit_function_specifier] = STATE(3458),
    [sym_operator_cast] = STATE(6528),
    [sym__constructor_specifiers] = STATE(3458),
    [sym_reference_declarator] = STATE(6098),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym_template_type] = STATE(8290),
    [sym_template_function] = STATE(6098),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5430),
    [sym_qualified_identifier] = STATE(6098),
    [sym_qualified_operator_cast_identifier] = STATE(6528),
    [sym_operator_name] = STATE(6098),
    [aux_sym_operator_cast_definition_repeat1] = STATE(3458),
    [sym_identifier] = ACTIONS(4841),
    [anon_sym_LPAREN2] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym___extension__] = ACTIONS(4843),
    [anon_sym_extern] = ACTIONS(4845),
    [anon_sym___attribute__] = ACTIONS(4847),
    [anon_sym_COLON_COLON] = ACTIONS(4849),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4851),
    [anon_sym___declspec] = ACTIONS(4853),
    [anon_sym___based] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(4845),
    [anon_sym_register] = ACTIONS(4845),
    [anon_sym_inline] = ACTIONS(4845),
    [anon_sym___inline] = ACTIONS(4845),
    [anon_sym___inline__] = ACTIONS(4845),
    [anon_sym___forceinline] = ACTIONS(4845),
    [anon_sym_thread_local] = ACTIONS(4845),
    [anon_sym___thread] = ACTIONS(4845),
    [anon_sym_const] = ACTIONS(4843),
    [anon_sym_constexpr] = ACTIONS(4843),
    [anon_sym_volatile] = ACTIONS(4843),
    [anon_sym_restrict] = ACTIONS(4843),
    [anon_sym___restrict__] = ACTIONS(4843),
    [anon_sym__Atomic] = ACTIONS(4843),
    [anon_sym__Noreturn] = ACTIONS(4843),
    [anon_sym_noreturn] = ACTIONS(4843),
    [anon_sym_mutable] = ACTIONS(4843),
    [anon_sym_constinit] = ACTIONS(4843),
    [anon_sym_consteval] = ACTIONS(4843),
    [anon_sym_PROGMEM] = ACTIONS(4843),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_virtual] = ACTIONS(4855),
    [anon_sym_alignas] = ACTIONS(4857),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_operator] = ACTIONS(133),
  },
  [1931] = {
    [sym_identifier] = ACTIONS(5008),
    [aux_sym_preproc_def_token1] = ACTIONS(5008),
    [aux_sym_preproc_if_token1] = ACTIONS(5008),
    [aux_sym_preproc_if_token2] = ACTIONS(5008),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5008),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5008),
    [aux_sym_preproc_else_token1] = ACTIONS(5008),
    [aux_sym_preproc_elif_token1] = ACTIONS(5008),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5008),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5008),
    [sym_preproc_directive] = ACTIONS(5008),
    [anon_sym_LPAREN2] = ACTIONS(5010),
    [anon_sym_TILDE] = ACTIONS(5010),
    [anon_sym_STAR] = ACTIONS(5010),
    [anon_sym_AMP_AMP] = ACTIONS(5010),
    [anon_sym_AMP] = ACTIONS(5008),
    [anon_sym___extension__] = ACTIONS(5008),
    [anon_sym_typedef] = ACTIONS(5008),
    [anon_sym_extern] = ACTIONS(5008),
    [anon_sym___attribute__] = ACTIONS(5008),
    [anon_sym_COLON_COLON] = ACTIONS(5010),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5010),
    [anon_sym___declspec] = ACTIONS(5008),
    [anon_sym___based] = ACTIONS(5008),
    [anon_sym_signed] = ACTIONS(5008),
    [anon_sym_unsigned] = ACTIONS(5008),
    [anon_sym_long] = ACTIONS(5008),
    [anon_sym_short] = ACTIONS(5008),
    [anon_sym_LBRACK] = ACTIONS(5008),
    [anon_sym_static] = ACTIONS(5008),
    [anon_sym_register] = ACTIONS(5008),
    [anon_sym_inline] = ACTIONS(5008),
    [anon_sym___inline] = ACTIONS(5008),
    [anon_sym___inline__] = ACTIONS(5008),
    [anon_sym___forceinline] = ACTIONS(5008),
    [anon_sym_thread_local] = ACTIONS(5008),
    [anon_sym___thread] = ACTIONS(5008),
    [anon_sym_const] = ACTIONS(5008),
    [anon_sym_constexpr] = ACTIONS(5008),
    [anon_sym_volatile] = ACTIONS(5008),
    [anon_sym_restrict] = ACTIONS(5008),
    [anon_sym___restrict__] = ACTIONS(5008),
    [anon_sym__Atomic] = ACTIONS(5008),
    [anon_sym__Noreturn] = ACTIONS(5008),
    [anon_sym_noreturn] = ACTIONS(5008),
    [anon_sym_mutable] = ACTIONS(5008),
    [anon_sym_constinit] = ACTIONS(5008),
    [anon_sym_consteval] = ACTIONS(5008),
    [anon_sym_PROGMEM] = ACTIONS(5008),
    [aux_sym_primitive_type_token1] = ACTIONS(5008),
    [anon_sym_byte] = ACTIONS(5008),
    [anon_sym_word] = ACTIONS(5008),
    [anon_sym_enum] = ACTIONS(5008),
    [anon_sym_class] = ACTIONS(5008),
    [anon_sym_struct] = ACTIONS(5008),
    [anon_sym_union] = ACTIONS(5008),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5008),
    [anon_sym_decltype] = ACTIONS(5008),
    [anon_sym_virtual] = ACTIONS(5008),
    [anon_sym_alignas] = ACTIONS(5008),
    [anon_sym_explicit] = ACTIONS(5008),
    [anon_sym_typename] = ACTIONS(5008),
    [anon_sym_template] = ACTIONS(5008),
    [anon_sym_operator] = ACTIONS(5008),
    [anon_sym_friend] = ACTIONS(5008),
    [anon_sym_public] = ACTIONS(5008),
    [anon_sym_private] = ACTIONS(5008),
    [anon_sym_protected] = ACTIONS(5008),
    [anon_sym_using] = ACTIONS(5008),
    [anon_sym_static_assert] = ACTIONS(5008),
  },
  [1932] = {
    [sym_identifier] = ACTIONS(5012),
    [aux_sym_preproc_def_token1] = ACTIONS(5012),
    [aux_sym_preproc_if_token1] = ACTIONS(5012),
    [aux_sym_preproc_if_token2] = ACTIONS(5012),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5012),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5012),
    [aux_sym_preproc_else_token1] = ACTIONS(5012),
    [aux_sym_preproc_elif_token1] = ACTIONS(5012),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5012),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5012),
    [sym_preproc_directive] = ACTIONS(5012),
    [anon_sym_LPAREN2] = ACTIONS(5014),
    [anon_sym_TILDE] = ACTIONS(5014),
    [anon_sym_STAR] = ACTIONS(5014),
    [anon_sym_AMP_AMP] = ACTIONS(5014),
    [anon_sym_AMP] = ACTIONS(5012),
    [anon_sym___extension__] = ACTIONS(5012),
    [anon_sym_typedef] = ACTIONS(5012),
    [anon_sym_extern] = ACTIONS(5012),
    [anon_sym___attribute__] = ACTIONS(5012),
    [anon_sym_COLON_COLON] = ACTIONS(5014),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5014),
    [anon_sym___declspec] = ACTIONS(5012),
    [anon_sym___based] = ACTIONS(5012),
    [anon_sym_signed] = ACTIONS(5012),
    [anon_sym_unsigned] = ACTIONS(5012),
    [anon_sym_long] = ACTIONS(5012),
    [anon_sym_short] = ACTIONS(5012),
    [anon_sym_LBRACK] = ACTIONS(5012),
    [anon_sym_static] = ACTIONS(5012),
    [anon_sym_register] = ACTIONS(5012),
    [anon_sym_inline] = ACTIONS(5012),
    [anon_sym___inline] = ACTIONS(5012),
    [anon_sym___inline__] = ACTIONS(5012),
    [anon_sym___forceinline] = ACTIONS(5012),
    [anon_sym_thread_local] = ACTIONS(5012),
    [anon_sym___thread] = ACTIONS(5012),
    [anon_sym_const] = ACTIONS(5012),
    [anon_sym_constexpr] = ACTIONS(5012),
    [anon_sym_volatile] = ACTIONS(5012),
    [anon_sym_restrict] = ACTIONS(5012),
    [anon_sym___restrict__] = ACTIONS(5012),
    [anon_sym__Atomic] = ACTIONS(5012),
    [anon_sym__Noreturn] = ACTIONS(5012),
    [anon_sym_noreturn] = ACTIONS(5012),
    [anon_sym_mutable] = ACTIONS(5012),
    [anon_sym_constinit] = ACTIONS(5012),
    [anon_sym_consteval] = ACTIONS(5012),
    [anon_sym_PROGMEM] = ACTIONS(5012),
    [aux_sym_primitive_type_token1] = ACTIONS(5012),
    [anon_sym_byte] = ACTIONS(5012),
    [anon_sym_word] = ACTIONS(5012),
    [anon_sym_enum] = ACTIONS(5012),
    [anon_sym_class] = ACTIONS(5012),
    [anon_sym_struct] = ACTIONS(5012),
    [anon_sym_union] = ACTIONS(5012),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5012),
    [anon_sym_decltype] = ACTIONS(5012),
    [anon_sym_virtual] = ACTIONS(5012),
    [anon_sym_alignas] = ACTIONS(5012),
    [anon_sym_explicit] = ACTIONS(5012),
    [anon_sym_typename] = ACTIONS(5012),
    [anon_sym_template] = ACTIONS(5012),
    [anon_sym_operator] = ACTIONS(5012),
    [anon_sym_friend] = ACTIONS(5012),
    [anon_sym_public] = ACTIONS(5012),
    [anon_sym_private] = ACTIONS(5012),
    [anon_sym_protected] = ACTIONS(5012),
    [anon_sym_using] = ACTIONS(5012),
    [anon_sym_static_assert] = ACTIONS(5012),
  },
  [1933] = {
    [sym_identifier] = ACTIONS(5016),
    [aux_sym_preproc_def_token1] = ACTIONS(5016),
    [aux_sym_preproc_if_token1] = ACTIONS(5016),
    [aux_sym_preproc_if_token2] = ACTIONS(5016),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5016),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5016),
    [aux_sym_preproc_else_token1] = ACTIONS(5016),
    [aux_sym_preproc_elif_token1] = ACTIONS(5016),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5016),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5016),
    [sym_preproc_directive] = ACTIONS(5016),
    [anon_sym_LPAREN2] = ACTIONS(5018),
    [anon_sym_TILDE] = ACTIONS(5018),
    [anon_sym_STAR] = ACTIONS(5018),
    [anon_sym_AMP_AMP] = ACTIONS(5018),
    [anon_sym_AMP] = ACTIONS(5016),
    [anon_sym___extension__] = ACTIONS(5016),
    [anon_sym_typedef] = ACTIONS(5016),
    [anon_sym_extern] = ACTIONS(5016),
    [anon_sym___attribute__] = ACTIONS(5016),
    [anon_sym_COLON_COLON] = ACTIONS(5018),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5018),
    [anon_sym___declspec] = ACTIONS(5016),
    [anon_sym___based] = ACTIONS(5016),
    [anon_sym_signed] = ACTIONS(5016),
    [anon_sym_unsigned] = ACTIONS(5016),
    [anon_sym_long] = ACTIONS(5016),
    [anon_sym_short] = ACTIONS(5016),
    [anon_sym_LBRACK] = ACTIONS(5016),
    [anon_sym_static] = ACTIONS(5016),
    [anon_sym_register] = ACTIONS(5016),
    [anon_sym_inline] = ACTIONS(5016),
    [anon_sym___inline] = ACTIONS(5016),
    [anon_sym___inline__] = ACTIONS(5016),
    [anon_sym___forceinline] = ACTIONS(5016),
    [anon_sym_thread_local] = ACTIONS(5016),
    [anon_sym___thread] = ACTIONS(5016),
    [anon_sym_const] = ACTIONS(5016),
    [anon_sym_constexpr] = ACTIONS(5016),
    [anon_sym_volatile] = ACTIONS(5016),
    [anon_sym_restrict] = ACTIONS(5016),
    [anon_sym___restrict__] = ACTIONS(5016),
    [anon_sym__Atomic] = ACTIONS(5016),
    [anon_sym__Noreturn] = ACTIONS(5016),
    [anon_sym_noreturn] = ACTIONS(5016),
    [anon_sym_mutable] = ACTIONS(5016),
    [anon_sym_constinit] = ACTIONS(5016),
    [anon_sym_consteval] = ACTIONS(5016),
    [anon_sym_PROGMEM] = ACTIONS(5016),
    [aux_sym_primitive_type_token1] = ACTIONS(5016),
    [anon_sym_byte] = ACTIONS(5016),
    [anon_sym_word] = ACTIONS(5016),
    [anon_sym_enum] = ACTIONS(5016),
    [anon_sym_class] = ACTIONS(5016),
    [anon_sym_struct] = ACTIONS(5016),
    [anon_sym_union] = ACTIONS(5016),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5016),
    [anon_sym_decltype] = ACTIONS(5016),
    [anon_sym_virtual] = ACTIONS(5016),
    [anon_sym_alignas] = ACTIONS(5016),
    [anon_sym_explicit] = ACTIONS(5016),
    [anon_sym_typename] = ACTIONS(5016),
    [anon_sym_template] = ACTIONS(5016),
    [anon_sym_operator] = ACTIONS(5016),
    [anon_sym_friend] = ACTIONS(5016),
    [anon_sym_public] = ACTIONS(5016),
    [anon_sym_private] = ACTIONS(5016),
    [anon_sym_protected] = ACTIONS(5016),
    [anon_sym_using] = ACTIONS(5016),
    [anon_sym_static_assert] = ACTIONS(5016),
  },
  [1934] = {
    [sym_identifier] = ACTIONS(5020),
    [aux_sym_preproc_def_token1] = ACTIONS(5020),
    [aux_sym_preproc_if_token1] = ACTIONS(5020),
    [aux_sym_preproc_if_token2] = ACTIONS(5020),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5020),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5020),
    [aux_sym_preproc_else_token1] = ACTIONS(5020),
    [aux_sym_preproc_elif_token1] = ACTIONS(5020),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5020),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5020),
    [sym_preproc_directive] = ACTIONS(5020),
    [anon_sym_LPAREN2] = ACTIONS(5022),
    [anon_sym_TILDE] = ACTIONS(5022),
    [anon_sym_STAR] = ACTIONS(5022),
    [anon_sym_AMP_AMP] = ACTIONS(5022),
    [anon_sym_AMP] = ACTIONS(5020),
    [anon_sym___extension__] = ACTIONS(5020),
    [anon_sym_typedef] = ACTIONS(5020),
    [anon_sym_extern] = ACTIONS(5020),
    [anon_sym___attribute__] = ACTIONS(5020),
    [anon_sym_COLON_COLON] = ACTIONS(5022),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5022),
    [anon_sym___declspec] = ACTIONS(5020),
    [anon_sym___based] = ACTIONS(5020),
    [anon_sym_signed] = ACTIONS(5020),
    [anon_sym_unsigned] = ACTIONS(5020),
    [anon_sym_long] = ACTIONS(5020),
    [anon_sym_short] = ACTIONS(5020),
    [anon_sym_LBRACK] = ACTIONS(5020),
    [anon_sym_static] = ACTIONS(5020),
    [anon_sym_register] = ACTIONS(5020),
    [anon_sym_inline] = ACTIONS(5020),
    [anon_sym___inline] = ACTIONS(5020),
    [anon_sym___inline__] = ACTIONS(5020),
    [anon_sym___forceinline] = ACTIONS(5020),
    [anon_sym_thread_local] = ACTIONS(5020),
    [anon_sym___thread] = ACTIONS(5020),
    [anon_sym_const] = ACTIONS(5020),
    [anon_sym_constexpr] = ACTIONS(5020),
    [anon_sym_volatile] = ACTIONS(5020),
    [anon_sym_restrict] = ACTIONS(5020),
    [anon_sym___restrict__] = ACTIONS(5020),
    [anon_sym__Atomic] = ACTIONS(5020),
    [anon_sym__Noreturn] = ACTIONS(5020),
    [anon_sym_noreturn] = ACTIONS(5020),
    [anon_sym_mutable] = ACTIONS(5020),
    [anon_sym_constinit] = ACTIONS(5020),
    [anon_sym_consteval] = ACTIONS(5020),
    [anon_sym_PROGMEM] = ACTIONS(5020),
    [aux_sym_primitive_type_token1] = ACTIONS(5020),
    [anon_sym_byte] = ACTIONS(5020),
    [anon_sym_word] = ACTIONS(5020),
    [anon_sym_enum] = ACTIONS(5020),
    [anon_sym_class] = ACTIONS(5020),
    [anon_sym_struct] = ACTIONS(5020),
    [anon_sym_union] = ACTIONS(5020),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5020),
    [anon_sym_decltype] = ACTIONS(5020),
    [anon_sym_virtual] = ACTIONS(5020),
    [anon_sym_alignas] = ACTIONS(5020),
    [anon_sym_explicit] = ACTIONS(5020),
    [anon_sym_typename] = ACTIONS(5020),
    [anon_sym_template] = ACTIONS(5020),
    [anon_sym_operator] = ACTIONS(5020),
    [anon_sym_friend] = ACTIONS(5020),
    [anon_sym_public] = ACTIONS(5020),
    [anon_sym_private] = ACTIONS(5020),
    [anon_sym_protected] = ACTIONS(5020),
    [anon_sym_using] = ACTIONS(5020),
    [anon_sym_static_assert] = ACTIONS(5020),
  },
  [1935] = {
    [sym_identifier] = ACTIONS(5024),
    [aux_sym_preproc_def_token1] = ACTIONS(5024),
    [aux_sym_preproc_if_token1] = ACTIONS(5024),
    [aux_sym_preproc_if_token2] = ACTIONS(5024),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5024),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5024),
    [aux_sym_preproc_else_token1] = ACTIONS(5024),
    [aux_sym_preproc_elif_token1] = ACTIONS(5024),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5024),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5024),
    [sym_preproc_directive] = ACTIONS(5024),
    [anon_sym_LPAREN2] = ACTIONS(5026),
    [anon_sym_TILDE] = ACTIONS(5026),
    [anon_sym_STAR] = ACTIONS(5026),
    [anon_sym_AMP_AMP] = ACTIONS(5026),
    [anon_sym_AMP] = ACTIONS(5024),
    [anon_sym___extension__] = ACTIONS(5024),
    [anon_sym_typedef] = ACTIONS(5024),
    [anon_sym_extern] = ACTIONS(5024),
    [anon_sym___attribute__] = ACTIONS(5024),
    [anon_sym_COLON_COLON] = ACTIONS(5026),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5026),
    [anon_sym___declspec] = ACTIONS(5024),
    [anon_sym___based] = ACTIONS(5024),
    [anon_sym_signed] = ACTIONS(5024),
    [anon_sym_unsigned] = ACTIONS(5024),
    [anon_sym_long] = ACTIONS(5024),
    [anon_sym_short] = ACTIONS(5024),
    [anon_sym_LBRACK] = ACTIONS(5024),
    [anon_sym_static] = ACTIONS(5024),
    [anon_sym_register] = ACTIONS(5024),
    [anon_sym_inline] = ACTIONS(5024),
    [anon_sym___inline] = ACTIONS(5024),
    [anon_sym___inline__] = ACTIONS(5024),
    [anon_sym___forceinline] = ACTIONS(5024),
    [anon_sym_thread_local] = ACTIONS(5024),
    [anon_sym___thread] = ACTIONS(5024),
    [anon_sym_const] = ACTIONS(5024),
    [anon_sym_constexpr] = ACTIONS(5024),
    [anon_sym_volatile] = ACTIONS(5024),
    [anon_sym_restrict] = ACTIONS(5024),
    [anon_sym___restrict__] = ACTIONS(5024),
    [anon_sym__Atomic] = ACTIONS(5024),
    [anon_sym__Noreturn] = ACTIONS(5024),
    [anon_sym_noreturn] = ACTIONS(5024),
    [anon_sym_mutable] = ACTIONS(5024),
    [anon_sym_constinit] = ACTIONS(5024),
    [anon_sym_consteval] = ACTIONS(5024),
    [anon_sym_PROGMEM] = ACTIONS(5024),
    [aux_sym_primitive_type_token1] = ACTIONS(5024),
    [anon_sym_byte] = ACTIONS(5024),
    [anon_sym_word] = ACTIONS(5024),
    [anon_sym_enum] = ACTIONS(5024),
    [anon_sym_class] = ACTIONS(5024),
    [anon_sym_struct] = ACTIONS(5024),
    [anon_sym_union] = ACTIONS(5024),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5024),
    [anon_sym_decltype] = ACTIONS(5024),
    [anon_sym_virtual] = ACTIONS(5024),
    [anon_sym_alignas] = ACTIONS(5024),
    [anon_sym_explicit] = ACTIONS(5024),
    [anon_sym_typename] = ACTIONS(5024),
    [anon_sym_template] = ACTIONS(5024),
    [anon_sym_operator] = ACTIONS(5024),
    [anon_sym_friend] = ACTIONS(5024),
    [anon_sym_public] = ACTIONS(5024),
    [anon_sym_private] = ACTIONS(5024),
    [anon_sym_protected] = ACTIONS(5024),
    [anon_sym_using] = ACTIONS(5024),
    [anon_sym_static_assert] = ACTIONS(5024),
  },
  [1936] = {
    [sym_identifier] = ACTIONS(5020),
    [aux_sym_preproc_def_token1] = ACTIONS(5020),
    [aux_sym_preproc_if_token1] = ACTIONS(5020),
    [aux_sym_preproc_if_token2] = ACTIONS(5020),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5020),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5020),
    [aux_sym_preproc_else_token1] = ACTIONS(5020),
    [aux_sym_preproc_elif_token1] = ACTIONS(5020),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5020),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5020),
    [sym_preproc_directive] = ACTIONS(5020),
    [anon_sym_LPAREN2] = ACTIONS(5022),
    [anon_sym_TILDE] = ACTIONS(5022),
    [anon_sym_STAR] = ACTIONS(5022),
    [anon_sym_AMP_AMP] = ACTIONS(5022),
    [anon_sym_AMP] = ACTIONS(5020),
    [anon_sym___extension__] = ACTIONS(5020),
    [anon_sym_typedef] = ACTIONS(5020),
    [anon_sym_extern] = ACTIONS(5020),
    [anon_sym___attribute__] = ACTIONS(5020),
    [anon_sym_COLON_COLON] = ACTIONS(5022),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5022),
    [anon_sym___declspec] = ACTIONS(5020),
    [anon_sym___based] = ACTIONS(5020),
    [anon_sym_signed] = ACTIONS(5020),
    [anon_sym_unsigned] = ACTIONS(5020),
    [anon_sym_long] = ACTIONS(5020),
    [anon_sym_short] = ACTIONS(5020),
    [anon_sym_LBRACK] = ACTIONS(5020),
    [anon_sym_static] = ACTIONS(5020),
    [anon_sym_register] = ACTIONS(5020),
    [anon_sym_inline] = ACTIONS(5020),
    [anon_sym___inline] = ACTIONS(5020),
    [anon_sym___inline__] = ACTIONS(5020),
    [anon_sym___forceinline] = ACTIONS(5020),
    [anon_sym_thread_local] = ACTIONS(5020),
    [anon_sym___thread] = ACTIONS(5020),
    [anon_sym_const] = ACTIONS(5020),
    [anon_sym_constexpr] = ACTIONS(5020),
    [anon_sym_volatile] = ACTIONS(5020),
    [anon_sym_restrict] = ACTIONS(5020),
    [anon_sym___restrict__] = ACTIONS(5020),
    [anon_sym__Atomic] = ACTIONS(5020),
    [anon_sym__Noreturn] = ACTIONS(5020),
    [anon_sym_noreturn] = ACTIONS(5020),
    [anon_sym_mutable] = ACTIONS(5020),
    [anon_sym_constinit] = ACTIONS(5020),
    [anon_sym_consteval] = ACTIONS(5020),
    [anon_sym_PROGMEM] = ACTIONS(5020),
    [aux_sym_primitive_type_token1] = ACTIONS(5020),
    [anon_sym_byte] = ACTIONS(5020),
    [anon_sym_word] = ACTIONS(5020),
    [anon_sym_enum] = ACTIONS(5020),
    [anon_sym_class] = ACTIONS(5020),
    [anon_sym_struct] = ACTIONS(5020),
    [anon_sym_union] = ACTIONS(5020),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5020),
    [anon_sym_decltype] = ACTIONS(5020),
    [anon_sym_virtual] = ACTIONS(5020),
    [anon_sym_alignas] = ACTIONS(5020),
    [anon_sym_explicit] = ACTIONS(5020),
    [anon_sym_typename] = ACTIONS(5020),
    [anon_sym_template] = ACTIONS(5020),
    [anon_sym_operator] = ACTIONS(5020),
    [anon_sym_friend] = ACTIONS(5020),
    [anon_sym_public] = ACTIONS(5020),
    [anon_sym_private] = ACTIONS(5020),
    [anon_sym_protected] = ACTIONS(5020),
    [anon_sym_using] = ACTIONS(5020),
    [anon_sym_static_assert] = ACTIONS(5020),
  },
  [1937] = {
    [sym_catch_clause] = STATE(1985),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1985),
    [sym_identifier] = ACTIONS(2482),
    [aux_sym_preproc_def_token1] = ACTIONS(2482),
    [aux_sym_preproc_if_token1] = ACTIONS(2482),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2482),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2482),
    [sym_preproc_directive] = ACTIONS(2482),
    [anon_sym_LPAREN2] = ACTIONS(2484),
    [anon_sym_TILDE] = ACTIONS(2484),
    [anon_sym_STAR] = ACTIONS(2484),
    [anon_sym_AMP_AMP] = ACTIONS(2484),
    [anon_sym_AMP] = ACTIONS(2482),
    [anon_sym___extension__] = ACTIONS(2482),
    [anon_sym_typedef] = ACTIONS(2482),
    [anon_sym_extern] = ACTIONS(2482),
    [anon_sym___attribute__] = ACTIONS(2482),
    [anon_sym_COLON_COLON] = ACTIONS(2484),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2484),
    [anon_sym___declspec] = ACTIONS(2482),
    [anon_sym___based] = ACTIONS(2482),
    [anon_sym_RBRACE] = ACTIONS(2484),
    [anon_sym_signed] = ACTIONS(2482),
    [anon_sym_unsigned] = ACTIONS(2482),
    [anon_sym_long] = ACTIONS(2482),
    [anon_sym_short] = ACTIONS(2482),
    [anon_sym_LBRACK] = ACTIONS(2482),
    [anon_sym_static] = ACTIONS(2482),
    [anon_sym_register] = ACTIONS(2482),
    [anon_sym_inline] = ACTIONS(2482),
    [anon_sym___inline] = ACTIONS(2482),
    [anon_sym___inline__] = ACTIONS(2482),
    [anon_sym___forceinline] = ACTIONS(2482),
    [anon_sym_thread_local] = ACTIONS(2482),
    [anon_sym___thread] = ACTIONS(2482),
    [anon_sym_const] = ACTIONS(2482),
    [anon_sym_constexpr] = ACTIONS(2482),
    [anon_sym_volatile] = ACTIONS(2482),
    [anon_sym_restrict] = ACTIONS(2482),
    [anon_sym___restrict__] = ACTIONS(2482),
    [anon_sym__Atomic] = ACTIONS(2482),
    [anon_sym__Noreturn] = ACTIONS(2482),
    [anon_sym_noreturn] = ACTIONS(2482),
    [anon_sym_mutable] = ACTIONS(2482),
    [anon_sym_constinit] = ACTIONS(2482),
    [anon_sym_consteval] = ACTIONS(2482),
    [anon_sym_PROGMEM] = ACTIONS(2482),
    [aux_sym_primitive_type_token1] = ACTIONS(2482),
    [anon_sym_byte] = ACTIONS(2482),
    [anon_sym_word] = ACTIONS(2482),
    [anon_sym_enum] = ACTIONS(2482),
    [anon_sym_class] = ACTIONS(2482),
    [anon_sym_struct] = ACTIONS(2482),
    [anon_sym_union] = ACTIONS(2482),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2482),
    [anon_sym_decltype] = ACTIONS(2482),
    [anon_sym_virtual] = ACTIONS(2482),
    [anon_sym_alignas] = ACTIONS(2482),
    [anon_sym_explicit] = ACTIONS(2482),
    [anon_sym_typename] = ACTIONS(2482),
    [anon_sym_template] = ACTIONS(2482),
    [anon_sym_operator] = ACTIONS(2482),
    [anon_sym_friend] = ACTIONS(2482),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_using] = ACTIONS(2482),
    [anon_sym_static_assert] = ACTIONS(2482),
    [anon_sym_catch] = ACTIONS(5028),
  },
  [1938] = {
    [sym_identifier] = ACTIONS(5030),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5032),
    [anon_sym_COMMA] = ACTIONS(5032),
    [anon_sym_RPAREN] = ACTIONS(5032),
    [anon_sym_LPAREN2] = ACTIONS(5032),
    [anon_sym_DASH] = ACTIONS(5030),
    [anon_sym_PLUS] = ACTIONS(5030),
    [anon_sym_STAR] = ACTIONS(5032),
    [anon_sym_SLASH] = ACTIONS(5030),
    [anon_sym_PERCENT] = ACTIONS(5032),
    [anon_sym_PIPE_PIPE] = ACTIONS(5032),
    [anon_sym_AMP_AMP] = ACTIONS(5032),
    [anon_sym_PIPE] = ACTIONS(5030),
    [anon_sym_CARET] = ACTIONS(5032),
    [anon_sym_AMP] = ACTIONS(5030),
    [anon_sym_EQ_EQ] = ACTIONS(5032),
    [anon_sym_BANG_EQ] = ACTIONS(5032),
    [anon_sym_GT] = ACTIONS(5030),
    [anon_sym_GT_EQ] = ACTIONS(5032),
    [anon_sym_LT_EQ] = ACTIONS(5030),
    [anon_sym_LT] = ACTIONS(5030),
    [anon_sym_LT_LT] = ACTIONS(5032),
    [anon_sym_GT_GT] = ACTIONS(5032),
    [anon_sym_SEMI] = ACTIONS(5032),
    [anon_sym___extension__] = ACTIONS(5030),
    [anon_sym___attribute__] = ACTIONS(5030),
    [anon_sym___based] = ACTIONS(5030),
    [anon_sym_LBRACE] = ACTIONS(5032),
    [anon_sym_RBRACE] = ACTIONS(5032),
    [anon_sym_signed] = ACTIONS(5030),
    [anon_sym_unsigned] = ACTIONS(5030),
    [anon_sym_long] = ACTIONS(5030),
    [anon_sym_short] = ACTIONS(5030),
    [anon_sym_LBRACK] = ACTIONS(5032),
    [anon_sym_RBRACK] = ACTIONS(5032),
    [anon_sym_const] = ACTIONS(5030),
    [anon_sym_constexpr] = ACTIONS(5030),
    [anon_sym_volatile] = ACTIONS(5030),
    [anon_sym_restrict] = ACTIONS(5030),
    [anon_sym___restrict__] = ACTIONS(5030),
    [anon_sym__Atomic] = ACTIONS(5030),
    [anon_sym__Noreturn] = ACTIONS(5030),
    [anon_sym_noreturn] = ACTIONS(5030),
    [anon_sym_mutable] = ACTIONS(5030),
    [anon_sym_constinit] = ACTIONS(5030),
    [anon_sym_consteval] = ACTIONS(5030),
    [anon_sym_PROGMEM] = ACTIONS(5030),
    [aux_sym_primitive_type_token1] = ACTIONS(5030),
    [anon_sym_byte] = ACTIONS(5030),
    [anon_sym_word] = ACTIONS(5030),
    [anon_sym_COLON] = ACTIONS(5032),
    [anon_sym_QMARK] = ACTIONS(5032),
    [anon_sym_LT_EQ_GT] = ACTIONS(5032),
    [anon_sym_or] = ACTIONS(5030),
    [anon_sym_and] = ACTIONS(5030),
    [anon_sym_bitor] = ACTIONS(5030),
    [anon_sym_xor] = ACTIONS(5030),
    [anon_sym_bitand] = ACTIONS(5030),
    [anon_sym_not_eq] = ACTIONS(5030),
    [anon_sym_DASH_DASH] = ACTIONS(5032),
    [anon_sym_PLUS_PLUS] = ACTIONS(5032),
    [anon_sym_DOT] = ACTIONS(5030),
    [anon_sym_DOT_STAR] = ACTIONS(5032),
    [anon_sym_DASH_GT] = ACTIONS(5032),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5030),
    [anon_sym_decltype] = ACTIONS(5030),
    [anon_sym_final] = ACTIONS(5030),
    [anon_sym_override] = ACTIONS(5030),
    [anon_sym_requires] = ACTIONS(5030),
  },
  [1939] = {
    [sym_identifier] = ACTIONS(5034),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5036),
    [anon_sym_COMMA] = ACTIONS(5036),
    [anon_sym_RPAREN] = ACTIONS(5036),
    [anon_sym_LPAREN2] = ACTIONS(5036),
    [anon_sym_DASH] = ACTIONS(5034),
    [anon_sym_PLUS] = ACTIONS(5034),
    [anon_sym_STAR] = ACTIONS(5036),
    [anon_sym_SLASH] = ACTIONS(5034),
    [anon_sym_PERCENT] = ACTIONS(5036),
    [anon_sym_PIPE_PIPE] = ACTIONS(5036),
    [anon_sym_AMP_AMP] = ACTIONS(5036),
    [anon_sym_PIPE] = ACTIONS(5034),
    [anon_sym_CARET] = ACTIONS(5036),
    [anon_sym_AMP] = ACTIONS(5034),
    [anon_sym_EQ_EQ] = ACTIONS(5036),
    [anon_sym_BANG_EQ] = ACTIONS(5036),
    [anon_sym_GT] = ACTIONS(5034),
    [anon_sym_GT_EQ] = ACTIONS(5036),
    [anon_sym_LT_EQ] = ACTIONS(5034),
    [anon_sym_LT] = ACTIONS(5034),
    [anon_sym_LT_LT] = ACTIONS(5036),
    [anon_sym_GT_GT] = ACTIONS(5036),
    [anon_sym_SEMI] = ACTIONS(5036),
    [anon_sym___extension__] = ACTIONS(5034),
    [anon_sym___attribute__] = ACTIONS(5034),
    [anon_sym___based] = ACTIONS(5034),
    [anon_sym_LBRACE] = ACTIONS(5036),
    [anon_sym_RBRACE] = ACTIONS(5036),
    [anon_sym_signed] = ACTIONS(5034),
    [anon_sym_unsigned] = ACTIONS(5034),
    [anon_sym_long] = ACTIONS(5034),
    [anon_sym_short] = ACTIONS(5034),
    [anon_sym_LBRACK] = ACTIONS(5036),
    [anon_sym_RBRACK] = ACTIONS(5036),
    [anon_sym_const] = ACTIONS(5034),
    [anon_sym_constexpr] = ACTIONS(5034),
    [anon_sym_volatile] = ACTIONS(5034),
    [anon_sym_restrict] = ACTIONS(5034),
    [anon_sym___restrict__] = ACTIONS(5034),
    [anon_sym__Atomic] = ACTIONS(5034),
    [anon_sym__Noreturn] = ACTIONS(5034),
    [anon_sym_noreturn] = ACTIONS(5034),
    [anon_sym_mutable] = ACTIONS(5034),
    [anon_sym_constinit] = ACTIONS(5034),
    [anon_sym_consteval] = ACTIONS(5034),
    [anon_sym_PROGMEM] = ACTIONS(5034),
    [aux_sym_primitive_type_token1] = ACTIONS(5034),
    [anon_sym_byte] = ACTIONS(5034),
    [anon_sym_word] = ACTIONS(5034),
    [anon_sym_COLON] = ACTIONS(5036),
    [anon_sym_QMARK] = ACTIONS(5036),
    [anon_sym_LT_EQ_GT] = ACTIONS(5036),
    [anon_sym_or] = ACTIONS(5034),
    [anon_sym_and] = ACTIONS(5034),
    [anon_sym_bitor] = ACTIONS(5034),
    [anon_sym_xor] = ACTIONS(5034),
    [anon_sym_bitand] = ACTIONS(5034),
    [anon_sym_not_eq] = ACTIONS(5034),
    [anon_sym_DASH_DASH] = ACTIONS(5036),
    [anon_sym_PLUS_PLUS] = ACTIONS(5036),
    [anon_sym_DOT] = ACTIONS(5034),
    [anon_sym_DOT_STAR] = ACTIONS(5036),
    [anon_sym_DASH_GT] = ACTIONS(5036),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5034),
    [anon_sym_decltype] = ACTIONS(5034),
    [anon_sym_final] = ACTIONS(5034),
    [anon_sym_override] = ACTIONS(5034),
    [anon_sym_requires] = ACTIONS(5034),
  },
  [1940] = {
    [sym_identifier] = ACTIONS(5038),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5040),
    [anon_sym_COMMA] = ACTIONS(5040),
    [anon_sym_RPAREN] = ACTIONS(5040),
    [anon_sym_LPAREN2] = ACTIONS(5040),
    [anon_sym_DASH] = ACTIONS(5038),
    [anon_sym_PLUS] = ACTIONS(5038),
    [anon_sym_STAR] = ACTIONS(5040),
    [anon_sym_SLASH] = ACTIONS(5038),
    [anon_sym_PERCENT] = ACTIONS(5040),
    [anon_sym_PIPE_PIPE] = ACTIONS(5040),
    [anon_sym_AMP_AMP] = ACTIONS(5040),
    [anon_sym_PIPE] = ACTIONS(5038),
    [anon_sym_CARET] = ACTIONS(5040),
    [anon_sym_AMP] = ACTIONS(5038),
    [anon_sym_EQ_EQ] = ACTIONS(5040),
    [anon_sym_BANG_EQ] = ACTIONS(5040),
    [anon_sym_GT] = ACTIONS(5038),
    [anon_sym_GT_EQ] = ACTIONS(5040),
    [anon_sym_LT_EQ] = ACTIONS(5038),
    [anon_sym_LT] = ACTIONS(5038),
    [anon_sym_LT_LT] = ACTIONS(5040),
    [anon_sym_GT_GT] = ACTIONS(5040),
    [anon_sym_SEMI] = ACTIONS(5040),
    [anon_sym___extension__] = ACTIONS(5038),
    [anon_sym___attribute__] = ACTIONS(5038),
    [anon_sym___based] = ACTIONS(5038),
    [anon_sym_LBRACE] = ACTIONS(5040),
    [anon_sym_RBRACE] = ACTIONS(5040),
    [anon_sym_signed] = ACTIONS(5038),
    [anon_sym_unsigned] = ACTIONS(5038),
    [anon_sym_long] = ACTIONS(5038),
    [anon_sym_short] = ACTIONS(5038),
    [anon_sym_LBRACK] = ACTIONS(5040),
    [anon_sym_RBRACK] = ACTIONS(5040),
    [anon_sym_const] = ACTIONS(5038),
    [anon_sym_constexpr] = ACTIONS(5038),
    [anon_sym_volatile] = ACTIONS(5038),
    [anon_sym_restrict] = ACTIONS(5038),
    [anon_sym___restrict__] = ACTIONS(5038),
    [anon_sym__Atomic] = ACTIONS(5038),
    [anon_sym__Noreturn] = ACTIONS(5038),
    [anon_sym_noreturn] = ACTIONS(5038),
    [anon_sym_mutable] = ACTIONS(5038),
    [anon_sym_constinit] = ACTIONS(5038),
    [anon_sym_consteval] = ACTIONS(5038),
    [anon_sym_PROGMEM] = ACTIONS(5038),
    [aux_sym_primitive_type_token1] = ACTIONS(5038),
    [anon_sym_byte] = ACTIONS(5038),
    [anon_sym_word] = ACTIONS(5038),
    [anon_sym_COLON] = ACTIONS(5040),
    [anon_sym_QMARK] = ACTIONS(5040),
    [anon_sym_LT_EQ_GT] = ACTIONS(5040),
    [anon_sym_or] = ACTIONS(5038),
    [anon_sym_and] = ACTIONS(5038),
    [anon_sym_bitor] = ACTIONS(5038),
    [anon_sym_xor] = ACTIONS(5038),
    [anon_sym_bitand] = ACTIONS(5038),
    [anon_sym_not_eq] = ACTIONS(5038),
    [anon_sym_DASH_DASH] = ACTIONS(5040),
    [anon_sym_PLUS_PLUS] = ACTIONS(5040),
    [anon_sym_DOT] = ACTIONS(5038),
    [anon_sym_DOT_STAR] = ACTIONS(5040),
    [anon_sym_DASH_GT] = ACTIONS(5040),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5038),
    [anon_sym_decltype] = ACTIONS(5038),
    [anon_sym_final] = ACTIONS(5038),
    [anon_sym_override] = ACTIONS(5038),
    [anon_sym_requires] = ACTIONS(5038),
  },
  [1941] = {
    [sym_identifier] = ACTIONS(5042),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5044),
    [anon_sym_COMMA] = ACTIONS(5044),
    [anon_sym_RPAREN] = ACTIONS(5044),
    [anon_sym_LPAREN2] = ACTIONS(5044),
    [anon_sym_DASH] = ACTIONS(5042),
    [anon_sym_PLUS] = ACTIONS(5042),
    [anon_sym_STAR] = ACTIONS(5044),
    [anon_sym_SLASH] = ACTIONS(5042),
    [anon_sym_PERCENT] = ACTIONS(5044),
    [anon_sym_PIPE_PIPE] = ACTIONS(5044),
    [anon_sym_AMP_AMP] = ACTIONS(5044),
    [anon_sym_PIPE] = ACTIONS(5042),
    [anon_sym_CARET] = ACTIONS(5044),
    [anon_sym_AMP] = ACTIONS(5042),
    [anon_sym_EQ_EQ] = ACTIONS(5044),
    [anon_sym_BANG_EQ] = ACTIONS(5044),
    [anon_sym_GT] = ACTIONS(5042),
    [anon_sym_GT_EQ] = ACTIONS(5044),
    [anon_sym_LT_EQ] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(5042),
    [anon_sym_LT_LT] = ACTIONS(5044),
    [anon_sym_GT_GT] = ACTIONS(5044),
    [anon_sym_SEMI] = ACTIONS(5044),
    [anon_sym___extension__] = ACTIONS(5042),
    [anon_sym___attribute__] = ACTIONS(5042),
    [anon_sym___based] = ACTIONS(5042),
    [anon_sym_LBRACE] = ACTIONS(5044),
    [anon_sym_RBRACE] = ACTIONS(5044),
    [anon_sym_signed] = ACTIONS(5042),
    [anon_sym_unsigned] = ACTIONS(5042),
    [anon_sym_long] = ACTIONS(5042),
    [anon_sym_short] = ACTIONS(5042),
    [anon_sym_LBRACK] = ACTIONS(5044),
    [anon_sym_RBRACK] = ACTIONS(5044),
    [anon_sym_const] = ACTIONS(5042),
    [anon_sym_constexpr] = ACTIONS(5042),
    [anon_sym_volatile] = ACTIONS(5042),
    [anon_sym_restrict] = ACTIONS(5042),
    [anon_sym___restrict__] = ACTIONS(5042),
    [anon_sym__Atomic] = ACTIONS(5042),
    [anon_sym__Noreturn] = ACTIONS(5042),
    [anon_sym_noreturn] = ACTIONS(5042),
    [anon_sym_mutable] = ACTIONS(5042),
    [anon_sym_constinit] = ACTIONS(5042),
    [anon_sym_consteval] = ACTIONS(5042),
    [anon_sym_PROGMEM] = ACTIONS(5042),
    [aux_sym_primitive_type_token1] = ACTIONS(5042),
    [anon_sym_byte] = ACTIONS(5042),
    [anon_sym_word] = ACTIONS(5042),
    [anon_sym_COLON] = ACTIONS(5044),
    [anon_sym_QMARK] = ACTIONS(5044),
    [anon_sym_LT_EQ_GT] = ACTIONS(5044),
    [anon_sym_or] = ACTIONS(5042),
    [anon_sym_and] = ACTIONS(5042),
    [anon_sym_bitor] = ACTIONS(5042),
    [anon_sym_xor] = ACTIONS(5042),
    [anon_sym_bitand] = ACTIONS(5042),
    [anon_sym_not_eq] = ACTIONS(5042),
    [anon_sym_DASH_DASH] = ACTIONS(5044),
    [anon_sym_PLUS_PLUS] = ACTIONS(5044),
    [anon_sym_DOT] = ACTIONS(5042),
    [anon_sym_DOT_STAR] = ACTIONS(5044),
    [anon_sym_DASH_GT] = ACTIONS(5044),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5042),
    [anon_sym_decltype] = ACTIONS(5042),
    [anon_sym_final] = ACTIONS(5042),
    [anon_sym_override] = ACTIONS(5042),
    [anon_sym_requires] = ACTIONS(5042),
  },
  [1942] = {
    [sym_identifier] = ACTIONS(5046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5048),
    [anon_sym_COMMA] = ACTIONS(5048),
    [anon_sym_RPAREN] = ACTIONS(5048),
    [anon_sym_LPAREN2] = ACTIONS(5048),
    [anon_sym_DASH] = ACTIONS(5046),
    [anon_sym_PLUS] = ACTIONS(5046),
    [anon_sym_STAR] = ACTIONS(5048),
    [anon_sym_SLASH] = ACTIONS(5046),
    [anon_sym_PERCENT] = ACTIONS(5048),
    [anon_sym_PIPE_PIPE] = ACTIONS(5048),
    [anon_sym_AMP_AMP] = ACTIONS(5048),
    [anon_sym_PIPE] = ACTIONS(5046),
    [anon_sym_CARET] = ACTIONS(5048),
    [anon_sym_AMP] = ACTIONS(5046),
    [anon_sym_EQ_EQ] = ACTIONS(5048),
    [anon_sym_BANG_EQ] = ACTIONS(5048),
    [anon_sym_GT] = ACTIONS(5046),
    [anon_sym_GT_EQ] = ACTIONS(5048),
    [anon_sym_LT_EQ] = ACTIONS(5046),
    [anon_sym_LT] = ACTIONS(5046),
    [anon_sym_LT_LT] = ACTIONS(5048),
    [anon_sym_GT_GT] = ACTIONS(5048),
    [anon_sym_SEMI] = ACTIONS(5048),
    [anon_sym___extension__] = ACTIONS(5046),
    [anon_sym___attribute__] = ACTIONS(5046),
    [anon_sym___based] = ACTIONS(5046),
    [anon_sym_LBRACE] = ACTIONS(5048),
    [anon_sym_RBRACE] = ACTIONS(5048),
    [anon_sym_signed] = ACTIONS(5046),
    [anon_sym_unsigned] = ACTIONS(5046),
    [anon_sym_long] = ACTIONS(5046),
    [anon_sym_short] = ACTIONS(5046),
    [anon_sym_LBRACK] = ACTIONS(5048),
    [anon_sym_RBRACK] = ACTIONS(5048),
    [anon_sym_const] = ACTIONS(5046),
    [anon_sym_constexpr] = ACTIONS(5046),
    [anon_sym_volatile] = ACTIONS(5046),
    [anon_sym_restrict] = ACTIONS(5046),
    [anon_sym___restrict__] = ACTIONS(5046),
    [anon_sym__Atomic] = ACTIONS(5046),
    [anon_sym__Noreturn] = ACTIONS(5046),
    [anon_sym_noreturn] = ACTIONS(5046),
    [anon_sym_mutable] = ACTIONS(5046),
    [anon_sym_constinit] = ACTIONS(5046),
    [anon_sym_consteval] = ACTIONS(5046),
    [anon_sym_PROGMEM] = ACTIONS(5046),
    [aux_sym_primitive_type_token1] = ACTIONS(5046),
    [anon_sym_byte] = ACTIONS(5046),
    [anon_sym_word] = ACTIONS(5046),
    [anon_sym_COLON] = ACTIONS(5048),
    [anon_sym_QMARK] = ACTIONS(5048),
    [anon_sym_LT_EQ_GT] = ACTIONS(5048),
    [anon_sym_or] = ACTIONS(5046),
    [anon_sym_and] = ACTIONS(5046),
    [anon_sym_bitor] = ACTIONS(5046),
    [anon_sym_xor] = ACTIONS(5046),
    [anon_sym_bitand] = ACTIONS(5046),
    [anon_sym_not_eq] = ACTIONS(5046),
    [anon_sym_DASH_DASH] = ACTIONS(5048),
    [anon_sym_PLUS_PLUS] = ACTIONS(5048),
    [anon_sym_DOT] = ACTIONS(5046),
    [anon_sym_DOT_STAR] = ACTIONS(5048),
    [anon_sym_DASH_GT] = ACTIONS(5048),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5046),
    [anon_sym_decltype] = ACTIONS(5046),
    [anon_sym_final] = ACTIONS(5046),
    [anon_sym_override] = ACTIONS(5046),
    [anon_sym_requires] = ACTIONS(5046),
  },
  [1943] = {
    [sym_identifier] = ACTIONS(5050),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5052),
    [anon_sym_COMMA] = ACTIONS(5052),
    [anon_sym_RPAREN] = ACTIONS(5052),
    [anon_sym_LPAREN2] = ACTIONS(5052),
    [anon_sym_DASH] = ACTIONS(5050),
    [anon_sym_PLUS] = ACTIONS(5050),
    [anon_sym_STAR] = ACTIONS(5052),
    [anon_sym_SLASH] = ACTIONS(5050),
    [anon_sym_PERCENT] = ACTIONS(5052),
    [anon_sym_PIPE_PIPE] = ACTIONS(5052),
    [anon_sym_AMP_AMP] = ACTIONS(5052),
    [anon_sym_PIPE] = ACTIONS(5050),
    [anon_sym_CARET] = ACTIONS(5052),
    [anon_sym_AMP] = ACTIONS(5050),
    [anon_sym_EQ_EQ] = ACTIONS(5052),
    [anon_sym_BANG_EQ] = ACTIONS(5052),
    [anon_sym_GT] = ACTIONS(5050),
    [anon_sym_GT_EQ] = ACTIONS(5052),
    [anon_sym_LT_EQ] = ACTIONS(5050),
    [anon_sym_LT] = ACTIONS(5050),
    [anon_sym_LT_LT] = ACTIONS(5052),
    [anon_sym_GT_GT] = ACTIONS(5052),
    [anon_sym_SEMI] = ACTIONS(5052),
    [anon_sym___extension__] = ACTIONS(5050),
    [anon_sym___attribute__] = ACTIONS(5050),
    [anon_sym___based] = ACTIONS(5050),
    [anon_sym_LBRACE] = ACTIONS(5052),
    [anon_sym_RBRACE] = ACTIONS(5052),
    [anon_sym_signed] = ACTIONS(5050),
    [anon_sym_unsigned] = ACTIONS(5050),
    [anon_sym_long] = ACTIONS(5050),
    [anon_sym_short] = ACTIONS(5050),
    [anon_sym_LBRACK] = ACTIONS(5052),
    [anon_sym_RBRACK] = ACTIONS(5052),
    [anon_sym_const] = ACTIONS(5050),
    [anon_sym_constexpr] = ACTIONS(5050),
    [anon_sym_volatile] = ACTIONS(5050),
    [anon_sym_restrict] = ACTIONS(5050),
    [anon_sym___restrict__] = ACTIONS(5050),
    [anon_sym__Atomic] = ACTIONS(5050),
    [anon_sym__Noreturn] = ACTIONS(5050),
    [anon_sym_noreturn] = ACTIONS(5050),
    [anon_sym_mutable] = ACTIONS(5050),
    [anon_sym_constinit] = ACTIONS(5050),
    [anon_sym_consteval] = ACTIONS(5050),
    [anon_sym_PROGMEM] = ACTIONS(5050),
    [aux_sym_primitive_type_token1] = ACTIONS(5050),
    [anon_sym_byte] = ACTIONS(5050),
    [anon_sym_word] = ACTIONS(5050),
    [anon_sym_COLON] = ACTIONS(5052),
    [anon_sym_QMARK] = ACTIONS(5052),
    [anon_sym_LT_EQ_GT] = ACTIONS(5052),
    [anon_sym_or] = ACTIONS(5050),
    [anon_sym_and] = ACTIONS(5050),
    [anon_sym_bitor] = ACTIONS(5050),
    [anon_sym_xor] = ACTIONS(5050),
    [anon_sym_bitand] = ACTIONS(5050),
    [anon_sym_not_eq] = ACTIONS(5050),
    [anon_sym_DASH_DASH] = ACTIONS(5052),
    [anon_sym_PLUS_PLUS] = ACTIONS(5052),
    [anon_sym_DOT] = ACTIONS(5050),
    [anon_sym_DOT_STAR] = ACTIONS(5052),
    [anon_sym_DASH_GT] = ACTIONS(5052),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5050),
    [anon_sym_decltype] = ACTIONS(5050),
    [anon_sym_final] = ACTIONS(5050),
    [anon_sym_override] = ACTIONS(5050),
    [anon_sym_requires] = ACTIONS(5050),
  },
  [1944] = {
    [sym_identifier] = ACTIONS(5054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5056),
    [anon_sym_COMMA] = ACTIONS(5056),
    [anon_sym_RPAREN] = ACTIONS(5056),
    [anon_sym_LPAREN2] = ACTIONS(5056),
    [anon_sym_DASH] = ACTIONS(5054),
    [anon_sym_PLUS] = ACTIONS(5054),
    [anon_sym_STAR] = ACTIONS(5056),
    [anon_sym_SLASH] = ACTIONS(5054),
    [anon_sym_PERCENT] = ACTIONS(5056),
    [anon_sym_PIPE_PIPE] = ACTIONS(5056),
    [anon_sym_AMP_AMP] = ACTIONS(5056),
    [anon_sym_PIPE] = ACTIONS(5054),
    [anon_sym_CARET] = ACTIONS(5056),
    [anon_sym_AMP] = ACTIONS(5054),
    [anon_sym_EQ_EQ] = ACTIONS(5056),
    [anon_sym_BANG_EQ] = ACTIONS(5056),
    [anon_sym_GT] = ACTIONS(5054),
    [anon_sym_GT_EQ] = ACTIONS(5056),
    [anon_sym_LT_EQ] = ACTIONS(5054),
    [anon_sym_LT] = ACTIONS(5054),
    [anon_sym_LT_LT] = ACTIONS(5056),
    [anon_sym_GT_GT] = ACTIONS(5056),
    [anon_sym_SEMI] = ACTIONS(5056),
    [anon_sym___extension__] = ACTIONS(5054),
    [anon_sym___attribute__] = ACTIONS(5054),
    [anon_sym___based] = ACTIONS(5054),
    [anon_sym_LBRACE] = ACTIONS(5056),
    [anon_sym_RBRACE] = ACTIONS(5056),
    [anon_sym_signed] = ACTIONS(5054),
    [anon_sym_unsigned] = ACTIONS(5054),
    [anon_sym_long] = ACTIONS(5054),
    [anon_sym_short] = ACTIONS(5054),
    [anon_sym_LBRACK] = ACTIONS(5056),
    [anon_sym_RBRACK] = ACTIONS(5056),
    [anon_sym_const] = ACTIONS(5054),
    [anon_sym_constexpr] = ACTIONS(5054),
    [anon_sym_volatile] = ACTIONS(5054),
    [anon_sym_restrict] = ACTIONS(5054),
    [anon_sym___restrict__] = ACTIONS(5054),
    [anon_sym__Atomic] = ACTIONS(5054),
    [anon_sym__Noreturn] = ACTIONS(5054),
    [anon_sym_noreturn] = ACTIONS(5054),
    [anon_sym_mutable] = ACTIONS(5054),
    [anon_sym_constinit] = ACTIONS(5054),
    [anon_sym_consteval] = ACTIONS(5054),
    [anon_sym_PROGMEM] = ACTIONS(5054),
    [aux_sym_primitive_type_token1] = ACTIONS(5054),
    [anon_sym_byte] = ACTIONS(5054),
    [anon_sym_word] = ACTIONS(5054),
    [anon_sym_COLON] = ACTIONS(5056),
    [anon_sym_QMARK] = ACTIONS(5056),
    [anon_sym_LT_EQ_GT] = ACTIONS(5056),
    [anon_sym_or] = ACTIONS(5054),
    [anon_sym_and] = ACTIONS(5054),
    [anon_sym_bitor] = ACTIONS(5054),
    [anon_sym_xor] = ACTIONS(5054),
    [anon_sym_bitand] = ACTIONS(5054),
    [anon_sym_not_eq] = ACTIONS(5054),
    [anon_sym_DASH_DASH] = ACTIONS(5056),
    [anon_sym_PLUS_PLUS] = ACTIONS(5056),
    [anon_sym_DOT] = ACTIONS(5054),
    [anon_sym_DOT_STAR] = ACTIONS(5056),
    [anon_sym_DASH_GT] = ACTIONS(5056),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5054),
    [anon_sym_decltype] = ACTIONS(5054),
    [anon_sym_final] = ACTIONS(5054),
    [anon_sym_override] = ACTIONS(5054),
    [anon_sym_requires] = ACTIONS(5054),
  },
  [1945] = {
    [sym_identifier] = ACTIONS(5058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5060),
    [anon_sym_COMMA] = ACTIONS(5060),
    [anon_sym_RPAREN] = ACTIONS(5060),
    [anon_sym_LPAREN2] = ACTIONS(5060),
    [anon_sym_DASH] = ACTIONS(5058),
    [anon_sym_PLUS] = ACTIONS(5058),
    [anon_sym_STAR] = ACTIONS(5060),
    [anon_sym_SLASH] = ACTIONS(5058),
    [anon_sym_PERCENT] = ACTIONS(5060),
    [anon_sym_PIPE_PIPE] = ACTIONS(5060),
    [anon_sym_AMP_AMP] = ACTIONS(5060),
    [anon_sym_PIPE] = ACTIONS(5058),
    [anon_sym_CARET] = ACTIONS(5060),
    [anon_sym_AMP] = ACTIONS(5058),
    [anon_sym_EQ_EQ] = ACTIONS(5060),
    [anon_sym_BANG_EQ] = ACTIONS(5060),
    [anon_sym_GT] = ACTIONS(5058),
    [anon_sym_GT_EQ] = ACTIONS(5060),
    [anon_sym_LT_EQ] = ACTIONS(5058),
    [anon_sym_LT] = ACTIONS(5058),
    [anon_sym_LT_LT] = ACTIONS(5060),
    [anon_sym_GT_GT] = ACTIONS(5060),
    [anon_sym_SEMI] = ACTIONS(5060),
    [anon_sym___extension__] = ACTIONS(5058),
    [anon_sym___attribute__] = ACTIONS(5058),
    [anon_sym___based] = ACTIONS(5058),
    [anon_sym_LBRACE] = ACTIONS(5060),
    [anon_sym_RBRACE] = ACTIONS(5060),
    [anon_sym_signed] = ACTIONS(5058),
    [anon_sym_unsigned] = ACTIONS(5058),
    [anon_sym_long] = ACTIONS(5058),
    [anon_sym_short] = ACTIONS(5058),
    [anon_sym_LBRACK] = ACTIONS(5060),
    [anon_sym_RBRACK] = ACTIONS(5060),
    [anon_sym_const] = ACTIONS(5058),
    [anon_sym_constexpr] = ACTIONS(5058),
    [anon_sym_volatile] = ACTIONS(5058),
    [anon_sym_restrict] = ACTIONS(5058),
    [anon_sym___restrict__] = ACTIONS(5058),
    [anon_sym__Atomic] = ACTIONS(5058),
    [anon_sym__Noreturn] = ACTIONS(5058),
    [anon_sym_noreturn] = ACTIONS(5058),
    [anon_sym_mutable] = ACTIONS(5058),
    [anon_sym_constinit] = ACTIONS(5058),
    [anon_sym_consteval] = ACTIONS(5058),
    [anon_sym_PROGMEM] = ACTIONS(5058),
    [aux_sym_primitive_type_token1] = ACTIONS(5058),
    [anon_sym_byte] = ACTIONS(5058),
    [anon_sym_word] = ACTIONS(5058),
    [anon_sym_COLON] = ACTIONS(5060),
    [anon_sym_QMARK] = ACTIONS(5060),
    [anon_sym_LT_EQ_GT] = ACTIONS(5060),
    [anon_sym_or] = ACTIONS(5058),
    [anon_sym_and] = ACTIONS(5058),
    [anon_sym_bitor] = ACTIONS(5058),
    [anon_sym_xor] = ACTIONS(5058),
    [anon_sym_bitand] = ACTIONS(5058),
    [anon_sym_not_eq] = ACTIONS(5058),
    [anon_sym_DASH_DASH] = ACTIONS(5060),
    [anon_sym_PLUS_PLUS] = ACTIONS(5060),
    [anon_sym_DOT] = ACTIONS(5058),
    [anon_sym_DOT_STAR] = ACTIONS(5060),
    [anon_sym_DASH_GT] = ACTIONS(5060),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5058),
    [anon_sym_decltype] = ACTIONS(5058),
    [anon_sym_final] = ACTIONS(5058),
    [anon_sym_override] = ACTIONS(5058),
    [anon_sym_requires] = ACTIONS(5058),
  },
  [1946] = {
    [sym_identifier] = ACTIONS(5050),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5052),
    [anon_sym_COMMA] = ACTIONS(5052),
    [anon_sym_RPAREN] = ACTIONS(5052),
    [anon_sym_LPAREN2] = ACTIONS(5052),
    [anon_sym_DASH] = ACTIONS(5050),
    [anon_sym_PLUS] = ACTIONS(5050),
    [anon_sym_STAR] = ACTIONS(5052),
    [anon_sym_SLASH] = ACTIONS(5050),
    [anon_sym_PERCENT] = ACTIONS(5052),
    [anon_sym_PIPE_PIPE] = ACTIONS(5052),
    [anon_sym_AMP_AMP] = ACTIONS(5052),
    [anon_sym_PIPE] = ACTIONS(5050),
    [anon_sym_CARET] = ACTIONS(5052),
    [anon_sym_AMP] = ACTIONS(5050),
    [anon_sym_EQ_EQ] = ACTIONS(5052),
    [anon_sym_BANG_EQ] = ACTIONS(5052),
    [anon_sym_GT] = ACTIONS(5050),
    [anon_sym_GT_EQ] = ACTIONS(5052),
    [anon_sym_LT_EQ] = ACTIONS(5050),
    [anon_sym_LT] = ACTIONS(5050),
    [anon_sym_LT_LT] = ACTIONS(5052),
    [anon_sym_GT_GT] = ACTIONS(5052),
    [anon_sym_SEMI] = ACTIONS(5052),
    [anon_sym___extension__] = ACTIONS(5050),
    [anon_sym___attribute__] = ACTIONS(5050),
    [anon_sym___based] = ACTIONS(5050),
    [anon_sym_LBRACE] = ACTIONS(5052),
    [anon_sym_RBRACE] = ACTIONS(5052),
    [anon_sym_signed] = ACTIONS(5050),
    [anon_sym_unsigned] = ACTIONS(5050),
    [anon_sym_long] = ACTIONS(5050),
    [anon_sym_short] = ACTIONS(5050),
    [anon_sym_LBRACK] = ACTIONS(5052),
    [anon_sym_RBRACK] = ACTIONS(5052),
    [anon_sym_const] = ACTIONS(5050),
    [anon_sym_constexpr] = ACTIONS(5050),
    [anon_sym_volatile] = ACTIONS(5050),
    [anon_sym_restrict] = ACTIONS(5050),
    [anon_sym___restrict__] = ACTIONS(5050),
    [anon_sym__Atomic] = ACTIONS(5050),
    [anon_sym__Noreturn] = ACTIONS(5050),
    [anon_sym_noreturn] = ACTIONS(5050),
    [anon_sym_mutable] = ACTIONS(5050),
    [anon_sym_constinit] = ACTIONS(5050),
    [anon_sym_consteval] = ACTIONS(5050),
    [anon_sym_PROGMEM] = ACTIONS(5050),
    [aux_sym_primitive_type_token1] = ACTIONS(5050),
    [anon_sym_byte] = ACTIONS(5050),
    [anon_sym_word] = ACTIONS(5050),
    [anon_sym_COLON] = ACTIONS(5052),
    [anon_sym_QMARK] = ACTIONS(5052),
    [anon_sym_LT_EQ_GT] = ACTIONS(5052),
    [anon_sym_or] = ACTIONS(5050),
    [anon_sym_and] = ACTIONS(5050),
    [anon_sym_bitor] = ACTIONS(5050),
    [anon_sym_xor] = ACTIONS(5050),
    [anon_sym_bitand] = ACTIONS(5050),
    [anon_sym_not_eq] = ACTIONS(5050),
    [anon_sym_DASH_DASH] = ACTIONS(5052),
    [anon_sym_PLUS_PLUS] = ACTIONS(5052),
    [anon_sym_DOT] = ACTIONS(5050),
    [anon_sym_DOT_STAR] = ACTIONS(5052),
    [anon_sym_DASH_GT] = ACTIONS(5052),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5050),
    [anon_sym_decltype] = ACTIONS(5050),
    [anon_sym_final] = ACTIONS(5050),
    [anon_sym_override] = ACTIONS(5050),
    [anon_sym_requires] = ACTIONS(5050),
  },
  [1947] = {
    [sym_identifier] = ACTIONS(5062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5064),
    [anon_sym_COMMA] = ACTIONS(5064),
    [anon_sym_RPAREN] = ACTIONS(5064),
    [anon_sym_LPAREN2] = ACTIONS(5064),
    [anon_sym_DASH] = ACTIONS(5062),
    [anon_sym_PLUS] = ACTIONS(5062),
    [anon_sym_STAR] = ACTIONS(5064),
    [anon_sym_SLASH] = ACTIONS(5062),
    [anon_sym_PERCENT] = ACTIONS(5064),
    [anon_sym_PIPE_PIPE] = ACTIONS(5064),
    [anon_sym_AMP_AMP] = ACTIONS(5064),
    [anon_sym_PIPE] = ACTIONS(5062),
    [anon_sym_CARET] = ACTIONS(5064),
    [anon_sym_AMP] = ACTIONS(5062),
    [anon_sym_EQ_EQ] = ACTIONS(5064),
    [anon_sym_BANG_EQ] = ACTIONS(5064),
    [anon_sym_GT] = ACTIONS(5062),
    [anon_sym_GT_EQ] = ACTIONS(5064),
    [anon_sym_LT_EQ] = ACTIONS(5062),
    [anon_sym_LT] = ACTIONS(5062),
    [anon_sym_LT_LT] = ACTIONS(5064),
    [anon_sym_GT_GT] = ACTIONS(5064),
    [anon_sym_SEMI] = ACTIONS(5064),
    [anon_sym___extension__] = ACTIONS(5062),
    [anon_sym___attribute__] = ACTIONS(5062),
    [anon_sym___based] = ACTIONS(5062),
    [anon_sym_LBRACE] = ACTIONS(5064),
    [anon_sym_RBRACE] = ACTIONS(5064),
    [anon_sym_signed] = ACTIONS(5062),
    [anon_sym_unsigned] = ACTIONS(5062),
    [anon_sym_long] = ACTIONS(5062),
    [anon_sym_short] = ACTIONS(5062),
    [anon_sym_LBRACK] = ACTIONS(5064),
    [anon_sym_RBRACK] = ACTIONS(5064),
    [anon_sym_const] = ACTIONS(5062),
    [anon_sym_constexpr] = ACTIONS(5062),
    [anon_sym_volatile] = ACTIONS(5062),
    [anon_sym_restrict] = ACTIONS(5062),
    [anon_sym___restrict__] = ACTIONS(5062),
    [anon_sym__Atomic] = ACTIONS(5062),
    [anon_sym__Noreturn] = ACTIONS(5062),
    [anon_sym_noreturn] = ACTIONS(5062),
    [anon_sym_mutable] = ACTIONS(5062),
    [anon_sym_constinit] = ACTIONS(5062),
    [anon_sym_consteval] = ACTIONS(5062),
    [anon_sym_PROGMEM] = ACTIONS(5062),
    [aux_sym_primitive_type_token1] = ACTIONS(5062),
    [anon_sym_byte] = ACTIONS(5062),
    [anon_sym_word] = ACTIONS(5062),
    [anon_sym_COLON] = ACTIONS(5064),
    [anon_sym_QMARK] = ACTIONS(5064),
    [anon_sym_LT_EQ_GT] = ACTIONS(5064),
    [anon_sym_or] = ACTIONS(5062),
    [anon_sym_and] = ACTIONS(5062),
    [anon_sym_bitor] = ACTIONS(5062),
    [anon_sym_xor] = ACTIONS(5062),
    [anon_sym_bitand] = ACTIONS(5062),
    [anon_sym_not_eq] = ACTIONS(5062),
    [anon_sym_DASH_DASH] = ACTIONS(5064),
    [anon_sym_PLUS_PLUS] = ACTIONS(5064),
    [anon_sym_DOT] = ACTIONS(5062),
    [anon_sym_DOT_STAR] = ACTIONS(5064),
    [anon_sym_DASH_GT] = ACTIONS(5064),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5062),
    [anon_sym_decltype] = ACTIONS(5062),
    [anon_sym_final] = ACTIONS(5062),
    [anon_sym_override] = ACTIONS(5062),
    [anon_sym_requires] = ACTIONS(5062),
  },
  [1948] = {
    [sym_identifier] = ACTIONS(5066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5068),
    [anon_sym_COMMA] = ACTIONS(5068),
    [anon_sym_RPAREN] = ACTIONS(5068),
    [anon_sym_LPAREN2] = ACTIONS(5068),
    [anon_sym_DASH] = ACTIONS(5066),
    [anon_sym_PLUS] = ACTIONS(5066),
    [anon_sym_STAR] = ACTIONS(5068),
    [anon_sym_SLASH] = ACTIONS(5066),
    [anon_sym_PERCENT] = ACTIONS(5068),
    [anon_sym_PIPE_PIPE] = ACTIONS(5068),
    [anon_sym_AMP_AMP] = ACTIONS(5068),
    [anon_sym_PIPE] = ACTIONS(5066),
    [anon_sym_CARET] = ACTIONS(5068),
    [anon_sym_AMP] = ACTIONS(5066),
    [anon_sym_EQ_EQ] = ACTIONS(5068),
    [anon_sym_BANG_EQ] = ACTIONS(5068),
    [anon_sym_GT] = ACTIONS(5066),
    [anon_sym_GT_EQ] = ACTIONS(5068),
    [anon_sym_LT_EQ] = ACTIONS(5066),
    [anon_sym_LT] = ACTIONS(5066),
    [anon_sym_LT_LT] = ACTIONS(5068),
    [anon_sym_GT_GT] = ACTIONS(5068),
    [anon_sym_SEMI] = ACTIONS(5068),
    [anon_sym___extension__] = ACTIONS(5066),
    [anon_sym___attribute__] = ACTIONS(5066),
    [anon_sym___based] = ACTIONS(5066),
    [anon_sym_LBRACE] = ACTIONS(5068),
    [anon_sym_RBRACE] = ACTIONS(5068),
    [anon_sym_signed] = ACTIONS(5066),
    [anon_sym_unsigned] = ACTIONS(5066),
    [anon_sym_long] = ACTIONS(5066),
    [anon_sym_short] = ACTIONS(5066),
    [anon_sym_LBRACK] = ACTIONS(5068),
    [anon_sym_RBRACK] = ACTIONS(5068),
    [anon_sym_const] = ACTIONS(5066),
    [anon_sym_constexpr] = ACTIONS(5066),
    [anon_sym_volatile] = ACTIONS(5066),
    [anon_sym_restrict] = ACTIONS(5066),
    [anon_sym___restrict__] = ACTIONS(5066),
    [anon_sym__Atomic] = ACTIONS(5066),
    [anon_sym__Noreturn] = ACTIONS(5066),
    [anon_sym_noreturn] = ACTIONS(5066),
    [anon_sym_mutable] = ACTIONS(5066),
    [anon_sym_constinit] = ACTIONS(5066),
    [anon_sym_consteval] = ACTIONS(5066),
    [anon_sym_PROGMEM] = ACTIONS(5066),
    [aux_sym_primitive_type_token1] = ACTIONS(5066),
    [anon_sym_byte] = ACTIONS(5066),
    [anon_sym_word] = ACTIONS(5066),
    [anon_sym_COLON] = ACTIONS(5068),
    [anon_sym_QMARK] = ACTIONS(5068),
    [anon_sym_LT_EQ_GT] = ACTIONS(5068),
    [anon_sym_or] = ACTIONS(5066),
    [anon_sym_and] = ACTIONS(5066),
    [anon_sym_bitor] = ACTIONS(5066),
    [anon_sym_xor] = ACTIONS(5066),
    [anon_sym_bitand] = ACTIONS(5066),
    [anon_sym_not_eq] = ACTIONS(5066),
    [anon_sym_DASH_DASH] = ACTIONS(5068),
    [anon_sym_PLUS_PLUS] = ACTIONS(5068),
    [anon_sym_DOT] = ACTIONS(5066),
    [anon_sym_DOT_STAR] = ACTIONS(5068),
    [anon_sym_DASH_GT] = ACTIONS(5068),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5066),
    [anon_sym_decltype] = ACTIONS(5066),
    [anon_sym_final] = ACTIONS(5066),
    [anon_sym_override] = ACTIONS(5066),
    [anon_sym_requires] = ACTIONS(5066),
  },
  [1949] = {
    [sym_identifier] = ACTIONS(5070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5072),
    [anon_sym_COMMA] = ACTIONS(5072),
    [anon_sym_RPAREN] = ACTIONS(5072),
    [anon_sym_LPAREN2] = ACTIONS(5072),
    [anon_sym_DASH] = ACTIONS(5070),
    [anon_sym_PLUS] = ACTIONS(5070),
    [anon_sym_STAR] = ACTIONS(5072),
    [anon_sym_SLASH] = ACTIONS(5070),
    [anon_sym_PERCENT] = ACTIONS(5072),
    [anon_sym_PIPE_PIPE] = ACTIONS(5072),
    [anon_sym_AMP_AMP] = ACTIONS(5072),
    [anon_sym_PIPE] = ACTIONS(5070),
    [anon_sym_CARET] = ACTIONS(5072),
    [anon_sym_AMP] = ACTIONS(5070),
    [anon_sym_EQ_EQ] = ACTIONS(5072),
    [anon_sym_BANG_EQ] = ACTIONS(5072),
    [anon_sym_GT] = ACTIONS(5070),
    [anon_sym_GT_EQ] = ACTIONS(5072),
    [anon_sym_LT_EQ] = ACTIONS(5070),
    [anon_sym_LT] = ACTIONS(5070),
    [anon_sym_LT_LT] = ACTIONS(5072),
    [anon_sym_GT_GT] = ACTIONS(5072),
    [anon_sym_SEMI] = ACTIONS(5072),
    [anon_sym___extension__] = ACTIONS(5070),
    [anon_sym___attribute__] = ACTIONS(5070),
    [anon_sym___based] = ACTIONS(5070),
    [anon_sym_LBRACE] = ACTIONS(5072),
    [anon_sym_RBRACE] = ACTIONS(5072),
    [anon_sym_signed] = ACTIONS(5070),
    [anon_sym_unsigned] = ACTIONS(5070),
    [anon_sym_long] = ACTIONS(5070),
    [anon_sym_short] = ACTIONS(5070),
    [anon_sym_LBRACK] = ACTIONS(5072),
    [anon_sym_RBRACK] = ACTIONS(5072),
    [anon_sym_const] = ACTIONS(5070),
    [anon_sym_constexpr] = ACTIONS(5070),
    [anon_sym_volatile] = ACTIONS(5070),
    [anon_sym_restrict] = ACTIONS(5070),
    [anon_sym___restrict__] = ACTIONS(5070),
    [anon_sym__Atomic] = ACTIONS(5070),
    [anon_sym__Noreturn] = ACTIONS(5070),
    [anon_sym_noreturn] = ACTIONS(5070),
    [anon_sym_mutable] = ACTIONS(5070),
    [anon_sym_constinit] = ACTIONS(5070),
    [anon_sym_consteval] = ACTIONS(5070),
    [anon_sym_PROGMEM] = ACTIONS(5070),
    [aux_sym_primitive_type_token1] = ACTIONS(5070),
    [anon_sym_byte] = ACTIONS(5070),
    [anon_sym_word] = ACTIONS(5070),
    [anon_sym_COLON] = ACTIONS(5072),
    [anon_sym_QMARK] = ACTIONS(5072),
    [anon_sym_LT_EQ_GT] = ACTIONS(5072),
    [anon_sym_or] = ACTIONS(5070),
    [anon_sym_and] = ACTIONS(5070),
    [anon_sym_bitor] = ACTIONS(5070),
    [anon_sym_xor] = ACTIONS(5070),
    [anon_sym_bitand] = ACTIONS(5070),
    [anon_sym_not_eq] = ACTIONS(5070),
    [anon_sym_DASH_DASH] = ACTIONS(5072),
    [anon_sym_PLUS_PLUS] = ACTIONS(5072),
    [anon_sym_DOT] = ACTIONS(5070),
    [anon_sym_DOT_STAR] = ACTIONS(5072),
    [anon_sym_DASH_GT] = ACTIONS(5072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5070),
    [anon_sym_decltype] = ACTIONS(5070),
    [anon_sym_final] = ACTIONS(5070),
    [anon_sym_override] = ACTIONS(5070),
    [anon_sym_requires] = ACTIONS(5070),
  },
  [1950] = {
    [sym_identifier] = ACTIONS(5074),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5076),
    [anon_sym_COMMA] = ACTIONS(5076),
    [anon_sym_RPAREN] = ACTIONS(5076),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_TILDE] = ACTIONS(5076),
    [anon_sym_STAR] = ACTIONS(5076),
    [anon_sym_AMP_AMP] = ACTIONS(5076),
    [anon_sym_AMP] = ACTIONS(5074),
    [anon_sym_SEMI] = ACTIONS(5076),
    [anon_sym___extension__] = ACTIONS(5074),
    [anon_sym_extern] = ACTIONS(5074),
    [anon_sym___attribute__] = ACTIONS(5074),
    [anon_sym_COLON_COLON] = ACTIONS(5076),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5076),
    [anon_sym___declspec] = ACTIONS(5074),
    [anon_sym___based] = ACTIONS(5074),
    [anon_sym_LBRACE] = ACTIONS(5076),
    [anon_sym_signed] = ACTIONS(5074),
    [anon_sym_unsigned] = ACTIONS(5074),
    [anon_sym_long] = ACTIONS(5074),
    [anon_sym_short] = ACTIONS(5074),
    [anon_sym_LBRACK] = ACTIONS(5074),
    [anon_sym_EQ] = ACTIONS(5076),
    [anon_sym_static] = ACTIONS(5074),
    [anon_sym_register] = ACTIONS(5074),
    [anon_sym_inline] = ACTIONS(5074),
    [anon_sym___inline] = ACTIONS(5074),
    [anon_sym___inline__] = ACTIONS(5074),
    [anon_sym___forceinline] = ACTIONS(5074),
    [anon_sym_thread_local] = ACTIONS(5074),
    [anon_sym___thread] = ACTIONS(5074),
    [anon_sym_const] = ACTIONS(5074),
    [anon_sym_constexpr] = ACTIONS(5074),
    [anon_sym_volatile] = ACTIONS(5074),
    [anon_sym_restrict] = ACTIONS(5074),
    [anon_sym___restrict__] = ACTIONS(5074),
    [anon_sym__Atomic] = ACTIONS(5074),
    [anon_sym__Noreturn] = ACTIONS(5074),
    [anon_sym_noreturn] = ACTIONS(5074),
    [anon_sym_mutable] = ACTIONS(5074),
    [anon_sym_constinit] = ACTIONS(5074),
    [anon_sym_consteval] = ACTIONS(5074),
    [anon_sym_PROGMEM] = ACTIONS(5074),
    [aux_sym_primitive_type_token1] = ACTIONS(5074),
    [anon_sym_byte] = ACTIONS(5074),
    [anon_sym_word] = ACTIONS(5074),
    [anon_sym_enum] = ACTIONS(5074),
    [anon_sym_class] = ACTIONS(5074),
    [anon_sym_struct] = ACTIONS(5074),
    [anon_sym_union] = ACTIONS(5074),
    [anon_sym_asm] = ACTIONS(5074),
    [anon_sym___asm__] = ACTIONS(5074),
    [anon_sym_DASH_GT] = ACTIONS(5076),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5074),
    [anon_sym_decltype] = ACTIONS(5074),
    [anon_sym_final] = ACTIONS(5074),
    [anon_sym_override] = ACTIONS(5074),
    [anon_sym_virtual] = ACTIONS(5074),
    [anon_sym_alignas] = ACTIONS(5074),
    [anon_sym_explicit] = ACTIONS(5074),
    [anon_sym_typename] = ACTIONS(5074),
    [anon_sym_template] = ACTIONS(5074),
    [anon_sym_GT2] = ACTIONS(5076),
    [anon_sym_operator] = ACTIONS(5074),
    [anon_sym_try] = ACTIONS(5074),
    [anon_sym_noexcept] = ACTIONS(5074),
    [anon_sym_throw] = ACTIONS(5074),
    [anon_sym_requires] = ACTIONS(5074),
  },
  [1951] = {
    [sym_identifier] = ACTIONS(5078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5080),
    [anon_sym_COMMA] = ACTIONS(5080),
    [anon_sym_RPAREN] = ACTIONS(5080),
    [anon_sym_LPAREN2] = ACTIONS(5080),
    [anon_sym_DASH] = ACTIONS(5078),
    [anon_sym_PLUS] = ACTIONS(5078),
    [anon_sym_STAR] = ACTIONS(5080),
    [anon_sym_SLASH] = ACTIONS(5078),
    [anon_sym_PERCENT] = ACTIONS(5080),
    [anon_sym_PIPE_PIPE] = ACTIONS(5080),
    [anon_sym_AMP_AMP] = ACTIONS(5080),
    [anon_sym_PIPE] = ACTIONS(5078),
    [anon_sym_CARET] = ACTIONS(5080),
    [anon_sym_AMP] = ACTIONS(5078),
    [anon_sym_EQ_EQ] = ACTIONS(5080),
    [anon_sym_BANG_EQ] = ACTIONS(5080),
    [anon_sym_GT] = ACTIONS(5078),
    [anon_sym_GT_EQ] = ACTIONS(5080),
    [anon_sym_LT_EQ] = ACTIONS(5078),
    [anon_sym_LT] = ACTIONS(5078),
    [anon_sym_LT_LT] = ACTIONS(5080),
    [anon_sym_GT_GT] = ACTIONS(5080),
    [anon_sym_SEMI] = ACTIONS(5080),
    [anon_sym___extension__] = ACTIONS(5078),
    [anon_sym___attribute__] = ACTIONS(5078),
    [anon_sym___based] = ACTIONS(5078),
    [anon_sym_LBRACE] = ACTIONS(5080),
    [anon_sym_RBRACE] = ACTIONS(5080),
    [anon_sym_signed] = ACTIONS(5078),
    [anon_sym_unsigned] = ACTIONS(5078),
    [anon_sym_long] = ACTIONS(5078),
    [anon_sym_short] = ACTIONS(5078),
    [anon_sym_LBRACK] = ACTIONS(5080),
    [anon_sym_RBRACK] = ACTIONS(5080),
    [anon_sym_const] = ACTIONS(5078),
    [anon_sym_constexpr] = ACTIONS(5078),
    [anon_sym_volatile] = ACTIONS(5078),
    [anon_sym_restrict] = ACTIONS(5078),
    [anon_sym___restrict__] = ACTIONS(5078),
    [anon_sym__Atomic] = ACTIONS(5078),
    [anon_sym__Noreturn] = ACTIONS(5078),
    [anon_sym_noreturn] = ACTIONS(5078),
    [anon_sym_mutable] = ACTIONS(5078),
    [anon_sym_constinit] = ACTIONS(5078),
    [anon_sym_consteval] = ACTIONS(5078),
    [anon_sym_PROGMEM] = ACTIONS(5078),
    [aux_sym_primitive_type_token1] = ACTIONS(5078),
    [anon_sym_byte] = ACTIONS(5078),
    [anon_sym_word] = ACTIONS(5078),
    [anon_sym_COLON] = ACTIONS(5080),
    [anon_sym_QMARK] = ACTIONS(5080),
    [anon_sym_LT_EQ_GT] = ACTIONS(5080),
    [anon_sym_or] = ACTIONS(5078),
    [anon_sym_and] = ACTIONS(5078),
    [anon_sym_bitor] = ACTIONS(5078),
    [anon_sym_xor] = ACTIONS(5078),
    [anon_sym_bitand] = ACTIONS(5078),
    [anon_sym_not_eq] = ACTIONS(5078),
    [anon_sym_DASH_DASH] = ACTIONS(5080),
    [anon_sym_PLUS_PLUS] = ACTIONS(5080),
    [anon_sym_DOT] = ACTIONS(5078),
    [anon_sym_DOT_STAR] = ACTIONS(5080),
    [anon_sym_DASH_GT] = ACTIONS(5080),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5078),
    [anon_sym_decltype] = ACTIONS(5078),
    [anon_sym_final] = ACTIONS(5078),
    [anon_sym_override] = ACTIONS(5078),
    [anon_sym_requires] = ACTIONS(5078),
  },
  [1952] = {
    [sym_catch_clause] = STATE(1952),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1952),
    [sym_identifier] = ACTIONS(2475),
    [aux_sym_preproc_def_token1] = ACTIONS(2475),
    [aux_sym_preproc_if_token1] = ACTIONS(2475),
    [aux_sym_preproc_if_token2] = ACTIONS(2475),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2475),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2475),
    [sym_preproc_directive] = ACTIONS(2475),
    [anon_sym_LPAREN2] = ACTIONS(2477),
    [anon_sym_TILDE] = ACTIONS(2477),
    [anon_sym_STAR] = ACTIONS(2477),
    [anon_sym_AMP_AMP] = ACTIONS(2477),
    [anon_sym_AMP] = ACTIONS(2475),
    [anon_sym___extension__] = ACTIONS(2475),
    [anon_sym_typedef] = ACTIONS(2475),
    [anon_sym_extern] = ACTIONS(2475),
    [anon_sym___attribute__] = ACTIONS(2475),
    [anon_sym_COLON_COLON] = ACTIONS(2477),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2477),
    [anon_sym___declspec] = ACTIONS(2475),
    [anon_sym___based] = ACTIONS(2475),
    [anon_sym_signed] = ACTIONS(2475),
    [anon_sym_unsigned] = ACTIONS(2475),
    [anon_sym_long] = ACTIONS(2475),
    [anon_sym_short] = ACTIONS(2475),
    [anon_sym_LBRACK] = ACTIONS(2475),
    [anon_sym_static] = ACTIONS(2475),
    [anon_sym_register] = ACTIONS(2475),
    [anon_sym_inline] = ACTIONS(2475),
    [anon_sym___inline] = ACTIONS(2475),
    [anon_sym___inline__] = ACTIONS(2475),
    [anon_sym___forceinline] = ACTIONS(2475),
    [anon_sym_thread_local] = ACTIONS(2475),
    [anon_sym___thread] = ACTIONS(2475),
    [anon_sym_const] = ACTIONS(2475),
    [anon_sym_constexpr] = ACTIONS(2475),
    [anon_sym_volatile] = ACTIONS(2475),
    [anon_sym_restrict] = ACTIONS(2475),
    [anon_sym___restrict__] = ACTIONS(2475),
    [anon_sym__Atomic] = ACTIONS(2475),
    [anon_sym__Noreturn] = ACTIONS(2475),
    [anon_sym_noreturn] = ACTIONS(2475),
    [anon_sym_mutable] = ACTIONS(2475),
    [anon_sym_constinit] = ACTIONS(2475),
    [anon_sym_consteval] = ACTIONS(2475),
    [anon_sym_PROGMEM] = ACTIONS(2475),
    [aux_sym_primitive_type_token1] = ACTIONS(2475),
    [anon_sym_byte] = ACTIONS(2475),
    [anon_sym_word] = ACTIONS(2475),
    [anon_sym_enum] = ACTIONS(2475),
    [anon_sym_class] = ACTIONS(2475),
    [anon_sym_struct] = ACTIONS(2475),
    [anon_sym_union] = ACTIONS(2475),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2475),
    [anon_sym_decltype] = ACTIONS(2475),
    [anon_sym_virtual] = ACTIONS(2475),
    [anon_sym_alignas] = ACTIONS(2475),
    [anon_sym_explicit] = ACTIONS(2475),
    [anon_sym_typename] = ACTIONS(2475),
    [anon_sym_template] = ACTIONS(2475),
    [anon_sym_operator] = ACTIONS(2475),
    [anon_sym_friend] = ACTIONS(2475),
    [anon_sym_public] = ACTIONS(2475),
    [anon_sym_private] = ACTIONS(2475),
    [anon_sym_protected] = ACTIONS(2475),
    [anon_sym_using] = ACTIONS(2475),
    [anon_sym_static_assert] = ACTIONS(2475),
    [anon_sym_catch] = ACTIONS(5082),
  },
  [1953] = {
    [sym_identifier] = ACTIONS(5085),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5087),
    [anon_sym_COMMA] = ACTIONS(5087),
    [anon_sym_RPAREN] = ACTIONS(5087),
    [anon_sym_LPAREN2] = ACTIONS(5087),
    [anon_sym_DASH] = ACTIONS(5085),
    [anon_sym_PLUS] = ACTIONS(5085),
    [anon_sym_STAR] = ACTIONS(5087),
    [anon_sym_SLASH] = ACTIONS(5085),
    [anon_sym_PERCENT] = ACTIONS(5087),
    [anon_sym_PIPE_PIPE] = ACTIONS(5087),
    [anon_sym_AMP_AMP] = ACTIONS(5087),
    [anon_sym_PIPE] = ACTIONS(5085),
    [anon_sym_CARET] = ACTIONS(5087),
    [anon_sym_AMP] = ACTIONS(5085),
    [anon_sym_EQ_EQ] = ACTIONS(5087),
    [anon_sym_BANG_EQ] = ACTIONS(5087),
    [anon_sym_GT] = ACTIONS(5085),
    [anon_sym_GT_EQ] = ACTIONS(5087),
    [anon_sym_LT_EQ] = ACTIONS(5085),
    [anon_sym_LT] = ACTIONS(5085),
    [anon_sym_LT_LT] = ACTIONS(5087),
    [anon_sym_GT_GT] = ACTIONS(5087),
    [anon_sym_SEMI] = ACTIONS(5087),
    [anon_sym___extension__] = ACTIONS(5085),
    [anon_sym___attribute__] = ACTIONS(5085),
    [anon_sym___based] = ACTIONS(5085),
    [anon_sym_LBRACE] = ACTIONS(5087),
    [anon_sym_RBRACE] = ACTIONS(5087),
    [anon_sym_signed] = ACTIONS(5085),
    [anon_sym_unsigned] = ACTIONS(5085),
    [anon_sym_long] = ACTIONS(5085),
    [anon_sym_short] = ACTIONS(5085),
    [anon_sym_LBRACK] = ACTIONS(5087),
    [anon_sym_RBRACK] = ACTIONS(5087),
    [anon_sym_const] = ACTIONS(5085),
    [anon_sym_constexpr] = ACTIONS(5085),
    [anon_sym_volatile] = ACTIONS(5085),
    [anon_sym_restrict] = ACTIONS(5085),
    [anon_sym___restrict__] = ACTIONS(5085),
    [anon_sym__Atomic] = ACTIONS(5085),
    [anon_sym__Noreturn] = ACTIONS(5085),
    [anon_sym_noreturn] = ACTIONS(5085),
    [anon_sym_mutable] = ACTIONS(5085),
    [anon_sym_constinit] = ACTIONS(5085),
    [anon_sym_consteval] = ACTIONS(5085),
    [anon_sym_PROGMEM] = ACTIONS(5085),
    [aux_sym_primitive_type_token1] = ACTIONS(5085),
    [anon_sym_byte] = ACTIONS(5085),
    [anon_sym_word] = ACTIONS(5085),
    [anon_sym_COLON] = ACTIONS(5087),
    [anon_sym_QMARK] = ACTIONS(5087),
    [anon_sym_LT_EQ_GT] = ACTIONS(5087),
    [anon_sym_or] = ACTIONS(5085),
    [anon_sym_and] = ACTIONS(5085),
    [anon_sym_bitor] = ACTIONS(5085),
    [anon_sym_xor] = ACTIONS(5085),
    [anon_sym_bitand] = ACTIONS(5085),
    [anon_sym_not_eq] = ACTIONS(5085),
    [anon_sym_DASH_DASH] = ACTIONS(5087),
    [anon_sym_PLUS_PLUS] = ACTIONS(5087),
    [anon_sym_DOT] = ACTIONS(5085),
    [anon_sym_DOT_STAR] = ACTIONS(5087),
    [anon_sym_DASH_GT] = ACTIONS(5087),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5085),
    [anon_sym_decltype] = ACTIONS(5085),
    [anon_sym_final] = ACTIONS(5085),
    [anon_sym_override] = ACTIONS(5085),
    [anon_sym_requires] = ACTIONS(5085),
  },
  [1954] = {
    [sym_identifier] = ACTIONS(5089),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5091),
    [anon_sym_COMMA] = ACTIONS(5091),
    [anon_sym_RPAREN] = ACTIONS(5091),
    [anon_sym_LPAREN2] = ACTIONS(5091),
    [anon_sym_DASH] = ACTIONS(5089),
    [anon_sym_PLUS] = ACTIONS(5089),
    [anon_sym_STAR] = ACTIONS(5091),
    [anon_sym_SLASH] = ACTIONS(5089),
    [anon_sym_PERCENT] = ACTIONS(5091),
    [anon_sym_PIPE_PIPE] = ACTIONS(5091),
    [anon_sym_AMP_AMP] = ACTIONS(5091),
    [anon_sym_PIPE] = ACTIONS(5089),
    [anon_sym_CARET] = ACTIONS(5091),
    [anon_sym_AMP] = ACTIONS(5089),
    [anon_sym_EQ_EQ] = ACTIONS(5091),
    [anon_sym_BANG_EQ] = ACTIONS(5091),
    [anon_sym_GT] = ACTIONS(5089),
    [anon_sym_GT_EQ] = ACTIONS(5091),
    [anon_sym_LT_EQ] = ACTIONS(5089),
    [anon_sym_LT] = ACTIONS(5089),
    [anon_sym_LT_LT] = ACTIONS(5091),
    [anon_sym_GT_GT] = ACTIONS(5091),
    [anon_sym_SEMI] = ACTIONS(5091),
    [anon_sym___extension__] = ACTIONS(5089),
    [anon_sym___attribute__] = ACTIONS(5089),
    [anon_sym___based] = ACTIONS(5089),
    [anon_sym_LBRACE] = ACTIONS(5091),
    [anon_sym_RBRACE] = ACTIONS(5091),
    [anon_sym_signed] = ACTIONS(5089),
    [anon_sym_unsigned] = ACTIONS(5089),
    [anon_sym_long] = ACTIONS(5089),
    [anon_sym_short] = ACTIONS(5089),
    [anon_sym_LBRACK] = ACTIONS(5091),
    [anon_sym_RBRACK] = ACTIONS(5091),
    [anon_sym_const] = ACTIONS(5089),
    [anon_sym_constexpr] = ACTIONS(5089),
    [anon_sym_volatile] = ACTIONS(5089),
    [anon_sym_restrict] = ACTIONS(5089),
    [anon_sym___restrict__] = ACTIONS(5089),
    [anon_sym__Atomic] = ACTIONS(5089),
    [anon_sym__Noreturn] = ACTIONS(5089),
    [anon_sym_noreturn] = ACTIONS(5089),
    [anon_sym_mutable] = ACTIONS(5089),
    [anon_sym_constinit] = ACTIONS(5089),
    [anon_sym_consteval] = ACTIONS(5089),
    [anon_sym_PROGMEM] = ACTIONS(5089),
    [aux_sym_primitive_type_token1] = ACTIONS(5089),
    [anon_sym_byte] = ACTIONS(5089),
    [anon_sym_word] = ACTIONS(5089),
    [anon_sym_COLON] = ACTIONS(5091),
    [anon_sym_QMARK] = ACTIONS(5091),
    [anon_sym_LT_EQ_GT] = ACTIONS(5091),
    [anon_sym_or] = ACTIONS(5089),
    [anon_sym_and] = ACTIONS(5089),
    [anon_sym_bitor] = ACTIONS(5089),
    [anon_sym_xor] = ACTIONS(5089),
    [anon_sym_bitand] = ACTIONS(5089),
    [anon_sym_not_eq] = ACTIONS(5089),
    [anon_sym_DASH_DASH] = ACTIONS(5091),
    [anon_sym_PLUS_PLUS] = ACTIONS(5091),
    [anon_sym_DOT] = ACTIONS(5089),
    [anon_sym_DOT_STAR] = ACTIONS(5091),
    [anon_sym_DASH_GT] = ACTIONS(5091),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5089),
    [anon_sym_decltype] = ACTIONS(5089),
    [anon_sym_final] = ACTIONS(5089),
    [anon_sym_override] = ACTIONS(5089),
    [anon_sym_requires] = ACTIONS(5089),
  },
  [1955] = {
    [sym_identifier] = ACTIONS(5093),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5095),
    [anon_sym_COMMA] = ACTIONS(5095),
    [anon_sym_RPAREN] = ACTIONS(5095),
    [anon_sym_LPAREN2] = ACTIONS(5095),
    [anon_sym_DASH] = ACTIONS(5093),
    [anon_sym_PLUS] = ACTIONS(5093),
    [anon_sym_STAR] = ACTIONS(5095),
    [anon_sym_SLASH] = ACTIONS(5093),
    [anon_sym_PERCENT] = ACTIONS(5095),
    [anon_sym_PIPE_PIPE] = ACTIONS(5095),
    [anon_sym_AMP_AMP] = ACTIONS(5095),
    [anon_sym_PIPE] = ACTIONS(5093),
    [anon_sym_CARET] = ACTIONS(5095),
    [anon_sym_AMP] = ACTIONS(5093),
    [anon_sym_EQ_EQ] = ACTIONS(5095),
    [anon_sym_BANG_EQ] = ACTIONS(5095),
    [anon_sym_GT] = ACTIONS(5093),
    [anon_sym_GT_EQ] = ACTIONS(5095),
    [anon_sym_LT_EQ] = ACTIONS(5093),
    [anon_sym_LT] = ACTIONS(5093),
    [anon_sym_LT_LT] = ACTIONS(5095),
    [anon_sym_GT_GT] = ACTIONS(5095),
    [anon_sym_SEMI] = ACTIONS(5095),
    [anon_sym___extension__] = ACTIONS(5093),
    [anon_sym___attribute__] = ACTIONS(5093),
    [anon_sym___based] = ACTIONS(5093),
    [anon_sym_LBRACE] = ACTIONS(5095),
    [anon_sym_RBRACE] = ACTIONS(5095),
    [anon_sym_signed] = ACTIONS(5093),
    [anon_sym_unsigned] = ACTIONS(5093),
    [anon_sym_long] = ACTIONS(5093),
    [anon_sym_short] = ACTIONS(5093),
    [anon_sym_LBRACK] = ACTIONS(5095),
    [anon_sym_RBRACK] = ACTIONS(5095),
    [anon_sym_const] = ACTIONS(5093),
    [anon_sym_constexpr] = ACTIONS(5093),
    [anon_sym_volatile] = ACTIONS(5093),
    [anon_sym_restrict] = ACTIONS(5093),
    [anon_sym___restrict__] = ACTIONS(5093),
    [anon_sym__Atomic] = ACTIONS(5093),
    [anon_sym__Noreturn] = ACTIONS(5093),
    [anon_sym_noreturn] = ACTIONS(5093),
    [anon_sym_mutable] = ACTIONS(5093),
    [anon_sym_constinit] = ACTIONS(5093),
    [anon_sym_consteval] = ACTIONS(5093),
    [anon_sym_PROGMEM] = ACTIONS(5093),
    [aux_sym_primitive_type_token1] = ACTIONS(5093),
    [anon_sym_byte] = ACTIONS(5093),
    [anon_sym_word] = ACTIONS(5093),
    [anon_sym_COLON] = ACTIONS(5095),
    [anon_sym_QMARK] = ACTIONS(5095),
    [anon_sym_LT_EQ_GT] = ACTIONS(5095),
    [anon_sym_or] = ACTIONS(5093),
    [anon_sym_and] = ACTIONS(5093),
    [anon_sym_bitor] = ACTIONS(5093),
    [anon_sym_xor] = ACTIONS(5093),
    [anon_sym_bitand] = ACTIONS(5093),
    [anon_sym_not_eq] = ACTIONS(5093),
    [anon_sym_DASH_DASH] = ACTIONS(5095),
    [anon_sym_PLUS_PLUS] = ACTIONS(5095),
    [anon_sym_DOT] = ACTIONS(5093),
    [anon_sym_DOT_STAR] = ACTIONS(5095),
    [anon_sym_DASH_GT] = ACTIONS(5095),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5093),
    [anon_sym_decltype] = ACTIONS(5093),
    [anon_sym_final] = ACTIONS(5093),
    [anon_sym_override] = ACTIONS(5093),
    [anon_sym_requires] = ACTIONS(5093),
  },
  [1956] = {
    [sym_identifier] = ACTIONS(5097),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5099),
    [anon_sym_COMMA] = ACTIONS(5099),
    [anon_sym_RPAREN] = ACTIONS(5099),
    [anon_sym_LPAREN2] = ACTIONS(5099),
    [anon_sym_DASH] = ACTIONS(5097),
    [anon_sym_PLUS] = ACTIONS(5097),
    [anon_sym_STAR] = ACTIONS(5099),
    [anon_sym_SLASH] = ACTIONS(5097),
    [anon_sym_PERCENT] = ACTIONS(5099),
    [anon_sym_PIPE_PIPE] = ACTIONS(5099),
    [anon_sym_AMP_AMP] = ACTIONS(5099),
    [anon_sym_PIPE] = ACTIONS(5097),
    [anon_sym_CARET] = ACTIONS(5099),
    [anon_sym_AMP] = ACTIONS(5097),
    [anon_sym_EQ_EQ] = ACTIONS(5099),
    [anon_sym_BANG_EQ] = ACTIONS(5099),
    [anon_sym_GT] = ACTIONS(5097),
    [anon_sym_GT_EQ] = ACTIONS(5099),
    [anon_sym_LT_EQ] = ACTIONS(5097),
    [anon_sym_LT] = ACTIONS(5097),
    [anon_sym_LT_LT] = ACTIONS(5099),
    [anon_sym_GT_GT] = ACTIONS(5099),
    [anon_sym_SEMI] = ACTIONS(5099),
    [anon_sym___extension__] = ACTIONS(5097),
    [anon_sym___attribute__] = ACTIONS(5097),
    [anon_sym___based] = ACTIONS(5097),
    [anon_sym_LBRACE] = ACTIONS(5099),
    [anon_sym_RBRACE] = ACTIONS(5099),
    [anon_sym_signed] = ACTIONS(5097),
    [anon_sym_unsigned] = ACTIONS(5097),
    [anon_sym_long] = ACTIONS(5097),
    [anon_sym_short] = ACTIONS(5097),
    [anon_sym_LBRACK] = ACTIONS(5099),
    [anon_sym_RBRACK] = ACTIONS(5099),
    [anon_sym_const] = ACTIONS(5097),
    [anon_sym_constexpr] = ACTIONS(5097),
    [anon_sym_volatile] = ACTIONS(5097),
    [anon_sym_restrict] = ACTIONS(5097),
    [anon_sym___restrict__] = ACTIONS(5097),
    [anon_sym__Atomic] = ACTIONS(5097),
    [anon_sym__Noreturn] = ACTIONS(5097),
    [anon_sym_noreturn] = ACTIONS(5097),
    [anon_sym_mutable] = ACTIONS(5097),
    [anon_sym_constinit] = ACTIONS(5097),
    [anon_sym_consteval] = ACTIONS(5097),
    [anon_sym_PROGMEM] = ACTIONS(5097),
    [aux_sym_primitive_type_token1] = ACTIONS(5097),
    [anon_sym_byte] = ACTIONS(5097),
    [anon_sym_word] = ACTIONS(5097),
    [anon_sym_COLON] = ACTIONS(5099),
    [anon_sym_QMARK] = ACTIONS(5099),
    [anon_sym_LT_EQ_GT] = ACTIONS(5099),
    [anon_sym_or] = ACTIONS(5097),
    [anon_sym_and] = ACTIONS(5097),
    [anon_sym_bitor] = ACTIONS(5097),
    [anon_sym_xor] = ACTIONS(5097),
    [anon_sym_bitand] = ACTIONS(5097),
    [anon_sym_not_eq] = ACTIONS(5097),
    [anon_sym_DASH_DASH] = ACTIONS(5099),
    [anon_sym_PLUS_PLUS] = ACTIONS(5099),
    [anon_sym_DOT] = ACTIONS(5097),
    [anon_sym_DOT_STAR] = ACTIONS(5099),
    [anon_sym_DASH_GT] = ACTIONS(5099),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5097),
    [anon_sym_decltype] = ACTIONS(5097),
    [anon_sym_final] = ACTIONS(5097),
    [anon_sym_override] = ACTIONS(5097),
    [anon_sym_requires] = ACTIONS(5097),
  },
  [1957] = {
    [sym_identifier] = ACTIONS(5101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5103),
    [anon_sym_COMMA] = ACTIONS(5103),
    [anon_sym_RPAREN] = ACTIONS(5103),
    [anon_sym_LPAREN2] = ACTIONS(5103),
    [anon_sym_DASH] = ACTIONS(5101),
    [anon_sym_PLUS] = ACTIONS(5101),
    [anon_sym_STAR] = ACTIONS(5103),
    [anon_sym_SLASH] = ACTIONS(5101),
    [anon_sym_PERCENT] = ACTIONS(5103),
    [anon_sym_PIPE_PIPE] = ACTIONS(5103),
    [anon_sym_AMP_AMP] = ACTIONS(5103),
    [anon_sym_PIPE] = ACTIONS(5101),
    [anon_sym_CARET] = ACTIONS(5103),
    [anon_sym_AMP] = ACTIONS(5101),
    [anon_sym_EQ_EQ] = ACTIONS(5103),
    [anon_sym_BANG_EQ] = ACTIONS(5103),
    [anon_sym_GT] = ACTIONS(5101),
    [anon_sym_GT_EQ] = ACTIONS(5103),
    [anon_sym_LT_EQ] = ACTIONS(5101),
    [anon_sym_LT] = ACTIONS(5101),
    [anon_sym_LT_LT] = ACTIONS(5103),
    [anon_sym_GT_GT] = ACTIONS(5103),
    [anon_sym_SEMI] = ACTIONS(5103),
    [anon_sym___extension__] = ACTIONS(5101),
    [anon_sym___attribute__] = ACTIONS(5101),
    [anon_sym___based] = ACTIONS(5101),
    [anon_sym_LBRACE] = ACTIONS(5103),
    [anon_sym_RBRACE] = ACTIONS(5103),
    [anon_sym_signed] = ACTIONS(5101),
    [anon_sym_unsigned] = ACTIONS(5101),
    [anon_sym_long] = ACTIONS(5101),
    [anon_sym_short] = ACTIONS(5101),
    [anon_sym_LBRACK] = ACTIONS(5103),
    [anon_sym_RBRACK] = ACTIONS(5103),
    [anon_sym_const] = ACTIONS(5101),
    [anon_sym_constexpr] = ACTIONS(5101),
    [anon_sym_volatile] = ACTIONS(5101),
    [anon_sym_restrict] = ACTIONS(5101),
    [anon_sym___restrict__] = ACTIONS(5101),
    [anon_sym__Atomic] = ACTIONS(5101),
    [anon_sym__Noreturn] = ACTIONS(5101),
    [anon_sym_noreturn] = ACTIONS(5101),
    [anon_sym_mutable] = ACTIONS(5101),
    [anon_sym_constinit] = ACTIONS(5101),
    [anon_sym_consteval] = ACTIONS(5101),
    [anon_sym_PROGMEM] = ACTIONS(5101),
    [aux_sym_primitive_type_token1] = ACTIONS(5101),
    [anon_sym_byte] = ACTIONS(5101),
    [anon_sym_word] = ACTIONS(5101),
    [anon_sym_COLON] = ACTIONS(5103),
    [anon_sym_QMARK] = ACTIONS(5103),
    [anon_sym_LT_EQ_GT] = ACTIONS(5103),
    [anon_sym_or] = ACTIONS(5101),
    [anon_sym_and] = ACTIONS(5101),
    [anon_sym_bitor] = ACTIONS(5101),
    [anon_sym_xor] = ACTIONS(5101),
    [anon_sym_bitand] = ACTIONS(5101),
    [anon_sym_not_eq] = ACTIONS(5101),
    [anon_sym_DASH_DASH] = ACTIONS(5103),
    [anon_sym_PLUS_PLUS] = ACTIONS(5103),
    [anon_sym_DOT] = ACTIONS(5101),
    [anon_sym_DOT_STAR] = ACTIONS(5103),
    [anon_sym_DASH_GT] = ACTIONS(5103),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5101),
    [anon_sym_decltype] = ACTIONS(5101),
    [anon_sym_final] = ACTIONS(5101),
    [anon_sym_override] = ACTIONS(5101),
    [anon_sym_requires] = ACTIONS(5101),
  },
  [1958] = {
    [sym_identifier] = ACTIONS(5105),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5107),
    [anon_sym_COMMA] = ACTIONS(5107),
    [anon_sym_RPAREN] = ACTIONS(5107),
    [anon_sym_LPAREN2] = ACTIONS(5107),
    [anon_sym_DASH] = ACTIONS(5105),
    [anon_sym_PLUS] = ACTIONS(5105),
    [anon_sym_STAR] = ACTIONS(5107),
    [anon_sym_SLASH] = ACTIONS(5105),
    [anon_sym_PERCENT] = ACTIONS(5107),
    [anon_sym_PIPE_PIPE] = ACTIONS(5107),
    [anon_sym_AMP_AMP] = ACTIONS(5107),
    [anon_sym_PIPE] = ACTIONS(5105),
    [anon_sym_CARET] = ACTIONS(5107),
    [anon_sym_AMP] = ACTIONS(5105),
    [anon_sym_EQ_EQ] = ACTIONS(5107),
    [anon_sym_BANG_EQ] = ACTIONS(5107),
    [anon_sym_GT] = ACTIONS(5105),
    [anon_sym_GT_EQ] = ACTIONS(5107),
    [anon_sym_LT_EQ] = ACTIONS(5105),
    [anon_sym_LT] = ACTIONS(5105),
    [anon_sym_LT_LT] = ACTIONS(5107),
    [anon_sym_GT_GT] = ACTIONS(5107),
    [anon_sym_SEMI] = ACTIONS(5107),
    [anon_sym___extension__] = ACTIONS(5105),
    [anon_sym___attribute__] = ACTIONS(5105),
    [anon_sym___based] = ACTIONS(5105),
    [anon_sym_LBRACE] = ACTIONS(5107),
    [anon_sym_RBRACE] = ACTIONS(5107),
    [anon_sym_signed] = ACTIONS(5105),
    [anon_sym_unsigned] = ACTIONS(5105),
    [anon_sym_long] = ACTIONS(5105),
    [anon_sym_short] = ACTIONS(5105),
    [anon_sym_LBRACK] = ACTIONS(5107),
    [anon_sym_RBRACK] = ACTIONS(5107),
    [anon_sym_const] = ACTIONS(5105),
    [anon_sym_constexpr] = ACTIONS(5105),
    [anon_sym_volatile] = ACTIONS(5105),
    [anon_sym_restrict] = ACTIONS(5105),
    [anon_sym___restrict__] = ACTIONS(5105),
    [anon_sym__Atomic] = ACTIONS(5105),
    [anon_sym__Noreturn] = ACTIONS(5105),
    [anon_sym_noreturn] = ACTIONS(5105),
    [anon_sym_mutable] = ACTIONS(5105),
    [anon_sym_constinit] = ACTIONS(5105),
    [anon_sym_consteval] = ACTIONS(5105),
    [anon_sym_PROGMEM] = ACTIONS(5105),
    [aux_sym_primitive_type_token1] = ACTIONS(5105),
    [anon_sym_byte] = ACTIONS(5105),
    [anon_sym_word] = ACTIONS(5105),
    [anon_sym_COLON] = ACTIONS(5107),
    [anon_sym_QMARK] = ACTIONS(5107),
    [anon_sym_LT_EQ_GT] = ACTIONS(5107),
    [anon_sym_or] = ACTIONS(5105),
    [anon_sym_and] = ACTIONS(5105),
    [anon_sym_bitor] = ACTIONS(5105),
    [anon_sym_xor] = ACTIONS(5105),
    [anon_sym_bitand] = ACTIONS(5105),
    [anon_sym_not_eq] = ACTIONS(5105),
    [anon_sym_DASH_DASH] = ACTIONS(5107),
    [anon_sym_PLUS_PLUS] = ACTIONS(5107),
    [anon_sym_DOT] = ACTIONS(5105),
    [anon_sym_DOT_STAR] = ACTIONS(5107),
    [anon_sym_DASH_GT] = ACTIONS(5107),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5105),
    [anon_sym_decltype] = ACTIONS(5105),
    [anon_sym_final] = ACTIONS(5105),
    [anon_sym_override] = ACTIONS(5105),
    [anon_sym_requires] = ACTIONS(5105),
  },
  [1959] = {
    [sym_identifier] = ACTIONS(5109),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5111),
    [anon_sym_COMMA] = ACTIONS(5111),
    [anon_sym_RPAREN] = ACTIONS(5111),
    [anon_sym_LPAREN2] = ACTIONS(5111),
    [anon_sym_DASH] = ACTIONS(5109),
    [anon_sym_PLUS] = ACTIONS(5109),
    [anon_sym_STAR] = ACTIONS(5111),
    [anon_sym_SLASH] = ACTIONS(5109),
    [anon_sym_PERCENT] = ACTIONS(5111),
    [anon_sym_PIPE_PIPE] = ACTIONS(5111),
    [anon_sym_AMP_AMP] = ACTIONS(5111),
    [anon_sym_PIPE] = ACTIONS(5109),
    [anon_sym_CARET] = ACTIONS(5111),
    [anon_sym_AMP] = ACTIONS(5109),
    [anon_sym_EQ_EQ] = ACTIONS(5111),
    [anon_sym_BANG_EQ] = ACTIONS(5111),
    [anon_sym_GT] = ACTIONS(5109),
    [anon_sym_GT_EQ] = ACTIONS(5111),
    [anon_sym_LT_EQ] = ACTIONS(5109),
    [anon_sym_LT] = ACTIONS(5109),
    [anon_sym_LT_LT] = ACTIONS(5111),
    [anon_sym_GT_GT] = ACTIONS(5111),
    [anon_sym_SEMI] = ACTIONS(5111),
    [anon_sym___extension__] = ACTIONS(5109),
    [anon_sym___attribute__] = ACTIONS(5109),
    [anon_sym___based] = ACTIONS(5109),
    [anon_sym_LBRACE] = ACTIONS(5111),
    [anon_sym_RBRACE] = ACTIONS(5111),
    [anon_sym_signed] = ACTIONS(5109),
    [anon_sym_unsigned] = ACTIONS(5109),
    [anon_sym_long] = ACTIONS(5109),
    [anon_sym_short] = ACTIONS(5109),
    [anon_sym_LBRACK] = ACTIONS(5111),
    [anon_sym_RBRACK] = ACTIONS(5111),
    [anon_sym_const] = ACTIONS(5109),
    [anon_sym_constexpr] = ACTIONS(5109),
    [anon_sym_volatile] = ACTIONS(5109),
    [anon_sym_restrict] = ACTIONS(5109),
    [anon_sym___restrict__] = ACTIONS(5109),
    [anon_sym__Atomic] = ACTIONS(5109),
    [anon_sym__Noreturn] = ACTIONS(5109),
    [anon_sym_noreturn] = ACTIONS(5109),
    [anon_sym_mutable] = ACTIONS(5109),
    [anon_sym_constinit] = ACTIONS(5109),
    [anon_sym_consteval] = ACTIONS(5109),
    [anon_sym_PROGMEM] = ACTIONS(5109),
    [aux_sym_primitive_type_token1] = ACTIONS(5109),
    [anon_sym_byte] = ACTIONS(5109),
    [anon_sym_word] = ACTIONS(5109),
    [anon_sym_COLON] = ACTIONS(5111),
    [anon_sym_QMARK] = ACTIONS(5111),
    [anon_sym_LT_EQ_GT] = ACTIONS(5111),
    [anon_sym_or] = ACTIONS(5109),
    [anon_sym_and] = ACTIONS(5109),
    [anon_sym_bitor] = ACTIONS(5109),
    [anon_sym_xor] = ACTIONS(5109),
    [anon_sym_bitand] = ACTIONS(5109),
    [anon_sym_not_eq] = ACTIONS(5109),
    [anon_sym_DASH_DASH] = ACTIONS(5111),
    [anon_sym_PLUS_PLUS] = ACTIONS(5111),
    [anon_sym_DOT] = ACTIONS(5109),
    [anon_sym_DOT_STAR] = ACTIONS(5111),
    [anon_sym_DASH_GT] = ACTIONS(5111),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5109),
    [anon_sym_decltype] = ACTIONS(5109),
    [anon_sym_final] = ACTIONS(5109),
    [anon_sym_override] = ACTIONS(5109),
    [anon_sym_requires] = ACTIONS(5109),
  },
  [1960] = {
    [sym_identifier] = ACTIONS(5113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5115),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_RPAREN] = ACTIONS(5115),
    [anon_sym_LPAREN2] = ACTIONS(5115),
    [anon_sym_DASH] = ACTIONS(5113),
    [anon_sym_PLUS] = ACTIONS(5113),
    [anon_sym_STAR] = ACTIONS(5115),
    [anon_sym_SLASH] = ACTIONS(5113),
    [anon_sym_PERCENT] = ACTIONS(5115),
    [anon_sym_PIPE_PIPE] = ACTIONS(5115),
    [anon_sym_AMP_AMP] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(5113),
    [anon_sym_CARET] = ACTIONS(5115),
    [anon_sym_AMP] = ACTIONS(5113),
    [anon_sym_EQ_EQ] = ACTIONS(5115),
    [anon_sym_BANG_EQ] = ACTIONS(5115),
    [anon_sym_GT] = ACTIONS(5113),
    [anon_sym_GT_EQ] = ACTIONS(5115),
    [anon_sym_LT_EQ] = ACTIONS(5113),
    [anon_sym_LT] = ACTIONS(5113),
    [anon_sym_LT_LT] = ACTIONS(5115),
    [anon_sym_GT_GT] = ACTIONS(5115),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym___extension__] = ACTIONS(5113),
    [anon_sym___attribute__] = ACTIONS(5113),
    [anon_sym___based] = ACTIONS(5113),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_RBRACE] = ACTIONS(5115),
    [anon_sym_signed] = ACTIONS(5113),
    [anon_sym_unsigned] = ACTIONS(5113),
    [anon_sym_long] = ACTIONS(5113),
    [anon_sym_short] = ACTIONS(5113),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_RBRACK] = ACTIONS(5115),
    [anon_sym_const] = ACTIONS(5113),
    [anon_sym_constexpr] = ACTIONS(5113),
    [anon_sym_volatile] = ACTIONS(5113),
    [anon_sym_restrict] = ACTIONS(5113),
    [anon_sym___restrict__] = ACTIONS(5113),
    [anon_sym__Atomic] = ACTIONS(5113),
    [anon_sym__Noreturn] = ACTIONS(5113),
    [anon_sym_noreturn] = ACTIONS(5113),
    [anon_sym_mutable] = ACTIONS(5113),
    [anon_sym_constinit] = ACTIONS(5113),
    [anon_sym_consteval] = ACTIONS(5113),
    [anon_sym_PROGMEM] = ACTIONS(5113),
    [aux_sym_primitive_type_token1] = ACTIONS(5113),
    [anon_sym_byte] = ACTIONS(5113),
    [anon_sym_word] = ACTIONS(5113),
    [anon_sym_COLON] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(5115),
    [anon_sym_LT_EQ_GT] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5113),
    [anon_sym_and] = ACTIONS(5113),
    [anon_sym_bitor] = ACTIONS(5113),
    [anon_sym_xor] = ACTIONS(5113),
    [anon_sym_bitand] = ACTIONS(5113),
    [anon_sym_not_eq] = ACTIONS(5113),
    [anon_sym_DASH_DASH] = ACTIONS(5115),
    [anon_sym_PLUS_PLUS] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(5113),
    [anon_sym_DOT_STAR] = ACTIONS(5115),
    [anon_sym_DASH_GT] = ACTIONS(5115),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5113),
    [anon_sym_decltype] = ACTIONS(5113),
    [anon_sym_final] = ACTIONS(5113),
    [anon_sym_override] = ACTIONS(5113),
    [anon_sym_requires] = ACTIONS(5113),
  },
  [1961] = {
    [sym__declaration_modifiers] = STATE(3125),
    [sym_attribute_specifier] = STATE(3125),
    [sym_attribute_declaration] = STATE(3125),
    [sym_ms_declspec_modifier] = STATE(3125),
    [sym_storage_class_specifier] = STATE(3125),
    [sym_type_qualifier] = STATE(3125),
    [sym__type_specifier] = STATE(2480),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(3125),
    [sym_alignas_specifier] = STATE(3125),
    [sym_dependent_type] = STATE(2629),
    [sym_template_type] = STATE(2618),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(6346),
    [sym_qualified_type_identifier] = STATE(3260),
    [aux_sym__declaration_specifiers_repeat1] = STATE(3125),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [sym_identifier] = ACTIONS(4625),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4627),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(2857),
    [anon_sym_class] = ACTIONS(2859),
    [anon_sym_struct] = ACTIONS(2861),
    [anon_sym_union] = ACTIONS(2863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2865),
    [anon_sym_template] = ACTIONS(1419),
  },
  [1962] = {
    [sym_identifier] = ACTIONS(5117),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5119),
    [anon_sym_COMMA] = ACTIONS(5119),
    [anon_sym_RPAREN] = ACTIONS(5119),
    [anon_sym_LPAREN2] = ACTIONS(5119),
    [anon_sym_DASH] = ACTIONS(5117),
    [anon_sym_PLUS] = ACTIONS(5117),
    [anon_sym_STAR] = ACTIONS(5119),
    [anon_sym_SLASH] = ACTIONS(5117),
    [anon_sym_PERCENT] = ACTIONS(5119),
    [anon_sym_PIPE_PIPE] = ACTIONS(5119),
    [anon_sym_AMP_AMP] = ACTIONS(5119),
    [anon_sym_PIPE] = ACTIONS(5117),
    [anon_sym_CARET] = ACTIONS(5119),
    [anon_sym_AMP] = ACTIONS(5117),
    [anon_sym_EQ_EQ] = ACTIONS(5119),
    [anon_sym_BANG_EQ] = ACTIONS(5119),
    [anon_sym_GT] = ACTIONS(5117),
    [anon_sym_GT_EQ] = ACTIONS(5119),
    [anon_sym_LT_EQ] = ACTIONS(5117),
    [anon_sym_LT] = ACTIONS(5117),
    [anon_sym_LT_LT] = ACTIONS(5119),
    [anon_sym_GT_GT] = ACTIONS(5119),
    [anon_sym_SEMI] = ACTIONS(5119),
    [anon_sym___extension__] = ACTIONS(5117),
    [anon_sym___attribute__] = ACTIONS(5117),
    [anon_sym___based] = ACTIONS(5117),
    [anon_sym_LBRACE] = ACTIONS(5119),
    [anon_sym_RBRACE] = ACTIONS(5119),
    [anon_sym_signed] = ACTIONS(5117),
    [anon_sym_unsigned] = ACTIONS(5117),
    [anon_sym_long] = ACTIONS(5117),
    [anon_sym_short] = ACTIONS(5117),
    [anon_sym_LBRACK] = ACTIONS(5119),
    [anon_sym_RBRACK] = ACTIONS(5119),
    [anon_sym_const] = ACTIONS(5117),
    [anon_sym_constexpr] = ACTIONS(5117),
    [anon_sym_volatile] = ACTIONS(5117),
    [anon_sym_restrict] = ACTIONS(5117),
    [anon_sym___restrict__] = ACTIONS(5117),
    [anon_sym__Atomic] = ACTIONS(5117),
    [anon_sym__Noreturn] = ACTIONS(5117),
    [anon_sym_noreturn] = ACTIONS(5117),
    [anon_sym_mutable] = ACTIONS(5117),
    [anon_sym_constinit] = ACTIONS(5117),
    [anon_sym_consteval] = ACTIONS(5117),
    [anon_sym_PROGMEM] = ACTIONS(5117),
    [aux_sym_primitive_type_token1] = ACTIONS(5117),
    [anon_sym_byte] = ACTIONS(5117),
    [anon_sym_word] = ACTIONS(5117),
    [anon_sym_COLON] = ACTIONS(5119),
    [anon_sym_QMARK] = ACTIONS(5119),
    [anon_sym_LT_EQ_GT] = ACTIONS(5119),
    [anon_sym_or] = ACTIONS(5117),
    [anon_sym_and] = ACTIONS(5117),
    [anon_sym_bitor] = ACTIONS(5117),
    [anon_sym_xor] = ACTIONS(5117),
    [anon_sym_bitand] = ACTIONS(5117),
    [anon_sym_not_eq] = ACTIONS(5117),
    [anon_sym_DASH_DASH] = ACTIONS(5119),
    [anon_sym_PLUS_PLUS] = ACTIONS(5119),
    [anon_sym_DOT] = ACTIONS(5117),
    [anon_sym_DOT_STAR] = ACTIONS(5119),
    [anon_sym_DASH_GT] = ACTIONS(5119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5117),
    [anon_sym_decltype] = ACTIONS(5117),
    [anon_sym_final] = ACTIONS(5117),
    [anon_sym_override] = ACTIONS(5117),
    [anon_sym_requires] = ACTIONS(5117),
  },
  [1963] = {
    [sym_identifier] = ACTIONS(5121),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5123),
    [anon_sym_COMMA] = ACTIONS(5123),
    [anon_sym_RPAREN] = ACTIONS(5123),
    [anon_sym_LPAREN2] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5121),
    [anon_sym_PLUS] = ACTIONS(5121),
    [anon_sym_STAR] = ACTIONS(5123),
    [anon_sym_SLASH] = ACTIONS(5121),
    [anon_sym_PERCENT] = ACTIONS(5123),
    [anon_sym_PIPE_PIPE] = ACTIONS(5123),
    [anon_sym_AMP_AMP] = ACTIONS(5123),
    [anon_sym_PIPE] = ACTIONS(5121),
    [anon_sym_CARET] = ACTIONS(5123),
    [anon_sym_AMP] = ACTIONS(5121),
    [anon_sym_EQ_EQ] = ACTIONS(5123),
    [anon_sym_BANG_EQ] = ACTIONS(5123),
    [anon_sym_GT] = ACTIONS(5121),
    [anon_sym_GT_EQ] = ACTIONS(5123),
    [anon_sym_LT_EQ] = ACTIONS(5121),
    [anon_sym_LT] = ACTIONS(5121),
    [anon_sym_LT_LT] = ACTIONS(5123),
    [anon_sym_GT_GT] = ACTIONS(5123),
    [anon_sym_SEMI] = ACTIONS(5123),
    [anon_sym___extension__] = ACTIONS(5121),
    [anon_sym___attribute__] = ACTIONS(5121),
    [anon_sym___based] = ACTIONS(5121),
    [anon_sym_LBRACE] = ACTIONS(5123),
    [anon_sym_RBRACE] = ACTIONS(5123),
    [anon_sym_signed] = ACTIONS(5121),
    [anon_sym_unsigned] = ACTIONS(5121),
    [anon_sym_long] = ACTIONS(5121),
    [anon_sym_short] = ACTIONS(5121),
    [anon_sym_LBRACK] = ACTIONS(5123),
    [anon_sym_RBRACK] = ACTIONS(5123),
    [anon_sym_const] = ACTIONS(5121),
    [anon_sym_constexpr] = ACTIONS(5121),
    [anon_sym_volatile] = ACTIONS(5121),
    [anon_sym_restrict] = ACTIONS(5121),
    [anon_sym___restrict__] = ACTIONS(5121),
    [anon_sym__Atomic] = ACTIONS(5121),
    [anon_sym__Noreturn] = ACTIONS(5121),
    [anon_sym_noreturn] = ACTIONS(5121),
    [anon_sym_mutable] = ACTIONS(5121),
    [anon_sym_constinit] = ACTIONS(5121),
    [anon_sym_consteval] = ACTIONS(5121),
    [anon_sym_PROGMEM] = ACTIONS(5121),
    [aux_sym_primitive_type_token1] = ACTIONS(5121),
    [anon_sym_byte] = ACTIONS(5121),
    [anon_sym_word] = ACTIONS(5121),
    [anon_sym_COLON] = ACTIONS(5123),
    [anon_sym_QMARK] = ACTIONS(5123),
    [anon_sym_LT_EQ_GT] = ACTIONS(5123),
    [anon_sym_or] = ACTIONS(5121),
    [anon_sym_and] = ACTIONS(5121),
    [anon_sym_bitor] = ACTIONS(5121),
    [anon_sym_xor] = ACTIONS(5121),
    [anon_sym_bitand] = ACTIONS(5121),
    [anon_sym_not_eq] = ACTIONS(5121),
    [anon_sym_DASH_DASH] = ACTIONS(5123),
    [anon_sym_PLUS_PLUS] = ACTIONS(5123),
    [anon_sym_DOT] = ACTIONS(5121),
    [anon_sym_DOT_STAR] = ACTIONS(5123),
    [anon_sym_DASH_GT] = ACTIONS(5123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5121),
    [anon_sym_decltype] = ACTIONS(5121),
    [anon_sym_final] = ACTIONS(5121),
    [anon_sym_override] = ACTIONS(5121),
    [anon_sym_requires] = ACTIONS(5121),
  },
  [1964] = {
    [sym__declaration_modifiers] = STATE(3125),
    [sym_attribute_specifier] = STATE(3125),
    [sym_attribute_declaration] = STATE(3125),
    [sym_ms_declspec_modifier] = STATE(3125),
    [sym_storage_class_specifier] = STATE(3125),
    [sym_type_qualifier] = STATE(3125),
    [sym__type_specifier] = STATE(2480),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(3125),
    [sym_alignas_specifier] = STATE(3125),
    [sym_dependent_type] = STATE(2629),
    [sym_template_type] = STATE(2618),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(6346),
    [sym_qualified_type_identifier] = STATE(3260),
    [aux_sym__declaration_specifiers_repeat1] = STATE(3125),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [sym_identifier] = ACTIONS(4625),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4627),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_struct] = ACTIONS(69),
    [anon_sym_union] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1419),
  },
  [1965] = {
    [sym_identifier] = ACTIONS(5125),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5127),
    [anon_sym_COMMA] = ACTIONS(5127),
    [anon_sym_RPAREN] = ACTIONS(5127),
    [anon_sym_LPAREN2] = ACTIONS(5127),
    [anon_sym_DASH] = ACTIONS(5125),
    [anon_sym_PLUS] = ACTIONS(5125),
    [anon_sym_STAR] = ACTIONS(5127),
    [anon_sym_SLASH] = ACTIONS(5125),
    [anon_sym_PERCENT] = ACTIONS(5127),
    [anon_sym_PIPE_PIPE] = ACTIONS(5127),
    [anon_sym_AMP_AMP] = ACTIONS(5127),
    [anon_sym_PIPE] = ACTIONS(5125),
    [anon_sym_CARET] = ACTIONS(5127),
    [anon_sym_AMP] = ACTIONS(5125),
    [anon_sym_EQ_EQ] = ACTIONS(5127),
    [anon_sym_BANG_EQ] = ACTIONS(5127),
    [anon_sym_GT] = ACTIONS(5125),
    [anon_sym_GT_EQ] = ACTIONS(5127),
    [anon_sym_LT_EQ] = ACTIONS(5125),
    [anon_sym_LT] = ACTIONS(5125),
    [anon_sym_LT_LT] = ACTIONS(5127),
    [anon_sym_GT_GT] = ACTIONS(5127),
    [anon_sym_SEMI] = ACTIONS(5127),
    [anon_sym___extension__] = ACTIONS(5125),
    [anon_sym___attribute__] = ACTIONS(5125),
    [anon_sym___based] = ACTIONS(5125),
    [anon_sym_LBRACE] = ACTIONS(5127),
    [anon_sym_RBRACE] = ACTIONS(5127),
    [anon_sym_signed] = ACTIONS(5125),
    [anon_sym_unsigned] = ACTIONS(5125),
    [anon_sym_long] = ACTIONS(5125),
    [anon_sym_short] = ACTIONS(5125),
    [anon_sym_LBRACK] = ACTIONS(5127),
    [anon_sym_RBRACK] = ACTIONS(5127),
    [anon_sym_const] = ACTIONS(5125),
    [anon_sym_constexpr] = ACTIONS(5125),
    [anon_sym_volatile] = ACTIONS(5125),
    [anon_sym_restrict] = ACTIONS(5125),
    [anon_sym___restrict__] = ACTIONS(5125),
    [anon_sym__Atomic] = ACTIONS(5125),
    [anon_sym__Noreturn] = ACTIONS(5125),
    [anon_sym_noreturn] = ACTIONS(5125),
    [anon_sym_mutable] = ACTIONS(5125),
    [anon_sym_constinit] = ACTIONS(5125),
    [anon_sym_consteval] = ACTIONS(5125),
    [anon_sym_PROGMEM] = ACTIONS(5125),
    [aux_sym_primitive_type_token1] = ACTIONS(5125),
    [anon_sym_byte] = ACTIONS(5125),
    [anon_sym_word] = ACTIONS(5125),
    [anon_sym_COLON] = ACTIONS(5127),
    [anon_sym_QMARK] = ACTIONS(5127),
    [anon_sym_LT_EQ_GT] = ACTIONS(5127),
    [anon_sym_or] = ACTIONS(5125),
    [anon_sym_and] = ACTIONS(5125),
    [anon_sym_bitor] = ACTIONS(5125),
    [anon_sym_xor] = ACTIONS(5125),
    [anon_sym_bitand] = ACTIONS(5125),
    [anon_sym_not_eq] = ACTIONS(5125),
    [anon_sym_DASH_DASH] = ACTIONS(5127),
    [anon_sym_PLUS_PLUS] = ACTIONS(5127),
    [anon_sym_DOT] = ACTIONS(5125),
    [anon_sym_DOT_STAR] = ACTIONS(5127),
    [anon_sym_DASH_GT] = ACTIONS(5127),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5125),
    [anon_sym_decltype] = ACTIONS(5125),
    [anon_sym_final] = ACTIONS(5125),
    [anon_sym_override] = ACTIONS(5125),
    [anon_sym_requires] = ACTIONS(5125),
  },
  [1966] = {
    [sym_identifier] = ACTIONS(5050),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5052),
    [anon_sym_COMMA] = ACTIONS(5052),
    [anon_sym_RPAREN] = ACTIONS(5052),
    [anon_sym_LPAREN2] = ACTIONS(5052),
    [anon_sym_DASH] = ACTIONS(5050),
    [anon_sym_PLUS] = ACTIONS(5050),
    [anon_sym_STAR] = ACTIONS(5052),
    [anon_sym_SLASH] = ACTIONS(5050),
    [anon_sym_PERCENT] = ACTIONS(5052),
    [anon_sym_PIPE_PIPE] = ACTIONS(5052),
    [anon_sym_AMP_AMP] = ACTIONS(5052),
    [anon_sym_PIPE] = ACTIONS(5050),
    [anon_sym_CARET] = ACTIONS(5052),
    [anon_sym_AMP] = ACTIONS(5050),
    [anon_sym_EQ_EQ] = ACTIONS(5052),
    [anon_sym_BANG_EQ] = ACTIONS(5052),
    [anon_sym_GT] = ACTIONS(5050),
    [anon_sym_GT_EQ] = ACTIONS(5052),
    [anon_sym_LT_EQ] = ACTIONS(5050),
    [anon_sym_LT] = ACTIONS(5050),
    [anon_sym_LT_LT] = ACTIONS(5052),
    [anon_sym_GT_GT] = ACTIONS(5052),
    [anon_sym_SEMI] = ACTIONS(5052),
    [anon_sym___extension__] = ACTIONS(5050),
    [anon_sym___attribute__] = ACTIONS(5050),
    [anon_sym___based] = ACTIONS(5050),
    [anon_sym_LBRACE] = ACTIONS(5052),
    [anon_sym_RBRACE] = ACTIONS(5052),
    [anon_sym_signed] = ACTIONS(5050),
    [anon_sym_unsigned] = ACTIONS(5050),
    [anon_sym_long] = ACTIONS(5050),
    [anon_sym_short] = ACTIONS(5050),
    [anon_sym_LBRACK] = ACTIONS(5052),
    [anon_sym_RBRACK] = ACTIONS(5052),
    [anon_sym_const] = ACTIONS(5050),
    [anon_sym_constexpr] = ACTIONS(5050),
    [anon_sym_volatile] = ACTIONS(5050),
    [anon_sym_restrict] = ACTIONS(5050),
    [anon_sym___restrict__] = ACTIONS(5050),
    [anon_sym__Atomic] = ACTIONS(5050),
    [anon_sym__Noreturn] = ACTIONS(5050),
    [anon_sym_noreturn] = ACTIONS(5050),
    [anon_sym_mutable] = ACTIONS(5050),
    [anon_sym_constinit] = ACTIONS(5050),
    [anon_sym_consteval] = ACTIONS(5050),
    [anon_sym_PROGMEM] = ACTIONS(5050),
    [aux_sym_primitive_type_token1] = ACTIONS(5050),
    [anon_sym_byte] = ACTIONS(5050),
    [anon_sym_word] = ACTIONS(5050),
    [anon_sym_COLON] = ACTIONS(5052),
    [anon_sym_QMARK] = ACTIONS(5052),
    [anon_sym_LT_EQ_GT] = ACTIONS(5052),
    [anon_sym_or] = ACTIONS(5050),
    [anon_sym_and] = ACTIONS(5050),
    [anon_sym_bitor] = ACTIONS(5050),
    [anon_sym_xor] = ACTIONS(5050),
    [anon_sym_bitand] = ACTIONS(5050),
    [anon_sym_not_eq] = ACTIONS(5050),
    [anon_sym_DASH_DASH] = ACTIONS(5052),
    [anon_sym_PLUS_PLUS] = ACTIONS(5052),
    [anon_sym_DOT] = ACTIONS(5050),
    [anon_sym_DOT_STAR] = ACTIONS(5052),
    [anon_sym_DASH_GT] = ACTIONS(5052),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5050),
    [anon_sym_decltype] = ACTIONS(5050),
    [anon_sym_final] = ACTIONS(5050),
    [anon_sym_override] = ACTIONS(5050),
    [anon_sym_requires] = ACTIONS(5050),
  },
  [1967] = {
    [sym__declaration_modifiers] = STATE(3125),
    [sym_attribute_specifier] = STATE(3125),
    [sym_attribute_declaration] = STATE(3125),
    [sym_ms_declspec_modifier] = STATE(3125),
    [sym_storage_class_specifier] = STATE(3125),
    [sym_type_qualifier] = STATE(3125),
    [sym__type_specifier] = STATE(2480),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(2805),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(3125),
    [sym_alignas_specifier] = STATE(3125),
    [sym_dependent_type] = STATE(2629),
    [sym_template_type] = STATE(2618),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(6380),
    [sym_qualified_type_identifier] = STATE(3260),
    [aux_sym__declaration_specifiers_repeat1] = STATE(3125),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2435),
    [sym_identifier] = ACTIONS(4516),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(4526),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(1755),
    [anon_sym_class] = ACTIONS(1757),
    [anon_sym_struct] = ACTIONS(1759),
    [anon_sym_union] = ACTIONS(1761),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(1787),
    [anon_sym_template] = ACTIONS(1419),
  },
  [1968] = {
    [sym_identifier] = ACTIONS(5129),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5131),
    [anon_sym_COMMA] = ACTIONS(5131),
    [anon_sym_RPAREN] = ACTIONS(5131),
    [anon_sym_LPAREN2] = ACTIONS(5131),
    [anon_sym_DASH] = ACTIONS(5129),
    [anon_sym_PLUS] = ACTIONS(5129),
    [anon_sym_STAR] = ACTIONS(5131),
    [anon_sym_SLASH] = ACTIONS(5129),
    [anon_sym_PERCENT] = ACTIONS(5131),
    [anon_sym_PIPE_PIPE] = ACTIONS(5131),
    [anon_sym_AMP_AMP] = ACTIONS(5131),
    [anon_sym_PIPE] = ACTIONS(5129),
    [anon_sym_CARET] = ACTIONS(5131),
    [anon_sym_AMP] = ACTIONS(5129),
    [anon_sym_EQ_EQ] = ACTIONS(5131),
    [anon_sym_BANG_EQ] = ACTIONS(5131),
    [anon_sym_GT] = ACTIONS(5129),
    [anon_sym_GT_EQ] = ACTIONS(5131),
    [anon_sym_LT_EQ] = ACTIONS(5129),
    [anon_sym_LT] = ACTIONS(5129),
    [anon_sym_LT_LT] = ACTIONS(5131),
    [anon_sym_GT_GT] = ACTIONS(5131),
    [anon_sym_SEMI] = ACTIONS(5131),
    [anon_sym___extension__] = ACTIONS(5129),
    [anon_sym___attribute__] = ACTIONS(5129),
    [anon_sym___based] = ACTIONS(5129),
    [anon_sym_LBRACE] = ACTIONS(5131),
    [anon_sym_RBRACE] = ACTIONS(5131),
    [anon_sym_signed] = ACTIONS(5129),
    [anon_sym_unsigned] = ACTIONS(5129),
    [anon_sym_long] = ACTIONS(5129),
    [anon_sym_short] = ACTIONS(5129),
    [anon_sym_LBRACK] = ACTIONS(5131),
    [anon_sym_RBRACK] = ACTIONS(5131),
    [anon_sym_const] = ACTIONS(5129),
    [anon_sym_constexpr] = ACTIONS(5129),
    [anon_sym_volatile] = ACTIONS(5129),
    [anon_sym_restrict] = ACTIONS(5129),
    [anon_sym___restrict__] = ACTIONS(5129),
    [anon_sym__Atomic] = ACTIONS(5129),
    [anon_sym__Noreturn] = ACTIONS(5129),
    [anon_sym_noreturn] = ACTIONS(5129),
    [anon_sym_mutable] = ACTIONS(5129),
    [anon_sym_constinit] = ACTIONS(5129),
    [anon_sym_consteval] = ACTIONS(5129),
    [anon_sym_PROGMEM] = ACTIONS(5129),
    [aux_sym_primitive_type_token1] = ACTIONS(5129),
    [anon_sym_byte] = ACTIONS(5129),
    [anon_sym_word] = ACTIONS(5129),
    [anon_sym_COLON] = ACTIONS(5131),
    [anon_sym_QMARK] = ACTIONS(5131),
    [anon_sym_LT_EQ_GT] = ACTIONS(5131),
    [anon_sym_or] = ACTIONS(5129),
    [anon_sym_and] = ACTIONS(5129),
    [anon_sym_bitor] = ACTIONS(5129),
    [anon_sym_xor] = ACTIONS(5129),
    [anon_sym_bitand] = ACTIONS(5129),
    [anon_sym_not_eq] = ACTIONS(5129),
    [anon_sym_DASH_DASH] = ACTIONS(5131),
    [anon_sym_PLUS_PLUS] = ACTIONS(5131),
    [anon_sym_DOT] = ACTIONS(5129),
    [anon_sym_DOT_STAR] = ACTIONS(5131),
    [anon_sym_DASH_GT] = ACTIONS(5131),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5129),
    [anon_sym_decltype] = ACTIONS(5129),
    [anon_sym_final] = ACTIONS(5129),
    [anon_sym_override] = ACTIONS(5129),
    [anon_sym_requires] = ACTIONS(5129),
  },
  [1969] = {
    [sym_identifier] = ACTIONS(5121),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5123),
    [anon_sym_COMMA] = ACTIONS(5123),
    [anon_sym_RPAREN] = ACTIONS(5123),
    [anon_sym_LPAREN2] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5121),
    [anon_sym_PLUS] = ACTIONS(5121),
    [anon_sym_STAR] = ACTIONS(5123),
    [anon_sym_SLASH] = ACTIONS(5121),
    [anon_sym_PERCENT] = ACTIONS(5123),
    [anon_sym_PIPE_PIPE] = ACTIONS(5123),
    [anon_sym_AMP_AMP] = ACTIONS(5123),
    [anon_sym_PIPE] = ACTIONS(5121),
    [anon_sym_CARET] = ACTIONS(5123),
    [anon_sym_AMP] = ACTIONS(5121),
    [anon_sym_EQ_EQ] = ACTIONS(5123),
    [anon_sym_BANG_EQ] = ACTIONS(5123),
    [anon_sym_GT] = ACTIONS(5121),
    [anon_sym_GT_EQ] = ACTIONS(5123),
    [anon_sym_LT_EQ] = ACTIONS(5121),
    [anon_sym_LT] = ACTIONS(5121),
    [anon_sym_LT_LT] = ACTIONS(5123),
    [anon_sym_GT_GT] = ACTIONS(5123),
    [anon_sym_SEMI] = ACTIONS(5123),
    [anon_sym___extension__] = ACTIONS(5121),
    [anon_sym___attribute__] = ACTIONS(5121),
    [anon_sym___based] = ACTIONS(5121),
    [anon_sym_LBRACE] = ACTIONS(5123),
    [anon_sym_RBRACE] = ACTIONS(5123),
    [anon_sym_signed] = ACTIONS(5121),
    [anon_sym_unsigned] = ACTIONS(5121),
    [anon_sym_long] = ACTIONS(5121),
    [anon_sym_short] = ACTIONS(5121),
    [anon_sym_LBRACK] = ACTIONS(5123),
    [anon_sym_RBRACK] = ACTIONS(5123),
    [anon_sym_const] = ACTIONS(5121),
    [anon_sym_constexpr] = ACTIONS(5121),
    [anon_sym_volatile] = ACTIONS(5121),
    [anon_sym_restrict] = ACTIONS(5121),
    [anon_sym___restrict__] = ACTIONS(5121),
    [anon_sym__Atomic] = ACTIONS(5121),
    [anon_sym__Noreturn] = ACTIONS(5121),
    [anon_sym_noreturn] = ACTIONS(5121),
    [anon_sym_mutable] = ACTIONS(5121),
    [anon_sym_constinit] = ACTIONS(5121),
    [anon_sym_consteval] = ACTIONS(5121),
    [anon_sym_PROGMEM] = ACTIONS(5121),
    [aux_sym_primitive_type_token1] = ACTIONS(5121),
    [anon_sym_byte] = ACTIONS(5121),
    [anon_sym_word] = ACTIONS(5121),
    [anon_sym_COLON] = ACTIONS(5123),
    [anon_sym_QMARK] = ACTIONS(5123),
    [anon_sym_LT_EQ_GT] = ACTIONS(5123),
    [anon_sym_or] = ACTIONS(5121),
    [anon_sym_and] = ACTIONS(5121),
    [anon_sym_bitor] = ACTIONS(5121),
    [anon_sym_xor] = ACTIONS(5121),
    [anon_sym_bitand] = ACTIONS(5121),
    [anon_sym_not_eq] = ACTIONS(5121),
    [anon_sym_DASH_DASH] = ACTIONS(5123),
    [anon_sym_PLUS_PLUS] = ACTIONS(5123),
    [anon_sym_DOT] = ACTIONS(5121),
    [anon_sym_DOT_STAR] = ACTIONS(5123),
    [anon_sym_DASH_GT] = ACTIONS(5123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5121),
    [anon_sym_decltype] = ACTIONS(5121),
    [anon_sym_final] = ACTIONS(5121),
    [anon_sym_override] = ACTIONS(5121),
    [anon_sym_requires] = ACTIONS(5121),
  },
  [1970] = {
    [sym_catch_clause] = STATE(1952),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1952),
    [sym_identifier] = ACTIONS(2492),
    [aux_sym_preproc_def_token1] = ACTIONS(2492),
    [aux_sym_preproc_if_token1] = ACTIONS(2492),
    [aux_sym_preproc_if_token2] = ACTIONS(2492),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2492),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2492),
    [sym_preproc_directive] = ACTIONS(2492),
    [anon_sym_LPAREN2] = ACTIONS(2494),
    [anon_sym_TILDE] = ACTIONS(2494),
    [anon_sym_STAR] = ACTIONS(2494),
    [anon_sym_AMP_AMP] = ACTIONS(2494),
    [anon_sym_AMP] = ACTIONS(2492),
    [anon_sym___extension__] = ACTIONS(2492),
    [anon_sym_typedef] = ACTIONS(2492),
    [anon_sym_extern] = ACTIONS(2492),
    [anon_sym___attribute__] = ACTIONS(2492),
    [anon_sym_COLON_COLON] = ACTIONS(2494),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2494),
    [anon_sym___declspec] = ACTIONS(2492),
    [anon_sym___based] = ACTIONS(2492),
    [anon_sym_signed] = ACTIONS(2492),
    [anon_sym_unsigned] = ACTIONS(2492),
    [anon_sym_long] = ACTIONS(2492),
    [anon_sym_short] = ACTIONS(2492),
    [anon_sym_LBRACK] = ACTIONS(2492),
    [anon_sym_static] = ACTIONS(2492),
    [anon_sym_register] = ACTIONS(2492),
    [anon_sym_inline] = ACTIONS(2492),
    [anon_sym___inline] = ACTIONS(2492),
    [anon_sym___inline__] = ACTIONS(2492),
    [anon_sym___forceinline] = ACTIONS(2492),
    [anon_sym_thread_local] = ACTIONS(2492),
    [anon_sym___thread] = ACTIONS(2492),
    [anon_sym_const] = ACTIONS(2492),
    [anon_sym_constexpr] = ACTIONS(2492),
    [anon_sym_volatile] = ACTIONS(2492),
    [anon_sym_restrict] = ACTIONS(2492),
    [anon_sym___restrict__] = ACTIONS(2492),
    [anon_sym__Atomic] = ACTIONS(2492),
    [anon_sym__Noreturn] = ACTIONS(2492),
    [anon_sym_noreturn] = ACTIONS(2492),
    [anon_sym_mutable] = ACTIONS(2492),
    [anon_sym_constinit] = ACTIONS(2492),
    [anon_sym_consteval] = ACTIONS(2492),
    [anon_sym_PROGMEM] = ACTIONS(2492),
    [aux_sym_primitive_type_token1] = ACTIONS(2492),
    [anon_sym_byte] = ACTIONS(2492),
    [anon_sym_word] = ACTIONS(2492),
    [anon_sym_enum] = ACTIONS(2492),
    [anon_sym_class] = ACTIONS(2492),
    [anon_sym_struct] = ACTIONS(2492),
    [anon_sym_union] = ACTIONS(2492),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2492),
    [anon_sym_decltype] = ACTIONS(2492),
    [anon_sym_virtual] = ACTIONS(2492),
    [anon_sym_alignas] = ACTIONS(2492),
    [anon_sym_explicit] = ACTIONS(2492),
    [anon_sym_typename] = ACTIONS(2492),
    [anon_sym_template] = ACTIONS(2492),
    [anon_sym_operator] = ACTIONS(2492),
    [anon_sym_friend] = ACTIONS(2492),
    [anon_sym_public] = ACTIONS(2492),
    [anon_sym_private] = ACTIONS(2492),
    [anon_sym_protected] = ACTIONS(2492),
    [anon_sym_using] = ACTIONS(2492),
    [anon_sym_static_assert] = ACTIONS(2492),
    [anon_sym_catch] = ACTIONS(5133),
  },
  [1971] = {
    [sym_identifier] = ACTIONS(2819),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2821),
    [anon_sym_COMMA] = ACTIONS(2821),
    [anon_sym_RPAREN] = ACTIONS(2821),
    [anon_sym_LPAREN2] = ACTIONS(2821),
    [anon_sym_TILDE] = ACTIONS(2821),
    [anon_sym_STAR] = ACTIONS(2821),
    [anon_sym_AMP_AMP] = ACTIONS(2821),
    [anon_sym_AMP] = ACTIONS(2819),
    [anon_sym_SEMI] = ACTIONS(2821),
    [anon_sym___extension__] = ACTIONS(2819),
    [anon_sym_extern] = ACTIONS(2819),
    [anon_sym___attribute__] = ACTIONS(2819),
    [anon_sym_COLON_COLON] = ACTIONS(2821),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2821),
    [anon_sym___declspec] = ACTIONS(2819),
    [anon_sym___based] = ACTIONS(2819),
    [anon_sym_LBRACE] = ACTIONS(2821),
    [anon_sym_signed] = ACTIONS(2819),
    [anon_sym_unsigned] = ACTIONS(2819),
    [anon_sym_long] = ACTIONS(2819),
    [anon_sym_short] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(2819),
    [anon_sym_EQ] = ACTIONS(2821),
    [anon_sym_static] = ACTIONS(2819),
    [anon_sym_register] = ACTIONS(2819),
    [anon_sym_inline] = ACTIONS(2819),
    [anon_sym___inline] = ACTIONS(2819),
    [anon_sym___inline__] = ACTIONS(2819),
    [anon_sym___forceinline] = ACTIONS(2819),
    [anon_sym_thread_local] = ACTIONS(2819),
    [anon_sym___thread] = ACTIONS(2819),
    [anon_sym_const] = ACTIONS(2819),
    [anon_sym_constexpr] = ACTIONS(2819),
    [anon_sym_volatile] = ACTIONS(2819),
    [anon_sym_restrict] = ACTIONS(2819),
    [anon_sym___restrict__] = ACTIONS(2819),
    [anon_sym__Atomic] = ACTIONS(2819),
    [anon_sym__Noreturn] = ACTIONS(2819),
    [anon_sym_noreturn] = ACTIONS(2819),
    [anon_sym_mutable] = ACTIONS(2819),
    [anon_sym_constinit] = ACTIONS(2819),
    [anon_sym_consteval] = ACTIONS(2819),
    [anon_sym_PROGMEM] = ACTIONS(2819),
    [aux_sym_primitive_type_token1] = ACTIONS(2819),
    [anon_sym_byte] = ACTIONS(2819),
    [anon_sym_word] = ACTIONS(2819),
    [anon_sym_enum] = ACTIONS(2819),
    [anon_sym_class] = ACTIONS(2819),
    [anon_sym_struct] = ACTIONS(2819),
    [anon_sym_union] = ACTIONS(2819),
    [anon_sym_asm] = ACTIONS(2819),
    [anon_sym___asm__] = ACTIONS(2819),
    [anon_sym_DASH_GT] = ACTIONS(2821),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2819),
    [anon_sym_decltype] = ACTIONS(2819),
    [anon_sym_final] = ACTIONS(2819),
    [anon_sym_override] = ACTIONS(2819),
    [anon_sym_virtual] = ACTIONS(2819),
    [anon_sym_alignas] = ACTIONS(2819),
    [anon_sym_explicit] = ACTIONS(2819),
    [anon_sym_typename] = ACTIONS(2819),
    [anon_sym_template] = ACTIONS(2819),
    [anon_sym_GT2] = ACTIONS(2821),
    [anon_sym_operator] = ACTIONS(2819),
    [anon_sym_try] = ACTIONS(2819),
    [anon_sym_noexcept] = ACTIONS(2819),
    [anon_sym_throw] = ACTIONS(2819),
    [anon_sym_requires] = ACTIONS(2819),
  },
  [1972] = {
    [sym_identifier] = ACTIONS(2819),
    [anon_sym_LPAREN2] = ACTIONS(2821),
    [anon_sym_BANG] = ACTIONS(2821),
    [anon_sym_TILDE] = ACTIONS(2821),
    [anon_sym_DASH] = ACTIONS(2819),
    [anon_sym_PLUS] = ACTIONS(2819),
    [anon_sym_STAR] = ACTIONS(2821),
    [anon_sym_AMP] = ACTIONS(2821),
    [anon_sym___extension__] = ACTIONS(2819),
    [anon_sym_COLON_COLON] = ACTIONS(2821),
    [anon_sym_LBRACK] = ACTIONS(2821),
    [anon_sym_RBRACK] = ACTIONS(2821),
    [anon_sym_const] = ACTIONS(2819),
    [anon_sym_constexpr] = ACTIONS(2819),
    [anon_sym_volatile] = ACTIONS(2819),
    [anon_sym_restrict] = ACTIONS(2819),
    [anon_sym___restrict__] = ACTIONS(2819),
    [anon_sym__Atomic] = ACTIONS(2819),
    [anon_sym__Noreturn] = ACTIONS(2819),
    [anon_sym_noreturn] = ACTIONS(2819),
    [anon_sym_mutable] = ACTIONS(2819),
    [anon_sym_constinit] = ACTIONS(2819),
    [anon_sym_consteval] = ACTIONS(2819),
    [anon_sym_PROGMEM] = ACTIONS(2819),
    [aux_sym_primitive_type_token1] = ACTIONS(2819),
    [anon_sym_byte] = ACTIONS(2819),
    [anon_sym_word] = ACTIONS(2819),
    [anon_sym_not] = ACTIONS(2819),
    [anon_sym_compl] = ACTIONS(2819),
    [anon_sym_DASH_DASH] = ACTIONS(2821),
    [anon_sym_PLUS_PLUS] = ACTIONS(2821),
    [anon_sym_sizeof] = ACTIONS(2819),
    [anon_sym___alignof__] = ACTIONS(2819),
    [anon_sym___alignof] = ACTIONS(2819),
    [anon_sym__alignof] = ACTIONS(2819),
    [anon_sym_alignof] = ACTIONS(2819),
    [anon_sym__Alignof] = ACTIONS(2819),
    [anon_sym_offsetof] = ACTIONS(2819),
    [anon_sym__Generic] = ACTIONS(2819),
    [anon_sym_asm] = ACTIONS(2819),
    [anon_sym___asm__] = ACTIONS(2819),
    [aux_sym_number_literal_token1] = ACTIONS(2821),
    [aux_sym_number_literal_token2] = ACTIONS(2819),
    [anon_sym_L_SQUOTE] = ACTIONS(2821),
    [anon_sym_u_SQUOTE] = ACTIONS(2821),
    [anon_sym_U_SQUOTE] = ACTIONS(2821),
    [anon_sym_u8_SQUOTE] = ACTIONS(2821),
    [anon_sym_SQUOTE] = ACTIONS(2821),
    [anon_sym_L_DQUOTE] = ACTIONS(2821),
    [anon_sym_u_DQUOTE] = ACTIONS(2821),
    [anon_sym_U_DQUOTE] = ACTIONS(2821),
    [anon_sym_u8_DQUOTE] = ACTIONS(2821),
    [anon_sym_DQUOTE] = ACTIONS(2821),
    [sym_true] = ACTIONS(2819),
    [sym_false] = ACTIONS(2819),
    [anon_sym_NULL] = ACTIONS(2819),
    [anon_sym_nullptr] = ACTIONS(2819),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2819),
    [anon_sym_template] = ACTIONS(2819),
    [anon_sym_delete] = ACTIONS(2819),
    [anon_sym_R_DQUOTE] = ACTIONS(2821),
    [anon_sym_LR_DQUOTE] = ACTIONS(2821),
    [anon_sym_uR_DQUOTE] = ACTIONS(2821),
    [anon_sym_UR_DQUOTE] = ACTIONS(2821),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2821),
    [anon_sym_co_await] = ACTIONS(2819),
    [anon_sym_new] = ACTIONS(2819),
    [anon_sym_requires] = ACTIONS(2819),
    [sym_this] = ACTIONS(2819),
  },
  [1973] = {
    [sym_identifier] = ACTIONS(5135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5137),
    [anon_sym_COMMA] = ACTIONS(5137),
    [anon_sym_RPAREN] = ACTIONS(5137),
    [anon_sym_LPAREN2] = ACTIONS(5137),
    [anon_sym_DASH] = ACTIONS(5135),
    [anon_sym_PLUS] = ACTIONS(5135),
    [anon_sym_STAR] = ACTIONS(5137),
    [anon_sym_SLASH] = ACTIONS(5135),
    [anon_sym_PERCENT] = ACTIONS(5137),
    [anon_sym_PIPE_PIPE] = ACTIONS(5137),
    [anon_sym_AMP_AMP] = ACTIONS(5137),
    [anon_sym_PIPE] = ACTIONS(5135),
    [anon_sym_CARET] = ACTIONS(5137),
    [anon_sym_AMP] = ACTIONS(5135),
    [anon_sym_EQ_EQ] = ACTIONS(5137),
    [anon_sym_BANG_EQ] = ACTIONS(5137),
    [anon_sym_GT] = ACTIONS(5135),
    [anon_sym_GT_EQ] = ACTIONS(5137),
    [anon_sym_LT_EQ] = ACTIONS(5135),
    [anon_sym_LT] = ACTIONS(5135),
    [anon_sym_LT_LT] = ACTIONS(5137),
    [anon_sym_GT_GT] = ACTIONS(5137),
    [anon_sym_SEMI] = ACTIONS(5137),
    [anon_sym___extension__] = ACTIONS(5135),
    [anon_sym___attribute__] = ACTIONS(5135),
    [anon_sym___based] = ACTIONS(5135),
    [anon_sym_LBRACE] = ACTIONS(5137),
    [anon_sym_RBRACE] = ACTIONS(5137),
    [anon_sym_signed] = ACTIONS(5135),
    [anon_sym_unsigned] = ACTIONS(5135),
    [anon_sym_long] = ACTIONS(5135),
    [anon_sym_short] = ACTIONS(5135),
    [anon_sym_LBRACK] = ACTIONS(5137),
    [anon_sym_RBRACK] = ACTIONS(5137),
    [anon_sym_const] = ACTIONS(5135),
    [anon_sym_constexpr] = ACTIONS(5135),
    [anon_sym_volatile] = ACTIONS(5135),
    [anon_sym_restrict] = ACTIONS(5135),
    [anon_sym___restrict__] = ACTIONS(5135),
    [anon_sym__Atomic] = ACTIONS(5135),
    [anon_sym__Noreturn] = ACTIONS(5135),
    [anon_sym_noreturn] = ACTIONS(5135),
    [anon_sym_mutable] = ACTIONS(5135),
    [anon_sym_constinit] = ACTIONS(5135),
    [anon_sym_consteval] = ACTIONS(5135),
    [anon_sym_PROGMEM] = ACTIONS(5135),
    [aux_sym_primitive_type_token1] = ACTIONS(5135),
    [anon_sym_byte] = ACTIONS(5135),
    [anon_sym_word] = ACTIONS(5135),
    [anon_sym_COLON] = ACTIONS(5137),
    [anon_sym_QMARK] = ACTIONS(5137),
    [anon_sym_LT_EQ_GT] = ACTIONS(5137),
    [anon_sym_or] = ACTIONS(5135),
    [anon_sym_and] = ACTIONS(5135),
    [anon_sym_bitor] = ACTIONS(5135),
    [anon_sym_xor] = ACTIONS(5135),
    [anon_sym_bitand] = ACTIONS(5135),
    [anon_sym_not_eq] = ACTIONS(5135),
    [anon_sym_DASH_DASH] = ACTIONS(5137),
    [anon_sym_PLUS_PLUS] = ACTIONS(5137),
    [anon_sym_DOT] = ACTIONS(5135),
    [anon_sym_DOT_STAR] = ACTIONS(5137),
    [anon_sym_DASH_GT] = ACTIONS(5137),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5135),
    [anon_sym_decltype] = ACTIONS(5135),
    [anon_sym_final] = ACTIONS(5135),
    [anon_sym_override] = ACTIONS(5135),
    [anon_sym_requires] = ACTIONS(5135),
  },
  [1974] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1767),
    [sym_identifier] = ACTIONS(4766),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5139),
    [anon_sym_COMMA] = ACTIONS(5139),
    [anon_sym_RPAREN] = ACTIONS(5139),
    [anon_sym_LPAREN2] = ACTIONS(5139),
    [anon_sym_DASH] = ACTIONS(5142),
    [anon_sym_PLUS] = ACTIONS(5142),
    [anon_sym_STAR] = ACTIONS(5139),
    [anon_sym_SLASH] = ACTIONS(5142),
    [anon_sym_PERCENT] = ACTIONS(5139),
    [anon_sym_PIPE_PIPE] = ACTIONS(5139),
    [anon_sym_AMP_AMP] = ACTIONS(5139),
    [anon_sym_PIPE] = ACTIONS(5142),
    [anon_sym_CARET] = ACTIONS(5139),
    [anon_sym_AMP] = ACTIONS(5142),
    [anon_sym_EQ_EQ] = ACTIONS(5139),
    [anon_sym_BANG_EQ] = ACTIONS(5139),
    [anon_sym_GT] = ACTIONS(5142),
    [anon_sym_GT_EQ] = ACTIONS(5139),
    [anon_sym_LT_EQ] = ACTIONS(5142),
    [anon_sym_LT] = ACTIONS(5142),
    [anon_sym_LT_LT] = ACTIONS(5139),
    [anon_sym_GT_GT] = ACTIONS(5139),
    [anon_sym_SEMI] = ACTIONS(5139),
    [anon_sym___extension__] = ACTIONS(5142),
    [anon_sym___attribute__] = ACTIONS(5142),
    [anon_sym_LBRACE] = ACTIONS(5139),
    [anon_sym_RBRACE] = ACTIONS(5139),
    [anon_sym_signed] = ACTIONS(4770),
    [anon_sym_unsigned] = ACTIONS(4770),
    [anon_sym_long] = ACTIONS(4770),
    [anon_sym_short] = ACTIONS(4770),
    [anon_sym_LBRACK] = ACTIONS(5139),
    [anon_sym_RBRACK] = ACTIONS(5139),
    [anon_sym_const] = ACTIONS(5142),
    [anon_sym_constexpr] = ACTIONS(5142),
    [anon_sym_volatile] = ACTIONS(5142),
    [anon_sym_restrict] = ACTIONS(5142),
    [anon_sym___restrict__] = ACTIONS(5142),
    [anon_sym__Atomic] = ACTIONS(5142),
    [anon_sym__Noreturn] = ACTIONS(5142),
    [anon_sym_noreturn] = ACTIONS(5142),
    [anon_sym_mutable] = ACTIONS(5142),
    [anon_sym_constinit] = ACTIONS(5142),
    [anon_sym_consteval] = ACTIONS(5142),
    [anon_sym_PROGMEM] = ACTIONS(5142),
    [aux_sym_primitive_type_token1] = ACTIONS(4766),
    [anon_sym_byte] = ACTIONS(4766),
    [anon_sym_word] = ACTIONS(4766),
    [anon_sym_COLON] = ACTIONS(5139),
    [anon_sym_QMARK] = ACTIONS(5139),
    [anon_sym_LT_EQ_GT] = ACTIONS(5139),
    [anon_sym_or] = ACTIONS(5142),
    [anon_sym_and] = ACTIONS(5142),
    [anon_sym_bitor] = ACTIONS(5142),
    [anon_sym_xor] = ACTIONS(5142),
    [anon_sym_bitand] = ACTIONS(5142),
    [anon_sym_not_eq] = ACTIONS(5142),
    [anon_sym_DASH_DASH] = ACTIONS(5139),
    [anon_sym_PLUS_PLUS] = ACTIONS(5139),
    [anon_sym_DOT] = ACTIONS(5142),
    [anon_sym_DOT_STAR] = ACTIONS(5139),
    [anon_sym_DASH_GT] = ACTIONS(5139),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5142),
    [anon_sym_decltype] = ACTIONS(5142),
    [anon_sym_final] = ACTIONS(5142),
    [anon_sym_override] = ACTIONS(5142),
    [anon_sym_requires] = ACTIONS(5142),
  },
  [1975] = {
    [sym_identifier] = ACTIONS(5145),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5147),
    [anon_sym_COMMA] = ACTIONS(5147),
    [anon_sym_RPAREN] = ACTIONS(5147),
    [anon_sym_LPAREN2] = ACTIONS(5147),
    [anon_sym_DASH] = ACTIONS(5145),
    [anon_sym_PLUS] = ACTIONS(5145),
    [anon_sym_STAR] = ACTIONS(5147),
    [anon_sym_SLASH] = ACTIONS(5145),
    [anon_sym_PERCENT] = ACTIONS(5147),
    [anon_sym_PIPE_PIPE] = ACTIONS(5147),
    [anon_sym_AMP_AMP] = ACTIONS(5147),
    [anon_sym_PIPE] = ACTIONS(5145),
    [anon_sym_CARET] = ACTIONS(5147),
    [anon_sym_AMP] = ACTIONS(5145),
    [anon_sym_EQ_EQ] = ACTIONS(5147),
    [anon_sym_BANG_EQ] = ACTIONS(5147),
    [anon_sym_GT] = ACTIONS(5145),
    [anon_sym_GT_EQ] = ACTIONS(5147),
    [anon_sym_LT_EQ] = ACTIONS(5145),
    [anon_sym_LT] = ACTIONS(5145),
    [anon_sym_LT_LT] = ACTIONS(5147),
    [anon_sym_GT_GT] = ACTIONS(5147),
    [anon_sym_SEMI] = ACTIONS(5147),
    [anon_sym___extension__] = ACTIONS(5145),
    [anon_sym___attribute__] = ACTIONS(5145),
    [anon_sym___based] = ACTIONS(5145),
    [anon_sym_LBRACE] = ACTIONS(5147),
    [anon_sym_RBRACE] = ACTIONS(5147),
    [anon_sym_signed] = ACTIONS(5145),
    [anon_sym_unsigned] = ACTIONS(5145),
    [anon_sym_long] = ACTIONS(5145),
    [anon_sym_short] = ACTIONS(5145),
    [anon_sym_LBRACK] = ACTIONS(5147),
    [anon_sym_RBRACK] = ACTIONS(5147),
    [anon_sym_const] = ACTIONS(5145),
    [anon_sym_constexpr] = ACTIONS(5145),
    [anon_sym_volatile] = ACTIONS(5145),
    [anon_sym_restrict] = ACTIONS(5145),
    [anon_sym___restrict__] = ACTIONS(5145),
    [anon_sym__Atomic] = ACTIONS(5145),
    [anon_sym__Noreturn] = ACTIONS(5145),
    [anon_sym_noreturn] = ACTIONS(5145),
    [anon_sym_mutable] = ACTIONS(5145),
    [anon_sym_constinit] = ACTIONS(5145),
    [anon_sym_consteval] = ACTIONS(5145),
    [anon_sym_PROGMEM] = ACTIONS(5145),
    [aux_sym_primitive_type_token1] = ACTIONS(5145),
    [anon_sym_byte] = ACTIONS(5145),
    [anon_sym_word] = ACTIONS(5145),
    [anon_sym_COLON] = ACTIONS(5147),
    [anon_sym_QMARK] = ACTIONS(5147),
    [anon_sym_LT_EQ_GT] = ACTIONS(5147),
    [anon_sym_or] = ACTIONS(5145),
    [anon_sym_and] = ACTIONS(5145),
    [anon_sym_bitor] = ACTIONS(5145),
    [anon_sym_xor] = ACTIONS(5145),
    [anon_sym_bitand] = ACTIONS(5145),
    [anon_sym_not_eq] = ACTIONS(5145),
    [anon_sym_DASH_DASH] = ACTIONS(5147),
    [anon_sym_PLUS_PLUS] = ACTIONS(5147),
    [anon_sym_DOT] = ACTIONS(5145),
    [anon_sym_DOT_STAR] = ACTIONS(5147),
    [anon_sym_DASH_GT] = ACTIONS(5147),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5145),
    [anon_sym_decltype] = ACTIONS(5145),
    [anon_sym_final] = ACTIONS(5145),
    [anon_sym_override] = ACTIONS(5145),
    [anon_sym_requires] = ACTIONS(5145),
  },
  [1976] = {
    [sym_template_argument_list] = STATE(2002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4536),
    [anon_sym_COMMA] = ACTIONS(4536),
    [anon_sym_RPAREN] = ACTIONS(4538),
    [anon_sym_LPAREN2] = ACTIONS(4538),
    [anon_sym_DASH] = ACTIONS(4543),
    [anon_sym_PLUS] = ACTIONS(4543),
    [anon_sym_STAR] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(4543),
    [anon_sym_PERCENT] = ACTIONS(4543),
    [anon_sym_PIPE_PIPE] = ACTIONS(4536),
    [anon_sym_AMP_AMP] = ACTIONS(4538),
    [anon_sym_PIPE] = ACTIONS(4543),
    [anon_sym_CARET] = ACTIONS(4543),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_EQ_EQ] = ACTIONS(4536),
    [anon_sym_BANG_EQ] = ACTIONS(4536),
    [anon_sym_GT] = ACTIONS(4543),
    [anon_sym_GT_EQ] = ACTIONS(4536),
    [anon_sym_LT_EQ] = ACTIONS(4543),
    [anon_sym_LT] = ACTIONS(5149),
    [anon_sym_LT_LT] = ACTIONS(4543),
    [anon_sym_GT_GT] = ACTIONS(4543),
    [anon_sym___extension__] = ACTIONS(4541),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(4541),
    [anon_sym_LBRACK] = ACTIONS(4538),
    [anon_sym_EQ] = ACTIONS(4543),
    [anon_sym_const] = ACTIONS(4534),
    [anon_sym_constexpr] = ACTIONS(4541),
    [anon_sym_volatile] = ACTIONS(4541),
    [anon_sym_restrict] = ACTIONS(4541),
    [anon_sym___restrict__] = ACTIONS(4541),
    [anon_sym__Atomic] = ACTIONS(4541),
    [anon_sym__Noreturn] = ACTIONS(4541),
    [anon_sym_noreturn] = ACTIONS(4541),
    [anon_sym_mutable] = ACTIONS(4541),
    [anon_sym_constinit] = ACTIONS(4541),
    [anon_sym_consteval] = ACTIONS(4541),
    [anon_sym_PROGMEM] = ACTIONS(4541),
    [anon_sym_QMARK] = ACTIONS(4536),
    [anon_sym_STAR_EQ] = ACTIONS(4536),
    [anon_sym_SLASH_EQ] = ACTIONS(4536),
    [anon_sym_PERCENT_EQ] = ACTIONS(4536),
    [anon_sym_PLUS_EQ] = ACTIONS(4536),
    [anon_sym_DASH_EQ] = ACTIONS(4536),
    [anon_sym_LT_LT_EQ] = ACTIONS(4536),
    [anon_sym_GT_GT_EQ] = ACTIONS(4536),
    [anon_sym_AMP_EQ] = ACTIONS(4536),
    [anon_sym_CARET_EQ] = ACTIONS(4536),
    [anon_sym_PIPE_EQ] = ACTIONS(4536),
    [anon_sym_and_eq] = ACTIONS(4536),
    [anon_sym_or_eq] = ACTIONS(4536),
    [anon_sym_xor_eq] = ACTIONS(4536),
    [anon_sym_LT_EQ_GT] = ACTIONS(4536),
    [anon_sym_or] = ACTIONS(4543),
    [anon_sym_and] = ACTIONS(4543),
    [anon_sym_bitor] = ACTIONS(4536),
    [anon_sym_xor] = ACTIONS(4543),
    [anon_sym_bitand] = ACTIONS(4536),
    [anon_sym_not_eq] = ACTIONS(4536),
    [anon_sym_DASH_DASH] = ACTIONS(4536),
    [anon_sym_PLUS_PLUS] = ACTIONS(4536),
    [anon_sym_DOT] = ACTIONS(4543),
    [anon_sym_DOT_STAR] = ACTIONS(4536),
    [anon_sym_DASH_GT] = ACTIONS(4543),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4541),
    [anon_sym_decltype] = ACTIONS(4541),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4536),
  },
  [1977] = {
    [sym_catch_clause] = STATE(1952),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1952),
    [sym_identifier] = ACTIONS(2488),
    [aux_sym_preproc_def_token1] = ACTIONS(2488),
    [aux_sym_preproc_if_token1] = ACTIONS(2488),
    [aux_sym_preproc_if_token2] = ACTIONS(2488),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2488),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2488),
    [sym_preproc_directive] = ACTIONS(2488),
    [anon_sym_LPAREN2] = ACTIONS(2490),
    [anon_sym_TILDE] = ACTIONS(2490),
    [anon_sym_STAR] = ACTIONS(2490),
    [anon_sym_AMP_AMP] = ACTIONS(2490),
    [anon_sym_AMP] = ACTIONS(2488),
    [anon_sym___extension__] = ACTIONS(2488),
    [anon_sym_typedef] = ACTIONS(2488),
    [anon_sym_extern] = ACTIONS(2488),
    [anon_sym___attribute__] = ACTIONS(2488),
    [anon_sym_COLON_COLON] = ACTIONS(2490),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2490),
    [anon_sym___declspec] = ACTIONS(2488),
    [anon_sym___based] = ACTIONS(2488),
    [anon_sym_signed] = ACTIONS(2488),
    [anon_sym_unsigned] = ACTIONS(2488),
    [anon_sym_long] = ACTIONS(2488),
    [anon_sym_short] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(2488),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_register] = ACTIONS(2488),
    [anon_sym_inline] = ACTIONS(2488),
    [anon_sym___inline] = ACTIONS(2488),
    [anon_sym___inline__] = ACTIONS(2488),
    [anon_sym___forceinline] = ACTIONS(2488),
    [anon_sym_thread_local] = ACTIONS(2488),
    [anon_sym___thread] = ACTIONS(2488),
    [anon_sym_const] = ACTIONS(2488),
    [anon_sym_constexpr] = ACTIONS(2488),
    [anon_sym_volatile] = ACTIONS(2488),
    [anon_sym_restrict] = ACTIONS(2488),
    [anon_sym___restrict__] = ACTIONS(2488),
    [anon_sym__Atomic] = ACTIONS(2488),
    [anon_sym__Noreturn] = ACTIONS(2488),
    [anon_sym_noreturn] = ACTIONS(2488),
    [anon_sym_mutable] = ACTIONS(2488),
    [anon_sym_constinit] = ACTIONS(2488),
    [anon_sym_consteval] = ACTIONS(2488),
    [anon_sym_PROGMEM] = ACTIONS(2488),
    [aux_sym_primitive_type_token1] = ACTIONS(2488),
    [anon_sym_byte] = ACTIONS(2488),
    [anon_sym_word] = ACTIONS(2488),
    [anon_sym_enum] = ACTIONS(2488),
    [anon_sym_class] = ACTIONS(2488),
    [anon_sym_struct] = ACTIONS(2488),
    [anon_sym_union] = ACTIONS(2488),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2488),
    [anon_sym_decltype] = ACTIONS(2488),
    [anon_sym_virtual] = ACTIONS(2488),
    [anon_sym_alignas] = ACTIONS(2488),
    [anon_sym_explicit] = ACTIONS(2488),
    [anon_sym_typename] = ACTIONS(2488),
    [anon_sym_template] = ACTIONS(2488),
    [anon_sym_operator] = ACTIONS(2488),
    [anon_sym_friend] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_using] = ACTIONS(2488),
    [anon_sym_static_assert] = ACTIONS(2488),
    [anon_sym_catch] = ACTIONS(5133),
  },
  [1978] = {
    [sym_identifier] = ACTIONS(5152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5154),
    [anon_sym_COMMA] = ACTIONS(5154),
    [anon_sym_RPAREN] = ACTIONS(5154),
    [anon_sym_LPAREN2] = ACTIONS(5154),
    [anon_sym_DASH] = ACTIONS(5152),
    [anon_sym_PLUS] = ACTIONS(5152),
    [anon_sym_STAR] = ACTIONS(5154),
    [anon_sym_SLASH] = ACTIONS(5152),
    [anon_sym_PERCENT] = ACTIONS(5154),
    [anon_sym_PIPE_PIPE] = ACTIONS(5154),
    [anon_sym_AMP_AMP] = ACTIONS(5154),
    [anon_sym_PIPE] = ACTIONS(5152),
    [anon_sym_CARET] = ACTIONS(5154),
    [anon_sym_AMP] = ACTIONS(5152),
    [anon_sym_EQ_EQ] = ACTIONS(5154),
    [anon_sym_BANG_EQ] = ACTIONS(5154),
    [anon_sym_GT] = ACTIONS(5152),
    [anon_sym_GT_EQ] = ACTIONS(5154),
    [anon_sym_LT_EQ] = ACTIONS(5152),
    [anon_sym_LT] = ACTIONS(5152),
    [anon_sym_LT_LT] = ACTIONS(5154),
    [anon_sym_GT_GT] = ACTIONS(5154),
    [anon_sym_SEMI] = ACTIONS(5154),
    [anon_sym___extension__] = ACTIONS(5152),
    [anon_sym___attribute__] = ACTIONS(5152),
    [anon_sym___based] = ACTIONS(5152),
    [anon_sym_LBRACE] = ACTIONS(5154),
    [anon_sym_RBRACE] = ACTIONS(5154),
    [anon_sym_signed] = ACTIONS(5152),
    [anon_sym_unsigned] = ACTIONS(5152),
    [anon_sym_long] = ACTIONS(5152),
    [anon_sym_short] = ACTIONS(5152),
    [anon_sym_LBRACK] = ACTIONS(5154),
    [anon_sym_RBRACK] = ACTIONS(5154),
    [anon_sym_const] = ACTIONS(5152),
    [anon_sym_constexpr] = ACTIONS(5152),
    [anon_sym_volatile] = ACTIONS(5152),
    [anon_sym_restrict] = ACTIONS(5152),
    [anon_sym___restrict__] = ACTIONS(5152),
    [anon_sym__Atomic] = ACTIONS(5152),
    [anon_sym__Noreturn] = ACTIONS(5152),
    [anon_sym_noreturn] = ACTIONS(5152),
    [anon_sym_mutable] = ACTIONS(5152),
    [anon_sym_constinit] = ACTIONS(5152),
    [anon_sym_consteval] = ACTIONS(5152),
    [anon_sym_PROGMEM] = ACTIONS(5152),
    [aux_sym_primitive_type_token1] = ACTIONS(5152),
    [anon_sym_byte] = ACTIONS(5152),
    [anon_sym_word] = ACTIONS(5152),
    [anon_sym_COLON] = ACTIONS(5154),
    [anon_sym_QMARK] = ACTIONS(5154),
    [anon_sym_LT_EQ_GT] = ACTIONS(5154),
    [anon_sym_or] = ACTIONS(5152),
    [anon_sym_and] = ACTIONS(5152),
    [anon_sym_bitor] = ACTIONS(5152),
    [anon_sym_xor] = ACTIONS(5152),
    [anon_sym_bitand] = ACTIONS(5152),
    [anon_sym_not_eq] = ACTIONS(5152),
    [anon_sym_DASH_DASH] = ACTIONS(5154),
    [anon_sym_PLUS_PLUS] = ACTIONS(5154),
    [anon_sym_DOT] = ACTIONS(5152),
    [anon_sym_DOT_STAR] = ACTIONS(5154),
    [anon_sym_DASH_GT] = ACTIONS(5154),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5152),
    [anon_sym_decltype] = ACTIONS(5152),
    [anon_sym_final] = ACTIONS(5152),
    [anon_sym_override] = ACTIONS(5152),
    [anon_sym_requires] = ACTIONS(5152),
  },
  [1979] = {
    [sym_identifier] = ACTIONS(5156),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5158),
    [anon_sym_COMMA] = ACTIONS(5158),
    [anon_sym_RPAREN] = ACTIONS(5158),
    [anon_sym_LPAREN2] = ACTIONS(5158),
    [anon_sym_DASH] = ACTIONS(5156),
    [anon_sym_PLUS] = ACTIONS(5156),
    [anon_sym_STAR] = ACTIONS(5158),
    [anon_sym_SLASH] = ACTIONS(5156),
    [anon_sym_PERCENT] = ACTIONS(5158),
    [anon_sym_PIPE_PIPE] = ACTIONS(5158),
    [anon_sym_AMP_AMP] = ACTIONS(5158),
    [anon_sym_PIPE] = ACTIONS(5156),
    [anon_sym_CARET] = ACTIONS(5158),
    [anon_sym_AMP] = ACTIONS(5156),
    [anon_sym_EQ_EQ] = ACTIONS(5158),
    [anon_sym_BANG_EQ] = ACTIONS(5158),
    [anon_sym_GT] = ACTIONS(5156),
    [anon_sym_GT_EQ] = ACTIONS(5158),
    [anon_sym_LT_EQ] = ACTIONS(5156),
    [anon_sym_LT] = ACTIONS(5156),
    [anon_sym_LT_LT] = ACTIONS(5158),
    [anon_sym_GT_GT] = ACTIONS(5158),
    [anon_sym_SEMI] = ACTIONS(5158),
    [anon_sym___extension__] = ACTIONS(5156),
    [anon_sym___attribute__] = ACTIONS(5156),
    [anon_sym___based] = ACTIONS(5156),
    [anon_sym_LBRACE] = ACTIONS(5158),
    [anon_sym_RBRACE] = ACTIONS(5158),
    [anon_sym_signed] = ACTIONS(5156),
    [anon_sym_unsigned] = ACTIONS(5156),
    [anon_sym_long] = ACTIONS(5156),
    [anon_sym_short] = ACTIONS(5156),
    [anon_sym_LBRACK] = ACTIONS(5158),
    [anon_sym_RBRACK] = ACTIONS(5158),
    [anon_sym_const] = ACTIONS(5156),
    [anon_sym_constexpr] = ACTIONS(5156),
    [anon_sym_volatile] = ACTIONS(5156),
    [anon_sym_restrict] = ACTIONS(5156),
    [anon_sym___restrict__] = ACTIONS(5156),
    [anon_sym__Atomic] = ACTIONS(5156),
    [anon_sym__Noreturn] = ACTIONS(5156),
    [anon_sym_noreturn] = ACTIONS(5156),
    [anon_sym_mutable] = ACTIONS(5156),
    [anon_sym_constinit] = ACTIONS(5156),
    [anon_sym_consteval] = ACTIONS(5156),
    [anon_sym_PROGMEM] = ACTIONS(5156),
    [aux_sym_primitive_type_token1] = ACTIONS(5156),
    [anon_sym_byte] = ACTIONS(5156),
    [anon_sym_word] = ACTIONS(5156),
    [anon_sym_COLON] = ACTIONS(5158),
    [anon_sym_QMARK] = ACTIONS(5158),
    [anon_sym_LT_EQ_GT] = ACTIONS(5158),
    [anon_sym_or] = ACTIONS(5156),
    [anon_sym_and] = ACTIONS(5156),
    [anon_sym_bitor] = ACTIONS(5156),
    [anon_sym_xor] = ACTIONS(5156),
    [anon_sym_bitand] = ACTIONS(5156),
    [anon_sym_not_eq] = ACTIONS(5156),
    [anon_sym_DASH_DASH] = ACTIONS(5158),
    [anon_sym_PLUS_PLUS] = ACTIONS(5158),
    [anon_sym_DOT] = ACTIONS(5156),
    [anon_sym_DOT_STAR] = ACTIONS(5158),
    [anon_sym_DASH_GT] = ACTIONS(5158),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5156),
    [anon_sym_decltype] = ACTIONS(5156),
    [anon_sym_final] = ACTIONS(5156),
    [anon_sym_override] = ACTIONS(5156),
    [anon_sym_requires] = ACTIONS(5156),
  },
  [1980] = {
    [sym_identifier] = ACTIONS(5160),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5162),
    [anon_sym_COMMA] = ACTIONS(5162),
    [anon_sym_RPAREN] = ACTIONS(5162),
    [anon_sym_LPAREN2] = ACTIONS(5162),
    [anon_sym_DASH] = ACTIONS(5160),
    [anon_sym_PLUS] = ACTIONS(5160),
    [anon_sym_STAR] = ACTIONS(5162),
    [anon_sym_SLASH] = ACTIONS(5160),
    [anon_sym_PERCENT] = ACTIONS(5162),
    [anon_sym_PIPE_PIPE] = ACTIONS(5162),
    [anon_sym_AMP_AMP] = ACTIONS(5162),
    [anon_sym_PIPE] = ACTIONS(5160),
    [anon_sym_CARET] = ACTIONS(5162),
    [anon_sym_AMP] = ACTIONS(5160),
    [anon_sym_EQ_EQ] = ACTIONS(5162),
    [anon_sym_BANG_EQ] = ACTIONS(5162),
    [anon_sym_GT] = ACTIONS(5160),
    [anon_sym_GT_EQ] = ACTIONS(5162),
    [anon_sym_LT_EQ] = ACTIONS(5160),
    [anon_sym_LT] = ACTIONS(5160),
    [anon_sym_LT_LT] = ACTIONS(5162),
    [anon_sym_GT_GT] = ACTIONS(5162),
    [anon_sym_SEMI] = ACTIONS(5162),
    [anon_sym___extension__] = ACTIONS(5160),
    [anon_sym___attribute__] = ACTIONS(5160),
    [anon_sym___based] = ACTIONS(5160),
    [anon_sym_LBRACE] = ACTIONS(5162),
    [anon_sym_RBRACE] = ACTIONS(5162),
    [anon_sym_signed] = ACTIONS(5160),
    [anon_sym_unsigned] = ACTIONS(5160),
    [anon_sym_long] = ACTIONS(5160),
    [anon_sym_short] = ACTIONS(5160),
    [anon_sym_LBRACK] = ACTIONS(5162),
    [anon_sym_RBRACK] = ACTIONS(5162),
    [anon_sym_const] = ACTIONS(5160),
    [anon_sym_constexpr] = ACTIONS(5160),
    [anon_sym_volatile] = ACTIONS(5160),
    [anon_sym_restrict] = ACTIONS(5160),
    [anon_sym___restrict__] = ACTIONS(5160),
    [anon_sym__Atomic] = ACTIONS(5160),
    [anon_sym__Noreturn] = ACTIONS(5160),
    [anon_sym_noreturn] = ACTIONS(5160),
    [anon_sym_mutable] = ACTIONS(5160),
    [anon_sym_constinit] = ACTIONS(5160),
    [anon_sym_consteval] = ACTIONS(5160),
    [anon_sym_PROGMEM] = ACTIONS(5160),
    [aux_sym_primitive_type_token1] = ACTIONS(5160),
    [anon_sym_byte] = ACTIONS(5160),
    [anon_sym_word] = ACTIONS(5160),
    [anon_sym_COLON] = ACTIONS(5162),
    [anon_sym_QMARK] = ACTIONS(5162),
    [anon_sym_LT_EQ_GT] = ACTIONS(5162),
    [anon_sym_or] = ACTIONS(5160),
    [anon_sym_and] = ACTIONS(5160),
    [anon_sym_bitor] = ACTIONS(5160),
    [anon_sym_xor] = ACTIONS(5160),
    [anon_sym_bitand] = ACTIONS(5160),
    [anon_sym_not_eq] = ACTIONS(5160),
    [anon_sym_DASH_DASH] = ACTIONS(5162),
    [anon_sym_PLUS_PLUS] = ACTIONS(5162),
    [anon_sym_DOT] = ACTIONS(5160),
    [anon_sym_DOT_STAR] = ACTIONS(5162),
    [anon_sym_DASH_GT] = ACTIONS(5162),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5160),
    [anon_sym_decltype] = ACTIONS(5160),
    [anon_sym_final] = ACTIONS(5160),
    [anon_sym_override] = ACTIONS(5160),
    [anon_sym_requires] = ACTIONS(5160),
  },
  [1981] = {
    [sym_identifier] = ACTIONS(5164),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5166),
    [anon_sym_COMMA] = ACTIONS(5166),
    [anon_sym_RPAREN] = ACTIONS(5166),
    [anon_sym_LPAREN2] = ACTIONS(5166),
    [anon_sym_DASH] = ACTIONS(5164),
    [anon_sym_PLUS] = ACTIONS(5164),
    [anon_sym_STAR] = ACTIONS(5166),
    [anon_sym_SLASH] = ACTIONS(5164),
    [anon_sym_PERCENT] = ACTIONS(5166),
    [anon_sym_PIPE_PIPE] = ACTIONS(5166),
    [anon_sym_AMP_AMP] = ACTIONS(5166),
    [anon_sym_PIPE] = ACTIONS(5164),
    [anon_sym_CARET] = ACTIONS(5166),
    [anon_sym_AMP] = ACTIONS(5164),
    [anon_sym_EQ_EQ] = ACTIONS(5166),
    [anon_sym_BANG_EQ] = ACTIONS(5166),
    [anon_sym_GT] = ACTIONS(5164),
    [anon_sym_GT_EQ] = ACTIONS(5166),
    [anon_sym_LT_EQ] = ACTIONS(5164),
    [anon_sym_LT] = ACTIONS(5164),
    [anon_sym_LT_LT] = ACTIONS(5166),
    [anon_sym_GT_GT] = ACTIONS(5166),
    [anon_sym_SEMI] = ACTIONS(5166),
    [anon_sym___extension__] = ACTIONS(5164),
    [anon_sym___attribute__] = ACTIONS(5164),
    [anon_sym___based] = ACTIONS(5164),
    [anon_sym_LBRACE] = ACTIONS(5166),
    [anon_sym_RBRACE] = ACTIONS(5166),
    [anon_sym_signed] = ACTIONS(5164),
    [anon_sym_unsigned] = ACTIONS(5164),
    [anon_sym_long] = ACTIONS(5164),
    [anon_sym_short] = ACTIONS(5164),
    [anon_sym_LBRACK] = ACTIONS(5166),
    [anon_sym_RBRACK] = ACTIONS(5166),
    [anon_sym_const] = ACTIONS(5164),
    [anon_sym_constexpr] = ACTIONS(5164),
    [anon_sym_volatile] = ACTIONS(5164),
    [anon_sym_restrict] = ACTIONS(5164),
    [anon_sym___restrict__] = ACTIONS(5164),
    [anon_sym__Atomic] = ACTIONS(5164),
    [anon_sym__Noreturn] = ACTIONS(5164),
    [anon_sym_noreturn] = ACTIONS(5164),
    [anon_sym_mutable] = ACTIONS(5164),
    [anon_sym_constinit] = ACTIONS(5164),
    [anon_sym_consteval] = ACTIONS(5164),
    [anon_sym_PROGMEM] = ACTIONS(5164),
    [aux_sym_primitive_type_token1] = ACTIONS(5164),
    [anon_sym_byte] = ACTIONS(5164),
    [anon_sym_word] = ACTIONS(5164),
    [anon_sym_COLON] = ACTIONS(5166),
    [anon_sym_QMARK] = ACTIONS(5166),
    [anon_sym_LT_EQ_GT] = ACTIONS(5166),
    [anon_sym_or] = ACTIONS(5164),
    [anon_sym_and] = ACTIONS(5164),
    [anon_sym_bitor] = ACTIONS(5164),
    [anon_sym_xor] = ACTIONS(5164),
    [anon_sym_bitand] = ACTIONS(5164),
    [anon_sym_not_eq] = ACTIONS(5164),
    [anon_sym_DASH_DASH] = ACTIONS(5166),
    [anon_sym_PLUS_PLUS] = ACTIONS(5166),
    [anon_sym_DOT] = ACTIONS(5164),
    [anon_sym_DOT_STAR] = ACTIONS(5166),
    [anon_sym_DASH_GT] = ACTIONS(5166),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5164),
    [anon_sym_decltype] = ACTIONS(5164),
    [anon_sym_final] = ACTIONS(5164),
    [anon_sym_override] = ACTIONS(5164),
    [anon_sym_requires] = ACTIONS(5164),
  },
  [1982] = {
    [sym_identifier] = ACTIONS(5168),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5170),
    [anon_sym_COMMA] = ACTIONS(5170),
    [anon_sym_RPAREN] = ACTIONS(5170),
    [anon_sym_LPAREN2] = ACTIONS(5170),
    [anon_sym_DASH] = ACTIONS(5168),
    [anon_sym_PLUS] = ACTIONS(5168),
    [anon_sym_STAR] = ACTIONS(5170),
    [anon_sym_SLASH] = ACTIONS(5168),
    [anon_sym_PERCENT] = ACTIONS(5170),
    [anon_sym_PIPE_PIPE] = ACTIONS(5170),
    [anon_sym_AMP_AMP] = ACTIONS(5170),
    [anon_sym_PIPE] = ACTIONS(5168),
    [anon_sym_CARET] = ACTIONS(5170),
    [anon_sym_AMP] = ACTIONS(5168),
    [anon_sym_EQ_EQ] = ACTIONS(5170),
    [anon_sym_BANG_EQ] = ACTIONS(5170),
    [anon_sym_GT] = ACTIONS(5168),
    [anon_sym_GT_EQ] = ACTIONS(5170),
    [anon_sym_LT_EQ] = ACTIONS(5168),
    [anon_sym_LT] = ACTIONS(5168),
    [anon_sym_LT_LT] = ACTIONS(5170),
    [anon_sym_GT_GT] = ACTIONS(5170),
    [anon_sym_SEMI] = ACTIONS(5170),
    [anon_sym___extension__] = ACTIONS(5168),
    [anon_sym___attribute__] = ACTIONS(5168),
    [anon_sym___based] = ACTIONS(5168),
    [anon_sym_LBRACE] = ACTIONS(5170),
    [anon_sym_RBRACE] = ACTIONS(5170),
    [anon_sym_signed] = ACTIONS(5168),
    [anon_sym_unsigned] = ACTIONS(5168),
    [anon_sym_long] = ACTIONS(5168),
    [anon_sym_short] = ACTIONS(5168),
    [anon_sym_LBRACK] = ACTIONS(5170),
    [anon_sym_RBRACK] = ACTIONS(5170),
    [anon_sym_const] = ACTIONS(5168),
    [anon_sym_constexpr] = ACTIONS(5168),
    [anon_sym_volatile] = ACTIONS(5168),
    [anon_sym_restrict] = ACTIONS(5168),
    [anon_sym___restrict__] = ACTIONS(5168),
    [anon_sym__Atomic] = ACTIONS(5168),
    [anon_sym__Noreturn] = ACTIONS(5168),
    [anon_sym_noreturn] = ACTIONS(5168),
    [anon_sym_mutable] = ACTIONS(5168),
    [anon_sym_constinit] = ACTIONS(5168),
    [anon_sym_consteval] = ACTIONS(5168),
    [anon_sym_PROGMEM] = ACTIONS(5168),
    [aux_sym_primitive_type_token1] = ACTIONS(5168),
    [anon_sym_byte] = ACTIONS(5168),
    [anon_sym_word] = ACTIONS(5168),
    [anon_sym_COLON] = ACTIONS(5170),
    [anon_sym_QMARK] = ACTIONS(5170),
    [anon_sym_LT_EQ_GT] = ACTIONS(5170),
    [anon_sym_or] = ACTIONS(5168),
    [anon_sym_and] = ACTIONS(5168),
    [anon_sym_bitor] = ACTIONS(5168),
    [anon_sym_xor] = ACTIONS(5168),
    [anon_sym_bitand] = ACTIONS(5168),
    [anon_sym_not_eq] = ACTIONS(5168),
    [anon_sym_DASH_DASH] = ACTIONS(5170),
    [anon_sym_PLUS_PLUS] = ACTIONS(5170),
    [anon_sym_DOT] = ACTIONS(5168),
    [anon_sym_DOT_STAR] = ACTIONS(5170),
    [anon_sym_DASH_GT] = ACTIONS(5170),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5168),
    [anon_sym_decltype] = ACTIONS(5168),
    [anon_sym_final] = ACTIONS(5168),
    [anon_sym_override] = ACTIONS(5168),
    [anon_sym_requires] = ACTIONS(5168),
  },
  [1983] = {
    [sym__declaration_modifiers] = STATE(3125),
    [sym_attribute_specifier] = STATE(3125),
    [sym_attribute_declaration] = STATE(3125),
    [sym_ms_declspec_modifier] = STATE(3125),
    [sym_storage_class_specifier] = STATE(3125),
    [sym_type_qualifier] = STATE(3125),
    [sym__type_specifier] = STATE(4052),
    [sym_sized_type_specifier] = STATE(2629),
    [sym_primitive_type] = STATE(3443),
    [sym_enum_specifier] = STATE(2629),
    [sym_struct_specifier] = STATE(2629),
    [sym_union_specifier] = STATE(2629),
    [sym_placeholder_type_specifier] = STATE(2629),
    [sym_decltype_auto] = STATE(2687),
    [sym_decltype] = STATE(2618),
    [sym_class_specifier] = STATE(2629),
    [sym_virtual] = STATE(3125),
    [sym_alignas_specifier] = STATE(3125),
    [sym_dependent_type] = STATE(2629),
    [sym_template_type] = STATE(2618),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(6333),
    [sym_qualified_type_identifier] = STATE(2825),
    [aux_sym__declaration_specifiers_repeat1] = STATE(3125),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2855),
    [sym_identifier] = ACTIONS(3572),
    [anon_sym___extension__] = ACTIONS(61),
    [anon_sym_extern] = ACTIONS(57),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_COLON_COLON] = ACTIONS(3578),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1733),
    [anon_sym___declspec] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(3580),
    [anon_sym_unsigned] = ACTIONS(3580),
    [anon_sym_long] = ACTIONS(3580),
    [anon_sym_short] = ACTIONS(3580),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_register] = ACTIONS(57),
    [anon_sym_inline] = ACTIONS(57),
    [anon_sym___inline] = ACTIONS(57),
    [anon_sym___inline__] = ACTIONS(57),
    [anon_sym___forceinline] = ACTIONS(57),
    [anon_sym_thread_local] = ACTIONS(57),
    [anon_sym___thread] = ACTIONS(57),
    [anon_sym_const] = ACTIONS(61),
    [anon_sym_constexpr] = ACTIONS(61),
    [anon_sym_volatile] = ACTIONS(61),
    [anon_sym_restrict] = ACTIONS(61),
    [anon_sym___restrict__] = ACTIONS(61),
    [anon_sym__Atomic] = ACTIONS(61),
    [anon_sym__Noreturn] = ACTIONS(61),
    [anon_sym_noreturn] = ACTIONS(61),
    [anon_sym_mutable] = ACTIONS(61),
    [anon_sym_constinit] = ACTIONS(61),
    [anon_sym_consteval] = ACTIONS(61),
    [anon_sym_PROGMEM] = ACTIONS(61),
    [aux_sym_primitive_type_token1] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(63),
    [anon_sym_word] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(3582),
    [anon_sym_class] = ACTIONS(3584),
    [anon_sym_struct] = ACTIONS(3586),
    [anon_sym_union] = ACTIONS(3588),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(119),
    [anon_sym_decltype] = ACTIONS(121),
    [anon_sym_virtual] = ACTIONS(123),
    [anon_sym_alignas] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(3590),
    [anon_sym_template] = ACTIONS(1419),
  },
  [1984] = {
    [sym_identifier] = ACTIONS(5172),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5174),
    [anon_sym_COMMA] = ACTIONS(5174),
    [anon_sym_RPAREN] = ACTIONS(5174),
    [anon_sym_LPAREN2] = ACTIONS(5174),
    [anon_sym_DASH] = ACTIONS(5172),
    [anon_sym_PLUS] = ACTIONS(5172),
    [anon_sym_STAR] = ACTIONS(5174),
    [anon_sym_SLASH] = ACTIONS(5172),
    [anon_sym_PERCENT] = ACTIONS(5174),
    [anon_sym_PIPE_PIPE] = ACTIONS(5174),
    [anon_sym_AMP_AMP] = ACTIONS(5174),
    [anon_sym_PIPE] = ACTIONS(5172),
    [anon_sym_CARET] = ACTIONS(5174),
    [anon_sym_AMP] = ACTIONS(5172),
    [anon_sym_EQ_EQ] = ACTIONS(5174),
    [anon_sym_BANG_EQ] = ACTIONS(5174),
    [anon_sym_GT] = ACTIONS(5172),
    [anon_sym_GT_EQ] = ACTIONS(5174),
    [anon_sym_LT_EQ] = ACTIONS(5172),
    [anon_sym_LT] = ACTIONS(5172),
    [anon_sym_LT_LT] = ACTIONS(5174),
    [anon_sym_GT_GT] = ACTIONS(5174),
    [anon_sym_SEMI] = ACTIONS(5174),
    [anon_sym___extension__] = ACTIONS(5172),
    [anon_sym___attribute__] = ACTIONS(5172),
    [anon_sym___based] = ACTIONS(5172),
    [anon_sym_LBRACE] = ACTIONS(5174),
    [anon_sym_RBRACE] = ACTIONS(5174),
    [anon_sym_signed] = ACTIONS(5172),
    [anon_sym_unsigned] = ACTIONS(5172),
    [anon_sym_long] = ACTIONS(5172),
    [anon_sym_short] = ACTIONS(5172),
    [anon_sym_LBRACK] = ACTIONS(5174),
    [anon_sym_RBRACK] = ACTIONS(5174),
    [anon_sym_const] = ACTIONS(5172),
    [anon_sym_constexpr] = ACTIONS(5172),
    [anon_sym_volatile] = ACTIONS(5172),
    [anon_sym_restrict] = ACTIONS(5172),
    [anon_sym___restrict__] = ACTIONS(5172),
    [anon_sym__Atomic] = ACTIONS(5172),
    [anon_sym__Noreturn] = ACTIONS(5172),
    [anon_sym_noreturn] = ACTIONS(5172),
    [anon_sym_mutable] = ACTIONS(5172),
    [anon_sym_constinit] = ACTIONS(5172),
    [anon_sym_consteval] = ACTIONS(5172),
    [anon_sym_PROGMEM] = ACTIONS(5172),
    [aux_sym_primitive_type_token1] = ACTIONS(5172),
    [anon_sym_byte] = ACTIONS(5172),
    [anon_sym_word] = ACTIONS(5172),
    [anon_sym_COLON] = ACTIONS(5174),
    [anon_sym_QMARK] = ACTIONS(5174),
    [anon_sym_LT_EQ_GT] = ACTIONS(5174),
    [anon_sym_or] = ACTIONS(5172),
    [anon_sym_and] = ACTIONS(5172),
    [anon_sym_bitor] = ACTIONS(5172),
    [anon_sym_xor] = ACTIONS(5172),
    [anon_sym_bitand] = ACTIONS(5172),
    [anon_sym_not_eq] = ACTIONS(5172),
    [anon_sym_DASH_DASH] = ACTIONS(5174),
    [anon_sym_PLUS_PLUS] = ACTIONS(5174),
    [anon_sym_DOT] = ACTIONS(5172),
    [anon_sym_DOT_STAR] = ACTIONS(5174),
    [anon_sym_DASH_GT] = ACTIONS(5174),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5172),
    [anon_sym_decltype] = ACTIONS(5172),
    [anon_sym_final] = ACTIONS(5172),
    [anon_sym_override] = ACTIONS(5172),
    [anon_sym_requires] = ACTIONS(5172),
  },
  [1985] = {
    [sym_catch_clause] = STATE(1985),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1985),
    [sym_identifier] = ACTIONS(2475),
    [aux_sym_preproc_def_token1] = ACTIONS(2475),
    [aux_sym_preproc_if_token1] = ACTIONS(2475),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2475),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2475),
    [sym_preproc_directive] = ACTIONS(2475),
    [anon_sym_LPAREN2] = ACTIONS(2477),
    [anon_sym_TILDE] = ACTIONS(2477),
    [anon_sym_STAR] = ACTIONS(2477),
    [anon_sym_AMP_AMP] = ACTIONS(2477),
    [anon_sym_AMP] = ACTIONS(2475),
    [anon_sym___extension__] = ACTIONS(2475),
    [anon_sym_typedef] = ACTIONS(2475),
    [anon_sym_extern] = ACTIONS(2475),
    [anon_sym___attribute__] = ACTIONS(2475),
    [anon_sym_COLON_COLON] = ACTIONS(2477),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2477),
    [anon_sym___declspec] = ACTIONS(2475),
    [anon_sym___based] = ACTIONS(2475),
    [anon_sym_RBRACE] = ACTIONS(2477),
    [anon_sym_signed] = ACTIONS(2475),
    [anon_sym_unsigned] = ACTIONS(2475),
    [anon_sym_long] = ACTIONS(2475),
    [anon_sym_short] = ACTIONS(2475),
    [anon_sym_LBRACK] = ACTIONS(2475),
    [anon_sym_static] = ACTIONS(2475),
    [anon_sym_register] = ACTIONS(2475),
    [anon_sym_inline] = ACTIONS(2475),
    [anon_sym___inline] = ACTIONS(2475),
    [anon_sym___inline__] = ACTIONS(2475),
    [anon_sym___forceinline] = ACTIONS(2475),
    [anon_sym_thread_local] = ACTIONS(2475),
    [anon_sym___thread] = ACTIONS(2475),
    [anon_sym_const] = ACTIONS(2475),
    [anon_sym_constexpr] = ACTIONS(2475),
    [anon_sym_volatile] = ACTIONS(2475),
    [anon_sym_restrict] = ACTIONS(2475),
    [anon_sym___restrict__] = ACTIONS(2475),
    [anon_sym__Atomic] = ACTIONS(2475),
    [anon_sym__Noreturn] = ACTIONS(2475),
    [anon_sym_noreturn] = ACTIONS(2475),
    [anon_sym_mutable] = ACTIONS(2475),
    [anon_sym_constinit] = ACTIONS(2475),
    [anon_sym_consteval] = ACTIONS(2475),
    [anon_sym_PROGMEM] = ACTIONS(2475),
    [aux_sym_primitive_type_token1] = ACTIONS(2475),
    [anon_sym_byte] = ACTIONS(2475),
    [anon_sym_word] = ACTIONS(2475),
    [anon_sym_enum] = ACTIONS(2475),
    [anon_sym_class] = ACTIONS(2475),
    [anon_sym_struct] = ACTIONS(2475),
    [anon_sym_union] = ACTIONS(2475),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2475),
    [anon_sym_decltype] = ACTIONS(2475),
    [anon_sym_virtual] = ACTIONS(2475),
    [anon_sym_alignas] = ACTIONS(2475),
    [anon_sym_explicit] = ACTIONS(2475),
    [anon_sym_typename] = ACTIONS(2475),
    [anon_sym_template] = ACTIONS(2475),
    [anon_sym_operator] = ACTIONS(2475),
    [anon_sym_friend] = ACTIONS(2475),
    [anon_sym_public] = ACTIONS(2475),
    [anon_sym_private] = ACTIONS(2475),
    [anon_sym_protected] = ACTIONS(2475),
    [anon_sym_using] = ACTIONS(2475),
    [anon_sym_static_assert] = ACTIONS(2475),
    [anon_sym_catch] = ACTIONS(5176),
  },
  [1986] = {
    [sym_identifier] = ACTIONS(5179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5181),
    [anon_sym_COMMA] = ACTIONS(5181),
    [anon_sym_RPAREN] = ACTIONS(5181),
    [anon_sym_LPAREN2] = ACTIONS(5181),
    [anon_sym_DASH] = ACTIONS(5179),
    [anon_sym_PLUS] = ACTIONS(5179),
    [anon_sym_STAR] = ACTIONS(5181),
    [anon_sym_SLASH] = ACTIONS(5179),
    [anon_sym_PERCENT] = ACTIONS(5181),
    [anon_sym_PIPE_PIPE] = ACTIONS(5181),
    [anon_sym_AMP_AMP] = ACTIONS(5181),
    [anon_sym_PIPE] = ACTIONS(5179),
    [anon_sym_CARET] = ACTIONS(5181),
    [anon_sym_AMP] = ACTIONS(5179),
    [anon_sym_EQ_EQ] = ACTIONS(5181),
    [anon_sym_BANG_EQ] = ACTIONS(5181),
    [anon_sym_GT] = ACTIONS(5179),
    [anon_sym_GT_EQ] = ACTIONS(5181),
    [anon_sym_LT_EQ] = ACTIONS(5179),
    [anon_sym_LT] = ACTIONS(5179),
    [anon_sym_LT_LT] = ACTIONS(5181),
    [anon_sym_GT_GT] = ACTIONS(5181),
    [anon_sym_SEMI] = ACTIONS(5181),
    [anon_sym___extension__] = ACTIONS(5179),
    [anon_sym___attribute__] = ACTIONS(5179),
    [anon_sym___based] = ACTIONS(5179),
    [anon_sym_LBRACE] = ACTIONS(5181),
    [anon_sym_RBRACE] = ACTIONS(5181),
    [anon_sym_signed] = ACTIONS(5179),
    [anon_sym_unsigned] = ACTIONS(5179),
    [anon_sym_long] = ACTIONS(5179),
    [anon_sym_short] = ACTIONS(5179),
    [anon_sym_LBRACK] = ACTIONS(5181),
    [anon_sym_RBRACK] = ACTIONS(5181),
    [anon_sym_const] = ACTIONS(5179),
    [anon_sym_constexpr] = ACTIONS(5179),
    [anon_sym_volatile] = ACTIONS(5179),
    [anon_sym_restrict] = ACTIONS(5179),
    [anon_sym___restrict__] = ACTIONS(5179),
    [anon_sym__Atomic] = ACTIONS(5179),
    [anon_sym__Noreturn] = ACTIONS(5179),
    [anon_sym_noreturn] = ACTIONS(5179),
    [anon_sym_mutable] = ACTIONS(5179),
    [anon_sym_constinit] = ACTIONS(5179),
    [anon_sym_consteval] = ACTIONS(5179),
    [anon_sym_PROGMEM] = ACTIONS(5179),
    [aux_sym_primitive_type_token1] = ACTIONS(5179),
    [anon_sym_byte] = ACTIONS(5179),
    [anon_sym_word] = ACTIONS(5179),
    [anon_sym_COLON] = ACTIONS(5181),
    [anon_sym_QMARK] = ACTIONS(5181),
    [anon_sym_LT_EQ_GT] = ACTIONS(5181),
    [anon_sym_or] = ACTIONS(5179),
    [anon_sym_and] = ACTIONS(5179),
    [anon_sym_bitor] = ACTIONS(5179),
    [anon_sym_xor] = ACTIONS(5179),
    [anon_sym_bitand] = ACTIONS(5179),
    [anon_sym_not_eq] = ACTIONS(5179),
    [anon_sym_DASH_DASH] = ACTIONS(5181),
    [anon_sym_PLUS_PLUS] = ACTIONS(5181),
    [anon_sym_DOT] = ACTIONS(5179),
    [anon_sym_DOT_STAR] = ACTIONS(5181),
    [anon_sym_DASH_GT] = ACTIONS(5181),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5179),
    [anon_sym_decltype] = ACTIONS(5179),
    [anon_sym_final] = ACTIONS(5179),
    [anon_sym_override] = ACTIONS(5179),
    [anon_sym_requires] = ACTIONS(5179),
  },
  [1987] = {
    [sym_identifier] = ACTIONS(4918),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4920),
    [anon_sym_COMMA] = ACTIONS(4920),
    [anon_sym_RPAREN] = ACTIONS(4920),
    [anon_sym_LPAREN2] = ACTIONS(4920),
    [anon_sym_DASH] = ACTIONS(4918),
    [anon_sym_PLUS] = ACTIONS(4918),
    [anon_sym_STAR] = ACTIONS(4920),
    [anon_sym_SLASH] = ACTIONS(4918),
    [anon_sym_PERCENT] = ACTIONS(4920),
    [anon_sym_PIPE_PIPE] = ACTIONS(4920),
    [anon_sym_AMP_AMP] = ACTIONS(4920),
    [anon_sym_PIPE] = ACTIONS(4918),
    [anon_sym_CARET] = ACTIONS(4920),
    [anon_sym_AMP] = ACTIONS(4918),
    [anon_sym_EQ_EQ] = ACTIONS(4920),
    [anon_sym_BANG_EQ] = ACTIONS(4920),
    [anon_sym_GT] = ACTIONS(4918),
    [anon_sym_GT_EQ] = ACTIONS(4920),
    [anon_sym_LT_EQ] = ACTIONS(4918),
    [anon_sym_LT] = ACTIONS(4918),
    [anon_sym_LT_LT] = ACTIONS(4920),
    [anon_sym_GT_GT] = ACTIONS(4920),
    [anon_sym_SEMI] = ACTIONS(4920),
    [anon_sym___extension__] = ACTIONS(4918),
    [anon_sym___attribute__] = ACTIONS(4918),
    [anon_sym___based] = ACTIONS(4918),
    [anon_sym_LBRACE] = ACTIONS(4920),
    [anon_sym_RBRACE] = ACTIONS(4920),
    [anon_sym_signed] = ACTIONS(4918),
    [anon_sym_unsigned] = ACTIONS(4918),
    [anon_sym_long] = ACTIONS(4918),
    [anon_sym_short] = ACTIONS(4918),
    [anon_sym_LBRACK] = ACTIONS(4920),
    [anon_sym_RBRACK] = ACTIONS(4920),
    [anon_sym_const] = ACTIONS(4918),
    [anon_sym_constexpr] = ACTIONS(4918),
    [anon_sym_volatile] = ACTIONS(4918),
    [anon_sym_restrict] = ACTIONS(4918),
    [anon_sym___restrict__] = ACTIONS(4918),
    [anon_sym__Atomic] = ACTIONS(4918),
    [anon_sym__Noreturn] = ACTIONS(4918),
    [anon_sym_noreturn] = ACTIONS(4918),
    [anon_sym_mutable] = ACTIONS(4918),
    [anon_sym_constinit] = ACTIONS(4918),
    [anon_sym_consteval] = ACTIONS(4918),
    [anon_sym_PROGMEM] = ACTIONS(4918),
    [aux_sym_primitive_type_token1] = ACTIONS(4918),
    [anon_sym_byte] = ACTIONS(4918),
    [anon_sym_word] = ACTIONS(4918),
    [anon_sym_COLON] = ACTIONS(4920),
    [anon_sym_QMARK] = ACTIONS(4920),
    [anon_sym_LT_EQ_GT] = ACTIONS(4920),
    [anon_sym_or] = ACTIONS(4918),
    [anon_sym_and] = ACTIONS(4918),
    [anon_sym_bitor] = ACTIONS(4918),
    [anon_sym_xor] = ACTIONS(4918),
    [anon_sym_bitand] = ACTIONS(4918),
    [anon_sym_not_eq] = ACTIONS(4918),
    [anon_sym_DASH_DASH] = ACTIONS(4920),
    [anon_sym_PLUS_PLUS] = ACTIONS(4920),
    [anon_sym_DOT] = ACTIONS(4918),
    [anon_sym_DOT_STAR] = ACTIONS(4920),
    [anon_sym_DASH_GT] = ACTIONS(4920),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4918),
    [anon_sym_decltype] = ACTIONS(4918),
    [anon_sym_final] = ACTIONS(4918),
    [anon_sym_override] = ACTIONS(4918),
    [anon_sym_requires] = ACTIONS(4918),
  },
  [1988] = {
    [sym_identifier] = ACTIONS(5183),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5185),
    [anon_sym_COMMA] = ACTIONS(5185),
    [anon_sym_RPAREN] = ACTIONS(5185),
    [anon_sym_LPAREN2] = ACTIONS(5185),
    [anon_sym_DASH] = ACTIONS(5183),
    [anon_sym_PLUS] = ACTIONS(5183),
    [anon_sym_STAR] = ACTIONS(5185),
    [anon_sym_SLASH] = ACTIONS(5183),
    [anon_sym_PERCENT] = ACTIONS(5185),
    [anon_sym_PIPE_PIPE] = ACTIONS(5185),
    [anon_sym_AMP_AMP] = ACTIONS(5185),
    [anon_sym_PIPE] = ACTIONS(5183),
    [anon_sym_CARET] = ACTIONS(5185),
    [anon_sym_AMP] = ACTIONS(5183),
    [anon_sym_EQ_EQ] = ACTIONS(5185),
    [anon_sym_BANG_EQ] = ACTIONS(5185),
    [anon_sym_GT] = ACTIONS(5183),
    [anon_sym_GT_EQ] = ACTIONS(5185),
    [anon_sym_LT_EQ] = ACTIONS(5183),
    [anon_sym_LT] = ACTIONS(5183),
    [anon_sym_LT_LT] = ACTIONS(5185),
    [anon_sym_GT_GT] = ACTIONS(5185),
    [anon_sym_SEMI] = ACTIONS(5185),
    [anon_sym___extension__] = ACTIONS(5183),
    [anon_sym___attribute__] = ACTIONS(5183),
    [anon_sym___based] = ACTIONS(5183),
    [anon_sym_LBRACE] = ACTIONS(5185),
    [anon_sym_RBRACE] = ACTIONS(5185),
    [anon_sym_signed] = ACTIONS(5183),
    [anon_sym_unsigned] = ACTIONS(5183),
    [anon_sym_long] = ACTIONS(5183),
    [anon_sym_short] = ACTIONS(5183),
    [anon_sym_LBRACK] = ACTIONS(5185),
    [anon_sym_RBRACK] = ACTIONS(5185),
    [anon_sym_const] = ACTIONS(5183),
    [anon_sym_constexpr] = ACTIONS(5183),
    [anon_sym_volatile] = ACTIONS(5183),
    [anon_sym_restrict] = ACTIONS(5183),
    [anon_sym___restrict__] = ACTIONS(5183),
    [anon_sym__Atomic] = ACTIONS(5183),
    [anon_sym__Noreturn] = ACTIONS(5183),
    [anon_sym_noreturn] = ACTIONS(5183),
    [anon_sym_mutable] = ACTIONS(5183),
    [anon_sym_constinit] = ACTIONS(5183),
    [anon_sym_consteval] = ACTIONS(5183),
    [anon_sym_PROGMEM] = ACTIONS(5183),
    [aux_sym_primitive_type_token1] = ACTIONS(5183),
    [anon_sym_byte] = ACTIONS(5183),
    [anon_sym_word] = ACTIONS(5183),
    [anon_sym_COLON] = ACTIONS(5185),
    [anon_sym_QMARK] = ACTIONS(5185),
    [anon_sym_LT_EQ_GT] = ACTIONS(5185),
    [anon_sym_or] = ACTIONS(5183),
    [anon_sym_and] = ACTIONS(5183),
    [anon_sym_bitor] = ACTIONS(5183),
    [anon_sym_xor] = ACTIONS(5183),
    [anon_sym_bitand] = ACTIONS(5183),
    [anon_sym_not_eq] = ACTIONS(5183),
    [anon_sym_DASH_DASH] = ACTIONS(5185),
    [anon_sym_PLUS_PLUS] = ACTIONS(5185),
    [anon_sym_DOT] = ACTIONS(5183),
    [anon_sym_DOT_STAR] = ACTIONS(5185),
    [anon_sym_DASH_GT] = ACTIONS(5185),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5183),
    [anon_sym_decltype] = ACTIONS(5183),
    [anon_sym_final] = ACTIONS(5183),
    [anon_sym_override] = ACTIONS(5183),
    [anon_sym_requires] = ACTIONS(5183),
  },
  [1989] = {
    [sym_catch_clause] = STATE(1952),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1952),
    [sym_identifier] = ACTIONS(2482),
    [aux_sym_preproc_def_token1] = ACTIONS(2482),
    [aux_sym_preproc_if_token1] = ACTIONS(2482),
    [aux_sym_preproc_if_token2] = ACTIONS(2482),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2482),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2482),
    [sym_preproc_directive] = ACTIONS(2482),
    [anon_sym_LPAREN2] = ACTIONS(2484),
    [anon_sym_TILDE] = ACTIONS(2484),
    [anon_sym_STAR] = ACTIONS(2484),
    [anon_sym_AMP_AMP] = ACTIONS(2484),
    [anon_sym_AMP] = ACTIONS(2482),
    [anon_sym___extension__] = ACTIONS(2482),
    [anon_sym_typedef] = ACTIONS(2482),
    [anon_sym_extern] = ACTIONS(2482),
    [anon_sym___attribute__] = ACTIONS(2482),
    [anon_sym_COLON_COLON] = ACTIONS(2484),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2484),
    [anon_sym___declspec] = ACTIONS(2482),
    [anon_sym___based] = ACTIONS(2482),
    [anon_sym_signed] = ACTIONS(2482),
    [anon_sym_unsigned] = ACTIONS(2482),
    [anon_sym_long] = ACTIONS(2482),
    [anon_sym_short] = ACTIONS(2482),
    [anon_sym_LBRACK] = ACTIONS(2482),
    [anon_sym_static] = ACTIONS(2482),
    [anon_sym_register] = ACTIONS(2482),
    [anon_sym_inline] = ACTIONS(2482),
    [anon_sym___inline] = ACTIONS(2482),
    [anon_sym___inline__] = ACTIONS(2482),
    [anon_sym___forceinline] = ACTIONS(2482),
    [anon_sym_thread_local] = ACTIONS(2482),
    [anon_sym___thread] = ACTIONS(2482),
    [anon_sym_const] = ACTIONS(2482),
    [anon_sym_constexpr] = ACTIONS(2482),
    [anon_sym_volatile] = ACTIONS(2482),
    [anon_sym_restrict] = ACTIONS(2482),
    [anon_sym___restrict__] = ACTIONS(2482),
    [anon_sym__Atomic] = ACTIONS(2482),
    [anon_sym__Noreturn] = ACTIONS(2482),
    [anon_sym_noreturn] = ACTIONS(2482),
    [anon_sym_mutable] = ACTIONS(2482),
    [anon_sym_constinit] = ACTIONS(2482),
    [anon_sym_consteval] = ACTIONS(2482),
    [anon_sym_PROGMEM] = ACTIONS(2482),
    [aux_sym_primitive_type_token1] = ACTIONS(2482),
    [anon_sym_byte] = ACTIONS(2482),
    [anon_sym_word] = ACTIONS(2482),
    [anon_sym_enum] = ACTIONS(2482),
    [anon_sym_class] = ACTIONS(2482),
    [anon_sym_struct] = ACTIONS(2482),
    [anon_sym_union] = ACTIONS(2482),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2482),
    [anon_sym_decltype] = ACTIONS(2482),
    [anon_sym_virtual] = ACTIONS(2482),
    [anon_sym_alignas] = ACTIONS(2482),
    [anon_sym_explicit] = ACTIONS(2482),
    [anon_sym_typename] = ACTIONS(2482),
    [anon_sym_template] = ACTIONS(2482),
    [anon_sym_operator] = ACTIONS(2482),
    [anon_sym_friend] = ACTIONS(2482),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_using] = ACTIONS(2482),
    [anon_sym_static_assert] = ACTIONS(2482),
    [anon_sym_catch] = ACTIONS(5133),
  },
  [1990] = {
    [sym_identifier] = ACTIONS(4924),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4926),
    [anon_sym_COMMA] = ACTIONS(4926),
    [anon_sym_RPAREN] = ACTIONS(4926),
    [anon_sym_LPAREN2] = ACTIONS(4926),
    [anon_sym_DASH] = ACTIONS(4924),
    [anon_sym_PLUS] = ACTIONS(4924),
    [anon_sym_STAR] = ACTIONS(4926),
    [anon_sym_SLASH] = ACTIONS(4924),
    [anon_sym_PERCENT] = ACTIONS(4926),
    [anon_sym_PIPE_PIPE] = ACTIONS(4926),
    [anon_sym_AMP_AMP] = ACTIONS(4926),
    [anon_sym_PIPE] = ACTIONS(4924),
    [anon_sym_CARET] = ACTIONS(4926),
    [anon_sym_AMP] = ACTIONS(4924),
    [anon_sym_EQ_EQ] = ACTIONS(4926),
    [anon_sym_BANG_EQ] = ACTIONS(4926),
    [anon_sym_GT] = ACTIONS(4924),
    [anon_sym_GT_EQ] = ACTIONS(4926),
    [anon_sym_LT_EQ] = ACTIONS(4924),
    [anon_sym_LT] = ACTIONS(4924),
    [anon_sym_LT_LT] = ACTIONS(4926),
    [anon_sym_GT_GT] = ACTIONS(4926),
    [anon_sym_SEMI] = ACTIONS(4926),
    [anon_sym___extension__] = ACTIONS(4924),
    [anon_sym___attribute__] = ACTIONS(4924),
    [anon_sym___based] = ACTIONS(4924),
    [anon_sym_LBRACE] = ACTIONS(4926),
    [anon_sym_RBRACE] = ACTIONS(4926),
    [anon_sym_signed] = ACTIONS(4924),
    [anon_sym_unsigned] = ACTIONS(4924),
    [anon_sym_long] = ACTIONS(4924),
    [anon_sym_short] = ACTIONS(4924),
    [anon_sym_LBRACK] = ACTIONS(4926),
    [anon_sym_RBRACK] = ACTIONS(4926),
    [anon_sym_const] = ACTIONS(4924),
    [anon_sym_constexpr] = ACTIONS(4924),
    [anon_sym_volatile] = ACTIONS(4924),
    [anon_sym_restrict] = ACTIONS(4924),
    [anon_sym___restrict__] = ACTIONS(4924),
    [anon_sym__Atomic] = ACTIONS(4924),
    [anon_sym__Noreturn] = ACTIONS(4924),
    [anon_sym_noreturn] = ACTIONS(4924),
    [anon_sym_mutable] = ACTIONS(4924),
    [anon_sym_constinit] = ACTIONS(4924),
    [anon_sym_consteval] = ACTIONS(4924),
    [anon_sym_PROGMEM] = ACTIONS(4924),
    [aux_sym_primitive_type_token1] = ACTIONS(4924),
    [anon_sym_byte] = ACTIONS(4924),
    [anon_sym_word] = ACTIONS(4924),
    [anon_sym_COLON] = ACTIONS(4926),
    [anon_sym_QMARK] = ACTIONS(4926),
    [anon_sym_LT_EQ_GT] = ACTIONS(4926),
    [anon_sym_or] = ACTIONS(4924),
    [anon_sym_and] = ACTIONS(4924),
    [anon_sym_bitor] = ACTIONS(4924),
    [anon_sym_xor] = ACTIONS(4924),
    [anon_sym_bitand] = ACTIONS(4924),
    [anon_sym_not_eq] = ACTIONS(4924),
    [anon_sym_DASH_DASH] = ACTIONS(4926),
    [anon_sym_PLUS_PLUS] = ACTIONS(4926),
    [anon_sym_DOT] = ACTIONS(4924),
    [anon_sym_DOT_STAR] = ACTIONS(4926),
    [anon_sym_DASH_GT] = ACTIONS(4926),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4924),
    [anon_sym_decltype] = ACTIONS(4924),
    [anon_sym_final] = ACTIONS(4924),
    [anon_sym_override] = ACTIONS(4924),
    [anon_sym_requires] = ACTIONS(4924),
  },
  [1991] = {
    [sym_catch_clause] = STATE(1985),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1985),
    [sym_identifier] = ACTIONS(2488),
    [aux_sym_preproc_def_token1] = ACTIONS(2488),
    [aux_sym_preproc_if_token1] = ACTIONS(2488),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2488),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2488),
    [sym_preproc_directive] = ACTIONS(2488),
    [anon_sym_LPAREN2] = ACTIONS(2490),
    [anon_sym_TILDE] = ACTIONS(2490),
    [anon_sym_STAR] = ACTIONS(2490),
    [anon_sym_AMP_AMP] = ACTIONS(2490),
    [anon_sym_AMP] = ACTIONS(2488),
    [anon_sym___extension__] = ACTIONS(2488),
    [anon_sym_typedef] = ACTIONS(2488),
    [anon_sym_extern] = ACTIONS(2488),
    [anon_sym___attribute__] = ACTIONS(2488),
    [anon_sym_COLON_COLON] = ACTIONS(2490),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2490),
    [anon_sym___declspec] = ACTIONS(2488),
    [anon_sym___based] = ACTIONS(2488),
    [anon_sym_RBRACE] = ACTIONS(2490),
    [anon_sym_signed] = ACTIONS(2488),
    [anon_sym_unsigned] = ACTIONS(2488),
    [anon_sym_long] = ACTIONS(2488),
    [anon_sym_short] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(2488),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_register] = ACTIONS(2488),
    [anon_sym_inline] = ACTIONS(2488),
    [anon_sym___inline] = ACTIONS(2488),
    [anon_sym___inline__] = ACTIONS(2488),
    [anon_sym___forceinline] = ACTIONS(2488),
    [anon_sym_thread_local] = ACTIONS(2488),
    [anon_sym___thread] = ACTIONS(2488),
    [anon_sym_const] = ACTIONS(2488),
    [anon_sym_constexpr] = ACTIONS(2488),
    [anon_sym_volatile] = ACTIONS(2488),
    [anon_sym_restrict] = ACTIONS(2488),
    [anon_sym___restrict__] = ACTIONS(2488),
    [anon_sym__Atomic] = ACTIONS(2488),
    [anon_sym__Noreturn] = ACTIONS(2488),
    [anon_sym_noreturn] = ACTIONS(2488),
    [anon_sym_mutable] = ACTIONS(2488),
    [anon_sym_constinit] = ACTIONS(2488),
    [anon_sym_consteval] = ACTIONS(2488),
    [anon_sym_PROGMEM] = ACTIONS(2488),
    [aux_sym_primitive_type_token1] = ACTIONS(2488),
    [anon_sym_byte] = ACTIONS(2488),
    [anon_sym_word] = ACTIONS(2488),
    [anon_sym_enum] = ACTIONS(2488),
    [anon_sym_class] = ACTIONS(2488),
    [anon_sym_struct] = ACTIONS(2488),
    [anon_sym_union] = ACTIONS(2488),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2488),
    [anon_sym_decltype] = ACTIONS(2488),
    [anon_sym_virtual] = ACTIONS(2488),
    [anon_sym_alignas] = ACTIONS(2488),
    [anon_sym_explicit] = ACTIONS(2488),
    [anon_sym_typename] = ACTIONS(2488),
    [anon_sym_template] = ACTIONS(2488),
    [anon_sym_operator] = ACTIONS(2488),
    [anon_sym_friend] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_using] = ACTIONS(2488),
    [anon_sym_static_assert] = ACTIONS(2488),
    [anon_sym_catch] = ACTIONS(5028),
  },
  [1992] = {
    [sym_catch_clause] = STATE(1985),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1985),
    [sym_identifier] = ACTIONS(2492),
    [aux_sym_preproc_def_token1] = ACTIONS(2492),
    [aux_sym_preproc_if_token1] = ACTIONS(2492),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2492),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2492),
    [sym_preproc_directive] = ACTIONS(2492),
    [anon_sym_LPAREN2] = ACTIONS(2494),
    [anon_sym_TILDE] = ACTIONS(2494),
    [anon_sym_STAR] = ACTIONS(2494),
    [anon_sym_AMP_AMP] = ACTIONS(2494),
    [anon_sym_AMP] = ACTIONS(2492),
    [anon_sym___extension__] = ACTIONS(2492),
    [anon_sym_typedef] = ACTIONS(2492),
    [anon_sym_extern] = ACTIONS(2492),
    [anon_sym___attribute__] = ACTIONS(2492),
    [anon_sym_COLON_COLON] = ACTIONS(2494),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2494),
    [anon_sym___declspec] = ACTIONS(2492),
    [anon_sym___based] = ACTIONS(2492),
    [anon_sym_RBRACE] = ACTIONS(2494),
    [anon_sym_signed] = ACTIONS(2492),
    [anon_sym_unsigned] = ACTIONS(2492),
    [anon_sym_long] = ACTIONS(2492),
    [anon_sym_short] = ACTIONS(2492),
    [anon_sym_LBRACK] = ACTIONS(2492),
    [anon_sym_static] = ACTIONS(2492),
    [anon_sym_register] = ACTIONS(2492),
    [anon_sym_inline] = ACTIONS(2492),
    [anon_sym___inline] = ACTIONS(2492),
    [anon_sym___inline__] = ACTIONS(2492),
    [anon_sym___forceinline] = ACTIONS(2492),
    [anon_sym_thread_local] = ACTIONS(2492),
    [anon_sym___thread] = ACTIONS(2492),
    [anon_sym_const] = ACTIONS(2492),
    [anon_sym_constexpr] = ACTIONS(2492),
    [anon_sym_volatile] = ACTIONS(2492),
    [anon_sym_restrict] = ACTIONS(2492),
    [anon_sym___restrict__] = ACTIONS(2492),
    [anon_sym__Atomic] = ACTIONS(2492),
    [anon_sym__Noreturn] = ACTIONS(2492),
    [anon_sym_noreturn] = ACTIONS(2492),
    [anon_sym_mutable] = ACTIONS(2492),
    [anon_sym_constinit] = ACTIONS(2492),
    [anon_sym_consteval] = ACTIONS(2492),
    [anon_sym_PROGMEM] = ACTIONS(2492),
    [aux_sym_primitive_type_token1] = ACTIONS(2492),
    [anon_sym_byte] = ACTIONS(2492),
    [anon_sym_word] = ACTIONS(2492),
    [anon_sym_enum] = ACTIONS(2492),
    [anon_sym_class] = ACTIONS(2492),
    [anon_sym_struct] = ACTIONS(2492),
    [anon_sym_union] = ACTIONS(2492),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2492),
    [anon_sym_decltype] = ACTIONS(2492),
    [anon_sym_virtual] = ACTIONS(2492),
    [anon_sym_alignas] = ACTIONS(2492),
    [anon_sym_explicit] = ACTIONS(2492),
    [anon_sym_typename] = ACTIONS(2492),
    [anon_sym_template] = ACTIONS(2492),
    [anon_sym_operator] = ACTIONS(2492),
    [anon_sym_friend] = ACTIONS(2492),
    [anon_sym_public] = ACTIONS(2492),
    [anon_sym_private] = ACTIONS(2492),
    [anon_sym_protected] = ACTIONS(2492),
    [anon_sym_using] = ACTIONS(2492),
    [anon_sym_static_assert] = ACTIONS(2492),
    [anon_sym_catch] = ACTIONS(5028),
  },
  [1993] = {
    [sym_identifier] = ACTIONS(1957),
    [aux_sym_preproc_def_token1] = ACTIONS(1957),
    [anon_sym_COMMA] = ACTIONS(2743),
    [aux_sym_preproc_if_token1] = ACTIONS(1957),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1957),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1957),
    [sym_preproc_directive] = ACTIONS(1957),
    [anon_sym_LPAREN2] = ACTIONS(1955),
    [anon_sym_TILDE] = ACTIONS(1955),
    [anon_sym_STAR] = ACTIONS(1955),
    [anon_sym_AMP_AMP] = ACTIONS(1955),
    [anon_sym_AMP] = ACTIONS(1957),
    [anon_sym_SEMI] = ACTIONS(2743),
    [anon_sym___extension__] = ACTIONS(1957),
    [anon_sym_typedef] = ACTIONS(1957),
    [anon_sym_extern] = ACTIONS(1957),
    [anon_sym___attribute__] = ACTIONS(1957),
    [anon_sym_COLON_COLON] = ACTIONS(1955),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1955),
    [anon_sym___declspec] = ACTIONS(1957),
    [anon_sym___based] = ACTIONS(1957),
    [anon_sym_RBRACE] = ACTIONS(1955),
    [anon_sym_signed] = ACTIONS(1957),
    [anon_sym_unsigned] = ACTIONS(1957),
    [anon_sym_long] = ACTIONS(1957),
    [anon_sym_short] = ACTIONS(1957),
    [anon_sym_LBRACK] = ACTIONS(1957),
    [anon_sym_static] = ACTIONS(1957),
    [anon_sym_register] = ACTIONS(1957),
    [anon_sym_inline] = ACTIONS(1957),
    [anon_sym___inline] = ACTIONS(1957),
    [anon_sym___inline__] = ACTIONS(1957),
    [anon_sym___forceinline] = ACTIONS(1957),
    [anon_sym_thread_local] = ACTIONS(1957),
    [anon_sym___thread] = ACTIONS(1957),
    [anon_sym_const] = ACTIONS(1957),
    [anon_sym_constexpr] = ACTIONS(1957),
    [anon_sym_volatile] = ACTIONS(1957),
    [anon_sym_restrict] = ACTIONS(1957),
    [anon_sym___restrict__] = ACTIONS(1957),
    [anon_sym__Atomic] = ACTIONS(1957),
    [anon_sym__Noreturn] = ACTIONS(1957),
    [anon_sym_noreturn] = ACTIONS(1957),
    [anon_sym_mutable] = ACTIONS(1957),
    [anon_sym_constinit] = ACTIONS(1957),
    [anon_sym_consteval] = ACTIONS(1957),
    [anon_sym_PROGMEM] = ACTIONS(1957),
    [aux_sym_primitive_type_token1] = ACTIONS(1957),
    [anon_sym_byte] = ACTIONS(1957),
    [anon_sym_word] = ACTIONS(1957),
    [anon_sym_enum] = ACTIONS(1957),
    [anon_sym_class] = ACTIONS(1957),
    [anon_sym_struct] = ACTIONS(1957),
    [anon_sym_union] = ACTIONS(1957),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1957),
    [anon_sym_decltype] = ACTIONS(1957),
    [anon_sym_virtual] = ACTIONS(1957),
    [anon_sym_alignas] = ACTIONS(1957),
    [anon_sym_explicit] = ACTIONS(1957),
    [anon_sym_typename] = ACTIONS(1957),
    [anon_sym_template] = ACTIONS(1957),
    [anon_sym_operator] = ACTIONS(1957),
    [anon_sym_friend] = ACTIONS(1957),
    [anon_sym_public] = ACTIONS(1957),
    [anon_sym_private] = ACTIONS(1957),
    [anon_sym_protected] = ACTIONS(1957),
    [anon_sym_using] = ACTIONS(1957),
    [anon_sym_static_assert] = ACTIONS(1957),
  },
  [1994] = {
    [sym_identifier] = ACTIONS(5101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5103),
    [anon_sym_COMMA] = ACTIONS(5103),
    [anon_sym_RPAREN] = ACTIONS(5103),
    [aux_sym_preproc_if_token2] = ACTIONS(5103),
    [aux_sym_preproc_else_token1] = ACTIONS(5103),
    [aux_sym_preproc_elif_token1] = ACTIONS(5101),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5103),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5103),
    [anon_sym_LPAREN2] = ACTIONS(5103),
    [anon_sym_DASH] = ACTIONS(5101),
    [anon_sym_PLUS] = ACTIONS(5101),
    [anon_sym_STAR] = ACTIONS(5101),
    [anon_sym_SLASH] = ACTIONS(5101),
    [anon_sym_PERCENT] = ACTIONS(5101),
    [anon_sym_PIPE_PIPE] = ACTIONS(5103),
    [anon_sym_AMP_AMP] = ACTIONS(5103),
    [anon_sym_PIPE] = ACTIONS(5101),
    [anon_sym_CARET] = ACTIONS(5101),
    [anon_sym_AMP] = ACTIONS(5101),
    [anon_sym_EQ_EQ] = ACTIONS(5103),
    [anon_sym_BANG_EQ] = ACTIONS(5103),
    [anon_sym_GT] = ACTIONS(5101),
    [anon_sym_GT_EQ] = ACTIONS(5103),
    [anon_sym_LT_EQ] = ACTIONS(5101),
    [anon_sym_LT] = ACTIONS(5101),
    [anon_sym_LT_LT] = ACTIONS(5101),
    [anon_sym_GT_GT] = ACTIONS(5101),
    [anon_sym_SEMI] = ACTIONS(5103),
    [anon_sym___attribute__] = ACTIONS(5101),
    [anon_sym_LBRACE] = ACTIONS(5103),
    [anon_sym_RBRACE] = ACTIONS(5103),
    [anon_sym_signed] = ACTIONS(5101),
    [anon_sym_unsigned] = ACTIONS(5101),
    [anon_sym_long] = ACTIONS(5101),
    [anon_sym_short] = ACTIONS(5101),
    [anon_sym_LBRACK] = ACTIONS(5103),
    [anon_sym_RBRACK] = ACTIONS(5103),
    [anon_sym_EQ] = ACTIONS(5101),
    [anon_sym_COLON] = ACTIONS(5103),
    [anon_sym_QMARK] = ACTIONS(5103),
    [anon_sym_STAR_EQ] = ACTIONS(5103),
    [anon_sym_SLASH_EQ] = ACTIONS(5103),
    [anon_sym_PERCENT_EQ] = ACTIONS(5103),
    [anon_sym_PLUS_EQ] = ACTIONS(5103),
    [anon_sym_DASH_EQ] = ACTIONS(5103),
    [anon_sym_LT_LT_EQ] = ACTIONS(5103),
    [anon_sym_GT_GT_EQ] = ACTIONS(5103),
    [anon_sym_AMP_EQ] = ACTIONS(5103),
    [anon_sym_CARET_EQ] = ACTIONS(5103),
    [anon_sym_PIPE_EQ] = ACTIONS(5103),
    [anon_sym_and_eq] = ACTIONS(5101),
    [anon_sym_or_eq] = ACTIONS(5101),
    [anon_sym_xor_eq] = ACTIONS(5101),
    [anon_sym_LT_EQ_GT] = ACTIONS(5103),
    [anon_sym_or] = ACTIONS(5101),
    [anon_sym_and] = ACTIONS(5101),
    [anon_sym_bitor] = ACTIONS(5101),
    [anon_sym_xor] = ACTIONS(5101),
    [anon_sym_bitand] = ACTIONS(5101),
    [anon_sym_not_eq] = ACTIONS(5101),
    [anon_sym_DASH_DASH] = ACTIONS(5103),
    [anon_sym_PLUS_PLUS] = ACTIONS(5103),
    [anon_sym_DOT] = ACTIONS(5101),
    [anon_sym_DOT_STAR] = ACTIONS(5103),
    [anon_sym_DASH_GT] = ACTIONS(5103),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5101),
    [anon_sym_decltype] = ACTIONS(5101),
  },
  [1995] = {
    [sym_template_argument_list] = STATE(2017),
    [sym_identifier] = ACTIONS(5187),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3785),
    [anon_sym_COMMA] = ACTIONS(3785),
    [anon_sym_RPAREN] = ACTIONS(3785),
    [aux_sym_preproc_if_token2] = ACTIONS(3785),
    [aux_sym_preproc_else_token1] = ACTIONS(3785),
    [aux_sym_preproc_elif_token1] = ACTIONS(5187),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3785),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3785),
    [anon_sym_LPAREN2] = ACTIONS(3785),
    [anon_sym_DASH] = ACTIONS(5187),
    [anon_sym_PLUS] = ACTIONS(5187),
    [anon_sym_STAR] = ACTIONS(5187),
    [anon_sym_SLASH] = ACTIONS(5187),
    [anon_sym_PERCENT] = ACTIONS(5187),
    [anon_sym_PIPE_PIPE] = ACTIONS(3785),
    [anon_sym_AMP_AMP] = ACTIONS(3785),
    [anon_sym_PIPE] = ACTIONS(5187),
    [anon_sym_CARET] = ACTIONS(5187),
    [anon_sym_AMP] = ACTIONS(5187),
    [anon_sym_EQ_EQ] = ACTIONS(3785),
    [anon_sym_BANG_EQ] = ACTIONS(3785),
    [anon_sym_GT] = ACTIONS(5187),
    [anon_sym_GT_EQ] = ACTIONS(3785),
    [anon_sym_LT_EQ] = ACTIONS(5187),
    [anon_sym_LT] = ACTIONS(5189),
    [anon_sym_LT_LT] = ACTIONS(5187),
    [anon_sym_GT_GT] = ACTIONS(5187),
    [anon_sym_SEMI] = ACTIONS(3785),
    [anon_sym___attribute__] = ACTIONS(5187),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(3785),
    [anon_sym_RBRACE] = ACTIONS(3785),
    [anon_sym_LBRACK] = ACTIONS(3785),
    [anon_sym_RBRACK] = ACTIONS(3785),
    [anon_sym_EQ] = ACTIONS(5187),
    [anon_sym_COLON] = ACTIONS(5187),
    [anon_sym_QMARK] = ACTIONS(3785),
    [anon_sym_STAR_EQ] = ACTIONS(3785),
    [anon_sym_SLASH_EQ] = ACTIONS(3785),
    [anon_sym_PERCENT_EQ] = ACTIONS(3785),
    [anon_sym_PLUS_EQ] = ACTIONS(3785),
    [anon_sym_DASH_EQ] = ACTIONS(3785),
    [anon_sym_LT_LT_EQ] = ACTIONS(3785),
    [anon_sym_GT_GT_EQ] = ACTIONS(3785),
    [anon_sym_AMP_EQ] = ACTIONS(3785),
    [anon_sym_CARET_EQ] = ACTIONS(3785),
    [anon_sym_PIPE_EQ] = ACTIONS(3785),
    [anon_sym_and_eq] = ACTIONS(5187),
    [anon_sym_or_eq] = ACTIONS(5187),
    [anon_sym_xor_eq] = ACTIONS(5187),
    [anon_sym_LT_EQ_GT] = ACTIONS(3785),
    [anon_sym_or] = ACTIONS(5187),
    [anon_sym_and] = ACTIONS(5187),
    [anon_sym_bitor] = ACTIONS(5187),
    [anon_sym_xor] = ACTIONS(5187),
    [anon_sym_bitand] = ACTIONS(5187),
    [anon_sym_not_eq] = ACTIONS(5187),
    [anon_sym_DASH_DASH] = ACTIONS(3785),
    [anon_sym_PLUS_PLUS] = ACTIONS(3785),
    [anon_sym_DOT] = ACTIONS(5187),
    [anon_sym_DOT_STAR] = ACTIONS(3785),
    [anon_sym_DASH_GT] = ACTIONS(3785),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5187),
    [anon_sym_decltype] = ACTIONS(5187),
    [anon_sym_final] = ACTIONS(5187),
    [anon_sym_override] = ACTIONS(5187),
  },
  [1996] = {
    [sym_primitive_type] = STATE(2397),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2044),
    [sym_identifier] = ACTIONS(5191),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4934),
    [anon_sym_COMMA] = ACTIONS(4934),
    [anon_sym_RPAREN] = ACTIONS(4934),
    [anon_sym_LPAREN2] = ACTIONS(4934),
    [anon_sym_DASH] = ACTIONS(4936),
    [anon_sym_PLUS] = ACTIONS(4936),
    [anon_sym_STAR] = ACTIONS(4936),
    [anon_sym_SLASH] = ACTIONS(4936),
    [anon_sym_PERCENT] = ACTIONS(4936),
    [anon_sym_PIPE_PIPE] = ACTIONS(4934),
    [anon_sym_AMP_AMP] = ACTIONS(4934),
    [anon_sym_PIPE] = ACTIONS(4936),
    [anon_sym_CARET] = ACTIONS(4936),
    [anon_sym_AMP] = ACTIONS(4936),
    [anon_sym_EQ_EQ] = ACTIONS(4934),
    [anon_sym_BANG_EQ] = ACTIONS(4934),
    [anon_sym_GT] = ACTIONS(4936),
    [anon_sym_GT_EQ] = ACTIONS(4934),
    [anon_sym_LT_EQ] = ACTIONS(4936),
    [anon_sym_LT] = ACTIONS(4936),
    [anon_sym_LT_LT] = ACTIONS(4936),
    [anon_sym_GT_GT] = ACTIONS(4936),
    [anon_sym_SEMI] = ACTIONS(4934),
    [anon_sym___attribute__] = ACTIONS(4936),
    [anon_sym_LBRACE] = ACTIONS(4934),
    [anon_sym_RBRACE] = ACTIONS(4934),
    [anon_sym_signed] = ACTIONS(5193),
    [anon_sym_unsigned] = ACTIONS(5193),
    [anon_sym_long] = ACTIONS(5193),
    [anon_sym_short] = ACTIONS(5193),
    [anon_sym_LBRACK] = ACTIONS(4934),
    [anon_sym_RBRACK] = ACTIONS(4934),
    [anon_sym_EQ] = ACTIONS(4936),
    [aux_sym_primitive_type_token1] = ACTIONS(5195),
    [anon_sym_byte] = ACTIONS(5195),
    [anon_sym_word] = ACTIONS(5195),
    [anon_sym_COLON] = ACTIONS(4934),
    [anon_sym_QMARK] = ACTIONS(4934),
    [anon_sym_STAR_EQ] = ACTIONS(4934),
    [anon_sym_SLASH_EQ] = ACTIONS(4934),
    [anon_sym_PERCENT_EQ] = ACTIONS(4934),
    [anon_sym_PLUS_EQ] = ACTIONS(4934),
    [anon_sym_DASH_EQ] = ACTIONS(4934),
    [anon_sym_LT_LT_EQ] = ACTIONS(4934),
    [anon_sym_GT_GT_EQ] = ACTIONS(4934),
    [anon_sym_AMP_EQ] = ACTIONS(4934),
    [anon_sym_CARET_EQ] = ACTIONS(4934),
    [anon_sym_PIPE_EQ] = ACTIONS(4934),
    [anon_sym_and_eq] = ACTIONS(4936),
    [anon_sym_or_eq] = ACTIONS(4936),
    [anon_sym_xor_eq] = ACTIONS(4936),
    [anon_sym_LT_EQ_GT] = ACTIONS(4934),
    [anon_sym_or] = ACTIONS(4936),
    [anon_sym_and] = ACTIONS(4936),
    [anon_sym_bitor] = ACTIONS(4936),
    [anon_sym_xor] = ACTIONS(4936),
    [anon_sym_bitand] = ACTIONS(4936),
    [anon_sym_not_eq] = ACTIONS(4936),
    [anon_sym_DASH_DASH] = ACTIONS(4934),
    [anon_sym_PLUS_PLUS] = ACTIONS(4934),
    [anon_sym_DOT] = ACTIONS(4936),
    [anon_sym_DOT_STAR] = ACTIONS(4934),
    [anon_sym_DASH_GT] = ACTIONS(4934),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4936),
    [anon_sym_decltype] = ACTIONS(4936),
  },
  [1997] = {
    [sym_string_literal] = STATE(1770),
    [sym_raw_string_literal] = STATE(1770),
    [sym_identifier] = ACTIONS(5197),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5199),
    [anon_sym_COMMA] = ACTIONS(5199),
    [aux_sym_preproc_if_token2] = ACTIONS(5199),
    [aux_sym_preproc_else_token1] = ACTIONS(5199),
    [aux_sym_preproc_elif_token1] = ACTIONS(5197),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5199),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5199),
    [anon_sym_LPAREN2] = ACTIONS(5199),
    [anon_sym_DASH] = ACTIONS(5197),
    [anon_sym_PLUS] = ACTIONS(5197),
    [anon_sym_STAR] = ACTIONS(5197),
    [anon_sym_SLASH] = ACTIONS(5197),
    [anon_sym_PERCENT] = ACTIONS(5197),
    [anon_sym_PIPE_PIPE] = ACTIONS(5199),
    [anon_sym_AMP_AMP] = ACTIONS(5199),
    [anon_sym_PIPE] = ACTIONS(5197),
    [anon_sym_CARET] = ACTIONS(5197),
    [anon_sym_AMP] = ACTIONS(5197),
    [anon_sym_EQ_EQ] = ACTIONS(5199),
    [anon_sym_BANG_EQ] = ACTIONS(5199),
    [anon_sym_GT] = ACTIONS(5197),
    [anon_sym_GT_EQ] = ACTIONS(5199),
    [anon_sym_LT_EQ] = ACTIONS(5197),
    [anon_sym_LT] = ACTIONS(5197),
    [anon_sym_LT_LT] = ACTIONS(5197),
    [anon_sym_GT_GT] = ACTIONS(5197),
    [anon_sym_LBRACK] = ACTIONS(5199),
    [anon_sym_EQ] = ACTIONS(5197),
    [anon_sym_QMARK] = ACTIONS(5199),
    [anon_sym_STAR_EQ] = ACTIONS(5199),
    [anon_sym_SLASH_EQ] = ACTIONS(5199),
    [anon_sym_PERCENT_EQ] = ACTIONS(5199),
    [anon_sym_PLUS_EQ] = ACTIONS(5199),
    [anon_sym_DASH_EQ] = ACTIONS(5199),
    [anon_sym_LT_LT_EQ] = ACTIONS(5199),
    [anon_sym_GT_GT_EQ] = ACTIONS(5199),
    [anon_sym_AMP_EQ] = ACTIONS(5199),
    [anon_sym_CARET_EQ] = ACTIONS(5199),
    [anon_sym_PIPE_EQ] = ACTIONS(5199),
    [anon_sym_and_eq] = ACTIONS(5197),
    [anon_sym_or_eq] = ACTIONS(5197),
    [anon_sym_xor_eq] = ACTIONS(5197),
    [anon_sym_LT_EQ_GT] = ACTIONS(5199),
    [anon_sym_or] = ACTIONS(5197),
    [anon_sym_and] = ACTIONS(5197),
    [anon_sym_bitor] = ACTIONS(5197),
    [anon_sym_xor] = ACTIONS(5197),
    [anon_sym_bitand] = ACTIONS(5197),
    [anon_sym_not_eq] = ACTIONS(5197),
    [anon_sym_DASH_DASH] = ACTIONS(5199),
    [anon_sym_PLUS_PLUS] = ACTIONS(5199),
    [anon_sym_DOT] = ACTIONS(5197),
    [anon_sym_DOT_STAR] = ACTIONS(5199),
    [anon_sym_DASH_GT] = ACTIONS(5199),
    [anon_sym_L_DQUOTE] = ACTIONS(1911),
    [anon_sym_u_DQUOTE] = ACTIONS(1911),
    [anon_sym_U_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8_DQUOTE] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(1911),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(1921),
    [anon_sym_LR_DQUOTE] = ACTIONS(1921),
    [anon_sym_uR_DQUOTE] = ACTIONS(1921),
    [anon_sym_UR_DQUOTE] = ACTIONS(1921),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1921),
    [sym_literal_suffix] = ACTIONS(5201),
  },
  [1998] = {
    [sym_string_literal] = STATE(1770),
    [sym_raw_string_literal] = STATE(1770),
    [sym_identifier] = ACTIONS(3769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3761),
    [anon_sym_COMMA] = ACTIONS(3761),
    [aux_sym_preproc_if_token2] = ACTIONS(3761),
    [aux_sym_preproc_else_token1] = ACTIONS(3761),
    [aux_sym_preproc_elif_token1] = ACTIONS(3769),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3761),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3761),
    [anon_sym_LPAREN2] = ACTIONS(3761),
    [anon_sym_DASH] = ACTIONS(3769),
    [anon_sym_PLUS] = ACTIONS(3769),
    [anon_sym_STAR] = ACTIONS(3769),
    [anon_sym_SLASH] = ACTIONS(3769),
    [anon_sym_PERCENT] = ACTIONS(3769),
    [anon_sym_PIPE_PIPE] = ACTIONS(3761),
    [anon_sym_AMP_AMP] = ACTIONS(3761),
    [anon_sym_PIPE] = ACTIONS(3769),
    [anon_sym_CARET] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(3769),
    [anon_sym_EQ_EQ] = ACTIONS(3761),
    [anon_sym_BANG_EQ] = ACTIONS(3761),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3761),
    [anon_sym_LT_EQ] = ACTIONS(3769),
    [anon_sym_LT] = ACTIONS(3769),
    [anon_sym_LT_LT] = ACTIONS(3769),
    [anon_sym_GT_GT] = ACTIONS(3769),
    [anon_sym_LBRACK] = ACTIONS(3761),
    [anon_sym_EQ] = ACTIONS(3769),
    [anon_sym_QMARK] = ACTIONS(3761),
    [anon_sym_STAR_EQ] = ACTIONS(3761),
    [anon_sym_SLASH_EQ] = ACTIONS(3761),
    [anon_sym_PERCENT_EQ] = ACTIONS(3761),
    [anon_sym_PLUS_EQ] = ACTIONS(3761),
    [anon_sym_DASH_EQ] = ACTIONS(3761),
    [anon_sym_LT_LT_EQ] = ACTIONS(3761),
    [anon_sym_GT_GT_EQ] = ACTIONS(3761),
    [anon_sym_AMP_EQ] = ACTIONS(3761),
    [anon_sym_CARET_EQ] = ACTIONS(3761),
    [anon_sym_PIPE_EQ] = ACTIONS(3761),
    [anon_sym_and_eq] = ACTIONS(3769),
    [anon_sym_or_eq] = ACTIONS(3769),
    [anon_sym_xor_eq] = ACTIONS(3769),
    [anon_sym_LT_EQ_GT] = ACTIONS(3761),
    [anon_sym_or] = ACTIONS(3769),
    [anon_sym_and] = ACTIONS(3769),
    [anon_sym_bitor] = ACTIONS(3769),
    [anon_sym_xor] = ACTIONS(3769),
    [anon_sym_bitand] = ACTIONS(3769),
    [anon_sym_not_eq] = ACTIONS(3769),
    [anon_sym_DASH_DASH] = ACTIONS(3761),
    [anon_sym_PLUS_PLUS] = ACTIONS(3761),
    [anon_sym_DOT] = ACTIONS(3769),
    [anon_sym_DOT_STAR] = ACTIONS(3761),
    [anon_sym_DASH_GT] = ACTIONS(3761),
    [anon_sym_L_DQUOTE] = ACTIONS(1911),
    [anon_sym_u_DQUOTE] = ACTIONS(1911),
    [anon_sym_U_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8_DQUOTE] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(1911),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(1921),
    [anon_sym_LR_DQUOTE] = ACTIONS(1921),
    [anon_sym_uR_DQUOTE] = ACTIONS(1921),
    [anon_sym_UR_DQUOTE] = ACTIONS(1921),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1921),
    [sym_literal_suffix] = ACTIONS(5201),
  },
  [1999] = {
    [sym_identifier] = ACTIONS(1957),
    [aux_sym_preproc_def_token1] = ACTIONS(1957),
    [anon_sym_COMMA] = ACTIONS(2743),
    [aux_sym_preproc_if_token1] = ACTIONS(1957),
    [aux_sym_preproc_if_token2] = ACTIONS(1957),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1957),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1957),
    [sym_preproc_directive] = ACTIONS(1957),
    [anon_sym_LPAREN2] = ACTIONS(1955),
    [anon_sym_TILDE] = ACTIONS(1955),
    [anon_sym_STAR] = ACTIONS(1955),
    [anon_sym_AMP_AMP] = ACTIONS(1955),
    [anon_sym_AMP] = ACTIONS(1957),
    [anon_sym_SEMI] = ACTIONS(2743),
    [anon_sym___extension__] = ACTIONS(1957),
    [anon_sym_typedef] = ACTIONS(1957),
    [anon_sym_extern] = ACTIONS(1957),
    [anon_sym___attribute__] = ACTIONS(4808),
    [anon_sym_COLON_COLON] = ACTIONS(1955),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1955),
    [anon_sym___declspec] = ACTIONS(1957),
    [anon_sym___based] = ACTIONS(1957),
    [anon_sym_signed] = ACTIONS(1957),
    [anon_sym_unsigned] = ACTIONS(1957),
    [anon_sym_long] = ACTIONS(1957),
    [anon_sym_short] = ACTIONS(1957),
    [anon_sym_LBRACK] = ACTIONS(1957),
    [anon_sym_static] = ACTIONS(1957),
    [anon_sym_register] = ACTIONS(1957),
    [anon_sym_inline] = ACTIONS(1957),
    [anon_sym___inline] = ACTIONS(1957),
    [anon_sym___inline__] = ACTIONS(1957),
    [anon_sym___forceinline] = ACTIONS(1957),
    [anon_sym_thread_local] = ACTIONS(1957),
    [anon_sym___thread] = ACTIONS(1957),
    [anon_sym_const] = ACTIONS(1957),
    [anon_sym_constexpr] = ACTIONS(1957),
    [anon_sym_volatile] = ACTIONS(1957),
    [anon_sym_restrict] = ACTIONS(1957),
    [anon_sym___restrict__] = ACTIONS(1957),
    [anon_sym__Atomic] = ACTIONS(1957),
    [anon_sym__Noreturn] = ACTIONS(1957),
    [anon_sym_noreturn] = ACTIONS(1957),
    [anon_sym_mutable] = ACTIONS(1957),
    [anon_sym_constinit] = ACTIONS(1957),
    [anon_sym_consteval] = ACTIONS(1957),
    [anon_sym_PROGMEM] = ACTIONS(1957),
    [aux_sym_primitive_type_token1] = ACTIONS(1957),
    [anon_sym_byte] = ACTIONS(1957),
    [anon_sym_word] = ACTIONS(1957),
    [anon_sym_enum] = ACTIONS(1957),
    [anon_sym_class] = ACTIONS(1957),
    [anon_sym_struct] = ACTIONS(1957),
    [anon_sym_union] = ACTIONS(1957),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1957),
    [anon_sym_decltype] = ACTIONS(1957),
    [anon_sym_virtual] = ACTIONS(1957),
    [anon_sym_alignas] = ACTIONS(1957),
    [anon_sym_explicit] = ACTIONS(1957),
    [anon_sym_typename] = ACTIONS(1957),
    [anon_sym_template] = ACTIONS(1957),
    [anon_sym_operator] = ACTIONS(1957),
    [anon_sym_friend] = ACTIONS(1957),
    [anon_sym_public] = ACTIONS(1957),
    [anon_sym_private] = ACTIONS(1957),
    [anon_sym_protected] = ACTIONS(1957),
    [anon_sym_using] = ACTIONS(1957),
    [anon_sym_static_assert] = ACTIONS(1957),
  },
  [2000] = {
    [sym_identifier] = ACTIONS(1961),
    [aux_sym_preproc_def_token1] = ACTIONS(1961),
    [aux_sym_preproc_if_token1] = ACTIONS(1961),
    [aux_sym_preproc_if_token2] = ACTIONS(1961),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1961),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1961),
    [sym_preproc_directive] = ACTIONS(1961),
    [anon_sym_LPAREN2] = ACTIONS(1959),
    [anon_sym_TILDE] = ACTIONS(1959),
    [anon_sym_STAR] = ACTIONS(1959),
    [anon_sym_AMP_AMP] = ACTIONS(1959),
    [anon_sym_AMP] = ACTIONS(1961),
    [anon_sym_SEMI] = ACTIONS(1959),
    [anon_sym___extension__] = ACTIONS(1961),
    [anon_sym_typedef] = ACTIONS(1961),
    [anon_sym_extern] = ACTIONS(1961),
    [anon_sym___attribute__] = ACTIONS(1961),
    [anon_sym_COLON_COLON] = ACTIONS(1959),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1959),
    [anon_sym___declspec] = ACTIONS(1961),
    [anon_sym___based] = ACTIONS(1961),
    [anon_sym_signed] = ACTIONS(1961),
    [anon_sym_unsigned] = ACTIONS(1961),
    [anon_sym_long] = ACTIONS(1961),
    [anon_sym_short] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1961),
    [anon_sym_static] = ACTIONS(1961),
    [anon_sym_register] = ACTIONS(1961),
    [anon_sym_inline] = ACTIONS(1961),
    [anon_sym___inline] = ACTIONS(1961),
    [anon_sym___inline__] = ACTIONS(1961),
    [anon_sym___forceinline] = ACTIONS(1961),
    [anon_sym_thread_local] = ACTIONS(1961),
    [anon_sym___thread] = ACTIONS(1961),
    [anon_sym_const] = ACTIONS(1961),
    [anon_sym_constexpr] = ACTIONS(1961),
    [anon_sym_volatile] = ACTIONS(1961),
    [anon_sym_restrict] = ACTIONS(1961),
    [anon_sym___restrict__] = ACTIONS(1961),
    [anon_sym__Atomic] = ACTIONS(1961),
    [anon_sym__Noreturn] = ACTIONS(1961),
    [anon_sym_noreturn] = ACTIONS(1961),
    [anon_sym_mutable] = ACTIONS(1961),
    [anon_sym_constinit] = ACTIONS(1961),
    [anon_sym_consteval] = ACTIONS(1961),
    [anon_sym_PROGMEM] = ACTIONS(1961),
    [aux_sym_primitive_type_token1] = ACTIONS(1961),
    [anon_sym_byte] = ACTIONS(1961),
    [anon_sym_word] = ACTIONS(1961),
    [anon_sym_enum] = ACTIONS(1961),
    [anon_sym_class] = ACTIONS(1961),
    [anon_sym_struct] = ACTIONS(1961),
    [anon_sym_union] = ACTIONS(1961),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1961),
    [anon_sym_decltype] = ACTIONS(1961),
    [anon_sym_virtual] = ACTIONS(1961),
    [anon_sym_alignas] = ACTIONS(1961),
    [anon_sym_explicit] = ACTIONS(1961),
    [anon_sym_typename] = ACTIONS(1961),
    [anon_sym_template] = ACTIONS(1961),
    [anon_sym_operator] = ACTIONS(1961),
    [anon_sym_friend] = ACTIONS(1961),
    [anon_sym_public] = ACTIONS(1961),
    [anon_sym_private] = ACTIONS(1961),
    [anon_sym_protected] = ACTIONS(1961),
    [anon_sym_using] = ACTIONS(1961),
    [anon_sym_static_assert] = ACTIONS(1961),
    [anon_sym_catch] = ACTIONS(1961),
  },
  [2001] = {
    [sym_identifier] = ACTIONS(1957),
    [aux_sym_preproc_def_token1] = ACTIONS(1957),
    [aux_sym_preproc_if_token1] = ACTIONS(1957),
    [aux_sym_preproc_if_token2] = ACTIONS(1957),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1957),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1957),
    [sym_preproc_directive] = ACTIONS(1957),
    [anon_sym_LPAREN2] = ACTIONS(1955),
    [anon_sym_TILDE] = ACTIONS(1955),
    [anon_sym_STAR] = ACTIONS(1955),
    [anon_sym_AMP_AMP] = ACTIONS(1955),
    [anon_sym_AMP] = ACTIONS(1957),
    [anon_sym_SEMI] = ACTIONS(1955),
    [anon_sym___extension__] = ACTIONS(1957),
    [anon_sym_typedef] = ACTIONS(1957),
    [anon_sym_extern] = ACTIONS(1957),
    [anon_sym___attribute__] = ACTIONS(1957),
    [anon_sym_COLON_COLON] = ACTIONS(1955),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1955),
    [anon_sym___declspec] = ACTIONS(1957),
    [anon_sym___based] = ACTIONS(1957),
    [anon_sym_signed] = ACTIONS(1957),
    [anon_sym_unsigned] = ACTIONS(1957),
    [anon_sym_long] = ACTIONS(1957),
    [anon_sym_short] = ACTIONS(1957),
    [anon_sym_LBRACK] = ACTIONS(1957),
    [anon_sym_static] = ACTIONS(1957),
    [anon_sym_register] = ACTIONS(1957),
    [anon_sym_inline] = ACTIONS(1957),
    [anon_sym___inline] = ACTIONS(1957),
    [anon_sym___inline__] = ACTIONS(1957),
    [anon_sym___forceinline] = ACTIONS(1957),
    [anon_sym_thread_local] = ACTIONS(1957),
    [anon_sym___thread] = ACTIONS(1957),
    [anon_sym_const] = ACTIONS(1957),
    [anon_sym_constexpr] = ACTIONS(1957),
    [anon_sym_volatile] = ACTIONS(1957),
    [anon_sym_restrict] = ACTIONS(1957),
    [anon_sym___restrict__] = ACTIONS(1957),
    [anon_sym__Atomic] = ACTIONS(1957),
    [anon_sym__Noreturn] = ACTIONS(1957),
    [anon_sym_noreturn] = ACTIONS(1957),
    [anon_sym_mutable] = ACTIONS(1957),
    [anon_sym_constinit] = ACTIONS(1957),
    [anon_sym_consteval] = ACTIONS(1957),
    [anon_sym_PROGMEM] = ACTIONS(1957),
    [aux_sym_primitive_type_token1] = ACTIONS(1957),
    [anon_sym_byte] = ACTIONS(1957),
    [anon_sym_word] = ACTIONS(1957),
    [anon_sym_enum] = ACTIONS(1957),
    [anon_sym_class] = ACTIONS(1957),
    [anon_sym_struct] = ACTIONS(1957),
    [anon_sym_union] = ACTIONS(1957),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1957),
    [anon_sym_decltype] = ACTIONS(1957),
    [anon_sym_virtual] = ACTIONS(1957),
    [anon_sym_alignas] = ACTIONS(1957),
    [anon_sym_explicit] = ACTIONS(1957),
    [anon_sym_typename] = ACTIONS(1957),
    [anon_sym_template] = ACTIONS(1957),
    [anon_sym_operator] = ACTIONS(1957),
    [anon_sym_friend] = ACTIONS(1957),
    [anon_sym_public] = ACTIONS(1957),
    [anon_sym_private] = ACTIONS(1957),
    [anon_sym_protected] = ACTIONS(1957),
    [anon_sym_using] = ACTIONS(1957),
    [anon_sym_static_assert] = ACTIONS(1957),
    [anon_sym_catch] = ACTIONS(1957),
  },
  [2002] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4577),
    [anon_sym_COMMA] = ACTIONS(4577),
    [anon_sym_RPAREN] = ACTIONS(4579),
    [anon_sym_LPAREN2] = ACTIONS(4579),
    [anon_sym_DASH] = ACTIONS(4584),
    [anon_sym_PLUS] = ACTIONS(4584),
    [anon_sym_STAR] = ACTIONS(4586),
    [anon_sym_SLASH] = ACTIONS(4584),
    [anon_sym_PERCENT] = ACTIONS(4584),
    [anon_sym_PIPE_PIPE] = ACTIONS(4577),
    [anon_sym_AMP_AMP] = ACTIONS(4579),
    [anon_sym_PIPE] = ACTIONS(4584),
    [anon_sym_CARET] = ACTIONS(4584),
    [anon_sym_AMP] = ACTIONS(4586),
    [anon_sym_EQ_EQ] = ACTIONS(4577),
    [anon_sym_BANG_EQ] = ACTIONS(4577),
    [anon_sym_GT] = ACTIONS(4584),
    [anon_sym_GT_EQ] = ACTIONS(4577),
    [anon_sym_LT_EQ] = ACTIONS(4584),
    [anon_sym_LT] = ACTIONS(4584),
    [anon_sym_LT_LT] = ACTIONS(4584),
    [anon_sym_GT_GT] = ACTIONS(4584),
    [anon_sym___extension__] = ACTIONS(4582),
    [anon_sym_COLON_COLON] = ACTIONS(4582),
    [anon_sym_LBRACE] = ACTIONS(4582),
    [anon_sym_LBRACK] = ACTIONS(4579),
    [anon_sym_EQ] = ACTIONS(4584),
    [anon_sym_const] = ACTIONS(4575),
    [anon_sym_constexpr] = ACTIONS(4582),
    [anon_sym_volatile] = ACTIONS(4582),
    [anon_sym_restrict] = ACTIONS(4582),
    [anon_sym___restrict__] = ACTIONS(4582),
    [anon_sym__Atomic] = ACTIONS(4582),
    [anon_sym__Noreturn] = ACTIONS(4582),
    [anon_sym_noreturn] = ACTIONS(4582),
    [anon_sym_mutable] = ACTIONS(4582),
    [anon_sym_constinit] = ACTIONS(4582),
    [anon_sym_consteval] = ACTIONS(4582),
    [anon_sym_PROGMEM] = ACTIONS(4582),
    [anon_sym_QMARK] = ACTIONS(4577),
    [anon_sym_STAR_EQ] = ACTIONS(4577),
    [anon_sym_SLASH_EQ] = ACTIONS(4577),
    [anon_sym_PERCENT_EQ] = ACTIONS(4577),
    [anon_sym_PLUS_EQ] = ACTIONS(4577),
    [anon_sym_DASH_EQ] = ACTIONS(4577),
    [anon_sym_LT_LT_EQ] = ACTIONS(4577),
    [anon_sym_GT_GT_EQ] = ACTIONS(4577),
    [anon_sym_AMP_EQ] = ACTIONS(4577),
    [anon_sym_CARET_EQ] = ACTIONS(4577),
    [anon_sym_PIPE_EQ] = ACTIONS(4577),
    [anon_sym_and_eq] = ACTIONS(4577),
    [anon_sym_or_eq] = ACTIONS(4577),
    [anon_sym_xor_eq] = ACTIONS(4577),
    [anon_sym_LT_EQ_GT] = ACTIONS(4577),
    [anon_sym_or] = ACTIONS(4584),
    [anon_sym_and] = ACTIONS(4584),
    [anon_sym_bitor] = ACTIONS(4577),
    [anon_sym_xor] = ACTIONS(4584),
    [anon_sym_bitand] = ACTIONS(4577),
    [anon_sym_not_eq] = ACTIONS(4577),
    [anon_sym_DASH_DASH] = ACTIONS(4577),
    [anon_sym_PLUS_PLUS] = ACTIONS(4577),
    [anon_sym_DOT] = ACTIONS(4584),
    [anon_sym_DOT_STAR] = ACTIONS(4577),
    [anon_sym_DASH_GT] = ACTIONS(4584),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4582),
    [anon_sym_decltype] = ACTIONS(4582),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4577),
  },
  [2003] = {
    [sym_primitive_type] = STATE(2362),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2028),
    [sym_identifier] = ACTIONS(5203),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4934),
    [anon_sym_COMMA] = ACTIONS(4934),
    [aux_sym_preproc_if_token2] = ACTIONS(4934),
    [aux_sym_preproc_else_token1] = ACTIONS(4934),
    [aux_sym_preproc_elif_token1] = ACTIONS(4936),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4934),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4934),
    [anon_sym_LPAREN2] = ACTIONS(4934),
    [anon_sym_DASH] = ACTIONS(4936),
    [anon_sym_PLUS] = ACTIONS(4936),
    [anon_sym_STAR] = ACTIONS(4936),
    [anon_sym_SLASH] = ACTIONS(4936),
    [anon_sym_PERCENT] = ACTIONS(4936),
    [anon_sym_PIPE_PIPE] = ACTIONS(4934),
    [anon_sym_AMP_AMP] = ACTIONS(4934),
    [anon_sym_PIPE] = ACTIONS(4936),
    [anon_sym_CARET] = ACTIONS(4936),
    [anon_sym_AMP] = ACTIONS(4936),
    [anon_sym_EQ_EQ] = ACTIONS(4934),
    [anon_sym_BANG_EQ] = ACTIONS(4934),
    [anon_sym_GT] = ACTIONS(4936),
    [anon_sym_GT_EQ] = ACTIONS(4934),
    [anon_sym_LT_EQ] = ACTIONS(4936),
    [anon_sym_LT] = ACTIONS(4936),
    [anon_sym_LT_LT] = ACTIONS(4936),
    [anon_sym_GT_GT] = ACTIONS(4936),
    [anon_sym___attribute__] = ACTIONS(4936),
    [anon_sym_LBRACE] = ACTIONS(4934),
    [anon_sym_signed] = ACTIONS(5206),
    [anon_sym_unsigned] = ACTIONS(5206),
    [anon_sym_long] = ACTIONS(5206),
    [anon_sym_short] = ACTIONS(5206),
    [anon_sym_LBRACK] = ACTIONS(4934),
    [anon_sym_EQ] = ACTIONS(4936),
    [aux_sym_primitive_type_token1] = ACTIONS(5195),
    [anon_sym_byte] = ACTIONS(5195),
    [anon_sym_word] = ACTIONS(5195),
    [anon_sym_QMARK] = ACTIONS(4934),
    [anon_sym_STAR_EQ] = ACTIONS(4934),
    [anon_sym_SLASH_EQ] = ACTIONS(4934),
    [anon_sym_PERCENT_EQ] = ACTIONS(4934),
    [anon_sym_PLUS_EQ] = ACTIONS(4934),
    [anon_sym_DASH_EQ] = ACTIONS(4934),
    [anon_sym_LT_LT_EQ] = ACTIONS(4934),
    [anon_sym_GT_GT_EQ] = ACTIONS(4934),
    [anon_sym_AMP_EQ] = ACTIONS(4934),
    [anon_sym_CARET_EQ] = ACTIONS(4934),
    [anon_sym_PIPE_EQ] = ACTIONS(4934),
    [anon_sym_and_eq] = ACTIONS(4936),
    [anon_sym_or_eq] = ACTIONS(4936),
    [anon_sym_xor_eq] = ACTIONS(4936),
    [anon_sym_LT_EQ_GT] = ACTIONS(4934),
    [anon_sym_or] = ACTIONS(4936),
    [anon_sym_and] = ACTIONS(4936),
    [anon_sym_bitor] = ACTIONS(4936),
    [anon_sym_xor] = ACTIONS(4936),
    [anon_sym_bitand] = ACTIONS(4936),
    [anon_sym_not_eq] = ACTIONS(4936),
    [anon_sym_DASH_DASH] = ACTIONS(4934),
    [anon_sym_PLUS_PLUS] = ACTIONS(4934),
    [anon_sym_DOT] = ACTIONS(4936),
    [anon_sym_DOT_STAR] = ACTIONS(4934),
    [anon_sym_DASH_GT] = ACTIONS(4934),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4936),
    [anon_sym_decltype] = ACTIONS(4936),
  },
  [2004] = {
    [sym_argument_list] = STATE(2560),
    [sym_initializer_list] = STATE(2560),
    [sym_decltype_auto] = STATE(2351),
    [sym_new_declarator] = STATE(2375),
    [sym_identifier] = ACTIONS(5208),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5210),
    [anon_sym_COMMA] = ACTIONS(5210),
    [anon_sym_RPAREN] = ACTIONS(5210),
    [aux_sym_preproc_if_token2] = ACTIONS(5210),
    [aux_sym_preproc_else_token1] = ACTIONS(5210),
    [aux_sym_preproc_elif_token1] = ACTIONS(5208),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5210),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5210),
    [anon_sym_LPAREN2] = ACTIONS(5212),
    [anon_sym_DASH] = ACTIONS(5208),
    [anon_sym_PLUS] = ACTIONS(5208),
    [anon_sym_STAR] = ACTIONS(5208),
    [anon_sym_SLASH] = ACTIONS(5208),
    [anon_sym_PERCENT] = ACTIONS(5208),
    [anon_sym_PIPE_PIPE] = ACTIONS(5210),
    [anon_sym_AMP_AMP] = ACTIONS(5210),
    [anon_sym_PIPE] = ACTIONS(5208),
    [anon_sym_CARET] = ACTIONS(5208),
    [anon_sym_AMP] = ACTIONS(5208),
    [anon_sym_EQ_EQ] = ACTIONS(5210),
    [anon_sym_BANG_EQ] = ACTIONS(5210),
    [anon_sym_GT] = ACTIONS(5208),
    [anon_sym_GT_EQ] = ACTIONS(5210),
    [anon_sym_LT_EQ] = ACTIONS(5208),
    [anon_sym_LT] = ACTIONS(5208),
    [anon_sym_LT_LT] = ACTIONS(5208),
    [anon_sym_GT_GT] = ACTIONS(5208),
    [anon_sym_SEMI] = ACTIONS(5210),
    [anon_sym___attribute__] = ACTIONS(5208),
    [anon_sym_LBRACE] = ACTIONS(1893),
    [anon_sym_RBRACE] = ACTIONS(5210),
    [anon_sym_LBRACK] = ACTIONS(5214),
    [anon_sym_RBRACK] = ACTIONS(5210),
    [anon_sym_EQ] = ACTIONS(5208),
    [anon_sym_COLON] = ACTIONS(5210),
    [anon_sym_QMARK] = ACTIONS(5210),
    [anon_sym_STAR_EQ] = ACTIONS(5210),
    [anon_sym_SLASH_EQ] = ACTIONS(5210),
    [anon_sym_PERCENT_EQ] = ACTIONS(5210),
    [anon_sym_PLUS_EQ] = ACTIONS(5210),
    [anon_sym_DASH_EQ] = ACTIONS(5210),
    [anon_sym_LT_LT_EQ] = ACTIONS(5210),
    [anon_sym_GT_GT_EQ] = ACTIONS(5210),
    [anon_sym_AMP_EQ] = ACTIONS(5210),
    [anon_sym_CARET_EQ] = ACTIONS(5210),
    [anon_sym_PIPE_EQ] = ACTIONS(5210),
    [anon_sym_and_eq] = ACTIONS(5208),
    [anon_sym_or_eq] = ACTIONS(5208),
    [anon_sym_xor_eq] = ACTIONS(5208),
    [anon_sym_LT_EQ_GT] = ACTIONS(5210),
    [anon_sym_or] = ACTIONS(5208),
    [anon_sym_and] = ACTIONS(5208),
    [anon_sym_bitor] = ACTIONS(5208),
    [anon_sym_xor] = ACTIONS(5208),
    [anon_sym_bitand] = ACTIONS(5208),
    [anon_sym_not_eq] = ACTIONS(5208),
    [anon_sym_DASH_DASH] = ACTIONS(5210),
    [anon_sym_PLUS_PLUS] = ACTIONS(5210),
    [anon_sym_DOT] = ACTIONS(5208),
    [anon_sym_DOT_STAR] = ACTIONS(5210),
    [anon_sym_DASH_GT] = ACTIONS(5210),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5216),
    [anon_sym_decltype] = ACTIONS(5218),
  },
  [2005] = {
    [sym_identifier] = ACTIONS(1957),
    [aux_sym_preproc_def_token1] = ACTIONS(1957),
    [anon_sym_COMMA] = ACTIONS(2743),
    [aux_sym_preproc_if_token1] = ACTIONS(1957),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1957),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1957),
    [sym_preproc_directive] = ACTIONS(1957),
    [anon_sym_LPAREN2] = ACTIONS(1955),
    [anon_sym_TILDE] = ACTIONS(1955),
    [anon_sym_STAR] = ACTIONS(1955),
    [anon_sym_AMP_AMP] = ACTIONS(1955),
    [anon_sym_AMP] = ACTIONS(1957),
    [anon_sym_SEMI] = ACTIONS(2743),
    [anon_sym___extension__] = ACTIONS(1957),
    [anon_sym_typedef] = ACTIONS(1957),
    [anon_sym_extern] = ACTIONS(1957),
    [anon_sym___attribute__] = ACTIONS(4808),
    [anon_sym_COLON_COLON] = ACTIONS(1955),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1955),
    [anon_sym___declspec] = ACTIONS(1957),
    [anon_sym___based] = ACTIONS(1957),
    [anon_sym_RBRACE] = ACTIONS(1955),
    [anon_sym_signed] = ACTIONS(1957),
    [anon_sym_unsigned] = ACTIONS(1957),
    [anon_sym_long] = ACTIONS(1957),
    [anon_sym_short] = ACTIONS(1957),
    [anon_sym_LBRACK] = ACTIONS(1957),
    [anon_sym_static] = ACTIONS(1957),
    [anon_sym_register] = ACTIONS(1957),
    [anon_sym_inline] = ACTIONS(1957),
    [anon_sym___inline] = ACTIONS(1957),
    [anon_sym___inline__] = ACTIONS(1957),
    [anon_sym___forceinline] = ACTIONS(1957),
    [anon_sym_thread_local] = ACTIONS(1957),
    [anon_sym___thread] = ACTIONS(1957),
    [anon_sym_const] = ACTIONS(1957),
    [anon_sym_constexpr] = ACTIONS(1957),
    [anon_sym_volatile] = ACTIONS(1957),
    [anon_sym_restrict] = ACTIONS(1957),
    [anon_sym___restrict__] = ACTIONS(1957),
    [anon_sym__Atomic] = ACTIONS(1957),
    [anon_sym__Noreturn] = ACTIONS(1957),
    [anon_sym_noreturn] = ACTIONS(1957),
    [anon_sym_mutable] = ACTIONS(1957),
    [anon_sym_constinit] = ACTIONS(1957),
    [anon_sym_consteval] = ACTIONS(1957),
    [anon_sym_PROGMEM] = ACTIONS(1957),
    [aux_sym_primitive_type_token1] = ACTIONS(1957),
    [anon_sym_byte] = ACTIONS(1957),
    [anon_sym_word] = ACTIONS(1957),
    [anon_sym_enum] = ACTIONS(1957),
    [anon_sym_class] = ACTIONS(1957),
    [anon_sym_struct] = ACTIONS(1957),
    [anon_sym_union] = ACTIONS(1957),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1957),
    [anon_sym_decltype] = ACTIONS(1957),
    [anon_sym_virtual] = ACTIONS(1957),
    [anon_sym_alignas] = ACTIONS(1957),
    [anon_sym_explicit] = ACTIONS(1957),
    [anon_sym_typename] = ACTIONS(1957),
    [anon_sym_template] = ACTIONS(1957),
    [anon_sym_operator] = ACTIONS(1957),
    [anon_sym_friend] = ACTIONS(1957),
    [anon_sym_public] = ACTIONS(1957),
    [anon_sym_private] = ACTIONS(1957),
    [anon_sym_protected] = ACTIONS(1957),
    [anon_sym_using] = ACTIONS(1957),
    [anon_sym_static_assert] = ACTIONS(1957),
  },
  [2006] = {
    [sym_identifier] = ACTIONS(1957),
    [aux_sym_preproc_def_token1] = ACTIONS(1957),
    [anon_sym_COMMA] = ACTIONS(2743),
    [aux_sym_preproc_if_token1] = ACTIONS(1957),
    [aux_sym_preproc_if_token2] = ACTIONS(1957),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1957),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1957),
    [sym_preproc_directive] = ACTIONS(1957),
    [anon_sym_LPAREN2] = ACTIONS(1955),
    [anon_sym_TILDE] = ACTIONS(1955),
    [anon_sym_STAR] = ACTIONS(1955),
    [anon_sym_AMP_AMP] = ACTIONS(1955),
    [anon_sym_AMP] = ACTIONS(1957),
    [anon_sym_SEMI] = ACTIONS(2743),
    [anon_sym___extension__] = ACTIONS(1957),
    [anon_sym_typedef] = ACTIONS(1957),
    [anon_sym_extern] = ACTIONS(1957),
    [anon_sym___attribute__] = ACTIONS(1957),
    [anon_sym_COLON_COLON] = ACTIONS(1955),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1955),
    [anon_sym___declspec] = ACTIONS(1957),
    [anon_sym___based] = ACTIONS(1957),
    [anon_sym_signed] = ACTIONS(1957),
    [anon_sym_unsigned] = ACTIONS(1957),
    [anon_sym_long] = ACTIONS(1957),
    [anon_sym_short] = ACTIONS(1957),
    [anon_sym_LBRACK] = ACTIONS(1957),
    [anon_sym_static] = ACTIONS(1957),
    [anon_sym_register] = ACTIONS(1957),
    [anon_sym_inline] = ACTIONS(1957),
    [anon_sym___inline] = ACTIONS(1957),
    [anon_sym___inline__] = ACTIONS(1957),
    [anon_sym___forceinline] = ACTIONS(1957),
    [anon_sym_thread_local] = ACTIONS(1957),
    [anon_sym___thread] = ACTIONS(1957),
    [anon_sym_const] = ACTIONS(1957),
    [anon_sym_constexpr] = ACTIONS(1957),
    [anon_sym_volatile] = ACTIONS(1957),
    [anon_sym_restrict] = ACTIONS(1957),
    [anon_sym___restrict__] = ACTIONS(1957),
    [anon_sym__Atomic] = ACTIONS(1957),
    [anon_sym__Noreturn] = ACTIONS(1957),
    [anon_sym_noreturn] = ACTIONS(1957),
    [anon_sym_mutable] = ACTIONS(1957),
    [anon_sym_constinit] = ACTIONS(1957),
    [anon_sym_consteval] = ACTIONS(1957),
    [anon_sym_PROGMEM] = ACTIONS(1957),
    [aux_sym_primitive_type_token1] = ACTIONS(1957),
    [anon_sym_byte] = ACTIONS(1957),
    [anon_sym_word] = ACTIONS(1957),
    [anon_sym_enum] = ACTIONS(1957),
    [anon_sym_class] = ACTIONS(1957),
    [anon_sym_struct] = ACTIONS(1957),
    [anon_sym_union] = ACTIONS(1957),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1957),
    [anon_sym_decltype] = ACTIONS(1957),
    [anon_sym_virtual] = ACTIONS(1957),
    [anon_sym_alignas] = ACTIONS(1957),
    [anon_sym_explicit] = ACTIONS(1957),
    [anon_sym_typename] = ACTIONS(1957),
    [anon_sym_template] = ACTIONS(1957),
    [anon_sym_operator] = ACTIONS(1957),
    [anon_sym_friend] = ACTIONS(1957),
    [anon_sym_public] = ACTIONS(1957),
    [anon_sym_private] = ACTIONS(1957),
    [anon_sym_protected] = ACTIONS(1957),
    [anon_sym_using] = ACTIONS(1957),
    [anon_sym_static_assert] = ACTIONS(1957),
  },
  [2007] = {
    [sym_template_argument_list] = STATE(2033),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4538),
    [anon_sym_COMMA] = ACTIONS(4538),
    [anon_sym_LPAREN2] = ACTIONS(4538),
    [anon_sym_DASH] = ACTIONS(4543),
    [anon_sym_PLUS] = ACTIONS(4543),
    [anon_sym_STAR] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(4543),
    [anon_sym_PERCENT] = ACTIONS(4543),
    [anon_sym_PIPE_PIPE] = ACTIONS(4536),
    [anon_sym_AMP_AMP] = ACTIONS(4538),
    [anon_sym_PIPE] = ACTIONS(4543),
    [anon_sym_CARET] = ACTIONS(4543),
    [anon_sym_AMP] = ACTIONS(4545),
    [anon_sym_EQ_EQ] = ACTIONS(4536),
    [anon_sym_BANG_EQ] = ACTIONS(4536),
    [anon_sym_GT] = ACTIONS(4543),
    [anon_sym_GT_EQ] = ACTIONS(4543),
    [anon_sym_LT_EQ] = ACTIONS(4543),
    [anon_sym_LT] = ACTIONS(5220),
    [anon_sym_LT_LT] = ACTIONS(4543),
    [anon_sym_GT_GT] = ACTIONS(4543),
    [anon_sym___extension__] = ACTIONS(4541),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(4541),
    [anon_sym_LBRACK] = ACTIONS(4538),
    [anon_sym_EQ] = ACTIONS(4543),
    [anon_sym_const] = ACTIONS(4534),
    [anon_sym_constexpr] = ACTIONS(4541),
    [anon_sym_volatile] = ACTIONS(4541),
    [anon_sym_restrict] = ACTIONS(4541),
    [anon_sym___restrict__] = ACTIONS(4541),
    [anon_sym__Atomic] = ACTIONS(4541),
    [anon_sym__Noreturn] = ACTIONS(4541),
    [anon_sym_noreturn] = ACTIONS(4541),
    [anon_sym_mutable] = ACTIONS(4541),
    [anon_sym_constinit] = ACTIONS(4541),
    [anon_sym_consteval] = ACTIONS(4541),
    [anon_sym_PROGMEM] = ACTIONS(4541),
    [anon_sym_QMARK] = ACTIONS(4536),
    [anon_sym_STAR_EQ] = ACTIONS(4536),
    [anon_sym_SLASH_EQ] = ACTIONS(4536),
    [anon_sym_PERCENT_EQ] = ACTIONS(4536),
    [anon_sym_PLUS_EQ] = ACTIONS(4536),
    [anon_sym_DASH_EQ] = ACTIONS(4536),
    [anon_sym_LT_LT_EQ] = ACTIONS(4536),
    [anon_sym_GT_GT_EQ] = ACTIONS(4543),
    [anon_sym_AMP_EQ] = ACTIONS(4536),
    [anon_sym_CARET_EQ] = ACTIONS(4536),
    [anon_sym_PIPE_EQ] = ACTIONS(4536),
    [anon_sym_and_eq] = ACTIONS(4536),
    [anon_sym_or_eq] = ACTIONS(4536),
    [anon_sym_xor_eq] = ACTIONS(4536),
    [anon_sym_LT_EQ_GT] = ACTIONS(4536),
    [anon_sym_or] = ACTIONS(4543),
    [anon_sym_and] = ACTIONS(4543),
    [anon_sym_bitor] = ACTIONS(4536),
    [anon_sym_xor] = ACTIONS(4543),
    [anon_sym_bitand] = ACTIONS(4536),
    [anon_sym_not_eq] = ACTIONS(4536),
    [anon_sym_DASH_DASH] = ACTIONS(4536),
    [anon_sym_PLUS_PLUS] = ACTIONS(4536),
    [anon_sym_DOT] = ACTIONS(4543),
    [anon_sym_DOT_STAR] = ACTIONS(4536),
    [anon_sym_DASH_GT] = ACTIONS(4536),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4541),
    [anon_sym_decltype] = ACTIONS(4541),
    [anon_sym_GT2] = ACTIONS(4538),
  },
  [2008] = {
    [sym_template_argument_list] = STATE(2017),
    [sym_identifier] = ACTIONS(4534),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4541),
    [anon_sym_COMMA] = ACTIONS(4541),
    [anon_sym_RPAREN] = ACTIONS(4541),
    [aux_sym_preproc_if_token2] = ACTIONS(4541),
    [aux_sym_preproc_else_token1] = ACTIONS(4541),
    [aux_sym_preproc_elif_token1] = ACTIONS(4534),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4541),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4541),
    [anon_sym_LPAREN2] = ACTIONS(4541),
    [anon_sym_DASH] = ACTIONS(4534),
    [anon_sym_PLUS] = ACTIONS(4534),
    [anon_sym_STAR] = ACTIONS(4534),
    [anon_sym_SLASH] = ACTIONS(4534),
    [anon_sym_PERCENT] = ACTIONS(4534),
    [anon_sym_PIPE_PIPE] = ACTIONS(4541),
    [anon_sym_AMP_AMP] = ACTIONS(4541),
    [anon_sym_PIPE] = ACTIONS(4534),
    [anon_sym_CARET] = ACTIONS(4534),
    [anon_sym_AMP] = ACTIONS(4534),
    [anon_sym_EQ_EQ] = ACTIONS(4541),
    [anon_sym_BANG_EQ] = ACTIONS(4541),
    [anon_sym_GT] = ACTIONS(4534),
    [anon_sym_GT_EQ] = ACTIONS(4541),
    [anon_sym_LT_EQ] = ACTIONS(4534),
    [anon_sym_LT] = ACTIONS(5223),
    [anon_sym_LT_LT] = ACTIONS(4534),
    [anon_sym_GT_GT] = ACTIONS(4534),
    [anon_sym_SEMI] = ACTIONS(4541),
    [anon_sym___attribute__] = ACTIONS(4534),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(4541),
    [anon_sym_RBRACE] = ACTIONS(4541),
    [anon_sym_LBRACK] = ACTIONS(4541),
    [anon_sym_RBRACK] = ACTIONS(4541),
    [anon_sym_EQ] = ACTIONS(4534),
    [anon_sym_COLON] = ACTIONS(4534),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_STAR_EQ] = ACTIONS(4541),
    [anon_sym_SLASH_EQ] = ACTIONS(4541),
    [anon_sym_PERCENT_EQ] = ACTIONS(4541),
    [anon_sym_PLUS_EQ] = ACTIONS(4541),
    [anon_sym_DASH_EQ] = ACTIONS(4541),
    [anon_sym_LT_LT_EQ] = ACTIONS(4541),
    [anon_sym_GT_GT_EQ] = ACTIONS(4541),
    [anon_sym_AMP_EQ] = ACTIONS(4541),
    [anon_sym_CARET_EQ] = ACTIONS(4541),
    [anon_sym_PIPE_EQ] = ACTIONS(4541),
    [anon_sym_and_eq] = ACTIONS(4534),
    [anon_sym_or_eq] = ACTIONS(4534),
    [anon_sym_xor_eq] = ACTIONS(4534),
    [anon_sym_LT_EQ_GT] = ACTIONS(4541),
    [anon_sym_or] = ACTIONS(4534),
    [anon_sym_and] = ACTIONS(4534),
    [anon_sym_bitor] = ACTIONS(4534),
    [anon_sym_xor] = ACTIONS(4534),
    [anon_sym_bitand] = ACTIONS(4534),
    [anon_sym_not_eq] = ACTIONS(4534),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
    [anon_sym_DOT] = ACTIONS(4534),
    [anon_sym_DOT_STAR] = ACTIONS(4541),
    [anon_sym_DASH_GT] = ACTIONS(4541),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4534),
    [anon_sym_decltype] = ACTIONS(4534),
    [anon_sym_final] = ACTIONS(4534),
    [anon_sym_override] = ACTIONS(4534),
  },
  [2009] = {
    [sym_identifier] = ACTIONS(1957),
    [aux_sym_preproc_def_token1] = ACTIONS(1957),
    [aux_sym_preproc_if_token1] = ACTIONS(1957),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1957),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1957),
    [sym_preproc_directive] = ACTIONS(1957),
    [anon_sym_LPAREN2] = ACTIONS(1955),
    [anon_sym_TILDE] = ACTIONS(1955),
    [anon_sym_STAR] = ACTIONS(1955),
    [anon_sym_AMP_AMP] = ACTIONS(1955),
    [anon_sym_AMP] = ACTIONS(1957),
    [anon_sym_SEMI] = ACTIONS(1955),
    [anon_sym___extension__] = ACTIONS(1957),
    [anon_sym_typedef] = ACTIONS(1957),
    [anon_sym_extern] = ACTIONS(1957),
    [anon_sym___attribute__] = ACTIONS(1957),
    [anon_sym_COLON_COLON] = ACTIONS(1955),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1955),
    [anon_sym___declspec] = ACTIONS(1957),
    [anon_sym___based] = ACTIONS(1957),
    [anon_sym_RBRACE] = ACTIONS(1955),
    [anon_sym_signed] = ACTIONS(1957),
    [anon_sym_unsigned] = ACTIONS(1957),
    [anon_sym_long] = ACTIONS(1957),
    [anon_sym_short] = ACTIONS(1957),
    [anon_sym_LBRACK] = ACTIONS(1957),
    [anon_sym_static] = ACTIONS(1957),
    [anon_sym_register] = ACTIONS(1957),
    [anon_sym_inline] = ACTIONS(1957),
    [anon_sym___inline] = ACTIONS(1957),
    [anon_sym___inline__] = ACTIONS(1957),
    [anon_sym___forceinline] = ACTIONS(1957),
    [anon_sym_thread_local] = ACTIONS(1957),
    [anon_sym___thread] = ACTIONS(1957),
    [anon_sym_const] = ACTIONS(1957),
    [anon_sym_constexpr] = ACTIONS(1957),
    [anon_sym_volatile] = ACTIONS(1957),
    [anon_sym_restrict] = ACTIONS(1957),
    [anon_sym___restrict__] = ACTIONS(1957),
    [anon_sym__Atomic] = ACTIONS(1957),
    [anon_sym__Noreturn] = ACTIONS(1957),
    [anon_sym_noreturn] = ACTIONS(1957),
    [anon_sym_mutable] = ACTIONS(1957),
    [anon_sym_constinit] = ACTIONS(1957),
    [anon_sym_consteval] = ACTIONS(1957),
    [anon_sym_PROGMEM] = ACTIONS(1957),
    [aux_sym_primitive_type_token1] = ACTIONS(1957),
    [anon_sym_byte] = ACTIONS(1957),
    [anon_sym_word] = ACTIONS(1957),
    [anon_sym_enum] = ACTIONS(1957),
    [anon_sym_class] = ACTIONS(1957),
    [anon_sym_struct] = ACTIONS(1957),
    [anon_sym_union] = ACTIONS(1957),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1957),
    [anon_sym_decltype] = ACTIONS(1957),
    [anon_sym_virtual] = ACTIONS(1957),
    [anon_sym_alignas] = ACTIONS(1957),
    [anon_sym_explicit] = ACTIONS(1957),
    [anon_sym_typename] = ACTIONS(1957),
    [anon_sym_template] = ACTIONS(1957),
    [anon_sym_operator] = ACTIONS(1957),
    [anon_sym_friend] = ACTIONS(1957),
    [anon_sym_public] = ACTIONS(1957),
    [anon_sym_private] = ACTIONS(1957),
    [anon_sym_protected] = ACTIONS(1957),
    [anon_sym_using] = ACTIONS(1957),
    [anon_sym_static_assert] = ACTIONS(1957),
    [anon_sym_catch] = ACTIONS(1957),
  },
  [2010] = {
    [sym_argument_list] = STATE(2516),
    [sym_initializer_list] = STATE(2516),
    [sym_decltype_auto] = STATE(2351),
    [sym_new_declarator] = STATE(2394),
    [sym_identifier] = ACTIONS(5226),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5228),
    [anon_sym_COMMA] = ACTIONS(5228),
    [anon_sym_RPAREN] = ACTIONS(5228),
    [aux_sym_preproc_if_token2] = ACTIONS(5228),
    [aux_sym_preproc_else_token1] = ACTIONS(5228),
    [aux_sym_preproc_elif_token1] = ACTIONS(5226),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5228),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5228),
    [anon_sym_LPAREN2] = ACTIONS(5212),
    [anon_sym_DASH] = ACTIONS(5226),
    [anon_sym_PLUS] = ACTIONS(5226),
    [anon_sym_STAR] = ACTIONS(5226),
    [anon_sym_SLASH] = ACTIONS(5226),
    [anon_sym_PERCENT] = ACTIONS(5226),
    [anon_sym_PIPE_PIPE] = ACTIONS(5228),
    [anon_sym_AMP_AMP] = ACTIONS(5228),
    [anon_sym_PIPE] = ACTIONS(5226),
    [anon_sym_CARET] = ACTIONS(5226),
    [anon_sym_AMP] = ACTIONS(5226),
    [anon_sym_EQ_EQ] = ACTIONS(5228),
    [anon_sym_BANG_EQ] = ACTIONS(5228),
    [anon_sym_GT] = ACTIONS(5226),
    [anon_sym_GT_EQ] = ACTIONS(5228),
    [anon_sym_LT_EQ] = ACTIONS(5226),
    [anon_sym_LT] = ACTIONS(5226),
    [anon_sym_LT_LT] = ACTIONS(5226),
    [anon_sym_GT_GT] = ACTIONS(5226),
    [anon_sym_SEMI] = ACTIONS(5228),
    [anon_sym___attribute__] = ACTIONS(5226),
    [anon_sym_LBRACE] = ACTIONS(1893),
    [anon_sym_RBRACE] = ACTIONS(5228),
    [anon_sym_LBRACK] = ACTIONS(5214),
    [anon_sym_RBRACK] = ACTIONS(5228),
    [anon_sym_EQ] = ACTIONS(5226),
    [anon_sym_COLON] = ACTIONS(5228),
    [anon_sym_QMARK] = ACTIONS(5228),
    [anon_sym_STAR_EQ] = ACTIONS(5228),
    [anon_sym_SLASH_EQ] = ACTIONS(5228),
    [anon_sym_PERCENT_EQ] = ACTIONS(5228),
    [anon_sym_PLUS_EQ] = ACTIONS(5228),
    [anon_sym_DASH_EQ] = ACTIONS(5228),
    [anon_sym_LT_LT_EQ] = ACTIONS(5228),
    [anon_sym_GT_GT_EQ] = ACTIONS(5228),
    [anon_sym_AMP_EQ] = ACTIONS(5228),
    [anon_sym_CARET_EQ] = ACTIONS(5228),
    [anon_sym_PIPE_EQ] = ACTIONS(5228),
    [anon_sym_and_eq] = ACTIONS(5226),
    [anon_sym_or_eq] = ACTIONS(5226),
    [anon_sym_xor_eq] = ACTIONS(5226),
    [anon_sym_LT_EQ_GT] = ACTIONS(5228),
    [anon_sym_or] = ACTIONS(5226),
    [anon_sym_and] = ACTIONS(5226),
    [anon_sym_bitor] = ACTIONS(5226),
    [anon_sym_xor] = ACTIONS(5226),
    [anon_sym_bitand] = ACTIONS(5226),
    [anon_sym_not_eq] = ACTIONS(5226),
    [anon_sym_DASH_DASH] = ACTIONS(5228),
    [anon_sym_PLUS_PLUS] = ACTIONS(5228),
    [anon_sym_DOT] = ACTIONS(5226),
    [anon_sym_DOT_STAR] = ACTIONS(5228),
    [anon_sym_DASH_GT] = ACTIONS(5228),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5216),
    [anon_sym_decltype] = ACTIONS(5218),
  },
  [2011] = {
    [sym_identifier] = ACTIONS(1961),
    [aux_sym_preproc_def_token1] = ACTIONS(1961),
    [aux_sym_preproc_if_token1] = ACTIONS(1961),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1961),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1961),
    [sym_preproc_directive] = ACTIONS(1961),
    [anon_sym_LPAREN2] = ACTIONS(1959),
    [anon_sym_TILDE] = ACTIONS(1959),
    [anon_sym_STAR] = ACTIONS(1959),
    [anon_sym_AMP_AMP] = ACTIONS(1959),
    [anon_sym_AMP] = ACTIONS(1961),
    [anon_sym_SEMI] = ACTIONS(1959),
    [anon_sym___extension__] = ACTIONS(1961),
    [anon_sym_typedef] = ACTIONS(1961),
    [anon_sym_extern] = ACTIONS(1961),
    [anon_sym___attribute__] = ACTIONS(1961),
    [anon_sym_COLON_COLON] = ACTIONS(1959),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1959),
    [anon_sym___declspec] = ACTIONS(1961),
    [anon_sym___based] = ACTIONS(1961),
    [anon_sym_RBRACE] = ACTIONS(1959),
    [anon_sym_signed] = ACTIONS(1961),
    [anon_sym_unsigned] = ACTIONS(1961),
    [anon_sym_long] = ACTIONS(1961),
    [anon_sym_short] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1961),
    [anon_sym_static] = ACTIONS(1961),
    [anon_sym_register] = ACTIONS(1961),
    [anon_sym_inline] = ACTIONS(1961),
    [anon_sym___inline] = ACTIONS(1961),
    [anon_sym___inline__] = ACTIONS(1961),
    [anon_sym___forceinline] = ACTIONS(1961),
    [anon_sym_thread_local] = ACTIONS(1961),
    [anon_sym___thread] = ACTIONS(1961),
    [anon_sym_const] = ACTIONS(1961),
    [anon_sym_constexpr] = ACTIONS(1961),
    [anon_sym_volatile] = ACTIONS(1961),
    [anon_sym_restrict] = ACTIONS(1961),
    [anon_sym___restrict__] = ACTIONS(1961),
    [anon_sym__Atomic] = ACTIONS(1961),
    [anon_sym__Noreturn] = ACTIONS(1961),
    [anon_sym_noreturn] = ACTIONS(1961),
    [anon_sym_mutable] = ACTIONS(1961),
    [anon_sym_constinit] = ACTIONS(1961),
    [anon_sym_consteval] = ACTIONS(1961),
    [anon_sym_PROGMEM] = ACTIONS(1961),
    [aux_sym_primitive_type_token1] = ACTIONS(1961),
    [anon_sym_byte] = ACTIONS(1961),
    [anon_sym_word] = ACTIONS(1961),
    [anon_sym_enum] = ACTIONS(1961),
    [anon_sym_class] = ACTIONS(1961),
    [anon_sym_struct] = ACTIONS(1961),
    [anon_sym_union] = ACTIONS(1961),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1961),
    [anon_sym_decltype] = ACTIONS(1961),
    [anon_sym_virtual] = ACTIONS(1961),
    [anon_sym_alignas] = ACTIONS(1961),
    [anon_sym_explicit] = ACTIONS(1961),
    [anon_sym_typename] = ACTIONS(1961),
    [anon_sym_template] = ACTIONS(1961),
    [anon_sym_operator] = ACTIONS(1961),
    [anon_sym_friend] = ACTIONS(1961),
    [anon_sym_public] = ACTIONS(1961),
    [anon_sym_private] = ACTIONS(1961),
    [anon_sym_protected] = ACTIONS(1961),
    [anon_sym_using] = ACTIONS(1961),
    [anon_sym_static_assert] = ACTIONS(1961),
    [anon_sym_catch] = ACTIONS(1961),
  },
  [2012] = {
    [sym_argument_list] = STATE(2565),
    [sym_initializer_list] = STATE(2565),
    [sym_decltype_auto] = STATE(2351),
    [sym_new_declarator] = STATE(2350),
    [sym_identifier] = ACTIONS(5230),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5232),
    [anon_sym_COMMA] = ACTIONS(5232),
    [anon_sym_RPAREN] = ACTIONS(5232),
    [aux_sym_preproc_if_token2] = ACTIONS(5232),
    [aux_sym_preproc_else_token1] = ACTIONS(5232),
    [aux_sym_preproc_elif_token1] = ACTIONS(5230),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5232),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5232),
    [anon_sym_LPAREN2] = ACTIONS(5212),
    [anon_sym_DASH] = ACTIONS(5230),
    [anon_sym_PLUS] = ACTIONS(5230),
    [anon_sym_STAR] = ACTIONS(5230),
    [anon_sym_SLASH] = ACTIONS(5230),
    [anon_sym_PERCENT] = ACTIONS(5230),
    [anon_sym_PIPE_PIPE] = ACTIONS(5232),
    [anon_sym_AMP_AMP] = ACTIONS(5232),
    [anon_sym_PIPE] = ACTIONS(5230),
    [anon_sym_CARET] = ACTIONS(5230),
    [anon_sym_AMP] = ACTIONS(5230),
    [anon_sym_EQ_EQ] = ACTIONS(5232),
    [anon_sym_BANG_EQ] = ACTIONS(5232),
    [anon_sym_GT] = ACTIONS(5230),
    [anon_sym_GT_EQ] = ACTIONS(5232),
    [anon_sym_LT_EQ] = ACTIONS(5230),
    [anon_sym_LT] = ACTIONS(5230),
    [anon_sym_LT_LT] = ACTIONS(5230),
    [anon_sym_GT_GT] = ACTIONS(5230),
    [anon_sym_SEMI] = ACTIONS(5232),
    [anon_sym___attribute__] = ACTIONS(5230),
    [anon_sym_LBRACE] = ACTIONS(1893),
    [anon_sym_RBRACE] = ACTIONS(5232),
    [anon_sym_LBRACK] = ACTIONS(5214),
    [anon_sym_RBRACK] = ACTIONS(5232),
    [anon_sym_EQ] = ACTIONS(5230),
    [anon_sym_COLON] = ACTIONS(5232),
    [anon_sym_QMARK] = ACTIONS(5232),
    [anon_sym_STAR_EQ] = ACTIONS(5232),
    [anon_sym_SLASH_EQ] = ACTIONS(5232),
    [anon_sym_PERCENT_EQ] = ACTIONS(5232),
    [anon_sym_PLUS_EQ] = ACTIONS(5232),
    [anon_sym_DASH_EQ] = ACTIONS(5232),
    [anon_sym_LT_LT_EQ] = ACTIONS(5232),
    [anon_sym_GT_GT_EQ] = ACTIONS(5232),
    [anon_sym_AMP_EQ] = ACTIONS(5232),
    [anon_sym_CARET_EQ] = ACTIONS(5232),
    [anon_sym_PIPE_EQ] = ACTIONS(5232),
    [anon_sym_and_eq] = ACTIONS(5230),
    [anon_sym_or_eq] = ACTIONS(5230),
    [anon_sym_xor_eq] = ACTIONS(5230),
    [anon_sym_LT_EQ_GT] = ACTIONS(5232),
    [anon_sym_or] = ACTIONS(5230),
    [anon_sym_and] = ACTIONS(5230),
    [anon_sym_bitor] = ACTIONS(5230),
    [anon_sym_xor] = ACTIONS(5230),
    [anon_sym_bitand] = ACTIONS(5230),
    [anon_sym_not_eq] = ACTIONS(5230),
    [anon_sym_DASH_DASH] = ACTIONS(5232),
    [anon_sym_PLUS_PLUS] = ACTIONS(5232),
    [anon_sym_DOT] = ACTIONS(5230),
    [anon_sym_DOT_STAR] = ACTIONS(5232),
    [anon_sym_DASH_GT] = ACTIONS(5232),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5216),
    [anon_sym_decltype] = ACTIONS(5218),
  },
  [2013] = {
    [sym_argument_list] = STATE(2502),
    [sym_initializer_list] = STATE(2502),
    [sym_decltype_auto] = STATE(2351),
    [sym_new_declarator] = STATE(2355),
    [sym_identifier] = ACTIONS(5234),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5236),
    [anon_sym_COMMA] = ACTIONS(5236),
    [anon_sym_RPAREN] = ACTIONS(5236),
    [aux_sym_preproc_if_token2] = ACTIONS(5236),
    [aux_sym_preproc_else_token1] = ACTIONS(5236),
    [aux_sym_preproc_elif_token1] = ACTIONS(5234),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5236),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5236),
    [anon_sym_LPAREN2] = ACTIONS(5212),
    [anon_sym_DASH] = ACTIONS(5234),
    [anon_sym_PLUS] = ACTIONS(5234),
    [anon_sym_STAR] = ACTIONS(5234),
    [anon_sym_SLASH] = ACTIONS(5234),
    [anon_sym_PERCENT] = ACTIONS(5234),
    [anon_sym_PIPE_PIPE] = ACTIONS(5236),
    [anon_sym_AMP_AMP] = ACTIONS(5236),
    [anon_sym_PIPE] = ACTIONS(5234),
    [anon_sym_CARET] = ACTIONS(5234),
    [anon_sym_AMP] = ACTIONS(5234),
    [anon_sym_EQ_EQ] = ACTIONS(5236),
    [anon_sym_BANG_EQ] = ACTIONS(5236),
    [anon_sym_GT] = ACTIONS(5234),
    [anon_sym_GT_EQ] = ACTIONS(5236),
    [anon_sym_LT_EQ] = ACTIONS(5234),
    [anon_sym_LT] = ACTIONS(5234),
    [anon_sym_LT_LT] = ACTIONS(5234),
    [anon_sym_GT_GT] = ACTIONS(5234),
    [anon_sym_SEMI] = ACTIONS(5236),
    [anon_sym___attribute__] = ACTIONS(5234),
    [anon_sym_LBRACE] = ACTIONS(1893),
    [anon_sym_RBRACE] = ACTIONS(5236),
    [anon_sym_LBRACK] = ACTIONS(5214),
    [anon_sym_RBRACK] = ACTIONS(5236),
    [anon_sym_EQ] = ACTIONS(5234),
    [anon_sym_COLON] = ACTIONS(5236),
    [anon_sym_QMARK] = ACTIONS(5236),
    [anon_sym_STAR_EQ] = ACTIONS(5236),
    [anon_sym_SLASH_EQ] = ACTIONS(5236),
    [anon_sym_PERCENT_EQ] = ACTIONS(5236),
    [anon_sym_PLUS_EQ] = ACTIONS(5236),
    [anon_sym_DASH_EQ] = ACTIONS(5236),
    [anon_sym_LT_LT_EQ] = ACTIONS(5236),
    [anon_sym_GT_GT_EQ] = ACTIONS(5236),
    [anon_sym_AMP_EQ] = ACTIONS(5236),
    [anon_sym_CARET_EQ] = ACTIONS(5236),
    [anon_sym_PIPE_EQ] = ACTIONS(5236),
    [anon_sym_and_eq] = ACTIONS(5234),
    [anon_sym_or_eq] = ACTIONS(5234),
    [anon_sym_xor_eq] = ACTIONS(5234),
    [anon_sym_LT_EQ_GT] = ACTIONS(5236),
    [anon_sym_or] = ACTIONS(5234),
    [anon_sym_and] = ACTIONS(5234),
    [anon_sym_bitor] = ACTIONS(5234),
    [anon_sym_xor] = ACTIONS(5234),
    [anon_sym_bitand] = ACTIONS(5234),
    [anon_sym_not_eq] = ACTIONS(5234),
    [anon_sym_DASH_DASH] = ACTIONS(5236),
    [anon_sym_PLUS_PLUS] = ACTIONS(5236),
    [anon_sym_DOT] = ACTIONS(5234),
    [anon_sym_DOT_STAR] = ACTIONS(5236),
    [anon_sym_DASH_GT] = ACTIONS(5236),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5216),
    [anon_sym_decltype] = ACTIONS(5218),
  },
  [2014] = {
    [sym_template_argument_list] = STATE(1741),
    [sym_identifier] = ACTIONS(5187),
    [anon_sym_LPAREN2] = ACTIONS(3785),
    [anon_sym_TILDE] = ACTIONS(3785),
    [anon_sym_STAR] = ACTIONS(3785),
    [anon_sym_PIPE_PIPE] = ACTIONS(3785),
    [anon_sym_AMP_AMP] = ACTIONS(3785),
    [anon_sym_AMP] = ACTIONS(5187),
    [anon_sym_LT] = ACTIONS(5238),
    [anon_sym___extension__] = ACTIONS(5187),
    [anon_sym_extern] = ACTIONS(5187),
    [anon_sym___attribute__] = ACTIONS(5187),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3785),
    [anon_sym___declspec] = ACTIONS(5187),
    [anon_sym___based] = ACTIONS(5187),
    [anon_sym___cdecl] = ACTIONS(5187),
    [anon_sym___clrcall] = ACTIONS(5187),
    [anon_sym___stdcall] = ACTIONS(5187),
    [anon_sym___fastcall] = ACTIONS(5187),
    [anon_sym___thiscall] = ACTIONS(5187),
    [anon_sym___vectorcall] = ACTIONS(5187),
    [anon_sym_signed] = ACTIONS(5187),
    [anon_sym_unsigned] = ACTIONS(5187),
    [anon_sym_long] = ACTIONS(5187),
    [anon_sym_short] = ACTIONS(5187),
    [anon_sym_LBRACK] = ACTIONS(5187),
    [anon_sym_static] = ACTIONS(5187),
    [anon_sym_register] = ACTIONS(5187),
    [anon_sym_inline] = ACTIONS(5187),
    [anon_sym___inline] = ACTIONS(5187),
    [anon_sym___inline__] = ACTIONS(5187),
    [anon_sym___forceinline] = ACTIONS(5187),
    [anon_sym_thread_local] = ACTIONS(5187),
    [anon_sym___thread] = ACTIONS(5187),
    [anon_sym_const] = ACTIONS(5187),
    [anon_sym_constexpr] = ACTIONS(5187),
    [anon_sym_volatile] = ACTIONS(5187),
    [anon_sym_restrict] = ACTIONS(5187),
    [anon_sym___restrict__] = ACTIONS(5187),
    [anon_sym__Atomic] = ACTIONS(5187),
    [anon_sym__Noreturn] = ACTIONS(5187),
    [anon_sym_noreturn] = ACTIONS(5187),
    [anon_sym_mutable] = ACTIONS(5187),
    [anon_sym_constinit] = ACTIONS(5187),
    [anon_sym_consteval] = ACTIONS(5187),
    [anon_sym_PROGMEM] = ACTIONS(5187),
    [aux_sym_primitive_type_token1] = ACTIONS(5187),
    [anon_sym_byte] = ACTIONS(5187),
    [anon_sym_word] = ACTIONS(5187),
    [anon_sym_enum] = ACTIONS(5187),
    [anon_sym_class] = ACTIONS(5187),
    [anon_sym_struct] = ACTIONS(5187),
    [anon_sym_union] = ACTIONS(5187),
    [anon_sym_or] = ACTIONS(5187),
    [anon_sym_and] = ACTIONS(5187),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5187),
    [anon_sym_decltype] = ACTIONS(5187),
    [anon_sym_virtual] = ACTIONS(5187),
    [anon_sym_alignas] = ACTIONS(5187),
    [anon_sym_explicit] = ACTIONS(5187),
    [anon_sym_typename] = ACTIONS(5187),
    [anon_sym_template] = ACTIONS(5187),
    [anon_sym_operator] = ACTIONS(5187),
    [anon_sym_friend] = ACTIONS(5187),
    [anon_sym_using] = ACTIONS(5187),
    [anon_sym_concept] = ACTIONS(5187),
  },
  [2015] = {
    [sym_identifier] = ACTIONS(3105),
    [aux_sym_preproc_def_token1] = ACTIONS(3105),
    [aux_sym_preproc_if_token1] = ACTIONS(3105),
    [aux_sym_preproc_if_token2] = ACTIONS(3105),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3105),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3105),
    [sym_preproc_directive] = ACTIONS(3105),
    [anon_sym_LPAREN2] = ACTIONS(3107),
    [anon_sym_TILDE] = ACTIONS(3107),
    [anon_sym_STAR] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3107),
    [anon_sym_AMP] = ACTIONS(3105),
    [anon_sym_SEMI] = ACTIONS(5240),
    [anon_sym___extension__] = ACTIONS(3105),
    [anon_sym_typedef] = ACTIONS(3105),
    [anon_sym_extern] = ACTIONS(3105),
    [anon_sym___attribute__] = ACTIONS(3105),
    [anon_sym_COLON_COLON] = ACTIONS(3107),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3107),
    [anon_sym___declspec] = ACTIONS(3105),
    [anon_sym___based] = ACTIONS(3105),
    [anon_sym_signed] = ACTIONS(3105),
    [anon_sym_unsigned] = ACTIONS(3105),
    [anon_sym_long] = ACTIONS(3105),
    [anon_sym_short] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(3105),
    [anon_sym_static] = ACTIONS(3105),
    [anon_sym_register] = ACTIONS(3105),
    [anon_sym_inline] = ACTIONS(3105),
    [anon_sym___inline] = ACTIONS(3105),
    [anon_sym___inline__] = ACTIONS(3105),
    [anon_sym___forceinline] = ACTIONS(3105),
    [anon_sym_thread_local] = ACTIONS(3105),
    [anon_sym___thread] = ACTIONS(3105),
    [anon_sym_const] = ACTIONS(3105),
    [anon_sym_constexpr] = ACTIONS(3105),
    [anon_sym_volatile] = ACTIONS(3105),
    [anon_sym_restrict] = ACTIONS(3105),
    [anon_sym___restrict__] = ACTIONS(3105),
    [anon_sym__Atomic] = ACTIONS(3105),
    [anon_sym__Noreturn] = ACTIONS(3105),
    [anon_sym_noreturn] = ACTIONS(3105),
    [anon_sym_mutable] = ACTIONS(3105),
    [anon_sym_constinit] = ACTIONS(3105),
    [anon_sym_consteval] = ACTIONS(3105),
    [anon_sym_PROGMEM] = ACTIONS(3105),
    [aux_sym_primitive_type_token1] = ACTIONS(3105),
    [anon_sym_byte] = ACTIONS(3105),
    [anon_sym_word] = ACTIONS(3105),
    [anon_sym_enum] = ACTIONS(3105),
    [anon_sym_class] = ACTIONS(3105),
    [anon_sym_struct] = ACTIONS(3105),
    [anon_sym_union] = ACTIONS(3105),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3105),
    [anon_sym_decltype] = ACTIONS(3105),
    [anon_sym_virtual] = ACTIONS(3105),
    [anon_sym_alignas] = ACTIONS(3105),
    [anon_sym_explicit] = ACTIONS(3105),
    [anon_sym_typename] = ACTIONS(3105),
    [anon_sym_template] = ACTIONS(3105),
    [anon_sym_operator] = ACTIONS(3105),
    [anon_sym_friend] = ACTIONS(3105),
    [anon_sym_public] = ACTIONS(3105),
    [anon_sym_private] = ACTIONS(3105),
    [anon_sym_protected] = ACTIONS(3105),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_static_assert] = ACTIONS(3105),
  },
  [2016] = {
    [sym_string_literal] = STATE(2617),
    [sym_template_argument_list] = STATE(3723),
    [sym_raw_string_literal] = STATE(2617),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3761),
    [anon_sym_COMMA] = ACTIONS(3761),
    [anon_sym_LPAREN2] = ACTIONS(3761),
    [anon_sym_DASH] = ACTIONS(3769),
    [anon_sym_PLUS] = ACTIONS(3769),
    [anon_sym_STAR] = ACTIONS(3769),
    [anon_sym_SLASH] = ACTIONS(3769),
    [anon_sym_PERCENT] = ACTIONS(3769),
    [anon_sym_PIPE_PIPE] = ACTIONS(3761),
    [anon_sym_AMP_AMP] = ACTIONS(3761),
    [anon_sym_PIPE] = ACTIONS(3769),
    [anon_sym_CARET] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(3769),
    [anon_sym_EQ_EQ] = ACTIONS(3761),
    [anon_sym_BANG_EQ] = ACTIONS(3761),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3761),
    [anon_sym_LT_EQ] = ACTIONS(3769),
    [anon_sym_LT] = ACTIONS(5242),
    [anon_sym_LT_LT] = ACTIONS(3769),
    [anon_sym_GT_GT] = ACTIONS(3769),
    [anon_sym_SEMI] = ACTIONS(3761),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(3785),
    [anon_sym_RBRACE] = ACTIONS(3761),
    [anon_sym_LBRACK] = ACTIONS(3761),
    [anon_sym_EQ] = ACTIONS(3793),
    [anon_sym_COLON] = ACTIONS(3815),
    [anon_sym_QMARK] = ACTIONS(3761),
    [anon_sym_STAR_EQ] = ACTIONS(3797),
    [anon_sym_SLASH_EQ] = ACTIONS(3797),
    [anon_sym_PERCENT_EQ] = ACTIONS(3797),
    [anon_sym_PLUS_EQ] = ACTIONS(3797),
    [anon_sym_DASH_EQ] = ACTIONS(3797),
    [anon_sym_LT_LT_EQ] = ACTIONS(3797),
    [anon_sym_GT_GT_EQ] = ACTIONS(3797),
    [anon_sym_AMP_EQ] = ACTIONS(3797),
    [anon_sym_CARET_EQ] = ACTIONS(3797),
    [anon_sym_PIPE_EQ] = ACTIONS(3797),
    [anon_sym_and_eq] = ACTIONS(3797),
    [anon_sym_or_eq] = ACTIONS(3797),
    [anon_sym_xor_eq] = ACTIONS(3797),
    [anon_sym_LT_EQ_GT] = ACTIONS(3761),
    [anon_sym_or] = ACTIONS(3769),
    [anon_sym_and] = ACTIONS(3769),
    [anon_sym_bitor] = ACTIONS(3761),
    [anon_sym_xor] = ACTIONS(3769),
    [anon_sym_bitand] = ACTIONS(3761),
    [anon_sym_not_eq] = ACTIONS(3761),
    [anon_sym_DASH_DASH] = ACTIONS(3761),
    [anon_sym_PLUS_PLUS] = ACTIONS(3761),
    [anon_sym_DOT] = ACTIONS(3769),
    [anon_sym_DOT_STAR] = ACTIONS(3761),
    [anon_sym_DASH_GT] = ACTIONS(3761),
    [anon_sym_L_DQUOTE] = ACTIONS(3204),
    [anon_sym_u_DQUOTE] = ACTIONS(3204),
    [anon_sym_U_DQUOTE] = ACTIONS(3204),
    [anon_sym_u8_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3204),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3208),
    [anon_sym_LR_DQUOTE] = ACTIONS(3208),
    [anon_sym_uR_DQUOTE] = ACTIONS(3208),
    [anon_sym_UR_DQUOTE] = ACTIONS(3208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3208),
  },
  [2017] = {
    [sym_identifier] = ACTIONS(4575),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4582),
    [anon_sym_COMMA] = ACTIONS(4582),
    [anon_sym_RPAREN] = ACTIONS(4582),
    [aux_sym_preproc_if_token2] = ACTIONS(4582),
    [aux_sym_preproc_else_token1] = ACTIONS(4582),
    [aux_sym_preproc_elif_token1] = ACTIONS(4575),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4582),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4582),
    [anon_sym_LPAREN2] = ACTIONS(4582),
    [anon_sym_DASH] = ACTIONS(4575),
    [anon_sym_PLUS] = ACTIONS(4575),
    [anon_sym_STAR] = ACTIONS(4575),
    [anon_sym_SLASH] = ACTIONS(4575),
    [anon_sym_PERCENT] = ACTIONS(4575),
    [anon_sym_PIPE_PIPE] = ACTIONS(4582),
    [anon_sym_AMP_AMP] = ACTIONS(4582),
    [anon_sym_PIPE] = ACTIONS(4575),
    [anon_sym_CARET] = ACTIONS(4575),
    [anon_sym_AMP] = ACTIONS(4575),
    [anon_sym_EQ_EQ] = ACTIONS(4582),
    [anon_sym_BANG_EQ] = ACTIONS(4582),
    [anon_sym_GT] = ACTIONS(4575),
    [anon_sym_GT_EQ] = ACTIONS(4582),
    [anon_sym_LT_EQ] = ACTIONS(4575),
    [anon_sym_LT] = ACTIONS(4575),
    [anon_sym_LT_LT] = ACTIONS(4575),
    [anon_sym_GT_GT] = ACTIONS(4575),
    [anon_sym_SEMI] = ACTIONS(4582),
    [anon_sym___attribute__] = ACTIONS(4575),
    [anon_sym_COLON_COLON] = ACTIONS(4582),
    [anon_sym_LBRACE] = ACTIONS(4582),
    [anon_sym_RBRACE] = ACTIONS(4582),
    [anon_sym_LBRACK] = ACTIONS(4582),
    [anon_sym_RBRACK] = ACTIONS(4582),
    [anon_sym_EQ] = ACTIONS(4575),
    [anon_sym_COLON] = ACTIONS(4575),
    [anon_sym_QMARK] = ACTIONS(4582),
    [anon_sym_STAR_EQ] = ACTIONS(4582),
    [anon_sym_SLASH_EQ] = ACTIONS(4582),
    [anon_sym_PERCENT_EQ] = ACTIONS(4582),
    [anon_sym_PLUS_EQ] = ACTIONS(4582),
    [anon_sym_DASH_EQ] = ACTIONS(4582),
    [anon_sym_LT_LT_EQ] = ACTIONS(4582),
    [anon_sym_GT_GT_EQ] = ACTIONS(4582),
    [anon_sym_AMP_EQ] = ACTIONS(4582),
    [anon_sym_CARET_EQ] = ACTIONS(4582),
    [anon_sym_PIPE_EQ] = ACTIONS(4582),
    [anon_sym_and_eq] = ACTIONS(4575),
    [anon_sym_or_eq] = ACTIONS(4575),
    [anon_sym_xor_eq] = ACTIONS(4575),
    [anon_sym_LT_EQ_GT] = ACTIONS(4582),
    [anon_sym_or] = ACTIONS(4575),
    [anon_sym_and] = ACTIONS(4575),
    [anon_sym_bitor] = ACTIONS(4575),
    [anon_sym_xor] = ACTIONS(4575),
    [anon_sym_bitand] = ACTIONS(4575),
    [anon_sym_not_eq] = ACTIONS(4575),
    [anon_sym_DASH_DASH] = ACTIONS(4582),
    [anon_sym_PLUS_PLUS] = ACTIONS(4582),
    [anon_sym_DOT] = ACTIONS(4575),
    [anon_sym_DOT_STAR] = ACTIONS(4582),
    [anon_sym_DASH_GT] = ACTIONS(4582),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4575),
    [anon_sym_decltype] = ACTIONS(4575),
    [anon_sym_final] = ACTIONS(4575),
    [anon_sym_override] = ACTIONS(4575),
  },
  [2018] = {
    [sym_identifier] = ACTIONS(4928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4930),
    [anon_sym_COMMA] = ACTIONS(4930),
    [anon_sym_RPAREN] = ACTIONS(4930),
    [aux_sym_preproc_if_token2] = ACTIONS(4930),
    [aux_sym_preproc_else_token1] = ACTIONS(4930),
    [aux_sym_preproc_elif_token1] = ACTIONS(4928),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4930),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4930),
    [anon_sym_LPAREN2] = ACTIONS(4930),
    [anon_sym_DASH] = ACTIONS(4928),
    [anon_sym_PLUS] = ACTIONS(4928),
    [anon_sym_STAR] = ACTIONS(4928),
    [anon_sym_SLASH] = ACTIONS(4928),
    [anon_sym_PERCENT] = ACTIONS(4928),
    [anon_sym_PIPE_PIPE] = ACTIONS(4930),
    [anon_sym_AMP_AMP] = ACTIONS(4930),
    [anon_sym_PIPE] = ACTIONS(4928),
    [anon_sym_CARET] = ACTIONS(4928),
    [anon_sym_AMP] = ACTIONS(4928),
    [anon_sym_EQ_EQ] = ACTIONS(4930),
    [anon_sym_BANG_EQ] = ACTIONS(4930),
    [anon_sym_GT] = ACTIONS(4928),
    [anon_sym_GT_EQ] = ACTIONS(4930),
    [anon_sym_LT_EQ] = ACTIONS(4928),
    [anon_sym_LT] = ACTIONS(4928),
    [anon_sym_LT_LT] = ACTIONS(4928),
    [anon_sym_GT_GT] = ACTIONS(4928),
    [anon_sym_SEMI] = ACTIONS(4930),
    [anon_sym___attribute__] = ACTIONS(4928),
    [anon_sym_COLON_COLON] = ACTIONS(4930),
    [anon_sym_LBRACE] = ACTIONS(4930),
    [anon_sym_RBRACE] = ACTIONS(4930),
    [anon_sym_LBRACK] = ACTIONS(4930),
    [anon_sym_RBRACK] = ACTIONS(4930),
    [anon_sym_EQ] = ACTIONS(4928),
    [anon_sym_COLON] = ACTIONS(4928),
    [anon_sym_QMARK] = ACTIONS(4930),
    [anon_sym_STAR_EQ] = ACTIONS(4930),
    [anon_sym_SLASH_EQ] = ACTIONS(4930),
    [anon_sym_PERCENT_EQ] = ACTIONS(4930),
    [anon_sym_PLUS_EQ] = ACTIONS(4930),
    [anon_sym_DASH_EQ] = ACTIONS(4930),
    [anon_sym_LT_LT_EQ] = ACTIONS(4930),
    [anon_sym_GT_GT_EQ] = ACTIONS(4930),
    [anon_sym_AMP_EQ] = ACTIONS(4930),
    [anon_sym_CARET_EQ] = ACTIONS(4930),
    [anon_sym_PIPE_EQ] = ACTIONS(4930),
    [anon_sym_and_eq] = ACTIONS(4928),
    [anon_sym_or_eq] = ACTIONS(4928),
    [anon_sym_xor_eq] = ACTIONS(4928),
    [anon_sym_LT_EQ_GT] = ACTIONS(4930),
    [anon_sym_or] = ACTIONS(4928),
    [anon_sym_and] = ACTIONS(4928),
    [anon_sym_bitor] = ACTIONS(4928),
    [anon_sym_xor] = ACTIONS(4928),
    [anon_sym_bitand] = ACTIONS(4928),
    [anon_sym_not_eq] = ACTIONS(4928),
    [anon_sym_DASH_DASH] = ACTIONS(4930),
    [anon_sym_PLUS_PLUS] = ACTIONS(4930),
    [anon_sym_DOT] = ACTIONS(4928),
    [anon_sym_DOT_STAR] = ACTIONS(4930),
    [anon_sym_DASH_GT] = ACTIONS(4930),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4928),
    [anon_sym_decltype] = ACTIONS(4928),
    [anon_sym_final] = ACTIONS(4928),
    [anon_sym_override] = ACTIONS(4928),
  },
  [2019] = {
    [sym_identifier] = ACTIONS(4567),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4569),
    [anon_sym_COMMA] = ACTIONS(4569),
    [anon_sym_RPAREN] = ACTIONS(4569),
    [aux_sym_preproc_if_token2] = ACTIONS(4569),
    [aux_sym_preproc_else_token1] = ACTIONS(4569),
    [aux_sym_preproc_elif_token1] = ACTIONS(4567),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4569),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4569),
    [anon_sym_LPAREN2] = ACTIONS(4569),
    [anon_sym_DASH] = ACTIONS(4567),
    [anon_sym_PLUS] = ACTIONS(4567),
    [anon_sym_STAR] = ACTIONS(4567),
    [anon_sym_SLASH] = ACTIONS(4567),
    [anon_sym_PERCENT] = ACTIONS(4567),
    [anon_sym_PIPE_PIPE] = ACTIONS(4569),
    [anon_sym_AMP_AMP] = ACTIONS(4569),
    [anon_sym_PIPE] = ACTIONS(4567),
    [anon_sym_CARET] = ACTIONS(4567),
    [anon_sym_AMP] = ACTIONS(4567),
    [anon_sym_EQ_EQ] = ACTIONS(4569),
    [anon_sym_BANG_EQ] = ACTIONS(4569),
    [anon_sym_GT] = ACTIONS(4567),
    [anon_sym_GT_EQ] = ACTIONS(4569),
    [anon_sym_LT_EQ] = ACTIONS(4567),
    [anon_sym_LT] = ACTIONS(4567),
    [anon_sym_LT_LT] = ACTIONS(4567),
    [anon_sym_GT_GT] = ACTIONS(4567),
    [anon_sym_SEMI] = ACTIONS(4569),
    [anon_sym___attribute__] = ACTIONS(4567),
    [anon_sym_COLON_COLON] = ACTIONS(4569),
    [anon_sym_LBRACE] = ACTIONS(4569),
    [anon_sym_RBRACE] = ACTIONS(4569),
    [anon_sym_LBRACK] = ACTIONS(4569),
    [anon_sym_RBRACK] = ACTIONS(4569),
    [anon_sym_EQ] = ACTIONS(4567),
    [anon_sym_COLON] = ACTIONS(4567),
    [anon_sym_QMARK] = ACTIONS(4569),
    [anon_sym_STAR_EQ] = ACTIONS(4569),
    [anon_sym_SLASH_EQ] = ACTIONS(4569),
    [anon_sym_PERCENT_EQ] = ACTIONS(4569),
    [anon_sym_PLUS_EQ] = ACTIONS(4569),
    [anon_sym_DASH_EQ] = ACTIONS(4569),
    [anon_sym_LT_LT_EQ] = ACTIONS(4569),
    [anon_sym_GT_GT_EQ] = ACTIONS(4569),
    [anon_sym_AMP_EQ] = ACTIONS(4569),
    [anon_sym_CARET_EQ] = ACTIONS(4569),
    [anon_sym_PIPE_EQ] = ACTIONS(4569),
    [anon_sym_and_eq] = ACTIONS(4567),
    [anon_sym_or_eq] = ACTIONS(4567),
    [anon_sym_xor_eq] = ACTIONS(4567),
    [anon_sym_LT_EQ_GT] = ACTIONS(4569),
    [anon_sym_or] = ACTIONS(4567),
    [anon_sym_and] = ACTIONS(4567),
    [anon_sym_bitor] = ACTIONS(4567),
    [anon_sym_xor] = ACTIONS(4567),
    [anon_sym_bitand] = ACTIONS(4567),
    [anon_sym_not_eq] = ACTIONS(4567),
    [anon_sym_DASH_DASH] = ACTIONS(4569),
    [anon_sym_PLUS_PLUS] = ACTIONS(4569),
    [anon_sym_DOT] = ACTIONS(4567),
    [anon_sym_DOT_STAR] = ACTIONS(4569),
    [anon_sym_DASH_GT] = ACTIONS(4569),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4567),
    [anon_sym_decltype] = ACTIONS(4567),
    [anon_sym_final] = ACTIONS(4567),
    [anon_sym_override] = ACTIONS(4567),
  },
  [2020] = {
    [sym_identifier] = ACTIONS(4559),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4561),
    [anon_sym_COMMA] = ACTIONS(4561),
    [anon_sym_RPAREN] = ACTIONS(4561),
    [aux_sym_preproc_if_token2] = ACTIONS(4561),
    [aux_sym_preproc_else_token1] = ACTIONS(4561),
    [aux_sym_preproc_elif_token1] = ACTIONS(4559),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4561),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4561),
    [anon_sym_LPAREN2] = ACTIONS(4561),
    [anon_sym_DASH] = ACTIONS(4559),
    [anon_sym_PLUS] = ACTIONS(4559),
    [anon_sym_STAR] = ACTIONS(4559),
    [anon_sym_SLASH] = ACTIONS(4559),
    [anon_sym_PERCENT] = ACTIONS(4559),
    [anon_sym_PIPE_PIPE] = ACTIONS(4561),
    [anon_sym_AMP_AMP] = ACTIONS(4561),
    [anon_sym_PIPE] = ACTIONS(4559),
    [anon_sym_CARET] = ACTIONS(4559),
    [anon_sym_AMP] = ACTIONS(4559),
    [anon_sym_EQ_EQ] = ACTIONS(4561),
    [anon_sym_BANG_EQ] = ACTIONS(4561),
    [anon_sym_GT] = ACTIONS(4559),
    [anon_sym_GT_EQ] = ACTIONS(4561),
    [anon_sym_LT_EQ] = ACTIONS(4559),
    [anon_sym_LT] = ACTIONS(4559),
    [anon_sym_LT_LT] = ACTIONS(4559),
    [anon_sym_GT_GT] = ACTIONS(4559),
    [anon_sym_SEMI] = ACTIONS(4561),
    [anon_sym___attribute__] = ACTIONS(4559),
    [anon_sym_COLON_COLON] = ACTIONS(4561),
    [anon_sym_LBRACE] = ACTIONS(4561),
    [anon_sym_RBRACE] = ACTIONS(4561),
    [anon_sym_LBRACK] = ACTIONS(4561),
    [anon_sym_RBRACK] = ACTIONS(4561),
    [anon_sym_EQ] = ACTIONS(4559),
    [anon_sym_COLON] = ACTIONS(4559),
    [anon_sym_QMARK] = ACTIONS(4561),
    [anon_sym_STAR_EQ] = ACTIONS(4561),
    [anon_sym_SLASH_EQ] = ACTIONS(4561),
    [anon_sym_PERCENT_EQ] = ACTIONS(4561),
    [anon_sym_PLUS_EQ] = ACTIONS(4561),
    [anon_sym_DASH_EQ] = ACTIONS(4561),
    [anon_sym_LT_LT_EQ] = ACTIONS(4561),
    [anon_sym_GT_GT_EQ] = ACTIONS(4561),
    [anon_sym_AMP_EQ] = ACTIONS(4561),
    [anon_sym_CARET_EQ] = ACTIONS(4561),
    [anon_sym_PIPE_EQ] = ACTIONS(4561),
    [anon_sym_and_eq] = ACTIONS(4559),
    [anon_sym_or_eq] = ACTIONS(4559),
    [anon_sym_xor_eq] = ACTIONS(4559),
    [anon_sym_LT_EQ_GT] = ACTIONS(4561),
    [anon_sym_or] = ACTIONS(4559),
    [anon_sym_and] = ACTIONS(4559),
    [anon_sym_bitor] = ACTIONS(4559),
    [anon_sym_xor] = ACTIONS(4559),
    [anon_sym_bitand] = ACTIONS(4559),
    [anon_sym_not_eq] = ACTIONS(4559),
    [anon_sym_DASH_DASH] = ACTIONS(4561),
    [anon_sym_PLUS_PLUS] = ACTIONS(4561),
    [anon_sym_DOT] = ACTIONS(4559),
    [anon_sym_DOT_STAR] = ACTIONS(4561),
    [anon_sym_DASH_GT] = ACTIONS(4561),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4559),
    [anon_sym_decltype] = ACTIONS(4559),
    [anon_sym_final] = ACTIONS(4559),
    [anon_sym_override] = ACTIONS(4559),
  },
  [2021] = {
    [sym_identifier] = ACTIONS(2937),
    [aux_sym_preproc_def_token1] = ACTIONS(2937),
    [aux_sym_preproc_if_token1] = ACTIONS(2937),
    [aux_sym_preproc_if_token2] = ACTIONS(2937),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2937),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2937),
    [sym_preproc_directive] = ACTIONS(2937),
    [anon_sym_LPAREN2] = ACTIONS(2939),
    [anon_sym_TILDE] = ACTIONS(2939),
    [anon_sym_STAR] = ACTIONS(2939),
    [anon_sym_AMP_AMP] = ACTIONS(2939),
    [anon_sym_AMP] = ACTIONS(2937),
    [anon_sym_SEMI] = ACTIONS(5245),
    [anon_sym___extension__] = ACTIONS(2937),
    [anon_sym_typedef] = ACTIONS(2937),
    [anon_sym_extern] = ACTIONS(2937),
    [anon_sym___attribute__] = ACTIONS(2937),
    [anon_sym_COLON_COLON] = ACTIONS(2939),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2939),
    [anon_sym___declspec] = ACTIONS(2937),
    [anon_sym___based] = ACTIONS(2937),
    [anon_sym_signed] = ACTIONS(2937),
    [anon_sym_unsigned] = ACTIONS(2937),
    [anon_sym_long] = ACTIONS(2937),
    [anon_sym_short] = ACTIONS(2937),
    [anon_sym_LBRACK] = ACTIONS(2937),
    [anon_sym_static] = ACTIONS(2937),
    [anon_sym_register] = ACTIONS(2937),
    [anon_sym_inline] = ACTIONS(2937),
    [anon_sym___inline] = ACTIONS(2937),
    [anon_sym___inline__] = ACTIONS(2937),
    [anon_sym___forceinline] = ACTIONS(2937),
    [anon_sym_thread_local] = ACTIONS(2937),
    [anon_sym___thread] = ACTIONS(2937),
    [anon_sym_const] = ACTIONS(2937),
    [anon_sym_constexpr] = ACTIONS(2937),
    [anon_sym_volatile] = ACTIONS(2937),
    [anon_sym_restrict] = ACTIONS(2937),
    [anon_sym___restrict__] = ACTIONS(2937),
    [anon_sym__Atomic] = ACTIONS(2937),
    [anon_sym__Noreturn] = ACTIONS(2937),
    [anon_sym_noreturn] = ACTIONS(2937),
    [anon_sym_mutable] = ACTIONS(2937),
    [anon_sym_constinit] = ACTIONS(2937),
    [anon_sym_consteval] = ACTIONS(2937),
    [anon_sym_PROGMEM] = ACTIONS(2937),
    [aux_sym_primitive_type_token1] = ACTIONS(2937),
    [anon_sym_byte] = ACTIONS(2937),
    [anon_sym_word] = ACTIONS(2937),
    [anon_sym_enum] = ACTIONS(2937),
    [anon_sym_class] = ACTIONS(2937),
    [anon_sym_struct] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2937),
    [anon_sym_decltype] = ACTIONS(2937),
    [anon_sym_virtual] = ACTIONS(2937),
    [anon_sym_alignas] = ACTIONS(2937),
    [anon_sym_explicit] = ACTIONS(2937),
    [anon_sym_typename] = ACTIONS(2937),
    [anon_sym_template] = ACTIONS(2937),
    [anon_sym_operator] = ACTIONS(2937),
    [anon_sym_friend] = ACTIONS(2937),
    [anon_sym_public] = ACTIONS(2937),
    [anon_sym_private] = ACTIONS(2937),
    [anon_sym_protected] = ACTIONS(2937),
    [anon_sym_using] = ACTIONS(2937),
    [anon_sym_static_assert] = ACTIONS(2937),
  },
  [2022] = {
    [sym_identifier] = ACTIONS(4563),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4565),
    [anon_sym_COMMA] = ACTIONS(4565),
    [anon_sym_RPAREN] = ACTIONS(4565),
    [aux_sym_preproc_if_token2] = ACTIONS(4565),
    [aux_sym_preproc_else_token1] = ACTIONS(4565),
    [aux_sym_preproc_elif_token1] = ACTIONS(4563),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4565),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4565),
    [anon_sym_LPAREN2] = ACTIONS(4565),
    [anon_sym_DASH] = ACTIONS(4563),
    [anon_sym_PLUS] = ACTIONS(4563),
    [anon_sym_STAR] = ACTIONS(4563),
    [anon_sym_SLASH] = ACTIONS(4563),
    [anon_sym_PERCENT] = ACTIONS(4563),
    [anon_sym_PIPE_PIPE] = ACTIONS(4565),
    [anon_sym_AMP_AMP] = ACTIONS(4565),
    [anon_sym_PIPE] = ACTIONS(4563),
    [anon_sym_CARET] = ACTIONS(4563),
    [anon_sym_AMP] = ACTIONS(4563),
    [anon_sym_EQ_EQ] = ACTIONS(4565),
    [anon_sym_BANG_EQ] = ACTIONS(4565),
    [anon_sym_GT] = ACTIONS(4563),
    [anon_sym_GT_EQ] = ACTIONS(4565),
    [anon_sym_LT_EQ] = ACTIONS(4563),
    [anon_sym_LT] = ACTIONS(4563),
    [anon_sym_LT_LT] = ACTIONS(4563),
    [anon_sym_GT_GT] = ACTIONS(4563),
    [anon_sym_SEMI] = ACTIONS(4565),
    [anon_sym___attribute__] = ACTIONS(4563),
    [anon_sym_COLON_COLON] = ACTIONS(4565),
    [anon_sym_LBRACE] = ACTIONS(4565),
    [anon_sym_RBRACE] = ACTIONS(4565),
    [anon_sym_LBRACK] = ACTIONS(4565),
    [anon_sym_RBRACK] = ACTIONS(4565),
    [anon_sym_EQ] = ACTIONS(4563),
    [anon_sym_COLON] = ACTIONS(4563),
    [anon_sym_QMARK] = ACTIONS(4565),
    [anon_sym_STAR_EQ] = ACTIONS(4565),
    [anon_sym_SLASH_EQ] = ACTIONS(4565),
    [anon_sym_PERCENT_EQ] = ACTIONS(4565),
    [anon_sym_PLUS_EQ] = ACTIONS(4565),
    [anon_sym_DASH_EQ] = ACTIONS(4565),
    [anon_sym_LT_LT_EQ] = ACTIONS(4565),
    [anon_sym_GT_GT_EQ] = ACTIONS(4565),
    [anon_sym_AMP_EQ] = ACTIONS(4565),
    [anon_sym_CARET_EQ] = ACTIONS(4565),
    [anon_sym_PIPE_EQ] = ACTIONS(4565),
    [anon_sym_and_eq] = ACTIONS(4563),
    [anon_sym_or_eq] = ACTIONS(4563),
    [anon_sym_xor_eq] = ACTIONS(4563),
    [anon_sym_LT_EQ_GT] = ACTIONS(4565),
    [anon_sym_or] = ACTIONS(4563),
    [anon_sym_and] = ACTIONS(4563),
    [anon_sym_bitor] = ACTIONS(4563),
    [anon_sym_xor] = ACTIONS(4563),
    [anon_sym_bitand] = ACTIONS(4563),
    [anon_sym_not_eq] = ACTIONS(4563),
    [anon_sym_DASH_DASH] = ACTIONS(4565),
    [anon_sym_PLUS_PLUS] = ACTIONS(4565),
    [anon_sym_DOT] = ACTIONS(4563),
    [anon_sym_DOT_STAR] = ACTIONS(4565),
    [anon_sym_DASH_GT] = ACTIONS(4565),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4563),
    [anon_sym_decltype] = ACTIONS(4563),
    [anon_sym_final] = ACTIONS(4563),
    [anon_sym_override] = ACTIONS(4563),
  },
  [2023] = {
    [sym_identifier] = ACTIONS(4555),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4557),
    [anon_sym_COMMA] = ACTIONS(4557),
    [anon_sym_RPAREN] = ACTIONS(4557),
    [aux_sym_preproc_if_token2] = ACTIONS(4557),
    [aux_sym_preproc_else_token1] = ACTIONS(4557),
    [aux_sym_preproc_elif_token1] = ACTIONS(4555),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4557),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4557),
    [anon_sym_LPAREN2] = ACTIONS(4557),
    [anon_sym_DASH] = ACTIONS(4555),
    [anon_sym_PLUS] = ACTIONS(4555),
    [anon_sym_STAR] = ACTIONS(4555),
    [anon_sym_SLASH] = ACTIONS(4555),
    [anon_sym_PERCENT] = ACTIONS(4555),
    [anon_sym_PIPE_PIPE] = ACTIONS(4557),
    [anon_sym_AMP_AMP] = ACTIONS(4557),
    [anon_sym_PIPE] = ACTIONS(4555),
    [anon_sym_CARET] = ACTIONS(4555),
    [anon_sym_AMP] = ACTIONS(4555),
    [anon_sym_EQ_EQ] = ACTIONS(4557),
    [anon_sym_BANG_EQ] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4555),
    [anon_sym_GT_EQ] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4555),
    [anon_sym_LT_LT] = ACTIONS(4555),
    [anon_sym_GT_GT] = ACTIONS(4555),
    [anon_sym_SEMI] = ACTIONS(4557),
    [anon_sym___attribute__] = ACTIONS(4555),
    [anon_sym_COLON_COLON] = ACTIONS(4557),
    [anon_sym_LBRACE] = ACTIONS(4557),
    [anon_sym_RBRACE] = ACTIONS(4557),
    [anon_sym_LBRACK] = ACTIONS(4557),
    [anon_sym_RBRACK] = ACTIONS(4557),
    [anon_sym_EQ] = ACTIONS(4555),
    [anon_sym_COLON] = ACTIONS(4555),
    [anon_sym_QMARK] = ACTIONS(4557),
    [anon_sym_STAR_EQ] = ACTIONS(4557),
    [anon_sym_SLASH_EQ] = ACTIONS(4557),
    [anon_sym_PERCENT_EQ] = ACTIONS(4557),
    [anon_sym_PLUS_EQ] = ACTIONS(4557),
    [anon_sym_DASH_EQ] = ACTIONS(4557),
    [anon_sym_LT_LT_EQ] = ACTIONS(4557),
    [anon_sym_GT_GT_EQ] = ACTIONS(4557),
    [anon_sym_AMP_EQ] = ACTIONS(4557),
    [anon_sym_CARET_EQ] = ACTIONS(4557),
    [anon_sym_PIPE_EQ] = ACTIONS(4557),
    [anon_sym_and_eq] = ACTIONS(4555),
    [anon_sym_or_eq] = ACTIONS(4555),
    [anon_sym_xor_eq] = ACTIONS(4555),
    [anon_sym_LT_EQ_GT] = ACTIONS(4557),
    [anon_sym_or] = ACTIONS(4555),
    [anon_sym_and] = ACTIONS(4555),
    [anon_sym_bitor] = ACTIONS(4555),
    [anon_sym_xor] = ACTIONS(4555),
    [anon_sym_bitand] = ACTIONS(4555),
    [anon_sym_not_eq] = ACTIONS(4555),
    [anon_sym_DASH_DASH] = ACTIONS(4557),
    [anon_sym_PLUS_PLUS] = ACTIONS(4557),
    [anon_sym_DOT] = ACTIONS(4555),
    [anon_sym_DOT_STAR] = ACTIONS(4557),
    [anon_sym_DASH_GT] = ACTIONS(4557),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4555),
    [anon_sym_decltype] = ACTIONS(4555),
    [anon_sym_final] = ACTIONS(4555),
    [anon_sym_override] = ACTIONS(4555),
  },
  [2024] = {
    [sym_template_argument_list] = STATE(1741),
    [sym_identifier] = ACTIONS(4534),
    [anon_sym_LPAREN2] = ACTIONS(4541),
    [anon_sym_TILDE] = ACTIONS(4541),
    [anon_sym_STAR] = ACTIONS(4541),
    [anon_sym_PIPE_PIPE] = ACTIONS(4541),
    [anon_sym_AMP_AMP] = ACTIONS(4541),
    [anon_sym_AMP] = ACTIONS(4534),
    [anon_sym_LT] = ACTIONS(5238),
    [anon_sym___extension__] = ACTIONS(4534),
    [anon_sym_extern] = ACTIONS(4534),
    [anon_sym___attribute__] = ACTIONS(4534),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4541),
    [anon_sym___declspec] = ACTIONS(4534),
    [anon_sym___based] = ACTIONS(4534),
    [anon_sym___cdecl] = ACTIONS(4534),
    [anon_sym___clrcall] = ACTIONS(4534),
    [anon_sym___stdcall] = ACTIONS(4534),
    [anon_sym___fastcall] = ACTIONS(4534),
    [anon_sym___thiscall] = ACTIONS(4534),
    [anon_sym___vectorcall] = ACTIONS(4534),
    [anon_sym_signed] = ACTIONS(4534),
    [anon_sym_unsigned] = ACTIONS(4534),
    [anon_sym_long] = ACTIONS(4534),
    [anon_sym_short] = ACTIONS(4534),
    [anon_sym_LBRACK] = ACTIONS(4534),
    [anon_sym_static] = ACTIONS(4534),
    [anon_sym_register] = ACTIONS(4534),
    [anon_sym_inline] = ACTIONS(4534),
    [anon_sym___inline] = ACTIONS(4534),
    [anon_sym___inline__] = ACTIONS(4534),
    [anon_sym___forceinline] = ACTIONS(4534),
    [anon_sym_thread_local] = ACTIONS(4534),
    [anon_sym___thread] = ACTIONS(4534),
    [anon_sym_const] = ACTIONS(4534),
    [anon_sym_constexpr] = ACTIONS(4534),
    [anon_sym_volatile] = ACTIONS(4534),
    [anon_sym_restrict] = ACTIONS(4534),
    [anon_sym___restrict__] = ACTIONS(4534),
    [anon_sym__Atomic] = ACTIONS(4534),
    [anon_sym__Noreturn] = ACTIONS(4534),
    [anon_sym_noreturn] = ACTIONS(4534),
    [anon_sym_mutable] = ACTIONS(4534),
    [anon_sym_constinit] = ACTIONS(4534),
    [anon_sym_consteval] = ACTIONS(4534),
    [anon_sym_PROGMEM] = ACTIONS(4534),
    [aux_sym_primitive_type_token1] = ACTIONS(4534),
    [anon_sym_byte] = ACTIONS(4534),
    [anon_sym_word] = ACTIONS(4534),
    [anon_sym_enum] = ACTIONS(4534),
    [anon_sym_class] = ACTIONS(4534),
    [anon_sym_struct] = ACTIONS(4534),
    [anon_sym_union] = ACTIONS(4534),
    [anon_sym_or] = ACTIONS(4534),
    [anon_sym_and] = ACTIONS(4534),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4534),
    [anon_sym_decltype] = ACTIONS(4534),
    [anon_sym_virtual] = ACTIONS(4534),
    [anon_sym_alignas] = ACTIONS(4534),
    [anon_sym_explicit] = ACTIONS(4534),
    [anon_sym_typename] = ACTIONS(4534),
    [anon_sym_template] = ACTIONS(4534),
    [anon_sym_operator] = ACTIONS(4534),
    [anon_sym_friend] = ACTIONS(4534),
    [anon_sym_using] = ACTIONS(4534),
    [anon_sym_concept] = ACTIONS(4534),
  },
  [2025] = {
    [sym_identifier] = ACTIONS(4551),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4553),
    [anon_sym_COMMA] = ACTIONS(4553),
    [anon_sym_RPAREN] = ACTIONS(4553),
    [aux_sym_preproc_if_token2] = ACTIONS(4553),
    [aux_sym_preproc_else_token1] = ACTIONS(4553),
    [aux_sym_preproc_elif_token1] = ACTIONS(4551),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4553),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4553),
    [anon_sym_LPAREN2] = ACTIONS(4553),
    [anon_sym_DASH] = ACTIONS(4551),
    [anon_sym_PLUS] = ACTIONS(4551),
    [anon_sym_STAR] = ACTIONS(4551),
    [anon_sym_SLASH] = ACTIONS(4551),
    [anon_sym_PERCENT] = ACTIONS(4551),
    [anon_sym_PIPE_PIPE] = ACTIONS(4553),
    [anon_sym_AMP_AMP] = ACTIONS(4553),
    [anon_sym_PIPE] = ACTIONS(4551),
    [anon_sym_CARET] = ACTIONS(4551),
    [anon_sym_AMP] = ACTIONS(4551),
    [anon_sym_EQ_EQ] = ACTIONS(4553),
    [anon_sym_BANG_EQ] = ACTIONS(4553),
    [anon_sym_GT] = ACTIONS(4551),
    [anon_sym_GT_EQ] = ACTIONS(4553),
    [anon_sym_LT_EQ] = ACTIONS(4551),
    [anon_sym_LT] = ACTIONS(4551),
    [anon_sym_LT_LT] = ACTIONS(4551),
    [anon_sym_GT_GT] = ACTIONS(4551),
    [anon_sym_SEMI] = ACTIONS(4553),
    [anon_sym___attribute__] = ACTIONS(4551),
    [anon_sym_COLON_COLON] = ACTIONS(4553),
    [anon_sym_LBRACE] = ACTIONS(4553),
    [anon_sym_RBRACE] = ACTIONS(4553),
    [anon_sym_LBRACK] = ACTIONS(4553),
    [anon_sym_RBRACK] = ACTIONS(4553),
    [anon_sym_EQ] = ACTIONS(4551),
    [anon_sym_COLON] = ACTIONS(4551),
    [anon_sym_QMARK] = ACTIONS(4553),
    [anon_sym_STAR_EQ] = ACTIONS(4553),
    [anon_sym_SLASH_EQ] = ACTIONS(4553),
    [anon_sym_PERCENT_EQ] = ACTIONS(4553),
    [anon_sym_PLUS_EQ] = ACTIONS(4553),
    [anon_sym_DASH_EQ] = ACTIONS(4553),
    [anon_sym_LT_LT_EQ] = ACTIONS(4553),
    [anon_sym_GT_GT_EQ] = ACTIONS(4553),
    [anon_sym_AMP_EQ] = ACTIONS(4553),
    [anon_sym_CARET_EQ] = ACTIONS(4553),
    [anon_sym_PIPE_EQ] = ACTIONS(4553),
    [anon_sym_and_eq] = ACTIONS(4551),
    [anon_sym_or_eq] = ACTIONS(4551),
    [anon_sym_xor_eq] = ACTIONS(4551),
    [anon_sym_LT_EQ_GT] = ACTIONS(4553),
    [anon_sym_or] = ACTIONS(4551),
    [anon_sym_and] = ACTIONS(4551),
    [anon_sym_bitor] = ACTIONS(4551),
    [anon_sym_xor] = ACTIONS(4551),
    [anon_sym_bitand] = ACTIONS(4551),
    [anon_sym_not_eq] = ACTIONS(4551),
    [anon_sym_DASH_DASH] = ACTIONS(4553),
    [anon_sym_PLUS_PLUS] = ACTIONS(4553),
    [anon_sym_DOT] = ACTIONS(4551),
    [anon_sym_DOT_STAR] = ACTIONS(4553),
    [anon_sym_DASH_GT] = ACTIONS(4553),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4551),
    [anon_sym_decltype] = ACTIONS(4551),
    [anon_sym_final] = ACTIONS(4551),
    [anon_sym_override] = ACTIONS(4551),
  },
  [2026] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2026),
    [sym_identifier] = ACTIONS(4766),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4768),
    [anon_sym_COMMA] = ACTIONS(4768),
    [anon_sym_RPAREN] = ACTIONS(4768),
    [anon_sym_LPAREN2] = ACTIONS(4768),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_STAR] = ACTIONS(4768),
    [anon_sym_AMP_AMP] = ACTIONS(4768),
    [anon_sym_AMP] = ACTIONS(4766),
    [anon_sym_SEMI] = ACTIONS(4768),
    [anon_sym___extension__] = ACTIONS(4766),
    [anon_sym_extern] = ACTIONS(4766),
    [anon_sym___attribute__] = ACTIONS(4766),
    [anon_sym_COLON_COLON] = ACTIONS(4768),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4768),
    [anon_sym___declspec] = ACTIONS(4766),
    [anon_sym___based] = ACTIONS(4766),
    [anon_sym___cdecl] = ACTIONS(4766),
    [anon_sym___clrcall] = ACTIONS(4766),
    [anon_sym___stdcall] = ACTIONS(4766),
    [anon_sym___fastcall] = ACTIONS(4766),
    [anon_sym___thiscall] = ACTIONS(4766),
    [anon_sym___vectorcall] = ACTIONS(4766),
    [anon_sym_LBRACE] = ACTIONS(4768),
    [anon_sym_signed] = ACTIONS(5247),
    [anon_sym_unsigned] = ACTIONS(5247),
    [anon_sym_long] = ACTIONS(5247),
    [anon_sym_short] = ACTIONS(5247),
    [anon_sym_LBRACK] = ACTIONS(4766),
    [anon_sym_EQ] = ACTIONS(4768),
    [anon_sym_static] = ACTIONS(4766),
    [anon_sym_register] = ACTIONS(4766),
    [anon_sym_inline] = ACTIONS(4766),
    [anon_sym___inline] = ACTIONS(4766),
    [anon_sym___inline__] = ACTIONS(4766),
    [anon_sym___forceinline] = ACTIONS(4766),
    [anon_sym_thread_local] = ACTIONS(4766),
    [anon_sym___thread] = ACTIONS(4766),
    [anon_sym_const] = ACTIONS(4766),
    [anon_sym_constexpr] = ACTIONS(4766),
    [anon_sym_volatile] = ACTIONS(4766),
    [anon_sym_restrict] = ACTIONS(4766),
    [anon_sym___restrict__] = ACTIONS(4766),
    [anon_sym__Atomic] = ACTIONS(4766),
    [anon_sym__Noreturn] = ACTIONS(4766),
    [anon_sym_noreturn] = ACTIONS(4766),
    [anon_sym_mutable] = ACTIONS(4766),
    [anon_sym_constinit] = ACTIONS(4766),
    [anon_sym_consteval] = ACTIONS(4766),
    [anon_sym_PROGMEM] = ACTIONS(4766),
    [aux_sym_primitive_type_token1] = ACTIONS(4766),
    [anon_sym_byte] = ACTIONS(4766),
    [anon_sym_word] = ACTIONS(4766),
    [anon_sym_asm] = ACTIONS(4766),
    [anon_sym___asm__] = ACTIONS(4766),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4766),
    [anon_sym_decltype] = ACTIONS(4766),
    [anon_sym_final] = ACTIONS(4766),
    [anon_sym_override] = ACTIONS(4766),
    [anon_sym_virtual] = ACTIONS(4766),
    [anon_sym_alignas] = ACTIONS(4766),
    [anon_sym_template] = ACTIONS(4766),
    [anon_sym_GT2] = ACTIONS(4768),
    [anon_sym_operator] = ACTIONS(4766),
    [anon_sym_try] = ACTIONS(4766),
    [anon_sym_requires] = ACTIONS(4766),
  },
  [2027] = {
    [sym_identifier] = ACTIONS(2527),
    [aux_sym_preproc_def_token1] = ACTIONS(2527),
    [aux_sym_preproc_if_token1] = ACTIONS(2527),
    [aux_sym_preproc_if_token2] = ACTIONS(2527),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2527),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2527),
    [sym_preproc_directive] = ACTIONS(2527),
    [anon_sym_LPAREN2] = ACTIONS(2529),
    [anon_sym_TILDE] = ACTIONS(2529),
    [anon_sym_STAR] = ACTIONS(2529),
    [anon_sym_AMP_AMP] = ACTIONS(2529),
    [anon_sym_AMP] = ACTIONS(2527),
    [anon_sym___extension__] = ACTIONS(2527),
    [anon_sym_typedef] = ACTIONS(2527),
    [anon_sym_extern] = ACTIONS(2527),
    [anon_sym___attribute__] = ACTIONS(2527),
    [anon_sym_COLON_COLON] = ACTIONS(2529),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2529),
    [anon_sym___declspec] = ACTIONS(2527),
    [anon_sym___based] = ACTIONS(2527),
    [anon_sym_signed] = ACTIONS(2527),
    [anon_sym_unsigned] = ACTIONS(2527),
    [anon_sym_long] = ACTIONS(2527),
    [anon_sym_short] = ACTIONS(2527),
    [anon_sym_LBRACK] = ACTIONS(2527),
    [anon_sym_static] = ACTIONS(2527),
    [anon_sym_register] = ACTIONS(2527),
    [anon_sym_inline] = ACTIONS(2527),
    [anon_sym___inline] = ACTIONS(2527),
    [anon_sym___inline__] = ACTIONS(2527),
    [anon_sym___forceinline] = ACTIONS(2527),
    [anon_sym_thread_local] = ACTIONS(2527),
    [anon_sym___thread] = ACTIONS(2527),
    [anon_sym_const] = ACTIONS(2527),
    [anon_sym_constexpr] = ACTIONS(2527),
    [anon_sym_volatile] = ACTIONS(2527),
    [anon_sym_restrict] = ACTIONS(2527),
    [anon_sym___restrict__] = ACTIONS(2527),
    [anon_sym__Atomic] = ACTIONS(2527),
    [anon_sym__Noreturn] = ACTIONS(2527),
    [anon_sym_noreturn] = ACTIONS(2527),
    [anon_sym_mutable] = ACTIONS(2527),
    [anon_sym_constinit] = ACTIONS(2527),
    [anon_sym_consteval] = ACTIONS(2527),
    [anon_sym_PROGMEM] = ACTIONS(2527),
    [aux_sym_primitive_type_token1] = ACTIONS(2527),
    [anon_sym_byte] = ACTIONS(2527),
    [anon_sym_word] = ACTIONS(2527),
    [anon_sym_enum] = ACTIONS(2527),
    [anon_sym_class] = ACTIONS(2527),
    [anon_sym_struct] = ACTIONS(2527),
    [anon_sym_union] = ACTIONS(2527),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2527),
    [anon_sym_decltype] = ACTIONS(2527),
    [anon_sym_virtual] = ACTIONS(2527),
    [anon_sym_alignas] = ACTIONS(2527),
    [anon_sym_explicit] = ACTIONS(2527),
    [anon_sym_typename] = ACTIONS(2527),
    [anon_sym_template] = ACTIONS(2527),
    [anon_sym_operator] = ACTIONS(2527),
    [anon_sym_friend] = ACTIONS(2527),
    [anon_sym_public] = ACTIONS(2527),
    [anon_sym_private] = ACTIONS(2527),
    [anon_sym_protected] = ACTIONS(2527),
    [anon_sym_using] = ACTIONS(2527),
    [anon_sym_static_assert] = ACTIONS(2527),
    [anon_sym_catch] = ACTIONS(2527),
  },
  [2028] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1782),
    [sym_identifier] = ACTIONS(5142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5139),
    [anon_sym_COMMA] = ACTIONS(5139),
    [aux_sym_preproc_if_token2] = ACTIONS(5139),
    [aux_sym_preproc_else_token1] = ACTIONS(5139),
    [aux_sym_preproc_elif_token1] = ACTIONS(5142),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5139),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5139),
    [anon_sym_LPAREN2] = ACTIONS(5139),
    [anon_sym_DASH] = ACTIONS(5142),
    [anon_sym_PLUS] = ACTIONS(5142),
    [anon_sym_STAR] = ACTIONS(5142),
    [anon_sym_SLASH] = ACTIONS(5142),
    [anon_sym_PERCENT] = ACTIONS(5142),
    [anon_sym_PIPE_PIPE] = ACTIONS(5139),
    [anon_sym_AMP_AMP] = ACTIONS(5139),
    [anon_sym_PIPE] = ACTIONS(5142),
    [anon_sym_CARET] = ACTIONS(5142),
    [anon_sym_AMP] = ACTIONS(5142),
    [anon_sym_EQ_EQ] = ACTIONS(5139),
    [anon_sym_BANG_EQ] = ACTIONS(5139),
    [anon_sym_GT] = ACTIONS(5142),
    [anon_sym_GT_EQ] = ACTIONS(5139),
    [anon_sym_LT_EQ] = ACTIONS(5142),
    [anon_sym_LT] = ACTIONS(5142),
    [anon_sym_LT_LT] = ACTIONS(5142),
    [anon_sym_GT_GT] = ACTIONS(5142),
    [anon_sym___attribute__] = ACTIONS(5142),
    [anon_sym_LBRACE] = ACTIONS(5139),
    [anon_sym_signed] = ACTIONS(4805),
    [anon_sym_unsigned] = ACTIONS(4805),
    [anon_sym_long] = ACTIONS(4805),
    [anon_sym_short] = ACTIONS(4805),
    [anon_sym_LBRACK] = ACTIONS(5139),
    [anon_sym_EQ] = ACTIONS(5142),
    [aux_sym_primitive_type_token1] = ACTIONS(4766),
    [anon_sym_byte] = ACTIONS(4766),
    [anon_sym_word] = ACTIONS(4766),
    [anon_sym_QMARK] = ACTIONS(5139),
    [anon_sym_STAR_EQ] = ACTIONS(5139),
    [anon_sym_SLASH_EQ] = ACTIONS(5139),
    [anon_sym_PERCENT_EQ] = ACTIONS(5139),
    [anon_sym_PLUS_EQ] = ACTIONS(5139),
    [anon_sym_DASH_EQ] = ACTIONS(5139),
    [anon_sym_LT_LT_EQ] = ACTIONS(5139),
    [anon_sym_GT_GT_EQ] = ACTIONS(5139),
    [anon_sym_AMP_EQ] = ACTIONS(5139),
    [anon_sym_CARET_EQ] = ACTIONS(5139),
    [anon_sym_PIPE_EQ] = ACTIONS(5139),
    [anon_sym_and_eq] = ACTIONS(5142),
    [anon_sym_or_eq] = ACTIONS(5142),
    [anon_sym_xor_eq] = ACTIONS(5142),
    [anon_sym_LT_EQ_GT] = ACTIONS(5139),
    [anon_sym_or] = ACTIONS(5142),
    [anon_sym_and] = ACTIONS(5142),
    [anon_sym_bitor] = ACTIONS(5142),
    [anon_sym_xor] = ACTIONS(5142),
    [anon_sym_bitand] = ACTIONS(5142),
    [anon_sym_not_eq] = ACTIONS(5142),
    [anon_sym_DASH_DASH] = ACTIONS(5139),
    [anon_sym_PLUS_PLUS] = ACTIONS(5139),
    [anon_sym_DOT] = ACTIONS(5142),
    [anon_sym_DOT_STAR] = ACTIONS(5139),
    [anon_sym_DASH_GT] = ACTIONS(5139),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5142),
    [anon_sym_decltype] = ACTIONS(5142),
  },
  [2029] = {
    [sym_string_literal] = STATE(2079),
    [sym_template_argument_list] = STATE(2992),
    [sym_raw_string_literal] = STATE(2079),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3761),
    [anon_sym_COMMA] = ACTIONS(3761),
    [anon_sym_RPAREN] = ACTIONS(5250),
    [anon_sym_LPAREN2] = ACTIONS(5250),
    [anon_sym_DASH] = ACTIONS(3769),
    [anon_sym_PLUS] = ACTIONS(3769),
    [anon_sym_STAR] = ACTIONS(3769),
    [anon_sym_SLASH] = ACTIONS(3769),
    [anon_sym_PERCENT] = ACTIONS(3769),
    [anon_sym_PIPE_PIPE] = ACTIONS(3761),
    [anon_sym_AMP_AMP] = ACTIONS(3761),
    [anon_sym_PIPE] = ACTIONS(3769),
    [anon_sym_CARET] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(3769),
    [anon_sym_EQ_EQ] = ACTIONS(3761),
    [anon_sym_BANG_EQ] = ACTIONS(3761),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3761),
    [anon_sym_LT_EQ] = ACTIONS(3769),
    [anon_sym_LT] = ACTIONS(4598),
    [anon_sym_LT_LT] = ACTIONS(3769),
    [anon_sym_GT_GT] = ACTIONS(3769),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4601),
    [anon_sym_LBRACE] = ACTIONS(3785),
    [anon_sym_LBRACK] = ACTIONS(5253),
    [anon_sym_EQ] = ACTIONS(3769),
    [anon_sym_QMARK] = ACTIONS(3761),
    [anon_sym_STAR_EQ] = ACTIONS(3761),
    [anon_sym_SLASH_EQ] = ACTIONS(3761),
    [anon_sym_PERCENT_EQ] = ACTIONS(3761),
    [anon_sym_PLUS_EQ] = ACTIONS(3761),
    [anon_sym_DASH_EQ] = ACTIONS(3761),
    [anon_sym_LT_LT_EQ] = ACTIONS(3761),
    [anon_sym_GT_GT_EQ] = ACTIONS(3761),
    [anon_sym_AMP_EQ] = ACTIONS(3761),
    [anon_sym_CARET_EQ] = ACTIONS(3761),
    [anon_sym_PIPE_EQ] = ACTIONS(3761),
    [anon_sym_and_eq] = ACTIONS(3761),
    [anon_sym_or_eq] = ACTIONS(3761),
    [anon_sym_xor_eq] = ACTIONS(3761),
    [anon_sym_LT_EQ_GT] = ACTIONS(3761),
    [anon_sym_or] = ACTIONS(3769),
    [anon_sym_and] = ACTIONS(3769),
    [anon_sym_bitor] = ACTIONS(3761),
    [anon_sym_xor] = ACTIONS(3769),
    [anon_sym_bitand] = ACTIONS(3761),
    [anon_sym_not_eq] = ACTIONS(3761),
    [anon_sym_DASH_DASH] = ACTIONS(3761),
    [anon_sym_PLUS_PLUS] = ACTIONS(3761),
    [anon_sym_DOT] = ACTIONS(3769),
    [anon_sym_DOT_STAR] = ACTIONS(3761),
    [anon_sym_DASH_GT] = ACTIONS(3769),
    [anon_sym_L_DQUOTE] = ACTIONS(4605),
    [anon_sym_u_DQUOTE] = ACTIONS(4605),
    [anon_sym_U_DQUOTE] = ACTIONS(4605),
    [anon_sym_u8_DQUOTE] = ACTIONS(4605),
    [anon_sym_DQUOTE] = ACTIONS(4605),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4607),
    [anon_sym_LR_DQUOTE] = ACTIONS(4607),
    [anon_sym_uR_DQUOTE] = ACTIONS(4607),
    [anon_sym_UR_DQUOTE] = ACTIONS(4607),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4607),
    [anon_sym_DASH_GT_STAR] = ACTIONS(3761),
  },
  [2030] = {
    [sym_identifier] = ACTIONS(4575),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4582),
    [anon_sym_COMMA] = ACTIONS(4582),
    [anon_sym_RPAREN] = ACTIONS(4582),
    [aux_sym_preproc_if_token2] = ACTIONS(4582),
    [aux_sym_preproc_else_token1] = ACTIONS(4582),
    [aux_sym_preproc_elif_token1] = ACTIONS(4575),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4582),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4582),
    [anon_sym_LPAREN2] = ACTIONS(4582),
    [anon_sym_DASH] = ACTIONS(4575),
    [anon_sym_PLUS] = ACTIONS(4575),
    [anon_sym_STAR] = ACTIONS(4582),
    [anon_sym_SLASH] = ACTIONS(4575),
    [anon_sym_PERCENT] = ACTIONS(4582),
    [anon_sym_PIPE_PIPE] = ACTIONS(4582),
    [anon_sym_AMP_AMP] = ACTIONS(4582),
    [anon_sym_PIPE] = ACTIONS(4575),
    [anon_sym_CARET] = ACTIONS(4582),
    [anon_sym_AMP] = ACTIONS(4575),
    [anon_sym_EQ_EQ] = ACTIONS(4582),
    [anon_sym_BANG_EQ] = ACTIONS(4582),
    [anon_sym_GT] = ACTIONS(4575),
    [anon_sym_GT_EQ] = ACTIONS(4582),
    [anon_sym_LT_EQ] = ACTIONS(4575),
    [anon_sym_LT] = ACTIONS(4575),
    [anon_sym_LT_LT] = ACTIONS(4582),
    [anon_sym_GT_GT] = ACTIONS(4582),
    [anon_sym_SEMI] = ACTIONS(4582),
    [anon_sym___extension__] = ACTIONS(4575),
    [anon_sym___attribute__] = ACTIONS(4575),
    [anon_sym_COLON_COLON] = ACTIONS(4582),
    [anon_sym_LBRACE] = ACTIONS(4582),
    [anon_sym_RBRACE] = ACTIONS(4582),
    [anon_sym_LBRACK] = ACTIONS(4582),
    [anon_sym_RBRACK] = ACTIONS(4582),
    [anon_sym_const] = ACTIONS(4575),
    [anon_sym_constexpr] = ACTIONS(4575),
    [anon_sym_volatile] = ACTIONS(4575),
    [anon_sym_restrict] = ACTIONS(4575),
    [anon_sym___restrict__] = ACTIONS(4575),
    [anon_sym__Atomic] = ACTIONS(4575),
    [anon_sym__Noreturn] = ACTIONS(4575),
    [anon_sym_noreturn] = ACTIONS(4575),
    [anon_sym_mutable] = ACTIONS(4575),
    [anon_sym_constinit] = ACTIONS(4575),
    [anon_sym_consteval] = ACTIONS(4575),
    [anon_sym_PROGMEM] = ACTIONS(4575),
    [anon_sym_COLON] = ACTIONS(4575),
    [anon_sym_QMARK] = ACTIONS(4582),
    [anon_sym_LT_EQ_GT] = ACTIONS(4582),
    [anon_sym_or] = ACTIONS(4575),
    [anon_sym_and] = ACTIONS(4575),
    [anon_sym_bitor] = ACTIONS(4575),
    [anon_sym_xor] = ACTIONS(4575),
    [anon_sym_bitand] = ACTIONS(4575),
    [anon_sym_not_eq] = ACTIONS(4575),
    [anon_sym_DASH_DASH] = ACTIONS(4582),
    [anon_sym_PLUS_PLUS] = ACTIONS(4582),
    [anon_sym_DOT] = ACTIONS(4575),
    [anon_sym_DOT_STAR] = ACTIONS(4582),
    [anon_sym_DASH_GT] = ACTIONS(4582),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4575),
    [anon_sym_decltype] = ACTIONS(4575),
    [anon_sym_final] = ACTIONS(4575),
    [anon_sym_override] = ACTIONS(4575),
    [anon_sym_requires] = ACTIONS(4575),
  },
  [2031] = {
    [sym_identifier] = ACTIONS(2985),
    [aux_sym_preproc_def_token1] = ACTIONS(2985),
    [aux_sym_preproc_if_token1] = ACTIONS(2985),
    [aux_sym_preproc_if_token2] = ACTIONS(2985),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2985),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2985),
    [sym_preproc_directive] = ACTIONS(2985),
    [anon_sym_LPAREN2] = ACTIONS(2987),
    [anon_sym_TILDE] = ACTIONS(2987),
    [anon_sym_STAR] = ACTIONS(2987),
    [anon_sym_AMP_AMP] = ACTIONS(2987),
    [anon_sym_AMP] = ACTIONS(2985),
    [anon_sym_SEMI] = ACTIONS(5256),
    [anon_sym___extension__] = ACTIONS(2985),
    [anon_sym_typedef] = ACTIONS(2985),
    [anon_sym_extern] = ACTIONS(2985),
    [anon_sym___attribute__] = ACTIONS(2985),
    [anon_sym_COLON_COLON] = ACTIONS(2987),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2987),
    [anon_sym___declspec] = ACTIONS(2985),
    [anon_sym___based] = ACTIONS(2985),
    [anon_sym_signed] = ACTIONS(2985),
    [anon_sym_unsigned] = ACTIONS(2985),
    [anon_sym_long] = ACTIONS(2985),
    [anon_sym_short] = ACTIONS(2985),
    [anon_sym_LBRACK] = ACTIONS(2985),
    [anon_sym_static] = ACTIONS(2985),
    [anon_sym_register] = ACTIONS(2985),
    [anon_sym_inline] = ACTIONS(2985),
    [anon_sym___inline] = ACTIONS(2985),
    [anon_sym___inline__] = ACTIONS(2985),
    [anon_sym___forceinline] = ACTIONS(2985),
    [anon_sym_thread_local] = ACTIONS(2985),
    [anon_sym___thread] = ACTIONS(2985),
    [anon_sym_const] = ACTIONS(2985),
    [anon_sym_constexpr] = ACTIONS(2985),
    [anon_sym_volatile] = ACTIONS(2985),
    [anon_sym_restrict] = ACTIONS(2985),
    [anon_sym___restrict__] = ACTIONS(2985),
    [anon_sym__Atomic] = ACTIONS(2985),
    [anon_sym__Noreturn] = ACTIONS(2985),
    [anon_sym_noreturn] = ACTIONS(2985),
    [anon_sym_mutable] = ACTIONS(2985),
    [anon_sym_constinit] = ACTIONS(2985),
    [anon_sym_consteval] = ACTIONS(2985),
    [anon_sym_PROGMEM] = ACTIONS(2985),
    [aux_sym_primitive_type_token1] = ACTIONS(2985),
    [anon_sym_byte] = ACTIONS(2985),
    [anon_sym_word] = ACTIONS(2985),
    [anon_sym_enum] = ACTIONS(2985),
    [anon_sym_class] = ACTIONS(2985),
    [anon_sym_struct] = ACTIONS(2985),
    [anon_sym_union] = ACTIONS(2985),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2985),
    [anon_sym_decltype] = ACTIONS(2985),
    [anon_sym_virtual] = ACTIONS(2985),
    [anon_sym_alignas] = ACTIONS(2985),
    [anon_sym_explicit] = ACTIONS(2985),
    [anon_sym_typename] = ACTIONS(2985),
    [anon_sym_template] = ACTIONS(2985),
    [anon_sym_operator] = ACTIONS(2985),
    [anon_sym_friend] = ACTIONS(2985),
    [anon_sym_public] = ACTIONS(2985),
    [anon_sym_private] = ACTIONS(2985),
    [anon_sym_protected] = ACTIONS(2985),
    [anon_sym_using] = ACTIONS(2985),
    [anon_sym_static_assert] = ACTIONS(2985),
  },
  [2032] = {
    [sym_identifier] = ACTIONS(3122),
    [aux_sym_preproc_def_token1] = ACTIONS(3122),
    [aux_sym_preproc_if_token1] = ACTIONS(3122),
    [aux_sym_preproc_if_token2] = ACTIONS(3122),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3122),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3122),
    [sym_preproc_directive] = ACTIONS(3122),
    [anon_sym_LPAREN2] = ACTIONS(3124),
    [anon_sym_TILDE] = ACTIONS(3124),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP_AMP] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3122),
    [anon_sym_SEMI] = ACTIONS(5258),
    [anon_sym___extension__] = ACTIONS(3122),
    [anon_sym_typedef] = ACTIONS(3122),
    [anon_sym_extern] = ACTIONS(3122),
    [anon_sym___attribute__] = ACTIONS(3122),
    [anon_sym_COLON_COLON] = ACTIONS(3124),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3124),
    [anon_sym___declspec] = ACTIONS(3122),
    [anon_sym___based] = ACTIONS(3122),
    [anon_sym_signed] = ACTIONS(3122),
    [anon_sym_unsigned] = ACTIONS(3122),
    [anon_sym_long] = ACTIONS(3122),
    [anon_sym_short] = ACTIONS(3122),
    [anon_sym_LBRACK] = ACTIONS(3122),
    [anon_sym_static] = ACTIONS(3122),
    [anon_sym_register] = ACTIONS(3122),
    [anon_sym_inline] = ACTIONS(3122),
    [anon_sym___inline] = ACTIONS(3122),
    [anon_sym___inline__] = ACTIONS(3122),
    [anon_sym___forceinline] = ACTIONS(3122),
    [anon_sym_thread_local] = ACTIONS(3122),
    [anon_sym___thread] = ACTIONS(3122),
    [anon_sym_const] = ACTIONS(3122),
    [anon_sym_constexpr] = ACTIONS(3122),
    [anon_sym_volatile] = ACTIONS(3122),
    [anon_sym_restrict] = ACTIONS(3122),
    [anon_sym___restrict__] = ACTIONS(3122),
    [anon_sym__Atomic] = ACTIONS(3122),
    [anon_sym__Noreturn] = ACTIONS(3122),
    [anon_sym_noreturn] = ACTIONS(3122),
    [anon_sym_mutable] = ACTIONS(3122),
    [anon_sym_constinit] = ACTIONS(3122),
    [anon_sym_consteval] = ACTIONS(3122),
    [anon_sym_PROGMEM] = ACTIONS(3122),
    [aux_sym_primitive_type_token1] = ACTIONS(3122),
    [anon_sym_byte] = ACTIONS(3122),
    [anon_sym_word] = ACTIONS(3122),
    [anon_sym_enum] = ACTIONS(3122),
    [anon_sym_class] = ACTIONS(3122),
    [anon_sym_struct] = ACTIONS(3122),
    [anon_sym_union] = ACTIONS(3122),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3122),
    [anon_sym_decltype] = ACTIONS(3122),
    [anon_sym_virtual] = ACTIONS(3122),
    [anon_sym_alignas] = ACTIONS(3122),
    [anon_sym_explicit] = ACTIONS(3122),
    [anon_sym_typename] = ACTIONS(3122),
    [anon_sym_template] = ACTIONS(3122),
    [anon_sym_operator] = ACTIONS(3122),
    [anon_sym_friend] = ACTIONS(3122),
    [anon_sym_public] = ACTIONS(3122),
    [anon_sym_private] = ACTIONS(3122),
    [anon_sym_protected] = ACTIONS(3122),
    [anon_sym_using] = ACTIONS(3122),
    [anon_sym_static_assert] = ACTIONS(3122),
  },
  [2033] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4579),
    [anon_sym_COMMA] = ACTIONS(4579),
    [anon_sym_LPAREN2] = ACTIONS(4579),
    [anon_sym_DASH] = ACTIONS(4584),
    [anon_sym_PLUS] = ACTIONS(4584),
    [anon_sym_STAR] = ACTIONS(4586),
    [anon_sym_SLASH] = ACTIONS(4584),
    [anon_sym_PERCENT] = ACTIONS(4584),
    [anon_sym_PIPE_PIPE] = ACTIONS(4577),
    [anon_sym_AMP_AMP] = ACTIONS(4579),
    [anon_sym_PIPE] = ACTIONS(4584),
    [anon_sym_CARET] = ACTIONS(4584),
    [anon_sym_AMP] = ACTIONS(4586),
    [anon_sym_EQ_EQ] = ACTIONS(4577),
    [anon_sym_BANG_EQ] = ACTIONS(4577),
    [anon_sym_GT] = ACTIONS(4584),
    [anon_sym_GT_EQ] = ACTIONS(4584),
    [anon_sym_LT_EQ] = ACTIONS(4584),
    [anon_sym_LT] = ACTIONS(4584),
    [anon_sym_LT_LT] = ACTIONS(4584),
    [anon_sym_GT_GT] = ACTIONS(4584),
    [anon_sym___extension__] = ACTIONS(4582),
    [anon_sym_COLON_COLON] = ACTIONS(4582),
    [anon_sym_LBRACE] = ACTIONS(4582),
    [anon_sym_LBRACK] = ACTIONS(4579),
    [anon_sym_EQ] = ACTIONS(4584),
    [anon_sym_const] = ACTIONS(4575),
    [anon_sym_constexpr] = ACTIONS(4582),
    [anon_sym_volatile] = ACTIONS(4582),
    [anon_sym_restrict] = ACTIONS(4582),
    [anon_sym___restrict__] = ACTIONS(4582),
    [anon_sym__Atomic] = ACTIONS(4582),
    [anon_sym__Noreturn] = ACTIONS(4582),
    [anon_sym_noreturn] = ACTIONS(4582),
    [anon_sym_mutable] = ACTIONS(4582),
    [anon_sym_constinit] = ACTIONS(4582),
    [anon_sym_consteval] = ACTIONS(4582),
    [anon_sym_PROGMEM] = ACTIONS(4582),
    [anon_sym_QMARK] = ACTIONS(4577),
    [anon_sym_STAR_EQ] = ACTIONS(4577),
    [anon_sym_SLASH_EQ] = ACTIONS(4577),
    [anon_sym_PERCENT_EQ] = ACTIONS(4577),
    [anon_sym_PLUS_EQ] = ACTIONS(4577),
    [anon_sym_DASH_EQ] = ACTIONS(4577),
    [anon_sym_LT_LT_EQ] = ACTIONS(4577),
    [anon_sym_GT_GT_EQ] = ACTIONS(4584),
    [anon_sym_AMP_EQ] = ACTIONS(4577),
    [anon_sym_CARET_EQ] = ACTIONS(4577),
    [anon_sym_PIPE_EQ] = ACTIONS(4577),
    [anon_sym_and_eq] = ACTIONS(4577),
    [anon_sym_or_eq] = ACTIONS(4577),
    [anon_sym_xor_eq] = ACTIONS(4577),
    [anon_sym_LT_EQ_GT] = ACTIONS(4577),
    [anon_sym_or] = ACTIONS(4584),
    [anon_sym_and] = ACTIONS(4584),
    [anon_sym_bitor] = ACTIONS(4577),
    [anon_sym_xor] = ACTIONS(4584),
    [anon_sym_bitand] = ACTIONS(4577),
    [anon_sym_not_eq] = ACTIONS(4577),
    [anon_sym_DASH_DASH] = ACTIONS(4577),
    [anon_sym_PLUS_PLUS] = ACTIONS(4577),
    [anon_sym_DOT] = ACTIONS(4584),
    [anon_sym_DOT_STAR] = ACTIONS(4577),
    [anon_sym_DASH_GT] = ACTIONS(4577),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4582),
    [anon_sym_decltype] = ACTIONS(4582),
    [anon_sym_GT2] = ACTIONS(4579),
  },
  [2034] = {
    [sym_identifier] = ACTIONS(4918),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4920),
    [anon_sym_COMMA] = ACTIONS(4920),
    [anon_sym_RPAREN] = ACTIONS(4920),
    [aux_sym_preproc_if_token2] = ACTIONS(4920),
    [aux_sym_preproc_else_token1] = ACTIONS(4920),
    [aux_sym_preproc_elif_token1] = ACTIONS(4918),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4920),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4920),
    [anon_sym_LPAREN2] = ACTIONS(4920),
    [anon_sym_DASH] = ACTIONS(4918),
    [anon_sym_PLUS] = ACTIONS(4918),
    [anon_sym_STAR] = ACTIONS(4918),
    [anon_sym_SLASH] = ACTIONS(4918),
    [anon_sym_PERCENT] = ACTIONS(4918),
    [anon_sym_PIPE_PIPE] = ACTIONS(4920),
    [anon_sym_AMP_AMP] = ACTIONS(4920),
    [anon_sym_PIPE] = ACTIONS(4918),
    [anon_sym_CARET] = ACTIONS(4918),
    [anon_sym_AMP] = ACTIONS(4918),
    [anon_sym_EQ_EQ] = ACTIONS(4920),
    [anon_sym_BANG_EQ] = ACTIONS(4920),
    [anon_sym_GT] = ACTIONS(4918),
    [anon_sym_GT_EQ] = ACTIONS(4920),
    [anon_sym_LT_EQ] = ACTIONS(4918),
    [anon_sym_LT] = ACTIONS(4918),
    [anon_sym_LT_LT] = ACTIONS(4918),
    [anon_sym_GT_GT] = ACTIONS(4918),
    [anon_sym_SEMI] = ACTIONS(4920),
    [anon_sym___attribute__] = ACTIONS(4918),
    [anon_sym_COLON_COLON] = ACTIONS(4922),
    [anon_sym_LBRACE] = ACTIONS(4920),
    [anon_sym_RBRACE] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(4920),
    [anon_sym_RBRACK] = ACTIONS(4920),
    [anon_sym_EQ] = ACTIONS(4918),
    [anon_sym_COLON] = ACTIONS(4918),
    [anon_sym_QMARK] = ACTIONS(4920),
    [anon_sym_STAR_EQ] = ACTIONS(4920),
    [anon_sym_SLASH_EQ] = ACTIONS(4920),
    [anon_sym_PERCENT_EQ] = ACTIONS(4920),
    [anon_sym_PLUS_EQ] = ACTIONS(4920),
    [anon_sym_DASH_EQ] = ACTIONS(4920),
    [anon_sym_LT_LT_EQ] = ACTIONS(4920),
    [anon_sym_GT_GT_EQ] = ACTIONS(4920),
    [anon_sym_AMP_EQ] = ACTIONS(4920),
    [anon_sym_CARET_EQ] = ACTIONS(4920),
    [anon_sym_PIPE_EQ] = ACTIONS(4920),
    [anon_sym_and_eq] = ACTIONS(4918),
    [anon_sym_or_eq] = ACTIONS(4918),
    [anon_sym_xor_eq] = ACTIONS(4918),
    [anon_sym_LT_EQ_GT] = ACTIONS(4920),
    [anon_sym_or] = ACTIONS(4918),
    [anon_sym_and] = ACTIONS(4918),
    [anon_sym_bitor] = ACTIONS(4918),
    [anon_sym_xor] = ACTIONS(4918),
    [anon_sym_bitand] = ACTIONS(4918),
    [anon_sym_not_eq] = ACTIONS(4918),
    [anon_sym_DASH_DASH] = ACTIONS(4920),
    [anon_sym_PLUS_PLUS] = ACTIONS(4920),
    [anon_sym_DOT] = ACTIONS(4918),
    [anon_sym_DOT_STAR] = ACTIONS(4920),
    [anon_sym_DASH_GT] = ACTIONS(4920),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4918),
    [anon_sym_decltype] = ACTIONS(4918),
    [anon_sym_final] = ACTIONS(4918),
    [anon_sym_override] = ACTIONS(4918),
  },
  [2035] = {
    [sym_identifier] = ACTIONS(4530),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4532),
    [anon_sym_COMMA] = ACTIONS(4532),
    [anon_sym_RPAREN] = ACTIONS(4532),
    [aux_sym_preproc_if_token2] = ACTIONS(4532),
    [aux_sym_preproc_else_token1] = ACTIONS(4532),
    [aux_sym_preproc_elif_token1] = ACTIONS(4530),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4532),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4532),
    [anon_sym_LPAREN2] = ACTIONS(4532),
    [anon_sym_DASH] = ACTIONS(4530),
    [anon_sym_PLUS] = ACTIONS(4530),
    [anon_sym_STAR] = ACTIONS(4530),
    [anon_sym_SLASH] = ACTIONS(4530),
    [anon_sym_PERCENT] = ACTIONS(4530),
    [anon_sym_PIPE_PIPE] = ACTIONS(4532),
    [anon_sym_AMP_AMP] = ACTIONS(4532),
    [anon_sym_PIPE] = ACTIONS(4530),
    [anon_sym_CARET] = ACTIONS(4530),
    [anon_sym_AMP] = ACTIONS(4530),
    [anon_sym_EQ_EQ] = ACTIONS(4532),
    [anon_sym_BANG_EQ] = ACTIONS(4532),
    [anon_sym_GT] = ACTIONS(4530),
    [anon_sym_GT_EQ] = ACTIONS(4532),
    [anon_sym_LT_EQ] = ACTIONS(4530),
    [anon_sym_LT] = ACTIONS(4530),
    [anon_sym_LT_LT] = ACTIONS(4530),
    [anon_sym_GT_GT] = ACTIONS(4530),
    [anon_sym_SEMI] = ACTIONS(4532),
    [anon_sym___attribute__] = ACTIONS(4530),
    [anon_sym_COLON_COLON] = ACTIONS(4532),
    [anon_sym_LBRACE] = ACTIONS(4532),
    [anon_sym_RBRACE] = ACTIONS(4532),
    [anon_sym_LBRACK] = ACTIONS(4532),
    [anon_sym_RBRACK] = ACTIONS(4532),
    [anon_sym_EQ] = ACTIONS(4530),
    [anon_sym_COLON] = ACTIONS(4530),
    [anon_sym_QMARK] = ACTIONS(4532),
    [anon_sym_STAR_EQ] = ACTIONS(4532),
    [anon_sym_SLASH_EQ] = ACTIONS(4532),
    [anon_sym_PERCENT_EQ] = ACTIONS(4532),
    [anon_sym_PLUS_EQ] = ACTIONS(4532),
    [anon_sym_DASH_EQ] = ACTIONS(4532),
    [anon_sym_LT_LT_EQ] = ACTIONS(4532),
    [anon_sym_GT_GT_EQ] = ACTIONS(4532),
    [anon_sym_AMP_EQ] = ACTIONS(4532),
    [anon_sym_CARET_EQ] = ACTIONS(4532),
    [anon_sym_PIPE_EQ] = ACTIONS(4532),
    [anon_sym_and_eq] = ACTIONS(4530),
    [anon_sym_or_eq] = ACTIONS(4530),
    [anon_sym_xor_eq] = ACTIONS(4530),
    [anon_sym_LT_EQ_GT] = ACTIONS(4532),
    [anon_sym_or] = ACTIONS(4530),
    [anon_sym_and] = ACTIONS(4530),
    [anon_sym_bitor] = ACTIONS(4530),
    [anon_sym_xor] = ACTIONS(4530),
    [anon_sym_bitand] = ACTIONS(4530),
    [anon_sym_not_eq] = ACTIONS(4530),
    [anon_sym_DASH_DASH] = ACTIONS(4532),
    [anon_sym_PLUS_PLUS] = ACTIONS(4532),
    [anon_sym_DOT] = ACTIONS(4530),
    [anon_sym_DOT_STAR] = ACTIONS(4532),
    [anon_sym_DASH_GT] = ACTIONS(4532),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4530),
    [anon_sym_decltype] = ACTIONS(4530),
    [anon_sym_final] = ACTIONS(4530),
    [anon_sym_override] = ACTIONS(4530),
  },
  [2036] = {
    [sym_identifier] = ACTIONS(3122),
    [aux_sym_preproc_def_token1] = ACTIONS(3122),
    [aux_sym_preproc_if_token1] = ACTIONS(3122),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3122),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3122),
    [sym_preproc_directive] = ACTIONS(3122),
    [anon_sym_LPAREN2] = ACTIONS(3124),
    [anon_sym_TILDE] = ACTIONS(3124),
    [anon_sym_STAR] = ACTIONS(3124),
    [anon_sym_AMP_AMP] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3122),
    [anon_sym_SEMI] = ACTIONS(5260),
    [anon_sym___extension__] = ACTIONS(3122),
    [anon_sym_typedef] = ACTIONS(3122),
    [anon_sym_extern] = ACTIONS(3122),
    [anon_sym___attribute__] = ACTIONS(3122),
    [anon_sym_COLON_COLON] = ACTIONS(3124),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3124),
    [anon_sym___declspec] = ACTIONS(3122),
    [anon_sym___based] = ACTIONS(3122),
    [anon_sym_RBRACE] = ACTIONS(3124),
    [anon_sym_signed] = ACTIONS(3122),
    [anon_sym_unsigned] = ACTIONS(3122),
    [anon_sym_long] = ACTIONS(3122),
    [anon_sym_short] = ACTIONS(3122),
    [anon_sym_LBRACK] = ACTIONS(3122),
    [anon_sym_static] = ACTIONS(3122),
    [anon_sym_register] = ACTIONS(3122),
    [anon_sym_inline] = ACTIONS(3122),
    [anon_sym___inline] = ACTIONS(3122),
    [anon_sym___inline__] = ACTIONS(3122),
    [anon_sym___forceinline] = ACTIONS(3122),
    [anon_sym_thread_local] = ACTIONS(3122),
    [anon_sym___thread] = ACTIONS(3122),
    [anon_sym_const] = ACTIONS(3122),
    [anon_sym_constexpr] = ACTIONS(3122),
    [anon_sym_volatile] = ACTIONS(3122),
    [anon_sym_restrict] = ACTIONS(3122),
    [anon_sym___restrict__] = ACTIONS(3122),
    [anon_sym__Atomic] = ACTIONS(3122),
    [anon_sym__Noreturn] = ACTIONS(3122),
    [anon_sym_noreturn] = ACTIONS(3122),
    [anon_sym_mutable] = ACTIONS(3122),
    [anon_sym_constinit] = ACTIONS(3122),
    [anon_sym_consteval] = ACTIONS(3122),
    [anon_sym_PROGMEM] = ACTIONS(3122),
    [aux_sym_primitive_type_token1] = ACTIONS(3122),
    [anon_sym_byte] = ACTIONS(3122),
    [anon_sym_word] = ACTIONS(3122),
    [anon_sym_enum] = ACTIONS(3122),
    [anon_sym_class] = ACTIONS(3122),
    [anon_sym_struct] = ACTIONS(3122),
    [anon_sym_union] = ACTIONS(3122),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3122),
    [anon_sym_decltype] = ACTIONS(3122),
    [anon_sym_virtual] = ACTIONS(3122),
    [anon_sym_alignas] = ACTIONS(3122),
    [anon_sym_explicit] = ACTIONS(3122),
    [anon_sym_typename] = ACTIONS(3122),
    [anon_sym_template] = ACTIONS(3122),
    [anon_sym_operator] = ACTIONS(3122),
    [anon_sym_friend] = ACTIONS(3122),
    [anon_sym_public] = ACTIONS(3122),
    [anon_sym_private] = ACTIONS(3122),
    [anon_sym_protected] = ACTIONS(3122),
    [anon_sym_using] = ACTIONS(3122),
    [anon_sym_static_assert] = ACTIONS(3122),
  },
  [2037] = {
    [sym_string_literal] = STATE(2617),
    [sym_template_argument_list] = STATE(3723),
    [sym_raw_string_literal] = STATE(2617),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3761),
    [anon_sym_COMMA] = ACTIONS(3761),
    [anon_sym_LPAREN2] = ACTIONS(3761),
    [anon_sym_DASH] = ACTIONS(3769),
    [anon_sym_PLUS] = ACTIONS(3769),
    [anon_sym_STAR] = ACTIONS(3769),
    [anon_sym_SLASH] = ACTIONS(3769),
    [anon_sym_PERCENT] = ACTIONS(3769),
    [anon_sym_PIPE_PIPE] = ACTIONS(3761),
    [anon_sym_AMP_AMP] = ACTIONS(3761),
    [anon_sym_PIPE] = ACTIONS(3769),
    [anon_sym_CARET] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(3769),
    [anon_sym_EQ_EQ] = ACTIONS(3761),
    [anon_sym_BANG_EQ] = ACTIONS(3761),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3761),
    [anon_sym_LT_EQ] = ACTIONS(3769),
    [anon_sym_LT] = ACTIONS(5242),
    [anon_sym_LT_LT] = ACTIONS(3769),
    [anon_sym_GT_GT] = ACTIONS(3769),
    [anon_sym_SEMI] = ACTIONS(3761),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(3785),
    [anon_sym_RBRACE] = ACTIONS(3761),
    [anon_sym_LBRACK] = ACTIONS(3761),
    [anon_sym_EQ] = ACTIONS(3793),
    [anon_sym_COLON] = ACTIONS(5262),
    [anon_sym_QMARK] = ACTIONS(3761),
    [anon_sym_STAR_EQ] = ACTIONS(3797),
    [anon_sym_SLASH_EQ] = ACTIONS(3797),
    [anon_sym_PERCENT_EQ] = ACTIONS(3797),
    [anon_sym_PLUS_EQ] = ACTIONS(3797),
    [anon_sym_DASH_EQ] = ACTIONS(3797),
    [anon_sym_LT_LT_EQ] = ACTIONS(3797),
    [anon_sym_GT_GT_EQ] = ACTIONS(3797),
    [anon_sym_AMP_EQ] = ACTIONS(3797),
    [anon_sym_CARET_EQ] = ACTIONS(3797),
    [anon_sym_PIPE_EQ] = ACTIONS(3797),
    [anon_sym_and_eq] = ACTIONS(3797),
    [anon_sym_or_eq] = ACTIONS(3797),
    [anon_sym_xor_eq] = ACTIONS(3797),
    [anon_sym_LT_EQ_GT] = ACTIONS(3761),
    [anon_sym_or] = ACTIONS(3769),
    [anon_sym_and] = ACTIONS(3769),
    [anon_sym_bitor] = ACTIONS(3761),
    [anon_sym_xor] = ACTIONS(3769),
    [anon_sym_bitand] = ACTIONS(3761),
    [anon_sym_not_eq] = ACTIONS(3761),
    [anon_sym_DASH_DASH] = ACTIONS(3761),
    [anon_sym_PLUS_PLUS] = ACTIONS(3761),
    [anon_sym_DOT] = ACTIONS(3769),
    [anon_sym_DOT_STAR] = ACTIONS(3761),
    [anon_sym_DASH_GT] = ACTIONS(3761),
    [anon_sym_L_DQUOTE] = ACTIONS(3204),
    [anon_sym_u_DQUOTE] = ACTIONS(3204),
    [anon_sym_U_DQUOTE] = ACTIONS(3204),
    [anon_sym_u8_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3204),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3208),
    [anon_sym_LR_DQUOTE] = ACTIONS(3208),
    [anon_sym_uR_DQUOTE] = ACTIONS(3208),
    [anon_sym_UR_DQUOTE] = ACTIONS(3208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3208),
  },
  [2038] = {
    [sym_identifier] = ACTIONS(4918),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4920),
    [anon_sym_COMMA] = ACTIONS(4920),
    [anon_sym_RPAREN] = ACTIONS(4920),
    [aux_sym_preproc_if_token2] = ACTIONS(4920),
    [aux_sym_preproc_else_token1] = ACTIONS(4920),
    [aux_sym_preproc_elif_token1] = ACTIONS(4918),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4920),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4920),
    [anon_sym_LPAREN2] = ACTIONS(4920),
    [anon_sym_DASH] = ACTIONS(4918),
    [anon_sym_PLUS] = ACTIONS(4918),
    [anon_sym_STAR] = ACTIONS(4918),
    [anon_sym_SLASH] = ACTIONS(4918),
    [anon_sym_PERCENT] = ACTIONS(4918),
    [anon_sym_PIPE_PIPE] = ACTIONS(4920),
    [anon_sym_AMP_AMP] = ACTIONS(4920),
    [anon_sym_PIPE] = ACTIONS(4918),
    [anon_sym_CARET] = ACTIONS(4918),
    [anon_sym_AMP] = ACTIONS(4918),
    [anon_sym_EQ_EQ] = ACTIONS(4920),
    [anon_sym_BANG_EQ] = ACTIONS(4920),
    [anon_sym_GT] = ACTIONS(4918),
    [anon_sym_GT_EQ] = ACTIONS(4920),
    [anon_sym_LT_EQ] = ACTIONS(4918),
    [anon_sym_LT] = ACTIONS(4918),
    [anon_sym_LT_LT] = ACTIONS(4918),
    [anon_sym_GT_GT] = ACTIONS(4918),
    [anon_sym_SEMI] = ACTIONS(4920),
    [anon_sym___attribute__] = ACTIONS(4918),
    [anon_sym_COLON_COLON] = ACTIONS(4922),
    [anon_sym_LBRACE] = ACTIONS(4920),
    [anon_sym_RBRACE] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(4920),
    [anon_sym_RBRACK] = ACTIONS(4920),
    [anon_sym_EQ] = ACTIONS(4918),
    [anon_sym_COLON] = ACTIONS(4918),
    [anon_sym_QMARK] = ACTIONS(4920),
    [anon_sym_STAR_EQ] = ACTIONS(4920),
    [anon_sym_SLASH_EQ] = ACTIONS(4920),
    [anon_sym_PERCENT_EQ] = ACTIONS(4920),
    [anon_sym_PLUS_EQ] = ACTIONS(4920),
    [anon_sym_DASH_EQ] = ACTIONS(4920),
    [anon_sym_LT_LT_EQ] = ACTIONS(4920),
    [anon_sym_GT_GT_EQ] = ACTIONS(4920),
    [anon_sym_AMP_EQ] = ACTIONS(4920),
    [anon_sym_CARET_EQ] = ACTIONS(4920),
    [anon_sym_PIPE_EQ] = ACTIONS(4920),
    [anon_sym_and_eq] = ACTIONS(4918),
    [anon_sym_or_eq] = ACTIONS(4918),
    [anon_sym_xor_eq] = ACTIONS(4918),
    [anon_sym_LT_EQ_GT] = ACTIONS(4920),
    [anon_sym_or] = ACTIONS(4918),
    [anon_sym_and] = ACTIONS(4918),
    [anon_sym_bitor] = ACTIONS(4918),
    [anon_sym_xor] = ACTIONS(4918),
    [anon_sym_bitand] = ACTIONS(4918),
    [anon_sym_not_eq] = ACTIONS(4918),
    [anon_sym_DASH_DASH] = ACTIONS(4920),
    [anon_sym_PLUS_PLUS] = ACTIONS(4920),
    [anon_sym_DOT] = ACTIONS(4918),
    [anon_sym_DOT_STAR] = ACTIONS(4920),
    [anon_sym_DASH_GT] = ACTIONS(4920),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4918),
    [anon_sym_decltype] = ACTIONS(4918),
    [anon_sym_final] = ACTIONS(4918),
    [anon_sym_override] = ACTIONS(4918),
  },
  [2039] = {
    [sym_string_literal] = STATE(2617),
    [sym_template_argument_list] = STATE(3723),
    [sym_raw_string_literal] = STATE(2617),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3761),
    [anon_sym_COMMA] = ACTIONS(3761),
    [anon_sym_RPAREN] = ACTIONS(3761),
    [anon_sym_LPAREN2] = ACTIONS(3761),
    [anon_sym_DASH] = ACTIONS(3769),
    [anon_sym_PLUS] = ACTIONS(3769),
    [anon_sym_STAR] = ACTIONS(3769),
    [anon_sym_SLASH] = ACTIONS(3769),
    [anon_sym_PERCENT] = ACTIONS(3769),
    [anon_sym_PIPE_PIPE] = ACTIONS(3761),
    [anon_sym_AMP_AMP] = ACTIONS(3761),
    [anon_sym_PIPE] = ACTIONS(3769),
    [anon_sym_CARET] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(3769),
    [anon_sym_EQ_EQ] = ACTIONS(3761),
    [anon_sym_BANG_EQ] = ACTIONS(3761),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3761),
    [anon_sym_LT_EQ] = ACTIONS(3769),
    [anon_sym_LT] = ACTIONS(5242),
    [anon_sym_LT_LT] = ACTIONS(3769),
    [anon_sym_GT_GT] = ACTIONS(3769),
    [anon_sym_SEMI] = ACTIONS(3761),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(3785),
    [anon_sym_RBRACE] = ACTIONS(3761),
    [anon_sym_LBRACK] = ACTIONS(3761),
    [anon_sym_EQ] = ACTIONS(3793),
    [anon_sym_QMARK] = ACTIONS(3761),
    [anon_sym_STAR_EQ] = ACTIONS(3797),
    [anon_sym_SLASH_EQ] = ACTIONS(3797),
    [anon_sym_PERCENT_EQ] = ACTIONS(3797),
    [anon_sym_PLUS_EQ] = ACTIONS(3797),
    [anon_sym_DASH_EQ] = ACTIONS(3797),
    [anon_sym_LT_LT_EQ] = ACTIONS(3797),
    [anon_sym_GT_GT_EQ] = ACTIONS(3797),
    [anon_sym_AMP_EQ] = ACTIONS(3797),
    [anon_sym_CARET_EQ] = ACTIONS(3797),
    [anon_sym_PIPE_EQ] = ACTIONS(3797),
    [anon_sym_and_eq] = ACTIONS(3797),
    [anon_sym_or_eq] = ACTIONS(3797),
    [anon_sym_xor_eq] = ACTIONS(3797),
    [anon_sym_LT_EQ_GT] = ACTIONS(3761),
    [anon_sym_or] = ACTIONS(3769),
    [anon_sym_and] = ACTIONS(3769),
    [anon_sym_bitor] = ACTIONS(3761),
    [anon_sym_xor] = ACTIONS(3769),
    [anon_sym_bitand] = ACTIONS(3761),
    [anon_sym_not_eq] = ACTIONS(3761),
    [anon_sym_DASH_DASH] = ACTIONS(3761),
    [anon_sym_PLUS_PLUS] = ACTIONS(3761),
    [anon_sym_DOT] = ACTIONS(3769),
    [anon_sym_DOT_STAR] = ACTIONS(3761),
    [anon_sym_DASH_GT] = ACTIONS(3761),
    [anon_sym_L_DQUOTE] = ACTIONS(3204),
    [anon_sym_u_DQUOTE] = ACTIONS(3204),
    [anon_sym_U_DQUOTE] = ACTIONS(3204),
    [anon_sym_u8_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3204),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3208),
    [anon_sym_LR_DQUOTE] = ACTIONS(3208),
    [anon_sym_uR_DQUOTE] = ACTIONS(3208),
    [anon_sym_UR_DQUOTE] = ACTIONS(3208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3208),
  },
  [2040] = {
    [sym_string_literal] = STATE(1770),
    [sym_template_argument_list] = STATE(2395),
    [sym_raw_string_literal] = STATE(1770),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3761),
    [anon_sym_COMMA] = ACTIONS(3761),
    [anon_sym_LPAREN2] = ACTIONS(5264),
    [anon_sym_DASH] = ACTIONS(3769),
    [anon_sym_PLUS] = ACTIONS(3769),
    [anon_sym_STAR] = ACTIONS(3769),
    [anon_sym_SLASH] = ACTIONS(3769),
    [anon_sym_PERCENT] = ACTIONS(3769),
    [anon_sym_PIPE_PIPE] = ACTIONS(3761),
    [anon_sym_AMP_AMP] = ACTIONS(3761),
    [anon_sym_PIPE] = ACTIONS(3769),
    [anon_sym_CARET] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(3769),
    [anon_sym_EQ_EQ] = ACTIONS(3761),
    [anon_sym_BANG_EQ] = ACTIONS(3761),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3761),
    [anon_sym_LT_EQ] = ACTIONS(3769),
    [anon_sym_LT] = ACTIONS(4743),
    [anon_sym_LT_LT] = ACTIONS(3769),
    [anon_sym_GT_GT] = ACTIONS(3769),
    [anon_sym_SEMI] = ACTIONS(3761),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5264),
    [anon_sym_LBRACE] = ACTIONS(3785),
    [anon_sym_RBRACE] = ACTIONS(3761),
    [anon_sym_LBRACK] = ACTIONS(5266),
    [anon_sym_EQ] = ACTIONS(3769),
    [anon_sym_QMARK] = ACTIONS(3761),
    [anon_sym_STAR_EQ] = ACTIONS(3761),
    [anon_sym_SLASH_EQ] = ACTIONS(3761),
    [anon_sym_PERCENT_EQ] = ACTIONS(3761),
    [anon_sym_PLUS_EQ] = ACTIONS(3761),
    [anon_sym_DASH_EQ] = ACTIONS(3761),
    [anon_sym_LT_LT_EQ] = ACTIONS(3761),
    [anon_sym_GT_GT_EQ] = ACTIONS(3761),
    [anon_sym_AMP_EQ] = ACTIONS(3761),
    [anon_sym_CARET_EQ] = ACTIONS(3761),
    [anon_sym_PIPE_EQ] = ACTIONS(3761),
    [anon_sym_and_eq] = ACTIONS(3761),
    [anon_sym_or_eq] = ACTIONS(3761),
    [anon_sym_xor_eq] = ACTIONS(3761),
    [anon_sym_LT_EQ_GT] = ACTIONS(3761),
    [anon_sym_or] = ACTIONS(3769),
    [anon_sym_and] = ACTIONS(3769),
    [anon_sym_bitor] = ACTIONS(3761),
    [anon_sym_xor] = ACTIONS(3769),
    [anon_sym_bitand] = ACTIONS(3761),
    [anon_sym_not_eq] = ACTIONS(3761),
    [anon_sym_DASH_DASH] = ACTIONS(3761),
    [anon_sym_PLUS_PLUS] = ACTIONS(3761),
    [anon_sym_DOT] = ACTIONS(3769),
    [anon_sym_DOT_STAR] = ACTIONS(3761),
    [anon_sym_DASH_GT] = ACTIONS(3761),
    [anon_sym_L_DQUOTE] = ACTIONS(1911),
    [anon_sym_u_DQUOTE] = ACTIONS(1911),
    [anon_sym_U_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8_DQUOTE] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(1911),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(1921),
    [anon_sym_LR_DQUOTE] = ACTIONS(1921),
    [anon_sym_uR_DQUOTE] = ACTIONS(1921),
    [anon_sym_UR_DQUOTE] = ACTIONS(1921),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1921),
  },
  [2041] = {
    [sym_string_literal] = STATE(2617),
    [sym_template_argument_list] = STATE(3723),
    [sym_raw_string_literal] = STATE(2617),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3761),
    [anon_sym_COMMA] = ACTIONS(3761),
    [anon_sym_LPAREN2] = ACTIONS(5264),
    [anon_sym_DASH] = ACTIONS(3769),
    [anon_sym_PLUS] = ACTIONS(3769),
    [anon_sym_STAR] = ACTIONS(3769),
    [anon_sym_SLASH] = ACTIONS(3769),
    [anon_sym_PERCENT] = ACTIONS(3769),
    [anon_sym_PIPE_PIPE] = ACTIONS(3761),
    [anon_sym_AMP_AMP] = ACTIONS(3761),
    [anon_sym_PIPE] = ACTIONS(3769),
    [anon_sym_CARET] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(3769),
    [anon_sym_EQ_EQ] = ACTIONS(3761),
    [anon_sym_BANG_EQ] = ACTIONS(3761),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3761),
    [anon_sym_LT_EQ] = ACTIONS(3769),
    [anon_sym_LT] = ACTIONS(5242),
    [anon_sym_LT_LT] = ACTIONS(3769),
    [anon_sym_GT_GT] = ACTIONS(3769),
    [anon_sym_SEMI] = ACTIONS(3761),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5264),
    [anon_sym_LBRACE] = ACTIONS(3785),
    [anon_sym_RBRACE] = ACTIONS(3761),
    [anon_sym_LBRACK] = ACTIONS(5266),
    [anon_sym_EQ] = ACTIONS(3793),
    [anon_sym_QMARK] = ACTIONS(3761),
    [anon_sym_STAR_EQ] = ACTIONS(3797),
    [anon_sym_SLASH_EQ] = ACTIONS(3797),
    [anon_sym_PERCENT_EQ] = ACTIONS(3797),
    [anon_sym_PLUS_EQ] = ACTIONS(3797),
    [anon_sym_DASH_EQ] = ACTIONS(3797),
    [anon_sym_LT_LT_EQ] = ACTIONS(3797),
    [anon_sym_GT_GT_EQ] = ACTIONS(3797),
    [anon_sym_AMP_EQ] = ACTIONS(3797),
    [anon_sym_CARET_EQ] = ACTIONS(3797),
    [anon_sym_PIPE_EQ] = ACTIONS(3797),
    [anon_sym_and_eq] = ACTIONS(3797),
    [anon_sym_or_eq] = ACTIONS(3797),
    [anon_sym_xor_eq] = ACTIONS(3797),
    [anon_sym_LT_EQ_GT] = ACTIONS(3761),
    [anon_sym_or] = ACTIONS(3769),
    [anon_sym_and] = ACTIONS(3769),
    [anon_sym_bitor] = ACTIONS(3761),
    [anon_sym_xor] = ACTIONS(3769),
    [anon_sym_bitand] = ACTIONS(3761),
    [anon_sym_not_eq] = ACTIONS(3761),
    [anon_sym_DASH_DASH] = ACTIONS(3761),
    [anon_sym_PLUS_PLUS] = ACTIONS(3761),
    [anon_sym_DOT] = ACTIONS(3769),
    [anon_sym_DOT_STAR] = ACTIONS(3761),
    [anon_sym_DASH_GT] = ACTIONS(3761),
    [anon_sym_L_DQUOTE] = ACTIONS(3204),
    [anon_sym_u_DQUOTE] = ACTIONS(3204),
    [anon_sym_U_DQUOTE] = ACTIONS(3204),
    [anon_sym_u8_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3204),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3208),
    [anon_sym_LR_DQUOTE] = ACTIONS(3208),
    [anon_sym_uR_DQUOTE] = ACTIONS(3208),
    [anon_sym_UR_DQUOTE] = ACTIONS(3208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3208),
  },
  [2042] = {
    [sym_identifier] = ACTIONS(4571),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4573),
    [anon_sym_COMMA] = ACTIONS(4573),
    [anon_sym_RPAREN] = ACTIONS(4573),
    [aux_sym_preproc_if_token2] = ACTIONS(4573),
    [aux_sym_preproc_else_token1] = ACTIONS(4573),
    [aux_sym_preproc_elif_token1] = ACTIONS(4571),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4573),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4573),
    [anon_sym_LPAREN2] = ACTIONS(4573),
    [anon_sym_DASH] = ACTIONS(4571),
    [anon_sym_PLUS] = ACTIONS(4571),
    [anon_sym_STAR] = ACTIONS(4571),
    [anon_sym_SLASH] = ACTIONS(4571),
    [anon_sym_PERCENT] = ACTIONS(4571),
    [anon_sym_PIPE_PIPE] = ACTIONS(4573),
    [anon_sym_AMP_AMP] = ACTIONS(4573),
    [anon_sym_PIPE] = ACTIONS(4571),
    [anon_sym_CARET] = ACTIONS(4571),
    [anon_sym_AMP] = ACTIONS(4571),
    [anon_sym_EQ_EQ] = ACTIONS(4573),
    [anon_sym_BANG_EQ] = ACTIONS(4573),
    [anon_sym_GT] = ACTIONS(4571),
    [anon_sym_GT_EQ] = ACTIONS(4573),
    [anon_sym_LT_EQ] = ACTIONS(4571),
    [anon_sym_LT] = ACTIONS(4571),
    [anon_sym_LT_LT] = ACTIONS(4571),
    [anon_sym_GT_GT] = ACTIONS(4571),
    [anon_sym_SEMI] = ACTIONS(4573),
    [anon_sym___attribute__] = ACTIONS(4571),
    [anon_sym_COLON_COLON] = ACTIONS(4573),
    [anon_sym_LBRACE] = ACTIONS(4573),
    [anon_sym_RBRACE] = ACTIONS(4573),
    [anon_sym_LBRACK] = ACTIONS(4573),
    [anon_sym_RBRACK] = ACTIONS(4573),
    [anon_sym_EQ] = ACTIONS(4571),
    [anon_sym_COLON] = ACTIONS(4571),
    [anon_sym_QMARK] = ACTIONS(4573),
    [anon_sym_STAR_EQ] = ACTIONS(4573),
    [anon_sym_SLASH_EQ] = ACTIONS(4573),
    [anon_sym_PERCENT_EQ] = ACTIONS(4573),
    [anon_sym_PLUS_EQ] = ACTIONS(4573),
    [anon_sym_DASH_EQ] = ACTIONS(4573),
    [anon_sym_LT_LT_EQ] = ACTIONS(4573),
    [anon_sym_GT_GT_EQ] = ACTIONS(4573),
    [anon_sym_AMP_EQ] = ACTIONS(4573),
    [anon_sym_CARET_EQ] = ACTIONS(4573),
    [anon_sym_PIPE_EQ] = ACTIONS(4573),
    [anon_sym_and_eq] = ACTIONS(4571),
    [anon_sym_or_eq] = ACTIONS(4571),
    [anon_sym_xor_eq] = ACTIONS(4571),
    [anon_sym_LT_EQ_GT] = ACTIONS(4573),
    [anon_sym_or] = ACTIONS(4571),
    [anon_sym_and] = ACTIONS(4571),
    [anon_sym_bitor] = ACTIONS(4571),
    [anon_sym_xor] = ACTIONS(4571),
    [anon_sym_bitand] = ACTIONS(4571),
    [anon_sym_not_eq] = ACTIONS(4571),
    [anon_sym_DASH_DASH] = ACTIONS(4573),
    [anon_sym_PLUS_PLUS] = ACTIONS(4573),
    [anon_sym_DOT] = ACTIONS(4571),
    [anon_sym_DOT_STAR] = ACTIONS(4573),
    [anon_sym_DASH_GT] = ACTIONS(4573),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4571),
    [anon_sym_decltype] = ACTIONS(4571),
    [anon_sym_final] = ACTIONS(4571),
    [anon_sym_override] = ACTIONS(4571),
  },
  [2043] = {
    [sym_string_literal] = STATE(2079),
    [sym_template_argument_list] = STATE(3123),
    [sym_raw_string_literal] = STATE(2079),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3761),
    [anon_sym_COMMA] = ACTIONS(3761),
    [anon_sym_RPAREN] = ACTIONS(5264),
    [anon_sym_LPAREN2] = ACTIONS(5264),
    [anon_sym_DASH] = ACTIONS(3769),
    [anon_sym_PLUS] = ACTIONS(3769),
    [anon_sym_STAR] = ACTIONS(3769),
    [anon_sym_SLASH] = ACTIONS(3769),
    [anon_sym_PERCENT] = ACTIONS(3769),
    [anon_sym_PIPE_PIPE] = ACTIONS(3761),
    [anon_sym_AMP_AMP] = ACTIONS(3761),
    [anon_sym_PIPE] = ACTIONS(3769),
    [anon_sym_CARET] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(3769),
    [anon_sym_EQ_EQ] = ACTIONS(3761),
    [anon_sym_BANG_EQ] = ACTIONS(3761),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3761),
    [anon_sym_LT_EQ] = ACTIONS(3769),
    [anon_sym_LT] = ACTIONS(4609),
    [anon_sym_LT_LT] = ACTIONS(3769),
    [anon_sym_GT_GT] = ACTIONS(3769),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5264),
    [anon_sym_LBRACE] = ACTIONS(3785),
    [anon_sym_LBRACK] = ACTIONS(5266),
    [anon_sym_EQ] = ACTIONS(3769),
    [anon_sym_QMARK] = ACTIONS(3761),
    [anon_sym_STAR_EQ] = ACTIONS(3761),
    [anon_sym_SLASH_EQ] = ACTIONS(3761),
    [anon_sym_PERCENT_EQ] = ACTIONS(3761),
    [anon_sym_PLUS_EQ] = ACTIONS(3761),
    [anon_sym_DASH_EQ] = ACTIONS(3761),
    [anon_sym_LT_LT_EQ] = ACTIONS(3761),
    [anon_sym_GT_GT_EQ] = ACTIONS(3761),
    [anon_sym_AMP_EQ] = ACTIONS(3761),
    [anon_sym_CARET_EQ] = ACTIONS(3761),
    [anon_sym_PIPE_EQ] = ACTIONS(3761),
    [anon_sym_and_eq] = ACTIONS(3761),
    [anon_sym_or_eq] = ACTIONS(3761),
    [anon_sym_xor_eq] = ACTIONS(3761),
    [anon_sym_LT_EQ_GT] = ACTIONS(3761),
    [anon_sym_or] = ACTIONS(3769),
    [anon_sym_and] = ACTIONS(3769),
    [anon_sym_bitor] = ACTIONS(3761),
    [anon_sym_xor] = ACTIONS(3769),
    [anon_sym_bitand] = ACTIONS(3761),
    [anon_sym_not_eq] = ACTIONS(3761),
    [anon_sym_DASH_DASH] = ACTIONS(3761),
    [anon_sym_PLUS_PLUS] = ACTIONS(3761),
    [anon_sym_DOT] = ACTIONS(3769),
    [anon_sym_DOT_STAR] = ACTIONS(3761),
    [anon_sym_DASH_GT] = ACTIONS(3769),
    [anon_sym_L_DQUOTE] = ACTIONS(4605),
    [anon_sym_u_DQUOTE] = ACTIONS(4605),
    [anon_sym_U_DQUOTE] = ACTIONS(4605),
    [anon_sym_u8_DQUOTE] = ACTIONS(4605),
    [anon_sym_DQUOTE] = ACTIONS(4605),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4607),
    [anon_sym_LR_DQUOTE] = ACTIONS(4607),
    [anon_sym_uR_DQUOTE] = ACTIONS(4607),
    [anon_sym_UR_DQUOTE] = ACTIONS(4607),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4607),
    [anon_sym_DASH_GT_STAR] = ACTIONS(3761),
  },
  [2044] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1782),
    [sym_identifier] = ACTIONS(4766),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5139),
    [anon_sym_COMMA] = ACTIONS(5139),
    [anon_sym_RPAREN] = ACTIONS(5139),
    [anon_sym_LPAREN2] = ACTIONS(5139),
    [anon_sym_DASH] = ACTIONS(5142),
    [anon_sym_PLUS] = ACTIONS(5142),
    [anon_sym_STAR] = ACTIONS(5142),
    [anon_sym_SLASH] = ACTIONS(5142),
    [anon_sym_PERCENT] = ACTIONS(5142),
    [anon_sym_PIPE_PIPE] = ACTIONS(5139),
    [anon_sym_AMP_AMP] = ACTIONS(5139),
    [anon_sym_PIPE] = ACTIONS(5142),
    [anon_sym_CARET] = ACTIONS(5142),
    [anon_sym_AMP] = ACTIONS(5142),
    [anon_sym_EQ_EQ] = ACTIONS(5139),
    [anon_sym_BANG_EQ] = ACTIONS(5139),
    [anon_sym_GT] = ACTIONS(5142),
    [anon_sym_GT_EQ] = ACTIONS(5139),
    [anon_sym_LT_EQ] = ACTIONS(5142),
    [anon_sym_LT] = ACTIONS(5142),
    [anon_sym_LT_LT] = ACTIONS(5142),
    [anon_sym_GT_GT] = ACTIONS(5142),
    [anon_sym_SEMI] = ACTIONS(5139),
    [anon_sym___attribute__] = ACTIONS(5142),
    [anon_sym_LBRACE] = ACTIONS(5139),
    [anon_sym_RBRACE] = ACTIONS(5139),
    [anon_sym_signed] = ACTIONS(4805),
    [anon_sym_unsigned] = ACTIONS(4805),
    [anon_sym_long] = ACTIONS(4805),
    [anon_sym_short] = ACTIONS(4805),
    [anon_sym_LBRACK] = ACTIONS(5139),
    [anon_sym_RBRACK] = ACTIONS(5139),
    [anon_sym_EQ] = ACTIONS(5142),
    [aux_sym_primitive_type_token1] = ACTIONS(4766),
    [anon_sym_byte] = ACTIONS(4766),
    [anon_sym_word] = ACTIONS(4766),
    [anon_sym_COLON] = ACTIONS(5139),
    [anon_sym_QMARK] = ACTIONS(5139),
    [anon_sym_STAR_EQ] = ACTIONS(5139),
    [anon_sym_SLASH_EQ] = ACTIONS(5139),
    [anon_sym_PERCENT_EQ] = ACTIONS(5139),
    [anon_sym_PLUS_EQ] = ACTIONS(5139),
    [anon_sym_DASH_EQ] = ACTIONS(5139),
    [anon_sym_LT_LT_EQ] = ACTIONS(5139),
    [anon_sym_GT_GT_EQ] = ACTIONS(5139),
    [anon_sym_AMP_EQ] = ACTIONS(5139),
    [anon_sym_CARET_EQ] = ACTIONS(5139),
    [anon_sym_PIPE_EQ] = ACTIONS(5139),
    [anon_sym_and_eq] = ACTIONS(5142),
    [anon_sym_or_eq] = ACTIONS(5142),
    [anon_sym_xor_eq] = ACTIONS(5142),
    [anon_sym_LT_EQ_GT] = ACTIONS(5139),
    [anon_sym_or] = ACTIONS(5142),
    [anon_sym_and] = ACTIONS(5142),
    [anon_sym_bitor] = ACTIONS(5142),
    [anon_sym_xor] = ACTIONS(5142),
    [anon_sym_bitand] = ACTIONS(5142),
    [anon_sym_not_eq] = ACTIONS(5142),
    [anon_sym_DASH_DASH] = ACTIONS(5139),
    [anon_sym_PLUS_PLUS] = ACTIONS(5139),
    [anon_sym_DOT] = ACTIONS(5142),
    [anon_sym_DOT_STAR] = ACTIONS(5139),
    [anon_sym_DASH_GT] = ACTIONS(5139),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5142),
    [anon_sym_decltype] = ACTIONS(5142),
  },
  [2045] = {
    [sym_identifier] = ACTIONS(2527),
    [aux_sym_preproc_def_token1] = ACTIONS(2527),
    [aux_sym_preproc_if_token1] = ACTIONS(2527),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2527),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2527),
    [sym_preproc_directive] = ACTIONS(2527),
    [anon_sym_LPAREN2] = ACTIONS(2529),
    [anon_sym_TILDE] = ACTIONS(2529),
    [anon_sym_STAR] = ACTIONS(2529),
    [anon_sym_AMP_AMP] = ACTIONS(2529),
    [anon_sym_AMP] = ACTIONS(2527),
    [anon_sym___extension__] = ACTIONS(2527),
    [anon_sym_typedef] = ACTIONS(2527),
    [anon_sym_extern] = ACTIONS(2527),
    [anon_sym___attribute__] = ACTIONS(2527),
    [anon_sym_COLON_COLON] = ACTIONS(2529),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2529),
    [anon_sym___declspec] = ACTIONS(2527),
    [anon_sym___based] = ACTIONS(2527),
    [anon_sym_RBRACE] = ACTIONS(2529),
    [anon_sym_signed] = ACTIONS(2527),
    [anon_sym_unsigned] = ACTIONS(2527),
    [anon_sym_long] = ACTIONS(2527),
    [anon_sym_short] = ACTIONS(2527),
    [anon_sym_LBRACK] = ACTIONS(2527),
    [anon_sym_static] = ACTIONS(2527),
    [anon_sym_register] = ACTIONS(2527),
    [anon_sym_inline] = ACTIONS(2527),
    [anon_sym___inline] = ACTIONS(2527),
    [anon_sym___inline__] = ACTIONS(2527),
    [anon_sym___forceinline] = ACTIONS(2527),
    [anon_sym_thread_local] = ACTIONS(2527),
    [anon_sym___thread] = ACTIONS(2527),
    [anon_sym_const] = ACTIONS(2527),
    [anon_sym_constexpr] = ACTIONS(2527),
    [anon_sym_volatile] = ACTIONS(2527),
    [anon_sym_restrict] = ACTIONS(2527),
    [anon_sym___restrict__] = ACTIONS(2527),
    [anon_sym__Atomic] = ACTIONS(2527),
    [anon_sym__Noreturn] = ACTIONS(2527),
    [anon_sym_noreturn] = ACTIONS(2527),
    [anon_sym_mutable] = ACTIONS(2527),
    [anon_sym_constinit] = ACTIONS(2527),
    [anon_sym_consteval] = ACTIONS(2527),
    [anon_sym_PROGMEM] = ACTIONS(2527),
    [aux_sym_primitive_type_token1] = ACTIONS(2527),
    [anon_sym_byte] = ACTIONS(2527),
    [anon_sym_word] = ACTIONS(2527),
    [anon_sym_enum] = ACTIONS(2527),
    [anon_sym_class] = ACTIONS(2527),
    [anon_sym_struct] = ACTIONS(2527),
    [anon_sym_union] = ACTIONS(2527),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2527),
    [anon_sym_decltype] = ACTIONS(2527),
    [anon_sym_virtual] = ACTIONS(2527),
    [anon_sym_alignas] = ACTIONS(2527),
    [anon_sym_explicit] = ACTIONS(2527),
    [anon_sym_typename] = ACTIONS(2527),
    [anon_sym_template] = ACTIONS(2527),
    [anon_sym_operator] = ACTIONS(2527),
    [anon_sym_friend] = ACTIONS(2527),
    [anon_sym_public] = ACTIONS(2527),
    [anon_sym_private] = ACTIONS(2527),
    [anon_sym_protected] = ACTIONS(2527),
    [anon_sym_using] = ACTIONS(2527),
    [anon_sym_static_assert] = ACTIONS(2527),
    [anon_sym_catch] = ACTIONS(2527),
  },
  [2046] = {
    [sym_string_literal] = STATE(1770),
    [sym_raw_string_literal] = STATE(1770),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3761),
    [anon_sym_COMMA] = ACTIONS(3761),
    [anon_sym_RPAREN] = ACTIONS(3761),
    [anon_sym_LPAREN2] = ACTIONS(3761),
    [anon_sym_DASH] = ACTIONS(3769),
    [anon_sym_PLUS] = ACTIONS(3769),
    [anon_sym_STAR] = ACTIONS(3769),
    [anon_sym_SLASH] = ACTIONS(3769),
    [anon_sym_PERCENT] = ACTIONS(3769),
    [anon_sym_PIPE_PIPE] = ACTIONS(3761),
    [anon_sym_AMP_AMP] = ACTIONS(3761),
    [anon_sym_PIPE] = ACTIONS(3769),
    [anon_sym_CARET] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(3769),
    [anon_sym_EQ_EQ] = ACTIONS(3761),
    [anon_sym_BANG_EQ] = ACTIONS(3761),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3761),
    [anon_sym_LT_EQ] = ACTIONS(3769),
    [anon_sym_LT] = ACTIONS(3769),
    [anon_sym_LT_LT] = ACTIONS(3769),
    [anon_sym_GT_GT] = ACTIONS(3769),
    [anon_sym_SEMI] = ACTIONS(3761),
    [anon_sym_RBRACE] = ACTIONS(3761),
    [anon_sym_LBRACK] = ACTIONS(3761),
    [anon_sym_RBRACK] = ACTIONS(3761),
    [anon_sym_EQ] = ACTIONS(3769),
    [anon_sym_COLON] = ACTIONS(3761),
    [anon_sym_QMARK] = ACTIONS(3761),
    [anon_sym_STAR_EQ] = ACTIONS(3761),
    [anon_sym_SLASH_EQ] = ACTIONS(3761),
    [anon_sym_PERCENT_EQ] = ACTIONS(3761),
    [anon_sym_PLUS_EQ] = ACTIONS(3761),
    [anon_sym_DASH_EQ] = ACTIONS(3761),
    [anon_sym_LT_LT_EQ] = ACTIONS(3761),
    [anon_sym_GT_GT_EQ] = ACTIONS(3761),
    [anon_sym_AMP_EQ] = ACTIONS(3761),
    [anon_sym_CARET_EQ] = ACTIONS(3761),
    [anon_sym_PIPE_EQ] = ACTIONS(3761),
    [anon_sym_and_eq] = ACTIONS(3769),
    [anon_sym_or_eq] = ACTIONS(3769),
    [anon_sym_xor_eq] = ACTIONS(3769),
    [anon_sym_LT_EQ_GT] = ACTIONS(3761),
    [anon_sym_or] = ACTIONS(3769),
    [anon_sym_and] = ACTIONS(3769),
    [anon_sym_bitor] = ACTIONS(3769),
    [anon_sym_xor] = ACTIONS(3769),
    [anon_sym_bitand] = ACTIONS(3769),
    [anon_sym_not_eq] = ACTIONS(3769),
    [anon_sym_DASH_DASH] = ACTIONS(3761),
    [anon_sym_PLUS_PLUS] = ACTIONS(3761),
    [anon_sym_DOT] = ACTIONS(3769),
    [anon_sym_DOT_STAR] = ACTIONS(3761),
    [anon_sym_DASH_GT] = ACTIONS(3761),
    [anon_sym_L_DQUOTE] = ACTIONS(1911),
    [anon_sym_u_DQUOTE] = ACTIONS(1911),
    [anon_sym_U_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8_DQUOTE] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(1911),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(1921),
    [anon_sym_LR_DQUOTE] = ACTIONS(1921),
    [anon_sym_uR_DQUOTE] = ACTIONS(1921),
    [anon_sym_UR_DQUOTE] = ACTIONS(1921),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1921),
    [sym_literal_suffix] = ACTIONS(5201),
  },
  [2047] = {
    [sym_string_literal] = STATE(1770),
    [sym_template_argument_list] = STATE(2854),
    [sym_raw_string_literal] = STATE(1770),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3761),
    [anon_sym_COMMA] = ACTIONS(3761),
    [anon_sym_LPAREN2] = ACTIONS(5250),
    [anon_sym_DASH] = ACTIONS(3769),
    [anon_sym_PLUS] = ACTIONS(3769),
    [anon_sym_STAR] = ACTIONS(3769),
    [anon_sym_SLASH] = ACTIONS(3769),
    [anon_sym_PERCENT] = ACTIONS(3769),
    [anon_sym_PIPE_PIPE] = ACTIONS(3761),
    [anon_sym_AMP_AMP] = ACTIONS(3761),
    [anon_sym_PIPE] = ACTIONS(3769),
    [anon_sym_CARET] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(3769),
    [anon_sym_EQ_EQ] = ACTIONS(3761),
    [anon_sym_BANG_EQ] = ACTIONS(3761),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3761),
    [anon_sym_LT_EQ] = ACTIONS(3769),
    [anon_sym_LT] = ACTIONS(5268),
    [anon_sym_LT_LT] = ACTIONS(3769),
    [anon_sym_GT_GT] = ACTIONS(3769),
    [anon_sym_SEMI] = ACTIONS(3761),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4601),
    [anon_sym_LBRACE] = ACTIONS(3785),
    [anon_sym_RBRACE] = ACTIONS(3761),
    [anon_sym_LBRACK] = ACTIONS(5253),
    [anon_sym_EQ] = ACTIONS(3769),
    [anon_sym_QMARK] = ACTIONS(3761),
    [anon_sym_STAR_EQ] = ACTIONS(3761),
    [anon_sym_SLASH_EQ] = ACTIONS(3761),
    [anon_sym_PERCENT_EQ] = ACTIONS(3761),
    [anon_sym_PLUS_EQ] = ACTIONS(3761),
    [anon_sym_DASH_EQ] = ACTIONS(3761),
    [anon_sym_LT_LT_EQ] = ACTIONS(3761),
    [anon_sym_GT_GT_EQ] = ACTIONS(3761),
    [anon_sym_AMP_EQ] = ACTIONS(3761),
    [anon_sym_CARET_EQ] = ACTIONS(3761),
    [anon_sym_PIPE_EQ] = ACTIONS(3761),
    [anon_sym_and_eq] = ACTIONS(3761),
    [anon_sym_or_eq] = ACTIONS(3761),
    [anon_sym_xor_eq] = ACTIONS(3761),
    [anon_sym_LT_EQ_GT] = ACTIONS(3761),
    [anon_sym_or] = ACTIONS(3769),
    [anon_sym_and] = ACTIONS(3769),
    [anon_sym_bitor] = ACTIONS(3761),
    [anon_sym_xor] = ACTIONS(3769),
    [anon_sym_bitand] = ACTIONS(3761),
    [anon_sym_not_eq] = ACTIONS(3761),
    [anon_sym_DASH_DASH] = ACTIONS(3761),
    [anon_sym_PLUS_PLUS] = ACTIONS(3761),
    [anon_sym_DOT] = ACTIONS(3769),
    [anon_sym_DOT_STAR] = ACTIONS(3761),
    [anon_sym_DASH_GT] = ACTIONS(3761),
    [anon_sym_L_DQUOTE] = ACTIONS(1911),
    [anon_sym_u_DQUOTE] = ACTIONS(1911),
    [anon_sym_U_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8_DQUOTE] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(1911),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(1921),
    [anon_sym_LR_DQUOTE] = ACTIONS(1921),
    [anon_sym_uR_DQUOTE] = ACTIONS(1921),
    [anon_sym_UR_DQUOTE] = ACTIONS(1921),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1921),
  },
  [2048] = {
    [sym_string_literal] = STATE(1770),
    [sym_raw_string_literal] = STATE(1770),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5199),
    [anon_sym_COMMA] = ACTIONS(5199),
    [anon_sym_RPAREN] = ACTIONS(5199),
    [anon_sym_LPAREN2] = ACTIONS(5199),
    [anon_sym_DASH] = ACTIONS(5197),
    [anon_sym_PLUS] = ACTIONS(5197),
    [anon_sym_STAR] = ACTIONS(5197),
    [anon_sym_SLASH] = ACTIONS(5197),
    [anon_sym_PERCENT] = ACTIONS(5197),
    [anon_sym_PIPE_PIPE] = ACTIONS(5199),
    [anon_sym_AMP_AMP] = ACTIONS(5199),
    [anon_sym_PIPE] = ACTIONS(5197),
    [anon_sym_CARET] = ACTIONS(5197),
    [anon_sym_AMP] = ACTIONS(5197),
    [anon_sym_EQ_EQ] = ACTIONS(5199),
    [anon_sym_BANG_EQ] = ACTIONS(5199),
    [anon_sym_GT] = ACTIONS(5197),
    [anon_sym_GT_EQ] = ACTIONS(5199),
    [anon_sym_LT_EQ] = ACTIONS(5197),
    [anon_sym_LT] = ACTIONS(5197),
    [anon_sym_LT_LT] = ACTIONS(5197),
    [anon_sym_GT_GT] = ACTIONS(5197),
    [anon_sym_SEMI] = ACTIONS(5199),
    [anon_sym_RBRACE] = ACTIONS(5199),
    [anon_sym_LBRACK] = ACTIONS(5199),
    [anon_sym_RBRACK] = ACTIONS(5199),
    [anon_sym_EQ] = ACTIONS(5197),
    [anon_sym_COLON] = ACTIONS(5199),
    [anon_sym_QMARK] = ACTIONS(5199),
    [anon_sym_STAR_EQ] = ACTIONS(5199),
    [anon_sym_SLASH_EQ] = ACTIONS(5199),
    [anon_sym_PERCENT_EQ] = ACTIONS(5199),
    [anon_sym_PLUS_EQ] = ACTIONS(5199),
    [anon_sym_DASH_EQ] = ACTIONS(5199),
    [anon_sym_LT_LT_EQ] = ACTIONS(5199),
    [anon_sym_GT_GT_EQ] = ACTIONS(5199),
    [anon_sym_AMP_EQ] = ACTIONS(5199),
    [anon_sym_CARET_EQ] = ACTIONS(5199),
    [anon_sym_PIPE_EQ] = ACTIONS(5199),
    [anon_sym_and_eq] = ACTIONS(5197),
    [anon_sym_or_eq] = ACTIONS(5197),
    [anon_sym_xor_eq] = ACTIONS(5197),
    [anon_sym_LT_EQ_GT] = ACTIONS(5199),
    [anon_sym_or] = ACTIONS(5197),
    [anon_sym_and] = ACTIONS(5197),
    [anon_sym_bitor] = ACTIONS(5197),
    [anon_sym_xor] = ACTIONS(5197),
    [anon_sym_bitand] = ACTIONS(5197),
    [anon_sym_not_eq] = ACTIONS(5197),
    [anon_sym_DASH_DASH] = ACTIONS(5199),
    [anon_sym_PLUS_PLUS] = ACTIONS(5199),
    [anon_sym_DOT] = ACTIONS(5197),
    [anon_sym_DOT_STAR] = ACTIONS(5199),
    [anon_sym_DASH_GT] = ACTIONS(5199),
    [anon_sym_L_DQUOTE] = ACTIONS(1911),
    [anon_sym_u_DQUOTE] = ACTIONS(1911),
    [anon_sym_U_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8_DQUOTE] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(1911),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(1921),
    [anon_sym_LR_DQUOTE] = ACTIONS(1921),
    [anon_sym_uR_DQUOTE] = ACTIONS(1921),
    [anon_sym_UR_DQUOTE] = ACTIONS(1921),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1921),
    [sym_literal_suffix] = ACTIONS(5201),
  },
  [2049] = {
    [sym_identifier] = ACTIONS(3105),
    [aux_sym_preproc_def_token1] = ACTIONS(3105),
    [aux_sym_preproc_if_token1] = ACTIONS(3105),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3105),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3105),
    [sym_preproc_directive] = ACTIONS(3105),
    [anon_sym_LPAREN2] = ACTIONS(3107),
    [anon_sym_TILDE] = ACTIONS(3107),
    [anon_sym_STAR] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3107),
    [anon_sym_AMP] = ACTIONS(3105),
    [anon_sym_SEMI] = ACTIONS(5271),
    [anon_sym___extension__] = ACTIONS(3105),
    [anon_sym_typedef] = ACTIONS(3105),
    [anon_sym_extern] = ACTIONS(3105),
    [anon_sym___attribute__] = ACTIONS(3105),
    [anon_sym_COLON_COLON] = ACTIONS(3107),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3107),
    [anon_sym___declspec] = ACTIONS(3105),
    [anon_sym___based] = ACTIONS(3105),
    [anon_sym_RBRACE] = ACTIONS(3107),
    [anon_sym_signed] = ACTIONS(3105),
    [anon_sym_unsigned] = ACTIONS(3105),
    [anon_sym_long] = ACTIONS(3105),
    [anon_sym_short] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(3105),
    [anon_sym_static] = ACTIONS(3105),
    [anon_sym_register] = ACTIONS(3105),
    [anon_sym_inline] = ACTIONS(3105),
    [anon_sym___inline] = ACTIONS(3105),
    [anon_sym___inline__] = ACTIONS(3105),
    [anon_sym___forceinline] = ACTIONS(3105),
    [anon_sym_thread_local] = ACTIONS(3105),
    [anon_sym___thread] = ACTIONS(3105),
    [anon_sym_const] = ACTIONS(3105),
    [anon_sym_constexpr] = ACTIONS(3105),
    [anon_sym_volatile] = ACTIONS(3105),
    [anon_sym_restrict] = ACTIONS(3105),
    [anon_sym___restrict__] = ACTIONS(3105),
    [anon_sym__Atomic] = ACTIONS(3105),
    [anon_sym__Noreturn] = ACTIONS(3105),
    [anon_sym_noreturn] = ACTIONS(3105),
    [anon_sym_mutable] = ACTIONS(3105),
    [anon_sym_constinit] = ACTIONS(3105),
    [anon_sym_consteval] = ACTIONS(3105),
    [anon_sym_PROGMEM] = ACTIONS(3105),
    [aux_sym_primitive_type_token1] = ACTIONS(3105),
    [anon_sym_byte] = ACTIONS(3105),
    [anon_sym_word] = ACTIONS(3105),
    [anon_sym_enum] = ACTIONS(3105),
    [anon_sym_class] = ACTIONS(3105),
    [anon_sym_struct] = ACTIONS(3105),
    [anon_sym_union] = ACTIONS(3105),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3105),
    [anon_sym_decltype] = ACTIONS(3105),
    [anon_sym_virtual] = ACTIONS(3105),
    [anon_sym_alignas] = ACTIONS(3105),
    [anon_sym_explicit] = ACTIONS(3105),
    [anon_sym_typename] = ACTIONS(3105),
    [anon_sym_template] = ACTIONS(3105),
    [anon_sym_operator] = ACTIONS(3105),
    [anon_sym_friend] = ACTIONS(3105),
    [anon_sym_public] = ACTIONS(3105),
    [anon_sym_private] = ACTIONS(3105),
    [anon_sym_protected] = ACTIONS(3105),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_static_assert] = ACTIONS(3105),
  },
  [2050] = {
    [sym_identifier] = ACTIONS(2937),
    [aux_sym_preproc_def_token1] = ACTIONS(2937),
    [aux_sym_preproc_if_token1] = ACTIONS(2937),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2937),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2937),
    [sym_preproc_directive] = ACTIONS(2937),
    [anon_sym_LPAREN2] = ACTIONS(2939),
    [anon_sym_TILDE] = ACTIONS(2939),
    [anon_sym_STAR] = ACTIONS(2939),
    [anon_sym_AMP_AMP] = ACTIONS(2939),
    [anon_sym_AMP] = ACTIONS(2937),
    [anon_sym_SEMI] = ACTIONS(5273),
    [anon_sym___extension__] = ACTIONS(2937),
    [anon_sym_typedef] = ACTIONS(2937),
    [anon_sym_extern] = ACTIONS(2937),
    [anon_sym___attribute__] = ACTIONS(2937),
    [anon_sym_COLON_COLON] = ACTIONS(2939),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2939),
    [anon_sym___declspec] = ACTIONS(2937),
    [anon_sym___based] = ACTIONS(2937),
    [anon_sym_RBRACE] = ACTIONS(2939),
    [anon_sym_signed] = ACTIONS(2937),
    [anon_sym_unsigned] = ACTIONS(2937),
    [anon_sym_long] = ACTIONS(2937),
    [anon_sym_short] = ACTIONS(2937),
    [anon_sym_LBRACK] = ACTIONS(2937),
    [anon_sym_static] = ACTIONS(2937),
    [anon_sym_register] = ACTIONS(2937),
    [anon_sym_inline] = ACTIONS(2937),
    [anon_sym___inline] = ACTIONS(2937),
    [anon_sym___inline__] = ACTIONS(2937),
    [anon_sym___forceinline] = ACTIONS(2937),
    [anon_sym_thread_local] = ACTIONS(2937),
    [anon_sym___thread] = ACTIONS(2937),
    [anon_sym_const] = ACTIONS(2937),
    [anon_sym_constexpr] = ACTIONS(2937),
    [anon_sym_volatile] = ACTIONS(2937),
    [anon_sym_restrict] = ACTIONS(2937),
    [anon_sym___restrict__] = ACTIONS(2937),
    [anon_sym__Atomic] = ACTIONS(2937),
    [anon_sym__Noreturn] = ACTIONS(2937),
    [anon_sym_noreturn] = ACTIONS(2937),
    [anon_sym_mutable] = ACTIONS(2937),
    [anon_sym_constinit] = ACTIONS(2937),
    [anon_sym_consteval] = ACTIONS(2937),
    [anon_sym_PROGMEM] = ACTIONS(2937),
    [aux_sym_primitive_type_token1] = ACTIONS(2937),
    [anon_sym_byte] = ACTIONS(2937),
    [anon_sym_word] = ACTIONS(2937),
    [anon_sym_enum] = ACTIONS(2937),
    [anon_sym_class] = ACTIONS(2937),
    [anon_sym_struct] = ACTIONS(2937),
    [anon_sym_union] = ACTIONS(2937),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2937),
    [anon_sym_decltype] = ACTIONS(2937),
    [anon_sym_virtual] = ACTIONS(2937),
    [anon_sym_alignas] = ACTIONS(2937),
    [anon_sym_explicit] = ACTIONS(2937),
    [anon_sym_typename] = ACTIONS(2937),
    [anon_sym_template] = ACTIONS(2937),
    [anon_sym_operator] = ACTIONS(2937),
    [anon_sym_friend] = ACTIONS(2937),
    [anon_sym_public] = ACTIONS(2937),
    [anon_sym_private] = ACTIONS(2937),
    [anon_sym_protected] = ACTIONS(2937),
    [anon_sym_using] = ACTIONS(2937),
    [anon_sym_static_assert] = ACTIONS(2937),
  },
  [2051] = {
    [sym_identifier] = ACTIONS(4940),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4942),
    [anon_sym_COMMA] = ACTIONS(4942),
    [anon_sym_RPAREN] = ACTIONS(4942),
    [aux_sym_preproc_if_token2] = ACTIONS(4942),
    [aux_sym_preproc_else_token1] = ACTIONS(4942),
    [aux_sym_preproc_elif_token1] = ACTIONS(4940),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4942),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4942),
    [anon_sym_LPAREN2] = ACTIONS(4942),
    [anon_sym_DASH] = ACTIONS(4940),
    [anon_sym_PLUS] = ACTIONS(4940),
    [anon_sym_STAR] = ACTIONS(4940),
    [anon_sym_SLASH] = ACTIONS(4940),
    [anon_sym_PERCENT] = ACTIONS(4940),
    [anon_sym_PIPE_PIPE] = ACTIONS(4942),
    [anon_sym_AMP_AMP] = ACTIONS(4942),
    [anon_sym_PIPE] = ACTIONS(4940),
    [anon_sym_CARET] = ACTIONS(4940),
    [anon_sym_AMP] = ACTIONS(4940),
    [anon_sym_EQ_EQ] = ACTIONS(4942),
    [anon_sym_BANG_EQ] = ACTIONS(4942),
    [anon_sym_GT] = ACTIONS(4940),
    [anon_sym_GT_EQ] = ACTIONS(4942),
    [anon_sym_LT_EQ] = ACTIONS(4940),
    [anon_sym_LT] = ACTIONS(4940),
    [anon_sym_LT_LT] = ACTIONS(4940),
    [anon_sym_GT_GT] = ACTIONS(4940),
    [anon_sym_SEMI] = ACTIONS(4942),
    [anon_sym___attribute__] = ACTIONS(4940),
    [anon_sym_COLON_COLON] = ACTIONS(4922),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_RBRACE] = ACTIONS(4942),
    [anon_sym_LBRACK] = ACTIONS(4942),
    [anon_sym_RBRACK] = ACTIONS(4942),
    [anon_sym_EQ] = ACTIONS(4940),
    [anon_sym_COLON] = ACTIONS(4940),
    [anon_sym_QMARK] = ACTIONS(4942),
    [anon_sym_STAR_EQ] = ACTIONS(4942),
    [anon_sym_SLASH_EQ] = ACTIONS(4942),
    [anon_sym_PERCENT_EQ] = ACTIONS(4942),
    [anon_sym_PLUS_EQ] = ACTIONS(4942),
    [anon_sym_DASH_EQ] = ACTIONS(4942),
    [anon_sym_LT_LT_EQ] = ACTIONS(4942),
    [anon_sym_GT_GT_EQ] = ACTIONS(4942),
    [anon_sym_AMP_EQ] = ACTIONS(4942),
    [anon_sym_CARET_EQ] = ACTIONS(4942),
    [anon_sym_PIPE_EQ] = ACTIONS(4942),
    [anon_sym_and_eq] = ACTIONS(4940),
    [anon_sym_or_eq] = ACTIONS(4940),
    [anon_sym_xor_eq] = ACTIONS(4940),
    [anon_sym_LT_EQ_GT] = ACTIONS(4942),
    [anon_sym_or] = ACTIONS(4940),
    [anon_sym_and] = ACTIONS(4940),
    [anon_sym_bitor] = ACTIONS(4940),
    [anon_sym_xor] = ACTIONS(4940),
    [anon_sym_bitand] = ACTIONS(4940),
    [anon_sym_not_eq] = ACTIONS(4940),
    [anon_sym_DASH_DASH] = ACTIONS(4942),
    [anon_sym_PLUS_PLUS] = ACTIONS(4942),
    [anon_sym_DOT] = ACTIONS(4940),
    [anon_sym_DOT_STAR] = ACTIONS(4942),
    [anon_sym_DASH_GT] = ACTIONS(4942),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4940),
    [anon_sym_decltype] = ACTIONS(4940),
    [anon_sym_final] = ACTIONS(4940),
    [anon_sym_override] = ACTIONS(4940),
  },
  [2052] = {
    [sym_identifier] = ACTIONS(2985),
    [aux_sym_preproc_def_token1] = ACTIONS(2985),
    [aux_sym_preproc_if_token1] = ACTIONS(2985),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2985),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2985),
    [sym_preproc_directive] = ACTIONS(2985),
    [anon_sym_LPAREN2] = ACTIONS(2987),
    [anon_sym_TILDE] = ACTIONS(2987),
    [anon_sym_STAR] = ACTIONS(2987),
    [anon_sym_AMP_AMP] = ACTIONS(2987),
    [anon_sym_AMP] = ACTIONS(2985),
    [anon_sym_SEMI] = ACTIONS(5275),
    [anon_sym___extension__] = ACTIONS(2985),
    [anon_sym_typedef] = ACTIONS(2985),
    [anon_sym_extern] = ACTIONS(2985),
    [anon_sym___attribute__] = ACTIONS(2985),
    [anon_sym_COLON_COLON] = ACTIONS(2987),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2987),
    [anon_sym___declspec] = ACTIONS(2985),
    [anon_sym___based] = ACTIONS(2985),
    [anon_sym_RBRACE] = ACTIONS(2987),
    [anon_sym_signed] = ACTIONS(2985),
    [anon_sym_unsigned] = ACTIONS(2985),
    [anon_sym_long] = ACTIONS(2985),
    [anon_sym_short] = ACTIONS(2985),
    [anon_sym_LBRACK] = ACTIONS(2985),
    [anon_sym_static] = ACTIONS(2985),
    [anon_sym_register] = ACTIONS(2985),
    [anon_sym_inline] = ACTIONS(2985),
    [anon_sym___inline] = ACTIONS(2985),
    [anon_sym___inline__] = ACTIONS(2985),
    [anon_sym___forceinline] = ACTIONS(2985),
    [anon_sym_thread_local] = ACTIONS(2985),
    [anon_sym___thread] = ACTIONS(2985),
    [anon_sym_const] = ACTIONS(2985),
    [anon_sym_constexpr] = ACTIONS(2985),
    [anon_sym_volatile] = ACTIONS(2985),
    [anon_sym_restrict] = ACTIONS(2985),
    [anon_sym___restrict__] = ACTIONS(2985),
    [anon_sym__Atomic] = ACTIONS(2985),
    [anon_sym__Noreturn] = ACTIONS(2985),
    [anon_sym_noreturn] = ACTIONS(2985),
    [anon_sym_mutable] = ACTIONS(2985),
    [anon_sym_constinit] = ACTIONS(2985),
    [anon_sym_consteval] = ACTIONS(2985),
    [anon_sym_PROGMEM] = ACTIONS(2985),
    [aux_sym_primitive_type_token1] = ACTIONS(2985),
    [anon_sym_byte] = ACTIONS(2985),
    [anon_sym_word] = ACTIONS(2985),
    [anon_sym_enum] = ACTIONS(2985),
    [anon_sym_class] = ACTIONS(2985),
    [anon_sym_struct] = ACTIONS(2985),
    [anon_sym_union] = ACTIONS(2985),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2985),
    [anon_sym_decltype] = ACTIONS(2985),
    [anon_sym_virtual] = ACTIONS(2985),
    [anon_sym_alignas] = ACTIONS(2985),
    [anon_sym_explicit] = ACTIONS(2985),
    [anon_sym_typename] = ACTIONS(2985),
    [anon_sym_template] = ACTIONS(2985),
    [anon_sym_operator] = ACTIONS(2985),
    [anon_sym_friend] = ACTIONS(2985),
    [anon_sym_public] = ACTIONS(2985),
    [anon_sym_private] = ACTIONS(2985),
    [anon_sym_protected] = ACTIONS(2985),
    [anon_sym_using] = ACTIONS(2985),
    [anon_sym_static_assert] = ACTIONS(2985),
  },
  [2053] = {
    [sym_identifier] = ACTIONS(4988),
    [aux_sym_preproc_def_token1] = ACTIONS(4988),
    [aux_sym_preproc_if_token1] = ACTIONS(4988),
    [aux_sym_preproc_if_token2] = ACTIONS(4988),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4988),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4988),
    [sym_preproc_directive] = ACTIONS(4988),
    [anon_sym_LPAREN2] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_STAR] = ACTIONS(4990),
    [anon_sym_AMP_AMP] = ACTIONS(4990),
    [anon_sym_AMP] = ACTIONS(4988),
    [anon_sym___extension__] = ACTIONS(4988),
    [anon_sym_typedef] = ACTIONS(4988),
    [anon_sym_extern] = ACTIONS(4988),
    [anon_sym___attribute__] = ACTIONS(4988),
    [anon_sym_COLON_COLON] = ACTIONS(4990),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4990),
    [anon_sym___declspec] = ACTIONS(4988),
    [anon_sym___based] = ACTIONS(4988),
    [anon_sym_signed] = ACTIONS(4988),
    [anon_sym_unsigned] = ACTIONS(4988),
    [anon_sym_long] = ACTIONS(4988),
    [anon_sym_short] = ACTIONS(4988),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_static] = ACTIONS(4988),
    [anon_sym_register] = ACTIONS(4988),
    [anon_sym_inline] = ACTIONS(4988),
    [anon_sym___inline] = ACTIONS(4988),
    [anon_sym___inline__] = ACTIONS(4988),
    [anon_sym___forceinline] = ACTIONS(4988),
    [anon_sym_thread_local] = ACTIONS(4988),
    [anon_sym___thread] = ACTIONS(4988),
    [anon_sym_const] = ACTIONS(4988),
    [anon_sym_constexpr] = ACTIONS(4988),
    [anon_sym_volatile] = ACTIONS(4988),
    [anon_sym_restrict] = ACTIONS(4988),
    [anon_sym___restrict__] = ACTIONS(4988),
    [anon_sym__Atomic] = ACTIONS(4988),
    [anon_sym__Noreturn] = ACTIONS(4988),
    [anon_sym_noreturn] = ACTIONS(4988),
    [anon_sym_mutable] = ACTIONS(4988),
    [anon_sym_constinit] = ACTIONS(4988),
    [anon_sym_consteval] = ACTIONS(4988),
    [anon_sym_PROGMEM] = ACTIONS(4988),
    [aux_sym_primitive_type_token1] = ACTIONS(4988),
    [anon_sym_byte] = ACTIONS(4988),
    [anon_sym_word] = ACTIONS(4988),
    [anon_sym_enum] = ACTIONS(4988),
    [anon_sym_class] = ACTIONS(4988),
    [anon_sym_struct] = ACTIONS(4988),
    [anon_sym_union] = ACTIONS(4988),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4988),
    [anon_sym_decltype] = ACTIONS(4988),
    [anon_sym_virtual] = ACTIONS(4988),
    [anon_sym_alignas] = ACTIONS(4988),
    [anon_sym_explicit] = ACTIONS(4988),
    [anon_sym_typename] = ACTIONS(4988),
    [anon_sym_template] = ACTIONS(4988),
    [anon_sym_operator] = ACTIONS(4988),
    [anon_sym_friend] = ACTIONS(4988),
    [anon_sym_public] = ACTIONS(4988),
    [anon_sym_private] = ACTIONS(4988),
    [anon_sym_protected] = ACTIONS(4988),
    [anon_sym_using] = ACTIONS(4988),
    [anon_sym_static_assert] = ACTIONS(4988),
  },
  [2054] = {
    [sym_identifier] = ACTIONS(2783),
    [aux_sym_preproc_def_token1] = ACTIONS(2783),
    [aux_sym_preproc_if_token1] = ACTIONS(2783),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2783),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2783),
    [sym_preproc_directive] = ACTIONS(2783),
    [anon_sym_LPAREN2] = ACTIONS(2785),
    [anon_sym_TILDE] = ACTIONS(2785),
    [anon_sym_STAR] = ACTIONS(2785),
    [anon_sym_AMP_AMP] = ACTIONS(2785),
    [anon_sym_AMP] = ACTIONS(2783),
    [anon_sym___extension__] = ACTIONS(2783),
    [anon_sym_typedef] = ACTIONS(2783),
    [anon_sym_extern] = ACTIONS(2783),
    [anon_sym___attribute__] = ACTIONS(2783),
    [anon_sym_COLON_COLON] = ACTIONS(2785),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2785),
    [anon_sym___declspec] = ACTIONS(2783),
    [anon_sym___based] = ACTIONS(2783),
    [anon_sym_RBRACE] = ACTIONS(2785),
    [anon_sym_signed] = ACTIONS(2783),
    [anon_sym_unsigned] = ACTIONS(2783),
    [anon_sym_long] = ACTIONS(2783),
    [anon_sym_short] = ACTIONS(2783),
    [anon_sym_LBRACK] = ACTIONS(2783),
    [anon_sym_static] = ACTIONS(2783),
    [anon_sym_register] = ACTIONS(2783),
    [anon_sym_inline] = ACTIONS(2783),
    [anon_sym___inline] = ACTIONS(2783),
    [anon_sym___inline__] = ACTIONS(2783),
    [anon_sym___forceinline] = ACTIONS(2783),
    [anon_sym_thread_local] = ACTIONS(2783),
    [anon_sym___thread] = ACTIONS(2783),
    [anon_sym_const] = ACTIONS(2783),
    [anon_sym_constexpr] = ACTIONS(2783),
    [anon_sym_volatile] = ACTIONS(2783),
    [anon_sym_restrict] = ACTIONS(2783),
    [anon_sym___restrict__] = ACTIONS(2783),
    [anon_sym__Atomic] = ACTIONS(2783),
    [anon_sym__Noreturn] = ACTIONS(2783),
    [anon_sym_noreturn] = ACTIONS(2783),
    [anon_sym_mutable] = ACTIONS(2783),
    [anon_sym_constinit] = ACTIONS(2783),
    [anon_sym_consteval] = ACTIONS(2783),
    [anon_sym_PROGMEM] = ACTIONS(2783),
    [aux_sym_primitive_type_token1] = ACTIONS(2783),
    [anon_sym_byte] = ACTIONS(2783),
    [anon_sym_word] = ACTIONS(2783),
    [anon_sym_enum] = ACTIONS(2783),
    [anon_sym_class] = ACTIONS(2783),
    [anon_sym_struct] = ACTIONS(2783),
    [anon_sym_union] = ACTIONS(2783),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2783),
    [anon_sym_decltype] = ACTIONS(2783),
    [anon_sym_virtual] = ACTIONS(2783),
    [anon_sym_alignas] = ACTIONS(2783),
    [anon_sym_explicit] = ACTIONS(2783),
    [anon_sym_typename] = ACTIONS(2783),
    [anon_sym_template] = ACTIONS(2783),
    [anon_sym_operator] = ACTIONS(2783),
    [anon_sym_friend] = ACTIONS(2783),
    [anon_sym_public] = ACTIONS(2783),
    [anon_sym_private] = ACTIONS(2783),
    [anon_sym_protected] = ACTIONS(2783),
    [anon_sym_using] = ACTIONS(2783),
    [anon_sym_static_assert] = ACTIONS(2783),
  },
  [2055] = {
    [sym_identifier] = ACTIONS(3111),
    [aux_sym_preproc_def_token1] = ACTIONS(3111),
    [aux_sym_preproc_if_token1] = ACTIONS(3111),
    [aux_sym_preproc_if_token2] = ACTIONS(3111),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3111),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3111),
    [sym_preproc_directive] = ACTIONS(3111),
    [anon_sym_LPAREN2] = ACTIONS(3113),
    [anon_sym_TILDE] = ACTIONS(3113),
    [anon_sym_STAR] = ACTIONS(3113),
    [anon_sym_AMP_AMP] = ACTIONS(3113),
    [anon_sym_AMP] = ACTIONS(3111),
    [anon_sym___extension__] = ACTIONS(3111),
    [anon_sym_typedef] = ACTIONS(3111),
    [anon_sym_extern] = ACTIONS(3111),
    [anon_sym___attribute__] = ACTIONS(3111),
    [anon_sym_COLON_COLON] = ACTIONS(3113),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3113),
    [anon_sym___declspec] = ACTIONS(3111),
    [anon_sym___based] = ACTIONS(3111),
    [anon_sym_signed] = ACTIONS(3111),
    [anon_sym_unsigned] = ACTIONS(3111),
    [anon_sym_long] = ACTIONS(3111),
    [anon_sym_short] = ACTIONS(3111),
    [anon_sym_LBRACK] = ACTIONS(3111),
    [anon_sym_static] = ACTIONS(3111),
    [anon_sym_register] = ACTIONS(3111),
    [anon_sym_inline] = ACTIONS(3111),
    [anon_sym___inline] = ACTIONS(3111),
    [anon_sym___inline__] = ACTIONS(3111),
    [anon_sym___forceinline] = ACTIONS(3111),
    [anon_sym_thread_local] = ACTIONS(3111),
    [anon_sym___thread] = ACTIONS(3111),
    [anon_sym_const] = ACTIONS(3111),
    [anon_sym_constexpr] = ACTIONS(3111),
    [anon_sym_volatile] = ACTIONS(3111),
    [anon_sym_restrict] = ACTIONS(3111),
    [anon_sym___restrict__] = ACTIONS(3111),
    [anon_sym__Atomic] = ACTIONS(3111),
    [anon_sym__Noreturn] = ACTIONS(3111),
    [anon_sym_noreturn] = ACTIONS(3111),
    [anon_sym_mutable] = ACTIONS(3111),
    [anon_sym_constinit] = ACTIONS(3111),
    [anon_sym_consteval] = ACTIONS(3111),
    [anon_sym_PROGMEM] = ACTIONS(3111),
    [aux_sym_primitive_type_token1] = ACTIONS(3111),
    [anon_sym_byte] = ACTIONS(3111),
    [anon_sym_word] = ACTIONS(3111),
    [anon_sym_enum] = ACTIONS(3111),
    [anon_sym_class] = ACTIONS(3111),
    [anon_sym_struct] = ACTIONS(3111),
    [anon_sym_union] = ACTIONS(3111),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3111),
    [anon_sym_decltype] = ACTIONS(3111),
    [anon_sym_virtual] = ACTIONS(3111),
    [anon_sym_alignas] = ACTIONS(3111),
    [anon_sym_explicit] = ACTIONS(3111),
    [anon_sym_typename] = ACTIONS(3111),
    [anon_sym_template] = ACTIONS(3111),
    [anon_sym_operator] = ACTIONS(3111),
    [anon_sym_friend] = ACTIONS(3111),
    [anon_sym_public] = ACTIONS(3111),
    [anon_sym_private] = ACTIONS(3111),
    [anon_sym_protected] = ACTIONS(3111),
    [anon_sym_using] = ACTIONS(3111),
    [anon_sym_static_assert] = ACTIONS(3111),
  },
  [2056] = {
    [sym_identifier] = ACTIONS(3556),
    [aux_sym_preproc_def_token1] = ACTIONS(3556),
    [aux_sym_preproc_if_token1] = ACTIONS(3556),
    [aux_sym_preproc_if_token2] = ACTIONS(3556),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3556),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3556),
    [sym_preproc_directive] = ACTIONS(3556),
    [anon_sym_LPAREN2] = ACTIONS(3554),
    [anon_sym_TILDE] = ACTIONS(3554),
    [anon_sym_STAR] = ACTIONS(3554),
    [anon_sym_AMP_AMP] = ACTIONS(3554),
    [anon_sym_AMP] = ACTIONS(3556),
    [anon_sym___extension__] = ACTIONS(3556),
    [anon_sym_typedef] = ACTIONS(3556),
    [anon_sym_extern] = ACTIONS(3556),
    [anon_sym___attribute__] = ACTIONS(3556),
    [anon_sym_COLON_COLON] = ACTIONS(3554),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3554),
    [anon_sym___declspec] = ACTIONS(3556),
    [anon_sym___based] = ACTIONS(3556),
    [anon_sym_signed] = ACTIONS(3556),
    [anon_sym_unsigned] = ACTIONS(3556),
    [anon_sym_long] = ACTIONS(3556),
    [anon_sym_short] = ACTIONS(3556),
    [anon_sym_LBRACK] = ACTIONS(3556),
    [anon_sym_static] = ACTIONS(3556),
    [anon_sym_register] = ACTIONS(3556),
    [anon_sym_inline] = ACTIONS(3556),
    [anon_sym___inline] = ACTIONS(3556),
    [anon_sym___inline__] = ACTIONS(3556),
    [anon_sym___forceinline] = ACTIONS(3556),
    [anon_sym_thread_local] = ACTIONS(3556),
    [anon_sym___thread] = ACTIONS(3556),
    [anon_sym_const] = ACTIONS(3556),
    [anon_sym_constexpr] = ACTIONS(3556),
    [anon_sym_volatile] = ACTIONS(3556),
    [anon_sym_restrict] = ACTIONS(3556),
    [anon_sym___restrict__] = ACTIONS(3556),
    [anon_sym__Atomic] = ACTIONS(3556),
    [anon_sym__Noreturn] = ACTIONS(3556),
    [anon_sym_noreturn] = ACTIONS(3556),
    [anon_sym_mutable] = ACTIONS(3556),
    [anon_sym_constinit] = ACTIONS(3556),
    [anon_sym_consteval] = ACTIONS(3556),
    [anon_sym_PROGMEM] = ACTIONS(3556),
    [aux_sym_primitive_type_token1] = ACTIONS(3556),
    [anon_sym_byte] = ACTIONS(3556),
    [anon_sym_word] = ACTIONS(3556),
    [anon_sym_enum] = ACTIONS(3556),
    [anon_sym_class] = ACTIONS(3556),
    [anon_sym_struct] = ACTIONS(3556),
    [anon_sym_union] = ACTIONS(3556),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3556),
    [anon_sym_decltype] = ACTIONS(3556),
    [anon_sym_virtual] = ACTIONS(3556),
    [anon_sym_alignas] = ACTIONS(3556),
    [anon_sym_explicit] = ACTIONS(3556),
    [anon_sym_typename] = ACTIONS(3556),
    [anon_sym_template] = ACTIONS(3556),
    [anon_sym_operator] = ACTIONS(3556),
    [anon_sym_friend] = ACTIONS(3556),
    [anon_sym_public] = ACTIONS(3556),
    [anon_sym_private] = ACTIONS(3556),
    [anon_sym_protected] = ACTIONS(3556),
    [anon_sym_using] = ACTIONS(3556),
    [anon_sym_static_assert] = ACTIONS(3556),
  },
  [2057] = {
    [sym_string_literal] = STATE(2617),
    [sym_template_argument_list] = STATE(3723),
    [sym_raw_string_literal] = STATE(2617),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3761),
    [anon_sym_COMMA] = ACTIONS(3761),
    [anon_sym_LPAREN2] = ACTIONS(3761),
    [anon_sym_DASH] = ACTIONS(3769),
    [anon_sym_PLUS] = ACTIONS(3769),
    [anon_sym_STAR] = ACTIONS(3769),
    [anon_sym_SLASH] = ACTIONS(3769),
    [anon_sym_PERCENT] = ACTIONS(3769),
    [anon_sym_PIPE_PIPE] = ACTIONS(3761),
    [anon_sym_AMP_AMP] = ACTIONS(3761),
    [anon_sym_PIPE] = ACTIONS(3769),
    [anon_sym_CARET] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(3769),
    [anon_sym_EQ_EQ] = ACTIONS(3761),
    [anon_sym_BANG_EQ] = ACTIONS(3761),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3761),
    [anon_sym_LT_EQ] = ACTIONS(3769),
    [anon_sym_LT] = ACTIONS(5242),
    [anon_sym_LT_LT] = ACTIONS(3769),
    [anon_sym_GT_GT] = ACTIONS(3769),
    [anon_sym_SEMI] = ACTIONS(3761),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(3785),
    [anon_sym_LBRACK] = ACTIONS(3761),
    [anon_sym_EQ] = ACTIONS(3793),
    [anon_sym_COLON] = ACTIONS(4044),
    [anon_sym_QMARK] = ACTIONS(3761),
    [anon_sym_STAR_EQ] = ACTIONS(3797),
    [anon_sym_SLASH_EQ] = ACTIONS(3797),
    [anon_sym_PERCENT_EQ] = ACTIONS(3797),
    [anon_sym_PLUS_EQ] = ACTIONS(3797),
    [anon_sym_DASH_EQ] = ACTIONS(3797),
    [anon_sym_LT_LT_EQ] = ACTIONS(3797),
    [anon_sym_GT_GT_EQ] = ACTIONS(3797),
    [anon_sym_AMP_EQ] = ACTIONS(3797),
    [anon_sym_CARET_EQ] = ACTIONS(3797),
    [anon_sym_PIPE_EQ] = ACTIONS(3797),
    [anon_sym_and_eq] = ACTIONS(3797),
    [anon_sym_or_eq] = ACTIONS(3797),
    [anon_sym_xor_eq] = ACTIONS(3797),
    [anon_sym_LT_EQ_GT] = ACTIONS(3761),
    [anon_sym_or] = ACTIONS(3769),
    [anon_sym_and] = ACTIONS(3769),
    [anon_sym_bitor] = ACTIONS(3761),
    [anon_sym_xor] = ACTIONS(3769),
    [anon_sym_bitand] = ACTIONS(3761),
    [anon_sym_not_eq] = ACTIONS(3761),
    [anon_sym_DASH_DASH] = ACTIONS(3761),
    [anon_sym_PLUS_PLUS] = ACTIONS(3761),
    [anon_sym_DOT] = ACTIONS(3769),
    [anon_sym_DOT_STAR] = ACTIONS(3761),
    [anon_sym_DASH_GT] = ACTIONS(3761),
    [anon_sym_L_DQUOTE] = ACTIONS(3204),
    [anon_sym_u_DQUOTE] = ACTIONS(3204),
    [anon_sym_U_DQUOTE] = ACTIONS(3204),
    [anon_sym_u8_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3204),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3208),
    [anon_sym_LR_DQUOTE] = ACTIONS(3208),
    [anon_sym_uR_DQUOTE] = ACTIONS(3208),
    [anon_sym_UR_DQUOTE] = ACTIONS(3208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3208),
  },
  [2058] = {
    [sym_identifier] = ACTIONS(3020),
    [aux_sym_preproc_def_token1] = ACTIONS(3020),
    [aux_sym_preproc_if_token1] = ACTIONS(3020),
    [aux_sym_preproc_if_token2] = ACTIONS(3020),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3020),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3020),
    [sym_preproc_directive] = ACTIONS(3020),
    [anon_sym_LPAREN2] = ACTIONS(3022),
    [anon_sym_TILDE] = ACTIONS(3022),
    [anon_sym_STAR] = ACTIONS(3022),
    [anon_sym_AMP_AMP] = ACTIONS(3022),
    [anon_sym_AMP] = ACTIONS(3020),
    [anon_sym___extension__] = ACTIONS(3020),
    [anon_sym_typedef] = ACTIONS(3020),
    [anon_sym_extern] = ACTIONS(3020),
    [anon_sym___attribute__] = ACTIONS(3020),
    [anon_sym_COLON_COLON] = ACTIONS(3022),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3022),
    [anon_sym___declspec] = ACTIONS(3020),
    [anon_sym___based] = ACTIONS(3020),
    [anon_sym_signed] = ACTIONS(3020),
    [anon_sym_unsigned] = ACTIONS(3020),
    [anon_sym_long] = ACTIONS(3020),
    [anon_sym_short] = ACTIONS(3020),
    [anon_sym_LBRACK] = ACTIONS(3020),
    [anon_sym_static] = ACTIONS(3020),
    [anon_sym_register] = ACTIONS(3020),
    [anon_sym_inline] = ACTIONS(3020),
    [anon_sym___inline] = ACTIONS(3020),
    [anon_sym___inline__] = ACTIONS(3020),
    [anon_sym___forceinline] = ACTIONS(3020),
    [anon_sym_thread_local] = ACTIONS(3020),
    [anon_sym___thread] = ACTIONS(3020),
    [anon_sym_const] = ACTIONS(3020),
    [anon_sym_constexpr] = ACTIONS(3020),
    [anon_sym_volatile] = ACTIONS(3020),
    [anon_sym_restrict] = ACTIONS(3020),
    [anon_sym___restrict__] = ACTIONS(3020),
    [anon_sym__Atomic] = ACTIONS(3020),
    [anon_sym__Noreturn] = ACTIONS(3020),
    [anon_sym_noreturn] = ACTIONS(3020),
    [anon_sym_mutable] = ACTIONS(3020),
    [anon_sym_constinit] = ACTIONS(3020),
    [anon_sym_consteval] = ACTIONS(3020),
    [anon_sym_PROGMEM] = ACTIONS(3020),
    [aux_sym_primitive_type_token1] = ACTIONS(3020),
    [anon_sym_byte] = ACTIONS(3020),
    [anon_sym_word] = ACTIONS(3020),
    [anon_sym_enum] = ACTIONS(3020),
    [anon_sym_class] = ACTIONS(3020),
    [anon_sym_struct] = ACTIONS(3020),
    [anon_sym_union] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3020),
    [anon_sym_decltype] = ACTIONS(3020),
    [anon_sym_virtual] = ACTIONS(3020),
    [anon_sym_alignas] = ACTIONS(3020),
    [anon_sym_explicit] = ACTIONS(3020),
    [anon_sym_typename] = ACTIONS(3020),
    [anon_sym_template] = ACTIONS(3020),
    [anon_sym_operator] = ACTIONS(3020),
    [anon_sym_friend] = ACTIONS(3020),
    [anon_sym_public] = ACTIONS(3020),
    [anon_sym_private] = ACTIONS(3020),
    [anon_sym_protected] = ACTIONS(3020),
    [anon_sym_using] = ACTIONS(3020),
    [anon_sym_static_assert] = ACTIONS(3020),
  },
  [2059] = {
    [sym_identifier] = ACTIONS(3132),
    [aux_sym_preproc_def_token1] = ACTIONS(3132),
    [aux_sym_preproc_if_token1] = ACTIONS(3132),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3132),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3132),
    [sym_preproc_directive] = ACTIONS(3132),
    [anon_sym_LPAREN2] = ACTIONS(3134),
    [anon_sym_TILDE] = ACTIONS(3134),
    [anon_sym_STAR] = ACTIONS(3134),
    [anon_sym_AMP_AMP] = ACTIONS(3134),
    [anon_sym_AMP] = ACTIONS(3132),
    [anon_sym___extension__] = ACTIONS(3132),
    [anon_sym_typedef] = ACTIONS(3132),
    [anon_sym_extern] = ACTIONS(3132),
    [anon_sym___attribute__] = ACTIONS(3132),
    [anon_sym_COLON_COLON] = ACTIONS(3134),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3134),
    [anon_sym___declspec] = ACTIONS(3132),
    [anon_sym___based] = ACTIONS(3132),
    [anon_sym_RBRACE] = ACTIONS(3134),
    [anon_sym_signed] = ACTIONS(3132),
    [anon_sym_unsigned] = ACTIONS(3132),
    [anon_sym_long] = ACTIONS(3132),
    [anon_sym_short] = ACTIONS(3132),
    [anon_sym_LBRACK] = ACTIONS(3132),
    [anon_sym_static] = ACTIONS(3132),
    [anon_sym_register] = ACTIONS(3132),
    [anon_sym_inline] = ACTIONS(3132),
    [anon_sym___inline] = ACTIONS(3132),
    [anon_sym___inline__] = ACTIONS(3132),
    [anon_sym___forceinline] = ACTIONS(3132),
    [anon_sym_thread_local] = ACTIONS(3132),
    [anon_sym___thread] = ACTIONS(3132),
    [anon_sym_const] = ACTIONS(3132),
    [anon_sym_constexpr] = ACTIONS(3132),
    [anon_sym_volatile] = ACTIONS(3132),
    [anon_sym_restrict] = ACTIONS(3132),
    [anon_sym___restrict__] = ACTIONS(3132),
    [anon_sym__Atomic] = ACTIONS(3132),
    [anon_sym__Noreturn] = ACTIONS(3132),
    [anon_sym_noreturn] = ACTIONS(3132),
    [anon_sym_mutable] = ACTIONS(3132),
    [anon_sym_constinit] = ACTIONS(3132),
    [anon_sym_consteval] = ACTIONS(3132),
    [anon_sym_PROGMEM] = ACTIONS(3132),
    [aux_sym_primitive_type_token1] = ACTIONS(3132),
    [anon_sym_byte] = ACTIONS(3132),
    [anon_sym_word] = ACTIONS(3132),
    [anon_sym_enum] = ACTIONS(3132),
    [anon_sym_class] = ACTIONS(3132),
    [anon_sym_struct] = ACTIONS(3132),
    [anon_sym_union] = ACTIONS(3132),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3132),
    [anon_sym_decltype] = ACTIONS(3132),
    [anon_sym_virtual] = ACTIONS(3132),
    [anon_sym_alignas] = ACTIONS(3132),
    [anon_sym_explicit] = ACTIONS(3132),
    [anon_sym_typename] = ACTIONS(3132),
    [anon_sym_template] = ACTIONS(3132),
    [anon_sym_operator] = ACTIONS(3132),
    [anon_sym_friend] = ACTIONS(3132),
    [anon_sym_public] = ACTIONS(3132),
    [anon_sym_private] = ACTIONS(3132),
    [anon_sym_protected] = ACTIONS(3132),
    [anon_sym_using] = ACTIONS(3132),
    [anon_sym_static_assert] = ACTIONS(3132),
  },
  [2060] = {
    [sym_identifier] = ACTIONS(4988),
    [aux_sym_preproc_def_token1] = ACTIONS(4988),
    [aux_sym_preproc_if_token1] = ACTIONS(4988),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4988),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4988),
    [sym_preproc_directive] = ACTIONS(4988),
    [anon_sym_LPAREN2] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_STAR] = ACTIONS(4990),
    [anon_sym_AMP_AMP] = ACTIONS(4990),
    [anon_sym_AMP] = ACTIONS(4988),
    [anon_sym___extension__] = ACTIONS(4988),
    [anon_sym_typedef] = ACTIONS(4988),
    [anon_sym_extern] = ACTIONS(4988),
    [anon_sym___attribute__] = ACTIONS(4988),
    [anon_sym_COLON_COLON] = ACTIONS(4990),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4990),
    [anon_sym___declspec] = ACTIONS(4988),
    [anon_sym___based] = ACTIONS(4988),
    [anon_sym_RBRACE] = ACTIONS(4990),
    [anon_sym_signed] = ACTIONS(4988),
    [anon_sym_unsigned] = ACTIONS(4988),
    [anon_sym_long] = ACTIONS(4988),
    [anon_sym_short] = ACTIONS(4988),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_static] = ACTIONS(4988),
    [anon_sym_register] = ACTIONS(4988),
    [anon_sym_inline] = ACTIONS(4988),
    [anon_sym___inline] = ACTIONS(4988),
    [anon_sym___inline__] = ACTIONS(4988),
    [anon_sym___forceinline] = ACTIONS(4988),
    [anon_sym_thread_local] = ACTIONS(4988),
    [anon_sym___thread] = ACTIONS(4988),
    [anon_sym_const] = ACTIONS(4988),
    [anon_sym_constexpr] = ACTIONS(4988),
    [anon_sym_volatile] = ACTIONS(4988),
    [anon_sym_restrict] = ACTIONS(4988),
    [anon_sym___restrict__] = ACTIONS(4988),
    [anon_sym__Atomic] = ACTIONS(4988),
    [anon_sym__Noreturn] = ACTIONS(4988),
    [anon_sym_noreturn] = ACTIONS(4988),
    [anon_sym_mutable] = ACTIONS(4988),
    [anon_sym_constinit] = ACTIONS(4988),
    [anon_sym_consteval] = ACTIONS(4988),
    [anon_sym_PROGMEM] = ACTIONS(4988),
    [aux_sym_primitive_type_token1] = ACTIONS(4988),
    [anon_sym_byte] = ACTIONS(4988),
    [anon_sym_word] = ACTIONS(4988),
    [anon_sym_enum] = ACTIONS(4988),
    [anon_sym_class] = ACTIONS(4988),
    [anon_sym_struct] = ACTIONS(4988),
    [anon_sym_union] = ACTIONS(4988),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4988),
    [anon_sym_decltype] = ACTIONS(4988),
    [anon_sym_virtual] = ACTIONS(4988),
    [anon_sym_alignas] = ACTIONS(4988),
    [anon_sym_explicit] = ACTIONS(4988),
    [anon_sym_typename] = ACTIONS(4988),
    [anon_sym_template] = ACTIONS(4988),
    [anon_sym_operator] = ACTIONS(4988),
    [anon_sym_friend] = ACTIONS(4988),
    [anon_sym_public] = ACTIONS(4988),
    [anon_sym_private] = ACTIONS(4988),
    [anon_sym_protected] = ACTIONS(4988),
    [anon_sym_using] = ACTIONS(4988),
    [anon_sym_static_assert] = ACTIONS(4988),
  },
  [2061] = {
    [sym_identifier] = ACTIONS(3170),
    [aux_sym_preproc_def_token1] = ACTIONS(3170),
    [aux_sym_preproc_if_token1] = ACTIONS(3170),
    [aux_sym_preproc_if_token2] = ACTIONS(3170),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3170),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3170),
    [sym_preproc_directive] = ACTIONS(3170),
    [anon_sym_LPAREN2] = ACTIONS(3172),
    [anon_sym_TILDE] = ACTIONS(3172),
    [anon_sym_STAR] = ACTIONS(3172),
    [anon_sym_AMP_AMP] = ACTIONS(3172),
    [anon_sym_AMP] = ACTIONS(3170),
    [anon_sym___extension__] = ACTIONS(3170),
    [anon_sym_typedef] = ACTIONS(3170),
    [anon_sym_extern] = ACTIONS(3170),
    [anon_sym___attribute__] = ACTIONS(3170),
    [anon_sym_COLON_COLON] = ACTIONS(3172),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3172),
    [anon_sym___declspec] = ACTIONS(3170),
    [anon_sym___based] = ACTIONS(3170),
    [anon_sym_signed] = ACTIONS(3170),
    [anon_sym_unsigned] = ACTIONS(3170),
    [anon_sym_long] = ACTIONS(3170),
    [anon_sym_short] = ACTIONS(3170),
    [anon_sym_LBRACK] = ACTIONS(3170),
    [anon_sym_static] = ACTIONS(3170),
    [anon_sym_register] = ACTIONS(3170),
    [anon_sym_inline] = ACTIONS(3170),
    [anon_sym___inline] = ACTIONS(3170),
    [anon_sym___inline__] = ACTIONS(3170),
    [anon_sym___forceinline] = ACTIONS(3170),
    [anon_sym_thread_local] = ACTIONS(3170),
    [anon_sym___thread] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3170),
    [anon_sym_constexpr] = ACTIONS(3170),
    [anon_sym_volatile] = ACTIONS(3170),
    [anon_sym_restrict] = ACTIONS(3170),
    [anon_sym___restrict__] = ACTIONS(3170),
    [anon_sym__Atomic] = ACTIONS(3170),
    [anon_sym__Noreturn] = ACTIONS(3170),
    [anon_sym_noreturn] = ACTIONS(3170),
    [anon_sym_mutable] = ACTIONS(3170),
    [anon_sym_constinit] = ACTIONS(3170),
    [anon_sym_consteval] = ACTIONS(3170),
    [anon_sym_PROGMEM] = ACTIONS(3170),
    [aux_sym_primitive_type_token1] = ACTIONS(3170),
    [anon_sym_byte] = ACTIONS(3170),
    [anon_sym_word] = ACTIONS(3170),
    [anon_sym_enum] = ACTIONS(3170),
    [anon_sym_class] = ACTIONS(3170),
    [anon_sym_struct] = ACTIONS(3170),
    [anon_sym_union] = ACTIONS(3170),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3170),
    [anon_sym_decltype] = ACTIONS(3170),
    [anon_sym_virtual] = ACTIONS(3170),
    [anon_sym_alignas] = ACTIONS(3170),
    [anon_sym_explicit] = ACTIONS(3170),
    [anon_sym_typename] = ACTIONS(3170),
    [anon_sym_template] = ACTIONS(3170),
    [anon_sym_operator] = ACTIONS(3170),
    [anon_sym_friend] = ACTIONS(3170),
    [anon_sym_public] = ACTIONS(3170),
    [anon_sym_private] = ACTIONS(3170),
    [anon_sym_protected] = ACTIONS(3170),
    [anon_sym_using] = ACTIONS(3170),
    [anon_sym_static_assert] = ACTIONS(3170),
  },
  [2062] = {
    [sym_identifier] = ACTIONS(4984),
    [aux_sym_preproc_def_token1] = ACTIONS(4984),
    [aux_sym_preproc_if_token1] = ACTIONS(4984),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4984),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4984),
    [sym_preproc_directive] = ACTIONS(4984),
    [anon_sym_LPAREN2] = ACTIONS(4986),
    [anon_sym_TILDE] = ACTIONS(4986),
    [anon_sym_STAR] = ACTIONS(4986),
    [anon_sym_AMP_AMP] = ACTIONS(4986),
    [anon_sym_AMP] = ACTIONS(4984),
    [anon_sym___extension__] = ACTIONS(4984),
    [anon_sym_typedef] = ACTIONS(4984),
    [anon_sym_extern] = ACTIONS(4984),
    [anon_sym___attribute__] = ACTIONS(4984),
    [anon_sym_COLON_COLON] = ACTIONS(4986),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4986),
    [anon_sym___declspec] = ACTIONS(4984),
    [anon_sym___based] = ACTIONS(4984),
    [anon_sym_RBRACE] = ACTIONS(4986),
    [anon_sym_signed] = ACTIONS(4984),
    [anon_sym_unsigned] = ACTIONS(4984),
    [anon_sym_long] = ACTIONS(4984),
    [anon_sym_short] = ACTIONS(4984),
    [anon_sym_LBRACK] = ACTIONS(4984),
    [anon_sym_static] = ACTIONS(4984),
    [anon_sym_register] = ACTIONS(4984),
    [anon_sym_inline] = ACTIONS(4984),
    [anon_sym___inline] = ACTIONS(4984),
    [anon_sym___inline__] = ACTIONS(4984),
    [anon_sym___forceinline] = ACTIONS(4984),
    [anon_sym_thread_local] = ACTIONS(4984),
    [anon_sym___thread] = ACTIONS(4984),
    [anon_sym_const] = ACTIONS(4984),
    [anon_sym_constexpr] = ACTIONS(4984),
    [anon_sym_volatile] = ACTIONS(4984),
    [anon_sym_restrict] = ACTIONS(4984),
    [anon_sym___restrict__] = ACTIONS(4984),
    [anon_sym__Atomic] = ACTIONS(4984),
    [anon_sym__Noreturn] = ACTIONS(4984),
    [anon_sym_noreturn] = ACTIONS(4984),
    [anon_sym_mutable] = ACTIONS(4984),
    [anon_sym_constinit] = ACTIONS(4984),
    [anon_sym_consteval] = ACTIONS(4984),
    [anon_sym_PROGMEM] = ACTIONS(4984),
    [aux_sym_primitive_type_token1] = ACTIONS(4984),
    [anon_sym_byte] = ACTIONS(4984),
    [anon_sym_word] = ACTIONS(4984),
    [anon_sym_enum] = ACTIONS(4984),
    [anon_sym_class] = ACTIONS(4984),
    [anon_sym_struct] = ACTIONS(4984),
    [anon_sym_union] = ACTIONS(4984),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4984),
    [anon_sym_decltype] = ACTIONS(4984),
    [anon_sym_virtual] = ACTIONS(4984),
    [anon_sym_alignas] = ACTIONS(4984),
    [anon_sym_explicit] = ACTIONS(4984),
    [anon_sym_typename] = ACTIONS(4984),
    [anon_sym_template] = ACTIONS(4984),
    [anon_sym_operator] = ACTIONS(4984),
    [anon_sym_friend] = ACTIONS(4984),
    [anon_sym_public] = ACTIONS(4984),
    [anon_sym_private] = ACTIONS(4984),
    [anon_sym_protected] = ACTIONS(4984),
    [anon_sym_using] = ACTIONS(4984),
    [anon_sym_static_assert] = ACTIONS(4984),
  },
  [2063] = {
    [sym_identifier] = ACTIONS(4980),
    [aux_sym_preproc_def_token1] = ACTIONS(4980),
    [aux_sym_preproc_if_token1] = ACTIONS(4980),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4980),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4980),
    [sym_preproc_directive] = ACTIONS(4980),
    [anon_sym_LPAREN2] = ACTIONS(4982),
    [anon_sym_TILDE] = ACTIONS(4982),
    [anon_sym_STAR] = ACTIONS(4982),
    [anon_sym_AMP_AMP] = ACTIONS(4982),
    [anon_sym_AMP] = ACTIONS(4980),
    [anon_sym___extension__] = ACTIONS(4980),
    [anon_sym_typedef] = ACTIONS(4980),
    [anon_sym_extern] = ACTIONS(4980),
    [anon_sym___attribute__] = ACTIONS(4980),
    [anon_sym_COLON_COLON] = ACTIONS(4982),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4982),
    [anon_sym___declspec] = ACTIONS(4980),
    [anon_sym___based] = ACTIONS(4980),
    [anon_sym_RBRACE] = ACTIONS(4982),
    [anon_sym_signed] = ACTIONS(4980),
    [anon_sym_unsigned] = ACTIONS(4980),
    [anon_sym_long] = ACTIONS(4980),
    [anon_sym_short] = ACTIONS(4980),
    [anon_sym_LBRACK] = ACTIONS(4980),
    [anon_sym_static] = ACTIONS(4980),
    [anon_sym_register] = ACTIONS(4980),
    [anon_sym_inline] = ACTIONS(4980),
    [anon_sym___inline] = ACTIONS(4980),
    [anon_sym___inline__] = ACTIONS(4980),
    [anon_sym___forceinline] = ACTIONS(4980),
    [anon_sym_thread_local] = ACTIONS(4980),
    [anon_sym___thread] = ACTIONS(4980),
    [anon_sym_const] = ACTIONS(4980),
    [anon_sym_constexpr] = ACTIONS(4980),
    [anon_sym_volatile] = ACTIONS(4980),
    [anon_sym_restrict] = ACTIONS(4980),
    [anon_sym___restrict__] = ACTIONS(4980),
    [anon_sym__Atomic] = ACTIONS(4980),
    [anon_sym__Noreturn] = ACTIONS(4980),
    [anon_sym_noreturn] = ACTIONS(4980),
    [anon_sym_mutable] = ACTIONS(4980),
    [anon_sym_constinit] = ACTIONS(4980),
    [anon_sym_consteval] = ACTIONS(4980),
    [anon_sym_PROGMEM] = ACTIONS(4980),
    [aux_sym_primitive_type_token1] = ACTIONS(4980),
    [anon_sym_byte] = ACTIONS(4980),
    [anon_sym_word] = ACTIONS(4980),
    [anon_sym_enum] = ACTIONS(4980),
    [anon_sym_class] = ACTIONS(4980),
    [anon_sym_struct] = ACTIONS(4980),
    [anon_sym_union] = ACTIONS(4980),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4980),
    [anon_sym_decltype] = ACTIONS(4980),
    [anon_sym_virtual] = ACTIONS(4980),
    [anon_sym_alignas] = ACTIONS(4980),
    [anon_sym_explicit] = ACTIONS(4980),
    [anon_sym_typename] = ACTIONS(4980),
    [anon_sym_template] = ACTIONS(4980),
    [anon_sym_operator] = ACTIONS(4980),
    [anon_sym_friend] = ACTIONS(4980),
    [anon_sym_public] = ACTIONS(4980),
    [anon_sym_private] = ACTIONS(4980),
    [anon_sym_protected] = ACTIONS(4980),
    [anon_sym_using] = ACTIONS(4980),
    [anon_sym_static_assert] = ACTIONS(4980),
  },
  [2064] = {
    [sym_identifier] = ACTIONS(4976),
    [aux_sym_preproc_def_token1] = ACTIONS(4976),
    [aux_sym_preproc_if_token1] = ACTIONS(4976),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4976),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4976),
    [sym_preproc_directive] = ACTIONS(4976),
    [anon_sym_LPAREN2] = ACTIONS(4978),
    [anon_sym_TILDE] = ACTIONS(4978),
    [anon_sym_STAR] = ACTIONS(4978),
    [anon_sym_AMP_AMP] = ACTIONS(4978),
    [anon_sym_AMP] = ACTIONS(4976),
    [anon_sym___extension__] = ACTIONS(4976),
    [anon_sym_typedef] = ACTIONS(4976),
    [anon_sym_extern] = ACTIONS(4976),
    [anon_sym___attribute__] = ACTIONS(4976),
    [anon_sym_COLON_COLON] = ACTIONS(4978),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4978),
    [anon_sym___declspec] = ACTIONS(4976),
    [anon_sym___based] = ACTIONS(4976),
    [anon_sym_RBRACE] = ACTIONS(4978),
    [anon_sym_signed] = ACTIONS(4976),
    [anon_sym_unsigned] = ACTIONS(4976),
    [anon_sym_long] = ACTIONS(4976),
    [anon_sym_short] = ACTIONS(4976),
    [anon_sym_LBRACK] = ACTIONS(4976),
    [anon_sym_static] = ACTIONS(4976),
    [anon_sym_register] = ACTIONS(4976),
    [anon_sym_inline] = ACTIONS(4976),
    [anon_sym___inline] = ACTIONS(4976),
    [anon_sym___inline__] = ACTIONS(4976),
    [anon_sym___forceinline] = ACTIONS(4976),
    [anon_sym_thread_local] = ACTIONS(4976),
    [anon_sym___thread] = ACTIONS(4976),
    [anon_sym_const] = ACTIONS(4976),
    [anon_sym_constexpr] = ACTIONS(4976),
    [anon_sym_volatile] = ACTIONS(4976),
    [anon_sym_restrict] = ACTIONS(4976),
    [anon_sym___restrict__] = ACTIONS(4976),
    [anon_sym__Atomic] = ACTIONS(4976),
    [anon_sym__Noreturn] = ACTIONS(4976),
    [anon_sym_noreturn] = ACTIONS(4976),
    [anon_sym_mutable] = ACTIONS(4976),
    [anon_sym_constinit] = ACTIONS(4976),
    [anon_sym_consteval] = ACTIONS(4976),
    [anon_sym_PROGMEM] = ACTIONS(4976),
    [aux_sym_primitive_type_token1] = ACTIONS(4976),
    [anon_sym_byte] = ACTIONS(4976),
    [anon_sym_word] = ACTIONS(4976),
    [anon_sym_enum] = ACTIONS(4976),
    [anon_sym_class] = ACTIONS(4976),
    [anon_sym_struct] = ACTIONS(4976),
    [anon_sym_union] = ACTIONS(4976),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4976),
    [anon_sym_decltype] = ACTIONS(4976),
    [anon_sym_virtual] = ACTIONS(4976),
    [anon_sym_alignas] = ACTIONS(4976),
    [anon_sym_explicit] = ACTIONS(4976),
    [anon_sym_typename] = ACTIONS(4976),
    [anon_sym_template] = ACTIONS(4976),
    [anon_sym_operator] = ACTIONS(4976),
    [anon_sym_friend] = ACTIONS(4976),
    [anon_sym_public] = ACTIONS(4976),
    [anon_sym_private] = ACTIONS(4976),
    [anon_sym_protected] = ACTIONS(4976),
    [anon_sym_using] = ACTIONS(4976),
    [anon_sym_static_assert] = ACTIONS(4976),
  },
  [2065] = {
    [sym_identifier] = ACTIONS(3148),
    [aux_sym_preproc_def_token1] = ACTIONS(3148),
    [aux_sym_preproc_if_token1] = ACTIONS(3148),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3148),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3148),
    [sym_preproc_directive] = ACTIONS(3148),
    [anon_sym_LPAREN2] = ACTIONS(3150),
    [anon_sym_TILDE] = ACTIONS(3150),
    [anon_sym_STAR] = ACTIONS(3150),
    [anon_sym_AMP_AMP] = ACTIONS(3150),
    [anon_sym_AMP] = ACTIONS(3148),
    [anon_sym___extension__] = ACTIONS(3148),
    [anon_sym_typedef] = ACTIONS(3148),
    [anon_sym_extern] = ACTIONS(3148),
    [anon_sym___attribute__] = ACTIONS(3148),
    [anon_sym_COLON_COLON] = ACTIONS(3150),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3150),
    [anon_sym___declspec] = ACTIONS(3148),
    [anon_sym___based] = ACTIONS(3148),
    [anon_sym_RBRACE] = ACTIONS(3150),
    [anon_sym_signed] = ACTIONS(3148),
    [anon_sym_unsigned] = ACTIONS(3148),
    [anon_sym_long] = ACTIONS(3148),
    [anon_sym_short] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_static] = ACTIONS(3148),
    [anon_sym_register] = ACTIONS(3148),
    [anon_sym_inline] = ACTIONS(3148),
    [anon_sym___inline] = ACTIONS(3148),
    [anon_sym___inline__] = ACTIONS(3148),
    [anon_sym___forceinline] = ACTIONS(3148),
    [anon_sym_thread_local] = ACTIONS(3148),
    [anon_sym___thread] = ACTIONS(3148),
    [anon_sym_const] = ACTIONS(3148),
    [anon_sym_constexpr] = ACTIONS(3148),
    [anon_sym_volatile] = ACTIONS(3148),
    [anon_sym_restrict] = ACTIONS(3148),
    [anon_sym___restrict__] = ACTIONS(3148),
    [anon_sym__Atomic] = ACTIONS(3148),
    [anon_sym__Noreturn] = ACTIONS(3148),
    [anon_sym_noreturn] = ACTIONS(3148),
    [anon_sym_mutable] = ACTIONS(3148),
    [anon_sym_constinit] = ACTIONS(3148),
    [anon_sym_consteval] = ACTIONS(3148),
    [anon_sym_PROGMEM] = ACTIONS(3148),
    [aux_sym_primitive_type_token1] = ACTIONS(3148),
    [anon_sym_byte] = ACTIONS(3148),
    [anon_sym_word] = ACTIONS(3148),
    [anon_sym_enum] = ACTIONS(3148),
    [anon_sym_class] = ACTIONS(3148),
    [anon_sym_struct] = ACTIONS(3148),
    [anon_sym_union] = ACTIONS(3148),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3148),
    [anon_sym_decltype] = ACTIONS(3148),
    [anon_sym_virtual] = ACTIONS(3148),
    [anon_sym_alignas] = ACTIONS(3148),
    [anon_sym_explicit] = ACTIONS(3148),
    [anon_sym_typename] = ACTIONS(3148),
    [anon_sym_template] = ACTIONS(3148),
    [anon_sym_operator] = ACTIONS(3148),
    [anon_sym_friend] = ACTIONS(3148),
    [anon_sym_public] = ACTIONS(3148),
    [anon_sym_private] = ACTIONS(3148),
    [anon_sym_protected] = ACTIONS(3148),
    [anon_sym_using] = ACTIONS(3148),
    [anon_sym_static_assert] = ACTIONS(3148),
  },
  [2066] = {
    [sym_identifier] = ACTIONS(4972),
    [aux_sym_preproc_def_token1] = ACTIONS(4972),
    [aux_sym_preproc_if_token1] = ACTIONS(4972),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4972),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4972),
    [sym_preproc_directive] = ACTIONS(4972),
    [anon_sym_LPAREN2] = ACTIONS(4974),
    [anon_sym_TILDE] = ACTIONS(4974),
    [anon_sym_STAR] = ACTIONS(4974),
    [anon_sym_AMP_AMP] = ACTIONS(4974),
    [anon_sym_AMP] = ACTIONS(4972),
    [anon_sym___extension__] = ACTIONS(4972),
    [anon_sym_typedef] = ACTIONS(4972),
    [anon_sym_extern] = ACTIONS(4972),
    [anon_sym___attribute__] = ACTIONS(4972),
    [anon_sym_COLON_COLON] = ACTIONS(4974),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4974),
    [anon_sym___declspec] = ACTIONS(4972),
    [anon_sym___based] = ACTIONS(4972),
    [anon_sym_RBRACE] = ACTIONS(4974),
    [anon_sym_signed] = ACTIONS(4972),
    [anon_sym_unsigned] = ACTIONS(4972),
    [anon_sym_long] = ACTIONS(4972),
    [anon_sym_short] = ACTIONS(4972),
    [anon_sym_LBRACK] = ACTIONS(4972),
    [anon_sym_static] = ACTIONS(4972),
    [anon_sym_register] = ACTIONS(4972),
    [anon_sym_inline] = ACTIONS(4972),
    [anon_sym___inline] = ACTIONS(4972),
    [anon_sym___inline__] = ACTIONS(4972),
    [anon_sym___forceinline] = ACTIONS(4972),
    [anon_sym_thread_local] = ACTIONS(4972),
    [anon_sym___thread] = ACTIONS(4972),
    [anon_sym_const] = ACTIONS(4972),
    [anon_sym_constexpr] = ACTIONS(4972),
    [anon_sym_volatile] = ACTIONS(4972),
    [anon_sym_restrict] = ACTIONS(4972),
    [anon_sym___restrict__] = ACTIONS(4972),
    [anon_sym__Atomic] = ACTIONS(4972),
    [anon_sym__Noreturn] = ACTIONS(4972),
    [anon_sym_noreturn] = ACTIONS(4972),
    [anon_sym_mutable] = ACTIONS(4972),
    [anon_sym_constinit] = ACTIONS(4972),
    [anon_sym_consteval] = ACTIONS(4972),
    [anon_sym_PROGMEM] = ACTIONS(4972),
    [aux_sym_primitive_type_token1] = ACTIONS(4972),
    [anon_sym_byte] = ACTIONS(4972),
    [anon_sym_word] = ACTIONS(4972),
    [anon_sym_enum] = ACTIONS(4972),
    [anon_sym_class] = ACTIONS(4972),
    [anon_sym_struct] = ACTIONS(4972),
    [anon_sym_union] = ACTIONS(4972),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4972),
    [anon_sym_decltype] = ACTIONS(4972),
    [anon_sym_virtual] = ACTIONS(4972),
    [anon_sym_alignas] = ACTIONS(4972),
    [anon_sym_explicit] = ACTIONS(4972),
    [anon_sym_typename] = ACTIONS(4972),
    [anon_sym_template] = ACTIONS(4972),
    [anon_sym_operator] = ACTIONS(4972),
    [anon_sym_friend] = ACTIONS(4972),
    [anon_sym_public] = ACTIONS(4972),
    [anon_sym_private] = ACTIONS(4972),
    [anon_sym_protected] = ACTIONS(4972),
    [anon_sym_using] = ACTIONS(4972),
    [anon_sym_static_assert] = ACTIONS(4972),
  },
  [2067] = {
    [sym_identifier] = ACTIONS(3078),
    [aux_sym_preproc_def_token1] = ACTIONS(3078),
    [aux_sym_preproc_if_token1] = ACTIONS(3078),
    [aux_sym_preproc_if_token2] = ACTIONS(3078),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3078),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3078),
    [sym_preproc_directive] = ACTIONS(3078),
    [anon_sym_LPAREN2] = ACTIONS(3080),
    [anon_sym_TILDE] = ACTIONS(3080),
    [anon_sym_STAR] = ACTIONS(3080),
    [anon_sym_AMP_AMP] = ACTIONS(3080),
    [anon_sym_AMP] = ACTIONS(3078),
    [anon_sym___extension__] = ACTIONS(3078),
    [anon_sym_typedef] = ACTIONS(3078),
    [anon_sym_extern] = ACTIONS(3078),
    [anon_sym___attribute__] = ACTIONS(3078),
    [anon_sym_COLON_COLON] = ACTIONS(3080),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3080),
    [anon_sym___declspec] = ACTIONS(3078),
    [anon_sym___based] = ACTIONS(3078),
    [anon_sym_signed] = ACTIONS(3078),
    [anon_sym_unsigned] = ACTIONS(3078),
    [anon_sym_long] = ACTIONS(3078),
    [anon_sym_short] = ACTIONS(3078),
    [anon_sym_LBRACK] = ACTIONS(3078),
    [anon_sym_static] = ACTIONS(3078),
    [anon_sym_register] = ACTIONS(3078),
    [anon_sym_inline] = ACTIONS(3078),
    [anon_sym___inline] = ACTIONS(3078),
    [anon_sym___inline__] = ACTIONS(3078),
    [anon_sym___forceinline] = ACTIONS(3078),
    [anon_sym_thread_local] = ACTIONS(3078),
    [anon_sym___thread] = ACTIONS(3078),
    [anon_sym_const] = ACTIONS(3078),
    [anon_sym_constexpr] = ACTIONS(3078),
    [anon_sym_volatile] = ACTIONS(3078),
    [anon_sym_restrict] = ACTIONS(3078),
    [anon_sym___restrict__] = ACTIONS(3078),
    [anon_sym__Atomic] = ACTIONS(3078),
    [anon_sym__Noreturn] = ACTIONS(3078),
    [anon_sym_noreturn] = ACTIONS(3078),
    [anon_sym_mutable] = ACTIONS(3078),
    [anon_sym_constinit] = ACTIONS(3078),
    [anon_sym_consteval] = ACTIONS(3078),
    [anon_sym_PROGMEM] = ACTIONS(3078),
    [aux_sym_primitive_type_token1] = ACTIONS(3078),
    [anon_sym_byte] = ACTIONS(3078),
    [anon_sym_word] = ACTIONS(3078),
    [anon_sym_enum] = ACTIONS(3078),
    [anon_sym_class] = ACTIONS(3078),
    [anon_sym_struct] = ACTIONS(3078),
    [anon_sym_union] = ACTIONS(3078),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3078),
    [anon_sym_decltype] = ACTIONS(3078),
    [anon_sym_virtual] = ACTIONS(3078),
    [anon_sym_alignas] = ACTIONS(3078),
    [anon_sym_explicit] = ACTIONS(3078),
    [anon_sym_typename] = ACTIONS(3078),
    [anon_sym_template] = ACTIONS(3078),
    [anon_sym_operator] = ACTIONS(3078),
    [anon_sym_friend] = ACTIONS(3078),
    [anon_sym_public] = ACTIONS(3078),
    [anon_sym_private] = ACTIONS(3078),
    [anon_sym_protected] = ACTIONS(3078),
    [anon_sym_using] = ACTIONS(3078),
    [anon_sym_static_assert] = ACTIONS(3078),
  },
  [2068] = {
    [sym_identifier] = ACTIONS(3068),
    [aux_sym_preproc_def_token1] = ACTIONS(3068),
    [aux_sym_preproc_if_token1] = ACTIONS(3068),
    [aux_sym_preproc_if_token2] = ACTIONS(3068),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3068),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3068),
    [sym_preproc_directive] = ACTIONS(3068),
    [anon_sym_LPAREN2] = ACTIONS(3070),
    [anon_sym_TILDE] = ACTIONS(3070),
    [anon_sym_STAR] = ACTIONS(3070),
    [anon_sym_AMP_AMP] = ACTIONS(3070),
    [anon_sym_AMP] = ACTIONS(3068),
    [anon_sym___extension__] = ACTIONS(3068),
    [anon_sym_typedef] = ACTIONS(3068),
    [anon_sym_extern] = ACTIONS(3068),
    [anon_sym___attribute__] = ACTIONS(3068),
    [anon_sym_COLON_COLON] = ACTIONS(3070),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3070),
    [anon_sym___declspec] = ACTIONS(3068),
    [anon_sym___based] = ACTIONS(3068),
    [anon_sym_signed] = ACTIONS(3068),
    [anon_sym_unsigned] = ACTIONS(3068),
    [anon_sym_long] = ACTIONS(3068),
    [anon_sym_short] = ACTIONS(3068),
    [anon_sym_LBRACK] = ACTIONS(3068),
    [anon_sym_static] = ACTIONS(3068),
    [anon_sym_register] = ACTIONS(3068),
    [anon_sym_inline] = ACTIONS(3068),
    [anon_sym___inline] = ACTIONS(3068),
    [anon_sym___inline__] = ACTIONS(3068),
    [anon_sym___forceinline] = ACTIONS(3068),
    [anon_sym_thread_local] = ACTIONS(3068),
    [anon_sym___thread] = ACTIONS(3068),
    [anon_sym_const] = ACTIONS(3068),
    [anon_sym_constexpr] = ACTIONS(3068),
    [anon_sym_volatile] = ACTIONS(3068),
    [anon_sym_restrict] = ACTIONS(3068),
    [anon_sym___restrict__] = ACTIONS(3068),
    [anon_sym__Atomic] = ACTIONS(3068),
    [anon_sym__Noreturn] = ACTIONS(3068),
    [anon_sym_noreturn] = ACTIONS(3068),
    [anon_sym_mutable] = ACTIONS(3068),
    [anon_sym_constinit] = ACTIONS(3068),
    [anon_sym_consteval] = ACTIONS(3068),
    [anon_sym_PROGMEM] = ACTIONS(3068),
    [aux_sym_primitive_type_token1] = ACTIONS(3068),
    [anon_sym_byte] = ACTIONS(3068),
    [anon_sym_word] = ACTIONS(3068),
    [anon_sym_enum] = ACTIONS(3068),
    [anon_sym_class] = ACTIONS(3068),
    [anon_sym_struct] = ACTIONS(3068),
    [anon_sym_union] = ACTIONS(3068),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3068),
    [anon_sym_decltype] = ACTIONS(3068),
    [anon_sym_virtual] = ACTIONS(3068),
    [anon_sym_alignas] = ACTIONS(3068),
    [anon_sym_explicit] = ACTIONS(3068),
    [anon_sym_typename] = ACTIONS(3068),
    [anon_sym_template] = ACTIONS(3068),
    [anon_sym_operator] = ACTIONS(3068),
    [anon_sym_friend] = ACTIONS(3068),
    [anon_sym_public] = ACTIONS(3068),
    [anon_sym_private] = ACTIONS(3068),
    [anon_sym_protected] = ACTIONS(3068),
    [anon_sym_using] = ACTIONS(3068),
    [anon_sym_static_assert] = ACTIONS(3068),
  },
  [2069] = {
    [sym_identifier] = ACTIONS(4968),
    [aux_sym_preproc_def_token1] = ACTIONS(4968),
    [aux_sym_preproc_if_token1] = ACTIONS(4968),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4968),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4968),
    [sym_preproc_directive] = ACTIONS(4968),
    [anon_sym_LPAREN2] = ACTIONS(4970),
    [anon_sym_TILDE] = ACTIONS(4970),
    [anon_sym_STAR] = ACTIONS(4970),
    [anon_sym_AMP_AMP] = ACTIONS(4970),
    [anon_sym_AMP] = ACTIONS(4968),
    [anon_sym___extension__] = ACTIONS(4968),
    [anon_sym_typedef] = ACTIONS(4968),
    [anon_sym_extern] = ACTIONS(4968),
    [anon_sym___attribute__] = ACTIONS(4968),
    [anon_sym_COLON_COLON] = ACTIONS(4970),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4970),
    [anon_sym___declspec] = ACTIONS(4968),
    [anon_sym___based] = ACTIONS(4968),
    [anon_sym_RBRACE] = ACTIONS(4970),
    [anon_sym_signed] = ACTIONS(4968),
    [anon_sym_unsigned] = ACTIONS(4968),
    [anon_sym_long] = ACTIONS(4968),
    [anon_sym_short] = ACTIONS(4968),
    [anon_sym_LBRACK] = ACTIONS(4968),
    [anon_sym_static] = ACTIONS(4968),
    [anon_sym_register] = ACTIONS(4968),
    [anon_sym_inline] = ACTIONS(4968),
    [anon_sym___inline] = ACTIONS(4968),
    [anon_sym___inline__] = ACTIONS(4968),
    [anon_sym___forceinline] = ACTIONS(4968),
    [anon_sym_thread_local] = ACTIONS(4968),
    [anon_sym___thread] = ACTIONS(4968),
    [anon_sym_const] = ACTIONS(4968),
    [anon_sym_constexpr] = ACTIONS(4968),
    [anon_sym_volatile] = ACTIONS(4968),
    [anon_sym_restrict] = ACTIONS(4968),
    [anon_sym___restrict__] = ACTIONS(4968),
    [anon_sym__Atomic] = ACTIONS(4968),
    [anon_sym__Noreturn] = ACTIONS(4968),
    [anon_sym_noreturn] = ACTIONS(4968),
    [anon_sym_mutable] = ACTIONS(4968),
    [anon_sym_constinit] = ACTIONS(4968),
    [anon_sym_consteval] = ACTIONS(4968),
    [anon_sym_PROGMEM] = ACTIONS(4968),
    [aux_sym_primitive_type_token1] = ACTIONS(4968),
    [anon_sym_byte] = ACTIONS(4968),
    [anon_sym_word] = ACTIONS(4968),
    [anon_sym_enum] = ACTIONS(4968),
    [anon_sym_class] = ACTIONS(4968),
    [anon_sym_struct] = ACTIONS(4968),
    [anon_sym_union] = ACTIONS(4968),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4968),
    [anon_sym_decltype] = ACTIONS(4968),
    [anon_sym_virtual] = ACTIONS(4968),
    [anon_sym_alignas] = ACTIONS(4968),
    [anon_sym_explicit] = ACTIONS(4968),
    [anon_sym_typename] = ACTIONS(4968),
    [anon_sym_template] = ACTIONS(4968),
    [anon_sym_operator] = ACTIONS(4968),
    [anon_sym_friend] = ACTIONS(4968),
    [anon_sym_public] = ACTIONS(4968),
    [anon_sym_private] = ACTIONS(4968),
    [anon_sym_protected] = ACTIONS(4968),
    [anon_sym_using] = ACTIONS(4968),
    [anon_sym_static_assert] = ACTIONS(4968),
  },
  [2070] = {
    [sym_identifier] = ACTIONS(3068),
    [aux_sym_preproc_def_token1] = ACTIONS(3068),
    [aux_sym_preproc_if_token1] = ACTIONS(3068),
    [aux_sym_preproc_if_token2] = ACTIONS(3068),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3068),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3068),
    [sym_preproc_directive] = ACTIONS(3068),
    [anon_sym_LPAREN2] = ACTIONS(3070),
    [anon_sym_TILDE] = ACTIONS(3070),
    [anon_sym_STAR] = ACTIONS(3070),
    [anon_sym_AMP_AMP] = ACTIONS(3070),
    [anon_sym_AMP] = ACTIONS(3068),
    [anon_sym___extension__] = ACTIONS(3068),
    [anon_sym_typedef] = ACTIONS(3068),
    [anon_sym_extern] = ACTIONS(3068),
    [anon_sym___attribute__] = ACTIONS(3068),
    [anon_sym_COLON_COLON] = ACTIONS(3070),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3070),
    [anon_sym___declspec] = ACTIONS(3068),
    [anon_sym___based] = ACTIONS(3068),
    [anon_sym_signed] = ACTIONS(3068),
    [anon_sym_unsigned] = ACTIONS(3068),
    [anon_sym_long] = ACTIONS(3068),
    [anon_sym_short] = ACTIONS(3068),
    [anon_sym_LBRACK] = ACTIONS(3068),
    [anon_sym_static] = ACTIONS(3068),
    [anon_sym_register] = ACTIONS(3068),
    [anon_sym_inline] = ACTIONS(3068),
    [anon_sym___inline] = ACTIONS(3068),
    [anon_sym___inline__] = ACTIONS(3068),
    [anon_sym___forceinline] = ACTIONS(3068),
    [anon_sym_thread_local] = ACTIONS(3068),
    [anon_sym___thread] = ACTIONS(3068),
    [anon_sym_const] = ACTIONS(3068),
    [anon_sym_constexpr] = ACTIONS(3068),
    [anon_sym_volatile] = ACTIONS(3068),
    [anon_sym_restrict] = ACTIONS(3068),
    [anon_sym___restrict__] = ACTIONS(3068),
    [anon_sym__Atomic] = ACTIONS(3068),
    [anon_sym__Noreturn] = ACTIONS(3068),
    [anon_sym_noreturn] = ACTIONS(3068),
    [anon_sym_mutable] = ACTIONS(3068),
    [anon_sym_constinit] = ACTIONS(3068),
    [anon_sym_consteval] = ACTIONS(3068),
    [anon_sym_PROGMEM] = ACTIONS(3068),
    [aux_sym_primitive_type_token1] = ACTIONS(3068),
    [anon_sym_byte] = ACTIONS(3068),
    [anon_sym_word] = ACTIONS(3068),
    [anon_sym_enum] = ACTIONS(3068),
    [anon_sym_class] = ACTIONS(3068),
    [anon_sym_struct] = ACTIONS(3068),
    [anon_sym_union] = ACTIONS(3068),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3068),
    [anon_sym_decltype] = ACTIONS(3068),
    [anon_sym_virtual] = ACTIONS(3068),
    [anon_sym_alignas] = ACTIONS(3068),
    [anon_sym_explicit] = ACTIONS(3068),
    [anon_sym_typename] = ACTIONS(3068),
    [anon_sym_template] = ACTIONS(3068),
    [anon_sym_operator] = ACTIONS(3068),
    [anon_sym_friend] = ACTIONS(3068),
    [anon_sym_public] = ACTIONS(3068),
    [anon_sym_private] = ACTIONS(3068),
    [anon_sym_protected] = ACTIONS(3068),
    [anon_sym_using] = ACTIONS(3068),
    [anon_sym_static_assert] = ACTIONS(3068),
  },
  [2071] = {
    [sym_identifier] = ACTIONS(3008),
    [aux_sym_preproc_def_token1] = ACTIONS(3008),
    [aux_sym_preproc_if_token1] = ACTIONS(3008),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3008),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3008),
    [sym_preproc_directive] = ACTIONS(3008),
    [anon_sym_LPAREN2] = ACTIONS(3010),
    [anon_sym_TILDE] = ACTIONS(3010),
    [anon_sym_STAR] = ACTIONS(3010),
    [anon_sym_AMP_AMP] = ACTIONS(3010),
    [anon_sym_AMP] = ACTIONS(3008),
    [anon_sym___extension__] = ACTIONS(3008),
    [anon_sym_typedef] = ACTIONS(3008),
    [anon_sym_extern] = ACTIONS(3008),
    [anon_sym___attribute__] = ACTIONS(3008),
    [anon_sym_COLON_COLON] = ACTIONS(3010),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3010),
    [anon_sym___declspec] = ACTIONS(3008),
    [anon_sym___based] = ACTIONS(3008),
    [anon_sym_RBRACE] = ACTIONS(3010),
    [anon_sym_signed] = ACTIONS(3008),
    [anon_sym_unsigned] = ACTIONS(3008),
    [anon_sym_long] = ACTIONS(3008),
    [anon_sym_short] = ACTIONS(3008),
    [anon_sym_LBRACK] = ACTIONS(3008),
    [anon_sym_static] = ACTIONS(3008),
    [anon_sym_register] = ACTIONS(3008),
    [anon_sym_inline] = ACTIONS(3008),
    [anon_sym___inline] = ACTIONS(3008),
    [anon_sym___inline__] = ACTIONS(3008),
    [anon_sym___forceinline] = ACTIONS(3008),
    [anon_sym_thread_local] = ACTIONS(3008),
    [anon_sym___thread] = ACTIONS(3008),
    [anon_sym_const] = ACTIONS(3008),
    [anon_sym_constexpr] = ACTIONS(3008),
    [anon_sym_volatile] = ACTIONS(3008),
    [anon_sym_restrict] = ACTIONS(3008),
    [anon_sym___restrict__] = ACTIONS(3008),
    [anon_sym__Atomic] = ACTIONS(3008),
    [anon_sym__Noreturn] = ACTIONS(3008),
    [anon_sym_noreturn] = ACTIONS(3008),
    [anon_sym_mutable] = ACTIONS(3008),
    [anon_sym_constinit] = ACTIONS(3008),
    [anon_sym_consteval] = ACTIONS(3008),
    [anon_sym_PROGMEM] = ACTIONS(3008),
    [aux_sym_primitive_type_token1] = ACTIONS(3008),
    [anon_sym_byte] = ACTIONS(3008),
    [anon_sym_word] = ACTIONS(3008),
    [anon_sym_enum] = ACTIONS(3008),
    [anon_sym_class] = ACTIONS(3008),
    [anon_sym_struct] = ACTIONS(3008),
    [anon_sym_union] = ACTIONS(3008),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3008),
    [anon_sym_decltype] = ACTIONS(3008),
    [anon_sym_virtual] = ACTIONS(3008),
    [anon_sym_alignas] = ACTIONS(3008),
    [anon_sym_explicit] = ACTIONS(3008),
    [anon_sym_typename] = ACTIONS(3008),
    [anon_sym_template] = ACTIONS(3008),
    [anon_sym_operator] = ACTIONS(3008),
    [anon_sym_friend] = ACTIONS(3008),
    [anon_sym_public] = ACTIONS(3008),
    [anon_sym_private] = ACTIONS(3008),
    [anon_sym_protected] = ACTIONS(3008),
    [anon_sym_using] = ACTIONS(3008),
    [anon_sym_static_assert] = ACTIONS(3008),
  },
  [2072] = {
    [sym_identifier] = ACTIONS(3016),
    [aux_sym_preproc_def_token1] = ACTIONS(3016),
    [aux_sym_preproc_if_token1] = ACTIONS(3016),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3016),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3016),
    [sym_preproc_directive] = ACTIONS(3016),
    [anon_sym_LPAREN2] = ACTIONS(3018),
    [anon_sym_TILDE] = ACTIONS(3018),
    [anon_sym_STAR] = ACTIONS(3018),
    [anon_sym_AMP_AMP] = ACTIONS(3018),
    [anon_sym_AMP] = ACTIONS(3016),
    [anon_sym___extension__] = ACTIONS(3016),
    [anon_sym_typedef] = ACTIONS(3016),
    [anon_sym_extern] = ACTIONS(3016),
    [anon_sym___attribute__] = ACTIONS(3016),
    [anon_sym_COLON_COLON] = ACTIONS(3018),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3018),
    [anon_sym___declspec] = ACTIONS(3016),
    [anon_sym___based] = ACTIONS(3016),
    [anon_sym_RBRACE] = ACTIONS(3018),
    [anon_sym_signed] = ACTIONS(3016),
    [anon_sym_unsigned] = ACTIONS(3016),
    [anon_sym_long] = ACTIONS(3016),
    [anon_sym_short] = ACTIONS(3016),
    [anon_sym_LBRACK] = ACTIONS(3016),
    [anon_sym_static] = ACTIONS(3016),
    [anon_sym_register] = ACTIONS(3016),
    [anon_sym_inline] = ACTIONS(3016),
    [anon_sym___inline] = ACTIONS(3016),
    [anon_sym___inline__] = ACTIONS(3016),
    [anon_sym___forceinline] = ACTIONS(3016),
    [anon_sym_thread_local] = ACTIONS(3016),
    [anon_sym___thread] = ACTIONS(3016),
    [anon_sym_const] = ACTIONS(3016),
    [anon_sym_constexpr] = ACTIONS(3016),
    [anon_sym_volatile] = ACTIONS(3016),
    [anon_sym_restrict] = ACTIONS(3016),
    [anon_sym___restrict__] = ACTIONS(3016),
    [anon_sym__Atomic] = ACTIONS(3016),
    [anon_sym__Noreturn] = ACTIONS(3016),
    [anon_sym_noreturn] = ACTIONS(3016),
    [anon_sym_mutable] = ACTIONS(3016),
    [anon_sym_constinit] = ACTIONS(3016),
    [anon_sym_consteval] = ACTIONS(3016),
    [anon_sym_PROGMEM] = ACTIONS(3016),
    [aux_sym_primitive_type_token1] = ACTIONS(3016),
    [anon_sym_byte] = ACTIONS(3016),
    [anon_sym_word] = ACTIONS(3016),
    [anon_sym_enum] = ACTIONS(3016),
    [anon_sym_class] = ACTIONS(3016),
    [anon_sym_struct] = ACTIONS(3016),
    [anon_sym_union] = ACTIONS(3016),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3016),
    [anon_sym_decltype] = ACTIONS(3016),
    [anon_sym_virtual] = ACTIONS(3016),
    [anon_sym_alignas] = ACTIONS(3016),
    [anon_sym_explicit] = ACTIONS(3016),
    [anon_sym_typename] = ACTIONS(3016),
    [anon_sym_template] = ACTIONS(3016),
    [anon_sym_operator] = ACTIONS(3016),
    [anon_sym_friend] = ACTIONS(3016),
    [anon_sym_public] = ACTIONS(3016),
    [anon_sym_private] = ACTIONS(3016),
    [anon_sym_protected] = ACTIONS(3016),
    [anon_sym_using] = ACTIONS(3016),
    [anon_sym_static_assert] = ACTIONS(3016),
  },
  [2073] = {
    [sym_identifier] = ACTIONS(2967),
    [aux_sym_preproc_def_token1] = ACTIONS(2967),
    [aux_sym_preproc_if_token1] = ACTIONS(2967),
    [aux_sym_preproc_if_token2] = ACTIONS(2967),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2967),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2967),
    [sym_preproc_directive] = ACTIONS(2967),
    [anon_sym_LPAREN2] = ACTIONS(2969),
    [anon_sym_TILDE] = ACTIONS(2969),
    [anon_sym_STAR] = ACTIONS(2969),
    [anon_sym_AMP_AMP] = ACTIONS(2969),
    [anon_sym_AMP] = ACTIONS(2967),
    [anon_sym___extension__] = ACTIONS(2967),
    [anon_sym_typedef] = ACTIONS(2967),
    [anon_sym_extern] = ACTIONS(2967),
    [anon_sym___attribute__] = ACTIONS(2967),
    [anon_sym_COLON_COLON] = ACTIONS(2969),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2969),
    [anon_sym___declspec] = ACTIONS(2967),
    [anon_sym___based] = ACTIONS(2967),
    [anon_sym_signed] = ACTIONS(2967),
    [anon_sym_unsigned] = ACTIONS(2967),
    [anon_sym_long] = ACTIONS(2967),
    [anon_sym_short] = ACTIONS(2967),
    [anon_sym_LBRACK] = ACTIONS(2967),
    [anon_sym_static] = ACTIONS(2967),
    [anon_sym_register] = ACTIONS(2967),
    [anon_sym_inline] = ACTIONS(2967),
    [anon_sym___inline] = ACTIONS(2967),
    [anon_sym___inline__] = ACTIONS(2967),
    [anon_sym___forceinline] = ACTIONS(2967),
    [anon_sym_thread_local] = ACTIONS(2967),
    [anon_sym___thread] = ACTIONS(2967),
    [anon_sym_const] = ACTIONS(2967),
    [anon_sym_constexpr] = ACTIONS(2967),
    [anon_sym_volatile] = ACTIONS(2967),
    [anon_sym_restrict] = ACTIONS(2967),
    [anon_sym___restrict__] = ACTIONS(2967),
    [anon_sym__Atomic] = ACTIONS(2967),
    [anon_sym__Noreturn] = ACTIONS(2967),
    [anon_sym_noreturn] = ACTIONS(2967),
    [anon_sym_mutable] = ACTIONS(2967),
    [anon_sym_constinit] = ACTIONS(2967),
    [anon_sym_consteval] = ACTIONS(2967),
    [anon_sym_PROGMEM] = ACTIONS(2967),
    [aux_sym_primitive_type_token1] = ACTIONS(2967),
    [anon_sym_byte] = ACTIONS(2967),
    [anon_sym_word] = ACTIONS(2967),
    [anon_sym_enum] = ACTIONS(2967),
    [anon_sym_class] = ACTIONS(2967),
    [anon_sym_struct] = ACTIONS(2967),
    [anon_sym_union] = ACTIONS(2967),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2967),
    [anon_sym_decltype] = ACTIONS(2967),
    [anon_sym_virtual] = ACTIONS(2967),
    [anon_sym_alignas] = ACTIONS(2967),
    [anon_sym_explicit] = ACTIONS(2967),
    [anon_sym_typename] = ACTIONS(2967),
    [anon_sym_template] = ACTIONS(2967),
    [anon_sym_operator] = ACTIONS(2967),
    [anon_sym_friend] = ACTIONS(2967),
    [anon_sym_public] = ACTIONS(2967),
    [anon_sym_private] = ACTIONS(2967),
    [anon_sym_protected] = ACTIONS(2967),
    [anon_sym_using] = ACTIONS(2967),
    [anon_sym_static_assert] = ACTIONS(2967),
  },
  [2074] = {
    [sym_identifier] = ACTIONS(3082),
    [aux_sym_preproc_def_token1] = ACTIONS(3082),
    [aux_sym_preproc_if_token1] = ACTIONS(3082),
    [aux_sym_preproc_if_token2] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3082),
    [sym_preproc_directive] = ACTIONS(3082),
    [anon_sym_LPAREN2] = ACTIONS(3084),
    [anon_sym_TILDE] = ACTIONS(3084),
    [anon_sym_STAR] = ACTIONS(3084),
    [anon_sym_AMP_AMP] = ACTIONS(3084),
    [anon_sym_AMP] = ACTIONS(3082),
    [anon_sym___extension__] = ACTIONS(3082),
    [anon_sym_typedef] = ACTIONS(3082),
    [anon_sym_extern] = ACTIONS(3082),
    [anon_sym___attribute__] = ACTIONS(3082),
    [anon_sym_COLON_COLON] = ACTIONS(3084),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3084),
    [anon_sym___declspec] = ACTIONS(3082),
    [anon_sym___based] = ACTIONS(3082),
    [anon_sym_signed] = ACTIONS(3082),
    [anon_sym_unsigned] = ACTIONS(3082),
    [anon_sym_long] = ACTIONS(3082),
    [anon_sym_short] = ACTIONS(3082),
    [anon_sym_LBRACK] = ACTIONS(3082),
    [anon_sym_static] = ACTIONS(3082),
    [anon_sym_register] = ACTIONS(3082),
    [anon_sym_inline] = ACTIONS(3082),
    [anon_sym___inline] = ACTIONS(3082),
    [anon_sym___inline__] = ACTIONS(3082),
    [anon_sym___forceinline] = ACTIONS(3082),
    [anon_sym_thread_local] = ACTIONS(3082),
    [anon_sym___thread] = ACTIONS(3082),
    [anon_sym_const] = ACTIONS(3082),
    [anon_sym_constexpr] = ACTIONS(3082),
    [anon_sym_volatile] = ACTIONS(3082),
    [anon_sym_restrict] = ACTIONS(3082),
    [anon_sym___restrict__] = ACTIONS(3082),
    [anon_sym__Atomic] = ACTIONS(3082),
    [anon_sym__Noreturn] = ACTIONS(3082),
    [anon_sym_noreturn] = ACTIONS(3082),
    [anon_sym_mutable] = ACTIONS(3082),
    [anon_sym_constinit] = ACTIONS(3082),
    [anon_sym_consteval] = ACTIONS(3082),
    [anon_sym_PROGMEM] = ACTIONS(3082),
    [aux_sym_primitive_type_token1] = ACTIONS(3082),
    [anon_sym_byte] = ACTIONS(3082),
    [anon_sym_word] = ACTIONS(3082),
    [anon_sym_enum] = ACTIONS(3082),
    [anon_sym_class] = ACTIONS(3082),
    [anon_sym_struct] = ACTIONS(3082),
    [anon_sym_union] = ACTIONS(3082),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3082),
    [anon_sym_decltype] = ACTIONS(3082),
    [anon_sym_virtual] = ACTIONS(3082),
    [anon_sym_alignas] = ACTIONS(3082),
    [anon_sym_explicit] = ACTIONS(3082),
    [anon_sym_typename] = ACTIONS(3082),
    [anon_sym_template] = ACTIONS(3082),
    [anon_sym_operator] = ACTIONS(3082),
    [anon_sym_friend] = ACTIONS(3082),
    [anon_sym_public] = ACTIONS(3082),
    [anon_sym_private] = ACTIONS(3082),
    [anon_sym_protected] = ACTIONS(3082),
    [anon_sym_using] = ACTIONS(3082),
    [anon_sym_static_assert] = ACTIONS(3082),
  },
  [2075] = {
    [sym_identifier] = ACTIONS(4886),
    [aux_sym_preproc_def_token1] = ACTIONS(4886),
    [aux_sym_preproc_if_token1] = ACTIONS(4886),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4886),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4886),
    [sym_preproc_directive] = ACTIONS(4886),
    [anon_sym_LPAREN2] = ACTIONS(4888),
    [anon_sym_TILDE] = ACTIONS(4888),
    [anon_sym_STAR] = ACTIONS(4888),
    [anon_sym_AMP_AMP] = ACTIONS(4888),
    [anon_sym_AMP] = ACTIONS(4886),
    [anon_sym___extension__] = ACTIONS(4886),
    [anon_sym_typedef] = ACTIONS(4886),
    [anon_sym_extern] = ACTIONS(4886),
    [anon_sym___attribute__] = ACTIONS(4886),
    [anon_sym_COLON_COLON] = ACTIONS(4888),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4888),
    [anon_sym___declspec] = ACTIONS(4886),
    [anon_sym___based] = ACTIONS(4886),
    [anon_sym_RBRACE] = ACTIONS(4888),
    [anon_sym_signed] = ACTIONS(4886),
    [anon_sym_unsigned] = ACTIONS(4886),
    [anon_sym_long] = ACTIONS(4886),
    [anon_sym_short] = ACTIONS(4886),
    [anon_sym_LBRACK] = ACTIONS(4886),
    [anon_sym_static] = ACTIONS(4886),
    [anon_sym_register] = ACTIONS(4886),
    [anon_sym_inline] = ACTIONS(4886),
    [anon_sym___inline] = ACTIONS(4886),
    [anon_sym___inline__] = ACTIONS(4886),
    [anon_sym___forceinline] = ACTIONS(4886),
    [anon_sym_thread_local] = ACTIONS(4886),
    [anon_sym___thread] = ACTIONS(4886),
    [anon_sym_const] = ACTIONS(4886),
    [anon_sym_constexpr] = ACTIONS(4886),
    [anon_sym_volatile] = ACTIONS(4886),
    [anon_sym_restrict] = ACTIONS(4886),
    [anon_sym___restrict__] = ACTIONS(4886),
    [anon_sym__Atomic] = ACTIONS(4886),
    [anon_sym__Noreturn] = ACTIONS(4886),
    [anon_sym_noreturn] = ACTIONS(4886),
    [anon_sym_mutable] = ACTIONS(4886),
    [anon_sym_constinit] = ACTIONS(4886),
    [anon_sym_consteval] = ACTIONS(4886),
    [anon_sym_PROGMEM] = ACTIONS(4886),
    [aux_sym_primitive_type_token1] = ACTIONS(4886),
    [anon_sym_byte] = ACTIONS(4886),
    [anon_sym_word] = ACTIONS(4886),
    [anon_sym_enum] = ACTIONS(4886),
    [anon_sym_class] = ACTIONS(4886),
    [anon_sym_struct] = ACTIONS(4886),
    [anon_sym_union] = ACTIONS(4886),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4886),
    [anon_sym_decltype] = ACTIONS(4886),
    [anon_sym_virtual] = ACTIONS(4886),
    [anon_sym_alignas] = ACTIONS(4886),
    [anon_sym_explicit] = ACTIONS(4886),
    [anon_sym_typename] = ACTIONS(4886),
    [anon_sym_template] = ACTIONS(4886),
    [anon_sym_operator] = ACTIONS(4886),
    [anon_sym_friend] = ACTIONS(4886),
    [anon_sym_public] = ACTIONS(4886),
    [anon_sym_private] = ACTIONS(4886),
    [anon_sym_protected] = ACTIONS(4886),
    [anon_sym_using] = ACTIONS(4886),
    [anon_sym_static_assert] = ACTIONS(4886),
  },
  [2076] = {
    [sym_identifier] = ACTIONS(2735),
    [aux_sym_preproc_def_token1] = ACTIONS(2735),
    [aux_sym_preproc_if_token1] = ACTIONS(2735),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2735),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2735),
    [sym_preproc_directive] = ACTIONS(2735),
    [anon_sym_LPAREN2] = ACTIONS(2737),
    [anon_sym_TILDE] = ACTIONS(2737),
    [anon_sym_STAR] = ACTIONS(2737),
    [anon_sym_AMP_AMP] = ACTIONS(2737),
    [anon_sym_AMP] = ACTIONS(2735),
    [anon_sym___extension__] = ACTIONS(2735),
    [anon_sym_typedef] = ACTIONS(2735),
    [anon_sym_extern] = ACTIONS(2735),
    [anon_sym___attribute__] = ACTIONS(2735),
    [anon_sym_COLON_COLON] = ACTIONS(2737),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2737),
    [anon_sym___declspec] = ACTIONS(2735),
    [anon_sym___based] = ACTIONS(2735),
    [anon_sym_RBRACE] = ACTIONS(2737),
    [anon_sym_signed] = ACTIONS(2735),
    [anon_sym_unsigned] = ACTIONS(2735),
    [anon_sym_long] = ACTIONS(2735),
    [anon_sym_short] = ACTIONS(2735),
    [anon_sym_LBRACK] = ACTIONS(2735),
    [anon_sym_static] = ACTIONS(2735),
    [anon_sym_register] = ACTIONS(2735),
    [anon_sym_inline] = ACTIONS(2735),
    [anon_sym___inline] = ACTIONS(2735),
    [anon_sym___inline__] = ACTIONS(2735),
    [anon_sym___forceinline] = ACTIONS(2735),
    [anon_sym_thread_local] = ACTIONS(2735),
    [anon_sym___thread] = ACTIONS(2735),
    [anon_sym_const] = ACTIONS(2735),
    [anon_sym_constexpr] = ACTIONS(2735),
    [anon_sym_volatile] = ACTIONS(2735),
    [anon_sym_restrict] = ACTIONS(2735),
    [anon_sym___restrict__] = ACTIONS(2735),
    [anon_sym__Atomic] = ACTIONS(2735),
    [anon_sym__Noreturn] = ACTIONS(2735),
    [anon_sym_noreturn] = ACTIONS(2735),
    [anon_sym_mutable] = ACTIONS(2735),
    [anon_sym_constinit] = ACTIONS(2735),
    [anon_sym_consteval] = ACTIONS(2735),
    [anon_sym_PROGMEM] = ACTIONS(2735),
    [aux_sym_primitive_type_token1] = ACTIONS(2735),
    [anon_sym_byte] = ACTIONS(2735),
    [anon_sym_word] = ACTIONS(2735),
    [anon_sym_enum] = ACTIONS(2735),
    [anon_sym_class] = ACTIONS(2735),
    [anon_sym_struct] = ACTIONS(2735),
    [anon_sym_union] = ACTIONS(2735),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2735),
    [anon_sym_decltype] = ACTIONS(2735),
    [anon_sym_virtual] = ACTIONS(2735),
    [anon_sym_alignas] = ACTIONS(2735),
    [anon_sym_explicit] = ACTIONS(2735),
    [anon_sym_typename] = ACTIONS(2735),
    [anon_sym_template] = ACTIONS(2735),
    [anon_sym_operator] = ACTIONS(2735),
    [anon_sym_friend] = ACTIONS(2735),
    [anon_sym_public] = ACTIONS(2735),
    [anon_sym_private] = ACTIONS(2735),
    [anon_sym_protected] = ACTIONS(2735),
    [anon_sym_using] = ACTIONS(2735),
    [anon_sym_static_assert] = ACTIONS(2735),
  },
  [2077] = {
    [sym_identifier] = ACTIONS(3020),
    [aux_sym_preproc_def_token1] = ACTIONS(3020),
    [aux_sym_preproc_if_token1] = ACTIONS(3020),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3020),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3020),
    [sym_preproc_directive] = ACTIONS(3020),
    [anon_sym_LPAREN2] = ACTIONS(3022),
    [anon_sym_TILDE] = ACTIONS(3022),
    [anon_sym_STAR] = ACTIONS(3022),
    [anon_sym_AMP_AMP] = ACTIONS(3022),
    [anon_sym_AMP] = ACTIONS(3020),
    [anon_sym___extension__] = ACTIONS(3020),
    [anon_sym_typedef] = ACTIONS(3020),
    [anon_sym_extern] = ACTIONS(3020),
    [anon_sym___attribute__] = ACTIONS(3020),
    [anon_sym_COLON_COLON] = ACTIONS(3022),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3022),
    [anon_sym___declspec] = ACTIONS(3020),
    [anon_sym___based] = ACTIONS(3020),
    [anon_sym_RBRACE] = ACTIONS(3022),
    [anon_sym_signed] = ACTIONS(3020),
    [anon_sym_unsigned] = ACTIONS(3020),
    [anon_sym_long] = ACTIONS(3020),
    [anon_sym_short] = ACTIONS(3020),
    [anon_sym_LBRACK] = ACTIONS(3020),
    [anon_sym_static] = ACTIONS(3020),
    [anon_sym_register] = ACTIONS(3020),
    [anon_sym_inline] = ACTIONS(3020),
    [anon_sym___inline] = ACTIONS(3020),
    [anon_sym___inline__] = ACTIONS(3020),
    [anon_sym___forceinline] = ACTIONS(3020),
    [anon_sym_thread_local] = ACTIONS(3020),
    [anon_sym___thread] = ACTIONS(3020),
    [anon_sym_const] = ACTIONS(3020),
    [anon_sym_constexpr] = ACTIONS(3020),
    [anon_sym_volatile] = ACTIONS(3020),
    [anon_sym_restrict] = ACTIONS(3020),
    [anon_sym___restrict__] = ACTIONS(3020),
    [anon_sym__Atomic] = ACTIONS(3020),
    [anon_sym__Noreturn] = ACTIONS(3020),
    [anon_sym_noreturn] = ACTIONS(3020),
    [anon_sym_mutable] = ACTIONS(3020),
    [anon_sym_constinit] = ACTIONS(3020),
    [anon_sym_consteval] = ACTIONS(3020),
    [anon_sym_PROGMEM] = ACTIONS(3020),
    [aux_sym_primitive_type_token1] = ACTIONS(3020),
    [anon_sym_byte] = ACTIONS(3020),
    [anon_sym_word] = ACTIONS(3020),
    [anon_sym_enum] = ACTIONS(3020),
    [anon_sym_class] = ACTIONS(3020),
    [anon_sym_struct] = ACTIONS(3020),
    [anon_sym_union] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3020),
    [anon_sym_decltype] = ACTIONS(3020),
    [anon_sym_virtual] = ACTIONS(3020),
    [anon_sym_alignas] = ACTIONS(3020),
    [anon_sym_explicit] = ACTIONS(3020),
    [anon_sym_typename] = ACTIONS(3020),
    [anon_sym_template] = ACTIONS(3020),
    [anon_sym_operator] = ACTIONS(3020),
    [anon_sym_friend] = ACTIONS(3020),
    [anon_sym_public] = ACTIONS(3020),
    [anon_sym_private] = ACTIONS(3020),
    [anon_sym_protected] = ACTIONS(3020),
    [anon_sym_using] = ACTIONS(3020),
    [anon_sym_static_assert] = ACTIONS(3020),
  },
  [2078] = {
    [sym_identifier] = ACTIONS(3556),
    [aux_sym_preproc_def_token1] = ACTIONS(3556),
    [aux_sym_preproc_if_token1] = ACTIONS(3556),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3556),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3556),
    [sym_preproc_directive] = ACTIONS(3556),
    [anon_sym_LPAREN2] = ACTIONS(3554),
    [anon_sym_TILDE] = ACTIONS(3554),
    [anon_sym_STAR] = ACTIONS(3554),
    [anon_sym_AMP_AMP] = ACTIONS(3554),
    [anon_sym_AMP] = ACTIONS(3556),
    [anon_sym___extension__] = ACTIONS(3556),
    [anon_sym_typedef] = ACTIONS(3556),
    [anon_sym_extern] = ACTIONS(3556),
    [anon_sym___attribute__] = ACTIONS(3556),
    [anon_sym_COLON_COLON] = ACTIONS(3554),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3554),
    [anon_sym___declspec] = ACTIONS(3556),
    [anon_sym___based] = ACTIONS(3556),
    [anon_sym_RBRACE] = ACTIONS(3554),
    [anon_sym_signed] = ACTIONS(3556),
    [anon_sym_unsigned] = ACTIONS(3556),
    [anon_sym_long] = ACTIONS(3556),
    [anon_sym_short] = ACTIONS(3556),
    [anon_sym_LBRACK] = ACTIONS(3556),
    [anon_sym_static] = ACTIONS(3556),
    [anon_sym_register] = ACTIONS(3556),
    [anon_sym_inline] = ACTIONS(3556),
    [anon_sym___inline] = ACTIONS(3556),
    [anon_sym___inline__] = ACTIONS(3556),
    [anon_sym___forceinline] = ACTIONS(3556),
    [anon_sym_thread_local] = ACTIONS(3556),
    [anon_sym___thread] = ACTIONS(3556),
    [anon_sym_const] = ACTIONS(3556),
    [anon_sym_constexpr] = ACTIONS(3556),
    [anon_sym_volatile] = ACTIONS(3556),
    [anon_sym_restrict] = ACTIONS(3556),
    [anon_sym___restrict__] = ACTIONS(3556),
    [anon_sym__Atomic] = ACTIONS(3556),
    [anon_sym__Noreturn] = ACTIONS(3556),
    [anon_sym_noreturn] = ACTIONS(3556),
    [anon_sym_mutable] = ACTIONS(3556),
    [anon_sym_constinit] = ACTIONS(3556),
    [anon_sym_consteval] = ACTIONS(3556),
    [anon_sym_PROGMEM] = ACTIONS(3556),
    [aux_sym_primitive_type_token1] = ACTIONS(3556),
    [anon_sym_byte] = ACTIONS(3556),
    [anon_sym_word] = ACTIONS(3556),
    [anon_sym_enum] = ACTIONS(3556),
    [anon_sym_class] = ACTIONS(3556),
    [anon_sym_struct] = ACTIONS(3556),
    [anon_sym_union] = ACTIONS(3556),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3556),
    [anon_sym_decltype] = ACTIONS(3556),
    [anon_sym_virtual] = ACTIONS(3556),
    [anon_sym_alignas] = ACTIONS(3556),
    [anon_sym_explicit] = ACTIONS(3556),
    [anon_sym_typename] = ACTIONS(3556),
    [anon_sym_template] = ACTIONS(3556),
    [anon_sym_operator] = ACTIONS(3556),
    [anon_sym_friend] = ACTIONS(3556),
    [anon_sym_public] = ACTIONS(3556),
    [anon_sym_private] = ACTIONS(3556),
    [anon_sym_protected] = ACTIONS(3556),
    [anon_sym_using] = ACTIONS(3556),
    [anon_sym_static_assert] = ACTIONS(3556),
  },
  [2079] = {
    [sym_string_literal] = STATE(2248),
    [sym_raw_string_literal] = STATE(2248),
    [aux_sym_concatenated_string_repeat1] = STATE(2248),
    [sym_identifier] = ACTIONS(5277),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4777),
    [anon_sym_COMMA] = ACTIONS(4777),
    [anon_sym_RPAREN] = ACTIONS(4777),
    [anon_sym_LPAREN2] = ACTIONS(4777),
    [anon_sym_DASH] = ACTIONS(4779),
    [anon_sym_PLUS] = ACTIONS(4779),
    [anon_sym_STAR] = ACTIONS(4779),
    [anon_sym_SLASH] = ACTIONS(4779),
    [anon_sym_PERCENT] = ACTIONS(4779),
    [anon_sym_PIPE_PIPE] = ACTIONS(4777),
    [anon_sym_AMP_AMP] = ACTIONS(4777),
    [anon_sym_PIPE] = ACTIONS(4779),
    [anon_sym_CARET] = ACTIONS(4779),
    [anon_sym_AMP] = ACTIONS(4779),
    [anon_sym_EQ_EQ] = ACTIONS(4777),
    [anon_sym_BANG_EQ] = ACTIONS(4777),
    [anon_sym_GT] = ACTIONS(4779),
    [anon_sym_GT_EQ] = ACTIONS(4777),
    [anon_sym_LT_EQ] = ACTIONS(4779),
    [anon_sym_LT] = ACTIONS(4779),
    [anon_sym_LT_LT] = ACTIONS(4779),
    [anon_sym_GT_GT] = ACTIONS(4779),
    [anon_sym_LBRACK] = ACTIONS(4777),
    [anon_sym_EQ] = ACTIONS(4779),
    [anon_sym_QMARK] = ACTIONS(4777),
    [anon_sym_STAR_EQ] = ACTIONS(4777),
    [anon_sym_SLASH_EQ] = ACTIONS(4777),
    [anon_sym_PERCENT_EQ] = ACTIONS(4777),
    [anon_sym_PLUS_EQ] = ACTIONS(4777),
    [anon_sym_DASH_EQ] = ACTIONS(4777),
    [anon_sym_LT_LT_EQ] = ACTIONS(4777),
    [anon_sym_GT_GT_EQ] = ACTIONS(4777),
    [anon_sym_AMP_EQ] = ACTIONS(4777),
    [anon_sym_CARET_EQ] = ACTIONS(4777),
    [anon_sym_PIPE_EQ] = ACTIONS(4777),
    [anon_sym_and_eq] = ACTIONS(4779),
    [anon_sym_or_eq] = ACTIONS(4779),
    [anon_sym_xor_eq] = ACTIONS(4779),
    [anon_sym_LT_EQ_GT] = ACTIONS(4777),
    [anon_sym_or] = ACTIONS(4779),
    [anon_sym_and] = ACTIONS(4779),
    [anon_sym_bitor] = ACTIONS(4779),
    [anon_sym_xor] = ACTIONS(4779),
    [anon_sym_bitand] = ACTIONS(4779),
    [anon_sym_not_eq] = ACTIONS(4779),
    [anon_sym_DASH_DASH] = ACTIONS(4777),
    [anon_sym_PLUS_PLUS] = ACTIONS(4777),
    [anon_sym_DOT] = ACTIONS(4779),
    [anon_sym_DOT_STAR] = ACTIONS(4777),
    [anon_sym_DASH_GT] = ACTIONS(4779),
    [anon_sym_L_DQUOTE] = ACTIONS(4605),
    [anon_sym_u_DQUOTE] = ACTIONS(4605),
    [anon_sym_U_DQUOTE] = ACTIONS(4605),
    [anon_sym_u8_DQUOTE] = ACTIONS(4605),
    [anon_sym_DQUOTE] = ACTIONS(4605),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4607),
    [anon_sym_LR_DQUOTE] = ACTIONS(4607),
    [anon_sym_uR_DQUOTE] = ACTIONS(4607),
    [anon_sym_UR_DQUOTE] = ACTIONS(4607),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4607),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4777),
    [sym_literal_suffix] = ACTIONS(4779),
  },
  [2080] = {
    [sym_string_literal] = STATE(2617),
    [sym_template_argument_list] = STATE(3723),
    [sym_raw_string_literal] = STATE(2617),
    [aux_sym_structured_binding_declarator_repeat1] = STATE(7216),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3761),
    [anon_sym_COMMA] = ACTIONS(5279),
    [anon_sym_LPAREN2] = ACTIONS(3761),
    [anon_sym_DASH] = ACTIONS(3769),
    [anon_sym_PLUS] = ACTIONS(3769),
    [anon_sym_STAR] = ACTIONS(3769),
    [anon_sym_SLASH] = ACTIONS(3769),
    [anon_sym_PERCENT] = ACTIONS(3769),
    [anon_sym_PIPE_PIPE] = ACTIONS(3761),
    [anon_sym_AMP_AMP] = ACTIONS(3761),
    [anon_sym_PIPE] = ACTIONS(3769),
    [anon_sym_CARET] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(3769),
    [anon_sym_EQ_EQ] = ACTIONS(3761),
    [anon_sym_BANG_EQ] = ACTIONS(3761),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3761),
    [anon_sym_LT_EQ] = ACTIONS(3769),
    [anon_sym_LT] = ACTIONS(5242),
    [anon_sym_LT_LT] = ACTIONS(3769),
    [anon_sym_GT_GT] = ACTIONS(3769),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(3785),
    [anon_sym_LBRACK] = ACTIONS(3761),
    [anon_sym_RBRACK] = ACTIONS(5282),
    [anon_sym_EQ] = ACTIONS(5285),
    [anon_sym_QMARK] = ACTIONS(3761),
    [anon_sym_STAR_EQ] = ACTIONS(5287),
    [anon_sym_SLASH_EQ] = ACTIONS(5287),
    [anon_sym_PERCENT_EQ] = ACTIONS(5287),
    [anon_sym_PLUS_EQ] = ACTIONS(5287),
    [anon_sym_DASH_EQ] = ACTIONS(5287),
    [anon_sym_LT_LT_EQ] = ACTIONS(5287),
    [anon_sym_GT_GT_EQ] = ACTIONS(5287),
    [anon_sym_AMP_EQ] = ACTIONS(5287),
    [anon_sym_CARET_EQ] = ACTIONS(5287),
    [anon_sym_PIPE_EQ] = ACTIONS(5287),
    [anon_sym_and_eq] = ACTIONS(5287),
    [anon_sym_or_eq] = ACTIONS(5287),
    [anon_sym_xor_eq] = ACTIONS(5287),
    [anon_sym_LT_EQ_GT] = ACTIONS(3761),
    [anon_sym_or] = ACTIONS(3769),
    [anon_sym_and] = ACTIONS(3769),
    [anon_sym_bitor] = ACTIONS(3761),
    [anon_sym_xor] = ACTIONS(3769),
    [anon_sym_bitand] = ACTIONS(3761),
    [anon_sym_not_eq] = ACTIONS(3761),
    [anon_sym_DASH_DASH] = ACTIONS(3761),
    [anon_sym_PLUS_PLUS] = ACTIONS(3761),
    [anon_sym_DOT] = ACTIONS(3769),
    [anon_sym_DOT_STAR] = ACTIONS(3761),
    [anon_sym_DASH_GT] = ACTIONS(3761),
    [anon_sym_L_DQUOTE] = ACTIONS(3204),
    [anon_sym_u_DQUOTE] = ACTIONS(3204),
    [anon_sym_U_DQUOTE] = ACTIONS(3204),
    [anon_sym_u8_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3204),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3208),
    [anon_sym_LR_DQUOTE] = ACTIONS(3208),
    [anon_sym_uR_DQUOTE] = ACTIONS(3208),
    [anon_sym_UR_DQUOTE] = ACTIONS(3208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3208),
  },
  [2081] = {
    [sym_identifier] = ACTIONS(2639),
    [aux_sym_preproc_def_token1] = ACTIONS(2639),
    [aux_sym_preproc_if_token1] = ACTIONS(2639),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2639),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2639),
    [sym_preproc_directive] = ACTIONS(2639),
    [anon_sym_LPAREN2] = ACTIONS(2641),
    [anon_sym_TILDE] = ACTIONS(2641),
    [anon_sym_STAR] = ACTIONS(2641),
    [anon_sym_AMP_AMP] = ACTIONS(2641),
    [anon_sym_AMP] = ACTIONS(2639),
    [anon_sym___extension__] = ACTIONS(2639),
    [anon_sym_typedef] = ACTIONS(2639),
    [anon_sym_extern] = ACTIONS(2639),
    [anon_sym___attribute__] = ACTIONS(2639),
    [anon_sym_COLON_COLON] = ACTIONS(2641),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2641),
    [anon_sym___declspec] = ACTIONS(2639),
    [anon_sym___based] = ACTIONS(2639),
    [anon_sym_RBRACE] = ACTIONS(2641),
    [anon_sym_signed] = ACTIONS(2639),
    [anon_sym_unsigned] = ACTIONS(2639),
    [anon_sym_long] = ACTIONS(2639),
    [anon_sym_short] = ACTIONS(2639),
    [anon_sym_LBRACK] = ACTIONS(2639),
    [anon_sym_static] = ACTIONS(2639),
    [anon_sym_register] = ACTIONS(2639),
    [anon_sym_inline] = ACTIONS(2639),
    [anon_sym___inline] = ACTIONS(2639),
    [anon_sym___inline__] = ACTIONS(2639),
    [anon_sym___forceinline] = ACTIONS(2639),
    [anon_sym_thread_local] = ACTIONS(2639),
    [anon_sym___thread] = ACTIONS(2639),
    [anon_sym_const] = ACTIONS(2639),
    [anon_sym_constexpr] = ACTIONS(2639),
    [anon_sym_volatile] = ACTIONS(2639),
    [anon_sym_restrict] = ACTIONS(2639),
    [anon_sym___restrict__] = ACTIONS(2639),
    [anon_sym__Atomic] = ACTIONS(2639),
    [anon_sym__Noreturn] = ACTIONS(2639),
    [anon_sym_noreturn] = ACTIONS(2639),
    [anon_sym_mutable] = ACTIONS(2639),
    [anon_sym_constinit] = ACTIONS(2639),
    [anon_sym_consteval] = ACTIONS(2639),
    [anon_sym_PROGMEM] = ACTIONS(2639),
    [aux_sym_primitive_type_token1] = ACTIONS(2639),
    [anon_sym_byte] = ACTIONS(2639),
    [anon_sym_word] = ACTIONS(2639),
    [anon_sym_enum] = ACTIONS(2639),
    [anon_sym_class] = ACTIONS(2639),
    [anon_sym_struct] = ACTIONS(2639),
    [anon_sym_union] = ACTIONS(2639),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2639),
    [anon_sym_decltype] = ACTIONS(2639),
    [anon_sym_virtual] = ACTIONS(2639),
    [anon_sym_alignas] = ACTIONS(2639),
    [anon_sym_explicit] = ACTIONS(2639),
    [anon_sym_typename] = ACTIONS(2639),
    [anon_sym_template] = ACTIONS(2639),
    [anon_sym_operator] = ACTIONS(2639),
    [anon_sym_friend] = ACTIONS(2639),
    [anon_sym_public] = ACTIONS(2639),
    [anon_sym_private] = ACTIONS(2639),
    [anon_sym_protected] = ACTIONS(2639),
    [anon_sym_using] = ACTIONS(2639),
    [anon_sym_static_assert] = ACTIONS(2639),
  },
  [2082] = {
    [sym_identifier] = ACTIONS(3082),
    [aux_sym_preproc_def_token1] = ACTIONS(3082),
    [aux_sym_preproc_if_token1] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3082),
    [sym_preproc_directive] = ACTIONS(3082),
    [anon_sym_LPAREN2] = ACTIONS(3084),
    [anon_sym_TILDE] = ACTIONS(3084),
    [anon_sym_STAR] = ACTIONS(3084),
    [anon_sym_AMP_AMP] = ACTIONS(3084),
    [anon_sym_AMP] = ACTIONS(3082),
    [anon_sym___extension__] = ACTIONS(3082),
    [anon_sym_typedef] = ACTIONS(3082),
    [anon_sym_extern] = ACTIONS(3082),
    [anon_sym___attribute__] = ACTIONS(3082),
    [anon_sym_COLON_COLON] = ACTIONS(3084),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3084),
    [anon_sym___declspec] = ACTIONS(3082),
    [anon_sym___based] = ACTIONS(3082),
    [anon_sym_RBRACE] = ACTIONS(3084),
    [anon_sym_signed] = ACTIONS(3082),
    [anon_sym_unsigned] = ACTIONS(3082),
    [anon_sym_long] = ACTIONS(3082),
    [anon_sym_short] = ACTIONS(3082),
    [anon_sym_LBRACK] = ACTIONS(3082),
    [anon_sym_static] = ACTIONS(3082),
    [anon_sym_register] = ACTIONS(3082),
    [anon_sym_inline] = ACTIONS(3082),
    [anon_sym___inline] = ACTIONS(3082),
    [anon_sym___inline__] = ACTIONS(3082),
    [anon_sym___forceinline] = ACTIONS(3082),
    [anon_sym_thread_local] = ACTIONS(3082),
    [anon_sym___thread] = ACTIONS(3082),
    [anon_sym_const] = ACTIONS(3082),
    [anon_sym_constexpr] = ACTIONS(3082),
    [anon_sym_volatile] = ACTIONS(3082),
    [anon_sym_restrict] = ACTIONS(3082),
    [anon_sym___restrict__] = ACTIONS(3082),
    [anon_sym__Atomic] = ACTIONS(3082),
    [anon_sym__Noreturn] = ACTIONS(3082),
    [anon_sym_noreturn] = ACTIONS(3082),
    [anon_sym_mutable] = ACTIONS(3082),
    [anon_sym_constinit] = ACTIONS(3082),
    [anon_sym_consteval] = ACTIONS(3082),
    [anon_sym_PROGMEM] = ACTIONS(3082),
    [aux_sym_primitive_type_token1] = ACTIONS(3082),
    [anon_sym_byte] = ACTIONS(3082),
    [anon_sym_word] = ACTIONS(3082),
    [anon_sym_enum] = ACTIONS(3082),
    [anon_sym_class] = ACTIONS(3082),
    [anon_sym_struct] = ACTIONS(3082),
    [anon_sym_union] = ACTIONS(3082),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3082),
    [anon_sym_decltype] = ACTIONS(3082),
    [anon_sym_virtual] = ACTIONS(3082),
    [anon_sym_alignas] = ACTIONS(3082),
    [anon_sym_explicit] = ACTIONS(3082),
    [anon_sym_typename] = ACTIONS(3082),
    [anon_sym_template] = ACTIONS(3082),
    [anon_sym_operator] = ACTIONS(3082),
    [anon_sym_friend] = ACTIONS(3082),
    [anon_sym_public] = ACTIONS(3082),
    [anon_sym_private] = ACTIONS(3082),
    [anon_sym_protected] = ACTIONS(3082),
    [anon_sym_using] = ACTIONS(3082),
    [anon_sym_static_assert] = ACTIONS(3082),
  },
  [2083] = {
    [sym_identifier] = ACTIONS(3086),
    [aux_sym_preproc_def_token1] = ACTIONS(3086),
    [aux_sym_preproc_if_token1] = ACTIONS(3086),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3086),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3086),
    [sym_preproc_directive] = ACTIONS(3086),
    [anon_sym_LPAREN2] = ACTIONS(3088),
    [anon_sym_TILDE] = ACTIONS(3088),
    [anon_sym_STAR] = ACTIONS(3088),
    [anon_sym_AMP_AMP] = ACTIONS(3088),
    [anon_sym_AMP] = ACTIONS(3086),
    [anon_sym___extension__] = ACTIONS(3086),
    [anon_sym_typedef] = ACTIONS(3086),
    [anon_sym_extern] = ACTIONS(3086),
    [anon_sym___attribute__] = ACTIONS(3086),
    [anon_sym_COLON_COLON] = ACTIONS(3088),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3088),
    [anon_sym___declspec] = ACTIONS(3086),
    [anon_sym___based] = ACTIONS(3086),
    [anon_sym_RBRACE] = ACTIONS(3088),
    [anon_sym_signed] = ACTIONS(3086),
    [anon_sym_unsigned] = ACTIONS(3086),
    [anon_sym_long] = ACTIONS(3086),
    [anon_sym_short] = ACTIONS(3086),
    [anon_sym_LBRACK] = ACTIONS(3086),
    [anon_sym_static] = ACTIONS(3086),
    [anon_sym_register] = ACTIONS(3086),
    [anon_sym_inline] = ACTIONS(3086),
    [anon_sym___inline] = ACTIONS(3086),
    [anon_sym___inline__] = ACTIONS(3086),
    [anon_sym___forceinline] = ACTIONS(3086),
    [anon_sym_thread_local] = ACTIONS(3086),
    [anon_sym___thread] = ACTIONS(3086),
    [anon_sym_const] = ACTIONS(3086),
    [anon_sym_constexpr] = ACTIONS(3086),
    [anon_sym_volatile] = ACTIONS(3086),
    [anon_sym_restrict] = ACTIONS(3086),
    [anon_sym___restrict__] = ACTIONS(3086),
    [anon_sym__Atomic] = ACTIONS(3086),
    [anon_sym__Noreturn] = ACTIONS(3086),
    [anon_sym_noreturn] = ACTIONS(3086),
    [anon_sym_mutable] = ACTIONS(3086),
    [anon_sym_constinit] = ACTIONS(3086),
    [anon_sym_consteval] = ACTIONS(3086),
    [anon_sym_PROGMEM] = ACTIONS(3086),
    [aux_sym_primitive_type_token1] = ACTIONS(3086),
    [anon_sym_byte] = ACTIONS(3086),
    [anon_sym_word] = ACTIONS(3086),
    [anon_sym_enum] = ACTIONS(3086),
    [anon_sym_class] = ACTIONS(3086),
    [anon_sym_struct] = ACTIONS(3086),
    [anon_sym_union] = ACTIONS(3086),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3086),
    [anon_sym_decltype] = ACTIONS(3086),
    [anon_sym_virtual] = ACTIONS(3086),
    [anon_sym_alignas] = ACTIONS(3086),
    [anon_sym_explicit] = ACTIONS(3086),
    [anon_sym_typename] = ACTIONS(3086),
    [anon_sym_template] = ACTIONS(3086),
    [anon_sym_operator] = ACTIONS(3086),
    [anon_sym_friend] = ACTIONS(3086),
    [anon_sym_public] = ACTIONS(3086),
    [anon_sym_private] = ACTIONS(3086),
    [anon_sym_protected] = ACTIONS(3086),
    [anon_sym_using] = ACTIONS(3086),
    [anon_sym_static_assert] = ACTIONS(3086),
  },
  [2084] = {
    [sym_string_literal] = STATE(2116),
    [sym_template_argument_list] = STATE(2395),
    [sym_raw_string_literal] = STATE(2116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3761),
    [anon_sym_COMMA] = ACTIONS(3761),
    [anon_sym_LPAREN2] = ACTIONS(3761),
    [anon_sym_DASH] = ACTIONS(3769),
    [anon_sym_PLUS] = ACTIONS(3769),
    [anon_sym_STAR] = ACTIONS(3769),
    [anon_sym_SLASH] = ACTIONS(3769),
    [anon_sym_PERCENT] = ACTIONS(3769),
    [anon_sym_PIPE_PIPE] = ACTIONS(3761),
    [anon_sym_AMP_AMP] = ACTIONS(3761),
    [anon_sym_PIPE] = ACTIONS(3769),
    [anon_sym_CARET] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(3769),
    [anon_sym_EQ_EQ] = ACTIONS(3761),
    [anon_sym_BANG_EQ] = ACTIONS(3761),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3761),
    [anon_sym_LT_EQ] = ACTIONS(3769),
    [anon_sym_LT] = ACTIONS(4743),
    [anon_sym_LT_LT] = ACTIONS(3769),
    [anon_sym_GT_GT] = ACTIONS(3769),
    [anon_sym_SEMI] = ACTIONS(3761),
    [anon_sym___attribute__] = ACTIONS(3761),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(3785),
    [anon_sym_LBRACK] = ACTIONS(3761),
    [anon_sym_EQ] = ACTIONS(3769),
    [anon_sym_QMARK] = ACTIONS(3761),
    [anon_sym_STAR_EQ] = ACTIONS(3761),
    [anon_sym_SLASH_EQ] = ACTIONS(3761),
    [anon_sym_PERCENT_EQ] = ACTIONS(3761),
    [anon_sym_PLUS_EQ] = ACTIONS(3761),
    [anon_sym_DASH_EQ] = ACTIONS(3761),
    [anon_sym_LT_LT_EQ] = ACTIONS(3761),
    [anon_sym_GT_GT_EQ] = ACTIONS(3761),
    [anon_sym_AMP_EQ] = ACTIONS(3761),
    [anon_sym_CARET_EQ] = ACTIONS(3761),
    [anon_sym_PIPE_EQ] = ACTIONS(3761),
    [anon_sym_and_eq] = ACTIONS(3761),
    [anon_sym_or_eq] = ACTIONS(3761),
    [anon_sym_xor_eq] = ACTIONS(3761),
    [anon_sym_LT_EQ_GT] = ACTIONS(3761),
    [anon_sym_or] = ACTIONS(3769),
    [anon_sym_and] = ACTIONS(3769),
    [anon_sym_bitor] = ACTIONS(3761),
    [anon_sym_xor] = ACTIONS(3769),
    [anon_sym_bitand] = ACTIONS(3761),
    [anon_sym_not_eq] = ACTIONS(3761),
    [anon_sym_DASH_DASH] = ACTIONS(3761),
    [anon_sym_PLUS_PLUS] = ACTIONS(3761),
    [anon_sym_DOT] = ACTIONS(3769),
    [anon_sym_DOT_STAR] = ACTIONS(3761),
    [anon_sym_DASH_GT] = ACTIONS(3761),
    [anon_sym_L_DQUOTE] = ACTIONS(5289),
    [anon_sym_u_DQUOTE] = ACTIONS(5289),
    [anon_sym_U_DQUOTE] = ACTIONS(5289),
    [anon_sym_u8_DQUOTE] = ACTIONS(5289),
    [anon_sym_DQUOTE] = ACTIONS(5289),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5291),
    [anon_sym_LR_DQUOTE] = ACTIONS(5291),
    [anon_sym_uR_DQUOTE] = ACTIONS(5291),
    [anon_sym_UR_DQUOTE] = ACTIONS(5291),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5291),
  },
  [2085] = {
    [sym_identifier] = ACTIONS(2639),
    [aux_sym_preproc_def_token1] = ACTIONS(2639),
    [aux_sym_preproc_if_token1] = ACTIONS(2639),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2639),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2639),
    [sym_preproc_directive] = ACTIONS(2639),
    [anon_sym_LPAREN2] = ACTIONS(2641),
    [anon_sym_TILDE] = ACTIONS(2641),
    [anon_sym_STAR] = ACTIONS(2641),
    [anon_sym_AMP_AMP] = ACTIONS(2641),
    [anon_sym_AMP] = ACTIONS(2639),
    [anon_sym___extension__] = ACTIONS(2639),
    [anon_sym_typedef] = ACTIONS(2639),
    [anon_sym_extern] = ACTIONS(2639),
    [anon_sym___attribute__] = ACTIONS(2639),
    [anon_sym_COLON_COLON] = ACTIONS(2641),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2641),
    [anon_sym___declspec] = ACTIONS(2639),
    [anon_sym___based] = ACTIONS(2639),
    [anon_sym_RBRACE] = ACTIONS(2641),
    [anon_sym_signed] = ACTIONS(2639),
    [anon_sym_unsigned] = ACTIONS(2639),
    [anon_sym_long] = ACTIONS(2639),
    [anon_sym_short] = ACTIONS(2639),
    [anon_sym_LBRACK] = ACTIONS(2639),
    [anon_sym_static] = ACTIONS(2639),
    [anon_sym_register] = ACTIONS(2639),
    [anon_sym_inline] = ACTIONS(2639),
    [anon_sym___inline] = ACTIONS(2639),
    [anon_sym___inline__] = ACTIONS(2639),
    [anon_sym___forceinline] = ACTIONS(2639),
    [anon_sym_thread_local] = ACTIONS(2639),
    [anon_sym___thread] = ACTIONS(2639),
    [anon_sym_const] = ACTIONS(2639),
    [anon_sym_constexpr] = ACTIONS(2639),
    [anon_sym_volatile] = ACTIONS(2639),
    [anon_sym_restrict] = ACTIONS(2639),
    [anon_sym___restrict__] = ACTIONS(2639),
    [anon_sym__Atomic] = ACTIONS(2639),
    [anon_sym__Noreturn] = ACTIONS(2639),
    [anon_sym_noreturn] = ACTIONS(2639),
    [anon_sym_mutable] = ACTIONS(2639),
    [anon_sym_constinit] = ACTIONS(2639),
    [anon_sym_consteval] = ACTIONS(2639),
    [anon_sym_PROGMEM] = ACTIONS(2639),
    [aux_sym_primitive_type_token1] = ACTIONS(2639),
    [anon_sym_byte] = ACTIONS(2639),
    [anon_sym_word] = ACTIONS(2639),
    [anon_sym_enum] = ACTIONS(2639),
    [anon_sym_class] = ACTIONS(2639),
    [anon_sym_struct] = ACTIONS(2639),
    [anon_sym_union] = ACTIONS(2639),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2639),
    [anon_sym_decltype] = ACTIONS(2639),
    [anon_sym_virtual] = ACTIONS(2639),
    [anon_sym_alignas] = ACTIONS(2639),
    [anon_sym_explicit] = ACTIONS(2639),
    [anon_sym_typename] = ACTIONS(2639),
    [anon_sym_template] = ACTIONS(2639),
    [anon_sym_operator] = ACTIONS(2639),
    [anon_sym_friend] = ACTIONS(2639),
    [anon_sym_public] = ACTIONS(2639),
    [anon_sym_private] = ACTIONS(2639),
    [anon_sym_protected] = ACTIONS(2639),
    [anon_sym_using] = ACTIONS(2639),
    [anon_sym_static_assert] = ACTIONS(2639),
  },
  [2086] = {
    [sym_identifier] = ACTIONS(3008),
    [aux_sym_preproc_def_token1] = ACTIONS(3008),
    [aux_sym_preproc_if_token1] = ACTIONS(3008),
    [aux_sym_preproc_if_token2] = ACTIONS(3008),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3008),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3008),
    [sym_preproc_directive] = ACTIONS(3008),
    [anon_sym_LPAREN2] = ACTIONS(3010),
    [anon_sym_TILDE] = ACTIONS(3010),
    [anon_sym_STAR] = ACTIONS(3010),
    [anon_sym_AMP_AMP] = ACTIONS(3010),
    [anon_sym_AMP] = ACTIONS(3008),
    [anon_sym___extension__] = ACTIONS(3008),
    [anon_sym_typedef] = ACTIONS(3008),
    [anon_sym_extern] = ACTIONS(3008),
    [anon_sym___attribute__] = ACTIONS(3008),
    [anon_sym_COLON_COLON] = ACTIONS(3010),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3010),
    [anon_sym___declspec] = ACTIONS(3008),
    [anon_sym___based] = ACTIONS(3008),
    [anon_sym_signed] = ACTIONS(3008),
    [anon_sym_unsigned] = ACTIONS(3008),
    [anon_sym_long] = ACTIONS(3008),
    [anon_sym_short] = ACTIONS(3008),
    [anon_sym_LBRACK] = ACTIONS(3008),
    [anon_sym_static] = ACTIONS(3008),
    [anon_sym_register] = ACTIONS(3008),
    [anon_sym_inline] = ACTIONS(3008),
    [anon_sym___inline] = ACTIONS(3008),
    [anon_sym___inline__] = ACTIONS(3008),
    [anon_sym___forceinline] = ACTIONS(3008),
    [anon_sym_thread_local] = ACTIONS(3008),
    [anon_sym___thread] = ACTIONS(3008),
    [anon_sym_const] = ACTIONS(3008),
    [anon_sym_constexpr] = ACTIONS(3008),
    [anon_sym_volatile] = ACTIONS(3008),
    [anon_sym_restrict] = ACTIONS(3008),
    [anon_sym___restrict__] = ACTIONS(3008),
    [anon_sym__Atomic] = ACTIONS(3008),
    [anon_sym__Noreturn] = ACTIONS(3008),
    [anon_sym_noreturn] = ACTIONS(3008),
    [anon_sym_mutable] = ACTIONS(3008),
    [anon_sym_constinit] = ACTIONS(3008),
    [anon_sym_consteval] = ACTIONS(3008),
    [anon_sym_PROGMEM] = ACTIONS(3008),
    [aux_sym_primitive_type_token1] = ACTIONS(3008),
    [anon_sym_byte] = ACTIONS(3008),
    [anon_sym_word] = ACTIONS(3008),
    [anon_sym_enum] = ACTIONS(3008),
    [anon_sym_class] = ACTIONS(3008),
    [anon_sym_struct] = ACTIONS(3008),
    [anon_sym_union] = ACTIONS(3008),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3008),
    [anon_sym_decltype] = ACTIONS(3008),
    [anon_sym_virtual] = ACTIONS(3008),
    [anon_sym_alignas] = ACTIONS(3008),
    [anon_sym_explicit] = ACTIONS(3008),
    [anon_sym_typename] = ACTIONS(3008),
    [anon_sym_template] = ACTIONS(3008),
    [anon_sym_operator] = ACTIONS(3008),
    [anon_sym_friend] = ACTIONS(3008),
    [anon_sym_public] = ACTIONS(3008),
    [anon_sym_private] = ACTIONS(3008),
    [anon_sym_protected] = ACTIONS(3008),
    [anon_sym_using] = ACTIONS(3008),
    [anon_sym_static_assert] = ACTIONS(3008),
  },
  [2087] = {
    [sym_identifier] = ACTIONS(2797),
    [aux_sym_preproc_def_token1] = ACTIONS(2797),
    [aux_sym_preproc_if_token1] = ACTIONS(2797),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2797),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2797),
    [sym_preproc_directive] = ACTIONS(2797),
    [anon_sym_LPAREN2] = ACTIONS(2799),
    [anon_sym_TILDE] = ACTIONS(2799),
    [anon_sym_STAR] = ACTIONS(2799),
    [anon_sym_AMP_AMP] = ACTIONS(2799),
    [anon_sym_AMP] = ACTIONS(2797),
    [anon_sym___extension__] = ACTIONS(2797),
    [anon_sym_typedef] = ACTIONS(2797),
    [anon_sym_extern] = ACTIONS(2797),
    [anon_sym___attribute__] = ACTIONS(2797),
    [anon_sym_COLON_COLON] = ACTIONS(2799),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2799),
    [anon_sym___declspec] = ACTIONS(2797),
    [anon_sym___based] = ACTIONS(2797),
    [anon_sym_RBRACE] = ACTIONS(2799),
    [anon_sym_signed] = ACTIONS(2797),
    [anon_sym_unsigned] = ACTIONS(2797),
    [anon_sym_long] = ACTIONS(2797),
    [anon_sym_short] = ACTIONS(2797),
    [anon_sym_LBRACK] = ACTIONS(2797),
    [anon_sym_static] = ACTIONS(2797),
    [anon_sym_register] = ACTIONS(2797),
    [anon_sym_inline] = ACTIONS(2797),
    [anon_sym___inline] = ACTIONS(2797),
    [anon_sym___inline__] = ACTIONS(2797),
    [anon_sym___forceinline] = ACTIONS(2797),
    [anon_sym_thread_local] = ACTIONS(2797),
    [anon_sym___thread] = ACTIONS(2797),
    [anon_sym_const] = ACTIONS(2797),
    [anon_sym_constexpr] = ACTIONS(2797),
    [anon_sym_volatile] = ACTIONS(2797),
    [anon_sym_restrict] = ACTIONS(2797),
    [anon_sym___restrict__] = ACTIONS(2797),
    [anon_sym__Atomic] = ACTIONS(2797),
    [anon_sym__Noreturn] = ACTIONS(2797),
    [anon_sym_noreturn] = ACTIONS(2797),
    [anon_sym_mutable] = ACTIONS(2797),
    [anon_sym_constinit] = ACTIONS(2797),
    [anon_sym_consteval] = ACTIONS(2797),
    [anon_sym_PROGMEM] = ACTIONS(2797),
    [aux_sym_primitive_type_token1] = ACTIONS(2797),
    [anon_sym_byte] = ACTIONS(2797),
    [anon_sym_word] = ACTIONS(2797),
    [anon_sym_enum] = ACTIONS(2797),
    [anon_sym_class] = ACTIONS(2797),
    [anon_sym_struct] = ACTIONS(2797),
    [anon_sym_union] = ACTIONS(2797),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2797),
    [anon_sym_decltype] = ACTIONS(2797),
    [anon_sym_virtual] = ACTIONS(2797),
    [anon_sym_alignas] = ACTIONS(2797),
    [anon_sym_explicit] = ACTIONS(2797),
    [anon_sym_typename] = ACTIONS(2797),
    [anon_sym_template] = ACTIONS(2797),
    [anon_sym_operator] = ACTIONS(2797),
    [anon_sym_friend] = ACTIONS(2797),
    [anon_sym_public] = ACTIONS(2797),
    [anon_sym_private] = ACTIONS(2797),
    [anon_sym_protected] = ACTIONS(2797),
    [anon_sym_using] = ACTIONS(2797),
    [anon_sym_static_assert] = ACTIONS(2797),
  },
  [2088] = {
    [sym_attribute_specifier] = STATE(2344),
    [sym_enumerator_list] = STATE(2271),
    [sym_identifier] = ACTIONS(5293),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5295),
    [anon_sym_COMMA] = ACTIONS(5295),
    [anon_sym_RPAREN] = ACTIONS(5295),
    [aux_sym_preproc_if_token2] = ACTIONS(5295),
    [aux_sym_preproc_else_token1] = ACTIONS(5295),
    [aux_sym_preproc_elif_token1] = ACTIONS(5293),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5295),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5295),
    [anon_sym_LPAREN2] = ACTIONS(5295),
    [anon_sym_DASH] = ACTIONS(5293),
    [anon_sym_PLUS] = ACTIONS(5293),
    [anon_sym_STAR] = ACTIONS(5293),
    [anon_sym_SLASH] = ACTIONS(5293),
    [anon_sym_PERCENT] = ACTIONS(5293),
    [anon_sym_PIPE_PIPE] = ACTIONS(5295),
    [anon_sym_AMP_AMP] = ACTIONS(5295),
    [anon_sym_PIPE] = ACTIONS(5293),
    [anon_sym_CARET] = ACTIONS(5293),
    [anon_sym_AMP] = ACTIONS(5293),
    [anon_sym_EQ_EQ] = ACTIONS(5295),
    [anon_sym_BANG_EQ] = ACTIONS(5295),
    [anon_sym_GT] = ACTIONS(5293),
    [anon_sym_GT_EQ] = ACTIONS(5295),
    [anon_sym_LT_EQ] = ACTIONS(5293),
    [anon_sym_LT] = ACTIONS(5293),
    [anon_sym_LT_LT] = ACTIONS(5293),
    [anon_sym_GT_GT] = ACTIONS(5293),
    [anon_sym_SEMI] = ACTIONS(5295),
    [anon_sym___attribute__] = ACTIONS(4906),
    [anon_sym_LBRACE] = ACTIONS(5297),
    [anon_sym_RBRACE] = ACTIONS(5295),
    [anon_sym_LBRACK] = ACTIONS(5295),
    [anon_sym_RBRACK] = ACTIONS(5295),
    [anon_sym_EQ] = ACTIONS(5293),
    [anon_sym_COLON] = ACTIONS(5295),
    [anon_sym_QMARK] = ACTIONS(5295),
    [anon_sym_STAR_EQ] = ACTIONS(5295),
    [anon_sym_SLASH_EQ] = ACTIONS(5295),
    [anon_sym_PERCENT_EQ] = ACTIONS(5295),
    [anon_sym_PLUS_EQ] = ACTIONS(5295),
    [anon_sym_DASH_EQ] = ACTIONS(5295),
    [anon_sym_LT_LT_EQ] = ACTIONS(5295),
    [anon_sym_GT_GT_EQ] = ACTIONS(5295),
    [anon_sym_AMP_EQ] = ACTIONS(5295),
    [anon_sym_CARET_EQ] = ACTIONS(5295),
    [anon_sym_PIPE_EQ] = ACTIONS(5295),
    [anon_sym_and_eq] = ACTIONS(5293),
    [anon_sym_or_eq] = ACTIONS(5293),
    [anon_sym_xor_eq] = ACTIONS(5293),
    [anon_sym_LT_EQ_GT] = ACTIONS(5295),
    [anon_sym_or] = ACTIONS(5293),
    [anon_sym_and] = ACTIONS(5293),
    [anon_sym_bitor] = ACTIONS(5293),
    [anon_sym_xor] = ACTIONS(5293),
    [anon_sym_bitand] = ACTIONS(5293),
    [anon_sym_not_eq] = ACTIONS(5293),
    [anon_sym_DASH_DASH] = ACTIONS(5295),
    [anon_sym_PLUS_PLUS] = ACTIONS(5295),
    [anon_sym_DOT] = ACTIONS(5293),
    [anon_sym_DOT_STAR] = ACTIONS(5295),
    [anon_sym_DASH_GT] = ACTIONS(5295),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5293),
    [anon_sym_decltype] = ACTIONS(5293),
  },
  [2089] = {
    [sym_identifier] = ACTIONS(3052),
    [aux_sym_preproc_def_token1] = ACTIONS(3052),
    [aux_sym_preproc_if_token1] = ACTIONS(3052),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3052),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3052),
    [sym_preproc_directive] = ACTIONS(3052),
    [anon_sym_LPAREN2] = ACTIONS(3054),
    [anon_sym_TILDE] = ACTIONS(3054),
    [anon_sym_STAR] = ACTIONS(3054),
    [anon_sym_AMP_AMP] = ACTIONS(3054),
    [anon_sym_AMP] = ACTIONS(3052),
    [anon_sym___extension__] = ACTIONS(3052),
    [anon_sym_typedef] = ACTIONS(3052),
    [anon_sym_extern] = ACTIONS(3052),
    [anon_sym___attribute__] = ACTIONS(3052),
    [anon_sym_COLON_COLON] = ACTIONS(3054),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3054),
    [anon_sym___declspec] = ACTIONS(3052),
    [anon_sym___based] = ACTIONS(3052),
    [anon_sym_RBRACE] = ACTIONS(3054),
    [anon_sym_signed] = ACTIONS(3052),
    [anon_sym_unsigned] = ACTIONS(3052),
    [anon_sym_long] = ACTIONS(3052),
    [anon_sym_short] = ACTIONS(3052),
    [anon_sym_LBRACK] = ACTIONS(3052),
    [anon_sym_static] = ACTIONS(3052),
    [anon_sym_register] = ACTIONS(3052),
    [anon_sym_inline] = ACTIONS(3052),
    [anon_sym___inline] = ACTIONS(3052),
    [anon_sym___inline__] = ACTIONS(3052),
    [anon_sym___forceinline] = ACTIONS(3052),
    [anon_sym_thread_local] = ACTIONS(3052),
    [anon_sym___thread] = ACTIONS(3052),
    [anon_sym_const] = ACTIONS(3052),
    [anon_sym_constexpr] = ACTIONS(3052),
    [anon_sym_volatile] = ACTIONS(3052),
    [anon_sym_restrict] = ACTIONS(3052),
    [anon_sym___restrict__] = ACTIONS(3052),
    [anon_sym__Atomic] = ACTIONS(3052),
    [anon_sym__Noreturn] = ACTIONS(3052),
    [anon_sym_noreturn] = ACTIONS(3052),
    [anon_sym_mutable] = ACTIONS(3052),
    [anon_sym_constinit] = ACTIONS(3052),
    [anon_sym_consteval] = ACTIONS(3052),
    [anon_sym_PROGMEM] = ACTIONS(3052),
    [aux_sym_primitive_type_token1] = ACTIONS(3052),
    [anon_sym_byte] = ACTIONS(3052),
    [anon_sym_word] = ACTIONS(3052),
    [anon_sym_enum] = ACTIONS(3052),
    [anon_sym_class] = ACTIONS(3052),
    [anon_sym_struct] = ACTIONS(3052),
    [anon_sym_union] = ACTIONS(3052),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3052),
    [anon_sym_decltype] = ACTIONS(3052),
    [anon_sym_virtual] = ACTIONS(3052),
    [anon_sym_alignas] = ACTIONS(3052),
    [anon_sym_explicit] = ACTIONS(3052),
    [anon_sym_typename] = ACTIONS(3052),
    [anon_sym_template] = ACTIONS(3052),
    [anon_sym_operator] = ACTIONS(3052),
    [anon_sym_friend] = ACTIONS(3052),
    [anon_sym_public] = ACTIONS(3052),
    [anon_sym_private] = ACTIONS(3052),
    [anon_sym_protected] = ACTIONS(3052),
    [anon_sym_using] = ACTIONS(3052),
    [anon_sym_static_assert] = ACTIONS(3052),
  },
  [2090] = {
    [sym_identifier] = ACTIONS(3164),
    [aux_sym_preproc_def_token1] = ACTIONS(3164),
    [aux_sym_preproc_if_token1] = ACTIONS(3164),
    [aux_sym_preproc_if_token2] = ACTIONS(3164),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3164),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3164),
    [sym_preproc_directive] = ACTIONS(3164),
    [anon_sym_LPAREN2] = ACTIONS(3166),
    [anon_sym_TILDE] = ACTIONS(3166),
    [anon_sym_STAR] = ACTIONS(3166),
    [anon_sym_AMP_AMP] = ACTIONS(3166),
    [anon_sym_AMP] = ACTIONS(3164),
    [anon_sym___extension__] = ACTIONS(3164),
    [anon_sym_typedef] = ACTIONS(3164),
    [anon_sym_extern] = ACTIONS(3164),
    [anon_sym___attribute__] = ACTIONS(3164),
    [anon_sym_COLON_COLON] = ACTIONS(3166),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3166),
    [anon_sym___declspec] = ACTIONS(3164),
    [anon_sym___based] = ACTIONS(3164),
    [anon_sym_signed] = ACTIONS(3164),
    [anon_sym_unsigned] = ACTIONS(3164),
    [anon_sym_long] = ACTIONS(3164),
    [anon_sym_short] = ACTIONS(3164),
    [anon_sym_LBRACK] = ACTIONS(3164),
    [anon_sym_static] = ACTIONS(3164),
    [anon_sym_register] = ACTIONS(3164),
    [anon_sym_inline] = ACTIONS(3164),
    [anon_sym___inline] = ACTIONS(3164),
    [anon_sym___inline__] = ACTIONS(3164),
    [anon_sym___forceinline] = ACTIONS(3164),
    [anon_sym_thread_local] = ACTIONS(3164),
    [anon_sym___thread] = ACTIONS(3164),
    [anon_sym_const] = ACTIONS(3164),
    [anon_sym_constexpr] = ACTIONS(3164),
    [anon_sym_volatile] = ACTIONS(3164),
    [anon_sym_restrict] = ACTIONS(3164),
    [anon_sym___restrict__] = ACTIONS(3164),
    [anon_sym__Atomic] = ACTIONS(3164),
    [anon_sym__Noreturn] = ACTIONS(3164),
    [anon_sym_noreturn] = ACTIONS(3164),
    [anon_sym_mutable] = ACTIONS(3164),
    [anon_sym_constinit] = ACTIONS(3164),
    [anon_sym_consteval] = ACTIONS(3164),
    [anon_sym_PROGMEM] = ACTIONS(3164),
    [aux_sym_primitive_type_token1] = ACTIONS(3164),
    [anon_sym_byte] = ACTIONS(3164),
    [anon_sym_word] = ACTIONS(3164),
    [anon_sym_enum] = ACTIONS(3164),
    [anon_sym_class] = ACTIONS(3164),
    [anon_sym_struct] = ACTIONS(3164),
    [anon_sym_union] = ACTIONS(3164),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3164),
    [anon_sym_decltype] = ACTIONS(3164),
    [anon_sym_virtual] = ACTIONS(3164),
    [anon_sym_alignas] = ACTIONS(3164),
    [anon_sym_explicit] = ACTIONS(3164),
    [anon_sym_typename] = ACTIONS(3164),
    [anon_sym_template] = ACTIONS(3164),
    [anon_sym_operator] = ACTIONS(3164),
    [anon_sym_friend] = ACTIONS(3164),
    [anon_sym_public] = ACTIONS(3164),
    [anon_sym_private] = ACTIONS(3164),
    [anon_sym_protected] = ACTIONS(3164),
    [anon_sym_using] = ACTIONS(3164),
    [anon_sym_static_assert] = ACTIONS(3164),
  },
  [2091] = {
    [sym_identifier] = ACTIONS(3160),
    [aux_sym_preproc_def_token1] = ACTIONS(3160),
    [aux_sym_preproc_if_token1] = ACTIONS(3160),
    [aux_sym_preproc_if_token2] = ACTIONS(3160),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3160),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3160),
    [sym_preproc_directive] = ACTIONS(3160),
    [anon_sym_LPAREN2] = ACTIONS(3162),
    [anon_sym_TILDE] = ACTIONS(3162),
    [anon_sym_STAR] = ACTIONS(3162),
    [anon_sym_AMP_AMP] = ACTIONS(3162),
    [anon_sym_AMP] = ACTIONS(3160),
    [anon_sym___extension__] = ACTIONS(3160),
    [anon_sym_typedef] = ACTIONS(3160),
    [anon_sym_extern] = ACTIONS(3160),
    [anon_sym___attribute__] = ACTIONS(3160),
    [anon_sym_COLON_COLON] = ACTIONS(3162),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3162),
    [anon_sym___declspec] = ACTIONS(3160),
    [anon_sym___based] = ACTIONS(3160),
    [anon_sym_signed] = ACTIONS(3160),
    [anon_sym_unsigned] = ACTIONS(3160),
    [anon_sym_long] = ACTIONS(3160),
    [anon_sym_short] = ACTIONS(3160),
    [anon_sym_LBRACK] = ACTIONS(3160),
    [anon_sym_static] = ACTIONS(3160),
    [anon_sym_register] = ACTIONS(3160),
    [anon_sym_inline] = ACTIONS(3160),
    [anon_sym___inline] = ACTIONS(3160),
    [anon_sym___inline__] = ACTIONS(3160),
    [anon_sym___forceinline] = ACTIONS(3160),
    [anon_sym_thread_local] = ACTIONS(3160),
    [anon_sym___thread] = ACTIONS(3160),
    [anon_sym_const] = ACTIONS(3160),
    [anon_sym_constexpr] = ACTIONS(3160),
    [anon_sym_volatile] = ACTIONS(3160),
    [anon_sym_restrict] = ACTIONS(3160),
    [anon_sym___restrict__] = ACTIONS(3160),
    [anon_sym__Atomic] = ACTIONS(3160),
    [anon_sym__Noreturn] = ACTIONS(3160),
    [anon_sym_noreturn] = ACTIONS(3160),
    [anon_sym_mutable] = ACTIONS(3160),
    [anon_sym_constinit] = ACTIONS(3160),
    [anon_sym_consteval] = ACTIONS(3160),
    [anon_sym_PROGMEM] = ACTIONS(3160),
    [aux_sym_primitive_type_token1] = ACTIONS(3160),
    [anon_sym_byte] = ACTIONS(3160),
    [anon_sym_word] = ACTIONS(3160),
    [anon_sym_enum] = ACTIONS(3160),
    [anon_sym_class] = ACTIONS(3160),
    [anon_sym_struct] = ACTIONS(3160),
    [anon_sym_union] = ACTIONS(3160),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3160),
    [anon_sym_decltype] = ACTIONS(3160),
    [anon_sym_virtual] = ACTIONS(3160),
    [anon_sym_alignas] = ACTIONS(3160),
    [anon_sym_explicit] = ACTIONS(3160),
    [anon_sym_typename] = ACTIONS(3160),
    [anon_sym_template] = ACTIONS(3160),
    [anon_sym_operator] = ACTIONS(3160),
    [anon_sym_friend] = ACTIONS(3160),
    [anon_sym_public] = ACTIONS(3160),
    [anon_sym_private] = ACTIONS(3160),
    [anon_sym_protected] = ACTIONS(3160),
    [anon_sym_using] = ACTIONS(3160),
    [anon_sym_static_assert] = ACTIONS(3160),
  },
  [2092] = {
    [sym_string_literal] = STATE(2617),
    [sym_template_argument_list] = STATE(3723),
    [sym_raw_string_literal] = STATE(2617),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3761),
    [anon_sym_COMMA] = ACTIONS(3761),
    [anon_sym_LPAREN2] = ACTIONS(3761),
    [anon_sym_DASH] = ACTIONS(3769),
    [anon_sym_PLUS] = ACTIONS(3769),
    [anon_sym_STAR] = ACTIONS(3769),
    [anon_sym_SLASH] = ACTIONS(3769),
    [anon_sym_PERCENT] = ACTIONS(3769),
    [anon_sym_PIPE_PIPE] = ACTIONS(3761),
    [anon_sym_AMP_AMP] = ACTIONS(3761),
    [anon_sym_PIPE] = ACTIONS(3769),
    [anon_sym_CARET] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(3769),
    [anon_sym_EQ_EQ] = ACTIONS(3761),
    [anon_sym_BANG_EQ] = ACTIONS(3761),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3761),
    [anon_sym_LT_EQ] = ACTIONS(3769),
    [anon_sym_LT] = ACTIONS(5242),
    [anon_sym_LT_LT] = ACTIONS(3769),
    [anon_sym_GT_GT] = ACTIONS(3769),
    [anon_sym_SEMI] = ACTIONS(3761),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(3785),
    [anon_sym_LBRACK] = ACTIONS(3761),
    [anon_sym_EQ] = ACTIONS(3793),
    [anon_sym_COLON] = ACTIONS(5299),
    [anon_sym_QMARK] = ACTIONS(3761),
    [anon_sym_STAR_EQ] = ACTIONS(3797),
    [anon_sym_SLASH_EQ] = ACTIONS(3797),
    [anon_sym_PERCENT_EQ] = ACTIONS(3797),
    [anon_sym_PLUS_EQ] = ACTIONS(3797),
    [anon_sym_DASH_EQ] = ACTIONS(3797),
    [anon_sym_LT_LT_EQ] = ACTIONS(3797),
    [anon_sym_GT_GT_EQ] = ACTIONS(3797),
    [anon_sym_AMP_EQ] = ACTIONS(3797),
    [anon_sym_CARET_EQ] = ACTIONS(3797),
    [anon_sym_PIPE_EQ] = ACTIONS(3797),
    [anon_sym_and_eq] = ACTIONS(3797),
    [anon_sym_or_eq] = ACTIONS(3797),
    [anon_sym_xor_eq] = ACTIONS(3797),
    [anon_sym_LT_EQ_GT] = ACTIONS(3761),
    [anon_sym_or] = ACTIONS(3769),
    [anon_sym_and] = ACTIONS(3769),
    [anon_sym_bitor] = ACTIONS(3761),
    [anon_sym_xor] = ACTIONS(3769),
    [anon_sym_bitand] = ACTIONS(3761),
    [anon_sym_not_eq] = ACTIONS(3761),
    [anon_sym_DASH_DASH] = ACTIONS(3761),
    [anon_sym_PLUS_PLUS] = ACTIONS(3761),
    [anon_sym_DOT] = ACTIONS(3769),
    [anon_sym_DOT_STAR] = ACTIONS(3761),
    [anon_sym_DASH_GT] = ACTIONS(3761),
    [anon_sym_L_DQUOTE] = ACTIONS(3204),
    [anon_sym_u_DQUOTE] = ACTIONS(3204),
    [anon_sym_U_DQUOTE] = ACTIONS(3204),
    [anon_sym_u8_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3204),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3208),
    [anon_sym_LR_DQUOTE] = ACTIONS(3208),
    [anon_sym_uR_DQUOTE] = ACTIONS(3208),
    [anon_sym_UR_DQUOTE] = ACTIONS(3208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3208),
  },
  [2093] = {
    [sym_string_literal] = STATE(2617),
    [sym_template_argument_list] = STATE(3723),
    [sym_raw_string_literal] = STATE(2617),
    [aux_sym_structured_binding_declarator_repeat1] = STATE(7216),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3761),
    [anon_sym_COMMA] = ACTIONS(5301),
    [anon_sym_LPAREN2] = ACTIONS(3761),
    [anon_sym_DASH] = ACTIONS(3769),
    [anon_sym_PLUS] = ACTIONS(3769),
    [anon_sym_STAR] = ACTIONS(3769),
    [anon_sym_SLASH] = ACTIONS(3769),
    [anon_sym_PERCENT] = ACTIONS(3769),
    [anon_sym_PIPE_PIPE] = ACTIONS(3761),
    [anon_sym_AMP_AMP] = ACTIONS(3761),
    [anon_sym_PIPE] = ACTIONS(3769),
    [anon_sym_CARET] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(3769),
    [anon_sym_EQ_EQ] = ACTIONS(3761),
    [anon_sym_BANG_EQ] = ACTIONS(3761),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3761),
    [anon_sym_LT_EQ] = ACTIONS(3769),
    [anon_sym_LT] = ACTIONS(5242),
    [anon_sym_LT_LT] = ACTIONS(3769),
    [anon_sym_GT_GT] = ACTIONS(3769),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(3785),
    [anon_sym_LBRACK] = ACTIONS(3761),
    [anon_sym_RBRACK] = ACTIONS(5282),
    [anon_sym_EQ] = ACTIONS(5285),
    [anon_sym_QMARK] = ACTIONS(3761),
    [anon_sym_STAR_EQ] = ACTIONS(5287),
    [anon_sym_SLASH_EQ] = ACTIONS(5287),
    [anon_sym_PERCENT_EQ] = ACTIONS(5287),
    [anon_sym_PLUS_EQ] = ACTIONS(5287),
    [anon_sym_DASH_EQ] = ACTIONS(5287),
    [anon_sym_LT_LT_EQ] = ACTIONS(5287),
    [anon_sym_GT_GT_EQ] = ACTIONS(5287),
    [anon_sym_AMP_EQ] = ACTIONS(5287),
    [anon_sym_CARET_EQ] = ACTIONS(5287),
    [anon_sym_PIPE_EQ] = ACTIONS(5287),
    [anon_sym_and_eq] = ACTIONS(5287),
    [anon_sym_or_eq] = ACTIONS(5287),
    [anon_sym_xor_eq] = ACTIONS(5287),
    [anon_sym_LT_EQ_GT] = ACTIONS(3761),
    [anon_sym_or] = ACTIONS(3769),
    [anon_sym_and] = ACTIONS(3769),
    [anon_sym_bitor] = ACTIONS(3761),
    [anon_sym_xor] = ACTIONS(3769),
    [anon_sym_bitand] = ACTIONS(3761),
    [anon_sym_not_eq] = ACTIONS(3761),
    [anon_sym_DASH_DASH] = ACTIONS(3761),
    [anon_sym_PLUS_PLUS] = ACTIONS(3761),
    [anon_sym_DOT] = ACTIONS(3769),
    [anon_sym_DOT_STAR] = ACTIONS(3761),
    [anon_sym_DASH_GT] = ACTIONS(3761),
    [anon_sym_L_DQUOTE] = ACTIONS(3204),
    [anon_sym_u_DQUOTE] = ACTIONS(3204),
    [anon_sym_U_DQUOTE] = ACTIONS(3204),
    [anon_sym_u8_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3204),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3208),
    [anon_sym_LR_DQUOTE] = ACTIONS(3208),
    [anon_sym_uR_DQUOTE] = ACTIONS(3208),
    [anon_sym_UR_DQUOTE] = ACTIONS(3208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3208),
  },
  [2094] = {
    [sym_identifier] = ACTIONS(3060),
    [aux_sym_preproc_def_token1] = ACTIONS(3060),
    [aux_sym_preproc_if_token1] = ACTIONS(3060),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3060),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3060),
    [sym_preproc_directive] = ACTIONS(3060),
    [anon_sym_LPAREN2] = ACTIONS(3062),
    [anon_sym_TILDE] = ACTIONS(3062),
    [anon_sym_STAR] = ACTIONS(3062),
    [anon_sym_AMP_AMP] = ACTIONS(3062),
    [anon_sym_AMP] = ACTIONS(3060),
    [anon_sym___extension__] = ACTIONS(3060),
    [anon_sym_typedef] = ACTIONS(3060),
    [anon_sym_extern] = ACTIONS(3060),
    [anon_sym___attribute__] = ACTIONS(3060),
    [anon_sym_COLON_COLON] = ACTIONS(3062),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3062),
    [anon_sym___declspec] = ACTIONS(3060),
    [anon_sym___based] = ACTIONS(3060),
    [anon_sym_RBRACE] = ACTIONS(3062),
    [anon_sym_signed] = ACTIONS(3060),
    [anon_sym_unsigned] = ACTIONS(3060),
    [anon_sym_long] = ACTIONS(3060),
    [anon_sym_short] = ACTIONS(3060),
    [anon_sym_LBRACK] = ACTIONS(3060),
    [anon_sym_static] = ACTIONS(3060),
    [anon_sym_register] = ACTIONS(3060),
    [anon_sym_inline] = ACTIONS(3060),
    [anon_sym___inline] = ACTIONS(3060),
    [anon_sym___inline__] = ACTIONS(3060),
    [anon_sym___forceinline] = ACTIONS(3060),
    [anon_sym_thread_local] = ACTIONS(3060),
    [anon_sym___thread] = ACTIONS(3060),
    [anon_sym_const] = ACTIONS(3060),
    [anon_sym_constexpr] = ACTIONS(3060),
    [anon_sym_volatile] = ACTIONS(3060),
    [anon_sym_restrict] = ACTIONS(3060),
    [anon_sym___restrict__] = ACTIONS(3060),
    [anon_sym__Atomic] = ACTIONS(3060),
    [anon_sym__Noreturn] = ACTIONS(3060),
    [anon_sym_noreturn] = ACTIONS(3060),
    [anon_sym_mutable] = ACTIONS(3060),
    [anon_sym_constinit] = ACTIONS(3060),
    [anon_sym_consteval] = ACTIONS(3060),
    [anon_sym_PROGMEM] = ACTIONS(3060),
    [aux_sym_primitive_type_token1] = ACTIONS(3060),
    [anon_sym_byte] = ACTIONS(3060),
    [anon_sym_word] = ACTIONS(3060),
    [anon_sym_enum] = ACTIONS(3060),
    [anon_sym_class] = ACTIONS(3060),
    [anon_sym_struct] = ACTIONS(3060),
    [anon_sym_union] = ACTIONS(3060),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3060),
    [anon_sym_decltype] = ACTIONS(3060),
    [anon_sym_virtual] = ACTIONS(3060),
    [anon_sym_alignas] = ACTIONS(3060),
    [anon_sym_explicit] = ACTIONS(3060),
    [anon_sym_typename] = ACTIONS(3060),
    [anon_sym_template] = ACTIONS(3060),
    [anon_sym_operator] = ACTIONS(3060),
    [anon_sym_friend] = ACTIONS(3060),
    [anon_sym_public] = ACTIONS(3060),
    [anon_sym_private] = ACTIONS(3060),
    [anon_sym_protected] = ACTIONS(3060),
    [anon_sym_using] = ACTIONS(3060),
    [anon_sym_static_assert] = ACTIONS(3060),
  },
  [2095] = {
    [sym_identifier] = ACTIONS(2945),
    [aux_sym_preproc_def_token1] = ACTIONS(2945),
    [aux_sym_preproc_if_token1] = ACTIONS(2945),
    [aux_sym_preproc_if_token2] = ACTIONS(2945),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2945),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2945),
    [sym_preproc_directive] = ACTIONS(2945),
    [anon_sym_LPAREN2] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2947),
    [anon_sym_STAR] = ACTIONS(2947),
    [anon_sym_AMP_AMP] = ACTIONS(2947),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym___extension__] = ACTIONS(2945),
    [anon_sym_typedef] = ACTIONS(2945),
    [anon_sym_extern] = ACTIONS(2945),
    [anon_sym___attribute__] = ACTIONS(2945),
    [anon_sym_COLON_COLON] = ACTIONS(2947),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2947),
    [anon_sym___declspec] = ACTIONS(2945),
    [anon_sym___based] = ACTIONS(2945),
    [anon_sym_signed] = ACTIONS(2945),
    [anon_sym_unsigned] = ACTIONS(2945),
    [anon_sym_long] = ACTIONS(2945),
    [anon_sym_short] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(2945),
    [anon_sym_static] = ACTIONS(2945),
    [anon_sym_register] = ACTIONS(2945),
    [anon_sym_inline] = ACTIONS(2945),
    [anon_sym___inline] = ACTIONS(2945),
    [anon_sym___inline__] = ACTIONS(2945),
    [anon_sym___forceinline] = ACTIONS(2945),
    [anon_sym_thread_local] = ACTIONS(2945),
    [anon_sym___thread] = ACTIONS(2945),
    [anon_sym_const] = ACTIONS(2945),
    [anon_sym_constexpr] = ACTIONS(2945),
    [anon_sym_volatile] = ACTIONS(2945),
    [anon_sym_restrict] = ACTIONS(2945),
    [anon_sym___restrict__] = ACTIONS(2945),
    [anon_sym__Atomic] = ACTIONS(2945),
    [anon_sym__Noreturn] = ACTIONS(2945),
    [anon_sym_noreturn] = ACTIONS(2945),
    [anon_sym_mutable] = ACTIONS(2945),
    [anon_sym_constinit] = ACTIONS(2945),
    [anon_sym_consteval] = ACTIONS(2945),
    [anon_sym_PROGMEM] = ACTIONS(2945),
    [aux_sym_primitive_type_token1] = ACTIONS(2945),
    [anon_sym_byte] = ACTIONS(2945),
    [anon_sym_word] = ACTIONS(2945),
    [anon_sym_enum] = ACTIONS(2945),
    [anon_sym_class] = ACTIONS(2945),
    [anon_sym_struct] = ACTIONS(2945),
    [anon_sym_union] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2945),
    [anon_sym_decltype] = ACTIONS(2945),
    [anon_sym_virtual] = ACTIONS(2945),
    [anon_sym_alignas] = ACTIONS(2945),
    [anon_sym_explicit] = ACTIONS(2945),
    [anon_sym_typename] = ACTIONS(2945),
    [anon_sym_template] = ACTIONS(2945),
    [anon_sym_operator] = ACTIONS(2945),
    [anon_sym_friend] = ACTIONS(2945),
    [anon_sym_public] = ACTIONS(2945),
    [anon_sym_private] = ACTIONS(2945),
    [anon_sym_protected] = ACTIONS(2945),
    [anon_sym_using] = ACTIONS(2945),
    [anon_sym_static_assert] = ACTIONS(2945),
  },
  [2096] = {
    [sym_identifier] = ACTIONS(4859),
    [aux_sym_preproc_def_token1] = ACTIONS(4859),
    [aux_sym_preproc_if_token1] = ACTIONS(4859),
    [aux_sym_preproc_if_token2] = ACTIONS(4859),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4859),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4859),
    [sym_preproc_directive] = ACTIONS(4859),
    [anon_sym_LPAREN2] = ACTIONS(4861),
    [anon_sym_TILDE] = ACTIONS(4861),
    [anon_sym_STAR] = ACTIONS(4861),
    [anon_sym_AMP_AMP] = ACTIONS(4861),
    [anon_sym_AMP] = ACTIONS(4859),
    [anon_sym___extension__] = ACTIONS(4859),
    [anon_sym_typedef] = ACTIONS(4859),
    [anon_sym_extern] = ACTIONS(4859),
    [anon_sym___attribute__] = ACTIONS(4859),
    [anon_sym_COLON_COLON] = ACTIONS(4861),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4861),
    [anon_sym___declspec] = ACTIONS(4859),
    [anon_sym___based] = ACTIONS(4859),
    [anon_sym_signed] = ACTIONS(4859),
    [anon_sym_unsigned] = ACTIONS(4859),
    [anon_sym_long] = ACTIONS(4859),
    [anon_sym_short] = ACTIONS(4859),
    [anon_sym_LBRACK] = ACTIONS(4859),
    [anon_sym_static] = ACTIONS(4859),
    [anon_sym_register] = ACTIONS(4859),
    [anon_sym_inline] = ACTIONS(4859),
    [anon_sym___inline] = ACTIONS(4859),
    [anon_sym___inline__] = ACTIONS(4859),
    [anon_sym___forceinline] = ACTIONS(4859),
    [anon_sym_thread_local] = ACTIONS(4859),
    [anon_sym___thread] = ACTIONS(4859),
    [anon_sym_const] = ACTIONS(4859),
    [anon_sym_constexpr] = ACTIONS(4859),
    [anon_sym_volatile] = ACTIONS(4859),
    [anon_sym_restrict] = ACTIONS(4859),
    [anon_sym___restrict__] = ACTIONS(4859),
    [anon_sym__Atomic] = ACTIONS(4859),
    [anon_sym__Noreturn] = ACTIONS(4859),
    [anon_sym_noreturn] = ACTIONS(4859),
    [anon_sym_mutable] = ACTIONS(4859),
    [anon_sym_constinit] = ACTIONS(4859),
    [anon_sym_consteval] = ACTIONS(4859),
    [anon_sym_PROGMEM] = ACTIONS(4859),
    [aux_sym_primitive_type_token1] = ACTIONS(4859),
    [anon_sym_byte] = ACTIONS(4859),
    [anon_sym_word] = ACTIONS(4859),
    [anon_sym_enum] = ACTIONS(4859),
    [anon_sym_class] = ACTIONS(4859),
    [anon_sym_struct] = ACTIONS(4859),
    [anon_sym_union] = ACTIONS(4859),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4859),
    [anon_sym_decltype] = ACTIONS(4859),
    [anon_sym_virtual] = ACTIONS(4859),
    [anon_sym_alignas] = ACTIONS(4859),
    [anon_sym_explicit] = ACTIONS(4859),
    [anon_sym_typename] = ACTIONS(4859),
    [anon_sym_template] = ACTIONS(4859),
    [anon_sym_operator] = ACTIONS(4859),
    [anon_sym_friend] = ACTIONS(4859),
    [anon_sym_public] = ACTIONS(4859),
    [anon_sym_private] = ACTIONS(4859),
    [anon_sym_protected] = ACTIONS(4859),
    [anon_sym_using] = ACTIONS(4859),
    [anon_sym_static_assert] = ACTIONS(4859),
  },
  [2097] = {
    [sym_identifier] = ACTIONS(4863),
    [aux_sym_preproc_def_token1] = ACTIONS(4863),
    [aux_sym_preproc_if_token1] = ACTIONS(4863),
    [aux_sym_preproc_if_token2] = ACTIONS(4863),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4863),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4863),
    [sym_preproc_directive] = ACTIONS(4863),
    [anon_sym_LPAREN2] = ACTIONS(4865),
    [anon_sym_TILDE] = ACTIONS(4865),
    [anon_sym_STAR] = ACTIONS(4865),
    [anon_sym_AMP_AMP] = ACTIONS(4865),
    [anon_sym_AMP] = ACTIONS(4863),
    [anon_sym___extension__] = ACTIONS(4863),
    [anon_sym_typedef] = ACTIONS(4863),
    [anon_sym_extern] = ACTIONS(4863),
    [anon_sym___attribute__] = ACTIONS(4863),
    [anon_sym_COLON_COLON] = ACTIONS(4865),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4865),
    [anon_sym___declspec] = ACTIONS(4863),
    [anon_sym___based] = ACTIONS(4863),
    [anon_sym_signed] = ACTIONS(4863),
    [anon_sym_unsigned] = ACTIONS(4863),
    [anon_sym_long] = ACTIONS(4863),
    [anon_sym_short] = ACTIONS(4863),
    [anon_sym_LBRACK] = ACTIONS(4863),
    [anon_sym_static] = ACTIONS(4863),
    [anon_sym_register] = ACTIONS(4863),
    [anon_sym_inline] = ACTIONS(4863),
    [anon_sym___inline] = ACTIONS(4863),
    [anon_sym___inline__] = ACTIONS(4863),
    [anon_sym___forceinline] = ACTIONS(4863),
    [anon_sym_thread_local] = ACTIONS(4863),
    [anon_sym___thread] = ACTIONS(4863),
    [anon_sym_const] = ACTIONS(4863),
    [anon_sym_constexpr] = ACTIONS(4863),
    [anon_sym_volatile] = ACTIONS(4863),
    [anon_sym_restrict] = ACTIONS(4863),
    [anon_sym___restrict__] = ACTIONS(4863),
    [anon_sym__Atomic] = ACTIONS(4863),
    [anon_sym__Noreturn] = ACTIONS(4863),
    [anon_sym_noreturn] = ACTIONS(4863),
    [anon_sym_mutable] = ACTIONS(4863),
    [anon_sym_constinit] = ACTIONS(4863),
    [anon_sym_consteval] = ACTIONS(4863),
    [anon_sym_PROGMEM] = ACTIONS(4863),
    [aux_sym_primitive_type_token1] = ACTIONS(4863),
    [anon_sym_byte] = ACTIONS(4863),
    [anon_sym_word] = ACTIONS(4863),
    [anon_sym_enum] = ACTIONS(4863),
    [anon_sym_class] = ACTIONS(4863),
    [anon_sym_struct] = ACTIONS(4863),
    [anon_sym_union] = ACTIONS(4863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4863),
    [anon_sym_decltype] = ACTIONS(4863),
    [anon_sym_virtual] = ACTIONS(4863),
    [anon_sym_alignas] = ACTIONS(4863),
    [anon_sym_explicit] = ACTIONS(4863),
    [anon_sym_typename] = ACTIONS(4863),
    [anon_sym_template] = ACTIONS(4863),
    [anon_sym_operator] = ACTIONS(4863),
    [anon_sym_friend] = ACTIONS(4863),
    [anon_sym_public] = ACTIONS(4863),
    [anon_sym_private] = ACTIONS(4863),
    [anon_sym_protected] = ACTIONS(4863),
    [anon_sym_using] = ACTIONS(4863),
    [anon_sym_static_assert] = ACTIONS(4863),
  },
  [2098] = {
    [sym_identifier] = ACTIONS(3468),
    [aux_sym_preproc_def_token1] = ACTIONS(3468),
    [aux_sym_preproc_if_token1] = ACTIONS(3468),
    [aux_sym_preproc_if_token2] = ACTIONS(3468),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3468),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3468),
    [sym_preproc_directive] = ACTIONS(3468),
    [anon_sym_LPAREN2] = ACTIONS(3466),
    [anon_sym_TILDE] = ACTIONS(3466),
    [anon_sym_STAR] = ACTIONS(3466),
    [anon_sym_AMP_AMP] = ACTIONS(3466),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym___extension__] = ACTIONS(3468),
    [anon_sym_typedef] = ACTIONS(3468),
    [anon_sym_extern] = ACTIONS(3468),
    [anon_sym___attribute__] = ACTIONS(3468),
    [anon_sym_COLON_COLON] = ACTIONS(3466),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3466),
    [anon_sym___declspec] = ACTIONS(3468),
    [anon_sym___based] = ACTIONS(3468),
    [anon_sym_signed] = ACTIONS(3468),
    [anon_sym_unsigned] = ACTIONS(3468),
    [anon_sym_long] = ACTIONS(3468),
    [anon_sym_short] = ACTIONS(3468),
    [anon_sym_LBRACK] = ACTIONS(3468),
    [anon_sym_static] = ACTIONS(3468),
    [anon_sym_register] = ACTIONS(3468),
    [anon_sym_inline] = ACTIONS(3468),
    [anon_sym___inline] = ACTIONS(3468),
    [anon_sym___inline__] = ACTIONS(3468),
    [anon_sym___forceinline] = ACTIONS(3468),
    [anon_sym_thread_local] = ACTIONS(3468),
    [anon_sym___thread] = ACTIONS(3468),
    [anon_sym_const] = ACTIONS(3468),
    [anon_sym_constexpr] = ACTIONS(3468),
    [anon_sym_volatile] = ACTIONS(3468),
    [anon_sym_restrict] = ACTIONS(3468),
    [anon_sym___restrict__] = ACTIONS(3468),
    [anon_sym__Atomic] = ACTIONS(3468),
    [anon_sym__Noreturn] = ACTIONS(3468),
    [anon_sym_noreturn] = ACTIONS(3468),
    [anon_sym_mutable] = ACTIONS(3468),
    [anon_sym_constinit] = ACTIONS(3468),
    [anon_sym_consteval] = ACTIONS(3468),
    [anon_sym_PROGMEM] = ACTIONS(3468),
    [aux_sym_primitive_type_token1] = ACTIONS(3468),
    [anon_sym_byte] = ACTIONS(3468),
    [anon_sym_word] = ACTIONS(3468),
    [anon_sym_enum] = ACTIONS(3468),
    [anon_sym_class] = ACTIONS(3468),
    [anon_sym_struct] = ACTIONS(3468),
    [anon_sym_union] = ACTIONS(3468),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3468),
    [anon_sym_decltype] = ACTIONS(3468),
    [anon_sym_virtual] = ACTIONS(3468),
    [anon_sym_alignas] = ACTIONS(3468),
    [anon_sym_explicit] = ACTIONS(3468),
    [anon_sym_typename] = ACTIONS(3468),
    [anon_sym_template] = ACTIONS(3468),
    [anon_sym_operator] = ACTIONS(3468),
    [anon_sym_friend] = ACTIONS(3468),
    [anon_sym_public] = ACTIONS(3468),
    [anon_sym_private] = ACTIONS(3468),
    [anon_sym_protected] = ACTIONS(3468),
    [anon_sym_using] = ACTIONS(3468),
    [anon_sym_static_assert] = ACTIONS(3468),
  },
  [2099] = {
    [sym_identifier] = ACTIONS(2925),
    [aux_sym_preproc_def_token1] = ACTIONS(2925),
    [aux_sym_preproc_if_token1] = ACTIONS(2925),
    [aux_sym_preproc_if_token2] = ACTIONS(2925),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2925),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2925),
    [sym_preproc_directive] = ACTIONS(2925),
    [anon_sym_LPAREN2] = ACTIONS(2927),
    [anon_sym_TILDE] = ACTIONS(2927),
    [anon_sym_STAR] = ACTIONS(2927),
    [anon_sym_AMP_AMP] = ACTIONS(2927),
    [anon_sym_AMP] = ACTIONS(2925),
    [anon_sym___extension__] = ACTIONS(2925),
    [anon_sym_typedef] = ACTIONS(2925),
    [anon_sym_extern] = ACTIONS(2925),
    [anon_sym___attribute__] = ACTIONS(2925),
    [anon_sym_COLON_COLON] = ACTIONS(2927),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2927),
    [anon_sym___declspec] = ACTIONS(2925),
    [anon_sym___based] = ACTIONS(2925),
    [anon_sym_signed] = ACTIONS(2925),
    [anon_sym_unsigned] = ACTIONS(2925),
    [anon_sym_long] = ACTIONS(2925),
    [anon_sym_short] = ACTIONS(2925),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_static] = ACTIONS(2925),
    [anon_sym_register] = ACTIONS(2925),
    [anon_sym_inline] = ACTIONS(2925),
    [anon_sym___inline] = ACTIONS(2925),
    [anon_sym___inline__] = ACTIONS(2925),
    [anon_sym___forceinline] = ACTIONS(2925),
    [anon_sym_thread_local] = ACTIONS(2925),
    [anon_sym___thread] = ACTIONS(2925),
    [anon_sym_const] = ACTIONS(2925),
    [anon_sym_constexpr] = ACTIONS(2925),
    [anon_sym_volatile] = ACTIONS(2925),
    [anon_sym_restrict] = ACTIONS(2925),
    [anon_sym___restrict__] = ACTIONS(2925),
    [anon_sym__Atomic] = ACTIONS(2925),
    [anon_sym__Noreturn] = ACTIONS(2925),
    [anon_sym_noreturn] = ACTIONS(2925),
    [anon_sym_mutable] = ACTIONS(2925),
    [anon_sym_constinit] = ACTIONS(2925),
    [anon_sym_consteval] = ACTIONS(2925),
    [anon_sym_PROGMEM] = ACTIONS(2925),
    [aux_sym_primitive_type_token1] = ACTIONS(2925),
    [anon_sym_byte] = ACTIONS(2925),
    [anon_sym_word] = ACTIONS(2925),
    [anon_sym_enum] = ACTIONS(2925),
    [anon_sym_class] = ACTIONS(2925),
    [anon_sym_struct] = ACTIONS(2925),
    [anon_sym_union] = ACTIONS(2925),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2925),
    [anon_sym_decltype] = ACTIONS(2925),
    [anon_sym_virtual] = ACTIONS(2925),
    [anon_sym_alignas] = ACTIONS(2925),
    [anon_sym_explicit] = ACTIONS(2925),
    [anon_sym_typename] = ACTIONS(2925),
    [anon_sym_template] = ACTIONS(2925),
    [anon_sym_operator] = ACTIONS(2925),
    [anon_sym_friend] = ACTIONS(2925),
    [anon_sym_public] = ACTIONS(2925),
    [anon_sym_private] = ACTIONS(2925),
    [anon_sym_protected] = ACTIONS(2925),
    [anon_sym_using] = ACTIONS(2925),
    [anon_sym_static_assert] = ACTIONS(2925),
  },
  [2100] = {
    [sym_identifier] = ACTIONS(3472),
    [aux_sym_preproc_def_token1] = ACTIONS(3472),
    [aux_sym_preproc_if_token1] = ACTIONS(3472),
    [aux_sym_preproc_if_token2] = ACTIONS(3472),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3472),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3472),
    [sym_preproc_directive] = ACTIONS(3472),
    [anon_sym_LPAREN2] = ACTIONS(3470),
    [anon_sym_TILDE] = ACTIONS(3470),
    [anon_sym_STAR] = ACTIONS(3470),
    [anon_sym_AMP_AMP] = ACTIONS(3470),
    [anon_sym_AMP] = ACTIONS(3472),
    [anon_sym___extension__] = ACTIONS(3472),
    [anon_sym_typedef] = ACTIONS(3472),
    [anon_sym_extern] = ACTIONS(3472),
    [anon_sym___attribute__] = ACTIONS(3472),
    [anon_sym_COLON_COLON] = ACTIONS(3470),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3470),
    [anon_sym___declspec] = ACTIONS(3472),
    [anon_sym___based] = ACTIONS(3472),
    [anon_sym_signed] = ACTIONS(3472),
    [anon_sym_unsigned] = ACTIONS(3472),
    [anon_sym_long] = ACTIONS(3472),
    [anon_sym_short] = ACTIONS(3472),
    [anon_sym_LBRACK] = ACTIONS(3472),
    [anon_sym_static] = ACTIONS(3472),
    [anon_sym_register] = ACTIONS(3472),
    [anon_sym_inline] = ACTIONS(3472),
    [anon_sym___inline] = ACTIONS(3472),
    [anon_sym___inline__] = ACTIONS(3472),
    [anon_sym___forceinline] = ACTIONS(3472),
    [anon_sym_thread_local] = ACTIONS(3472),
    [anon_sym___thread] = ACTIONS(3472),
    [anon_sym_const] = ACTIONS(3472),
    [anon_sym_constexpr] = ACTIONS(3472),
    [anon_sym_volatile] = ACTIONS(3472),
    [anon_sym_restrict] = ACTIONS(3472),
    [anon_sym___restrict__] = ACTIONS(3472),
    [anon_sym__Atomic] = ACTIONS(3472),
    [anon_sym__Noreturn] = ACTIONS(3472),
    [anon_sym_noreturn] = ACTIONS(3472),
    [anon_sym_mutable] = ACTIONS(3472),
    [anon_sym_constinit] = ACTIONS(3472),
    [anon_sym_consteval] = ACTIONS(3472),
    [anon_sym_PROGMEM] = ACTIONS(3472),
    [aux_sym_primitive_type_token1] = ACTIONS(3472),
    [anon_sym_byte] = ACTIONS(3472),
    [anon_sym_word] = ACTIONS(3472),
    [anon_sym_enum] = ACTIONS(3472),
    [anon_sym_class] = ACTIONS(3472),
    [anon_sym_struct] = ACTIONS(3472),
    [anon_sym_union] = ACTIONS(3472),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3472),
    [anon_sym_decltype] = ACTIONS(3472),
    [anon_sym_virtual] = ACTIONS(3472),
    [anon_sym_alignas] = ACTIONS(3472),
    [anon_sym_explicit] = ACTIONS(3472),
    [anon_sym_typename] = ACTIONS(3472),
    [anon_sym_template] = ACTIONS(3472),
    [anon_sym_operator] = ACTIONS(3472),
    [anon_sym_friend] = ACTIONS(3472),
    [anon_sym_public] = ACTIONS(3472),
    [anon_sym_private] = ACTIONS(3472),
    [anon_sym_protected] = ACTIONS(3472),
    [anon_sym_using] = ACTIONS(3472),
    [anon_sym_static_assert] = ACTIONS(3472),
  },
  [2101] = {
    [sym_identifier] = ACTIONS(2731),
    [aux_sym_preproc_def_token1] = ACTIONS(2731),
    [aux_sym_preproc_if_token1] = ACTIONS(2731),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2731),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2731),
    [sym_preproc_directive] = ACTIONS(2731),
    [anon_sym_LPAREN2] = ACTIONS(2733),
    [anon_sym_TILDE] = ACTIONS(2733),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_AMP_AMP] = ACTIONS(2733),
    [anon_sym_AMP] = ACTIONS(2731),
    [anon_sym___extension__] = ACTIONS(2731),
    [anon_sym_typedef] = ACTIONS(2731),
    [anon_sym_extern] = ACTIONS(2731),
    [anon_sym___attribute__] = ACTIONS(2731),
    [anon_sym_COLON_COLON] = ACTIONS(2733),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2733),
    [anon_sym___declspec] = ACTIONS(2731),
    [anon_sym___based] = ACTIONS(2731),
    [anon_sym_RBRACE] = ACTIONS(2733),
    [anon_sym_signed] = ACTIONS(2731),
    [anon_sym_unsigned] = ACTIONS(2731),
    [anon_sym_long] = ACTIONS(2731),
    [anon_sym_short] = ACTIONS(2731),
    [anon_sym_LBRACK] = ACTIONS(2731),
    [anon_sym_static] = ACTIONS(2731),
    [anon_sym_register] = ACTIONS(2731),
    [anon_sym_inline] = ACTIONS(2731),
    [anon_sym___inline] = ACTIONS(2731),
    [anon_sym___inline__] = ACTIONS(2731),
    [anon_sym___forceinline] = ACTIONS(2731),
    [anon_sym_thread_local] = ACTIONS(2731),
    [anon_sym___thread] = ACTIONS(2731),
    [anon_sym_const] = ACTIONS(2731),
    [anon_sym_constexpr] = ACTIONS(2731),
    [anon_sym_volatile] = ACTIONS(2731),
    [anon_sym_restrict] = ACTIONS(2731),
    [anon_sym___restrict__] = ACTIONS(2731),
    [anon_sym__Atomic] = ACTIONS(2731),
    [anon_sym__Noreturn] = ACTIONS(2731),
    [anon_sym_noreturn] = ACTIONS(2731),
    [anon_sym_mutable] = ACTIONS(2731),
    [anon_sym_constinit] = ACTIONS(2731),
    [anon_sym_consteval] = ACTIONS(2731),
    [anon_sym_PROGMEM] = ACTIONS(2731),
    [aux_sym_primitive_type_token1] = ACTIONS(2731),
    [anon_sym_byte] = ACTIONS(2731),
    [anon_sym_word] = ACTIONS(2731),
    [anon_sym_enum] = ACTIONS(2731),
    [anon_sym_class] = ACTIONS(2731),
    [anon_sym_struct] = ACTIONS(2731),
    [anon_sym_union] = ACTIONS(2731),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2731),
    [anon_sym_decltype] = ACTIONS(2731),
    [anon_sym_virtual] = ACTIONS(2731),
    [anon_sym_alignas] = ACTIONS(2731),
    [anon_sym_explicit] = ACTIONS(2731),
    [anon_sym_typename] = ACTIONS(2731),
    [anon_sym_template] = ACTIONS(2731),
    [anon_sym_operator] = ACTIONS(2731),
    [anon_sym_friend] = ACTIONS(2731),
    [anon_sym_public] = ACTIONS(2731),
    [anon_sym_private] = ACTIONS(2731),
    [anon_sym_protected] = ACTIONS(2731),
    [anon_sym_using] = ACTIONS(2731),
    [anon_sym_static_assert] = ACTIONS(2731),
  },
  [2102] = {
    [sym_identifier] = ACTIONS(3476),
    [aux_sym_preproc_def_token1] = ACTIONS(3476),
    [aux_sym_preproc_if_token1] = ACTIONS(3476),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3476),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3476),
    [sym_preproc_directive] = ACTIONS(3476),
    [anon_sym_LPAREN2] = ACTIONS(3474),
    [anon_sym_TILDE] = ACTIONS(3474),
    [anon_sym_STAR] = ACTIONS(3474),
    [anon_sym_AMP_AMP] = ACTIONS(3474),
    [anon_sym_AMP] = ACTIONS(3476),
    [anon_sym___extension__] = ACTIONS(3476),
    [anon_sym_typedef] = ACTIONS(3476),
    [anon_sym_extern] = ACTIONS(3476),
    [anon_sym___attribute__] = ACTIONS(3476),
    [anon_sym_COLON_COLON] = ACTIONS(3474),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3474),
    [anon_sym___declspec] = ACTIONS(3476),
    [anon_sym___based] = ACTIONS(3476),
    [anon_sym_RBRACE] = ACTIONS(3474),
    [anon_sym_signed] = ACTIONS(3476),
    [anon_sym_unsigned] = ACTIONS(3476),
    [anon_sym_long] = ACTIONS(3476),
    [anon_sym_short] = ACTIONS(3476),
    [anon_sym_LBRACK] = ACTIONS(3476),
    [anon_sym_static] = ACTIONS(3476),
    [anon_sym_register] = ACTIONS(3476),
    [anon_sym_inline] = ACTIONS(3476),
    [anon_sym___inline] = ACTIONS(3476),
    [anon_sym___inline__] = ACTIONS(3476),
    [anon_sym___forceinline] = ACTIONS(3476),
    [anon_sym_thread_local] = ACTIONS(3476),
    [anon_sym___thread] = ACTIONS(3476),
    [anon_sym_const] = ACTIONS(3476),
    [anon_sym_constexpr] = ACTIONS(3476),
    [anon_sym_volatile] = ACTIONS(3476),
    [anon_sym_restrict] = ACTIONS(3476),
    [anon_sym___restrict__] = ACTIONS(3476),
    [anon_sym__Atomic] = ACTIONS(3476),
    [anon_sym__Noreturn] = ACTIONS(3476),
    [anon_sym_noreturn] = ACTIONS(3476),
    [anon_sym_mutable] = ACTIONS(3476),
    [anon_sym_constinit] = ACTIONS(3476),
    [anon_sym_consteval] = ACTIONS(3476),
    [anon_sym_PROGMEM] = ACTIONS(3476),
    [aux_sym_primitive_type_token1] = ACTIONS(3476),
    [anon_sym_byte] = ACTIONS(3476),
    [anon_sym_word] = ACTIONS(3476),
    [anon_sym_enum] = ACTIONS(3476),
    [anon_sym_class] = ACTIONS(3476),
    [anon_sym_struct] = ACTIONS(3476),
    [anon_sym_union] = ACTIONS(3476),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3476),
    [anon_sym_decltype] = ACTIONS(3476),
    [anon_sym_virtual] = ACTIONS(3476),
    [anon_sym_alignas] = ACTIONS(3476),
    [anon_sym_explicit] = ACTIONS(3476),
    [anon_sym_typename] = ACTIONS(3476),
    [anon_sym_template] = ACTIONS(3476),
    [anon_sym_operator] = ACTIONS(3476),
    [anon_sym_friend] = ACTIONS(3476),
    [anon_sym_public] = ACTIONS(3476),
    [anon_sym_private] = ACTIONS(3476),
    [anon_sym_protected] = ACTIONS(3476),
    [anon_sym_using] = ACTIONS(3476),
    [anon_sym_static_assert] = ACTIONS(3476),
  },
  [2103] = {
    [sym_identifier] = ACTIONS(5000),
    [aux_sym_preproc_def_token1] = ACTIONS(5000),
    [aux_sym_preproc_if_token1] = ACTIONS(5000),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5000),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5000),
    [sym_preproc_directive] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [anon_sym_STAR] = ACTIONS(5002),
    [anon_sym_AMP_AMP] = ACTIONS(5002),
    [anon_sym_AMP] = ACTIONS(5000),
    [anon_sym___extension__] = ACTIONS(5000),
    [anon_sym_typedef] = ACTIONS(5000),
    [anon_sym_extern] = ACTIONS(5000),
    [anon_sym___attribute__] = ACTIONS(5000),
    [anon_sym_COLON_COLON] = ACTIONS(5002),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5002),
    [anon_sym___declspec] = ACTIONS(5000),
    [anon_sym___based] = ACTIONS(5000),
    [anon_sym_RBRACE] = ACTIONS(5002),
    [anon_sym_signed] = ACTIONS(5000),
    [anon_sym_unsigned] = ACTIONS(5000),
    [anon_sym_long] = ACTIONS(5000),
    [anon_sym_short] = ACTIONS(5000),
    [anon_sym_LBRACK] = ACTIONS(5000),
    [anon_sym_static] = ACTIONS(5000),
    [anon_sym_register] = ACTIONS(5000),
    [anon_sym_inline] = ACTIONS(5000),
    [anon_sym___inline] = ACTIONS(5000),
    [anon_sym___inline__] = ACTIONS(5000),
    [anon_sym___forceinline] = ACTIONS(5000),
    [anon_sym_thread_local] = ACTIONS(5000),
    [anon_sym___thread] = ACTIONS(5000),
    [anon_sym_const] = ACTIONS(5000),
    [anon_sym_constexpr] = ACTIONS(5000),
    [anon_sym_volatile] = ACTIONS(5000),
    [anon_sym_restrict] = ACTIONS(5000),
    [anon_sym___restrict__] = ACTIONS(5000),
    [anon_sym__Atomic] = ACTIONS(5000),
    [anon_sym__Noreturn] = ACTIONS(5000),
    [anon_sym_noreturn] = ACTIONS(5000),
    [anon_sym_mutable] = ACTIONS(5000),
    [anon_sym_constinit] = ACTIONS(5000),
    [anon_sym_consteval] = ACTIONS(5000),
    [anon_sym_PROGMEM] = ACTIONS(5000),
    [aux_sym_primitive_type_token1] = ACTIONS(5000),
    [anon_sym_byte] = ACTIONS(5000),
    [anon_sym_word] = ACTIONS(5000),
    [anon_sym_enum] = ACTIONS(5000),
    [anon_sym_class] = ACTIONS(5000),
    [anon_sym_struct] = ACTIONS(5000),
    [anon_sym_union] = ACTIONS(5000),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5000),
    [anon_sym_decltype] = ACTIONS(5000),
    [anon_sym_virtual] = ACTIONS(5000),
    [anon_sym_alignas] = ACTIONS(5000),
    [anon_sym_explicit] = ACTIONS(5000),
    [anon_sym_typename] = ACTIONS(5000),
    [anon_sym_template] = ACTIONS(5000),
    [anon_sym_operator] = ACTIONS(5000),
    [anon_sym_friend] = ACTIONS(5000),
    [anon_sym_public] = ACTIONS(5000),
    [anon_sym_private] = ACTIONS(5000),
    [anon_sym_protected] = ACTIONS(5000),
    [anon_sym_using] = ACTIONS(5000),
    [anon_sym_static_assert] = ACTIONS(5000),
  },
  [2104] = {
    [sym_identifier] = ACTIONS(3064),
    [aux_sym_preproc_def_token1] = ACTIONS(3064),
    [aux_sym_preproc_if_token1] = ACTIONS(3064),
    [aux_sym_preproc_if_token2] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3064),
    [sym_preproc_directive] = ACTIONS(3064),
    [anon_sym_LPAREN2] = ACTIONS(3066),
    [anon_sym_TILDE] = ACTIONS(3066),
    [anon_sym_STAR] = ACTIONS(3066),
    [anon_sym_AMP_AMP] = ACTIONS(3066),
    [anon_sym_AMP] = ACTIONS(3064),
    [anon_sym___extension__] = ACTIONS(3064),
    [anon_sym_typedef] = ACTIONS(3064),
    [anon_sym_extern] = ACTIONS(3064),
    [anon_sym___attribute__] = ACTIONS(3064),
    [anon_sym_COLON_COLON] = ACTIONS(3066),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3066),
    [anon_sym___declspec] = ACTIONS(3064),
    [anon_sym___based] = ACTIONS(3064),
    [anon_sym_signed] = ACTIONS(3064),
    [anon_sym_unsigned] = ACTIONS(3064),
    [anon_sym_long] = ACTIONS(3064),
    [anon_sym_short] = ACTIONS(3064),
    [anon_sym_LBRACK] = ACTIONS(3064),
    [anon_sym_static] = ACTIONS(3064),
    [anon_sym_register] = ACTIONS(3064),
    [anon_sym_inline] = ACTIONS(3064),
    [anon_sym___inline] = ACTIONS(3064),
    [anon_sym___inline__] = ACTIONS(3064),
    [anon_sym___forceinline] = ACTIONS(3064),
    [anon_sym_thread_local] = ACTIONS(3064),
    [anon_sym___thread] = ACTIONS(3064),
    [anon_sym_const] = ACTIONS(3064),
    [anon_sym_constexpr] = ACTIONS(3064),
    [anon_sym_volatile] = ACTIONS(3064),
    [anon_sym_restrict] = ACTIONS(3064),
    [anon_sym___restrict__] = ACTIONS(3064),
    [anon_sym__Atomic] = ACTIONS(3064),
    [anon_sym__Noreturn] = ACTIONS(3064),
    [anon_sym_noreturn] = ACTIONS(3064),
    [anon_sym_mutable] = ACTIONS(3064),
    [anon_sym_constinit] = ACTIONS(3064),
    [anon_sym_consteval] = ACTIONS(3064),
    [anon_sym_PROGMEM] = ACTIONS(3064),
    [aux_sym_primitive_type_token1] = ACTIONS(3064),
    [anon_sym_byte] = ACTIONS(3064),
    [anon_sym_word] = ACTIONS(3064),
    [anon_sym_enum] = ACTIONS(3064),
    [anon_sym_class] = ACTIONS(3064),
    [anon_sym_struct] = ACTIONS(3064),
    [anon_sym_union] = ACTIONS(3064),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3064),
    [anon_sym_decltype] = ACTIONS(3064),
    [anon_sym_virtual] = ACTIONS(3064),
    [anon_sym_alignas] = ACTIONS(3064),
    [anon_sym_explicit] = ACTIONS(3064),
    [anon_sym_typename] = ACTIONS(3064),
    [anon_sym_template] = ACTIONS(3064),
    [anon_sym_operator] = ACTIONS(3064),
    [anon_sym_friend] = ACTIONS(3064),
    [anon_sym_public] = ACTIONS(3064),
    [anon_sym_private] = ACTIONS(3064),
    [anon_sym_protected] = ACTIONS(3064),
    [anon_sym_using] = ACTIONS(3064),
    [anon_sym_static_assert] = ACTIONS(3064),
  },
  [2105] = {
    [sym_string_literal] = STATE(2079),
    [sym_template_argument_list] = STATE(3123),
    [sym_raw_string_literal] = STATE(2079),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3761),
    [anon_sym_COMMA] = ACTIONS(3761),
    [anon_sym_RPAREN] = ACTIONS(3761),
    [anon_sym_LPAREN2] = ACTIONS(3761),
    [anon_sym_DASH] = ACTIONS(3769),
    [anon_sym_PLUS] = ACTIONS(3769),
    [anon_sym_STAR] = ACTIONS(3769),
    [anon_sym_SLASH] = ACTIONS(3769),
    [anon_sym_PERCENT] = ACTIONS(3769),
    [anon_sym_PIPE_PIPE] = ACTIONS(3761),
    [anon_sym_AMP_AMP] = ACTIONS(3761),
    [anon_sym_PIPE] = ACTIONS(3769),
    [anon_sym_CARET] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(3769),
    [anon_sym_EQ_EQ] = ACTIONS(3761),
    [anon_sym_BANG_EQ] = ACTIONS(3761),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3761),
    [anon_sym_LT_EQ] = ACTIONS(3769),
    [anon_sym_LT] = ACTIONS(4609),
    [anon_sym_LT_LT] = ACTIONS(3769),
    [anon_sym_GT_GT] = ACTIONS(3769),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(3785),
    [anon_sym_LBRACK] = ACTIONS(3761),
    [anon_sym_EQ] = ACTIONS(3769),
    [anon_sym_QMARK] = ACTIONS(3761),
    [anon_sym_STAR_EQ] = ACTIONS(3761),
    [anon_sym_SLASH_EQ] = ACTIONS(3761),
    [anon_sym_PERCENT_EQ] = ACTIONS(3761),
    [anon_sym_PLUS_EQ] = ACTIONS(3761),
    [anon_sym_DASH_EQ] = ACTIONS(3761),
    [anon_sym_LT_LT_EQ] = ACTIONS(3761),
    [anon_sym_GT_GT_EQ] = ACTIONS(3761),
    [anon_sym_AMP_EQ] = ACTIONS(3761),
    [anon_sym_CARET_EQ] = ACTIONS(3761),
    [anon_sym_PIPE_EQ] = ACTIONS(3761),
    [anon_sym_and_eq] = ACTIONS(3761),
    [anon_sym_or_eq] = ACTIONS(3761),
    [anon_sym_xor_eq] = ACTIONS(3761),
    [anon_sym_LT_EQ_GT] = ACTIONS(3761),
    [anon_sym_or] = ACTIONS(3769),
    [anon_sym_and] = ACTIONS(3769),
    [anon_sym_bitor] = ACTIONS(3761),
    [anon_sym_xor] = ACTIONS(3769),
    [anon_sym_bitand] = ACTIONS(3761),
    [anon_sym_not_eq] = ACTIONS(3761),
    [anon_sym_DASH_DASH] = ACTIONS(3761),
    [anon_sym_PLUS_PLUS] = ACTIONS(3761),
    [anon_sym_DOT] = ACTIONS(3769),
    [anon_sym_DOT_STAR] = ACTIONS(3761),
    [anon_sym_DASH_GT] = ACTIONS(3769),
    [anon_sym_L_DQUOTE] = ACTIONS(4605),
    [anon_sym_u_DQUOTE] = ACTIONS(4605),
    [anon_sym_U_DQUOTE] = ACTIONS(4605),
    [anon_sym_u8_DQUOTE] = ACTIONS(4605),
    [anon_sym_DQUOTE] = ACTIONS(4605),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4607),
    [anon_sym_LR_DQUOTE] = ACTIONS(4607),
    [anon_sym_uR_DQUOTE] = ACTIONS(4607),
    [anon_sym_UR_DQUOTE] = ACTIONS(4607),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4607),
    [anon_sym_DASH_GT_STAR] = ACTIONS(3761),
  },
  [2106] = {
    [sym_identifier] = ACTIONS(3056),
    [aux_sym_preproc_def_token1] = ACTIONS(3056),
    [aux_sym_preproc_if_token1] = ACTIONS(3056),
    [aux_sym_preproc_if_token2] = ACTIONS(3056),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3056),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3056),
    [sym_preproc_directive] = ACTIONS(3056),
    [anon_sym_LPAREN2] = ACTIONS(3058),
    [anon_sym_TILDE] = ACTIONS(3058),
    [anon_sym_STAR] = ACTIONS(3058),
    [anon_sym_AMP_AMP] = ACTIONS(3058),
    [anon_sym_AMP] = ACTIONS(3056),
    [anon_sym___extension__] = ACTIONS(3056),
    [anon_sym_typedef] = ACTIONS(3056),
    [anon_sym_extern] = ACTIONS(3056),
    [anon_sym___attribute__] = ACTIONS(3056),
    [anon_sym_COLON_COLON] = ACTIONS(3058),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3058),
    [anon_sym___declspec] = ACTIONS(3056),
    [anon_sym___based] = ACTIONS(3056),
    [anon_sym_signed] = ACTIONS(3056),
    [anon_sym_unsigned] = ACTIONS(3056),
    [anon_sym_long] = ACTIONS(3056),
    [anon_sym_short] = ACTIONS(3056),
    [anon_sym_LBRACK] = ACTIONS(3056),
    [anon_sym_static] = ACTIONS(3056),
    [anon_sym_register] = ACTIONS(3056),
    [anon_sym_inline] = ACTIONS(3056),
    [anon_sym___inline] = ACTIONS(3056),
    [anon_sym___inline__] = ACTIONS(3056),
    [anon_sym___forceinline] = ACTIONS(3056),
    [anon_sym_thread_local] = ACTIONS(3056),
    [anon_sym___thread] = ACTIONS(3056),
    [anon_sym_const] = ACTIONS(3056),
    [anon_sym_constexpr] = ACTIONS(3056),
    [anon_sym_volatile] = ACTIONS(3056),
    [anon_sym_restrict] = ACTIONS(3056),
    [anon_sym___restrict__] = ACTIONS(3056),
    [anon_sym__Atomic] = ACTIONS(3056),
    [anon_sym__Noreturn] = ACTIONS(3056),
    [anon_sym_noreturn] = ACTIONS(3056),
    [anon_sym_mutable] = ACTIONS(3056),
    [anon_sym_constinit] = ACTIONS(3056),
    [anon_sym_consteval] = ACTIONS(3056),
    [anon_sym_PROGMEM] = ACTIONS(3056),
    [aux_sym_primitive_type_token1] = ACTIONS(3056),
    [anon_sym_byte] = ACTIONS(3056),
    [anon_sym_word] = ACTIONS(3056),
    [anon_sym_enum] = ACTIONS(3056),
    [anon_sym_class] = ACTIONS(3056),
    [anon_sym_struct] = ACTIONS(3056),
    [anon_sym_union] = ACTIONS(3056),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3056),
    [anon_sym_decltype] = ACTIONS(3056),
    [anon_sym_virtual] = ACTIONS(3056),
    [anon_sym_alignas] = ACTIONS(3056),
    [anon_sym_explicit] = ACTIONS(3056),
    [anon_sym_typename] = ACTIONS(3056),
    [anon_sym_template] = ACTIONS(3056),
    [anon_sym_operator] = ACTIONS(3056),
    [anon_sym_friend] = ACTIONS(3056),
    [anon_sym_public] = ACTIONS(3056),
    [anon_sym_private] = ACTIONS(3056),
    [anon_sym_protected] = ACTIONS(3056),
    [anon_sym_using] = ACTIONS(3056),
    [anon_sym_static_assert] = ACTIONS(3056),
  },
  [2107] = {
    [sym_identifier] = ACTIONS(3170),
    [aux_sym_preproc_def_token1] = ACTIONS(3170),
    [aux_sym_preproc_if_token1] = ACTIONS(3170),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3170),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3170),
    [sym_preproc_directive] = ACTIONS(3170),
    [anon_sym_LPAREN2] = ACTIONS(3172),
    [anon_sym_TILDE] = ACTIONS(3172),
    [anon_sym_STAR] = ACTIONS(3172),
    [anon_sym_AMP_AMP] = ACTIONS(3172),
    [anon_sym_AMP] = ACTIONS(3170),
    [anon_sym___extension__] = ACTIONS(3170),
    [anon_sym_typedef] = ACTIONS(3170),
    [anon_sym_extern] = ACTIONS(3170),
    [anon_sym___attribute__] = ACTIONS(3170),
    [anon_sym_COLON_COLON] = ACTIONS(3172),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3172),
    [anon_sym___declspec] = ACTIONS(3170),
    [anon_sym___based] = ACTIONS(3170),
    [anon_sym_RBRACE] = ACTIONS(3172),
    [anon_sym_signed] = ACTIONS(3170),
    [anon_sym_unsigned] = ACTIONS(3170),
    [anon_sym_long] = ACTIONS(3170),
    [anon_sym_short] = ACTIONS(3170),
    [anon_sym_LBRACK] = ACTIONS(3170),
    [anon_sym_static] = ACTIONS(3170),
    [anon_sym_register] = ACTIONS(3170),
    [anon_sym_inline] = ACTIONS(3170),
    [anon_sym___inline] = ACTIONS(3170),
    [anon_sym___inline__] = ACTIONS(3170),
    [anon_sym___forceinline] = ACTIONS(3170),
    [anon_sym_thread_local] = ACTIONS(3170),
    [anon_sym___thread] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3170),
    [anon_sym_constexpr] = ACTIONS(3170),
    [anon_sym_volatile] = ACTIONS(3170),
    [anon_sym_restrict] = ACTIONS(3170),
    [anon_sym___restrict__] = ACTIONS(3170),
    [anon_sym__Atomic] = ACTIONS(3170),
    [anon_sym__Noreturn] = ACTIONS(3170),
    [anon_sym_noreturn] = ACTIONS(3170),
    [anon_sym_mutable] = ACTIONS(3170),
    [anon_sym_constinit] = ACTIONS(3170),
    [anon_sym_consteval] = ACTIONS(3170),
    [anon_sym_PROGMEM] = ACTIONS(3170),
    [aux_sym_primitive_type_token1] = ACTIONS(3170),
    [anon_sym_byte] = ACTIONS(3170),
    [anon_sym_word] = ACTIONS(3170),
    [anon_sym_enum] = ACTIONS(3170),
    [anon_sym_class] = ACTIONS(3170),
    [anon_sym_struct] = ACTIONS(3170),
    [anon_sym_union] = ACTIONS(3170),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3170),
    [anon_sym_decltype] = ACTIONS(3170),
    [anon_sym_virtual] = ACTIONS(3170),
    [anon_sym_alignas] = ACTIONS(3170),
    [anon_sym_explicit] = ACTIONS(3170),
    [anon_sym_typename] = ACTIONS(3170),
    [anon_sym_template] = ACTIONS(3170),
    [anon_sym_operator] = ACTIONS(3170),
    [anon_sym_friend] = ACTIONS(3170),
    [anon_sym_public] = ACTIONS(3170),
    [anon_sym_private] = ACTIONS(3170),
    [anon_sym_protected] = ACTIONS(3170),
    [anon_sym_using] = ACTIONS(3170),
    [anon_sym_static_assert] = ACTIONS(3170),
  },
  [2108] = {
    [sym_identifier] = ACTIONS(3111),
    [aux_sym_preproc_def_token1] = ACTIONS(3111),
    [aux_sym_preproc_if_token1] = ACTIONS(3111),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3111),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3111),
    [sym_preproc_directive] = ACTIONS(3111),
    [anon_sym_LPAREN2] = ACTIONS(3113),
    [anon_sym_TILDE] = ACTIONS(3113),
    [anon_sym_STAR] = ACTIONS(3113),
    [anon_sym_AMP_AMP] = ACTIONS(3113),
    [anon_sym_AMP] = ACTIONS(3111),
    [anon_sym___extension__] = ACTIONS(3111),
    [anon_sym_typedef] = ACTIONS(3111),
    [anon_sym_extern] = ACTIONS(3111),
    [anon_sym___attribute__] = ACTIONS(3111),
    [anon_sym_COLON_COLON] = ACTIONS(3113),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3113),
    [anon_sym___declspec] = ACTIONS(3111),
    [anon_sym___based] = ACTIONS(3111),
    [anon_sym_RBRACE] = ACTIONS(3113),
    [anon_sym_signed] = ACTIONS(3111),
    [anon_sym_unsigned] = ACTIONS(3111),
    [anon_sym_long] = ACTIONS(3111),
    [anon_sym_short] = ACTIONS(3111),
    [anon_sym_LBRACK] = ACTIONS(3111),
    [anon_sym_static] = ACTIONS(3111),
    [anon_sym_register] = ACTIONS(3111),
    [anon_sym_inline] = ACTIONS(3111),
    [anon_sym___inline] = ACTIONS(3111),
    [anon_sym___inline__] = ACTIONS(3111),
    [anon_sym___forceinline] = ACTIONS(3111),
    [anon_sym_thread_local] = ACTIONS(3111),
    [anon_sym___thread] = ACTIONS(3111),
    [anon_sym_const] = ACTIONS(3111),
    [anon_sym_constexpr] = ACTIONS(3111),
    [anon_sym_volatile] = ACTIONS(3111),
    [anon_sym_restrict] = ACTIONS(3111),
    [anon_sym___restrict__] = ACTIONS(3111),
    [anon_sym__Atomic] = ACTIONS(3111),
    [anon_sym__Noreturn] = ACTIONS(3111),
    [anon_sym_noreturn] = ACTIONS(3111),
    [anon_sym_mutable] = ACTIONS(3111),
    [anon_sym_constinit] = ACTIONS(3111),
    [anon_sym_consteval] = ACTIONS(3111),
    [anon_sym_PROGMEM] = ACTIONS(3111),
    [aux_sym_primitive_type_token1] = ACTIONS(3111),
    [anon_sym_byte] = ACTIONS(3111),
    [anon_sym_word] = ACTIONS(3111),
    [anon_sym_enum] = ACTIONS(3111),
    [anon_sym_class] = ACTIONS(3111),
    [anon_sym_struct] = ACTIONS(3111),
    [anon_sym_union] = ACTIONS(3111),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3111),
    [anon_sym_decltype] = ACTIONS(3111),
    [anon_sym_virtual] = ACTIONS(3111),
    [anon_sym_alignas] = ACTIONS(3111),
    [anon_sym_explicit] = ACTIONS(3111),
    [anon_sym_typename] = ACTIONS(3111),
    [anon_sym_template] = ACTIONS(3111),
    [anon_sym_operator] = ACTIONS(3111),
    [anon_sym_friend] = ACTIONS(3111),
    [anon_sym_public] = ACTIONS(3111),
    [anon_sym_private] = ACTIONS(3111),
    [anon_sym_protected] = ACTIONS(3111),
    [anon_sym_using] = ACTIONS(3111),
    [anon_sym_static_assert] = ACTIONS(3111),
  },
  [2109] = {
    [sym_identifier] = ACTIONS(2905),
    [aux_sym_preproc_def_token1] = ACTIONS(2905),
    [aux_sym_preproc_if_token1] = ACTIONS(2905),
    [aux_sym_preproc_if_token2] = ACTIONS(2905),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2905),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2905),
    [sym_preproc_directive] = ACTIONS(2905),
    [anon_sym_LPAREN2] = ACTIONS(2907),
    [anon_sym_TILDE] = ACTIONS(2907),
    [anon_sym_STAR] = ACTIONS(2907),
    [anon_sym_AMP_AMP] = ACTIONS(2907),
    [anon_sym_AMP] = ACTIONS(2905),
    [anon_sym___extension__] = ACTIONS(2905),
    [anon_sym_typedef] = ACTIONS(2905),
    [anon_sym_extern] = ACTIONS(2905),
    [anon_sym___attribute__] = ACTIONS(2905),
    [anon_sym_COLON_COLON] = ACTIONS(2907),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2907),
    [anon_sym___declspec] = ACTIONS(2905),
    [anon_sym___based] = ACTIONS(2905),
    [anon_sym_signed] = ACTIONS(2905),
    [anon_sym_unsigned] = ACTIONS(2905),
    [anon_sym_long] = ACTIONS(2905),
    [anon_sym_short] = ACTIONS(2905),
    [anon_sym_LBRACK] = ACTIONS(2905),
    [anon_sym_static] = ACTIONS(2905),
    [anon_sym_register] = ACTIONS(2905),
    [anon_sym_inline] = ACTIONS(2905),
    [anon_sym___inline] = ACTIONS(2905),
    [anon_sym___inline__] = ACTIONS(2905),
    [anon_sym___forceinline] = ACTIONS(2905),
    [anon_sym_thread_local] = ACTIONS(2905),
    [anon_sym___thread] = ACTIONS(2905),
    [anon_sym_const] = ACTIONS(2905),
    [anon_sym_constexpr] = ACTIONS(2905),
    [anon_sym_volatile] = ACTIONS(2905),
    [anon_sym_restrict] = ACTIONS(2905),
    [anon_sym___restrict__] = ACTIONS(2905),
    [anon_sym__Atomic] = ACTIONS(2905),
    [anon_sym__Noreturn] = ACTIONS(2905),
    [anon_sym_noreturn] = ACTIONS(2905),
    [anon_sym_mutable] = ACTIONS(2905),
    [anon_sym_constinit] = ACTIONS(2905),
    [anon_sym_consteval] = ACTIONS(2905),
    [anon_sym_PROGMEM] = ACTIONS(2905),
    [aux_sym_primitive_type_token1] = ACTIONS(2905),
    [anon_sym_byte] = ACTIONS(2905),
    [anon_sym_word] = ACTIONS(2905),
    [anon_sym_enum] = ACTIONS(2905),
    [anon_sym_class] = ACTIONS(2905),
    [anon_sym_struct] = ACTIONS(2905),
    [anon_sym_union] = ACTIONS(2905),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2905),
    [anon_sym_decltype] = ACTIONS(2905),
    [anon_sym_virtual] = ACTIONS(2905),
    [anon_sym_alignas] = ACTIONS(2905),
    [anon_sym_explicit] = ACTIONS(2905),
    [anon_sym_typename] = ACTIONS(2905),
    [anon_sym_template] = ACTIONS(2905),
    [anon_sym_operator] = ACTIONS(2905),
    [anon_sym_friend] = ACTIONS(2905),
    [anon_sym_public] = ACTIONS(2905),
    [anon_sym_private] = ACTIONS(2905),
    [anon_sym_protected] = ACTIONS(2905),
    [anon_sym_using] = ACTIONS(2905),
    [anon_sym_static_assert] = ACTIONS(2905),
  },
  [2110] = {
    [sym_identifier] = ACTIONS(3052),
    [aux_sym_preproc_def_token1] = ACTIONS(3052),
    [aux_sym_preproc_if_token1] = ACTIONS(3052),
    [aux_sym_preproc_if_token2] = ACTIONS(3052),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3052),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3052),
    [sym_preproc_directive] = ACTIONS(3052),
    [anon_sym_LPAREN2] = ACTIONS(3054),
    [anon_sym_TILDE] = ACTIONS(3054),
    [anon_sym_STAR] = ACTIONS(3054),
    [anon_sym_AMP_AMP] = ACTIONS(3054),
    [anon_sym_AMP] = ACTIONS(3052),
    [anon_sym___extension__] = ACTIONS(3052),
    [anon_sym_typedef] = ACTIONS(3052),
    [anon_sym_extern] = ACTIONS(3052),
    [anon_sym___attribute__] = ACTIONS(3052),
    [anon_sym_COLON_COLON] = ACTIONS(3054),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3054),
    [anon_sym___declspec] = ACTIONS(3052),
    [anon_sym___based] = ACTIONS(3052),
    [anon_sym_signed] = ACTIONS(3052),
    [anon_sym_unsigned] = ACTIONS(3052),
    [anon_sym_long] = ACTIONS(3052),
    [anon_sym_short] = ACTIONS(3052),
    [anon_sym_LBRACK] = ACTIONS(3052),
    [anon_sym_static] = ACTIONS(3052),
    [anon_sym_register] = ACTIONS(3052),
    [anon_sym_inline] = ACTIONS(3052),
    [anon_sym___inline] = ACTIONS(3052),
    [anon_sym___inline__] = ACTIONS(3052),
    [anon_sym___forceinline] = ACTIONS(3052),
    [anon_sym_thread_local] = ACTIONS(3052),
    [anon_sym___thread] = ACTIONS(3052),
    [anon_sym_const] = ACTIONS(3052),
    [anon_sym_constexpr] = ACTIONS(3052),
    [anon_sym_volatile] = ACTIONS(3052),
    [anon_sym_restrict] = ACTIONS(3052),
    [anon_sym___restrict__] = ACTIONS(3052),
    [anon_sym__Atomic] = ACTIONS(3052),
    [anon_sym__Noreturn] = ACTIONS(3052),
    [anon_sym_noreturn] = ACTIONS(3052),
    [anon_sym_mutable] = ACTIONS(3052),
    [anon_sym_constinit] = ACTIONS(3052),
    [anon_sym_consteval] = ACTIONS(3052),
    [anon_sym_PROGMEM] = ACTIONS(3052),
    [aux_sym_primitive_type_token1] = ACTIONS(3052),
    [anon_sym_byte] = ACTIONS(3052),
    [anon_sym_word] = ACTIONS(3052),
    [anon_sym_enum] = ACTIONS(3052),
    [anon_sym_class] = ACTIONS(3052),
    [anon_sym_struct] = ACTIONS(3052),
    [anon_sym_union] = ACTIONS(3052),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3052),
    [anon_sym_decltype] = ACTIONS(3052),
    [anon_sym_virtual] = ACTIONS(3052),
    [anon_sym_alignas] = ACTIONS(3052),
    [anon_sym_explicit] = ACTIONS(3052),
    [anon_sym_typename] = ACTIONS(3052),
    [anon_sym_template] = ACTIONS(3052),
    [anon_sym_operator] = ACTIONS(3052),
    [anon_sym_friend] = ACTIONS(3052),
    [anon_sym_public] = ACTIONS(3052),
    [anon_sym_private] = ACTIONS(3052),
    [anon_sym_protected] = ACTIONS(3052),
    [anon_sym_using] = ACTIONS(3052),
    [anon_sym_static_assert] = ACTIONS(3052),
  },
  [2111] = {
    [sym_identifier] = ACTIONS(2901),
    [aux_sym_preproc_def_token1] = ACTIONS(2901),
    [aux_sym_preproc_if_token1] = ACTIONS(2901),
    [aux_sym_preproc_if_token2] = ACTIONS(2901),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2901),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2901),
    [sym_preproc_directive] = ACTIONS(2901),
    [anon_sym_LPAREN2] = ACTIONS(2903),
    [anon_sym_TILDE] = ACTIONS(2903),
    [anon_sym_STAR] = ACTIONS(2903),
    [anon_sym_AMP_AMP] = ACTIONS(2903),
    [anon_sym_AMP] = ACTIONS(2901),
    [anon_sym___extension__] = ACTIONS(2901),
    [anon_sym_typedef] = ACTIONS(2901),
    [anon_sym_extern] = ACTIONS(2901),
    [anon_sym___attribute__] = ACTIONS(2901),
    [anon_sym_COLON_COLON] = ACTIONS(2903),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2903),
    [anon_sym___declspec] = ACTIONS(2901),
    [anon_sym___based] = ACTIONS(2901),
    [anon_sym_signed] = ACTIONS(2901),
    [anon_sym_unsigned] = ACTIONS(2901),
    [anon_sym_long] = ACTIONS(2901),
    [anon_sym_short] = ACTIONS(2901),
    [anon_sym_LBRACK] = ACTIONS(2901),
    [anon_sym_static] = ACTIONS(2901),
    [anon_sym_register] = ACTIONS(2901),
    [anon_sym_inline] = ACTIONS(2901),
    [anon_sym___inline] = ACTIONS(2901),
    [anon_sym___inline__] = ACTIONS(2901),
    [anon_sym___forceinline] = ACTIONS(2901),
    [anon_sym_thread_local] = ACTIONS(2901),
    [anon_sym___thread] = ACTIONS(2901),
    [anon_sym_const] = ACTIONS(2901),
    [anon_sym_constexpr] = ACTIONS(2901),
    [anon_sym_volatile] = ACTIONS(2901),
    [anon_sym_restrict] = ACTIONS(2901),
    [anon_sym___restrict__] = ACTIONS(2901),
    [anon_sym__Atomic] = ACTIONS(2901),
    [anon_sym__Noreturn] = ACTIONS(2901),
    [anon_sym_noreturn] = ACTIONS(2901),
    [anon_sym_mutable] = ACTIONS(2901),
    [anon_sym_constinit] = ACTIONS(2901),
    [anon_sym_consteval] = ACTIONS(2901),
    [anon_sym_PROGMEM] = ACTIONS(2901),
    [aux_sym_primitive_type_token1] = ACTIONS(2901),
    [anon_sym_byte] = ACTIONS(2901),
    [anon_sym_word] = ACTIONS(2901),
    [anon_sym_enum] = ACTIONS(2901),
    [anon_sym_class] = ACTIONS(2901),
    [anon_sym_struct] = ACTIONS(2901),
    [anon_sym_union] = ACTIONS(2901),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2901),
    [anon_sym_decltype] = ACTIONS(2901),
    [anon_sym_virtual] = ACTIONS(2901),
    [anon_sym_alignas] = ACTIONS(2901),
    [anon_sym_explicit] = ACTIONS(2901),
    [anon_sym_typename] = ACTIONS(2901),
    [anon_sym_template] = ACTIONS(2901),
    [anon_sym_operator] = ACTIONS(2901),
    [anon_sym_friend] = ACTIONS(2901),
    [anon_sym_public] = ACTIONS(2901),
    [anon_sym_private] = ACTIONS(2901),
    [anon_sym_protected] = ACTIONS(2901),
    [anon_sym_using] = ACTIONS(2901),
    [anon_sym_static_assert] = ACTIONS(2901),
  },
  [2112] = {
    [sym_identifier] = ACTIONS(3048),
    [aux_sym_preproc_def_token1] = ACTIONS(3048),
    [aux_sym_preproc_if_token1] = ACTIONS(3048),
    [aux_sym_preproc_if_token2] = ACTIONS(3048),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3048),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3048),
    [sym_preproc_directive] = ACTIONS(3048),
    [anon_sym_LPAREN2] = ACTIONS(3050),
    [anon_sym_TILDE] = ACTIONS(3050),
    [anon_sym_STAR] = ACTIONS(3050),
    [anon_sym_AMP_AMP] = ACTIONS(3050),
    [anon_sym_AMP] = ACTIONS(3048),
    [anon_sym___extension__] = ACTIONS(3048),
    [anon_sym_typedef] = ACTIONS(3048),
    [anon_sym_extern] = ACTIONS(3048),
    [anon_sym___attribute__] = ACTIONS(3048),
    [anon_sym_COLON_COLON] = ACTIONS(3050),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3050),
    [anon_sym___declspec] = ACTIONS(3048),
    [anon_sym___based] = ACTIONS(3048),
    [anon_sym_signed] = ACTIONS(3048),
    [anon_sym_unsigned] = ACTIONS(3048),
    [anon_sym_long] = ACTIONS(3048),
    [anon_sym_short] = ACTIONS(3048),
    [anon_sym_LBRACK] = ACTIONS(3048),
    [anon_sym_static] = ACTIONS(3048),
    [anon_sym_register] = ACTIONS(3048),
    [anon_sym_inline] = ACTIONS(3048),
    [anon_sym___inline] = ACTIONS(3048),
    [anon_sym___inline__] = ACTIONS(3048),
    [anon_sym___forceinline] = ACTIONS(3048),
    [anon_sym_thread_local] = ACTIONS(3048),
    [anon_sym___thread] = ACTIONS(3048),
    [anon_sym_const] = ACTIONS(3048),
    [anon_sym_constexpr] = ACTIONS(3048),
    [anon_sym_volatile] = ACTIONS(3048),
    [anon_sym_restrict] = ACTIONS(3048),
    [anon_sym___restrict__] = ACTIONS(3048),
    [anon_sym__Atomic] = ACTIONS(3048),
    [anon_sym__Noreturn] = ACTIONS(3048),
    [anon_sym_noreturn] = ACTIONS(3048),
    [anon_sym_mutable] = ACTIONS(3048),
    [anon_sym_constinit] = ACTIONS(3048),
    [anon_sym_consteval] = ACTIONS(3048),
    [anon_sym_PROGMEM] = ACTIONS(3048),
    [aux_sym_primitive_type_token1] = ACTIONS(3048),
    [anon_sym_byte] = ACTIONS(3048),
    [anon_sym_word] = ACTIONS(3048),
    [anon_sym_enum] = ACTIONS(3048),
    [anon_sym_class] = ACTIONS(3048),
    [anon_sym_struct] = ACTIONS(3048),
    [anon_sym_union] = ACTIONS(3048),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3048),
    [anon_sym_decltype] = ACTIONS(3048),
    [anon_sym_virtual] = ACTIONS(3048),
    [anon_sym_alignas] = ACTIONS(3048),
    [anon_sym_explicit] = ACTIONS(3048),
    [anon_sym_typename] = ACTIONS(3048),
    [anon_sym_template] = ACTIONS(3048),
    [anon_sym_operator] = ACTIONS(3048),
    [anon_sym_friend] = ACTIONS(3048),
    [anon_sym_public] = ACTIONS(3048),
    [anon_sym_private] = ACTIONS(3048),
    [anon_sym_protected] = ACTIONS(3048),
    [anon_sym_using] = ACTIONS(3048),
    [anon_sym_static_assert] = ACTIONS(3048),
  },
  [2113] = {
    [sym_identifier] = ACTIONS(4859),
    [aux_sym_preproc_def_token1] = ACTIONS(4859),
    [aux_sym_preproc_if_token1] = ACTIONS(4859),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4859),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4859),
    [sym_preproc_directive] = ACTIONS(4859),
    [anon_sym_LPAREN2] = ACTIONS(4861),
    [anon_sym_TILDE] = ACTIONS(4861),
    [anon_sym_STAR] = ACTIONS(4861),
    [anon_sym_AMP_AMP] = ACTIONS(4861),
    [anon_sym_AMP] = ACTIONS(4859),
    [anon_sym___extension__] = ACTIONS(4859),
    [anon_sym_typedef] = ACTIONS(4859),
    [anon_sym_extern] = ACTIONS(4859),
    [anon_sym___attribute__] = ACTIONS(4859),
    [anon_sym_COLON_COLON] = ACTIONS(4861),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4861),
    [anon_sym___declspec] = ACTIONS(4859),
    [anon_sym___based] = ACTIONS(4859),
    [anon_sym_RBRACE] = ACTIONS(4861),
    [anon_sym_signed] = ACTIONS(4859),
    [anon_sym_unsigned] = ACTIONS(4859),
    [anon_sym_long] = ACTIONS(4859),
    [anon_sym_short] = ACTIONS(4859),
    [anon_sym_LBRACK] = ACTIONS(4859),
    [anon_sym_static] = ACTIONS(4859),
    [anon_sym_register] = ACTIONS(4859),
    [anon_sym_inline] = ACTIONS(4859),
    [anon_sym___inline] = ACTIONS(4859),
    [anon_sym___inline__] = ACTIONS(4859),
    [anon_sym___forceinline] = ACTIONS(4859),
    [anon_sym_thread_local] = ACTIONS(4859),
    [anon_sym___thread] = ACTIONS(4859),
    [anon_sym_const] = ACTIONS(4859),
    [anon_sym_constexpr] = ACTIONS(4859),
    [anon_sym_volatile] = ACTIONS(4859),
    [anon_sym_restrict] = ACTIONS(4859),
    [anon_sym___restrict__] = ACTIONS(4859),
    [anon_sym__Atomic] = ACTIONS(4859),
    [anon_sym__Noreturn] = ACTIONS(4859),
    [anon_sym_noreturn] = ACTIONS(4859),
    [anon_sym_mutable] = ACTIONS(4859),
    [anon_sym_constinit] = ACTIONS(4859),
    [anon_sym_consteval] = ACTIONS(4859),
    [anon_sym_PROGMEM] = ACTIONS(4859),
    [aux_sym_primitive_type_token1] = ACTIONS(4859),
    [anon_sym_byte] = ACTIONS(4859),
    [anon_sym_word] = ACTIONS(4859),
    [anon_sym_enum] = ACTIONS(4859),
    [anon_sym_class] = ACTIONS(4859),
    [anon_sym_struct] = ACTIONS(4859),
    [anon_sym_union] = ACTIONS(4859),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4859),
    [anon_sym_decltype] = ACTIONS(4859),
    [anon_sym_virtual] = ACTIONS(4859),
    [anon_sym_alignas] = ACTIONS(4859),
    [anon_sym_explicit] = ACTIONS(4859),
    [anon_sym_typename] = ACTIONS(4859),
    [anon_sym_template] = ACTIONS(4859),
    [anon_sym_operator] = ACTIONS(4859),
    [anon_sym_friend] = ACTIONS(4859),
    [anon_sym_public] = ACTIONS(4859),
    [anon_sym_private] = ACTIONS(4859),
    [anon_sym_protected] = ACTIONS(4859),
    [anon_sym_using] = ACTIONS(4859),
    [anon_sym_static_assert] = ACTIONS(4859),
  },
  [2114] = {
    [sym_identifier] = ACTIONS(4918),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4920),
    [anon_sym_COMMA] = ACTIONS(4920),
    [anon_sym_RPAREN] = ACTIONS(4920),
    [aux_sym_preproc_if_token2] = ACTIONS(4920),
    [aux_sym_preproc_else_token1] = ACTIONS(4920),
    [aux_sym_preproc_elif_token1] = ACTIONS(4918),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4920),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4920),
    [anon_sym_LPAREN2] = ACTIONS(4920),
    [anon_sym_DASH] = ACTIONS(4918),
    [anon_sym_PLUS] = ACTIONS(4918),
    [anon_sym_STAR] = ACTIONS(4918),
    [anon_sym_SLASH] = ACTIONS(4918),
    [anon_sym_PERCENT] = ACTIONS(4918),
    [anon_sym_PIPE_PIPE] = ACTIONS(4920),
    [anon_sym_AMP_AMP] = ACTIONS(4920),
    [anon_sym_PIPE] = ACTIONS(4918),
    [anon_sym_CARET] = ACTIONS(4918),
    [anon_sym_AMP] = ACTIONS(4918),
    [anon_sym_EQ_EQ] = ACTIONS(4920),
    [anon_sym_BANG_EQ] = ACTIONS(4920),
    [anon_sym_GT] = ACTIONS(4918),
    [anon_sym_GT_EQ] = ACTIONS(4920),
    [anon_sym_LT_EQ] = ACTIONS(4918),
    [anon_sym_LT] = ACTIONS(4918),
    [anon_sym_LT_LT] = ACTIONS(4918),
    [anon_sym_GT_GT] = ACTIONS(4918),
    [anon_sym_SEMI] = ACTIONS(4920),
    [anon_sym___attribute__] = ACTIONS(4918),
    [anon_sym_LBRACE] = ACTIONS(4920),
    [anon_sym_RBRACE] = ACTIONS(4920),
    [anon_sym_LBRACK] = ACTIONS(4920),
    [anon_sym_RBRACK] = ACTIONS(4920),
    [anon_sym_EQ] = ACTIONS(4918),
    [anon_sym_COLON] = ACTIONS(4920),
    [anon_sym_QMARK] = ACTIONS(4920),
    [anon_sym_STAR_EQ] = ACTIONS(4920),
    [anon_sym_SLASH_EQ] = ACTIONS(4920),
    [anon_sym_PERCENT_EQ] = ACTIONS(4920),
    [anon_sym_PLUS_EQ] = ACTIONS(4920),
    [anon_sym_DASH_EQ] = ACTIONS(4920),
    [anon_sym_LT_LT_EQ] = ACTIONS(4920),
    [anon_sym_GT_GT_EQ] = ACTIONS(4920),
    [anon_sym_AMP_EQ] = ACTIONS(4920),
    [anon_sym_CARET_EQ] = ACTIONS(4920),
    [anon_sym_PIPE_EQ] = ACTIONS(4920),
    [anon_sym_and_eq] = ACTIONS(4918),
    [anon_sym_or_eq] = ACTIONS(4918),
    [anon_sym_xor_eq] = ACTIONS(4918),
    [anon_sym_LT_EQ_GT] = ACTIONS(4920),
    [anon_sym_or] = ACTIONS(4918),
    [anon_sym_and] = ACTIONS(4918),
    [anon_sym_bitor] = ACTIONS(4918),
    [anon_sym_xor] = ACTIONS(4918),
    [anon_sym_bitand] = ACTIONS(4918),
    [anon_sym_not_eq] = ACTIONS(4918),
    [anon_sym_DASH_DASH] = ACTIONS(4920),
    [anon_sym_PLUS_PLUS] = ACTIONS(4920),
    [anon_sym_DOT] = ACTIONS(4918),
    [anon_sym_DOT_STAR] = ACTIONS(4920),
    [anon_sym_DASH_GT] = ACTIONS(4920),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4918),
    [anon_sym_decltype] = ACTIONS(4918),
    [anon_sym_final] = ACTIONS(4918),
    [anon_sym_override] = ACTIONS(4918),
  },
  [2115] = {
    [sym_template_argument_list] = STATE(1741),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2381),
    [sym_identifier] = ACTIONS(5303),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5305),
    [anon_sym_COMMA] = ACTIONS(5305),
    [aux_sym_preproc_if_token2] = ACTIONS(5305),
    [aux_sym_preproc_else_token1] = ACTIONS(5305),
    [aux_sym_preproc_elif_token1] = ACTIONS(5303),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5305),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5305),
    [anon_sym_LPAREN2] = ACTIONS(5305),
    [anon_sym_DASH] = ACTIONS(5303),
    [anon_sym_PLUS] = ACTIONS(5303),
    [anon_sym_STAR] = ACTIONS(5303),
    [anon_sym_SLASH] = ACTIONS(5303),
    [anon_sym_PERCENT] = ACTIONS(5303),
    [anon_sym_PIPE_PIPE] = ACTIONS(5305),
    [anon_sym_AMP_AMP] = ACTIONS(5305),
    [anon_sym_PIPE] = ACTIONS(5303),
    [anon_sym_CARET] = ACTIONS(5303),
    [anon_sym_AMP] = ACTIONS(5303),
    [anon_sym_EQ_EQ] = ACTIONS(5305),
    [anon_sym_BANG_EQ] = ACTIONS(5305),
    [anon_sym_GT] = ACTIONS(5303),
    [anon_sym_GT_EQ] = ACTIONS(5305),
    [anon_sym_LT_EQ] = ACTIONS(5303),
    [anon_sym_LT] = ACTIONS(5303),
    [anon_sym_LT_LT] = ACTIONS(5303),
    [anon_sym_GT_GT] = ACTIONS(5303),
    [anon_sym___attribute__] = ACTIONS(5303),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(5305),
    [anon_sym_signed] = ACTIONS(5307),
    [anon_sym_unsigned] = ACTIONS(5307),
    [anon_sym_long] = ACTIONS(5307),
    [anon_sym_short] = ACTIONS(5307),
    [anon_sym_LBRACK] = ACTIONS(5305),
    [anon_sym_EQ] = ACTIONS(5303),
    [anon_sym_QMARK] = ACTIONS(5305),
    [anon_sym_STAR_EQ] = ACTIONS(5305),
    [anon_sym_SLASH_EQ] = ACTIONS(5305),
    [anon_sym_PERCENT_EQ] = ACTIONS(5305),
    [anon_sym_PLUS_EQ] = ACTIONS(5305),
    [anon_sym_DASH_EQ] = ACTIONS(5305),
    [anon_sym_LT_LT_EQ] = ACTIONS(5305),
    [anon_sym_GT_GT_EQ] = ACTIONS(5305),
    [anon_sym_AMP_EQ] = ACTIONS(5305),
    [anon_sym_CARET_EQ] = ACTIONS(5305),
    [anon_sym_PIPE_EQ] = ACTIONS(5305),
    [anon_sym_and_eq] = ACTIONS(5303),
    [anon_sym_or_eq] = ACTIONS(5303),
    [anon_sym_xor_eq] = ACTIONS(5303),
    [anon_sym_LT_EQ_GT] = ACTIONS(5305),
    [anon_sym_or] = ACTIONS(5303),
    [anon_sym_and] = ACTIONS(5303),
    [anon_sym_bitor] = ACTIONS(5303),
    [anon_sym_xor] = ACTIONS(5303),
    [anon_sym_bitand] = ACTIONS(5303),
    [anon_sym_not_eq] = ACTIONS(5303),
    [anon_sym_DASH_DASH] = ACTIONS(5305),
    [anon_sym_PLUS_PLUS] = ACTIONS(5305),
    [anon_sym_DOT] = ACTIONS(5303),
    [anon_sym_DOT_STAR] = ACTIONS(5305),
    [anon_sym_DASH_GT] = ACTIONS(5305),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5303),
    [anon_sym_decltype] = ACTIONS(5303),
  },
  [2116] = {
    [sym_string_literal] = STATE(2206),
    [sym_raw_string_literal] = STATE(2206),
    [aux_sym_concatenated_string_repeat1] = STATE(2206),
    [sym_identifier] = ACTIONS(5309),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4777),
    [anon_sym_COMMA] = ACTIONS(4777),
    [anon_sym_LPAREN2] = ACTIONS(4777),
    [anon_sym_DASH] = ACTIONS(4779),
    [anon_sym_PLUS] = ACTIONS(4779),
    [anon_sym_STAR] = ACTIONS(4779),
    [anon_sym_SLASH] = ACTIONS(4779),
    [anon_sym_PERCENT] = ACTIONS(4779),
    [anon_sym_PIPE_PIPE] = ACTIONS(4777),
    [anon_sym_AMP_AMP] = ACTIONS(4777),
    [anon_sym_PIPE] = ACTIONS(4779),
    [anon_sym_CARET] = ACTIONS(4779),
    [anon_sym_AMP] = ACTIONS(4779),
    [anon_sym_EQ_EQ] = ACTIONS(4777),
    [anon_sym_BANG_EQ] = ACTIONS(4777),
    [anon_sym_GT] = ACTIONS(4779),
    [anon_sym_GT_EQ] = ACTIONS(4777),
    [anon_sym_LT_EQ] = ACTIONS(4779),
    [anon_sym_LT] = ACTIONS(4779),
    [anon_sym_LT_LT] = ACTIONS(4779),
    [anon_sym_GT_GT] = ACTIONS(4779),
    [anon_sym_SEMI] = ACTIONS(4777),
    [anon_sym___attribute__] = ACTIONS(4779),
    [anon_sym_LBRACK] = ACTIONS(4777),
    [anon_sym_EQ] = ACTIONS(4779),
    [anon_sym_QMARK] = ACTIONS(4777),
    [anon_sym_STAR_EQ] = ACTIONS(4777),
    [anon_sym_SLASH_EQ] = ACTIONS(4777),
    [anon_sym_PERCENT_EQ] = ACTIONS(4777),
    [anon_sym_PLUS_EQ] = ACTIONS(4777),
    [anon_sym_DASH_EQ] = ACTIONS(4777),
    [anon_sym_LT_LT_EQ] = ACTIONS(4777),
    [anon_sym_GT_GT_EQ] = ACTIONS(4777),
    [anon_sym_AMP_EQ] = ACTIONS(4777),
    [anon_sym_CARET_EQ] = ACTIONS(4777),
    [anon_sym_PIPE_EQ] = ACTIONS(4777),
    [anon_sym_and_eq] = ACTIONS(4779),
    [anon_sym_or_eq] = ACTIONS(4779),
    [anon_sym_xor_eq] = ACTIONS(4779),
    [anon_sym_LT_EQ_GT] = ACTIONS(4777),
    [anon_sym_or] = ACTIONS(4779),
    [anon_sym_and] = ACTIONS(4779),
    [anon_sym_bitor] = ACTIONS(4779),
    [anon_sym_xor] = ACTIONS(4779),
    [anon_sym_bitand] = ACTIONS(4779),
    [anon_sym_not_eq] = ACTIONS(4779),
    [anon_sym_DASH_DASH] = ACTIONS(4777),
    [anon_sym_PLUS_PLUS] = ACTIONS(4777),
    [anon_sym_DOT] = ACTIONS(4779),
    [anon_sym_DOT_STAR] = ACTIONS(4777),
    [anon_sym_DASH_GT] = ACTIONS(4777),
    [anon_sym_L_DQUOTE] = ACTIONS(5289),
    [anon_sym_u_DQUOTE] = ACTIONS(5289),
    [anon_sym_U_DQUOTE] = ACTIONS(5289),
    [anon_sym_u8_DQUOTE] = ACTIONS(5289),
    [anon_sym_DQUOTE] = ACTIONS(5289),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5291),
    [anon_sym_LR_DQUOTE] = ACTIONS(5291),
    [anon_sym_uR_DQUOTE] = ACTIONS(5291),
    [anon_sym_UR_DQUOTE] = ACTIONS(5291),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5291),
    [sym_literal_suffix] = ACTIONS(4779),
  },
  [2117] = {
    [sym_identifier] = ACTIONS(4988),
    [aux_sym_preproc_def_token1] = ACTIONS(4988),
    [aux_sym_preproc_if_token1] = ACTIONS(4988),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4988),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4988),
    [sym_preproc_directive] = ACTIONS(4988),
    [anon_sym_LPAREN2] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_STAR] = ACTIONS(4990),
    [anon_sym_AMP_AMP] = ACTIONS(4990),
    [anon_sym_AMP] = ACTIONS(4988),
    [anon_sym___extension__] = ACTIONS(4988),
    [anon_sym_typedef] = ACTIONS(4988),
    [anon_sym_extern] = ACTIONS(4988),
    [anon_sym___attribute__] = ACTIONS(4988),
    [anon_sym_COLON_COLON] = ACTIONS(4990),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4990),
    [anon_sym___declspec] = ACTIONS(4988),
    [anon_sym___based] = ACTIONS(4988),
    [anon_sym_RBRACE] = ACTIONS(4990),
    [anon_sym_signed] = ACTIONS(4988),
    [anon_sym_unsigned] = ACTIONS(4988),
    [anon_sym_long] = ACTIONS(4988),
    [anon_sym_short] = ACTIONS(4988),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_static] = ACTIONS(4988),
    [anon_sym_register] = ACTIONS(4988),
    [anon_sym_inline] = ACTIONS(4988),
    [anon_sym___inline] = ACTIONS(4988),
    [anon_sym___inline__] = ACTIONS(4988),
    [anon_sym___forceinline] = ACTIONS(4988),
    [anon_sym_thread_local] = ACTIONS(4988),
    [anon_sym___thread] = ACTIONS(4988),
    [anon_sym_const] = ACTIONS(4988),
    [anon_sym_constexpr] = ACTIONS(4988),
    [anon_sym_volatile] = ACTIONS(4988),
    [anon_sym_restrict] = ACTIONS(4988),
    [anon_sym___restrict__] = ACTIONS(4988),
    [anon_sym__Atomic] = ACTIONS(4988),
    [anon_sym__Noreturn] = ACTIONS(4988),
    [anon_sym_noreturn] = ACTIONS(4988),
    [anon_sym_mutable] = ACTIONS(4988),
    [anon_sym_constinit] = ACTIONS(4988),
    [anon_sym_consteval] = ACTIONS(4988),
    [anon_sym_PROGMEM] = ACTIONS(4988),
    [aux_sym_primitive_type_token1] = ACTIONS(4988),
    [anon_sym_byte] = ACTIONS(4988),
    [anon_sym_word] = ACTIONS(4988),
    [anon_sym_enum] = ACTIONS(4988),
    [anon_sym_class] = ACTIONS(4988),
    [anon_sym_struct] = ACTIONS(4988),
    [anon_sym_union] = ACTIONS(4988),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4988),
    [anon_sym_decltype] = ACTIONS(4988),
    [anon_sym_virtual] = ACTIONS(4988),
    [anon_sym_alignas] = ACTIONS(4988),
    [anon_sym_explicit] = ACTIONS(4988),
    [anon_sym_typename] = ACTIONS(4988),
    [anon_sym_template] = ACTIONS(4988),
    [anon_sym_operator] = ACTIONS(4988),
    [anon_sym_friend] = ACTIONS(4988),
    [anon_sym_public] = ACTIONS(4988),
    [anon_sym_private] = ACTIONS(4988),
    [anon_sym_protected] = ACTIONS(4988),
    [anon_sym_using] = ACTIONS(4988),
    [anon_sym_static_assert] = ACTIONS(4988),
  },
  [2118] = {
    [sym_string_literal] = STATE(2118),
    [sym_raw_string_literal] = STATE(2118),
    [aux_sym_concatenated_string_repeat1] = STATE(2118),
    [sym_identifier] = ACTIONS(5311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4790),
    [anon_sym_COMMA] = ACTIONS(4790),
    [anon_sym_RPAREN] = ACTIONS(4790),
    [anon_sym_LPAREN2] = ACTIONS(4790),
    [anon_sym_DASH] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(4792),
    [anon_sym_STAR] = ACTIONS(4792),
    [anon_sym_SLASH] = ACTIONS(4792),
    [anon_sym_PERCENT] = ACTIONS(4792),
    [anon_sym_PIPE_PIPE] = ACTIONS(4790),
    [anon_sym_AMP_AMP] = ACTIONS(4790),
    [anon_sym_PIPE] = ACTIONS(4792),
    [anon_sym_CARET] = ACTIONS(4792),
    [anon_sym_AMP] = ACTIONS(4792),
    [anon_sym_EQ_EQ] = ACTIONS(4790),
    [anon_sym_BANG_EQ] = ACTIONS(4790),
    [anon_sym_GT] = ACTIONS(4792),
    [anon_sym_GT_EQ] = ACTIONS(4790),
    [anon_sym_LT_EQ] = ACTIONS(4792),
    [anon_sym_LT] = ACTIONS(4792),
    [anon_sym_LT_LT] = ACTIONS(4792),
    [anon_sym_GT_GT] = ACTIONS(4792),
    [anon_sym_LBRACK] = ACTIONS(4790),
    [anon_sym_EQ] = ACTIONS(4792),
    [anon_sym_QMARK] = ACTIONS(4790),
    [anon_sym_STAR_EQ] = ACTIONS(4790),
    [anon_sym_SLASH_EQ] = ACTIONS(4790),
    [anon_sym_PERCENT_EQ] = ACTIONS(4790),
    [anon_sym_PLUS_EQ] = ACTIONS(4790),
    [anon_sym_DASH_EQ] = ACTIONS(4790),
    [anon_sym_LT_LT_EQ] = ACTIONS(4790),
    [anon_sym_GT_GT_EQ] = ACTIONS(4790),
    [anon_sym_AMP_EQ] = ACTIONS(4790),
    [anon_sym_CARET_EQ] = ACTIONS(4790),
    [anon_sym_PIPE_EQ] = ACTIONS(4790),
    [anon_sym_and_eq] = ACTIONS(4792),
    [anon_sym_or_eq] = ACTIONS(4792),
    [anon_sym_xor_eq] = ACTIONS(4792),
    [anon_sym_LT_EQ_GT] = ACTIONS(4790),
    [anon_sym_or] = ACTIONS(4792),
    [anon_sym_and] = ACTIONS(4792),
    [anon_sym_bitor] = ACTIONS(4792),
    [anon_sym_xor] = ACTIONS(4792),
    [anon_sym_bitand] = ACTIONS(4792),
    [anon_sym_not_eq] = ACTIONS(4792),
    [anon_sym_DASH_DASH] = ACTIONS(4790),
    [anon_sym_PLUS_PLUS] = ACTIONS(4790),
    [anon_sym_DOT] = ACTIONS(4792),
    [anon_sym_DOT_STAR] = ACTIONS(4790),
    [anon_sym_DASH_GT] = ACTIONS(4792),
    [anon_sym_L_DQUOTE] = ACTIONS(5314),
    [anon_sym_u_DQUOTE] = ACTIONS(5314),
    [anon_sym_U_DQUOTE] = ACTIONS(5314),
    [anon_sym_u8_DQUOTE] = ACTIONS(5314),
    [anon_sym_DQUOTE] = ACTIONS(5314),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5317),
    [anon_sym_LR_DQUOTE] = ACTIONS(5317),
    [anon_sym_uR_DQUOTE] = ACTIONS(5317),
    [anon_sym_UR_DQUOTE] = ACTIONS(5317),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5317),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4790),
    [sym_literal_suffix] = ACTIONS(4792),
  },
  [2119] = {
    [sym_identifier] = ACTIONS(2897),
    [aux_sym_preproc_def_token1] = ACTIONS(2897),
    [aux_sym_preproc_if_token1] = ACTIONS(2897),
    [aux_sym_preproc_if_token2] = ACTIONS(2897),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2897),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2897),
    [sym_preproc_directive] = ACTIONS(2897),
    [anon_sym_LPAREN2] = ACTIONS(2899),
    [anon_sym_TILDE] = ACTIONS(2899),
    [anon_sym_STAR] = ACTIONS(2899),
    [anon_sym_AMP_AMP] = ACTIONS(2899),
    [anon_sym_AMP] = ACTIONS(2897),
    [anon_sym___extension__] = ACTIONS(2897),
    [anon_sym_typedef] = ACTIONS(2897),
    [anon_sym_extern] = ACTIONS(2897),
    [anon_sym___attribute__] = ACTIONS(2897),
    [anon_sym_COLON_COLON] = ACTIONS(2899),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2899),
    [anon_sym___declspec] = ACTIONS(2897),
    [anon_sym___based] = ACTIONS(2897),
    [anon_sym_signed] = ACTIONS(2897),
    [anon_sym_unsigned] = ACTIONS(2897),
    [anon_sym_long] = ACTIONS(2897),
    [anon_sym_short] = ACTIONS(2897),
    [anon_sym_LBRACK] = ACTIONS(2897),
    [anon_sym_static] = ACTIONS(2897),
    [anon_sym_register] = ACTIONS(2897),
    [anon_sym_inline] = ACTIONS(2897),
    [anon_sym___inline] = ACTIONS(2897),
    [anon_sym___inline__] = ACTIONS(2897),
    [anon_sym___forceinline] = ACTIONS(2897),
    [anon_sym_thread_local] = ACTIONS(2897),
    [anon_sym___thread] = ACTIONS(2897),
    [anon_sym_const] = ACTIONS(2897),
    [anon_sym_constexpr] = ACTIONS(2897),
    [anon_sym_volatile] = ACTIONS(2897),
    [anon_sym_restrict] = ACTIONS(2897),
    [anon_sym___restrict__] = ACTIONS(2897),
    [anon_sym__Atomic] = ACTIONS(2897),
    [anon_sym__Noreturn] = ACTIONS(2897),
    [anon_sym_noreturn] = ACTIONS(2897),
    [anon_sym_mutable] = ACTIONS(2897),
    [anon_sym_constinit] = ACTIONS(2897),
    [anon_sym_consteval] = ACTIONS(2897),
    [anon_sym_PROGMEM] = ACTIONS(2897),
    [aux_sym_primitive_type_token1] = ACTIONS(2897),
    [anon_sym_byte] = ACTIONS(2897),
    [anon_sym_word] = ACTIONS(2897),
    [anon_sym_enum] = ACTIONS(2897),
    [anon_sym_class] = ACTIONS(2897),
    [anon_sym_struct] = ACTIONS(2897),
    [anon_sym_union] = ACTIONS(2897),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2897),
    [anon_sym_decltype] = ACTIONS(2897),
    [anon_sym_virtual] = ACTIONS(2897),
    [anon_sym_alignas] = ACTIONS(2897),
    [anon_sym_explicit] = ACTIONS(2897),
    [anon_sym_typename] = ACTIONS(2897),
    [anon_sym_template] = ACTIONS(2897),
    [anon_sym_operator] = ACTIONS(2897),
    [anon_sym_friend] = ACTIONS(2897),
    [anon_sym_public] = ACTIONS(2897),
    [anon_sym_private] = ACTIONS(2897),
    [anon_sym_protected] = ACTIONS(2897),
    [anon_sym_using] = ACTIONS(2897),
    [anon_sym_static_assert] = ACTIONS(2897),
  },
  [2120] = {
    [sym_string_literal] = STATE(2120),
    [sym_raw_string_literal] = STATE(2120),
    [aux_sym_concatenated_string_repeat1] = STATE(2120),
    [sym_identifier] = ACTIONS(5320),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4790),
    [anon_sym_COMMA] = ACTIONS(4790),
    [anon_sym_LPAREN2] = ACTIONS(4790),
    [anon_sym_DASH] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(4792),
    [anon_sym_STAR] = ACTIONS(4792),
    [anon_sym_SLASH] = ACTIONS(4792),
    [anon_sym_PERCENT] = ACTIONS(4792),
    [anon_sym_PIPE_PIPE] = ACTIONS(4790),
    [anon_sym_AMP_AMP] = ACTIONS(4790),
    [anon_sym_PIPE] = ACTIONS(4792),
    [anon_sym_CARET] = ACTIONS(4792),
    [anon_sym_AMP] = ACTIONS(4792),
    [anon_sym_EQ_EQ] = ACTIONS(4790),
    [anon_sym_BANG_EQ] = ACTIONS(4790),
    [anon_sym_GT] = ACTIONS(4792),
    [anon_sym_GT_EQ] = ACTIONS(4790),
    [anon_sym_LT_EQ] = ACTIONS(4792),
    [anon_sym_LT] = ACTIONS(4792),
    [anon_sym_LT_LT] = ACTIONS(4792),
    [anon_sym_GT_GT] = ACTIONS(4792),
    [anon_sym_SEMI] = ACTIONS(4790),
    [anon_sym___attribute__] = ACTIONS(4792),
    [anon_sym_LBRACK] = ACTIONS(4790),
    [anon_sym_EQ] = ACTIONS(4792),
    [anon_sym_QMARK] = ACTIONS(4790),
    [anon_sym_STAR_EQ] = ACTIONS(4790),
    [anon_sym_SLASH_EQ] = ACTIONS(4790),
    [anon_sym_PERCENT_EQ] = ACTIONS(4790),
    [anon_sym_PLUS_EQ] = ACTIONS(4790),
    [anon_sym_DASH_EQ] = ACTIONS(4790),
    [anon_sym_LT_LT_EQ] = ACTIONS(4790),
    [anon_sym_GT_GT_EQ] = ACTIONS(4790),
    [anon_sym_AMP_EQ] = ACTIONS(4790),
    [anon_sym_CARET_EQ] = ACTIONS(4790),
    [anon_sym_PIPE_EQ] = ACTIONS(4790),
    [anon_sym_and_eq] = ACTIONS(4792),
    [anon_sym_or_eq] = ACTIONS(4792),
    [anon_sym_xor_eq] = ACTIONS(4792),
    [anon_sym_LT_EQ_GT] = ACTIONS(4790),
    [anon_sym_or] = ACTIONS(4792),
    [anon_sym_and] = ACTIONS(4792),
    [anon_sym_bitor] = ACTIONS(4792),
    [anon_sym_xor] = ACTIONS(4792),
    [anon_sym_bitand] = ACTIONS(4792),
    [anon_sym_not_eq] = ACTIONS(4792),
    [anon_sym_DASH_DASH] = ACTIONS(4790),
    [anon_sym_PLUS_PLUS] = ACTIONS(4790),
    [anon_sym_DOT] = ACTIONS(4792),
    [anon_sym_DOT_STAR] = ACTIONS(4790),
    [anon_sym_DASH_GT] = ACTIONS(4790),
    [anon_sym_L_DQUOTE] = ACTIONS(5323),
    [anon_sym_u_DQUOTE] = ACTIONS(5323),
    [anon_sym_U_DQUOTE] = ACTIONS(5323),
    [anon_sym_u8_DQUOTE] = ACTIONS(5323),
    [anon_sym_DQUOTE] = ACTIONS(5323),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5326),
    [anon_sym_LR_DQUOTE] = ACTIONS(5326),
    [anon_sym_uR_DQUOTE] = ACTIONS(5326),
    [anon_sym_UR_DQUOTE] = ACTIONS(5326),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5326),
    [sym_literal_suffix] = ACTIONS(4792),
  },
  [2121] = {
    [sym_identifier] = ACTIONS(3064),
    [aux_sym_preproc_def_token1] = ACTIONS(3064),
    [aux_sym_preproc_if_token1] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3064),
    [sym_preproc_directive] = ACTIONS(3064),
    [anon_sym_LPAREN2] = ACTIONS(3066),
    [anon_sym_TILDE] = ACTIONS(3066),
    [anon_sym_STAR] = ACTIONS(3066),
    [anon_sym_AMP_AMP] = ACTIONS(3066),
    [anon_sym_AMP] = ACTIONS(3064),
    [anon_sym___extension__] = ACTIONS(3064),
    [anon_sym_typedef] = ACTIONS(3064),
    [anon_sym_extern] = ACTIONS(3064),
    [anon_sym___attribute__] = ACTIONS(3064),
    [anon_sym_COLON_COLON] = ACTIONS(3066),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3066),
    [anon_sym___declspec] = ACTIONS(3064),
    [anon_sym___based] = ACTIONS(3064),
    [anon_sym_RBRACE] = ACTIONS(3066),
    [anon_sym_signed] = ACTIONS(3064),
    [anon_sym_unsigned] = ACTIONS(3064),
    [anon_sym_long] = ACTIONS(3064),
    [anon_sym_short] = ACTIONS(3064),
    [anon_sym_LBRACK] = ACTIONS(3064),
    [anon_sym_static] = ACTIONS(3064),
    [anon_sym_register] = ACTIONS(3064),
    [anon_sym_inline] = ACTIONS(3064),
    [anon_sym___inline] = ACTIONS(3064),
    [anon_sym___inline__] = ACTIONS(3064),
    [anon_sym___forceinline] = ACTIONS(3064),
    [anon_sym_thread_local] = ACTIONS(3064),
    [anon_sym___thread] = ACTIONS(3064),
    [anon_sym_const] = ACTIONS(3064),
    [anon_sym_constexpr] = ACTIONS(3064),
    [anon_sym_volatile] = ACTIONS(3064),
    [anon_sym_restrict] = ACTIONS(3064),
    [anon_sym___restrict__] = ACTIONS(3064),
    [anon_sym__Atomic] = ACTIONS(3064),
    [anon_sym__Noreturn] = ACTIONS(3064),
    [anon_sym_noreturn] = ACTIONS(3064),
    [anon_sym_mutable] = ACTIONS(3064),
    [anon_sym_constinit] = ACTIONS(3064),
    [anon_sym_consteval] = ACTIONS(3064),
    [anon_sym_PROGMEM] = ACTIONS(3064),
    [aux_sym_primitive_type_token1] = ACTIONS(3064),
    [anon_sym_byte] = ACTIONS(3064),
    [anon_sym_word] = ACTIONS(3064),
    [anon_sym_enum] = ACTIONS(3064),
    [anon_sym_class] = ACTIONS(3064),
    [anon_sym_struct] = ACTIONS(3064),
    [anon_sym_union] = ACTIONS(3064),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3064),
    [anon_sym_decltype] = ACTIONS(3064),
    [anon_sym_virtual] = ACTIONS(3064),
    [anon_sym_alignas] = ACTIONS(3064),
    [anon_sym_explicit] = ACTIONS(3064),
    [anon_sym_typename] = ACTIONS(3064),
    [anon_sym_template] = ACTIONS(3064),
    [anon_sym_operator] = ACTIONS(3064),
    [anon_sym_friend] = ACTIONS(3064),
    [anon_sym_public] = ACTIONS(3064),
    [anon_sym_private] = ACTIONS(3064),
    [anon_sym_protected] = ACTIONS(3064),
    [anon_sym_using] = ACTIONS(3064),
    [anon_sym_static_assert] = ACTIONS(3064),
  },
  [2122] = {
    [sym_identifier] = ACTIONS(3056),
    [aux_sym_preproc_def_token1] = ACTIONS(3056),
    [aux_sym_preproc_if_token1] = ACTIONS(3056),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3056),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3056),
    [sym_preproc_directive] = ACTIONS(3056),
    [anon_sym_LPAREN2] = ACTIONS(3058),
    [anon_sym_TILDE] = ACTIONS(3058),
    [anon_sym_STAR] = ACTIONS(3058),
    [anon_sym_AMP_AMP] = ACTIONS(3058),
    [anon_sym_AMP] = ACTIONS(3056),
    [anon_sym___extension__] = ACTIONS(3056),
    [anon_sym_typedef] = ACTIONS(3056),
    [anon_sym_extern] = ACTIONS(3056),
    [anon_sym___attribute__] = ACTIONS(3056),
    [anon_sym_COLON_COLON] = ACTIONS(3058),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3058),
    [anon_sym___declspec] = ACTIONS(3056),
    [anon_sym___based] = ACTIONS(3056),
    [anon_sym_RBRACE] = ACTIONS(3058),
    [anon_sym_signed] = ACTIONS(3056),
    [anon_sym_unsigned] = ACTIONS(3056),
    [anon_sym_long] = ACTIONS(3056),
    [anon_sym_short] = ACTIONS(3056),
    [anon_sym_LBRACK] = ACTIONS(3056),
    [anon_sym_static] = ACTIONS(3056),
    [anon_sym_register] = ACTIONS(3056),
    [anon_sym_inline] = ACTIONS(3056),
    [anon_sym___inline] = ACTIONS(3056),
    [anon_sym___inline__] = ACTIONS(3056),
    [anon_sym___forceinline] = ACTIONS(3056),
    [anon_sym_thread_local] = ACTIONS(3056),
    [anon_sym___thread] = ACTIONS(3056),
    [anon_sym_const] = ACTIONS(3056),
    [anon_sym_constexpr] = ACTIONS(3056),
    [anon_sym_volatile] = ACTIONS(3056),
    [anon_sym_restrict] = ACTIONS(3056),
    [anon_sym___restrict__] = ACTIONS(3056),
    [anon_sym__Atomic] = ACTIONS(3056),
    [anon_sym__Noreturn] = ACTIONS(3056),
    [anon_sym_noreturn] = ACTIONS(3056),
    [anon_sym_mutable] = ACTIONS(3056),
    [anon_sym_constinit] = ACTIONS(3056),
    [anon_sym_consteval] = ACTIONS(3056),
    [anon_sym_PROGMEM] = ACTIONS(3056),
    [aux_sym_primitive_type_token1] = ACTIONS(3056),
    [anon_sym_byte] = ACTIONS(3056),
    [anon_sym_word] = ACTIONS(3056),
    [anon_sym_enum] = ACTIONS(3056),
    [anon_sym_class] = ACTIONS(3056),
    [anon_sym_struct] = ACTIONS(3056),
    [anon_sym_union] = ACTIONS(3056),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3056),
    [anon_sym_decltype] = ACTIONS(3056),
    [anon_sym_virtual] = ACTIONS(3056),
    [anon_sym_alignas] = ACTIONS(3056),
    [anon_sym_explicit] = ACTIONS(3056),
    [anon_sym_typename] = ACTIONS(3056),
    [anon_sym_template] = ACTIONS(3056),
    [anon_sym_operator] = ACTIONS(3056),
    [anon_sym_friend] = ACTIONS(3056),
    [anon_sym_public] = ACTIONS(3056),
    [anon_sym_private] = ACTIONS(3056),
    [anon_sym_protected] = ACTIONS(3056),
    [anon_sym_using] = ACTIONS(3056),
    [anon_sym_static_assert] = ACTIONS(3056),
  },
  [2123] = {
    [sym_identifier] = ACTIONS(2893),
    [aux_sym_preproc_def_token1] = ACTIONS(2893),
    [aux_sym_preproc_if_token1] = ACTIONS(2893),
    [aux_sym_preproc_if_token2] = ACTIONS(2893),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2893),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2893),
    [sym_preproc_directive] = ACTIONS(2893),
    [anon_sym_LPAREN2] = ACTIONS(2895),
    [anon_sym_TILDE] = ACTIONS(2895),
    [anon_sym_STAR] = ACTIONS(2895),
    [anon_sym_AMP_AMP] = ACTIONS(2895),
    [anon_sym_AMP] = ACTIONS(2893),
    [anon_sym___extension__] = ACTIONS(2893),
    [anon_sym_typedef] = ACTIONS(2893),
    [anon_sym_extern] = ACTIONS(2893),
    [anon_sym___attribute__] = ACTIONS(2893),
    [anon_sym_COLON_COLON] = ACTIONS(2895),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2895),
    [anon_sym___declspec] = ACTIONS(2893),
    [anon_sym___based] = ACTIONS(2893),
    [anon_sym_signed] = ACTIONS(2893),
    [anon_sym_unsigned] = ACTIONS(2893),
    [anon_sym_long] = ACTIONS(2893),
    [anon_sym_short] = ACTIONS(2893),
    [anon_sym_LBRACK] = ACTIONS(2893),
    [anon_sym_static] = ACTIONS(2893),
    [anon_sym_register] = ACTIONS(2893),
    [anon_sym_inline] = ACTIONS(2893),
    [anon_sym___inline] = ACTIONS(2893),
    [anon_sym___inline__] = ACTIONS(2893),
    [anon_sym___forceinline] = ACTIONS(2893),
    [anon_sym_thread_local] = ACTIONS(2893),
    [anon_sym___thread] = ACTIONS(2893),
    [anon_sym_const] = ACTIONS(2893),
    [anon_sym_constexpr] = ACTIONS(2893),
    [anon_sym_volatile] = ACTIONS(2893),
    [anon_sym_restrict] = ACTIONS(2893),
    [anon_sym___restrict__] = ACTIONS(2893),
    [anon_sym__Atomic] = ACTIONS(2893),
    [anon_sym__Noreturn] = ACTIONS(2893),
    [anon_sym_noreturn] = ACTIONS(2893),
    [anon_sym_mutable] = ACTIONS(2893),
    [anon_sym_constinit] = ACTIONS(2893),
    [anon_sym_consteval] = ACTIONS(2893),
    [anon_sym_PROGMEM] = ACTIONS(2893),
    [aux_sym_primitive_type_token1] = ACTIONS(2893),
    [anon_sym_byte] = ACTIONS(2893),
    [anon_sym_word] = ACTIONS(2893),
    [anon_sym_enum] = ACTIONS(2893),
    [anon_sym_class] = ACTIONS(2893),
    [anon_sym_struct] = ACTIONS(2893),
    [anon_sym_union] = ACTIONS(2893),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2893),
    [anon_sym_decltype] = ACTIONS(2893),
    [anon_sym_virtual] = ACTIONS(2893),
    [anon_sym_alignas] = ACTIONS(2893),
    [anon_sym_explicit] = ACTIONS(2893),
    [anon_sym_typename] = ACTIONS(2893),
    [anon_sym_template] = ACTIONS(2893),
    [anon_sym_operator] = ACTIONS(2893),
    [anon_sym_friend] = ACTIONS(2893),
    [anon_sym_public] = ACTIONS(2893),
    [anon_sym_private] = ACTIONS(2893),
    [anon_sym_protected] = ACTIONS(2893),
    [anon_sym_using] = ACTIONS(2893),
    [anon_sym_static_assert] = ACTIONS(2893),
  },
  [2124] = {
    [sym_identifier] = ACTIONS(2893),
    [aux_sym_preproc_def_token1] = ACTIONS(2893),
    [aux_sym_preproc_if_token1] = ACTIONS(2893),
    [aux_sym_preproc_if_token2] = ACTIONS(2893),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2893),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2893),
    [sym_preproc_directive] = ACTIONS(2893),
    [anon_sym_LPAREN2] = ACTIONS(2895),
    [anon_sym_TILDE] = ACTIONS(2895),
    [anon_sym_STAR] = ACTIONS(2895),
    [anon_sym_AMP_AMP] = ACTIONS(2895),
    [anon_sym_AMP] = ACTIONS(2893),
    [anon_sym___extension__] = ACTIONS(2893),
    [anon_sym_typedef] = ACTIONS(2893),
    [anon_sym_extern] = ACTIONS(2893),
    [anon_sym___attribute__] = ACTIONS(2893),
    [anon_sym_COLON_COLON] = ACTIONS(2895),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2895),
    [anon_sym___declspec] = ACTIONS(2893),
    [anon_sym___based] = ACTIONS(2893),
    [anon_sym_signed] = ACTIONS(2893),
    [anon_sym_unsigned] = ACTIONS(2893),
    [anon_sym_long] = ACTIONS(2893),
    [anon_sym_short] = ACTIONS(2893),
    [anon_sym_LBRACK] = ACTIONS(2893),
    [anon_sym_static] = ACTIONS(2893),
    [anon_sym_register] = ACTIONS(2893),
    [anon_sym_inline] = ACTIONS(2893),
    [anon_sym___inline] = ACTIONS(2893),
    [anon_sym___inline__] = ACTIONS(2893),
    [anon_sym___forceinline] = ACTIONS(2893),
    [anon_sym_thread_local] = ACTIONS(2893),
    [anon_sym___thread] = ACTIONS(2893),
    [anon_sym_const] = ACTIONS(2893),
    [anon_sym_constexpr] = ACTIONS(2893),
    [anon_sym_volatile] = ACTIONS(2893),
    [anon_sym_restrict] = ACTIONS(2893),
    [anon_sym___restrict__] = ACTIONS(2893),
    [anon_sym__Atomic] = ACTIONS(2893),
    [anon_sym__Noreturn] = ACTIONS(2893),
    [anon_sym_noreturn] = ACTIONS(2893),
    [anon_sym_mutable] = ACTIONS(2893),
    [anon_sym_constinit] = ACTIONS(2893),
    [anon_sym_consteval] = ACTIONS(2893),
    [anon_sym_PROGMEM] = ACTIONS(2893),
    [aux_sym_primitive_type_token1] = ACTIONS(2893),
    [anon_sym_byte] = ACTIONS(2893),
    [anon_sym_word] = ACTIONS(2893),
    [anon_sym_enum] = ACTIONS(2893),
    [anon_sym_class] = ACTIONS(2893),
    [anon_sym_struct] = ACTIONS(2893),
    [anon_sym_union] = ACTIONS(2893),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2893),
    [anon_sym_decltype] = ACTIONS(2893),
    [anon_sym_virtual] = ACTIONS(2893),
    [anon_sym_alignas] = ACTIONS(2893),
    [anon_sym_explicit] = ACTIONS(2893),
    [anon_sym_typename] = ACTIONS(2893),
    [anon_sym_template] = ACTIONS(2893),
    [anon_sym_operator] = ACTIONS(2893),
    [anon_sym_friend] = ACTIONS(2893),
    [anon_sym_public] = ACTIONS(2893),
    [anon_sym_private] = ACTIONS(2893),
    [anon_sym_protected] = ACTIONS(2893),
    [anon_sym_using] = ACTIONS(2893),
    [anon_sym_static_assert] = ACTIONS(2893),
  },
  [2125] = {
    [sym_identifier] = ACTIONS(2773),
    [aux_sym_preproc_def_token1] = ACTIONS(2773),
    [aux_sym_preproc_if_token1] = ACTIONS(2773),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2773),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2773),
    [sym_preproc_directive] = ACTIONS(2773),
    [anon_sym_LPAREN2] = ACTIONS(2775),
    [anon_sym_TILDE] = ACTIONS(2775),
    [anon_sym_STAR] = ACTIONS(2775),
    [anon_sym_AMP_AMP] = ACTIONS(2775),
    [anon_sym_AMP] = ACTIONS(2773),
    [anon_sym___extension__] = ACTIONS(2773),
    [anon_sym_typedef] = ACTIONS(2773),
    [anon_sym_extern] = ACTIONS(2773),
    [anon_sym___attribute__] = ACTIONS(2773),
    [anon_sym_COLON_COLON] = ACTIONS(2775),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2775),
    [anon_sym___declspec] = ACTIONS(2773),
    [anon_sym___based] = ACTIONS(2773),
    [anon_sym_RBRACE] = ACTIONS(2775),
    [anon_sym_signed] = ACTIONS(2773),
    [anon_sym_unsigned] = ACTIONS(2773),
    [anon_sym_long] = ACTIONS(2773),
    [anon_sym_short] = ACTIONS(2773),
    [anon_sym_LBRACK] = ACTIONS(2773),
    [anon_sym_static] = ACTIONS(2773),
    [anon_sym_register] = ACTIONS(2773),
    [anon_sym_inline] = ACTIONS(2773),
    [anon_sym___inline] = ACTIONS(2773),
    [anon_sym___inline__] = ACTIONS(2773),
    [anon_sym___forceinline] = ACTIONS(2773),
    [anon_sym_thread_local] = ACTIONS(2773),
    [anon_sym___thread] = ACTIONS(2773),
    [anon_sym_const] = ACTIONS(2773),
    [anon_sym_constexpr] = ACTIONS(2773),
    [anon_sym_volatile] = ACTIONS(2773),
    [anon_sym_restrict] = ACTIONS(2773),
    [anon_sym___restrict__] = ACTIONS(2773),
    [anon_sym__Atomic] = ACTIONS(2773),
    [anon_sym__Noreturn] = ACTIONS(2773),
    [anon_sym_noreturn] = ACTIONS(2773),
    [anon_sym_mutable] = ACTIONS(2773),
    [anon_sym_constinit] = ACTIONS(2773),
    [anon_sym_consteval] = ACTIONS(2773),
    [anon_sym_PROGMEM] = ACTIONS(2773),
    [aux_sym_primitive_type_token1] = ACTIONS(2773),
    [anon_sym_byte] = ACTIONS(2773),
    [anon_sym_word] = ACTIONS(2773),
    [anon_sym_enum] = ACTIONS(2773),
    [anon_sym_class] = ACTIONS(2773),
    [anon_sym_struct] = ACTIONS(2773),
    [anon_sym_union] = ACTIONS(2773),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2773),
    [anon_sym_decltype] = ACTIONS(2773),
    [anon_sym_virtual] = ACTIONS(2773),
    [anon_sym_alignas] = ACTIONS(2773),
    [anon_sym_explicit] = ACTIONS(2773),
    [anon_sym_typename] = ACTIONS(2773),
    [anon_sym_template] = ACTIONS(2773),
    [anon_sym_operator] = ACTIONS(2773),
    [anon_sym_friend] = ACTIONS(2773),
    [anon_sym_public] = ACTIONS(2773),
    [anon_sym_private] = ACTIONS(2773),
    [anon_sym_protected] = ACTIONS(2773),
    [anon_sym_using] = ACTIONS(2773),
    [anon_sym_static_assert] = ACTIONS(2773),
  },
  [2126] = {
    [sym_identifier] = ACTIONS(2945),
    [aux_sym_preproc_def_token1] = ACTIONS(2945),
    [aux_sym_preproc_if_token1] = ACTIONS(2945),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2945),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2945),
    [sym_preproc_directive] = ACTIONS(2945),
    [anon_sym_LPAREN2] = ACTIONS(2947),
    [anon_sym_TILDE] = ACTIONS(2947),
    [anon_sym_STAR] = ACTIONS(2947),
    [anon_sym_AMP_AMP] = ACTIONS(2947),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym___extension__] = ACTIONS(2945),
    [anon_sym_typedef] = ACTIONS(2945),
    [anon_sym_extern] = ACTIONS(2945),
    [anon_sym___attribute__] = ACTIONS(2945),
    [anon_sym_COLON_COLON] = ACTIONS(2947),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2947),
    [anon_sym___declspec] = ACTIONS(2945),
    [anon_sym___based] = ACTIONS(2945),
    [anon_sym_RBRACE] = ACTIONS(2947),
    [anon_sym_signed] = ACTIONS(2945),
    [anon_sym_unsigned] = ACTIONS(2945),
    [anon_sym_long] = ACTIONS(2945),
    [anon_sym_short] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(2945),
    [anon_sym_static] = ACTIONS(2945),
    [anon_sym_register] = ACTIONS(2945),
    [anon_sym_inline] = ACTIONS(2945),
    [anon_sym___inline] = ACTIONS(2945),
    [anon_sym___inline__] = ACTIONS(2945),
    [anon_sym___forceinline] = ACTIONS(2945),
    [anon_sym_thread_local] = ACTIONS(2945),
    [anon_sym___thread] = ACTIONS(2945),
    [anon_sym_const] = ACTIONS(2945),
    [anon_sym_constexpr] = ACTIONS(2945),
    [anon_sym_volatile] = ACTIONS(2945),
    [anon_sym_restrict] = ACTIONS(2945),
    [anon_sym___restrict__] = ACTIONS(2945),
    [anon_sym__Atomic] = ACTIONS(2945),
    [anon_sym__Noreturn] = ACTIONS(2945),
    [anon_sym_noreturn] = ACTIONS(2945),
    [anon_sym_mutable] = ACTIONS(2945),
    [anon_sym_constinit] = ACTIONS(2945),
    [anon_sym_consteval] = ACTIONS(2945),
    [anon_sym_PROGMEM] = ACTIONS(2945),
    [aux_sym_primitive_type_token1] = ACTIONS(2945),
    [anon_sym_byte] = ACTIONS(2945),
    [anon_sym_word] = ACTIONS(2945),
    [anon_sym_enum] = ACTIONS(2945),
    [anon_sym_class] = ACTIONS(2945),
    [anon_sym_struct] = ACTIONS(2945),
    [anon_sym_union] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2945),
    [anon_sym_decltype] = ACTIONS(2945),
    [anon_sym_virtual] = ACTIONS(2945),
    [anon_sym_alignas] = ACTIONS(2945),
    [anon_sym_explicit] = ACTIONS(2945),
    [anon_sym_typename] = ACTIONS(2945),
    [anon_sym_template] = ACTIONS(2945),
    [anon_sym_operator] = ACTIONS(2945),
    [anon_sym_friend] = ACTIONS(2945),
    [anon_sym_public] = ACTIONS(2945),
    [anon_sym_private] = ACTIONS(2945),
    [anon_sym_protected] = ACTIONS(2945),
    [anon_sym_using] = ACTIONS(2945),
    [anon_sym_static_assert] = ACTIONS(2945),
  },
  [2127] = {
    [sym_identifier] = ACTIONS(3468),
    [aux_sym_preproc_def_token1] = ACTIONS(3468),
    [aux_sym_preproc_if_token1] = ACTIONS(3468),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3468),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3468),
    [sym_preproc_directive] = ACTIONS(3468),
    [anon_sym_LPAREN2] = ACTIONS(3466),
    [anon_sym_TILDE] = ACTIONS(3466),
    [anon_sym_STAR] = ACTIONS(3466),
    [anon_sym_AMP_AMP] = ACTIONS(3466),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym___extension__] = ACTIONS(3468),
    [anon_sym_typedef] = ACTIONS(3468),
    [anon_sym_extern] = ACTIONS(3468),
    [anon_sym___attribute__] = ACTIONS(3468),
    [anon_sym_COLON_COLON] = ACTIONS(3466),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3466),
    [anon_sym___declspec] = ACTIONS(3468),
    [anon_sym___based] = ACTIONS(3468),
    [anon_sym_RBRACE] = ACTIONS(3466),
    [anon_sym_signed] = ACTIONS(3468),
    [anon_sym_unsigned] = ACTIONS(3468),
    [anon_sym_long] = ACTIONS(3468),
    [anon_sym_short] = ACTIONS(3468),
    [anon_sym_LBRACK] = ACTIONS(3468),
    [anon_sym_static] = ACTIONS(3468),
    [anon_sym_register] = ACTIONS(3468),
    [anon_sym_inline] = ACTIONS(3468),
    [anon_sym___inline] = ACTIONS(3468),
    [anon_sym___inline__] = ACTIONS(3468),
    [anon_sym___forceinline] = ACTIONS(3468),
    [anon_sym_thread_local] = ACTIONS(3468),
    [anon_sym___thread] = ACTIONS(3468),
    [anon_sym_const] = ACTIONS(3468),
    [anon_sym_constexpr] = ACTIONS(3468),
    [anon_sym_volatile] = ACTIONS(3468),
    [anon_sym_restrict] = ACTIONS(3468),
    [anon_sym___restrict__] = ACTIONS(3468),
    [anon_sym__Atomic] = ACTIONS(3468),
    [anon_sym__Noreturn] = ACTIONS(3468),
    [anon_sym_noreturn] = ACTIONS(3468),
    [anon_sym_mutable] = ACTIONS(3468),
    [anon_sym_constinit] = ACTIONS(3468),
    [anon_sym_consteval] = ACTIONS(3468),
    [anon_sym_PROGMEM] = ACTIONS(3468),
    [aux_sym_primitive_type_token1] = ACTIONS(3468),
    [anon_sym_byte] = ACTIONS(3468),
    [anon_sym_word] = ACTIONS(3468),
    [anon_sym_enum] = ACTIONS(3468),
    [anon_sym_class] = ACTIONS(3468),
    [anon_sym_struct] = ACTIONS(3468),
    [anon_sym_union] = ACTIONS(3468),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3468),
    [anon_sym_decltype] = ACTIONS(3468),
    [anon_sym_virtual] = ACTIONS(3468),
    [anon_sym_alignas] = ACTIONS(3468),
    [anon_sym_explicit] = ACTIONS(3468),
    [anon_sym_typename] = ACTIONS(3468),
    [anon_sym_template] = ACTIONS(3468),
    [anon_sym_operator] = ACTIONS(3468),
    [anon_sym_friend] = ACTIONS(3468),
    [anon_sym_public] = ACTIONS(3468),
    [anon_sym_private] = ACTIONS(3468),
    [anon_sym_protected] = ACTIONS(3468),
    [anon_sym_using] = ACTIONS(3468),
    [anon_sym_static_assert] = ACTIONS(3468),
  },
  [2128] = {
    [sym_identifier] = ACTIONS(2813),
    [aux_sym_preproc_def_token1] = ACTIONS(2813),
    [aux_sym_preproc_if_token1] = ACTIONS(2813),
    [aux_sym_preproc_if_token2] = ACTIONS(2813),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2813),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2813),
    [sym_preproc_directive] = ACTIONS(2813),
    [anon_sym_LPAREN2] = ACTIONS(2815),
    [anon_sym_TILDE] = ACTIONS(2815),
    [anon_sym_STAR] = ACTIONS(2815),
    [anon_sym_AMP_AMP] = ACTIONS(2815),
    [anon_sym_AMP] = ACTIONS(2813),
    [anon_sym___extension__] = ACTIONS(2813),
    [anon_sym_typedef] = ACTIONS(2813),
    [anon_sym_extern] = ACTIONS(2813),
    [anon_sym___attribute__] = ACTIONS(2813),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2815),
    [anon_sym___declspec] = ACTIONS(2813),
    [anon_sym___based] = ACTIONS(2813),
    [anon_sym_signed] = ACTIONS(2813),
    [anon_sym_unsigned] = ACTIONS(2813),
    [anon_sym_long] = ACTIONS(2813),
    [anon_sym_short] = ACTIONS(2813),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_static] = ACTIONS(2813),
    [anon_sym_register] = ACTIONS(2813),
    [anon_sym_inline] = ACTIONS(2813),
    [anon_sym___inline] = ACTIONS(2813),
    [anon_sym___inline__] = ACTIONS(2813),
    [anon_sym___forceinline] = ACTIONS(2813),
    [anon_sym_thread_local] = ACTIONS(2813),
    [anon_sym___thread] = ACTIONS(2813),
    [anon_sym_const] = ACTIONS(2813),
    [anon_sym_constexpr] = ACTIONS(2813),
    [anon_sym_volatile] = ACTIONS(2813),
    [anon_sym_restrict] = ACTIONS(2813),
    [anon_sym___restrict__] = ACTIONS(2813),
    [anon_sym__Atomic] = ACTIONS(2813),
    [anon_sym__Noreturn] = ACTIONS(2813),
    [anon_sym_noreturn] = ACTIONS(2813),
    [anon_sym_mutable] = ACTIONS(2813),
    [anon_sym_constinit] = ACTIONS(2813),
    [anon_sym_consteval] = ACTIONS(2813),
    [anon_sym_PROGMEM] = ACTIONS(2813),
    [aux_sym_primitive_type_token1] = ACTIONS(2813),
    [anon_sym_byte] = ACTIONS(2813),
    [anon_sym_word] = ACTIONS(2813),
    [anon_sym_enum] = ACTIONS(2813),
    [anon_sym_class] = ACTIONS(2813),
    [anon_sym_struct] = ACTIONS(2813),
    [anon_sym_union] = ACTIONS(2813),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2813),
    [anon_sym_decltype] = ACTIONS(2813),
    [anon_sym_virtual] = ACTIONS(2813),
    [anon_sym_alignas] = ACTIONS(2813),
    [anon_sym_explicit] = ACTIONS(2813),
    [anon_sym_typename] = ACTIONS(2813),
    [anon_sym_template] = ACTIONS(2813),
    [anon_sym_operator] = ACTIONS(2813),
    [anon_sym_friend] = ACTIONS(2813),
    [anon_sym_public] = ACTIONS(2813),
    [anon_sym_private] = ACTIONS(2813),
    [anon_sym_protected] = ACTIONS(2813),
    [anon_sym_using] = ACTIONS(2813),
    [anon_sym_static_assert] = ACTIONS(2813),
  },
  [2129] = {
    [sym_identifier] = ACTIONS(2813),
    [aux_sym_preproc_def_token1] = ACTIONS(2813),
    [aux_sym_preproc_if_token1] = ACTIONS(2813),
    [aux_sym_preproc_if_token2] = ACTIONS(2813),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2813),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2813),
    [sym_preproc_directive] = ACTIONS(2813),
    [anon_sym_LPAREN2] = ACTIONS(2815),
    [anon_sym_TILDE] = ACTIONS(2815),
    [anon_sym_STAR] = ACTIONS(2815),
    [anon_sym_AMP_AMP] = ACTIONS(2815),
    [anon_sym_AMP] = ACTIONS(2813),
    [anon_sym___extension__] = ACTIONS(2813),
    [anon_sym_typedef] = ACTIONS(2813),
    [anon_sym_extern] = ACTIONS(2813),
    [anon_sym___attribute__] = ACTIONS(2813),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2815),
    [anon_sym___declspec] = ACTIONS(2813),
    [anon_sym___based] = ACTIONS(2813),
    [anon_sym_signed] = ACTIONS(2813),
    [anon_sym_unsigned] = ACTIONS(2813),
    [anon_sym_long] = ACTIONS(2813),
    [anon_sym_short] = ACTIONS(2813),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_static] = ACTIONS(2813),
    [anon_sym_register] = ACTIONS(2813),
    [anon_sym_inline] = ACTIONS(2813),
    [anon_sym___inline] = ACTIONS(2813),
    [anon_sym___inline__] = ACTIONS(2813),
    [anon_sym___forceinline] = ACTIONS(2813),
    [anon_sym_thread_local] = ACTIONS(2813),
    [anon_sym___thread] = ACTIONS(2813),
    [anon_sym_const] = ACTIONS(2813),
    [anon_sym_constexpr] = ACTIONS(2813),
    [anon_sym_volatile] = ACTIONS(2813),
    [anon_sym_restrict] = ACTIONS(2813),
    [anon_sym___restrict__] = ACTIONS(2813),
    [anon_sym__Atomic] = ACTIONS(2813),
    [anon_sym__Noreturn] = ACTIONS(2813),
    [anon_sym_noreturn] = ACTIONS(2813),
    [anon_sym_mutable] = ACTIONS(2813),
    [anon_sym_constinit] = ACTIONS(2813),
    [anon_sym_consteval] = ACTIONS(2813),
    [anon_sym_PROGMEM] = ACTIONS(2813),
    [aux_sym_primitive_type_token1] = ACTIONS(2813),
    [anon_sym_byte] = ACTIONS(2813),
    [anon_sym_word] = ACTIONS(2813),
    [anon_sym_enum] = ACTIONS(2813),
    [anon_sym_class] = ACTIONS(2813),
    [anon_sym_struct] = ACTIONS(2813),
    [anon_sym_union] = ACTIONS(2813),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2813),
    [anon_sym_decltype] = ACTIONS(2813),
    [anon_sym_virtual] = ACTIONS(2813),
    [anon_sym_alignas] = ACTIONS(2813),
    [anon_sym_explicit] = ACTIONS(2813),
    [anon_sym_typename] = ACTIONS(2813),
    [anon_sym_template] = ACTIONS(2813),
    [anon_sym_operator] = ACTIONS(2813),
    [anon_sym_friend] = ACTIONS(2813),
    [anon_sym_public] = ACTIONS(2813),
    [anon_sym_private] = ACTIONS(2813),
    [anon_sym_protected] = ACTIONS(2813),
    [anon_sym_using] = ACTIONS(2813),
    [anon_sym_static_assert] = ACTIONS(2813),
  },
  [2130] = {
    [sym_string_literal] = STATE(2405),
    [sym_template_argument_list] = STATE(3614),
    [sym_raw_string_literal] = STATE(2405),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3761),
    [anon_sym_COMMA] = ACTIONS(3761),
    [anon_sym_RPAREN] = ACTIONS(3761),
    [anon_sym_LPAREN2] = ACTIONS(3761),
    [anon_sym_DASH] = ACTIONS(3769),
    [anon_sym_PLUS] = ACTIONS(3769),
    [anon_sym_STAR] = ACTIONS(3769),
    [anon_sym_SLASH] = ACTIONS(3769),
    [anon_sym_PERCENT] = ACTIONS(3769),
    [anon_sym_PIPE_PIPE] = ACTIONS(3761),
    [anon_sym_AMP_AMP] = ACTIONS(3761),
    [anon_sym_PIPE] = ACTIONS(3769),
    [anon_sym_CARET] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(3769),
    [anon_sym_EQ_EQ] = ACTIONS(3761),
    [anon_sym_BANG_EQ] = ACTIONS(3761),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3761),
    [anon_sym_LT_EQ] = ACTIONS(3769),
    [anon_sym_LT] = ACTIONS(5329),
    [anon_sym_LT_LT] = ACTIONS(3769),
    [anon_sym_GT_GT] = ACTIONS(3769),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(3785),
    [anon_sym_LBRACK] = ACTIONS(3761),
    [anon_sym_EQ] = ACTIONS(3769),
    [anon_sym_QMARK] = ACTIONS(3761),
    [anon_sym_STAR_EQ] = ACTIONS(3761),
    [anon_sym_SLASH_EQ] = ACTIONS(3761),
    [anon_sym_PERCENT_EQ] = ACTIONS(3761),
    [anon_sym_PLUS_EQ] = ACTIONS(3761),
    [anon_sym_DASH_EQ] = ACTIONS(3761),
    [anon_sym_LT_LT_EQ] = ACTIONS(3761),
    [anon_sym_GT_GT_EQ] = ACTIONS(3761),
    [anon_sym_AMP_EQ] = ACTIONS(3761),
    [anon_sym_CARET_EQ] = ACTIONS(3761),
    [anon_sym_PIPE_EQ] = ACTIONS(3761),
    [anon_sym_and_eq] = ACTIONS(5332),
    [anon_sym_or_eq] = ACTIONS(5332),
    [anon_sym_xor_eq] = ACTIONS(5332),
    [anon_sym_LT_EQ_GT] = ACTIONS(3761),
    [anon_sym_or] = ACTIONS(3769),
    [anon_sym_and] = ACTIONS(3769),
    [anon_sym_bitor] = ACTIONS(3761),
    [anon_sym_xor] = ACTIONS(3769),
    [anon_sym_bitand] = ACTIONS(3761),
    [anon_sym_not_eq] = ACTIONS(3761),
    [anon_sym_DASH_DASH] = ACTIONS(3761),
    [anon_sym_PLUS_PLUS] = ACTIONS(3761),
    [anon_sym_DOT] = ACTIONS(3769),
    [anon_sym_DOT_STAR] = ACTIONS(3761),
    [anon_sym_DASH_GT] = ACTIONS(3769),
    [anon_sym_L_DQUOTE] = ACTIONS(4040),
    [anon_sym_u_DQUOTE] = ACTIONS(4040),
    [anon_sym_U_DQUOTE] = ACTIONS(4040),
    [anon_sym_u8_DQUOTE] = ACTIONS(4040),
    [anon_sym_DQUOTE] = ACTIONS(4040),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4042),
    [anon_sym_LR_DQUOTE] = ACTIONS(4042),
    [anon_sym_uR_DQUOTE] = ACTIONS(4042),
    [anon_sym_UR_DQUOTE] = ACTIONS(4042),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4042),
    [anon_sym_DASH_GT_STAR] = ACTIONS(3761),
  },
  [2131] = {
    [sym_identifier] = ACTIONS(2925),
    [aux_sym_preproc_def_token1] = ACTIONS(2925),
    [aux_sym_preproc_if_token1] = ACTIONS(2925),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2925),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2925),
    [sym_preproc_directive] = ACTIONS(2925),
    [anon_sym_LPAREN2] = ACTIONS(2927),
    [anon_sym_TILDE] = ACTIONS(2927),
    [anon_sym_STAR] = ACTIONS(2927),
    [anon_sym_AMP_AMP] = ACTIONS(2927),
    [anon_sym_AMP] = ACTIONS(2925),
    [anon_sym___extension__] = ACTIONS(2925),
    [anon_sym_typedef] = ACTIONS(2925),
    [anon_sym_extern] = ACTIONS(2925),
    [anon_sym___attribute__] = ACTIONS(2925),
    [anon_sym_COLON_COLON] = ACTIONS(2927),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2927),
    [anon_sym___declspec] = ACTIONS(2925),
    [anon_sym___based] = ACTIONS(2925),
    [anon_sym_RBRACE] = ACTIONS(2927),
    [anon_sym_signed] = ACTIONS(2925),
    [anon_sym_unsigned] = ACTIONS(2925),
    [anon_sym_long] = ACTIONS(2925),
    [anon_sym_short] = ACTIONS(2925),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_static] = ACTIONS(2925),
    [anon_sym_register] = ACTIONS(2925),
    [anon_sym_inline] = ACTIONS(2925),
    [anon_sym___inline] = ACTIONS(2925),
    [anon_sym___inline__] = ACTIONS(2925),
    [anon_sym___forceinline] = ACTIONS(2925),
    [anon_sym_thread_local] = ACTIONS(2925),
    [anon_sym___thread] = ACTIONS(2925),
    [anon_sym_const] = ACTIONS(2925),
    [anon_sym_constexpr] = ACTIONS(2925),
    [anon_sym_volatile] = ACTIONS(2925),
    [anon_sym_restrict] = ACTIONS(2925),
    [anon_sym___restrict__] = ACTIONS(2925),
    [anon_sym__Atomic] = ACTIONS(2925),
    [anon_sym__Noreturn] = ACTIONS(2925),
    [anon_sym_noreturn] = ACTIONS(2925),
    [anon_sym_mutable] = ACTIONS(2925),
    [anon_sym_constinit] = ACTIONS(2925),
    [anon_sym_consteval] = ACTIONS(2925),
    [anon_sym_PROGMEM] = ACTIONS(2925),
    [aux_sym_primitive_type_token1] = ACTIONS(2925),
    [anon_sym_byte] = ACTIONS(2925),
    [anon_sym_word] = ACTIONS(2925),
    [anon_sym_enum] = ACTIONS(2925),
    [anon_sym_class] = ACTIONS(2925),
    [anon_sym_struct] = ACTIONS(2925),
    [anon_sym_union] = ACTIONS(2925),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2925),
    [anon_sym_decltype] = ACTIONS(2925),
    [anon_sym_virtual] = ACTIONS(2925),
    [anon_sym_alignas] = ACTIONS(2925),
    [anon_sym_explicit] = ACTIONS(2925),
    [anon_sym_typename] = ACTIONS(2925),
    [anon_sym_template] = ACTIONS(2925),
    [anon_sym_operator] = ACTIONS(2925),
    [anon_sym_friend] = ACTIONS(2925),
    [anon_sym_public] = ACTIONS(2925),
    [anon_sym_private] = ACTIONS(2925),
    [anon_sym_protected] = ACTIONS(2925),
    [anon_sym_using] = ACTIONS(2925),
    [anon_sym_static_assert] = ACTIONS(2925),
  },
  [2132] = {
    [sym_identifier] = ACTIONS(4996),
    [aux_sym_preproc_def_token1] = ACTIONS(4996),
    [aux_sym_preproc_if_token1] = ACTIONS(4996),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4996),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4996),
    [sym_preproc_directive] = ACTIONS(4996),
    [anon_sym_LPAREN2] = ACTIONS(4998),
    [anon_sym_TILDE] = ACTIONS(4998),
    [anon_sym_STAR] = ACTIONS(4998),
    [anon_sym_AMP_AMP] = ACTIONS(4998),
    [anon_sym_AMP] = ACTIONS(4996),
    [anon_sym___extension__] = ACTIONS(4996),
    [anon_sym_typedef] = ACTIONS(4996),
    [anon_sym_extern] = ACTIONS(4996),
    [anon_sym___attribute__] = ACTIONS(4996),
    [anon_sym_COLON_COLON] = ACTIONS(4998),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4998),
    [anon_sym___declspec] = ACTIONS(4996),
    [anon_sym___based] = ACTIONS(4996),
    [anon_sym_RBRACE] = ACTIONS(4998),
    [anon_sym_signed] = ACTIONS(4996),
    [anon_sym_unsigned] = ACTIONS(4996),
    [anon_sym_long] = ACTIONS(4996),
    [anon_sym_short] = ACTIONS(4996),
    [anon_sym_LBRACK] = ACTIONS(4996),
    [anon_sym_static] = ACTIONS(4996),
    [anon_sym_register] = ACTIONS(4996),
    [anon_sym_inline] = ACTIONS(4996),
    [anon_sym___inline] = ACTIONS(4996),
    [anon_sym___inline__] = ACTIONS(4996),
    [anon_sym___forceinline] = ACTIONS(4996),
    [anon_sym_thread_local] = ACTIONS(4996),
    [anon_sym___thread] = ACTIONS(4996),
    [anon_sym_const] = ACTIONS(4996),
    [anon_sym_constexpr] = ACTIONS(4996),
    [anon_sym_volatile] = ACTIONS(4996),
    [anon_sym_restrict] = ACTIONS(4996),
    [anon_sym___restrict__] = ACTIONS(4996),
    [anon_sym__Atomic] = ACTIONS(4996),
    [anon_sym__Noreturn] = ACTIONS(4996),
    [anon_sym_noreturn] = ACTIONS(4996),
    [anon_sym_mutable] = ACTIONS(4996),
    [anon_sym_constinit] = ACTIONS(4996),
    [anon_sym_consteval] = ACTIONS(4996),
    [anon_sym_PROGMEM] = ACTIONS(4996),
    [aux_sym_primitive_type_token1] = ACTIONS(4996),
    [anon_sym_byte] = ACTIONS(4996),
    [anon_sym_word] = ACTIONS(4996),
    [anon_sym_enum] = ACTIONS(4996),
    [anon_sym_class] = ACTIONS(4996),
    [anon_sym_struct] = ACTIONS(4996),
    [anon_sym_union] = ACTIONS(4996),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4996),
    [anon_sym_decltype] = ACTIONS(4996),
    [anon_sym_virtual] = ACTIONS(4996),
    [anon_sym_alignas] = ACTIONS(4996),
    [anon_sym_explicit] = ACTIONS(4996),
    [anon_sym_typename] = ACTIONS(4996),
    [anon_sym_template] = ACTIONS(4996),
    [anon_sym_operator] = ACTIONS(4996),
    [anon_sym_friend] = ACTIONS(4996),
    [anon_sym_public] = ACTIONS(4996),
    [anon_sym_private] = ACTIONS(4996),
    [anon_sym_protected] = ACTIONS(4996),
    [anon_sym_using] = ACTIONS(4996),
    [anon_sym_static_assert] = ACTIONS(4996),
  },
  [2133] = {
    [sym_identifier] = ACTIONS(3016),
    [aux_sym_preproc_def_token1] = ACTIONS(3016),
    [aux_sym_preproc_if_token1] = ACTIONS(3016),
    [aux_sym_preproc_if_token2] = ACTIONS(3016),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3016),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3016),
    [sym_preproc_directive] = ACTIONS(3016),
    [anon_sym_LPAREN2] = ACTIONS(3018),
    [anon_sym_TILDE] = ACTIONS(3018),
    [anon_sym_STAR] = ACTIONS(3018),
    [anon_sym_AMP_AMP] = ACTIONS(3018),
    [anon_sym_AMP] = ACTIONS(3016),
    [anon_sym___extension__] = ACTIONS(3016),
    [anon_sym_typedef] = ACTIONS(3016),
    [anon_sym_extern] = ACTIONS(3016),
    [anon_sym___attribute__] = ACTIONS(3016),
    [anon_sym_COLON_COLON] = ACTIONS(3018),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3018),
    [anon_sym___declspec] = ACTIONS(3016),
    [anon_sym___based] = ACTIONS(3016),
    [anon_sym_signed] = ACTIONS(3016),
    [anon_sym_unsigned] = ACTIONS(3016),
    [anon_sym_long] = ACTIONS(3016),
    [anon_sym_short] = ACTIONS(3016),
    [anon_sym_LBRACK] = ACTIONS(3016),
    [anon_sym_static] = ACTIONS(3016),
    [anon_sym_register] = ACTIONS(3016),
    [anon_sym_inline] = ACTIONS(3016),
    [anon_sym___inline] = ACTIONS(3016),
    [anon_sym___inline__] = ACTIONS(3016),
    [anon_sym___forceinline] = ACTIONS(3016),
    [anon_sym_thread_local] = ACTIONS(3016),
    [anon_sym___thread] = ACTIONS(3016),
    [anon_sym_const] = ACTIONS(3016),
    [anon_sym_constexpr] = ACTIONS(3016),
    [anon_sym_volatile] = ACTIONS(3016),
    [anon_sym_restrict] = ACTIONS(3016),
    [anon_sym___restrict__] = ACTIONS(3016),
    [anon_sym__Atomic] = ACTIONS(3016),
    [anon_sym__Noreturn] = ACTIONS(3016),
    [anon_sym_noreturn] = ACTIONS(3016),
    [anon_sym_mutable] = ACTIONS(3016),
    [anon_sym_constinit] = ACTIONS(3016),
    [anon_sym_consteval] = ACTIONS(3016),
    [anon_sym_PROGMEM] = ACTIONS(3016),
    [aux_sym_primitive_type_token1] = ACTIONS(3016),
    [anon_sym_byte] = ACTIONS(3016),
    [anon_sym_word] = ACTIONS(3016),
    [anon_sym_enum] = ACTIONS(3016),
    [anon_sym_class] = ACTIONS(3016),
    [anon_sym_struct] = ACTIONS(3016),
    [anon_sym_union] = ACTIONS(3016),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3016),
    [anon_sym_decltype] = ACTIONS(3016),
    [anon_sym_virtual] = ACTIONS(3016),
    [anon_sym_alignas] = ACTIONS(3016),
    [anon_sym_explicit] = ACTIONS(3016),
    [anon_sym_typename] = ACTIONS(3016),
    [anon_sym_template] = ACTIONS(3016),
    [anon_sym_operator] = ACTIONS(3016),
    [anon_sym_friend] = ACTIONS(3016),
    [anon_sym_public] = ACTIONS(3016),
    [anon_sym_private] = ACTIONS(3016),
    [anon_sym_protected] = ACTIONS(3016),
    [anon_sym_using] = ACTIONS(3016),
    [anon_sym_static_assert] = ACTIONS(3016),
  },
  [2134] = {
    [sym_identifier] = ACTIONS(3148),
    [aux_sym_preproc_def_token1] = ACTIONS(3148),
    [aux_sym_preproc_if_token1] = ACTIONS(3148),
    [aux_sym_preproc_if_token2] = ACTIONS(3148),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3148),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3148),
    [sym_preproc_directive] = ACTIONS(3148),
    [anon_sym_LPAREN2] = ACTIONS(3150),
    [anon_sym_TILDE] = ACTIONS(3150),
    [anon_sym_STAR] = ACTIONS(3150),
    [anon_sym_AMP_AMP] = ACTIONS(3150),
    [anon_sym_AMP] = ACTIONS(3148),
    [anon_sym___extension__] = ACTIONS(3148),
    [anon_sym_typedef] = ACTIONS(3148),
    [anon_sym_extern] = ACTIONS(3148),
    [anon_sym___attribute__] = ACTIONS(3148),
    [anon_sym_COLON_COLON] = ACTIONS(3150),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3150),
    [anon_sym___declspec] = ACTIONS(3148),
    [anon_sym___based] = ACTIONS(3148),
    [anon_sym_signed] = ACTIONS(3148),
    [anon_sym_unsigned] = ACTIONS(3148),
    [anon_sym_long] = ACTIONS(3148),
    [anon_sym_short] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_static] = ACTIONS(3148),
    [anon_sym_register] = ACTIONS(3148),
    [anon_sym_inline] = ACTIONS(3148),
    [anon_sym___inline] = ACTIONS(3148),
    [anon_sym___inline__] = ACTIONS(3148),
    [anon_sym___forceinline] = ACTIONS(3148),
    [anon_sym_thread_local] = ACTIONS(3148),
    [anon_sym___thread] = ACTIONS(3148),
    [anon_sym_const] = ACTIONS(3148),
    [anon_sym_constexpr] = ACTIONS(3148),
    [anon_sym_volatile] = ACTIONS(3148),
    [anon_sym_restrict] = ACTIONS(3148),
    [anon_sym___restrict__] = ACTIONS(3148),
    [anon_sym__Atomic] = ACTIONS(3148),
    [anon_sym__Noreturn] = ACTIONS(3148),
    [anon_sym_noreturn] = ACTIONS(3148),
    [anon_sym_mutable] = ACTIONS(3148),
    [anon_sym_constinit] = ACTIONS(3148),
    [anon_sym_consteval] = ACTIONS(3148),
    [anon_sym_PROGMEM] = ACTIONS(3148),
    [aux_sym_primitive_type_token1] = ACTIONS(3148),
    [anon_sym_byte] = ACTIONS(3148),
    [anon_sym_word] = ACTIONS(3148),
    [anon_sym_enum] = ACTIONS(3148),
    [anon_sym_class] = ACTIONS(3148),
    [anon_sym_struct] = ACTIONS(3148),
    [anon_sym_union] = ACTIONS(3148),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3148),
    [anon_sym_decltype] = ACTIONS(3148),
    [anon_sym_virtual] = ACTIONS(3148),
    [anon_sym_alignas] = ACTIONS(3148),
    [anon_sym_explicit] = ACTIONS(3148),
    [anon_sym_typename] = ACTIONS(3148),
    [anon_sym_template] = ACTIONS(3148),
    [anon_sym_operator] = ACTIONS(3148),
    [anon_sym_friend] = ACTIONS(3148),
    [anon_sym_public] = ACTIONS(3148),
    [anon_sym_private] = ACTIONS(3148),
    [anon_sym_protected] = ACTIONS(3148),
    [anon_sym_using] = ACTIONS(3148),
    [anon_sym_static_assert] = ACTIONS(3148),
  },
  [2135] = {
    [sym_identifier] = ACTIONS(3126),
    [aux_sym_preproc_def_token1] = ACTIONS(3126),
    [aux_sym_preproc_if_token1] = ACTIONS(3126),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3126),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3126),
    [sym_preproc_directive] = ACTIONS(3126),
    [anon_sym_LPAREN2] = ACTIONS(3128),
    [anon_sym_TILDE] = ACTIONS(3128),
    [anon_sym_STAR] = ACTIONS(3128),
    [anon_sym_AMP_AMP] = ACTIONS(3128),
    [anon_sym_AMP] = ACTIONS(3126),
    [anon_sym___extension__] = ACTIONS(3126),
    [anon_sym_typedef] = ACTIONS(3126),
    [anon_sym_extern] = ACTIONS(3126),
    [anon_sym___attribute__] = ACTIONS(3126),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3128),
    [anon_sym___declspec] = ACTIONS(3126),
    [anon_sym___based] = ACTIONS(3126),
    [anon_sym_RBRACE] = ACTIONS(3128),
    [anon_sym_signed] = ACTIONS(3126),
    [anon_sym_unsigned] = ACTIONS(3126),
    [anon_sym_long] = ACTIONS(3126),
    [anon_sym_short] = ACTIONS(3126),
    [anon_sym_LBRACK] = ACTIONS(3126),
    [anon_sym_static] = ACTIONS(3126),
    [anon_sym_register] = ACTIONS(3126),
    [anon_sym_inline] = ACTIONS(3126),
    [anon_sym___inline] = ACTIONS(3126),
    [anon_sym___inline__] = ACTIONS(3126),
    [anon_sym___forceinline] = ACTIONS(3126),
    [anon_sym_thread_local] = ACTIONS(3126),
    [anon_sym___thread] = ACTIONS(3126),
    [anon_sym_const] = ACTIONS(3126),
    [anon_sym_constexpr] = ACTIONS(3126),
    [anon_sym_volatile] = ACTIONS(3126),
    [anon_sym_restrict] = ACTIONS(3126),
    [anon_sym___restrict__] = ACTIONS(3126),
    [anon_sym__Atomic] = ACTIONS(3126),
    [anon_sym__Noreturn] = ACTIONS(3126),
    [anon_sym_noreturn] = ACTIONS(3126),
    [anon_sym_mutable] = ACTIONS(3126),
    [anon_sym_constinit] = ACTIONS(3126),
    [anon_sym_consteval] = ACTIONS(3126),
    [anon_sym_PROGMEM] = ACTIONS(3126),
    [aux_sym_primitive_type_token1] = ACTIONS(3126),
    [anon_sym_byte] = ACTIONS(3126),
    [anon_sym_word] = ACTIONS(3126),
    [anon_sym_enum] = ACTIONS(3126),
    [anon_sym_class] = ACTIONS(3126),
    [anon_sym_struct] = ACTIONS(3126),
    [anon_sym_union] = ACTIONS(3126),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3126),
    [anon_sym_decltype] = ACTIONS(3126),
    [anon_sym_virtual] = ACTIONS(3126),
    [anon_sym_alignas] = ACTIONS(3126),
    [anon_sym_explicit] = ACTIONS(3126),
    [anon_sym_typename] = ACTIONS(3126),
    [anon_sym_template] = ACTIONS(3126),
    [anon_sym_operator] = ACTIONS(3126),
    [anon_sym_friend] = ACTIONS(3126),
    [anon_sym_public] = ACTIONS(3126),
    [anon_sym_private] = ACTIONS(3126),
    [anon_sym_protected] = ACTIONS(3126),
    [anon_sym_using] = ACTIONS(3126),
    [anon_sym_static_assert] = ACTIONS(3126),
  },
  [2136] = {
    [sym_identifier] = ACTIONS(3126),
    [aux_sym_preproc_def_token1] = ACTIONS(3126),
    [aux_sym_preproc_if_token1] = ACTIONS(3126),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3126),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3126),
    [sym_preproc_directive] = ACTIONS(3126),
    [anon_sym_LPAREN2] = ACTIONS(3128),
    [anon_sym_TILDE] = ACTIONS(3128),
    [anon_sym_STAR] = ACTIONS(3128),
    [anon_sym_AMP_AMP] = ACTIONS(3128),
    [anon_sym_AMP] = ACTIONS(3126),
    [anon_sym___extension__] = ACTIONS(3126),
    [anon_sym_typedef] = ACTIONS(3126),
    [anon_sym_extern] = ACTIONS(3126),
    [anon_sym___attribute__] = ACTIONS(3126),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3128),
    [anon_sym___declspec] = ACTIONS(3126),
    [anon_sym___based] = ACTIONS(3126),
    [anon_sym_RBRACE] = ACTIONS(3128),
    [anon_sym_signed] = ACTIONS(3126),
    [anon_sym_unsigned] = ACTIONS(3126),
    [anon_sym_long] = ACTIONS(3126),
    [anon_sym_short] = ACTIONS(3126),
    [anon_sym_LBRACK] = ACTIONS(3126),
    [anon_sym_static] = ACTIONS(3126),
    [anon_sym_register] = ACTIONS(3126),
    [anon_sym_inline] = ACTIONS(3126),
    [anon_sym___inline] = ACTIONS(3126),
    [anon_sym___inline__] = ACTIONS(3126),
    [anon_sym___forceinline] = ACTIONS(3126),
    [anon_sym_thread_local] = ACTIONS(3126),
    [anon_sym___thread] = ACTIONS(3126),
    [anon_sym_const] = ACTIONS(3126),
    [anon_sym_constexpr] = ACTIONS(3126),
    [anon_sym_volatile] = ACTIONS(3126),
    [anon_sym_restrict] = ACTIONS(3126),
    [anon_sym___restrict__] = ACTIONS(3126),
    [anon_sym__Atomic] = ACTIONS(3126),
    [anon_sym__Noreturn] = ACTIONS(3126),
    [anon_sym_noreturn] = ACTIONS(3126),
    [anon_sym_mutable] = ACTIONS(3126),
    [anon_sym_constinit] = ACTIONS(3126),
    [anon_sym_consteval] = ACTIONS(3126),
    [anon_sym_PROGMEM] = ACTIONS(3126),
    [aux_sym_primitive_type_token1] = ACTIONS(3126),
    [anon_sym_byte] = ACTIONS(3126),
    [anon_sym_word] = ACTIONS(3126),
    [anon_sym_enum] = ACTIONS(3126),
    [anon_sym_class] = ACTIONS(3126),
    [anon_sym_struct] = ACTIONS(3126),
    [anon_sym_union] = ACTIONS(3126),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3126),
    [anon_sym_decltype] = ACTIONS(3126),
    [anon_sym_virtual] = ACTIONS(3126),
    [anon_sym_alignas] = ACTIONS(3126),
    [anon_sym_explicit] = ACTIONS(3126),
    [anon_sym_typename] = ACTIONS(3126),
    [anon_sym_template] = ACTIONS(3126),
    [anon_sym_operator] = ACTIONS(3126),
    [anon_sym_friend] = ACTIONS(3126),
    [anon_sym_public] = ACTIONS(3126),
    [anon_sym_private] = ACTIONS(3126),
    [anon_sym_protected] = ACTIONS(3126),
    [anon_sym_using] = ACTIONS(3126),
    [anon_sym_static_assert] = ACTIONS(3126),
  },
  [2137] = {
    [sym_string_literal] = STATE(2617),
    [sym_template_argument_list] = STATE(3723),
    [sym_raw_string_literal] = STATE(2617),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3761),
    [anon_sym_COMMA] = ACTIONS(3761),
    [anon_sym_LPAREN2] = ACTIONS(3761),
    [anon_sym_DASH] = ACTIONS(3769),
    [anon_sym_PLUS] = ACTIONS(3769),
    [anon_sym_STAR] = ACTIONS(3769),
    [anon_sym_SLASH] = ACTIONS(3769),
    [anon_sym_PERCENT] = ACTIONS(3769),
    [anon_sym_PIPE_PIPE] = ACTIONS(3761),
    [anon_sym_AMP_AMP] = ACTIONS(3761),
    [anon_sym_PIPE] = ACTIONS(3769),
    [anon_sym_CARET] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(3769),
    [anon_sym_EQ_EQ] = ACTIONS(3761),
    [anon_sym_BANG_EQ] = ACTIONS(3761),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3761),
    [anon_sym_LT_EQ] = ACTIONS(3769),
    [anon_sym_LT] = ACTIONS(5242),
    [anon_sym_LT_LT] = ACTIONS(3769),
    [anon_sym_GT_GT] = ACTIONS(3769),
    [anon_sym_SEMI] = ACTIONS(3761),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(3785),
    [anon_sym_LBRACK] = ACTIONS(3761),
    [anon_sym_EQ] = ACTIONS(3793),
    [anon_sym_COLON] = ACTIONS(3851),
    [anon_sym_QMARK] = ACTIONS(3761),
    [anon_sym_STAR_EQ] = ACTIONS(3797),
    [anon_sym_SLASH_EQ] = ACTIONS(3797),
    [anon_sym_PERCENT_EQ] = ACTIONS(3797),
    [anon_sym_PLUS_EQ] = ACTIONS(3797),
    [anon_sym_DASH_EQ] = ACTIONS(3797),
    [anon_sym_LT_LT_EQ] = ACTIONS(3797),
    [anon_sym_GT_GT_EQ] = ACTIONS(3797),
    [anon_sym_AMP_EQ] = ACTIONS(3797),
    [anon_sym_CARET_EQ] = ACTIONS(3797),
    [anon_sym_PIPE_EQ] = ACTIONS(3797),
    [anon_sym_and_eq] = ACTIONS(3797),
    [anon_sym_or_eq] = ACTIONS(3797),
    [anon_sym_xor_eq] = ACTIONS(3797),
    [anon_sym_LT_EQ_GT] = ACTIONS(3761),
    [anon_sym_or] = ACTIONS(3769),
    [anon_sym_and] = ACTIONS(3769),
    [anon_sym_bitor] = ACTIONS(3761),
    [anon_sym_xor] = ACTIONS(3769),
    [anon_sym_bitand] = ACTIONS(3761),
    [anon_sym_not_eq] = ACTIONS(3761),
    [anon_sym_DASH_DASH] = ACTIONS(3761),
    [anon_sym_PLUS_PLUS] = ACTIONS(3761),
    [anon_sym_DOT] = ACTIONS(3769),
    [anon_sym_DOT_STAR] = ACTIONS(3761),
    [anon_sym_DASH_GT] = ACTIONS(3761),
    [anon_sym_L_DQUOTE] = ACTIONS(3204),
    [anon_sym_u_DQUOTE] = ACTIONS(3204),
    [anon_sym_U_DQUOTE] = ACTIONS(3204),
    [anon_sym_u8_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3204),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3208),
    [anon_sym_LR_DQUOTE] = ACTIONS(3208),
    [anon_sym_uR_DQUOTE] = ACTIONS(3208),
    [anon_sym_UR_DQUOTE] = ACTIONS(3208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3208),
  },
  [2138] = {
    [sym_identifier] = ACTIONS(3472),
    [aux_sym_preproc_def_token1] = ACTIONS(3472),
    [aux_sym_preproc_if_token1] = ACTIONS(3472),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3472),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3472),
    [sym_preproc_directive] = ACTIONS(3472),
    [anon_sym_LPAREN2] = ACTIONS(3470),
    [anon_sym_TILDE] = ACTIONS(3470),
    [anon_sym_STAR] = ACTIONS(3470),
    [anon_sym_AMP_AMP] = ACTIONS(3470),
    [anon_sym_AMP] = ACTIONS(3472),
    [anon_sym___extension__] = ACTIONS(3472),
    [anon_sym_typedef] = ACTIONS(3472),
    [anon_sym_extern] = ACTIONS(3472),
    [anon_sym___attribute__] = ACTIONS(3472),
    [anon_sym_COLON_COLON] = ACTIONS(3470),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3470),
    [anon_sym___declspec] = ACTIONS(3472),
    [anon_sym___based] = ACTIONS(3472),
    [anon_sym_RBRACE] = ACTIONS(3470),
    [anon_sym_signed] = ACTIONS(3472),
    [anon_sym_unsigned] = ACTIONS(3472),
    [anon_sym_long] = ACTIONS(3472),
    [anon_sym_short] = ACTIONS(3472),
    [anon_sym_LBRACK] = ACTIONS(3472),
    [anon_sym_static] = ACTIONS(3472),
    [anon_sym_register] = ACTIONS(3472),
    [anon_sym_inline] = ACTIONS(3472),
    [anon_sym___inline] = ACTIONS(3472),
    [anon_sym___inline__] = ACTIONS(3472),
    [anon_sym___forceinline] = ACTIONS(3472),
    [anon_sym_thread_local] = ACTIONS(3472),
    [anon_sym___thread] = ACTIONS(3472),
    [anon_sym_const] = ACTIONS(3472),
    [anon_sym_constexpr] = ACTIONS(3472),
    [anon_sym_volatile] = ACTIONS(3472),
    [anon_sym_restrict] = ACTIONS(3472),
    [anon_sym___restrict__] = ACTIONS(3472),
    [anon_sym__Atomic] = ACTIONS(3472),
    [anon_sym__Noreturn] = ACTIONS(3472),
    [anon_sym_noreturn] = ACTIONS(3472),
    [anon_sym_mutable] = ACTIONS(3472),
    [anon_sym_constinit] = ACTIONS(3472),
    [anon_sym_consteval] = ACTIONS(3472),
    [anon_sym_PROGMEM] = ACTIONS(3472),
    [aux_sym_primitive_type_token1] = ACTIONS(3472),
    [anon_sym_byte] = ACTIONS(3472),
    [anon_sym_word] = ACTIONS(3472),
    [anon_sym_enum] = ACTIONS(3472),
    [anon_sym_class] = ACTIONS(3472),
    [anon_sym_struct] = ACTIONS(3472),
    [anon_sym_union] = ACTIONS(3472),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3472),
    [anon_sym_decltype] = ACTIONS(3472),
    [anon_sym_virtual] = ACTIONS(3472),
    [anon_sym_alignas] = ACTIONS(3472),
    [anon_sym_explicit] = ACTIONS(3472),
    [anon_sym_typename] = ACTIONS(3472),
    [anon_sym_template] = ACTIONS(3472),
    [anon_sym_operator] = ACTIONS(3472),
    [anon_sym_friend] = ACTIONS(3472),
    [anon_sym_public] = ACTIONS(3472),
    [anon_sym_private] = ACTIONS(3472),
    [anon_sym_protected] = ACTIONS(3472),
    [anon_sym_using] = ACTIONS(3472),
    [anon_sym_static_assert] = ACTIONS(3472),
  },
  [2139] = {
    [sym_identifier] = ACTIONS(2905),
    [aux_sym_preproc_def_token1] = ACTIONS(2905),
    [aux_sym_preproc_if_token1] = ACTIONS(2905),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2905),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2905),
    [sym_preproc_directive] = ACTIONS(2905),
    [anon_sym_LPAREN2] = ACTIONS(2907),
    [anon_sym_TILDE] = ACTIONS(2907),
    [anon_sym_STAR] = ACTIONS(2907),
    [anon_sym_AMP_AMP] = ACTIONS(2907),
    [anon_sym_AMP] = ACTIONS(2905),
    [anon_sym___extension__] = ACTIONS(2905),
    [anon_sym_typedef] = ACTIONS(2905),
    [anon_sym_extern] = ACTIONS(2905),
    [anon_sym___attribute__] = ACTIONS(2905),
    [anon_sym_COLON_COLON] = ACTIONS(2907),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2907),
    [anon_sym___declspec] = ACTIONS(2905),
    [anon_sym___based] = ACTIONS(2905),
    [anon_sym_RBRACE] = ACTIONS(2907),
    [anon_sym_signed] = ACTIONS(2905),
    [anon_sym_unsigned] = ACTIONS(2905),
    [anon_sym_long] = ACTIONS(2905),
    [anon_sym_short] = ACTIONS(2905),
    [anon_sym_LBRACK] = ACTIONS(2905),
    [anon_sym_static] = ACTIONS(2905),
    [anon_sym_register] = ACTIONS(2905),
    [anon_sym_inline] = ACTIONS(2905),
    [anon_sym___inline] = ACTIONS(2905),
    [anon_sym___inline__] = ACTIONS(2905),
    [anon_sym___forceinline] = ACTIONS(2905),
    [anon_sym_thread_local] = ACTIONS(2905),
    [anon_sym___thread] = ACTIONS(2905),
    [anon_sym_const] = ACTIONS(2905),
    [anon_sym_constexpr] = ACTIONS(2905),
    [anon_sym_volatile] = ACTIONS(2905),
    [anon_sym_restrict] = ACTIONS(2905),
    [anon_sym___restrict__] = ACTIONS(2905),
    [anon_sym__Atomic] = ACTIONS(2905),
    [anon_sym__Noreturn] = ACTIONS(2905),
    [anon_sym_noreturn] = ACTIONS(2905),
    [anon_sym_mutable] = ACTIONS(2905),
    [anon_sym_constinit] = ACTIONS(2905),
    [anon_sym_consteval] = ACTIONS(2905),
    [anon_sym_PROGMEM] = ACTIONS(2905),
    [aux_sym_primitive_type_token1] = ACTIONS(2905),
    [anon_sym_byte] = ACTIONS(2905),
    [anon_sym_word] = ACTIONS(2905),
    [anon_sym_enum] = ACTIONS(2905),
    [anon_sym_class] = ACTIONS(2905),
    [anon_sym_struct] = ACTIONS(2905),
    [anon_sym_union] = ACTIONS(2905),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2905),
    [anon_sym_decltype] = ACTIONS(2905),
    [anon_sym_virtual] = ACTIONS(2905),
    [anon_sym_alignas] = ACTIONS(2905),
    [anon_sym_explicit] = ACTIONS(2905),
    [anon_sym_typename] = ACTIONS(2905),
    [anon_sym_template] = ACTIONS(2905),
    [anon_sym_operator] = ACTIONS(2905),
    [anon_sym_friend] = ACTIONS(2905),
    [anon_sym_public] = ACTIONS(2905),
    [anon_sym_private] = ACTIONS(2905),
    [anon_sym_protected] = ACTIONS(2905),
    [anon_sym_using] = ACTIONS(2905),
    [anon_sym_static_assert] = ACTIONS(2905),
  },
  [2140] = {
    [sym_identifier] = ACTIONS(2901),
    [aux_sym_preproc_def_token1] = ACTIONS(2901),
    [aux_sym_preproc_if_token1] = ACTIONS(2901),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2901),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2901),
    [sym_preproc_directive] = ACTIONS(2901),
    [anon_sym_LPAREN2] = ACTIONS(2903),
    [anon_sym_TILDE] = ACTIONS(2903),
    [anon_sym_STAR] = ACTIONS(2903),
    [anon_sym_AMP_AMP] = ACTIONS(2903),
    [anon_sym_AMP] = ACTIONS(2901),
    [anon_sym___extension__] = ACTIONS(2901),
    [anon_sym_typedef] = ACTIONS(2901),
    [anon_sym_extern] = ACTIONS(2901),
    [anon_sym___attribute__] = ACTIONS(2901),
    [anon_sym_COLON_COLON] = ACTIONS(2903),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2903),
    [anon_sym___declspec] = ACTIONS(2901),
    [anon_sym___based] = ACTIONS(2901),
    [anon_sym_RBRACE] = ACTIONS(2903),
    [anon_sym_signed] = ACTIONS(2901),
    [anon_sym_unsigned] = ACTIONS(2901),
    [anon_sym_long] = ACTIONS(2901),
    [anon_sym_short] = ACTIONS(2901),
    [anon_sym_LBRACK] = ACTIONS(2901),
    [anon_sym_static] = ACTIONS(2901),
    [anon_sym_register] = ACTIONS(2901),
    [anon_sym_inline] = ACTIONS(2901),
    [anon_sym___inline] = ACTIONS(2901),
    [anon_sym___inline__] = ACTIONS(2901),
    [anon_sym___forceinline] = ACTIONS(2901),
    [anon_sym_thread_local] = ACTIONS(2901),
    [anon_sym___thread] = ACTIONS(2901),
    [anon_sym_const] = ACTIONS(2901),
    [anon_sym_constexpr] = ACTIONS(2901),
    [anon_sym_volatile] = ACTIONS(2901),
    [anon_sym_restrict] = ACTIONS(2901),
    [anon_sym___restrict__] = ACTIONS(2901),
    [anon_sym__Atomic] = ACTIONS(2901),
    [anon_sym__Noreturn] = ACTIONS(2901),
    [anon_sym_noreturn] = ACTIONS(2901),
    [anon_sym_mutable] = ACTIONS(2901),
    [anon_sym_constinit] = ACTIONS(2901),
    [anon_sym_consteval] = ACTIONS(2901),
    [anon_sym_PROGMEM] = ACTIONS(2901),
    [aux_sym_primitive_type_token1] = ACTIONS(2901),
    [anon_sym_byte] = ACTIONS(2901),
    [anon_sym_word] = ACTIONS(2901),
    [anon_sym_enum] = ACTIONS(2901),
    [anon_sym_class] = ACTIONS(2901),
    [anon_sym_struct] = ACTIONS(2901),
    [anon_sym_union] = ACTIONS(2901),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2901),
    [anon_sym_decltype] = ACTIONS(2901),
    [anon_sym_virtual] = ACTIONS(2901),
    [anon_sym_alignas] = ACTIONS(2901),
    [anon_sym_explicit] = ACTIONS(2901),
    [anon_sym_typename] = ACTIONS(2901),
    [anon_sym_template] = ACTIONS(2901),
    [anon_sym_operator] = ACTIONS(2901),
    [anon_sym_friend] = ACTIONS(2901),
    [anon_sym_public] = ACTIONS(2901),
    [anon_sym_private] = ACTIONS(2901),
    [anon_sym_protected] = ACTIONS(2901),
    [anon_sym_using] = ACTIONS(2901),
    [anon_sym_static_assert] = ACTIONS(2901),
  },
  [2141] = {
    [sym_identifier] = ACTIONS(3132),
    [aux_sym_preproc_def_token1] = ACTIONS(3132),
    [aux_sym_preproc_if_token1] = ACTIONS(3132),
    [aux_sym_preproc_if_token2] = ACTIONS(3132),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3132),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3132),
    [sym_preproc_directive] = ACTIONS(3132),
    [anon_sym_LPAREN2] = ACTIONS(3134),
    [anon_sym_TILDE] = ACTIONS(3134),
    [anon_sym_STAR] = ACTIONS(3134),
    [anon_sym_AMP_AMP] = ACTIONS(3134),
    [anon_sym_AMP] = ACTIONS(3132),
    [anon_sym___extension__] = ACTIONS(3132),
    [anon_sym_typedef] = ACTIONS(3132),
    [anon_sym_extern] = ACTIONS(3132),
    [anon_sym___attribute__] = ACTIONS(3132),
    [anon_sym_COLON_COLON] = ACTIONS(3134),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3134),
    [anon_sym___declspec] = ACTIONS(3132),
    [anon_sym___based] = ACTIONS(3132),
    [anon_sym_signed] = ACTIONS(3132),
    [anon_sym_unsigned] = ACTIONS(3132),
    [anon_sym_long] = ACTIONS(3132),
    [anon_sym_short] = ACTIONS(3132),
    [anon_sym_LBRACK] = ACTIONS(3132),
    [anon_sym_static] = ACTIONS(3132),
    [anon_sym_register] = ACTIONS(3132),
    [anon_sym_inline] = ACTIONS(3132),
    [anon_sym___inline] = ACTIONS(3132),
    [anon_sym___inline__] = ACTIONS(3132),
    [anon_sym___forceinline] = ACTIONS(3132),
    [anon_sym_thread_local] = ACTIONS(3132),
    [anon_sym___thread] = ACTIONS(3132),
    [anon_sym_const] = ACTIONS(3132),
    [anon_sym_constexpr] = ACTIONS(3132),
    [anon_sym_volatile] = ACTIONS(3132),
    [anon_sym_restrict] = ACTIONS(3132),
    [anon_sym___restrict__] = ACTIONS(3132),
    [anon_sym__Atomic] = ACTIONS(3132),
    [anon_sym__Noreturn] = ACTIONS(3132),
    [anon_sym_noreturn] = ACTIONS(3132),
    [anon_sym_mutable] = ACTIONS(3132),
    [anon_sym_constinit] = ACTIONS(3132),
    [anon_sym_consteval] = ACTIONS(3132),
    [anon_sym_PROGMEM] = ACTIONS(3132),
    [aux_sym_primitive_type_token1] = ACTIONS(3132),
    [anon_sym_byte] = ACTIONS(3132),
    [anon_sym_word] = ACTIONS(3132),
    [anon_sym_enum] = ACTIONS(3132),
    [anon_sym_class] = ACTIONS(3132),
    [anon_sym_struct] = ACTIONS(3132),
    [anon_sym_union] = ACTIONS(3132),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3132),
    [anon_sym_decltype] = ACTIONS(3132),
    [anon_sym_virtual] = ACTIONS(3132),
    [anon_sym_alignas] = ACTIONS(3132),
    [anon_sym_explicit] = ACTIONS(3132),
    [anon_sym_typename] = ACTIONS(3132),
    [anon_sym_template] = ACTIONS(3132),
    [anon_sym_operator] = ACTIONS(3132),
    [anon_sym_friend] = ACTIONS(3132),
    [anon_sym_public] = ACTIONS(3132),
    [anon_sym_private] = ACTIONS(3132),
    [anon_sym_protected] = ACTIONS(3132),
    [anon_sym_using] = ACTIONS(3132),
    [anon_sym_static_assert] = ACTIONS(3132),
  },
  [2142] = {
    [sym_identifier] = ACTIONS(2783),
    [aux_sym_preproc_def_token1] = ACTIONS(2783),
    [aux_sym_preproc_if_token1] = ACTIONS(2783),
    [aux_sym_preproc_if_token2] = ACTIONS(2783),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2783),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2783),
    [sym_preproc_directive] = ACTIONS(2783),
    [anon_sym_LPAREN2] = ACTIONS(2785),
    [anon_sym_TILDE] = ACTIONS(2785),
    [anon_sym_STAR] = ACTIONS(2785),
    [anon_sym_AMP_AMP] = ACTIONS(2785),
    [anon_sym_AMP] = ACTIONS(2783),
    [anon_sym___extension__] = ACTIONS(2783),
    [anon_sym_typedef] = ACTIONS(2783),
    [anon_sym_extern] = ACTIONS(2783),
    [anon_sym___attribute__] = ACTIONS(2783),
    [anon_sym_COLON_COLON] = ACTIONS(2785),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2785),
    [anon_sym___declspec] = ACTIONS(2783),
    [anon_sym___based] = ACTIONS(2783),
    [anon_sym_signed] = ACTIONS(2783),
    [anon_sym_unsigned] = ACTIONS(2783),
    [anon_sym_long] = ACTIONS(2783),
    [anon_sym_short] = ACTIONS(2783),
    [anon_sym_LBRACK] = ACTIONS(2783),
    [anon_sym_static] = ACTIONS(2783),
    [anon_sym_register] = ACTIONS(2783),
    [anon_sym_inline] = ACTIONS(2783),
    [anon_sym___inline] = ACTIONS(2783),
    [anon_sym___inline__] = ACTIONS(2783),
    [anon_sym___forceinline] = ACTIONS(2783),
    [anon_sym_thread_local] = ACTIONS(2783),
    [anon_sym___thread] = ACTIONS(2783),
    [anon_sym_const] = ACTIONS(2783),
    [anon_sym_constexpr] = ACTIONS(2783),
    [anon_sym_volatile] = ACTIONS(2783),
    [anon_sym_restrict] = ACTIONS(2783),
    [anon_sym___restrict__] = ACTIONS(2783),
    [anon_sym__Atomic] = ACTIONS(2783),
    [anon_sym__Noreturn] = ACTIONS(2783),
    [anon_sym_noreturn] = ACTIONS(2783),
    [anon_sym_mutable] = ACTIONS(2783),
    [anon_sym_constinit] = ACTIONS(2783),
    [anon_sym_consteval] = ACTIONS(2783),
    [anon_sym_PROGMEM] = ACTIONS(2783),
    [aux_sym_primitive_type_token1] = ACTIONS(2783),
    [anon_sym_byte] = ACTIONS(2783),
    [anon_sym_word] = ACTIONS(2783),
    [anon_sym_enum] = ACTIONS(2783),
    [anon_sym_class] = ACTIONS(2783),
    [anon_sym_struct] = ACTIONS(2783),
    [anon_sym_union] = ACTIONS(2783),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2783),
    [anon_sym_decltype] = ACTIONS(2783),
    [anon_sym_virtual] = ACTIONS(2783),
    [anon_sym_alignas] = ACTIONS(2783),
    [anon_sym_explicit] = ACTIONS(2783),
    [anon_sym_typename] = ACTIONS(2783),
    [anon_sym_template] = ACTIONS(2783),
    [anon_sym_operator] = ACTIONS(2783),
    [anon_sym_friend] = ACTIONS(2783),
    [anon_sym_public] = ACTIONS(2783),
    [anon_sym_private] = ACTIONS(2783),
    [anon_sym_protected] = ACTIONS(2783),
    [anon_sym_using] = ACTIONS(2783),
    [anon_sym_static_assert] = ACTIONS(2783),
  },
  [2143] = {
    [sym_identifier] = ACTIONS(2941),
    [aux_sym_preproc_def_token1] = ACTIONS(2941),
    [aux_sym_preproc_if_token1] = ACTIONS(2941),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2941),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2941),
    [sym_preproc_directive] = ACTIONS(2941),
    [anon_sym_LPAREN2] = ACTIONS(2943),
    [anon_sym_TILDE] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2943),
    [anon_sym_AMP_AMP] = ACTIONS(2943),
    [anon_sym_AMP] = ACTIONS(2941),
    [anon_sym___extension__] = ACTIONS(2941),
    [anon_sym_typedef] = ACTIONS(2941),
    [anon_sym_extern] = ACTIONS(2941),
    [anon_sym___attribute__] = ACTIONS(2941),
    [anon_sym_COLON_COLON] = ACTIONS(2943),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2943),
    [anon_sym___declspec] = ACTIONS(2941),
    [anon_sym___based] = ACTIONS(2941),
    [anon_sym_RBRACE] = ACTIONS(2943),
    [anon_sym_signed] = ACTIONS(2941),
    [anon_sym_unsigned] = ACTIONS(2941),
    [anon_sym_long] = ACTIONS(2941),
    [anon_sym_short] = ACTIONS(2941),
    [anon_sym_LBRACK] = ACTIONS(2941),
    [anon_sym_static] = ACTIONS(2941),
    [anon_sym_register] = ACTIONS(2941),
    [anon_sym_inline] = ACTIONS(2941),
    [anon_sym___inline] = ACTIONS(2941),
    [anon_sym___inline__] = ACTIONS(2941),
    [anon_sym___forceinline] = ACTIONS(2941),
    [anon_sym_thread_local] = ACTIONS(2941),
    [anon_sym___thread] = ACTIONS(2941),
    [anon_sym_const] = ACTIONS(2941),
    [anon_sym_constexpr] = ACTIONS(2941),
    [anon_sym_volatile] = ACTIONS(2941),
    [anon_sym_restrict] = ACTIONS(2941),
    [anon_sym___restrict__] = ACTIONS(2941),
    [anon_sym__Atomic] = ACTIONS(2941),
    [anon_sym__Noreturn] = ACTIONS(2941),
    [anon_sym_noreturn] = ACTIONS(2941),
    [anon_sym_mutable] = ACTIONS(2941),
    [anon_sym_constinit] = ACTIONS(2941),
    [anon_sym_consteval] = ACTIONS(2941),
    [anon_sym_PROGMEM] = ACTIONS(2941),
    [aux_sym_primitive_type_token1] = ACTIONS(2941),
    [anon_sym_byte] = ACTIONS(2941),
    [anon_sym_word] = ACTIONS(2941),
    [anon_sym_enum] = ACTIONS(2941),
    [anon_sym_class] = ACTIONS(2941),
    [anon_sym_struct] = ACTIONS(2941),
    [anon_sym_union] = ACTIONS(2941),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2941),
    [anon_sym_decltype] = ACTIONS(2941),
    [anon_sym_virtual] = ACTIONS(2941),
    [anon_sym_alignas] = ACTIONS(2941),
    [anon_sym_explicit] = ACTIONS(2941),
    [anon_sym_typename] = ACTIONS(2941),
    [anon_sym_template] = ACTIONS(2941),
    [anon_sym_operator] = ACTIONS(2941),
    [anon_sym_friend] = ACTIONS(2941),
    [anon_sym_public] = ACTIONS(2941),
    [anon_sym_private] = ACTIONS(2941),
    [anon_sym_protected] = ACTIONS(2941),
    [anon_sym_using] = ACTIONS(2941),
    [anon_sym_static_assert] = ACTIONS(2941),
  },
  [2144] = {
    [sym_identifier] = ACTIONS(2773),
    [aux_sym_preproc_def_token1] = ACTIONS(2773),
    [aux_sym_preproc_if_token1] = ACTIONS(2773),
    [aux_sym_preproc_if_token2] = ACTIONS(2773),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2773),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2773),
    [sym_preproc_directive] = ACTIONS(2773),
    [anon_sym_LPAREN2] = ACTIONS(2775),
    [anon_sym_TILDE] = ACTIONS(2775),
    [anon_sym_STAR] = ACTIONS(2775),
    [anon_sym_AMP_AMP] = ACTIONS(2775),
    [anon_sym_AMP] = ACTIONS(2773),
    [anon_sym___extension__] = ACTIONS(2773),
    [anon_sym_typedef] = ACTIONS(2773),
    [anon_sym_extern] = ACTIONS(2773),
    [anon_sym___attribute__] = ACTIONS(2773),
    [anon_sym_COLON_COLON] = ACTIONS(2775),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2775),
    [anon_sym___declspec] = ACTIONS(2773),
    [anon_sym___based] = ACTIONS(2773),
    [anon_sym_signed] = ACTIONS(2773),
    [anon_sym_unsigned] = ACTIONS(2773),
    [anon_sym_long] = ACTIONS(2773),
    [anon_sym_short] = ACTIONS(2773),
    [anon_sym_LBRACK] = ACTIONS(2773),
    [anon_sym_static] = ACTIONS(2773),
    [anon_sym_register] = ACTIONS(2773),
    [anon_sym_inline] = ACTIONS(2773),
    [anon_sym___inline] = ACTIONS(2773),
    [anon_sym___inline__] = ACTIONS(2773),
    [anon_sym___forceinline] = ACTIONS(2773),
    [anon_sym_thread_local] = ACTIONS(2773),
    [anon_sym___thread] = ACTIONS(2773),
    [anon_sym_const] = ACTIONS(2773),
    [anon_sym_constexpr] = ACTIONS(2773),
    [anon_sym_volatile] = ACTIONS(2773),
    [anon_sym_restrict] = ACTIONS(2773),
    [anon_sym___restrict__] = ACTIONS(2773),
    [anon_sym__Atomic] = ACTIONS(2773),
    [anon_sym__Noreturn] = ACTIONS(2773),
    [anon_sym_noreturn] = ACTIONS(2773),
    [anon_sym_mutable] = ACTIONS(2773),
    [anon_sym_constinit] = ACTIONS(2773),
    [anon_sym_consteval] = ACTIONS(2773),
    [anon_sym_PROGMEM] = ACTIONS(2773),
    [aux_sym_primitive_type_token1] = ACTIONS(2773),
    [anon_sym_byte] = ACTIONS(2773),
    [anon_sym_word] = ACTIONS(2773),
    [anon_sym_enum] = ACTIONS(2773),
    [anon_sym_class] = ACTIONS(2773),
    [anon_sym_struct] = ACTIONS(2773),
    [anon_sym_union] = ACTIONS(2773),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2773),
    [anon_sym_decltype] = ACTIONS(2773),
    [anon_sym_virtual] = ACTIONS(2773),
    [anon_sym_alignas] = ACTIONS(2773),
    [anon_sym_explicit] = ACTIONS(2773),
    [anon_sym_typename] = ACTIONS(2773),
    [anon_sym_template] = ACTIONS(2773),
    [anon_sym_operator] = ACTIONS(2773),
    [anon_sym_friend] = ACTIONS(2773),
    [anon_sym_public] = ACTIONS(2773),
    [anon_sym_private] = ACTIONS(2773),
    [anon_sym_protected] = ACTIONS(2773),
    [anon_sym_using] = ACTIONS(2773),
    [anon_sym_static_assert] = ACTIONS(2773),
  },
  [2145] = {
    [sym_identifier] = ACTIONS(3048),
    [aux_sym_preproc_def_token1] = ACTIONS(3048),
    [aux_sym_preproc_if_token1] = ACTIONS(3048),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3048),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3048),
    [sym_preproc_directive] = ACTIONS(3048),
    [anon_sym_LPAREN2] = ACTIONS(3050),
    [anon_sym_TILDE] = ACTIONS(3050),
    [anon_sym_STAR] = ACTIONS(3050),
    [anon_sym_AMP_AMP] = ACTIONS(3050),
    [anon_sym_AMP] = ACTIONS(3048),
    [anon_sym___extension__] = ACTIONS(3048),
    [anon_sym_typedef] = ACTIONS(3048),
    [anon_sym_extern] = ACTIONS(3048),
    [anon_sym___attribute__] = ACTIONS(3048),
    [anon_sym_COLON_COLON] = ACTIONS(3050),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3050),
    [anon_sym___declspec] = ACTIONS(3048),
    [anon_sym___based] = ACTIONS(3048),
    [anon_sym_RBRACE] = ACTIONS(3050),
    [anon_sym_signed] = ACTIONS(3048),
    [anon_sym_unsigned] = ACTIONS(3048),
    [anon_sym_long] = ACTIONS(3048),
    [anon_sym_short] = ACTIONS(3048),
    [anon_sym_LBRACK] = ACTIONS(3048),
    [anon_sym_static] = ACTIONS(3048),
    [anon_sym_register] = ACTIONS(3048),
    [anon_sym_inline] = ACTIONS(3048),
    [anon_sym___inline] = ACTIONS(3048),
    [anon_sym___inline__] = ACTIONS(3048),
    [anon_sym___forceinline] = ACTIONS(3048),
    [anon_sym_thread_local] = ACTIONS(3048),
    [anon_sym___thread] = ACTIONS(3048),
    [anon_sym_const] = ACTIONS(3048),
    [anon_sym_constexpr] = ACTIONS(3048),
    [anon_sym_volatile] = ACTIONS(3048),
    [anon_sym_restrict] = ACTIONS(3048),
    [anon_sym___restrict__] = ACTIONS(3048),
    [anon_sym__Atomic] = ACTIONS(3048),
    [anon_sym__Noreturn] = ACTIONS(3048),
    [anon_sym_noreturn] = ACTIONS(3048),
    [anon_sym_mutable] = ACTIONS(3048),
    [anon_sym_constinit] = ACTIONS(3048),
    [anon_sym_consteval] = ACTIONS(3048),
    [anon_sym_PROGMEM] = ACTIONS(3048),
    [aux_sym_primitive_type_token1] = ACTIONS(3048),
    [anon_sym_byte] = ACTIONS(3048),
    [anon_sym_word] = ACTIONS(3048),
    [anon_sym_enum] = ACTIONS(3048),
    [anon_sym_class] = ACTIONS(3048),
    [anon_sym_struct] = ACTIONS(3048),
    [anon_sym_union] = ACTIONS(3048),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3048),
    [anon_sym_decltype] = ACTIONS(3048),
    [anon_sym_virtual] = ACTIONS(3048),
    [anon_sym_alignas] = ACTIONS(3048),
    [anon_sym_explicit] = ACTIONS(3048),
    [anon_sym_typename] = ACTIONS(3048),
    [anon_sym_template] = ACTIONS(3048),
    [anon_sym_operator] = ACTIONS(3048),
    [anon_sym_friend] = ACTIONS(3048),
    [anon_sym_public] = ACTIONS(3048),
    [anon_sym_private] = ACTIONS(3048),
    [anon_sym_protected] = ACTIONS(3048),
    [anon_sym_using] = ACTIONS(3048),
    [anon_sym_static_assert] = ACTIONS(3048),
  },
  [2146] = {
    [sym_identifier] = ACTIONS(3040),
    [aux_sym_preproc_def_token1] = ACTIONS(3040),
    [aux_sym_preproc_if_token1] = ACTIONS(3040),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3040),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3040),
    [sym_preproc_directive] = ACTIONS(3040),
    [anon_sym_LPAREN2] = ACTIONS(3042),
    [anon_sym_TILDE] = ACTIONS(3042),
    [anon_sym_STAR] = ACTIONS(3042),
    [anon_sym_AMP_AMP] = ACTIONS(3042),
    [anon_sym_AMP] = ACTIONS(3040),
    [anon_sym___extension__] = ACTIONS(3040),
    [anon_sym_typedef] = ACTIONS(3040),
    [anon_sym_extern] = ACTIONS(3040),
    [anon_sym___attribute__] = ACTIONS(3040),
    [anon_sym_COLON_COLON] = ACTIONS(3042),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3042),
    [anon_sym___declspec] = ACTIONS(3040),
    [anon_sym___based] = ACTIONS(3040),
    [anon_sym_RBRACE] = ACTIONS(3042),
    [anon_sym_signed] = ACTIONS(3040),
    [anon_sym_unsigned] = ACTIONS(3040),
    [anon_sym_long] = ACTIONS(3040),
    [anon_sym_short] = ACTIONS(3040),
    [anon_sym_LBRACK] = ACTIONS(3040),
    [anon_sym_static] = ACTIONS(3040),
    [anon_sym_register] = ACTIONS(3040),
    [anon_sym_inline] = ACTIONS(3040),
    [anon_sym___inline] = ACTIONS(3040),
    [anon_sym___inline__] = ACTIONS(3040),
    [anon_sym___forceinline] = ACTIONS(3040),
    [anon_sym_thread_local] = ACTIONS(3040),
    [anon_sym___thread] = ACTIONS(3040),
    [anon_sym_const] = ACTIONS(3040),
    [anon_sym_constexpr] = ACTIONS(3040),
    [anon_sym_volatile] = ACTIONS(3040),
    [anon_sym_restrict] = ACTIONS(3040),
    [anon_sym___restrict__] = ACTIONS(3040),
    [anon_sym__Atomic] = ACTIONS(3040),
    [anon_sym__Noreturn] = ACTIONS(3040),
    [anon_sym_noreturn] = ACTIONS(3040),
    [anon_sym_mutable] = ACTIONS(3040),
    [anon_sym_constinit] = ACTIONS(3040),
    [anon_sym_consteval] = ACTIONS(3040),
    [anon_sym_PROGMEM] = ACTIONS(3040),
    [aux_sym_primitive_type_token1] = ACTIONS(3040),
    [anon_sym_byte] = ACTIONS(3040),
    [anon_sym_word] = ACTIONS(3040),
    [anon_sym_enum] = ACTIONS(3040),
    [anon_sym_class] = ACTIONS(3040),
    [anon_sym_struct] = ACTIONS(3040),
    [anon_sym_union] = ACTIONS(3040),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3040),
    [anon_sym_decltype] = ACTIONS(3040),
    [anon_sym_virtual] = ACTIONS(3040),
    [anon_sym_alignas] = ACTIONS(3040),
    [anon_sym_explicit] = ACTIONS(3040),
    [anon_sym_typename] = ACTIONS(3040),
    [anon_sym_template] = ACTIONS(3040),
    [anon_sym_operator] = ACTIONS(3040),
    [anon_sym_friend] = ACTIONS(3040),
    [anon_sym_public] = ACTIONS(3040),
    [anon_sym_private] = ACTIONS(3040),
    [anon_sym_protected] = ACTIONS(3040),
    [anon_sym_using] = ACTIONS(3040),
    [anon_sym_static_assert] = ACTIONS(3040),
  },
  [2147] = {
    [sym_identifier] = ACTIONS(4886),
    [aux_sym_preproc_def_token1] = ACTIONS(4886),
    [aux_sym_preproc_if_token1] = ACTIONS(4886),
    [aux_sym_preproc_if_token2] = ACTIONS(4886),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4886),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4886),
    [sym_preproc_directive] = ACTIONS(4886),
    [anon_sym_LPAREN2] = ACTIONS(4888),
    [anon_sym_TILDE] = ACTIONS(4888),
    [anon_sym_STAR] = ACTIONS(4888),
    [anon_sym_AMP_AMP] = ACTIONS(4888),
    [anon_sym_AMP] = ACTIONS(4886),
    [anon_sym___extension__] = ACTIONS(4886),
    [anon_sym_typedef] = ACTIONS(4886),
    [anon_sym_extern] = ACTIONS(4886),
    [anon_sym___attribute__] = ACTIONS(4886),
    [anon_sym_COLON_COLON] = ACTIONS(4888),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4888),
    [anon_sym___declspec] = ACTIONS(4886),
    [anon_sym___based] = ACTIONS(4886),
    [anon_sym_signed] = ACTIONS(4886),
    [anon_sym_unsigned] = ACTIONS(4886),
    [anon_sym_long] = ACTIONS(4886),
    [anon_sym_short] = ACTIONS(4886),
    [anon_sym_LBRACK] = ACTIONS(4886),
    [anon_sym_static] = ACTIONS(4886),
    [anon_sym_register] = ACTIONS(4886),
    [anon_sym_inline] = ACTIONS(4886),
    [anon_sym___inline] = ACTIONS(4886),
    [anon_sym___inline__] = ACTIONS(4886),
    [anon_sym___forceinline] = ACTIONS(4886),
    [anon_sym_thread_local] = ACTIONS(4886),
    [anon_sym___thread] = ACTIONS(4886),
    [anon_sym_const] = ACTIONS(4886),
    [anon_sym_constexpr] = ACTIONS(4886),
    [anon_sym_volatile] = ACTIONS(4886),
    [anon_sym_restrict] = ACTIONS(4886),
    [anon_sym___restrict__] = ACTIONS(4886),
    [anon_sym__Atomic] = ACTIONS(4886),
    [anon_sym__Noreturn] = ACTIONS(4886),
    [anon_sym_noreturn] = ACTIONS(4886),
    [anon_sym_mutable] = ACTIONS(4886),
    [anon_sym_constinit] = ACTIONS(4886),
    [anon_sym_consteval] = ACTIONS(4886),
    [anon_sym_PROGMEM] = ACTIONS(4886),
    [aux_sym_primitive_type_token1] = ACTIONS(4886),
    [anon_sym_byte] = ACTIONS(4886),
    [anon_sym_word] = ACTIONS(4886),
    [anon_sym_enum] = ACTIONS(4886),
    [anon_sym_class] = ACTIONS(4886),
    [anon_sym_struct] = ACTIONS(4886),
    [anon_sym_union] = ACTIONS(4886),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4886),
    [anon_sym_decltype] = ACTIONS(4886),
    [anon_sym_virtual] = ACTIONS(4886),
    [anon_sym_alignas] = ACTIONS(4886),
    [anon_sym_explicit] = ACTIONS(4886),
    [anon_sym_typename] = ACTIONS(4886),
    [anon_sym_template] = ACTIONS(4886),
    [anon_sym_operator] = ACTIONS(4886),
    [anon_sym_friend] = ACTIONS(4886),
    [anon_sym_public] = ACTIONS(4886),
    [anon_sym_private] = ACTIONS(4886),
    [anon_sym_protected] = ACTIONS(4886),
    [anon_sym_using] = ACTIONS(4886),
    [anon_sym_static_assert] = ACTIONS(4886),
  },
  [2148] = {
    [sym_identifier] = ACTIONS(4890),
    [aux_sym_preproc_def_token1] = ACTIONS(4890),
    [aux_sym_preproc_if_token1] = ACTIONS(4890),
    [aux_sym_preproc_if_token2] = ACTIONS(4890),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4890),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4890),
    [sym_preproc_directive] = ACTIONS(4890),
    [anon_sym_LPAREN2] = ACTIONS(4892),
    [anon_sym_TILDE] = ACTIONS(4892),
    [anon_sym_STAR] = ACTIONS(4892),
    [anon_sym_AMP_AMP] = ACTIONS(4892),
    [anon_sym_AMP] = ACTIONS(4890),
    [anon_sym___extension__] = ACTIONS(4890),
    [anon_sym_typedef] = ACTIONS(4890),
    [anon_sym_extern] = ACTIONS(4890),
    [anon_sym___attribute__] = ACTIONS(4890),
    [anon_sym_COLON_COLON] = ACTIONS(4892),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4892),
    [anon_sym___declspec] = ACTIONS(4890),
    [anon_sym___based] = ACTIONS(4890),
    [anon_sym_signed] = ACTIONS(4890),
    [anon_sym_unsigned] = ACTIONS(4890),
    [anon_sym_long] = ACTIONS(4890),
    [anon_sym_short] = ACTIONS(4890),
    [anon_sym_LBRACK] = ACTIONS(4890),
    [anon_sym_static] = ACTIONS(4890),
    [anon_sym_register] = ACTIONS(4890),
    [anon_sym_inline] = ACTIONS(4890),
    [anon_sym___inline] = ACTIONS(4890),
    [anon_sym___inline__] = ACTIONS(4890),
    [anon_sym___forceinline] = ACTIONS(4890),
    [anon_sym_thread_local] = ACTIONS(4890),
    [anon_sym___thread] = ACTIONS(4890),
    [anon_sym_const] = ACTIONS(4890),
    [anon_sym_constexpr] = ACTIONS(4890),
    [anon_sym_volatile] = ACTIONS(4890),
    [anon_sym_restrict] = ACTIONS(4890),
    [anon_sym___restrict__] = ACTIONS(4890),
    [anon_sym__Atomic] = ACTIONS(4890),
    [anon_sym__Noreturn] = ACTIONS(4890),
    [anon_sym_noreturn] = ACTIONS(4890),
    [anon_sym_mutable] = ACTIONS(4890),
    [anon_sym_constinit] = ACTIONS(4890),
    [anon_sym_consteval] = ACTIONS(4890),
    [anon_sym_PROGMEM] = ACTIONS(4890),
    [aux_sym_primitive_type_token1] = ACTIONS(4890),
    [anon_sym_byte] = ACTIONS(4890),
    [anon_sym_word] = ACTIONS(4890),
    [anon_sym_enum] = ACTIONS(4890),
    [anon_sym_class] = ACTIONS(4890),
    [anon_sym_struct] = ACTIONS(4890),
    [anon_sym_union] = ACTIONS(4890),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4890),
    [anon_sym_decltype] = ACTIONS(4890),
    [anon_sym_virtual] = ACTIONS(4890),
    [anon_sym_alignas] = ACTIONS(4890),
    [anon_sym_explicit] = ACTIONS(4890),
    [anon_sym_typename] = ACTIONS(4890),
    [anon_sym_template] = ACTIONS(4890),
    [anon_sym_operator] = ACTIONS(4890),
    [anon_sym_friend] = ACTIONS(4890),
    [anon_sym_public] = ACTIONS(4890),
    [anon_sym_private] = ACTIONS(4890),
    [anon_sym_protected] = ACTIONS(4890),
    [anon_sym_using] = ACTIONS(4890),
    [anon_sym_static_assert] = ACTIONS(4890),
  },
  [2149] = {
    [sym_identifier] = ACTIONS(3126),
    [aux_sym_preproc_def_token1] = ACTIONS(3126),
    [aux_sym_preproc_if_token1] = ACTIONS(3126),
    [aux_sym_preproc_if_token2] = ACTIONS(3126),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3126),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3126),
    [sym_preproc_directive] = ACTIONS(3126),
    [anon_sym_LPAREN2] = ACTIONS(3128),
    [anon_sym_TILDE] = ACTIONS(3128),
    [anon_sym_STAR] = ACTIONS(3128),
    [anon_sym_AMP_AMP] = ACTIONS(3128),
    [anon_sym_AMP] = ACTIONS(3126),
    [anon_sym___extension__] = ACTIONS(3126),
    [anon_sym_typedef] = ACTIONS(3126),
    [anon_sym_extern] = ACTIONS(3126),
    [anon_sym___attribute__] = ACTIONS(3126),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3128),
    [anon_sym___declspec] = ACTIONS(3126),
    [anon_sym___based] = ACTIONS(3126),
    [anon_sym_signed] = ACTIONS(3126),
    [anon_sym_unsigned] = ACTIONS(3126),
    [anon_sym_long] = ACTIONS(3126),
    [anon_sym_short] = ACTIONS(3126),
    [anon_sym_LBRACK] = ACTIONS(3126),
    [anon_sym_static] = ACTIONS(3126),
    [anon_sym_register] = ACTIONS(3126),
    [anon_sym_inline] = ACTIONS(3126),
    [anon_sym___inline] = ACTIONS(3126),
    [anon_sym___inline__] = ACTIONS(3126),
    [anon_sym___forceinline] = ACTIONS(3126),
    [anon_sym_thread_local] = ACTIONS(3126),
    [anon_sym___thread] = ACTIONS(3126),
    [anon_sym_const] = ACTIONS(3126),
    [anon_sym_constexpr] = ACTIONS(3126),
    [anon_sym_volatile] = ACTIONS(3126),
    [anon_sym_restrict] = ACTIONS(3126),
    [anon_sym___restrict__] = ACTIONS(3126),
    [anon_sym__Atomic] = ACTIONS(3126),
    [anon_sym__Noreturn] = ACTIONS(3126),
    [anon_sym_noreturn] = ACTIONS(3126),
    [anon_sym_mutable] = ACTIONS(3126),
    [anon_sym_constinit] = ACTIONS(3126),
    [anon_sym_consteval] = ACTIONS(3126),
    [anon_sym_PROGMEM] = ACTIONS(3126),
    [aux_sym_primitive_type_token1] = ACTIONS(3126),
    [anon_sym_byte] = ACTIONS(3126),
    [anon_sym_word] = ACTIONS(3126),
    [anon_sym_enum] = ACTIONS(3126),
    [anon_sym_class] = ACTIONS(3126),
    [anon_sym_struct] = ACTIONS(3126),
    [anon_sym_union] = ACTIONS(3126),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3126),
    [anon_sym_decltype] = ACTIONS(3126),
    [anon_sym_virtual] = ACTIONS(3126),
    [anon_sym_alignas] = ACTIONS(3126),
    [anon_sym_explicit] = ACTIONS(3126),
    [anon_sym_typename] = ACTIONS(3126),
    [anon_sym_template] = ACTIONS(3126),
    [anon_sym_operator] = ACTIONS(3126),
    [anon_sym_friend] = ACTIONS(3126),
    [anon_sym_public] = ACTIONS(3126),
    [anon_sym_private] = ACTIONS(3126),
    [anon_sym_protected] = ACTIONS(3126),
    [anon_sym_using] = ACTIONS(3126),
    [anon_sym_static_assert] = ACTIONS(3126),
  },
  [2150] = {
    [sym_identifier] = ACTIONS(3126),
    [aux_sym_preproc_def_token1] = ACTIONS(3126),
    [aux_sym_preproc_if_token1] = ACTIONS(3126),
    [aux_sym_preproc_if_token2] = ACTIONS(3126),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3126),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3126),
    [sym_preproc_directive] = ACTIONS(3126),
    [anon_sym_LPAREN2] = ACTIONS(3128),
    [anon_sym_TILDE] = ACTIONS(3128),
    [anon_sym_STAR] = ACTIONS(3128),
    [anon_sym_AMP_AMP] = ACTIONS(3128),
    [anon_sym_AMP] = ACTIONS(3126),
    [anon_sym___extension__] = ACTIONS(3126),
    [anon_sym_typedef] = ACTIONS(3126),
    [anon_sym_extern] = ACTIONS(3126),
    [anon_sym___attribute__] = ACTIONS(3126),
    [anon_sym_COLON_COLON] = ACTIONS(3128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3128),
    [anon_sym___declspec] = ACTIONS(3126),
    [anon_sym___based] = ACTIONS(3126),
    [anon_sym_signed] = ACTIONS(3126),
    [anon_sym_unsigned] = ACTIONS(3126),
    [anon_sym_long] = ACTIONS(3126),
    [anon_sym_short] = ACTIONS(3126),
    [anon_sym_LBRACK] = ACTIONS(3126),
    [anon_sym_static] = ACTIONS(3126),
    [anon_sym_register] = ACTIONS(3126),
    [anon_sym_inline] = ACTIONS(3126),
    [anon_sym___inline] = ACTIONS(3126),
    [anon_sym___inline__] = ACTIONS(3126),
    [anon_sym___forceinline] = ACTIONS(3126),
    [anon_sym_thread_local] = ACTIONS(3126),
    [anon_sym___thread] = ACTIONS(3126),
    [anon_sym_const] = ACTIONS(3126),
    [anon_sym_constexpr] = ACTIONS(3126),
    [anon_sym_volatile] = ACTIONS(3126),
    [anon_sym_restrict] = ACTIONS(3126),
    [anon_sym___restrict__] = ACTIONS(3126),
    [anon_sym__Atomic] = ACTIONS(3126),
    [anon_sym__Noreturn] = ACTIONS(3126),
    [anon_sym_noreturn] = ACTIONS(3126),
    [anon_sym_mutable] = ACTIONS(3126),
    [anon_sym_constinit] = ACTIONS(3126),
    [anon_sym_consteval] = ACTIONS(3126),
    [anon_sym_PROGMEM] = ACTIONS(3126),
    [aux_sym_primitive_type_token1] = ACTIONS(3126),
    [anon_sym_byte] = ACTIONS(3126),
    [anon_sym_word] = ACTIONS(3126),
    [anon_sym_enum] = ACTIONS(3126),
    [anon_sym_class] = ACTIONS(3126),
    [anon_sym_struct] = ACTIONS(3126),
    [anon_sym_union] = ACTIONS(3126),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3126),
    [anon_sym_decltype] = ACTIONS(3126),
    [anon_sym_virtual] = ACTIONS(3126),
    [anon_sym_alignas] = ACTIONS(3126),
    [anon_sym_explicit] = ACTIONS(3126),
    [anon_sym_typename] = ACTIONS(3126),
    [anon_sym_template] = ACTIONS(3126),
    [anon_sym_operator] = ACTIONS(3126),
    [anon_sym_friend] = ACTIONS(3126),
    [anon_sym_public] = ACTIONS(3126),
    [anon_sym_private] = ACTIONS(3126),
    [anon_sym_protected] = ACTIONS(3126),
    [anon_sym_using] = ACTIONS(3126),
    [anon_sym_static_assert] = ACTIONS(3126),
  },
  [2151] = {
    [sym_identifier] = ACTIONS(4894),
    [aux_sym_preproc_def_token1] = ACTIONS(4894),
    [aux_sym_preproc_if_token1] = ACTIONS(4894),
    [aux_sym_preproc_if_token2] = ACTIONS(4894),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4894),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4894),
    [sym_preproc_directive] = ACTIONS(4894),
    [anon_sym_LPAREN2] = ACTIONS(4896),
    [anon_sym_TILDE] = ACTIONS(4896),
    [anon_sym_STAR] = ACTIONS(4896),
    [anon_sym_AMP_AMP] = ACTIONS(4896),
    [anon_sym_AMP] = ACTIONS(4894),
    [anon_sym___extension__] = ACTIONS(4894),
    [anon_sym_typedef] = ACTIONS(4894),
    [anon_sym_extern] = ACTIONS(4894),
    [anon_sym___attribute__] = ACTIONS(4894),
    [anon_sym_COLON_COLON] = ACTIONS(4896),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4896),
    [anon_sym___declspec] = ACTIONS(4894),
    [anon_sym___based] = ACTIONS(4894),
    [anon_sym_signed] = ACTIONS(4894),
    [anon_sym_unsigned] = ACTIONS(4894),
    [anon_sym_long] = ACTIONS(4894),
    [anon_sym_short] = ACTIONS(4894),
    [anon_sym_LBRACK] = ACTIONS(4894),
    [anon_sym_static] = ACTIONS(4894),
    [anon_sym_register] = ACTIONS(4894),
    [anon_sym_inline] = ACTIONS(4894),
    [anon_sym___inline] = ACTIONS(4894),
    [anon_sym___inline__] = ACTIONS(4894),
    [anon_sym___forceinline] = ACTIONS(4894),
    [anon_sym_thread_local] = ACTIONS(4894),
    [anon_sym___thread] = ACTIONS(4894),
    [anon_sym_const] = ACTIONS(4894),
    [anon_sym_constexpr] = ACTIONS(4894),
    [anon_sym_volatile] = ACTIONS(4894),
    [anon_sym_restrict] = ACTIONS(4894),
    [anon_sym___restrict__] = ACTIONS(4894),
    [anon_sym__Atomic] = ACTIONS(4894),
    [anon_sym__Noreturn] = ACTIONS(4894),
    [anon_sym_noreturn] = ACTIONS(4894),
    [anon_sym_mutable] = ACTIONS(4894),
    [anon_sym_constinit] = ACTIONS(4894),
    [anon_sym_consteval] = ACTIONS(4894),
    [anon_sym_PROGMEM] = ACTIONS(4894),
    [aux_sym_primitive_type_token1] = ACTIONS(4894),
    [anon_sym_byte] = ACTIONS(4894),
    [anon_sym_word] = ACTIONS(4894),
    [anon_sym_enum] = ACTIONS(4894),
    [anon_sym_class] = ACTIONS(4894),
    [anon_sym_struct] = ACTIONS(4894),
    [anon_sym_union] = ACTIONS(4894),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4894),
    [anon_sym_decltype] = ACTIONS(4894),
    [anon_sym_virtual] = ACTIONS(4894),
    [anon_sym_alignas] = ACTIONS(4894),
    [anon_sym_explicit] = ACTIONS(4894),
    [anon_sym_typename] = ACTIONS(4894),
    [anon_sym_template] = ACTIONS(4894),
    [anon_sym_operator] = ACTIONS(4894),
    [anon_sym_friend] = ACTIONS(4894),
    [anon_sym_public] = ACTIONS(4894),
    [anon_sym_private] = ACTIONS(4894),
    [anon_sym_protected] = ACTIONS(4894),
    [anon_sym_using] = ACTIONS(4894),
    [anon_sym_static_assert] = ACTIONS(4894),
  },
  [2152] = {
    [sym_identifier] = ACTIONS(4898),
    [aux_sym_preproc_def_token1] = ACTIONS(4898),
    [aux_sym_preproc_if_token1] = ACTIONS(4898),
    [aux_sym_preproc_if_token2] = ACTIONS(4898),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4898),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4898),
    [sym_preproc_directive] = ACTIONS(4898),
    [anon_sym_LPAREN2] = ACTIONS(4900),
    [anon_sym_TILDE] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_AMP_AMP] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4898),
    [anon_sym___extension__] = ACTIONS(4898),
    [anon_sym_typedef] = ACTIONS(4898),
    [anon_sym_extern] = ACTIONS(4898),
    [anon_sym___attribute__] = ACTIONS(4898),
    [anon_sym_COLON_COLON] = ACTIONS(4900),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4900),
    [anon_sym___declspec] = ACTIONS(4898),
    [anon_sym___based] = ACTIONS(4898),
    [anon_sym_signed] = ACTIONS(4898),
    [anon_sym_unsigned] = ACTIONS(4898),
    [anon_sym_long] = ACTIONS(4898),
    [anon_sym_short] = ACTIONS(4898),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_static] = ACTIONS(4898),
    [anon_sym_register] = ACTIONS(4898),
    [anon_sym_inline] = ACTIONS(4898),
    [anon_sym___inline] = ACTIONS(4898),
    [anon_sym___inline__] = ACTIONS(4898),
    [anon_sym___forceinline] = ACTIONS(4898),
    [anon_sym_thread_local] = ACTIONS(4898),
    [anon_sym___thread] = ACTIONS(4898),
    [anon_sym_const] = ACTIONS(4898),
    [anon_sym_constexpr] = ACTIONS(4898),
    [anon_sym_volatile] = ACTIONS(4898),
    [anon_sym_restrict] = ACTIONS(4898),
    [anon_sym___restrict__] = ACTIONS(4898),
    [anon_sym__Atomic] = ACTIONS(4898),
    [anon_sym__Noreturn] = ACTIONS(4898),
    [anon_sym_noreturn] = ACTIONS(4898),
    [anon_sym_mutable] = ACTIONS(4898),
    [anon_sym_constinit] = ACTIONS(4898),
    [anon_sym_consteval] = ACTIONS(4898),
    [anon_sym_PROGMEM] = ACTIONS(4898),
    [aux_sym_primitive_type_token1] = ACTIONS(4898),
    [anon_sym_byte] = ACTIONS(4898),
    [anon_sym_word] = ACTIONS(4898),
    [anon_sym_enum] = ACTIONS(4898),
    [anon_sym_class] = ACTIONS(4898),
    [anon_sym_struct] = ACTIONS(4898),
    [anon_sym_union] = ACTIONS(4898),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4898),
    [anon_sym_decltype] = ACTIONS(4898),
    [anon_sym_virtual] = ACTIONS(4898),
    [anon_sym_alignas] = ACTIONS(4898),
    [anon_sym_explicit] = ACTIONS(4898),
    [anon_sym_typename] = ACTIONS(4898),
    [anon_sym_template] = ACTIONS(4898),
    [anon_sym_operator] = ACTIONS(4898),
    [anon_sym_friend] = ACTIONS(4898),
    [anon_sym_public] = ACTIONS(4898),
    [anon_sym_private] = ACTIONS(4898),
    [anon_sym_protected] = ACTIONS(4898),
    [anon_sym_using] = ACTIONS(4898),
    [anon_sym_static_assert] = ACTIONS(4898),
  },
  [2153] = {
    [sym_identifier] = ACTIONS(4914),
    [aux_sym_preproc_def_token1] = ACTIONS(4914),
    [aux_sym_preproc_if_token1] = ACTIONS(4914),
    [aux_sym_preproc_if_token2] = ACTIONS(4914),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4914),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4914),
    [sym_preproc_directive] = ACTIONS(4914),
    [anon_sym_LPAREN2] = ACTIONS(4916),
    [anon_sym_TILDE] = ACTIONS(4916),
    [anon_sym_STAR] = ACTIONS(4916),
    [anon_sym_AMP_AMP] = ACTIONS(4916),
    [anon_sym_AMP] = ACTIONS(4914),
    [anon_sym___extension__] = ACTIONS(4914),
    [anon_sym_typedef] = ACTIONS(4914),
    [anon_sym_extern] = ACTIONS(4914),
    [anon_sym___attribute__] = ACTIONS(4914),
    [anon_sym_COLON_COLON] = ACTIONS(4916),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4916),
    [anon_sym___declspec] = ACTIONS(4914),
    [anon_sym___based] = ACTIONS(4914),
    [anon_sym_signed] = ACTIONS(4914),
    [anon_sym_unsigned] = ACTIONS(4914),
    [anon_sym_long] = ACTIONS(4914),
    [anon_sym_short] = ACTIONS(4914),
    [anon_sym_LBRACK] = ACTIONS(4914),
    [anon_sym_static] = ACTIONS(4914),
    [anon_sym_register] = ACTIONS(4914),
    [anon_sym_inline] = ACTIONS(4914),
    [anon_sym___inline] = ACTIONS(4914),
    [anon_sym___inline__] = ACTIONS(4914),
    [anon_sym___forceinline] = ACTIONS(4914),
    [anon_sym_thread_local] = ACTIONS(4914),
    [anon_sym___thread] = ACTIONS(4914),
    [anon_sym_const] = ACTIONS(4914),
    [anon_sym_constexpr] = ACTIONS(4914),
    [anon_sym_volatile] = ACTIONS(4914),
    [anon_sym_restrict] = ACTIONS(4914),
    [anon_sym___restrict__] = ACTIONS(4914),
    [anon_sym__Atomic] = ACTIONS(4914),
    [anon_sym__Noreturn] = ACTIONS(4914),
    [anon_sym_noreturn] = ACTIONS(4914),
    [anon_sym_mutable] = ACTIONS(4914),
    [anon_sym_constinit] = ACTIONS(4914),
    [anon_sym_consteval] = ACTIONS(4914),
    [anon_sym_PROGMEM] = ACTIONS(4914),
    [aux_sym_primitive_type_token1] = ACTIONS(4914),
    [anon_sym_byte] = ACTIONS(4914),
    [anon_sym_word] = ACTIONS(4914),
    [anon_sym_enum] = ACTIONS(4914),
    [anon_sym_class] = ACTIONS(4914),
    [anon_sym_struct] = ACTIONS(4914),
    [anon_sym_union] = ACTIONS(4914),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4914),
    [anon_sym_decltype] = ACTIONS(4914),
    [anon_sym_virtual] = ACTIONS(4914),
    [anon_sym_alignas] = ACTIONS(4914),
    [anon_sym_explicit] = ACTIONS(4914),
    [anon_sym_typename] = ACTIONS(4914),
    [anon_sym_template] = ACTIONS(4914),
    [anon_sym_operator] = ACTIONS(4914),
    [anon_sym_friend] = ACTIONS(4914),
    [anon_sym_public] = ACTIONS(4914),
    [anon_sym_private] = ACTIONS(4914),
    [anon_sym_protected] = ACTIONS(4914),
    [anon_sym_using] = ACTIONS(4914),
    [anon_sym_static_assert] = ACTIONS(4914),
  },
  [2154] = {
    [sym_identifier] = ACTIONS(4914),
    [aux_sym_preproc_def_token1] = ACTIONS(4914),
    [aux_sym_preproc_if_token1] = ACTIONS(4914),
    [aux_sym_preproc_if_token2] = ACTIONS(4914),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4914),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4914),
    [sym_preproc_directive] = ACTIONS(4914),
    [anon_sym_LPAREN2] = ACTIONS(4916),
    [anon_sym_TILDE] = ACTIONS(4916),
    [anon_sym_STAR] = ACTIONS(4916),
    [anon_sym_AMP_AMP] = ACTIONS(4916),
    [anon_sym_AMP] = ACTIONS(4914),
    [anon_sym___extension__] = ACTIONS(4914),
    [anon_sym_typedef] = ACTIONS(4914),
    [anon_sym_extern] = ACTIONS(4914),
    [anon_sym___attribute__] = ACTIONS(4914),
    [anon_sym_COLON_COLON] = ACTIONS(4916),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4916),
    [anon_sym___declspec] = ACTIONS(4914),
    [anon_sym___based] = ACTIONS(4914),
    [anon_sym_signed] = ACTIONS(4914),
    [anon_sym_unsigned] = ACTIONS(4914),
    [anon_sym_long] = ACTIONS(4914),
    [anon_sym_short] = ACTIONS(4914),
    [anon_sym_LBRACK] = ACTIONS(4914),
    [anon_sym_static] = ACTIONS(4914),
    [anon_sym_register] = ACTIONS(4914),
    [anon_sym_inline] = ACTIONS(4914),
    [anon_sym___inline] = ACTIONS(4914),
    [anon_sym___inline__] = ACTIONS(4914),
    [anon_sym___forceinline] = ACTIONS(4914),
    [anon_sym_thread_local] = ACTIONS(4914),
    [anon_sym___thread] = ACTIONS(4914),
    [anon_sym_const] = ACTIONS(4914),
    [anon_sym_constexpr] = ACTIONS(4914),
    [anon_sym_volatile] = ACTIONS(4914),
    [anon_sym_restrict] = ACTIONS(4914),
    [anon_sym___restrict__] = ACTIONS(4914),
    [anon_sym__Atomic] = ACTIONS(4914),
    [anon_sym__Noreturn] = ACTIONS(4914),
    [anon_sym_noreturn] = ACTIONS(4914),
    [anon_sym_mutable] = ACTIONS(4914),
    [anon_sym_constinit] = ACTIONS(4914),
    [anon_sym_consteval] = ACTIONS(4914),
    [anon_sym_PROGMEM] = ACTIONS(4914),
    [aux_sym_primitive_type_token1] = ACTIONS(4914),
    [anon_sym_byte] = ACTIONS(4914),
    [anon_sym_word] = ACTIONS(4914),
    [anon_sym_enum] = ACTIONS(4914),
    [anon_sym_class] = ACTIONS(4914),
    [anon_sym_struct] = ACTIONS(4914),
    [anon_sym_union] = ACTIONS(4914),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4914),
    [anon_sym_decltype] = ACTIONS(4914),
    [anon_sym_virtual] = ACTIONS(4914),
    [anon_sym_alignas] = ACTIONS(4914),
    [anon_sym_explicit] = ACTIONS(4914),
    [anon_sym_typename] = ACTIONS(4914),
    [anon_sym_template] = ACTIONS(4914),
    [anon_sym_operator] = ACTIONS(4914),
    [anon_sym_friend] = ACTIONS(4914),
    [anon_sym_public] = ACTIONS(4914),
    [anon_sym_private] = ACTIONS(4914),
    [anon_sym_protected] = ACTIONS(4914),
    [anon_sym_using] = ACTIONS(4914),
    [anon_sym_static_assert] = ACTIONS(4914),
  },
  [2155] = {
    [sym_identifier] = ACTIONS(3036),
    [aux_sym_preproc_def_token1] = ACTIONS(3036),
    [aux_sym_preproc_if_token1] = ACTIONS(3036),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3036),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3036),
    [sym_preproc_directive] = ACTIONS(3036),
    [anon_sym_LPAREN2] = ACTIONS(3038),
    [anon_sym_TILDE] = ACTIONS(3038),
    [anon_sym_STAR] = ACTIONS(3038),
    [anon_sym_AMP_AMP] = ACTIONS(3038),
    [anon_sym_AMP] = ACTIONS(3036),
    [anon_sym___extension__] = ACTIONS(3036),
    [anon_sym_typedef] = ACTIONS(3036),
    [anon_sym_extern] = ACTIONS(3036),
    [anon_sym___attribute__] = ACTIONS(3036),
    [anon_sym_COLON_COLON] = ACTIONS(3038),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3038),
    [anon_sym___declspec] = ACTIONS(3036),
    [anon_sym___based] = ACTIONS(3036),
    [anon_sym_RBRACE] = ACTIONS(3038),
    [anon_sym_signed] = ACTIONS(3036),
    [anon_sym_unsigned] = ACTIONS(3036),
    [anon_sym_long] = ACTIONS(3036),
    [anon_sym_short] = ACTIONS(3036),
    [anon_sym_LBRACK] = ACTIONS(3036),
    [anon_sym_static] = ACTIONS(3036),
    [anon_sym_register] = ACTIONS(3036),
    [anon_sym_inline] = ACTIONS(3036),
    [anon_sym___inline] = ACTIONS(3036),
    [anon_sym___inline__] = ACTIONS(3036),
    [anon_sym___forceinline] = ACTIONS(3036),
    [anon_sym_thread_local] = ACTIONS(3036),
    [anon_sym___thread] = ACTIONS(3036),
    [anon_sym_const] = ACTIONS(3036),
    [anon_sym_constexpr] = ACTIONS(3036),
    [anon_sym_volatile] = ACTIONS(3036),
    [anon_sym_restrict] = ACTIONS(3036),
    [anon_sym___restrict__] = ACTIONS(3036),
    [anon_sym__Atomic] = ACTIONS(3036),
    [anon_sym__Noreturn] = ACTIONS(3036),
    [anon_sym_noreturn] = ACTIONS(3036),
    [anon_sym_mutable] = ACTIONS(3036),
    [anon_sym_constinit] = ACTIONS(3036),
    [anon_sym_consteval] = ACTIONS(3036),
    [anon_sym_PROGMEM] = ACTIONS(3036),
    [aux_sym_primitive_type_token1] = ACTIONS(3036),
    [anon_sym_byte] = ACTIONS(3036),
    [anon_sym_word] = ACTIONS(3036),
    [anon_sym_enum] = ACTIONS(3036),
    [anon_sym_class] = ACTIONS(3036),
    [anon_sym_struct] = ACTIONS(3036),
    [anon_sym_union] = ACTIONS(3036),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3036),
    [anon_sym_decltype] = ACTIONS(3036),
    [anon_sym_virtual] = ACTIONS(3036),
    [anon_sym_alignas] = ACTIONS(3036),
    [anon_sym_explicit] = ACTIONS(3036),
    [anon_sym_typename] = ACTIONS(3036),
    [anon_sym_template] = ACTIONS(3036),
    [anon_sym_operator] = ACTIONS(3036),
    [anon_sym_friend] = ACTIONS(3036),
    [anon_sym_public] = ACTIONS(3036),
    [anon_sym_private] = ACTIONS(3036),
    [anon_sym_protected] = ACTIONS(3036),
    [anon_sym_using] = ACTIONS(3036),
    [anon_sym_static_assert] = ACTIONS(3036),
  },
  [2156] = {
    [sym_identifier] = ACTIONS(4914),
    [aux_sym_preproc_def_token1] = ACTIONS(4914),
    [aux_sym_preproc_if_token1] = ACTIONS(4914),
    [aux_sym_preproc_if_token2] = ACTIONS(4914),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4914),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4914),
    [sym_preproc_directive] = ACTIONS(4914),
    [anon_sym_LPAREN2] = ACTIONS(4916),
    [anon_sym_TILDE] = ACTIONS(4916),
    [anon_sym_STAR] = ACTIONS(4916),
    [anon_sym_AMP_AMP] = ACTIONS(4916),
    [anon_sym_AMP] = ACTIONS(4914),
    [anon_sym___extension__] = ACTIONS(4914),
    [anon_sym_typedef] = ACTIONS(4914),
    [anon_sym_extern] = ACTIONS(4914),
    [anon_sym___attribute__] = ACTIONS(4914),
    [anon_sym_COLON_COLON] = ACTIONS(4916),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4916),
    [anon_sym___declspec] = ACTIONS(4914),
    [anon_sym___based] = ACTIONS(4914),
    [anon_sym_signed] = ACTIONS(4914),
    [anon_sym_unsigned] = ACTIONS(4914),
    [anon_sym_long] = ACTIONS(4914),
    [anon_sym_short] = ACTIONS(4914),
    [anon_sym_LBRACK] = ACTIONS(4914),
    [anon_sym_static] = ACTIONS(4914),
    [anon_sym_register] = ACTIONS(4914),
    [anon_sym_inline] = ACTIONS(4914),
    [anon_sym___inline] = ACTIONS(4914),
    [anon_sym___inline__] = ACTIONS(4914),
    [anon_sym___forceinline] = ACTIONS(4914),
    [anon_sym_thread_local] = ACTIONS(4914),
    [anon_sym___thread] = ACTIONS(4914),
    [anon_sym_const] = ACTIONS(4914),
    [anon_sym_constexpr] = ACTIONS(4914),
    [anon_sym_volatile] = ACTIONS(4914),
    [anon_sym_restrict] = ACTIONS(4914),
    [anon_sym___restrict__] = ACTIONS(4914),
    [anon_sym__Atomic] = ACTIONS(4914),
    [anon_sym__Noreturn] = ACTIONS(4914),
    [anon_sym_noreturn] = ACTIONS(4914),
    [anon_sym_mutable] = ACTIONS(4914),
    [anon_sym_constinit] = ACTIONS(4914),
    [anon_sym_consteval] = ACTIONS(4914),
    [anon_sym_PROGMEM] = ACTIONS(4914),
    [aux_sym_primitive_type_token1] = ACTIONS(4914),
    [anon_sym_byte] = ACTIONS(4914),
    [anon_sym_word] = ACTIONS(4914),
    [anon_sym_enum] = ACTIONS(4914),
    [anon_sym_class] = ACTIONS(4914),
    [anon_sym_struct] = ACTIONS(4914),
    [anon_sym_union] = ACTIONS(4914),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4914),
    [anon_sym_decltype] = ACTIONS(4914),
    [anon_sym_virtual] = ACTIONS(4914),
    [anon_sym_alignas] = ACTIONS(4914),
    [anon_sym_explicit] = ACTIONS(4914),
    [anon_sym_typename] = ACTIONS(4914),
    [anon_sym_template] = ACTIONS(4914),
    [anon_sym_operator] = ACTIONS(4914),
    [anon_sym_friend] = ACTIONS(4914),
    [anon_sym_public] = ACTIONS(4914),
    [anon_sym_private] = ACTIONS(4914),
    [anon_sym_protected] = ACTIONS(4914),
    [anon_sym_using] = ACTIONS(4914),
    [anon_sym_static_assert] = ACTIONS(4914),
  },
  [2157] = {
    [sym_identifier] = ACTIONS(4898),
    [aux_sym_preproc_def_token1] = ACTIONS(4898),
    [aux_sym_preproc_if_token1] = ACTIONS(4898),
    [aux_sym_preproc_if_token2] = ACTIONS(4898),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4898),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4898),
    [sym_preproc_directive] = ACTIONS(4898),
    [anon_sym_LPAREN2] = ACTIONS(4900),
    [anon_sym_TILDE] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_AMP_AMP] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4898),
    [anon_sym___extension__] = ACTIONS(4898),
    [anon_sym_typedef] = ACTIONS(4898),
    [anon_sym_extern] = ACTIONS(4898),
    [anon_sym___attribute__] = ACTIONS(4898),
    [anon_sym_COLON_COLON] = ACTIONS(4900),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4900),
    [anon_sym___declspec] = ACTIONS(4898),
    [anon_sym___based] = ACTIONS(4898),
    [anon_sym_signed] = ACTIONS(4898),
    [anon_sym_unsigned] = ACTIONS(4898),
    [anon_sym_long] = ACTIONS(4898),
    [anon_sym_short] = ACTIONS(4898),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_static] = ACTIONS(4898),
    [anon_sym_register] = ACTIONS(4898),
    [anon_sym_inline] = ACTIONS(4898),
    [anon_sym___inline] = ACTIONS(4898),
    [anon_sym___inline__] = ACTIONS(4898),
    [anon_sym___forceinline] = ACTIONS(4898),
    [anon_sym_thread_local] = ACTIONS(4898),
    [anon_sym___thread] = ACTIONS(4898),
    [anon_sym_const] = ACTIONS(4898),
    [anon_sym_constexpr] = ACTIONS(4898),
    [anon_sym_volatile] = ACTIONS(4898),
    [anon_sym_restrict] = ACTIONS(4898),
    [anon_sym___restrict__] = ACTIONS(4898),
    [anon_sym__Atomic] = ACTIONS(4898),
    [anon_sym__Noreturn] = ACTIONS(4898),
    [anon_sym_noreturn] = ACTIONS(4898),
    [anon_sym_mutable] = ACTIONS(4898),
    [anon_sym_constinit] = ACTIONS(4898),
    [anon_sym_consteval] = ACTIONS(4898),
    [anon_sym_PROGMEM] = ACTIONS(4898),
    [aux_sym_primitive_type_token1] = ACTIONS(4898),
    [anon_sym_byte] = ACTIONS(4898),
    [anon_sym_word] = ACTIONS(4898),
    [anon_sym_enum] = ACTIONS(4898),
    [anon_sym_class] = ACTIONS(4898),
    [anon_sym_struct] = ACTIONS(4898),
    [anon_sym_union] = ACTIONS(4898),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4898),
    [anon_sym_decltype] = ACTIONS(4898),
    [anon_sym_virtual] = ACTIONS(4898),
    [anon_sym_alignas] = ACTIONS(4898),
    [anon_sym_explicit] = ACTIONS(4898),
    [anon_sym_typename] = ACTIONS(4898),
    [anon_sym_template] = ACTIONS(4898),
    [anon_sym_operator] = ACTIONS(4898),
    [anon_sym_friend] = ACTIONS(4898),
    [anon_sym_public] = ACTIONS(4898),
    [anon_sym_private] = ACTIONS(4898),
    [anon_sym_protected] = ACTIONS(4898),
    [anon_sym_using] = ACTIONS(4898),
    [anon_sym_static_assert] = ACTIONS(4898),
  },
  [2158] = {
    [sym_identifier] = ACTIONS(3028),
    [aux_sym_preproc_def_token1] = ACTIONS(3028),
    [aux_sym_preproc_if_token1] = ACTIONS(3028),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3028),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3028),
    [sym_preproc_directive] = ACTIONS(3028),
    [anon_sym_LPAREN2] = ACTIONS(3030),
    [anon_sym_TILDE] = ACTIONS(3030),
    [anon_sym_STAR] = ACTIONS(3030),
    [anon_sym_AMP_AMP] = ACTIONS(3030),
    [anon_sym_AMP] = ACTIONS(3028),
    [anon_sym___extension__] = ACTIONS(3028),
    [anon_sym_typedef] = ACTIONS(3028),
    [anon_sym_extern] = ACTIONS(3028),
    [anon_sym___attribute__] = ACTIONS(3028),
    [anon_sym_COLON_COLON] = ACTIONS(3030),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3030),
    [anon_sym___declspec] = ACTIONS(3028),
    [anon_sym___based] = ACTIONS(3028),
    [anon_sym_RBRACE] = ACTIONS(3030),
    [anon_sym_signed] = ACTIONS(3028),
    [anon_sym_unsigned] = ACTIONS(3028),
    [anon_sym_long] = ACTIONS(3028),
    [anon_sym_short] = ACTIONS(3028),
    [anon_sym_LBRACK] = ACTIONS(3028),
    [anon_sym_static] = ACTIONS(3028),
    [anon_sym_register] = ACTIONS(3028),
    [anon_sym_inline] = ACTIONS(3028),
    [anon_sym___inline] = ACTIONS(3028),
    [anon_sym___inline__] = ACTIONS(3028),
    [anon_sym___forceinline] = ACTIONS(3028),
    [anon_sym_thread_local] = ACTIONS(3028),
    [anon_sym___thread] = ACTIONS(3028),
    [anon_sym_const] = ACTIONS(3028),
    [anon_sym_constexpr] = ACTIONS(3028),
    [anon_sym_volatile] = ACTIONS(3028),
    [anon_sym_restrict] = ACTIONS(3028),
    [anon_sym___restrict__] = ACTIONS(3028),
    [anon_sym__Atomic] = ACTIONS(3028),
    [anon_sym__Noreturn] = ACTIONS(3028),
    [anon_sym_noreturn] = ACTIONS(3028),
    [anon_sym_mutable] = ACTIONS(3028),
    [anon_sym_constinit] = ACTIONS(3028),
    [anon_sym_consteval] = ACTIONS(3028),
    [anon_sym_PROGMEM] = ACTIONS(3028),
    [aux_sym_primitive_type_token1] = ACTIONS(3028),
    [anon_sym_byte] = ACTIONS(3028),
    [anon_sym_word] = ACTIONS(3028),
    [anon_sym_enum] = ACTIONS(3028),
    [anon_sym_class] = ACTIONS(3028),
    [anon_sym_struct] = ACTIONS(3028),
    [anon_sym_union] = ACTIONS(3028),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3028),
    [anon_sym_decltype] = ACTIONS(3028),
    [anon_sym_virtual] = ACTIONS(3028),
    [anon_sym_alignas] = ACTIONS(3028),
    [anon_sym_explicit] = ACTIONS(3028),
    [anon_sym_typename] = ACTIONS(3028),
    [anon_sym_template] = ACTIONS(3028),
    [anon_sym_operator] = ACTIONS(3028),
    [anon_sym_friend] = ACTIONS(3028),
    [anon_sym_public] = ACTIONS(3028),
    [anon_sym_private] = ACTIONS(3028),
    [anon_sym_protected] = ACTIONS(3028),
    [anon_sym_using] = ACTIONS(3028),
    [anon_sym_static_assert] = ACTIONS(3028),
  },
  [2159] = {
    [sym_identifier] = ACTIONS(2897),
    [aux_sym_preproc_def_token1] = ACTIONS(2897),
    [aux_sym_preproc_if_token1] = ACTIONS(2897),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2897),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2897),
    [sym_preproc_directive] = ACTIONS(2897),
    [anon_sym_LPAREN2] = ACTIONS(2899),
    [anon_sym_TILDE] = ACTIONS(2899),
    [anon_sym_STAR] = ACTIONS(2899),
    [anon_sym_AMP_AMP] = ACTIONS(2899),
    [anon_sym_AMP] = ACTIONS(2897),
    [anon_sym___extension__] = ACTIONS(2897),
    [anon_sym_typedef] = ACTIONS(2897),
    [anon_sym_extern] = ACTIONS(2897),
    [anon_sym___attribute__] = ACTIONS(2897),
    [anon_sym_COLON_COLON] = ACTIONS(2899),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2899),
    [anon_sym___declspec] = ACTIONS(2897),
    [anon_sym___based] = ACTIONS(2897),
    [anon_sym_RBRACE] = ACTIONS(2899),
    [anon_sym_signed] = ACTIONS(2897),
    [anon_sym_unsigned] = ACTIONS(2897),
    [anon_sym_long] = ACTIONS(2897),
    [anon_sym_short] = ACTIONS(2897),
    [anon_sym_LBRACK] = ACTIONS(2897),
    [anon_sym_static] = ACTIONS(2897),
    [anon_sym_register] = ACTIONS(2897),
    [anon_sym_inline] = ACTIONS(2897),
    [anon_sym___inline] = ACTIONS(2897),
    [anon_sym___inline__] = ACTIONS(2897),
    [anon_sym___forceinline] = ACTIONS(2897),
    [anon_sym_thread_local] = ACTIONS(2897),
    [anon_sym___thread] = ACTIONS(2897),
    [anon_sym_const] = ACTIONS(2897),
    [anon_sym_constexpr] = ACTIONS(2897),
    [anon_sym_volatile] = ACTIONS(2897),
    [anon_sym_restrict] = ACTIONS(2897),
    [anon_sym___restrict__] = ACTIONS(2897),
    [anon_sym__Atomic] = ACTIONS(2897),
    [anon_sym__Noreturn] = ACTIONS(2897),
    [anon_sym_noreturn] = ACTIONS(2897),
    [anon_sym_mutable] = ACTIONS(2897),
    [anon_sym_constinit] = ACTIONS(2897),
    [anon_sym_consteval] = ACTIONS(2897),
    [anon_sym_PROGMEM] = ACTIONS(2897),
    [aux_sym_primitive_type_token1] = ACTIONS(2897),
    [anon_sym_byte] = ACTIONS(2897),
    [anon_sym_word] = ACTIONS(2897),
    [anon_sym_enum] = ACTIONS(2897),
    [anon_sym_class] = ACTIONS(2897),
    [anon_sym_struct] = ACTIONS(2897),
    [anon_sym_union] = ACTIONS(2897),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2897),
    [anon_sym_decltype] = ACTIONS(2897),
    [anon_sym_virtual] = ACTIONS(2897),
    [anon_sym_alignas] = ACTIONS(2897),
    [anon_sym_explicit] = ACTIONS(2897),
    [anon_sym_typename] = ACTIONS(2897),
    [anon_sym_template] = ACTIONS(2897),
    [anon_sym_operator] = ACTIONS(2897),
    [anon_sym_friend] = ACTIONS(2897),
    [anon_sym_public] = ACTIONS(2897),
    [anon_sym_private] = ACTIONS(2897),
    [anon_sym_protected] = ACTIONS(2897),
    [anon_sym_using] = ACTIONS(2897),
    [anon_sym_static_assert] = ACTIONS(2897),
  },
  [2160] = {
    [sym_identifier] = ACTIONS(3024),
    [aux_sym_preproc_def_token1] = ACTIONS(3024),
    [aux_sym_preproc_if_token1] = ACTIONS(3024),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3024),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3024),
    [sym_preproc_directive] = ACTIONS(3024),
    [anon_sym_LPAREN2] = ACTIONS(3026),
    [anon_sym_TILDE] = ACTIONS(3026),
    [anon_sym_STAR] = ACTIONS(3026),
    [anon_sym_AMP_AMP] = ACTIONS(3026),
    [anon_sym_AMP] = ACTIONS(3024),
    [anon_sym___extension__] = ACTIONS(3024),
    [anon_sym_typedef] = ACTIONS(3024),
    [anon_sym_extern] = ACTIONS(3024),
    [anon_sym___attribute__] = ACTIONS(3024),
    [anon_sym_COLON_COLON] = ACTIONS(3026),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3026),
    [anon_sym___declspec] = ACTIONS(3024),
    [anon_sym___based] = ACTIONS(3024),
    [anon_sym_RBRACE] = ACTIONS(3026),
    [anon_sym_signed] = ACTIONS(3024),
    [anon_sym_unsigned] = ACTIONS(3024),
    [anon_sym_long] = ACTIONS(3024),
    [anon_sym_short] = ACTIONS(3024),
    [anon_sym_LBRACK] = ACTIONS(3024),
    [anon_sym_static] = ACTIONS(3024),
    [anon_sym_register] = ACTIONS(3024),
    [anon_sym_inline] = ACTIONS(3024),
    [anon_sym___inline] = ACTIONS(3024),
    [anon_sym___inline__] = ACTIONS(3024),
    [anon_sym___forceinline] = ACTIONS(3024),
    [anon_sym_thread_local] = ACTIONS(3024),
    [anon_sym___thread] = ACTIONS(3024),
    [anon_sym_const] = ACTIONS(3024),
    [anon_sym_constexpr] = ACTIONS(3024),
    [anon_sym_volatile] = ACTIONS(3024),
    [anon_sym_restrict] = ACTIONS(3024),
    [anon_sym___restrict__] = ACTIONS(3024),
    [anon_sym__Atomic] = ACTIONS(3024),
    [anon_sym__Noreturn] = ACTIONS(3024),
    [anon_sym_noreturn] = ACTIONS(3024),
    [anon_sym_mutable] = ACTIONS(3024),
    [anon_sym_constinit] = ACTIONS(3024),
    [anon_sym_consteval] = ACTIONS(3024),
    [anon_sym_PROGMEM] = ACTIONS(3024),
    [aux_sym_primitive_type_token1] = ACTIONS(3024),
    [anon_sym_byte] = ACTIONS(3024),
    [anon_sym_word] = ACTIONS(3024),
    [anon_sym_enum] = ACTIONS(3024),
    [anon_sym_class] = ACTIONS(3024),
    [anon_sym_struct] = ACTIONS(3024),
    [anon_sym_union] = ACTIONS(3024),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3024),
    [anon_sym_decltype] = ACTIONS(3024),
    [anon_sym_virtual] = ACTIONS(3024),
    [anon_sym_alignas] = ACTIONS(3024),
    [anon_sym_explicit] = ACTIONS(3024),
    [anon_sym_typename] = ACTIONS(3024),
    [anon_sym_template] = ACTIONS(3024),
    [anon_sym_operator] = ACTIONS(3024),
    [anon_sym_friend] = ACTIONS(3024),
    [anon_sym_public] = ACTIONS(3024),
    [anon_sym_private] = ACTIONS(3024),
    [anon_sym_protected] = ACTIONS(3024),
    [anon_sym_using] = ACTIONS(3024),
    [anon_sym_static_assert] = ACTIONS(3024),
  },
  [2161] = {
    [sym_identifier] = ACTIONS(2809),
    [aux_sym_preproc_def_token1] = ACTIONS(2809),
    [aux_sym_preproc_if_token1] = ACTIONS(2809),
    [aux_sym_preproc_if_token2] = ACTIONS(2809),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2809),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2809),
    [sym_preproc_directive] = ACTIONS(2809),
    [anon_sym_LPAREN2] = ACTIONS(2811),
    [anon_sym_TILDE] = ACTIONS(2811),
    [anon_sym_STAR] = ACTIONS(2811),
    [anon_sym_AMP_AMP] = ACTIONS(2811),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym___extension__] = ACTIONS(2809),
    [anon_sym_typedef] = ACTIONS(2809),
    [anon_sym_extern] = ACTIONS(2809),
    [anon_sym___attribute__] = ACTIONS(2809),
    [anon_sym_COLON_COLON] = ACTIONS(2811),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2811),
    [anon_sym___declspec] = ACTIONS(2809),
    [anon_sym___based] = ACTIONS(2809),
    [anon_sym_signed] = ACTIONS(2809),
    [anon_sym_unsigned] = ACTIONS(2809),
    [anon_sym_long] = ACTIONS(2809),
    [anon_sym_short] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2809),
    [anon_sym_static] = ACTIONS(2809),
    [anon_sym_register] = ACTIONS(2809),
    [anon_sym_inline] = ACTIONS(2809),
    [anon_sym___inline] = ACTIONS(2809),
    [anon_sym___inline__] = ACTIONS(2809),
    [anon_sym___forceinline] = ACTIONS(2809),
    [anon_sym_thread_local] = ACTIONS(2809),
    [anon_sym___thread] = ACTIONS(2809),
    [anon_sym_const] = ACTIONS(2809),
    [anon_sym_constexpr] = ACTIONS(2809),
    [anon_sym_volatile] = ACTIONS(2809),
    [anon_sym_restrict] = ACTIONS(2809),
    [anon_sym___restrict__] = ACTIONS(2809),
    [anon_sym__Atomic] = ACTIONS(2809),
    [anon_sym__Noreturn] = ACTIONS(2809),
    [anon_sym_noreturn] = ACTIONS(2809),
    [anon_sym_mutable] = ACTIONS(2809),
    [anon_sym_constinit] = ACTIONS(2809),
    [anon_sym_consteval] = ACTIONS(2809),
    [anon_sym_PROGMEM] = ACTIONS(2809),
    [aux_sym_primitive_type_token1] = ACTIONS(2809),
    [anon_sym_byte] = ACTIONS(2809),
    [anon_sym_word] = ACTIONS(2809),
    [anon_sym_enum] = ACTIONS(2809),
    [anon_sym_class] = ACTIONS(2809),
    [anon_sym_struct] = ACTIONS(2809),
    [anon_sym_union] = ACTIONS(2809),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2809),
    [anon_sym_decltype] = ACTIONS(2809),
    [anon_sym_virtual] = ACTIONS(2809),
    [anon_sym_alignas] = ACTIONS(2809),
    [anon_sym_explicit] = ACTIONS(2809),
    [anon_sym_typename] = ACTIONS(2809),
    [anon_sym_template] = ACTIONS(2809),
    [anon_sym_operator] = ACTIONS(2809),
    [anon_sym_friend] = ACTIONS(2809),
    [anon_sym_public] = ACTIONS(2809),
    [anon_sym_private] = ACTIONS(2809),
    [anon_sym_protected] = ACTIONS(2809),
    [anon_sym_using] = ACTIONS(2809),
    [anon_sym_static_assert] = ACTIONS(2809),
  },
  [2162] = {
    [sym_identifier] = ACTIONS(2885),
    [aux_sym_preproc_def_token1] = ACTIONS(2885),
    [aux_sym_preproc_if_token1] = ACTIONS(2885),
    [aux_sym_preproc_if_token2] = ACTIONS(2885),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2885),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2885),
    [sym_preproc_directive] = ACTIONS(2885),
    [anon_sym_LPAREN2] = ACTIONS(2887),
    [anon_sym_TILDE] = ACTIONS(2887),
    [anon_sym_STAR] = ACTIONS(2887),
    [anon_sym_AMP_AMP] = ACTIONS(2887),
    [anon_sym_AMP] = ACTIONS(2885),
    [anon_sym___extension__] = ACTIONS(2885),
    [anon_sym_typedef] = ACTIONS(2885),
    [anon_sym_extern] = ACTIONS(2885),
    [anon_sym___attribute__] = ACTIONS(2885),
    [anon_sym_COLON_COLON] = ACTIONS(2887),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2887),
    [anon_sym___declspec] = ACTIONS(2885),
    [anon_sym___based] = ACTIONS(2885),
    [anon_sym_signed] = ACTIONS(2885),
    [anon_sym_unsigned] = ACTIONS(2885),
    [anon_sym_long] = ACTIONS(2885),
    [anon_sym_short] = ACTIONS(2885),
    [anon_sym_LBRACK] = ACTIONS(2885),
    [anon_sym_static] = ACTIONS(2885),
    [anon_sym_register] = ACTIONS(2885),
    [anon_sym_inline] = ACTIONS(2885),
    [anon_sym___inline] = ACTIONS(2885),
    [anon_sym___inline__] = ACTIONS(2885),
    [anon_sym___forceinline] = ACTIONS(2885),
    [anon_sym_thread_local] = ACTIONS(2885),
    [anon_sym___thread] = ACTIONS(2885),
    [anon_sym_const] = ACTIONS(2885),
    [anon_sym_constexpr] = ACTIONS(2885),
    [anon_sym_volatile] = ACTIONS(2885),
    [anon_sym_restrict] = ACTIONS(2885),
    [anon_sym___restrict__] = ACTIONS(2885),
    [anon_sym__Atomic] = ACTIONS(2885),
    [anon_sym__Noreturn] = ACTIONS(2885),
    [anon_sym_noreturn] = ACTIONS(2885),
    [anon_sym_mutable] = ACTIONS(2885),
    [anon_sym_constinit] = ACTIONS(2885),
    [anon_sym_consteval] = ACTIONS(2885),
    [anon_sym_PROGMEM] = ACTIONS(2885),
    [aux_sym_primitive_type_token1] = ACTIONS(2885),
    [anon_sym_byte] = ACTIONS(2885),
    [anon_sym_word] = ACTIONS(2885),
    [anon_sym_enum] = ACTIONS(2885),
    [anon_sym_class] = ACTIONS(2885),
    [anon_sym_struct] = ACTIONS(2885),
    [anon_sym_union] = ACTIONS(2885),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2885),
    [anon_sym_decltype] = ACTIONS(2885),
    [anon_sym_virtual] = ACTIONS(2885),
    [anon_sym_alignas] = ACTIONS(2885),
    [anon_sym_explicit] = ACTIONS(2885),
    [anon_sym_typename] = ACTIONS(2885),
    [anon_sym_template] = ACTIONS(2885),
    [anon_sym_operator] = ACTIONS(2885),
    [anon_sym_friend] = ACTIONS(2885),
    [anon_sym_public] = ACTIONS(2885),
    [anon_sym_private] = ACTIONS(2885),
    [anon_sym_protected] = ACTIONS(2885),
    [anon_sym_using] = ACTIONS(2885),
    [anon_sym_static_assert] = ACTIONS(2885),
  },
  [2163] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym_RBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_friend] = ACTIONS(3072),
    [anon_sym_public] = ACTIONS(3072),
    [anon_sym_private] = ACTIONS(3072),
    [anon_sym_protected] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
  },
  [2164] = {
    [sym_primitive_type] = STATE(2515),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2285),
    [sym_identifier] = ACTIONS(5334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4934),
    [anon_sym_COMMA] = ACTIONS(4934),
    [anon_sym_LPAREN2] = ACTIONS(4934),
    [anon_sym_DASH] = ACTIONS(4936),
    [anon_sym_PLUS] = ACTIONS(4936),
    [anon_sym_STAR] = ACTIONS(4934),
    [anon_sym_SLASH] = ACTIONS(4936),
    [anon_sym_PERCENT] = ACTIONS(4934),
    [anon_sym_PIPE_PIPE] = ACTIONS(4934),
    [anon_sym_AMP_AMP] = ACTIONS(4934),
    [anon_sym_PIPE] = ACTIONS(4936),
    [anon_sym_CARET] = ACTIONS(4934),
    [anon_sym_AMP] = ACTIONS(4936),
    [anon_sym_EQ_EQ] = ACTIONS(4934),
    [anon_sym_BANG_EQ] = ACTIONS(4934),
    [anon_sym_GT] = ACTIONS(4936),
    [anon_sym_GT_EQ] = ACTIONS(4936),
    [anon_sym_LT_EQ] = ACTIONS(4936),
    [anon_sym_LT] = ACTIONS(4936),
    [anon_sym_LT_LT] = ACTIONS(4934),
    [anon_sym_GT_GT] = ACTIONS(4936),
    [anon_sym___extension__] = ACTIONS(4936),
    [anon_sym___attribute__] = ACTIONS(4936),
    [anon_sym_LBRACE] = ACTIONS(4934),
    [anon_sym_signed] = ACTIONS(5336),
    [anon_sym_unsigned] = ACTIONS(5336),
    [anon_sym_long] = ACTIONS(5336),
    [anon_sym_short] = ACTIONS(5336),
    [anon_sym_LBRACK] = ACTIONS(4934),
    [anon_sym_const] = ACTIONS(4936),
    [anon_sym_constexpr] = ACTIONS(4936),
    [anon_sym_volatile] = ACTIONS(4936),
    [anon_sym_restrict] = ACTIONS(4936),
    [anon_sym___restrict__] = ACTIONS(4936),
    [anon_sym__Atomic] = ACTIONS(4936),
    [anon_sym__Noreturn] = ACTIONS(4936),
    [anon_sym_noreturn] = ACTIONS(4936),
    [anon_sym_mutable] = ACTIONS(4936),
    [anon_sym_constinit] = ACTIONS(4936),
    [anon_sym_consteval] = ACTIONS(4936),
    [anon_sym_PROGMEM] = ACTIONS(4936),
    [aux_sym_primitive_type_token1] = ACTIONS(2587),
    [anon_sym_byte] = ACTIONS(2587),
    [anon_sym_word] = ACTIONS(2587),
    [anon_sym_QMARK] = ACTIONS(4934),
    [anon_sym_LT_EQ_GT] = ACTIONS(4934),
    [anon_sym_or] = ACTIONS(4936),
    [anon_sym_and] = ACTIONS(4936),
    [anon_sym_bitor] = ACTIONS(4936),
    [anon_sym_xor] = ACTIONS(4936),
    [anon_sym_bitand] = ACTIONS(4936),
    [anon_sym_not_eq] = ACTIONS(4936),
    [anon_sym_DASH_DASH] = ACTIONS(4934),
    [anon_sym_PLUS_PLUS] = ACTIONS(4934),
    [anon_sym_DOT] = ACTIONS(4936),
    [anon_sym_DOT_STAR] = ACTIONS(4934),
    [anon_sym_DASH_GT] = ACTIONS(4934),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4936),
    [anon_sym_decltype] = ACTIONS(4936),
    [anon_sym_final] = ACTIONS(4936),
    [anon_sym_override] = ACTIONS(4936),
    [anon_sym_GT2] = ACTIONS(4934),
    [anon_sym_requires] = ACTIONS(4936),
  },
  [2165] = {
    [sym_identifier] = ACTIONS(2809),
    [aux_sym_preproc_def_token1] = ACTIONS(2809),
    [aux_sym_preproc_if_token1] = ACTIONS(2809),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2809),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2809),
    [sym_preproc_directive] = ACTIONS(2809),
    [anon_sym_LPAREN2] = ACTIONS(2811),
    [anon_sym_TILDE] = ACTIONS(2811),
    [anon_sym_STAR] = ACTIONS(2811),
    [anon_sym_AMP_AMP] = ACTIONS(2811),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym___extension__] = ACTIONS(2809),
    [anon_sym_typedef] = ACTIONS(2809),
    [anon_sym_extern] = ACTIONS(2809),
    [anon_sym___attribute__] = ACTIONS(2809),
    [anon_sym_COLON_COLON] = ACTIONS(2811),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2811),
    [anon_sym___declspec] = ACTIONS(2809),
    [anon_sym___based] = ACTIONS(2809),
    [anon_sym_RBRACE] = ACTIONS(2811),
    [anon_sym_signed] = ACTIONS(2809),
    [anon_sym_unsigned] = ACTIONS(2809),
    [anon_sym_long] = ACTIONS(2809),
    [anon_sym_short] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2809),
    [anon_sym_static] = ACTIONS(2809),
    [anon_sym_register] = ACTIONS(2809),
    [anon_sym_inline] = ACTIONS(2809),
    [anon_sym___inline] = ACTIONS(2809),
    [anon_sym___inline__] = ACTIONS(2809),
    [anon_sym___forceinline] = ACTIONS(2809),
    [anon_sym_thread_local] = ACTIONS(2809),
    [anon_sym___thread] = ACTIONS(2809),
    [anon_sym_const] = ACTIONS(2809),
    [anon_sym_constexpr] = ACTIONS(2809),
    [anon_sym_volatile] = ACTIONS(2809),
    [anon_sym_restrict] = ACTIONS(2809),
    [anon_sym___restrict__] = ACTIONS(2809),
    [anon_sym__Atomic] = ACTIONS(2809),
    [anon_sym__Noreturn] = ACTIONS(2809),
    [anon_sym_noreturn] = ACTIONS(2809),
    [anon_sym_mutable] = ACTIONS(2809),
    [anon_sym_constinit] = ACTIONS(2809),
    [anon_sym_consteval] = ACTIONS(2809),
    [anon_sym_PROGMEM] = ACTIONS(2809),
    [aux_sym_primitive_type_token1] = ACTIONS(2809),
    [anon_sym_byte] = ACTIONS(2809),
    [anon_sym_word] = ACTIONS(2809),
    [anon_sym_enum] = ACTIONS(2809),
    [anon_sym_class] = ACTIONS(2809),
    [anon_sym_struct] = ACTIONS(2809),
    [anon_sym_union] = ACTIONS(2809),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2809),
    [anon_sym_decltype] = ACTIONS(2809),
    [anon_sym_virtual] = ACTIONS(2809),
    [anon_sym_alignas] = ACTIONS(2809),
    [anon_sym_explicit] = ACTIONS(2809),
    [anon_sym_typename] = ACTIONS(2809),
    [anon_sym_template] = ACTIONS(2809),
    [anon_sym_operator] = ACTIONS(2809),
    [anon_sym_friend] = ACTIONS(2809),
    [anon_sym_public] = ACTIONS(2809),
    [anon_sym_private] = ACTIONS(2809),
    [anon_sym_protected] = ACTIONS(2809),
    [anon_sym_using] = ACTIONS(2809),
    [anon_sym_static_assert] = ACTIONS(2809),
  },
  [2166] = {
    [sym_identifier] = ACTIONS(2877),
    [aux_sym_preproc_def_token1] = ACTIONS(2877),
    [aux_sym_preproc_if_token1] = ACTIONS(2877),
    [aux_sym_preproc_if_token2] = ACTIONS(2877),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2877),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2877),
    [sym_preproc_directive] = ACTIONS(2877),
    [anon_sym_LPAREN2] = ACTIONS(2879),
    [anon_sym_TILDE] = ACTIONS(2879),
    [anon_sym_STAR] = ACTIONS(2879),
    [anon_sym_AMP_AMP] = ACTIONS(2879),
    [anon_sym_AMP] = ACTIONS(2877),
    [anon_sym___extension__] = ACTIONS(2877),
    [anon_sym_typedef] = ACTIONS(2877),
    [anon_sym_extern] = ACTIONS(2877),
    [anon_sym___attribute__] = ACTIONS(2877),
    [anon_sym_COLON_COLON] = ACTIONS(2879),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2879),
    [anon_sym___declspec] = ACTIONS(2877),
    [anon_sym___based] = ACTIONS(2877),
    [anon_sym_signed] = ACTIONS(2877),
    [anon_sym_unsigned] = ACTIONS(2877),
    [anon_sym_long] = ACTIONS(2877),
    [anon_sym_short] = ACTIONS(2877),
    [anon_sym_LBRACK] = ACTIONS(2877),
    [anon_sym_static] = ACTIONS(2877),
    [anon_sym_register] = ACTIONS(2877),
    [anon_sym_inline] = ACTIONS(2877),
    [anon_sym___inline] = ACTIONS(2877),
    [anon_sym___inline__] = ACTIONS(2877),
    [anon_sym___forceinline] = ACTIONS(2877),
    [anon_sym_thread_local] = ACTIONS(2877),
    [anon_sym___thread] = ACTIONS(2877),
    [anon_sym_const] = ACTIONS(2877),
    [anon_sym_constexpr] = ACTIONS(2877),
    [anon_sym_volatile] = ACTIONS(2877),
    [anon_sym_restrict] = ACTIONS(2877),
    [anon_sym___restrict__] = ACTIONS(2877),
    [anon_sym__Atomic] = ACTIONS(2877),
    [anon_sym__Noreturn] = ACTIONS(2877),
    [anon_sym_noreturn] = ACTIONS(2877),
    [anon_sym_mutable] = ACTIONS(2877),
    [anon_sym_constinit] = ACTIONS(2877),
    [anon_sym_consteval] = ACTIONS(2877),
    [anon_sym_PROGMEM] = ACTIONS(2877),
    [aux_sym_primitive_type_token1] = ACTIONS(2877),
    [anon_sym_byte] = ACTIONS(2877),
    [anon_sym_word] = ACTIONS(2877),
    [anon_sym_enum] = ACTIONS(2877),
    [anon_sym_class] = ACTIONS(2877),
    [anon_sym_struct] = ACTIONS(2877),
    [anon_sym_union] = ACTIONS(2877),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2877),
    [anon_sym_decltype] = ACTIONS(2877),
    [anon_sym_virtual] = ACTIONS(2877),
    [anon_sym_alignas] = ACTIONS(2877),
    [anon_sym_explicit] = ACTIONS(2877),
    [anon_sym_typename] = ACTIONS(2877),
    [anon_sym_template] = ACTIONS(2877),
    [anon_sym_operator] = ACTIONS(2877),
    [anon_sym_friend] = ACTIONS(2877),
    [anon_sym_public] = ACTIONS(2877),
    [anon_sym_private] = ACTIONS(2877),
    [anon_sym_protected] = ACTIONS(2877),
    [anon_sym_using] = ACTIONS(2877),
    [anon_sym_static_assert] = ACTIONS(2877),
  },
  [2167] = {
    [sym_identifier] = ACTIONS(2885),
    [aux_sym_preproc_def_token1] = ACTIONS(2885),
    [aux_sym_preproc_if_token1] = ACTIONS(2885),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2885),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2885),
    [sym_preproc_directive] = ACTIONS(2885),
    [anon_sym_LPAREN2] = ACTIONS(2887),
    [anon_sym_TILDE] = ACTIONS(2887),
    [anon_sym_STAR] = ACTIONS(2887),
    [anon_sym_AMP_AMP] = ACTIONS(2887),
    [anon_sym_AMP] = ACTIONS(2885),
    [anon_sym___extension__] = ACTIONS(2885),
    [anon_sym_typedef] = ACTIONS(2885),
    [anon_sym_extern] = ACTIONS(2885),
    [anon_sym___attribute__] = ACTIONS(2885),
    [anon_sym_COLON_COLON] = ACTIONS(2887),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2887),
    [anon_sym___declspec] = ACTIONS(2885),
    [anon_sym___based] = ACTIONS(2885),
    [anon_sym_RBRACE] = ACTIONS(2887),
    [anon_sym_signed] = ACTIONS(2885),
    [anon_sym_unsigned] = ACTIONS(2885),
    [anon_sym_long] = ACTIONS(2885),
    [anon_sym_short] = ACTIONS(2885),
    [anon_sym_LBRACK] = ACTIONS(2885),
    [anon_sym_static] = ACTIONS(2885),
    [anon_sym_register] = ACTIONS(2885),
    [anon_sym_inline] = ACTIONS(2885),
    [anon_sym___inline] = ACTIONS(2885),
    [anon_sym___inline__] = ACTIONS(2885),
    [anon_sym___forceinline] = ACTIONS(2885),
    [anon_sym_thread_local] = ACTIONS(2885),
    [anon_sym___thread] = ACTIONS(2885),
    [anon_sym_const] = ACTIONS(2885),
    [anon_sym_constexpr] = ACTIONS(2885),
    [anon_sym_volatile] = ACTIONS(2885),
    [anon_sym_restrict] = ACTIONS(2885),
    [anon_sym___restrict__] = ACTIONS(2885),
    [anon_sym__Atomic] = ACTIONS(2885),
    [anon_sym__Noreturn] = ACTIONS(2885),
    [anon_sym_noreturn] = ACTIONS(2885),
    [anon_sym_mutable] = ACTIONS(2885),
    [anon_sym_constinit] = ACTIONS(2885),
    [anon_sym_consteval] = ACTIONS(2885),
    [anon_sym_PROGMEM] = ACTIONS(2885),
    [aux_sym_primitive_type_token1] = ACTIONS(2885),
    [anon_sym_byte] = ACTIONS(2885),
    [anon_sym_word] = ACTIONS(2885),
    [anon_sym_enum] = ACTIONS(2885),
    [anon_sym_class] = ACTIONS(2885),
    [anon_sym_struct] = ACTIONS(2885),
    [anon_sym_union] = ACTIONS(2885),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2885),
    [anon_sym_decltype] = ACTIONS(2885),
    [anon_sym_virtual] = ACTIONS(2885),
    [anon_sym_alignas] = ACTIONS(2885),
    [anon_sym_explicit] = ACTIONS(2885),
    [anon_sym_typename] = ACTIONS(2885),
    [anon_sym_template] = ACTIONS(2885),
    [anon_sym_operator] = ACTIONS(2885),
    [anon_sym_friend] = ACTIONS(2885),
    [anon_sym_public] = ACTIONS(2885),
    [anon_sym_private] = ACTIONS(2885),
    [anon_sym_protected] = ACTIONS(2885),
    [anon_sym_using] = ACTIONS(2885),
    [anon_sym_static_assert] = ACTIONS(2885),
  },
  [2168] = {
    [sym_identifier] = ACTIONS(4944),
    [aux_sym_preproc_def_token1] = ACTIONS(4944),
    [aux_sym_preproc_if_token1] = ACTIONS(4944),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4944),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4944),
    [sym_preproc_directive] = ACTIONS(4944),
    [anon_sym_LPAREN2] = ACTIONS(4946),
    [anon_sym_TILDE] = ACTIONS(4946),
    [anon_sym_STAR] = ACTIONS(4946),
    [anon_sym_AMP_AMP] = ACTIONS(4946),
    [anon_sym_AMP] = ACTIONS(4944),
    [anon_sym___extension__] = ACTIONS(4944),
    [anon_sym_typedef] = ACTIONS(4944),
    [anon_sym_extern] = ACTIONS(4944),
    [anon_sym___attribute__] = ACTIONS(4944),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4946),
    [anon_sym___declspec] = ACTIONS(4944),
    [anon_sym___based] = ACTIONS(4944),
    [anon_sym_RBRACE] = ACTIONS(4946),
    [anon_sym_signed] = ACTIONS(4944),
    [anon_sym_unsigned] = ACTIONS(4944),
    [anon_sym_long] = ACTIONS(4944),
    [anon_sym_short] = ACTIONS(4944),
    [anon_sym_LBRACK] = ACTIONS(4944),
    [anon_sym_static] = ACTIONS(4944),
    [anon_sym_register] = ACTIONS(4944),
    [anon_sym_inline] = ACTIONS(4944),
    [anon_sym___inline] = ACTIONS(4944),
    [anon_sym___inline__] = ACTIONS(4944),
    [anon_sym___forceinline] = ACTIONS(4944),
    [anon_sym_thread_local] = ACTIONS(4944),
    [anon_sym___thread] = ACTIONS(4944),
    [anon_sym_const] = ACTIONS(4944),
    [anon_sym_constexpr] = ACTIONS(4944),
    [anon_sym_volatile] = ACTIONS(4944),
    [anon_sym_restrict] = ACTIONS(4944),
    [anon_sym___restrict__] = ACTIONS(4944),
    [anon_sym__Atomic] = ACTIONS(4944),
    [anon_sym__Noreturn] = ACTIONS(4944),
    [anon_sym_noreturn] = ACTIONS(4944),
    [anon_sym_mutable] = ACTIONS(4944),
    [anon_sym_constinit] = ACTIONS(4944),
    [anon_sym_consteval] = ACTIONS(4944),
    [anon_sym_PROGMEM] = ACTIONS(4944),
    [aux_sym_primitive_type_token1] = ACTIONS(4944),
    [anon_sym_byte] = ACTIONS(4944),
    [anon_sym_word] = ACTIONS(4944),
    [anon_sym_enum] = ACTIONS(4944),
    [anon_sym_class] = ACTIONS(4944),
    [anon_sym_struct] = ACTIONS(4944),
    [anon_sym_union] = ACTIONS(4944),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4944),
    [anon_sym_decltype] = ACTIONS(4944),
    [anon_sym_virtual] = ACTIONS(4944),
    [anon_sym_alignas] = ACTIONS(4944),
    [anon_sym_explicit] = ACTIONS(4944),
    [anon_sym_typename] = ACTIONS(4944),
    [anon_sym_template] = ACTIONS(4944),
    [anon_sym_operator] = ACTIONS(4944),
    [anon_sym_friend] = ACTIONS(4944),
    [anon_sym_public] = ACTIONS(4944),
    [anon_sym_private] = ACTIONS(4944),
    [anon_sym_protected] = ACTIONS(4944),
    [anon_sym_using] = ACTIONS(4944),
    [anon_sym_static_assert] = ACTIONS(4944),
  },
  [2169] = {
    [sym_identifier] = ACTIONS(4944),
    [aux_sym_preproc_def_token1] = ACTIONS(4944),
    [aux_sym_preproc_if_token1] = ACTIONS(4944),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4944),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4944),
    [sym_preproc_directive] = ACTIONS(4944),
    [anon_sym_LPAREN2] = ACTIONS(4946),
    [anon_sym_TILDE] = ACTIONS(4946),
    [anon_sym_STAR] = ACTIONS(4946),
    [anon_sym_AMP_AMP] = ACTIONS(4946),
    [anon_sym_AMP] = ACTIONS(4944),
    [anon_sym___extension__] = ACTIONS(4944),
    [anon_sym_typedef] = ACTIONS(4944),
    [anon_sym_extern] = ACTIONS(4944),
    [anon_sym___attribute__] = ACTIONS(4944),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4946),
    [anon_sym___declspec] = ACTIONS(4944),
    [anon_sym___based] = ACTIONS(4944),
    [anon_sym_RBRACE] = ACTIONS(4946),
    [anon_sym_signed] = ACTIONS(4944),
    [anon_sym_unsigned] = ACTIONS(4944),
    [anon_sym_long] = ACTIONS(4944),
    [anon_sym_short] = ACTIONS(4944),
    [anon_sym_LBRACK] = ACTIONS(4944),
    [anon_sym_static] = ACTIONS(4944),
    [anon_sym_register] = ACTIONS(4944),
    [anon_sym_inline] = ACTIONS(4944),
    [anon_sym___inline] = ACTIONS(4944),
    [anon_sym___inline__] = ACTIONS(4944),
    [anon_sym___forceinline] = ACTIONS(4944),
    [anon_sym_thread_local] = ACTIONS(4944),
    [anon_sym___thread] = ACTIONS(4944),
    [anon_sym_const] = ACTIONS(4944),
    [anon_sym_constexpr] = ACTIONS(4944),
    [anon_sym_volatile] = ACTIONS(4944),
    [anon_sym_restrict] = ACTIONS(4944),
    [anon_sym___restrict__] = ACTIONS(4944),
    [anon_sym__Atomic] = ACTIONS(4944),
    [anon_sym__Noreturn] = ACTIONS(4944),
    [anon_sym_noreturn] = ACTIONS(4944),
    [anon_sym_mutable] = ACTIONS(4944),
    [anon_sym_constinit] = ACTIONS(4944),
    [anon_sym_consteval] = ACTIONS(4944),
    [anon_sym_PROGMEM] = ACTIONS(4944),
    [aux_sym_primitive_type_token1] = ACTIONS(4944),
    [anon_sym_byte] = ACTIONS(4944),
    [anon_sym_word] = ACTIONS(4944),
    [anon_sym_enum] = ACTIONS(4944),
    [anon_sym_class] = ACTIONS(4944),
    [anon_sym_struct] = ACTIONS(4944),
    [anon_sym_union] = ACTIONS(4944),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4944),
    [anon_sym_decltype] = ACTIONS(4944),
    [anon_sym_virtual] = ACTIONS(4944),
    [anon_sym_alignas] = ACTIONS(4944),
    [anon_sym_explicit] = ACTIONS(4944),
    [anon_sym_typename] = ACTIONS(4944),
    [anon_sym_template] = ACTIONS(4944),
    [anon_sym_operator] = ACTIONS(4944),
    [anon_sym_friend] = ACTIONS(4944),
    [anon_sym_public] = ACTIONS(4944),
    [anon_sym_private] = ACTIONS(4944),
    [anon_sym_protected] = ACTIONS(4944),
    [anon_sym_using] = ACTIONS(4944),
    [anon_sym_static_assert] = ACTIONS(4944),
  },
  [2170] = {
    [sym_identifier] = ACTIONS(4992),
    [aux_sym_preproc_def_token1] = ACTIONS(4992),
    [aux_sym_preproc_if_token1] = ACTIONS(4992),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4992),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4992),
    [sym_preproc_directive] = ACTIONS(4992),
    [anon_sym_LPAREN2] = ACTIONS(4994),
    [anon_sym_TILDE] = ACTIONS(4994),
    [anon_sym_STAR] = ACTIONS(4994),
    [anon_sym_AMP_AMP] = ACTIONS(4994),
    [anon_sym_AMP] = ACTIONS(4992),
    [anon_sym___extension__] = ACTIONS(4992),
    [anon_sym_typedef] = ACTIONS(4992),
    [anon_sym_extern] = ACTIONS(4992),
    [anon_sym___attribute__] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4994),
    [anon_sym___declspec] = ACTIONS(4992),
    [anon_sym___based] = ACTIONS(4992),
    [anon_sym_RBRACE] = ACTIONS(4994),
    [anon_sym_signed] = ACTIONS(4992),
    [anon_sym_unsigned] = ACTIONS(4992),
    [anon_sym_long] = ACTIONS(4992),
    [anon_sym_short] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4992),
    [anon_sym_static] = ACTIONS(4992),
    [anon_sym_register] = ACTIONS(4992),
    [anon_sym_inline] = ACTIONS(4992),
    [anon_sym___inline] = ACTIONS(4992),
    [anon_sym___inline__] = ACTIONS(4992),
    [anon_sym___forceinline] = ACTIONS(4992),
    [anon_sym_thread_local] = ACTIONS(4992),
    [anon_sym___thread] = ACTIONS(4992),
    [anon_sym_const] = ACTIONS(4992),
    [anon_sym_constexpr] = ACTIONS(4992),
    [anon_sym_volatile] = ACTIONS(4992),
    [anon_sym_restrict] = ACTIONS(4992),
    [anon_sym___restrict__] = ACTIONS(4992),
    [anon_sym__Atomic] = ACTIONS(4992),
    [anon_sym__Noreturn] = ACTIONS(4992),
    [anon_sym_noreturn] = ACTIONS(4992),
    [anon_sym_mutable] = ACTIONS(4992),
    [anon_sym_constinit] = ACTIONS(4992),
    [anon_sym_consteval] = ACTIONS(4992),
    [anon_sym_PROGMEM] = ACTIONS(4992),
    [aux_sym_primitive_type_token1] = ACTIONS(4992),
    [anon_sym_byte] = ACTIONS(4992),
    [anon_sym_word] = ACTIONS(4992),
    [anon_sym_enum] = ACTIONS(4992),
    [anon_sym_class] = ACTIONS(4992),
    [anon_sym_struct] = ACTIONS(4992),
    [anon_sym_union] = ACTIONS(4992),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4992),
    [anon_sym_decltype] = ACTIONS(4992),
    [anon_sym_virtual] = ACTIONS(4992),
    [anon_sym_alignas] = ACTIONS(4992),
    [anon_sym_explicit] = ACTIONS(4992),
    [anon_sym_typename] = ACTIONS(4992),
    [anon_sym_template] = ACTIONS(4992),
    [anon_sym_operator] = ACTIONS(4992),
    [anon_sym_friend] = ACTIONS(4992),
    [anon_sym_public] = ACTIONS(4992),
    [anon_sym_private] = ACTIONS(4992),
    [anon_sym_protected] = ACTIONS(4992),
    [anon_sym_using] = ACTIONS(4992),
    [anon_sym_static_assert] = ACTIONS(4992),
  },
  [2171] = {
    [sym_identifier] = ACTIONS(2735),
    [aux_sym_preproc_def_token1] = ACTIONS(2735),
    [aux_sym_preproc_if_token1] = ACTIONS(2735),
    [aux_sym_preproc_if_token2] = ACTIONS(2735),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2735),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2735),
    [sym_preproc_directive] = ACTIONS(2735),
    [anon_sym_LPAREN2] = ACTIONS(2737),
    [anon_sym_TILDE] = ACTIONS(2737),
    [anon_sym_STAR] = ACTIONS(2737),
    [anon_sym_AMP_AMP] = ACTIONS(2737),
    [anon_sym_AMP] = ACTIONS(2735),
    [anon_sym___extension__] = ACTIONS(2735),
    [anon_sym_typedef] = ACTIONS(2735),
    [anon_sym_extern] = ACTIONS(2735),
    [anon_sym___attribute__] = ACTIONS(2735),
    [anon_sym_COLON_COLON] = ACTIONS(2737),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2737),
    [anon_sym___declspec] = ACTIONS(2735),
    [anon_sym___based] = ACTIONS(2735),
    [anon_sym_signed] = ACTIONS(2735),
    [anon_sym_unsigned] = ACTIONS(2735),
    [anon_sym_long] = ACTIONS(2735),
    [anon_sym_short] = ACTIONS(2735),
    [anon_sym_LBRACK] = ACTIONS(2735),
    [anon_sym_static] = ACTIONS(2735),
    [anon_sym_register] = ACTIONS(2735),
    [anon_sym_inline] = ACTIONS(2735),
    [anon_sym___inline] = ACTIONS(2735),
    [anon_sym___inline__] = ACTIONS(2735),
    [anon_sym___forceinline] = ACTIONS(2735),
    [anon_sym_thread_local] = ACTIONS(2735),
    [anon_sym___thread] = ACTIONS(2735),
    [anon_sym_const] = ACTIONS(2735),
    [anon_sym_constexpr] = ACTIONS(2735),
    [anon_sym_volatile] = ACTIONS(2735),
    [anon_sym_restrict] = ACTIONS(2735),
    [anon_sym___restrict__] = ACTIONS(2735),
    [anon_sym__Atomic] = ACTIONS(2735),
    [anon_sym__Noreturn] = ACTIONS(2735),
    [anon_sym_noreturn] = ACTIONS(2735),
    [anon_sym_mutable] = ACTIONS(2735),
    [anon_sym_constinit] = ACTIONS(2735),
    [anon_sym_consteval] = ACTIONS(2735),
    [anon_sym_PROGMEM] = ACTIONS(2735),
    [aux_sym_primitive_type_token1] = ACTIONS(2735),
    [anon_sym_byte] = ACTIONS(2735),
    [anon_sym_word] = ACTIONS(2735),
    [anon_sym_enum] = ACTIONS(2735),
    [anon_sym_class] = ACTIONS(2735),
    [anon_sym_struct] = ACTIONS(2735),
    [anon_sym_union] = ACTIONS(2735),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2735),
    [anon_sym_decltype] = ACTIONS(2735),
    [anon_sym_virtual] = ACTIONS(2735),
    [anon_sym_alignas] = ACTIONS(2735),
    [anon_sym_explicit] = ACTIONS(2735),
    [anon_sym_typename] = ACTIONS(2735),
    [anon_sym_template] = ACTIONS(2735),
    [anon_sym_operator] = ACTIONS(2735),
    [anon_sym_friend] = ACTIONS(2735),
    [anon_sym_public] = ACTIONS(2735),
    [anon_sym_private] = ACTIONS(2735),
    [anon_sym_protected] = ACTIONS(2735),
    [anon_sym_using] = ACTIONS(2735),
    [anon_sym_static_assert] = ACTIONS(2735),
  },
  [2172] = {
    [sym_string_literal] = STATE(2617),
    [sym_template_argument_list] = STATE(3723),
    [sym_raw_string_literal] = STATE(2617),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3761),
    [anon_sym_COMMA] = ACTIONS(3761),
    [anon_sym_LPAREN2] = ACTIONS(3761),
    [anon_sym_DASH] = ACTIONS(3769),
    [anon_sym_PLUS] = ACTIONS(3769),
    [anon_sym_STAR] = ACTIONS(3769),
    [anon_sym_SLASH] = ACTIONS(3769),
    [anon_sym_PERCENT] = ACTIONS(3769),
    [anon_sym_PIPE_PIPE] = ACTIONS(3761),
    [anon_sym_AMP_AMP] = ACTIONS(3761),
    [anon_sym_PIPE] = ACTIONS(3769),
    [anon_sym_CARET] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(3769),
    [anon_sym_EQ_EQ] = ACTIONS(3761),
    [anon_sym_BANG_EQ] = ACTIONS(3761),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3761),
    [anon_sym_LT_EQ] = ACTIONS(3769),
    [anon_sym_LT] = ACTIONS(5242),
    [anon_sym_LT_LT] = ACTIONS(3769),
    [anon_sym_GT_GT] = ACTIONS(3769),
    [anon_sym_SEMI] = ACTIONS(3761),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(3785),
    [anon_sym_LBRACK] = ACTIONS(3761),
    [anon_sym_EQ] = ACTIONS(3793),
    [anon_sym_COLON] = ACTIONS(3819),
    [anon_sym_QMARK] = ACTIONS(3761),
    [anon_sym_STAR_EQ] = ACTIONS(3797),
    [anon_sym_SLASH_EQ] = ACTIONS(3797),
    [anon_sym_PERCENT_EQ] = ACTIONS(3797),
    [anon_sym_PLUS_EQ] = ACTIONS(3797),
    [anon_sym_DASH_EQ] = ACTIONS(3797),
    [anon_sym_LT_LT_EQ] = ACTIONS(3797),
    [anon_sym_GT_GT_EQ] = ACTIONS(3797),
    [anon_sym_AMP_EQ] = ACTIONS(3797),
    [anon_sym_CARET_EQ] = ACTIONS(3797),
    [anon_sym_PIPE_EQ] = ACTIONS(3797),
    [anon_sym_and_eq] = ACTIONS(3797),
    [anon_sym_or_eq] = ACTIONS(3797),
    [anon_sym_xor_eq] = ACTIONS(3797),
    [anon_sym_LT_EQ_GT] = ACTIONS(3761),
    [anon_sym_or] = ACTIONS(3769),
    [anon_sym_and] = ACTIONS(3769),
    [anon_sym_bitor] = ACTIONS(3761),
    [anon_sym_xor] = ACTIONS(3769),
    [anon_sym_bitand] = ACTIONS(3761),
    [anon_sym_not_eq] = ACTIONS(3761),
    [anon_sym_DASH_DASH] = ACTIONS(3761),
    [anon_sym_PLUS_PLUS] = ACTIONS(3761),
    [anon_sym_DOT] = ACTIONS(3769),
    [anon_sym_DOT_STAR] = ACTIONS(3761),
    [anon_sym_DASH_GT] = ACTIONS(3761),
    [anon_sym_L_DQUOTE] = ACTIONS(3204),
    [anon_sym_u_DQUOTE] = ACTIONS(3204),
    [anon_sym_U_DQUOTE] = ACTIONS(3204),
    [anon_sym_u8_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3204),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3208),
    [anon_sym_LR_DQUOTE] = ACTIONS(3208),
    [anon_sym_uR_DQUOTE] = ACTIONS(3208),
    [anon_sym_UR_DQUOTE] = ACTIONS(3208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3208),
  },
  [2173] = {
    [sym_identifier] = ACTIONS(4863),
    [aux_sym_preproc_def_token1] = ACTIONS(4863),
    [aux_sym_preproc_if_token1] = ACTIONS(4863),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4863),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4863),
    [sym_preproc_directive] = ACTIONS(4863),
    [anon_sym_LPAREN2] = ACTIONS(4865),
    [anon_sym_TILDE] = ACTIONS(4865),
    [anon_sym_STAR] = ACTIONS(4865),
    [anon_sym_AMP_AMP] = ACTIONS(4865),
    [anon_sym_AMP] = ACTIONS(4863),
    [anon_sym___extension__] = ACTIONS(4863),
    [anon_sym_typedef] = ACTIONS(4863),
    [anon_sym_extern] = ACTIONS(4863),
    [anon_sym___attribute__] = ACTIONS(4863),
    [anon_sym_COLON_COLON] = ACTIONS(4865),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4865),
    [anon_sym___declspec] = ACTIONS(4863),
    [anon_sym___based] = ACTIONS(4863),
    [anon_sym_RBRACE] = ACTIONS(4865),
    [anon_sym_signed] = ACTIONS(4863),
    [anon_sym_unsigned] = ACTIONS(4863),
    [anon_sym_long] = ACTIONS(4863),
    [anon_sym_short] = ACTIONS(4863),
    [anon_sym_LBRACK] = ACTIONS(4863),
    [anon_sym_static] = ACTIONS(4863),
    [anon_sym_register] = ACTIONS(4863),
    [anon_sym_inline] = ACTIONS(4863),
    [anon_sym___inline] = ACTIONS(4863),
    [anon_sym___inline__] = ACTIONS(4863),
    [anon_sym___forceinline] = ACTIONS(4863),
    [anon_sym_thread_local] = ACTIONS(4863),
    [anon_sym___thread] = ACTIONS(4863),
    [anon_sym_const] = ACTIONS(4863),
    [anon_sym_constexpr] = ACTIONS(4863),
    [anon_sym_volatile] = ACTIONS(4863),
    [anon_sym_restrict] = ACTIONS(4863),
    [anon_sym___restrict__] = ACTIONS(4863),
    [anon_sym__Atomic] = ACTIONS(4863),
    [anon_sym__Noreturn] = ACTIONS(4863),
    [anon_sym_noreturn] = ACTIONS(4863),
    [anon_sym_mutable] = ACTIONS(4863),
    [anon_sym_constinit] = ACTIONS(4863),
    [anon_sym_consteval] = ACTIONS(4863),
    [anon_sym_PROGMEM] = ACTIONS(4863),
    [aux_sym_primitive_type_token1] = ACTIONS(4863),
    [anon_sym_byte] = ACTIONS(4863),
    [anon_sym_word] = ACTIONS(4863),
    [anon_sym_enum] = ACTIONS(4863),
    [anon_sym_class] = ACTIONS(4863),
    [anon_sym_struct] = ACTIONS(4863),
    [anon_sym_union] = ACTIONS(4863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4863),
    [anon_sym_decltype] = ACTIONS(4863),
    [anon_sym_virtual] = ACTIONS(4863),
    [anon_sym_alignas] = ACTIONS(4863),
    [anon_sym_explicit] = ACTIONS(4863),
    [anon_sym_typename] = ACTIONS(4863),
    [anon_sym_template] = ACTIONS(4863),
    [anon_sym_operator] = ACTIONS(4863),
    [anon_sym_friend] = ACTIONS(4863),
    [anon_sym_public] = ACTIONS(4863),
    [anon_sym_private] = ACTIONS(4863),
    [anon_sym_protected] = ACTIONS(4863),
    [anon_sym_using] = ACTIONS(4863),
    [anon_sym_static_assert] = ACTIONS(4863),
  },
  [2174] = {
    [sym_identifier] = ACTIONS(4948),
    [aux_sym_preproc_def_token1] = ACTIONS(4948),
    [aux_sym_preproc_if_token1] = ACTIONS(4948),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4948),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4948),
    [sym_preproc_directive] = ACTIONS(4948),
    [anon_sym_LPAREN2] = ACTIONS(4950),
    [anon_sym_TILDE] = ACTIONS(4950),
    [anon_sym_STAR] = ACTIONS(4950),
    [anon_sym_AMP_AMP] = ACTIONS(4950),
    [anon_sym_AMP] = ACTIONS(4948),
    [anon_sym___extension__] = ACTIONS(4948),
    [anon_sym_typedef] = ACTIONS(4948),
    [anon_sym_extern] = ACTIONS(4948),
    [anon_sym___attribute__] = ACTIONS(4948),
    [anon_sym_COLON_COLON] = ACTIONS(4950),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4950),
    [anon_sym___declspec] = ACTIONS(4948),
    [anon_sym___based] = ACTIONS(4948),
    [anon_sym_RBRACE] = ACTIONS(4950),
    [anon_sym_signed] = ACTIONS(4948),
    [anon_sym_unsigned] = ACTIONS(4948),
    [anon_sym_long] = ACTIONS(4948),
    [anon_sym_short] = ACTIONS(4948),
    [anon_sym_LBRACK] = ACTIONS(4948),
    [anon_sym_static] = ACTIONS(4948),
    [anon_sym_register] = ACTIONS(4948),
    [anon_sym_inline] = ACTIONS(4948),
    [anon_sym___inline] = ACTIONS(4948),
    [anon_sym___inline__] = ACTIONS(4948),
    [anon_sym___forceinline] = ACTIONS(4948),
    [anon_sym_thread_local] = ACTIONS(4948),
    [anon_sym___thread] = ACTIONS(4948),
    [anon_sym_const] = ACTIONS(4948),
    [anon_sym_constexpr] = ACTIONS(4948),
    [anon_sym_volatile] = ACTIONS(4948),
    [anon_sym_restrict] = ACTIONS(4948),
    [anon_sym___restrict__] = ACTIONS(4948),
    [anon_sym__Atomic] = ACTIONS(4948),
    [anon_sym__Noreturn] = ACTIONS(4948),
    [anon_sym_noreturn] = ACTIONS(4948),
    [anon_sym_mutable] = ACTIONS(4948),
    [anon_sym_constinit] = ACTIONS(4948),
    [anon_sym_consteval] = ACTIONS(4948),
    [anon_sym_PROGMEM] = ACTIONS(4948),
    [aux_sym_primitive_type_token1] = ACTIONS(4948),
    [anon_sym_byte] = ACTIONS(4948),
    [anon_sym_word] = ACTIONS(4948),
    [anon_sym_enum] = ACTIONS(4948),
    [anon_sym_class] = ACTIONS(4948),
    [anon_sym_struct] = ACTIONS(4948),
    [anon_sym_union] = ACTIONS(4948),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4948),
    [anon_sym_decltype] = ACTIONS(4948),
    [anon_sym_virtual] = ACTIONS(4948),
    [anon_sym_alignas] = ACTIONS(4948),
    [anon_sym_explicit] = ACTIONS(4948),
    [anon_sym_typename] = ACTIONS(4948),
    [anon_sym_template] = ACTIONS(4948),
    [anon_sym_operator] = ACTIONS(4948),
    [anon_sym_friend] = ACTIONS(4948),
    [anon_sym_public] = ACTIONS(4948),
    [anon_sym_private] = ACTIONS(4948),
    [anon_sym_protected] = ACTIONS(4948),
    [anon_sym_using] = ACTIONS(4948),
    [anon_sym_static_assert] = ACTIONS(4948),
  },
  [2175] = {
    [sym_identifier] = ACTIONS(4952),
    [aux_sym_preproc_def_token1] = ACTIONS(4952),
    [aux_sym_preproc_if_token1] = ACTIONS(4952),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4952),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4952),
    [sym_preproc_directive] = ACTIONS(4952),
    [anon_sym_LPAREN2] = ACTIONS(4954),
    [anon_sym_TILDE] = ACTIONS(4954),
    [anon_sym_STAR] = ACTIONS(4954),
    [anon_sym_AMP_AMP] = ACTIONS(4954),
    [anon_sym_AMP] = ACTIONS(4952),
    [anon_sym___extension__] = ACTIONS(4952),
    [anon_sym_typedef] = ACTIONS(4952),
    [anon_sym_extern] = ACTIONS(4952),
    [anon_sym___attribute__] = ACTIONS(4952),
    [anon_sym_COLON_COLON] = ACTIONS(4954),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4954),
    [anon_sym___declspec] = ACTIONS(4952),
    [anon_sym___based] = ACTIONS(4952),
    [anon_sym_RBRACE] = ACTIONS(4954),
    [anon_sym_signed] = ACTIONS(4952),
    [anon_sym_unsigned] = ACTIONS(4952),
    [anon_sym_long] = ACTIONS(4952),
    [anon_sym_short] = ACTIONS(4952),
    [anon_sym_LBRACK] = ACTIONS(4952),
    [anon_sym_static] = ACTIONS(4952),
    [anon_sym_register] = ACTIONS(4952),
    [anon_sym_inline] = ACTIONS(4952),
    [anon_sym___inline] = ACTIONS(4952),
    [anon_sym___inline__] = ACTIONS(4952),
    [anon_sym___forceinline] = ACTIONS(4952),
    [anon_sym_thread_local] = ACTIONS(4952),
    [anon_sym___thread] = ACTIONS(4952),
    [anon_sym_const] = ACTIONS(4952),
    [anon_sym_constexpr] = ACTIONS(4952),
    [anon_sym_volatile] = ACTIONS(4952),
    [anon_sym_restrict] = ACTIONS(4952),
    [anon_sym___restrict__] = ACTIONS(4952),
    [anon_sym__Atomic] = ACTIONS(4952),
    [anon_sym__Noreturn] = ACTIONS(4952),
    [anon_sym_noreturn] = ACTIONS(4952),
    [anon_sym_mutable] = ACTIONS(4952),
    [anon_sym_constinit] = ACTIONS(4952),
    [anon_sym_consteval] = ACTIONS(4952),
    [anon_sym_PROGMEM] = ACTIONS(4952),
    [aux_sym_primitive_type_token1] = ACTIONS(4952),
    [anon_sym_byte] = ACTIONS(4952),
    [anon_sym_word] = ACTIONS(4952),
    [anon_sym_enum] = ACTIONS(4952),
    [anon_sym_class] = ACTIONS(4952),
    [anon_sym_struct] = ACTIONS(4952),
    [anon_sym_union] = ACTIONS(4952),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4952),
    [anon_sym_decltype] = ACTIONS(4952),
    [anon_sym_virtual] = ACTIONS(4952),
    [anon_sym_alignas] = ACTIONS(4952),
    [anon_sym_explicit] = ACTIONS(4952),
    [anon_sym_typename] = ACTIONS(4952),
    [anon_sym_template] = ACTIONS(4952),
    [anon_sym_operator] = ACTIONS(4952),
    [anon_sym_friend] = ACTIONS(4952),
    [anon_sym_public] = ACTIONS(4952),
    [anon_sym_private] = ACTIONS(4952),
    [anon_sym_protected] = ACTIONS(4952),
    [anon_sym_using] = ACTIONS(4952),
    [anon_sym_static_assert] = ACTIONS(4952),
  },
  [2176] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_PROGMEM] = ACTIONS(3072),
    [aux_sym_primitive_type_token1] = ACTIONS(3072),
    [anon_sym_byte] = ACTIONS(3072),
    [anon_sym_word] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_friend] = ACTIONS(3072),
    [anon_sym_public] = ACTIONS(3072),
    [anon_sym_private] = ACTIONS(3072),
    [anon_sym_protected] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
  },
  [2177] = {
    [sym_identifier] = ACTIONS(2967),
    [aux_sym_preproc_def_token1] = ACTIONS(2967),
    [aux_sym_preproc_if_token1] = ACTIONS(2967),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2967),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2967),
    [sym_preproc_directive] = ACTIONS(2967),
    [anon_sym_LPAREN2] = ACTIONS(2969),
    [anon_sym_TILDE] = ACTIONS(2969),
    [anon_sym_STAR] = ACTIONS(2969),
    [anon_sym_AMP_AMP] = ACTIONS(2969),
    [anon_sym_AMP] = ACTIONS(2967),
    [anon_sym___extension__] = ACTIONS(2967),
    [anon_sym_typedef] = ACTIONS(2967),
    [anon_sym_extern] = ACTIONS(2967),
    [anon_sym___attribute__] = ACTIONS(2967),
    [anon_sym_COLON_COLON] = ACTIONS(2969),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2969),
    [anon_sym___declspec] = ACTIONS(2967),
    [anon_sym___based] = ACTIONS(2967),
    [anon_sym_RBRACE] = ACTIONS(2969),
    [anon_sym_signed] = ACTIONS(2967),
    [anon_sym_unsigned] = ACTIONS(2967),
    [anon_sym_long] = ACTIONS(2967),
    [anon_sym_short] = ACTIONS(2967),
    [anon_sym_LBRACK] = ACTIONS(2967),
    [anon_sym_static] = ACTIONS(2967),
    [anon_sym_register] = ACTIONS(2967),
    [anon_sym_inline] = ACTIONS(2967),
    [anon_sym___inline] = ACTIONS(2967),
    [anon_sym___inline__] = ACTIONS(2967),
    [anon_sym___forceinline] = ACTIONS(2967),
    [anon_sym_thread_local] = ACTIONS(2967),
    [anon_sym___thread] = ACTIONS(2967),
    [anon_sym_const] = ACTIONS(2967),
    [anon_sym_constexpr] = ACTIONS(2967),
    [anon_sym_volatile] = ACTIONS(2967),
    [anon_sym_restrict] = ACTIONS(2967),
    [anon_sym___restrict__] = ACTIONS(2967),
    [anon_sym__Atomic] = ACTIONS(2967),
    [anon_sym__Noreturn] = ACTIONS(2967),
    [anon_sym_noreturn] = ACTIONS(2967),
    [anon_sym_mutable] = ACTIONS(2967),
    [anon_sym_constinit] = ACTIONS(2967),
    [anon_sym_consteval] = ACTIONS(2967),
    [anon_sym_PROGMEM] = ACTIONS(2967),
    [aux_sym_primitive_type_token1] = ACTIONS(2967),
    [anon_sym_byte] = ACTIONS(2967),
    [anon_sym_word] = ACTIONS(2967),
    [anon_sym_enum] = ACTIONS(2967),
    [anon_sym_class] = ACTIONS(2967),
    [anon_sym_struct] = ACTIONS(2967),
    [anon_sym_union] = ACTIONS(2967),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2967),
    [anon_sym_decltype] = ACTIONS(2967),
    [anon_sym_virtual] = ACTIONS(2967),
    [anon_sym_alignas] = ACTIONS(2967),
    [anon_sym_explicit] = ACTIONS(2967),
    [anon_sym_typename] = ACTIONS(2967),
    [anon_sym_template] = ACTIONS(2967),
    [anon_sym_operator] = ACTIONS(2967),
    [anon_sym_friend] = ACTIONS(2967),
    [anon_sym_public] = ACTIONS(2967),
    [anon_sym_private] = ACTIONS(2967),
    [anon_sym_protected] = ACTIONS(2967),
    [anon_sym_using] = ACTIONS(2967),
    [anon_sym_static_assert] = ACTIONS(2967),
  },
  [2178] = {
    [sym_identifier] = ACTIONS(4890),
    [aux_sym_preproc_def_token1] = ACTIONS(4890),
    [aux_sym_preproc_if_token1] = ACTIONS(4890),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4890),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4890),
    [sym_preproc_directive] = ACTIONS(4890),
    [anon_sym_LPAREN2] = ACTIONS(4892),
    [anon_sym_TILDE] = ACTIONS(4892),
    [anon_sym_STAR] = ACTIONS(4892),
    [anon_sym_AMP_AMP] = ACTIONS(4892),
    [anon_sym_AMP] = ACTIONS(4890),
    [anon_sym___extension__] = ACTIONS(4890),
    [anon_sym_typedef] = ACTIONS(4890),
    [anon_sym_extern] = ACTIONS(4890),
    [anon_sym___attribute__] = ACTIONS(4890),
    [anon_sym_COLON_COLON] = ACTIONS(4892),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4892),
    [anon_sym___declspec] = ACTIONS(4890),
    [anon_sym___based] = ACTIONS(4890),
    [anon_sym_RBRACE] = ACTIONS(4892),
    [anon_sym_signed] = ACTIONS(4890),
    [anon_sym_unsigned] = ACTIONS(4890),
    [anon_sym_long] = ACTIONS(4890),
    [anon_sym_short] = ACTIONS(4890),
    [anon_sym_LBRACK] = ACTIONS(4890),
    [anon_sym_static] = ACTIONS(4890),
    [anon_sym_register] = ACTIONS(4890),
    [anon_sym_inline] = ACTIONS(4890),
    [anon_sym___inline] = ACTIONS(4890),
    [anon_sym___inline__] = ACTIONS(4890),
    [anon_sym___forceinline] = ACTIONS(4890),
    [anon_sym_thread_local] = ACTIONS(4890),
    [anon_sym___thread] = ACTIONS(4890),
    [anon_sym_const] = ACTIONS(4890),
    [anon_sym_constexpr] = ACTIONS(4890),
    [anon_sym_volatile] = ACTIONS(4890),
    [anon_sym_restrict] = ACTIONS(4890),
    [anon_sym___restrict__] = ACTIONS(4890),
    [anon_sym__Atomic] = ACTIONS(4890),
    [anon_sym__Noreturn] = ACTIONS(4890),
    [anon_sym_noreturn] = ACTIONS(4890),
    [anon_sym_mutable] = ACTIONS(4890),
    [anon_sym_constinit] = ACTIONS(4890),
    [anon_sym_consteval] = ACTIONS(4890),
    [anon_sym_PROGMEM] = ACTIONS(4890),
    [aux_sym_primitive_type_token1] = ACTIONS(4890),
    [anon_sym_byte] = ACTIONS(4890),
    [anon_sym_word] = ACTIONS(4890),
    [anon_sym_enum] = ACTIONS(4890),
    [anon_sym_class] = ACTIONS(4890),
    [anon_sym_struct] = ACTIONS(4890),
    [anon_sym_union] = ACTIONS(4890),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4890),
    [anon_sym_decltype] = ACTIONS(4890),
    [anon_sym_virtual] = ACTIONS(4890),
    [anon_sym_alignas] = ACTIONS(4890),
    [anon_sym_explicit] = ACTIONS(4890),
    [anon_sym_typename] = ACTIONS(4890),
    [anon_sym_template] = ACTIONS(4890),
    [anon_sym_operator] = ACTIONS(4890),
    [anon_sym_friend] = ACTIONS(4890),
    [anon_sym_public] = ACTIONS(4890),
    [anon_sym_private] = ACTIONS(4890),
    [anon_sym_protected] = ACTIONS(4890),
    [anon_sym_using] = ACTIONS(4890),
    [anon_sym_static_assert] = ACTIONS(4890),
  },
  [2179] = {
    [sym_identifier] = ACTIONS(3476),
    [aux_sym_preproc_def_token1] = ACTIONS(3476),
    [aux_sym_preproc_if_token1] = ACTIONS(3476),
    [aux_sym_preproc_if_token2] = ACTIONS(3476),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3476),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3476),
    [sym_preproc_directive] = ACTIONS(3476),
    [anon_sym_LPAREN2] = ACTIONS(3474),
    [anon_sym_TILDE] = ACTIONS(3474),
    [anon_sym_STAR] = ACTIONS(3474),
    [anon_sym_AMP_AMP] = ACTIONS(3474),
    [anon_sym_AMP] = ACTIONS(3476),
    [anon_sym___extension__] = ACTIONS(3476),
    [anon_sym_typedef] = ACTIONS(3476),
    [anon_sym_extern] = ACTIONS(3476),
    [anon_sym___attribute__] = ACTIONS(3476),
    [anon_sym_COLON_COLON] = ACTIONS(3474),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3474),
    [anon_sym___declspec] = ACTIONS(3476),
    [anon_sym___based] = ACTIONS(3476),
    [anon_sym_signed] = ACTIONS(3476),
    [anon_sym_unsigned] = ACTIONS(3476),
    [anon_sym_long] = ACTIONS(3476),
    [anon_sym_short] = ACTIONS(3476),
    [anon_sym_LBRACK] = ACTIONS(3476),
    [anon_sym_static] = ACTIONS(3476),
    [anon_sym_register] = ACTIONS(3476),
    [anon_sym_inline] = ACTIONS(3476),
    [anon_sym___inline] = ACTIONS(3476),
    [anon_sym___inline__] = ACTIONS(3476),
    [anon_sym___forceinline] = ACTIONS(3476),
    [anon_sym_thread_local] = ACTIONS(3476),
    [anon_sym___thread] = ACTIONS(3476),
    [anon_sym_const] = ACTIONS(3476),
    [anon_sym_constexpr] = ACTIONS(3476),
    [anon_sym_volatile] = ACTIONS(3476),
    [anon_sym_restrict] = ACTIONS(3476),
    [anon_sym___restrict__] = ACTIONS(3476),
    [anon_sym__Atomic] = ACTIONS(3476),
    [anon_sym__Noreturn] = ACTIONS(3476),
    [anon_sym_noreturn] = ACTIONS(3476),
    [anon_sym_mutable] = ACTIONS(3476),
    [anon_sym_constinit] = ACTIONS(3476),
    [anon_sym_consteval] = ACTIONS(3476),
    [anon_sym_PROGMEM] = ACTIONS(3476),
    [aux_sym_primitive_type_token1] = ACTIONS(3476),
    [anon_sym_byte] = ACTIONS(3476),
    [anon_sym_word] = ACTIONS(3476),
    [anon_sym_enum] = ACTIONS(3476),
    [anon_sym_class] = ACTIONS(3476),
    [anon_sym_struct] = ACTIONS(3476),
    [anon_sym_union] = ACTIONS(3476),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3476),
    [anon_sym_decltype] = ACTIONS(3476),
    [anon_sym_virtual] = ACTIONS(3476),
    [anon_sym_alignas] = ACTIONS(3476),
    [anon_sym_explicit] = ACTIONS(3476),
    [anon_sym_typename] = ACTIONS(3476),
    [anon_sym_template] = ACTIONS(3476),
    [anon_sym_operator] = ACTIONS(3476),
    [anon_sym_friend] = ACTIONS(3476),
    [anon_sym_public] = ACTIONS(3476),
    [anon_sym_private] = ACTIONS(3476),
    [anon_sym_protected] = ACTIONS(3476),
    [anon_sym_using] = ACTIONS(3476),
    [anon_sym_static_assert] = ACTIONS(3476),
  },
  [2180] = {
    [sym_identifier] = ACTIONS(4956),
    [aux_sym_preproc_def_token1] = ACTIONS(4956),
    [aux_sym_preproc_if_token1] = ACTIONS(4956),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4956),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4956),
    [sym_preproc_directive] = ACTIONS(4956),
    [anon_sym_LPAREN2] = ACTIONS(4958),
    [anon_sym_TILDE] = ACTIONS(4958),
    [anon_sym_STAR] = ACTIONS(4958),
    [anon_sym_AMP_AMP] = ACTIONS(4958),
    [anon_sym_AMP] = ACTIONS(4956),
    [anon_sym___extension__] = ACTIONS(4956),
    [anon_sym_typedef] = ACTIONS(4956),
    [anon_sym_extern] = ACTIONS(4956),
    [anon_sym___attribute__] = ACTIONS(4956),
    [anon_sym_COLON_COLON] = ACTIONS(4958),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4958),
    [anon_sym___declspec] = ACTIONS(4956),
    [anon_sym___based] = ACTIONS(4956),
    [anon_sym_RBRACE] = ACTIONS(4958),
    [anon_sym_signed] = ACTIONS(4956),
    [anon_sym_unsigned] = ACTIONS(4956),
    [anon_sym_long] = ACTIONS(4956),
    [anon_sym_short] = ACTIONS(4956),
    [anon_sym_LBRACK] = ACTIONS(4956),
    [anon_sym_static] = ACTIONS(4956),
    [anon_sym_register] = ACTIONS(4956),
    [anon_sym_inline] = ACTIONS(4956),
    [anon_sym___inline] = ACTIONS(4956),
    [anon_sym___inline__] = ACTIONS(4956),
    [anon_sym___forceinline] = ACTIONS(4956),
    [anon_sym_thread_local] = ACTIONS(4956),
    [anon_sym___thread] = ACTIONS(4956),
    [anon_sym_const] = ACTIONS(4956),
    [anon_sym_constexpr] = ACTIONS(4956),
    [anon_sym_volatile] = ACTIONS(4956),
    [anon_sym_restrict] = ACTIONS(4956),
    [anon_sym___restrict__] = ACTIONS(4956),
    [anon_sym__Atomic] = ACTIONS(4956),
    [anon_sym__Noreturn] = ACTIONS(4956),
    [anon_sym_noreturn] = ACTIONS(4956),
    [anon_sym_mutable] = ACTIONS(4956),
    [anon_sym_constinit] = ACTIONS(4956),
    [anon_sym_consteval] = ACTIONS(4956),
    [anon_sym_PROGMEM] = ACTIONS(4956),
    [aux_sym_primitive_type_token1] = ACTIONS(4956),
    [anon_sym_byte] = ACTIONS(4956),
    [anon_sym_word] = ACTIONS(4956),
    [anon_sym_enum] = ACTIONS(4956),
    [anon_sym_class] = ACTIONS(4956),
    [anon_sym_struct] = ACTIONS(4956),
    [anon_sym_union] = ACTIONS(4956),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4956),
    [anon_sym_decltype] = ACTIONS(4956),
    [anon_sym_virtual] = ACTIONS(4956),
    [anon_sym_alignas] = ACTIONS(4956),
    [anon_sym_explicit] = ACTIONS(4956),
    [anon_sym_typename] = ACTIONS(4956),
    [anon_sym_template] = ACTIONS(4956),
    [anon_sym_operator] = ACTIONS(4956),
    [anon_sym_friend] = ACTIONS(4956),
    [anon_sym_public] = ACTIONS(4956),
    [anon_sym_private] = ACTIONS(4956),
    [anon_sym_protected] = ACTIONS(4956),
    [anon_sym_using] = ACTIONS(4956),
    [anon_sym_static_assert] = ACTIONS(4956),
  },
  [2181] = {
    [sym_identifier] = ACTIONS(2813),
    [aux_sym_preproc_def_token1] = ACTIONS(2813),
    [aux_sym_preproc_if_token1] = ACTIONS(2813),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2813),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2813),
    [sym_preproc_directive] = ACTIONS(2813),
    [anon_sym_LPAREN2] = ACTIONS(2815),
    [anon_sym_TILDE] = ACTIONS(2815),
    [anon_sym_STAR] = ACTIONS(2815),
    [anon_sym_AMP_AMP] = ACTIONS(2815),
    [anon_sym_AMP] = ACTIONS(2813),
    [anon_sym___extension__] = ACTIONS(2813),
    [anon_sym_typedef] = ACTIONS(2813),
    [anon_sym_extern] = ACTIONS(2813),
    [anon_sym___attribute__] = ACTIONS(2813),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2815),
    [anon_sym___declspec] = ACTIONS(2813),
    [anon_sym___based] = ACTIONS(2813),
    [anon_sym_RBRACE] = ACTIONS(2815),
    [anon_sym_signed] = ACTIONS(2813),
    [anon_sym_unsigned] = ACTIONS(2813),
    [anon_sym_long] = ACTIONS(2813),
    [anon_sym_short] = ACTIONS(2813),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_static] = ACTIONS(2813),
    [anon_sym_register] = ACTIONS(2813),
    [anon_sym_inline] = ACTIONS(2813),
    [anon_sym___inline] = ACTIONS(2813),
    [anon_sym___inline__] = ACTIONS(2813),
    [anon_sym___forceinline] = ACTIONS(2813),
    [anon_sym_thread_local] = ACTIONS(2813),
    [anon_sym___thread] = ACTIONS(2813),
    [anon_sym_const] = ACTIONS(2813),
    [anon_sym_constexpr] = ACTIONS(2813),
    [anon_sym_volatile] = ACTIONS(2813),
    [anon_sym_restrict] = ACTIONS(2813),
    [anon_sym___restrict__] = ACTIONS(2813),
    [anon_sym__Atomic] = ACTIONS(2813),
    [anon_sym__Noreturn] = ACTIONS(2813),
    [anon_sym_noreturn] = ACTIONS(2813),
    [anon_sym_mutable] = ACTIONS(2813),
    [anon_sym_constinit] = ACTIONS(2813),
    [anon_sym_consteval] = ACTIONS(2813),
    [anon_sym_PROGMEM] = ACTIONS(2813),
    [aux_sym_primitive_type_token1] = ACTIONS(2813),
    [anon_sym_byte] = ACTIONS(2813),
    [anon_sym_word] = ACTIONS(2813),
    [anon_sym_enum] = ACTIONS(2813),
    [anon_sym_class] = ACTIONS(2813),
    [anon_sym_struct] = ACTIONS(2813),
    [anon_sym_union] = ACTIONS(2813),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2813),
    [anon_sym_decltype] = ACTIONS(2813),
    [anon_sym_virtual] = ACTIONS(2813),
    [anon_sym_alignas] = ACTIONS(2813),
    [anon_sym_explicit] = ACTIONS(2813),
    [anon_sym_typename] = ACTIONS(2813),
    [anon_sym_template] = ACTIONS(2813),
    [anon_sym_operator] = ACTIONS(2813),
    [anon_sym_friend] = ACTIONS(2813),
    [anon_sym_public] = ACTIONS(2813),
    [anon_sym_private] = ACTIONS(2813),
    [anon_sym_protected] = ACTIONS(2813),
    [anon_sym_using] = ACTIONS(2813),
    [anon_sym_static_assert] = ACTIONS(2813),
  },
  [2182] = {
    [sym_identifier] = ACTIONS(2731),
    [aux_sym_preproc_def_token1] = ACTIONS(2731),
    [aux_sym_preproc_if_token1] = ACTIONS(2731),
    [aux_sym_preproc_if_token2] = ACTIONS(2731),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2731),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2731),
    [sym_preproc_directive] = ACTIONS(2731),
    [anon_sym_LPAREN2] = ACTIONS(2733),
    [anon_sym_TILDE] = ACTIONS(2733),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_AMP_AMP] = ACTIONS(2733),
    [anon_sym_AMP] = ACTIONS(2731),
    [anon_sym___extension__] = ACTIONS(2731),
    [anon_sym_typedef] = ACTIONS(2731),
    [anon_sym_extern] = ACTIONS(2731),
    [anon_sym___attribute__] = ACTIONS(2731),
    [anon_sym_COLON_COLON] = ACTIONS(2733),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2733),
    [anon_sym___declspec] = ACTIONS(2731),
    [anon_sym___based] = ACTIONS(2731),
    [anon_sym_signed] = ACTIONS(2731),
    [anon_sym_unsigned] = ACTIONS(2731),
    [anon_sym_long] = ACTIONS(2731),
    [anon_sym_short] = ACTIONS(2731),
    [anon_sym_LBRACK] = ACTIONS(2731),
    [anon_sym_static] = ACTIONS(2731),
    [anon_sym_register] = ACTIONS(2731),
    [anon_sym_inline] = ACTIONS(2731),
    [anon_sym___inline] = ACTIONS(2731),
    [anon_sym___inline__] = ACTIONS(2731),
    [anon_sym___forceinline] = ACTIONS(2731),
    [anon_sym_thread_local] = ACTIONS(2731),
    [anon_sym___thread] = ACTIONS(2731),
    [anon_sym_const] = ACTIONS(2731),
    [anon_sym_constexpr] = ACTIONS(2731),
    [anon_sym_volatile] = ACTIONS(2731),
    [anon_sym_restrict] = ACTIONS(2731),
    [anon_sym___restrict__] = ACTIONS(2731),
    [anon_sym__Atomic] = ACTIONS(2731),
    [anon_sym__Noreturn] = ACTIONS(2731),
    [anon_sym_noreturn] = ACTIONS(2731),
    [anon_sym_mutable] = ACTIONS(2731),
    [anon_sym_constinit] = ACTIONS(2731),
    [anon_sym_consteval] = ACTIONS(2731),
    [anon_sym_PROGMEM] = ACTIONS(2731),
    [aux_sym_primitive_type_token1] = ACTIONS(2731),
    [anon_sym_byte] = ACTIONS(2731),
    [anon_sym_word] = ACTIONS(2731),
    [anon_sym_enum] = ACTIONS(2731),
    [anon_sym_class] = ACTIONS(2731),
    [anon_sym_struct] = ACTIONS(2731),
    [anon_sym_union] = ACTIONS(2731),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2731),
    [anon_sym_decltype] = ACTIONS(2731),
    [anon_sym_virtual] = ACTIONS(2731),
    [anon_sym_alignas] = ACTIONS(2731),
    [anon_sym_explicit] = ACTIONS(2731),
    [anon_sym_typename] = ACTIONS(2731),
    [anon_sym_template] = ACTIONS(2731),
    [anon_sym_operator] = ACTIONS(2731),
    [anon_sym_friend] = ACTIONS(2731),
    [anon_sym_public] = ACTIONS(2731),
    [anon_sym_private] = ACTIONS(2731),
    [anon_sym_protected] = ACTIONS(2731),
    [anon_sym_using] = ACTIONS(2731),
    [anon_sym_static_assert] = ACTIONS(2731),
  },
  [2183] = {
    [sym_identifier] = ACTIONS(2813),
    [aux_sym_preproc_def_token1] = ACTIONS(2813),
    [aux_sym_preproc_if_token1] = ACTIONS(2813),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2813),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2813),
    [sym_preproc_directive] = ACTIONS(2813),
    [anon_sym_LPAREN2] = ACTIONS(2815),
    [anon_sym_TILDE] = ACTIONS(2815),
    [anon_sym_STAR] = ACTIONS(2815),
    [anon_sym_AMP_AMP] = ACTIONS(2815),
    [anon_sym_AMP] = ACTIONS(2813),
    [anon_sym___extension__] = ACTIONS(2813),
    [anon_sym_typedef] = ACTIONS(2813),
    [anon_sym_extern] = ACTIONS(2813),
    [anon_sym___attribute__] = ACTIONS(2813),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2815),
    [anon_sym___declspec] = ACTIONS(2813),
    [anon_sym___based] = ACTIONS(2813),
    [anon_sym_RBRACE] = ACTIONS(2815),
    [anon_sym_signed] = ACTIONS(2813),
    [anon_sym_unsigned] = ACTIONS(2813),
    [anon_sym_long] = ACTIONS(2813),
    [anon_sym_short] = ACTIONS(2813),
    [anon_sym_LBRACK] = ACTIONS(2813),
    [anon_sym_static] = ACTIONS(2813),
    [anon_sym_register] = ACTIONS(2813),
    [anon_sym_inline] = ACTIONS(2813),
    [anon_sym___inline] = ACTIONS(2813),
    [anon_sym___inline__] = ACTIONS(2813),
    [anon_sym___forceinline] = ACTIONS(2813),
    [anon_sym_thread_local] = ACTIONS(2813),
    [anon_sym___thread] = ACTIONS(2813),
    [anon_sym_const] = ACTIONS(2813),
    [anon_sym_constexpr] = ACTIONS(2813),
    [anon_sym_volatile] = ACTIONS(2813),
    [anon_sym_restrict] = ACTIONS(2813),
    [anon_sym___restrict__] = ACTIONS(2813),
    [anon_sym__Atomic] = ACTIONS(2813),
    [anon_sym__Noreturn] = ACTIONS(2813),
    [anon_sym_noreturn] = ACTIONS(2813),
    [anon_sym_mutable] = ACTIONS(2813),
    [anon_sym_constinit] = ACTIONS(2813),
    [anon_sym_consteval] = ACTIONS(2813),
    [anon_sym_PROGMEM] = ACTIONS(2813),
    [aux_sym_primitive_type_token1] = ACTIONS(2813),
    [anon_sym_byte] = ACTIONS(2813),
    [anon_sym_word] = ACTIONS(2813),
    [anon_sym_enum] = ACTIONS(2813),
    [anon_sym_class] = ACTIONS(2813),
    [anon_sym_struct] = ACTIONS(2813),
    [anon_sym_union] = ACTIONS(2813),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2813),
    [anon_sym_decltype] = ACTIONS(2813),
    [anon_sym_virtual] = ACTIONS(2813),
    [anon_sym_alignas] = ACTIONS(2813),
    [anon_sym_explicit] = ACTIONS(2813),
    [anon_sym_typename] = ACTIONS(2813),
    [anon_sym_template] = ACTIONS(2813),
    [anon_sym_operator] = ACTIONS(2813),
    [anon_sym_friend] = ACTIONS(2813),
    [anon_sym_public] = ACTIONS(2813),
    [anon_sym_private] = ACTIONS(2813),
    [anon_sym_protected] = ACTIONS(2813),
    [anon_sym_using] = ACTIONS(2813),
    [anon_sym_static_assert] = ACTIONS(2813),
  },
  [2184] = {
    [sym_identifier] = ACTIONS(3086),
    [aux_sym_preproc_def_token1] = ACTIONS(3086),
    [aux_sym_preproc_if_token1] = ACTIONS(3086),
    [aux_sym_preproc_if_token2] = ACTIONS(3086),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3086),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3086),
    [sym_preproc_directive] = ACTIONS(3086),
    [anon_sym_LPAREN2] = ACTIONS(3088),
    [anon_sym_TILDE] = ACTIONS(3088),
    [anon_sym_STAR] = ACTIONS(3088),
    [anon_sym_AMP_AMP] = ACTIONS(3088),
    [anon_sym_AMP] = ACTIONS(3086),
    [anon_sym___extension__] = ACTIONS(3086),
    [anon_sym_typedef] = ACTIONS(3086),
    [anon_sym_extern] = ACTIONS(3086),
    [anon_sym___attribute__] = ACTIONS(3086),
    [anon_sym_COLON_COLON] = ACTIONS(3088),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3088),
    [anon_sym___declspec] = ACTIONS(3086),
    [anon_sym___based] = ACTIONS(3086),
    [anon_sym_signed] = ACTIONS(3086),
    [anon_sym_unsigned] = ACTIONS(3086),
    [anon_sym_long] = ACTIONS(3086),
    [anon_sym_short] = ACTIONS(3086),
    [anon_sym_LBRACK] = ACTIONS(3086),
    [anon_sym_static] = ACTIONS(3086),
    [anon_sym_register] = ACTIONS(3086),
    [anon_sym_inline] = ACTIONS(3086),
    [anon_sym___inline] = ACTIONS(3086),
    [anon_sym___inline__] = ACTIONS(3086),
    [anon_sym___forceinline] = ACTIONS(3086),
    [anon_sym_thread_local] = ACTIONS(3086),
    [anon_sym___thread] = ACTIONS(3086),
    [anon_sym_const] = ACTIONS(3086),
    [anon_sym_constexpr] = ACTIONS(3086),
    [anon_sym_volatile] = ACTIONS(3086),
    [anon_sym_restrict] = ACTIONS(3086),
    [anon_sym___restrict__] = ACTIONS(3086),
    [anon_sym__Atomic] = ACTIONS(3086),
    [anon_sym__Noreturn] = ACTIONS(3086),
    [anon_sym_noreturn] = ACTIONS(3086),
    [anon_sym_mutable] = ACTIONS(3086),
    [anon_sym_constinit] = ACTIONS(3086),
    [anon_sym_consteval] = ACTIONS(3086),
    [anon_sym_PROGMEM] = ACTIONS(3086),
    [aux_sym_primitive_type_token1] = ACTIONS(3086),
    [anon_sym_byte] = ACTIONS(3086),
    [anon_sym_word] = ACTIONS(3086),
    [anon_sym_enum] = ACTIONS(3086),
    [anon_sym_class] = ACTIONS(3086),
    [anon_sym_struct] = ACTIONS(3086),
    [anon_sym_union] = ACTIONS(3086),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3086),
    [anon_sym_decltype] = ACTIONS(3086),
    [anon_sym_virtual] = ACTIONS(3086),
    [anon_sym_alignas] = ACTIONS(3086),
    [anon_sym_explicit] = ACTIONS(3086),
    [anon_sym_typename] = ACTIONS(3086),
    [anon_sym_template] = ACTIONS(3086),
    [anon_sym_operator] = ACTIONS(3086),
    [anon_sym_friend] = ACTIONS(3086),
    [anon_sym_public] = ACTIONS(3086),
    [anon_sym_private] = ACTIONS(3086),
    [anon_sym_protected] = ACTIONS(3086),
    [anon_sym_using] = ACTIONS(3086),
    [anon_sym_static_assert] = ACTIONS(3086),
  },
  [2185] = {
    [sym_identifier] = ACTIONS(4894),
    [aux_sym_preproc_def_token1] = ACTIONS(4894),
    [aux_sym_preproc_if_token1] = ACTIONS(4894),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4894),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4894),
    [sym_preproc_directive] = ACTIONS(4894),
    [anon_sym_LPAREN2] = ACTIONS(4896),
    [anon_sym_TILDE] = ACTIONS(4896),
    [anon_sym_STAR] = ACTIONS(4896),
    [anon_sym_AMP_AMP] = ACTIONS(4896),
    [anon_sym_AMP] = ACTIONS(4894),
    [anon_sym___extension__] = ACTIONS(4894),
    [anon_sym_typedef] = ACTIONS(4894),
    [anon_sym_extern] = ACTIONS(4894),
    [anon_sym___attribute__] = ACTIONS(4894),
    [anon_sym_COLON_COLON] = ACTIONS(4896),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4896),
    [anon_sym___declspec] = ACTIONS(4894),
    [anon_sym___based] = ACTIONS(4894),
    [anon_sym_RBRACE] = ACTIONS(4896),
    [anon_sym_signed] = ACTIONS(4894),
    [anon_sym_unsigned] = ACTIONS(4894),
    [anon_sym_long] = ACTIONS(4894),
    [anon_sym_short] = ACTIONS(4894),
    [anon_sym_LBRACK] = ACTIONS(4894),
    [anon_sym_static] = ACTIONS(4894),
    [anon_sym_register] = ACTIONS(4894),
    [anon_sym_inline] = ACTIONS(4894),
    [anon_sym___inline] = ACTIONS(4894),
    [anon_sym___inline__] = ACTIONS(4894),
    [anon_sym___forceinline] = ACTIONS(4894),
    [anon_sym_thread_local] = ACTIONS(4894),
    [anon_sym___thread] = ACTIONS(4894),
    [anon_sym_const] = ACTIONS(4894),
    [anon_sym_constexpr] = ACTIONS(4894),
    [anon_sym_volatile] = ACTIONS(4894),
    [anon_sym_restrict] = ACTIONS(4894),
    [anon_sym___restrict__] = ACTIONS(4894),
    [anon_sym__Atomic] = ACTIONS(4894),
    [anon_sym__Noreturn] = ACTIONS(4894),
    [anon_sym_noreturn] = ACTIONS(4894),
    [anon_sym_mutable] = ACTIONS(4894),
    [anon_sym_constinit] = ACTIONS(4894),
    [anon_sym_consteval] = ACTIONS(4894),
    [anon_sym_PROGMEM] = ACTIONS(4894),
    [aux_sym_primitive_type_token1] = ACTIONS(4894),
    [anon_sym_byte] = ACTIONS(4894),
    [anon_sym_word] = ACTIONS(4894),
    [anon_sym_enum] = ACTIONS(4894),
    [anon_sym_class] = ACTIONS(4894),
    [anon_sym_struct] = ACTIONS(4894),
    [anon_sym_union] = ACTIONS(4894),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4894),
    [anon_sym_decltype] = ACTIONS(4894),
    [anon_sym_virtual] = ACTIONS(4894),
    [anon_sym_alignas] = ACTIONS(4894),
    [anon_sym_explicit] = ACTIONS(4894),
    [anon_sym_typename] = ACTIONS(4894),
    [anon_sym_template] = ACTIONS(4894),
    [anon_sym_operator] = ACTIONS(4894),
    [anon_sym_friend] = ACTIONS(4894),
    [anon_sym_public] = ACTIONS(4894),
    [anon_sym_private] = ACTIONS(4894),
    [anon_sym_protected] = ACTIONS(4894),
    [anon_sym_using] = ACTIONS(4894),
    [anon_sym_static_assert] = ACTIONS(4894),
  },
  [2186] = {
    [sym_identifier] = ACTIONS(3068),
    [aux_sym_preproc_def_token1] = ACTIONS(3068),
    [aux_sym_preproc_if_token1] = ACTIONS(3068),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3068),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3068),
    [sym_preproc_directive] = ACTIONS(3068),
    [anon_sym_LPAREN2] = ACTIONS(3070),
    [anon_sym_TILDE] = ACTIONS(3070),
    [anon_sym_STAR] = ACTIONS(3070),
    [anon_sym_AMP_AMP] = ACTIONS(3070),
    [anon_sym_AMP] = ACTIONS(3068),
    [anon_sym___extension__] = ACTIONS(3068),
    [anon_sym_typedef] = ACTIONS(3068),
    [anon_sym_extern] = ACTIONS(3068),
    [anon_sym___attribute__] = ACTIONS(3068),
    [anon_sym_COLON_COLON] = ACTIONS(3070),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3070),
    [anon_sym___declspec] = ACTIONS(3068),
    [anon_sym___based] = ACTIONS(3068),
    [anon_sym_RBRACE] = ACTIONS(3070),
    [anon_sym_signed] = ACTIONS(3068),
    [anon_sym_unsigned] = ACTIONS(3068),
    [anon_sym_long] = ACTIONS(3068),
    [anon_sym_short] = ACTIONS(3068),
    [anon_sym_LBRACK] = ACTIONS(3068),
    [anon_sym_static] = ACTIONS(3068),
    [anon_sym_register] = ACTIONS(3068),
    [anon_sym_inline] = ACTIONS(3068),
    [anon_sym___inline] = ACTIONS(3068),
    [anon_sym___inline__] = ACTIONS(3068),
    [anon_sym___forceinline] = ACTIONS(3068),
    [anon_sym_thread_local] = ACTIONS(3068),
    [anon_sym___thread] = ACTIONS(3068),
    [anon_sym_const] = ACTIONS(3068),
    [anon_sym_constexpr] = ACTIONS(3068),
    [anon_sym_volatile] = ACTIONS(3068),
    [anon_sym_restrict] = ACTIONS(3068),
    [anon_sym___restrict__] = ACTIONS(3068),
    [anon_sym__Atomic] = ACTIONS(3068),
    [anon_sym__Noreturn] = ACTIONS(3068),
    [anon_sym_noreturn] = ACTIONS(3068),
    [anon_sym_mutable] = ACTIONS(3068),
    [anon_sym_constinit] = ACTIONS(3068),
    [anon_sym_consteval] = ACTIONS(3068),
    [anon_sym_PROGMEM] = ACTIONS(3068),
    [aux_sym_primitive_type_token1] = ACTIONS(3068),
    [anon_sym_byte] = ACTIONS(3068),
    [anon_sym_word] = ACTIONS(3068),
    [anon_sym_enum] = ACTIONS(3068),
    [anon_sym_class] = ACTIONS(3068),
    [anon_sym_struct] = ACTIONS(3068),
    [anon_sym_union] = ACTIONS(3068),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3068),
    [anon_sym_decltype] = ACTIONS(3068),
    [anon_sym_virtual] = ACTIONS(3068),
    [anon_sym_alignas] = ACTIONS(3068),
    [anon_sym_explicit] = ACTIONS(3068),
    [anon_sym_typename] = ACTIONS(3068),
    [anon_sym_template] = ACTIONS(3068),
    [anon_sym_operator] = ACTIONS(3068),
    [anon_sym_friend] = ACTIONS(3068),
    [anon_sym_public] = ACTIONS(3068),
    [anon_sym_private] = ACTIONS(3068),
    [anon_sym_protected] = ACTIONS(3068),
    [anon_sym_using] = ACTIONS(3068),
    [anon_sym_static_assert] = ACTIONS(3068),
  },
  [2187] = {
    [sym_identifier] = ACTIONS(3060),
    [aux_sym_preproc_def_token1] = ACTIONS(3060),
    [aux_sym_preproc_if_token1] = ACTIONS(3060),
    [aux_sym_preproc_if_token2] = ACTIONS(3060),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3060),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3060),
    [sym_preproc_directive] = ACTIONS(3060),
    [anon_sym_LPAREN2] = ACTIONS(3062),
    [anon_sym_TILDE] = ACTIONS(3062),
    [anon_sym_STAR] = ACTIONS(3062),
    [anon_sym_AMP_AMP] = ACTIONS(3062),
    [anon_sym_AMP] = ACTIONS(3060),
    [anon_sym___extension__] = ACTIONS(3060),
    [anon_sym_typedef] = ACTIONS(3060),
    [anon_sym_extern] = ACTIONS(3060),
    [anon_sym___attribute__] = ACTIONS(3060),
    [anon_sym_COLON_COLON] = ACTIONS(3062),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3062),
    [anon_sym___declspec] = ACTIONS(3060),
    [anon_sym___based] = ACTIONS(3060),
    [anon_sym_signed] = ACTIONS(3060),
    [anon_sym_unsigned] = ACTIONS(3060),
    [anon_sym_long] = ACTIONS(3060),
    [anon_sym_short] = ACTIONS(3060),
    [anon_sym_LBRACK] = ACTIONS(3060),
    [anon_sym_static] = ACTIONS(3060),
    [anon_sym_register] = ACTIONS(3060),
    [anon_sym_inline] = ACTIONS(3060),
    [anon_sym___inline] = ACTIONS(3060),
    [anon_sym___inline__] = ACTIONS(3060),
    [anon_sym___forceinline] = ACTIONS(3060),
    [anon_sym_thread_local] = ACTIONS(3060),
    [anon_sym___thread] = ACTIONS(3060),
    [anon_sym_const] = ACTIONS(3060),
    [anon_sym_constexpr] = ACTIONS(3060),
    [anon_sym_volatile] = ACTIONS(3060),
    [anon_sym_restrict] = ACTIONS(3060),
    [anon_sym___restrict__] = ACTIONS(3060),
    [anon_sym__Atomic] = ACTIONS(3060),
    [anon_sym__Noreturn] = ACTIONS(3060),
    [anon_sym_noreturn] = ACTIONS(3060),
    [anon_sym_mutable] = ACTIONS(3060),
    [anon_sym_constinit] = ACTIONS(3060),
    [anon_sym_consteval] = ACTIONS(3060),
    [anon_sym_PROGMEM] = ACTIONS(3060),
    [aux_sym_primitive_type_token1] = ACTIONS(3060),
    [anon_sym_byte] = ACTIONS(3060),
    [anon_sym_word] = ACTIONS(3060),
    [anon_sym_enum] = ACTIONS(3060),
    [anon_sym_class] = ACTIONS(3060),
    [anon_sym_struct] = ACTIONS(3060),
    [anon_sym_union] = ACTIONS(3060),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3060),
    [anon_sym_decltype] = ACTIONS(3060),
    [anon_sym_virtual] = ACTIONS(3060),
    [anon_sym_alignas] = ACTIONS(3060),
    [anon_sym_explicit] = ACTIONS(3060),
    [anon_sym_typename] = ACTIONS(3060),
    [anon_sym_template] = ACTIONS(3060),
    [anon_sym_operator] = ACTIONS(3060),
    [anon_sym_friend] = ACTIONS(3060),
    [anon_sym_public] = ACTIONS(3060),
    [anon_sym_private] = ACTIONS(3060),
    [anon_sym_protected] = ACTIONS(3060),
    [anon_sym_using] = ACTIONS(3060),
    [anon_sym_static_assert] = ACTIONS(3060),
  },
  [2188] = {
    [sym_identifier] = ACTIONS(3068),
    [aux_sym_preproc_def_token1] = ACTIONS(3068),
    [aux_sym_preproc_if_token1] = ACTIONS(3068),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3068),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3068),
    [sym_preproc_directive] = ACTIONS(3068),
    [anon_sym_LPAREN2] = ACTIONS(3070),
    [anon_sym_TILDE] = ACTIONS(3070),
    [anon_sym_STAR] = ACTIONS(3070),
    [anon_sym_AMP_AMP] = ACTIONS(3070),
    [anon_sym_AMP] = ACTIONS(3068),
    [anon_sym___extension__] = ACTIONS(3068),
    [anon_sym_typedef] = ACTIONS(3068),
    [anon_sym_extern] = ACTIONS(3068),
    [anon_sym___attribute__] = ACTIONS(3068),
    [anon_sym_COLON_COLON] = ACTIONS(3070),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3070),
    [anon_sym___declspec] = ACTIONS(3068),
    [anon_sym___based] = ACTIONS(3068),
    [anon_sym_RBRACE] = ACTIONS(3070),
    [anon_sym_signed] = ACTIONS(3068),
    [anon_sym_unsigned] = ACTIONS(3068),
    [anon_sym_long] = ACTIONS(3068),
    [anon_sym_short] = ACTIONS(3068),
    [anon_sym_LBRACK] = ACTIONS(3068),
    [anon_sym_static] = ACTIONS(3068),
    [anon_sym_register] = ACTIONS(3068),
    [anon_sym_inline] = ACTIONS(3068),
    [anon_sym___inline] = ACTIONS(3068),
    [anon_sym___inline__] = ACTIONS(3068),
    [anon_sym___forceinline] = ACTIONS(3068),
    [anon_sym_thread_local] = ACTIONS(3068),
    [anon_sym___thread] = ACTIONS(3068),
    [anon_sym_const] = ACTIONS(3068),
    [anon_sym_constexpr] = ACTIONS(3068),
    [anon_sym_volatile] = ACTIONS(3068),
    [anon_sym_restrict] = ACTIONS(3068),
    [anon_sym___restrict__] = ACTIONS(3068),
    [anon_sym__Atomic] = ACTIONS(3068),
    [anon_sym__Noreturn] = ACTIONS(3068),
    [anon_sym_noreturn] = ACTIONS(3068),
    [anon_sym_mutable] = ACTIONS(3068),
    [anon_sym_constinit] = ACTIONS(3068),
    [anon_sym_consteval] = ACTIONS(3068),
    [anon_sym_PROGMEM] = ACTIONS(3068),
    [aux_sym_primitive_type_token1] = ACTIONS(3068),
    [anon_sym_byte] = ACTIONS(3068),
    [anon_sym_word] = ACTIONS(3068),
    [anon_sym_enum] = ACTIONS(3068),
    [anon_sym_class] = ACTIONS(3068),
    [anon_sym_struct] = ACTIONS(3068),
    [anon_sym_union] = ACTIONS(3068),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3068),
    [anon_sym_decltype] = ACTIONS(3068),
    [anon_sym_virtual] = ACTIONS(3068),
    [anon_sym_alignas] = ACTIONS(3068),
    [anon_sym_explicit] = ACTIONS(3068),
    [anon_sym_typename] = ACTIONS(3068),
    [anon_sym_template] = ACTIONS(3068),
    [anon_sym_operator] = ACTIONS(3068),
    [anon_sym_friend] = ACTIONS(3068),
    [anon_sym_public] = ACTIONS(3068),
    [anon_sym_private] = ACTIONS(3068),
    [anon_sym_protected] = ACTIONS(3068),
    [anon_sym_using] = ACTIONS(3068),
    [anon_sym_static_assert] = ACTIONS(3068),
  },
  [2189] = {
    [sym_identifier] = ACTIONS(2877),
    [aux_sym_preproc_def_token1] = ACTIONS(2877),
    [aux_sym_preproc_if_token1] = ACTIONS(2877),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2877),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2877),
    [sym_preproc_directive] = ACTIONS(2877),
    [anon_sym_LPAREN2] = ACTIONS(2879),
    [anon_sym_TILDE] = ACTIONS(2879),
    [anon_sym_STAR] = ACTIONS(2879),
    [anon_sym_AMP_AMP] = ACTIONS(2879),
    [anon_sym_AMP] = ACTIONS(2877),
    [anon_sym___extension__] = ACTIONS(2877),
    [anon_sym_typedef] = ACTIONS(2877),
    [anon_sym_extern] = ACTIONS(2877),
    [anon_sym___attribute__] = ACTIONS(2877),
    [anon_sym_COLON_COLON] = ACTIONS(2879),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2879),
    [anon_sym___declspec] = ACTIONS(2877),
    [anon_sym___based] = ACTIONS(2877),
    [anon_sym_RBRACE] = ACTIONS(2879),
    [anon_sym_signed] = ACTIONS(2877),
    [anon_sym_unsigned] = ACTIONS(2877),
    [anon_sym_long] = ACTIONS(2877),
    [anon_sym_short] = ACTIONS(2877),
    [anon_sym_LBRACK] = ACTIONS(2877),
    [anon_sym_static] = ACTIONS(2877),
    [anon_sym_register] = ACTIONS(2877),
    [anon_sym_inline] = ACTIONS(2877),
    [anon_sym___inline] = ACTIONS(2877),
    [anon_sym___inline__] = ACTIONS(2877),
    [anon_sym___forceinline] = ACTIONS(2877),
    [anon_sym_thread_local] = ACTIONS(2877),
    [anon_sym___thread] = ACTIONS(2877),
    [anon_sym_const] = ACTIONS(2877),
    [anon_sym_constexpr] = ACTIONS(2877),
    [anon_sym_volatile] = ACTIONS(2877),
    [anon_sym_restrict] = ACTIONS(2877),
    [anon_sym___restrict__] = ACTIONS(2877),
    [anon_sym__Atomic] = ACTIONS(2877),
    [anon_sym__Noreturn] = ACTIONS(2877),
    [anon_sym_noreturn] = ACTIONS(2877),
    [anon_sym_mutable] = ACTIONS(2877),
    [anon_sym_constinit] = ACTIONS(2877),
    [anon_sym_consteval] = ACTIONS(2877),
    [anon_sym_PROGMEM] = ACTIONS(2877),
    [aux_sym_primitive_type_token1] = ACTIONS(2877),
    [anon_sym_byte] = ACTIONS(2877),
    [anon_sym_word] = ACTIONS(2877),
    [anon_sym_enum] = ACTIONS(2877),
    [anon_sym_class] = ACTIONS(2877),
    [anon_sym_struct] = ACTIONS(2877),
    [anon_sym_union] = ACTIONS(2877),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2877),
    [anon_sym_decltype] = ACTIONS(2877),
    [anon_sym_virtual] = ACTIONS(2877),
    [anon_sym_alignas] = ACTIONS(2877),
    [anon_sym_explicit] = ACTIONS(2877),
    [anon_sym_typename] = ACTIONS(2877),
    [anon_sym_template] = ACTIONS(2877),
    [anon_sym_operator] = ACTIONS(2877),
    [anon_sym_friend] = ACTIONS(2877),
    [anon_sym_public] = ACTIONS(2877),
    [anon_sym_private] = ACTIONS(2877),
    [anon_sym_protected] = ACTIONS(2877),
    [anon_sym_using] = ACTIONS(2877),
    [anon_sym_static_assert] = ACTIONS(2877),
  },
  [2190] = {
    [sym_string_literal] = STATE(2617),
    [sym_template_argument_list] = STATE(3723),
    [sym_raw_string_literal] = STATE(2617),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3761),
    [anon_sym_COMMA] = ACTIONS(3761),
    [anon_sym_LPAREN2] = ACTIONS(3761),
    [anon_sym_DASH] = ACTIONS(3769),
    [anon_sym_PLUS] = ACTIONS(3769),
    [anon_sym_STAR] = ACTIONS(3769),
    [anon_sym_SLASH] = ACTIONS(3769),
    [anon_sym_PERCENT] = ACTIONS(3769),
    [anon_sym_PIPE_PIPE] = ACTIONS(3761),
    [anon_sym_AMP_AMP] = ACTIONS(3761),
    [anon_sym_PIPE] = ACTIONS(3769),
    [anon_sym_CARET] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(3769),
    [anon_sym_EQ_EQ] = ACTIONS(3761),
    [anon_sym_BANG_EQ] = ACTIONS(3761),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3761),
    [anon_sym_LT_EQ] = ACTIONS(3769),
    [anon_sym_LT] = ACTIONS(5242),
    [anon_sym_LT_LT] = ACTIONS(3769),
    [anon_sym_GT_GT] = ACTIONS(3769),
    [anon_sym_SEMI] = ACTIONS(3761),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(3785),
    [anon_sym_LBRACK] = ACTIONS(3761),
    [anon_sym_EQ] = ACTIONS(3793),
    [anon_sym_COLON] = ACTIONS(3817),
    [anon_sym_QMARK] = ACTIONS(3761),
    [anon_sym_STAR_EQ] = ACTIONS(3797),
    [anon_sym_SLASH_EQ] = ACTIONS(3797),
    [anon_sym_PERCENT_EQ] = ACTIONS(3797),
    [anon_sym_PLUS_EQ] = ACTIONS(3797),
    [anon_sym_DASH_EQ] = ACTIONS(3797),
    [anon_sym_LT_LT_EQ] = ACTIONS(3797),
    [anon_sym_GT_GT_EQ] = ACTIONS(3797),
    [anon_sym_AMP_EQ] = ACTIONS(3797),
    [anon_sym_CARET_EQ] = ACTIONS(3797),
    [anon_sym_PIPE_EQ] = ACTIONS(3797),
    [anon_sym_and_eq] = ACTIONS(3797),
    [anon_sym_or_eq] = ACTIONS(3797),
    [anon_sym_xor_eq] = ACTIONS(3797),
    [anon_sym_LT_EQ_GT] = ACTIONS(3761),
    [anon_sym_or] = ACTIONS(3769),
    [anon_sym_and] = ACTIONS(3769),
    [anon_sym_bitor] = ACTIONS(3761),
    [anon_sym_xor] = ACTIONS(3769),
    [anon_sym_bitand] = ACTIONS(3761),
    [anon_sym_not_eq] = ACTIONS(3761),
    [anon_sym_DASH_DASH] = ACTIONS(3761),
    [anon_sym_PLUS_PLUS] = ACTIONS(3761),
    [anon_sym_DOT] = ACTIONS(3769),
    [anon_sym_DOT_STAR] = ACTIONS(3761),
    [anon_sym_DASH_GT] = ACTIONS(3761),
    [anon_sym_L_DQUOTE] = ACTIONS(3204),
    [anon_sym_u_DQUOTE] = ACTIONS(3204),
    [anon_sym_U_DQUOTE] = ACTIONS(3204),
    [anon_sym_u8_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3204),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3208),
    [anon_sym_LR_DQUOTE] = ACTIONS(3208),
    [anon_sym_uR_DQUOTE] = ACTIONS(3208),
    [anon_sym_UR_DQUOTE] = ACTIONS(3208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3208),
  },
  [2191] = {
    [sym_identifier] = ACTIONS(2893),
    [aux_sym_preproc_def_token1] = ACTIONS(2893),
    [aux_sym_preproc_if_token1] = ACTIONS(2893),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2893),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2893),
    [sym_preproc_directive] = ACTIONS(2893),
    [anon_sym_LPAREN2] = ACTIONS(2895),
    [anon_sym_TILDE] = ACTIONS(2895),
    [anon_sym_STAR] = ACTIONS(2895),
    [anon_sym_AMP_AMP] = ACTIONS(2895),
    [anon_sym_AMP] = ACTIONS(2893),
    [anon_sym___extension__] = ACTIONS(2893),
    [anon_sym_typedef] = ACTIONS(2893),
    [anon_sym_extern] = ACTIONS(2893),
    [anon_sym___attribute__] = ACTIONS(2893),
    [anon_sym_COLON_COLON] = ACTIONS(2895),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2895),
    [anon_sym___declspec] = ACTIONS(2893),
    [anon_sym___based] = ACTIONS(2893),
    [anon_sym_RBRACE] = ACTIONS(2895),
    [anon_sym_signed] = ACTIONS(2893),
    [anon_sym_unsigned] = ACTIONS(2893),
    [anon_sym_long] = ACTIONS(2893),
    [anon_sym_short] = ACTIONS(2893),
    [anon_sym_LBRACK] = ACTIONS(2893),
    [anon_sym_static] = ACTIONS(2893),
    [anon_sym_register] = ACTIONS(2893),
    [anon_sym_inline] = ACTIONS(2893),
    [anon_sym___inline] = ACTIONS(2893),
    [anon_sym___inline__] = ACTIONS(2893),
    [anon_sym___forceinline] = ACTIONS(2893),
    [anon_sym_thread_local] = ACTIONS(2893),
    [anon_sym___thread] = ACTIONS(2893),
    [anon_sym_const] = ACTIONS(2893),
    [anon_sym_constexpr] = ACTIONS(2893),
    [anon_sym_volatile] = ACTIONS(2893),
    [anon_sym_restrict] = ACTIONS(2893),
    [anon_sym___restrict__] = ACTIONS(2893),
    [anon_sym__Atomic] = ACTIONS(2893),
    [anon_sym__Noreturn] = ACTIONS(2893),
    [anon_sym_noreturn] = ACTIONS(2893),
    [anon_sym_mutable] = ACTIONS(2893),
    [anon_sym_constinit] = ACTIONS(2893),
    [anon_sym_consteval] = ACTIONS(2893),
    [anon_sym_PROGMEM] = ACTIONS(2893),
    [aux_sym_primitive_type_token1] = ACTIONS(2893),
    [anon_sym_byte] = ACTIONS(2893),
    [anon_sym_word] = ACTIONS(2893),
    [anon_sym_enum] = ACTIONS(2893),
    [anon_sym_class] = ACTIONS(2893),
    [anon_sym_struct] = ACTIONS(2893),
    [anon_sym_union] = ACTIONS(2893),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2893),
    [anon_sym_decltype] = ACTIONS(2893),
    [anon_sym_virtual] = ACTIONS(2893),
    [anon_sym_alignas] = ACTIONS(2893),
    [anon_sym_explicit] = ACTIONS(2893),
    [anon_sym_typename] = ACTIONS(2893),
    [anon_sym_template] = ACTIONS(2893),
    [anon_sym_operator] = ACTIONS(2893),
    [anon_sym_friend] = ACTIONS(2893),
    [anon_sym_public] = ACTIONS(2893),
    [anon_sym_private] = ACTIONS(2893),
    [anon_sym_protected] = ACTIONS(2893),
    [anon_sym_using] = ACTIONS(2893),
    [anon_sym_static_assert] = ACTIONS(2893),
  },
  [2192] = {
    [sym_identifier] = ACTIONS(3078),
    [aux_sym_preproc_def_token1] = ACTIONS(3078),
    [aux_sym_preproc_if_token1] = ACTIONS(3078),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3078),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3078),
    [sym_preproc_directive] = ACTIONS(3078),
    [anon_sym_LPAREN2] = ACTIONS(3080),
    [anon_sym_TILDE] = ACTIONS(3080),
    [anon_sym_STAR] = ACTIONS(3080),
    [anon_sym_AMP_AMP] = ACTIONS(3080),
    [anon_sym_AMP] = ACTIONS(3078),
    [anon_sym___extension__] = ACTIONS(3078),
    [anon_sym_typedef] = ACTIONS(3078),
    [anon_sym_extern] = ACTIONS(3078),
    [anon_sym___attribute__] = ACTIONS(3078),
    [anon_sym_COLON_COLON] = ACTIONS(3080),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3080),
    [anon_sym___declspec] = ACTIONS(3078),
    [anon_sym___based] = ACTIONS(3078),
    [anon_sym_RBRACE] = ACTIONS(3080),
    [anon_sym_signed] = ACTIONS(3078),
    [anon_sym_unsigned] = ACTIONS(3078),
    [anon_sym_long] = ACTIONS(3078),
    [anon_sym_short] = ACTIONS(3078),
    [anon_sym_LBRACK] = ACTIONS(3078),
    [anon_sym_static] = ACTIONS(3078),
    [anon_sym_register] = ACTIONS(3078),
    [anon_sym_inline] = ACTIONS(3078),
    [anon_sym___inline] = ACTIONS(3078),
    [anon_sym___inline__] = ACTIONS(3078),
    [anon_sym___forceinline] = ACTIONS(3078),
    [anon_sym_thread_local] = ACTIONS(3078),
    [anon_sym___thread] = ACTIONS(3078),
    [anon_sym_const] = ACTIONS(3078),
    [anon_sym_constexpr] = ACTIONS(3078),
    [anon_sym_volatile] = ACTIONS(3078),
    [anon_sym_restrict] = ACTIONS(3078),
    [anon_sym___restrict__] = ACTIONS(3078),
    [anon_sym__Atomic] = ACTIONS(3078),
    [anon_sym__Noreturn] = ACTIONS(3078),
    [anon_sym_noreturn] = ACTIONS(3078),
    [anon_sym_mutable] = ACTIONS(3078),
    [anon_sym_constinit] = ACTIONS(3078),
    [anon_sym_consteval] = ACTIONS(3078),
    [anon_sym_PROGMEM] = ACTIONS(3078),
    [aux_sym_primitive_type_token1] = ACTIONS(3078),
    [anon_sym_byte] = ACTIONS(3078),
    [anon_sym_word] = ACTIONS(3078),
    [anon_sym_enum] = ACTIONS(3078),
    [anon_sym_class] = ACTIONS(3078),
    [anon_sym_struct] = ACTIONS(3078),
    [anon_sym_union] = ACTIONS(3078),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3078),
    [anon_sym_decltype] = ACTIONS(3078),
    [anon_sym_virtual] = ACTIONS(3078),
    [anon_sym_alignas] = ACTIONS(3078),
    [anon_sym_explicit] = ACTIONS(3078),
    [anon_sym_typename] = ACTIONS(3078),
    [anon_sym_template] = ACTIONS(3078),
    [anon_sym_operator] = ACTIONS(3078),
    [anon_sym_friend] = ACTIONS(3078),
    [anon_sym_public] = ACTIONS(3078),
    [anon_sym_private] = ACTIONS(3078),
    [anon_sym_protected] = ACTIONS(3078),
    [anon_sym_using] = ACTIONS(3078),
    [anon_sym_static_assert] = ACTIONS(3078),
  },
  [2193] = {
    [sym_identifier] = ACTIONS(4960),
    [aux_sym_preproc_def_token1] = ACTIONS(4960),
    [aux_sym_preproc_if_token1] = ACTIONS(4960),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4960),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4960),
    [sym_preproc_directive] = ACTIONS(4960),
    [anon_sym_LPAREN2] = ACTIONS(4962),
    [anon_sym_TILDE] = ACTIONS(4962),
    [anon_sym_STAR] = ACTIONS(4962),
    [anon_sym_AMP_AMP] = ACTIONS(4962),
    [anon_sym_AMP] = ACTIONS(4960),
    [anon_sym___extension__] = ACTIONS(4960),
    [anon_sym_typedef] = ACTIONS(4960),
    [anon_sym_extern] = ACTIONS(4960),
    [anon_sym___attribute__] = ACTIONS(4960),
    [anon_sym_COLON_COLON] = ACTIONS(4962),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4962),
    [anon_sym___declspec] = ACTIONS(4960),
    [anon_sym___based] = ACTIONS(4960),
    [anon_sym_RBRACE] = ACTIONS(4962),
    [anon_sym_signed] = ACTIONS(4960),
    [anon_sym_unsigned] = ACTIONS(4960),
    [anon_sym_long] = ACTIONS(4960),
    [anon_sym_short] = ACTIONS(4960),
    [anon_sym_LBRACK] = ACTIONS(4960),
    [anon_sym_static] = ACTIONS(4960),
    [anon_sym_register] = ACTIONS(4960),
    [anon_sym_inline] = ACTIONS(4960),
    [anon_sym___inline] = ACTIONS(4960),
    [anon_sym___inline__] = ACTIONS(4960),
    [anon_sym___forceinline] = ACTIONS(4960),
    [anon_sym_thread_local] = ACTIONS(4960),
    [anon_sym___thread] = ACTIONS(4960),
    [anon_sym_const] = ACTIONS(4960),
    [anon_sym_constexpr] = ACTIONS(4960),
    [anon_sym_volatile] = ACTIONS(4960),
    [anon_sym_restrict] = ACTIONS(4960),
    [anon_sym___restrict__] = ACTIONS(4960),
    [anon_sym__Atomic] = ACTIONS(4960),
    [anon_sym__Noreturn] = ACTIONS(4960),
    [anon_sym_noreturn] = ACTIONS(4960),
    [anon_sym_mutable] = ACTIONS(4960),
    [anon_sym_constinit] = ACTIONS(4960),
    [anon_sym_consteval] = ACTIONS(4960),
    [anon_sym_PROGMEM] = ACTIONS(4960),
    [aux_sym_primitive_type_token1] = ACTIONS(4960),
    [anon_sym_byte] = ACTIONS(4960),
    [anon_sym_word] = ACTIONS(4960),
    [anon_sym_enum] = ACTIONS(4960),
    [anon_sym_class] = ACTIONS(4960),
    [anon_sym_struct] = ACTIONS(4960),
    [anon_sym_union] = ACTIONS(4960),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4960),
    [anon_sym_decltype] = ACTIONS(4960),
    [anon_sym_virtual] = ACTIONS(4960),
    [anon_sym_alignas] = ACTIONS(4960),
    [anon_sym_explicit] = ACTIONS(4960),
    [anon_sym_typename] = ACTIONS(4960),
    [anon_sym_template] = ACTIONS(4960),
    [anon_sym_operator] = ACTIONS(4960),
    [anon_sym_friend] = ACTIONS(4960),
    [anon_sym_public] = ACTIONS(4960),
    [anon_sym_private] = ACTIONS(4960),
    [anon_sym_protected] = ACTIONS(4960),
    [anon_sym_using] = ACTIONS(4960),
    [anon_sym_static_assert] = ACTIONS(4960),
  },
  [2194] = {
    [sym_identifier] = ACTIONS(4964),
    [aux_sym_preproc_def_token1] = ACTIONS(4964),
    [aux_sym_preproc_if_token1] = ACTIONS(4964),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4964),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4964),
    [sym_preproc_directive] = ACTIONS(4964),
    [anon_sym_LPAREN2] = ACTIONS(4966),
    [anon_sym_TILDE] = ACTIONS(4966),
    [anon_sym_STAR] = ACTIONS(4966),
    [anon_sym_AMP_AMP] = ACTIONS(4966),
    [anon_sym_AMP] = ACTIONS(4964),
    [anon_sym___extension__] = ACTIONS(4964),
    [anon_sym_typedef] = ACTIONS(4964),
    [anon_sym_extern] = ACTIONS(4964),
    [anon_sym___attribute__] = ACTIONS(4964),
    [anon_sym_COLON_COLON] = ACTIONS(4966),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4966),
    [anon_sym___declspec] = ACTIONS(4964),
    [anon_sym___based] = ACTIONS(4964),
    [anon_sym_RBRACE] = ACTIONS(4966),
    [anon_sym_signed] = ACTIONS(4964),
    [anon_sym_unsigned] = ACTIONS(4964),
    [anon_sym_long] = ACTIONS(4964),
    [anon_sym_short] = ACTIONS(4964),
    [anon_sym_LBRACK] = ACTIONS(4964),
    [anon_sym_static] = ACTIONS(4964),
    [anon_sym_register] = ACTIONS(4964),
    [anon_sym_inline] = ACTIONS(4964),
    [anon_sym___inline] = ACTIONS(4964),
    [anon_sym___inline__] = ACTIONS(4964),
    [anon_sym___forceinline] = ACTIONS(4964),
    [anon_sym_thread_local] = ACTIONS(4964),
    [anon_sym___thread] = ACTIONS(4964),
    [anon_sym_const] = ACTIONS(4964),
    [anon_sym_constexpr] = ACTIONS(4964),
    [anon_sym_volatile] = ACTIONS(4964),
    [anon_sym_restrict] = ACTIONS(4964),
    [anon_sym___restrict__] = ACTIONS(4964),
    [anon_sym__Atomic] = ACTIONS(4964),
    [anon_sym__Noreturn] = ACTIONS(4964),
    [anon_sym_noreturn] = ACTIONS(4964),
    [anon_sym_mutable] = ACTIONS(4964),
    [anon_sym_constinit] = ACTIONS(4964),
    [anon_sym_consteval] = ACTIONS(4964),
    [anon_sym_PROGMEM] = ACTIONS(4964),
    [aux_sym_primitive_type_token1] = ACTIONS(4964),
    [anon_sym_byte] = ACTIONS(4964),
    [anon_sym_word] = ACTIONS(4964),
    [anon_sym_enum] = ACTIONS(4964),
    [anon_sym_class] = ACTIONS(4964),
    [anon_sym_struct] = ACTIONS(4964),
    [anon_sym_union] = ACTIONS(4964),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4964),
    [anon_sym_decltype] = ACTIONS(4964),
    [anon_sym_virtual] = ACTIONS(4964),
    [anon_sym_alignas] = ACTIONS(4964),
    [anon_sym_explicit] = ACTIONS(4964),
    [anon_sym_typename] = ACTIONS(4964),
    [anon_sym_template] = ACTIONS(4964),
    [anon_sym_operator] = ACTIONS(4964),
    [anon_sym_friend] = ACTIONS(4964),
    [anon_sym_public] = ACTIONS(4964),
    [anon_sym_private] = ACTIONS(4964),
    [anon_sym_protected] = ACTIONS(4964),
    [anon_sym_using] = ACTIONS(4964),
    [anon_sym_static_assert] = ACTIONS(4964),
  },
  [2195] = {
    [sym_identifier] = ACTIONS(2751),
    [aux_sym_preproc_def_token1] = ACTIONS(2751),
    [aux_sym_preproc_if_token1] = ACTIONS(2751),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2751),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2751),
    [sym_preproc_directive] = ACTIONS(2751),
    [anon_sym_LPAREN2] = ACTIONS(2753),
    [anon_sym_TILDE] = ACTIONS(2753),
    [anon_sym_STAR] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2751),
    [anon_sym___extension__] = ACTIONS(2751),
    [anon_sym_typedef] = ACTIONS(2751),
    [anon_sym_extern] = ACTIONS(2751),
    [anon_sym___attribute__] = ACTIONS(2751),
    [anon_sym_COLON_COLON] = ACTIONS(2753),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2753),
    [anon_sym___declspec] = ACTIONS(2751),
    [anon_sym___based] = ACTIONS(2751),
    [anon_sym_RBRACE] = ACTIONS(2753),
    [anon_sym_signed] = ACTIONS(2751),
    [anon_sym_unsigned] = ACTIONS(2751),
    [anon_sym_long] = ACTIONS(2751),
    [anon_sym_short] = ACTIONS(2751),
    [anon_sym_LBRACK] = ACTIONS(2751),
    [anon_sym_static] = ACTIONS(2751),
    [anon_sym_register] = ACTIONS(2751),
    [anon_sym_inline] = ACTIONS(2751),
    [anon_sym___inline] = ACTIONS(2751),
    [anon_sym___inline__] = ACTIONS(2751),
    [anon_sym___forceinline] = ACTIONS(2751),
    [anon_sym_thread_local] = ACTIONS(2751),
    [anon_sym___thread] = ACTIONS(2751),
    [anon_sym_const] = ACTIONS(2751),
    [anon_sym_constexpr] = ACTIONS(2751),
    [anon_sym_volatile] = ACTIONS(2751),
    [anon_sym_restrict] = ACTIONS(2751),
    [anon_sym___restrict__] = ACTIONS(2751),
    [anon_sym__Atomic] = ACTIONS(2751),
    [anon_sym__Noreturn] = ACTIONS(2751),
    [anon_sym_noreturn] = ACTIONS(2751),
    [anon_sym_mutable] = ACTIONS(2751),
    [anon_sym_constinit] = ACTIONS(2751),
    [anon_sym_consteval] = ACTIONS(2751),
    [anon_sym_PROGMEM] = ACTIONS(2751),
    [aux_sym_primitive_type_token1] = ACTIONS(2751),
    [anon_sym_byte] = ACTIONS(2751),
    [anon_sym_word] = ACTIONS(2751),
    [anon_sym_enum] = ACTIONS(2751),
    [anon_sym_class] = ACTIONS(2751),
    [anon_sym_struct] = ACTIONS(2751),
    [anon_sym_union] = ACTIONS(2751),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2751),
    [anon_sym_decltype] = ACTIONS(2751),
    [anon_sym_virtual] = ACTIONS(2751),
    [anon_sym_alignas] = ACTIONS(2751),
    [anon_sym_explicit] = ACTIONS(2751),
    [anon_sym_typename] = ACTIONS(2751),
    [anon_sym_template] = ACTIONS(2751),
    [anon_sym_operator] = ACTIONS(2751),
    [anon_sym_friend] = ACTIONS(2751),
    [anon_sym_public] = ACTIONS(2751),
    [anon_sym_private] = ACTIONS(2751),
    [anon_sym_protected] = ACTIONS(2751),
    [anon_sym_using] = ACTIONS(2751),
    [anon_sym_static_assert] = ACTIONS(2751),
  },
  [2196] = {
    [sym_identifier] = ACTIONS(5074),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5076),
    [anon_sym_COMMA] = ACTIONS(5076),
    [anon_sym_RPAREN] = ACTIONS(5076),
    [aux_sym_preproc_if_token2] = ACTIONS(5076),
    [aux_sym_preproc_else_token1] = ACTIONS(5076),
    [aux_sym_preproc_elif_token1] = ACTIONS(5074),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5076),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5076),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_DASH] = ACTIONS(5074),
    [anon_sym_PLUS] = ACTIONS(5074),
    [anon_sym_STAR] = ACTIONS(5076),
    [anon_sym_SLASH] = ACTIONS(5074),
    [anon_sym_PERCENT] = ACTIONS(5076),
    [anon_sym_PIPE_PIPE] = ACTIONS(5076),
    [anon_sym_AMP_AMP] = ACTIONS(5076),
    [anon_sym_PIPE] = ACTIONS(5074),
    [anon_sym_CARET] = ACTIONS(5076),
    [anon_sym_AMP] = ACTIONS(5074),
    [anon_sym_EQ_EQ] = ACTIONS(5076),
    [anon_sym_BANG_EQ] = ACTIONS(5076),
    [anon_sym_GT] = ACTIONS(5074),
    [anon_sym_GT_EQ] = ACTIONS(5076),
    [anon_sym_LT_EQ] = ACTIONS(5074),
    [anon_sym_LT] = ACTIONS(5074),
    [anon_sym_LT_LT] = ACTIONS(5076),
    [anon_sym_GT_GT] = ACTIONS(5076),
    [anon_sym_SEMI] = ACTIONS(5076),
    [anon_sym___extension__] = ACTIONS(5074),
    [anon_sym___attribute__] = ACTIONS(5074),
    [anon_sym_LBRACE] = ACTIONS(5076),
    [anon_sym_RBRACE] = ACTIONS(5076),
    [anon_sym_LBRACK] = ACTIONS(5076),
    [anon_sym_RBRACK] = ACTIONS(5076),
    [anon_sym_const] = ACTIONS(5074),
    [anon_sym_constexpr] = ACTIONS(5074),
    [anon_sym_volatile] = ACTIONS(5074),
    [anon_sym_restrict] = ACTIONS(5074),
    [anon_sym___restrict__] = ACTIONS(5074),
    [anon_sym__Atomic] = ACTIONS(5074),
    [anon_sym__Noreturn] = ACTIONS(5074),
    [anon_sym_noreturn] = ACTIONS(5074),
    [anon_sym_mutable] = ACTIONS(5074),
    [anon_sym_constinit] = ACTIONS(5074),
    [anon_sym_consteval] = ACTIONS(5074),
    [anon_sym_PROGMEM] = ACTIONS(5074),
    [anon_sym_COLON] = ACTIONS(5076),
    [anon_sym_QMARK] = ACTIONS(5076),
    [anon_sym_LT_EQ_GT] = ACTIONS(5076),
    [anon_sym_or] = ACTIONS(5074),
    [anon_sym_and] = ACTIONS(5074),
    [anon_sym_bitor] = ACTIONS(5074),
    [anon_sym_xor] = ACTIONS(5074),
    [anon_sym_bitand] = ACTIONS(5074),
    [anon_sym_not_eq] = ACTIONS(5074),
    [anon_sym_DASH_DASH] = ACTIONS(5076),
    [anon_sym_PLUS_PLUS] = ACTIONS(5076),
    [anon_sym_DOT] = ACTIONS(5074),
    [anon_sym_DOT_STAR] = ACTIONS(5076),
    [anon_sym_DASH_GT] = ACTIONS(5076),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5074),
    [anon_sym_decltype] = ACTIONS(5074),
    [anon_sym_final] = ACTIONS(5074),
    [anon_sym_override] = ACTIONS(5074),
    [anon_sym_requires] = ACTIONS(5074),
  },
  [2197] = {
    [sym_identifier] = ACTIONS(4898),
    [aux_sym_preproc_def_token1] = ACTIONS(4898),
    [aux_sym_preproc_if_token1] = ACTIONS(4898),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4898),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4898),
    [sym_preproc_directive] = ACTIONS(4898),
    [anon_sym_LPAREN2] = ACTIONS(4900),
    [anon_sym_TILDE] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_AMP_AMP] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4898),
    [anon_sym___extension__] = ACTIONS(4898),
    [anon_sym_typedef] = ACTIONS(4898),
    [anon_sym_extern] = ACTIONS(4898),
    [anon_sym___attribute__] = ACTIONS(4898),
    [anon_sym_COLON_COLON] = ACTIONS(4900),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4900),
    [anon_sym___declspec] = ACTIONS(4898),
    [anon_sym___based] = ACTIONS(4898),
    [anon_sym_RBRACE] = ACTIONS(4900),
    [anon_sym_signed] = ACTIONS(4898),
    [anon_sym_unsigned] = ACTIONS(4898),
    [anon_sym_long] = ACTIONS(4898),
    [anon_sym_short] = ACTIONS(4898),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_static] = ACTIONS(4898),
    [anon_sym_register] = ACTIONS(4898),
    [anon_sym_inline] = ACTIONS(4898),
    [anon_sym___inline] = ACTIONS(4898),
    [anon_sym___inline__] = ACTIONS(4898),
    [anon_sym___forceinline] = ACTIONS(4898),
    [anon_sym_thread_local] = ACTIONS(4898),
    [anon_sym___thread] = ACTIONS(4898),
    [anon_sym_const] = ACTIONS(4898),
    [anon_sym_constexpr] = ACTIONS(4898),
    [anon_sym_volatile] = ACTIONS(4898),
    [anon_sym_restrict] = ACTIONS(4898),
    [anon_sym___restrict__] = ACTIONS(4898),
    [anon_sym__Atomic] = ACTIONS(4898),
    [anon_sym__Noreturn] = ACTIONS(4898),
    [anon_sym_noreturn] = ACTIONS(4898),
    [anon_sym_mutable] = ACTIONS(4898),
    [anon_sym_constinit] = ACTIONS(4898),
    [anon_sym_consteval] = ACTIONS(4898),
    [anon_sym_PROGMEM] = ACTIONS(4898),
    [aux_sym_primitive_type_token1] = ACTIONS(4898),
    [anon_sym_byte] = ACTIONS(4898),
    [anon_sym_word] = ACTIONS(4898),
    [anon_sym_enum] = ACTIONS(4898),
    [anon_sym_class] = ACTIONS(4898),
    [anon_sym_struct] = ACTIONS(4898),
    [anon_sym_union] = ACTIONS(4898),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4898),
    [anon_sym_decltype] = ACTIONS(4898),
    [anon_sym_virtual] = ACTIONS(4898),
    [anon_sym_alignas] = ACTIONS(4898),
    [anon_sym_explicit] = ACTIONS(4898),
    [anon_sym_typename] = ACTIONS(4898),
    [anon_sym_template] = ACTIONS(4898),
    [anon_sym_operator] = ACTIONS(4898),
    [anon_sym_friend] = ACTIONS(4898),
    [anon_sym_public] = ACTIONS(4898),
    [anon_sym_private] = ACTIONS(4898),
    [anon_sym_protected] = ACTIONS(4898),
    [anon_sym_using] = ACTIONS(4898),
    [anon_sym_static_assert] = ACTIONS(4898),
  },
  [2198] = {
    [sym_identifier] = ACTIONS(2893),
    [aux_sym_preproc_def_token1] = ACTIONS(2893),
    [aux_sym_preproc_if_token1] = ACTIONS(2893),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2893),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2893),
    [sym_preproc_directive] = ACTIONS(2893),
    [anon_sym_LPAREN2] = ACTIONS(2895),
    [anon_sym_TILDE] = ACTIONS(2895),
    [anon_sym_STAR] = ACTIONS(2895),
    [anon_sym_AMP_AMP] = ACTIONS(2895),
    [anon_sym_AMP] = ACTIONS(2893),
    [anon_sym___extension__] = ACTIONS(2893),
    [anon_sym_typedef] = ACTIONS(2893),
    [anon_sym_extern] = ACTIONS(2893),
    [anon_sym___attribute__] = ACTIONS(2893),
    [anon_sym_COLON_COLON] = ACTIONS(2895),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2895),
    [anon_sym___declspec] = ACTIONS(2893),
    [anon_sym___based] = ACTIONS(2893),
    [anon_sym_RBRACE] = ACTIONS(2895),
    [anon_sym_signed] = ACTIONS(2893),
    [anon_sym_unsigned] = ACTIONS(2893),
    [anon_sym_long] = ACTIONS(2893),
    [anon_sym_short] = ACTIONS(2893),
    [anon_sym_LBRACK] = ACTIONS(2893),
    [anon_sym_static] = ACTIONS(2893),
    [anon_sym_register] = ACTIONS(2893),
    [anon_sym_inline] = ACTIONS(2893),
    [anon_sym___inline] = ACTIONS(2893),
    [anon_sym___inline__] = ACTIONS(2893),
    [anon_sym___forceinline] = ACTIONS(2893),
    [anon_sym_thread_local] = ACTIONS(2893),
    [anon_sym___thread] = ACTIONS(2893),
    [anon_sym_const] = ACTIONS(2893),
    [anon_sym_constexpr] = ACTIONS(2893),
    [anon_sym_volatile] = ACTIONS(2893),
    [anon_sym_restrict] = ACTIONS(2893),
    [anon_sym___restrict__] = ACTIONS(2893),
    [anon_sym__Atomic] = ACTIONS(2893),
    [anon_sym__Noreturn] = ACTIONS(2893),
    [anon_sym_noreturn] = ACTIONS(2893),
    [anon_sym_mutable] = ACTIONS(2893),
    [anon_sym_constinit] = ACTIONS(2893),
    [anon_sym_consteval] = ACTIONS(2893),
    [anon_sym_PROGMEM] = ACTIONS(2893),
    [aux_sym_primitive_type_token1] = ACTIONS(2893),
    [anon_sym_byte] = ACTIONS(2893),
    [anon_sym_word] = ACTIONS(2893),
    [anon_sym_enum] = ACTIONS(2893),
    [anon_sym_class] = ACTIONS(2893),
    [anon_sym_struct] = ACTIONS(2893),
    [anon_sym_union] = ACTIONS(2893),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2893),
    [anon_sym_decltype] = ACTIONS(2893),
    [anon_sym_virtual] = ACTIONS(2893),
    [anon_sym_alignas] = ACTIONS(2893),
    [anon_sym_explicit] = ACTIONS(2893),
    [anon_sym_typename] = ACTIONS(2893),
    [anon_sym_template] = ACTIONS(2893),
    [anon_sym_operator] = ACTIONS(2893),
    [anon_sym_friend] = ACTIONS(2893),
    [anon_sym_public] = ACTIONS(2893),
    [anon_sym_private] = ACTIONS(2893),
    [anon_sym_protected] = ACTIONS(2893),
    [anon_sym_using] = ACTIONS(2893),
    [anon_sym_static_assert] = ACTIONS(2893),
  },
  [2199] = {
    [sym_identifier] = ACTIONS(4914),
    [aux_sym_preproc_def_token1] = ACTIONS(4914),
    [aux_sym_preproc_if_token1] = ACTIONS(4914),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4914),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4914),
    [sym_preproc_directive] = ACTIONS(4914),
    [anon_sym_LPAREN2] = ACTIONS(4916),
    [anon_sym_TILDE] = ACTIONS(4916),
    [anon_sym_STAR] = ACTIONS(4916),
    [anon_sym_AMP_AMP] = ACTIONS(4916),
    [anon_sym_AMP] = ACTIONS(4914),
    [anon_sym___extension__] = ACTIONS(4914),
    [anon_sym_typedef] = ACTIONS(4914),
    [anon_sym_extern] = ACTIONS(4914),
    [anon_sym___attribute__] = ACTIONS(4914),
    [anon_sym_COLON_COLON] = ACTIONS(4916),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4916),
    [anon_sym___declspec] = ACTIONS(4914),
    [anon_sym___based] = ACTIONS(4914),
    [anon_sym_RBRACE] = ACTIONS(4916),
    [anon_sym_signed] = ACTIONS(4914),
    [anon_sym_unsigned] = ACTIONS(4914),
    [anon_sym_long] = ACTIONS(4914),
    [anon_sym_short] = ACTIONS(4914),
    [anon_sym_LBRACK] = ACTIONS(4914),
    [anon_sym_static] = ACTIONS(4914),
    [anon_sym_register] = ACTIONS(4914),
    [anon_sym_inline] = ACTIONS(4914),
    [anon_sym___inline] = ACTIONS(4914),
    [anon_sym___inline__] = ACTIONS(4914),
    [anon_sym___forceinline] = ACTIONS(4914),
    [anon_sym_thread_local] = ACTIONS(4914),
    [anon_sym___thread] = ACTIONS(4914),
    [anon_sym_const] = ACTIONS(4914),
    [anon_sym_constexpr] = ACTIONS(4914),
    [anon_sym_volatile] = ACTIONS(4914),
    [anon_sym_restrict] = ACTIONS(4914),
    [anon_sym___restrict__] = ACTIONS(4914),
    [anon_sym__Atomic] = ACTIONS(4914),
    [anon_sym__Noreturn] = ACTIONS(4914),
    [anon_sym_noreturn] = ACTIONS(4914),
    [anon_sym_mutable] = ACTIONS(4914),
    [anon_sym_constinit] = ACTIONS(4914),
    [anon_sym_consteval] = ACTIONS(4914),
    [anon_sym_PROGMEM] = ACTIONS(4914),
    [aux_sym_primitive_type_token1] = ACTIONS(4914),
    [anon_sym_byte] = ACTIONS(4914),
    [anon_sym_word] = ACTIONS(4914),
    [anon_sym_enum] = ACTIONS(4914),
    [anon_sym_class] = ACTIONS(4914),
    [anon_sym_struct] = ACTIONS(4914),
    [anon_sym_union] = ACTIONS(4914),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4914),
    [anon_sym_decltype] = ACTIONS(4914),
    [anon_sym_virtual] = ACTIONS(4914),
    [anon_sym_alignas] = ACTIONS(4914),
    [anon_sym_explicit] = ACTIONS(4914),
    [anon_sym_typename] = ACTIONS(4914),
    [anon_sym_template] = ACTIONS(4914),
    [anon_sym_operator] = ACTIONS(4914),
    [anon_sym_friend] = ACTIONS(4914),
    [anon_sym_public] = ACTIONS(4914),
    [anon_sym_private] = ACTIONS(4914),
    [anon_sym_protected] = ACTIONS(4914),
    [anon_sym_using] = ACTIONS(4914),
    [anon_sym_static_assert] = ACTIONS(4914),
  },
  [2200] = {
    [sym_identifier] = ACTIONS(4914),
    [aux_sym_preproc_def_token1] = ACTIONS(4914),
    [aux_sym_preproc_if_token1] = ACTIONS(4914),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4914),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4914),
    [sym_preproc_directive] = ACTIONS(4914),
    [anon_sym_LPAREN2] = ACTIONS(4916),
    [anon_sym_TILDE] = ACTIONS(4916),
    [anon_sym_STAR] = ACTIONS(4916),
    [anon_sym_AMP_AMP] = ACTIONS(4916),
    [anon_sym_AMP] = ACTIONS(4914),
    [anon_sym___extension__] = ACTIONS(4914),
    [anon_sym_typedef] = ACTIONS(4914),
    [anon_sym_extern] = ACTIONS(4914),
    [anon_sym___attribute__] = ACTIONS(4914),
    [anon_sym_COLON_COLON] = ACTIONS(4916),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4916),
    [anon_sym___declspec] = ACTIONS(4914),
    [anon_sym___based] = ACTIONS(4914),
    [anon_sym_RBRACE] = ACTIONS(4916),
    [anon_sym_signed] = ACTIONS(4914),
    [anon_sym_unsigned] = ACTIONS(4914),
    [anon_sym_long] = ACTIONS(4914),
    [anon_sym_short] = ACTIONS(4914),
    [anon_sym_LBRACK] = ACTIONS(4914),
    [anon_sym_static] = ACTIONS(4914),
    [anon_sym_register] = ACTIONS(4914),
    [anon_sym_inline] = ACTIONS(4914),
    [anon_sym___inline] = ACTIONS(4914),
    [anon_sym___inline__] = ACTIONS(4914),
    [anon_sym___forceinline] = ACTIONS(4914),
    [anon_sym_thread_local] = ACTIONS(4914),
    [anon_sym___thread] = ACTIONS(4914),
    [anon_sym_const] = ACTIONS(4914),
    [anon_sym_constexpr] = ACTIONS(4914),
    [anon_sym_volatile] = ACTIONS(4914),
    [anon_sym_restrict] = ACTIONS(4914),
    [anon_sym___restrict__] = ACTIONS(4914),
    [anon_sym__Atomic] = ACTIONS(4914),
    [anon_sym__Noreturn] = ACTIONS(4914),
    [anon_sym_noreturn] = ACTIONS(4914),
    [anon_sym_mutable] = ACTIONS(4914),
    [anon_sym_constinit] = ACTIONS(4914),
    [anon_sym_consteval] = ACTIONS(4914),
    [anon_sym_PROGMEM] = ACTIONS(4914),
    [aux_sym_primitive_type_token1] = ACTIONS(4914),
    [anon_sym_byte] = ACTIONS(4914),
    [anon_sym_word] = ACTIONS(4914),
    [anon_sym_enum] = ACTIONS(4914),
    [anon_sym_class] = ACTIONS(4914),
    [anon_sym_struct] = ACTIONS(4914),
    [anon_sym_union] = ACTIONS(4914),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4914),
    [anon_sym_decltype] = ACTIONS(4914),
    [anon_sym_virtual] = ACTIONS(4914),
    [anon_sym_alignas] = ACTIONS(4914),
    [anon_sym_explicit] = ACTIONS(4914),
    [anon_sym_typename] = ACTIONS(4914),
    [anon_sym_template] = ACTIONS(4914),
    [anon_sym_operator] = ACTIONS(4914),
    [anon_sym_friend] = ACTIONS(4914),
    [anon_sym_public] = ACTIONS(4914),
    [anon_sym_private] = ACTIONS(4914),
    [anon_sym_protected] = ACTIONS(4914),
    [anon_sym_using] = ACTIONS(4914),
    [anon_sym_static_assert] = ACTIONS(4914),
  },
  [2201] = {
    [sym_identifier] = ACTIONS(3160),
    [aux_sym_preproc_def_token1] = ACTIONS(3160),
    [aux_sym_preproc_if_token1] = ACTIONS(3160),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3160),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3160),
    [sym_preproc_directive] = ACTIONS(3160),
    [anon_sym_LPAREN2] = ACTIONS(3162),
    [anon_sym_TILDE] = ACTIONS(3162),
    [anon_sym_STAR] = ACTIONS(3162),
    [anon_sym_AMP_AMP] = ACTIONS(3162),
    [anon_sym_AMP] = ACTIONS(3160),
    [anon_sym___extension__] = ACTIONS(3160),
    [anon_sym_typedef] = ACTIONS(3160),
    [anon_sym_extern] = ACTIONS(3160),
    [anon_sym___attribute__] = ACTIONS(3160),
    [anon_sym_COLON_COLON] = ACTIONS(3162),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3162),
    [anon_sym___declspec] = ACTIONS(3160),
    [anon_sym___based] = ACTIONS(3160),
    [anon_sym_RBRACE] = ACTIONS(3162),
    [anon_sym_signed] = ACTIONS(3160),
    [anon_sym_unsigned] = ACTIONS(3160),
    [anon_sym_long] = ACTIONS(3160),
    [anon_sym_short] = ACTIONS(3160),
    [anon_sym_LBRACK] = ACTIONS(3160),
    [anon_sym_static] = ACTIONS(3160),
    [anon_sym_register] = ACTIONS(3160),
    [anon_sym_inline] = ACTIONS(3160),
    [anon_sym___inline] = ACTIONS(3160),
    [anon_sym___inline__] = ACTIONS(3160),
    [anon_sym___forceinline] = ACTIONS(3160),
    [anon_sym_thread_local] = ACTIONS(3160),
    [anon_sym___thread] = ACTIONS(3160),
    [anon_sym_const] = ACTIONS(3160),
    [anon_sym_constexpr] = ACTIONS(3160),
    [anon_sym_volatile] = ACTIONS(3160),
    [anon_sym_restrict] = ACTIONS(3160),
    [anon_sym___restrict__] = ACTIONS(3160),
    [anon_sym__Atomic] = ACTIONS(3160),
    [anon_sym__Noreturn] = ACTIONS(3160),
    [anon_sym_noreturn] = ACTIONS(3160),
    [anon_sym_mutable] = ACTIONS(3160),
    [anon_sym_constinit] = ACTIONS(3160),
    [anon_sym_consteval] = ACTIONS(3160),
    [anon_sym_PROGMEM] = ACTIONS(3160),
    [aux_sym_primitive_type_token1] = ACTIONS(3160),
    [anon_sym_byte] = ACTIONS(3160),
    [anon_sym_word] = ACTIONS(3160),
    [anon_sym_enum] = ACTIONS(3160),
    [anon_sym_class] = ACTIONS(3160),
    [anon_sym_struct] = ACTIONS(3160),
    [anon_sym_union] = ACTIONS(3160),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3160),
    [anon_sym_decltype] = ACTIONS(3160),
    [anon_sym_virtual] = ACTIONS(3160),
    [anon_sym_alignas] = ACTIONS(3160),
    [anon_sym_explicit] = ACTIONS(3160),
    [anon_sym_typename] = ACTIONS(3160),
    [anon_sym_template] = ACTIONS(3160),
    [anon_sym_operator] = ACTIONS(3160),
    [anon_sym_friend] = ACTIONS(3160),
    [anon_sym_public] = ACTIONS(3160),
    [anon_sym_private] = ACTIONS(3160),
    [anon_sym_protected] = ACTIONS(3160),
    [anon_sym_using] = ACTIONS(3160),
    [anon_sym_static_assert] = ACTIONS(3160),
  },
  [2202] = {
    [sym_identifier] = ACTIONS(5004),
    [aux_sym_preproc_def_token1] = ACTIONS(5004),
    [aux_sym_preproc_if_token1] = ACTIONS(5004),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5004),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5004),
    [sym_preproc_directive] = ACTIONS(5004),
    [anon_sym_LPAREN2] = ACTIONS(5006),
    [anon_sym_TILDE] = ACTIONS(5006),
    [anon_sym_STAR] = ACTIONS(5006),
    [anon_sym_AMP_AMP] = ACTIONS(5006),
    [anon_sym_AMP] = ACTIONS(5004),
    [anon_sym___extension__] = ACTIONS(5004),
    [anon_sym_typedef] = ACTIONS(5004),
    [anon_sym_extern] = ACTIONS(5004),
    [anon_sym___attribute__] = ACTIONS(5004),
    [anon_sym_COLON_COLON] = ACTIONS(5006),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5006),
    [anon_sym___declspec] = ACTIONS(5004),
    [anon_sym___based] = ACTIONS(5004),
    [anon_sym_RBRACE] = ACTIONS(5006),
    [anon_sym_signed] = ACTIONS(5004),
    [anon_sym_unsigned] = ACTIONS(5004),
    [anon_sym_long] = ACTIONS(5004),
    [anon_sym_short] = ACTIONS(5004),
    [anon_sym_LBRACK] = ACTIONS(5004),
    [anon_sym_static] = ACTIONS(5004),
    [anon_sym_register] = ACTIONS(5004),
    [anon_sym_inline] = ACTIONS(5004),
    [anon_sym___inline] = ACTIONS(5004),
    [anon_sym___inline__] = ACTIONS(5004),
    [anon_sym___forceinline] = ACTIONS(5004),
    [anon_sym_thread_local] = ACTIONS(5004),
    [anon_sym___thread] = ACTIONS(5004),
    [anon_sym_const] = ACTIONS(5004),
    [anon_sym_constexpr] = ACTIONS(5004),
    [anon_sym_volatile] = ACTIONS(5004),
    [anon_sym_restrict] = ACTIONS(5004),
    [anon_sym___restrict__] = ACTIONS(5004),
    [anon_sym__Atomic] = ACTIONS(5004),
    [anon_sym__Noreturn] = ACTIONS(5004),
    [anon_sym_noreturn] = ACTIONS(5004),
    [anon_sym_mutable] = ACTIONS(5004),
    [anon_sym_constinit] = ACTIONS(5004),
    [anon_sym_consteval] = ACTIONS(5004),
    [anon_sym_PROGMEM] = ACTIONS(5004),
    [aux_sym_primitive_type_token1] = ACTIONS(5004),
    [anon_sym_byte] = ACTIONS(5004),
    [anon_sym_word] = ACTIONS(5004),
    [anon_sym_enum] = ACTIONS(5004),
    [anon_sym_class] = ACTIONS(5004),
    [anon_sym_struct] = ACTIONS(5004),
    [anon_sym_union] = ACTIONS(5004),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5004),
    [anon_sym_decltype] = ACTIONS(5004),
    [anon_sym_virtual] = ACTIONS(5004),
    [anon_sym_alignas] = ACTIONS(5004),
    [anon_sym_explicit] = ACTIONS(5004),
    [anon_sym_typename] = ACTIONS(5004),
    [anon_sym_template] = ACTIONS(5004),
    [anon_sym_operator] = ACTIONS(5004),
    [anon_sym_friend] = ACTIONS(5004),
    [anon_sym_public] = ACTIONS(5004),
    [anon_sym_private] = ACTIONS(5004),
    [anon_sym_protected] = ACTIONS(5004),
    [anon_sym_using] = ACTIONS(5004),
    [anon_sym_static_assert] = ACTIONS(5004),
  },
  [2203] = {
    [sym_identifier] = ACTIONS(2941),
    [aux_sym_preproc_def_token1] = ACTIONS(2941),
    [aux_sym_preproc_if_token1] = ACTIONS(2941),
    [aux_sym_preproc_if_token2] = ACTIONS(2941),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2941),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2941),
    [sym_preproc_directive] = ACTIONS(2941),
    [anon_sym_LPAREN2] = ACTIONS(2943),
    [anon_sym_TILDE] = ACTIONS(2943),
    [anon_sym_STAR] = ACTIONS(2943),
    [anon_sym_AMP_AMP] = ACTIONS(2943),
    [anon_sym_AMP] = ACTIONS(2941),
    [anon_sym___extension__] = ACTIONS(2941),
    [anon_sym_typedef] = ACTIONS(2941),
    [anon_sym_extern] = ACTIONS(2941),
    [anon_sym___attribute__] = ACTIONS(2941),
    [anon_sym_COLON_COLON] = ACTIONS(2943),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2943),
    [anon_sym___declspec] = ACTIONS(2941),
    [anon_sym___based] = ACTIONS(2941),
    [anon_sym_signed] = ACTIONS(2941),
    [anon_sym_unsigned] = ACTIONS(2941),
    [anon_sym_long] = ACTIONS(2941),
    [anon_sym_short] = ACTIONS(2941),
    [anon_sym_LBRACK] = ACTIONS(2941),
    [anon_sym_static] = ACTIONS(2941),
    [anon_sym_register] = ACTIONS(2941),
    [anon_sym_inline] = ACTIONS(2941),
    [anon_sym___inline] = ACTIONS(2941),
    [anon_sym___inline__] = ACTIONS(2941),
    [anon_sym___forceinline] = ACTIONS(2941),
    [anon_sym_thread_local] = ACTIONS(2941),
    [anon_sym___thread] = ACTIONS(2941),
    [anon_sym_const] = ACTIONS(2941),
    [anon_sym_constexpr] = ACTIONS(2941),
    [anon_sym_volatile] = ACTIONS(2941),
    [anon_sym_restrict] = ACTIONS(2941),
    [anon_sym___restrict__] = ACTIONS(2941),
    [anon_sym__Atomic] = ACTIONS(2941),
    [anon_sym__Noreturn] = ACTIONS(2941),
    [anon_sym_noreturn] = ACTIONS(2941),
    [anon_sym_mutable] = ACTIONS(2941),
    [anon_sym_constinit] = ACTIONS(2941),
    [anon_sym_consteval] = ACTIONS(2941),
    [anon_sym_PROGMEM] = ACTIONS(2941),
    [aux_sym_primitive_type_token1] = ACTIONS(2941),
    [anon_sym_byte] = ACTIONS(2941),
    [anon_sym_word] = ACTIONS(2941),
    [anon_sym_enum] = ACTIONS(2941),
    [anon_sym_class] = ACTIONS(2941),
    [anon_sym_struct] = ACTIONS(2941),
    [anon_sym_union] = ACTIONS(2941),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2941),
    [anon_sym_decltype] = ACTIONS(2941),
    [anon_sym_virtual] = ACTIONS(2941),
    [anon_sym_alignas] = ACTIONS(2941),
    [anon_sym_explicit] = ACTIONS(2941),
    [anon_sym_typename] = ACTIONS(2941),
    [anon_sym_template] = ACTIONS(2941),
    [anon_sym_operator] = ACTIONS(2941),
    [anon_sym_friend] = ACTIONS(2941),
    [anon_sym_public] = ACTIONS(2941),
    [anon_sym_private] = ACTIONS(2941),
    [anon_sym_protected] = ACTIONS(2941),
    [anon_sym_using] = ACTIONS(2941),
    [anon_sym_static_assert] = ACTIONS(2941),
  },
  [2204] = {
    [sym_identifier] = ACTIONS(4944),
    [aux_sym_preproc_def_token1] = ACTIONS(4944),
    [aux_sym_preproc_if_token1] = ACTIONS(4944),
    [aux_sym_preproc_if_token2] = ACTIONS(4944),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4944),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4944),
    [sym_preproc_directive] = ACTIONS(4944),
    [anon_sym_LPAREN2] = ACTIONS(4946),
    [anon_sym_TILDE] = ACTIONS(4946),
    [anon_sym_STAR] = ACTIONS(4946),
    [anon_sym_AMP_AMP] = ACTIONS(4946),
    [anon_sym_AMP] = ACTIONS(4944),
    [anon_sym___extension__] = ACTIONS(4944),
    [anon_sym_typedef] = ACTIONS(4944),
    [anon_sym_extern] = ACTIONS(4944),
    [anon_sym___attribute__] = ACTIONS(4944),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4946),
    [anon_sym___declspec] = ACTIONS(4944),
    [anon_sym___based] = ACTIONS(4944),
    [anon_sym_signed] = ACTIONS(4944),
    [anon_sym_unsigned] = ACTIONS(4944),
    [anon_sym_long] = ACTIONS(4944),
    [anon_sym_short] = ACTIONS(4944),
    [anon_sym_LBRACK] = ACTIONS(4944),
    [anon_sym_static] = ACTIONS(4944),
    [anon_sym_register] = ACTIONS(4944),
    [anon_sym_inline] = ACTIONS(4944),
    [anon_sym___inline] = ACTIONS(4944),
    [anon_sym___inline__] = ACTIONS(4944),
    [anon_sym___forceinline] = ACTIONS(4944),
    [anon_sym_thread_local] = ACTIONS(4944),
    [anon_sym___thread] = ACTIONS(4944),
    [anon_sym_const] = ACTIONS(4944),
    [anon_sym_constexpr] = ACTIONS(4944),
    [anon_sym_volatile] = ACTIONS(4944),
    [anon_sym_restrict] = ACTIONS(4944),
    [anon_sym___restrict__] = ACTIONS(4944),
    [anon_sym__Atomic] = ACTIONS(4944),
    [anon_sym__Noreturn] = ACTIONS(4944),
    [anon_sym_noreturn] = ACTIONS(4944),
    [anon_sym_mutable] = ACTIONS(4944),
    [anon_sym_constinit] = ACTIONS(4944),
    [anon_sym_consteval] = ACTIONS(4944),
    [anon_sym_PROGMEM] = ACTIONS(4944),
    [aux_sym_primitive_type_token1] = ACTIONS(4944),
    [anon_sym_byte] = ACTIONS(4944),
    [anon_sym_word] = ACTIONS(4944),
    [anon_sym_enum] = ACTIONS(4944),
    [anon_sym_class] = ACTIONS(4944),
    [anon_sym_struct] = ACTIONS(4944),
    [anon_sym_union] = ACTIONS(4944),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4944),
    [anon_sym_decltype] = ACTIONS(4944),
    [anon_sym_virtual] = ACTIONS(4944),
    [anon_sym_alignas] = ACTIONS(4944),
    [anon_sym_explicit] = ACTIONS(4944),
    [anon_sym_typename] = ACTIONS(4944),
    [anon_sym_template] = ACTIONS(4944),
    [anon_sym_operator] = ACTIONS(4944),
    [anon_sym_friend] = ACTIONS(4944),
    [anon_sym_public] = ACTIONS(4944),
    [anon_sym_private] = ACTIONS(4944),
    [anon_sym_protected] = ACTIONS(4944),
    [anon_sym_using] = ACTIONS(4944),
    [anon_sym_static_assert] = ACTIONS(4944),
  },
  [2205] = {
    [sym_identifier] = ACTIONS(4944),
    [aux_sym_preproc_def_token1] = ACTIONS(4944),
    [aux_sym_preproc_if_token1] = ACTIONS(4944),
    [aux_sym_preproc_if_token2] = ACTIONS(4944),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4944),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4944),
    [sym_preproc_directive] = ACTIONS(4944),
    [anon_sym_LPAREN2] = ACTIONS(4946),
    [anon_sym_TILDE] = ACTIONS(4946),
    [anon_sym_STAR] = ACTIONS(4946),
    [anon_sym_AMP_AMP] = ACTIONS(4946),
    [anon_sym_AMP] = ACTIONS(4944),
    [anon_sym___extension__] = ACTIONS(4944),
    [anon_sym_typedef] = ACTIONS(4944),
    [anon_sym_extern] = ACTIONS(4944),
    [anon_sym___attribute__] = ACTIONS(4944),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4946),
    [anon_sym___declspec] = ACTIONS(4944),
    [anon_sym___based] = ACTIONS(4944),
    [anon_sym_signed] = ACTIONS(4944),
    [anon_sym_unsigned] = ACTIONS(4944),
    [anon_sym_long] = ACTIONS(4944),
    [anon_sym_short] = ACTIONS(4944),
    [anon_sym_LBRACK] = ACTIONS(4944),
    [anon_sym_static] = ACTIONS(4944),
    [anon_sym_register] = ACTIONS(4944),
    [anon_sym_inline] = ACTIONS(4944),
    [anon_sym___inline] = ACTIONS(4944),
    [anon_sym___inline__] = ACTIONS(4944),
    [anon_sym___forceinline] = ACTIONS(4944),
    [anon_sym_thread_local] = ACTIONS(4944),
    [anon_sym___thread] = ACTIONS(4944),
    [anon_sym_const] = ACTIONS(4944),
    [anon_sym_constexpr] = ACTIONS(4944),
    [anon_sym_volatile] = ACTIONS(4944),
    [anon_sym_restrict] = ACTIONS(4944),
    [anon_sym___restrict__] = ACTIONS(4944),
    [anon_sym__Atomic] = ACTIONS(4944),
    [anon_sym__Noreturn] = ACTIONS(4944),
    [anon_sym_noreturn] = ACTIONS(4944),
    [anon_sym_mutable] = ACTIONS(4944),
    [anon_sym_constinit] = ACTIONS(4944),
    [anon_sym_consteval] = ACTIONS(4944),
    [anon_sym_PROGMEM] = ACTIONS(4944),
    [aux_sym_primitive_type_token1] = ACTIONS(4944),
    [anon_sym_byte] = ACTIONS(4944),
    [anon_sym_word] = ACTIONS(4944),
    [anon_sym_enum] = ACTIONS(4944),
    [anon_sym_class] = ACTIONS(4944),
    [anon_sym_struct] = ACTIONS(4944),
    [anon_sym_union] = ACTIONS(4944),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4944),
    [anon_sym_decltype] = ACTIONS(4944),
    [anon_sym_virtual] = ACTIONS(4944),
    [anon_sym_alignas] = ACTIONS(4944),
    [anon_sym_explicit] = ACTIONS(4944),
    [anon_sym_typename] = ACTIONS(4944),
    [anon_sym_template] = ACTIONS(4944),
    [anon_sym_operator] = ACTIONS(4944),
    [anon_sym_friend] = ACTIONS(4944),
    [anon_sym_public] = ACTIONS(4944),
    [anon_sym_private] = ACTIONS(4944),
    [anon_sym_protected] = ACTIONS(4944),
    [anon_sym_using] = ACTIONS(4944),
    [anon_sym_static_assert] = ACTIONS(4944),
  },
  [2206] = {
    [sym_string_literal] = STATE(2120),
    [sym_raw_string_literal] = STATE(2120),
    [aux_sym_concatenated_string_repeat1] = STATE(2120),
    [sym_identifier] = ACTIONS(5338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4783),
    [anon_sym_COMMA] = ACTIONS(4783),
    [anon_sym_LPAREN2] = ACTIONS(4783),
    [anon_sym_DASH] = ACTIONS(4785),
    [anon_sym_PLUS] = ACTIONS(4785),
    [anon_sym_STAR] = ACTIONS(4785),
    [anon_sym_SLASH] = ACTIONS(4785),
    [anon_sym_PERCENT] = ACTIONS(4785),
    [anon_sym_PIPE_PIPE] = ACTIONS(4783),
    [anon_sym_AMP_AMP] = ACTIONS(4783),
    [anon_sym_PIPE] = ACTIONS(4785),
    [anon_sym_CARET] = ACTIONS(4785),
    [anon_sym_AMP] = ACTIONS(4785),
    [anon_sym_EQ_EQ] = ACTIONS(4783),
    [anon_sym_BANG_EQ] = ACTIONS(4783),
    [anon_sym_GT] = ACTIONS(4785),
    [anon_sym_GT_EQ] = ACTIONS(4783),
    [anon_sym_LT_EQ] = ACTIONS(4785),
    [anon_sym_LT] = ACTIONS(4785),
    [anon_sym_LT_LT] = ACTIONS(4785),
    [anon_sym_GT_GT] = ACTIONS(4785),
    [anon_sym_SEMI] = ACTIONS(4783),
    [anon_sym___attribute__] = ACTIONS(4785),
    [anon_sym_LBRACK] = ACTIONS(4783),
    [anon_sym_EQ] = ACTIONS(4785),
    [anon_sym_QMARK] = ACTIONS(4783),
    [anon_sym_STAR_EQ] = ACTIONS(4783),
    [anon_sym_SLASH_EQ] = ACTIONS(4783),
    [anon_sym_PERCENT_EQ] = ACTIONS(4783),
    [anon_sym_PLUS_EQ] = ACTIONS(4783),
    [anon_sym_DASH_EQ] = ACTIONS(4783),
    [anon_sym_LT_LT_EQ] = ACTIONS(4783),
    [anon_sym_GT_GT_EQ] = ACTIONS(4783),
    [anon_sym_AMP_EQ] = ACTIONS(4783),
    [anon_sym_CARET_EQ] = ACTIONS(4783),
    [anon_sym_PIPE_EQ] = ACTIONS(4783),
    [anon_sym_and_eq] = ACTIONS(4785),
    [anon_sym_or_eq] = ACTIONS(4785),
    [anon_sym_xor_eq] = ACTIONS(4785),
    [anon_sym_LT_EQ_GT] = ACTIONS(4783),
    [anon_sym_or] = ACTIONS(4785),
    [anon_sym_and] = ACTIONS(4785),
    [anon_sym_bitor] = ACTIONS(4785),
    [anon_sym_xor] = ACTIONS(4785),
    [anon_sym_bitand] = ACTIONS(4785),
    [anon_sym_not_eq] = ACTIONS(4785),
    [anon_sym_DASH_DASH] = ACTIONS(4783),
    [anon_sym_PLUS_PLUS] = ACTIONS(4783),
    [anon_sym_DOT] = ACTIONS(4785),
    [anon_sym_DOT_STAR] = ACTIONS(4783),
    [anon_sym_DASH_GT] = ACTIONS(4783),
    [anon_sym_L_DQUOTE] = ACTIONS(5289),
    [anon_sym_u_DQUOTE] = ACTIONS(5289),
    [anon_sym_U_DQUOTE] = ACTIONS(5289),
    [anon_sym_u8_DQUOTE] = ACTIONS(5289),
    [anon_sym_DQUOTE] = ACTIONS(5289),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5291),
    [anon_sym_LR_DQUOTE] = ACTIONS(5291),
    [anon_sym_uR_DQUOTE] = ACTIONS(5291),
    [anon_sym_UR_DQUOTE] = ACTIONS(5291),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5291),
    [sym_literal_suffix] = ACTIONS(4785),
  },
  [2207] = {
    [sym_identifier] = ACTIONS(4948),
    [aux_sym_preproc_def_token1] = ACTIONS(4948),
    [aux_sym_preproc_if_token1] = ACTIONS(4948),
    [aux_sym_preproc_if_token2] = ACTIONS(4948),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4948),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4948),
    [sym_preproc_directive] = ACTIONS(4948),
    [anon_sym_LPAREN2] = ACTIONS(4950),
    [anon_sym_TILDE] = ACTIONS(4950),
    [anon_sym_STAR] = ACTIONS(4950),
    [anon_sym_AMP_AMP] = ACTIONS(4950),
    [anon_sym_AMP] = ACTIONS(4948),
    [anon_sym___extension__] = ACTIONS(4948),
    [anon_sym_typedef] = ACTIONS(4948),
    [anon_sym_extern] = ACTIONS(4948),
    [anon_sym___attribute__] = ACTIONS(4948),
    [anon_sym_COLON_COLON] = ACTIONS(4950),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4950),
    [anon_sym___declspec] = ACTIONS(4948),
    [anon_sym___based] = ACTIONS(4948),
    [anon_sym_signed] = ACTIONS(4948),
    [anon_sym_unsigned] = ACTIONS(4948),
    [anon_sym_long] = ACTIONS(4948),
    [anon_sym_short] = ACTIONS(4948),
    [anon_sym_LBRACK] = ACTIONS(4948),
    [anon_sym_static] = ACTIONS(4948),
    [anon_sym_register] = ACTIONS(4948),
    [anon_sym_inline] = ACTIONS(4948),
    [anon_sym___inline] = ACTIONS(4948),
    [anon_sym___inline__] = ACTIONS(4948),
    [anon_sym___forceinline] = ACTIONS(4948),
    [anon_sym_thread_local] = ACTIONS(4948),
    [anon_sym___thread] = ACTIONS(4948),
    [anon_sym_const] = ACTIONS(4948),
    [anon_sym_constexpr] = ACTIONS(4948),
    [anon_sym_volatile] = ACTIONS(4948),
    [anon_sym_restrict] = ACTIONS(4948),
    [anon_sym___restrict__] = ACTIONS(4948),
    [anon_sym__Atomic] = ACTIONS(4948),
    [anon_sym__Noreturn] = ACTIONS(4948),
    [anon_sym_noreturn] = ACTIONS(4948),
    [anon_sym_mutable] = ACTIONS(4948),
    [anon_sym_constinit] = ACTIONS(4948),
    [anon_sym_consteval] = ACTIONS(4948),
    [anon_sym_PROGMEM] = ACTIONS(4948),
    [aux_sym_primitive_type_token1] = ACTIONS(4948),
    [anon_sym_byte] = ACTIONS(4948),
    [anon_sym_word] = ACTIONS(4948),
    [anon_sym_enum] = ACTIONS(4948),
    [anon_sym_class] = ACTIONS(4948),
    [anon_sym_struct] = ACTIONS(4948),
    [anon_sym_union] = ACTIONS(4948),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4948),
    [anon_sym_decltype] = ACTIONS(4948),
    [anon_sym_virtual] = ACTIONS(4948),
    [anon_sym_alignas] = ACTIONS(4948),
    [anon_sym_explicit] = ACTIONS(4948),
    [anon_sym_typename] = ACTIONS(4948),
    [anon_sym_template] = ACTIONS(4948),
    [anon_sym_operator] = ACTIONS(4948),
    [anon_sym_friend] = ACTIONS(4948),
    [anon_sym_public] = ACTIONS(4948),
    [anon_sym_private] = ACTIONS(4948),
    [anon_sym_protected] = ACTIONS(4948),
    [anon_sym_using] = ACTIONS(4948),
    [anon_sym_static_assert] = ACTIONS(4948),
  },
  [2208] = {
    [sym_identifier] = ACTIONS(4952),
    [aux_sym_preproc_def_token1] = ACTIONS(4952),
    [aux_sym_preproc_if_token1] = ACTIONS(4952),
    [aux_sym_preproc_if_token2] = ACTIONS(4952),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4952),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4952),
    [sym_preproc_directive] = ACTIONS(4952),
    [anon_sym_LPAREN2] = ACTIONS(4954),
    [anon_sym_TILDE] = ACTIONS(4954),
    [anon_sym_STAR] = ACTIONS(4954),
    [anon_sym_AMP_AMP] = ACTIONS(4954),
    [anon_sym_AMP] = ACTIONS(4952),
    [anon_sym___extension__] = ACTIONS(4952),
    [anon_sym_typedef] = ACTIONS(4952),
    [anon_sym_extern] = ACTIONS(4952),
    [anon_sym___attribute__] = ACTIONS(4952),
    [anon_sym_COLON_COLON] = ACTIONS(4954),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4954),
    [anon_sym___declspec] = ACTIONS(4952),
    [anon_sym___based] = ACTIONS(4952),
    [anon_sym_signed] = ACTIONS(4952),
    [anon_sym_unsigned] = ACTIONS(4952),
    [anon_sym_long] = ACTIONS(4952),
    [anon_sym_short] = ACTIONS(4952),
    [anon_sym_LBRACK] = ACTIONS(4952),
    [anon_sym_static] = ACTIONS(4952),
    [anon_sym_register] = ACTIONS(4952),
    [anon_sym_inline] = ACTIONS(4952),
    [anon_sym___inline] = ACTIONS(4952),
    [anon_sym___inline__] = ACTIONS(4952),
    [anon_sym___forceinline] = ACTIONS(4952),
    [anon_sym_thread_local] = ACTIONS(4952),
    [anon_sym___thread] = ACTIONS(4952),
    [anon_sym_const] = ACTIONS(4952),
    [anon_sym_constexpr] = ACTIONS(4952),
    [anon_sym_volatile] = ACTIONS(4952),
    [anon_sym_restrict] = ACTIONS(4952),
    [anon_sym___restrict__] = ACTIONS(4952),
    [anon_sym__Atomic] = ACTIONS(4952),
    [anon_sym__Noreturn] = ACTIONS(4952),
    [anon_sym_noreturn] = ACTIONS(4952),
    [anon_sym_mutable] = ACTIONS(4952),
    [anon_sym_constinit] = ACTIONS(4952),
    [anon_sym_consteval] = ACTIONS(4952),
    [anon_sym_PROGMEM] = ACTIONS(4952),
    [aux_sym_primitive_type_token1] = ACTIONS(4952),
    [anon_sym_byte] = ACTIONS(4952),
    [anon_sym_word] = ACTIONS(4952),
    [anon_sym_enum] = ACTIONS(4952),
    [anon_sym_class] = ACTIONS(4952),
    [anon_sym_struct] = ACTIONS(4952),
    [anon_sym_union] = ACTIONS(4952),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4952),
    [anon_sym_decltype] = ACTIONS(4952),
    [anon_sym_virtual] = ACTIONS(4952),
    [anon_sym_alignas] = ACTIONS(4952),
    [anon_sym_explicit] = ACTIONS(4952),
    [anon_sym_typename] = ACTIONS(4952),
    [anon_sym_template] = ACTIONS(4952),
    [anon_sym_operator] = ACTIONS(4952),
    [anon_sym_friend] = ACTIONS(4952),
    [anon_sym_public] = ACTIONS(4952),
    [anon_sym_private] = ACTIONS(4952),
    [anon_sym_protected] = ACTIONS(4952),
    [anon_sym_using] = ACTIONS(4952),
    [anon_sym_static_assert] = ACTIONS(4952),
  },
  [2209] = {
    [sym_identifier] = ACTIONS(5016),
    [aux_sym_preproc_def_token1] = ACTIONS(5016),
    [aux_sym_preproc_if_token1] = ACTIONS(5016),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5016),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5016),
    [sym_preproc_directive] = ACTIONS(5016),
    [anon_sym_LPAREN2] = ACTIONS(5018),
    [anon_sym_TILDE] = ACTIONS(5018),
    [anon_sym_STAR] = ACTIONS(5018),
    [anon_sym_AMP_AMP] = ACTIONS(5018),
    [anon_sym_AMP] = ACTIONS(5016),
    [anon_sym___extension__] = ACTIONS(5016),
    [anon_sym_typedef] = ACTIONS(5016),
    [anon_sym_extern] = ACTIONS(5016),
    [anon_sym___attribute__] = ACTIONS(5016),
    [anon_sym_COLON_COLON] = ACTIONS(5018),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5018),
    [anon_sym___declspec] = ACTIONS(5016),
    [anon_sym___based] = ACTIONS(5016),
    [anon_sym_RBRACE] = ACTIONS(5018),
    [anon_sym_signed] = ACTIONS(5016),
    [anon_sym_unsigned] = ACTIONS(5016),
    [anon_sym_long] = ACTIONS(5016),
    [anon_sym_short] = ACTIONS(5016),
    [anon_sym_LBRACK] = ACTIONS(5016),
    [anon_sym_static] = ACTIONS(5016),
    [anon_sym_register] = ACTIONS(5016),
    [anon_sym_inline] = ACTIONS(5016),
    [anon_sym___inline] = ACTIONS(5016),
    [anon_sym___inline__] = ACTIONS(5016),
    [anon_sym___forceinline] = ACTIONS(5016),
    [anon_sym_thread_local] = ACTIONS(5016),
    [anon_sym___thread] = ACTIONS(5016),
    [anon_sym_const] = ACTIONS(5016),
    [anon_sym_constexpr] = ACTIONS(5016),
    [anon_sym_volatile] = ACTIONS(5016),
    [anon_sym_restrict] = ACTIONS(5016),
    [anon_sym___restrict__] = ACTIONS(5016),
    [anon_sym__Atomic] = ACTIONS(5016),
    [anon_sym__Noreturn] = ACTIONS(5016),
    [anon_sym_noreturn] = ACTIONS(5016),
    [anon_sym_mutable] = ACTIONS(5016),
    [anon_sym_constinit] = ACTIONS(5016),
    [anon_sym_consteval] = ACTIONS(5016),
    [anon_sym_PROGMEM] = ACTIONS(5016),
    [aux_sym_primitive_type_token1] = ACTIONS(5016),
    [anon_sym_byte] = ACTIONS(5016),
    [anon_sym_word] = ACTIONS(5016),
    [anon_sym_enum] = ACTIONS(5016),
    [anon_sym_class] = ACTIONS(5016),
    [anon_sym_struct] = ACTIONS(5016),
    [anon_sym_union] = ACTIONS(5016),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5016),
    [anon_sym_decltype] = ACTIONS(5016),
    [anon_sym_virtual] = ACTIONS(5016),
    [anon_sym_alignas] = ACTIONS(5016),
    [anon_sym_explicit] = ACTIONS(5016),
    [anon_sym_typename] = ACTIONS(5016),
    [anon_sym_template] = ACTIONS(5016),
    [anon_sym_operator] = ACTIONS(5016),
    [anon_sym_friend] = ACTIONS(5016),
    [anon_sym_public] = ACTIONS(5016),
    [anon_sym_private] = ACTIONS(5016),
    [anon_sym_protected] = ACTIONS(5016),
    [anon_sym_using] = ACTIONS(5016),
    [anon_sym_static_assert] = ACTIONS(5016),
  },
  [2210] = {
    [sym_identifier] = ACTIONS(2639),
    [aux_sym_preproc_def_token1] = ACTIONS(2639),
    [aux_sym_preproc_if_token1] = ACTIONS(2639),
    [aux_sym_preproc_if_token2] = ACTIONS(2639),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2639),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2639),
    [sym_preproc_directive] = ACTIONS(2639),
    [anon_sym_LPAREN2] = ACTIONS(2641),
    [anon_sym_TILDE] = ACTIONS(2641),
    [anon_sym_STAR] = ACTIONS(2641),
    [anon_sym_AMP_AMP] = ACTIONS(2641),
    [anon_sym_AMP] = ACTIONS(2639),
    [anon_sym___extension__] = ACTIONS(2639),
    [anon_sym_typedef] = ACTIONS(2639),
    [anon_sym_extern] = ACTIONS(2639),
    [anon_sym___attribute__] = ACTIONS(2639),
    [anon_sym_COLON_COLON] = ACTIONS(2641),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2641),
    [anon_sym___declspec] = ACTIONS(2639),
    [anon_sym___based] = ACTIONS(2639),
    [anon_sym_signed] = ACTIONS(2639),
    [anon_sym_unsigned] = ACTIONS(2639),
    [anon_sym_long] = ACTIONS(2639),
    [anon_sym_short] = ACTIONS(2639),
    [anon_sym_LBRACK] = ACTIONS(2639),
    [anon_sym_static] = ACTIONS(2639),
    [anon_sym_register] = ACTIONS(2639),
    [anon_sym_inline] = ACTIONS(2639),
    [anon_sym___inline] = ACTIONS(2639),
    [anon_sym___inline__] = ACTIONS(2639),
    [anon_sym___forceinline] = ACTIONS(2639),
    [anon_sym_thread_local] = ACTIONS(2639),
    [anon_sym___thread] = ACTIONS(2639),
    [anon_sym_const] = ACTIONS(2639),
    [anon_sym_constexpr] = ACTIONS(2639),
    [anon_sym_volatile] = ACTIONS(2639),
    [anon_sym_restrict] = ACTIONS(2639),
    [anon_sym___restrict__] = ACTIONS(2639),
    [anon_sym__Atomic] = ACTIONS(2639),
    [anon_sym__Noreturn] = ACTIONS(2639),
    [anon_sym_noreturn] = ACTIONS(2639),
    [anon_sym_mutable] = ACTIONS(2639),
    [anon_sym_constinit] = ACTIONS(2639),
    [anon_sym_consteval] = ACTIONS(2639),
    [anon_sym_PROGMEM] = ACTIONS(2639),
    [aux_sym_primitive_type_token1] = ACTIONS(2639),
    [anon_sym_byte] = ACTIONS(2639),
    [anon_sym_word] = ACTIONS(2639),
    [anon_sym_enum] = ACTIONS(2639),
    [anon_sym_class] = ACTIONS(2639),
    [anon_sym_struct] = ACTIONS(2639),
    [anon_sym_union] = ACTIONS(2639),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2639),
    [anon_sym_decltype] = ACTIONS(2639),
    [anon_sym_virtual] = ACTIONS(2639),
    [anon_sym_alignas] = ACTIONS(2639),
    [anon_sym_explicit] = ACTIONS(2639),
    [anon_sym_typename] = ACTIONS(2639),
    [anon_sym_template] = ACTIONS(2639),
    [anon_sym_operator] = ACTIONS(2639),
    [anon_sym_friend] = ACTIONS(2639),
    [anon_sym_public] = ACTIONS(2639),
    [anon_sym_private] = ACTIONS(2639),
    [anon_sym_protected] = ACTIONS(2639),
    [anon_sym_using] = ACTIONS(2639),
    [anon_sym_static_assert] = ACTIONS(2639),
  },
  [2211] = {
    [sym_identifier] = ACTIONS(4956),
    [aux_sym_preproc_def_token1] = ACTIONS(4956),
    [aux_sym_preproc_if_token1] = ACTIONS(4956),
    [aux_sym_preproc_if_token2] = ACTIONS(4956),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4956),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4956),
    [sym_preproc_directive] = ACTIONS(4956),
    [anon_sym_LPAREN2] = ACTIONS(4958),
    [anon_sym_TILDE] = ACTIONS(4958),
    [anon_sym_STAR] = ACTIONS(4958),
    [anon_sym_AMP_AMP] = ACTIONS(4958),
    [anon_sym_AMP] = ACTIONS(4956),
    [anon_sym___extension__] = ACTIONS(4956),
    [anon_sym_typedef] = ACTIONS(4956),
    [anon_sym_extern] = ACTIONS(4956),
    [anon_sym___attribute__] = ACTIONS(4956),
    [anon_sym_COLON_COLON] = ACTIONS(4958),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4958),
    [anon_sym___declspec] = ACTIONS(4956),
    [anon_sym___based] = ACTIONS(4956),
    [anon_sym_signed] = ACTIONS(4956),
    [anon_sym_unsigned] = ACTIONS(4956),
    [anon_sym_long] = ACTIONS(4956),
    [anon_sym_short] = ACTIONS(4956),
    [anon_sym_LBRACK] = ACTIONS(4956),
    [anon_sym_static] = ACTIONS(4956),
    [anon_sym_register] = ACTIONS(4956),
    [anon_sym_inline] = ACTIONS(4956),
    [anon_sym___inline] = ACTIONS(4956),
    [anon_sym___inline__] = ACTIONS(4956),
    [anon_sym___forceinline] = ACTIONS(4956),
    [anon_sym_thread_local] = ACTIONS(4956),
    [anon_sym___thread] = ACTIONS(4956),
    [anon_sym_const] = ACTIONS(4956),
    [anon_sym_constexpr] = ACTIONS(4956),
    [anon_sym_volatile] = ACTIONS(4956),
    [anon_sym_restrict] = ACTIONS(4956),
    [anon_sym___restrict__] = ACTIONS(4956),
    [anon_sym__Atomic] = ACTIONS(4956),
    [anon_sym__Noreturn] = ACTIONS(4956),
    [anon_sym_noreturn] = ACTIONS(4956),
    [anon_sym_mutable] = ACTIONS(4956),
    [anon_sym_constinit] = ACTIONS(4956),
    [anon_sym_consteval] = ACTIONS(4956),
    [anon_sym_PROGMEM] = ACTIONS(4956),
    [aux_sym_primitive_type_token1] = ACTIONS(4956),
    [anon_sym_byte] = ACTIONS(4956),
    [anon_sym_word] = ACTIONS(4956),
    [anon_sym_enum] = ACTIONS(4956),
    [anon_sym_class] = ACTIONS(4956),
    [anon_sym_struct] = ACTIONS(4956),
    [anon_sym_union] = ACTIONS(4956),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4956),
    [anon_sym_decltype] = ACTIONS(4956),
    [anon_sym_virtual] = ACTIONS(4956),
    [anon_sym_alignas] = ACTIONS(4956),
    [anon_sym_explicit] = ACTIONS(4956),
    [anon_sym_typename] = ACTIONS(4956),
    [anon_sym_template] = ACTIONS(4956),
    [anon_sym_operator] = ACTIONS(4956),
    [anon_sym_friend] = ACTIONS(4956),
    [anon_sym_public] = ACTIONS(4956),
    [anon_sym_private] = ACTIONS(4956),
    [anon_sym_protected] = ACTIONS(4956),
    [anon_sym_using] = ACTIONS(4956),
    [anon_sym_static_assert] = ACTIONS(4956),
  },
  [2212] = {
    [sym_identifier] = ACTIONS(4956),
    [aux_sym_preproc_def_token1] = ACTIONS(4956),
    [aux_sym_preproc_if_token1] = ACTIONS(4956),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4956),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4956),
    [sym_preproc_directive] = ACTIONS(4956),
    [anon_sym_LPAREN2] = ACTIONS(4958),
    [anon_sym_TILDE] = ACTIONS(4958),
    [anon_sym_STAR] = ACTIONS(4958),
    [anon_sym_AMP_AMP] = ACTIONS(4958),
    [anon_sym_AMP] = ACTIONS(4956),
    [anon_sym___extension__] = ACTIONS(4956),
    [anon_sym_typedef] = ACTIONS(4956),
    [anon_sym_extern] = ACTIONS(4956),
    [anon_sym___attribute__] = ACTIONS(4956),
    [anon_sym_COLON_COLON] = ACTIONS(4958),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4958),
    [anon_sym___declspec] = ACTIONS(4956),
    [anon_sym___based] = ACTIONS(4956),
    [anon_sym_RBRACE] = ACTIONS(4958),
    [anon_sym_signed] = ACTIONS(4956),
    [anon_sym_unsigned] = ACTIONS(4956),
    [anon_sym_long] = ACTIONS(4956),
    [anon_sym_short] = ACTIONS(4956),
    [anon_sym_LBRACK] = ACTIONS(4956),
    [anon_sym_static] = ACTIONS(4956),
    [anon_sym_register] = ACTIONS(4956),
    [anon_sym_inline] = ACTIONS(4956),
    [anon_sym___inline] = ACTIONS(4956),
    [anon_sym___inline__] = ACTIONS(4956),
    [anon_sym___forceinline] = ACTIONS(4956),
    [anon_sym_thread_local] = ACTIONS(4956),
    [anon_sym___thread] = ACTIONS(4956),
    [anon_sym_const] = ACTIONS(4956),
    [anon_sym_constexpr] = ACTIONS(4956),
    [anon_sym_volatile] = ACTIONS(4956),
    [anon_sym_restrict] = ACTIONS(4956),
    [anon_sym___restrict__] = ACTIONS(4956),
    [anon_sym__Atomic] = ACTIONS(4956),
    [anon_sym__Noreturn] = ACTIONS(4956),
    [anon_sym_noreturn] = ACTIONS(4956),
    [anon_sym_mutable] = ACTIONS(4956),
    [anon_sym_constinit] = ACTIONS(4956),
    [anon_sym_consteval] = ACTIONS(4956),
    [anon_sym_PROGMEM] = ACTIONS(4956),
    [aux_sym_primitive_type_token1] = ACTIONS(4956),
    [anon_sym_byte] = ACTIONS(4956),
    [anon_sym_word] = ACTIONS(4956),
    [anon_sym_enum] = ACTIONS(4956),
    [anon_sym_class] = ACTIONS(4956),
    [anon_sym_struct] = ACTIONS(4956),
    [anon_sym_union] = ACTIONS(4956),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4956),
    [anon_sym_decltype] = ACTIONS(4956),
    [anon_sym_virtual] = ACTIONS(4956),
    [anon_sym_alignas] = ACTIONS(4956),
    [anon_sym_explicit] = ACTIONS(4956),
    [anon_sym_typename] = ACTIONS(4956),
    [anon_sym_template] = ACTIONS(4956),
    [anon_sym_operator] = ACTIONS(4956),
    [anon_sym_friend] = ACTIONS(4956),
    [anon_sym_public] = ACTIONS(4956),
    [anon_sym_private] = ACTIONS(4956),
    [anon_sym_protected] = ACTIONS(4956),
    [anon_sym_using] = ACTIONS(4956),
    [anon_sym_static_assert] = ACTIONS(4956),
  },
  [2213] = {
    [sym_identifier] = ACTIONS(4960),
    [aux_sym_preproc_def_token1] = ACTIONS(4960),
    [aux_sym_preproc_if_token1] = ACTIONS(4960),
    [aux_sym_preproc_if_token2] = ACTIONS(4960),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4960),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4960),
    [sym_preproc_directive] = ACTIONS(4960),
    [anon_sym_LPAREN2] = ACTIONS(4962),
    [anon_sym_TILDE] = ACTIONS(4962),
    [anon_sym_STAR] = ACTIONS(4962),
    [anon_sym_AMP_AMP] = ACTIONS(4962),
    [anon_sym_AMP] = ACTIONS(4960),
    [anon_sym___extension__] = ACTIONS(4960),
    [anon_sym_typedef] = ACTIONS(4960),
    [anon_sym_extern] = ACTIONS(4960),
    [anon_sym___attribute__] = ACTIONS(4960),
    [anon_sym_COLON_COLON] = ACTIONS(4962),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4962),
    [anon_sym___declspec] = ACTIONS(4960),
    [anon_sym___based] = ACTIONS(4960),
    [anon_sym_signed] = ACTIONS(4960),
    [anon_sym_unsigned] = ACTIONS(4960),
    [anon_sym_long] = ACTIONS(4960),
    [anon_sym_short] = ACTIONS(4960),
    [anon_sym_LBRACK] = ACTIONS(4960),
    [anon_sym_static] = ACTIONS(4960),
    [anon_sym_register] = ACTIONS(4960),
    [anon_sym_inline] = ACTIONS(4960),
    [anon_sym___inline] = ACTIONS(4960),
    [anon_sym___inline__] = ACTIONS(4960),
    [anon_sym___forceinline] = ACTIONS(4960),
    [anon_sym_thread_local] = ACTIONS(4960),
    [anon_sym___thread] = ACTIONS(4960),
    [anon_sym_const] = ACTIONS(4960),
    [anon_sym_constexpr] = ACTIONS(4960),
    [anon_sym_volatile] = ACTIONS(4960),
    [anon_sym_restrict] = ACTIONS(4960),
    [anon_sym___restrict__] = ACTIONS(4960),
    [anon_sym__Atomic] = ACTIONS(4960),
    [anon_sym__Noreturn] = ACTIONS(4960),
    [anon_sym_noreturn] = ACTIONS(4960),
    [anon_sym_mutable] = ACTIONS(4960),
    [anon_sym_constinit] = ACTIONS(4960),
    [anon_sym_consteval] = ACTIONS(4960),
    [anon_sym_PROGMEM] = ACTIONS(4960),
    [aux_sym_primitive_type_token1] = ACTIONS(4960),
    [anon_sym_byte] = ACTIONS(4960),
    [anon_sym_word] = ACTIONS(4960),
    [anon_sym_enum] = ACTIONS(4960),
    [anon_sym_class] = ACTIONS(4960),
    [anon_sym_struct] = ACTIONS(4960),
    [anon_sym_union] = ACTIONS(4960),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4960),
    [anon_sym_decltype] = ACTIONS(4960),
    [anon_sym_virtual] = ACTIONS(4960),
    [anon_sym_alignas] = ACTIONS(4960),
    [anon_sym_explicit] = ACTIONS(4960),
    [anon_sym_typename] = ACTIONS(4960),
    [anon_sym_template] = ACTIONS(4960),
    [anon_sym_operator] = ACTIONS(4960),
    [anon_sym_friend] = ACTIONS(4960),
    [anon_sym_public] = ACTIONS(4960),
    [anon_sym_private] = ACTIONS(4960),
    [anon_sym_protected] = ACTIONS(4960),
    [anon_sym_using] = ACTIONS(4960),
    [anon_sym_static_assert] = ACTIONS(4960),
  },
  [2214] = {
    [sym_identifier] = ACTIONS(4956),
    [aux_sym_preproc_def_token1] = ACTIONS(4956),
    [aux_sym_preproc_if_token1] = ACTIONS(4956),
    [aux_sym_preproc_if_token2] = ACTIONS(4956),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4956),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4956),
    [sym_preproc_directive] = ACTIONS(4956),
    [anon_sym_LPAREN2] = ACTIONS(4958),
    [anon_sym_TILDE] = ACTIONS(4958),
    [anon_sym_STAR] = ACTIONS(4958),
    [anon_sym_AMP_AMP] = ACTIONS(4958),
    [anon_sym_AMP] = ACTIONS(4956),
    [anon_sym___extension__] = ACTIONS(4956),
    [anon_sym_typedef] = ACTIONS(4956),
    [anon_sym_extern] = ACTIONS(4956),
    [anon_sym___attribute__] = ACTIONS(4956),
    [anon_sym_COLON_COLON] = ACTIONS(4958),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4958),
    [anon_sym___declspec] = ACTIONS(4956),
    [anon_sym___based] = ACTIONS(4956),
    [anon_sym_signed] = ACTIONS(4956),
    [anon_sym_unsigned] = ACTIONS(4956),
    [anon_sym_long] = ACTIONS(4956),
    [anon_sym_short] = ACTIONS(4956),
    [anon_sym_LBRACK] = ACTIONS(4956),
    [anon_sym_static] = ACTIONS(4956),
    [anon_sym_register] = ACTIONS(4956),
    [anon_sym_inline] = ACTIONS(4956),
    [anon_sym___inline] = ACTIONS(4956),
    [anon_sym___inline__] = ACTIONS(4956),
    [anon_sym___forceinline] = ACTIONS(4956),
    [anon_sym_thread_local] = ACTIONS(4956),
    [anon_sym___thread] = ACTIONS(4956),
    [anon_sym_const] = ACTIONS(4956),
    [anon_sym_constexpr] = ACTIONS(4956),
    [anon_sym_volatile] = ACTIONS(4956),
    [anon_sym_restrict] = ACTIONS(4956),
    [anon_sym___restrict__] = ACTIONS(4956),
    [anon_sym__Atomic] = ACTIONS(4956),
    [anon_sym__Noreturn] = ACTIONS(4956),
    [anon_sym_noreturn] = ACTIONS(4956),
    [anon_sym_mutable] = ACTIONS(4956),
    [anon_sym_constinit] = ACTIONS(4956),
    [anon_sym_consteval] = ACTIONS(4956),
    [anon_sym_PROGMEM] = ACTIONS(4956),
    [aux_sym_primitive_type_token1] = ACTIONS(4956),
    [anon_sym_byte] = ACTIONS(4956),
    [anon_sym_word] = ACTIONS(4956),
    [anon_sym_enum] = ACTIONS(4956),
    [anon_sym_class] = ACTIONS(4956),
    [anon_sym_struct] = ACTIONS(4956),
    [anon_sym_union] = ACTIONS(4956),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4956),
    [anon_sym_decltype] = ACTIONS(4956),
    [anon_sym_virtual] = ACTIONS(4956),
    [anon_sym_alignas] = ACTIONS(4956),
    [anon_sym_explicit] = ACTIONS(4956),
    [anon_sym_typename] = ACTIONS(4956),
    [anon_sym_template] = ACTIONS(4956),
    [anon_sym_operator] = ACTIONS(4956),
    [anon_sym_friend] = ACTIONS(4956),
    [anon_sym_public] = ACTIONS(4956),
    [anon_sym_private] = ACTIONS(4956),
    [anon_sym_protected] = ACTIONS(4956),
    [anon_sym_using] = ACTIONS(4956),
    [anon_sym_static_assert] = ACTIONS(4956),
  },
  [2215] = {
    [sym_identifier] = ACTIONS(4960),
    [aux_sym_preproc_def_token1] = ACTIONS(4960),
    [aux_sym_preproc_if_token1] = ACTIONS(4960),
    [aux_sym_preproc_if_token2] = ACTIONS(4960),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4960),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4960),
    [sym_preproc_directive] = ACTIONS(4960),
    [anon_sym_LPAREN2] = ACTIONS(4962),
    [anon_sym_TILDE] = ACTIONS(4962),
    [anon_sym_STAR] = ACTIONS(4962),
    [anon_sym_AMP_AMP] = ACTIONS(4962),
    [anon_sym_AMP] = ACTIONS(4960),
    [anon_sym___extension__] = ACTIONS(4960),
    [anon_sym_typedef] = ACTIONS(4960),
    [anon_sym_extern] = ACTIONS(4960),
    [anon_sym___attribute__] = ACTIONS(4960),
    [anon_sym_COLON_COLON] = ACTIONS(4962),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4962),
    [anon_sym___declspec] = ACTIONS(4960),
    [anon_sym___based] = ACTIONS(4960),
    [anon_sym_signed] = ACTIONS(4960),
    [anon_sym_unsigned] = ACTIONS(4960),
    [anon_sym_long] = ACTIONS(4960),
    [anon_sym_short] = ACTIONS(4960),
    [anon_sym_LBRACK] = ACTIONS(4960),
    [anon_sym_static] = ACTIONS(4960),
    [anon_sym_register] = ACTIONS(4960),
    [anon_sym_inline] = ACTIONS(4960),
    [anon_sym___inline] = ACTIONS(4960),
    [anon_sym___inline__] = ACTIONS(4960),
    [anon_sym___forceinline] = ACTIONS(4960),
    [anon_sym_thread_local] = ACTIONS(4960),
    [anon_sym___thread] = ACTIONS(4960),
    [anon_sym_const] = ACTIONS(4960),
    [anon_sym_constexpr] = ACTIONS(4960),
    [anon_sym_volatile] = ACTIONS(4960),
    [anon_sym_restrict] = ACTIONS(4960),
    [anon_sym___restrict__] = ACTIONS(4960),
    [anon_sym__Atomic] = ACTIONS(4960),
    [anon_sym__Noreturn] = ACTIONS(4960),
    [anon_sym_noreturn] = ACTIONS(4960),
    [anon_sym_mutable] = ACTIONS(4960),
    [anon_sym_constinit] = ACTIONS(4960),
    [anon_sym_consteval] = ACTIONS(4960),
    [anon_sym_PROGMEM] = ACTIONS(4960),
    [aux_sym_primitive_type_token1] = ACTIONS(4960),
    [anon_sym_byte] = ACTIONS(4960),
    [anon_sym_word] = ACTIONS(4960),
    [anon_sym_enum] = ACTIONS(4960),
    [anon_sym_class] = ACTIONS(4960),
    [anon_sym_struct] = ACTIONS(4960),
    [anon_sym_union] = ACTIONS(4960),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4960),
    [anon_sym_decltype] = ACTIONS(4960),
    [anon_sym_virtual] = ACTIONS(4960),
    [anon_sym_alignas] = ACTIONS(4960),
    [anon_sym_explicit] = ACTIONS(4960),
    [anon_sym_typename] = ACTIONS(4960),
    [anon_sym_template] = ACTIONS(4960),
    [anon_sym_operator] = ACTIONS(4960),
    [anon_sym_friend] = ACTIONS(4960),
    [anon_sym_public] = ACTIONS(4960),
    [anon_sym_private] = ACTIONS(4960),
    [anon_sym_protected] = ACTIONS(4960),
    [anon_sym_using] = ACTIONS(4960),
    [anon_sym_static_assert] = ACTIONS(4960),
  },
  [2216] = {
    [sym_identifier] = ACTIONS(4964),
    [aux_sym_preproc_def_token1] = ACTIONS(4964),
    [aux_sym_preproc_if_token1] = ACTIONS(4964),
    [aux_sym_preproc_if_token2] = ACTIONS(4964),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4964),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4964),
    [sym_preproc_directive] = ACTIONS(4964),
    [anon_sym_LPAREN2] = ACTIONS(4966),
    [anon_sym_TILDE] = ACTIONS(4966),
    [anon_sym_STAR] = ACTIONS(4966),
    [anon_sym_AMP_AMP] = ACTIONS(4966),
    [anon_sym_AMP] = ACTIONS(4964),
    [anon_sym___extension__] = ACTIONS(4964),
    [anon_sym_typedef] = ACTIONS(4964),
    [anon_sym_extern] = ACTIONS(4964),
    [anon_sym___attribute__] = ACTIONS(4964),
    [anon_sym_COLON_COLON] = ACTIONS(4966),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4966),
    [anon_sym___declspec] = ACTIONS(4964),
    [anon_sym___based] = ACTIONS(4964),
    [anon_sym_signed] = ACTIONS(4964),
    [anon_sym_unsigned] = ACTIONS(4964),
    [anon_sym_long] = ACTIONS(4964),
    [anon_sym_short] = ACTIONS(4964),
    [anon_sym_LBRACK] = ACTIONS(4964),
    [anon_sym_static] = ACTIONS(4964),
    [anon_sym_register] = ACTIONS(4964),
    [anon_sym_inline] = ACTIONS(4964),
    [anon_sym___inline] = ACTIONS(4964),
    [anon_sym___inline__] = ACTIONS(4964),
    [anon_sym___forceinline] = ACTIONS(4964),
    [anon_sym_thread_local] = ACTIONS(4964),
    [anon_sym___thread] = ACTIONS(4964),
    [anon_sym_const] = ACTIONS(4964),
    [anon_sym_constexpr] = ACTIONS(4964),
    [anon_sym_volatile] = ACTIONS(4964),
    [anon_sym_restrict] = ACTIONS(4964),
    [anon_sym___restrict__] = ACTIONS(4964),
    [anon_sym__Atomic] = ACTIONS(4964),
    [anon_sym__Noreturn] = ACTIONS(4964),
    [anon_sym_noreturn] = ACTIONS(4964),
    [anon_sym_mutable] = ACTIONS(4964),
    [anon_sym_constinit] = ACTIONS(4964),
    [anon_sym_consteval] = ACTIONS(4964),
    [anon_sym_PROGMEM] = ACTIONS(4964),
    [aux_sym_primitive_type_token1] = ACTIONS(4964),
    [anon_sym_byte] = ACTIONS(4964),
    [anon_sym_word] = ACTIONS(4964),
    [anon_sym_enum] = ACTIONS(4964),
    [anon_sym_class] = ACTIONS(4964),
    [anon_sym_struct] = ACTIONS(4964),
    [anon_sym_union] = ACTIONS(4964),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4964),
    [anon_sym_decltype] = ACTIONS(4964),
    [anon_sym_virtual] = ACTIONS(4964),
    [anon_sym_alignas] = ACTIONS(4964),
    [anon_sym_explicit] = ACTIONS(4964),
    [anon_sym_typename] = ACTIONS(4964),
    [anon_sym_template] = ACTIONS(4964),
    [anon_sym_operator] = ACTIONS(4964),
    [anon_sym_friend] = ACTIONS(4964),
    [anon_sym_public] = ACTIONS(4964),
    [anon_sym_private] = ACTIONS(4964),
    [anon_sym_protected] = ACTIONS(4964),
    [anon_sym_using] = ACTIONS(4964),
    [anon_sym_static_assert] = ACTIONS(4964),
  },
  [2217] = {
    [sym_identifier] = ACTIONS(2723),
    [aux_sym_preproc_def_token1] = ACTIONS(2723),
    [aux_sym_preproc_if_token1] = ACTIONS(2723),
    [aux_sym_preproc_if_token2] = ACTIONS(2723),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2723),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2723),
    [sym_preproc_directive] = ACTIONS(2723),
    [anon_sym_LPAREN2] = ACTIONS(2725),
    [anon_sym_TILDE] = ACTIONS(2725),
    [anon_sym_STAR] = ACTIONS(2725),
    [anon_sym_AMP_AMP] = ACTIONS(2725),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym___extension__] = ACTIONS(2723),
    [anon_sym_typedef] = ACTIONS(2723),
    [anon_sym_extern] = ACTIONS(2723),
    [anon_sym___attribute__] = ACTIONS(2723),
    [anon_sym_COLON_COLON] = ACTIONS(2725),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2725),
    [anon_sym___declspec] = ACTIONS(2723),
    [anon_sym___based] = ACTIONS(2723),
    [anon_sym_signed] = ACTIONS(2723),
    [anon_sym_unsigned] = ACTIONS(2723),
    [anon_sym_long] = ACTIONS(2723),
    [anon_sym_short] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_static] = ACTIONS(2723),
    [anon_sym_register] = ACTIONS(2723),
    [anon_sym_inline] = ACTIONS(2723),
    [anon_sym___inline] = ACTIONS(2723),
    [anon_sym___inline__] = ACTIONS(2723),
    [anon_sym___forceinline] = ACTIONS(2723),
    [anon_sym_thread_local] = ACTIONS(2723),
    [anon_sym___thread] = ACTIONS(2723),
    [anon_sym_const] = ACTIONS(2723),
    [anon_sym_constexpr] = ACTIONS(2723),
    [anon_sym_volatile] = ACTIONS(2723),
    [anon_sym_restrict] = ACTIONS(2723),
    [anon_sym___restrict__] = ACTIONS(2723),
    [anon_sym__Atomic] = ACTIONS(2723),
    [anon_sym__Noreturn] = ACTIONS(2723),
    [anon_sym_noreturn] = ACTIONS(2723),
    [anon_sym_mutable] = ACTIONS(2723),
    [anon_sym_constinit] = ACTIONS(2723),
    [anon_sym_consteval] = ACTIONS(2723),
    [anon_sym_PROGMEM] = ACTIONS(2723),
    [aux_sym_primitive_type_token1] = ACTIONS(2723),
    [anon_sym_byte] = ACTIONS(2723),
    [anon_sym_word] = ACTIONS(2723),
    [anon_sym_enum] = ACTIONS(2723),
    [anon_sym_class] = ACTIONS(2723),
    [anon_sym_struct] = ACTIONS(2723),
    [anon_sym_union] = ACTIONS(2723),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2723),
    [anon_sym_decltype] = ACTIONS(2723),
    [anon_sym_virtual] = ACTIONS(2723),
    [anon_sym_alignas] = ACTIONS(2723),
    [anon_sym_explicit] = ACTIONS(2723),
    [anon_sym_typename] = ACTIONS(2723),
    [anon_sym_template] = ACTIONS(2723),
    [anon_sym_operator] = ACTIONS(2723),
    [anon_sym_friend] = ACTIONS(2723),
    [anon_sym_public] = ACTIONS(2723),
    [anon_sym_private] = ACTIONS(2723),
    [anon_sym_protected] = ACTIONS(2723),
    [anon_sym_using] = ACTIONS(2723),
    [anon_sym_static_assert] = ACTIONS(2723),
  },
  [2218] = {
    [sym_identifier] = ACTIONS(4968),
    [aux_sym_preproc_def_token1] = ACTIONS(4968),
    [aux_sym_preproc_if_token1] = ACTIONS(4968),
    [aux_sym_preproc_if_token2] = ACTIONS(4968),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4968),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4968),
    [sym_preproc_directive] = ACTIONS(4968),
    [anon_sym_LPAREN2] = ACTIONS(4970),
    [anon_sym_TILDE] = ACTIONS(4970),
    [anon_sym_STAR] = ACTIONS(4970),
    [anon_sym_AMP_AMP] = ACTIONS(4970),
    [anon_sym_AMP] = ACTIONS(4968),
    [anon_sym___extension__] = ACTIONS(4968),
    [anon_sym_typedef] = ACTIONS(4968),
    [anon_sym_extern] = ACTIONS(4968),
    [anon_sym___attribute__] = ACTIONS(4968),
    [anon_sym_COLON_COLON] = ACTIONS(4970),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4970),
    [anon_sym___declspec] = ACTIONS(4968),
    [anon_sym___based] = ACTIONS(4968),
    [anon_sym_signed] = ACTIONS(4968),
    [anon_sym_unsigned] = ACTIONS(4968),
    [anon_sym_long] = ACTIONS(4968),
    [anon_sym_short] = ACTIONS(4968),
    [anon_sym_LBRACK] = ACTIONS(4968),
    [anon_sym_static] = ACTIONS(4968),
    [anon_sym_register] = ACTIONS(4968),
    [anon_sym_inline] = ACTIONS(4968),
    [anon_sym___inline] = ACTIONS(4968),
    [anon_sym___inline__] = ACTIONS(4968),
    [anon_sym___forceinline] = ACTIONS(4968),
    [anon_sym_thread_local] = ACTIONS(4968),
    [anon_sym___thread] = ACTIONS(4968),
    [anon_sym_const] = ACTIONS(4968),
    [anon_sym_constexpr] = ACTIONS(4968),
    [anon_sym_volatile] = ACTIONS(4968),
    [anon_sym_restrict] = ACTIONS(4968),
    [anon_sym___restrict__] = ACTIONS(4968),
    [anon_sym__Atomic] = ACTIONS(4968),
    [anon_sym__Noreturn] = ACTIONS(4968),
    [anon_sym_noreturn] = ACTIONS(4968),
    [anon_sym_mutable] = ACTIONS(4968),
    [anon_sym_constinit] = ACTIONS(4968),
    [anon_sym_consteval] = ACTIONS(4968),
    [anon_sym_PROGMEM] = ACTIONS(4968),
    [aux_sym_primitive_type_token1] = ACTIONS(4968),
    [anon_sym_byte] = ACTIONS(4968),
    [anon_sym_word] = ACTIONS(4968),
    [anon_sym_enum] = ACTIONS(4968),
    [anon_sym_class] = ACTIONS(4968),
    [anon_sym_struct] = ACTIONS(4968),
    [anon_sym_union] = ACTIONS(4968),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4968),
    [anon_sym_decltype] = ACTIONS(4968),
    [anon_sym_virtual] = ACTIONS(4968),
    [anon_sym_alignas] = ACTIONS(4968),
    [anon_sym_explicit] = ACTIONS(4968),
    [anon_sym_typename] = ACTIONS(4968),
    [anon_sym_template] = ACTIONS(4968),
    [anon_sym_operator] = ACTIONS(4968),
    [anon_sym_friend] = ACTIONS(4968),
    [anon_sym_public] = ACTIONS(4968),
    [anon_sym_private] = ACTIONS(4968),
    [anon_sym_protected] = ACTIONS(4968),
    [anon_sym_using] = ACTIONS(4968),
    [anon_sym_static_assert] = ACTIONS(4968),
  },
  [2219] = {
    [sym_identifier] = ACTIONS(2639),
    [aux_sym_preproc_def_token1] = ACTIONS(2639),
    [aux_sym_preproc_if_token1] = ACTIONS(2639),
    [aux_sym_preproc_if_token2] = ACTIONS(2639),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2639),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2639),
    [sym_preproc_directive] = ACTIONS(2639),
    [anon_sym_LPAREN2] = ACTIONS(2641),
    [anon_sym_TILDE] = ACTIONS(2641),
    [anon_sym_STAR] = ACTIONS(2641),
    [anon_sym_AMP_AMP] = ACTIONS(2641),
    [anon_sym_AMP] = ACTIONS(2639),
    [anon_sym___extension__] = ACTIONS(2639),
    [anon_sym_typedef] = ACTIONS(2639),
    [anon_sym_extern] = ACTIONS(2639),
    [anon_sym___attribute__] = ACTIONS(2639),
    [anon_sym_COLON_COLON] = ACTIONS(2641),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2641),
    [anon_sym___declspec] = ACTIONS(2639),
    [anon_sym___based] = ACTIONS(2639),
    [anon_sym_signed] = ACTIONS(2639),
    [anon_sym_unsigned] = ACTIONS(2639),
    [anon_sym_long] = ACTIONS(2639),
    [anon_sym_short] = ACTIONS(2639),
    [anon_sym_LBRACK] = ACTIONS(2639),
    [anon_sym_static] = ACTIONS(2639),
    [anon_sym_register] = ACTIONS(2639),
    [anon_sym_inline] = ACTIONS(2639),
    [anon_sym___inline] = ACTIONS(2639),
    [anon_sym___inline__] = ACTIONS(2639),
    [anon_sym___forceinline] = ACTIONS(2639),
    [anon_sym_thread_local] = ACTIONS(2639),
    [anon_sym___thread] = ACTIONS(2639),
    [anon_sym_const] = ACTIONS(2639),
    [anon_sym_constexpr] = ACTIONS(2639),
    [anon_sym_volatile] = ACTIONS(2639),
    [anon_sym_restrict] = ACTIONS(2639),
    [anon_sym___restrict__] = ACTIONS(2639),
    [anon_sym__Atomic] = ACTIONS(2639),
    [anon_sym__Noreturn] = ACTIONS(2639),
    [anon_sym_noreturn] = ACTIONS(2639),
    [anon_sym_mutable] = ACTIONS(2639),
    [anon_sym_constinit] = ACTIONS(2639),
    [anon_sym_consteval] = ACTIONS(2639),
    [anon_sym_PROGMEM] = ACTIONS(2639),
    [aux_sym_primitive_type_token1] = ACTIONS(2639),
    [anon_sym_byte] = ACTIONS(2639),
    [anon_sym_word] = ACTIONS(2639),
    [anon_sym_enum] = ACTIONS(2639),
    [anon_sym_class] = ACTIONS(2639),
    [anon_sym_struct] = ACTIONS(2639),
    [anon_sym_union] = ACTIONS(2639),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2639),
    [anon_sym_decltype] = ACTIONS(2639),
    [anon_sym_virtual] = ACTIONS(2639),
    [anon_sym_alignas] = ACTIONS(2639),
    [anon_sym_explicit] = ACTIONS(2639),
    [anon_sym_typename] = ACTIONS(2639),
    [anon_sym_template] = ACTIONS(2639),
    [anon_sym_operator] = ACTIONS(2639),
    [anon_sym_friend] = ACTIONS(2639),
    [anon_sym_public] = ACTIONS(2639),
    [anon_sym_private] = ACTIONS(2639),
    [anon_sym_protected] = ACTIONS(2639),
    [anon_sym_using] = ACTIONS(2639),
    [anon_sym_static_assert] = ACTIONS(2639),
  },
  [2220] = {
    [sym_identifier] = ACTIONS(2797),
    [aux_sym_preproc_def_token1] = ACTIONS(2797),
    [aux_sym_preproc_if_token1] = ACTIONS(2797),
    [aux_sym_preproc_if_token2] = ACTIONS(2797),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2797),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2797),
    [sym_preproc_directive] = ACTIONS(2797),
    [anon_sym_LPAREN2] = ACTIONS(2799),
    [anon_sym_TILDE] = ACTIONS(2799),
    [anon_sym_STAR] = ACTIONS(2799),
    [anon_sym_AMP_AMP] = ACTIONS(2799),
    [anon_sym_AMP] = ACTIONS(2797),
    [anon_sym___extension__] = ACTIONS(2797),
    [anon_sym_typedef] = ACTIONS(2797),
    [anon_sym_extern] = ACTIONS(2797),
    [anon_sym___attribute__] = ACTIONS(2797),
    [anon_sym_COLON_COLON] = ACTIONS(2799),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2799),
    [anon_sym___declspec] = ACTIONS(2797),
    [anon_sym___based] = ACTIONS(2797),
    [anon_sym_signed] = ACTIONS(2797),
    [anon_sym_unsigned] = ACTIONS(2797),
    [anon_sym_long] = ACTIONS(2797),
    [anon_sym_short] = ACTIONS(2797),
    [anon_sym_LBRACK] = ACTIONS(2797),
    [anon_sym_static] = ACTIONS(2797),
    [anon_sym_register] = ACTIONS(2797),
    [anon_sym_inline] = ACTIONS(2797),
    [anon_sym___inline] = ACTIONS(2797),
    [anon_sym___inline__] = ACTIONS(2797),
    [anon_sym___forceinline] = ACTIONS(2797),
    [anon_sym_thread_local] = ACTIONS(2797),
    [anon_sym___thread] = ACTIONS(2797),
    [anon_sym_const] = ACTIONS(2797),
    [anon_sym_constexpr] = ACTIONS(2797),
    [anon_sym_volatile] = ACTIONS(2797),
    [anon_sym_restrict] = ACTIONS(2797),
    [anon_sym___restrict__] = ACTIONS(2797),
    [anon_sym__Atomic] = ACTIONS(2797),
    [anon_sym__Noreturn] = ACTIONS(2797),
    [anon_sym_noreturn] = ACTIONS(2797),
    [anon_sym_mutable] = ACTIONS(2797),
    [anon_sym_constinit] = ACTIONS(2797),
    [anon_sym_consteval] = ACTIONS(2797),
    [anon_sym_PROGMEM] = ACTIONS(2797),
    [aux_sym_primitive_type_token1] = ACTIONS(2797),
    [anon_sym_byte] = ACTIONS(2797),
    [anon_sym_word] = ACTIONS(2797),
    [anon_sym_enum] = ACTIONS(2797),
    [anon_sym_class] = ACTIONS(2797),
    [anon_sym_struct] = ACTIONS(2797),
    [anon_sym_union] = ACTIONS(2797),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2797),
    [anon_sym_decltype] = ACTIONS(2797),
    [anon_sym_virtual] = ACTIONS(2797),
    [anon_sym_alignas] = ACTIONS(2797),
    [anon_sym_explicit] = ACTIONS(2797),
    [anon_sym_typename] = ACTIONS(2797),
    [anon_sym_template] = ACTIONS(2797),
    [anon_sym_operator] = ACTIONS(2797),
    [anon_sym_friend] = ACTIONS(2797),
    [anon_sym_public] = ACTIONS(2797),
    [anon_sym_private] = ACTIONS(2797),
    [anon_sym_protected] = ACTIONS(2797),
    [anon_sym_using] = ACTIONS(2797),
    [anon_sym_static_assert] = ACTIONS(2797),
  },
  [2221] = {
    [sym_identifier] = ACTIONS(4972),
    [aux_sym_preproc_def_token1] = ACTIONS(4972),
    [aux_sym_preproc_if_token1] = ACTIONS(4972),
    [aux_sym_preproc_if_token2] = ACTIONS(4972),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4972),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4972),
    [sym_preproc_directive] = ACTIONS(4972),
    [anon_sym_LPAREN2] = ACTIONS(4974),
    [anon_sym_TILDE] = ACTIONS(4974),
    [anon_sym_STAR] = ACTIONS(4974),
    [anon_sym_AMP_AMP] = ACTIONS(4974),
    [anon_sym_AMP] = ACTIONS(4972),
    [anon_sym___extension__] = ACTIONS(4972),
    [anon_sym_typedef] = ACTIONS(4972),
    [anon_sym_extern] = ACTIONS(4972),
    [anon_sym___attribute__] = ACTIONS(4972),
    [anon_sym_COLON_COLON] = ACTIONS(4974),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4974),
    [anon_sym___declspec] = ACTIONS(4972),
    [anon_sym___based] = ACTIONS(4972),
    [anon_sym_signed] = ACTIONS(4972),
    [anon_sym_unsigned] = ACTIONS(4972),
    [anon_sym_long] = ACTIONS(4972),
    [anon_sym_short] = ACTIONS(4972),
    [anon_sym_LBRACK] = ACTIONS(4972),
    [anon_sym_static] = ACTIONS(4972),
    [anon_sym_register] = ACTIONS(4972),
    [anon_sym_inline] = ACTIONS(4972),
    [anon_sym___inline] = ACTIONS(4972),
    [anon_sym___inline__] = ACTIONS(4972),
    [anon_sym___forceinline] = ACTIONS(4972),
    [anon_sym_thread_local] = ACTIONS(4972),
    [anon_sym___thread] = ACTIONS(4972),
    [anon_sym_const] = ACTIONS(4972),
    [anon_sym_constexpr] = ACTIONS(4972),
    [anon_sym_volatile] = ACTIONS(4972),
    [anon_sym_restrict] = ACTIONS(4972),
    [anon_sym___restrict__] = ACTIONS(4972),
    [anon_sym__Atomic] = ACTIONS(4972),
    [anon_sym__Noreturn] = ACTIONS(4972),
    [anon_sym_noreturn] = ACTIONS(4972),
    [anon_sym_mutable] = ACTIONS(4972),
    [anon_sym_constinit] = ACTIONS(4972),
    [anon_sym_consteval] = ACTIONS(4972),
    [anon_sym_PROGMEM] = ACTIONS(4972),
    [aux_sym_primitive_type_token1] = ACTIONS(4972),
    [anon_sym_byte] = ACTIONS(4972),
    [anon_sym_word] = ACTIONS(4972),
    [anon_sym_enum] = ACTIONS(4972),
    [anon_sym_class] = ACTIONS(4972),
    [anon_sym_struct] = ACTIONS(4972),
    [anon_sym_union] = ACTIONS(4972),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4972),
    [anon_sym_decltype] = ACTIONS(4972),
    [anon_sym_virtual] = ACTIONS(4972),
    [anon_sym_alignas] = ACTIONS(4972),
    [anon_sym_explicit] = ACTIONS(4972),
    [anon_sym_typename] = ACTIONS(4972),
    [anon_sym_template] = ACTIONS(4972),
    [anon_sym_operator] = ACTIONS(4972),
    [anon_sym_friend] = ACTIONS(4972),
    [anon_sym_public] = ACTIONS(4972),
    [anon_sym_private] = ACTIONS(4972),
    [anon_sym_protected] = ACTIONS(4972),
    [anon_sym_using] = ACTIONS(4972),
    [anon_sym_static_assert] = ACTIONS(4972),
  },
  [2222] = {
    [sym_identifier] = ACTIONS(4976),
    [aux_sym_preproc_def_token1] = ACTIONS(4976),
    [aux_sym_preproc_if_token1] = ACTIONS(4976),
    [aux_sym_preproc_if_token2] = ACTIONS(4976),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4976),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4976),
    [sym_preproc_directive] = ACTIONS(4976),
    [anon_sym_LPAREN2] = ACTIONS(4978),
    [anon_sym_TILDE] = ACTIONS(4978),
    [anon_sym_STAR] = ACTIONS(4978),
    [anon_sym_AMP_AMP] = ACTIONS(4978),
    [anon_sym_AMP] = ACTIONS(4976),
    [anon_sym___extension__] = ACTIONS(4976),
    [anon_sym_typedef] = ACTIONS(4976),
    [anon_sym_extern] = ACTIONS(4976),
    [anon_sym___attribute__] = ACTIONS(4976),
    [anon_sym_COLON_COLON] = ACTIONS(4978),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4978),
    [anon_sym___declspec] = ACTIONS(4976),
    [anon_sym___based] = ACTIONS(4976),
    [anon_sym_signed] = ACTIONS(4976),
    [anon_sym_unsigned] = ACTIONS(4976),
    [anon_sym_long] = ACTIONS(4976),
    [anon_sym_short] = ACTIONS(4976),
    [anon_sym_LBRACK] = ACTIONS(4976),
    [anon_sym_static] = ACTIONS(4976),
    [anon_sym_register] = ACTIONS(4976),
    [anon_sym_inline] = ACTIONS(4976),
    [anon_sym___inline] = ACTIONS(4976),
    [anon_sym___inline__] = ACTIONS(4976),
    [anon_sym___forceinline] = ACTIONS(4976),
    [anon_sym_thread_local] = ACTIONS(4976),
    [anon_sym___thread] = ACTIONS(4976),
    [anon_sym_const] = ACTIONS(4976),
    [anon_sym_constexpr] = ACTIONS(4976),
    [anon_sym_volatile] = ACTIONS(4976),
    [anon_sym_restrict] = ACTIONS(4976),
    [anon_sym___restrict__] = ACTIONS(4976),
    [anon_sym__Atomic] = ACTIONS(4976),
    [anon_sym__Noreturn] = ACTIONS(4976),
    [anon_sym_noreturn] = ACTIONS(4976),
    [anon_sym_mutable] = ACTIONS(4976),
    [anon_sym_constinit] = ACTIONS(4976),
    [anon_sym_consteval] = ACTIONS(4976),
    [anon_sym_PROGMEM] = ACTIONS(4976),
    [aux_sym_primitive_type_token1] = ACTIONS(4976),
    [anon_sym_byte] = ACTIONS(4976),
    [anon_sym_word] = ACTIONS(4976),
    [anon_sym_enum] = ACTIONS(4976),
    [anon_sym_class] = ACTIONS(4976),
    [anon_sym_struct] = ACTIONS(4976),
    [anon_sym_union] = ACTIONS(4976),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4976),
    [anon_sym_decltype] = ACTIONS(4976),
    [anon_sym_virtual] = ACTIONS(4976),
    [anon_sym_alignas] = ACTIONS(4976),
    [anon_sym_explicit] = ACTIONS(4976),
    [anon_sym_typename] = ACTIONS(4976),
    [anon_sym_template] = ACTIONS(4976),
    [anon_sym_operator] = ACTIONS(4976),
    [anon_sym_friend] = ACTIONS(4976),
    [anon_sym_public] = ACTIONS(4976),
    [anon_sym_private] = ACTIONS(4976),
    [anon_sym_protected] = ACTIONS(4976),
    [anon_sym_using] = ACTIONS(4976),
    [anon_sym_static_assert] = ACTIONS(4976),
  },
  [2223] = {
    [sym_identifier] = ACTIONS(2751),
    [aux_sym_preproc_def_token1] = ACTIONS(2751),
    [aux_sym_preproc_if_token1] = ACTIONS(2751),
    [aux_sym_preproc_if_token2] = ACTIONS(2751),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2751),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2751),
    [sym_preproc_directive] = ACTIONS(2751),
    [anon_sym_LPAREN2] = ACTIONS(2753),
    [anon_sym_TILDE] = ACTIONS(2753),
    [anon_sym_STAR] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2751),
    [anon_sym___extension__] = ACTIONS(2751),
    [anon_sym_typedef] = ACTIONS(2751),
    [anon_sym_extern] = ACTIONS(2751),
    [anon_sym___attribute__] = ACTIONS(2751),
    [anon_sym_COLON_COLON] = ACTIONS(2753),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2753),
    [anon_sym___declspec] = ACTIONS(2751),
    [anon_sym___based] = ACTIONS(2751),
    [anon_sym_signed] = ACTIONS(2751),
    [anon_sym_unsigned] = ACTIONS(2751),
    [anon_sym_long] = ACTIONS(2751),
    [anon_sym_short] = ACTIONS(2751),
    [anon_sym_LBRACK] = ACTIONS(2751),
    [anon_sym_static] = ACTIONS(2751),
    [anon_sym_register] = ACTIONS(2751),
    [anon_sym_inline] = ACTIONS(2751),
    [anon_sym___inline] = ACTIONS(2751),
    [anon_sym___inline__] = ACTIONS(2751),
    [anon_sym___forceinline] = ACTIONS(2751),
    [anon_sym_thread_local] = ACTIONS(2751),
    [anon_sym___thread] = ACTIONS(2751),
    [anon_sym_const] = ACTIONS(2751),
    [anon_sym_constexpr] = ACTIONS(2751),
    [anon_sym_volatile] = ACTIONS(2751),
    [anon_sym_restrict] = ACTIONS(2751),
    [anon_sym___restrict__] = ACTIONS(2751),
    [anon_sym__Atomic] = ACTIONS(2751),
    [anon_sym__Noreturn] = ACTIONS(2751),
    [anon_sym_noreturn] = ACTIONS(2751),
    [anon_sym_mutable] = ACTIONS(2751),
    [anon_sym_constinit] = ACTIONS(2751),
    [anon_sym_consteval] = ACTIONS(2751),
    [anon_sym_PROGMEM] = ACTIONS(2751),
    [aux_sym_primitive_type_token1] = ACTIONS(2751),
    [anon_sym_byte] = ACTIONS(2751),
    [anon_sym_word] = ACTIONS(2751),
    [anon_sym_enum] = ACTIONS(2751),
    [anon_sym_class] = ACTIONS(2751),
    [anon_sym_struct] = ACTIONS(2751),
    [anon_sym_union] = ACTIONS(2751),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2751),
    [anon_sym_decltype] = ACTIONS(2751),
    [anon_sym_virtual] = ACTIONS(2751),
    [anon_sym_alignas] = ACTIONS(2751),
    [anon_sym_explicit] = ACTIONS(2751),
    [anon_sym_typename] = ACTIONS(2751),
    [anon_sym_template] = ACTIONS(2751),
    [anon_sym_operator] = ACTIONS(2751),
    [anon_sym_friend] = ACTIONS(2751),
    [anon_sym_public] = ACTIONS(2751),
    [anon_sym_private] = ACTIONS(2751),
    [anon_sym_protected] = ACTIONS(2751),
    [anon_sym_using] = ACTIONS(2751),
    [anon_sym_static_assert] = ACTIONS(2751),
  },
  [2224] = {
    [sym_identifier] = ACTIONS(4980),
    [aux_sym_preproc_def_token1] = ACTIONS(4980),
    [aux_sym_preproc_if_token1] = ACTIONS(4980),
    [aux_sym_preproc_if_token2] = ACTIONS(4980),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4980),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4980),
    [sym_preproc_directive] = ACTIONS(4980),
    [anon_sym_LPAREN2] = ACTIONS(4982),
    [anon_sym_TILDE] = ACTIONS(4982),
    [anon_sym_STAR] = ACTIONS(4982),
    [anon_sym_AMP_AMP] = ACTIONS(4982),
    [anon_sym_AMP] = ACTIONS(4980),
    [anon_sym___extension__] = ACTIONS(4980),
    [anon_sym_typedef] = ACTIONS(4980),
    [anon_sym_extern] = ACTIONS(4980),
    [anon_sym___attribute__] = ACTIONS(4980),
    [anon_sym_COLON_COLON] = ACTIONS(4982),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4982),
    [anon_sym___declspec] = ACTIONS(4980),
    [anon_sym___based] = ACTIONS(4980),
    [anon_sym_signed] = ACTIONS(4980),
    [anon_sym_unsigned] = ACTIONS(4980),
    [anon_sym_long] = ACTIONS(4980),
    [anon_sym_short] = ACTIONS(4980),
    [anon_sym_LBRACK] = ACTIONS(4980),
    [anon_sym_static] = ACTIONS(4980),
    [anon_sym_register] = ACTIONS(4980),
    [anon_sym_inline] = ACTIONS(4980),
    [anon_sym___inline] = ACTIONS(4980),
    [anon_sym___inline__] = ACTIONS(4980),
    [anon_sym___forceinline] = ACTIONS(4980),
    [anon_sym_thread_local] = ACTIONS(4980),
    [anon_sym___thread] = ACTIONS(4980),
    [anon_sym_const] = ACTIONS(4980),
    [anon_sym_constexpr] = ACTIONS(4980),
    [anon_sym_volatile] = ACTIONS(4980),
    [anon_sym_restrict] = ACTIONS(4980),
    [anon_sym___restrict__] = ACTIONS(4980),
    [anon_sym__Atomic] = ACTIONS(4980),
    [anon_sym__Noreturn] = ACTIONS(4980),
    [anon_sym_noreturn] = ACTIONS(4980),
    [anon_sym_mutable] = ACTIONS(4980),
    [anon_sym_constinit] = ACTIONS(4980),
    [anon_sym_consteval] = ACTIONS(4980),
    [anon_sym_PROGMEM] = ACTIONS(4980),
    [aux_sym_primitive_type_token1] = ACTIONS(4980),
    [anon_sym_byte] = ACTIONS(4980),
    [anon_sym_word] = ACTIONS(4980),
    [anon_sym_enum] = ACTIONS(4980),
    [anon_sym_class] = ACTIONS(4980),
    [anon_sym_struct] = ACTIONS(4980),
    [anon_sym_union] = ACTIONS(4980),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4980),
    [anon_sym_decltype] = ACTIONS(4980),
    [anon_sym_virtual] = ACTIONS(4980),
    [anon_sym_alignas] = ACTIONS(4980),
    [anon_sym_explicit] = ACTIONS(4980),
    [anon_sym_typename] = ACTIONS(4980),
    [anon_sym_template] = ACTIONS(4980),
    [anon_sym_operator] = ACTIONS(4980),
    [anon_sym_friend] = ACTIONS(4980),
    [anon_sym_public] = ACTIONS(4980),
    [anon_sym_private] = ACTIONS(4980),
    [anon_sym_protected] = ACTIONS(4980),
    [anon_sym_using] = ACTIONS(4980),
    [anon_sym_static_assert] = ACTIONS(4980),
  },
  [2225] = {
    [sym_identifier] = ACTIONS(4984),
    [aux_sym_preproc_def_token1] = ACTIONS(4984),
    [aux_sym_preproc_if_token1] = ACTIONS(4984),
    [aux_sym_preproc_if_token2] = ACTIONS(4984),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4984),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4984),
    [sym_preproc_directive] = ACTIONS(4984),
    [anon_sym_LPAREN2] = ACTIONS(4986),
    [anon_sym_TILDE] = ACTIONS(4986),
    [anon_sym_STAR] = ACTIONS(4986),
    [anon_sym_AMP_AMP] = ACTIONS(4986),
    [anon_sym_AMP] = ACTIONS(4984),
    [anon_sym___extension__] = ACTIONS(4984),
    [anon_sym_typedef] = ACTIONS(4984),
    [anon_sym_extern] = ACTIONS(4984),
    [anon_sym___attribute__] = ACTIONS(4984),
    [anon_sym_COLON_COLON] = ACTIONS(4986),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4986),
    [anon_sym___declspec] = ACTIONS(4984),
    [anon_sym___based] = ACTIONS(4984),
    [anon_sym_signed] = ACTIONS(4984),
    [anon_sym_unsigned] = ACTIONS(4984),
    [anon_sym_long] = ACTIONS(4984),
    [anon_sym_short] = ACTIONS(4984),
    [anon_sym_LBRACK] = ACTIONS(4984),
    [anon_sym_static] = ACTIONS(4984),
    [anon_sym_register] = ACTIONS(4984),
    [anon_sym_inline] = ACTIONS(4984),
    [anon_sym___inline] = ACTIONS(4984),
    [anon_sym___inline__] = ACTIONS(4984),
    [anon_sym___forceinline] = ACTIONS(4984),
    [anon_sym_thread_local] = ACTIONS(4984),
    [anon_sym___thread] = ACTIONS(4984),
    [anon_sym_const] = ACTIONS(4984),
    [anon_sym_constexpr] = ACTIONS(4984),
    [anon_sym_volatile] = ACTIONS(4984),
    [anon_sym_restrict] = ACTIONS(4984),
    [anon_sym___restrict__] = ACTIONS(4984),
    [anon_sym__Atomic] = ACTIONS(4984),
    [anon_sym__Noreturn] = ACTIONS(4984),
    [anon_sym_noreturn] = ACTIONS(4984),
    [anon_sym_mutable] = ACTIONS(4984),
    [anon_sym_constinit] = ACTIONS(4984),
    [anon_sym_consteval] = ACTIONS(4984),
    [anon_sym_PROGMEM] = ACTIONS(4984),
    [aux_sym_primitive_type_token1] = ACTIONS(4984),
    [anon_sym_byte] = ACTIONS(4984),
    [anon_sym_word] = ACTIONS(4984),
    [anon_sym_enum] = ACTIONS(4984),
    [anon_sym_class] = ACTIONS(4984),
    [anon_sym_struct] = ACTIONS(4984),
    [anon_sym_union] = ACTIONS(4984),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4984),
    [anon_sym_decltype] = ACTIONS(4984),
    [anon_sym_virtual] = ACTIONS(4984),
    [anon_sym_alignas] = ACTIONS(4984),
    [anon_sym_explicit] = ACTIONS(4984),
    [anon_sym_typename] = ACTIONS(4984),
    [anon_sym_template] = ACTIONS(4984),
    [anon_sym_operator] = ACTIONS(4984),
    [anon_sym_friend] = ACTIONS(4984),
    [anon_sym_public] = ACTIONS(4984),
    [anon_sym_private] = ACTIONS(4984),
    [anon_sym_protected] = ACTIONS(4984),
    [anon_sym_using] = ACTIONS(4984),
    [anon_sym_static_assert] = ACTIONS(4984),
  },
  [2226] = {
    [sym_identifier] = ACTIONS(4914),
    [aux_sym_preproc_def_token1] = ACTIONS(4914),
    [aux_sym_preproc_if_token1] = ACTIONS(4914),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4914),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4914),
    [sym_preproc_directive] = ACTIONS(4914),
    [anon_sym_LPAREN2] = ACTIONS(4916),
    [anon_sym_TILDE] = ACTIONS(4916),
    [anon_sym_STAR] = ACTIONS(4916),
    [anon_sym_AMP_AMP] = ACTIONS(4916),
    [anon_sym_AMP] = ACTIONS(4914),
    [anon_sym___extension__] = ACTIONS(4914),
    [anon_sym_typedef] = ACTIONS(4914),
    [anon_sym_extern] = ACTIONS(4914),
    [anon_sym___attribute__] = ACTIONS(4914),
    [anon_sym_COLON_COLON] = ACTIONS(4916),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4916),
    [anon_sym___declspec] = ACTIONS(4914),
    [anon_sym___based] = ACTIONS(4914),
    [anon_sym_RBRACE] = ACTIONS(4916),
    [anon_sym_signed] = ACTIONS(4914),
    [anon_sym_unsigned] = ACTIONS(4914),
    [anon_sym_long] = ACTIONS(4914),
    [anon_sym_short] = ACTIONS(4914),
    [anon_sym_LBRACK] = ACTIONS(4914),
    [anon_sym_static] = ACTIONS(4914),
    [anon_sym_register] = ACTIONS(4914),
    [anon_sym_inline] = ACTIONS(4914),
    [anon_sym___inline] = ACTIONS(4914),
    [anon_sym___inline__] = ACTIONS(4914),
    [anon_sym___forceinline] = ACTIONS(4914),
    [anon_sym_thread_local] = ACTIONS(4914),
    [anon_sym___thread] = ACTIONS(4914),
    [anon_sym_const] = ACTIONS(4914),
    [anon_sym_constexpr] = ACTIONS(4914),
    [anon_sym_volatile] = ACTIONS(4914),
    [anon_sym_restrict] = ACTIONS(4914),
    [anon_sym___restrict__] = ACTIONS(4914),
    [anon_sym__Atomic] = ACTIONS(4914),
    [anon_sym__Noreturn] = ACTIONS(4914),
    [anon_sym_noreturn] = ACTIONS(4914),
    [anon_sym_mutable] = ACTIONS(4914),
    [anon_sym_constinit] = ACTIONS(4914),
    [anon_sym_consteval] = ACTIONS(4914),
    [anon_sym_PROGMEM] = ACTIONS(4914),
    [aux_sym_primitive_type_token1] = ACTIONS(4914),
    [anon_sym_byte] = ACTIONS(4914),
    [anon_sym_word] = ACTIONS(4914),
    [anon_sym_enum] = ACTIONS(4914),
    [anon_sym_class] = ACTIONS(4914),
    [anon_sym_struct] = ACTIONS(4914),
    [anon_sym_union] = ACTIONS(4914),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4914),
    [anon_sym_decltype] = ACTIONS(4914),
    [anon_sym_virtual] = ACTIONS(4914),
    [anon_sym_alignas] = ACTIONS(4914),
    [anon_sym_explicit] = ACTIONS(4914),
    [anon_sym_typename] = ACTIONS(4914),
    [anon_sym_template] = ACTIONS(4914),
    [anon_sym_operator] = ACTIONS(4914),
    [anon_sym_friend] = ACTIONS(4914),
    [anon_sym_public] = ACTIONS(4914),
    [anon_sym_private] = ACTIONS(4914),
    [anon_sym_protected] = ACTIONS(4914),
    [anon_sym_using] = ACTIONS(4914),
    [anon_sym_static_assert] = ACTIONS(4914),
  },
  [2227] = {
    [sym_identifier] = ACTIONS(4988),
    [aux_sym_preproc_def_token1] = ACTIONS(4988),
    [aux_sym_preproc_if_token1] = ACTIONS(4988),
    [aux_sym_preproc_if_token2] = ACTIONS(4988),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4988),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4988),
    [sym_preproc_directive] = ACTIONS(4988),
    [anon_sym_LPAREN2] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_STAR] = ACTIONS(4990),
    [anon_sym_AMP_AMP] = ACTIONS(4990),
    [anon_sym_AMP] = ACTIONS(4988),
    [anon_sym___extension__] = ACTIONS(4988),
    [anon_sym_typedef] = ACTIONS(4988),
    [anon_sym_extern] = ACTIONS(4988),
    [anon_sym___attribute__] = ACTIONS(4988),
    [anon_sym_COLON_COLON] = ACTIONS(4990),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4990),
    [anon_sym___declspec] = ACTIONS(4988),
    [anon_sym___based] = ACTIONS(4988),
    [anon_sym_signed] = ACTIONS(4988),
    [anon_sym_unsigned] = ACTIONS(4988),
    [anon_sym_long] = ACTIONS(4988),
    [anon_sym_short] = ACTIONS(4988),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_static] = ACTIONS(4988),
    [anon_sym_register] = ACTIONS(4988),
    [anon_sym_inline] = ACTIONS(4988),
    [anon_sym___inline] = ACTIONS(4988),
    [anon_sym___inline__] = ACTIONS(4988),
    [anon_sym___forceinline] = ACTIONS(4988),
    [anon_sym_thread_local] = ACTIONS(4988),
    [anon_sym___thread] = ACTIONS(4988),
    [anon_sym_const] = ACTIONS(4988),
    [anon_sym_constexpr] = ACTIONS(4988),
    [anon_sym_volatile] = ACTIONS(4988),
    [anon_sym_restrict] = ACTIONS(4988),
    [anon_sym___restrict__] = ACTIONS(4988),
    [anon_sym__Atomic] = ACTIONS(4988),
    [anon_sym__Noreturn] = ACTIONS(4988),
    [anon_sym_noreturn] = ACTIONS(4988),
    [anon_sym_mutable] = ACTIONS(4988),
    [anon_sym_constinit] = ACTIONS(4988),
    [anon_sym_consteval] = ACTIONS(4988),
    [anon_sym_PROGMEM] = ACTIONS(4988),
    [aux_sym_primitive_type_token1] = ACTIONS(4988),
    [anon_sym_byte] = ACTIONS(4988),
    [anon_sym_word] = ACTIONS(4988),
    [anon_sym_enum] = ACTIONS(4988),
    [anon_sym_class] = ACTIONS(4988),
    [anon_sym_struct] = ACTIONS(4988),
    [anon_sym_union] = ACTIONS(4988),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4988),
    [anon_sym_decltype] = ACTIONS(4988),
    [anon_sym_virtual] = ACTIONS(4988),
    [anon_sym_alignas] = ACTIONS(4988),
    [anon_sym_explicit] = ACTIONS(4988),
    [anon_sym_typename] = ACTIONS(4988),
    [anon_sym_template] = ACTIONS(4988),
    [anon_sym_operator] = ACTIONS(4988),
    [anon_sym_friend] = ACTIONS(4988),
    [anon_sym_public] = ACTIONS(4988),
    [anon_sym_private] = ACTIONS(4988),
    [anon_sym_protected] = ACTIONS(4988),
    [anon_sym_using] = ACTIONS(4988),
    [anon_sym_static_assert] = ACTIONS(4988),
  },
  [2228] = {
    [sym_identifier] = ACTIONS(4992),
    [aux_sym_preproc_def_token1] = ACTIONS(4992),
    [aux_sym_preproc_if_token1] = ACTIONS(4992),
    [aux_sym_preproc_if_token2] = ACTIONS(4992),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4992),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4992),
    [sym_preproc_directive] = ACTIONS(4992),
    [anon_sym_LPAREN2] = ACTIONS(4994),
    [anon_sym_TILDE] = ACTIONS(4994),
    [anon_sym_STAR] = ACTIONS(4994),
    [anon_sym_AMP_AMP] = ACTIONS(4994),
    [anon_sym_AMP] = ACTIONS(4992),
    [anon_sym___extension__] = ACTIONS(4992),
    [anon_sym_typedef] = ACTIONS(4992),
    [anon_sym_extern] = ACTIONS(4992),
    [anon_sym___attribute__] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4994),
    [anon_sym___declspec] = ACTIONS(4992),
    [anon_sym___based] = ACTIONS(4992),
    [anon_sym_signed] = ACTIONS(4992),
    [anon_sym_unsigned] = ACTIONS(4992),
    [anon_sym_long] = ACTIONS(4992),
    [anon_sym_short] = ACTIONS(4992),
    [anon_sym_LBRACK] = ACTIONS(4992),
    [anon_sym_static] = ACTIONS(4992),
    [anon_sym_register] = ACTIONS(4992),
    [anon_sym_inline] = ACTIONS(4992),
    [anon_sym___inline] = ACTIONS(4992),
    [anon_sym___inline__] = ACTIONS(4992),
    [anon_sym___forceinline] = ACTIONS(4992),
    [anon_sym_thread_local] = ACTIONS(4992),
    [anon_sym___thread] = ACTIONS(4992),
    [anon_sym_const] = ACTIONS(4992),
    [anon_sym_constexpr] = ACTIONS(4992),
    [anon_sym_volatile] = ACTIONS(4992),
    [anon_sym_restrict] = ACTIONS(4992),
    [anon_sym___restrict__] = ACTIONS(4992),
    [anon_sym__Atomic] = ACTIONS(4992),
    [anon_sym__Noreturn] = ACTIONS(4992),
    [anon_sym_noreturn] = ACTIONS(4992),
    [anon_sym_mutable] = ACTIONS(4992),
    [anon_sym_constinit] = ACTIONS(4992),
    [anon_sym_consteval] = ACTIONS(4992),
    [anon_sym_PROGMEM] = ACTIONS(4992),
    [aux_sym_primitive_type_token1] = ACTIONS(4992),
    [anon_sym_byte] = ACTIONS(4992),
    [anon_sym_word] = ACTIONS(4992),
    [anon_sym_enum] = ACTIONS(4992),
    [anon_sym_class] = ACTIONS(4992),
    [anon_sym_struct] = ACTIONS(4992),
    [anon_sym_union] = ACTIONS(4992),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4992),
    [anon_sym_decltype] = ACTIONS(4992),
    [anon_sym_virtual] = ACTIONS(4992),
    [anon_sym_alignas] = ACTIONS(4992),
    [anon_sym_explicit] = ACTIONS(4992),
    [anon_sym_typename] = ACTIONS(4992),
    [anon_sym_template] = ACTIONS(4992),
    [anon_sym_operator] = ACTIONS(4992),
    [anon_sym_friend] = ACTIONS(4992),
    [anon_sym_public] = ACTIONS(4992),
    [anon_sym_private] = ACTIONS(4992),
    [anon_sym_protected] = ACTIONS(4992),
    [anon_sym_using] = ACTIONS(4992),
    [anon_sym_static_assert] = ACTIONS(4992),
  },
  [2229] = {
    [sym_identifier] = ACTIONS(4996),
    [aux_sym_preproc_def_token1] = ACTIONS(4996),
    [aux_sym_preproc_if_token1] = ACTIONS(4996),
    [aux_sym_preproc_if_token2] = ACTIONS(4996),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4996),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4996),
    [sym_preproc_directive] = ACTIONS(4996),
    [anon_sym_LPAREN2] = ACTIONS(4998),
    [anon_sym_TILDE] = ACTIONS(4998),
    [anon_sym_STAR] = ACTIONS(4998),
    [anon_sym_AMP_AMP] = ACTIONS(4998),
    [anon_sym_AMP] = ACTIONS(4996),
    [anon_sym___extension__] = ACTIONS(4996),
    [anon_sym_typedef] = ACTIONS(4996),
    [anon_sym_extern] = ACTIONS(4996),
    [anon_sym___attribute__] = ACTIONS(4996),
    [anon_sym_COLON_COLON] = ACTIONS(4998),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4998),
    [anon_sym___declspec] = ACTIONS(4996),
    [anon_sym___based] = ACTIONS(4996),
    [anon_sym_signed] = ACTIONS(4996),
    [anon_sym_unsigned] = ACTIONS(4996),
    [anon_sym_long] = ACTIONS(4996),
    [anon_sym_short] = ACTIONS(4996),
    [anon_sym_LBRACK] = ACTIONS(4996),
    [anon_sym_static] = ACTIONS(4996),
    [anon_sym_register] = ACTIONS(4996),
    [anon_sym_inline] = ACTIONS(4996),
    [anon_sym___inline] = ACTIONS(4996),
    [anon_sym___inline__] = ACTIONS(4996),
    [anon_sym___forceinline] = ACTIONS(4996),
    [anon_sym_thread_local] = ACTIONS(4996),
    [anon_sym___thread] = ACTIONS(4996),
    [anon_sym_const] = ACTIONS(4996),
    [anon_sym_constexpr] = ACTIONS(4996),
    [anon_sym_volatile] = ACTIONS(4996),
    [anon_sym_restrict] = ACTIONS(4996),
    [anon_sym___restrict__] = ACTIONS(4996),
    [anon_sym__Atomic] = ACTIONS(4996),
    [anon_sym__Noreturn] = ACTIONS(4996),
    [anon_sym_noreturn] = ACTIONS(4996),
    [anon_sym_mutable] = ACTIONS(4996),
    [anon_sym_constinit] = ACTIONS(4996),
    [anon_sym_consteval] = ACTIONS(4996),
    [anon_sym_PROGMEM] = ACTIONS(4996),
    [aux_sym_primitive_type_token1] = ACTIONS(4996),
    [anon_sym_byte] = ACTIONS(4996),
    [anon_sym_word] = ACTIONS(4996),
    [anon_sym_enum] = ACTIONS(4996),
    [anon_sym_class] = ACTIONS(4996),
    [anon_sym_struct] = ACTIONS(4996),
    [anon_sym_union] = ACTIONS(4996),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4996),
    [anon_sym_decltype] = ACTIONS(4996),
    [anon_sym_virtual] = ACTIONS(4996),
    [anon_sym_alignas] = ACTIONS(4996),
    [anon_sym_explicit] = ACTIONS(4996),
    [anon_sym_typename] = ACTIONS(4996),
    [anon_sym_template] = ACTIONS(4996),
    [anon_sym_operator] = ACTIONS(4996),
    [anon_sym_friend] = ACTIONS(4996),
    [anon_sym_public] = ACTIONS(4996),
    [anon_sym_private] = ACTIONS(4996),
    [anon_sym_protected] = ACTIONS(4996),
    [anon_sym_using] = ACTIONS(4996),
    [anon_sym_static_assert] = ACTIONS(4996),
  },
  [2230] = {
    [sym_identifier] = ACTIONS(5000),
    [aux_sym_preproc_def_token1] = ACTIONS(5000),
    [aux_sym_preproc_if_token1] = ACTIONS(5000),
    [aux_sym_preproc_if_token2] = ACTIONS(5000),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5000),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5000),
    [sym_preproc_directive] = ACTIONS(5000),
    [anon_sym_LPAREN2] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [anon_sym_STAR] = ACTIONS(5002),
    [anon_sym_AMP_AMP] = ACTIONS(5002),
    [anon_sym_AMP] = ACTIONS(5000),
    [anon_sym___extension__] = ACTIONS(5000),
    [anon_sym_typedef] = ACTIONS(5000),
    [anon_sym_extern] = ACTIONS(5000),
    [anon_sym___attribute__] = ACTIONS(5000),
    [anon_sym_COLON_COLON] = ACTIONS(5002),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5002),
    [anon_sym___declspec] = ACTIONS(5000),
    [anon_sym___based] = ACTIONS(5000),
    [anon_sym_signed] = ACTIONS(5000),
    [anon_sym_unsigned] = ACTIONS(5000),
    [anon_sym_long] = ACTIONS(5000),
    [anon_sym_short] = ACTIONS(5000),
    [anon_sym_LBRACK] = ACTIONS(5000),
    [anon_sym_static] = ACTIONS(5000),
    [anon_sym_register] = ACTIONS(5000),
    [anon_sym_inline] = ACTIONS(5000),
    [anon_sym___inline] = ACTIONS(5000),
    [anon_sym___inline__] = ACTIONS(5000),
    [anon_sym___forceinline] = ACTIONS(5000),
    [anon_sym_thread_local] = ACTIONS(5000),
    [anon_sym___thread] = ACTIONS(5000),
    [anon_sym_const] = ACTIONS(5000),
    [anon_sym_constexpr] = ACTIONS(5000),
    [anon_sym_volatile] = ACTIONS(5000),
    [anon_sym_restrict] = ACTIONS(5000),
    [anon_sym___restrict__] = ACTIONS(5000),
    [anon_sym__Atomic] = ACTIONS(5000),
    [anon_sym__Noreturn] = ACTIONS(5000),
    [anon_sym_noreturn] = ACTIONS(5000),
    [anon_sym_mutable] = ACTIONS(5000),
    [anon_sym_constinit] = ACTIONS(5000),
    [anon_sym_consteval] = ACTIONS(5000),
    [anon_sym_PROGMEM] = ACTIONS(5000),
    [aux_sym_primitive_type_token1] = ACTIONS(5000),
    [anon_sym_byte] = ACTIONS(5000),
    [anon_sym_word] = ACTIONS(5000),
    [anon_sym_enum] = ACTIONS(5000),
    [anon_sym_class] = ACTIONS(5000),
    [anon_sym_struct] = ACTIONS(5000),
    [anon_sym_union] = ACTIONS(5000),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5000),
    [anon_sym_decltype] = ACTIONS(5000),
    [anon_sym_virtual] = ACTIONS(5000),
    [anon_sym_alignas] = ACTIONS(5000),
    [anon_sym_explicit] = ACTIONS(5000),
    [anon_sym_typename] = ACTIONS(5000),
    [anon_sym_template] = ACTIONS(5000),
    [anon_sym_operator] = ACTIONS(5000),
    [anon_sym_friend] = ACTIONS(5000),
    [anon_sym_public] = ACTIONS(5000),
    [anon_sym_private] = ACTIONS(5000),
    [anon_sym_protected] = ACTIONS(5000),
    [anon_sym_using] = ACTIONS(5000),
    [anon_sym_static_assert] = ACTIONS(5000),
  },
  [2231] = {
    [sym_identifier] = ACTIONS(3040),
    [aux_sym_preproc_def_token1] = ACTIONS(3040),
    [aux_sym_preproc_if_token1] = ACTIONS(3040),
    [aux_sym_preproc_if_token2] = ACTIONS(3040),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3040),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3040),
    [sym_preproc_directive] = ACTIONS(3040),
    [anon_sym_LPAREN2] = ACTIONS(3042),
    [anon_sym_TILDE] = ACTIONS(3042),
    [anon_sym_STAR] = ACTIONS(3042),
    [anon_sym_AMP_AMP] = ACTIONS(3042),
    [anon_sym_AMP] = ACTIONS(3040),
    [anon_sym___extension__] = ACTIONS(3040),
    [anon_sym_typedef] = ACTIONS(3040),
    [anon_sym_extern] = ACTIONS(3040),
    [anon_sym___attribute__] = ACTIONS(3040),
    [anon_sym_COLON_COLON] = ACTIONS(3042),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3042),
    [anon_sym___declspec] = ACTIONS(3040),
    [anon_sym___based] = ACTIONS(3040),
    [anon_sym_signed] = ACTIONS(3040),
    [anon_sym_unsigned] = ACTIONS(3040),
    [anon_sym_long] = ACTIONS(3040),
    [anon_sym_short] = ACTIONS(3040),
    [anon_sym_LBRACK] = ACTIONS(3040),
    [anon_sym_static] = ACTIONS(3040),
    [anon_sym_register] = ACTIONS(3040),
    [anon_sym_inline] = ACTIONS(3040),
    [anon_sym___inline] = ACTIONS(3040),
    [anon_sym___inline__] = ACTIONS(3040),
    [anon_sym___forceinline] = ACTIONS(3040),
    [anon_sym_thread_local] = ACTIONS(3040),
    [anon_sym___thread] = ACTIONS(3040),
    [anon_sym_const] = ACTIONS(3040),
    [anon_sym_constexpr] = ACTIONS(3040),
    [anon_sym_volatile] = ACTIONS(3040),
    [anon_sym_restrict] = ACTIONS(3040),
    [anon_sym___restrict__] = ACTIONS(3040),
    [anon_sym__Atomic] = ACTIONS(3040),
    [anon_sym__Noreturn] = ACTIONS(3040),
    [anon_sym_noreturn] = ACTIONS(3040),
    [anon_sym_mutable] = ACTIONS(3040),
    [anon_sym_constinit] = ACTIONS(3040),
    [anon_sym_consteval] = ACTIONS(3040),
    [anon_sym_PROGMEM] = ACTIONS(3040),
    [aux_sym_primitive_type_token1] = ACTIONS(3040),
    [anon_sym_byte] = ACTIONS(3040),
    [anon_sym_word] = ACTIONS(3040),
    [anon_sym_enum] = ACTIONS(3040),
    [anon_sym_class] = ACTIONS(3040),
    [anon_sym_struct] = ACTIONS(3040),
    [anon_sym_union] = ACTIONS(3040),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3040),
    [anon_sym_decltype] = ACTIONS(3040),
    [anon_sym_virtual] = ACTIONS(3040),
    [anon_sym_alignas] = ACTIONS(3040),
    [anon_sym_explicit] = ACTIONS(3040),
    [anon_sym_typename] = ACTIONS(3040),
    [anon_sym_template] = ACTIONS(3040),
    [anon_sym_operator] = ACTIONS(3040),
    [anon_sym_friend] = ACTIONS(3040),
    [anon_sym_public] = ACTIONS(3040),
    [anon_sym_private] = ACTIONS(3040),
    [anon_sym_protected] = ACTIONS(3040),
    [anon_sym_using] = ACTIONS(3040),
    [anon_sym_static_assert] = ACTIONS(3040),
  },
  [2232] = {
    [sym_identifier] = ACTIONS(4960),
    [aux_sym_preproc_def_token1] = ACTIONS(4960),
    [aux_sym_preproc_if_token1] = ACTIONS(4960),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4960),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4960),
    [sym_preproc_directive] = ACTIONS(4960),
    [anon_sym_LPAREN2] = ACTIONS(4962),
    [anon_sym_TILDE] = ACTIONS(4962),
    [anon_sym_STAR] = ACTIONS(4962),
    [anon_sym_AMP_AMP] = ACTIONS(4962),
    [anon_sym_AMP] = ACTIONS(4960),
    [anon_sym___extension__] = ACTIONS(4960),
    [anon_sym_typedef] = ACTIONS(4960),
    [anon_sym_extern] = ACTIONS(4960),
    [anon_sym___attribute__] = ACTIONS(4960),
    [anon_sym_COLON_COLON] = ACTIONS(4962),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4962),
    [anon_sym___declspec] = ACTIONS(4960),
    [anon_sym___based] = ACTIONS(4960),
    [anon_sym_RBRACE] = ACTIONS(4962),
    [anon_sym_signed] = ACTIONS(4960),
    [anon_sym_unsigned] = ACTIONS(4960),
    [anon_sym_long] = ACTIONS(4960),
    [anon_sym_short] = ACTIONS(4960),
    [anon_sym_LBRACK] = ACTIONS(4960),
    [anon_sym_static] = ACTIONS(4960),
    [anon_sym_register] = ACTIONS(4960),
    [anon_sym_inline] = ACTIONS(4960),
    [anon_sym___inline] = ACTIONS(4960),
    [anon_sym___inline__] = ACTIONS(4960),
    [anon_sym___forceinline] = ACTIONS(4960),
    [anon_sym_thread_local] = ACTIONS(4960),
    [anon_sym___thread] = ACTIONS(4960),
    [anon_sym_const] = ACTIONS(4960),
    [anon_sym_constexpr] = ACTIONS(4960),
    [anon_sym_volatile] = ACTIONS(4960),
    [anon_sym_restrict] = ACTIONS(4960),
    [anon_sym___restrict__] = ACTIONS(4960),
    [anon_sym__Atomic] = ACTIONS(4960),
    [anon_sym__Noreturn] = ACTIONS(4960),
    [anon_sym_noreturn] = ACTIONS(4960),
    [anon_sym_mutable] = ACTIONS(4960),
    [anon_sym_constinit] = ACTIONS(4960),
    [anon_sym_consteval] = ACTIONS(4960),
    [anon_sym_PROGMEM] = ACTIONS(4960),
    [aux_sym_primitive_type_token1] = ACTIONS(4960),
    [anon_sym_byte] = ACTIONS(4960),
    [anon_sym_word] = ACTIONS(4960),
    [anon_sym_enum] = ACTIONS(4960),
    [anon_sym_class] = ACTIONS(4960),
    [anon_sym_struct] = ACTIONS(4960),
    [anon_sym_union] = ACTIONS(4960),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4960),
    [anon_sym_decltype] = ACTIONS(4960),
    [anon_sym_virtual] = ACTIONS(4960),
    [anon_sym_alignas] = ACTIONS(4960),
    [anon_sym_explicit] = ACTIONS(4960),
    [anon_sym_typename] = ACTIONS(4960),
    [anon_sym_template] = ACTIONS(4960),
    [anon_sym_operator] = ACTIONS(4960),
    [anon_sym_friend] = ACTIONS(4960),
    [anon_sym_public] = ACTIONS(4960),
    [anon_sym_private] = ACTIONS(4960),
    [anon_sym_protected] = ACTIONS(4960),
    [anon_sym_using] = ACTIONS(4960),
    [anon_sym_static_assert] = ACTIONS(4960),
  },
  [2233] = {
    [sym_identifier] = ACTIONS(4924),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4926),
    [anon_sym_COMMA] = ACTIONS(4926),
    [anon_sym_RPAREN] = ACTIONS(4926),
    [aux_sym_preproc_if_token2] = ACTIONS(4926),
    [aux_sym_preproc_else_token1] = ACTIONS(4926),
    [aux_sym_preproc_elif_token1] = ACTIONS(4924),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4926),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4926),
    [anon_sym_LPAREN2] = ACTIONS(4926),
    [anon_sym_DASH] = ACTIONS(4924),
    [anon_sym_PLUS] = ACTIONS(4924),
    [anon_sym_STAR] = ACTIONS(4926),
    [anon_sym_SLASH] = ACTIONS(4924),
    [anon_sym_PERCENT] = ACTIONS(4926),
    [anon_sym_PIPE_PIPE] = ACTIONS(4926),
    [anon_sym_AMP_AMP] = ACTIONS(4926),
    [anon_sym_PIPE] = ACTIONS(4924),
    [anon_sym_CARET] = ACTIONS(4926),
    [anon_sym_AMP] = ACTIONS(4924),
    [anon_sym_EQ_EQ] = ACTIONS(4926),
    [anon_sym_BANG_EQ] = ACTIONS(4926),
    [anon_sym_GT] = ACTIONS(4924),
    [anon_sym_GT_EQ] = ACTIONS(4926),
    [anon_sym_LT_EQ] = ACTIONS(4924),
    [anon_sym_LT] = ACTIONS(4924),
    [anon_sym_LT_LT] = ACTIONS(4926),
    [anon_sym_GT_GT] = ACTIONS(4926),
    [anon_sym_SEMI] = ACTIONS(4926),
    [anon_sym___extension__] = ACTIONS(4924),
    [anon_sym___attribute__] = ACTIONS(4924),
    [anon_sym_LBRACE] = ACTIONS(4926),
    [anon_sym_RBRACE] = ACTIONS(4926),
    [anon_sym_LBRACK] = ACTIONS(4926),
    [anon_sym_RBRACK] = ACTIONS(4926),
    [anon_sym_const] = ACTIONS(4924),
    [anon_sym_constexpr] = ACTIONS(4924),
    [anon_sym_volatile] = ACTIONS(4924),
    [anon_sym_restrict] = ACTIONS(4924),
    [anon_sym___restrict__] = ACTIONS(4924),
    [anon_sym__Atomic] = ACTIONS(4924),
    [anon_sym__Noreturn] = ACTIONS(4924),
    [anon_sym_noreturn] = ACTIONS(4924),
    [anon_sym_mutable] = ACTIONS(4924),
    [anon_sym_constinit] = ACTIONS(4924),
    [anon_sym_consteval] = ACTIONS(4924),
    [anon_sym_PROGMEM] = ACTIONS(4924),
    [anon_sym_COLON] = ACTIONS(4926),
    [anon_sym_QMARK] = ACTIONS(4926),
    [anon_sym_LT_EQ_GT] = ACTIONS(4926),
    [anon_sym_or] = ACTIONS(4924),
    [anon_sym_and] = ACTIONS(4924),
    [anon_sym_bitor] = ACTIONS(4924),
    [anon_sym_xor] = ACTIONS(4924),
    [anon_sym_bitand] = ACTIONS(4924),
    [anon_sym_not_eq] = ACTIONS(4924),
    [anon_sym_DASH_DASH] = ACTIONS(4926),
    [anon_sym_PLUS_PLUS] = ACTIONS(4926),
    [anon_sym_DOT] = ACTIONS(4924),
    [anon_sym_DOT_STAR] = ACTIONS(4926),
    [anon_sym_DASH_GT] = ACTIONS(4926),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4924),
    [anon_sym_decltype] = ACTIONS(4924),
    [anon_sym_final] = ACTIONS(4924),
    [anon_sym_override] = ACTIONS(4924),
    [anon_sym_requires] = ACTIONS(4924),
  },
  [2234] = {
    [sym_identifier] = ACTIONS(3036),
    [aux_sym_preproc_def_token1] = ACTIONS(3036),
    [aux_sym_preproc_if_token1] = ACTIONS(3036),
    [aux_sym_preproc_if_token2] = ACTIONS(3036),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3036),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3036),
    [sym_preproc_directive] = ACTIONS(3036),
    [anon_sym_LPAREN2] = ACTIONS(3038),
    [anon_sym_TILDE] = ACTIONS(3038),
    [anon_sym_STAR] = ACTIONS(3038),
    [anon_sym_AMP_AMP] = ACTIONS(3038),
    [anon_sym_AMP] = ACTIONS(3036),
    [anon_sym___extension__] = ACTIONS(3036),
    [anon_sym_typedef] = ACTIONS(3036),
    [anon_sym_extern] = ACTIONS(3036),
    [anon_sym___attribute__] = ACTIONS(3036),
    [anon_sym_COLON_COLON] = ACTIONS(3038),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3038),
    [anon_sym___declspec] = ACTIONS(3036),
    [anon_sym___based] = ACTIONS(3036),
    [anon_sym_signed] = ACTIONS(3036),
    [anon_sym_unsigned] = ACTIONS(3036),
    [anon_sym_long] = ACTIONS(3036),
    [anon_sym_short] = ACTIONS(3036),
    [anon_sym_LBRACK] = ACTIONS(3036),
    [anon_sym_static] = ACTIONS(3036),
    [anon_sym_register] = ACTIONS(3036),
    [anon_sym_inline] = ACTIONS(3036),
    [anon_sym___inline] = ACTIONS(3036),
    [anon_sym___inline__] = ACTIONS(3036),
    [anon_sym___forceinline] = ACTIONS(3036),
    [anon_sym_thread_local] = ACTIONS(3036),
    [anon_sym___thread] = ACTIONS(3036),
    [anon_sym_const] = ACTIONS(3036),
    [anon_sym_constexpr] = ACTIONS(3036),
    [anon_sym_volatile] = ACTIONS(3036),
    [anon_sym_restrict] = ACTIONS(3036),
    [anon_sym___restrict__] = ACTIONS(3036),
    [anon_sym__Atomic] = ACTIONS(3036),
    [anon_sym__Noreturn] = ACTIONS(3036),
    [anon_sym_noreturn] = ACTIONS(3036),
    [anon_sym_mutable] = ACTIONS(3036),
    [anon_sym_constinit] = ACTIONS(3036),
    [anon_sym_consteval] = ACTIONS(3036),
    [anon_sym_PROGMEM] = ACTIONS(3036),
    [aux_sym_primitive_type_token1] = ACTIONS(3036),
    [anon_sym_byte] = ACTIONS(3036),
    [anon_sym_word] = ACTIONS(3036),
    [anon_sym_enum] = ACTIONS(3036),
    [anon_sym_class] = ACTIONS(3036),
    [anon_sym_struct] = ACTIONS(3036),
    [anon_sym_union] = ACTIONS(3036),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3036),
    [anon_sym_decltype] = ACTIONS(3036),
    [anon_sym_virtual] = ACTIONS(3036),
    [anon_sym_alignas] = ACTIONS(3036),
    [anon_sym_explicit] = ACTIONS(3036),
    [anon_sym_typename] = ACTIONS(3036),
    [anon_sym_template] = ACTIONS(3036),
    [anon_sym_operator] = ACTIONS(3036),
    [anon_sym_friend] = ACTIONS(3036),
    [anon_sym_public] = ACTIONS(3036),
    [anon_sym_private] = ACTIONS(3036),
    [anon_sym_protected] = ACTIONS(3036),
    [anon_sym_using] = ACTIONS(3036),
    [anon_sym_static_assert] = ACTIONS(3036),
  },
  [2235] = {
    [sym_string_literal] = STATE(3304),
    [sym_template_argument_list] = STATE(3723),
    [sym_raw_string_literal] = STATE(3304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3761),
    [anon_sym_COMMA] = ACTIONS(3761),
    [anon_sym_LPAREN2] = ACTIONS(3761),
    [anon_sym_DASH] = ACTIONS(3769),
    [anon_sym_PLUS] = ACTIONS(3769),
    [anon_sym_STAR] = ACTIONS(3769),
    [anon_sym_SLASH] = ACTIONS(3769),
    [anon_sym_PERCENT] = ACTIONS(3769),
    [anon_sym_PIPE_PIPE] = ACTIONS(3761),
    [anon_sym_AMP_AMP] = ACTIONS(3761),
    [anon_sym_PIPE] = ACTIONS(3769),
    [anon_sym_CARET] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(3769),
    [anon_sym_EQ_EQ] = ACTIONS(3761),
    [anon_sym_BANG_EQ] = ACTIONS(3761),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3761),
    [anon_sym_LT_EQ] = ACTIONS(3769),
    [anon_sym_LT] = ACTIONS(5242),
    [anon_sym_LT_LT] = ACTIONS(3769),
    [anon_sym_GT_GT] = ACTIONS(3769),
    [anon_sym_SEMI] = ACTIONS(3761),
    [anon_sym___attribute__] = ACTIONS(3761),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(3785),
    [anon_sym_LBRACK] = ACTIONS(3761),
    [anon_sym_EQ] = ACTIONS(5340),
    [anon_sym_QMARK] = ACTIONS(3761),
    [anon_sym_STAR_EQ] = ACTIONS(5342),
    [anon_sym_SLASH_EQ] = ACTIONS(5342),
    [anon_sym_PERCENT_EQ] = ACTIONS(5342),
    [anon_sym_PLUS_EQ] = ACTIONS(5342),
    [anon_sym_DASH_EQ] = ACTIONS(5342),
    [anon_sym_LT_LT_EQ] = ACTIONS(5342),
    [anon_sym_GT_GT_EQ] = ACTIONS(5342),
    [anon_sym_AMP_EQ] = ACTIONS(5342),
    [anon_sym_CARET_EQ] = ACTIONS(5342),
    [anon_sym_PIPE_EQ] = ACTIONS(5342),
    [anon_sym_and_eq] = ACTIONS(5342),
    [anon_sym_or_eq] = ACTIONS(5342),
    [anon_sym_xor_eq] = ACTIONS(5342),
    [anon_sym_LT_EQ_GT] = ACTIONS(3761),
    [anon_sym_or] = ACTIONS(3769),
    [anon_sym_and] = ACTIONS(3769),
    [anon_sym_bitor] = ACTIONS(3761),
    [anon_sym_xor] = ACTIONS(3769),
    [anon_sym_bitand] = ACTIONS(3761),
    [anon_sym_not_eq] = ACTIONS(3761),
    [anon_sym_DASH_DASH] = ACTIONS(3761),
    [anon_sym_PLUS_PLUS] = ACTIONS(3761),
    [anon_sym_DOT] = ACTIONS(3769),
    [anon_sym_DOT_STAR] = ACTIONS(3761),
    [anon_sym_DASH_GT] = ACTIONS(3761),
    [anon_sym_L_DQUOTE] = ACTIONS(5344),
    [anon_sym_u_DQUOTE] = ACTIONS(5344),
    [anon_sym_U_DQUOTE] = ACTIONS(5344),
    [anon_sym_u8_DQUOTE] = ACTIONS(5344),
    [anon_sym_DQUOTE] = ACTIONS(5344),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5346),
    [anon_sym_LR_DQUOTE] = ACTIONS(5346),
    [anon_sym_uR_DQUOTE] = ACTIONS(5346),
    [anon_sym_UR_DQUOTE] = ACTIONS(5346),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5346),
  },
  [2236] = {
    [sym_identifier] = ACTIONS(2723),
    [aux_sym_preproc_def_token1] = ACTIONS(2723),
    [aux_sym_preproc_if_token1] = ACTIONS(2723),
    [aux_sym_preproc_if_token2] = ACTIONS(2723),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2723),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2723),
    [sym_preproc_directive] = ACTIONS(2723),
    [anon_sym_LPAREN2] = ACTIONS(2725),
    [anon_sym_TILDE] = ACTIONS(2725),
    [anon_sym_STAR] = ACTIONS(2725),
    [anon_sym_AMP_AMP] = ACTIONS(2725),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym___extension__] = ACTIONS(2723),
    [anon_sym_typedef] = ACTIONS(2723),
    [anon_sym_extern] = ACTIONS(2723),
    [anon_sym___attribute__] = ACTIONS(2723),
    [anon_sym_COLON_COLON] = ACTIONS(2725),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2725),
    [anon_sym___declspec] = ACTIONS(2723),
    [anon_sym___based] = ACTIONS(2723),
    [anon_sym_signed] = ACTIONS(2723),
    [anon_sym_unsigned] = ACTIONS(2723),
    [anon_sym_long] = ACTIONS(2723),
    [anon_sym_short] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_static] = ACTIONS(2723),
    [anon_sym_register] = ACTIONS(2723),
    [anon_sym_inline] = ACTIONS(2723),
    [anon_sym___inline] = ACTIONS(2723),
    [anon_sym___inline__] = ACTIONS(2723),
    [anon_sym___forceinline] = ACTIONS(2723),
    [anon_sym_thread_local] = ACTIONS(2723),
    [anon_sym___thread] = ACTIONS(2723),
    [anon_sym_const] = ACTIONS(2723),
    [anon_sym_constexpr] = ACTIONS(2723),
    [anon_sym_volatile] = ACTIONS(2723),
    [anon_sym_restrict] = ACTIONS(2723),
    [anon_sym___restrict__] = ACTIONS(2723),
    [anon_sym__Atomic] = ACTIONS(2723),
    [anon_sym__Noreturn] = ACTIONS(2723),
    [anon_sym_noreturn] = ACTIONS(2723),
    [anon_sym_mutable] = ACTIONS(2723),
    [anon_sym_constinit] = ACTIONS(2723),
    [anon_sym_consteval] = ACTIONS(2723),
    [anon_sym_PROGMEM] = ACTIONS(2723),
    [aux_sym_primitive_type_token1] = ACTIONS(2723),
    [anon_sym_byte] = ACTIONS(2723),
    [anon_sym_word] = ACTIONS(2723),
    [anon_sym_enum] = ACTIONS(2723),
    [anon_sym_class] = ACTIONS(2723),
    [anon_sym_struct] = ACTIONS(2723),
    [anon_sym_union] = ACTIONS(2723),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2723),
    [anon_sym_decltype] = ACTIONS(2723),
    [anon_sym_virtual] = ACTIONS(2723),
    [anon_sym_alignas] = ACTIONS(2723),
    [anon_sym_explicit] = ACTIONS(2723),
    [anon_sym_typename] = ACTIONS(2723),
    [anon_sym_template] = ACTIONS(2723),
    [anon_sym_operator] = ACTIONS(2723),
    [anon_sym_friend] = ACTIONS(2723),
    [anon_sym_public] = ACTIONS(2723),
    [anon_sym_private] = ACTIONS(2723),
    [anon_sym_protected] = ACTIONS(2723),
    [anon_sym_using] = ACTIONS(2723),
    [anon_sym_static_assert] = ACTIONS(2723),
  },
  [2237] = {
    [sym_identifier] = ACTIONS(5004),
    [aux_sym_preproc_def_token1] = ACTIONS(5004),
    [aux_sym_preproc_if_token1] = ACTIONS(5004),
    [aux_sym_preproc_if_token2] = ACTIONS(5004),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5004),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5004),
    [sym_preproc_directive] = ACTIONS(5004),
    [anon_sym_LPAREN2] = ACTIONS(5006),
    [anon_sym_TILDE] = ACTIONS(5006),
    [anon_sym_STAR] = ACTIONS(5006),
    [anon_sym_AMP_AMP] = ACTIONS(5006),
    [anon_sym_AMP] = ACTIONS(5004),
    [anon_sym___extension__] = ACTIONS(5004),
    [anon_sym_typedef] = ACTIONS(5004),
    [anon_sym_extern] = ACTIONS(5004),
    [anon_sym___attribute__] = ACTIONS(5004),
    [anon_sym_COLON_COLON] = ACTIONS(5006),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5006),
    [anon_sym___declspec] = ACTIONS(5004),
    [anon_sym___based] = ACTIONS(5004),
    [anon_sym_signed] = ACTIONS(5004),
    [anon_sym_unsigned] = ACTIONS(5004),
    [anon_sym_long] = ACTIONS(5004),
    [anon_sym_short] = ACTIONS(5004),
    [anon_sym_LBRACK] = ACTIONS(5004),
    [anon_sym_static] = ACTIONS(5004),
    [anon_sym_register] = ACTIONS(5004),
    [anon_sym_inline] = ACTIONS(5004),
    [anon_sym___inline] = ACTIONS(5004),
    [anon_sym___inline__] = ACTIONS(5004),
    [anon_sym___forceinline] = ACTIONS(5004),
    [anon_sym_thread_local] = ACTIONS(5004),
    [anon_sym___thread] = ACTIONS(5004),
    [anon_sym_const] = ACTIONS(5004),
    [anon_sym_constexpr] = ACTIONS(5004),
    [anon_sym_volatile] = ACTIONS(5004),
    [anon_sym_restrict] = ACTIONS(5004),
    [anon_sym___restrict__] = ACTIONS(5004),
    [anon_sym__Atomic] = ACTIONS(5004),
    [anon_sym__Noreturn] = ACTIONS(5004),
    [anon_sym_noreturn] = ACTIONS(5004),
    [anon_sym_mutable] = ACTIONS(5004),
    [anon_sym_constinit] = ACTIONS(5004),
    [anon_sym_consteval] = ACTIONS(5004),
    [anon_sym_PROGMEM] = ACTIONS(5004),
    [aux_sym_primitive_type_token1] = ACTIONS(5004),
    [anon_sym_byte] = ACTIONS(5004),
    [anon_sym_word] = ACTIONS(5004),
    [anon_sym_enum] = ACTIONS(5004),
    [anon_sym_class] = ACTIONS(5004),
    [anon_sym_struct] = ACTIONS(5004),
    [anon_sym_union] = ACTIONS(5004),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5004),
    [anon_sym_decltype] = ACTIONS(5004),
    [anon_sym_virtual] = ACTIONS(5004),
    [anon_sym_alignas] = ACTIONS(5004),
    [anon_sym_explicit] = ACTIONS(5004),
    [anon_sym_typename] = ACTIONS(5004),
    [anon_sym_template] = ACTIONS(5004),
    [anon_sym_operator] = ACTIONS(5004),
    [anon_sym_friend] = ACTIONS(5004),
    [anon_sym_public] = ACTIONS(5004),
    [anon_sym_private] = ACTIONS(5004),
    [anon_sym_protected] = ACTIONS(5004),
    [anon_sym_using] = ACTIONS(5004),
    [anon_sym_static_assert] = ACTIONS(5004),
  },
  [2238] = {
    [sym_identifier] = ACTIONS(5016),
    [aux_sym_preproc_def_token1] = ACTIONS(5016),
    [aux_sym_preproc_if_token1] = ACTIONS(5016),
    [aux_sym_preproc_if_token2] = ACTIONS(5016),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5016),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5016),
    [sym_preproc_directive] = ACTIONS(5016),
    [anon_sym_LPAREN2] = ACTIONS(5018),
    [anon_sym_TILDE] = ACTIONS(5018),
    [anon_sym_STAR] = ACTIONS(5018),
    [anon_sym_AMP_AMP] = ACTIONS(5018),
    [anon_sym_AMP] = ACTIONS(5016),
    [anon_sym___extension__] = ACTIONS(5016),
    [anon_sym_typedef] = ACTIONS(5016),
    [anon_sym_extern] = ACTIONS(5016),
    [anon_sym___attribute__] = ACTIONS(5016),
    [anon_sym_COLON_COLON] = ACTIONS(5018),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5018),
    [anon_sym___declspec] = ACTIONS(5016),
    [anon_sym___based] = ACTIONS(5016),
    [anon_sym_signed] = ACTIONS(5016),
    [anon_sym_unsigned] = ACTIONS(5016),
    [anon_sym_long] = ACTIONS(5016),
    [anon_sym_short] = ACTIONS(5016),
    [anon_sym_LBRACK] = ACTIONS(5016),
    [anon_sym_static] = ACTIONS(5016),
    [anon_sym_register] = ACTIONS(5016),
    [anon_sym_inline] = ACTIONS(5016),
    [anon_sym___inline] = ACTIONS(5016),
    [anon_sym___inline__] = ACTIONS(5016),
    [anon_sym___forceinline] = ACTIONS(5016),
    [anon_sym_thread_local] = ACTIONS(5016),
    [anon_sym___thread] = ACTIONS(5016),
    [anon_sym_const] = ACTIONS(5016),
    [anon_sym_constexpr] = ACTIONS(5016),
    [anon_sym_volatile] = ACTIONS(5016),
    [anon_sym_restrict] = ACTIONS(5016),
    [anon_sym___restrict__] = ACTIONS(5016),
    [anon_sym__Atomic] = ACTIONS(5016),
    [anon_sym__Noreturn] = ACTIONS(5016),
    [anon_sym_noreturn] = ACTIONS(5016),
    [anon_sym_mutable] = ACTIONS(5016),
    [anon_sym_constinit] = ACTIONS(5016),
    [anon_sym_consteval] = ACTIONS(5016),
    [anon_sym_PROGMEM] = ACTIONS(5016),
    [aux_sym_primitive_type_token1] = ACTIONS(5016),
    [anon_sym_byte] = ACTIONS(5016),
    [anon_sym_word] = ACTIONS(5016),
    [anon_sym_enum] = ACTIONS(5016),
    [anon_sym_class] = ACTIONS(5016),
    [anon_sym_struct] = ACTIONS(5016),
    [anon_sym_union] = ACTIONS(5016),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5016),
    [anon_sym_decltype] = ACTIONS(5016),
    [anon_sym_virtual] = ACTIONS(5016),
    [anon_sym_alignas] = ACTIONS(5016),
    [anon_sym_explicit] = ACTIONS(5016),
    [anon_sym_typename] = ACTIONS(5016),
    [anon_sym_template] = ACTIONS(5016),
    [anon_sym_operator] = ACTIONS(5016),
    [anon_sym_friend] = ACTIONS(5016),
    [anon_sym_public] = ACTIONS(5016),
    [anon_sym_private] = ACTIONS(5016),
    [anon_sym_protected] = ACTIONS(5016),
    [anon_sym_using] = ACTIONS(5016),
    [anon_sym_static_assert] = ACTIONS(5016),
  },
  [2239] = {
    [sym_identifier] = ACTIONS(5020),
    [aux_sym_preproc_def_token1] = ACTIONS(5020),
    [aux_sym_preproc_if_token1] = ACTIONS(5020),
    [aux_sym_preproc_if_token2] = ACTIONS(5020),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5020),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5020),
    [sym_preproc_directive] = ACTIONS(5020),
    [anon_sym_LPAREN2] = ACTIONS(5022),
    [anon_sym_TILDE] = ACTIONS(5022),
    [anon_sym_STAR] = ACTIONS(5022),
    [anon_sym_AMP_AMP] = ACTIONS(5022),
    [anon_sym_AMP] = ACTIONS(5020),
    [anon_sym___extension__] = ACTIONS(5020),
    [anon_sym_typedef] = ACTIONS(5020),
    [anon_sym_extern] = ACTIONS(5020),
    [anon_sym___attribute__] = ACTIONS(5020),
    [anon_sym_COLON_COLON] = ACTIONS(5022),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5022),
    [anon_sym___declspec] = ACTIONS(5020),
    [anon_sym___based] = ACTIONS(5020),
    [anon_sym_signed] = ACTIONS(5020),
    [anon_sym_unsigned] = ACTIONS(5020),
    [anon_sym_long] = ACTIONS(5020),
    [anon_sym_short] = ACTIONS(5020),
    [anon_sym_LBRACK] = ACTIONS(5020),
    [anon_sym_static] = ACTIONS(5020),
    [anon_sym_register] = ACTIONS(5020),
    [anon_sym_inline] = ACTIONS(5020),
    [anon_sym___inline] = ACTIONS(5020),
    [anon_sym___inline__] = ACTIONS(5020),
    [anon_sym___forceinline] = ACTIONS(5020),
    [anon_sym_thread_local] = ACTIONS(5020),
    [anon_sym___thread] = ACTIONS(5020),
    [anon_sym_const] = ACTIONS(5020),
    [anon_sym_constexpr] = ACTIONS(5020),
    [anon_sym_volatile] = ACTIONS(5020),
    [anon_sym_restrict] = ACTIONS(5020),
    [anon_sym___restrict__] = ACTIONS(5020),
    [anon_sym__Atomic] = ACTIONS(5020),
    [anon_sym__Noreturn] = ACTIONS(5020),
    [anon_sym_noreturn] = ACTIONS(5020),
    [anon_sym_mutable] = ACTIONS(5020),
    [anon_sym_constinit] = ACTIONS(5020),
    [anon_sym_consteval] = ACTIONS(5020),
    [anon_sym_PROGMEM] = ACTIONS(5020),
    [aux_sym_primitive_type_token1] = ACTIONS(5020),
    [anon_sym_byte] = ACTIONS(5020),
    [anon_sym_word] = ACTIONS(5020),
    [anon_sym_enum] = ACTIONS(5020),
    [anon_sym_class] = ACTIONS(5020),
    [anon_sym_struct] = ACTIONS(5020),
    [anon_sym_union] = ACTIONS(5020),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5020),
    [anon_sym_decltype] = ACTIONS(5020),
    [anon_sym_virtual] = ACTIONS(5020),
    [anon_sym_alignas] = ACTIONS(5020),
    [anon_sym_explicit] = ACTIONS(5020),
    [anon_sym_typename] = ACTIONS(5020),
    [anon_sym_template] = ACTIONS(5020),
    [anon_sym_operator] = ACTIONS(5020),
    [anon_sym_friend] = ACTIONS(5020),
    [anon_sym_public] = ACTIONS(5020),
    [anon_sym_private] = ACTIONS(5020),
    [anon_sym_protected] = ACTIONS(5020),
    [anon_sym_using] = ACTIONS(5020),
    [anon_sym_static_assert] = ACTIONS(5020),
  },
  [2240] = {
    [sym_identifier] = ACTIONS(5020),
    [aux_sym_preproc_def_token1] = ACTIONS(5020),
    [aux_sym_preproc_if_token1] = ACTIONS(5020),
    [aux_sym_preproc_if_token2] = ACTIONS(5020),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5020),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5020),
    [sym_preproc_directive] = ACTIONS(5020),
    [anon_sym_LPAREN2] = ACTIONS(5022),
    [anon_sym_TILDE] = ACTIONS(5022),
    [anon_sym_STAR] = ACTIONS(5022),
    [anon_sym_AMP_AMP] = ACTIONS(5022),
    [anon_sym_AMP] = ACTIONS(5020),
    [anon_sym___extension__] = ACTIONS(5020),
    [anon_sym_typedef] = ACTIONS(5020),
    [anon_sym_extern] = ACTIONS(5020),
    [anon_sym___attribute__] = ACTIONS(5020),
    [anon_sym_COLON_COLON] = ACTIONS(5022),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5022),
    [anon_sym___declspec] = ACTIONS(5020),
    [anon_sym___based] = ACTIONS(5020),
    [anon_sym_signed] = ACTIONS(5020),
    [anon_sym_unsigned] = ACTIONS(5020),
    [anon_sym_long] = ACTIONS(5020),
    [anon_sym_short] = ACTIONS(5020),
    [anon_sym_LBRACK] = ACTIONS(5020),
    [anon_sym_static] = ACTIONS(5020),
    [anon_sym_register] = ACTIONS(5020),
    [anon_sym_inline] = ACTIONS(5020),
    [anon_sym___inline] = ACTIONS(5020),
    [anon_sym___inline__] = ACTIONS(5020),
    [anon_sym___forceinline] = ACTIONS(5020),
    [anon_sym_thread_local] = ACTIONS(5020),
    [anon_sym___thread] = ACTIONS(5020),
    [anon_sym_const] = ACTIONS(5020),
    [anon_sym_constexpr] = ACTIONS(5020),
    [anon_sym_volatile] = ACTIONS(5020),
    [anon_sym_restrict] = ACTIONS(5020),
    [anon_sym___restrict__] = ACTIONS(5020),
    [anon_sym__Atomic] = ACTIONS(5020),
    [anon_sym__Noreturn] = ACTIONS(5020),
    [anon_sym_noreturn] = ACTIONS(5020),
    [anon_sym_mutable] = ACTIONS(5020),
    [anon_sym_constinit] = ACTIONS(5020),
    [anon_sym_consteval] = ACTIONS(5020),
    [anon_sym_PROGMEM] = ACTIONS(5020),
    [aux_sym_primitive_type_token1] = ACTIONS(5020),
    [anon_sym_byte] = ACTIONS(5020),
    [anon_sym_word] = ACTIONS(5020),
    [anon_sym_enum] = ACTIONS(5020),
    [anon_sym_class] = ACTIONS(5020),
    [anon_sym_struct] = ACTIONS(5020),
    [anon_sym_union] = ACTIONS(5020),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5020),
    [anon_sym_decltype] = ACTIONS(5020),
    [anon_sym_virtual] = ACTIONS(5020),
    [anon_sym_alignas] = ACTIONS(5020),
    [anon_sym_explicit] = ACTIONS(5020),
    [anon_sym_typename] = ACTIONS(5020),
    [anon_sym_template] = ACTIONS(5020),
    [anon_sym_operator] = ACTIONS(5020),
    [anon_sym_friend] = ACTIONS(5020),
    [anon_sym_public] = ACTIONS(5020),
    [anon_sym_private] = ACTIONS(5020),
    [anon_sym_protected] = ACTIONS(5020),
    [anon_sym_using] = ACTIONS(5020),
    [anon_sym_static_assert] = ACTIONS(5020),
  },
  [2241] = {
    [sym_identifier] = ACTIONS(2723),
    [aux_sym_preproc_def_token1] = ACTIONS(2723),
    [aux_sym_preproc_if_token1] = ACTIONS(2723),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2723),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2723),
    [sym_preproc_directive] = ACTIONS(2723),
    [anon_sym_LPAREN2] = ACTIONS(2725),
    [anon_sym_TILDE] = ACTIONS(2725),
    [anon_sym_STAR] = ACTIONS(2725),
    [anon_sym_AMP_AMP] = ACTIONS(2725),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym___extension__] = ACTIONS(2723),
    [anon_sym_typedef] = ACTIONS(2723),
    [anon_sym_extern] = ACTIONS(2723),
    [anon_sym___attribute__] = ACTIONS(2723),
    [anon_sym_COLON_COLON] = ACTIONS(2725),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2725),
    [anon_sym___declspec] = ACTIONS(2723),
    [anon_sym___based] = ACTIONS(2723),
    [anon_sym_RBRACE] = ACTIONS(2725),
    [anon_sym_signed] = ACTIONS(2723),
    [anon_sym_unsigned] = ACTIONS(2723),
    [anon_sym_long] = ACTIONS(2723),
    [anon_sym_short] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_static] = ACTIONS(2723),
    [anon_sym_register] = ACTIONS(2723),
    [anon_sym_inline] = ACTIONS(2723),
    [anon_sym___inline] = ACTIONS(2723),
    [anon_sym___inline__] = ACTIONS(2723),
    [anon_sym___forceinline] = ACTIONS(2723),
    [anon_sym_thread_local] = ACTIONS(2723),
    [anon_sym___thread] = ACTIONS(2723),
    [anon_sym_const] = ACTIONS(2723),
    [anon_sym_constexpr] = ACTIONS(2723),
    [anon_sym_volatile] = ACTIONS(2723),
    [anon_sym_restrict] = ACTIONS(2723),
    [anon_sym___restrict__] = ACTIONS(2723),
    [anon_sym__Atomic] = ACTIONS(2723),
    [anon_sym__Noreturn] = ACTIONS(2723),
    [anon_sym_noreturn] = ACTIONS(2723),
    [anon_sym_mutable] = ACTIONS(2723),
    [anon_sym_constinit] = ACTIONS(2723),
    [anon_sym_consteval] = ACTIONS(2723),
    [anon_sym_PROGMEM] = ACTIONS(2723),
    [aux_sym_primitive_type_token1] = ACTIONS(2723),
    [anon_sym_byte] = ACTIONS(2723),
    [anon_sym_word] = ACTIONS(2723),
    [anon_sym_enum] = ACTIONS(2723),
    [anon_sym_class] = ACTIONS(2723),
    [anon_sym_struct] = ACTIONS(2723),
    [anon_sym_union] = ACTIONS(2723),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2723),
    [anon_sym_decltype] = ACTIONS(2723),
    [anon_sym_virtual] = ACTIONS(2723),
    [anon_sym_alignas] = ACTIONS(2723),
    [anon_sym_explicit] = ACTIONS(2723),
    [anon_sym_typename] = ACTIONS(2723),
    [anon_sym_template] = ACTIONS(2723),
    [anon_sym_operator] = ACTIONS(2723),
    [anon_sym_friend] = ACTIONS(2723),
    [anon_sym_public] = ACTIONS(2723),
    [anon_sym_private] = ACTIONS(2723),
    [anon_sym_protected] = ACTIONS(2723),
    [anon_sym_using] = ACTIONS(2723),
    [anon_sym_static_assert] = ACTIONS(2723),
  },
  [2242] = {
    [sym_identifier] = ACTIONS(4898),
    [aux_sym_preproc_def_token1] = ACTIONS(4898),
    [aux_sym_preproc_if_token1] = ACTIONS(4898),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(4898),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(4898),
    [sym_preproc_directive] = ACTIONS(4898),
    [anon_sym_LPAREN2] = ACTIONS(4900),
    [anon_sym_TILDE] = ACTIONS(4900),
    [anon_sym_STAR] = ACTIONS(4900),
    [anon_sym_AMP_AMP] = ACTIONS(4900),
    [anon_sym_AMP] = ACTIONS(4898),
    [anon_sym___extension__] = ACTIONS(4898),
    [anon_sym_typedef] = ACTIONS(4898),
    [anon_sym_extern] = ACTIONS(4898),
    [anon_sym___attribute__] = ACTIONS(4898),
    [anon_sym_COLON_COLON] = ACTIONS(4900),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4900),
    [anon_sym___declspec] = ACTIONS(4898),
    [anon_sym___based] = ACTIONS(4898),
    [anon_sym_RBRACE] = ACTIONS(4900),
    [anon_sym_signed] = ACTIONS(4898),
    [anon_sym_unsigned] = ACTIONS(4898),
    [anon_sym_long] = ACTIONS(4898),
    [anon_sym_short] = ACTIONS(4898),
    [anon_sym_LBRACK] = ACTIONS(4898),
    [anon_sym_static] = ACTIONS(4898),
    [anon_sym_register] = ACTIONS(4898),
    [anon_sym_inline] = ACTIONS(4898),
    [anon_sym___inline] = ACTIONS(4898),
    [anon_sym___inline__] = ACTIONS(4898),
    [anon_sym___forceinline] = ACTIONS(4898),
    [anon_sym_thread_local] = ACTIONS(4898),
    [anon_sym___thread] = ACTIONS(4898),
    [anon_sym_const] = ACTIONS(4898),
    [anon_sym_constexpr] = ACTIONS(4898),
    [anon_sym_volatile] = ACTIONS(4898),
    [anon_sym_restrict] = ACTIONS(4898),
    [anon_sym___restrict__] = ACTIONS(4898),
    [anon_sym__Atomic] = ACTIONS(4898),
    [anon_sym__Noreturn] = ACTIONS(4898),
    [anon_sym_noreturn] = ACTIONS(4898),
    [anon_sym_mutable] = ACTIONS(4898),
    [anon_sym_constinit] = ACTIONS(4898),
    [anon_sym_consteval] = ACTIONS(4898),
    [anon_sym_PROGMEM] = ACTIONS(4898),
    [aux_sym_primitive_type_token1] = ACTIONS(4898),
    [anon_sym_byte] = ACTIONS(4898),
    [anon_sym_word] = ACTIONS(4898),
    [anon_sym_enum] = ACTIONS(4898),
    [anon_sym_class] = ACTIONS(4898),
    [anon_sym_struct] = ACTIONS(4898),
    [anon_sym_union] = ACTIONS(4898),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4898),
    [anon_sym_decltype] = ACTIONS(4898),
    [anon_sym_virtual] = ACTIONS(4898),
    [anon_sym_alignas] = ACTIONS(4898),
    [anon_sym_explicit] = ACTIONS(4898),
    [anon_sym_typename] = ACTIONS(4898),
    [anon_sym_template] = ACTIONS(4898),
    [anon_sym_operator] = ACTIONS(4898),
    [anon_sym_friend] = ACTIONS(4898),
    [anon_sym_public] = ACTIONS(4898),
    [anon_sym_private] = ACTIONS(4898),
    [anon_sym_protected] = ACTIONS(4898),
    [anon_sym_using] = ACTIONS(4898),
    [anon_sym_static_assert] = ACTIONS(4898),
  },
  [2243] = {
    [sym_identifier] = ACTIONS(5008),
    [aux_sym_preproc_def_token1] = ACTIONS(5008),
    [aux_sym_preproc_if_token1] = ACTIONS(5008),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5008),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5008),
    [sym_preproc_directive] = ACTIONS(5008),
    [anon_sym_LPAREN2] = ACTIONS(5010),
    [anon_sym_TILDE] = ACTIONS(5010),
    [anon_sym_STAR] = ACTIONS(5010),
    [anon_sym_AMP_AMP] = ACTIONS(5010),
    [anon_sym_AMP] = ACTIONS(5008),
    [anon_sym___extension__] = ACTIONS(5008),
    [anon_sym_typedef] = ACTIONS(5008),
    [anon_sym_extern] = ACTIONS(5008),
    [anon_sym___attribute__] = ACTIONS(5008),
    [anon_sym_COLON_COLON] = ACTIONS(5010),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5010),
    [anon_sym___declspec] = ACTIONS(5008),
    [anon_sym___based] = ACTIONS(5008),
    [anon_sym_RBRACE] = ACTIONS(5010),
    [anon_sym_signed] = ACTIONS(5008),
    [anon_sym_unsigned] = ACTIONS(5008),
    [anon_sym_long] = ACTIONS(5008),
    [anon_sym_short] = ACTIONS(5008),
    [anon_sym_LBRACK] = ACTIONS(5008),
    [anon_sym_static] = ACTIONS(5008),
    [anon_sym_register] = ACTIONS(5008),
    [anon_sym_inline] = ACTIONS(5008),
    [anon_sym___inline] = ACTIONS(5008),
    [anon_sym___inline__] = ACTIONS(5008),
    [anon_sym___forceinline] = ACTIONS(5008),
    [anon_sym_thread_local] = ACTIONS(5008),
    [anon_sym___thread] = ACTIONS(5008),
    [anon_sym_const] = ACTIONS(5008),
    [anon_sym_constexpr] = ACTIONS(5008),
    [anon_sym_volatile] = ACTIONS(5008),
    [anon_sym_restrict] = ACTIONS(5008),
    [anon_sym___restrict__] = ACTIONS(5008),
    [anon_sym__Atomic] = ACTIONS(5008),
    [anon_sym__Noreturn] = ACTIONS(5008),
    [anon_sym_noreturn] = ACTIONS(5008),
    [anon_sym_mutable] = ACTIONS(5008),
    [anon_sym_constinit] = ACTIONS(5008),
    [anon_sym_consteval] = ACTIONS(5008),
    [anon_sym_PROGMEM] = ACTIONS(5008),
    [aux_sym_primitive_type_token1] = ACTIONS(5008),
    [anon_sym_byte] = ACTIONS(5008),
    [anon_sym_word] = ACTIONS(5008),
    [anon_sym_enum] = ACTIONS(5008),
    [anon_sym_class] = ACTIONS(5008),
    [anon_sym_struct] = ACTIONS(5008),
    [anon_sym_union] = ACTIONS(5008),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5008),
    [anon_sym_decltype] = ACTIONS(5008),
    [anon_sym_virtual] = ACTIONS(5008),
    [anon_sym_alignas] = ACTIONS(5008),
    [anon_sym_explicit] = ACTIONS(5008),
    [anon_sym_typename] = ACTIONS(5008),
    [anon_sym_template] = ACTIONS(5008),
    [anon_sym_operator] = ACTIONS(5008),
    [anon_sym_friend] = ACTIONS(5008),
    [anon_sym_public] = ACTIONS(5008),
    [anon_sym_private] = ACTIONS(5008),
    [anon_sym_protected] = ACTIONS(5008),
    [anon_sym_using] = ACTIONS(5008),
    [anon_sym_static_assert] = ACTIONS(5008),
  },
  [2244] = {
    [sym_identifier] = ACTIONS(5024),
    [aux_sym_preproc_def_token1] = ACTIONS(5024),
    [aux_sym_preproc_if_token1] = ACTIONS(5024),
    [aux_sym_preproc_if_token2] = ACTIONS(5024),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5024),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5024),
    [sym_preproc_directive] = ACTIONS(5024),
    [anon_sym_LPAREN2] = ACTIONS(5026),
    [anon_sym_TILDE] = ACTIONS(5026),
    [anon_sym_STAR] = ACTIONS(5026),
    [anon_sym_AMP_AMP] = ACTIONS(5026),
    [anon_sym_AMP] = ACTIONS(5024),
    [anon_sym___extension__] = ACTIONS(5024),
    [anon_sym_typedef] = ACTIONS(5024),
    [anon_sym_extern] = ACTIONS(5024),
    [anon_sym___attribute__] = ACTIONS(5024),
    [anon_sym_COLON_COLON] = ACTIONS(5026),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5026),
    [anon_sym___declspec] = ACTIONS(5024),
    [anon_sym___based] = ACTIONS(5024),
    [anon_sym_signed] = ACTIONS(5024),
    [anon_sym_unsigned] = ACTIONS(5024),
    [anon_sym_long] = ACTIONS(5024),
    [anon_sym_short] = ACTIONS(5024),
    [anon_sym_LBRACK] = ACTIONS(5024),
    [anon_sym_static] = ACTIONS(5024),
    [anon_sym_register] = ACTIONS(5024),
    [anon_sym_inline] = ACTIONS(5024),
    [anon_sym___inline] = ACTIONS(5024),
    [anon_sym___inline__] = ACTIONS(5024),
    [anon_sym___forceinline] = ACTIONS(5024),
    [anon_sym_thread_local] = ACTIONS(5024),
    [anon_sym___thread] = ACTIONS(5024),
    [anon_sym_const] = ACTIONS(5024),
    [anon_sym_constexpr] = ACTIONS(5024),
    [anon_sym_volatile] = ACTIONS(5024),
    [anon_sym_restrict] = ACTIONS(5024),
    [anon_sym___restrict__] = ACTIONS(5024),
    [anon_sym__Atomic] = ACTIONS(5024),
    [anon_sym__Noreturn] = ACTIONS(5024),
    [anon_sym_noreturn] = ACTIONS(5024),
    [anon_sym_mutable] = ACTIONS(5024),
    [anon_sym_constinit] = ACTIONS(5024),
    [anon_sym_consteval] = ACTIONS(5024),
    [anon_sym_PROGMEM] = ACTIONS(5024),
    [aux_sym_primitive_type_token1] = ACTIONS(5024),
    [anon_sym_byte] = ACTIONS(5024),
    [anon_sym_word] = ACTIONS(5024),
    [anon_sym_enum] = ACTIONS(5024),
    [anon_sym_class] = ACTIONS(5024),
    [anon_sym_struct] = ACTIONS(5024),
    [anon_sym_union] = ACTIONS(5024),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5024),
    [anon_sym_decltype] = ACTIONS(5024),
    [anon_sym_virtual] = ACTIONS(5024),
    [anon_sym_alignas] = ACTIONS(5024),
    [anon_sym_explicit] = ACTIONS(5024),
    [anon_sym_typename] = ACTIONS(5024),
    [anon_sym_template] = ACTIONS(5024),
    [anon_sym_operator] = ACTIONS(5024),
    [anon_sym_friend] = ACTIONS(5024),
    [anon_sym_public] = ACTIONS(5024),
    [anon_sym_private] = ACTIONS(5024),
    [anon_sym_protected] = ACTIONS(5024),
    [anon_sym_using] = ACTIONS(5024),
    [anon_sym_static_assert] = ACTIONS(5024),
  },
  [2245] = {
    [sym_identifier] = ACTIONS(5012),
    [aux_sym_preproc_def_token1] = ACTIONS(5012),
    [aux_sym_preproc_if_token1] = ACTIONS(5012),
    [aux_sym_preproc_if_token2] = ACTIONS(5012),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5012),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5012),
    [sym_preproc_directive] = ACTIONS(5012),
    [anon_sym_LPAREN2] = ACTIONS(5014),
    [anon_sym_TILDE] = ACTIONS(5014),
    [anon_sym_STAR] = ACTIONS(5014),
    [anon_sym_AMP_AMP] = ACTIONS(5014),
    [anon_sym_AMP] = ACTIONS(5012),
    [anon_sym___extension__] = ACTIONS(5012),
    [anon_sym_typedef] = ACTIONS(5012),
    [anon_sym_extern] = ACTIONS(5012),
    [anon_sym___attribute__] = ACTIONS(5012),
    [anon_sym_COLON_COLON] = ACTIONS(5014),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5014),
    [anon_sym___declspec] = ACTIONS(5012),
    [anon_sym___based] = ACTIONS(5012),
    [anon_sym_signed] = ACTIONS(5012),
    [anon_sym_unsigned] = ACTIONS(5012),
    [anon_sym_long] = ACTIONS(5012),
    [anon_sym_short] = ACTIONS(5012),
    [anon_sym_LBRACK] = ACTIONS(5012),
    [anon_sym_static] = ACTIONS(5012),
    [anon_sym_register] = ACTIONS(5012),
    [anon_sym_inline] = ACTIONS(5012),
    [anon_sym___inline] = ACTIONS(5012),
    [anon_sym___inline__] = ACTIONS(5012),
    [anon_sym___forceinline] = ACTIONS(5012),
    [anon_sym_thread_local] = ACTIONS(5012),
    [anon_sym___thread] = ACTIONS(5012),
    [anon_sym_const] = ACTIONS(5012),
    [anon_sym_constexpr] = ACTIONS(5012),
    [anon_sym_volatile] = ACTIONS(5012),
    [anon_sym_restrict] = ACTIONS(5012),
    [anon_sym___restrict__] = ACTIONS(5012),
    [anon_sym__Atomic] = ACTIONS(5012),
    [anon_sym__Noreturn] = ACTIONS(5012),
    [anon_sym_noreturn] = ACTIONS(5012),
    [anon_sym_mutable] = ACTIONS(5012),
    [anon_sym_constinit] = ACTIONS(5012),
    [anon_sym_consteval] = ACTIONS(5012),
    [anon_sym_PROGMEM] = ACTIONS(5012),
    [aux_sym_primitive_type_token1] = ACTIONS(5012),
    [anon_sym_byte] = ACTIONS(5012),
    [anon_sym_word] = ACTIONS(5012),
    [anon_sym_enum] = ACTIONS(5012),
    [anon_sym_class] = ACTIONS(5012),
    [anon_sym_struct] = ACTIONS(5012),
    [anon_sym_union] = ACTIONS(5012),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5012),
    [anon_sym_decltype] = ACTIONS(5012),
    [anon_sym_virtual] = ACTIONS(5012),
    [anon_sym_alignas] = ACTIONS(5012),
    [anon_sym_explicit] = ACTIONS(5012),
    [anon_sym_typename] = ACTIONS(5012),
    [anon_sym_template] = ACTIONS(5012),
    [anon_sym_operator] = ACTIONS(5012),
    [anon_sym_friend] = ACTIONS(5012),
    [anon_sym_public] = ACTIONS(5012),
    [anon_sym_private] = ACTIONS(5012),
    [anon_sym_protected] = ACTIONS(5012),
    [anon_sym_using] = ACTIONS(5012),
    [anon_sym_static_assert] = ACTIONS(5012),
  },
  [2246] = {
    [sym_identifier] = ACTIONS(5008),
    [aux_sym_preproc_def_token1] = ACTIONS(5008),
    [aux_sym_preproc_if_token1] = ACTIONS(5008),
    [aux_sym_preproc_if_token2] = ACTIONS(5008),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5008),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5008),
    [sym_preproc_directive] = ACTIONS(5008),
    [anon_sym_LPAREN2] = ACTIONS(5010),
    [anon_sym_TILDE] = ACTIONS(5010),
    [anon_sym_STAR] = ACTIONS(5010),
    [anon_sym_AMP_AMP] = ACTIONS(5010),
    [anon_sym_AMP] = ACTIONS(5008),
    [anon_sym___extension__] = ACTIONS(5008),
    [anon_sym_typedef] = ACTIONS(5008),
    [anon_sym_extern] = ACTIONS(5008),
    [anon_sym___attribute__] = ACTIONS(5008),
    [anon_sym_COLON_COLON] = ACTIONS(5010),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5010),
    [anon_sym___declspec] = ACTIONS(5008),
    [anon_sym___based] = ACTIONS(5008),
    [anon_sym_signed] = ACTIONS(5008),
    [anon_sym_unsigned] = ACTIONS(5008),
    [anon_sym_long] = ACTIONS(5008),
    [anon_sym_short] = ACTIONS(5008),
    [anon_sym_LBRACK] = ACTIONS(5008),
    [anon_sym_static] = ACTIONS(5008),
    [anon_sym_register] = ACTIONS(5008),
    [anon_sym_inline] = ACTIONS(5008),
    [anon_sym___inline] = ACTIONS(5008),
    [anon_sym___inline__] = ACTIONS(5008),
    [anon_sym___forceinline] = ACTIONS(5008),
    [anon_sym_thread_local] = ACTIONS(5008),
    [anon_sym___thread] = ACTIONS(5008),
    [anon_sym_const] = ACTIONS(5008),
    [anon_sym_constexpr] = ACTIONS(5008),
    [anon_sym_volatile] = ACTIONS(5008),
    [anon_sym_restrict] = ACTIONS(5008),
    [anon_sym___restrict__] = ACTIONS(5008),
    [anon_sym__Atomic] = ACTIONS(5008),
    [anon_sym__Noreturn] = ACTIONS(5008),
    [anon_sym_noreturn] = ACTIONS(5008),
    [anon_sym_mutable] = ACTIONS(5008),
    [anon_sym_constinit] = ACTIONS(5008),
    [anon_sym_consteval] = ACTIONS(5008),
    [anon_sym_PROGMEM] = ACTIONS(5008),
    [aux_sym_primitive_type_token1] = ACTIONS(5008),
    [anon_sym_byte] = ACTIONS(5008),
    [anon_sym_word] = ACTIONS(5008),
    [anon_sym_enum] = ACTIONS(5008),
    [anon_sym_class] = ACTIONS(5008),
    [anon_sym_struct] = ACTIONS(5008),
    [anon_sym_union] = ACTIONS(5008),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5008),
    [anon_sym_decltype] = ACTIONS(5008),
    [anon_sym_virtual] = ACTIONS(5008),
    [anon_sym_alignas] = ACTIONS(5008),
    [anon_sym_explicit] = ACTIONS(5008),
    [anon_sym_typename] = ACTIONS(5008),
    [anon_sym_template] = ACTIONS(5008),
    [anon_sym_operator] = ACTIONS(5008),
    [anon_sym_friend] = ACTIONS(5008),
    [anon_sym_public] = ACTIONS(5008),
    [anon_sym_private] = ACTIONS(5008),
    [anon_sym_protected] = ACTIONS(5008),
    [anon_sym_using] = ACTIONS(5008),
    [anon_sym_static_assert] = ACTIONS(5008),
  },
  [2247] = {
    [sym_identifier] = ACTIONS(5020),
    [aux_sym_preproc_def_token1] = ACTIONS(5020),
    [aux_sym_preproc_if_token1] = ACTIONS(5020),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5020),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5020),
    [sym_preproc_directive] = ACTIONS(5020),
    [anon_sym_LPAREN2] = ACTIONS(5022),
    [anon_sym_TILDE] = ACTIONS(5022),
    [anon_sym_STAR] = ACTIONS(5022),
    [anon_sym_AMP_AMP] = ACTIONS(5022),
    [anon_sym_AMP] = ACTIONS(5020),
    [anon_sym___extension__] = ACTIONS(5020),
    [anon_sym_typedef] = ACTIONS(5020),
    [anon_sym_extern] = ACTIONS(5020),
    [anon_sym___attribute__] = ACTIONS(5020),
    [anon_sym_COLON_COLON] = ACTIONS(5022),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5022),
    [anon_sym___declspec] = ACTIONS(5020),
    [anon_sym___based] = ACTIONS(5020),
    [anon_sym_RBRACE] = ACTIONS(5022),
    [anon_sym_signed] = ACTIONS(5020),
    [anon_sym_unsigned] = ACTIONS(5020),
    [anon_sym_long] = ACTIONS(5020),
    [anon_sym_short] = ACTIONS(5020),
    [anon_sym_LBRACK] = ACTIONS(5020),
    [anon_sym_static] = ACTIONS(5020),
    [anon_sym_register] = ACTIONS(5020),
    [anon_sym_inline] = ACTIONS(5020),
    [anon_sym___inline] = ACTIONS(5020),
    [anon_sym___inline__] = ACTIONS(5020),
    [anon_sym___forceinline] = ACTIONS(5020),
    [anon_sym_thread_local] = ACTIONS(5020),
    [anon_sym___thread] = ACTIONS(5020),
    [anon_sym_const] = ACTIONS(5020),
    [anon_sym_constexpr] = ACTIONS(5020),
    [anon_sym_volatile] = ACTIONS(5020),
    [anon_sym_restrict] = ACTIONS(5020),
    [anon_sym___restrict__] = ACTIONS(5020),
    [anon_sym__Atomic] = ACTIONS(5020),
    [anon_sym__Noreturn] = ACTIONS(5020),
    [anon_sym_noreturn] = ACTIONS(5020),
    [anon_sym_mutable] = ACTIONS(5020),
    [anon_sym_constinit] = ACTIONS(5020),
    [anon_sym_consteval] = ACTIONS(5020),
    [anon_sym_PROGMEM] = ACTIONS(5020),
    [aux_sym_primitive_type_token1] = ACTIONS(5020),
    [anon_sym_byte] = ACTIONS(5020),
    [anon_sym_word] = ACTIONS(5020),
    [anon_sym_enum] = ACTIONS(5020),
    [anon_sym_class] = ACTIONS(5020),
    [anon_sym_struct] = ACTIONS(5020),
    [anon_sym_union] = ACTIONS(5020),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5020),
    [anon_sym_decltype] = ACTIONS(5020),
    [anon_sym_virtual] = ACTIONS(5020),
    [anon_sym_alignas] = ACTIONS(5020),
    [anon_sym_explicit] = ACTIONS(5020),
    [anon_sym_typename] = ACTIONS(5020),
    [anon_sym_template] = ACTIONS(5020),
    [anon_sym_operator] = ACTIONS(5020),
    [anon_sym_friend] = ACTIONS(5020),
    [anon_sym_public] = ACTIONS(5020),
    [anon_sym_private] = ACTIONS(5020),
    [anon_sym_protected] = ACTIONS(5020),
    [anon_sym_using] = ACTIONS(5020),
    [anon_sym_static_assert] = ACTIONS(5020),
  },
  [2248] = {
    [sym_string_literal] = STATE(2118),
    [sym_raw_string_literal] = STATE(2118),
    [aux_sym_concatenated_string_repeat1] = STATE(2118),
    [sym_identifier] = ACTIONS(5348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4783),
    [anon_sym_COMMA] = ACTIONS(4783),
    [anon_sym_RPAREN] = ACTIONS(4783),
    [anon_sym_LPAREN2] = ACTIONS(4783),
    [anon_sym_DASH] = ACTIONS(4785),
    [anon_sym_PLUS] = ACTIONS(4785),
    [anon_sym_STAR] = ACTIONS(4785),
    [anon_sym_SLASH] = ACTIONS(4785),
    [anon_sym_PERCENT] = ACTIONS(4785),
    [anon_sym_PIPE_PIPE] = ACTIONS(4783),
    [anon_sym_AMP_AMP] = ACTIONS(4783),
    [anon_sym_PIPE] = ACTIONS(4785),
    [anon_sym_CARET] = ACTIONS(4785),
    [anon_sym_AMP] = ACTIONS(4785),
    [anon_sym_EQ_EQ] = ACTIONS(4783),
    [anon_sym_BANG_EQ] = ACTIONS(4783),
    [anon_sym_GT] = ACTIONS(4785),
    [anon_sym_GT_EQ] = ACTIONS(4783),
    [anon_sym_LT_EQ] = ACTIONS(4785),
    [anon_sym_LT] = ACTIONS(4785),
    [anon_sym_LT_LT] = ACTIONS(4785),
    [anon_sym_GT_GT] = ACTIONS(4785),
    [anon_sym_LBRACK] = ACTIONS(4783),
    [anon_sym_EQ] = ACTIONS(4785),
    [anon_sym_QMARK] = ACTIONS(4783),
    [anon_sym_STAR_EQ] = ACTIONS(4783),
    [anon_sym_SLASH_EQ] = ACTIONS(4783),
    [anon_sym_PERCENT_EQ] = ACTIONS(4783),
    [anon_sym_PLUS_EQ] = ACTIONS(4783),
    [anon_sym_DASH_EQ] = ACTIONS(4783),
    [anon_sym_LT_LT_EQ] = ACTIONS(4783),
    [anon_sym_GT_GT_EQ] = ACTIONS(4783),
    [anon_sym_AMP_EQ] = ACTIONS(4783),
    [anon_sym_CARET_EQ] = ACTIONS(4783),
    [anon_sym_PIPE_EQ] = ACTIONS(4783),
    [anon_sym_and_eq] = ACTIONS(4785),
    [anon_sym_or_eq] = ACTIONS(4785),
    [anon_sym_xor_eq] = ACTIONS(4785),
    [anon_sym_LT_EQ_GT] = ACTIONS(4783),
    [anon_sym_or] = ACTIONS(4785),
    [anon_sym_and] = ACTIONS(4785),
    [anon_sym_bitor] = ACTIONS(4785),
    [anon_sym_xor] = ACTIONS(4785),
    [anon_sym_bitand] = ACTIONS(4785),
    [anon_sym_not_eq] = ACTIONS(4785),
    [anon_sym_DASH_DASH] = ACTIONS(4783),
    [anon_sym_PLUS_PLUS] = ACTIONS(4783),
    [anon_sym_DOT] = ACTIONS(4785),
    [anon_sym_DOT_STAR] = ACTIONS(4783),
    [anon_sym_DASH_GT] = ACTIONS(4785),
    [anon_sym_L_DQUOTE] = ACTIONS(4605),
    [anon_sym_u_DQUOTE] = ACTIONS(4605),
    [anon_sym_U_DQUOTE] = ACTIONS(4605),
    [anon_sym_u8_DQUOTE] = ACTIONS(4605),
    [anon_sym_DQUOTE] = ACTIONS(4605),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4607),
    [anon_sym_LR_DQUOTE] = ACTIONS(4607),
    [anon_sym_uR_DQUOTE] = ACTIONS(4607),
    [anon_sym_UR_DQUOTE] = ACTIONS(4607),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4607),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4783),
    [sym_literal_suffix] = ACTIONS(4785),
  },
  [2249] = {
    [sym_identifier] = ACTIONS(5020),
    [aux_sym_preproc_def_token1] = ACTIONS(5020),
    [aux_sym_preproc_if_token1] = ACTIONS(5020),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5020),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5020),
    [sym_preproc_directive] = ACTIONS(5020),
    [anon_sym_LPAREN2] = ACTIONS(5022),
    [anon_sym_TILDE] = ACTIONS(5022),
    [anon_sym_STAR] = ACTIONS(5022),
    [anon_sym_AMP_AMP] = ACTIONS(5022),
    [anon_sym_AMP] = ACTIONS(5020),
    [anon_sym___extension__] = ACTIONS(5020),
    [anon_sym_typedef] = ACTIONS(5020),
    [anon_sym_extern] = ACTIONS(5020),
    [anon_sym___attribute__] = ACTIONS(5020),
    [anon_sym_COLON_COLON] = ACTIONS(5022),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5022),
    [anon_sym___declspec] = ACTIONS(5020),
    [anon_sym___based] = ACTIONS(5020),
    [anon_sym_RBRACE] = ACTIONS(5022),
    [anon_sym_signed] = ACTIONS(5020),
    [anon_sym_unsigned] = ACTIONS(5020),
    [anon_sym_long] = ACTIONS(5020),
    [anon_sym_short] = ACTIONS(5020),
    [anon_sym_LBRACK] = ACTIONS(5020),
    [anon_sym_static] = ACTIONS(5020),
    [anon_sym_register] = ACTIONS(5020),
    [anon_sym_inline] = ACTIONS(5020),
    [anon_sym___inline] = ACTIONS(5020),
    [anon_sym___inline__] = ACTIONS(5020),
    [anon_sym___forceinline] = ACTIONS(5020),
    [anon_sym_thread_local] = ACTIONS(5020),
    [anon_sym___thread] = ACTIONS(5020),
    [anon_sym_const] = ACTIONS(5020),
    [anon_sym_constexpr] = ACTIONS(5020),
    [anon_sym_volatile] = ACTIONS(5020),
    [anon_sym_restrict] = ACTIONS(5020),
    [anon_sym___restrict__] = ACTIONS(5020),
    [anon_sym__Atomic] = ACTIONS(5020),
    [anon_sym__Noreturn] = ACTIONS(5020),
    [anon_sym_noreturn] = ACTIONS(5020),
    [anon_sym_mutable] = ACTIONS(5020),
    [anon_sym_constinit] = ACTIONS(5020),
    [anon_sym_consteval] = ACTIONS(5020),
    [anon_sym_PROGMEM] = ACTIONS(5020),
    [aux_sym_primitive_type_token1] = ACTIONS(5020),
    [anon_sym_byte] = ACTIONS(5020),
    [anon_sym_word] = ACTIONS(5020),
    [anon_sym_enum] = ACTIONS(5020),
    [anon_sym_class] = ACTIONS(5020),
    [anon_sym_struct] = ACTIONS(5020),
    [anon_sym_union] = ACTIONS(5020),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5020),
    [anon_sym_decltype] = ACTIONS(5020),
    [anon_sym_virtual] = ACTIONS(5020),
    [anon_sym_alignas] = ACTIONS(5020),
    [anon_sym_explicit] = ACTIONS(5020),
    [anon_sym_typename] = ACTIONS(5020),
    [anon_sym_template] = ACTIONS(5020),
    [anon_sym_operator] = ACTIONS(5020),
    [anon_sym_friend] = ACTIONS(5020),
    [anon_sym_public] = ACTIONS(5020),
    [anon_sym_private] = ACTIONS(5020),
    [anon_sym_protected] = ACTIONS(5020),
    [anon_sym_using] = ACTIONS(5020),
    [anon_sym_static_assert] = ACTIONS(5020),
  },
  [2250] = {
    [sym_identifier] = ACTIONS(2723),
    [aux_sym_preproc_def_token1] = ACTIONS(2723),
    [aux_sym_preproc_if_token1] = ACTIONS(2723),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2723),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2723),
    [sym_preproc_directive] = ACTIONS(2723),
    [anon_sym_LPAREN2] = ACTIONS(2725),
    [anon_sym_TILDE] = ACTIONS(2725),
    [anon_sym_STAR] = ACTIONS(2725),
    [anon_sym_AMP_AMP] = ACTIONS(2725),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym___extension__] = ACTIONS(2723),
    [anon_sym_typedef] = ACTIONS(2723),
    [anon_sym_extern] = ACTIONS(2723),
    [anon_sym___attribute__] = ACTIONS(2723),
    [anon_sym_COLON_COLON] = ACTIONS(2725),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2725),
    [anon_sym___declspec] = ACTIONS(2723),
    [anon_sym___based] = ACTIONS(2723),
    [anon_sym_RBRACE] = ACTIONS(2725),
    [anon_sym_signed] = ACTIONS(2723),
    [anon_sym_unsigned] = ACTIONS(2723),
    [anon_sym_long] = ACTIONS(2723),
    [anon_sym_short] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_static] = ACTIONS(2723),
    [anon_sym_register] = ACTIONS(2723),
    [anon_sym_inline] = ACTIONS(2723),
    [anon_sym___inline] = ACTIONS(2723),
    [anon_sym___inline__] = ACTIONS(2723),
    [anon_sym___forceinline] = ACTIONS(2723),
    [anon_sym_thread_local] = ACTIONS(2723),
    [anon_sym___thread] = ACTIONS(2723),
    [anon_sym_const] = ACTIONS(2723),
    [anon_sym_constexpr] = ACTIONS(2723),
    [anon_sym_volatile] = ACTIONS(2723),
    [anon_sym_restrict] = ACTIONS(2723),
    [anon_sym___restrict__] = ACTIONS(2723),
    [anon_sym__Atomic] = ACTIONS(2723),
    [anon_sym__Noreturn] = ACTIONS(2723),
    [anon_sym_noreturn] = ACTIONS(2723),
    [anon_sym_mutable] = ACTIONS(2723),
    [anon_sym_constinit] = ACTIONS(2723),
    [anon_sym_consteval] = ACTIONS(2723),
    [anon_sym_PROGMEM] = ACTIONS(2723),
    [aux_sym_primitive_type_token1] = ACTIONS(2723),
    [anon_sym_byte] = ACTIONS(2723),
    [anon_sym_word] = ACTIONS(2723),
    [anon_sym_enum] = ACTIONS(2723),
    [anon_sym_class] = ACTIONS(2723),
    [anon_sym_struct] = ACTIONS(2723),
    [anon_sym_union] = ACTIONS(2723),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2723),
    [anon_sym_decltype] = ACTIONS(2723),
    [anon_sym_virtual] = ACTIONS(2723),
    [anon_sym_alignas] = ACTIONS(2723),
    [anon_sym_explicit] = ACTIONS(2723),
    [anon_sym_typename] = ACTIONS(2723),
    [anon_sym_template] = ACTIONS(2723),
    [anon_sym_operator] = ACTIONS(2723),
    [anon_sym_friend] = ACTIONS(2723),
    [anon_sym_public] = ACTIONS(2723),
    [anon_sym_private] = ACTIONS(2723),
    [anon_sym_protected] = ACTIONS(2723),
    [anon_sym_using] = ACTIONS(2723),
    [anon_sym_static_assert] = ACTIONS(2723),
  },
  [2251] = {
    [sym_identifier] = ACTIONS(3164),
    [aux_sym_preproc_def_token1] = ACTIONS(3164),
    [aux_sym_preproc_if_token1] = ACTIONS(3164),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3164),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3164),
    [sym_preproc_directive] = ACTIONS(3164),
    [anon_sym_LPAREN2] = ACTIONS(3166),
    [anon_sym_TILDE] = ACTIONS(3166),
    [anon_sym_STAR] = ACTIONS(3166),
    [anon_sym_AMP_AMP] = ACTIONS(3166),
    [anon_sym_AMP] = ACTIONS(3164),
    [anon_sym___extension__] = ACTIONS(3164),
    [anon_sym_typedef] = ACTIONS(3164),
    [anon_sym_extern] = ACTIONS(3164),
    [anon_sym___attribute__] = ACTIONS(3164),
    [anon_sym_COLON_COLON] = ACTIONS(3166),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3166),
    [anon_sym___declspec] = ACTIONS(3164),
    [anon_sym___based] = ACTIONS(3164),
    [anon_sym_RBRACE] = ACTIONS(3166),
    [anon_sym_signed] = ACTIONS(3164),
    [anon_sym_unsigned] = ACTIONS(3164),
    [anon_sym_long] = ACTIONS(3164),
    [anon_sym_short] = ACTIONS(3164),
    [anon_sym_LBRACK] = ACTIONS(3164),
    [anon_sym_static] = ACTIONS(3164),
    [anon_sym_register] = ACTIONS(3164),
    [anon_sym_inline] = ACTIONS(3164),
    [anon_sym___inline] = ACTIONS(3164),
    [anon_sym___inline__] = ACTIONS(3164),
    [anon_sym___forceinline] = ACTIONS(3164),
    [anon_sym_thread_local] = ACTIONS(3164),
    [anon_sym___thread] = ACTIONS(3164),
    [anon_sym_const] = ACTIONS(3164),
    [anon_sym_constexpr] = ACTIONS(3164),
    [anon_sym_volatile] = ACTIONS(3164),
    [anon_sym_restrict] = ACTIONS(3164),
    [anon_sym___restrict__] = ACTIONS(3164),
    [anon_sym__Atomic] = ACTIONS(3164),
    [anon_sym__Noreturn] = ACTIONS(3164),
    [anon_sym_noreturn] = ACTIONS(3164),
    [anon_sym_mutable] = ACTIONS(3164),
    [anon_sym_constinit] = ACTIONS(3164),
    [anon_sym_consteval] = ACTIONS(3164),
    [anon_sym_PROGMEM] = ACTIONS(3164),
    [aux_sym_primitive_type_token1] = ACTIONS(3164),
    [anon_sym_byte] = ACTIONS(3164),
    [anon_sym_word] = ACTIONS(3164),
    [anon_sym_enum] = ACTIONS(3164),
    [anon_sym_class] = ACTIONS(3164),
    [anon_sym_struct] = ACTIONS(3164),
    [anon_sym_union] = ACTIONS(3164),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3164),
    [anon_sym_decltype] = ACTIONS(3164),
    [anon_sym_virtual] = ACTIONS(3164),
    [anon_sym_alignas] = ACTIONS(3164),
    [anon_sym_explicit] = ACTIONS(3164),
    [anon_sym_typename] = ACTIONS(3164),
    [anon_sym_template] = ACTIONS(3164),
    [anon_sym_operator] = ACTIONS(3164),
    [anon_sym_friend] = ACTIONS(3164),
    [anon_sym_public] = ACTIONS(3164),
    [anon_sym_private] = ACTIONS(3164),
    [anon_sym_protected] = ACTIONS(3164),
    [anon_sym_using] = ACTIONS(3164),
    [anon_sym_static_assert] = ACTIONS(3164),
  },
  [2252] = {
    [sym_attribute_specifier] = STATE(2384),
    [sym_enumerator_list] = STATE(2300),
    [sym_identifier] = ACTIONS(5350),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5352),
    [anon_sym_COMMA] = ACTIONS(5352),
    [anon_sym_RPAREN] = ACTIONS(5352),
    [aux_sym_preproc_if_token2] = ACTIONS(5352),
    [aux_sym_preproc_else_token1] = ACTIONS(5352),
    [aux_sym_preproc_elif_token1] = ACTIONS(5350),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5352),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5352),
    [anon_sym_LPAREN2] = ACTIONS(5352),
    [anon_sym_DASH] = ACTIONS(5350),
    [anon_sym_PLUS] = ACTIONS(5350),
    [anon_sym_STAR] = ACTIONS(5350),
    [anon_sym_SLASH] = ACTIONS(5350),
    [anon_sym_PERCENT] = ACTIONS(5350),
    [anon_sym_PIPE_PIPE] = ACTIONS(5352),
    [anon_sym_AMP_AMP] = ACTIONS(5352),
    [anon_sym_PIPE] = ACTIONS(5350),
    [anon_sym_CARET] = ACTIONS(5350),
    [anon_sym_AMP] = ACTIONS(5350),
    [anon_sym_EQ_EQ] = ACTIONS(5352),
    [anon_sym_BANG_EQ] = ACTIONS(5352),
    [anon_sym_GT] = ACTIONS(5350),
    [anon_sym_GT_EQ] = ACTIONS(5352),
    [anon_sym_LT_EQ] = ACTIONS(5350),
    [anon_sym_LT] = ACTIONS(5350),
    [anon_sym_LT_LT] = ACTIONS(5350),
    [anon_sym_GT_GT] = ACTIONS(5350),
    [anon_sym_SEMI] = ACTIONS(5352),
    [anon_sym___attribute__] = ACTIONS(4906),
    [anon_sym_LBRACE] = ACTIONS(5297),
    [anon_sym_RBRACE] = ACTIONS(5352),
    [anon_sym_LBRACK] = ACTIONS(5352),
    [anon_sym_RBRACK] = ACTIONS(5352),
    [anon_sym_EQ] = ACTIONS(5350),
    [anon_sym_COLON] = ACTIONS(5352),
    [anon_sym_QMARK] = ACTIONS(5352),
    [anon_sym_STAR_EQ] = ACTIONS(5352),
    [anon_sym_SLASH_EQ] = ACTIONS(5352),
    [anon_sym_PERCENT_EQ] = ACTIONS(5352),
    [anon_sym_PLUS_EQ] = ACTIONS(5352),
    [anon_sym_DASH_EQ] = ACTIONS(5352),
    [anon_sym_LT_LT_EQ] = ACTIONS(5352),
    [anon_sym_GT_GT_EQ] = ACTIONS(5352),
    [anon_sym_AMP_EQ] = ACTIONS(5352),
    [anon_sym_CARET_EQ] = ACTIONS(5352),
    [anon_sym_PIPE_EQ] = ACTIONS(5352),
    [anon_sym_and_eq] = ACTIONS(5350),
    [anon_sym_or_eq] = ACTIONS(5350),
    [anon_sym_xor_eq] = ACTIONS(5350),
    [anon_sym_LT_EQ_GT] = ACTIONS(5352),
    [anon_sym_or] = ACTIONS(5350),
    [anon_sym_and] = ACTIONS(5350),
    [anon_sym_bitor] = ACTIONS(5350),
    [anon_sym_xor] = ACTIONS(5350),
    [anon_sym_bitand] = ACTIONS(5350),
    [anon_sym_not_eq] = ACTIONS(5350),
    [anon_sym_DASH_DASH] = ACTIONS(5352),
    [anon_sym_PLUS_PLUS] = ACTIONS(5352),
    [anon_sym_DOT] = ACTIONS(5350),
    [anon_sym_DOT_STAR] = ACTIONS(5352),
    [anon_sym_DASH_GT] = ACTIONS(5352),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5350),
    [anon_sym_decltype] = ACTIONS(5350),
  },
  [2253] = {
    [sym_identifier] = ACTIONS(3024),
    [aux_sym_preproc_def_token1] = ACTIONS(3024),
    [aux_sym_preproc_if_token1] = ACTIONS(3024),
    [aux_sym_preproc_if_token2] = ACTIONS(3024),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3024),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3024),
    [sym_preproc_directive] = ACTIONS(3024),
    [anon_sym_LPAREN2] = ACTIONS(3026),
    [anon_sym_TILDE] = ACTIONS(3026),
    [anon_sym_STAR] = ACTIONS(3026),
    [anon_sym_AMP_AMP] = ACTIONS(3026),
    [anon_sym_AMP] = ACTIONS(3024),
    [anon_sym___extension__] = ACTIONS(3024),
    [anon_sym_typedef] = ACTIONS(3024),
    [anon_sym_extern] = ACTIONS(3024),
    [anon_sym___attribute__] = ACTIONS(3024),
    [anon_sym_COLON_COLON] = ACTIONS(3026),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3026),
    [anon_sym___declspec] = ACTIONS(3024),
    [anon_sym___based] = ACTIONS(3024),
    [anon_sym_signed] = ACTIONS(3024),
    [anon_sym_unsigned] = ACTIONS(3024),
    [anon_sym_long] = ACTIONS(3024),
    [anon_sym_short] = ACTIONS(3024),
    [anon_sym_LBRACK] = ACTIONS(3024),
    [anon_sym_static] = ACTIONS(3024),
    [anon_sym_register] = ACTIONS(3024),
    [anon_sym_inline] = ACTIONS(3024),
    [anon_sym___inline] = ACTIONS(3024),
    [anon_sym___inline__] = ACTIONS(3024),
    [anon_sym___forceinline] = ACTIONS(3024),
    [anon_sym_thread_local] = ACTIONS(3024),
    [anon_sym___thread] = ACTIONS(3024),
    [anon_sym_const] = ACTIONS(3024),
    [anon_sym_constexpr] = ACTIONS(3024),
    [anon_sym_volatile] = ACTIONS(3024),
    [anon_sym_restrict] = ACTIONS(3024),
    [anon_sym___restrict__] = ACTIONS(3024),
    [anon_sym__Atomic] = ACTIONS(3024),
    [anon_sym__Noreturn] = ACTIONS(3024),
    [anon_sym_noreturn] = ACTIONS(3024),
    [anon_sym_mutable] = ACTIONS(3024),
    [anon_sym_constinit] = ACTIONS(3024),
    [anon_sym_consteval] = ACTIONS(3024),
    [anon_sym_PROGMEM] = ACTIONS(3024),
    [aux_sym_primitive_type_token1] = ACTIONS(3024),
    [anon_sym_byte] = ACTIONS(3024),
    [anon_sym_word] = ACTIONS(3024),
    [anon_sym_enum] = ACTIONS(3024),
    [anon_sym_class] = ACTIONS(3024),
    [anon_sym_struct] = ACTIONS(3024),
    [anon_sym_union] = ACTIONS(3024),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3024),
    [anon_sym_decltype] = ACTIONS(3024),
    [anon_sym_virtual] = ACTIONS(3024),
    [anon_sym_alignas] = ACTIONS(3024),
    [anon_sym_explicit] = ACTIONS(3024),
    [anon_sym_typename] = ACTIONS(3024),
    [anon_sym_template] = ACTIONS(3024),
    [anon_sym_operator] = ACTIONS(3024),
    [anon_sym_friend] = ACTIONS(3024),
    [anon_sym_public] = ACTIONS(3024),
    [anon_sym_private] = ACTIONS(3024),
    [anon_sym_protected] = ACTIONS(3024),
    [anon_sym_using] = ACTIONS(3024),
    [anon_sym_static_assert] = ACTIONS(3024),
  },
  [2254] = {
    [sym_identifier] = ACTIONS(5012),
    [aux_sym_preproc_def_token1] = ACTIONS(5012),
    [aux_sym_preproc_if_token1] = ACTIONS(5012),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5012),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5012),
    [sym_preproc_directive] = ACTIONS(5012),
    [anon_sym_LPAREN2] = ACTIONS(5014),
    [anon_sym_TILDE] = ACTIONS(5014),
    [anon_sym_STAR] = ACTIONS(5014),
    [anon_sym_AMP_AMP] = ACTIONS(5014),
    [anon_sym_AMP] = ACTIONS(5012),
    [anon_sym___extension__] = ACTIONS(5012),
    [anon_sym_typedef] = ACTIONS(5012),
    [anon_sym_extern] = ACTIONS(5012),
    [anon_sym___attribute__] = ACTIONS(5012),
    [anon_sym_COLON_COLON] = ACTIONS(5014),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5014),
    [anon_sym___declspec] = ACTIONS(5012),
    [anon_sym___based] = ACTIONS(5012),
    [anon_sym_RBRACE] = ACTIONS(5014),
    [anon_sym_signed] = ACTIONS(5012),
    [anon_sym_unsigned] = ACTIONS(5012),
    [anon_sym_long] = ACTIONS(5012),
    [anon_sym_short] = ACTIONS(5012),
    [anon_sym_LBRACK] = ACTIONS(5012),
    [anon_sym_static] = ACTIONS(5012),
    [anon_sym_register] = ACTIONS(5012),
    [anon_sym_inline] = ACTIONS(5012),
    [anon_sym___inline] = ACTIONS(5012),
    [anon_sym___inline__] = ACTIONS(5012),
    [anon_sym___forceinline] = ACTIONS(5012),
    [anon_sym_thread_local] = ACTIONS(5012),
    [anon_sym___thread] = ACTIONS(5012),
    [anon_sym_const] = ACTIONS(5012),
    [anon_sym_constexpr] = ACTIONS(5012),
    [anon_sym_volatile] = ACTIONS(5012),
    [anon_sym_restrict] = ACTIONS(5012),
    [anon_sym___restrict__] = ACTIONS(5012),
    [anon_sym__Atomic] = ACTIONS(5012),
    [anon_sym__Noreturn] = ACTIONS(5012),
    [anon_sym_noreturn] = ACTIONS(5012),
    [anon_sym_mutable] = ACTIONS(5012),
    [anon_sym_constinit] = ACTIONS(5012),
    [anon_sym_consteval] = ACTIONS(5012),
    [anon_sym_PROGMEM] = ACTIONS(5012),
    [aux_sym_primitive_type_token1] = ACTIONS(5012),
    [anon_sym_byte] = ACTIONS(5012),
    [anon_sym_word] = ACTIONS(5012),
    [anon_sym_enum] = ACTIONS(5012),
    [anon_sym_class] = ACTIONS(5012),
    [anon_sym_struct] = ACTIONS(5012),
    [anon_sym_union] = ACTIONS(5012),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5012),
    [anon_sym_decltype] = ACTIONS(5012),
    [anon_sym_virtual] = ACTIONS(5012),
    [anon_sym_alignas] = ACTIONS(5012),
    [anon_sym_explicit] = ACTIONS(5012),
    [anon_sym_typename] = ACTIONS(5012),
    [anon_sym_template] = ACTIONS(5012),
    [anon_sym_operator] = ACTIONS(5012),
    [anon_sym_friend] = ACTIONS(5012),
    [anon_sym_public] = ACTIONS(5012),
    [anon_sym_private] = ACTIONS(5012),
    [anon_sym_protected] = ACTIONS(5012),
    [anon_sym_using] = ACTIONS(5012),
    [anon_sym_static_assert] = ACTIONS(5012),
  },
  [2255] = {
    [sym_identifier] = ACTIONS(3028),
    [aux_sym_preproc_def_token1] = ACTIONS(3028),
    [aux_sym_preproc_if_token1] = ACTIONS(3028),
    [aux_sym_preproc_if_token2] = ACTIONS(3028),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3028),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3028),
    [sym_preproc_directive] = ACTIONS(3028),
    [anon_sym_LPAREN2] = ACTIONS(3030),
    [anon_sym_TILDE] = ACTIONS(3030),
    [anon_sym_STAR] = ACTIONS(3030),
    [anon_sym_AMP_AMP] = ACTIONS(3030),
    [anon_sym_AMP] = ACTIONS(3028),
    [anon_sym___extension__] = ACTIONS(3028),
    [anon_sym_typedef] = ACTIONS(3028),
    [anon_sym_extern] = ACTIONS(3028),
    [anon_sym___attribute__] = ACTIONS(3028),
    [anon_sym_COLON_COLON] = ACTIONS(3030),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3030),
    [anon_sym___declspec] = ACTIONS(3028),
    [anon_sym___based] = ACTIONS(3028),
    [anon_sym_signed] = ACTIONS(3028),
    [anon_sym_unsigned] = ACTIONS(3028),
    [anon_sym_long] = ACTIONS(3028),
    [anon_sym_short] = ACTIONS(3028),
    [anon_sym_LBRACK] = ACTIONS(3028),
    [anon_sym_static] = ACTIONS(3028),
    [anon_sym_register] = ACTIONS(3028),
    [anon_sym_inline] = ACTIONS(3028),
    [anon_sym___inline] = ACTIONS(3028),
    [anon_sym___inline__] = ACTIONS(3028),
    [anon_sym___forceinline] = ACTIONS(3028),
    [anon_sym_thread_local] = ACTIONS(3028),
    [anon_sym___thread] = ACTIONS(3028),
    [anon_sym_const] = ACTIONS(3028),
    [anon_sym_constexpr] = ACTIONS(3028),
    [anon_sym_volatile] = ACTIONS(3028),
    [anon_sym_restrict] = ACTIONS(3028),
    [anon_sym___restrict__] = ACTIONS(3028),
    [anon_sym__Atomic] = ACTIONS(3028),
    [anon_sym__Noreturn] = ACTIONS(3028),
    [anon_sym_noreturn] = ACTIONS(3028),
    [anon_sym_mutable] = ACTIONS(3028),
    [anon_sym_constinit] = ACTIONS(3028),
    [anon_sym_consteval] = ACTIONS(3028),
    [anon_sym_PROGMEM] = ACTIONS(3028),
    [aux_sym_primitive_type_token1] = ACTIONS(3028),
    [anon_sym_byte] = ACTIONS(3028),
    [anon_sym_word] = ACTIONS(3028),
    [anon_sym_enum] = ACTIONS(3028),
    [anon_sym_class] = ACTIONS(3028),
    [anon_sym_struct] = ACTIONS(3028),
    [anon_sym_union] = ACTIONS(3028),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3028),
    [anon_sym_decltype] = ACTIONS(3028),
    [anon_sym_virtual] = ACTIONS(3028),
    [anon_sym_alignas] = ACTIONS(3028),
    [anon_sym_explicit] = ACTIONS(3028),
    [anon_sym_typename] = ACTIONS(3028),
    [anon_sym_template] = ACTIONS(3028),
    [anon_sym_operator] = ACTIONS(3028),
    [anon_sym_friend] = ACTIONS(3028),
    [anon_sym_public] = ACTIONS(3028),
    [anon_sym_private] = ACTIONS(3028),
    [anon_sym_protected] = ACTIONS(3028),
    [anon_sym_using] = ACTIONS(3028),
    [anon_sym_static_assert] = ACTIONS(3028),
  },
  [2256] = {
    [sym_identifier] = ACTIONS(5024),
    [aux_sym_preproc_def_token1] = ACTIONS(5024),
    [aux_sym_preproc_if_token1] = ACTIONS(5024),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5024),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5024),
    [sym_preproc_directive] = ACTIONS(5024),
    [anon_sym_LPAREN2] = ACTIONS(5026),
    [anon_sym_TILDE] = ACTIONS(5026),
    [anon_sym_STAR] = ACTIONS(5026),
    [anon_sym_AMP_AMP] = ACTIONS(5026),
    [anon_sym_AMP] = ACTIONS(5024),
    [anon_sym___extension__] = ACTIONS(5024),
    [anon_sym_typedef] = ACTIONS(5024),
    [anon_sym_extern] = ACTIONS(5024),
    [anon_sym___attribute__] = ACTIONS(5024),
    [anon_sym_COLON_COLON] = ACTIONS(5026),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5026),
    [anon_sym___declspec] = ACTIONS(5024),
    [anon_sym___based] = ACTIONS(5024),
    [anon_sym_RBRACE] = ACTIONS(5026),
    [anon_sym_signed] = ACTIONS(5024),
    [anon_sym_unsigned] = ACTIONS(5024),
    [anon_sym_long] = ACTIONS(5024),
    [anon_sym_short] = ACTIONS(5024),
    [anon_sym_LBRACK] = ACTIONS(5024),
    [anon_sym_static] = ACTIONS(5024),
    [anon_sym_register] = ACTIONS(5024),
    [anon_sym_inline] = ACTIONS(5024),
    [anon_sym___inline] = ACTIONS(5024),
    [anon_sym___inline__] = ACTIONS(5024),
    [anon_sym___forceinline] = ACTIONS(5024),
    [anon_sym_thread_local] = ACTIONS(5024),
    [anon_sym___thread] = ACTIONS(5024),
    [anon_sym_const] = ACTIONS(5024),
    [anon_sym_constexpr] = ACTIONS(5024),
    [anon_sym_volatile] = ACTIONS(5024),
    [anon_sym_restrict] = ACTIONS(5024),
    [anon_sym___restrict__] = ACTIONS(5024),
    [anon_sym__Atomic] = ACTIONS(5024),
    [anon_sym__Noreturn] = ACTIONS(5024),
    [anon_sym_noreturn] = ACTIONS(5024),
    [anon_sym_mutable] = ACTIONS(5024),
    [anon_sym_constinit] = ACTIONS(5024),
    [anon_sym_consteval] = ACTIONS(5024),
    [anon_sym_PROGMEM] = ACTIONS(5024),
    [aux_sym_primitive_type_token1] = ACTIONS(5024),
    [anon_sym_byte] = ACTIONS(5024),
    [anon_sym_word] = ACTIONS(5024),
    [anon_sym_enum] = ACTIONS(5024),
    [anon_sym_class] = ACTIONS(5024),
    [anon_sym_struct] = ACTIONS(5024),
    [anon_sym_union] = ACTIONS(5024),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5024),
    [anon_sym_decltype] = ACTIONS(5024),
    [anon_sym_virtual] = ACTIONS(5024),
    [anon_sym_alignas] = ACTIONS(5024),
    [anon_sym_explicit] = ACTIONS(5024),
    [anon_sym_typename] = ACTIONS(5024),
    [anon_sym_template] = ACTIONS(5024),
    [anon_sym_operator] = ACTIONS(5024),
    [anon_sym_friend] = ACTIONS(5024),
    [anon_sym_public] = ACTIONS(5024),
    [anon_sym_private] = ACTIONS(5024),
    [anon_sym_protected] = ACTIONS(5024),
    [anon_sym_using] = ACTIONS(5024),
    [anon_sym_static_assert] = ACTIONS(5024),
  },
  [2257] = {
    [sym_identifier] = ACTIONS(4918),
    [anon_sym_LPAREN2] = ACTIONS(4920),
    [anon_sym_TILDE] = ACTIONS(4920),
    [anon_sym_STAR] = ACTIONS(4920),
    [anon_sym_PIPE_PIPE] = ACTIONS(4920),
    [anon_sym_AMP_AMP] = ACTIONS(4920),
    [anon_sym_AMP] = ACTIONS(4918),
    [anon_sym___extension__] = ACTIONS(4918),
    [anon_sym_extern] = ACTIONS(4918),
    [anon_sym___attribute__] = ACTIONS(4918),
    [anon_sym_COLON_COLON] = ACTIONS(4922),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4920),
    [anon_sym___declspec] = ACTIONS(4918),
    [anon_sym___based] = ACTIONS(4918),
    [anon_sym___cdecl] = ACTIONS(4918),
    [anon_sym___clrcall] = ACTIONS(4918),
    [anon_sym___stdcall] = ACTIONS(4918),
    [anon_sym___fastcall] = ACTIONS(4918),
    [anon_sym___thiscall] = ACTIONS(4918),
    [anon_sym___vectorcall] = ACTIONS(4918),
    [anon_sym_signed] = ACTIONS(4918),
    [anon_sym_unsigned] = ACTIONS(4918),
    [anon_sym_long] = ACTIONS(4918),
    [anon_sym_short] = ACTIONS(4918),
    [anon_sym_LBRACK] = ACTIONS(4918),
    [anon_sym_static] = ACTIONS(4918),
    [anon_sym_register] = ACTIONS(4918),
    [anon_sym_inline] = ACTIONS(4918),
    [anon_sym___inline] = ACTIONS(4918),
    [anon_sym___inline__] = ACTIONS(4918),
    [anon_sym___forceinline] = ACTIONS(4918),
    [anon_sym_thread_local] = ACTIONS(4918),
    [anon_sym___thread] = ACTIONS(4918),
    [anon_sym_const] = ACTIONS(4918),
    [anon_sym_constexpr] = ACTIONS(4918),
    [anon_sym_volatile] = ACTIONS(4918),
    [anon_sym_restrict] = ACTIONS(4918),
    [anon_sym___restrict__] = ACTIONS(4918),
    [anon_sym__Atomic] = ACTIONS(4918),
    [anon_sym__Noreturn] = ACTIONS(4918),
    [anon_sym_noreturn] = ACTIONS(4918),
    [anon_sym_mutable] = ACTIONS(4918),
    [anon_sym_constinit] = ACTIONS(4918),
    [anon_sym_consteval] = ACTIONS(4918),
    [anon_sym_PROGMEM] = ACTIONS(4918),
    [aux_sym_primitive_type_token1] = ACTIONS(4918),
    [anon_sym_byte] = ACTIONS(4918),
    [anon_sym_word] = ACTIONS(4918),
    [anon_sym_enum] = ACTIONS(4918),
    [anon_sym_class] = ACTIONS(4918),
    [anon_sym_struct] = ACTIONS(4918),
    [anon_sym_union] = ACTIONS(4918),
    [anon_sym_or] = ACTIONS(4918),
    [anon_sym_and] = ACTIONS(4918),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4918),
    [anon_sym_decltype] = ACTIONS(4918),
    [anon_sym_virtual] = ACTIONS(4918),
    [anon_sym_alignas] = ACTIONS(4918),
    [anon_sym_explicit] = ACTIONS(4918),
    [anon_sym_typename] = ACTIONS(4918),
    [anon_sym_template] = ACTIONS(4918),
    [anon_sym_operator] = ACTIONS(4918),
    [anon_sym_friend] = ACTIONS(4918),
    [anon_sym_using] = ACTIONS(4918),
    [anon_sym_concept] = ACTIONS(4918),
  },
  [2258] = {
    [sym_string_literal] = STATE(2258),
    [sym_raw_string_literal] = STATE(2258),
    [aux_sym_concatenated_string_repeat1] = STATE(2258),
    [sym_identifier] = ACTIONS(5354),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4790),
    [anon_sym_COMMA] = ACTIONS(4790),
    [anon_sym_LPAREN2] = ACTIONS(4790),
    [anon_sym_DASH] = ACTIONS(4792),
    [anon_sym_PLUS] = ACTIONS(4792),
    [anon_sym_STAR] = ACTIONS(4792),
    [anon_sym_SLASH] = ACTIONS(4792),
    [anon_sym_PERCENT] = ACTIONS(4792),
    [anon_sym_PIPE_PIPE] = ACTIONS(4790),
    [anon_sym_AMP_AMP] = ACTIONS(4790),
    [anon_sym_PIPE] = ACTIONS(4792),
    [anon_sym_CARET] = ACTIONS(4792),
    [anon_sym_AMP] = ACTIONS(4792),
    [anon_sym_EQ_EQ] = ACTIONS(4790),
    [anon_sym_BANG_EQ] = ACTIONS(4790),
    [anon_sym_GT] = ACTIONS(4792),
    [anon_sym_GT_EQ] = ACTIONS(4792),
    [anon_sym_LT_EQ] = ACTIONS(4792),
    [anon_sym_LT] = ACTIONS(4792),
    [anon_sym_LT_LT] = ACTIONS(4792),
    [anon_sym_GT_GT] = ACTIONS(4792),
    [anon_sym_LBRACK] = ACTIONS(4790),
    [anon_sym_EQ] = ACTIONS(4792),
    [anon_sym_QMARK] = ACTIONS(4790),
    [anon_sym_STAR_EQ] = ACTIONS(4790),
    [anon_sym_SLASH_EQ] = ACTIONS(4790),
    [anon_sym_PERCENT_EQ] = ACTIONS(4790),
    [anon_sym_PLUS_EQ] = ACTIONS(4790),
    [anon_sym_DASH_EQ] = ACTIONS(4790),
    [anon_sym_LT_LT_EQ] = ACTIONS(4790),
    [anon_sym_GT_GT_EQ] = ACTIONS(4792),
    [anon_sym_AMP_EQ] = ACTIONS(4790),
    [anon_sym_CARET_EQ] = ACTIONS(4790),
    [anon_sym_PIPE_EQ] = ACTIONS(4790),
    [anon_sym_and_eq] = ACTIONS(4792),
    [anon_sym_or_eq] = ACTIONS(4792),
    [anon_sym_xor_eq] = ACTIONS(4792),
    [anon_sym_LT_EQ_GT] = ACTIONS(4790),
    [anon_sym_or] = ACTIONS(4792),
    [anon_sym_and] = ACTIONS(4792),
    [anon_sym_bitor] = ACTIONS(4792),
    [anon_sym_xor] = ACTIONS(4792),
    [anon_sym_bitand] = ACTIONS(4792),
    [anon_sym_not_eq] = ACTIONS(4792),
    [anon_sym_DASH_DASH] = ACTIONS(4790),
    [anon_sym_PLUS_PLUS] = ACTIONS(4790),
    [anon_sym_DOT] = ACTIONS(4792),
    [anon_sym_DOT_STAR] = ACTIONS(4790),
    [anon_sym_DASH_GT] = ACTIONS(4790),
    [anon_sym_L_DQUOTE] = ACTIONS(5357),
    [anon_sym_u_DQUOTE] = ACTIONS(5357),
    [anon_sym_U_DQUOTE] = ACTIONS(5357),
    [anon_sym_u8_DQUOTE] = ACTIONS(5357),
    [anon_sym_DQUOTE] = ACTIONS(5357),
    [sym_comment] = ACTIONS(3),
    [anon_sym_GT2] = ACTIONS(4790),
    [anon_sym_R_DQUOTE] = ACTIONS(5360),
    [anon_sym_LR_DQUOTE] = ACTIONS(5360),
    [anon_sym_uR_DQUOTE] = ACTIONS(5360),
    [anon_sym_UR_DQUOTE] = ACTIONS(5360),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5360),
    [sym_literal_suffix] = ACTIONS(4792),
  },
  [2259] = {
    [sym_identifier] = ACTIONS(4918),
    [anon_sym_LPAREN2] = ACTIONS(4920),
    [anon_sym_TILDE] = ACTIONS(4920),
    [anon_sym_STAR] = ACTIONS(4920),
    [anon_sym_PIPE_PIPE] = ACTIONS(4920),
    [anon_sym_AMP_AMP] = ACTIONS(4920),
    [anon_sym_AMP] = ACTIONS(4918),
    [anon_sym___extension__] = ACTIONS(4918),
    [anon_sym_extern] = ACTIONS(4918),
    [anon_sym___attribute__] = ACTIONS(4918),
    [anon_sym_COLON_COLON] = ACTIONS(4920),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4920),
    [anon_sym___declspec] = ACTIONS(4918),
    [anon_sym___based] = ACTIONS(4918),
    [anon_sym___cdecl] = ACTIONS(4918),
    [anon_sym___clrcall] = ACTIONS(4918),
    [anon_sym___stdcall] = ACTIONS(4918),
    [anon_sym___fastcall] = ACTIONS(4918),
    [anon_sym___thiscall] = ACTIONS(4918),
    [anon_sym___vectorcall] = ACTIONS(4918),
    [anon_sym_signed] = ACTIONS(4918),
    [anon_sym_unsigned] = ACTIONS(4918),
    [anon_sym_long] = ACTIONS(4918),
    [anon_sym_short] = ACTIONS(4918),
    [anon_sym_LBRACK] = ACTIONS(4918),
    [anon_sym_static] = ACTIONS(4918),
    [anon_sym_register] = ACTIONS(4918),
    [anon_sym_inline] = ACTIONS(4918),
    [anon_sym___inline] = ACTIONS(4918),
    [anon_sym___inline__] = ACTIONS(4918),
    [anon_sym___forceinline] = ACTIONS(4918),
    [anon_sym_thread_local] = ACTIONS(4918),
    [anon_sym___thread] = ACTIONS(4918),
    [anon_sym_const] = ACTIONS(4918),
    [anon_sym_constexpr] = ACTIONS(4918),
    [anon_sym_volatile] = ACTIONS(4918),
    [anon_sym_restrict] = ACTIONS(4918),
    [anon_sym___restrict__] = ACTIONS(4918),
    [anon_sym__Atomic] = ACTIONS(4918),
    [anon_sym__Noreturn] = ACTIONS(4918),
    [anon_sym_noreturn] = ACTIONS(4918),
    [anon_sym_mutable] = ACTIONS(4918),
    [anon_sym_constinit] = ACTIONS(4918),
    [anon_sym_consteval] = ACTIONS(4918),
    [anon_sym_PROGMEM] = ACTIONS(4918),
    [aux_sym_primitive_type_token1] = ACTIONS(4918),
    [anon_sym_byte] = ACTIONS(4918),
    [anon_sym_word] = ACTIONS(4918),
    [anon_sym_enum] = ACTIONS(4918),
    [anon_sym_class] = ACTIONS(4918),
    [anon_sym_struct] = ACTIONS(4918),
    [anon_sym_union] = ACTIONS(4918),
    [anon_sym_or] = ACTIONS(4918),
    [anon_sym_and] = ACTIONS(4918),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4918),
    [anon_sym_decltype] = ACTIONS(4918),
    [anon_sym_virtual] = ACTIONS(4918),
    [anon_sym_alignas] = ACTIONS(4918),
    [anon_sym_explicit] = ACTIONS(4918),
    [anon_sym_typename] = ACTIONS(4918),
    [anon_sym_template] = ACTIONS(4918),
    [anon_sym_operator] = ACTIONS(4918),
    [anon_sym_friend] = ACTIONS(4918),
    [anon_sym_using] = ACTIONS(4918),
    [anon_sym_concept] = ACTIONS(4918),
  },
  [2260] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4818),
    [anon_sym_COMMA] = ACTIONS(4818),
    [anon_sym_RPAREN] = ACTIONS(4818),
    [anon_sym_LPAREN2] = ACTIONS(4818),
    [anon_sym_DASH] = ACTIONS(4816),
    [anon_sym_PLUS] = ACTIONS(4816),
    [anon_sym_STAR] = ACTIONS(4816),
    [anon_sym_SLASH] = ACTIONS(4816),
    [anon_sym_PERCENT] = ACTIONS(4816),
    [anon_sym_PIPE_PIPE] = ACTIONS(4818),
    [anon_sym_AMP_AMP] = ACTIONS(4818),
    [anon_sym_PIPE] = ACTIONS(4816),
    [anon_sym_CARET] = ACTIONS(4816),
    [anon_sym_AMP] = ACTIONS(4816),
    [anon_sym_EQ_EQ] = ACTIONS(4818),
    [anon_sym_BANG_EQ] = ACTIONS(4818),
    [anon_sym_GT] = ACTIONS(4816),
    [anon_sym_GT_EQ] = ACTIONS(4818),
    [anon_sym_LT_EQ] = ACTIONS(4816),
    [anon_sym_LT] = ACTIONS(4816),
    [anon_sym_LT_LT] = ACTIONS(4816),
    [anon_sym_GT_GT] = ACTIONS(4816),
    [anon_sym_SEMI] = ACTIONS(4818),
    [anon_sym_RBRACE] = ACTIONS(4818),
    [anon_sym_LBRACK] = ACTIONS(4818),
    [anon_sym_RBRACK] = ACTIONS(4818),
    [anon_sym_EQ] = ACTIONS(4816),
    [anon_sym_COLON] = ACTIONS(4818),
    [anon_sym_QMARK] = ACTIONS(4818),
    [anon_sym_STAR_EQ] = ACTIONS(4818),
    [anon_sym_SLASH_EQ] = ACTIONS(4818),
    [anon_sym_PERCENT_EQ] = ACTIONS(4818),
    [anon_sym_PLUS_EQ] = ACTIONS(4818),
    [anon_sym_DASH_EQ] = ACTIONS(4818),
    [anon_sym_LT_LT_EQ] = ACTIONS(4818),
    [anon_sym_GT_GT_EQ] = ACTIONS(4818),
    [anon_sym_AMP_EQ] = ACTIONS(4818),
    [anon_sym_CARET_EQ] = ACTIONS(4818),
    [anon_sym_PIPE_EQ] = ACTIONS(4818),
    [anon_sym_and_eq] = ACTIONS(4816),
    [anon_sym_or_eq] = ACTIONS(4816),
    [anon_sym_xor_eq] = ACTIONS(4816),
    [anon_sym_LT_EQ_GT] = ACTIONS(4818),
    [anon_sym_or] = ACTIONS(4816),
    [anon_sym_and] = ACTIONS(4816),
    [anon_sym_bitor] = ACTIONS(4816),
    [anon_sym_xor] = ACTIONS(4816),
    [anon_sym_bitand] = ACTIONS(4816),
    [anon_sym_not_eq] = ACTIONS(4816),
    [anon_sym_DASH_DASH] = ACTIONS(4818),
    [anon_sym_PLUS_PLUS] = ACTIONS(4818),
    [anon_sym_DOT] = ACTIONS(4816),
    [anon_sym_DOT_STAR] = ACTIONS(4818),
    [anon_sym_DASH_GT] = ACTIONS(4818),
    [anon_sym_L_DQUOTE] = ACTIONS(4818),
    [anon_sym_u_DQUOTE] = ACTIONS(4818),
    [anon_sym_U_DQUOTE] = ACTIONS(4818),
    [anon_sym_u8_DQUOTE] = ACTIONS(4818),
    [anon_sym_DQUOTE] = ACTIONS(4818),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4818),
    [anon_sym_LR_DQUOTE] = ACTIONS(4818),
    [anon_sym_uR_DQUOTE] = ACTIONS(4818),
    [anon_sym_UR_DQUOTE] = ACTIONS(4818),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4818),
    [sym_literal_suffix] = ACTIONS(4816),
  },
  [2261] = {
    [sym_attribute_specifier] = STATE(2383),
    [sym_identifier] = ACTIONS(5363),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5365),
    [anon_sym_COMMA] = ACTIONS(5365),
    [anon_sym_RPAREN] = ACTIONS(5365),
    [aux_sym_preproc_if_token2] = ACTIONS(5365),
    [aux_sym_preproc_else_token1] = ACTIONS(5365),
    [aux_sym_preproc_elif_token1] = ACTIONS(5363),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5365),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5365),
    [anon_sym_LPAREN2] = ACTIONS(5365),
    [anon_sym_DASH] = ACTIONS(5363),
    [anon_sym_PLUS] = ACTIONS(5363),
    [anon_sym_STAR] = ACTIONS(5363),
    [anon_sym_SLASH] = ACTIONS(5363),
    [anon_sym_PERCENT] = ACTIONS(5363),
    [anon_sym_PIPE_PIPE] = ACTIONS(5365),
    [anon_sym_AMP_AMP] = ACTIONS(5365),
    [anon_sym_PIPE] = ACTIONS(5363),
    [anon_sym_CARET] = ACTIONS(5363),
    [anon_sym_AMP] = ACTIONS(5363),
    [anon_sym_EQ_EQ] = ACTIONS(5365),
    [anon_sym_BANG_EQ] = ACTIONS(5365),
    [anon_sym_GT] = ACTIONS(5363),
    [anon_sym_GT_EQ] = ACTIONS(5365),
    [anon_sym_LT_EQ] = ACTIONS(5363),
    [anon_sym_LT] = ACTIONS(5363),
    [anon_sym_LT_LT] = ACTIONS(5363),
    [anon_sym_GT_GT] = ACTIONS(5363),
    [anon_sym_SEMI] = ACTIONS(5365),
    [anon_sym___attribute__] = ACTIONS(4906),
    [anon_sym_LBRACE] = ACTIONS(5365),
    [anon_sym_RBRACE] = ACTIONS(5365),
    [anon_sym_LBRACK] = ACTIONS(5365),
    [anon_sym_RBRACK] = ACTIONS(5365),
    [anon_sym_EQ] = ACTIONS(5363),
    [anon_sym_COLON] = ACTIONS(5365),
    [anon_sym_QMARK] = ACTIONS(5365),
    [anon_sym_STAR_EQ] = ACTIONS(5365),
    [anon_sym_SLASH_EQ] = ACTIONS(5365),
    [anon_sym_PERCENT_EQ] = ACTIONS(5365),
    [anon_sym_PLUS_EQ] = ACTIONS(5365),
    [anon_sym_DASH_EQ] = ACTIONS(5365),
    [anon_sym_LT_LT_EQ] = ACTIONS(5365),
    [anon_sym_GT_GT_EQ] = ACTIONS(5365),
    [anon_sym_AMP_EQ] = ACTIONS(5365),
    [anon_sym_CARET_EQ] = ACTIONS(5365),
    [anon_sym_PIPE_EQ] = ACTIONS(5365),
    [anon_sym_and_eq] = ACTIONS(5363),
    [anon_sym_or_eq] = ACTIONS(5363),
    [anon_sym_xor_eq] = ACTIONS(5363),
    [anon_sym_LT_EQ_GT] = ACTIONS(5365),
    [anon_sym_or] = ACTIONS(5363),
    [anon_sym_and] = ACTIONS(5363),
    [anon_sym_bitor] = ACTIONS(5363),
    [anon_sym_xor] = ACTIONS(5363),
    [anon_sym_bitand] = ACTIONS(5363),
    [anon_sym_not_eq] = ACTIONS(5363),
    [anon_sym_DASH_DASH] = ACTIONS(5365),
    [anon_sym_PLUS_PLUS] = ACTIONS(5365),
    [anon_sym_DOT] = ACTIONS(5363),
    [anon_sym_DOT_STAR] = ACTIONS(5365),
    [anon_sym_DASH_GT] = ACTIONS(5365),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5363),
    [anon_sym_decltype] = ACTIONS(5363),
  },
  [2262] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1767),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5367),
    [anon_sym_COMMA] = ACTIONS(5367),
    [anon_sym_RPAREN] = ACTIONS(5367),
    [anon_sym_LPAREN2] = ACTIONS(5367),
    [anon_sym_DASH] = ACTIONS(5369),
    [anon_sym_PLUS] = ACTIONS(5369),
    [anon_sym_STAR] = ACTIONS(5367),
    [anon_sym_SLASH] = ACTIONS(5369),
    [anon_sym_PERCENT] = ACTIONS(5367),
    [anon_sym_PIPE_PIPE] = ACTIONS(5367),
    [anon_sym_AMP_AMP] = ACTIONS(5367),
    [anon_sym_PIPE] = ACTIONS(5369),
    [anon_sym_CARET] = ACTIONS(5367),
    [anon_sym_AMP] = ACTIONS(5369),
    [anon_sym_EQ_EQ] = ACTIONS(5367),
    [anon_sym_BANG_EQ] = ACTIONS(5367),
    [anon_sym_GT] = ACTIONS(5369),
    [anon_sym_GT_EQ] = ACTIONS(5367),
    [anon_sym_LT_EQ] = ACTIONS(5369),
    [anon_sym_LT] = ACTIONS(5369),
    [anon_sym_LT_LT] = ACTIONS(5367),
    [anon_sym_GT_GT] = ACTIONS(5367),
    [anon_sym_SEMI] = ACTIONS(5367),
    [anon_sym___extension__] = ACTIONS(5367),
    [anon_sym___attribute__] = ACTIONS(5367),
    [anon_sym_LBRACE] = ACTIONS(5367),
    [anon_sym_RBRACE] = ACTIONS(5367),
    [anon_sym_signed] = ACTIONS(5371),
    [anon_sym_unsigned] = ACTIONS(5371),
    [anon_sym_long] = ACTIONS(5371),
    [anon_sym_short] = ACTIONS(5371),
    [anon_sym_LBRACK] = ACTIONS(5367),
    [anon_sym_RBRACK] = ACTIONS(5367),
    [anon_sym_const] = ACTIONS(5369),
    [anon_sym_constexpr] = ACTIONS(5367),
    [anon_sym_volatile] = ACTIONS(5367),
    [anon_sym_restrict] = ACTIONS(5367),
    [anon_sym___restrict__] = ACTIONS(5367),
    [anon_sym__Atomic] = ACTIONS(5367),
    [anon_sym__Noreturn] = ACTIONS(5367),
    [anon_sym_noreturn] = ACTIONS(5367),
    [anon_sym_mutable] = ACTIONS(5367),
    [anon_sym_constinit] = ACTIONS(5367),
    [anon_sym_consteval] = ACTIONS(5367),
    [anon_sym_PROGMEM] = ACTIONS(5367),
    [anon_sym_COLON] = ACTIONS(5367),
    [anon_sym_QMARK] = ACTIONS(5367),
    [anon_sym_LT_EQ_GT] = ACTIONS(5367),
    [anon_sym_or] = ACTIONS(5367),
    [anon_sym_and] = ACTIONS(5367),
    [anon_sym_bitor] = ACTIONS(5367),
    [anon_sym_xor] = ACTIONS(5367),
    [anon_sym_bitand] = ACTIONS(5367),
    [anon_sym_not_eq] = ACTIONS(5367),
    [anon_sym_DASH_DASH] = ACTIONS(5367),
    [anon_sym_PLUS_PLUS] = ACTIONS(5367),
    [anon_sym_DOT] = ACTIONS(5369),
    [anon_sym_DOT_STAR] = ACTIONS(5367),
    [anon_sym_DASH_GT] = ACTIONS(5367),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5367),
    [anon_sym_decltype] = ACTIONS(5367),
    [anon_sym_final] = ACTIONS(5367),
    [anon_sym_override] = ACTIONS(5367),
    [anon_sym_requires] = ACTIONS(5367),
  },
  [2263] = {
    [sym_primitive_type] = STATE(2615),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2365),
    [sym_identifier] = ACTIONS(5373),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4934),
    [anon_sym_COMMA] = ACTIONS(4934),
    [anon_sym_RPAREN] = ACTIONS(4934),
    [anon_sym_LPAREN2] = ACTIONS(4934),
    [anon_sym_DASH] = ACTIONS(4936),
    [anon_sym_PLUS] = ACTIONS(4936),
    [anon_sym_STAR] = ACTIONS(4936),
    [anon_sym_SLASH] = ACTIONS(4936),
    [anon_sym_PERCENT] = ACTIONS(4936),
    [anon_sym_PIPE_PIPE] = ACTIONS(4934),
    [anon_sym_AMP_AMP] = ACTIONS(4934),
    [anon_sym_PIPE] = ACTIONS(4936),
    [anon_sym_CARET] = ACTIONS(4936),
    [anon_sym_AMP] = ACTIONS(4936),
    [anon_sym_EQ_EQ] = ACTIONS(4934),
    [anon_sym_BANG_EQ] = ACTIONS(4934),
    [anon_sym_GT] = ACTIONS(4936),
    [anon_sym_GT_EQ] = ACTIONS(4934),
    [anon_sym_LT_EQ] = ACTIONS(4936),
    [anon_sym_LT] = ACTIONS(4936),
    [anon_sym_LT_LT] = ACTIONS(4936),
    [anon_sym_GT_GT] = ACTIONS(4936),
    [anon_sym___attribute__] = ACTIONS(4936),
    [anon_sym_LBRACE] = ACTIONS(4934),
    [anon_sym_signed] = ACTIONS(5375),
    [anon_sym_unsigned] = ACTIONS(5375),
    [anon_sym_long] = ACTIONS(5375),
    [anon_sym_short] = ACTIONS(5375),
    [anon_sym_LBRACK] = ACTIONS(4934),
    [anon_sym_EQ] = ACTIONS(4936),
    [aux_sym_primitive_type_token1] = ACTIONS(5377),
    [anon_sym_byte] = ACTIONS(5377),
    [anon_sym_word] = ACTIONS(5377),
    [anon_sym_QMARK] = ACTIONS(4934),
    [anon_sym_STAR_EQ] = ACTIONS(4934),
    [anon_sym_SLASH_EQ] = ACTIONS(4934),
    [anon_sym_PERCENT_EQ] = ACTIONS(4934),
    [anon_sym_PLUS_EQ] = ACTIONS(4934),
    [anon_sym_DASH_EQ] = ACTIONS(4934),
    [anon_sym_LT_LT_EQ] = ACTIONS(4934),
    [anon_sym_GT_GT_EQ] = ACTIONS(4934),
    [anon_sym_AMP_EQ] = ACTIONS(4934),
    [anon_sym_CARET_EQ] = ACTIONS(4934),
    [anon_sym_PIPE_EQ] = ACTIONS(4934),
    [anon_sym_and_eq] = ACTIONS(4936),
    [anon_sym_or_eq] = ACTIONS(4936),
    [anon_sym_xor_eq] = ACTIONS(4936),
    [anon_sym_LT_EQ_GT] = ACTIONS(4934),
    [anon_sym_or] = ACTIONS(4936),
    [anon_sym_and] = ACTIONS(4936),
    [anon_sym_bitor] = ACTIONS(4936),
    [anon_sym_xor] = ACTIONS(4936),
    [anon_sym_bitand] = ACTIONS(4936),
    [anon_sym_not_eq] = ACTIONS(4936),
    [anon_sym_DASH_DASH] = ACTIONS(4934),
    [anon_sym_PLUS_PLUS] = ACTIONS(4934),
    [anon_sym_DOT] = ACTIONS(4936),
    [anon_sym_DOT_STAR] = ACTIONS(4934),
    [anon_sym_DASH_GT] = ACTIONS(4936),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4936),
    [anon_sym_decltype] = ACTIONS(4936),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4934),
  },
  [2264] = {
    [sym_identifier] = ACTIONS(1961),
    [anon_sym_LPAREN2] = ACTIONS(1959),
    [anon_sym_TILDE] = ACTIONS(1959),
    [anon_sym_STAR] = ACTIONS(1959),
    [anon_sym_PIPE_PIPE] = ACTIONS(1959),
    [anon_sym_AMP_AMP] = ACTIONS(1959),
    [anon_sym_AMP] = ACTIONS(1961),
    [anon_sym___extension__] = ACTIONS(1961),
    [anon_sym_extern] = ACTIONS(1961),
    [anon_sym___attribute__] = ACTIONS(1961),
    [anon_sym_COLON_COLON] = ACTIONS(1959),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1959),
    [anon_sym___declspec] = ACTIONS(1961),
    [anon_sym___based] = ACTIONS(1961),
    [anon_sym___cdecl] = ACTIONS(1961),
    [anon_sym___clrcall] = ACTIONS(1961),
    [anon_sym___stdcall] = ACTIONS(1961),
    [anon_sym___fastcall] = ACTIONS(1961),
    [anon_sym___thiscall] = ACTIONS(1961),
    [anon_sym___vectorcall] = ACTIONS(1961),
    [anon_sym_signed] = ACTIONS(1961),
    [anon_sym_unsigned] = ACTIONS(1961),
    [anon_sym_long] = ACTIONS(1961),
    [anon_sym_short] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1961),
    [anon_sym_static] = ACTIONS(1961),
    [anon_sym_register] = ACTIONS(1961),
    [anon_sym_inline] = ACTIONS(1961),
    [anon_sym___inline] = ACTIONS(1961),
    [anon_sym___inline__] = ACTIONS(1961),
    [anon_sym___forceinline] = ACTIONS(1961),
    [anon_sym_thread_local] = ACTIONS(1961),
    [anon_sym___thread] = ACTIONS(1961),
    [anon_sym_const] = ACTIONS(1961),
    [anon_sym_constexpr] = ACTIONS(1961),
    [anon_sym_volatile] = ACTIONS(1961),
    [anon_sym_restrict] = ACTIONS(1961),
    [anon_sym___restrict__] = ACTIONS(1961),
    [anon_sym__Atomic] = ACTIONS(1961),
    [anon_sym__Noreturn] = ACTIONS(1961),
    [anon_sym_noreturn] = ACTIONS(1961),
    [anon_sym_mutable] = ACTIONS(1961),
    [anon_sym_constinit] = ACTIONS(1961),
    [anon_sym_consteval] = ACTIONS(1961),
    [anon_sym_PROGMEM] = ACTIONS(1961),
    [aux_sym_primitive_type_token1] = ACTIONS(1961),
    [anon_sym_byte] = ACTIONS(1961),
    [anon_sym_word] = ACTIONS(1961),
    [anon_sym_enum] = ACTIONS(1961),
    [anon_sym_class] = ACTIONS(1961),
    [anon_sym_struct] = ACTIONS(1961),
    [anon_sym_union] = ACTIONS(1961),
    [anon_sym_or] = ACTIONS(1961),
    [anon_sym_and] = ACTIONS(1961),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1961),
    [anon_sym_decltype] = ACTIONS(1961),
    [anon_sym_virtual] = ACTIONS(1961),
    [anon_sym_alignas] = ACTIONS(1961),
    [anon_sym_explicit] = ACTIONS(1961),
    [anon_sym_typename] = ACTIONS(1961),
    [anon_sym_template] = ACTIONS(1961),
    [anon_sym_operator] = ACTIONS(1961),
    [anon_sym_friend] = ACTIONS(1961),
    [anon_sym_using] = ACTIONS(1961),
    [anon_sym_concept] = ACTIONS(1961),
  },
  [2265] = {
    [sym_string_literal] = STATE(2291),
    [sym_template_argument_list] = STATE(3347),
    [sym_raw_string_literal] = STATE(2291),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3761),
    [anon_sym_COMMA] = ACTIONS(3761),
    [anon_sym_LPAREN2] = ACTIONS(3761),
    [anon_sym_DASH] = ACTIONS(3769),
    [anon_sym_PLUS] = ACTIONS(3769),
    [anon_sym_STAR] = ACTIONS(3769),
    [anon_sym_SLASH] = ACTIONS(3769),
    [anon_sym_PERCENT] = ACTIONS(3769),
    [anon_sym_PIPE_PIPE] = ACTIONS(3761),
    [anon_sym_AMP_AMP] = ACTIONS(3761),
    [anon_sym_PIPE] = ACTIONS(3769),
    [anon_sym_CARET] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(3769),
    [anon_sym_EQ_EQ] = ACTIONS(3761),
    [anon_sym_BANG_EQ] = ACTIONS(3761),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3769),
    [anon_sym_LT_EQ] = ACTIONS(3769),
    [anon_sym_LT] = ACTIONS(5379),
    [anon_sym_LT_LT] = ACTIONS(3769),
    [anon_sym_GT_GT] = ACTIONS(3769),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(3785),
    [anon_sym_LBRACK] = ACTIONS(3761),
    [anon_sym_EQ] = ACTIONS(3769),
    [anon_sym_QMARK] = ACTIONS(3761),
    [anon_sym_STAR_EQ] = ACTIONS(3761),
    [anon_sym_SLASH_EQ] = ACTIONS(3761),
    [anon_sym_PERCENT_EQ] = ACTIONS(3761),
    [anon_sym_PLUS_EQ] = ACTIONS(3761),
    [anon_sym_DASH_EQ] = ACTIONS(3761),
    [anon_sym_LT_LT_EQ] = ACTIONS(3761),
    [anon_sym_GT_GT_EQ] = ACTIONS(3769),
    [anon_sym_AMP_EQ] = ACTIONS(3761),
    [anon_sym_CARET_EQ] = ACTIONS(3761),
    [anon_sym_PIPE_EQ] = ACTIONS(3761),
    [anon_sym_and_eq] = ACTIONS(3761),
    [anon_sym_or_eq] = ACTIONS(3761),
    [anon_sym_xor_eq] = ACTIONS(3761),
    [anon_sym_LT_EQ_GT] = ACTIONS(3761),
    [anon_sym_or] = ACTIONS(3769),
    [anon_sym_and] = ACTIONS(3769),
    [anon_sym_bitor] = ACTIONS(3761),
    [anon_sym_xor] = ACTIONS(3769),
    [anon_sym_bitand] = ACTIONS(3761),
    [anon_sym_not_eq] = ACTIONS(3761),
    [anon_sym_DASH_DASH] = ACTIONS(3761),
    [anon_sym_PLUS_PLUS] = ACTIONS(3761),
    [anon_sym_DOT] = ACTIONS(3769),
    [anon_sym_DOT_STAR] = ACTIONS(3761),
    [anon_sym_DASH_GT] = ACTIONS(3761),
    [anon_sym_L_DQUOTE] = ACTIONS(5382),
    [anon_sym_u_DQUOTE] = ACTIONS(5382),
    [anon_sym_U_DQUOTE] = ACTIONS(5382),
    [anon_sym_u8_DQUOTE] = ACTIONS(5382),
    [anon_sym_DQUOTE] = ACTIONS(5382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_GT2] = ACTIONS(3761),
    [anon_sym_R_DQUOTE] = ACTIONS(5384),
    [anon_sym_LR_DQUOTE] = ACTIONS(5384),
    [anon_sym_uR_DQUOTE] = ACTIONS(5384),
    [anon_sym_UR_DQUOTE] = ACTIONS(5384),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5384),
  },
  [2266] = {
    [sym_attribute_specifier] = STATE(2360),
    [sym_identifier] = ACTIONS(5386),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5388),
    [anon_sym_COMMA] = ACTIONS(5388),
    [anon_sym_RPAREN] = ACTIONS(5388),
    [aux_sym_preproc_if_token2] = ACTIONS(5388),
    [aux_sym_preproc_else_token1] = ACTIONS(5388),
    [aux_sym_preproc_elif_token1] = ACTIONS(5386),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5388),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5388),
    [anon_sym_LPAREN2] = ACTIONS(5388),
    [anon_sym_DASH] = ACTIONS(5386),
    [anon_sym_PLUS] = ACTIONS(5386),
    [anon_sym_STAR] = ACTIONS(5386),
    [anon_sym_SLASH] = ACTIONS(5386),
    [anon_sym_PERCENT] = ACTIONS(5386),
    [anon_sym_PIPE_PIPE] = ACTIONS(5388),
    [anon_sym_AMP_AMP] = ACTIONS(5388),
    [anon_sym_PIPE] = ACTIONS(5386),
    [anon_sym_CARET] = ACTIONS(5386),
    [anon_sym_AMP] = ACTIONS(5386),
    [anon_sym_EQ_EQ] = ACTIONS(5388),
    [anon_sym_BANG_EQ] = ACTIONS(5388),
    [anon_sym_GT] = ACTIONS(5386),
    [anon_sym_GT_EQ] = ACTIONS(5388),
    [anon_sym_LT_EQ] = ACTIONS(5386),
    [anon_sym_LT] = ACTIONS(5386),
    [anon_sym_LT_LT] = ACTIONS(5386),
    [anon_sym_GT_GT] = ACTIONS(5386),
    [anon_sym_SEMI] = ACTIONS(5388),
    [anon_sym___attribute__] = ACTIONS(4906),
    [anon_sym_LBRACE] = ACTIONS(5388),
    [anon_sym_RBRACE] = ACTIONS(5388),
    [anon_sym_LBRACK] = ACTIONS(5388),
    [anon_sym_RBRACK] = ACTIONS(5388),
    [anon_sym_EQ] = ACTIONS(5386),
    [anon_sym_COLON] = ACTIONS(5388),
    [anon_sym_QMARK] = ACTIONS(5388),
    [anon_sym_STAR_EQ] = ACTIONS(5388),
    [anon_sym_SLASH_EQ] = ACTIONS(5388),
    [anon_sym_PERCENT_EQ] = ACTIONS(5388),
    [anon_sym_PLUS_EQ] = ACTIONS(5388),
    [anon_sym_DASH_EQ] = ACTIONS(5388),
    [anon_sym_LT_LT_EQ] = ACTIONS(5388),
    [anon_sym_GT_GT_EQ] = ACTIONS(5388),
    [anon_sym_AMP_EQ] = ACTIONS(5388),
    [anon_sym_CARET_EQ] = ACTIONS(5388),
    [anon_sym_PIPE_EQ] = ACTIONS(5388),
    [anon_sym_and_eq] = ACTIONS(5386),
    [anon_sym_or_eq] = ACTIONS(5386),
    [anon_sym_xor_eq] = ACTIONS(5386),
    [anon_sym_LT_EQ_GT] = ACTIONS(5388),
    [anon_sym_or] = ACTIONS(5386),
    [anon_sym_and] = ACTIONS(5386),
    [anon_sym_bitor] = ACTIONS(5386),
    [anon_sym_xor] = ACTIONS(5386),
    [anon_sym_bitand] = ACTIONS(5386),
    [anon_sym_not_eq] = ACTIONS(5386),
    [anon_sym_DASH_DASH] = ACTIONS(5388),
    [anon_sym_PLUS_PLUS] = ACTIONS(5388),
    [anon_sym_DOT] = ACTIONS(5386),
    [anon_sym_DOT_STAR] = ACTIONS(5388),
    [anon_sym_DASH_GT] = ACTIONS(5388),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5386),
    [anon_sym_decltype] = ACTIONS(5386),
  },
  [2267] = {
    [sym_attribute_declaration] = STATE(2374),
    [sym_parameter_list] = STATE(2342),
    [aux_sym_attributed_declarator_repeat1] = STATE(2374),
    [sym_identifier] = ACTIONS(5390),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5392),
    [anon_sym_COMMA] = ACTIONS(5392),
    [anon_sym_RPAREN] = ACTIONS(5392),
    [aux_sym_preproc_if_token2] = ACTIONS(5392),
    [aux_sym_preproc_else_token1] = ACTIONS(5392),
    [aux_sym_preproc_elif_token1] = ACTIONS(5390),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5392),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5392),
    [anon_sym_LPAREN2] = ACTIONS(5394),
    [anon_sym_DASH] = ACTIONS(5390),
    [anon_sym_PLUS] = ACTIONS(5390),
    [anon_sym_STAR] = ACTIONS(5390),
    [anon_sym_SLASH] = ACTIONS(5390),
    [anon_sym_PERCENT] = ACTIONS(5390),
    [anon_sym_PIPE_PIPE] = ACTIONS(5392),
    [anon_sym_AMP_AMP] = ACTIONS(5392),
    [anon_sym_PIPE] = ACTIONS(5390),
    [anon_sym_CARET] = ACTIONS(5390),
    [anon_sym_AMP] = ACTIONS(5390),
    [anon_sym_EQ_EQ] = ACTIONS(5392),
    [anon_sym_BANG_EQ] = ACTIONS(5392),
    [anon_sym_GT] = ACTIONS(5390),
    [anon_sym_GT_EQ] = ACTIONS(5392),
    [anon_sym_LT_EQ] = ACTIONS(5390),
    [anon_sym_LT] = ACTIONS(5390),
    [anon_sym_LT_LT] = ACTIONS(5390),
    [anon_sym_GT_GT] = ACTIONS(5390),
    [anon_sym_SEMI] = ACTIONS(5392),
    [anon_sym___attribute__] = ACTIONS(5390),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5396),
    [anon_sym_RBRACE] = ACTIONS(5392),
    [anon_sym_LBRACK] = ACTIONS(5398),
    [anon_sym_RBRACK] = ACTIONS(5392),
    [anon_sym_EQ] = ACTIONS(5390),
    [anon_sym_COLON] = ACTIONS(5392),
    [anon_sym_QMARK] = ACTIONS(5392),
    [anon_sym_STAR_EQ] = ACTIONS(5392),
    [anon_sym_SLASH_EQ] = ACTIONS(5392),
    [anon_sym_PERCENT_EQ] = ACTIONS(5392),
    [anon_sym_PLUS_EQ] = ACTIONS(5392),
    [anon_sym_DASH_EQ] = ACTIONS(5392),
    [anon_sym_LT_LT_EQ] = ACTIONS(5392),
    [anon_sym_GT_GT_EQ] = ACTIONS(5392),
    [anon_sym_AMP_EQ] = ACTIONS(5392),
    [anon_sym_CARET_EQ] = ACTIONS(5392),
    [anon_sym_PIPE_EQ] = ACTIONS(5392),
    [anon_sym_and_eq] = ACTIONS(5390),
    [anon_sym_or_eq] = ACTIONS(5390),
    [anon_sym_xor_eq] = ACTIONS(5390),
    [anon_sym_LT_EQ_GT] = ACTIONS(5392),
    [anon_sym_or] = ACTIONS(5390),
    [anon_sym_and] = ACTIONS(5390),
    [anon_sym_bitor] = ACTIONS(5390),
    [anon_sym_xor] = ACTIONS(5390),
    [anon_sym_bitand] = ACTIONS(5390),
    [anon_sym_not_eq] = ACTIONS(5390),
    [anon_sym_DASH_DASH] = ACTIONS(5392),
    [anon_sym_PLUS_PLUS] = ACTIONS(5392),
    [anon_sym_DOT] = ACTIONS(5390),
    [anon_sym_DOT_STAR] = ACTIONS(5392),
    [anon_sym_DASH_GT] = ACTIONS(5392),
    [sym_comment] = ACTIONS(3),
  },
  [2268] = {
    [sym_attribute_specifier] = STATE(2388),
    [sym_identifier] = ACTIONS(5400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5402),
    [anon_sym_COMMA] = ACTIONS(5402),
    [anon_sym_RPAREN] = ACTIONS(5402),
    [aux_sym_preproc_if_token2] = ACTIONS(5402),
    [aux_sym_preproc_else_token1] = ACTIONS(5402),
    [aux_sym_preproc_elif_token1] = ACTIONS(5400),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5402),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5402),
    [anon_sym_LPAREN2] = ACTIONS(5402),
    [anon_sym_DASH] = ACTIONS(5400),
    [anon_sym_PLUS] = ACTIONS(5400),
    [anon_sym_STAR] = ACTIONS(5400),
    [anon_sym_SLASH] = ACTIONS(5400),
    [anon_sym_PERCENT] = ACTIONS(5400),
    [anon_sym_PIPE_PIPE] = ACTIONS(5402),
    [anon_sym_AMP_AMP] = ACTIONS(5402),
    [anon_sym_PIPE] = ACTIONS(5400),
    [anon_sym_CARET] = ACTIONS(5400),
    [anon_sym_AMP] = ACTIONS(5400),
    [anon_sym_EQ_EQ] = ACTIONS(5402),
    [anon_sym_BANG_EQ] = ACTIONS(5402),
    [anon_sym_GT] = ACTIONS(5400),
    [anon_sym_GT_EQ] = ACTIONS(5402),
    [anon_sym_LT_EQ] = ACTIONS(5400),
    [anon_sym_LT] = ACTIONS(5400),
    [anon_sym_LT_LT] = ACTIONS(5400),
    [anon_sym_GT_GT] = ACTIONS(5400),
    [anon_sym_SEMI] = ACTIONS(5402),
    [anon_sym___attribute__] = ACTIONS(4906),
    [anon_sym_LBRACE] = ACTIONS(5402),
    [anon_sym_RBRACE] = ACTIONS(5402),
    [anon_sym_LBRACK] = ACTIONS(5402),
    [anon_sym_RBRACK] = ACTIONS(5402),
    [anon_sym_EQ] = ACTIONS(5400),
    [anon_sym_COLON] = ACTIONS(5402),
    [anon_sym_QMARK] = ACTIONS(5402),
    [anon_sym_STAR_EQ] = ACTIONS(5402),
    [anon_sym_SLASH_EQ] = ACTIONS(5402),
    [anon_sym_PERCENT_EQ] = ACTIONS(5402),
    [anon_sym_PLUS_EQ] = ACTIONS(5402),
    [anon_sym_DASH_EQ] = ACTIONS(5402),
    [anon_sym_LT_LT_EQ] = ACTIONS(5402),
    [anon_sym_GT_GT_EQ] = ACTIONS(5402),
    [anon_sym_AMP_EQ] = ACTIONS(5402),
    [anon_sym_CARET_EQ] = ACTIONS(5402),
    [anon_sym_PIPE_EQ] = ACTIONS(5402),
    [anon_sym_and_eq] = ACTIONS(5400),
    [anon_sym_or_eq] = ACTIONS(5400),
    [anon_sym_xor_eq] = ACTIONS(5400),
    [anon_sym_LT_EQ_GT] = ACTIONS(5402),
    [anon_sym_or] = ACTIONS(5400),
    [anon_sym_and] = ACTIONS(5400),
    [anon_sym_bitor] = ACTIONS(5400),
    [anon_sym_xor] = ACTIONS(5400),
    [anon_sym_bitand] = ACTIONS(5400),
    [anon_sym_not_eq] = ACTIONS(5400),
    [anon_sym_DASH_DASH] = ACTIONS(5402),
    [anon_sym_PLUS_PLUS] = ACTIONS(5402),
    [anon_sym_DOT] = ACTIONS(5400),
    [anon_sym_DOT_STAR] = ACTIONS(5402),
    [anon_sym_DASH_GT] = ACTIONS(5402),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5400),
    [anon_sym_decltype] = ACTIONS(5400),
  },
  [2269] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1767),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5404),
    [anon_sym_COMMA] = ACTIONS(5404),
    [anon_sym_RPAREN] = ACTIONS(5404),
    [anon_sym_LPAREN2] = ACTIONS(5404),
    [anon_sym_DASH] = ACTIONS(5406),
    [anon_sym_PLUS] = ACTIONS(5406),
    [anon_sym_STAR] = ACTIONS(5404),
    [anon_sym_SLASH] = ACTIONS(5406),
    [anon_sym_PERCENT] = ACTIONS(5404),
    [anon_sym_PIPE_PIPE] = ACTIONS(5404),
    [anon_sym_AMP_AMP] = ACTIONS(5404),
    [anon_sym_PIPE] = ACTIONS(5406),
    [anon_sym_CARET] = ACTIONS(5404),
    [anon_sym_AMP] = ACTIONS(5406),
    [anon_sym_EQ_EQ] = ACTIONS(5404),
    [anon_sym_BANG_EQ] = ACTIONS(5404),
    [anon_sym_GT] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(5404),
    [anon_sym_LT_EQ] = ACTIONS(5406),
    [anon_sym_LT] = ACTIONS(5406),
    [anon_sym_LT_LT] = ACTIONS(5404),
    [anon_sym_GT_GT] = ACTIONS(5404),
    [anon_sym_SEMI] = ACTIONS(5404),
    [anon_sym___extension__] = ACTIONS(5404),
    [anon_sym___attribute__] = ACTIONS(5404),
    [anon_sym_LBRACE] = ACTIONS(5404),
    [anon_sym_RBRACE] = ACTIONS(5404),
    [anon_sym_signed] = ACTIONS(5371),
    [anon_sym_unsigned] = ACTIONS(5371),
    [anon_sym_long] = ACTIONS(5371),
    [anon_sym_short] = ACTIONS(5371),
    [anon_sym_LBRACK] = ACTIONS(5404),
    [anon_sym_RBRACK] = ACTIONS(5404),
    [anon_sym_const] = ACTIONS(5406),
    [anon_sym_constexpr] = ACTIONS(5404),
    [anon_sym_volatile] = ACTIONS(5404),
    [anon_sym_restrict] = ACTIONS(5404),
    [anon_sym___restrict__] = ACTIONS(5404),
    [anon_sym__Atomic] = ACTIONS(5404),
    [anon_sym__Noreturn] = ACTIONS(5404),
    [anon_sym_noreturn] = ACTIONS(5404),
    [anon_sym_mutable] = ACTIONS(5404),
    [anon_sym_constinit] = ACTIONS(5404),
    [anon_sym_consteval] = ACTIONS(5404),
    [anon_sym_PROGMEM] = ACTIONS(5404),
    [anon_sym_COLON] = ACTIONS(5404),
    [anon_sym_QMARK] = ACTIONS(5404),
    [anon_sym_LT_EQ_GT] = ACTIONS(5404),
    [anon_sym_or] = ACTIONS(5404),
    [anon_sym_and] = ACTIONS(5404),
    [anon_sym_bitor] = ACTIONS(5404),
    [anon_sym_xor] = ACTIONS(5404),
    [anon_sym_bitand] = ACTIONS(5404),
    [anon_sym_not_eq] = ACTIONS(5404),
    [anon_sym_DASH_DASH] = ACTIONS(5404),
    [anon_sym_PLUS_PLUS] = ACTIONS(5404),
    [anon_sym_DOT] = ACTIONS(5406),
    [anon_sym_DOT_STAR] = ACTIONS(5404),
    [anon_sym_DASH_GT] = ACTIONS(5404),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5404),
    [anon_sym_decltype] = ACTIONS(5404),
    [anon_sym_final] = ACTIONS(5404),
    [anon_sym_override] = ACTIONS(5404),
    [anon_sym_requires] = ACTIONS(5404),
  },
  [2270] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5408),
    [anon_sym_COMMA] = ACTIONS(5408),
    [anon_sym_RPAREN] = ACTIONS(5408),
    [anon_sym_LPAREN2] = ACTIONS(5408),
    [anon_sym_DASH] = ACTIONS(5410),
    [anon_sym_PLUS] = ACTIONS(5410),
    [anon_sym_STAR] = ACTIONS(5408),
    [anon_sym_SLASH] = ACTIONS(5410),
    [anon_sym_PERCENT] = ACTIONS(5408),
    [anon_sym_PIPE_PIPE] = ACTIONS(5408),
    [anon_sym_AMP_AMP] = ACTIONS(5408),
    [anon_sym_PIPE] = ACTIONS(5410),
    [anon_sym_CARET] = ACTIONS(5408),
    [anon_sym_AMP] = ACTIONS(5410),
    [anon_sym_EQ_EQ] = ACTIONS(5408),
    [anon_sym_BANG_EQ] = ACTIONS(5408),
    [anon_sym_GT] = ACTIONS(5410),
    [anon_sym_GT_EQ] = ACTIONS(5408),
    [anon_sym_LT_EQ] = ACTIONS(5410),
    [anon_sym_LT] = ACTIONS(5410),
    [anon_sym_LT_LT] = ACTIONS(5408),
    [anon_sym_GT_GT] = ACTIONS(5408),
    [anon_sym_SEMI] = ACTIONS(5408),
    [anon_sym___extension__] = ACTIONS(5408),
    [anon_sym___attribute__] = ACTIONS(5408),
    [anon_sym_LBRACE] = ACTIONS(5408),
    [anon_sym_RBRACE] = ACTIONS(5408),
    [anon_sym_signed] = ACTIONS(5412),
    [anon_sym_unsigned] = ACTIONS(5412),
    [anon_sym_long] = ACTIONS(5412),
    [anon_sym_short] = ACTIONS(5412),
    [anon_sym_LBRACK] = ACTIONS(5408),
    [anon_sym_RBRACK] = ACTIONS(5408),
    [anon_sym_const] = ACTIONS(5410),
    [anon_sym_constexpr] = ACTIONS(5408),
    [anon_sym_volatile] = ACTIONS(5408),
    [anon_sym_restrict] = ACTIONS(5408),
    [anon_sym___restrict__] = ACTIONS(5408),
    [anon_sym__Atomic] = ACTIONS(5408),
    [anon_sym__Noreturn] = ACTIONS(5408),
    [anon_sym_noreturn] = ACTIONS(5408),
    [anon_sym_mutable] = ACTIONS(5408),
    [anon_sym_constinit] = ACTIONS(5408),
    [anon_sym_consteval] = ACTIONS(5408),
    [anon_sym_PROGMEM] = ACTIONS(5408),
    [anon_sym_COLON] = ACTIONS(5408),
    [anon_sym_QMARK] = ACTIONS(5408),
    [anon_sym_LT_EQ_GT] = ACTIONS(5408),
    [anon_sym_or] = ACTIONS(5408),
    [anon_sym_and] = ACTIONS(5408),
    [anon_sym_bitor] = ACTIONS(5408),
    [anon_sym_xor] = ACTIONS(5408),
    [anon_sym_bitand] = ACTIONS(5408),
    [anon_sym_not_eq] = ACTIONS(5408),
    [anon_sym_DASH_DASH] = ACTIONS(5408),
    [anon_sym_PLUS_PLUS] = ACTIONS(5408),
    [anon_sym_DOT] = ACTIONS(5410),
    [anon_sym_DOT_STAR] = ACTIONS(5408),
    [anon_sym_DASH_GT] = ACTIONS(5408),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5408),
    [anon_sym_decltype] = ACTIONS(5408),
    [anon_sym_final] = ACTIONS(5408),
    [anon_sym_override] = ACTIONS(5408),
    [anon_sym_requires] = ACTIONS(5408),
  },
  [2271] = {
    [sym_attribute_specifier] = STATE(2386),
    [sym_identifier] = ACTIONS(5414),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5416),
    [anon_sym_COMMA] = ACTIONS(5416),
    [anon_sym_RPAREN] = ACTIONS(5416),
    [aux_sym_preproc_if_token2] = ACTIONS(5416),
    [aux_sym_preproc_else_token1] = ACTIONS(5416),
    [aux_sym_preproc_elif_token1] = ACTIONS(5414),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5416),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5416),
    [anon_sym_LPAREN2] = ACTIONS(5416),
    [anon_sym_DASH] = ACTIONS(5414),
    [anon_sym_PLUS] = ACTIONS(5414),
    [anon_sym_STAR] = ACTIONS(5414),
    [anon_sym_SLASH] = ACTIONS(5414),
    [anon_sym_PERCENT] = ACTIONS(5414),
    [anon_sym_PIPE_PIPE] = ACTIONS(5416),
    [anon_sym_AMP_AMP] = ACTIONS(5416),
    [anon_sym_PIPE] = ACTIONS(5414),
    [anon_sym_CARET] = ACTIONS(5414),
    [anon_sym_AMP] = ACTIONS(5414),
    [anon_sym_EQ_EQ] = ACTIONS(5416),
    [anon_sym_BANG_EQ] = ACTIONS(5416),
    [anon_sym_GT] = ACTIONS(5414),
    [anon_sym_GT_EQ] = ACTIONS(5416),
    [anon_sym_LT_EQ] = ACTIONS(5414),
    [anon_sym_LT] = ACTIONS(5414),
    [anon_sym_LT_LT] = ACTIONS(5414),
    [anon_sym_GT_GT] = ACTIONS(5414),
    [anon_sym_SEMI] = ACTIONS(5416),
    [anon_sym___attribute__] = ACTIONS(4906),
    [anon_sym_LBRACE] = ACTIONS(5416),
    [anon_sym_RBRACE] = ACTIONS(5416),
    [anon_sym_LBRACK] = ACTIONS(5416),
    [anon_sym_RBRACK] = ACTIONS(5416),
    [anon_sym_EQ] = ACTIONS(5414),
    [anon_sym_COLON] = ACTIONS(5416),
    [anon_sym_QMARK] = ACTIONS(5416),
    [anon_sym_STAR_EQ] = ACTIONS(5416),
    [anon_sym_SLASH_EQ] = ACTIONS(5416),
    [anon_sym_PERCENT_EQ] = ACTIONS(5416),
    [anon_sym_PLUS_EQ] = ACTIONS(5416),
    [anon_sym_DASH_EQ] = ACTIONS(5416),
    [anon_sym_LT_LT_EQ] = ACTIONS(5416),
    [anon_sym_GT_GT_EQ] = ACTIONS(5416),
    [anon_sym_AMP_EQ] = ACTIONS(5416),
    [anon_sym_CARET_EQ] = ACTIONS(5416),
    [anon_sym_PIPE_EQ] = ACTIONS(5416),
    [anon_sym_and_eq] = ACTIONS(5414),
    [anon_sym_or_eq] = ACTIONS(5414),
    [anon_sym_xor_eq] = ACTIONS(5414),
    [anon_sym_LT_EQ_GT] = ACTIONS(5416),
    [anon_sym_or] = ACTIONS(5414),
    [anon_sym_and] = ACTIONS(5414),
    [anon_sym_bitor] = ACTIONS(5414),
    [anon_sym_xor] = ACTIONS(5414),
    [anon_sym_bitand] = ACTIONS(5414),
    [anon_sym_not_eq] = ACTIONS(5414),
    [anon_sym_DASH_DASH] = ACTIONS(5416),
    [anon_sym_PLUS_PLUS] = ACTIONS(5416),
    [anon_sym_DOT] = ACTIONS(5414),
    [anon_sym_DOT_STAR] = ACTIONS(5416),
    [anon_sym_DASH_GT] = ACTIONS(5416),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5414),
    [anon_sym_decltype] = ACTIONS(5414),
  },
  [2272] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2274),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5418),
    [anon_sym_COMMA] = ACTIONS(5418),
    [anon_sym_RPAREN] = ACTIONS(5418),
    [anon_sym_LPAREN2] = ACTIONS(5418),
    [anon_sym_DASH] = ACTIONS(5420),
    [anon_sym_PLUS] = ACTIONS(5420),
    [anon_sym_STAR] = ACTIONS(5418),
    [anon_sym_SLASH] = ACTIONS(5420),
    [anon_sym_PERCENT] = ACTIONS(5418),
    [anon_sym_PIPE_PIPE] = ACTIONS(5418),
    [anon_sym_AMP_AMP] = ACTIONS(5418),
    [anon_sym_PIPE] = ACTIONS(5420),
    [anon_sym_CARET] = ACTIONS(5418),
    [anon_sym_AMP] = ACTIONS(5420),
    [anon_sym_EQ_EQ] = ACTIONS(5418),
    [anon_sym_BANG_EQ] = ACTIONS(5418),
    [anon_sym_GT] = ACTIONS(5420),
    [anon_sym_GT_EQ] = ACTIONS(5418),
    [anon_sym_LT_EQ] = ACTIONS(5420),
    [anon_sym_LT] = ACTIONS(5420),
    [anon_sym_LT_LT] = ACTIONS(5418),
    [anon_sym_GT_GT] = ACTIONS(5418),
    [anon_sym_SEMI] = ACTIONS(5418),
    [anon_sym___extension__] = ACTIONS(5418),
    [anon_sym___attribute__] = ACTIONS(5418),
    [anon_sym_LBRACE] = ACTIONS(5418),
    [anon_sym_RBRACE] = ACTIONS(5418),
    [anon_sym_signed] = ACTIONS(5422),
    [anon_sym_unsigned] = ACTIONS(5422),
    [anon_sym_long] = ACTIONS(5422),
    [anon_sym_short] = ACTIONS(5422),
    [anon_sym_LBRACK] = ACTIONS(5418),
    [anon_sym_RBRACK] = ACTIONS(5418),
    [anon_sym_const] = ACTIONS(5420),
    [anon_sym_constexpr] = ACTIONS(5418),
    [anon_sym_volatile] = ACTIONS(5418),
    [anon_sym_restrict] = ACTIONS(5418),
    [anon_sym___restrict__] = ACTIONS(5418),
    [anon_sym__Atomic] = ACTIONS(5418),
    [anon_sym__Noreturn] = ACTIONS(5418),
    [anon_sym_noreturn] = ACTIONS(5418),
    [anon_sym_mutable] = ACTIONS(5418),
    [anon_sym_constinit] = ACTIONS(5418),
    [anon_sym_consteval] = ACTIONS(5418),
    [anon_sym_PROGMEM] = ACTIONS(5418),
    [anon_sym_COLON] = ACTIONS(5418),
    [anon_sym_QMARK] = ACTIONS(5418),
    [anon_sym_LT_EQ_GT] = ACTIONS(5418),
    [anon_sym_or] = ACTIONS(5418),
    [anon_sym_and] = ACTIONS(5418),
    [anon_sym_bitor] = ACTIONS(5418),
    [anon_sym_xor] = ACTIONS(5418),
    [anon_sym_bitand] = ACTIONS(5418),
    [anon_sym_not_eq] = ACTIONS(5418),
    [anon_sym_DASH_DASH] = ACTIONS(5418),
    [anon_sym_PLUS_PLUS] = ACTIONS(5418),
    [anon_sym_DOT] = ACTIONS(5420),
    [anon_sym_DOT_STAR] = ACTIONS(5418),
    [anon_sym_DASH_GT] = ACTIONS(5418),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5418),
    [anon_sym_decltype] = ACTIONS(5418),
    [anon_sym_final] = ACTIONS(5418),
    [anon_sym_override] = ACTIONS(5418),
    [anon_sym_requires] = ACTIONS(5418),
  },
  [2273] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4835),
    [anon_sym_COMMA] = ACTIONS(4835),
    [anon_sym_RPAREN] = ACTIONS(4835),
    [anon_sym_LPAREN2] = ACTIONS(4835),
    [anon_sym_DASH] = ACTIONS(4833),
    [anon_sym_PLUS] = ACTIONS(4833),
    [anon_sym_STAR] = ACTIONS(4833),
    [anon_sym_SLASH] = ACTIONS(4833),
    [anon_sym_PERCENT] = ACTIONS(4833),
    [anon_sym_PIPE_PIPE] = ACTIONS(4835),
    [anon_sym_AMP_AMP] = ACTIONS(4835),
    [anon_sym_PIPE] = ACTIONS(4833),
    [anon_sym_CARET] = ACTIONS(4833),
    [anon_sym_AMP] = ACTIONS(4833),
    [anon_sym_EQ_EQ] = ACTIONS(4835),
    [anon_sym_BANG_EQ] = ACTIONS(4835),
    [anon_sym_GT] = ACTIONS(4833),
    [anon_sym_GT_EQ] = ACTIONS(4835),
    [anon_sym_LT_EQ] = ACTIONS(4833),
    [anon_sym_LT] = ACTIONS(4833),
    [anon_sym_LT_LT] = ACTIONS(4833),
    [anon_sym_GT_GT] = ACTIONS(4833),
    [anon_sym_SEMI] = ACTIONS(4835),
    [anon_sym_RBRACE] = ACTIONS(4835),
    [anon_sym_LBRACK] = ACTIONS(4835),
    [anon_sym_RBRACK] = ACTIONS(4835),
    [anon_sym_EQ] = ACTIONS(4833),
    [anon_sym_COLON] = ACTIONS(4835),
    [anon_sym_QMARK] = ACTIONS(4835),
    [anon_sym_STAR_EQ] = ACTIONS(4835),
    [anon_sym_SLASH_EQ] = ACTIONS(4835),
    [anon_sym_PERCENT_EQ] = ACTIONS(4835),
    [anon_sym_PLUS_EQ] = ACTIONS(4835),
    [anon_sym_DASH_EQ] = ACTIONS(4835),
    [anon_sym_LT_LT_EQ] = ACTIONS(4835),
    [anon_sym_GT_GT_EQ] = ACTIONS(4835),
    [anon_sym_AMP_EQ] = ACTIONS(4835),
    [anon_sym_CARET_EQ] = ACTIONS(4835),
    [anon_sym_PIPE_EQ] = ACTIONS(4835),
    [anon_sym_and_eq] = ACTIONS(4833),
    [anon_sym_or_eq] = ACTIONS(4833),
    [anon_sym_xor_eq] = ACTIONS(4833),
    [anon_sym_LT_EQ_GT] = ACTIONS(4835),
    [anon_sym_or] = ACTIONS(4833),
    [anon_sym_and] = ACTIONS(4833),
    [anon_sym_bitor] = ACTIONS(4833),
    [anon_sym_xor] = ACTIONS(4833),
    [anon_sym_bitand] = ACTIONS(4833),
    [anon_sym_not_eq] = ACTIONS(4833),
    [anon_sym_DASH_DASH] = ACTIONS(4835),
    [anon_sym_PLUS_PLUS] = ACTIONS(4835),
    [anon_sym_DOT] = ACTIONS(4833),
    [anon_sym_DOT_STAR] = ACTIONS(4835),
    [anon_sym_DASH_GT] = ACTIONS(4835),
    [anon_sym_L_DQUOTE] = ACTIONS(4835),
    [anon_sym_u_DQUOTE] = ACTIONS(4835),
    [anon_sym_U_DQUOTE] = ACTIONS(4835),
    [anon_sym_u8_DQUOTE] = ACTIONS(4835),
    [anon_sym_DQUOTE] = ACTIONS(4835),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4835),
    [anon_sym_LR_DQUOTE] = ACTIONS(4835),
    [anon_sym_uR_DQUOTE] = ACTIONS(4835),
    [anon_sym_UR_DQUOTE] = ACTIONS(4835),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4835),
    [sym_literal_suffix] = ACTIONS(4833),
  },
  [2274] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1767),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5424),
    [anon_sym_COMMA] = ACTIONS(5424),
    [anon_sym_RPAREN] = ACTIONS(5424),
    [anon_sym_LPAREN2] = ACTIONS(5424),
    [anon_sym_DASH] = ACTIONS(5426),
    [anon_sym_PLUS] = ACTIONS(5426),
    [anon_sym_STAR] = ACTIONS(5424),
    [anon_sym_SLASH] = ACTIONS(5426),
    [anon_sym_PERCENT] = ACTIONS(5424),
    [anon_sym_PIPE_PIPE] = ACTIONS(5424),
    [anon_sym_AMP_AMP] = ACTIONS(5424),
    [anon_sym_PIPE] = ACTIONS(5426),
    [anon_sym_CARET] = ACTIONS(5424),
    [anon_sym_AMP] = ACTIONS(5426),
    [anon_sym_EQ_EQ] = ACTIONS(5424),
    [anon_sym_BANG_EQ] = ACTIONS(5424),
    [anon_sym_GT] = ACTIONS(5426),
    [anon_sym_GT_EQ] = ACTIONS(5424),
    [anon_sym_LT_EQ] = ACTIONS(5426),
    [anon_sym_LT] = ACTIONS(5426),
    [anon_sym_LT_LT] = ACTIONS(5424),
    [anon_sym_GT_GT] = ACTIONS(5424),
    [anon_sym_SEMI] = ACTIONS(5424),
    [anon_sym___extension__] = ACTIONS(5424),
    [anon_sym___attribute__] = ACTIONS(5424),
    [anon_sym_LBRACE] = ACTIONS(5424),
    [anon_sym_RBRACE] = ACTIONS(5424),
    [anon_sym_signed] = ACTIONS(5371),
    [anon_sym_unsigned] = ACTIONS(5371),
    [anon_sym_long] = ACTIONS(5371),
    [anon_sym_short] = ACTIONS(5371),
    [anon_sym_LBRACK] = ACTIONS(5424),
    [anon_sym_RBRACK] = ACTIONS(5424),
    [anon_sym_const] = ACTIONS(5426),
    [anon_sym_constexpr] = ACTIONS(5424),
    [anon_sym_volatile] = ACTIONS(5424),
    [anon_sym_restrict] = ACTIONS(5424),
    [anon_sym___restrict__] = ACTIONS(5424),
    [anon_sym__Atomic] = ACTIONS(5424),
    [anon_sym__Noreturn] = ACTIONS(5424),
    [anon_sym_noreturn] = ACTIONS(5424),
    [anon_sym_mutable] = ACTIONS(5424),
    [anon_sym_constinit] = ACTIONS(5424),
    [anon_sym_consteval] = ACTIONS(5424),
    [anon_sym_PROGMEM] = ACTIONS(5424),
    [anon_sym_COLON] = ACTIONS(5424),
    [anon_sym_QMARK] = ACTIONS(5424),
    [anon_sym_LT_EQ_GT] = ACTIONS(5424),
    [anon_sym_or] = ACTIONS(5424),
    [anon_sym_and] = ACTIONS(5424),
    [anon_sym_bitor] = ACTIONS(5424),
    [anon_sym_xor] = ACTIONS(5424),
    [anon_sym_bitand] = ACTIONS(5424),
    [anon_sym_not_eq] = ACTIONS(5424),
    [anon_sym_DASH_DASH] = ACTIONS(5424),
    [anon_sym_PLUS_PLUS] = ACTIONS(5424),
    [anon_sym_DOT] = ACTIONS(5426),
    [anon_sym_DOT_STAR] = ACTIONS(5424),
    [anon_sym_DASH_GT] = ACTIONS(5424),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5424),
    [anon_sym_decltype] = ACTIONS(5424),
    [anon_sym_final] = ACTIONS(5424),
    [anon_sym_override] = ACTIONS(5424),
    [anon_sym_requires] = ACTIONS(5424),
  },
  [2275] = {
    [sym_identifier] = ACTIONS(5428),
    [anon_sym_LPAREN2] = ACTIONS(5430),
    [anon_sym_TILDE] = ACTIONS(5430),
    [anon_sym_STAR] = ACTIONS(5430),
    [anon_sym_PIPE_PIPE] = ACTIONS(5432),
    [anon_sym_AMP_AMP] = ACTIONS(5434),
    [anon_sym_AMP] = ACTIONS(5428),
    [anon_sym___extension__] = ACTIONS(5428),
    [anon_sym_extern] = ACTIONS(5428),
    [anon_sym___attribute__] = ACTIONS(5428),
    [anon_sym_COLON_COLON] = ACTIONS(5430),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5430),
    [anon_sym___declspec] = ACTIONS(5428),
    [anon_sym___based] = ACTIONS(5428),
    [anon_sym___cdecl] = ACTIONS(5428),
    [anon_sym___clrcall] = ACTIONS(5428),
    [anon_sym___stdcall] = ACTIONS(5428),
    [anon_sym___fastcall] = ACTIONS(5428),
    [anon_sym___thiscall] = ACTIONS(5428),
    [anon_sym___vectorcall] = ACTIONS(5428),
    [anon_sym_signed] = ACTIONS(5428),
    [anon_sym_unsigned] = ACTIONS(5428),
    [anon_sym_long] = ACTIONS(5428),
    [anon_sym_short] = ACTIONS(5428),
    [anon_sym_LBRACK] = ACTIONS(5428),
    [anon_sym_static] = ACTIONS(5428),
    [anon_sym_register] = ACTIONS(5428),
    [anon_sym_inline] = ACTIONS(5428),
    [anon_sym___inline] = ACTIONS(5428),
    [anon_sym___inline__] = ACTIONS(5428),
    [anon_sym___forceinline] = ACTIONS(5428),
    [anon_sym_thread_local] = ACTIONS(5428),
    [anon_sym___thread] = ACTIONS(5428),
    [anon_sym_const] = ACTIONS(5428),
    [anon_sym_constexpr] = ACTIONS(5428),
    [anon_sym_volatile] = ACTIONS(5428),
    [anon_sym_restrict] = ACTIONS(5428),
    [anon_sym___restrict__] = ACTIONS(5428),
    [anon_sym__Atomic] = ACTIONS(5428),
    [anon_sym__Noreturn] = ACTIONS(5428),
    [anon_sym_noreturn] = ACTIONS(5428),
    [anon_sym_mutable] = ACTIONS(5428),
    [anon_sym_constinit] = ACTIONS(5428),
    [anon_sym_consteval] = ACTIONS(5428),
    [anon_sym_PROGMEM] = ACTIONS(5428),
    [aux_sym_primitive_type_token1] = ACTIONS(5428),
    [anon_sym_byte] = ACTIONS(5428),
    [anon_sym_word] = ACTIONS(5428),
    [anon_sym_enum] = ACTIONS(5428),
    [anon_sym_class] = ACTIONS(5428),
    [anon_sym_struct] = ACTIONS(5428),
    [anon_sym_union] = ACTIONS(5428),
    [anon_sym_or] = ACTIONS(5436),
    [anon_sym_and] = ACTIONS(5438),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5428),
    [anon_sym_decltype] = ACTIONS(5428),
    [anon_sym_virtual] = ACTIONS(5428),
    [anon_sym_alignas] = ACTIONS(5428),
    [anon_sym_explicit] = ACTIONS(5428),
    [anon_sym_typename] = ACTIONS(5428),
    [anon_sym_template] = ACTIONS(5428),
    [anon_sym_operator] = ACTIONS(5428),
    [anon_sym_friend] = ACTIONS(5428),
    [anon_sym_using] = ACTIONS(5428),
    [anon_sym_concept] = ACTIONS(5428),
  },
  [2276] = {
    [sym_template_argument_list] = STATE(1741),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2410),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5305),
    [anon_sym_COMMA] = ACTIONS(5305),
    [anon_sym_RPAREN] = ACTIONS(5305),
    [anon_sym_LPAREN2] = ACTIONS(5305),
    [anon_sym_DASH] = ACTIONS(5303),
    [anon_sym_PLUS] = ACTIONS(5303),
    [anon_sym_STAR] = ACTIONS(5303),
    [anon_sym_SLASH] = ACTIONS(5303),
    [anon_sym_PERCENT] = ACTIONS(5303),
    [anon_sym_PIPE_PIPE] = ACTIONS(5305),
    [anon_sym_AMP_AMP] = ACTIONS(5305),
    [anon_sym_PIPE] = ACTIONS(5303),
    [anon_sym_CARET] = ACTIONS(5303),
    [anon_sym_AMP] = ACTIONS(5303),
    [anon_sym_EQ_EQ] = ACTIONS(5305),
    [anon_sym_BANG_EQ] = ACTIONS(5305),
    [anon_sym_GT] = ACTIONS(5303),
    [anon_sym_GT_EQ] = ACTIONS(5305),
    [anon_sym_LT_EQ] = ACTIONS(5303),
    [anon_sym_LT] = ACTIONS(5303),
    [anon_sym_LT_LT] = ACTIONS(5303),
    [anon_sym_GT_GT] = ACTIONS(5303),
    [anon_sym_SEMI] = ACTIONS(5305),
    [anon_sym___attribute__] = ACTIONS(5305),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(5305),
    [anon_sym_RBRACE] = ACTIONS(5305),
    [anon_sym_signed] = ACTIONS(5440),
    [anon_sym_unsigned] = ACTIONS(5440),
    [anon_sym_long] = ACTIONS(5440),
    [anon_sym_short] = ACTIONS(5440),
    [anon_sym_LBRACK] = ACTIONS(5305),
    [anon_sym_RBRACK] = ACTIONS(5305),
    [anon_sym_EQ] = ACTIONS(5303),
    [anon_sym_COLON] = ACTIONS(5303),
    [anon_sym_QMARK] = ACTIONS(5305),
    [anon_sym_STAR_EQ] = ACTIONS(5305),
    [anon_sym_SLASH_EQ] = ACTIONS(5305),
    [anon_sym_PERCENT_EQ] = ACTIONS(5305),
    [anon_sym_PLUS_EQ] = ACTIONS(5305),
    [anon_sym_DASH_EQ] = ACTIONS(5305),
    [anon_sym_LT_LT_EQ] = ACTIONS(5305),
    [anon_sym_GT_GT_EQ] = ACTIONS(5305),
    [anon_sym_AMP_EQ] = ACTIONS(5305),
    [anon_sym_CARET_EQ] = ACTIONS(5305),
    [anon_sym_PIPE_EQ] = ACTIONS(5305),
    [anon_sym_and_eq] = ACTIONS(5305),
    [anon_sym_or_eq] = ACTIONS(5305),
    [anon_sym_xor_eq] = ACTIONS(5305),
    [anon_sym_LT_EQ_GT] = ACTIONS(5305),
    [anon_sym_or] = ACTIONS(5303),
    [anon_sym_and] = ACTIONS(5303),
    [anon_sym_bitor] = ACTIONS(5305),
    [anon_sym_xor] = ACTIONS(5303),
    [anon_sym_bitand] = ACTIONS(5305),
    [anon_sym_not_eq] = ACTIONS(5305),
    [anon_sym_DASH_DASH] = ACTIONS(5305),
    [anon_sym_PLUS_PLUS] = ACTIONS(5305),
    [anon_sym_DOT] = ACTIONS(5303),
    [anon_sym_DOT_STAR] = ACTIONS(5305),
    [anon_sym_DASH_GT] = ACTIONS(5305),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5305),
    [anon_sym_decltype] = ACTIONS(5305),
  },
  [2277] = {
    [sym_attribute_declaration] = STATE(2374),
    [sym_parameter_list] = STATE(2342),
    [aux_sym_attributed_declarator_repeat1] = STATE(2374),
    [sym_identifier] = ACTIONS(5442),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5444),
    [anon_sym_COMMA] = ACTIONS(5444),
    [anon_sym_RPAREN] = ACTIONS(5444),
    [aux_sym_preproc_if_token2] = ACTIONS(5444),
    [aux_sym_preproc_else_token1] = ACTIONS(5444),
    [aux_sym_preproc_elif_token1] = ACTIONS(5442),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5444),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5444),
    [anon_sym_LPAREN2] = ACTIONS(5394),
    [anon_sym_DASH] = ACTIONS(5442),
    [anon_sym_PLUS] = ACTIONS(5442),
    [anon_sym_STAR] = ACTIONS(5442),
    [anon_sym_SLASH] = ACTIONS(5442),
    [anon_sym_PERCENT] = ACTIONS(5442),
    [anon_sym_PIPE_PIPE] = ACTIONS(5444),
    [anon_sym_AMP_AMP] = ACTIONS(5444),
    [anon_sym_PIPE] = ACTIONS(5442),
    [anon_sym_CARET] = ACTIONS(5442),
    [anon_sym_AMP] = ACTIONS(5442),
    [anon_sym_EQ_EQ] = ACTIONS(5444),
    [anon_sym_BANG_EQ] = ACTIONS(5444),
    [anon_sym_GT] = ACTIONS(5442),
    [anon_sym_GT_EQ] = ACTIONS(5444),
    [anon_sym_LT_EQ] = ACTIONS(5442),
    [anon_sym_LT] = ACTIONS(5442),
    [anon_sym_LT_LT] = ACTIONS(5442),
    [anon_sym_GT_GT] = ACTIONS(5442),
    [anon_sym_SEMI] = ACTIONS(5444),
    [anon_sym___attribute__] = ACTIONS(5442),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5396),
    [anon_sym_RBRACE] = ACTIONS(5444),
    [anon_sym_LBRACK] = ACTIONS(5398),
    [anon_sym_RBRACK] = ACTIONS(5444),
    [anon_sym_EQ] = ACTIONS(5442),
    [anon_sym_COLON] = ACTIONS(5444),
    [anon_sym_QMARK] = ACTIONS(5444),
    [anon_sym_STAR_EQ] = ACTIONS(5444),
    [anon_sym_SLASH_EQ] = ACTIONS(5444),
    [anon_sym_PERCENT_EQ] = ACTIONS(5444),
    [anon_sym_PLUS_EQ] = ACTIONS(5444),
    [anon_sym_DASH_EQ] = ACTIONS(5444),
    [anon_sym_LT_LT_EQ] = ACTIONS(5444),
    [anon_sym_GT_GT_EQ] = ACTIONS(5444),
    [anon_sym_AMP_EQ] = ACTIONS(5444),
    [anon_sym_CARET_EQ] = ACTIONS(5444),
    [anon_sym_PIPE_EQ] = ACTIONS(5444),
    [anon_sym_and_eq] = ACTIONS(5442),
    [anon_sym_or_eq] = ACTIONS(5442),
    [anon_sym_xor_eq] = ACTIONS(5442),
    [anon_sym_LT_EQ_GT] = ACTIONS(5444),
    [anon_sym_or] = ACTIONS(5442),
    [anon_sym_and] = ACTIONS(5442),
    [anon_sym_bitor] = ACTIONS(5442),
    [anon_sym_xor] = ACTIONS(5442),
    [anon_sym_bitand] = ACTIONS(5442),
    [anon_sym_not_eq] = ACTIONS(5442),
    [anon_sym_DASH_DASH] = ACTIONS(5444),
    [anon_sym_PLUS_PLUS] = ACTIONS(5444),
    [anon_sym_DOT] = ACTIONS(5442),
    [anon_sym_DOT_STAR] = ACTIONS(5444),
    [anon_sym_DASH_GT] = ACTIONS(5444),
    [sym_comment] = ACTIONS(3),
  },
  [2278] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2262),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5107),
    [anon_sym_COMMA] = ACTIONS(5107),
    [anon_sym_RPAREN] = ACTIONS(5107),
    [anon_sym_LPAREN2] = ACTIONS(5107),
    [anon_sym_DASH] = ACTIONS(5105),
    [anon_sym_PLUS] = ACTIONS(5105),
    [anon_sym_STAR] = ACTIONS(5107),
    [anon_sym_SLASH] = ACTIONS(5105),
    [anon_sym_PERCENT] = ACTIONS(5107),
    [anon_sym_PIPE_PIPE] = ACTIONS(5107),
    [anon_sym_AMP_AMP] = ACTIONS(5107),
    [anon_sym_PIPE] = ACTIONS(5105),
    [anon_sym_CARET] = ACTIONS(5107),
    [anon_sym_AMP] = ACTIONS(5105),
    [anon_sym_EQ_EQ] = ACTIONS(5107),
    [anon_sym_BANG_EQ] = ACTIONS(5107),
    [anon_sym_GT] = ACTIONS(5105),
    [anon_sym_GT_EQ] = ACTIONS(5107),
    [anon_sym_LT_EQ] = ACTIONS(5105),
    [anon_sym_LT] = ACTIONS(5105),
    [anon_sym_LT_LT] = ACTIONS(5107),
    [anon_sym_GT_GT] = ACTIONS(5107),
    [anon_sym_SEMI] = ACTIONS(5107),
    [anon_sym___extension__] = ACTIONS(5107),
    [anon_sym___attribute__] = ACTIONS(5107),
    [anon_sym_LBRACE] = ACTIONS(5107),
    [anon_sym_RBRACE] = ACTIONS(5107),
    [anon_sym_signed] = ACTIONS(5446),
    [anon_sym_unsigned] = ACTIONS(5446),
    [anon_sym_long] = ACTIONS(5446),
    [anon_sym_short] = ACTIONS(5446),
    [anon_sym_LBRACK] = ACTIONS(5107),
    [anon_sym_RBRACK] = ACTIONS(5107),
    [anon_sym_const] = ACTIONS(5105),
    [anon_sym_constexpr] = ACTIONS(5107),
    [anon_sym_volatile] = ACTIONS(5107),
    [anon_sym_restrict] = ACTIONS(5107),
    [anon_sym___restrict__] = ACTIONS(5107),
    [anon_sym__Atomic] = ACTIONS(5107),
    [anon_sym__Noreturn] = ACTIONS(5107),
    [anon_sym_noreturn] = ACTIONS(5107),
    [anon_sym_mutable] = ACTIONS(5107),
    [anon_sym_constinit] = ACTIONS(5107),
    [anon_sym_consteval] = ACTIONS(5107),
    [anon_sym_PROGMEM] = ACTIONS(5107),
    [anon_sym_COLON] = ACTIONS(5107),
    [anon_sym_QMARK] = ACTIONS(5107),
    [anon_sym_LT_EQ_GT] = ACTIONS(5107),
    [anon_sym_or] = ACTIONS(5107),
    [anon_sym_and] = ACTIONS(5107),
    [anon_sym_bitor] = ACTIONS(5107),
    [anon_sym_xor] = ACTIONS(5107),
    [anon_sym_bitand] = ACTIONS(5107),
    [anon_sym_not_eq] = ACTIONS(5107),
    [anon_sym_DASH_DASH] = ACTIONS(5107),
    [anon_sym_PLUS_PLUS] = ACTIONS(5107),
    [anon_sym_DOT] = ACTIONS(5105),
    [anon_sym_DOT_STAR] = ACTIONS(5107),
    [anon_sym_DASH_GT] = ACTIONS(5107),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5107),
    [anon_sym_decltype] = ACTIONS(5107),
    [anon_sym_final] = ACTIONS(5107),
    [anon_sym_override] = ACTIONS(5107),
    [anon_sym_requires] = ACTIONS(5107),
  },
  [2279] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4812),
    [anon_sym_COMMA] = ACTIONS(4812),
    [anon_sym_RPAREN] = ACTIONS(4812),
    [anon_sym_LPAREN2] = ACTIONS(4812),
    [anon_sym_DASH] = ACTIONS(4810),
    [anon_sym_PLUS] = ACTIONS(4810),
    [anon_sym_STAR] = ACTIONS(4810),
    [anon_sym_SLASH] = ACTIONS(4810),
    [anon_sym_PERCENT] = ACTIONS(4810),
    [anon_sym_PIPE_PIPE] = ACTIONS(4812),
    [anon_sym_AMP_AMP] = ACTIONS(4812),
    [anon_sym_PIPE] = ACTIONS(4810),
    [anon_sym_CARET] = ACTIONS(4810),
    [anon_sym_AMP] = ACTIONS(4810),
    [anon_sym_EQ_EQ] = ACTIONS(4812),
    [anon_sym_BANG_EQ] = ACTIONS(4812),
    [anon_sym_GT] = ACTIONS(4810),
    [anon_sym_GT_EQ] = ACTIONS(4812),
    [anon_sym_LT_EQ] = ACTIONS(4810),
    [anon_sym_LT] = ACTIONS(4810),
    [anon_sym_LT_LT] = ACTIONS(4810),
    [anon_sym_GT_GT] = ACTIONS(4810),
    [anon_sym_SEMI] = ACTIONS(4812),
    [anon_sym_RBRACE] = ACTIONS(4812),
    [anon_sym_LBRACK] = ACTIONS(4812),
    [anon_sym_RBRACK] = ACTIONS(4812),
    [anon_sym_EQ] = ACTIONS(4810),
    [anon_sym_COLON] = ACTIONS(4812),
    [anon_sym_QMARK] = ACTIONS(4812),
    [anon_sym_STAR_EQ] = ACTIONS(4812),
    [anon_sym_SLASH_EQ] = ACTIONS(4812),
    [anon_sym_PERCENT_EQ] = ACTIONS(4812),
    [anon_sym_PLUS_EQ] = ACTIONS(4812),
    [anon_sym_DASH_EQ] = ACTIONS(4812),
    [anon_sym_LT_LT_EQ] = ACTIONS(4812),
    [anon_sym_GT_GT_EQ] = ACTIONS(4812),
    [anon_sym_AMP_EQ] = ACTIONS(4812),
    [anon_sym_CARET_EQ] = ACTIONS(4812),
    [anon_sym_PIPE_EQ] = ACTIONS(4812),
    [anon_sym_and_eq] = ACTIONS(4810),
    [anon_sym_or_eq] = ACTIONS(4810),
    [anon_sym_xor_eq] = ACTIONS(4810),
    [anon_sym_LT_EQ_GT] = ACTIONS(4812),
    [anon_sym_or] = ACTIONS(4810),
    [anon_sym_and] = ACTIONS(4810),
    [anon_sym_bitor] = ACTIONS(4810),
    [anon_sym_xor] = ACTIONS(4810),
    [anon_sym_bitand] = ACTIONS(4810),
    [anon_sym_not_eq] = ACTIONS(4810),
    [anon_sym_DASH_DASH] = ACTIONS(4812),
    [anon_sym_PLUS_PLUS] = ACTIONS(4812),
    [anon_sym_DOT] = ACTIONS(4810),
    [anon_sym_DOT_STAR] = ACTIONS(4812),
    [anon_sym_DASH_GT] = ACTIONS(4812),
    [anon_sym_L_DQUOTE] = ACTIONS(4812),
    [anon_sym_u_DQUOTE] = ACTIONS(4812),
    [anon_sym_U_DQUOTE] = ACTIONS(4812),
    [anon_sym_u8_DQUOTE] = ACTIONS(4812),
    [anon_sym_DQUOTE] = ACTIONS(4812),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4812),
    [anon_sym_LR_DQUOTE] = ACTIONS(4812),
    [anon_sym_uR_DQUOTE] = ACTIONS(4812),
    [anon_sym_UR_DQUOTE] = ACTIONS(4812),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4812),
    [sym_literal_suffix] = ACTIONS(4810),
  },
  [2280] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1767),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5448),
    [anon_sym_COMMA] = ACTIONS(5448),
    [anon_sym_RPAREN] = ACTIONS(5448),
    [anon_sym_LPAREN2] = ACTIONS(5448),
    [anon_sym_DASH] = ACTIONS(5450),
    [anon_sym_PLUS] = ACTIONS(5450),
    [anon_sym_STAR] = ACTIONS(5448),
    [anon_sym_SLASH] = ACTIONS(5450),
    [anon_sym_PERCENT] = ACTIONS(5448),
    [anon_sym_PIPE_PIPE] = ACTIONS(5448),
    [anon_sym_AMP_AMP] = ACTIONS(5448),
    [anon_sym_PIPE] = ACTIONS(5450),
    [anon_sym_CARET] = ACTIONS(5448),
    [anon_sym_AMP] = ACTIONS(5450),
    [anon_sym_EQ_EQ] = ACTIONS(5448),
    [anon_sym_BANG_EQ] = ACTIONS(5448),
    [anon_sym_GT] = ACTIONS(5450),
    [anon_sym_GT_EQ] = ACTIONS(5448),
    [anon_sym_LT_EQ] = ACTIONS(5450),
    [anon_sym_LT] = ACTIONS(5450),
    [anon_sym_LT_LT] = ACTIONS(5448),
    [anon_sym_GT_GT] = ACTIONS(5448),
    [anon_sym_SEMI] = ACTIONS(5448),
    [anon_sym___extension__] = ACTIONS(5448),
    [anon_sym___attribute__] = ACTIONS(5448),
    [anon_sym_LBRACE] = ACTIONS(5448),
    [anon_sym_RBRACE] = ACTIONS(5448),
    [anon_sym_signed] = ACTIONS(5371),
    [anon_sym_unsigned] = ACTIONS(5371),
    [anon_sym_long] = ACTIONS(5371),
    [anon_sym_short] = ACTIONS(5371),
    [anon_sym_LBRACK] = ACTIONS(5448),
    [anon_sym_RBRACK] = ACTIONS(5448),
    [anon_sym_const] = ACTIONS(5450),
    [anon_sym_constexpr] = ACTIONS(5448),
    [anon_sym_volatile] = ACTIONS(5448),
    [anon_sym_restrict] = ACTIONS(5448),
    [anon_sym___restrict__] = ACTIONS(5448),
    [anon_sym__Atomic] = ACTIONS(5448),
    [anon_sym__Noreturn] = ACTIONS(5448),
    [anon_sym_noreturn] = ACTIONS(5448),
    [anon_sym_mutable] = ACTIONS(5448),
    [anon_sym_constinit] = ACTIONS(5448),
    [anon_sym_consteval] = ACTIONS(5448),
    [anon_sym_PROGMEM] = ACTIONS(5448),
    [anon_sym_COLON] = ACTIONS(5448),
    [anon_sym_QMARK] = ACTIONS(5448),
    [anon_sym_LT_EQ_GT] = ACTIONS(5448),
    [anon_sym_or] = ACTIONS(5448),
    [anon_sym_and] = ACTIONS(5448),
    [anon_sym_bitor] = ACTIONS(5448),
    [anon_sym_xor] = ACTIONS(5448),
    [anon_sym_bitand] = ACTIONS(5448),
    [anon_sym_not_eq] = ACTIONS(5448),
    [anon_sym_DASH_DASH] = ACTIONS(5448),
    [anon_sym_PLUS_PLUS] = ACTIONS(5448),
    [anon_sym_DOT] = ACTIONS(5450),
    [anon_sym_DOT_STAR] = ACTIONS(5448),
    [anon_sym_DASH_GT] = ACTIONS(5448),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5448),
    [anon_sym_decltype] = ACTIONS(5448),
    [anon_sym_final] = ACTIONS(5448),
    [anon_sym_override] = ACTIONS(5448),
    [anon_sym_requires] = ACTIONS(5448),
  },
  [2281] = {
    [sym_attribute_specifier] = STATE(2334),
    [sym_identifier] = ACTIONS(5452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5454),
    [anon_sym_COMMA] = ACTIONS(5454),
    [anon_sym_RPAREN] = ACTIONS(5454),
    [aux_sym_preproc_if_token2] = ACTIONS(5454),
    [aux_sym_preproc_else_token1] = ACTIONS(5454),
    [aux_sym_preproc_elif_token1] = ACTIONS(5452),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5454),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5454),
    [anon_sym_LPAREN2] = ACTIONS(5454),
    [anon_sym_DASH] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5452),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_SLASH] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5454),
    [anon_sym_AMP_AMP] = ACTIONS(5454),
    [anon_sym_PIPE] = ACTIONS(5452),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5452),
    [anon_sym_EQ_EQ] = ACTIONS(5454),
    [anon_sym_BANG_EQ] = ACTIONS(5454),
    [anon_sym_GT] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5454),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5452),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [anon_sym_GT_GT] = ACTIONS(5452),
    [anon_sym_SEMI] = ACTIONS(5454),
    [anon_sym___attribute__] = ACTIONS(4906),
    [anon_sym_LBRACE] = ACTIONS(5454),
    [anon_sym_RBRACE] = ACTIONS(5454),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_RBRACK] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(5452),
    [anon_sym_COLON] = ACTIONS(5454),
    [anon_sym_QMARK] = ACTIONS(5454),
    [anon_sym_STAR_EQ] = ACTIONS(5454),
    [anon_sym_SLASH_EQ] = ACTIONS(5454),
    [anon_sym_PERCENT_EQ] = ACTIONS(5454),
    [anon_sym_PLUS_EQ] = ACTIONS(5454),
    [anon_sym_DASH_EQ] = ACTIONS(5454),
    [anon_sym_LT_LT_EQ] = ACTIONS(5454),
    [anon_sym_GT_GT_EQ] = ACTIONS(5454),
    [anon_sym_AMP_EQ] = ACTIONS(5454),
    [anon_sym_CARET_EQ] = ACTIONS(5454),
    [anon_sym_PIPE_EQ] = ACTIONS(5454),
    [anon_sym_and_eq] = ACTIONS(5452),
    [anon_sym_or_eq] = ACTIONS(5452),
    [anon_sym_xor_eq] = ACTIONS(5452),
    [anon_sym_LT_EQ_GT] = ACTIONS(5454),
    [anon_sym_or] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5452),
    [anon_sym_bitor] = ACTIONS(5452),
    [anon_sym_xor] = ACTIONS(5452),
    [anon_sym_bitand] = ACTIONS(5452),
    [anon_sym_not_eq] = ACTIONS(5452),
    [anon_sym_DASH_DASH] = ACTIONS(5454),
    [anon_sym_PLUS_PLUS] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(5452),
    [anon_sym_DOT_STAR] = ACTIONS(5454),
    [anon_sym_DASH_GT] = ACTIONS(5454),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5452),
    [anon_sym_decltype] = ACTIONS(5452),
  },
  [2282] = {
    [sym_identifier] = ACTIONS(4918),
    [anon_sym_LPAREN2] = ACTIONS(4920),
    [anon_sym_TILDE] = ACTIONS(4920),
    [anon_sym_STAR] = ACTIONS(4920),
    [anon_sym_PIPE_PIPE] = ACTIONS(4920),
    [anon_sym_AMP_AMP] = ACTIONS(4920),
    [anon_sym_AMP] = ACTIONS(4918),
    [anon_sym___extension__] = ACTIONS(4918),
    [anon_sym_extern] = ACTIONS(4918),
    [anon_sym___attribute__] = ACTIONS(4918),
    [anon_sym_COLON_COLON] = ACTIONS(4922),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4920),
    [anon_sym___declspec] = ACTIONS(4918),
    [anon_sym___based] = ACTIONS(4918),
    [anon_sym___cdecl] = ACTIONS(4918),
    [anon_sym___clrcall] = ACTIONS(4918),
    [anon_sym___stdcall] = ACTIONS(4918),
    [anon_sym___fastcall] = ACTIONS(4918),
    [anon_sym___thiscall] = ACTIONS(4918),
    [anon_sym___vectorcall] = ACTIONS(4918),
    [anon_sym_signed] = ACTIONS(4918),
    [anon_sym_unsigned] = ACTIONS(4918),
    [anon_sym_long] = ACTIONS(4918),
    [anon_sym_short] = ACTIONS(4918),
    [anon_sym_LBRACK] = ACTIONS(4918),
    [anon_sym_static] = ACTIONS(4918),
    [anon_sym_register] = ACTIONS(4918),
    [anon_sym_inline] = ACTIONS(4918),
    [anon_sym___inline] = ACTIONS(4918),
    [anon_sym___inline__] = ACTIONS(4918),
    [anon_sym___forceinline] = ACTIONS(4918),
    [anon_sym_thread_local] = ACTIONS(4918),
    [anon_sym___thread] = ACTIONS(4918),
    [anon_sym_const] = ACTIONS(4918),
    [anon_sym_constexpr] = ACTIONS(4918),
    [anon_sym_volatile] = ACTIONS(4918),
    [anon_sym_restrict] = ACTIONS(4918),
    [anon_sym___restrict__] = ACTIONS(4918),
    [anon_sym__Atomic] = ACTIONS(4918),
    [anon_sym__Noreturn] = ACTIONS(4918),
    [anon_sym_noreturn] = ACTIONS(4918),
    [anon_sym_mutable] = ACTIONS(4918),
    [anon_sym_constinit] = ACTIONS(4918),
    [anon_sym_consteval] = ACTIONS(4918),
    [anon_sym_PROGMEM] = ACTIONS(4918),
    [aux_sym_primitive_type_token1] = ACTIONS(4918),
    [anon_sym_byte] = ACTIONS(4918),
    [anon_sym_word] = ACTIONS(4918),
    [anon_sym_enum] = ACTIONS(4918),
    [anon_sym_class] = ACTIONS(4918),
    [anon_sym_struct] = ACTIONS(4918),
    [anon_sym_union] = ACTIONS(4918),
    [anon_sym_or] = ACTIONS(4918),
    [anon_sym_and] = ACTIONS(4918),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4918),
    [anon_sym_decltype] = ACTIONS(4918),
    [anon_sym_virtual] = ACTIONS(4918),
    [anon_sym_alignas] = ACTIONS(4918),
    [anon_sym_explicit] = ACTIONS(4918),
    [anon_sym_typename] = ACTIONS(4918),
    [anon_sym_template] = ACTIONS(4918),
    [anon_sym_operator] = ACTIONS(4918),
    [anon_sym_friend] = ACTIONS(4918),
    [anon_sym_using] = ACTIONS(4918),
    [anon_sym_concept] = ACTIONS(4918),
  },
  [2283] = {
    [sym_attribute_specifier] = STATE(2318),
    [sym_identifier] = ACTIONS(5456),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5458),
    [anon_sym_COMMA] = ACTIONS(5458),
    [anon_sym_RPAREN] = ACTIONS(5458),
    [aux_sym_preproc_if_token2] = ACTIONS(5458),
    [aux_sym_preproc_else_token1] = ACTIONS(5458),
    [aux_sym_preproc_elif_token1] = ACTIONS(5456),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5458),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5458),
    [anon_sym_LPAREN2] = ACTIONS(5458),
    [anon_sym_DASH] = ACTIONS(5456),
    [anon_sym_PLUS] = ACTIONS(5456),
    [anon_sym_STAR] = ACTIONS(5456),
    [anon_sym_SLASH] = ACTIONS(5456),
    [anon_sym_PERCENT] = ACTIONS(5456),
    [anon_sym_PIPE_PIPE] = ACTIONS(5458),
    [anon_sym_AMP_AMP] = ACTIONS(5458),
    [anon_sym_PIPE] = ACTIONS(5456),
    [anon_sym_CARET] = ACTIONS(5456),
    [anon_sym_AMP] = ACTIONS(5456),
    [anon_sym_EQ_EQ] = ACTIONS(5458),
    [anon_sym_BANG_EQ] = ACTIONS(5458),
    [anon_sym_GT] = ACTIONS(5456),
    [anon_sym_GT_EQ] = ACTIONS(5458),
    [anon_sym_LT_EQ] = ACTIONS(5456),
    [anon_sym_LT] = ACTIONS(5456),
    [anon_sym_LT_LT] = ACTIONS(5456),
    [anon_sym_GT_GT] = ACTIONS(5456),
    [anon_sym_SEMI] = ACTIONS(5458),
    [anon_sym___attribute__] = ACTIONS(4906),
    [anon_sym_LBRACE] = ACTIONS(5458),
    [anon_sym_RBRACE] = ACTIONS(5458),
    [anon_sym_LBRACK] = ACTIONS(5458),
    [anon_sym_RBRACK] = ACTIONS(5458),
    [anon_sym_EQ] = ACTIONS(5456),
    [anon_sym_COLON] = ACTIONS(5458),
    [anon_sym_QMARK] = ACTIONS(5458),
    [anon_sym_STAR_EQ] = ACTIONS(5458),
    [anon_sym_SLASH_EQ] = ACTIONS(5458),
    [anon_sym_PERCENT_EQ] = ACTIONS(5458),
    [anon_sym_PLUS_EQ] = ACTIONS(5458),
    [anon_sym_DASH_EQ] = ACTIONS(5458),
    [anon_sym_LT_LT_EQ] = ACTIONS(5458),
    [anon_sym_GT_GT_EQ] = ACTIONS(5458),
    [anon_sym_AMP_EQ] = ACTIONS(5458),
    [anon_sym_CARET_EQ] = ACTIONS(5458),
    [anon_sym_PIPE_EQ] = ACTIONS(5458),
    [anon_sym_and_eq] = ACTIONS(5456),
    [anon_sym_or_eq] = ACTIONS(5456),
    [anon_sym_xor_eq] = ACTIONS(5456),
    [anon_sym_LT_EQ_GT] = ACTIONS(5458),
    [anon_sym_or] = ACTIONS(5456),
    [anon_sym_and] = ACTIONS(5456),
    [anon_sym_bitor] = ACTIONS(5456),
    [anon_sym_xor] = ACTIONS(5456),
    [anon_sym_bitand] = ACTIONS(5456),
    [anon_sym_not_eq] = ACTIONS(5456),
    [anon_sym_DASH_DASH] = ACTIONS(5458),
    [anon_sym_PLUS_PLUS] = ACTIONS(5458),
    [anon_sym_DOT] = ACTIONS(5456),
    [anon_sym_DOT_STAR] = ACTIONS(5458),
    [anon_sym_DASH_GT] = ACTIONS(5458),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5456),
    [anon_sym_decltype] = ACTIONS(5456),
  },
  [2284] = {
    [sym_identifier] = ACTIONS(4928),
    [anon_sym_LPAREN2] = ACTIONS(4930),
    [anon_sym_TILDE] = ACTIONS(4930),
    [anon_sym_STAR] = ACTIONS(4930),
    [anon_sym_PIPE_PIPE] = ACTIONS(4930),
    [anon_sym_AMP_AMP] = ACTIONS(4930),
    [anon_sym_AMP] = ACTIONS(4928),
    [anon_sym___extension__] = ACTIONS(4928),
    [anon_sym_extern] = ACTIONS(4928),
    [anon_sym___attribute__] = ACTIONS(4928),
    [anon_sym_COLON_COLON] = ACTIONS(4930),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4930),
    [anon_sym___declspec] = ACTIONS(4928),
    [anon_sym___based] = ACTIONS(4928),
    [anon_sym___cdecl] = ACTIONS(4928),
    [anon_sym___clrcall] = ACTIONS(4928),
    [anon_sym___stdcall] = ACTIONS(4928),
    [anon_sym___fastcall] = ACTIONS(4928),
    [anon_sym___thiscall] = ACTIONS(4928),
    [anon_sym___vectorcall] = ACTIONS(4928),
    [anon_sym_signed] = ACTIONS(4928),
    [anon_sym_unsigned] = ACTIONS(4928),
    [anon_sym_long] = ACTIONS(4928),
    [anon_sym_short] = ACTIONS(4928),
    [anon_sym_LBRACK] = ACTIONS(4928),
    [anon_sym_static] = ACTIONS(4928),
    [anon_sym_register] = ACTIONS(4928),
    [anon_sym_inline] = ACTIONS(4928),
    [anon_sym___inline] = ACTIONS(4928),
    [anon_sym___inline__] = ACTIONS(4928),
    [anon_sym___forceinline] = ACTIONS(4928),
    [anon_sym_thread_local] = ACTIONS(4928),
    [anon_sym___thread] = ACTIONS(4928),
    [anon_sym_const] = ACTIONS(4928),
    [anon_sym_constexpr] = ACTIONS(4928),
    [anon_sym_volatile] = ACTIONS(4928),
    [anon_sym_restrict] = ACTIONS(4928),
    [anon_sym___restrict__] = ACTIONS(4928),
    [anon_sym__Atomic] = ACTIONS(4928),
    [anon_sym__Noreturn] = ACTIONS(4928),
    [anon_sym_noreturn] = ACTIONS(4928),
    [anon_sym_mutable] = ACTIONS(4928),
    [anon_sym_constinit] = ACTIONS(4928),
    [anon_sym_consteval] = ACTIONS(4928),
    [anon_sym_PROGMEM] = ACTIONS(4928),
    [aux_sym_primitive_type_token1] = ACTIONS(4928),
    [anon_sym_byte] = ACTIONS(4928),
    [anon_sym_word] = ACTIONS(4928),
    [anon_sym_enum] = ACTIONS(4928),
    [anon_sym_class] = ACTIONS(4928),
    [anon_sym_struct] = ACTIONS(4928),
    [anon_sym_union] = ACTIONS(4928),
    [anon_sym_or] = ACTIONS(4928),
    [anon_sym_and] = ACTIONS(4928),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4928),
    [anon_sym_decltype] = ACTIONS(4928),
    [anon_sym_virtual] = ACTIONS(4928),
    [anon_sym_alignas] = ACTIONS(4928),
    [anon_sym_explicit] = ACTIONS(4928),
    [anon_sym_typename] = ACTIONS(4928),
    [anon_sym_template] = ACTIONS(4928),
    [anon_sym_operator] = ACTIONS(4928),
    [anon_sym_friend] = ACTIONS(4928),
    [anon_sym_using] = ACTIONS(4928),
    [anon_sym_concept] = ACTIONS(4928),
  },
  [2285] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2306),
    [sym_identifier] = ACTIONS(4766),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5139),
    [anon_sym_COMMA] = ACTIONS(5139),
    [anon_sym_LPAREN2] = ACTIONS(5139),
    [anon_sym_DASH] = ACTIONS(5142),
    [anon_sym_PLUS] = ACTIONS(5142),
    [anon_sym_STAR] = ACTIONS(5139),
    [anon_sym_SLASH] = ACTIONS(5142),
    [anon_sym_PERCENT] = ACTIONS(5139),
    [anon_sym_PIPE_PIPE] = ACTIONS(5139),
    [anon_sym_AMP_AMP] = ACTIONS(5139),
    [anon_sym_PIPE] = ACTIONS(5142),
    [anon_sym_CARET] = ACTIONS(5139),
    [anon_sym_AMP] = ACTIONS(5142),
    [anon_sym_EQ_EQ] = ACTIONS(5139),
    [anon_sym_BANG_EQ] = ACTIONS(5139),
    [anon_sym_GT] = ACTIONS(5142),
    [anon_sym_GT_EQ] = ACTIONS(5142),
    [anon_sym_LT_EQ] = ACTIONS(5142),
    [anon_sym_LT] = ACTIONS(5142),
    [anon_sym_LT_LT] = ACTIONS(5139),
    [anon_sym_GT_GT] = ACTIONS(5142),
    [anon_sym___extension__] = ACTIONS(5142),
    [anon_sym___attribute__] = ACTIONS(5142),
    [anon_sym_LBRACE] = ACTIONS(5139),
    [anon_sym_signed] = ACTIONS(5460),
    [anon_sym_unsigned] = ACTIONS(5460),
    [anon_sym_long] = ACTIONS(5460),
    [anon_sym_short] = ACTIONS(5460),
    [anon_sym_LBRACK] = ACTIONS(5139),
    [anon_sym_const] = ACTIONS(5142),
    [anon_sym_constexpr] = ACTIONS(5142),
    [anon_sym_volatile] = ACTIONS(5142),
    [anon_sym_restrict] = ACTIONS(5142),
    [anon_sym___restrict__] = ACTIONS(5142),
    [anon_sym__Atomic] = ACTIONS(5142),
    [anon_sym__Noreturn] = ACTIONS(5142),
    [anon_sym_noreturn] = ACTIONS(5142),
    [anon_sym_mutable] = ACTIONS(5142),
    [anon_sym_constinit] = ACTIONS(5142),
    [anon_sym_consteval] = ACTIONS(5142),
    [anon_sym_PROGMEM] = ACTIONS(5142),
    [aux_sym_primitive_type_token1] = ACTIONS(4766),
    [anon_sym_byte] = ACTIONS(4766),
    [anon_sym_word] = ACTIONS(4766),
    [anon_sym_QMARK] = ACTIONS(5139),
    [anon_sym_LT_EQ_GT] = ACTIONS(5139),
    [anon_sym_or] = ACTIONS(5142),
    [anon_sym_and] = ACTIONS(5142),
    [anon_sym_bitor] = ACTIONS(5142),
    [anon_sym_xor] = ACTIONS(5142),
    [anon_sym_bitand] = ACTIONS(5142),
    [anon_sym_not_eq] = ACTIONS(5142),
    [anon_sym_DASH_DASH] = ACTIONS(5139),
    [anon_sym_PLUS_PLUS] = ACTIONS(5139),
    [anon_sym_DOT] = ACTIONS(5142),
    [anon_sym_DOT_STAR] = ACTIONS(5139),
    [anon_sym_DASH_GT] = ACTIONS(5139),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5142),
    [anon_sym_decltype] = ACTIONS(5142),
    [anon_sym_final] = ACTIONS(5142),
    [anon_sym_override] = ACTIONS(5142),
    [anon_sym_GT2] = ACTIONS(5139),
    [anon_sym_requires] = ACTIONS(5142),
  },
  [2286] = {
    [sym_identifier] = ACTIONS(4563),
    [anon_sym_LPAREN2] = ACTIONS(4565),
    [anon_sym_TILDE] = ACTIONS(4565),
    [anon_sym_STAR] = ACTIONS(4565),
    [anon_sym_PIPE_PIPE] = ACTIONS(4565),
    [anon_sym_AMP_AMP] = ACTIONS(4565),
    [anon_sym_AMP] = ACTIONS(4563),
    [anon_sym___extension__] = ACTIONS(4563),
    [anon_sym_extern] = ACTIONS(4563),
    [anon_sym___attribute__] = ACTIONS(4563),
    [anon_sym_COLON_COLON] = ACTIONS(4565),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4565),
    [anon_sym___declspec] = ACTIONS(4563),
    [anon_sym___based] = ACTIONS(4563),
    [anon_sym___cdecl] = ACTIONS(4563),
    [anon_sym___clrcall] = ACTIONS(4563),
    [anon_sym___stdcall] = ACTIONS(4563),
    [anon_sym___fastcall] = ACTIONS(4563),
    [anon_sym___thiscall] = ACTIONS(4563),
    [anon_sym___vectorcall] = ACTIONS(4563),
    [anon_sym_signed] = ACTIONS(4563),
    [anon_sym_unsigned] = ACTIONS(4563),
    [anon_sym_long] = ACTIONS(4563),
    [anon_sym_short] = ACTIONS(4563),
    [anon_sym_LBRACK] = ACTIONS(4563),
    [anon_sym_static] = ACTIONS(4563),
    [anon_sym_register] = ACTIONS(4563),
    [anon_sym_inline] = ACTIONS(4563),
    [anon_sym___inline] = ACTIONS(4563),
    [anon_sym___inline__] = ACTIONS(4563),
    [anon_sym___forceinline] = ACTIONS(4563),
    [anon_sym_thread_local] = ACTIONS(4563),
    [anon_sym___thread] = ACTIONS(4563),
    [anon_sym_const] = ACTIONS(4563),
    [anon_sym_constexpr] = ACTIONS(4563),
    [anon_sym_volatile] = ACTIONS(4563),
    [anon_sym_restrict] = ACTIONS(4563),
    [anon_sym___restrict__] = ACTIONS(4563),
    [anon_sym__Atomic] = ACTIONS(4563),
    [anon_sym__Noreturn] = ACTIONS(4563),
    [anon_sym_noreturn] = ACTIONS(4563),
    [anon_sym_mutable] = ACTIONS(4563),
    [anon_sym_constinit] = ACTIONS(4563),
    [anon_sym_consteval] = ACTIONS(4563),
    [anon_sym_PROGMEM] = ACTIONS(4563),
    [aux_sym_primitive_type_token1] = ACTIONS(4563),
    [anon_sym_byte] = ACTIONS(4563),
    [anon_sym_word] = ACTIONS(4563),
    [anon_sym_enum] = ACTIONS(4563),
    [anon_sym_class] = ACTIONS(4563),
    [anon_sym_struct] = ACTIONS(4563),
    [anon_sym_union] = ACTIONS(4563),
    [anon_sym_or] = ACTIONS(4563),
    [anon_sym_and] = ACTIONS(4563),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4563),
    [anon_sym_decltype] = ACTIONS(4563),
    [anon_sym_virtual] = ACTIONS(4563),
    [anon_sym_alignas] = ACTIONS(4563),
    [anon_sym_explicit] = ACTIONS(4563),
    [anon_sym_typename] = ACTIONS(4563),
    [anon_sym_template] = ACTIONS(4563),
    [anon_sym_operator] = ACTIONS(4563),
    [anon_sym_friend] = ACTIONS(4563),
    [anon_sym_using] = ACTIONS(4563),
    [anon_sym_concept] = ACTIONS(4563),
  },
  [2287] = {
    [sym_identifier] = ACTIONS(4567),
    [anon_sym_LPAREN2] = ACTIONS(4569),
    [anon_sym_TILDE] = ACTIONS(4569),
    [anon_sym_STAR] = ACTIONS(4569),
    [anon_sym_PIPE_PIPE] = ACTIONS(4569),
    [anon_sym_AMP_AMP] = ACTIONS(4569),
    [anon_sym_AMP] = ACTIONS(4567),
    [anon_sym___extension__] = ACTIONS(4567),
    [anon_sym_extern] = ACTIONS(4567),
    [anon_sym___attribute__] = ACTIONS(4567),
    [anon_sym_COLON_COLON] = ACTIONS(4569),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4569),
    [anon_sym___declspec] = ACTIONS(4567),
    [anon_sym___based] = ACTIONS(4567),
    [anon_sym___cdecl] = ACTIONS(4567),
    [anon_sym___clrcall] = ACTIONS(4567),
    [anon_sym___stdcall] = ACTIONS(4567),
    [anon_sym___fastcall] = ACTIONS(4567),
    [anon_sym___thiscall] = ACTIONS(4567),
    [anon_sym___vectorcall] = ACTIONS(4567),
    [anon_sym_signed] = ACTIONS(4567),
    [anon_sym_unsigned] = ACTIONS(4567),
    [anon_sym_long] = ACTIONS(4567),
    [anon_sym_short] = ACTIONS(4567),
    [anon_sym_LBRACK] = ACTIONS(4567),
    [anon_sym_static] = ACTIONS(4567),
    [anon_sym_register] = ACTIONS(4567),
    [anon_sym_inline] = ACTIONS(4567),
    [anon_sym___inline] = ACTIONS(4567),
    [anon_sym___inline__] = ACTIONS(4567),
    [anon_sym___forceinline] = ACTIONS(4567),
    [anon_sym_thread_local] = ACTIONS(4567),
    [anon_sym___thread] = ACTIONS(4567),
    [anon_sym_const] = ACTIONS(4567),
    [anon_sym_constexpr] = ACTIONS(4567),
    [anon_sym_volatile] = ACTIONS(4567),
    [anon_sym_restrict] = ACTIONS(4567),
    [anon_sym___restrict__] = ACTIONS(4567),
    [anon_sym__Atomic] = ACTIONS(4567),
    [anon_sym__Noreturn] = ACTIONS(4567),
    [anon_sym_noreturn] = ACTIONS(4567),
    [anon_sym_mutable] = ACTIONS(4567),
    [anon_sym_constinit] = ACTIONS(4567),
    [anon_sym_consteval] = ACTIONS(4567),
    [anon_sym_PROGMEM] = ACTIONS(4567),
    [aux_sym_primitive_type_token1] = ACTIONS(4567),
    [anon_sym_byte] = ACTIONS(4567),
    [anon_sym_word] = ACTIONS(4567),
    [anon_sym_enum] = ACTIONS(4567),
    [anon_sym_class] = ACTIONS(4567),
    [anon_sym_struct] = ACTIONS(4567),
    [anon_sym_union] = ACTIONS(4567),
    [anon_sym_or] = ACTIONS(4567),
    [anon_sym_and] = ACTIONS(4567),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4567),
    [anon_sym_decltype] = ACTIONS(4567),
    [anon_sym_virtual] = ACTIONS(4567),
    [anon_sym_alignas] = ACTIONS(4567),
    [anon_sym_explicit] = ACTIONS(4567),
    [anon_sym_typename] = ACTIONS(4567),
    [anon_sym_template] = ACTIONS(4567),
    [anon_sym_operator] = ACTIONS(4567),
    [anon_sym_friend] = ACTIONS(4567),
    [anon_sym_using] = ACTIONS(4567),
    [anon_sym_concept] = ACTIONS(4567),
  },
  [2288] = {
    [sym_identifier] = ACTIONS(4571),
    [anon_sym_LPAREN2] = ACTIONS(4573),
    [anon_sym_TILDE] = ACTIONS(4573),
    [anon_sym_STAR] = ACTIONS(4573),
    [anon_sym_PIPE_PIPE] = ACTIONS(4573),
    [anon_sym_AMP_AMP] = ACTIONS(4573),
    [anon_sym_AMP] = ACTIONS(4571),
    [anon_sym___extension__] = ACTIONS(4571),
    [anon_sym_extern] = ACTIONS(4571),
    [anon_sym___attribute__] = ACTIONS(4571),
    [anon_sym_COLON_COLON] = ACTIONS(4573),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4573),
    [anon_sym___declspec] = ACTIONS(4571),
    [anon_sym___based] = ACTIONS(4571),
    [anon_sym___cdecl] = ACTIONS(4571),
    [anon_sym___clrcall] = ACTIONS(4571),
    [anon_sym___stdcall] = ACTIONS(4571),
    [anon_sym___fastcall] = ACTIONS(4571),
    [anon_sym___thiscall] = ACTIONS(4571),
    [anon_sym___vectorcall] = ACTIONS(4571),
    [anon_sym_signed] = ACTIONS(4571),
    [anon_sym_unsigned] = ACTIONS(4571),
    [anon_sym_long] = ACTIONS(4571),
    [anon_sym_short] = ACTIONS(4571),
    [anon_sym_LBRACK] = ACTIONS(4571),
    [anon_sym_static] = ACTIONS(4571),
    [anon_sym_register] = ACTIONS(4571),
    [anon_sym_inline] = ACTIONS(4571),
    [anon_sym___inline] = ACTIONS(4571),
    [anon_sym___inline__] = ACTIONS(4571),
    [anon_sym___forceinline] = ACTIONS(4571),
    [anon_sym_thread_local] = ACTIONS(4571),
    [anon_sym___thread] = ACTIONS(4571),
    [anon_sym_const] = ACTIONS(4571),
    [anon_sym_constexpr] = ACTIONS(4571),
    [anon_sym_volatile] = ACTIONS(4571),
    [anon_sym_restrict] = ACTIONS(4571),
    [anon_sym___restrict__] = ACTIONS(4571),
    [anon_sym__Atomic] = ACTIONS(4571),
    [anon_sym__Noreturn] = ACTIONS(4571),
    [anon_sym_noreturn] = ACTIONS(4571),
    [anon_sym_mutable] = ACTIONS(4571),
    [anon_sym_constinit] = ACTIONS(4571),
    [anon_sym_consteval] = ACTIONS(4571),
    [anon_sym_PROGMEM] = ACTIONS(4571),
    [aux_sym_primitive_type_token1] = ACTIONS(4571),
    [anon_sym_byte] = ACTIONS(4571),
    [anon_sym_word] = ACTIONS(4571),
    [anon_sym_enum] = ACTIONS(4571),
    [anon_sym_class] = ACTIONS(4571),
    [anon_sym_struct] = ACTIONS(4571),
    [anon_sym_union] = ACTIONS(4571),
    [anon_sym_or] = ACTIONS(4571),
    [anon_sym_and] = ACTIONS(4571),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4571),
    [anon_sym_decltype] = ACTIONS(4571),
    [anon_sym_virtual] = ACTIONS(4571),
    [anon_sym_alignas] = ACTIONS(4571),
    [anon_sym_explicit] = ACTIONS(4571),
    [anon_sym_typename] = ACTIONS(4571),
    [anon_sym_template] = ACTIONS(4571),
    [anon_sym_operator] = ACTIONS(4571),
    [anon_sym_friend] = ACTIONS(4571),
    [anon_sym_using] = ACTIONS(4571),
    [anon_sym_concept] = ACTIONS(4571),
  },
  [2289] = {
    [sym_attribute_declaration] = STATE(2374),
    [sym_parameter_list] = STATE(2342),
    [aux_sym_attributed_declarator_repeat1] = STATE(2374),
    [sym_identifier] = ACTIONS(5463),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5465),
    [anon_sym_COMMA] = ACTIONS(5465),
    [anon_sym_RPAREN] = ACTIONS(5465),
    [aux_sym_preproc_if_token2] = ACTIONS(5465),
    [aux_sym_preproc_else_token1] = ACTIONS(5465),
    [aux_sym_preproc_elif_token1] = ACTIONS(5463),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5465),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5465),
    [anon_sym_LPAREN2] = ACTIONS(5394),
    [anon_sym_DASH] = ACTIONS(5463),
    [anon_sym_PLUS] = ACTIONS(5463),
    [anon_sym_STAR] = ACTIONS(5463),
    [anon_sym_SLASH] = ACTIONS(5463),
    [anon_sym_PERCENT] = ACTIONS(5463),
    [anon_sym_PIPE_PIPE] = ACTIONS(5465),
    [anon_sym_AMP_AMP] = ACTIONS(5465),
    [anon_sym_PIPE] = ACTIONS(5463),
    [anon_sym_CARET] = ACTIONS(5463),
    [anon_sym_AMP] = ACTIONS(5463),
    [anon_sym_EQ_EQ] = ACTIONS(5465),
    [anon_sym_BANG_EQ] = ACTIONS(5465),
    [anon_sym_GT] = ACTIONS(5463),
    [anon_sym_GT_EQ] = ACTIONS(5465),
    [anon_sym_LT_EQ] = ACTIONS(5463),
    [anon_sym_LT] = ACTIONS(5463),
    [anon_sym_LT_LT] = ACTIONS(5463),
    [anon_sym_GT_GT] = ACTIONS(5463),
    [anon_sym_SEMI] = ACTIONS(5465),
    [anon_sym___attribute__] = ACTIONS(5463),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5396),
    [anon_sym_RBRACE] = ACTIONS(5465),
    [anon_sym_LBRACK] = ACTIONS(5398),
    [anon_sym_RBRACK] = ACTIONS(5465),
    [anon_sym_EQ] = ACTIONS(5463),
    [anon_sym_COLON] = ACTIONS(5465),
    [anon_sym_QMARK] = ACTIONS(5465),
    [anon_sym_STAR_EQ] = ACTIONS(5465),
    [anon_sym_SLASH_EQ] = ACTIONS(5465),
    [anon_sym_PERCENT_EQ] = ACTIONS(5465),
    [anon_sym_PLUS_EQ] = ACTIONS(5465),
    [anon_sym_DASH_EQ] = ACTIONS(5465),
    [anon_sym_LT_LT_EQ] = ACTIONS(5465),
    [anon_sym_GT_GT_EQ] = ACTIONS(5465),
    [anon_sym_AMP_EQ] = ACTIONS(5465),
    [anon_sym_CARET_EQ] = ACTIONS(5465),
    [anon_sym_PIPE_EQ] = ACTIONS(5465),
    [anon_sym_and_eq] = ACTIONS(5463),
    [anon_sym_or_eq] = ACTIONS(5463),
    [anon_sym_xor_eq] = ACTIONS(5463),
    [anon_sym_LT_EQ_GT] = ACTIONS(5465),
    [anon_sym_or] = ACTIONS(5463),
    [anon_sym_and] = ACTIONS(5463),
    [anon_sym_bitor] = ACTIONS(5463),
    [anon_sym_xor] = ACTIONS(5463),
    [anon_sym_bitand] = ACTIONS(5463),
    [anon_sym_not_eq] = ACTIONS(5463),
    [anon_sym_DASH_DASH] = ACTIONS(5465),
    [anon_sym_PLUS_PLUS] = ACTIONS(5465),
    [anon_sym_DOT] = ACTIONS(5463),
    [anon_sym_DOT_STAR] = ACTIONS(5465),
    [anon_sym_DASH_GT] = ACTIONS(5465),
    [sym_comment] = ACTIONS(3),
  },
  [2290] = {
    [sym_identifier] = ACTIONS(4924),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4926),
    [anon_sym_COMMA] = ACTIONS(4926),
    [anon_sym_RPAREN] = ACTIONS(4926),
    [aux_sym_preproc_if_token2] = ACTIONS(4926),
    [aux_sym_preproc_else_token1] = ACTIONS(4926),
    [aux_sym_preproc_elif_token1] = ACTIONS(4924),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4926),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4926),
    [anon_sym_LPAREN2] = ACTIONS(4926),
    [anon_sym_DASH] = ACTIONS(4924),
    [anon_sym_PLUS] = ACTIONS(4924),
    [anon_sym_STAR] = ACTIONS(4924),
    [anon_sym_SLASH] = ACTIONS(4924),
    [anon_sym_PERCENT] = ACTIONS(4924),
    [anon_sym_PIPE_PIPE] = ACTIONS(4926),
    [anon_sym_AMP_AMP] = ACTIONS(4926),
    [anon_sym_PIPE] = ACTIONS(4924),
    [anon_sym_CARET] = ACTIONS(4924),
    [anon_sym_AMP] = ACTIONS(4924),
    [anon_sym_EQ_EQ] = ACTIONS(4926),
    [anon_sym_BANG_EQ] = ACTIONS(4926),
    [anon_sym_GT] = ACTIONS(4924),
    [anon_sym_GT_EQ] = ACTIONS(4926),
    [anon_sym_LT_EQ] = ACTIONS(4924),
    [anon_sym_LT] = ACTIONS(4924),
    [anon_sym_LT_LT] = ACTIONS(4924),
    [anon_sym_GT_GT] = ACTIONS(4924),
    [anon_sym_SEMI] = ACTIONS(4926),
    [anon_sym___attribute__] = ACTIONS(4924),
    [anon_sym_COLON_COLON] = ACTIONS(4922),
    [anon_sym_LBRACE] = ACTIONS(4926),
    [anon_sym_RBRACE] = ACTIONS(4926),
    [anon_sym_LBRACK] = ACTIONS(4926),
    [anon_sym_RBRACK] = ACTIONS(4926),
    [anon_sym_EQ] = ACTIONS(4924),
    [anon_sym_COLON] = ACTIONS(4924),
    [anon_sym_QMARK] = ACTIONS(4926),
    [anon_sym_STAR_EQ] = ACTIONS(4926),
    [anon_sym_SLASH_EQ] = ACTIONS(4926),
    [anon_sym_PERCENT_EQ] = ACTIONS(4926),
    [anon_sym_PLUS_EQ] = ACTIONS(4926),
    [anon_sym_DASH_EQ] = ACTIONS(4926),
    [anon_sym_LT_LT_EQ] = ACTIONS(4926),
    [anon_sym_GT_GT_EQ] = ACTIONS(4926),
    [anon_sym_AMP_EQ] = ACTIONS(4926),
    [anon_sym_CARET_EQ] = ACTIONS(4926),
    [anon_sym_PIPE_EQ] = ACTIONS(4926),
    [anon_sym_and_eq] = ACTIONS(4924),
    [anon_sym_or_eq] = ACTIONS(4924),
    [anon_sym_xor_eq] = ACTIONS(4924),
    [anon_sym_LT_EQ_GT] = ACTIONS(4926),
    [anon_sym_or] = ACTIONS(4924),
    [anon_sym_and] = ACTIONS(4924),
    [anon_sym_bitor] = ACTIONS(4924),
    [anon_sym_xor] = ACTIONS(4924),
    [anon_sym_bitand] = ACTIONS(4924),
    [anon_sym_not_eq] = ACTIONS(4924),
    [anon_sym_DASH_DASH] = ACTIONS(4926),
    [anon_sym_PLUS_PLUS] = ACTIONS(4926),
    [anon_sym_DOT] = ACTIONS(4924),
    [anon_sym_DOT_STAR] = ACTIONS(4926),
    [anon_sym_DASH_GT] = ACTIONS(4926),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4924),
    [anon_sym_decltype] = ACTIONS(4924),
  },
  [2291] = {
    [sym_string_literal] = STATE(2307),
    [sym_raw_string_literal] = STATE(2307),
    [aux_sym_concatenated_string_repeat1] = STATE(2307),
    [sym_identifier] = ACTIONS(5467),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4777),
    [anon_sym_COMMA] = ACTIONS(4777),
    [anon_sym_LPAREN2] = ACTIONS(4777),
    [anon_sym_DASH] = ACTIONS(4779),
    [anon_sym_PLUS] = ACTIONS(4779),
    [anon_sym_STAR] = ACTIONS(4779),
    [anon_sym_SLASH] = ACTIONS(4779),
    [anon_sym_PERCENT] = ACTIONS(4779),
    [anon_sym_PIPE_PIPE] = ACTIONS(4777),
    [anon_sym_AMP_AMP] = ACTIONS(4777),
    [anon_sym_PIPE] = ACTIONS(4779),
    [anon_sym_CARET] = ACTIONS(4779),
    [anon_sym_AMP] = ACTIONS(4779),
    [anon_sym_EQ_EQ] = ACTIONS(4777),
    [anon_sym_BANG_EQ] = ACTIONS(4777),
    [anon_sym_GT] = ACTIONS(4779),
    [anon_sym_GT_EQ] = ACTIONS(4779),
    [anon_sym_LT_EQ] = ACTIONS(4779),
    [anon_sym_LT] = ACTIONS(4779),
    [anon_sym_LT_LT] = ACTIONS(4779),
    [anon_sym_GT_GT] = ACTIONS(4779),
    [anon_sym_LBRACK] = ACTIONS(4777),
    [anon_sym_EQ] = ACTIONS(4779),
    [anon_sym_QMARK] = ACTIONS(4777),
    [anon_sym_STAR_EQ] = ACTIONS(4777),
    [anon_sym_SLASH_EQ] = ACTIONS(4777),
    [anon_sym_PERCENT_EQ] = ACTIONS(4777),
    [anon_sym_PLUS_EQ] = ACTIONS(4777),
    [anon_sym_DASH_EQ] = ACTIONS(4777),
    [anon_sym_LT_LT_EQ] = ACTIONS(4777),
    [anon_sym_GT_GT_EQ] = ACTIONS(4779),
    [anon_sym_AMP_EQ] = ACTIONS(4777),
    [anon_sym_CARET_EQ] = ACTIONS(4777),
    [anon_sym_PIPE_EQ] = ACTIONS(4777),
    [anon_sym_and_eq] = ACTIONS(4779),
    [anon_sym_or_eq] = ACTIONS(4779),
    [anon_sym_xor_eq] = ACTIONS(4779),
    [anon_sym_LT_EQ_GT] = ACTIONS(4777),
    [anon_sym_or] = ACTIONS(4779),
    [anon_sym_and] = ACTIONS(4779),
    [anon_sym_bitor] = ACTIONS(4779),
    [anon_sym_xor] = ACTIONS(4779),
    [anon_sym_bitand] = ACTIONS(4779),
    [anon_sym_not_eq] = ACTIONS(4779),
    [anon_sym_DASH_DASH] = ACTIONS(4777),
    [anon_sym_PLUS_PLUS] = ACTIONS(4777),
    [anon_sym_DOT] = ACTIONS(4779),
    [anon_sym_DOT_STAR] = ACTIONS(4777),
    [anon_sym_DASH_GT] = ACTIONS(4777),
    [anon_sym_L_DQUOTE] = ACTIONS(5382),
    [anon_sym_u_DQUOTE] = ACTIONS(5382),
    [anon_sym_U_DQUOTE] = ACTIONS(5382),
    [anon_sym_u8_DQUOTE] = ACTIONS(5382),
    [anon_sym_DQUOTE] = ACTIONS(5382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_GT2] = ACTIONS(4777),
    [anon_sym_R_DQUOTE] = ACTIONS(5384),
    [anon_sym_LR_DQUOTE] = ACTIONS(5384),
    [anon_sym_uR_DQUOTE] = ACTIONS(5384),
    [anon_sym_UR_DQUOTE] = ACTIONS(5384),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5384),
    [sym_literal_suffix] = ACTIONS(4779),
  },
  [2292] = {
    [sym_string_literal] = STATE(3396),
    [sym_template_argument_list] = STATE(4379),
    [sym_raw_string_literal] = STATE(3396),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3761),
    [anon_sym_COMMA] = ACTIONS(3761),
    [anon_sym_LPAREN2] = ACTIONS(3761),
    [anon_sym_DASH] = ACTIONS(3769),
    [anon_sym_PLUS] = ACTIONS(3769),
    [anon_sym_STAR] = ACTIONS(3769),
    [anon_sym_SLASH] = ACTIONS(3769),
    [anon_sym_PERCENT] = ACTIONS(3769),
    [anon_sym_PIPE_PIPE] = ACTIONS(3761),
    [anon_sym_AMP_AMP] = ACTIONS(3761),
    [anon_sym_PIPE] = ACTIONS(3769),
    [anon_sym_CARET] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(3769),
    [anon_sym_EQ_EQ] = ACTIONS(3761),
    [anon_sym_BANG_EQ] = ACTIONS(3761),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3769),
    [anon_sym_LT_EQ] = ACTIONS(3769),
    [anon_sym_LT] = ACTIONS(4612),
    [anon_sym_LT_LT] = ACTIONS(3769),
    [anon_sym_GT_GT] = ACTIONS(3769),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(3785),
    [anon_sym_LBRACK] = ACTIONS(3761),
    [anon_sym_EQ] = ACTIONS(4617),
    [anon_sym_QMARK] = ACTIONS(3761),
    [anon_sym_STAR_EQ] = ACTIONS(4619),
    [anon_sym_SLASH_EQ] = ACTIONS(4619),
    [anon_sym_PERCENT_EQ] = ACTIONS(4619),
    [anon_sym_PLUS_EQ] = ACTIONS(4619),
    [anon_sym_DASH_EQ] = ACTIONS(4619),
    [anon_sym_LT_LT_EQ] = ACTIONS(4619),
    [anon_sym_GT_GT_EQ] = ACTIONS(4617),
    [anon_sym_AMP_EQ] = ACTIONS(4619),
    [anon_sym_CARET_EQ] = ACTIONS(4619),
    [anon_sym_PIPE_EQ] = ACTIONS(4619),
    [anon_sym_and_eq] = ACTIONS(4619),
    [anon_sym_or_eq] = ACTIONS(4619),
    [anon_sym_xor_eq] = ACTIONS(4619),
    [anon_sym_LT_EQ_GT] = ACTIONS(3761),
    [anon_sym_or] = ACTIONS(3769),
    [anon_sym_and] = ACTIONS(3769),
    [anon_sym_bitor] = ACTIONS(3761),
    [anon_sym_xor] = ACTIONS(3769),
    [anon_sym_bitand] = ACTIONS(3761),
    [anon_sym_not_eq] = ACTIONS(3761),
    [anon_sym_DASH_DASH] = ACTIONS(3761),
    [anon_sym_PLUS_PLUS] = ACTIONS(3761),
    [anon_sym_DOT] = ACTIONS(3769),
    [anon_sym_DOT_STAR] = ACTIONS(3761),
    [anon_sym_DASH_GT] = ACTIONS(3761),
    [anon_sym_L_DQUOTE] = ACTIONS(4621),
    [anon_sym_u_DQUOTE] = ACTIONS(4621),
    [anon_sym_U_DQUOTE] = ACTIONS(4621),
    [anon_sym_u8_DQUOTE] = ACTIONS(4621),
    [anon_sym_DQUOTE] = ACTIONS(4621),
    [sym_comment] = ACTIONS(3),
    [anon_sym_GT2] = ACTIONS(3761),
    [anon_sym_R_DQUOTE] = ACTIONS(4623),
    [anon_sym_LR_DQUOTE] = ACTIONS(4623),
    [anon_sym_uR_DQUOTE] = ACTIONS(4623),
    [anon_sym_UR_DQUOTE] = ACTIONS(4623),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4623),
  },
  [2293] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2262),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4926),
    [anon_sym_COMMA] = ACTIONS(4926),
    [anon_sym_RPAREN] = ACTIONS(4926),
    [anon_sym_LPAREN2] = ACTIONS(4926),
    [anon_sym_DASH] = ACTIONS(4924),
    [anon_sym_PLUS] = ACTIONS(4924),
    [anon_sym_STAR] = ACTIONS(4926),
    [anon_sym_SLASH] = ACTIONS(4924),
    [anon_sym_PERCENT] = ACTIONS(4926),
    [anon_sym_PIPE_PIPE] = ACTIONS(4926),
    [anon_sym_AMP_AMP] = ACTIONS(4926),
    [anon_sym_PIPE] = ACTIONS(4924),
    [anon_sym_CARET] = ACTIONS(4926),
    [anon_sym_AMP] = ACTIONS(4924),
    [anon_sym_EQ_EQ] = ACTIONS(4926),
    [anon_sym_BANG_EQ] = ACTIONS(4926),
    [anon_sym_GT] = ACTIONS(4924),
    [anon_sym_GT_EQ] = ACTIONS(4926),
    [anon_sym_LT_EQ] = ACTIONS(4924),
    [anon_sym_LT] = ACTIONS(4924),
    [anon_sym_LT_LT] = ACTIONS(4926),
    [anon_sym_GT_GT] = ACTIONS(4926),
    [anon_sym_SEMI] = ACTIONS(4926),
    [anon_sym___extension__] = ACTIONS(4926),
    [anon_sym___attribute__] = ACTIONS(4926),
    [anon_sym_LBRACE] = ACTIONS(4926),
    [anon_sym_RBRACE] = ACTIONS(4926),
    [anon_sym_signed] = ACTIONS(5446),
    [anon_sym_unsigned] = ACTIONS(5446),
    [anon_sym_long] = ACTIONS(5446),
    [anon_sym_short] = ACTIONS(5446),
    [anon_sym_LBRACK] = ACTIONS(4926),
    [anon_sym_RBRACK] = ACTIONS(4926),
    [anon_sym_const] = ACTIONS(4924),
    [anon_sym_constexpr] = ACTIONS(4926),
    [anon_sym_volatile] = ACTIONS(4926),
    [anon_sym_restrict] = ACTIONS(4926),
    [anon_sym___restrict__] = ACTIONS(4926),
    [anon_sym__Atomic] = ACTIONS(4926),
    [anon_sym__Noreturn] = ACTIONS(4926),
    [anon_sym_noreturn] = ACTIONS(4926),
    [anon_sym_mutable] = ACTIONS(4926),
    [anon_sym_constinit] = ACTIONS(4926),
    [anon_sym_consteval] = ACTIONS(4926),
    [anon_sym_PROGMEM] = ACTIONS(4926),
    [anon_sym_COLON] = ACTIONS(4926),
    [anon_sym_QMARK] = ACTIONS(4926),
    [anon_sym_LT_EQ_GT] = ACTIONS(4926),
    [anon_sym_or] = ACTIONS(4926),
    [anon_sym_and] = ACTIONS(4926),
    [anon_sym_bitor] = ACTIONS(4926),
    [anon_sym_xor] = ACTIONS(4926),
    [anon_sym_bitand] = ACTIONS(4926),
    [anon_sym_not_eq] = ACTIONS(4926),
    [anon_sym_DASH_DASH] = ACTIONS(4926),
    [anon_sym_PLUS_PLUS] = ACTIONS(4926),
    [anon_sym_DOT] = ACTIONS(4924),
    [anon_sym_DOT_STAR] = ACTIONS(4926),
    [anon_sym_DASH_GT] = ACTIONS(4926),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4926),
    [anon_sym_decltype] = ACTIONS(4926),
    [anon_sym_final] = ACTIONS(4926),
    [anon_sym_override] = ACTIONS(4926),
    [anon_sym_requires] = ACTIONS(4926),
  },
  [2294] = {
    [sym_identifier] = ACTIONS(4559),
    [anon_sym_LPAREN2] = ACTIONS(4561),
    [anon_sym_TILDE] = ACTIONS(4561),
    [anon_sym_STAR] = ACTIONS(4561),
    [anon_sym_PIPE_PIPE] = ACTIONS(4561),
    [anon_sym_AMP_AMP] = ACTIONS(4561),
    [anon_sym_AMP] = ACTIONS(4559),
    [anon_sym___extension__] = ACTIONS(4559),
    [anon_sym_extern] = ACTIONS(4559),
    [anon_sym___attribute__] = ACTIONS(4559),
    [anon_sym_COLON_COLON] = ACTIONS(4561),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4561),
    [anon_sym___declspec] = ACTIONS(4559),
    [anon_sym___based] = ACTIONS(4559),
    [anon_sym___cdecl] = ACTIONS(4559),
    [anon_sym___clrcall] = ACTIONS(4559),
    [anon_sym___stdcall] = ACTIONS(4559),
    [anon_sym___fastcall] = ACTIONS(4559),
    [anon_sym___thiscall] = ACTIONS(4559),
    [anon_sym___vectorcall] = ACTIONS(4559),
    [anon_sym_signed] = ACTIONS(4559),
    [anon_sym_unsigned] = ACTIONS(4559),
    [anon_sym_long] = ACTIONS(4559),
    [anon_sym_short] = ACTIONS(4559),
    [anon_sym_LBRACK] = ACTIONS(4559),
    [anon_sym_static] = ACTIONS(4559),
    [anon_sym_register] = ACTIONS(4559),
    [anon_sym_inline] = ACTIONS(4559),
    [anon_sym___inline] = ACTIONS(4559),
    [anon_sym___inline__] = ACTIONS(4559),
    [anon_sym___forceinline] = ACTIONS(4559),
    [anon_sym_thread_local] = ACTIONS(4559),
    [anon_sym___thread] = ACTIONS(4559),
    [anon_sym_const] = ACTIONS(4559),
    [anon_sym_constexpr] = ACTIONS(4559),
    [anon_sym_volatile] = ACTIONS(4559),
    [anon_sym_restrict] = ACTIONS(4559),
    [anon_sym___restrict__] = ACTIONS(4559),
    [anon_sym__Atomic] = ACTIONS(4559),
    [anon_sym__Noreturn] = ACTIONS(4559),
    [anon_sym_noreturn] = ACTIONS(4559),
    [anon_sym_mutable] = ACTIONS(4559),
    [anon_sym_constinit] = ACTIONS(4559),
    [anon_sym_consteval] = ACTIONS(4559),
    [anon_sym_PROGMEM] = ACTIONS(4559),
    [aux_sym_primitive_type_token1] = ACTIONS(4559),
    [anon_sym_byte] = ACTIONS(4559),
    [anon_sym_word] = ACTIONS(4559),
    [anon_sym_enum] = ACTIONS(4559),
    [anon_sym_class] = ACTIONS(4559),
    [anon_sym_struct] = ACTIONS(4559),
    [anon_sym_union] = ACTIONS(4559),
    [anon_sym_or] = ACTIONS(4559),
    [anon_sym_and] = ACTIONS(4559),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4559),
    [anon_sym_decltype] = ACTIONS(4559),
    [anon_sym_virtual] = ACTIONS(4559),
    [anon_sym_alignas] = ACTIONS(4559),
    [anon_sym_explicit] = ACTIONS(4559),
    [anon_sym_typename] = ACTIONS(4559),
    [anon_sym_template] = ACTIONS(4559),
    [anon_sym_operator] = ACTIONS(4559),
    [anon_sym_friend] = ACTIONS(4559),
    [anon_sym_using] = ACTIONS(4559),
    [anon_sym_concept] = ACTIONS(4559),
  },
  [2295] = {
    [sym_attribute_declaration] = STATE(2374),
    [sym_parameter_list] = STATE(2342),
    [aux_sym_attributed_declarator_repeat1] = STATE(2374),
    [sym_identifier] = ACTIONS(5469),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5471),
    [anon_sym_COMMA] = ACTIONS(5471),
    [anon_sym_RPAREN] = ACTIONS(5471),
    [aux_sym_preproc_if_token2] = ACTIONS(5471),
    [aux_sym_preproc_else_token1] = ACTIONS(5471),
    [aux_sym_preproc_elif_token1] = ACTIONS(5469),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5471),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5471),
    [anon_sym_LPAREN2] = ACTIONS(5394),
    [anon_sym_DASH] = ACTIONS(5469),
    [anon_sym_PLUS] = ACTIONS(5469),
    [anon_sym_STAR] = ACTIONS(5469),
    [anon_sym_SLASH] = ACTIONS(5469),
    [anon_sym_PERCENT] = ACTIONS(5469),
    [anon_sym_PIPE_PIPE] = ACTIONS(5471),
    [anon_sym_AMP_AMP] = ACTIONS(5471),
    [anon_sym_PIPE] = ACTIONS(5469),
    [anon_sym_CARET] = ACTIONS(5469),
    [anon_sym_AMP] = ACTIONS(5469),
    [anon_sym_EQ_EQ] = ACTIONS(5471),
    [anon_sym_BANG_EQ] = ACTIONS(5471),
    [anon_sym_GT] = ACTIONS(5469),
    [anon_sym_GT_EQ] = ACTIONS(5471),
    [anon_sym_LT_EQ] = ACTIONS(5469),
    [anon_sym_LT] = ACTIONS(5469),
    [anon_sym_LT_LT] = ACTIONS(5469),
    [anon_sym_GT_GT] = ACTIONS(5469),
    [anon_sym_SEMI] = ACTIONS(5471),
    [anon_sym___attribute__] = ACTIONS(5469),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5396),
    [anon_sym_RBRACE] = ACTIONS(5471),
    [anon_sym_LBRACK] = ACTIONS(5398),
    [anon_sym_RBRACK] = ACTIONS(5471),
    [anon_sym_EQ] = ACTIONS(5469),
    [anon_sym_COLON] = ACTIONS(5471),
    [anon_sym_QMARK] = ACTIONS(5471),
    [anon_sym_STAR_EQ] = ACTIONS(5471),
    [anon_sym_SLASH_EQ] = ACTIONS(5471),
    [anon_sym_PERCENT_EQ] = ACTIONS(5471),
    [anon_sym_PLUS_EQ] = ACTIONS(5471),
    [anon_sym_DASH_EQ] = ACTIONS(5471),
    [anon_sym_LT_LT_EQ] = ACTIONS(5471),
    [anon_sym_GT_GT_EQ] = ACTIONS(5471),
    [anon_sym_AMP_EQ] = ACTIONS(5471),
    [anon_sym_CARET_EQ] = ACTIONS(5471),
    [anon_sym_PIPE_EQ] = ACTIONS(5471),
    [anon_sym_and_eq] = ACTIONS(5469),
    [anon_sym_or_eq] = ACTIONS(5469),
    [anon_sym_xor_eq] = ACTIONS(5469),
    [anon_sym_LT_EQ_GT] = ACTIONS(5471),
    [anon_sym_or] = ACTIONS(5469),
    [anon_sym_and] = ACTIONS(5469),
    [anon_sym_bitor] = ACTIONS(5469),
    [anon_sym_xor] = ACTIONS(5469),
    [anon_sym_bitand] = ACTIONS(5469),
    [anon_sym_not_eq] = ACTIONS(5469),
    [anon_sym_DASH_DASH] = ACTIONS(5471),
    [anon_sym_PLUS_PLUS] = ACTIONS(5471),
    [anon_sym_DOT] = ACTIONS(5469),
    [anon_sym_DOT_STAR] = ACTIONS(5471),
    [anon_sym_DASH_GT] = ACTIONS(5471),
    [sym_comment] = ACTIONS(3),
  },
  [2296] = {
    [sym_attribute_specifier] = STATE(2370),
    [sym_identifier] = ACTIONS(5473),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5475),
    [anon_sym_COMMA] = ACTIONS(5475),
    [anon_sym_RPAREN] = ACTIONS(5475),
    [aux_sym_preproc_if_token2] = ACTIONS(5475),
    [aux_sym_preproc_else_token1] = ACTIONS(5475),
    [aux_sym_preproc_elif_token1] = ACTIONS(5473),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5475),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5475),
    [anon_sym_LPAREN2] = ACTIONS(5475),
    [anon_sym_DASH] = ACTIONS(5473),
    [anon_sym_PLUS] = ACTIONS(5473),
    [anon_sym_STAR] = ACTIONS(5473),
    [anon_sym_SLASH] = ACTIONS(5473),
    [anon_sym_PERCENT] = ACTIONS(5473),
    [anon_sym_PIPE_PIPE] = ACTIONS(5475),
    [anon_sym_AMP_AMP] = ACTIONS(5475),
    [anon_sym_PIPE] = ACTIONS(5473),
    [anon_sym_CARET] = ACTIONS(5473),
    [anon_sym_AMP] = ACTIONS(5473),
    [anon_sym_EQ_EQ] = ACTIONS(5475),
    [anon_sym_BANG_EQ] = ACTIONS(5475),
    [anon_sym_GT] = ACTIONS(5473),
    [anon_sym_GT_EQ] = ACTIONS(5475),
    [anon_sym_LT_EQ] = ACTIONS(5473),
    [anon_sym_LT] = ACTIONS(5473),
    [anon_sym_LT_LT] = ACTIONS(5473),
    [anon_sym_GT_GT] = ACTIONS(5473),
    [anon_sym_SEMI] = ACTIONS(5475),
    [anon_sym___attribute__] = ACTIONS(4906),
    [anon_sym_LBRACE] = ACTIONS(5475),
    [anon_sym_RBRACE] = ACTIONS(5475),
    [anon_sym_LBRACK] = ACTIONS(5475),
    [anon_sym_RBRACK] = ACTIONS(5475),
    [anon_sym_EQ] = ACTIONS(5473),
    [anon_sym_COLON] = ACTIONS(5475),
    [anon_sym_QMARK] = ACTIONS(5475),
    [anon_sym_STAR_EQ] = ACTIONS(5475),
    [anon_sym_SLASH_EQ] = ACTIONS(5475),
    [anon_sym_PERCENT_EQ] = ACTIONS(5475),
    [anon_sym_PLUS_EQ] = ACTIONS(5475),
    [anon_sym_DASH_EQ] = ACTIONS(5475),
    [anon_sym_LT_LT_EQ] = ACTIONS(5475),
    [anon_sym_GT_GT_EQ] = ACTIONS(5475),
    [anon_sym_AMP_EQ] = ACTIONS(5475),
    [anon_sym_CARET_EQ] = ACTIONS(5475),
    [anon_sym_PIPE_EQ] = ACTIONS(5475),
    [anon_sym_and_eq] = ACTIONS(5473),
    [anon_sym_or_eq] = ACTIONS(5473),
    [anon_sym_xor_eq] = ACTIONS(5473),
    [anon_sym_LT_EQ_GT] = ACTIONS(5475),
    [anon_sym_or] = ACTIONS(5473),
    [anon_sym_and] = ACTIONS(5473),
    [anon_sym_bitor] = ACTIONS(5473),
    [anon_sym_xor] = ACTIONS(5473),
    [anon_sym_bitand] = ACTIONS(5473),
    [anon_sym_not_eq] = ACTIONS(5473),
    [anon_sym_DASH_DASH] = ACTIONS(5475),
    [anon_sym_PLUS_PLUS] = ACTIONS(5475),
    [anon_sym_DOT] = ACTIONS(5473),
    [anon_sym_DOT_STAR] = ACTIONS(5475),
    [anon_sym_DASH_GT] = ACTIONS(5475),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5473),
    [anon_sym_decltype] = ACTIONS(5473),
  },
  [2297] = {
    [sym_identifier] = ACTIONS(5477),
    [anon_sym_LPAREN2] = ACTIONS(5479),
    [anon_sym_TILDE] = ACTIONS(5479),
    [anon_sym_STAR] = ACTIONS(5479),
    [anon_sym_PIPE_PIPE] = ACTIONS(5479),
    [anon_sym_AMP_AMP] = ACTIONS(5434),
    [anon_sym_AMP] = ACTIONS(5477),
    [anon_sym___extension__] = ACTIONS(5477),
    [anon_sym_extern] = ACTIONS(5477),
    [anon_sym___attribute__] = ACTIONS(5477),
    [anon_sym_COLON_COLON] = ACTIONS(5479),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5479),
    [anon_sym___declspec] = ACTIONS(5477),
    [anon_sym___based] = ACTIONS(5477),
    [anon_sym___cdecl] = ACTIONS(5477),
    [anon_sym___clrcall] = ACTIONS(5477),
    [anon_sym___stdcall] = ACTIONS(5477),
    [anon_sym___fastcall] = ACTIONS(5477),
    [anon_sym___thiscall] = ACTIONS(5477),
    [anon_sym___vectorcall] = ACTIONS(5477),
    [anon_sym_signed] = ACTIONS(5477),
    [anon_sym_unsigned] = ACTIONS(5477),
    [anon_sym_long] = ACTIONS(5477),
    [anon_sym_short] = ACTIONS(5477),
    [anon_sym_LBRACK] = ACTIONS(5477),
    [anon_sym_static] = ACTIONS(5477),
    [anon_sym_register] = ACTIONS(5477),
    [anon_sym_inline] = ACTIONS(5477),
    [anon_sym___inline] = ACTIONS(5477),
    [anon_sym___inline__] = ACTIONS(5477),
    [anon_sym___forceinline] = ACTIONS(5477),
    [anon_sym_thread_local] = ACTIONS(5477),
    [anon_sym___thread] = ACTIONS(5477),
    [anon_sym_const] = ACTIONS(5477),
    [anon_sym_constexpr] = ACTIONS(5477),
    [anon_sym_volatile] = ACTIONS(5477),
    [anon_sym_restrict] = ACTIONS(5477),
    [anon_sym___restrict__] = ACTIONS(5477),
    [anon_sym__Atomic] = ACTIONS(5477),
    [anon_sym__Noreturn] = ACTIONS(5477),
    [anon_sym_noreturn] = ACTIONS(5477),
    [anon_sym_mutable] = ACTIONS(5477),
    [anon_sym_constinit] = ACTIONS(5477),
    [anon_sym_consteval] = ACTIONS(5477),
    [anon_sym_PROGMEM] = ACTIONS(5477),
    [aux_sym_primitive_type_token1] = ACTIONS(5477),
    [anon_sym_byte] = ACTIONS(5477),
    [anon_sym_word] = ACTIONS(5477),
    [anon_sym_enum] = ACTIONS(5477),
    [anon_sym_class] = ACTIONS(5477),
    [anon_sym_struct] = ACTIONS(5477),
    [anon_sym_union] = ACTIONS(5477),
    [anon_sym_or] = ACTIONS(5477),
    [anon_sym_and] = ACTIONS(5438),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5477),
    [anon_sym_decltype] = ACTIONS(5477),
    [anon_sym_virtual] = ACTIONS(5477),
    [anon_sym_alignas] = ACTIONS(5477),
    [anon_sym_explicit] = ACTIONS(5477),
    [anon_sym_typename] = ACTIONS(5477),
    [anon_sym_template] = ACTIONS(5477),
    [anon_sym_operator] = ACTIONS(5477),
    [anon_sym_friend] = ACTIONS(5477),
    [anon_sym_using] = ACTIONS(5477),
    [anon_sym_concept] = ACTIONS(5477),
  },
  [2298] = {
    [sym_identifier] = ACTIONS(4555),
    [anon_sym_LPAREN2] = ACTIONS(4557),
    [anon_sym_TILDE] = ACTIONS(4557),
    [anon_sym_STAR] = ACTIONS(4557),
    [anon_sym_PIPE_PIPE] = ACTIONS(4557),
    [anon_sym_AMP_AMP] = ACTIONS(4557),
    [anon_sym_AMP] = ACTIONS(4555),
    [anon_sym___extension__] = ACTIONS(4555),
    [anon_sym_extern] = ACTIONS(4555),
    [anon_sym___attribute__] = ACTIONS(4555),
    [anon_sym_COLON_COLON] = ACTIONS(4557),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4557),
    [anon_sym___declspec] = ACTIONS(4555),
    [anon_sym___based] = ACTIONS(4555),
    [anon_sym___cdecl] = ACTIONS(4555),
    [anon_sym___clrcall] = ACTIONS(4555),
    [anon_sym___stdcall] = ACTIONS(4555),
    [anon_sym___fastcall] = ACTIONS(4555),
    [anon_sym___thiscall] = ACTIONS(4555),
    [anon_sym___vectorcall] = ACTIONS(4555),
    [anon_sym_signed] = ACTIONS(4555),
    [anon_sym_unsigned] = ACTIONS(4555),
    [anon_sym_long] = ACTIONS(4555),
    [anon_sym_short] = ACTIONS(4555),
    [anon_sym_LBRACK] = ACTIONS(4555),
    [anon_sym_static] = ACTIONS(4555),
    [anon_sym_register] = ACTIONS(4555),
    [anon_sym_inline] = ACTIONS(4555),
    [anon_sym___inline] = ACTIONS(4555),
    [anon_sym___inline__] = ACTIONS(4555),
    [anon_sym___forceinline] = ACTIONS(4555),
    [anon_sym_thread_local] = ACTIONS(4555),
    [anon_sym___thread] = ACTIONS(4555),
    [anon_sym_const] = ACTIONS(4555),
    [anon_sym_constexpr] = ACTIONS(4555),
    [anon_sym_volatile] = ACTIONS(4555),
    [anon_sym_restrict] = ACTIONS(4555),
    [anon_sym___restrict__] = ACTIONS(4555),
    [anon_sym__Atomic] = ACTIONS(4555),
    [anon_sym__Noreturn] = ACTIONS(4555),
    [anon_sym_noreturn] = ACTIONS(4555),
    [anon_sym_mutable] = ACTIONS(4555),
    [anon_sym_constinit] = ACTIONS(4555),
    [anon_sym_consteval] = ACTIONS(4555),
    [anon_sym_PROGMEM] = ACTIONS(4555),
    [aux_sym_primitive_type_token1] = ACTIONS(4555),
    [anon_sym_byte] = ACTIONS(4555),
    [anon_sym_word] = ACTIONS(4555),
    [anon_sym_enum] = ACTIONS(4555),
    [anon_sym_class] = ACTIONS(4555),
    [anon_sym_struct] = ACTIONS(4555),
    [anon_sym_union] = ACTIONS(4555),
    [anon_sym_or] = ACTIONS(4555),
    [anon_sym_and] = ACTIONS(4555),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4555),
    [anon_sym_decltype] = ACTIONS(4555),
    [anon_sym_virtual] = ACTIONS(4555),
    [anon_sym_alignas] = ACTIONS(4555),
    [anon_sym_explicit] = ACTIONS(4555),
    [anon_sym_typename] = ACTIONS(4555),
    [anon_sym_template] = ACTIONS(4555),
    [anon_sym_operator] = ACTIONS(4555),
    [anon_sym_friend] = ACTIONS(4555),
    [anon_sym_using] = ACTIONS(4555),
    [anon_sym_concept] = ACTIONS(4555),
  },
  [2299] = {
    [sym_attribute_specifier] = STATE(2363),
    [sym_identifier] = ACTIONS(5481),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5483),
    [anon_sym_COMMA] = ACTIONS(5483),
    [anon_sym_RPAREN] = ACTIONS(5483),
    [aux_sym_preproc_if_token2] = ACTIONS(5483),
    [aux_sym_preproc_else_token1] = ACTIONS(5483),
    [aux_sym_preproc_elif_token1] = ACTIONS(5481),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5483),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5483),
    [anon_sym_LPAREN2] = ACTIONS(5483),
    [anon_sym_DASH] = ACTIONS(5481),
    [anon_sym_PLUS] = ACTIONS(5481),
    [anon_sym_STAR] = ACTIONS(5481),
    [anon_sym_SLASH] = ACTIONS(5481),
    [anon_sym_PERCENT] = ACTIONS(5481),
    [anon_sym_PIPE_PIPE] = ACTIONS(5483),
    [anon_sym_AMP_AMP] = ACTIONS(5483),
    [anon_sym_PIPE] = ACTIONS(5481),
    [anon_sym_CARET] = ACTIONS(5481),
    [anon_sym_AMP] = ACTIONS(5481),
    [anon_sym_EQ_EQ] = ACTIONS(5483),
    [anon_sym_BANG_EQ] = ACTIONS(5483),
    [anon_sym_GT] = ACTIONS(5481),
    [anon_sym_GT_EQ] = ACTIONS(5483),
    [anon_sym_LT_EQ] = ACTIONS(5481),
    [anon_sym_LT] = ACTIONS(5481),
    [anon_sym_LT_LT] = ACTIONS(5481),
    [anon_sym_GT_GT] = ACTIONS(5481),
    [anon_sym_SEMI] = ACTIONS(5483),
    [anon_sym___attribute__] = ACTIONS(4906),
    [anon_sym_LBRACE] = ACTIONS(5483),
    [anon_sym_RBRACE] = ACTIONS(5483),
    [anon_sym_LBRACK] = ACTIONS(5483),
    [anon_sym_RBRACK] = ACTIONS(5483),
    [anon_sym_EQ] = ACTIONS(5481),
    [anon_sym_COLON] = ACTIONS(5483),
    [anon_sym_QMARK] = ACTIONS(5483),
    [anon_sym_STAR_EQ] = ACTIONS(5483),
    [anon_sym_SLASH_EQ] = ACTIONS(5483),
    [anon_sym_PERCENT_EQ] = ACTIONS(5483),
    [anon_sym_PLUS_EQ] = ACTIONS(5483),
    [anon_sym_DASH_EQ] = ACTIONS(5483),
    [anon_sym_LT_LT_EQ] = ACTIONS(5483),
    [anon_sym_GT_GT_EQ] = ACTIONS(5483),
    [anon_sym_AMP_EQ] = ACTIONS(5483),
    [anon_sym_CARET_EQ] = ACTIONS(5483),
    [anon_sym_PIPE_EQ] = ACTIONS(5483),
    [anon_sym_and_eq] = ACTIONS(5481),
    [anon_sym_or_eq] = ACTIONS(5481),
    [anon_sym_xor_eq] = ACTIONS(5481),
    [anon_sym_LT_EQ_GT] = ACTIONS(5483),
    [anon_sym_or] = ACTIONS(5481),
    [anon_sym_and] = ACTIONS(5481),
    [anon_sym_bitor] = ACTIONS(5481),
    [anon_sym_xor] = ACTIONS(5481),
    [anon_sym_bitand] = ACTIONS(5481),
    [anon_sym_not_eq] = ACTIONS(5481),
    [anon_sym_DASH_DASH] = ACTIONS(5483),
    [anon_sym_PLUS_PLUS] = ACTIONS(5483),
    [anon_sym_DOT] = ACTIONS(5481),
    [anon_sym_DOT_STAR] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5483),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5481),
    [anon_sym_decltype] = ACTIONS(5481),
  },
  [2300] = {
    [sym_attribute_specifier] = STATE(2329),
    [sym_identifier] = ACTIONS(5485),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5487),
    [anon_sym_COMMA] = ACTIONS(5487),
    [anon_sym_RPAREN] = ACTIONS(5487),
    [aux_sym_preproc_if_token2] = ACTIONS(5487),
    [aux_sym_preproc_else_token1] = ACTIONS(5487),
    [aux_sym_preproc_elif_token1] = ACTIONS(5485),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5487),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5487),
    [anon_sym_LPAREN2] = ACTIONS(5487),
    [anon_sym_DASH] = ACTIONS(5485),
    [anon_sym_PLUS] = ACTIONS(5485),
    [anon_sym_STAR] = ACTIONS(5485),
    [anon_sym_SLASH] = ACTIONS(5485),
    [anon_sym_PERCENT] = ACTIONS(5485),
    [anon_sym_PIPE_PIPE] = ACTIONS(5487),
    [anon_sym_AMP_AMP] = ACTIONS(5487),
    [anon_sym_PIPE] = ACTIONS(5485),
    [anon_sym_CARET] = ACTIONS(5485),
    [anon_sym_AMP] = ACTIONS(5485),
    [anon_sym_EQ_EQ] = ACTIONS(5487),
    [anon_sym_BANG_EQ] = ACTIONS(5487),
    [anon_sym_GT] = ACTIONS(5485),
    [anon_sym_GT_EQ] = ACTIONS(5487),
    [anon_sym_LT_EQ] = ACTIONS(5485),
    [anon_sym_LT] = ACTIONS(5485),
    [anon_sym_LT_LT] = ACTIONS(5485),
    [anon_sym_GT_GT] = ACTIONS(5485),
    [anon_sym_SEMI] = ACTIONS(5487),
    [anon_sym___attribute__] = ACTIONS(4906),
    [anon_sym_LBRACE] = ACTIONS(5487),
    [anon_sym_RBRACE] = ACTIONS(5487),
    [anon_sym_LBRACK] = ACTIONS(5487),
    [anon_sym_RBRACK] = ACTIONS(5487),
    [anon_sym_EQ] = ACTIONS(5485),
    [anon_sym_COLON] = ACTIONS(5487),
    [anon_sym_QMARK] = ACTIONS(5487),
    [anon_sym_STAR_EQ] = ACTIONS(5487),
    [anon_sym_SLASH_EQ] = ACTIONS(5487),
    [anon_sym_PERCENT_EQ] = ACTIONS(5487),
    [anon_sym_PLUS_EQ] = ACTIONS(5487),
    [anon_sym_DASH_EQ] = ACTIONS(5487),
    [anon_sym_LT_LT_EQ] = ACTIONS(5487),
    [anon_sym_GT_GT_EQ] = ACTIONS(5487),
    [anon_sym_AMP_EQ] = ACTIONS(5487),
    [anon_sym_CARET_EQ] = ACTIONS(5487),
    [anon_sym_PIPE_EQ] = ACTIONS(5487),
    [anon_sym_and_eq] = ACTIONS(5485),
    [anon_sym_or_eq] = ACTIONS(5485),
    [anon_sym_xor_eq] = ACTIONS(5485),
    [anon_sym_LT_EQ_GT] = ACTIONS(5487),
    [anon_sym_or] = ACTIONS(5485),
    [anon_sym_and] = ACTIONS(5485),
    [anon_sym_bitor] = ACTIONS(5485),
    [anon_sym_xor] = ACTIONS(5485),
    [anon_sym_bitand] = ACTIONS(5485),
    [anon_sym_not_eq] = ACTIONS(5485),
    [anon_sym_DASH_DASH] = ACTIONS(5487),
    [anon_sym_PLUS_PLUS] = ACTIONS(5487),
    [anon_sym_DOT] = ACTIONS(5485),
    [anon_sym_DOT_STAR] = ACTIONS(5487),
    [anon_sym_DASH_GT] = ACTIONS(5487),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5485),
    [anon_sym_decltype] = ACTIONS(5485),
  },
  [2301] = {
    [sym_template_argument_list] = STATE(2017),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2410),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3767),
    [anon_sym_COMMA] = ACTIONS(3767),
    [anon_sym_RPAREN] = ACTIONS(3767),
    [anon_sym_LPAREN2] = ACTIONS(3767),
    [anon_sym_DASH] = ACTIONS(3759),
    [anon_sym_PLUS] = ACTIONS(3759),
    [anon_sym_STAR] = ACTIONS(3759),
    [anon_sym_SLASH] = ACTIONS(3759),
    [anon_sym_PERCENT] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(3767),
    [anon_sym_AMP_AMP] = ACTIONS(3767),
    [anon_sym_PIPE] = ACTIONS(3759),
    [anon_sym_CARET] = ACTIONS(3759),
    [anon_sym_AMP] = ACTIONS(3759),
    [anon_sym_EQ_EQ] = ACTIONS(3767),
    [anon_sym_BANG_EQ] = ACTIONS(3767),
    [anon_sym_GT] = ACTIONS(3759),
    [anon_sym_GT_EQ] = ACTIONS(3767),
    [anon_sym_LT_EQ] = ACTIONS(3759),
    [anon_sym_LT] = ACTIONS(5189),
    [anon_sym_LT_LT] = ACTIONS(3759),
    [anon_sym_GT_GT] = ACTIONS(3759),
    [anon_sym_SEMI] = ACTIONS(3767),
    [anon_sym___attribute__] = ACTIONS(3767),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(3767),
    [anon_sym_RBRACE] = ACTIONS(3767),
    [anon_sym_signed] = ACTIONS(5440),
    [anon_sym_unsigned] = ACTIONS(5440),
    [anon_sym_long] = ACTIONS(5440),
    [anon_sym_short] = ACTIONS(5440),
    [anon_sym_LBRACK] = ACTIONS(3767),
    [anon_sym_RBRACK] = ACTIONS(3767),
    [anon_sym_EQ] = ACTIONS(3759),
    [anon_sym_COLON] = ACTIONS(3759),
    [anon_sym_QMARK] = ACTIONS(3767),
    [anon_sym_STAR_EQ] = ACTIONS(3767),
    [anon_sym_SLASH_EQ] = ACTIONS(3767),
    [anon_sym_PERCENT_EQ] = ACTIONS(3767),
    [anon_sym_PLUS_EQ] = ACTIONS(3767),
    [anon_sym_DASH_EQ] = ACTIONS(3767),
    [anon_sym_LT_LT_EQ] = ACTIONS(3767),
    [anon_sym_GT_GT_EQ] = ACTIONS(3767),
    [anon_sym_AMP_EQ] = ACTIONS(3767),
    [anon_sym_CARET_EQ] = ACTIONS(3767),
    [anon_sym_PIPE_EQ] = ACTIONS(3767),
    [anon_sym_and_eq] = ACTIONS(3767),
    [anon_sym_or_eq] = ACTIONS(3767),
    [anon_sym_xor_eq] = ACTIONS(3767),
    [anon_sym_LT_EQ_GT] = ACTIONS(3767),
    [anon_sym_or] = ACTIONS(3759),
    [anon_sym_and] = ACTIONS(3759),
    [anon_sym_bitor] = ACTIONS(3767),
    [anon_sym_xor] = ACTIONS(3759),
    [anon_sym_bitand] = ACTIONS(3767),
    [anon_sym_not_eq] = ACTIONS(3767),
    [anon_sym_DASH_DASH] = ACTIONS(3767),
    [anon_sym_PLUS_PLUS] = ACTIONS(3767),
    [anon_sym_DOT] = ACTIONS(3759),
    [anon_sym_DOT_STAR] = ACTIONS(3767),
    [anon_sym_DASH_GT] = ACTIONS(3767),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3767),
    [anon_sym_decltype] = ACTIONS(3767),
  },
  [2302] = {
    [sym_attribute_specifier] = STATE(2387),
    [sym_identifier] = ACTIONS(5489),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5491),
    [anon_sym_COMMA] = ACTIONS(5491),
    [anon_sym_RPAREN] = ACTIONS(5491),
    [aux_sym_preproc_if_token2] = ACTIONS(5491),
    [aux_sym_preproc_else_token1] = ACTIONS(5491),
    [aux_sym_preproc_elif_token1] = ACTIONS(5489),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5491),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5491),
    [anon_sym_LPAREN2] = ACTIONS(5491),
    [anon_sym_DASH] = ACTIONS(5489),
    [anon_sym_PLUS] = ACTIONS(5489),
    [anon_sym_STAR] = ACTIONS(5489),
    [anon_sym_SLASH] = ACTIONS(5489),
    [anon_sym_PERCENT] = ACTIONS(5489),
    [anon_sym_PIPE_PIPE] = ACTIONS(5491),
    [anon_sym_AMP_AMP] = ACTIONS(5491),
    [anon_sym_PIPE] = ACTIONS(5489),
    [anon_sym_CARET] = ACTIONS(5489),
    [anon_sym_AMP] = ACTIONS(5489),
    [anon_sym_EQ_EQ] = ACTIONS(5491),
    [anon_sym_BANG_EQ] = ACTIONS(5491),
    [anon_sym_GT] = ACTIONS(5489),
    [anon_sym_GT_EQ] = ACTIONS(5491),
    [anon_sym_LT_EQ] = ACTIONS(5489),
    [anon_sym_LT] = ACTIONS(5489),
    [anon_sym_LT_LT] = ACTIONS(5489),
    [anon_sym_GT_GT] = ACTIONS(5489),
    [anon_sym_SEMI] = ACTIONS(5491),
    [anon_sym___attribute__] = ACTIONS(4906),
    [anon_sym_LBRACE] = ACTIONS(5491),
    [anon_sym_RBRACE] = ACTIONS(5491),
    [anon_sym_LBRACK] = ACTIONS(5491),
    [anon_sym_RBRACK] = ACTIONS(5491),
    [anon_sym_EQ] = ACTIONS(5489),
    [anon_sym_COLON] = ACTIONS(5491),
    [anon_sym_QMARK] = ACTIONS(5491),
    [anon_sym_STAR_EQ] = ACTIONS(5491),
    [anon_sym_SLASH_EQ] = ACTIONS(5491),
    [anon_sym_PERCENT_EQ] = ACTIONS(5491),
    [anon_sym_PLUS_EQ] = ACTIONS(5491),
    [anon_sym_DASH_EQ] = ACTIONS(5491),
    [anon_sym_LT_LT_EQ] = ACTIONS(5491),
    [anon_sym_GT_GT_EQ] = ACTIONS(5491),
    [anon_sym_AMP_EQ] = ACTIONS(5491),
    [anon_sym_CARET_EQ] = ACTIONS(5491),
    [anon_sym_PIPE_EQ] = ACTIONS(5491),
    [anon_sym_and_eq] = ACTIONS(5489),
    [anon_sym_or_eq] = ACTIONS(5489),
    [anon_sym_xor_eq] = ACTIONS(5489),
    [anon_sym_LT_EQ_GT] = ACTIONS(5491),
    [anon_sym_or] = ACTIONS(5489),
    [anon_sym_and] = ACTIONS(5489),
    [anon_sym_bitor] = ACTIONS(5489),
    [anon_sym_xor] = ACTIONS(5489),
    [anon_sym_bitand] = ACTIONS(5489),
    [anon_sym_not_eq] = ACTIONS(5489),
    [anon_sym_DASH_DASH] = ACTIONS(5491),
    [anon_sym_PLUS_PLUS] = ACTIONS(5491),
    [anon_sym_DOT] = ACTIONS(5489),
    [anon_sym_DOT_STAR] = ACTIONS(5491),
    [anon_sym_DASH_GT] = ACTIONS(5491),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5489),
    [anon_sym_decltype] = ACTIONS(5489),
  },
  [2303] = {
    [sym_identifier] = ACTIONS(4551),
    [anon_sym_LPAREN2] = ACTIONS(4553),
    [anon_sym_TILDE] = ACTIONS(4553),
    [anon_sym_STAR] = ACTIONS(4553),
    [anon_sym_PIPE_PIPE] = ACTIONS(4553),
    [anon_sym_AMP_AMP] = ACTIONS(4553),
    [anon_sym_AMP] = ACTIONS(4551),
    [anon_sym___extension__] = ACTIONS(4551),
    [anon_sym_extern] = ACTIONS(4551),
    [anon_sym___attribute__] = ACTIONS(4551),
    [anon_sym_COLON_COLON] = ACTIONS(4553),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4553),
    [anon_sym___declspec] = ACTIONS(4551),
    [anon_sym___based] = ACTIONS(4551),
    [anon_sym___cdecl] = ACTIONS(4551),
    [anon_sym___clrcall] = ACTIONS(4551),
    [anon_sym___stdcall] = ACTIONS(4551),
    [anon_sym___fastcall] = ACTIONS(4551),
    [anon_sym___thiscall] = ACTIONS(4551),
    [anon_sym___vectorcall] = ACTIONS(4551),
    [anon_sym_signed] = ACTIONS(4551),
    [anon_sym_unsigned] = ACTIONS(4551),
    [anon_sym_long] = ACTIONS(4551),
    [anon_sym_short] = ACTIONS(4551),
    [anon_sym_LBRACK] = ACTIONS(4551),
    [anon_sym_static] = ACTIONS(4551),
    [anon_sym_register] = ACTIONS(4551),
    [anon_sym_inline] = ACTIONS(4551),
    [anon_sym___inline] = ACTIONS(4551),
    [anon_sym___inline__] = ACTIONS(4551),
    [anon_sym___forceinline] = ACTIONS(4551),
    [anon_sym_thread_local] = ACTIONS(4551),
    [anon_sym___thread] = ACTIONS(4551),
    [anon_sym_const] = ACTIONS(4551),
    [anon_sym_constexpr] = ACTIONS(4551),
    [anon_sym_volatile] = ACTIONS(4551),
    [anon_sym_restrict] = ACTIONS(4551),
    [anon_sym___restrict__] = ACTIONS(4551),
    [anon_sym__Atomic] = ACTIONS(4551),
    [anon_sym__Noreturn] = ACTIONS(4551),
    [anon_sym_noreturn] = ACTIONS(4551),
    [anon_sym_mutable] = ACTIONS(4551),
    [anon_sym_constinit] = ACTIONS(4551),
    [anon_sym_consteval] = ACTIONS(4551),
    [anon_sym_PROGMEM] = ACTIONS(4551),
    [aux_sym_primitive_type_token1] = ACTIONS(4551),
    [anon_sym_byte] = ACTIONS(4551),
    [anon_sym_word] = ACTIONS(4551),
    [anon_sym_enum] = ACTIONS(4551),
    [anon_sym_class] = ACTIONS(4551),
    [anon_sym_struct] = ACTIONS(4551),
    [anon_sym_union] = ACTIONS(4551),
    [anon_sym_or] = ACTIONS(4551),
    [anon_sym_and] = ACTIONS(4551),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4551),
    [anon_sym_decltype] = ACTIONS(4551),
    [anon_sym_virtual] = ACTIONS(4551),
    [anon_sym_alignas] = ACTIONS(4551),
    [anon_sym_explicit] = ACTIONS(4551),
    [anon_sym_typename] = ACTIONS(4551),
    [anon_sym_template] = ACTIONS(4551),
    [anon_sym_operator] = ACTIONS(4551),
    [anon_sym_friend] = ACTIONS(4551),
    [anon_sym_using] = ACTIONS(4551),
    [anon_sym_concept] = ACTIONS(4551),
  },
  [2304] = {
    [sym_attribute_specifier] = STATE(2352),
    [sym_identifier] = ACTIONS(5493),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5495),
    [anon_sym_COMMA] = ACTIONS(5495),
    [anon_sym_RPAREN] = ACTIONS(5495),
    [aux_sym_preproc_if_token2] = ACTIONS(5495),
    [aux_sym_preproc_else_token1] = ACTIONS(5495),
    [aux_sym_preproc_elif_token1] = ACTIONS(5493),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5495),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5495),
    [anon_sym_LPAREN2] = ACTIONS(5495),
    [anon_sym_DASH] = ACTIONS(5493),
    [anon_sym_PLUS] = ACTIONS(5493),
    [anon_sym_STAR] = ACTIONS(5493),
    [anon_sym_SLASH] = ACTIONS(5493),
    [anon_sym_PERCENT] = ACTIONS(5493),
    [anon_sym_PIPE_PIPE] = ACTIONS(5495),
    [anon_sym_AMP_AMP] = ACTIONS(5495),
    [anon_sym_PIPE] = ACTIONS(5493),
    [anon_sym_CARET] = ACTIONS(5493),
    [anon_sym_AMP] = ACTIONS(5493),
    [anon_sym_EQ_EQ] = ACTIONS(5495),
    [anon_sym_BANG_EQ] = ACTIONS(5495),
    [anon_sym_GT] = ACTIONS(5493),
    [anon_sym_GT_EQ] = ACTIONS(5495),
    [anon_sym_LT_EQ] = ACTIONS(5493),
    [anon_sym_LT] = ACTIONS(5493),
    [anon_sym_LT_LT] = ACTIONS(5493),
    [anon_sym_GT_GT] = ACTIONS(5493),
    [anon_sym_SEMI] = ACTIONS(5495),
    [anon_sym___attribute__] = ACTIONS(4906),
    [anon_sym_LBRACE] = ACTIONS(5495),
    [anon_sym_RBRACE] = ACTIONS(5495),
    [anon_sym_LBRACK] = ACTIONS(5495),
    [anon_sym_RBRACK] = ACTIONS(5495),
    [anon_sym_EQ] = ACTIONS(5493),
    [anon_sym_COLON] = ACTIONS(5495),
    [anon_sym_QMARK] = ACTIONS(5495),
    [anon_sym_STAR_EQ] = ACTIONS(5495),
    [anon_sym_SLASH_EQ] = ACTIONS(5495),
    [anon_sym_PERCENT_EQ] = ACTIONS(5495),
    [anon_sym_PLUS_EQ] = ACTIONS(5495),
    [anon_sym_DASH_EQ] = ACTIONS(5495),
    [anon_sym_LT_LT_EQ] = ACTIONS(5495),
    [anon_sym_GT_GT_EQ] = ACTIONS(5495),
    [anon_sym_AMP_EQ] = ACTIONS(5495),
    [anon_sym_CARET_EQ] = ACTIONS(5495),
    [anon_sym_PIPE_EQ] = ACTIONS(5495),
    [anon_sym_and_eq] = ACTIONS(5493),
    [anon_sym_or_eq] = ACTIONS(5493),
    [anon_sym_xor_eq] = ACTIONS(5493),
    [anon_sym_LT_EQ_GT] = ACTIONS(5495),
    [anon_sym_or] = ACTIONS(5493),
    [anon_sym_and] = ACTIONS(5493),
    [anon_sym_bitor] = ACTIONS(5493),
    [anon_sym_xor] = ACTIONS(5493),
    [anon_sym_bitand] = ACTIONS(5493),
    [anon_sym_not_eq] = ACTIONS(5493),
    [anon_sym_DASH_DASH] = ACTIONS(5495),
    [anon_sym_PLUS_PLUS] = ACTIONS(5495),
    [anon_sym_DOT] = ACTIONS(5493),
    [anon_sym_DOT_STAR] = ACTIONS(5495),
    [anon_sym_DASH_GT] = ACTIONS(5495),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5493),
    [anon_sym_decltype] = ACTIONS(5493),
  },
  [2305] = {
    [sym_identifier] = ACTIONS(4940),
    [anon_sym_LPAREN2] = ACTIONS(4942),
    [anon_sym_TILDE] = ACTIONS(4942),
    [anon_sym_STAR] = ACTIONS(4942),
    [anon_sym_PIPE_PIPE] = ACTIONS(4942),
    [anon_sym_AMP_AMP] = ACTIONS(4942),
    [anon_sym_AMP] = ACTIONS(4940),
    [anon_sym___extension__] = ACTIONS(4940),
    [anon_sym_extern] = ACTIONS(4940),
    [anon_sym___attribute__] = ACTIONS(4940),
    [anon_sym_COLON_COLON] = ACTIONS(4922),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4942),
    [anon_sym___declspec] = ACTIONS(4940),
    [anon_sym___based] = ACTIONS(4940),
    [anon_sym___cdecl] = ACTIONS(4940),
    [anon_sym___clrcall] = ACTIONS(4940),
    [anon_sym___stdcall] = ACTIONS(4940),
    [anon_sym___fastcall] = ACTIONS(4940),
    [anon_sym___thiscall] = ACTIONS(4940),
    [anon_sym___vectorcall] = ACTIONS(4940),
    [anon_sym_signed] = ACTIONS(4940),
    [anon_sym_unsigned] = ACTIONS(4940),
    [anon_sym_long] = ACTIONS(4940),
    [anon_sym_short] = ACTIONS(4940),
    [anon_sym_LBRACK] = ACTIONS(4940),
    [anon_sym_static] = ACTIONS(4940),
    [anon_sym_register] = ACTIONS(4940),
    [anon_sym_inline] = ACTIONS(4940),
    [anon_sym___inline] = ACTIONS(4940),
    [anon_sym___inline__] = ACTIONS(4940),
    [anon_sym___forceinline] = ACTIONS(4940),
    [anon_sym_thread_local] = ACTIONS(4940),
    [anon_sym___thread] = ACTIONS(4940),
    [anon_sym_const] = ACTIONS(4940),
    [anon_sym_constexpr] = ACTIONS(4940),
    [anon_sym_volatile] = ACTIONS(4940),
    [anon_sym_restrict] = ACTIONS(4940),
    [anon_sym___restrict__] = ACTIONS(4940),
    [anon_sym__Atomic] = ACTIONS(4940),
    [anon_sym__Noreturn] = ACTIONS(4940),
    [anon_sym_noreturn] = ACTIONS(4940),
    [anon_sym_mutable] = ACTIONS(4940),
    [anon_sym_constinit] = ACTIONS(4940),
    [anon_sym_consteval] = ACTIONS(4940),
    [anon_sym_PROGMEM] = ACTIONS(4940),
    [aux_sym_primitive_type_token1] = ACTIONS(4940),
    [anon_sym_byte] = ACTIONS(4940),
    [anon_sym_word] = ACTIONS(4940),
    [anon_sym_enum] = ACTIONS(4940),
    [anon_sym_class] = ACTIONS(4940),
    [anon_sym_struct] = ACTIONS(4940),
    [anon_sym_union] = ACTIONS(4940),
    [anon_sym_or] = ACTIONS(4940),
    [anon_sym_and] = ACTIONS(4940),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4940),
    [anon_sym_decltype] = ACTIONS(4940),
    [anon_sym_virtual] = ACTIONS(4940),
    [anon_sym_alignas] = ACTIONS(4940),
    [anon_sym_explicit] = ACTIONS(4940),
    [anon_sym_typename] = ACTIONS(4940),
    [anon_sym_template] = ACTIONS(4940),
    [anon_sym_operator] = ACTIONS(4940),
    [anon_sym_friend] = ACTIONS(4940),
    [anon_sym_using] = ACTIONS(4940),
    [anon_sym_concept] = ACTIONS(4940),
  },
  [2306] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2306),
    [sym_identifier] = ACTIONS(4766),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4768),
    [anon_sym_COMMA] = ACTIONS(4768),
    [anon_sym_LPAREN2] = ACTIONS(4768),
    [anon_sym_DASH] = ACTIONS(4766),
    [anon_sym_PLUS] = ACTIONS(4766),
    [anon_sym_STAR] = ACTIONS(4768),
    [anon_sym_SLASH] = ACTIONS(4766),
    [anon_sym_PERCENT] = ACTIONS(4768),
    [anon_sym_PIPE_PIPE] = ACTIONS(4768),
    [anon_sym_AMP_AMP] = ACTIONS(4768),
    [anon_sym_PIPE] = ACTIONS(4766),
    [anon_sym_CARET] = ACTIONS(4768),
    [anon_sym_AMP] = ACTIONS(4766),
    [anon_sym_EQ_EQ] = ACTIONS(4768),
    [anon_sym_BANG_EQ] = ACTIONS(4768),
    [anon_sym_GT] = ACTIONS(4766),
    [anon_sym_GT_EQ] = ACTIONS(4766),
    [anon_sym_LT_EQ] = ACTIONS(4766),
    [anon_sym_LT] = ACTIONS(4766),
    [anon_sym_LT_LT] = ACTIONS(4768),
    [anon_sym_GT_GT] = ACTIONS(4766),
    [anon_sym___extension__] = ACTIONS(4766),
    [anon_sym___attribute__] = ACTIONS(4766),
    [anon_sym_LBRACE] = ACTIONS(4768),
    [anon_sym_signed] = ACTIONS(5460),
    [anon_sym_unsigned] = ACTIONS(5460),
    [anon_sym_long] = ACTIONS(5460),
    [anon_sym_short] = ACTIONS(5460),
    [anon_sym_LBRACK] = ACTIONS(4768),
    [anon_sym_const] = ACTIONS(4766),
    [anon_sym_constexpr] = ACTIONS(4766),
    [anon_sym_volatile] = ACTIONS(4766),
    [anon_sym_restrict] = ACTIONS(4766),
    [anon_sym___restrict__] = ACTIONS(4766),
    [anon_sym__Atomic] = ACTIONS(4766),
    [anon_sym__Noreturn] = ACTIONS(4766),
    [anon_sym_noreturn] = ACTIONS(4766),
    [anon_sym_mutable] = ACTIONS(4766),
    [anon_sym_constinit] = ACTIONS(4766),
    [anon_sym_consteval] = ACTIONS(4766),
    [anon_sym_PROGMEM] = ACTIONS(4766),
    [aux_sym_primitive_type_token1] = ACTIONS(4766),
    [anon_sym_byte] = ACTIONS(4766),
    [anon_sym_word] = ACTIONS(4766),
    [anon_sym_QMARK] = ACTIONS(4768),
    [anon_sym_LT_EQ_GT] = ACTIONS(4768),
    [anon_sym_or] = ACTIONS(4766),
    [anon_sym_and] = ACTIONS(4766),
    [anon_sym_bitor] = ACTIONS(4766),
    [anon_sym_xor] = ACTIONS(4766),
    [anon_sym_bitand] = ACTIONS(4766),
    [anon_sym_not_eq] = ACTIONS(4766),
    [anon_sym_DASH_DASH] = ACTIONS(4768),
    [anon_sym_PLUS_PLUS] = ACTIONS(4768),
    [anon_sym_DOT] = ACTIONS(4766),
    [anon_sym_DOT_STAR] = ACTIONS(4768),
    [anon_sym_DASH_GT] = ACTIONS(4768),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4766),
    [anon_sym_decltype] = ACTIONS(4766),
    [anon_sym_final] = ACTIONS(4766),
    [anon_sym_override] = ACTIONS(4766),
    [anon_sym_GT2] = ACTIONS(4768),
    [anon_sym_requires] = ACTIONS(4766),
  },
  [2307] = {
    [sym_string_literal] = STATE(2258),
    [sym_raw_string_literal] = STATE(2258),
    [aux_sym_concatenated_string_repeat1] = STATE(2258),
    [sym_identifier] = ACTIONS(5497),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4783),
    [anon_sym_COMMA] = ACTIONS(4783),
    [anon_sym_LPAREN2] = ACTIONS(4783),
    [anon_sym_DASH] = ACTIONS(4785),
    [anon_sym_PLUS] = ACTIONS(4785),
    [anon_sym_STAR] = ACTIONS(4785),
    [anon_sym_SLASH] = ACTIONS(4785),
    [anon_sym_PERCENT] = ACTIONS(4785),
    [anon_sym_PIPE_PIPE] = ACTIONS(4783),
    [anon_sym_AMP_AMP] = ACTIONS(4783),
    [anon_sym_PIPE] = ACTIONS(4785),
    [anon_sym_CARET] = ACTIONS(4785),
    [anon_sym_AMP] = ACTIONS(4785),
    [anon_sym_EQ_EQ] = ACTIONS(4783),
    [anon_sym_BANG_EQ] = ACTIONS(4783),
    [anon_sym_GT] = ACTIONS(4785),
    [anon_sym_GT_EQ] = ACTIONS(4785),
    [anon_sym_LT_EQ] = ACTIONS(4785),
    [anon_sym_LT] = ACTIONS(4785),
    [anon_sym_LT_LT] = ACTIONS(4785),
    [anon_sym_GT_GT] = ACTIONS(4785),
    [anon_sym_LBRACK] = ACTIONS(4783),
    [anon_sym_EQ] = ACTIONS(4785),
    [anon_sym_QMARK] = ACTIONS(4783),
    [anon_sym_STAR_EQ] = ACTIONS(4783),
    [anon_sym_SLASH_EQ] = ACTIONS(4783),
    [anon_sym_PERCENT_EQ] = ACTIONS(4783),
    [anon_sym_PLUS_EQ] = ACTIONS(4783),
    [anon_sym_DASH_EQ] = ACTIONS(4783),
    [anon_sym_LT_LT_EQ] = ACTIONS(4783),
    [anon_sym_GT_GT_EQ] = ACTIONS(4785),
    [anon_sym_AMP_EQ] = ACTIONS(4783),
    [anon_sym_CARET_EQ] = ACTIONS(4783),
    [anon_sym_PIPE_EQ] = ACTIONS(4783),
    [anon_sym_and_eq] = ACTIONS(4785),
    [anon_sym_or_eq] = ACTIONS(4785),
    [anon_sym_xor_eq] = ACTIONS(4785),
    [anon_sym_LT_EQ_GT] = ACTIONS(4783),
    [anon_sym_or] = ACTIONS(4785),
    [anon_sym_and] = ACTIONS(4785),
    [anon_sym_bitor] = ACTIONS(4785),
    [anon_sym_xor] = ACTIONS(4785),
    [anon_sym_bitand] = ACTIONS(4785),
    [anon_sym_not_eq] = ACTIONS(4785),
    [anon_sym_DASH_DASH] = ACTIONS(4783),
    [anon_sym_PLUS_PLUS] = ACTIONS(4783),
    [anon_sym_DOT] = ACTIONS(4785),
    [anon_sym_DOT_STAR] = ACTIONS(4783),
    [anon_sym_DASH_GT] = ACTIONS(4783),
    [anon_sym_L_DQUOTE] = ACTIONS(5382),
    [anon_sym_u_DQUOTE] = ACTIONS(5382),
    [anon_sym_U_DQUOTE] = ACTIONS(5382),
    [anon_sym_u8_DQUOTE] = ACTIONS(5382),
    [anon_sym_DQUOTE] = ACTIONS(5382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_GT2] = ACTIONS(4783),
    [anon_sym_R_DQUOTE] = ACTIONS(5384),
    [anon_sym_LR_DQUOTE] = ACTIONS(5384),
    [anon_sym_uR_DQUOTE] = ACTIONS(5384),
    [anon_sym_UR_DQUOTE] = ACTIONS(5384),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5384),
    [sym_literal_suffix] = ACTIONS(4785),
  },
  [2308] = {
    [sym_attribute_specifier] = STATE(2393),
    [sym_identifier] = ACTIONS(5499),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5501),
    [anon_sym_COMMA] = ACTIONS(5501),
    [anon_sym_RPAREN] = ACTIONS(5501),
    [aux_sym_preproc_if_token2] = ACTIONS(5501),
    [aux_sym_preproc_else_token1] = ACTIONS(5501),
    [aux_sym_preproc_elif_token1] = ACTIONS(5499),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5501),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5501),
    [anon_sym_LPAREN2] = ACTIONS(5501),
    [anon_sym_DASH] = ACTIONS(5499),
    [anon_sym_PLUS] = ACTIONS(5499),
    [anon_sym_STAR] = ACTIONS(5499),
    [anon_sym_SLASH] = ACTIONS(5499),
    [anon_sym_PERCENT] = ACTIONS(5499),
    [anon_sym_PIPE_PIPE] = ACTIONS(5501),
    [anon_sym_AMP_AMP] = ACTIONS(5501),
    [anon_sym_PIPE] = ACTIONS(5499),
    [anon_sym_CARET] = ACTIONS(5499),
    [anon_sym_AMP] = ACTIONS(5499),
    [anon_sym_EQ_EQ] = ACTIONS(5501),
    [anon_sym_BANG_EQ] = ACTIONS(5501),
    [anon_sym_GT] = ACTIONS(5499),
    [anon_sym_GT_EQ] = ACTIONS(5501),
    [anon_sym_LT_EQ] = ACTIONS(5499),
    [anon_sym_LT] = ACTIONS(5499),
    [anon_sym_LT_LT] = ACTIONS(5499),
    [anon_sym_GT_GT] = ACTIONS(5499),
    [anon_sym_SEMI] = ACTIONS(5501),
    [anon_sym___attribute__] = ACTIONS(4906),
    [anon_sym_LBRACE] = ACTIONS(5501),
    [anon_sym_RBRACE] = ACTIONS(5501),
    [anon_sym_LBRACK] = ACTIONS(5501),
    [anon_sym_RBRACK] = ACTIONS(5501),
    [anon_sym_EQ] = ACTIONS(5499),
    [anon_sym_COLON] = ACTIONS(5501),
    [anon_sym_QMARK] = ACTIONS(5501),
    [anon_sym_STAR_EQ] = ACTIONS(5501),
    [anon_sym_SLASH_EQ] = ACTIONS(5501),
    [anon_sym_PERCENT_EQ] = ACTIONS(5501),
    [anon_sym_PLUS_EQ] = ACTIONS(5501),
    [anon_sym_DASH_EQ] = ACTIONS(5501),
    [anon_sym_LT_LT_EQ] = ACTIONS(5501),
    [anon_sym_GT_GT_EQ] = ACTIONS(5501),
    [anon_sym_AMP_EQ] = ACTIONS(5501),
    [anon_sym_CARET_EQ] = ACTIONS(5501),
    [anon_sym_PIPE_EQ] = ACTIONS(5501),
    [anon_sym_and_eq] = ACTIONS(5499),
    [anon_sym_or_eq] = ACTIONS(5499),
    [anon_sym_xor_eq] = ACTIONS(5499),
    [anon_sym_LT_EQ_GT] = ACTIONS(5501),
    [anon_sym_or] = ACTIONS(5499),
    [anon_sym_and] = ACTIONS(5499),
    [anon_sym_bitor] = ACTIONS(5499),
    [anon_sym_xor] = ACTIONS(5499),
    [anon_sym_bitand] = ACTIONS(5499),
    [anon_sym_not_eq] = ACTIONS(5499),
    [anon_sym_DASH_DASH] = ACTIONS(5501),
    [anon_sym_PLUS_PLUS] = ACTIONS(5501),
    [anon_sym_DOT] = ACTIONS(5499),
    [anon_sym_DOT_STAR] = ACTIONS(5501),
    [anon_sym_DASH_GT] = ACTIONS(5501),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5499),
    [anon_sym_decltype] = ACTIONS(5499),
  },
  [2309] = {
    [sym_string_literal] = STATE(2617),
    [sym_template_argument_list] = STATE(3723),
    [sym_raw_string_literal] = STATE(2617),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3761),
    [anon_sym_COMMA] = ACTIONS(3761),
    [anon_sym_LPAREN2] = ACTIONS(3761),
    [anon_sym_DASH] = ACTIONS(3769),
    [anon_sym_PLUS] = ACTIONS(3769),
    [anon_sym_STAR] = ACTIONS(3769),
    [anon_sym_SLASH] = ACTIONS(3769),
    [anon_sym_PERCENT] = ACTIONS(3769),
    [anon_sym_PIPE_PIPE] = ACTIONS(3761),
    [anon_sym_AMP_AMP] = ACTIONS(3761),
    [anon_sym_PIPE] = ACTIONS(3769),
    [anon_sym_CARET] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(3769),
    [anon_sym_EQ_EQ] = ACTIONS(3761),
    [anon_sym_BANG_EQ] = ACTIONS(3761),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3761),
    [anon_sym_LT_EQ] = ACTIONS(3769),
    [anon_sym_LT] = ACTIONS(5242),
    [anon_sym_LT_LT] = ACTIONS(3769),
    [anon_sym_GT_GT] = ACTIONS(3769),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(3785),
    [anon_sym_LBRACK] = ACTIONS(3761),
    [anon_sym_RBRACK] = ACTIONS(3761),
    [anon_sym_EQ] = ACTIONS(5285),
    [anon_sym_QMARK] = ACTIONS(3761),
    [anon_sym_STAR_EQ] = ACTIONS(5287),
    [anon_sym_SLASH_EQ] = ACTIONS(5287),
    [anon_sym_PERCENT_EQ] = ACTIONS(5287),
    [anon_sym_PLUS_EQ] = ACTIONS(5287),
    [anon_sym_DASH_EQ] = ACTIONS(5287),
    [anon_sym_LT_LT_EQ] = ACTIONS(5287),
    [anon_sym_GT_GT_EQ] = ACTIONS(5287),
    [anon_sym_AMP_EQ] = ACTIONS(5287),
    [anon_sym_CARET_EQ] = ACTIONS(5287),
    [anon_sym_PIPE_EQ] = ACTIONS(5287),
    [anon_sym_and_eq] = ACTIONS(5287),
    [anon_sym_or_eq] = ACTIONS(5287),
    [anon_sym_xor_eq] = ACTIONS(5287),
    [anon_sym_LT_EQ_GT] = ACTIONS(3761),
    [anon_sym_or] = ACTIONS(3769),
    [anon_sym_and] = ACTIONS(3769),
    [anon_sym_bitor] = ACTIONS(3761),
    [anon_sym_xor] = ACTIONS(3769),
    [anon_sym_bitand] = ACTIONS(3761),
    [anon_sym_not_eq] = ACTIONS(3761),
    [anon_sym_DASH_DASH] = ACTIONS(3761),
    [anon_sym_PLUS_PLUS] = ACTIONS(3761),
    [anon_sym_DOT] = ACTIONS(3769),
    [anon_sym_DOT_STAR] = ACTIONS(3761),
    [anon_sym_DASH_GT] = ACTIONS(3761),
    [anon_sym_L_DQUOTE] = ACTIONS(3204),
    [anon_sym_u_DQUOTE] = ACTIONS(3204),
    [anon_sym_U_DQUOTE] = ACTIONS(3204),
    [anon_sym_u8_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3204),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3208),
    [anon_sym_LR_DQUOTE] = ACTIONS(3208),
    [anon_sym_uR_DQUOTE] = ACTIONS(3208),
    [anon_sym_UR_DQUOTE] = ACTIONS(3208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3208),
  },
  [2310] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4831),
    [anon_sym_COMMA] = ACTIONS(4831),
    [anon_sym_RPAREN] = ACTIONS(4831),
    [anon_sym_LPAREN2] = ACTIONS(4831),
    [anon_sym_DASH] = ACTIONS(4829),
    [anon_sym_PLUS] = ACTIONS(4829),
    [anon_sym_STAR] = ACTIONS(4829),
    [anon_sym_SLASH] = ACTIONS(4829),
    [anon_sym_PERCENT] = ACTIONS(4829),
    [anon_sym_PIPE_PIPE] = ACTIONS(4831),
    [anon_sym_AMP_AMP] = ACTIONS(4831),
    [anon_sym_PIPE] = ACTIONS(4829),
    [anon_sym_CARET] = ACTIONS(4829),
    [anon_sym_AMP] = ACTIONS(4829),
    [anon_sym_EQ_EQ] = ACTIONS(4831),
    [anon_sym_BANG_EQ] = ACTIONS(4831),
    [anon_sym_GT] = ACTIONS(4829),
    [anon_sym_GT_EQ] = ACTIONS(4831),
    [anon_sym_LT_EQ] = ACTIONS(4829),
    [anon_sym_LT] = ACTIONS(4829),
    [anon_sym_LT_LT] = ACTIONS(4829),
    [anon_sym_GT_GT] = ACTIONS(4829),
    [anon_sym_SEMI] = ACTIONS(4831),
    [anon_sym_RBRACE] = ACTIONS(4831),
    [anon_sym_LBRACK] = ACTIONS(4831),
    [anon_sym_RBRACK] = ACTIONS(4831),
    [anon_sym_EQ] = ACTIONS(4829),
    [anon_sym_COLON] = ACTIONS(4831),
    [anon_sym_QMARK] = ACTIONS(4831),
    [anon_sym_STAR_EQ] = ACTIONS(4831),
    [anon_sym_SLASH_EQ] = ACTIONS(4831),
    [anon_sym_PERCENT_EQ] = ACTIONS(4831),
    [anon_sym_PLUS_EQ] = ACTIONS(4831),
    [anon_sym_DASH_EQ] = ACTIONS(4831),
    [anon_sym_LT_LT_EQ] = ACTIONS(4831),
    [anon_sym_GT_GT_EQ] = ACTIONS(4831),
    [anon_sym_AMP_EQ] = ACTIONS(4831),
    [anon_sym_CARET_EQ] = ACTIONS(4831),
    [anon_sym_PIPE_EQ] = ACTIONS(4831),
    [anon_sym_and_eq] = ACTIONS(4829),
    [anon_sym_or_eq] = ACTIONS(4829),
    [anon_sym_xor_eq] = ACTIONS(4829),
    [anon_sym_LT_EQ_GT] = ACTIONS(4831),
    [anon_sym_or] = ACTIONS(4829),
    [anon_sym_and] = ACTIONS(4829),
    [anon_sym_bitor] = ACTIONS(4829),
    [anon_sym_xor] = ACTIONS(4829),
    [anon_sym_bitand] = ACTIONS(4829),
    [anon_sym_not_eq] = ACTIONS(4829),
    [anon_sym_DASH_DASH] = ACTIONS(4831),
    [anon_sym_PLUS_PLUS] = ACTIONS(4831),
    [anon_sym_DOT] = ACTIONS(4829),
    [anon_sym_DOT_STAR] = ACTIONS(4831),
    [anon_sym_DASH_GT] = ACTIONS(4831),
    [anon_sym_L_DQUOTE] = ACTIONS(4831),
    [anon_sym_u_DQUOTE] = ACTIONS(4831),
    [anon_sym_U_DQUOTE] = ACTIONS(4831),
    [anon_sym_u8_DQUOTE] = ACTIONS(4831),
    [anon_sym_DQUOTE] = ACTIONS(4831),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4831),
    [anon_sym_LR_DQUOTE] = ACTIONS(4831),
    [anon_sym_uR_DQUOTE] = ACTIONS(4831),
    [anon_sym_UR_DQUOTE] = ACTIONS(4831),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4831),
    [sym_literal_suffix] = ACTIONS(4829),
  },
  [2311] = {
    [sym_attribute_declaration] = STATE(2374),
    [sym_parameter_list] = STATE(2342),
    [aux_sym_attributed_declarator_repeat1] = STATE(2374),
    [sym_identifier] = ACTIONS(5503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5505),
    [anon_sym_COMMA] = ACTIONS(5505),
    [anon_sym_RPAREN] = ACTIONS(5505),
    [aux_sym_preproc_if_token2] = ACTIONS(5505),
    [aux_sym_preproc_else_token1] = ACTIONS(5505),
    [aux_sym_preproc_elif_token1] = ACTIONS(5503),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5505),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5505),
    [anon_sym_LPAREN2] = ACTIONS(5394),
    [anon_sym_DASH] = ACTIONS(5503),
    [anon_sym_PLUS] = ACTIONS(5503),
    [anon_sym_STAR] = ACTIONS(5503),
    [anon_sym_SLASH] = ACTIONS(5503),
    [anon_sym_PERCENT] = ACTIONS(5503),
    [anon_sym_PIPE_PIPE] = ACTIONS(5505),
    [anon_sym_AMP_AMP] = ACTIONS(5505),
    [anon_sym_PIPE] = ACTIONS(5503),
    [anon_sym_CARET] = ACTIONS(5503),
    [anon_sym_AMP] = ACTIONS(5503),
    [anon_sym_EQ_EQ] = ACTIONS(5505),
    [anon_sym_BANG_EQ] = ACTIONS(5505),
    [anon_sym_GT] = ACTIONS(5503),
    [anon_sym_GT_EQ] = ACTIONS(5505),
    [anon_sym_LT_EQ] = ACTIONS(5503),
    [anon_sym_LT] = ACTIONS(5503),
    [anon_sym_LT_LT] = ACTIONS(5503),
    [anon_sym_GT_GT] = ACTIONS(5503),
    [anon_sym_SEMI] = ACTIONS(5505),
    [anon_sym___attribute__] = ACTIONS(5503),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5396),
    [anon_sym_RBRACE] = ACTIONS(5505),
    [anon_sym_LBRACK] = ACTIONS(5398),
    [anon_sym_RBRACK] = ACTIONS(5505),
    [anon_sym_EQ] = ACTIONS(5503),
    [anon_sym_COLON] = ACTIONS(5505),
    [anon_sym_QMARK] = ACTIONS(5505),
    [anon_sym_STAR_EQ] = ACTIONS(5505),
    [anon_sym_SLASH_EQ] = ACTIONS(5505),
    [anon_sym_PERCENT_EQ] = ACTIONS(5505),
    [anon_sym_PLUS_EQ] = ACTIONS(5505),
    [anon_sym_DASH_EQ] = ACTIONS(5505),
    [anon_sym_LT_LT_EQ] = ACTIONS(5505),
    [anon_sym_GT_GT_EQ] = ACTIONS(5505),
    [anon_sym_AMP_EQ] = ACTIONS(5505),
    [anon_sym_CARET_EQ] = ACTIONS(5505),
    [anon_sym_PIPE_EQ] = ACTIONS(5505),
    [anon_sym_and_eq] = ACTIONS(5503),
    [anon_sym_or_eq] = ACTIONS(5503),
    [anon_sym_xor_eq] = ACTIONS(5503),
    [anon_sym_LT_EQ_GT] = ACTIONS(5505),
    [anon_sym_or] = ACTIONS(5503),
    [anon_sym_and] = ACTIONS(5503),
    [anon_sym_bitor] = ACTIONS(5503),
    [anon_sym_xor] = ACTIONS(5503),
    [anon_sym_bitand] = ACTIONS(5503),
    [anon_sym_not_eq] = ACTIONS(5503),
    [anon_sym_DASH_DASH] = ACTIONS(5505),
    [anon_sym_PLUS_PLUS] = ACTIONS(5505),
    [anon_sym_DOT] = ACTIONS(5503),
    [anon_sym_DOT_STAR] = ACTIONS(5505),
    [anon_sym_DASH_GT] = ACTIONS(5505),
    [sym_comment] = ACTIONS(3),
  },
  [2312] = {
    [sym_string_literal] = STATE(2617),
    [sym_template_argument_list] = STATE(3723),
    [sym_raw_string_literal] = STATE(2617),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3761),
    [anon_sym_COMMA] = ACTIONS(3761),
    [anon_sym_LPAREN2] = ACTIONS(3761),
    [anon_sym_DASH] = ACTIONS(3769),
    [anon_sym_PLUS] = ACTIONS(3769),
    [anon_sym_STAR] = ACTIONS(3769),
    [anon_sym_SLASH] = ACTIONS(3769),
    [anon_sym_PERCENT] = ACTIONS(3769),
    [anon_sym_PIPE_PIPE] = ACTIONS(3761),
    [anon_sym_AMP_AMP] = ACTIONS(3761),
    [anon_sym_PIPE] = ACTIONS(3769),
    [anon_sym_CARET] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(3769),
    [anon_sym_EQ_EQ] = ACTIONS(3761),
    [anon_sym_BANG_EQ] = ACTIONS(3761),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3761),
    [anon_sym_LT_EQ] = ACTIONS(3769),
    [anon_sym_LT] = ACTIONS(5242),
    [anon_sym_LT_LT] = ACTIONS(3769),
    [anon_sym_GT_GT] = ACTIONS(3769),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(3785),
    [anon_sym_LBRACK] = ACTIONS(3761),
    [anon_sym_EQ] = ACTIONS(5507),
    [anon_sym_COLON] = ACTIONS(3769),
    [anon_sym_QMARK] = ACTIONS(3761),
    [anon_sym_STAR_EQ] = ACTIONS(5509),
    [anon_sym_SLASH_EQ] = ACTIONS(5509),
    [anon_sym_PERCENT_EQ] = ACTIONS(5509),
    [anon_sym_PLUS_EQ] = ACTIONS(5509),
    [anon_sym_DASH_EQ] = ACTIONS(5509),
    [anon_sym_LT_LT_EQ] = ACTIONS(5509),
    [anon_sym_GT_GT_EQ] = ACTIONS(5509),
    [anon_sym_AMP_EQ] = ACTIONS(5509),
    [anon_sym_CARET_EQ] = ACTIONS(5509),
    [anon_sym_PIPE_EQ] = ACTIONS(5509),
    [anon_sym_and_eq] = ACTIONS(5509),
    [anon_sym_or_eq] = ACTIONS(5509),
    [anon_sym_xor_eq] = ACTIONS(5509),
    [anon_sym_LT_EQ_GT] = ACTIONS(3761),
    [anon_sym_or] = ACTIONS(3769),
    [anon_sym_and] = ACTIONS(3769),
    [anon_sym_bitor] = ACTIONS(3761),
    [anon_sym_xor] = ACTIONS(3769),
    [anon_sym_bitand] = ACTIONS(3761),
    [anon_sym_not_eq] = ACTIONS(3761),
    [anon_sym_DASH_DASH] = ACTIONS(3761),
    [anon_sym_PLUS_PLUS] = ACTIONS(3761),
    [anon_sym_DOT] = ACTIONS(3769),
    [anon_sym_DOT_STAR] = ACTIONS(3761),
    [anon_sym_DASH_GT] = ACTIONS(3761),
    [anon_sym_L_DQUOTE] = ACTIONS(3204),
    [anon_sym_u_DQUOTE] = ACTIONS(3204),
    [anon_sym_U_DQUOTE] = ACTIONS(3204),
    [anon_sym_u8_DQUOTE] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3204),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3208),
    [anon_sym_LR_DQUOTE] = ACTIONS(3208),
    [anon_sym_uR_DQUOTE] = ACTIONS(3208),
    [anon_sym_UR_DQUOTE] = ACTIONS(3208),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3208),
  },
  [2313] = {
    [sym_decltype_auto] = STATE(2351),
    [sym_identifier] = ACTIONS(4871),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4873),
    [anon_sym_COMMA] = ACTIONS(4873),
    [anon_sym_RPAREN] = ACTIONS(4873),
    [aux_sym_preproc_if_token2] = ACTIONS(4873),
    [aux_sym_preproc_else_token1] = ACTIONS(4873),
    [aux_sym_preproc_elif_token1] = ACTIONS(4871),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4873),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4873),
    [anon_sym_LPAREN2] = ACTIONS(4873),
    [anon_sym_DASH] = ACTIONS(4871),
    [anon_sym_PLUS] = ACTIONS(4871),
    [anon_sym_STAR] = ACTIONS(4871),
    [anon_sym_SLASH] = ACTIONS(4871),
    [anon_sym_PERCENT] = ACTIONS(4871),
    [anon_sym_PIPE_PIPE] = ACTIONS(4873),
    [anon_sym_AMP_AMP] = ACTIONS(4873),
    [anon_sym_PIPE] = ACTIONS(4871),
    [anon_sym_CARET] = ACTIONS(4871),
    [anon_sym_AMP] = ACTIONS(4871),
    [anon_sym_EQ_EQ] = ACTIONS(4873),
    [anon_sym_BANG_EQ] = ACTIONS(4873),
    [anon_sym_GT] = ACTIONS(4871),
    [anon_sym_GT_EQ] = ACTIONS(4873),
    [anon_sym_LT_EQ] = ACTIONS(4871),
    [anon_sym_LT] = ACTIONS(4871),
    [anon_sym_LT_LT] = ACTIONS(4871),
    [anon_sym_GT_GT] = ACTIONS(4871),
    [anon_sym_SEMI] = ACTIONS(4873),
    [anon_sym___attribute__] = ACTIONS(4871),
    [anon_sym_LBRACE] = ACTIONS(4873),
    [anon_sym_RBRACE] = ACTIONS(4873),
    [anon_sym_LBRACK] = ACTIONS(4873),
    [anon_sym_RBRACK] = ACTIONS(4873),
    [anon_sym_EQ] = ACTIONS(4871),
    [anon_sym_COLON] = ACTIONS(4873),
    [anon_sym_QMARK] = ACTIONS(4873),
    [anon_sym_STAR_EQ] = ACTIONS(4873),
    [anon_sym_SLASH_EQ] = ACTIONS(4873),
    [anon_sym_PERCENT_EQ] = ACTIONS(4873),
    [anon_sym_PLUS_EQ] = ACTIONS(4873),
    [anon_sym_DASH_EQ] = ACTIONS(4873),
    [anon_sym_LT_LT_EQ] = ACTIONS(4873),
    [anon_sym_GT_GT_EQ] = ACTIONS(4873),
    [anon_sym_AMP_EQ] = ACTIONS(4873),
    [anon_sym_CARET_EQ] = ACTIONS(4873),
    [anon_sym_PIPE_EQ] = ACTIONS(4873),
    [anon_sym_and_eq] = ACTIONS(4871),
    [anon_sym_or_eq] = ACTIONS(4871),
    [anon_sym_xor_eq] = ACTIONS(4871),
    [anon_sym_LT_EQ_GT] = ACTIONS(4873),
    [anon_sym_or] = ACTIONS(4871),
    [anon_sym_and] = ACTIONS(4871),
    [anon_sym_bitor] = ACTIONS(4871),
    [anon_sym_xor] = ACTIONS(4871),
    [anon_sym_bitand] = ACTIONS(4871),
    [anon_sym_not_eq] = ACTIONS(4871),
    [anon_sym_DASH_DASH] = ACTIONS(4873),
    [anon_sym_PLUS_PLUS] = ACTIONS(4873),
    [anon_sym_DOT] = ACTIONS(4871),
    [anon_sym_DOT_STAR] = ACTIONS(4873),
    [anon_sym_DASH_GT] = ACTIONS(4873),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5216),
    [anon_sym_decltype] = ACTIONS(5218),
  },
  [2314] = {
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_LPAREN2] = ACTIONS(1955),
    [anon_sym_TILDE] = ACTIONS(1955),
    [anon_sym_STAR] = ACTIONS(1955),
    [anon_sym_PIPE_PIPE] = ACTIONS(1955),
    [anon_sym_AMP_AMP] = ACTIONS(1955),
    [anon_sym_AMP] = ACTIONS(1957),
    [anon_sym___extension__] = ACTIONS(1957),
    [anon_sym_extern] = ACTIONS(1957),
    [anon_sym___attribute__] = ACTIONS(1957),
    [anon_sym_COLON_COLON] = ACTIONS(1955),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1955),
    [anon_sym___declspec] = ACTIONS(1957),
    [anon_sym___based] = ACTIONS(1957),
    [anon_sym___cdecl] = ACTIONS(1957),
    [anon_sym___clrcall] = ACTIONS(1957),
    [anon_sym___stdcall] = ACTIONS(1957),
    [anon_sym___fastcall] = ACTIONS(1957),
    [anon_sym___thiscall] = ACTIONS(1957),
    [anon_sym___vectorcall] = ACTIONS(1957),
    [anon_sym_signed] = ACTIONS(1957),
    [anon_sym_unsigned] = ACTIONS(1957),
    [anon_sym_long] = ACTIONS(1957),
    [anon_sym_short] = ACTIONS(1957),
    [anon_sym_LBRACK] = ACTIONS(1957),
    [anon_sym_static] = ACTIONS(1957),
    [anon_sym_register] = ACTIONS(1957),
    [anon_sym_inline] = ACTIONS(1957),
    [anon_sym___inline] = ACTIONS(1957),
    [anon_sym___inline__] = ACTIONS(1957),
    [anon_sym___forceinline] = ACTIONS(1957),
    [anon_sym_thread_local] = ACTIONS(1957),
    [anon_sym___thread] = ACTIONS(1957),
    [anon_sym_const] = ACTIONS(1957),
    [anon_sym_constexpr] = ACTIONS(1957),
    [anon_sym_volatile] = ACTIONS(1957),
    [anon_sym_restrict] = ACTIONS(1957),
    [anon_sym___restrict__] = ACTIONS(1957),
    [anon_sym__Atomic] = ACTIONS(1957),
    [anon_sym__Noreturn] = ACTIONS(1957),
    [anon_sym_noreturn] = ACTIONS(1957),
    [anon_sym_mutable] = ACTIONS(1957),
    [anon_sym_constinit] = ACTIONS(1957),
    [anon_sym_consteval] = ACTIONS(1957),
    [anon_sym_PROGMEM] = ACTIONS(1957),
    [aux_sym_primitive_type_token1] = ACTIONS(1957),
    [anon_sym_byte] = ACTIONS(1957),
    [anon_sym_word] = ACTIONS(1957),
    [anon_sym_enum] = ACTIONS(1957),
    [anon_sym_class] = ACTIONS(1957),
    [anon_sym_struct] = ACTIONS(1957),
    [anon_sym_union] = ACTIONS(1957),
    [anon_sym_or] = ACTIONS(1957),
    [anon_sym_and] = ACTIONS(1957),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1957),
    [anon_sym_decltype] = ACTIONS(1957),
    [anon_sym_virtual] = ACTIONS(1957),
    [anon_sym_alignas] = ACTIONS(1957),
    [anon_sym_explicit] = ACTIONS(1957),
    [anon_sym_typename] = ACTIONS(1957),
    [anon_sym_template] = ACTIONS(1957),
    [anon_sym_operator] = ACTIONS(1957),
    [anon_sym_friend] = ACTIONS(1957),
    [anon_sym_using] = ACTIONS(1957),
    [anon_sym_concept] = ACTIONS(1957),
  },
  [2315] = {
    [sym_identifier] = ACTIONS(4530),
    [anon_sym_LPAREN2] = ACTIONS(4532),
    [anon_sym_TILDE] = ACTIONS(4532),
    [anon_sym_STAR] = ACTIONS(4532),
    [anon_sym_PIPE_PIPE] = ACTIONS(4532),
    [anon_sym_AMP_AMP] = ACTIONS(4532),
    [anon_sym_AMP] = ACTIONS(4530),
    [anon_sym___extension__] = ACTIONS(4530),
    [anon_sym_extern] = ACTIONS(4530),
    [anon_sym___attribute__] = ACTIONS(4530),
    [anon_sym_COLON_COLON] = ACTIONS(4532),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4532),
    [anon_sym___declspec] = ACTIONS(4530),
    [anon_sym___based] = ACTIONS(4530),
    [anon_sym___cdecl] = ACTIONS(4530),
    [anon_sym___clrcall] = ACTIONS(4530),
    [anon_sym___stdcall] = ACTIONS(4530),
    [anon_sym___fastcall] = ACTIONS(4530),
    [anon_sym___thiscall] = ACTIONS(4530),
    [anon_sym___vectorcall] = ACTIONS(4530),
    [anon_sym_signed] = ACTIONS(4530),
    [anon_sym_unsigned] = ACTIONS(4530),
    [anon_sym_long] = ACTIONS(4530),
    [anon_sym_short] = ACTIONS(4530),
    [anon_sym_LBRACK] = ACTIONS(4530),
    [anon_sym_static] = ACTIONS(4530),
    [anon_sym_register] = ACTIONS(4530),
    [anon_sym_inline] = ACTIONS(4530),
    [anon_sym___inline] = ACTIONS(4530),
    [anon_sym___inline__] = ACTIONS(4530),
    [anon_sym___forceinline] = ACTIONS(4530),
    [anon_sym_thread_local] = ACTIONS(4530),
    [anon_sym___thread] = ACTIONS(4530),
    [anon_sym_const] = ACTIONS(4530),
    [anon_sym_constexpr] = ACTIONS(4530),
    [anon_sym_volatile] = ACTIONS(4530),
    [anon_sym_restrict] = ACTIONS(4530),
    [anon_sym___restrict__] = ACTIONS(4530),
    [anon_sym__Atomic] = ACTIONS(4530),
    [anon_sym__Noreturn] = ACTIONS(4530),
    [anon_sym_noreturn] = ACTIONS(4530),
    [anon_sym_mutable] = ACTIONS(4530),
    [anon_sym_constinit] = ACTIONS(4530),
    [anon_sym_consteval] = ACTIONS(4530),
    [anon_sym_PROGMEM] = ACTIONS(4530),
    [aux_sym_primitive_type_token1] = ACTIONS(4530),
    [anon_sym_byte] = ACTIONS(4530),
    [anon_sym_word] = ACTIONS(4530),
    [anon_sym_enum] = ACTIONS(4530),
    [anon_sym_class] = ACTIONS(4530),
    [anon_sym_struct] = ACTIONS(4530),
    [anon_sym_union] = ACTIONS(4530),
    [anon_sym_or] = ACTIONS(4530),
    [anon_sym_and] = ACTIONS(4530),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4530),
    [anon_sym_decltype] = ACTIONS(4530),
    [anon_sym_virtual] = ACTIONS(4530),
    [anon_sym_alignas] = ACTIONS(4530),
    [anon_sym_explicit] = ACTIONS(4530),
    [anon_sym_typename] = ACTIONS(4530),
    [anon_sym_template] = ACTIONS(4530),
    [anon_sym_operator] = ACTIONS(4530),
    [anon_sym_friend] = ACTIONS(4530),
    [anon_sym_using] = ACTIONS(4530),
    [anon_sym_concept] = ACTIONS(4530),
  },
  [2316] = {
    [sym_identifier] = ACTIONS(4867),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4869),
    [anon_sym_COMMA] = ACTIONS(4869),
    [anon_sym_RPAREN] = ACTIONS(4869),
    [aux_sym_preproc_if_token2] = ACTIONS(4869),
    [aux_sym_preproc_else_token1] = ACTIONS(4869),
    [aux_sym_preproc_elif_token1] = ACTIONS(4867),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4869),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4869),
    [anon_sym_LPAREN2] = ACTIONS(4869),
    [anon_sym_DASH] = ACTIONS(4867),
    [anon_sym_PLUS] = ACTIONS(4867),
    [anon_sym_STAR] = ACTIONS(4867),
    [anon_sym_SLASH] = ACTIONS(4867),
    [anon_sym_PERCENT] = ACTIONS(4867),
    [anon_sym_PIPE_PIPE] = ACTIONS(4869),
    [anon_sym_AMP_AMP] = ACTIONS(4869),
    [anon_sym_PIPE] = ACTIONS(4867),
    [anon_sym_CARET] = ACTIONS(4867),
    [anon_sym_AMP] = ACTIONS(4867),
    [anon_sym_EQ_EQ] = ACTIONS(4869),
    [anon_sym_BANG_EQ] = ACTIONS(4869),
    [anon_sym_GT] = ACTIONS(4867),
    [anon_sym_GT_EQ] = ACTIONS(4869),
    [anon_sym_LT_EQ] = ACTIONS(4867),
    [anon_sym_LT] = ACTIONS(4867),
    [anon_sym_LT_LT] = ACTIONS(4867),
    [anon_sym_GT_GT] = ACTIONS(4867),
    [anon_sym_SEMI] = ACTIONS(4869),
    [anon_sym___attribute__] = ACTIONS(4867),
    [anon_sym_COLON_COLON] = ACTIONS(4869),
    [anon_sym_LBRACE] = ACTIONS(4869),
    [anon_sym_RBRACE] = ACTIONS(4869),
    [anon_sym_LBRACK] = ACTIONS(4869),
    [anon_sym_RBRACK] = ACTIONS(4869),
    [anon_sym_EQ] = ACTIONS(4867),
    [anon_sym_COLON] = ACTIONS(4867),
    [anon_sym_QMARK] = ACTIONS(4869),
    [anon_sym_STAR_EQ] = ACTIONS(4869),
    [anon_sym_SLASH_EQ] = ACTIONS(4869),
    [anon_sym_PERCENT_EQ] = ACTIONS(4869),
    [anon_sym_PLUS_EQ] = ACTIONS(4869),
    [anon_sym_DASH_EQ] = ACTIONS(4869),
    [anon_sym_LT_LT_EQ] = ACTIONS(4869),
    [anon_sym_GT_GT_EQ] = ACTIONS(4869),
    [anon_sym_AMP_EQ] = ACTIONS(4869),
    [anon_sym_CARET_EQ] = ACTIONS(4869),
    [anon_sym_PIPE_EQ] = ACTIONS(4869),
    [anon_sym_and_eq] = ACTIONS(4867),
    [anon_sym_or_eq] = ACTIONS(4867),
    [anon_sym_xor_eq] = ACTIONS(4867),
    [anon_sym_LT_EQ_GT] = ACTIONS(4869),
    [anon_sym_or] = ACTIONS(4867),
    [anon_sym_and] = ACTIONS(4867),
    [anon_sym_bitor] = ACTIONS(4867),
    [anon_sym_xor] = ACTIONS(4867),
    [anon_sym_bitand] = ACTIONS(4867),
    [anon_sym_not_eq] = ACTIONS(4867),
    [anon_sym_DASH_DASH] = ACTIONS(4869),
    [anon_sym_PLUS_PLUS] = ACTIONS(4869),
    [anon_sym_DOT] = ACTIONS(4867),
    [anon_sym_DOT_STAR] = ACTIONS(4869),
    [anon_sym_DASH_GT] = ACTIONS(4869),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4867),
    [anon_sym_decltype] = ACTIONS(4867),
  },
  [2317] = {
    [sym_template_argument_list] = STATE(2017),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2381),
    [sym_identifier] = ACTIONS(3759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3767),
    [anon_sym_COMMA] = ACTIONS(3767),
    [aux_sym_preproc_if_token2] = ACTIONS(3767),
    [aux_sym_preproc_else_token1] = ACTIONS(3767),
    [aux_sym_preproc_elif_token1] = ACTIONS(3759),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3767),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3767),
    [anon_sym_LPAREN2] = ACTIONS(3767),
    [anon_sym_DASH] = ACTIONS(3759),
    [anon_sym_PLUS] = ACTIONS(3759),
    [anon_sym_STAR] = ACTIONS(3759),
    [anon_sym_SLASH] = ACTIONS(3759),
    [anon_sym_PERCENT] = ACTIONS(3759),
    [anon_sym_PIPE_PIPE] = ACTIONS(3767),
    [anon_sym_AMP_AMP] = ACTIONS(3767),
    [anon_sym_PIPE] = ACTIONS(3759),
    [anon_sym_CARET] = ACTIONS(3759),
    [anon_sym_AMP] = ACTIONS(3759),
    [anon_sym_EQ_EQ] = ACTIONS(3767),
    [anon_sym_BANG_EQ] = ACTIONS(3767),
    [anon_sym_GT] = ACTIONS(3759),
    [anon_sym_GT_EQ] = ACTIONS(3767),
    [anon_sym_LT_EQ] = ACTIONS(3759),
    [anon_sym_LT] = ACTIONS(5189),
    [anon_sym_LT_LT] = ACTIONS(3759),
    [anon_sym_GT_GT] = ACTIONS(3759),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(3767),
    [anon_sym_signed] = ACTIONS(5307),
    [anon_sym_unsigned] = ACTIONS(5307),
    [anon_sym_long] = ACTIONS(5307),
    [anon_sym_short] = ACTIONS(5307),
    [anon_sym_LBRACK] = ACTIONS(3767),
    [anon_sym_EQ] = ACTIONS(3759),
    [anon_sym_QMARK] = ACTIONS(3767),
    [anon_sym_STAR_EQ] = ACTIONS(3767),
    [anon_sym_SLASH_EQ] = ACTIONS(3767),
    [anon_sym_PERCENT_EQ] = ACTIONS(3767),
    [anon_sym_PLUS_EQ] = ACTIONS(3767),
    [anon_sym_DASH_EQ] = ACTIONS(3767),
    [anon_sym_LT_LT_EQ] = ACTIONS(3767),
    [anon_sym_GT_GT_EQ] = ACTIONS(3767),
    [anon_sym_AMP_EQ] = ACTIONS(3767),
    [anon_sym_CARET_EQ] = ACTIONS(3767),
    [anon_sym_PIPE_EQ] = ACTIONS(3767),
    [anon_sym_and_eq] = ACTIONS(3759),
    [anon_sym_or_eq] = ACTIONS(3759),
    [anon_sym_xor_eq] = ACTIONS(3759),
    [anon_sym_LT_EQ_GT] = ACTIONS(3767),
    [anon_sym_or] = ACTIONS(3759),
    [anon_sym_and] = ACTIONS(3759),
    [anon_sym_bitor] = ACTIONS(3759),
    [anon_sym_xor] = ACTIONS(3759),
    [anon_sym_bitand] = ACTIONS(3759),
    [anon_sym_not_eq] = ACTIONS(3759),
    [anon_sym_DASH_DASH] = ACTIONS(3767),
    [anon_sym_PLUS_PLUS] = ACTIONS(3767),
    [anon_sym_DOT] = ACTIONS(3759),
    [anon_sym_DOT_STAR] = ACTIONS(3767),
    [anon_sym_DASH_GT] = ACTIONS(3767),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3759),
    [anon_sym_decltype] = ACTIONS(3759),
  },
  [2318] = {
    [sym_identifier] = ACTIONS(5089),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5091),
    [anon_sym_COMMA] = ACTIONS(5091),
    [anon_sym_RPAREN] = ACTIONS(5091),
    [aux_sym_preproc_if_token2] = ACTIONS(5091),
    [aux_sym_preproc_else_token1] = ACTIONS(5091),
    [aux_sym_preproc_elif_token1] = ACTIONS(5089),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5091),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5091),
    [anon_sym_LPAREN2] = ACTIONS(5091),
    [anon_sym_DASH] = ACTIONS(5089),
    [anon_sym_PLUS] = ACTIONS(5089),
    [anon_sym_STAR] = ACTIONS(5089),
    [anon_sym_SLASH] = ACTIONS(5089),
    [anon_sym_PERCENT] = ACTIONS(5089),
    [anon_sym_PIPE_PIPE] = ACTIONS(5091),
    [anon_sym_AMP_AMP] = ACTIONS(5091),
    [anon_sym_PIPE] = ACTIONS(5089),
    [anon_sym_CARET] = ACTIONS(5089),
    [anon_sym_AMP] = ACTIONS(5089),
    [anon_sym_EQ_EQ] = ACTIONS(5091),
    [anon_sym_BANG_EQ] = ACTIONS(5091),
    [anon_sym_GT] = ACTIONS(5089),
    [anon_sym_GT_EQ] = ACTIONS(5091),
    [anon_sym_LT_EQ] = ACTIONS(5089),
    [anon_sym_LT] = ACTIONS(5089),
    [anon_sym_LT_LT] = ACTIONS(5089),
    [anon_sym_GT_GT] = ACTIONS(5089),
    [anon_sym_SEMI] = ACTIONS(5091),
    [anon_sym___attribute__] = ACTIONS(5089),
    [anon_sym_LBRACE] = ACTIONS(5091),
    [anon_sym_RBRACE] = ACTIONS(5091),
    [anon_sym_LBRACK] = ACTIONS(5091),
    [anon_sym_RBRACK] = ACTIONS(5091),
    [anon_sym_EQ] = ACTIONS(5089),
    [anon_sym_COLON] = ACTIONS(5091),
    [anon_sym_QMARK] = ACTIONS(5091),
    [anon_sym_STAR_EQ] = ACTIONS(5091),
    [anon_sym_SLASH_EQ] = ACTIONS(5091),
    [anon_sym_PERCENT_EQ] = ACTIONS(5091),
    [anon_sym_PLUS_EQ] = ACTIONS(5091),
    [anon_sym_DASH_EQ] = ACTIONS(5091),
    [anon_sym_LT_LT_EQ] = ACTIONS(5091),
    [anon_sym_GT_GT_EQ] = ACTIONS(5091),
    [anon_sym_AMP_EQ] = ACTIONS(5091),
    [anon_sym_CARET_EQ] = ACTIONS(5091),
    [anon_sym_PIPE_EQ] = ACTIONS(5091),
    [anon_sym_and_eq] = ACTIONS(5089),
    [anon_sym_or_eq] = ACTIONS(5089),
    [anon_sym_xor_eq] = ACTIONS(5089),
    [anon_sym_LT_EQ_GT] = ACTIONS(5091),
    [anon_sym_or] = ACTIONS(5089),
    [anon_sym_and] = ACTIONS(5089),
    [anon_sym_bitor] = ACTIONS(5089),
    [anon_sym_xor] = ACTIONS(5089),
    [anon_sym_bitand] = ACTIONS(5089),
    [anon_sym_not_eq] = ACTIONS(5089),
    [anon_sym_DASH_DASH] = ACTIONS(5091),
    [anon_sym_PLUS_PLUS] = ACTIONS(5091),
    [anon_sym_DOT] = ACTIONS(5089),
    [anon_sym_DOT_STAR] = ACTIONS(5091),
    [anon_sym_DASH_GT] = ACTIONS(5091),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5089),
    [anon_sym_decltype] = ACTIONS(5089),
  },
  [2319] = {
    [sym_identifier] = ACTIONS(5152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5154),
    [anon_sym_COMMA] = ACTIONS(5154),
    [anon_sym_RPAREN] = ACTIONS(5154),
    [aux_sym_preproc_if_token2] = ACTIONS(5154),
    [aux_sym_preproc_else_token1] = ACTIONS(5154),
    [aux_sym_preproc_elif_token1] = ACTIONS(5152),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5154),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5154),
    [anon_sym_LPAREN2] = ACTIONS(5154),
    [anon_sym_DASH] = ACTIONS(5152),
    [anon_sym_PLUS] = ACTIONS(5152),
    [anon_sym_STAR] = ACTIONS(5152),
    [anon_sym_SLASH] = ACTIONS(5152),
    [anon_sym_PERCENT] = ACTIONS(5152),
    [anon_sym_PIPE_PIPE] = ACTIONS(5154),
    [anon_sym_AMP_AMP] = ACTIONS(5154),
    [anon_sym_PIPE] = ACTIONS(5152),
    [anon_sym_CARET] = ACTIONS(5152),
    [anon_sym_AMP] = ACTIONS(5152),
    [anon_sym_EQ_EQ] = ACTIONS(5154),
    [anon_sym_BANG_EQ] = ACTIONS(5154),
    [anon_sym_GT] = ACTIONS(5152),
    [anon_sym_GT_EQ] = ACTIONS(5154),
    [anon_sym_LT_EQ] = ACTIONS(5152),
    [anon_sym_LT] = ACTIONS(5152),
    [anon_sym_LT_LT] = ACTIONS(5152),
    [anon_sym_GT_GT] = ACTIONS(5152),
    [anon_sym_SEMI] = ACTIONS(5154),
    [anon_sym___attribute__] = ACTIONS(5152),
    [anon_sym_LBRACE] = ACTIONS(5154),
    [anon_sym_RBRACE] = ACTIONS(5154),
    [anon_sym_LBRACK] = ACTIONS(5154),
    [anon_sym_RBRACK] = ACTIONS(5154),
    [anon_sym_EQ] = ACTIONS(5152),
    [anon_sym_COLON] = ACTIONS(5154),
    [anon_sym_QMARK] = ACTIONS(5154),
    [anon_sym_STAR_EQ] = ACTIONS(5154),
    [anon_sym_SLASH_EQ] = ACTIONS(5154),
    [anon_sym_PERCENT_EQ] = ACTIONS(5154),
    [anon_sym_PLUS_EQ] = ACTIONS(5154),
    [anon_sym_DASH_EQ] = ACTIONS(5154),
    [anon_sym_LT_LT_EQ] = ACTIONS(5154),
    [anon_sym_GT_GT_EQ] = ACTIONS(5154),
    [anon_sym_AMP_EQ] = ACTIONS(5154),
    [anon_sym_CARET_EQ] = ACTIONS(5154),
    [anon_sym_PIPE_EQ] = ACTIONS(5154),
    [anon_sym_and_eq] = ACTIONS(5152),
    [anon_sym_or_eq] = ACTIONS(5152),
    [anon_sym_xor_eq] = ACTIONS(5152),
    [anon_sym_LT_EQ_GT] = ACTIONS(5154),
    [anon_sym_or] = ACTIONS(5152),
    [anon_sym_and] = ACTIONS(5152),
    [anon_sym_bitor] = ACTIONS(5152),
    [anon_sym_xor] = ACTIONS(5152),
    [anon_sym_bitand] = ACTIONS(5152),
    [anon_sym_not_eq] = ACTIONS(5152),
    [anon_sym_DASH_DASH] = ACTIONS(5154),
    [anon_sym_PLUS_PLUS] = ACTIONS(5154),
    [anon_sym_DOT] = ACTIONS(5152),
    [anon_sym_DOT_STAR] = ACTIONS(5154),
    [anon_sym_DASH_GT] = ACTIONS(5154),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5152),
    [anon_sym_decltype] = ACTIONS(5152),
  },
  [2320] = {
    [sym_identifier] = ACTIONS(5121),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5123),
    [anon_sym_COMMA] = ACTIONS(5123),
    [anon_sym_RPAREN] = ACTIONS(5123),
    [aux_sym_preproc_if_token2] = ACTIONS(5123),
    [aux_sym_preproc_else_token1] = ACTIONS(5123),
    [aux_sym_preproc_elif_token1] = ACTIONS(5121),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5123),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5123),
    [anon_sym_LPAREN2] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5121),
    [anon_sym_PLUS] = ACTIONS(5121),
    [anon_sym_STAR] = ACTIONS(5121),
    [anon_sym_SLASH] = ACTIONS(5121),
    [anon_sym_PERCENT] = ACTIONS(5121),
    [anon_sym_PIPE_PIPE] = ACTIONS(5123),
    [anon_sym_AMP_AMP] = ACTIONS(5123),
    [anon_sym_PIPE] = ACTIONS(5121),
    [anon_sym_CARET] = ACTIONS(5121),
    [anon_sym_AMP] = ACTIONS(5121),
    [anon_sym_EQ_EQ] = ACTIONS(5123),
    [anon_sym_BANG_EQ] = ACTIONS(5123),
    [anon_sym_GT] = ACTIONS(5121),
    [anon_sym_GT_EQ] = ACTIONS(5123),
    [anon_sym_LT_EQ] = ACTIONS(5121),
    [anon_sym_LT] = ACTIONS(5121),
    [anon_sym_LT_LT] = ACTIONS(5121),
    [anon_sym_GT_GT] = ACTIONS(5121),
    [anon_sym_SEMI] = ACTIONS(5123),
    [anon_sym___attribute__] = ACTIONS(5121),
    [anon_sym_LBRACE] = ACTIONS(5123),
    [anon_sym_RBRACE] = ACTIONS(5123),
    [anon_sym_LBRACK] = ACTIONS(5123),
    [anon_sym_RBRACK] = ACTIONS(5123),
    [anon_sym_EQ] = ACTIONS(5121),
    [anon_sym_COLON] = ACTIONS(5123),
    [anon_sym_QMARK] = ACTIONS(5123),
    [anon_sym_STAR_EQ] = ACTIONS(5123),
    [anon_sym_SLASH_EQ] = ACTIONS(5123),
    [anon_sym_PERCENT_EQ] = ACTIONS(5123),
    [anon_sym_PLUS_EQ] = ACTIONS(5123),
    [anon_sym_DASH_EQ] = ACTIONS(5123),
    [anon_sym_LT_LT_EQ] = ACTIONS(5123),
    [anon_sym_GT_GT_EQ] = ACTIONS(5123),
    [anon_sym_AMP_EQ] = ACTIONS(5123),
    [anon_sym_CARET_EQ] = ACTIONS(5123),
    [anon_sym_PIPE_EQ] = ACTIONS(5123),
    [anon_sym_and_eq] = ACTIONS(5121),
    [anon_sym_or_eq] = ACTIONS(5121),
    [anon_sym_xor_eq] = ACTIONS(5121),
    [anon_sym_LT_EQ_GT] = ACTIONS(5123),
    [anon_sym_or] = ACTIONS(5121),
    [anon_sym_and] = ACTIONS(5121),
    [anon_sym_bitor] = ACTIONS(5121),
    [anon_sym_xor] = ACTIONS(5121),
    [anon_sym_bitand] = ACTIONS(5121),
    [anon_sym_not_eq] = ACTIONS(5121),
    [anon_sym_DASH_DASH] = ACTIONS(5123),
    [anon_sym_PLUS_PLUS] = ACTIONS(5123),
    [anon_sym_DOT] = ACTIONS(5121),
    [anon_sym_DOT_STAR] = ACTIONS(5123),
    [anon_sym_DASH_GT] = ACTIONS(5123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5121),
    [anon_sym_decltype] = ACTIONS(5121),
  },
  [2321] = {
    [sym_identifier] = ACTIONS(5070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5072),
    [anon_sym_COMMA] = ACTIONS(5072),
    [anon_sym_RPAREN] = ACTIONS(5072),
    [aux_sym_preproc_if_token2] = ACTIONS(5072),
    [aux_sym_preproc_else_token1] = ACTIONS(5072),
    [aux_sym_preproc_elif_token1] = ACTIONS(5070),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5072),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5072),
    [anon_sym_LPAREN2] = ACTIONS(5072),
    [anon_sym_DASH] = ACTIONS(5070),
    [anon_sym_PLUS] = ACTIONS(5070),
    [anon_sym_STAR] = ACTIONS(5070),
    [anon_sym_SLASH] = ACTIONS(5070),
    [anon_sym_PERCENT] = ACTIONS(5070),
    [anon_sym_PIPE_PIPE] = ACTIONS(5072),
    [anon_sym_AMP_AMP] = ACTIONS(5072),
    [anon_sym_PIPE] = ACTIONS(5070),
    [anon_sym_CARET] = ACTIONS(5070),
    [anon_sym_AMP] = ACTIONS(5070),
    [anon_sym_EQ_EQ] = ACTIONS(5072),
    [anon_sym_BANG_EQ] = ACTIONS(5072),
    [anon_sym_GT] = ACTIONS(5070),
    [anon_sym_GT_EQ] = ACTIONS(5072),
    [anon_sym_LT_EQ] = ACTIONS(5070),
    [anon_sym_LT] = ACTIONS(5070),
    [anon_sym_LT_LT] = ACTIONS(5070),
    [anon_sym_GT_GT] = ACTIONS(5070),
    [anon_sym_SEMI] = ACTIONS(5072),
    [anon_sym___attribute__] = ACTIONS(5070),
    [anon_sym_LBRACE] = ACTIONS(5072),
    [anon_sym_RBRACE] = ACTIONS(5072),
    [anon_sym_LBRACK] = ACTIONS(5072),
    [anon_sym_RBRACK] = ACTIONS(5072),
    [anon_sym_EQ] = ACTIONS(5070),
    [anon_sym_COLON] = ACTIONS(5072),
    [anon_sym_QMARK] = ACTIONS(5072),
    [anon_sym_STAR_EQ] = ACTIONS(5072),
    [anon_sym_SLASH_EQ] = ACTIONS(5072),
    [anon_sym_PERCENT_EQ] = ACTIONS(5072),
    [anon_sym_PLUS_EQ] = ACTIONS(5072),
    [anon_sym_DASH_EQ] = ACTIONS(5072),
    [anon_sym_LT_LT_EQ] = ACTIONS(5072),
    [anon_sym_GT_GT_EQ] = ACTIONS(5072),
    [anon_sym_AMP_EQ] = ACTIONS(5072),
    [anon_sym_CARET_EQ] = ACTIONS(5072),
    [anon_sym_PIPE_EQ] = ACTIONS(5072),
    [anon_sym_and_eq] = ACTIONS(5070),
    [anon_sym_or_eq] = ACTIONS(5070),
    [anon_sym_xor_eq] = ACTIONS(5070),
    [anon_sym_LT_EQ_GT] = ACTIONS(5072),
    [anon_sym_or] = ACTIONS(5070),
    [anon_sym_and] = ACTIONS(5070),
    [anon_sym_bitor] = ACTIONS(5070),
    [anon_sym_xor] = ACTIONS(5070),
    [anon_sym_bitand] = ACTIONS(5070),
    [anon_sym_not_eq] = ACTIONS(5070),
    [anon_sym_DASH_DASH] = ACTIONS(5072),
    [anon_sym_PLUS_PLUS] = ACTIONS(5072),
    [anon_sym_DOT] = ACTIONS(5070),
    [anon_sym_DOT_STAR] = ACTIONS(5072),
    [anon_sym_DASH_GT] = ACTIONS(5072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5070),
    [anon_sym_decltype] = ACTIONS(5070),
  },
  [2322] = {
    [sym_ms_based_modifier] = STATE(7771),
    [sym_ms_unaligned_ptr_modifier] = STATE(4186),
    [sym_ms_pointer_modifier] = STATE(2347),
    [sym__declarator] = STATE(6150),
    [sym__abstract_declarator] = STATE(6285),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_abstract_parenthesized_declarator] = STATE(6031),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_abstract_pointer_declarator] = STATE(6031),
    [sym_function_declarator] = STATE(6098),
    [sym_abstract_function_declarator] = STATE(6031),
    [sym_array_declarator] = STATE(6098),
    [sym_abstract_array_declarator] = STATE(6031),
    [sym_type_qualifier] = STATE(2844),
    [sym_parameter_list] = STATE(3343),
    [sym_decltype] = STATE(8290),
    [sym_reference_declarator] = STATE(6098),
    [sym_abstract_reference_declarator] = STATE(6031),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym__function_declarator_seq] = STATE(6035),
    [sym_template_type] = STATE(8290),
    [sym_template_function] = STATE(6098),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5695),
    [sym_qualified_identifier] = STATE(6098),
    [sym_operator_name] = STATE(6098),
    [aux_sym__type_definition_type_repeat1] = STATE(2844),
    [aux_sym_pointer_declarator_repeat1] = STATE(2347),
    [sym_identifier] = ACTIONS(5511),
    [anon_sym_COMMA] = ACTIONS(5513),
    [anon_sym_RPAREN] = ACTIONS(5513),
    [anon_sym_LPAREN2] = ACTIONS(3803),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(5515),
    [anon_sym_AMP_AMP] = ACTIONS(5517),
    [anon_sym_AMP] = ACTIONS(5519),
    [anon_sym___extension__] = ACTIONS(2917),
    [anon_sym_COLON_COLON] = ACTIONS(5521),
    [anon_sym___based] = ACTIONS(47),
    [sym_ms_restrict_modifier] = ACTIONS(2919),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(2919),
    [sym_ms_signed_ptr_modifier] = ACTIONS(2919),
    [anon_sym__unaligned] = ACTIONS(2921),
    [anon_sym___unaligned] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(5523),
    [anon_sym_EQ] = ACTIONS(5513),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_constexpr] = ACTIONS(2917),
    [anon_sym_volatile] = ACTIONS(2917),
    [anon_sym_restrict] = ACTIONS(2917),
    [anon_sym___restrict__] = ACTIONS(2917),
    [anon_sym__Atomic] = ACTIONS(2917),
    [anon_sym__Noreturn] = ACTIONS(2917),
    [anon_sym_noreturn] = ACTIONS(2917),
    [anon_sym_mutable] = ACTIONS(2917),
    [anon_sym_constinit] = ACTIONS(2917),
    [anon_sym_consteval] = ACTIONS(2917),
    [anon_sym_PROGMEM] = ACTIONS(2917),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_GT2] = ACTIONS(5513),
    [anon_sym_operator] = ACTIONS(1871),
  },
  [2323] = {
    [sym_identifier] = ACTIONS(5085),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5087),
    [anon_sym_COMMA] = ACTIONS(5087),
    [anon_sym_RPAREN] = ACTIONS(5087),
    [aux_sym_preproc_if_token2] = ACTIONS(5087),
    [aux_sym_preproc_else_token1] = ACTIONS(5087),
    [aux_sym_preproc_elif_token1] = ACTIONS(5085),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5087),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5087),
    [anon_sym_LPAREN2] = ACTIONS(5087),
    [anon_sym_DASH] = ACTIONS(5085),
    [anon_sym_PLUS] = ACTIONS(5085),
    [anon_sym_STAR] = ACTIONS(5085),
    [anon_sym_SLASH] = ACTIONS(5085),
    [anon_sym_PERCENT] = ACTIONS(5085),
    [anon_sym_PIPE_PIPE] = ACTIONS(5087),
    [anon_sym_AMP_AMP] = ACTIONS(5087),
    [anon_sym_PIPE] = ACTIONS(5085),
    [anon_sym_CARET] = ACTIONS(5085),
    [anon_sym_AMP] = ACTIONS(5085),
    [anon_sym_EQ_EQ] = ACTIONS(5087),
    [anon_sym_BANG_EQ] = ACTIONS(5087),
    [anon_sym_GT] = ACTIONS(5085),
    [anon_sym_GT_EQ] = ACTIONS(5087),
    [anon_sym_LT_EQ] = ACTIONS(5085),
    [anon_sym_LT] = ACTIONS(5085),
    [anon_sym_LT_LT] = ACTIONS(5085),
    [anon_sym_GT_GT] = ACTIONS(5085),
    [anon_sym_SEMI] = ACTIONS(5087),
    [anon_sym___attribute__] = ACTIONS(5085),
    [anon_sym_LBRACE] = ACTIONS(5087),
    [anon_sym_RBRACE] = ACTIONS(5087),
    [anon_sym_LBRACK] = ACTIONS(5087),
    [anon_sym_RBRACK] = ACTIONS(5087),
    [anon_sym_EQ] = ACTIONS(5085),
    [anon_sym_COLON] = ACTIONS(5087),
    [anon_sym_QMARK] = ACTIONS(5087),
    [anon_sym_STAR_EQ] = ACTIONS(5087),
    [anon_sym_SLASH_EQ] = ACTIONS(5087),
    [anon_sym_PERCENT_EQ] = ACTIONS(5087),
    [anon_sym_PLUS_EQ] = ACTIONS(5087),
    [anon_sym_DASH_EQ] = ACTIONS(5087),
    [anon_sym_LT_LT_EQ] = ACTIONS(5087),
    [anon_sym_GT_GT_EQ] = ACTIONS(5087),
    [anon_sym_AMP_EQ] = ACTIONS(5087),
    [anon_sym_CARET_EQ] = ACTIONS(5087),
    [anon_sym_PIPE_EQ] = ACTIONS(5087),
    [anon_sym_and_eq] = ACTIONS(5085),
    [anon_sym_or_eq] = ACTIONS(5085),
    [anon_sym_xor_eq] = ACTIONS(5085),
    [anon_sym_LT_EQ_GT] = ACTIONS(5087),
    [anon_sym_or] = ACTIONS(5085),
    [anon_sym_and] = ACTIONS(5085),
    [anon_sym_bitor] = ACTIONS(5085),
    [anon_sym_xor] = ACTIONS(5085),
    [anon_sym_bitand] = ACTIONS(5085),
    [anon_sym_not_eq] = ACTIONS(5085),
    [anon_sym_DASH_DASH] = ACTIONS(5087),
    [anon_sym_PLUS_PLUS] = ACTIONS(5087),
    [anon_sym_DOT] = ACTIONS(5085),
    [anon_sym_DOT_STAR] = ACTIONS(5087),
    [anon_sym_DASH_GT] = ACTIONS(5087),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5085),
    [anon_sym_decltype] = ACTIONS(5085),
  },
  [2324] = {
    [sym_identifier] = ACTIONS(5093),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5095),
    [anon_sym_COMMA] = ACTIONS(5095),
    [anon_sym_RPAREN] = ACTIONS(5095),
    [aux_sym_preproc_if_token2] = ACTIONS(5095),
    [aux_sym_preproc_else_token1] = ACTIONS(5095),
    [aux_sym_preproc_elif_token1] = ACTIONS(5093),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5095),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5095),
    [anon_sym_LPAREN2] = ACTIONS(5095),
    [anon_sym_DASH] = ACTIONS(5093),
    [anon_sym_PLUS] = ACTIONS(5093),
    [anon_sym_STAR] = ACTIONS(5093),
    [anon_sym_SLASH] = ACTIONS(5093),
    [anon_sym_PERCENT] = ACTIONS(5093),
    [anon_sym_PIPE_PIPE] = ACTIONS(5095),
    [anon_sym_AMP_AMP] = ACTIONS(5095),
    [anon_sym_PIPE] = ACTIONS(5093),
    [anon_sym_CARET] = ACTIONS(5093),
    [anon_sym_AMP] = ACTIONS(5093),
    [anon_sym_EQ_EQ] = ACTIONS(5095),
    [anon_sym_BANG_EQ] = ACTIONS(5095),
    [anon_sym_GT] = ACTIONS(5093),
    [anon_sym_GT_EQ] = ACTIONS(5095),
    [anon_sym_LT_EQ] = ACTIONS(5093),
    [anon_sym_LT] = ACTIONS(5093),
    [anon_sym_LT_LT] = ACTIONS(5093),
    [anon_sym_GT_GT] = ACTIONS(5093),
    [anon_sym_SEMI] = ACTIONS(5095),
    [anon_sym___attribute__] = ACTIONS(5093),
    [anon_sym_LBRACE] = ACTIONS(5095),
    [anon_sym_RBRACE] = ACTIONS(5095),
    [anon_sym_LBRACK] = ACTIONS(5095),
    [anon_sym_RBRACK] = ACTIONS(5095),
    [anon_sym_EQ] = ACTIONS(5093),
    [anon_sym_COLON] = ACTIONS(5095),
    [anon_sym_QMARK] = ACTIONS(5095),
    [anon_sym_STAR_EQ] = ACTIONS(5095),
    [anon_sym_SLASH_EQ] = ACTIONS(5095),
    [anon_sym_PERCENT_EQ] = ACTIONS(5095),
    [anon_sym_PLUS_EQ] = ACTIONS(5095),
    [anon_sym_DASH_EQ] = ACTIONS(5095),
    [anon_sym_LT_LT_EQ] = ACTIONS(5095),
    [anon_sym_GT_GT_EQ] = ACTIONS(5095),
    [anon_sym_AMP_EQ] = ACTIONS(5095),
    [anon_sym_CARET_EQ] = ACTIONS(5095),
    [anon_sym_PIPE_EQ] = ACTIONS(5095),
    [anon_sym_and_eq] = ACTIONS(5093),
    [anon_sym_or_eq] = ACTIONS(5093),
    [anon_sym_xor_eq] = ACTIONS(5093),
    [anon_sym_LT_EQ_GT] = ACTIONS(5095),
    [anon_sym_or] = ACTIONS(5093),
    [anon_sym_and] = ACTIONS(5093),
    [anon_sym_bitor] = ACTIONS(5093),
    [anon_sym_xor] = ACTIONS(5093),
    [anon_sym_bitand] = ACTIONS(5093),
    [anon_sym_not_eq] = ACTIONS(5093),
    [anon_sym_DASH_DASH] = ACTIONS(5095),
    [anon_sym_PLUS_PLUS] = ACTIONS(5095),
    [anon_sym_DOT] = ACTIONS(5093),
    [anon_sym_DOT_STAR] = ACTIONS(5095),
    [anon_sym_DASH_GT] = ACTIONS(5095),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5093),
    [anon_sym_decltype] = ACTIONS(5093),
  },
  [2325] = {
    [sym_identifier] = ACTIONS(5525),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5527),
    [anon_sym_COMMA] = ACTIONS(5527),
    [anon_sym_RPAREN] = ACTIONS(5527),
    [aux_sym_preproc_if_token2] = ACTIONS(5527),
    [aux_sym_preproc_else_token1] = ACTIONS(5527),
    [aux_sym_preproc_elif_token1] = ACTIONS(5525),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5527),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5527),
    [anon_sym_LPAREN2] = ACTIONS(5527),
    [anon_sym_DASH] = ACTIONS(5525),
    [anon_sym_PLUS] = ACTIONS(5525),
    [anon_sym_STAR] = ACTIONS(5525),
    [anon_sym_SLASH] = ACTIONS(5525),
    [anon_sym_PERCENT] = ACTIONS(5525),
    [anon_sym_PIPE_PIPE] = ACTIONS(5527),
    [anon_sym_AMP_AMP] = ACTIONS(5527),
    [anon_sym_PIPE] = ACTIONS(5525),
    [anon_sym_CARET] = ACTIONS(5525),
    [anon_sym_AMP] = ACTIONS(5525),
    [anon_sym_EQ_EQ] = ACTIONS(5527),
    [anon_sym_BANG_EQ] = ACTIONS(5527),
    [anon_sym_GT] = ACTIONS(5525),
    [anon_sym_GT_EQ] = ACTIONS(5527),
    [anon_sym_LT_EQ] = ACTIONS(5525),
    [anon_sym_LT] = ACTIONS(5525),
    [anon_sym_LT_LT] = ACTIONS(5525),
    [anon_sym_GT_GT] = ACTIONS(5525),
    [anon_sym_SEMI] = ACTIONS(5527),
    [anon_sym___attribute__] = ACTIONS(5525),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5527),
    [anon_sym_LBRACE] = ACTIONS(5527),
    [anon_sym_RBRACE] = ACTIONS(5527),
    [anon_sym_LBRACK] = ACTIONS(5525),
    [anon_sym_RBRACK] = ACTIONS(5527),
    [anon_sym_EQ] = ACTIONS(5525),
    [anon_sym_COLON] = ACTIONS(5527),
    [anon_sym_QMARK] = ACTIONS(5527),
    [anon_sym_STAR_EQ] = ACTIONS(5527),
    [anon_sym_SLASH_EQ] = ACTIONS(5527),
    [anon_sym_PERCENT_EQ] = ACTIONS(5527),
    [anon_sym_PLUS_EQ] = ACTIONS(5527),
    [anon_sym_DASH_EQ] = ACTIONS(5527),
    [anon_sym_LT_LT_EQ] = ACTIONS(5527),
    [anon_sym_GT_GT_EQ] = ACTIONS(5527),
    [anon_sym_AMP_EQ] = ACTIONS(5527),
    [anon_sym_CARET_EQ] = ACTIONS(5527),
    [anon_sym_PIPE_EQ] = ACTIONS(5527),
    [anon_sym_and_eq] = ACTIONS(5525),
    [anon_sym_or_eq] = ACTIONS(5525),
    [anon_sym_xor_eq] = ACTIONS(5525),
    [anon_sym_LT_EQ_GT] = ACTIONS(5527),
    [anon_sym_or] = ACTIONS(5525),
    [anon_sym_and] = ACTIONS(5525),
    [anon_sym_bitor] = ACTIONS(5525),
    [anon_sym_xor] = ACTIONS(5525),
    [anon_sym_bitand] = ACTIONS(5525),
    [anon_sym_not_eq] = ACTIONS(5525),
    [anon_sym_DASH_DASH] = ACTIONS(5527),
    [anon_sym_PLUS_PLUS] = ACTIONS(5527),
    [anon_sym_DOT] = ACTIONS(5525),
    [anon_sym_DOT_STAR] = ACTIONS(5527),
    [anon_sym_DASH_GT] = ACTIONS(5527),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(5525),
  },
  [2326] = {
    [sym_identifier] = ACTIONS(5145),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5147),
    [anon_sym_COMMA] = ACTIONS(5147),
    [anon_sym_RPAREN] = ACTIONS(5147),
    [aux_sym_preproc_if_token2] = ACTIONS(5147),
    [aux_sym_preproc_else_token1] = ACTIONS(5147),
    [aux_sym_preproc_elif_token1] = ACTIONS(5145),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5147),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5147),
    [anon_sym_LPAREN2] = ACTIONS(5147),
    [anon_sym_DASH] = ACTIONS(5145),
    [anon_sym_PLUS] = ACTIONS(5145),
    [anon_sym_STAR] = ACTIONS(5145),
    [anon_sym_SLASH] = ACTIONS(5145),
    [anon_sym_PERCENT] = ACTIONS(5145),
    [anon_sym_PIPE_PIPE] = ACTIONS(5147),
    [anon_sym_AMP_AMP] = ACTIONS(5147),
    [anon_sym_PIPE] = ACTIONS(5145),
    [anon_sym_CARET] = ACTIONS(5145),
    [anon_sym_AMP] = ACTIONS(5145),
    [anon_sym_EQ_EQ] = ACTIONS(5147),
    [anon_sym_BANG_EQ] = ACTIONS(5147),
    [anon_sym_GT] = ACTIONS(5145),
    [anon_sym_GT_EQ] = ACTIONS(5147),
    [anon_sym_LT_EQ] = ACTIONS(5145),
    [anon_sym_LT] = ACTIONS(5145),
    [anon_sym_LT_LT] = ACTIONS(5145),
    [anon_sym_GT_GT] = ACTIONS(5145),
    [anon_sym_SEMI] = ACTIONS(5147),
    [anon_sym___attribute__] = ACTIONS(5145),
    [anon_sym_LBRACE] = ACTIONS(5147),
    [anon_sym_RBRACE] = ACTIONS(5147),
    [anon_sym_LBRACK] = ACTIONS(5147),
    [anon_sym_RBRACK] = ACTIONS(5147),
    [anon_sym_EQ] = ACTIONS(5145),
    [anon_sym_COLON] = ACTIONS(5147),
    [anon_sym_QMARK] = ACTIONS(5147),
    [anon_sym_STAR_EQ] = ACTIONS(5147),
    [anon_sym_SLASH_EQ] = ACTIONS(5147),
    [anon_sym_PERCENT_EQ] = ACTIONS(5147),
    [anon_sym_PLUS_EQ] = ACTIONS(5147),
    [anon_sym_DASH_EQ] = ACTIONS(5147),
    [anon_sym_LT_LT_EQ] = ACTIONS(5147),
    [anon_sym_GT_GT_EQ] = ACTIONS(5147),
    [anon_sym_AMP_EQ] = ACTIONS(5147),
    [anon_sym_CARET_EQ] = ACTIONS(5147),
    [anon_sym_PIPE_EQ] = ACTIONS(5147),
    [anon_sym_and_eq] = ACTIONS(5145),
    [anon_sym_or_eq] = ACTIONS(5145),
    [anon_sym_xor_eq] = ACTIONS(5145),
    [anon_sym_LT_EQ_GT] = ACTIONS(5147),
    [anon_sym_or] = ACTIONS(5145),
    [anon_sym_and] = ACTIONS(5145),
    [anon_sym_bitor] = ACTIONS(5145),
    [anon_sym_xor] = ACTIONS(5145),
    [anon_sym_bitand] = ACTIONS(5145),
    [anon_sym_not_eq] = ACTIONS(5145),
    [anon_sym_DASH_DASH] = ACTIONS(5147),
    [anon_sym_PLUS_PLUS] = ACTIONS(5147),
    [anon_sym_DOT] = ACTIONS(5145),
    [anon_sym_DOT_STAR] = ACTIONS(5147),
    [anon_sym_DASH_GT] = ACTIONS(5147),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5145),
    [anon_sym_decltype] = ACTIONS(5145),
  },
  [2327] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2327),
    [sym_identifier] = ACTIONS(4766),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4768),
    [anon_sym_COMMA] = ACTIONS(4768),
    [anon_sym_RPAREN] = ACTIONS(4768),
    [anon_sym_LPAREN2] = ACTIONS(4768),
    [anon_sym_DASH] = ACTIONS(4766),
    [anon_sym_PLUS] = ACTIONS(4766),
    [anon_sym_STAR] = ACTIONS(4766),
    [anon_sym_SLASH] = ACTIONS(4766),
    [anon_sym_PERCENT] = ACTIONS(4766),
    [anon_sym_PIPE_PIPE] = ACTIONS(4768),
    [anon_sym_AMP_AMP] = ACTIONS(4768),
    [anon_sym_PIPE] = ACTIONS(4766),
    [anon_sym_CARET] = ACTIONS(4766),
    [anon_sym_AMP] = ACTIONS(4766),
    [anon_sym_EQ_EQ] = ACTIONS(4768),
    [anon_sym_BANG_EQ] = ACTIONS(4768),
    [anon_sym_GT] = ACTIONS(4766),
    [anon_sym_GT_EQ] = ACTIONS(4768),
    [anon_sym_LT_EQ] = ACTIONS(4766),
    [anon_sym_LT] = ACTIONS(4766),
    [anon_sym_LT_LT] = ACTIONS(4766),
    [anon_sym_GT_GT] = ACTIONS(4766),
    [anon_sym___attribute__] = ACTIONS(4766),
    [anon_sym_LBRACE] = ACTIONS(4768),
    [anon_sym_signed] = ACTIONS(5529),
    [anon_sym_unsigned] = ACTIONS(5529),
    [anon_sym_long] = ACTIONS(5529),
    [anon_sym_short] = ACTIONS(5529),
    [anon_sym_LBRACK] = ACTIONS(4768),
    [anon_sym_EQ] = ACTIONS(4766),
    [aux_sym_primitive_type_token1] = ACTIONS(4766),
    [anon_sym_byte] = ACTIONS(4766),
    [anon_sym_word] = ACTIONS(4766),
    [anon_sym_QMARK] = ACTIONS(4768),
    [anon_sym_STAR_EQ] = ACTIONS(4768),
    [anon_sym_SLASH_EQ] = ACTIONS(4768),
    [anon_sym_PERCENT_EQ] = ACTIONS(4768),
    [anon_sym_PLUS_EQ] = ACTIONS(4768),
    [anon_sym_DASH_EQ] = ACTIONS(4768),
    [anon_sym_LT_LT_EQ] = ACTIONS(4768),
    [anon_sym_GT_GT_EQ] = ACTIONS(4768),
    [anon_sym_AMP_EQ] = ACTIONS(4768),
    [anon_sym_CARET_EQ] = ACTIONS(4768),
    [anon_sym_PIPE_EQ] = ACTIONS(4768),
    [anon_sym_and_eq] = ACTIONS(4766),
    [anon_sym_or_eq] = ACTIONS(4766),
    [anon_sym_xor_eq] = ACTIONS(4766),
    [anon_sym_LT_EQ_GT] = ACTIONS(4768),
    [anon_sym_or] = ACTIONS(4766),
    [anon_sym_and] = ACTIONS(4766),
    [anon_sym_bitor] = ACTIONS(4766),
    [anon_sym_xor] = ACTIONS(4766),
    [anon_sym_bitand] = ACTIONS(4766),
    [anon_sym_not_eq] = ACTIONS(4766),
    [anon_sym_DASH_DASH] = ACTIONS(4768),
    [anon_sym_PLUS_PLUS] = ACTIONS(4768),
    [anon_sym_DOT] = ACTIONS(4766),
    [anon_sym_DOT_STAR] = ACTIONS(4768),
    [anon_sym_DASH_GT] = ACTIONS(4766),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4766),
    [anon_sym_decltype] = ACTIONS(4766),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4768),
  },
  [2328] = {
    [sym_attribute_declaration] = STATE(2328),
    [aux_sym_attributed_declarator_repeat1] = STATE(2328),
    [sym_identifier] = ACTIONS(5532),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5534),
    [anon_sym_COMMA] = ACTIONS(5534),
    [anon_sym_RPAREN] = ACTIONS(5534),
    [aux_sym_preproc_if_token2] = ACTIONS(5534),
    [aux_sym_preproc_else_token1] = ACTIONS(5534),
    [aux_sym_preproc_elif_token1] = ACTIONS(5532),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5534),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5534),
    [anon_sym_LPAREN2] = ACTIONS(5534),
    [anon_sym_DASH] = ACTIONS(5532),
    [anon_sym_PLUS] = ACTIONS(5532),
    [anon_sym_STAR] = ACTIONS(5532),
    [anon_sym_SLASH] = ACTIONS(5532),
    [anon_sym_PERCENT] = ACTIONS(5532),
    [anon_sym_PIPE_PIPE] = ACTIONS(5534),
    [anon_sym_AMP_AMP] = ACTIONS(5534),
    [anon_sym_PIPE] = ACTIONS(5532),
    [anon_sym_CARET] = ACTIONS(5532),
    [anon_sym_AMP] = ACTIONS(5532),
    [anon_sym_EQ_EQ] = ACTIONS(5534),
    [anon_sym_BANG_EQ] = ACTIONS(5534),
    [anon_sym_GT] = ACTIONS(5532),
    [anon_sym_GT_EQ] = ACTIONS(5534),
    [anon_sym_LT_EQ] = ACTIONS(5532),
    [anon_sym_LT] = ACTIONS(5532),
    [anon_sym_LT_LT] = ACTIONS(5532),
    [anon_sym_GT_GT] = ACTIONS(5532),
    [anon_sym_SEMI] = ACTIONS(5534),
    [anon_sym___attribute__] = ACTIONS(5532),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5536),
    [anon_sym_RBRACE] = ACTIONS(5534),
    [anon_sym_LBRACK] = ACTIONS(5532),
    [anon_sym_RBRACK] = ACTIONS(5534),
    [anon_sym_EQ] = ACTIONS(5532),
    [anon_sym_COLON] = ACTIONS(5534),
    [anon_sym_QMARK] = ACTIONS(5534),
    [anon_sym_STAR_EQ] = ACTIONS(5534),
    [anon_sym_SLASH_EQ] = ACTIONS(5534),
    [anon_sym_PERCENT_EQ] = ACTIONS(5534),
    [anon_sym_PLUS_EQ] = ACTIONS(5534),
    [anon_sym_DASH_EQ] = ACTIONS(5534),
    [anon_sym_LT_LT_EQ] = ACTIONS(5534),
    [anon_sym_GT_GT_EQ] = ACTIONS(5534),
    [anon_sym_AMP_EQ] = ACTIONS(5534),
    [anon_sym_CARET_EQ] = ACTIONS(5534),
    [anon_sym_PIPE_EQ] = ACTIONS(5534),
    [anon_sym_and_eq] = ACTIONS(5532),
    [anon_sym_or_eq] = ACTIONS(5532),
    [anon_sym_xor_eq] = ACTIONS(5532),
    [anon_sym_LT_EQ_GT] = ACTIONS(5534),
    [anon_sym_or] = ACTIONS(5532),
    [anon_sym_and] = ACTIONS(5532),
    [anon_sym_bitor] = ACTIONS(5532),
    [anon_sym_xor] = ACTIONS(5532),
    [anon_sym_bitand] = ACTIONS(5532),
    [anon_sym_not_eq] = ACTIONS(5532),
    [anon_sym_DASH_DASH] = ACTIONS(5534),
    [anon_sym_PLUS_PLUS] = ACTIONS(5534),
    [anon_sym_DOT] = ACTIONS(5532),
    [anon_sym_DOT_STAR] = ACTIONS(5534),
    [anon_sym_DASH_GT] = ACTIONS(5534),
    [sym_comment] = ACTIONS(3),
  },
  [2329] = {
    [sym_identifier] = ACTIONS(5054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5056),
    [anon_sym_COMMA] = ACTIONS(5056),
    [anon_sym_RPAREN] = ACTIONS(5056),
    [aux_sym_preproc_if_token2] = ACTIONS(5056),
    [aux_sym_preproc_else_token1] = ACTIONS(5056),
    [aux_sym_preproc_elif_token1] = ACTIONS(5054),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5056),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5056),
    [anon_sym_LPAREN2] = ACTIONS(5056),
    [anon_sym_DASH] = ACTIONS(5054),
    [anon_sym_PLUS] = ACTIONS(5054),
    [anon_sym_STAR] = ACTIONS(5054),
    [anon_sym_SLASH] = ACTIONS(5054),
    [anon_sym_PERCENT] = ACTIONS(5054),
    [anon_sym_PIPE_PIPE] = ACTIONS(5056),
    [anon_sym_AMP_AMP] = ACTIONS(5056),
    [anon_sym_PIPE] = ACTIONS(5054),
    [anon_sym_CARET] = ACTIONS(5054),
    [anon_sym_AMP] = ACTIONS(5054),
    [anon_sym_EQ_EQ] = ACTIONS(5056),
    [anon_sym_BANG_EQ] = ACTIONS(5056),
    [anon_sym_GT] = ACTIONS(5054),
    [anon_sym_GT_EQ] = ACTIONS(5056),
    [anon_sym_LT_EQ] = ACTIONS(5054),
    [anon_sym_LT] = ACTIONS(5054),
    [anon_sym_LT_LT] = ACTIONS(5054),
    [anon_sym_GT_GT] = ACTIONS(5054),
    [anon_sym_SEMI] = ACTIONS(5056),
    [anon_sym___attribute__] = ACTIONS(5054),
    [anon_sym_LBRACE] = ACTIONS(5056),
    [anon_sym_RBRACE] = ACTIONS(5056),
    [anon_sym_LBRACK] = ACTIONS(5056),
    [anon_sym_RBRACK] = ACTIONS(5056),
    [anon_sym_EQ] = ACTIONS(5054),
    [anon_sym_COLON] = ACTIONS(5056),
    [anon_sym_QMARK] = ACTIONS(5056),
    [anon_sym_STAR_EQ] = ACTIONS(5056),
    [anon_sym_SLASH_EQ] = ACTIONS(5056),
    [anon_sym_PERCENT_EQ] = ACTIONS(5056),
    [anon_sym_PLUS_EQ] = ACTIONS(5056),
    [anon_sym_DASH_EQ] = ACTIONS(5056),
    [anon_sym_LT_LT_EQ] = ACTIONS(5056),
    [anon_sym_GT_GT_EQ] = ACTIONS(5056),
    [anon_sym_AMP_EQ] = ACTIONS(5056),
    [anon_sym_CARET_EQ] = ACTIONS(5056),
    [anon_sym_PIPE_EQ] = ACTIONS(5056),
    [anon_sym_and_eq] = ACTIONS(5054),
    [anon_sym_or_eq] = ACTIONS(5054),
    [anon_sym_xor_eq] = ACTIONS(5054),
    [anon_sym_LT_EQ_GT] = ACTIONS(5056),
    [anon_sym_or] = ACTIONS(5054),
    [anon_sym_and] = ACTIONS(5054),
    [anon_sym_bitor] = ACTIONS(5054),
    [anon_sym_xor] = ACTIONS(5054),
    [anon_sym_bitand] = ACTIONS(5054),
    [anon_sym_not_eq] = ACTIONS(5054),
    [anon_sym_DASH_DASH] = ACTIONS(5056),
    [anon_sym_PLUS_PLUS] = ACTIONS(5056),
    [anon_sym_DOT] = ACTIONS(5054),
    [anon_sym_DOT_STAR] = ACTIONS(5056),
    [anon_sym_DASH_GT] = ACTIONS(5056),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5054),
    [anon_sym_decltype] = ACTIONS(5054),
  },
  [2330] = {
    [sym_identifier] = ACTIONS(3646),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3648),
    [anon_sym_COMMA] = ACTIONS(3648),
    [anon_sym_RPAREN] = ACTIONS(3648),
    [anon_sym_LPAREN2] = ACTIONS(3648),
    [anon_sym_TILDE] = ACTIONS(3648),
    [anon_sym_STAR] = ACTIONS(3648),
    [anon_sym_AMP_AMP] = ACTIONS(3648),
    [anon_sym_AMP] = ACTIONS(3646),
    [anon_sym_SEMI] = ACTIONS(3648),
    [anon_sym___extension__] = ACTIONS(3646),
    [anon_sym_extern] = ACTIONS(3646),
    [anon_sym___attribute__] = ACTIONS(3646),
    [anon_sym_COLON_COLON] = ACTIONS(3648),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3648),
    [anon_sym___declspec] = ACTIONS(3646),
    [anon_sym___based] = ACTIONS(3646),
    [anon_sym___cdecl] = ACTIONS(3646),
    [anon_sym___clrcall] = ACTIONS(3646),
    [anon_sym___stdcall] = ACTIONS(3646),
    [anon_sym___fastcall] = ACTIONS(3646),
    [anon_sym___thiscall] = ACTIONS(3646),
    [anon_sym___vectorcall] = ACTIONS(3646),
    [anon_sym_LBRACE] = ACTIONS(3648),
    [anon_sym_LBRACK] = ACTIONS(3646),
    [anon_sym_EQ] = ACTIONS(3648),
    [anon_sym_static] = ACTIONS(3646),
    [anon_sym_register] = ACTIONS(3646),
    [anon_sym_inline] = ACTIONS(3646),
    [anon_sym___inline] = ACTIONS(3646),
    [anon_sym___inline__] = ACTIONS(3646),
    [anon_sym___forceinline] = ACTIONS(3646),
    [anon_sym_thread_local] = ACTIONS(3646),
    [anon_sym___thread] = ACTIONS(3646),
    [anon_sym_const] = ACTIONS(3646),
    [anon_sym_constexpr] = ACTIONS(3646),
    [anon_sym_volatile] = ACTIONS(3646),
    [anon_sym_restrict] = ACTIONS(3646),
    [anon_sym___restrict__] = ACTIONS(3646),
    [anon_sym__Atomic] = ACTIONS(3646),
    [anon_sym__Noreturn] = ACTIONS(3646),
    [anon_sym_noreturn] = ACTIONS(3646),
    [anon_sym_mutable] = ACTIONS(3646),
    [anon_sym_constinit] = ACTIONS(3646),
    [anon_sym_consteval] = ACTIONS(3646),
    [anon_sym_PROGMEM] = ACTIONS(3646),
    [anon_sym_COLON] = ACTIONS(3646),
    [anon_sym_asm] = ACTIONS(3646),
    [anon_sym___asm__] = ACTIONS(3646),
    [anon_sym_DASH_GT] = ACTIONS(3648),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3646),
    [anon_sym_final] = ACTIONS(3646),
    [anon_sym_override] = ACTIONS(3646),
    [anon_sym_virtual] = ACTIONS(3646),
    [anon_sym_alignas] = ACTIONS(3646),
    [anon_sym_explicit] = ACTIONS(3646),
    [anon_sym_template] = ACTIONS(3646),
    [anon_sym_GT2] = ACTIONS(3648),
    [anon_sym_operator] = ACTIONS(3646),
    [anon_sym_try] = ACTIONS(3646),
    [anon_sym_public] = ACTIONS(3646),
    [anon_sym_private] = ACTIONS(3646),
    [anon_sym_protected] = ACTIONS(3646),
    [anon_sym_requires] = ACTIONS(3646),
  },
  [2331] = {
    [sym_identifier] = ACTIONS(5105),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5107),
    [anon_sym_COMMA] = ACTIONS(5107),
    [anon_sym_RPAREN] = ACTIONS(5107),
    [aux_sym_preproc_if_token2] = ACTIONS(5107),
    [aux_sym_preproc_else_token1] = ACTIONS(5107),
    [aux_sym_preproc_elif_token1] = ACTIONS(5105),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5107),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5107),
    [anon_sym_LPAREN2] = ACTIONS(5107),
    [anon_sym_DASH] = ACTIONS(5105),
    [anon_sym_PLUS] = ACTIONS(5105),
    [anon_sym_STAR] = ACTIONS(5105),
    [anon_sym_SLASH] = ACTIONS(5105),
    [anon_sym_PERCENT] = ACTIONS(5105),
    [anon_sym_PIPE_PIPE] = ACTIONS(5107),
    [anon_sym_AMP_AMP] = ACTIONS(5107),
    [anon_sym_PIPE] = ACTIONS(5105),
    [anon_sym_CARET] = ACTIONS(5105),
    [anon_sym_AMP] = ACTIONS(5105),
    [anon_sym_EQ_EQ] = ACTIONS(5107),
    [anon_sym_BANG_EQ] = ACTIONS(5107),
    [anon_sym_GT] = ACTIONS(5105),
    [anon_sym_GT_EQ] = ACTIONS(5107),
    [anon_sym_LT_EQ] = ACTIONS(5105),
    [anon_sym_LT] = ACTIONS(5105),
    [anon_sym_LT_LT] = ACTIONS(5105),
    [anon_sym_GT_GT] = ACTIONS(5105),
    [anon_sym_SEMI] = ACTIONS(5107),
    [anon_sym___attribute__] = ACTIONS(5105),
    [anon_sym_LBRACE] = ACTIONS(5107),
    [anon_sym_RBRACE] = ACTIONS(5107),
    [anon_sym_LBRACK] = ACTIONS(5107),
    [anon_sym_RBRACK] = ACTIONS(5107),
    [anon_sym_EQ] = ACTIONS(5105),
    [anon_sym_COLON] = ACTIONS(5107),
    [anon_sym_QMARK] = ACTIONS(5107),
    [anon_sym_STAR_EQ] = ACTIONS(5107),
    [anon_sym_SLASH_EQ] = ACTIONS(5107),
    [anon_sym_PERCENT_EQ] = ACTIONS(5107),
    [anon_sym_PLUS_EQ] = ACTIONS(5107),
    [anon_sym_DASH_EQ] = ACTIONS(5107),
    [anon_sym_LT_LT_EQ] = ACTIONS(5107),
    [anon_sym_GT_GT_EQ] = ACTIONS(5107),
    [anon_sym_AMP_EQ] = ACTIONS(5107),
    [anon_sym_CARET_EQ] = ACTIONS(5107),
    [anon_sym_PIPE_EQ] = ACTIONS(5107),
    [anon_sym_and_eq] = ACTIONS(5105),
    [anon_sym_or_eq] = ACTIONS(5105),
    [anon_sym_xor_eq] = ACTIONS(5105),
    [anon_sym_LT_EQ_GT] = ACTIONS(5107),
    [anon_sym_or] = ACTIONS(5105),
    [anon_sym_and] = ACTIONS(5105),
    [anon_sym_bitor] = ACTIONS(5105),
    [anon_sym_xor] = ACTIONS(5105),
    [anon_sym_bitand] = ACTIONS(5105),
    [anon_sym_not_eq] = ACTIONS(5105),
    [anon_sym_DASH_DASH] = ACTIONS(5107),
    [anon_sym_PLUS_PLUS] = ACTIONS(5107),
    [anon_sym_DOT] = ACTIONS(5105),
    [anon_sym_DOT_STAR] = ACTIONS(5107),
    [anon_sym_DASH_GT] = ACTIONS(5107),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5105),
    [anon_sym_decltype] = ACTIONS(5105),
  },
  [2332] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(5426),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5424),
    [anon_sym_COMMA] = ACTIONS(5424),
    [aux_sym_preproc_if_token2] = ACTIONS(5424),
    [aux_sym_preproc_else_token1] = ACTIONS(5424),
    [aux_sym_preproc_elif_token1] = ACTIONS(5426),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5424),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5424),
    [anon_sym_LPAREN2] = ACTIONS(5424),
    [anon_sym_DASH] = ACTIONS(5426),
    [anon_sym_PLUS] = ACTIONS(5426),
    [anon_sym_STAR] = ACTIONS(5426),
    [anon_sym_SLASH] = ACTIONS(5426),
    [anon_sym_PERCENT] = ACTIONS(5426),
    [anon_sym_PIPE_PIPE] = ACTIONS(5424),
    [anon_sym_AMP_AMP] = ACTIONS(5424),
    [anon_sym_PIPE] = ACTIONS(5426),
    [anon_sym_CARET] = ACTIONS(5426),
    [anon_sym_AMP] = ACTIONS(5426),
    [anon_sym_EQ_EQ] = ACTIONS(5424),
    [anon_sym_BANG_EQ] = ACTIONS(5424),
    [anon_sym_GT] = ACTIONS(5426),
    [anon_sym_GT_EQ] = ACTIONS(5424),
    [anon_sym_LT_EQ] = ACTIONS(5426),
    [anon_sym_LT] = ACTIONS(5426),
    [anon_sym_LT_LT] = ACTIONS(5426),
    [anon_sym_GT_GT] = ACTIONS(5426),
    [anon_sym___attribute__] = ACTIONS(5426),
    [anon_sym_LBRACE] = ACTIONS(5424),
    [anon_sym_signed] = ACTIONS(5539),
    [anon_sym_unsigned] = ACTIONS(5539),
    [anon_sym_long] = ACTIONS(5539),
    [anon_sym_short] = ACTIONS(5539),
    [anon_sym_LBRACK] = ACTIONS(5424),
    [anon_sym_EQ] = ACTIONS(5426),
    [anon_sym_QMARK] = ACTIONS(5424),
    [anon_sym_STAR_EQ] = ACTIONS(5424),
    [anon_sym_SLASH_EQ] = ACTIONS(5424),
    [anon_sym_PERCENT_EQ] = ACTIONS(5424),
    [anon_sym_PLUS_EQ] = ACTIONS(5424),
    [anon_sym_DASH_EQ] = ACTIONS(5424),
    [anon_sym_LT_LT_EQ] = ACTIONS(5424),
    [anon_sym_GT_GT_EQ] = ACTIONS(5424),
    [anon_sym_AMP_EQ] = ACTIONS(5424),
    [anon_sym_CARET_EQ] = ACTIONS(5424),
    [anon_sym_PIPE_EQ] = ACTIONS(5424),
    [anon_sym_and_eq] = ACTIONS(5426),
    [anon_sym_or_eq] = ACTIONS(5426),
    [anon_sym_xor_eq] = ACTIONS(5426),
    [anon_sym_LT_EQ_GT] = ACTIONS(5424),
    [anon_sym_or] = ACTIONS(5426),
    [anon_sym_and] = ACTIONS(5426),
    [anon_sym_bitor] = ACTIONS(5426),
    [anon_sym_xor] = ACTIONS(5426),
    [anon_sym_bitand] = ACTIONS(5426),
    [anon_sym_not_eq] = ACTIONS(5426),
    [anon_sym_DASH_DASH] = ACTIONS(5424),
    [anon_sym_PLUS_PLUS] = ACTIONS(5424),
    [anon_sym_DOT] = ACTIONS(5426),
    [anon_sym_DOT_STAR] = ACTIONS(5424),
    [anon_sym_DASH_GT] = ACTIONS(5424),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5426),
    [anon_sym_decltype] = ACTIONS(5426),
  },
  [2333] = {
    [sym_template_argument_list] = STATE(2395),
    [sym_identifier] = ACTIONS(4543),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4536),
    [anon_sym_COMMA] = ACTIONS(4536),
    [anon_sym_RPAREN] = ACTIONS(4536),
    [aux_sym_preproc_if_token2] = ACTIONS(4536),
    [aux_sym_preproc_else_token1] = ACTIONS(4536),
    [aux_sym_preproc_elif_token1] = ACTIONS(4543),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4536),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4536),
    [anon_sym_LPAREN2] = ACTIONS(4536),
    [anon_sym_DASH] = ACTIONS(4543),
    [anon_sym_PLUS] = ACTIONS(4543),
    [anon_sym_STAR] = ACTIONS(4543),
    [anon_sym_SLASH] = ACTIONS(4543),
    [anon_sym_PERCENT] = ACTIONS(4543),
    [anon_sym_PIPE_PIPE] = ACTIONS(4536),
    [anon_sym_AMP_AMP] = ACTIONS(4536),
    [anon_sym_PIPE] = ACTIONS(4543),
    [anon_sym_CARET] = ACTIONS(4543),
    [anon_sym_AMP] = ACTIONS(4543),
    [anon_sym_EQ_EQ] = ACTIONS(4536),
    [anon_sym_BANG_EQ] = ACTIONS(4536),
    [anon_sym_GT] = ACTIONS(4543),
    [anon_sym_GT_EQ] = ACTIONS(4536),
    [anon_sym_LT_EQ] = ACTIONS(4543),
    [anon_sym_LT] = ACTIONS(5541),
    [anon_sym_LT_LT] = ACTIONS(4543),
    [anon_sym_GT_GT] = ACTIONS(4543),
    [anon_sym_SEMI] = ACTIONS(4536),
    [anon_sym___attribute__] = ACTIONS(4543),
    [anon_sym_COLON_COLON] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(4541),
    [anon_sym_RBRACE] = ACTIONS(4536),
    [anon_sym_LBRACK] = ACTIONS(4536),
    [anon_sym_RBRACK] = ACTIONS(4536),
    [anon_sym_EQ] = ACTIONS(4543),
    [anon_sym_COLON] = ACTIONS(4543),
    [anon_sym_QMARK] = ACTIONS(4536),
    [anon_sym_STAR_EQ] = ACTIONS(4536),
    [anon_sym_SLASH_EQ] = ACTIONS(4536),
    [anon_sym_PERCENT_EQ] = ACTIONS(4536),
    [anon_sym_PLUS_EQ] = ACTIONS(4536),
    [anon_sym_DASH_EQ] = ACTIONS(4536),
    [anon_sym_LT_LT_EQ] = ACTIONS(4536),
    [anon_sym_GT_GT_EQ] = ACTIONS(4536),
    [anon_sym_AMP_EQ] = ACTIONS(4536),
    [anon_sym_CARET_EQ] = ACTIONS(4536),
    [anon_sym_PIPE_EQ] = ACTIONS(4536),
    [anon_sym_and_eq] = ACTIONS(4543),
    [anon_sym_or_eq] = ACTIONS(4543),
    [anon_sym_xor_eq] = ACTIONS(4543),
    [anon_sym_LT_EQ_GT] = ACTIONS(4536),
    [anon_sym_or] = ACTIONS(4543),
    [anon_sym_and] = ACTIONS(4543),
    [anon_sym_bitor] = ACTIONS(4543),
    [anon_sym_xor] = ACTIONS(4543),
    [anon_sym_bitand] = ACTIONS(4543),
    [anon_sym_not_eq] = ACTIONS(4543),
    [anon_sym_DASH_DASH] = ACTIONS(4536),
    [anon_sym_PLUS_PLUS] = ACTIONS(4536),
    [anon_sym_DOT] = ACTIONS(4543),
    [anon_sym_DOT_STAR] = ACTIONS(4536),
    [anon_sym_DASH_GT] = ACTIONS(4536),
    [sym_comment] = ACTIONS(3),
  },
  [2334] = {
    [sym_identifier] = ACTIONS(5109),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5111),
    [anon_sym_COMMA] = ACTIONS(5111),
    [anon_sym_RPAREN] = ACTIONS(5111),
    [aux_sym_preproc_if_token2] = ACTIONS(5111),
    [aux_sym_preproc_else_token1] = ACTIONS(5111),
    [aux_sym_preproc_elif_token1] = ACTIONS(5109),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5111),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5111),
    [anon_sym_LPAREN2] = ACTIONS(5111),
    [anon_sym_DASH] = ACTIONS(5109),
    [anon_sym_PLUS] = ACTIONS(5109),
    [anon_sym_STAR] = ACTIONS(5109),
    [anon_sym_SLASH] = ACTIONS(5109),
    [anon_sym_PERCENT] = ACTIONS(5109),
    [anon_sym_PIPE_PIPE] = ACTIONS(5111),
    [anon_sym_AMP_AMP] = ACTIONS(5111),
    [anon_sym_PIPE] = ACTIONS(5109),
    [anon_sym_CARET] = ACTIONS(5109),
    [anon_sym_AMP] = ACTIONS(5109),
    [anon_sym_EQ_EQ] = ACTIONS(5111),
    [anon_sym_BANG_EQ] = ACTIONS(5111),
    [anon_sym_GT] = ACTIONS(5109),
    [anon_sym_GT_EQ] = ACTIONS(5111),
    [anon_sym_LT_EQ] = ACTIONS(5109),
    [anon_sym_LT] = ACTIONS(5109),
    [anon_sym_LT_LT] = ACTIONS(5109),
    [anon_sym_GT_GT] = ACTIONS(5109),
    [anon_sym_SEMI] = ACTIONS(5111),
    [anon_sym___attribute__] = ACTIONS(5109),
    [anon_sym_LBRACE] = ACTIONS(5111),
    [anon_sym_RBRACE] = ACTIONS(5111),
    [anon_sym_LBRACK] = ACTIONS(5111),
    [anon_sym_RBRACK] = ACTIONS(5111),
    [anon_sym_EQ] = ACTIONS(5109),
    [anon_sym_COLON] = ACTIONS(5111),
    [anon_sym_QMARK] = ACTIONS(5111),
    [anon_sym_STAR_EQ] = ACTIONS(5111),
    [anon_sym_SLASH_EQ] = ACTIONS(5111),
    [anon_sym_PERCENT_EQ] = ACTIONS(5111),
    [anon_sym_PLUS_EQ] = ACTIONS(5111),
    [anon_sym_DASH_EQ] = ACTIONS(5111),
    [anon_sym_LT_LT_EQ] = ACTIONS(5111),
    [anon_sym_GT_GT_EQ] = ACTIONS(5111),
    [anon_sym_AMP_EQ] = ACTIONS(5111),
    [anon_sym_CARET_EQ] = ACTIONS(5111),
    [anon_sym_PIPE_EQ] = ACTIONS(5111),
    [anon_sym_and_eq] = ACTIONS(5109),
    [anon_sym_or_eq] = ACTIONS(5109),
    [anon_sym_xor_eq] = ACTIONS(5109),
    [anon_sym_LT_EQ_GT] = ACTIONS(5111),
    [anon_sym_or] = ACTIONS(5109),
    [anon_sym_and] = ACTIONS(5109),
    [anon_sym_bitor] = ACTIONS(5109),
    [anon_sym_xor] = ACTIONS(5109),
    [anon_sym_bitand] = ACTIONS(5109),
    [anon_sym_not_eq] = ACTIONS(5109),
    [anon_sym_DASH_DASH] = ACTIONS(5111),
    [anon_sym_PLUS_PLUS] = ACTIONS(5111),
    [anon_sym_DOT] = ACTIONS(5109),
    [anon_sym_DOT_STAR] = ACTIONS(5111),
    [anon_sym_DASH_GT] = ACTIONS(5111),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5109),
    [anon_sym_decltype] = ACTIONS(5109),
  },
  [2335] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(4766),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4768),
    [anon_sym_COMMA] = ACTIONS(4768),
    [aux_sym_preproc_if_token2] = ACTIONS(4768),
    [aux_sym_preproc_else_token1] = ACTIONS(4768),
    [aux_sym_preproc_elif_token1] = ACTIONS(4766),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4768),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4768),
    [anon_sym_LPAREN2] = ACTIONS(4768),
    [anon_sym_DASH] = ACTIONS(4766),
    [anon_sym_PLUS] = ACTIONS(4766),
    [anon_sym_STAR] = ACTIONS(4766),
    [anon_sym_SLASH] = ACTIONS(4766),
    [anon_sym_PERCENT] = ACTIONS(4766),
    [anon_sym_PIPE_PIPE] = ACTIONS(4768),
    [anon_sym_AMP_AMP] = ACTIONS(4768),
    [anon_sym_PIPE] = ACTIONS(4766),
    [anon_sym_CARET] = ACTIONS(4766),
    [anon_sym_AMP] = ACTIONS(4766),
    [anon_sym_EQ_EQ] = ACTIONS(4768),
    [anon_sym_BANG_EQ] = ACTIONS(4768),
    [anon_sym_GT] = ACTIONS(4766),
    [anon_sym_GT_EQ] = ACTIONS(4768),
    [anon_sym_LT_EQ] = ACTIONS(4766),
    [anon_sym_LT] = ACTIONS(4766),
    [anon_sym_LT_LT] = ACTIONS(4766),
    [anon_sym_GT_GT] = ACTIONS(4766),
    [anon_sym___attribute__] = ACTIONS(4766),
    [anon_sym_LBRACE] = ACTIONS(4768),
    [anon_sym_signed] = ACTIONS(5544),
    [anon_sym_unsigned] = ACTIONS(5544),
    [anon_sym_long] = ACTIONS(5544),
    [anon_sym_short] = ACTIONS(5544),
    [anon_sym_LBRACK] = ACTIONS(4768),
    [anon_sym_EQ] = ACTIONS(4766),
    [anon_sym_QMARK] = ACTIONS(4768),
    [anon_sym_STAR_EQ] = ACTIONS(4768),
    [anon_sym_SLASH_EQ] = ACTIONS(4768),
    [anon_sym_PERCENT_EQ] = ACTIONS(4768),
    [anon_sym_PLUS_EQ] = ACTIONS(4768),
    [anon_sym_DASH_EQ] = ACTIONS(4768),
    [anon_sym_LT_LT_EQ] = ACTIONS(4768),
    [anon_sym_GT_GT_EQ] = ACTIONS(4768),
    [anon_sym_AMP_EQ] = ACTIONS(4768),
    [anon_sym_CARET_EQ] = ACTIONS(4768),
    [anon_sym_PIPE_EQ] = ACTIONS(4768),
    [anon_sym_and_eq] = ACTIONS(4766),
    [anon_sym_or_eq] = ACTIONS(4766),
    [anon_sym_xor_eq] = ACTIONS(4766),
    [anon_sym_LT_EQ_GT] = ACTIONS(4768),
    [anon_sym_or] = ACTIONS(4766),
    [anon_sym_and] = ACTIONS(4766),
    [anon_sym_bitor] = ACTIONS(4766),
    [anon_sym_xor] = ACTIONS(4766),
    [anon_sym_bitand] = ACTIONS(4766),
    [anon_sym_not_eq] = ACTIONS(4766),
    [anon_sym_DASH_DASH] = ACTIONS(4768),
    [anon_sym_PLUS_PLUS] = ACTIONS(4768),
    [anon_sym_DOT] = ACTIONS(4766),
    [anon_sym_DOT_STAR] = ACTIONS(4768),
    [anon_sym_DASH_GT] = ACTIONS(4768),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4766),
    [anon_sym_decltype] = ACTIONS(4766),
  },
  [2336] = {
    [sym_identifier] = ACTIONS(5050),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5052),
    [anon_sym_COMMA] = ACTIONS(5052),
    [anon_sym_RPAREN] = ACTIONS(5052),
    [aux_sym_preproc_if_token2] = ACTIONS(5052),
    [aux_sym_preproc_else_token1] = ACTIONS(5052),
    [aux_sym_preproc_elif_token1] = ACTIONS(5050),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5052),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5052),
    [anon_sym_LPAREN2] = ACTIONS(5052),
    [anon_sym_DASH] = ACTIONS(5050),
    [anon_sym_PLUS] = ACTIONS(5050),
    [anon_sym_STAR] = ACTIONS(5050),
    [anon_sym_SLASH] = ACTIONS(5050),
    [anon_sym_PERCENT] = ACTIONS(5050),
    [anon_sym_PIPE_PIPE] = ACTIONS(5052),
    [anon_sym_AMP_AMP] = ACTIONS(5052),
    [anon_sym_PIPE] = ACTIONS(5050),
    [anon_sym_CARET] = ACTIONS(5050),
    [anon_sym_AMP] = ACTIONS(5050),
    [anon_sym_EQ_EQ] = ACTIONS(5052),
    [anon_sym_BANG_EQ] = ACTIONS(5052),
    [anon_sym_GT] = ACTIONS(5050),
    [anon_sym_GT_EQ] = ACTIONS(5052),
    [anon_sym_LT_EQ] = ACTIONS(5050),
    [anon_sym_LT] = ACTIONS(5050),
    [anon_sym_LT_LT] = ACTIONS(5050),
    [anon_sym_GT_GT] = ACTIONS(5050),
    [anon_sym_SEMI] = ACTIONS(5052),
    [anon_sym___attribute__] = ACTIONS(5050),
    [anon_sym_LBRACE] = ACTIONS(5052),
    [anon_sym_RBRACE] = ACTIONS(5052),
    [anon_sym_LBRACK] = ACTIONS(5052),
    [anon_sym_RBRACK] = ACTIONS(5052),
    [anon_sym_EQ] = ACTIONS(5050),
    [anon_sym_COLON] = ACTIONS(5052),
    [anon_sym_QMARK] = ACTIONS(5052),
    [anon_sym_STAR_EQ] = ACTIONS(5052),
    [anon_sym_SLASH_EQ] = ACTIONS(5052),
    [anon_sym_PERCENT_EQ] = ACTIONS(5052),
    [anon_sym_PLUS_EQ] = ACTIONS(5052),
    [anon_sym_DASH_EQ] = ACTIONS(5052),
    [anon_sym_LT_LT_EQ] = ACTIONS(5052),
    [anon_sym_GT_GT_EQ] = ACTIONS(5052),
    [anon_sym_AMP_EQ] = ACTIONS(5052),
    [anon_sym_CARET_EQ] = ACTIONS(5052),
    [anon_sym_PIPE_EQ] = ACTIONS(5052),
    [anon_sym_and_eq] = ACTIONS(5050),
    [anon_sym_or_eq] = ACTIONS(5050),
    [anon_sym_xor_eq] = ACTIONS(5050),
    [anon_sym_LT_EQ_GT] = ACTIONS(5052),
    [anon_sym_or] = ACTIONS(5050),
    [anon_sym_and] = ACTIONS(5050),
    [anon_sym_bitor] = ACTIONS(5050),
    [anon_sym_xor] = ACTIONS(5050),
    [anon_sym_bitand] = ACTIONS(5050),
    [anon_sym_not_eq] = ACTIONS(5050),
    [anon_sym_DASH_DASH] = ACTIONS(5052),
    [anon_sym_PLUS_PLUS] = ACTIONS(5052),
    [anon_sym_DOT] = ACTIONS(5050),
    [anon_sym_DOT_STAR] = ACTIONS(5052),
    [anon_sym_DASH_GT] = ACTIONS(5052),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5050),
    [anon_sym_decltype] = ACTIONS(5050),
  },
  [2337] = {
    [sym_identifier] = ACTIONS(5078),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5080),
    [anon_sym_COMMA] = ACTIONS(5080),
    [anon_sym_RPAREN] = ACTIONS(5080),
    [aux_sym_preproc_if_token2] = ACTIONS(5080),
    [aux_sym_preproc_else_token1] = ACTIONS(5080),
    [aux_sym_preproc_elif_token1] = ACTIONS(5078),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5080),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5080),
    [anon_sym_LPAREN2] = ACTIONS(5080),
    [anon_sym_DASH] = ACTIONS(5078),
    [anon_sym_PLUS] = ACTIONS(5078),
    [anon_sym_STAR] = ACTIONS(5078),
    [anon_sym_SLASH] = ACTIONS(5078),
    [anon_sym_PERCENT] = ACTIONS(5078),
    [anon_sym_PIPE_PIPE] = ACTIONS(5080),
    [anon_sym_AMP_AMP] = ACTIONS(5080),
    [anon_sym_PIPE] = ACTIONS(5078),
    [anon_sym_CARET] = ACTIONS(5078),
    [anon_sym_AMP] = ACTIONS(5078),
    [anon_sym_EQ_EQ] = ACTIONS(5080),
    [anon_sym_BANG_EQ] = ACTIONS(5080),
    [anon_sym_GT] = ACTIONS(5078),
    [anon_sym_GT_EQ] = ACTIONS(5080),
    [anon_sym_LT_EQ] = ACTIONS(5078),
    [anon_sym_LT] = ACTIONS(5078),
    [anon_sym_LT_LT] = ACTIONS(5078),
    [anon_sym_GT_GT] = ACTIONS(5078),
    [anon_sym_SEMI] = ACTIONS(5080),
    [anon_sym___attribute__] = ACTIONS(5078),
    [anon_sym_LBRACE] = ACTIONS(5080),
    [anon_sym_RBRACE] = ACTIONS(5080),
    [anon_sym_LBRACK] = ACTIONS(5080),
    [anon_sym_RBRACK] = ACTIONS(5080),
    [anon_sym_EQ] = ACTIONS(5078),
    [anon_sym_COLON] = ACTIONS(5080),
    [anon_sym_QMARK] = ACTIONS(5080),
    [anon_sym_STAR_EQ] = ACTIONS(5080),
    [anon_sym_SLASH_EQ] = ACTIONS(5080),
    [anon_sym_PERCENT_EQ] = ACTIONS(5080),
    [anon_sym_PLUS_EQ] = ACTIONS(5080),
    [anon_sym_DASH_EQ] = ACTIONS(5080),
    [anon_sym_LT_LT_EQ] = ACTIONS(5080),
    [anon_sym_GT_GT_EQ] = ACTIONS(5080),
    [anon_sym_AMP_EQ] = ACTIONS(5080),
    [anon_sym_CARET_EQ] = ACTIONS(5080),
    [anon_sym_PIPE_EQ] = ACTIONS(5080),
    [anon_sym_and_eq] = ACTIONS(5078),
    [anon_sym_or_eq] = ACTIONS(5078),
    [anon_sym_xor_eq] = ACTIONS(5078),
    [anon_sym_LT_EQ_GT] = ACTIONS(5080),
    [anon_sym_or] = ACTIONS(5078),
    [anon_sym_and] = ACTIONS(5078),
    [anon_sym_bitor] = ACTIONS(5078),
    [anon_sym_xor] = ACTIONS(5078),
    [anon_sym_bitand] = ACTIONS(5078),
    [anon_sym_not_eq] = ACTIONS(5078),
    [anon_sym_DASH_DASH] = ACTIONS(5080),
    [anon_sym_PLUS_PLUS] = ACTIONS(5080),
    [anon_sym_DOT] = ACTIONS(5078),
    [anon_sym_DOT_STAR] = ACTIONS(5080),
    [anon_sym_DASH_GT] = ACTIONS(5080),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5078),
    [anon_sym_decltype] = ACTIONS(5078),
  },
  [2338] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(5450),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5448),
    [anon_sym_COMMA] = ACTIONS(5448),
    [aux_sym_preproc_if_token2] = ACTIONS(5448),
    [aux_sym_preproc_else_token1] = ACTIONS(5448),
    [aux_sym_preproc_elif_token1] = ACTIONS(5450),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5448),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5448),
    [anon_sym_LPAREN2] = ACTIONS(5448),
    [anon_sym_DASH] = ACTIONS(5450),
    [anon_sym_PLUS] = ACTIONS(5450),
    [anon_sym_STAR] = ACTIONS(5450),
    [anon_sym_SLASH] = ACTIONS(5450),
    [anon_sym_PERCENT] = ACTIONS(5450),
    [anon_sym_PIPE_PIPE] = ACTIONS(5448),
    [anon_sym_AMP_AMP] = ACTIONS(5448),
    [anon_sym_PIPE] = ACTIONS(5450),
    [anon_sym_CARET] = ACTIONS(5450),
    [anon_sym_AMP] = ACTIONS(5450),
    [anon_sym_EQ_EQ] = ACTIONS(5448),
    [anon_sym_BANG_EQ] = ACTIONS(5448),
    [anon_sym_GT] = ACTIONS(5450),
    [anon_sym_GT_EQ] = ACTIONS(5448),
    [anon_sym_LT_EQ] = ACTIONS(5450),
    [anon_sym_LT] = ACTIONS(5450),
    [anon_sym_LT_LT] = ACTIONS(5450),
    [anon_sym_GT_GT] = ACTIONS(5450),
    [anon_sym___attribute__] = ACTIONS(5450),
    [anon_sym_LBRACE] = ACTIONS(5448),
    [anon_sym_signed] = ACTIONS(5539),
    [anon_sym_unsigned] = ACTIONS(5539),
    [anon_sym_long] = ACTIONS(5539),
    [anon_sym_short] = ACTIONS(5539),
    [anon_sym_LBRACK] = ACTIONS(5448),
    [anon_sym_EQ] = ACTIONS(5450),
    [anon_sym_QMARK] = ACTIONS(5448),
    [anon_sym_STAR_EQ] = ACTIONS(5448),
    [anon_sym_SLASH_EQ] = ACTIONS(5448),
    [anon_sym_PERCENT_EQ] = ACTIONS(5448),
    [anon_sym_PLUS_EQ] = ACTIONS(5448),
    [anon_sym_DASH_EQ] = ACTIONS(5448),
    [anon_sym_LT_LT_EQ] = ACTIONS(5448),
    [anon_sym_GT_GT_EQ] = ACTIONS(5448),
    [anon_sym_AMP_EQ] = ACTIONS(5448),
    [anon_sym_CARET_EQ] = ACTIONS(5448),
    [anon_sym_PIPE_EQ] = ACTIONS(5448),
    [anon_sym_and_eq] = ACTIONS(5450),
    [anon_sym_or_eq] = ACTIONS(5450),
    [anon_sym_xor_eq] = ACTIONS(5450),
    [anon_sym_LT_EQ_GT] = ACTIONS(5448),
    [anon_sym_or] = ACTIONS(5450),
    [anon_sym_and] = ACTIONS(5450),
    [anon_sym_bitor] = ACTIONS(5450),
    [anon_sym_xor] = ACTIONS(5450),
    [anon_sym_bitand] = ACTIONS(5450),
    [anon_sym_not_eq] = ACTIONS(5450),
    [anon_sym_DASH_DASH] = ACTIONS(5448),
    [anon_sym_PLUS_PLUS] = ACTIONS(5448),
    [anon_sym_DOT] = ACTIONS(5450),
    [anon_sym_DOT_STAR] = ACTIONS(5448),
    [anon_sym_DASH_GT] = ACTIONS(5448),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5450),
    [anon_sym_decltype] = ACTIONS(5450),
  },
  [2339] = {
    [sym_identifier] = ACTIONS(5050),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5052),
    [anon_sym_COMMA] = ACTIONS(5052),
    [anon_sym_RPAREN] = ACTIONS(5052),
    [aux_sym_preproc_if_token2] = ACTIONS(5052),
    [aux_sym_preproc_else_token1] = ACTIONS(5052),
    [aux_sym_preproc_elif_token1] = ACTIONS(5050),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5052),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5052),
    [anon_sym_LPAREN2] = ACTIONS(5052),
    [anon_sym_DASH] = ACTIONS(5050),
    [anon_sym_PLUS] = ACTIONS(5050),
    [anon_sym_STAR] = ACTIONS(5050),
    [anon_sym_SLASH] = ACTIONS(5050),
    [anon_sym_PERCENT] = ACTIONS(5050),
    [anon_sym_PIPE_PIPE] = ACTIONS(5052),
    [anon_sym_AMP_AMP] = ACTIONS(5052),
    [anon_sym_PIPE] = ACTIONS(5050),
    [anon_sym_CARET] = ACTIONS(5050),
    [anon_sym_AMP] = ACTIONS(5050),
    [anon_sym_EQ_EQ] = ACTIONS(5052),
    [anon_sym_BANG_EQ] = ACTIONS(5052),
    [anon_sym_GT] = ACTIONS(5050),
    [anon_sym_GT_EQ] = ACTIONS(5052),
    [anon_sym_LT_EQ] = ACTIONS(5050),
    [anon_sym_LT] = ACTIONS(5050),
    [anon_sym_LT_LT] = ACTIONS(5050),
    [anon_sym_GT_GT] = ACTIONS(5050),
    [anon_sym_SEMI] = ACTIONS(5052),
    [anon_sym___attribute__] = ACTIONS(5050),
    [anon_sym_LBRACE] = ACTIONS(5052),
    [anon_sym_RBRACE] = ACTIONS(5052),
    [anon_sym_LBRACK] = ACTIONS(5052),
    [anon_sym_RBRACK] = ACTIONS(5052),
    [anon_sym_EQ] = ACTIONS(5050),
    [anon_sym_COLON] = ACTIONS(5052),
    [anon_sym_QMARK] = ACTIONS(5052),
    [anon_sym_STAR_EQ] = ACTIONS(5052),
    [anon_sym_SLASH_EQ] = ACTIONS(5052),
    [anon_sym_PERCENT_EQ] = ACTIONS(5052),
    [anon_sym_PLUS_EQ] = ACTIONS(5052),
    [anon_sym_DASH_EQ] = ACTIONS(5052),
    [anon_sym_LT_LT_EQ] = ACTIONS(5052),
    [anon_sym_GT_GT_EQ] = ACTIONS(5052),
    [anon_sym_AMP_EQ] = ACTIONS(5052),
    [anon_sym_CARET_EQ] = ACTIONS(5052),
    [anon_sym_PIPE_EQ] = ACTIONS(5052),
    [anon_sym_and_eq] = ACTIONS(5050),
    [anon_sym_or_eq] = ACTIONS(5050),
    [anon_sym_xor_eq] = ACTIONS(5050),
    [anon_sym_LT_EQ_GT] = ACTIONS(5052),
    [anon_sym_or] = ACTIONS(5050),
    [anon_sym_and] = ACTIONS(5050),
    [anon_sym_bitor] = ACTIONS(5050),
    [anon_sym_xor] = ACTIONS(5050),
    [anon_sym_bitand] = ACTIONS(5050),
    [anon_sym_not_eq] = ACTIONS(5050),
    [anon_sym_DASH_DASH] = ACTIONS(5052),
    [anon_sym_PLUS_PLUS] = ACTIONS(5052),
    [anon_sym_DOT] = ACTIONS(5050),
    [anon_sym_DOT_STAR] = ACTIONS(5052),
    [anon_sym_DASH_GT] = ACTIONS(5052),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5050),
    [anon_sym_decltype] = ACTIONS(5050),
  },
  [2340] = {
    [sym_identifier] = ACTIONS(5547),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5549),
    [anon_sym_COMMA] = ACTIONS(5549),
    [anon_sym_RPAREN] = ACTIONS(5549),
    [aux_sym_preproc_if_token2] = ACTIONS(5549),
    [aux_sym_preproc_else_token1] = ACTIONS(5549),
    [aux_sym_preproc_elif_token1] = ACTIONS(5547),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5549),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5549),
    [anon_sym_LPAREN2] = ACTIONS(5549),
    [anon_sym_DASH] = ACTIONS(5547),
    [anon_sym_PLUS] = ACTIONS(5547),
    [anon_sym_STAR] = ACTIONS(5547),
    [anon_sym_SLASH] = ACTIONS(5547),
    [anon_sym_PERCENT] = ACTIONS(5547),
    [anon_sym_PIPE_PIPE] = ACTIONS(5549),
    [anon_sym_AMP_AMP] = ACTIONS(5549),
    [anon_sym_PIPE] = ACTIONS(5547),
    [anon_sym_CARET] = ACTIONS(5547),
    [anon_sym_AMP] = ACTIONS(5547),
    [anon_sym_EQ_EQ] = ACTIONS(5549),
    [anon_sym_BANG_EQ] = ACTIONS(5549),
    [anon_sym_GT] = ACTIONS(5547),
    [anon_sym_GT_EQ] = ACTIONS(5549),
    [anon_sym_LT_EQ] = ACTIONS(5547),
    [anon_sym_LT] = ACTIONS(5547),
    [anon_sym_LT_LT] = ACTIONS(5547),
    [anon_sym_GT_GT] = ACTIONS(5547),
    [anon_sym_SEMI] = ACTIONS(5549),
    [anon_sym___attribute__] = ACTIONS(5547),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5549),
    [anon_sym_LBRACE] = ACTIONS(5549),
    [anon_sym_RBRACE] = ACTIONS(5549),
    [anon_sym_LBRACK] = ACTIONS(5547),
    [anon_sym_RBRACK] = ACTIONS(5549),
    [anon_sym_EQ] = ACTIONS(5547),
    [anon_sym_COLON] = ACTIONS(5549),
    [anon_sym_QMARK] = ACTIONS(5549),
    [anon_sym_STAR_EQ] = ACTIONS(5549),
    [anon_sym_SLASH_EQ] = ACTIONS(5549),
    [anon_sym_PERCENT_EQ] = ACTIONS(5549),
    [anon_sym_PLUS_EQ] = ACTIONS(5549),
    [anon_sym_DASH_EQ] = ACTIONS(5549),
    [anon_sym_LT_LT_EQ] = ACTIONS(5549),
    [anon_sym_GT_GT_EQ] = ACTIONS(5549),
    [anon_sym_AMP_EQ] = ACTIONS(5549),
    [anon_sym_CARET_EQ] = ACTIONS(5549),
    [anon_sym_PIPE_EQ] = ACTIONS(5549),
    [anon_sym_and_eq] = ACTIONS(5547),
    [anon_sym_or_eq] = ACTIONS(5547),
    [anon_sym_xor_eq] = ACTIONS(5547),
    [anon_sym_LT_EQ_GT] = ACTIONS(5549),
    [anon_sym_or] = ACTIONS(5547),
    [anon_sym_and] = ACTIONS(5547),
    [anon_sym_bitor] = ACTIONS(5547),
    [anon_sym_xor] = ACTIONS(5547),
    [anon_sym_bitand] = ACTIONS(5547),
    [anon_sym_not_eq] = ACTIONS(5547),
    [anon_sym_DASH_DASH] = ACTIONS(5549),
    [anon_sym_PLUS_PLUS] = ACTIONS(5549),
    [anon_sym_DOT] = ACTIONS(5547),
    [anon_sym_DOT_STAR] = ACTIONS(5549),
    [anon_sym_DASH_GT] = ACTIONS(5549),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(5547),
  },
  [2341] = {
    [sym_identifier] = ACTIONS(5074),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5076),
    [anon_sym_COMMA] = ACTIONS(5076),
    [anon_sym_RPAREN] = ACTIONS(5076),
    [aux_sym_preproc_if_token2] = ACTIONS(5076),
    [aux_sym_preproc_else_token1] = ACTIONS(5076),
    [aux_sym_preproc_elif_token1] = ACTIONS(5074),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5076),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5076),
    [anon_sym_LPAREN2] = ACTIONS(5076),
    [anon_sym_DASH] = ACTIONS(5074),
    [anon_sym_PLUS] = ACTIONS(5074),
    [anon_sym_STAR] = ACTIONS(5074),
    [anon_sym_SLASH] = ACTIONS(5074),
    [anon_sym_PERCENT] = ACTIONS(5074),
    [anon_sym_PIPE_PIPE] = ACTIONS(5076),
    [anon_sym_AMP_AMP] = ACTIONS(5076),
    [anon_sym_PIPE] = ACTIONS(5074),
    [anon_sym_CARET] = ACTIONS(5074),
    [anon_sym_AMP] = ACTIONS(5074),
    [anon_sym_EQ_EQ] = ACTIONS(5076),
    [anon_sym_BANG_EQ] = ACTIONS(5076),
    [anon_sym_GT] = ACTIONS(5074),
    [anon_sym_GT_EQ] = ACTIONS(5076),
    [anon_sym_LT_EQ] = ACTIONS(5074),
    [anon_sym_LT] = ACTIONS(5074),
    [anon_sym_LT_LT] = ACTIONS(5074),
    [anon_sym_GT_GT] = ACTIONS(5074),
    [anon_sym_SEMI] = ACTIONS(5076),
    [anon_sym___attribute__] = ACTIONS(5074),
    [anon_sym_LBRACE] = ACTIONS(5076),
    [anon_sym_RBRACE] = ACTIONS(5076),
    [anon_sym_LBRACK] = ACTIONS(5076),
    [anon_sym_RBRACK] = ACTIONS(5076),
    [anon_sym_EQ] = ACTIONS(5074),
    [anon_sym_COLON] = ACTIONS(5076),
    [anon_sym_QMARK] = ACTIONS(5076),
    [anon_sym_STAR_EQ] = ACTIONS(5076),
    [anon_sym_SLASH_EQ] = ACTIONS(5076),
    [anon_sym_PERCENT_EQ] = ACTIONS(5076),
    [anon_sym_PLUS_EQ] = ACTIONS(5076),
    [anon_sym_DASH_EQ] = ACTIONS(5076),
    [anon_sym_LT_LT_EQ] = ACTIONS(5076),
    [anon_sym_GT_GT_EQ] = ACTIONS(5076),
    [anon_sym_AMP_EQ] = ACTIONS(5076),
    [anon_sym_CARET_EQ] = ACTIONS(5076),
    [anon_sym_PIPE_EQ] = ACTIONS(5076),
    [anon_sym_and_eq] = ACTIONS(5074),
    [anon_sym_or_eq] = ACTIONS(5074),
    [anon_sym_xor_eq] = ACTIONS(5074),
    [anon_sym_LT_EQ_GT] = ACTIONS(5076),
    [anon_sym_or] = ACTIONS(5074),
    [anon_sym_and] = ACTIONS(5074),
    [anon_sym_bitor] = ACTIONS(5074),
    [anon_sym_xor] = ACTIONS(5074),
    [anon_sym_bitand] = ACTIONS(5074),
    [anon_sym_not_eq] = ACTIONS(5074),
    [anon_sym_DASH_DASH] = ACTIONS(5076),
    [anon_sym_PLUS_PLUS] = ACTIONS(5076),
    [anon_sym_DOT] = ACTIONS(5074),
    [anon_sym_DOT_STAR] = ACTIONS(5076),
    [anon_sym_DASH_GT] = ACTIONS(5076),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5074),
    [anon_sym_decltype] = ACTIONS(5074),
  },
  [2342] = {
    [sym_identifier] = ACTIONS(5551),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5553),
    [anon_sym_COMMA] = ACTIONS(5553),
    [anon_sym_RPAREN] = ACTIONS(5553),
    [aux_sym_preproc_if_token2] = ACTIONS(5553),
    [aux_sym_preproc_else_token1] = ACTIONS(5553),
    [aux_sym_preproc_elif_token1] = ACTIONS(5551),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5553),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5553),
    [anon_sym_LPAREN2] = ACTIONS(5553),
    [anon_sym_DASH] = ACTIONS(5551),
    [anon_sym_PLUS] = ACTIONS(5551),
    [anon_sym_STAR] = ACTIONS(5551),
    [anon_sym_SLASH] = ACTIONS(5551),
    [anon_sym_PERCENT] = ACTIONS(5551),
    [anon_sym_PIPE_PIPE] = ACTIONS(5553),
    [anon_sym_AMP_AMP] = ACTIONS(5553),
    [anon_sym_PIPE] = ACTIONS(5551),
    [anon_sym_CARET] = ACTIONS(5551),
    [anon_sym_AMP] = ACTIONS(5551),
    [anon_sym_EQ_EQ] = ACTIONS(5553),
    [anon_sym_BANG_EQ] = ACTIONS(5553),
    [anon_sym_GT] = ACTIONS(5551),
    [anon_sym_GT_EQ] = ACTIONS(5553),
    [anon_sym_LT_EQ] = ACTIONS(5551),
    [anon_sym_LT] = ACTIONS(5551),
    [anon_sym_LT_LT] = ACTIONS(5551),
    [anon_sym_GT_GT] = ACTIONS(5551),
    [anon_sym_SEMI] = ACTIONS(5553),
    [anon_sym___attribute__] = ACTIONS(5551),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5553),
    [anon_sym_LBRACE] = ACTIONS(5553),
    [anon_sym_RBRACE] = ACTIONS(5553),
    [anon_sym_LBRACK] = ACTIONS(5551),
    [anon_sym_RBRACK] = ACTIONS(5553),
    [anon_sym_EQ] = ACTIONS(5551),
    [anon_sym_COLON] = ACTIONS(5553),
    [anon_sym_QMARK] = ACTIONS(5553),
    [anon_sym_STAR_EQ] = ACTIONS(5553),
    [anon_sym_SLASH_EQ] = ACTIONS(5553),
    [anon_sym_PERCENT_EQ] = ACTIONS(5553),
    [anon_sym_PLUS_EQ] = ACTIONS(5553),
    [anon_sym_DASH_EQ] = ACTIONS(5553),
    [anon_sym_LT_LT_EQ] = ACTIONS(5553),
    [anon_sym_GT_GT_EQ] = ACTIONS(5553),
    [anon_sym_AMP_EQ] = ACTIONS(5553),
    [anon_sym_CARET_EQ] = ACTIONS(5553),
    [anon_sym_PIPE_EQ] = ACTIONS(5553),
    [anon_sym_and_eq] = ACTIONS(5551),
    [anon_sym_or_eq] = ACTIONS(5551),
    [anon_sym_xor_eq] = ACTIONS(5551),
    [anon_sym_LT_EQ_GT] = ACTIONS(5553),
    [anon_sym_or] = ACTIONS(5551),
    [anon_sym_and] = ACTIONS(5551),
    [anon_sym_bitor] = ACTIONS(5551),
    [anon_sym_xor] = ACTIONS(5551),
    [anon_sym_bitand] = ACTIONS(5551),
    [anon_sym_not_eq] = ACTIONS(5551),
    [anon_sym_DASH_DASH] = ACTIONS(5553),
    [anon_sym_PLUS_PLUS] = ACTIONS(5553),
    [anon_sym_DOT] = ACTIONS(5551),
    [anon_sym_DOT_STAR] = ACTIONS(5553),
    [anon_sym_DASH_GT] = ACTIONS(5553),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(5551),
  },
  [2343] = {
    [sym_string_literal] = STATE(2116),
    [sym_raw_string_literal] = STATE(2116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5199),
    [anon_sym_COMMA] = ACTIONS(5199),
    [anon_sym_LPAREN2] = ACTIONS(5199),
    [anon_sym_DASH] = ACTIONS(5197),
    [anon_sym_PLUS] = ACTIONS(5197),
    [anon_sym_STAR] = ACTIONS(5197),
    [anon_sym_SLASH] = ACTIONS(5197),
    [anon_sym_PERCENT] = ACTIONS(5197),
    [anon_sym_PIPE_PIPE] = ACTIONS(5199),
    [anon_sym_AMP_AMP] = ACTIONS(5199),
    [anon_sym_PIPE] = ACTIONS(5197),
    [anon_sym_CARET] = ACTIONS(5197),
    [anon_sym_AMP] = ACTIONS(5197),
    [anon_sym_EQ_EQ] = ACTIONS(5199),
    [anon_sym_BANG_EQ] = ACTIONS(5199),
    [anon_sym_GT] = ACTIONS(5197),
    [anon_sym_GT_EQ] = ACTIONS(5199),
    [anon_sym_LT_EQ] = ACTIONS(5197),
    [anon_sym_LT] = ACTIONS(5197),
    [anon_sym_LT_LT] = ACTIONS(5197),
    [anon_sym_GT_GT] = ACTIONS(5197),
    [anon_sym_SEMI] = ACTIONS(5199),
    [anon_sym___attribute__] = ACTIONS(5197),
    [anon_sym_LBRACK] = ACTIONS(5199),
    [anon_sym_EQ] = ACTIONS(5197),
    [anon_sym_QMARK] = ACTIONS(5199),
    [anon_sym_STAR_EQ] = ACTIONS(5199),
    [anon_sym_SLASH_EQ] = ACTIONS(5199),
    [anon_sym_PERCENT_EQ] = ACTIONS(5199),
    [anon_sym_PLUS_EQ] = ACTIONS(5199),
    [anon_sym_DASH_EQ] = ACTIONS(5199),
    [anon_sym_LT_LT_EQ] = ACTIONS(5199),
    [anon_sym_GT_GT_EQ] = ACTIONS(5199),
    [anon_sym_AMP_EQ] = ACTIONS(5199),
    [anon_sym_CARET_EQ] = ACTIONS(5199),
    [anon_sym_PIPE_EQ] = ACTIONS(5199),
    [anon_sym_and_eq] = ACTIONS(5197),
    [anon_sym_or_eq] = ACTIONS(5197),
    [anon_sym_xor_eq] = ACTIONS(5197),
    [anon_sym_LT_EQ_GT] = ACTIONS(5199),
    [anon_sym_or] = ACTIONS(5197),
    [anon_sym_and] = ACTIONS(5197),
    [anon_sym_bitor] = ACTIONS(5197),
    [anon_sym_xor] = ACTIONS(5197),
    [anon_sym_bitand] = ACTIONS(5197),
    [anon_sym_not_eq] = ACTIONS(5197),
    [anon_sym_DASH_DASH] = ACTIONS(5199),
    [anon_sym_PLUS_PLUS] = ACTIONS(5199),
    [anon_sym_DOT] = ACTIONS(5197),
    [anon_sym_DOT_STAR] = ACTIONS(5199),
    [anon_sym_DASH_GT] = ACTIONS(5199),
    [anon_sym_L_DQUOTE] = ACTIONS(5289),
    [anon_sym_u_DQUOTE] = ACTIONS(5289),
    [anon_sym_U_DQUOTE] = ACTIONS(5289),
    [anon_sym_u8_DQUOTE] = ACTIONS(5289),
    [anon_sym_DQUOTE] = ACTIONS(5289),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5291),
    [anon_sym_LR_DQUOTE] = ACTIONS(5291),
    [anon_sym_uR_DQUOTE] = ACTIONS(5291),
    [anon_sym_UR_DQUOTE] = ACTIONS(5291),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5291),
    [sym_literal_suffix] = ACTIONS(5201),
  },
  [2344] = {
    [sym_identifier] = ACTIONS(5113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5115),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_RPAREN] = ACTIONS(5115),
    [aux_sym_preproc_if_token2] = ACTIONS(5115),
    [aux_sym_preproc_else_token1] = ACTIONS(5115),
    [aux_sym_preproc_elif_token1] = ACTIONS(5113),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5115),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5115),
    [anon_sym_LPAREN2] = ACTIONS(5115),
    [anon_sym_DASH] = ACTIONS(5113),
    [anon_sym_PLUS] = ACTIONS(5113),
    [anon_sym_STAR] = ACTIONS(5113),
    [anon_sym_SLASH] = ACTIONS(5113),
    [anon_sym_PERCENT] = ACTIONS(5113),
    [anon_sym_PIPE_PIPE] = ACTIONS(5115),
    [anon_sym_AMP_AMP] = ACTIONS(5115),
    [anon_sym_PIPE] = ACTIONS(5113),
    [anon_sym_CARET] = ACTIONS(5113),
    [anon_sym_AMP] = ACTIONS(5113),
    [anon_sym_EQ_EQ] = ACTIONS(5115),
    [anon_sym_BANG_EQ] = ACTIONS(5115),
    [anon_sym_GT] = ACTIONS(5113),
    [anon_sym_GT_EQ] = ACTIONS(5115),
    [anon_sym_LT_EQ] = ACTIONS(5113),
    [anon_sym_LT] = ACTIONS(5113),
    [anon_sym_LT_LT] = ACTIONS(5113),
    [anon_sym_GT_GT] = ACTIONS(5113),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym___attribute__] = ACTIONS(5113),
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_RBRACE] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_RBRACK] = ACTIONS(5115),
    [anon_sym_EQ] = ACTIONS(5113),
    [anon_sym_COLON] = ACTIONS(5115),
    [anon_sym_QMARK] = ACTIONS(5115),
    [anon_sym_STAR_EQ] = ACTIONS(5115),
    [anon_sym_SLASH_EQ] = ACTIONS(5115),
    [anon_sym_PERCENT_EQ] = ACTIONS(5115),
    [anon_sym_PLUS_EQ] = ACTIONS(5115),
    [anon_sym_DASH_EQ] = ACTIONS(5115),
    [anon_sym_LT_LT_EQ] = ACTIONS(5115),
    [anon_sym_GT_GT_EQ] = ACTIONS(5115),
    [anon_sym_AMP_EQ] = ACTIONS(5115),
    [anon_sym_CARET_EQ] = ACTIONS(5115),
    [anon_sym_PIPE_EQ] = ACTIONS(5115),
    [anon_sym_and_eq] = ACTIONS(5113),
    [anon_sym_or_eq] = ACTIONS(5113),
    [anon_sym_xor_eq] = ACTIONS(5113),
    [anon_sym_LT_EQ_GT] = ACTIONS(5115),
    [anon_sym_or] = ACTIONS(5113),
    [anon_sym_and] = ACTIONS(5113),
    [anon_sym_bitor] = ACTIONS(5113),
    [anon_sym_xor] = ACTIONS(5113),
    [anon_sym_bitand] = ACTIONS(5113),
    [anon_sym_not_eq] = ACTIONS(5113),
    [anon_sym_DASH_DASH] = ACTIONS(5115),
    [anon_sym_PLUS_PLUS] = ACTIONS(5115),
    [anon_sym_DOT] = ACTIONS(5113),
    [anon_sym_DOT_STAR] = ACTIONS(5115),
    [anon_sym_DASH_GT] = ACTIONS(5115),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5113),
    [anon_sym_decltype] = ACTIONS(5113),
  },
  [2345] = {
    [sym_identifier] = ACTIONS(3650),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3652),
    [anon_sym_COMMA] = ACTIONS(3652),
    [anon_sym_RPAREN] = ACTIONS(3652),
    [anon_sym_LPAREN2] = ACTIONS(3652),
    [anon_sym_TILDE] = ACTIONS(3652),
    [anon_sym_STAR] = ACTIONS(3652),
    [anon_sym_AMP_AMP] = ACTIONS(3652),
    [anon_sym_AMP] = ACTIONS(3650),
    [anon_sym_SEMI] = ACTIONS(3652),
    [anon_sym___extension__] = ACTIONS(3650),
    [anon_sym_extern] = ACTIONS(3650),
    [anon_sym___attribute__] = ACTIONS(3650),
    [anon_sym_COLON_COLON] = ACTIONS(3652),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3652),
    [anon_sym___declspec] = ACTIONS(3650),
    [anon_sym___based] = ACTIONS(3650),
    [anon_sym___cdecl] = ACTIONS(3650),
    [anon_sym___clrcall] = ACTIONS(3650),
    [anon_sym___stdcall] = ACTIONS(3650),
    [anon_sym___fastcall] = ACTIONS(3650),
    [anon_sym___thiscall] = ACTIONS(3650),
    [anon_sym___vectorcall] = ACTIONS(3650),
    [anon_sym_LBRACE] = ACTIONS(3652),
    [anon_sym_LBRACK] = ACTIONS(3650),
    [anon_sym_EQ] = ACTIONS(3652),
    [anon_sym_static] = ACTIONS(3650),
    [anon_sym_register] = ACTIONS(3650),
    [anon_sym_inline] = ACTIONS(3650),
    [anon_sym___inline] = ACTIONS(3650),
    [anon_sym___inline__] = ACTIONS(3650),
    [anon_sym___forceinline] = ACTIONS(3650),
    [anon_sym_thread_local] = ACTIONS(3650),
    [anon_sym___thread] = ACTIONS(3650),
    [anon_sym_const] = ACTIONS(3650),
    [anon_sym_constexpr] = ACTIONS(3650),
    [anon_sym_volatile] = ACTIONS(3650),
    [anon_sym_restrict] = ACTIONS(3650),
    [anon_sym___restrict__] = ACTIONS(3650),
    [anon_sym__Atomic] = ACTIONS(3650),
    [anon_sym__Noreturn] = ACTIONS(3650),
    [anon_sym_noreturn] = ACTIONS(3650),
    [anon_sym_mutable] = ACTIONS(3650),
    [anon_sym_constinit] = ACTIONS(3650),
    [anon_sym_consteval] = ACTIONS(3650),
    [anon_sym_PROGMEM] = ACTIONS(3650),
    [anon_sym_COLON] = ACTIONS(3650),
    [anon_sym_asm] = ACTIONS(3650),
    [anon_sym___asm__] = ACTIONS(3650),
    [anon_sym_DASH_GT] = ACTIONS(3652),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3650),
    [anon_sym_final] = ACTIONS(3650),
    [anon_sym_override] = ACTIONS(3650),
    [anon_sym_virtual] = ACTIONS(3650),
    [anon_sym_alignas] = ACTIONS(3650),
    [anon_sym_explicit] = ACTIONS(3650),
    [anon_sym_template] = ACTIONS(3650),
    [anon_sym_GT2] = ACTIONS(3652),
    [anon_sym_operator] = ACTIONS(3650),
    [anon_sym_try] = ACTIONS(3650),
    [anon_sym_public] = ACTIONS(3650),
    [anon_sym_private] = ACTIONS(3650),
    [anon_sym_protected] = ACTIONS(3650),
    [anon_sym_requires] = ACTIONS(3650),
  },
  [2346] = {
    [sym_identifier] = ACTIONS(5038),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5040),
    [anon_sym_COMMA] = ACTIONS(5040),
    [anon_sym_RPAREN] = ACTIONS(5040),
    [aux_sym_preproc_if_token2] = ACTIONS(5040),
    [aux_sym_preproc_else_token1] = ACTIONS(5040),
    [aux_sym_preproc_elif_token1] = ACTIONS(5038),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5040),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5040),
    [anon_sym_LPAREN2] = ACTIONS(5040),
    [anon_sym_DASH] = ACTIONS(5038),
    [anon_sym_PLUS] = ACTIONS(5038),
    [anon_sym_STAR] = ACTIONS(5038),
    [anon_sym_SLASH] = ACTIONS(5038),
    [anon_sym_PERCENT] = ACTIONS(5038),
    [anon_sym_PIPE_PIPE] = ACTIONS(5040),
    [anon_sym_AMP_AMP] = ACTIONS(5040),
    [anon_sym_PIPE] = ACTIONS(5038),
    [anon_sym_CARET] = ACTIONS(5038),
    [anon_sym_AMP] = ACTIONS(5038),
    [anon_sym_EQ_EQ] = ACTIONS(5040),
    [anon_sym_BANG_EQ] = ACTIONS(5040),
    [anon_sym_GT] = ACTIONS(5038),
    [anon_sym_GT_EQ] = ACTIONS(5040),
    [anon_sym_LT_EQ] = ACTIONS(5038),
    [anon_sym_LT] = ACTIONS(5038),
    [anon_sym_LT_LT] = ACTIONS(5038),
    [anon_sym_GT_GT] = ACTIONS(5038),
    [anon_sym_SEMI] = ACTIONS(5040),
    [anon_sym___attribute__] = ACTIONS(5038),
    [anon_sym_LBRACE] = ACTIONS(5040),
    [anon_sym_RBRACE] = ACTIONS(5040),
    [anon_sym_LBRACK] = ACTIONS(5040),
    [anon_sym_RBRACK] = ACTIONS(5040),
    [anon_sym_EQ] = ACTIONS(5038),
    [anon_sym_COLON] = ACTIONS(5040),
    [anon_sym_QMARK] = ACTIONS(5040),
    [anon_sym_STAR_EQ] = ACTIONS(5040),
    [anon_sym_SLASH_EQ] = ACTIONS(5040),
    [anon_sym_PERCENT_EQ] = ACTIONS(5040),
    [anon_sym_PLUS_EQ] = ACTIONS(5040),
    [anon_sym_DASH_EQ] = ACTIONS(5040),
    [anon_sym_LT_LT_EQ] = ACTIONS(5040),
    [anon_sym_GT_GT_EQ] = ACTIONS(5040),
    [anon_sym_AMP_EQ] = ACTIONS(5040),
    [anon_sym_CARET_EQ] = ACTIONS(5040),
    [anon_sym_PIPE_EQ] = ACTIONS(5040),
    [anon_sym_and_eq] = ACTIONS(5038),
    [anon_sym_or_eq] = ACTIONS(5038),
    [anon_sym_xor_eq] = ACTIONS(5038),
    [anon_sym_LT_EQ_GT] = ACTIONS(5040),
    [anon_sym_or] = ACTIONS(5038),
    [anon_sym_and] = ACTIONS(5038),
    [anon_sym_bitor] = ACTIONS(5038),
    [anon_sym_xor] = ACTIONS(5038),
    [anon_sym_bitand] = ACTIONS(5038),
    [anon_sym_not_eq] = ACTIONS(5038),
    [anon_sym_DASH_DASH] = ACTIONS(5040),
    [anon_sym_PLUS_PLUS] = ACTIONS(5040),
    [anon_sym_DOT] = ACTIONS(5038),
    [anon_sym_DOT_STAR] = ACTIONS(5040),
    [anon_sym_DASH_GT] = ACTIONS(5040),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5038),
    [anon_sym_decltype] = ACTIONS(5038),
  },
  [2347] = {
    [sym_ms_based_modifier] = STATE(7771),
    [sym_ms_unaligned_ptr_modifier] = STATE(4186),
    [sym_ms_pointer_modifier] = STATE(4100),
    [sym__declarator] = STATE(6167),
    [sym__abstract_declarator] = STATE(6287),
    [sym_parenthesized_declarator] = STATE(6098),
    [sym_abstract_parenthesized_declarator] = STATE(6031),
    [sym_attributed_declarator] = STATE(6098),
    [sym_pointer_declarator] = STATE(6098),
    [sym_abstract_pointer_declarator] = STATE(6031),
    [sym_function_declarator] = STATE(6098),
    [sym_abstract_function_declarator] = STATE(6031),
    [sym_array_declarator] = STATE(6098),
    [sym_abstract_array_declarator] = STATE(6031),
    [sym_type_qualifier] = STATE(2859),
    [sym_parameter_list] = STATE(3343),
    [sym_decltype] = STATE(8290),
    [sym_reference_declarator] = STATE(6098),
    [sym_abstract_reference_declarator] = STATE(6031),
    [sym_structured_binding_declarator] = STATE(6098),
    [sym__function_declarator_seq] = STATE(6035),
    [sym_template_type] = STATE(8290),
    [sym_template_function] = STATE(6098),
    [sym_destructor_name] = STATE(6098),
    [sym_dependent_type_identifier] = STATE(8290),
    [sym__scope_resolution] = STATE(5695),
    [sym_qualified_identifier] = STATE(6098),
    [sym_operator_name] = STATE(6098),
    [aux_sym__type_definition_type_repeat1] = STATE(2859),
    [aux_sym_pointer_declarator_repeat1] = STATE(4100),
    [sym_identifier] = ACTIONS(5511),
    [anon_sym_COMMA] = ACTIONS(5555),
    [anon_sym_RPAREN] = ACTIONS(5555),
    [anon_sym_LPAREN2] = ACTIONS(3803),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(5515),
    [anon_sym_AMP_AMP] = ACTIONS(5517),
    [anon_sym_AMP] = ACTIONS(5519),
    [anon_sym___extension__] = ACTIONS(2917),
    [anon_sym_COLON_COLON] = ACTIONS(5521),
    [anon_sym___based] = ACTIONS(47),
    [sym_ms_restrict_modifier] = ACTIONS(2919),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(2919),
    [sym_ms_signed_ptr_modifier] = ACTIONS(2919),
    [anon_sym__unaligned] = ACTIONS(2921),
    [anon_sym___unaligned] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(5523),
    [anon_sym_EQ] = ACTIONS(5555),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_constexpr] = ACTIONS(2917),
    [anon_sym_volatile] = ACTIONS(2917),
    [anon_sym_restrict] = ACTIONS(2917),
    [anon_sym___restrict__] = ACTIONS(2917),
    [anon_sym__Atomic] = ACTIONS(2917),
    [anon_sym__Noreturn] = ACTIONS(2917),
    [anon_sym_noreturn] = ACTIONS(2917),
    [anon_sym_mutable] = ACTIONS(2917),
    [anon_sym_constinit] = ACTIONS(2917),
    [anon_sym_consteval] = ACTIONS(2917),
    [anon_sym_PROGMEM] = ACTIONS(2917),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1917),
    [anon_sym_template] = ACTIONS(1419),
    [anon_sym_GT2] = ACTIONS(5555),
    [anon_sym_operator] = ACTIONS(1871),
  },
  [2348] = {
    [sym_string_literal] = STATE(2116),
    [sym_raw_string_literal] = STATE(2116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3761),
    [anon_sym_COMMA] = ACTIONS(3761),
    [anon_sym_LPAREN2] = ACTIONS(3761),
    [anon_sym_DASH] = ACTIONS(3769),
    [anon_sym_PLUS] = ACTIONS(3769),
    [anon_sym_STAR] = ACTIONS(3769),
    [anon_sym_SLASH] = ACTIONS(3769),
    [anon_sym_PERCENT] = ACTIONS(3769),
    [anon_sym_PIPE_PIPE] = ACTIONS(3761),
    [anon_sym_AMP_AMP] = ACTIONS(3761),
    [anon_sym_PIPE] = ACTIONS(3769),
    [anon_sym_CARET] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(3769),
    [anon_sym_EQ_EQ] = ACTIONS(3761),
    [anon_sym_BANG_EQ] = ACTIONS(3761),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3761),
    [anon_sym_LT_EQ] = ACTIONS(3769),
    [anon_sym_LT] = ACTIONS(3769),
    [anon_sym_LT_LT] = ACTIONS(3769),
    [anon_sym_GT_GT] = ACTIONS(3769),
    [anon_sym_SEMI] = ACTIONS(3761),
    [anon_sym___attribute__] = ACTIONS(3769),
    [anon_sym_LBRACK] = ACTIONS(3761),
    [anon_sym_EQ] = ACTIONS(3769),
    [anon_sym_QMARK] = ACTIONS(3761),
    [anon_sym_STAR_EQ] = ACTIONS(3761),
    [anon_sym_SLASH_EQ] = ACTIONS(3761),
    [anon_sym_PERCENT_EQ] = ACTIONS(3761),
    [anon_sym_PLUS_EQ] = ACTIONS(3761),
    [anon_sym_DASH_EQ] = ACTIONS(3761),
    [anon_sym_LT_LT_EQ] = ACTIONS(3761),
    [anon_sym_GT_GT_EQ] = ACTIONS(3761),
    [anon_sym_AMP_EQ] = ACTIONS(3761),
    [anon_sym_CARET_EQ] = ACTIONS(3761),
    [anon_sym_PIPE_EQ] = ACTIONS(3761),
    [anon_sym_and_eq] = ACTIONS(3769),
    [anon_sym_or_eq] = ACTIONS(3769),
    [anon_sym_xor_eq] = ACTIONS(3769),
    [anon_sym_LT_EQ_GT] = ACTIONS(3761),
    [anon_sym_or] = ACTIONS(3769),
    [anon_sym_and] = ACTIONS(3769),
    [anon_sym_bitor] = ACTIONS(3769),
    [anon_sym_xor] = ACTIONS(3769),
    [anon_sym_bitand] = ACTIONS(3769),
    [anon_sym_not_eq] = ACTIONS(3769),
    [anon_sym_DASH_DASH] = ACTIONS(3761),
    [anon_sym_PLUS_PLUS] = ACTIONS(3761),
    [anon_sym_DOT] = ACTIONS(3769),
    [anon_sym_DOT_STAR] = ACTIONS(3761),
    [anon_sym_DASH_GT] = ACTIONS(3761),
    [anon_sym_L_DQUOTE] = ACTIONS(5289),
    [anon_sym_u_DQUOTE] = ACTIONS(5289),
    [anon_sym_U_DQUOTE] = ACTIONS(5289),
    [anon_sym_u8_DQUOTE] = ACTIONS(5289),
    [anon_sym_DQUOTE] = ACTIONS(5289),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5291),
    [anon_sym_LR_DQUOTE] = ACTIONS(5291),
    [anon_sym_uR_DQUOTE] = ACTIONS(5291),
    [anon_sym_UR_DQUOTE] = ACTIONS(5291),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5291),
    [sym_literal_suffix] = ACTIONS(5201),
  },
  [2349] = {
    [sym_identifier] = ACTIONS(5557),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5559),
    [anon_sym_COMMA] = ACTIONS(5559),
    [anon_sym_RPAREN] = ACTIONS(5559),
    [aux_sym_preproc_if_token2] = ACTIONS(5559),
    [aux_sym_preproc_else_token1] = ACTIONS(5559),
    [aux_sym_preproc_elif_token1] = ACTIONS(5557),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5559),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5559),
    [anon_sym_LPAREN2] = ACTIONS(5559),
    [anon_sym_DASH] = ACTIONS(5557),
    [anon_sym_PLUS] = ACTIONS(5557),
    [anon_sym_STAR] = ACTIONS(5557),
    [anon_sym_SLASH] = ACTIONS(5557),
    [anon_sym_PERCENT] = ACTIONS(5557),
    [anon_sym_PIPE_PIPE] = ACTIONS(5559),
    [anon_sym_AMP_AMP] = ACTIONS(5559),
    [anon_sym_PIPE] = ACTIONS(5557),
    [anon_sym_CARET] = ACTIONS(5557),
    [anon_sym_AMP] = ACTIONS(5557),
    [anon_sym_EQ_EQ] = ACTIONS(5559),
    [anon_sym_BANG_EQ] = ACTIONS(5559),
    [anon_sym_GT] = ACTIONS(5557),
    [anon_sym_GT_EQ] = ACTIONS(5559),
    [anon_sym_LT_EQ] = ACTIONS(5557),
    [anon_sym_LT] = ACTIONS(5557),
    [anon_sym_LT_LT] = ACTIONS(5557),
    [anon_sym_GT_GT] = ACTIONS(5557),
    [anon_sym_SEMI] = ACTIONS(5559),
    [anon_sym___attribute__] = ACTIONS(5557),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5559),
    [anon_sym_LBRACE] = ACTIONS(5559),
    [anon_sym_RBRACE] = ACTIONS(5559),
    [anon_sym_LBRACK] = ACTIONS(5557),
    [anon_sym_RBRACK] = ACTIONS(5559),
    [anon_sym_EQ] = ACTIONS(5557),
    [anon_sym_COLON] = ACTIONS(5559),
    [anon_sym_QMARK] = ACTIONS(5559),
    [anon_sym_STAR_EQ] = ACTIONS(5559),
    [anon_sym_SLASH_EQ] = ACTIONS(5559),
    [anon_sym_PERCENT_EQ] = ACTIONS(5559),
    [anon_sym_PLUS_EQ] = ACTIONS(5559),
    [anon_sym_DASH_EQ] = ACTIONS(5559),
    [anon_sym_LT_LT_EQ] = ACTIONS(5559),
    [anon_sym_GT_GT_EQ] = ACTIONS(5559),
    [anon_sym_AMP_EQ] = ACTIONS(5559),
    [anon_sym_CARET_EQ] = ACTIONS(5559),
    [anon_sym_PIPE_EQ] = ACTIONS(5559),
    [anon_sym_and_eq] = ACTIONS(5557),
    [anon_sym_or_eq] = ACTIONS(5557),
    [anon_sym_xor_eq] = ACTIONS(5557),
    [anon_sym_LT_EQ_GT] = ACTIONS(5559),
    [anon_sym_or] = ACTIONS(5557),
    [anon_sym_and] = ACTIONS(5557),
    [anon_sym_bitor] = ACTIONS(5557),
    [anon_sym_xor] = ACTIONS(5557),
    [anon_sym_bitand] = ACTIONS(5557),
    [anon_sym_not_eq] = ACTIONS(5557),
    [anon_sym_DASH_DASH] = ACTIONS(5559),
    [anon_sym_PLUS_PLUS] = ACTIONS(5559),
    [anon_sym_DOT] = ACTIONS(5557),
    [anon_sym_DOT_STAR] = ACTIONS(5559),
    [anon_sym_DASH_GT] = ACTIONS(5559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(5557),
  },
  [2350] = {
    [sym_argument_list] = STATE(2517),
    [sym_initializer_list] = STATE(2517),
    [sym_identifier] = ACTIONS(5561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5563),
    [anon_sym_COMMA] = ACTIONS(5563),
    [anon_sym_RPAREN] = ACTIONS(5563),
    [aux_sym_preproc_if_token2] = ACTIONS(5563),
    [aux_sym_preproc_else_token1] = ACTIONS(5563),
    [aux_sym_preproc_elif_token1] = ACTIONS(5561),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5563),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5563),
    [anon_sym_LPAREN2] = ACTIONS(5212),
    [anon_sym_DASH] = ACTIONS(5561),
    [anon_sym_PLUS] = ACTIONS(5561),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_SLASH] = ACTIONS(5561),
    [anon_sym_PERCENT] = ACTIONS(5561),
    [anon_sym_PIPE_PIPE] = ACTIONS(5563),
    [anon_sym_AMP_AMP] = ACTIONS(5563),
    [anon_sym_PIPE] = ACTIONS(5561),
    [anon_sym_CARET] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5561),
    [anon_sym_EQ_EQ] = ACTIONS(5563),
    [anon_sym_BANG_EQ] = ACTIONS(5563),
    [anon_sym_GT] = ACTIONS(5561),
    [anon_sym_GT_EQ] = ACTIONS(5563),
    [anon_sym_LT_EQ] = ACTIONS(5561),
    [anon_sym_LT] = ACTIONS(5561),
    [anon_sym_LT_LT] = ACTIONS(5561),
    [anon_sym_GT_GT] = ACTIONS(5561),
    [anon_sym_SEMI] = ACTIONS(5563),
    [anon_sym___attribute__] = ACTIONS(5561),
    [anon_sym_LBRACE] = ACTIONS(1893),
    [anon_sym_RBRACE] = ACTIONS(5563),
    [anon_sym_LBRACK] = ACTIONS(5563),
    [anon_sym_RBRACK] = ACTIONS(5563),
    [anon_sym_EQ] = ACTIONS(5561),
    [anon_sym_COLON] = ACTIONS(5563),
    [anon_sym_QMARK] = ACTIONS(5563),
    [anon_sym_STAR_EQ] = ACTIONS(5563),
    [anon_sym_SLASH_EQ] = ACTIONS(5563),
    [anon_sym_PERCENT_EQ] = ACTIONS(5563),
    [anon_sym_PLUS_EQ] = ACTIONS(5563),
    [anon_sym_DASH_EQ] = ACTIONS(5563),
    [anon_sym_LT_LT_EQ] = ACTIONS(5563),
    [anon_sym_GT_GT_EQ] = ACTIONS(5563),
    [anon_sym_AMP_EQ] = ACTIONS(5563),
    [anon_sym_CARET_EQ] = ACTIONS(5563),
    [anon_sym_PIPE_EQ] = ACTIONS(5563),
    [anon_sym_and_eq] = ACTIONS(5561),
    [anon_sym_or_eq] = ACTIONS(5561),
    [anon_sym_xor_eq] = ACTIONS(5561),
    [anon_sym_LT_EQ_GT] = ACTIONS(5563),
    [anon_sym_or] = ACTIONS(5561),
    [anon_sym_and] = ACTIONS(5561),
    [anon_sym_bitor] = ACTIONS(5561),
    [anon_sym_xor] = ACTIONS(5561),
    [anon_sym_bitand] = ACTIONS(5561),
    [anon_sym_not_eq] = ACTIONS(5561),
    [anon_sym_DASH_DASH] = ACTIONS(5563),
    [anon_sym_PLUS_PLUS] = ACTIONS(5563),
    [anon_sym_DOT] = ACTIONS(5561),
    [anon_sym_DOT_STAR] = ACTIONS(5563),
    [anon_sym_DASH_GT] = ACTIONS(5563),
    [sym_comment] = ACTIONS(3),
  },
  [2351] = {
    [sym_identifier] = ACTIONS(5183),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5185),
    [anon_sym_COMMA] = ACTIONS(5185),
    [anon_sym_RPAREN] = ACTIONS(5185),
    [aux_sym_preproc_if_token2] = ACTIONS(5185),
    [aux_sym_preproc_else_token1] = ACTIONS(5185),
    [aux_sym_preproc_elif_token1] = ACTIONS(5183),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5185),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5185),
    [anon_sym_LPAREN2] = ACTIONS(5185),
    [anon_sym_DASH] = ACTIONS(5183),
    [anon_sym_PLUS] = ACTIONS(5183),
    [anon_sym_STAR] = ACTIONS(5183),
    [anon_sym_SLASH] = ACTIONS(5183),
    [anon_sym_PERCENT] = ACTIONS(5183),
    [anon_sym_PIPE_PIPE] = ACTIONS(5185),
    [anon_sym_AMP_AMP] = ACTIONS(5185),
    [anon_sym_PIPE] = ACTIONS(5183),
    [anon_sym_CARET] = ACTIONS(5183),
    [anon_sym_AMP] = ACTIONS(5183),
    [anon_sym_EQ_EQ] = ACTIONS(5185),
    [anon_sym_BANG_EQ] = ACTIONS(5185),
    [anon_sym_GT] = ACTIONS(5183),
    [anon_sym_GT_EQ] = ACTIONS(5185),
    [anon_sym_LT_EQ] = ACTIONS(5183),
    [anon_sym_LT] = ACTIONS(5183),
    [anon_sym_LT_LT] = ACTIONS(5183),
    [anon_sym_GT_GT] = ACTIONS(5183),
    [anon_sym_SEMI] = ACTIONS(5185),
    [anon_sym___attribute__] = ACTIONS(5183),
    [anon_sym_LBRACE] = ACTIONS(5185),
    [anon_sym_RBRACE] = ACTIONS(5185),
    [anon_sym_LBRACK] = ACTIONS(5185),
    [anon_sym_RBRACK] = ACTIONS(5185),
    [anon_sym_EQ] = ACTIONS(5183),
    [anon_sym_COLON] = ACTIONS(5185),
    [anon_sym_QMARK] = ACTIONS(5185),
    [anon_sym_STAR_EQ] = ACTIONS(5185),
    [anon_sym_SLASH_EQ] = ACTIONS(5185),
    [anon_sym_PERCENT_EQ] = ACTIONS(5185),
    [anon_sym_PLUS_EQ] = ACTIONS(5185),
    [anon_sym_DASH_EQ] = ACTIONS(5185),
    [anon_sym_LT_LT_EQ] = ACTIONS(5185),
    [anon_sym_GT_GT_EQ] = ACTIONS(5185),
    [anon_sym_AMP_EQ] = ACTIONS(5185),
    [anon_sym_CARET_EQ] = ACTIONS(5185),
    [anon_sym_PIPE_EQ] = ACTIONS(5185),
    [anon_sym_and_eq] = ACTIONS(5183),
    [anon_sym_or_eq] = ACTIONS(5183),
    [anon_sym_xor_eq] = ACTIONS(5183),
    [anon_sym_LT_EQ_GT] = ACTIONS(5185),
    [anon_sym_or] = ACTIONS(5183),
    [anon_sym_and] = ACTIONS(5183),
    [anon_sym_bitor] = ACTIONS(5183),
    [anon_sym_xor] = ACTIONS(5183),
    [anon_sym_bitand] = ACTIONS(5183),
    [anon_sym_not_eq] = ACTIONS(5183),
    [anon_sym_DASH_DASH] = ACTIONS(5185),
    [anon_sym_PLUS_PLUS] = ACTIONS(5185),
    [anon_sym_DOT] = ACTIONS(5183),
    [anon_sym_DOT_STAR] = ACTIONS(5185),
    [anon_sym_DASH_GT] = ACTIONS(5185),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5183),
    [anon_sym_decltype] = ACTIONS(5183),
  },
  [2352] = {
    [sym_identifier] = ACTIONS(5034),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5036),
    [anon_sym_COMMA] = ACTIONS(5036),
    [anon_sym_RPAREN] = ACTIONS(5036),
    [aux_sym_preproc_if_token2] = ACTIONS(5036),
    [aux_sym_preproc_else_token1] = ACTIONS(5036),
    [aux_sym_preproc_elif_token1] = ACTIONS(5034),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5036),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5036),
    [anon_sym_LPAREN2] = ACTIONS(5036),
    [anon_sym_DASH] = ACTIONS(5034),
    [anon_sym_PLUS] = ACTIONS(5034),
    [anon_sym_STAR] = ACTIONS(5034),
    [anon_sym_SLASH] = ACTIONS(5034),
    [anon_sym_PERCENT] = ACTIONS(5034),
    [anon_sym_PIPE_PIPE] = ACTIONS(5036),
    [anon_sym_AMP_AMP] = ACTIONS(5036),
    [anon_sym_PIPE] = ACTIONS(5034),
    [anon_sym_CARET] = ACTIONS(5034),
    [anon_sym_AMP] = ACTIONS(5034),
    [anon_sym_EQ_EQ] = ACTIONS(5036),
    [anon_sym_BANG_EQ] = ACTIONS(5036),
    [anon_sym_GT] = ACTIONS(5034),
    [anon_sym_GT_EQ] = ACTIONS(5036),
    [anon_sym_LT_EQ] = ACTIONS(5034),
    [anon_sym_LT] = ACTIONS(5034),
    [anon_sym_LT_LT] = ACTIONS(5034),
    [anon_sym_GT_GT] = ACTIONS(5034),
    [anon_sym_SEMI] = ACTIONS(5036),
    [anon_sym___attribute__] = ACTIONS(5034),
    [anon_sym_LBRACE] = ACTIONS(5036),
    [anon_sym_RBRACE] = ACTIONS(5036),
    [anon_sym_LBRACK] = ACTIONS(5036),
    [anon_sym_RBRACK] = ACTIONS(5036),
    [anon_sym_EQ] = ACTIONS(5034),
    [anon_sym_COLON] = ACTIONS(5036),
    [anon_sym_QMARK] = ACTIONS(5036),
    [anon_sym_STAR_EQ] = ACTIONS(5036),
    [anon_sym_SLASH_EQ] = ACTIONS(5036),
    [anon_sym_PERCENT_EQ] = ACTIONS(5036),
    [anon_sym_PLUS_EQ] = ACTIONS(5036),
    [anon_sym_DASH_EQ] = ACTIONS(5036),
    [anon_sym_LT_LT_EQ] = ACTIONS(5036),
    [anon_sym_GT_GT_EQ] = ACTIONS(5036),
    [anon_sym_AMP_EQ] = ACTIONS(5036),
    [anon_sym_CARET_EQ] = ACTIONS(5036),
    [anon_sym_PIPE_EQ] = ACTIONS(5036),
    [anon_sym_and_eq] = ACTIONS(5034),
    [anon_sym_or_eq] = ACTIONS(5034),
    [anon_sym_xor_eq] = ACTIONS(5034),
    [anon_sym_LT_EQ_GT] = ACTIONS(5036),
    [anon_sym_or] = ACTIONS(5034),
    [anon_sym_and] = ACTIONS(5034),
    [anon_sym_bitor] = ACTIONS(5034),
    [anon_sym_xor] = ACTIONS(5034),
    [anon_sym_bitand] = ACTIONS(5034),
    [anon_sym_not_eq] = ACTIONS(5034),
    [anon_sym_DASH_DASH] = ACTIONS(5036),
    [anon_sym_PLUS_PLUS] = ACTIONS(5036),
    [anon_sym_DOT] = ACTIONS(5034),
    [anon_sym_DOT_STAR] = ACTIONS(5036),
    [anon_sym_DASH_GT] = ACTIONS(5036),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5034),
    [anon_sym_decltype] = ACTIONS(5034),
  },
  [2353] = {
    [sym_identifier] = ACTIONS(5050),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5052),
    [anon_sym_COMMA] = ACTIONS(5052),
    [anon_sym_RPAREN] = ACTIONS(5052),
    [aux_sym_preproc_if_token2] = ACTIONS(5052),
    [aux_sym_preproc_else_token1] = ACTIONS(5052),
    [aux_sym_preproc_elif_token1] = ACTIONS(5050),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5052),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5052),
    [anon_sym_LPAREN2] = ACTIONS(5052),
    [anon_sym_DASH] = ACTIONS(5050),
    [anon_sym_PLUS] = ACTIONS(5050),
    [anon_sym_STAR] = ACTIONS(5050),
    [anon_sym_SLASH] = ACTIONS(5050),
    [anon_sym_PERCENT] = ACTIONS(5050),
    [anon_sym_PIPE_PIPE] = ACTIONS(5052),
    [anon_sym_AMP_AMP] = ACTIONS(5052),
    [anon_sym_PIPE] = ACTIONS(5050),
    [anon_sym_CARET] = ACTIONS(5050),
    [anon_sym_AMP] = ACTIONS(5050),
    [anon_sym_EQ_EQ] = ACTIONS(5052),
    [anon_sym_BANG_EQ] = ACTIONS(5052),
    [anon_sym_GT] = ACTIONS(5050),
    [anon_sym_GT_EQ] = ACTIONS(5052),
    [anon_sym_LT_EQ] = ACTIONS(5050),
    [anon_sym_LT] = ACTIONS(5050),
    [anon_sym_LT_LT] = ACTIONS(5050),
    [anon_sym_GT_GT] = ACTIONS(5050),
    [anon_sym_SEMI] = ACTIONS(5052),
    [anon_sym___attribute__] = ACTIONS(5050),
    [anon_sym_LBRACE] = ACTIONS(5052),
    [anon_sym_RBRACE] = ACTIONS(5052),
    [anon_sym_LBRACK] = ACTIONS(5052),
    [anon_sym_RBRACK] = ACTIONS(5052),
    [anon_sym_EQ] = ACTIONS(5050),
    [anon_sym_COLON] = ACTIONS(5052),
    [anon_sym_QMARK] = ACTIONS(5052),
    [anon_sym_STAR_EQ] = ACTIONS(5052),
    [anon_sym_SLASH_EQ] = ACTIONS(5052),
    [anon_sym_PERCENT_EQ] = ACTIONS(5052),
    [anon_sym_PLUS_EQ] = ACTIONS(5052),
    [anon_sym_DASH_EQ] = ACTIONS(5052),
    [anon_sym_LT_LT_EQ] = ACTIONS(5052),
    [anon_sym_GT_GT_EQ] = ACTIONS(5052),
    [anon_sym_AMP_EQ] = ACTIONS(5052),
    [anon_sym_CARET_EQ] = ACTIONS(5052),
    [anon_sym_PIPE_EQ] = ACTIONS(5052),
    [anon_sym_and_eq] = ACTIONS(5050),
    [anon_sym_or_eq] = ACTIONS(5050),
    [anon_sym_xor_eq] = ACTIONS(5050),
    [anon_sym_LT_EQ_GT] = ACTIONS(5052),
    [anon_sym_or] = ACTIONS(5050),
    [anon_sym_and] = ACTIONS(5050),
    [anon_sym_bitor] = ACTIONS(5050),
    [anon_sym_xor] = ACTIONS(5050),
    [anon_sym_bitand] = ACTIONS(5050),
    [anon_sym_not_eq] = ACTIONS(5050),
    [anon_sym_DASH_DASH] = ACTIONS(5052),
    [anon_sym_PLUS_PLUS] = ACTIONS(5052),
    [anon_sym_DOT] = ACTIONS(5050),
    [anon_sym_DOT_STAR] = ACTIONS(5052),
    [anon_sym_DASH_GT] = ACTIONS(5052),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5050),
    [anon_sym_decltype] = ACTIONS(5050),
  },
  [2354] = {
    [sym_identifier] = ACTIONS(5030),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5032),
    [anon_sym_COMMA] = ACTIONS(5032),
    [anon_sym_RPAREN] = ACTIONS(5032),
    [aux_sym_preproc_if_token2] = ACTIONS(5032),
    [aux_sym_preproc_else_token1] = ACTIONS(5032),
    [aux_sym_preproc_elif_token1] = ACTIONS(5030),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5032),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5032),
    [anon_sym_LPAREN2] = ACTIONS(5032),
    [anon_sym_DASH] = ACTIONS(5030),
    [anon_sym_PLUS] = ACTIONS(5030),
    [anon_sym_STAR] = ACTIONS(5030),
    [anon_sym_SLASH] = ACTIONS(5030),
    [anon_sym_PERCENT] = ACTIONS(5030),
    [anon_sym_PIPE_PIPE] = ACTIONS(5032),
    [anon_sym_AMP_AMP] = ACTIONS(5032),
    [anon_sym_PIPE] = ACTIONS(5030),
    [anon_sym_CARET] = ACTIONS(5030),
    [anon_sym_AMP] = ACTIONS(5030),
    [anon_sym_EQ_EQ] = ACTIONS(5032),
    [anon_sym_BANG_EQ] = ACTIONS(5032),
    [anon_sym_GT] = ACTIONS(5030),
    [anon_sym_GT_EQ] = ACTIONS(5032),
    [anon_sym_LT_EQ] = ACTIONS(5030),
    [anon_sym_LT] = ACTIONS(5030),
    [anon_sym_LT_LT] = ACTIONS(5030),
    [anon_sym_GT_GT] = ACTIONS(5030),
    [anon_sym_SEMI] = ACTIONS(5032),
    [anon_sym___attribute__] = ACTIONS(5030),
    [anon_sym_LBRACE] = ACTIONS(5032),
    [anon_sym_RBRACE] = ACTIONS(5032),
    [anon_sym_LBRACK] = ACTIONS(5032),
    [anon_sym_RBRACK] = ACTIONS(5032),
    [anon_sym_EQ] = ACTIONS(5030),
    [anon_sym_COLON] = ACTIONS(5032),
    [anon_sym_QMARK] = ACTIONS(5032),
    [anon_sym_STAR_EQ] = ACTIONS(5032),
    [anon_sym_SLASH_EQ] = ACTIONS(5032),
    [anon_sym_PERCENT_EQ] = ACTIONS(5032),
    [anon_sym_PLUS_EQ] = ACTIONS(5032),
    [anon_sym_DASH_EQ] = ACTIONS(5032),
    [anon_sym_LT_LT_EQ] = ACTIONS(5032),
    [anon_sym_GT_GT_EQ] = ACTIONS(5032),
    [anon_sym_AMP_EQ] = ACTIONS(5032),
    [anon_sym_CARET_EQ] = ACTIONS(5032),
    [anon_sym_PIPE_EQ] = ACTIONS(5032),
    [anon_sym_and_eq] = ACTIONS(5030),
    [anon_sym_or_eq] = ACTIONS(5030),
    [anon_sym_xor_eq] = ACTIONS(5030),
    [anon_sym_LT_EQ_GT] = ACTIONS(5032),
    [anon_sym_or] = ACTIONS(5030),
    [anon_sym_and] = ACTIONS(5030),
    [anon_sym_bitor] = ACTIONS(5030),
    [anon_sym_xor] = ACTIONS(5030),
    [anon_sym_bitand] = ACTIONS(5030),
    [anon_sym_not_eq] = ACTIONS(5030),
    [anon_sym_DASH_DASH] = ACTIONS(5032),
    [anon_sym_PLUS_PLUS] = ACTIONS(5032),
    [anon_sym_DOT] = ACTIONS(5030),
    [anon_sym_DOT_STAR] = ACTIONS(5032),
    [anon_sym_DASH_GT] = ACTIONS(5032),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5030),
    [anon_sym_decltype] = ACTIONS(5030),
  },
  [2355] = {
    [sym_argument_list] = STATE(2551),
    [sym_initializer_list] = STATE(2551),
    [sym_identifier] = ACTIONS(5565),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5567),
    [anon_sym_COMMA] = ACTIONS(5567),
    [anon_sym_RPAREN] = ACTIONS(5567),
    [aux_sym_preproc_if_token2] = ACTIONS(5567),
    [aux_sym_preproc_else_token1] = ACTIONS(5567),
    [aux_sym_preproc_elif_token1] = ACTIONS(5565),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5567),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5567),
    [anon_sym_LPAREN2] = ACTIONS(5212),
    [anon_sym_DASH] = ACTIONS(5565),
    [anon_sym_PLUS] = ACTIONS(5565),
    [anon_sym_STAR] = ACTIONS(5565),
    [anon_sym_SLASH] = ACTIONS(5565),
    [anon_sym_PERCENT] = ACTIONS(5565),
    [anon_sym_PIPE_PIPE] = ACTIONS(5567),
    [anon_sym_AMP_AMP] = ACTIONS(5567),
    [anon_sym_PIPE] = ACTIONS(5565),
    [anon_sym_CARET] = ACTIONS(5565),
    [anon_sym_AMP] = ACTIONS(5565),
    [anon_sym_EQ_EQ] = ACTIONS(5567),
    [anon_sym_BANG_EQ] = ACTIONS(5567),
    [anon_sym_GT] = ACTIONS(5565),
    [anon_sym_GT_EQ] = ACTIONS(5567),
    [anon_sym_LT_EQ] = ACTIONS(5565),
    [anon_sym_LT] = ACTIONS(5565),
    [anon_sym_LT_LT] = ACTIONS(5565),
    [anon_sym_GT_GT] = ACTIONS(5565),
    [anon_sym_SEMI] = ACTIONS(5567),
    [anon_sym___attribute__] = ACTIONS(5565),
    [anon_sym_LBRACE] = ACTIONS(1893),
    [anon_sym_RBRACE] = ACTIONS(5567),
    [anon_sym_LBRACK] = ACTIONS(5567),
    [anon_sym_RBRACK] = ACTIONS(5567),
    [anon_sym_EQ] = ACTIONS(5565),
    [anon_sym_COLON] = ACTIONS(5567),
    [anon_sym_QMARK] = ACTIONS(5567),
    [anon_sym_STAR_EQ] = ACTIONS(5567),
    [anon_sym_SLASH_EQ] = ACTIONS(5567),
    [anon_sym_PERCENT_EQ] = ACTIONS(5567),
    [anon_sym_PLUS_EQ] = ACTIONS(5567),
    [anon_sym_DASH_EQ] = ACTIONS(5567),
    [anon_sym_LT_LT_EQ] = ACTIONS(5567),
    [anon_sym_GT_GT_EQ] = ACTIONS(5567),
    [anon_sym_AMP_EQ] = ACTIONS(5567),
    [anon_sym_CARET_EQ] = ACTIONS(5567),
    [anon_sym_PIPE_EQ] = ACTIONS(5567),
    [anon_sym_and_eq] = ACTIONS(5565),
    [anon_sym_or_eq] = ACTIONS(5565),
    [anon_sym_xor_eq] = ACTIONS(5565),
    [anon_sym_LT_EQ_GT] = ACTIONS(5567),
    [anon_sym_or] = ACTIONS(5565),
    [anon_sym_and] = ACTIONS(5565),
    [anon_sym_bitor] = ACTIONS(5565),
    [anon_sym_xor] = ACTIONS(5565),
    [anon_sym_bitand] = ACTIONS(5565),
    [anon_sym_not_eq] = ACTIONS(5565),
    [anon_sym_DASH_DASH] = ACTIONS(5567),
    [anon_sym_PLUS_PLUS] = ACTIONS(5567),
    [anon_sym_DOT] = ACTIONS(5565),
    [anon_sym_DOT_STAR] = ACTIONS(5567),
    [anon_sym_DASH_GT] = ACTIONS(5567),
    [sym_comment] = ACTIONS(3),
  },
  [2356] = {
    [sym_identifier] = ACTIONS(5569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5571),
    [anon_sym_COMMA] = ACTIONS(5571),
    [anon_sym_RPAREN] = ACTIONS(5571),
    [aux_sym_preproc_if_token2] = ACTIONS(5571),
    [aux_sym_preproc_else_token1] = ACTIONS(5571),
    [aux_sym_preproc_elif_token1] = ACTIONS(5569),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5571),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5571),
    [anon_sym_LPAREN2] = ACTIONS(5571),
    [anon_sym_DASH] = ACTIONS(5569),
    [anon_sym_PLUS] = ACTIONS(5569),
    [anon_sym_STAR] = ACTIONS(5569),
    [anon_sym_SLASH] = ACTIONS(5569),
    [anon_sym_PERCENT] = ACTIONS(5569),
    [anon_sym_PIPE_PIPE] = ACTIONS(5571),
    [anon_sym_AMP_AMP] = ACTIONS(5571),
    [anon_sym_PIPE] = ACTIONS(5569),
    [anon_sym_CARET] = ACTIONS(5569),
    [anon_sym_AMP] = ACTIONS(5569),
    [anon_sym_EQ_EQ] = ACTIONS(5571),
    [anon_sym_BANG_EQ] = ACTIONS(5571),
    [anon_sym_GT] = ACTIONS(5569),
    [anon_sym_GT_EQ] = ACTIONS(5571),
    [anon_sym_LT_EQ] = ACTIONS(5569),
    [anon_sym_LT] = ACTIONS(5569),
    [anon_sym_LT_LT] = ACTIONS(5569),
    [anon_sym_GT_GT] = ACTIONS(5569),
    [anon_sym_SEMI] = ACTIONS(5571),
    [anon_sym___attribute__] = ACTIONS(5569),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5571),
    [anon_sym_LBRACE] = ACTIONS(5571),
    [anon_sym_RBRACE] = ACTIONS(5571),
    [anon_sym_LBRACK] = ACTIONS(5569),
    [anon_sym_RBRACK] = ACTIONS(5571),
    [anon_sym_EQ] = ACTIONS(5569),
    [anon_sym_COLON] = ACTIONS(5571),
    [anon_sym_QMARK] = ACTIONS(5571),
    [anon_sym_STAR_EQ] = ACTIONS(5571),
    [anon_sym_SLASH_EQ] = ACTIONS(5571),
    [anon_sym_PERCENT_EQ] = ACTIONS(5571),
    [anon_sym_PLUS_EQ] = ACTIONS(5571),
    [anon_sym_DASH_EQ] = ACTIONS(5571),
    [anon_sym_LT_LT_EQ] = ACTIONS(5571),
    [anon_sym_GT_GT_EQ] = ACTIONS(5571),
    [anon_sym_AMP_EQ] = ACTIONS(5571),
    [anon_sym_CARET_EQ] = ACTIONS(5571),
    [anon_sym_PIPE_EQ] = ACTIONS(5571),
    [anon_sym_and_eq] = ACTIONS(5569),
    [anon_sym_or_eq] = ACTIONS(5569),
    [anon_sym_xor_eq] = ACTIONS(5569),
    [anon_sym_LT_EQ_GT] = ACTIONS(5571),
    [anon_sym_or] = ACTIONS(5569),
    [anon_sym_and] = ACTIONS(5569),
    [anon_sym_bitor] = ACTIONS(5569),
    [anon_sym_xor] = ACTIONS(5569),
    [anon_sym_bitand] = ACTIONS(5569),
    [anon_sym_not_eq] = ACTIONS(5569),
    [anon_sym_DASH_DASH] = ACTIONS(5571),
    [anon_sym_PLUS_PLUS] = ACTIONS(5571),
    [anon_sym_DOT] = ACTIONS(5569),
    [anon_sym_DOT_STAR] = ACTIONS(5571),
    [anon_sym_DASH_GT] = ACTIONS(5571),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(5569),
  },
  [2357] = {
    [sym_attribute_specifier] = STATE(1940),
    [sym_field_declaration_list] = STATE(2532),
    [sym_virtual_specifier] = STATE(6682),
    [sym_base_class_clause] = STATE(7395),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4904),
    [anon_sym_COMMA] = ACTIONS(4904),
    [anon_sym_RPAREN] = ACTIONS(4904),
    [anon_sym_LPAREN2] = ACTIONS(4904),
    [anon_sym_DASH] = ACTIONS(4902),
    [anon_sym_PLUS] = ACTIONS(4902),
    [anon_sym_STAR] = ACTIONS(4904),
    [anon_sym_SLASH] = ACTIONS(4902),
    [anon_sym_PERCENT] = ACTIONS(4904),
    [anon_sym_PIPE_PIPE] = ACTIONS(4904),
    [anon_sym_AMP_AMP] = ACTIONS(4904),
    [anon_sym_PIPE] = ACTIONS(4902),
    [anon_sym_CARET] = ACTIONS(4904),
    [anon_sym_AMP] = ACTIONS(4902),
    [anon_sym_EQ_EQ] = ACTIONS(4904),
    [anon_sym_BANG_EQ] = ACTIONS(4904),
    [anon_sym_GT] = ACTIONS(4902),
    [anon_sym_GT_EQ] = ACTIONS(4904),
    [anon_sym_LT_EQ] = ACTIONS(4902),
    [anon_sym_LT] = ACTIONS(4902),
    [anon_sym_LT_LT] = ACTIONS(4904),
    [anon_sym_GT_GT] = ACTIONS(4904),
    [anon_sym_SEMI] = ACTIONS(4904),
    [anon_sym___extension__] = ACTIONS(4904),
    [anon_sym___attribute__] = ACTIONS(5573),
    [anon_sym_LBRACE] = ACTIONS(5575),
    [anon_sym_RBRACE] = ACTIONS(4904),
    [anon_sym_LBRACK] = ACTIONS(4904),
    [anon_sym_RBRACK] = ACTIONS(4904),
    [anon_sym_const] = ACTIONS(4902),
    [anon_sym_constexpr] = ACTIONS(4904),
    [anon_sym_volatile] = ACTIONS(4904),
    [anon_sym_restrict] = ACTIONS(4904),
    [anon_sym___restrict__] = ACTIONS(4904),
    [anon_sym__Atomic] = ACTIONS(4904),
    [anon_sym__Noreturn] = ACTIONS(4904),
    [anon_sym_noreturn] = ACTIONS(4904),
    [anon_sym_mutable] = ACTIONS(4904),
    [anon_sym_constinit] = ACTIONS(4904),
    [anon_sym_consteval] = ACTIONS(4904),
    [anon_sym_PROGMEM] = ACTIONS(4904),
    [anon_sym_COLON] = ACTIONS(4910),
    [anon_sym_QMARK] = ACTIONS(4904),
    [anon_sym_LT_EQ_GT] = ACTIONS(4904),
    [anon_sym_or] = ACTIONS(4904),
    [anon_sym_and] = ACTIONS(4904),
    [anon_sym_bitor] = ACTIONS(4904),
    [anon_sym_xor] = ACTIONS(4904),
    [anon_sym_bitand] = ACTIONS(4904),
    [anon_sym_not_eq] = ACTIONS(4904),
    [anon_sym_DASH_DASH] = ACTIONS(4904),
    [anon_sym_PLUS_PLUS] = ACTIONS(4904),
    [anon_sym_DOT] = ACTIONS(4902),
    [anon_sym_DOT_STAR] = ACTIONS(4904),
    [anon_sym_DASH_GT] = ACTIONS(4904),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4904),
    [anon_sym_decltype] = ACTIONS(4904),
    [anon_sym_final] = ACTIONS(5577),
    [anon_sym_override] = ACTIONS(5577),
    [anon_sym_requires] = ACTIONS(4904),
  },
  [2358] = {
    [sym_identifier] = ACTIONS(5042),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5044),
    [anon_sym_COMMA] = ACTIONS(5044),
    [anon_sym_RPAREN] = ACTIONS(5044),
    [aux_sym_preproc_if_token2] = ACTIONS(5044),
    [aux_sym_preproc_else_token1] = ACTIONS(5044),
    [aux_sym_preproc_elif_token1] = ACTIONS(5042),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5044),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5044),
    [anon_sym_LPAREN2] = ACTIONS(5044),
    [anon_sym_DASH] = ACTIONS(5042),
    [anon_sym_PLUS] = ACTIONS(5042),
    [anon_sym_STAR] = ACTIONS(5042),
    [anon_sym_SLASH] = ACTIONS(5042),
    [anon_sym_PERCENT] = ACTIONS(5042),
    [anon_sym_PIPE_PIPE] = ACTIONS(5044),
    [anon_sym_AMP_AMP] = ACTIONS(5044),
    [anon_sym_PIPE] = ACTIONS(5042),
    [anon_sym_CARET] = ACTIONS(5042),
    [anon_sym_AMP] = ACTIONS(5042),
    [anon_sym_EQ_EQ] = ACTIONS(5044),
    [anon_sym_BANG_EQ] = ACTIONS(5044),
    [anon_sym_GT] = ACTIONS(5042),
    [anon_sym_GT_EQ] = ACTIONS(5044),
    [anon_sym_LT_EQ] = ACTIONS(5042),
    [anon_sym_LT] = ACTIONS(5042),
    [anon_sym_LT_LT] = ACTIONS(5042),
    [anon_sym_GT_GT] = ACTIONS(5042),
    [anon_sym_SEMI] = ACTIONS(5044),
    [anon_sym___attribute__] = ACTIONS(5042),
    [anon_sym_LBRACE] = ACTIONS(5044),
    [anon_sym_RBRACE] = ACTIONS(5044),
    [anon_sym_LBRACK] = ACTIONS(5044),
    [anon_sym_RBRACK] = ACTIONS(5044),
    [anon_sym_EQ] = ACTIONS(5042),
    [anon_sym_COLON] = ACTIONS(5044),
    [anon_sym_QMARK] = ACTIONS(5044),
    [anon_sym_STAR_EQ] = ACTIONS(5044),
    [anon_sym_SLASH_EQ] = ACTIONS(5044),
    [anon_sym_PERCENT_EQ] = ACTIONS(5044),
    [anon_sym_PLUS_EQ] = ACTIONS(5044),
    [anon_sym_DASH_EQ] = ACTIONS(5044),
    [anon_sym_LT_LT_EQ] = ACTIONS(5044),
    [anon_sym_GT_GT_EQ] = ACTIONS(5044),
    [anon_sym_AMP_EQ] = ACTIONS(5044),
    [anon_sym_CARET_EQ] = ACTIONS(5044),
    [anon_sym_PIPE_EQ] = ACTIONS(5044),
    [anon_sym_and_eq] = ACTIONS(5042),
    [anon_sym_or_eq] = ACTIONS(5042),
    [anon_sym_xor_eq] = ACTIONS(5042),
    [anon_sym_LT_EQ_GT] = ACTIONS(5044),
    [anon_sym_or] = ACTIONS(5042),
    [anon_sym_and] = ACTIONS(5042),
    [anon_sym_bitor] = ACTIONS(5042),
    [anon_sym_xor] = ACTIONS(5042),
    [anon_sym_bitand] = ACTIONS(5042),
    [anon_sym_not_eq] = ACTIONS(5042),
    [anon_sym_DASH_DASH] = ACTIONS(5044),
    [anon_sym_PLUS_PLUS] = ACTIONS(5044),
    [anon_sym_DOT] = ACTIONS(5042),
    [anon_sym_DOT_STAR] = ACTIONS(5044),
    [anon_sym_DASH_GT] = ACTIONS(5044),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5042),
    [anon_sym_decltype] = ACTIONS(5042),
  },
  [2359] = {
    [sym_identifier] = ACTIONS(5579),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5581),
    [anon_sym_COMMA] = ACTIONS(5581),
    [anon_sym_RPAREN] = ACTIONS(5581),
    [aux_sym_preproc_if_token2] = ACTIONS(5581),
    [aux_sym_preproc_else_token1] = ACTIONS(5581),
    [aux_sym_preproc_elif_token1] = ACTIONS(5579),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5581),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5581),
    [anon_sym_LPAREN2] = ACTIONS(5581),
    [anon_sym_DASH] = ACTIONS(5579),
    [anon_sym_PLUS] = ACTIONS(5579),
    [anon_sym_STAR] = ACTIONS(5579),
    [anon_sym_SLASH] = ACTIONS(5579),
    [anon_sym_PERCENT] = ACTIONS(5579),
    [anon_sym_PIPE_PIPE] = ACTIONS(5581),
    [anon_sym_AMP_AMP] = ACTIONS(5581),
    [anon_sym_PIPE] = ACTIONS(5579),
    [anon_sym_CARET] = ACTIONS(5579),
    [anon_sym_AMP] = ACTIONS(5579),
    [anon_sym_EQ_EQ] = ACTIONS(5581),
    [anon_sym_BANG_EQ] = ACTIONS(5581),
    [anon_sym_GT] = ACTIONS(5579),
    [anon_sym_GT_EQ] = ACTIONS(5581),
    [anon_sym_LT_EQ] = ACTIONS(5579),
    [anon_sym_LT] = ACTIONS(5579),
    [anon_sym_LT_LT] = ACTIONS(5579),
    [anon_sym_GT_GT] = ACTIONS(5579),
    [anon_sym_SEMI] = ACTIONS(5581),
    [anon_sym___attribute__] = ACTIONS(5579),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5581),
    [anon_sym_LBRACE] = ACTIONS(5581),
    [anon_sym_RBRACE] = ACTIONS(5581),
    [anon_sym_LBRACK] = ACTIONS(5579),
    [anon_sym_RBRACK] = ACTIONS(5581),
    [anon_sym_EQ] = ACTIONS(5579),
    [anon_sym_COLON] = ACTIONS(5581),
    [anon_sym_QMARK] = ACTIONS(5581),
    [anon_sym_STAR_EQ] = ACTIONS(5581),
    [anon_sym_SLASH_EQ] = ACTIONS(5581),
    [anon_sym_PERCENT_EQ] = ACTIONS(5581),
    [anon_sym_PLUS_EQ] = ACTIONS(5581),
    [anon_sym_DASH_EQ] = ACTIONS(5581),
    [anon_sym_LT_LT_EQ] = ACTIONS(5581),
    [anon_sym_GT_GT_EQ] = ACTIONS(5581),
    [anon_sym_AMP_EQ] = ACTIONS(5581),
    [anon_sym_CARET_EQ] = ACTIONS(5581),
    [anon_sym_PIPE_EQ] = ACTIONS(5581),
    [anon_sym_and_eq] = ACTIONS(5579),
    [anon_sym_or_eq] = ACTIONS(5579),
    [anon_sym_xor_eq] = ACTIONS(5579),
    [anon_sym_LT_EQ_GT] = ACTIONS(5581),
    [anon_sym_or] = ACTIONS(5579),
    [anon_sym_and] = ACTIONS(5579),
    [anon_sym_bitor] = ACTIONS(5579),
    [anon_sym_xor] = ACTIONS(5579),
    [anon_sym_bitand] = ACTIONS(5579),
    [anon_sym_not_eq] = ACTIONS(5579),
    [anon_sym_DASH_DASH] = ACTIONS(5581),
    [anon_sym_PLUS_PLUS] = ACTIONS(5581),
    [anon_sym_DOT] = ACTIONS(5579),
    [anon_sym_DOT_STAR] = ACTIONS(5581),
    [anon_sym_DASH_GT] = ACTIONS(5581),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(5579),
  },
  [2360] = {
    [sym_identifier] = ACTIONS(5129),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5131),
    [anon_sym_COMMA] = ACTIONS(5131),
    [anon_sym_RPAREN] = ACTIONS(5131),
    [aux_sym_preproc_if_token2] = ACTIONS(5131),
    [aux_sym_preproc_else_token1] = ACTIONS(5131),
    [aux_sym_preproc_elif_token1] = ACTIONS(5129),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5131),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5131),
    [anon_sym_LPAREN2] = ACTIONS(5131),
    [anon_sym_DASH] = ACTIONS(5129),
    [anon_sym_PLUS] = ACTIONS(5129),
    [anon_sym_STAR] = ACTIONS(5129),
    [anon_sym_SLASH] = ACTIONS(5129),
    [anon_sym_PERCENT] = ACTIONS(5129),
    [anon_sym_PIPE_PIPE] = ACTIONS(5131),
    [anon_sym_AMP_AMP] = ACTIONS(5131),
    [anon_sym_PIPE] = ACTIONS(5129),
    [anon_sym_CARET] = ACTIONS(5129),
    [anon_sym_AMP] = ACTIONS(5129),
    [anon_sym_EQ_EQ] = ACTIONS(5131),
    [anon_sym_BANG_EQ] = ACTIONS(5131),
    [anon_sym_GT] = ACTIONS(5129),
    [anon_sym_GT_EQ] = ACTIONS(5131),
    [anon_sym_LT_EQ] = ACTIONS(5129),
    [anon_sym_LT] = ACTIONS(5129),
    [anon_sym_LT_LT] = ACTIONS(5129),
    [anon_sym_GT_GT] = ACTIONS(5129),
    [anon_sym_SEMI] = ACTIONS(5131),
    [anon_sym___attribute__] = ACTIONS(5129),
    [anon_sym_LBRACE] = ACTIONS(5131),
    [anon_sym_RBRACE] = ACTIONS(5131),
    [anon_sym_LBRACK] = ACTIONS(5131),
    [anon_sym_RBRACK] = ACTIONS(5131),
    [anon_sym_EQ] = ACTIONS(5129),
    [anon_sym_COLON] = ACTIONS(5131),
    [anon_sym_QMARK] = ACTIONS(5131),
    [anon_sym_STAR_EQ] = ACTIONS(5131),
    [anon_sym_SLASH_EQ] = ACTIONS(5131),
    [anon_sym_PERCENT_EQ] = ACTIONS(5131),
    [anon_sym_PLUS_EQ] = ACTIONS(5131),
    [anon_sym_DASH_EQ] = ACTIONS(5131),
    [anon_sym_LT_LT_EQ] = ACTIONS(5131),
    [anon_sym_GT_GT_EQ] = ACTIONS(5131),
    [anon_sym_AMP_EQ] = ACTIONS(5131),
    [anon_sym_CARET_EQ] = ACTIONS(5131),
    [anon_sym_PIPE_EQ] = ACTIONS(5131),
    [anon_sym_and_eq] = ACTIONS(5129),
    [anon_sym_or_eq] = ACTIONS(5129),
    [anon_sym_xor_eq] = ACTIONS(5129),
    [anon_sym_LT_EQ_GT] = ACTIONS(5131),
    [anon_sym_or] = ACTIONS(5129),
    [anon_sym_and] = ACTIONS(5129),
    [anon_sym_bitor] = ACTIONS(5129),
    [anon_sym_xor] = ACTIONS(5129),
    [anon_sym_bitand] = ACTIONS(5129),
    [anon_sym_not_eq] = ACTIONS(5129),
    [anon_sym_DASH_DASH] = ACTIONS(5131),
    [anon_sym_PLUS_PLUS] = ACTIONS(5131),
    [anon_sym_DOT] = ACTIONS(5129),
    [anon_sym_DOT_STAR] = ACTIONS(5131),
    [anon_sym_DASH_GT] = ACTIONS(5131),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5129),
    [anon_sym_decltype] = ACTIONS(5129),
  },
  [2361] = {
    [sym_identifier] = ACTIONS(5583),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5585),
    [anon_sym_COMMA] = ACTIONS(5585),
    [anon_sym_RPAREN] = ACTIONS(5585),
    [aux_sym_preproc_if_token2] = ACTIONS(5585),
    [aux_sym_preproc_else_token1] = ACTIONS(5585),
    [aux_sym_preproc_elif_token1] = ACTIONS(5583),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5585),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5585),
    [anon_sym_LPAREN2] = ACTIONS(5585),
    [anon_sym_DASH] = ACTIONS(5583),
    [anon_sym_PLUS] = ACTIONS(5583),
    [anon_sym_STAR] = ACTIONS(5583),
    [anon_sym_SLASH] = ACTIONS(5583),
    [anon_sym_PERCENT] = ACTIONS(5583),
    [anon_sym_PIPE_PIPE] = ACTIONS(5585),
    [anon_sym_AMP_AMP] = ACTIONS(5585),
    [anon_sym_PIPE] = ACTIONS(5583),
    [anon_sym_CARET] = ACTIONS(5583),
    [anon_sym_AMP] = ACTIONS(5583),
    [anon_sym_EQ_EQ] = ACTIONS(5585),
    [anon_sym_BANG_EQ] = ACTIONS(5585),
    [anon_sym_GT] = ACTIONS(5583),
    [anon_sym_GT_EQ] = ACTIONS(5585),
    [anon_sym_LT_EQ] = ACTIONS(5583),
    [anon_sym_LT] = ACTIONS(5583),
    [anon_sym_LT_LT] = ACTIONS(5583),
    [anon_sym_GT_GT] = ACTIONS(5583),
    [anon_sym_SEMI] = ACTIONS(5585),
    [anon_sym___attribute__] = ACTIONS(5583),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5585),
    [anon_sym_LBRACE] = ACTIONS(5585),
    [anon_sym_RBRACE] = ACTIONS(5585),
    [anon_sym_LBRACK] = ACTIONS(5583),
    [anon_sym_RBRACK] = ACTIONS(5585),
    [anon_sym_EQ] = ACTIONS(5583),
    [anon_sym_COLON] = ACTIONS(5585),
    [anon_sym_QMARK] = ACTIONS(5585),
    [anon_sym_STAR_EQ] = ACTIONS(5585),
    [anon_sym_SLASH_EQ] = ACTIONS(5585),
    [anon_sym_PERCENT_EQ] = ACTIONS(5585),
    [anon_sym_PLUS_EQ] = ACTIONS(5585),
    [anon_sym_DASH_EQ] = ACTIONS(5585),
    [anon_sym_LT_LT_EQ] = ACTIONS(5585),
    [anon_sym_GT_GT_EQ] = ACTIONS(5585),
    [anon_sym_AMP_EQ] = ACTIONS(5585),
    [anon_sym_CARET_EQ] = ACTIONS(5585),
    [anon_sym_PIPE_EQ] = ACTIONS(5585),
    [anon_sym_and_eq] = ACTIONS(5583),
    [anon_sym_or_eq] = ACTIONS(5583),
    [anon_sym_xor_eq] = ACTIONS(5583),
    [anon_sym_LT_EQ_GT] = ACTIONS(5585),
    [anon_sym_or] = ACTIONS(5583),
    [anon_sym_and] = ACTIONS(5583),
    [anon_sym_bitor] = ACTIONS(5583),
    [anon_sym_xor] = ACTIONS(5583),
    [anon_sym_bitand] = ACTIONS(5583),
    [anon_sym_not_eq] = ACTIONS(5583),
    [anon_sym_DASH_DASH] = ACTIONS(5585),
    [anon_sym_PLUS_PLUS] = ACTIONS(5585),
    [anon_sym_DOT] = ACTIONS(5583),
    [anon_sym_DOT_STAR] = ACTIONS(5585),
    [anon_sym_DASH_GT] = ACTIONS(5585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(5583),
  },
  [2362] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2332),
    [sym_identifier] = ACTIONS(5420),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5418),
    [anon_sym_COMMA] = ACTIONS(5418),
    [aux_sym_preproc_if_token2] = ACTIONS(5418),
    [aux_sym_preproc_else_token1] = ACTIONS(5418),
    [aux_sym_preproc_elif_token1] = ACTIONS(5420),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5418),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5418),
    [anon_sym_LPAREN2] = ACTIONS(5418),
    [anon_sym_DASH] = ACTIONS(5420),
    [anon_sym_PLUS] = ACTIONS(5420),
    [anon_sym_STAR] = ACTIONS(5420),
    [anon_sym_SLASH] = ACTIONS(5420),
    [anon_sym_PERCENT] = ACTIONS(5420),
    [anon_sym_PIPE_PIPE] = ACTIONS(5418),
    [anon_sym_AMP_AMP] = ACTIONS(5418),
    [anon_sym_PIPE] = ACTIONS(5420),
    [anon_sym_CARET] = ACTIONS(5420),
    [anon_sym_AMP] = ACTIONS(5420),
    [anon_sym_EQ_EQ] = ACTIONS(5418),
    [anon_sym_BANG_EQ] = ACTIONS(5418),
    [anon_sym_GT] = ACTIONS(5420),
    [anon_sym_GT_EQ] = ACTIONS(5418),
    [anon_sym_LT_EQ] = ACTIONS(5420),
    [anon_sym_LT] = ACTIONS(5420),
    [anon_sym_LT_LT] = ACTIONS(5420),
    [anon_sym_GT_GT] = ACTIONS(5420),
    [anon_sym___attribute__] = ACTIONS(5420),
    [anon_sym_LBRACE] = ACTIONS(5418),
    [anon_sym_signed] = ACTIONS(5587),
    [anon_sym_unsigned] = ACTIONS(5587),
    [anon_sym_long] = ACTIONS(5587),
    [anon_sym_short] = ACTIONS(5587),
    [anon_sym_LBRACK] = ACTIONS(5418),
    [anon_sym_EQ] = ACTIONS(5420),
    [anon_sym_QMARK] = ACTIONS(5418),
    [anon_sym_STAR_EQ] = ACTIONS(5418),
    [anon_sym_SLASH_EQ] = ACTIONS(5418),
    [anon_sym_PERCENT_EQ] = ACTIONS(5418),
    [anon_sym_PLUS_EQ] = ACTIONS(5418),
    [anon_sym_DASH_EQ] = ACTIONS(5418),
    [anon_sym_LT_LT_EQ] = ACTIONS(5418),
    [anon_sym_GT_GT_EQ] = ACTIONS(5418),
    [anon_sym_AMP_EQ] = ACTIONS(5418),
    [anon_sym_CARET_EQ] = ACTIONS(5418),
    [anon_sym_PIPE_EQ] = ACTIONS(5418),
    [anon_sym_and_eq] = ACTIONS(5420),
    [anon_sym_or_eq] = ACTIONS(5420),
    [anon_sym_xor_eq] = ACTIONS(5420),
    [anon_sym_LT_EQ_GT] = ACTIONS(5418),
    [anon_sym_or] = ACTIONS(5420),
    [anon_sym_and] = ACTIONS(5420),
    [anon_sym_bitor] = ACTIONS(5420),
    [anon_sym_xor] = ACTIONS(5420),
    [anon_sym_bitand] = ACTIONS(5420),
    [anon_sym_not_eq] = ACTIONS(5420),
    [anon_sym_DASH_DASH] = ACTIONS(5418),
    [anon_sym_PLUS_PLUS] = ACTIONS(5418),
    [anon_sym_DOT] = ACTIONS(5420),
    [anon_sym_DOT_STAR] = ACTIONS(5418),
    [anon_sym_DASH_GT] = ACTIONS(5418),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5420),
    [anon_sym_decltype] = ACTIONS(5420),
  },
  [2363] = {
    [sym_identifier] = ACTIONS(5058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5060),
    [anon_sym_COMMA] = ACTIONS(5060),
    [anon_sym_RPAREN] = ACTIONS(5060),
    [aux_sym_preproc_if_token2] = ACTIONS(5060),
    [aux_sym_preproc_else_token1] = ACTIONS(5060),
    [aux_sym_preproc_elif_token1] = ACTIONS(5058),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5060),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5060),
    [anon_sym_LPAREN2] = ACTIONS(5060),
    [anon_sym_DASH] = ACTIONS(5058),
    [anon_sym_PLUS] = ACTIONS(5058),
    [anon_sym_STAR] = ACTIONS(5058),
    [anon_sym_SLASH] = ACTIONS(5058),
    [anon_sym_PERCENT] = ACTIONS(5058),
    [anon_sym_PIPE_PIPE] = ACTIONS(5060),
    [anon_sym_AMP_AMP] = ACTIONS(5060),
    [anon_sym_PIPE] = ACTIONS(5058),
    [anon_sym_CARET] = ACTIONS(5058),
    [anon_sym_AMP] = ACTIONS(5058),
    [anon_sym_EQ_EQ] = ACTIONS(5060),
    [anon_sym_BANG_EQ] = ACTIONS(5060),
    [anon_sym_GT] = ACTIONS(5058),
    [anon_sym_GT_EQ] = ACTIONS(5060),
    [anon_sym_LT_EQ] = ACTIONS(5058),
    [anon_sym_LT] = ACTIONS(5058),
    [anon_sym_LT_LT] = ACTIONS(5058),
    [anon_sym_GT_GT] = ACTIONS(5058),
    [anon_sym_SEMI] = ACTIONS(5060),
    [anon_sym___attribute__] = ACTIONS(5058),
    [anon_sym_LBRACE] = ACTIONS(5060),
    [anon_sym_RBRACE] = ACTIONS(5060),
    [anon_sym_LBRACK] = ACTIONS(5060),
    [anon_sym_RBRACK] = ACTIONS(5060),
    [anon_sym_EQ] = ACTIONS(5058),
    [anon_sym_COLON] = ACTIONS(5060),
    [anon_sym_QMARK] = ACTIONS(5060),
    [anon_sym_STAR_EQ] = ACTIONS(5060),
    [anon_sym_SLASH_EQ] = ACTIONS(5060),
    [anon_sym_PERCENT_EQ] = ACTIONS(5060),
    [anon_sym_PLUS_EQ] = ACTIONS(5060),
    [anon_sym_DASH_EQ] = ACTIONS(5060),
    [anon_sym_LT_LT_EQ] = ACTIONS(5060),
    [anon_sym_GT_GT_EQ] = ACTIONS(5060),
    [anon_sym_AMP_EQ] = ACTIONS(5060),
    [anon_sym_CARET_EQ] = ACTIONS(5060),
    [anon_sym_PIPE_EQ] = ACTIONS(5060),
    [anon_sym_and_eq] = ACTIONS(5058),
    [anon_sym_or_eq] = ACTIONS(5058),
    [anon_sym_xor_eq] = ACTIONS(5058),
    [anon_sym_LT_EQ_GT] = ACTIONS(5060),
    [anon_sym_or] = ACTIONS(5058),
    [anon_sym_and] = ACTIONS(5058),
    [anon_sym_bitor] = ACTIONS(5058),
    [anon_sym_xor] = ACTIONS(5058),
    [anon_sym_bitand] = ACTIONS(5058),
    [anon_sym_not_eq] = ACTIONS(5058),
    [anon_sym_DASH_DASH] = ACTIONS(5060),
    [anon_sym_PLUS_PLUS] = ACTIONS(5060),
    [anon_sym_DOT] = ACTIONS(5058),
    [anon_sym_DOT_STAR] = ACTIONS(5060),
    [anon_sym_DASH_GT] = ACTIONS(5060),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5058),
    [anon_sym_decltype] = ACTIONS(5058),
  },
  [2364] = {
    [sym_identifier] = ACTIONS(5117),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5119),
    [anon_sym_COMMA] = ACTIONS(5119),
    [anon_sym_RPAREN] = ACTIONS(5119),
    [aux_sym_preproc_if_token2] = ACTIONS(5119),
    [aux_sym_preproc_else_token1] = ACTIONS(5119),
    [aux_sym_preproc_elif_token1] = ACTIONS(5117),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5119),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5119),
    [anon_sym_LPAREN2] = ACTIONS(5119),
    [anon_sym_DASH] = ACTIONS(5117),
    [anon_sym_PLUS] = ACTIONS(5117),
    [anon_sym_STAR] = ACTIONS(5117),
    [anon_sym_SLASH] = ACTIONS(5117),
    [anon_sym_PERCENT] = ACTIONS(5117),
    [anon_sym_PIPE_PIPE] = ACTIONS(5119),
    [anon_sym_AMP_AMP] = ACTIONS(5119),
    [anon_sym_PIPE] = ACTIONS(5117),
    [anon_sym_CARET] = ACTIONS(5117),
    [anon_sym_AMP] = ACTIONS(5117),
    [anon_sym_EQ_EQ] = ACTIONS(5119),
    [anon_sym_BANG_EQ] = ACTIONS(5119),
    [anon_sym_GT] = ACTIONS(5117),
    [anon_sym_GT_EQ] = ACTIONS(5119),
    [anon_sym_LT_EQ] = ACTIONS(5117),
    [anon_sym_LT] = ACTIONS(5117),
    [anon_sym_LT_LT] = ACTIONS(5117),
    [anon_sym_GT_GT] = ACTIONS(5117),
    [anon_sym_SEMI] = ACTIONS(5119),
    [anon_sym___attribute__] = ACTIONS(5117),
    [anon_sym_LBRACE] = ACTIONS(5119),
    [anon_sym_RBRACE] = ACTIONS(5119),
    [anon_sym_LBRACK] = ACTIONS(5119),
    [anon_sym_RBRACK] = ACTIONS(5119),
    [anon_sym_EQ] = ACTIONS(5117),
    [anon_sym_COLON] = ACTIONS(5119),
    [anon_sym_QMARK] = ACTIONS(5119),
    [anon_sym_STAR_EQ] = ACTIONS(5119),
    [anon_sym_SLASH_EQ] = ACTIONS(5119),
    [anon_sym_PERCENT_EQ] = ACTIONS(5119),
    [anon_sym_PLUS_EQ] = ACTIONS(5119),
    [anon_sym_DASH_EQ] = ACTIONS(5119),
    [anon_sym_LT_LT_EQ] = ACTIONS(5119),
    [anon_sym_GT_GT_EQ] = ACTIONS(5119),
    [anon_sym_AMP_EQ] = ACTIONS(5119),
    [anon_sym_CARET_EQ] = ACTIONS(5119),
    [anon_sym_PIPE_EQ] = ACTIONS(5119),
    [anon_sym_and_eq] = ACTIONS(5117),
    [anon_sym_or_eq] = ACTIONS(5117),
    [anon_sym_xor_eq] = ACTIONS(5117),
    [anon_sym_LT_EQ_GT] = ACTIONS(5119),
    [anon_sym_or] = ACTIONS(5117),
    [anon_sym_and] = ACTIONS(5117),
    [anon_sym_bitor] = ACTIONS(5117),
    [anon_sym_xor] = ACTIONS(5117),
    [anon_sym_bitand] = ACTIONS(5117),
    [anon_sym_not_eq] = ACTIONS(5117),
    [anon_sym_DASH_DASH] = ACTIONS(5119),
    [anon_sym_PLUS_PLUS] = ACTIONS(5119),
    [anon_sym_DOT] = ACTIONS(5117),
    [anon_sym_DOT_STAR] = ACTIONS(5119),
    [anon_sym_DASH_GT] = ACTIONS(5119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5117),
    [anon_sym_decltype] = ACTIONS(5117),
  },
  [2365] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2327),
    [sym_identifier] = ACTIONS(4766),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5139),
    [anon_sym_COMMA] = ACTIONS(5139),
    [anon_sym_RPAREN] = ACTIONS(5139),
    [anon_sym_LPAREN2] = ACTIONS(5139),
    [anon_sym_DASH] = ACTIONS(5142),
    [anon_sym_PLUS] = ACTIONS(5142),
    [anon_sym_STAR] = ACTIONS(5142),
    [anon_sym_SLASH] = ACTIONS(5142),
    [anon_sym_PERCENT] = ACTIONS(5142),
    [anon_sym_PIPE_PIPE] = ACTIONS(5139),
    [anon_sym_AMP_AMP] = ACTIONS(5139),
    [anon_sym_PIPE] = ACTIONS(5142),
    [anon_sym_CARET] = ACTIONS(5142),
    [anon_sym_AMP] = ACTIONS(5142),
    [anon_sym_EQ_EQ] = ACTIONS(5139),
    [anon_sym_BANG_EQ] = ACTIONS(5139),
    [anon_sym_GT] = ACTIONS(5142),
    [anon_sym_GT_EQ] = ACTIONS(5139),
    [anon_sym_LT_EQ] = ACTIONS(5142),
    [anon_sym_LT] = ACTIONS(5142),
    [anon_sym_LT_LT] = ACTIONS(5142),
    [anon_sym_GT_GT] = ACTIONS(5142),
    [anon_sym___attribute__] = ACTIONS(5142),
    [anon_sym_LBRACE] = ACTIONS(5139),
    [anon_sym_signed] = ACTIONS(5529),
    [anon_sym_unsigned] = ACTIONS(5529),
    [anon_sym_long] = ACTIONS(5529),
    [anon_sym_short] = ACTIONS(5529),
    [anon_sym_LBRACK] = ACTIONS(5139),
    [anon_sym_EQ] = ACTIONS(5142),
    [aux_sym_primitive_type_token1] = ACTIONS(4766),
    [anon_sym_byte] = ACTIONS(4766),
    [anon_sym_word] = ACTIONS(4766),
    [anon_sym_QMARK] = ACTIONS(5139),
    [anon_sym_STAR_EQ] = ACTIONS(5139),
    [anon_sym_SLASH_EQ] = ACTIONS(5139),
    [anon_sym_PERCENT_EQ] = ACTIONS(5139),
    [anon_sym_PLUS_EQ] = ACTIONS(5139),
    [anon_sym_DASH_EQ] = ACTIONS(5139),
    [anon_sym_LT_LT_EQ] = ACTIONS(5139),
    [anon_sym_GT_GT_EQ] = ACTIONS(5139),
    [anon_sym_AMP_EQ] = ACTIONS(5139),
    [anon_sym_CARET_EQ] = ACTIONS(5139),
    [anon_sym_PIPE_EQ] = ACTIONS(5139),
    [anon_sym_and_eq] = ACTIONS(5142),
    [anon_sym_or_eq] = ACTIONS(5142),
    [anon_sym_xor_eq] = ACTIONS(5142),
    [anon_sym_LT_EQ_GT] = ACTIONS(5139),
    [anon_sym_or] = ACTIONS(5142),
    [anon_sym_and] = ACTIONS(5142),
    [anon_sym_bitor] = ACTIONS(5142),
    [anon_sym_xor] = ACTIONS(5142),
    [anon_sym_bitand] = ACTIONS(5142),
    [anon_sym_not_eq] = ACTIONS(5142),
    [anon_sym_DASH_DASH] = ACTIONS(5139),
    [anon_sym_PLUS_PLUS] = ACTIONS(5139),
    [anon_sym_DOT] = ACTIONS(5142),
    [anon_sym_DOT_STAR] = ACTIONS(5139),
    [anon_sym_DASH_GT] = ACTIONS(5142),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5142),
    [anon_sym_decltype] = ACTIONS(5142),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5139),
  },
  [2366] = {
    [sym_identifier] = ACTIONS(5589),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5591),
    [anon_sym_COMMA] = ACTIONS(5591),
    [anon_sym_RPAREN] = ACTIONS(5591),
    [aux_sym_preproc_if_token2] = ACTIONS(5591),
    [aux_sym_preproc_else_token1] = ACTIONS(5591),
    [aux_sym_preproc_elif_token1] = ACTIONS(5589),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5591),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5591),
    [anon_sym_LPAREN2] = ACTIONS(5591),
    [anon_sym_DASH] = ACTIONS(5589),
    [anon_sym_PLUS] = ACTIONS(5589),
    [anon_sym_STAR] = ACTIONS(5589),
    [anon_sym_SLASH] = ACTIONS(5589),
    [anon_sym_PERCENT] = ACTIONS(5589),
    [anon_sym_PIPE_PIPE] = ACTIONS(5591),
    [anon_sym_AMP_AMP] = ACTIONS(5591),
    [anon_sym_PIPE] = ACTIONS(5589),
    [anon_sym_CARET] = ACTIONS(5589),
    [anon_sym_AMP] = ACTIONS(5589),
    [anon_sym_EQ_EQ] = ACTIONS(5591),
    [anon_sym_BANG_EQ] = ACTIONS(5591),
    [anon_sym_GT] = ACTIONS(5589),
    [anon_sym_GT_EQ] = ACTIONS(5591),
    [anon_sym_LT_EQ] = ACTIONS(5589),
    [anon_sym_LT] = ACTIONS(5589),
    [anon_sym_LT_LT] = ACTIONS(5589),
    [anon_sym_GT_GT] = ACTIONS(5589),
    [anon_sym_SEMI] = ACTIONS(5591),
    [anon_sym___attribute__] = ACTIONS(5589),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5591),
    [anon_sym_LBRACE] = ACTIONS(5591),
    [anon_sym_RBRACE] = ACTIONS(5591),
    [anon_sym_LBRACK] = ACTIONS(5589),
    [anon_sym_RBRACK] = ACTIONS(5591),
    [anon_sym_EQ] = ACTIONS(5589),
    [anon_sym_COLON] = ACTIONS(5591),
    [anon_sym_QMARK] = ACTIONS(5591),
    [anon_sym_STAR_EQ] = ACTIONS(5591),
    [anon_sym_SLASH_EQ] = ACTIONS(5591),
    [anon_sym_PERCENT_EQ] = ACTIONS(5591),
    [anon_sym_PLUS_EQ] = ACTIONS(5591),
    [anon_sym_DASH_EQ] = ACTIONS(5591),
    [anon_sym_LT_LT_EQ] = ACTIONS(5591),
    [anon_sym_GT_GT_EQ] = ACTIONS(5591),
    [anon_sym_AMP_EQ] = ACTIONS(5591),
    [anon_sym_CARET_EQ] = ACTIONS(5591),
    [anon_sym_PIPE_EQ] = ACTIONS(5591),
    [anon_sym_and_eq] = ACTIONS(5589),
    [anon_sym_or_eq] = ACTIONS(5589),
    [anon_sym_xor_eq] = ACTIONS(5589),
    [anon_sym_LT_EQ_GT] = ACTIONS(5591),
    [anon_sym_or] = ACTIONS(5589),
    [anon_sym_and] = ACTIONS(5589),
    [anon_sym_bitor] = ACTIONS(5589),
    [anon_sym_xor] = ACTIONS(5589),
    [anon_sym_bitand] = ACTIONS(5589),
    [anon_sym_not_eq] = ACTIONS(5589),
    [anon_sym_DASH_DASH] = ACTIONS(5591),
    [anon_sym_PLUS_PLUS] = ACTIONS(5591),
    [anon_sym_DOT] = ACTIONS(5589),
    [anon_sym_DOT_STAR] = ACTIONS(5591),
    [anon_sym_DASH_GT] = ACTIONS(5591),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(5589),
  },
  [2367] = {
    [sym_identifier] = ACTIONS(5593),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5595),
    [anon_sym_COMMA] = ACTIONS(5595),
    [anon_sym_RPAREN] = ACTIONS(5595),
    [aux_sym_preproc_if_token2] = ACTIONS(5595),
    [aux_sym_preproc_else_token1] = ACTIONS(5595),
    [aux_sym_preproc_elif_token1] = ACTIONS(5593),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5595),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5595),
    [anon_sym_LPAREN2] = ACTIONS(5595),
    [anon_sym_DASH] = ACTIONS(5593),
    [anon_sym_PLUS] = ACTIONS(5593),
    [anon_sym_STAR] = ACTIONS(5593),
    [anon_sym_SLASH] = ACTIONS(5593),
    [anon_sym_PERCENT] = ACTIONS(5593),
    [anon_sym_PIPE_PIPE] = ACTIONS(5595),
    [anon_sym_AMP_AMP] = ACTIONS(5595),
    [anon_sym_PIPE] = ACTIONS(5593),
    [anon_sym_CARET] = ACTIONS(5593),
    [anon_sym_AMP] = ACTIONS(5593),
    [anon_sym_EQ_EQ] = ACTIONS(5595),
    [anon_sym_BANG_EQ] = ACTIONS(5595),
    [anon_sym_GT] = ACTIONS(5593),
    [anon_sym_GT_EQ] = ACTIONS(5595),
    [anon_sym_LT_EQ] = ACTIONS(5593),
    [anon_sym_LT] = ACTIONS(5593),
    [anon_sym_LT_LT] = ACTIONS(5593),
    [anon_sym_GT_GT] = ACTIONS(5593),
    [anon_sym_SEMI] = ACTIONS(5595),
    [anon_sym___attribute__] = ACTIONS(5593),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5595),
    [anon_sym_LBRACE] = ACTIONS(5595),
    [anon_sym_RBRACE] = ACTIONS(5595),
    [anon_sym_LBRACK] = ACTIONS(5593),
    [anon_sym_RBRACK] = ACTIONS(5595),
    [anon_sym_EQ] = ACTIONS(5593),
    [anon_sym_COLON] = ACTIONS(5595),
    [anon_sym_QMARK] = ACTIONS(5595),
    [anon_sym_STAR_EQ] = ACTIONS(5595),
    [anon_sym_SLASH_EQ] = ACTIONS(5595),
    [anon_sym_PERCENT_EQ] = ACTIONS(5595),
    [anon_sym_PLUS_EQ] = ACTIONS(5595),
    [anon_sym_DASH_EQ] = ACTIONS(5595),
    [anon_sym_LT_LT_EQ] = ACTIONS(5595),
    [anon_sym_GT_GT_EQ] = ACTIONS(5595),
    [anon_sym_AMP_EQ] = ACTIONS(5595),
    [anon_sym_CARET_EQ] = ACTIONS(5595),
    [anon_sym_PIPE_EQ] = ACTIONS(5595),
    [anon_sym_and_eq] = ACTIONS(5593),
    [anon_sym_or_eq] = ACTIONS(5593),
    [anon_sym_xor_eq] = ACTIONS(5593),
    [anon_sym_LT_EQ_GT] = ACTIONS(5595),
    [anon_sym_or] = ACTIONS(5593),
    [anon_sym_and] = ACTIONS(5593),
    [anon_sym_bitor] = ACTIONS(5593),
    [anon_sym_xor] = ACTIONS(5593),
    [anon_sym_bitand] = ACTIONS(5593),
    [anon_sym_not_eq] = ACTIONS(5593),
    [anon_sym_DASH_DASH] = ACTIONS(5595),
    [anon_sym_PLUS_PLUS] = ACTIONS(5595),
    [anon_sym_DOT] = ACTIONS(5593),
    [anon_sym_DOT_STAR] = ACTIONS(5595),
    [anon_sym_DASH_GT] = ACTIONS(5595),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(5593),
  },
  [2368] = {
    [sym_identifier] = ACTIONS(5597),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5599),
    [anon_sym_COMMA] = ACTIONS(5599),
    [anon_sym_RPAREN] = ACTIONS(5599),
    [aux_sym_preproc_if_token2] = ACTIONS(5599),
    [aux_sym_preproc_else_token1] = ACTIONS(5599),
    [aux_sym_preproc_elif_token1] = ACTIONS(5597),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5599),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5599),
    [anon_sym_LPAREN2] = ACTIONS(5599),
    [anon_sym_DASH] = ACTIONS(5597),
    [anon_sym_PLUS] = ACTIONS(5597),
    [anon_sym_STAR] = ACTIONS(5597),
    [anon_sym_SLASH] = ACTIONS(5597),
    [anon_sym_PERCENT] = ACTIONS(5597),
    [anon_sym_PIPE_PIPE] = ACTIONS(5599),
    [anon_sym_AMP_AMP] = ACTIONS(5599),
    [anon_sym_PIPE] = ACTIONS(5597),
    [anon_sym_CARET] = ACTIONS(5597),
    [anon_sym_AMP] = ACTIONS(5597),
    [anon_sym_EQ_EQ] = ACTIONS(5599),
    [anon_sym_BANG_EQ] = ACTIONS(5599),
    [anon_sym_GT] = ACTIONS(5597),
    [anon_sym_GT_EQ] = ACTIONS(5599),
    [anon_sym_LT_EQ] = ACTIONS(5597),
    [anon_sym_LT] = ACTIONS(5597),
    [anon_sym_LT_LT] = ACTIONS(5597),
    [anon_sym_GT_GT] = ACTIONS(5597),
    [anon_sym_SEMI] = ACTIONS(5599),
    [anon_sym___attribute__] = ACTIONS(5597),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5599),
    [anon_sym_LBRACE] = ACTIONS(5599),
    [anon_sym_RBRACE] = ACTIONS(5599),
    [anon_sym_LBRACK] = ACTIONS(5597),
    [anon_sym_RBRACK] = ACTIONS(5599),
    [anon_sym_EQ] = ACTIONS(5597),
    [anon_sym_COLON] = ACTIONS(5599),
    [anon_sym_QMARK] = ACTIONS(5599),
    [anon_sym_STAR_EQ] = ACTIONS(5599),
    [anon_sym_SLASH_EQ] = ACTIONS(5599),
    [anon_sym_PERCENT_EQ] = ACTIONS(5599),
    [anon_sym_PLUS_EQ] = ACTIONS(5599),
    [anon_sym_DASH_EQ] = ACTIONS(5599),
    [anon_sym_LT_LT_EQ] = ACTIONS(5599),
    [anon_sym_GT_GT_EQ] = ACTIONS(5599),
    [anon_sym_AMP_EQ] = ACTIONS(5599),
    [anon_sym_CARET_EQ] = ACTIONS(5599),
    [anon_sym_PIPE_EQ] = ACTIONS(5599),
    [anon_sym_and_eq] = ACTIONS(5597),
    [anon_sym_or_eq] = ACTIONS(5597),
    [anon_sym_xor_eq] = ACTIONS(5597),
    [anon_sym_LT_EQ_GT] = ACTIONS(5599),
    [anon_sym_or] = ACTIONS(5597),
    [anon_sym_and] = ACTIONS(5597),
    [anon_sym_bitor] = ACTIONS(5597),
    [anon_sym_xor] = ACTIONS(5597),
    [anon_sym_bitand] = ACTIONS(5597),
    [anon_sym_not_eq] = ACTIONS(5597),
    [anon_sym_DASH_DASH] = ACTIONS(5599),
    [anon_sym_PLUS_PLUS] = ACTIONS(5599),
    [anon_sym_DOT] = ACTIONS(5597),
    [anon_sym_DOT_STAR] = ACTIONS(5599),
    [anon_sym_DASH_GT] = ACTIONS(5599),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(5597),
  },
  [2369] = {
    [sym_identifier] = ACTIONS(5097),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5099),
    [anon_sym_COMMA] = ACTIONS(5099),
    [anon_sym_RPAREN] = ACTIONS(5099),
    [aux_sym_preproc_if_token2] = ACTIONS(5099),
    [aux_sym_preproc_else_token1] = ACTIONS(5099),
    [aux_sym_preproc_elif_token1] = ACTIONS(5097),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5099),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5099),
    [anon_sym_LPAREN2] = ACTIONS(5099),
    [anon_sym_DASH] = ACTIONS(5097),
    [anon_sym_PLUS] = ACTIONS(5097),
    [anon_sym_STAR] = ACTIONS(5097),
    [anon_sym_SLASH] = ACTIONS(5097),
    [anon_sym_PERCENT] = ACTIONS(5097),
    [anon_sym_PIPE_PIPE] = ACTIONS(5099),
    [anon_sym_AMP_AMP] = ACTIONS(5099),
    [anon_sym_PIPE] = ACTIONS(5097),
    [anon_sym_CARET] = ACTIONS(5097),
    [anon_sym_AMP] = ACTIONS(5097),
    [anon_sym_EQ_EQ] = ACTIONS(5099),
    [anon_sym_BANG_EQ] = ACTIONS(5099),
    [anon_sym_GT] = ACTIONS(5097),
    [anon_sym_GT_EQ] = ACTIONS(5099),
    [anon_sym_LT_EQ] = ACTIONS(5097),
    [anon_sym_LT] = ACTIONS(5097),
    [anon_sym_LT_LT] = ACTIONS(5097),
    [anon_sym_GT_GT] = ACTIONS(5097),
    [anon_sym_SEMI] = ACTIONS(5099),
    [anon_sym___attribute__] = ACTIONS(5097),
    [anon_sym_LBRACE] = ACTIONS(5099),
    [anon_sym_RBRACE] = ACTIONS(5099),
    [anon_sym_LBRACK] = ACTIONS(5099),
    [anon_sym_RBRACK] = ACTIONS(5099),
    [anon_sym_EQ] = ACTIONS(5097),
    [anon_sym_COLON] = ACTIONS(5099),
    [anon_sym_QMARK] = ACTIONS(5099),
    [anon_sym_STAR_EQ] = ACTIONS(5099),
    [anon_sym_SLASH_EQ] = ACTIONS(5099),
    [anon_sym_PERCENT_EQ] = ACTIONS(5099),
    [anon_sym_PLUS_EQ] = ACTIONS(5099),
    [anon_sym_DASH_EQ] = ACTIONS(5099),
    [anon_sym_LT_LT_EQ] = ACTIONS(5099),
    [anon_sym_GT_GT_EQ] = ACTIONS(5099),
    [anon_sym_AMP_EQ] = ACTIONS(5099),
    [anon_sym_CARET_EQ] = ACTIONS(5099),
    [anon_sym_PIPE_EQ] = ACTIONS(5099),
    [anon_sym_and_eq] = ACTIONS(5097),
    [anon_sym_or_eq] = ACTIONS(5097),
    [anon_sym_xor_eq] = ACTIONS(5097),
    [anon_sym_LT_EQ_GT] = ACTIONS(5099),
    [anon_sym_or] = ACTIONS(5097),
    [anon_sym_and] = ACTIONS(5097),
    [anon_sym_bitor] = ACTIONS(5097),
    [anon_sym_xor] = ACTIONS(5097),
    [anon_sym_bitand] = ACTIONS(5097),
    [anon_sym_not_eq] = ACTIONS(5097),
    [anon_sym_DASH_DASH] = ACTIONS(5099),
    [anon_sym_PLUS_PLUS] = ACTIONS(5099),
    [anon_sym_DOT] = ACTIONS(5097),
    [anon_sym_DOT_STAR] = ACTIONS(5099),
    [anon_sym_DASH_GT] = ACTIONS(5099),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5097),
    [anon_sym_decltype] = ACTIONS(5097),
  },
  [2370] = {
    [sym_identifier] = ACTIONS(5062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5064),
    [anon_sym_COMMA] = ACTIONS(5064),
    [anon_sym_RPAREN] = ACTIONS(5064),
    [aux_sym_preproc_if_token2] = ACTIONS(5064),
    [aux_sym_preproc_else_token1] = ACTIONS(5064),
    [aux_sym_preproc_elif_token1] = ACTIONS(5062),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5064),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5064),
    [anon_sym_LPAREN2] = ACTIONS(5064),
    [anon_sym_DASH] = ACTIONS(5062),
    [anon_sym_PLUS] = ACTIONS(5062),
    [anon_sym_STAR] = ACTIONS(5062),
    [anon_sym_SLASH] = ACTIONS(5062),
    [anon_sym_PERCENT] = ACTIONS(5062),
    [anon_sym_PIPE_PIPE] = ACTIONS(5064),
    [anon_sym_AMP_AMP] = ACTIONS(5064),
    [anon_sym_PIPE] = ACTIONS(5062),
    [anon_sym_CARET] = ACTIONS(5062),
    [anon_sym_AMP] = ACTIONS(5062),
    [anon_sym_EQ_EQ] = ACTIONS(5064),
    [anon_sym_BANG_EQ] = ACTIONS(5064),
    [anon_sym_GT] = ACTIONS(5062),
    [anon_sym_GT_EQ] = ACTIONS(5064),
    [anon_sym_LT_EQ] = ACTIONS(5062),
    [anon_sym_LT] = ACTIONS(5062),
    [anon_sym_LT_LT] = ACTIONS(5062),
    [anon_sym_GT_GT] = ACTIONS(5062),
    [anon_sym_SEMI] = ACTIONS(5064),
    [anon_sym___attribute__] = ACTIONS(5062),
    [anon_sym_LBRACE] = ACTIONS(5064),
    [anon_sym_RBRACE] = ACTIONS(5064),
    [anon_sym_LBRACK] = ACTIONS(5064),
    [anon_sym_RBRACK] = ACTIONS(5064),
    [anon_sym_EQ] = ACTIONS(5062),
    [anon_sym_COLON] = ACTIONS(5064),
    [anon_sym_QMARK] = ACTIONS(5064),
    [anon_sym_STAR_EQ] = ACTIONS(5064),
    [anon_sym_SLASH_EQ] = ACTIONS(5064),
    [anon_sym_PERCENT_EQ] = ACTIONS(5064),
    [anon_sym_PLUS_EQ] = ACTIONS(5064),
    [anon_sym_DASH_EQ] = ACTIONS(5064),
    [anon_sym_LT_LT_EQ] = ACTIONS(5064),
    [anon_sym_GT_GT_EQ] = ACTIONS(5064),
    [anon_sym_AMP_EQ] = ACTIONS(5064),
    [anon_sym_CARET_EQ] = ACTIONS(5064),
    [anon_sym_PIPE_EQ] = ACTIONS(5064),
    [anon_sym_and_eq] = ACTIONS(5062),
    [anon_sym_or_eq] = ACTIONS(5062),
    [anon_sym_xor_eq] = ACTIONS(5062),
    [anon_sym_LT_EQ_GT] = ACTIONS(5064),
    [anon_sym_or] = ACTIONS(5062),
    [anon_sym_and] = ACTIONS(5062),
    [anon_sym_bitor] = ACTIONS(5062),
    [anon_sym_xor] = ACTIONS(5062),
    [anon_sym_bitand] = ACTIONS(5062),
    [anon_sym_not_eq] = ACTIONS(5062),
    [anon_sym_DASH_DASH] = ACTIONS(5064),
    [anon_sym_PLUS_PLUS] = ACTIONS(5064),
    [anon_sym_DOT] = ACTIONS(5062),
    [anon_sym_DOT_STAR] = ACTIONS(5064),
    [anon_sym_DASH_GT] = ACTIONS(5064),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5062),
    [anon_sym_decltype] = ACTIONS(5062),
  },
  [2371] = {
    [sym_identifier] = ACTIONS(5066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5068),
    [anon_sym_COMMA] = ACTIONS(5068),
    [anon_sym_RPAREN] = ACTIONS(5068),
    [aux_sym_preproc_if_token2] = ACTIONS(5068),
    [aux_sym_preproc_else_token1] = ACTIONS(5068),
    [aux_sym_preproc_elif_token1] = ACTIONS(5066),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5068),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5068),
    [anon_sym_LPAREN2] = ACTIONS(5068),
    [anon_sym_DASH] = ACTIONS(5066),
    [anon_sym_PLUS] = ACTIONS(5066),
    [anon_sym_STAR] = ACTIONS(5066),
    [anon_sym_SLASH] = ACTIONS(5066),
    [anon_sym_PERCENT] = ACTIONS(5066),
    [anon_sym_PIPE_PIPE] = ACTIONS(5068),
    [anon_sym_AMP_AMP] = ACTIONS(5068),
    [anon_sym_PIPE] = ACTIONS(5066),
    [anon_sym_CARET] = ACTIONS(5066),
    [anon_sym_AMP] = ACTIONS(5066),
    [anon_sym_EQ_EQ] = ACTIONS(5068),
    [anon_sym_BANG_EQ] = ACTIONS(5068),
    [anon_sym_GT] = ACTIONS(5066),
    [anon_sym_GT_EQ] = ACTIONS(5068),
    [anon_sym_LT_EQ] = ACTIONS(5066),
    [anon_sym_LT] = ACTIONS(5066),
    [anon_sym_LT_LT] = ACTIONS(5066),
    [anon_sym_GT_GT] = ACTIONS(5066),
    [anon_sym_SEMI] = ACTIONS(5068),
    [anon_sym___attribute__] = ACTIONS(5066),
    [anon_sym_LBRACE] = ACTIONS(5068),
    [anon_sym_RBRACE] = ACTIONS(5068),
    [anon_sym_LBRACK] = ACTIONS(5068),
    [anon_sym_RBRACK] = ACTIONS(5068),
    [anon_sym_EQ] = ACTIONS(5066),
    [anon_sym_COLON] = ACTIONS(5068),
    [anon_sym_QMARK] = ACTIONS(5068),
    [anon_sym_STAR_EQ] = ACTIONS(5068),
    [anon_sym_SLASH_EQ] = ACTIONS(5068),
    [anon_sym_PERCENT_EQ] = ACTIONS(5068),
    [anon_sym_PLUS_EQ] = ACTIONS(5068),
    [anon_sym_DASH_EQ] = ACTIONS(5068),
    [anon_sym_LT_LT_EQ] = ACTIONS(5068),
    [anon_sym_GT_GT_EQ] = ACTIONS(5068),
    [anon_sym_AMP_EQ] = ACTIONS(5068),
    [anon_sym_CARET_EQ] = ACTIONS(5068),
    [anon_sym_PIPE_EQ] = ACTIONS(5068),
    [anon_sym_and_eq] = ACTIONS(5066),
    [anon_sym_or_eq] = ACTIONS(5066),
    [anon_sym_xor_eq] = ACTIONS(5066),
    [anon_sym_LT_EQ_GT] = ACTIONS(5068),
    [anon_sym_or] = ACTIONS(5066),
    [anon_sym_and] = ACTIONS(5066),
    [anon_sym_bitor] = ACTIONS(5066),
    [anon_sym_xor] = ACTIONS(5066),
    [anon_sym_bitand] = ACTIONS(5066),
    [anon_sym_not_eq] = ACTIONS(5066),
    [anon_sym_DASH_DASH] = ACTIONS(5068),
    [anon_sym_PLUS_PLUS] = ACTIONS(5068),
    [anon_sym_DOT] = ACTIONS(5066),
    [anon_sym_DOT_STAR] = ACTIONS(5068),
    [anon_sym_DASH_GT] = ACTIONS(5068),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5066),
    [anon_sym_decltype] = ACTIONS(5066),
  },
  [2372] = {
    [sym_identifier] = ACTIONS(5601),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5603),
    [anon_sym_COMMA] = ACTIONS(5603),
    [anon_sym_RPAREN] = ACTIONS(5603),
    [aux_sym_preproc_if_token2] = ACTIONS(5603),
    [aux_sym_preproc_else_token1] = ACTIONS(5603),
    [aux_sym_preproc_elif_token1] = ACTIONS(5601),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5603),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5603),
    [anon_sym_LPAREN2] = ACTIONS(5603),
    [anon_sym_DASH] = ACTIONS(5601),
    [anon_sym_PLUS] = ACTIONS(5601),
    [anon_sym_STAR] = ACTIONS(5601),
    [anon_sym_SLASH] = ACTIONS(5601),
    [anon_sym_PERCENT] = ACTIONS(5601),
    [anon_sym_PIPE_PIPE] = ACTIONS(5603),
    [anon_sym_AMP_AMP] = ACTIONS(5603),
    [anon_sym_PIPE] = ACTIONS(5601),
    [anon_sym_CARET] = ACTIONS(5601),
    [anon_sym_AMP] = ACTIONS(5601),
    [anon_sym_EQ_EQ] = ACTIONS(5603),
    [anon_sym_BANG_EQ] = ACTIONS(5603),
    [anon_sym_GT] = ACTIONS(5601),
    [anon_sym_GT_EQ] = ACTIONS(5603),
    [anon_sym_LT_EQ] = ACTIONS(5601),
    [anon_sym_LT] = ACTIONS(5601),
    [anon_sym_LT_LT] = ACTIONS(5601),
    [anon_sym_GT_GT] = ACTIONS(5601),
    [anon_sym_SEMI] = ACTIONS(5603),
    [anon_sym___attribute__] = ACTIONS(5601),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5603),
    [anon_sym_LBRACE] = ACTIONS(5603),
    [anon_sym_RBRACE] = ACTIONS(5603),
    [anon_sym_LBRACK] = ACTIONS(5601),
    [anon_sym_RBRACK] = ACTIONS(5603),
    [anon_sym_EQ] = ACTIONS(5601),
    [anon_sym_COLON] = ACTIONS(5603),
    [anon_sym_QMARK] = ACTIONS(5603),
    [anon_sym_STAR_EQ] = ACTIONS(5603),
    [anon_sym_SLASH_EQ] = ACTIONS(5603),
    [anon_sym_PERCENT_EQ] = ACTIONS(5603),
    [anon_sym_PLUS_EQ] = ACTIONS(5603),
    [anon_sym_DASH_EQ] = ACTIONS(5603),
    [anon_sym_LT_LT_EQ] = ACTIONS(5603),
    [anon_sym_GT_GT_EQ] = ACTIONS(5603),
    [anon_sym_AMP_EQ] = ACTIONS(5603),
    [anon_sym_CARET_EQ] = ACTIONS(5603),
    [anon_sym_PIPE_EQ] = ACTIONS(5603),
    [anon_sym_and_eq] = ACTIONS(5601),
    [anon_sym_or_eq] = ACTIONS(5601),
    [anon_sym_xor_eq] = ACTIONS(5601),
    [anon_sym_LT_EQ_GT] = ACTIONS(5603),
    [anon_sym_or] = ACTIONS(5601),
    [anon_sym_and] = ACTIONS(5601),
    [anon_sym_bitor] = ACTIONS(5601),
    [anon_sym_xor] = ACTIONS(5601),
    [anon_sym_bitand] = ACTIONS(5601),
    [anon_sym_not_eq] = ACTIONS(5601),
    [anon_sym_DASH_DASH] = ACTIONS(5603),
    [anon_sym_PLUS_PLUS] = ACTIONS(5603),
    [anon_sym_DOT] = ACTIONS(5601),
    [anon_sym_DOT_STAR] = ACTIONS(5603),
    [anon_sym_DASH_GT] = ACTIONS(5603),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(5601),
  },
  [2373] = {
    [sym_identifier] = ACTIONS(5046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5048),
    [anon_sym_COMMA] = ACTIONS(5048),
    [anon_sym_RPAREN] = ACTIONS(5048),
    [aux_sym_preproc_if_token2] = ACTIONS(5048),
    [aux_sym_preproc_else_token1] = ACTIONS(5048),
    [aux_sym_preproc_elif_token1] = ACTIONS(5046),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5048),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5048),
    [anon_sym_LPAREN2] = ACTIONS(5048),
    [anon_sym_DASH] = ACTIONS(5046),
    [anon_sym_PLUS] = ACTIONS(5046),
    [anon_sym_STAR] = ACTIONS(5046),
    [anon_sym_SLASH] = ACTIONS(5046),
    [anon_sym_PERCENT] = ACTIONS(5046),
    [anon_sym_PIPE_PIPE] = ACTIONS(5048),
    [anon_sym_AMP_AMP] = ACTIONS(5048),
    [anon_sym_PIPE] = ACTIONS(5046),
    [anon_sym_CARET] = ACTIONS(5046),
    [anon_sym_AMP] = ACTIONS(5046),
    [anon_sym_EQ_EQ] = ACTIONS(5048),
    [anon_sym_BANG_EQ] = ACTIONS(5048),
    [anon_sym_GT] = ACTIONS(5046),
    [anon_sym_GT_EQ] = ACTIONS(5048),
    [anon_sym_LT_EQ] = ACTIONS(5046),
    [anon_sym_LT] = ACTIONS(5046),
    [anon_sym_LT_LT] = ACTIONS(5046),
    [anon_sym_GT_GT] = ACTIONS(5046),
    [anon_sym_SEMI] = ACTIONS(5048),
    [anon_sym___attribute__] = ACTIONS(5046),
    [anon_sym_LBRACE] = ACTIONS(5048),
    [anon_sym_RBRACE] = ACTIONS(5048),
    [anon_sym_LBRACK] = ACTIONS(5048),
    [anon_sym_RBRACK] = ACTIONS(5048),
    [anon_sym_EQ] = ACTIONS(5046),
    [anon_sym_COLON] = ACTIONS(5048),
    [anon_sym_QMARK] = ACTIONS(5048),
    [anon_sym_STAR_EQ] = ACTIONS(5048),
    [anon_sym_SLASH_EQ] = ACTIONS(5048),
    [anon_sym_PERCENT_EQ] = ACTIONS(5048),
    [anon_sym_PLUS_EQ] = ACTIONS(5048),
    [anon_sym_DASH_EQ] = ACTIONS(5048),
    [anon_sym_LT_LT_EQ] = ACTIONS(5048),
    [anon_sym_GT_GT_EQ] = ACTIONS(5048),
    [anon_sym_AMP_EQ] = ACTIONS(5048),
    [anon_sym_CARET_EQ] = ACTIONS(5048),
    [anon_sym_PIPE_EQ] = ACTIONS(5048),
    [anon_sym_and_eq] = ACTIONS(5046),
    [anon_sym_or_eq] = ACTIONS(5046),
    [anon_sym_xor_eq] = ACTIONS(5046),
    [anon_sym_LT_EQ_GT] = ACTIONS(5048),
    [anon_sym_or] = ACTIONS(5046),
    [anon_sym_and] = ACTIONS(5046),
    [anon_sym_bitor] = ACTIONS(5046),
    [anon_sym_xor] = ACTIONS(5046),
    [anon_sym_bitand] = ACTIONS(5046),
    [anon_sym_not_eq] = ACTIONS(5046),
    [anon_sym_DASH_DASH] = ACTIONS(5048),
    [anon_sym_PLUS_PLUS] = ACTIONS(5048),
    [anon_sym_DOT] = ACTIONS(5046),
    [anon_sym_DOT_STAR] = ACTIONS(5048),
    [anon_sym_DASH_GT] = ACTIONS(5048),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5046),
    [anon_sym_decltype] = ACTIONS(5046),
  },
  [2374] = {
    [sym_attribute_declaration] = STATE(2328),
    [aux_sym_attributed_declarator_repeat1] = STATE(2328),
    [sym_identifier] = ACTIONS(5605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5607),
    [anon_sym_COMMA] = ACTIONS(5607),
    [anon_sym_RPAREN] = ACTIONS(5607),
    [aux_sym_preproc_if_token2] = ACTIONS(5607),
    [aux_sym_preproc_else_token1] = ACTIONS(5607),
    [aux_sym_preproc_elif_token1] = ACTIONS(5605),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5607),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5607),
    [anon_sym_LPAREN2] = ACTIONS(5607),
    [anon_sym_DASH] = ACTIONS(5605),
    [anon_sym_PLUS] = ACTIONS(5605),
    [anon_sym_STAR] = ACTIONS(5605),
    [anon_sym_SLASH] = ACTIONS(5605),
    [anon_sym_PERCENT] = ACTIONS(5605),
    [anon_sym_PIPE_PIPE] = ACTIONS(5607),
    [anon_sym_AMP_AMP] = ACTIONS(5607),
    [anon_sym_PIPE] = ACTIONS(5605),
    [anon_sym_CARET] = ACTIONS(5605),
    [anon_sym_AMP] = ACTIONS(5605),
    [anon_sym_EQ_EQ] = ACTIONS(5607),
    [anon_sym_BANG_EQ] = ACTIONS(5607),
    [anon_sym_GT] = ACTIONS(5605),
    [anon_sym_GT_EQ] = ACTIONS(5607),
    [anon_sym_LT_EQ] = ACTIONS(5605),
    [anon_sym_LT] = ACTIONS(5605),
    [anon_sym_LT_LT] = ACTIONS(5605),
    [anon_sym_GT_GT] = ACTIONS(5605),
    [anon_sym_SEMI] = ACTIONS(5607),
    [anon_sym___attribute__] = ACTIONS(5605),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5396),
    [anon_sym_RBRACE] = ACTIONS(5607),
    [anon_sym_LBRACK] = ACTIONS(5605),
    [anon_sym_RBRACK] = ACTIONS(5607),
    [anon_sym_EQ] = ACTIONS(5605),
    [anon_sym_COLON] = ACTIONS(5607),
    [anon_sym_QMARK] = ACTIONS(5607),
    [anon_sym_STAR_EQ] = ACTIONS(5607),
    [anon_sym_SLASH_EQ] = ACTIONS(5607),
    [anon_sym_PERCENT_EQ] = ACTIONS(5607),
    [anon_sym_PLUS_EQ] = ACTIONS(5607),
    [anon_sym_DASH_EQ] = ACTIONS(5607),
    [anon_sym_LT_LT_EQ] = ACTIONS(5607),
    [anon_sym_GT_GT_EQ] = ACTIONS(5607),
    [anon_sym_AMP_EQ] = ACTIONS(5607),
    [anon_sym_CARET_EQ] = ACTIONS(5607),
    [anon_sym_PIPE_EQ] = ACTIONS(5607),
    [anon_sym_and_eq] = ACTIONS(5605),
    [anon_sym_or_eq] = ACTIONS(5605),
    [anon_sym_xor_eq] = ACTIONS(5605),
    [anon_sym_LT_EQ_GT] = ACTIONS(5607),
    [anon_sym_or] = ACTIONS(5605),
    [anon_sym_and] = ACTIONS(5605),
    [anon_sym_bitor] = ACTIONS(5605),
    [anon_sym_xor] = ACTIONS(5605),
    [anon_sym_bitand] = ACTIONS(5605),
    [anon_sym_not_eq] = ACTIONS(5605),
    [anon_sym_DASH_DASH] = ACTIONS(5607),
    [anon_sym_PLUS_PLUS] = ACTIONS(5607),
    [anon_sym_DOT] = ACTIONS(5605),
    [anon_sym_DOT_STAR] = ACTIONS(5607),
    [anon_sym_DASH_GT] = ACTIONS(5607),
    [sym_comment] = ACTIONS(3),
  },
  [2375] = {
    [sym_argument_list] = STATE(2505),
    [sym_initializer_list] = STATE(2505),
    [sym_identifier] = ACTIONS(5609),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5611),
    [anon_sym_COMMA] = ACTIONS(5611),
    [anon_sym_RPAREN] = ACTIONS(5611),
    [aux_sym_preproc_if_token2] = ACTIONS(5611),
    [aux_sym_preproc_else_token1] = ACTIONS(5611),
    [aux_sym_preproc_elif_token1] = ACTIONS(5609),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5611),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5611),
    [anon_sym_LPAREN2] = ACTIONS(5212),
    [anon_sym_DASH] = ACTIONS(5609),
    [anon_sym_PLUS] = ACTIONS(5609),
    [anon_sym_STAR] = ACTIONS(5609),
    [anon_sym_SLASH] = ACTIONS(5609),
    [anon_sym_PERCENT] = ACTIONS(5609),
    [anon_sym_PIPE_PIPE] = ACTIONS(5611),
    [anon_sym_AMP_AMP] = ACTIONS(5611),
    [anon_sym_PIPE] = ACTIONS(5609),
    [anon_sym_CARET] = ACTIONS(5609),
    [anon_sym_AMP] = ACTIONS(5609),
    [anon_sym_EQ_EQ] = ACTIONS(5611),
    [anon_sym_BANG_EQ] = ACTIONS(5611),
    [anon_sym_GT] = ACTIONS(5609),
    [anon_sym_GT_EQ] = ACTIONS(5611),
    [anon_sym_LT_EQ] = ACTIONS(5609),
    [anon_sym_LT] = ACTIONS(5609),
    [anon_sym_LT_LT] = ACTIONS(5609),
    [anon_sym_GT_GT] = ACTIONS(5609),
    [anon_sym_SEMI] = ACTIONS(5611),
    [anon_sym___attribute__] = ACTIONS(5609),
    [anon_sym_LBRACE] = ACTIONS(1893),
    [anon_sym_RBRACE] = ACTIONS(5611),
    [anon_sym_LBRACK] = ACTIONS(5611),
    [anon_sym_RBRACK] = ACTIONS(5611),
    [anon_sym_EQ] = ACTIONS(5609),
    [anon_sym_COLON] = ACTIONS(5611),
    [anon_sym_QMARK] = ACTIONS(5611),
    [anon_sym_STAR_EQ] = ACTIONS(5611),
    [anon_sym_SLASH_EQ] = ACTIONS(5611),
    [anon_sym_PERCENT_EQ] = ACTIONS(5611),
    [anon_sym_PLUS_EQ] = ACTIONS(5611),
    [anon_sym_DASH_EQ] = ACTIONS(5611),
    [anon_sym_LT_LT_EQ] = ACTIONS(5611),
    [anon_sym_GT_GT_EQ] = ACTIONS(5611),
    [anon_sym_AMP_EQ] = ACTIONS(5611),
    [anon_sym_CARET_EQ] = ACTIONS(5611),
    [anon_sym_PIPE_EQ] = ACTIONS(5611),
    [anon_sym_and_eq] = ACTIONS(5609),
    [anon_sym_or_eq] = ACTIONS(5609),
    [anon_sym_xor_eq] = ACTIONS(5609),
    [anon_sym_LT_EQ_GT] = ACTIONS(5611),
    [anon_sym_or] = ACTIONS(5609),
    [anon_sym_and] = ACTIONS(5609),
    [anon_sym_bitor] = ACTIONS(5609),
    [anon_sym_xor] = ACTIONS(5609),
    [anon_sym_bitand] = ACTIONS(5609),
    [anon_sym_not_eq] = ACTIONS(5609),
    [anon_sym_DASH_DASH] = ACTIONS(5611),
    [anon_sym_PLUS_PLUS] = ACTIONS(5611),
    [anon_sym_DOT] = ACTIONS(5609),
    [anon_sym_DOT_STAR] = ACTIONS(5611),
    [anon_sym_DASH_GT] = ACTIONS(5611),
    [sym_comment] = ACTIONS(3),
  },
  [2376] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2385),
    [sym_identifier] = ACTIONS(5105),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5107),
    [anon_sym_COMMA] = ACTIONS(5107),
    [aux_sym_preproc_if_token2] = ACTIONS(5107),
    [aux_sym_preproc_else_token1] = ACTIONS(5107),
    [aux_sym_preproc_elif_token1] = ACTIONS(5105),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5107),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5107),
    [anon_sym_LPAREN2] = ACTIONS(5107),
    [anon_sym_DASH] = ACTIONS(5105),
    [anon_sym_PLUS] = ACTIONS(5105),
    [anon_sym_STAR] = ACTIONS(5105),
    [anon_sym_SLASH] = ACTIONS(5105),
    [anon_sym_PERCENT] = ACTIONS(5105),
    [anon_sym_PIPE_PIPE] = ACTIONS(5107),
    [anon_sym_AMP_AMP] = ACTIONS(5107),
    [anon_sym_PIPE] = ACTIONS(5105),
    [anon_sym_CARET] = ACTIONS(5105),
    [anon_sym_AMP] = ACTIONS(5105),
    [anon_sym_EQ_EQ] = ACTIONS(5107),
    [anon_sym_BANG_EQ] = ACTIONS(5107),
    [anon_sym_GT] = ACTIONS(5105),
    [anon_sym_GT_EQ] = ACTIONS(5107),
    [anon_sym_LT_EQ] = ACTIONS(5105),
    [anon_sym_LT] = ACTIONS(5105),
    [anon_sym_LT_LT] = ACTIONS(5105),
    [anon_sym_GT_GT] = ACTIONS(5105),
    [anon_sym___attribute__] = ACTIONS(5105),
    [anon_sym_LBRACE] = ACTIONS(5107),
    [anon_sym_signed] = ACTIONS(5613),
    [anon_sym_unsigned] = ACTIONS(5613),
    [anon_sym_long] = ACTIONS(5613),
    [anon_sym_short] = ACTIONS(5613),
    [anon_sym_LBRACK] = ACTIONS(5107),
    [anon_sym_EQ] = ACTIONS(5105),
    [anon_sym_QMARK] = ACTIONS(5107),
    [anon_sym_STAR_EQ] = ACTIONS(5107),
    [anon_sym_SLASH_EQ] = ACTIONS(5107),
    [anon_sym_PERCENT_EQ] = ACTIONS(5107),
    [anon_sym_PLUS_EQ] = ACTIONS(5107),
    [anon_sym_DASH_EQ] = ACTIONS(5107),
    [anon_sym_LT_LT_EQ] = ACTIONS(5107),
    [anon_sym_GT_GT_EQ] = ACTIONS(5107),
    [anon_sym_AMP_EQ] = ACTIONS(5107),
    [anon_sym_CARET_EQ] = ACTIONS(5107),
    [anon_sym_PIPE_EQ] = ACTIONS(5107),
    [anon_sym_and_eq] = ACTIONS(5105),
    [anon_sym_or_eq] = ACTIONS(5105),
    [anon_sym_xor_eq] = ACTIONS(5105),
    [anon_sym_LT_EQ_GT] = ACTIONS(5107),
    [anon_sym_or] = ACTIONS(5105),
    [anon_sym_and] = ACTIONS(5105),
    [anon_sym_bitor] = ACTIONS(5105),
    [anon_sym_xor] = ACTIONS(5105),
    [anon_sym_bitand] = ACTIONS(5105),
    [anon_sym_not_eq] = ACTIONS(5105),
    [anon_sym_DASH_DASH] = ACTIONS(5107),
    [anon_sym_PLUS_PLUS] = ACTIONS(5107),
    [anon_sym_DOT] = ACTIONS(5105),
    [anon_sym_DOT_STAR] = ACTIONS(5107),
    [anon_sym_DASH_GT] = ACTIONS(5107),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5105),
    [anon_sym_decltype] = ACTIONS(5105),
  },
  [2377] = {
    [sym_primitive_type] = STATE(2660),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2426),
    [sym_identifier] = ACTIONS(5615),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4934),
    [anon_sym_COMMA] = ACTIONS(4934),
    [anon_sym_LPAREN2] = ACTIONS(4934),
    [anon_sym_DASH] = ACTIONS(4936),
    [anon_sym_PLUS] = ACTIONS(4936),
    [anon_sym_STAR] = ACTIONS(4936),
    [anon_sym_SLASH] = ACTIONS(4936),
    [anon_sym_PERCENT] = ACTIONS(4936),
    [anon_sym_PIPE_PIPE] = ACTIONS(4934),
    [anon_sym_AMP_AMP] = ACTIONS(4934),
    [anon_sym_PIPE] = ACTIONS(4936),
    [anon_sym_CARET] = ACTIONS(4936),
    [anon_sym_AMP] = ACTIONS(4936),
    [anon_sym_EQ_EQ] = ACTIONS(4934),
    [anon_sym_BANG_EQ] = ACTIONS(4934),
    [anon_sym_GT] = ACTIONS(4936),
    [anon_sym_GT_EQ] = ACTIONS(4936),
    [anon_sym_LT_EQ] = ACTIONS(4936),
    [anon_sym_LT] = ACTIONS(4936),
    [anon_sym_LT_LT] = ACTIONS(4936),
    [anon_sym_GT_GT] = ACTIONS(4936),
    [anon_sym___attribute__] = ACTIONS(4936),
    [anon_sym_LBRACE] = ACTIONS(4934),
    [anon_sym_signed] = ACTIONS(5617),
    [anon_sym_unsigned] = ACTIONS(5617),
    [anon_sym_long] = ACTIONS(5617),
    [anon_sym_short] = ACTIONS(5617),
    [anon_sym_LBRACK] = ACTIONS(4934),
    [anon_sym_EQ] = ACTIONS(4936),
    [aux_sym_primitive_type_token1] = ACTIONS(5619),
    [anon_sym_byte] = ACTIONS(5619),
    [anon_sym_word] = ACTIONS(5619),
    [anon_sym_QMARK] = ACTIONS(4934),
    [anon_sym_STAR_EQ] = ACTIONS(4934),
    [anon_sym_SLASH_EQ] = ACTIONS(4934),
    [anon_sym_PERCENT_EQ] = ACTIONS(4934),
    [anon_sym_PLUS_EQ] = ACTIONS(4934),
    [anon_sym_DASH_EQ] = ACTIONS(4934),
    [anon_sym_LT_LT_EQ] = ACTIONS(4934),
    [anon_sym_GT_GT_EQ] = ACTIONS(4936),
    [anon_sym_AMP_EQ] = ACTIONS(4934),
    [anon_sym_CARET_EQ] = ACTIONS(4934),
    [anon_sym_PIPE_EQ] = ACTIONS(4934),
    [anon_sym_and_eq] = ACTIONS(4936),
    [anon_sym_or_eq] = ACTIONS(4936),
    [anon_sym_xor_eq] = ACTIONS(4936),
    [anon_sym_LT_EQ_GT] = ACTIONS(4934),
    [anon_sym_or] = ACTIONS(4936),
    [anon_sym_and] = ACTIONS(4936),
    [anon_sym_bitor] = ACTIONS(4936),
    [anon_sym_xor] = ACTIONS(4936),
    [anon_sym_bitand] = ACTIONS(4936),
    [anon_sym_not_eq] = ACTIONS(4936),
    [anon_sym_DASH_DASH] = ACTIONS(4934),
    [anon_sym_PLUS_PLUS] = ACTIONS(4934),
    [anon_sym_DOT] = ACTIONS(4936),
    [anon_sym_DOT_STAR] = ACTIONS(4934),
    [anon_sym_DASH_GT] = ACTIONS(4934),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4936),
    [anon_sym_decltype] = ACTIONS(4936),
    [anon_sym_GT2] = ACTIONS(4934),
  },
  [2378] = {
    [sym_identifier] = ACTIONS(5121),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5123),
    [anon_sym_COMMA] = ACTIONS(5123),
    [anon_sym_RPAREN] = ACTIONS(5123),
    [aux_sym_preproc_if_token2] = ACTIONS(5123),
    [aux_sym_preproc_else_token1] = ACTIONS(5123),
    [aux_sym_preproc_elif_token1] = ACTIONS(5121),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5123),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5123),
    [anon_sym_LPAREN2] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5121),
    [anon_sym_PLUS] = ACTIONS(5121),
    [anon_sym_STAR] = ACTIONS(5121),
    [anon_sym_SLASH] = ACTIONS(5121),
    [anon_sym_PERCENT] = ACTIONS(5121),
    [anon_sym_PIPE_PIPE] = ACTIONS(5123),
    [anon_sym_AMP_AMP] = ACTIONS(5123),
    [anon_sym_PIPE] = ACTIONS(5121),
    [anon_sym_CARET] = ACTIONS(5121),
    [anon_sym_AMP] = ACTIONS(5121),
    [anon_sym_EQ_EQ] = ACTIONS(5123),
    [anon_sym_BANG_EQ] = ACTIONS(5123),
    [anon_sym_GT] = ACTIONS(5121),
    [anon_sym_GT_EQ] = ACTIONS(5123),
    [anon_sym_LT_EQ] = ACTIONS(5121),
    [anon_sym_LT] = ACTIONS(5121),
    [anon_sym_LT_LT] = ACTIONS(5121),
    [anon_sym_GT_GT] = ACTIONS(5121),
    [anon_sym_SEMI] = ACTIONS(5123),
    [anon_sym___attribute__] = ACTIONS(5121),
    [anon_sym_LBRACE] = ACTIONS(5123),
    [anon_sym_RBRACE] = ACTIONS(5123),
    [anon_sym_LBRACK] = ACTIONS(5123),
    [anon_sym_RBRACK] = ACTIONS(5123),
    [anon_sym_EQ] = ACTIONS(5121),
    [anon_sym_COLON] = ACTIONS(5123),
    [anon_sym_QMARK] = ACTIONS(5123),
    [anon_sym_STAR_EQ] = ACTIONS(5123),
    [anon_sym_SLASH_EQ] = ACTIONS(5123),
    [anon_sym_PERCENT_EQ] = ACTIONS(5123),
    [anon_sym_PLUS_EQ] = ACTIONS(5123),
    [anon_sym_DASH_EQ] = ACTIONS(5123),
    [anon_sym_LT_LT_EQ] = ACTIONS(5123),
    [anon_sym_GT_GT_EQ] = ACTIONS(5123),
    [anon_sym_AMP_EQ] = ACTIONS(5123),
    [anon_sym_CARET_EQ] = ACTIONS(5123),
    [anon_sym_PIPE_EQ] = ACTIONS(5123),
    [anon_sym_and_eq] = ACTIONS(5121),
    [anon_sym_or_eq] = ACTIONS(5121),
    [anon_sym_xor_eq] = ACTIONS(5121),
    [anon_sym_LT_EQ_GT] = ACTIONS(5123),
    [anon_sym_or] = ACTIONS(5121),
    [anon_sym_and] = ACTIONS(5121),
    [anon_sym_bitor] = ACTIONS(5121),
    [anon_sym_xor] = ACTIONS(5121),
    [anon_sym_bitand] = ACTIONS(5121),
    [anon_sym_not_eq] = ACTIONS(5121),
    [anon_sym_DASH_DASH] = ACTIONS(5123),
    [anon_sym_PLUS_PLUS] = ACTIONS(5123),
    [anon_sym_DOT] = ACTIONS(5121),
    [anon_sym_DOT_STAR] = ACTIONS(5123),
    [anon_sym_DASH_GT] = ACTIONS(5123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5121),
    [anon_sym_decltype] = ACTIONS(5121),
  },
  [2379] = {
    [sym_identifier] = ACTIONS(5135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5137),
    [anon_sym_COMMA] = ACTIONS(5137),
    [anon_sym_RPAREN] = ACTIONS(5137),
    [aux_sym_preproc_if_token2] = ACTIONS(5137),
    [aux_sym_preproc_else_token1] = ACTIONS(5137),
    [aux_sym_preproc_elif_token1] = ACTIONS(5135),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5137),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5137),
    [anon_sym_LPAREN2] = ACTIONS(5137),
    [anon_sym_DASH] = ACTIONS(5135),
    [anon_sym_PLUS] = ACTIONS(5135),
    [anon_sym_STAR] = ACTIONS(5135),
    [anon_sym_SLASH] = ACTIONS(5135),
    [anon_sym_PERCENT] = ACTIONS(5135),
    [anon_sym_PIPE_PIPE] = ACTIONS(5137),
    [anon_sym_AMP_AMP] = ACTIONS(5137),
    [anon_sym_PIPE] = ACTIONS(5135),
    [anon_sym_CARET] = ACTIONS(5135),
    [anon_sym_AMP] = ACTIONS(5135),
    [anon_sym_EQ_EQ] = ACTIONS(5137),
    [anon_sym_BANG_EQ] = ACTIONS(5137),
    [anon_sym_GT] = ACTIONS(5135),
    [anon_sym_GT_EQ] = ACTIONS(5137),
    [anon_sym_LT_EQ] = ACTIONS(5135),
    [anon_sym_LT] = ACTIONS(5135),
    [anon_sym_LT_LT] = ACTIONS(5135),
    [anon_sym_GT_GT] = ACTIONS(5135),
    [anon_sym_SEMI] = ACTIONS(5137),
    [anon_sym___attribute__] = ACTIONS(5135),
    [anon_sym_LBRACE] = ACTIONS(5137),
    [anon_sym_RBRACE] = ACTIONS(5137),
    [anon_sym_LBRACK] = ACTIONS(5137),
    [anon_sym_RBRACK] = ACTIONS(5137),
    [anon_sym_EQ] = ACTIONS(5135),
    [anon_sym_COLON] = ACTIONS(5137),
    [anon_sym_QMARK] = ACTIONS(5137),
    [anon_sym_STAR_EQ] = ACTIONS(5137),
    [anon_sym_SLASH_EQ] = ACTIONS(5137),
    [anon_sym_PERCENT_EQ] = ACTIONS(5137),
    [anon_sym_PLUS_EQ] = ACTIONS(5137),
    [anon_sym_DASH_EQ] = ACTIONS(5137),
    [anon_sym_LT_LT_EQ] = ACTIONS(5137),
    [anon_sym_GT_GT_EQ] = ACTIONS(5137),
    [anon_sym_AMP_EQ] = ACTIONS(5137),
    [anon_sym_CARET_EQ] = ACTIONS(5137),
    [anon_sym_PIPE_EQ] = ACTIONS(5137),
    [anon_sym_and_eq] = ACTIONS(5135),
    [anon_sym_or_eq] = ACTIONS(5135),
    [anon_sym_xor_eq] = ACTIONS(5135),
    [anon_sym_LT_EQ_GT] = ACTIONS(5137),
    [anon_sym_or] = ACTIONS(5135),
    [anon_sym_and] = ACTIONS(5135),
    [anon_sym_bitor] = ACTIONS(5135),
    [anon_sym_xor] = ACTIONS(5135),
    [anon_sym_bitand] = ACTIONS(5135),
    [anon_sym_not_eq] = ACTIONS(5135),
    [anon_sym_DASH_DASH] = ACTIONS(5137),
    [anon_sym_PLUS_PLUS] = ACTIONS(5137),
    [anon_sym_DOT] = ACTIONS(5135),
    [anon_sym_DOT_STAR] = ACTIONS(5137),
    [anon_sym_DASH_GT] = ACTIONS(5137),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5135),
    [anon_sym_decltype] = ACTIONS(5135),
  },
  [2380] = {
    [sym_identifier] = ACTIONS(4924),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4926),
    [anon_sym_COMMA] = ACTIONS(4926),
    [anon_sym_RPAREN] = ACTIONS(4926),
    [aux_sym_preproc_if_token2] = ACTIONS(4926),
    [aux_sym_preproc_else_token1] = ACTIONS(4926),
    [aux_sym_preproc_elif_token1] = ACTIONS(4924),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4926),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4926),
    [anon_sym_LPAREN2] = ACTIONS(4926),
    [anon_sym_DASH] = ACTIONS(4924),
    [anon_sym_PLUS] = ACTIONS(4924),
    [anon_sym_STAR] = ACTIONS(4924),
    [anon_sym_SLASH] = ACTIONS(4924),
    [anon_sym_PERCENT] = ACTIONS(4924),
    [anon_sym_PIPE_PIPE] = ACTIONS(4926),
    [anon_sym_AMP_AMP] = ACTIONS(4926),
    [anon_sym_PIPE] = ACTIONS(4924),
    [anon_sym_CARET] = ACTIONS(4924),
    [anon_sym_AMP] = ACTIONS(4924),
    [anon_sym_EQ_EQ] = ACTIONS(4926),
    [anon_sym_BANG_EQ] = ACTIONS(4926),
    [anon_sym_GT] = ACTIONS(4924),
    [anon_sym_GT_EQ] = ACTIONS(4926),
    [anon_sym_LT_EQ] = ACTIONS(4924),
    [anon_sym_LT] = ACTIONS(4924),
    [anon_sym_LT_LT] = ACTIONS(4924),
    [anon_sym_GT_GT] = ACTIONS(4924),
    [anon_sym_SEMI] = ACTIONS(4926),
    [anon_sym___attribute__] = ACTIONS(4924),
    [anon_sym_LBRACE] = ACTIONS(4926),
    [anon_sym_RBRACE] = ACTIONS(4926),
    [anon_sym_LBRACK] = ACTIONS(4926),
    [anon_sym_RBRACK] = ACTIONS(4926),
    [anon_sym_EQ] = ACTIONS(4924),
    [anon_sym_COLON] = ACTIONS(4926),
    [anon_sym_QMARK] = ACTIONS(4926),
    [anon_sym_STAR_EQ] = ACTIONS(4926),
    [anon_sym_SLASH_EQ] = ACTIONS(4926),
    [anon_sym_PERCENT_EQ] = ACTIONS(4926),
    [anon_sym_PLUS_EQ] = ACTIONS(4926),
    [anon_sym_DASH_EQ] = ACTIONS(4926),
    [anon_sym_LT_LT_EQ] = ACTIONS(4926),
    [anon_sym_GT_GT_EQ] = ACTIONS(4926),
    [anon_sym_AMP_EQ] = ACTIONS(4926),
    [anon_sym_CARET_EQ] = ACTIONS(4926),
    [anon_sym_PIPE_EQ] = ACTIONS(4926),
    [anon_sym_and_eq] = ACTIONS(4924),
    [anon_sym_or_eq] = ACTIONS(4924),
    [anon_sym_xor_eq] = ACTIONS(4924),
    [anon_sym_LT_EQ_GT] = ACTIONS(4926),
    [anon_sym_or] = ACTIONS(4924),
    [anon_sym_and] = ACTIONS(4924),
    [anon_sym_bitor] = ACTIONS(4924),
    [anon_sym_xor] = ACTIONS(4924),
    [anon_sym_bitand] = ACTIONS(4924),
    [anon_sym_not_eq] = ACTIONS(4924),
    [anon_sym_DASH_DASH] = ACTIONS(4926),
    [anon_sym_PLUS_PLUS] = ACTIONS(4926),
    [anon_sym_DOT] = ACTIONS(4924),
    [anon_sym_DOT_STAR] = ACTIONS(4926),
    [anon_sym_DASH_GT] = ACTIONS(4926),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4924),
    [anon_sym_decltype] = ACTIONS(4924),
  },
  [2381] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(5406),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5404),
    [anon_sym_COMMA] = ACTIONS(5404),
    [aux_sym_preproc_if_token2] = ACTIONS(5404),
    [aux_sym_preproc_else_token1] = ACTIONS(5404),
    [aux_sym_preproc_elif_token1] = ACTIONS(5406),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5404),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5404),
    [anon_sym_LPAREN2] = ACTIONS(5404),
    [anon_sym_DASH] = ACTIONS(5406),
    [anon_sym_PLUS] = ACTIONS(5406),
    [anon_sym_STAR] = ACTIONS(5406),
    [anon_sym_SLASH] = ACTIONS(5406),
    [anon_sym_PERCENT] = ACTIONS(5406),
    [anon_sym_PIPE_PIPE] = ACTIONS(5404),
    [anon_sym_AMP_AMP] = ACTIONS(5404),
    [anon_sym_PIPE] = ACTIONS(5406),
    [anon_sym_CARET] = ACTIONS(5406),
    [anon_sym_AMP] = ACTIONS(5406),
    [anon_sym_EQ_EQ] = ACTIONS(5404),
    [anon_sym_BANG_EQ] = ACTIONS(5404),
    [anon_sym_GT] = ACTIONS(5406),
    [anon_sym_GT_EQ] = ACTIONS(5404),
    [anon_sym_LT_EQ] = ACTIONS(5406),
    [anon_sym_LT] = ACTIONS(5406),
    [anon_sym_LT_LT] = ACTIONS(5406),
    [anon_sym_GT_GT] = ACTIONS(5406),
    [anon_sym___attribute__] = ACTIONS(5406),
    [anon_sym_LBRACE] = ACTIONS(5404),
    [anon_sym_signed] = ACTIONS(5539),
    [anon_sym_unsigned] = ACTIONS(5539),
    [anon_sym_long] = ACTIONS(5539),
    [anon_sym_short] = ACTIONS(5539),
    [anon_sym_LBRACK] = ACTIONS(5404),
    [anon_sym_EQ] = ACTIONS(5406),
    [anon_sym_QMARK] = ACTIONS(5404),
    [anon_sym_STAR_EQ] = ACTIONS(5404),
    [anon_sym_SLASH_EQ] = ACTIONS(5404),
    [anon_sym_PERCENT_EQ] = ACTIONS(5404),
    [anon_sym_PLUS_EQ] = ACTIONS(5404),
    [anon_sym_DASH_EQ] = ACTIONS(5404),
    [anon_sym_LT_LT_EQ] = ACTIONS(5404),
    [anon_sym_GT_GT_EQ] = ACTIONS(5404),
    [anon_sym_AMP_EQ] = ACTIONS(5404),
    [anon_sym_CARET_EQ] = ACTIONS(5404),
    [anon_sym_PIPE_EQ] = ACTIONS(5404),
    [anon_sym_and_eq] = ACTIONS(5406),
    [anon_sym_or_eq] = ACTIONS(5406),
    [anon_sym_xor_eq] = ACTIONS(5406),
    [anon_sym_LT_EQ_GT] = ACTIONS(5404),
    [anon_sym_or] = ACTIONS(5406),
    [anon_sym_and] = ACTIONS(5406),
    [anon_sym_bitor] = ACTIONS(5406),
    [anon_sym_xor] = ACTIONS(5406),
    [anon_sym_bitand] = ACTIONS(5406),
    [anon_sym_not_eq] = ACTIONS(5406),
    [anon_sym_DASH_DASH] = ACTIONS(5404),
    [anon_sym_PLUS_PLUS] = ACTIONS(5404),
    [anon_sym_DOT] = ACTIONS(5406),
    [anon_sym_DOT_STAR] = ACTIONS(5404),
    [anon_sym_DASH_GT] = ACTIONS(5404),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5406),
    [anon_sym_decltype] = ACTIONS(5406),
  },
  [2382] = {
    [sym_identifier] = ACTIONS(5156),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5158),
    [anon_sym_COMMA] = ACTIONS(5158),
    [anon_sym_RPAREN] = ACTIONS(5158),
    [aux_sym_preproc_if_token2] = ACTIONS(5158),
    [aux_sym_preproc_else_token1] = ACTIONS(5158),
    [aux_sym_preproc_elif_token1] = ACTIONS(5156),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5158),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5158),
    [anon_sym_LPAREN2] = ACTIONS(5158),
    [anon_sym_DASH] = ACTIONS(5156),
    [anon_sym_PLUS] = ACTIONS(5156),
    [anon_sym_STAR] = ACTIONS(5156),
    [anon_sym_SLASH] = ACTIONS(5156),
    [anon_sym_PERCENT] = ACTIONS(5156),
    [anon_sym_PIPE_PIPE] = ACTIONS(5158),
    [anon_sym_AMP_AMP] = ACTIONS(5158),
    [anon_sym_PIPE] = ACTIONS(5156),
    [anon_sym_CARET] = ACTIONS(5156),
    [anon_sym_AMP] = ACTIONS(5156),
    [anon_sym_EQ_EQ] = ACTIONS(5158),
    [anon_sym_BANG_EQ] = ACTIONS(5158),
    [anon_sym_GT] = ACTIONS(5156),
    [anon_sym_GT_EQ] = ACTIONS(5158),
    [anon_sym_LT_EQ] = ACTIONS(5156),
    [anon_sym_LT] = ACTIONS(5156),
    [anon_sym_LT_LT] = ACTIONS(5156),
    [anon_sym_GT_GT] = ACTIONS(5156),
    [anon_sym_SEMI] = ACTIONS(5158),
    [anon_sym___attribute__] = ACTIONS(5156),
    [anon_sym_LBRACE] = ACTIONS(5158),
    [anon_sym_RBRACE] = ACTIONS(5158),
    [anon_sym_LBRACK] = ACTIONS(5158),
    [anon_sym_RBRACK] = ACTIONS(5158),
    [anon_sym_EQ] = ACTIONS(5156),
    [anon_sym_COLON] = ACTIONS(5158),
    [anon_sym_QMARK] = ACTIONS(5158),
    [anon_sym_STAR_EQ] = ACTIONS(5158),
    [anon_sym_SLASH_EQ] = ACTIONS(5158),
    [anon_sym_PERCENT_EQ] = ACTIONS(5158),
    [anon_sym_PLUS_EQ] = ACTIONS(5158),
    [anon_sym_DASH_EQ] = ACTIONS(5158),
    [anon_sym_LT_LT_EQ] = ACTIONS(5158),
    [anon_sym_GT_GT_EQ] = ACTIONS(5158),
    [anon_sym_AMP_EQ] = ACTIONS(5158),
    [anon_sym_CARET_EQ] = ACTIONS(5158),
    [anon_sym_PIPE_EQ] = ACTIONS(5158),
    [anon_sym_and_eq] = ACTIONS(5156),
    [anon_sym_or_eq] = ACTIONS(5156),
    [anon_sym_xor_eq] = ACTIONS(5156),
    [anon_sym_LT_EQ_GT] = ACTIONS(5158),
    [anon_sym_or] = ACTIONS(5156),
    [anon_sym_and] = ACTIONS(5156),
    [anon_sym_bitor] = ACTIONS(5156),
    [anon_sym_xor] = ACTIONS(5156),
    [anon_sym_bitand] = ACTIONS(5156),
    [anon_sym_not_eq] = ACTIONS(5156),
    [anon_sym_DASH_DASH] = ACTIONS(5158),
    [anon_sym_PLUS_PLUS] = ACTIONS(5158),
    [anon_sym_DOT] = ACTIONS(5156),
    [anon_sym_DOT_STAR] = ACTIONS(5158),
    [anon_sym_DASH_GT] = ACTIONS(5158),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5156),
    [anon_sym_decltype] = ACTIONS(5156),
  },
  [2383] = {
    [sym_identifier] = ACTIONS(5168),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5170),
    [anon_sym_COMMA] = ACTIONS(5170),
    [anon_sym_RPAREN] = ACTIONS(5170),
    [aux_sym_preproc_if_token2] = ACTIONS(5170),
    [aux_sym_preproc_else_token1] = ACTIONS(5170),
    [aux_sym_preproc_elif_token1] = ACTIONS(5168),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5170),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5170),
    [anon_sym_LPAREN2] = ACTIONS(5170),
    [anon_sym_DASH] = ACTIONS(5168),
    [anon_sym_PLUS] = ACTIONS(5168),
    [anon_sym_STAR] = ACTIONS(5168),
    [anon_sym_SLASH] = ACTIONS(5168),
    [anon_sym_PERCENT] = ACTIONS(5168),
    [anon_sym_PIPE_PIPE] = ACTIONS(5170),
    [anon_sym_AMP_AMP] = ACTIONS(5170),
    [anon_sym_PIPE] = ACTIONS(5168),
    [anon_sym_CARET] = ACTIONS(5168),
    [anon_sym_AMP] = ACTIONS(5168),
    [anon_sym_EQ_EQ] = ACTIONS(5170),
    [anon_sym_BANG_EQ] = ACTIONS(5170),
    [anon_sym_GT] = ACTIONS(5168),
    [anon_sym_GT_EQ] = ACTIONS(5170),
    [anon_sym_LT_EQ] = ACTIONS(5168),
    [anon_sym_LT] = ACTIONS(5168),
    [anon_sym_LT_LT] = ACTIONS(5168),
    [anon_sym_GT_GT] = ACTIONS(5168),
    [anon_sym_SEMI] = ACTIONS(5170),
    [anon_sym___attribute__] = ACTIONS(5168),
    [anon_sym_LBRACE] = ACTIONS(5170),
    [anon_sym_RBRACE] = ACTIONS(5170),
    [anon_sym_LBRACK] = ACTIONS(5170),
    [anon_sym_RBRACK] = ACTIONS(5170),
    [anon_sym_EQ] = ACTIONS(5168),
    [anon_sym_COLON] = ACTIONS(5170),
    [anon_sym_QMARK] = ACTIONS(5170),
    [anon_sym_STAR_EQ] = ACTIONS(5170),
    [anon_sym_SLASH_EQ] = ACTIONS(5170),
    [anon_sym_PERCENT_EQ] = ACTIONS(5170),
    [anon_sym_PLUS_EQ] = ACTIONS(5170),
    [anon_sym_DASH_EQ] = ACTIONS(5170),
    [anon_sym_LT_LT_EQ] = ACTIONS(5170),
    [anon_sym_GT_GT_EQ] = ACTIONS(5170),
    [anon_sym_AMP_EQ] = ACTIONS(5170),
    [anon_sym_CARET_EQ] = ACTIONS(5170),
    [anon_sym_PIPE_EQ] = ACTIONS(5170),
    [anon_sym_and_eq] = ACTIONS(5168),
    [anon_sym_or_eq] = ACTIONS(5168),
    [anon_sym_xor_eq] = ACTIONS(5168),
    [anon_sym_LT_EQ_GT] = ACTIONS(5170),
    [anon_sym_or] = ACTIONS(5168),
    [anon_sym_and] = ACTIONS(5168),
    [anon_sym_bitor] = ACTIONS(5168),
    [anon_sym_xor] = ACTIONS(5168),
    [anon_sym_bitand] = ACTIONS(5168),
    [anon_sym_not_eq] = ACTIONS(5168),
    [anon_sym_DASH_DASH] = ACTIONS(5170),
    [anon_sym_PLUS_PLUS] = ACTIONS(5170),
    [anon_sym_DOT] = ACTIONS(5168),
    [anon_sym_DOT_STAR] = ACTIONS(5170),
    [anon_sym_DASH_GT] = ACTIONS(5170),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5168),
    [anon_sym_decltype] = ACTIONS(5168),
  },
  [2384] = {
    [sym_identifier] = ACTIONS(5172),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5174),
    [anon_sym_COMMA] = ACTIONS(5174),
    [anon_sym_RPAREN] = ACTIONS(5174),
    [aux_sym_preproc_if_token2] = ACTIONS(5174),
    [aux_sym_preproc_else_token1] = ACTIONS(5174),
    [aux_sym_preproc_elif_token1] = ACTIONS(5172),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5174),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5174),
    [anon_sym_LPAREN2] = ACTIONS(5174),
    [anon_sym_DASH] = ACTIONS(5172),
    [anon_sym_PLUS] = ACTIONS(5172),
    [anon_sym_STAR] = ACTIONS(5172),
    [anon_sym_SLASH] = ACTIONS(5172),
    [anon_sym_PERCENT] = ACTIONS(5172),
    [anon_sym_PIPE_PIPE] = ACTIONS(5174),
    [anon_sym_AMP_AMP] = ACTIONS(5174),
    [anon_sym_PIPE] = ACTIONS(5172),
    [anon_sym_CARET] = ACTIONS(5172),
    [anon_sym_AMP] = ACTIONS(5172),
    [anon_sym_EQ_EQ] = ACTIONS(5174),
    [anon_sym_BANG_EQ] = ACTIONS(5174),
    [anon_sym_GT] = ACTIONS(5172),
    [anon_sym_GT_EQ] = ACTIONS(5174),
    [anon_sym_LT_EQ] = ACTIONS(5172),
    [anon_sym_LT] = ACTIONS(5172),
    [anon_sym_LT_LT] = ACTIONS(5172),
    [anon_sym_GT_GT] = ACTIONS(5172),
    [anon_sym_SEMI] = ACTIONS(5174),
    [anon_sym___attribute__] = ACTIONS(5172),
    [anon_sym_LBRACE] = ACTIONS(5174),
    [anon_sym_RBRACE] = ACTIONS(5174),
    [anon_sym_LBRACK] = ACTIONS(5174),
    [anon_sym_RBRACK] = ACTIONS(5174),
    [anon_sym_EQ] = ACTIONS(5172),
    [anon_sym_COLON] = ACTIONS(5174),
    [anon_sym_QMARK] = ACTIONS(5174),
    [anon_sym_STAR_EQ] = ACTIONS(5174),
    [anon_sym_SLASH_EQ] = ACTIONS(5174),
    [anon_sym_PERCENT_EQ] = ACTIONS(5174),
    [anon_sym_PLUS_EQ] = ACTIONS(5174),
    [anon_sym_DASH_EQ] = ACTIONS(5174),
    [anon_sym_LT_LT_EQ] = ACTIONS(5174),
    [anon_sym_GT_GT_EQ] = ACTIONS(5174),
    [anon_sym_AMP_EQ] = ACTIONS(5174),
    [anon_sym_CARET_EQ] = ACTIONS(5174),
    [anon_sym_PIPE_EQ] = ACTIONS(5174),
    [anon_sym_and_eq] = ACTIONS(5172),
    [anon_sym_or_eq] = ACTIONS(5172),
    [anon_sym_xor_eq] = ACTIONS(5172),
    [anon_sym_LT_EQ_GT] = ACTIONS(5174),
    [anon_sym_or] = ACTIONS(5172),
    [anon_sym_and] = ACTIONS(5172),
    [anon_sym_bitor] = ACTIONS(5172),
    [anon_sym_xor] = ACTIONS(5172),
    [anon_sym_bitand] = ACTIONS(5172),
    [anon_sym_not_eq] = ACTIONS(5172),
    [anon_sym_DASH_DASH] = ACTIONS(5174),
    [anon_sym_PLUS_PLUS] = ACTIONS(5174),
    [anon_sym_DOT] = ACTIONS(5172),
    [anon_sym_DOT_STAR] = ACTIONS(5174),
    [anon_sym_DASH_GT] = ACTIONS(5174),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5172),
    [anon_sym_decltype] = ACTIONS(5172),
  },
  [2385] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(5369),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5367),
    [anon_sym_COMMA] = ACTIONS(5367),
    [aux_sym_preproc_if_token2] = ACTIONS(5367),
    [aux_sym_preproc_else_token1] = ACTIONS(5367),
    [aux_sym_preproc_elif_token1] = ACTIONS(5369),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5367),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5367),
    [anon_sym_LPAREN2] = ACTIONS(5367),
    [anon_sym_DASH] = ACTIONS(5369),
    [anon_sym_PLUS] = ACTIONS(5369),
    [anon_sym_STAR] = ACTIONS(5369),
    [anon_sym_SLASH] = ACTIONS(5369),
    [anon_sym_PERCENT] = ACTIONS(5369),
    [anon_sym_PIPE_PIPE] = ACTIONS(5367),
    [anon_sym_AMP_AMP] = ACTIONS(5367),
    [anon_sym_PIPE] = ACTIONS(5369),
    [anon_sym_CARET] = ACTIONS(5369),
    [anon_sym_AMP] = ACTIONS(5369),
    [anon_sym_EQ_EQ] = ACTIONS(5367),
    [anon_sym_BANG_EQ] = ACTIONS(5367),
    [anon_sym_GT] = ACTIONS(5369),
    [anon_sym_GT_EQ] = ACTIONS(5367),
    [anon_sym_LT_EQ] = ACTIONS(5369),
    [anon_sym_LT] = ACTIONS(5369),
    [anon_sym_LT_LT] = ACTIONS(5369),
    [anon_sym_GT_GT] = ACTIONS(5369),
    [anon_sym___attribute__] = ACTIONS(5369),
    [anon_sym_LBRACE] = ACTIONS(5367),
    [anon_sym_signed] = ACTIONS(5539),
    [anon_sym_unsigned] = ACTIONS(5539),
    [anon_sym_long] = ACTIONS(5539),
    [anon_sym_short] = ACTIONS(5539),
    [anon_sym_LBRACK] = ACTIONS(5367),
    [anon_sym_EQ] = ACTIONS(5369),
    [anon_sym_QMARK] = ACTIONS(5367),
    [anon_sym_STAR_EQ] = ACTIONS(5367),
    [anon_sym_SLASH_EQ] = ACTIONS(5367),
    [anon_sym_PERCENT_EQ] = ACTIONS(5367),
    [anon_sym_PLUS_EQ] = ACTIONS(5367),
    [anon_sym_DASH_EQ] = ACTIONS(5367),
    [anon_sym_LT_LT_EQ] = ACTIONS(5367),
    [anon_sym_GT_GT_EQ] = ACTIONS(5367),
    [anon_sym_AMP_EQ] = ACTIONS(5367),
    [anon_sym_CARET_EQ] = ACTIONS(5367),
    [anon_sym_PIPE_EQ] = ACTIONS(5367),
    [anon_sym_and_eq] = ACTIONS(5369),
    [anon_sym_or_eq] = ACTIONS(5369),
    [anon_sym_xor_eq] = ACTIONS(5369),
    [anon_sym_LT_EQ_GT] = ACTIONS(5367),
    [anon_sym_or] = ACTIONS(5369),
    [anon_sym_and] = ACTIONS(5369),
    [anon_sym_bitor] = ACTIONS(5369),
    [anon_sym_xor] = ACTIONS(5369),
    [anon_sym_bitand] = ACTIONS(5369),
    [anon_sym_not_eq] = ACTIONS(5369),
    [anon_sym_DASH_DASH] = ACTIONS(5367),
    [anon_sym_PLUS_PLUS] = ACTIONS(5367),
    [anon_sym_DOT] = ACTIONS(5369),
    [anon_sym_DOT_STAR] = ACTIONS(5367),
    [anon_sym_DASH_GT] = ACTIONS(5367),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5369),
    [anon_sym_decltype] = ACTIONS(5369),
  },
  [2386] = {
    [sym_identifier] = ACTIONS(5179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5181),
    [anon_sym_COMMA] = ACTIONS(5181),
    [anon_sym_RPAREN] = ACTIONS(5181),
    [aux_sym_preproc_if_token2] = ACTIONS(5181),
    [aux_sym_preproc_else_token1] = ACTIONS(5181),
    [aux_sym_preproc_elif_token1] = ACTIONS(5179),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5181),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5181),
    [anon_sym_LPAREN2] = ACTIONS(5181),
    [anon_sym_DASH] = ACTIONS(5179),
    [anon_sym_PLUS] = ACTIONS(5179),
    [anon_sym_STAR] = ACTIONS(5179),
    [anon_sym_SLASH] = ACTIONS(5179),
    [anon_sym_PERCENT] = ACTIONS(5179),
    [anon_sym_PIPE_PIPE] = ACTIONS(5181),
    [anon_sym_AMP_AMP] = ACTIONS(5181),
    [anon_sym_PIPE] = ACTIONS(5179),
    [anon_sym_CARET] = ACTIONS(5179),
    [anon_sym_AMP] = ACTIONS(5179),
    [anon_sym_EQ_EQ] = ACTIONS(5181),
    [anon_sym_BANG_EQ] = ACTIONS(5181),
    [anon_sym_GT] = ACTIONS(5179),
    [anon_sym_GT_EQ] = ACTIONS(5181),
    [anon_sym_LT_EQ] = ACTIONS(5179),
    [anon_sym_LT] = ACTIONS(5179),
    [anon_sym_LT_LT] = ACTIONS(5179),
    [anon_sym_GT_GT] = ACTIONS(5179),
    [anon_sym_SEMI] = ACTIONS(5181),
    [anon_sym___attribute__] = ACTIONS(5179),
    [anon_sym_LBRACE] = ACTIONS(5181),
    [anon_sym_RBRACE] = ACTIONS(5181),
    [anon_sym_LBRACK] = ACTIONS(5181),
    [anon_sym_RBRACK] = ACTIONS(5181),
    [anon_sym_EQ] = ACTIONS(5179),
    [anon_sym_COLON] = ACTIONS(5181),
    [anon_sym_QMARK] = ACTIONS(5181),
    [anon_sym_STAR_EQ] = ACTIONS(5181),
    [anon_sym_SLASH_EQ] = ACTIONS(5181),
    [anon_sym_PERCENT_EQ] = ACTIONS(5181),
    [anon_sym_PLUS_EQ] = ACTIONS(5181),
    [anon_sym_DASH_EQ] = ACTIONS(5181),
    [anon_sym_LT_LT_EQ] = ACTIONS(5181),
    [anon_sym_GT_GT_EQ] = ACTIONS(5181),
    [anon_sym_AMP_EQ] = ACTIONS(5181),
    [anon_sym_CARET_EQ] = ACTIONS(5181),
    [anon_sym_PIPE_EQ] = ACTIONS(5181),
    [anon_sym_and_eq] = ACTIONS(5179),
    [anon_sym_or_eq] = ACTIONS(5179),
    [anon_sym_xor_eq] = ACTIONS(5179),
    [anon_sym_LT_EQ_GT] = ACTIONS(5181),
    [anon_sym_or] = ACTIONS(5179),
    [anon_sym_and] = ACTIONS(5179),
    [anon_sym_bitor] = ACTIONS(5179),
    [anon_sym_xor] = ACTIONS(5179),
    [anon_sym_bitand] = ACTIONS(5179),
    [anon_sym_not_eq] = ACTIONS(5179),
    [anon_sym_DASH_DASH] = ACTIONS(5181),
    [anon_sym_PLUS_PLUS] = ACTIONS(5181),
    [anon_sym_DOT] = ACTIONS(5179),
    [anon_sym_DOT_STAR] = ACTIONS(5181),
    [anon_sym_DASH_GT] = ACTIONS(5181),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5179),
    [anon_sym_decltype] = ACTIONS(5179),
  },
  [2387] = {
    [sym_identifier] = ACTIONS(5164),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5166),
    [anon_sym_COMMA] = ACTIONS(5166),
    [anon_sym_RPAREN] = ACTIONS(5166),
    [aux_sym_preproc_if_token2] = ACTIONS(5166),
    [aux_sym_preproc_else_token1] = ACTIONS(5166),
    [aux_sym_preproc_elif_token1] = ACTIONS(5164),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5166),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5166),
    [anon_sym_LPAREN2] = ACTIONS(5166),
    [anon_sym_DASH] = ACTIONS(5164),
    [anon_sym_PLUS] = ACTIONS(5164),
    [anon_sym_STAR] = ACTIONS(5164),
    [anon_sym_SLASH] = ACTIONS(5164),
    [anon_sym_PERCENT] = ACTIONS(5164),
    [anon_sym_PIPE_PIPE] = ACTIONS(5166),
    [anon_sym_AMP_AMP] = ACTIONS(5166),
    [anon_sym_PIPE] = ACTIONS(5164),
    [anon_sym_CARET] = ACTIONS(5164),
    [anon_sym_AMP] = ACTIONS(5164),
    [anon_sym_EQ_EQ] = ACTIONS(5166),
    [anon_sym_BANG_EQ] = ACTIONS(5166),
    [anon_sym_GT] = ACTIONS(5164),
    [anon_sym_GT_EQ] = ACTIONS(5166),
    [anon_sym_LT_EQ] = ACTIONS(5164),
    [anon_sym_LT] = ACTIONS(5164),
    [anon_sym_LT_LT] = ACTIONS(5164),
    [anon_sym_GT_GT] = ACTIONS(5164),
    [anon_sym_SEMI] = ACTIONS(5166),
    [anon_sym___attribute__] = ACTIONS(5164),
    [anon_sym_LBRACE] = ACTIONS(5166),
    [anon_sym_RBRACE] = ACTIONS(5166),
    [anon_sym_LBRACK] = ACTIONS(5166),
    [anon_sym_RBRACK] = ACTIONS(5166),
    [anon_sym_EQ] = ACTIONS(5164),
    [anon_sym_COLON] = ACTIONS(5166),
    [anon_sym_QMARK] = ACTIONS(5166),
    [anon_sym_STAR_EQ] = ACTIONS(5166),
    [anon_sym_SLASH_EQ] = ACTIONS(5166),
    [anon_sym_PERCENT_EQ] = ACTIONS(5166),
    [anon_sym_PLUS_EQ] = ACTIONS(5166),
    [anon_sym_DASH_EQ] = ACTIONS(5166),
    [anon_sym_LT_LT_EQ] = ACTIONS(5166),
    [anon_sym_GT_GT_EQ] = ACTIONS(5166),
    [anon_sym_AMP_EQ] = ACTIONS(5166),
    [anon_sym_CARET_EQ] = ACTIONS(5166),
    [anon_sym_PIPE_EQ] = ACTIONS(5166),
    [anon_sym_and_eq] = ACTIONS(5164),
    [anon_sym_or_eq] = ACTIONS(5164),
    [anon_sym_xor_eq] = ACTIONS(5164),
    [anon_sym_LT_EQ_GT] = ACTIONS(5166),
    [anon_sym_or] = ACTIONS(5164),
    [anon_sym_and] = ACTIONS(5164),
    [anon_sym_bitor] = ACTIONS(5164),
    [anon_sym_xor] = ACTIONS(5164),
    [anon_sym_bitand] = ACTIONS(5164),
    [anon_sym_not_eq] = ACTIONS(5164),
    [anon_sym_DASH_DASH] = ACTIONS(5166),
    [anon_sym_PLUS_PLUS] = ACTIONS(5166),
    [anon_sym_DOT] = ACTIONS(5164),
    [anon_sym_DOT_STAR] = ACTIONS(5166),
    [anon_sym_DASH_GT] = ACTIONS(5166),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5164),
    [anon_sym_decltype] = ACTIONS(5164),
  },
  [2388] = {
    [sym_identifier] = ACTIONS(5125),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5127),
    [anon_sym_COMMA] = ACTIONS(5127),
    [anon_sym_RPAREN] = ACTIONS(5127),
    [aux_sym_preproc_if_token2] = ACTIONS(5127),
    [aux_sym_preproc_else_token1] = ACTIONS(5127),
    [aux_sym_preproc_elif_token1] = ACTIONS(5125),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5127),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5127),
    [anon_sym_LPAREN2] = ACTIONS(5127),
    [anon_sym_DASH] = ACTIONS(5125),
    [anon_sym_PLUS] = ACTIONS(5125),
    [anon_sym_STAR] = ACTIONS(5125),
    [anon_sym_SLASH] = ACTIONS(5125),
    [anon_sym_PERCENT] = ACTIONS(5125),
    [anon_sym_PIPE_PIPE] = ACTIONS(5127),
    [anon_sym_AMP_AMP] = ACTIONS(5127),
    [anon_sym_PIPE] = ACTIONS(5125),
    [anon_sym_CARET] = ACTIONS(5125),
    [anon_sym_AMP] = ACTIONS(5125),
    [anon_sym_EQ_EQ] = ACTIONS(5127),
    [anon_sym_BANG_EQ] = ACTIONS(5127),
    [anon_sym_GT] = ACTIONS(5125),
    [anon_sym_GT_EQ] = ACTIONS(5127),
    [anon_sym_LT_EQ] = ACTIONS(5125),
    [anon_sym_LT] = ACTIONS(5125),
    [anon_sym_LT_LT] = ACTIONS(5125),
    [anon_sym_GT_GT] = ACTIONS(5125),
    [anon_sym_SEMI] = ACTIONS(5127),
    [anon_sym___attribute__] = ACTIONS(5125),
    [anon_sym_LBRACE] = ACTIONS(5127),
    [anon_sym_RBRACE] = ACTIONS(5127),
    [anon_sym_LBRACK] = ACTIONS(5127),
    [anon_sym_RBRACK] = ACTIONS(5127),
    [anon_sym_EQ] = ACTIONS(5125),
    [anon_sym_COLON] = ACTIONS(5127),
    [anon_sym_QMARK] = ACTIONS(5127),
    [anon_sym_STAR_EQ] = ACTIONS(5127),
    [anon_sym_SLASH_EQ] = ACTIONS(5127),
    [anon_sym_PERCENT_EQ] = ACTIONS(5127),
    [anon_sym_PLUS_EQ] = ACTIONS(5127),
    [anon_sym_DASH_EQ] = ACTIONS(5127),
    [anon_sym_LT_LT_EQ] = ACTIONS(5127),
    [anon_sym_GT_GT_EQ] = ACTIONS(5127),
    [anon_sym_AMP_EQ] = ACTIONS(5127),
    [anon_sym_CARET_EQ] = ACTIONS(5127),
    [anon_sym_PIPE_EQ] = ACTIONS(5127),
    [anon_sym_and_eq] = ACTIONS(5125),
    [anon_sym_or_eq] = ACTIONS(5125),
    [anon_sym_xor_eq] = ACTIONS(5125),
    [anon_sym_LT_EQ_GT] = ACTIONS(5127),
    [anon_sym_or] = ACTIONS(5125),
    [anon_sym_and] = ACTIONS(5125),
    [anon_sym_bitor] = ACTIONS(5125),
    [anon_sym_xor] = ACTIONS(5125),
    [anon_sym_bitand] = ACTIONS(5125),
    [anon_sym_not_eq] = ACTIONS(5125),
    [anon_sym_DASH_DASH] = ACTIONS(5127),
    [anon_sym_PLUS_PLUS] = ACTIONS(5127),
    [anon_sym_DOT] = ACTIONS(5125),
    [anon_sym_DOT_STAR] = ACTIONS(5127),
    [anon_sym_DASH_GT] = ACTIONS(5127),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5125),
    [anon_sym_decltype] = ACTIONS(5125),
  },
  [2389] = {
    [sym_string_literal] = STATE(2079),
    [sym_raw_string_literal] = STATE(2079),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5199),
    [anon_sym_COMMA] = ACTIONS(5199),
    [anon_sym_RPAREN] = ACTIONS(5199),
    [anon_sym_LPAREN2] = ACTIONS(5199),
    [anon_sym_DASH] = ACTIONS(5197),
    [anon_sym_PLUS] = ACTIONS(5197),
    [anon_sym_STAR] = ACTIONS(5197),
    [anon_sym_SLASH] = ACTIONS(5197),
    [anon_sym_PERCENT] = ACTIONS(5197),
    [anon_sym_PIPE_PIPE] = ACTIONS(5199),
    [anon_sym_AMP_AMP] = ACTIONS(5199),
    [anon_sym_PIPE] = ACTIONS(5197),
    [anon_sym_CARET] = ACTIONS(5197),
    [anon_sym_AMP] = ACTIONS(5197),
    [anon_sym_EQ_EQ] = ACTIONS(5199),
    [anon_sym_BANG_EQ] = ACTIONS(5199),
    [anon_sym_GT] = ACTIONS(5197),
    [anon_sym_GT_EQ] = ACTIONS(5199),
    [anon_sym_LT_EQ] = ACTIONS(5197),
    [anon_sym_LT] = ACTIONS(5197),
    [anon_sym_LT_LT] = ACTIONS(5197),
    [anon_sym_GT_GT] = ACTIONS(5197),
    [anon_sym_LBRACK] = ACTIONS(5199),
    [anon_sym_EQ] = ACTIONS(5197),
    [anon_sym_QMARK] = ACTIONS(5199),
    [anon_sym_STAR_EQ] = ACTIONS(5199),
    [anon_sym_SLASH_EQ] = ACTIONS(5199),
    [anon_sym_PERCENT_EQ] = ACTIONS(5199),
    [anon_sym_PLUS_EQ] = ACTIONS(5199),
    [anon_sym_DASH_EQ] = ACTIONS(5199),
    [anon_sym_LT_LT_EQ] = ACTIONS(5199),
    [anon_sym_GT_GT_EQ] = ACTIONS(5199),
    [anon_sym_AMP_EQ] = ACTIONS(5199),
    [anon_sym_CARET_EQ] = ACTIONS(5199),
    [anon_sym_PIPE_EQ] = ACTIONS(5199),
    [anon_sym_and_eq] = ACTIONS(5197),
    [anon_sym_or_eq] = ACTIONS(5197),
    [anon_sym_xor_eq] = ACTIONS(5197),
    [anon_sym_LT_EQ_GT] = ACTIONS(5199),
    [anon_sym_or] = ACTIONS(5197),
    [anon_sym_and] = ACTIONS(5197),
    [anon_sym_bitor] = ACTIONS(5197),
    [anon_sym_xor] = ACTIONS(5197),
    [anon_sym_bitand] = ACTIONS(5197),
    [anon_sym_not_eq] = ACTIONS(5197),
    [anon_sym_DASH_DASH] = ACTIONS(5199),
    [anon_sym_PLUS_PLUS] = ACTIONS(5199),
    [anon_sym_DOT] = ACTIONS(5197),
    [anon_sym_DOT_STAR] = ACTIONS(5199),
    [anon_sym_DASH_GT] = ACTIONS(5197),
    [anon_sym_L_DQUOTE] = ACTIONS(4605),
    [anon_sym_u_DQUOTE] = ACTIONS(4605),
    [anon_sym_U_DQUOTE] = ACTIONS(4605),
    [anon_sym_u8_DQUOTE] = ACTIONS(4605),
    [anon_sym_DQUOTE] = ACTIONS(4605),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4607),
    [anon_sym_LR_DQUOTE] = ACTIONS(4607),
    [anon_sym_uR_DQUOTE] = ACTIONS(4607),
    [anon_sym_UR_DQUOTE] = ACTIONS(4607),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4607),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5199),
    [sym_literal_suffix] = ACTIONS(5621),
  },
  [2390] = {
    [sym_string_literal] = STATE(2079),
    [sym_raw_string_literal] = STATE(2079),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3761),
    [anon_sym_COMMA] = ACTIONS(3761),
    [anon_sym_RPAREN] = ACTIONS(3761),
    [anon_sym_LPAREN2] = ACTIONS(3761),
    [anon_sym_DASH] = ACTIONS(3769),
    [anon_sym_PLUS] = ACTIONS(3769),
    [anon_sym_STAR] = ACTIONS(3769),
    [anon_sym_SLASH] = ACTIONS(3769),
    [anon_sym_PERCENT] = ACTIONS(3769),
    [anon_sym_PIPE_PIPE] = ACTIONS(3761),
    [anon_sym_AMP_AMP] = ACTIONS(3761),
    [anon_sym_PIPE] = ACTIONS(3769),
    [anon_sym_CARET] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(3769),
    [anon_sym_EQ_EQ] = ACTIONS(3761),
    [anon_sym_BANG_EQ] = ACTIONS(3761),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3761),
    [anon_sym_LT_EQ] = ACTIONS(3769),
    [anon_sym_LT] = ACTIONS(3769),
    [anon_sym_LT_LT] = ACTIONS(3769),
    [anon_sym_GT_GT] = ACTIONS(3769),
    [anon_sym_LBRACK] = ACTIONS(3761),
    [anon_sym_EQ] = ACTIONS(3769),
    [anon_sym_QMARK] = ACTIONS(3761),
    [anon_sym_STAR_EQ] = ACTIONS(3761),
    [anon_sym_SLASH_EQ] = ACTIONS(3761),
    [anon_sym_PERCENT_EQ] = ACTIONS(3761),
    [anon_sym_PLUS_EQ] = ACTIONS(3761),
    [anon_sym_DASH_EQ] = ACTIONS(3761),
    [anon_sym_LT_LT_EQ] = ACTIONS(3761),
    [anon_sym_GT_GT_EQ] = ACTIONS(3761),
    [anon_sym_AMP_EQ] = ACTIONS(3761),
    [anon_sym_CARET_EQ] = ACTIONS(3761),
    [anon_sym_PIPE_EQ] = ACTIONS(3761),
    [anon_sym_and_eq] = ACTIONS(3769),
    [anon_sym_or_eq] = ACTIONS(3769),
    [anon_sym_xor_eq] = ACTIONS(3769),
    [anon_sym_LT_EQ_GT] = ACTIONS(3761),
    [anon_sym_or] = ACTIONS(3769),
    [anon_sym_and] = ACTIONS(3769),
    [anon_sym_bitor] = ACTIONS(3769),
    [anon_sym_xor] = ACTIONS(3769),
    [anon_sym_bitand] = ACTIONS(3769),
    [anon_sym_not_eq] = ACTIONS(3769),
    [anon_sym_DASH_DASH] = ACTIONS(3761),
    [anon_sym_PLUS_PLUS] = ACTIONS(3761),
    [anon_sym_DOT] = ACTIONS(3769),
    [anon_sym_DOT_STAR] = ACTIONS(3761),
    [anon_sym_DASH_GT] = ACTIONS(3769),
    [anon_sym_L_DQUOTE] = ACTIONS(4605),
    [anon_sym_u_DQUOTE] = ACTIONS(4605),
    [anon_sym_U_DQUOTE] = ACTIONS(4605),
    [anon_sym_u8_DQUOTE] = ACTIONS(4605),
    [anon_sym_DQUOTE] = ACTIONS(4605),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4607),
    [anon_sym_LR_DQUOTE] = ACTIONS(4607),
    [anon_sym_uR_DQUOTE] = ACTIONS(4607),
    [anon_sym_UR_DQUOTE] = ACTIONS(4607),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4607),
    [anon_sym_DASH_GT_STAR] = ACTIONS(3761),
    [sym_literal_suffix] = ACTIONS(5621),
  },
  [2391] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2338),
    [sym_identifier] = ACTIONS(5410),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5408),
    [anon_sym_COMMA] = ACTIONS(5408),
    [aux_sym_preproc_if_token2] = ACTIONS(5408),
    [aux_sym_preproc_else_token1] = ACTIONS(5408),
    [aux_sym_preproc_elif_token1] = ACTIONS(5410),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5408),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5408),
    [anon_sym_LPAREN2] = ACTIONS(5408),
    [anon_sym_DASH] = ACTIONS(5410),
    [anon_sym_PLUS] = ACTIONS(5410),
    [anon_sym_STAR] = ACTIONS(5410),
    [anon_sym_SLASH] = ACTIONS(5410),
    [anon_sym_PERCENT] = ACTIONS(5410),
    [anon_sym_PIPE_PIPE] = ACTIONS(5408),
    [anon_sym_AMP_AMP] = ACTIONS(5408),
    [anon_sym_PIPE] = ACTIONS(5410),
    [anon_sym_CARET] = ACTIONS(5410),
    [anon_sym_AMP] = ACTIONS(5410),
    [anon_sym_EQ_EQ] = ACTIONS(5408),
    [anon_sym_BANG_EQ] = ACTIONS(5408),
    [anon_sym_GT] = ACTIONS(5410),
    [anon_sym_GT_EQ] = ACTIONS(5408),
    [anon_sym_LT_EQ] = ACTIONS(5410),
    [anon_sym_LT] = ACTIONS(5410),
    [anon_sym_LT_LT] = ACTIONS(5410),
    [anon_sym_GT_GT] = ACTIONS(5410),
    [anon_sym___attribute__] = ACTIONS(5410),
    [anon_sym_LBRACE] = ACTIONS(5408),
    [anon_sym_signed] = ACTIONS(5623),
    [anon_sym_unsigned] = ACTIONS(5623),
    [anon_sym_long] = ACTIONS(5623),
    [anon_sym_short] = ACTIONS(5623),
    [anon_sym_LBRACK] = ACTIONS(5408),
    [anon_sym_EQ] = ACTIONS(5410),
    [anon_sym_QMARK] = ACTIONS(5408),
    [anon_sym_STAR_EQ] = ACTIONS(5408),
    [anon_sym_SLASH_EQ] = ACTIONS(5408),
    [anon_sym_PERCENT_EQ] = ACTIONS(5408),
    [anon_sym_PLUS_EQ] = ACTIONS(5408),
    [anon_sym_DASH_EQ] = ACTIONS(5408),
    [anon_sym_LT_LT_EQ] = ACTIONS(5408),
    [anon_sym_GT_GT_EQ] = ACTIONS(5408),
    [anon_sym_AMP_EQ] = ACTIONS(5408),
    [anon_sym_CARET_EQ] = ACTIONS(5408),
    [anon_sym_PIPE_EQ] = ACTIONS(5408),
    [anon_sym_and_eq] = ACTIONS(5410),
    [anon_sym_or_eq] = ACTIONS(5410),
    [anon_sym_xor_eq] = ACTIONS(5410),
    [anon_sym_LT_EQ_GT] = ACTIONS(5408),
    [anon_sym_or] = ACTIONS(5410),
    [anon_sym_and] = ACTIONS(5410),
    [anon_sym_bitor] = ACTIONS(5410),
    [anon_sym_xor] = ACTIONS(5410),
    [anon_sym_bitand] = ACTIONS(5410),
    [anon_sym_not_eq] = ACTIONS(5410),
    [anon_sym_DASH_DASH] = ACTIONS(5408),
    [anon_sym_PLUS_PLUS] = ACTIONS(5408),
    [anon_sym_DOT] = ACTIONS(5410),
    [anon_sym_DOT_STAR] = ACTIONS(5408),
    [anon_sym_DASH_GT] = ACTIONS(5408),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5410),
    [anon_sym_decltype] = ACTIONS(5410),
  },
  [2392] = {
    [sym_identifier] = ACTIONS(4924),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4926),
    [anon_sym_COMMA] = ACTIONS(4926),
    [anon_sym_RPAREN] = ACTIONS(4926),
    [aux_sym_preproc_if_token2] = ACTIONS(4926),
    [aux_sym_preproc_else_token1] = ACTIONS(4926),
    [aux_sym_preproc_elif_token1] = ACTIONS(4924),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4926),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4926),
    [anon_sym_LPAREN2] = ACTIONS(4926),
    [anon_sym_DASH] = ACTIONS(4924),
    [anon_sym_PLUS] = ACTIONS(4924),
    [anon_sym_STAR] = ACTIONS(4924),
    [anon_sym_SLASH] = ACTIONS(4924),
    [anon_sym_PERCENT] = ACTIONS(4924),
    [anon_sym_PIPE_PIPE] = ACTIONS(4926),
    [anon_sym_AMP_AMP] = ACTIONS(4926),
    [anon_sym_PIPE] = ACTIONS(4924),
    [anon_sym_CARET] = ACTIONS(4924),
    [anon_sym_AMP] = ACTIONS(4924),
    [anon_sym_EQ_EQ] = ACTIONS(4926),
    [anon_sym_BANG_EQ] = ACTIONS(4926),
    [anon_sym_GT] = ACTIONS(4924),
    [anon_sym_GT_EQ] = ACTIONS(4926),
    [anon_sym_LT_EQ] = ACTIONS(4924),
    [anon_sym_LT] = ACTIONS(4924),
    [anon_sym_LT_LT] = ACTIONS(4924),
    [anon_sym_GT_GT] = ACTIONS(4924),
    [anon_sym_SEMI] = ACTIONS(4926),
    [anon_sym___attribute__] = ACTIONS(4924),
    [anon_sym_LBRACE] = ACTIONS(4926),
    [anon_sym_RBRACE] = ACTIONS(4926),
    [anon_sym_LBRACK] = ACTIONS(4926),
    [anon_sym_RBRACK] = ACTIONS(4926),
    [anon_sym_EQ] = ACTIONS(4924),
    [anon_sym_COLON] = ACTIONS(4926),
    [anon_sym_QMARK] = ACTIONS(4926),
    [anon_sym_STAR_EQ] = ACTIONS(4926),
    [anon_sym_SLASH_EQ] = ACTIONS(4926),
    [anon_sym_PERCENT_EQ] = ACTIONS(4926),
    [anon_sym_PLUS_EQ] = ACTIONS(4926),
    [anon_sym_DASH_EQ] = ACTIONS(4926),
    [anon_sym_LT_LT_EQ] = ACTIONS(4926),
    [anon_sym_GT_GT_EQ] = ACTIONS(4926),
    [anon_sym_AMP_EQ] = ACTIONS(4926),
    [anon_sym_CARET_EQ] = ACTIONS(4926),
    [anon_sym_PIPE_EQ] = ACTIONS(4926),
    [anon_sym_and_eq] = ACTIONS(4924),
    [anon_sym_or_eq] = ACTIONS(4924),
    [anon_sym_xor_eq] = ACTIONS(4924),
    [anon_sym_LT_EQ_GT] = ACTIONS(4926),
    [anon_sym_or] = ACTIONS(4924),
    [anon_sym_and] = ACTIONS(4924),
    [anon_sym_bitor] = ACTIONS(4924),
    [anon_sym_xor] = ACTIONS(4924),
    [anon_sym_bitand] = ACTIONS(4924),
    [anon_sym_not_eq] = ACTIONS(4924),
    [anon_sym_DASH_DASH] = ACTIONS(4926),
    [anon_sym_PLUS_PLUS] = ACTIONS(4926),
    [anon_sym_DOT] = ACTIONS(4924),
    [anon_sym_DOT_STAR] = ACTIONS(4926),
    [anon_sym_DASH_GT] = ACTIONS(4926),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4924),
    [anon_sym_decltype] = ACTIONS(4924),
  },
  [2393] = {
    [sym_identifier] = ACTIONS(5160),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5162),
    [anon_sym_COMMA] = ACTIONS(5162),
    [anon_sym_RPAREN] = ACTIONS(5162),
    [aux_sym_preproc_if_token2] = ACTIONS(5162),
    [aux_sym_preproc_else_token1] = ACTIONS(5162),
    [aux_sym_preproc_elif_token1] = ACTIONS(5160),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5162),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5162),
    [anon_sym_LPAREN2] = ACTIONS(5162),
    [anon_sym_DASH] = ACTIONS(5160),
    [anon_sym_PLUS] = ACTIONS(5160),
    [anon_sym_STAR] = ACTIONS(5160),
    [anon_sym_SLASH] = ACTIONS(5160),
    [anon_sym_PERCENT] = ACTIONS(5160),
    [anon_sym_PIPE_PIPE] = ACTIONS(5162),
    [anon_sym_AMP_AMP] = ACTIONS(5162),
    [anon_sym_PIPE] = ACTIONS(5160),
    [anon_sym_CARET] = ACTIONS(5160),
    [anon_sym_AMP] = ACTIONS(5160),
    [anon_sym_EQ_EQ] = ACTIONS(5162),
    [anon_sym_BANG_EQ] = ACTIONS(5162),
    [anon_sym_GT] = ACTIONS(5160),
    [anon_sym_GT_EQ] = ACTIONS(5162),
    [anon_sym_LT_EQ] = ACTIONS(5160),
    [anon_sym_LT] = ACTIONS(5160),
    [anon_sym_LT_LT] = ACTIONS(5160),
    [anon_sym_GT_GT] = ACTIONS(5160),
    [anon_sym_SEMI] = ACTIONS(5162),
    [anon_sym___attribute__] = ACTIONS(5160),
    [anon_sym_LBRACE] = ACTIONS(5162),
    [anon_sym_RBRACE] = ACTIONS(5162),
    [anon_sym_LBRACK] = ACTIONS(5162),
    [anon_sym_RBRACK] = ACTIONS(5162),
    [anon_sym_EQ] = ACTIONS(5160),
    [anon_sym_COLON] = ACTIONS(5162),
    [anon_sym_QMARK] = ACTIONS(5162),
    [anon_sym_STAR_EQ] = ACTIONS(5162),
    [anon_sym_SLASH_EQ] = ACTIONS(5162),
    [anon_sym_PERCENT_EQ] = ACTIONS(5162),
    [anon_sym_PLUS_EQ] = ACTIONS(5162),
    [anon_sym_DASH_EQ] = ACTIONS(5162),
    [anon_sym_LT_LT_EQ] = ACTIONS(5162),
    [anon_sym_GT_GT_EQ] = ACTIONS(5162),
    [anon_sym_AMP_EQ] = ACTIONS(5162),
    [anon_sym_CARET_EQ] = ACTIONS(5162),
    [anon_sym_PIPE_EQ] = ACTIONS(5162),
    [anon_sym_and_eq] = ACTIONS(5160),
    [anon_sym_or_eq] = ACTIONS(5160),
    [anon_sym_xor_eq] = ACTIONS(5160),
    [anon_sym_LT_EQ_GT] = ACTIONS(5162),
    [anon_sym_or] = ACTIONS(5160),
    [anon_sym_and] = ACTIONS(5160),
    [anon_sym_bitor] = ACTIONS(5160),
    [anon_sym_xor] = ACTIONS(5160),
    [anon_sym_bitand] = ACTIONS(5160),
    [anon_sym_not_eq] = ACTIONS(5160),
    [anon_sym_DASH_DASH] = ACTIONS(5162),
    [anon_sym_PLUS_PLUS] = ACTIONS(5162),
    [anon_sym_DOT] = ACTIONS(5160),
    [anon_sym_DOT_STAR] = ACTIONS(5162),
    [anon_sym_DASH_GT] = ACTIONS(5162),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5160),
    [anon_sym_decltype] = ACTIONS(5160),
  },
  [2394] = {
    [sym_argument_list] = STATE(2547),
    [sym_initializer_list] = STATE(2547),
    [sym_identifier] = ACTIONS(5625),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5627),
    [anon_sym_COMMA] = ACTIONS(5627),
    [anon_sym_RPAREN] = ACTIONS(5627),
    [aux_sym_preproc_if_token2] = ACTIONS(5627),
    [aux_sym_preproc_else_token1] = ACTIONS(5627),
    [aux_sym_preproc_elif_token1] = ACTIONS(5625),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5627),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5627),
    [anon_sym_LPAREN2] = ACTIONS(5212),
    [anon_sym_DASH] = ACTIONS(5625),
    [anon_sym_PLUS] = ACTIONS(5625),
    [anon_sym_STAR] = ACTIONS(5625),
    [anon_sym_SLASH] = ACTIONS(5625),
    [anon_sym_PERCENT] = ACTIONS(5625),
    [anon_sym_PIPE_PIPE] = ACTIONS(5627),
    [anon_sym_AMP_AMP] = ACTIONS(5627),
    [anon_sym_PIPE] = ACTIONS(5625),
    [anon_sym_CARET] = ACTIONS(5625),
    [anon_sym_AMP] = ACTIONS(5625),
    [anon_sym_EQ_EQ] = ACTIONS(5627),
    [anon_sym_BANG_EQ] = ACTIONS(5627),
    [anon_sym_GT] = ACTIONS(5625),
    [anon_sym_GT_EQ] = ACTIONS(5627),
    [anon_sym_LT_EQ] = ACTIONS(5625),
    [anon_sym_LT] = ACTIONS(5625),
    [anon_sym_LT_LT] = ACTIONS(5625),
    [anon_sym_GT_GT] = ACTIONS(5625),
    [anon_sym_SEMI] = ACTIONS(5627),
    [anon_sym___attribute__] = ACTIONS(5625),
    [anon_sym_LBRACE] = ACTIONS(1893),
    [anon_sym_RBRACE] = ACTIONS(5627),
    [anon_sym_LBRACK] = ACTIONS(5627),
    [anon_sym_RBRACK] = ACTIONS(5627),
    [anon_sym_EQ] = ACTIONS(5625),
    [anon_sym_COLON] = ACTIONS(5627),
    [anon_sym_QMARK] = ACTIONS(5627),
    [anon_sym_STAR_EQ] = ACTIONS(5627),
    [anon_sym_SLASH_EQ] = ACTIONS(5627),
    [anon_sym_PERCENT_EQ] = ACTIONS(5627),
    [anon_sym_PLUS_EQ] = ACTIONS(5627),
    [anon_sym_DASH_EQ] = ACTIONS(5627),
    [anon_sym_LT_LT_EQ] = ACTIONS(5627),
    [anon_sym_GT_GT_EQ] = ACTIONS(5627),
    [anon_sym_AMP_EQ] = ACTIONS(5627),
    [anon_sym_CARET_EQ] = ACTIONS(5627),
    [anon_sym_PIPE_EQ] = ACTIONS(5627),
    [anon_sym_and_eq] = ACTIONS(5625),
    [anon_sym_or_eq] = ACTIONS(5625),
    [anon_sym_xor_eq] = ACTIONS(5625),
    [anon_sym_LT_EQ_GT] = ACTIONS(5627),
    [anon_sym_or] = ACTIONS(5625),
    [anon_sym_and] = ACTIONS(5625),
    [anon_sym_bitor] = ACTIONS(5625),
    [anon_sym_xor] = ACTIONS(5625),
    [anon_sym_bitand] = ACTIONS(5625),
    [anon_sym_not_eq] = ACTIONS(5625),
    [anon_sym_DASH_DASH] = ACTIONS(5627),
    [anon_sym_PLUS_PLUS] = ACTIONS(5627),
    [anon_sym_DOT] = ACTIONS(5625),
    [anon_sym_DOT_STAR] = ACTIONS(5627),
    [anon_sym_DASH_GT] = ACTIONS(5627),
    [sym_comment] = ACTIONS(3),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4582), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(4584), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4577), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [73] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4906), 1,
      anon_sym___attribute__,
    ACTIONS(5297), 1,
      anon_sym_LBRACE,
    ACTIONS(5633), 1,
      anon_sym_COLON,
    STATE(2252), 1,
      sym__enum_base_clause,
    STATE(2261), 1,
      sym_enumerator_list,
    STATE(2369), 1,
      sym_attribute_specifier,
    ACTIONS(5629), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5631), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [156] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2414), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5635), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5420), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5418), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
  [231] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2413), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5637), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5410), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5408), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
  [306] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5639), 1,
      sym_identifier,
    STATE(2399), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(5642), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(5645), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(4792), 23,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(4790), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [385] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5650), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5648), 57,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_friend,
      anon_sym_using,
      anon_sym_concept,
      anon_sym_requires,
  [456] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4833), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(4835), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [527] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5654), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5652), 57,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_friend,
      anon_sym_using,
      anon_sym_concept,
      anon_sym_requires,
  [598] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4920), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4918), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [669] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4829), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(4831), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [740] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5656), 1,
      sym_identifier,
    STATE(2427), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(4040), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(4042), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(4779), 23,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(4777), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [819] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2425), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5658), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4924), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4926), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
  [894] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4829), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(4831), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [965] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4922), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4920), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4918), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [1038] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4833), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(4835), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [1109] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1782), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5660), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5406), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5404), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
  [1184] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4810), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(4812), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [1255] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4816), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(4818), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [1326] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1782), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5660), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5450), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5448), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
  [1401] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1782), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5660), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5426), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5424), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
  [1476] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4582), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5662), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5664), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [1549] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4816), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(4818), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [1620] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5103), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5101), 50,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [1691] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5189), 1,
      anon_sym_LT,
    STATE(2415), 1,
      sym_template_argument_list,
    ACTIONS(5666), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5668), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [1768] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5670), 1,
      sym_literal_suffix,
    STATE(2291), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(5382), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(5384), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(3761), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(3769), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
  [1847] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4810), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(4812), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [1918] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4922), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4942), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4940), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [1991] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4922), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4920), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4918), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [2064] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2425), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5658), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5105), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5107), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
  [2139] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5189), 1,
      anon_sym_LT,
    STATE(2415), 1,
      sym_template_argument_list,
    ACTIONS(5672), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5674), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [2216] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1782), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5660), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5369), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5367), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
  [2291] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2431), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4766), 4,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
    ACTIONS(5676), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5139), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(5142), 29,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_auto,
      anon_sym_decltype,
  [2368] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5679), 1,
      sym_identifier,
    STATE(2399), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(4040), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(4042), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(4785), 23,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(4783), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [2447] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5214), 1,
      anon_sym_LBRACK,
    STATE(2439), 1,
      sym_new_declarator,
    ACTIONS(5681), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5683), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [2522] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2385), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5613), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4924), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(4926), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [2597] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5670), 1,
      sym_literal_suffix,
    STATE(2291), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(5382), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(5384), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5199), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(5197), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
  [2676] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2431), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5676), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4768), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(4766), 33,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [2751] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5687), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5685), 57,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_friend,
      anon_sym_using,
      anon_sym_concept,
      anon_sym_requires,
  [2822] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4930), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4928), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [2893] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4906), 1,
      anon_sym___attribute__,
    ACTIONS(5297), 1,
      anon_sym_LBRACE,
    ACTIONS(5633), 1,
      anon_sym_COLON,
    STATE(2088), 1,
      sym__enum_base_clause,
    STATE(2281), 1,
      sym_enumerator_list,
    STATE(2358), 1,
      sym_attribute_specifier,
    ACTIONS(5689), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5691), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [2976] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5693), 1,
      sym_identifier,
    STATE(2566), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2729), 1,
      sym_primitive_type,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(5696), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4934), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4936), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [3056] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4829), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(4831), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [3126] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5698), 26,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(5700), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [3208] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(3803), 1,
      anon_sym_LPAREN2,
    ACTIONS(5511), 1,
      sym_identifier,
    ACTIONS(5521), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5523), 1,
      anon_sym_LBRACK,
    ACTIONS(5708), 1,
      anon_sym_STAR,
    ACTIONS(5710), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5712), 1,
      anon_sym_AMP,
    STATE(3830), 1,
      sym_parameter_list,
    STATE(4186), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5695), 1,
      sym__scope_resolution,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6150), 1,
      sym__declarator,
    STATE(6465), 1,
      sym__abstract_declarator,
    STATE(7771), 1,
      sym_ms_based_modifier,
    ACTIONS(2921), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(5513), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(2469), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3013), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2919), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [3330] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5714), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5716), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [3400] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(5718), 26,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(5720), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
  [3484] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(5724), 26,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(5726), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
  [3568] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5573), 1,
      anon_sym___attribute__,
    ACTIONS(5728), 1,
      anon_sym_LBRACE,
    STATE(1984), 1,
      sym_attribute_specifier,
    STATE(2594), 1,
      sym_enumerator_list,
    ACTIONS(5350), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5352), 48,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [3646] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4810), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(4812), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [3716] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4833), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(4835), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [3786] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4816), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(4818), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [3856] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3646), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(3648), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [3926] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5734), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(5730), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5732), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [3998] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5736), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5738), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4068] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5736), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5738), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4138] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(3803), 1,
      anon_sym_LPAREN2,
    ACTIONS(5511), 1,
      sym_identifier,
    ACTIONS(5521), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5523), 1,
      anon_sym_LBRACK,
    ACTIONS(5740), 1,
      anon_sym_STAR,
    ACTIONS(5742), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5744), 1,
      anon_sym_AMP,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(4186), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5695), 1,
      sym__scope_resolution,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6167), 1,
      sym__declarator,
    STATE(6435), 1,
      sym__abstract_declarator,
    STATE(7771), 1,
      sym_ms_based_modifier,
    ACTIONS(2921), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(5555), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(2985), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4100), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(2919), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [4260] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5746), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5748), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4330] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5754), 1,
      anon_sym_LT,
    STATE(2395), 1,
      sym_template_argument_list,
    ACTIONS(5750), 26,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5752), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4404] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5736), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5738), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4474] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(3803), 1,
      anon_sym_LPAREN2,
    ACTIONS(5511), 1,
      sym_identifier,
    ACTIONS(5521), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5523), 1,
      anon_sym_LBRACK,
    ACTIONS(5740), 1,
      anon_sym_STAR,
    ACTIONS(5742), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5744), 1,
      anon_sym_AMP,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(4186), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5695), 1,
      sym__scope_resolution,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6150), 1,
      sym__declarator,
    STATE(6481), 1,
      sym__abstract_declarator,
    STATE(7771), 1,
      sym_ms_based_modifier,
    ACTIONS(2921), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(5513), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(2450), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3033), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2919), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [4596] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5757), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5759), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4666] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4816), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(4818), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [4736] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    STATE(1741), 1,
      sym_template_argument_list,
    STATE(2595), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5761), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5303), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5305), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [4814] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5763), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5765), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4884] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3650), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(3652), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4954] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4829), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(4831), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [5024] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4833), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(4835), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [5094] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(5767), 26,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(5769), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
  [5178] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(5771), 26,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(5773), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
  [5262] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(5775), 26,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(5777), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
  [5346] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4810), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(4812), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [5416] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4829), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(4831), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [5486] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5779), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5781), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [5556] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4810), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(4812), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [5626] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(3803), 1,
      anon_sym_LPAREN2,
    ACTIONS(5511), 1,
      sym_identifier,
    ACTIONS(5521), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5523), 1,
      anon_sym_LBRACK,
    ACTIONS(5708), 1,
      anon_sym_STAR,
    ACTIONS(5710), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5712), 1,
      anon_sym_AMP,
    STATE(3830), 1,
      sym_parameter_list,
    STATE(4186), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5695), 1,
      sym__scope_resolution,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6167), 1,
      sym__declarator,
    STATE(6470), 1,
      sym__abstract_declarator,
    STATE(7771), 1,
      sym_ms_based_modifier,
    ACTIONS(2921), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(5555), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(3031), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4100), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(2919), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [5748] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4833), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(4835), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [5818] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5783), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5785), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [5888] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5787), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5789), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [5958] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4855), 1,
      anon_sym_virtual,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(5795), 1,
      sym_auto,
    ACTIONS(5797), 1,
      anon_sym_decltype,
    STATE(2655), 1,
      sym_decltype_auto,
    ACTIONS(4845), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    STATE(2610), 9,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      sym_virtual,
      sym_alignas_specifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(5793), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5791), 12,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_template,
      anon_sym_operator,
    ACTIONS(4843), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [6050] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5799), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5801), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [6120] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5101), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5103), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [6190] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5573), 1,
      anon_sym___attribute__,
    ACTIONS(5728), 1,
      anon_sym_LBRACE,
    STATE(1960), 1,
      sym_attribute_specifier,
    STATE(2512), 1,
      sym_enumerator_list,
    ACTIONS(5293), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5295), 48,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [6268] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5803), 1,
      sym_identifier,
    STATE(2523), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2768), 1,
      sym_primitive_type,
    ACTIONS(5807), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(5805), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4936), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(4934), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [6348] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4910), 1,
      anon_sym_COLON,
    ACTIONS(5809), 1,
      anon_sym___attribute__,
    ACTIONS(5811), 1,
      anon_sym_LBRACE,
    STATE(2838), 1,
      sym_field_declaration_list,
    STATE(3001), 1,
      sym_attribute_specifier,
    STATE(6668), 1,
      sym_virtual_specifier,
    STATE(7564), 1,
      sym_base_class_clause,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(4902), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4904), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [6434] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5813), 26,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(5815), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [6516] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4855), 1,
      anon_sym_virtual,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(5795), 1,
      sym_auto,
    ACTIONS(5797), 1,
      anon_sym_decltype,
    STATE(2655), 1,
      sym_decltype_auto,
    ACTIONS(4845), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    STATE(2611), 9,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      sym_virtual,
      sym_alignas_specifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(5819), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5817), 12,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_template,
      anon_sym_operator,
    ACTIONS(4843), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [6608] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4816), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(4818), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [6678] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5821), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5823), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [6747] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(3803), 1,
      anon_sym_LPAREN2,
    ACTIONS(3805), 1,
      anon_sym_STAR,
    ACTIONS(3807), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3809), 1,
      anon_sym_AMP,
    ACTIONS(4841), 1,
      sym_identifier,
    ACTIONS(5523), 1,
      anon_sym_LBRACK,
    ACTIONS(5555), 1,
      anon_sym_RPAREN,
    ACTIONS(5825), 1,
      anon_sym_COLON_COLON,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(4186), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5610), 1,
      sym__scope_resolution,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6284), 1,
      sym__declarator,
    STATE(6435), 1,
      sym__abstract_declarator,
    STATE(8318), 1,
      sym_ms_based_modifier,
    ACTIONS(2921), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3185), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4100), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(2919), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [6868] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5827), 1,
      anon_sym_LT,
    STATE(2595), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2688), 1,
      sym_template_argument_list,
    ACTIONS(5761), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3759), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3767), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [6947] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4719), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4721), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [7016] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4723), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4725), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [7085] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4727), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4729), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [7154] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4543), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4536), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [7223] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5297), 1,
      anon_sym_LBRACE,
    ACTIONS(5829), 1,
      anon_sym___attribute__,
    ACTIONS(5831), 1,
      anon_sym_COLON,
    STATE(2252), 1,
      sym__enum_base_clause,
    STATE(2261), 1,
      sym_enumerator_list,
    STATE(2369), 1,
      sym_attribute_specifier,
    ACTIONS(5629), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5631), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
  [7304] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4543), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4536), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [7373] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4543), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4536), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [7442] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4543), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4536), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [7511] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5266), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5264), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [7580] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4543), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4536), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [7649] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4810), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(4812), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [7718] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4543), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4536), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [7787] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5621), 1,
      sym_literal_suffix,
    STATE(2405), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(4040), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(4042), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(3769), 22,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3761), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [7864] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5621), 1,
      sym_literal_suffix,
    STATE(2405), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(4040), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(4042), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5197), 22,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5199), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [7941] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5833), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5835), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [8010] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5837), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5839), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [8079] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4833), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(4835), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [8148] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5841), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5843), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [8217] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5845), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5847), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [8286] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5849), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5851), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [8355] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5853), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5855), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [8424] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4691), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4693), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [8493] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4691), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4693), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [8562] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4691), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4693), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [8631] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4715), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4717), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [8700] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5573), 1,
      anon_sym___attribute__,
    STATE(1982), 1,
      sym_attribute_specifier,
    ACTIONS(5363), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5365), 49,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [8773] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5857), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5859), 1,
      anon_sym_and,
    ACTIONS(5477), 26,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5479), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [8846] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5573), 1,
      anon_sym___attribute__,
    STATE(1986), 1,
      sym_attribute_specifier,
    ACTIONS(5414), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5416), 49,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [8919] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4739), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4741), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [8988] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4711), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4713), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [9057] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2592), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5861), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5420), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5418), 44,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [9130] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5863), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5865), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [9199] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5867), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5869), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [9268] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2591), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5871), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5410), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5408), 44,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [9341] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5873), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5875), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [9410] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5877), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5879), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [9479] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5881), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5883), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [9548] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5573), 1,
      anon_sym___attribute__,
    STATE(1954), 1,
      sym_attribute_specifier,
    ACTIONS(5456), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5458), 49,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [9621] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2555), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4766), 4,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
    ACTIONS(5885), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5142), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5139), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [9696] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5888), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5890), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [9765] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5892), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5894), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [9834] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5837), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5839), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [9903] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5896), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5898), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [9972] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5573), 1,
      anon_sym___attribute__,
    STATE(1981), 1,
      sym_attribute_specifier,
    ACTIONS(5489), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5491), 49,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [10045] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4829), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(4831), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [10114] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5573), 1,
      anon_sym___attribute__,
    STATE(1980), 1,
      sym_attribute_specifier,
    ACTIONS(5499), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5501), 49,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [10187] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5573), 1,
      anon_sym___attribute__,
    STATE(1959), 1,
      sym_attribute_specifier,
    ACTIONS(5452), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5454), 49,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [10260] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5573), 1,
      anon_sym___attribute__,
    STATE(1965), 1,
      sym_attribute_specifier,
    ACTIONS(5400), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5402), 49,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [10333] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5573), 1,
      anon_sym___attribute__,
    STATE(1968), 1,
      sym_attribute_specifier,
    ACTIONS(5386), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5388), 49,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [10406] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(3803), 1,
      anon_sym_LPAREN2,
    ACTIONS(3805), 1,
      anon_sym_STAR,
    ACTIONS(3807), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3809), 1,
      anon_sym_AMP,
    ACTIONS(4841), 1,
      sym_identifier,
    ACTIONS(5513), 1,
      anon_sym_RPAREN,
    ACTIONS(5523), 1,
      anon_sym_LBRACK,
    ACTIONS(5825), 1,
      anon_sym_COLON_COLON,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(4186), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5610), 1,
      sym__scope_resolution,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6279), 1,
      sym__declarator,
    STATE(6481), 1,
      sym__abstract_declarator,
    STATE(8318), 1,
      sym_ms_based_modifier,
    ACTIONS(2921), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(2483), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3181), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2919), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [10527] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2306), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5900), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5369), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5367), 44,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [10600] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1957), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(1955), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [10669] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2306), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5900), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5406), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5404), 44,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [10742] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5902), 1,
      anon_sym_LT,
    STATE(2626), 1,
      sym_template_argument_list,
    ACTIONS(4541), 27,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_number_literal_token1,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(4534), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      aux_sym_number_literal_token2,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [10817] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5904), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5906), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [10886] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5908), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5910), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [10955] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5912), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5914), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [11024] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5916), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5918), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [11093] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5920), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5922), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [11162] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4808), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2743), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [11231] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2535), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5924), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5105), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5107), 44,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [11304] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4910), 1,
      anon_sym_COLON,
    ACTIONS(5926), 1,
      anon_sym___attribute__,
    ACTIONS(5928), 1,
      anon_sym_LBRACE,
    STATE(2761), 1,
      sym_field_declaration_list,
    STATE(2948), 1,
      sym_attribute_specifier,
    STATE(6712), 1,
      sym_virtual_specifier,
    STATE(7563), 1,
      sym_base_class_clause,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(4902), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(4904), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      anon_sym_requires,
  [11389] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5930), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5932), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [11458] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5934), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5936), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [11527] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5938), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5940), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [11596] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4707), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4709), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [11665] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5942), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5944), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [11734] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5946), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5948), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [11803] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5730), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5732), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [11872] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5950), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5952), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [11941] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2555), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5885), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4768), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
    ACTIONS(4766), 29,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [12014] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5902), 1,
      anon_sym_LT,
    STATE(2626), 1,
      sym_template_argument_list,
    ACTIONS(3785), 27,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_number_literal_token1,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5187), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      aux_sym_number_literal_token2,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [12089] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5297), 1,
      anon_sym_LBRACE,
    ACTIONS(5829), 1,
      anon_sym___attribute__,
    ACTIONS(5831), 1,
      anon_sym_COLON,
    STATE(2088), 1,
      sym__enum_base_clause,
    STATE(2281), 1,
      sym_enumerator_list,
    STATE(2358), 1,
      sym_attribute_specifier,
    ACTIONS(5689), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5691), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
  [12170] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5954), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5956), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [12239] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5958), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5960), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [12308] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5962), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5964), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [12377] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4910), 1,
      anon_sym_COLON,
    ACTIONS(5966), 1,
      anon_sym___attribute__,
    ACTIONS(5968), 1,
      anon_sym_LBRACE,
    STATE(2970), 1,
      sym_field_declaration_list,
    STATE(3097), 1,
      sym_attribute_specifier,
    STATE(6836), 1,
      sym_virtual_specifier,
    STATE(7542), 1,
      sym_base_class_clause,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(4902), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4904), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [12462] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5970), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5972), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [12531] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5974), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5976), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [12600] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4816), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(4818), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [12669] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5978), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5980), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [12738] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2026), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4766), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(5247), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5139), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5142), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [12813] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5982), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5984), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [12882] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4703), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4705), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [12951] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    STATE(1741), 1,
      sym_template_argument_list,
    STATE(2636), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5986), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5303), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5305), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [13028] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3568), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(3564), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [13097] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4699), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4701), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [13166] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1961), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(1959), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [13235] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5988), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5990), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [13304] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5992), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5994), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [13373] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5573), 1,
      anon_sym___attribute__,
    STATE(1945), 1,
      sym_attribute_specifier,
    ACTIONS(5481), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5483), 49,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [13446] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5996), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5998), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [13515] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6000), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6002), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [13584] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5573), 1,
      anon_sym___attribute__,
    STATE(1947), 1,
      sym_attribute_specifier,
    ACTIONS(5473), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5475), 49,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [13657] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6004), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6006), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [13726] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6008), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6010), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [13795] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6012), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6014), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [13864] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6016), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6018), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [13933] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6020), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6022), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [14002] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5573), 1,
      anon_sym___attribute__,
    STATE(1939), 1,
      sym_attribute_specifier,
    ACTIONS(5493), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5495), 49,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [14075] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4735), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4737), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [14144] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6024), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6026), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [14213] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4731), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4733), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [14282] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4695), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4697), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [14351] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5857), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5859), 1,
      anon_sym_and,
    ACTIONS(6028), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6030), 1,
      anon_sym_or,
    ACTIONS(5428), 25,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5430), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [14428] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6032), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6034), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [14497] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2306), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5900), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5450), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5448), 44,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [14570] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2306), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5900), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5426), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5424), 44,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [14643] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6036), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6038), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [14712] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5573), 1,
      anon_sym___attribute__,
    STATE(1944), 1,
      sym_attribute_specifier,
    ACTIONS(5485), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5487), 49,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [14785] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2327), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6040), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5406), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5404), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [14857] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    STATE(2665), 1,
      sym_attribute_specifier,
    STATE(3111), 1,
      sym_field_declaration_list,
    STATE(6691), 1,
      sym_virtual_specifier,
    STATE(7390), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(4904), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4902), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [14941] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5101), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5103), 48,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [15009] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4810), 24,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(4812), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [15077] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6046), 1,
      anon_sym_LT,
    STATE(2636), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2719), 1,
      sym_template_argument_list,
    ACTIONS(5986), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3759), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3767), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [15155] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6048), 1,
      sym_identifier,
    STATE(2619), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(3204), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(3208), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(4785), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(4783), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [15231] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5827), 1,
      anon_sym_LT,
    STATE(2688), 1,
      sym_template_argument_list,
    ACTIONS(5187), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3785), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [15305] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4869), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4867), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [15373] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4829), 24,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(4831), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [15441] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4816), 24,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(4818), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [15509] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2327), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6040), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5369), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5367), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [15581] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2327), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6040), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5450), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5448), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [15653] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2327), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6040), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5426), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5424), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [15725] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6050), 1,
      anon_sym_LT,
    STATE(2688), 1,
      sym_template_argument_list,
    ACTIONS(4534), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4541), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [15799] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4833), 24,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(4835), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [15867] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4855), 1,
      anon_sym_virtual,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(4845), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    STATE(2616), 9,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      sym_virtual,
      sym_alignas_specifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(6055), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4843), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
    ACTIONS(6053), 13,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [15951] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4855), 1,
      anon_sym_virtual,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(4845), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    STATE(2616), 9,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      sym_virtual,
      sym_alignas_specifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(6059), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4843), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
    ACTIONS(6057), 13,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [16035] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2535), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5924), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4924), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(4926), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [16107] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2605), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6061), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5105), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5107), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [16179] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5795), 1,
      sym_auto,
    ACTIONS(5797), 1,
      anon_sym_decltype,
    STATE(2655), 1,
      sym_decltype_auto,
    ACTIONS(4873), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4871), 44,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [16253] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2607), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6063), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5420), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5418), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [16325] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6075), 1,
      anon_sym___attribute__,
    ACTIONS(6078), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6081), 1,
      anon_sym___declspec,
    ACTIONS(6084), 1,
      anon_sym_virtual,
    ACTIONS(6087), 1,
      anon_sym_alignas,
    ACTIONS(6072), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    STATE(2616), 9,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      sym_virtual,
      sym_alignas_specifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(6067), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6065), 13,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
    ACTIONS(6069), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [16409] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6090), 1,
      sym_identifier,
    STATE(2600), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(3204), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(3208), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(4779), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(4777), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [16485] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4922), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4926), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4924), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [16555] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6092), 1,
      sym_identifier,
    STATE(2619), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(6095), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(6098), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(4792), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(4790), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [16631] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2606), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6101), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5410), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5408), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [16703] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6103), 1,
      anon_sym_LT,
    STATE(1741), 1,
      sym_template_argument_list,
    STATE(2716), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3787), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5305), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5303), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [16781] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4561), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_number_literal_token1,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(4559), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      aux_sym_number_literal_token2,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [16848] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5131), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5129), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [16915] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2638), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6105), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5410), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5408), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [16986] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5107), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5105), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [17053] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4582), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_number_literal_token1,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(4575), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      aux_sym_number_literal_token2,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [17120] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5032), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5030), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [17187] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5147), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5145), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [17254] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4926), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4924), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [17321] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3194), 1,
      anon_sym_LBRACE,
    ACTIONS(6107), 1,
      anon_sym_LPAREN2,
    STATE(2526), 1,
      sym_argument_list,
    STATE(2728), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3942), 1,
      sym_initializer_list,
    ACTIONS(6110), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4926), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
    ACTIONS(4924), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [17400] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2605), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6061), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4924), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4926), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [17471] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5052), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5050), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [17538] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5044), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5042), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [17605] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5052), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5050), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [17672] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2431), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6112), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5369), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5367), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [17743] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2431), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6112), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5406), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5404), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [17814] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5060), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5058), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [17881] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2431), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6112), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5450), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5448), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [17952] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2562), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_number_literal_token1,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(2557), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      aux_sym_number_literal_token2,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [18019] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5056), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5054), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [18086] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6116), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_number_literal_token1,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(6114), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      aux_sym_number_literal_token2,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [18153] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6120), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_number_literal_token1,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(6118), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      aux_sym_number_literal_token2,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [18220] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1729), 1,
      sym_string_literal,
    ACTIONS(6126), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(6124), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6122), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [18291] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4565), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_number_literal_token1,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(4563), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      aux_sym_number_literal_token2,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [18358] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6130), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_number_literal_token1,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(6128), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      aux_sym_number_literal_token2,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [18425] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6134), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_number_literal_token1,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(6132), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      aux_sym_number_literal_token2,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [18492] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4569), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_number_literal_token1,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(4567), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      aux_sym_number_literal_token2,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [18559] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1731), 1,
      sym_string_literal,
    ACTIONS(6126), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(6124), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6122), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [18630] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5099), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5097), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [18697] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4573), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_number_literal_token1,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(4571), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      aux_sym_number_literal_token2,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [18764] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5158), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5156), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [18831] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5068), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5066), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [18898] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5123), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5121), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [18965] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5162), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5160), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [19032] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5185), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5183), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [19099] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5127), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5125), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [19166] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5154), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5152), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [19233] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5119), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5117), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [19300] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4910), 1,
      anon_sym_COLON,
    ACTIONS(6136), 1,
      anon_sym___attribute__,
    ACTIONS(6138), 1,
      anon_sym_LBRACE,
    STATE(3116), 1,
      sym_field_declaration_list,
    STATE(3463), 1,
      sym_attribute_specifier,
    STATE(6603), 1,
      sym_virtual_specifier,
    STATE(7342), 1,
      sym_base_class_clause,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(4902), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4904), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [19383] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2673), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6140), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5420), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5418), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [19454] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4810), 23,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(4812), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [19521] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1732), 1,
      sym_string_literal,
    ACTIONS(6126), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(6124), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6122), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [19592] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5166), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5164), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [19659] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6144), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_number_literal_token1,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(6142), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      aux_sym_number_literal_token2,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [19726] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5040), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5038), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [19793] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4557), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_number_literal_token1,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(4555), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      aux_sym_number_literal_token2,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [19860] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5111), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5109), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [19927] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5095), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5093), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [19994] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5087), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5085), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [20061] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5115), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5113), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [20128] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4922), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4920), 27,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_number_literal_token1,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(4918), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      aux_sym_number_literal_token2,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [20197] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4922), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4920), 27,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_number_literal_token1,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(4918), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      aux_sym_number_literal_token2,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [20266] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2431), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6112), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5426), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5424), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [20337] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4553), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_number_literal_token1,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(4551), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      aux_sym_number_literal_token2,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [20404] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4920), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_number_literal_token1,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(4918), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      aux_sym_number_literal_token2,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [20471] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5091), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5089), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [20538] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5048), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5046), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [20605] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4829), 23,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(4831), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [20672] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6046), 1,
      anon_sym_LT,
    STATE(2719), 1,
      sym_template_argument_list,
    ACTIONS(5187), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3785), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [20745] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5072), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5070), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [20812] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4532), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_number_literal_token1,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(4530), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      aux_sym_number_literal_token2,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [20879] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5036), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5034), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [20946] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4922), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4942), 27,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_number_literal_token1,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(4940), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      aux_sym_number_literal_token2,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [21015] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5170), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5168), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [21082] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5809), 1,
      anon_sym___attribute__,
    ACTIONS(6146), 1,
      anon_sym_LBRACE,
    ACTIONS(6148), 1,
      anon_sym_COLON,
    STATE(2814), 1,
      sym__enum_base_clause,
    STATE(2840), 1,
      sym_enumerator_list,
    STATE(2994), 1,
      sym_attribute_specifier,
    ACTIONS(5629), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5631), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [21161] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5101), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5103), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [21228] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5137), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5135), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [21295] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4575), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4582), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [21362] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6150), 1,
      anon_sym_LT,
    STATE(2719), 1,
      sym_template_argument_list,
    ACTIONS(4534), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4541), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [21435] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5174), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5172), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [21502] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5080), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5078), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [21569] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4922), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4940), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4942), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [21638] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5809), 1,
      anon_sym___attribute__,
    ACTIONS(6146), 1,
      anon_sym_LBRACE,
    ACTIONS(6148), 1,
      anon_sym_COLON,
    STATE(2785), 1,
      sym__enum_base_clause,
    STATE(2834), 1,
      sym_enumerator_list,
    STATE(3010), 1,
      sym_attribute_specifier,
    ACTIONS(5689), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5691), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [21717] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    STATE(1741), 1,
      sym_template_argument_list,
    STATE(2780), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6153), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5303), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5305), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [21792] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5052), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5050), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [21859] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4928), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4930), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [21926] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5181), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5179), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [21993] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4930), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_number_literal_token1,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(4928), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      aux_sym_number_literal_token2,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [22060] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4922), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4918), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4920), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [22129] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2512), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_number_literal_token1,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(2507), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      aux_sym_number_literal_token2,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [22196] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4922), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4918), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4920), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [22265] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2635), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6155), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5105), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5107), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [22336] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5064), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5062), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [22403] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4816), 23,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(4818), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [22470] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5123), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5121), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [22537] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4833), 23,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(4835), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [22604] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1730), 1,
      sym_string_literal,
    ACTIONS(6126), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(6124), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6122), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [22675] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4922), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4918), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(4920), 44,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [22743] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4571), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(4573), 45,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [22809] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5926), 1,
      anon_sym___attribute__,
    ACTIONS(6157), 1,
      anon_sym_LBRACE,
    STATE(2779), 1,
      sym_enumerator_list,
    STATE(2879), 1,
      sym_attribute_specifier,
    ACTIONS(5293), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5295), 42,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [22883] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4918), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4920), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [22949] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5926), 1,
      anon_sym___attribute__,
    ACTIONS(6157), 1,
      anon_sym_LBRACE,
    STATE(2760), 1,
      sym_enumerator_list,
    STATE(2934), 1,
      sym_attribute_specifier,
    ACTIONS(5350), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5352), 42,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [23023] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5966), 1,
      anon_sym___attribute__,
    ACTIONS(6159), 1,
      anon_sym_LBRACE,
    ACTIONS(6161), 1,
      anon_sym_COLON,
    STATE(2837), 1,
      sym__enum_base_clause,
    STATE(2946), 1,
      sym_enumerator_list,
    STATE(3085), 1,
      sym_attribute_specifier,
    ACTIONS(5689), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5691), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [23101] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4551), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(4553), 45,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [23167] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1967), 1,
      anon_sym_LBRACE,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6165), 1,
      anon_sym_LBRACK,
    ACTIONS(6167), 1,
      sym_auto,
    ACTIONS(6169), 1,
      anon_sym_decltype,
    STATE(3014), 1,
      sym_decltype_auto,
    STATE(3021), 1,
      sym_new_declarator,
    STATE(3456), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5234), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5236), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [23249] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2723), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6171), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5404), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5406), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [23319] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6034), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_RBRACK_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6032), 32,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
  [23385] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4555), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(4557), 45,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [23451] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4575), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4582), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [23517] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5966), 1,
      anon_sym___attribute__,
    ACTIONS(6159), 1,
      anon_sym_LBRACE,
    ACTIONS(6161), 1,
      anon_sym_COLON,
    STATE(2822), 1,
      sym__enum_base_clause,
    STATE(2885), 1,
      sym_enumerator_list,
    STATE(3148), 1,
      sym_attribute_specifier,
    ACTIONS(5629), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5631), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [23595] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4922), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4918), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(4920), 44,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [23663] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4559), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(4561), 45,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [23729] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2723), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6173), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4768), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4766), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [23799] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4575), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(4582), 45,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [23865] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2723), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6171), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5424), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5426), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [23935] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5835), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_RBRACK_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5833), 32,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
  [24001] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4530), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(4532), 45,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [24067] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2723), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6171), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5367), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5369), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [24137] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2725), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6176), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5418), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5420), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [24207] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2728), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6110), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5107), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5105), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [24277] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1967), 1,
      anon_sym_LBRACE,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6165), 1,
      anon_sym_LBRACK,
    ACTIONS(6167), 1,
      sym_auto,
    ACTIONS(6169), 1,
      anon_sym_decltype,
    STATE(2979), 1,
      sym_new_declarator,
    STATE(3014), 1,
      sym_decltype_auto,
    STATE(3406), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5226), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5228), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [24359] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5883), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_RBRACK_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5881), 32,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
  [24425] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4928), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(4930), 45,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [24491] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1967), 1,
      anon_sym_LBRACE,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6165), 1,
      anon_sym_LBRACK,
    ACTIONS(6167), 1,
      sym_auto,
    ACTIONS(6169), 1,
      anon_sym_decltype,
    STATE(3014), 1,
      sym_decltype_auto,
    STATE(3037), 1,
      sym_new_declarator,
    STATE(3470), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5230), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5232), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [24573] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4928), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4930), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [24639] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4575), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4582), 41,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_DASH_GT_STAR,
  [24705] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2741), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6178), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5408), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5410), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [24775] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1967), 1,
      anon_sym_LBRACE,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6165), 1,
      anon_sym_LBRACK,
    ACTIONS(6167), 1,
      sym_auto,
    ACTIONS(6169), 1,
      anon_sym_decltype,
    STATE(3014), 1,
      sym_decltype_auto,
    STATE(3050), 1,
      sym_new_declarator,
    STATE(3372), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5208), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5210), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [24857] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4922), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4940), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(4942), 44,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [24925] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4563), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(4565), 45,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [24991] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2723), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6171), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5448), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5450), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [25061] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6180), 1,
      anon_sym_LT,
    STATE(2736), 1,
      sym_template_argument_list,
    STATE(2780), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6153), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3759), 15,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3767), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [25137] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4922), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4940), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4942), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [25205] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4922), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4918), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4920), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [25273] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5875), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_RBRACK_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5873), 32,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
  [25339] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4922), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4918), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4920), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [25407] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2635), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6155), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4924), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4926), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [25477] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4567), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(4569), 45,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [25543] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5101), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5103), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [25609] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4855), 1,
      anon_sym_virtual,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(5795), 1,
      sym_auto,
    ACTIONS(5797), 1,
      anon_sym_decltype,
    ACTIONS(6182), 1,
      anon_sym_SEMI,
    STATE(2655), 1,
      sym_decltype_auto,
    ACTIONS(5793), 5,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
    ACTIONS(4845), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    STATE(2610), 9,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      sym_virtual,
      sym_alignas_specifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(5791), 12,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_template,
      anon_sym_operator,
    ACTIONS(4843), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [25698] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6194), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6200), 1,
      anon_sym_not_eq,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6184), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6188), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(6190), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6196), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6186), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6192), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5724), 12,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      sym_identifier,
    ACTIONS(5726), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [25795] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4918), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(4920), 45,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [25860] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2236), 1,
      anon_sym_LBRACE,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6204), 1,
      anon_sym_LBRACK,
    ACTIONS(6206), 1,
      sym_auto,
    ACTIONS(6208), 1,
      anon_sym_decltype,
    STATE(3088), 1,
      sym_decltype_auto,
    STATE(3126), 1,
      sym_new_declarator,
    STATE(3656), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5234), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5236), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [25941] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4855), 1,
      anon_sym_virtual,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(5795), 1,
      sym_auto,
    ACTIONS(5797), 1,
      anon_sym_decltype,
    ACTIONS(6210), 1,
      anon_sym_SEMI,
    STATE(2655), 1,
      sym_decltype_auto,
    ACTIONS(5793), 5,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
    ACTIONS(4845), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    STATE(2610), 9,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      sym_virtual,
      sym_alignas_specifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(5791), 12,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_template,
      anon_sym_operator,
    ACTIONS(4843), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [26030] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5926), 1,
      anon_sym___attribute__,
    STATE(2911), 1,
      sym_attribute_specifier,
    ACTIONS(5473), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5475), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [26099] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4833), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(4835), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [26164] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2236), 1,
      anon_sym_LBRACE,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6204), 1,
      anon_sym_LBRACK,
    ACTIONS(6206), 1,
      sym_auto,
    ACTIONS(6208), 1,
      anon_sym_decltype,
    STATE(3088), 1,
      sym_decltype_auto,
    STATE(3138), 1,
      sym_new_declarator,
    STATE(3564), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5208), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5210), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [26245] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2555), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6212), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5369), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5367), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [26314] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4855), 1,
      anon_sym_virtual,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(5795), 1,
      sym_auto,
    ACTIONS(5797), 1,
      anon_sym_decltype,
    ACTIONS(6214), 1,
      anon_sym_SEMI,
    STATE(2655), 1,
      sym_decltype_auto,
    ACTIONS(5793), 5,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
    ACTIONS(4845), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    STATE(2610), 9,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      sym_virtual,
      sym_alignas_specifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(5791), 12,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_template,
      anon_sym_operator,
    ACTIONS(4843), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [26403] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5926), 1,
      anon_sym___attribute__,
    STATE(2908), 1,
      sym_attribute_specifier,
    ACTIONS(5485), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5487), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [26472] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5926), 1,
      anon_sym___attribute__,
    STATE(2938), 1,
      sym_attribute_specifier,
    ACTIONS(5400), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5402), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [26541] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5926), 1,
      anon_sym___attribute__,
    STATE(2890), 1,
      sym_attribute_specifier,
    ACTIONS(5386), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5388), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [26610] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6194), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6200), 1,
      anon_sym_not_eq,
    ACTIONS(6218), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6222), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6224), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6230), 1,
      anon_sym_QMARK,
    ACTIONS(6232), 1,
      anon_sym_or,
    ACTIONS(6234), 1,
      anon_sym_and,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6184), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6188), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(6190), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6196), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6226), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(6228), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6186), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6192), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6216), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(6220), 15,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [26723] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4565), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4563), 43,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [26788] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2812), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6236), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5410), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5408), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [26857] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6180), 1,
      anon_sym_LT,
    STATE(2736), 1,
      sym_template_argument_list,
    ACTIONS(5187), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3785), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [26928] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4569), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4567), 43,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [26993] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2811), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6238), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5420), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5418), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [27062] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5926), 1,
      anon_sym___attribute__,
    STATE(2956), 1,
      sym_attribute_specifier,
    ACTIONS(5493), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5495), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [27131] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4573), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4571), 43,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [27196] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6194), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6200), 1,
      anon_sym_not_eq,
    ACTIONS(6222), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6224), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6232), 1,
      anon_sym_or,
    ACTIONS(6234), 1,
      anon_sym_and,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6184), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6188), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(6190), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6196), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6226), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(6228), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6186), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6192), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6240), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(6242), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [27305] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5926), 1,
      anon_sym___attribute__,
    STATE(2944), 1,
      sym_attribute_specifier,
    ACTIONS(5489), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5491), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [27374] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6194), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6200), 1,
      anon_sym_not_eq,
    ACTIONS(6218), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6222), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6224), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6230), 1,
      anon_sym_QMARK,
    ACTIONS(6232), 1,
      anon_sym_or,
    ACTIONS(6234), 1,
      anon_sym_and,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6184), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6188), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(6190), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6196), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6226), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(6228), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6186), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6192), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6244), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(6246), 15,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [27487] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2236), 1,
      anon_sym_LBRACE,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6204), 1,
      anon_sym_LBRACK,
    ACTIONS(6206), 1,
      sym_auto,
    ACTIONS(6208), 1,
      anon_sym_decltype,
    STATE(3076), 1,
      sym_new_declarator,
    STATE(3088), 1,
      sym_decltype_auto,
    STATE(3635), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5226), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5228), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [27568] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6194), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6200), 1,
      anon_sym_not_eq,
    ACTIONS(6222), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6224), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6232), 1,
      anon_sym_or,
    ACTIONS(6234), 1,
      anon_sym_and,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6184), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6188), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(6190), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6196), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6226), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(6228), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6186), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6192), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6248), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(6250), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [27677] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6198), 1,
      anon_sym_LT_EQ_GT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6184), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6196), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6186), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5724), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(5726), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [27764] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6194), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_LT_EQ_GT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6184), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6196), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6186), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6192), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5724), 15,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(5726), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [27855] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6194), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6200), 1,
      anon_sym_not_eq,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6184), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6190), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6196), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6186), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6192), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5724), 14,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      sym_identifier,
    ACTIONS(5726), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [27950] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5926), 1,
      anon_sym___attribute__,
    STATE(2937), 1,
      sym_attribute_specifier,
    ACTIONS(5414), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5416), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [28019] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2555), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6212), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5406), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5404), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [28088] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4532), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4530), 43,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [28153] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4855), 1,
      anon_sym_virtual,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(5795), 1,
      sym_auto,
    ACTIONS(5797), 1,
      anon_sym_decltype,
    ACTIONS(6252), 1,
      anon_sym_SEMI,
    STATE(2655), 1,
      sym_decltype_auto,
    ACTIONS(5793), 5,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
    ACTIONS(4845), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    STATE(2610), 9,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      sym_virtual,
      sym_alignas_specifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(5791), 12,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_template,
      anon_sym_operator,
    ACTIONS(4843), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [28242] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5926), 1,
      anon_sym___attribute__,
    STATE(2896), 1,
      sym_attribute_specifier,
    ACTIONS(5481), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5483), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [28311] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4829), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(4831), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [28376] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5809), 1,
      anon_sym___attribute__,
    ACTIONS(6146), 1,
      anon_sym_LBRACE,
    STATE(2848), 1,
      sym_enumerator_list,
    STATE(3020), 1,
      sym_attribute_specifier,
    ACTIONS(5293), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5295), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [28449] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4918), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4920), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [28514] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6194), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6200), 1,
      anon_sym_not_eq,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6184), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6188), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(6190), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6196), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6228), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6186), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6192), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5724), 10,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      sym_identifier,
    ACTIONS(5726), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [28613] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6194), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6200), 1,
      anon_sym_not_eq,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6184), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6188), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(6190), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6196), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6226), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(6228), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6186), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6192), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5724), 8,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
    ACTIONS(5726), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [28714] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6194), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6200), 1,
      anon_sym_not_eq,
    ACTIONS(6224), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6234), 1,
      anon_sym_and,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6184), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6188), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(6190), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6196), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6226), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(6228), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6186), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6192), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5724), 7,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      sym_identifier,
    ACTIONS(5726), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [28819] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4855), 1,
      anon_sym_virtual,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(5795), 1,
      sym_auto,
    ACTIONS(5797), 1,
      anon_sym_decltype,
    ACTIONS(6254), 1,
      anon_sym_SEMI,
    STATE(2655), 1,
      sym_decltype_auto,
    ACTIONS(5793), 5,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
    ACTIONS(4845), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    STATE(2610), 9,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      sym_virtual,
      sym_alignas_specifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(5791), 12,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_template,
      anon_sym_operator,
    ACTIONS(4843), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [28908] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6194), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6200), 1,
      anon_sym_not_eq,
    ACTIONS(6218), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6222), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6224), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6230), 1,
      anon_sym_QMARK,
    ACTIONS(6232), 1,
      anon_sym_or,
    ACTIONS(6234), 1,
      anon_sym_and,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6184), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6188), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(6190), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6196), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6226), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(6228), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6186), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6192), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5934), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(5936), 15,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [29021] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6194), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6200), 1,
      anon_sym_not_eq,
    ACTIONS(6222), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6224), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6232), 1,
      anon_sym_or,
    ACTIONS(6234), 1,
      anon_sym_and,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6184), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6188), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(6190), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6196), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6226), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(6228), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6186), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6192), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6256), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(6258), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [29130] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4816), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(4818), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [29195] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4855), 1,
      anon_sym_virtual,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(5795), 1,
      sym_auto,
    ACTIONS(5797), 1,
      anon_sym_decltype,
    ACTIONS(6260), 1,
      anon_sym_SEMI,
    STATE(2655), 1,
      sym_decltype_auto,
    ACTIONS(5793), 5,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
    ACTIONS(4845), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    STATE(2610), 9,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      sym_virtual,
      sym_alignas_specifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(5791), 12,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_template,
      anon_sym_operator,
    ACTIONS(4843), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [29284] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4553), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4551), 43,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [29349] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2236), 1,
      anon_sym_LBRACE,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6204), 1,
      anon_sym_LBRACK,
    ACTIONS(6206), 1,
      sym_auto,
    ACTIONS(6208), 1,
      anon_sym_decltype,
    STATE(3088), 1,
      sym_decltype_auto,
    STATE(3188), 1,
      sym_new_declarator,
    STATE(3632), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5230), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5232), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [29430] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5926), 1,
      anon_sym___attribute__,
    STATE(2953), 1,
      sym_attribute_specifier,
    ACTIONS(5499), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5501), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [29499] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4810), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(4812), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [29564] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4557), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4555), 43,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [29629] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4561), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4559), 43,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [29694] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5926), 1,
      anon_sym___attribute__,
    STATE(2939), 1,
      sym_attribute_specifier,
    ACTIONS(5456), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5458), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [29763] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6262), 1,
      anon_sym_LT,
    STATE(2736), 1,
      sym_template_argument_list,
    ACTIONS(4534), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4541), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [29834] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5926), 1,
      anon_sym___attribute__,
    STATE(2959), 1,
      sym_attribute_specifier,
    ACTIONS(5452), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5454), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [29903] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4855), 1,
      anon_sym_virtual,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(5795), 1,
      sym_auto,
    ACTIONS(5797), 1,
      anon_sym_decltype,
    ACTIONS(6265), 1,
      anon_sym_SEMI,
    STATE(2655), 1,
      sym_decltype_auto,
    ACTIONS(5793), 5,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
    ACTIONS(4845), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    STATE(2610), 9,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      sym_virtual,
      sym_alignas_specifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(5791), 12,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_template,
      anon_sym_operator,
    ACTIONS(4843), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [29992] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2728), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6110), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4926), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4924), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [30061] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2758), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6267), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5105), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5107), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [30130] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6194), 1,
      anon_sym_GT_EQ,
    ACTIONS(6198), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6200), 1,
      anon_sym_not_eq,
    ACTIONS(6222), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6224), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6232), 1,
      anon_sym_or,
    ACTIONS(6234), 1,
      anon_sym_and,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6184), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6188), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(6190), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6196), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6226), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(6228), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6186), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6192), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6269), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(6271), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [30239] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6186), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5724), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(5726), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
  [30320] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6184), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6186), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5724), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(5726), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
  [30403] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6184), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6196), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6186), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5724), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(5726), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
  [30488] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2555), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6212), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5426), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5424), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [30557] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2555), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6212), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5450), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5448), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [30626] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5926), 1,
      anon_sym___attribute__,
    STATE(2899), 1,
      sym_attribute_specifier,
    ACTIONS(5363), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5365), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [30695] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5809), 1,
      anon_sym___attribute__,
    ACTIONS(6146), 1,
      anon_sym_LBRACE,
    STATE(2847), 1,
      sym_enumerator_list,
    STATE(2991), 1,
      sym_attribute_specifier,
    ACTIONS(5350), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5352), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [30768] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5076), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5074), 44,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_template,
      anon_sym_operator,
  [30833] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6275), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6273), 43,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_template,
      anon_sym_operator,
  [30897] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2758), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6267), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4924), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4926), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [30965] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5030), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5032), 44,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [31029] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4922), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4918), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4920), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [31095] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4922), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4918), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4920), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [31161] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6279), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6277), 43,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_template,
      anon_sym_operator,
  [31225] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5966), 1,
      anon_sym___attribute__,
    ACTIONS(6159), 1,
      anon_sym_LBRACE,
    STATE(2901), 1,
      sym_enumerator_list,
    STATE(3162), 1,
      sym_attribute_specifier,
    ACTIONS(5350), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5352), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [31297] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4530), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4532), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [31361] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4555), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4557), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [31425] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4926), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT2,
    ACTIONS(4924), 45,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_try,
      anon_sym_requires,
  [31489] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4559), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4561), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [31553] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4571), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4573), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [31617] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5066), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5068), 44,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [31681] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4567), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4569), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [31745] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4563), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4565), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [31809] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5201), 1,
      sym_literal_suffix,
    ACTIONS(5197), 26,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5199), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [31875] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5201), 1,
      sym_literal_suffix,
    ACTIONS(3769), 26,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(3761), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [31941] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5809), 1,
      anon_sym___attribute__,
    STATE(2993), 1,
      sym_attribute_specifier,
    ACTIONS(5456), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5458), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [32009] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5809), 1,
      anon_sym___attribute__,
    STATE(3060), 1,
      sym_attribute_specifier,
    ACTIONS(5452), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5454), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [32077] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6016), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6018), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_try,
  [32141] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5078), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5080), 44,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [32205] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5966), 1,
      anon_sym___attribute__,
    ACTIONS(6159), 1,
      anon_sym_LBRACE,
    STATE(2875), 1,
      sym_enumerator_list,
    STATE(3152), 1,
      sym_attribute_specifier,
    ACTIONS(5293), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5295), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [32277] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5809), 1,
      anon_sym___attribute__,
    STATE(3053), 1,
      sym_attribute_specifier,
    ACTIONS(5400), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5402), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [32345] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6281), 1,
      sym_auto,
    ACTIONS(6283), 1,
      anon_sym_decltype,
    STATE(2951), 1,
      sym_decltype_auto,
    ACTIONS(4871), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(4873), 41,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [32415] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5809), 1,
      anon_sym___attribute__,
    STATE(2990), 1,
      sym_attribute_specifier,
    ACTIONS(5363), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5365), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [32483] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5809), 1,
      anon_sym___attribute__,
    STATE(3045), 1,
      sym_attribute_specifier,
    ACTIONS(5386), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5388), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [32551] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6136), 1,
      anon_sym___attribute__,
    ACTIONS(6285), 1,
      anon_sym_LBRACE,
    ACTIONS(6287), 1,
      anon_sym_COLON,
    STATE(3046), 1,
      sym__enum_base_clause,
    STATE(3107), 1,
      sym_enumerator_list,
    STATE(3457), 1,
      sym_attribute_specifier,
    ACTIONS(5689), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5691), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [32627] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4582), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4575), 43,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [32691] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(3803), 1,
      anon_sym_LPAREN2,
    ACTIONS(5511), 1,
      sym_identifier,
    ACTIONS(5515), 1,
      anon_sym_STAR,
    ACTIONS(5517), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5519), 1,
      anon_sym_AMP,
    ACTIONS(5521), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5523), 1,
      anon_sym_LBRACK,
    STATE(3343), 1,
      sym_parameter_list,
    STATE(5695), 1,
      sym__scope_resolution,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6167), 1,
      sym__declarator,
    STATE(6287), 1,
      sym__abstract_declarator,
    STATE(7771), 1,
      sym_ms_based_modifier,
    STATE(4972), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(5555), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_GT2,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [32799] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6289), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(6291), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [32863] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4543), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4536), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_try,
  [32927] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5809), 1,
      anon_sym___attribute__,
    STATE(3018), 1,
      sym_attribute_specifier,
    ACTIONS(5485), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5487), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [32995] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5809), 1,
      anon_sym___attribute__,
    STATE(3000), 1,
      sym_attribute_specifier,
    ACTIONS(5414), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5416), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [33063] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4928), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4930), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [33127] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4543), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4536), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_try,
  [33191] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4543), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4536), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_try,
  [33255] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5156), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5158), 44,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [33319] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6136), 1,
      anon_sym___attribute__,
    ACTIONS(6285), 1,
      anon_sym_LBRACE,
    ACTIONS(6287), 1,
      anon_sym_COLON,
    STATE(3043), 1,
      sym__enum_base_clause,
    STATE(3163), 1,
      sym_enumerator_list,
    STATE(3547), 1,
      sym_attribute_specifier,
    ACTIONS(5629), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5631), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [33395] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4582), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(4584), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4577), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [33461] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6293), 1,
      sym_identifier,
    STATE(2955), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3402), 1,
      sym_primitive_type,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(6295), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4934), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4936), 36,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_try,
      anon_sym_requires,
  [33535] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5809), 1,
      anon_sym___attribute__,
    STATE(3011), 1,
      sym_attribute_specifier,
    ACTIONS(5481), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5483), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [33603] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4922), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4940), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4942), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [33669] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5101), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5103), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [33733] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(3803), 1,
      anon_sym_LPAREN2,
    ACTIONS(5511), 1,
      sym_identifier,
    ACTIONS(5515), 1,
      anon_sym_STAR,
    ACTIONS(5517), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5519), 1,
      anon_sym_AMP,
    ACTIONS(5521), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5523), 1,
      anon_sym_LBRACK,
    STATE(3343), 1,
      sym_parameter_list,
    STATE(5695), 1,
      sym__scope_resolution,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6141), 1,
      sym__declarator,
    STATE(6261), 1,
      sym__abstract_declarator,
    STATE(7771), 1,
      sym_ms_based_modifier,
    STATE(4972), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(6297), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_GT2,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [33841] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6299), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(6301), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [33905] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5809), 1,
      anon_sym___attribute__,
    STATE(3006), 1,
      sym_attribute_specifier,
    ACTIONS(5473), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5475), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [33973] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5105), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5107), 44,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [34037] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4543), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4536), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_try,
  [34101] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5809), 1,
      anon_sym___attribute__,
    STATE(3004), 1,
      sym_attribute_specifier,
    ACTIONS(5493), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5495), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [34169] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4543), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4536), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_try,
  [34233] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5117), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5119), 44,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [34297] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4551), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4553), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [34361] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4922), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4924), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(4926), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [34427] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5809), 1,
      anon_sym___attribute__,
    STATE(2996), 1,
      sym_attribute_specifier,
    ACTIONS(5489), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5491), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [34495] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4867), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(4869), 44,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [34559] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4543), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4536), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_try,
  [34623] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5809), 1,
      anon_sym___attribute__,
    STATE(3012), 1,
      sym_attribute_specifier,
    ACTIONS(5499), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5501), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [34691] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4867), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4869), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [34754] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6305), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6303), 43,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
  [34817] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5966), 1,
      anon_sym___attribute__,
    STATE(3122), 1,
      sym_attribute_specifier,
    ACTIONS(5414), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5416), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [34884] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(6307), 1,
      anon_sym_SEMI,
    STATE(2665), 1,
      sym_attribute_specifier,
    STATE(3111), 1,
      sym_field_declaration_list,
    STATE(6691), 1,
      sym_virtual_specifier,
    STATE(7390), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(4904), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4902), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [34965] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6309), 1,
      anon_sym_LPAREN2,
    ACTIONS(6311), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6313), 1,
      anon_sym_LBRACK,
    STATE(3345), 1,
      sym_parameter_list,
    STATE(3055), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5469), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5471), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [35038] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(6315), 1,
      anon_sym_SEMI,
    STATE(2665), 1,
      sym_attribute_specifier,
    STATE(3111), 1,
      sym_field_declaration_list,
    STATE(6691), 1,
      sym_virtual_specifier,
    STATE(7390), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(4904), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4902), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [35119] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5113), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5115), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [35182] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6309), 1,
      anon_sym_LPAREN2,
    ACTIONS(6311), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6313), 1,
      anon_sym_LBRACK,
    STATE(3345), 1,
      sym_parameter_list,
    STATE(3055), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5390), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5392), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [35255] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(6317), 1,
      anon_sym_LBRACE,
    STATE(2670), 1,
      sym_attribute_specifier,
    STATE(3113), 1,
      sym_enumerator_list,
    ACTIONS(5295), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5293), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [35326] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4924), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(4926), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [35389] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5145), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5147), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [35452] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2473), 1,
      anon_sym_LBRACE,
    ACTIONS(6319), 1,
      anon_sym_LPAREN2,
    ACTIONS(6321), 1,
      anon_sym_LBRACK,
    ACTIONS(6323), 1,
      sym_auto,
    ACTIONS(6325), 1,
      anon_sym_decltype,
    STATE(3409), 1,
      sym_decltype_auto,
    STATE(3541), 1,
      sym_new_declarator,
    STATE(3890), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5208), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5210), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [35531] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5966), 1,
      anon_sym___attribute__,
    STATE(3133), 1,
      sym_attribute_specifier,
    ACTIONS(5363), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5365), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [35598] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(6327), 1,
      anon_sym_SEMI,
    STATE(2665), 1,
      sym_attribute_specifier,
    STATE(3111), 1,
      sym_field_declaration_list,
    STATE(6691), 1,
      sym_virtual_specifier,
    STATE(7390), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(4904), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4902), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [35679] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4922), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4924), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4926), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [35744] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6289), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6291), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [35807] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5966), 1,
      anon_sym___attribute__,
    STATE(3114), 1,
      sym_attribute_specifier,
    ACTIONS(5489), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5491), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [35874] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5129), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5131), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [35937] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5105), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5107), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [36000] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5201), 1,
      sym_literal_suffix,
    ACTIONS(5197), 24,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(5199), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [36065] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5966), 1,
      anon_sym___attribute__,
    STATE(3102), 1,
      sym_attribute_specifier,
    ACTIONS(5499), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5501), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [36132] = 52,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6329), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6331), 1,
      anon_sym_COMMA,
    ACTIONS(6333), 1,
      anon_sym_RPAREN,
    ACTIONS(6335), 1,
      anon_sym_DASH,
    ACTIONS(6337), 1,
      anon_sym_PLUS,
    ACTIONS(6339), 1,
      anon_sym_STAR,
    ACTIONS(6341), 1,
      anon_sym_SLASH,
    ACTIONS(6343), 1,
      anon_sym_PERCENT,
    ACTIONS(6345), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6347), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6349), 1,
      anon_sym_PIPE,
    ACTIONS(6351), 1,
      anon_sym_CARET,
    ACTIONS(6353), 1,
      anon_sym_AMP,
    ACTIONS(6355), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6357), 1,
      anon_sym_BANG_EQ,
    ACTIONS(6359), 1,
      anon_sym_GT,
    ACTIONS(6361), 1,
      anon_sym_GT_EQ,
    ACTIONS(6363), 1,
      anon_sym_LT_EQ,
    ACTIONS(6365), 1,
      anon_sym_LT,
    ACTIONS(6367), 1,
      anon_sym_LT_LT,
    ACTIONS(6369), 1,
      anon_sym_GT_GT,
    ACTIONS(6371), 1,
      anon_sym_LBRACK,
    ACTIONS(6373), 1,
      anon_sym_EQ,
    ACTIONS(6375), 1,
      anon_sym_QMARK,
    ACTIONS(6377), 1,
      anon_sym_STAR_EQ,
    ACTIONS(6379), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(6381), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(6383), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(6385), 1,
      anon_sym_DASH_EQ,
    ACTIONS(6387), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(6389), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(6391), 1,
      anon_sym_AMP_EQ,
    ACTIONS(6393), 1,
      anon_sym_CARET_EQ,
    ACTIONS(6395), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(6399), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6401), 1,
      anon_sym_or,
    ACTIONS(6403), 1,
      anon_sym_and,
    ACTIONS(6405), 1,
      anon_sym_bitor,
    ACTIONS(6407), 1,
      anon_sym_xor,
    ACTIONS(6409), 1,
      anon_sym_bitand,
    ACTIONS(6411), 1,
      anon_sym_not_eq,
    ACTIONS(6417), 1,
      anon_sym_DOT_STAR,
    ACTIONS(6419), 1,
      anon_sym_DASH_GT_STAR,
    STATE(1375), 1,
      sym__binary_fold_operator,
    STATE(3367), 1,
      sym_argument_list,
    STATE(3368), 1,
      sym_subscript_argument_list,
    STATE(7963), 1,
      sym__fold_operator,
    ACTIONS(6413), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6415), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6397), 3,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [36293] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5042), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5044), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [36356] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5058), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5060), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [36419] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(6421), 1,
      anon_sym_SEMI,
    STATE(2665), 1,
      sym_attribute_specifier,
    STATE(3111), 1,
      sym_field_declaration_list,
    STATE(6691), 1,
      sym_virtual_specifier,
    STATE(7390), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(4904), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4902), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [36500] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5201), 1,
      sym_literal_suffix,
    ACTIONS(3769), 24,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(3761), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [36565] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5168), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5170), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [36628] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5121), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5123), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [36691] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5966), 1,
      anon_sym___attribute__,
    STATE(3066), 1,
      sym_attribute_specifier,
    ACTIONS(5485), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5487), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [36758] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6425), 25,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_number_literal_token1,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(6423), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      aux_sym_number_literal_token2,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [36821] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6269), 1,
      anon_sym_EQ,
    ACTIONS(6431), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6433), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6435), 1,
      anon_sym_PIPE,
    ACTIONS(6439), 1,
      anon_sym_AMP,
    ACTIONS(6445), 1,
      anon_sym_GT_EQ,
    ACTIONS(6449), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6451), 1,
      anon_sym_or,
    ACTIONS(6453), 1,
      anon_sym_and,
    ACTIONS(6455), 1,
      anon_sym_bitor,
    ACTIONS(6457), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6427), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6437), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6447), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6429), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6441), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6443), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6271), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [36930] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6218), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6244), 1,
      anon_sym_EQ,
    ACTIONS(6431), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6433), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6435), 1,
      anon_sym_PIPE,
    ACTIONS(6439), 1,
      anon_sym_AMP,
    ACTIONS(6445), 1,
      anon_sym_GT_EQ,
    ACTIONS(6449), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6451), 1,
      anon_sym_or,
    ACTIONS(6453), 1,
      anon_sym_and,
    ACTIONS(6455), 1,
      anon_sym_bitor,
    ACTIONS(6457), 1,
      anon_sym_bitand,
    ACTIONS(6459), 1,
      anon_sym_QMARK,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6427), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6437), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6447), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6429), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6441), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6443), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6246), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [37043] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2473), 1,
      anon_sym_LBRACE,
    ACTIONS(6319), 1,
      anon_sym_LPAREN2,
    ACTIONS(6321), 1,
      anon_sym_LBRACK,
    ACTIONS(6323), 1,
      sym_auto,
    ACTIONS(6325), 1,
      anon_sym_decltype,
    STATE(3409), 1,
      sym_decltype_auto,
    STATE(3495), 1,
      sym_new_declarator,
    STATE(3857), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5234), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5236), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [37122] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6299), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6301), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [37185] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6256), 1,
      anon_sym_EQ,
    ACTIONS(6431), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6433), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6435), 1,
      anon_sym_PIPE,
    ACTIONS(6439), 1,
      anon_sym_AMP,
    ACTIONS(6445), 1,
      anon_sym_GT_EQ,
    ACTIONS(6449), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6451), 1,
      anon_sym_or,
    ACTIONS(6453), 1,
      anon_sym_and,
    ACTIONS(6455), 1,
      anon_sym_bitor,
    ACTIONS(6457), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6427), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6437), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6447), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6429), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6441), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6443), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6258), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [37294] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5054), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5056), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [37357] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6427), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6447), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6429), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5724), 10,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(5726), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [37440] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6427), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6429), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5724), 12,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(5726), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [37521] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5062), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5064), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [37584] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(6461), 1,
      anon_sym_SEMI,
    STATE(2665), 1,
      sym_attribute_specifier,
    STATE(3111), 1,
      sym_field_declaration_list,
    STATE(6691), 1,
      sym_virtual_specifier,
    STATE(7390), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(4904), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4902), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [37665] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6449), 1,
      anon_sym_LT_EQ_GT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6427), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6447), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6429), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5724), 10,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(5726), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [37750] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5099), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [37813] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5966), 1,
      anon_sym___attribute__,
    STATE(3082), 1,
      sym_attribute_specifier,
    ACTIONS(5481), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5483), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [37880] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6216), 1,
      anon_sym_EQ,
    ACTIONS(6218), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6431), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6433), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6435), 1,
      anon_sym_PIPE,
    ACTIONS(6439), 1,
      anon_sym_AMP,
    ACTIONS(6445), 1,
      anon_sym_GT_EQ,
    ACTIONS(6449), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6451), 1,
      anon_sym_or,
    ACTIONS(6453), 1,
      anon_sym_and,
    ACTIONS(6455), 1,
      anon_sym_bitor,
    ACTIONS(6457), 1,
      anon_sym_bitand,
    ACTIONS(6459), 1,
      anon_sym_QMARK,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6427), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6437), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6447), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6429), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6441), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6443), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6220), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [37993] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6445), 1,
      anon_sym_GT_EQ,
    ACTIONS(6449), 1,
      anon_sym_LT_EQ_GT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6427), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6447), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6429), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6443), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5724), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(5726), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [38082] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5066), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5068), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [38145] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4918), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4920), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [38208] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5966), 1,
      anon_sym___attribute__,
    STATE(3095), 1,
      sym_attribute_specifier,
    ACTIONS(5493), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5495), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [38275] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6445), 1,
      anon_sym_GT_EQ,
    ACTIONS(6449), 1,
      anon_sym_LT_EQ_GT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6427), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6447), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6429), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6441), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6443), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5724), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(5726), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
  [38366] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6439), 1,
      anon_sym_AMP,
    ACTIONS(6445), 1,
      anon_sym_GT_EQ,
    ACTIONS(6449), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6457), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6427), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6447), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6429), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6441), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6443), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5724), 6,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(5726), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
  [38461] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6439), 1,
      anon_sym_AMP,
    ACTIONS(6445), 1,
      anon_sym_GT_EQ,
    ACTIONS(6449), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6457), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6427), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6437), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6447), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6429), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6441), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6443), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5724), 4,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(5726), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
  [38558] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5050), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5052), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [38621] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5050), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5052), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [38684] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6435), 1,
      anon_sym_PIPE,
    ACTIONS(6439), 1,
      anon_sym_AMP,
    ACTIONS(6445), 1,
      anon_sym_GT_EQ,
    ACTIONS(6449), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6455), 1,
      anon_sym_bitor,
    ACTIONS(6457), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6427), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6437), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6447), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5724), 3,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(6429), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6441), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6443), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5726), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [38785] = 52,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6329), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6331), 1,
      anon_sym_COMMA,
    ACTIONS(6335), 1,
      anon_sym_DASH,
    ACTIONS(6337), 1,
      anon_sym_PLUS,
    ACTIONS(6339), 1,
      anon_sym_STAR,
    ACTIONS(6341), 1,
      anon_sym_SLASH,
    ACTIONS(6343), 1,
      anon_sym_PERCENT,
    ACTIONS(6345), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6347), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6349), 1,
      anon_sym_PIPE,
    ACTIONS(6351), 1,
      anon_sym_CARET,
    ACTIONS(6353), 1,
      anon_sym_AMP,
    ACTIONS(6355), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6357), 1,
      anon_sym_BANG_EQ,
    ACTIONS(6359), 1,
      anon_sym_GT,
    ACTIONS(6361), 1,
      anon_sym_GT_EQ,
    ACTIONS(6363), 1,
      anon_sym_LT_EQ,
    ACTIONS(6365), 1,
      anon_sym_LT,
    ACTIONS(6367), 1,
      anon_sym_LT_LT,
    ACTIONS(6369), 1,
      anon_sym_GT_GT,
    ACTIONS(6371), 1,
      anon_sym_LBRACK,
    ACTIONS(6373), 1,
      anon_sym_EQ,
    ACTIONS(6375), 1,
      anon_sym_QMARK,
    ACTIONS(6377), 1,
      anon_sym_STAR_EQ,
    ACTIONS(6379), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(6381), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(6383), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(6385), 1,
      anon_sym_DASH_EQ,
    ACTIONS(6387), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(6389), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(6391), 1,
      anon_sym_AMP_EQ,
    ACTIONS(6393), 1,
      anon_sym_CARET_EQ,
    ACTIONS(6395), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(6399), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6401), 1,
      anon_sym_or,
    ACTIONS(6403), 1,
      anon_sym_and,
    ACTIONS(6405), 1,
      anon_sym_bitor,
    ACTIONS(6407), 1,
      anon_sym_xor,
    ACTIONS(6409), 1,
      anon_sym_bitand,
    ACTIONS(6411), 1,
      anon_sym_not_eq,
    ACTIONS(6417), 1,
      anon_sym_DOT_STAR,
    ACTIONS(6419), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(6463), 1,
      anon_sym_RPAREN,
    STATE(1375), 1,
      sym__binary_fold_operator,
    STATE(3367), 1,
      sym_argument_list,
    STATE(3368), 1,
      sym_subscript_argument_list,
    STATE(7963), 1,
      sym__fold_operator,
    ACTIONS(6413), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6415), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6397), 3,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [38946] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6433), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6435), 1,
      anon_sym_PIPE,
    ACTIONS(6439), 1,
      anon_sym_AMP,
    ACTIONS(6445), 1,
      anon_sym_GT_EQ,
    ACTIONS(6449), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6453), 1,
      anon_sym_and,
    ACTIONS(6455), 1,
      anon_sym_bitor,
    ACTIONS(6457), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(5724), 2,
      anon_sym_EQ,
      anon_sym_or,
    ACTIONS(6427), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6437), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6447), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6429), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6441), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6443), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5726), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [39051] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6309), 1,
      anon_sym_LPAREN2,
    ACTIONS(6311), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6313), 1,
      anon_sym_LBRACK,
    STATE(3345), 1,
      sym_parameter_list,
    STATE(3055), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5503), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5505), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [39124] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5966), 1,
      anon_sym___attribute__,
    STATE(3147), 1,
      sym_attribute_specifier,
    ACTIONS(5456), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5458), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [39191] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6429), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5724), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(5726), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [39270] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4541), 1,
      anon_sym_LBRACE,
    ACTIONS(4595), 1,
      anon_sym_LT,
    STATE(2992), 1,
      sym_template_argument_list,
    ACTIONS(4543), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4536), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [39341] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5135), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5137), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [39404] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5172), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5174), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [39467] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4924), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(4926), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [39530] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6309), 1,
      anon_sym_LPAREN2,
    ACTIONS(6311), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6313), 1,
      anon_sym_LBRACK,
    STATE(3345), 1,
      sym_parameter_list,
    STATE(3055), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5442), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5444), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [39603] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5179), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5181), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [39666] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5125), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5127), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [39729] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5089), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5091), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [39792] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2473), 1,
      anon_sym_LBRACE,
    ACTIONS(6319), 1,
      anon_sym_LPAREN2,
    ACTIONS(6321), 1,
      anon_sym_LBRACK,
    ACTIONS(6323), 1,
      sym_auto,
    ACTIONS(6325), 1,
      anon_sym_decltype,
    STATE(3409), 1,
      sym_decltype_auto,
    STATE(3494), 1,
      sym_new_declarator,
    STATE(3876), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5230), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5232), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [39871] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6309), 1,
      anon_sym_LPAREN2,
    ACTIONS(6311), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6313), 1,
      anon_sym_LBRACK,
    STATE(3345), 1,
      sym_parameter_list,
    STATE(3055), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5463), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5465), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [39944] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5030), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5032), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [40007] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5152), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5154), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [40070] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5164), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5166), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [40133] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6167), 1,
      sym_auto,
    ACTIONS(6169), 1,
      anon_sym_decltype,
    STATE(3014), 1,
      sym_decltype_auto,
    ACTIONS(4871), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4873), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [40202] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5966), 1,
      anon_sym___attribute__,
    STATE(3151), 1,
      sym_attribute_specifier,
    ACTIONS(5452), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5454), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [40269] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5074), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5076), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [40332] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5038), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5040), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [40395] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5966), 1,
      anon_sym___attribute__,
    STATE(3065), 1,
      sym_attribute_specifier,
    ACTIONS(5473), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5475), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [40462] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(6465), 1,
      anon_sym_SEMI,
    STATE(2665), 1,
      sym_attribute_specifier,
    STATE(3111), 1,
      sym_field_declaration_list,
    STATE(6691), 1,
      sym_virtual_specifier,
    STATE(7390), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(4904), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4902), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [40543] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5185), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [40606] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5121), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5123), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [40669] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5160), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5162), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [40732] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5078), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5080), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [40795] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2026), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4766), 4,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
    ACTIONS(5247), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5139), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5142), 36,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_try,
      anon_sym_requires,
  [40864] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5034), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5036), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [40927] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5156), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5158), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [40990] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(6467), 1,
      anon_sym_SEMI,
    STATE(2665), 1,
      sym_attribute_specifier,
    STATE(3111), 1,
      sym_field_declaration_list,
    STATE(6691), 1,
      sym_virtual_specifier,
    STATE(7390), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(4904), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4902), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [41071] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5109), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5111), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [41134] = 52,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6329), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6331), 1,
      anon_sym_COMMA,
    ACTIONS(6335), 1,
      anon_sym_DASH,
    ACTIONS(6337), 1,
      anon_sym_PLUS,
    ACTIONS(6339), 1,
      anon_sym_STAR,
    ACTIONS(6341), 1,
      anon_sym_SLASH,
    ACTIONS(6343), 1,
      anon_sym_PERCENT,
    ACTIONS(6345), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6347), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6349), 1,
      anon_sym_PIPE,
    ACTIONS(6351), 1,
      anon_sym_CARET,
    ACTIONS(6353), 1,
      anon_sym_AMP,
    ACTIONS(6355), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6357), 1,
      anon_sym_BANG_EQ,
    ACTIONS(6359), 1,
      anon_sym_GT,
    ACTIONS(6361), 1,
      anon_sym_GT_EQ,
    ACTIONS(6363), 1,
      anon_sym_LT_EQ,
    ACTIONS(6365), 1,
      anon_sym_LT,
    ACTIONS(6367), 1,
      anon_sym_LT_LT,
    ACTIONS(6369), 1,
      anon_sym_GT_GT,
    ACTIONS(6371), 1,
      anon_sym_LBRACK,
    ACTIONS(6373), 1,
      anon_sym_EQ,
    ACTIONS(6375), 1,
      anon_sym_QMARK,
    ACTIONS(6377), 1,
      anon_sym_STAR_EQ,
    ACTIONS(6379), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(6381), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(6383), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(6385), 1,
      anon_sym_DASH_EQ,
    ACTIONS(6387), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(6389), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(6391), 1,
      anon_sym_AMP_EQ,
    ACTIONS(6393), 1,
      anon_sym_CARET_EQ,
    ACTIONS(6395), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(6399), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6401), 1,
      anon_sym_or,
    ACTIONS(6403), 1,
      anon_sym_and,
    ACTIONS(6405), 1,
      anon_sym_bitor,
    ACTIONS(6407), 1,
      anon_sym_xor,
    ACTIONS(6409), 1,
      anon_sym_bitand,
    ACTIONS(6411), 1,
      anon_sym_not_eq,
    ACTIONS(6417), 1,
      anon_sym_DOT_STAR,
    ACTIONS(6419), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(6469), 1,
      anon_sym_RPAREN,
    STATE(1375), 1,
      sym__binary_fold_operator,
    STATE(3367), 1,
      sym_argument_list,
    STATE(3368), 1,
      sym_subscript_argument_list,
    STATE(7963), 1,
      sym__fold_operator,
    ACTIONS(6413), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6415), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6397), 3,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [41295] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4882), 4,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(4884), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(3761), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(3769), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
  [41362] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2473), 1,
      anon_sym_LBRACE,
    ACTIONS(6319), 1,
      anon_sym_LPAREN2,
    ACTIONS(6321), 1,
      anon_sym_LBRACK,
    ACTIONS(6323), 1,
      sym_auto,
    ACTIONS(6325), 1,
      anon_sym_decltype,
    STATE(3409), 1,
      sym_decltype_auto,
    STATE(3515), 1,
      sym_new_declarator,
    STATE(3874), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5226), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5228), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [41441] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5117), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5119), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [41504] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5093), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5095), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [41567] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5085), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5087), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [41630] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(6317), 1,
      anon_sym_LBRACE,
    STATE(2690), 1,
      sym_attribute_specifier,
    STATE(3061), 1,
      sym_enumerator_list,
    ACTIONS(5352), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5350), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [41701] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4541), 1,
      anon_sym_LBRACE,
    ACTIONS(4548), 1,
      anon_sym_LT,
    STATE(2854), 1,
      sym_template_argument_list,
    ACTIONS(4543), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4536), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [41772] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5046), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5048), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [41835] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5050), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5052), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [41898] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5966), 1,
      anon_sym___attribute__,
    STATE(3156), 1,
      sym_attribute_specifier,
    ACTIONS(5400), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5402), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [41965] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5070), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5072), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [42028] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(5934), 1,
      anon_sym_EQ,
    ACTIONS(6218), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6431), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6433), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6435), 1,
      anon_sym_PIPE,
    ACTIONS(6439), 1,
      anon_sym_AMP,
    ACTIONS(6445), 1,
      anon_sym_GT_EQ,
    ACTIONS(6449), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6451), 1,
      anon_sym_or,
    ACTIONS(6453), 1,
      anon_sym_and,
    ACTIONS(6455), 1,
      anon_sym_bitor,
    ACTIONS(6457), 1,
      anon_sym_bitand,
    ACTIONS(6459), 1,
      anon_sym_QMARK,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6427), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6437), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6447), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6429), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6441), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6443), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5936), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [42141] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6240), 1,
      anon_sym_EQ,
    ACTIONS(6431), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6433), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6435), 1,
      anon_sym_PIPE,
    ACTIONS(6439), 1,
      anon_sym_AMP,
    ACTIONS(6445), 1,
      anon_sym_GT_EQ,
    ACTIONS(6449), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6451), 1,
      anon_sym_or,
    ACTIONS(6453), 1,
      anon_sym_and,
    ACTIONS(6455), 1,
      anon_sym_bitor,
    ACTIONS(6457), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6427), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6437), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6447), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6429), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6441), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6443), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6242), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [42250] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6248), 1,
      anon_sym_EQ,
    ACTIONS(6431), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6433), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6435), 1,
      anon_sym_PIPE,
    ACTIONS(6439), 1,
      anon_sym_AMP,
    ACTIONS(6445), 1,
      anon_sym_GT_EQ,
    ACTIONS(6449), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6451), 1,
      anon_sym_or,
    ACTIONS(6453), 1,
      anon_sym_and,
    ACTIONS(6455), 1,
      anon_sym_bitor,
    ACTIONS(6457), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6427), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6437), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6447), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6429), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6441), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6443), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6250), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [42359] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5966), 1,
      anon_sym___attribute__,
    STATE(3167), 1,
      sym_attribute_specifier,
    ACTIONS(5386), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5388), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [42426] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5152), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5154), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [42488] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5145), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5147), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [42550] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6471), 1,
      anon_sym_typedef,
    ACTIONS(2821), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2819), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [42614] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1967), 1,
      anon_sym_LBRACE,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    STATE(3507), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5625), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5627), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [42682] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5050), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5052), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [42744] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4922), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4924), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4926), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [42808] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6473), 1,
      anon_sym_LPAREN2,
    ACTIONS(6475), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6477), 1,
      anon_sym_LBRACK,
    STATE(3449), 1,
      sym_parameter_list,
    STATE(3124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5390), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5392), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [42880] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6485), 1,
      anon_sym_DQUOTE_DQUOTE,
    ACTIONS(6483), 2,
      anon_sym_delete,
      anon_sym_new,
    ACTIONS(6481), 20,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_not,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DASH_GT,
    ACTIONS(6479), 31,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_compl,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_co_await,
      anon_sym_DASH_GT_STAR,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LBRACK_RBRACK,
  [42946] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6487), 1,
      sym_identifier,
    STATE(3189), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3603), 1,
      sym_primitive_type,
    ACTIONS(6492), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(6490), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4936), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(4934), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [43018] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(3803), 1,
      anon_sym_LPAREN2,
    ACTIONS(5511), 1,
      sym_identifier,
    ACTIONS(5521), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5523), 1,
      anon_sym_LBRACK,
    ACTIONS(5740), 1,
      anon_sym_STAR,
    ACTIONS(5742), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5744), 1,
      anon_sym_AMP,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(5695), 1,
      sym__scope_resolution,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6141), 1,
      sym__declarator,
    STATE(6449), 1,
      sym__abstract_declarator,
    STATE(7771), 1,
      sym_ms_based_modifier,
    ACTIONS(6297), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(4972), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [43124] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3785), 1,
      anon_sym_SEMI,
    ACTIONS(6103), 1,
      anon_sym_LT,
    STATE(2716), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2843), 1,
      sym_template_argument_list,
    ACTIONS(3787), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3767), 5,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3759), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [43198] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5030), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5032), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [43260] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6206), 1,
      sym_auto,
    ACTIONS(6208), 1,
      anon_sym_decltype,
    STATE(3088), 1,
      sym_decltype_auto,
    ACTIONS(4871), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4873), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [43328] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5050), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5052), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [43390] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5168), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5170), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [43452] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5172), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5174), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [43514] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4582), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(4584), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4577), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [43578] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5089), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5091), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [43640] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5099), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [43702] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6494), 1,
      anon_sym_namespace,
    ACTIONS(6124), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6122), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [43766] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5164), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5166), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [43828] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4867), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4869), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [43890] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5070), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5072), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [43952] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6496), 1,
      anon_sym_typedef,
    ACTIONS(2821), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2819), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [44016] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5179), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5181), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [44078] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5038), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5040), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [44140] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6504), 1,
      anon_sym_DQUOTE_DQUOTE,
    ACTIONS(6502), 2,
      anon_sym_delete,
      anon_sym_new,
    ACTIONS(6500), 20,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_not,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DASH_GT,
    ACTIONS(6498), 31,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_compl,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_co_await,
      anon_sym_DASH_GT_STAR,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LBRACK_RBRACK,
  [44206] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6473), 1,
      anon_sym_LPAREN2,
    ACTIONS(6475), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6477), 1,
      anon_sym_LBRACK,
    STATE(3449), 1,
      sym_parameter_list,
    STATE(3124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5503), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5505), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [44278] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5034), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5036), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [44340] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5050), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5052), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [44402] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5062), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5064), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [44464] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5135), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5137), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [44526] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6506), 1,
      anon_sym_typedef,
    ACTIONS(2821), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2819), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [44590] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4924), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4926), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [44652] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5042), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5044), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [44714] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5058), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5060), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [44776] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5160), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5162), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [44838] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(3803), 1,
      anon_sym_LPAREN2,
    ACTIONS(5511), 1,
      sym_identifier,
    ACTIONS(5521), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5523), 1,
      anon_sym_LBRACK,
    ACTIONS(5708), 1,
      anon_sym_STAR,
    ACTIONS(5710), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5712), 1,
      anon_sym_AMP,
    STATE(3830), 1,
      sym_parameter_list,
    STATE(5695), 1,
      sym__scope_resolution,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6167), 1,
      sym__declarator,
    STATE(6470), 1,
      sym__abstract_declarator,
    STATE(7771), 1,
      sym_ms_based_modifier,
    ACTIONS(5555), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(4972), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [44944] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5185), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [45006] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6508), 1,
      anon_sym_typedef,
    ACTIONS(2821), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2819), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [45070] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6510), 1,
      anon_sym_typedef,
    ACTIONS(2821), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2819), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [45134] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5066), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5068), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [45196] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5054), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5056), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [45258] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6473), 1,
      anon_sym_LPAREN2,
    ACTIONS(6475), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6477), 1,
      anon_sym_LBRACK,
    STATE(3449), 1,
      sym_parameter_list,
    STATE(3124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5463), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5465), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [45330] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5113), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5115), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [45392] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1967), 1,
      anon_sym_LBRACE,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    STATE(3537), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5565), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5567), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [45460] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6473), 1,
      anon_sym_LPAREN2,
    ACTIONS(6475), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6477), 1,
      anon_sym_LBRACK,
    STATE(3449), 1,
      sym_parameter_list,
    STATE(3124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5469), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5471), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [45532] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6473), 1,
      anon_sym_LPAREN2,
    ACTIONS(6475), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6477), 1,
      anon_sym_LBRACK,
    STATE(3449), 1,
      sym_parameter_list,
    STATE(3124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5442), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5444), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [45604] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5074), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5076), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [45666] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6518), 1,
      anon_sym_DQUOTE_DQUOTE,
    ACTIONS(6516), 2,
      anon_sym_delete,
      anon_sym_new,
    ACTIONS(6514), 20,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_not,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DASH_GT,
    ACTIONS(6512), 31,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_compl,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_co_await,
      anon_sym_DASH_GT_STAR,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LBRACK_RBRACK,
  [45732] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5201), 1,
      sym_literal_suffix,
    STATE(2617), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(3204), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(3208), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(3769), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(3761), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [45802] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6520), 1,
      anon_sym_typedef,
    ACTIONS(2821), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2819), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [45866] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4924), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4926), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [45928] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6103), 1,
      anon_sym_LT,
    STATE(1741), 1,
      sym_template_argument_list,
    STATE(3431), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5303), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(6522), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5305), 42,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [46000] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6530), 1,
      anon_sym_DQUOTE_DQUOTE,
    ACTIONS(6528), 2,
      anon_sym_delete,
      anon_sym_new,
    ACTIONS(6526), 20,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_not,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DASH_GT,
    ACTIONS(6524), 31,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_compl,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_co_await,
      anon_sym_DASH_GT_STAR,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LBRACK_RBRACK,
  [46066] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(3803), 1,
      anon_sym_LPAREN2,
    ACTIONS(5511), 1,
      sym_identifier,
    ACTIONS(5521), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5523), 1,
      anon_sym_LBRACK,
    ACTIONS(5708), 1,
      anon_sym_STAR,
    ACTIONS(5710), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5712), 1,
      anon_sym_AMP,
    STATE(3830), 1,
      sym_parameter_list,
    STATE(5695), 1,
      sym__scope_resolution,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6141), 1,
      sym__declarator,
    STATE(6472), 1,
      sym__abstract_declarator,
    STATE(7771), 1,
      sym_ms_based_modifier,
    ACTIONS(6297), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(4972), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [46172] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6103), 1,
      anon_sym_LT,
    ACTIONS(6532), 1,
      anon_sym_LBRACK,
    STATE(2716), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3917), 1,
      sym_template_argument_list,
    ACTIONS(3782), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3767), 4,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
    ACTIONS(3787), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3759), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [46248] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(3803), 1,
      anon_sym_LPAREN2,
    ACTIONS(5511), 1,
      sym_identifier,
    ACTIONS(5521), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5523), 1,
      anon_sym_LBRACK,
    ACTIONS(5740), 1,
      anon_sym_STAR,
    ACTIONS(5742), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5744), 1,
      anon_sym_AMP,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(5695), 1,
      sym__scope_resolution,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6167), 1,
      sym__declarator,
    STATE(6435), 1,
      sym__abstract_declarator,
    STATE(7771), 1,
      sym_ms_based_modifier,
    ACTIONS(5555), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(4972), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [46354] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5201), 1,
      sym_literal_suffix,
    STATE(2617), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(3204), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(3208), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5197), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5199), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [46424] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6535), 1,
      anon_sym_namespace,
    ACTIONS(6124), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6122), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [46488] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6537), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(3036), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5532), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5534), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [46554] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1967), 1,
      anon_sym_LBRACE,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    STATE(3404), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5561), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5563), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [46622] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6103), 1,
      anon_sym_LT,
    STATE(2716), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2843), 1,
      sym_template_argument_list,
    ACTIONS(3787), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3767), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3759), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [46694] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5078), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5080), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [46756] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3594), 1,
      anon_sym_DQUOTE_DQUOTE,
    ACTIONS(6540), 2,
      anon_sym_delete,
      anon_sym_new,
    ACTIONS(3576), 20,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_not,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DASH_GT,
    ACTIONS(3574), 31,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_compl,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_co_await,
      anon_sym_DASH_GT_STAR,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LBRACK_RBRACK,
  [46822] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5046), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5048), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [46884] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5156), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5158), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [46946] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6136), 1,
      anon_sym___attribute__,
    ACTIONS(6285), 1,
      anon_sym_LBRACE,
    STATE(3192), 1,
      sym_enumerator_list,
    STATE(3491), 1,
      sym_attribute_specifier,
    ACTIONS(5350), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5352), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [47016] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5121), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5123), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [47078] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5129), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5131), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [47140] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6136), 1,
      anon_sym___attribute__,
    ACTIONS(6285), 1,
      anon_sym_LBRACE,
    STATE(3164), 1,
      sym_enumerator_list,
    STATE(3535), 1,
      sym_attribute_specifier,
    ACTIONS(5293), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5295), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [47210] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6542), 1,
      anon_sym_namespace,
    ACTIONS(6124), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6122), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [47274] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6544), 1,
      anon_sym_typedef,
    ACTIONS(2821), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2819), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [47338] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6546), 1,
      anon_sym_namespace,
    ACTIONS(6124), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6122), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [47402] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1967), 1,
      anon_sym_LBRACE,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    STATE(3454), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5609), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5611), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [47470] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4541), 1,
      anon_sym_LBRACE,
    ACTIONS(5149), 1,
      anon_sym_LT,
    STATE(3123), 1,
      sym_template_argument_list,
    ACTIONS(4543), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4536), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [47540] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3602), 1,
      anon_sym_DQUOTE_DQUOTE,
    ACTIONS(6548), 2,
      anon_sym_delete,
      anon_sym_new,
    ACTIONS(3598), 20,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_not,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DASH_GT,
    ACTIONS(3596), 31,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_compl,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_co_await,
      anon_sym_DASH_GT_STAR,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LBRACK_RBRACK,
  [47606] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5125), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5127), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [47668] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5121), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5123), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [47730] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6311), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(3036), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5605), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5607), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [47796] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5105), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5107), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [47858] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5117), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5119), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [47920] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5093), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5095), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [47982] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5085), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5087), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [48044] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5109), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5111), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [48106] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    STATE(2640), 1,
      sym_attribute_specifier,
    ACTIONS(5487), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5485), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [48171] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6554), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6556), 1,
      anon_sym_PIPE,
    ACTIONS(6560), 1,
      anon_sym_AMP,
    ACTIONS(6566), 1,
      anon_sym_GT_EQ,
    ACTIONS(6570), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6572), 1,
      anon_sym_and,
    ACTIONS(6574), 1,
      anon_sym_bitor,
    ACTIONS(6576), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(5724), 2,
      anon_sym_EQ,
      anon_sym_or,
    ACTIONS(6550), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6558), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6568), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6552), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6562), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6564), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5726), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [48274] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6256), 1,
      anon_sym_EQ,
    ACTIONS(6554), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6556), 1,
      anon_sym_PIPE,
    ACTIONS(6560), 1,
      anon_sym_AMP,
    ACTIONS(6566), 1,
      anon_sym_GT_EQ,
    ACTIONS(6570), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6572), 1,
      anon_sym_and,
    ACTIONS(6574), 1,
      anon_sym_bitor,
    ACTIONS(6576), 1,
      anon_sym_bitand,
    ACTIONS(6578), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6580), 1,
      anon_sym_or,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6550), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6558), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6568), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6552), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6562), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6564), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6258), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [48381] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6371), 1,
      anon_sym_LBRACK,
    ACTIONS(6582), 1,
      anon_sym_DOT_STAR,
    STATE(3367), 1,
      sym_argument_list,
    STATE(3368), 1,
      sym_subscript_argument_list,
    ACTIONS(6413), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6415), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5775), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(5777), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [48456] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5062), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5064), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [48517] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5054), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5056), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [48578] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6136), 1,
      anon_sym___attribute__,
    STATE(3462), 1,
      sym_attribute_specifier,
    ACTIONS(5493), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5495), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [48643] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4575), 1,
      anon_sym_const,
    ACTIONS(4586), 1,
      anon_sym_AMP,
    ACTIONS(4579), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
      anon_sym_GT2,
    ACTIONS(4584), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4582), 16,
      anon_sym___extension__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(4577), 18,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [48712] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4541), 1,
      anon_sym_LBRACE,
    ACTIONS(5220), 1,
      anon_sym_LT,
    STATE(3347), 1,
      sym_template_argument_list,
    ACTIONS(4543), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4536), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [48781] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6584), 1,
      anon_sym_LT,
    STATE(1828), 1,
      sym_template_argument_list,
    ACTIONS(5750), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5752), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [48846] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6136), 1,
      anon_sym___attribute__,
    STATE(3455), 1,
      sym_attribute_specifier,
    ACTIONS(5481), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5483), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [48911] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6269), 1,
      anon_sym_EQ,
    ACTIONS(6554), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6556), 1,
      anon_sym_PIPE,
    ACTIONS(6560), 1,
      anon_sym_AMP,
    ACTIONS(6566), 1,
      anon_sym_GT_EQ,
    ACTIONS(6570), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6572), 1,
      anon_sym_and,
    ACTIONS(6574), 1,
      anon_sym_bitor,
    ACTIONS(6576), 1,
      anon_sym_bitand,
    ACTIONS(6578), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6580), 1,
      anon_sym_or,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6550), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6558), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6568), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6552), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6562), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6564), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6271), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [49018] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3652), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3650), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [49079] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6587), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(5730), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5732), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [49142] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6589), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(5730), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5732), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [49205] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2236), 1,
      anon_sym_LBRACE,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    STATE(3562), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5625), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5627), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [49272] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6591), 1,
      anon_sym_LT,
    STATE(1690), 1,
      sym_template_argument_list,
    ACTIONS(5750), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5752), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [49337] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6371), 1,
      anon_sym_LBRACK,
    ACTIONS(6582), 1,
      anon_sym_DOT_STAR,
    STATE(3367), 1,
      sym_argument_list,
    STATE(3368), 1,
      sym_subscript_argument_list,
    ACTIONS(6415), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5698), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(5700), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT_STAR,
  [49410] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    STATE(2684), 1,
      sym_attribute_specifier,
    ACTIONS(5365), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5363), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [49475] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4920), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT2,
    ACTIONS(4918), 41,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [49536] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6103), 1,
      anon_sym_LT,
    STATE(2843), 1,
      sym_template_argument_list,
    ACTIONS(3785), 7,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(5187), 43,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [49603] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5058), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5060), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [49664] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5827), 1,
      anon_sym_LT,
    STATE(3302), 1,
      sym_template_argument_list,
    ACTIONS(5672), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5674), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [49731] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    STATE(2654), 1,
      sym_attribute_specifier,
    ACTIONS(5501), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5499), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [49796] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5042), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5044), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [49857] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6269), 1,
      anon_sym_EQ,
    ACTIONS(6371), 1,
      anon_sym_LBRACK,
    ACTIONS(6399), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6582), 1,
      anon_sym_DOT_STAR,
    ACTIONS(6598), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6600), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6602), 1,
      anon_sym_PIPE,
    ACTIONS(6606), 1,
      anon_sym_AMP,
    ACTIONS(6612), 1,
      anon_sym_GT_EQ,
    ACTIONS(6616), 1,
      anon_sym_or,
    ACTIONS(6618), 1,
      anon_sym_and,
    ACTIONS(6620), 1,
      anon_sym_bitor,
    ACTIONS(6622), 1,
      anon_sym_bitand,
    STATE(3367), 1,
      sym_argument_list,
    STATE(3368), 1,
      sym_subscript_argument_list,
    ACTIONS(6413), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6415), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6594), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6604), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6614), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6596), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6608), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6610), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6271), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [49964] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    STATE(2663), 1,
      sym_attribute_specifier,
    ACTIONS(5491), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5489), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [50029] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5185), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [50090] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6279), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6277), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [50151] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4924), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4926), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [50212] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6248), 1,
      anon_sym_EQ,
    ACTIONS(6371), 1,
      anon_sym_LBRACK,
    ACTIONS(6399), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6582), 1,
      anon_sym_DOT_STAR,
    ACTIONS(6598), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6600), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6602), 1,
      anon_sym_PIPE,
    ACTIONS(6606), 1,
      anon_sym_AMP,
    ACTIONS(6612), 1,
      anon_sym_GT_EQ,
    ACTIONS(6616), 1,
      anon_sym_or,
    ACTIONS(6618), 1,
      anon_sym_and,
    ACTIONS(6620), 1,
      anon_sym_bitor,
    ACTIONS(6622), 1,
      anon_sym_bitand,
    STATE(3367), 1,
      sym_argument_list,
    STATE(3368), 1,
      sym_subscript_argument_list,
    ACTIONS(6413), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6415), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6594), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6604), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6614), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6596), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6608), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6610), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6250), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [50319] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    STATE(2637), 1,
      sym_attribute_specifier,
    ACTIONS(5483), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5481), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [50384] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6371), 1,
      anon_sym_LBRACK,
    ACTIONS(6582), 1,
      anon_sym_DOT_STAR,
    STATE(3367), 1,
      sym_argument_list,
    STATE(3368), 1,
      sym_subscript_argument_list,
    ACTIONS(6413), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6415), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6594), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6614), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6596), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5724), 10,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(5726), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [50465] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5050), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5052), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [50526] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5034), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5036), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [50587] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6371), 1,
      anon_sym_LBRACK,
    ACTIONS(6399), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6582), 1,
      anon_sym_DOT_STAR,
    ACTIONS(6612), 1,
      anon_sym_GT_EQ,
    STATE(3367), 1,
      sym_argument_list,
    STATE(3368), 1,
      sym_subscript_argument_list,
    ACTIONS(6413), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6415), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6594), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6614), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6596), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6608), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6610), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5724), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(5726), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_DASH_GT_STAR,
  [50676] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5038), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5040), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [50737] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5152), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5154), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [50798] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5050), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5052), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [50859] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5093), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5095), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [50920] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5050), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5052), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [50981] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5160), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5162), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [51042] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5085), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5087), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [51103] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6371), 1,
      anon_sym_LBRACK,
    ACTIONS(6582), 1,
      anon_sym_DOT_STAR,
    STATE(3367), 1,
      sym_argument_list,
    STATE(3368), 1,
      sym_subscript_argument_list,
    ACTIONS(6413), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6415), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6594), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6596), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5724), 12,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(5726), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [51182] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6136), 1,
      anon_sym___attribute__,
    STATE(3546), 1,
      sym_attribute_specifier,
    ACTIONS(5456), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5458), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [51247] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    STATE(2623), 1,
      sym_attribute_specifier,
    ACTIONS(5388), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5386), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [51312] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6136), 1,
      anon_sym___attribute__,
    STATE(3536), 1,
      sym_attribute_specifier,
    ACTIONS(5452), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5454), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [51377] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6371), 1,
      anon_sym_LBRACK,
    ACTIONS(6399), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6582), 1,
      anon_sym_DOT_STAR,
    STATE(3367), 1,
      sym_argument_list,
    STATE(3368), 1,
      sym_subscript_argument_list,
    ACTIONS(6413), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6415), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6594), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6614), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6596), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5724), 10,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(5726), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [51460] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5070), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5072), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [51521] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6371), 1,
      anon_sym_LBRACK,
    ACTIONS(6582), 1,
      anon_sym_DOT_STAR,
    STATE(3367), 1,
      sym_argument_list,
    STATE(3368), 1,
      sym_subscript_argument_list,
    ACTIONS(6413), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6415), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5771), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(5773), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [51596] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    STATE(2656), 1,
      sym_attribute_specifier,
    ACTIONS(5402), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5400), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [51661] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    STATE(2682), 1,
      sym_attribute_specifier,
    ACTIONS(5495), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5493), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [51726] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    STATE(2697), 1,
      sym_attribute_specifier,
    ACTIONS(5416), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5414), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [51791] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5164), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5166), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [51852] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5046), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5048), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [51913] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6136), 1,
      anon_sym___attribute__,
    STATE(3531), 1,
      sym_attribute_specifier,
    ACTIONS(5400), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5402), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [51978] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(5934), 1,
      anon_sym_EQ,
    ACTIONS(6218), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6554), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6556), 1,
      anon_sym_PIPE,
    ACTIONS(6560), 1,
      anon_sym_AMP,
    ACTIONS(6566), 1,
      anon_sym_GT_EQ,
    ACTIONS(6570), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6572), 1,
      anon_sym_and,
    ACTIONS(6574), 1,
      anon_sym_bitor,
    ACTIONS(6576), 1,
      anon_sym_bitand,
    ACTIONS(6578), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6580), 1,
      anon_sym_or,
    ACTIONS(6624), 1,
      anon_sym_QMARK,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6550), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6558), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6568), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6552), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6562), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6564), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5936), 16,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [52089] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6136), 1,
      anon_sym___attribute__,
    STATE(3525), 1,
      sym_attribute_specifier,
    ACTIONS(5386), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5388), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [52154] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6626), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(3119), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5532), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5534), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [52219] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6244), 1,
      anon_sym_EQ,
    ACTIONS(6329), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6371), 1,
      anon_sym_LBRACK,
    ACTIONS(6375), 1,
      anon_sym_QMARK,
    ACTIONS(6399), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6582), 1,
      anon_sym_DOT_STAR,
    ACTIONS(6598), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6600), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6602), 1,
      anon_sym_PIPE,
    ACTIONS(6606), 1,
      anon_sym_AMP,
    ACTIONS(6612), 1,
      anon_sym_GT_EQ,
    ACTIONS(6616), 1,
      anon_sym_or,
    ACTIONS(6618), 1,
      anon_sym_and,
    ACTIONS(6620), 1,
      anon_sym_bitor,
    ACTIONS(6622), 1,
      anon_sym_bitand,
    STATE(3367), 1,
      sym_argument_list,
    STATE(3368), 1,
      sym_subscript_argument_list,
    ACTIONS(6413), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6415), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6594), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6604), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6614), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6596), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6608), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6610), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6246), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [52330] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6371), 1,
      anon_sym_LBRACK,
    ACTIONS(6399), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6582), 1,
      anon_sym_DOT_STAR,
    ACTIONS(6612), 1,
      anon_sym_GT_EQ,
    STATE(3367), 1,
      sym_argument_list,
    STATE(3368), 1,
      sym_subscript_argument_list,
    ACTIONS(6413), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6415), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6594), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6614), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6596), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6610), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5724), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(5726), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [52417] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5179), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5181), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [52478] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4582), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(4584), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4577), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [52541] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6475), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(3119), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5605), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5607), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [52606] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6067), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6635), 1,
      anon_sym___attribute__,
    ACTIONS(6638), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6641), 1,
      anon_sym___declspec,
    ACTIONS(6644), 1,
      anon_sym_virtual,
    ACTIONS(6647), 1,
      anon_sym_alignas,
    ACTIONS(6632), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    STATE(3125), 9,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      sym_virtual,
      sym_alignas_specifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(6629), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
    ACTIONS(6065), 16,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
  [52683] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2236), 1,
      anon_sym_LBRACE,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    STATE(3672), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5565), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5567), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [52750] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6371), 1,
      anon_sym_LBRACK,
    ACTIONS(6582), 1,
      anon_sym_DOT_STAR,
    STATE(3367), 1,
      sym_argument_list,
    STATE(3368), 1,
      sym_subscript_argument_list,
    ACTIONS(6413), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6415), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5767), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(5769), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [52825] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6124), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6122), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [52886] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6552), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5724), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(5726), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [52963] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3648), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3646), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [53024] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6275), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6273), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [53085] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6556), 1,
      anon_sym_PIPE,
    ACTIONS(6560), 1,
      anon_sym_AMP,
    ACTIONS(6566), 1,
      anon_sym_GT_EQ,
    ACTIONS(6570), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6574), 1,
      anon_sym_bitor,
    ACTIONS(6576), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6550), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6558), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6568), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5724), 3,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(6552), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6562), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6564), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5726), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [53184] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5168), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5170), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [53245] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6584), 1,
      anon_sym_LT,
    STATE(2992), 1,
      sym_template_argument_list,
    ACTIONS(5750), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5752), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [53310] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    STATE(2667), 1,
      sym_attribute_specifier,
    ACTIONS(5454), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5452), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [53375] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6240), 1,
      anon_sym_EQ,
    ACTIONS(6371), 1,
      anon_sym_LBRACK,
    ACTIONS(6399), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6582), 1,
      anon_sym_DOT_STAR,
    ACTIONS(6598), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6600), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6602), 1,
      anon_sym_PIPE,
    ACTIONS(6606), 1,
      anon_sym_AMP,
    ACTIONS(6612), 1,
      anon_sym_GT_EQ,
    ACTIONS(6616), 1,
      anon_sym_or,
    ACTIONS(6618), 1,
      anon_sym_and,
    ACTIONS(6620), 1,
      anon_sym_bitor,
    ACTIONS(6622), 1,
      anon_sym_bitand,
    STATE(3367), 1,
      sym_argument_list,
    STATE(3368), 1,
      sym_subscript_argument_list,
    ACTIONS(6413), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6415), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6594), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6604), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6614), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6596), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6608), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6610), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6242), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [53482] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6305), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6303), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [53543] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2236), 1,
      anon_sym_LBRACE,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    STATE(3675), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5609), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5611), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [53610] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6371), 1,
      anon_sym_LBRACK,
    ACTIONS(6399), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6582), 1,
      anon_sym_DOT_STAR,
    ACTIONS(6606), 1,
      anon_sym_AMP,
    ACTIONS(6612), 1,
      anon_sym_GT_EQ,
    ACTIONS(6622), 1,
      anon_sym_bitand,
    STATE(3367), 1,
      sym_argument_list,
    STATE(3368), 1,
      sym_subscript_argument_list,
    ACTIONS(6413), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6415), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6594), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6614), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6596), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6608), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6610), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5724), 6,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(5726), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_DASH_GT_STAR,
  [53703] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6371), 1,
      anon_sym_LBRACK,
    ACTIONS(6399), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6582), 1,
      anon_sym_DOT_STAR,
    ACTIONS(6606), 1,
      anon_sym_AMP,
    ACTIONS(6612), 1,
      anon_sym_GT_EQ,
    ACTIONS(6622), 1,
      anon_sym_bitand,
    STATE(3367), 1,
      sym_argument_list,
    STATE(3368), 1,
      sym_subscript_argument_list,
    ACTIONS(6413), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6415), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6594), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6604), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6614), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6596), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6608), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6610), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5724), 4,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(5726), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_DASH_GT_STAR,
  [53798] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6371), 1,
      anon_sym_LBRACK,
    ACTIONS(6399), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6582), 1,
      anon_sym_DOT_STAR,
    ACTIONS(6602), 1,
      anon_sym_PIPE,
    ACTIONS(6606), 1,
      anon_sym_AMP,
    ACTIONS(6612), 1,
      anon_sym_GT_EQ,
    ACTIONS(6620), 1,
      anon_sym_bitor,
    ACTIONS(6622), 1,
      anon_sym_bitand,
    STATE(3367), 1,
      sym_argument_list,
    STATE(3368), 1,
      sym_subscript_argument_list,
    ACTIONS(6413), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6415), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6594), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6604), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6614), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5724), 3,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(6596), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6608), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6610), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5726), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [53897] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6371), 1,
      anon_sym_LBRACK,
    ACTIONS(6399), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6582), 1,
      anon_sym_DOT_STAR,
    ACTIONS(6600), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6602), 1,
      anon_sym_PIPE,
    ACTIONS(6606), 1,
      anon_sym_AMP,
    ACTIONS(6612), 1,
      anon_sym_GT_EQ,
    ACTIONS(6618), 1,
      anon_sym_and,
    ACTIONS(6620), 1,
      anon_sym_bitor,
    ACTIONS(6622), 1,
      anon_sym_bitand,
    STATE(3367), 1,
      sym_argument_list,
    STATE(3368), 1,
      sym_subscript_argument_list,
    ACTIONS(5724), 2,
      anon_sym_EQ,
      anon_sym_or,
    ACTIONS(6413), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6415), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6594), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6604), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6614), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6596), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6608), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6610), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5726), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [54000] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    STATE(2676), 1,
      sym_attribute_specifier,
    ACTIONS(5458), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5456), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [54065] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6371), 1,
      anon_sym_LBRACK,
    ACTIONS(6582), 1,
      anon_sym_DOT_STAR,
    STATE(3367), 1,
      sym_argument_list,
    STATE(3368), 1,
      sym_subscript_argument_list,
    ACTIONS(6413), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6415), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5724), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(5726), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [54140] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6371), 1,
      anon_sym_LBRACK,
    ACTIONS(6582), 1,
      anon_sym_DOT_STAR,
    STATE(3367), 1,
      sym_argument_list,
    STATE(3368), 1,
      sym_subscript_argument_list,
    ACTIONS(6413), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6415), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6596), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5724), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(5726), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [54217] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6591), 1,
      anon_sym_LT,
    STATE(2854), 1,
      sym_template_argument_list,
    ACTIONS(5750), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5752), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [54282] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5089), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5091), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [54343] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5099), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [54404] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6371), 1,
      anon_sym_LBRACK,
    ACTIONS(6582), 1,
      anon_sym_DOT_STAR,
    STATE(3367), 1,
      sym_argument_list,
    STATE(3368), 1,
      sym_subscript_argument_list,
    ACTIONS(6413), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6415), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5718), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(5720), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [54479] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6657), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6653), 4,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(6655), 5,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_explicit,
      anon_sym_operator,
    ACTIONS(6660), 13,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_auto,
      anon_sym_typename,
    ACTIONS(6650), 29,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
  [54546] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5109), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5111), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [54607] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5113), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5115), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [54668] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6103), 1,
      anon_sym_LT,
    STATE(2843), 1,
      sym_template_argument_list,
    ACTIONS(4541), 7,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(4534), 43,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [54735] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5121), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5123), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [54796] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6566), 1,
      anon_sym_GT_EQ,
    ACTIONS(6570), 1,
      anon_sym_LT_EQ_GT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6550), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6568), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6552), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6564), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5724), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(5726), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [54883] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5125), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5127), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [54944] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6371), 1,
      anon_sym_LBRACK,
    ACTIONS(6582), 1,
      anon_sym_DOT_STAR,
    STATE(3367), 1,
      sym_argument_list,
    STATE(3368), 1,
      sym_subscript_argument_list,
    ACTIONS(6415), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5813), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(5815), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT_STAR,
  [55017] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6256), 1,
      anon_sym_EQ,
    ACTIONS(6371), 1,
      anon_sym_LBRACK,
    ACTIONS(6399), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6582), 1,
      anon_sym_DOT_STAR,
    ACTIONS(6598), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6600), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6602), 1,
      anon_sym_PIPE,
    ACTIONS(6606), 1,
      anon_sym_AMP,
    ACTIONS(6612), 1,
      anon_sym_GT_EQ,
    ACTIONS(6616), 1,
      anon_sym_or,
    ACTIONS(6618), 1,
      anon_sym_and,
    ACTIONS(6620), 1,
      anon_sym_bitor,
    ACTIONS(6622), 1,
      anon_sym_bitand,
    STATE(3367), 1,
      sym_argument_list,
    STATE(3368), 1,
      sym_subscript_argument_list,
    ACTIONS(6413), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6415), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6594), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6604), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6614), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6596), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6608), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6610), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6258), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [55124] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6560), 1,
      anon_sym_AMP,
    ACTIONS(6566), 1,
      anon_sym_GT_EQ,
    ACTIONS(6570), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6576), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6550), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6558), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6568), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6552), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6562), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6564), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5724), 4,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(5726), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
  [55219] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6560), 1,
      anon_sym_AMP,
    ACTIONS(6566), 1,
      anon_sym_GT_EQ,
    ACTIONS(6570), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6576), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6550), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6568), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6552), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6562), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6564), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5724), 6,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(5726), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
  [55312] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6566), 1,
      anon_sym_GT_EQ,
    ACTIONS(6570), 1,
      anon_sym_LT_EQ_GT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6550), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6568), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6552), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6562), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6564), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5724), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(5726), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
  [55401] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5172), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5174), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [55462] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6136), 1,
      anon_sym___attribute__,
    STATE(3492), 1,
      sym_attribute_specifier,
    ACTIONS(5363), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5365), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [55527] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6136), 1,
      anon_sym___attribute__,
    STATE(3490), 1,
      sym_attribute_specifier,
    ACTIONS(5414), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5416), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [55592] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5074), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5076), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [55653] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6136), 1,
      anon_sym___attribute__,
    STATE(3489), 1,
      sym_attribute_specifier,
    ACTIONS(5489), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5491), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [55718] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5129), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5131), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [55779] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5121), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5123), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [55840] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5201), 1,
      sym_literal_suffix,
    STATE(2617), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(3204), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(3208), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5197), 15,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(5199), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [55909] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6136), 1,
      anon_sym___attribute__,
    STATE(3487), 1,
      sym_attribute_specifier,
    ACTIONS(5499), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5501), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [55974] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6216), 1,
      anon_sym_EQ,
    ACTIONS(6218), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6554), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6556), 1,
      anon_sym_PIPE,
    ACTIONS(6560), 1,
      anon_sym_AMP,
    ACTIONS(6566), 1,
      anon_sym_GT_EQ,
    ACTIONS(6570), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6572), 1,
      anon_sym_and,
    ACTIONS(6574), 1,
      anon_sym_bitor,
    ACTIONS(6576), 1,
      anon_sym_bitand,
    ACTIONS(6578), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6580), 1,
      anon_sym_or,
    ACTIONS(6624), 1,
      anon_sym_QMARK,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6550), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6558), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6568), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6552), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6562), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6564), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6220), 16,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [56085] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6240), 1,
      anon_sym_EQ,
    ACTIONS(6554), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6556), 1,
      anon_sym_PIPE,
    ACTIONS(6560), 1,
      anon_sym_AMP,
    ACTIONS(6566), 1,
      anon_sym_GT_EQ,
    ACTIONS(6570), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6572), 1,
      anon_sym_and,
    ACTIONS(6574), 1,
      anon_sym_bitor,
    ACTIONS(6576), 1,
      anon_sym_bitand,
    ACTIONS(6578), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6580), 1,
      anon_sym_or,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6550), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6558), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6568), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6552), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6562), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6564), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6242), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [56192] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6218), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6244), 1,
      anon_sym_EQ,
    ACTIONS(6554), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6556), 1,
      anon_sym_PIPE,
    ACTIONS(6560), 1,
      anon_sym_AMP,
    ACTIONS(6566), 1,
      anon_sym_GT_EQ,
    ACTIONS(6570), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6572), 1,
      anon_sym_and,
    ACTIONS(6574), 1,
      anon_sym_bitor,
    ACTIONS(6576), 1,
      anon_sym_bitand,
    ACTIONS(6578), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6580), 1,
      anon_sym_or,
    ACTIONS(6624), 1,
      anon_sym_QMARK,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6550), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6558), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6568), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6552), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6562), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6564), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6246), 16,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [56303] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5827), 1,
      anon_sym_LT,
    STATE(3302), 1,
      sym_template_argument_list,
    ACTIONS(5666), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5668), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [56370] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6248), 1,
      anon_sym_EQ,
    ACTIONS(6554), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6556), 1,
      anon_sym_PIPE,
    ACTIONS(6560), 1,
      anon_sym_AMP,
    ACTIONS(6566), 1,
      anon_sym_GT_EQ,
    ACTIONS(6570), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6572), 1,
      anon_sym_and,
    ACTIONS(6574), 1,
      anon_sym_bitor,
    ACTIONS(6576), 1,
      anon_sym_bitand,
    ACTIONS(6578), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6580), 1,
      anon_sym_or,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6550), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6558), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6568), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6552), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6562), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6564), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6250), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [56477] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6570), 1,
      anon_sym_LT_EQ_GT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6550), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6568), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6552), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5724), 10,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(5726), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [56560] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6216), 1,
      anon_sym_EQ,
    ACTIONS(6329), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6371), 1,
      anon_sym_LBRACK,
    ACTIONS(6375), 1,
      anon_sym_QMARK,
    ACTIONS(6399), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6582), 1,
      anon_sym_DOT_STAR,
    ACTIONS(6598), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6600), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6602), 1,
      anon_sym_PIPE,
    ACTIONS(6606), 1,
      anon_sym_AMP,
    ACTIONS(6612), 1,
      anon_sym_GT_EQ,
    ACTIONS(6616), 1,
      anon_sym_or,
    ACTIONS(6618), 1,
      anon_sym_and,
    ACTIONS(6620), 1,
      anon_sym_bitor,
    ACTIONS(6622), 1,
      anon_sym_bitand,
    STATE(3367), 1,
      sym_argument_list,
    STATE(3368), 1,
      sym_subscript_argument_list,
    ACTIONS(6413), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6415), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6594), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6604), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6614), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6596), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6608), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6610), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6220), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [56671] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5201), 1,
      sym_literal_suffix,
    STATE(2617), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(3204), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(3208), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(3769), 15,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(3761), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [56740] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    STATE(2703), 1,
      sym_attribute_specifier,
    ACTIONS(5475), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5473), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [56805] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5145), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5147), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [56866] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(3803), 1,
      anon_sym_LPAREN2,
    ACTIONS(3805), 1,
      anon_sym_STAR,
    ACTIONS(3807), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3809), 1,
      anon_sym_AMP,
    ACTIONS(4841), 1,
      sym_identifier,
    ACTIONS(5523), 1,
      anon_sym_LBRACK,
    ACTIONS(5555), 1,
      anon_sym_RPAREN,
    ACTIONS(5825), 1,
      anon_sym_COLON_COLON,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(5610), 1,
      sym__scope_resolution,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6284), 1,
      sym__declarator,
    STATE(6435), 1,
      sym__abstract_declarator,
    STATE(8318), 1,
      sym_ms_based_modifier,
    STATE(4972), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [56971] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6550), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6552), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5724), 12,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(5726), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [57050] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6550), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6568), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6552), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5724), 10,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(5726), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [57131] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4924), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4926), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [57192] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(3803), 1,
      anon_sym_LPAREN2,
    ACTIONS(3805), 1,
      anon_sym_STAR,
    ACTIONS(3807), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3809), 1,
      anon_sym_AMP,
    ACTIONS(4841), 1,
      sym_identifier,
    ACTIONS(5523), 1,
      anon_sym_LBRACK,
    ACTIONS(5825), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6297), 1,
      anon_sym_RPAREN,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(5610), 1,
      sym__scope_resolution,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6221), 1,
      sym__declarator,
    STATE(6449), 1,
      sym__abstract_declarator,
    STATE(8318), 1,
      sym_ms_based_modifier,
    STATE(4972), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [57297] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6136), 1,
      anon_sym___attribute__,
    STATE(3433), 1,
      sym_attribute_specifier,
    ACTIONS(5473), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5475), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [57362] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5135), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5137), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [57423] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2236), 1,
      anon_sym_LBRACE,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    STATE(3636), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5561), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5563), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [57490] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1767), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4766), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(4770), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5142), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5139), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [57557] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6165), 1,
      anon_sym_LBRACK,
    STATE(3243), 1,
      sym_new_declarator,
    ACTIONS(5681), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5683), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [57622] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5934), 1,
      anon_sym_EQ,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6329), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6371), 1,
      anon_sym_LBRACK,
    ACTIONS(6375), 1,
      anon_sym_QMARK,
    ACTIONS(6399), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6582), 1,
      anon_sym_DOT_STAR,
    ACTIONS(6598), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6600), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6602), 1,
      anon_sym_PIPE,
    ACTIONS(6606), 1,
      anon_sym_AMP,
    ACTIONS(6612), 1,
      anon_sym_GT_EQ,
    ACTIONS(6616), 1,
      anon_sym_or,
    ACTIONS(6618), 1,
      anon_sym_and,
    ACTIONS(6620), 1,
      anon_sym_bitor,
    ACTIONS(6622), 1,
      anon_sym_bitand,
    STATE(3367), 1,
      sym_argument_list,
    STATE(3368), 1,
      sym_subscript_argument_list,
    ACTIONS(6413), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6415), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6594), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6604), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6614), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6596), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6608), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6610), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5936), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [57733] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6136), 1,
      anon_sym___attribute__,
    STATE(3435), 1,
      sym_attribute_specifier,
    ACTIONS(5485), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5487), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [57798] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5156), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5158), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [57858] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6218), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6244), 1,
      anon_sym_EQ,
    ACTIONS(6666), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6670), 1,
      anon_sym_PIPE,
    ACTIONS(6674), 1,
      anon_sym_AMP,
    ACTIONS(6680), 1,
      anon_sym_GT_EQ,
    ACTIONS(6684), 1,
      anon_sym_QMARK,
    ACTIONS(6686), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6688), 1,
      anon_sym_or,
    ACTIONS(6690), 1,
      anon_sym_and,
    ACTIONS(6692), 1,
      anon_sym_bitor,
    ACTIONS(6694), 1,
      anon_sym_bitand,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6662), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6672), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6682), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6664), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6676), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6678), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6246), 15,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [57968] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6371), 1,
      anon_sym_LBRACK,
    ACTIONS(6417), 1,
      anon_sym_DOT_STAR,
    ACTIONS(6419), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(6700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6702), 1,
      anon_sym_COMMA,
    ACTIONS(6704), 1,
      anon_sym_RPAREN,
    ACTIONS(6706), 1,
      anon_sym_DASH,
    ACTIONS(6708), 1,
      anon_sym_PLUS,
    ACTIONS(6710), 1,
      anon_sym_STAR,
    ACTIONS(6712), 1,
      anon_sym_SLASH,
    ACTIONS(6714), 1,
      anon_sym_PERCENT,
    ACTIONS(6716), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6718), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6720), 1,
      anon_sym_PIPE,
    ACTIONS(6722), 1,
      anon_sym_CARET,
    ACTIONS(6724), 1,
      anon_sym_AMP,
    ACTIONS(6726), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6728), 1,
      anon_sym_BANG_EQ,
    ACTIONS(6730), 1,
      anon_sym_GT,
    ACTIONS(6732), 1,
      anon_sym_GT_EQ,
    ACTIONS(6734), 1,
      anon_sym_LT_EQ,
    ACTIONS(6736), 1,
      anon_sym_LT,
    ACTIONS(6738), 1,
      anon_sym_LT_LT,
    ACTIONS(6740), 1,
      anon_sym_GT_GT,
    ACTIONS(6742), 1,
      anon_sym_EQ,
    ACTIONS(6744), 1,
      anon_sym_QMARK,
    ACTIONS(6746), 1,
      anon_sym_STAR_EQ,
    ACTIONS(6748), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(6750), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(6752), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(6754), 1,
      anon_sym_DASH_EQ,
    ACTIONS(6756), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(6758), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(6760), 1,
      anon_sym_AMP_EQ,
    ACTIONS(6762), 1,
      anon_sym_CARET_EQ,
    ACTIONS(6764), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(6766), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6768), 1,
      anon_sym_or,
    ACTIONS(6770), 1,
      anon_sym_and,
    ACTIONS(6772), 1,
      anon_sym_bitor,
    ACTIONS(6774), 1,
      anon_sym_xor,
    ACTIONS(6776), 1,
      anon_sym_bitand,
    ACTIONS(6778), 1,
      anon_sym_not_eq,
    STATE(1375), 1,
      sym__binary_fold_operator,
    STATE(3367), 1,
      sym_argument_list,
    STATE(3368), 1,
      sym_subscript_argument_list,
    STATE(7963), 1,
      sym__fold_operator,
    ACTIONS(6415), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6780), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [58124] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6248), 1,
      anon_sym_EQ,
    ACTIONS(6666), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6670), 1,
      anon_sym_PIPE,
    ACTIONS(6674), 1,
      anon_sym_AMP,
    ACTIONS(6680), 1,
      anon_sym_GT_EQ,
    ACTIONS(6686), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6688), 1,
      anon_sym_or,
    ACTIONS(6690), 1,
      anon_sym_and,
    ACTIONS(6692), 1,
      anon_sym_bitor,
    ACTIONS(6694), 1,
      anon_sym_bitand,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6662), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6672), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6682), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6664), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6676), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6678), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6250), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [58230] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6289), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6291), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [58290] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6591), 1,
      anon_sym_LT,
    STATE(1709), 1,
      sym_template_argument_list,
    ACTIONS(5750), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5752), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [58354] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5775), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(5777), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [58428] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6046), 1,
      anon_sym_LT,
    STATE(3523), 1,
      sym_template_argument_list,
    ACTIONS(5666), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5668), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [58494] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(6782), 1,
      sym_identifier,
    ACTIONS(6784), 1,
      anon_sym_STAR,
    ACTIONS(6786), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6788), 1,
      anon_sym_AMP,
    ACTIONS(6790), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    STATE(4186), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5612), 1,
      sym__scope_resolution,
    STATE(6284), 1,
      sym__declarator,
    STATE(7612), 1,
      sym_ms_based_modifier,
    ACTIONS(2921), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4065), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4100), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(2919), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [58596] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6662), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6682), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6664), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5724), 10,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(5726), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [58676] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6371), 1,
      anon_sym_LBRACK,
    ACTIONS(6417), 1,
      anon_sym_DOT_STAR,
    ACTIONS(6419), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(6700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6702), 1,
      anon_sym_COMMA,
    ACTIONS(6706), 1,
      anon_sym_DASH,
    ACTIONS(6708), 1,
      anon_sym_PLUS,
    ACTIONS(6710), 1,
      anon_sym_STAR,
    ACTIONS(6712), 1,
      anon_sym_SLASH,
    ACTIONS(6714), 1,
      anon_sym_PERCENT,
    ACTIONS(6716), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6718), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6720), 1,
      anon_sym_PIPE,
    ACTIONS(6722), 1,
      anon_sym_CARET,
    ACTIONS(6724), 1,
      anon_sym_AMP,
    ACTIONS(6726), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6728), 1,
      anon_sym_BANG_EQ,
    ACTIONS(6730), 1,
      anon_sym_GT,
    ACTIONS(6732), 1,
      anon_sym_GT_EQ,
    ACTIONS(6734), 1,
      anon_sym_LT_EQ,
    ACTIONS(6736), 1,
      anon_sym_LT,
    ACTIONS(6738), 1,
      anon_sym_LT_LT,
    ACTIONS(6740), 1,
      anon_sym_GT_GT,
    ACTIONS(6742), 1,
      anon_sym_EQ,
    ACTIONS(6744), 1,
      anon_sym_QMARK,
    ACTIONS(6746), 1,
      anon_sym_STAR_EQ,
    ACTIONS(6748), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(6750), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(6752), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(6754), 1,
      anon_sym_DASH_EQ,
    ACTIONS(6756), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(6758), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(6760), 1,
      anon_sym_AMP_EQ,
    ACTIONS(6762), 1,
      anon_sym_CARET_EQ,
    ACTIONS(6764), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(6766), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6768), 1,
      anon_sym_or,
    ACTIONS(6770), 1,
      anon_sym_and,
    ACTIONS(6772), 1,
      anon_sym_bitor,
    ACTIONS(6774), 1,
      anon_sym_xor,
    ACTIONS(6776), 1,
      anon_sym_bitand,
    ACTIONS(6778), 1,
      anon_sym_not_eq,
    ACTIONS(6794), 1,
      anon_sym_RPAREN,
    STATE(1375), 1,
      sym__binary_fold_operator,
    STATE(3367), 1,
      sym_argument_list,
    STATE(3368), 1,
      sym_subscript_argument_list,
    STATE(7963), 1,
      sym__fold_operator,
    ACTIONS(6415), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6780), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [58832] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6796), 1,
      sym_identifier,
    STATE(3257), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(5344), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(5346), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(4785), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(4783), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [58900] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6124), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6122), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_template,
      anon_sym_operator,
  [58960] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(5511), 1,
      sym_identifier,
    ACTIONS(5521), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    ACTIONS(6798), 1,
      anon_sym_STAR,
    ACTIONS(6800), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6802), 1,
      anon_sym_AMP,
    STATE(4186), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5695), 1,
      sym__scope_resolution,
    STATE(6013), 1,
      sym__declarator,
    STATE(7894), 1,
      sym_ms_based_modifier,
    ACTIONS(2921), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4078), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4100), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(2919), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [59062] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4942), 1,
      anon_sym_LBRACE,
    ACTIONS(4926), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
    ACTIONS(4924), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [59124] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3793), 1,
      anon_sym_EQ,
    ACTIONS(4601), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5250), 1,
      anon_sym_LPAREN2,
    ACTIONS(5253), 1,
      anon_sym_LBRACK,
    ACTIONS(3797), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(3769), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3761), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [59194] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    ACTIONS(6808), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6804), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5724), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(5726), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [59270] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5938), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5940), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [59330] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(5511), 1,
      sym_identifier,
    ACTIONS(5521), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    ACTIONS(6798), 1,
      anon_sym_STAR,
    ACTIONS(6800), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6802), 1,
      anon_sym_AMP,
    STATE(4186), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5695), 1,
      sym__scope_resolution,
    STATE(5967), 1,
      sym__declarator,
    STATE(7894), 1,
      sym_ms_based_modifier,
    ACTIONS(2921), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4083), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4100), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(2919), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [59432] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6371), 1,
      anon_sym_LBRACK,
    ACTIONS(6417), 1,
      anon_sym_DOT_STAR,
    ACTIONS(6419), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(6700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6702), 1,
      anon_sym_COMMA,
    ACTIONS(6706), 1,
      anon_sym_DASH,
    ACTIONS(6708), 1,
      anon_sym_PLUS,
    ACTIONS(6710), 1,
      anon_sym_STAR,
    ACTIONS(6712), 1,
      anon_sym_SLASH,
    ACTIONS(6714), 1,
      anon_sym_PERCENT,
    ACTIONS(6716), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6718), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6720), 1,
      anon_sym_PIPE,
    ACTIONS(6722), 1,
      anon_sym_CARET,
    ACTIONS(6724), 1,
      anon_sym_AMP,
    ACTIONS(6726), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6728), 1,
      anon_sym_BANG_EQ,
    ACTIONS(6730), 1,
      anon_sym_GT,
    ACTIONS(6732), 1,
      anon_sym_GT_EQ,
    ACTIONS(6734), 1,
      anon_sym_LT_EQ,
    ACTIONS(6736), 1,
      anon_sym_LT,
    ACTIONS(6738), 1,
      anon_sym_LT_LT,
    ACTIONS(6740), 1,
      anon_sym_GT_GT,
    ACTIONS(6742), 1,
      anon_sym_EQ,
    ACTIONS(6744), 1,
      anon_sym_QMARK,
    ACTIONS(6746), 1,
      anon_sym_STAR_EQ,
    ACTIONS(6748), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(6750), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(6752), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(6754), 1,
      anon_sym_DASH_EQ,
    ACTIONS(6756), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(6758), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(6760), 1,
      anon_sym_AMP_EQ,
    ACTIONS(6762), 1,
      anon_sym_CARET_EQ,
    ACTIONS(6764), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(6766), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6768), 1,
      anon_sym_or,
    ACTIONS(6770), 1,
      anon_sym_and,
    ACTIONS(6772), 1,
      anon_sym_bitor,
    ACTIONS(6774), 1,
      anon_sym_xor,
    ACTIONS(6776), 1,
      anon_sym_bitand,
    ACTIONS(6778), 1,
      anon_sym_not_eq,
    ACTIONS(6814), 1,
      anon_sym_RPAREN,
    STATE(1375), 1,
      sym__binary_fold_operator,
    STATE(3367), 1,
      sym_argument_list,
    STATE(3368), 1,
      sym_subscript_argument_list,
    STATE(7963), 1,
      sym__fold_operator,
    ACTIONS(6415), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6780), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [59588] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6662), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6664), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5724), 12,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(5726), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [59666] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    ACTIONS(6808), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5724), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(5726), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [59740] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    ACTIONS(6818), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6820), 1,
      anon_sym_PIPE,
    ACTIONS(6824), 1,
      anon_sym_AMP,
    ACTIONS(6832), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6834), 1,
      anon_sym_and,
    ACTIONS(6836), 1,
      anon_sym_bitor,
    ACTIONS(6838), 1,
      anon_sym_bitand,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    ACTIONS(6808), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6816), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6822), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6830), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5724), 3,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
    ACTIONS(6804), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6826), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6828), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5726), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [59840] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    ACTIONS(6820), 1,
      anon_sym_PIPE,
    ACTIONS(6824), 1,
      anon_sym_AMP,
    ACTIONS(6832), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6836), 1,
      anon_sym_bitor,
    ACTIONS(6838), 1,
      anon_sym_bitand,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    ACTIONS(6808), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6816), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6822), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6830), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6804), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6826), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(5724), 4,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(6828), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5726), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [59936] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6240), 1,
      anon_sym_EQ,
    ACTIONS(6666), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6670), 1,
      anon_sym_PIPE,
    ACTIONS(6674), 1,
      anon_sym_AMP,
    ACTIONS(6680), 1,
      anon_sym_GT_EQ,
    ACTIONS(6686), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6688), 1,
      anon_sym_or,
    ACTIONS(6690), 1,
      anon_sym_and,
    ACTIONS(6692), 1,
      anon_sym_bitor,
    ACTIONS(6694), 1,
      anon_sym_bitand,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6662), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6672), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6682), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6664), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6676), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6678), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6242), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [60042] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6216), 1,
      anon_sym_EQ,
    ACTIONS(6218), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6666), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6670), 1,
      anon_sym_PIPE,
    ACTIONS(6674), 1,
      anon_sym_AMP,
    ACTIONS(6680), 1,
      anon_sym_GT_EQ,
    ACTIONS(6684), 1,
      anon_sym_QMARK,
    ACTIONS(6686), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6688), 1,
      anon_sym_or,
    ACTIONS(6690), 1,
      anon_sym_and,
    ACTIONS(6692), 1,
      anon_sym_bitor,
    ACTIONS(6694), 1,
      anon_sym_bitand,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6662), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6672), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6682), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6664), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6676), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6678), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6220), 15,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [60152] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    ACTIONS(6824), 1,
      anon_sym_AMP,
    ACTIONS(6832), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6838), 1,
      anon_sym_bitand,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    ACTIONS(6808), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6816), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6822), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6830), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6804), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6826), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6828), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5724), 5,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(5726), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_GT2,
  [60244] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    ACTIONS(6824), 1,
      anon_sym_AMP,
    ACTIONS(6832), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6838), 1,
      anon_sym_bitand,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    ACTIONS(6808), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6816), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6830), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6804), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6826), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6828), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5724), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(5726), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_GT2,
  [60334] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    ACTIONS(6832), 1,
      anon_sym_LT_EQ_GT,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    ACTIONS(6808), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6816), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6830), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6804), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6826), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6828), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5724), 8,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(5726), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_GT2,
  [60420] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4867), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4869), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [60480] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    ACTIONS(6832), 1,
      anon_sym_LT_EQ_GT,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    ACTIONS(6808), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6816), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6830), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6804), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6828), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5724), 8,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(5726), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [60564] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    ACTIONS(6832), 1,
      anon_sym_LT_EQ_GT,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    ACTIONS(6808), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6816), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6830), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6804), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5724), 12,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(5726), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [60646] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    ACTIONS(6808), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6816), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6804), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5724), 14,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(5726), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [60724] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5589), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5591), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [60784] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    ACTIONS(6808), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6816), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6830), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6804), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5724), 12,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(5726), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [60864] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5583), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5585), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [60924] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5579), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5581), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [60984] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4922), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4942), 1,
      anon_sym_LBRACE,
    ACTIONS(4926), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
    ACTIONS(4924), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [61048] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(6782), 1,
      sym_identifier,
    ACTIONS(6784), 1,
      anon_sym_STAR,
    ACTIONS(6786), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6788), 1,
      anon_sym_AMP,
    ACTIONS(6790), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    STATE(4186), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5612), 1,
      sym__scope_resolution,
    STATE(6279), 1,
      sym__declarator,
    STATE(7612), 1,
      sym_ms_based_modifier,
    ACTIONS(2921), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3201), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4055), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2919), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [61150] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6840), 1,
      anon_sym_LT,
    STATE(2002), 1,
      sym_template_argument_list,
    ACTIONS(5750), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5752), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [61214] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5117), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5119), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [61274] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3793), 1,
      anon_sym_EQ,
    ACTIONS(3797), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(3769), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3761), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [61338] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5105), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5107), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [61398] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6686), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6662), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6682), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6664), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5724), 10,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(5726), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [61480] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5621), 1,
      sym_literal_suffix,
    ACTIONS(3769), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3761), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [61542] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5746), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5748), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [61602] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(2845), 1,
      anon_sym_STAR,
    ACTIONS(2847), 1,
      anon_sym_AMP,
    ACTIONS(4841), 1,
      sym_identifier,
    ACTIONS(5825), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    STATE(4186), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5610), 1,
      sym__scope_resolution,
    STATE(6221), 1,
      sym__declarator,
    STATE(8318), 1,
      sym_ms_based_modifier,
    ACTIONS(2921), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4063), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4100), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(2919), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [61704] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5078), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5080), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [61764] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6680), 1,
      anon_sym_GT_EQ,
    ACTIONS(6686), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6662), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6682), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6664), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6678), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5724), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(5726), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [61850] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4601), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5253), 1,
      anon_sym_LBRACK,
    ACTIONS(5250), 2,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    ACTIONS(3769), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3761), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [61916] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5714), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5716), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [61976] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(5511), 1,
      sym_identifier,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    ACTIONS(6843), 1,
      anon_sym_STAR,
    ACTIONS(6845), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6847), 1,
      anon_sym_AMP,
    ACTIONS(6849), 1,
      anon_sym_COLON_COLON,
    STATE(4186), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5585), 1,
      sym__scope_resolution,
    STATE(6027), 1,
      sym__declarator,
    STATE(7697), 1,
      sym_ms_based_modifier,
    ACTIONS(2921), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4100), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4101), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2919), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [62078] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    ACTIONS(6808), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5775), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(5777), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [62152] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    ACTIONS(6818), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6820), 1,
      anon_sym_PIPE,
    ACTIONS(6824), 1,
      anon_sym_AMP,
    ACTIONS(6832), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6834), 1,
      anon_sym_and,
    ACTIONS(6836), 1,
      anon_sym_bitor,
    ACTIONS(6838), 1,
      anon_sym_bitand,
    ACTIONS(6851), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6853), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6855), 1,
      anon_sym_QMARK,
    ACTIONS(6857), 1,
      anon_sym_or,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    ACTIONS(6216), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(6808), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6816), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6822), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6830), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6804), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6826), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6828), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6220), 14,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [62260] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4601), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5253), 1,
      anon_sym_LBRACK,
    ACTIONS(5250), 2,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    ACTIONS(3769), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3761), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [62326] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    ACTIONS(6818), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6820), 1,
      anon_sym_PIPE,
    ACTIONS(6824), 1,
      anon_sym_AMP,
    ACTIONS(6832), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6834), 1,
      anon_sym_and,
    ACTIONS(6836), 1,
      anon_sym_bitor,
    ACTIONS(6838), 1,
      anon_sym_bitand,
    ACTIONS(6851), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6853), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6855), 1,
      anon_sym_QMARK,
    ACTIONS(6857), 1,
      anon_sym_or,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    ACTIONS(5934), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(6808), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6816), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6822), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6830), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6804), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6826), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6828), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5936), 14,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [62434] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6218), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6431), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6433), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6435), 1,
      anon_sym_PIPE,
    ACTIONS(6439), 1,
      anon_sym_AMP,
    ACTIONS(6445), 1,
      anon_sym_GT_EQ,
    ACTIONS(6449), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6451), 1,
      anon_sym_or,
    ACTIONS(6453), 1,
      anon_sym_and,
    ACTIONS(6455), 1,
      anon_sym_bitor,
    ACTIONS(6457), 1,
      anon_sym_bitand,
    ACTIONS(6459), 1,
      anon_sym_QMARK,
    ACTIONS(6469), 1,
      anon_sym_RPAREN,
    ACTIONS(6859), 1,
      anon_sym_COMMA,
    ACTIONS(6861), 1,
      anon_sym_EQ,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6427), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6437), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6447), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6429), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6441), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6443), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6397), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [62548] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6371), 1,
      anon_sym_LBRACK,
    ACTIONS(6417), 1,
      anon_sym_DOT_STAR,
    ACTIONS(6419), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(6700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6702), 1,
      anon_sym_COMMA,
    ACTIONS(6706), 1,
      anon_sym_DASH,
    ACTIONS(6708), 1,
      anon_sym_PLUS,
    ACTIONS(6710), 1,
      anon_sym_STAR,
    ACTIONS(6712), 1,
      anon_sym_SLASH,
    ACTIONS(6714), 1,
      anon_sym_PERCENT,
    ACTIONS(6716), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6718), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6720), 1,
      anon_sym_PIPE,
    ACTIONS(6722), 1,
      anon_sym_CARET,
    ACTIONS(6724), 1,
      anon_sym_AMP,
    ACTIONS(6726), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6728), 1,
      anon_sym_BANG_EQ,
    ACTIONS(6730), 1,
      anon_sym_GT,
    ACTIONS(6732), 1,
      anon_sym_GT_EQ,
    ACTIONS(6734), 1,
      anon_sym_LT_EQ,
    ACTIONS(6736), 1,
      anon_sym_LT,
    ACTIONS(6738), 1,
      anon_sym_LT_LT,
    ACTIONS(6740), 1,
      anon_sym_GT_GT,
    ACTIONS(6742), 1,
      anon_sym_EQ,
    ACTIONS(6744), 1,
      anon_sym_QMARK,
    ACTIONS(6746), 1,
      anon_sym_STAR_EQ,
    ACTIONS(6748), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(6750), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(6752), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(6754), 1,
      anon_sym_DASH_EQ,
    ACTIONS(6756), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(6758), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(6760), 1,
      anon_sym_AMP_EQ,
    ACTIONS(6762), 1,
      anon_sym_CARET_EQ,
    ACTIONS(6764), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(6766), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6768), 1,
      anon_sym_or,
    ACTIONS(6770), 1,
      anon_sym_and,
    ACTIONS(6772), 1,
      anon_sym_bitor,
    ACTIONS(6774), 1,
      anon_sym_xor,
    ACTIONS(6776), 1,
      anon_sym_bitand,
    ACTIONS(6778), 1,
      anon_sym_not_eq,
    ACTIONS(6863), 1,
      anon_sym_RPAREN,
    STATE(1375), 1,
      sym__binary_fold_operator,
    STATE(3367), 1,
      sym_argument_list,
    STATE(3368), 1,
      sym_subscript_argument_list,
    STATE(7963), 1,
      sym__fold_operator,
    ACTIONS(6415), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6780), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [62704] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6680), 1,
      anon_sym_GT_EQ,
    ACTIONS(6686), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6662), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6682), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6664), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6676), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6678), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5724), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(5726), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
  [62792] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6371), 1,
      anon_sym_LBRACK,
    ACTIONS(6417), 1,
      anon_sym_DOT_STAR,
    ACTIONS(6419), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(6700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6702), 1,
      anon_sym_COMMA,
    ACTIONS(6706), 1,
      anon_sym_DASH,
    ACTIONS(6708), 1,
      anon_sym_PLUS,
    ACTIONS(6710), 1,
      anon_sym_STAR,
    ACTIONS(6712), 1,
      anon_sym_SLASH,
    ACTIONS(6714), 1,
      anon_sym_PERCENT,
    ACTIONS(6716), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6718), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6720), 1,
      anon_sym_PIPE,
    ACTIONS(6722), 1,
      anon_sym_CARET,
    ACTIONS(6724), 1,
      anon_sym_AMP,
    ACTIONS(6726), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6728), 1,
      anon_sym_BANG_EQ,
    ACTIONS(6730), 1,
      anon_sym_GT,
    ACTIONS(6732), 1,
      anon_sym_GT_EQ,
    ACTIONS(6734), 1,
      anon_sym_LT_EQ,
    ACTIONS(6736), 1,
      anon_sym_LT,
    ACTIONS(6738), 1,
      anon_sym_LT_LT,
    ACTIONS(6740), 1,
      anon_sym_GT_GT,
    ACTIONS(6742), 1,
      anon_sym_EQ,
    ACTIONS(6744), 1,
      anon_sym_QMARK,
    ACTIONS(6746), 1,
      anon_sym_STAR_EQ,
    ACTIONS(6748), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(6750), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(6752), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(6754), 1,
      anon_sym_DASH_EQ,
    ACTIONS(6756), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(6758), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(6760), 1,
      anon_sym_AMP_EQ,
    ACTIONS(6762), 1,
      anon_sym_CARET_EQ,
    ACTIONS(6764), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(6766), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6768), 1,
      anon_sym_or,
    ACTIONS(6770), 1,
      anon_sym_and,
    ACTIONS(6772), 1,
      anon_sym_bitor,
    ACTIONS(6774), 1,
      anon_sym_xor,
    ACTIONS(6776), 1,
      anon_sym_bitand,
    ACTIONS(6778), 1,
      anon_sym_not_eq,
    ACTIONS(6865), 1,
      anon_sym_RPAREN,
    STATE(1375), 1,
      sym__binary_fold_operator,
    STATE(3367), 1,
      sym_argument_list,
    STATE(3368), 1,
      sym_subscript_argument_list,
    STATE(7963), 1,
      sym__fold_operator,
    ACTIONS(6415), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6780), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [62948] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6674), 1,
      anon_sym_AMP,
    ACTIONS(6680), 1,
      anon_sym_GT_EQ,
    ACTIONS(6686), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6694), 1,
      anon_sym_bitand,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6662), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6682), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6664), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6676), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6678), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5724), 6,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(5726), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
  [63040] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6204), 1,
      anon_sym_LBRACK,
    STATE(3514), 1,
      sym_new_declarator,
    ACTIONS(5681), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5683), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [63104] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(6782), 1,
      sym_identifier,
    ACTIONS(6784), 1,
      anon_sym_STAR,
    ACTIONS(6786), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6788), 1,
      anon_sym_AMP,
    ACTIONS(6790), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    STATE(4186), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5612), 1,
      sym__scope_resolution,
    STATE(6284), 1,
      sym__declarator,
    STATE(7612), 1,
      sym_ms_based_modifier,
    ACTIONS(2921), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3321), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4065), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2919), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [63206] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(2845), 1,
      anon_sym_STAR,
    ACTIONS(2847), 1,
      anon_sym_AMP,
    ACTIONS(4841), 1,
      sym_identifier,
    ACTIONS(5825), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    STATE(4186), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5610), 1,
      sym__scope_resolution,
    STATE(6284), 1,
      sym__declarator,
    STATE(8318), 1,
      sym_ms_based_modifier,
    ACTIONS(2921), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3239), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4098), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2919), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [63308] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6867), 1,
      sym_identifier,
    STATE(3257), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(6870), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(6873), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(4792), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(4790), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [63376] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6371), 1,
      anon_sym_LBRACK,
    ACTIONS(6417), 1,
      anon_sym_DOT_STAR,
    ACTIONS(6419), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(6700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6702), 1,
      anon_sym_COMMA,
    ACTIONS(6706), 1,
      anon_sym_DASH,
    ACTIONS(6708), 1,
      anon_sym_PLUS,
    ACTIONS(6710), 1,
      anon_sym_STAR,
    ACTIONS(6712), 1,
      anon_sym_SLASH,
    ACTIONS(6714), 1,
      anon_sym_PERCENT,
    ACTIONS(6716), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6718), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6720), 1,
      anon_sym_PIPE,
    ACTIONS(6722), 1,
      anon_sym_CARET,
    ACTIONS(6724), 1,
      anon_sym_AMP,
    ACTIONS(6726), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6728), 1,
      anon_sym_BANG_EQ,
    ACTIONS(6730), 1,
      anon_sym_GT,
    ACTIONS(6732), 1,
      anon_sym_GT_EQ,
    ACTIONS(6734), 1,
      anon_sym_LT_EQ,
    ACTIONS(6736), 1,
      anon_sym_LT,
    ACTIONS(6738), 1,
      anon_sym_LT_LT,
    ACTIONS(6740), 1,
      anon_sym_GT_GT,
    ACTIONS(6742), 1,
      anon_sym_EQ,
    ACTIONS(6744), 1,
      anon_sym_QMARK,
    ACTIONS(6746), 1,
      anon_sym_STAR_EQ,
    ACTIONS(6748), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(6750), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(6752), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(6754), 1,
      anon_sym_DASH_EQ,
    ACTIONS(6756), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(6758), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(6760), 1,
      anon_sym_AMP_EQ,
    ACTIONS(6762), 1,
      anon_sym_CARET_EQ,
    ACTIONS(6764), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(6766), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6768), 1,
      anon_sym_or,
    ACTIONS(6770), 1,
      anon_sym_and,
    ACTIONS(6772), 1,
      anon_sym_bitor,
    ACTIONS(6774), 1,
      anon_sym_xor,
    ACTIONS(6776), 1,
      anon_sym_bitand,
    ACTIONS(6778), 1,
      anon_sym_not_eq,
    ACTIONS(6876), 1,
      anon_sym_RPAREN,
    STATE(1375), 1,
      sym__binary_fold_operator,
    STATE(3367), 1,
      sym_argument_list,
    STATE(3368), 1,
      sym_subscript_argument_list,
    STATE(7963), 1,
      sym__fold_operator,
    ACTIONS(6415), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6780), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [63532] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6674), 1,
      anon_sym_AMP,
    ACTIONS(6680), 1,
      anon_sym_GT_EQ,
    ACTIONS(6686), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6694), 1,
      anon_sym_bitand,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6662), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6672), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6682), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6664), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6676), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6678), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5724), 4,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(5726), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
  [63626] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4926), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4924), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [63686] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3646), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3648), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [63746] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(6317), 1,
      anon_sym_LBRACE,
    ACTIONS(6878), 1,
      anon_sym_COLON,
    STATE(2649), 1,
      sym_attribute_specifier,
    STATE(2966), 1,
      sym__enum_base_clause,
    STATE(3079), 1,
      sym_enumerator_list,
    ACTIONS(5631), 7,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5629), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [63818] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(5511), 1,
      sym_identifier,
    ACTIONS(5521), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    ACTIONS(6798), 1,
      anon_sym_STAR,
    ACTIONS(6800), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6802), 1,
      anon_sym_AMP,
    STATE(4186), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5695), 1,
      sym__scope_resolution,
    STATE(5968), 1,
      sym__declarator,
    STATE(7894), 1,
      sym_ms_based_modifier,
    ACTIONS(2921), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3206), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4048), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2919), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [63920] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5601), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5603), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [63980] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6840), 1,
      anon_sym_LT,
    STATE(3123), 1,
      sym_template_argument_list,
    ACTIONS(5750), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5752), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [64044] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5547), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5549), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [64104] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(5511), 1,
      sym_identifier,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    ACTIONS(6843), 1,
      anon_sym_STAR,
    ACTIONS(6845), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6847), 1,
      anon_sym_AMP,
    ACTIONS(6849), 1,
      anon_sym_COLON_COLON,
    STATE(4186), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5585), 1,
      sym__scope_resolution,
    STATE(5925), 1,
      sym__declarator,
    STATE(7697), 1,
      sym_ms_based_modifier,
    ACTIONS(2921), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3244), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4058), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2919), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [64206] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5597), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5599), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [64266] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(5511), 1,
      sym_identifier,
    ACTIONS(5521), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    ACTIONS(6880), 1,
      anon_sym_STAR,
    ACTIONS(6882), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6884), 1,
      anon_sym_AMP,
    STATE(4186), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5695), 1,
      sym__scope_resolution,
    STATE(6167), 1,
      sym__declarator,
    STATE(7771), 1,
      sym_ms_based_modifier,
    ACTIONS(2921), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3291), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4041), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2919), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [64368] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5593), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5595), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [64428] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(2845), 1,
      anon_sym_STAR,
    ACTIONS(2847), 1,
      anon_sym_AMP,
    ACTIONS(4841), 1,
      sym_identifier,
    ACTIONS(5825), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    STATE(4186), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5610), 1,
      sym__scope_resolution,
    STATE(6284), 1,
      sym__declarator,
    STATE(8318), 1,
      sym_ms_based_modifier,
    ACTIONS(2921), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4098), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4100), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(2919), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [64530] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6670), 1,
      anon_sym_PIPE,
    ACTIONS(6674), 1,
      anon_sym_AMP,
    ACTIONS(6680), 1,
      anon_sym_GT_EQ,
    ACTIONS(6686), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6692), 1,
      anon_sym_bitor,
    ACTIONS(6694), 1,
      anon_sym_bitand,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6662), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6672), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6682), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5724), 3,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(6664), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6676), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6678), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5726), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [64628] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(5511), 1,
      sym_identifier,
    ACTIONS(5521), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    ACTIONS(6798), 1,
      anon_sym_STAR,
    ACTIONS(6800), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6802), 1,
      anon_sym_AMP,
    STATE(4186), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5695), 1,
      sym__scope_resolution,
    STATE(6013), 1,
      sym__declarator,
    STATE(7894), 1,
      sym_ms_based_modifier,
    ACTIONS(2921), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3211), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4078), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2919), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [64730] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6670), 1,
      anon_sym_PIPE,
    ACTIONS(6674), 1,
      anon_sym_AMP,
    ACTIONS(6680), 1,
      anon_sym_GT_EQ,
    ACTIONS(6686), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6690), 1,
      anon_sym_and,
    ACTIONS(6692), 1,
      anon_sym_bitor,
    ACTIONS(6694), 1,
      anon_sym_bitand,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(5724), 2,
      anon_sym_EQ,
      anon_sym_or,
    ACTIONS(6662), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6672), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6682), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6664), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6676), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6678), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5726), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [64832] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(2845), 1,
      anon_sym_STAR,
    ACTIONS(2847), 1,
      anon_sym_AMP,
    ACTIONS(4841), 1,
      sym_identifier,
    ACTIONS(5825), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    STATE(4186), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5610), 1,
      sym__scope_resolution,
    STATE(6279), 1,
      sym__declarator,
    STATE(8318), 1,
      sym_ms_based_modifier,
    ACTIONS(2921), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3271), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4051), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2919), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [64934] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(4841), 1,
      sym_identifier,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    ACTIONS(6886), 1,
      anon_sym_STAR,
    ACTIONS(6888), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6890), 1,
      anon_sym_AMP,
    ACTIONS(6892), 1,
      anon_sym_COLON_COLON,
    STATE(4186), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5603), 1,
      sym__scope_resolution,
    STATE(6418), 1,
      sym__declarator,
    STATE(7821), 1,
      sym_ms_based_modifier,
    ACTIONS(2921), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4054), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4100), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(2919), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [65036] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6299), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6301), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [65096] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5724), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(5726), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [65170] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5938), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5940), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [65230] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5557), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5559), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [65290] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6664), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5724), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(5726), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [65366] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6371), 1,
      anon_sym_LBRACK,
    ACTIONS(6417), 1,
      anon_sym_DOT_STAR,
    ACTIONS(6419), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(6700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6702), 1,
      anon_sym_COMMA,
    ACTIONS(6706), 1,
      anon_sym_DASH,
    ACTIONS(6708), 1,
      anon_sym_PLUS,
    ACTIONS(6710), 1,
      anon_sym_STAR,
    ACTIONS(6712), 1,
      anon_sym_SLASH,
    ACTIONS(6714), 1,
      anon_sym_PERCENT,
    ACTIONS(6716), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6718), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6720), 1,
      anon_sym_PIPE,
    ACTIONS(6722), 1,
      anon_sym_CARET,
    ACTIONS(6724), 1,
      anon_sym_AMP,
    ACTIONS(6726), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6728), 1,
      anon_sym_BANG_EQ,
    ACTIONS(6730), 1,
      anon_sym_GT,
    ACTIONS(6732), 1,
      anon_sym_GT_EQ,
    ACTIONS(6734), 1,
      anon_sym_LT_EQ,
    ACTIONS(6736), 1,
      anon_sym_LT,
    ACTIONS(6738), 1,
      anon_sym_LT_LT,
    ACTIONS(6740), 1,
      anon_sym_GT_GT,
    ACTIONS(6742), 1,
      anon_sym_EQ,
    ACTIONS(6744), 1,
      anon_sym_QMARK,
    ACTIONS(6746), 1,
      anon_sym_STAR_EQ,
    ACTIONS(6748), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(6750), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(6752), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(6754), 1,
      anon_sym_DASH_EQ,
    ACTIONS(6756), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(6758), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(6760), 1,
      anon_sym_AMP_EQ,
    ACTIONS(6762), 1,
      anon_sym_CARET_EQ,
    ACTIONS(6764), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(6766), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6768), 1,
      anon_sym_or,
    ACTIONS(6770), 1,
      anon_sym_and,
    ACTIONS(6772), 1,
      anon_sym_bitor,
    ACTIONS(6774), 1,
      anon_sym_xor,
    ACTIONS(6776), 1,
      anon_sym_bitand,
    ACTIONS(6778), 1,
      anon_sym_not_eq,
    ACTIONS(6894), 1,
      anon_sym_RPAREN,
    STATE(1375), 1,
      sym__binary_fold_operator,
    STATE(3367), 1,
      sym_argument_list,
    STATE(3368), 1,
      sym_subscript_argument_list,
    STATE(7963), 1,
      sym__fold_operator,
    ACTIONS(6415), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6780), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [65522] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5525), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5527), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [65582] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2821), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2819), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_template,
      anon_sym_operator,
  [65642] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5934), 1,
      anon_sym_EQ,
    ACTIONS(6218), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6666), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6670), 1,
      anon_sym_PIPE,
    ACTIONS(6674), 1,
      anon_sym_AMP,
    ACTIONS(6680), 1,
      anon_sym_GT_EQ,
    ACTIONS(6684), 1,
      anon_sym_QMARK,
    ACTIONS(6686), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6688), 1,
      anon_sym_or,
    ACTIONS(6690), 1,
      anon_sym_and,
    ACTIONS(6692), 1,
      anon_sym_bitor,
    ACTIONS(6694), 1,
      anon_sym_bitand,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6662), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6672), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6682), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6664), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6676), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6678), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5936), 15,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [65752] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6299), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(6301), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [65812] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5718), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(5720), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [65886] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(5511), 1,
      sym_identifier,
    ACTIONS(5521), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    ACTIONS(6880), 1,
      anon_sym_STAR,
    ACTIONS(6882), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6884), 1,
      anon_sym_AMP,
    STATE(4186), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5695), 1,
      sym__scope_resolution,
    STATE(6150), 1,
      sym__declarator,
    STATE(7771), 1,
      sym_ms_based_modifier,
    ACTIONS(2921), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3312), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4046), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2919), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [65988] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    STATE(1741), 1,
      sym_template_argument_list,
    STATE(3610), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6896), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5303), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5305), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [66056] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4601), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5250), 1,
      anon_sym_LPAREN2,
    ACTIONS(5253), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3761), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [66122] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(5511), 1,
      sym_identifier,
    ACTIONS(5521), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    ACTIONS(6880), 1,
      anon_sym_STAR,
    ACTIONS(6882), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6884), 1,
      anon_sym_AMP,
    STATE(4186), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5695), 1,
      sym__scope_resolution,
    STATE(6141), 1,
      sym__declarator,
    STATE(7771), 1,
      sym_ms_based_modifier,
    ACTIONS(2921), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4056), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4100), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(2919), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [66224] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5201), 1,
      sym_literal_suffix,
    ACTIONS(3769), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(3761), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [66286] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6046), 1,
      anon_sym_LT,
    STATE(3523), 1,
      sym_template_argument_list,
    ACTIONS(5672), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5674), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [66352] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2473), 1,
      anon_sym_LBRACE,
    ACTIONS(6898), 1,
      anon_sym_LPAREN2,
    STATE(2728), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3362), 1,
      sym_argument_list,
    STATE(3841), 1,
      sym_initializer_list,
    ACTIONS(6110), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4926), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
    ACTIONS(4924), 34,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [66424] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    ACTIONS(6818), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6820), 1,
      anon_sym_PIPE,
    ACTIONS(6824), 1,
      anon_sym_AMP,
    ACTIONS(6832), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6834), 1,
      anon_sym_and,
    ACTIONS(6836), 1,
      anon_sym_bitor,
    ACTIONS(6838), 1,
      anon_sym_bitand,
    ACTIONS(6853), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6857), 1,
      anon_sym_or,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    ACTIONS(6256), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(6808), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6816), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6822), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6830), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6804), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6826), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6828), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6258), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [66528] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5266), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5264), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [66588] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(4841), 1,
      sym_identifier,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    ACTIONS(6886), 1,
      anon_sym_STAR,
    ACTIONS(6888), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6890), 1,
      anon_sym_AMP,
    ACTIONS(6892), 1,
      anon_sym_COLON_COLON,
    STATE(4186), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5603), 1,
      sym__scope_resolution,
    STATE(6414), 1,
      sym__declarator,
    STATE(7821), 1,
      sym_ms_based_modifier,
    ACTIONS(2921), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3276), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4053), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2919), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [66690] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5763), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5765), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [66750] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5787), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5789), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [66810] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6256), 1,
      anon_sym_EQ,
    ACTIONS(6666), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6670), 1,
      anon_sym_PIPE,
    ACTIONS(6674), 1,
      anon_sym_AMP,
    ACTIONS(6680), 1,
      anon_sym_GT_EQ,
    ACTIONS(6686), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6688), 1,
      anon_sym_or,
    ACTIONS(6690), 1,
      anon_sym_and,
    ACTIONS(6692), 1,
      anon_sym_bitor,
    ACTIONS(6694), 1,
      anon_sym_bitand,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6662), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6672), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6682), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6664), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6676), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6678), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6258), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [66916] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    ACTIONS(6818), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6820), 1,
      anon_sym_PIPE,
    ACTIONS(6824), 1,
      anon_sym_AMP,
    ACTIONS(6832), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6834), 1,
      anon_sym_and,
    ACTIONS(6836), 1,
      anon_sym_bitor,
    ACTIONS(6838), 1,
      anon_sym_bitand,
    ACTIONS(6853), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6857), 1,
      anon_sym_or,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    ACTIONS(6240), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(6808), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6816), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6822), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6830), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6804), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6826), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6828), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6242), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [67020] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4582), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5662), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5664), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [67082] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5030), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5032), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [67142] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6901), 1,
      sym_identifier,
    STATE(3204), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(5344), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(5346), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(4779), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(4777), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [67210] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(6317), 1,
      anon_sym_LBRACE,
    ACTIONS(6878), 1,
      anon_sym_COLON,
    STATE(2633), 1,
      sym_attribute_specifier,
    STATE(2881), 1,
      sym__enum_base_clause,
    STATE(3135), 1,
      sym_enumerator_list,
    ACTIONS(5691), 7,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5689), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [67282] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(4841), 1,
      sym_identifier,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    ACTIONS(6886), 1,
      anon_sym_STAR,
    ACTIONS(6888), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6890), 1,
      anon_sym_AMP,
    ACTIONS(6892), 1,
      anon_sym_COLON_COLON,
    STATE(4186), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5603), 1,
      sym__scope_resolution,
    STATE(6409), 1,
      sym__declarator,
    STATE(7821), 1,
      sym_ms_based_modifier,
    ACTIONS(2921), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4043), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4100), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(2919), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [67384] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5621), 1,
      sym_literal_suffix,
    ACTIONS(5197), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5199), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [67446] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5201), 1,
      sym_literal_suffix,
    ACTIONS(5197), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(5199), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [67508] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(4841), 1,
      sym_identifier,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    ACTIONS(6886), 1,
      anon_sym_STAR,
    ACTIONS(6888), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6890), 1,
      anon_sym_AMP,
    ACTIONS(6892), 1,
      anon_sym_COLON_COLON,
    STATE(4186), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5603), 1,
      sym__scope_resolution,
    STATE(6418), 1,
      sym__declarator,
    STATE(7821), 1,
      sym_ms_based_modifier,
    ACTIONS(2921), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3306), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4054), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2919), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [67610] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4601), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5250), 1,
      anon_sym_LPAREN2,
    ACTIONS(5253), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3761), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [67676] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5101), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5103), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [67736] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(5511), 1,
      sym_identifier,
    ACTIONS(5521), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    ACTIONS(6880), 1,
      anon_sym_STAR,
    ACTIONS(6882), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6884), 1,
      anon_sym_AMP,
    STATE(4186), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5695), 1,
      sym__scope_resolution,
    STATE(6167), 1,
      sym__declarator,
    STATE(7771), 1,
      sym_ms_based_modifier,
    ACTIONS(2921), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4041), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4100), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(2919), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [67838] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6584), 1,
      anon_sym_LT,
    STATE(1710), 1,
      sym_template_argument_list,
    ACTIONS(5750), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5752), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [67902] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5813), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(5815), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [67974] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5066), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5068), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [68034] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4910), 1,
      anon_sym_COLON,
    ACTIONS(6903), 1,
      anon_sym___attribute__,
    ACTIONS(6905), 1,
      anon_sym_LBRACE,
    STATE(3979), 1,
      sym_field_declaration_list,
    STATE(4066), 1,
      sym_attribute_specifier,
    STATE(6741), 1,
      sym_virtual_specifier,
    STATE(7408), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(4902), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(4904), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [68110] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5813), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(5815), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_GT2,
  [68182] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    ACTIONS(6808), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5718), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(5720), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [68256] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5771), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(5773), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [68330] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5266), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5264), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [68390] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(6782), 1,
      sym_identifier,
    ACTIONS(6784), 1,
      anon_sym_STAR,
    ACTIONS(6786), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6788), 1,
      anon_sym_AMP,
    ACTIONS(6790), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    STATE(4186), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5612), 1,
      sym__scope_resolution,
    STATE(6221), 1,
      sym__declarator,
    STATE(7612), 1,
      sym_ms_based_modifier,
    ACTIONS(2921), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4076), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4100), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(2919), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [68492] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5767), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(5769), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [68566] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6269), 1,
      anon_sym_EQ,
    ACTIONS(6666), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6670), 1,
      anon_sym_PIPE,
    ACTIONS(6674), 1,
      anon_sym_AMP,
    ACTIONS(6680), 1,
      anon_sym_GT_EQ,
    ACTIONS(6686), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6688), 1,
      anon_sym_or,
    ACTIONS(6690), 1,
      anon_sym_and,
    ACTIONS(6692), 1,
      anon_sym_bitor,
    ACTIONS(6694), 1,
      anon_sym_bitand,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5722), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6662), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6672), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6682), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6664), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6676), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6678), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6271), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [68672] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6907), 1,
      anon_sym_LT,
    STATE(2716), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2843), 1,
      sym_template_argument_list,
    ACTIONS(3787), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3767), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3759), 34,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [68742] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6911), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6913), 1,
      anon_sym_AMP,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(6919), 1,
      anon_sym_LBRACK,
    ACTIONS(6923), 1,
      anon_sym_DASH_GT,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(6932), 1,
      anon_sym_requires,
    STATE(4724), 1,
      sym__function_attributes_start,
    STATE(4828), 1,
      sym_ref_qualifier,
    STATE(5700), 1,
      sym__function_attributes_end,
    STATE(5812), 1,
      sym_trailing_return_type,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6925), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4181), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4519), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5973), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5174), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6909), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
    ACTIONS(6915), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [68848] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    ACTIONS(6818), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6820), 1,
      anon_sym_PIPE,
    ACTIONS(6824), 1,
      anon_sym_AMP,
    ACTIONS(6832), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6834), 1,
      anon_sym_and,
    ACTIONS(6836), 1,
      anon_sym_bitor,
    ACTIONS(6838), 1,
      anon_sym_bitand,
    ACTIONS(6853), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6857), 1,
      anon_sym_or,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    ACTIONS(6248), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(6808), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6816), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6822), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6830), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6804), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6826), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6828), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6250), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [68952] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6289), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(6291), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [69012] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    ACTIONS(6808), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5771), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(5773), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [69086] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6935), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(5730), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5732), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [69148] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    ACTIONS(6808), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5767), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(5769), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [69222] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5730), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5732), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [69282] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5569), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5571), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [69342] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5698), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(5700), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [69414] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4543), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4536), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [69474] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    ACTIONS(6818), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6820), 1,
      anon_sym_PIPE,
    ACTIONS(6824), 1,
      anon_sym_AMP,
    ACTIONS(6832), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6834), 1,
      anon_sym_and,
    ACTIONS(6836), 1,
      anon_sym_bitor,
    ACTIONS(6838), 1,
      anon_sym_bitand,
    ACTIONS(6853), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6857), 1,
      anon_sym_or,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    ACTIONS(6269), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(6808), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6816), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6822), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6830), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6804), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6826), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6828), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6271), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [69578] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6371), 1,
      anon_sym_LBRACK,
    ACTIONS(6417), 1,
      anon_sym_DOT_STAR,
    ACTIONS(6419), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(6700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6702), 1,
      anon_sym_COMMA,
    ACTIONS(6706), 1,
      anon_sym_DASH,
    ACTIONS(6708), 1,
      anon_sym_PLUS,
    ACTIONS(6710), 1,
      anon_sym_STAR,
    ACTIONS(6712), 1,
      anon_sym_SLASH,
    ACTIONS(6714), 1,
      anon_sym_PERCENT,
    ACTIONS(6716), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6718), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6720), 1,
      anon_sym_PIPE,
    ACTIONS(6722), 1,
      anon_sym_CARET,
    ACTIONS(6724), 1,
      anon_sym_AMP,
    ACTIONS(6726), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6728), 1,
      anon_sym_BANG_EQ,
    ACTIONS(6730), 1,
      anon_sym_GT,
    ACTIONS(6732), 1,
      anon_sym_GT_EQ,
    ACTIONS(6734), 1,
      anon_sym_LT_EQ,
    ACTIONS(6736), 1,
      anon_sym_LT,
    ACTIONS(6738), 1,
      anon_sym_LT_LT,
    ACTIONS(6740), 1,
      anon_sym_GT_GT,
    ACTIONS(6742), 1,
      anon_sym_EQ,
    ACTIONS(6744), 1,
      anon_sym_QMARK,
    ACTIONS(6746), 1,
      anon_sym_STAR_EQ,
    ACTIONS(6748), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(6750), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(6752), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(6754), 1,
      anon_sym_DASH_EQ,
    ACTIONS(6756), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(6758), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(6760), 1,
      anon_sym_AMP_EQ,
    ACTIONS(6762), 1,
      anon_sym_CARET_EQ,
    ACTIONS(6764), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(6766), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6768), 1,
      anon_sym_or,
    ACTIONS(6770), 1,
      anon_sym_and,
    ACTIONS(6772), 1,
      anon_sym_bitor,
    ACTIONS(6774), 1,
      anon_sym_xor,
    ACTIONS(6776), 1,
      anon_sym_bitand,
    ACTIONS(6778), 1,
      anon_sym_not_eq,
    ACTIONS(6937), 1,
      anon_sym_RPAREN,
    STATE(1375), 1,
      sym__binary_fold_operator,
    STATE(3367), 1,
      sym_argument_list,
    STATE(3368), 1,
      sym_subscript_argument_list,
    STATE(7963), 1,
      sym__fold_operator,
    ACTIONS(6415), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6780), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [69734] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5698), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(5700), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_GT2,
  [69806] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6016), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6018), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [69866] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4543), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4536), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [69926] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(5511), 1,
      sym_identifier,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    ACTIONS(6843), 1,
      anon_sym_STAR,
    ACTIONS(6845), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6847), 1,
      anon_sym_AMP,
    ACTIONS(6849), 1,
      anon_sym_COLON_COLON,
    STATE(4186), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5585), 1,
      sym__scope_resolution,
    STATE(5925), 1,
      sym__declarator,
    STATE(7697), 1,
      sym_ms_based_modifier,
    ACTIONS(2921), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4058), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4100), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(2919), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [70028] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4922), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4924), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4926), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [70090] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3650), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3652), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [70150] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6911), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6913), 1,
      anon_sym_AMP,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(6919), 1,
      anon_sym_LBRACK,
    ACTIONS(6923), 1,
      anon_sym_DASH_GT,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(6941), 1,
      anon_sym_requires,
    STATE(4656), 1,
      sym__function_attributes_start,
    STATE(4857), 1,
      sym_ref_qualifier,
    STATE(5703), 1,
      sym__function_attributes_end,
    STATE(5832), 1,
      sym_trailing_return_type,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4181), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4519), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5973), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5177), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6909), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
    ACTIONS(6915), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [70256] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4543), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4536), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [70316] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5551), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5553), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [70376] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4543), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4536), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [70436] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4582), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(4584), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4577), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [70498] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4543), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4536), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [70558] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4543), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4536), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [70618] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6323), 1,
      sym_auto,
    ACTIONS(6325), 1,
      anon_sym_decltype,
    STATE(3409), 1,
      sym_decltype_auto,
    ACTIONS(4871), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4873), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [70684] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    ACTIONS(6818), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6820), 1,
      anon_sym_PIPE,
    ACTIONS(6824), 1,
      anon_sym_AMP,
    ACTIONS(6832), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6834), 1,
      anon_sym_and,
    ACTIONS(6836), 1,
      anon_sym_bitor,
    ACTIONS(6838), 1,
      anon_sym_bitand,
    ACTIONS(6851), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6853), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6855), 1,
      anon_sym_QMARK,
    ACTIONS(6857), 1,
      anon_sym_or,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    ACTIONS(6244), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(6808), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6816), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6822), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6830), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6804), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6826), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6828), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6246), 14,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [70792] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6371), 1,
      anon_sym_LBRACK,
    ACTIONS(6417), 1,
      anon_sym_DOT_STAR,
    ACTIONS(6419), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(6700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6702), 1,
      anon_sym_COMMA,
    ACTIONS(6706), 1,
      anon_sym_DASH,
    ACTIONS(6708), 1,
      anon_sym_PLUS,
    ACTIONS(6710), 1,
      anon_sym_STAR,
    ACTIONS(6712), 1,
      anon_sym_SLASH,
    ACTIONS(6714), 1,
      anon_sym_PERCENT,
    ACTIONS(6716), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6718), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6720), 1,
      anon_sym_PIPE,
    ACTIONS(6722), 1,
      anon_sym_CARET,
    ACTIONS(6724), 1,
      anon_sym_AMP,
    ACTIONS(6726), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6728), 1,
      anon_sym_BANG_EQ,
    ACTIONS(6730), 1,
      anon_sym_GT,
    ACTIONS(6732), 1,
      anon_sym_GT_EQ,
    ACTIONS(6734), 1,
      anon_sym_LT_EQ,
    ACTIONS(6736), 1,
      anon_sym_LT,
    ACTIONS(6738), 1,
      anon_sym_LT_LT,
    ACTIONS(6740), 1,
      anon_sym_GT_GT,
    ACTIONS(6742), 1,
      anon_sym_EQ,
    ACTIONS(6744), 1,
      anon_sym_QMARK,
    ACTIONS(6746), 1,
      anon_sym_STAR_EQ,
    ACTIONS(6748), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(6750), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(6752), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(6754), 1,
      anon_sym_DASH_EQ,
    ACTIONS(6756), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(6758), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(6760), 1,
      anon_sym_AMP_EQ,
    ACTIONS(6762), 1,
      anon_sym_CARET_EQ,
    ACTIONS(6764), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(6766), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6768), 1,
      anon_sym_or,
    ACTIONS(6770), 1,
      anon_sym_and,
    ACTIONS(6772), 1,
      anon_sym_bitor,
    ACTIONS(6774), 1,
      anon_sym_xor,
    ACTIONS(6776), 1,
      anon_sym_bitand,
    ACTIONS(6778), 1,
      anon_sym_not_eq,
    ACTIONS(6943), 1,
      anon_sym_RPAREN,
    STATE(1375), 1,
      sym__binary_fold_operator,
    STATE(3367), 1,
      sym_argument_list,
    STATE(3368), 1,
      sym_subscript_argument_list,
    STATE(7963), 1,
      sym__fold_operator,
    ACTIONS(6415), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6780), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [70948] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5730), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5732), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [71008] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(5511), 1,
      sym_identifier,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    ACTIONS(6843), 1,
      anon_sym_STAR,
    ACTIONS(6845), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6847), 1,
      anon_sym_AMP,
    ACTIONS(6849), 1,
      anon_sym_COLON_COLON,
    STATE(4186), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5585), 1,
      sym__scope_resolution,
    STATE(6037), 1,
      sym__declarator,
    STATE(7697), 1,
      sym_ms_based_modifier,
    ACTIONS(2921), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3340), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4045), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2919), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [71110] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4543), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4536), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [71169] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    STATE(1741), 1,
      sym_template_argument_list,
    STATE(2269), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4603), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5303), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(5305), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
  [71236] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5982), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5984), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [71295] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1961), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(1959), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [71354] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5569), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5571), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [71413] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6911), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6913), 1,
      anon_sym_AMP,
    ACTIONS(6919), 1,
      anon_sym_LBRACK,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(6947), 1,
      anon_sym___attribute__,
    ACTIONS(6950), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6953), 1,
      anon_sym_const,
    ACTIONS(6955), 1,
      anon_sym_DASH_GT,
    ACTIONS(6960), 1,
      anon_sym_requires,
    STATE(4755), 1,
      sym__function_attributes_start,
    STATE(4912), 1,
      sym_ref_qualifier,
    STATE(5594), 1,
      sym__function_attributes_end,
    STATE(5629), 1,
      sym_trailing_return_type,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6957), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4307), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4741), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5784), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5215), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6909), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
    ACTIONS(6945), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [71518] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5881), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5883), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [71577] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5837), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5839), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [71636] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5992), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5994), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [71695] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3568), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3564), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [71754] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5946), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5948), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [71813] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5266), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5264), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [71872] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5837), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5839), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [71931] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5845), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5847), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [71990] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5849), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5851), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [72049] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4723), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(4725), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [72108] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5135), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5137), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [72167] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5962), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5964), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [72226] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4924), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4926), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [72285] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5332), 3,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(3769), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3761), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [72346] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4707), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(4709), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [72405] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6911), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6913), 1,
      anon_sym_AMP,
    ACTIONS(6919), 1,
      anon_sym_LBRACK,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(6947), 1,
      anon_sym___attribute__,
    ACTIONS(6950), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6953), 1,
      anon_sym_const,
    ACTIONS(6955), 1,
      anon_sym_DASH_GT,
    ACTIONS(6963), 1,
      anon_sym_requires,
    STATE(4754), 1,
      sym__function_attributes_start,
    STATE(4942), 1,
      sym_ref_qualifier,
    STATE(5577), 1,
      sym__function_attributes_end,
    STATE(5676), 1,
      sym_trailing_return_type,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(4307), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4741), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5784), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5208), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6909), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
    ACTIONS(6945), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [72510] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4715), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(4717), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [72569] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4727), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4729), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [72628] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5601), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5603), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [72687] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5763), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5765), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [72746] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4924), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4926), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [72805] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4735), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4737), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [72864] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4731), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4733), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [72923] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1957), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1955), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [72982] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5547), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5549), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [73041] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5046), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5048), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [73100] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5070), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5072), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [73159] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5085), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5087), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [73218] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5093), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5095), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [73277] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5597), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5599), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [73336] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5593), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5595), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [73395] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5896), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5898), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [73454] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4735), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(4737), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [73513] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4831), 3,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(4829), 48,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_typename,
      anon_sym_template,
  [73572] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5892), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5894), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [73631] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6965), 1,
      sym_identifier,
    STATE(3483), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(4621), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(4623), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(4779), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(4777), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [73698] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4833), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(4835), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [73757] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5888), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5890), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [73816] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5974), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5976), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [73875] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4727), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(4729), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [73934] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4731), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(4733), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [73993] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3426), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5420), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(6967), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5418), 42,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [74056] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4816), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(4818), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [74115] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5867), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5869), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [74174] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3424), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5410), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(6969), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5408), 42,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [74237] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5863), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5865), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [74296] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4711), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(4713), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [74355] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4711), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4713), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [74414] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5185), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [74473] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4739), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4741), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [74532] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5583), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5585), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [74591] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6971), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6973), 1,
      anon_sym_and,
    ACTIONS(5477), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5479), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [74654] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4695), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4697), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [74713] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4715), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4717), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [74772] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5670), 1,
      sym_literal_suffix,
    ACTIONS(5199), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(5197), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
  [74833] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5670), 1,
      sym_literal_suffix,
    ACTIONS(3761), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(3769), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
  [74894] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4810), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(4812), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [74953] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4719), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(4721), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [75012] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4543), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4536), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [75071] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5730), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5732), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [75130] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4543), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4536), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [75189] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4543), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4536), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [75248] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4543), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4536), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [75307] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2026), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5450), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(6975), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5448), 42,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [75370] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4543), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4536), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [75429] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2026), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5426), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(6975), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5424), 42,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [75492] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2026), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5369), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(6975), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5367), 42,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [75555] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6977), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(5730), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5732), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [75616] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5736), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5738), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [75675] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5736), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5738), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [75734] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2026), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5406), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(6975), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5404), 42,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [75797] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5736), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5738), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [75856] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5062), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5064), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [75915] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6301), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(6299), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
  [75974] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5054), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5056), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [76033] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5783), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5785), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [76092] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5912), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5914), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [76151] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4910), 1,
      anon_sym_COLON,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    STATE(2665), 1,
      sym_attribute_specifier,
    STATE(3956), 1,
      sym_field_declaration_list,
    STATE(6673), 1,
      sym_virtual_specifier,
    STATE(7486), 1,
      sym_base_class_clause,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(4902), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(4904), 38,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_EQ,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [76226] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1957), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(1955), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [76285] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5340), 1,
      anon_sym_EQ,
    ACTIONS(5342), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(3769), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3761), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [76348] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5579), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5581), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [76407] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5757), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5759), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [76466] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3427), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4924), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(6979), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4926), 42,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [76529] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6981), 1,
      anon_sym_LT,
    STATE(2030), 1,
      sym_template_argument_list,
    STATE(2269), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4603), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3759), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(3767), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
  [76598] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4723), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4725), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [76657] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5589), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5591), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [76716] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5799), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5801), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [76775] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4719), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4721), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [76834] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5551), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5553), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [76893] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6024), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6026), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [76952] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1961), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1959), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [77011] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5873), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5875), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [77070] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5938), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5940), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [77129] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5853), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5855), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [77188] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5058), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5060), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [77247] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5841), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5843), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [77306] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5042), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5044), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [77365] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6993), 1,
      anon_sym___attribute__,
    ACTIONS(6996), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6999), 1,
      anon_sym___declspec,
    ACTIONS(7002), 1,
      anon_sym_virtual,
    ACTIONS(7005), 1,
      anon_sym_alignas,
    ACTIONS(7008), 1,
      anon_sym_explicit,
    ACTIONS(6985), 5,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
    ACTIONS(6983), 7,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
    ACTIONS(6990), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    STATE(3458), 11,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      sym_virtual,
      sym_alignas_specifier,
      sym_explicit_function_specifier,
      sym__constructor_specifiers,
      aux_sym_operator_cast_definition_repeat1,
    ACTIONS(6987), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [77442] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5787), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5789), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [77501] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5074), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5076), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [77560] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5050), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5052), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [77619] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5034), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5036), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [77678] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5038), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5040), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [77737] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3427), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5105), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(6979), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5107), 42,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [77800] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6591), 1,
      anon_sym_LT,
    STATE(1712), 1,
      sym_template_argument_list,
    ACTIONS(5750), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5752), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [77863] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5050), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5052), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [77922] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4699), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4701), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [77981] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5050), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5052), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [78040] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4703), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4705), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [78099] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5978), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5980), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [78158] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7011), 1,
      anon_sym_LT,
    STATE(3347), 1,
      sym_template_argument_list,
    ACTIONS(5750), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5752), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [78221] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4691), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4693), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [78280] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6907), 1,
      anon_sym_LT,
    STATE(2843), 1,
      sym_template_argument_list,
    ACTIONS(3785), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5187), 37,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [78345] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4691), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4693), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [78404] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4691), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4693), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [78463] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3646), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3648), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [78522] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5779), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5781), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [78581] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4818), 3,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(4816), 48,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_typename,
      anon_sym_template,
  [78640] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4699), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(4701), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [78699] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4695), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(4697), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [78758] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4703), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(4705), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [78817] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4691), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(4693), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [78876] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7014), 1,
      sym_identifier,
    STATE(3519), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(4621), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(4623), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(4785), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(4783), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [78943] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6036), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6038), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [79002] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5904), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5906), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [79061] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5152), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5154), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [79120] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5160), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5162), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [79179] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6020), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6022), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [79238] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5164), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5166), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [79297] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5179), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5181), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [79356] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5172), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5174), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [79415] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5168), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5170), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [79474] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5821), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5823), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [79533] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2473), 1,
      anon_sym_LBRACE,
    ACTIONS(6319), 1,
      anon_sym_LPAREN2,
    STATE(3875), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5561), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5563), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [79598] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2473), 1,
      anon_sym_LBRACE,
    ACTIONS(6319), 1,
      anon_sym_LPAREN2,
    STATE(3823), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5565), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5567), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [79663] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7016), 1,
      anon_sym_LT,
    STATE(2030), 1,
      sym_template_argument_list,
    STATE(3610), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6896), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3759), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(3767), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [79732] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5916), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5918), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [79791] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6907), 1,
      anon_sym_LT,
    ACTIONS(7020), 1,
      anon_sym_EQ,
    STATE(2716), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2843), 1,
      sym_template_argument_list,
    ACTIONS(7018), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(3787), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3767), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3759), 34,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [79864] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5920), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5922), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [79923] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5934), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5936), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [79982] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6012), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6014), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [80041] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6008), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6010), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [80100] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6004), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6006), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [80159] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4691), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(4693), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [80218] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4691), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(4693), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [80277] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4808), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2743), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [80336] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5930), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5932), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [80395] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6032), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6034), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [80454] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5908), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5910), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [80513] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5101), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5103), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [80572] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6291), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(6289), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
  [80631] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4739), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(4741), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [80690] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5996), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5998), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [80749] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5714), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5716), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [80808] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2473), 1,
      anon_sym_LBRACE,
    ACTIONS(6319), 1,
      anon_sym_LPAREN2,
    STATE(3827), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5625), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5627), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [80873] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5525), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5527), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [80932] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5557), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5559), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [80991] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5145), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5147), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [81050] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7022), 1,
      sym_identifier,
    STATE(3519), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(7025), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(7028), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(4792), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(4790), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [81117] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4707), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4709), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [81176] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3650), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3652), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [81235] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6971), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6973), 1,
      anon_sym_and,
    ACTIONS(7031), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7033), 1,
      anon_sym_or,
    ACTIONS(5428), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5430), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [81302] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4582), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5662), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5664), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [81363] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5121), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5123), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [81422] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5129), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5131), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [81481] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5877), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5879), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [81540] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6016), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6018), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [81599] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6000), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6002), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [81658] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5988), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5990), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [81717] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4829), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(4831), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [81776] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5125), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5127), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [81835] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5121), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5123), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [81894] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5833), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5835), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [81953] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6532), 1,
      anon_sym_LBRACK,
    ACTIONS(6907), 1,
      anon_sym_LT,
    STATE(2716), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3993), 1,
      sym_template_argument_list,
    ACTIONS(3782), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3787), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3767), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_EQ,
    ACTIONS(3759), 33,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [82026] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5113), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5115), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [82085] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5109), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5111), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [82144] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5942), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5944), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [82203] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5746), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5748), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [82262] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6907), 1,
      anon_sym_LT,
    STATE(2843), 1,
      sym_template_argument_list,
    ACTIONS(4541), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4534), 37,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [82327] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5970), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5972), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [82386] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2473), 1,
      anon_sym_LBRACE,
    ACTIONS(6319), 1,
      anon_sym_LPAREN2,
    STATE(3858), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5609), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5611), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [82451] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5958), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5960), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [82510] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5954), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5956), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [82569] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5950), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5952), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [82628] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7011), 1,
      anon_sym_LT,
    STATE(2033), 1,
      sym_template_argument_list,
    ACTIONS(5750), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5752), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [82691] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5089), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5091), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [82750] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5099), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [82809] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5736), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5738), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [82867] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4715), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4717), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [82925] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5982), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5984), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [82983] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6016), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6018), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [83041] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5779), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5781), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [83099] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4543), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4536), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [83157] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4707), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4709), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [83215] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5799), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5801), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [83273] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4543), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4536), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [83331] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6371), 1,
      anon_sym_LBRACK,
    ACTIONS(6582), 1,
      anon_sym_DOT_STAR,
    STATE(3367), 1,
      sym_argument_list,
    STATE(3368), 1,
      sym_subscript_argument_list,
    ACTIONS(6415), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6780), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(5775), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(5777), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [83403] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4543), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4536), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [83461] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4543), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4536), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [83519] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3622), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7035), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5410), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5408), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [83581] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4735), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4737), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [83639] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5930), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5932), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [83697] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4543), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4536), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [83755] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5962), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5964), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [83813] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4543), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4536), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [83871] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5821), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5823), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [83929] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7037), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7039), 1,
      anon_sym_and,
    ACTIONS(5477), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5479), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [83991] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4727), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4729), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [84049] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6911), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6913), 1,
      anon_sym_AMP,
    ACTIONS(6919), 1,
      anon_sym_LBRACK,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(6950), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6953), 1,
      anon_sym_const,
    ACTIONS(6960), 1,
      anon_sym_requires,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(7043), 1,
      anon_sym_DASH_GT,
    STATE(4787), 1,
      sym__function_attributes_start,
    STATE(4957), 1,
      sym_ref_qualifier,
    STATE(5629), 1,
      sym_trailing_return_type,
    STATE(5753), 1,
      sym__function_attributes_end,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6957), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4307), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4741), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5784), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5229), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6909), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
    ACTIONS(6945), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [84153] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5950), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5952), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [84211] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4731), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4733), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [84269] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5954), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5956), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [84327] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6032), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6034), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [84385] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5946), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5948), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [84443] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5904), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5906), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [84501] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5736), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5738), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [84559] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3568), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3564), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [84617] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5992), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5994), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [84675] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6371), 1,
      anon_sym_LBRACK,
    ACTIONS(6582), 1,
      anon_sym_DOT_STAR,
    STATE(3367), 1,
      sym_argument_list,
    STATE(3368), 1,
      sym_subscript_argument_list,
    ACTIONS(6415), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6780), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7045), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7049), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7047), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5724), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
    ACTIONS(5726), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [84753] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3604), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7051), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5369), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5367), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [84815] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6371), 1,
      anon_sym_LBRACK,
    ACTIONS(6582), 1,
      anon_sym_DOT_STAR,
    STATE(3367), 1,
      sym_argument_list,
    STATE(3368), 1,
      sym_subscript_argument_list,
    ACTIONS(6415), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6780), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7045), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7047), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5724), 9,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(5726), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [84891] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5736), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5738), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [84949] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6371), 1,
      anon_sym_LBRACK,
    ACTIONS(6582), 1,
      anon_sym_DOT_STAR,
    ACTIONS(6766), 1,
      anon_sym_LT_EQ_GT,
    STATE(3367), 1,
      sym_argument_list,
    STATE(3368), 1,
      sym_subscript_argument_list,
    ACTIONS(6415), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6780), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7045), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7049), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7047), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5724), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
    ACTIONS(5726), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [85029] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4695), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4697), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [85087] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6248), 1,
      anon_sym_EQ,
    ACTIONS(6371), 1,
      anon_sym_LBRACK,
    ACTIONS(6582), 1,
      anon_sym_DOT_STAR,
    ACTIONS(6766), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7057), 1,
      anon_sym_PIPE,
    ACTIONS(7059), 1,
      anon_sym_CARET,
    ACTIONS(7061), 1,
      anon_sym_AMP,
    ACTIONS(7067), 1,
      anon_sym_GT_EQ,
    ACTIONS(7069), 1,
      anon_sym_bitor,
    ACTIONS(7071), 1,
      anon_sym_xor,
    ACTIONS(7073), 1,
      anon_sym_bitand,
    STATE(3367), 1,
      sym_argument_list,
    STATE(3368), 1,
      sym_subscript_argument_list,
    ACTIONS(6415), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6780), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7045), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7049), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7053), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7055), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7047), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7063), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7065), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6250), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
  [85189] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5881), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5883), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [85247] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6371), 1,
      anon_sym_LBRACK,
    ACTIONS(6582), 1,
      anon_sym_DOT_STAR,
    ACTIONS(6766), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7067), 1,
      anon_sym_GT_EQ,
    STATE(3367), 1,
      sym_argument_list,
    STATE(3368), 1,
      sym_subscript_argument_list,
    ACTIONS(6415), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6780), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7045), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7049), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7047), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7065), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5724), 4,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
    ACTIONS(5726), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [85331] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6371), 1,
      anon_sym_LBRACK,
    ACTIONS(6582), 1,
      anon_sym_DOT_STAR,
    STATE(3367), 1,
      sym_argument_list,
    STATE(3368), 1,
      sym_subscript_argument_list,
    ACTIONS(6415), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5813), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(5815), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT_STAR,
  [85401] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6371), 1,
      anon_sym_LBRACK,
    ACTIONS(6582), 1,
      anon_sym_DOT_STAR,
    ACTIONS(6766), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7067), 1,
      anon_sym_GT_EQ,
    STATE(3367), 1,
      sym_argument_list,
    STATE(3368), 1,
      sym_subscript_argument_list,
    ACTIONS(6415), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6780), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7045), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7049), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7047), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7063), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7065), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5724), 4,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
    ACTIONS(5726), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_DASH_GT_STAR,
  [85487] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6371), 1,
      anon_sym_LBRACK,
    ACTIONS(6582), 1,
      anon_sym_DOT_STAR,
    ACTIONS(6766), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7061), 1,
      anon_sym_AMP,
    ACTIONS(7067), 1,
      anon_sym_GT_EQ,
    ACTIONS(7073), 1,
      anon_sym_bitand,
    STATE(3367), 1,
      sym_argument_list,
    STATE(3368), 1,
      sym_subscript_argument_list,
    ACTIONS(6415), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6780), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7045), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7049), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5724), 3,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
    ACTIONS(7047), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7063), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7065), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5726), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_DASH_GT_STAR,
  [85577] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5912), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5914), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [85635] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5849), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5851), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [85693] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5757), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5759), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [85751] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5845), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5847), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [85809] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1957), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(1955), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [85867] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6371), 1,
      anon_sym_LBRACK,
    ACTIONS(6582), 1,
      anon_sym_DOT_STAR,
    ACTIONS(6766), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7059), 1,
      anon_sym_CARET,
    ACTIONS(7061), 1,
      anon_sym_AMP,
    ACTIONS(7067), 1,
      anon_sym_GT_EQ,
    ACTIONS(7071), 1,
      anon_sym_xor,
    ACTIONS(7073), 1,
      anon_sym_bitand,
    STATE(3367), 1,
      sym_argument_list,
    STATE(3368), 1,
      sym_subscript_argument_list,
    ACTIONS(5724), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(6415), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6780), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7045), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7049), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7047), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7063), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7065), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5726), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_DASH_GT_STAR,
  [85961] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5837), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5839), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [86019] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5724), 1,
      anon_sym_EQ,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6371), 1,
      anon_sym_LBRACK,
    ACTIONS(6582), 1,
      anon_sym_DOT_STAR,
    ACTIONS(6766), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7057), 1,
      anon_sym_PIPE,
    ACTIONS(7059), 1,
      anon_sym_CARET,
    ACTIONS(7061), 1,
      anon_sym_AMP,
    ACTIONS(7067), 1,
      anon_sym_GT_EQ,
    ACTIONS(7069), 1,
      anon_sym_bitor,
    ACTIONS(7071), 1,
      anon_sym_xor,
    ACTIONS(7073), 1,
      anon_sym_bitand,
    STATE(3367), 1,
      sym_argument_list,
    STATE(3368), 1,
      sym_subscript_argument_list,
    ACTIONS(6415), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6780), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7045), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7049), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7047), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7063), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7065), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5726), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH_GT_STAR,
  [86117] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5724), 1,
      anon_sym_EQ,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6371), 1,
      anon_sym_LBRACK,
    ACTIONS(6582), 1,
      anon_sym_DOT_STAR,
    ACTIONS(6766), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7057), 1,
      anon_sym_PIPE,
    ACTIONS(7059), 1,
      anon_sym_CARET,
    ACTIONS(7061), 1,
      anon_sym_AMP,
    ACTIONS(7067), 1,
      anon_sym_GT_EQ,
    ACTIONS(7069), 1,
      anon_sym_bitor,
    ACTIONS(7071), 1,
      anon_sym_xor,
    ACTIONS(7073), 1,
      anon_sym_bitand,
    STATE(3367), 1,
      sym_argument_list,
    STATE(3368), 1,
      sym_subscript_argument_list,
    ACTIONS(6415), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6780), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7045), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7049), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7055), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7047), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7063), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7065), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5726), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_DASH_GT_STAR,
  [86217] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6004), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6006), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [86275] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6371), 1,
      anon_sym_LBRACK,
    ACTIONS(6582), 1,
      anon_sym_DOT_STAR,
    STATE(3367), 1,
      sym_argument_list,
    STATE(3368), 1,
      sym_subscript_argument_list,
    ACTIONS(6415), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6780), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(5724), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(5726), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [86347] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6371), 1,
      anon_sym_LBRACK,
    ACTIONS(6582), 1,
      anon_sym_DOT_STAR,
    STATE(3367), 1,
      sym_argument_list,
    STATE(3368), 1,
      sym_subscript_argument_list,
    ACTIONS(6415), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6780), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7047), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5724), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(5726), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [86421] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3661), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7075), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5420), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5418), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [86483] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3604), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7077), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4766), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(4768), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [86545] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5958), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5960), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [86603] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6020), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6022), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [86661] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5783), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5785), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [86719] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6371), 1,
      anon_sym_LBRACK,
    ACTIONS(6582), 1,
      anon_sym_DOT_STAR,
    STATE(3367), 1,
      sym_argument_list,
    STATE(3368), 1,
      sym_subscript_argument_list,
    ACTIONS(6415), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6780), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(5771), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(5773), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [86791] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6244), 1,
      anon_sym_EQ,
    ACTIONS(6371), 1,
      anon_sym_LBRACK,
    ACTIONS(6582), 1,
      anon_sym_DOT_STAR,
    ACTIONS(6700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6744), 1,
      anon_sym_QMARK,
    ACTIONS(6766), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7057), 1,
      anon_sym_PIPE,
    ACTIONS(7059), 1,
      anon_sym_CARET,
    ACTIONS(7061), 1,
      anon_sym_AMP,
    ACTIONS(7067), 1,
      anon_sym_GT_EQ,
    ACTIONS(7069), 1,
      anon_sym_bitor,
    ACTIONS(7071), 1,
      anon_sym_xor,
    ACTIONS(7073), 1,
      anon_sym_bitand,
    STATE(3367), 1,
      sym_argument_list,
    STATE(3368), 1,
      sym_subscript_argument_list,
    ACTIONS(6415), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6780), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7045), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7049), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7053), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7055), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7047), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7063), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7065), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6246), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
  [86897] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3604), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7051), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5406), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5404), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [86959] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5285), 1,
      anon_sym_EQ,
    ACTIONS(5287), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(3769), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3761), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [87021] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4530), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4532), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [87079] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6371), 1,
      anon_sym_LBRACK,
    ACTIONS(6582), 1,
      anon_sym_DOT_STAR,
    STATE(3367), 1,
      sym_argument_list,
    STATE(3368), 1,
      sym_subscript_argument_list,
    ACTIONS(6415), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6780), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(5767), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(5769), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [87151] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4582), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(4584), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4577), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [87211] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7037), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7039), 1,
      anon_sym_and,
    ACTIONS(7080), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7082), 1,
      anon_sym_or,
    ACTIONS(5428), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5430), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [87277] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3909), 1,
      sym_ms_unaligned_ptr_modifier,
    ACTIONS(7091), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3616), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(7088), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7086), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT2,
    ACTIONS(7084), 31,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [87343] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(6911), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6913), 1,
      anon_sym_AMP,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(6919), 1,
      anon_sym_LBRACK,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(7094), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7100), 1,
      anon_sym_DASH_GT,
    ACTIONS(7102), 1,
      anon_sym_requires,
    STATE(4788), 1,
      sym__function_attributes_start,
    STATE(4948), 1,
      sym_ref_qualifier,
    STATE(5574), 1,
      sym_trailing_return_type,
    STATE(5694), 1,
      sym__function_attributes_end,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6957), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7097), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(4181), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4519), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5784), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5239), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6909), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    ACTIONS(6915), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [87447] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6907), 1,
      anon_sym_LT,
    ACTIONS(7020), 1,
      anon_sym_EQ,
    STATE(2843), 1,
      sym_template_argument_list,
    ACTIONS(7018), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(3785), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(5187), 37,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [87515] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4699), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4701), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [87573] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6240), 1,
      anon_sym_EQ,
    ACTIONS(6371), 1,
      anon_sym_LBRACK,
    ACTIONS(6582), 1,
      anon_sym_DOT_STAR,
    ACTIONS(6766), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7057), 1,
      anon_sym_PIPE,
    ACTIONS(7059), 1,
      anon_sym_CARET,
    ACTIONS(7061), 1,
      anon_sym_AMP,
    ACTIONS(7067), 1,
      anon_sym_GT_EQ,
    ACTIONS(7069), 1,
      anon_sym_bitor,
    ACTIONS(7071), 1,
      anon_sym_xor,
    ACTIONS(7073), 1,
      anon_sym_bitand,
    STATE(3367), 1,
      sym_argument_list,
    STATE(3368), 1,
      sym_subscript_argument_list,
    ACTIONS(6415), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6780), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7045), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7049), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7053), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7055), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7047), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7063), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7065), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6242), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
  [87675] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5970), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5972), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [87733] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3604), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7051), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5450), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5448), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [87795] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6269), 1,
      anon_sym_EQ,
    ACTIONS(6371), 1,
      anon_sym_LBRACK,
    ACTIONS(6582), 1,
      anon_sym_DOT_STAR,
    ACTIONS(6766), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7057), 1,
      anon_sym_PIPE,
    ACTIONS(7059), 1,
      anon_sym_CARET,
    ACTIONS(7061), 1,
      anon_sym_AMP,
    ACTIONS(7067), 1,
      anon_sym_GT_EQ,
    ACTIONS(7069), 1,
      anon_sym_bitor,
    ACTIONS(7071), 1,
      anon_sym_xor,
    ACTIONS(7073), 1,
      anon_sym_bitand,
    STATE(3367), 1,
      sym_argument_list,
    STATE(3368), 1,
      sym_subscript_argument_list,
    ACTIONS(6415), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6780), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7045), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7049), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7053), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7055), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7047), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7063), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7065), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6271), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
  [87897] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4703), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4705), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [87955] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5266), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5264), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [88013] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5988), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5990), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [88071] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6911), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6913), 1,
      anon_sym_AMP,
    ACTIONS(6919), 1,
      anon_sym_LBRACK,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(6950), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6953), 1,
      anon_sym_const,
    ACTIONS(6963), 1,
      anon_sym_requires,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(7105), 1,
      anon_sym_DASH_GT,
    STATE(4786), 1,
      sym__function_attributes_start,
    STATE(4960), 1,
      sym_ref_qualifier,
    STATE(5591), 1,
      sym__function_attributes_end,
    STATE(5676), 1,
      sym_trailing_return_type,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7097), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(4307), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4741), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5784), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5232), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6909), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(6945), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [88175] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6371), 1,
      anon_sym_LBRACK,
    ACTIONS(6582), 1,
      anon_sym_DOT_STAR,
    STATE(3367), 1,
      sym_argument_list,
    STATE(3368), 1,
      sym_subscript_argument_list,
    ACTIONS(6415), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5698), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(5700), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT_STAR,
  [88245] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6000), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6002), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [88303] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(6911), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6913), 1,
      anon_sym_AMP,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(6919), 1,
      anon_sym_LBRACK,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(7094), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7100), 1,
      anon_sym_DASH_GT,
    ACTIONS(7107), 1,
      anon_sym_requires,
    STATE(4789), 1,
      sym__function_attributes_start,
    STATE(4980), 1,
      sym_ref_qualifier,
    STATE(5590), 1,
      sym_trailing_return_type,
    STATE(5635), 1,
      sym__function_attributes_end,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7097), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(4181), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4519), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5784), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5219), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6909), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    ACTIONS(6915), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [88407] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(6317), 1,
      anon_sym_LBRACE,
    ACTIONS(7109), 1,
      anon_sym_COLON,
    STATE(2649), 1,
      sym_attribute_specifier,
    STATE(2966), 1,
      sym__enum_base_clause,
    STATE(3079), 1,
      sym_enumerator_list,
    ACTIONS(5631), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5629), 33,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [88477] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5978), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5980), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [88535] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6008), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6010), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [88593] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4739), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4741), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [88651] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5863), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5865), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [88709] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5867), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5869), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [88767] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5877), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5879), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [88825] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6911), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6913), 1,
      anon_sym_AMP,
    ACTIONS(6919), 1,
      anon_sym_LBRACK,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(6950), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6953), 1,
      anon_sym_const,
    ACTIONS(6960), 1,
      anon_sym_requires,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(7105), 1,
      anon_sym_DASH_GT,
    STATE(4795), 1,
      sym__function_attributes_start,
    STATE(4974), 1,
      sym_ref_qualifier,
    STATE(5586), 1,
      sym__function_attributes_end,
    STATE(5629), 1,
      sym_trailing_return_type,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(6957), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7097), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(4307), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4741), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5784), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5225), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6909), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(6945), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [88929] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1961), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(1959), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [88987] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5201), 1,
      sym_literal_suffix,
    STATE(3304), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(5344), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(5346), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5197), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(5199), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [89053] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5201), 1,
      sym_literal_suffix,
    STATE(3304), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(5344), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(5346), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(3769), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(3761), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [89119] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5908), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5910), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [89177] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6012), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6014), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [89235] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5873), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5875), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [89293] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5730), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5732), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [89351] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4691), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4693), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [89409] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6036), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6038), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [89467] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4691), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4693), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [89525] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5888), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5890), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [89583] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4691), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4693), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [89641] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5934), 1,
      anon_sym_EQ,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6371), 1,
      anon_sym_LBRACK,
    ACTIONS(6582), 1,
      anon_sym_DOT_STAR,
    ACTIONS(6700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6744), 1,
      anon_sym_QMARK,
    ACTIONS(6766), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7057), 1,
      anon_sym_PIPE,
    ACTIONS(7059), 1,
      anon_sym_CARET,
    ACTIONS(7061), 1,
      anon_sym_AMP,
    ACTIONS(7067), 1,
      anon_sym_GT_EQ,
    ACTIONS(7069), 1,
      anon_sym_bitor,
    ACTIONS(7071), 1,
      anon_sym_xor,
    ACTIONS(7073), 1,
      anon_sym_bitand,
    STATE(3367), 1,
      sym_argument_list,
    STATE(3368), 1,
      sym_subscript_argument_list,
    ACTIONS(6415), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6780), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7045), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7049), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7053), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7055), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7047), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7063), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7065), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5936), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
  [89747] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5934), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5936), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [89805] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6103), 1,
      anon_sym_LT,
    STATE(1741), 1,
      sym_template_argument_list,
    ACTIONS(4534), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(4541), 42,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_try,
      anon_sym_requires,
  [89869] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6256), 1,
      anon_sym_EQ,
    ACTIONS(6371), 1,
      anon_sym_LBRACK,
    ACTIONS(6582), 1,
      anon_sym_DOT_STAR,
    ACTIONS(6766), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7057), 1,
      anon_sym_PIPE,
    ACTIONS(7059), 1,
      anon_sym_CARET,
    ACTIONS(7061), 1,
      anon_sym_AMP,
    ACTIONS(7067), 1,
      anon_sym_GT_EQ,
    ACTIONS(7069), 1,
      anon_sym_bitor,
    ACTIONS(7071), 1,
      anon_sym_xor,
    ACTIONS(7073), 1,
      anon_sym_bitand,
    STATE(3367), 1,
      sym_argument_list,
    STATE(3368), 1,
      sym_subscript_argument_list,
    ACTIONS(6415), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6780), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7045), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7049), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7053), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7055), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7047), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7063), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7065), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6258), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
  [89971] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1833), 1,
      anon_sym_enum,
    ACTIONS(1835), 1,
      anon_sym_class,
    ACTIONS(1837), 1,
      anon_sym_struct,
    ACTIONS(1839), 1,
      anon_sym_union,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(1869), 1,
      anon_sym_typename,
    ACTIONS(7111), 1,
      sym_identifier,
    ACTIONS(7113), 1,
      anon_sym_RPAREN,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    STATE(1898), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2293), 1,
      sym_primitive_type,
    STATE(4794), 1,
      sym__type_specifier,
    STATE(6373), 1,
      sym__scope_resolution,
    STATE(7116), 1,
      sym_type_descriptor,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3883), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(1827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [90075] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5841), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5843), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [90133] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(6911), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6913), 1,
      anon_sym_AMP,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(6919), 1,
      anon_sym_LBRACK,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(7094), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7102), 1,
      anon_sym_requires,
    ACTIONS(7117), 1,
      anon_sym_DASH_GT,
    STATE(4792), 1,
      sym__function_attributes_start,
    STATE(4976), 1,
      sym_ref_qualifier,
    STATE(5574), 1,
      sym_trailing_return_type,
    STATE(5724), 1,
      sym__function_attributes_end,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6957), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4181), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4519), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5784), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5234), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6909), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6915), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [90237] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    ACTIONS(6216), 1,
      anon_sym_EQ,
    ACTIONS(6371), 1,
      anon_sym_LBRACK,
    ACTIONS(6582), 1,
      anon_sym_DOT_STAR,
    ACTIONS(6700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6744), 1,
      anon_sym_QMARK,
    ACTIONS(6766), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7057), 1,
      anon_sym_PIPE,
    ACTIONS(7059), 1,
      anon_sym_CARET,
    ACTIONS(7061), 1,
      anon_sym_AMP,
    ACTIONS(7067), 1,
      anon_sym_GT_EQ,
    ACTIONS(7069), 1,
      anon_sym_bitor,
    ACTIONS(7071), 1,
      anon_sym_xor,
    ACTIONS(7073), 1,
      anon_sym_bitand,
    STATE(3367), 1,
      sym_argument_list,
    STATE(3368), 1,
      sym_subscript_argument_list,
    ACTIONS(6415), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6780), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7045), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7049), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7053), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7055), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7047), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7063), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7065), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6220), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
  [90343] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5920), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5922), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [90401] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5896), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5898), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [90459] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3604), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7051), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5426), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5424), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [90521] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4808), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2743), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [90579] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4617), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(4619), 12,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(3761), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(3769), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
  [90641] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7119), 1,
      anon_sym_LT,
    STATE(2030), 1,
      sym_template_argument_list,
    ACTIONS(4534), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(4541), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [90705] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(6317), 1,
      anon_sym_LBRACE,
    ACTIONS(7109), 1,
      anon_sym_COLON,
    STATE(2633), 1,
      sym_attribute_specifier,
    STATE(2881), 1,
      sym__enum_base_clause,
    STATE(3135), 1,
      sym_enumerator_list,
    ACTIONS(5691), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5689), 33,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [90775] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(6911), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6913), 1,
      anon_sym_AMP,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(6919), 1,
      anon_sym_LBRACK,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(7094), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7107), 1,
      anon_sym_requires,
    ACTIONS(7117), 1,
      anon_sym_DASH_GT,
    STATE(4798), 1,
      sym__function_attributes_start,
    STATE(4977), 1,
      sym_ref_qualifier,
    STATE(5590), 1,
      sym_trailing_return_type,
    STATE(5739), 1,
      sym__function_attributes_end,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(4181), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4519), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5784), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5235), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6909), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6915), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [90879] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5938), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5940), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [90937] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3580), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7122), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5105), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5107), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [90999] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4711), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4713), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [91057] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7016), 1,
      anon_sym_LT,
    STATE(2030), 1,
      sym_template_argument_list,
    ACTIONS(5187), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(3785), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [91121] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5916), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5918), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [91179] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5942), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5944), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [91237] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5833), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5835), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [91295] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5892), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5894), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [91353] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5853), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5855), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [91411] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5974), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5976), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [91469] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4551), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4553), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [91527] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6911), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6913), 1,
      anon_sym_AMP,
    ACTIONS(6919), 1,
      anon_sym_LBRACK,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(6950), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6953), 1,
      anon_sym_const,
    ACTIONS(6963), 1,
      anon_sym_requires,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(7043), 1,
      anon_sym_DASH_GT,
    STATE(4791), 1,
      sym__function_attributes_start,
    STATE(4947), 1,
      sym_ref_qualifier,
    STATE(5676), 1,
      sym_trailing_return_type,
    STATE(5779), 1,
      sym__function_attributes_end,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(4307), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4741), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5784), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5220), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6909), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
    ACTIONS(6945), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [91631] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5507), 1,
      anon_sym_EQ,
    ACTIONS(5509), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(3769), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3761), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [91693] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4555), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4557), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [91751] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6103), 1,
      anon_sym_LT,
    STATE(1741), 1,
      sym_template_argument_list,
    ACTIONS(5187), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(3785), 42,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_try,
      anon_sym_requires,
  [91815] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4559), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4561), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [91873] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4571), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4573), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [91931] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4567), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4569), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [91989] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4563), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4565), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [92047] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6024), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6026), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [92105] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5996), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5998), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [92163] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5837), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5839), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [92221] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4723), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4725), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [92279] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6321), 1,
      anon_sym_LBRACK,
    STATE(3719), 1,
      sym_new_declarator,
    ACTIONS(5681), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5683), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [92341] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4719), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4721), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [92399] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7124), 1,
      anon_sym_LBRACK,
    STATE(3838), 1,
      sym_new_declarator,
    ACTIONS(5681), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5683), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [92460] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1833), 1,
      anon_sym_enum,
    ACTIONS(1835), 1,
      anon_sym_class,
    ACTIONS(1837), 1,
      anon_sym_struct,
    ACTIONS(1839), 1,
      anon_sym_union,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(1869), 1,
      anon_sym_typename,
    ACTIONS(7111), 1,
      sym_identifier,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    STATE(1898), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2293), 1,
      sym_primitive_type,
    STATE(4794), 1,
      sym__type_specifier,
    STATE(6373), 1,
      sym__scope_resolution,
    STATE(8188), 1,
      sym_type_descriptor,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3883), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(1827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [92561] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1833), 1,
      anon_sym_enum,
    ACTIONS(1835), 1,
      anon_sym_class,
    ACTIONS(1837), 1,
      anon_sym_struct,
    ACTIONS(1839), 1,
      anon_sym_union,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(1869), 1,
      anon_sym_typename,
    ACTIONS(7111), 1,
      sym_identifier,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    STATE(1898), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2293), 1,
      sym_primitive_type,
    STATE(4794), 1,
      sym__type_specifier,
    STATE(6373), 1,
      sym__scope_resolution,
    STATE(7724), 1,
      sym_type_descriptor,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3883), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(1827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [92662] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(7126), 1,
      sym_identifier,
    ACTIONS(7128), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7132), 1,
      anon_sym_enum,
    ACTIONS(7134), 1,
      anon_sym_class,
    ACTIONS(7136), 1,
      anon_sym_struct,
    ACTIONS(7138), 1,
      anon_sym_union,
    ACTIONS(7140), 1,
      anon_sym_typename,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2825), 1,
      sym_qualified_type_identifier,
    STATE(4908), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4981), 1,
      sym__type_specifier,
    STATE(5150), 1,
      sym_primitive_type,
    STATE(5288), 1,
      sym__type_definition_type,
    STATE(6365), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3871), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7130), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [92763] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1833), 1,
      anon_sym_enum,
    ACTIONS(1835), 1,
      anon_sym_class,
    ACTIONS(1837), 1,
      anon_sym_struct,
    ACTIONS(1839), 1,
      anon_sym_union,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(1869), 1,
      anon_sym_typename,
    ACTIONS(7111), 1,
      sym_identifier,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    STATE(1898), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2293), 1,
      sym_primitive_type,
    STATE(4906), 1,
      sym__type_specifier,
    STATE(6373), 1,
      sym__scope_resolution,
    STATE(7905), 1,
      sym_type_descriptor,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3807), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(1827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [92864] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_auto,
    ACTIONS(121), 1,
      anon_sym_decltype,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(3572), 1,
      sym_identifier,
    ACTIONS(3578), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3582), 1,
      anon_sym_enum,
    ACTIONS(3584), 1,
      anon_sym_class,
    ACTIONS(3586), 1,
      anon_sym_struct,
    ACTIONS(3588), 1,
      anon_sym_union,
    ACTIONS(3590), 1,
      anon_sym_typename,
    STATE(2687), 1,
      sym_decltype_auto,
    STATE(2825), 1,
      sym_qualified_type_identifier,
    STATE(2855), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3443), 1,
      sym_primitive_type,
    STATE(4309), 1,
      sym__type_specifier,
    STATE(5733), 1,
      sym_type_descriptor,
    STATE(6333), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(2618), 2,
      sym_decltype,
      sym_template_type,
    STATE(3835), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(3580), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2629), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [92965] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6911), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6913), 1,
      anon_sym_AMP,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(6919), 1,
      anon_sym_LBRACK,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(7142), 1,
      anon_sym_DASH_GT,
    ACTIONS(7144), 1,
      anon_sym_requires,
    STATE(4884), 1,
      sym__function_attributes_start,
    STATE(5007), 1,
      sym_ref_qualifier,
    STATE(5889), 1,
      sym__function_attributes_end,
    STATE(5912), 1,
      sym_trailing_return_type,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4181), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4519), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5973), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5242), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6909), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    ACTIONS(6915), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [93068] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1833), 1,
      anon_sym_enum,
    ACTIONS(1835), 1,
      anon_sym_class,
    ACTIONS(1837), 1,
      anon_sym_struct,
    ACTIONS(1839), 1,
      anon_sym_union,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(1869), 1,
      anon_sym_typename,
    ACTIONS(7111), 1,
      sym_identifier,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    STATE(1898), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2293), 1,
      sym_primitive_type,
    STATE(4794), 1,
      sym__type_specifier,
    STATE(6373), 1,
      sym__scope_resolution,
    STATE(7741), 1,
      sym_type_descriptor,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3883), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(1827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [93169] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1833), 1,
      anon_sym_enum,
    ACTIONS(1835), 1,
      anon_sym_class,
    ACTIONS(1837), 1,
      anon_sym_struct,
    ACTIONS(1839), 1,
      anon_sym_union,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(1869), 1,
      anon_sym_typename,
    ACTIONS(7111), 1,
      sym_identifier,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    STATE(1898), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2293), 1,
      sym_primitive_type,
    STATE(4744), 1,
      sym__type_specifier,
    STATE(5940), 1,
      sym_type_descriptor,
    STATE(6373), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3884), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(1827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [93270] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4810), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(4812), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [93327] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(7126), 1,
      sym_identifier,
    ACTIONS(7128), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7132), 1,
      anon_sym_enum,
    ACTIONS(7134), 1,
      anon_sym_class,
    ACTIONS(7136), 1,
      anon_sym_struct,
    ACTIONS(7138), 1,
      anon_sym_union,
    ACTIONS(7140), 1,
      anon_sym_typename,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2825), 1,
      sym_qualified_type_identifier,
    STATE(4908), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4981), 1,
      sym__type_specifier,
    STATE(5150), 1,
      sym_primitive_type,
    STATE(5294), 1,
      sym__type_definition_type,
    STATE(6365), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3871), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7130), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [93428] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(7146), 1,
      sym_identifier,
    ACTIONS(7148), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7154), 1,
      anon_sym_enum,
    ACTIONS(7156), 1,
      anon_sym_class,
    ACTIONS(7158), 1,
      anon_sym_struct,
    ACTIONS(7160), 1,
      anon_sym_union,
    ACTIONS(7162), 1,
      sym_auto,
    ACTIONS(7164), 1,
      anon_sym_decltype,
    ACTIONS(7166), 1,
      anon_sym_typename,
    STATE(2825), 1,
      sym_qualified_type_identifier,
    STATE(4105), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4225), 1,
      sym__type_specifier,
    STATE(4456), 1,
      sym_primitive_type,
    STATE(4873), 1,
      sym_decltype_auto,
    STATE(5733), 1,
      sym_type_descriptor,
    STATE(6355), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(2618), 2,
      sym_decltype,
      sym_template_type,
    STATE(3842), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7152), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7150), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4876), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [93529] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4833), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(4835), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [93586] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1833), 1,
      anon_sym_enum,
    ACTIONS(1835), 1,
      anon_sym_class,
    ACTIONS(1837), 1,
      anon_sym_struct,
    ACTIONS(1839), 1,
      anon_sym_union,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(1869), 1,
      anon_sym_typename,
    ACTIONS(7111), 1,
      sym_identifier,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    STATE(1898), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2293), 1,
      sym_primitive_type,
    STATE(4794), 1,
      sym__type_specifier,
    STATE(6373), 1,
      sym__scope_resolution,
    STATE(7689), 1,
      sym_type_descriptor,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3883), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(1827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [93687] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(7126), 1,
      sym_identifier,
    ACTIONS(7128), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7132), 1,
      anon_sym_enum,
    ACTIONS(7134), 1,
      anon_sym_class,
    ACTIONS(7136), 1,
      anon_sym_struct,
    ACTIONS(7138), 1,
      anon_sym_union,
    ACTIONS(7140), 1,
      anon_sym_typename,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2825), 1,
      sym_qualified_type_identifier,
    STATE(4908), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4981), 1,
      sym__type_specifier,
    STATE(5150), 1,
      sym_primitive_type,
    STATE(5286), 1,
      sym__type_definition_type,
    STATE(6365), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3871), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7130), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [93788] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5670), 1,
      sym_literal_suffix,
    STATE(3396), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(4621), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(4623), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5197), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(5199), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [93853] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(7168), 1,
      sym_identifier,
    ACTIONS(7170), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7176), 1,
      anon_sym_enum,
    ACTIONS(7178), 1,
      anon_sym_class,
    ACTIONS(7180), 1,
      anon_sym_struct,
    ACTIONS(7182), 1,
      anon_sym_union,
    ACTIONS(7184), 1,
      sym_auto,
    ACTIONS(7186), 1,
      anon_sym_decltype,
    ACTIONS(7188), 1,
      anon_sym_typename,
    STATE(4159), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4165), 1,
      sym__type_specifier,
    STATE(4768), 1,
      sym_primitive_type,
    STATE(5028), 1,
      sym_decltype_auto,
    STATE(5057), 1,
      sym_qualified_type_identifier,
    STATE(5940), 1,
      sym_type_descriptor,
    STATE(6342), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(3844), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4951), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(7174), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7172), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5027), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [93954] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5670), 1,
      sym_literal_suffix,
    STATE(3396), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(4621), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(4623), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(3769), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(3761), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [94019] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4563), 23,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(4565), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [94076] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1833), 1,
      anon_sym_enum,
    ACTIONS(1835), 1,
      anon_sym_class,
    ACTIONS(1837), 1,
      anon_sym_struct,
    ACTIONS(1839), 1,
      anon_sym_union,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(1869), 1,
      anon_sym_typename,
    ACTIONS(7111), 1,
      sym_identifier,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    STATE(1898), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2293), 1,
      sym_primitive_type,
    STATE(4794), 1,
      sym__type_specifier,
    STATE(6373), 1,
      sym__scope_resolution,
    STATE(8187), 1,
      sym_type_descriptor,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3883), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(1827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [94177] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1833), 1,
      anon_sym_enum,
    ACTIONS(1835), 1,
      anon_sym_class,
    ACTIONS(1837), 1,
      anon_sym_struct,
    ACTIONS(1839), 1,
      anon_sym_union,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(1869), 1,
      anon_sym_typename,
    ACTIONS(7111), 1,
      sym_identifier,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    STATE(1898), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2293), 1,
      sym_primitive_type,
    STATE(4794), 1,
      sym__type_specifier,
    STATE(5733), 1,
      sym_type_descriptor,
    STATE(6373), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3883), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(1827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [94278] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(7126), 1,
      sym_identifier,
    ACTIONS(7128), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7132), 1,
      anon_sym_enum,
    ACTIONS(7134), 1,
      anon_sym_class,
    ACTIONS(7136), 1,
      anon_sym_struct,
    ACTIONS(7138), 1,
      anon_sym_union,
    ACTIONS(7140), 1,
      anon_sym_typename,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2825), 1,
      sym_qualified_type_identifier,
    STATE(4908), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4981), 1,
      sym__type_specifier,
    STATE(5150), 1,
      sym_primitive_type,
    STATE(5293), 1,
      sym__type_definition_type,
    STATE(6365), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3871), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7130), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [94379] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(7126), 1,
      sym_identifier,
    ACTIONS(7128), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7132), 1,
      anon_sym_enum,
    ACTIONS(7134), 1,
      anon_sym_class,
    ACTIONS(7136), 1,
      anon_sym_struct,
    ACTIONS(7138), 1,
      anon_sym_union,
    ACTIONS(7140), 1,
      anon_sym_typename,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2825), 1,
      sym_qualified_type_identifier,
    STATE(4908), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4981), 1,
      sym__type_specifier,
    STATE(5150), 1,
      sym_primitive_type,
    STATE(5290), 1,
      sym__type_definition_type,
    STATE(6365), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3871), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7130), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [94480] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(7126), 1,
      sym_identifier,
    ACTIONS(7128), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7132), 1,
      anon_sym_enum,
    ACTIONS(7134), 1,
      anon_sym_class,
    ACTIONS(7136), 1,
      anon_sym_struct,
    ACTIONS(7138), 1,
      anon_sym_union,
    ACTIONS(7140), 1,
      anon_sym_typename,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2825), 1,
      sym_qualified_type_identifier,
    STATE(4908), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4981), 1,
      sym__type_specifier,
    STATE(5150), 1,
      sym_primitive_type,
    STATE(5289), 1,
      sym__type_definition_type,
    STATE(6365), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3871), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7130), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [94581] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4567), 23,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(4569), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [94638] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(7126), 1,
      sym_identifier,
    ACTIONS(7128), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7132), 1,
      anon_sym_enum,
    ACTIONS(7134), 1,
      anon_sym_class,
    ACTIONS(7136), 1,
      anon_sym_struct,
    ACTIONS(7138), 1,
      anon_sym_union,
    ACTIONS(7140), 1,
      anon_sym_typename,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2825), 1,
      sym_qualified_type_identifier,
    STATE(4908), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4981), 1,
      sym__type_specifier,
    STATE(5150), 1,
      sym_primitive_type,
    STATE(5292), 1,
      sym__type_definition_type,
    STATE(6365), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3871), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7130), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [94739] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(7126), 1,
      sym_identifier,
    ACTIONS(7128), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7132), 1,
      anon_sym_enum,
    ACTIONS(7134), 1,
      anon_sym_class,
    ACTIONS(7136), 1,
      anon_sym_struct,
    ACTIONS(7138), 1,
      anon_sym_union,
    ACTIONS(7140), 1,
      anon_sym_typename,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2825), 1,
      sym_qualified_type_identifier,
    STATE(4908), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4981), 1,
      sym__type_specifier,
    STATE(5150), 1,
      sym_primitive_type,
    STATE(5285), 1,
      sym__type_definition_type,
    STATE(6365), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3871), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7130), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [94840] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5714), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5716), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [94897] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_auto,
    ACTIONS(121), 1,
      anon_sym_decltype,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(7190), 1,
      sym_identifier,
    ACTIONS(7192), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7194), 1,
      anon_sym_enum,
    ACTIONS(7196), 1,
      anon_sym_class,
    ACTIONS(7198), 1,
      anon_sym_struct,
    ACTIONS(7200), 1,
      anon_sym_union,
    ACTIONS(7202), 1,
      anon_sym_typename,
    STATE(2687), 1,
      sym_decltype_auto,
    STATE(2825), 1,
      sym_qualified_type_identifier,
    STATE(2855), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3443), 1,
      sym_primitive_type,
    STATE(4191), 1,
      sym__type_specifier,
    STATE(5733), 1,
      sym_type_descriptor,
    STATE(6371), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(2618), 2,
      sym_decltype,
      sym_template_type,
    STATE(3810), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(3580), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2629), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [94998] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(7126), 1,
      sym_identifier,
    ACTIONS(7128), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7132), 1,
      anon_sym_enum,
    ACTIONS(7134), 1,
      anon_sym_class,
    ACTIONS(7136), 1,
      anon_sym_struct,
    ACTIONS(7138), 1,
      anon_sym_union,
    ACTIONS(7140), 1,
      anon_sym_typename,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2825), 1,
      sym_qualified_type_identifier,
    STATE(4908), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4981), 1,
      sym__type_specifier,
    STATE(5150), 1,
      sym_primitive_type,
    STATE(5276), 1,
      sym__type_definition_type,
    STATE(6365), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3871), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7130), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [95099] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4571), 23,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(4573), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [95156] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4582), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(4584), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4577), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [95215] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1833), 1,
      anon_sym_enum,
    ACTIONS(1835), 1,
      anon_sym_class,
    ACTIONS(1837), 1,
      anon_sym_struct,
    ACTIONS(1839), 1,
      anon_sym_union,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(1869), 1,
      anon_sym_typename,
    ACTIONS(7111), 1,
      sym_identifier,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    STATE(1898), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2293), 1,
      sym_primitive_type,
    STATE(4794), 1,
      sym__type_specifier,
    STATE(6373), 1,
      sym__scope_resolution,
    STATE(8147), 1,
      sym_type_descriptor,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3883), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(1827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [95316] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4559), 23,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(4561), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [95373] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1833), 1,
      anon_sym_enum,
    ACTIONS(1835), 1,
      anon_sym_class,
    ACTIONS(1837), 1,
      anon_sym_struct,
    ACTIONS(1839), 1,
      anon_sym_union,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(1869), 1,
      anon_sym_typename,
    ACTIONS(7111), 1,
      sym_identifier,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    STATE(1898), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2293), 1,
      sym_primitive_type,
    STATE(4794), 1,
      sym__type_specifier,
    STATE(6373), 1,
      sym__scope_resolution,
    STATE(7789), 1,
      sym_type_descriptor,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3883), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(1827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [95474] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1833), 1,
      anon_sym_enum,
    ACTIONS(1835), 1,
      anon_sym_class,
    ACTIONS(1837), 1,
      anon_sym_struct,
    ACTIONS(1839), 1,
      anon_sym_union,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(1869), 1,
      anon_sym_typename,
    ACTIONS(7111), 1,
      sym_identifier,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    STATE(1898), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2293), 1,
      sym_primitive_type,
    STATE(4794), 1,
      sym__type_specifier,
    STATE(6373), 1,
      sym__scope_resolution,
    STATE(7446), 1,
      sym_type_descriptor,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3883), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(1827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [95575] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1833), 1,
      anon_sym_enum,
    ACTIONS(1835), 1,
      anon_sym_class,
    ACTIONS(1837), 1,
      anon_sym_struct,
    ACTIONS(1839), 1,
      anon_sym_union,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(1869), 1,
      anon_sym_typename,
    ACTIONS(7111), 1,
      sym_identifier,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    STATE(1898), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2293), 1,
      sym_primitive_type,
    STATE(4906), 1,
      sym__type_specifier,
    STATE(6373), 1,
      sym__scope_resolution,
    STATE(8210), 1,
      sym_type_descriptor,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3807), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(1827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [95676] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1833), 1,
      anon_sym_enum,
    ACTIONS(1835), 1,
      anon_sym_class,
    ACTIONS(1837), 1,
      anon_sym_struct,
    ACTIONS(1839), 1,
      anon_sym_union,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(1869), 1,
      anon_sym_typename,
    ACTIONS(7111), 1,
      sym_identifier,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    STATE(1898), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2293), 1,
      sym_primitive_type,
    STATE(4906), 1,
      sym__type_specifier,
    STATE(6373), 1,
      sym__scope_resolution,
    STATE(8192), 1,
      sym_type_descriptor,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3807), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(1827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [95777] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1833), 1,
      anon_sym_enum,
    ACTIONS(1835), 1,
      anon_sym_class,
    ACTIONS(1837), 1,
      anon_sym_struct,
    ACTIONS(1839), 1,
      anon_sym_union,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(1869), 1,
      anon_sym_typename,
    ACTIONS(7111), 1,
      sym_identifier,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    STATE(1898), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2293), 1,
      sym_primitive_type,
    STATE(4906), 1,
      sym__type_specifier,
    STATE(6373), 1,
      sym__scope_resolution,
    STATE(8152), 1,
      sym_type_descriptor,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3807), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(1827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [95878] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4555), 23,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(4557), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [95935] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6289), 23,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(6291), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [95992] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(7162), 1,
      sym_auto,
    ACTIONS(7164), 1,
      anon_sym_decltype,
    ACTIONS(7204), 1,
      sym_identifier,
    ACTIONS(7206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7208), 1,
      anon_sym_enum,
    ACTIONS(7210), 1,
      anon_sym_class,
    ACTIONS(7212), 1,
      anon_sym_struct,
    ACTIONS(7214), 1,
      anon_sym_union,
    ACTIONS(7216), 1,
      anon_sym_typename,
    STATE(2825), 1,
      sym_qualified_type_identifier,
    STATE(4105), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4456), 1,
      sym_primitive_type,
    STATE(4667), 1,
      sym__type_specifier,
    STATE(4873), 1,
      sym_decltype_auto,
    STATE(5733), 1,
      sym_type_descriptor,
    STATE(6336), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(2618), 2,
      sym_decltype,
      sym_template_type,
    STATE(3867), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7152), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7150), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4876), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [96093] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6903), 1,
      anon_sym___attribute__,
    ACTIONS(7218), 1,
      anon_sym_LBRACE,
    ACTIONS(7220), 1,
      anon_sym_COLON,
    STATE(3916), 1,
      sym__enum_base_clause,
    STATE(3977), 1,
      sym_enumerator_list,
    STATE(4072), 1,
      sym_attribute_specifier,
    ACTIONS(5689), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5691), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [96162] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7224), 5,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7222), 44,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_typename,
      anon_sym_template,
  [96219] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(7126), 1,
      sym_identifier,
    ACTIONS(7128), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7132), 1,
      anon_sym_enum,
    ACTIONS(7134), 1,
      anon_sym_class,
    ACTIONS(7136), 1,
      anon_sym_struct,
    ACTIONS(7138), 1,
      anon_sym_union,
    ACTIONS(7140), 1,
      anon_sym_typename,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2825), 1,
      sym_qualified_type_identifier,
    STATE(4908), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4981), 1,
      sym__type_specifier,
    STATE(5150), 1,
      sym_primitive_type,
    STATE(5296), 1,
      sym__type_definition_type,
    STATE(6365), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3871), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7130), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [96320] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(7126), 1,
      sym_identifier,
    ACTIONS(7128), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7132), 1,
      anon_sym_enum,
    ACTIONS(7134), 1,
      anon_sym_class,
    ACTIONS(7136), 1,
      anon_sym_struct,
    ACTIONS(7138), 1,
      anon_sym_union,
    ACTIONS(7140), 1,
      anon_sym_typename,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2825), 1,
      sym_qualified_type_identifier,
    STATE(4908), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4981), 1,
      sym__type_specifier,
    STATE(5150), 1,
      sym_primitive_type,
    STATE(5280), 1,
      sym__type_definition_type,
    STATE(6365), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3871), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7130), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [96421] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(7126), 1,
      sym_identifier,
    ACTIONS(7128), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7132), 1,
      anon_sym_enum,
    ACTIONS(7134), 1,
      anon_sym_class,
    ACTIONS(7136), 1,
      anon_sym_struct,
    ACTIONS(7138), 1,
      anon_sym_union,
    ACTIONS(7140), 1,
      anon_sym_typename,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2825), 1,
      sym_qualified_type_identifier,
    STATE(4908), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4981), 1,
      sym__type_specifier,
    STATE(5150), 1,
      sym_primitive_type,
    STATE(5278), 1,
      sym__type_definition_type,
    STATE(6365), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3871), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7130), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [96522] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1833), 1,
      anon_sym_enum,
    ACTIONS(1835), 1,
      anon_sym_class,
    ACTIONS(1837), 1,
      anon_sym_struct,
    ACTIONS(1839), 1,
      anon_sym_union,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(1869), 1,
      anon_sym_typename,
    ACTIONS(7111), 1,
      sym_identifier,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    STATE(1898), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2293), 1,
      sym_primitive_type,
    STATE(4794), 1,
      sym__type_specifier,
    STATE(6373), 1,
      sym__scope_resolution,
    STATE(7836), 1,
      sym_type_descriptor,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3883), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(1827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [96623] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1833), 1,
      anon_sym_enum,
    ACTIONS(1835), 1,
      anon_sym_class,
    ACTIONS(1837), 1,
      anon_sym_struct,
    ACTIONS(1839), 1,
      anon_sym_union,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(1869), 1,
      anon_sym_typename,
    ACTIONS(7111), 1,
      sym_identifier,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    STATE(1898), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2293), 1,
      sym_primitive_type,
    STATE(4794), 1,
      sym__type_specifier,
    STATE(6373), 1,
      sym__scope_resolution,
    STATE(7995), 1,
      sym_type_descriptor,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3883), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(1827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [96724] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6299), 23,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(6301), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [96781] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6103), 1,
      anon_sym_LT,
    STATE(1741), 1,
      sym_template_argument_list,
    STATE(3431), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3759), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(6522), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3767), 37,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_try,
      anon_sym_requires,
  [96848] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1833), 1,
      anon_sym_enum,
    ACTIONS(1835), 1,
      anon_sym_class,
    ACTIONS(1837), 1,
      anon_sym_struct,
    ACTIONS(1839), 1,
      anon_sym_union,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(1869), 1,
      anon_sym_typename,
    ACTIONS(7111), 1,
      sym_identifier,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    STATE(1898), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2293), 1,
      sym_primitive_type,
    STATE(4794), 1,
      sym__type_specifier,
    STATE(6373), 1,
      sym__scope_resolution,
    STATE(7599), 1,
      sym_type_descriptor,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3883), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(1827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [96949] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6903), 1,
      anon_sym___attribute__,
    ACTIONS(7218), 1,
      anon_sym_LBRACE,
    ACTIONS(7220), 1,
      anon_sym_COLON,
    STATE(3938), 1,
      sym__enum_base_clause,
    STATE(3971), 1,
      sym_enumerator_list,
    STATE(4071), 1,
      sym_attribute_specifier,
    ACTIONS(5629), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5631), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [97018] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(6911), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6913), 1,
      anon_sym_AMP,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(6919), 1,
      anon_sym_LBRACK,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(7094), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7226), 1,
      anon_sym_DASH_GT,
    ACTIONS(7228), 1,
      anon_sym_requires,
    STATE(4901), 1,
      sym__function_attributes_start,
    STATE(5054), 1,
      sym_ref_qualifier,
    STATE(5802), 1,
      sym__function_attributes_end,
    STATE(5914), 1,
      sym_trailing_return_type,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(4181), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4519), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5784), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5254), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6909), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
    ACTIONS(6915), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [97121] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1833), 1,
      anon_sym_enum,
    ACTIONS(1835), 1,
      anon_sym_class,
    ACTIONS(1837), 1,
      anon_sym_struct,
    ACTIONS(1839), 1,
      anon_sym_union,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(1869), 1,
      anon_sym_typename,
    ACTIONS(7111), 1,
      sym_identifier,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    STATE(1898), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2293), 1,
      sym_primitive_type,
    STATE(4906), 1,
      sym__type_specifier,
    STATE(6373), 1,
      sym__scope_resolution,
    STATE(8173), 1,
      sym_type_descriptor,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3807), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(1827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [97222] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4551), 23,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(4553), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [97279] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1833), 1,
      anon_sym_enum,
    ACTIONS(1835), 1,
      anon_sym_class,
    ACTIONS(1837), 1,
      anon_sym_struct,
    ACTIONS(1839), 1,
      anon_sym_union,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(1869), 1,
      anon_sym_typename,
    ACTIONS(7111), 1,
      sym_identifier,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    STATE(1898), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2293), 1,
      sym_primitive_type,
    STATE(4906), 1,
      sym__type_specifier,
    STATE(6373), 1,
      sym__scope_resolution,
    STATE(8017), 1,
      sym_type_descriptor,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3807), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(1827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [97380] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1833), 1,
      anon_sym_enum,
    ACTIONS(1835), 1,
      anon_sym_class,
    ACTIONS(1837), 1,
      anon_sym_struct,
    ACTIONS(1839), 1,
      anon_sym_union,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(1869), 1,
      anon_sym_typename,
    ACTIONS(7111), 1,
      sym_identifier,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    STATE(1898), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2293), 1,
      sym_primitive_type,
    STATE(4794), 1,
      sym__type_specifier,
    STATE(6373), 1,
      sym__scope_resolution,
    STATE(8168), 1,
      sym_type_descriptor,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3883), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(1827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [97481] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4530), 23,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(4532), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [97538] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(7126), 1,
      sym_identifier,
    ACTIONS(7128), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7132), 1,
      anon_sym_enum,
    ACTIONS(7134), 1,
      anon_sym_class,
    ACTIONS(7136), 1,
      anon_sym_struct,
    ACTIONS(7138), 1,
      anon_sym_union,
    ACTIONS(7140), 1,
      anon_sym_typename,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2825), 1,
      sym_qualified_type_identifier,
    STATE(4908), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4981), 1,
      sym__type_specifier,
    STATE(5150), 1,
      sym_primitive_type,
    STATE(5274), 1,
      sym__type_definition_type,
    STATE(6365), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3871), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7130), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [97639] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(7126), 1,
      sym_identifier,
    ACTIONS(7128), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7132), 1,
      anon_sym_enum,
    ACTIONS(7134), 1,
      anon_sym_class,
    ACTIONS(7136), 1,
      anon_sym_struct,
    ACTIONS(7138), 1,
      anon_sym_union,
    ACTIONS(7140), 1,
      anon_sym_typename,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2825), 1,
      sym_qualified_type_identifier,
    STATE(4908), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4981), 1,
      sym__type_specifier,
    STATE(5150), 1,
      sym_primitive_type,
    STATE(5282), 1,
      sym__type_definition_type,
    STATE(6365), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3871), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7130), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [97740] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3580), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7122), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4924), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(4926), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [97801] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1833), 1,
      anon_sym_enum,
    ACTIONS(1835), 1,
      anon_sym_class,
    ACTIONS(1837), 1,
      anon_sym_struct,
    ACTIONS(1839), 1,
      anon_sym_union,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(1869), 1,
      anon_sym_typename,
    ACTIONS(7111), 1,
      sym_identifier,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    STATE(1898), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2293), 1,
      sym_primitive_type,
    STATE(4794), 1,
      sym__type_specifier,
    STATE(6373), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(8367), 1,
      sym_type_descriptor,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3883), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(1827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [97902] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4545), 1,
      anon_sym_LBRACK,
    ACTIONS(6103), 1,
      anon_sym_LT,
    STATE(3917), 1,
      sym_template_argument_list,
    ACTIONS(4538), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4541), 4,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
    ACTIONS(4534), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [97969] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1833), 1,
      anon_sym_enum,
    ACTIONS(1835), 1,
      anon_sym_class,
    ACTIONS(1837), 1,
      anon_sym_struct,
    ACTIONS(1839), 1,
      anon_sym_union,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(1869), 1,
      anon_sym_typename,
    ACTIONS(7111), 1,
      sym_identifier,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    STATE(1898), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2293), 1,
      sym_primitive_type,
    STATE(4794), 1,
      sym__type_specifier,
    STATE(6373), 1,
      sym__scope_resolution,
    STATE(8205), 1,
      sym_type_descriptor,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3883), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(1827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [98070] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1833), 1,
      anon_sym_enum,
    ACTIONS(1835), 1,
      anon_sym_class,
    ACTIONS(1837), 1,
      anon_sym_struct,
    ACTIONS(1839), 1,
      anon_sym_union,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(1869), 1,
      anon_sym_typename,
    ACTIONS(7111), 1,
      sym_identifier,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    STATE(1898), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2293), 1,
      sym_primitive_type,
    STATE(4794), 1,
      sym__type_specifier,
    STATE(6373), 1,
      sym__scope_resolution,
    STATE(7707), 1,
      sym_type_descriptor,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3883), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(1827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [98171] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1833), 1,
      anon_sym_enum,
    ACTIONS(1835), 1,
      anon_sym_class,
    ACTIONS(1837), 1,
      anon_sym_struct,
    ACTIONS(1839), 1,
      anon_sym_union,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(1869), 1,
      anon_sym_typename,
    ACTIONS(7111), 1,
      sym_identifier,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    STATE(1898), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2293), 1,
      sym_primitive_type,
    STATE(4794), 1,
      sym__type_specifier,
    STATE(6373), 1,
      sym__scope_resolution,
    STATE(8074), 1,
      sym_type_descriptor,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3883), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(1827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [98272] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6911), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6913), 1,
      anon_sym_AMP,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(6919), 1,
      anon_sym_LBRACK,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(7142), 1,
      anon_sym_DASH_GT,
    ACTIONS(7230), 1,
      anon_sym_requires,
    STATE(4891), 1,
      sym__function_attributes_start,
    STATE(5047), 1,
      sym_ref_qualifier,
    STATE(5880), 1,
      sym__function_attributes_end,
    STATE(5958), 1,
      sym_trailing_return_type,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6925), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4181), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4519), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5973), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5250), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6909), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    ACTIONS(6915), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [98375] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1833), 1,
      anon_sym_enum,
    ACTIONS(1835), 1,
      anon_sym_class,
    ACTIONS(1837), 1,
      anon_sym_struct,
    ACTIONS(1839), 1,
      anon_sym_union,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(1869), 1,
      anon_sym_typename,
    ACTIONS(7111), 1,
      sym_identifier,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    STATE(1898), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2293), 1,
      sym_primitive_type,
    STATE(4794), 1,
      sym__type_specifier,
    STATE(6373), 1,
      sym__scope_resolution,
    STATE(7702), 1,
      sym_type_descriptor,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3883), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(1827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [98476] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1833), 1,
      anon_sym_enum,
    ACTIONS(1835), 1,
      anon_sym_class,
    ACTIONS(1837), 1,
      anon_sym_struct,
    ACTIONS(1839), 1,
      anon_sym_union,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(1869), 1,
      anon_sym_typename,
    ACTIONS(7111), 1,
      sym_identifier,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    STATE(1898), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2293), 1,
      sym_primitive_type,
    STATE(4794), 1,
      sym__type_specifier,
    STATE(6373), 1,
      sym__scope_resolution,
    STATE(7623), 1,
      sym_type_descriptor,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3883), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(1827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [98577] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(7126), 1,
      sym_identifier,
    ACTIONS(7128), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7132), 1,
      anon_sym_enum,
    ACTIONS(7134), 1,
      anon_sym_class,
    ACTIONS(7136), 1,
      anon_sym_struct,
    ACTIONS(7138), 1,
      anon_sym_union,
    ACTIONS(7140), 1,
      anon_sym_typename,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2825), 1,
      sym_qualified_type_identifier,
    STATE(4908), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4981), 1,
      sym__type_specifier,
    STATE(5150), 1,
      sym_primitive_type,
    STATE(5277), 1,
      sym__type_definition_type,
    STATE(6365), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3871), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7130), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [98678] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4922), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4918), 23,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(4920), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [98737] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(7126), 1,
      sym_identifier,
    ACTIONS(7128), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7132), 1,
      anon_sym_enum,
    ACTIONS(7134), 1,
      anon_sym_class,
    ACTIONS(7136), 1,
      anon_sym_struct,
    ACTIONS(7138), 1,
      anon_sym_union,
    ACTIONS(7140), 1,
      anon_sym_typename,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2825), 1,
      sym_qualified_type_identifier,
    STATE(4908), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4981), 1,
      sym__type_specifier,
    STATE(5150), 1,
      sym_primitive_type,
    STATE(5284), 1,
      sym__type_definition_type,
    STATE(6365), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3871), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7130), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [98838] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1833), 1,
      anon_sym_enum,
    ACTIONS(1835), 1,
      anon_sym_class,
    ACTIONS(1837), 1,
      anon_sym_struct,
    ACTIONS(1839), 1,
      anon_sym_union,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(1869), 1,
      anon_sym_typename,
    ACTIONS(7111), 1,
      sym_identifier,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    STATE(1898), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2293), 1,
      sym_primitive_type,
    STATE(4794), 1,
      sym__type_specifier,
    STATE(6373), 1,
      sym__scope_resolution,
    STATE(8162), 1,
      sym_type_descriptor,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3883), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(1827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [98939] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1833), 1,
      anon_sym_enum,
    ACTIONS(1835), 1,
      anon_sym_class,
    ACTIONS(1837), 1,
      anon_sym_struct,
    ACTIONS(1839), 1,
      anon_sym_union,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(1869), 1,
      anon_sym_typename,
    ACTIONS(7111), 1,
      sym_identifier,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    STATE(1898), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2293), 1,
      sym_primitive_type,
    STATE(4794), 1,
      sym__type_specifier,
    STATE(6373), 1,
      sym__scope_resolution,
    STATE(8170), 1,
      sym_type_descriptor,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3883), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(1827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [99040] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1833), 1,
      anon_sym_enum,
    ACTIONS(1835), 1,
      anon_sym_class,
    ACTIONS(1837), 1,
      anon_sym_struct,
    ACTIONS(1839), 1,
      anon_sym_union,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(1869), 1,
      anon_sym_typename,
    ACTIONS(7111), 1,
      sym_identifier,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    STATE(1898), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2293), 1,
      sym_primitive_type,
    STATE(4405), 1,
      sym__type_specifier,
    STATE(5940), 1,
      sym_type_descriptor,
    STATE(6373), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3873), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(1827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [99141] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(2589), 1,
      anon_sym_enum,
    ACTIONS(2591), 1,
      anon_sym_class,
    ACTIONS(2593), 1,
      anon_sym_struct,
    ACTIONS(2595), 1,
      anon_sym_union,
    ACTIONS(2621), 1,
      sym_auto,
    ACTIONS(2623), 1,
      anon_sym_decltype,
    ACTIONS(2625), 1,
      anon_sym_typename,
    ACTIONS(7233), 1,
      sym_identifier,
    ACTIONS(7235), 1,
      anon_sym_COLON_COLON,
    STATE(2164), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2612), 1,
      sym_primitive_type,
    STATE(2882), 1,
      sym_qualified_type_identifier,
    STATE(2933), 1,
      sym_decltype_auto,
    STATE(4610), 1,
      sym__type_specifier,
    STATE(5940), 1,
      sym_type_descriptor,
    STATE(6339), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(2868), 2,
      sym_decltype,
      sym_template_type,
    STATE(3821), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2587), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2585), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2935), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [99242] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1833), 1,
      anon_sym_enum,
    ACTIONS(1835), 1,
      anon_sym_class,
    ACTIONS(1837), 1,
      anon_sym_struct,
    ACTIONS(1839), 1,
      anon_sym_union,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(1869), 1,
      anon_sym_typename,
    ACTIONS(7111), 1,
      sym_identifier,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    STATE(1898), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2293), 1,
      sym_primitive_type,
    STATE(4794), 1,
      sym__type_specifier,
    STATE(6373), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(8330), 1,
      sym_type_descriptor,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3883), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(1827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [99343] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1833), 1,
      anon_sym_enum,
    ACTIONS(1835), 1,
      anon_sym_class,
    ACTIONS(1837), 1,
      anon_sym_struct,
    ACTIONS(1839), 1,
      anon_sym_union,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(1869), 1,
      anon_sym_typename,
    ACTIONS(7111), 1,
      sym_identifier,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    STATE(1898), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2293), 1,
      sym_primitive_type,
    STATE(4794), 1,
      sym__type_specifier,
    STATE(6373), 1,
      sym__scope_resolution,
    STATE(8026), 1,
      sym_type_descriptor,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3883), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(1827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [99444] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4922), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4918), 23,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(4920), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [99503] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1833), 1,
      anon_sym_enum,
    ACTIONS(1835), 1,
      anon_sym_class,
    ACTIONS(1837), 1,
      anon_sym_struct,
    ACTIONS(1839), 1,
      anon_sym_union,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(1869), 1,
      anon_sym_typename,
    ACTIONS(7111), 1,
      sym_identifier,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    STATE(1898), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2293), 1,
      sym_primitive_type,
    STATE(4794), 1,
      sym__type_specifier,
    STATE(6373), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(8354), 1,
      sym_type_descriptor,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3883), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(1827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [99604] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5621), 1,
      sym_literal_suffix,
    ACTIONS(5197), 22,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5199), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [99663] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4829), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(4831), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [99720] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(7126), 1,
      sym_identifier,
    ACTIONS(7128), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7132), 1,
      anon_sym_enum,
    ACTIONS(7134), 1,
      anon_sym_class,
    ACTIONS(7136), 1,
      anon_sym_struct,
    ACTIONS(7138), 1,
      anon_sym_union,
    ACTIONS(7140), 1,
      anon_sym_typename,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2825), 1,
      sym_qualified_type_identifier,
    STATE(4908), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4981), 1,
      sym__type_specifier,
    STATE(5150), 1,
      sym_primitive_type,
    STATE(5281), 1,
      sym__type_definition_type,
    STATE(6365), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3871), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7130), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [99821] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1833), 1,
      anon_sym_enum,
    ACTIONS(1835), 1,
      anon_sym_class,
    ACTIONS(1837), 1,
      anon_sym_struct,
    ACTIONS(1839), 1,
      anon_sym_union,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(1869), 1,
      anon_sym_typename,
    ACTIONS(7111), 1,
      sym_identifier,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    STATE(1898), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2293), 1,
      sym_primitive_type,
    STATE(4794), 1,
      sym__type_specifier,
    STATE(6373), 1,
      sym__scope_resolution,
    STATE(7832), 1,
      sym_type_descriptor,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3883), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(1827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [99922] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4928), 23,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(4930), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [99979] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1833), 1,
      anon_sym_enum,
    ACTIONS(1835), 1,
      anon_sym_class,
    ACTIONS(1837), 1,
      anon_sym_struct,
    ACTIONS(1839), 1,
      anon_sym_union,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(1869), 1,
      anon_sym_typename,
    ACTIONS(7111), 1,
      sym_identifier,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    STATE(1898), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2293), 1,
      sym_primitive_type,
    STATE(4794), 1,
      sym__type_specifier,
    STATE(6373), 1,
      sym__scope_resolution,
    STATE(7698), 1,
      sym_type_descriptor,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3883), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(1827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [100080] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(7126), 1,
      sym_identifier,
    ACTIONS(7128), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7132), 1,
      anon_sym_enum,
    ACTIONS(7134), 1,
      anon_sym_class,
    ACTIONS(7136), 1,
      anon_sym_struct,
    ACTIONS(7138), 1,
      anon_sym_union,
    ACTIONS(7140), 1,
      anon_sym_typename,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2825), 1,
      sym_qualified_type_identifier,
    STATE(4908), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4981), 1,
      sym__type_specifier,
    STATE(5150), 1,
      sym_primitive_type,
    STATE(5275), 1,
      sym__type_definition_type,
    STATE(6365), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3871), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7130), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [100181] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4922), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4940), 23,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(4942), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [100240] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5621), 1,
      sym_literal_suffix,
    ACTIONS(3769), 22,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3761), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [100299] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(7146), 1,
      sym_identifier,
    ACTIONS(7148), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7154), 1,
      anon_sym_enum,
    ACTIONS(7156), 1,
      anon_sym_class,
    ACTIONS(7158), 1,
      anon_sym_struct,
    ACTIONS(7160), 1,
      anon_sym_union,
    ACTIONS(7162), 1,
      sym_auto,
    ACTIONS(7164), 1,
      anon_sym_decltype,
    ACTIONS(7166), 1,
      anon_sym_typename,
    STATE(2825), 1,
      sym_qualified_type_identifier,
    STATE(4105), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4138), 1,
      sym__type_specifier,
    STATE(4456), 1,
      sym_primitive_type,
    STATE(4873), 1,
      sym_decltype_auto,
    STATE(5733), 1,
      sym_type_descriptor,
    STATE(6355), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(2618), 2,
      sym_decltype,
      sym_template_type,
    STATE(3887), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7152), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7150), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4876), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [100400] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(7146), 1,
      sym_identifier,
    ACTIONS(7148), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7154), 1,
      anon_sym_enum,
    ACTIONS(7156), 1,
      anon_sym_class,
    ACTIONS(7158), 1,
      anon_sym_struct,
    ACTIONS(7160), 1,
      anon_sym_union,
    ACTIONS(7162), 1,
      sym_auto,
    ACTIONS(7164), 1,
      anon_sym_decltype,
    ACTIONS(7166), 1,
      anon_sym_typename,
    STATE(2825), 1,
      sym_qualified_type_identifier,
    STATE(4105), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4153), 1,
      sym__type_specifier,
    STATE(4456), 1,
      sym_primitive_type,
    STATE(4873), 1,
      sym_decltype_auto,
    STATE(5733), 1,
      sym_type_descriptor,
    STATE(6355), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(2618), 2,
      sym_decltype,
      sym_template_type,
    STATE(3852), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7152), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7150), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4876), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [100501] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(6911), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6913), 1,
      anon_sym_AMP,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(6919), 1,
      anon_sym_LBRACK,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(7094), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7226), 1,
      anon_sym_DASH_GT,
    ACTIONS(7237), 1,
      anon_sym_requires,
    STATE(4882), 1,
      sym__function_attributes_start,
    STATE(4998), 1,
      sym_ref_qualifier,
    STATE(5827), 1,
      sym__function_attributes_end,
    STATE(5977), 1,
      sym_trailing_return_type,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6957), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4181), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4519), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5784), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5245), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6909), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
    ACTIONS(6915), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [100604] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1833), 1,
      anon_sym_enum,
    ACTIONS(1835), 1,
      anon_sym_class,
    ACTIONS(1837), 1,
      anon_sym_struct,
    ACTIONS(1839), 1,
      anon_sym_union,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(1869), 1,
      anon_sym_typename,
    ACTIONS(7111), 1,
      sym_identifier,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    STATE(1898), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2293), 1,
      sym_primitive_type,
    STATE(4794), 1,
      sym__type_specifier,
    STATE(6373), 1,
      sym__scope_resolution,
    STATE(7999), 1,
      sym_type_descriptor,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3883), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(1827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [100705] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1833), 1,
      anon_sym_enum,
    ACTIONS(1835), 1,
      anon_sym_class,
    ACTIONS(1837), 1,
      anon_sym_struct,
    ACTIONS(1839), 1,
      anon_sym_union,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(1869), 1,
      anon_sym_typename,
    ACTIONS(7111), 1,
      sym_identifier,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    STATE(1898), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2293), 1,
      sym_primitive_type,
    STATE(4794), 1,
      sym__type_specifier,
    STATE(6373), 1,
      sym__scope_resolution,
    STATE(8004), 1,
      sym_type_descriptor,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3883), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(1827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [100806] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1833), 1,
      anon_sym_enum,
    ACTIONS(1835), 1,
      anon_sym_class,
    ACTIONS(1837), 1,
      anon_sym_struct,
    ACTIONS(1839), 1,
      anon_sym_union,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(1869), 1,
      anon_sym_typename,
    ACTIONS(7111), 1,
      sym_identifier,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    STATE(1898), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2293), 1,
      sym_primitive_type,
    STATE(4794), 1,
      sym__type_specifier,
    STATE(6373), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(8368), 1,
      sym_type_descriptor,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3883), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(1827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [100907] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1833), 1,
      anon_sym_enum,
    ACTIONS(1835), 1,
      anon_sym_class,
    ACTIONS(1837), 1,
      anon_sym_struct,
    ACTIONS(1839), 1,
      anon_sym_union,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(1869), 1,
      anon_sym_typename,
    ACTIONS(7111), 1,
      sym_identifier,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    STATE(1898), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2293), 1,
      sym_primitive_type,
    STATE(4794), 1,
      sym__type_specifier,
    STATE(6373), 1,
      sym__scope_resolution,
    STATE(8025), 1,
      sym_type_descriptor,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3883), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(1827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [101008] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1833), 1,
      anon_sym_enum,
    ACTIONS(1835), 1,
      anon_sym_class,
    ACTIONS(1837), 1,
      anon_sym_struct,
    ACTIONS(1839), 1,
      anon_sym_union,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(1869), 1,
      anon_sym_typename,
    ACTIONS(7111), 1,
      sym_identifier,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    STATE(1898), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2293), 1,
      sym_primitive_type,
    STATE(4794), 1,
      sym__type_specifier,
    STATE(6373), 1,
      sym__scope_resolution,
    STATE(7672), 1,
      sym_type_descriptor,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3883), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(1827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [101109] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5101), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5103), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [101166] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1833), 1,
      anon_sym_enum,
    ACTIONS(1835), 1,
      anon_sym_class,
    ACTIONS(1837), 1,
      anon_sym_struct,
    ACTIONS(1839), 1,
      anon_sym_union,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(1869), 1,
      anon_sym_typename,
    ACTIONS(7111), 1,
      sym_identifier,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    STATE(1898), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2293), 1,
      sym_primitive_type,
    STATE(4906), 1,
      sym__type_specifier,
    STATE(6373), 1,
      sym__scope_resolution,
    STATE(7892), 1,
      sym_type_descriptor,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3807), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(1827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [101267] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_auto,
    ACTIONS(121), 1,
      anon_sym_decltype,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(7190), 1,
      sym_identifier,
    ACTIONS(7192), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7194), 1,
      anon_sym_enum,
    ACTIONS(7196), 1,
      anon_sym_class,
    ACTIONS(7198), 1,
      anon_sym_struct,
    ACTIONS(7200), 1,
      anon_sym_union,
    ACTIONS(7202), 1,
      anon_sym_typename,
    STATE(2687), 1,
      sym_decltype_auto,
    STATE(2825), 1,
      sym_qualified_type_identifier,
    STATE(2855), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3443), 1,
      sym_primitive_type,
    STATE(4151), 1,
      sym__type_specifier,
    STATE(5733), 1,
      sym_type_descriptor,
    STATE(6371), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(2618), 2,
      sym_decltype,
      sym_template_type,
    STATE(3851), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(3580), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2629), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [101368] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1833), 1,
      anon_sym_enum,
    ACTIONS(1835), 1,
      anon_sym_class,
    ACTIONS(1837), 1,
      anon_sym_struct,
    ACTIONS(1839), 1,
      anon_sym_union,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(1869), 1,
      anon_sym_typename,
    ACTIONS(7111), 1,
      sym_identifier,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    STATE(1898), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2293), 1,
      sym_primitive_type,
    STATE(4794), 1,
      sym__type_specifier,
    STATE(6373), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(8334), 1,
      sym_type_descriptor,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(3883), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(1827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [101469] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4816), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(4818), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [101526] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(5771), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(5773), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
  [101596] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7242), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(5477), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5479), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [101654] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6036), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6038), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [101710] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6004), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6006), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [101766] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(2589), 1,
      anon_sym_enum,
    ACTIONS(2591), 1,
      anon_sym_class,
    ACTIONS(2593), 1,
      anon_sym_struct,
    ACTIONS(2595), 1,
      anon_sym_union,
    ACTIONS(2621), 1,
      sym_auto,
    ACTIONS(2623), 1,
      anon_sym_decltype,
    ACTIONS(2625), 1,
      anon_sym_typename,
    ACTIONS(7233), 1,
      sym_identifier,
    ACTIONS(7235), 1,
      anon_sym_COLON_COLON,
    STATE(2164), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2612), 1,
      sym_primitive_type,
    STATE(2882), 1,
      sym_qualified_type_identifier,
    STATE(2933), 1,
      sym_decltype_auto,
    STATE(4780), 1,
      sym__type_specifier,
    STATE(6339), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(2868), 2,
      sym_decltype,
      sym_template_type,
    STATE(4628), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2587), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2585), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2935), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [101864] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6008), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6010), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [101920] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7242), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7244), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(5428), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5430), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [101980] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4808), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2743), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [102036] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4918), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(4920), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [102092] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6317), 1,
      anon_sym_LBRACE,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    STATE(2690), 1,
      sym_attribute_specifier,
    STATE(3919), 1,
      sym_enumerator_list,
    ACTIONS(5350), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(5352), 40,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_EQ,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [102156] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6012), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6014), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [102212] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7246), 1,
      anon_sym_LT,
    STATE(2030), 1,
      sym_template_argument_list,
    ACTIONS(4534), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(4541), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
  [102274] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1833), 1,
      anon_sym_enum,
    ACTIONS(1835), 1,
      anon_sym_class,
    ACTIONS(1837), 1,
      anon_sym_struct,
    ACTIONS(1839), 1,
      anon_sym_union,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(1869), 1,
      anon_sym_typename,
    ACTIONS(7111), 1,
      sym_identifier,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    STATE(1898), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2293), 1,
      sym_primitive_type,
    STATE(4930), 1,
      sym__type_specifier,
    STATE(6373), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(4628), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(1827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [102372] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4829), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(4831), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [102428] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6000), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6002), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [102484] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_auto,
    ACTIONS(121), 1,
      anon_sym_decltype,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(7190), 1,
      sym_identifier,
    ACTIONS(7192), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7194), 1,
      anon_sym_enum,
    ACTIONS(7196), 1,
      anon_sym_class,
    ACTIONS(7198), 1,
      anon_sym_struct,
    ACTIONS(7200), 1,
      anon_sym_union,
    ACTIONS(7202), 1,
      anon_sym_typename,
    STATE(2687), 1,
      sym_decltype_auto,
    STATE(2825), 1,
      sym_qualified_type_identifier,
    STATE(2855), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3443), 1,
      sym_primitive_type,
    STATE(4222), 1,
      sym__type_specifier,
    STATE(6371), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(2618), 2,
      sym_decltype,
      sym_template_type,
    STATE(4628), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(3580), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2629), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [102582] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5988), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5990), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [102638] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3194), 1,
      anon_sym_LBRACE,
    ACTIONS(7124), 1,
      anon_sym_LBRACK,
    ACTIONS(7249), 1,
      anon_sym_LPAREN2,
    ACTIONS(7251), 1,
      sym_auto,
    ACTIONS(7253), 1,
      anon_sym_decltype,
    STATE(3981), 1,
      sym_new_declarator,
    STATE(4088), 1,
      sym_decltype_auto,
    STATE(3934), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5208), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5210), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [102710] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5970), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5972), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [102766] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5958), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5960), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [102822] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5954), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5956), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [102878] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4601), 1,
      anon_sym_SEMI,
    ACTIONS(6103), 1,
      anon_sym_LT,
    ACTIONS(6532), 1,
      anon_sym_LBRACK,
    STATE(2716), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3993), 1,
      sym_template_argument_list,
    ACTIONS(3782), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3767), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(3787), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3759), 33,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [102950] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5950), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5952), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [103006] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4810), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(4812), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [103062] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3194), 1,
      anon_sym_LBRACE,
    ACTIONS(7124), 1,
      anon_sym_LBRACK,
    ACTIONS(7249), 1,
      anon_sym_LPAREN2,
    ACTIONS(7251), 1,
      sym_auto,
    ACTIONS(7253), 1,
      anon_sym_decltype,
    STATE(3968), 1,
      sym_new_declarator,
    STATE(4088), 1,
      sym_decltype_auto,
    STATE(3922), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5230), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5232), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [103134] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6020), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6022), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [103190] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(2589), 1,
      anon_sym_enum,
    ACTIONS(2591), 1,
      anon_sym_class,
    ACTIONS(2593), 1,
      anon_sym_struct,
    ACTIONS(2595), 1,
      anon_sym_union,
    ACTIONS(2621), 1,
      sym_auto,
    ACTIONS(2623), 1,
      anon_sym_decltype,
    ACTIONS(2625), 1,
      anon_sym_typename,
    ACTIONS(7233), 1,
      sym_identifier,
    ACTIONS(7235), 1,
      anon_sym_COLON_COLON,
    STATE(2164), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2612), 1,
      sym_primitive_type,
    STATE(2882), 1,
      sym_qualified_type_identifier,
    STATE(2933), 1,
      sym_decltype_auto,
    STATE(4563), 1,
      sym__type_specifier,
    STATE(6339), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(2868), 2,
      sym_decltype,
      sym_template_type,
    STATE(4628), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2587), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2585), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2935), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [103288] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5873), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5875), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [103344] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5942), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5944), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [103400] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4833), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(4835), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [103456] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4707), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4709), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [103512] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6911), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6913), 1,
      anon_sym_AMP,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(6919), 1,
      anon_sym_LBRACK,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(7255), 1,
      anon_sym_DASH_GT,
    ACTIONS(7257), 1,
      anon_sym_requires,
    STATE(4931), 1,
      sym__function_attributes_start,
    STATE(5103), 1,
      sym_ref_qualifier,
    STATE(5943), 1,
      sym__function_attributes_end,
    STATE(6205), 1,
      sym_trailing_return_type,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6925), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4181), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4519), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5973), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5267), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6909), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
    ACTIONS(6915), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [103614] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5930), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5932), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [103670] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4810), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(4812), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [103726] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4833), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(4835), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [103782] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6911), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6913), 1,
      anon_sym_AMP,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(6919), 1,
      anon_sym_LBRACK,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(7255), 1,
      anon_sym_DASH_GT,
    ACTIONS(7260), 1,
      anon_sym_requires,
    STATE(4935), 1,
      sym__function_attributes_start,
    STATE(5067), 1,
      sym_ref_qualifier,
    STATE(5933), 1,
      sym__function_attributes_end,
    STATE(6165), 1,
      sym_trailing_return_type,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4181), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4519), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5973), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5272), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6909), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
    ACTIONS(6915), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [103884] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5920), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5922), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [103940] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5916), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5918), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [103996] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5821), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5823), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [104052] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5904), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5906), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [104108] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_auto,
    ACTIONS(121), 1,
      anon_sym_decltype,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(3572), 1,
      sym_identifier,
    ACTIONS(3578), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3582), 1,
      anon_sym_enum,
    ACTIONS(3584), 1,
      anon_sym_class,
    ACTIONS(3586), 1,
      anon_sym_struct,
    ACTIONS(3588), 1,
      anon_sym_union,
    ACTIONS(3590), 1,
      anon_sym_typename,
    STATE(2687), 1,
      sym_decltype_auto,
    STATE(2825), 1,
      sym_qualified_type_identifier,
    STATE(2855), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3443), 1,
      sym_primitive_type,
    STATE(4265), 1,
      sym__type_specifier,
    STATE(6333), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(2618), 2,
      sym_decltype,
      sym_template_type,
    STATE(4628), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(3580), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2629), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [104206] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5877), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5879), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [104262] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3194), 1,
      anon_sym_LBRACE,
    ACTIONS(7124), 1,
      anon_sym_LBRACK,
    ACTIONS(7249), 1,
      anon_sym_LPAREN2,
    ACTIONS(7251), 1,
      sym_auto,
    ACTIONS(7253), 1,
      anon_sym_decltype,
    STATE(3972), 1,
      sym_new_declarator,
    STATE(4088), 1,
      sym_decltype_auto,
    STATE(3952), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5226), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5228), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [104334] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5714), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5716), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [104390] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6317), 1,
      anon_sym_LBRACE,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    STATE(2670), 1,
      sym_attribute_specifier,
    STATE(3911), 1,
      sym_enumerator_list,
    ACTIONS(5293), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(5295), 40,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_EQ,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [104454] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4695), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4697), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [104510] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5992), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5994), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [104566] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(7146), 1,
      sym_identifier,
    ACTIONS(7148), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7154), 1,
      anon_sym_enum,
    ACTIONS(7156), 1,
      anon_sym_class,
    ACTIONS(7158), 1,
      anon_sym_struct,
    ACTIONS(7160), 1,
      anon_sym_union,
    ACTIONS(7162), 1,
      sym_auto,
    ACTIONS(7164), 1,
      anon_sym_decltype,
    ACTIONS(7166), 1,
      anon_sym_typename,
    STATE(2825), 1,
      sym_qualified_type_identifier,
    STATE(4105), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4218), 1,
      sym__type_specifier,
    STATE(4456), 1,
      sym_primitive_type,
    STATE(4873), 1,
      sym_decltype_auto,
    STATE(6355), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(2618), 2,
      sym_decltype,
      sym_template_type,
    STATE(4628), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7152), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7150), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4876), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [104664] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3568), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3564), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [104720] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(7168), 1,
      sym_identifier,
    ACTIONS(7170), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7176), 1,
      anon_sym_enum,
    ACTIONS(7178), 1,
      anon_sym_class,
    ACTIONS(7180), 1,
      anon_sym_struct,
    ACTIONS(7182), 1,
      anon_sym_union,
    ACTIONS(7184), 1,
      sym_auto,
    ACTIONS(7186), 1,
      anon_sym_decltype,
    ACTIONS(7188), 1,
      anon_sym_typename,
    STATE(4159), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4182), 1,
      sym__type_specifier,
    STATE(4768), 1,
      sym_primitive_type,
    STATE(5028), 1,
      sym_decltype_auto,
    STATE(5057), 1,
      sym_qualified_type_identifier,
    STATE(6342), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(4628), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4951), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(7174), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7172), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5027), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [104818] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4715), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4717), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [104874] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4816), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(4818), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [104930] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4711), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4713), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [104986] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5946), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5948), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [105042] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6981), 1,
      anon_sym_LT,
    STATE(2030), 1,
      sym_template_argument_list,
    ACTIONS(5187), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(3785), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
  [105104] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4727), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4729), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [105160] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_auto,
    ACTIONS(121), 1,
      anon_sym_decltype,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(7190), 1,
      sym_identifier,
    ACTIONS(7192), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7194), 1,
      anon_sym_enum,
    ACTIONS(7196), 1,
      anon_sym_class,
    ACTIONS(7198), 1,
      anon_sym_struct,
    ACTIONS(7200), 1,
      anon_sym_union,
    ACTIONS(7202), 1,
      anon_sym_typename,
    STATE(2687), 1,
      sym_decltype_auto,
    STATE(2825), 1,
      sym_qualified_type_identifier,
    STATE(2855), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3443), 1,
      sym_primitive_type,
    STATE(4147), 1,
      sym__type_specifier,
    STATE(6371), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(2618), 2,
      sym_decltype,
      sym_template_type,
    STATE(4628), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(3580), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2629), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [105258] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(7146), 1,
      sym_identifier,
    ACTIONS(7148), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7154), 1,
      anon_sym_enum,
    ACTIONS(7156), 1,
      anon_sym_class,
    ACTIONS(7158), 1,
      anon_sym_struct,
    ACTIONS(7160), 1,
      anon_sym_union,
    ACTIONS(7162), 1,
      sym_auto,
    ACTIONS(7164), 1,
      anon_sym_decltype,
    ACTIONS(7166), 1,
      anon_sym_typename,
    STATE(2825), 1,
      sym_qualified_type_identifier,
    STATE(4105), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4141), 1,
      sym__type_specifier,
    STATE(4456), 1,
      sym_primitive_type,
    STATE(4873), 1,
      sym_decltype_auto,
    STATE(6355), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(2618), 2,
      sym_decltype,
      sym_template_type,
    STATE(4628), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7152), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7150), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4876), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [105356] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4691), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4693), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [105412] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4691), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4693), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [105468] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4691), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4693), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [105524] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6032), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6034), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [105580] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5841), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5843), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [105636] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5853), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5855), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [105692] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5881), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5883), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [105748] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(5767), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(5769), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
  [105818] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5904), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5906), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [105874] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4816), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(4818), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [105930] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4719), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4721), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [105986] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4723), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4725), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [106042] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1961), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1959), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [106098] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5908), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5910), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [106154] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(7162), 1,
      sym_auto,
    ACTIONS(7164), 1,
      anon_sym_decltype,
    ACTIONS(7204), 1,
      sym_identifier,
    ACTIONS(7206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7208), 1,
      anon_sym_enum,
    ACTIONS(7210), 1,
      anon_sym_class,
    ACTIONS(7212), 1,
      anon_sym_struct,
    ACTIONS(7214), 1,
      anon_sym_union,
    ACTIONS(7216), 1,
      anon_sym_typename,
    STATE(2825), 1,
      sym_qualified_type_identifier,
    STATE(4105), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4456), 1,
      sym_primitive_type,
    STATE(4678), 1,
      sym__type_specifier,
    STATE(4873), 1,
      sym_decltype_auto,
    STATE(6336), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(2618), 2,
      sym_decltype,
      sym_template_type,
    STATE(4628), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7152), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7150), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4876), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [106252] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(5775), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(5777), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
  [106322] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4808), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2743), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [106378] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5934), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5936), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [106434] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(7126), 1,
      sym_identifier,
    ACTIONS(7128), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7132), 1,
      anon_sym_enum,
    ACTIONS(7134), 1,
      anon_sym_class,
    ACTIONS(7136), 1,
      anon_sym_struct,
    ACTIONS(7138), 1,
      anon_sym_union,
    ACTIONS(7140), 1,
      anon_sym_typename,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2825), 1,
      sym_qualified_type_identifier,
    STATE(4908), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4965), 1,
      sym__type_specifier,
    STATE(5150), 1,
      sym_primitive_type,
    STATE(6365), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(4628), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7130), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [106532] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4739), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4741), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [106588] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1833), 1,
      anon_sym_enum,
    ACTIONS(1835), 1,
      anon_sym_class,
    ACTIONS(1837), 1,
      anon_sym_struct,
    ACTIONS(1839), 1,
      anon_sym_union,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(1869), 1,
      anon_sym_typename,
    ACTIONS(7111), 1,
      sym_identifier,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    STATE(1898), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2293), 1,
      sym_primitive_type,
    STATE(4417), 1,
      sym__type_specifier,
    STATE(6373), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(4628), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(1827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [106686] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5863), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5865), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [106742] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5867), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5869), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [106798] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5978), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5980), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [106854] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4703), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4705), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [106910] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5888), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5890), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [106966] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5892), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5894), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [107022] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4699), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4701), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [107078] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5896), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5898), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [107134] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1957), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1955), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [107190] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1833), 1,
      anon_sym_enum,
    ACTIONS(1835), 1,
      anon_sym_class,
    ACTIONS(1837), 1,
      anon_sym_struct,
    ACTIONS(1839), 1,
      anon_sym_union,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(1869), 1,
      anon_sym_typename,
    ACTIONS(7111), 1,
      sym_identifier,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    STATE(1898), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2293), 1,
      sym_primitive_type,
    STATE(4804), 1,
      sym__type_specifier,
    STATE(6373), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(4628), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(1827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [107288] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1833), 1,
      anon_sym_enum,
    ACTIONS(1835), 1,
      anon_sym_class,
    ACTIONS(1837), 1,
      anon_sym_struct,
    ACTIONS(1839), 1,
      anon_sym_union,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(1869), 1,
      anon_sym_typename,
    ACTIONS(7111), 1,
      sym_identifier,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    STATE(1898), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2293), 1,
      sym_primitive_type,
    STATE(4753), 1,
      sym__type_specifier,
    STATE(6373), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    STATE(4628), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(1827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [107386] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(5724), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(5726), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
  [107456] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5950), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5952), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [107512] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(7146), 1,
      sym_identifier,
    ACTIONS(7148), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7154), 1,
      anon_sym_enum,
    ACTIONS(7156), 1,
      anon_sym_class,
    ACTIONS(7158), 1,
      anon_sym_struct,
    ACTIONS(7160), 1,
      anon_sym_union,
    ACTIONS(7162), 1,
      sym_auto,
    ACTIONS(7164), 1,
      anon_sym_decltype,
    ACTIONS(7166), 1,
      anon_sym_typename,
    STATE(2825), 1,
      sym_qualified_type_identifier,
    STATE(4105), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4143), 1,
      sym__type_specifier,
    STATE(4456), 1,
      sym_primitive_type,
    STATE(4873), 1,
      sym_decltype_auto,
    STATE(6355), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(2618), 2,
      sym_decltype,
      sym_template_type,
    STATE(4628), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7152), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7150), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4876), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [107610] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4829), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(4831), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [107666] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5833), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5835), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [107722] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5962), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5964), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [107778] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3194), 1,
      anon_sym_LBRACE,
    ACTIONS(7124), 1,
      anon_sym_LBRACK,
    ACTIONS(7249), 1,
      anon_sym_LPAREN2,
    ACTIONS(7251), 1,
      sym_auto,
    ACTIONS(7253), 1,
      anon_sym_decltype,
    STATE(3961), 1,
      sym_new_declarator,
    STATE(4088), 1,
      sym_decltype_auto,
    STATE(3902), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5234), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5236), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [107850] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5896), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5898), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [107906] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4731), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4733), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [107962] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4735), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4737), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [108018] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5813), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(5815), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [108086] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5982), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5984), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [108142] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5698), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(5700), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [108210] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5946), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5948), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [108265] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6953), 1,
      anon_sym_const,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7264), 1,
      anon_sym_STAR,
    ACTIONS(7266), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7268), 1,
      anon_sym_AMP,
    ACTIONS(7270), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    STATE(3638), 1,
      sym_parameter_list,
    STATE(3909), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(5897), 1,
      sym__abstract_declarator,
    ACTIONS(7272), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7274), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3953), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4241), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5513), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(6945), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [108352] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    STATE(2654), 1,
      sym_attribute_specifier,
    ACTIONS(5499), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(5501), 41,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [108411] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7270), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    ACTIONS(7278), 1,
      anon_sym_STAR,
    ACTIONS(7280), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7282), 1,
      anon_sym_AMP,
    STATE(3617), 1,
      sym_parameter_list,
    STATE(3909), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(5904), 1,
      sym__abstract_declarator,
    ACTIONS(7272), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7274), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3958), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4332), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5513), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6915), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [108498] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5841), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5843), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [108553] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4816), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(4818), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [108608] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6004), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6006), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [108663] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5982), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5984), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [108718] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5916), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5918), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [108773] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5954), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5956), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [108828] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4833), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(4835), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [108883] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7286), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT2,
    ACTIONS(7284), 36,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___based,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [108938] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4810), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(4812), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [108993] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    STATE(2697), 1,
      sym_attribute_specifier,
    ACTIONS(5414), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(5416), 41,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [109052] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5892), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5894), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [109107] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6000), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6002), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [109162] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6008), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6010), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [109217] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5888), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5890), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [109272] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6903), 1,
      anon_sym___attribute__,
    ACTIONS(7218), 1,
      anon_sym_LBRACE,
    STATE(3974), 1,
      sym_enumerator_list,
    STATE(4080), 1,
      sym_attribute_specifier,
    ACTIONS(5293), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5295), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [109335] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4579), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4582), 5,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
    ACTIONS(4575), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [109394] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    STATE(2637), 1,
      sym_attribute_specifier,
    ACTIONS(5481), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(5483), 41,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [109453] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    STATE(2640), 1,
      sym_attribute_specifier,
    ACTIONS(5485), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(5487), 41,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [109512] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6012), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6014), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [109567] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    STATE(2663), 1,
      sym_attribute_specifier,
    ACTIONS(5489), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(5491), 41,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [109626] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5978), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5980), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [109681] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5958), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5960), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [109736] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    STATE(2682), 1,
      sym_attribute_specifier,
    ACTIONS(5493), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(5495), 41,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [109795] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5853), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5855), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [109850] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5821), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5823), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [109905] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5920), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5922), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [109960] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5988), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5990), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [110015] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6020), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6022), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [110070] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7290), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT2,
    ACTIONS(7288), 36,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___based,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [110125] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5908), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5910), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [110180] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6953), 1,
      anon_sym_const,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7270), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    ACTIONS(7292), 1,
      anon_sym_STAR,
    ACTIONS(7294), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7296), 1,
      anon_sym_AMP,
    STATE(3360), 1,
      sym_parameter_list,
    STATE(3909), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(5861), 1,
      sym__abstract_declarator,
    ACTIONS(7272), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7274), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3937), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4331), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5513), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6945), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [110267] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5934), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5936), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [110322] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5962), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5964), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [110377] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    STATE(2703), 1,
      sym_attribute_specifier,
    ACTIONS(5473), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(5475), 41,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [110436] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    STATE(2676), 1,
      sym_attribute_specifier,
    ACTIONS(5456), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(5458), 41,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [110495] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6953), 1,
      anon_sym_const,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7270), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    ACTIONS(7292), 1,
      anon_sym_STAR,
    ACTIONS(7294), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7296), 1,
      anon_sym_AMP,
    STATE(3360), 1,
      sym_parameter_list,
    STATE(3909), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(5866), 1,
      sym__abstract_declarator,
    ACTIONS(7272), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7274), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3616), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4284), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5555), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6945), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [110582] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6903), 1,
      anon_sym___attribute__,
    ACTIONS(7218), 1,
      anon_sym_LBRACE,
    STATE(3978), 1,
      sym_enumerator_list,
    STATE(4093), 1,
      sym_attribute_specifier,
    ACTIONS(5350), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5352), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [110645] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4829), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(4831), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [110700] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6036), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6038), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [110755] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5942), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5944), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [110810] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5992), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5994), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [110865] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5970), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5972), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [110920] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    STATE(1741), 1,
      sym_template_argument_list,
    STATE(2537), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4615), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5303), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5305), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [110983] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4922), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4942), 1,
      anon_sym_SEMI,
    ACTIONS(4926), 5,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4924), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [111042] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    STATE(2667), 1,
      sym_attribute_specifier,
    ACTIONS(5452), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(5454), 41,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [111101] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3568), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(3564), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [111156] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4942), 1,
      anon_sym_SEMI,
    ACTIONS(4926), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4924), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [111213] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5930), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5932), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [111268] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5877), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5879), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [111323] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    STATE(2684), 1,
      sym_attribute_specifier,
    ACTIONS(5363), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(5365), 41,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [111382] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5863), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5865), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [111437] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6953), 1,
      anon_sym_const,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7264), 1,
      anon_sym_STAR,
    ACTIONS(7266), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7268), 1,
      anon_sym_AMP,
    ACTIONS(7270), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    STATE(3638), 1,
      sym_parameter_list,
    STATE(3909), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(5905), 1,
      sym__abstract_declarator,
    ACTIONS(7272), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7274), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3616), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4237), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5555), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(6945), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [111524] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5867), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5869), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [111579] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5573), 1,
      anon_sym___attribute__,
    ACTIONS(5728), 1,
      anon_sym_LBRACE,
    ACTIONS(7298), 1,
      anon_sym_COLON,
    STATE(1941), 1,
      sym_attribute_specifier,
    STATE(2476), 1,
      sym__enum_base_clause,
    STATE(2531), 1,
      sym_enumerator_list,
    ACTIONS(5689), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(5691), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
  [111646] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    STATE(2656), 1,
      sym_attribute_specifier,
    ACTIONS(5400), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(5402), 41,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [111705] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    STATE(2623), 1,
      sym_attribute_specifier,
    ACTIONS(5386), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(5388), 41,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [111764] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7270), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    ACTIONS(7278), 1,
      anon_sym_STAR,
    ACTIONS(7280), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7282), 1,
      anon_sym_AMP,
    STATE(3617), 1,
      sym_parameter_list,
    STATE(3909), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(5892), 1,
      sym__abstract_declarator,
    ACTIONS(7272), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7274), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3616), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4246), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5555), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6915), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [111851] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5573), 1,
      anon_sym___attribute__,
    ACTIONS(5728), 1,
      anon_sym_LBRACE,
    ACTIONS(7298), 1,
      anon_sym_COLON,
    STATE(1956), 1,
      sym_attribute_specifier,
    STATE(2442), 1,
      sym__enum_base_clause,
    STATE(2510), 1,
      sym_enumerator_list,
    ACTIONS(5629), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(5631), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
  [111918] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6903), 1,
      anon_sym___attribute__,
    STATE(4067), 1,
      sym_attribute_specifier,
    ACTIONS(5493), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5495), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [111976] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3194), 1,
      anon_sym_LBRACE,
    ACTIONS(7249), 1,
      anon_sym_LPAREN2,
    STATE(3941), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5565), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5567), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [112036] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6903), 1,
      anon_sym___attribute__,
    STATE(4038), 1,
      sym_attribute_specifier,
    ACTIONS(5481), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5483), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [112094] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6103), 1,
      anon_sym_LT,
    ACTIONS(7300), 1,
      anon_sym_LBRACK,
    STATE(2716), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4271), 1,
      sym_template_argument_list,
    ACTIONS(3782), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3767), 3,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
    ACTIONS(3787), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3759), 32,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_operator,
  [112162] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6911), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6913), 1,
      anon_sym_AMP,
    ACTIONS(6919), 1,
      anon_sym_LBRACK,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(6950), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6953), 1,
      anon_sym_const,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(7302), 1,
      anon_sym_DASH_GT,
    ACTIONS(7304), 1,
      anon_sym_requires,
    STATE(5013), 1,
      sym__function_attributes_start,
    STATE(5213), 1,
      sym_ref_qualifier,
    STATE(6077), 1,
      sym__function_attributes_end,
    STATE(6249), 1,
      sym_trailing_return_type,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(6909), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6957), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4307), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4741), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5784), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5390), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6945), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [112262] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3194), 1,
      anon_sym_LBRACE,
    ACTIONS(7124), 1,
      anon_sym_LBRACK,
    ACTIONS(7307), 1,
      anon_sym_LPAREN2,
    ACTIONS(7309), 1,
      sym_auto,
    ACTIONS(7311), 1,
      anon_sym_decltype,
    STATE(1988), 1,
      sym_decltype_auto,
    STATE(4142), 1,
      sym_new_declarator,
    STATE(3902), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5234), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(5236), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [112332] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_const,
    ACTIONS(2919), 1,
      sym_ms_restrict_modifier,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(7313), 1,
      anon_sym_STAR,
    ACTIONS(7315), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7317), 1,
      anon_sym_AMP,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    STATE(3325), 1,
      sym_parameter_list,
    STATE(4186), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5955), 1,
      sym__abstract_declarator,
    STATE(6035), 1,
      sym__function_declarator_seq,
    ACTIONS(7321), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7323), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3987), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4375), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5513), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7319), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [112418] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7327), 1,
      anon_sym_LT,
    STATE(2537), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2724), 1,
      sym_template_argument_list,
    ACTIONS(4615), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3759), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3767), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [112482] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3194), 1,
      anon_sym_LBRACE,
    ACTIONS(7249), 1,
      anon_sym_LPAREN2,
    STATE(3954), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5561), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5563), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [112542] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6903), 1,
      anon_sym___attribute__,
    STATE(4050), 1,
      sym_attribute_specifier,
    ACTIONS(5473), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5475), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [112600] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6911), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6913), 1,
      anon_sym_AMP,
    ACTIONS(6919), 1,
      anon_sym_LBRACK,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(6950), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6953), 1,
      anon_sym_const,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(7302), 1,
      anon_sym_DASH_GT,
    ACTIONS(7329), 1,
      anon_sym_requires,
    STATE(5024), 1,
      sym__function_attributes_start,
    STATE(5205), 1,
      sym_ref_qualifier,
    STATE(6062), 1,
      sym__function_attributes_end,
    STATE(6248), 1,
      sym_trailing_return_type,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6909), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(4307), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4741), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5784), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5345), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6945), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [112700] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6903), 1,
      anon_sym___attribute__,
    STATE(4103), 1,
      sym_attribute_specifier,
    ACTIONS(5363), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5365), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [112758] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3194), 1,
      anon_sym_LBRACE,
    ACTIONS(7249), 1,
      anon_sym_LPAREN2,
    STATE(3949), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5625), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5627), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [112818] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3194), 1,
      anon_sym_LBRACE,
    ACTIONS(7124), 1,
      anon_sym_LBRACK,
    ACTIONS(7307), 1,
      anon_sym_LPAREN2,
    ACTIONS(7309), 1,
      sym_auto,
    ACTIONS(7311), 1,
      anon_sym_decltype,
    STATE(1988), 1,
      sym_decltype_auto,
    STATE(4155), 1,
      sym_new_declarator,
    STATE(3952), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5226), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(5228), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [112888] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6903), 1,
      anon_sym___attribute__,
    STATE(4087), 1,
      sym_attribute_specifier,
    ACTIONS(5414), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5416), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [112946] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6903), 1,
      anon_sym___attribute__,
    STATE(4097), 1,
      sym_attribute_specifier,
    ACTIONS(5456), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5458), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [113004] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6903), 1,
      anon_sym___attribute__,
    STATE(4082), 1,
      sym_attribute_specifier,
    ACTIONS(5499), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5501), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [113062] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6903), 1,
      anon_sym___attribute__,
    STATE(4079), 1,
      sym_attribute_specifier,
    ACTIONS(5452), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5454), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [113120] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6903), 1,
      anon_sym___attribute__,
    STATE(4049), 1,
      sym_attribute_specifier,
    ACTIONS(5485), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5487), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [113178] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6903), 1,
      anon_sym___attribute__,
    STATE(4089), 1,
      sym_attribute_specifier,
    ACTIONS(5400), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5402), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [113236] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6911), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6913), 1,
      anon_sym_AMP,
    ACTIONS(6919), 1,
      anon_sym_LBRACK,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(6953), 1,
      anon_sym_const,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(7230), 1,
      anon_sym_requires,
    ACTIONS(7331), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7333), 1,
      anon_sym_DASH_GT,
    STATE(4999), 1,
      sym__function_attributes_start,
    STATE(5204), 1,
      sym_ref_qualifier,
    STATE(5958), 1,
      sym_trailing_return_type,
    STATE(6208), 1,
      sym__function_attributes_end,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(6909), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6925), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4307), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4741), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5973), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5358), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6945), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [113336] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3194), 1,
      anon_sym_LBRACE,
    ACTIONS(7249), 1,
      anon_sym_LPAREN2,
    STATE(3925), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5609), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5611), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [113396] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6911), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6913), 1,
      anon_sym_AMP,
    ACTIONS(6919), 1,
      anon_sym_LBRACK,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(6953), 1,
      anon_sym_const,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(7144), 1,
      anon_sym_requires,
    ACTIONS(7331), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7333), 1,
      anon_sym_DASH_GT,
    STATE(5022), 1,
      sym__function_attributes_start,
    STATE(5206), 1,
      sym_ref_qualifier,
    STATE(5912), 1,
      sym_trailing_return_type,
    STATE(6191), 1,
      sym__function_attributes_end,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(6909), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4307), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4741), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5973), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5380), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6945), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [113496] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3194), 1,
      anon_sym_LBRACE,
    ACTIONS(7124), 1,
      anon_sym_LBRACK,
    ACTIONS(7307), 1,
      anon_sym_LPAREN2,
    ACTIONS(7309), 1,
      sym_auto,
    ACTIONS(7311), 1,
      anon_sym_decltype,
    STATE(1988), 1,
      sym_decltype_auto,
    STATE(4152), 1,
      sym_new_declarator,
    STATE(3934), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5208), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(5210), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [113566] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6903), 1,
      anon_sym___attribute__,
    STATE(4084), 1,
      sym_attribute_specifier,
    ACTIONS(5489), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5491), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [113624] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4545), 1,
      anon_sym_LBRACK,
    ACTIONS(6907), 1,
      anon_sym_LT,
    STATE(3993), 1,
      sym_template_argument_list,
    ACTIONS(4538), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4541), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_EQ,
    ACTIONS(4534), 33,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [113688] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6903), 1,
      anon_sym___attribute__,
    STATE(4090), 1,
      sym_attribute_specifier,
    ACTIONS(5386), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5388), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [113746] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_const,
    ACTIONS(2919), 1,
      sym_ms_restrict_modifier,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(7313), 1,
      anon_sym_STAR,
    ACTIONS(7315), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7317), 1,
      anon_sym_AMP,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    STATE(3325), 1,
      sym_parameter_list,
    STATE(4186), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5939), 1,
      sym__abstract_declarator,
    STATE(6035), 1,
      sym__function_declarator_seq,
    ACTIONS(7321), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7323), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4100), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4398), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5555), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7319), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [113832] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3194), 1,
      anon_sym_LBRACE,
    ACTIONS(7124), 1,
      anon_sym_LBRACK,
    ACTIONS(7307), 1,
      anon_sym_LPAREN2,
    ACTIONS(7309), 1,
      sym_auto,
    ACTIONS(7311), 1,
      anon_sym_decltype,
    STATE(1988), 1,
      sym_decltype_auto,
    STATE(4144), 1,
      sym_new_declarator,
    STATE(3922), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5230), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(5232), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [113902] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5030), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5032), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [113955] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7335), 1,
      sym_identifier,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7339), 1,
      anon_sym_STAR,
    ACTIONS(7341), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7343), 1,
      anon_sym_AMP,
    STATE(3003), 1,
      sym__type_declarator,
    STATE(3379), 1,
      sym_pointer_type_declarator,
    STATE(3909), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7618), 1,
      sym_ms_based_modifier,
    ACTIONS(7345), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3616), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7270), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7349), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7347), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3385), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [114040] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7351), 1,
      sym_identifier,
    ACTIONS(7353), 1,
      anon_sym_LPAREN2,
    ACTIONS(7355), 1,
      anon_sym_STAR,
    ACTIONS(7357), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7359), 1,
      anon_sym_AMP,
    STATE(2372), 1,
      sym_pointer_type_declarator,
    STATE(3909), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6474), 1,
      sym__type_declarator,
    STATE(7983), 1,
      sym_ms_based_modifier,
    ACTIONS(7345), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4015), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4507), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7270), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7363), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2340), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [114125] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6953), 1,
      anon_sym_const,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7270), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    ACTIONS(7365), 1,
      anon_sym_STAR,
    ACTIONS(7367), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7369), 1,
      anon_sym_AMP,
    STATE(3569), 1,
      sym_parameter_list,
    STATE(3909), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(6090), 1,
      sym__abstract_declarator,
    ACTIONS(7272), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7274), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4014), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4518), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5513), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6945), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [114210] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4577), 1,
      anon_sym_SEMI,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4579), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4582), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
    ACTIONS(4575), 33,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [114269] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7351), 1,
      sym_identifier,
    ACTIONS(7353), 1,
      anon_sym_LPAREN2,
    ACTIONS(7371), 1,
      anon_sym_STAR,
    ACTIONS(7373), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    STATE(2372), 1,
      sym_pointer_type_declarator,
    STATE(3909), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6160), 1,
      sym__type_declarator,
    STATE(7781), 1,
      sym_ms_based_modifier,
    ACTIONS(7345), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4024), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4533), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7270), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2340), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [114354] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7377), 1,
      sym_identifier,
    ACTIONS(7379), 1,
      anon_sym_LPAREN2,
    ACTIONS(7381), 1,
      anon_sym_STAR,
    ACTIONS(7383), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7385), 1,
      anon_sym_AMP,
    STATE(3909), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5847), 1,
      sym__type_declarator,
    STATE(6116), 1,
      sym_pointer_type_declarator,
    STATE(8041), 1,
      sym_ms_based_modifier,
    ACTIONS(7345), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4025), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4528), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7270), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7387), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6111), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [114439] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7389), 1,
      anon_sym_LT,
    STATE(2724), 1,
      sym_template_argument_list,
    ACTIONS(4534), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(4541), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [114498] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7351), 1,
      sym_identifier,
    ACTIONS(7353), 1,
      anon_sym_LPAREN2,
    ACTIONS(7392), 1,
      anon_sym_STAR,
    ACTIONS(7394), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7396), 1,
      anon_sym_AMP,
    STATE(2267), 1,
      sym__type_declarator,
    STATE(2372), 1,
      sym_pointer_type_declarator,
    STATE(3909), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8058), 1,
      sym_ms_based_modifier,
    ACTIONS(7345), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3616), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4514), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7270), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7363), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2340), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [114583] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6317), 1,
      anon_sym_LBRACE,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7398), 1,
      anon_sym_COLON,
    STATE(2633), 1,
      sym_attribute_specifier,
    STATE(3839), 1,
      sym__enum_base_clause,
    STATE(3946), 1,
      sym_enumerator_list,
    ACTIONS(5689), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(5691), 35,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_try,
      anon_sym_requires,
  [114648] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7351), 1,
      sym_identifier,
    ACTIONS(7353), 1,
      anon_sym_LPAREN2,
    ACTIONS(7392), 1,
      anon_sym_STAR,
    ACTIONS(7394), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7396), 1,
      anon_sym_AMP,
    STATE(2289), 1,
      sym__type_declarator,
    STATE(2372), 1,
      sym_pointer_type_declarator,
    STATE(3909), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8058), 1,
      sym_ms_based_modifier,
    ACTIONS(7345), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4009), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4517), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7270), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7363), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2340), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [114733] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7377), 1,
      sym_identifier,
    ACTIONS(7379), 1,
      anon_sym_LPAREN2,
    ACTIONS(7400), 1,
      anon_sym_STAR,
    ACTIONS(7402), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7404), 1,
      anon_sym_AMP,
    STATE(3909), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6086), 1,
      sym__type_declarator,
    STATE(6116), 1,
      sym_pointer_type_declarator,
    STATE(7809), 1,
      sym_ms_based_modifier,
    ACTIONS(7345), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3616), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4597), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7152), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7270), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7387), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6111), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [114818] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7351), 1,
      sym_identifier,
    ACTIONS(7353), 1,
      anon_sym_LPAREN2,
    ACTIONS(7371), 1,
      anon_sym_STAR,
    ACTIONS(7373), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    STATE(2372), 1,
      sym_pointer_type_declarator,
    STATE(3909), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6159), 1,
      sym__type_declarator,
    STATE(7781), 1,
      sym_ms_based_modifier,
    ACTIONS(7345), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3616), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4636), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7270), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2340), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [114903] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4910), 1,
      anon_sym_COLON,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    STATE(2665), 1,
      sym_attribute_specifier,
    STATE(3111), 1,
      sym_field_declaration_list,
    STATE(6691), 1,
      sym_virtual_specifier,
    STATE(7390), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(4904), 5,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4902), 31,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_operator,
  [114972] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7406), 1,
      sym_identifier,
    ACTIONS(7408), 1,
      anon_sym_LPAREN2,
    ACTIONS(7410), 1,
      anon_sym_STAR,
    ACTIONS(7412), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7414), 1,
      anon_sym_AMP,
    STATE(2929), 1,
      sym__type_declarator,
    STATE(3264), 1,
      sym_pointer_type_declarator,
    STATE(3909), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7901), 1,
      sym_ms_based_modifier,
    ACTIONS(7345), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4033), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4638), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7270), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7418), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7416), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3266), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [115057] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7406), 1,
      sym_identifier,
    ACTIONS(7408), 1,
      anon_sym_LPAREN2,
    ACTIONS(7410), 1,
      anon_sym_STAR,
    ACTIONS(7412), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7414), 1,
      anon_sym_AMP,
    STATE(2929), 1,
      sym__type_declarator,
    STATE(3264), 1,
      sym_pointer_type_declarator,
    STATE(3909), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7901), 1,
      sym_ms_based_modifier,
    ACTIONS(7345), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3616), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4638), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7270), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7418), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7416), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3266), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [115142] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7270), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    ACTIONS(7420), 1,
      anon_sym_STAR,
    ACTIONS(7422), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7424), 1,
      anon_sym_AMP,
    STATE(3657), 1,
      sym_parameter_list,
    STATE(3909), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(6119), 1,
      sym__abstract_declarator,
    ACTIONS(7272), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7274), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4037), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4550), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5513), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(6915), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [115227] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7351), 1,
      sym_identifier,
    ACTIONS(7353), 1,
      anon_sym_LPAREN2,
    ACTIONS(7392), 1,
      anon_sym_STAR,
    ACTIONS(7394), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7396), 1,
      anon_sym_AMP,
    STATE(2311), 1,
      sym__type_declarator,
    STATE(2372), 1,
      sym_pointer_type_declarator,
    STATE(3909), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8058), 1,
      sym_ms_based_modifier,
    ACTIONS(7345), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3997), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4588), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7270), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7363), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2340), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [115312] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7426), 1,
      anon_sym_typedef,
    ACTIONS(2821), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2819), 42,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_typename,
      anon_sym_template,
  [115367] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5156), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5158), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [115420] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7351), 1,
      sym_identifier,
    ACTIONS(7353), 1,
      anon_sym_LPAREN2,
    ACTIONS(7392), 1,
      anon_sym_STAR,
    ACTIONS(7394), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7396), 1,
      anon_sym_AMP,
    STATE(2311), 1,
      sym__type_declarator,
    STATE(2372), 1,
      sym_pointer_type_declarator,
    STATE(3909), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8058), 1,
      sym_ms_based_modifier,
    ACTIONS(7345), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3616), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4588), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7270), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7363), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2340), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [115505] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7351), 1,
      sym_identifier,
    ACTIONS(7353), 1,
      anon_sym_LPAREN2,
    ACTIONS(7355), 1,
      anon_sym_STAR,
    ACTIONS(7357), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7359), 1,
      anon_sym_AMP,
    STATE(2372), 1,
      sym_pointer_type_declarator,
    STATE(3909), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6441), 1,
      sym__type_declarator,
    STATE(7983), 1,
      sym_ms_based_modifier,
    ACTIONS(7345), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3616), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4504), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7270), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7363), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2340), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [115590] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7406), 1,
      sym_identifier,
    ACTIONS(7408), 1,
      anon_sym_LPAREN2,
    ACTIONS(7410), 1,
      anon_sym_STAR,
    ACTIONS(7412), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7414), 1,
      anon_sym_AMP,
    STATE(2941), 1,
      sym__type_declarator,
    STATE(3264), 1,
      sym_pointer_type_declarator,
    STATE(3909), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7901), 1,
      sym_ms_based_modifier,
    ACTIONS(7345), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4004), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4551), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7270), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7418), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7416), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3266), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [115675] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7335), 1,
      sym_identifier,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7339), 1,
      anon_sym_STAR,
    ACTIONS(7341), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7343), 1,
      anon_sym_AMP,
    STATE(3019), 1,
      sym__type_declarator,
    STATE(3379), 1,
      sym_pointer_type_declarator,
    STATE(3909), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7618), 1,
      sym_ms_based_modifier,
    ACTIONS(7345), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3990), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4568), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7270), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7349), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7347), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3385), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [115760] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7251), 1,
      sym_auto,
    ACTIONS(7253), 1,
      anon_sym_decltype,
    STATE(4088), 1,
      sym_decltype_auto,
    ACTIONS(4871), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4873), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [115819] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6953), 1,
      anon_sym_const,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7270), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    ACTIONS(7365), 1,
      anon_sym_STAR,
    ACTIONS(7367), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7369), 1,
      anon_sym_AMP,
    STATE(3569), 1,
      sym_parameter_list,
    STATE(3909), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(6095), 1,
      sym__abstract_declarator,
    ACTIONS(7272), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7274), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3616), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4646), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5555), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6945), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [115904] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7351), 1,
      sym_identifier,
    ACTIONS(7353), 1,
      anon_sym_LPAREN2,
    ACTIONS(7355), 1,
      anon_sym_STAR,
    ACTIONS(7357), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7359), 1,
      anon_sym_AMP,
    STATE(2372), 1,
      sym_pointer_type_declarator,
    STATE(3909), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6484), 1,
      sym__type_declarator,
    STATE(7983), 1,
      sym_ms_based_modifier,
    ACTIONS(7345), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3616), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4505), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7270), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7363), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2340), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [115989] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7335), 1,
      sym_identifier,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7339), 1,
      anon_sym_STAR,
    ACTIONS(7341), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7343), 1,
      anon_sym_AMP,
    STATE(2982), 1,
      sym__type_declarator,
    STATE(3379), 1,
      sym_pointer_type_declarator,
    STATE(3909), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7618), 1,
      sym_ms_based_modifier,
    ACTIONS(7345), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3616), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4590), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7270), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7349), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7347), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3385), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [116074] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4867), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(4869), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [116127] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7351), 1,
      sym_identifier,
    ACTIONS(7353), 1,
      anon_sym_LPAREN2,
    ACTIONS(7371), 1,
      anon_sym_STAR,
    ACTIONS(7373), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    STATE(2372), 1,
      sym_pointer_type_declarator,
    STATE(3909), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6166), 1,
      sym__type_declarator,
    STATE(7781), 1,
      sym_ms_based_modifier,
    ACTIONS(7345), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4001), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4496), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7270), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2340), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [116212] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5117), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5119), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [116265] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7351), 1,
      sym_identifier,
    ACTIONS(7353), 1,
      anon_sym_LPAREN2,
    ACTIONS(7355), 1,
      anon_sym_STAR,
    ACTIONS(7357), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7359), 1,
      anon_sym_AMP,
    STATE(2372), 1,
      sym_pointer_type_declarator,
    STATE(3909), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6484), 1,
      sym__type_declarator,
    STATE(7983), 1,
      sym_ms_based_modifier,
    ACTIONS(7345), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4010), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4505), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7270), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7363), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2340), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [116350] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5066), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5068), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [116403] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5105), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5107), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [116456] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7377), 1,
      sym_identifier,
    ACTIONS(7379), 1,
      anon_sym_LPAREN2,
    ACTIONS(7400), 1,
      anon_sym_STAR,
    ACTIONS(7402), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7404), 1,
      anon_sym_AMP,
    STATE(3909), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6052), 1,
      sym__type_declarator,
    STATE(6116), 1,
      sym_pointer_type_declarator,
    STATE(7809), 1,
      sym_ms_based_modifier,
    ACTIONS(7345), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4029), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4613), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7152), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7270), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7387), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6111), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [116541] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7351), 1,
      sym_identifier,
    ACTIONS(7353), 1,
      anon_sym_LPAREN2,
    ACTIONS(7371), 1,
      anon_sym_STAR,
    ACTIONS(7373), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    STATE(2372), 1,
      sym_pointer_type_declarator,
    STATE(3909), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6166), 1,
      sym__type_declarator,
    STATE(7781), 1,
      sym_ms_based_modifier,
    ACTIONS(7345), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3616), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4496), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7270), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2340), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [116626] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7377), 1,
      sym_identifier,
    ACTIONS(7379), 1,
      anon_sym_LPAREN2,
    ACTIONS(7381), 1,
      anon_sym_STAR,
    ACTIONS(7383), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7385), 1,
      anon_sym_AMP,
    STATE(3909), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5839), 1,
      sym__type_declarator,
    STATE(6116), 1,
      sym_pointer_type_declarator,
    STATE(8041), 1,
      sym_ms_based_modifier,
    ACTIONS(7345), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3616), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4535), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7270), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7387), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6111), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [116711] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7377), 1,
      sym_identifier,
    ACTIONS(7379), 1,
      anon_sym_LPAREN2,
    ACTIONS(7381), 1,
      anon_sym_STAR,
    ACTIONS(7383), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7385), 1,
      anon_sym_AMP,
    STATE(3909), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5839), 1,
      sym__type_declarator,
    STATE(6116), 1,
      sym_pointer_type_declarator,
    STATE(8041), 1,
      sym_ms_based_modifier,
    ACTIONS(7345), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4034), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4535), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7270), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7387), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6111), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [116796] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4922), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4924), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(4926), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [116851] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5078), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5080), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [116904] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7377), 1,
      sym_identifier,
    ACTIONS(7379), 1,
      anon_sym_LPAREN2,
    ACTIONS(7400), 1,
      anon_sym_STAR,
    ACTIONS(7402), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7404), 1,
      anon_sym_AMP,
    STATE(3909), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6047), 1,
      sym__type_declarator,
    STATE(6116), 1,
      sym_pointer_type_declarator,
    STATE(7809), 1,
      sym_ms_based_modifier,
    ACTIONS(7345), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3616), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4596), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7152), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7270), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7387), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6111), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [116989] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7335), 1,
      sym_identifier,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7339), 1,
      anon_sym_STAR,
    ACTIONS(7341), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7343), 1,
      anon_sym_AMP,
    STATE(3003), 1,
      sym__type_declarator,
    STATE(3379), 1,
      sym_pointer_type_declarator,
    STATE(3909), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7618), 1,
      sym_ms_based_modifier,
    ACTIONS(7345), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4016), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7270), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7349), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7347), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3385), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [117074] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6317), 1,
      anon_sym_LBRACE,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7398), 1,
      anon_sym_COLON,
    STATE(2649), 1,
      sym_attribute_specifier,
    STATE(3804), 1,
      sym__enum_base_clause,
    STATE(3951), 1,
      sym_enumerator_list,
    ACTIONS(5629), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(5631), 35,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_try,
      anon_sym_requires,
  [117139] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7428), 1,
      anon_sym_typedef,
    ACTIONS(2821), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2819), 42,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_typename,
      anon_sym_template,
  [117194] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7406), 1,
      sym_identifier,
    ACTIONS(7408), 1,
      anon_sym_LPAREN2,
    ACTIONS(7410), 1,
      anon_sym_STAR,
    ACTIONS(7412), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7414), 1,
      anon_sym_AMP,
    STATE(2880), 1,
      sym__type_declarator,
    STATE(3264), 1,
      sym_pointer_type_declarator,
    STATE(3909), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(7901), 1,
      sym_ms_based_modifier,
    ACTIONS(7345), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3616), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4604), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7270), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7418), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7416), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3266), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [117279] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7377), 1,
      sym_identifier,
    ACTIONS(7379), 1,
      anon_sym_LPAREN2,
    ACTIONS(7381), 1,
      anon_sym_STAR,
    ACTIONS(7383), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7385), 1,
      anon_sym_AMP,
    STATE(3909), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5837), 1,
      sym__type_declarator,
    STATE(6116), 1,
      sym_pointer_type_declarator,
    STATE(8041), 1,
      sym_ms_based_modifier,
    ACTIONS(7345), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3616), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4544), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7270), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7387), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6111), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [117364] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7377), 1,
      sym_identifier,
    ACTIONS(7379), 1,
      anon_sym_LPAREN2,
    ACTIONS(7400), 1,
      anon_sym_STAR,
    ACTIONS(7402), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7404), 1,
      anon_sym_AMP,
    STATE(3909), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6047), 1,
      sym__type_declarator,
    STATE(6116), 1,
      sym_pointer_type_declarator,
    STATE(7809), 1,
      sym_ms_based_modifier,
    ACTIONS(7345), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4000), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4596), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7152), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7270), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7387), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6111), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [117449] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7327), 1,
      anon_sym_LT,
    STATE(2724), 1,
      sym_template_argument_list,
    ACTIONS(5187), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(3785), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [117508] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7270), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    ACTIONS(7420), 1,
      anon_sym_STAR,
    ACTIONS(7422), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7424), 1,
      anon_sym_AMP,
    STATE(3657), 1,
      sym_parameter_list,
    STATE(3909), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(6108), 1,
      sym__abstract_declarator,
    ACTIONS(7272), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7274), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3616), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4502), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5555), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(6915), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [117593] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5058), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5060), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [117645] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5145), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5147), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [117697] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3018), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3016), 42,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_typename,
      anon_sym_template,
  [117749] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(5511), 1,
      sym_identifier,
    ACTIONS(5521), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    ACTIONS(6880), 1,
      anon_sym_STAR,
    ACTIONS(6882), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6884), 1,
      anon_sym_AMP,
    STATE(5695), 1,
      sym__scope_resolution,
    STATE(6141), 1,
      sym__declarator,
    STATE(7771), 1,
      sym_ms_based_modifier,
    STATE(4972), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [117835] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3194), 1,
      anon_sym_LBRACE,
    ACTIONS(7124), 1,
      anon_sym_LBRACK,
    ACTIONS(7249), 1,
      anon_sym_LPAREN2,
    ACTIONS(7309), 1,
      sym_auto,
    ACTIONS(7311), 1,
      anon_sym_decltype,
    STATE(1988), 1,
      sym_decltype_auto,
    STATE(3968), 1,
      sym_new_declarator,
    STATE(3922), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5230), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(5232), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [117903] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(4841), 1,
      sym_identifier,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    ACTIONS(6886), 1,
      anon_sym_STAR,
    ACTIONS(6888), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6890), 1,
      anon_sym_AMP,
    ACTIONS(6892), 1,
      anon_sym_COLON_COLON,
    STATE(5603), 1,
      sym__scope_resolution,
    STATE(6416), 1,
      sym__declarator,
    STATE(7821), 1,
      sym_ms_based_modifier,
    STATE(4972), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [117989] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5152), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5154), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [118041] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(5511), 1,
      sym_identifier,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    ACTIONS(6843), 1,
      anon_sym_STAR,
    ACTIONS(6845), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6847), 1,
      anon_sym_AMP,
    ACTIONS(6849), 1,
      anon_sym_COLON_COLON,
    STATE(5585), 1,
      sym__scope_resolution,
    STATE(5925), 1,
      sym__declarator,
    STATE(7697), 1,
      sym_ms_based_modifier,
    STATE(4972), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [118127] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(5511), 1,
      sym_identifier,
    ACTIONS(5521), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    ACTIONS(6880), 1,
      anon_sym_STAR,
    ACTIONS(6882), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6884), 1,
      anon_sym_AMP,
    STATE(5695), 1,
      sym__scope_resolution,
    STATE(6167), 1,
      sym__declarator,
    STATE(7771), 1,
      sym_ms_based_modifier,
    STATE(4972), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [118213] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7270), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    ACTIONS(7430), 1,
      anon_sym_STAR,
    ACTIONS(7432), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7434), 1,
      anon_sym_AMP,
    STATE(3784), 1,
      sym_parameter_list,
    STATE(3909), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(6195), 1,
      sym__abstract_declarator,
    ACTIONS(7272), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7274), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4069), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4649), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5513), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6915), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [118297] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(5511), 1,
      sym_identifier,
    ACTIONS(5521), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    ACTIONS(6798), 1,
      anon_sym_STAR,
    ACTIONS(6800), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6802), 1,
      anon_sym_AMP,
    STATE(5695), 1,
      sym__scope_resolution,
    STATE(6013), 1,
      sym__declarator,
    STATE(7894), 1,
      sym_ms_based_modifier,
    STATE(4972), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [118383] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5054), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5056), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [118435] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5062), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5064), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [118487] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(2845), 1,
      anon_sym_STAR,
    ACTIONS(2847), 1,
      anon_sym_AMP,
    ACTIONS(4841), 1,
      sym_identifier,
    ACTIONS(5825), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    STATE(5610), 1,
      sym__scope_resolution,
    STATE(6284), 1,
      sym__declarator,
    STATE(8318), 1,
      sym_ms_based_modifier,
    STATE(4972), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [118573] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(57), 1,
      anon_sym___inline,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7438), 1,
      anon_sym___declspec,
    ACTIONS(7440), 1,
      sym_auto,
    ACTIONS(7442), 1,
      anon_sym_decltype,
    ACTIONS(7444), 1,
      anon_sym_virtual,
    ACTIONS(7446), 1,
      anon_sym_alignas,
    STATE(2655), 1,
      sym_decltype_auto,
    ACTIONS(5817), 2,
      anon_sym_AMP,
      anon_sym_LBRACK,
    ACTIONS(5819), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(7436), 8,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    STATE(4171), 9,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      sym_virtual,
      sym_alignas_specifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(6915), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [118651] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(4841), 1,
      sym_identifier,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    ACTIONS(6886), 1,
      anon_sym_STAR,
    ACTIONS(6888), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6890), 1,
      anon_sym_AMP,
    ACTIONS(6892), 1,
      anon_sym_COLON_COLON,
    STATE(5603), 1,
      sym__scope_resolution,
    STATE(6418), 1,
      sym__declarator,
    STATE(7821), 1,
      sym_ms_based_modifier,
    STATE(4972), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [118737] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(4841), 1,
      sym_identifier,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    ACTIONS(6886), 1,
      anon_sym_STAR,
    ACTIONS(6888), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6890), 1,
      anon_sym_AMP,
    ACTIONS(6892), 1,
      anon_sym_COLON_COLON,
    STATE(5603), 1,
      sym__scope_resolution,
    STATE(6409), 1,
      sym__declarator,
    STATE(7821), 1,
      sym_ms_based_modifier,
    STATE(4972), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [118823] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(6782), 1,
      sym_identifier,
    ACTIONS(6784), 1,
      anon_sym_STAR,
    ACTIONS(6786), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6788), 1,
      anon_sym_AMP,
    ACTIONS(6790), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    STATE(5612), 1,
      sym__scope_resolution,
    STATE(6284), 1,
      sym__declarator,
    STATE(7612), 1,
      sym_ms_based_modifier,
    STATE(4972), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [118909] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(5511), 1,
      sym_identifier,
    ACTIONS(5521), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    ACTIONS(6880), 1,
      anon_sym_STAR,
    ACTIONS(6882), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6884), 1,
      anon_sym_AMP,
    STATE(5695), 1,
      sym__scope_resolution,
    STATE(6199), 1,
      sym__declarator,
    STATE(7771), 1,
      sym_ms_based_modifier,
    STATE(4972), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [118995] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5135), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5137), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [119047] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(5511), 1,
      sym_identifier,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    ACTIONS(6843), 1,
      anon_sym_STAR,
    ACTIONS(6845), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6847), 1,
      anon_sym_AMP,
    ACTIONS(6849), 1,
      anon_sym_COLON_COLON,
    STATE(5585), 1,
      sym__scope_resolution,
    STATE(6027), 1,
      sym__declarator,
    STATE(7697), 1,
      sym_ms_based_modifier,
    STATE(4972), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [119133] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2753), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2751), 42,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_typename,
      anon_sym_template,
  [119185] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5050), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5052), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [119237] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5050), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5052), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [119289] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(57), 1,
      anon_sym___inline,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7438), 1,
      anon_sym___declspec,
    ACTIONS(7440), 1,
      sym_auto,
    ACTIONS(7442), 1,
      anon_sym_decltype,
    ACTIONS(7444), 1,
      anon_sym_virtual,
    ACTIONS(7446), 1,
      anon_sym_alignas,
    STATE(2655), 1,
      sym_decltype_auto,
    ACTIONS(5791), 2,
      anon_sym_AMP,
      anon_sym_LBRACK,
    ACTIONS(5793), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(7436), 8,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    STATE(4160), 9,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      sym_virtual,
      sym_alignas_specifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(6915), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [119367] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(2845), 1,
      anon_sym_STAR,
    ACTIONS(2847), 1,
      anon_sym_AMP,
    ACTIONS(4841), 1,
      sym_identifier,
    ACTIONS(5825), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    STATE(5610), 1,
      sym__scope_resolution,
    STATE(6254), 1,
      sym__declarator,
    STATE(8318), 1,
      sym_ms_based_modifier,
    STATE(4972), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [119453] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3194), 1,
      anon_sym_LBRACE,
    ACTIONS(7124), 1,
      anon_sym_LBRACK,
    ACTIONS(7249), 1,
      anon_sym_LPAREN2,
    ACTIONS(7309), 1,
      sym_auto,
    ACTIONS(7311), 1,
      anon_sym_decltype,
    STATE(1988), 1,
      sym_decltype_auto,
    STATE(3961), 1,
      sym_new_declarator,
    STATE(3902), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5234), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(5236), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [119521] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(6782), 1,
      sym_identifier,
    ACTIONS(6784), 1,
      anon_sym_STAR,
    ACTIONS(6786), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6788), 1,
      anon_sym_AMP,
    ACTIONS(6790), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    STATE(5612), 1,
      sym__scope_resolution,
    STATE(6221), 1,
      sym__declarator,
    STATE(7612), 1,
      sym_ms_based_modifier,
    STATE(4972), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [119607] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5038), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5040), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [119659] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5034), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5036), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [119711] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5050), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5052), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [119763] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7270), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    ACTIONS(7430), 1,
      anon_sym_STAR,
    ACTIONS(7432), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7434), 1,
      anon_sym_AMP,
    STATE(3784), 1,
      sym_parameter_list,
    STATE(3909), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(6184), 1,
      sym__abstract_declarator,
    ACTIONS(7272), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7274), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3616), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4666), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5555), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6915), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [119847] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4924), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(4926), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [119899] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5099), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [119951] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5042), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5044), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [120003] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5926), 1,
      anon_sym___attribute__,
    ACTIONS(6157), 1,
      anon_sym_LBRACE,
    ACTIONS(7448), 1,
      anon_sym_COLON,
    STATE(2710), 1,
      sym__enum_base_clause,
    STATE(2803), 1,
      sym_enumerator_list,
    STATE(2895), 1,
      sym_attribute_specifier,
    ACTIONS(5689), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5691), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [120067] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2737), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2735), 42,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_typename,
      anon_sym_template,
  [120119] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3194), 1,
      anon_sym_LBRACE,
    ACTIONS(7124), 1,
      anon_sym_LBRACK,
    ACTIONS(7249), 1,
      anon_sym_LPAREN2,
    ACTIONS(7309), 1,
      sym_auto,
    ACTIONS(7311), 1,
      anon_sym_decltype,
    STATE(1988), 1,
      sym_decltype_auto,
    STATE(3972), 1,
      sym_new_declarator,
    STATE(3952), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5226), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(5228), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [120187] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(6782), 1,
      sym_identifier,
    ACTIONS(6784), 1,
      anon_sym_STAR,
    ACTIONS(6786), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6788), 1,
      anon_sym_AMP,
    ACTIONS(6790), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    STATE(5612), 1,
      sym__scope_resolution,
    STATE(6254), 1,
      sym__declarator,
    STATE(7612), 1,
      sym_ms_based_modifier,
    STATE(4972), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [120273] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5926), 1,
      anon_sym___attribute__,
    ACTIONS(6157), 1,
      anon_sym_LBRACE,
    ACTIONS(7448), 1,
      anon_sym_COLON,
    STATE(2712), 1,
      sym__enum_base_clause,
    STATE(2813), 1,
      sym_enumerator_list,
    STATE(2914), 1,
      sym_attribute_specifier,
    ACTIONS(5629), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5631), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [120337] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(5511), 1,
      sym_identifier,
    ACTIONS(5521), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    ACTIONS(6798), 1,
      anon_sym_STAR,
    ACTIONS(6800), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6802), 1,
      anon_sym_AMP,
    STATE(5695), 1,
      sym__scope_resolution,
    STATE(5967), 1,
      sym__declarator,
    STATE(7894), 1,
      sym_ms_based_modifier,
    STATE(4972), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [120423] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5109), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5111), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [120475] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5113), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5115), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [120527] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2541), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2536), 42,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_typename,
      anon_sym_template,
  [120579] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5160), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5162), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [120631] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(5511), 1,
      sym_identifier,
    ACTIONS(5521), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    ACTIONS(6798), 1,
      anon_sym_STAR,
    ACTIONS(6800), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6802), 1,
      anon_sym_AMP,
    STATE(5695), 1,
      sym__scope_resolution,
    STATE(5927), 1,
      sym__declarator,
    STATE(7894), 1,
      sym_ms_based_modifier,
    STATE(4972), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [120717] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5164), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5166), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [120769] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3194), 1,
      anon_sym_LBRACE,
    ACTIONS(7124), 1,
      anon_sym_LBRACK,
    ACTIONS(7249), 1,
      anon_sym_LPAREN2,
    ACTIONS(7309), 1,
      sym_auto,
    ACTIONS(7311), 1,
      anon_sym_decltype,
    STATE(1988), 1,
      sym_decltype_auto,
    STATE(3981), 1,
      sym_new_declarator,
    STATE(3934), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5208), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(5210), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [120837] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5121), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5123), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [120889] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5179), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5181), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [120941] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5185), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [120993] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5125), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5127), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [121045] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5129), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5131), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [121097] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2785), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2783), 42,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_typename,
      anon_sym_template,
  [121149] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2775), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2773), 42,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_typename,
      anon_sym_template,
  [121201] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5172), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5174), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [121253] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5121), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5123), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [121305] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5046), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5048), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [121357] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3088), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3086), 42,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_typename,
      anon_sym_template,
  [121409] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5089), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5091), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [121461] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(2845), 1,
      anon_sym_STAR,
    ACTIONS(2847), 1,
      anon_sym_AMP,
    ACTIONS(4841), 1,
      sym_identifier,
    ACTIONS(5825), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    STATE(5610), 1,
      sym__scope_resolution,
    STATE(6221), 1,
      sym__declarator,
    STATE(8318), 1,
      sym_ms_based_modifier,
    STATE(4972), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [121547] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5070), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5072), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [121599] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4186), 1,
      sym_ms_unaligned_ptr_modifier,
    ACTIONS(7453), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4100), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(7450), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7086), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(7084), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [121659] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(5511), 1,
      sym_identifier,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    ACTIONS(6843), 1,
      anon_sym_STAR,
    ACTIONS(6845), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6847), 1,
      anon_sym_AMP,
    ACTIONS(6849), 1,
      anon_sym_COLON_COLON,
    STATE(5585), 1,
      sym__scope_resolution,
    STATE(6022), 1,
      sym__declarator,
    STATE(7697), 1,
      sym_ms_based_modifier,
    STATE(4972), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [121745] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5093), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5095), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [121797] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5168), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5170), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [121849] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5085), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5087), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [121901] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7456), 1,
      sym_identifier,
    STATE(4156), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4481), 1,
      sym_primitive_type,
    ACTIONS(7152), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7458), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4934), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(4936), 24,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [121962] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7462), 1,
      anon_sym_SLASH,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7460), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5724), 15,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(5726), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
  [122031] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7462), 1,
      anon_sym_SLASH,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7474), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7478), 1,
      anon_sym_CARET,
    ACTIONS(7486), 1,
      anon_sym_GT_EQ,
    ACTIONS(7490), 1,
      anon_sym_QMARK,
    ACTIONS(7492), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7494), 1,
      anon_sym_or,
    ACTIONS(7496), 1,
      anon_sym_and,
    ACTIONS(7498), 1,
      anon_sym_xor,
    ACTIONS(7500), 1,
      anon_sym_not_eq,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7460), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7464), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(7470), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7476), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(7480), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(7482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7488), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7484), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7468), 5,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
  [122134] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7462), 1,
      anon_sym_SLASH,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7460), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7470), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(5724), 13,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(5726), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
  [122205] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_LBRACE,
    ACTIONS(6281), 1,
      sym_auto,
    ACTIONS(6283), 1,
      anon_sym_decltype,
    ACTIONS(7502), 1,
      anon_sym_LPAREN2,
    ACTIONS(7504), 1,
      anon_sym_LBRACK,
    STATE(2951), 1,
      sym_decltype_auto,
    STATE(4340), 1,
      sym_new_declarator,
    STATE(4661), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5208), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5210), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [122272] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_LBRACE,
    ACTIONS(6281), 1,
      sym_auto,
    ACTIONS(6283), 1,
      anon_sym_decltype,
    ACTIONS(7502), 1,
      anon_sym_LPAREN2,
    ACTIONS(7504), 1,
      anon_sym_LBRACK,
    STATE(2951), 1,
      sym_decltype_auto,
    STATE(4337), 1,
      sym_new_declarator,
    STATE(4671), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5226), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5228), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [122339] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7462), 1,
      anon_sym_SLASH,
    ACTIONS(7486), 1,
      anon_sym_GT_EQ,
    ACTIONS(7492), 1,
      anon_sym_LT_EQ_GT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7460), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7470), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7488), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7484), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5724), 10,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(5726), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
  [122418] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7462), 1,
      anon_sym_SLASH,
    ACTIONS(7478), 1,
      anon_sym_CARET,
    ACTIONS(7486), 1,
      anon_sym_GT_EQ,
    ACTIONS(7492), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7498), 1,
      anon_sym_xor,
    ACTIONS(7500), 1,
      anon_sym_not_eq,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7460), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7470), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7476), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(7480), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(7482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7488), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7484), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5724), 4,
      aux_sym_preproc_elif_token1,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
    ACTIONS(5726), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
  [122509] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7462), 1,
      anon_sym_SLASH,
    ACTIONS(7478), 1,
      anon_sym_CARET,
    ACTIONS(7486), 1,
      anon_sym_GT_EQ,
    ACTIONS(7492), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7498), 1,
      anon_sym_xor,
    ACTIONS(7500), 1,
      anon_sym_not_eq,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7460), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7470), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7480), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(7482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7488), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7484), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5724), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      sym_identifier,
    ACTIONS(5726), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
  [122598] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_const,
    ACTIONS(2919), 1,
      sym_ms_restrict_modifier,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(7506), 1,
      anon_sym_STAR,
    ACTIONS(7508), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7510), 1,
      anon_sym_AMP,
    STATE(3759), 1,
      sym_parameter_list,
    STATE(4186), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6212), 1,
      sym__abstract_declarator,
    ACTIONS(7321), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7323), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4125), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4771), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5513), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7319), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [122681] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7462), 1,
      anon_sym_SLASH,
    ACTIONS(7472), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7474), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7478), 1,
      anon_sym_CARET,
    ACTIONS(7486), 1,
      anon_sym_GT_EQ,
    ACTIONS(7492), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7494), 1,
      anon_sym_or,
    ACTIONS(7496), 1,
      anon_sym_and,
    ACTIONS(7498), 1,
      anon_sym_xor,
    ACTIONS(7500), 1,
      anon_sym_not_eq,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6269), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7460), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7470), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7476), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(7480), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(7482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7488), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7484), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6271), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
  [122780] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7462), 1,
      anon_sym_SLASH,
    ACTIONS(7486), 1,
      anon_sym_GT_EQ,
    ACTIONS(7492), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7500), 1,
      anon_sym_not_eq,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7460), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7470), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7480), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(7482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7488), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7484), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5724), 7,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      sym_identifier,
    ACTIONS(5726), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_QMARK,
  [122865] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6032), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6034), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [122916] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(3803), 1,
      anon_sym_LPAREN2,
    ACTIONS(5511), 1,
      sym_identifier,
    ACTIONS(5521), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5523), 1,
      anon_sym_LBRACK,
    ACTIONS(5740), 1,
      anon_sym_STAR,
    ACTIONS(7512), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7516), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7518), 1,
      anon_sym_AMP,
    ACTIONS(7520), 1,
      anon_sym_EQ,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(5695), 1,
      sym__scope_resolution,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6305), 1,
      sym__declarator,
    STATE(6529), 1,
      sym__abstract_declarator,
    STATE(6554), 1,
      sym_abstract_reference_declarator,
    STATE(7076), 1,
      sym_variadic_declarator,
    STATE(7085), 1,
      sym_variadic_reference_declarator,
    STATE(7771), 1,
      sym_ms_based_modifier,
    ACTIONS(7514), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6031), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [123017] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7462), 1,
      anon_sym_SLASH,
    ACTIONS(7486), 1,
      anon_sym_GT_EQ,
    ACTIONS(7492), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7500), 1,
      anon_sym_not_eq,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7460), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7470), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7488), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7484), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5724), 9,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      sym_identifier,
    ACTIONS(5726), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_QMARK,
  [123100] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5881), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5883), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [123151] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7462), 1,
      anon_sym_SLASH,
    ACTIONS(7474), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7478), 1,
      anon_sym_CARET,
    ACTIONS(7486), 1,
      anon_sym_GT_EQ,
    ACTIONS(7492), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7496), 1,
      anon_sym_and,
    ACTIONS(7498), 1,
      anon_sym_xor,
    ACTIONS(7500), 1,
      anon_sym_not_eq,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7460), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7470), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7476), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(7480), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(7482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7488), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5724), 3,
      aux_sym_preproc_elif_token1,
      anon_sym_or,
      sym_identifier,
    ACTIONS(7484), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5726), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
  [123246] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5873), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5875), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [123297] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7462), 1,
      anon_sym_SLASH,
    ACTIONS(7472), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7474), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7478), 1,
      anon_sym_CARET,
    ACTIONS(7486), 1,
      anon_sym_GT_EQ,
    ACTIONS(7492), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7494), 1,
      anon_sym_or,
    ACTIONS(7496), 1,
      anon_sym_and,
    ACTIONS(7498), 1,
      anon_sym_xor,
    ACTIONS(7500), 1,
      anon_sym_not_eq,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6256), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7460), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7470), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7476), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(7480), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(7482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7488), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7484), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6258), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
  [123396] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4536), 1,
      anon_sym_SEMI,
    ACTIONS(4545), 1,
      anon_sym_LBRACK,
    ACTIONS(6103), 1,
      anon_sym_LT,
    STATE(3993), 1,
      sym_template_argument_list,
    ACTIONS(4538), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4541), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(4534), 33,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [123459] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_const,
    ACTIONS(2919), 1,
      sym_ms_restrict_modifier,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(7506), 1,
      anon_sym_STAR,
    ACTIONS(7508), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7510), 1,
      anon_sym_AMP,
    STATE(3759), 1,
      sym_parameter_list,
    STATE(4186), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6281), 1,
      sym__abstract_declarator,
    ACTIONS(7321), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7323), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4100), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4740), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5555), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7319), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [123542] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7462), 1,
      anon_sym_SLASH,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7474), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7478), 1,
      anon_sym_CARET,
    ACTIONS(7486), 1,
      anon_sym_GT_EQ,
    ACTIONS(7490), 1,
      anon_sym_QMARK,
    ACTIONS(7492), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7494), 1,
      anon_sym_or,
    ACTIONS(7496), 1,
      anon_sym_and,
    ACTIONS(7498), 1,
      anon_sym_xor,
    ACTIONS(7500), 1,
      anon_sym_not_eq,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6216), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7460), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7470), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7476), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(7480), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(7482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7488), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7484), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6220), 5,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
  [123645] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7462), 1,
      anon_sym_SLASH,
    ACTIONS(7472), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7474), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7478), 1,
      anon_sym_CARET,
    ACTIONS(7486), 1,
      anon_sym_GT_EQ,
    ACTIONS(7492), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7494), 1,
      anon_sym_or,
    ACTIONS(7496), 1,
      anon_sym_and,
    ACTIONS(7498), 1,
      anon_sym_xor,
    ACTIONS(7500), 1,
      anon_sym_not_eq,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6240), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7460), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7470), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7476), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(7480), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(7482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7488), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7484), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6242), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
  [123744] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7462), 1,
      anon_sym_SLASH,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7474), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7478), 1,
      anon_sym_CARET,
    ACTIONS(7486), 1,
      anon_sym_GT_EQ,
    ACTIONS(7490), 1,
      anon_sym_QMARK,
    ACTIONS(7492), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7494), 1,
      anon_sym_or,
    ACTIONS(7496), 1,
      anon_sym_and,
    ACTIONS(7498), 1,
      anon_sym_xor,
    ACTIONS(7500), 1,
      anon_sym_not_eq,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6244), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7460), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7470), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7476), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(7480), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(7482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7488), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7484), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6246), 5,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
  [123847] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7462), 1,
      anon_sym_SLASH,
    ACTIONS(7472), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7474), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7478), 1,
      anon_sym_CARET,
    ACTIONS(7486), 1,
      anon_sym_GT_EQ,
    ACTIONS(7492), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7494), 1,
      anon_sym_or,
    ACTIONS(7496), 1,
      anon_sym_and,
    ACTIONS(7498), 1,
      anon_sym_xor,
    ACTIONS(7500), 1,
      anon_sym_not_eq,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6248), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7460), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7470), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7476), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(7480), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(7482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7488), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7484), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6250), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
  [123946] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7462), 1,
      anon_sym_SLASH,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7460), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7470), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7488), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5724), 13,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(5726), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
  [124019] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7462), 1,
      anon_sym_SLASH,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7474), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7478), 1,
      anon_sym_CARET,
    ACTIONS(7486), 1,
      anon_sym_GT_EQ,
    ACTIONS(7490), 1,
      anon_sym_QMARK,
    ACTIONS(7492), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7494), 1,
      anon_sym_or,
    ACTIONS(7496), 1,
      anon_sym_and,
    ACTIONS(7498), 1,
      anon_sym_xor,
    ACTIONS(7500), 1,
      anon_sym_not_eq,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5934), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7460), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7470), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7476), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(7480), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(7482), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7488), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7484), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5936), 5,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
  [124122] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7462), 1,
      anon_sym_SLASH,
    ACTIONS(7492), 1,
      anon_sym_LT_EQ_GT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7460), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7470), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7488), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5724), 13,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(5726), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
  [124197] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_LBRACE,
    ACTIONS(6281), 1,
      sym_auto,
    ACTIONS(6283), 1,
      anon_sym_decltype,
    ACTIONS(7502), 1,
      anon_sym_LPAREN2,
    ACTIONS(7504), 1,
      anon_sym_LBRACK,
    STATE(2951), 1,
      sym_decltype_auto,
    STATE(4318), 1,
      sym_new_declarator,
    STATE(4679), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5234), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5236), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [124264] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(3803), 1,
      anon_sym_LPAREN2,
    ACTIONS(5511), 1,
      sym_identifier,
    ACTIONS(5521), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5523), 1,
      anon_sym_LBRACK,
    ACTIONS(5708), 1,
      anon_sym_STAR,
    ACTIONS(7512), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7516), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7518), 1,
      anon_sym_AMP,
    ACTIONS(7522), 1,
      anon_sym_EQ,
    STATE(3830), 1,
      sym_parameter_list,
    STATE(5695), 1,
      sym__scope_resolution,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6292), 1,
      sym__declarator,
    STATE(6509), 1,
      sym__abstract_declarator,
    STATE(6569), 1,
      sym_abstract_reference_declarator,
    STATE(7076), 1,
      sym_variadic_declarator,
    STATE(7085), 1,
      sym_variadic_reference_declarator,
    STATE(7771), 1,
      sym_ms_based_modifier,
    ACTIONS(7514), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6031), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [124365] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_LBRACE,
    ACTIONS(6281), 1,
      sym_auto,
    ACTIONS(6283), 1,
      anon_sym_decltype,
    ACTIONS(7502), 1,
      anon_sym_LPAREN2,
    ACTIONS(7504), 1,
      anon_sym_LBRACK,
    STATE(2951), 1,
      sym_decltype_auto,
    STATE(4316), 1,
      sym_new_declarator,
    STATE(4653), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5230), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5232), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [124432] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(3803), 1,
      anon_sym_LPAREN2,
    ACTIONS(5511), 1,
      sym_identifier,
    ACTIONS(5515), 1,
      anon_sym_STAR,
    ACTIONS(5517), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5519), 1,
      anon_sym_AMP,
    ACTIONS(5521), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5523), 1,
      anon_sym_LBRACK,
    ACTIONS(7512), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(3343), 1,
      sym_parameter_list,
    STATE(5695), 1,
      sym__scope_resolution,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6149), 1,
      sym__declarator,
    STATE(6283), 1,
      sym__abstract_declarator,
    STATE(7185), 1,
      sym_variadic_declarator,
    STATE(7771), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(7524), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_GT2,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [124527] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5833), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5835), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [124578] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6953), 1,
      anon_sym_const,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7264), 1,
      anon_sym_STAR,
    ACTIONS(7266), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7268), 1,
      anon_sym_AMP,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    ACTIONS(7528), 1,
      sym_auto,
    ACTIONS(7530), 1,
      anon_sym_decltype,
    STATE(3638), 1,
      sym_parameter_list,
    STATE(4894), 1,
      sym_decltype_auto,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(5899), 1,
      sym__abstract_declarator,
    STATE(4243), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7526), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(6945), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [124656] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4139), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7532), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4768), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(4766), 28,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [124710] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(6317), 1,
      anon_sym_LBRACE,
    ACTIONS(7535), 1,
      anon_sym_COLON,
    STATE(2633), 1,
      sym_attribute_specifier,
    STATE(2881), 1,
      sym__enum_base_clause,
    STATE(3135), 1,
      sym_enumerator_list,
    ACTIONS(5691), 5,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5689), 31,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_operator,
  [124772] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6953), 1,
      anon_sym_const,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    ACTIONS(7292), 1,
      anon_sym_STAR,
    ACTIONS(7294), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7296), 1,
      anon_sym_AMP,
    ACTIONS(7528), 1,
      sym_auto,
    ACTIONS(7530), 1,
      anon_sym_decltype,
    STATE(3360), 1,
      sym_parameter_list,
    STATE(4894), 1,
      sym_decltype_auto,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(5865), 1,
      sym__abstract_declarator,
    STATE(4305), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7537), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6945), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [124850] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3194), 1,
      anon_sym_LBRACE,
    ACTIONS(7307), 1,
      anon_sym_LPAREN2,
    STATE(3941), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5565), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(5567), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [124906] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6953), 1,
      anon_sym_const,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7264), 1,
      anon_sym_STAR,
    ACTIONS(7266), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7268), 1,
      anon_sym_AMP,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    ACTIONS(7528), 1,
      sym_auto,
    ACTIONS(7530), 1,
      anon_sym_decltype,
    STATE(3638), 1,
      sym_parameter_list,
    STATE(4894), 1,
      sym_decltype_auto,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(5906), 1,
      sym__abstract_declarator,
    STATE(4239), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7537), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(6945), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [124984] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3194), 1,
      anon_sym_LBRACE,
    ACTIONS(7307), 1,
      anon_sym_LPAREN2,
    STATE(3954), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5561), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(5563), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [125040] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6299), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(6301), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [125090] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_const,
    ACTIONS(2919), 1,
      sym_ms_restrict_modifier,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(7539), 1,
      anon_sym_STAR,
    ACTIONS(7541), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7543), 1,
      anon_sym_AMP,
    STATE(3826), 1,
      sym_parameter_list,
    STATE(4186), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6309), 1,
      sym__abstract_declarator,
    ACTIONS(7321), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7323), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4100), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4793), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5555), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7319), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [125172] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    ACTIONS(7278), 1,
      anon_sym_STAR,
    ACTIONS(7280), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7282), 1,
      anon_sym_AMP,
    ACTIONS(7440), 1,
      sym_auto,
    ACTIONS(7442), 1,
      anon_sym_decltype,
    STATE(2655), 1,
      sym_decltype_auto,
    STATE(3617), 1,
      sym_parameter_list,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(5909), 1,
      sym__abstract_declarator,
    STATE(4242), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7537), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6915), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [125250] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6289), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(6291), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [125300] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5201), 1,
      sym_literal_suffix,
    ACTIONS(3769), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(3761), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [125352] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5201), 1,
      sym_literal_suffix,
    ACTIONS(5197), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5199), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [125404] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    ACTIONS(7278), 1,
      anon_sym_STAR,
    ACTIONS(7280), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7282), 1,
      anon_sym_AMP,
    ACTIONS(7440), 1,
      sym_auto,
    ACTIONS(7442), 1,
      anon_sym_decltype,
    STATE(2655), 1,
      sym_decltype_auto,
    STATE(3617), 1,
      sym_parameter_list,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(5898), 1,
      sym__abstract_declarator,
    STATE(4279), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7526), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6915), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [125482] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3194), 1,
      anon_sym_LBRACE,
    ACTIONS(7307), 1,
      anon_sym_LPAREN2,
    STATE(3925), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5609), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(5611), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [125538] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6953), 1,
      anon_sym_const,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    ACTIONS(7292), 1,
      anon_sym_STAR,
    ACTIONS(7294), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7296), 1,
      anon_sym_AMP,
    ACTIONS(7528), 1,
      sym_auto,
    ACTIONS(7530), 1,
      anon_sym_decltype,
    STATE(3360), 1,
      sym_parameter_list,
    STATE(4894), 1,
      sym_decltype_auto,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(5860), 1,
      sym__abstract_declarator,
    STATE(4333), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7526), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6945), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [125616] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_const,
    ACTIONS(2919), 1,
      sym_ms_restrict_modifier,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(7539), 1,
      anon_sym_STAR,
    ACTIONS(7541), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7543), 1,
      anon_sym_AMP,
    STATE(3826), 1,
      sym_parameter_list,
    STATE(4186), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6297), 1,
      sym__abstract_declarator,
    ACTIONS(7321), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7323), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4146), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4808), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5513), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7319), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [125698] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3194), 1,
      anon_sym_LBRACE,
    ACTIONS(7307), 1,
      anon_sym_LPAREN2,
    STATE(3949), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5625), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(5627), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [125754] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4139), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4766), 4,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
    ACTIONS(7532), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5139), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(5142), 24,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [125810] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(6317), 1,
      anon_sym_LBRACE,
    ACTIONS(7535), 1,
      anon_sym_COLON,
    STATE(2649), 1,
      sym_attribute_specifier,
    STATE(2966), 1,
      sym__enum_base_clause,
    STATE(3079), 1,
      sym_enumerator_list,
    ACTIONS(5631), 5,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5629), 31,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_operator,
  [125872] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7290), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(7288), 28,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [125921] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7545), 1,
      sym_identifier,
    STATE(4192), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4723), 1,
      sym_primitive_type,
    ACTIONS(7174), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7547), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4934), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4936), 21,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [125980] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(57), 1,
      anon_sym___inline,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7438), 1,
      anon_sym___declspec,
    ACTIONS(7444), 1,
      anon_sym_virtual,
    ACTIONS(7446), 1,
      anon_sym_alignas,
    ACTIONS(6053), 2,
      anon_sym_AMP,
      anon_sym_LBRACK,
    ACTIONS(6055), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(7436), 8,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    STATE(4161), 9,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      sym_virtual,
      sym_alignas_specifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(6915), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [126049] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6629), 1,
      anon_sym_const,
    ACTIONS(6632), 1,
      anon_sym___inline,
    ACTIONS(7555), 1,
      anon_sym___attribute__,
    ACTIONS(7558), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7561), 1,
      anon_sym___declspec,
    ACTIONS(7564), 1,
      anon_sym_virtual,
    ACTIONS(7567), 1,
      anon_sym_alignas,
    ACTIONS(6065), 2,
      anon_sym_AMP,
      anon_sym_LBRACK,
    ACTIONS(6067), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(7552), 8,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    STATE(4161), 9,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      sym_virtual,
      sym_alignas_specifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(7549), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [126118] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6907), 1,
      anon_sym_LT,
    STATE(1741), 1,
      sym_template_argument_list,
    STATE(3431), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3759), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6522), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3767), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [126177] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7570), 1,
      anon_sym_COMMA,
    ACTIONS(7576), 1,
      anon_sym_SLASH,
    ACTIONS(7582), 1,
      anon_sym_PIPE,
    ACTIONS(7586), 1,
      anon_sym_AMP,
    ACTIONS(7592), 1,
      anon_sym_GT_EQ,
    ACTIONS(7596), 1,
      anon_sym_SEMI,
    ACTIONS(7598), 1,
      anon_sym_QMARK,
    ACTIONS(7600), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7602), 1,
      anon_sym_bitor,
    ACTIONS(7604), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    STATE(6571), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8051), 1,
      sym_attribute_specifier,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7578), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7580), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7584), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7594), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7588), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7590), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [126280] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6289), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6291), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [126329] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_const,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(7313), 1,
      anon_sym_STAR,
    ACTIONS(7315), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7317), 1,
      anon_sym_AMP,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(7606), 1,
      sym_auto,
    ACTIONS(7608), 1,
      anon_sym_decltype,
    STATE(3325), 1,
      sym_parameter_list,
    STATE(5016), 1,
      sym_decltype_auto,
    STATE(5965), 1,
      sym__abstract_declarator,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(4428), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7526), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7319), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [126406] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6299), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6301), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [126455] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6907), 1,
      anon_sym_LT,
    STATE(1741), 1,
      sym_template_argument_list,
    ACTIONS(5187), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(3785), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [126510] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7610), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7612), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7614), 1,
      anon_sym_or,
    ACTIONS(7616), 1,
      anon_sym_and,
    ACTIONS(5428), 15,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5430), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [126567] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6953), 1,
      anon_sym_const,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7270), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    ACTIONS(7618), 1,
      anon_sym_STAR,
    ACTIONS(7620), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7622), 1,
      anon_sym_AMP,
    STATE(3909), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(3964), 1,
      sym_parameter_list,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(6347), 1,
      sym__abstract_declarator,
    ACTIONS(7272), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7274), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4177), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4851), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5513), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6945), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [126648] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7624), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7626), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(5428), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(5430), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [126701] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(57), 1,
      anon_sym___inline,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7438), 1,
      anon_sym___declspec,
    ACTIONS(7444), 1,
      anon_sym_virtual,
    ACTIONS(7446), 1,
      anon_sym_alignas,
    ACTIONS(6057), 2,
      anon_sym_AMP,
      anon_sym_LBRACK,
    ACTIONS(6059), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(7436), 8,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    STATE(4161), 9,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      sym_virtual,
      sym_alignas_specifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(6915), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [126770] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7612), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7616), 1,
      anon_sym_and,
    ACTIONS(5477), 16,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5479), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [126823] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6907), 1,
      anon_sym_LT,
    STATE(1741), 1,
      sym_template_argument_list,
    ACTIONS(4534), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(4541), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [126878] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5201), 1,
      sym_literal_suffix,
    ACTIONS(3769), 15,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(3761), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [126929] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5201), 1,
      sym_literal_suffix,
    ACTIONS(5197), 15,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(5199), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [126980] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4543), 1,
      anon_sym_LBRACK,
    ACTIONS(6103), 1,
      anon_sym_LT,
    STATE(4271), 1,
      sym_template_argument_list,
    ACTIONS(4538), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4541), 3,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
    ACTIONS(4534), 32,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_operator,
  [127039] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6953), 1,
      anon_sym_const,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7270), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    ACTIONS(7618), 1,
      anon_sym_STAR,
    ACTIONS(7620), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7622), 1,
      anon_sym_AMP,
    STATE(3909), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(3964), 1,
      sym_parameter_list,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(6366), 1,
      sym__abstract_declarator,
    ACTIONS(7272), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7274), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3616), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4842), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5555), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6945), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [127120] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(3803), 1,
      anon_sym_LPAREN2,
    ACTIONS(5511), 1,
      sym_identifier,
    ACTIONS(5515), 1,
      anon_sym_STAR,
    ACTIONS(5517), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5519), 1,
      anon_sym_AMP,
    ACTIONS(5521), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5523), 1,
      anon_sym_LBRACK,
    STATE(3343), 1,
      sym_parameter_list,
    STATE(5695), 1,
      sym__scope_resolution,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6149), 1,
      sym__declarator,
    STATE(6283), 1,
      sym__abstract_declarator,
    STATE(7771), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(7524), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_GT2,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [127209] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7570), 1,
      anon_sym_COMMA,
    ACTIONS(7576), 1,
      anon_sym_SLASH,
    ACTIONS(7582), 1,
      anon_sym_PIPE,
    ACTIONS(7586), 1,
      anon_sym_AMP,
    ACTIONS(7592), 1,
      anon_sym_GT_EQ,
    ACTIONS(7598), 1,
      anon_sym_QMARK,
    ACTIONS(7600), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7602), 1,
      anon_sym_bitor,
    ACTIONS(7604), 1,
      anon_sym_bitand,
    ACTIONS(7628), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    STATE(6547), 1,
      aux_sym_field_declaration_repeat1,
    STATE(7777), 1,
      sym_attribute_specifier,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7578), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7580), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7584), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7594), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7588), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7590), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [127312] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6907), 1,
      anon_sym_LT,
    STATE(1741), 1,
      sym_template_argument_list,
    STATE(4471), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3759), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(7630), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3767), 29,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [127371] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(7634), 2,
      anon_sym_AMP,
      anon_sym_LBRACK,
    STATE(4640), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4643), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5679), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6915), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
    ACTIONS(7632), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [127430] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_const,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(7313), 1,
      anon_sym_STAR,
    ACTIONS(7315), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7317), 1,
      anon_sym_AMP,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(7606), 1,
      sym_auto,
    ACTIONS(7608), 1,
      anon_sym_decltype,
    STATE(3325), 1,
      sym_parameter_list,
    STATE(5016), 1,
      sym_decltype_auto,
    STATE(5949), 1,
      sym__abstract_declarator,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(4350), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7537), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7319), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [127507] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7570), 1,
      anon_sym_COMMA,
    ACTIONS(7576), 1,
      anon_sym_SLASH,
    ACTIONS(7582), 1,
      anon_sym_PIPE,
    ACTIONS(7586), 1,
      anon_sym_AMP,
    ACTIONS(7592), 1,
      anon_sym_GT_EQ,
    ACTIONS(7598), 1,
      anon_sym_QMARK,
    ACTIONS(7600), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7602), 1,
      anon_sym_bitor,
    ACTIONS(7604), 1,
      anon_sym_bitand,
    ACTIONS(7636), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    STATE(6583), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8311), 1,
      sym_attribute_specifier,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7578), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7580), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7584), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7594), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7588), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7590), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [127610] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7626), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(5477), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(5479), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [127661] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6103), 1,
      anon_sym_LT,
    STATE(1741), 1,
      sym_template_argument_list,
    STATE(4471), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5303), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(7630), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5305), 29,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [127720] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7286), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(7284), 28,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [127769] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5724), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5726), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [127845] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(7652), 1,
      sym_identifier,
    ACTIONS(7654), 1,
      anon_sym_LPAREN2,
    ACTIONS(7656), 1,
      anon_sym_STAR,
    ACTIONS(7658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7660), 1,
      anon_sym_AMP,
    STATE(4186), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6012), 1,
      sym__field_declarator,
    STATE(6201), 1,
      sym_operator_name,
    STATE(8292), 1,
      sym_ms_based_modifier,
    ACTIONS(2921), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4100), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4943), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2919), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(6227), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [127923] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(7654), 1,
      anon_sym_LPAREN2,
    ACTIONS(7662), 1,
      sym_identifier,
    ACTIONS(7664), 1,
      anon_sym_STAR,
    ACTIONS(7666), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7668), 1,
      anon_sym_AMP,
    STATE(4186), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6421), 1,
      sym__field_declarator,
    STATE(6495), 1,
      sym_operator_name,
    STATE(7783), 1,
      sym_ms_based_modifier,
    ACTIONS(2921), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4100), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4922), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2919), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(6227), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [128001] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5724), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(5726), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
  [128079] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    ACTIONS(7420), 1,
      anon_sym_STAR,
    ACTIONS(7422), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7424), 1,
      anon_sym_AMP,
    ACTIONS(7440), 1,
      sym_auto,
    ACTIONS(7442), 1,
      anon_sym_decltype,
    STATE(2655), 1,
      sym_decltype_auto,
    STATE(3657), 1,
      sym_parameter_list,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(6136), 1,
      sym__abstract_declarator,
    STATE(4574), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7526), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(6915), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [128155] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4221), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4766), 4,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
    ACTIONS(7672), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5139), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5142), 21,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [128209] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(5936), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [128303] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(7652), 1,
      sym_identifier,
    ACTIONS(7654), 1,
      anon_sym_LPAREN2,
    ACTIONS(7656), 1,
      anon_sym_STAR,
    ACTIONS(7658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7660), 1,
      anon_sym_AMP,
    STATE(4186), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5913), 1,
      sym__field_declarator,
    STATE(6201), 1,
      sym_operator_name,
    STATE(8292), 1,
      sym_ms_based_modifier,
    ACTIONS(2921), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4100), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4916), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2919), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(6227), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [128381] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(5726), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_or,
  [128469] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(7691), 1,
      anon_sym_STAR,
    ACTIONS(7693), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7695), 1,
      anon_sym_AMP,
    ACTIONS(7699), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7705), 1,
      anon_sym_const,
    STATE(3980), 1,
      sym_parameter_list,
    STATE(5201), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6411), 1,
      sym__abstract_declarator,
    ACTIONS(7701), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7703), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4924), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5002), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(5555), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7697), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [128549] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(7691), 1,
      anon_sym_STAR,
    ACTIONS(7693), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7695), 1,
      anon_sym_AMP,
    ACTIONS(7699), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7705), 1,
      anon_sym_const,
    STATE(3980), 1,
      sym_parameter_list,
    STATE(5201), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6392), 1,
      sym__abstract_declarator,
    ACTIONS(7701), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7703), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4196), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4921), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5513), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7697), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [128629] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5724), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5726), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [128701] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(7652), 1,
      sym_identifier,
    ACTIONS(7654), 1,
      anon_sym_LPAREN2,
    ACTIONS(7656), 1,
      anon_sym_STAR,
    ACTIONS(7658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7660), 1,
      anon_sym_AMP,
    STATE(4186), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5913), 1,
      sym__field_declarator,
    STATE(6201), 1,
      sym_operator_name,
    STATE(8292), 1,
      sym_ms_based_modifier,
    ACTIONS(2921), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4188), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4916), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2919), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(6227), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [128779] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6250), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
  [128869] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5724), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5726), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [128937] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5724), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5726), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [129007] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5724), 7,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5726), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [129073] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(7654), 1,
      anon_sym_LPAREN2,
    ACTIONS(7662), 1,
      sym_identifier,
    ACTIONS(7664), 1,
      anon_sym_STAR,
    ACTIONS(7666), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7668), 1,
      anon_sym_AMP,
    STATE(4186), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6404), 1,
      sym__field_declarator,
    STATE(6495), 1,
      sym_operator_name,
    STATE(7783), 1,
      sym_ms_based_modifier,
    ACTIONS(2921), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4189), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4934), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2919), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(6227), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [129151] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7709), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7707), 34,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_template,
      anon_sym_operator,
  [129199] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(5726), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
  [129285] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_const,
    ACTIONS(2919), 1,
      sym_ms_restrict_modifier,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(7711), 1,
      anon_sym_STAR,
    ACTIONS(7713), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7715), 1,
      anon_sym_AMP,
    STATE(3343), 1,
      sym_parameter_list,
    STATE(4186), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6285), 1,
      sym__abstract_declarator,
    ACTIONS(7321), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7323), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4212), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4920), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5513), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7319), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [129365] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6246), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [129459] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(7652), 1,
      sym_identifier,
    ACTIONS(7654), 1,
      anon_sym_LPAREN2,
    ACTIONS(7656), 1,
      anon_sym_STAR,
    ACTIONS(7658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7660), 1,
      anon_sym_AMP,
    STATE(4186), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5978), 1,
      sym__field_declarator,
    STATE(6201), 1,
      sym_operator_name,
    STATE(8292), 1,
      sym_ms_based_modifier,
    ACTIONS(2921), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4194), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4907), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2919), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(6227), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [129537] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4922), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4926), 5,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4924), 34,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_template,
      anon_sym_operator,
  [129587] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6271), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
  [129677] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_const,
    ACTIONS(2919), 1,
      sym_ms_restrict_modifier,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(7711), 1,
      anon_sym_STAR,
    ACTIONS(7713), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7715), 1,
      anon_sym_AMP,
    STATE(3343), 1,
      sym_parameter_list,
    STATE(4186), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6287), 1,
      sym__abstract_declarator,
    ACTIONS(7321), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7323), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4100), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4932), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5555), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7319), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [129757] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(5724), 1,
      anon_sym_PIPE,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(5726), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
  [129841] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7719), 1,
      anon_sym_LPAREN2,
    ACTIONS(7721), 5,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7717), 34,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_explicit,
      anon_sym_template,
      anon_sym_operator,
  [129891] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(5724), 1,
      anon_sym_PIPE,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(5726), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
  [129973] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6242), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
  [130063] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6220), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [130157] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6953), 1,
      anon_sym_const,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    ACTIONS(7365), 1,
      anon_sym_STAR,
    ACTIONS(7367), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7369), 1,
      anon_sym_AMP,
    ACTIONS(7528), 1,
      sym_auto,
    ACTIONS(7530), 1,
      anon_sym_decltype,
    STATE(3569), 1,
      sym_parameter_list,
    STATE(4894), 1,
      sym_decltype_auto,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(6072), 1,
      sym__abstract_declarator,
    STATE(4614), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7537), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6945), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [130233] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6258), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
  [130323] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(7654), 1,
      anon_sym_LPAREN2,
    ACTIONS(7662), 1,
      sym_identifier,
    ACTIONS(7664), 1,
      anon_sym_STAR,
    ACTIONS(7666), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7668), 1,
      anon_sym_AMP,
    STATE(4186), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6419), 1,
      sym__field_declarator,
    STATE(6495), 1,
      sym_operator_name,
    STATE(7783), 1,
      sym_ms_based_modifier,
    ACTIONS(2921), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4100), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4909), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2919), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(6227), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [130401] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4221), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7672), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4768), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4766), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [130453] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    ACTIONS(7420), 1,
      anon_sym_STAR,
    ACTIONS(7422), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7424), 1,
      anon_sym_AMP,
    ACTIONS(7440), 1,
      sym_auto,
    ACTIONS(7442), 1,
      anon_sym_decltype,
    STATE(2655), 1,
      sym_decltype_auto,
    STATE(3657), 1,
      sym_parameter_list,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(6113), 1,
      sym__abstract_declarator,
    STATE(4525), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7537), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(6915), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [130529] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(7723), 1,
      anon_sym_COMMA,
    ACTIONS(7725), 1,
      anon_sym_SEMI,
    ACTIONS(7727), 1,
      anon_sym_RBRACE,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    STATE(6889), 1,
      aux_sym_initializer_list_repeat1,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [130629] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(7654), 1,
      anon_sym_LPAREN2,
    ACTIONS(7662), 1,
      sym_identifier,
    ACTIONS(7664), 1,
      anon_sym_STAR,
    ACTIONS(7666), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7668), 1,
      anon_sym_AMP,
    STATE(4186), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6421), 1,
      sym__field_declarator,
    STATE(6495), 1,
      sym_operator_name,
    STATE(7783), 1,
      sym_ms_based_modifier,
    ACTIONS(2921), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4220), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4922), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2919), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(6227), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [130707] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6953), 1,
      anon_sym_const,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    ACTIONS(7365), 1,
      anon_sym_STAR,
    ACTIONS(7367), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7369), 1,
      anon_sym_AMP,
    ACTIONS(7528), 1,
      sym_auto,
    ACTIONS(7530), 1,
      anon_sym_decltype,
    STATE(3569), 1,
      sym_parameter_list,
    STATE(4894), 1,
      sym_decltype_auto,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(6063), 1,
      sym__abstract_declarator,
    STATE(4530), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7526), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6945), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [130783] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1961), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(1959), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [130830] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4739), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4741), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [130877] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(7729), 1,
      anon_sym_COMMA,
    ACTIONS(7731), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    STATE(6946), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [130974] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(7729), 1,
      anon_sym_COMMA,
    ACTIONS(7733), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    STATE(7186), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [131071] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(7735), 1,
      anon_sym_COMMA,
    ACTIONS(7737), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    STATE(7077), 1,
      aux_sym_generic_expression_repeat1,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [131168] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(3803), 1,
      anon_sym_LPAREN2,
    ACTIONS(5511), 1,
      sym_identifier,
    ACTIONS(5521), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5523), 1,
      anon_sym_LBRACK,
    ACTIONS(5708), 1,
      anon_sym_STAR,
    ACTIONS(5710), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5712), 1,
      anon_sym_AMP,
    STATE(3830), 1,
      sym_parameter_list,
    STATE(5695), 1,
      sym__scope_resolution,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6149), 1,
      sym__declarator,
    STATE(6466), 1,
      sym__abstract_declarator,
    STATE(7771), 1,
      sym_ms_based_modifier,
    ACTIONS(7524), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [131255] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(7729), 1,
      anon_sym_COMMA,
    ACTIONS(7739), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    STATE(7069), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [131352] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7576), 1,
      anon_sym_SLASH,
    ACTIONS(7582), 1,
      anon_sym_PIPE,
    ACTIONS(7586), 1,
      anon_sym_AMP,
    ACTIONS(7592), 1,
      anon_sym_GT_EQ,
    ACTIONS(7598), 1,
      anon_sym_QMARK,
    ACTIONS(7600), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7602), 1,
      anon_sym_bitor,
    ACTIONS(7604), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7578), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7580), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7584), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7594), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6246), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
    ACTIONS(7588), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7590), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [131445] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7576), 1,
      anon_sym_SLASH,
    ACTIONS(7582), 1,
      anon_sym_PIPE,
    ACTIONS(7586), 1,
      anon_sym_AMP,
    ACTIONS(7592), 1,
      anon_sym_GT_EQ,
    ACTIONS(7600), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7602), 1,
      anon_sym_bitor,
    ACTIONS(7604), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7578), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7580), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7584), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7594), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7588), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7590), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6271), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
  [131534] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(7725), 1,
      anon_sym_SEMI,
    ACTIONS(7741), 1,
      anon_sym_COMMA,
    ACTIONS(7744), 1,
      anon_sym_RBRACE,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [131631] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(7746), 1,
      anon_sym_COMMA,
    ACTIONS(7749), 1,
      anon_sym_SEMI,
    ACTIONS(7751), 1,
      anon_sym_RBRACE,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [131728] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6953), 1,
      anon_sym_const,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7264), 1,
      anon_sym_STAR,
    ACTIONS(7266), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7268), 1,
      anon_sym_AMP,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    STATE(3638), 1,
      sym_parameter_list,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(5902), 1,
      sym__abstract_declarator,
    STATE(4650), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6297), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(6945), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [131797] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7576), 1,
      anon_sym_SLASH,
    ACTIONS(7582), 1,
      anon_sym_PIPE,
    ACTIONS(7586), 1,
      anon_sym_AMP,
    ACTIONS(7592), 1,
      anon_sym_GT_EQ,
    ACTIONS(7600), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7602), 1,
      anon_sym_bitor,
    ACTIONS(7604), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7578), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7580), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7584), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7594), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7588), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7590), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6242), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
  [131886] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6953), 1,
      anon_sym_const,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7264), 1,
      anon_sym_STAR,
    ACTIONS(7266), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7268), 1,
      anon_sym_AMP,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    STATE(3638), 1,
      sym_parameter_list,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(5903), 1,
      sym__abstract_declarator,
    STATE(4650), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7753), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(6945), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [131955] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    ACTIONS(7755), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(7763), 1,
      anon_sym_SLASH,
    ACTIONS(7769), 1,
      anon_sym_PIPE,
    ACTIONS(7773), 1,
      anon_sym_AMP,
    ACTIONS(7779), 1,
      anon_sym_LT_LT,
    ACTIONS(7781), 1,
      anon_sym_GT_GT,
    ACTIONS(7783), 1,
      anon_sym_QMARK,
    ACTIONS(7785), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7787), 1,
      anon_sym_bitor,
    ACTIONS(7789), 1,
      anon_sym_bitand,
    ACTIONS(7793), 1,
      anon_sym_GT2,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    STATE(7012), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7759), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7761), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7765), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7767), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7771), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7791), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7775), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7777), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [132052] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6953), 1,
      anon_sym_const,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7264), 1,
      anon_sym_STAR,
    ACTIONS(7266), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7268), 1,
      anon_sym_AMP,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    STATE(3638), 1,
      sym_parameter_list,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(5905), 1,
      sym__abstract_declarator,
    STATE(4650), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5555), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(6945), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [132121] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    ACTIONS(7278), 1,
      anon_sym_STAR,
    ACTIONS(7280), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7282), 1,
      anon_sym_AMP,
    STATE(3617), 1,
      sym_parameter_list,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(5894), 1,
      sym__abstract_declarator,
    STATE(4424), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7753), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6915), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [132190] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6953), 1,
      anon_sym_const,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7264), 1,
      anon_sym_STAR,
    ACTIONS(7266), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7268), 1,
      anon_sym_AMP,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    STATE(3638), 1,
      sym_parameter_list,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(5890), 1,
      sym__abstract_declarator,
    STATE(4650), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7795), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(6945), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [132259] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7576), 1,
      anon_sym_SLASH,
    ACTIONS(7582), 1,
      anon_sym_PIPE,
    ACTIONS(7586), 1,
      anon_sym_AMP,
    ACTIONS(7592), 1,
      anon_sym_GT_EQ,
    ACTIONS(7600), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7602), 1,
      anon_sym_bitor,
    ACTIONS(7604), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7578), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7580), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7584), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7594), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7588), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7590), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6250), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
  [132348] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(7735), 1,
      anon_sym_COMMA,
    ACTIONS(7797), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    STATE(7097), 1,
      aux_sym_generic_expression_repeat1,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [132445] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    ACTIONS(7278), 1,
      anon_sym_STAR,
    ACTIONS(7280), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7282), 1,
      anon_sym_AMP,
    STATE(3617), 1,
      sym_parameter_list,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(5896), 1,
      sym__abstract_declarator,
    STATE(4424), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6297), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6915), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [132514] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(7801), 1,
      anon_sym_RBRACE,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    STATE(6965), 1,
      aux_sym_initializer_list_repeat1,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [132611] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    ACTIONS(7755), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(7763), 1,
      anon_sym_SLASH,
    ACTIONS(7769), 1,
      anon_sym_PIPE,
    ACTIONS(7773), 1,
      anon_sym_AMP,
    ACTIONS(7779), 1,
      anon_sym_LT_LT,
    ACTIONS(7781), 1,
      anon_sym_GT_GT,
    ACTIONS(7783), 1,
      anon_sym_QMARK,
    ACTIONS(7785), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7787), 1,
      anon_sym_bitor,
    ACTIONS(7789), 1,
      anon_sym_bitand,
    ACTIONS(7803), 1,
      anon_sym_GT2,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    STATE(6969), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7759), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7761), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7765), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7767), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7771), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7791), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7775), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7777), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [132708] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7576), 1,
      anon_sym_SLASH,
    ACTIONS(7582), 1,
      anon_sym_PIPE,
    ACTIONS(7586), 1,
      anon_sym_AMP,
    ACTIONS(7592), 1,
      anon_sym_GT_EQ,
    ACTIONS(7598), 1,
      anon_sym_QMARK,
    ACTIONS(7600), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7602), 1,
      anon_sym_bitor,
    ACTIONS(7604), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7578), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7580), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7584), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7594), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7588), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7590), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7805), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [132801] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7807), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7809), 1,
      anon_sym_COMMA,
    ACTIONS(7815), 1,
      anon_sym_SLASH,
    ACTIONS(7821), 1,
      anon_sym_PIPE,
    ACTIONS(7825), 1,
      anon_sym_AMP,
    ACTIONS(7831), 1,
      anon_sym_GT_EQ,
    ACTIONS(7835), 1,
      anon_sym_RBRACK,
    ACTIONS(7837), 1,
      anon_sym_QMARK,
    ACTIONS(7839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7841), 1,
      anon_sym_bitor,
    ACTIONS(7843), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    STATE(7197), 1,
      aux_sym_lambda_capture_specifier_repeat1,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [132898] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1607), 1,
      sym__fold_operator,
    ACTIONS(7847), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(7845), 25,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [132947] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_const,
    ACTIONS(2919), 1,
      sym_ms_restrict_modifier,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(4520), 1,
      anon_sym_STAR,
    ACTIONS(4522), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4524), 1,
      anon_sym_AMP,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(4186), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6435), 1,
      sym__abstract_declarator,
    ACTIONS(7321), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7323), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4100), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4966), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5555), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7319), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [133026] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6859), 1,
      anon_sym_COMMA,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(7849), 1,
      anon_sym_RPAREN,
    ACTIONS(7851), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [133123] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(7735), 1,
      anon_sym_COMMA,
    ACTIONS(7853), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    STATE(6966), 1,
      aux_sym_generic_expression_repeat1,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [133220] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(3803), 1,
      anon_sym_LPAREN2,
    ACTIONS(5511), 1,
      sym_identifier,
    ACTIONS(5521), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5523), 1,
      anon_sym_LBRACK,
    ACTIONS(5740), 1,
      anon_sym_STAR,
    ACTIONS(5742), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5744), 1,
      anon_sym_AMP,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(5695), 1,
      sym__scope_resolution,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6149), 1,
      sym__declarator,
    STATE(6482), 1,
      sym__abstract_declarator,
    STATE(7771), 1,
      sym_ms_based_modifier,
    ACTIONS(7524), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [133307] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(7857), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7855), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [133402] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7815), 1,
      anon_sym_SLASH,
    ACTIONS(7821), 1,
      anon_sym_PIPE,
    ACTIONS(7825), 1,
      anon_sym_AMP,
    ACTIONS(7831), 1,
      anon_sym_GT_EQ,
    ACTIONS(7837), 1,
      anon_sym_QMARK,
    ACTIONS(7839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7841), 1,
      anon_sym_bitor,
    ACTIONS(7843), 1,
      anon_sym_bitand,
    ACTIONS(7859), 1,
      anon_sym_COMMA,
    ACTIONS(7861), 1,
      anon_sym_RBRACK,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    STATE(7024), 1,
      aux_sym_subscript_argument_list_repeat1,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [133499] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    ACTIONS(7755), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(7763), 1,
      anon_sym_SLASH,
    ACTIONS(7769), 1,
      anon_sym_PIPE,
    ACTIONS(7773), 1,
      anon_sym_AMP,
    ACTIONS(7779), 1,
      anon_sym_LT_LT,
    ACTIONS(7781), 1,
      anon_sym_GT_GT,
    ACTIONS(7783), 1,
      anon_sym_QMARK,
    ACTIONS(7785), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7787), 1,
      anon_sym_bitor,
    ACTIONS(7789), 1,
      anon_sym_bitand,
    ACTIONS(7863), 1,
      anon_sym_GT2,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    STATE(7211), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7759), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7761), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7765), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7767), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7771), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7791), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7775), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7777), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [133596] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7576), 1,
      anon_sym_SLASH,
    ACTIONS(7582), 1,
      anon_sym_PIPE,
    ACTIONS(7586), 1,
      anon_sym_AMP,
    ACTIONS(7592), 1,
      anon_sym_GT_EQ,
    ACTIONS(7598), 1,
      anon_sym_QMARK,
    ACTIONS(7600), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7602), 1,
      anon_sym_bitor,
    ACTIONS(7604), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7578), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7580), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7584), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7594), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7588), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7590), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7865), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [133689] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(7729), 1,
      anon_sym_COMMA,
    ACTIONS(7867), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    STATE(6986), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [133786] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(7869), 1,
      anon_sym_COMMA,
    ACTIONS(7871), 1,
      anon_sym_RBRACE,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    STATE(7224), 1,
      aux_sym_initializer_list_repeat1,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [133883] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(7729), 1,
      anon_sym_COMMA,
    ACTIONS(7873), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    STATE(7242), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [133980] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(7727), 1,
      anon_sym_RBRACE,
    ACTIONS(7875), 1,
      anon_sym_COMMA,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    STATE(6889), 1,
      aux_sym_initializer_list_repeat1,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [134077] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7576), 1,
      anon_sym_SLASH,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7594), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5724), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5726), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [134146] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    ACTIONS(7430), 1,
      anon_sym_STAR,
    ACTIONS(7432), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7434), 1,
      anon_sym_AMP,
    ACTIONS(7440), 1,
      sym_auto,
    ACTIONS(7442), 1,
      anon_sym_decltype,
    STATE(2655), 1,
      sym_decltype_auto,
    STATE(3784), 1,
      sym_parameter_list,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(6186), 1,
      sym__abstract_declarator,
    STATE(4730), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7537), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6915), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [134221] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(7729), 1,
      anon_sym_COMMA,
    ACTIONS(7877), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    STATE(6974), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [134318] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7576), 1,
      anon_sym_SLASH,
    ACTIONS(7582), 1,
      anon_sym_PIPE,
    ACTIONS(7586), 1,
      anon_sym_AMP,
    ACTIONS(7592), 1,
      anon_sym_GT_EQ,
    ACTIONS(7598), 1,
      anon_sym_QMARK,
    ACTIONS(7600), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7602), 1,
      anon_sym_bitor,
    ACTIONS(7604), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7578), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7580), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7584), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7594), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6220), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
    ACTIONS(7588), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7590), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [134411] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7576), 1,
      anon_sym_SLASH,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5724), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5726), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [134478] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7576), 1,
      anon_sym_SLASH,
    ACTIONS(7600), 1,
      anon_sym_LT_EQ_GT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7594), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5724), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5726), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [134549] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7576), 1,
      anon_sym_SLASH,
    ACTIONS(7592), 1,
      anon_sym_GT_EQ,
    ACTIONS(7600), 1,
      anon_sym_LT_EQ_GT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5724), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7594), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7590), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5726), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [134624] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4584), 1,
      anon_sym_LBRACK,
    ACTIONS(4579), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4582), 4,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
    ACTIONS(4575), 32,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_alignas,
      anon_sym_operator,
  [134675] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7576), 1,
      anon_sym_SLASH,
    ACTIONS(7592), 1,
      anon_sym_GT_EQ,
    ACTIONS(7600), 1,
      anon_sym_LT_EQ_GT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5724), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7594), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7588), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7590), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5726), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
  [134752] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(5724), 1,
      anon_sym_PIPE,
    ACTIONS(7576), 1,
      anon_sym_SLASH,
    ACTIONS(7586), 1,
      anon_sym_AMP,
    ACTIONS(7592), 1,
      anon_sym_GT_EQ,
    ACTIONS(7600), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7604), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7594), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7588), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7590), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5726), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
  [134833] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(5724), 1,
      anon_sym_PIPE,
    ACTIONS(7576), 1,
      anon_sym_SLASH,
    ACTIONS(7586), 1,
      anon_sym_AMP,
    ACTIONS(7592), 1,
      anon_sym_GT_EQ,
    ACTIONS(7600), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7604), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7584), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7594), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7588), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7590), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5726), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
  [134916] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7576), 1,
      anon_sym_SLASH,
    ACTIONS(7582), 1,
      anon_sym_PIPE,
    ACTIONS(7586), 1,
      anon_sym_AMP,
    ACTIONS(7592), 1,
      anon_sym_GT_EQ,
    ACTIONS(7600), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7602), 1,
      anon_sym_bitor,
    ACTIONS(7604), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7584), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7594), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7588), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7590), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5726), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
  [135001] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7576), 1,
      anon_sym_SLASH,
    ACTIONS(7582), 1,
      anon_sym_PIPE,
    ACTIONS(7586), 1,
      anon_sym_AMP,
    ACTIONS(7592), 1,
      anon_sym_GT_EQ,
    ACTIONS(7600), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7602), 1,
      anon_sym_bitor,
    ACTIONS(7604), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7580), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7584), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7594), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7588), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7590), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5726), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_or,
  [135088] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    ACTIONS(7755), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(7763), 1,
      anon_sym_SLASH,
    ACTIONS(7769), 1,
      anon_sym_PIPE,
    ACTIONS(7773), 1,
      anon_sym_AMP,
    ACTIONS(7779), 1,
      anon_sym_LT_LT,
    ACTIONS(7781), 1,
      anon_sym_GT_GT,
    ACTIONS(7783), 1,
      anon_sym_QMARK,
    ACTIONS(7785), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7787), 1,
      anon_sym_bitor,
    ACTIONS(7789), 1,
      anon_sym_bitand,
    ACTIONS(7879), 1,
      anon_sym_GT2,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    STATE(7152), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7759), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7761), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7765), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7767), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7771), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7791), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7775), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7777), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [135185] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7809), 1,
      anon_sym_COMMA,
    ACTIONS(7815), 1,
      anon_sym_SLASH,
    ACTIONS(7821), 1,
      anon_sym_PIPE,
    ACTIONS(7825), 1,
      anon_sym_AMP,
    ACTIONS(7831), 1,
      anon_sym_GT_EQ,
    ACTIONS(7837), 1,
      anon_sym_QMARK,
    ACTIONS(7839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7841), 1,
      anon_sym_bitor,
    ACTIONS(7843), 1,
      anon_sym_bitand,
    ACTIONS(7881), 1,
      anon_sym_RBRACK,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    STATE(6900), 1,
      aux_sym_lambda_capture_specifier_repeat1,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [135282] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    ACTIONS(7278), 1,
      anon_sym_STAR,
    ACTIONS(7280), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7282), 1,
      anon_sym_AMP,
    STATE(3617), 1,
      sym_parameter_list,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(5908), 1,
      sym__abstract_declarator,
    STATE(4424), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7795), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6915), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [135351] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7815), 1,
      anon_sym_SLASH,
    ACTIONS(7821), 1,
      anon_sym_PIPE,
    ACTIONS(7825), 1,
      anon_sym_AMP,
    ACTIONS(7831), 1,
      anon_sym_GT_EQ,
    ACTIONS(7837), 1,
      anon_sym_QMARK,
    ACTIONS(7839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7841), 1,
      anon_sym_bitor,
    ACTIONS(7843), 1,
      anon_sym_bitand,
    ACTIONS(7859), 1,
      anon_sym_COMMA,
    ACTIONS(7883), 1,
      anon_sym_RBRACK,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    STATE(6994), 1,
      aux_sym_subscript_argument_list_repeat1,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [135448] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7576), 1,
      anon_sym_SLASH,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5724), 7,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5726), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [135513] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(7729), 1,
      anon_sym_COMMA,
    ACTIONS(7885), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    STATE(6985), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [135610] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7809), 1,
      anon_sym_COMMA,
    ACTIONS(7815), 1,
      anon_sym_SLASH,
    ACTIONS(7821), 1,
      anon_sym_PIPE,
    ACTIONS(7825), 1,
      anon_sym_AMP,
    ACTIONS(7831), 1,
      anon_sym_GT_EQ,
    ACTIONS(7837), 1,
      anon_sym_QMARK,
    ACTIONS(7839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7841), 1,
      anon_sym_bitor,
    ACTIONS(7843), 1,
      anon_sym_bitand,
    ACTIONS(7887), 1,
      anon_sym_RBRACK,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    STATE(7197), 1,
      aux_sym_lambda_capture_specifier_repeat1,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [135707] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6953), 1,
      anon_sym_const,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    ACTIONS(7292), 1,
      anon_sym_STAR,
    ACTIONS(7294), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7296), 1,
      anon_sym_AMP,
    STATE(3360), 1,
      sym_parameter_list,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(5868), 1,
      sym__abstract_declarator,
    STATE(4650), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6297), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6945), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [135776] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4707), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4709), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [135823] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    ACTIONS(7755), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(7763), 1,
      anon_sym_SLASH,
    ACTIONS(7769), 1,
      anon_sym_PIPE,
    ACTIONS(7773), 1,
      anon_sym_AMP,
    ACTIONS(7779), 1,
      anon_sym_LT_LT,
    ACTIONS(7781), 1,
      anon_sym_GT_GT,
    ACTIONS(7783), 1,
      anon_sym_QMARK,
    ACTIONS(7785), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7787), 1,
      anon_sym_bitor,
    ACTIONS(7789), 1,
      anon_sym_bitand,
    ACTIONS(7889), 1,
      anon_sym_GT2,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    STATE(7037), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7759), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7761), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7765), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7767), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7771), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7791), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7775), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7777), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [135920] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(7891), 1,
      anon_sym_COMMA,
    ACTIONS(7893), 1,
      anon_sym_RBRACE,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    STATE(7055), 1,
      aux_sym_initializer_list_repeat1,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [136017] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    ACTIONS(7755), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(7763), 1,
      anon_sym_SLASH,
    ACTIONS(7769), 1,
      anon_sym_PIPE,
    ACTIONS(7773), 1,
      anon_sym_AMP,
    ACTIONS(7779), 1,
      anon_sym_LT_LT,
    ACTIONS(7781), 1,
      anon_sym_GT_GT,
    ACTIONS(7783), 1,
      anon_sym_QMARK,
    ACTIONS(7785), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7787), 1,
      anon_sym_bitor,
    ACTIONS(7789), 1,
      anon_sym_bitand,
    ACTIONS(7895), 1,
      anon_sym_GT2,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    STATE(7007), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7759), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7761), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7765), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7767), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7771), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7791), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7775), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7777), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [136114] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(7729), 1,
      anon_sym_COMMA,
    ACTIONS(7897), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    STATE(7141), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [136211] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4695), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4697), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [136258] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(7729), 1,
      anon_sym_COMMA,
    ACTIONS(7899), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    STATE(6955), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [136355] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(7735), 1,
      anon_sym_COMMA,
    ACTIONS(7901), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    STATE(7015), 1,
      aux_sym_generic_expression_repeat1,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [136452] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6103), 1,
      anon_sym_LT,
    STATE(1741), 1,
      sym_template_argument_list,
    STATE(4729), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5303), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(7903), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5305), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [136509] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7576), 1,
      anon_sym_SLASH,
    ACTIONS(7582), 1,
      anon_sym_PIPE,
    ACTIONS(7586), 1,
      anon_sym_AMP,
    ACTIONS(7592), 1,
      anon_sym_GT_EQ,
    ACTIONS(7598), 1,
      anon_sym_QMARK,
    ACTIONS(7600), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7602), 1,
      anon_sym_bitor,
    ACTIONS(7604), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7578), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7580), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7584), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7594), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5936), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
    ACTIONS(7588), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7590), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [136602] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(7729), 1,
      anon_sym_COMMA,
    ACTIONS(7905), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    STATE(6876), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [136699] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    ACTIONS(7755), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(7763), 1,
      anon_sym_SLASH,
    ACTIONS(7769), 1,
      anon_sym_PIPE,
    ACTIONS(7773), 1,
      anon_sym_AMP,
    ACTIONS(7779), 1,
      anon_sym_LT_LT,
    ACTIONS(7781), 1,
      anon_sym_GT_GT,
    ACTIONS(7783), 1,
      anon_sym_QMARK,
    ACTIONS(7785), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7787), 1,
      anon_sym_bitor,
    ACTIONS(7789), 1,
      anon_sym_bitand,
    ACTIONS(7907), 1,
      anon_sym_GT2,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    STATE(6928), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7759), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7761), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7765), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7767), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7771), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7791), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7775), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7777), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [136796] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4727), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4729), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [136843] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6859), 1,
      anon_sym_COMMA,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7749), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [136938] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(7735), 1,
      anon_sym_COMMA,
    ACTIONS(7909), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    STATE(7139), 1,
      aux_sym_generic_expression_repeat1,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [137035] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4691), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4693), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [137082] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(7729), 1,
      anon_sym_COMMA,
    ACTIONS(7911), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    STATE(6864), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [137179] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    ACTIONS(7755), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(7763), 1,
      anon_sym_SLASH,
    ACTIONS(7769), 1,
      anon_sym_PIPE,
    ACTIONS(7773), 1,
      anon_sym_AMP,
    ACTIONS(7779), 1,
      anon_sym_LT_LT,
    ACTIONS(7781), 1,
      anon_sym_GT_GT,
    ACTIONS(7783), 1,
      anon_sym_QMARK,
    ACTIONS(7785), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7787), 1,
      anon_sym_bitor,
    ACTIONS(7789), 1,
      anon_sym_bitand,
    ACTIONS(7913), 1,
      anon_sym_GT2,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    STATE(6947), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7759), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7761), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7765), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7767), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7771), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7791), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7775), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7777), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [137276] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    ACTIONS(7755), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(7763), 1,
      anon_sym_SLASH,
    ACTIONS(7769), 1,
      anon_sym_PIPE,
    ACTIONS(7773), 1,
      anon_sym_AMP,
    ACTIONS(7779), 1,
      anon_sym_LT_LT,
    ACTIONS(7781), 1,
      anon_sym_GT_GT,
    ACTIONS(7783), 1,
      anon_sym_QMARK,
    ACTIONS(7785), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7787), 1,
      anon_sym_bitor,
    ACTIONS(7789), 1,
      anon_sym_bitand,
    ACTIONS(7915), 1,
      anon_sym_GT2,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    STATE(7081), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7759), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7761), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7765), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7767), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7771), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7791), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7775), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7777), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [137373] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4691), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4693), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [137420] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6953), 1,
      anon_sym_const,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    ACTIONS(7292), 1,
      anon_sym_STAR,
    ACTIONS(7294), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7296), 1,
      anon_sym_AMP,
    STATE(3360), 1,
      sym_parameter_list,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(5867), 1,
      sym__abstract_declarator,
    STATE(4650), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7753), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6945), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [137489] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4691), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4693), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [137536] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6953), 1,
      anon_sym_const,
    ACTIONS(7634), 2,
      anon_sym_AMP,
      anon_sym_LBRACK,
    STATE(4762), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4764), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5702), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6945), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
    ACTIONS(7632), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [137593] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(7729), 1,
      anon_sym_COMMA,
    ACTIONS(7917), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    STATE(7058), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [137690] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    ACTIONS(7430), 1,
      anon_sym_STAR,
    ACTIONS(7432), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7434), 1,
      anon_sym_AMP,
    ACTIONS(7440), 1,
      sym_auto,
    ACTIONS(7442), 1,
      anon_sym_decltype,
    STATE(2655), 1,
      sym_decltype_auto,
    STATE(3784), 1,
      sym_parameter_list,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(6197), 1,
      sym__abstract_declarator,
    STATE(4732), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7526), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6915), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [137765] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_const,
    ACTIONS(2919), 1,
      sym_ms_restrict_modifier,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(7919), 1,
      anon_sym_STAR,
    ACTIONS(7921), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7923), 1,
      anon_sym_AMP,
    STATE(3830), 1,
      sym_parameter_list,
    STATE(4186), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6465), 1,
      sym__abstract_declarator,
    ACTIONS(7321), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7323), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4315), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4986), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5513), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7319), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [137844] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7576), 1,
      anon_sym_SLASH,
    ACTIONS(7582), 1,
      anon_sym_PIPE,
    ACTIONS(7586), 1,
      anon_sym_AMP,
    ACTIONS(7592), 1,
      anon_sym_GT_EQ,
    ACTIONS(7600), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7602), 1,
      anon_sym_bitor,
    ACTIONS(7604), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7578), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7580), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7584), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7594), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7588), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7590), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6258), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
  [137933] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(7925), 1,
      anon_sym_COMMA,
    ACTIONS(7927), 1,
      anon_sym_RBRACE,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    STATE(7202), 1,
      aux_sym_initializer_list_repeat1,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [138030] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    ACTIONS(7755), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(7763), 1,
      anon_sym_SLASH,
    ACTIONS(7769), 1,
      anon_sym_PIPE,
    ACTIONS(7773), 1,
      anon_sym_AMP,
    ACTIONS(7779), 1,
      anon_sym_LT_LT,
    ACTIONS(7781), 1,
      anon_sym_GT_GT,
    ACTIONS(7783), 1,
      anon_sym_QMARK,
    ACTIONS(7785), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7787), 1,
      anon_sym_bitor,
    ACTIONS(7789), 1,
      anon_sym_bitand,
    ACTIONS(7929), 1,
      anon_sym_GT2,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    STATE(7164), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7759), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7761), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7765), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7767), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7771), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7791), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7775), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7777), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [138127] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1957), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(1955), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [138174] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_const,
    ACTIONS(2919), 1,
      sym_ms_restrict_modifier,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(7919), 1,
      anon_sym_STAR,
    ACTIONS(7921), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7923), 1,
      anon_sym_AMP,
    STATE(3830), 1,
      sym_parameter_list,
    STATE(4186), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6470), 1,
      sym__abstract_declarator,
    ACTIONS(7321), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7323), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4100), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4987), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5555), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7319), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [138253] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_LBRACE,
    ACTIONS(7502), 1,
      anon_sym_LPAREN2,
    STATE(4669), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5561), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5563), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [138306] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4703), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4705), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [138353] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_LBRACE,
    ACTIONS(7502), 1,
      anon_sym_LPAREN2,
    STATE(4694), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5565), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5567), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [138406] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4699), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4701), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [138453] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_const,
    ACTIONS(2919), 1,
      sym_ms_restrict_modifier,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(4520), 1,
      anon_sym_STAR,
    ACTIONS(4522), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4524), 1,
      anon_sym_AMP,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(4186), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6481), 1,
      sym__abstract_declarator,
    ACTIONS(7321), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7323), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4252), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4961), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5513), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7319), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [138532] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(7931), 1,
      anon_sym_COMMA,
    ACTIONS(7933), 1,
      anon_sym_RBRACE,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    STATE(6926), 1,
      aux_sym_initializer_list_repeat1,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [138629] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4719), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4721), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [138676] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4723), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4725), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [138723] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    ACTIONS(7755), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(7763), 1,
      anon_sym_SLASH,
    ACTIONS(7769), 1,
      anon_sym_PIPE,
    ACTIONS(7773), 1,
      anon_sym_AMP,
    ACTIONS(7779), 1,
      anon_sym_LT_LT,
    ACTIONS(7781), 1,
      anon_sym_GT_GT,
    ACTIONS(7783), 1,
      anon_sym_QMARK,
    ACTIONS(7785), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7787), 1,
      anon_sym_bitor,
    ACTIONS(7789), 1,
      anon_sym_bitand,
    ACTIONS(7935), 1,
      anon_sym_GT2,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    STATE(7107), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7759), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7761), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7765), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7767), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7771), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7791), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7775), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7777), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [138820] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    ACTIONS(7755), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(7763), 1,
      anon_sym_SLASH,
    ACTIONS(7769), 1,
      anon_sym_PIPE,
    ACTIONS(7773), 1,
      anon_sym_AMP,
    ACTIONS(7779), 1,
      anon_sym_LT_LT,
    ACTIONS(7781), 1,
      anon_sym_GT_GT,
    ACTIONS(7783), 1,
      anon_sym_QMARK,
    ACTIONS(7785), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7787), 1,
      anon_sym_bitor,
    ACTIONS(7789), 1,
      anon_sym_bitand,
    ACTIONS(7937), 1,
      anon_sym_GT2,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    STATE(6937), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7759), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7761), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7765), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7767), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7771), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7791), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7775), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7777), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [138917] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(7735), 1,
      anon_sym_COMMA,
    ACTIONS(7939), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    STATE(7065), 1,
      aux_sym_generic_expression_repeat1,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [139014] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    ACTIONS(7755), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(7763), 1,
      anon_sym_SLASH,
    ACTIONS(7769), 1,
      anon_sym_PIPE,
    ACTIONS(7773), 1,
      anon_sym_AMP,
    ACTIONS(7779), 1,
      anon_sym_LT_LT,
    ACTIONS(7781), 1,
      anon_sym_GT_GT,
    ACTIONS(7783), 1,
      anon_sym_QMARK,
    ACTIONS(7785), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7787), 1,
      anon_sym_bitor,
    ACTIONS(7789), 1,
      anon_sym_bitand,
    ACTIONS(7941), 1,
      anon_sym_GT2,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    STATE(7130), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7759), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7761), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7765), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7767), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7771), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7791), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7775), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7777), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [139111] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(7729), 1,
      anon_sym_COMMA,
    ACTIONS(7943), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    STATE(6914), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [139208] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    ACTIONS(7755), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(7763), 1,
      anon_sym_SLASH,
    ACTIONS(7769), 1,
      anon_sym_PIPE,
    ACTIONS(7773), 1,
      anon_sym_AMP,
    ACTIONS(7779), 1,
      anon_sym_LT_LT,
    ACTIONS(7781), 1,
      anon_sym_GT_GT,
    ACTIONS(7783), 1,
      anon_sym_QMARK,
    ACTIONS(7785), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7787), 1,
      anon_sym_bitor,
    ACTIONS(7789), 1,
      anon_sym_bitand,
    ACTIONS(7945), 1,
      anon_sym_GT2,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    STATE(7233), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7759), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7761), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7765), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7767), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7771), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7791), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7775), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7777), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [139305] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4715), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4717), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [139352] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6953), 1,
      anon_sym_const,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    ACTIONS(7292), 1,
      anon_sym_STAR,
    ACTIONS(7294), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7296), 1,
      anon_sym_AMP,
    STATE(3360), 1,
      sym_parameter_list,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(5866), 1,
      sym__abstract_declarator,
    STATE(4650), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5555), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6945), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [139421] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    ACTIONS(7278), 1,
      anon_sym_STAR,
    ACTIONS(7280), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7282), 1,
      anon_sym_AMP,
    STATE(3617), 1,
      sym_parameter_list,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(5892), 1,
      sym__abstract_declarator,
    STATE(4424), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5555), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6915), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [139490] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6953), 1,
      anon_sym_const,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    ACTIONS(7292), 1,
      anon_sym_STAR,
    ACTIONS(7294), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7296), 1,
      anon_sym_AMP,
    STATE(3360), 1,
      sym_parameter_list,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(5863), 1,
      sym__abstract_declarator,
    STATE(4650), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7795), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6945), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [139559] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    ACTIONS(7755), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(7763), 1,
      anon_sym_SLASH,
    ACTIONS(7769), 1,
      anon_sym_PIPE,
    ACTIONS(7773), 1,
      anon_sym_AMP,
    ACTIONS(7779), 1,
      anon_sym_LT_LT,
    ACTIONS(7781), 1,
      anon_sym_GT_GT,
    ACTIONS(7783), 1,
      anon_sym_QMARK,
    ACTIONS(7785), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7787), 1,
      anon_sym_bitor,
    ACTIONS(7789), 1,
      anon_sym_bitand,
    ACTIONS(7947), 1,
      anon_sym_GT2,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    STATE(7213), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7759), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7761), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7765), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7767), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7771), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7791), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7775), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7777), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [139656] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    ACTIONS(7755), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(7763), 1,
      anon_sym_SLASH,
    ACTIONS(7769), 1,
      anon_sym_PIPE,
    ACTIONS(7773), 1,
      anon_sym_AMP,
    ACTIONS(7779), 1,
      anon_sym_LT_LT,
    ACTIONS(7781), 1,
      anon_sym_GT_GT,
    ACTIONS(7783), 1,
      anon_sym_QMARK,
    ACTIONS(7785), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7787), 1,
      anon_sym_bitor,
    ACTIONS(7789), 1,
      anon_sym_bitand,
    ACTIONS(7949), 1,
      anon_sym_GT2,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    STATE(7193), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7759), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7761), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7765), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7767), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7771), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7791), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7775), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7777), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [139753] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4711), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4713), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [139800] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_LBRACE,
    ACTIONS(7502), 1,
      anon_sym_LPAREN2,
    STATE(4692), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5625), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5627), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [139853] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    ACTIONS(7755), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(7763), 1,
      anon_sym_SLASH,
    ACTIONS(7769), 1,
      anon_sym_PIPE,
    ACTIONS(7773), 1,
      anon_sym_AMP,
    ACTIONS(7779), 1,
      anon_sym_LT_LT,
    ACTIONS(7781), 1,
      anon_sym_GT_GT,
    ACTIONS(7783), 1,
      anon_sym_QMARK,
    ACTIONS(7785), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7787), 1,
      anon_sym_bitor,
    ACTIONS(7789), 1,
      anon_sym_bitand,
    ACTIONS(7951), 1,
      anon_sym_GT2,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    STATE(7173), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7759), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7761), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7765), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7767), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7771), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7791), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7775), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7777), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [139950] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7815), 1,
      anon_sym_SLASH,
    ACTIONS(7821), 1,
      anon_sym_PIPE,
    ACTIONS(7825), 1,
      anon_sym_AMP,
    ACTIONS(7831), 1,
      anon_sym_GT_EQ,
    ACTIONS(7837), 1,
      anon_sym_QMARK,
    ACTIONS(7839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7841), 1,
      anon_sym_bitor,
    ACTIONS(7843), 1,
      anon_sym_bitand,
    ACTIONS(7859), 1,
      anon_sym_COMMA,
    ACTIONS(7953), 1,
      anon_sym_RBRACK,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    STATE(6964), 1,
      aux_sym_subscript_argument_list_repeat1,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [140047] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_LBRACE,
    ACTIONS(7502), 1,
      anon_sym_LPAREN2,
    STATE(4677), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5609), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5611), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [140100] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(7729), 1,
      anon_sym_COMMA,
    ACTIONS(7955), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    STATE(7099), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [140197] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4735), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4737), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [140244] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4731), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4733), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [140291] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    ACTIONS(7763), 1,
      anon_sym_SLASH,
    ACTIONS(7779), 1,
      anon_sym_LT_LT,
    ACTIONS(7781), 1,
      anon_sym_GT_GT,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7759), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7761), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7791), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(5724), 6,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5726), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [140361] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6859), 1,
      anon_sym_COMMA,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(7957), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [140455] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6317), 1,
      anon_sym_LBRACE,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7959), 1,
      anon_sym_COLON,
    STATE(2649), 1,
      sym_attribute_specifier,
    STATE(3804), 1,
      sym__enum_base_clause,
    STATE(3951), 1,
      sym_enumerator_list,
    ACTIONS(5629), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5631), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [140513] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7791), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(5775), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(5777), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [140573] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6859), 1,
      anon_sym_COMMA,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(7961), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [140667] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    ACTIONS(7763), 1,
      anon_sym_SLASH,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7759), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7761), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7791), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(5724), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(5726), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [140733] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_const,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(7313), 1,
      anon_sym_STAR,
    ACTIONS(7315), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7317), 1,
      anon_sym_AMP,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    STATE(3325), 1,
      sym_parameter_list,
    STATE(5938), 1,
      sym__abstract_declarator,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(4968), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7753), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7319), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [140801] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6859), 1,
      anon_sym_COMMA,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(7963), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [140895] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5201), 1,
      sym_literal_suffix,
    ACTIONS(3769), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(3761), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [140943] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    ACTIONS(7763), 1,
      anon_sym_SLASH,
    ACTIONS(7769), 1,
      anon_sym_PIPE,
    ACTIONS(7773), 1,
      anon_sym_AMP,
    ACTIONS(7779), 1,
      anon_sym_LT_LT,
    ACTIONS(7781), 1,
      anon_sym_GT_GT,
    ACTIONS(7785), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7787), 1,
      anon_sym_bitor,
    ACTIONS(7789), 1,
      anon_sym_bitand,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7759), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7761), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7765), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7767), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7771), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7791), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7775), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6250), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_GT2,
    ACTIONS(7777), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [141031] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    ACTIONS(7763), 1,
      anon_sym_SLASH,
    ACTIONS(7779), 1,
      anon_sym_LT_LT,
    ACTIONS(7781), 1,
      anon_sym_GT_GT,
    ACTIONS(7785), 1,
      anon_sym_LT_EQ_GT,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7759), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7761), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7791), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(5724), 6,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5726), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [141103] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7965), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [141195] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7967), 1,
      anon_sym_COMMA,
    ACTIONS(7973), 1,
      anon_sym_SLASH,
    ACTIONS(7979), 1,
      anon_sym_PIPE,
    ACTIONS(7983), 1,
      anon_sym_AMP,
    ACTIONS(7989), 1,
      anon_sym_GT_EQ,
    ACTIONS(7993), 1,
      anon_sym_COLON,
    ACTIONS(7995), 1,
      anon_sym_QMARK,
    ACTIONS(7997), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7999), 1,
      anon_sym_bitor,
    ACTIONS(8001), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7969), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7971), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7975), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7977), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7981), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7991), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7985), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7987), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [141289] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    ACTIONS(7763), 1,
      anon_sym_SLASH,
    ACTIONS(7779), 1,
      anon_sym_LT_LT,
    ACTIONS(7781), 1,
      anon_sym_GT_GT,
    ACTIONS(7785), 1,
      anon_sym_LT_EQ_GT,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    ACTIONS(5724), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7759), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7761), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7791), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7777), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5726), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [141363] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7751), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [141455] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    ACTIONS(7763), 1,
      anon_sym_SLASH,
    ACTIONS(7779), 1,
      anon_sym_LT_LT,
    ACTIONS(7781), 1,
      anon_sym_GT_GT,
    ACTIONS(7785), 1,
      anon_sym_LT_EQ_GT,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    ACTIONS(5724), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7759), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7761), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7791), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7775), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7777), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5726), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_GT2,
  [141531] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5724), 1,
      anon_sym_PIPE,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    ACTIONS(7763), 1,
      anon_sym_SLASH,
    ACTIONS(7773), 1,
      anon_sym_AMP,
    ACTIONS(7779), 1,
      anon_sym_LT_LT,
    ACTIONS(7781), 1,
      anon_sym_GT_GT,
    ACTIONS(7785), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7789), 1,
      anon_sym_bitand,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7759), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7761), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7791), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7775), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7777), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5726), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_GT2,
  [141611] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4475), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5105), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8003), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5107), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [141661] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5724), 1,
      anon_sym_PIPE,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    ACTIONS(7763), 1,
      anon_sym_SLASH,
    ACTIONS(7773), 1,
      anon_sym_AMP,
    ACTIONS(7779), 1,
      anon_sym_LT_LT,
    ACTIONS(7781), 1,
      anon_sym_GT_GT,
    ACTIONS(7785), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7789), 1,
      anon_sym_bitand,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7759), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7761), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7771), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7791), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7775), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7777), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5726), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_GT2,
  [141743] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8005), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [141835] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5201), 1,
      sym_literal_suffix,
    ACTIONS(5197), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(5199), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [141883] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8005), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [141975] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8007), 1,
      anon_sym_COMMA,
    ACTIONS(8009), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [142069] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7967), 1,
      anon_sym_COMMA,
    ACTIONS(7973), 1,
      anon_sym_SLASH,
    ACTIONS(7979), 1,
      anon_sym_PIPE,
    ACTIONS(7983), 1,
      anon_sym_AMP,
    ACTIONS(7989), 1,
      anon_sym_GT_EQ,
    ACTIONS(7995), 1,
      anon_sym_QMARK,
    ACTIONS(7997), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7999), 1,
      anon_sym_bitor,
    ACTIONS(8001), 1,
      anon_sym_bitand,
    ACTIONS(8011), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7969), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7971), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7975), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7977), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7981), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7991), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7985), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7987), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [142163] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8013), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [142255] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8015), 1,
      anon_sym_COMMA,
    ACTIONS(8017), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [142349] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    ACTIONS(7755), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7763), 1,
      anon_sym_SLASH,
    ACTIONS(7769), 1,
      anon_sym_PIPE,
    ACTIONS(7773), 1,
      anon_sym_AMP,
    ACTIONS(7779), 1,
      anon_sym_LT_LT,
    ACTIONS(7781), 1,
      anon_sym_GT_GT,
    ACTIONS(7783), 1,
      anon_sym_QMARK,
    ACTIONS(7785), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7787), 1,
      anon_sym_bitor,
    ACTIONS(7789), 1,
      anon_sym_bitand,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    ACTIONS(6246), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7759), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7761), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7765), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7767), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7771), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7791), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7775), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7777), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [142441] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    ACTIONS(7763), 1,
      anon_sym_SLASH,
    ACTIONS(7769), 1,
      anon_sym_PIPE,
    ACTIONS(7773), 1,
      anon_sym_AMP,
    ACTIONS(7779), 1,
      anon_sym_LT_LT,
    ACTIONS(7781), 1,
      anon_sym_GT_GT,
    ACTIONS(7785), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7787), 1,
      anon_sym_bitor,
    ACTIONS(7789), 1,
      anon_sym_bitand,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7759), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7761), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7771), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7791), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7775), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7777), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5726), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT2,
  [142525] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    ACTIONS(7763), 1,
      anon_sym_SLASH,
    ACTIONS(7769), 1,
      anon_sym_PIPE,
    ACTIONS(7773), 1,
      anon_sym_AMP,
    ACTIONS(7779), 1,
      anon_sym_LT_LT,
    ACTIONS(7781), 1,
      anon_sym_GT_GT,
    ACTIONS(7785), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7787), 1,
      anon_sym_bitor,
    ACTIONS(7789), 1,
      anon_sym_bitand,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7759), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7761), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7767), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7771), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7791), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7775), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7777), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5726), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_GT2,
  [142611] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7791), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(5724), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(5726), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [142671] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    ACTIONS(7763), 1,
      anon_sym_SLASH,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7761), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7791), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(5724), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(5726), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [142735] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_const,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(7313), 1,
      anon_sym_STAR,
    ACTIONS(7315), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7317), 1,
      anon_sym_AMP,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    STATE(3325), 1,
      sym_parameter_list,
    STATE(5939), 1,
      sym__abstract_declarator,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(4968), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5555), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7319), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [142803] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7967), 1,
      anon_sym_COMMA,
    ACTIONS(7973), 1,
      anon_sym_SLASH,
    ACTIONS(7979), 1,
      anon_sym_PIPE,
    ACTIONS(7983), 1,
      anon_sym_AMP,
    ACTIONS(7989), 1,
      anon_sym_GT_EQ,
    ACTIONS(7995), 1,
      anon_sym_QMARK,
    ACTIONS(7997), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7999), 1,
      anon_sym_bitor,
    ACTIONS(8001), 1,
      anon_sym_bitand,
    ACTIONS(8019), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7969), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7971), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7975), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7977), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7981), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7991), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7985), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7987), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [142897] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    ACTIONS(7973), 1,
      anon_sym_SLASH,
    ACTIONS(7989), 1,
      anon_sym_GT_EQ,
    ACTIONS(7997), 1,
      anon_sym_LT_EQ_GT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5724), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7969), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7971), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7991), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7985), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7987), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5726), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
  [142973] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    ACTIONS(7763), 1,
      anon_sym_SLASH,
    ACTIONS(7769), 1,
      anon_sym_PIPE,
    ACTIONS(7773), 1,
      anon_sym_AMP,
    ACTIONS(7779), 1,
      anon_sym_LT_LT,
    ACTIONS(7781), 1,
      anon_sym_GT_GT,
    ACTIONS(7785), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7787), 1,
      anon_sym_bitor,
    ACTIONS(7789), 1,
      anon_sym_bitand,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7759), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7761), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7765), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7767), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7771), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7791), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7775), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6242), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_GT2,
    ACTIONS(7777), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [143061] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4582), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(4584), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4577), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [143109] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7967), 1,
      anon_sym_COMMA,
    ACTIONS(7973), 1,
      anon_sym_SLASH,
    ACTIONS(7979), 1,
      anon_sym_PIPE,
    ACTIONS(7983), 1,
      anon_sym_AMP,
    ACTIONS(7989), 1,
      anon_sym_GT_EQ,
    ACTIONS(7995), 1,
      anon_sym_QMARK,
    ACTIONS(7997), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7999), 1,
      anon_sym_bitor,
    ACTIONS(8001), 1,
      anon_sym_bitand,
    ACTIONS(8021), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7969), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7971), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7975), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7977), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7981), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7991), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7985), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7987), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [143203] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    ACTIONS(7973), 1,
      anon_sym_SLASH,
    ACTIONS(7979), 1,
      anon_sym_PIPE,
    ACTIONS(7983), 1,
      anon_sym_AMP,
    ACTIONS(7989), 1,
      anon_sym_GT_EQ,
    ACTIONS(7997), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7999), 1,
      anon_sym_bitor,
    ACTIONS(8001), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7969), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7971), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7975), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7977), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7981), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7991), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7985), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7987), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6258), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [143291] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7973), 1,
      anon_sym_SLASH,
    ACTIONS(7979), 1,
      anon_sym_PIPE,
    ACTIONS(7983), 1,
      anon_sym_AMP,
    ACTIONS(7989), 1,
      anon_sym_GT_EQ,
    ACTIONS(7995), 1,
      anon_sym_QMARK,
    ACTIONS(7997), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7999), 1,
      anon_sym_bitor,
    ACTIONS(8001), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5936), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7969), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7971), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7975), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7977), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7981), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7991), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7985), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7987), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [143383] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    ACTIONS(7973), 1,
      anon_sym_SLASH,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7971), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5724), 7,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5726), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [143447] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    ACTIONS(7755), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7763), 1,
      anon_sym_SLASH,
    ACTIONS(7769), 1,
      anon_sym_PIPE,
    ACTIONS(7773), 1,
      anon_sym_AMP,
    ACTIONS(7779), 1,
      anon_sym_LT_LT,
    ACTIONS(7781), 1,
      anon_sym_GT_GT,
    ACTIONS(7783), 1,
      anon_sym_QMARK,
    ACTIONS(7785), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7787), 1,
      anon_sym_bitor,
    ACTIONS(7789), 1,
      anon_sym_bitand,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7759), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7761), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7765), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7767), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7771), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7791), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8023), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(7775), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7777), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [143539] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6859), 1,
      anon_sym_COMMA,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8025), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [143633] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    ACTIONS(7973), 1,
      anon_sym_SLASH,
    ACTIONS(7979), 1,
      anon_sym_PIPE,
    ACTIONS(7983), 1,
      anon_sym_AMP,
    ACTIONS(7989), 1,
      anon_sym_GT_EQ,
    ACTIONS(7997), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7999), 1,
      anon_sym_bitor,
    ACTIONS(8001), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7969), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7971), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7977), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7981), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7991), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7985), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7987), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5726), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_or,
  [143719] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7967), 1,
      anon_sym_COMMA,
    ACTIONS(7973), 1,
      anon_sym_SLASH,
    ACTIONS(7979), 1,
      anon_sym_PIPE,
    ACTIONS(7983), 1,
      anon_sym_AMP,
    ACTIONS(7989), 1,
      anon_sym_GT_EQ,
    ACTIONS(7995), 1,
      anon_sym_QMARK,
    ACTIONS(7997), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7999), 1,
      anon_sym_bitor,
    ACTIONS(8001), 1,
      anon_sym_bitand,
    ACTIONS(8027), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7969), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7971), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7975), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7977), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7981), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7991), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7985), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7987), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [143813] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    ACTIONS(7973), 1,
      anon_sym_SLASH,
    ACTIONS(7979), 1,
      anon_sym_PIPE,
    ACTIONS(7983), 1,
      anon_sym_AMP,
    ACTIONS(7989), 1,
      anon_sym_GT_EQ,
    ACTIONS(7997), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7999), 1,
      anon_sym_bitor,
    ACTIONS(8001), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7969), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7971), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7991), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7985), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7987), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5726), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
  [143897] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5724), 1,
      anon_sym_PIPE,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    ACTIONS(7973), 1,
      anon_sym_SLASH,
    ACTIONS(7983), 1,
      anon_sym_AMP,
    ACTIONS(7989), 1,
      anon_sym_GT_EQ,
    ACTIONS(7997), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8001), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7969), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7971), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7991), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7985), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7987), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5726), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
  [143979] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8029), 1,
      anon_sym_LT,
    STATE(4681), 1,
      sym_template_argument_list,
    ACTIONS(5187), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(3785), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [144031] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5724), 1,
      anon_sym_PIPE,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    ACTIONS(7973), 1,
      anon_sym_SLASH,
    ACTIONS(7983), 1,
      anon_sym_AMP,
    ACTIONS(7989), 1,
      anon_sym_GT_EQ,
    ACTIONS(7997), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8001), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7969), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7971), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7991), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7985), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7987), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5726), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
  [144111] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    ACTIONS(7973), 1,
      anon_sym_SLASH,
    ACTIONS(7989), 1,
      anon_sym_GT_EQ,
    ACTIONS(7997), 1,
      anon_sym_LT_EQ_GT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5724), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7969), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7971), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7991), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7987), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5726), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [144185] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7744), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [144277] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    ACTIONS(7973), 1,
      anon_sym_SLASH,
    ACTIONS(7997), 1,
      anon_sym_LT_EQ_GT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7969), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7971), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7991), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5724), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5726), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [144347] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    ACTIONS(7755), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7763), 1,
      anon_sym_SLASH,
    ACTIONS(7769), 1,
      anon_sym_PIPE,
    ACTIONS(7773), 1,
      anon_sym_AMP,
    ACTIONS(7779), 1,
      anon_sym_LT_LT,
    ACTIONS(7781), 1,
      anon_sym_GT_GT,
    ACTIONS(7783), 1,
      anon_sym_QMARK,
    ACTIONS(7785), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7787), 1,
      anon_sym_bitor,
    ACTIONS(7789), 1,
      anon_sym_bitand,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    ACTIONS(5936), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7759), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7761), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7765), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7767), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7771), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7791), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7775), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7777), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [144439] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8029), 1,
      anon_sym_LT,
    STATE(4681), 1,
      sym_template_argument_list,
    ACTIONS(4534), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(4541), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [144491] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6859), 1,
      anon_sym_COMMA,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8031), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [144585] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_const,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(7313), 1,
      anon_sym_STAR,
    ACTIONS(7315), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7317), 1,
      anon_sym_AMP,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    STATE(3325), 1,
      sym_parameter_list,
    STATE(5935), 1,
      sym__abstract_declarator,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(4968), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6297), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7319), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [144653] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    ACTIONS(7973), 1,
      anon_sym_SLASH,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7969), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7971), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5724), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5726), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [144719] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    ACTIONS(7763), 1,
      anon_sym_SLASH,
    ACTIONS(7769), 1,
      anon_sym_PIPE,
    ACTIONS(7773), 1,
      anon_sym_AMP,
    ACTIONS(7779), 1,
      anon_sym_LT_LT,
    ACTIONS(7781), 1,
      anon_sym_GT_GT,
    ACTIONS(7785), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7787), 1,
      anon_sym_bitor,
    ACTIONS(7789), 1,
      anon_sym_bitand,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7759), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7761), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7765), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7767), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7771), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7791), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7775), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6258), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_GT2,
    ACTIONS(7777), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [144807] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    ACTIONS(7755), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7763), 1,
      anon_sym_SLASH,
    ACTIONS(7769), 1,
      anon_sym_PIPE,
    ACTIONS(7773), 1,
      anon_sym_AMP,
    ACTIONS(7779), 1,
      anon_sym_LT_LT,
    ACTIONS(7781), 1,
      anon_sym_GT_GT,
    ACTIONS(7783), 1,
      anon_sym_QMARK,
    ACTIONS(7785), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7787), 1,
      anon_sym_bitor,
    ACTIONS(7789), 1,
      anon_sym_bitand,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7759), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7761), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7765), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7767), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7771), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7791), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8013), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(7775), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7777), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [144899] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    ACTIONS(7973), 1,
      anon_sym_SLASH,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7969), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7971), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7991), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5724), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5726), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [144967] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    ACTIONS(7973), 1,
      anon_sym_SLASH,
    ACTIONS(7979), 1,
      anon_sym_PIPE,
    ACTIONS(7983), 1,
      anon_sym_AMP,
    ACTIONS(7989), 1,
      anon_sym_GT_EQ,
    ACTIONS(7997), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7999), 1,
      anon_sym_bitor,
    ACTIONS(8001), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7969), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7971), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7975), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7977), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7981), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7991), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7985), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7987), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6250), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [145055] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7973), 1,
      anon_sym_SLASH,
    ACTIONS(7979), 1,
      anon_sym_PIPE,
    ACTIONS(7983), 1,
      anon_sym_AMP,
    ACTIONS(7989), 1,
      anon_sym_GT_EQ,
    ACTIONS(7995), 1,
      anon_sym_QMARK,
    ACTIONS(7997), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7999), 1,
      anon_sym_bitor,
    ACTIONS(8001), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(6246), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7969), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7971), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7975), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7977), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7981), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7991), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7985), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7987), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [145147] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_const,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(7309), 1,
      sym_auto,
    ACTIONS(7311), 1,
      anon_sym_decltype,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(7506), 1,
      anon_sym_STAR,
    ACTIONS(7508), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7510), 1,
      anon_sym_AMP,
    STATE(1988), 1,
      sym_decltype_auto,
    STATE(3759), 1,
      sym_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6277), 1,
      sym__abstract_declarator,
    STATE(4761), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7526), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7319), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [145221] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4139), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5426), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8033), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5424), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [145271] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    ACTIONS(7973), 1,
      anon_sym_SLASH,
    ACTIONS(7979), 1,
      anon_sym_PIPE,
    ACTIONS(7983), 1,
      anon_sym_AMP,
    ACTIONS(7989), 1,
      anon_sym_GT_EQ,
    ACTIONS(7997), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7999), 1,
      anon_sym_bitor,
    ACTIONS(8001), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7969), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7971), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7975), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7977), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7981), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7991), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7985), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7987), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6242), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [145359] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7815), 1,
      anon_sym_SLASH,
    ACTIONS(7821), 1,
      anon_sym_PIPE,
    ACTIONS(7825), 1,
      anon_sym_AMP,
    ACTIONS(7831), 1,
      anon_sym_GT_EQ,
    ACTIONS(7837), 1,
      anon_sym_QMARK,
    ACTIONS(7839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7841), 1,
      anon_sym_bitor,
    ACTIONS(7843), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6220), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [145451] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7815), 1,
      anon_sym_SLASH,
    ACTIONS(7821), 1,
      anon_sym_PIPE,
    ACTIONS(7825), 1,
      anon_sym_AMP,
    ACTIONS(7831), 1,
      anon_sym_GT_EQ,
    ACTIONS(7839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7841), 1,
      anon_sym_bitor,
    ACTIONS(7843), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6242), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [145539] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6859), 1,
      anon_sym_COMMA,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8035), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [145633] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4139), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5450), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8033), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5448), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [145683] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(3803), 1,
      anon_sym_LPAREN2,
    ACTIONS(3805), 1,
      anon_sym_STAR,
    ACTIONS(3807), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3809), 1,
      anon_sym_AMP,
    ACTIONS(4841), 1,
      sym_identifier,
    ACTIONS(5523), 1,
      anon_sym_LBRACK,
    ACTIONS(5825), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7524), 1,
      anon_sym_RPAREN,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(5610), 1,
      sym__scope_resolution,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6220), 1,
      sym__declarator,
    STATE(6482), 1,
      sym__abstract_declarator,
    STATE(8318), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [145769] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6317), 1,
      anon_sym_LBRACE,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7959), 1,
      anon_sym_COLON,
    STATE(2633), 1,
      sym_attribute_specifier,
    STATE(3839), 1,
      sym__enum_base_clause,
    STATE(3946), 1,
      sym_enumerator_list,
    ACTIONS(5689), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5691), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [145827] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7815), 1,
      anon_sym_SLASH,
    ACTIONS(7821), 1,
      anon_sym_PIPE,
    ACTIONS(7825), 1,
      anon_sym_AMP,
    ACTIONS(7831), 1,
      anon_sym_GT_EQ,
    ACTIONS(7837), 1,
      anon_sym_QMARK,
    ACTIONS(7839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7841), 1,
      anon_sym_bitor,
    ACTIONS(7843), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6246), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [145919] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7973), 1,
      anon_sym_SLASH,
    ACTIONS(7979), 1,
      anon_sym_PIPE,
    ACTIONS(7983), 1,
      anon_sym_AMP,
    ACTIONS(7989), 1,
      anon_sym_GT_EQ,
    ACTIONS(7995), 1,
      anon_sym_QMARK,
    ACTIONS(7997), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7999), 1,
      anon_sym_bitor,
    ACTIONS(8001), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(6220), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7969), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7971), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7975), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7977), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7981), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7991), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7985), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7987), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [146011] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7815), 1,
      anon_sym_SLASH,
    ACTIONS(7821), 1,
      anon_sym_PIPE,
    ACTIONS(7825), 1,
      anon_sym_AMP,
    ACTIONS(7831), 1,
      anon_sym_GT_EQ,
    ACTIONS(7839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7841), 1,
      anon_sym_bitor,
    ACTIONS(7843), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6258), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [146099] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_const,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(7309), 1,
      sym_auto,
    ACTIONS(7311), 1,
      anon_sym_decltype,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(7506), 1,
      anon_sym_STAR,
    ACTIONS(7508), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7510), 1,
      anon_sym_AMP,
    STATE(1988), 1,
      sym_decltype_auto,
    STATE(3759), 1,
      sym_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6242), 1,
      sym__abstract_declarator,
    STATE(4737), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7537), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7319), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [146173] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6859), 1,
      anon_sym_COMMA,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8037), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [146267] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    ACTIONS(7973), 1,
      anon_sym_SLASH,
    ACTIONS(7979), 1,
      anon_sym_PIPE,
    ACTIONS(7983), 1,
      anon_sym_AMP,
    ACTIONS(7989), 1,
      anon_sym_GT_EQ,
    ACTIONS(7997), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7999), 1,
      anon_sym_bitor,
    ACTIONS(8001), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7969), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7971), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7975), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7977), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7981), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7991), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7985), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7987), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6271), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [146355] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6859), 1,
      anon_sym_COMMA,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8039), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [146449] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5698), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(5700), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_GT2,
  [146507] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7504), 1,
      anon_sym_LBRACK,
    STATE(4549), 1,
      sym_new_declarator,
    ACTIONS(5681), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5683), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [146557] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    ACTIONS(7763), 1,
      anon_sym_SLASH,
    ACTIONS(7769), 1,
      anon_sym_PIPE,
    ACTIONS(7773), 1,
      anon_sym_AMP,
    ACTIONS(7779), 1,
      anon_sym_LT_LT,
    ACTIONS(7781), 1,
      anon_sym_GT_GT,
    ACTIONS(7785), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7787), 1,
      anon_sym_bitor,
    ACTIONS(7789), 1,
      anon_sym_bitand,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7759), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7761), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7765), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7767), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7771), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7791), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7775), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6271), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_GT2,
    ACTIONS(7777), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [146645] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8044), 1,
      anon_sym_const,
    ACTIONS(4822), 2,
      anon_sym_AMP,
      anon_sym_LBRACK,
    STATE(4424), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8041), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
    ACTIONS(4824), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [146697] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    ACTIONS(7755), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7763), 1,
      anon_sym_SLASH,
    ACTIONS(7769), 1,
      anon_sym_PIPE,
    ACTIONS(7773), 1,
      anon_sym_AMP,
    ACTIONS(7779), 1,
      anon_sym_LT_LT,
    ACTIONS(7781), 1,
      anon_sym_GT_GT,
    ACTIONS(7783), 1,
      anon_sym_QMARK,
    ACTIONS(7785), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7787), 1,
      anon_sym_bitor,
    ACTIONS(7789), 1,
      anon_sym_bitand,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    ACTIONS(6220), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7759), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7761), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7765), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7767), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7771), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7791), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7775), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7777), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [146789] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7791), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(5767), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(5769), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [146849] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7815), 1,
      anon_sym_SLASH,
    ACTIONS(7821), 1,
      anon_sym_PIPE,
    ACTIONS(7825), 1,
      anon_sym_AMP,
    ACTIONS(7831), 1,
      anon_sym_GT_EQ,
    ACTIONS(7839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7841), 1,
      anon_sym_bitor,
    ACTIONS(7843), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6250), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [146937] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_const,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(7313), 1,
      anon_sym_STAR,
    ACTIONS(7315), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7317), 1,
      anon_sym_AMP,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    STATE(3325), 1,
      sym_parameter_list,
    STATE(5950), 1,
      sym__abstract_declarator,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(4968), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7795), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7319), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [147005] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7791), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(5771), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(5773), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [147065] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    ACTIONS(7755), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7763), 1,
      anon_sym_SLASH,
    ACTIONS(7769), 1,
      anon_sym_PIPE,
    ACTIONS(7773), 1,
      anon_sym_AMP,
    ACTIONS(7779), 1,
      anon_sym_LT_LT,
    ACTIONS(7781), 1,
      anon_sym_GT_GT,
    ACTIONS(7783), 1,
      anon_sym_QMARK,
    ACTIONS(7785), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7787), 1,
      anon_sym_bitor,
    ACTIONS(7789), 1,
      anon_sym_bitand,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7759), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7761), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7765), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7767), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7771), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7791), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8005), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(7775), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7777), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [147157] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6859), 1,
      anon_sym_COMMA,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(7725), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [147251] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    ACTIONS(7755), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7763), 1,
      anon_sym_SLASH,
    ACTIONS(7769), 1,
      anon_sym_PIPE,
    ACTIONS(7773), 1,
      anon_sym_AMP,
    ACTIONS(7779), 1,
      anon_sym_LT_LT,
    ACTIONS(7781), 1,
      anon_sym_GT_GT,
    ACTIONS(7783), 1,
      anon_sym_QMARK,
    ACTIONS(7785), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7787), 1,
      anon_sym_bitor,
    ACTIONS(7789), 1,
      anon_sym_bitand,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7759), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7761), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7765), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7767), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7771), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7791), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8005), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(7775), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7777), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [147343] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6859), 1,
      anon_sym_COMMA,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(7851), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [147437] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6289), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6291), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [147483] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7815), 1,
      anon_sym_SLASH,
    ACTIONS(7821), 1,
      anon_sym_PIPE,
    ACTIONS(7825), 1,
      anon_sym_AMP,
    ACTIONS(7831), 1,
      anon_sym_GT_EQ,
    ACTIONS(7837), 1,
      anon_sym_QMARK,
    ACTIONS(7839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7841), 1,
      anon_sym_bitor,
    ACTIONS(7843), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8047), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(7827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [147575] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6859), 1,
      anon_sym_COMMA,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8049), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [147669] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5813), 8,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5815), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [147727] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(5771), 8,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5773), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [147787] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(5767), 8,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5769), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [147847] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5698), 8,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5700), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [147905] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7967), 1,
      anon_sym_COMMA,
    ACTIONS(7973), 1,
      anon_sym_SLASH,
    ACTIONS(7979), 1,
      anon_sym_PIPE,
    ACTIONS(7983), 1,
      anon_sym_AMP,
    ACTIONS(7989), 1,
      anon_sym_GT_EQ,
    ACTIONS(7995), 1,
      anon_sym_QMARK,
    ACTIONS(7997), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7999), 1,
      anon_sym_bitor,
    ACTIONS(8001), 1,
      anon_sym_bitand,
    ACTIONS(8051), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7969), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7971), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7975), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7977), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7981), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7991), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7985), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7987), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [147999] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_LBRACK,
    ACTIONS(6810), 1,
      anon_sym_DOT,
    STATE(3594), 1,
      sym_subscript_argument_list,
    STATE(3597), 1,
      sym_argument_list,
    ACTIONS(6812), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5813), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(5815), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_GT2,
  [148057] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7855), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [148149] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6299), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6301), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [148195] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7967), 1,
      anon_sym_COMMA,
    ACTIONS(7973), 1,
      anon_sym_SLASH,
    ACTIONS(7979), 1,
      anon_sym_PIPE,
    ACTIONS(7983), 1,
      anon_sym_AMP,
    ACTIONS(7989), 1,
      anon_sym_GT_EQ,
    ACTIONS(7995), 1,
      anon_sym_QMARK,
    ACTIONS(7997), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7999), 1,
      anon_sym_bitor,
    ACTIONS(8001), 1,
      anon_sym_bitand,
    ACTIONS(8053), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7969), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7971), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7975), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7977), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7981), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7991), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7985), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7987), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [148289] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7967), 1,
      anon_sym_COMMA,
    ACTIONS(7973), 1,
      anon_sym_SLASH,
    ACTIONS(7979), 1,
      anon_sym_PIPE,
    ACTIONS(7983), 1,
      anon_sym_AMP,
    ACTIONS(7989), 1,
      anon_sym_GT_EQ,
    ACTIONS(7995), 1,
      anon_sym_QMARK,
    ACTIONS(7997), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7999), 1,
      anon_sym_bitor,
    ACTIONS(8001), 1,
      anon_sym_bitand,
    ACTIONS(8055), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7969), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7971), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7975), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7977), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7981), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7991), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7985), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7987), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [148383] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6859), 1,
      anon_sym_COMMA,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8057), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [148477] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6859), 1,
      anon_sym_COMMA,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8059), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [148571] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8061), 1,
      anon_sym_COMMA,
    ACTIONS(8063), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [148665] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7967), 1,
      anon_sym_COMMA,
    ACTIONS(7973), 1,
      anon_sym_SLASH,
    ACTIONS(7979), 1,
      anon_sym_PIPE,
    ACTIONS(7983), 1,
      anon_sym_AMP,
    ACTIONS(7989), 1,
      anon_sym_GT_EQ,
    ACTIONS(7995), 1,
      anon_sym_QMARK,
    ACTIONS(7997), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7999), 1,
      anon_sym_bitor,
    ACTIONS(8001), 1,
      anon_sym_bitand,
    ACTIONS(8065), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7969), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7971), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7975), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7977), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7981), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7991), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7985), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7987), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [148759] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7749), 1,
      anon_sym_COLON,
    ACTIONS(7967), 1,
      anon_sym_COMMA,
    ACTIONS(7973), 1,
      anon_sym_SLASH,
    ACTIONS(7979), 1,
      anon_sym_PIPE,
    ACTIONS(7983), 1,
      anon_sym_AMP,
    ACTIONS(7989), 1,
      anon_sym_GT_EQ,
    ACTIONS(7995), 1,
      anon_sym_QMARK,
    ACTIONS(7997), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7999), 1,
      anon_sym_bitor,
    ACTIONS(8001), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7969), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7971), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7975), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7977), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7981), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7991), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7985), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7987), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [148853] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6859), 1,
      anon_sym_COMMA,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8067), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [148947] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6859), 1,
      anon_sym_COMMA,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8069), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [149041] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6859), 1,
      anon_sym_COMMA,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8071), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [149135] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6859), 1,
      anon_sym_COMMA,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8073), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [149229] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4475), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4924), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8003), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4926), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [149279] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6859), 1,
      anon_sym_COMMA,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8075), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [149373] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7468), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [149465] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7815), 1,
      anon_sym_SLASH,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5724), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5726), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [149533] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7815), 1,
      anon_sym_SLASH,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5724), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5726), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [149599] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7967), 1,
      anon_sym_COMMA,
    ACTIONS(7973), 1,
      anon_sym_SLASH,
    ACTIONS(7979), 1,
      anon_sym_PIPE,
    ACTIONS(7983), 1,
      anon_sym_AMP,
    ACTIONS(7989), 1,
      anon_sym_GT_EQ,
    ACTIONS(7995), 1,
      anon_sym_QMARK,
    ACTIONS(7997), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7999), 1,
      anon_sym_bitor,
    ACTIONS(8001), 1,
      anon_sym_bitand,
    ACTIONS(8077), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7969), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7971), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7975), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7977), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7981), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7991), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7985), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7987), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [149693] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7815), 1,
      anon_sym_SLASH,
    ACTIONS(7839), 1,
      anon_sym_LT_EQ_GT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5724), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5726), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [149763] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7815), 1,
      anon_sym_SLASH,
    ACTIONS(7831), 1,
      anon_sym_GT_EQ,
    ACTIONS(7839), 1,
      anon_sym_LT_EQ_GT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5724), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5726), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [149837] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7815), 1,
      anon_sym_SLASH,
    ACTIONS(7831), 1,
      anon_sym_GT_EQ,
    ACTIONS(7839), 1,
      anon_sym_LT_EQ_GT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5724), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5726), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
  [149913] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(5724), 1,
      anon_sym_PIPE,
    ACTIONS(7815), 1,
      anon_sym_SLASH,
    ACTIONS(7825), 1,
      anon_sym_AMP,
    ACTIONS(7831), 1,
      anon_sym_GT_EQ,
    ACTIONS(7839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7843), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5726), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
  [149993] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(5724), 1,
      anon_sym_PIPE,
    ACTIONS(7815), 1,
      anon_sym_SLASH,
    ACTIONS(7825), 1,
      anon_sym_AMP,
    ACTIONS(7831), 1,
      anon_sym_GT_EQ,
    ACTIONS(7839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7843), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5726), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
  [150075] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(5724), 8,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5726), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [150135] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8029), 1,
      anon_sym_LT,
    STATE(4681), 1,
      sym_template_argument_list,
    STATE(4729), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3759), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(7903), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3767), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [150191] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7967), 1,
      anon_sym_COMMA,
    ACTIONS(7973), 1,
      anon_sym_SLASH,
    ACTIONS(7979), 1,
      anon_sym_PIPE,
    ACTIONS(7983), 1,
      anon_sym_AMP,
    ACTIONS(7989), 1,
      anon_sym_GT_EQ,
    ACTIONS(7995), 1,
      anon_sym_QMARK,
    ACTIONS(7997), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7999), 1,
      anon_sym_bitor,
    ACTIONS(8001), 1,
      anon_sym_bitand,
    ACTIONS(8079), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7969), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7971), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7975), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7977), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7981), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7991), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7985), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7987), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [150285] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6859), 1,
      anon_sym_COMMA,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8081), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [150379] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4139), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5406), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8033), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5404), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [150429] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7815), 1,
      anon_sym_SLASH,
    ACTIONS(7821), 1,
      anon_sym_PIPE,
    ACTIONS(7825), 1,
      anon_sym_AMP,
    ACTIONS(7831), 1,
      anon_sym_GT_EQ,
    ACTIONS(7839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7841), 1,
      anon_sym_bitor,
    ACTIONS(7843), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5726), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
  [150513] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7815), 1,
      anon_sym_SLASH,
    ACTIONS(7821), 1,
      anon_sym_PIPE,
    ACTIONS(7825), 1,
      anon_sym_AMP,
    ACTIONS(7831), 1,
      anon_sym_GT_EQ,
    ACTIONS(7839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7841), 1,
      anon_sym_bitor,
    ACTIONS(7843), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5726), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_or,
  [150599] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7967), 1,
      anon_sym_COMMA,
    ACTIONS(7973), 1,
      anon_sym_SLASH,
    ACTIONS(7979), 1,
      anon_sym_PIPE,
    ACTIONS(7983), 1,
      anon_sym_AMP,
    ACTIONS(7989), 1,
      anon_sym_GT_EQ,
    ACTIONS(7995), 1,
      anon_sym_QMARK,
    ACTIONS(7997), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7999), 1,
      anon_sym_bitor,
    ACTIONS(8001), 1,
      anon_sym_bitand,
    ACTIONS(8083), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7969), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7971), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7975), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7977), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7981), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7991), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7985), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7987), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [150693] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4139), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5369), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8033), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5367), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [150743] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6859), 1,
      anon_sym_COMMA,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8085), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [150837] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4601), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5250), 1,
      anon_sym_LPAREN2,
    ACTIONS(5253), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(3761), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [150889] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8087), 1,
      anon_sym_COMMA,
    ACTIONS(8089), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [150983] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8091), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [151075] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4411), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5410), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5408), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [151125] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4406), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5420), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8095), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5418), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [151175] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7815), 1,
      anon_sym_SLASH,
    ACTIONS(7821), 1,
      anon_sym_PIPE,
    ACTIONS(7825), 1,
      anon_sym_AMP,
    ACTIONS(7831), 1,
      anon_sym_GT_EQ,
    ACTIONS(7837), 1,
      anon_sym_QMARK,
    ACTIONS(7839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7841), 1,
      anon_sym_bitor,
    ACTIONS(7843), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8097), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(7827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [151267] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6859), 1,
      anon_sym_COMMA,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8099), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [151361] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7815), 1,
      anon_sym_SLASH,
    ACTIONS(7821), 1,
      anon_sym_PIPE,
    ACTIONS(7825), 1,
      anon_sym_AMP,
    ACTIONS(7831), 1,
      anon_sym_GT_EQ,
    ACTIONS(7839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7841), 1,
      anon_sym_bitor,
    ACTIONS(7843), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6271), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [151449] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7815), 1,
      anon_sym_SLASH,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(5724), 7,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5726), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [151513] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8101), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [151605] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8103), 1,
      anon_sym_COMMA,
    ACTIONS(8105), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [151699] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8107), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [151791] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(5775), 8,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(5777), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [151851] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7967), 1,
      anon_sym_COMMA,
    ACTIONS(7973), 1,
      anon_sym_SLASH,
    ACTIONS(7979), 1,
      anon_sym_PIPE,
    ACTIONS(7983), 1,
      anon_sym_AMP,
    ACTIONS(7989), 1,
      anon_sym_GT_EQ,
    ACTIONS(7995), 1,
      anon_sym_QMARK,
    ACTIONS(7997), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7999), 1,
      anon_sym_bitor,
    ACTIONS(8001), 1,
      anon_sym_bitand,
    ACTIONS(8109), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7969), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7971), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7975), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7977), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7981), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7991), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7985), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7987), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [151945] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8111), 1,
      anon_sym_COMMA,
    ACTIONS(8113), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [152039] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(6859), 1,
      anon_sym_COMMA,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8115), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [152133] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8117), 1,
      anon_sym_COMMA,
    ACTIONS(8119), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [152227] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7815), 1,
      anon_sym_SLASH,
    ACTIONS(7821), 1,
      anon_sym_PIPE,
    ACTIONS(7825), 1,
      anon_sym_AMP,
    ACTIONS(7831), 1,
      anon_sym_GT_EQ,
    ACTIONS(7837), 1,
      anon_sym_QMARK,
    ACTIONS(7839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7841), 1,
      anon_sym_bitor,
    ACTIONS(7843), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(5936), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [152319] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8121), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [152410] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7351), 1,
      sym_identifier,
    ACTIONS(7353), 1,
      anon_sym_LPAREN2,
    ACTIONS(7371), 1,
      anon_sym_STAR,
    ACTIONS(7373), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    STATE(2372), 1,
      sym_pointer_type_declarator,
    STATE(6159), 1,
      sym__type_declarator,
    STATE(7781), 1,
      sym_ms_based_modifier,
    STATE(4628), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2340), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [152479] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4432), 1,
      anon_sym_RBRACK,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7815), 1,
      anon_sym_SLASH,
    ACTIONS(7821), 1,
      anon_sym_PIPE,
    ACTIONS(7825), 1,
      anon_sym_AMP,
    ACTIONS(7831), 1,
      anon_sym_GT_EQ,
    ACTIONS(7837), 1,
      anon_sym_QMARK,
    ACTIONS(7839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7841), 1,
      anon_sym_bitor,
    ACTIONS(7843), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [152570] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8123), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [152661] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8125), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [152752] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4422), 1,
      anon_sym_RBRACK,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7815), 1,
      anon_sym_SLASH,
    ACTIONS(7821), 1,
      anon_sym_PIPE,
    ACTIONS(7825), 1,
      anon_sym_AMP,
    ACTIONS(7831), 1,
      anon_sym_GT_EQ,
    ACTIONS(7837), 1,
      anon_sym_QMARK,
    ACTIONS(7839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7841), 1,
      anon_sym_bitor,
    ACTIONS(7843), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [152843] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8127), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [152934] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    ACTIONS(7420), 1,
      anon_sym_STAR,
    ACTIONS(7422), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7424), 1,
      anon_sym_AMP,
    STATE(3657), 1,
      sym_parameter_list,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(6100), 1,
      sym__abstract_declarator,
    STATE(4424), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6297), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(6915), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [153001] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8129), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [153092] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7351), 1,
      sym_identifier,
    ACTIONS(7353), 1,
      anon_sym_LPAREN2,
    ACTIONS(7355), 1,
      anon_sym_STAR,
    ACTIONS(7357), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7359), 1,
      anon_sym_AMP,
    STATE(2372), 1,
      sym_pointer_type_declarator,
    STATE(6457), 1,
      sym__type_declarator,
    STATE(7983), 1,
      sym_ms_based_modifier,
    STATE(4628), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7363), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2340), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [153161] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7351), 1,
      sym_identifier,
    ACTIONS(7353), 1,
      anon_sym_LPAREN2,
    ACTIONS(7355), 1,
      anon_sym_STAR,
    ACTIONS(7357), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7359), 1,
      anon_sym_AMP,
    STATE(2372), 1,
      sym_pointer_type_declarator,
    STATE(6441), 1,
      sym__type_declarator,
    STATE(7983), 1,
      sym_ms_based_modifier,
    STATE(4628), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7363), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2340), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [153230] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8131), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [153321] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7351), 1,
      sym_identifier,
    ACTIONS(7353), 1,
      anon_sym_LPAREN2,
    ACTIONS(7355), 1,
      anon_sym_STAR,
    ACTIONS(7357), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7359), 1,
      anon_sym_AMP,
    STATE(2372), 1,
      sym_pointer_type_declarator,
    STATE(6484), 1,
      sym__type_declarator,
    STATE(7983), 1,
      sym_ms_based_modifier,
    STATE(4628), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7363), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2340), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [153390] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7815), 1,
      anon_sym_SLASH,
    ACTIONS(7821), 1,
      anon_sym_PIPE,
    ACTIONS(7825), 1,
      anon_sym_AMP,
    ACTIONS(7831), 1,
      anon_sym_GT_EQ,
    ACTIONS(7837), 1,
      anon_sym_QMARK,
    ACTIONS(7839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7841), 1,
      anon_sym_bitor,
    ACTIONS(7843), 1,
      anon_sym_bitand,
    ACTIONS(8133), 1,
      anon_sym_RBRACK,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [153481] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8135), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [153572] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4440), 1,
      anon_sym_RBRACK,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7815), 1,
      anon_sym_SLASH,
    ACTIONS(7821), 1,
      anon_sym_PIPE,
    ACTIONS(7825), 1,
      anon_sym_AMP,
    ACTIONS(7831), 1,
      anon_sym_GT_EQ,
    ACTIONS(7837), 1,
      anon_sym_QMARK,
    ACTIONS(7839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7841), 1,
      anon_sym_bitor,
    ACTIONS(7843), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [153663] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7973), 1,
      anon_sym_SLASH,
    ACTIONS(7979), 1,
      anon_sym_PIPE,
    ACTIONS(7983), 1,
      anon_sym_AMP,
    ACTIONS(7989), 1,
      anon_sym_GT_EQ,
    ACTIONS(7995), 1,
      anon_sym_QMARK,
    ACTIONS(7997), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7999), 1,
      anon_sym_bitor,
    ACTIONS(8001), 1,
      anon_sym_bitand,
    ACTIONS(8137), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7969), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7971), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7975), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7977), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7981), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7991), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7985), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7987), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [153754] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7815), 1,
      anon_sym_SLASH,
    ACTIONS(7821), 1,
      anon_sym_PIPE,
    ACTIONS(7825), 1,
      anon_sym_AMP,
    ACTIONS(7831), 1,
      anon_sym_GT_EQ,
    ACTIONS(7837), 1,
      anon_sym_QMARK,
    ACTIONS(7839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7841), 1,
      anon_sym_bitor,
    ACTIONS(7843), 1,
      anon_sym_bitand,
    ACTIONS(8139), 1,
      anon_sym_RBRACK,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [153845] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4288), 1,
      anon_sym_RBRACK,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7815), 1,
      anon_sym_SLASH,
    ACTIONS(7821), 1,
      anon_sym_PIPE,
    ACTIONS(7825), 1,
      anon_sym_AMP,
    ACTIONS(7831), 1,
      anon_sym_GT_EQ,
    ACTIONS(7837), 1,
      anon_sym_QMARK,
    ACTIONS(7839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7841), 1,
      anon_sym_bitor,
    ACTIONS(7843), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [153936] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7351), 1,
      sym_identifier,
    ACTIONS(7353), 1,
      anon_sym_LPAREN2,
    ACTIONS(7392), 1,
      anon_sym_STAR,
    ACTIONS(7394), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7396), 1,
      anon_sym_AMP,
    STATE(2277), 1,
      sym__type_declarator,
    STATE(2372), 1,
      sym_pointer_type_declarator,
    STATE(8058), 1,
      sym_ms_based_modifier,
    STATE(4628), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7363), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2340), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [154005] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4452), 1,
      anon_sym_RBRACK,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7815), 1,
      anon_sym_SLASH,
    ACTIONS(7821), 1,
      anon_sym_PIPE,
    ACTIONS(7825), 1,
      anon_sym_AMP,
    ACTIONS(7831), 1,
      anon_sym_GT_EQ,
    ACTIONS(7837), 1,
      anon_sym_QMARK,
    ACTIONS(7839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7841), 1,
      anon_sym_bitor,
    ACTIONS(7843), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [154096] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(5511), 1,
      sym_identifier,
    ACTIONS(5521), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    ACTIONS(6798), 1,
      anon_sym_STAR,
    ACTIONS(6800), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6802), 1,
      anon_sym_AMP,
    STATE(5079), 1,
      sym_ms_call_modifier,
    STATE(5526), 1,
      sym__declarator,
    STATE(5695), 1,
      sym__scope_resolution,
    STATE(6888), 1,
      sym_init_declarator,
    STATE(7894), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1825), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [154177] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7351), 1,
      sym_identifier,
    ACTIONS(7353), 1,
      anon_sym_LPAREN2,
    ACTIONS(7392), 1,
      anon_sym_STAR,
    ACTIONS(7394), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7396), 1,
      anon_sym_AMP,
    STATE(2311), 1,
      sym__type_declarator,
    STATE(2372), 1,
      sym_pointer_type_declarator,
    STATE(8058), 1,
      sym_ms_based_modifier,
    STATE(4628), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7363), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2340), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [154246] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6953), 1,
      anon_sym_const,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    ACTIONS(7365), 1,
      anon_sym_STAR,
    ACTIONS(7367), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7369), 1,
      anon_sym_AMP,
    STATE(3569), 1,
      sym_parameter_list,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(6095), 1,
      sym__abstract_declarator,
    STATE(4650), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5555), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6945), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [154313] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(7634), 2,
      anon_sym_AMP,
      anon_sym_LBRACK,
    STATE(4424), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6915), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
    ACTIONS(7632), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [154364] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7973), 1,
      anon_sym_SLASH,
    ACTIONS(7979), 1,
      anon_sym_PIPE,
    ACTIONS(7983), 1,
      anon_sym_AMP,
    ACTIONS(7989), 1,
      anon_sym_GT_EQ,
    ACTIONS(7995), 1,
      anon_sym_QMARK,
    ACTIONS(7997), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7999), 1,
      anon_sym_bitor,
    ACTIONS(8001), 1,
      anon_sym_bitand,
    ACTIONS(8141), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7969), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7971), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7975), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7977), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7981), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7991), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7985), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7987), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [154455] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8143), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [154546] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8145), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [154637] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8147), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [154728] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8149), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [154819] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    ACTIONS(7420), 1,
      anon_sym_STAR,
    ACTIONS(7422), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7424), 1,
      anon_sym_AMP,
    STATE(3657), 1,
      sym_parameter_list,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(6102), 1,
      sym__abstract_declarator,
    STATE(4424), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7753), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(6915), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [154886] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(5513), 1,
      anon_sym_COLON,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(7699), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7705), 1,
      anon_sym_const,
    ACTIONS(8151), 1,
      anon_sym_STAR,
    ACTIONS(8153), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8155), 1,
      anon_sym_AMP,
    STATE(3982), 1,
      sym_parameter_list,
    STATE(5201), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6560), 1,
      sym__abstract_declarator,
    ACTIONS(7701), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7703), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4527), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5086), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7697), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [154963] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(5555), 1,
      anon_sym_COLON,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(7699), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7705), 1,
      anon_sym_const,
    ACTIONS(8151), 1,
      anon_sym_STAR,
    ACTIONS(8153), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8155), 1,
      anon_sym_AMP,
    STATE(3982), 1,
      sym_parameter_list,
    STATE(5201), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6572), 1,
      sym__abstract_declarator,
    ACTIONS(7701), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7703), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(5002), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5085), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7697), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [155040] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7377), 1,
      sym_identifier,
    ACTIONS(7379), 1,
      anon_sym_LPAREN2,
    ACTIONS(7381), 1,
      anon_sym_STAR,
    ACTIONS(7383), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7385), 1,
      anon_sym_AMP,
    STATE(5839), 1,
      sym__type_declarator,
    STATE(6116), 1,
      sym_pointer_type_declarator,
    STATE(8041), 1,
      sym_ms_based_modifier,
    STATE(4628), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7387), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6111), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [155109] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(3803), 1,
      anon_sym_LPAREN2,
    ACTIONS(3805), 1,
      anon_sym_STAR,
    ACTIONS(3807), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3809), 1,
      anon_sym_AMP,
    ACTIONS(4841), 1,
      sym_identifier,
    ACTIONS(5523), 1,
      anon_sym_LBRACK,
    ACTIONS(5825), 1,
      anon_sym_COLON_COLON,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(5610), 1,
      sym__scope_resolution,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6433), 1,
      sym__declarator,
    STATE(6545), 1,
      sym__abstract_declarator,
    STATE(8318), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [155192] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6953), 1,
      anon_sym_const,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    ACTIONS(7365), 1,
      anon_sym_STAR,
    ACTIONS(7367), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7369), 1,
      anon_sym_AMP,
    STATE(3569), 1,
      sym_parameter_list,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(6060), 1,
      sym__abstract_declarator,
    STATE(4650), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7795), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6945), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [155259] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4910), 1,
      anon_sym_COLON,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(8157), 1,
      anon_sym_LBRACE,
    STATE(4779), 1,
      sym_field_declaration_list,
    STATE(4845), 1,
      sym_attribute_specifier,
    STATE(6774), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(4902), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(4904), 25,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_try,
      anon_sym_requires,
  [155320] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8159), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [155411] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7351), 1,
      sym_identifier,
    ACTIONS(7353), 1,
      anon_sym_LPAREN2,
    ACTIONS(7371), 1,
      anon_sym_STAR,
    ACTIONS(7373), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    STATE(2372), 1,
      sym_pointer_type_declarator,
    STATE(6166), 1,
      sym__type_declarator,
    STATE(7781), 1,
      sym_ms_based_modifier,
    STATE(4628), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2340), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [155480] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8161), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [155571] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7377), 1,
      sym_identifier,
    ACTIONS(7379), 1,
      anon_sym_LPAREN2,
    ACTIONS(7381), 1,
      anon_sym_STAR,
    ACTIONS(7383), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7385), 1,
      anon_sym_AMP,
    STATE(5837), 1,
      sym__type_declarator,
    STATE(6116), 1,
      sym_pointer_type_declarator,
    STATE(8041), 1,
      sym_ms_based_modifier,
    STATE(4628), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7387), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6111), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [155640] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8163), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [155731] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8165), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [155822] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7807), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7815), 1,
      anon_sym_SLASH,
    ACTIONS(7821), 1,
      anon_sym_PIPE,
    ACTIONS(7825), 1,
      anon_sym_AMP,
    ACTIONS(7831), 1,
      anon_sym_GT_EQ,
    ACTIONS(7837), 1,
      anon_sym_QMARK,
    ACTIONS(7839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7841), 1,
      anon_sym_bitor,
    ACTIONS(7843), 1,
      anon_sym_bitand,
    ACTIONS(8167), 1,
      anon_sym_RBRACK,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [155913] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8169), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [156004] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7815), 1,
      anon_sym_SLASH,
    ACTIONS(7821), 1,
      anon_sym_PIPE,
    ACTIONS(7825), 1,
      anon_sym_AMP,
    ACTIONS(7831), 1,
      anon_sym_GT_EQ,
    ACTIONS(7837), 1,
      anon_sym_QMARK,
    ACTIONS(7839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7841), 1,
      anon_sym_bitor,
    ACTIONS(7843), 1,
      anon_sym_bitand,
    ACTIONS(8171), 1,
      anon_sym_RBRACK,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [156095] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(5511), 1,
      sym_identifier,
    ACTIONS(5521), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    ACTIONS(6798), 1,
      anon_sym_STAR,
    ACTIONS(6800), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6802), 1,
      anon_sym_AMP,
    STATE(5092), 1,
      sym_ms_call_modifier,
    STATE(5517), 1,
      sym__declarator,
    STATE(5695), 1,
      sym__scope_resolution,
    STATE(7246), 1,
      sym_init_declarator,
    STATE(7894), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1825), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [156176] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8173), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [156267] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8175), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [156358] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7377), 1,
      sym_identifier,
    ACTIONS(7379), 1,
      anon_sym_LPAREN2,
    ACTIONS(7381), 1,
      anon_sym_STAR,
    ACTIONS(7383), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7385), 1,
      anon_sym_AMP,
    STATE(5835), 1,
      sym__type_declarator,
    STATE(6116), 1,
      sym_pointer_type_declarator,
    STATE(8041), 1,
      sym_ms_based_modifier,
    STATE(4628), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7387), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6111), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [156427] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5101), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5103), 34,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [156472] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4398), 1,
      anon_sym_RBRACK,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7815), 1,
      anon_sym_SLASH,
    ACTIONS(7821), 1,
      anon_sym_PIPE,
    ACTIONS(7825), 1,
      anon_sym_AMP,
    ACTIONS(7831), 1,
      anon_sym_GT_EQ,
    ACTIONS(7837), 1,
      anon_sym_QMARK,
    ACTIONS(7839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7841), 1,
      anon_sym_bitor,
    ACTIONS(7843), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [156563] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8177), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [156654] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4356), 1,
      anon_sym_RBRACK,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7815), 1,
      anon_sym_SLASH,
    ACTIONS(7821), 1,
      anon_sym_PIPE,
    ACTIONS(7825), 1,
      anon_sym_AMP,
    ACTIONS(7831), 1,
      anon_sym_GT_EQ,
    ACTIONS(7837), 1,
      anon_sym_QMARK,
    ACTIONS(7839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7841), 1,
      anon_sym_bitor,
    ACTIONS(7843), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [156745] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5714), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5716), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [156790] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    ACTIONS(7420), 1,
      anon_sym_STAR,
    ACTIONS(7422), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7424), 1,
      anon_sym_AMP,
    STATE(3657), 1,
      sym_parameter_list,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(6108), 1,
      sym__abstract_declarator,
    STATE(4424), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5555), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(6915), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [156857] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7406), 1,
      sym_identifier,
    ACTIONS(7408), 1,
      anon_sym_LPAREN2,
    ACTIONS(7410), 1,
      anon_sym_STAR,
    ACTIONS(7412), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7414), 1,
      anon_sym_AMP,
    STATE(2929), 1,
      sym__type_declarator,
    STATE(3264), 1,
      sym_pointer_type_declarator,
    STATE(7901), 1,
      sym_ms_based_modifier,
    STATE(4628), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7418), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7416), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3266), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [156926] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4268), 1,
      anon_sym_RBRACK,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7815), 1,
      anon_sym_SLASH,
    ACTIONS(7821), 1,
      anon_sym_PIPE,
    ACTIONS(7825), 1,
      anon_sym_AMP,
    ACTIONS(7831), 1,
      anon_sym_GT_EQ,
    ACTIONS(7837), 1,
      anon_sym_QMARK,
    ACTIONS(7839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7841), 1,
      anon_sym_bitor,
    ACTIONS(7843), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [157017] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8179), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [157108] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4266), 1,
      anon_sym_RBRACK,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7815), 1,
      anon_sym_SLASH,
    ACTIONS(7821), 1,
      anon_sym_PIPE,
    ACTIONS(7825), 1,
      anon_sym_AMP,
    ACTIONS(7831), 1,
      anon_sym_GT_EQ,
    ACTIONS(7837), 1,
      anon_sym_QMARK,
    ACTIONS(7839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7841), 1,
      anon_sym_bitor,
    ACTIONS(7843), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [157199] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8181), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [157290] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4424), 1,
      anon_sym_RBRACK,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7815), 1,
      anon_sym_SLASH,
    ACTIONS(7821), 1,
      anon_sym_PIPE,
    ACTIONS(7825), 1,
      anon_sym_AMP,
    ACTIONS(7831), 1,
      anon_sym_GT_EQ,
    ACTIONS(7837), 1,
      anon_sym_QMARK,
    ACTIONS(7839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7841), 1,
      anon_sym_bitor,
    ACTIONS(7843), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [157381] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8183), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [157472] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(5511), 1,
      sym_identifier,
    ACTIONS(5521), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    ACTIONS(6798), 1,
      anon_sym_STAR,
    ACTIONS(6800), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6802), 1,
      anon_sym_AMP,
    STATE(5081), 1,
      sym_ms_call_modifier,
    STATE(5508), 1,
      sym__declarator,
    STATE(5695), 1,
      sym__scope_resolution,
    STATE(7051), 1,
      sym_init_declarator,
    STATE(7894), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1825), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [157553] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7973), 1,
      anon_sym_SLASH,
    ACTIONS(7979), 1,
      anon_sym_PIPE,
    ACTIONS(7983), 1,
      anon_sym_AMP,
    ACTIONS(7989), 1,
      anon_sym_GT_EQ,
    ACTIONS(7995), 1,
      anon_sym_QMARK,
    ACTIONS(7997), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7999), 1,
      anon_sym_bitor,
    ACTIONS(8001), 1,
      anon_sym_bitand,
    ACTIONS(8185), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7969), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7971), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7975), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7977), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7981), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7991), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7985), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7987), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [157644] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8187), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [157735] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8189), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [157826] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8191), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [157917] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_const,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(6281), 1,
      sym_auto,
    ACTIONS(6283), 1,
      anon_sym_decltype,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(7539), 1,
      anon_sym_STAR,
    ACTIONS(7541), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7543), 1,
      anon_sym_AMP,
    STATE(2951), 1,
      sym_decltype_auto,
    STATE(3826), 1,
      sym_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6304), 1,
      sym__abstract_declarator,
    STATE(4777), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7537), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7319), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [157990] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8193), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [158081] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5670), 1,
      sym_literal_suffix,
    ACTIONS(5197), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(5199), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [158128] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8195), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [158219] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4396), 1,
      anon_sym_RBRACK,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7815), 1,
      anon_sym_SLASH,
    ACTIONS(7821), 1,
      anon_sym_PIPE,
    ACTIONS(7825), 1,
      anon_sym_AMP,
    ACTIONS(7831), 1,
      anon_sym_GT_EQ,
    ACTIONS(7837), 1,
      anon_sym_QMARK,
    ACTIONS(7839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7841), 1,
      anon_sym_bitor,
    ACTIONS(7843), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [158310] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7335), 1,
      sym_identifier,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7339), 1,
      anon_sym_STAR,
    ACTIONS(7341), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7343), 1,
      anon_sym_AMP,
    STATE(3003), 1,
      sym__type_declarator,
    STATE(3379), 1,
      sym_pointer_type_declarator,
    STATE(7618), 1,
      sym_ms_based_modifier,
    STATE(4628), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7349), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7347), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3385), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [158379] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(5511), 1,
      sym_identifier,
    ACTIONS(5521), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    ACTIONS(6798), 1,
      anon_sym_STAR,
    ACTIONS(6800), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6802), 1,
      anon_sym_AMP,
    STATE(5107), 1,
      sym_ms_call_modifier,
    STATE(5521), 1,
      sym__declarator,
    STATE(5695), 1,
      sym__scope_resolution,
    STATE(7098), 1,
      sym_init_declarator,
    STATE(7894), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1825), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [158460] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8197), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [158551] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8199), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [158642] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8201), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [158733] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5670), 1,
      sym_literal_suffix,
    ACTIONS(3769), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(3761), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [158780] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    ACTIONS(7420), 1,
      anon_sym_STAR,
    ACTIONS(7422), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7424), 1,
      anon_sym_AMP,
    STATE(3657), 1,
      sym_parameter_list,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(6115), 1,
      sym__abstract_declarator,
    STATE(4424), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7795), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(6915), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [158847] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8203), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [158938] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7815), 1,
      anon_sym_SLASH,
    ACTIONS(7821), 1,
      anon_sym_PIPE,
    ACTIONS(7825), 1,
      anon_sym_AMP,
    ACTIONS(7831), 1,
      anon_sym_GT_EQ,
    ACTIONS(7837), 1,
      anon_sym_QMARK,
    ACTIONS(7839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7841), 1,
      anon_sym_bitor,
    ACTIONS(7843), 1,
      anon_sym_bitand,
    ACTIONS(8205), 1,
      anon_sym_RBRACK,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [159029] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8207), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [159120] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8209), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [159211] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(7857), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [159302] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7335), 1,
      sym_identifier,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7339), 1,
      anon_sym_STAR,
    ACTIONS(7341), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7343), 1,
      anon_sym_AMP,
    STATE(2982), 1,
      sym__type_declarator,
    STATE(3379), 1,
      sym_pointer_type_declarator,
    STATE(7618), 1,
      sym_ms_based_modifier,
    STATE(4628), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7349), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7347), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3385), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [159371] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8211), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [159462] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8213), 1,
      anon_sym_COMMA,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [159553] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8215), 1,
      anon_sym_COMMA,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [159644] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8217), 1,
      anon_sym_COMMA,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [159735] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8219), 1,
      anon_sym_COMMA,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [159826] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8221), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [159917] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8223), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [160008] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7351), 1,
      sym_identifier,
    ACTIONS(7353), 1,
      anon_sym_LPAREN2,
    ACTIONS(7392), 1,
      anon_sym_STAR,
    ACTIONS(7394), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7396), 1,
      anon_sym_AMP,
    STATE(2267), 1,
      sym__type_declarator,
    STATE(2372), 1,
      sym_pointer_type_declarator,
    STATE(8058), 1,
      sym_ms_based_modifier,
    STATE(4628), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7363), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2340), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [160077] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8225), 1,
      anon_sym_COMMA,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [160168] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7335), 1,
      sym_identifier,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7339), 1,
      anon_sym_STAR,
    ACTIONS(7341), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7343), 1,
      anon_sym_AMP,
    STATE(3023), 1,
      sym__type_declarator,
    STATE(3379), 1,
      sym_pointer_type_declarator,
    STATE(7618), 1,
      sym_ms_based_modifier,
    STATE(4628), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7349), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7347), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3385), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [160237] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4426), 1,
      anon_sym_RBRACK,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7815), 1,
      anon_sym_SLASH,
    ACTIONS(7821), 1,
      anon_sym_PIPE,
    ACTIONS(7825), 1,
      anon_sym_AMP,
    ACTIONS(7831), 1,
      anon_sym_GT_EQ,
    ACTIONS(7837), 1,
      anon_sym_QMARK,
    ACTIONS(7839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7841), 1,
      anon_sym_bitor,
    ACTIONS(7843), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [160328] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4446), 1,
      anon_sym_RBRACK,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7815), 1,
      anon_sym_SLASH,
    ACTIONS(7821), 1,
      anon_sym_PIPE,
    ACTIONS(7825), 1,
      anon_sym_AMP,
    ACTIONS(7831), 1,
      anon_sym_GT_EQ,
    ACTIONS(7837), 1,
      anon_sym_QMARK,
    ACTIONS(7839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7841), 1,
      anon_sym_bitor,
    ACTIONS(7843), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [160419] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8227), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [160510] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6299), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6301), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [160555] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6289), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6291), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [160600] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7377), 1,
      sym_identifier,
    ACTIONS(7379), 1,
      anon_sym_LPAREN2,
    ACTIONS(7400), 1,
      anon_sym_STAR,
    ACTIONS(7402), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7404), 1,
      anon_sym_AMP,
    STATE(6086), 1,
      sym__type_declarator,
    STATE(6116), 1,
      sym_pointer_type_declarator,
    STATE(7809), 1,
      sym_ms_based_modifier,
    STATE(4628), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7152), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7387), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6111), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [160669] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7377), 1,
      sym_identifier,
    ACTIONS(7379), 1,
      anon_sym_LPAREN2,
    ACTIONS(7400), 1,
      anon_sym_STAR,
    ACTIONS(7402), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7404), 1,
      anon_sym_AMP,
    STATE(6044), 1,
      sym__type_declarator,
    STATE(6116), 1,
      sym_pointer_type_declarator,
    STATE(7809), 1,
      sym_ms_based_modifier,
    STATE(4628), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7152), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7387), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6111), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [160738] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8229), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [160829] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8231), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [160920] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7973), 1,
      anon_sym_SLASH,
    ACTIONS(7979), 1,
      anon_sym_PIPE,
    ACTIONS(7983), 1,
      anon_sym_AMP,
    ACTIONS(7989), 1,
      anon_sym_GT_EQ,
    ACTIONS(7995), 1,
      anon_sym_QMARK,
    ACTIONS(7997), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7999), 1,
      anon_sym_bitor,
    ACTIONS(8001), 1,
      anon_sym_bitand,
    ACTIONS(8233), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7969), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7971), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7975), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7977), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7981), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7991), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7985), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7987), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [161011] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8235), 1,
      anon_sym_COMMA,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [161102] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(5511), 1,
      sym_identifier,
    ACTIONS(5521), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    ACTIONS(6798), 1,
      anon_sym_STAR,
    ACTIONS(6800), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6802), 1,
      anon_sym_AMP,
    STATE(5126), 1,
      sym_ms_call_modifier,
    STATE(5545), 1,
      sym__declarator,
    STATE(5695), 1,
      sym__scope_resolution,
    STATE(6867), 1,
      sym_init_declarator,
    STATE(7894), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1825), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [161183] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4414), 1,
      anon_sym_RBRACK,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7815), 1,
      anon_sym_SLASH,
    ACTIONS(7821), 1,
      anon_sym_PIPE,
    ACTIONS(7825), 1,
      anon_sym_AMP,
    ACTIONS(7831), 1,
      anon_sym_GT_EQ,
    ACTIONS(7837), 1,
      anon_sym_QMARK,
    ACTIONS(7839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7841), 1,
      anon_sym_bitor,
    ACTIONS(7843), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [161274] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7406), 1,
      sym_identifier,
    ACTIONS(7408), 1,
      anon_sym_LPAREN2,
    ACTIONS(7410), 1,
      anon_sym_STAR,
    ACTIONS(7412), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7414), 1,
      anon_sym_AMP,
    STATE(2936), 1,
      sym__type_declarator,
    STATE(3264), 1,
      sym_pointer_type_declarator,
    STATE(7901), 1,
      sym_ms_based_modifier,
    STATE(4628), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7418), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7416), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3266), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [161343] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8237), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [161434] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8239), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [161525] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7815), 1,
      anon_sym_SLASH,
    ACTIONS(7821), 1,
      anon_sym_PIPE,
    ACTIONS(7825), 1,
      anon_sym_AMP,
    ACTIONS(7831), 1,
      anon_sym_GT_EQ,
    ACTIONS(7837), 1,
      anon_sym_QMARK,
    ACTIONS(7839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7841), 1,
      anon_sym_bitor,
    ACTIONS(7843), 1,
      anon_sym_bitand,
    ACTIONS(8241), 1,
      anon_sym_RBRACK,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [161616] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8243), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [161707] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7815), 1,
      anon_sym_SLASH,
    ACTIONS(7821), 1,
      anon_sym_PIPE,
    ACTIONS(7825), 1,
      anon_sym_AMP,
    ACTIONS(7831), 1,
      anon_sym_GT_EQ,
    ACTIONS(7837), 1,
      anon_sym_QMARK,
    ACTIONS(7839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7841), 1,
      anon_sym_bitor,
    ACTIONS(7843), 1,
      anon_sym_bitand,
    ACTIONS(8245), 1,
      anon_sym_RBRACK,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [161798] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_const,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(6281), 1,
      sym_auto,
    ACTIONS(6283), 1,
      anon_sym_decltype,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(7539), 1,
      anon_sym_STAR,
    ACTIONS(7541), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7543), 1,
      anon_sym_AMP,
    STATE(2951), 1,
      sym_decltype_auto,
    STATE(3826), 1,
      sym_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6296), 1,
      sym__abstract_declarator,
    STATE(4803), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7526), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7319), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [161871] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8247), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [161962] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(5511), 1,
      sym_identifier,
    ACTIONS(5521), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    ACTIONS(6798), 1,
      anon_sym_STAR,
    ACTIONS(6800), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6802), 1,
      anon_sym_AMP,
    STATE(5063), 1,
      sym_ms_call_modifier,
    STATE(5548), 1,
      sym__declarator,
    STATE(5695), 1,
      sym__scope_resolution,
    STATE(7111), 1,
      sym_init_declarator,
    STATE(7894), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1825), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [162043] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7377), 1,
      sym_identifier,
    ACTIONS(7379), 1,
      anon_sym_LPAREN2,
    ACTIONS(7400), 1,
      anon_sym_STAR,
    ACTIONS(7402), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7404), 1,
      anon_sym_AMP,
    STATE(6047), 1,
      sym__type_declarator,
    STATE(6116), 1,
      sym_pointer_type_declarator,
    STATE(7809), 1,
      sym_ms_based_modifier,
    STATE(4628), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7152), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7387), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6111), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [162112] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6953), 1,
      anon_sym_const,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    ACTIONS(7365), 1,
      anon_sym_STAR,
    ACTIONS(7367), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7369), 1,
      anon_sym_AMP,
    STATE(3569), 1,
      sym_parameter_list,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(6056), 1,
      sym__abstract_declarator,
    STATE(4650), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7753), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6945), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [162179] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8249), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [162270] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8251), 1,
      anon_sym_RBRACE,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [162361] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8253), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [162452] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6103), 1,
      anon_sym_LT,
    STATE(1741), 1,
      sym_template_argument_list,
    STATE(2269), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5303), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(4603), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5305), 26,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [162507] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4272), 1,
      anon_sym_RBRACK,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7815), 1,
      anon_sym_SLASH,
    ACTIONS(7821), 1,
      anon_sym_PIPE,
    ACTIONS(7825), 1,
      anon_sym_AMP,
    ACTIONS(7831), 1,
      anon_sym_GT_EQ,
    ACTIONS(7837), 1,
      anon_sym_QMARK,
    ACTIONS(7839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7841), 1,
      anon_sym_bitor,
    ACTIONS(7843), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [162598] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8255), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [162689] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4284), 1,
      anon_sym_RBRACK,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7815), 1,
      anon_sym_SLASH,
    ACTIONS(7821), 1,
      anon_sym_PIPE,
    ACTIONS(7825), 1,
      anon_sym_AMP,
    ACTIONS(7831), 1,
      anon_sym_GT_EQ,
    ACTIONS(7837), 1,
      anon_sym_QMARK,
    ACTIONS(7839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7841), 1,
      anon_sym_bitor,
    ACTIONS(7843), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [162780] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4286), 1,
      anon_sym_RBRACK,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7815), 1,
      anon_sym_SLASH,
    ACTIONS(7821), 1,
      anon_sym_PIPE,
    ACTIONS(7825), 1,
      anon_sym_AMP,
    ACTIONS(7831), 1,
      anon_sym_GT_EQ,
    ACTIONS(7837), 1,
      anon_sym_QMARK,
    ACTIONS(7839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7841), 1,
      anon_sym_bitor,
    ACTIONS(7843), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [162871] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8257), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [162962] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8259), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [163053] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8261), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [163144] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8263), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [163235] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8265), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [163326] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4628), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4824), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
    ACTIONS(8044), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
    ACTIONS(4822), 18,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
  [163375] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(4910), 1,
      anon_sym_COLON,
    ACTIONS(5575), 1,
      anon_sym_LBRACE,
    STATE(1940), 1,
      sym_attribute_specifier,
    STATE(5042), 1,
      sym_field_declaration_list,
    STATE(6696), 1,
      sym_virtual_specifier,
    STATE(7382), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(4904), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(4902), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [163436] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4458), 1,
      anon_sym_RBRACK,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7815), 1,
      anon_sym_SLASH,
    ACTIONS(7821), 1,
      anon_sym_PIPE,
    ACTIONS(7825), 1,
      anon_sym_AMP,
    ACTIONS(7831), 1,
      anon_sym_GT_EQ,
    ACTIONS(7837), 1,
      anon_sym_QMARK,
    ACTIONS(7839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7841), 1,
      anon_sym_bitor,
    ACTIONS(7843), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [163527] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4296), 1,
      anon_sym_RBRACK,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7815), 1,
      anon_sym_SLASH,
    ACTIONS(7821), 1,
      anon_sym_PIPE,
    ACTIONS(7825), 1,
      anon_sym_AMP,
    ACTIONS(7831), 1,
      anon_sym_GT_EQ,
    ACTIONS(7837), 1,
      anon_sym_QMARK,
    ACTIONS(7839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7841), 1,
      anon_sym_bitor,
    ACTIONS(7843), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [163618] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8267), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [163709] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8269), 1,
      anon_sym_RPAREN,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [163800] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8271), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [163891] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_auto,
    ACTIONS(121), 1,
      anon_sym_decltype,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1755), 1,
      anon_sym_enum,
    ACTIONS(1757), 1,
      anon_sym_class,
    ACTIONS(1759), 1,
      anon_sym_struct,
    ACTIONS(1761), 1,
      anon_sym_union,
    ACTIONS(1787), 1,
      anon_sym_typename,
    ACTIONS(4526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8273), 1,
      sym_identifier,
    ACTIONS(8275), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8279), 1,
      anon_sym_EQ,
    STATE(2435), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2614), 1,
      sym__type_specifier,
    STATE(2687), 1,
      sym_decltype_auto,
    STATE(2805), 1,
      sym_primitive_type,
    STATE(3260), 1,
      sym_qualified_type_identifier,
    STATE(6380), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    ACTIONS(8277), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(2618), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(53), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2629), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [163980] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7351), 1,
      sym_identifier,
    ACTIONS(7353), 1,
      anon_sym_LPAREN2,
    ACTIONS(7371), 1,
      anon_sym_STAR,
    ACTIONS(7373), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    STATE(2372), 1,
      sym_pointer_type_declarator,
    STATE(6146), 1,
      sym__type_declarator,
    STATE(7781), 1,
      sym_ms_based_modifier,
    STATE(4628), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2340), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [164049] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(5511), 1,
      sym_identifier,
    ACTIONS(5521), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    ACTIONS(6798), 1,
      anon_sym_STAR,
    ACTIONS(6800), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6802), 1,
      anon_sym_AMP,
    STATE(5151), 1,
      sym_ms_call_modifier,
    STATE(5529), 1,
      sym__declarator,
    STATE(5695), 1,
      sym__scope_resolution,
    STATE(7093), 1,
      sym_init_declarator,
    STATE(7894), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1825), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [164130] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7406), 1,
      sym_identifier,
    ACTIONS(7408), 1,
      anon_sym_LPAREN2,
    ACTIONS(7410), 1,
      anon_sym_STAR,
    ACTIONS(7412), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7414), 1,
      anon_sym_AMP,
    STATE(2880), 1,
      sym__type_declarator,
    STATE(3264), 1,
      sym_pointer_type_declarator,
    STATE(7901), 1,
      sym_ms_based_modifier,
    STATE(4628), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7418), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7416), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3266), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [164199] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7815), 1,
      anon_sym_SLASH,
    ACTIONS(7821), 1,
      anon_sym_PIPE,
    ACTIONS(7825), 1,
      anon_sym_AMP,
    ACTIONS(7831), 1,
      anon_sym_GT_EQ,
    ACTIONS(7837), 1,
      anon_sym_QMARK,
    ACTIONS(7839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7841), 1,
      anon_sym_bitor,
    ACTIONS(7843), 1,
      anon_sym_bitand,
    ACTIONS(8281), 1,
      anon_sym_RBRACK,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [164290] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8287), 1,
      anon_sym___attribute__,
    STATE(4640), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(8285), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8283), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [164339] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8290), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [164430] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4292), 1,
      anon_sym_RBRACK,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7815), 1,
      anon_sym_SLASH,
    ACTIONS(7821), 1,
      anon_sym_PIPE,
    ACTIONS(7825), 1,
      anon_sym_AMP,
    ACTIONS(7831), 1,
      anon_sym_GT_EQ,
    ACTIONS(7837), 1,
      anon_sym_QMARK,
    ACTIONS(7839), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7841), 1,
      anon_sym_bitor,
    ACTIONS(7843), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7811), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7817), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7819), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7823), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7833), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7827), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7829), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [164521] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(8294), 2,
      anon_sym_AMP,
      anon_sym_LBRACK,
    STATE(4424), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6915), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
    ACTIONS(8292), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [164572] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7973), 1,
      anon_sym_SLASH,
    ACTIONS(7979), 1,
      anon_sym_PIPE,
    ACTIONS(7983), 1,
      anon_sym_AMP,
    ACTIONS(7989), 1,
      anon_sym_GT_EQ,
    ACTIONS(7995), 1,
      anon_sym_QMARK,
    ACTIONS(7997), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7999), 1,
      anon_sym_bitor,
    ACTIONS(8001), 1,
      anon_sym_bitand,
    ACTIONS(8296), 1,
      anon_sym_COLON,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(6698), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7969), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7971), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7975), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7977), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7981), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7991), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7985), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7987), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [164663] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    ACTIONS(8298), 1,
      anon_sym_SEMI,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [164754] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6953), 1,
      anon_sym_const,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    ACTIONS(7365), 1,
      anon_sym_STAR,
    ACTIONS(7367), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7369), 1,
      anon_sym_AMP,
    STATE(3569), 1,
      sym_parameter_list,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(6041), 1,
      sym__abstract_declarator,
    STATE(4650), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6297), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6945), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [164821] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4221), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5450), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(8300), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5448), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [164869] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5877), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5879), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [164913] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    ACTIONS(7430), 1,
      anon_sym_STAR,
    ACTIONS(7432), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7434), 1,
      anon_sym_AMP,
    STATE(3784), 1,
      sym_parameter_list,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(6184), 1,
      sym__abstract_declarator,
    STATE(4424), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5555), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6915), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [164979] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8305), 1,
      anon_sym_const,
    ACTIONS(4822), 2,
      anon_sym_AMP,
      anon_sym_LBRACK,
    STATE(4650), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8302), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
    ACTIONS(4824), 19,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [165029] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4808), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2743), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [165073] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5934), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5936), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [165117] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5978), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5980), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [165161] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8308), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8310), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(5428), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5430), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [165209] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5763), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5765), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [165253] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6911), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6913), 1,
      anon_sym_AMP,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(6923), 1,
      anon_sym_DASH_GT,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(6941), 1,
      anon_sym_requires,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    STATE(4859), 1,
      sym_ref_qualifier,
    STATE(5696), 1,
      sym__function_attributes_end,
    STATE(5811), 1,
      sym_trailing_return_type,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5948), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5187), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8312), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [165335] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5787), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5789), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [165379] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6103), 1,
      anon_sym_LT,
    STATE(1741), 1,
      sym_template_argument_list,
    STATE(2537), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5303), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(4615), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5305), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [165433] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(6782), 1,
      sym_identifier,
    ACTIONS(6784), 1,
      anon_sym_STAR,
    ACTIONS(6786), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6788), 1,
      anon_sym_AMP,
    ACTIONS(6790), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    STATE(5090), 1,
      sym_ms_call_modifier,
    STATE(5612), 1,
      sym__scope_resolution,
    STATE(6251), 1,
      sym__declarator,
    STATE(7612), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1825), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [165511] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5982), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5984), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [165555] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5962), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5964), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [165599] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8316), 1,
      anon_sym_LT,
    STATE(1741), 1,
      sym_template_argument_list,
    ACTIONS(3785), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(5187), 29,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_COLON,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
  [165649] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5896), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5898), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [165693] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5892), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5894), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [165737] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(5702), 1,
      anon_sym_LBRACK,
    ACTIONS(5704), 1,
      anon_sym_DOT,
    ACTIONS(7466), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7642), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_EQ,
    ACTIONS(7650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7679), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_AMP,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_bitor,
    ACTIONS(7689), 1,
      anon_sym_bitand,
    STATE(2500), 1,
      sym_argument_list,
    STATE(2503), 1,
      sym_subscript_argument_list,
    ACTIONS(5706), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7240), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7638), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7640), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7648), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7675), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7677), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7681), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7644), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7670), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
  [165825] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    ACTIONS(7430), 1,
      anon_sym_STAR,
    ACTIONS(7432), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7434), 1,
      anon_sym_AMP,
    STATE(3784), 1,
      sym_parameter_list,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(6176), 1,
      sym__abstract_declarator,
    STATE(4424), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6297), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6915), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [165891] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6953), 1,
      anon_sym_const,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    ACTIONS(7528), 1,
      sym_auto,
    ACTIONS(7530), 1,
      anon_sym_decltype,
    ACTIONS(7618), 1,
      anon_sym_STAR,
    ACTIONS(7620), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7622), 1,
      anon_sym_AMP,
    STATE(3964), 1,
      sym_parameter_list,
    STATE(4894), 1,
      sym_decltype_auto,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(6345), 1,
      sym__abstract_declarator,
    STATE(4856), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7526), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6945), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [165963] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5888), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5890), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [166007] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5867), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5869), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [166051] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(6782), 1,
      sym_identifier,
    ACTIONS(6784), 1,
      anon_sym_STAR,
    ACTIONS(6786), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6788), 1,
      anon_sym_AMP,
    ACTIONS(6790), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    STATE(5160), 1,
      sym_ms_call_modifier,
    STATE(5612), 1,
      sym__scope_resolution,
    STATE(6267), 1,
      sym__declarator,
    STATE(7612), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1825), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [166129] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5863), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5865), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [166173] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8310), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(5477), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5479), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [166219] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5946), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5948), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [166263] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5746), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5748), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [166307] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2821), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2819), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [166351] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6032), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6034), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [166395] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5853), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5855), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [166439] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6953), 1,
      anon_sym_const,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    ACTIONS(7528), 1,
      sym_auto,
    ACTIONS(7530), 1,
      anon_sym_decltype,
    ACTIONS(7618), 1,
      anon_sym_STAR,
    ACTIONS(7620), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7622), 1,
      anon_sym_AMP,
    STATE(3964), 1,
      sym_parameter_list,
    STATE(4894), 1,
      sym_decltype_auto,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(6354), 1,
      sym__abstract_declarator,
    STATE(4850), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7537), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6945), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [166511] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5841), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5843), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [166555] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(6782), 1,
      sym_identifier,
    ACTIONS(6784), 1,
      anon_sym_STAR,
    ACTIONS(6786), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6788), 1,
      anon_sym_AMP,
    ACTIONS(6790), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    STATE(5080), 1,
      sym_ms_call_modifier,
    STATE(5612), 1,
      sym__scope_resolution,
    STATE(6290), 1,
      sym__declarator,
    STATE(7612), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1825), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [166633] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4575), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(4582), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [166677] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4563), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(4565), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [166721] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4567), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(4569), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [166765] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4571), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(4573), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [166809] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4559), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(4561), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [166853] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4555), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(4557), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [166897] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4551), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(4553), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [166941] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4530), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(4532), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [166985] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5821), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5823), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [167029] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5916), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5918), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [167073] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5920), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5922), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [167117] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5930), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5932), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [167161] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5873), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5875), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [167205] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5942), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5944), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [167249] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5950), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5952), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [167293] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5954), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5956), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [167337] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4922), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4940), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(4942), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [167383] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5904), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5906), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [167427] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3568), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3564), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [167471] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5970), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5972), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [167515] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5881), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5883), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [167559] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(6782), 1,
      sym_identifier,
    ACTIONS(6784), 1,
      anon_sym_STAR,
    ACTIONS(6786), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6788), 1,
      anon_sym_AMP,
    ACTIONS(6790), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    STATE(5062), 1,
      sym_ms_call_modifier,
    STATE(5612), 1,
      sym__scope_resolution,
    STATE(6269), 1,
      sym__declarator,
    STATE(7612), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1825), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [167637] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5992), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5994), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [167681] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5988), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5990), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [167725] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6000), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6002), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [167769] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6004), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6006), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [167813] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6008), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6010), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [167857] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4922), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4918), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(4920), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [167903] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4922), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4918), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(4920), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [167949] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6012), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6014), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [167993] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6020), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6022), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [168037] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6036), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6038), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [168081] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8316), 1,
      anon_sym_LT,
    STATE(2030), 1,
      sym_template_argument_list,
    STATE(2269), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3759), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(4603), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3767), 25,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [168135] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4928), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(4930), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [168179] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5908), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5910), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [168223] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4726), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5105), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(8318), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5107), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [168271] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4221), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5426), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(8300), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5424), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [168319] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(2845), 1,
      anon_sym_STAR,
    ACTIONS(2847), 1,
      anon_sym_AMP,
    ACTIONS(4841), 1,
      sym_identifier,
    ACTIONS(5825), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    STATE(5130), 1,
      sym_ms_call_modifier,
    STATE(5610), 1,
      sym__scope_resolution,
    STATE(6389), 1,
      sym__declarator,
    STATE(8318), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1825), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [168397] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(6782), 1,
      sym_identifier,
    ACTIONS(6784), 1,
      anon_sym_STAR,
    ACTIONS(6786), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6788), 1,
      anon_sym_AMP,
    ACTIONS(6790), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    STATE(5096), 1,
      sym_ms_call_modifier,
    STATE(5612), 1,
      sym__scope_resolution,
    STATE(6262), 1,
      sym__declarator,
    STATE(7612), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1825), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [168475] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(6782), 1,
      sym_identifier,
    ACTIONS(6784), 1,
      anon_sym_STAR,
    ACTIONS(6786), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6788), 1,
      anon_sym_AMP,
    ACTIONS(6790), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    STATE(5064), 1,
      sym_ms_call_modifier,
    STATE(5612), 1,
      sym__scope_resolution,
    STATE(6263), 1,
      sym__declarator,
    STATE(7612), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1825), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [168553] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5958), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5960), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [168597] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5833), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5835), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [168641] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4717), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5420), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(8320), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5418), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [168689] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6911), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6913), 1,
      anon_sym_AMP,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(6923), 1,
      anon_sym_DASH_GT,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8325), 1,
      anon_sym_requires,
    STATE(4821), 1,
      sym_ref_qualifier,
    STATE(5697), 1,
      sym__function_attributes_end,
    STATE(5817), 1,
      sym_trailing_return_type,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8322), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5948), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5200), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8312), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [168771] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4647), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5410), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(8328), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5408), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [168819] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4221), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5369), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(8300), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5367), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [168867] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4910), 1,
      anon_sym_COLON,
    ACTIONS(8330), 1,
      anon_sym___attribute__,
    ACTIONS(8332), 1,
      anon_sym_LBRACE,
    STATE(4926), 1,
      sym_field_declaration_list,
    STATE(5003), 1,
      sym_attribute_specifier,
    STATE(6786), 1,
      sym_virtual_specifier,
    STATE(7466), 1,
      sym_base_class_clause,
    ACTIONS(4902), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(4904), 25,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [168927] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5074), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5076), 33,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [168971] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4221), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5406), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(8300), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5404), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [169019] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    ACTIONS(7430), 1,
      anon_sym_STAR,
    ACTIONS(7432), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7434), 1,
      anon_sym_AMP,
    STATE(3784), 1,
      sym_parameter_list,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(6180), 1,
      sym__abstract_declarator,
    STATE(4424), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7753), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6915), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [169085] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(8334), 1,
      anon_sym_LBRACE,
    ACTIONS(8336), 1,
      anon_sym_COLON,
    STATE(4752), 1,
      sym__enum_base_clause,
    STATE(4810), 1,
      sym_enumerator_list,
    STATE(4811), 1,
      sym_attribute_specifier,
    ACTIONS(5629), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5631), 27,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [169141] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_const,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    ACTIONS(7430), 1,
      anon_sym_STAR,
    ACTIONS(7432), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7434), 1,
      anon_sym_AMP,
    STATE(3784), 1,
      sym_parameter_list,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(6193), 1,
      sym__abstract_declarator,
    STATE(4424), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7795), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6915), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [169207] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(8334), 1,
      anon_sym_LBRACE,
    ACTIONS(8336), 1,
      anon_sym_COLON,
    STATE(4743), 1,
      sym__enum_base_clause,
    STATE(4809), 1,
      sym_enumerator_list,
    STATE(4899), 1,
      sym_attribute_specifier,
    ACTIONS(5689), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5691), 27,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [169263] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(6782), 1,
      sym_identifier,
    ACTIONS(6784), 1,
      anon_sym_STAR,
    ACTIONS(6786), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6788), 1,
      anon_sym_AMP,
    ACTIONS(6790), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    STATE(5122), 1,
      sym_ms_call_modifier,
    STATE(5612), 1,
      sym__scope_resolution,
    STATE(6288), 1,
      sym__declarator,
    STATE(7612), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1825), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [169341] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8316), 1,
      anon_sym_LT,
    STATE(1741), 1,
      sym_template_argument_list,
    ACTIONS(4541), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(4534), 29,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      anon_sym_COLON,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
  [169391] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(7307), 1,
      anon_sym_LPAREN2,
    ACTIONS(8338), 1,
      sym_identifier,
    ACTIONS(8340), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8342), 1,
      anon_sym_enum,
    ACTIONS(8344), 1,
      anon_sym_class,
    ACTIONS(8346), 1,
      anon_sym_struct,
    ACTIONS(8348), 1,
      anon_sym_union,
    ACTIONS(8350), 1,
      anon_sym_typename,
    STATE(1898), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2293), 1,
      sym_primitive_type,
    STATE(4085), 1,
      sym__type_specifier,
    STATE(4872), 1,
      sym_argument_list,
    STATE(6337), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(1827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [169476] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_const,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(7506), 1,
      anon_sym_STAR,
    ACTIONS(7508), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7510), 1,
      anon_sym_AMP,
    STATE(3759), 1,
      sym_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6232), 1,
      sym__abstract_declarator,
    STATE(4968), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7753), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7319), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [169541] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(7307), 1,
      anon_sym_LPAREN2,
    ACTIONS(8352), 1,
      sym_identifier,
    ACTIONS(8354), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8358), 1,
      anon_sym_enum,
    ACTIONS(8360), 1,
      anon_sym_class,
    ACTIONS(8362), 1,
      anon_sym_struct,
    ACTIONS(8364), 1,
      anon_sym_union,
    ACTIONS(8366), 1,
      sym_auto,
    ACTIONS(8368), 1,
      anon_sym_decltype,
    ACTIONS(8370), 1,
      anon_sym_typename,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2984), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3753), 1,
      sym_primitive_type,
    STATE(3819), 1,
      sym__type_specifier,
    STATE(4057), 1,
      sym_decltype_auto,
    STATE(4889), 1,
      sym_argument_list,
    STATE(6377), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(4027), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(6492), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8356), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4070), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [169626] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8372), 1,
      anon_sym_LT,
    STATE(2724), 1,
      sym_template_argument_list,
    ACTIONS(5187), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(3785), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [169675] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_const,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(7506), 1,
      anon_sym_STAR,
    ACTIONS(7508), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7510), 1,
      anon_sym_AMP,
    STATE(3759), 1,
      sym_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6223), 1,
      sym__abstract_declarator,
    STATE(4968), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6297), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7319), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [169740] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6953), 1,
      anon_sym_const,
    ACTIONS(7634), 2,
      anon_sym_AMP,
      anon_sym_LBRACK,
    STATE(4650), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6945), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
    ACTIONS(7632), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [169789] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8316), 1,
      anon_sym_LT,
    STATE(2030), 1,
      sym_template_argument_list,
    ACTIONS(5187), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(3785), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [169838] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(8334), 1,
      anon_sym_LBRACE,
    STATE(4790), 1,
      sym_enumerator_list,
    STATE(4831), 1,
      sym_attribute_specifier,
    ACTIONS(5293), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5295), 28,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [169889] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(7309), 1,
      sym_auto,
    ACTIONS(7311), 1,
      anon_sym_decltype,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(7691), 1,
      anon_sym_STAR,
    ACTIONS(7693), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7695), 1,
      anon_sym_AMP,
    ACTIONS(7705), 1,
      anon_sym_const,
    STATE(1988), 1,
      sym_decltype_auto,
    STATE(3980), 1,
      sym_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6417), 1,
      sym__abstract_declarator,
    STATE(4919), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7526), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7697), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [169960] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(7307), 1,
      anon_sym_LPAREN2,
    ACTIONS(8374), 1,
      sym_identifier,
    ACTIONS(8376), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8380), 1,
      anon_sym_enum,
    ACTIONS(8382), 1,
      anon_sym_class,
    ACTIONS(8384), 1,
      anon_sym_struct,
    ACTIONS(8386), 1,
      anon_sym_union,
    ACTIONS(8388), 1,
      sym_auto,
    ACTIONS(8390), 1,
      anon_sym_decltype,
    ACTIONS(8392), 1,
      anon_sym_typename,
    STATE(2477), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2817), 1,
      sym_primitive_type,
    STATE(2884), 1,
      sym__type_specifier,
    STATE(3371), 1,
      sym_decltype_auto,
    STATE(3381), 1,
      sym_qualified_type_identifier,
    STATE(4832), 1,
      sym_argument_list,
    STATE(6349), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(3341), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5807), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8378), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3373), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [170045] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(2621), 1,
      sym_auto,
    ACTIONS(2623), 1,
      anon_sym_decltype,
    ACTIONS(7307), 1,
      anon_sym_LPAREN2,
    ACTIONS(8394), 1,
      sym_identifier,
    ACTIONS(8396), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8398), 1,
      anon_sym_enum,
    ACTIONS(8400), 1,
      anon_sym_class,
    ACTIONS(8402), 1,
      anon_sym_struct,
    ACTIONS(8404), 1,
      anon_sym_union,
    ACTIONS(8406), 1,
      anon_sym_typename,
    STATE(2164), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2612), 1,
      sym_primitive_type,
    STATE(2882), 1,
      sym_qualified_type_identifier,
    STATE(2933), 1,
      sym_decltype_auto,
    STATE(4135), 1,
      sym__type_specifier,
    STATE(4886), 1,
      sym_argument_list,
    STATE(6376), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(2868), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2587), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2585), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2935), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [170130] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(7307), 1,
      anon_sym_LPAREN2,
    ACTIONS(8352), 1,
      sym_identifier,
    ACTIONS(8354), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8358), 1,
      anon_sym_enum,
    ACTIONS(8360), 1,
      anon_sym_class,
    ACTIONS(8362), 1,
      anon_sym_struct,
    ACTIONS(8364), 1,
      anon_sym_union,
    ACTIONS(8366), 1,
      sym_auto,
    ACTIONS(8368), 1,
      anon_sym_decltype,
    ACTIONS(8370), 1,
      anon_sym_typename,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2984), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3753), 1,
      sym_primitive_type,
    STATE(3812), 1,
      sym__type_specifier,
    STATE(4057), 1,
      sym_decltype_auto,
    STATE(4868), 1,
      sym_argument_list,
    STATE(6377), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(4027), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(6492), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8356), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4070), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [170215] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(7307), 1,
      anon_sym_LPAREN2,
    ACTIONS(8374), 1,
      sym_identifier,
    ACTIONS(8376), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8380), 1,
      anon_sym_enum,
    ACTIONS(8382), 1,
      anon_sym_class,
    ACTIONS(8384), 1,
      anon_sym_struct,
    ACTIONS(8386), 1,
      anon_sym_union,
    ACTIONS(8388), 1,
      sym_auto,
    ACTIONS(8390), 1,
      anon_sym_decltype,
    ACTIONS(8392), 1,
      anon_sym_typename,
    STATE(2477), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2817), 1,
      sym_primitive_type,
    STATE(2940), 1,
      sym__type_specifier,
    STATE(3371), 1,
      sym_decltype_auto,
    STATE(3381), 1,
      sym_qualified_type_identifier,
    STATE(4825), 1,
      sym_argument_list,
    STATE(6349), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(3341), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5807), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8378), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3373), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [170300] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(7307), 1,
      anon_sym_LPAREN2,
    ACTIONS(8408), 1,
      sym_identifier,
    ACTIONS(8410), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8414), 1,
      anon_sym_enum,
    ACTIONS(8416), 1,
      anon_sym_class,
    ACTIONS(8418), 1,
      anon_sym_struct,
    ACTIONS(8420), 1,
      anon_sym_union,
    ACTIONS(8422), 1,
      sym_auto,
    ACTIONS(8424), 1,
      anon_sym_decltype,
    ACTIONS(8426), 1,
      anon_sym_typename,
    STATE(2263), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2631), 1,
      sym_primitive_type,
    STATE(2734), 1,
      sym__type_specifier,
    STATE(3007), 1,
      sym_decltype_auto,
    STATE(3009), 1,
      sym_qualified_type_identifier,
    STATE(4823), 1,
      sym_argument_list,
    STATE(6348), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(2887), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5377), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8412), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3028), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [170385] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(2621), 1,
      sym_auto,
    ACTIONS(2623), 1,
      anon_sym_decltype,
    ACTIONS(7307), 1,
      anon_sym_LPAREN2,
    ACTIONS(8394), 1,
      sym_identifier,
    ACTIONS(8396), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8398), 1,
      anon_sym_enum,
    ACTIONS(8400), 1,
      anon_sym_class,
    ACTIONS(8402), 1,
      anon_sym_struct,
    ACTIONS(8404), 1,
      anon_sym_union,
    ACTIONS(8406), 1,
      anon_sym_typename,
    STATE(2164), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2612), 1,
      sym_primitive_type,
    STATE(2882), 1,
      sym_qualified_type_identifier,
    STATE(2933), 1,
      sym_decltype_auto,
    STATE(4109), 1,
      sym__type_specifier,
    STATE(4877), 1,
      sym_argument_list,
    STATE(6376), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(2868), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2587), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2585), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2935), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [170470] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8330), 1,
      anon_sym___attribute__,
    ACTIONS(8428), 1,
      anon_sym_LBRACE,
    ACTIONS(8430), 1,
      anon_sym_COLON,
    STATE(4883), 1,
      sym__enum_base_clause,
    STATE(4928), 1,
      sym_enumerator_list,
    STATE(4995), 1,
      sym_attribute_specifier,
    ACTIONS(5629), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5631), 27,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [170525] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(8334), 1,
      anon_sym_LBRACE,
    STATE(4784), 1,
      sym_enumerator_list,
    STATE(4849), 1,
      sym_attribute_specifier,
    ACTIONS(5350), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5352), 28,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [170576] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(7309), 1,
      sym_auto,
    ACTIONS(7311), 1,
      anon_sym_decltype,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(7691), 1,
      anon_sym_STAR,
    ACTIONS(7693), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7695), 1,
      anon_sym_AMP,
    ACTIONS(7705), 1,
      anon_sym_const,
    STATE(1988), 1,
      sym_decltype_auto,
    STATE(3980), 1,
      sym_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6395), 1,
      sym__abstract_declarator,
    STATE(4923), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7537), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7697), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [170647] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6911), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6913), 1,
      anon_sym_AMP,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(6955), 1,
      anon_sym_DASH_GT,
    ACTIONS(6963), 1,
      anon_sym_requires,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8432), 1,
      anon_sym___attribute__,
    ACTIONS(8435), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(4927), 1,
      sym_ref_qualifier,
    STATE(5625), 1,
      sym__function_attributes_end,
    STATE(5647), 1,
      sym_trailing_return_type,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5216), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8312), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [170728] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6911), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6913), 1,
      anon_sym_AMP,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(6955), 1,
      anon_sym_DASH_GT,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8432), 1,
      anon_sym___attribute__,
    ACTIONS(8435), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8441), 1,
      anon_sym_requires,
    STATE(4925), 1,
      sym_ref_qualifier,
    STATE(5598), 1,
      sym__function_attributes_end,
    STATE(5685), 1,
      sym_trailing_return_type,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8438), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5210), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8312), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [170809] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8372), 1,
      anon_sym_LT,
    STATE(2724), 1,
      sym_template_argument_list,
    ACTIONS(4534), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(4541), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [170858] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(7307), 1,
      anon_sym_LPAREN2,
    ACTIONS(8444), 1,
      sym_identifier,
    ACTIONS(8446), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8450), 1,
      anon_sym_enum,
    ACTIONS(8452), 1,
      anon_sym_class,
    ACTIONS(8454), 1,
      anon_sym_struct,
    ACTIONS(8456), 1,
      anon_sym_union,
    ACTIONS(8458), 1,
      sym_auto,
    ACTIONS(8460), 1,
      anon_sym_decltype,
    ACTIONS(8462), 1,
      anon_sym_typename,
    STATE(2003), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2012), 1,
      sym__type_specifier,
    STATE(2379), 1,
      sym_decltype_auto,
    STATE(2392), 1,
      sym_qualified_type_identifier,
    STATE(2429), 1,
      sym_primitive_type,
    STATE(4843), 1,
      sym_argument_list,
    STATE(6383), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(2290), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5195), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8448), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2380), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [170943] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4918), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(4920), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [170986] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(7307), 1,
      anon_sym_LPAREN2,
    ACTIONS(8338), 1,
      sym_identifier,
    ACTIONS(8340), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8342), 1,
      anon_sym_enum,
    ACTIONS(8344), 1,
      anon_sym_class,
    ACTIONS(8346), 1,
      anon_sym_struct,
    ACTIONS(8348), 1,
      anon_sym_union,
    ACTIONS(8350), 1,
      anon_sym_typename,
    STATE(1898), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2293), 1,
      sym_primitive_type,
    STATE(3988), 1,
      sym__type_specifier,
    STATE(4880), 1,
      sym_argument_list,
    STATE(6337), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(1827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [171071] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(7307), 1,
      anon_sym_LPAREN2,
    ACTIONS(8464), 1,
      sym_identifier,
    ACTIONS(8466), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8470), 1,
      anon_sym_enum,
    ACTIONS(8472), 1,
      anon_sym_class,
    ACTIONS(8474), 1,
      anon_sym_struct,
    ACTIONS(8476), 1,
      anon_sym_union,
    ACTIONS(8478), 1,
      sym_auto,
    ACTIONS(8480), 1,
      anon_sym_decltype,
    ACTIONS(8482), 1,
      anon_sym_typename,
    STATE(2377), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2747), 1,
      sym_primitive_type,
    STATE(2796), 1,
      sym__type_specifier,
    STATE(3090), 1,
      sym_qualified_type_identifier,
    STATE(3187), 1,
      sym_decltype_auto,
    STATE(4887), 1,
      sym_argument_list,
    STATE(6368), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(2981), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5619), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8468), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3184), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [171156] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_const,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(7506), 1,
      anon_sym_STAR,
    ACTIONS(7508), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7510), 1,
      anon_sym_AMP,
    STATE(3759), 1,
      sym_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6252), 1,
      sym__abstract_declarator,
    STATE(4968), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7795), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7319), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [171221] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8484), 1,
      anon_sym___attribute__,
    STATE(4762), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(8285), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8283), 29,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [171268] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8330), 1,
      anon_sym___attribute__,
    ACTIONS(8428), 1,
      anon_sym_LBRACE,
    ACTIONS(8430), 1,
      anon_sym_COLON,
    STATE(4863), 1,
      sym__enum_base_clause,
    STATE(4918), 1,
      sym_enumerator_list,
    STATE(5010), 1,
      sym_attribute_specifier,
    ACTIONS(5689), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5691), 27,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [171323] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6953), 1,
      anon_sym_const,
    ACTIONS(8294), 2,
      anon_sym_AMP,
      anon_sym_LBRACK,
    STATE(4650), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6945), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
    ACTIONS(8292), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [171372] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(7307), 1,
      anon_sym_LPAREN2,
    ACTIONS(8464), 1,
      sym_identifier,
    ACTIONS(8466), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8470), 1,
      anon_sym_enum,
    ACTIONS(8472), 1,
      anon_sym_class,
    ACTIONS(8474), 1,
      anon_sym_struct,
    ACTIONS(8476), 1,
      anon_sym_union,
    ACTIONS(8478), 1,
      sym_auto,
    ACTIONS(8480), 1,
      anon_sym_decltype,
    ACTIONS(8482), 1,
      anon_sym_typename,
    STATE(2377), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2747), 1,
      sym_primitive_type,
    STATE(2757), 1,
      sym__type_specifier,
    STATE(3090), 1,
      sym_qualified_type_identifier,
    STATE(3187), 1,
      sym_decltype_auto,
    STATE(4864), 1,
      sym_argument_list,
    STATE(6368), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(2981), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5619), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8468), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3184), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [171457] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(7307), 1,
      anon_sym_LPAREN2,
    ACTIONS(8338), 1,
      sym_identifier,
    ACTIONS(8340), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8342), 1,
      anon_sym_enum,
    ACTIONS(8344), 1,
      anon_sym_class,
    ACTIONS(8346), 1,
      anon_sym_struct,
    ACTIONS(8348), 1,
      anon_sym_union,
    ACTIONS(8350), 1,
      anon_sym_typename,
    STATE(1898), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2293), 1,
      sym_primitive_type,
    STATE(4042), 1,
      sym__type_specifier,
    STATE(4840), 1,
      sym_argument_list,
    STATE(6337), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(1827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [171542] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(7307), 1,
      anon_sym_LPAREN2,
    ACTIONS(8446), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8452), 1,
      anon_sym_class,
    ACTIONS(8454), 1,
      anon_sym_struct,
    ACTIONS(8456), 1,
      anon_sym_union,
    ACTIONS(8458), 1,
      sym_auto,
    ACTIONS(8460), 1,
      anon_sym_decltype,
    ACTIONS(8487), 1,
      sym_identifier,
    ACTIONS(8491), 1,
      anon_sym_enum,
    ACTIONS(8493), 1,
      anon_sym_typename,
    STATE(1996), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2012), 1,
      sym__type_specifier,
    STATE(2379), 1,
      sym_decltype_auto,
    STATE(2392), 1,
      sym_qualified_type_identifier,
    STATE(2406), 1,
      sym_primitive_type,
    STATE(4847), 1,
      sym_argument_list,
    STATE(6383), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(2290), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5195), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8489), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2380), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [171627] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4726), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4924), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(8318), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4926), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [171674] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(7307), 1,
      anon_sym_LPAREN2,
    ACTIONS(8446), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8452), 1,
      anon_sym_class,
    ACTIONS(8454), 1,
      anon_sym_struct,
    ACTIONS(8456), 1,
      anon_sym_union,
    ACTIONS(8458), 1,
      sym_auto,
    ACTIONS(8460), 1,
      anon_sym_decltype,
    ACTIONS(8487), 1,
      sym_identifier,
    ACTIONS(8491), 1,
      anon_sym_enum,
    ACTIONS(8493), 1,
      anon_sym_typename,
    STATE(1996), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2004), 1,
      sym__type_specifier,
    STATE(2379), 1,
      sym_decltype_auto,
    STATE(2392), 1,
      sym_qualified_type_identifier,
    STATE(2406), 1,
      sym_primitive_type,
    STATE(4860), 1,
      sym_argument_list,
    STATE(6383), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(2290), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5195), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8489), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2380), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [171759] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(7307), 1,
      anon_sym_LPAREN2,
    ACTIONS(8408), 1,
      sym_identifier,
    ACTIONS(8410), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8414), 1,
      anon_sym_enum,
    ACTIONS(8416), 1,
      anon_sym_class,
    ACTIONS(8418), 1,
      anon_sym_struct,
    ACTIONS(8420), 1,
      anon_sym_union,
    ACTIONS(8422), 1,
      sym_auto,
    ACTIONS(8424), 1,
      anon_sym_decltype,
    ACTIONS(8426), 1,
      anon_sym_typename,
    STATE(2263), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2631), 1,
      sym_primitive_type,
    STATE(2738), 1,
      sym__type_specifier,
    STATE(3007), 1,
      sym_decltype_auto,
    STATE(3009), 1,
      sym_qualified_type_identifier,
    STATE(4820), 1,
      sym_argument_list,
    STATE(6348), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(2887), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5377), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8412), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3028), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [171844] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_const,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(7506), 1,
      anon_sym_STAR,
    ACTIONS(7508), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7510), 1,
      anon_sym_AMP,
    STATE(3759), 1,
      sym_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6281), 1,
      sym__abstract_declarator,
    STATE(4968), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5555), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7319), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [171909] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8316), 1,
      anon_sym_LT,
    STATE(2030), 1,
      sym_template_argument_list,
    ACTIONS(4534), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(4541), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [171958] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5101), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5103), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [172001] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8495), 1,
      anon_sym_SEMI,
    ACTIONS(5877), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(5879), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [172046] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(7307), 1,
      anon_sym_LPAREN2,
    ACTIONS(8444), 1,
      sym_identifier,
    ACTIONS(8446), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8450), 1,
      anon_sym_enum,
    ACTIONS(8452), 1,
      anon_sym_class,
    ACTIONS(8454), 1,
      anon_sym_struct,
    ACTIONS(8456), 1,
      anon_sym_union,
    ACTIONS(8458), 1,
      sym_auto,
    ACTIONS(8460), 1,
      anon_sym_decltype,
    ACTIONS(8462), 1,
      anon_sym_typename,
    STATE(2003), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2004), 1,
      sym__type_specifier,
    STATE(2379), 1,
      sym_decltype_auto,
    STATE(2392), 1,
      sym_qualified_type_identifier,
    STATE(2429), 1,
      sym_primitive_type,
    STATE(4839), 1,
      sym_argument_list,
    STATE(6383), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(2290), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5195), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8448), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2380), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [172131] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(7307), 1,
      anon_sym_LPAREN2,
    ACTIONS(8338), 1,
      sym_identifier,
    ACTIONS(8340), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8342), 1,
      anon_sym_enum,
    ACTIONS(8344), 1,
      anon_sym_class,
    ACTIONS(8346), 1,
      anon_sym_struct,
    ACTIONS(8348), 1,
      anon_sym_union,
    ACTIONS(8350), 1,
      anon_sym_typename,
    STATE(1898), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2293), 1,
      sym_primitive_type,
    STATE(3983), 1,
      sym__type_specifier,
    STATE(4854), 1,
      sym_argument_list,
    STATE(6337), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(1827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [172216] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_const,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(7539), 1,
      anon_sym_STAR,
    ACTIONS(7541), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7543), 1,
      anon_sym_AMP,
    STATE(3826), 1,
      sym_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6310), 1,
      sym__abstract_declarator,
    STATE(4968), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7753), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7319), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [172280] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    STATE(4870), 1,
      sym_attribute_specifier,
    ACTIONS(5473), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5475), 29,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [172326] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    STATE(4835), 1,
      sym_attribute_specifier,
    ACTIONS(5400), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5402), 29,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [172372] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_const,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(6281), 1,
      sym_auto,
    ACTIONS(6283), 1,
      anon_sym_decltype,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(7919), 1,
      anon_sym_STAR,
    ACTIONS(7921), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7923), 1,
      anon_sym_AMP,
    STATE(2951), 1,
      sym_decltype_auto,
    STATE(3830), 1,
      sym_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6436), 1,
      sym__abstract_declarator,
    STATE(4982), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7537), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7319), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [172442] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    STATE(4815), 1,
      sym_attribute_specifier,
    ACTIONS(5499), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5501), 29,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [172488] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8372), 1,
      anon_sym_LT,
    STATE(2537), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2724), 1,
      sym_template_argument_list,
    ACTIONS(3759), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(4615), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3767), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [172540] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    STATE(4841), 1,
      sym_attribute_specifier,
    ACTIONS(5386), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5388), 29,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [172586] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    STATE(4862), 1,
      sym_attribute_specifier,
    ACTIONS(5485), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5487), 29,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [172632] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    STATE(4844), 1,
      sym_attribute_specifier,
    ACTIONS(5489), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5491), 29,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [172678] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6911), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6913), 1,
      anon_sym_AMP,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(6963), 1,
      anon_sym_requires,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(7105), 1,
      anon_sym_DASH_GT,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8435), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(4958), 1,
      sym_ref_qualifier,
    STATE(5632), 1,
      sym__function_attributes_end,
    STATE(5647), 1,
      sym_trailing_return_type,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8497), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5222), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8312), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [172758] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6911), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6913), 1,
      anon_sym_AMP,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(7043), 1,
      anon_sym_DASH_GT,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8435), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8441), 1,
      anon_sym_requires,
    STATE(4954), 1,
      sym_ref_qualifier,
    STATE(5685), 1,
      sym_trailing_return_type,
    STATE(5767), 1,
      sym__function_attributes_end,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8438), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5227), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8312), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [172838] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6911), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6913), 1,
      anon_sym_AMP,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(7100), 1,
      anon_sym_DASH_GT,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8500), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8503), 1,
      anon_sym_requires,
    STATE(4946), 1,
      sym_ref_qualifier,
    STATE(5557), 1,
      sym_trailing_return_type,
    STATE(5580), 1,
      sym__function_attributes_end,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(8438), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8497), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5217), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8312), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [172918] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6911), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6913), 1,
      anon_sym_AMP,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(7100), 1,
      anon_sym_DASH_GT,
    ACTIONS(7107), 1,
      anon_sym_requires,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8500), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(4984), 1,
      sym_ref_qualifier,
    STATE(5560), 1,
      sym_trailing_return_type,
    STATE(5634), 1,
      sym__function_attributes_end,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8497), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5241), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8312), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [172998] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    STATE(4846), 1,
      sym_attribute_specifier,
    ACTIONS(5414), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5416), 29,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [173044] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6911), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6913), 1,
      anon_sym_AMP,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(6963), 1,
      anon_sym_requires,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(7043), 1,
      anon_sym_DASH_GT,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8435), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(4945), 1,
      sym_ref_qualifier,
    STATE(5647), 1,
      sym_trailing_return_type,
    STATE(5732), 1,
      sym__function_attributes_end,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5226), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8312), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [173124] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6911), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6913), 1,
      anon_sym_AMP,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(7117), 1,
      anon_sym_DASH_GT,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8500), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8503), 1,
      anon_sym_requires,
    STATE(4978), 1,
      sym_ref_qualifier,
    STATE(5557), 1,
      sym_trailing_return_type,
    STATE(5721), 1,
      sym__function_attributes_end,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8438), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5233), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8312), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [173204] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_const,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(7539), 1,
      anon_sym_STAR,
    ACTIONS(7541), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7543), 1,
      anon_sym_AMP,
    STATE(3826), 1,
      sym_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6311), 1,
      sym__abstract_declarator,
    STATE(4968), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6297), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7319), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [173268] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_const,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(4520), 1,
      anon_sym_STAR,
    ACTIONS(4522), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4524), 1,
      anon_sym_AMP,
    ACTIONS(7309), 1,
      sym_auto,
    ACTIONS(7311), 1,
      anon_sym_decltype,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    STATE(1988), 1,
      sym_decltype_auto,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6437), 1,
      sym__abstract_declarator,
    STATE(4979), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7526), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7319), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [173338] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6911), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6913), 1,
      anon_sym_AMP,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(7105), 1,
      anon_sym_DASH_GT,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8435), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8441), 1,
      anon_sym_requires,
    STATE(4973), 1,
      sym_ref_qualifier,
    STATE(5588), 1,
      sym__function_attributes_end,
    STATE(5685), 1,
      sym_trailing_return_type,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(8438), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8497), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5238), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8312), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [173418] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    STATE(4896), 1,
      sym_attribute_specifier,
    ACTIONS(5481), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5483), 29,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [173464] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    STATE(4903), 1,
      sym_attribute_specifier,
    ACTIONS(5493), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5495), 29,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [173510] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6911), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6913), 1,
      anon_sym_AMP,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(7107), 1,
      anon_sym_requires,
    ACTIONS(7117), 1,
      anon_sym_DASH_GT,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8500), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(4989), 1,
      sym_ref_qualifier,
    STATE(5560), 1,
      sym_trailing_return_type,
    STATE(5738), 1,
      sym__function_attributes_end,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5236), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8312), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [173590] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(5728), 1,
      anon_sym_LBRACE,
    ACTIONS(8506), 1,
      anon_sym_COLON,
    STATE(1956), 1,
      sym_attribute_specifier,
    STATE(4936), 1,
      sym__enum_base_clause,
    STATE(5050), 1,
      sym_enumerator_list,
    ACTIONS(5631), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(5629), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [173644] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6103), 1,
      anon_sym_LT,
    STATE(1741), 1,
      sym_template_argument_list,
    STATE(4956), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5305), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(5303), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [173694] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_const,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(6281), 1,
      sym_auto,
    ACTIONS(6283), 1,
      anon_sym_decltype,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(7919), 1,
      anon_sym_STAR,
    ACTIONS(7921), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7923), 1,
      anon_sym_AMP,
    STATE(2951), 1,
      sym_decltype_auto,
    STATE(3830), 1,
      sym_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6456), 1,
      sym__abstract_declarator,
    STATE(4955), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7526), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7319), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [173764] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2819), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(2821), 31,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [173806] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_const,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(7539), 1,
      anon_sym_STAR,
    ACTIONS(7541), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7543), 1,
      anon_sym_AMP,
    STATE(3826), 1,
      sym_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6302), 1,
      sym__abstract_declarator,
    STATE(4968), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7795), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7319), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [173870] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_const,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(4520), 1,
      anon_sym_STAR,
    ACTIONS(4522), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4524), 1,
      anon_sym_AMP,
    ACTIONS(7309), 1,
      sym_auto,
    ACTIONS(7311), 1,
      anon_sym_decltype,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    STATE(1988), 1,
      sym_decltype_auto,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6478), 1,
      sym__abstract_declarator,
    STATE(4988), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7537), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7319), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [173940] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7528), 1,
      sym_auto,
    ACTIONS(7530), 1,
      anon_sym_decltype,
    STATE(4894), 1,
      sym_decltype_auto,
    ACTIONS(4871), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(4873), 28,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [173988] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(5728), 1,
      anon_sym_LBRACE,
    ACTIONS(8506), 1,
      anon_sym_COLON,
    STATE(1941), 1,
      sym_attribute_specifier,
    STATE(4939), 1,
      sym__enum_base_clause,
    STATE(5036), 1,
      sym_enumerator_list,
    ACTIONS(5691), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(5689), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [174042] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    STATE(4818), 1,
      sym_attribute_specifier,
    ACTIONS(5456), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5458), 29,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [174088] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_const,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(7539), 1,
      anon_sym_STAR,
    ACTIONS(7541), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7543), 1,
      anon_sym_AMP,
    STATE(3826), 1,
      sym_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6309), 1,
      sym__abstract_declarator,
    STATE(4968), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5555), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7319), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [174152] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    STATE(4826), 1,
      sym_attribute_specifier,
    ACTIONS(5452), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5454), 29,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [174198] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    STATE(4852), 1,
      sym_attribute_specifier,
    ACTIONS(5363), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5365), 29,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [174244] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5099), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [174285] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_auto,
    ACTIONS(121), 1,
      anon_sym_decltype,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(7190), 1,
      sym_identifier,
    ACTIONS(7192), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7194), 1,
      anon_sym_enum,
    ACTIONS(7196), 1,
      anon_sym_class,
    ACTIONS(7198), 1,
      anon_sym_struct,
    ACTIONS(7200), 1,
      anon_sym_union,
    ACTIONS(7202), 1,
      anon_sym_typename,
    STATE(2687), 1,
      sym_decltype_auto,
    STATE(2825), 1,
      sym_qualified_type_identifier,
    STATE(2855), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3443), 1,
      sym_primitive_type,
    STATE(6371), 1,
      sym__scope_resolution,
    STATE(6578), 1,
      sym__type_specifier,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(2618), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(3580), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2629), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [174364] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(8444), 1,
      sym_identifier,
    ACTIONS(8446), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8450), 1,
      anon_sym_enum,
    ACTIONS(8452), 1,
      anon_sym_class,
    ACTIONS(8454), 1,
      anon_sym_struct,
    ACTIONS(8456), 1,
      anon_sym_union,
    ACTIONS(8458), 1,
      sym_auto,
    ACTIONS(8460), 1,
      anon_sym_decltype,
    ACTIONS(8462), 1,
      anon_sym_typename,
    STATE(2003), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2313), 1,
      sym__type_specifier,
    STATE(2379), 1,
      sym_decltype_auto,
    STATE(2392), 1,
      sym_qualified_type_identifier,
    STATE(2429), 1,
      sym_primitive_type,
    STATE(6383), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(2290), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5195), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8448), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2380), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [174443] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5152), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5154), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [174484] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5160), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5162), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [174525] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5078), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5080), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [174566] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(7168), 1,
      sym_identifier,
    ACTIONS(7170), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7176), 1,
      anon_sym_enum,
    ACTIONS(7178), 1,
      anon_sym_class,
    ACTIONS(7180), 1,
      anon_sym_struct,
    ACTIONS(7182), 1,
      anon_sym_union,
    ACTIONS(7184), 1,
      sym_auto,
    ACTIONS(7186), 1,
      anon_sym_decltype,
    ACTIONS(7188), 1,
      anon_sym_typename,
    STATE(4159), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4768), 1,
      sym_primitive_type,
    STATE(4969), 1,
      sym__type_specifier,
    STATE(5028), 1,
      sym_decltype_auto,
    STATE(5057), 1,
      sym_qualified_type_identifier,
    STATE(6342), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(4951), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(7174), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7172), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5027), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [174645] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5089), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5091), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [174686] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(8408), 1,
      sym_identifier,
    ACTIONS(8410), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8414), 1,
      anon_sym_enum,
    ACTIONS(8416), 1,
      anon_sym_class,
    ACTIONS(8418), 1,
      anon_sym_struct,
    ACTIONS(8420), 1,
      anon_sym_union,
    ACTIONS(8422), 1,
      sym_auto,
    ACTIONS(8424), 1,
      anon_sym_decltype,
    ACTIONS(8426), 1,
      anon_sym_typename,
    STATE(2263), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2631), 1,
      sym_primitive_type,
    STATE(2945), 1,
      sym__type_specifier,
    STATE(3007), 1,
      sym_decltype_auto,
    STATE(3009), 1,
      sym_qualified_type_identifier,
    STATE(6348), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(2887), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5377), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8412), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3028), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [174765] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(8408), 1,
      sym_identifier,
    ACTIONS(8410), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8414), 1,
      anon_sym_enum,
    ACTIONS(8416), 1,
      anon_sym_class,
    ACTIONS(8418), 1,
      anon_sym_struct,
    ACTIONS(8420), 1,
      anon_sym_union,
    ACTIONS(8422), 1,
      sym_auto,
    ACTIONS(8424), 1,
      anon_sym_decltype,
    ACTIONS(8426), 1,
      anon_sym_typename,
    STATE(2263), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2631), 1,
      sym_primitive_type,
    STATE(2715), 1,
      sym__type_specifier,
    STATE(3007), 1,
      sym_decltype_auto,
    STATE(3009), 1,
      sym_qualified_type_identifier,
    STATE(6348), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(2887), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5377), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8412), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3028), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [174844] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(6923), 1,
      anon_sym_DASH_GT,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    ACTIONS(8515), 1,
      anon_sym_requires,
    STATE(5704), 1,
      sym__function_attributes_end,
    STATE(5820), 1,
      sym_trailing_return_type,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8512), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5911), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5198), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8508), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [174917] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(2621), 1,
      sym_auto,
    ACTIONS(2623), 1,
      anon_sym_decltype,
    ACTIONS(8394), 1,
      sym_identifier,
    ACTIONS(8396), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8398), 1,
      anon_sym_enum,
    ACTIONS(8400), 1,
      anon_sym_class,
    ACTIONS(8402), 1,
      anon_sym_struct,
    ACTIONS(8404), 1,
      anon_sym_union,
    ACTIONS(8406), 1,
      anon_sym_typename,
    STATE(2164), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2612), 1,
      sym_primitive_type,
    STATE(2839), 1,
      sym__type_specifier,
    STATE(2882), 1,
      sym_qualified_type_identifier,
    STATE(2933), 1,
      sym_decltype_auto,
    STATE(6376), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(2868), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2587), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2585), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2935), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [174996] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(8408), 1,
      sym_identifier,
    ACTIONS(8410), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8414), 1,
      anon_sym_enum,
    ACTIONS(8416), 1,
      anon_sym_class,
    ACTIONS(8418), 1,
      anon_sym_struct,
    ACTIONS(8420), 1,
      anon_sym_union,
    ACTIONS(8422), 1,
      sym_auto,
    ACTIONS(8424), 1,
      anon_sym_decltype,
    ACTIONS(8426), 1,
      anon_sym_typename,
    STATE(2263), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2631), 1,
      sym_primitive_type,
    STATE(2731), 1,
      sym__type_specifier,
    STATE(3007), 1,
      sym_decltype_auto,
    STATE(3009), 1,
      sym_qualified_type_identifier,
    STATE(6348), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(2887), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5377), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8412), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3028), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [175075] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5105), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5107), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [175116] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(8374), 1,
      sym_identifier,
    ACTIONS(8376), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8380), 1,
      anon_sym_enum,
    ACTIONS(8382), 1,
      anon_sym_class,
    ACTIONS(8384), 1,
      anon_sym_struct,
    ACTIONS(8386), 1,
      anon_sym_union,
    ACTIONS(8388), 1,
      sym_auto,
    ACTIONS(8390), 1,
      anon_sym_decltype,
    ACTIONS(8392), 1,
      anon_sym_typename,
    STATE(2477), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2817), 1,
      sym_primitive_type,
    STATE(2962), 1,
      sym__type_specifier,
    STATE(3371), 1,
      sym_decltype_auto,
    STATE(3381), 1,
      sym_qualified_type_identifier,
    STATE(6349), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(3341), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5807), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8378), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3373), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [175195] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5109), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5111), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [175236] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_auto,
    ACTIONS(121), 1,
      anon_sym_decltype,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1755), 1,
      anon_sym_enum,
    ACTIONS(1757), 1,
      anon_sym_class,
    ACTIONS(1759), 1,
      anon_sym_struct,
    ACTIONS(1761), 1,
      anon_sym_union,
    ACTIONS(1787), 1,
      anon_sym_typename,
    ACTIONS(4516), 1,
      sym_identifier,
    ACTIONS(4526), 1,
      anon_sym_COLON_COLON,
    STATE(2435), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2614), 1,
      sym__type_specifier,
    STATE(2687), 1,
      sym_decltype_auto,
    STATE(2805), 1,
      sym_primitive_type,
    STATE(3260), 1,
      sym_qualified_type_identifier,
    STATE(6380), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(2618), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(53), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2629), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [175315] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(6923), 1,
      anon_sym_DASH_GT,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8325), 1,
      anon_sym_requires,
    STATE(5697), 1,
      sym__function_attributes_end,
    STATE(5817), 1,
      sym_trailing_return_type,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8322), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5948), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5200), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8312), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [175388] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_auto,
    ACTIONS(121), 1,
      anon_sym_decltype,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(2857), 1,
      anon_sym_enum,
    ACTIONS(2859), 1,
      anon_sym_class,
    ACTIONS(2861), 1,
      anon_sym_struct,
    ACTIONS(2863), 1,
      anon_sym_union,
    ACTIONS(2865), 1,
      anon_sym_typename,
    ACTIONS(4625), 1,
      sym_identifier,
    ACTIONS(4627), 1,
      anon_sym_COLON_COLON,
    STATE(2435), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2614), 1,
      sym__type_specifier,
    STATE(2687), 1,
      sym_decltype_auto,
    STATE(2805), 1,
      sym_primitive_type,
    STATE(3260), 1,
      sym_qualified_type_identifier,
    STATE(6346), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(2618), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(53), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2629), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [175467] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6103), 1,
      anon_sym_LT,
    STATE(1741), 1,
      sym_template_argument_list,
    STATE(4471), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3759), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(7630), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3767), 21,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [175518] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5113), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5115), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [175559] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(8374), 1,
      sym_identifier,
    ACTIONS(8376), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8380), 1,
      anon_sym_enum,
    ACTIONS(8382), 1,
      anon_sym_class,
    ACTIONS(8384), 1,
      anon_sym_struct,
    ACTIONS(8386), 1,
      anon_sym_union,
    ACTIONS(8388), 1,
      sym_auto,
    ACTIONS(8390), 1,
      anon_sym_decltype,
    ACTIONS(8392), 1,
      anon_sym_typename,
    STATE(2477), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2817), 1,
      sym_primitive_type,
    STATE(2905), 1,
      sym__type_specifier,
    STATE(3371), 1,
      sym_decltype_auto,
    STATE(3381), 1,
      sym_qualified_type_identifier,
    STATE(6349), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(3341), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5807), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8378), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3373), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [175638] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5117), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5119), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [175679] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5121), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5123), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [175720] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5125), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5127), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [175761] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5050), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5052), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [175802] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5050), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5052), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [175843] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(7146), 1,
      sym_identifier,
    ACTIONS(7148), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7154), 1,
      anon_sym_enum,
    ACTIONS(7156), 1,
      anon_sym_class,
    ACTIONS(7158), 1,
      anon_sym_struct,
    ACTIONS(7160), 1,
      anon_sym_union,
    ACTIONS(7162), 1,
      sym_auto,
    ACTIONS(7164), 1,
      anon_sym_decltype,
    ACTIONS(7166), 1,
      anon_sym_typename,
    STATE(2825), 1,
      sym_qualified_type_identifier,
    STATE(4105), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4456), 1,
      sym_primitive_type,
    STATE(4805), 1,
      sym__type_specifier,
    STATE(4873), 1,
      sym_decltype_auto,
    STATE(6355), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(2618), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(7152), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7150), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4876), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [175922] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(8444), 1,
      sym_identifier,
    ACTIONS(8446), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8450), 1,
      anon_sym_enum,
    ACTIONS(8452), 1,
      anon_sym_class,
    ACTIONS(8454), 1,
      anon_sym_struct,
    ACTIONS(8456), 1,
      anon_sym_union,
    ACTIONS(8458), 1,
      sym_auto,
    ACTIONS(8460), 1,
      anon_sym_decltype,
    ACTIONS(8462), 1,
      anon_sym_typename,
    STATE(2003), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2013), 1,
      sym__type_specifier,
    STATE(2379), 1,
      sym_decltype_auto,
    STATE(2392), 1,
      sym_qualified_type_identifier,
    STATE(2429), 1,
      sym_primitive_type,
    STATE(6383), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(2290), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5195), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8448), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2380), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [176001] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(8338), 1,
      sym_identifier,
    ACTIONS(8340), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8342), 1,
      anon_sym_enum,
    ACTIONS(8344), 1,
      anon_sym_class,
    ACTIONS(8346), 1,
      anon_sym_struct,
    ACTIONS(8348), 1,
      anon_sym_union,
    ACTIONS(8350), 1,
      anon_sym_typename,
    STATE(1898), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2293), 1,
      sym_primitive_type,
    STATE(4075), 1,
      sym__type_specifier,
    STATE(6337), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(1827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [176080] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5129), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5131), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [176121] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6953), 1,
      anon_sym_const,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    ACTIONS(7618), 1,
      anon_sym_STAR,
    ACTIONS(7620), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7622), 1,
      anon_sym_AMP,
    STATE(3964), 1,
      sym_parameter_list,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(6372), 1,
      sym__abstract_declarator,
    STATE(4650), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6297), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6945), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [176184] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(8444), 1,
      sym_identifier,
    ACTIONS(8446), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8450), 1,
      anon_sym_enum,
    ACTIONS(8452), 1,
      anon_sym_class,
    ACTIONS(8454), 1,
      anon_sym_struct,
    ACTIONS(8456), 1,
      anon_sym_union,
    ACTIONS(8458), 1,
      sym_auto,
    ACTIONS(8460), 1,
      anon_sym_decltype,
    ACTIONS(8462), 1,
      anon_sym_typename,
    STATE(2003), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2010), 1,
      sym__type_specifier,
    STATE(2379), 1,
      sym_decltype_auto,
    STATE(2392), 1,
      sym_qualified_type_identifier,
    STATE(2429), 1,
      sym_primitive_type,
    STATE(6383), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(2290), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5195), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8448), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2380), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [176263] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5164), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5166), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [176304] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5038), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5040), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [176345] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5179), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5181), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [176386] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(8446), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8452), 1,
      anon_sym_class,
    ACTIONS(8454), 1,
      anon_sym_struct,
    ACTIONS(8456), 1,
      anon_sym_union,
    ACTIONS(8458), 1,
      sym_auto,
    ACTIONS(8460), 1,
      anon_sym_decltype,
    ACTIONS(8487), 1,
      sym_identifier,
    ACTIONS(8491), 1,
      anon_sym_enum,
    ACTIONS(8493), 1,
      anon_sym_typename,
    STATE(1996), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2010), 1,
      sym__type_specifier,
    STATE(2379), 1,
      sym_decltype_auto,
    STATE(2392), 1,
      sym_qualified_type_identifier,
    STATE(2406), 1,
      sym_primitive_type,
    STATE(6383), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(2290), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5195), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8489), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2380), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [176465] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8518), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(5763), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5765), 28,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [176508] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5172), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5174), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [176549] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6953), 1,
      anon_sym_const,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    ACTIONS(7618), 1,
      anon_sym_STAR,
    ACTIONS(7620), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7622), 1,
      anon_sym_AMP,
    STATE(3964), 1,
      sym_parameter_list,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(6370), 1,
      sym__abstract_declarator,
    STATE(4650), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7753), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6945), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [176612] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6953), 1,
      anon_sym_const,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    ACTIONS(7618), 1,
      anon_sym_STAR,
    ACTIONS(7620), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7622), 1,
      anon_sym_AMP,
    STATE(3964), 1,
      sym_parameter_list,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(6366), 1,
      sym__abstract_declarator,
    STATE(4650), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5555), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6945), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [176675] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5168), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5170), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [176716] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(8374), 1,
      sym_identifier,
    ACTIONS(8376), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8380), 1,
      anon_sym_enum,
    ACTIONS(8382), 1,
      anon_sym_class,
    ACTIONS(8384), 1,
      anon_sym_struct,
    ACTIONS(8386), 1,
      anon_sym_union,
    ACTIONS(8388), 1,
      sym_auto,
    ACTIONS(8390), 1,
      anon_sym_decltype,
    ACTIONS(8392), 1,
      anon_sym_typename,
    STATE(2477), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2817), 1,
      sym_primitive_type,
    STATE(3350), 1,
      sym__type_specifier,
    STATE(3371), 1,
      sym_decltype_auto,
    STATE(3381), 1,
      sym_qualified_type_identifier,
    STATE(6349), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(3341), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5807), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8378), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3373), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [176795] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(8338), 1,
      sym_identifier,
    ACTIONS(8340), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8342), 1,
      anon_sym_enum,
    ACTIONS(8344), 1,
      anon_sym_class,
    ACTIONS(8346), 1,
      anon_sym_struct,
    ACTIONS(8348), 1,
      anon_sym_union,
    ACTIONS(8350), 1,
      anon_sym_typename,
    STATE(1898), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2293), 1,
      sym_primitive_type,
    STATE(3965), 1,
      sym__type_specifier,
    STATE(6337), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(1827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [176874] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5156), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5158), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [176915] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6953), 1,
      anon_sym_const,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    ACTIONS(7618), 1,
      anon_sym_STAR,
    ACTIONS(7620), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7622), 1,
      anon_sym_AMP,
    STATE(3964), 1,
      sym_parameter_list,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(6352), 1,
      sym__abstract_declarator,
    STATE(4650), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7795), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6945), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [176978] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(6923), 1,
      anon_sym_DASH_GT,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(6941), 1,
      anon_sym_requires,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    STATE(5696), 1,
      sym__function_attributes_end,
    STATE(5811), 1,
      sym_trailing_return_type,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5948), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5187), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8312), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [177051] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(8446), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8452), 1,
      anon_sym_class,
    ACTIONS(8454), 1,
      anon_sym_struct,
    ACTIONS(8456), 1,
      anon_sym_union,
    ACTIONS(8458), 1,
      sym_auto,
    ACTIONS(8460), 1,
      anon_sym_decltype,
    ACTIONS(8487), 1,
      sym_identifier,
    ACTIONS(8491), 1,
      anon_sym_enum,
    ACTIONS(8493), 1,
      anon_sym_typename,
    STATE(1996), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2313), 1,
      sym__type_specifier,
    STATE(2379), 1,
      sym_decltype_auto,
    STATE(2392), 1,
      sym_qualified_type_identifier,
    STATE(2406), 1,
      sym_primitive_type,
    STATE(6383), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(2290), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5195), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8489), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2380), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [177130] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(6923), 1,
      anon_sym_DASH_GT,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(6941), 1,
      anon_sym_requires,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    STATE(5698), 1,
      sym__function_attributes_end,
    STATE(5785), 1,
      sym_trailing_return_type,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5911), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5189), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8508), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [177203] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(8446), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8452), 1,
      anon_sym_class,
    ACTIONS(8454), 1,
      anon_sym_struct,
    ACTIONS(8456), 1,
      anon_sym_union,
    ACTIONS(8458), 1,
      sym_auto,
    ACTIONS(8460), 1,
      anon_sym_decltype,
    ACTIONS(8487), 1,
      sym_identifier,
    ACTIONS(8491), 1,
      anon_sym_enum,
    ACTIONS(8493), 1,
      anon_sym_typename,
    STATE(1996), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2013), 1,
      sym__type_specifier,
    STATE(2379), 1,
      sym_decltype_auto,
    STATE(2392), 1,
      sym_qualified_type_identifier,
    STATE(2406), 1,
      sym_primitive_type,
    STATE(6383), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(2290), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5195), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8489), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2380), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [177282] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1833), 1,
      anon_sym_enum,
    ACTIONS(1835), 1,
      anon_sym_class,
    ACTIONS(1837), 1,
      anon_sym_struct,
    ACTIONS(1839), 1,
      anon_sym_union,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(1869), 1,
      anon_sym_typename,
    ACTIONS(7111), 1,
      sym_identifier,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    STATE(1829), 1,
      sym__type_specifier,
    STATE(1898), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2293), 1,
      sym_primitive_type,
    STATE(6373), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(1827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [177361] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5054), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5056), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [177402] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8330), 1,
      anon_sym___attribute__,
    ACTIONS(8428), 1,
      anon_sym_LBRACE,
    STATE(4929), 1,
      sym_enumerator_list,
    STATE(4992), 1,
      sym_attribute_specifier,
    ACTIONS(5293), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5295), 27,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [177451] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(8464), 1,
      sym_identifier,
    ACTIONS(8466), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8470), 1,
      anon_sym_enum,
    ACTIONS(8472), 1,
      anon_sym_class,
    ACTIONS(8474), 1,
      anon_sym_struct,
    ACTIONS(8476), 1,
      anon_sym_union,
    ACTIONS(8478), 1,
      sym_auto,
    ACTIONS(8480), 1,
      anon_sym_decltype,
    ACTIONS(8482), 1,
      anon_sym_typename,
    STATE(2377), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2747), 1,
      sym_primitive_type,
    STATE(2753), 1,
      sym__type_specifier,
    STATE(3090), 1,
      sym_qualified_type_identifier,
    STATE(3187), 1,
      sym_decltype_auto,
    STATE(6368), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(2981), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5619), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8468), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3184), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [177530] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8275), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8279), 1,
      anon_sym_EQ,
    ACTIONS(8521), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(2677), 1,
      sym__class_declaration,
    STATE(2680), 1,
      sym__class_declaration_item,
    STATE(3112), 1,
      sym_field_declaration_list,
    STATE(5450), 1,
      sym_ms_declspec_modifier,
    STATE(6380), 1,
      sym__scope_resolution,
    STATE(6695), 1,
      sym_virtual_specifier,
    STATE(7449), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8277), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(2596), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5449), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5188), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [177619] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(65), 1,
      anon_sym_enum,
    ACTIONS(67), 1,
      anon_sym_class,
    ACTIONS(69), 1,
      anon_sym_struct,
    ACTIONS(71), 1,
      anon_sym_union,
    ACTIONS(119), 1,
      sym_auto,
    ACTIONS(121), 1,
      anon_sym_decltype,
    ACTIONS(129), 1,
      anon_sym_typename,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(4625), 1,
      sym_identifier,
    ACTIONS(4627), 1,
      anon_sym_COLON_COLON,
    STATE(2435), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2614), 1,
      sym__type_specifier,
    STATE(2687), 1,
      sym_decltype_auto,
    STATE(2805), 1,
      sym_primitive_type,
    STATE(3260), 1,
      sym_qualified_type_identifier,
    STATE(6346), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(2618), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(53), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2629), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [177698] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(7162), 1,
      sym_auto,
    ACTIONS(7164), 1,
      anon_sym_decltype,
    ACTIONS(7204), 1,
      sym_identifier,
    ACTIONS(7206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7208), 1,
      anon_sym_enum,
    ACTIONS(7210), 1,
      anon_sym_class,
    ACTIONS(7212), 1,
      anon_sym_struct,
    ACTIONS(7214), 1,
      anon_sym_union,
    ACTIONS(7216), 1,
      anon_sym_typename,
    STATE(2825), 1,
      sym_qualified_type_identifier,
    STATE(4105), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4456), 1,
      sym_primitive_type,
    STATE(4805), 1,
      sym__type_specifier,
    STATE(4873), 1,
      sym_decltype_auto,
    STATE(6336), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(2618), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(7152), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7150), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4876), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [177777] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(8352), 1,
      sym_identifier,
    ACTIONS(8354), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8358), 1,
      anon_sym_enum,
    ACTIONS(8360), 1,
      anon_sym_class,
    ACTIONS(8362), 1,
      anon_sym_struct,
    ACTIONS(8364), 1,
      anon_sym_union,
    ACTIONS(8366), 1,
      sym_auto,
    ACTIONS(8368), 1,
      anon_sym_decltype,
    ACTIONS(8370), 1,
      anon_sym_typename,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2984), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3753), 1,
      sym_primitive_type,
    STATE(3891), 1,
      sym__type_specifier,
    STATE(4057), 1,
      sym_decltype_auto,
    STATE(6377), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(4027), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(6492), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8356), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4070), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [177856] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_auto,
    ACTIONS(121), 1,
      anon_sym_decltype,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(7190), 1,
      sym_identifier,
    ACTIONS(7192), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7194), 1,
      anon_sym_enum,
    ACTIONS(7196), 1,
      anon_sym_class,
    ACTIONS(7198), 1,
      anon_sym_struct,
    ACTIONS(7200), 1,
      anon_sym_union,
    ACTIONS(7202), 1,
      anon_sym_typename,
    STATE(2687), 1,
      sym_decltype_auto,
    STATE(2825), 1,
      sym_qualified_type_identifier,
    STATE(2855), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3443), 1,
      sym_primitive_type,
    STATE(6371), 1,
      sym__scope_resolution,
    STATE(6555), 1,
      sym__type_specifier,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(2618), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(3580), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2629), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [177935] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5062), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5064), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [177976] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_auto,
    ACTIONS(121), 1,
      anon_sym_decltype,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(7190), 1,
      sym_identifier,
    ACTIONS(7192), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7194), 1,
      anon_sym_enum,
    ACTIONS(7196), 1,
      anon_sym_class,
    ACTIONS(7198), 1,
      anon_sym_struct,
    ACTIONS(7200), 1,
      anon_sym_union,
    ACTIONS(7202), 1,
      anon_sym_typename,
    STATE(2614), 1,
      sym__type_specifier,
    STATE(2687), 1,
      sym_decltype_auto,
    STATE(2825), 1,
      sym_qualified_type_identifier,
    STATE(2855), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3443), 1,
      sym_primitive_type,
    STATE(6371), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(2618), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(3580), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2629), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [178055] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(8338), 1,
      sym_identifier,
    ACTIONS(8340), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8342), 1,
      anon_sym_enum,
    ACTIONS(8344), 1,
      anon_sym_class,
    ACTIONS(8346), 1,
      anon_sym_struct,
    ACTIONS(8348), 1,
      anon_sym_union,
    ACTIONS(8350), 1,
      anon_sym_typename,
    STATE(1898), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2293), 1,
      sym_primitive_type,
    STATE(4064), 1,
      sym__type_specifier,
    STATE(6337), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(1827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [178134] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5135), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5137), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [178175] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(2589), 1,
      anon_sym_enum,
    ACTIONS(2591), 1,
      anon_sym_class,
    ACTIONS(2593), 1,
      anon_sym_struct,
    ACTIONS(2595), 1,
      anon_sym_union,
    ACTIONS(2621), 1,
      sym_auto,
    ACTIONS(2623), 1,
      anon_sym_decltype,
    ACTIONS(2625), 1,
      anon_sym_typename,
    ACTIONS(7233), 1,
      sym_identifier,
    ACTIONS(7235), 1,
      anon_sym_COLON_COLON,
    STATE(2164), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2612), 1,
      sym_primitive_type,
    STATE(2839), 1,
      sym__type_specifier,
    STATE(2882), 1,
      sym_qualified_type_identifier,
    STATE(2933), 1,
      sym_decltype_auto,
    STATE(6339), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(2868), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2587), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2585), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2935), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [178254] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(119), 1,
      sym_auto,
    ACTIONS(121), 1,
      anon_sym_decltype,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(3572), 1,
      sym_identifier,
    ACTIONS(3578), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3582), 1,
      anon_sym_enum,
    ACTIONS(3584), 1,
      anon_sym_class,
    ACTIONS(3586), 1,
      anon_sym_struct,
    ACTIONS(3588), 1,
      anon_sym_union,
    ACTIONS(3590), 1,
      anon_sym_typename,
    STATE(2614), 1,
      sym__type_specifier,
    STATE(2687), 1,
      sym_decltype_auto,
    STATE(2825), 1,
      sym_qualified_type_identifier,
    STATE(2855), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3443), 1,
      sym_primitive_type,
    STATE(6333), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(2618), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(3580), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2629), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [178333] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4924), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(4926), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [178374] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(2621), 1,
      sym_auto,
    ACTIONS(2623), 1,
      anon_sym_decltype,
    ACTIONS(8394), 1,
      sym_identifier,
    ACTIONS(8396), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8398), 1,
      anon_sym_enum,
    ACTIONS(8400), 1,
      anon_sym_class,
    ACTIONS(8402), 1,
      anon_sym_struct,
    ACTIONS(8404), 1,
      anon_sym_union,
    ACTIONS(8406), 1,
      anon_sym_typename,
    STATE(2164), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2612), 1,
      sym_primitive_type,
    STATE(2882), 1,
      sym_qualified_type_identifier,
    STATE(2933), 1,
      sym_decltype_auto,
    STATE(4133), 1,
      sym__type_specifier,
    STATE(6376), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(2868), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2587), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2585), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2935), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [178453] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5121), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5123), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [178494] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5046), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5048), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [178535] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(8338), 1,
      sym_identifier,
    ACTIONS(8340), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8342), 1,
      anon_sym_enum,
    ACTIONS(8344), 1,
      anon_sym_class,
    ACTIONS(8346), 1,
      anon_sym_struct,
    ACTIONS(8348), 1,
      anon_sym_union,
    ACTIONS(8350), 1,
      anon_sym_typename,
    STATE(1898), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2293), 1,
      sym_primitive_type,
    STATE(3973), 1,
      sym__type_specifier,
    STATE(6337), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(1827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [178614] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5070), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5072), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [178655] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6911), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6913), 1,
      anon_sym_AMP,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(7226), 1,
      anon_sym_DASH_GT,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8500), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8523), 1,
      anon_sym_requires,
    STATE(5025), 1,
      sym_ref_qualifier,
    STATE(5816), 1,
      sym__function_attributes_end,
    STATE(5983), 1,
      sym_trailing_return_type,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8438), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5255), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8312), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [178734] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8330), 1,
      anon_sym___attribute__,
    ACTIONS(8428), 1,
      anon_sym_LBRACE,
    STATE(4938), 1,
      sym_enumerator_list,
    STATE(5033), 1,
      sym_attribute_specifier,
    ACTIONS(5350), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5352), 27,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [178783] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6911), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6913), 1,
      anon_sym_AMP,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(7142), 1,
      anon_sym_DASH_GT,
    ACTIONS(7144), 1,
      anon_sym_requires,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    STATE(5023), 1,
      sym_ref_qualifier,
    STATE(5885), 1,
      sym__function_attributes_end,
    STATE(5956), 1,
      sym_trailing_return_type,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5948), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5246), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8312), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [178862] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5085), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5087), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [178903] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(2621), 1,
      sym_auto,
    ACTIONS(2623), 1,
      anon_sym_decltype,
    ACTIONS(8394), 1,
      sym_identifier,
    ACTIONS(8396), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8398), 1,
      anon_sym_enum,
    ACTIONS(8400), 1,
      anon_sym_class,
    ACTIONS(8402), 1,
      anon_sym_struct,
    ACTIONS(8404), 1,
      anon_sym_union,
    ACTIONS(8406), 1,
      anon_sym_typename,
    STATE(2164), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2612), 1,
      sym_primitive_type,
    STATE(2882), 1,
      sym_qualified_type_identifier,
    STATE(2933), 1,
      sym_decltype_auto,
    STATE(4110), 1,
      sym__type_specifier,
    STATE(6376), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(2868), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2587), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(2585), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2935), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [178982] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(8464), 1,
      sym_identifier,
    ACTIONS(8466), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8470), 1,
      anon_sym_enum,
    ACTIONS(8472), 1,
      anon_sym_class,
    ACTIONS(8474), 1,
      anon_sym_struct,
    ACTIONS(8476), 1,
      anon_sym_union,
    ACTIONS(8478), 1,
      sym_auto,
    ACTIONS(8480), 1,
      anon_sym_decltype,
    ACTIONS(8482), 1,
      anon_sym_typename,
    STATE(2377), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2747), 1,
      sym_primitive_type,
    STATE(2774), 1,
      sym__type_specifier,
    STATE(3090), 1,
      sym_qualified_type_identifier,
    STATE(3187), 1,
      sym_decltype_auto,
    STATE(6368), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(2981), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5619), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8468), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3184), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [179061] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5093), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5095), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [179102] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(8352), 1,
      sym_identifier,
    ACTIONS(8354), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8358), 1,
      anon_sym_enum,
    ACTIONS(8360), 1,
      anon_sym_class,
    ACTIONS(8362), 1,
      anon_sym_struct,
    ACTIONS(8364), 1,
      anon_sym_union,
    ACTIONS(8366), 1,
      sym_auto,
    ACTIONS(8368), 1,
      anon_sym_decltype,
    ACTIONS(8370), 1,
      anon_sym_typename,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2984), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3753), 1,
      sym_primitive_type,
    STATE(3837), 1,
      sym__type_specifier,
    STATE(4057), 1,
      sym_decltype_auto,
    STATE(6377), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(4027), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(6492), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8356), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4070), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [179181] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5145), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5147), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [179222] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6911), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6913), 1,
      anon_sym_AMP,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(7142), 1,
      anon_sym_DASH_GT,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8526), 1,
      anon_sym_requires,
    STATE(5040), 1,
      sym_ref_qualifier,
    STATE(5864), 1,
      sym__function_attributes_end,
    STATE(5924), 1,
      sym_trailing_return_type,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8322), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5948), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5244), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8312), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [179301] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(8338), 1,
      sym_identifier,
    ACTIONS(8340), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8342), 1,
      anon_sym_enum,
    ACTIONS(8344), 1,
      anon_sym_class,
    ACTIONS(8346), 1,
      anon_sym_struct,
    ACTIONS(8348), 1,
      anon_sym_union,
    ACTIONS(8350), 1,
      anon_sym_typename,
    STATE(1829), 1,
      sym__type_specifier,
    STATE(1898), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2293), 1,
      sym_primitive_type,
    STATE(6337), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(1827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [179380] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1865), 1,
      sym_auto,
    ACTIONS(1867), 1,
      anon_sym_decltype,
    ACTIONS(7126), 1,
      sym_identifier,
    ACTIONS(7128), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7132), 1,
      anon_sym_enum,
    ACTIONS(7134), 1,
      anon_sym_class,
    ACTIONS(7136), 1,
      anon_sym_struct,
    ACTIONS(7138), 1,
      anon_sym_union,
    ACTIONS(7140), 1,
      anon_sym_typename,
    STATE(1829), 1,
      sym__type_specifier,
    STATE(1973), 1,
      sym_decltype_auto,
    STATE(2825), 1,
      sym_qualified_type_identifier,
    STATE(4908), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5150), 1,
      sym_primitive_type,
    STATE(6365), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(1874), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7130), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1990), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [179459] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5185), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [179500] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5066), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5068), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [179541] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5058), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5060), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [179582] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(8464), 1,
      sym_identifier,
    ACTIONS(8466), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8470), 1,
      anon_sym_enum,
    ACTIONS(8472), 1,
      anon_sym_class,
    ACTIONS(8474), 1,
      anon_sym_struct,
    ACTIONS(8476), 1,
      anon_sym_union,
    ACTIONS(8478), 1,
      sym_auto,
    ACTIONS(8480), 1,
      anon_sym_decltype,
    ACTIONS(8482), 1,
      anon_sym_typename,
    STATE(2377), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2747), 1,
      sym_primitive_type,
    STATE(2988), 1,
      sym__type_specifier,
    STATE(3090), 1,
      sym_qualified_type_identifier,
    STATE(3187), 1,
      sym_decltype_auto,
    STATE(6368), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(2981), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(5619), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8468), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3184), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [179661] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(8352), 1,
      sym_identifier,
    ACTIONS(8354), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8358), 1,
      anon_sym_enum,
    ACTIONS(8360), 1,
      anon_sym_class,
    ACTIONS(8362), 1,
      anon_sym_struct,
    ACTIONS(8364), 1,
      anon_sym_union,
    ACTIONS(8366), 1,
      sym_auto,
    ACTIONS(8368), 1,
      anon_sym_decltype,
    ACTIONS(8370), 1,
      anon_sym_typename,
    STATE(2233), 1,
      sym_qualified_type_identifier,
    STATE(2984), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3753), 1,
      sym_primitive_type,
    STATE(4013), 1,
      sym__type_specifier,
    STATE(4057), 1,
      sym_decltype_auto,
    STATE(6377), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_dependent_type_identifier,
    STATE(4027), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(6492), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(8356), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4070), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [179740] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5042), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5044), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [179781] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5030), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5032), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [179822] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6911), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6913), 1,
      anon_sym_AMP,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(7226), 1,
      anon_sym_DASH_GT,
    ACTIONS(7228), 1,
      anon_sym_requires,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8500), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5000), 1,
      sym_ref_qualifier,
    STATE(5808), 1,
      sym__function_attributes_end,
    STATE(5919), 1,
      sym_trailing_return_type,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5257), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8312), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [179901] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5050), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5052), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [179942] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5034), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5036), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [179983] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8330), 1,
      anon_sym___attribute__,
    STATE(5012), 1,
      sym_attribute_specifier,
    ACTIONS(5386), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5388), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [180027] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8330), 1,
      anon_sym___attribute__,
    STATE(5044), 1,
      sym_attribute_specifier,
    ACTIONS(5499), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5501), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [180071] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(7309), 1,
      sym_auto,
    ACTIONS(7311), 1,
      anon_sym_decltype,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(7526), 1,
      anon_sym_COLON,
    ACTIONS(7705), 1,
      anon_sym_const,
    ACTIONS(8151), 1,
      anon_sym_STAR,
    ACTIONS(8153), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8155), 1,
      anon_sym_AMP,
    STATE(1988), 1,
      sym_decltype_auto,
    STATE(3982), 1,
      sym_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6549), 1,
      sym__abstract_declarator,
    STATE(5078), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7697), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [180139] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(7652), 1,
      sym_identifier,
    ACTIONS(7654), 1,
      anon_sym_LPAREN2,
    ACTIONS(7656), 1,
      anon_sym_STAR,
    ACTIONS(7658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7660), 1,
      anon_sym_AMP,
    STATE(5913), 1,
      sym__field_declarator,
    STATE(6201), 1,
      sym_operator_name,
    STATE(8292), 1,
      sym_ms_based_modifier,
    STATE(4972), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6227), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [180201] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8529), 1,
      sym_identifier,
    STATE(4950), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4952), 1,
      sym_primitive_type,
    ACTIONS(8535), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(4934), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(8532), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4936), 18,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
  [180251] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(7654), 1,
      anon_sym_LPAREN2,
    ACTIONS(7662), 1,
      sym_identifier,
    ACTIONS(7664), 1,
      anon_sym_STAR,
    ACTIONS(7666), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7668), 1,
      anon_sym_AMP,
    STATE(6410), 1,
      sym__field_declarator,
    STATE(6495), 1,
      sym_operator_name,
    STATE(7783), 1,
      sym_ms_based_modifier,
    STATE(4972), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6227), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [180313] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8330), 1,
      anon_sym___attribute__,
    STATE(5011), 1,
      sym_attribute_specifier,
    ACTIONS(5481), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5483), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [180357] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5926), 1,
      anon_sym___attribute__,
    ACTIONS(6157), 1,
      anon_sym_LBRACE,
    ACTIONS(8538), 1,
      anon_sym_COLON,
    STATE(2710), 1,
      sym__enum_base_clause,
    STATE(2803), 1,
      sym_enumerator_list,
    STATE(2895), 1,
      sym_attribute_specifier,
    ACTIONS(5689), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5691), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [180409] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(6955), 1,
      anon_sym_DASH_GT,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8432), 1,
      anon_sym___attribute__,
    ACTIONS(8435), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8441), 1,
      anon_sym_requires,
    STATE(5598), 1,
      sym__function_attributes_end,
    STATE(5685), 1,
      sym_trailing_return_type,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8438), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5210), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8312), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [180481] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5573), 1,
      anon_sym___attribute__,
    ACTIONS(5728), 1,
      anon_sym_LBRACE,
    ACTIONS(8540), 1,
      anon_sym_COLON,
    STATE(1956), 1,
      sym_attribute_specifier,
    STATE(2442), 1,
      sym__enum_base_clause,
    STATE(2510), 1,
      sym_enumerator_list,
    ACTIONS(5629), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5631), 24,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [180533] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8330), 1,
      anon_sym___attribute__,
    STATE(5004), 1,
      sym_attribute_specifier,
    ACTIONS(5493), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5495), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [180577] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8330), 1,
      anon_sym___attribute__,
    STATE(4996), 1,
      sym_attribute_specifier,
    ACTIONS(5456), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5458), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [180621] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(7652), 1,
      sym_identifier,
    ACTIONS(7654), 1,
      anon_sym_LPAREN2,
    ACTIONS(7656), 1,
      anon_sym_STAR,
    ACTIONS(7658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7660), 1,
      anon_sym_AMP,
    STATE(6012), 1,
      sym__field_declarator,
    STATE(6201), 1,
      sym_operator_name,
    STATE(8292), 1,
      sym_ms_based_modifier,
    STATE(4972), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6227), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [180683] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5573), 1,
      anon_sym___attribute__,
    ACTIONS(5728), 1,
      anon_sym_LBRACE,
    ACTIONS(8540), 1,
      anon_sym_COLON,
    STATE(1941), 1,
      sym_attribute_specifier,
    STATE(2476), 1,
      sym__enum_base_clause,
    STATE(2531), 1,
      sym_enumerator_list,
    ACTIONS(5689), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5691), 24,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [180735] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8330), 1,
      anon_sym___attribute__,
    STATE(4993), 1,
      sym_attribute_specifier,
    ACTIONS(5452), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5454), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [180779] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(7691), 1,
      anon_sym_STAR,
    ACTIONS(7693), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7695), 1,
      anon_sym_AMP,
    ACTIONS(7705), 1,
      anon_sym_const,
    STATE(3980), 1,
      sym_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6394), 1,
      sym__abstract_declarator,
    STATE(5263), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7795), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7697), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [180841] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_const,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(7711), 1,
      anon_sym_STAR,
    ACTIONS(7713), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7715), 1,
      anon_sym_AMP,
    STATE(3343), 1,
      sym_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6287), 1,
      sym__abstract_declarator,
    STATE(4968), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5555), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7319), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [180903] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(7691), 1,
      anon_sym_STAR,
    ACTIONS(7693), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7695), 1,
      anon_sym_AMP,
    ACTIONS(7705), 1,
      anon_sym_const,
    STATE(3980), 1,
      sym_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6411), 1,
      sym__abstract_declarator,
    STATE(5263), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5555), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7697), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [180965] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(7654), 1,
      anon_sym_LPAREN2,
    ACTIONS(7662), 1,
      sym_identifier,
    ACTIONS(7664), 1,
      anon_sym_STAR,
    ACTIONS(7666), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7668), 1,
      anon_sym_AMP,
    STATE(6419), 1,
      sym__field_declarator,
    STATE(6495), 1,
      sym_operator_name,
    STATE(7783), 1,
      sym_ms_based_modifier,
    STATE(4972), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6227), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [181027] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(7691), 1,
      anon_sym_STAR,
    ACTIONS(7693), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7695), 1,
      anon_sym_AMP,
    ACTIONS(7705), 1,
      anon_sym_const,
    STATE(3980), 1,
      sym_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6413), 1,
      sym__abstract_declarator,
    STATE(5263), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7753), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7697), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [181089] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(7691), 1,
      anon_sym_STAR,
    ACTIONS(7693), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7695), 1,
      anon_sym_AMP,
    ACTIONS(7705), 1,
      anon_sym_const,
    STATE(3980), 1,
      sym_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6385), 1,
      sym__abstract_declarator,
    STATE(5263), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6297), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7697), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [181151] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(6955), 1,
      anon_sym_DASH_GT,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    ACTIONS(8542), 1,
      anon_sym___attribute__,
    ACTIONS(8545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8551), 1,
      anon_sym_requires,
    STATE(5606), 1,
      sym__function_attributes_end,
    STATE(5669), 1,
      sym_trailing_return_type,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8548), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5778), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5212), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8508), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [181223] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8330), 1,
      anon_sym___attribute__,
    STATE(5009), 1,
      sym_attribute_specifier,
    ACTIONS(5400), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5402), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [181267] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(6955), 1,
      anon_sym_DASH_GT,
    ACTIONS(6963), 1,
      anon_sym_requires,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    ACTIONS(8542), 1,
      anon_sym___attribute__,
    ACTIONS(8545), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5600), 1,
      sym_trailing_return_type,
    STATE(5640), 1,
      sym__function_attributes_end,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5778), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5203), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8508), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [181339] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8330), 1,
      anon_sym___attribute__,
    STATE(5026), 1,
      sym_attribute_specifier,
    ACTIONS(5363), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5365), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [181383] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8330), 1,
      anon_sym___attribute__,
    STATE(5037), 1,
      sym_attribute_specifier,
    ACTIONS(5414), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5416), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [181427] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(7309), 1,
      sym_auto,
    ACTIONS(7311), 1,
      anon_sym_decltype,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(7537), 1,
      anon_sym_COLON,
    ACTIONS(7705), 1,
      anon_sym_const,
    ACTIONS(8151), 1,
      anon_sym_STAR,
    ACTIONS(8153), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8155), 1,
      anon_sym_AMP,
    STATE(1988), 1,
      sym_decltype_auto,
    STATE(3982), 1,
      sym_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6564), 1,
      sym__abstract_declarator,
    STATE(5088), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7697), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [181495] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6911), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6913), 1,
      anon_sym_AMP,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(7255), 1,
      anon_sym_DASH_GT,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8554), 1,
      anon_sym_requires,
    STATE(5108), 1,
      sym_ref_qualifier,
    STATE(5945), 1,
      sym__function_attributes_end,
    STATE(6198), 1,
      sym_trailing_return_type,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8322), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5948), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5266), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8312), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [181573] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_const,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(7711), 1,
      anon_sym_STAR,
    ACTIONS(7713), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7715), 1,
      anon_sym_AMP,
    STATE(3343), 1,
      sym_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6261), 1,
      sym__abstract_declarator,
    STATE(4968), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6297), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7319), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [181635] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8330), 1,
      anon_sym___attribute__,
    STATE(5051), 1,
      sym_attribute_specifier,
    ACTIONS(5473), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5475), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [181679] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(7654), 1,
      anon_sym_LPAREN2,
    ACTIONS(7662), 1,
      sym_identifier,
    ACTIONS(7664), 1,
      anon_sym_STAR,
    ACTIONS(7666), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7668), 1,
      anon_sym_AMP,
    STATE(6421), 1,
      sym__field_declarator,
    STATE(6495), 1,
      sym_operator_name,
    STATE(7783), 1,
      sym_ms_based_modifier,
    STATE(4972), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6227), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [181741] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6911), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6913), 1,
      anon_sym_AMP,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(7255), 1,
      anon_sym_DASH_GT,
    ACTIONS(7260), 1,
      anon_sym_requires,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    STATE(5074), 1,
      sym_ref_qualifier,
    STATE(5934), 1,
      sym__function_attributes_end,
    STATE(6144), 1,
      sym_trailing_return_type,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5948), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5271), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8312), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [181819] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(5728), 1,
      anon_sym_LBRACE,
    STATE(1984), 1,
      sym_attribute_specifier,
    STATE(5056), 1,
      sym_enumerator_list,
    ACTIONS(5352), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(5350), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [181867] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8330), 1,
      anon_sym___attribute__,
    STATE(5038), 1,
      sym_attribute_specifier,
    ACTIONS(5489), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5491), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [181911] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8330), 1,
      anon_sym___attribute__,
    STATE(5048), 1,
      sym_attribute_specifier,
    ACTIONS(5485), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5487), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [181955] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(5728), 1,
      anon_sym_LBRACE,
    STATE(1960), 1,
      sym_attribute_specifier,
    STATE(5052), 1,
      sym_enumerator_list,
    ACTIONS(5295), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(5293), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [182003] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5926), 1,
      anon_sym___attribute__,
    ACTIONS(6157), 1,
      anon_sym_LBRACE,
    ACTIONS(8538), 1,
      anon_sym_COLON,
    STATE(2712), 1,
      sym__enum_base_clause,
    STATE(2813), 1,
      sym_enumerator_list,
    STATE(2914), 1,
      sym_attribute_specifier,
    ACTIONS(5629), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5631), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [182055] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8316), 1,
      anon_sym_LT,
    STATE(1741), 1,
      sym_template_argument_list,
    STATE(4956), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3767), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(8557), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3759), 21,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [182105] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(6955), 1,
      anon_sym_DASH_GT,
    ACTIONS(6963), 1,
      anon_sym_requires,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8432), 1,
      anon_sym___attribute__,
    ACTIONS(8435), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5625), 1,
      sym__function_attributes_end,
    STATE(5647), 1,
      sym_trailing_return_type,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5216), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8312), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [182177] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(7652), 1,
      sym_identifier,
    ACTIONS(7654), 1,
      anon_sym_LPAREN2,
    ACTIONS(7656), 1,
      anon_sym_STAR,
    ACTIONS(7658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7660), 1,
      anon_sym_AMP,
    STATE(6006), 1,
      sym__field_declarator,
    STATE(6201), 1,
      sym_operator_name,
    STATE(8292), 1,
      sym_ms_based_modifier,
    STATE(4972), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6227), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(2917), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [182239] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5117), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5119), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [182278] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(6963), 1,
      anon_sym_requires,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(7043), 1,
      anon_sym_DASH_GT,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    ACTIONS(8545), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5600), 1,
      sym_trailing_return_type,
    STATE(5777), 1,
      sym__function_attributes_end,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5778), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5237), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8508), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [182349] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(7100), 1,
      anon_sym_DASH_GT,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    ACTIONS(8559), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8565), 1,
      anon_sym_requires,
    STATE(5579), 1,
      sym_trailing_return_type,
    STATE(5621), 1,
      sym__function_attributes_end,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(8548), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8562), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5778), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5224), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8508), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [182420] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(6963), 1,
      anon_sym_requires,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(7043), 1,
      anon_sym_DASH_GT,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8435), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5647), 1,
      sym_trailing_return_type,
    STATE(5732), 1,
      sym__function_attributes_end,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5226), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8312), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [182491] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(7100), 1,
      anon_sym_DASH_GT,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8500), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8503), 1,
      anon_sym_requires,
    STATE(5557), 1,
      sym_trailing_return_type,
    STATE(5580), 1,
      sym__function_attributes_end,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(8438), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8497), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5217), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8312), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [182562] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2026), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5367), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(8568), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5369), 22,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [182605] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2026), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5139), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(8571), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5142), 22,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [182648] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4922), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4924), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(4926), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [182689] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4964), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5418), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(8575), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5420), 22,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [182732] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4962), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5408), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(8578), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5410), 22,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [182775] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(7043), 1,
      anon_sym_DASH_GT,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    ACTIONS(8545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8551), 1,
      anon_sym_requires,
    STATE(5669), 1,
      sym_trailing_return_type,
    STATE(5713), 1,
      sym__function_attributes_end,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8548), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5778), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5221), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8508), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [182846] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_const,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(7919), 1,
      anon_sym_STAR,
    ACTIONS(7921), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7923), 1,
      anon_sym_AMP,
    STATE(3830), 1,
      sym_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6439), 1,
      sym__abstract_declarator,
    STATE(4968), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7795), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7319), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [182907] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2026), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5404), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(8581), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5406), 22,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [182950] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(7043), 1,
      anon_sym_DASH_GT,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8435), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8441), 1,
      anon_sym_requires,
    STATE(5685), 1,
      sym_trailing_return_type,
    STATE(5767), 1,
      sym__function_attributes_end,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8438), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5227), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8312), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [183021] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(6963), 1,
      anon_sym_requires,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(7105), 1,
      anon_sym_DASH_GT,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    ACTIONS(8545), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5570), 1,
      sym__function_attributes_end,
    STATE(5600), 1,
      sym_trailing_return_type,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8562), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5778), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5230), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8508), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [183092] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4867), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(4869), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [183131] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(6963), 1,
      anon_sym_requires,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(7105), 1,
      anon_sym_DASH_GT,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8435), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5632), 1,
      sym__function_attributes_end,
    STATE(5647), 1,
      sym_trailing_return_type,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8497), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5222), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8312), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [183202] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_const,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(4520), 1,
      anon_sym_STAR,
    ACTIONS(4522), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4524), 1,
      anon_sym_AMP,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6435), 1,
      sym__abstract_declarator,
    STATE(4968), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5555), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7319), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [183263] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2026), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5448), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(8584), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5450), 22,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [183306] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_LBRACE,
    ACTIONS(8587), 1,
      anon_sym_LPAREN2,
    STATE(2535), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3688), 1,
      sym_argument_list,
    STATE(4703), 1,
      sym_initializer_list,
    ACTIONS(4924), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5924), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4926), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [183357] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2026), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5424), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(8590), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5426), 22,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [183400] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4875), 1,
      sym_auto,
    ACTIONS(4877), 1,
      anon_sym_decltype,
    STATE(1988), 1,
      sym_decltype_auto,
    STATE(5195), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8595), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(8593), 10,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [183449] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_const,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(4520), 1,
      anon_sym_STAR,
    ACTIONS(4522), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4524), 1,
      anon_sym_AMP,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6449), 1,
      sym__abstract_declarator,
    STATE(4968), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6297), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7319), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [183510] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5156), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5158), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [183549] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4822), 1,
      anon_sym_AMP,
    ACTIONS(8600), 1,
      anon_sym_const,
    STATE(4968), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8597), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
    ACTIONS(4824), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [183594] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7606), 1,
      sym_auto,
    ACTIONS(7608), 1,
      anon_sym_decltype,
    STATE(5016), 1,
      sym_decltype_auto,
    ACTIONS(4871), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(4873), 26,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [183639] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4949), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5107), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(5105), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [183680] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5066), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5068), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [183719] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4972), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4822), 6,
      anon_sym_AMP,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
    ACTIONS(4824), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(8600), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [183762] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(7105), 1,
      anon_sym_DASH_GT,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    ACTIONS(8545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8551), 1,
      anon_sym_requires,
    STATE(5589), 1,
      sym__function_attributes_end,
    STATE(5669), 1,
      sym_trailing_return_type,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(8548), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8562), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5778), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5240), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8508), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [183833] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(7105), 1,
      anon_sym_DASH_GT,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8435), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8441), 1,
      anon_sym_requires,
    STATE(5588), 1,
      sym__function_attributes_end,
    STATE(5685), 1,
      sym_trailing_return_type,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(8438), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8497), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5238), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8312), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [183904] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5030), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5032), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [183943] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(7117), 1,
      anon_sym_DASH_GT,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8500), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8503), 1,
      anon_sym_requires,
    STATE(5557), 1,
      sym_trailing_return_type,
    STATE(5721), 1,
      sym__function_attributes_end,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8438), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5233), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8312), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [184014] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(7107), 1,
      anon_sym_requires,
    ACTIONS(7117), 1,
      anon_sym_DASH_GT,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8500), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5560), 1,
      sym_trailing_return_type,
    STATE(5738), 1,
      sym__function_attributes_end,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5236), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8312), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [184085] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(7117), 1,
      anon_sym_DASH_GT,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    ACTIONS(8559), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8565), 1,
      anon_sym_requires,
    STATE(5579), 1,
      sym_trailing_return_type,
    STATE(5720), 1,
      sym__function_attributes_end,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8548), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5778), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5231), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8508), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [184156] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_const,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(4520), 1,
      anon_sym_STAR,
    ACTIONS(4522), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4524), 1,
      anon_sym_AMP,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6464), 1,
      sym__abstract_declarator,
    STATE(4968), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7795), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7319), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [184217] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(7100), 1,
      anon_sym_DASH_GT,
    ACTIONS(7107), 1,
      anon_sym_requires,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8500), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5560), 1,
      sym_trailing_return_type,
    STATE(5634), 1,
      sym__function_attributes_end,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8497), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5241), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8312), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [184288] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4875), 1,
      sym_auto,
    ACTIONS(4877), 1,
      anon_sym_decltype,
    STATE(1988), 1,
      sym_decltype_auto,
    STATE(5193), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8605), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(8603), 10,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [184337] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_const,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(7919), 1,
      anon_sym_STAR,
    ACTIONS(7921), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7923), 1,
      anon_sym_AMP,
    STATE(3830), 1,
      sym_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6443), 1,
      sym__abstract_declarator,
    STATE(4968), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7753), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7319), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [184398] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5078), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5080), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [184437] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(7100), 1,
      anon_sym_DASH_GT,
    ACTIONS(7107), 1,
      anon_sym_requires,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    ACTIONS(8559), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5558), 1,
      sym_trailing_return_type,
    STATE(5665), 1,
      sym__function_attributes_end,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8562), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5778), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5218), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8508), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [184508] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5105), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5107), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [184547] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_const,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(7919), 1,
      anon_sym_STAR,
    ACTIONS(7921), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7923), 1,
      anon_sym_AMP,
    STATE(3830), 1,
      sym_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6470), 1,
      sym__abstract_declarator,
    STATE(4968), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5555), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7319), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [184608] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_const,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(7919), 1,
      anon_sym_STAR,
    ACTIONS(7921), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7923), 1,
      anon_sym_AMP,
    STATE(3830), 1,
      sym_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6472), 1,
      sym__abstract_declarator,
    STATE(4968), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6297), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7319), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [184669] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_const,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(4520), 1,
      anon_sym_STAR,
    ACTIONS(4522), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4524), 1,
      anon_sym_AMP,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6479), 1,
      sym__abstract_declarator,
    STATE(4968), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7753), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7319), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [184730] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(7107), 1,
      anon_sym_requires,
    ACTIONS(7117), 1,
      anon_sym_DASH_GT,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    ACTIONS(8559), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5558), 1,
      sym_trailing_return_type,
    STATE(5734), 1,
      sym__function_attributes_end,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5778), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5223), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8508), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [184801] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5050), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5052), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [184839] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    STATE(1939), 1,
      sym_attribute_specifier,
    ACTIONS(5495), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(5493), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [184881] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5113), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5115), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [184919] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5109), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5111), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [184957] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(5511), 1,
      sym_identifier,
    ACTIONS(5521), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    ACTIONS(6798), 1,
      anon_sym_STAR,
    ACTIONS(6800), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6802), 1,
      anon_sym_AMP,
    STATE(5695), 1,
      sym__scope_resolution,
    STATE(5813), 1,
      sym__declarator,
    STATE(7324), 1,
      sym_init_declarator,
    STATE(7894), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [185027] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5099), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [185065] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5089), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5091), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [185103] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5074), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5076), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [185141] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(7226), 1,
      anon_sym_DASH_GT,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8500), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8523), 1,
      anon_sym_requires,
    STATE(5816), 1,
      sym__function_attributes_end,
    STATE(5983), 1,
      sym_trailing_return_type,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8438), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5255), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8312), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [185211] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6911), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6913), 1,
      anon_sym_AMP,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(7331), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7333), 1,
      anon_sym_DASH_GT,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8526), 1,
      anon_sym_requires,
    STATE(5211), 1,
      sym_ref_qualifier,
    STATE(5924), 1,
      sym_trailing_return_type,
    STATE(6203), 1,
      sym__function_attributes_end,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8312), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(8322), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5948), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5357), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [185287] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(7226), 1,
      anon_sym_DASH_GT,
    ACTIONS(7228), 1,
      anon_sym_requires,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    ACTIONS(8559), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5799), 1,
      sym__function_attributes_end,
    STATE(5920), 1,
      sym_trailing_return_type,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5778), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5258), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8508), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [185357] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5050), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5052), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [185395] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8607), 1,
      sym_ms_restrict_modifier,
    STATE(5201), 1,
      sym_ms_unaligned_ptr_modifier,
    ACTIONS(7084), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(8610), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8613), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(5002), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(7086), 20,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [185443] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5038), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5040), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [185481] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5034), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5036), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [185519] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5050), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5052), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [185557] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    STATE(1947), 1,
      sym_attribute_specifier,
    ACTIONS(5475), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(5473), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [185599] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(7142), 1,
      anon_sym_DASH_GT,
    ACTIONS(7144), 1,
      anon_sym_requires,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    STATE(5885), 1,
      sym__function_attributes_end,
    STATE(5956), 1,
      sym_trailing_return_type,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5948), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5246), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8312), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [185669] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5121), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5123), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [185707] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5125), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5127), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [185745] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5042), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5044), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [185783] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5058), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5060), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [185821] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5129), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5131), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [185859] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6911), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6913), 1,
      anon_sym_AMP,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(7302), 1,
      anon_sym_DASH_GT,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8435), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8616), 1,
      anon_sym_requires,
    STATE(5214), 1,
      sym_ref_qualifier,
    STATE(6079), 1,
      sym__function_attributes_end,
    STATE(6245), 1,
      sym_trailing_return_type,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8312), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(8438), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5387), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [185935] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5121), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5123), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [185973] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    STATE(1945), 1,
      sym_attribute_specifier,
    ACTIONS(5483), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(5481), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [186015] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5185), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [186053] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5145), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5147), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [186091] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5093), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5095), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [186129] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5085), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5087), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [186167] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5070), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5072), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [186205] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5046), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5048), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [186243] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6911), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6913), 1,
      anon_sym_AMP,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(7144), 1,
      anon_sym_requires,
    ACTIONS(7331), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7333), 1,
      anon_sym_DASH_GT,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    STATE(5207), 1,
      sym_ref_qualifier,
    STATE(5956), 1,
      sym_trailing_return_type,
    STATE(6177), 1,
      sym__function_attributes_end,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8312), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5948), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5393), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [186319] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(7142), 1,
      anon_sym_DASH_GT,
    ACTIONS(7144), 1,
      anon_sym_requires,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    STATE(5876), 1,
      sym__function_attributes_end,
    STATE(5975), 1,
      sym_trailing_return_type,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5911), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5248), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8508), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [186389] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6911), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6913), 1,
      anon_sym_AMP,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(7302), 1,
      anon_sym_DASH_GT,
    ACTIONS(7329), 1,
      anon_sym_requires,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8435), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5202), 1,
      sym_ref_qualifier,
    STATE(6064), 1,
      sym__function_attributes_end,
    STATE(6211), 1,
      sym_trailing_return_type,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8312), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5328), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [186465] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(7226), 1,
      anon_sym_DASH_GT,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    ACTIONS(8559), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8619), 1,
      anon_sym_requires,
    STATE(5806), 1,
      sym__function_attributes_end,
    STATE(5986), 1,
      sym_trailing_return_type,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8548), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5778), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5243), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8508), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [186535] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5168), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5170), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [186573] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4924), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(4926), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [186611] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5135), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5137), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [186649] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(5511), 1,
      sym_identifier,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    ACTIONS(6843), 1,
      anon_sym_STAR,
    ACTIONS(6845), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6847), 1,
      anon_sym_AMP,
    ACTIONS(6849), 1,
      anon_sym_COLON_COLON,
    STATE(5585), 1,
      sym__scope_resolution,
    STATE(5708), 1,
      sym__declarator,
    STATE(7188), 1,
      sym_init_declarator,
    STATE(7697), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [186719] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(5511), 1,
      sym_identifier,
    ACTIONS(5521), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    ACTIONS(6798), 1,
      anon_sym_STAR,
    ACTIONS(6800), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6802), 1,
      anon_sym_AMP,
    STATE(5695), 1,
      sym__scope_resolution,
    STATE(5750), 1,
      sym__declarator,
    STATE(7111), 1,
      sym_init_declarator,
    STATE(7894), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [186789] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(5511), 1,
      sym_identifier,
    ACTIONS(5521), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    ACTIONS(6798), 1,
      anon_sym_STAR,
    ACTIONS(6800), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6802), 1,
      anon_sym_AMP,
    STATE(5695), 1,
      sym__scope_resolution,
    STATE(5763), 1,
      sym__declarator,
    STATE(7246), 1,
      sym_init_declarator,
    STATE(7894), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [186859] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(5511), 1,
      sym_identifier,
    ACTIONS(5521), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    ACTIONS(6798), 1,
      anon_sym_STAR,
    ACTIONS(6800), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6802), 1,
      anon_sym_AMP,
    STATE(5695), 1,
      sym__scope_resolution,
    STATE(5751), 1,
      sym__declarator,
    STATE(7188), 1,
      sym_init_declarator,
    STATE(7894), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [186929] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5172), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5174), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [186967] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(5511), 1,
      sym_identifier,
    ACTIONS(5521), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    ACTIONS(6798), 1,
      anon_sym_STAR,
    ACTIONS(6800), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6802), 1,
      anon_sym_AMP,
    STATE(5695), 1,
      sym__scope_resolution,
    STATE(5710), 1,
      sym__declarator,
    STATE(6867), 1,
      sym_init_declarator,
    STATE(7894), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [187037] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    STATE(1954), 1,
      sym_attribute_specifier,
    ACTIONS(5458), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(5456), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [187079] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    STATE(1959), 1,
      sym_attribute_specifier,
    ACTIONS(5454), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(5452), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [187121] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5179), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5181), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [187159] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5164), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5166), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [187197] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(5511), 1,
      sym_identifier,
    ACTIONS(5521), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    ACTIONS(6798), 1,
      anon_sym_STAR,
    ACTIONS(6800), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6802), 1,
      anon_sym_AMP,
    STATE(5695), 1,
      sym__scope_resolution,
    STATE(5743), 1,
      sym__declarator,
    STATE(7188), 1,
      sym_init_declarator,
    STATE(7894), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [187267] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(7142), 1,
      anon_sym_DASH_GT,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    ACTIONS(8622), 1,
      anon_sym_requires,
    STATE(5852), 1,
      sym__function_attributes_end,
    STATE(5923), 1,
      sym_trailing_return_type,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8512), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5911), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5247), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8508), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [187337] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(8334), 1,
      anon_sym_LBRACE,
    ACTIONS(8625), 1,
      anon_sym_COLON,
    STATE(4743), 1,
      sym__enum_base_clause,
    STATE(4809), 1,
      sym_enumerator_list,
    STATE(4899), 1,
      sym_attribute_specifier,
    ACTIONS(5689), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5691), 21,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [187387] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    STATE(1965), 1,
      sym_attribute_specifier,
    ACTIONS(5402), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(5400), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [187429] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    STATE(1968), 1,
      sym_attribute_specifier,
    ACTIONS(5388), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(5386), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [187471] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5160), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5162), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [187509] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5152), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5154), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [187547] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(5511), 1,
      sym_identifier,
    ACTIONS(5521), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    ACTIONS(6798), 1,
      anon_sym_STAR,
    ACTIONS(6800), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6802), 1,
      anon_sym_AMP,
    STATE(5695), 1,
      sym__scope_resolution,
    STATE(5773), 1,
      sym__declarator,
    STATE(7093), 1,
      sym_init_declarator,
    STATE(7894), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [187617] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(7142), 1,
      anon_sym_DASH_GT,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8526), 1,
      anon_sym_requires,
    STATE(5864), 1,
      sym__function_attributes_end,
    STATE(5924), 1,
      sym_trailing_return_type,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8322), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5948), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5244), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8312), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [187687] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5054), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5056), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [187725] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(8334), 1,
      anon_sym_LBRACE,
    ACTIONS(8625), 1,
      anon_sym_COLON,
    STATE(4752), 1,
      sym__enum_base_clause,
    STATE(4810), 1,
      sym_enumerator_list,
    STATE(4811), 1,
      sym_attribute_specifier,
    ACTIONS(5629), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5631), 21,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [187775] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    STATE(1982), 1,
      sym_attribute_specifier,
    ACTIONS(5365), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(5363), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [187817] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5062), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5064), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [187855] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    STATE(1986), 1,
      sym_attribute_specifier,
    ACTIONS(5416), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(5414), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [187897] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    STATE(1981), 1,
      sym_attribute_specifier,
    ACTIONS(5491), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(5489), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [187939] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(7226), 1,
      anon_sym_DASH_GT,
    ACTIONS(7228), 1,
      anon_sym_requires,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8500), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5808), 1,
      sym__function_attributes_end,
    STATE(5919), 1,
      sym_trailing_return_type,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5257), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8312), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [188009] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    STATE(1980), 1,
      sym_attribute_specifier,
    ACTIONS(5501), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(5499), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [188051] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    STATE(1944), 1,
      sym_attribute_specifier,
    ACTIONS(5487), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(5485), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [188093] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4924), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(4926), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [188131] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7148), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8157), 1,
      anon_sym_LBRACE,
    ACTIONS(8627), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(4797), 1,
      sym_field_declaration_list,
    STATE(4881), 1,
      sym__class_declaration_item,
    STATE(4885), 1,
      sym__class_declaration,
    STATE(5427), 1,
      sym_ms_declspec_modifier,
    STATE(6355), 1,
      sym__scope_resolution,
    STATE(6735), 1,
      sym_virtual_specifier,
    STATE(7438), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4531), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5437), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5175), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [188210] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(5575), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7128), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8629), 1,
      sym_identifier,
    STATE(1901), 1,
      sym_template_type,
    STATE(1942), 1,
      sym__class_declaration,
    STATE(1949), 1,
      sym__class_declaration_item,
    STATE(4991), 1,
      sym_field_declaration_list,
    STATE(5434), 1,
      sym_ms_declspec_modifier,
    STATE(6365), 1,
      sym__scope_resolution,
    STATE(6725), 1,
      sym_virtual_specifier,
    STATE(7378), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4629), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5435), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5182), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [188289] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4627), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8631), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(2669), 1,
      sym__class_declaration,
    STATE(2680), 1,
      sym__class_declaration_item,
    STATE(3112), 1,
      sym_field_declaration_list,
    STATE(5429), 1,
      sym_ms_declspec_modifier,
    STATE(6346), 1,
      sym__scope_resolution,
    STATE(6695), 1,
      sym_virtual_specifier,
    STATE(7449), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2912), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5419), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5181), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [188368] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4627), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8631), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(2677), 1,
      sym__class_declaration,
    STATE(2680), 1,
      sym__class_declaration_item,
    STATE(3112), 1,
      sym_field_declaration_list,
    STATE(5429), 1,
      sym_ms_declspec_modifier,
    STATE(6346), 1,
      sym__scope_resolution,
    STATE(6695), 1,
      sym_virtual_specifier,
    STATE(7449), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2912), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5419), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5181), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [188447] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(6782), 1,
      sym_identifier,
    ACTIONS(6784), 1,
      anon_sym_STAR,
    ACTIONS(6786), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6788), 1,
      anon_sym_AMP,
    ACTIONS(6790), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    STATE(5612), 1,
      sym__scope_resolution,
    STATE(6260), 1,
      sym__declarator,
    STATE(7612), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [188514] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(6782), 1,
      sym_identifier,
    ACTIONS(6784), 1,
      anon_sym_STAR,
    ACTIONS(6786), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6788), 1,
      anon_sym_AMP,
    ACTIONS(6790), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    STATE(5612), 1,
      sym__scope_resolution,
    STATE(6224), 1,
      sym__declarator,
    STATE(7612), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [188581] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(6782), 1,
      sym_identifier,
    ACTIONS(6784), 1,
      anon_sym_STAR,
    ACTIONS(6786), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6788), 1,
      anon_sym_AMP,
    ACTIONS(6790), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    STATE(5612), 1,
      sym__scope_resolution,
    STATE(6226), 1,
      sym__declarator,
    STATE(7612), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [188648] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(5575), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8633), 1,
      sym_identifier,
    STATE(1901), 1,
      sym_template_type,
    STATE(1949), 1,
      sym__class_declaration_item,
    STATE(1955), 1,
      sym__class_declaration,
    STATE(2584), 1,
      sym_field_declaration_list,
    STATE(5482), 1,
      sym_ms_declspec_modifier,
    STATE(6373), 1,
      sym__scope_resolution,
    STATE(6813), 1,
      sym_virtual_specifier,
    STATE(7307), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2357), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5425), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5186), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [188727] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(5575), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8633), 1,
      sym_identifier,
    STATE(1901), 1,
      sym_template_type,
    STATE(1949), 1,
      sym__class_declaration_item,
    STATE(1953), 1,
      sym__class_declaration,
    STATE(2584), 1,
      sym_field_declaration_list,
    STATE(5482), 1,
      sym_ms_declspec_modifier,
    STATE(6373), 1,
      sym__scope_resolution,
    STATE(6813), 1,
      sym_virtual_specifier,
    STATE(7307), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2357), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5425), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5186), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [188806] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(7255), 1,
      anon_sym_DASH_GT,
    ACTIONS(7260), 1,
      anon_sym_requires,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    STATE(5934), 1,
      sym__function_attributes_end,
    STATE(6144), 1,
      sym_trailing_return_type,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5948), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5271), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8312), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [188875] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(2845), 1,
      anon_sym_STAR,
    ACTIONS(2847), 1,
      anon_sym_AMP,
    ACTIONS(4841), 1,
      sym_identifier,
    ACTIONS(5825), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    STATE(5610), 1,
      sym__scope_resolution,
    STATE(6220), 1,
      sym__declarator,
    STATE(8318), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [188942] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4627), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8631), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(2668), 1,
      sym__class_declaration,
    STATE(2680), 1,
      sym__class_declaration_item,
    STATE(3112), 1,
      sym_field_declaration_list,
    STATE(5429), 1,
      sym_ms_declspec_modifier,
    STATE(6346), 1,
      sym__scope_resolution,
    STATE(6695), 1,
      sym_virtual_specifier,
    STATE(7449), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2876), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5419), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5181), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [189021] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4627), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8631), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(2669), 1,
      sym__class_declaration,
    STATE(2680), 1,
      sym__class_declaration_item,
    STATE(3112), 1,
      sym_field_declaration_list,
    STATE(5429), 1,
      sym_ms_declspec_modifier,
    STATE(6346), 1,
      sym__scope_resolution,
    STATE(6695), 1,
      sym_virtual_specifier,
    STATE(7449), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2876), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5419), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5181), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [189100] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4627), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8631), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(2677), 1,
      sym__class_declaration,
    STATE(2680), 1,
      sym__class_declaration_item,
    STATE(3112), 1,
      sym_field_declaration_list,
    STATE(5429), 1,
      sym_ms_declspec_modifier,
    STATE(6346), 1,
      sym__scope_resolution,
    STATE(6695), 1,
      sym_virtual_specifier,
    STATE(7449), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2876), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5419), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5181), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [189179] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4627), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8631), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(2677), 1,
      sym__class_declaration,
    STATE(2680), 1,
      sym__class_declaration_item,
    STATE(3112), 1,
      sym_field_declaration_list,
    STATE(5429), 1,
      sym_ms_declspec_modifier,
    STATE(6346), 1,
      sym__scope_resolution,
    STATE(6695), 1,
      sym_virtual_specifier,
    STATE(7449), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2596), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5419), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5181), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [189258] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4627), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8631), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(2669), 1,
      sym__class_declaration,
    STATE(2680), 1,
      sym__class_declaration_item,
    STATE(3112), 1,
      sym_field_declaration_list,
    STATE(5429), 1,
      sym_ms_declspec_modifier,
    STATE(6346), 1,
      sym__scope_resolution,
    STATE(6695), 1,
      sym_virtual_specifier,
    STATE(7449), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2596), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5419), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5181), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [189337] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(7255), 1,
      anon_sym_DASH_GT,
    ACTIONS(7260), 1,
      anon_sym_requires,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    STATE(5936), 1,
      sym__function_attributes_end,
    STATE(6147), 1,
      sym_trailing_return_type,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5911), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5269), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8508), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [189406] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4627), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8631), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(2668), 1,
      sym__class_declaration,
    STATE(2680), 1,
      sym__class_declaration_item,
    STATE(3112), 1,
      sym_field_declaration_list,
    STATE(5429), 1,
      sym_ms_declspec_modifier,
    STATE(6346), 1,
      sym__scope_resolution,
    STATE(6695), 1,
      sym_virtual_specifier,
    STATE(7449), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2596), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5419), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5181), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [189485] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(5575), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8633), 1,
      sym_identifier,
    STATE(1901), 1,
      sym_template_type,
    STATE(1942), 1,
      sym__class_declaration,
    STATE(1949), 1,
      sym__class_declaration_item,
    STATE(2584), 1,
      sym_field_declaration_list,
    STATE(5482), 1,
      sym_ms_declspec_modifier,
    STATE(6373), 1,
      sym__scope_resolution,
    STATE(6813), 1,
      sym_virtual_specifier,
    STATE(7307), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2357), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5425), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5186), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [189564] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(2845), 1,
      anon_sym_STAR,
    ACTIONS(2847), 1,
      anon_sym_AMP,
    ACTIONS(4841), 1,
      sym_identifier,
    ACTIONS(5825), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    STATE(5610), 1,
      sym__scope_resolution,
    STATE(6406), 1,
      sym__declarator,
    STATE(8318), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [189631] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(7705), 1,
      anon_sym_const,
    ACTIONS(7795), 1,
      anon_sym_COLON,
    ACTIONS(8151), 1,
      anon_sym_STAR,
    ACTIONS(8153), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8155), 1,
      anon_sym_AMP,
    STATE(3982), 1,
      sym_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6563), 1,
      sym__abstract_declarator,
    STATE(5263), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7697), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [189690] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(6782), 1,
      sym_identifier,
    ACTIONS(6784), 1,
      anon_sym_STAR,
    ACTIONS(6786), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6788), 1,
      anon_sym_AMP,
    ACTIONS(6790), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    STATE(5612), 1,
      sym__scope_resolution,
    STATE(6209), 1,
      sym__declarator,
    STATE(7612), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [189757] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(6782), 1,
      sym_identifier,
    ACTIONS(6784), 1,
      anon_sym_STAR,
    ACTIONS(6786), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6788), 1,
      anon_sym_AMP,
    ACTIONS(6790), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    STATE(5612), 1,
      sym__scope_resolution,
    STATE(6278), 1,
      sym__declarator,
    STATE(7612), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [189824] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(6782), 1,
      sym_identifier,
    ACTIONS(6784), 1,
      anon_sym_STAR,
    ACTIONS(6786), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6788), 1,
      anon_sym_AMP,
    ACTIONS(6790), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    STATE(5612), 1,
      sym__scope_resolution,
    STATE(6266), 1,
      sym__declarator,
    STATE(7612), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [189891] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(5811), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8410), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8635), 1,
      sym_identifier,
    STATE(2692), 1,
      sym_template_type,
    STATE(2864), 1,
      sym_field_declaration_list,
    STATE(2998), 1,
      sym__class_declaration_item,
    STATE(3041), 1,
      sym__class_declaration,
    STATE(5443), 1,
      sym_ms_declspec_modifier,
    STATE(6348), 1,
      sym__scope_resolution,
    STATE(6711), 1,
      sym_virtual_specifier,
    STATE(7352), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2478), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5446), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5196), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [189970] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(5811), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8410), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8635), 1,
      sym_identifier,
    STATE(2692), 1,
      sym_template_type,
    STATE(2864), 1,
      sym_field_declaration_list,
    STATE(2998), 1,
      sym__class_declaration_item,
    STATE(3059), 1,
      sym__class_declaration,
    STATE(5443), 1,
      sym_ms_declspec_modifier,
    STATE(6348), 1,
      sym__scope_resolution,
    STATE(6711), 1,
      sym_virtual_specifier,
    STATE(7352), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2478), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5446), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5196), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [190049] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(5811), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8410), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8635), 1,
      sym_identifier,
    STATE(2692), 1,
      sym_template_type,
    STATE(2864), 1,
      sym_field_declaration_list,
    STATE(2998), 1,
      sym__class_declaration_item,
    STATE(3058), 1,
      sym__class_declaration,
    STATE(5443), 1,
      sym_ms_declspec_modifier,
    STATE(6348), 1,
      sym__scope_resolution,
    STATE(6711), 1,
      sym_virtual_specifier,
    STATE(7352), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2478), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5446), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5196), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [190128] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(6297), 1,
      anon_sym_COLON,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(7705), 1,
      anon_sym_const,
    ACTIONS(8151), 1,
      anon_sym_STAR,
    ACTIONS(8153), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8155), 1,
      anon_sym_AMP,
    STATE(3982), 1,
      sym_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6575), 1,
      sym__abstract_declarator,
    STATE(5263), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7697), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [190187] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(5555), 1,
      anon_sym_COLON,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(7705), 1,
      anon_sym_const,
    ACTIONS(8151), 1,
      anon_sym_STAR,
    ACTIONS(8153), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8155), 1,
      anon_sym_AMP,
    STATE(3982), 1,
      sym_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6572), 1,
      sym__abstract_declarator,
    STATE(5263), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7697), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [190246] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7351), 1,
      sym_identifier,
    ACTIONS(7353), 1,
      anon_sym_LPAREN2,
    ACTIONS(7371), 1,
      anon_sym_STAR,
    ACTIONS(7373), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    STATE(2372), 1,
      sym_pointer_type_declarator,
    STATE(5337), 1,
      sym_ms_call_modifier,
    STATE(6451), 1,
      sym__type_declarator,
    STATE(7781), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(49), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(2340), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
  [190307] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(7705), 1,
      anon_sym_const,
    ACTIONS(7753), 1,
      anon_sym_COLON,
    ACTIONS(8151), 1,
      anon_sym_STAR,
    ACTIONS(8153), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8155), 1,
      anon_sym_AMP,
    STATE(3982), 1,
      sym_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6573), 1,
      sym__abstract_declarator,
    STATE(5263), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7697), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [190366] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1967), 1,
      anon_sym_LBRACE,
    ACTIONS(6898), 1,
      anon_sym_LPAREN2,
    STATE(2262), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3362), 1,
      sym_argument_list,
    STATE(3363), 1,
      sym_initializer_list,
    ACTIONS(4924), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5446), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4926), 18,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
  [190415] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(6782), 1,
      sym_identifier,
    ACTIONS(6784), 1,
      anon_sym_STAR,
    ACTIONS(6786), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6788), 1,
      anon_sym_AMP,
    ACTIONS(6790), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    STATE(5612), 1,
      sym__scope_resolution,
    STATE(6244), 1,
      sym__declarator,
    STATE(7612), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [190482] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(4841), 1,
      sym_identifier,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    ACTIONS(6886), 1,
      anon_sym_STAR,
    ACTIONS(6888), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6890), 1,
      anon_sym_AMP,
    ACTIONS(6892), 1,
      anon_sym_COLON_COLON,
    STATE(5603), 1,
      sym__scope_resolution,
    STATE(6431), 1,
      sym__declarator,
    STATE(7821), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [190549] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(6782), 1,
      sym_identifier,
    ACTIONS(6784), 1,
      anon_sym_STAR,
    ACTIONS(6786), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6788), 1,
      anon_sym_AMP,
    ACTIONS(6790), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    STATE(5612), 1,
      sym__scope_resolution,
    STATE(6247), 1,
      sym__declarator,
    STATE(7612), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [190616] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4627), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8631), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(2668), 1,
      sym__class_declaration,
    STATE(2680), 1,
      sym__class_declaration_item,
    STATE(3112), 1,
      sym_field_declaration_list,
    STATE(5429), 1,
      sym_ms_declspec_modifier,
    STATE(6346), 1,
      sym__scope_resolution,
    STATE(6695), 1,
      sym_virtual_specifier,
    STATE(7449), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2950), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5419), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5181), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [190695] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4627), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8631), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(2669), 1,
      sym__class_declaration,
    STATE(2680), 1,
      sym__class_declaration_item,
    STATE(3112), 1,
      sym_field_declaration_list,
    STATE(5429), 1,
      sym_ms_declspec_modifier,
    STATE(6346), 1,
      sym__scope_resolution,
    STATE(6695), 1,
      sym_virtual_specifier,
    STATE(7449), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2950), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5419), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5181), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [190774] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4627), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8631), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(2677), 1,
      sym__class_declaration,
    STATE(2680), 1,
      sym__class_declaration_item,
    STATE(3112), 1,
      sym_field_declaration_list,
    STATE(5429), 1,
      sym_ms_declspec_modifier,
    STATE(6346), 1,
      sym__scope_resolution,
    STATE(6695), 1,
      sym_virtual_specifier,
    STATE(7449), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2950), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5419), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5181), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [190853] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(6782), 1,
      sym_identifier,
    ACTIONS(6784), 1,
      anon_sym_STAR,
    ACTIONS(6786), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6788), 1,
      anon_sym_AMP,
    ACTIONS(6790), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    STATE(5612), 1,
      sym__scope_resolution,
    STATE(6215), 1,
      sym__declarator,
    STATE(7612), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [190920] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(2845), 1,
      anon_sym_STAR,
    ACTIONS(2847), 1,
      anon_sym_AMP,
    ACTIONS(4841), 1,
      sym_identifier,
    ACTIONS(5825), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    STATE(5610), 1,
      sym__scope_resolution,
    STATE(6400), 1,
      sym__declarator,
    STATE(8318), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [190987] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8637), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(2668), 1,
      sym__class_declaration,
    STATE(2680), 1,
      sym__class_declaration_item,
    STATE(3112), 1,
      sym_field_declaration_list,
    STATE(5450), 1,
      sym_ms_declspec_modifier,
    STATE(6380), 1,
      sym__scope_resolution,
    STATE(6695), 1,
      sym_virtual_specifier,
    STATE(7449), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2596), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5449), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5188), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [191066] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8637), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(2669), 1,
      sym__class_declaration,
    STATE(2680), 1,
      sym__class_declaration_item,
    STATE(3112), 1,
      sym_field_declaration_list,
    STATE(5450), 1,
      sym_ms_declspec_modifier,
    STATE(6380), 1,
      sym__scope_resolution,
    STATE(6695), 1,
      sym_virtual_specifier,
    STATE(7449), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2596), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5449), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5188), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [191145] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8637), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(2677), 1,
      sym__class_declaration,
    STATE(2680), 1,
      sym__class_declaration_item,
    STATE(3112), 1,
      sym_field_declaration_list,
    STATE(5450), 1,
      sym_ms_declspec_modifier,
    STATE(6380), 1,
      sym__scope_resolution,
    STATE(6695), 1,
      sym_virtual_specifier,
    STATE(7449), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2596), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5449), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5188), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [191224] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(5575), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8340), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8639), 1,
      sym_identifier,
    STATE(1901), 1,
      sym_template_type,
    STATE(1949), 1,
      sym__class_declaration_item,
    STATE(1955), 1,
      sym__class_declaration,
    STATE(2584), 1,
      sym_field_declaration_list,
    STATE(5454), 1,
      sym_ms_declspec_modifier,
    STATE(6337), 1,
      sym__scope_resolution,
    STATE(6813), 1,
      sym_virtual_specifier,
    STATE(7307), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2357), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5448), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5183), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [191303] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(5511), 1,
      sym_identifier,
    ACTIONS(5521), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    ACTIONS(6798), 1,
      anon_sym_STAR,
    ACTIONS(6800), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6802), 1,
      anon_sym_AMP,
    STATE(5695), 1,
      sym__scope_resolution,
    STATE(6032), 1,
      sym__declarator,
    STATE(7894), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [191370] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(7255), 1,
      anon_sym_DASH_GT,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8554), 1,
      anon_sym_requires,
    STATE(5945), 1,
      sym__function_attributes_end,
    STATE(6198), 1,
      sym_trailing_return_type,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8322), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5948), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5266), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8312), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [191439] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4627), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8631), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(2677), 1,
      sym__class_declaration,
    STATE(2680), 1,
      sym__class_declaration_item,
    STATE(3112), 1,
      sym_field_declaration_list,
    STATE(5429), 1,
      sym_ms_declspec_modifier,
    STATE(6346), 1,
      sym__scope_resolution,
    STATE(6695), 1,
      sym_virtual_specifier,
    STATE(7449), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2897), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5419), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5181), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [191518] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4627), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8631), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(2669), 1,
      sym__class_declaration,
    STATE(2680), 1,
      sym__class_declaration_item,
    STATE(3112), 1,
      sym_field_declaration_list,
    STATE(5429), 1,
      sym_ms_declspec_modifier,
    STATE(6346), 1,
      sym__scope_resolution,
    STATE(6695), 1,
      sym_virtual_specifier,
    STATE(7449), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2897), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5419), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5181), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [191597] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(5575), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8340), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8639), 1,
      sym_identifier,
    STATE(1901), 1,
      sym_template_type,
    STATE(1949), 1,
      sym__class_declaration_item,
    STATE(1953), 1,
      sym__class_declaration,
    STATE(2584), 1,
      sym_field_declaration_list,
    STATE(5454), 1,
      sym_ms_declspec_modifier,
    STATE(6337), 1,
      sym__scope_resolution,
    STATE(6813), 1,
      sym_virtual_specifier,
    STATE(7307), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2357), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5448), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5183), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [191676] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(6782), 1,
      sym_identifier,
    ACTIONS(6784), 1,
      anon_sym_STAR,
    ACTIONS(6786), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6788), 1,
      anon_sym_AMP,
    ACTIONS(6790), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    STATE(5612), 1,
      sym__scope_resolution,
    STATE(6258), 1,
      sym__declarator,
    STATE(7612), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [191743] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(7255), 1,
      anon_sym_DASH_GT,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    ACTIONS(8641), 1,
      anon_sym_requires,
    STATE(5946), 1,
      sym__function_attributes_end,
    STATE(6178), 1,
      sym_trailing_return_type,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8512), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5911), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5264), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(8508), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [191812] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8157), 1,
      anon_sym_LBRACE,
    ACTIONS(8644), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(4797), 1,
      sym_field_declaration_list,
    STATE(4881), 1,
      sym__class_declaration_item,
    STATE(4888), 1,
      sym__class_declaration,
    STATE(5467), 1,
      sym_ms_declspec_modifier,
    STATE(6336), 1,
      sym__scope_resolution,
    STATE(6735), 1,
      sym_virtual_specifier,
    STATE(7438), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4531), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5470), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5190), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [191891] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8157), 1,
      anon_sym_LBRACE,
    ACTIONS(8644), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(4797), 1,
      sym_field_declaration_list,
    STATE(4881), 1,
      sym__class_declaration_item,
    STATE(4885), 1,
      sym__class_declaration,
    STATE(5467), 1,
      sym_ms_declspec_modifier,
    STATE(6336), 1,
      sym__scope_resolution,
    STATE(6735), 1,
      sym_virtual_specifier,
    STATE(7438), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4531), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5470), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5190), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [191970] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8157), 1,
      anon_sym_LBRACE,
    ACTIONS(8644), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(4797), 1,
      sym_field_declaration_list,
    STATE(4879), 1,
      sym__class_declaration,
    STATE(4881), 1,
      sym__class_declaration_item,
    STATE(5467), 1,
      sym_ms_declspec_modifier,
    STATE(6336), 1,
      sym__scope_resolution,
    STATE(6735), 1,
      sym_virtual_specifier,
    STATE(7438), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4531), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5470), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5190), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [192049] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4627), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8631), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(2668), 1,
      sym__class_declaration,
    STATE(2680), 1,
      sym__class_declaration_item,
    STATE(3112), 1,
      sym_field_declaration_list,
    STATE(5429), 1,
      sym_ms_declspec_modifier,
    STATE(6346), 1,
      sym__scope_resolution,
    STATE(6695), 1,
      sym_virtual_specifier,
    STATE(7449), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2897), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5419), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5181), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [192128] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8644), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(2668), 1,
      sym__class_declaration,
    STATE(2680), 1,
      sym__class_declaration_item,
    STATE(3924), 1,
      sym_field_declaration_list,
    STATE(5459), 1,
      sym_ms_declspec_modifier,
    STATE(6336), 1,
      sym__scope_resolution,
    STATE(6755), 1,
      sym_virtual_specifier,
    STATE(7484), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3438), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5464), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5197), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [192207] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8644), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(2669), 1,
      sym__class_declaration,
    STATE(2680), 1,
      sym__class_declaration_item,
    STATE(3924), 1,
      sym_field_declaration_list,
    STATE(5459), 1,
      sym_ms_declspec_modifier,
    STATE(6336), 1,
      sym__scope_resolution,
    STATE(6755), 1,
      sym_virtual_specifier,
    STATE(7484), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3438), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5464), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5197), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [192286] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(5511), 1,
      sym_identifier,
    ACTIONS(5521), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    ACTIONS(6880), 1,
      anon_sym_STAR,
    ACTIONS(6882), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6884), 1,
      anon_sym_AMP,
    STATE(5695), 1,
      sym__scope_resolution,
    STATE(6149), 1,
      sym__declarator,
    STATE(7771), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [192353] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8644), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(2677), 1,
      sym__class_declaration,
    STATE(2680), 1,
      sym__class_declaration_item,
    STATE(3924), 1,
      sym_field_declaration_list,
    STATE(5459), 1,
      sym_ms_declspec_modifier,
    STATE(6336), 1,
      sym__scope_resolution,
    STATE(6755), 1,
      sym_virtual_specifier,
    STATE(7484), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3438), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5464), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5197), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [192432] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4627), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8631), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(2668), 1,
      sym__class_declaration,
    STATE(2680), 1,
      sym__class_declaration_item,
    STATE(3112), 1,
      sym_field_declaration_list,
    STATE(5429), 1,
      sym_ms_declspec_modifier,
    STATE(6346), 1,
      sym__scope_resolution,
    STATE(6695), 1,
      sym_virtual_specifier,
    STATE(7449), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2958), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5419), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5181), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [192511] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4627), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8631), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(2669), 1,
      sym__class_declaration,
    STATE(2680), 1,
      sym__class_declaration_item,
    STATE(3112), 1,
      sym_field_declaration_list,
    STATE(5429), 1,
      sym_ms_declspec_modifier,
    STATE(6346), 1,
      sym__scope_resolution,
    STATE(6695), 1,
      sym_virtual_specifier,
    STATE(7449), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2958), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5419), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5181), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [192590] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4627), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8631), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(2677), 1,
      sym__class_declaration,
    STATE(2680), 1,
      sym__class_declaration_item,
    STATE(3112), 1,
      sym_field_declaration_list,
    STATE(5429), 1,
      sym_ms_declspec_modifier,
    STATE(6346), 1,
      sym__scope_resolution,
    STATE(6695), 1,
      sym_virtual_specifier,
    STATE(7449), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2958), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5419), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5181), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [192669] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(5575), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8340), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8639), 1,
      sym_identifier,
    STATE(1901), 1,
      sym_template_type,
    STATE(1942), 1,
      sym__class_declaration,
    STATE(1949), 1,
      sym__class_declaration_item,
    STATE(2584), 1,
      sym_field_declaration_list,
    STATE(5454), 1,
      sym_ms_declspec_modifier,
    STATE(6337), 1,
      sym__scope_resolution,
    STATE(6813), 1,
      sym_virtual_specifier,
    STATE(7307), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2357), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5448), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5183), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [192748] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(6905), 1,
      anon_sym_LBRACE,
    ACTIONS(8354), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8646), 1,
      sym_identifier,
    STATE(3780), 1,
      sym_template_type,
    STATE(3960), 1,
      sym_field_declaration_list,
    STATE(4099), 1,
      sym__class_declaration_item,
    STATE(4102), 1,
      sym__class_declaration,
    STATE(5484), 1,
      sym_ms_declspec_modifier,
    STATE(6377), 1,
      sym__scope_resolution,
    STATE(6754), 1,
      sym_virtual_specifier,
    STATE(7421), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3316), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5414), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5184), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [192827] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(6782), 1,
      sym_identifier,
    ACTIONS(6784), 1,
      anon_sym_STAR,
    ACTIONS(6786), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6788), 1,
      anon_sym_AMP,
    ACTIONS(6790), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    STATE(5612), 1,
      sym__scope_resolution,
    STATE(6235), 1,
      sym__declarator,
    STATE(7612), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [192894] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7351), 1,
      sym_identifier,
    ACTIONS(7353), 1,
      anon_sym_LPAREN2,
    ACTIONS(7371), 1,
      anon_sym_STAR,
    ACTIONS(7373), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    STATE(2372), 1,
      sym_pointer_type_declarator,
    STATE(5320), 1,
      sym_ms_call_modifier,
    STATE(6463), 1,
      sym__type_declarator,
    STATE(7781), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(49), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(2340), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
  [192955] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(6905), 1,
      anon_sym_LBRACE,
    ACTIONS(8354), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8646), 1,
      sym_identifier,
    STATE(3780), 1,
      sym_template_type,
    STATE(3960), 1,
      sym_field_declaration_list,
    STATE(4099), 1,
      sym__class_declaration_item,
    STATE(4104), 1,
      sym__class_declaration,
    STATE(5484), 1,
      sym_ms_declspec_modifier,
    STATE(6377), 1,
      sym__scope_resolution,
    STATE(6754), 1,
      sym_virtual_specifier,
    STATE(7421), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3316), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5414), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5184), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [193034] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(6905), 1,
      anon_sym_LBRACE,
    ACTIONS(8354), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8646), 1,
      sym_identifier,
    STATE(3780), 1,
      sym_template_type,
    STATE(3960), 1,
      sym_field_declaration_list,
    STATE(4095), 1,
      sym__class_declaration,
    STATE(4099), 1,
      sym__class_declaration_item,
    STATE(5484), 1,
      sym_ms_declspec_modifier,
    STATE(6377), 1,
      sym__scope_resolution,
    STATE(6754), 1,
      sym_virtual_specifier,
    STATE(7421), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3316), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5414), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5184), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [193113] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(6782), 1,
      sym_identifier,
    ACTIONS(6784), 1,
      anon_sym_STAR,
    ACTIONS(6786), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6788), 1,
      anon_sym_AMP,
    ACTIONS(6790), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    STATE(5612), 1,
      sym__scope_resolution,
    STATE(6217), 1,
      sym__declarator,
    STATE(7612), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [193180] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7170), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8332), 1,
      anon_sym_LBRACE,
    ACTIONS(8648), 1,
      sym_identifier,
    STATE(4697), 1,
      sym_template_type,
    STATE(4914), 1,
      sym_field_declaration_list,
    STATE(5018), 1,
      sym__class_declaration,
    STATE(5020), 1,
      sym__class_declaration_item,
    STATE(5477), 1,
      sym_ms_declspec_modifier,
    STATE(6342), 1,
      sym__scope_resolution,
    STATE(6797), 1,
      sym_virtual_specifier,
    STATE(7487), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4727), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5478), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5179), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [193259] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(2845), 1,
      anon_sym_STAR,
    ACTIONS(2847), 1,
      anon_sym_AMP,
    ACTIONS(4841), 1,
      sym_identifier,
    ACTIONS(5825), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    STATE(5610), 1,
      sym__scope_resolution,
    STATE(6432), 1,
      sym__declarator,
    STATE(8318), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [193326] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7170), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8332), 1,
      anon_sym_LBRACE,
    ACTIONS(8648), 1,
      sym_identifier,
    STATE(4697), 1,
      sym_template_type,
    STATE(4914), 1,
      sym_field_declaration_list,
    STATE(5019), 1,
      sym__class_declaration,
    STATE(5020), 1,
      sym__class_declaration_item,
    STATE(5477), 1,
      sym_ms_declspec_modifier,
    STATE(6342), 1,
      sym__scope_resolution,
    STATE(6797), 1,
      sym_virtual_specifier,
    STATE(7487), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4727), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5478), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5179), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [193405] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(2845), 1,
      anon_sym_STAR,
    ACTIONS(2847), 1,
      anon_sym_AMP,
    ACTIONS(4841), 1,
      sym_identifier,
    ACTIONS(5825), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    STATE(5610), 1,
      sym__scope_resolution,
    STATE(6433), 1,
      sym__declarator,
    STATE(8318), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [193472] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7170), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8332), 1,
      anon_sym_LBRACE,
    ACTIONS(8648), 1,
      sym_identifier,
    STATE(4697), 1,
      sym_template_type,
    STATE(4914), 1,
      sym_field_declaration_list,
    STATE(5020), 1,
      sym__class_declaration_item,
    STATE(5021), 1,
      sym__class_declaration,
    STATE(5477), 1,
      sym_ms_declspec_modifier,
    STATE(6342), 1,
      sym__scope_resolution,
    STATE(6797), 1,
      sym_virtual_specifier,
    STATE(7487), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4727), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5478), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5179), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [193551] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7148), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8627), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(2668), 1,
      sym__class_declaration,
    STATE(2680), 1,
      sym__class_declaration_item,
    STATE(3924), 1,
      sym_field_declaration_list,
    STATE(5417), 1,
      sym_ms_declspec_modifier,
    STATE(6355), 1,
      sym__scope_resolution,
    STATE(6755), 1,
      sym_virtual_specifier,
    STATE(7484), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3438), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5471), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5176), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [193630] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7148), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8627), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(2669), 1,
      sym__class_declaration,
    STATE(2680), 1,
      sym__class_declaration_item,
    STATE(3924), 1,
      sym_field_declaration_list,
    STATE(5417), 1,
      sym_ms_declspec_modifier,
    STATE(6355), 1,
      sym__scope_resolution,
    STATE(6755), 1,
      sym_virtual_specifier,
    STATE(7484), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3438), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5471), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5176), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [193709] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7148), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8627), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(2677), 1,
      sym__class_declaration,
    STATE(2680), 1,
      sym__class_declaration_item,
    STATE(3924), 1,
      sym_field_declaration_list,
    STATE(5417), 1,
      sym_ms_declspec_modifier,
    STATE(6355), 1,
      sym__scope_resolution,
    STATE(6755), 1,
      sym_virtual_specifier,
    STATE(7484), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3438), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5471), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5176), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [193788] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(5968), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8466), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8650), 1,
      sym_identifier,
    STATE(2743), 1,
      sym_template_type,
    STATE(2920), 1,
      sym_field_declaration_list,
    STATE(3100), 1,
      sym__class_declaration,
    STATE(3109), 1,
      sym__class_declaration_item,
    STATE(5418), 1,
      sym_ms_declspec_modifier,
    STATE(6368), 1,
      sym__scope_resolution,
    STATE(6855), 1,
      sym_virtual_specifier,
    STATE(7569), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2561), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5420), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5178), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [193867] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(5511), 1,
      sym_identifier,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    ACTIONS(6843), 1,
      anon_sym_STAR,
    ACTIONS(6845), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6847), 1,
      anon_sym_AMP,
    ACTIONS(6849), 1,
      anon_sym_COLON_COLON,
    STATE(5585), 1,
      sym__scope_resolution,
    STATE(6036), 1,
      sym__declarator,
    STATE(7697), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [193934] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(5968), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8466), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8650), 1,
      sym_identifier,
    STATE(2743), 1,
      sym_template_type,
    STATE(2920), 1,
      sym_field_declaration_list,
    STATE(3103), 1,
      sym__class_declaration,
    STATE(3109), 1,
      sym__class_declaration_item,
    STATE(5418), 1,
      sym_ms_declspec_modifier,
    STATE(6368), 1,
      sym__scope_resolution,
    STATE(6855), 1,
      sym_virtual_specifier,
    STATE(7569), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2561), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5420), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5178), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [194013] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(6782), 1,
      sym_identifier,
    ACTIONS(6784), 1,
      anon_sym_STAR,
    ACTIONS(6786), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6788), 1,
      anon_sym_AMP,
    ACTIONS(6790), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    STATE(5612), 1,
      sym__scope_resolution,
    STATE(6220), 1,
      sym__declarator,
    STATE(7612), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [194080] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(4908), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8446), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8652), 1,
      sym_identifier,
    STATE(2051), 1,
      sym_template_type,
    STATE(2304), 1,
      sym_field_declaration_list,
    STATE(2321), 1,
      sym__class_declaration_item,
    STATE(2373), 1,
      sym__class_declaration,
    STATE(5469), 1,
      sym_ms_declspec_modifier,
    STATE(6383), 1,
      sym__scope_resolution,
    STATE(6713), 1,
      sym_virtual_specifier,
    STATE(7381), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(1855), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5472), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5194), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [194159] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(5968), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8466), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8650), 1,
      sym_identifier,
    STATE(2743), 1,
      sym_template_type,
    STATE(2920), 1,
      sym_field_declaration_list,
    STATE(3109), 1,
      sym__class_declaration_item,
    STATE(3115), 1,
      sym__class_declaration,
    STATE(5418), 1,
      sym_ms_declspec_modifier,
    STATE(6368), 1,
      sym__scope_resolution,
    STATE(6855), 1,
      sym_virtual_specifier,
    STATE(7569), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2561), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5420), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5178), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [194238] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(4908), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8446), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8652), 1,
      sym_identifier,
    STATE(2051), 1,
      sym_template_type,
    STATE(2304), 1,
      sym_field_declaration_list,
    STATE(2321), 1,
      sym__class_declaration_item,
    STATE(2323), 1,
      sym__class_declaration,
    STATE(5469), 1,
      sym_ms_declspec_modifier,
    STATE(6383), 1,
      sym__scope_resolution,
    STATE(6713), 1,
      sym_virtual_specifier,
    STATE(7381), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(1855), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5472), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5194), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [194317] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(4908), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8446), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8652), 1,
      sym_identifier,
    STATE(2051), 1,
      sym_template_type,
    STATE(2304), 1,
      sym_field_declaration_list,
    STATE(2321), 1,
      sym__class_declaration_item,
    STATE(2324), 1,
      sym__class_declaration,
    STATE(5469), 1,
      sym_ms_declspec_modifier,
    STATE(6383), 1,
      sym__scope_resolution,
    STATE(6713), 1,
      sym_virtual_specifier,
    STATE(7381), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(1855), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5472), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5194), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [194396] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7148), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8157), 1,
      anon_sym_LBRACE,
    ACTIONS(8627), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(4797), 1,
      sym_field_declaration_list,
    STATE(4881), 1,
      sym__class_declaration_item,
    STATE(4888), 1,
      sym__class_declaration,
    STATE(5427), 1,
      sym_ms_declspec_modifier,
    STATE(6355), 1,
      sym__scope_resolution,
    STATE(6735), 1,
      sym_virtual_specifier,
    STATE(7438), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4531), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5437), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5175), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [194475] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7148), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8157), 1,
      anon_sym_LBRACE,
    ACTIONS(8627), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(4797), 1,
      sym_field_declaration_list,
    STATE(4879), 1,
      sym__class_declaration,
    STATE(4881), 1,
      sym__class_declaration_item,
    STATE(5427), 1,
      sym_ms_declspec_modifier,
    STATE(6355), 1,
      sym__scope_resolution,
    STATE(6735), 1,
      sym_virtual_specifier,
    STATE(7438), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4531), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5437), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5175), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [194554] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(6138), 1,
      anon_sym_LBRACE,
    ACTIONS(8376), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8654), 1,
      sym_identifier,
    STATE(2857), 1,
      sym_template_type,
    STATE(3067), 1,
      sym_field_declaration_list,
    STATE(3387), 1,
      sym__class_declaration_item,
    STATE(3389), 1,
      sym__class_declaration,
    STATE(5463), 1,
      sym_ms_declspec_modifier,
    STATE(6349), 1,
      sym__scope_resolution,
    STATE(6825), 1,
      sym_virtual_specifier,
    STATE(7392), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2659), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5462), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5185), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [194633] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(6138), 1,
      anon_sym_LBRACE,
    ACTIONS(8376), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8654), 1,
      sym_identifier,
    STATE(2857), 1,
      sym_template_type,
    STATE(3067), 1,
      sym_field_declaration_list,
    STATE(3387), 1,
      sym__class_declaration_item,
    STATE(3388), 1,
      sym__class_declaration,
    STATE(5463), 1,
      sym_ms_declspec_modifier,
    STATE(6349), 1,
      sym__scope_resolution,
    STATE(6825), 1,
      sym_virtual_specifier,
    STATE(7392), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2659), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5462), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5185), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [194712] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(6138), 1,
      anon_sym_LBRACE,
    ACTIONS(8376), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8654), 1,
      sym_identifier,
    STATE(2857), 1,
      sym_template_type,
    STATE(3067), 1,
      sym_field_declaration_list,
    STATE(3386), 1,
      sym__class_declaration,
    STATE(3387), 1,
      sym__class_declaration_item,
    STATE(5463), 1,
      sym_ms_declspec_modifier,
    STATE(6349), 1,
      sym__scope_resolution,
    STATE(6825), 1,
      sym_virtual_specifier,
    STATE(7392), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2659), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5462), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5185), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [194791] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(2845), 1,
      anon_sym_STAR,
    ACTIONS(2847), 1,
      anon_sym_AMP,
    ACTIONS(4841), 1,
      sym_identifier,
    ACTIONS(5825), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    STATE(5610), 1,
      sym__scope_resolution,
    STATE(6397), 1,
      sym__declarator,
    STATE(8318), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [194858] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(5928), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8396), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8656), 1,
      sym_identifier,
    STATE(2739), 1,
      sym_template_type,
    STATE(2769), 1,
      sym_field_declaration_list,
    STATE(2964), 1,
      sym__class_declaration,
    STATE(2971), 1,
      sym__class_declaration_item,
    STATE(5496), 1,
      sym_ms_declspec_modifier,
    STATE(6376), 1,
      sym__scope_resolution,
    STATE(6624), 1,
      sym_virtual_specifier,
    STATE(7527), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2546), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5497), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5191), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [194937] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4949), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4926), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(8658), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4924), 21,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [194978] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(6782), 1,
      sym_identifier,
    ACTIONS(6784), 1,
      anon_sym_STAR,
    ACTIONS(6786), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6788), 1,
      anon_sym_AMP,
    ACTIONS(6790), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    STATE(5612), 1,
      sym__scope_resolution,
    STATE(6282), 1,
      sym__declarator,
    STATE(7612), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [195045] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(5928), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8396), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8656), 1,
      sym_identifier,
    STATE(2739), 1,
      sym_template_type,
    STATE(2769), 1,
      sym_field_declaration_list,
    STATE(2965), 1,
      sym__class_declaration,
    STATE(2971), 1,
      sym__class_declaration_item,
    STATE(5496), 1,
      sym_ms_declspec_modifier,
    STATE(6376), 1,
      sym__scope_resolution,
    STATE(6624), 1,
      sym_virtual_specifier,
    STATE(7527), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2546), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5497), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5191), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [195124] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7351), 1,
      sym_identifier,
    ACTIONS(7353), 1,
      anon_sym_LPAREN2,
    ACTIONS(7371), 1,
      anon_sym_STAR,
    ACTIONS(7373), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    STATE(2372), 1,
      sym_pointer_type_declarator,
    STATE(5354), 1,
      sym_ms_call_modifier,
    STATE(6442), 1,
      sym__type_declarator,
    STATE(7781), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(49), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(2340), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
  [195185] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8631), 1,
      sym_identifier,
    ACTIONS(8661), 1,
      anon_sym_COLON_COLON,
    STATE(2421), 1,
      sym_template_type,
    STATE(2677), 1,
      sym__class_declaration,
    STATE(2680), 1,
      sym__class_declaration_item,
    STATE(3112), 1,
      sym_field_declaration_list,
    STATE(5460), 1,
      sym_ms_declspec_modifier,
    STATE(6356), 1,
      sym__scope_resolution,
    STATE(6695), 1,
      sym_virtual_specifier,
    STATE(7449), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4002), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5507), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5199), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [195264] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8631), 1,
      sym_identifier,
    ACTIONS(8661), 1,
      anon_sym_COLON_COLON,
    STATE(2421), 1,
      sym_template_type,
    STATE(2669), 1,
      sym__class_declaration,
    STATE(2680), 1,
      sym__class_declaration_item,
    STATE(3112), 1,
      sym_field_declaration_list,
    STATE(5460), 1,
      sym_ms_declspec_modifier,
    STATE(6356), 1,
      sym__scope_resolution,
    STATE(6695), 1,
      sym_virtual_specifier,
    STATE(7449), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4002), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5507), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5199), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [195343] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8631), 1,
      sym_identifier,
    ACTIONS(8661), 1,
      anon_sym_COLON_COLON,
    STATE(2421), 1,
      sym_template_type,
    STATE(2668), 1,
      sym__class_declaration,
    STATE(2680), 1,
      sym__class_declaration_item,
    STATE(3112), 1,
      sym_field_declaration_list,
    STATE(5460), 1,
      sym_ms_declspec_modifier,
    STATE(6356), 1,
      sym__scope_resolution,
    STATE(6695), 1,
      sym_virtual_specifier,
    STATE(7449), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4002), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5507), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5199), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [195422] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(4841), 1,
      sym_identifier,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    ACTIONS(6886), 1,
      anon_sym_STAR,
    ACTIONS(6888), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6890), 1,
      anon_sym_AMP,
    ACTIONS(6892), 1,
      anon_sym_COLON_COLON,
    STATE(5603), 1,
      sym__scope_resolution,
    STATE(6407), 1,
      sym__declarator,
    STATE(7821), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [195489] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(5928), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8396), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8656), 1,
      sym_identifier,
    STATE(2739), 1,
      sym_template_type,
    STATE(2769), 1,
      sym_field_declaration_list,
    STATE(2968), 1,
      sym__class_declaration,
    STATE(2971), 1,
      sym__class_declaration_item,
    STATE(5496), 1,
      sym_ms_declspec_modifier,
    STATE(6376), 1,
      sym__scope_resolution,
    STATE(6624), 1,
      sym_virtual_specifier,
    STATE(7527), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2546), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5497), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5191), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [195568] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(5511), 1,
      sym_identifier,
    ACTIONS(5521), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    ACTIONS(6880), 1,
      anon_sym_STAR,
    ACTIONS(6882), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6884), 1,
      anon_sym_AMP,
    STATE(5695), 1,
      sym__scope_resolution,
    STATE(6314), 1,
      sym__declarator,
    STATE(7771), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [195635] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2841), 1,
      anon_sym_LPAREN2,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(6782), 1,
      sym_identifier,
    ACTIONS(6784), 1,
      anon_sym_STAR,
    ACTIONS(6786), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6788), 1,
      anon_sym_AMP,
    ACTIONS(6790), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    STATE(5612), 1,
      sym__scope_resolution,
    STATE(6276), 1,
      sym__declarator,
    STATE(7612), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6098), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [195702] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4627), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8631), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(2677), 1,
      sym__class_declaration,
    STATE(2680), 1,
      sym__class_declaration_item,
    STATE(3112), 1,
      sym_field_declaration_list,
    STATE(5429), 1,
      sym_ms_declspec_modifier,
    STATE(6346), 1,
      sym__scope_resolution,
    STATE(6695), 1,
      sym_virtual_specifier,
    STATE(7449), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2886), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5419), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5181), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [195781] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4627), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8631), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(2668), 1,
      sym__class_declaration,
    STATE(2680), 1,
      sym__class_declaration_item,
    STATE(3112), 1,
      sym_field_declaration_list,
    STATE(5429), 1,
      sym_ms_declspec_modifier,
    STATE(6346), 1,
      sym__scope_resolution,
    STATE(6695), 1,
      sym_virtual_specifier,
    STATE(7449), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2912), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5419), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5181), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [195860] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(5928), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7235), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8663), 1,
      sym_identifier,
    STATE(2739), 1,
      sym_template_type,
    STATE(2769), 1,
      sym_field_declaration_list,
    STATE(2968), 1,
      sym__class_declaration,
    STATE(2971), 1,
      sym__class_declaration_item,
    STATE(5440), 1,
      sym_ms_declspec_modifier,
    STATE(6339), 1,
      sym__scope_resolution,
    STATE(6624), 1,
      sym_virtual_specifier,
    STATE(7527), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2546), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5441), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5180), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [195939] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(5928), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7235), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8663), 1,
      sym_identifier,
    STATE(2739), 1,
      sym_template_type,
    STATE(2769), 1,
      sym_field_declaration_list,
    STATE(2965), 1,
      sym__class_declaration,
    STATE(2971), 1,
      sym__class_declaration_item,
    STATE(5440), 1,
      sym_ms_declspec_modifier,
    STATE(6339), 1,
      sym__scope_resolution,
    STATE(6624), 1,
      sym_virtual_specifier,
    STATE(7527), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2546), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5441), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5180), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [196018] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(5928), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7235), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8663), 1,
      sym_identifier,
    STATE(2739), 1,
      sym_template_type,
    STATE(2769), 1,
      sym_field_declaration_list,
    STATE(2964), 1,
      sym__class_declaration,
    STATE(2971), 1,
      sym__class_declaration_item,
    STATE(5440), 1,
      sym_ms_declspec_modifier,
    STATE(6339), 1,
      sym__scope_resolution,
    STATE(6624), 1,
      sym_virtual_specifier,
    STATE(7527), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2546), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5441), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5180), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [196097] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7351), 1,
      sym_identifier,
    ACTIONS(7353), 1,
      anon_sym_LPAREN2,
    ACTIONS(7371), 1,
      anon_sym_STAR,
    ACTIONS(7373), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    STATE(2372), 1,
      sym_pointer_type_declarator,
    STATE(5371), 1,
      sym_ms_call_modifier,
    STATE(6434), 1,
      sym__type_declarator,
    STATE(7781), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(49), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(2340), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
  [196158] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(5575), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7128), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8629), 1,
      sym_identifier,
    STATE(1901), 1,
      sym_template_type,
    STATE(1949), 1,
      sym__class_declaration_item,
    STATE(1953), 1,
      sym__class_declaration,
    STATE(4991), 1,
      sym_field_declaration_list,
    STATE(5434), 1,
      sym_ms_declspec_modifier,
    STATE(6365), 1,
      sym__scope_resolution,
    STATE(6725), 1,
      sym_virtual_specifier,
    STATE(7378), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4629), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5435), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5182), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [196237] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(5575), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7128), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8629), 1,
      sym_identifier,
    STATE(1901), 1,
      sym_template_type,
    STATE(1949), 1,
      sym__class_declaration_item,
    STATE(1955), 1,
      sym__class_declaration,
    STATE(4991), 1,
      sym_field_declaration_list,
    STATE(5434), 1,
      sym_ms_declspec_modifier,
    STATE(6365), 1,
      sym__scope_resolution,
    STATE(6725), 1,
      sym_virtual_specifier,
    STATE(7378), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4629), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5435), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5182), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [196316] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4627), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8631), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(2668), 1,
      sym__class_declaration,
    STATE(2680), 1,
      sym__class_declaration_item,
    STATE(3112), 1,
      sym_field_declaration_list,
    STATE(5429), 1,
      sym_ms_declspec_modifier,
    STATE(6346), 1,
      sym__scope_resolution,
    STATE(6695), 1,
      sym_virtual_specifier,
    STATE(7449), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2886), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5419), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5181), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [196395] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4627), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8631), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(2677), 1,
      sym__class_declaration,
    STATE(2680), 1,
      sym__class_declaration_item,
    STATE(3112), 1,
      sym_field_declaration_list,
    STATE(5429), 1,
      sym_ms_declspec_modifier,
    STATE(6346), 1,
      sym__scope_resolution,
    STATE(6695), 1,
      sym_virtual_specifier,
    STATE(7449), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2878), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5419), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5181), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [196474] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4627), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8631), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(2668), 1,
      sym__class_declaration,
    STATE(2680), 1,
      sym__class_declaration_item,
    STATE(3112), 1,
      sym_field_declaration_list,
    STATE(5429), 1,
      sym_ms_declspec_modifier,
    STATE(6346), 1,
      sym__scope_resolution,
    STATE(6695), 1,
      sym_virtual_specifier,
    STATE(7449), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2878), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5419), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5181), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [196553] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4627), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8631), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(2669), 1,
      sym__class_declaration,
    STATE(2680), 1,
      sym__class_declaration_item,
    STATE(3112), 1,
      sym_field_declaration_list,
    STATE(5429), 1,
      sym_ms_declspec_modifier,
    STATE(6346), 1,
      sym__scope_resolution,
    STATE(6695), 1,
      sym_virtual_specifier,
    STATE(7449), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2878), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5419), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5181), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [196632] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4627), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8631), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(2669), 1,
      sym__class_declaration,
    STATE(2680), 1,
      sym__class_declaration_item,
    STATE(3112), 1,
      sym_field_declaration_list,
    STATE(5429), 1,
      sym_ms_declspec_modifier,
    STATE(6346), 1,
      sym__scope_resolution,
    STATE(6695), 1,
      sym_virtual_specifier,
    STATE(7449), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2886), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5419), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5181), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [196711] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(6923), 1,
      anon_sym_DASH_GT,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8325), 1,
      anon_sym_requires,
    STATE(5697), 1,
      sym__function_attributes_end,
    STATE(5817), 1,
      sym_trailing_return_type,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8322), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5948), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8312), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [196773] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7148), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8157), 1,
      anon_sym_LBRACE,
    ACTIONS(8627), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(4797), 1,
      sym_field_declaration_list,
    STATE(4836), 1,
      sym__class_declaration_item,
    STATE(5498), 1,
      sym_ms_declspec_modifier,
    STATE(6355), 1,
      sym__scope_resolution,
    STATE(6735), 1,
      sym_virtual_specifier,
    STATE(7438), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4531), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5468), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5859), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [196849] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7148), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8627), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(2634), 1,
      sym__class_declaration_item,
    STATE(3924), 1,
      sym_field_declaration_list,
    STATE(5433), 1,
      sym_ms_declspec_modifier,
    STATE(6355), 1,
      sym__scope_resolution,
    STATE(6755), 1,
      sym_virtual_specifier,
    STATE(7484), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3438), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5431), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5859), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [196925] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(6923), 1,
      anon_sym_DASH_GT,
    ACTIONS(6941), 1,
      anon_sym_requires,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    STATE(5696), 1,
      sym__function_attributes_end,
    STATE(5811), 1,
      sym_trailing_return_type,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5948), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8312), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [196987] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(5968), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8466), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8650), 1,
      sym_identifier,
    STATE(2743), 1,
      sym_template_type,
    STATE(2920), 1,
      sym_field_declaration_list,
    STATE(3101), 1,
      sym__class_declaration_item,
    STATE(5426), 1,
      sym_ms_declspec_modifier,
    STATE(6368), 1,
      sym__scope_resolution,
    STATE(6855), 1,
      sym_virtual_specifier,
    STATE(7569), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2561), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5423), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5859), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [197063] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7170), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8332), 1,
      anon_sym_LBRACE,
    ACTIONS(8648), 1,
      sym_identifier,
    STATE(4697), 1,
      sym_template_type,
    STATE(4914), 1,
      sym_field_declaration_list,
    STATE(5001), 1,
      sym__class_declaration_item,
    STATE(5504), 1,
      sym_ms_declspec_modifier,
    STATE(6342), 1,
      sym__scope_resolution,
    STATE(6797), 1,
      sym_virtual_specifier,
    STATE(7487), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4727), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5480), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5859), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [197139] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(5928), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7235), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8663), 1,
      sym_identifier,
    STATE(2739), 1,
      sym_template_type,
    STATE(2769), 1,
      sym_field_declaration_list,
    STATE(2924), 1,
      sym__class_declaration_item,
    STATE(5452), 1,
      sym_ms_declspec_modifier,
    STATE(6339), 1,
      sym__scope_resolution,
    STATE(6624), 1,
      sym_virtual_specifier,
    STATE(7527), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2546), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5451), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5859), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [197215] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4627), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8631), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(2634), 1,
      sym__class_declaration_item,
    STATE(3112), 1,
      sym_field_declaration_list,
    STATE(5476), 1,
      sym_ms_declspec_modifier,
    STATE(6346), 1,
      sym__scope_resolution,
    STATE(6695), 1,
      sym_virtual_specifier,
    STATE(7449), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2596), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5465), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5859), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [197291] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(5575), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7128), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8629), 1,
      sym_identifier,
    STATE(1901), 1,
      sym_template_type,
    STATE(1946), 1,
      sym__class_declaration_item,
    STATE(4991), 1,
      sym_field_declaration_list,
    STATE(5489), 1,
      sym_ms_declspec_modifier,
    STATE(6365), 1,
      sym__scope_resolution,
    STATE(6725), 1,
      sym_virtual_specifier,
    STATE(7378), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4629), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5490), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5859), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [197367] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(5575), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8340), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8639), 1,
      sym_identifier,
    STATE(1901), 1,
      sym_template_type,
    STATE(1946), 1,
      sym__class_declaration_item,
    STATE(2584), 1,
      sym_field_declaration_list,
    STATE(5413), 1,
      sym_ms_declspec_modifier,
    STATE(6337), 1,
      sym__scope_resolution,
    STATE(6813), 1,
      sym_virtual_specifier,
    STATE(7307), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2357), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5445), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5859), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [197443] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(6905), 1,
      anon_sym_LBRACE,
    ACTIONS(8354), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8646), 1,
      sym_identifier,
    STATE(3780), 1,
      sym_template_type,
    STATE(3960), 1,
      sym_field_declaration_list,
    STATE(4060), 1,
      sym__class_declaration_item,
    STATE(5422), 1,
      sym_ms_declspec_modifier,
    STATE(6377), 1,
      sym__scope_resolution,
    STATE(6754), 1,
      sym_virtual_specifier,
    STATE(7421), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3316), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5421), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5859), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [197519] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(6138), 1,
      anon_sym_LBRACE,
    ACTIONS(8376), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8654), 1,
      sym_identifier,
    STATE(2857), 1,
      sym_template_type,
    STATE(3067), 1,
      sym_field_declaration_list,
    STATE(3468), 1,
      sym__class_declaration_item,
    STATE(5458), 1,
      sym_ms_declspec_modifier,
    STATE(6349), 1,
      sym__scope_resolution,
    STATE(6825), 1,
      sym_virtual_specifier,
    STATE(7392), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2659), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5412), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5859), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [197595] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(5575), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8633), 1,
      sym_identifier,
    STATE(1901), 1,
      sym_template_type,
    STATE(1946), 1,
      sym__class_declaration_item,
    STATE(2584), 1,
      sym_field_declaration_list,
    STATE(5502), 1,
      sym_ms_declspec_modifier,
    STATE(6373), 1,
      sym__scope_resolution,
    STATE(6813), 1,
      sym_virtual_specifier,
    STATE(7307), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2357), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5494), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5859), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [197671] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(6923), 1,
      anon_sym_DASH_GT,
    ACTIONS(6941), 1,
      anon_sym_requires,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    STATE(5698), 1,
      sym__function_attributes_end,
    STATE(5785), 1,
      sym_trailing_return_type,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5911), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8508), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [197733] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8637), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(2634), 1,
      sym__class_declaration_item,
    STATE(3112), 1,
      sym_field_declaration_list,
    STATE(5506), 1,
      sym_ms_declspec_modifier,
    STATE(6380), 1,
      sym__scope_resolution,
    STATE(6695), 1,
      sym_virtual_specifier,
    STATE(7449), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2596), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5488), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5859), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [197809] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(6923), 1,
      anon_sym_DASH_GT,
    ACTIONS(6941), 1,
      anon_sym_requires,
    ACTIONS(8667), 1,
      anon_sym_LBRACK,
    STATE(5701), 1,
      sym__function_attributes_end,
    STATE(5794), 1,
      sym_trailing_return_type,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6005), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8665), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [197871] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8157), 1,
      anon_sym_LBRACE,
    ACTIONS(8644), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(4797), 1,
      sym_field_declaration_list,
    STATE(4836), 1,
      sym__class_declaration_item,
    STATE(5487), 1,
      sym_ms_declspec_modifier,
    STATE(6336), 1,
      sym__scope_resolution,
    STATE(6735), 1,
      sym_virtual_specifier,
    STATE(7438), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4531), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5486), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5859), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [197947] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(5928), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8396), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8656), 1,
      sym_identifier,
    STATE(2739), 1,
      sym_template_type,
    STATE(2769), 1,
      sym_field_declaration_list,
    STATE(2924), 1,
      sym__class_declaration_item,
    STATE(5501), 1,
      sym_ms_declspec_modifier,
    STATE(6376), 1,
      sym__scope_resolution,
    STATE(6624), 1,
      sym_virtual_specifier,
    STATE(7527), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2546), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5500), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5859), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [198023] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8669), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5534), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(5532), 15,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_virtual,
      anon_sym_template,
      anon_sym_try,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_requires,
  [198063] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4628), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8674), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(8672), 10,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [198103] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(4908), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8446), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8652), 1,
      sym_identifier,
    STATE(2051), 1,
      sym_template_type,
    STATE(2304), 1,
      sym_field_declaration_list,
    STATE(2336), 1,
      sym__class_declaration_item,
    STATE(5485), 1,
      sym_ms_declspec_modifier,
    STATE(6383), 1,
      sym__scope_resolution,
    STATE(6713), 1,
      sym_virtual_specifier,
    STATE(7381), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(1855), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5492), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5859), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [198179] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4628), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8678), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(8676), 10,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
      sym_identifier,
    ACTIONS(61), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [198219] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(5811), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8410), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8635), 1,
      sym_identifier,
    STATE(2692), 1,
      sym_template_type,
    STATE(2864), 1,
      sym_field_declaration_list,
    STATE(2980), 1,
      sym__class_declaration_item,
    STATE(5411), 1,
      sym_ms_declspec_modifier,
    STATE(6348), 1,
      sym__scope_resolution,
    STATE(6711), 1,
      sym_virtual_specifier,
    STATE(7352), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2478), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5499), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5859), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [198295] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8644), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(2634), 1,
      sym__class_declaration_item,
    STATE(3924), 1,
      sym_field_declaration_list,
    STATE(5475), 1,
      sym_ms_declspec_modifier,
    STATE(6336), 1,
      sym__scope_resolution,
    STATE(6755), 1,
      sym_virtual_specifier,
    STATE(7484), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3438), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5473), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5859), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [198371] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(6923), 1,
      anon_sym_DASH_GT,
    ACTIONS(8667), 1,
      anon_sym_LBRACK,
    ACTIONS(8683), 1,
      anon_sym_requires,
    STATE(5706), 1,
      sym__function_attributes_end,
    STATE(5822), 1,
      sym_trailing_return_type,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8680), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6005), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8665), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [198433] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4847), 1,
      anon_sym___attribute__,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4853), 1,
      anon_sym___declspec,
    ACTIONS(4857), 1,
      anon_sym_alignas,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8631), 1,
      sym_identifier,
    ACTIONS(8661), 1,
      anon_sym_COLON_COLON,
    STATE(2421), 1,
      sym_template_type,
    STATE(2634), 1,
      sym__class_declaration_item,
    STATE(3112), 1,
      sym_field_declaration_list,
    STATE(5424), 1,
      sym_ms_declspec_modifier,
    STATE(6356), 1,
      sym__scope_resolution,
    STATE(6695), 1,
      sym_virtual_specifier,
    STATE(7449), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4002), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5432), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5859), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
  [198509] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(6923), 1,
      anon_sym_DASH_GT,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    ACTIONS(8515), 1,
      anon_sym_requires,
    STATE(5704), 1,
      sym__function_attributes_end,
    STATE(5820), 1,
      sym_trailing_return_type,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8512), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5911), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8508), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [198571] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7284), 3,
      anon_sym_AMP,
      sym_ms_restrict_modifier,
      anon_sym_const,
    ACTIONS(7286), 24,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [198606] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(7302), 1,
      anon_sym_DASH_GT,
    ACTIONS(7329), 1,
      anon_sym_requires,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    ACTIONS(8545), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6069), 1,
      sym__function_attributes_end,
    STATE(6225), 1,
      sym_trailing_return_type,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8508), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5778), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5321), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [198673] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6955), 1,
      anon_sym_DASH_GT,
    ACTIONS(6963), 1,
      anon_sym_requires,
    ACTIONS(8667), 1,
      anon_sym_LBRACK,
    ACTIONS(8686), 1,
      anon_sym___attribute__,
    ACTIONS(8689), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5654), 1,
      sym_trailing_return_type,
    STATE(5657), 1,
      sym__function_attributes_end,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5771), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8665), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [198734] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(7331), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7333), 1,
      anon_sym_DASH_GT,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8526), 1,
      anon_sym_requires,
    STATE(5924), 1,
      sym_trailing_return_type,
    STATE(6203), 1,
      sym__function_attributes_end,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8312), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(8322), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5948), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5357), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [198801] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(7302), 1,
      anon_sym_DASH_GT,
    ACTIONS(7329), 1,
      anon_sym_requires,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8435), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6064), 1,
      sym__function_attributes_end,
    STATE(6211), 1,
      sym_trailing_return_type,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8312), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5328), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [198868] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(7144), 1,
      anon_sym_requires,
    ACTIONS(7331), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7333), 1,
      anon_sym_DASH_GT,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    STATE(5956), 1,
      sym_trailing_return_type,
    STATE(6177), 1,
      sym__function_attributes_end,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8312), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5948), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5393), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [198935] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(7144), 1,
      anon_sym_requires,
    ACTIONS(7331), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7333), 1,
      anon_sym_DASH_GT,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    STATE(5975), 1,
      sym_trailing_return_type,
    STATE(6172), 1,
      sym__function_attributes_end,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8508), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5911), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5398), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [199002] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6955), 1,
      anon_sym_DASH_GT,
    ACTIONS(6963), 1,
      anon_sym_requires,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8432), 1,
      anon_sym___attribute__,
    ACTIONS(8435), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5625), 1,
      sym__function_attributes_end,
    STATE(5647), 1,
      sym_trailing_return_type,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8312), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [199063] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7288), 3,
      anon_sym_AMP,
      sym_ms_restrict_modifier,
      anon_sym_const,
    ACTIONS(7290), 24,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [199098] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6955), 1,
      anon_sym_DASH_GT,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    ACTIONS(8542), 1,
      anon_sym___attribute__,
    ACTIONS(8545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8551), 1,
      anon_sym_requires,
    STATE(5606), 1,
      sym__function_attributes_end,
    STATE(5669), 1,
      sym_trailing_return_type,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8548), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5778), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8508), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [199159] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(7331), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7333), 1,
      anon_sym_DASH_GT,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    ACTIONS(8622), 1,
      anon_sym_requires,
    STATE(5923), 1,
      sym_trailing_return_type,
    STATE(6192), 1,
      sym__function_attributes_end,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8508), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(8512), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5911), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5356), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [199226] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6955), 1,
      anon_sym_DASH_GT,
    ACTIONS(8667), 1,
      anon_sym_LBRACK,
    ACTIONS(8686), 1,
      anon_sym___attribute__,
    ACTIONS(8689), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8695), 1,
      anon_sym_requires,
    STATE(5620), 1,
      sym__function_attributes_end,
    STATE(5652), 1,
      sym_trailing_return_type,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8692), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5771), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8665), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [199287] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(7302), 1,
      anon_sym_DASH_GT,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8435), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8616), 1,
      anon_sym_requires,
    STATE(6079), 1,
      sym__function_attributes_end,
    STATE(6245), 1,
      sym_trailing_return_type,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8312), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(8438), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5387), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [199354] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6928), 1,
      anon_sym_noexcept,
    ACTIONS(6930), 1,
      anon_sym_throw,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(7302), 1,
      anon_sym_DASH_GT,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    ACTIONS(8545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8698), 1,
      anon_sym_requires,
    STATE(6081), 1,
      sym__function_attributes_end,
    STATE(6237), 1,
      sym_trailing_return_type,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8508), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(8548), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5778), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5386), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [199421] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6955), 1,
      anon_sym_DASH_GT,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8432), 1,
      anon_sym___attribute__,
    ACTIONS(8435), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8441), 1,
      anon_sym_requires,
    STATE(5598), 1,
      sym__function_attributes_end,
    STATE(5685), 1,
      sym_trailing_return_type,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8438), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8312), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [199482] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6955), 1,
      anon_sym_DASH_GT,
    ACTIONS(6963), 1,
      anon_sym_requires,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    ACTIONS(8542), 1,
      anon_sym___attribute__,
    ACTIONS(8545), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5600), 1,
      sym_trailing_return_type,
    STATE(5640), 1,
      sym__function_attributes_end,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5778), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8508), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [199543] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7100), 1,
      anon_sym_DASH_GT,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    ACTIONS(8559), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8565), 1,
      anon_sym_requires,
    STATE(5579), 1,
      sym_trailing_return_type,
    STATE(5621), 1,
      sym__function_attributes_end,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(8548), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8562), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5778), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8508), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [199603] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7100), 1,
      anon_sym_DASH_GT,
    ACTIONS(7107), 1,
      anon_sym_requires,
    ACTIONS(8667), 1,
      anon_sym_LBRACK,
    ACTIONS(8701), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5564), 1,
      sym_trailing_return_type,
    STATE(5619), 1,
      sym__function_attributes_end,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8704), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5771), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8665), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [199663] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7100), 1,
      anon_sym_DASH_GT,
    ACTIONS(7107), 1,
      anon_sym_requires,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8500), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5560), 1,
      sym_trailing_return_type,
    STATE(5634), 1,
      sym__function_attributes_end,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8497), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8312), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [199723] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6963), 1,
      anon_sym_requires,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(7043), 1,
      anon_sym_DASH_GT,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8435), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5647), 1,
      sym_trailing_return_type,
    STATE(5732), 1,
      sym__function_attributes_end,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8312), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [199783] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(7043), 1,
      anon_sym_DASH_GT,
    ACTIONS(8667), 1,
      anon_sym_LBRACK,
    ACTIONS(8689), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8695), 1,
      anon_sym_requires,
    STATE(5652), 1,
      sym_trailing_return_type,
    STATE(5745), 1,
      sym__function_attributes_end,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8692), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5771), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8665), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [199843] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6963), 1,
      anon_sym_requires,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(7105), 1,
      anon_sym_DASH_GT,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    ACTIONS(8545), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5570), 1,
      sym__function_attributes_end,
    STATE(5600), 1,
      sym_trailing_return_type,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8562), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5778), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8508), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [199903] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7107), 1,
      anon_sym_requires,
    ACTIONS(7117), 1,
      anon_sym_DASH_GT,
    ACTIONS(8667), 1,
      anon_sym_LBRACK,
    ACTIONS(8701), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5564), 1,
      sym_trailing_return_type,
    STATE(5728), 1,
      sym__function_attributes_end,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5771), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8665), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [199963] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7100), 1,
      anon_sym_DASH_GT,
    ACTIONS(8667), 1,
      anon_sym_LBRACK,
    ACTIONS(8701), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8707), 1,
      anon_sym_requires,
    STATE(5578), 1,
      sym_trailing_return_type,
    STATE(5663), 1,
      sym__function_attributes_end,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(8692), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8704), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5771), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8665), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [200023] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(7105), 1,
      anon_sym_DASH_GT,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8435), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8441), 1,
      anon_sym_requires,
    STATE(5588), 1,
      sym__function_attributes_end,
    STATE(5685), 1,
      sym_trailing_return_type,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(8438), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8497), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8312), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [200083] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6963), 1,
      anon_sym_requires,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(7043), 1,
      anon_sym_DASH_GT,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    ACTIONS(8545), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5600), 1,
      sym_trailing_return_type,
    STATE(5777), 1,
      sym__function_attributes_end,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5778), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8508), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [200143] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(7043), 1,
      anon_sym_DASH_GT,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    ACTIONS(8545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8551), 1,
      anon_sym_requires,
    STATE(5669), 1,
      sym_trailing_return_type,
    STATE(5713), 1,
      sym__function_attributes_end,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8548), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5778), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8508), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [200203] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4922), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4942), 1,
      anon_sym_LBRACE,
    ACTIONS(4924), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(4926), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [200241] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(7043), 1,
      anon_sym_DASH_GT,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8435), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8441), 1,
      anon_sym_requires,
    STATE(5685), 1,
      sym_trailing_return_type,
    STATE(5767), 1,
      sym__function_attributes_end,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8438), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8312), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [200301] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6963), 1,
      anon_sym_requires,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(7105), 1,
      anon_sym_DASH_GT,
    ACTIONS(8667), 1,
      anon_sym_LBRACK,
    ACTIONS(8689), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5567), 1,
      sym__function_attributes_end,
    STATE(5654), 1,
      sym_trailing_return_type,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8704), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5771), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8665), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [200361] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7117), 1,
      anon_sym_DASH_GT,
    ACTIONS(8667), 1,
      anon_sym_LBRACK,
    ACTIONS(8701), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8707), 1,
      anon_sym_requires,
    STATE(5578), 1,
      sym_trailing_return_type,
    STATE(5718), 1,
      sym__function_attributes_end,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8692), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5771), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8665), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [200421] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6963), 1,
      anon_sym_requires,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(7105), 1,
      anon_sym_DASH_GT,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8435), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5632), 1,
      sym__function_attributes_end,
    STATE(5647), 1,
      sym_trailing_return_type,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8497), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8312), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [200481] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7117), 1,
      anon_sym_DASH_GT,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    ACTIONS(8559), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8565), 1,
      anon_sym_requires,
    STATE(5579), 1,
      sym_trailing_return_type,
    STATE(5720), 1,
      sym__function_attributes_end,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8548), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5778), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8508), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [200541] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7117), 1,
      anon_sym_DASH_GT,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8500), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8503), 1,
      anon_sym_requires,
    STATE(5557), 1,
      sym_trailing_return_type,
    STATE(5721), 1,
      sym__function_attributes_end,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8438), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8312), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [200601] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7107), 1,
      anon_sym_requires,
    ACTIONS(7117), 1,
      anon_sym_DASH_GT,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8500), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5560), 1,
      sym_trailing_return_type,
    STATE(5738), 1,
      sym__function_attributes_end,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8312), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [200661] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7107), 1,
      anon_sym_requires,
    ACTIONS(7117), 1,
      anon_sym_DASH_GT,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    ACTIONS(8559), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5558), 1,
      sym_trailing_return_type,
    STATE(5734), 1,
      sym__function_attributes_end,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5778), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8508), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [200721] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6963), 1,
      anon_sym_requires,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(7043), 1,
      anon_sym_DASH_GT,
    ACTIONS(8667), 1,
      anon_sym_LBRACK,
    ACTIONS(8689), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5654), 1,
      sym_trailing_return_type,
    STATE(5717), 1,
      sym__function_attributes_end,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5771), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8665), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [200781] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(7105), 1,
      anon_sym_DASH_GT,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    ACTIONS(8545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8551), 1,
      anon_sym_requires,
    STATE(5589), 1,
      sym__function_attributes_end,
    STATE(5669), 1,
      sym_trailing_return_type,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(8548), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8562), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5778), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8508), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [200841] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7100), 1,
      anon_sym_DASH_GT,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8500), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8503), 1,
      anon_sym_requires,
    STATE(5557), 1,
      sym_trailing_return_type,
    STATE(5580), 1,
      sym__function_attributes_end,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(8438), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8497), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8312), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [200901] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(7105), 1,
      anon_sym_DASH_GT,
    ACTIONS(8667), 1,
      anon_sym_LBRACK,
    ACTIONS(8689), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8695), 1,
      anon_sym_requires,
    STATE(5595), 1,
      sym__function_attributes_end,
    STATE(5652), 1,
      sym_trailing_return_type,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(8692), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8704), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5771), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8665), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [200961] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7100), 1,
      anon_sym_DASH_GT,
    ACTIONS(7107), 1,
      anon_sym_requires,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    ACTIONS(8559), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5558), 1,
      sym_trailing_return_type,
    STATE(5665), 1,
      sym__function_attributes_end,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8562), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5778), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8508), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [201021] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7142), 1,
      anon_sym_DASH_GT,
    ACTIONS(7144), 1,
      anon_sym_requires,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    STATE(5885), 1,
      sym__function_attributes_end,
    STATE(5956), 1,
      sym_trailing_return_type,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5948), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8312), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [201080] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7226), 1,
      anon_sym_DASH_GT,
    ACTIONS(8667), 1,
      anon_sym_LBRACK,
    ACTIONS(8701), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8710), 1,
      anon_sym_requires,
    STATE(5805), 1,
      sym__function_attributes_end,
    STATE(5987), 1,
      sym_trailing_return_type,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8692), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5771), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8665), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [201139] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7142), 1,
      anon_sym_DASH_GT,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    ACTIONS(8622), 1,
      anon_sym_requires,
    STATE(5852), 1,
      sym__function_attributes_end,
    STATE(5923), 1,
      sym_trailing_return_type,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8512), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5911), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8508), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [201198] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7226), 1,
      anon_sym_DASH_GT,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8500), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8523), 1,
      anon_sym_requires,
    STATE(5816), 1,
      sym__function_attributes_end,
    STATE(5983), 1,
      sym_trailing_return_type,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8438), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8312), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [201257] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7142), 1,
      anon_sym_DASH_GT,
    ACTIONS(7144), 1,
      anon_sym_requires,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    STATE(5876), 1,
      sym__function_attributes_end,
    STATE(5975), 1,
      sym_trailing_return_type,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5911), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8508), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [201316] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7142), 1,
      anon_sym_DASH_GT,
    ACTIONS(8667), 1,
      anon_sym_LBRACK,
    ACTIONS(8713), 1,
      anon_sym_requires,
    STATE(5843), 1,
      sym__function_attributes_end,
    STATE(5964), 1,
      sym_trailing_return_type,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8680), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6005), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8665), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [201375] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7142), 1,
      anon_sym_DASH_GT,
    ACTIONS(7144), 1,
      anon_sym_requires,
    ACTIONS(8667), 1,
      anon_sym_LBRACK,
    STATE(5873), 1,
      sym__function_attributes_end,
    STATE(5979), 1,
      sym_trailing_return_type,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6005), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8665), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [201434] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2469), 1,
      anon_sym_LBRACK,
    ACTIONS(8410), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8635), 1,
      sym_identifier,
    ACTIONS(8716), 1,
      anon_sym_LPAREN2,
    ACTIONS(8718), 1,
      anon_sym_LBRACE,
    ACTIONS(8722), 1,
      anon_sym_requires,
    STATE(2692), 1,
      sym_template_type,
    STATE(3413), 1,
      sym_requirement_seq,
    STATE(5774), 1,
      sym_lambda_capture_specifier,
    STATE(6348), 1,
      sym__scope_resolution,
    STATE(7260), 1,
      sym_requires_parameter_list,
    ACTIONS(8720), 2,
      sym_true,
      sym_false,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3522), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [201495] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7142), 1,
      anon_sym_DASH_GT,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8526), 1,
      anon_sym_requires,
    STATE(5864), 1,
      sym__function_attributes_end,
    STATE(5924), 1,
      sym_trailing_return_type,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8322), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5948), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8312), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [201554] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2469), 1,
      anon_sym_LBRACK,
    ACTIONS(8446), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8652), 1,
      sym_identifier,
    ACTIONS(8724), 1,
      anon_sym_LPAREN2,
    ACTIONS(8726), 1,
      anon_sym_LBRACE,
    ACTIONS(8730), 1,
      anon_sym_requires,
    STATE(2051), 1,
      sym_template_type,
    STATE(2588), 1,
      sym_requirement_seq,
    STATE(5754), 1,
      sym_lambda_capture_specifier,
    STATE(6383), 1,
      sym__scope_resolution,
    STATE(7379), 1,
      sym_requires_parameter_list,
    ACTIONS(8728), 2,
      sym_true,
      sym_false,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(2589), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [201615] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2469), 1,
      anon_sym_LBRACK,
    ACTIONS(8354), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8646), 1,
      sym_identifier,
    ACTIONS(8732), 1,
      anon_sym_LPAREN2,
    ACTIONS(8734), 1,
      anon_sym_LBRACE,
    ACTIONS(8738), 1,
      anon_sym_requires,
    STATE(3480), 1,
      sym_requirement_seq,
    STATE(3780), 1,
      sym_template_type,
    STATE(5736), 1,
      sym_lambda_capture_specifier,
    STATE(6377), 1,
      sym__scope_resolution,
    STATE(7360), 1,
      sym_requires_parameter_list,
    ACTIONS(8736), 2,
      sym_true,
      sym_false,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4168), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [201676] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4942), 1,
      anon_sym_LBRACE,
    ACTIONS(4924), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(4926), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [201711] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7226), 1,
      anon_sym_DASH_GT,
    ACTIONS(7228), 1,
      anon_sym_requires,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8500), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5808), 1,
      sym__function_attributes_end,
    STATE(5919), 1,
      sym_trailing_return_type,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8312), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [201770] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7226), 1,
      anon_sym_DASH_GT,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    ACTIONS(8559), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8619), 1,
      anon_sym_requires,
    STATE(5806), 1,
      sym__function_attributes_end,
    STATE(5986), 1,
      sym_trailing_return_type,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8548), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5778), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8508), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [201829] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2469), 1,
      anon_sym_LBRACK,
    ACTIONS(8376), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8654), 1,
      sym_identifier,
    ACTIONS(8740), 1,
      anon_sym_LPAREN2,
    ACTIONS(8742), 1,
      anon_sym_LBRACE,
    ACTIONS(8746), 1,
      anon_sym_requires,
    STATE(2857), 1,
      sym_template_type,
    STATE(3840), 1,
      sym_requirement_seq,
    STATE(5723), 1,
      sym_lambda_capture_specifier,
    STATE(6349), 1,
      sym__scope_resolution,
    STATE(7591), 1,
      sym_requires_parameter_list,
    ACTIONS(8744), 2,
      sym_true,
      sym_false,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3801), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [201890] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7226), 1,
      anon_sym_DASH_GT,
    ACTIONS(7228), 1,
      anon_sym_requires,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    ACTIONS(8559), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5799), 1,
      sym__function_attributes_end,
    STATE(5920), 1,
      sym_trailing_return_type,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5778), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8508), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [201949] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7226), 1,
      anon_sym_DASH_GT,
    ACTIONS(7228), 1,
      anon_sym_requires,
    ACTIONS(8667), 1,
      anon_sym_LBRACK,
    ACTIONS(8701), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5793), 1,
      sym__function_attributes_end,
    STATE(5921), 1,
      sym_trailing_return_type,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5771), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8665), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [202008] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2469), 1,
      anon_sym_LBRACK,
    ACTIONS(8466), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8650), 1,
      sym_identifier,
    ACTIONS(8748), 1,
      anon_sym_LPAREN2,
    ACTIONS(8750), 1,
      anon_sym_LBRACE,
    ACTIONS(8754), 1,
      anon_sym_requires,
    STATE(2743), 1,
      sym_template_type,
    STATE(3584), 1,
      sym_requirement_seq,
    STATE(5725), 1,
      sym_lambda_capture_specifier,
    STATE(6368), 1,
      sym__scope_resolution,
    STATE(7377), 1,
      sym_requires_parameter_list,
    ACTIONS(8752), 2,
      sym_true,
      sym_false,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3615), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [202069] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2469), 1,
      anon_sym_LBRACK,
    ACTIONS(8396), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8656), 1,
      sym_identifier,
    ACTIONS(8756), 1,
      anon_sym_LPAREN2,
    ACTIONS(8758), 1,
      anon_sym_LBRACE,
    ACTIONS(8762), 1,
      anon_sym_requires,
    STATE(2739), 1,
      sym_template_type,
    STATE(4290), 1,
      sym_requirement_seq,
    STATE(5768), 1,
      sym_lambda_capture_specifier,
    STATE(6376), 1,
      sym__scope_resolution,
    STATE(7328), 1,
      sym_requires_parameter_list,
    ACTIONS(8760), 2,
      sym_true,
      sym_false,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4654), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [202130] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2469), 1,
      anon_sym_LBRACK,
    ACTIONS(8340), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8639), 1,
      sym_identifier,
    ACTIONS(8732), 1,
      anon_sym_LPAREN2,
    ACTIONS(8734), 1,
      anon_sym_LBRACE,
    ACTIONS(8738), 1,
      anon_sym_requires,
    STATE(1901), 1,
      sym_template_type,
    STATE(3480), 1,
      sym_requirement_seq,
    STATE(5736), 1,
      sym_lambda_capture_specifier,
    STATE(6337), 1,
      sym__scope_resolution,
    STATE(7360), 1,
      sym_requires_parameter_list,
    ACTIONS(8764), 2,
      sym_true,
      sym_false,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4170), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [202191] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    ACTIONS(7292), 1,
      anon_sym_STAR,
    ACTIONS(7294), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7296), 1,
      anon_sym_AMP,
    STATE(3360), 1,
      sym_parameter_list,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(5862), 1,
      sym__abstract_declarator,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7524), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [202239] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4822), 1,
      anon_sym_AMP,
    ACTIONS(8769), 1,
      anon_sym_const,
    STATE(5263), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4824), 8,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(8766), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
  [202277] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7255), 1,
      anon_sym_DASH_GT,
    ACTIONS(8667), 1,
      anon_sym_LBRACK,
    ACTIONS(8772), 1,
      anon_sym_requires,
    STATE(5947), 1,
      sym__function_attributes_end,
    STATE(6175), 1,
      sym_trailing_return_type,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8680), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6005), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8665), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [202335] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    ACTIONS(7278), 1,
      anon_sym_STAR,
    ACTIONS(7280), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7282), 1,
      anon_sym_AMP,
    STATE(3617), 1,
      sym_parameter_list,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(5907), 1,
      sym__abstract_declarator,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7524), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [202383] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7255), 1,
      anon_sym_DASH_GT,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    ACTIONS(8641), 1,
      anon_sym_requires,
    STATE(5946), 1,
      sym__function_attributes_end,
    STATE(6178), 1,
      sym_trailing_return_type,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8512), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5911), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8508), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [202441] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7255), 1,
      anon_sym_DASH_GT,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8554), 1,
      anon_sym_requires,
    STATE(5945), 1,
      sym__function_attributes_end,
    STATE(6198), 1,
      sym_trailing_return_type,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8322), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5948), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8312), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [202499] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7264), 1,
      anon_sym_STAR,
    ACTIONS(7266), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7268), 1,
      anon_sym_AMP,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    STATE(3638), 1,
      sym_parameter_list,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(5893), 1,
      sym__abstract_declarator,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7524), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [202547] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7255), 1,
      anon_sym_DASH_GT,
    ACTIONS(7260), 1,
      anon_sym_requires,
    ACTIONS(8667), 1,
      anon_sym_LBRACK,
    STATE(5937), 1,
      sym__function_attributes_end,
    STATE(6157), 1,
      sym_trailing_return_type,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6005), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8665), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [202605] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(7654), 1,
      anon_sym_LPAREN2,
    ACTIONS(7662), 1,
      sym_identifier,
    ACTIONS(7664), 1,
      anon_sym_STAR,
    ACTIONS(7666), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7668), 1,
      anon_sym_AMP,
    STATE(5722), 1,
      sym_ms_call_modifier,
    STATE(6391), 1,
      sym__field_declarator,
    STATE(6495), 1,
      sym_operator_name,
    STATE(7783), 1,
      sym_ms_based_modifier,
    ACTIONS(1825), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6227), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [202659] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7255), 1,
      anon_sym_DASH_GT,
    ACTIONS(7260), 1,
      anon_sym_requires,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    STATE(5936), 1,
      sym__function_attributes_end,
    STATE(6147), 1,
      sym_trailing_return_type,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5911), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8508), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [202717] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7255), 1,
      anon_sym_DASH_GT,
    ACTIONS(7260), 1,
      anon_sym_requires,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    STATE(5934), 1,
      sym__function_attributes_end,
    STATE(6144), 1,
      sym_trailing_return_type,
    STATE(6522), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5395), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5611), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5948), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8312), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [202775] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8775), 1,
      sym_identifier,
    ACTIONS(8777), 1,
      anon_sym_RPAREN,
    ACTIONS(8779), 1,
      anon_sym_LPAREN2,
    ACTIONS(8781), 1,
      anon_sym_defined,
    ACTIONS(8787), 1,
      aux_sym_number_literal_token1,
    ACTIONS(8789), 1,
      aux_sym_number_literal_token2,
    ACTIONS(8783), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(8785), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8791), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5447), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [202822] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7351), 1,
      sym_identifier,
    ACTIONS(7353), 1,
      anon_sym_LPAREN2,
    ACTIONS(7371), 1,
      anon_sym_STAR,
    ACTIONS(7373), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    STATE(2372), 1,
      sym_pointer_type_declarator,
    STATE(6318), 1,
      sym__type_declarator,
    STATE(6637), 1,
      sym__type_definition_declarators,
    STATE(7781), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2340), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
  [202875] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7351), 1,
      sym_identifier,
    ACTIONS(7353), 1,
      anon_sym_LPAREN2,
    ACTIONS(7371), 1,
      anon_sym_STAR,
    ACTIONS(7373), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    STATE(2372), 1,
      sym_pointer_type_declarator,
    STATE(6318), 1,
      sym__type_declarator,
    STATE(6760), 1,
      sym__type_definition_declarators,
    STATE(7781), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2340), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
  [202928] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7351), 1,
      sym_identifier,
    ACTIONS(7353), 1,
      anon_sym_LPAREN2,
    ACTIONS(7371), 1,
      anon_sym_STAR,
    ACTIONS(7373), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    STATE(2372), 1,
      sym_pointer_type_declarator,
    STATE(6318), 1,
      sym__type_declarator,
    STATE(6605), 1,
      sym__type_definition_declarators,
    STATE(7781), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2340), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
  [202981] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7351), 1,
      sym_identifier,
    ACTIONS(7353), 1,
      anon_sym_LPAREN2,
    ACTIONS(7371), 1,
      anon_sym_STAR,
    ACTIONS(7373), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    STATE(2372), 1,
      sym_pointer_type_declarator,
    STATE(6318), 1,
      sym__type_declarator,
    STATE(6679), 1,
      sym__type_definition_declarators,
    STATE(7781), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2340), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
  [203034] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7351), 1,
      sym_identifier,
    ACTIONS(7353), 1,
      anon_sym_LPAREN2,
    ACTIONS(7371), 1,
      anon_sym_STAR,
    ACTIONS(7373), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    STATE(2372), 1,
      sym_pointer_type_declarator,
    STATE(6318), 1,
      sym__type_declarator,
    STATE(6806), 1,
      sym__type_definition_declarators,
    STATE(7781), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2340), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
  [203087] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(7313), 1,
      anon_sym_STAR,
    ACTIONS(7315), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7317), 1,
      anon_sym_AMP,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    STATE(3325), 1,
      sym_parameter_list,
    STATE(5953), 1,
      sym__abstract_declarator,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7524), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [203134] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7351), 1,
      sym_identifier,
    ACTIONS(7353), 1,
      anon_sym_LPAREN2,
    ACTIONS(7371), 1,
      anon_sym_STAR,
    ACTIONS(7373), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    STATE(2372), 1,
      sym_pointer_type_declarator,
    STATE(6318), 1,
      sym__type_declarator,
    STATE(6812), 1,
      sym__type_definition_declarators,
    STATE(7781), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2340), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
  [203187] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7351), 1,
      sym_identifier,
    ACTIONS(7353), 1,
      anon_sym_LPAREN2,
    ACTIONS(7371), 1,
      anon_sym_STAR,
    ACTIONS(7373), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    STATE(2372), 1,
      sym_pointer_type_declarator,
    STATE(6318), 1,
      sym__type_declarator,
    STATE(6727), 1,
      sym__type_definition_declarators,
    STATE(7781), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2340), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
  [203240] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7351), 1,
      sym_identifier,
    ACTIONS(7353), 1,
      anon_sym_LPAREN2,
    ACTIONS(7371), 1,
      anon_sym_STAR,
    ACTIONS(7373), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    STATE(2372), 1,
      sym_pointer_type_declarator,
    STATE(6318), 1,
      sym__type_declarator,
    STATE(6817), 1,
      sym__type_definition_declarators,
    STATE(7781), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2340), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
  [203293] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8775), 1,
      sym_identifier,
    ACTIONS(8779), 1,
      anon_sym_LPAREN2,
    ACTIONS(8781), 1,
      anon_sym_defined,
    ACTIONS(8787), 1,
      aux_sym_number_literal_token1,
    ACTIONS(8789), 1,
      aux_sym_number_literal_token2,
    ACTIONS(8793), 1,
      anon_sym_RPAREN,
    ACTIONS(8783), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(8785), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8791), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5461), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [203340] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7351), 1,
      sym_identifier,
    ACTIONS(7353), 1,
      anon_sym_LPAREN2,
    ACTIONS(7371), 1,
      anon_sym_STAR,
    ACTIONS(7373), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    STATE(2372), 1,
      sym_pointer_type_declarator,
    STATE(6318), 1,
      sym__type_declarator,
    STATE(6721), 1,
      sym__type_definition_declarators,
    STATE(7781), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2340), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
  [203393] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7351), 1,
      sym_identifier,
    ACTIONS(7353), 1,
      anon_sym_LPAREN2,
    ACTIONS(7371), 1,
      anon_sym_STAR,
    ACTIONS(7373), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    STATE(2372), 1,
      sym_pointer_type_declarator,
    STATE(6318), 1,
      sym__type_declarator,
    STATE(6686), 1,
      sym__type_definition_declarators,
    STATE(7781), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2340), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
  [203446] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7351), 1,
      sym_identifier,
    ACTIONS(7353), 1,
      anon_sym_LPAREN2,
    ACTIONS(7371), 1,
      anon_sym_STAR,
    ACTIONS(7373), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    STATE(2372), 1,
      sym_pointer_type_declarator,
    STATE(6318), 1,
      sym__type_declarator,
    STATE(6800), 1,
      sym__type_definition_declarators,
    STATE(7781), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2340), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
  [203499] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8775), 1,
      sym_identifier,
    ACTIONS(8779), 1,
      anon_sym_LPAREN2,
    ACTIONS(8781), 1,
      anon_sym_defined,
    ACTIONS(8787), 1,
      aux_sym_number_literal_token1,
    ACTIONS(8789), 1,
      aux_sym_number_literal_token2,
    ACTIONS(8795), 1,
      anon_sym_RPAREN,
    ACTIONS(8783), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(8785), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8791), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5479), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [203546] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7351), 1,
      sym_identifier,
    ACTIONS(7353), 1,
      anon_sym_LPAREN2,
    ACTIONS(7371), 1,
      anon_sym_STAR,
    ACTIONS(7373), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    STATE(2372), 1,
      sym_pointer_type_declarator,
    STATE(6318), 1,
      sym__type_declarator,
    STATE(6680), 1,
      sym__type_definition_declarators,
    STATE(7781), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2340), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
  [203599] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7351), 1,
      sym_identifier,
    ACTIONS(7353), 1,
      anon_sym_LPAREN2,
    ACTIONS(7371), 1,
      anon_sym_STAR,
    ACTIONS(7373), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    STATE(2372), 1,
      sym_pointer_type_declarator,
    STATE(6318), 1,
      sym__type_declarator,
    STATE(6840), 1,
      sym__type_definition_declarators,
    STATE(7781), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2340), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
  [203652] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7351), 1,
      sym_identifier,
    ACTIONS(7353), 1,
      anon_sym_LPAREN2,
    ACTIONS(7371), 1,
      anon_sym_STAR,
    ACTIONS(7373), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    STATE(2372), 1,
      sym_pointer_type_declarator,
    STATE(6318), 1,
      sym__type_declarator,
    STATE(6824), 1,
      sym__type_definition_declarators,
    STATE(7781), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2340), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
  [203705] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7331), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7570), 1,
      anon_sym_COMMA,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(8799), 1,
      anon_sym_SEMI,
    ACTIONS(8801), 1,
      anon_sym_LBRACE,
    ACTIONS(8803), 1,
      anon_sym_LBRACK,
    ACTIONS(8805), 1,
      anon_sym_EQ,
    ACTIONS(8807), 1,
      anon_sym_COLON,
    ACTIONS(8809), 1,
      anon_sym_try,
    STATE(2152), 1,
      sym_compound_statement,
    STATE(2153), 1,
      sym_default_method_clause,
    STATE(2154), 1,
      sym_delete_method_clause,
    STATE(2156), 1,
      sym_pure_virtual_clause,
    STATE(2157), 1,
      sym_try_statement,
    STATE(3376), 1,
      sym_parameter_list,
    STATE(6214), 1,
      sym__function_declarator_seq,
    STATE(6540), 1,
      sym_initializer_list,
    STATE(6541), 1,
      aux_sym_field_declaration_repeat1,
    STATE(6570), 1,
      sym_bitfield_clause,
    STATE(8064), 1,
      sym_attribute_specifier,
    STATE(6163), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [203776] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7351), 1,
      sym_identifier,
    ACTIONS(7353), 1,
      anon_sym_LPAREN2,
    ACTIONS(7371), 1,
      anon_sym_STAR,
    ACTIONS(7373), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    STATE(2372), 1,
      sym_pointer_type_declarator,
    STATE(6318), 1,
      sym__type_declarator,
    STATE(6748), 1,
      sym__type_definition_declarators,
    STATE(7781), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2340), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
  [203829] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7351), 1,
      sym_identifier,
    ACTIONS(7353), 1,
      anon_sym_LPAREN2,
    ACTIONS(7371), 1,
      anon_sym_STAR,
    ACTIONS(7373), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    STATE(2372), 1,
      sym_pointer_type_declarator,
    STATE(6318), 1,
      sym__type_declarator,
    STATE(6790), 1,
      sym__type_definition_declarators,
    STATE(7781), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2340), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
  [203882] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7351), 1,
      sym_identifier,
    ACTIONS(7353), 1,
      anon_sym_LPAREN2,
    ACTIONS(7371), 1,
      anon_sym_STAR,
    ACTIONS(7373), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    STATE(2372), 1,
      sym_pointer_type_declarator,
    STATE(6318), 1,
      sym__type_declarator,
    STATE(6778), 1,
      sym__type_definition_declarators,
    STATE(7781), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2340), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
  [203935] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7331), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7570), 1,
      anon_sym_COMMA,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(8803), 1,
      anon_sym_LBRACK,
    ACTIONS(8807), 1,
      anon_sym_COLON,
    ACTIONS(8811), 1,
      anon_sym_SEMI,
    ACTIONS(8813), 1,
      anon_sym_LBRACE,
    ACTIONS(8815), 1,
      anon_sym_EQ,
    ACTIONS(8817), 1,
      anon_sym_try,
    STATE(1847), 1,
      sym_compound_statement,
    STATE(1860), 1,
      sym_default_method_clause,
    STATE(1861), 1,
      sym_delete_method_clause,
    STATE(1872), 1,
      sym_pure_virtual_clause,
    STATE(1876), 1,
      sym_try_statement,
    STATE(3376), 1,
      sym_parameter_list,
    STATE(6214), 1,
      sym__function_declarator_seq,
    STATE(6550), 1,
      aux_sym_field_declaration_repeat1,
    STATE(6562), 1,
      sym_initializer_list,
    STATE(6567), 1,
      sym_bitfield_clause,
    STATE(7705), 1,
      sym_attribute_specifier,
    STATE(6163), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [204006] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7351), 1,
      sym_identifier,
    ACTIONS(7353), 1,
      anon_sym_LPAREN2,
    ACTIONS(7371), 1,
      anon_sym_STAR,
    ACTIONS(7373), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    STATE(2372), 1,
      sym_pointer_type_declarator,
    STATE(6318), 1,
      sym__type_declarator,
    STATE(6823), 1,
      sym__type_definition_declarators,
    STATE(7781), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2340), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
  [204059] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7331), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7570), 1,
      anon_sym_COMMA,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(8803), 1,
      anon_sym_LBRACK,
    ACTIONS(8807), 1,
      anon_sym_COLON,
    ACTIONS(8819), 1,
      anon_sym_SEMI,
    ACTIONS(8821), 1,
      anon_sym_LBRACE,
    ACTIONS(8823), 1,
      anon_sym_EQ,
    ACTIONS(8825), 1,
      anon_sym_try,
    STATE(2197), 1,
      sym_compound_statement,
    STATE(2199), 1,
      sym_default_method_clause,
    STATE(2200), 1,
      sym_delete_method_clause,
    STATE(2226), 1,
      sym_pure_virtual_clause,
    STATE(2242), 1,
      sym_try_statement,
    STATE(3376), 1,
      sym_parameter_list,
    STATE(6214), 1,
      sym__function_declarator_seq,
    STATE(6579), 1,
      aux_sym_field_declaration_repeat1,
    STATE(6590), 1,
      sym_initializer_list,
    STATE(6596), 1,
      sym_bitfield_clause,
    STATE(7708), 1,
      sym_attribute_specifier,
    STATE(6163), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [204130] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8827), 1,
      sym_identifier,
    ACTIONS(8829), 1,
      anon_sym_LPAREN2,
    ACTIONS(8831), 1,
      anon_sym_defined,
    ACTIONS(8837), 1,
      aux_sym_number_literal_token1,
    ACTIONS(8839), 1,
      aux_sym_number_literal_token2,
    ACTIONS(8833), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(8835), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8841), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5631), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [204174] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8775), 1,
      sym_identifier,
    ACTIONS(8779), 1,
      anon_sym_LPAREN2,
    ACTIONS(8781), 1,
      anon_sym_defined,
    ACTIONS(8787), 1,
      aux_sym_number_literal_token1,
    ACTIONS(8789), 1,
      aux_sym_number_literal_token2,
    ACTIONS(8783), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(8785), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8791), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5544), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [204218] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7406), 1,
      sym_identifier,
    ACTIONS(7408), 1,
      anon_sym_LPAREN2,
    ACTIONS(7410), 1,
      anon_sym_STAR,
    ACTIONS(7412), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7414), 1,
      anon_sym_AMP,
    STATE(2877), 1,
      sym__type_declarator,
    STATE(3264), 1,
      sym_pointer_type_declarator,
    STATE(7901), 1,
      sym_ms_based_modifier,
    ACTIONS(7418), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7416), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3266), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
  [204268] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(133), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(2853), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7371), 1,
      anon_sym_STAR,
    ACTIONS(8843), 1,
      sym_identifier,
    ACTIONS(8845), 1,
      anon_sym_template,
    STATE(2403), 1,
      sym_qualified_type_identifier,
    STATE(2408), 1,
      sym_dependent_type_identifier,
    STATE(2422), 1,
      sym_template_type,
    STATE(2846), 1,
      sym_pointer_type_declarator,
    STATE(2850), 1,
      sym_template_function,
    STATE(2851), 1,
      sym_destructor_name,
    STATE(2863), 1,
      sym_operator_name,
    STATE(2865), 1,
      sym_dependent_identifier,
    STATE(2871), 1,
      sym_qualified_identifier,
    STATE(5301), 1,
      sym__scope_resolution,
    STATE(6801), 1,
      sym_operator_cast,
    STATE(6832), 1,
      sym_qualified_operator_cast_identifier,
    STATE(7781), 1,
      sym_ms_based_modifier,
    STATE(8290), 1,
      sym_decltype,
  [204338] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8827), 1,
      sym_identifier,
    ACTIONS(8829), 1,
      anon_sym_LPAREN2,
    ACTIONS(8831), 1,
      anon_sym_defined,
    ACTIONS(8837), 1,
      aux_sym_number_literal_token1,
    ACTIONS(8839), 1,
      aux_sym_number_literal_token2,
    ACTIONS(8833), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(8835), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8841), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5575), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [204382] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8827), 1,
      sym_identifier,
    ACTIONS(8829), 1,
      anon_sym_LPAREN2,
    ACTIONS(8831), 1,
      anon_sym_defined,
    ACTIONS(8837), 1,
      aux_sym_number_literal_token1,
    ACTIONS(8839), 1,
      aux_sym_number_literal_token2,
    ACTIONS(8833), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(8835), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8841), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5599), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [204426] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2469), 1,
      anon_sym_LBRACK,
    ACTIONS(7235), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8663), 1,
      sym_identifier,
    ACTIONS(8762), 1,
      anon_sym_requires,
    ACTIONS(8847), 1,
      anon_sym_LPAREN2,
    STATE(2739), 1,
      sym_template_type,
    STATE(5768), 1,
      sym_lambda_capture_specifier,
    STATE(6339), 1,
      sym__scope_resolution,
    ACTIONS(8849), 2,
      sym_true,
      sym_false,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6148), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [204478] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2469), 1,
      anon_sym_LBRACK,
    ACTIONS(7148), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8627), 1,
      sym_identifier,
    ACTIONS(8851), 1,
      anon_sym_LPAREN2,
    ACTIONS(8855), 1,
      anon_sym_requires,
    STATE(2421), 1,
      sym_template_type,
    STATE(5748), 1,
      sym_lambda_capture_specifier,
    STATE(6355), 1,
      sym__scope_resolution,
    ACTIONS(8853), 2,
      sym_true,
      sym_false,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5581), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [204530] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2469), 1,
      anon_sym_LBRACK,
    ACTIONS(7148), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8627), 1,
      sym_identifier,
    ACTIONS(8851), 1,
      anon_sym_LPAREN2,
    ACTIONS(8855), 1,
      anon_sym_requires,
    STATE(2421), 1,
      sym_template_type,
    STATE(5748), 1,
      sym_lambda_capture_specifier,
    STATE(6355), 1,
      sym__scope_resolution,
    ACTIONS(8857), 2,
      sym_true,
      sym_false,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5618), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [204582] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2469), 1,
      anon_sym_LBRACK,
    ACTIONS(8738), 1,
      anon_sym_requires,
    ACTIONS(8859), 1,
      sym_identifier,
    ACTIONS(8861), 1,
      anon_sym_LPAREN2,
    ACTIONS(8863), 1,
      anon_sym_COLON_COLON,
    STATE(1901), 1,
      sym_template_type,
    STATE(5736), 1,
      sym_lambda_capture_specifier,
    STATE(6367), 1,
      sym__scope_resolution,
    ACTIONS(8865), 2,
      sym_true,
      sym_false,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5969), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [204634] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2469), 1,
      anon_sym_LBRACK,
    ACTIONS(8446), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8652), 1,
      sym_identifier,
    ACTIONS(8730), 1,
      anon_sym_requires,
    ACTIONS(8867), 1,
      anon_sym_LPAREN2,
    STATE(2051), 1,
      sym_template_type,
    STATE(5754), 1,
      sym_lambda_capture_specifier,
    STATE(6383), 1,
      sym__scope_resolution,
    ACTIONS(8869), 2,
      sym_true,
      sym_false,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(2509), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [204686] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8775), 1,
      sym_identifier,
    ACTIONS(8779), 1,
      anon_sym_LPAREN2,
    ACTIONS(8781), 1,
      anon_sym_defined,
    ACTIONS(8787), 1,
      aux_sym_number_literal_token1,
    ACTIONS(8789), 1,
      aux_sym_number_literal_token2,
    ACTIONS(8783), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(8785), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8791), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5537), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [204730] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8827), 1,
      sym_identifier,
    ACTIONS(8829), 1,
      anon_sym_LPAREN2,
    ACTIONS(8831), 1,
      anon_sym_defined,
    ACTIONS(8837), 1,
      aux_sym_number_literal_token1,
    ACTIONS(8839), 1,
      aux_sym_number_literal_token2,
    ACTIONS(8833), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(8835), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8841), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5614), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [204774] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2469), 1,
      anon_sym_LBRACK,
    ACTIONS(7206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8644), 1,
      sym_identifier,
    ACTIONS(8851), 1,
      anon_sym_LPAREN2,
    ACTIONS(8855), 1,
      anon_sym_requires,
    STATE(2421), 1,
      sym_template_type,
    STATE(5748), 1,
      sym_lambda_capture_specifier,
    STATE(6336), 1,
      sym__scope_resolution,
    ACTIONS(8871), 2,
      sym_true,
      sym_false,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6259), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [204826] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7377), 1,
      sym_identifier,
    ACTIONS(7379), 1,
      anon_sym_LPAREN2,
    ACTIONS(7381), 1,
      anon_sym_STAR,
    ACTIONS(7383), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7385), 1,
      anon_sym_AMP,
    STATE(5844), 1,
      sym__type_declarator,
    STATE(6116), 1,
      sym_pointer_type_declarator,
    STATE(8041), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7387), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6111), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
  [204876] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8827), 1,
      sym_identifier,
    ACTIONS(8829), 1,
      anon_sym_LPAREN2,
    ACTIONS(8831), 1,
      anon_sym_defined,
    ACTIONS(8837), 1,
      aux_sym_number_literal_token1,
    ACTIONS(8839), 1,
      aux_sym_number_literal_token2,
    ACTIONS(8833), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(8835), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8841), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5630), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [204920] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8827), 1,
      sym_identifier,
    ACTIONS(8829), 1,
      anon_sym_LPAREN2,
    ACTIONS(8831), 1,
      anon_sym_defined,
    ACTIONS(8837), 1,
      aux_sym_number_literal_token1,
    ACTIONS(8839), 1,
      aux_sym_number_literal_token2,
    ACTIONS(8833), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(8835), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8841), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5593), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [204964] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7351), 1,
      sym_identifier,
    ACTIONS(7353), 1,
      anon_sym_LPAREN2,
    ACTIONS(7355), 1,
      anon_sym_STAR,
    ACTIONS(7357), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7359), 1,
      anon_sym_AMP,
    STATE(2372), 1,
      sym_pointer_type_declarator,
    STATE(6447), 1,
      sym__type_declarator,
    STATE(7983), 1,
      sym_ms_based_modifier,
    ACTIONS(7363), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2340), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
  [205014] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2469), 1,
      anon_sym_LBRACK,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8633), 1,
      sym_identifier,
    ACTIONS(8738), 1,
      anon_sym_requires,
    ACTIONS(8861), 1,
      anon_sym_LPAREN2,
    STATE(1901), 1,
      sym_template_type,
    STATE(5736), 1,
      sym_lambda_capture_specifier,
    STATE(6373), 1,
      sym__scope_resolution,
    ACTIONS(8873), 2,
      sym_true,
      sym_false,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6359), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [205066] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2469), 1,
      anon_sym_LBRACK,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8633), 1,
      sym_identifier,
    ACTIONS(8738), 1,
      anon_sym_requires,
    ACTIONS(8861), 1,
      anon_sym_LPAREN2,
    STATE(1901), 1,
      sym_template_type,
    STATE(5736), 1,
      sym_lambda_capture_specifier,
    STATE(6373), 1,
      sym__scope_resolution,
    ACTIONS(8875), 2,
      sym_true,
      sym_false,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3377), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [205118] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2469), 1,
      anon_sym_LBRACK,
    ACTIONS(7170), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8648), 1,
      sym_identifier,
    ACTIONS(8877), 1,
      anon_sym_LPAREN2,
    ACTIONS(8881), 1,
      anon_sym_requires,
    STATE(4697), 1,
      sym_template_type,
    STATE(5761), 1,
      sym_lambda_capture_specifier,
    STATE(6342), 1,
      sym__scope_resolution,
    ACTIONS(8879), 2,
      sym_true,
      sym_false,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5814), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [205170] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2469), 1,
      anon_sym_LBRACK,
    ACTIONS(7170), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8648), 1,
      sym_identifier,
    ACTIONS(8877), 1,
      anon_sym_LPAREN2,
    ACTIONS(8881), 1,
      anon_sym_requires,
    STATE(4697), 1,
      sym_template_type,
    STATE(5761), 1,
      sym_lambda_capture_specifier,
    STATE(6342), 1,
      sym__scope_resolution,
    ACTIONS(8883), 2,
      sym_true,
      sym_false,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5819), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [205222] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7351), 1,
      sym_identifier,
    ACTIONS(7353), 1,
      anon_sym_LPAREN2,
    ACTIONS(7371), 1,
      anon_sym_STAR,
    ACTIONS(7373), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    STATE(2372), 1,
      sym_pointer_type_declarator,
    STATE(6471), 1,
      sym__type_declarator,
    STATE(7781), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2340), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
  [205272] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(7302), 1,
      anon_sym_DASH_GT,
    ACTIONS(7329), 1,
      anon_sym_requires,
    ACTIONS(8667), 1,
      anon_sym_LBRACK,
    ACTIONS(8689), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6071), 1,
      sym__function_attributes_end,
    STATE(6229), 1,
      sym_trailing_return_type,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8665), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5771), 2,
      sym__function_postfix,
      sym_requires_clause,
  [205328] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(7392), 1,
      anon_sym_STAR,
    ACTIONS(8885), 1,
      sym_identifier,
    ACTIONS(8887), 1,
      anon_sym_TILDE,
    ACTIONS(8889), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8891), 1,
      anon_sym_template,
    ACTIONS(8893), 1,
      anon_sym_operator,
    STATE(2403), 1,
      sym_qualified_type_identifier,
    STATE(2408), 1,
      sym_dependent_type_identifier,
    STATE(2422), 1,
      sym_template_type,
    STATE(2846), 1,
      sym_pointer_type_declarator,
    STATE(2850), 1,
      sym_template_function,
    STATE(2851), 1,
      sym_destructor_name,
    STATE(2863), 1,
      sym_operator_name,
    STATE(2865), 1,
      sym_dependent_identifier,
    STATE(2871), 1,
      sym_qualified_identifier,
    STATE(5322), 1,
      sym__scope_resolution,
    STATE(6801), 1,
      sym_operator_cast,
    STATE(6832), 1,
      sym_qualified_operator_cast_identifier,
    STATE(8058), 1,
      sym_ms_based_modifier,
    STATE(8290), 1,
      sym_decltype,
  [205398] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8775), 1,
      sym_identifier,
    ACTIONS(8779), 1,
      anon_sym_LPAREN2,
    ACTIONS(8781), 1,
      anon_sym_defined,
    ACTIONS(8787), 1,
      aux_sym_number_literal_token1,
    ACTIONS(8789), 1,
      aux_sym_number_literal_token2,
    ACTIONS(8783), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(8785), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8791), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5661), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [205442] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8827), 1,
      sym_identifier,
    ACTIONS(8829), 1,
      anon_sym_LPAREN2,
    ACTIONS(8831), 1,
      anon_sym_defined,
    ACTIONS(8837), 1,
      aux_sym_number_literal_token1,
    ACTIONS(8839), 1,
      aux_sym_number_literal_token2,
    ACTIONS(8833), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(8835), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8841), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5653), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [205486] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    ACTIONS(7420), 1,
      anon_sym_STAR,
    ACTIONS(7422), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7424), 1,
      anon_sym_AMP,
    STATE(3657), 1,
      sym_parameter_list,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(6117), 1,
      sym__abstract_declarator,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7524), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [205532] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2469), 1,
      anon_sym_LBRACK,
    ACTIONS(7170), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8648), 1,
      sym_identifier,
    ACTIONS(8877), 1,
      anon_sym_LPAREN2,
    ACTIONS(8881), 1,
      anon_sym_requires,
    STATE(4697), 1,
      sym_template_type,
    STATE(5761), 1,
      sym_lambda_capture_specifier,
    STATE(6342), 1,
      sym__scope_resolution,
    ACTIONS(8895), 2,
      sym_true,
      sym_false,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5829), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [205584] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8827), 1,
      sym_identifier,
    ACTIONS(8829), 1,
      anon_sym_LPAREN2,
    ACTIONS(8831), 1,
      anon_sym_defined,
    ACTIONS(8837), 1,
      aux_sym_number_literal_token1,
    ACTIONS(8839), 1,
      aux_sym_number_literal_token2,
    ACTIONS(8833), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(8835), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8841), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5670), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [205628] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(7302), 1,
      anon_sym_DASH_GT,
    ACTIONS(7329), 1,
      anon_sym_requires,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    ACTIONS(8545), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6069), 1,
      sym__function_attributes_end,
    STATE(6225), 1,
      sym_trailing_return_type,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8508), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5778), 2,
      sym__function_postfix,
      sym_requires_clause,
  [205684] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2469), 1,
      anon_sym_LBRACK,
    ACTIONS(7235), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8663), 1,
      sym_identifier,
    ACTIONS(8762), 1,
      anon_sym_requires,
    ACTIONS(8847), 1,
      anon_sym_LPAREN2,
    STATE(2739), 1,
      sym_template_type,
    STATE(5768), 1,
      sym_lambda_capture_specifier,
    STATE(6339), 1,
      sym__scope_resolution,
    ACTIONS(8897), 2,
      sym_true,
      sym_false,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6196), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [205736] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2469), 1,
      anon_sym_LBRACK,
    ACTIONS(7235), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8663), 1,
      sym_identifier,
    ACTIONS(8762), 1,
      anon_sym_requires,
    ACTIONS(8847), 1,
      anon_sym_LPAREN2,
    STATE(2739), 1,
      sym_template_type,
    STATE(5768), 1,
      sym_lambda_capture_specifier,
    STATE(6339), 1,
      sym__scope_resolution,
    ACTIONS(8899), 2,
      sym_true,
      sym_false,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4330), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [205788] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2469), 1,
      anon_sym_LBRACK,
    ACTIONS(8376), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8654), 1,
      sym_identifier,
    ACTIONS(8746), 1,
      anon_sym_requires,
    ACTIONS(8901), 1,
      anon_sym_LPAREN2,
    STATE(2857), 1,
      sym_template_type,
    STATE(5723), 1,
      sym_lambda_capture_specifier,
    STATE(6349), 1,
      sym__scope_resolution,
    ACTIONS(8903), 2,
      sym_true,
      sym_false,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3796), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [205840] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2469), 1,
      anon_sym_LBRACK,
    ACTIONS(8738), 1,
      anon_sym_requires,
    ACTIONS(8859), 1,
      sym_identifier,
    ACTIONS(8861), 1,
      anon_sym_LPAREN2,
    ACTIONS(8863), 1,
      anon_sym_COLON_COLON,
    STATE(1901), 1,
      sym_template_type,
    STATE(5736), 1,
      sym_lambda_capture_specifier,
    STATE(6367), 1,
      sym__scope_resolution,
    ACTIONS(8905), 2,
      sym_true,
      sym_false,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5944), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [205892] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2469), 1,
      anon_sym_LBRACK,
    ACTIONS(8738), 1,
      anon_sym_requires,
    ACTIONS(8859), 1,
      sym_identifier,
    ACTIONS(8861), 1,
      anon_sym_LPAREN2,
    ACTIONS(8863), 1,
      anon_sym_COLON_COLON,
    STATE(1901), 1,
      sym_template_type,
    STATE(5736), 1,
      sym_lambda_capture_specifier,
    STATE(6367), 1,
      sym__scope_resolution,
    ACTIONS(8875), 2,
      sym_true,
      sym_false,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3377), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [205944] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8775), 1,
      sym_identifier,
    ACTIONS(8779), 1,
      anon_sym_LPAREN2,
    ACTIONS(8781), 1,
      anon_sym_defined,
    ACTIONS(8787), 1,
      aux_sym_number_literal_token1,
    ACTIONS(8789), 1,
      aux_sym_number_literal_token2,
    ACTIONS(8783), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(8785), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8791), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5551), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [205988] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2469), 1,
      anon_sym_LBRACK,
    ACTIONS(7192), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8627), 1,
      sym_identifier,
    ACTIONS(8907), 1,
      anon_sym_LPAREN2,
    ACTIONS(8911), 1,
      anon_sym_requires,
    STATE(2421), 1,
      sym_template_type,
    STATE(5755), 1,
      sym_lambda_capture_specifier,
    STATE(6371), 1,
      sym__scope_resolution,
    ACTIONS(8909), 2,
      sym_true,
      sym_false,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5638), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [206040] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2469), 1,
      anon_sym_LBRACK,
    ACTIONS(8376), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8654), 1,
      sym_identifier,
    ACTIONS(8746), 1,
      anon_sym_requires,
    ACTIONS(8901), 1,
      anon_sym_LPAREN2,
    STATE(2857), 1,
      sym_template_type,
    STATE(5723), 1,
      sym_lambda_capture_specifier,
    STATE(6349), 1,
      sym__scope_resolution,
    ACTIONS(8913), 2,
      sym_true,
      sym_false,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3845), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [206092] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7351), 1,
      sym_identifier,
    ACTIONS(7353), 1,
      anon_sym_LPAREN2,
    ACTIONS(7371), 1,
      anon_sym_STAR,
    ACTIONS(7373), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    STATE(2372), 1,
      sym_pointer_type_declarator,
    STATE(6448), 1,
      sym__type_declarator,
    STATE(7781), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2340), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
  [206142] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8827), 1,
      sym_identifier,
    ACTIONS(8829), 1,
      anon_sym_LPAREN2,
    ACTIONS(8831), 1,
      anon_sym_defined,
    ACTIONS(8837), 1,
      aux_sym_number_literal_token1,
    ACTIONS(8839), 1,
      aux_sym_number_literal_token2,
    ACTIONS(8833), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(8835), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8841), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5644), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [206186] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8827), 1,
      sym_identifier,
    ACTIONS(8829), 1,
      anon_sym_LPAREN2,
    ACTIONS(8831), 1,
      anon_sym_defined,
    ACTIONS(8837), 1,
      aux_sym_number_literal_token1,
    ACTIONS(8839), 1,
      aux_sym_number_literal_token2,
    ACTIONS(8833), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(8835), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8841), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5648), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [206230] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8827), 1,
      sym_identifier,
    ACTIONS(8829), 1,
      anon_sym_LPAREN2,
    ACTIONS(8831), 1,
      anon_sym_defined,
    ACTIONS(8837), 1,
      aux_sym_number_literal_token1,
    ACTIONS(8839), 1,
      aux_sym_number_literal_token2,
    ACTIONS(8833), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(8835), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8841), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5616), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [206274] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8827), 1,
      sym_identifier,
    ACTIONS(8829), 1,
      anon_sym_LPAREN2,
    ACTIONS(8831), 1,
      anon_sym_defined,
    ACTIONS(8837), 1,
      aux_sym_number_literal_token1,
    ACTIONS(8839), 1,
      aux_sym_number_literal_token2,
    ACTIONS(8833), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(8835), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8841), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5582), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [206318] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8827), 1,
      sym_identifier,
    ACTIONS(8829), 1,
      anon_sym_LPAREN2,
    ACTIONS(8831), 1,
      anon_sym_defined,
    ACTIONS(8837), 1,
      aux_sym_number_literal_token1,
    ACTIONS(8839), 1,
      aux_sym_number_literal_token2,
    ACTIONS(8833), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(8835), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8841), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5623), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [206362] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2819), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(2821), 20,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_PROGMEM,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [206392] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(133), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(3606), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7371), 1,
      anon_sym_STAR,
    ACTIONS(8915), 1,
      sym_identifier,
    ACTIONS(8917), 1,
      anon_sym_template,
    STATE(2403), 1,
      sym_qualified_type_identifier,
    STATE(2408), 1,
      sym_dependent_type_identifier,
    STATE(2422), 1,
      sym_template_type,
    STATE(2846), 1,
      sym_pointer_type_declarator,
    STATE(2850), 1,
      sym_template_function,
    STATE(2851), 1,
      sym_destructor_name,
    STATE(2863), 1,
      sym_operator_name,
    STATE(2865), 1,
      sym_dependent_identifier,
    STATE(2871), 1,
      sym_qualified_identifier,
    STATE(5344), 1,
      sym__scope_resolution,
    STATE(6801), 1,
      sym_operator_cast,
    STATE(6832), 1,
      sym_qualified_operator_cast_identifier,
    STATE(7781), 1,
      sym_ms_based_modifier,
    STATE(8290), 1,
      sym_decltype,
  [206462] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(7302), 1,
      anon_sym_DASH_GT,
    ACTIONS(7329), 1,
      anon_sym_requires,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8435), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6064), 1,
      sym__function_attributes_end,
    STATE(6211), 1,
      sym_trailing_return_type,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8312), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
  [206518] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2469), 1,
      anon_sym_LBRACK,
    ACTIONS(8466), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8650), 1,
      sym_identifier,
    ACTIONS(8754), 1,
      anon_sym_requires,
    ACTIONS(8919), 1,
      anon_sym_LPAREN2,
    STATE(2743), 1,
      sym_template_type,
    STATE(5725), 1,
      sym_lambda_capture_specifier,
    STATE(6368), 1,
      sym__scope_resolution,
    ACTIONS(8921), 2,
      sym_true,
      sym_false,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3549), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [206570] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2469), 1,
      anon_sym_LBRACK,
    ACTIONS(8907), 1,
      anon_sym_LPAREN2,
    ACTIONS(8911), 1,
      anon_sym_requires,
    ACTIONS(8923), 1,
      sym_identifier,
    ACTIONS(8925), 1,
      anon_sym_COLON_COLON,
    STATE(2305), 1,
      sym_template_type,
    STATE(5741), 1,
      sym_lambda_capture_specifier,
    STATE(6361), 1,
      sym__scope_resolution,
    ACTIONS(8927), 2,
      sym_true,
      sym_false,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(1752), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [206622] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7351), 1,
      sym_identifier,
    ACTIONS(7353), 1,
      anon_sym_LPAREN2,
    ACTIONS(7371), 1,
      anon_sym_STAR,
    ACTIONS(7373), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    STATE(2372), 1,
      sym_pointer_type_declarator,
    STATE(6207), 1,
      sym__type_declarator,
    STATE(7781), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2340), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
  [206672] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2469), 1,
      anon_sym_LBRACK,
    ACTIONS(8907), 1,
      anon_sym_LPAREN2,
    ACTIONS(8911), 1,
      anon_sym_requires,
    ACTIONS(8923), 1,
      sym_identifier,
    ACTIONS(8925), 1,
      anon_sym_COLON_COLON,
    STATE(2305), 1,
      sym_template_type,
    STATE(5741), 1,
      sym_lambda_capture_specifier,
    STATE(6361), 1,
      sym__scope_resolution,
    ACTIONS(8929), 2,
      sym_true,
      sym_false,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(2297), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [206724] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2469), 1,
      anon_sym_LBRACK,
    ACTIONS(8466), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8650), 1,
      sym_identifier,
    ACTIONS(8754), 1,
      anon_sym_requires,
    ACTIONS(8919), 1,
      anon_sym_LPAREN2,
    STATE(2743), 1,
      sym_template_type,
    STATE(5725), 1,
      sym_lambda_capture_specifier,
    STATE(6368), 1,
      sym__scope_resolution,
    ACTIONS(8931), 2,
      sym_true,
      sym_false,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3567), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [206776] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7335), 1,
      sym_identifier,
    ACTIONS(7337), 1,
      anon_sym_LPAREN2,
    ACTIONS(7339), 1,
      anon_sym_STAR,
    ACTIONS(7341), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7343), 1,
      anon_sym_AMP,
    STATE(3022), 1,
      sym__type_declarator,
    STATE(3379), 1,
      sym_pointer_type_declarator,
    STATE(7618), 1,
      sym_ms_based_modifier,
    ACTIONS(7349), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7347), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3385), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
  [206826] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2469), 1,
      anon_sym_LBRACK,
    ACTIONS(8354), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8646), 1,
      sym_identifier,
    ACTIONS(8738), 1,
      anon_sym_requires,
    ACTIONS(8861), 1,
      anon_sym_LPAREN2,
    STATE(3780), 1,
      sym_template_type,
    STATE(5736), 1,
      sym_lambda_capture_specifier,
    STATE(6377), 1,
      sym__scope_resolution,
    ACTIONS(8875), 2,
      sym_true,
      sym_false,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3377), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [206878] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2469), 1,
      anon_sym_LBRACK,
    ACTIONS(8354), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8646), 1,
      sym_identifier,
    ACTIONS(8738), 1,
      anon_sym_requires,
    ACTIONS(8861), 1,
      anon_sym_LPAREN2,
    STATE(3780), 1,
      sym_template_type,
    STATE(5736), 1,
      sym_lambda_capture_specifier,
    STATE(6377), 1,
      sym__scope_resolution,
    ACTIONS(8933), 2,
      sym_true,
      sym_false,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4172), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [206930] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7351), 1,
      sym_identifier,
    ACTIONS(7353), 1,
      anon_sym_LPAREN2,
    ACTIONS(7371), 1,
      anon_sym_STAR,
    ACTIONS(7373), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    STATE(2372), 1,
      sym_pointer_type_declarator,
    STATE(6469), 1,
      sym__type_declarator,
    STATE(7781), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2340), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
  [206980] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2469), 1,
      anon_sym_LBRACK,
    ACTIONS(8446), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8652), 1,
      sym_identifier,
    ACTIONS(8730), 1,
      anon_sym_requires,
    ACTIONS(8867), 1,
      anon_sym_LPAREN2,
    STATE(2051), 1,
      sym_template_type,
    STATE(5754), 1,
      sym_lambda_capture_specifier,
    STATE(6383), 1,
      sym__scope_resolution,
    ACTIONS(8935), 2,
      sym_true,
      sym_false,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(2511), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [207032] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(7331), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7333), 1,
      anon_sym_DASH_GT,
    ACTIONS(8667), 1,
      anon_sym_LBRACK,
    ACTIONS(8713), 1,
      anon_sym_requires,
    STATE(5964), 1,
      sym_trailing_return_type,
    STATE(6174), 1,
      sym__function_attributes_end,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8665), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(8680), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6005), 2,
      sym__function_postfix,
      sym_requires_clause,
  [207088] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(7331), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7333), 1,
      anon_sym_DASH_GT,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    ACTIONS(8622), 1,
      anon_sym_requires,
    STATE(5923), 1,
      sym_trailing_return_type,
    STATE(6192), 1,
      sym__function_attributes_end,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8508), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(8512), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5911), 2,
      sym__function_postfix,
      sym_requires_clause,
  [207144] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(7331), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7333), 1,
      anon_sym_DASH_GT,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8526), 1,
      anon_sym_requires,
    STATE(5924), 1,
      sym_trailing_return_type,
    STATE(6203), 1,
      sym__function_attributes_end,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8312), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(8322), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5948), 2,
      sym__function_postfix,
      sym_requires_clause,
  [207200] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2469), 1,
      anon_sym_LBRACK,
    ACTIONS(8396), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8656), 1,
      sym_identifier,
    ACTIONS(8762), 1,
      anon_sym_requires,
    ACTIONS(8847), 1,
      anon_sym_LPAREN2,
    STATE(2739), 1,
      sym_template_type,
    STATE(5768), 1,
      sym_lambda_capture_specifier,
    STATE(6376), 1,
      sym__scope_resolution,
    ACTIONS(8937), 2,
      sym_true,
      sym_false,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4672), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [207252] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2469), 1,
      anon_sym_LBRACK,
    ACTIONS(8410), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8635), 1,
      sym_identifier,
    ACTIONS(8722), 1,
      anon_sym_requires,
    ACTIONS(8939), 1,
      anon_sym_LPAREN2,
    STATE(2692), 1,
      sym_template_type,
    STATE(5774), 1,
      sym_lambda_capture_specifier,
    STATE(6348), 1,
      sym__scope_resolution,
    ACTIONS(8941), 2,
      sym_true,
      sym_false,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3414), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [207304] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2469), 1,
      anon_sym_LBRACK,
    ACTIONS(8410), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8635), 1,
      sym_identifier,
    ACTIONS(8722), 1,
      anon_sym_requires,
    ACTIONS(8939), 1,
      anon_sym_LPAREN2,
    STATE(2692), 1,
      sym_template_type,
    STATE(5774), 1,
      sym_lambda_capture_specifier,
    STATE(6348), 1,
      sym__scope_resolution,
    ACTIONS(8943), 2,
      sym_true,
      sym_false,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3412), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [207356] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2469), 1,
      anon_sym_LBRACK,
    ACTIONS(7148), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8627), 1,
      sym_identifier,
    ACTIONS(8851), 1,
      anon_sym_LPAREN2,
    ACTIONS(8855), 1,
      anon_sym_requires,
    STATE(2421), 1,
      sym_template_type,
    STATE(5748), 1,
      sym_lambda_capture_specifier,
    STATE(6355), 1,
      sym__scope_resolution,
    ACTIONS(8945), 2,
      sym_true,
      sym_false,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5688), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [207408] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2469), 1,
      anon_sym_LBRACK,
    ACTIONS(3578), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8644), 1,
      sym_identifier,
    ACTIONS(8907), 1,
      anon_sym_LPAREN2,
    ACTIONS(8911), 1,
      anon_sym_requires,
    STATE(2421), 1,
      sym_template_type,
    STATE(5755), 1,
      sym_lambda_capture_specifier,
    STATE(6333), 1,
      sym__scope_resolution,
    ACTIONS(8947), 2,
      sym_true,
      sym_false,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5995), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [207460] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2469), 1,
      anon_sym_LBRACK,
    ACTIONS(8396), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8656), 1,
      sym_identifier,
    ACTIONS(8762), 1,
      anon_sym_requires,
    ACTIONS(8847), 1,
      anon_sym_LPAREN2,
    STATE(2739), 1,
      sym_template_type,
    STATE(5768), 1,
      sym_lambda_capture_specifier,
    STATE(6376), 1,
      sym__scope_resolution,
    ACTIONS(8899), 2,
      sym_true,
      sym_false,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4330), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [207512] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2469), 1,
      anon_sym_LBRACK,
    ACTIONS(8907), 1,
      anon_sym_LPAREN2,
    ACTIONS(8911), 1,
      anon_sym_requires,
    ACTIONS(8923), 1,
      sym_identifier,
    ACTIONS(8925), 1,
      anon_sym_COLON_COLON,
    STATE(2305), 1,
      sym_template_type,
    STATE(5741), 1,
      sym_lambda_capture_specifier,
    STATE(6361), 1,
      sym__scope_resolution,
    ACTIONS(8949), 2,
      sym_true,
      sym_false,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(2275), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [207564] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2469), 1,
      anon_sym_LBRACK,
    ACTIONS(3578), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8644), 1,
      sym_identifier,
    ACTIONS(8907), 1,
      anon_sym_LPAREN2,
    ACTIONS(8911), 1,
      anon_sym_requires,
    STATE(2421), 1,
      sym_template_type,
    STATE(5755), 1,
      sym_lambda_capture_specifier,
    STATE(6333), 1,
      sym__scope_resolution,
    ACTIONS(8927), 2,
      sym_true,
      sym_false,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(1752), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [207616] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8827), 1,
      sym_identifier,
    ACTIONS(8829), 1,
      anon_sym_LPAREN2,
    ACTIONS(8831), 1,
      anon_sym_defined,
    ACTIONS(8837), 1,
      aux_sym_number_literal_token1,
    ACTIONS(8839), 1,
      aux_sym_number_literal_token2,
    ACTIONS(8833), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(8835), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8841), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5683), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [207660] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8827), 1,
      sym_identifier,
    ACTIONS(8829), 1,
      anon_sym_LPAREN2,
    ACTIONS(8831), 1,
      anon_sym_defined,
    ACTIONS(8837), 1,
      aux_sym_number_literal_token1,
    ACTIONS(8839), 1,
      aux_sym_number_literal_token2,
    ACTIONS(8833), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(8835), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8841), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5687), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [207704] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7351), 1,
      sym_identifier,
    ACTIONS(7353), 1,
      anon_sym_LPAREN2,
    ACTIONS(7371), 1,
      anon_sym_STAR,
    ACTIONS(7373), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    STATE(2372), 1,
      sym_pointer_type_declarator,
    STATE(6378), 1,
      sym__type_declarator,
    STATE(7781), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2340), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
  [207754] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7377), 1,
      sym_identifier,
    ACTIONS(7379), 1,
      anon_sym_LPAREN2,
    ACTIONS(7400), 1,
      anon_sym_STAR,
    ACTIONS(7402), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7404), 1,
      anon_sym_AMP,
    STATE(6038), 1,
      sym__type_declarator,
    STATE(6116), 1,
      sym_pointer_type_declarator,
    STATE(7809), 1,
      sym_ms_based_modifier,
    ACTIONS(7152), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7387), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6111), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
  [207804] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7351), 1,
      sym_identifier,
    ACTIONS(7353), 1,
      anon_sym_LPAREN2,
    ACTIONS(7371), 1,
      anon_sym_STAR,
    ACTIONS(7373), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    STATE(2372), 1,
      sym_pointer_type_declarator,
    STATE(6473), 1,
      sym__type_declarator,
    STATE(7781), 1,
      sym_ms_based_modifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2340), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
  [207854] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2469), 1,
      anon_sym_LBRACK,
    ACTIONS(8340), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8639), 1,
      sym_identifier,
    ACTIONS(8738), 1,
      anon_sym_requires,
    ACTIONS(8861), 1,
      anon_sym_LPAREN2,
    STATE(1901), 1,
      sym_template_type,
    STATE(5736), 1,
      sym_lambda_capture_specifier,
    STATE(6337), 1,
      sym__scope_resolution,
    ACTIONS(8951), 2,
      sym_true,
      sym_false,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4184), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [207906] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8827), 1,
      sym_identifier,
    ACTIONS(8829), 1,
      anon_sym_LPAREN2,
    ACTIONS(8831), 1,
      anon_sym_defined,
    ACTIONS(8837), 1,
      aux_sym_number_literal_token1,
    ACTIONS(8839), 1,
      aux_sym_number_literal_token2,
    ACTIONS(8833), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(8835), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8841), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5690), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [207950] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8827), 1,
      sym_identifier,
    ACTIONS(8829), 1,
      anon_sym_LPAREN2,
    ACTIONS(8831), 1,
      anon_sym_defined,
    ACTIONS(8837), 1,
      aux_sym_number_literal_token1,
    ACTIONS(8839), 1,
      aux_sym_number_literal_token2,
    ACTIONS(8833), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(8835), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8841), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5675), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [207994] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2469), 1,
      anon_sym_LBRACK,
    ACTIONS(8340), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8639), 1,
      sym_identifier,
    ACTIONS(8738), 1,
      anon_sym_requires,
    ACTIONS(8861), 1,
      anon_sym_LPAREN2,
    STATE(1901), 1,
      sym_template_type,
    STATE(5736), 1,
      sym_lambda_capture_specifier,
    STATE(6337), 1,
      sym__scope_resolution,
    ACTIONS(8875), 2,
      sym_true,
      sym_false,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3377), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [208046] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8827), 1,
      sym_identifier,
    ACTIONS(8829), 1,
      anon_sym_LPAREN2,
    ACTIONS(8831), 1,
      anon_sym_defined,
    ACTIONS(8837), 1,
      aux_sym_number_literal_token1,
    ACTIONS(8839), 1,
      aux_sym_number_literal_token2,
    ACTIONS(8833), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(8835), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8841), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5674), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [208090] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2469), 1,
      anon_sym_LBRACK,
    ACTIONS(3578), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8644), 1,
      sym_identifier,
    ACTIONS(8907), 1,
      anon_sym_LPAREN2,
    ACTIONS(8911), 1,
      anon_sym_requires,
    STATE(2421), 1,
      sym_template_type,
    STATE(5755), 1,
      sym_lambda_capture_specifier,
    STATE(6333), 1,
      sym__scope_resolution,
    ACTIONS(8953), 2,
      sym_true,
      sym_false,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5993), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [208142] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2469), 1,
      anon_sym_LBRACK,
    ACTIONS(7206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8644), 1,
      sym_identifier,
    ACTIONS(8851), 1,
      anon_sym_LPAREN2,
    ACTIONS(8855), 1,
      anon_sym_requires,
    STATE(2421), 1,
      sym_template_type,
    STATE(5748), 1,
      sym_lambda_capture_specifier,
    STATE(6336), 1,
      sym__scope_resolution,
    ACTIONS(8955), 2,
      sym_true,
      sym_false,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6291), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [208194] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8827), 1,
      sym_identifier,
    ACTIONS(8829), 1,
      anon_sym_LPAREN2,
    ACTIONS(8831), 1,
      anon_sym_defined,
    ACTIONS(8837), 1,
      aux_sym_number_literal_token1,
    ACTIONS(8839), 1,
      aux_sym_number_literal_token2,
    ACTIONS(8833), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(8835), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8841), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5602), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [208238] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(7144), 1,
      anon_sym_requires,
    ACTIONS(7331), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7333), 1,
      anon_sym_DASH_GT,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    STATE(5956), 1,
      sym_trailing_return_type,
    STATE(6177), 1,
      sym__function_attributes_end,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8312), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5948), 2,
      sym__function_postfix,
      sym_requires_clause,
  [208294] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8827), 1,
      sym_identifier,
    ACTIONS(8829), 1,
      anon_sym_LPAREN2,
    ACTIONS(8831), 1,
      anon_sym_defined,
    ACTIONS(8837), 1,
      aux_sym_number_literal_token1,
    ACTIONS(8839), 1,
      aux_sym_number_literal_token2,
    ACTIONS(8833), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(8835), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8841), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5680), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [208338] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8827), 1,
      sym_identifier,
    ACTIONS(8829), 1,
      anon_sym_LPAREN2,
    ACTIONS(8831), 1,
      anon_sym_defined,
    ACTIONS(8837), 1,
      aux_sym_number_literal_token1,
    ACTIONS(8839), 1,
      aux_sym_number_literal_token2,
    ACTIONS(8833), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(8835), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8841), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5677), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [208382] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8827), 1,
      sym_identifier,
    ACTIONS(8829), 1,
      anon_sym_LPAREN2,
    ACTIONS(8831), 1,
      anon_sym_defined,
    ACTIONS(8837), 1,
      aux_sym_number_literal_token1,
    ACTIONS(8839), 1,
      aux_sym_number_literal_token2,
    ACTIONS(8833), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(8835), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8841), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5668), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [208426] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8827), 1,
      sym_identifier,
    ACTIONS(8829), 1,
      anon_sym_LPAREN2,
    ACTIONS(8831), 1,
      anon_sym_defined,
    ACTIONS(8837), 1,
      aux_sym_number_literal_token1,
    ACTIONS(8839), 1,
      aux_sym_number_literal_token2,
    ACTIONS(8833), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(8835), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8841), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5645), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [208470] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(7351), 1,
      sym_identifier,
    ACTIONS(7353), 1,
      anon_sym_LPAREN2,
    ACTIONS(7392), 1,
      anon_sym_STAR,
    ACTIONS(7394), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7396), 1,
      anon_sym_AMP,
    STATE(2295), 1,
      sym__type_declarator,
    STATE(2372), 1,
      sym_pointer_type_declarator,
    STATE(8058), 1,
      sym_ms_based_modifier,
    ACTIONS(7363), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2340), 6,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_primitive_type,
      sym_reference_type_declarator,
  [208520] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(7302), 1,
      anon_sym_DASH_GT,
    ACTIONS(8667), 1,
      anon_sym_LBRACK,
    ACTIONS(8689), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8957), 1,
      anon_sym_requires,
    STATE(6082), 1,
      sym__function_attributes_end,
    STATE(6236), 1,
      sym_trailing_return_type,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8665), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(8692), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5771), 2,
      sym__function_postfix,
      sym_requires_clause,
  [208576] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(7302), 1,
      anon_sym_DASH_GT,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    ACTIONS(8545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8698), 1,
      anon_sym_requires,
    STATE(6081), 1,
      sym__function_attributes_end,
    STATE(6237), 1,
      sym_trailing_return_type,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8508), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(8548), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5778), 2,
      sym__function_postfix,
      sym_requires_clause,
  [208632] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8827), 1,
      sym_identifier,
    ACTIONS(8829), 1,
      anon_sym_LPAREN2,
    ACTIONS(8831), 1,
      anon_sym_defined,
    ACTIONS(8837), 1,
      aux_sym_number_literal_token1,
    ACTIONS(8839), 1,
      aux_sym_number_literal_token2,
    ACTIONS(8833), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(8835), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8841), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5686), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [208676] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8775), 1,
      sym_identifier,
    ACTIONS(8779), 1,
      anon_sym_LPAREN2,
    ACTIONS(8781), 1,
      anon_sym_defined,
    ACTIONS(8787), 1,
      aux_sym_number_literal_token1,
    ACTIONS(8789), 1,
      aux_sym_number_literal_token2,
    ACTIONS(8783), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(8785), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8791), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5667), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [208720] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(7302), 1,
      anon_sym_DASH_GT,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8435), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8616), 1,
      anon_sym_requires,
    STATE(6079), 1,
      sym__function_attributes_end,
    STATE(6245), 1,
      sym_trailing_return_type,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(8312), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(8438), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
  [208776] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(8962), 1,
      anon_sym_LBRACK,
    STATE(4640), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5571), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(8960), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [208814] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8775), 1,
      sym_identifier,
    ACTIONS(8779), 1,
      anon_sym_LPAREN2,
    ACTIONS(8781), 1,
      anon_sym_defined,
    ACTIONS(8787), 1,
      aux_sym_number_literal_token1,
    ACTIONS(8789), 1,
      aux_sym_number_literal_token2,
    ACTIONS(8783), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(8785), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8791), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5525), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [208858] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(7144), 1,
      anon_sym_requires,
    ACTIONS(7331), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7333), 1,
      anon_sym_DASH_GT,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    STATE(5975), 1,
      sym_trailing_return_type,
    STATE(6172), 1,
      sym__function_attributes_end,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8508), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5911), 2,
      sym__function_postfix,
      sym_requires_clause,
  [208914] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2469), 1,
      anon_sym_LBRACK,
    ACTIONS(7206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8644), 1,
      sym_identifier,
    ACTIONS(8851), 1,
      anon_sym_LPAREN2,
    ACTIONS(8855), 1,
      anon_sym_requires,
    STATE(2421), 1,
      sym_template_type,
    STATE(5748), 1,
      sym_lambda_capture_specifier,
    STATE(6336), 1,
      sym__scope_resolution,
    ACTIONS(8853), 2,
      sym_true,
      sym_false,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5581), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [208966] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(8966), 1,
      anon_sym_LBRACK,
    STATE(4640), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5679), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(8964), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [209004] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8775), 1,
      sym_identifier,
    ACTIONS(8779), 1,
      anon_sym_LPAREN2,
    ACTIONS(8781), 1,
      anon_sym_defined,
    ACTIONS(8787), 1,
      aux_sym_number_literal_token1,
    ACTIONS(8789), 1,
      aux_sym_number_literal_token2,
    ACTIONS(8783), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(8785), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8791), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5509), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [209048] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2469), 1,
      anon_sym_LBRACK,
    ACTIONS(7192), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8627), 1,
      sym_identifier,
    ACTIONS(8907), 1,
      anon_sym_LPAREN2,
    ACTIONS(8911), 1,
      anon_sym_requires,
    STATE(2421), 1,
      sym_template_type,
    STATE(5755), 1,
      sym_lambda_capture_specifier,
    STATE(6371), 1,
      sym__scope_resolution,
    ACTIONS(8927), 2,
      sym_true,
      sym_false,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(1752), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [209100] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(7144), 1,
      anon_sym_requires,
    ACTIONS(7331), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7333), 1,
      anon_sym_DASH_GT,
    ACTIONS(8667), 1,
      anon_sym_LBRACK,
    STATE(5979), 1,
      sym_trailing_return_type,
    STATE(6162), 1,
      sym__function_attributes_end,
    STATE(6518), 1,
      sym_gnu_asm_expression,
    ACTIONS(6921), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(8665), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(5533), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5699), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6005), 2,
      sym__function_postfix,
      sym_requires_clause,
  [209156] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2469), 1,
      anon_sym_LBRACK,
    ACTIONS(7192), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8627), 1,
      sym_identifier,
    ACTIONS(8907), 1,
      anon_sym_LPAREN2,
    ACTIONS(8911), 1,
      anon_sym_requires,
    STATE(2421), 1,
      sym_template_type,
    STATE(5755), 1,
      sym_lambda_capture_specifier,
    STATE(6371), 1,
      sym__scope_resolution,
    ACTIONS(8968), 2,
      sym_true,
      sym_false,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5673), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [209208] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8775), 1,
      sym_identifier,
    ACTIONS(8779), 1,
      anon_sym_LPAREN2,
    ACTIONS(8781), 1,
      anon_sym_defined,
    ACTIONS(8787), 1,
      aux_sym_number_literal_token1,
    ACTIONS(8789), 1,
      aux_sym_number_literal_token2,
    ACTIONS(8783), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(8785), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8791), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5511), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [209252] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8775), 1,
      sym_identifier,
    ACTIONS(8779), 1,
      anon_sym_LPAREN2,
    ACTIONS(8781), 1,
      anon_sym_defined,
    ACTIONS(8787), 1,
      aux_sym_number_literal_token1,
    ACTIONS(8789), 1,
      aux_sym_number_literal_token2,
    ACTIONS(8783), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(8785), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8791), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5514), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [209296] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8775), 1,
      sym_identifier,
    ACTIONS(8779), 1,
      anon_sym_LPAREN2,
    ACTIONS(8781), 1,
      anon_sym_defined,
    ACTIONS(8787), 1,
      aux_sym_number_literal_token1,
    ACTIONS(8789), 1,
      aux_sym_number_literal_token2,
    ACTIONS(8783), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(8785), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8791), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5534), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [209340] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8775), 1,
      sym_identifier,
    ACTIONS(8779), 1,
      anon_sym_LPAREN2,
    ACTIONS(8781), 1,
      anon_sym_defined,
    ACTIONS(8787), 1,
      aux_sym_number_literal_token1,
    ACTIONS(8789), 1,
      aux_sym_number_literal_token2,
    ACTIONS(8783), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(8785), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8791), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5518), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [209384] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8775), 1,
      sym_identifier,
    ACTIONS(8779), 1,
      anon_sym_LPAREN2,
    ACTIONS(8781), 1,
      anon_sym_defined,
    ACTIONS(8787), 1,
      aux_sym_number_literal_token1,
    ACTIONS(8789), 1,
      aux_sym_number_literal_token2,
    ACTIONS(8783), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(8785), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8791), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5530), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [209428] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8972), 1,
      anon_sym_LPAREN2,
    STATE(5546), 1,
      sym_preproc_argument_list,
    ACTIONS(8974), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8970), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [209462] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8775), 1,
      sym_identifier,
    ACTIONS(8779), 1,
      anon_sym_LPAREN2,
    ACTIONS(8781), 1,
      anon_sym_defined,
    ACTIONS(8787), 1,
      aux_sym_number_literal_token1,
    ACTIONS(8789), 1,
      aux_sym_number_literal_token2,
    ACTIONS(8783), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(8785), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8791), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5549), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [209506] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8775), 1,
      sym_identifier,
    ACTIONS(8779), 1,
      anon_sym_LPAREN2,
    ACTIONS(8781), 1,
      anon_sym_defined,
    ACTIONS(8787), 1,
      aux_sym_number_literal_token1,
    ACTIONS(8789), 1,
      aux_sym_number_literal_token2,
    ACTIONS(8783), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(8785), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8791), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5542), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [209550] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    ACTIONS(7365), 1,
      anon_sym_STAR,
    ACTIONS(7367), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7369), 1,
      anon_sym_AMP,
    STATE(3569), 1,
      sym_parameter_list,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(6092), 1,
      sym__abstract_declarator,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7524), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [209596] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8827), 1,
      sym_identifier,
    ACTIONS(8829), 1,
      anon_sym_LPAREN2,
    ACTIONS(8831), 1,
      anon_sym_defined,
    ACTIONS(8837), 1,
      aux_sym_number_literal_token1,
    ACTIONS(8839), 1,
      aux_sym_number_literal_token2,
    ACTIONS(8833), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(8835), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8841), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5626), 8,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_number_literal,
      sym_char_literal,
  [209640] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2469), 1,
      anon_sym_LBRACK,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8633), 1,
      sym_identifier,
    ACTIONS(8738), 1,
      anon_sym_requires,
    ACTIONS(8861), 1,
      anon_sym_LPAREN2,
    STATE(1901), 1,
      sym_template_type,
    STATE(5736), 1,
      sym_lambda_capture_specifier,
    STATE(6373), 1,
      sym__scope_resolution,
    ACTIONS(8976), 2,
      sym_true,
      sym_false,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6341), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [209692] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5811), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8410), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8635), 1,
      sym_identifier,
    STATE(2692), 1,
      sym_template_type,
    STATE(2864), 1,
      sym_field_declaration_list,
    STATE(3044), 1,
      sym__class_declaration_item,
    STATE(6348), 1,
      sym__scope_resolution,
    STATE(6711), 1,
      sym_virtual_specifier,
    STATE(7352), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2478), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5481), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [209751] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(6138), 1,
      anon_sym_LBRACE,
    ACTIONS(8376), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8654), 1,
      sym_identifier,
    STATE(2857), 1,
      sym_template_type,
    STATE(3067), 1,
      sym_field_declaration_list,
    STATE(3532), 1,
      sym__class_declaration_item,
    STATE(6349), 1,
      sym__scope_resolution,
    STATE(6825), 1,
      sym_virtual_specifier,
    STATE(7392), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2659), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [209810] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5575), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8340), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8639), 1,
      sym_identifier,
    STATE(1901), 1,
      sym_template_type,
    STATE(1969), 1,
      sym__class_declaration_item,
    STATE(2584), 1,
      sym_field_declaration_list,
    STATE(6337), 1,
      sym__scope_resolution,
    STATE(6813), 1,
      sym_virtual_specifier,
    STATE(7307), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2357), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5439), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [209869] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(6905), 1,
      anon_sym_LBRACE,
    ACTIONS(8354), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8646), 1,
      sym_identifier,
    STATE(3780), 1,
      sym_template_type,
    STATE(3960), 1,
      sym_field_declaration_list,
    STATE(4061), 1,
      sym__class_declaration_item,
    STATE(6377), 1,
      sym__scope_resolution,
    STATE(6754), 1,
      sym_virtual_specifier,
    STATE(7421), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3316), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [209928] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4627), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8631), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(2657), 1,
      sym__class_declaration_item,
    STATE(3112), 1,
      sym_field_declaration_list,
    STATE(6346), 1,
      sym__scope_resolution,
    STATE(6695), 1,
      sym_virtual_specifier,
    STATE(7449), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2596), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [209987] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7148), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8157), 1,
      anon_sym_LBRACE,
    ACTIONS(8627), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(4797), 1,
      sym_field_declaration_list,
    STATE(4814), 1,
      sym__class_declaration_item,
    STATE(6355), 1,
      sym__scope_resolution,
    STATE(6735), 1,
      sym_virtual_specifier,
    STATE(7438), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4531), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [210046] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7148), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8627), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(2695), 1,
      sym__class_declaration_item,
    STATE(3924), 1,
      sym_field_declaration_list,
    STATE(6355), 1,
      sym__scope_resolution,
    STATE(6755), 1,
      sym_virtual_specifier,
    STATE(7484), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3438), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5431), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [210105] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5968), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8466), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8650), 1,
      sym_identifier,
    STATE(2743), 1,
      sym_template_type,
    STATE(2920), 1,
      sym_field_declaration_list,
    STATE(3094), 1,
      sym__class_declaration_item,
    STATE(6368), 1,
      sym__scope_resolution,
    STATE(6855), 1,
      sym_virtual_specifier,
    STATE(7569), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2561), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5423), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [210164] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4627), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8631), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(2632), 1,
      sym__class_declaration_item,
    STATE(3112), 1,
      sym_field_declaration_list,
    STATE(6346), 1,
      sym__scope_resolution,
    STATE(6695), 1,
      sym_virtual_specifier,
    STATE(7449), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2596), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [210223] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5968), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8466), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8650), 1,
      sym_identifier,
    STATE(2743), 1,
      sym_template_type,
    STATE(2920), 1,
      sym_field_declaration_list,
    STATE(3099), 1,
      sym__class_declaration_item,
    STATE(6368), 1,
      sym__scope_resolution,
    STATE(6855), 1,
      sym_virtual_specifier,
    STATE(7569), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2561), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [210282] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(6905), 1,
      anon_sym_LBRACE,
    ACTIONS(8354), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8646), 1,
      sym_identifier,
    STATE(3780), 1,
      sym_template_type,
    STATE(3960), 1,
      sym_field_declaration_list,
    STATE(4086), 1,
      sym__class_declaration_item,
    STATE(6377), 1,
      sym__scope_resolution,
    STATE(6754), 1,
      sym_virtual_specifier,
    STATE(7421), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3316), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [210341] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(6905), 1,
      anon_sym_LBRACE,
    ACTIONS(8354), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8646), 1,
      sym_identifier,
    STATE(3780), 1,
      sym_template_type,
    STATE(3960), 1,
      sym_field_declaration_list,
    STATE(4094), 1,
      sym__class_declaration_item,
    STATE(6377), 1,
      sym__scope_resolution,
    STATE(6754), 1,
      sym_virtual_specifier,
    STATE(7421), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3316), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5444), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [210400] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5968), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8466), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8650), 1,
      sym_identifier,
    STATE(2743), 1,
      sym_template_type,
    STATE(2920), 1,
      sym_field_declaration_list,
    STATE(3154), 1,
      sym__class_declaration_item,
    STATE(6368), 1,
      sym__scope_resolution,
    STATE(6855), 1,
      sym_virtual_specifier,
    STATE(7569), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2561), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [210459] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8631), 1,
      sym_identifier,
    ACTIONS(8661), 1,
      anon_sym_COLON_COLON,
    STATE(2421), 1,
      sym_template_type,
    STATE(2705), 1,
      sym__class_declaration_item,
    STATE(3112), 1,
      sym_field_declaration_list,
    STATE(6356), 1,
      sym__scope_resolution,
    STATE(6695), 1,
      sym_virtual_specifier,
    STATE(7449), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4002), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5438), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [210518] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5575), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8633), 1,
      sym_identifier,
    STATE(1901), 1,
      sym_template_type,
    STATE(1943), 1,
      sym__class_declaration_item,
    STATE(2584), 1,
      sym_field_declaration_list,
    STATE(6373), 1,
      sym__scope_resolution,
    STATE(6813), 1,
      sym_virtual_specifier,
    STATE(7307), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2357), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [210577] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5968), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8466), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8650), 1,
      sym_identifier,
    STATE(2743), 1,
      sym_template_type,
    STATE(2920), 1,
      sym_field_declaration_list,
    STATE(3168), 1,
      sym__class_declaration_item,
    STATE(6368), 1,
      sym__scope_resolution,
    STATE(6855), 1,
      sym_virtual_specifier,
    STATE(7569), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2561), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5428), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [210636] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7148), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8157), 1,
      anon_sym_LBRACE,
    ACTIONS(8627), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(4797), 1,
      sym_field_declaration_list,
    STATE(4902), 1,
      sym__class_declaration_item,
    STATE(6355), 1,
      sym__scope_resolution,
    STATE(6735), 1,
      sym_virtual_specifier,
    STATE(7438), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4531), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5468), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [210695] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5968), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8466), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8650), 1,
      sym_identifier,
    STATE(2743), 1,
      sym_template_type,
    STATE(2920), 1,
      sym_field_declaration_list,
    STATE(3098), 1,
      sym__class_declaration_item,
    STATE(6368), 1,
      sym__scope_resolution,
    STATE(6855), 1,
      sym_virtual_specifier,
    STATE(7569), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2561), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [210754] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4627), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8631), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(2695), 1,
      sym__class_declaration_item,
    STATE(3112), 1,
      sym_field_declaration_list,
    STATE(6346), 1,
      sym__scope_resolution,
    STATE(6695), 1,
      sym_virtual_specifier,
    STATE(7449), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2596), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5465), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [210813] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(133), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(4849), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7371), 1,
      anon_sym_STAR,
    ACTIONS(8978), 1,
      sym_identifier,
    ACTIONS(8980), 1,
      anon_sym_template,
    STATE(2846), 1,
      sym_pointer_type_declarator,
    STATE(2850), 1,
      sym_template_function,
    STATE(2851), 1,
      sym_destructor_name,
    STATE(2863), 1,
      sym_operator_name,
    STATE(2865), 1,
      sym_dependent_identifier,
    STATE(2871), 1,
      sym_qualified_identifier,
    STATE(5430), 1,
      sym__scope_resolution,
    STATE(6801), 1,
      sym_operator_cast,
    STATE(6832), 1,
      sym_qualified_operator_cast_identifier,
    STATE(7781), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [210876] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7148), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8627), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(2653), 1,
      sym__class_declaration_item,
    STATE(3924), 1,
      sym_field_declaration_list,
    STATE(6355), 1,
      sym__scope_resolution,
    STATE(6755), 1,
      sym_virtual_specifier,
    STATE(7484), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3438), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [210935] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8631), 1,
      sym_identifier,
    ACTIONS(8661), 1,
      anon_sym_COLON_COLON,
    STATE(2421), 1,
      sym_template_type,
    STATE(2653), 1,
      sym__class_declaration_item,
    STATE(3112), 1,
      sym_field_declaration_list,
    STATE(6356), 1,
      sym__scope_resolution,
    STATE(6695), 1,
      sym_virtual_specifier,
    STATE(7449), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4002), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [210994] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7148), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8627), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(2705), 1,
      sym__class_declaration_item,
    STATE(3924), 1,
      sym_field_declaration_list,
    STATE(6355), 1,
      sym__scope_resolution,
    STATE(6755), 1,
      sym_virtual_specifier,
    STATE(7484), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3438), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5436), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [211053] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5575), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7128), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8629), 1,
      sym_identifier,
    STATE(1901), 1,
      sym_template_type,
    STATE(1966), 1,
      sym__class_declaration_item,
    STATE(4991), 1,
      sym_field_declaration_list,
    STATE(6365), 1,
      sym__scope_resolution,
    STATE(6725), 1,
      sym_virtual_specifier,
    STATE(7378), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4629), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5490), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [211112] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5575), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7128), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8629), 1,
      sym_identifier,
    STATE(1901), 1,
      sym_template_type,
    STATE(1943), 1,
      sym__class_declaration_item,
    STATE(4991), 1,
      sym_field_declaration_list,
    STATE(6365), 1,
      sym__scope_resolution,
    STATE(6725), 1,
      sym_virtual_specifier,
    STATE(7378), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4629), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [211171] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7148), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8627), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(2657), 1,
      sym__class_declaration_item,
    STATE(3924), 1,
      sym_field_declaration_list,
    STATE(6355), 1,
      sym__scope_resolution,
    STATE(6755), 1,
      sym_virtual_specifier,
    STATE(7484), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3438), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [211230] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7148), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8157), 1,
      anon_sym_LBRACE,
    ACTIONS(8627), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(4797), 1,
      sym_field_declaration_list,
    STATE(4837), 1,
      sym__class_declaration_item,
    STATE(6355), 1,
      sym__scope_resolution,
    STATE(6735), 1,
      sym_virtual_specifier,
    STATE(7438), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4531), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [211289] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8631), 1,
      sym_identifier,
    ACTIONS(8661), 1,
      anon_sym_COLON_COLON,
    STATE(2421), 1,
      sym_template_type,
    STATE(2657), 1,
      sym__class_declaration_item,
    STATE(3112), 1,
      sym_field_declaration_list,
    STATE(6356), 1,
      sym__scope_resolution,
    STATE(6695), 1,
      sym_virtual_specifier,
    STATE(7449), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4002), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [211348] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5575), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8340), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8639), 1,
      sym_identifier,
    STATE(1901), 1,
      sym_template_type,
    STATE(1978), 1,
      sym__class_declaration_item,
    STATE(2584), 1,
      sym_field_declaration_list,
    STATE(6337), 1,
      sym__scope_resolution,
    STATE(6813), 1,
      sym_virtual_specifier,
    STATE(7307), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2357), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [211407] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5928), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7235), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8663), 1,
      sym_identifier,
    STATE(2739), 1,
      sym_template_type,
    STATE(2769), 1,
      sym_field_declaration_list,
    STATE(2969), 1,
      sym__class_declaration_item,
    STATE(6339), 1,
      sym__scope_resolution,
    STATE(6624), 1,
      sym_virtual_specifier,
    STATE(7527), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2546), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5451), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [211466] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5928), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7235), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8663), 1,
      sym_identifier,
    STATE(2739), 1,
      sym_template_type,
    STATE(2769), 1,
      sym_field_declaration_list,
    STATE(2925), 1,
      sym__class_declaration_item,
    STATE(6339), 1,
      sym__scope_resolution,
    STATE(6624), 1,
      sym_virtual_specifier,
    STATE(7527), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2546), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [211525] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    ACTIONS(7430), 1,
      anon_sym_STAR,
    ACTIONS(7432), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7434), 1,
      anon_sym_AMP,
    STATE(3784), 1,
      sym_parameter_list,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(6194), 1,
      sym__abstract_declarator,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7524), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [211570] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5811), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8410), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8635), 1,
      sym_identifier,
    STATE(2692), 1,
      sym_template_type,
    STATE(2864), 1,
      sym_field_declaration_list,
    STATE(3005), 1,
      sym__class_declaration_item,
    STATE(6348), 1,
      sym__scope_resolution,
    STATE(6711), 1,
      sym_virtual_specifier,
    STATE(7352), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2478), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5499), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [211629] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(6905), 1,
      anon_sym_LBRACE,
    ACTIONS(8354), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8646), 1,
      sym_identifier,
    STATE(3780), 1,
      sym_template_type,
    STATE(3960), 1,
      sym_field_declaration_list,
    STATE(4044), 1,
      sym__class_declaration_item,
    STATE(6377), 1,
      sym__scope_resolution,
    STATE(6754), 1,
      sym_virtual_specifier,
    STATE(7421), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3316), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [211688] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5575), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8340), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8639), 1,
      sym_identifier,
    STATE(1901), 1,
      sym_template_type,
    STATE(1963), 1,
      sym__class_declaration_item,
    STATE(2584), 1,
      sym_field_declaration_list,
    STATE(6337), 1,
      sym__scope_resolution,
    STATE(6813), 1,
      sym_virtual_specifier,
    STATE(7307), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2357), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [211747] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5811), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8410), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8635), 1,
      sym_identifier,
    STATE(2692), 1,
      sym_template_type,
    STATE(2864), 1,
      sym_field_declaration_list,
    STATE(2989), 1,
      sym__class_declaration_item,
    STATE(6348), 1,
      sym__scope_resolution,
    STATE(6711), 1,
      sym_virtual_specifier,
    STATE(7352), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2478), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [211806] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8982), 1,
      anon_sym_COMMA,
    ACTIONS(8984), 1,
      anon_sym_RPAREN,
    ACTIONS(8990), 1,
      anon_sym_SLASH,
    ACTIONS(8992), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8994), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8996), 1,
      anon_sym_PIPE,
    ACTIONS(8998), 1,
      anon_sym_CARET,
    ACTIONS(9000), 1,
      anon_sym_AMP,
    STATE(6978), 1,
      aux_sym_preproc_argument_list_repeat1,
    ACTIONS(8986), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8988), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9002), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9004), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(9008), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [211861] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5575), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8340), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8639), 1,
      sym_identifier,
    STATE(1901), 1,
      sym_template_type,
    STATE(1943), 1,
      sym__class_declaration_item,
    STATE(2584), 1,
      sym_field_declaration_list,
    STATE(6337), 1,
      sym__scope_resolution,
    STATE(6813), 1,
      sym_virtual_specifier,
    STATE(7307), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2357), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [211920] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8637), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(2632), 1,
      sym__class_declaration_item,
    STATE(3112), 1,
      sym_field_declaration_list,
    STATE(6380), 1,
      sym__scope_resolution,
    STATE(6695), 1,
      sym_virtual_specifier,
    STATE(7449), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2596), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [211979] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8637), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(2695), 1,
      sym__class_declaration_item,
    STATE(3112), 1,
      sym_field_declaration_list,
    STATE(6380), 1,
      sym__scope_resolution,
    STATE(6695), 1,
      sym_virtual_specifier,
    STATE(7449), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2596), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5488), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [212038] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5928), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7235), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8663), 1,
      sym_identifier,
    STATE(2739), 1,
      sym_template_type,
    STATE(2769), 1,
      sym_field_declaration_list,
    STATE(2900), 1,
      sym__class_declaration_item,
    STATE(6339), 1,
      sym__scope_resolution,
    STATE(6624), 1,
      sym_virtual_specifier,
    STATE(7527), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2546), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [212097] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5928), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7235), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8663), 1,
      sym_identifier,
    STATE(2739), 1,
      sym_template_type,
    STATE(2769), 1,
      sym_field_declaration_list,
    STATE(2952), 1,
      sym__class_declaration_item,
    STATE(6339), 1,
      sym__scope_resolution,
    STATE(6624), 1,
      sym_virtual_specifier,
    STATE(7527), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2546), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5453), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [212156] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5928), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7235), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8663), 1,
      sym_identifier,
    STATE(2739), 1,
      sym_template_type,
    STATE(2769), 1,
      sym_field_declaration_list,
    STATE(2943), 1,
      sym__class_declaration_item,
    STATE(6339), 1,
      sym__scope_resolution,
    STATE(6624), 1,
      sym_virtual_specifier,
    STATE(7527), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2546), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [212215] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5575), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8340), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8639), 1,
      sym_identifier,
    STATE(1901), 1,
      sym_template_type,
    STATE(1966), 1,
      sym__class_declaration_item,
    STATE(2584), 1,
      sym_field_declaration_list,
    STATE(6337), 1,
      sym__scope_resolution,
    STATE(6813), 1,
      sym_virtual_specifier,
    STATE(7307), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2357), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5445), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [212274] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(6138), 1,
      anon_sym_LBRACE,
    ACTIONS(8376), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8654), 1,
      sym_identifier,
    STATE(2857), 1,
      sym_template_type,
    STATE(3067), 1,
      sym_field_declaration_list,
    STATE(3486), 1,
      sym__class_declaration_item,
    STATE(6349), 1,
      sym__scope_resolution,
    STATE(6825), 1,
      sym_virtual_specifier,
    STATE(7392), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2659), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [212333] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5575), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8633), 1,
      sym_identifier,
    STATE(1901), 1,
      sym_template_type,
    STATE(1978), 1,
      sym__class_declaration_item,
    STATE(2584), 1,
      sym_field_declaration_list,
    STATE(6373), 1,
      sym__scope_resolution,
    STATE(6813), 1,
      sym_virtual_specifier,
    STATE(7307), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2357), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [212392] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5575), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7128), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8629), 1,
      sym_identifier,
    STATE(1901), 1,
      sym_template_type,
    STATE(1978), 1,
      sym__class_declaration_item,
    STATE(4991), 1,
      sym_field_declaration_list,
    STATE(6365), 1,
      sym__scope_resolution,
    STATE(6725), 1,
      sym_virtual_specifier,
    STATE(7378), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4629), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [212451] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(6138), 1,
      anon_sym_LBRACE,
    ACTIONS(8376), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8654), 1,
      sym_identifier,
    STATE(2857), 1,
      sym_template_type,
    STATE(3067), 1,
      sym_field_declaration_list,
    STATE(3524), 1,
      sym__class_declaration_item,
    STATE(6349), 1,
      sym__scope_resolution,
    STATE(6825), 1,
      sym_virtual_specifier,
    STATE(7392), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2659), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5455), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [212510] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8644), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(2695), 1,
      sym__class_declaration_item,
    STATE(3924), 1,
      sym_field_declaration_list,
    STATE(6336), 1,
      sym__scope_resolution,
    STATE(6755), 1,
      sym_virtual_specifier,
    STATE(7484), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3438), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5473), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [212569] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8631), 1,
      sym_identifier,
    ACTIONS(8661), 1,
      anon_sym_COLON_COLON,
    STATE(2421), 1,
      sym_template_type,
    STATE(2695), 1,
      sym__class_declaration_item,
    STATE(3112), 1,
      sym_field_declaration_list,
    STATE(6356), 1,
      sym__scope_resolution,
    STATE(6695), 1,
      sym_virtual_specifier,
    STATE(7449), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4002), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5432), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [212628] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8982), 1,
      anon_sym_COMMA,
    ACTIONS(8990), 1,
      anon_sym_SLASH,
    ACTIONS(8992), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8994), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8996), 1,
      anon_sym_PIPE,
    ACTIONS(8998), 1,
      anon_sym_CARET,
    ACTIONS(9000), 1,
      anon_sym_AMP,
    ACTIONS(9010), 1,
      anon_sym_RPAREN,
    STATE(6980), 1,
      aux_sym_preproc_argument_list_repeat1,
    ACTIONS(8986), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8988), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9002), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9004), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(9008), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [212683] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(6138), 1,
      anon_sym_LBRACE,
    ACTIONS(8376), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8654), 1,
      sym_identifier,
    STATE(2857), 1,
      sym_template_type,
    STATE(3067), 1,
      sym_field_declaration_list,
    STATE(3466), 1,
      sym__class_declaration_item,
    STATE(6349), 1,
      sym__scope_resolution,
    STATE(6825), 1,
      sym_virtual_specifier,
    STATE(7392), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2659), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [212742] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(6138), 1,
      anon_sym_LBRACE,
    ACTIONS(8376), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8654), 1,
      sym_identifier,
    STATE(2857), 1,
      sym_template_type,
    STATE(3067), 1,
      sym_field_declaration_list,
    STATE(3461), 1,
      sym__class_declaration_item,
    STATE(6349), 1,
      sym__scope_resolution,
    STATE(6825), 1,
      sym_virtual_specifier,
    STATE(7392), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2659), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5412), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [212801] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8644), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(2632), 1,
      sym__class_declaration_item,
    STATE(3924), 1,
      sym_field_declaration_list,
    STATE(6336), 1,
      sym__scope_resolution,
    STATE(6755), 1,
      sym_virtual_specifier,
    STATE(7484), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3438), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [212860] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4627), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8631), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(2653), 1,
      sym__class_declaration_item,
    STATE(3112), 1,
      sym_field_declaration_list,
    STATE(6346), 1,
      sym__scope_resolution,
    STATE(6695), 1,
      sym_virtual_specifier,
    STATE(7449), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2596), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [212919] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9014), 1,
      anon_sym_LBRACK,
    ACTIONS(9012), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [212948] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8157), 1,
      anon_sym_LBRACE,
    ACTIONS(8644), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(4797), 1,
      sym_field_declaration_list,
    STATE(4902), 1,
      sym__class_declaration_item,
    STATE(6336), 1,
      sym__scope_resolution,
    STATE(6735), 1,
      sym_virtual_specifier,
    STATE(7438), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4531), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5486), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [213007] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7148), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8157), 1,
      anon_sym_LBRACE,
    ACTIONS(8627), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(4797), 1,
      sym_field_declaration_list,
    STATE(4834), 1,
      sym__class_declaration_item,
    STATE(6355), 1,
      sym__scope_resolution,
    STATE(6735), 1,
      sym_virtual_specifier,
    STATE(7438), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4531), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [213066] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4908), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8446), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8652), 1,
      sym_identifier,
    STATE(2051), 1,
      sym_template_type,
    STATE(2304), 1,
      sym_field_declaration_list,
    STATE(2353), 1,
      sym__class_declaration_item,
    STATE(6383), 1,
      sym__scope_resolution,
    STATE(6713), 1,
      sym_virtual_specifier,
    STATE(7381), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(1855), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5492), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [213125] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8157), 1,
      anon_sym_LBRACE,
    ACTIONS(8644), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(4797), 1,
      sym_field_declaration_list,
    STATE(4837), 1,
      sym__class_declaration_item,
    STATE(6336), 1,
      sym__scope_resolution,
    STATE(6735), 1,
      sym_virtual_specifier,
    STATE(7438), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4531), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [213184] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7148), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8627), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(2632), 1,
      sym__class_declaration_item,
    STATE(3924), 1,
      sym_field_declaration_list,
    STATE(6355), 1,
      sym__scope_resolution,
    STATE(6755), 1,
      sym_virtual_specifier,
    STATE(7484), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3438), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [213243] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4908), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8446), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8652), 1,
      sym_identifier,
    STATE(2051), 1,
      sym_template_type,
    STATE(2304), 1,
      sym_field_declaration_list,
    STATE(2339), 1,
      sym__class_declaration_item,
    STATE(6383), 1,
      sym__scope_resolution,
    STATE(6713), 1,
      sym_virtual_specifier,
    STATE(7381), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(1855), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [213302] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8644), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(2653), 1,
      sym__class_declaration_item,
    STATE(3924), 1,
      sym_field_declaration_list,
    STATE(6336), 1,
      sym__scope_resolution,
    STATE(6755), 1,
      sym_virtual_specifier,
    STATE(7484), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3438), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [213361] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8644), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(2657), 1,
      sym__class_declaration_item,
    STATE(3924), 1,
      sym_field_declaration_list,
    STATE(6336), 1,
      sym__scope_resolution,
    STATE(6755), 1,
      sym_virtual_specifier,
    STATE(7484), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3438), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [213420] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8644), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(2705), 1,
      sym__class_declaration_item,
    STATE(3924), 1,
      sym_field_declaration_list,
    STATE(6336), 1,
      sym__scope_resolution,
    STATE(6755), 1,
      sym_virtual_specifier,
    STATE(7484), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3438), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5474), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [213479] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4627), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8631), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(2705), 1,
      sym__class_declaration_item,
    STATE(3112), 1,
      sym_field_declaration_list,
    STATE(6346), 1,
      sym__scope_resolution,
    STATE(6695), 1,
      sym_virtual_specifier,
    STATE(7449), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2596), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5415), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [213538] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7170), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8332), 1,
      anon_sym_LBRACE,
    ACTIONS(8648), 1,
      sym_identifier,
    STATE(4697), 1,
      sym_template_type,
    STATE(4914), 1,
      sym_field_declaration_list,
    STATE(5005), 1,
      sym__class_declaration_item,
    STATE(6342), 1,
      sym__scope_resolution,
    STATE(6797), 1,
      sym_virtual_specifier,
    STATE(7487), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4727), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5480), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [213597] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7170), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8332), 1,
      anon_sym_LBRACE,
    ACTIONS(8648), 1,
      sym_identifier,
    STATE(4697), 1,
      sym_template_type,
    STATE(4914), 1,
      sym_field_declaration_list,
    STATE(4990), 1,
      sym__class_declaration_item,
    STATE(6342), 1,
      sym__scope_resolution,
    STATE(6797), 1,
      sym_virtual_specifier,
    STATE(7487), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4727), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [213656] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8982), 1,
      anon_sym_COMMA,
    ACTIONS(8990), 1,
      anon_sym_SLASH,
    ACTIONS(8992), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8994), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8996), 1,
      anon_sym_PIPE,
    ACTIONS(8998), 1,
      anon_sym_CARET,
    ACTIONS(9000), 1,
      anon_sym_AMP,
    ACTIONS(9016), 1,
      anon_sym_RPAREN,
    STATE(6972), 1,
      aux_sym_preproc_argument_list_repeat1,
    ACTIONS(8986), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8988), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9002), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9004), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(9008), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [213711] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7170), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8332), 1,
      anon_sym_LBRACE,
    ACTIONS(8648), 1,
      sym_identifier,
    STATE(4697), 1,
      sym_template_type,
    STATE(4914), 1,
      sym_field_declaration_list,
    STATE(5008), 1,
      sym__class_declaration_item,
    STATE(6342), 1,
      sym__scope_resolution,
    STATE(6797), 1,
      sym_virtual_specifier,
    STATE(7487), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4727), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [213770] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5811), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8410), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8635), 1,
      sym_identifier,
    STATE(2692), 1,
      sym_template_type,
    STATE(2864), 1,
      sym_field_declaration_list,
    STATE(2976), 1,
      sym__class_declaration_item,
    STATE(6348), 1,
      sym__scope_resolution,
    STATE(6711), 1,
      sym_virtual_specifier,
    STATE(7352), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2478), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [213829] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5575), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8633), 1,
      sym_identifier,
    STATE(1901), 1,
      sym_template_type,
    STATE(1966), 1,
      sym__class_declaration_item,
    STATE(2584), 1,
      sym_field_declaration_list,
    STATE(6373), 1,
      sym__scope_resolution,
    STATE(6813), 1,
      sym_virtual_specifier,
    STATE(7307), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2357), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5494), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [213888] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4908), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8446), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8652), 1,
      sym_identifier,
    STATE(2051), 1,
      sym_template_type,
    STATE(2304), 1,
      sym_field_declaration_list,
    STATE(2319), 1,
      sym__class_declaration_item,
    STATE(6383), 1,
      sym__scope_resolution,
    STATE(6713), 1,
      sym_virtual_specifier,
    STATE(7381), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(1855), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [213947] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(6905), 1,
      anon_sym_LBRACE,
    ACTIONS(8354), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8646), 1,
      sym_identifier,
    STATE(3780), 1,
      sym_template_type,
    STATE(3960), 1,
      sym_field_declaration_list,
    STATE(4068), 1,
      sym__class_declaration_item,
    STATE(6377), 1,
      sym__scope_resolution,
    STATE(6754), 1,
      sym_virtual_specifier,
    STATE(7421), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3316), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5421), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [214006] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4908), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8446), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8652), 1,
      sym_identifier,
    STATE(2051), 1,
      sym_template_type,
    STATE(2304), 1,
      sym_field_declaration_list,
    STATE(2320), 1,
      sym__class_declaration_item,
    STATE(6383), 1,
      sym__scope_resolution,
    STATE(6713), 1,
      sym_virtual_specifier,
    STATE(7381), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(1855), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5483), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [214065] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8157), 1,
      anon_sym_LBRACE,
    ACTIONS(8644), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(4797), 1,
      sym_field_declaration_list,
    STATE(4834), 1,
      sym__class_declaration_item,
    STATE(6336), 1,
      sym__scope_resolution,
    STATE(6735), 1,
      sym_virtual_specifier,
    STATE(7438), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4531), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [214124] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8157), 1,
      anon_sym_LBRACE,
    ACTIONS(8644), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(4797), 1,
      sym_field_declaration_list,
    STATE(4878), 1,
      sym__class_declaration_item,
    STATE(6336), 1,
      sym__scope_resolution,
    STATE(6735), 1,
      sym_virtual_specifier,
    STATE(7438), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4531), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5493), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [214183] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8637), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(2653), 1,
      sym__class_declaration_item,
    STATE(3112), 1,
      sym_field_declaration_list,
    STATE(6380), 1,
      sym__scope_resolution,
    STATE(6695), 1,
      sym_virtual_specifier,
    STATE(7449), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2596), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [214242] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5575), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7128), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8629), 1,
      sym_identifier,
    STATE(1901), 1,
      sym_template_type,
    STATE(1969), 1,
      sym__class_declaration_item,
    STATE(4991), 1,
      sym_field_declaration_list,
    STATE(6365), 1,
      sym__scope_resolution,
    STATE(6725), 1,
      sym_virtual_specifier,
    STATE(7378), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4629), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5457), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [214301] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5575), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7128), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8629), 1,
      sym_identifier,
    STATE(1901), 1,
      sym_template_type,
    STATE(1963), 1,
      sym__class_declaration_item,
    STATE(4991), 1,
      sym_field_declaration_list,
    STATE(6365), 1,
      sym__scope_resolution,
    STATE(6725), 1,
      sym_virtual_specifier,
    STATE(7378), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4629), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [214360] = 5,
    ACTIONS(8970), 1,
      anon_sym_LF,
    ACTIONS(9018), 1,
      anon_sym_LPAREN2,
    ACTIONS(9020), 1,
      sym_comment,
    STATE(5627), 1,
      sym_preproc_argument_list,
    ACTIONS(8974), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [214393] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4908), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8446), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8652), 1,
      sym_identifier,
    STATE(2051), 1,
      sym_template_type,
    STATE(2304), 1,
      sym_field_declaration_list,
    STATE(2378), 1,
      sym__class_declaration_item,
    STATE(6383), 1,
      sym__scope_resolution,
    STATE(6713), 1,
      sym_virtual_specifier,
    STATE(7381), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(1855), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [214452] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8157), 1,
      anon_sym_LBRACE,
    ACTIONS(8644), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(4797), 1,
      sym_field_declaration_list,
    STATE(4814), 1,
      sym__class_declaration_item,
    STATE(6336), 1,
      sym__scope_resolution,
    STATE(6735), 1,
      sym_virtual_specifier,
    STATE(7438), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4531), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [214511] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5575), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8633), 1,
      sym_identifier,
    STATE(1901), 1,
      sym_template_type,
    STATE(1963), 1,
      sym__class_declaration_item,
    STATE(2584), 1,
      sym_field_declaration_list,
    STATE(6373), 1,
      sym__scope_resolution,
    STATE(6813), 1,
      sym_virtual_specifier,
    STATE(7307), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2357), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [214570] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8637), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(2657), 1,
      sym__class_declaration_item,
    STATE(3112), 1,
      sym_field_declaration_list,
    STATE(6380), 1,
      sym__scope_resolution,
    STATE(6695), 1,
      sym_virtual_specifier,
    STATE(7449), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2596), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [214629] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5928), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8396), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8656), 1,
      sym_identifier,
    STATE(2739), 1,
      sym_template_type,
    STATE(2769), 1,
      sym_field_declaration_list,
    STATE(2969), 1,
      sym__class_declaration_item,
    STATE(6376), 1,
      sym__scope_resolution,
    STATE(6624), 1,
      sym_virtual_specifier,
    STATE(7527), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2546), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5500), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [214688] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5928), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8396), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8656), 1,
      sym_identifier,
    STATE(2739), 1,
      sym_template_type,
    STATE(2769), 1,
      sym_field_declaration_list,
    STATE(2925), 1,
      sym__class_declaration_item,
    STATE(6376), 1,
      sym__scope_resolution,
    STATE(6624), 1,
      sym_virtual_specifier,
    STATE(7527), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2546), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [214747] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7148), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8157), 1,
      anon_sym_LBRACE,
    ACTIONS(8627), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(4797), 1,
      sym_field_declaration_list,
    STATE(4878), 1,
      sym__class_declaration_item,
    STATE(6355), 1,
      sym__scope_resolution,
    STATE(6735), 1,
      sym_virtual_specifier,
    STATE(7438), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4531), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5416), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [214806] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5811), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8410), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8635), 1,
      sym_identifier,
    STATE(2692), 1,
      sym_template_type,
    STATE(2864), 1,
      sym_field_declaration_list,
    STATE(3054), 1,
      sym__class_declaration_item,
    STATE(6348), 1,
      sym__scope_resolution,
    STATE(6711), 1,
      sym_virtual_specifier,
    STATE(7352), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2478), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [214865] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5928), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8396), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8656), 1,
      sym_identifier,
    STATE(2739), 1,
      sym_template_type,
    STATE(2769), 1,
      sym_field_declaration_list,
    STATE(2900), 1,
      sym__class_declaration_item,
    STATE(6376), 1,
      sym__scope_resolution,
    STATE(6624), 1,
      sym_virtual_specifier,
    STATE(7527), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2546), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [214924] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5928), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8396), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8656), 1,
      sym_identifier,
    STATE(2739), 1,
      sym_template_type,
    STATE(2769), 1,
      sym_field_declaration_list,
    STATE(2952), 1,
      sym__class_declaration_item,
    STATE(6376), 1,
      sym__scope_resolution,
    STATE(6624), 1,
      sym_virtual_specifier,
    STATE(7527), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2546), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5505), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [214983] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5575), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8633), 1,
      sym_identifier,
    STATE(1901), 1,
      sym_template_type,
    STATE(1969), 1,
      sym__class_declaration_item,
    STATE(2584), 1,
      sym_field_declaration_list,
    STATE(6373), 1,
      sym__scope_resolution,
    STATE(6813), 1,
      sym_virtual_specifier,
    STATE(7307), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2357), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5456), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [215042] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7170), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8332), 1,
      anon_sym_LBRACE,
    ACTIONS(8648), 1,
      sym_identifier,
    STATE(4697), 1,
      sym_template_type,
    STATE(4914), 1,
      sym_field_declaration_list,
    STATE(5045), 1,
      sym__class_declaration_item,
    STATE(6342), 1,
      sym__scope_resolution,
    STATE(6797), 1,
      sym_virtual_specifier,
    STATE(7487), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4727), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [215101] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(7170), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8332), 1,
      anon_sym_LBRACE,
    ACTIONS(8648), 1,
      sym_identifier,
    STATE(4697), 1,
      sym_template_type,
    STATE(4914), 1,
      sym_field_declaration_list,
    STATE(5014), 1,
      sym__class_declaration_item,
    STATE(6342), 1,
      sym__scope_resolution,
    STATE(6797), 1,
      sym_virtual_specifier,
    STATE(7487), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4727), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5503), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [215160] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5928), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8396), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8656), 1,
      sym_identifier,
    STATE(2739), 1,
      sym_template_type,
    STATE(2769), 1,
      sym_field_declaration_list,
    STATE(2943), 1,
      sym__class_declaration_item,
    STATE(6376), 1,
      sym__scope_resolution,
    STATE(6624), 1,
      sym_virtual_specifier,
    STATE(7527), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2546), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [215219] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8637), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(2705), 1,
      sym__class_declaration_item,
    STATE(3112), 1,
      sym_field_declaration_list,
    STATE(6380), 1,
      sym__scope_resolution,
    STATE(6695), 1,
      sym_virtual_specifier,
    STATE(7449), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2596), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5495), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [215278] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    ACTIONS(6044), 1,
      anon_sym_COLON,
    ACTIONS(8631), 1,
      sym_identifier,
    ACTIONS(8661), 1,
      anon_sym_COLON_COLON,
    STATE(2421), 1,
      sym_template_type,
    STATE(2632), 1,
      sym__class_declaration_item,
    STATE(3112), 1,
      sym_field_declaration_list,
    STATE(6356), 1,
      sym__scope_resolution,
    STATE(6695), 1,
      sym_virtual_specifier,
    STATE(7449), 1,
      sym_base_class_clause,
    ACTIONS(4912), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4002), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [215337] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8817), 1,
      anon_sym_try,
    ACTIONS(9022), 1,
      anon_sym_COMMA,
    ACTIONS(9024), 1,
      anon_sym_LPAREN2,
    ACTIONS(9026), 1,
      anon_sym_SEMI,
    ACTIONS(9028), 1,
      anon_sym_LBRACE,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    ACTIONS(9032), 1,
      anon_sym_EQ,
    STATE(1890), 1,
      sym_try_statement,
    STATE(1891), 1,
      sym_compound_statement,
    STATE(3630), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6983), 1,
      aux_sym_declaration_repeat1,
    STATE(6989), 1,
      sym_gnu_asm_expression,
    ACTIONS(9034), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7549), 2,
      sym_argument_list,
      sym_initializer_list,
  [215395] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8990), 1,
      anon_sym_SLASH,
    ACTIONS(8986), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8988), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9008), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9038), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9036), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [215431] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6299), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(6301), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [215459] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8990), 1,
      anon_sym_SLASH,
    ACTIONS(8986), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8988), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9004), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(9008), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9038), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(9036), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [215499] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(7339), 1,
      anon_sym_STAR,
    ACTIONS(9040), 1,
      sym_identifier,
    ACTIONS(9042), 1,
      anon_sym_TILDE,
    ACTIONS(9044), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9046), 1,
      anon_sym_template,
    ACTIONS(9048), 1,
      anon_sym_operator,
    STATE(2403), 1,
      sym_qualified_type_identifier,
    STATE(2408), 1,
      sym_dependent_type_identifier,
    STATE(2422), 1,
      sym_template_type,
    STATE(3553), 1,
      sym_operator_name,
    STATE(3556), 1,
      sym_qualified_identifier,
    STATE(3558), 1,
      sym_dependent_identifier,
    STATE(3559), 1,
      sym_destructor_name,
    STATE(3563), 1,
      sym_template_function,
    STATE(3565), 1,
      sym_pointer_type_declarator,
    STATE(5512), 1,
      sym__scope_resolution,
    STATE(7618), 1,
      sym_ms_based_modifier,
    STATE(8290), 1,
      sym_decltype,
  [215563] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(7392), 1,
      anon_sym_STAR,
    ACTIONS(9050), 1,
      sym_identifier,
    ACTIONS(9052), 1,
      anon_sym_TILDE,
    ACTIONS(9054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9056), 1,
      anon_sym_template,
    ACTIONS(9058), 1,
      anon_sym_operator,
    STATE(2403), 1,
      sym_qualified_type_identifier,
    STATE(2408), 1,
      sym_dependent_type_identifier,
    STATE(2422), 1,
      sym_template_type,
    STATE(2488), 1,
      sym_pointer_type_declarator,
    STATE(2490), 1,
      sym_template_function,
    STATE(2491), 1,
      sym_destructor_name,
    STATE(2492), 1,
      sym_dependent_identifier,
    STATE(2494), 1,
      sym_qualified_identifier,
    STATE(2496), 1,
      sym_operator_name,
    STATE(5513), 1,
      sym__scope_resolution,
    STATE(8058), 1,
      sym_ms_based_modifier,
    STATE(8290), 1,
      sym_decltype,
  [215627] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8990), 1,
      anon_sym_SLASH,
    ACTIONS(8986), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8988), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9002), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9004), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(9008), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9038), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(9036), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [215669] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9062), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9060), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [215697] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(3811), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7371), 1,
      anon_sym_STAR,
    ACTIONS(9064), 1,
      sym_identifier,
    ACTIONS(9066), 1,
      anon_sym_template,
    STATE(2403), 1,
      sym_qualified_type_identifier,
    STATE(2408), 1,
      sym_dependent_type_identifier,
    STATE(2422), 1,
      sym_template_type,
    STATE(2846), 1,
      sym_pointer_type_declarator,
    STATE(2850), 1,
      sym_template_function,
    STATE(2851), 1,
      sym_destructor_name,
    STATE(2863), 1,
      sym_operator_name,
    STATE(2865), 1,
      sym_dependent_identifier,
    STATE(2871), 1,
      sym_qualified_identifier,
    STATE(5516), 1,
      sym__scope_resolution,
    STATE(7781), 1,
      sym_ms_based_modifier,
    STATE(8290), 1,
      sym_decltype,
  [215761] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9022), 1,
      anon_sym_COMMA,
    ACTIONS(9024), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    ACTIONS(9032), 1,
      anon_sym_EQ,
    ACTIONS(9068), 1,
      anon_sym_SEMI,
    ACTIONS(9070), 1,
      anon_sym_LBRACE,
    ACTIONS(9072), 1,
      anon_sym_try,
    STATE(809), 1,
      sym_compound_statement,
    STATE(810), 1,
      sym_try_statement,
    STATE(3630), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6956), 1,
      aux_sym_declaration_repeat1,
    STATE(6957), 1,
      sym_gnu_asm_expression,
    ACTIONS(9034), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7549), 2,
      sym_argument_list,
      sym_initializer_list,
  [215819] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8990), 1,
      anon_sym_SLASH,
    ACTIONS(8998), 1,
      anon_sym_CARET,
    ACTIONS(9000), 1,
      anon_sym_AMP,
    ACTIONS(9038), 1,
      anon_sym_PIPE,
    ACTIONS(8986), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8988), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9002), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9004), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(9008), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9036), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [215865] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(7410), 1,
      anon_sym_STAR,
    ACTIONS(9074), 1,
      sym_identifier,
    ACTIONS(9076), 1,
      anon_sym_TILDE,
    ACTIONS(9078), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9080), 1,
      anon_sym_template,
    ACTIONS(9082), 1,
      anon_sym_operator,
    STATE(2403), 1,
      sym_qualified_type_identifier,
    STATE(2408), 1,
      sym_dependent_type_identifier,
    STATE(2422), 1,
      sym_template_type,
    STATE(3355), 1,
      sym_operator_name,
    STATE(3419), 1,
      sym_pointer_type_declarator,
    STATE(3421), 1,
      sym_template_function,
    STATE(3422), 1,
      sym_destructor_name,
    STATE(3423), 1,
      sym_dependent_identifier,
    STATE(3425), 1,
      sym_qualified_identifier,
    STATE(5519), 1,
      sym__scope_resolution,
    STATE(7901), 1,
      sym_ms_based_modifier,
    STATE(8290), 1,
      sym_decltype,
  [215929] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(7410), 1,
      anon_sym_STAR,
    ACTIONS(9084), 1,
      sym_identifier,
    ACTIONS(9086), 1,
      anon_sym_TILDE,
    ACTIONS(9088), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9090), 1,
      anon_sym_template,
    ACTIONS(9092), 1,
      anon_sym_operator,
    STATE(1865), 1,
      sym_template_type,
    STATE(1869), 1,
      sym_dependent_type_identifier,
    STATE(1987), 1,
      sym_qualified_type_identifier,
    STATE(3334), 1,
      sym_operator_name,
    STATE(3339), 1,
      sym_qualified_identifier,
    STATE(3344), 1,
      sym_pointer_type_declarator,
    STATE(3346), 1,
      sym_template_function,
    STATE(3348), 1,
      sym_destructor_name,
    STATE(3349), 1,
      sym_dependent_identifier,
    STATE(5520), 1,
      sym__scope_resolution,
    STATE(7901), 1,
      sym_ms_based_modifier,
    STATE(8290), 1,
      sym_decltype,
  [215993] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8825), 1,
      anon_sym_try,
    ACTIONS(9022), 1,
      anon_sym_COMMA,
    ACTIONS(9024), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    ACTIONS(9032), 1,
      anon_sym_EQ,
    ACTIONS(9094), 1,
      anon_sym_SEMI,
    ACTIONS(9096), 1,
      anon_sym_LBRACE,
    STATE(2135), 1,
      sym_compound_statement,
    STATE(2136), 1,
      sym_try_statement,
    STATE(3630), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(7181), 1,
      sym_gnu_asm_expression,
    STATE(7190), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(9034), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7549), 2,
      sym_argument_list,
      sym_initializer_list,
  [216051] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(7410), 1,
      anon_sym_STAR,
    ACTIONS(9076), 1,
      anon_sym_TILDE,
    ACTIONS(9082), 1,
      anon_sym_operator,
    ACTIONS(9098), 1,
      sym_identifier,
    ACTIONS(9100), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9102), 1,
      anon_sym_template,
    STATE(1865), 1,
      sym_template_type,
    STATE(1869), 1,
      sym_dependent_type_identifier,
    STATE(1987), 1,
      sym_qualified_type_identifier,
    STATE(3355), 1,
      sym_operator_name,
    STATE(3419), 1,
      sym_pointer_type_declarator,
    STATE(3421), 1,
      sym_template_function,
    STATE(3422), 1,
      sym_destructor_name,
    STATE(3423), 1,
      sym_dependent_identifier,
    STATE(3425), 1,
      sym_qualified_identifier,
    STATE(5522), 1,
      sym__scope_resolution,
    STATE(7901), 1,
      sym_ms_based_modifier,
    STATE(8290), 1,
      sym_decltype,
  [216115] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(4593), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7371), 1,
      anon_sym_STAR,
    ACTIONS(9104), 1,
      sym_identifier,
    ACTIONS(9106), 1,
      anon_sym_template,
    STATE(2403), 1,
      sym_qualified_type_identifier,
    STATE(2408), 1,
      sym_dependent_type_identifier,
    STATE(2422), 1,
      sym_template_type,
    STATE(2846), 1,
      sym_pointer_type_declarator,
    STATE(2850), 1,
      sym_template_function,
    STATE(2851), 1,
      sym_destructor_name,
    STATE(2863), 1,
      sym_operator_name,
    STATE(2865), 1,
      sym_dependent_identifier,
    STATE(2871), 1,
      sym_qualified_identifier,
    STATE(5523), 1,
      sym__scope_resolution,
    STATE(7781), 1,
      sym_ms_based_modifier,
    STATE(8290), 1,
      sym_decltype,
  [216179] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9110), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9108), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [216207] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8990), 1,
      anon_sym_SLASH,
    ACTIONS(8986), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8988), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9038), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9036), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [216241] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8809), 1,
      anon_sym_try,
    ACTIONS(9022), 1,
      anon_sym_COMMA,
    ACTIONS(9024), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    ACTIONS(9032), 1,
      anon_sym_EQ,
    ACTIONS(9112), 1,
      anon_sym_SEMI,
    ACTIONS(9114), 1,
      anon_sym_LBRACE,
    STATE(2149), 1,
      sym_compound_statement,
    STATE(2150), 1,
      sym_try_statement,
    STATE(3630), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6915), 1,
      sym_gnu_asm_expression,
    STATE(6916), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(9034), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7549), 2,
      sym_argument_list,
      sym_initializer_list,
  [216299] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9118), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9116), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [216327] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(7331), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8962), 1,
      anon_sym_LBRACK,
    STATE(4762), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5709), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(8960), 13,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [216363] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9022), 1,
      anon_sym_COMMA,
    ACTIONS(9024), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    ACTIONS(9032), 1,
      anon_sym_EQ,
    ACTIONS(9120), 1,
      anon_sym_SEMI,
    ACTIONS(9122), 1,
      anon_sym_LBRACE,
    ACTIONS(9124), 1,
      anon_sym_try,
    STATE(404), 1,
      sym_try_statement,
    STATE(406), 1,
      sym_compound_statement,
    STATE(3630), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(7002), 1,
      sym_gnu_asm_expression,
    STATE(7004), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(9034), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7549), 2,
      sym_argument_list,
      sym_initializer_list,
  [216421] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8990), 1,
      anon_sym_SLASH,
    ACTIONS(8996), 1,
      anon_sym_PIPE,
    ACTIONS(8998), 1,
      anon_sym_CARET,
    ACTIONS(9000), 1,
      anon_sym_AMP,
    ACTIONS(8986), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8988), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9002), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9004), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(9008), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9036), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [216467] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(7652), 1,
      sym_identifier,
    ACTIONS(7654), 1,
      anon_sym_LPAREN2,
    ACTIONS(7656), 1,
      anon_sym_STAR,
    ACTIONS(7658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7660), 1,
      anon_sym_AMP,
    ACTIONS(9126), 1,
      anon_sym_SEMI,
    STATE(5295), 1,
      sym__field_declarator,
    STATE(6201), 1,
      sym_operator_name,
    STATE(7598), 1,
      sym_attribute_specifier,
    STATE(8292), 1,
      sym_ms_based_modifier,
    STATE(6227), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [216519] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(7506), 1,
      anon_sym_STAR,
    ACTIONS(7508), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7510), 1,
      anon_sym_AMP,
    STATE(3759), 1,
      sym_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6240), 1,
      sym__abstract_declarator,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7524), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [216563] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(7331), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8966), 1,
      anon_sym_LBRACK,
    STATE(4762), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5702), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(8964), 13,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [216599] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8990), 1,
      anon_sym_SLASH,
    ACTIONS(9000), 1,
      anon_sym_AMP,
    ACTIONS(9038), 1,
      anon_sym_PIPE,
    ACTIONS(8986), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8988), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9002), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9004), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(9008), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9036), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [216643] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(7410), 1,
      anon_sym_STAR,
    ACTIONS(9086), 1,
      anon_sym_TILDE,
    ACTIONS(9092), 1,
      anon_sym_operator,
    ACTIONS(9128), 1,
      sym_identifier,
    ACTIONS(9130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9132), 1,
      anon_sym_template,
    STATE(2403), 1,
      sym_qualified_type_identifier,
    STATE(2408), 1,
      sym_dependent_type_identifier,
    STATE(2422), 1,
      sym_template_type,
    STATE(3334), 1,
      sym_operator_name,
    STATE(3339), 1,
      sym_qualified_identifier,
    STATE(3344), 1,
      sym_pointer_type_declarator,
    STATE(3346), 1,
      sym_template_function,
    STATE(3348), 1,
      sym_destructor_name,
    STATE(3349), 1,
      sym_dependent_identifier,
    STATE(5535), 1,
      sym__scope_resolution,
    STATE(7901), 1,
      sym_ms_based_modifier,
    STATE(8290), 1,
      sym_decltype,
  [216707] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(7652), 1,
      sym_identifier,
    ACTIONS(7654), 1,
      anon_sym_LPAREN2,
    ACTIONS(7656), 1,
      anon_sym_STAR,
    ACTIONS(7658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7660), 1,
      anon_sym_AMP,
    ACTIONS(9134), 1,
      anon_sym_SEMI,
    STATE(5297), 1,
      sym__field_declarator,
    STATE(6201), 1,
      sym_operator_name,
    STATE(8275), 1,
      sym_attribute_specifier,
    STATE(8292), 1,
      sym_ms_based_modifier,
    STATE(6227), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [216759] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8990), 1,
      anon_sym_SLASH,
    ACTIONS(8992), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8994), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8996), 1,
      anon_sym_PIPE,
    ACTIONS(8998), 1,
      anon_sym_CARET,
    ACTIONS(9000), 1,
      anon_sym_AMP,
    ACTIONS(8986), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8988), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9002), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9004), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(9008), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9136), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [216809] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(7410), 1,
      anon_sym_STAR,
    ACTIONS(9076), 1,
      anon_sym_TILDE,
    ACTIONS(9082), 1,
      anon_sym_operator,
    ACTIONS(9138), 1,
      sym_identifier,
    ACTIONS(9140), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9142), 1,
      anon_sym_template,
    STATE(2403), 1,
      sym_qualified_type_identifier,
    STATE(2408), 1,
      sym_dependent_type_identifier,
    STATE(2422), 1,
      sym_template_type,
    STATE(3355), 1,
      sym_operator_name,
    STATE(3419), 1,
      sym_pointer_type_declarator,
    STATE(3421), 1,
      sym_template_function,
    STATE(3422), 1,
      sym_destructor_name,
    STATE(3423), 1,
      sym_dependent_identifier,
    STATE(3425), 1,
      sym_qualified_identifier,
    STATE(5538), 1,
      sym__scope_resolution,
    STATE(7901), 1,
      sym_ms_based_modifier,
    STATE(8290), 1,
      sym_decltype,
  [216873] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(7392), 1,
      anon_sym_STAR,
    ACTIONS(9052), 1,
      anon_sym_TILDE,
    ACTIONS(9058), 1,
      anon_sym_operator,
    ACTIONS(9144), 1,
      sym_identifier,
    ACTIONS(9146), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9148), 1,
      anon_sym_template,
    STATE(2403), 1,
      sym_qualified_type_identifier,
    STATE(2408), 1,
      sym_dependent_type_identifier,
    STATE(2422), 1,
      sym_template_type,
    STATE(2488), 1,
      sym_pointer_type_declarator,
    STATE(2490), 1,
      sym_template_function,
    STATE(2491), 1,
      sym_destructor_name,
    STATE(2492), 1,
      sym_dependent_identifier,
    STATE(2494), 1,
      sym_qualified_identifier,
    STATE(2496), 1,
      sym_operator_name,
    STATE(5539), 1,
      sym__scope_resolution,
    STATE(8058), 1,
      sym_ms_based_modifier,
    STATE(8290), 1,
      sym_decltype,
  [216937] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9152), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9150), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [216965] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(7339), 1,
      anon_sym_STAR,
    ACTIONS(9042), 1,
      anon_sym_TILDE,
    ACTIONS(9048), 1,
      anon_sym_operator,
    ACTIONS(9154), 1,
      sym_identifier,
    ACTIONS(9156), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9158), 1,
      anon_sym_template,
    STATE(2708), 1,
      sym_dependent_type_identifier,
    STATE(2721), 1,
      sym_template_type,
    STATE(2752), 1,
      sym_qualified_type_identifier,
    STATE(3553), 1,
      sym_operator_name,
    STATE(3556), 1,
      sym_qualified_identifier,
    STATE(3558), 1,
      sym_dependent_identifier,
    STATE(3559), 1,
      sym_destructor_name,
    STATE(3563), 1,
      sym_template_function,
    STATE(3565), 1,
      sym_pointer_type_declarator,
    STATE(5541), 1,
      sym__scope_resolution,
    STATE(7618), 1,
      sym_ms_based_modifier,
    STATE(8290), 1,
      sym_decltype,
  [217029] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8990), 1,
      anon_sym_SLASH,
    ACTIONS(8988), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9038), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9036), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [217061] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(7652), 1,
      sym_identifier,
    ACTIONS(7654), 1,
      anon_sym_LPAREN2,
    ACTIONS(7656), 1,
      anon_sym_STAR,
    ACTIONS(7658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7660), 1,
      anon_sym_AMP,
    ACTIONS(9160), 1,
      anon_sym_SEMI,
    STATE(5291), 1,
      sym__field_declarator,
    STATE(6201), 1,
      sym_operator_name,
    STATE(8088), 1,
      sym_attribute_specifier,
    STATE(8292), 1,
      sym_ms_based_modifier,
    STATE(6227), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [217113] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9038), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9036), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [217141] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9022), 1,
      anon_sym_COMMA,
    ACTIONS(9024), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    ACTIONS(9032), 1,
      anon_sym_EQ,
    ACTIONS(9162), 1,
      anon_sym_SEMI,
    ACTIONS(9164), 1,
      anon_sym_LBRACE,
    ACTIONS(9166), 1,
      anon_sym_try,
    STATE(783), 1,
      sym_compound_statement,
    STATE(785), 1,
      sym_try_statement,
    STATE(3630), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6905), 1,
      sym_gnu_asm_expression,
    STATE(6906), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(9034), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7549), 2,
      sym_argument_list,
      sym_initializer_list,
  [217199] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9170), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9168), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [217227] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9174), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9172), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [217255] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1807), 1,
      anon_sym_LBRACE,
    ACTIONS(9022), 1,
      anon_sym_COMMA,
    ACTIONS(9024), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    ACTIONS(9032), 1,
      anon_sym_EQ,
    ACTIONS(9176), 1,
      anon_sym_SEMI,
    ACTIONS(9178), 1,
      anon_sym_try,
    STATE(865), 1,
      sym_try_statement,
    STATE(868), 1,
      sym_compound_statement,
    STATE(3630), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6893), 1,
      sym_gnu_asm_expression,
    STATE(6896), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(9034), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7549), 2,
      sym_argument_list,
      sym_initializer_list,
  [217313] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8990), 1,
      anon_sym_SLASH,
    ACTIONS(8994), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8996), 1,
      anon_sym_PIPE,
    ACTIONS(8998), 1,
      anon_sym_CARET,
    ACTIONS(9000), 1,
      anon_sym_AMP,
    ACTIONS(8986), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8988), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9002), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9004), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(9008), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9036), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
  [217361] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9182), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9180), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [217389] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9186), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9184), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [217417] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(7392), 1,
      anon_sym_STAR,
    ACTIONS(9052), 1,
      anon_sym_TILDE,
    ACTIONS(9058), 1,
      anon_sym_operator,
    ACTIONS(9188), 1,
      sym_identifier,
    ACTIONS(9190), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9192), 1,
      anon_sym_template,
    STATE(2403), 1,
      sym_qualified_type_identifier,
    STATE(2408), 1,
      sym_dependent_type_identifier,
    STATE(2422), 1,
      sym_template_type,
    STATE(2488), 1,
      sym_pointer_type_declarator,
    STATE(2490), 1,
      sym_template_function,
    STATE(2491), 1,
      sym_destructor_name,
    STATE(2492), 1,
      sym_dependent_identifier,
    STATE(2494), 1,
      sym_qualified_identifier,
    STATE(2496), 1,
      sym_operator_name,
    STATE(5552), 1,
      sym__scope_resolution,
    STATE(8058), 1,
      sym_ms_based_modifier,
    STATE(8290), 1,
      sym_decltype,
  [217481] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6289), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(6291), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [217509] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(7392), 1,
      anon_sym_STAR,
    ACTIONS(8887), 1,
      anon_sym_TILDE,
    ACTIONS(9194), 1,
      sym_identifier,
    ACTIONS(9196), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9198), 1,
      anon_sym_template,
    ACTIONS(9200), 1,
      anon_sym_operator,
    STATE(2403), 1,
      sym_qualified_type_identifier,
    STATE(2408), 1,
      sym_dependent_type_identifier,
    STATE(2422), 1,
      sym_template_type,
    STATE(2846), 1,
      sym_pointer_type_declarator,
    STATE(2850), 1,
      sym_template_function,
    STATE(2851), 1,
      sym_destructor_name,
    STATE(2863), 1,
      sym_operator_name,
    STATE(2865), 1,
      sym_dependent_identifier,
    STATE(2871), 1,
      sym_qualified_identifier,
    STATE(5554), 1,
      sym__scope_resolution,
    STATE(8058), 1,
      sym_ms_based_modifier,
    STATE(8290), 1,
      sym_decltype,
  [217573] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9202), 1,
      sym_identifier,
    STATE(1898), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2278), 1,
      sym_primitive_type,
    STATE(6373), 1,
      sym__scope_resolution,
    STATE(1958), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [217618] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(8396), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9204), 1,
      sym_identifier,
    STATE(2164), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2545), 1,
      sym_primitive_type,
    STATE(6376), 1,
      sym__scope_resolution,
    STATE(2862), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    ACTIONS(2587), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2585), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [217663] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    ACTIONS(8565), 1,
      anon_sym_requires,
    ACTIONS(8548), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5778), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8508), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [217698] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7107), 1,
      anon_sym_requires,
    ACTIONS(8667), 1,
      anon_sym_LBRACK,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5771), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8665), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [217733] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9208), 1,
      anon_sym_LBRACK,
    ACTIONS(9206), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [217760] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7107), 1,
      anon_sym_requires,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5778), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8508), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [217795] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4691), 1,
      anon_sym_LBRACK,
    ACTIONS(4693), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [217822] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4691), 1,
      anon_sym_LBRACK,
    ACTIONS(4693), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [217849] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(3578), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4855), 1,
      anon_sym_virtual,
    ACTIONS(8644), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(6009), 1,
      sym_virtual,
    STATE(6143), 1,
      sym_access_specifier,
    STATE(6333), 1,
      sym__scope_resolution,
    STATE(5660), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6697), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(9210), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
  [217900] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7107), 1,
      anon_sym_requires,
    ACTIONS(9214), 1,
      anon_sym_LBRACK,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5760), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9212), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [217935] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4691), 1,
      anon_sym_LBRACK,
    ACTIONS(4693), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [217962] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4727), 1,
      anon_sym_LBRACK,
    ACTIONS(4729), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [217989] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6963), 1,
      anon_sym_requires,
    ACTIONS(7105), 1,
      anon_sym_DASH_GT,
    ACTIONS(9214), 1,
      anon_sym_LBRACK,
    STATE(5608), 1,
      sym_trailing_return_type,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5760), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9212), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [218028] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(8410), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9216), 1,
      sym_identifier,
    STATE(2263), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2613), 1,
      sym_primitive_type,
    STATE(6348), 1,
      sym__scope_resolution,
    STATE(2891), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    ACTIONS(5377), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(8412), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [218073] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4695), 1,
      anon_sym_LBRACK,
    ACTIONS(4697), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [218100] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6963), 1,
      anon_sym_requires,
    ACTIONS(7105), 1,
      anon_sym_DASH_GT,
    ACTIONS(8667), 1,
      anon_sym_LBRACK,
    STATE(5654), 1,
      sym_trailing_return_type,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5771), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8665), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [218139] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9220), 1,
      anon_sym_LBRACK,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9218), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [218170] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7107), 1,
      anon_sym_requires,
    ACTIONS(9224), 1,
      anon_sym_LBRACK,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5747), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9222), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [218205] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(3578), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4855), 1,
      anon_sym_virtual,
    ACTIONS(8644), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(6002), 1,
      sym_virtual,
    STATE(6190), 1,
      sym_access_specifier,
    STATE(6333), 1,
      sym__scope_resolution,
    STATE(5622), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7043), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(9210), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
  [218256] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8503), 1,
      anon_sym_requires,
    ACTIONS(8438), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8312), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [218291] = 12,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(9226), 1,
      anon_sym_LF,
    ACTIONS(9232), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9234), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9236), 1,
      anon_sym_PIPE,
    ACTIONS(9238), 1,
      anon_sym_CARET,
    ACTIONS(9240), 1,
      anon_sym_AMP,
    ACTIONS(9228), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9242), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9246), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9230), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(9244), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [218336] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(7148), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9248), 1,
      sym_identifier,
    STATE(4105), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4361), 1,
      sym_primitive_type,
    STATE(6355), 1,
      sym__scope_resolution,
    STATE(4824), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    ACTIONS(7152), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(7150), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [218381] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6955), 1,
      anon_sym_DASH_GT,
    ACTIONS(6963), 1,
      anon_sym_requires,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    STATE(5647), 1,
      sym_trailing_return_type,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8312), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [218420] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9214), 1,
      anon_sym_LBRACK,
    ACTIONS(9253), 1,
      anon_sym_requires,
    ACTIONS(9250), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5760), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9212), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [218455] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8667), 1,
      anon_sym_LBRACK,
    ACTIONS(8707), 1,
      anon_sym_requires,
    ACTIONS(8692), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5771), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8665), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [218490] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7100), 1,
      anon_sym_DASH_GT,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    ACTIONS(8565), 1,
      anon_sym_requires,
    STATE(5579), 1,
      sym_trailing_return_type,
    ACTIONS(8548), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5778), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8508), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [218529] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4715), 1,
      anon_sym_LBRACK,
    ACTIONS(4717), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [218556] = 12,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(9232), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9234), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9236), 1,
      anon_sym_PIPE,
    ACTIONS(9238), 1,
      anon_sym_CARET,
    ACTIONS(9240), 1,
      anon_sym_AMP,
    ACTIONS(9256), 1,
      anon_sym_LF,
    ACTIONS(9228), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9242), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9246), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9230), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(9244), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [218601] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9224), 1,
      anon_sym_LBRACK,
    ACTIONS(9261), 1,
      anon_sym_requires,
    ACTIONS(9258), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5747), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9222), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [218636] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(7128), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9264), 1,
      sym_identifier,
    STATE(4908), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4970), 1,
      sym_primitive_type,
    STATE(6365), 1,
      sym__scope_resolution,
    STATE(1958), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(7130), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [218681] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(6849), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7400), 1,
      anon_sym_STAR,
    ACTIONS(9266), 1,
      sym_identifier,
    ACTIONS(9268), 1,
      anon_sym_template,
    STATE(5585), 1,
      sym__scope_resolution,
    STATE(6046), 1,
      sym_destructor_name,
    STATE(6050), 1,
      sym_dependent_identifier,
    STATE(6053), 1,
      sym_qualified_identifier,
    STATE(6065), 1,
      sym_operator_name,
    STATE(6107), 1,
      sym_template_function,
    STATE(6120), 1,
      sym_pointer_type_declarator,
    STATE(7809), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [218738] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7105), 1,
      anon_sym_DASH_GT,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8441), 1,
      anon_sym_requires,
    STATE(5685), 1,
      sym_trailing_return_type,
    ACTIONS(8438), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8312), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [218777] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4703), 1,
      anon_sym_LBRACK,
    ACTIONS(4705), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [218804] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7105), 1,
      anon_sym_DASH_GT,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    ACTIONS(8551), 1,
      anon_sym_requires,
    STATE(5669), 1,
      sym_trailing_return_type,
    ACTIONS(8548), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5778), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8508), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [218843] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7105), 1,
      anon_sym_DASH_GT,
    ACTIONS(8667), 1,
      anon_sym_LBRACK,
    ACTIONS(8695), 1,
      anon_sym_requires,
    STATE(5652), 1,
      sym_trailing_return_type,
    ACTIONS(8692), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5771), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8665), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [218882] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7107), 1,
      anon_sym_requires,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8312), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [218917] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6963), 1,
      anon_sym_requires,
    ACTIONS(7105), 1,
      anon_sym_DASH_GT,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    STATE(5647), 1,
      sym_trailing_return_type,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8312), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [218956] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(8446), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9270), 1,
      sym_identifier,
    STATE(1996), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2423), 1,
      sym_primitive_type,
    STATE(6383), 1,
      sym__scope_resolution,
    STATE(2331), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    ACTIONS(5195), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(8489), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [219001] = 12,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(9232), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9234), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9236), 1,
      anon_sym_PIPE,
    ACTIONS(9238), 1,
      anon_sym_CARET,
    ACTIONS(9240), 1,
      anon_sym_AMP,
    ACTIONS(9272), 1,
      anon_sym_LF,
    ACTIONS(9228), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9242), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9246), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9230), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(9244), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [219046] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6955), 1,
      anon_sym_DASH_GT,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8441), 1,
      anon_sym_requires,
    STATE(5685), 1,
      sym_trailing_return_type,
    ACTIONS(8438), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8312), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [219085] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7105), 1,
      anon_sym_DASH_GT,
    ACTIONS(9214), 1,
      anon_sym_LBRACK,
    ACTIONS(9274), 1,
      anon_sym_requires,
    STATE(5643), 1,
      sym_trailing_return_type,
    ACTIONS(9250), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5760), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9212), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [219124] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9279), 1,
      anon_sym_LBRACK,
    ACTIONS(9277), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [219151] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(7235), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9281), 1,
      sym_identifier,
    STATE(2164), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2545), 1,
      sym_primitive_type,
    STATE(6339), 1,
      sym__scope_resolution,
    STATE(2862), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    ACTIONS(2587), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2585), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [219196] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6955), 1,
      anon_sym_DASH_GT,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    ACTIONS(8551), 1,
      anon_sym_requires,
    STATE(5669), 1,
      sym_trailing_return_type,
    ACTIONS(8548), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5778), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8508), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [219235] = 12,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(9232), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9234), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9236), 1,
      anon_sym_PIPE,
    ACTIONS(9238), 1,
      anon_sym_CARET,
    ACTIONS(9240), 1,
      anon_sym_AMP,
    ACTIONS(9283), 1,
      anon_sym_LF,
    ACTIONS(9228), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9242), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9246), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9230), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(9244), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [219280] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6963), 1,
      anon_sym_requires,
    ACTIONS(8667), 1,
      anon_sym_LBRACK,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5771), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8665), 11,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [219315] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4707), 1,
      anon_sym_LBRACK,
    ACTIONS(4709), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [219342] = 12,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(9232), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9234), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9236), 1,
      anon_sym_PIPE,
    ACTIONS(9238), 1,
      anon_sym_CARET,
    ACTIONS(9240), 1,
      anon_sym_AMP,
    ACTIONS(9285), 1,
      anon_sym_LF,
    ACTIONS(9228), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9242), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9246), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9230), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(9244), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [219387] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(6892), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7355), 1,
      anon_sym_STAR,
    ACTIONS(8978), 1,
      sym_identifier,
    ACTIONS(8980), 1,
      anon_sym_template,
    STATE(2846), 1,
      sym_pointer_type_declarator,
    STATE(2850), 1,
      sym_template_function,
    STATE(2851), 1,
      sym_destructor_name,
    STATE(2863), 1,
      sym_operator_name,
    STATE(2865), 1,
      sym_dependent_identifier,
    STATE(2871), 1,
      sym_qualified_identifier,
    STATE(5603), 1,
      sym__scope_resolution,
    STATE(7983), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [219444] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9289), 1,
      anon_sym_LBRACK,
    ACTIONS(9287), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [219471] = 3,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(9150), 1,
      anon_sym_LF,
    ACTIONS(9152), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [219498] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6955), 1,
      anon_sym_DASH_GT,
    ACTIONS(8667), 1,
      anon_sym_LBRACK,
    ACTIONS(8695), 1,
      anon_sym_requires,
    STATE(5652), 1,
      sym_trailing_return_type,
    ACTIONS(8692), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5771), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8665), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [219537] = 3,
    ACTIONS(6291), 1,
      anon_sym_LF,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(6289), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [219564] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6963), 1,
      anon_sym_requires,
    ACTIONS(9224), 1,
      anon_sym_LBRACK,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5747), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9222), 11,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [219599] = 3,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(9172), 1,
      anon_sym_LF,
    ACTIONS(9174), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [219626] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(5825), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7371), 1,
      anon_sym_STAR,
    ACTIONS(8978), 1,
      sym_identifier,
    ACTIONS(8980), 1,
      anon_sym_template,
    STATE(2846), 1,
      sym_pointer_type_declarator,
    STATE(2850), 1,
      sym_template_function,
    STATE(2851), 1,
      sym_destructor_name,
    STATE(2863), 1,
      sym_operator_name,
    STATE(2865), 1,
      sym_dependent_identifier,
    STATE(2871), 1,
      sym_qualified_identifier,
    STATE(5610), 1,
      sym__scope_resolution,
    STATE(7781), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [219683] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8966), 1,
      anon_sym_LBRACK,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(8964), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [219714] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(6790), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7371), 1,
      anon_sym_STAR,
    ACTIONS(9291), 1,
      sym_identifier,
    ACTIONS(9293), 1,
      anon_sym_template,
    STATE(2846), 1,
      sym_pointer_type_declarator,
    STATE(2850), 1,
      sym_template_function,
    STATE(2851), 1,
      sym_destructor_name,
    STATE(2863), 1,
      sym_operator_name,
    STATE(2865), 1,
      sym_dependent_identifier,
    STATE(2871), 1,
      sym_qualified_identifier,
    STATE(5612), 1,
      sym__scope_resolution,
    STATE(7781), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [219771] = 3,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(9116), 1,
      anon_sym_LF,
    ACTIONS(9118), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [219798] = 12,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(9232), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9234), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9236), 1,
      anon_sym_PIPE,
    ACTIONS(9238), 1,
      anon_sym_CARET,
    ACTIONS(9240), 1,
      anon_sym_AMP,
    ACTIONS(9295), 1,
      anon_sym_LF,
    ACTIONS(9228), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9242), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9246), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9230), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(9244), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [219843] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4699), 1,
      anon_sym_LBRACK,
    ACTIONS(4701), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [219870] = 12,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(9232), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9234), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9236), 1,
      anon_sym_PIPE,
    ACTIONS(9238), 1,
      anon_sym_CARET,
    ACTIONS(9240), 1,
      anon_sym_AMP,
    ACTIONS(9297), 1,
      anon_sym_LF,
    ACTIONS(9228), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9242), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9246), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9230), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(9244), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [219915] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(8466), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9299), 1,
      sym_identifier,
    STATE(2377), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2702), 1,
      sym_primitive_type,
    STATE(6368), 1,
      sym__scope_resolution,
    STATE(3056), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    ACTIONS(5619), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(8468), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [219960] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5477), 1,
      anon_sym_LBRACK,
    ACTIONS(9301), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(5479), 16,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [219989] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7100), 1,
      anon_sym_DASH_GT,
    ACTIONS(7107), 1,
      anon_sym_requires,
    ACTIONS(9214), 1,
      anon_sym_LBRACK,
    STATE(5572), 1,
      sym_trailing_return_type,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5760), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9212), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [220028] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6955), 1,
      anon_sym_DASH_GT,
    ACTIONS(9214), 1,
      anon_sym_LBRACK,
    ACTIONS(9274), 1,
      anon_sym_requires,
    STATE(5643), 1,
      sym_trailing_return_type,
    ACTIONS(9250), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5760), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9212), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [220067] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7100), 1,
      anon_sym_DASH_GT,
    ACTIONS(8667), 1,
      anon_sym_LBRACK,
    ACTIONS(8707), 1,
      anon_sym_requires,
    STATE(5578), 1,
      sym_trailing_return_type,
    ACTIONS(8692), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5771), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8665), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [220106] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(3578), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4855), 1,
      anon_sym_virtual,
    ACTIONS(8644), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(6017), 1,
      sym_virtual,
    STATE(6189), 1,
      sym_access_specifier,
    STATE(6333), 1,
      sym__scope_resolution,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6936), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(9210), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
  [220157] = 12,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(9232), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9234), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9236), 1,
      anon_sym_PIPE,
    ACTIONS(9238), 1,
      anon_sym_CARET,
    ACTIONS(9240), 1,
      anon_sym_AMP,
    ACTIONS(9303), 1,
      anon_sym_LF,
    ACTIONS(9228), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9242), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9246), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9230), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(9244), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [220202] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4719), 1,
      anon_sym_LBRACK,
    ACTIONS(4721), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [220229] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6955), 1,
      anon_sym_DASH_GT,
    ACTIONS(6963), 1,
      anon_sym_requires,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    STATE(5600), 1,
      sym_trailing_return_type,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5778), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8508), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [220268] = 12,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(9232), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9234), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9236), 1,
      anon_sym_PIPE,
    ACTIONS(9238), 1,
      anon_sym_CARET,
    ACTIONS(9240), 1,
      anon_sym_AMP,
    ACTIONS(9305), 1,
      anon_sym_LF,
    ACTIONS(9228), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9242), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9246), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9230), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(9244), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [220313] = 3,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(9168), 1,
      anon_sym_LF,
    ACTIONS(9170), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [220340] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(8340), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9307), 1,
      sym_identifier,
    STATE(1898), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2278), 1,
      sym_primitive_type,
    STATE(6337), 1,
      sym__scope_resolution,
    STATE(1958), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    ACTIONS(1831), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [220385] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8441), 1,
      anon_sym_requires,
    ACTIONS(8438), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8312), 11,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [220420] = 12,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(9232), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9234), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9236), 1,
      anon_sym_PIPE,
    ACTIONS(9238), 1,
      anon_sym_CARET,
    ACTIONS(9240), 1,
      anon_sym_AMP,
    ACTIONS(9309), 1,
      anon_sym_LF,
    ACTIONS(9228), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9242), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9246), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9230), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(9244), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [220465] = 4,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(9036), 1,
      anon_sym_LF,
    ACTIONS(9230), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(9038), 15,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [220494] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6963), 1,
      anon_sym_requires,
    ACTIONS(7105), 1,
      anon_sym_DASH_GT,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    STATE(5600), 1,
      sym_trailing_return_type,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5778), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8508), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [220533] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(8446), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9311), 1,
      sym_identifier,
    STATE(2003), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2376), 1,
      sym_primitive_type,
    STATE(6383), 1,
      sym__scope_resolution,
    STATE(2331), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    ACTIONS(5195), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(8448), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [220578] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7100), 1,
      anon_sym_DASH_GT,
    ACTIONS(7107), 1,
      anon_sym_requires,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    STATE(5558), 1,
      sym_trailing_return_type,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5778), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8508), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [220617] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7100), 1,
      anon_sym_DASH_GT,
    ACTIONS(7107), 1,
      anon_sym_requires,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    STATE(5560), 1,
      sym_trailing_return_type,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8312), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [220656] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(7539), 1,
      anon_sym_STAR,
    ACTIONS(7541), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7543), 1,
      anon_sym_AMP,
    STATE(3826), 1,
      sym_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6298), 1,
      sym__abstract_declarator,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7524), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [220699] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(7170), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9313), 1,
      sym_identifier,
    STATE(4159), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4716), 1,
      sym_primitive_type,
    STATE(6342), 1,
      sym__scope_resolution,
    STATE(4985), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    ACTIONS(7174), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(7172), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [220744] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5428), 1,
      anon_sym_LBRACK,
    ACTIONS(9315), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9317), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(5430), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [220775] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1957), 1,
      anon_sym_LBRACK,
    ACTIONS(1955), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [220802] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6955), 1,
      anon_sym_DASH_GT,
    ACTIONS(6963), 1,
      anon_sym_requires,
    ACTIONS(8667), 1,
      anon_sym_LBRACK,
    STATE(5654), 1,
      sym_trailing_return_type,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5771), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8665), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [220841] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(8354), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9319), 1,
      sym_identifier,
    STATE(2984), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3668), 1,
      sym_primitive_type,
    STATE(6377), 1,
      sym__scope_resolution,
    STATE(4022), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    ACTIONS(6492), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(8356), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [220886] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9321), 1,
      sym_identifier,
    STATE(2435), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2730), 1,
      sym_primitive_type,
    STATE(6380), 1,
      sym__scope_resolution,
    STATE(2625), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(53), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [220931] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9224), 1,
      anon_sym_LBRACK,
    ACTIONS(9323), 1,
      anon_sym_requires,
    ACTIONS(9258), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5747), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9222), 11,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [220966] = 12,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(9232), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9234), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9236), 1,
      anon_sym_PIPE,
    ACTIONS(9238), 1,
      anon_sym_CARET,
    ACTIONS(9240), 1,
      anon_sym_AMP,
    ACTIONS(9326), 1,
      anon_sym_LF,
    ACTIONS(9228), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9242), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9246), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9230), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(9244), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [221011] = 3,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(9036), 1,
      anon_sym_LF,
    ACTIONS(9038), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [221038] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1961), 1,
      anon_sym_LBRACK,
    ACTIONS(1959), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [221065] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6963), 1,
      anon_sym_requires,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5778), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8508), 11,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [221100] = 12,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(9232), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9234), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9236), 1,
      anon_sym_PIPE,
    ACTIONS(9238), 1,
      anon_sym_CARET,
    ACTIONS(9240), 1,
      anon_sym_AMP,
    ACTIONS(9328), 1,
      anon_sym_LF,
    ACTIONS(9228), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9242), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9246), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9230), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(9244), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [221145] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(7192), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9330), 1,
      sym_identifier,
    STATE(2855), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3464), 1,
      sym_primitive_type,
    STATE(6371), 1,
      sym__scope_resolution,
    STATE(2625), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(3580), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [221190] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4739), 1,
      anon_sym_LBRACK,
    ACTIONS(4741), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [221217] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4723), 1,
      anon_sym_LBRACK,
    ACTIONS(4725), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [221244] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9214), 1,
      anon_sym_LBRACK,
    ACTIONS(9274), 1,
      anon_sym_requires,
    ACTIONS(9250), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5760), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9212), 11,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [221279] = 3,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(9184), 1,
      anon_sym_LF,
    ACTIONS(9186), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [221306] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6963), 1,
      anon_sym_requires,
    ACTIONS(9214), 1,
      anon_sym_LBRACK,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5760), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9212), 11,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [221341] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(3578), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9330), 1,
      sym_identifier,
    STATE(2855), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3464), 1,
      sym_primitive_type,
    STATE(6333), 1,
      sym__scope_resolution,
    STATE(2625), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(3580), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [221386] = 3,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(9180), 1,
      anon_sym_LF,
    ACTIONS(9182), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [221413] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6955), 1,
      anon_sym_DASH_GT,
    ACTIONS(6963), 1,
      anon_sym_requires,
    ACTIONS(9214), 1,
      anon_sym_LBRACK,
    STATE(5608), 1,
      sym_trailing_return_type,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5760), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9212), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [221452] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9334), 1,
      anon_sym_LBRACK,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5659), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    ACTIONS(9332), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [221483] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9338), 1,
      anon_sym_LBRACK,
    ACTIONS(9340), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5659), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    ACTIONS(9336), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [221514] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(3578), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4855), 1,
      anon_sym_virtual,
    ACTIONS(8644), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(6034), 1,
      sym_virtual,
    STATE(6179), 1,
      sym_access_specifier,
    STATE(6333), 1,
      sym__scope_resolution,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6829), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(9210), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
  [221565] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8990), 1,
      anon_sym_SLASH,
    ACTIONS(8992), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8994), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8996), 1,
      anon_sym_PIPE,
    ACTIONS(8998), 1,
      anon_sym_CARET,
    ACTIONS(9000), 1,
      anon_sym_AMP,
    ACTIONS(9343), 1,
      anon_sym_RPAREN,
    ACTIONS(8986), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8988), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9002), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9004), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(9008), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [221614] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4711), 1,
      anon_sym_LBRACK,
    ACTIONS(4713), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [221641] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7100), 1,
      anon_sym_DASH_GT,
    ACTIONS(9214), 1,
      anon_sym_LBRACK,
    ACTIONS(9253), 1,
      anon_sym_requires,
    STATE(5583), 1,
      sym_trailing_return_type,
    ACTIONS(9250), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5760), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9212), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [221680] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9347), 1,
      anon_sym_LPAREN2,
    ACTIONS(9349), 1,
      anon_sym_LBRACK,
    ACTIONS(9345), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [221709] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7100), 1,
      anon_sym_DASH_GT,
    ACTIONS(7107), 1,
      anon_sym_requires,
    ACTIONS(8667), 1,
      anon_sym_LBRACK,
    STATE(5564), 1,
      sym_trailing_return_type,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5771), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8665), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [221748] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4627), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9321), 1,
      sym_identifier,
    STATE(2435), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2730), 1,
      sym_primitive_type,
    STATE(6346), 1,
      sym__scope_resolution,
    STATE(2625), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    ACTIONS(63), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(53), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [221793] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8990), 1,
      anon_sym_SLASH,
    ACTIONS(8992), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8994), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8996), 1,
      anon_sym_PIPE,
    ACTIONS(8998), 1,
      anon_sym_CARET,
    ACTIONS(9000), 1,
      anon_sym_AMP,
    ACTIONS(9351), 1,
      anon_sym_RPAREN,
    ACTIONS(8986), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8988), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9002), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9004), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(9008), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [221842] = 12,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(9036), 1,
      anon_sym_LF,
    ACTIONS(9038), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9234), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9236), 1,
      anon_sym_PIPE,
    ACTIONS(9238), 1,
      anon_sym_CARET,
    ACTIONS(9240), 1,
      anon_sym_AMP,
    ACTIONS(9228), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9242), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9246), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9230), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(9244), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [221887] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8667), 1,
      anon_sym_LBRACK,
    ACTIONS(8695), 1,
      anon_sym_requires,
    ACTIONS(8692), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5771), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8665), 11,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [221922] = 12,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(9232), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9234), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9236), 1,
      anon_sym_PIPE,
    ACTIONS(9238), 1,
      anon_sym_CARET,
    ACTIONS(9240), 1,
      anon_sym_AMP,
    ACTIONS(9353), 1,
      anon_sym_LF,
    ACTIONS(9228), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9242), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9246), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9230), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(9244), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [221967] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(7371), 1,
      anon_sym_STAR,
    ACTIONS(9355), 1,
      sym_identifier,
    ACTIONS(9357), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9359), 1,
      anon_sym_template,
    STATE(2846), 1,
      sym_pointer_type_declarator,
    STATE(2850), 1,
      sym_template_function,
    STATE(2851), 1,
      sym_destructor_name,
    STATE(2863), 1,
      sym_operator_name,
    STATE(2865), 1,
      sym_dependent_identifier,
    STATE(2871), 1,
      sym_qualified_identifier,
    STATE(5671), 1,
      sym__scope_resolution,
    STATE(7781), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [222024] = 3,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(9108), 1,
      anon_sym_LF,
    ACTIONS(9110), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [222051] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5477), 1,
      anon_sym_LBRACK,
    ACTIONS(9317), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(5479), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [222080] = 9,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(9036), 1,
      anon_sym_LF,
    ACTIONS(9240), 1,
      anon_sym_AMP,
    ACTIONS(9228), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9242), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9246), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9230), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(9038), 4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(9244), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [222119] = 8,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(9036), 1,
      anon_sym_LF,
    ACTIONS(9228), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9242), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9246), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9230), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(9244), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9038), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
  [222156] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6963), 1,
      anon_sym_requires,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8312), 11,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [222191] = 11,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(9036), 1,
      anon_sym_LF,
    ACTIONS(9236), 1,
      anon_sym_PIPE,
    ACTIONS(9238), 1,
      anon_sym_CARET,
    ACTIONS(9240), 1,
      anon_sym_AMP,
    ACTIONS(9038), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(9228), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9242), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9246), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9230), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(9244), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [222234] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4731), 1,
      anon_sym_LBRACK,
    ACTIONS(4733), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [222261] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8962), 1,
      anon_sym_LBRACK,
    STATE(5192), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(8960), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [222292] = 10,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(9036), 1,
      anon_sym_LF,
    ACTIONS(9238), 1,
      anon_sym_CARET,
    ACTIONS(9240), 1,
      anon_sym_AMP,
    ACTIONS(9228), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9242), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9246), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9038), 3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
    ACTIONS(9230), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(9244), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [222333] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4735), 1,
      anon_sym_LBRACK,
    ACTIONS(4737), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [222360] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9363), 1,
      anon_sym_LBRACK,
    ACTIONS(9361), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [222387] = 12,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(9232), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9234), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9236), 1,
      anon_sym_PIPE,
    ACTIONS(9238), 1,
      anon_sym_CARET,
    ACTIONS(9240), 1,
      anon_sym_AMP,
    ACTIONS(9365), 1,
      anon_sym_LF,
    ACTIONS(9228), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9242), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9246), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9230), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(9244), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [222432] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9369), 1,
      anon_sym_LBRACK,
    ACTIONS(9367), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [222459] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    ACTIONS(8551), 1,
      anon_sym_requires,
    ACTIONS(8548), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5778), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8508), 11,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [222494] = 5,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(9036), 1,
      anon_sym_LF,
    ACTIONS(9228), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9230), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(9038), 13,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [222525] = 6,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(9036), 1,
      anon_sym_LF,
    ACTIONS(9228), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9246), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9230), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(9038), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [222558] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5428), 1,
      anon_sym_LBRACK,
    ACTIONS(9301), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9371), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(5430), 14,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [222589] = 3,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(9060), 1,
      anon_sym_LF,
    ACTIONS(9062), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [222616] = 7,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(9036), 1,
      anon_sym_LF,
    ACTIONS(9228), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9246), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9230), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(9244), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9038), 7,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [222651] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(8376), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9373), 1,
      sym_identifier,
    STATE(2477), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2806), 1,
      sym_primitive_type,
    STATE(6349), 1,
      sym__scope_resolution,
    STATE(3235), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    ACTIONS(5807), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(8378), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [222696] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(7206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9248), 1,
      sym_identifier,
    STATE(4105), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4361), 1,
      sym_primitive_type,
    STATE(6336), 1,
      sym__scope_resolution,
    STATE(4824), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    ACTIONS(7152), 3,
      aux_sym_primitive_type_token1,
      anon_sym_byte,
      anon_sym_word,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(7150), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [222741] = 3,
    ACTIONS(6301), 1,
      anon_sym_LF,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(6299), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [222768] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7100), 1,
      anon_sym_DASH_GT,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8503), 1,
      anon_sym_requires,
    STATE(5557), 1,
      sym_trailing_return_type,
    ACTIONS(8438), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8312), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [222807] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(2843), 1,
      anon_sym_TILDE,
    ACTIONS(5521), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7381), 1,
      anon_sym_STAR,
    ACTIONS(9266), 1,
      sym_identifier,
    ACTIONS(9268), 1,
      anon_sym_template,
    STATE(5695), 1,
      sym__scope_resolution,
    STATE(6046), 1,
      sym_destructor_name,
    STATE(6050), 1,
      sym_dependent_identifier,
    STATE(6053), 1,
      sym_qualified_identifier,
    STATE(6065), 1,
      sym_operator_name,
    STATE(6107), 1,
      sym_template_function,
    STATE(6120), 1,
      sym_pointer_type_declarator,
    STATE(8041), 1,
      sym_ms_based_modifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [222864] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6923), 1,
      anon_sym_DASH_GT,
    ACTIONS(6941), 1,
      anon_sym_requires,
    STATE(5785), 1,
      sym_trailing_return_type,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5911), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8508), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [222900] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6923), 1,
      anon_sym_DASH_GT,
    ACTIONS(8515), 1,
      anon_sym_requires,
    STATE(5820), 1,
      sym_trailing_return_type,
    ACTIONS(8512), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5911), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8508), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [222936] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6923), 1,
      anon_sym_DASH_GT,
    ACTIONS(6941), 1,
      anon_sym_requires,
    STATE(5794), 1,
      sym_trailing_return_type,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6005), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8665), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [222972] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7331), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8966), 1,
      anon_sym_LBRACK,
    STATE(5705), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(8964), 14,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [223002] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6923), 1,
      anon_sym_DASH_GT,
    ACTIONS(8325), 1,
      anon_sym_requires,
    STATE(5817), 1,
      sym_trailing_return_type,
    ACTIONS(8322), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5948), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8312), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [223038] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6923), 1,
      anon_sym_DASH_GT,
    ACTIONS(6941), 1,
      anon_sym_requires,
    STATE(5792), 1,
      sym_trailing_return_type,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5998), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9212), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [223074] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7331), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8962), 1,
      anon_sym_LBRACK,
    STATE(5705), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(8960), 14,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [223104] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6923), 1,
      anon_sym_DASH_GT,
    ACTIONS(6941), 1,
      anon_sym_requires,
    STATE(5811), 1,
      sym_trailing_return_type,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5948), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8312), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [223140] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6923), 1,
      anon_sym_DASH_GT,
    ACTIONS(8683), 1,
      anon_sym_requires,
    STATE(5822), 1,
      sym_trailing_return_type,
    ACTIONS(8680), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6005), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8665), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [223176] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5532), 1,
      anon_sym_LBRACK,
    ACTIONS(9375), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5705), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5534), 14,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [223206] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6923), 1,
      anon_sym_DASH_GT,
    ACTIONS(9381), 1,
      anon_sym_requires,
    STATE(5823), 1,
      sym_trailing_return_type,
    ACTIONS(9378), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5998), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9212), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [223242] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7262), 1,
      anon_sym_LPAREN2,
    ACTIONS(7276), 1,
      anon_sym_LBRACK,
    ACTIONS(7618), 1,
      anon_sym_STAR,
    ACTIONS(7620), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7622), 1,
      anon_sym_AMP,
    STATE(3964), 1,
      sym_parameter_list,
    STATE(5772), 1,
      sym__function_declarator_seq,
    STATE(6351), 1,
      sym__abstract_declarator,
    ACTIONS(7524), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(5711), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [223284] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3194), 1,
      anon_sym_LBRACE,
    ACTIONS(7331), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9022), 1,
      anon_sym_COMMA,
    ACTIONS(9024), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    ACTIONS(9032), 1,
      anon_sym_EQ,
    ACTIONS(9384), 1,
      anon_sym_SEMI,
    ACTIONS(9386), 1,
      anon_sym_COLON,
    STATE(3627), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(7222), 1,
      sym_gnu_asm_expression,
    STATE(7225), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(9034), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6155), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7549), 2,
      sym_argument_list,
      sym_initializer_list,
  [223336] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7331), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9220), 1,
      anon_sym_LBRACK,
    STATE(5705), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9218), 14,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [223366] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3194), 1,
      anon_sym_LBRACE,
    ACTIONS(9022), 1,
      anon_sym_COMMA,
    ACTIONS(9024), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    ACTIONS(9032), 1,
      anon_sym_EQ,
    ACTIONS(9162), 1,
      anon_sym_SEMI,
    STATE(3630), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6905), 1,
      sym_gnu_asm_expression,
    STATE(6906), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(9034), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7549), 2,
      sym_argument_list,
      sym_initializer_list,
  [223415] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9390), 1,
      anon_sym_LBRACK,
    ACTIONS(9388), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [223440] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(4520), 1,
      anon_sym_STAR,
    ACTIONS(4522), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4524), 1,
      anon_sym_AMP,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(9392), 1,
      anon_sym_LBRACE,
    ACTIONS(9394), 1,
      anon_sym_requires,
    STATE(3382), 1,
      sym_compound_statement,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(5878), 1,
      sym_requires_clause,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6620), 1,
      sym_abstract_function_declarator,
    STATE(6857), 1,
      sym__abstract_declarator,
    STATE(6031), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [223489] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7043), 1,
      anon_sym_DASH_GT,
    ACTIONS(8667), 1,
      anon_sym_LBRACK,
    ACTIONS(8695), 1,
      anon_sym_requires,
    STATE(5652), 1,
      sym_trailing_return_type,
    ACTIONS(8692), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5771), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8665), 7,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [223526] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(7711), 1,
      anon_sym_STAR,
    ACTIONS(7713), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7715), 1,
      anon_sym_AMP,
    STATE(3343), 1,
      sym_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6283), 1,
      sym__abstract_declarator,
    ACTIONS(7524), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [223567] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(4520), 1,
      anon_sym_STAR,
    ACTIONS(4522), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4524), 1,
      anon_sym_AMP,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(9394), 1,
      anon_sym_requires,
    ACTIONS(9396), 1,
      anon_sym_LBRACE,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(3894), 1,
      sym_compound_statement,
    STATE(5887), 1,
      sym_requires_clause,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6769), 1,
      sym_abstract_function_declarator,
    STATE(6857), 1,
      sym__abstract_declarator,
    STATE(6031), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [223616] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9400), 1,
      anon_sym_LBRACK,
    ACTIONS(9398), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [223641] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6963), 1,
      anon_sym_requires,
    ACTIONS(7043), 1,
      anon_sym_DASH_GT,
    ACTIONS(9214), 1,
      anon_sym_LBRACK,
    STATE(5608), 1,
      sym_trailing_return_type,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5760), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9212), 7,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [223678] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7117), 1,
      anon_sym_DASH_GT,
    ACTIONS(9214), 1,
      anon_sym_LBRACK,
    ACTIONS(9253), 1,
      anon_sym_requires,
    STATE(5583), 1,
      sym_trailing_return_type,
    ACTIONS(9250), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5760), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9212), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [223715] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9404), 1,
      anon_sym_LBRACK,
    ACTIONS(9402), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [223740] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7117), 1,
      anon_sym_DASH_GT,
    ACTIONS(8667), 1,
      anon_sym_LBRACK,
    ACTIONS(8707), 1,
      anon_sym_requires,
    STATE(5578), 1,
      sym_trailing_return_type,
    ACTIONS(8692), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5771), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8665), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [223777] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7117), 1,
      anon_sym_DASH_GT,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    ACTIONS(8565), 1,
      anon_sym_requires,
    STATE(5579), 1,
      sym_trailing_return_type,
    ACTIONS(8548), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5778), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8508), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [223814] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(7654), 1,
      anon_sym_LPAREN2,
    ACTIONS(7662), 1,
      sym_identifier,
    ACTIONS(7664), 1,
      anon_sym_STAR,
    ACTIONS(7666), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7668), 1,
      anon_sym_AMP,
    STATE(6405), 1,
      sym__field_declarator,
    STATE(6495), 1,
      sym_operator_name,
    STATE(7783), 1,
      sym_ms_based_modifier,
    STATE(6227), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [223857] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(4520), 1,
      anon_sym_STAR,
    ACTIONS(4522), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4524), 1,
      anon_sym_AMP,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(9396), 1,
      anon_sym_LBRACE,
    ACTIONS(9406), 1,
      anon_sym_LT,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(3850), 1,
      sym_compound_statement,
    STATE(5715), 1,
      sym_template_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6604), 1,
      sym_abstract_function_declarator,
    STATE(6857), 1,
      sym__abstract_declarator,
    STATE(6031), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [223906] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7117), 1,
      anon_sym_DASH_GT,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8503), 1,
      anon_sym_requires,
    STATE(5557), 1,
      sym_trailing_return_type,
    ACTIONS(8438), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8312), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [223943] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(4520), 1,
      anon_sym_STAR,
    ACTIONS(4522), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4524), 1,
      anon_sym_AMP,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(9406), 1,
      anon_sym_LT,
    ACTIONS(9408), 1,
      anon_sym_LBRACE,
    STATE(3568), 1,
      sym_compound_statement,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(5737), 1,
      sym_template_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6731), 1,
      sym_abstract_function_declarator,
    STATE(6857), 1,
      sym__abstract_declarator,
    STATE(6031), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [223992] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9412), 1,
      anon_sym_LBRACK,
    ACTIONS(9410), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [224017] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9416), 1,
      anon_sym_LBRACK,
    ACTIONS(9414), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [224042] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7107), 1,
      anon_sym_requires,
    ACTIONS(7117), 1,
      anon_sym_DASH_GT,
    ACTIONS(9214), 1,
      anon_sym_LBRACK,
    STATE(5572), 1,
      sym_trailing_return_type,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5760), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9212), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [224079] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(7652), 1,
      sym_identifier,
    ACTIONS(7654), 1,
      anon_sym_LPAREN2,
    ACTIONS(7656), 1,
      anon_sym_STAR,
    ACTIONS(7658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7660), 1,
      anon_sym_AMP,
    STATE(5891), 1,
      sym__field_declarator,
    STATE(6201), 1,
      sym_operator_name,
    STATE(8292), 1,
      sym_ms_based_modifier,
    STATE(6227), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [224122] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(4520), 1,
      anon_sym_STAR,
    ACTIONS(4522), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4524), 1,
      anon_sym_AMP,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(9394), 1,
      anon_sym_requires,
    ACTIONS(9418), 1,
      anon_sym_LBRACE,
    STATE(2585), 1,
      sym_compound_statement,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(5850), 1,
      sym_requires_clause,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6718), 1,
      sym_abstract_function_declarator,
    STATE(6857), 1,
      sym__abstract_declarator,
    STATE(6031), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [224171] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    ACTIONS(8508), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [224196] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6963), 1,
      anon_sym_requires,
    ACTIONS(7043), 1,
      anon_sym_DASH_GT,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    STATE(5600), 1,
      sym_trailing_return_type,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5778), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8508), 7,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [224233] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9422), 1,
      anon_sym_LBRACK,
    ACTIONS(9420), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [224258] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7107), 1,
      anon_sym_requires,
    ACTIONS(7117), 1,
      anon_sym_DASH_GT,
    ACTIONS(8667), 1,
      anon_sym_LBRACK,
    STATE(5564), 1,
      sym_trailing_return_type,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5771), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8665), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [224295] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5187), 1,
      anon_sym_COLON,
    ACTIONS(8316), 1,
      anon_sym_LT,
    STATE(2736), 1,
      sym_template_argument_list,
    ACTIONS(3785), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [224326] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(4520), 1,
      anon_sym_STAR,
    ACTIONS(4522), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4524), 1,
      anon_sym_AMP,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(9406), 1,
      anon_sym_LT,
    ACTIONS(9424), 1,
      anon_sym_LBRACE,
    STATE(3400), 1,
      sym_compound_statement,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(5769), 1,
      sym_template_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6851), 1,
      sym_abstract_function_declarator,
    STATE(6857), 1,
      sym__abstract_declarator,
    STATE(6031), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [224375] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(4520), 1,
      anon_sym_STAR,
    ACTIONS(4522), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4524), 1,
      anon_sym_AMP,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(9394), 1,
      anon_sym_requires,
    ACTIONS(9408), 1,
      anon_sym_LBRACE,
    STATE(3561), 1,
      sym_compound_statement,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(5877), 1,
      sym_requires_clause,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6631), 1,
      sym_abstract_function_declarator,
    STATE(6857), 1,
      sym__abstract_declarator,
    STATE(6031), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [224424] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7107), 1,
      anon_sym_requires,
    ACTIONS(7117), 1,
      anon_sym_DASH_GT,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    STATE(5558), 1,
      sym_trailing_return_type,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5778), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8508), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [224461] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7107), 1,
      anon_sym_requires,
    ACTIONS(7117), 1,
      anon_sym_DASH_GT,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    STATE(5560), 1,
      sym_trailing_return_type,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8312), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [224498] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9428), 1,
      anon_sym_LBRACK,
    ACTIONS(9426), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [224523] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(4520), 1,
      anon_sym_STAR,
    ACTIONS(4522), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4524), 1,
      anon_sym_AMP,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(9406), 1,
      anon_sym_LT,
    ACTIONS(9430), 1,
      anon_sym_LBRACE,
    STATE(1756), 1,
      sym_compound_statement,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(5742), 1,
      sym_template_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6753), 1,
      sym_abstract_function_declarator,
    STATE(6857), 1,
      sym__abstract_declarator,
    STATE(6031), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [224572] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(4520), 1,
      anon_sym_STAR,
    ACTIONS(4522), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4524), 1,
      anon_sym_AMP,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(9394), 1,
      anon_sym_requires,
    ACTIONS(9430), 1,
      anon_sym_LBRACE,
    STATE(1758), 1,
      sym_compound_statement,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(5848), 1,
      sym_requires_clause,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6802), 1,
      sym_abstract_function_declarator,
    STATE(6857), 1,
      sym__abstract_declarator,
    STATE(6031), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [224621] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3194), 1,
      anon_sym_LBRACE,
    ACTIONS(9022), 1,
      anon_sym_COMMA,
    ACTIONS(9024), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    ACTIONS(9032), 1,
      anon_sym_EQ,
    ACTIONS(9384), 1,
      anon_sym_SEMI,
    STATE(3630), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(7222), 1,
      sym_gnu_asm_expression,
    STATE(7225), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(9034), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7549), 2,
      sym_argument_list,
      sym_initializer_list,
  [224670] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9434), 1,
      anon_sym_LBRACK,
    ACTIONS(9432), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [224695] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7043), 1,
      anon_sym_DASH_GT,
    ACTIONS(9214), 1,
      anon_sym_LBRACK,
    ACTIONS(9274), 1,
      anon_sym_requires,
    STATE(5643), 1,
      sym_trailing_return_type,
    ACTIONS(9250), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5760), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9212), 7,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [224732] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9438), 1,
      anon_sym_LBRACK,
    ACTIONS(9436), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [224757] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9442), 1,
      anon_sym_LBRACK,
    ACTIONS(9440), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [224782] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(4520), 1,
      anon_sym_STAR,
    ACTIONS(4522), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4524), 1,
      anon_sym_AMP,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(9406), 1,
      anon_sym_LT,
    ACTIONS(9444), 1,
      anon_sym_LBRACE,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(5566), 1,
      sym_compound_statement,
    STATE(5752), 1,
      sym_template_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6842), 1,
      sym_abstract_function_declarator,
    STATE(6857), 1,
      sym__abstract_declarator,
    STATE(6031), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [224831] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4534), 1,
      anon_sym_COLON,
    ACTIONS(8316), 1,
      anon_sym_LT,
    STATE(2736), 1,
      sym_template_argument_list,
    ACTIONS(4541), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [224862] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3194), 1,
      anon_sym_LBRACE,
    ACTIONS(9022), 1,
      anon_sym_COMMA,
    ACTIONS(9024), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    ACTIONS(9032), 1,
      anon_sym_EQ,
    ACTIONS(9176), 1,
      anon_sym_SEMI,
    STATE(3630), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6893), 1,
      sym_gnu_asm_expression,
    STATE(6896), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(9034), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7549), 2,
      sym_argument_list,
      sym_initializer_list,
  [224911] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3194), 1,
      anon_sym_LBRACE,
    ACTIONS(9022), 1,
      anon_sym_COMMA,
    ACTIONS(9024), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    ACTIONS(9384), 1,
      anon_sym_SEMI,
    ACTIONS(9446), 1,
      anon_sym_EQ,
    STATE(3630), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(7075), 1,
      sym_initializer_list,
    STATE(7222), 1,
      sym_gnu_asm_expression,
    STATE(7225), 1,
      aux_sym_declaration_repeat1,
    STATE(7549), 1,
      sym_argument_list,
    ACTIONS(9034), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [224962] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(4520), 1,
      anon_sym_STAR,
    ACTIONS(4522), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4524), 1,
      anon_sym_AMP,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(9394), 1,
      anon_sym_requires,
    ACTIONS(9444), 1,
      anon_sym_LBRACE,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(5681), 1,
      sym_compound_statement,
    STATE(5841), 1,
      sym_requires_clause,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6827), 1,
      sym_abstract_function_declarator,
    STATE(6857), 1,
      sym__abstract_declarator,
    STATE(6031), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [225011] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7043), 1,
      anon_sym_DASH_GT,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8441), 1,
      anon_sym_requires,
    STATE(5685), 1,
      sym_trailing_return_type,
    ACTIONS(8438), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8312), 7,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [225048] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(4520), 1,
      anon_sym_STAR,
    ACTIONS(4522), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4524), 1,
      anon_sym_AMP,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(9406), 1,
      anon_sym_LT,
    ACTIONS(9418), 1,
      anon_sym_LBRACE,
    STATE(2487), 1,
      sym_compound_statement,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(5730), 1,
      sym_template_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6818), 1,
      sym_abstract_function_declarator,
    STATE(6857), 1,
      sym__abstract_declarator,
    STATE(6031), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [225097] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(4520), 1,
      anon_sym_STAR,
    ACTIONS(4522), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4524), 1,
      anon_sym_AMP,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(9406), 1,
      anon_sym_LT,
    STATE(1756), 1,
      sym_compound_statement,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(5757), 1,
      sym_template_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6791), 1,
      sym_abstract_function_declarator,
    STATE(6857), 1,
      sym__abstract_declarator,
    STATE(6031), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [225146] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(7652), 1,
      sym_identifier,
    ACTIONS(7654), 1,
      anon_sym_LPAREN2,
    ACTIONS(7656), 1,
      anon_sym_STAR,
    ACTIONS(7658), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7660), 1,
      anon_sym_AMP,
    STATE(5980), 1,
      sym__field_declarator,
    STATE(6201), 1,
      sym_operator_name,
    STATE(8292), 1,
      sym_ms_based_modifier,
    STATE(6227), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [225189] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(4520), 1,
      anon_sym_STAR,
    ACTIONS(4522), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4524), 1,
      anon_sym_AMP,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(9394), 1,
      anon_sym_requires,
    STATE(1758), 1,
      sym_compound_statement,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(5851), 1,
      sym_requires_clause,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6781), 1,
      sym_abstract_function_declarator,
    STATE(6857), 1,
      sym__abstract_declarator,
    STATE(6031), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [225238] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9448), 1,
      sym_identifier,
    STATE(5874), 1,
      sym_string_literal,
    STATE(6151), 1,
      sym_raw_string_literal,
    ACTIONS(9450), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(6804), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [225273] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9454), 1,
      anon_sym_LBRACK,
    ACTIONS(9452), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [225298] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9224), 1,
      anon_sym_LBRACK,
    ACTIONS(9222), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [225323] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(4520), 1,
      anon_sym_STAR,
    ACTIONS(4522), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4524), 1,
      anon_sym_AMP,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(9406), 1,
      anon_sym_LT,
    ACTIONS(9456), 1,
      anon_sym_LBRACE,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(5762), 1,
      sym_template_parameter_list,
    STATE(5798), 1,
      sym_compound_statement,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6744), 1,
      sym_abstract_function_declarator,
    STATE(6857), 1,
      sym__abstract_declarator,
    STATE(6031), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [225372] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(4520), 1,
      anon_sym_STAR,
    ACTIONS(4522), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4524), 1,
      anon_sym_AMP,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(9394), 1,
      anon_sym_requires,
    ACTIONS(9456), 1,
      anon_sym_LBRACE,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(5788), 1,
      sym_compound_statement,
    STATE(5857), 1,
      sym_requires_clause,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6736), 1,
      sym_abstract_function_declarator,
    STATE(6857), 1,
      sym__abstract_declarator,
    STATE(6031), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [225421] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3194), 1,
      anon_sym_LBRACE,
    ACTIONS(9022), 1,
      anon_sym_COMMA,
    ACTIONS(9024), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    ACTIONS(9032), 1,
      anon_sym_EQ,
    ACTIONS(9068), 1,
      anon_sym_SEMI,
    STATE(3630), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6956), 1,
      aux_sym_declaration_repeat1,
    STATE(6957), 1,
      sym_gnu_asm_expression,
    ACTIONS(9034), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7549), 2,
      sym_argument_list,
      sym_initializer_list,
  [225470] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(7691), 1,
      anon_sym_STAR,
    ACTIONS(7693), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7695), 1,
      anon_sym_AMP,
    STATE(3980), 1,
      sym_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6387), 1,
      sym__abstract_declarator,
    ACTIONS(7524), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [225511] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym___based,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(7654), 1,
      anon_sym_LPAREN2,
    ACTIONS(7662), 1,
      sym_identifier,
    ACTIONS(7664), 1,
      anon_sym_STAR,
    ACTIONS(7666), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7668), 1,
      anon_sym_AMP,
    STATE(6403), 1,
      sym__field_declarator,
    STATE(6495), 1,
      sym_operator_name,
    STATE(7783), 1,
      sym_ms_based_modifier,
    STATE(6227), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [225554] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(4520), 1,
      anon_sym_STAR,
    ACTIONS(4522), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4524), 1,
      anon_sym_AMP,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(9394), 1,
      anon_sym_requires,
    ACTIONS(9458), 1,
      anon_sym_LBRACE,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(4342), 1,
      sym_compound_statement,
    STATE(5842), 1,
      sym_requires_clause,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6763), 1,
      sym_abstract_function_declarator,
    STATE(6857), 1,
      sym__abstract_declarator,
    STATE(6031), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [225603] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7043), 1,
      anon_sym_DASH_GT,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    ACTIONS(8551), 1,
      anon_sym_requires,
    STATE(5669), 1,
      sym_trailing_return_type,
    ACTIONS(8548), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5778), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8508), 7,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [225640] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(4520), 1,
      anon_sym_STAR,
    ACTIONS(4522), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4524), 1,
      anon_sym_AMP,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(9406), 1,
      anon_sym_LT,
    ACTIONS(9458), 1,
      anon_sym_LBRACE,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(4297), 1,
      sym_compound_statement,
    STATE(5766), 1,
      sym_template_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6838), 1,
      sym_abstract_function_declarator,
    STATE(6857), 1,
      sym__abstract_declarator,
    STATE(6031), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [225689] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(4520), 1,
      anon_sym_STAR,
    ACTIONS(4522), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4524), 1,
      anon_sym_AMP,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(9394), 1,
      anon_sym_requires,
    ACTIONS(9424), 1,
      anon_sym_LBRACE,
    STATE(3393), 1,
      sym_compound_statement,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(5895), 1,
      sym_requires_clause,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6745), 1,
      sym_abstract_function_declarator,
    STATE(6857), 1,
      sym__abstract_declarator,
    STATE(6031), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [225738] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9460), 1,
      sym_identifier,
    ACTIONS(4790), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(5770), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(9463), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(9466), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [225769] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9214), 1,
      anon_sym_LBRACK,
    ACTIONS(9212), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [225794] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9471), 1,
      anon_sym_LBRACK,
    ACTIONS(9469), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [225819] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3194), 1,
      anon_sym_LBRACE,
    ACTIONS(9022), 1,
      anon_sym_COMMA,
    ACTIONS(9024), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    ACTIONS(9032), 1,
      anon_sym_EQ,
    ACTIONS(9120), 1,
      anon_sym_SEMI,
    STATE(3630), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(7002), 1,
      sym_gnu_asm_expression,
    STATE(7004), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(9034), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7549), 2,
      sym_argument_list,
      sym_initializer_list,
  [225868] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(4520), 1,
      anon_sym_STAR,
    ACTIONS(4522), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4524), 1,
      anon_sym_AMP,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(9392), 1,
      anon_sym_LBRACE,
    ACTIONS(9406), 1,
      anon_sym_LT,
    STATE(3378), 1,
      sym_compound_statement,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(5712), 1,
      sym_template_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6758), 1,
      sym_abstract_function_declarator,
    STATE(6857), 1,
      sym__abstract_declarator,
    STATE(6031), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [225917] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9475), 1,
      anon_sym_LBRACK,
    ACTIONS(9473), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [225942] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9477), 1,
      sym_identifier,
    ACTIONS(4783), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(5770), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(9479), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(9481), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [225973] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6963), 1,
      anon_sym_requires,
    ACTIONS(7043), 1,
      anon_sym_DASH_GT,
    ACTIONS(8667), 1,
      anon_sym_LBRACK,
    STATE(5654), 1,
      sym_trailing_return_type,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5771), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8665), 7,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [226010] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8667), 1,
      anon_sym_LBRACK,
    ACTIONS(8665), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [226035] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6963), 1,
      anon_sym_requires,
    ACTIONS(7043), 1,
      anon_sym_DASH_GT,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    STATE(5647), 1,
      sym_trailing_return_type,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8312), 7,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [226072] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9485), 1,
      anon_sym_LBRACK,
    ACTIONS(9483), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [226097] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9489), 1,
      anon_sym_LBRACK,
    ACTIONS(9487), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [226122] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9491), 1,
      sym_identifier,
    ACTIONS(4777), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(5776), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(9479), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(9481), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [226153] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9495), 1,
      anon_sym_LBRACK,
    ACTIONS(9493), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [226178] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8312), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [226203] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6941), 1,
      anon_sym_requires,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6005), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8665), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [226233] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4733), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [226255] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5800), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    ACTIONS(9332), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [226281] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4737), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [226303] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(4520), 1,
      anon_sym_STAR,
    ACTIONS(4522), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4524), 1,
      anon_sym_AMP,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6482), 1,
      sym__abstract_declarator,
    ACTIONS(7524), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [226343] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1959), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [226365] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4701), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [226387] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6941), 1,
      anon_sym_requires,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6003), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9222), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [226417] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7226), 1,
      anon_sym_DASH_GT,
    ACTIONS(7228), 1,
      anon_sym_requires,
    ACTIONS(9214), 1,
      anon_sym_LBRACK,
    STATE(5922), 1,
      sym_trailing_return_type,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5760), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9212), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [226453] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6941), 1,
      anon_sym_requires,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5998), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9212), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [226483] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1955), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [226505] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6907), 1,
      anon_sym_LT,
    STATE(5917), 1,
      sym_template_argument_list,
    ACTIONS(7300), 2,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(4601), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [226535] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4705), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [226557] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4729), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [226579] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7226), 1,
      anon_sym_DASH_GT,
    ACTIONS(7228), 1,
      anon_sym_requires,
    ACTIONS(8667), 1,
      anon_sym_LBRACK,
    STATE(5921), 1,
      sym_trailing_return_type,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5771), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8665), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [226615] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5800), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    ACTIONS(9336), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [226641] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(7919), 1,
      anon_sym_STAR,
    ACTIONS(7921), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7923), 1,
      anon_sym_AMP,
    STATE(3830), 1,
      sym_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6466), 1,
      sym__abstract_declarator,
    ACTIONS(7524), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [226681] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7226), 1,
      anon_sym_DASH_GT,
    ACTIONS(7228), 1,
      anon_sym_requires,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    STATE(5919), 1,
      sym_trailing_return_type,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8312), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [226717] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3650), 1,
      anon_sym_LBRACK,
    ACTIONS(3652), 15,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [226741] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3646), 1,
      anon_sym_LBRACK,
    ACTIONS(3648), 15,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [226765] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7226), 1,
      anon_sym_DASH_GT,
    ACTIONS(9214), 1,
      anon_sym_LBRACK,
    ACTIONS(9500), 1,
      anon_sym_requires,
    STATE(5988), 1,
      sym_trailing_return_type,
    ACTIONS(9250), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5760), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9212), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [226801] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7226), 1,
      anon_sym_DASH_GT,
    ACTIONS(8667), 1,
      anon_sym_LBRACK,
    ACTIONS(8710), 1,
      anon_sym_requires,
    STATE(5987), 1,
      sym_trailing_return_type,
    ACTIONS(8692), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5771), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8665), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [226837] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5730), 1,
      anon_sym_LBRACK,
    ACTIONS(9503), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(5732), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [226863] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7226), 1,
      anon_sym_DASH_GT,
    ACTIONS(7228), 1,
      anon_sym_requires,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    STATE(5920), 1,
      sym_trailing_return_type,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5778), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8508), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [226899] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4713), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [226921] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(9076), 1,
      anon_sym_TILDE,
    ACTIONS(9505), 1,
      sym_identifier,
    ACTIONS(9507), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9510), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9512), 1,
      anon_sym_template,
    STATE(6057), 1,
      sym__scope_resolution,
    STATE(7431), 1,
      sym_operator_name,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(3399), 4,
      sym_template_method,
      sym_destructor_name,
      sym_dependent_field_identifier,
      sym_qualified_field_identifier,
  [226963] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6941), 1,
      anon_sym_requires,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5911), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8508), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [226993] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8325), 1,
      anon_sym_requires,
    ACTIONS(8322), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5948), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8312), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [227023] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3194), 1,
      anon_sym_LBRACE,
    ACTIONS(9024), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    ACTIONS(9032), 1,
      anon_sym_EQ,
    STATE(3630), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(7321), 1,
      sym_gnu_asm_expression,
    ACTIONS(9034), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9514), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7549), 2,
      sym_argument_list,
      sym_initializer_list,
  [227067] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9516), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(5479), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [227091] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4741), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [227113] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7226), 1,
      anon_sym_DASH_GT,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    ACTIONS(8619), 1,
      anon_sym_requires,
    STATE(5986), 1,
      sym_trailing_return_type,
    ACTIONS(8548), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5778), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8508), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [227149] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8515), 1,
      anon_sym_requires,
    ACTIONS(8512), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5911), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8508), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [227179] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4693), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [227201] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4717), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [227223] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8683), 1,
      anon_sym_requires,
    ACTIONS(8680), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6005), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8665), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [227253] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6907), 1,
      anon_sym_LT,
    STATE(5917), 1,
      sym_template_argument_list,
    ACTIONS(4543), 2,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(4536), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [227283] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9381), 1,
      anon_sym_requires,
    ACTIONS(9378), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5998), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9212), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [227313] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9521), 1,
      anon_sym_requires,
    ACTIONS(9518), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6003), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9222), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [227343] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4709), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [227365] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4693), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [227387] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4693), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [227409] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7226), 1,
      anon_sym_DASH_GT,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8523), 1,
      anon_sym_requires,
    STATE(5983), 1,
      sym_trailing_return_type,
    ACTIONS(8438), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8312), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [227445] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4697), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [227467] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9516), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9524), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(5430), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [227493] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4725), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [227515] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4721), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [227537] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6941), 1,
      anon_sym_requires,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5948), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8312), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [227567] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9448), 1,
      sym_identifier,
    STATE(5874), 1,
      sym_string_literal,
    STATE(6151), 1,
      sym_raw_string_literal,
    STATE(7228), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [227598] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9526), 1,
      sym_identifier,
    ACTIONS(9528), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9530), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(9532), 1,
      aux_sym_preproc_elif_token1,
    STATE(6270), 1,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(6271), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(6460), 1,
      sym_enumerator,
    ACTIONS(9534), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(8153), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
    STATE(8154), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [227637] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9536), 1,
      anon_sym_LBRACK,
    STATE(6127), 1,
      sym_parameter_list,
    STATE(6021), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5444), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [227668] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5730), 1,
      anon_sym_LBRACK,
    ACTIONS(5732), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [227691] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9536), 1,
      anon_sym_LBRACK,
    STATE(6127), 1,
      sym_parameter_list,
    STATE(6021), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5392), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [227722] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(9052), 1,
      anon_sym_TILDE,
    ACTIONS(9538), 1,
      sym_identifier,
    ACTIONS(9540), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9542), 1,
      anon_sym_template,
    STATE(6040), 1,
      sym__scope_resolution,
    STATE(7508), 1,
      sym_operator_name,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(2563), 4,
      sym_template_method,
      sym_destructor_name,
      sym_dependent_field_identifier,
      sym_qualified_field_identifier,
  [227761] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9536), 1,
      anon_sym_LBRACK,
    STATE(6127), 1,
      sym_parameter_list,
    STATE(6021), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5505), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [227792] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(9052), 1,
      anon_sym_TILDE,
    ACTIONS(9538), 1,
      sym_identifier,
    ACTIONS(9544), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9546), 1,
      anon_sym_template,
    STATE(6083), 1,
      sym__scope_resolution,
    STATE(7529), 1,
      sym_operator_name,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(2563), 4,
      sym_template_method,
      sym_destructor_name,
      sym_dependent_field_identifier,
      sym_qualified_field_identifier,
  [227831] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(4520), 1,
      anon_sym_STAR,
    ACTIONS(4522), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4524), 1,
      anon_sym_AMP,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(9444), 1,
      anon_sym_LBRACE,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(5624), 1,
      sym_compound_statement,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6821), 1,
      sym_abstract_function_declarator,
    STATE(6857), 1,
      sym__abstract_declarator,
    STATE(6031), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [227874] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(4520), 1,
      anon_sym_STAR,
    ACTIONS(4522), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4524), 1,
      anon_sym_AMP,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(9458), 1,
      anon_sym_LBRACE,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(4322), 1,
      sym_compound_statement,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6704), 1,
      sym_abstract_function_declarator,
    STATE(6857), 1,
      sym__abstract_declarator,
    STATE(6031), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [227917] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7142), 1,
      anon_sym_DASH_GT,
    ACTIONS(9548), 1,
      anon_sym_requires,
    STATE(5918), 1,
      sym_trailing_return_type,
    ACTIONS(9378), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5998), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9212), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [227950] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9536), 1,
      anon_sym_LBRACK,
    STATE(6127), 1,
      sym_parameter_list,
    STATE(6021), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5471), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [227981] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(9076), 1,
      anon_sym_TILDE,
    ACTIONS(9505), 1,
      sym_identifier,
    ACTIONS(9510), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9512), 1,
      anon_sym_template,
    STATE(6057), 1,
      sym__scope_resolution,
    STATE(7431), 1,
      sym_operator_name,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(3399), 4,
      sym_template_method,
      sym_destructor_name,
      sym_dependent_field_identifier,
      sym_qualified_field_identifier,
  [228020] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9448), 1,
      sym_identifier,
    STATE(5874), 1,
      sym_string_literal,
    STATE(6151), 1,
      sym_raw_string_literal,
    STATE(6949), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [228051] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9536), 1,
      anon_sym_LBRACK,
    STATE(6127), 1,
      sym_parameter_list,
    STATE(6021), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5465), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [228082] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(4520), 1,
      anon_sym_STAR,
    ACTIONS(4522), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4524), 1,
      anon_sym_AMP,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(9430), 1,
      anon_sym_LBRACE,
    STATE(1753), 1,
      sym_compound_statement,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6828), 1,
      sym_abstract_function_declarator,
    STATE(6857), 1,
      sym__abstract_declarator,
    STATE(6031), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [228125] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9448), 1,
      sym_identifier,
    STATE(5874), 1,
      sym_string_literal,
    STATE(6151), 1,
      sym_raw_string_literal,
    STATE(7008), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [228156] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(4520), 1,
      anon_sym_STAR,
    ACTIONS(4522), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4524), 1,
      anon_sym_AMP,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(9418), 1,
      anon_sym_LBRACE,
    STATE(2485), 1,
      sym_compound_statement,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6764), 1,
      sym_abstract_function_declarator,
    STATE(6857), 1,
      sym__abstract_declarator,
    STATE(6031), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [228199] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(4520), 1,
      anon_sym_STAR,
    ACTIONS(4522), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4524), 1,
      anon_sym_AMP,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    STATE(1753), 1,
      sym_compound_statement,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6776), 1,
      sym_abstract_function_declarator,
    STATE(6857), 1,
      sym__abstract_declarator,
    STATE(6031), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [228242] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7142), 1,
      anon_sym_DASH_GT,
    ACTIONS(8713), 1,
      anon_sym_requires,
    STATE(5964), 1,
      sym_trailing_return_type,
    ACTIONS(8680), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6005), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8665), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [228275] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9448), 1,
      sym_identifier,
    STATE(5874), 1,
      sym_string_literal,
    STATE(6151), 1,
      sym_raw_string_literal,
    STATE(7219), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [228306] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9448), 1,
      sym_identifier,
    STATE(5874), 1,
      sym_string_literal,
    STATE(6151), 1,
      sym_raw_string_literal,
    STATE(7135), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [228337] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9448), 1,
      sym_identifier,
    STATE(5874), 1,
      sym_string_literal,
    STATE(6151), 1,
      sym_raw_string_literal,
    STATE(6968), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [228368] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9526), 1,
      sym_identifier,
    ACTIONS(9530), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(9532), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(9551), 1,
      aux_sym_preproc_if_token2,
    STATE(6265), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(6272), 1,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(6460), 1,
      sym_enumerator,
    ACTIONS(9534), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(7638), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
    STATE(7643), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [228407] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(4520), 1,
      anon_sym_STAR,
    ACTIONS(4522), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4524), 1,
      anon_sym_AMP,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(9456), 1,
      anon_sym_LBRACE,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(5831), 1,
      sym_compound_statement,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6730), 1,
      sym_abstract_function_declarator,
    STATE(6857), 1,
      sym__abstract_declarator,
    STATE(6031), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [228450] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9448), 1,
      sym_identifier,
    STATE(5874), 1,
      sym_string_literal,
    STATE(6151), 1,
      sym_raw_string_literal,
    STATE(6887), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [228481] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9555), 1,
      anon_sym___attribute__,
    ACTIONS(9560), 1,
      anon_sym_alignas,
    ACTIONS(9558), 3,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    STATE(5859), 3,
      sym_attribute_specifier,
      sym_alignas_specifier,
      aux_sym__class_declaration_repeat1,
    ACTIONS(9553), 7,
      anon_sym___declspec,
      anon_sym_COLON,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
  [228510] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9565), 1,
      anon_sym_LBRACK,
    STATE(3360), 1,
      sym_parameter_list,
    STATE(5783), 1,
      sym__function_declarator_seq,
    ACTIONS(9563), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [228539] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9565), 1,
      anon_sym_LBRACK,
    STATE(3360), 1,
      sym_parameter_list,
    STATE(5783), 1,
      sym__function_declarator_seq,
    ACTIONS(9567), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [228568] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9565), 1,
      anon_sym_LBRACK,
    STATE(3360), 1,
      sym_parameter_list,
    STATE(5783), 1,
      sym__function_declarator_seq,
    ACTIONS(9569), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [228597] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9565), 1,
      anon_sym_LBRACK,
    STATE(3360), 1,
      sym_parameter_list,
    STATE(5783), 1,
      sym__function_declarator_seq,
    ACTIONS(9571), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [228626] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7142), 1,
      anon_sym_DASH_GT,
    ACTIONS(8622), 1,
      anon_sym_requires,
    STATE(5923), 1,
      sym_trailing_return_type,
    ACTIONS(8512), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5911), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8508), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [228659] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9565), 1,
      anon_sym_LBRACK,
    STATE(3360), 1,
      sym_parameter_list,
    STATE(5783), 1,
      sym__function_declarator_seq,
    ACTIONS(9573), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [228688] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9565), 1,
      anon_sym_LBRACK,
    STATE(3360), 1,
      sym_parameter_list,
    STATE(5783), 1,
      sym__function_declarator_seq,
    ACTIONS(9575), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [228717] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9565), 1,
      anon_sym_LBRACK,
    STATE(3360), 1,
      sym_parameter_list,
    STATE(5783), 1,
      sym__function_declarator_seq,
    ACTIONS(9577), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [228746] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9565), 1,
      anon_sym_LBRACK,
    STATE(3360), 1,
      sym_parameter_list,
    STATE(5783), 1,
      sym__function_declarator_seq,
    ACTIONS(9579), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [228775] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5750), 1,
      anon_sym_LBRACK,
    ACTIONS(6907), 1,
      anon_sym_LT,
    STATE(5917), 1,
      sym_template_argument_list,
    ACTIONS(5752), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [228802] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9448), 1,
      sym_identifier,
    STATE(5874), 1,
      sym_string_literal,
    STATE(6151), 1,
      sym_raw_string_literal,
    STATE(7169), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [228833] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9448), 1,
      sym_identifier,
    STATE(5874), 1,
      sym_string_literal,
    STATE(6151), 1,
      sym_raw_string_literal,
    STATE(7208), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [228864] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9448), 1,
      sym_identifier,
    STATE(5874), 1,
      sym_string_literal,
    STATE(6151), 1,
      sym_raw_string_literal,
    STATE(6987), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [228895] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7142), 1,
      anon_sym_DASH_GT,
    ACTIONS(7144), 1,
      anon_sym_requires,
    STATE(6001), 1,
      sym_trailing_return_type,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5998), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9212), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [228928] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5782), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(5199), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(9479), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(9481), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [228955] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9448), 1,
      sym_identifier,
    STATE(5874), 1,
      sym_string_literal,
    STATE(6151), 1,
      sym_raw_string_literal,
    STATE(6999), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [228986] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7142), 1,
      anon_sym_DASH_GT,
    ACTIONS(7144), 1,
      anon_sym_requires,
    STATE(5979), 1,
      sym_trailing_return_type,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6005), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8665), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [229019] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(4520), 1,
      anon_sym_STAR,
    ACTIONS(4522), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4524), 1,
      anon_sym_AMP,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(9408), 1,
      anon_sym_LBRACE,
    STATE(3691), 1,
      sym_compound_statement,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6662), 1,
      sym_abstract_function_declarator,
    STATE(6857), 1,
      sym__abstract_declarator,
    STATE(6031), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [229062] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(4520), 1,
      anon_sym_STAR,
    ACTIONS(4522), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4524), 1,
      anon_sym_AMP,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(9392), 1,
      anon_sym_LBRACE,
    STATE(3448), 1,
      sym_compound_statement,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6698), 1,
      sym_abstract_function_declarator,
    STATE(6857), 1,
      sym__abstract_declarator,
    STATE(6031), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [229105] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9448), 1,
      sym_identifier,
    STATE(5874), 1,
      sym_string_literal,
    STATE(6151), 1,
      sym_raw_string_literal,
    STATE(7045), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [229136] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7142), 1,
      anon_sym_DASH_GT,
    ACTIONS(8526), 1,
      anon_sym_requires,
    STATE(5924), 1,
      sym_trailing_return_type,
    ACTIONS(8322), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5948), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8312), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [229169] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5938), 1,
      anon_sym_LBRACK,
    ACTIONS(5940), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [229192] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9448), 1,
      sym_identifier,
    STATE(5874), 1,
      sym_string_literal,
    STATE(6151), 1,
      sym_raw_string_literal,
    STATE(7038), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [229223] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9526), 1,
      sym_identifier,
    ACTIONS(9530), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(9532), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(9581), 1,
      aux_sym_preproc_if_token2,
    STATE(6241), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(6246), 1,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(6460), 1,
      sym_enumerator,
    ACTIONS(9534), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(8222), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
    STATE(8223), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [229262] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9448), 1,
      sym_identifier,
    STATE(5874), 1,
      sym_string_literal,
    STATE(6151), 1,
      sym_raw_string_literal,
    STATE(6890), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [229293] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7142), 1,
      anon_sym_DASH_GT,
    ACTIONS(7144), 1,
      anon_sym_requires,
    STATE(5975), 1,
      sym_trailing_return_type,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5911), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8508), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [229326] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5532), 1,
      anon_sym_LBRACK,
    ACTIONS(9583), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5886), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5534), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [229353] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(4520), 1,
      anon_sym_STAR,
    ACTIONS(4522), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4524), 1,
      anon_sym_AMP,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(9396), 1,
      anon_sym_LBRACE,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(3863), 1,
      sym_compound_statement,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6641), 1,
      sym_abstract_function_declarator,
    STATE(6857), 1,
      sym__abstract_declarator,
    STATE(6031), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [229396] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9448), 1,
      sym_identifier,
    STATE(5874), 1,
      sym_string_literal,
    STATE(6151), 1,
      sym_raw_string_literal,
    STATE(6933), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [229427] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7142), 1,
      anon_sym_DASH_GT,
    ACTIONS(7144), 1,
      anon_sym_requires,
    STATE(5956), 1,
      sym_trailing_return_type,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5948), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8312), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [229460] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9565), 1,
      anon_sym_LBRACK,
    STATE(3638), 1,
      sym_parameter_list,
    STATE(5783), 1,
      sym__function_declarator_seq,
    ACTIONS(9571), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [229489] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3194), 1,
      anon_sym_LBRACE,
    ACTIONS(7331), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(8803), 1,
      anon_sym_LBRACK,
    ACTIONS(8807), 1,
      anon_sym_COLON,
    ACTIONS(9588), 1,
      anon_sym_EQ,
    STATE(3376), 1,
      sym_parameter_list,
    STATE(6214), 1,
      sym__function_declarator_seq,
    STATE(7123), 1,
      sym_initializer_list,
    STATE(7146), 1,
      sym_bitfield_clause,
    STATE(6163), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9586), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [229532] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9565), 1,
      anon_sym_LBRACK,
    STATE(3617), 1,
      sym_parameter_list,
    STATE(5783), 1,
      sym__function_declarator_seq,
    ACTIONS(9575), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [229561] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9565), 1,
      anon_sym_LBRACK,
    STATE(3638), 1,
      sym_parameter_list,
    STATE(5783), 1,
      sym__function_declarator_seq,
    ACTIONS(9569), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [229590] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9565), 1,
      anon_sym_LBRACK,
    STATE(3617), 1,
      sym_parameter_list,
    STATE(5783), 1,
      sym__function_declarator_seq,
    ACTIONS(9577), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [229619] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(4520), 1,
      anon_sym_STAR,
    ACTIONS(4522), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4524), 1,
      anon_sym_AMP,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(9424), 1,
      anon_sym_LBRACE,
    STATE(3418), 1,
      sym_compound_statement,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6761), 1,
      sym_abstract_function_declarator,
    STATE(6857), 1,
      sym__abstract_declarator,
    STATE(6031), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [229662] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9565), 1,
      anon_sym_LBRACK,
    STATE(3617), 1,
      sym_parameter_list,
    STATE(5783), 1,
      sym__function_declarator_seq,
    ACTIONS(9579), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [229691] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9565), 1,
      anon_sym_LBRACK,
    STATE(3638), 1,
      sym_parameter_list,
    STATE(5783), 1,
      sym__function_declarator_seq,
    ACTIONS(9567), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [229720] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9565), 1,
      anon_sym_LBRACK,
    STATE(3617), 1,
      sym_parameter_list,
    STATE(5783), 1,
      sym__function_declarator_seq,
    ACTIONS(9563), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [229749] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9565), 1,
      anon_sym_LBRACK,
    STATE(3638), 1,
      sym_parameter_list,
    STATE(5783), 1,
      sym__function_declarator_seq,
    ACTIONS(9563), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [229778] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(9042), 1,
      anon_sym_TILDE,
    ACTIONS(9590), 1,
      sym_identifier,
    ACTIONS(9592), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9594), 1,
      anon_sym_template,
    STATE(6133), 1,
      sym__scope_resolution,
    STATE(7284), 1,
      sym_operator_name,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(3676), 4,
      sym_template_method,
      sym_destructor_name,
      sym_dependent_field_identifier,
      sym_qualified_field_identifier,
  [229817] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9526), 1,
      sym_identifier,
    ACTIONS(9530), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(9532), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(9596), 1,
      aux_sym_preproc_if_token2,
    STATE(6268), 1,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(6273), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(6460), 1,
      sym_enumerator,
    ACTIONS(9534), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(7715), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
    STATE(7775), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [229856] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9565), 1,
      anon_sym_LBRACK,
    STATE(3638), 1,
      sym_parameter_list,
    STATE(5783), 1,
      sym__function_declarator_seq,
    ACTIONS(9579), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [229885] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9565), 1,
      anon_sym_LBRACK,
    STATE(3638), 1,
      sym_parameter_list,
    STATE(5783), 1,
      sym__function_declarator_seq,
    ACTIONS(9577), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [229914] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9565), 1,
      anon_sym_LBRACK,
    STATE(3617), 1,
      sym_parameter_list,
    STATE(5783), 1,
      sym__function_declarator_seq,
    ACTIONS(9567), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [229943] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9565), 1,
      anon_sym_LBRACK,
    STATE(3638), 1,
      sym_parameter_list,
    STATE(5783), 1,
      sym__function_declarator_seq,
    ACTIONS(9575), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [229972] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9565), 1,
      anon_sym_LBRACK,
    STATE(3638), 1,
      sym_parameter_list,
    STATE(5783), 1,
      sym__function_declarator_seq,
    ACTIONS(9573), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [230001] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9565), 1,
      anon_sym_LBRACK,
    STATE(3617), 1,
      sym_parameter_list,
    STATE(5783), 1,
      sym__function_declarator_seq,
    ACTIONS(9569), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [230030] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9565), 1,
      anon_sym_LBRACK,
    STATE(3617), 1,
      sym_parameter_list,
    STATE(5783), 1,
      sym__function_declarator_seq,
    ACTIONS(9571), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [230059] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9565), 1,
      anon_sym_LBRACK,
    STATE(3617), 1,
      sym_parameter_list,
    STATE(5783), 1,
      sym__function_declarator_seq,
    ACTIONS(9573), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [230088] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9473), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [230108] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8665), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [230128] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7144), 1,
      anon_sym_requires,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5948), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8312), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [230156] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7331), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(8803), 1,
      anon_sym_LBRACK,
    STATE(3376), 1,
      sym_parameter_list,
    STATE(6214), 1,
      sym__function_declarator_seq,
    STATE(6163), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9598), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [230188] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7228), 1,
      anon_sym_requires,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8312), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [230218] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9493), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [230238] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9483), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [230258] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4582), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4584), 2,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(4577), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [230282] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9600), 1,
      anon_sym_requires,
    ACTIONS(9518), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6003), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9222), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [230310] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7228), 1,
      anon_sym_requires,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5778), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8508), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [230340] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7228), 1,
      anon_sym_requires,
    ACTIONS(8667), 1,
      anon_sym_LBRACK,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5771), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8665), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [230370] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7228), 1,
      anon_sym_requires,
    ACTIONS(9214), 1,
      anon_sym_LBRACK,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5760), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9212), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [230400] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7228), 1,
      anon_sym_requires,
    ACTIONS(9224), 1,
      anon_sym_LBRACK,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5747), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9222), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [230430] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8713), 1,
      anon_sym_requires,
    ACTIONS(8680), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6005), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8665), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [230458] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8622), 1,
      anon_sym_requires,
    ACTIONS(8512), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5911), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8508), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [230486] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7331), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    STATE(3627), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6155), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9603), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [230518] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(6146), 1,
      anon_sym_LBRACE,
    ACTIONS(8410), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8635), 1,
      sym_identifier,
    STATE(2692), 1,
      sym_template_type,
    STATE(2856), 1,
      sym_enumerator_list,
    STATE(6348), 1,
      sym__scope_resolution,
    ACTIONS(9605), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(2693), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [230558] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    STATE(3630), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9607), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [230590] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9487), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [230610] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9452), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [230630] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9448), 1,
      sym_identifier,
    STATE(7895), 1,
      sym_concatenated_string,
    STATE(6132), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [230658] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9436), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [230678] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [230698] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7255), 1,
      anon_sym_DASH_GT,
    ACTIONS(7260), 1,
      anon_sym_requires,
    STATE(6144), 1,
      sym_trailing_return_type,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5948), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8312), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [230730] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7255), 1,
      anon_sym_DASH_GT,
    ACTIONS(7260), 1,
      anon_sym_requires,
    STATE(6147), 1,
      sym_trailing_return_type,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5911), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8508), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [230762] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3325), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
    ACTIONS(9579), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [230790] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7255), 1,
      anon_sym_DASH_GT,
    ACTIONS(7260), 1,
      anon_sym_requires,
    STATE(6157), 1,
      sym_trailing_return_type,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6005), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8665), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [230822] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7255), 1,
      anon_sym_DASH_GT,
    ACTIONS(7260), 1,
      anon_sym_requires,
    STATE(6171), 1,
      sym_trailing_return_type,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5998), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9212), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [230854] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3325), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
    ACTIONS(9577), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [230882] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3325), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
    ACTIONS(9575), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [230910] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9420), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [230930] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7300), 1,
      anon_sym_LBRACK,
    ACTIONS(9611), 1,
      anon_sym_SEMI,
    ACTIONS(9613), 1,
      anon_sym_LBRACE,
    ACTIONS(9615), 1,
      anon_sym_EQ,
    ACTIONS(9617), 1,
      anon_sym_COLON,
    ACTIONS(9619), 1,
      anon_sym_try,
    STATE(1797), 1,
      sym_compound_statement,
    STATE(7265), 1,
      sym_field_initializer_list,
    ACTIONS(4601), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(1882), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [230968] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9448), 1,
      sym_identifier,
    STATE(7858), 1,
      sym_concatenated_string,
    STATE(6112), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [230996] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7255), 1,
      anon_sym_DASH_GT,
    ACTIONS(8554), 1,
      anon_sym_requires,
    STATE(6198), 1,
      sym_trailing_return_type,
    ACTIONS(8322), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5948), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8312), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [231028] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9621), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(5479), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [231050] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7255), 1,
      anon_sym_DASH_GT,
    ACTIONS(8641), 1,
      anon_sym_requires,
    STATE(6178), 1,
      sym_trailing_return_type,
    ACTIONS(8512), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5911), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8508), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [231082] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7255), 1,
      anon_sym_DASH_GT,
    ACTIONS(8772), 1,
      anon_sym_requires,
    STATE(6175), 1,
      sym_trailing_return_type,
    ACTIONS(8680), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6005), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8665), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [231114] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7255), 1,
      anon_sym_DASH_GT,
    ACTIONS(9623), 1,
      anon_sym_requires,
    STATE(6169), 1,
      sym_trailing_return_type,
    ACTIONS(9378), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5998), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9212), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [231146] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8508), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [231166] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3325), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
    ACTIONS(9573), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [231194] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3325), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
    ACTIONS(9571), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [231222] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9448), 1,
      sym_identifier,
    STATE(7810), 1,
      sym_concatenated_string,
    STATE(6097), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [231250] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(6317), 1,
      anon_sym_LBRACE,
    ACTIONS(8631), 1,
      sym_identifier,
    ACTIONS(8661), 1,
      anon_sym_COLON_COLON,
    STATE(2421), 1,
      sym_template_type,
    STATE(3092), 1,
      sym_enumerator_list,
    STATE(6356), 1,
      sym__scope_resolution,
    ACTIONS(9626), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(4140), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [231290] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3325), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
    ACTIONS(9569), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [231318] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(6317), 1,
      anon_sym_LBRACE,
    ACTIONS(7206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8644), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(3918), 1,
      sym_enumerator_list,
    STATE(6336), 1,
      sym__scope_resolution,
    ACTIONS(9628), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(3998), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [231358] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3325), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
    ACTIONS(9567), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [231386] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7144), 1,
      anon_sym_requires,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5911), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8508), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [231414] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(7300), 1,
      anon_sym_LBRACK,
    ACTIONS(9617), 1,
      anon_sym_COLON,
    ACTIONS(9630), 1,
      anon_sym_SEMI,
    ACTIONS(9632), 1,
      anon_sym_EQ,
    ACTIONS(9634), 1,
      anon_sym_try,
    STATE(815), 1,
      sym_compound_statement,
    STATE(7287), 1,
      sym_field_initializer_list,
    ACTIONS(4601), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(848), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [231452] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8526), 1,
      anon_sym_requires,
    ACTIONS(8322), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5948), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8312), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [231480] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(617), 1,
      anon_sym_LBRACE,
    ACTIONS(7300), 1,
      anon_sym_LBRACK,
    ACTIONS(9617), 1,
      anon_sym_COLON,
    ACTIONS(9636), 1,
      anon_sym_SEMI,
    ACTIONS(9638), 1,
      anon_sym_EQ,
    ACTIONS(9640), 1,
      anon_sym_try,
    STATE(696), 1,
      sym_compound_statement,
    STATE(7275), 1,
      sym_field_initializer_list,
    ACTIONS(4601), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(697), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [231518] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9398), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [231538] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9448), 1,
      sym_identifier,
    STATE(7750), 1,
      sym_concatenated_string,
    STATE(6067), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [231566] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7300), 1,
      anon_sym_LBRACK,
    ACTIONS(9613), 1,
      anon_sym_LBRACE,
    ACTIONS(9615), 1,
      anon_sym_EQ,
    ACTIONS(9617), 1,
      anon_sym_COLON,
    ACTIONS(9619), 1,
      anon_sym_try,
    ACTIONS(9642), 1,
      anon_sym_SEMI,
    STATE(1807), 1,
      sym_compound_statement,
    STATE(7373), 1,
      sym_field_initializer_list,
    ACTIONS(4601), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(1927), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [231604] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(5297), 1,
      anon_sym_LBRACE,
    ACTIONS(8446), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8652), 1,
      sym_identifier,
    STATE(2051), 1,
      sym_template_type,
    STATE(2299), 1,
      sym_enumerator_list,
    STATE(6383), 1,
      sym__scope_resolution,
    ACTIONS(9644), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(2434), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [231644] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9548), 1,
      anon_sym_requires,
    ACTIONS(9378), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5998), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9212), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [231672] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3325), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
    ACTIONS(9563), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [231700] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(675), 1,
      anon_sym_LBRACE,
    ACTIONS(7300), 1,
      anon_sym_LBRACK,
    ACTIONS(9617), 1,
      anon_sym_COLON,
    ACTIONS(9646), 1,
      anon_sym_SEMI,
    ACTIONS(9648), 1,
      anon_sym_EQ,
    ACTIONS(9650), 1,
      anon_sym_try,
    STATE(788), 1,
      sym_compound_statement,
    STATE(7584), 1,
      sym_field_initializer_list,
    ACTIONS(4601), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(789), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [231738] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    STATE(3630), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9652), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [231770] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    STATE(3630), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9654), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [231802] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9621), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9656), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(5430), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [231826] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4816), 1,
      sym_identifier,
    ACTIONS(4818), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [231848] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6317), 1,
      anon_sym_LBRACE,
    ACTIONS(8637), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(3092), 1,
      sym_enumerator_list,
    STATE(6380), 1,
      sym__scope_resolution,
    ACTIONS(9658), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(3665), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [231888] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4829), 1,
      sym_identifier,
    ACTIONS(4831), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [231910] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8312), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [231930] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9448), 1,
      sym_identifier,
    STATE(7653), 1,
      sym_concatenated_string,
    STATE(6043), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [231958] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7144), 1,
      anon_sym_requires,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6005), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8665), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [231986] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(675), 1,
      anon_sym_LBRACE,
    ACTIONS(7300), 1,
      anon_sym_LBRACK,
    ACTIONS(9617), 1,
      anon_sym_COLON,
    ACTIONS(9648), 1,
      anon_sym_EQ,
    ACTIONS(9650), 1,
      anon_sym_try,
    ACTIONS(9660), 1,
      anon_sym_SEMI,
    STATE(772), 1,
      sym_compound_statement,
    STATE(7515), 1,
      sym_field_initializer_list,
    ACTIONS(4601), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(771), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [232024] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8523), 1,
      anon_sym_requires,
    ACTIONS(8438), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8312), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [232054] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7331), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(8803), 1,
      anon_sym_LBRACK,
    STATE(3376), 1,
      sym_parameter_list,
    STATE(6214), 1,
      sym__function_declarator_seq,
    STATE(6163), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9662), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [232086] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7144), 1,
      anon_sym_requires,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5998), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9212), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [232114] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7331), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(8803), 1,
      anon_sym_LBRACK,
    STATE(3376), 1,
      sym_parameter_list,
    STATE(6214), 1,
      sym__function_declarator_seq,
    STATE(6163), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9664), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [232146] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(7206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8334), 1,
      anon_sym_LBRACE,
    ACTIONS(8644), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(4796), 1,
      sym_enumerator_list,
    STATE(6336), 1,
      sym__scope_resolution,
    ACTIONS(9666), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(5041), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [232186] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(5728), 1,
      anon_sym_LBRACE,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8633), 1,
      sym_identifier,
    STATE(1901), 1,
      sym_template_type,
    STATE(2575), 1,
      sym_enumerator_list,
    STATE(6373), 1,
      sym__scope_resolution,
    ACTIONS(9668), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(4917), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [232226] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    ACTIONS(8619), 1,
      anon_sym_requires,
    ACTIONS(8548), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5778), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8508), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [232256] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(7218), 1,
      anon_sym_LBRACE,
    ACTIONS(8354), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8646), 1,
      sym_identifier,
    STATE(3780), 1,
      sym_template_type,
    STATE(3962), 1,
      sym_enumerator_list,
    STATE(6377), 1,
      sym__scope_resolution,
    ACTIONS(9670), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(3734), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [232296] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(5728), 1,
      anon_sym_LBRACE,
    ACTIONS(8340), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8639), 1,
      sym_identifier,
    STATE(1901), 1,
      sym_template_type,
    STATE(2575), 1,
      sym_enumerator_list,
    STATE(6337), 1,
      sym__scope_resolution,
    ACTIONS(9672), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(3955), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [232336] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8667), 1,
      anon_sym_LBRACK,
    ACTIONS(8710), 1,
      anon_sym_requires,
    ACTIONS(8692), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5771), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8665), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [232366] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9214), 1,
      anon_sym_LBRACK,
    ACTIONS(9500), 1,
      anon_sym_requires,
    ACTIONS(9250), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5760), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9212), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [232396] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9224), 1,
      anon_sym_LBRACK,
    ACTIONS(9674), 1,
      anon_sym_requires,
    ACTIONS(9258), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5747), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9222), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [232426] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9402), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [232446] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9410), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [232466] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9414), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [232486] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(7170), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8428), 1,
      anon_sym_LBRACE,
    ACTIONS(8648), 1,
      sym_identifier,
    STATE(4697), 1,
      sym_template_type,
    STATE(4910), 1,
      sym_enumerator_list,
    STATE(6342), 1,
      sym__scope_resolution,
    ACTIONS(9677), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(4763), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [232526] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5428), 1,
      anon_sym_LBRACK,
    ACTIONS(9679), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9681), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(5430), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [232552] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(6317), 1,
      anon_sym_LBRACE,
    ACTIONS(7148), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8627), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(3918), 1,
      sym_enumerator_list,
    STATE(6355), 1,
      sym__scope_resolution,
    ACTIONS(9683), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(4413), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [232592] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5477), 1,
      anon_sym_LBRACK,
    ACTIONS(9681), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(5479), 11,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_or,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [232616] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(6159), 1,
      anon_sym_LBRACE,
    ACTIONS(8466), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8650), 1,
      sym_identifier,
    STATE(2743), 1,
      sym_template_type,
    STATE(2915), 1,
      sym_enumerator_list,
    STATE(6368), 1,
      sym__scope_resolution,
    ACTIONS(9685), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(2713), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [232656] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9448), 1,
      sym_identifier,
    STATE(8030), 1,
      sym_concatenated_string,
    STATE(6074), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [232684] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9222), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [232704] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9426), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [232724] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(5297), 1,
      anon_sym_LBRACE,
    ACTIONS(8446), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8652), 1,
      sym_identifier,
    STATE(2051), 1,
      sym_template_type,
    STATE(2299), 1,
      sym_enumerator_list,
    STATE(6383), 1,
      sym__scope_resolution,
    ACTIONS(9687), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(2557), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [232764] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7144), 1,
      anon_sym_requires,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6003), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9222), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [232792] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(3578), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8644), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(6329), 1,
      sym_access_specifier,
    STATE(6333), 1,
      sym__scope_resolution,
    STATE(6936), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(9210), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
  [232830] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9440), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [232850] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(7148), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8334), 1,
      anon_sym_LBRACE,
    ACTIONS(8627), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(4796), 1,
      sym_enumerator_list,
    STATE(6355), 1,
      sym__scope_resolution,
    ACTIONS(9689), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(4733), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [232890] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9212), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [232910] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7331), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(8803), 1,
      anon_sym_LBRACK,
    STATE(3376), 1,
      sym_parameter_list,
    STATE(6214), 1,
      sym__function_declarator_seq,
    STATE(6163), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9691), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [232942] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(7300), 1,
      anon_sym_LBRACK,
    ACTIONS(9617), 1,
      anon_sym_COLON,
    ACTIONS(9632), 1,
      anon_sym_EQ,
    ACTIONS(9634), 1,
      anon_sym_try,
    ACTIONS(9693), 1,
      anon_sym_SEMI,
    STATE(818), 1,
      sym_compound_statement,
    STATE(7343), 1,
      sym_field_initializer_list,
    ACTIONS(4601), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(909), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [232980] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(6285), 1,
      anon_sym_LBRACE,
    ACTIONS(8376), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8654), 1,
      sym_identifier,
    STATE(2857), 1,
      sym_template_type,
    STATE(3071), 1,
      sym_enumerator_list,
    STATE(6349), 1,
      sym__scope_resolution,
    ACTIONS(9695), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(2842), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [233020] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(3578), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8644), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(6325), 1,
      sym_access_specifier,
    STATE(6333), 1,
      sym__scope_resolution,
    STATE(6829), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(9210), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
  [233058] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7300), 1,
      anon_sym_LBRACK,
    ACTIONS(9617), 1,
      anon_sym_COLON,
    ACTIONS(9697), 1,
      anon_sym_SEMI,
    ACTIONS(9699), 1,
      anon_sym_LBRACE,
    ACTIONS(9701), 1,
      anon_sym_EQ,
    ACTIONS(9703), 1,
      anon_sym_try,
    STATE(2052), 1,
      sym_compound_statement,
    STATE(7325), 1,
      sym_field_initializer_list,
    ACTIONS(4601), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(2145), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [233096] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(6157), 1,
      anon_sym_LBRACE,
    ACTIONS(8396), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8656), 1,
      sym_identifier,
    STATE(2739), 1,
      sym_template_type,
    STATE(2783), 1,
      sym_enumerator_list,
    STATE(6376), 1,
      sym__scope_resolution,
    ACTIONS(9705), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(4073), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [233136] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7331), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(8803), 1,
      anon_sym_LBRACK,
    STATE(3376), 1,
      sym_parameter_list,
    STATE(6214), 1,
      sym__function_declarator_seq,
    STATE(6163), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9707), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [233168] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    STATE(3630), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9603), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [233200] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7300), 1,
      anon_sym_LBRACK,
    ACTIONS(9617), 1,
      anon_sym_COLON,
    ACTIONS(9709), 1,
      anon_sym_SEMI,
    ACTIONS(9711), 1,
      anon_sym_LBRACE,
    ACTIONS(9713), 1,
      anon_sym_EQ,
    ACTIONS(9715), 1,
      anon_sym_try,
    STATE(2031), 1,
      sym_compound_statement,
    STATE(7420), 1,
      sym_field_initializer_list,
    ACTIONS(4601), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(2112), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [233238] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_LBRACE,
    ACTIONS(7300), 1,
      anon_sym_LBRACK,
    ACTIONS(9617), 1,
      anon_sym_COLON,
    ACTIONS(9717), 1,
      anon_sym_SEMI,
    ACTIONS(9719), 1,
      anon_sym_EQ,
    ACTIONS(9721), 1,
      anon_sym_try,
    STATE(397), 1,
      sym_compound_statement,
    STATE(7405), 1,
      sym_field_initializer_list,
    ACTIONS(4601), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(351), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [233276] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(5728), 1,
      anon_sym_LBRACE,
    ACTIONS(7128), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8629), 1,
      sym_identifier,
    STATE(1901), 1,
      sym_template_type,
    STATE(5015), 1,
      sym_enumerator_list,
    STATE(6365), 1,
      sym__scope_resolution,
    ACTIONS(9723), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(4806), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [233316] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(3578), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8644), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(6306), 1,
      sym_access_specifier,
    STATE(6333), 1,
      sym__scope_resolution,
    STATE(6921), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(9210), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
  [233354] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7300), 1,
      anon_sym_LBRACK,
    ACTIONS(9617), 1,
      anon_sym_COLON,
    ACTIONS(9699), 1,
      anon_sym_LBRACE,
    ACTIONS(9701), 1,
      anon_sym_EQ,
    ACTIONS(9703), 1,
      anon_sym_try,
    ACTIONS(9725), 1,
      anon_sym_SEMI,
    STATE(2049), 1,
      sym_compound_statement,
    STATE(7271), 1,
      sym_field_initializer_list,
    ACTIONS(4601), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(2143), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [233392] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(7524), 1,
      anon_sym_COLON,
    ACTIONS(8151), 1,
      anon_sym_STAR,
    ACTIONS(8153), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8155), 1,
      anon_sym_AMP,
    STATE(3982), 1,
      sym_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6561), 1,
      sym__abstract_declarator,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [233430] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(617), 1,
      anon_sym_LBRACE,
    ACTIONS(7300), 1,
      anon_sym_LBRACK,
    ACTIONS(9617), 1,
      anon_sym_COLON,
    ACTIONS(9638), 1,
      anon_sym_EQ,
    ACTIONS(9640), 1,
      anon_sym_try,
    ACTIONS(9727), 1,
      anon_sym_SEMI,
    STATE(806), 1,
      sym_compound_statement,
    STATE(7538), 1,
      sym_field_initializer_list,
    ACTIONS(4601), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(805), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [233468] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5605), 1,
      anon_sym_LBRACK,
    STATE(5886), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5607), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [233494] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7331), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    STATE(3627), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6155), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9607), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [233526] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7300), 1,
      anon_sym_LBRACK,
    ACTIONS(9617), 1,
      anon_sym_COLON,
    ACTIONS(9711), 1,
      anon_sym_LBRACE,
    ACTIONS(9713), 1,
      anon_sym_EQ,
    ACTIONS(9715), 1,
      anon_sym_try,
    ACTIONS(9729), 1,
      anon_sym_SEMI,
    STATE(2015), 1,
      sym_compound_statement,
    STATE(7497), 1,
      sym_field_initializer_list,
    ACTIONS(4601), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(2203), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [233564] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(6157), 1,
      anon_sym_LBRACE,
    ACTIONS(7235), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8663), 1,
      sym_identifier,
    STATE(2739), 1,
      sym_template_type,
    STATE(2783), 1,
      sym_enumerator_list,
    STATE(6339), 1,
      sym__scope_resolution,
    ACTIONS(9731), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(4911), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [233604] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4627), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6317), 1,
      anon_sym_LBRACE,
    ACTIONS(8631), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(3092), 1,
      sym_enumerator_list,
    STATE(6346), 1,
      sym__scope_resolution,
    ACTIONS(9733), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(3305), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [233644] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4810), 1,
      sym_identifier,
    ACTIONS(4812), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [233666] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7331), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    STATE(3627), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6155), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9652), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [233698] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9448), 1,
      sym_identifier,
    STATE(7766), 1,
      sym_concatenated_string,
    STATE(6084), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [233726] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9737), 1,
      anon_sym_LBRACK,
    STATE(5886), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9735), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [233752] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_LBRACE,
    ACTIONS(7300), 1,
      anon_sym_LBRACK,
    ACTIONS(9617), 1,
      anon_sym_COLON,
    ACTIONS(9719), 1,
      anon_sym_EQ,
    ACTIONS(9721), 1,
      anon_sym_try,
    ACTIONS(9739), 1,
      anon_sym_SEMI,
    STATE(364), 1,
      sym_compound_statement,
    STATE(7385), 1,
      sym_field_initializer_list,
    ACTIONS(4601), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(381), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [233790] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9388), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [233810] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    STATE(3630), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9741), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [233842] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4833), 1,
      sym_identifier,
    ACTIONS(4835), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [233864] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(3578), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8644), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(6321), 1,
      sym_access_specifier,
    STATE(6333), 1,
      sym__scope_resolution,
    STATE(6676), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(9210), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
  [233902] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9469), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [233922] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7331), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    STATE(3627), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6155), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9741), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [233954] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7331), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    STATE(3627), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6155), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9654), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [233986] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7331), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9536), 1,
      anon_sym_LBRACK,
    STATE(6127), 1,
      sym_parameter_list,
    STATE(6170), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5471), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [234015] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9745), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [234036] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(9540), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9542), 1,
      anon_sym_template,
    ACTIONS(9747), 1,
      sym_identifier,
    STATE(2448), 1,
      sym_qualified_field_identifier,
    STATE(2449), 1,
      sym_dependent_field_identifier,
    STATE(2453), 1,
      sym_template_method,
    STATE(6040), 1,
      sym__scope_resolution,
    STATE(7508), 1,
      sym_operator_name,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [234075] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9565), 1,
      anon_sym_LBRACK,
    STATE(3569), 1,
      sym_parameter_list,
    STATE(5783), 1,
      sym__function_declarator_seq,
    ACTIONS(9579), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [234102] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(9749), 1,
      sym_identifier,
    ACTIONS(9751), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(9755), 1,
      anon_sym_RBRACE,
    ACTIONS(9753), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7547), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8376), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6055), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [234135] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9757), 1,
      anon_sym_RPAREN,
    STATE(5782), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(9479), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(9481), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [234160] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7331), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9536), 1,
      anon_sym_LBRACK,
    STATE(6127), 1,
      sym_parameter_list,
    STATE(6170), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5444), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [234189] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(9749), 1,
      sym_identifier,
    ACTIONS(9751), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(9759), 1,
      anon_sym_RBRACE,
    ACTIONS(9753), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7567), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(7604), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6087), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [234222] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4543), 1,
      anon_sym_LBRACK,
    ACTIONS(4536), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [234243] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7331), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9536), 1,
      anon_sym_LBRACK,
    STATE(6127), 1,
      sym_parameter_list,
    STATE(6170), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5505), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [234272] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(9761), 1,
      sym_identifier,
    ACTIONS(9763), 1,
      anon_sym_COLON_COLON,
    STATE(6131), 1,
      sym__scope_resolution,
    STATE(7376), 1,
      sym_field_initializer,
    STATE(7402), 1,
      sym_operator_name,
    STATE(6729), 2,
      sym_template_method,
      sym_qualified_field_identifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [234309] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9767), 1,
      anon_sym_LBRACK,
    ACTIONS(9765), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [234330] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4543), 1,
      anon_sym_LBRACK,
    ACTIONS(4536), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [234351] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9771), 1,
      anon_sym_LBRACK,
    ACTIONS(9769), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [234372] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7331), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9536), 1,
      anon_sym_LBRACK,
    STATE(6127), 1,
      sym_parameter_list,
    STATE(6170), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5465), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [234401] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4543), 1,
      anon_sym_LBRACK,
    ACTIONS(4536), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [234422] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5569), 1,
      anon_sym_LBRACK,
    ACTIONS(5571), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [234443] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(9749), 1,
      sym_identifier,
    ACTIONS(9751), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(9773), 1,
      anon_sym_RBRACE,
    ACTIONS(9753), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7530), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8358), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6255), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [234476] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9565), 1,
      anon_sym_LBRACK,
    STATE(3569), 1,
      sym_parameter_list,
    STATE(5783), 1,
      sym__function_declarator_seq,
    ACTIONS(9577), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [234503] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(9510), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9512), 1,
      anon_sym_template,
    ACTIONS(9775), 1,
      sym_identifier,
    STATE(3429), 1,
      sym_template_method,
    STATE(3430), 1,
      sym_dependent_field_identifier,
    STATE(3432), 1,
      sym_qualified_field_identifier,
    STATE(6057), 1,
      sym__scope_resolution,
    STATE(7431), 1,
      sym_operator_name,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [234542] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(675), 1,
      anon_sym_LBRACE,
    ACTIONS(7300), 1,
      anon_sym_LBRACK,
    ACTIONS(9617), 1,
      anon_sym_COLON,
    ACTIONS(9648), 1,
      anon_sym_EQ,
    ACTIONS(9650), 1,
      anon_sym_try,
    STATE(788), 1,
      sym_compound_statement,
    STATE(7584), 1,
      sym_field_initializer_list,
    ACTIONS(4601), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(789), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [234577] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    ACTIONS(7711), 1,
      anon_sym_STAR,
    ACTIONS(7713), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7715), 1,
      anon_sym_AMP,
    STATE(3343), 1,
      sym_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6429), 1,
      sym__abstract_declarator,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [234612] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9565), 1,
      anon_sym_LBRACK,
    STATE(3569), 1,
      sym_parameter_list,
    STATE(5783), 1,
      sym__function_declarator_seq,
    ACTIONS(9571), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [234639] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_LBRACE,
    ACTIONS(7300), 1,
      anon_sym_LBRACK,
    ACTIONS(9617), 1,
      anon_sym_COLON,
    ACTIONS(9719), 1,
      anon_sym_EQ,
    ACTIONS(9721), 1,
      anon_sym_try,
    STATE(364), 1,
      sym_compound_statement,
    STATE(7385), 1,
      sym_field_initializer_list,
    ACTIONS(4601), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(381), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [234674] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7302), 1,
      anon_sym_DASH_GT,
    ACTIONS(7329), 1,
      anon_sym_requires,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    STATE(6211), 1,
      sym_trailing_return_type,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8312), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [234707] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9565), 1,
      anon_sym_LBRACK,
    STATE(3569), 1,
      sym_parameter_list,
    STATE(5783), 1,
      sym__function_declarator_seq,
    ACTIONS(9563), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [234734] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7302), 1,
      anon_sym_DASH_GT,
    ACTIONS(7329), 1,
      anon_sym_requires,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    STATE(6225), 1,
      sym_trailing_return_type,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5778), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8508), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [234767] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4543), 1,
      anon_sym_LBRACK,
    ACTIONS(4536), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [234788] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(675), 1,
      anon_sym_LBRACE,
    ACTIONS(7300), 1,
      anon_sym_LBRACK,
    ACTIONS(9617), 1,
      anon_sym_COLON,
    ACTIONS(9648), 1,
      anon_sym_EQ,
    ACTIONS(9650), 1,
      anon_sym_try,
    STATE(772), 1,
      sym_compound_statement,
    STATE(7515), 1,
      sym_field_initializer_list,
    ACTIONS(4601), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(771), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [234823] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9777), 1,
      anon_sym_RPAREN,
    STATE(5782), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(9479), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(9481), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [234848] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(5581), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [234869] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7302), 1,
      anon_sym_DASH_GT,
    ACTIONS(7329), 1,
      anon_sym_requires,
    ACTIONS(8667), 1,
      anon_sym_LBRACK,
    STATE(6229), 1,
      sym_trailing_return_type,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5771), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8665), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [234902] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5583), 1,
      anon_sym_LBRACK,
    ACTIONS(5585), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [234923] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7302), 1,
      anon_sym_DASH_GT,
    ACTIONS(7329), 1,
      anon_sym_requires,
    ACTIONS(9214), 1,
      anon_sym_LBRACK,
    STATE(6230), 1,
      sym_trailing_return_type,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5760), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9212), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [234956] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9565), 1,
      anon_sym_LBRACK,
    STATE(3569), 1,
      sym_parameter_list,
    STATE(5783), 1,
      sym__function_declarator_seq,
    ACTIONS(9573), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [234983] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5589), 1,
      anon_sym_LBRACK,
    ACTIONS(5591), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [235004] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9779), 1,
      anon_sym_RPAREN,
    STATE(5782), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(9479), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(9481), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [235029] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(9749), 1,
      sym_identifier,
    ACTIONS(9751), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(9781), 1,
      anon_sym_RBRACE,
    ACTIONS(9753), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7281), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(7967), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6255), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [235062] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(7300), 1,
      anon_sym_LBRACK,
    ACTIONS(9617), 1,
      anon_sym_COLON,
    ACTIONS(9632), 1,
      anon_sym_EQ,
    ACTIONS(9634), 1,
      anon_sym_try,
    STATE(815), 1,
      sym_compound_statement,
    STATE(7287), 1,
      sym_field_initializer_list,
    ACTIONS(4601), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(848), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [235097] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7302), 1,
      anon_sym_DASH_GT,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8616), 1,
      anon_sym_requires,
    STATE(6245), 1,
      sym_trailing_return_type,
    ACTIONS(8438), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8312), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [235130] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(9761), 1,
      sym_identifier,
    ACTIONS(9763), 1,
      anon_sym_COLON_COLON,
    STATE(6131), 1,
      sym__scope_resolution,
    STATE(7064), 1,
      sym_field_initializer,
    STATE(7402), 1,
      sym_operator_name,
    STATE(6729), 2,
      sym_template_method,
      sym_qualified_field_identifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [235167] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7302), 1,
      anon_sym_DASH_GT,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    ACTIONS(8698), 1,
      anon_sym_requires,
    STATE(6237), 1,
      sym_trailing_return_type,
    ACTIONS(8548), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5778), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8508), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [235200] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(9749), 1,
      sym_identifier,
    ACTIONS(9751), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(9783), 1,
      anon_sym_RBRACE,
    ACTIONS(9753), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7366), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(7804), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6089), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [235233] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7302), 1,
      anon_sym_DASH_GT,
    ACTIONS(8667), 1,
      anon_sym_LBRACK,
    ACTIONS(8957), 1,
      anon_sym_requires,
    STATE(6236), 1,
      sym_trailing_return_type,
    ACTIONS(8692), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5771), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8665), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [235266] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7302), 1,
      anon_sym_DASH_GT,
    ACTIONS(9214), 1,
      anon_sym_LBRACK,
    ACTIONS(9785), 1,
      anon_sym_requires,
    STATE(6233), 1,
      sym_trailing_return_type,
    ACTIONS(9250), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5760), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9212), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [235299] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(9544), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9546), 1,
      anon_sym_template,
    ACTIONS(9747), 1,
      sym_identifier,
    STATE(2448), 1,
      sym_qualified_field_identifier,
    STATE(2449), 1,
      sym_dependent_field_identifier,
    STATE(2453), 1,
      sym_template_method,
    STATE(6083), 1,
      sym__scope_resolution,
    STATE(7529), 1,
      sym_operator_name,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [235338] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9788), 1,
      anon_sym_RPAREN,
    STATE(5782), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(9479), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(9481), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [235363] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACK,
    ACTIONS(9790), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [235384] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7331), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9536), 1,
      anon_sym_LBRACK,
    STATE(6127), 1,
      sym_parameter_list,
    STATE(6170), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5392), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [235413] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(9749), 1,
      sym_identifier,
    ACTIONS(9751), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(9794), 1,
      anon_sym_RBRACE,
    ACTIONS(9753), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7504), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(7675), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6255), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [235446] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(617), 1,
      anon_sym_LBRACE,
    ACTIONS(7300), 1,
      anon_sym_LBRACK,
    ACTIONS(9617), 1,
      anon_sym_COLON,
    ACTIONS(9638), 1,
      anon_sym_EQ,
    ACTIONS(9640), 1,
      anon_sym_try,
    STATE(806), 1,
      sym_compound_statement,
    STATE(7538), 1,
      sym_field_initializer_list,
    ACTIONS(4601), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(805), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [235481] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(9749), 1,
      sym_identifier,
    ACTIONS(9751), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(9796), 1,
      anon_sym_RBRACE,
    ACTIONS(9753), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7558), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(7602), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6255), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [235514] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9565), 1,
      anon_sym_LBRACK,
    STATE(3569), 1,
      sym_parameter_list,
    STATE(5783), 1,
      sym__function_declarator_seq,
    ACTIONS(9567), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [235541] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(9749), 1,
      sym_identifier,
    ACTIONS(9751), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(9798), 1,
      anon_sym_RBRACE,
    ACTIONS(9753), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7292), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(7874), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6255), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [235574] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9565), 1,
      anon_sym_LBRACK,
    STATE(3569), 1,
      sym_parameter_list,
    STATE(5783), 1,
      sym__function_declarator_seq,
    ACTIONS(9569), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [235601] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(9749), 1,
      sym_identifier,
    ACTIONS(9751), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(9800), 1,
      anon_sym_RBRACE,
    ACTIONS(9753), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7312), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8018), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6091), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [235634] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9804), 1,
      anon_sym_LBRACK,
    ACTIONS(9802), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [235655] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9565), 1,
      anon_sym_LBRACK,
    STATE(3569), 1,
      sym_parameter_list,
    STATE(5783), 1,
      sym__function_declarator_seq,
    ACTIONS(9575), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [235682] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(7300), 1,
      anon_sym_LBRACK,
    ACTIONS(9617), 1,
      anon_sym_COLON,
    ACTIONS(9632), 1,
      anon_sym_EQ,
    ACTIONS(9634), 1,
      anon_sym_try,
    STATE(818), 1,
      sym_compound_statement,
    STATE(7343), 1,
      sym_field_initializer_list,
    ACTIONS(4601), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(909), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [235717] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9806), 1,
      anon_sym_RPAREN,
    STATE(5782), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(9479), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(9481), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [235742] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7300), 1,
      anon_sym_LBRACK,
    ACTIONS(4601), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [235763] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9810), 1,
      anon_sym_LBRACK,
    ACTIONS(9808), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [235784] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9565), 1,
      anon_sym_LBRACK,
    STATE(3657), 1,
      sym_parameter_list,
    STATE(5783), 1,
      sym__function_declarator_seq,
    ACTIONS(9579), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [235811] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(9749), 1,
      sym_identifier,
    ACTIONS(9751), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(9812), 1,
      anon_sym_RBRACE,
    ACTIONS(9753), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7441), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8199), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6255), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [235844] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9565), 1,
      anon_sym_LBRACK,
    STATE(3657), 1,
      sym_parameter_list,
    STATE(5783), 1,
      sym__function_declarator_seq,
    ACTIONS(9577), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [235871] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5557), 1,
      anon_sym_LBRACK,
    ACTIONS(5559), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [235892] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(9749), 1,
      sym_identifier,
    ACTIONS(9751), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(9814), 1,
      anon_sym_RBRACE,
    ACTIONS(9753), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7471), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8221), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6114), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [235925] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5525), 1,
      anon_sym_LBRACK,
    ACTIONS(5527), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [235946] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(9749), 1,
      sym_identifier,
    ACTIONS(9751), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(9816), 1,
      anon_sym_RBRACE,
    ACTIONS(9753), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7477), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(7692), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6135), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [235979] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4543), 1,
      anon_sym_LBRACK,
    ACTIONS(4536), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [236000] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9565), 1,
      anon_sym_LBRACK,
    STATE(3657), 1,
      sym_parameter_list,
    STATE(5783), 1,
      sym__function_declarator_seq,
    ACTIONS(9575), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [236027] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5593), 1,
      anon_sym_LBRACK,
    ACTIONS(5595), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [236048] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5597), 1,
      anon_sym_LBRACK,
    ACTIONS(5599), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [236069] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5547), 1,
      anon_sym_LBRACK,
    ACTIONS(5549), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [236090] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9818), 1,
      anon_sym_RPAREN,
    STATE(5782), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(9479), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(9481), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [236115] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9565), 1,
      anon_sym_LBRACK,
    STATE(3657), 1,
      sym_parameter_list,
    STATE(5783), 1,
      sym__function_declarator_seq,
    ACTIONS(9573), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [236142] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(9749), 1,
      sym_identifier,
    ACTIONS(9751), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(9820), 1,
      anon_sym_RBRACE,
    ACTIONS(9753), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7460), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8171), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6255), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [236175] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9565), 1,
      anon_sym_LBRACK,
    STATE(3657), 1,
      sym_parameter_list,
    STATE(5783), 1,
      sym__function_declarator_seq,
    ACTIONS(9571), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [236202] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5601), 1,
      anon_sym_LBRACK,
    ACTIONS(5603), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [236223] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9565), 1,
      anon_sym_LBRACK,
    STATE(3657), 1,
      sym_parameter_list,
    STATE(5783), 1,
      sym__function_declarator_seq,
    ACTIONS(9569), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [236250] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6016), 1,
      anon_sym_LBRACK,
    ACTIONS(6018), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [236271] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9565), 1,
      anon_sym_LBRACK,
    STATE(3657), 1,
      sym_parameter_list,
    STATE(5783), 1,
      sym__function_declarator_seq,
    ACTIONS(9567), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [236298] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4543), 1,
      anon_sym_LBRACK,
    ACTIONS(4536), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [236319] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(9749), 1,
      sym_identifier,
    ACTIONS(9751), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(9822), 1,
      anon_sym_RBRACE,
    ACTIONS(9753), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7332), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(7837), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6101), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [236352] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(4520), 1,
      anon_sym_STAR,
    ACTIONS(4522), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4524), 1,
      anon_sym_AMP,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6542), 1,
      sym__abstract_declarator,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [236387] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9826), 1,
      anon_sym_LBRACK,
    ACTIONS(9824), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [236408] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(9749), 1,
      sym_identifier,
    ACTIONS(9751), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(9828), 1,
      anon_sym_RBRACE,
    ACTIONS(9753), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7398), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8105), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6255), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [236441] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9832), 1,
      anon_sym_LBRACK,
    ACTIONS(9830), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [236462] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(9749), 1,
      sym_identifier,
    ACTIONS(9751), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(9834), 1,
      anon_sym_RBRACE,
    ACTIONS(9753), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7544), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8159), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6137), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [236495] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5551), 1,
      anon_sym_LBRACK,
    ACTIONS(5553), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [236516] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9838), 1,
      anon_sym_LBRACK,
    ACTIONS(9836), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [236537] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(617), 1,
      anon_sym_LBRACE,
    ACTIONS(7300), 1,
      anon_sym_LBRACK,
    ACTIONS(9617), 1,
      anon_sym_COLON,
    ACTIONS(9638), 1,
      anon_sym_EQ,
    ACTIONS(9640), 1,
      anon_sym_try,
    STATE(696), 1,
      sym_compound_statement,
    STATE(7275), 1,
      sym_field_initializer_list,
    ACTIONS(4601), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(697), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [236572] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(9749), 1,
      sym_identifier,
    ACTIONS(9751), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(9840), 1,
      anon_sym_RBRACE,
    ACTIONS(9753), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7412), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8117), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6124), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [236605] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(9763), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9842), 1,
      sym_identifier,
    ACTIONS(9844), 1,
      anon_sym_template,
    STATE(2448), 1,
      sym_qualified_field_identifier,
    STATE(2449), 1,
      sym_dependent_field_identifier,
    STATE(2453), 1,
      sym_template_method,
    STATE(6131), 1,
      sym__scope_resolution,
    STATE(7402), 1,
      sym_operator_name,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [236644] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9846), 1,
      anon_sym_RPAREN,
    STATE(5782), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(9479), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(9481), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [236669] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(9592), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9594), 1,
      anon_sym_template,
    ACTIONS(9848), 1,
      sym_identifier,
    STATE(3548), 1,
      sym_template_method,
    STATE(3576), 1,
      sym_dependent_field_identifier,
    STATE(3582), 1,
      sym_qualified_field_identifier,
    STATE(6133), 1,
      sym__scope_resolution,
    STATE(7284), 1,
      sym_operator_name,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [236708] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5266), 1,
      anon_sym_LBRACK,
    ACTIONS(5264), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [236729] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(9749), 1,
      sym_identifier,
    ACTIONS(9751), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(9850), 1,
      anon_sym_RBRACE,
    ACTIONS(9753), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7350), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8079), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6255), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [236762] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9565), 1,
      anon_sym_LBRACK,
    STATE(3657), 1,
      sym_parameter_list,
    STATE(5783), 1,
      sym__function_declarator_seq,
    ACTIONS(9563), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [236789] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(9749), 1,
      sym_identifier,
    ACTIONS(9751), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(9852), 1,
      anon_sym_RBRACE,
    ACTIONS(9753), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7507), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8317), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6255), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [236822] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_LBRACE,
    ACTIONS(7300), 1,
      anon_sym_LBRACK,
    ACTIONS(9617), 1,
      anon_sym_COLON,
    ACTIONS(9719), 1,
      anon_sym_EQ,
    ACTIONS(9721), 1,
      anon_sym_try,
    STATE(397), 1,
      sym_compound_statement,
    STATE(7405), 1,
      sym_field_initializer_list,
    ACTIONS(4601), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(351), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [236857] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_LPAREN2,
    ACTIONS(4520), 1,
      anon_sym_STAR,
    ACTIONS(4522), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4524), 1,
      anon_sym_AMP,
    ACTIONS(7325), 1,
      anon_sym_LBRACK,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(6035), 1,
      sym__function_declarator_seq,
    STATE(6545), 1,
      sym__abstract_declarator,
    STATE(6031), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [236892] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(9749), 1,
      sym_identifier,
    ACTIONS(9751), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(9854), 1,
      anon_sym_RBRACE,
    ACTIONS(9753), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7346), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(7826), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6075), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [236925] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    STATE(3666), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9652), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [236955] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(6317), 1,
      anon_sym_LBRACE,
    ACTIONS(7206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8644), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(3936), 1,
      sym_enumerator_list,
    STATE(6336), 1,
      sym__scope_resolution,
    STATE(4031), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [236991] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(3578), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4855), 1,
      anon_sym_virtual,
    ACTIONS(8644), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(6325), 1,
      sym_virtual,
    STATE(6333), 1,
      sym__scope_resolution,
    STATE(6829), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [237027] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7260), 1,
      anon_sym_requires,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5911), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8508), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [237053] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(6317), 1,
      anon_sym_LBRACE,
    ACTIONS(8631), 1,
      sym_identifier,
    ACTIONS(8661), 1,
      anon_sym_COLON_COLON,
    STATE(2421), 1,
      sym_template_type,
    STATE(3143), 1,
      sym_enumerator_list,
    STATE(6356), 1,
      sym__scope_resolution,
    STATE(4157), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [237089] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    STATE(2342), 1,
      sym_parameter_list,
    STATE(6243), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5444), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_try,
  [237117] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7260), 1,
      anon_sym_requires,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6005), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8665), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [237143] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9856), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9858), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(5430), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [237165] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    STATE(3666), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9741), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [237195] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    STATE(3666), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9654), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [237225] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5782), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(9479), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(9481), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [237247] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(7206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8334), 1,
      anon_sym_LBRACE,
    ACTIONS(8644), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(4807), 1,
      sym_enumerator_list,
    STATE(6336), 1,
      sym__scope_resolution,
    STATE(5049), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [237283] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(5728), 1,
      anon_sym_LBRACE,
    ACTIONS(8340), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8639), 1,
      sym_identifier,
    STATE(1901), 1,
      sym_template_type,
    STATE(2522), 1,
      sym_enumerator_list,
    STATE(6337), 1,
      sym__scope_resolution,
    STATE(3959), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [237319] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(6146), 1,
      anon_sym_LBRACE,
    ACTIONS(8410), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8635), 1,
      sym_identifier,
    STATE(2692), 1,
      sym_template_type,
    STATE(2833), 1,
      sym_enumerator_list,
    STATE(6348), 1,
      sym__scope_resolution,
    STATE(2685), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [237355] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7331), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9737), 1,
      anon_sym_LBRACK,
    STATE(5705), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9735), 8,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [237379] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6317), 1,
      anon_sym_LBRACE,
    ACTIONS(8637), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(3143), 1,
      sym_enumerator_list,
    STATE(6380), 1,
      sym__scope_resolution,
    STATE(3631), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [237415] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7260), 1,
      anon_sym_requires,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5998), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9212), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [237441] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(7218), 1,
      anon_sym_LBRACE,
    ACTIONS(8354), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8646), 1,
      sym_identifier,
    STATE(3780), 1,
      sym_template_type,
    STATE(3975), 1,
      sym_enumerator_list,
    STATE(6377), 1,
      sym__scope_resolution,
    STATE(3744), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [237477] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    STATE(2342), 1,
      sym_parameter_list,
    STATE(6243), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5392), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_try,
  [237505] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    STATE(2342), 1,
      sym_parameter_list,
    STATE(6243), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5465), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_try,
  [237533] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(6157), 1,
      anon_sym_LBRACE,
    ACTIONS(8396), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8656), 1,
      sym_identifier,
    STATE(2739), 1,
      sym_template_type,
    STATE(2801), 1,
      sym_enumerator_list,
    STATE(6376), 1,
      sym__scope_resolution,
    STATE(4077), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [237569] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7144), 1,
      anon_sym_requires,
    ACTIONS(7333), 1,
      anon_sym_DASH_GT,
    STATE(6001), 1,
      sym_trailing_return_type,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5998), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9212), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [237599] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7331), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9862), 1,
      anon_sym_LBRACK,
    STATE(5705), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9860), 8,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [237623] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(5297), 1,
      anon_sym_LBRACE,
    ACTIONS(8446), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8652), 1,
      sym_identifier,
    STATE(2051), 1,
      sym_template_type,
    STATE(2283), 1,
      sym_enumerator_list,
    STATE(6383), 1,
      sym__scope_resolution,
    STATE(2489), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [237659] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7260), 1,
      anon_sym_requires,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5948), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8312), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [237685] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    STATE(2342), 1,
      sym_parameter_list,
    STATE(6243), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5505), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_try,
  [237713] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    STATE(3666), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9603), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [237743] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(7170), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8428), 1,
      anon_sym_LBRACE,
    ACTIONS(8648), 1,
      sym_identifier,
    STATE(4697), 1,
      sym_template_type,
    STATE(4915), 1,
      sym_enumerator_list,
    STATE(6342), 1,
      sym__scope_resolution,
    STATE(4751), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [237779] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9864), 1,
      anon_sym_requires,
    ACTIONS(9518), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6003), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9222), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [237805] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5605), 1,
      anon_sym_LBRACK,
    ACTIONS(7331), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5705), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5607), 8,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [237829] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7260), 1,
      anon_sym_requires,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6003), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9222), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [237855] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7144), 1,
      anon_sym_requires,
    ACTIONS(7333), 1,
      anon_sym_DASH_GT,
    STATE(5979), 1,
      sym_trailing_return_type,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6005), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8665), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [237885] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7222), 6,
      anon_sym_AMP,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
    ACTIONS(7224), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
  [237905] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7333), 1,
      anon_sym_DASH_GT,
    ACTIONS(9548), 1,
      anon_sym_requires,
    STATE(5918), 1,
      sym_trailing_return_type,
    ACTIONS(9378), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5998), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9212), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [237935] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9623), 1,
      anon_sym_requires,
    ACTIONS(9378), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5998), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9212), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [237961] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9565), 1,
      anon_sym_LBRACK,
    STATE(3784), 1,
      sym_parameter_list,
    STATE(5783), 1,
      sym__function_declarator_seq,
    ACTIONS(9579), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [237987] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7144), 1,
      anon_sym_requires,
    ACTIONS(7333), 1,
      anon_sym_DASH_GT,
    STATE(5975), 1,
      sym_trailing_return_type,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5911), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8508), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [238017] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8772), 1,
      anon_sym_requires,
    ACTIONS(8680), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6005), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8665), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [238043] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(3578), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4855), 1,
      anon_sym_virtual,
    ACTIONS(8644), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(6321), 1,
      sym_virtual,
    STATE(6333), 1,
      sym__scope_resolution,
    STATE(6676), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [238079] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9565), 1,
      anon_sym_LBRACK,
    STATE(3784), 1,
      sym_parameter_list,
    STATE(5783), 1,
      sym__function_declarator_seq,
    ACTIONS(9577), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [238105] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9869), 1,
      anon_sym_LT,
    ACTIONS(9871), 1,
      anon_sym_LBRACK,
    STATE(6275), 1,
      sym_template_argument_list,
    ACTIONS(9867), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [238129] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4627), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6317), 1,
      anon_sym_LBRACE,
    ACTIONS(8631), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(3143), 1,
      sym_enumerator_list,
    STATE(6346), 1,
      sym__scope_resolution,
    STATE(3262), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [238165] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(6157), 1,
      anon_sym_LBRACE,
    ACTIONS(7235), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8663), 1,
      sym_identifier,
    STATE(2739), 1,
      sym_template_type,
    STATE(2801), 1,
      sym_enumerator_list,
    STATE(6339), 1,
      sym__scope_resolution,
    STATE(4940), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [238201] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9565), 1,
      anon_sym_LBRACK,
    STATE(3784), 1,
      sym_parameter_list,
    STATE(5783), 1,
      sym__function_declarator_seq,
    ACTIONS(9575), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [238227] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(5728), 1,
      anon_sym_LBRACE,
    ACTIONS(7128), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8629), 1,
      sym_identifier,
    STATE(1901), 1,
      sym_template_type,
    STATE(5035), 1,
      sym_enumerator_list,
    STATE(6365), 1,
      sym__scope_resolution,
    STATE(4799), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [238263] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9565), 1,
      anon_sym_LBRACK,
    STATE(3784), 1,
      sym_parameter_list,
    STATE(5783), 1,
      sym__function_declarator_seq,
    ACTIONS(9573), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [238289] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(6285), 1,
      anon_sym_LBRACE,
    ACTIONS(8376), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8654), 1,
      sym_identifier,
    STATE(2857), 1,
      sym_template_type,
    STATE(3105), 1,
      sym_enumerator_list,
    STATE(6349), 1,
      sym__scope_resolution,
    STATE(2853), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [238325] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(6317), 1,
      anon_sym_LBRACE,
    ACTIONS(7148), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8627), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(3936), 1,
      sym_enumerator_list,
    STATE(6355), 1,
      sym__scope_resolution,
    STATE(4346), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [238361] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(3578), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4855), 1,
      anon_sym_virtual,
    ACTIONS(8644), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(6306), 1,
      sym_virtual,
    STATE(6333), 1,
      sym__scope_resolution,
    STATE(6921), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [238397] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(3578), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4855), 1,
      anon_sym_virtual,
    ACTIONS(8644), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(6329), 1,
      sym_virtual,
    STATE(6333), 1,
      sym__scope_resolution,
    STATE(6936), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [238433] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7144), 1,
      anon_sym_requires,
    ACTIONS(7333), 1,
      anon_sym_DASH_GT,
    STATE(5956), 1,
      sym_trailing_return_type,
    ACTIONS(6939), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5948), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8312), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [238463] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7333), 1,
      anon_sym_DASH_GT,
    ACTIONS(8713), 1,
      anon_sym_requires,
    STATE(5964), 1,
      sym_trailing_return_type,
    ACTIONS(8680), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6005), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8665), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [238493] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9565), 1,
      anon_sym_LBRACK,
    STATE(3784), 1,
      sym_parameter_list,
    STATE(5783), 1,
      sym__function_declarator_seq,
    ACTIONS(9571), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [238519] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9565), 1,
      anon_sym_LBRACK,
    STATE(3784), 1,
      sym_parameter_list,
    STATE(5783), 1,
      sym__function_declarator_seq,
    ACTIONS(9569), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [238545] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9565), 1,
      anon_sym_LBRACK,
    STATE(3784), 1,
      sym_parameter_list,
    STATE(5783), 1,
      sym__function_declarator_seq,
    ACTIONS(9567), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [238571] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9858), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(5479), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [238591] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9565), 1,
      anon_sym_LBRACK,
    STATE(3784), 1,
      sym_parameter_list,
    STATE(5783), 1,
      sym__function_declarator_seq,
    ACTIONS(9563), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [238617] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8641), 1,
      anon_sym_requires,
    ACTIONS(8512), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5911), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8508), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [238643] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    STATE(3666), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9607), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [238673] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(6159), 1,
      anon_sym_LBRACE,
    ACTIONS(8466), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8650), 1,
      sym_identifier,
    STATE(2743), 1,
      sym_template_type,
    STATE(2930), 1,
      sym_enumerator_list,
    STATE(6368), 1,
      sym__scope_resolution,
    STATE(2720), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [238709] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9869), 1,
      anon_sym_LT,
    ACTIONS(9875), 1,
      anon_sym_LBRACK,
    STATE(6257), 1,
      sym_template_argument_list,
    ACTIONS(9873), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [238733] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(5297), 1,
      anon_sym_LBRACE,
    ACTIONS(8446), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8652), 1,
      sym_identifier,
    STATE(2051), 1,
      sym_template_type,
    STATE(2283), 1,
      sym_enumerator_list,
    STATE(6383), 1,
      sym__scope_resolution,
    STATE(2396), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [238769] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7333), 1,
      anon_sym_DASH_GT,
    ACTIONS(8622), 1,
      anon_sym_requires,
    STATE(5923), 1,
      sym_trailing_return_type,
    ACTIONS(8512), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5911), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8508), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [238799] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(7148), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8334), 1,
      anon_sym_LBRACE,
    ACTIONS(8627), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(4807), 1,
      sym_enumerator_list,
    STATE(6355), 1,
      sym__scope_resolution,
    STATE(4731), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [238835] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8554), 1,
      anon_sym_requires,
    ACTIONS(8322), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5948), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8312), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [238861] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(5728), 1,
      anon_sym_LBRACE,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8633), 1,
      sym_identifier,
    STATE(1901), 1,
      sym_template_type,
    STATE(2522), 1,
      sym_enumerator_list,
    STATE(6373), 1,
      sym__scope_resolution,
    STATE(4913), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [238897] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    STATE(2342), 1,
      sym_parameter_list,
    STATE(6243), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5471), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_try,
  [238925] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7333), 1,
      anon_sym_DASH_GT,
    ACTIONS(8526), 1,
      anon_sym_requires,
    STATE(5924), 1,
      sym_trailing_return_type,
    ACTIONS(8322), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5787), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5948), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8312), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [238955] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(8809), 1,
      anon_sym_try,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    ACTIONS(9711), 1,
      anon_sym_LBRACE,
    STATE(2128), 1,
      sym_try_statement,
    STATE(2129), 1,
      sym_compound_statement,
    STATE(3745), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [238990] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9526), 1,
      sym_identifier,
    ACTIONS(9877), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9879), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(9881), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(9883), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(6270), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(8153), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [239019] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7329), 1,
      anon_sym_requires,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5778), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8508), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [239046] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3759), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
    ACTIONS(9567), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [239071] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9887), 1,
      anon_sym_LBRACK,
    ACTIONS(9885), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [239090] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9891), 1,
      anon_sym_LBRACK,
    ACTIONS(9889), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [239109] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(8825), 1,
      anon_sym_try,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    ACTIONS(9699), 1,
      anon_sym_LBRACE,
    STATE(2186), 1,
      sym_try_statement,
    STATE(2188), 1,
      sym_compound_statement,
    STATE(3745), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [239144] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9895), 1,
      anon_sym_LBRACK,
    ACTIONS(9893), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [239163] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(675), 1,
      anon_sym_LBRACE,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    ACTIONS(9166), 1,
      anon_sym_try,
    STATE(745), 1,
      sym_try_statement,
    STATE(748), 1,
      sym_compound_statement,
    STATE(3745), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [239198] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(9357), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9897), 1,
      sym_identifier,
    STATE(5671), 1,
      sym__scope_resolution,
    STATE(7800), 1,
      sym_qualified_identifier,
    ACTIONS(9899), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [239229] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9903), 1,
      anon_sym_LBRACK,
    ACTIONS(9901), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [239248] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    STATE(3745), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9741), 4,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [239277] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    STATE(3745), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9652), 4,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [239306] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9749), 1,
      sym_identifier,
    ACTIONS(9905), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9907), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(9909), 1,
      aux_sym_preproc_elif_token1,
    STATE(6241), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(8236), 1,
      sym_enumerator,
    ACTIONS(9911), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(8222), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [239337] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3759), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
    ACTIONS(9579), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [239362] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    ACTIONS(9178), 1,
      anon_sym_try,
    STATE(833), 1,
      sym_try_statement,
    STATE(897), 1,
      sym_compound_statement,
    STATE(3745), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [239397] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7329), 1,
      anon_sym_requires,
    ACTIONS(8667), 1,
      anon_sym_LBRACK,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5771), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8665), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [239424] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    ACTIONS(9178), 1,
      anon_sym_try,
    STATE(864), 1,
      sym_compound_statement,
    STATE(891), 1,
      sym_try_statement,
    STATE(3745), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [239459] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9875), 1,
      anon_sym_LBRACK,
    ACTIONS(9873), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [239478] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(9357), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9913), 1,
      sym_identifier,
    STATE(5671), 1,
      sym__scope_resolution,
    STATE(7625), 1,
      sym_qualified_identifier,
    ACTIONS(9915), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [239509] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7329), 1,
      anon_sym_requires,
    ACTIONS(9214), 1,
      anon_sym_LBRACK,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5760), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9212), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [239536] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7329), 1,
      anon_sym_requires,
    ACTIONS(9224), 1,
      anon_sym_LBRACK,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5747), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9222), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [239563] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9749), 1,
      sym_identifier,
    ACTIONS(9907), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(9909), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(9917), 1,
      aux_sym_preproc_if_token2,
    STATE(6265), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(8236), 1,
      sym_enumerator,
    ACTIONS(9911), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(7638), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [239594] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3759), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
    ACTIONS(9577), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [239619] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9224), 1,
      anon_sym_LBRACK,
    ACTIONS(9919), 1,
      anon_sym_requires,
    ACTIONS(9258), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5747), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9222), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [239646] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(9357), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9922), 1,
      sym_identifier,
    STATE(5671), 1,
      sym__scope_resolution,
    STATE(7676), 1,
      sym_qualified_identifier,
    ACTIONS(9924), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [239677] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(675), 1,
      anon_sym_LBRACE,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    ACTIONS(9166), 1,
      anon_sym_try,
    STATE(741), 1,
      sym_compound_statement,
    STATE(742), 1,
      sym_try_statement,
    STATE(3745), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [239712] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9214), 1,
      anon_sym_LBRACK,
    ACTIONS(9785), 1,
      anon_sym_requires,
    ACTIONS(9250), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5760), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9212), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [239739] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8667), 1,
      anon_sym_LBRACK,
    ACTIONS(8957), 1,
      anon_sym_requires,
    ACTIONS(8692), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5771), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8665), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [239766] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9928), 1,
      anon_sym_LBRACK,
    ACTIONS(9926), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [239785] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9526), 1,
      sym_identifier,
    ACTIONS(9879), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(9881), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(9930), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9883), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(6268), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(7775), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [239814] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3759), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
    ACTIONS(9569), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [239839] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9749), 1,
      sym_identifier,
    ACTIONS(9907), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(9909), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(9932), 1,
      aux_sym_preproc_if_token2,
    STATE(6390), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(8236), 1,
      sym_enumerator,
    ACTIONS(9911), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(7767), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [239870] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3759), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
    ACTIONS(9573), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [239895] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5605), 1,
      anon_sym_LBRACK,
    STATE(5886), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5607), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_try,
  [239918] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(8809), 1,
      anon_sym_try,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    ACTIONS(9711), 1,
      anon_sym_LBRACE,
    STATE(2068), 1,
      sym_compound_statement,
    STATE(2070), 1,
      sym_try_statement,
    STATE(3745), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [239953] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8510), 1,
      anon_sym_LBRACK,
    ACTIONS(8698), 1,
      anon_sym_requires,
    ACTIONS(8548), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5778), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8508), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [239980] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9526), 1,
      sym_identifier,
    ACTIONS(9879), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(9881), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(9934), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9883), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(6426), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(7729), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [240009] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(617), 1,
      anon_sym_LBRACE,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    ACTIONS(9072), 1,
      anon_sym_try,
    STATE(751), 1,
      sym_try_statement,
    STATE(752), 1,
      sym_compound_statement,
    STATE(3745), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [240044] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7329), 1,
      anon_sym_requires,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(5577), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8312), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [240071] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8314), 1,
      anon_sym_LBRACK,
    ACTIONS(8616), 1,
      anon_sym_requires,
    ACTIONS(8438), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5658), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5731), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(8312), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [240098] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9938), 1,
      anon_sym_LBRACK,
    ACTIONS(9936), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [240117] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(8809), 1,
      anon_sym_try,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    ACTIONS(9711), 1,
      anon_sym_LBRACE,
    STATE(2123), 1,
      sym_try_statement,
    STATE(2124), 1,
      sym_compound_statement,
    STATE(3745), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [240152] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3759), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
    ACTIONS(9571), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [240177] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9528), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9749), 1,
      sym_identifier,
    ACTIONS(9907), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(9909), 1,
      aux_sym_preproc_elif_token1,
    STATE(6271), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(8236), 1,
      sym_enumerator,
    ACTIONS(9911), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(8154), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [240208] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    STATE(3745), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9607), 4,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [240237] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9940), 1,
      sym_identifier,
    ACTIONS(9943), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(9949), 1,
      sym_preproc_directive,
    ACTIONS(9952), 1,
      anon_sym_RBRACE,
    ACTIONS(9946), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7654), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(6255), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [240266] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(9357), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9954), 1,
      sym_identifier,
    STATE(5671), 1,
      sym__scope_resolution,
    STATE(8114), 1,
      sym_qualified_identifier,
    ACTIONS(9956), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [240297] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5783), 1,
      anon_sym_LBRACK,
    ACTIONS(5785), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [240316] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(8825), 1,
      anon_sym_try,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    ACTIONS(9699), 1,
      anon_sym_LBRACE,
    STATE(2181), 1,
      sym_compound_statement,
    STATE(2183), 1,
      sym_try_statement,
    STATE(3745), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [240351] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5428), 1,
      anon_sym_LBRACK,
    ACTIONS(9958), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9960), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(5430), 6,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [240374] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(8817), 1,
      anon_sym_try,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    ACTIONS(9613), 1,
      anon_sym_LBRACE,
    STATE(1820), 1,
      sym_try_statement,
    STATE(1821), 1,
      sym_compound_statement,
    STATE(3745), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [240409] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3343), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
    ACTIONS(9579), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [240434] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(8825), 1,
      anon_sym_try,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    ACTIONS(9699), 1,
      anon_sym_LBRACE,
    STATE(2191), 1,
      sym_compound_statement,
    STATE(2198), 1,
      sym_try_statement,
    STATE(3745), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [240469] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    ACTIONS(9178), 1,
      anon_sym_try,
    STATE(877), 1,
      sym_compound_statement,
    STATE(879), 1,
      sym_try_statement,
    STATE(3745), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [240504] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9596), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9749), 1,
      sym_identifier,
    ACTIONS(9907), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(9909), 1,
      aux_sym_preproc_elif_token1,
    STATE(6273), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(8236), 1,
      sym_enumerator,
    ACTIONS(9911), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(7715), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [240535] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9749), 1,
      sym_identifier,
    ACTIONS(9907), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(9909), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(9962), 1,
      aux_sym_preproc_if_token2,
    STATE(6390), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(8236), 1,
      sym_enumerator,
    ACTIONS(9911), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(8233), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [240566] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(8817), 1,
      anon_sym_try,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    ACTIONS(9613), 1,
      anon_sym_LBRACE,
    STATE(1853), 1,
      sym_try_statement,
    STATE(1854), 1,
      sym_compound_statement,
    STATE(3745), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [240601] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(287), 1,
      anon_sym_LBRACE,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    ACTIONS(9124), 1,
      anon_sym_try,
    STATE(339), 1,
      sym_compound_statement,
    STATE(340), 1,
      sym_try_statement,
    STATE(3745), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [240636] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9526), 1,
      sym_identifier,
    ACTIONS(9879), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(9881), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(9964), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9883), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(6426), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(8119), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [240665] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(8817), 1,
      anon_sym_try,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    ACTIONS(9613), 1,
      anon_sym_LBRACE,
    STATE(1848), 1,
      sym_try_statement,
    STATE(1851), 1,
      sym_compound_statement,
    STATE(3745), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [240700] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9526), 1,
      sym_identifier,
    ACTIONS(9879), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(9881), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(9966), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9883), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(6426), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(7918), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [240729] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9749), 1,
      sym_identifier,
    ACTIONS(9907), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(9909), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(9968), 1,
      aux_sym_preproc_if_token2,
    STATE(6390), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(8236), 1,
      sym_enumerator,
    ACTIONS(9911), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(7928), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [240760] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9526), 1,
      sym_identifier,
    ACTIONS(9879), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(9881), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(9970), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9883), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(6426), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(8265), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [240789] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9749), 1,
      sym_identifier,
    ACTIONS(9907), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(9909), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(9972), 1,
      aux_sym_preproc_if_token2,
    STATE(6390), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(8236), 1,
      sym_enumerator,
    ACTIONS(9911), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(8142), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [240820] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9976), 1,
      anon_sym_LBRACK,
    ACTIONS(9974), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [240839] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5662), 1,
      anon_sym_LBRACK,
    ACTIONS(5664), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [240858] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(287), 1,
      anon_sym_LBRACE,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    ACTIONS(9124), 1,
      anon_sym_try,
    STATE(386), 1,
      sym_try_statement,
    STATE(387), 1,
      sym_compound_statement,
    STATE(3745), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [240893] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3759), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
    ACTIONS(9563), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [240918] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(617), 1,
      anon_sym_LBRACE,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    ACTIONS(9072), 1,
      anon_sym_try,
    STATE(688), 1,
      sym_compound_statement,
    STATE(689), 1,
      sym_try_statement,
    STATE(3745), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [240953] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    STATE(3745), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9654), 4,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [240982] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(9357), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9978), 1,
      sym_identifier,
    STATE(5671), 1,
      sym__scope_resolution,
    STATE(8063), 1,
      sym_qualified_identifier,
    ACTIONS(9980), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [241013] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3759), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
    ACTIONS(9575), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [241038] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(287), 1,
      anon_sym_LBRACE,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    ACTIONS(9124), 1,
      anon_sym_try,
    STATE(329), 1,
      sym_compound_statement,
    STATE(330), 1,
      sym_try_statement,
    STATE(3745), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [241073] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3343), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
    ACTIONS(9569), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [241098] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    STATE(3745), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9603), 4,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [241127] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3343), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
    ACTIONS(9567), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [241152] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(9357), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9982), 1,
      sym_identifier,
    STATE(5671), 1,
      sym__scope_resolution,
    STATE(7960), 1,
      sym_qualified_identifier,
    ACTIONS(9984), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [241183] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3343), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
    ACTIONS(9575), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [241208] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(675), 1,
      anon_sym_LBRACE,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    ACTIONS(9166), 1,
      anon_sym_try,
    STATE(715), 1,
      sym_try_statement,
    STATE(720), 1,
      sym_compound_statement,
    STATE(3745), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [241243] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(9357), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9986), 1,
      sym_identifier,
    STATE(5671), 1,
      sym__scope_resolution,
    STATE(8092), 1,
      sym_qualified_identifier,
    ACTIONS(9988), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [241274] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(617), 1,
      anon_sym_LBRACE,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    ACTIONS(9072), 1,
      anon_sym_try,
    STATE(746), 1,
      sym_try_statement,
    STATE(747), 1,
      sym_compound_statement,
    STATE(3745), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [241309] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5477), 1,
      anon_sym_LBRACK,
    ACTIONS(9960), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(5479), 8,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [241330] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    ACTIONS(9992), 1,
      anon_sym_EQ,
    STATE(3666), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    ACTIONS(9990), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [241360] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9998), 1,
      anon_sym_delete,
    ACTIONS(10000), 1,
      anon_sym_new,
    ACTIONS(9996), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(9994), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [241382] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10002), 1,
      anon_sym_delete,
    ACTIONS(10004), 1,
      anon_sym_new,
    ACTIONS(9996), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(9994), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [241404] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10006), 1,
      anon_sym_delete,
    ACTIONS(10008), 1,
      anon_sym_new,
    ACTIONS(9996), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(9994), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [241426] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3826), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
    ACTIONS(9563), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [241450] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3826), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
    ACTIONS(9567), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [241474] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3826), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
    ACTIONS(9569), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [241498] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4530), 1,
      anon_sym_LBRACK,
    ACTIONS(4532), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [241516] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4555), 1,
      anon_sym_LBRACK,
    ACTIONS(4557), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [241534] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10010), 1,
      anon_sym_delete,
    ACTIONS(10012), 1,
      anon_sym_new,
    ACTIONS(9996), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(9994), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [241556] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3826), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
    ACTIONS(9571), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [241580] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10014), 1,
      anon_sym_delete,
    ACTIONS(10016), 1,
      anon_sym_new,
    ACTIONS(9996), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(9994), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [241602] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3826), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
    ACTIONS(9573), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [241626] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    ACTIONS(10018), 1,
      anon_sym_EQ,
    STATE(3666), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    ACTIONS(9990), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [241656] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(3578), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8644), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(6333), 1,
      sym__scope_resolution,
    STATE(6859), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [241686] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10020), 1,
      anon_sym_delete,
    ACTIONS(10022), 1,
      anon_sym_new,
    ACTIONS(9996), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(9994), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [241708] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4563), 1,
      anon_sym_LBRACK,
    ACTIONS(4565), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [241726] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3826), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
    ACTIONS(9575), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [241750] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3826), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
    ACTIONS(9577), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [241774] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3826), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
    ACTIONS(9579), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [241798] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4567), 1,
      anon_sym_LBRACK,
    ACTIONS(4569), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [241816] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(10024), 1,
      sym_identifier,
    ACTIONS(10026), 1,
      anon_sym_COLON_COLON,
    STATE(2683), 1,
      sym_template_type,
    STATE(6358), 1,
      sym__scope_resolution,
    STATE(2645), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [241846] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3194), 1,
      anon_sym_LBRACE,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    ACTIONS(10028), 1,
      anon_sym_EQ,
    STATE(3666), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(8283), 1,
      sym_initializer_list,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [241878] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10032), 1,
      anon_sym_LBRACK,
    STATE(6845), 1,
      sym_gnu_asm_input_operand,
    STATE(8043), 1,
      sym_string_literal,
    ACTIONS(10030), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [241902] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4571), 1,
      anon_sym_LBRACK,
    ACTIONS(4573), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [241920] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10034), 1,
      anon_sym_delete,
    ACTIONS(10036), 1,
      anon_sym_new,
    ACTIONS(9996), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(9994), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [241942] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(10038), 1,
      anon_sym_COMMA,
    STATE(2342), 1,
      sym_parameter_list,
    STATE(6709), 1,
      aux_sym__type_definition_declarators_repeat1,
    ACTIONS(10040), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
    STATE(6243), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [241972] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10042), 1,
      anon_sym_delete,
    ACTIONS(10044), 1,
      anon_sym_new,
    ACTIONS(9996), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(9994), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [241994] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10000), 1,
      anon_sym_new,
    ACTIONS(10046), 1,
      anon_sym_delete,
    ACTIONS(9996), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(9994), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [242016] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(3578), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8644), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(6333), 1,
      sym__scope_resolution,
    STATE(6843), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [242046] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10008), 1,
      anon_sym_new,
    ACTIONS(10048), 1,
      anon_sym_delete,
    ACTIONS(9996), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(9994), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [242068] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4559), 1,
      anon_sym_LBRACK,
    ACTIONS(4561), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [242086] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10050), 1,
      anon_sym_delete,
    ACTIONS(10052), 1,
      anon_sym_new,
    ACTIONS(9996), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(9994), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [242108] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(3578), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8644), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(6333), 1,
      sym__scope_resolution,
    STATE(6676), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [242138] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4551), 1,
      anon_sym_LBRACK,
    ACTIONS(4553), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [242156] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10036), 1,
      anon_sym_new,
    ACTIONS(10054), 1,
      anon_sym_delete,
    ACTIONS(9996), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(9994), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [242178] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10000), 1,
      anon_sym_new,
    ACTIONS(10056), 1,
      anon_sym_delete,
    ACTIONS(9996), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(9994), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [242200] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(3578), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8644), 1,
      sym_identifier,
    STATE(2421), 1,
      sym_template_type,
    STATE(6333), 1,
      sym__scope_resolution,
    STATE(6921), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8290), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [242230] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10060), 1,
      anon_sym_LBRACK,
    STATE(6749), 1,
      sym_gnu_asm_output_operand,
    STATE(7910), 1,
      sym_string_literal,
    ACTIONS(10058), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [242254] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4635), 1,
      anon_sym_LBRACE,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10062), 1,
      sym_identifier,
    ACTIONS(10064), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10066), 1,
      anon_sym_inline,
    STATE(886), 1,
      sym_declaration_list,
    STATE(6446), 1,
      sym_attribute_declaration,
    STATE(7401), 1,
      sym_nested_namespace_specifier,
    STATE(8107), 1,
      sym__namespace_specifier,
  [242285] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(9357), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10068), 1,
      sym_identifier,
    STATE(5671), 1,
      sym__scope_resolution,
    STATE(7682), 1,
      sym_qualified_identifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [242312] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(3578), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10070), 1,
      sym_identifier,
    STATE(2403), 1,
      sym_qualified_type_identifier,
    STATE(2408), 1,
      sym_dependent_type_identifier,
    STATE(2422), 1,
      sym_template_type,
    STATE(6333), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_decltype,
  [242343] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4633), 1,
      anon_sym_LBRACE,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10064), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10066), 1,
      anon_sym_inline,
    ACTIONS(10072), 1,
      sym_identifier,
    STATE(766), 1,
      sym_declaration_list,
    STATE(6458), 1,
      sym_attribute_declaration,
    STATE(7365), 1,
      sym_nested_namespace_specifier,
    STATE(8107), 1,
      sym__namespace_specifier,
  [242374] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4629), 1,
      anon_sym_LBRACE,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10064), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10066), 1,
      anon_sym_inline,
    ACTIONS(10074), 1,
      sym_identifier,
    STATE(347), 1,
      sym_declaration_list,
    STATE(6450), 1,
      sym_attribute_declaration,
    STATE(7355), 1,
      sym_nested_namespace_specifier,
    STATE(8107), 1,
      sym__namespace_specifier,
  [242405] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(7206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10070), 1,
      sym_identifier,
    STATE(2408), 1,
      sym_dependent_type_identifier,
    STATE(2422), 1,
      sym_template_type,
    STATE(3080), 1,
      sym_qualified_type_identifier,
    STATE(6336), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_decltype,
  [242436] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(8340), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10076), 1,
      sym_identifier,
    ACTIONS(10078), 1,
      anon_sym_template,
    STATE(1865), 1,
      sym_template_type,
    STATE(1869), 1,
      sym_dependent_type_identifier,
    STATE(1987), 1,
      sym_qualified_type_identifier,
    STATE(6337), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_decltype,
  [242467] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10080), 1,
      sym_identifier,
    ACTIONS(10084), 1,
      sym_system_lib_string,
    STATE(8306), 2,
      sym_preproc_call_expression,
      sym_string_literal,
    ACTIONS(10082), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [242488] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(7235), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10086), 1,
      sym_identifier,
    ACTIONS(10088), 1,
      anon_sym_template,
    STATE(2708), 1,
      sym_dependent_type_identifier,
    STATE(2721), 1,
      sym_template_type,
    STATE(2752), 1,
      sym_qualified_type_identifier,
    STATE(6339), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_decltype,
  [242519] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10090), 1,
      sym_identifier,
    ACTIONS(10092), 1,
      sym_system_lib_string,
    STATE(8149), 2,
      sym_preproc_call_expression,
      sym_string_literal,
    ACTIONS(10082), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [242540] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5428), 1,
      anon_sym_AMP,
    ACTIONS(10094), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10096), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(5430), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [242561] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(7170), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10098), 1,
      sym_identifier,
    ACTIONS(10100), 1,
      anon_sym_template,
    STATE(4708), 1,
      sym_template_type,
    STATE(4709), 1,
      sym_dependent_type_identifier,
    STATE(4758), 1,
      sym_qualified_type_identifier,
    STATE(6342), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_decltype,
  [242592] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(9357), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10102), 1,
      sym_identifier,
    STATE(5671), 1,
      sym__scope_resolution,
    STATE(7663), 1,
      sym_qualified_identifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [242619] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6103), 1,
      anon_sym_LT,
    STATE(2854), 1,
      sym_template_argument_list,
    ACTIONS(4543), 2,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(4536), 4,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
  [242642] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9565), 1,
      anon_sym_LBRACK,
    STATE(3964), 1,
      sym_parameter_list,
    STATE(5783), 1,
      sym__function_declarator_seq,
    ACTIONS(9563), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [242665] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4627), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10104), 1,
      sym_identifier,
    ACTIONS(10106), 1,
      anon_sym_template,
    STATE(2403), 1,
      sym_qualified_type_identifier,
    STATE(2408), 1,
      sym_dependent_type_identifier,
    STATE(2422), 1,
      sym_template_type,
    STATE(6346), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_decltype,
  [242696] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9565), 1,
      anon_sym_LBRACK,
    STATE(3964), 1,
      sym_parameter_list,
    STATE(5783), 1,
      sym__function_declarator_seq,
    ACTIONS(9567), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [242719] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(8410), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10108), 1,
      sym_identifier,
    ACTIONS(10110), 1,
      anon_sym_template,
    STATE(2699), 1,
      sym_dependent_type_identifier,
    STATE(2701), 1,
      sym_template_type,
    STATE(2711), 1,
      sym_qualified_type_identifier,
    STATE(6348), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_decltype,
  [242750] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(8376), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10112), 1,
      sym_identifier,
    ACTIONS(10114), 1,
      anon_sym_template,
    STATE(2819), 1,
      sym_dependent_type_identifier,
    STATE(2820), 1,
      sym_template_type,
    STATE(2919), 1,
      sym_qualified_type_identifier,
    STATE(6349), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_decltype,
  [242781] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(9357), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10116), 1,
      sym_identifier,
    STATE(5671), 1,
      sym__scope_resolution,
    STATE(7613), 1,
      sym_qualified_identifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [242808] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9565), 1,
      anon_sym_LBRACK,
    STATE(3964), 1,
      sym_parameter_list,
    STATE(5783), 1,
      sym__function_declarator_seq,
    ACTIONS(9569), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [242831] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9565), 1,
      anon_sym_LBRACK,
    STATE(3964), 1,
      sym_parameter_list,
    STATE(5783), 1,
      sym__function_declarator_seq,
    ACTIONS(9571), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [242854] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4631), 1,
      anon_sym_LBRACE,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10064), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10066), 1,
      anon_sym_inline,
    ACTIONS(10118), 1,
      sym_identifier,
    STATE(681), 1,
      sym_declaration_list,
    STATE(6477), 1,
      sym_attribute_declaration,
    STATE(7334), 1,
      sym_nested_namespace_specifier,
    STATE(8107), 1,
      sym__namespace_specifier,
  [242885] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9565), 1,
      anon_sym_LBRACK,
    STATE(3964), 1,
      sym_parameter_list,
    STATE(5783), 1,
      sym__function_declarator_seq,
    ACTIONS(9573), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [242908] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(7148), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10120), 1,
      sym_identifier,
    ACTIONS(10122), 1,
      anon_sym_template,
    STATE(2408), 1,
      sym_dependent_type_identifier,
    STATE(2422), 1,
      sym_template_type,
    STATE(3080), 1,
      sym_qualified_type_identifier,
    STATE(6355), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_decltype,
  [242939] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(8661), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10104), 1,
      sym_identifier,
    ACTIONS(10106), 1,
      anon_sym_template,
    STATE(2408), 1,
      sym_dependent_type_identifier,
    STATE(2422), 1,
      sym_template_type,
    STATE(3080), 1,
      sym_qualified_type_identifier,
    STATE(6356), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_decltype,
  [242970] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(9357), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10124), 1,
      sym_identifier,
    STATE(5671), 1,
      sym__scope_resolution,
    STATE(7631), 1,
      sym_qualified_identifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [242997] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(10026), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10126), 1,
      sym_identifier,
    ACTIONS(10128), 1,
      anon_sym_template,
    STATE(2671), 1,
      sym_template_type,
    STATE(2672), 1,
      sym_dependent_type_identifier,
    STATE(2675), 1,
      sym_qualified_type_identifier,
    STATE(6358), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_decltype,
  [243028] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5477), 1,
      anon_sym_AMP,
    ACTIONS(10096), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(5479), 6,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_or,
  [243047] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10130), 1,
      sym_identifier,
    ACTIONS(10132), 1,
      sym_system_lib_string,
    STATE(8207), 2,
      sym_preproc_call_expression,
      sym_string_literal,
    ACTIONS(10082), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [243068] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(8925), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10134), 1,
      sym_identifier,
    ACTIONS(10136), 1,
      anon_sym_template,
    STATE(2257), 1,
      sym_template_type,
    STATE(2259), 1,
      sym_qualified_type_identifier,
    STATE(2282), 1,
      sym_dependent_type_identifier,
    STATE(6361), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_decltype,
  [243099] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6103), 1,
      anon_sym_LT,
    STATE(2854), 1,
      sym_template_argument_list,
    ACTIONS(7300), 2,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(4601), 4,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
  [243122] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(9357), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10138), 1,
      sym_identifier,
    STATE(5671), 1,
      sym__scope_resolution,
    STATE(7989), 1,
      sym_qualified_identifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [243149] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4635), 1,
      anon_sym_LBRACE,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10064), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10066), 1,
      anon_sym_inline,
    ACTIONS(10140), 1,
      sym_identifier,
    STATE(862), 1,
      sym_declaration_list,
    STATE(6480), 1,
      sym_attribute_declaration,
    STATE(7322), 1,
      sym_nested_namespace_specifier,
    STATE(8107), 1,
      sym__namespace_specifier,
  [243180] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(7128), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10142), 1,
      sym_identifier,
    ACTIONS(10144), 1,
      anon_sym_template,
    STATE(1865), 1,
      sym_template_type,
    STATE(1869), 1,
      sym_dependent_type_identifier,
    STATE(1987), 1,
      sym_qualified_type_identifier,
    STATE(6365), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_decltype,
  [243211] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9565), 1,
      anon_sym_LBRACK,
    STATE(3964), 1,
      sym_parameter_list,
    STATE(5783), 1,
      sym__function_declarator_seq,
    ACTIONS(9575), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [243234] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(8863), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10146), 1,
      sym_identifier,
    ACTIONS(10148), 1,
      anon_sym_template,
    STATE(1865), 1,
      sym_template_type,
    STATE(1869), 1,
      sym_dependent_type_identifier,
    STATE(1987), 1,
      sym_qualified_type_identifier,
    STATE(6367), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_decltype,
  [243265] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(8466), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10150), 1,
      sym_identifier,
    ACTIONS(10152), 1,
      anon_sym_template,
    STATE(2744), 1,
      sym_template_type,
    STATE(2746), 1,
      sym_dependent_type_identifier,
    STATE(2786), 1,
      sym_qualified_type_identifier,
    STATE(6368), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_decltype,
  [243296] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4633), 1,
      anon_sym_LBRACE,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10064), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10066), 1,
      anon_sym_inline,
    ACTIONS(10154), 1,
      sym_identifier,
    STATE(693), 1,
      sym_declaration_list,
    STATE(6444), 1,
      sym_attribute_declaration,
    STATE(7288), 1,
      sym_nested_namespace_specifier,
    STATE(8107), 1,
      sym__namespace_specifier,
  [243327] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9565), 1,
      anon_sym_LBRACK,
    STATE(3964), 1,
      sym_parameter_list,
    STATE(5783), 1,
      sym__function_declarator_seq,
    ACTIONS(9577), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [243350] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(7192), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10120), 1,
      sym_identifier,
    ACTIONS(10122), 1,
      anon_sym_template,
    STATE(2403), 1,
      sym_qualified_type_identifier,
    STATE(2408), 1,
      sym_dependent_type_identifier,
    STATE(2422), 1,
      sym_template_type,
    STATE(6371), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_decltype,
  [243381] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9565), 1,
      anon_sym_LBRACK,
    STATE(3964), 1,
      sym_parameter_list,
    STATE(5783), 1,
      sym__function_declarator_seq,
    ACTIONS(9579), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [243404] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(7115), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10078), 1,
      anon_sym_template,
    ACTIONS(10156), 1,
      sym_identifier,
    STATE(1865), 1,
      sym_template_type,
    STATE(1869), 1,
      sym_dependent_type_identifier,
    STATE(1987), 1,
      sym_qualified_type_identifier,
    STATE(6373), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_decltype,
  [243435] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10158), 1,
      sym_identifier,
    ACTIONS(10160), 1,
      sym_system_lib_string,
    STATE(8077), 2,
      sym_preproc_call_expression,
      sym_string_literal,
    ACTIONS(10082), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [243456] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4629), 1,
      anon_sym_LBRACE,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10064), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10066), 1,
      anon_sym_inline,
    ACTIONS(10162), 1,
      sym_identifier,
    STATE(419), 1,
      sym_declaration_list,
    STATE(6454), 1,
      sym_attribute_declaration,
    STATE(7473), 1,
      sym_nested_namespace_specifier,
    STATE(8107), 1,
      sym__namespace_specifier,
  [243487] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(8396), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10088), 1,
      anon_sym_template,
    ACTIONS(10164), 1,
      sym_identifier,
    STATE(2708), 1,
      sym_dependent_type_identifier,
    STATE(2721), 1,
      sym_template_type,
    STATE(2752), 1,
      sym_qualified_type_identifier,
    STATE(6376), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_decltype,
  [243518] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(8354), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10166), 1,
      sym_identifier,
    ACTIONS(10168), 1,
      anon_sym_template,
    STATE(3763), 1,
      sym_template_type,
    STATE(3771), 1,
      sym_dependent_type_identifier,
    STATE(3803), 1,
      sym_qualified_type_identifier,
    STATE(6377), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_decltype,
  [243549] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    STATE(2342), 1,
      sym_parameter_list,
    STATE(6243), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10170), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [243574] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(9357), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10172), 1,
      sym_identifier,
    STATE(5671), 1,
      sym__scope_resolution,
    STATE(8213), 1,
      sym_qualified_identifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [243601] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(4526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10174), 1,
      sym_identifier,
    ACTIONS(10176), 1,
      anon_sym_template,
    STATE(2403), 1,
      sym_qualified_type_identifier,
    STATE(2408), 1,
      sym_dependent_type_identifier,
    STATE(2422), 1,
      sym_template_type,
    STATE(6380), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_decltype,
  [243632] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4631), 1,
      anon_sym_LBRACE,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10064), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10066), 1,
      anon_sym_inline,
    ACTIONS(10178), 1,
      sym_identifier,
    STATE(707), 1,
      sym_declaration_list,
    STATE(6445), 1,
      sym_attribute_declaration,
    STATE(7313), 1,
      sym_nested_namespace_specifier,
    STATE(8107), 1,
      sym__namespace_specifier,
  [243663] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10182), 1,
      anon_sym_AMP,
    ACTIONS(10184), 2,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(10180), 6,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [243682] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(8446), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10186), 1,
      sym_identifier,
    ACTIONS(10188), 1,
      anon_sym_template,
    STATE(2034), 1,
      sym_dependent_type_identifier,
    STATE(2038), 1,
      sym_template_type,
    STATE(2114), 1,
      sym_qualified_type_identifier,
    STATE(6383), 1,
      sym__scope_resolution,
    STATE(8290), 1,
      sym_decltype,
  [243713] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_template,
    ACTIONS(1917), 1,
      anon_sym_decltype,
    ACTIONS(9357), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10190), 1,
      sym_identifier,
    STATE(5671), 1,
      sym__scope_resolution,
    STATE(7848), 1,
      sym_qualified_identifier,
    STATE(8290), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [243740] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3980), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
    ACTIONS(9579), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [243762] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    ACTIONS(10192), 1,
      anon_sym_SEMI,
    STATE(3745), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [243788] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3980), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
    ACTIONS(9569), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [243810] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10196), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(10194), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [243826] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    ACTIONS(10198), 1,
      anon_sym_RPAREN,
    STATE(3745), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [243852] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10200), 1,
      sym_identifier,
    ACTIONS(10205), 1,
      aux_sym_preproc_elif_token1,
    STATE(6390), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(8236), 1,
      sym_enumerator,
    ACTIONS(10203), 4,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
  [243874] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(8803), 1,
      anon_sym_LBRACK,
    ACTIONS(10207), 1,
      anon_sym_RPAREN,
    STATE(3745), 1,
      sym_parameter_list,
    STATE(6214), 1,
      sym__function_declarator_seq,
    STATE(6503), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [243900] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3980), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
    ACTIONS(9567), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [243922] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6103), 1,
      anon_sym_LT,
    ACTIONS(10209), 1,
      anon_sym_SEMI,
    ACTIONS(10211), 1,
      anon_sym_EQ,
    STATE(1741), 1,
      sym_template_argument_list,
    STATE(6602), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [243948] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3980), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
    ACTIONS(9571), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [243970] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3980), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
    ACTIONS(9573), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [243992] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10060), 1,
      anon_sym_LBRACK,
    STATE(6939), 1,
      sym_gnu_asm_output_operand,
    STATE(7910), 1,
      sym_string_literal,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [244012] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    ACTIONS(10213), 1,
      anon_sym_SEMI,
    STATE(3745), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [244038] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10217), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(10219), 1,
      anon_sym_EQ,
    ACTIONS(10215), 6,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_identifier,
  [244056] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5750), 1,
      anon_sym_LBRACK,
    ACTIONS(6103), 1,
      anon_sym_LT,
    STATE(2854), 1,
      sym_template_argument_list,
    ACTIONS(5752), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [244076] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    ACTIONS(10221), 1,
      anon_sym_SEMI,
    STATE(3745), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [244102] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6103), 1,
      anon_sym_LT,
    ACTIONS(10223), 1,
      anon_sym_SEMI,
    ACTIONS(10225), 1,
      anon_sym_EQ,
    STATE(1741), 1,
      sym_template_argument_list,
    STATE(6723), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [244128] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6103), 1,
      anon_sym_LT,
    ACTIONS(7300), 1,
      anon_sym_LBRACK,
    STATE(5917), 1,
      sym_template_argument_list,
    ACTIONS(4601), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [244150] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(8803), 1,
      anon_sym_LBRACK,
    ACTIONS(9664), 1,
      anon_sym_RPAREN,
    STATE(3745), 1,
      sym_parameter_list,
    STATE(6214), 1,
      sym__function_declarator_seq,
    STATE(6503), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [244176] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(8803), 1,
      anon_sym_LBRACK,
    ACTIONS(9662), 1,
      anon_sym_RPAREN,
    STATE(3745), 1,
      sym_parameter_list,
    STATE(6214), 1,
      sym__function_declarator_seq,
    STATE(6503), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [244202] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(8803), 1,
      anon_sym_LBRACK,
    ACTIONS(10227), 1,
      anon_sym_RPAREN,
    STATE(3745), 1,
      sym_parameter_list,
    STATE(6214), 1,
      sym__function_declarator_seq,
    STATE(6503), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [244228] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    ACTIONS(10229), 1,
      anon_sym_SEMI,
    STATE(3745), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [244254] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7331), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    ACTIONS(10231), 1,
      anon_sym_COLON,
    STATE(3970), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6155), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [244280] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6103), 1,
      anon_sym_LT,
    ACTIONS(10233), 1,
      anon_sym_SEMI,
    ACTIONS(10235), 1,
      anon_sym_EQ,
    STATE(1741), 1,
      sym_template_argument_list,
    STATE(6815), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [244306] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7331), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    ACTIONS(9652), 1,
      anon_sym_COLON,
    STATE(3970), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6155), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [244332] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(8803), 1,
      anon_sym_LBRACK,
    ACTIONS(9691), 1,
      anon_sym_RPAREN,
    STATE(3745), 1,
      sym_parameter_list,
    STATE(6214), 1,
      sym__function_declarator_seq,
    STATE(6503), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [244358] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3980), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
    ACTIONS(9575), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [244380] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10239), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(10237), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [244396] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3980), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
    ACTIONS(9577), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [244418] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7331), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    ACTIONS(9654), 1,
      anon_sym_COLON,
    STATE(3970), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6155), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [244444] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6103), 1,
      anon_sym_LT,
    ACTIONS(10241), 1,
      anon_sym_SEMI,
    ACTIONS(10243), 1,
      anon_sym_EQ,
    STATE(1741), 1,
      sym_template_argument_list,
    STATE(6647), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [244470] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7331), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    ACTIONS(9607), 1,
      anon_sym_COLON,
    STATE(3970), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6155), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [244496] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3980), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
    ACTIONS(9563), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [244518] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7331), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    ACTIONS(9603), 1,
      anon_sym_COLON,
    STATE(3970), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6155), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [244544] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(8803), 1,
      anon_sym_LBRACK,
    ACTIONS(9707), 1,
      anon_sym_RPAREN,
    STATE(3745), 1,
      sym_parameter_list,
    STATE(6214), 1,
      sym__function_declarator_seq,
    STATE(6503), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [244570] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4543), 1,
      anon_sym_LBRACK,
    ACTIONS(6103), 1,
      anon_sym_LT,
    STATE(5917), 1,
      sym_template_argument_list,
    ACTIONS(4536), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [244592] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(8803), 1,
      anon_sym_LBRACK,
    ACTIONS(9598), 1,
      anon_sym_RPAREN,
    STATE(3745), 1,
      sym_parameter_list,
    STATE(6214), 1,
      sym__function_declarator_seq,
    STATE(6503), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [244618] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    ACTIONS(10245), 1,
      anon_sym_SEMI,
    STATE(3745), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [244644] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6103), 1,
      anon_sym_LT,
    ACTIONS(10247), 1,
      anon_sym_SEMI,
    ACTIONS(10249), 1,
      anon_sym_EQ,
    STATE(1741), 1,
      sym_template_argument_list,
    STATE(6687), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [244670] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6103), 1,
      anon_sym_LT,
    ACTIONS(10251), 1,
      anon_sym_SEMI,
    ACTIONS(10253), 1,
      anon_sym_EQ,
    STATE(1741), 1,
      sym_template_argument_list,
    STATE(6623), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [244696] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    ACTIONS(10255), 1,
      anon_sym_SEMI,
    STATE(3745), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [244722] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10257), 1,
      sym_identifier,
    ACTIONS(10262), 1,
      aux_sym_preproc_elif_token1,
    STATE(6426), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    ACTIONS(10260), 4,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
  [244742] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10032), 1,
      anon_sym_LBRACK,
    STATE(7160), 1,
      sym_gnu_asm_input_operand,
    STATE(8043), 1,
      sym_string_literal,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [244762] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6103), 1,
      anon_sym_LT,
    ACTIONS(10264), 1,
      anon_sym_SEMI,
    ACTIONS(10266), 1,
      anon_sym_EQ,
    STATE(1741), 1,
      sym_template_argument_list,
    STATE(6799), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [244788] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3343), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
    ACTIONS(10268), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [244810] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    ACTIONS(10270), 1,
      anon_sym_SEMI,
    STATE(3745), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [244836] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7331), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    ACTIONS(9741), 1,
      anon_sym_COLON,
    STATE(3970), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6155), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [244862] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    ACTIONS(10272), 1,
      anon_sym_SEMI,
    STATE(3745), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [244888] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    ACTIONS(10274), 1,
      anon_sym_RPAREN,
    STATE(3745), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [244914] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(10276), 1,
      anon_sym_RPAREN,
    STATE(2342), 1,
      sym_parameter_list,
    STATE(6243), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [244937] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
    ACTIONS(9575), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [244958] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3830), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
    ACTIONS(9573), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
  [244979] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
    ACTIONS(9563), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [245000] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3194), 1,
      anon_sym_LBRACE,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6103), 1,
      anon_sym_LT,
    ACTIONS(7307), 1,
      anon_sym_LPAREN2,
    STATE(2415), 1,
      sym_template_argument_list,
    STATE(7157), 2,
      sym_argument_list,
      sym_initializer_list,
  [245023] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3830), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
    ACTIONS(9571), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
  [245044] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5652), 1,
      anon_sym_AMP,
    ACTIONS(5654), 6,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_requires,
  [245059] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5392), 1,
      anon_sym_COLON,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(7331), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    STATE(2342), 1,
      sym_parameter_list,
    STATE(6487), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [245082] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(10278), 1,
      anon_sym_RPAREN,
    STATE(2342), 1,
      sym_parameter_list,
    STATE(6243), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [245105] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3830), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
    ACTIONS(9577), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
  [245126] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4633), 1,
      anon_sym_LBRACE,
    ACTIONS(10064), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10066), 1,
      anon_sym_inline,
    ACTIONS(10072), 1,
      sym_identifier,
    STATE(766), 1,
      sym_declaration_list,
    STATE(7365), 1,
      sym_nested_namespace_specifier,
    STATE(8107), 1,
      sym__namespace_specifier,
  [245151] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4631), 1,
      anon_sym_LBRACE,
    ACTIONS(10064), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10066), 1,
      anon_sym_inline,
    ACTIONS(10280), 1,
      sym_identifier,
    STATE(780), 1,
      sym_declaration_list,
    STATE(7289), 1,
      sym_nested_namespace_specifier,
    STATE(8107), 1,
      sym__namespace_specifier,
  [245176] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4635), 1,
      anon_sym_LBRACE,
    ACTIONS(10064), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10066), 1,
      anon_sym_inline,
    ACTIONS(10140), 1,
      sym_identifier,
    STATE(862), 1,
      sym_declaration_list,
    STATE(7322), 1,
      sym_nested_namespace_specifier,
    STATE(8107), 1,
      sym__namespace_specifier,
  [245201] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5471), 1,
      anon_sym_COLON,
    ACTIONS(7331), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    STATE(2342), 1,
      sym_parameter_list,
    STATE(6487), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [245224] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(10282), 1,
      anon_sym_RPAREN,
    STATE(2342), 1,
      sym_parameter_list,
    STATE(6243), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [245247] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
    ACTIONS(9579), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [245268] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4629), 1,
      anon_sym_LBRACE,
    ACTIONS(10064), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10066), 1,
      anon_sym_inline,
    ACTIONS(10162), 1,
      sym_identifier,
    STATE(419), 1,
      sym_declaration_list,
    STATE(7473), 1,
      sym_nested_namespace_specifier,
    STATE(8107), 1,
      sym__namespace_specifier,
  [245293] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(10284), 1,
      anon_sym_RPAREN,
    STATE(2342), 1,
      sym_parameter_list,
    STATE(6243), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [245316] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5648), 1,
      anon_sym_AMP,
    ACTIONS(5650), 6,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_requires,
  [245331] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10288), 1,
      anon_sym_AMP,
    ACTIONS(10286), 6,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [245346] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4629), 1,
      anon_sym_LBRACE,
    ACTIONS(10064), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10066), 1,
      anon_sym_inline,
    ACTIONS(10290), 1,
      sym_identifier,
    STATE(365), 1,
      sym_declaration_list,
    STATE(7341), 1,
      sym_nested_namespace_specifier,
    STATE(8107), 1,
      sym__namespace_specifier,
  [245371] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4086), 1,
      anon_sym_AMP,
    ACTIONS(4084), 6,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [245386] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3830), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
    ACTIONS(9563), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
  [245407] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5444), 1,
      anon_sym_COLON,
    ACTIONS(7331), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    STATE(2342), 1,
      sym_parameter_list,
    STATE(6487), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [245430] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4633), 1,
      anon_sym_LBRACE,
    ACTIONS(10064), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10066), 1,
      anon_sym_inline,
    ACTIONS(10292), 1,
      sym_identifier,
    STATE(776), 1,
      sym_declaration_list,
    STATE(7559), 1,
      sym_nested_namespace_specifier,
    STATE(8107), 1,
      sym__namespace_specifier,
  [245455] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10296), 1,
      anon_sym_AMP,
    ACTIONS(10294), 6,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [245470] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10300), 1,
      anon_sym_COMMA,
    ACTIONS(10302), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(10298), 5,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_identifier,
  [245487] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10306), 1,
      anon_sym_AMP,
    ACTIONS(10304), 6,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [245502] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10308), 1,
      anon_sym_LBRACK,
    ACTIONS(10311), 1,
      anon_sym_EQ,
    ACTIONS(10313), 1,
      anon_sym_DOT,
    STATE(6462), 4,
      sym_subscript_designator,
      sym_subscript_range_designator,
      sym_field_designator,
      aux_sym_initializer_pair_repeat1,
  [245521] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(10316), 1,
      anon_sym_RPAREN,
    STATE(2342), 1,
      sym_parameter_list,
    STATE(6243), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [245544] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
    ACTIONS(9571), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [245565] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3830), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
    ACTIONS(9567), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
  [245586] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3830), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
    ACTIONS(9569), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
  [245607] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5685), 1,
      anon_sym_AMP,
    ACTIONS(5687), 6,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_requires,
  [245622] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10318), 1,
      anon_sym_LBRACK,
    ACTIONS(10320), 1,
      anon_sym_EQ,
    ACTIONS(10322), 1,
      anon_sym_DOT,
    STATE(6462), 4,
      sym_subscript_designator,
      sym_subscript_range_designator,
      sym_field_designator,
      aux_sym_initializer_pair_repeat1,
  [245641] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(10324), 1,
      anon_sym_RPAREN,
    STATE(2342), 1,
      sym_parameter_list,
    STATE(6243), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [245664] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3830), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
    ACTIONS(9575), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
  [245685] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(10326), 1,
      anon_sym_RPAREN,
    STATE(2342), 1,
      sym_parameter_list,
    STATE(6243), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [245708] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3830), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
    ACTIONS(9579), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
  [245729] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(10328), 1,
      anon_sym_RPAREN,
    STATE(2342), 1,
      sym_parameter_list,
    STATE(6243), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [245752] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5465), 1,
      anon_sym_COLON,
    ACTIONS(7331), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    STATE(2342), 1,
      sym_parameter_list,
    STATE(6487), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [245775] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5750), 1,
      anon_sym_LBRACK,
    ACTIONS(6103), 1,
      anon_sym_LT,
    STATE(5917), 1,
      sym_template_argument_list,
    ACTIONS(5752), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [245794] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10182), 1,
      anon_sym_AMP,
    ACTIONS(10180), 6,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [245809] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4631), 1,
      anon_sym_LBRACE,
    ACTIONS(10064), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10066), 1,
      anon_sym_inline,
    ACTIONS(10178), 1,
      sym_identifier,
    STATE(707), 1,
      sym_declaration_list,
    STATE(7313), 1,
      sym_nested_namespace_specifier,
    STATE(8107), 1,
      sym__namespace_specifier,
  [245834] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
    ACTIONS(9573), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [245855] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
    ACTIONS(9577), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [245876] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4635), 1,
      anon_sym_LBRACE,
    ACTIONS(10064), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10066), 1,
      anon_sym_inline,
    ACTIONS(10330), 1,
      sym_identifier,
    STATE(898), 1,
      sym_declaration_list,
    STATE(7426), 1,
      sym_nested_namespace_specifier,
    STATE(8107), 1,
      sym__namespace_specifier,
  [245901] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
    ACTIONS(9567), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [245922] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
    ACTIONS(9569), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [245943] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9030), 1,
      anon_sym_LBRACK,
    STATE(3678), 1,
      sym_parameter_list,
    STATE(6099), 1,
      sym__function_declarator_seq,
    STATE(6029), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [245966] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5505), 1,
      anon_sym_COLON,
    ACTIONS(7331), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    STATE(2342), 1,
      sym_parameter_list,
    STATE(6487), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [245989] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10332), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(10334), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [246003] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10336), 1,
      anon_sym_LPAREN2,
    STATE(6520), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(10338), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [246019] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5605), 1,
      anon_sym_LBRACK,
    ACTIONS(7331), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5607), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(5705), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [246037] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(7841), 1,
      sym_string_literal,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [246051] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10340), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(10342), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [246065] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9952), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(10344), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [246079] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10346), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(10348), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [246093] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10205), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(10203), 5,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_identifier,
  [246107] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8825), 1,
      anon_sym_try,
    ACTIONS(9699), 1,
      anon_sym_LBRACE,
    ACTIONS(10350), 1,
      anon_sym_SEMI,
    ACTIONS(10352), 1,
      anon_sym_EQ,
    STATE(2155), 2,
      sym_compound_statement,
      sym_try_statement,
  [246127] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_LBRACE,
    ACTIONS(9124), 1,
      anon_sym_try,
    ACTIONS(10354), 1,
      anon_sym_SEMI,
    ACTIONS(10356), 1,
      anon_sym_EQ,
    STATE(385), 2,
      sym_compound_statement,
      sym_try_statement,
  [246147] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6103), 1,
      anon_sym_LT,
    ACTIONS(9875), 1,
      anon_sym_LBRACK,
    STATE(6257), 1,
      sym_template_argument_list,
    ACTIONS(9873), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [246165] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10358), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(10360), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [246179] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5750), 1,
      anon_sym_LBRACK,
    ACTIONS(6907), 1,
      anon_sym_LT,
    STATE(3993), 1,
      sym_template_argument_list,
    ACTIONS(5752), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [246197] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(9178), 1,
      anon_sym_try,
    ACTIONS(10362), 1,
      anon_sym_SEMI,
    ACTIONS(10364), 1,
      anon_sym_EQ,
    STATE(844), 2,
      sym_compound_statement,
      sym_try_statement,
  [246217] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10366), 1,
      anon_sym_LPAREN2,
    STATE(6515), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(10338), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [246233] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10368), 1,
      anon_sym_LPAREN2,
    STATE(6520), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(10338), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [246249] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10370), 1,
      anon_sym_LPAREN2,
    STATE(6500), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(10338), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [246265] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10372), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(10374), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [246279] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9862), 1,
      anon_sym_LBRACK,
    ACTIONS(9860), 2,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    STATE(5886), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [246297] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(7898), 1,
      sym_string_literal,
    ACTIONS(113), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [246311] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(617), 1,
      anon_sym_LBRACE,
    ACTIONS(9072), 1,
      anon_sym_try,
    ACTIONS(10376), 1,
      anon_sym_SEMI,
    ACTIONS(10378), 1,
      anon_sym_EQ,
    STATE(702), 2,
      sym_compound_statement,
      sym_try_statement,
  [246331] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8809), 1,
      anon_sym_try,
    ACTIONS(9711), 1,
      anon_sym_LBRACE,
    ACTIONS(10380), 1,
      anon_sym_SEMI,
    ACTIONS(10382), 1,
      anon_sym_EQ,
    STATE(2234), 2,
      sym_compound_statement,
      sym_try_statement,
  [246351] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10384), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(10386), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [246365] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(617), 1,
      anon_sym_LBRACE,
    ACTIONS(9072), 1,
      anon_sym_try,
    ACTIONS(10388), 1,
      anon_sym_SEMI,
    ACTIONS(10390), 1,
      anon_sym_EQ,
    STATE(799), 2,
      sym_compound_statement,
      sym_try_statement,
  [246385] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3830), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
    ACTIONS(9990), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [246405] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8817), 1,
      anon_sym_try,
    ACTIONS(9613), 1,
      anon_sym_LBRACE,
    ACTIONS(10392), 1,
      anon_sym_SEMI,
    ACTIONS(10394), 1,
      anon_sym_EQ,
    STATE(1899), 2,
      sym_compound_statement,
      sym_try_statement,
  [246425] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10332), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(10334), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [246439] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8809), 1,
      anon_sym_try,
    ACTIONS(9711), 1,
      anon_sym_LBRACE,
    ACTIONS(10396), 1,
      anon_sym_SEMI,
    ACTIONS(10398), 1,
      anon_sym_EQ,
    STATE(2104), 2,
      sym_compound_statement,
      sym_try_statement,
  [246459] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(9178), 1,
      anon_sym_try,
    ACTIONS(10400), 1,
      anon_sym_SEMI,
    ACTIONS(10402), 1,
      anon_sym_EQ,
    STATE(906), 2,
      sym_compound_statement,
      sym_try_statement,
  [246479] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5750), 1,
      anon_sym_LBRACK,
    ACTIONS(6103), 1,
      anon_sym_LT,
    STATE(3993), 1,
      sym_template_argument_list,
    ACTIONS(5752), 3,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
  [246497] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10404), 1,
      anon_sym_LPAREN2,
    STATE(6520), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(10338), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [246513] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10406), 1,
      anon_sym_LPAREN2,
    STATE(6519), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(10338), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [246529] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(675), 1,
      anon_sym_LBRACE,
    ACTIONS(9166), 1,
      anon_sym_try,
    ACTIONS(10408), 1,
      anon_sym_SEMI,
    ACTIONS(10410), 1,
      anon_sym_EQ,
    STATE(794), 2,
      sym_compound_statement,
      sym_try_statement,
  [246549] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7041), 1,
      anon_sym___attribute__,
    ACTIONS(7331), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5528), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5702), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [246567] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10412), 1,
      anon_sym_LPAREN2,
    STATE(6520), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(10338), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [246583] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10414), 1,
      anon_sym_LPAREN2,
    STATE(6520), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(10416), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [246599] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10419), 1,
      anon_sym_LPAREN2,
    STATE(6520), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(10338), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [246615] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    STATE(5391), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5679), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [246633] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10421), 1,
      anon_sym_LPAREN2,
    STATE(6520), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(10338), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [246649] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10423), 1,
      anon_sym_LPAREN2,
    STATE(6523), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(10338), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [246665] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6103), 1,
      anon_sym_LT,
    ACTIONS(9871), 1,
      anon_sym_LBRACK,
    STATE(6275), 1,
      sym_template_argument_list,
    ACTIONS(9867), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [246683] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10425), 1,
      anon_sym_LPAREN2,
    STATE(6521), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(10338), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [246699] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10427), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(10429), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [246713] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_LBRACE,
    ACTIONS(9124), 1,
      anon_sym_try,
    ACTIONS(10431), 1,
      anon_sym_SEMI,
    ACTIONS(10433), 1,
      anon_sym_EQ,
    STATE(378), 2,
      sym_compound_statement,
      sym_try_statement,
  [246733] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
    ACTIONS(9990), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [246753] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10427), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(10429), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [246767] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10435), 1,
      anon_sym_LPAREN2,
    STATE(6486), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(10338), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [246783] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(675), 1,
      anon_sym_LBRACE,
    ACTIONS(9166), 1,
      anon_sym_try,
    ACTIONS(10437), 1,
      anon_sym_SEMI,
    ACTIONS(10439), 1,
      anon_sym_EQ,
    STATE(769), 2,
      sym_compound_statement,
      sym_try_statement,
  [246803] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10441), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(10443), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [246817] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10445), 1,
      anon_sym_LPAREN2,
    STATE(6520), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(10338), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [246833] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10447), 1,
      anon_sym_LPAREN2,
    STATE(6534), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(10338), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [246849] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8825), 1,
      anon_sym_try,
    ACTIONS(9699), 1,
      anon_sym_LBRACE,
    ACTIONS(10449), 1,
      anon_sym_SEMI,
    ACTIONS(10451), 1,
      anon_sym_EQ,
    STATE(2121), 2,
      sym_compound_statement,
      sym_try_statement,
  [246869] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8817), 1,
      anon_sym_try,
    ACTIONS(9613), 1,
      anon_sym_LBRACE,
    ACTIONS(10453), 1,
      anon_sym_SEMI,
    ACTIONS(10455), 1,
      anon_sym_EQ,
    STATE(1879), 2,
      sym_compound_statement,
      sym_try_statement,
  [246889] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7570), 1,
      anon_sym_COMMA,
    ACTIONS(10457), 1,
      anon_sym_SEMI,
    STATE(6701), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8179), 1,
      sym_attribute_specifier,
  [246908] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7570), 1,
      anon_sym_COMMA,
    ACTIONS(10459), 1,
      anon_sym_SEMI,
    STATE(6701), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8304), 1,
      sym_attribute_specifier,
  [246927] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7570), 1,
      anon_sym_COMMA,
    ACTIONS(10461), 1,
      anon_sym_SEMI,
    STATE(6539), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8326), 1,
      sym_attribute_specifier,
  [246946] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7570), 1,
      anon_sym_COMMA,
    ACTIONS(10463), 1,
      anon_sym_SEMI,
    STATE(6701), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8319), 1,
      sym_attribute_specifier,
  [246965] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    ACTIONS(10465), 1,
      anon_sym_RPAREN,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
  [246984] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7307), 1,
      anon_sym_LPAREN2,
    ACTIONS(10469), 1,
      anon_sym_COLON_COLON,
    STATE(7273), 1,
      sym_argument_list,
    ACTIONS(10467), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [247001] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10064), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10066), 1,
      anon_sym_inline,
    ACTIONS(10471), 1,
      sym_identifier,
    STATE(8107), 1,
      sym__namespace_specifier,
    STATE(8184), 1,
      sym_nested_namespace_specifier,
  [247020] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    ACTIONS(10473), 1,
      anon_sym_RPAREN,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
  [247039] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5750), 1,
      anon_sym_LBRACK,
    ACTIONS(6103), 1,
      anon_sym_LT,
    STATE(4271), 1,
      sym_template_argument_list,
    ACTIONS(5752), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [247056] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7570), 1,
      anon_sym_COMMA,
    ACTIONS(10475), 1,
      anon_sym_SEMI,
    STATE(6701), 1,
      aux_sym_field_declaration_repeat1,
    STATE(7794), 1,
      sym_attribute_specifier,
  [247075] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7570), 1,
      anon_sym_COMMA,
    ACTIONS(10477), 1,
      anon_sym_SEMI,
    STATE(6701), 1,
      aux_sym_field_declaration_repeat1,
    STATE(7796), 1,
      sym_attribute_specifier,
  [247094] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9563), 1,
      anon_sym_COLON,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3982), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
  [247113] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7570), 1,
      anon_sym_COMMA,
    ACTIONS(10479), 1,
      anon_sym_SEMI,
    STATE(6701), 1,
      aux_sym_field_declaration_repeat1,
    STATE(7754), 1,
      sym_attribute_specifier,
  [247132] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(10481), 1,
      sym_identifier,
    STATE(2433), 1,
      sym_template_type,
    STATE(2455), 1,
      sym_template_method,
    STATE(7508), 1,
      sym_operator_name,
  [247151] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(10481), 1,
      sym_identifier,
    STATE(2433), 1,
      sym_template_type,
    STATE(2455), 1,
      sym_template_method,
    STATE(7529), 1,
      sym_operator_name,
  [247170] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8275), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8279), 1,
      anon_sym_EQ,
    ACTIONS(10483), 1,
      sym_identifier,
    ACTIONS(8277), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [247187] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10485), 1,
      anon_sym_EQ,
    ACTIONS(9388), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [247200] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      sym_auto,
    ACTIONS(7442), 1,
      anon_sym_decltype,
    STATE(2655), 1,
      sym_decltype_auto,
    ACTIONS(10487), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [247217] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(10489), 1,
      sym_identifier,
    STATE(2433), 1,
      sym_template_type,
    STATE(3593), 1,
      sym_template_method,
    STATE(7284), 1,
      sym_operator_name,
  [247236] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7570), 1,
      anon_sym_COMMA,
    ACTIONS(10491), 1,
      anon_sym_SEMI,
    STATE(6587), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8310), 1,
      sym_attribute_specifier,
  [247255] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6103), 1,
      anon_sym_LT,
    STATE(2415), 1,
      sym_template_argument_list,
    ACTIONS(5668), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
  [247272] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    ACTIONS(10493), 1,
      anon_sym_RPAREN,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
  [247291] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9567), 1,
      anon_sym_COLON,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3982), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
  [247310] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9569), 1,
      anon_sym_COLON,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3982), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
  [247329] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7570), 1,
      anon_sym_COMMA,
    ACTIONS(10495), 1,
      anon_sym_SEMI,
    STATE(6593), 1,
      aux_sym_field_declaration_repeat1,
    STATE(7745), 1,
      sym_attribute_specifier,
  [247348] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9571), 1,
      anon_sym_COLON,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3982), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
  [247367] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9573), 1,
      anon_sym_COLON,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3982), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
  [247386] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10497), 2,
      anon_sym_class,
      anon_sym_typename,
    STATE(7304), 3,
      sym_type_parameter_declaration,
      sym_variadic_type_parameter_declaration,
      sym_optional_type_parameter_declaration,
  [247399] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7570), 1,
      anon_sym_COMMA,
    ACTIONS(10499), 1,
      anon_sym_SEMI,
    STATE(6701), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8075), 1,
      sym_attribute_specifier,
  [247418] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7570), 1,
      anon_sym_COMMA,
    ACTIONS(10501), 1,
      anon_sym_SEMI,
    STATE(6595), 1,
      aux_sym_field_declaration_repeat1,
    STATE(7742), 1,
      sym_attribute_specifier,
  [247437] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(10503), 1,
      sym_identifier,
    STATE(2433), 1,
      sym_template_type,
    STATE(3442), 1,
      sym_template_method,
    STATE(7431), 1,
      sym_operator_name,
  [247456] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10505), 1,
      anon_sym_EQ,
    ACTIONS(9388), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [247469] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7570), 1,
      anon_sym_COMMA,
    ACTIONS(10507), 1,
      anon_sym_SEMI,
    STATE(6538), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8327), 1,
      sym_attribute_specifier,
  [247488] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7570), 1,
      anon_sym_COMMA,
    ACTIONS(10509), 1,
      anon_sym_SEMI,
    STATE(6701), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8078), 1,
      sym_attribute_specifier,
  [247507] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9575), 1,
      anon_sym_COLON,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3982), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
  [247526] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9577), 1,
      anon_sym_COLON,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3982), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
  [247545] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5750), 1,
      anon_sym_LBRACK,
    ACTIONS(6103), 1,
      anon_sym_LT,
    STATE(3917), 1,
      sym_template_argument_list,
    ACTIONS(5752), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [247562] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9579), 1,
      anon_sym_COLON,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3982), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
  [247581] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1871), 1,
      anon_sym_operator,
    ACTIONS(10511), 1,
      sym_identifier,
    STATE(2433), 1,
      sym_template_type,
    STATE(2455), 1,
      sym_template_method,
    STATE(7402), 1,
      sym_operator_name,
  [247600] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7570), 1,
      anon_sym_COMMA,
    ACTIONS(10513), 1,
      anon_sym_SEMI,
    STATE(6548), 1,
      aux_sym_field_declaration_repeat1,
    STATE(7784), 1,
      sym_attribute_specifier,
  [247619] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7440), 1,
      sym_auto,
    ACTIONS(7442), 1,
      anon_sym_decltype,
    STATE(2655), 1,
      sym_decltype_auto,
    ACTIONS(10515), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [247636] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7570), 1,
      anon_sym_COMMA,
    ACTIONS(10517), 1,
      anon_sym_SEMI,
    STATE(6701), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8303), 1,
      sym_attribute_specifier,
  [247655] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10064), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10066), 1,
      anon_sym_inline,
    ACTIONS(10519), 1,
      sym_identifier,
    STATE(6878), 1,
      sym__namespace_specifier,
    STATE(7546), 1,
      sym_nested_namespace_specifier,
  [247674] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10064), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10066), 1,
      anon_sym_inline,
    ACTIONS(10519), 1,
      sym_identifier,
    STATE(7105), 1,
      sym__namespace_specifier,
    STATE(7356), 1,
      sym_nested_namespace_specifier,
  [247693] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10064), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10066), 1,
      anon_sym_inline,
    ACTIONS(10521), 1,
      sym_identifier,
    STATE(7630), 1,
      sym_nested_namespace_specifier,
    STATE(8107), 1,
      sym__namespace_specifier,
  [247712] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7570), 1,
      anon_sym_COMMA,
    ACTIONS(10523), 1,
      anon_sym_SEMI,
    STATE(6701), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8298), 1,
      sym_attribute_specifier,
  [247731] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10527), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10525), 4,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_virtual,
      anon_sym_template,
  [247744] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10064), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10066), 1,
      anon_sym_inline,
    ACTIONS(10529), 1,
      sym_identifier,
    STATE(8089), 1,
      sym_nested_namespace_specifier,
    STATE(8107), 1,
      sym__namespace_specifier,
  [247763] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7570), 1,
      anon_sym_COMMA,
    ACTIONS(10531), 1,
      anon_sym_SEMI,
    STATE(6566), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8093), 1,
      sym_attribute_specifier,
  [247782] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7570), 1,
      anon_sym_COMMA,
    ACTIONS(10533), 1,
      anon_sym_SEMI,
    STATE(6701), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8297), 1,
      sym_attribute_specifier,
  [247801] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7570), 1,
      anon_sym_COMMA,
    ACTIONS(10535), 1,
      anon_sym_SEMI,
    STATE(6701), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8150), 1,
      sym_attribute_specifier,
  [247820] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7570), 1,
      anon_sym_COMMA,
    ACTIONS(10537), 1,
      anon_sym_SEMI,
    STATE(6701), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8131), 1,
      sym_attribute_specifier,
  [247839] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7570), 1,
      anon_sym_COMMA,
    ACTIONS(10539), 1,
      anon_sym_SEMI,
    STATE(6588), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8286), 1,
      sym_attribute_specifier,
  [247858] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9526), 1,
      sym_identifier,
    ACTIONS(10541), 1,
      aux_sym_preproc_if_token2,
    STATE(6460), 1,
      sym_enumerator,
    STATE(6705), 1,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(6740), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
  [247877] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    ACTIONS(10543), 1,
      anon_sym_RPAREN,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
  [247896] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7570), 1,
      anon_sym_COMMA,
    ACTIONS(10545), 1,
      anon_sym_SEMI,
    STATE(6701), 1,
      aux_sym_field_declaration_repeat1,
    STATE(7788), 1,
      sym_attribute_specifier,
  [247915] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10064), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10066), 1,
      anon_sym_inline,
    ACTIONS(10547), 1,
      sym_identifier,
    STATE(7838), 1,
      sym_nested_namespace_specifier,
    STATE(8107), 1,
      sym__namespace_specifier,
  [247934] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7570), 1,
      anon_sym_COMMA,
    ACTIONS(10549), 1,
      anon_sym_SEMI,
    STATE(6701), 1,
      aux_sym_field_declaration_repeat1,
    STATE(7786), 1,
      sym_attribute_specifier,
  [247953] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(7570), 1,
      anon_sym_COMMA,
    ACTIONS(10551), 1,
      anon_sym_SEMI,
    STATE(6589), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8282), 1,
      sym_attribute_specifier,
  [247972] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3194), 1,
      anon_sym_LBRACE,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(8231), 1,
      anon_sym_RPAREN,
    STATE(2526), 1,
      sym_argument_list,
    STATE(3942), 1,
      sym_initializer_list,
  [247991] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3194), 1,
      anon_sym_LBRACE,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    ACTIONS(8265), 1,
      anon_sym_RPAREN,
    STATE(2526), 1,
      sym_argument_list,
    STATE(3942), 1,
      sym_initializer_list,
  [248010] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(10553), 1,
      anon_sym_SEMI,
    STATE(4640), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [248024] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(9617), 1,
      anon_sym_COLON,
    STATE(6971), 1,
      sym_compound_statement,
    STATE(7278), 1,
      sym_field_initializer_list,
  [248040] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4591), 1,
      anon_sym_LT,
    ACTIONS(10555), 1,
      sym_identifier,
    STATE(920), 1,
      sym_template_parameter_list,
    STATE(2433), 1,
      sym_template_type,
  [248056] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10557), 1,
      anon_sym_EQ,
    STATE(5886), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [248070] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4910), 1,
      anon_sym_COLON,
    ACTIONS(6138), 1,
      anon_sym_LBRACE,
    STATE(3166), 1,
      sym_field_declaration_list,
    STATE(7293), 1,
      sym_base_class_clause,
  [248086] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9396), 1,
      anon_sym_LBRACE,
    STATE(3893), 1,
      sym_compound_statement,
    ACTIONS(9388), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [248100] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(10559), 1,
      anon_sym_SEMI,
    STATE(6634), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [248114] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4629), 1,
      anon_sym_LBRACE,
    ACTIONS(10561), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10563), 1,
      anon_sym_EQ,
    STATE(326), 1,
      sym_declaration_list,
  [248130] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10565), 1,
      anon_sym___except,
    ACTIONS(10567), 1,
      anon_sym___finally,
    STATE(497), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [248144] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10569), 1,
      anon_sym_LPAREN2,
    ACTIONS(10571), 1,
      anon_sym_LBRACE,
    STATE(1745), 1,
      sym_requirement_seq,
    STATE(7419), 1,
      sym_requires_parameter_list,
  [248160] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(9617), 1,
      anon_sym_COLON,
    STATE(7041), 1,
      sym_compound_statement,
    STATE(7537), 1,
      sym_field_initializer_list,
  [248176] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4591), 1,
      anon_sym_LT,
    ACTIONS(10555), 1,
      sym_identifier,
    STATE(923), 1,
      sym_template_parameter_list,
    STATE(2433), 1,
      sym_template_type,
  [248192] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(10573), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10575), 1,
      anon_sym_GT2,
    STATE(7207), 1,
      aux_sym_template_argument_list_repeat1,
  [248208] = 5,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(10577), 1,
      anon_sym_DQUOTE,
    ACTIONS(10579), 1,
      aux_sym_string_literal_token1,
    ACTIONS(10581), 1,
      sym_escape_sequence,
    STATE(6852), 1,
      aux_sym_string_literal_repeat1,
  [248224] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2236), 1,
      anon_sym_LBRACE,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    STATE(3578), 1,
      sym_initializer_list,
    STATE(3688), 1,
      sym_argument_list,
  [248240] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6103), 1,
      anon_sym_LT,
    ACTIONS(10583), 1,
      anon_sym_SEMI,
    STATE(1741), 1,
      sym_template_argument_list,
  [248256] = 5,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(10585), 1,
      anon_sym_DQUOTE,
    ACTIONS(10587), 1,
      aux_sym_string_literal_token1,
    ACTIONS(10589), 1,
      sym_escape_sequence,
    STATE(6728), 1,
      aux_sym_string_literal_repeat1,
  [248272] = 4,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(10591), 1,
      anon_sym_SQUOTE,
    STATE(6632), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(10593), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [248286] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(9617), 1,
      anon_sym_COLON,
    STATE(6942), 1,
      sym_compound_statement,
    STATE(7368), 1,
      sym_field_initializer_list,
  [248302] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4591), 1,
      anon_sym_LT,
    ACTIONS(10555), 1,
      sym_identifier,
    STATE(2433), 1,
      sym_template_type,
    STATE(6565), 1,
      sym_template_parameter_list,
  [248318] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(10573), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10595), 1,
      anon_sym_GT2,
    STATE(7033), 1,
      aux_sym_template_argument_list_repeat1,
  [248334] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9392), 1,
      anon_sym_LBRACE,
    STATE(3445), 1,
      sym_compound_statement,
    ACTIONS(9388), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [248348] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10597), 1,
      anon_sym_COMMA,
    STATE(6621), 1,
      aux_sym_gnu_asm_clobber_list_repeat1,
    ACTIONS(10600), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [248362] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10266), 1,
      anon_sym_EQ,
    STATE(6799), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [248376] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10602), 1,
      anon_sym_EQ,
    STATE(5886), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [248390] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4910), 1,
      anon_sym_COLON,
    ACTIONS(5928), 1,
      anon_sym_LBRACE,
    STATE(2762), 1,
      sym_field_declaration_list,
    STATE(7562), 1,
      sym_base_class_clause,
  [248406] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6103), 1,
      anon_sym_LT,
    ACTIONS(10604), 1,
      anon_sym_SEMI,
    STATE(1741), 1,
      sym_template_argument_list,
  [248422] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3194), 1,
      anon_sym_LBRACE,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    STATE(2526), 1,
      sym_argument_list,
    STATE(3942), 1,
      sym_initializer_list,
  [248438] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(10573), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10606), 1,
      anon_sym_GT2,
    STATE(7022), 1,
      aux_sym_template_argument_list_repeat1,
  [248454] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10608), 1,
      anon_sym_COMMA,
    STATE(6819), 1,
      aux_sym_gnu_asm_output_operand_list_repeat1,
    ACTIONS(10610), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [248468] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4591), 1,
      anon_sym_LT,
    ACTIONS(10555), 1,
      sym_identifier,
    STATE(919), 1,
      sym_template_parameter_list,
    STATE(2433), 1,
      sym_template_type,
  [248484] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10225), 1,
      anon_sym_EQ,
    STATE(6723), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [248498] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9408), 1,
      anon_sym_LBRACE,
    STATE(3689), 1,
      sym_compound_statement,
    ACTIONS(9388), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [248512] = 4,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(10612), 1,
      anon_sym_SQUOTE,
    STATE(6632), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(10614), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [248526] = 5,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(10587), 1,
      aux_sym_string_literal_token1,
    ACTIONS(10589), 1,
      sym_escape_sequence,
    ACTIONS(10617), 1,
      anon_sym_DQUOTE,
    STATE(6728), 1,
      aux_sym_string_literal_repeat1,
  [248542] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(10619), 1,
      anon_sym_SEMI,
    STATE(4640), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [248556] = 5,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(10621), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(10623), 1,
      anon_sym_LPAREN,
    ACTIONS(10625), 1,
      sym_preproc_arg,
    STATE(7320), 1,
      sym_preproc_params,
  [248572] = 5,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(10623), 1,
      anon_sym_LPAREN,
    ACTIONS(10627), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(10629), 1,
      sym_preproc_arg,
    STATE(7539), 1,
      sym_preproc_params,
  [248588] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(10631), 1,
      anon_sym_SEMI,
    STATE(6665), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [248602] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(10633), 1,
      anon_sym_SEMI,
    STATE(4640), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [248616] = 5,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(10635), 1,
      anon_sym_DQUOTE,
    ACTIONS(10637), 1,
      aux_sym_string_literal_token1,
    ACTIONS(10639), 1,
      sym_escape_sequence,
    STATE(6633), 1,
      aux_sym_string_literal_repeat1,
  [248632] = 5,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(10587), 1,
      aux_sym_string_literal_token1,
    ACTIONS(10589), 1,
      sym_escape_sequence,
    ACTIONS(10641), 1,
      anon_sym_DQUOTE,
    STATE(6728), 1,
      aux_sym_string_literal_repeat1,
  [248648] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9396), 1,
      anon_sym_LBRACE,
    STATE(3825), 1,
      sym_compound_statement,
    ACTIONS(9388), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [248662] = 5,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(10643), 1,
      anon_sym_DQUOTE,
    ACTIONS(10645), 1,
      aux_sym_string_literal_token1,
    ACTIONS(10647), 1,
      sym_escape_sequence,
    STATE(6640), 1,
      aux_sym_string_literal_repeat1,
  [248678] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(10573), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10649), 1,
      anon_sym_GT2,
    STATE(7234), 1,
      aux_sym_template_argument_list_repeat1,
  [248694] = 5,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(10587), 1,
      aux_sym_string_literal_token1,
    ACTIONS(10589), 1,
      sym_escape_sequence,
    ACTIONS(10651), 1,
      anon_sym_DQUOTE,
    STATE(6728), 1,
      aux_sym_string_literal_repeat1,
  [248710] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(10653), 1,
      anon_sym_SEMI,
    STATE(4640), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [248724] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6103), 1,
      anon_sym_LT,
    ACTIONS(10655), 1,
      anon_sym_SEMI,
    STATE(1741), 1,
      sym_template_argument_list,
  [248740] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10657), 1,
      anon_sym_EQ,
    STATE(5886), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [248754] = 5,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(10659), 1,
      anon_sym_DQUOTE,
    ACTIONS(10661), 1,
      aux_sym_string_literal_token1,
    ACTIONS(10663), 1,
      sym_escape_sequence,
    STATE(6615), 1,
      aux_sym_string_literal_repeat1,
  [248770] = 5,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(10665), 1,
      anon_sym_DQUOTE,
    ACTIONS(10667), 1,
      aux_sym_string_literal_token1,
    ACTIONS(10669), 1,
      sym_escape_sequence,
    STATE(6644), 1,
      aux_sym_string_literal_repeat1,
  [248786] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10671), 4,
      anon_sym_LPAREN2,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [248796] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(10573), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10673), 1,
      anon_sym_GT2,
    STATE(7214), 1,
      aux_sym_template_argument_list_repeat1,
  [248812] = 5,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(10587), 1,
      aux_sym_string_literal_token1,
    ACTIONS(10589), 1,
      sym_escape_sequence,
    ACTIONS(10675), 1,
      anon_sym_DQUOTE,
    STATE(6728), 1,
      aux_sym_string_literal_repeat1,
  [248828] = 5,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(10677), 1,
      anon_sym_DQUOTE,
    ACTIONS(10679), 1,
      aux_sym_string_literal_token1,
    ACTIONS(10681), 1,
      sym_escape_sequence,
    STATE(6652), 1,
      aux_sym_string_literal_repeat1,
  [248844] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10683), 1,
      anon_sym_COMMA,
    STATE(6621), 1,
      aux_sym_gnu_asm_clobber_list_repeat1,
    ACTIONS(10685), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [248858] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(9617), 1,
      anon_sym_COLON,
    STATE(7243), 1,
      sym_compound_statement,
    STATE(7430), 1,
      sym_field_initializer_list,
  [248874] = 4,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(10687), 1,
      anon_sym_SQUOTE,
    STATE(6632), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(10593), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [248888] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(10573), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10689), 1,
      anon_sym_GT2,
    STATE(7194), 1,
      aux_sym_template_argument_list_repeat1,
  [248904] = 5,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(10587), 1,
      aux_sym_string_literal_token1,
    ACTIONS(10589), 1,
      sym_escape_sequence,
    ACTIONS(10691), 1,
      anon_sym_DQUOTE,
    STATE(6728), 1,
      aux_sym_string_literal_repeat1,
  [248920] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(10693), 1,
      anon_sym_SEMI,
    STATE(4640), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [248934] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(10573), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10695), 1,
      anon_sym_GT2,
    STATE(6938), 1,
      aux_sym_template_argument_list_repeat1,
  [248950] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4591), 1,
      anon_sym_LT,
    ACTIONS(10555), 1,
      sym_identifier,
    STATE(918), 1,
      sym_template_parameter_list,
    STATE(2433), 1,
      sym_template_type,
  [248966] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9408), 1,
      anon_sym_LBRACE,
    STATE(3554), 1,
      sym_compound_statement,
    ACTIONS(9388), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [248980] = 5,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(10587), 1,
      aux_sym_string_literal_token1,
    ACTIONS(10589), 1,
      sym_escape_sequence,
    ACTIONS(10697), 1,
      anon_sym_DQUOTE,
    STATE(6728), 1,
      aux_sym_string_literal_repeat1,
  [248996] = 5,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(10587), 1,
      aux_sym_string_literal_token1,
    ACTIONS(10589), 1,
      sym_escape_sequence,
    ACTIONS(10699), 1,
      anon_sym_DQUOTE,
    STATE(6728), 1,
      aux_sym_string_literal_repeat1,
  [249012] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(10701), 1,
      anon_sym_SEMI,
    STATE(4640), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [249026] = 5,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(10703), 1,
      anon_sym_DQUOTE,
    ACTIONS(10705), 1,
      aux_sym_string_literal_token1,
    ACTIONS(10707), 1,
      sym_escape_sequence,
    STATE(6658), 1,
      aux_sym_string_literal_repeat1,
  [249042] = 5,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(10623), 1,
      anon_sym_LPAREN,
    ACTIONS(10709), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(10711), 1,
      sym_preproc_arg,
    STATE(7308), 1,
      sym_preproc_params,
  [249058] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4910), 1,
      anon_sym_COLON,
    ACTIONS(5811), 1,
      anon_sym_LBRACE,
    STATE(2869), 1,
      sym_field_declaration_list,
    STATE(7371), 1,
      sym_base_class_clause,
  [249074] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_LBRACE,
    ACTIONS(6202), 1,
      anon_sym_LPAREN2,
    STATE(3688), 1,
      sym_argument_list,
    STATE(4703), 1,
      sym_initializer_list,
  [249090] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(10713), 1,
      anon_sym_SEMI,
    STATE(4640), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [249104] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(10573), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10715), 1,
      anon_sym_GT2,
    STATE(7174), 1,
      aux_sym_template_argument_list_repeat1,
  [249120] = 5,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(10587), 1,
      aux_sym_string_literal_token1,
    ACTIONS(10589), 1,
      sym_escape_sequence,
    ACTIONS(10717), 1,
      anon_sym_DQUOTE,
    STATE(6728), 1,
      aux_sym_string_literal_repeat1,
  [249136] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4910), 1,
      anon_sym_COLON,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    STATE(3921), 1,
      sym_field_declaration_list,
    STATE(7489), 1,
      sym_base_class_clause,
  [249152] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6103), 1,
      anon_sym_LT,
    ACTIONS(10719), 1,
      anon_sym_SEMI,
    STATE(1741), 1,
      sym_template_argument_list,
  [249168] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4635), 1,
      anon_sym_LBRACE,
    ACTIONS(10561), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10721), 1,
      anon_sym_EQ,
    STATE(857), 1,
      sym_declaration_list,
  [249184] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10723), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10725), 1,
      anon_sym_COMMA,
    ACTIONS(10727), 1,
      anon_sym_LBRACE,
    STATE(6907), 1,
      aux_sym_base_class_clause_repeat1,
  [249200] = 5,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(10729), 1,
      anon_sym_DQUOTE,
    ACTIONS(10731), 1,
      aux_sym_string_literal_token1,
    ACTIONS(10733), 1,
      sym_escape_sequence,
    STATE(6672), 1,
      aux_sym_string_literal_repeat1,
  [249216] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10735), 1,
      anon_sym_COMMA,
    STATE(6678), 1,
      aux_sym_gnu_asm_input_operand_list_repeat1,
    ACTIONS(10738), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [249230] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(10740), 1,
      anon_sym_SEMI,
    STATE(6638), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [249244] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(10742), 1,
      anon_sym_SEMI,
    STATE(6826), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [249258] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(10573), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10744), 1,
      anon_sym_GT2,
    STATE(7153), 1,
      aux_sym_template_argument_list_repeat1,
  [249274] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4910), 1,
      anon_sym_COLON,
    ACTIONS(5575), 1,
      anon_sym_LBRACE,
    STATE(2528), 1,
      sym_field_declaration_list,
    STATE(7531), 1,
      sym_base_class_clause,
  [249290] = 4,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(10746), 1,
      anon_sym_SQUOTE,
    STATE(6632), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(10593), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [249304] = 5,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(10587), 1,
      aux_sym_string_literal_token1,
    ACTIONS(10589), 1,
      sym_escape_sequence,
    ACTIONS(10748), 1,
      anon_sym_DQUOTE,
    STATE(6728), 1,
      aux_sym_string_literal_repeat1,
  [249320] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(9617), 1,
      anon_sym_COLON,
    STATE(6909), 1,
      sym_compound_statement,
    STATE(7370), 1,
      sym_field_initializer_list,
  [249336] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(10750), 1,
      anon_sym_SEMI,
    STATE(6659), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [249350] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10752), 1,
      anon_sym_EQ,
    STATE(5886), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [249364] = 5,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(10754), 1,
      anon_sym_DQUOTE,
    ACTIONS(10756), 1,
      aux_sym_string_literal_token1,
    ACTIONS(10758), 1,
      sym_escape_sequence,
    STATE(6684), 1,
      aux_sym_string_literal_repeat1,
  [249380] = 5,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(10760), 1,
      anon_sym_DQUOTE,
    ACTIONS(10762), 1,
      aux_sym_string_literal_token1,
    ACTIONS(10764), 1,
      sym_escape_sequence,
    STATE(6788), 1,
      aux_sym_string_literal_repeat1,
  [249396] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(10573), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10766), 1,
      anon_sym_GT2,
    STATE(7131), 1,
      aux_sym_template_argument_list_repeat1,
  [249412] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4910), 1,
      anon_sym_COLON,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    STATE(3087), 1,
      sym_field_declaration_list,
    STATE(7548), 1,
      sym_base_class_clause,
  [249428] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4591), 1,
      anon_sym_LT,
    ACTIONS(10555), 1,
      sym_identifier,
    STATE(922), 1,
      sym_template_parameter_list,
    STATE(2433), 1,
      sym_template_type,
  [249444] = 5,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(10587), 1,
      aux_sym_string_literal_token1,
    ACTIONS(10589), 1,
      sym_escape_sequence,
    ACTIONS(10768), 1,
      anon_sym_DQUOTE,
    STATE(6728), 1,
      aux_sym_string_literal_repeat1,
  [249460] = 4,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(10770), 1,
      anon_sym_SQUOTE,
    STATE(6632), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(10593), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [249474] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4910), 1,
      anon_sym_COLON,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    STATE(3106), 1,
      sym_field_declaration_list,
    STATE(7397), 1,
      sym_base_class_clause,
  [249490] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4910), 1,
      anon_sym_COLON,
    ACTIONS(5575), 1,
      anon_sym_LBRACE,
    STATE(5053), 1,
      sym_field_declaration_list,
    STATE(7393), 1,
      sym_base_class_clause,
  [249506] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10725), 1,
      anon_sym_COMMA,
    ACTIONS(10772), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10774), 1,
      anon_sym_LBRACE,
    STATE(6919), 1,
      aux_sym_base_class_clause_repeat1,
  [249522] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9392), 1,
      anon_sym_LBRACE,
    STATE(3520), 1,
      sym_compound_statement,
    ACTIONS(9388), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [249536] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10776), 1,
      anon_sym___except,
    ACTIONS(10778), 1,
      anon_sym___finally,
    STATE(1024), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [249550] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(10780), 1,
      anon_sym_SEMI,
    STATE(4640), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [249564] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10782), 1,
      anon_sym_COMMA,
    STATE(6701), 1,
      aux_sym_field_declaration_repeat1,
    ACTIONS(10785), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [249578] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10787), 1,
      anon_sym_COMMA,
    STATE(6702), 1,
      aux_sym__type_definition_declarators_repeat1,
    ACTIONS(10790), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [249592] = 5,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(10792), 1,
      anon_sym_DQUOTE,
    ACTIONS(10794), 1,
      aux_sym_string_literal_token1,
    ACTIONS(10796), 1,
      sym_escape_sequence,
    STATE(6693), 1,
      aux_sym_string_literal_repeat1,
  [249608] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9458), 1,
      anon_sym_LBRACE,
    STATE(4285), 1,
      sym_compound_statement,
    ACTIONS(9388), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [249622] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9526), 1,
      sym_identifier,
    ACTIONS(10798), 1,
      aux_sym_preproc_if_token2,
    STATE(6426), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
  [249636] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4591), 1,
      anon_sym_LT,
    ACTIONS(10555), 1,
      sym_identifier,
    STATE(924), 1,
      sym_template_parameter_list,
    STATE(2433), 1,
      sym_template_type,
  [249652] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10800), 1,
      anon_sym___except,
    ACTIONS(10802), 1,
      anon_sym___finally,
    STATE(540), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [249666] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(10573), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10804), 1,
      anon_sym_GT2,
    STATE(7108), 1,
      aux_sym_template_argument_list_repeat1,
  [249682] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10038), 1,
      anon_sym_COMMA,
    STATE(6702), 1,
      aux_sym__type_definition_declarators_repeat1,
    ACTIONS(10806), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [249696] = 5,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(10808), 1,
      anon_sym_DQUOTE,
    ACTIONS(10810), 1,
      aux_sym_string_literal_token1,
    ACTIONS(10812), 1,
      sym_escape_sequence,
    STATE(6738), 1,
      aux_sym_string_literal_repeat1,
  [249712] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4910), 1,
      anon_sym_COLON,
    ACTIONS(5811), 1,
      anon_sym_LBRACE,
    STATE(2841), 1,
      sym_field_declaration_list,
    STATE(7565), 1,
      sym_base_class_clause,
  [249728] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4910), 1,
      anon_sym_COLON,
    ACTIONS(5928), 1,
      anon_sym_LBRACE,
    STATE(2772), 1,
      sym_field_declaration_list,
    STATE(7499), 1,
      sym_base_class_clause,
  [249744] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4908), 1,
      anon_sym_LBRACE,
    ACTIONS(4910), 1,
      anon_sym_COLON,
    STATE(2266), 1,
      sym_field_declaration_list,
    STATE(7310), 1,
      sym_base_class_clause,
  [249760] = 5,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(10623), 1,
      anon_sym_LPAREN,
    ACTIONS(10814), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(10816), 1,
      sym_preproc_arg,
    STATE(7364), 1,
      sym_preproc_params,
  [249776] = 5,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(10587), 1,
      aux_sym_string_literal_token1,
    ACTIONS(10589), 1,
      sym_escape_sequence,
    ACTIONS(10818), 1,
      anon_sym_DQUOTE,
    STATE(6728), 1,
      aux_sym_string_literal_repeat1,
  [249792] = 5,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(10623), 1,
      anon_sym_LPAREN,
    ACTIONS(10820), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(10822), 1,
      sym_preproc_arg,
    STATE(7423), 1,
      sym_preproc_params,
  [249808] = 4,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(10824), 1,
      anon_sym_SQUOTE,
    STATE(6632), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(10593), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [249822] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9418), 1,
      anon_sym_LBRACE,
    STATE(2486), 1,
      sym_compound_statement,
    ACTIONS(9388), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [249836] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(9617), 1,
      anon_sym_COLON,
    STATE(7239), 1,
      sym_compound_statement,
    STATE(7319), 1,
      sym_field_initializer_list,
  [249852] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7307), 1,
      anon_sym_LPAREN2,
    STATE(7568), 1,
      sym_argument_list,
    ACTIONS(10826), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [249866] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(10828), 1,
      anon_sym_SEMI,
    STATE(6670), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [249880] = 5,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(10830), 1,
      anon_sym_DQUOTE,
    ACTIONS(10832), 1,
      aux_sym_string_literal_token1,
    ACTIONS(10834), 1,
      sym_escape_sequence,
    STATE(6715), 1,
      aux_sym_string_literal_repeat1,
  [249896] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10836), 1,
      anon_sym_EQ,
    STATE(5886), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [249910] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4591), 1,
      anon_sym_LT,
    ACTIONS(10555), 1,
      sym_identifier,
    STATE(921), 1,
      sym_template_parameter_list,
    STATE(2433), 1,
      sym_template_type,
  [249926] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4910), 1,
      anon_sym_COLON,
    ACTIONS(5575), 1,
      anon_sym_LBRACE,
    STATE(5043), 1,
      sym_field_declaration_list,
    STATE(7386), 1,
      sym_base_class_clause,
  [249942] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4536), 1,
      anon_sym_SEMI,
    ACTIONS(6103), 1,
      anon_sym_LT,
    STATE(1828), 1,
      sym_template_argument_list,
  [249958] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(10838), 1,
      anon_sym_SEMI,
    STATE(6599), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [249972] = 5,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(10840), 1,
      anon_sym_DQUOTE,
    ACTIONS(10842), 1,
      aux_sym_string_literal_token1,
    ACTIONS(10845), 1,
      sym_escape_sequence,
    STATE(6728), 1,
      aux_sym_string_literal_repeat1,
  [249988] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3194), 1,
      anon_sym_LBRACE,
    ACTIONS(7307), 1,
      anon_sym_LPAREN2,
    STATE(7028), 2,
      sym_argument_list,
      sym_initializer_list,
  [250002] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9456), 1,
      anon_sym_LBRACE,
    STATE(5824), 1,
      sym_compound_statement,
    ACTIONS(9388), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [250016] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9408), 1,
      anon_sym_LBRACE,
    STATE(3571), 1,
      sym_compound_statement,
    ACTIONS(9388), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [250030] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(9617), 1,
      anon_sym_COLON,
    STATE(7073), 1,
      sym_compound_statement,
    STATE(7400), 1,
      sym_field_initializer_list,
  [250046] = 5,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(10848), 1,
      anon_sym_DQUOTE,
    ACTIONS(10850), 1,
      aux_sym_string_literal_token1,
    ACTIONS(10852), 1,
      sym_escape_sequence,
    STATE(6789), 1,
      aux_sym_string_literal_repeat1,
  [250062] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10854), 1,
      anon_sym___except,
    ACTIONS(10856), 1,
      anon_sym___finally,
    STATE(497), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [250076] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4910), 1,
      anon_sym_COLON,
    ACTIONS(8157), 1,
      anon_sym_LBRACE,
    STATE(4783), 1,
      sym_field_declaration_list,
    STATE(7450), 1,
      sym_base_class_clause,
  [250092] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9456), 1,
      anon_sym_LBRACE,
    STATE(5830), 1,
      sym_compound_statement,
    ACTIONS(9388), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [250106] = 4,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(10858), 1,
      anon_sym_SQUOTE,
    STATE(6632), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(10593), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [250120] = 5,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(10587), 1,
      aux_sym_string_literal_token1,
    ACTIONS(10589), 1,
      sym_escape_sequence,
    ACTIONS(10860), 1,
      anon_sym_DQUOTE,
    STATE(6728), 1,
      aux_sym_string_literal_repeat1,
  [250136] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(10573), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10862), 1,
      anon_sym_GT2,
    STATE(7082), 1,
      aux_sym_template_argument_list_repeat1,
  [250152] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9749), 1,
      sym_identifier,
    ACTIONS(10864), 1,
      aux_sym_preproc_if_token2,
    STATE(6390), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(8236), 1,
      sym_enumerator,
  [250168] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4910), 1,
      anon_sym_COLON,
    ACTIONS(6905), 1,
      anon_sym_LBRACE,
    STATE(3984), 1,
      sym_field_declaration_list,
    STATE(7394), 1,
      sym_base_class_clause,
  [250184] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10253), 1,
      anon_sym_EQ,
    STATE(6623), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [250198] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(10866), 1,
      anon_sym_SEMI,
    STATE(4640), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [250212] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9456), 1,
      anon_sym_LBRACE,
    STATE(5786), 1,
      sym_compound_statement,
    ACTIONS(9388), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [250226] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9424), 1,
      anon_sym_LBRACE,
    STATE(3370), 1,
      sym_compound_statement,
    ACTIONS(9388), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [250240] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10868), 1,
      sym_identifier,
    ACTIONS(10870), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [250252] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10569), 1,
      anon_sym_LPAREN2,
    ACTIONS(10872), 1,
      anon_sym_LBRACE,
    STATE(5569), 1,
      sym_requirement_seq,
    STATE(7557), 1,
      sym_requires_parameter_list,
  [250268] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(10874), 1,
      anon_sym_SEMI,
    STATE(6700), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [250282] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10608), 1,
      anon_sym_COMMA,
    STATE(6628), 1,
      aux_sym_gnu_asm_output_operand_list_repeat1,
    ACTIONS(10876), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [250296] = 5,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(10587), 1,
      aux_sym_string_literal_token1,
    ACTIONS(10589), 1,
      sym_escape_sequence,
    ACTIONS(10878), 1,
      anon_sym_DQUOTE,
    STATE(6728), 1,
      aux_sym_string_literal_repeat1,
  [250312] = 4,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(10880), 1,
      anon_sym_SQUOTE,
    STATE(6632), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(10593), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [250326] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(10573), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10882), 1,
      anon_sym_GT2,
    STATE(6970), 1,
      aux_sym_template_argument_list_repeat1,
  [250342] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9430), 1,
      anon_sym_LBRACE,
    STATE(1757), 1,
      sym_compound_statement,
    ACTIONS(9388), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [250356] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4910), 1,
      anon_sym_COLON,
    ACTIONS(6905), 1,
      anon_sym_LBRACE,
    STATE(3986), 1,
      sym_field_declaration_list,
    STATE(7407), 1,
      sym_base_class_clause,
  [250372] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4910), 1,
      anon_sym_COLON,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    STATE(3957), 1,
      sym_field_declaration_list,
    STATE(7488), 1,
      sym_base_class_clause,
  [250388] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10884), 1,
      anon_sym___except,
    ACTIONS(10886), 1,
      anon_sym___finally,
    STATE(310), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [250402] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8742), 1,
      anon_sym_LBRACE,
    ACTIONS(10569), 1,
      anon_sym_LPAREN2,
    STATE(3840), 1,
      sym_requirement_seq,
    STATE(7591), 1,
      sym_requires_parameter_list,
  [250418] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9392), 1,
      anon_sym_LBRACE,
    STATE(3383), 1,
      sym_compound_statement,
    ACTIONS(9388), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [250432] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8734), 1,
      anon_sym_LBRACE,
    ACTIONS(10569), 1,
      anon_sym_LPAREN2,
    STATE(3480), 1,
      sym_requirement_seq,
    STATE(7360), 1,
      sym_requires_parameter_list,
  [250448] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(10888), 1,
      anon_sym_SEMI,
    STATE(6807), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [250462] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9424), 1,
      anon_sym_LBRACE,
    STATE(3375), 1,
      sym_compound_statement,
    ACTIONS(9388), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [250476] = 5,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(10890), 1,
      anon_sym_DQUOTE,
    ACTIONS(10892), 1,
      aux_sym_string_literal_token1,
    ACTIONS(10894), 1,
      sym_escape_sequence,
    STATE(6750), 1,
      aux_sym_string_literal_repeat1,
  [250492] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9458), 1,
      anon_sym_LBRACE,
    STATE(4323), 1,
      sym_compound_statement,
    ACTIONS(9388), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [250506] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9418), 1,
      anon_sym_LBRACE,
    STATE(2550), 1,
      sym_compound_statement,
    ACTIONS(9388), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [250520] = 5,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(10896), 1,
      anon_sym_DQUOTE,
    ACTIONS(10898), 1,
      aux_sym_string_literal_token1,
    ACTIONS(10900), 1,
      sym_escape_sequence,
    STATE(6787), 1,
      aux_sym_string_literal_repeat1,
  [250536] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8726), 1,
      anon_sym_LBRACE,
    ACTIONS(10569), 1,
      anon_sym_LPAREN2,
    STATE(2588), 1,
      sym_requirement_seq,
    STATE(7379), 1,
      sym_requires_parameter_list,
  [250552] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6103), 1,
      anon_sym_LT,
    ACTIONS(10902), 1,
      anon_sym_SEMI,
    STATE(1741), 1,
      sym_template_argument_list,
  [250568] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10904), 1,
      anon_sym_EQ,
    STATE(5886), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [250582] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9396), 1,
      anon_sym_LBRACE,
    STATE(3864), 1,
      sym_compound_statement,
    ACTIONS(9388), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [250596] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10211), 1,
      anon_sym_EQ,
    STATE(6602), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [250610] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8718), 1,
      anon_sym_LBRACE,
    ACTIONS(10569), 1,
      anon_sym_LPAREN2,
    STATE(3413), 1,
      sym_requirement_seq,
    STATE(7260), 1,
      sym_requires_parameter_list,
  [250626] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10243), 1,
      anon_sym_EQ,
    STATE(6647), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [250640] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9749), 1,
      sym_identifier,
    ACTIONS(10541), 1,
      aux_sym_preproc_if_token2,
    STATE(6740), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(8236), 1,
      sym_enumerator,
  [250656] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4910), 1,
      anon_sym_COLON,
    ACTIONS(8157), 1,
      anon_sym_LBRACE,
    STATE(4785), 1,
      sym_field_declaration_list,
    STATE(7511), 1,
      sym_base_class_clause,
  [250672] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(10906), 1,
      anon_sym_SEMI,
    STATE(4640), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [250686] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(1749), 1,
      sym_compound_statement,
    ACTIONS(9388), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [250700] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(10908), 1,
      anon_sym_SEMI,
    STATE(4640), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [250714] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(10910), 1,
      anon_sym_SEMI,
    STATE(6775), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [250728] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4633), 1,
      anon_sym_LBRACE,
    ACTIONS(10561), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10912), 1,
      anon_sym_EQ,
    STATE(803), 1,
      sym_declaration_list,
  [250744] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(10573), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10914), 1,
      anon_sym_GT2,
    STATE(6945), 1,
      aux_sym_template_argument_list_repeat1,
  [250760] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(1755), 1,
      sym_compound_statement,
    ACTIONS(9388), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [250774] = 4,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(10916), 1,
      anon_sym_SQUOTE,
    STATE(6632), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(10593), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [250788] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6103), 1,
      anon_sym_LT,
    ACTIONS(10918), 1,
      anon_sym_SEMI,
    STATE(1741), 1,
      sym_template_argument_list,
  [250804] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(10573), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10920), 1,
      anon_sym_GT2,
    STATE(7013), 1,
      aux_sym_template_argument_list_repeat1,
  [250820] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6103), 1,
      anon_sym_LT,
    ACTIONS(10922), 1,
      anon_sym_SEMI,
    STATE(1741), 1,
      sym_template_argument_list,
  [250836] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4910), 1,
      anon_sym_COLON,
    ACTIONS(8332), 1,
      anon_sym_LBRACE,
    STATE(4937), 1,
      sym_field_declaration_list,
    STATE(7457), 1,
      sym_base_class_clause,
  [250852] = 5,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(10587), 1,
      aux_sym_string_literal_token1,
    ACTIONS(10589), 1,
      sym_escape_sequence,
    ACTIONS(10924), 1,
      anon_sym_DQUOTE,
    STATE(6728), 1,
      aux_sym_string_literal_repeat1,
  [250868] = 5,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(10587), 1,
      aux_sym_string_literal_token1,
    ACTIONS(10589), 1,
      sym_escape_sequence,
    ACTIONS(10926), 1,
      anon_sym_DQUOTE,
    STATE(6728), 1,
      aux_sym_string_literal_repeat1,
  [250884] = 5,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(10587), 1,
      aux_sym_string_literal_token1,
    ACTIONS(10589), 1,
      sym_escape_sequence,
    ACTIONS(10928), 1,
      anon_sym_DQUOTE,
    STATE(6728), 1,
      aux_sym_string_literal_repeat1,
  [250900] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(10930), 1,
      anon_sym_SEMI,
    STATE(6777), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [250914] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(1757), 1,
      sym_compound_statement,
    ACTIONS(9388), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [250928] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10569), 1,
      anon_sym_LPAREN2,
    ACTIONS(10932), 1,
      anon_sym_LBRACE,
    STATE(5828), 1,
      sym_requirement_seq,
    STATE(7479), 1,
      sym_requires_parameter_list,
  [250944] = 4,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(10934), 1,
      anon_sym_SQUOTE,
    STATE(6632), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(10593), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [250958] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(10573), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10936), 1,
      anon_sym_GT2,
    STATE(7163), 1,
      aux_sym_template_argument_list_repeat1,
  [250974] = 5,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(10587), 1,
      aux_sym_string_literal_token1,
    ACTIONS(10589), 1,
      sym_escape_sequence,
    ACTIONS(10938), 1,
      anon_sym_DQUOTE,
    STATE(6728), 1,
      aux_sym_string_literal_repeat1,
  [250990] = 4,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(10940), 1,
      anon_sym_SQUOTE,
    STATE(6632), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(10593), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [251004] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4910), 1,
      anon_sym_COLON,
    ACTIONS(8332), 1,
      anon_sym_LBRACE,
    STATE(4904), 1,
      sym_field_declaration_list,
    STATE(7465), 1,
      sym_base_class_clause,
  [251020] = 4,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(10942), 1,
      anon_sym_SQUOTE,
    STATE(6632), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(10593), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [251034] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10944), 1,
      anon_sym_EQ,
    STATE(5886), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [251048] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(10946), 1,
      anon_sym_SEMI,
    STATE(6645), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [251062] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10948), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [251072] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9430), 1,
      anon_sym_LBRACE,
    STATE(1755), 1,
      sym_compound_statement,
    ACTIONS(9388), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [251086] = 5,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(10950), 1,
      anon_sym_DQUOTE,
    ACTIONS(10952), 1,
      aux_sym_string_literal_token1,
    ACTIONS(10954), 1,
      sym_escape_sequence,
    STATE(6664), 1,
      aux_sym_string_literal_repeat1,
  [251102] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10683), 1,
      anon_sym_COMMA,
    STATE(6654), 1,
      aux_sym_gnu_asm_clobber_list_repeat1,
    ACTIONS(10956), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [251116] = 5,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(10958), 1,
      anon_sym_DQUOTE,
    ACTIONS(10960), 1,
      aux_sym_string_literal_token1,
    ACTIONS(10962), 1,
      sym_escape_sequence,
    STATE(6663), 1,
      aux_sym_string_literal_repeat1,
  [251132] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(10964), 1,
      anon_sym_SEMI,
    STATE(6830), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [251146] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(10966), 1,
      anon_sym_SEMI,
    STATE(4640), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [251160] = 5,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(10968), 1,
      anon_sym_DQUOTE,
    ACTIONS(10970), 1,
      aux_sym_string_literal_token1,
    ACTIONS(10972), 1,
      sym_escape_sequence,
    STATE(6795), 1,
      aux_sym_string_literal_repeat1,
  [251176] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10974), 1,
      anon_sym_EQ,
    STATE(6841), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [251190] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4908), 1,
      anon_sym_LBRACE,
    ACTIONS(4910), 1,
      anon_sym_COLON,
    STATE(2302), 1,
      sym_field_declaration_list,
    STATE(7297), 1,
      sym_base_class_clause,
  [251206] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10976), 1,
      anon_sym_COMMA,
    STATE(6678), 1,
      aux_sym_gnu_asm_input_operand_list_repeat1,
    ACTIONS(10978), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [251220] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(10980), 1,
      anon_sym_SEMI,
    STATE(6847), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [251234] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4910), 1,
      anon_sym_COLON,
    ACTIONS(5575), 1,
      anon_sym_LBRACE,
    STATE(2533), 1,
      sym_field_declaration_list,
    STATE(7399), 1,
      sym_base_class_clause,
  [251250] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10982), 1,
      anon_sym___except,
    ACTIONS(10984), 1,
      anon_sym___finally,
    STATE(537), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [251264] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10986), 1,
      anon_sym_EQ,
    STATE(5886), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [251278] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9526), 1,
      sym_identifier,
    ACTIONS(10988), 1,
      aux_sym_preproc_if_token2,
    STATE(6705), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
  [251292] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(10990), 1,
      anon_sym_SEMI,
    STATE(6835), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [251306] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9418), 1,
      anon_sym_LBRACE,
    STATE(2587), 1,
      sym_compound_statement,
    ACTIONS(9388), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [251320] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10992), 1,
      anon_sym_COMMA,
    STATE(6819), 1,
      aux_sym_gnu_asm_output_operand_list_repeat1,
    ACTIONS(10995), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [251334] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(10997), 1,
      anon_sym_SEMI,
    STATE(4640), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [251348] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9444), 1,
      anon_sym_LBRACE,
    STATE(5601), 1,
      sym_compound_statement,
    ACTIONS(9388), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [251362] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(10999), 1,
      anon_sym_SEMI,
    STATE(4640), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [251376] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(11001), 1,
      anon_sym_SEMI,
    STATE(6743), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [251390] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(11003), 1,
      anon_sym_SEMI,
    STATE(6820), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [251404] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4910), 1,
      anon_sym_COLON,
    ACTIONS(6138), 1,
      anon_sym_LBRACE,
    STATE(3118), 1,
      sym_field_declaration_list,
    STATE(7340), 1,
      sym_base_class_clause,
  [251420] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(11005), 1,
      anon_sym_SEMI,
    STATE(4640), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [251434] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9444), 1,
      anon_sym_LBRACE,
    STATE(5651), 1,
      sym_compound_statement,
    ACTIONS(9388), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [251448] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9430), 1,
      anon_sym_LBRACE,
    STATE(1749), 1,
      sym_compound_statement,
    ACTIONS(9388), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [251462] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10725), 1,
      anon_sym_COMMA,
    ACTIONS(11007), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11009), 1,
      anon_sym_LBRACE,
    STATE(7042), 1,
      aux_sym_base_class_clause_repeat1,
  [251478] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(11011), 1,
      anon_sym_SEMI,
    STATE(4640), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [251492] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1893), 1,
      anon_sym_LBRACE,
    ACTIONS(5212), 1,
      anon_sym_LPAREN2,
    STATE(2526), 1,
      sym_argument_list,
    STATE(2574), 1,
      sym_initializer_list,
  [251508] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10948), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [251518] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11013), 1,
      anon_sym_SEMI,
    ACTIONS(11015), 1,
      anon_sym_DASH_GT,
    ACTIONS(11017), 1,
      anon_sym_noexcept,
    STATE(7616), 1,
      sym_trailing_return_type,
  [251534] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(10573), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11019), 1,
      anon_sym_GT2,
    STATE(6929), 1,
      aux_sym_template_argument_list_repeat1,
  [251550] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(11021), 1,
      anon_sym_SEMI,
    STATE(4640), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [251564] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4910), 1,
      anon_sym_COLON,
    ACTIONS(5968), 1,
      anon_sym_LBRACE,
    STATE(2889), 1,
      sym_field_declaration_list,
    STATE(7525), 1,
      sym_base_class_clause,
  [251580] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10249), 1,
      anon_sym_EQ,
    STATE(6687), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [251594] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9458), 1,
      anon_sym_LBRACE,
    STATE(4343), 1,
      sym_compound_statement,
    ACTIONS(9388), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [251608] = 5,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(10623), 1,
      anon_sym_LPAREN,
    ACTIONS(11023), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(11025), 1,
      sym_preproc_arg,
    STATE(7414), 1,
      sym_preproc_params,
  [251624] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(11027), 1,
      anon_sym_SEMI,
    STATE(6822), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [251638] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11029), 1,
      anon_sym_EQ,
    STATE(5886), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [251652] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9444), 1,
      anon_sym_LBRACE,
    STATE(5678), 1,
      sym_compound_statement,
    ACTIONS(9388), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [251666] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10725), 1,
      anon_sym_COMMA,
    ACTIONS(11031), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11033), 1,
      anon_sym_LBRACE,
    STATE(6880), 1,
      aux_sym_base_class_clause_repeat1,
  [251682] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10235), 1,
      anon_sym_EQ,
    STATE(6815), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [251696] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10976), 1,
      anon_sym_COMMA,
    STATE(6811), 1,
      aux_sym_gnu_asm_input_operand_list_repeat1,
    ACTIONS(11035), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [251710] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11037), 1,
      anon_sym_EQ,
    STATE(6768), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [251724] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym___attribute__,
    ACTIONS(11039), 1,
      anon_sym_SEMI,
    STATE(4640), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [251738] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1967), 1,
      anon_sym_LBRACE,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    STATE(3362), 1,
      sym_argument_list,
    STATE(3363), 1,
      sym_initializer_list,
  [251754] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8758), 1,
      anon_sym_LBRACE,
    ACTIONS(10569), 1,
      anon_sym_LPAREN2,
    STATE(4290), 1,
      sym_requirement_seq,
    STATE(7328), 1,
      sym_requires_parameter_list,
  [251770] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8750), 1,
      anon_sym_LBRACE,
    ACTIONS(10569), 1,
      anon_sym_LPAREN2,
    STATE(3584), 1,
      sym_requirement_seq,
    STATE(7377), 1,
      sym_requires_parameter_list,
  [251786] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9424), 1,
      anon_sym_LBRACE,
    STATE(3401), 1,
      sym_compound_statement,
    ACTIONS(9388), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [251800] = 5,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(10587), 1,
      aux_sym_string_literal_token1,
    ACTIONS(10589), 1,
      sym_escape_sequence,
    ACTIONS(11041), 1,
      anon_sym_DQUOTE,
    STATE(6728), 1,
      aux_sym_string_literal_repeat1,
  [251816] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2473), 1,
      anon_sym_LBRACE,
    ACTIONS(6163), 1,
      anon_sym_LPAREN2,
    STATE(3362), 1,
      sym_argument_list,
    STATE(3841), 1,
      sym_initializer_list,
  [251832] = 4,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(11043), 1,
      anon_sym_SQUOTE,
    STATE(6632), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(10593), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [251846] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4910), 1,
      anon_sym_COLON,
    ACTIONS(5968), 1,
      anon_sym_LBRACE,
    STATE(2975), 1,
      sym_field_declaration_list,
    STATE(7541), 1,
      sym_base_class_clause,
  [251862] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4631), 1,
      anon_sym_LBRACE,
    ACTIONS(10561), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11045), 1,
      anon_sym_EQ,
    STATE(756), 1,
      sym_declaration_list,
  [251878] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_LBRACK,
    STATE(3698), 1,
      sym_parameter_list,
    STATE(5915), 1,
      sym__function_declarator_seq,
  [251894] = 5,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(10623), 1,
      anon_sym_LPAREN,
    ACTIONS(11047), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(11049), 1,
      sym_preproc_arg,
    STATE(7280), 1,
      sym_preproc_params,
  [251910] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11051), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11053), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [251921] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10184), 3,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
  [251930] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11055), 1,
      anon_sym_RPAREN,
    ACTIONS(11057), 1,
      anon_sym_COLON,
    STATE(6952), 1,
      sym_gnu_asm_clobber_list,
  [251943] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8107), 1,
      anon_sym_RPAREN,
    ACTIONS(11059), 1,
      anon_sym_COMMA,
    STATE(6862), 1,
      aux_sym_argument_list_repeat1,
  [251956] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11062), 1,
      anon_sym_default,
    ACTIONS(11064), 1,
      anon_sym_delete,
    ACTIONS(11066), 1,
      anon_sym_0,
  [251969] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7729), 1,
      anon_sym_COMMA,
    ACTIONS(7867), 1,
      anon_sym_RPAREN,
    STATE(6862), 1,
      aux_sym_argument_list_repeat1,
  [251982] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11068), 1,
      anon_sym_RPAREN,
    ACTIONS(11070), 1,
      anon_sym_COLON,
    STATE(6953), 1,
      sym_gnu_asm_input_operand_list,
  [251995] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7891), 1,
      anon_sym_COMMA,
    ACTIONS(7893), 1,
      anon_sym_RBRACE,
    STATE(7055), 1,
      aux_sym_initializer_list_repeat1,
  [252008] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9022), 1,
      anon_sym_COMMA,
    ACTIONS(11072), 1,
      anon_sym_SEMI,
    STATE(7018), 1,
      aux_sym_declaration_repeat1,
  [252021] = 3,
    ACTIONS(9020), 1,
      sym_comment,
    STATE(6683), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(11074), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [252032] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11076), 1,
      anon_sym_LPAREN2,
    ACTIONS(11078), 1,
      anon_sym_constexpr,
    STATE(177), 1,
      sym_condition_clause,
  [252045] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11080), 1,
      anon_sym_COMMA,
    ACTIONS(11082), 1,
      anon_sym_RPAREN,
    STATE(7140), 1,
      aux_sym_requires_parameter_list_repeat1,
  [252058] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11084), 1,
      anon_sym_COMMA,
    ACTIONS(11086), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7074), 1,
      aux_sym_attribute_declaration_repeat1,
  [252071] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11084), 1,
      anon_sym_COMMA,
    ACTIONS(11088), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(6898), 1,
      aux_sym_attribute_declaration_repeat1,
  [252084] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4633), 1,
      anon_sym_LBRACE,
    ACTIONS(10561), 1,
      anon_sym_COLON_COLON,
    STATE(719), 1,
      sym_declaration_list,
  [252097] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10561), 3,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
  [252106] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11090), 1,
      sym_identifier,
    STATE(2433), 1,
      sym_template_type,
    STATE(2835), 1,
      sym_template_function,
  [252119] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7729), 1,
      anon_sym_COMMA,
    ACTIONS(11092), 1,
      anon_sym_RPAREN,
    STATE(6862), 1,
      aux_sym_argument_list_repeat1,
  [252132] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7729), 1,
      anon_sym_COMMA,
    ACTIONS(7731), 1,
      anon_sym_RPAREN,
    STATE(6946), 1,
      aux_sym_argument_list_repeat1,
  [252145] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11096), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11094), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [252156] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10725), 1,
      anon_sym_COMMA,
    ACTIONS(11098), 1,
      anon_sym_LBRACE,
    STATE(7138), 1,
      aux_sym_base_class_clause_repeat1,
  [252169] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10725), 1,
      anon_sym_COMMA,
    ACTIONS(11098), 1,
      anon_sym_LBRACE,
    STATE(7044), 1,
      aux_sym_base_class_clause_repeat1,
  [252182] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11100), 1,
      anon_sym_catch,
    STATE(1937), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [252193] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11102), 1,
      anon_sym_catch,
    STATE(1989), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [252204] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11104), 3,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
  [252213] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7799), 1,
      anon_sym_COMMA,
    ACTIONS(7801), 1,
      anon_sym_RBRACE,
    STATE(6965), 1,
      aux_sym_initializer_list_repeat1,
  [252226] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11106), 3,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
  [252235] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11108), 3,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
  [252244] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11110), 1,
      anon_sym_RPAREN,
    ACTIONS(11112), 1,
      anon_sym_COLON,
    STATE(6967), 1,
      sym_gnu_asm_output_operand_list,
  [252257] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9022), 1,
      anon_sym_COMMA,
    ACTIONS(11114), 1,
      anon_sym_SEMI,
    STATE(6917), 1,
      aux_sym_declaration_repeat1,
  [252270] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3889), 1,
      anon_sym_RBRACE,
    ACTIONS(11116), 1,
      anon_sym_COMMA,
    STATE(7203), 1,
      aux_sym_initializer_list_repeat1,
  [252283] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11112), 1,
      anon_sym_COLON,
    ACTIONS(11118), 1,
      anon_sym_RPAREN,
    STATE(7049), 1,
      sym_gnu_asm_output_operand_list,
  [252296] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10725), 1,
      anon_sym_COMMA,
    ACTIONS(11033), 1,
      anon_sym_LBRACE,
    STATE(6880), 1,
      aux_sym_base_class_clause_repeat1,
  [252309] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11120), 1,
      sym_identifier,
    STATE(2433), 1,
      sym_template_type,
    STATE(3527), 1,
      sym_template_function,
  [252322] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9022), 1,
      anon_sym_COMMA,
    ACTIONS(11122), 1,
      anon_sym_SEMI,
    STATE(7121), 1,
      aux_sym_declaration_repeat1,
  [252335] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11124), 1,
      anon_sym_RPAREN,
    ACTIONS(11126), 1,
      anon_sym_COLON,
    STATE(8383), 1,
      sym_gnu_asm_goto_list,
  [252348] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11128), 1,
      anon_sym_GT2,
    STATE(6975), 1,
      aux_sym_template_argument_list_repeat1,
  [252361] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9022), 1,
      anon_sym_COMMA,
    ACTIONS(11130), 1,
      anon_sym_SEMI,
    STATE(7120), 1,
      aux_sym_declaration_repeat1,
  [252374] = 4,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(11132), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(11134), 1,
      anon_sym_LPAREN2,
    STATE(8016), 1,
      sym_preproc_argument_list,
  [252387] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11084), 1,
      anon_sym_COMMA,
    ACTIONS(11136), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7074), 1,
      aux_sym_attribute_declaration_repeat1,
  [252400] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9022), 1,
      anon_sym_COMMA,
    ACTIONS(11138), 1,
      anon_sym_SEMI,
    STATE(7120), 1,
      aux_sym_declaration_repeat1,
  [252413] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7809), 1,
      anon_sym_COMMA,
    ACTIONS(11140), 1,
      anon_sym_RBRACK,
    STATE(7046), 1,
      aux_sym_lambda_capture_specifier_repeat1,
  [252426] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11084), 1,
      anon_sym_COMMA,
    ACTIONS(11142), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7074), 1,
      aux_sym_attribute_declaration_repeat1,
  [252439] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11144), 1,
      anon_sym_COMMA,
    ACTIONS(11146), 1,
      anon_sym_RPAREN,
    STATE(7025), 1,
      aux_sym_throw_specifier_repeat1,
  [252452] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11148), 1,
      anon_sym_COMMA,
    ACTIONS(11150), 1,
      anon_sym_GT2,
    STATE(7088), 1,
      aux_sym_template_parameter_list_repeat1,
  [252465] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11057), 1,
      anon_sym_COLON,
    ACTIONS(11152), 1,
      anon_sym_RPAREN,
    STATE(6894), 1,
      sym_gnu_asm_clobber_list,
  [252478] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9022), 1,
      anon_sym_COMMA,
    ACTIONS(11154), 1,
      anon_sym_SEMI,
    STATE(6977), 1,
      aux_sym_declaration_repeat1,
  [252491] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9022), 1,
      anon_sym_COMMA,
    ACTIONS(11156), 1,
      anon_sym_SEMI,
    STATE(7120), 1,
      aux_sym_declaration_repeat1,
  [252504] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10725), 1,
      anon_sym_COMMA,
    ACTIONS(11033), 1,
      anon_sym_LBRACE,
    STATE(7044), 1,
      aux_sym_base_class_clause_repeat1,
  [252517] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11126), 1,
      anon_sym_COLON,
    ACTIONS(11158), 1,
      anon_sym_RPAREN,
    STATE(8379), 1,
      sym_gnu_asm_goto_list,
  [252530] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11160), 1,
      anon_sym_catch,
    STATE(421), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [252541] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11162), 1,
      anon_sym_GT2,
    STATE(6930), 1,
      aux_sym_template_argument_list_repeat1,
  [252554] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11164), 1,
      anon_sym_GT2,
    STATE(7032), 1,
      aux_sym_template_argument_list_repeat1,
  [252567] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11070), 1,
      anon_sym_COLON,
    ACTIONS(11166), 1,
      anon_sym_RPAREN,
    STATE(6904), 1,
      sym_gnu_asm_input_operand_list,
  [252580] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11057), 1,
      anon_sym_COLON,
    ACTIONS(11168), 1,
      anon_sym_RPAREN,
    STATE(6908), 1,
      sym_gnu_asm_clobber_list,
  [252593] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7729), 1,
      anon_sym_COMMA,
    ACTIONS(11170), 1,
      anon_sym_RPAREN,
    STATE(6862), 1,
      aux_sym_argument_list_repeat1,
  [252606] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9022), 1,
      anon_sym_COMMA,
    ACTIONS(11172), 1,
      anon_sym_SEMI,
    STATE(6934), 1,
      aux_sym_declaration_repeat1,
  [252619] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9022), 1,
      anon_sym_COMMA,
    ACTIONS(11174), 1,
      anon_sym_SEMI,
    STATE(7120), 1,
      aux_sym_declaration_repeat1,
  [252632] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9022), 1,
      anon_sym_COMMA,
    ACTIONS(11176), 1,
      anon_sym_SEMI,
    STATE(7120), 1,
      aux_sym_declaration_repeat1,
  [252645] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11178), 1,
      anon_sym_COMMA,
    ACTIONS(11180), 1,
      anon_sym_RPAREN,
    STATE(7102), 1,
      aux_sym_parameter_list_repeat1,
  [252658] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10725), 1,
      anon_sym_COMMA,
    ACTIONS(11009), 1,
      anon_sym_LBRACE,
    STATE(7044), 1,
      aux_sym_base_class_clause_repeat1,
  [252671] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11076), 1,
      anon_sym_LPAREN2,
    ACTIONS(11182), 1,
      anon_sym_constexpr,
    STATE(149), 1,
      sym_condition_clause,
  [252684] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11184), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11186), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [252695] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11102), 1,
      anon_sym_catch,
    STATE(1970), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [252706] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9022), 1,
      anon_sym_COMMA,
    ACTIONS(11188), 1,
      anon_sym_SEMI,
    STATE(7120), 1,
      aux_sym_declaration_repeat1,
  [252719] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11190), 1,
      anon_sym_COMMA,
    ACTIONS(11192), 1,
      anon_sym_RPAREN,
    STATE(7005), 1,
      aux_sym_preproc_params_repeat1,
  [252732] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2498), 1,
      anon_sym_while,
    ACTIONS(11194), 1,
      anon_sym_else,
    STATE(455), 1,
      sym_else_clause,
  [252745] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4001), 1,
      anon_sym_RBRACE,
    ACTIONS(11196), 1,
      anon_sym_COMMA,
    STATE(7203), 1,
      aux_sym_initializer_list_repeat1,
  [252758] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7859), 1,
      anon_sym_COMMA,
    ACTIONS(7953), 1,
      anon_sym_RBRACK,
    STATE(6964), 1,
      aux_sym_subscript_argument_list_repeat1,
  [252771] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11198), 1,
      anon_sym_GT2,
    STATE(7217), 1,
      aux_sym_template_argument_list_repeat1,
  [252784] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11200), 1,
      anon_sym_GT2,
    STATE(7217), 1,
      aux_sym_template_argument_list_repeat1,
  [252797] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11202), 1,
      anon_sym_GT2,
    STATE(7217), 1,
      aux_sym_template_argument_list_repeat1,
  [252810] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11084), 1,
      anon_sym_COMMA,
    ACTIONS(11204), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(6871), 1,
      aux_sym_attribute_declaration_repeat1,
  [252823] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11070), 1,
      anon_sym_COLON,
    ACTIONS(11206), 1,
      anon_sym_RPAREN,
    STATE(7060), 1,
      sym_gnu_asm_input_operand_list,
  [252836] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11112), 1,
      anon_sym_COLON,
    ACTIONS(11208), 1,
      anon_sym_RPAREN,
    STATE(7026), 1,
      sym_gnu_asm_output_operand_list,
  [252849] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9022), 1,
      anon_sym_COMMA,
    ACTIONS(11210), 1,
      anon_sym_SEMI,
    STATE(7120), 1,
      aux_sym_declaration_repeat1,
  [252862] = 3,
    ACTIONS(9020), 1,
      sym_comment,
    STATE(6656), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(11212), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [252873] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11214), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11216), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [252884] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11218), 1,
      anon_sym_GT2,
    STATE(7217), 1,
      aux_sym_template_argument_list_repeat1,
  [252897] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11220), 1,
      anon_sym_GT2,
    STATE(7217), 1,
      aux_sym_template_argument_list_repeat1,
  [252910] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11222), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [252919] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11224), 1,
      anon_sym_GT2,
    STATE(7217), 1,
      aux_sym_template_argument_list_repeat1,
  [252932] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11226), 1,
      anon_sym_GT2,
    STATE(7217), 1,
      aux_sym_template_argument_list_repeat1,
  [252945] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11228), 1,
      anon_sym_catch,
    STATE(422), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [252956] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11230), 1,
      anon_sym_GT2,
    STATE(7030), 1,
      aux_sym_template_argument_list_repeat1,
  [252969] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11148), 1,
      anon_sym_COMMA,
    ACTIONS(11232), 1,
      anon_sym_GT2,
    STATE(7171), 1,
      aux_sym_template_parameter_list_repeat1,
  [252982] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11234), 1,
      anon_sym_GT2,
    STATE(7217), 1,
      aux_sym_template_argument_list_repeat1,
  [252995] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7729), 1,
      anon_sym_COMMA,
    ACTIONS(7885), 1,
      anon_sym_RPAREN,
    STATE(6862), 1,
      aux_sym_argument_list_repeat1,
  [253008] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11236), 1,
      anon_sym_GT2,
    STATE(7217), 1,
      aux_sym_template_argument_list_repeat1,
  [253021] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10725), 1,
      anon_sym_COMMA,
    ACTIONS(11009), 1,
      anon_sym_LBRACE,
    STATE(7042), 1,
      aux_sym_base_class_clause_repeat1,
  [253034] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11112), 1,
      anon_sym_COLON,
    ACTIONS(11238), 1,
      anon_sym_RPAREN,
    STATE(6912), 1,
      sym_gnu_asm_output_operand_list,
  [253047] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11070), 1,
      anon_sym_COLON,
    ACTIONS(11240), 1,
      anon_sym_RPAREN,
    STATE(6913), 1,
      sym_gnu_asm_input_operand_list,
  [253060] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11178), 1,
      anon_sym_COMMA,
    ACTIONS(11242), 1,
      anon_sym_RPAREN,
    STATE(6962), 1,
      aux_sym_parameter_list_repeat1,
  [253073] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11126), 1,
      anon_sym_COLON,
    ACTIONS(11244), 1,
      anon_sym_RPAREN,
    STATE(8300), 1,
      sym_gnu_asm_goto_list,
  [253086] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11057), 1,
      anon_sym_COLON,
    ACTIONS(11246), 1,
      anon_sym_RPAREN,
    STATE(6961), 1,
      sym_gnu_asm_clobber_list,
  [253099] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9022), 1,
      anon_sym_COMMA,
    ACTIONS(11248), 1,
      anon_sym_SEMI,
    STATE(7120), 1,
      aux_sym_declaration_repeat1,
  [253112] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7729), 1,
      anon_sym_COMMA,
    ACTIONS(7943), 1,
      anon_sym_RPAREN,
    STATE(6862), 1,
      aux_sym_argument_list_repeat1,
  [253125] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9022), 1,
      anon_sym_COMMA,
    ACTIONS(11250), 1,
      anon_sym_SEMI,
    STATE(7120), 1,
      aux_sym_declaration_repeat1,
  [253138] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9022), 1,
      anon_sym_COMMA,
    ACTIONS(11252), 1,
      anon_sym_SEMI,
    STATE(6960), 1,
      aux_sym_declaration_repeat1,
  [253151] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11015), 1,
      anon_sym_DASH_GT,
    ACTIONS(11254), 1,
      anon_sym_SEMI,
    STATE(8062), 1,
      sym_trailing_return_type,
  [253164] = 4,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(11134), 1,
      anon_sym_LPAREN2,
    ACTIONS(11256), 1,
      aux_sym_preproc_include_token2,
    STATE(8016), 1,
      sym_preproc_argument_list,
  [253177] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9022), 1,
      anon_sym_COMMA,
    ACTIONS(11258), 1,
      anon_sym_SEMI,
    STATE(7120), 1,
      aux_sym_declaration_repeat1,
  [253190] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11126), 1,
      anon_sym_COLON,
    ACTIONS(11260), 1,
      anon_sym_RPAREN,
    STATE(8293), 1,
      sym_gnu_asm_goto_list,
  [253203] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11178), 1,
      anon_sym_COMMA,
    ACTIONS(11262), 1,
      anon_sym_RPAREN,
    STATE(7143), 1,
      aux_sym_parameter_list_repeat1,
  [253216] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11228), 1,
      anon_sym_catch,
    STATE(424), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [253227] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7859), 1,
      anon_sym_COMMA,
    ACTIONS(11264), 1,
      anon_sym_RBRACK,
    STATE(7072), 1,
      aux_sym_subscript_argument_list_repeat1,
  [253240] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4003), 1,
      anon_sym_RBRACE,
    ACTIONS(11266), 1,
      anon_sym_COMMA,
    STATE(7203), 1,
      aux_sym_initializer_list_repeat1,
  [253253] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7735), 1,
      anon_sym_COMMA,
    ACTIONS(11268), 1,
      anon_sym_RPAREN,
    STATE(7256), 1,
      aux_sym_generic_expression_repeat1,
  [253266] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11070), 1,
      anon_sym_COLON,
    ACTIONS(11270), 1,
      anon_sym_RPAREN,
    STATE(6990), 1,
      sym_gnu_asm_input_operand_list,
  [253279] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11112), 1,
      anon_sym_COLON,
    ACTIONS(11272), 1,
      anon_sym_RPAREN,
    STATE(6992), 1,
      sym_gnu_asm_output_operand_list,
  [253292] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11274), 1,
      anon_sym_GT2,
    STATE(7217), 1,
      aux_sym_template_argument_list_repeat1,
  [253305] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11276), 1,
      anon_sym_GT2,
    STATE(7217), 1,
      aux_sym_template_argument_list_repeat1,
  [253318] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11102), 1,
      anon_sym_catch,
    STATE(1977), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [253329] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8982), 1,
      anon_sym_COMMA,
    ACTIONS(11278), 1,
      anon_sym_RPAREN,
    STATE(7150), 1,
      aux_sym_preproc_argument_list_repeat1,
  [253342] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11076), 1,
      anon_sym_LPAREN2,
    ACTIONS(11280), 1,
      anon_sym_constexpr,
    STATE(192), 1,
      sym_condition_clause,
  [253355] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7729), 1,
      anon_sym_COMMA,
    ACTIONS(11282), 1,
      anon_sym_RPAREN,
    STATE(6862), 1,
      aux_sym_argument_list_repeat1,
  [253368] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11284), 1,
      anon_sym_GT2,
    STATE(7217), 1,
      aux_sym_template_argument_list_repeat1,
  [253381] = 3,
    ACTIONS(9020), 1,
      sym_comment,
    STATE(6782), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(11286), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [253392] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9022), 1,
      anon_sym_COMMA,
    ACTIONS(11288), 1,
      anon_sym_SEMI,
    STATE(7120), 1,
      aux_sym_declaration_repeat1,
  [253405] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8982), 1,
      anon_sym_COMMA,
    ACTIONS(11290), 1,
      anon_sym_RPAREN,
    STATE(7150), 1,
      aux_sym_preproc_argument_list_repeat1,
  [253418] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9022), 1,
      anon_sym_COMMA,
    ACTIONS(11292), 1,
      anon_sym_SEMI,
    STATE(7120), 1,
      aux_sym_declaration_repeat1,
  [253431] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8982), 1,
      anon_sym_COMMA,
    ACTIONS(11294), 1,
      anon_sym_RPAREN,
    STATE(7150), 1,
      aux_sym_preproc_argument_list_repeat1,
  [253444] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11296), 1,
      sym_identifier,
    STATE(2433), 1,
      sym_template_type,
    STATE(3338), 1,
      sym_template_function,
  [253457] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11160), 1,
      anon_sym_catch,
    STATE(423), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [253468] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9022), 1,
      anon_sym_COMMA,
    ACTIONS(11298), 1,
      anon_sym_SEMI,
    STATE(7120), 1,
      aux_sym_declaration_repeat1,
  [253481] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11084), 1,
      anon_sym_COMMA,
    ACTIONS(11300), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7240), 1,
      aux_sym_attribute_declaration_repeat1,
  [253494] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7729), 1,
      anon_sym_COMMA,
    ACTIONS(11302), 1,
      anon_sym_RPAREN,
    STATE(6862), 1,
      aux_sym_argument_list_repeat1,
  [253507] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7729), 1,
      anon_sym_COMMA,
    ACTIONS(11304), 1,
      anon_sym_RPAREN,
    STATE(6862), 1,
      aux_sym_argument_list_repeat1,
  [253520] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11112), 1,
      anon_sym_COLON,
    ACTIONS(11306), 1,
      anon_sym_RPAREN,
    STATE(6991), 1,
      sym_gnu_asm_output_operand_list,
  [253533] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5752), 1,
      anon_sym_SEMI,
    ACTIONS(6103), 1,
      anon_sym_LT,
    STATE(1828), 1,
      sym_template_argument_list,
  [253546] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9022), 1,
      anon_sym_COMMA,
    ACTIONS(11308), 1,
      anon_sym_SEMI,
    STATE(6923), 1,
      aux_sym_declaration_repeat1,
  [253559] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11057), 1,
      anon_sym_COLON,
    ACTIONS(11310), 1,
      anon_sym_RPAREN,
    STATE(6993), 1,
      sym_gnu_asm_clobber_list,
  [253572] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11070), 1,
      anon_sym_COLON,
    ACTIONS(11312), 1,
      anon_sym_RPAREN,
    STATE(7250), 1,
      sym_gnu_asm_input_operand_list,
  [253585] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11070), 1,
      anon_sym_COLON,
    ACTIONS(11314), 1,
      anon_sym_RPAREN,
    STATE(7003), 1,
      sym_gnu_asm_input_operand_list,
  [253598] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11126), 1,
      anon_sym_COLON,
    ACTIONS(11316), 1,
      anon_sym_RPAREN,
    STATE(7704), 1,
      sym_gnu_asm_goto_list,
  [253611] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7859), 1,
      anon_sym_COMMA,
    ACTIONS(11318), 1,
      anon_sym_RBRACK,
    STATE(7072), 1,
      aux_sym_subscript_argument_list_repeat1,
  [253624] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11076), 1,
      anon_sym_LPAREN2,
    ACTIONS(11320), 1,
      anon_sym_constexpr,
    STATE(169), 1,
      sym_condition_clause,
  [253637] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11322), 1,
      anon_sym_catch,
    STATE(223), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [253648] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11324), 1,
      anon_sym_GT2,
    STATE(7014), 1,
      aux_sym_template_argument_list_repeat1,
  [253661] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11178), 1,
      anon_sym_COMMA,
    ACTIONS(11326), 1,
      anon_sym_RPAREN,
    STATE(7143), 1,
      aux_sym_parameter_list_repeat1,
  [253674] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11112), 1,
      anon_sym_COLON,
    ACTIONS(11328), 1,
      anon_sym_RPAREN,
    STATE(7133), 1,
      sym_gnu_asm_output_operand_list,
  [253687] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11126), 1,
      anon_sym_COLON,
    ACTIONS(11330), 1,
      anon_sym_RPAREN,
    STATE(7985), 1,
      sym_gnu_asm_goto_list,
  [253700] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9022), 1,
      anon_sym_COMMA,
    ACTIONS(11332), 1,
      anon_sym_SEMI,
    STATE(7120), 1,
      aux_sym_declaration_repeat1,
  [253713] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9022), 1,
      anon_sym_COMMA,
    ACTIONS(11334), 1,
      anon_sym_SEMI,
    STATE(7001), 1,
      aux_sym_declaration_repeat1,
  [253726] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11057), 1,
      anon_sym_COLON,
    ACTIONS(11336), 1,
      anon_sym_RPAREN,
    STATE(7011), 1,
      sym_gnu_asm_clobber_list,
  [253739] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9022), 1,
      anon_sym_COMMA,
    ACTIONS(11338), 1,
      anon_sym_SEMI,
    STATE(7120), 1,
      aux_sym_declaration_repeat1,
  [253752] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11340), 1,
      anon_sym_COMMA,
    ACTIONS(11343), 1,
      anon_sym_RPAREN,
    STATE(7005), 1,
      aux_sym_preproc_params_repeat1,
  [253765] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11345), 1,
      anon_sym_GT2,
    STATE(6941), 1,
      aux_sym_template_argument_list_repeat1,
  [253778] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11347), 1,
      anon_sym_GT2,
    STATE(7217), 1,
      aux_sym_template_argument_list_repeat1,
  [253791] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11112), 1,
      anon_sym_COLON,
    ACTIONS(11349), 1,
      anon_sym_RPAREN,
    STATE(6950), 1,
      sym_gnu_asm_output_operand_list,
  [253804] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4629), 1,
      anon_sym_LBRACE,
    ACTIONS(10561), 1,
      anon_sym_COLON_COLON,
    STATE(366), 1,
      sym_declaration_list,
  [253817] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9022), 1,
      anon_sym_COMMA,
    ACTIONS(11351), 1,
      anon_sym_SEMI,
    STATE(7120), 1,
      aux_sym_declaration_repeat1,
  [253830] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11126), 1,
      anon_sym_COLON,
    ACTIONS(11353), 1,
      anon_sym_RPAREN,
    STATE(7706), 1,
      sym_gnu_asm_goto_list,
  [253843] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11355), 1,
      anon_sym_GT2,
    STATE(7217), 1,
      aux_sym_template_argument_list_repeat1,
  [253856] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11357), 1,
      anon_sym_GT2,
    STATE(7217), 1,
      aux_sym_template_argument_list_repeat1,
  [253869] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11359), 1,
      anon_sym_GT2,
    STATE(7217), 1,
      aux_sym_template_argument_list_repeat1,
  [253882] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7735), 1,
      anon_sym_COMMA,
    ACTIONS(11361), 1,
      anon_sym_RPAREN,
    STATE(7256), 1,
      aux_sym_generic_expression_repeat1,
  [253895] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7729), 1,
      anon_sym_COMMA,
    ACTIONS(7897), 1,
      anon_sym_RPAREN,
    STATE(7141), 1,
      aux_sym_argument_list_repeat1,
  [253908] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11148), 1,
      anon_sym_COMMA,
    ACTIONS(11363), 1,
      anon_sym_GT2,
    STATE(6944), 1,
      aux_sym_template_parameter_list_repeat1,
  [253921] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9022), 1,
      anon_sym_COMMA,
    ACTIONS(11365), 1,
      anon_sym_SEMI,
    STATE(7120), 1,
      aux_sym_declaration_repeat1,
  [253934] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11367), 1,
      anon_sym_default,
    ACTIONS(11369), 1,
      anon_sym_delete,
    ACTIONS(11371), 1,
      anon_sym_0,
  [253947] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11178), 1,
      anon_sym_COMMA,
    ACTIONS(11373), 1,
      anon_sym_RPAREN,
    STATE(6998), 1,
      aux_sym_parameter_list_repeat1,
  [253960] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11375), 1,
      anon_sym_GT2,
    STATE(6940), 1,
      aux_sym_template_argument_list_repeat1,
  [253973] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11377), 1,
      anon_sym_GT2,
    STATE(7217), 1,
      aux_sym_template_argument_list_repeat1,
  [253986] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7727), 1,
      anon_sym_RBRACE,
    ACTIONS(7875), 1,
      anon_sym_COMMA,
    STATE(6889), 1,
      aux_sym_initializer_list_repeat1,
  [253999] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7859), 1,
      anon_sym_COMMA,
    ACTIONS(11379), 1,
      anon_sym_RBRACK,
    STATE(7072), 1,
      aux_sym_subscript_argument_list_repeat1,
  [254012] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11381), 1,
      anon_sym_COMMA,
    ACTIONS(11384), 1,
      anon_sym_RPAREN,
    STATE(7025), 1,
      aux_sym_throw_specifier_repeat1,
  [254025] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11070), 1,
      anon_sym_COLON,
    ACTIONS(11386), 1,
      anon_sym_RPAREN,
    STATE(7054), 1,
      sym_gnu_asm_input_operand_list,
  [254038] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11388), 1,
      anon_sym_catch,
    STATE(761), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [254049] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11390), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11392), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [254060] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4635), 1,
      anon_sym_LBRACE,
    ACTIONS(10561), 1,
      anon_sym_COLON_COLON,
    STATE(823), 1,
      sym_declaration_list,
  [254073] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11394), 1,
      anon_sym_GT2,
    STATE(7217), 1,
      aux_sym_template_argument_list_repeat1,
  [254086] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7729), 1,
      anon_sym_COMMA,
    ACTIONS(7899), 1,
      anon_sym_RPAREN,
    STATE(6955), 1,
      aux_sym_argument_list_repeat1,
  [254099] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11396), 1,
      anon_sym_GT2,
    STATE(7217), 1,
      aux_sym_template_argument_list_repeat1,
  [254112] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11398), 1,
      anon_sym_GT2,
    STATE(7217), 1,
      aux_sym_template_argument_list_repeat1,
  [254125] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11400), 1,
      sym_identifier,
    ACTIONS(11402), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [254136] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11084), 1,
      anon_sym_COMMA,
    ACTIONS(11404), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7074), 1,
      aux_sym_attribute_declaration_repeat1,
  [254149] = 4,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(11134), 1,
      anon_sym_LPAREN2,
    ACTIONS(11406), 1,
      aux_sym_preproc_include_token2,
    STATE(8016), 1,
      sym_preproc_argument_list,
  [254162] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11408), 1,
      anon_sym_GT2,
    STATE(7217), 1,
      aux_sym_template_argument_list_repeat1,
  [254175] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11112), 1,
      anon_sym_COLON,
    ACTIONS(11410), 1,
      anon_sym_RPAREN,
    STATE(6932), 1,
      sym_gnu_asm_output_operand_list,
  [254188] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11412), 1,
      anon_sym_COMMA,
    ACTIONS(11414), 1,
      anon_sym_LBRACE,
    STATE(7086), 1,
      aux_sym_field_initializer_list_repeat1,
  [254201] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7931), 1,
      anon_sym_COMMA,
    ACTIONS(7933), 1,
      anon_sym_RBRACE,
    STATE(6926), 1,
      aux_sym_initializer_list_repeat1,
  [254214] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11322), 1,
      anon_sym_catch,
    STATE(222), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [254225] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10725), 1,
      anon_sym_COMMA,
    ACTIONS(10727), 1,
      anon_sym_LBRACE,
    STATE(7044), 1,
      aux_sym_base_class_clause_repeat1,
  [254238] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11416), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11418), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [254249] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11418), 1,
      anon_sym_LBRACE,
    ACTIONS(11420), 1,
      anon_sym_COMMA,
    STATE(7044), 1,
      aux_sym_base_class_clause_repeat1,
  [254262] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11112), 1,
      anon_sym_COLON,
    ACTIONS(11423), 1,
      anon_sym_RPAREN,
    STATE(6865), 1,
      sym_gnu_asm_output_operand_list,
  [254275] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8047), 1,
      anon_sym_RBRACK,
    ACTIONS(11425), 1,
      anon_sym_COMMA,
    STATE(7046), 1,
      aux_sym_lambda_capture_specifier_repeat1,
  [254288] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11428), 1,
      sym_identifier,
    STATE(2433), 1,
      sym_template_type,
    STATE(6118), 1,
      sym_template_function,
  [254301] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11126), 1,
      anon_sym_COLON,
    ACTIONS(11430), 1,
      anon_sym_RPAREN,
    STATE(7790), 1,
      sym_gnu_asm_goto_list,
  [254314] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11070), 1,
      anon_sym_COLON,
    ACTIONS(11432), 1,
      anon_sym_RPAREN,
    STATE(6861), 1,
      sym_gnu_asm_input_operand_list,
  [254327] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10725), 1,
      anon_sym_COMMA,
    ACTIONS(10727), 1,
      anon_sym_LBRACE,
    STATE(6907), 1,
      aux_sym_base_class_clause_repeat1,
  [254340] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9022), 1,
      anon_sym_COMMA,
    ACTIONS(11434), 1,
      anon_sym_SEMI,
    STATE(6979), 1,
      aux_sym_declaration_repeat1,
  [254353] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11436), 1,
      anon_sym_COMMA,
    ACTIONS(11439), 1,
      anon_sym_RBRACK,
    STATE(7052), 1,
      aux_sym_structured_binding_declarator_repeat1,
  [254366] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11076), 1,
      anon_sym_LPAREN2,
    ACTIONS(11441), 1,
      anon_sym_constexpr,
    STATE(185), 1,
      sym_condition_clause,
  [254379] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11057), 1,
      anon_sym_COLON,
    ACTIONS(11443), 1,
      anon_sym_RPAREN,
    STATE(7091), 1,
      sym_gnu_asm_clobber_list,
  [254392] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3993), 1,
      anon_sym_RBRACE,
    ACTIONS(11445), 1,
      anon_sym_COMMA,
    STATE(7203), 1,
      aux_sym_initializer_list_repeat1,
  [254405] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11447), 1,
      sym_identifier,
    STATE(1896), 1,
      sym_template_type,
    STATE(3527), 1,
      sym_template_function,
  [254418] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7859), 1,
      anon_sym_COMMA,
    ACTIONS(7883), 1,
      anon_sym_RBRACK,
    STATE(6994), 1,
      aux_sym_subscript_argument_list_repeat1,
  [254431] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7729), 1,
      anon_sym_COMMA,
    ACTIONS(7955), 1,
      anon_sym_RPAREN,
    STATE(6862), 1,
      aux_sym_argument_list_repeat1,
  [254444] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11057), 1,
      anon_sym_COLON,
    ACTIONS(11449), 1,
      anon_sym_RPAREN,
    STATE(7000), 1,
      sym_gnu_asm_clobber_list,
  [254457] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11057), 1,
      anon_sym_COLON,
    ACTIONS(11451), 1,
      anon_sym_RPAREN,
    STATE(7048), 1,
      sym_gnu_asm_clobber_list,
  [254470] = 3,
    ACTIONS(9020), 1,
      sym_comment,
    STATE(6616), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(11453), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [254481] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11084), 1,
      anon_sym_COMMA,
    ACTIONS(11455), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7170), 1,
      aux_sym_attribute_declaration_repeat1,
  [254494] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11388), 1,
      anon_sym_catch,
    STATE(356), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [254505] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11412), 1,
      anon_sym_COMMA,
    ACTIONS(11457), 1,
      anon_sym_LBRACE,
    STATE(7039), 1,
      aux_sym_field_initializer_list_repeat1,
  [254518] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7735), 1,
      anon_sym_COMMA,
    ACTIONS(11459), 1,
      anon_sym_RPAREN,
    STATE(7256), 1,
      aux_sym_generic_expression_repeat1,
  [254531] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11084), 1,
      anon_sym_COMMA,
    ACTIONS(11461), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7110), 1,
      aux_sym_attribute_declaration_repeat1,
  [254544] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11126), 1,
      anon_sym_COLON,
    ACTIONS(11463), 1,
      anon_sym_RPAREN,
    STATE(7768), 1,
      sym_gnu_asm_goto_list,
  [254557] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2525), 1,
      anon_sym_while,
    ACTIONS(11194), 1,
      anon_sym_else,
    STATE(473), 1,
      sym_else_clause,
  [254570] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7729), 1,
      anon_sym_COMMA,
    ACTIONS(7905), 1,
      anon_sym_RPAREN,
    STATE(6862), 1,
      aux_sym_argument_list_repeat1,
  [254583] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11465), 1,
      anon_sym_catch,
    STATE(1773), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [254594] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11467), 1,
      anon_sym_GT2,
    STATE(7083), 1,
      aux_sym_template_argument_list_repeat1,
  [254607] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8097), 1,
      anon_sym_RBRACK,
    ACTIONS(11469), 1,
      anon_sym_COMMA,
    STATE(7072), 1,
      aux_sym_subscript_argument_list_repeat1,
  [254620] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11388), 1,
      anon_sym_catch,
    STATE(781), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [254631] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11472), 1,
      anon_sym_COMMA,
    ACTIONS(11475), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7074), 1,
      aux_sym_attribute_declaration_repeat1,
  [254644] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11479), 1,
      anon_sym_RPAREN,
    ACTIONS(11477), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [254655] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11481), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [254664] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7735), 1,
      anon_sym_COMMA,
    ACTIONS(11483), 1,
      anon_sym_RPAREN,
    STATE(7256), 1,
      aux_sym_generic_expression_repeat1,
  [254677] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11485), 1,
      sym_identifier,
    STATE(2433), 1,
      sym_template_type,
    STATE(2582), 1,
      sym_template_function,
  [254690] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11487), 1,
      anon_sym_default,
    ACTIONS(11489), 1,
      anon_sym_delete,
    ACTIONS(11491), 1,
      anon_sym_0,
  [254703] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7859), 1,
      anon_sym_COMMA,
    ACTIONS(7861), 1,
      anon_sym_RBRACK,
    STATE(7024), 1,
      aux_sym_subscript_argument_list_repeat1,
  [254716] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11493), 1,
      anon_sym_GT2,
    STATE(7217), 1,
      aux_sym_template_argument_list_repeat1,
  [254729] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11495), 1,
      anon_sym_GT2,
    STATE(7217), 1,
      aux_sym_template_argument_list_repeat1,
  [254742] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11497), 1,
      anon_sym_GT2,
    STATE(7217), 1,
      aux_sym_template_argument_list_repeat1,
  [254755] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11057), 1,
      anon_sym_COLON,
    ACTIONS(11499), 1,
      anon_sym_RPAREN,
    STATE(7067), 1,
      sym_gnu_asm_clobber_list,
  [254768] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11481), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [254777] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11501), 1,
      anon_sym_COMMA,
    ACTIONS(11504), 1,
      anon_sym_LBRACE,
    STATE(7086), 1,
      aux_sym_field_initializer_list_repeat1,
  [254790] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11126), 1,
      anon_sym_COLON,
    ACTIONS(11506), 1,
      anon_sym_RPAREN,
    STATE(7774), 1,
      sym_gnu_asm_goto_list,
  [254803] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11148), 1,
      anon_sym_COMMA,
    ACTIONS(11508), 1,
      anon_sym_GT2,
    STATE(7171), 1,
      aux_sym_template_parameter_list_repeat1,
  [254816] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11084), 1,
      anon_sym_COMMA,
    ACTIONS(11510), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7035), 1,
      aux_sym_attribute_declaration_repeat1,
  [254829] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11070), 1,
      anon_sym_COLON,
    ACTIONS(11512), 1,
      anon_sym_RPAREN,
    STATE(7084), 1,
      sym_gnu_asm_input_operand_list,
  [254842] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11126), 1,
      anon_sym_COLON,
    ACTIONS(11514), 1,
      anon_sym_RPAREN,
    STATE(7801), 1,
      sym_gnu_asm_goto_list,
  [254855] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11516), 1,
      anon_sym_catch,
    STATE(958), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [254866] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9022), 1,
      anon_sym_COMMA,
    ACTIONS(11518), 1,
      anon_sym_SEMI,
    STATE(7010), 1,
      aux_sym_declaration_repeat1,
  [254879] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11057), 1,
      anon_sym_COLON,
    ACTIONS(11520), 1,
      anon_sym_RPAREN,
    STATE(7087), 1,
      sym_gnu_asm_clobber_list,
  [254892] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7020), 1,
      anon_sym_EQ,
    ACTIONS(7018), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [254903] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4635), 1,
      anon_sym_LBRACE,
    ACTIONS(10561), 1,
      anon_sym_COLON_COLON,
    STATE(896), 1,
      sym_declaration_list,
  [254916] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7735), 1,
      anon_sym_COMMA,
    ACTIONS(11522), 1,
      anon_sym_RPAREN,
    STATE(7256), 1,
      aux_sym_generic_expression_repeat1,
  [254929] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9022), 1,
      anon_sym_COMMA,
    ACTIONS(11524), 1,
      anon_sym_SEMI,
    STATE(7198), 1,
      aux_sym_declaration_repeat1,
  [254942] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7729), 1,
      anon_sym_COMMA,
    ACTIONS(11526), 1,
      anon_sym_RPAREN,
    STATE(6862), 1,
      aux_sym_argument_list_repeat1,
  [254955] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11528), 1,
      sym_identifier,
    STATE(2433), 1,
      sym_template_type,
    STATE(2835), 1,
      sym_template_function,
  [254968] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11530), 1,
      sym_identifier,
    STATE(2433), 1,
      sym_template_type,
    STATE(2835), 1,
      sym_template_function,
  [254981] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11178), 1,
      anon_sym_COMMA,
    ACTIONS(11532), 1,
      anon_sym_RPAREN,
    STATE(7143), 1,
      aux_sym_parameter_list_repeat1,
  [254994] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11190), 1,
      anon_sym_COMMA,
    ACTIONS(11534), 1,
      anon_sym_RPAREN,
    STATE(6924), 1,
      aux_sym_preproc_params_repeat1,
  [255007] = 3,
    ACTIONS(9020), 1,
      sym_comment,
    STATE(6798), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(11536), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [255018] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11096), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11538), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [255029] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11540), 1,
      anon_sym_GT2,
    STATE(7109), 1,
      aux_sym_template_argument_list_repeat1,
  [255042] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11542), 1,
      anon_sym_GT2,
    STATE(7217), 1,
      aux_sym_template_argument_list_repeat1,
  [255055] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11544), 1,
      anon_sym_GT2,
    STATE(7217), 1,
      aux_sym_template_argument_list_repeat1,
  [255068] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11546), 1,
      anon_sym_GT2,
    STATE(7217), 1,
      aux_sym_template_argument_list_repeat1,
  [255081] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11084), 1,
      anon_sym_COMMA,
    ACTIONS(11548), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7074), 1,
      aux_sym_attribute_declaration_repeat1,
  [255094] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9022), 1,
      anon_sym_COMMA,
    ACTIONS(11550), 1,
      anon_sym_SEMI,
    STATE(6899), 1,
      aux_sym_declaration_repeat1,
  [255107] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11100), 1,
      anon_sym_catch,
    STATE(1992), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [255118] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7729), 1,
      anon_sym_COMMA,
    ACTIONS(7873), 1,
      anon_sym_RPAREN,
    STATE(7242), 1,
      aux_sym_argument_list_repeat1,
  [255131] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7865), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [255140] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4633), 1,
      anon_sym_LBRACE,
    ACTIONS(10561), 1,
      anon_sym_COLON_COLON,
    STATE(778), 1,
      sym_declaration_list,
  [255153] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11144), 1,
      anon_sym_COMMA,
    ACTIONS(11552), 1,
      anon_sym_RPAREN,
    STATE(6902), 1,
      aux_sym_throw_specifier_repeat1,
  [255166] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11178), 1,
      anon_sym_COMMA,
    ACTIONS(11554), 1,
      anon_sym_RPAREN,
    STATE(7143), 1,
      aux_sym_parameter_list_repeat1,
  [255179] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11556), 1,
      anon_sym_default,
    ACTIONS(11558), 1,
      anon_sym_delete,
    ACTIONS(11560), 1,
      anon_sym_0,
  [255192] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11160), 1,
      anon_sym_catch,
    STATE(336), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [255203] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11562), 1,
      anon_sym_COMMA,
    ACTIONS(11565), 1,
      anon_sym_SEMI,
    STATE(7120), 1,
      aux_sym_declaration_repeat1,
  [255216] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9022), 1,
      anon_sym_COMMA,
    ACTIONS(11567), 1,
      anon_sym_SEMI,
    STATE(7120), 1,
      aux_sym_declaration_repeat1,
  [255229] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7729), 1,
      anon_sym_COMMA,
    ACTIONS(7911), 1,
      anon_sym_RPAREN,
    STATE(6864), 1,
      aux_sym_argument_list_repeat1,
  [255242] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11569), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [255251] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9022), 1,
      anon_sym_COMMA,
    ACTIONS(11571), 1,
      anon_sym_SEMI,
    STATE(7120), 1,
      aux_sym_declaration_repeat1,
  [255264] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11573), 1,
      sym_identifier,
    STATE(2433), 1,
      sym_template_type,
    STATE(2582), 1,
      sym_template_function,
  [255277] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7869), 1,
      anon_sym_COMMA,
    ACTIONS(7871), 1,
      anon_sym_RBRACE,
    STATE(7224), 1,
      aux_sym_initializer_list_repeat1,
  [255290] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4629), 1,
      anon_sym_LBRACE,
    ACTIONS(10561), 1,
      anon_sym_COLON_COLON,
    STATE(360), 1,
      sym_declaration_list,
  [255303] = 4,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(11134), 1,
      anon_sym_LPAREN2,
    ACTIONS(11575), 1,
      aux_sym_preproc_include_token2,
    STATE(8016), 1,
      sym_preproc_argument_list,
  [255316] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11577), 1,
      anon_sym_GT2,
    STATE(7132), 1,
      aux_sym_template_argument_list_repeat1,
  [255329] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11579), 1,
      anon_sym_GT2,
    STATE(7217), 1,
      aux_sym_template_argument_list_repeat1,
  [255342] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11581), 1,
      anon_sym_GT2,
    STATE(7217), 1,
      aux_sym_template_argument_list_repeat1,
  [255355] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11583), 1,
      anon_sym_GT2,
    STATE(7217), 1,
      aux_sym_template_argument_list_repeat1,
  [255368] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11070), 1,
      anon_sym_COLON,
    ACTIONS(11585), 1,
      anon_sym_RPAREN,
    STATE(7059), 1,
      sym_gnu_asm_input_operand_list,
  [255381] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11084), 1,
      anon_sym_COMMA,
    ACTIONS(11587), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7074), 1,
      aux_sym_attribute_declaration_repeat1,
  [255394] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11112), 1,
      anon_sym_COLON,
    ACTIONS(11589), 1,
      anon_sym_RPAREN,
    STATE(7220), 1,
      sym_gnu_asm_output_operand_list,
  [255407] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11591), 1,
      anon_sym_default,
    ACTIONS(11593), 1,
      anon_sym_delete,
    ACTIONS(11595), 1,
      anon_sym_0,
  [255420] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11597), 1,
      anon_sym_GT2,
    STATE(7206), 1,
      aux_sym_template_argument_list_repeat1,
  [255433] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10725), 1,
      anon_sym_COMMA,
    ACTIONS(11599), 1,
      anon_sym_LBRACE,
    STATE(7044), 1,
      aux_sym_base_class_clause_repeat1,
  [255446] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7735), 1,
      anon_sym_COMMA,
    ACTIONS(11601), 1,
      anon_sym_RPAREN,
    STATE(7256), 1,
      aux_sym_generic_expression_repeat1,
  [255459] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11080), 1,
      anon_sym_COMMA,
    ACTIONS(11603), 1,
      anon_sym_RPAREN,
    STATE(7161), 1,
      aux_sym_requires_parameter_list_repeat1,
  [255472] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7729), 1,
      anon_sym_COMMA,
    ACTIONS(7877), 1,
      anon_sym_RPAREN,
    STATE(6862), 1,
      aux_sym_argument_list_repeat1,
  [255485] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11605), 1,
      sym_identifier,
    STATE(2433), 1,
      sym_template_type,
    STATE(2835), 1,
      sym_template_function,
  [255498] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11607), 1,
      anon_sym_COMMA,
    ACTIONS(11610), 1,
      anon_sym_RPAREN,
    STATE(7143), 1,
      aux_sym_parameter_list_repeat1,
  [255511] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11612), 1,
      sym_identifier,
    STATE(2433), 1,
      sym_template_type,
    STATE(2835), 1,
      sym_template_function,
  [255524] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11614), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [255533] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11616), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [255542] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11618), 1,
      sym_identifier,
    STATE(2733), 1,
      sym_template_type,
    STATE(3551), 1,
      sym_template_function,
  [255555] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11620), 1,
      anon_sym_EQ,
    ACTIONS(10215), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [255566] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11622), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [255575] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9136), 1,
      anon_sym_RPAREN,
    ACTIONS(11624), 1,
      anon_sym_COMMA,
    STATE(7150), 1,
      aux_sym_preproc_argument_list_repeat1,
  [255588] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11627), 1,
      anon_sym_GT2,
    STATE(7154), 1,
      aux_sym_template_argument_list_repeat1,
  [255601] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11629), 1,
      anon_sym_GT2,
    STATE(7217), 1,
      aux_sym_template_argument_list_repeat1,
  [255614] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11631), 1,
      anon_sym_GT2,
    STATE(7217), 1,
      aux_sym_template_argument_list_repeat1,
  [255627] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11633), 1,
      anon_sym_GT2,
    STATE(7217), 1,
      aux_sym_template_argument_list_repeat1,
  [255640] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11635), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [255649] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11637), 1,
      anon_sym_GT2,
    STATE(7217), 1,
      aux_sym_template_argument_list_repeat1,
  [255662] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11639), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11641), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [255673] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11643), 1,
      sym_identifier,
    STATE(2433), 1,
      sym_template_type,
    STATE(2835), 1,
      sym_template_function,
  [255686] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11126), 1,
      anon_sym_COLON,
    ACTIONS(11645), 1,
      anon_sym_RPAREN,
    STATE(8053), 1,
      sym_gnu_asm_goto_list,
  [255699] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11647), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [255708] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11649), 1,
      anon_sym_COMMA,
    ACTIONS(11652), 1,
      anon_sym_RPAREN,
    STATE(7161), 1,
      aux_sym_requires_parameter_list_repeat1,
  [255721] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7749), 3,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
  [255730] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11654), 1,
      anon_sym_GT2,
    STATE(7217), 1,
      aux_sym_template_argument_list_repeat1,
  [255743] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11656), 1,
      anon_sym_GT2,
    STATE(7217), 1,
      aux_sym_template_argument_list_repeat1,
  [255756] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11057), 1,
      anon_sym_COLON,
    ACTIONS(11658), 1,
      anon_sym_RPAREN,
    STATE(7159), 1,
      sym_gnu_asm_clobber_list,
  [255769] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11126), 1,
      anon_sym_COLON,
    ACTIONS(11660), 1,
      anon_sym_RPAREN,
    STATE(8042), 1,
      sym_gnu_asm_goto_list,
  [255782] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11084), 1,
      anon_sym_COMMA,
    ACTIONS(11662), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7134), 1,
      aux_sym_attribute_declaration_repeat1,
  [255795] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11664), 1,
      sym_identifier,
    STATE(2433), 1,
      sym_template_type,
    STATE(2835), 1,
      sym_template_function,
  [255808] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11112), 1,
      anon_sym_COLON,
    ACTIONS(11666), 1,
      anon_sym_RPAREN,
    STATE(7090), 1,
      sym_gnu_asm_output_operand_list,
  [255821] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11084), 1,
      anon_sym_COMMA,
    ACTIONS(11668), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7074), 1,
      aux_sym_attribute_declaration_repeat1,
  [255834] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11670), 1,
      anon_sym_COMMA,
    ACTIONS(11673), 1,
      anon_sym_GT2,
    STATE(7171), 1,
      aux_sym_template_parameter_list_repeat1,
  [255847] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11675), 1,
      anon_sym_GT2,
    STATE(7175), 1,
      aux_sym_template_argument_list_repeat1,
  [255860] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11677), 1,
      anon_sym_GT2,
    STATE(7217), 1,
      aux_sym_template_argument_list_repeat1,
  [255873] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11679), 1,
      anon_sym_GT2,
    STATE(7217), 1,
      aux_sym_template_argument_list_repeat1,
  [255886] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11681), 1,
      anon_sym_GT2,
    STATE(7217), 1,
      aux_sym_template_argument_list_repeat1,
  [255899] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7729), 1,
      anon_sym_COMMA,
    ACTIONS(7917), 1,
      anon_sym_RPAREN,
    STATE(7058), 1,
      aux_sym_argument_list_repeat1,
  [255912] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11070), 1,
      anon_sym_COLON,
    ACTIONS(11683), 1,
      anon_sym_RPAREN,
    STATE(7094), 1,
      sym_gnu_asm_input_operand_list,
  [255925] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4631), 1,
      anon_sym_LBRACE,
    ACTIONS(10561), 1,
      anon_sym_COLON_COLON,
    STATE(784), 1,
      sym_declaration_list,
  [255938] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11070), 1,
      anon_sym_COLON,
    ACTIONS(11685), 1,
      anon_sym_RPAREN,
    STATE(7165), 1,
      sym_gnu_asm_input_operand_list,
  [255951] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11057), 1,
      anon_sym_COLON,
    ACTIONS(11687), 1,
      anon_sym_RPAREN,
    STATE(7166), 1,
      sym_gnu_asm_clobber_list,
  [255964] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9022), 1,
      anon_sym_COMMA,
    ACTIONS(11689), 1,
      anon_sym_SEMI,
    STATE(7191), 1,
      aux_sym_declaration_repeat1,
  [255977] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11691), 1,
      anon_sym_default,
    ACTIONS(11693), 1,
      anon_sym_delete,
    ACTIONS(11695), 1,
      anon_sym_0,
  [255990] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11699), 1,
      anon_sym_RPAREN,
    ACTIONS(11697), 2,
      anon_sym_DOT_DOT_DOT,
      sym_identifier,
  [256001] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11701), 1,
      anon_sym_COMMA,
    ACTIONS(11704), 1,
      anon_sym_RPAREN,
    STATE(7184), 1,
      aux_sym_gnu_asm_goto_list_repeat1,
  [256014] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11706), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [256023] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7729), 1,
      anon_sym_COMMA,
    ACTIONS(11708), 1,
      anon_sym_RPAREN,
    STATE(6862), 1,
      aux_sym_argument_list_repeat1,
  [256036] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11465), 1,
      anon_sym_catch,
    STATE(1774), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [256047] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9022), 1,
      anon_sym_COMMA,
    ACTIONS(11710), 1,
      anon_sym_SEMI,
    STATE(7226), 1,
      aux_sym_declaration_repeat1,
  [256060] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11712), 1,
      sym_identifier,
    STATE(2433), 1,
      sym_template_type,
    STATE(3527), 1,
      sym_template_function,
  [256073] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9022), 1,
      anon_sym_COMMA,
    ACTIONS(11714), 1,
      anon_sym_SEMI,
    STATE(7120), 1,
      aux_sym_declaration_repeat1,
  [256086] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9022), 1,
      anon_sym_COMMA,
    ACTIONS(11716), 1,
      anon_sym_SEMI,
    STATE(7120), 1,
      aux_sym_declaration_repeat1,
  [256099] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11718), 1,
      anon_sym_GT2,
    STATE(7195), 1,
      aux_sym_template_argument_list_repeat1,
  [256112] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11720), 1,
      anon_sym_GT2,
    STATE(7217), 1,
      aux_sym_template_argument_list_repeat1,
  [256125] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11722), 1,
      anon_sym_GT2,
    STATE(7217), 1,
      aux_sym_template_argument_list_repeat1,
  [256138] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11724), 1,
      anon_sym_GT2,
    STATE(7217), 1,
      aux_sym_template_argument_list_repeat1,
  [256151] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11726), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [256160] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7809), 1,
      anon_sym_COMMA,
    ACTIONS(11728), 1,
      anon_sym_RBRACK,
    STATE(7046), 1,
      aux_sym_lambda_capture_specifier_repeat1,
  [256173] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9022), 1,
      anon_sym_COMMA,
    ACTIONS(11730), 1,
      anon_sym_SEMI,
    STATE(7120), 1,
      aux_sym_declaration_repeat1,
  [256186] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11126), 1,
      anon_sym_COLON,
    ACTIONS(11732), 1,
      anon_sym_RPAREN,
    STATE(8259), 1,
      sym_gnu_asm_goto_list,
  [256199] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11734), 1,
      anon_sym_COMMA,
    ACTIONS(11736), 1,
      anon_sym_RPAREN,
    STATE(7184), 1,
      aux_sym_gnu_asm_goto_list_repeat1,
  [256212] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11084), 1,
      anon_sym_COMMA,
    ACTIONS(11738), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(6901), 1,
      aux_sym_attribute_declaration_repeat1,
  [256225] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3997), 1,
      anon_sym_RBRACE,
    ACTIONS(11740), 1,
      anon_sym_COMMA,
    STATE(7203), 1,
      aux_sym_initializer_list_repeat1,
  [256238] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7751), 1,
      anon_sym_RBRACE,
    ACTIONS(11742), 1,
      anon_sym_COMMA,
    STATE(7203), 1,
      aux_sym_initializer_list_repeat1,
  [256251] = 3,
    ACTIONS(9020), 1,
      sym_comment,
    STATE(6737), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(11745), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [256262] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7925), 1,
      anon_sym_COMMA,
    ACTIONS(7927), 1,
      anon_sym_RBRACE,
    STATE(7202), 1,
      aux_sym_initializer_list_repeat1,
  [256275] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11747), 1,
      anon_sym_GT2,
    STATE(7217), 1,
      aux_sym_template_argument_list_repeat1,
  [256288] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11749), 1,
      anon_sym_GT2,
    STATE(7217), 1,
      aux_sym_template_argument_list_repeat1,
  [256301] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11112), 1,
      anon_sym_COLON,
    ACTIONS(11751), 1,
      anon_sym_RPAREN,
    STATE(7177), 1,
      sym_gnu_asm_output_operand_list,
  [256314] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11753), 1,
      sym_identifier,
    STATE(2433), 1,
      sym_template_type,
    STATE(2835), 1,
      sym_template_function,
  [256327] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11755), 1,
      anon_sym_GT2,
    STATE(7156), 1,
      aux_sym_template_argument_list_repeat1,
  [256340] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11757), 1,
      anon_sym_GT2,
    STATE(7217), 1,
      aux_sym_template_argument_list_repeat1,
  [256353] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11759), 1,
      anon_sym_GT2,
    STATE(7215), 1,
      aux_sym_template_argument_list_repeat1,
  [256366] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11761), 1,
      anon_sym_GT2,
    STATE(7217), 1,
      aux_sym_template_argument_list_repeat1,
  [256379] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11763), 1,
      anon_sym_GT2,
    STATE(7217), 1,
      aux_sym_template_argument_list_repeat1,
  [256392] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11765), 1,
      anon_sym_GT2,
    STATE(7217), 1,
      aux_sym_template_argument_list_repeat1,
  [256405] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5301), 1,
      anon_sym_COMMA,
    ACTIONS(11767), 1,
      anon_sym_RBRACK,
    STATE(7052), 1,
      aux_sym_structured_binding_declarator_repeat1,
  [256418] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11769), 1,
      anon_sym_COMMA,
    ACTIONS(11772), 1,
      anon_sym_GT2,
    STATE(7217), 1,
      aux_sym_template_argument_list_repeat1,
  [256431] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11228), 1,
      anon_sym_catch,
    STATE(344), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [256442] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11112), 1,
      anon_sym_COLON,
    ACTIONS(11774), 1,
      anon_sym_RPAREN,
    STATE(7179), 1,
      sym_gnu_asm_output_operand_list,
  [256455] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11070), 1,
      anon_sym_COLON,
    ACTIONS(11776), 1,
      anon_sym_RPAREN,
    STATE(7180), 1,
      sym_gnu_asm_input_operand_list,
  [256468] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11734), 1,
      anon_sym_COMMA,
    ACTIONS(11778), 1,
      anon_sym_RPAREN,
    STATE(7200), 1,
      aux_sym_gnu_asm_goto_list_repeat1,
  [256481] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9022), 1,
      anon_sym_COMMA,
    ACTIONS(11780), 1,
      anon_sym_SEMI,
    STATE(7124), 1,
      aux_sym_declaration_repeat1,
  [256494] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11782), 1,
      anon_sym_default,
    ACTIONS(11784), 1,
      anon_sym_delete,
    ACTIONS(11786), 1,
      anon_sym_0,
  [256507] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3985), 1,
      anon_sym_RBRACE,
    ACTIONS(11788), 1,
      anon_sym_COMMA,
    STATE(7203), 1,
      aux_sym_initializer_list_repeat1,
  [256520] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9022), 1,
      anon_sym_COMMA,
    ACTIONS(11790), 1,
      anon_sym_SEMI,
    STATE(7120), 1,
      aux_sym_declaration_repeat1,
  [256533] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9022), 1,
      anon_sym_COMMA,
    ACTIONS(11792), 1,
      anon_sym_SEMI,
    STATE(7120), 1,
      aux_sym_declaration_repeat1,
  [256546] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11322), 1,
      anon_sym_catch,
    STATE(221), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [256557] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11794), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [256566] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11796), 1,
      sym_identifier,
    STATE(2433), 1,
      sym_template_type,
    STATE(3551), 1,
      sym_template_function,
  [256579] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11178), 1,
      anon_sym_COMMA,
    ACTIONS(11798), 1,
      anon_sym_RPAREN,
    STATE(7117), 1,
      aux_sym_parameter_list_repeat1,
  [256592] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10573), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11800), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [256603] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11802), 1,
      anon_sym_GT2,
    STATE(7235), 1,
      aux_sym_template_argument_list_repeat1,
  [256616] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11804), 1,
      anon_sym_GT2,
    STATE(7217), 1,
      aux_sym_template_argument_list_repeat1,
  [256629] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11806), 1,
      anon_sym_GT2,
    STATE(7217), 1,
      aux_sym_template_argument_list_repeat1,
  [256642] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_COMMA,
    ACTIONS(11808), 1,
      anon_sym_GT2,
    STATE(7217), 1,
      aux_sym_template_argument_list_repeat1,
  [256655] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11810), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [256664] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4631), 1,
      anon_sym_LBRACE,
    ACTIONS(10561), 1,
      anon_sym_COLON_COLON,
    STATE(710), 1,
      sym_declaration_list,
  [256677] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7729), 1,
      anon_sym_COMMA,
    ACTIONS(7739), 1,
      anon_sym_RPAREN,
    STATE(7069), 1,
      aux_sym_argument_list_repeat1,
  [256690] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11465), 1,
      anon_sym_catch,
    STATE(1776), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [256701] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11084), 1,
      anon_sym_COMMA,
    ACTIONS(11812), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7074), 1,
      aux_sym_attribute_declaration_repeat1,
  [256714] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11814), 1,
      sym_identifier,
    STATE(2433), 1,
      sym_template_type,
    STATE(2582), 1,
      sym_template_function,
  [256727] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7729), 1,
      anon_sym_COMMA,
    ACTIONS(7733), 1,
      anon_sym_RPAREN,
    STATE(6862), 1,
      aux_sym_argument_list_repeat1,
  [256740] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11100), 1,
      anon_sym_catch,
    STATE(1991), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [256751] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5301), 1,
      anon_sym_COMMA,
    ACTIONS(11816), 1,
      anon_sym_RBRACK,
    STATE(7216), 1,
      aux_sym_structured_binding_declarator_repeat1,
  [256764] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11818), 1,
      sym_identifier,
    STATE(2433), 1,
      sym_template_type,
    STATE(2835), 1,
      sym_template_function,
  [256777] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9022), 1,
      anon_sym_COMMA,
    ACTIONS(11820), 1,
      anon_sym_SEMI,
    STATE(6954), 1,
      aux_sym_declaration_repeat1,
  [256790] = 3,
    ACTIONS(9020), 1,
      sym_comment,
    STATE(6694), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(11822), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [256801] = 3,
    ACTIONS(9020), 1,
      sym_comment,
    STATE(6717), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(11824), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [256812] = 3,
    ACTIONS(9020), 1,
      sym_comment,
    STATE(6751), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(11826), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [256823] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11057), 1,
      anon_sym_COLON,
    ACTIONS(11828), 1,
      anon_sym_RPAREN,
    STATE(7199), 1,
      sym_gnu_asm_clobber_list,
  [256836] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11076), 1,
      anon_sym_LPAREN2,
    ACTIONS(11830), 1,
      anon_sym_constexpr,
    STATE(174), 1,
      sym_condition_clause,
  [256849] = 3,
    ACTIONS(9020), 1,
      sym_comment,
    STATE(6796), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(11832), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [256860] = 3,
    ACTIONS(9020), 1,
      sym_comment,
    STATE(6793), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(11834), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [256871] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11836), 1,
      sym_identifier,
    STATE(1896), 1,
      sym_template_type,
    STATE(3338), 1,
      sym_template_function,
  [256884] = 3,
    ACTIONS(9020), 1,
      sym_comment,
    STATE(6854), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(11838), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [256895] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11840), 1,
      anon_sym_COMMA,
    ACTIONS(11843), 1,
      anon_sym_RPAREN,
    STATE(7256), 1,
      aux_sym_generic_expression_repeat1,
  [256908] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6907), 1,
      anon_sym_LT,
    STATE(2843), 1,
      sym_template_argument_list,
  [256918] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7307), 1,
      anon_sym_LPAREN2,
    STATE(8258), 1,
      sym_argument_list,
  [256928] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11845), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [256936] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8718), 1,
      anon_sym_LBRACE,
    STATE(3467), 1,
      sym_requirement_seq,
  [256946] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11076), 1,
      anon_sym_LPAREN2,
    STATE(7305), 1,
      sym_condition_clause,
  [256956] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7307), 1,
      anon_sym_LPAREN2,
    STATE(8118), 1,
      sym_argument_list,
  [256966] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11076), 1,
      anon_sym_LPAREN2,
    STATE(150), 1,
      sym_condition_clause,
  [256976] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    STATE(7524), 1,
      sym_parameter_list,
  [256986] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9613), 1,
      anon_sym_LBRACE,
    STATE(1793), 1,
      sym_compound_statement,
  [256996] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11847), 1,
      sym_identifier,
    STATE(7167), 1,
      sym_attribute,
  [257006] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7307), 1,
      anon_sym_LPAREN2,
    STATE(8382), 1,
      sym_argument_list,
  [257016] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(6882), 1,
      sym_compound_statement,
  [257026] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(7218), 1,
      sym_compound_statement,
  [257036] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4908), 1,
      anon_sym_LBRACE,
    STATE(2302), 1,
      sym_field_declaration_list,
  [257046] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9699), 1,
      anon_sym_LBRACE,
    STATE(2050), 1,
      sym_compound_statement,
  [257056] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11847), 1,
      sym_identifier,
    STATE(6872), 1,
      sym_attribute,
  [257066] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11849), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [257074] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11847), 1,
      sym_identifier,
    STATE(7391), 1,
      sym_attribute,
  [257084] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(617), 1,
      anon_sym_LBRACE,
    STATE(807), 1,
      sym_compound_statement,
  [257094] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11851), 1,
      anon_sym_LT,
    STATE(2719), 1,
      sym_template_argument_list,
  [257104] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1633), 1,
      anon_sym_LBRACE,
    STATE(1019), 1,
      sym_compound_statement,
  [257114] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(6922), 1,
      sym_compound_statement,
  [257124] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11853), 1,
      sym_identifier,
    STATE(2433), 1,
      sym_template_type,
  [257134] = 3,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(11855), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(11857), 1,
      sym_preproc_arg,
  [257144] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11859), 1,
      anon_sym_COMMA,
    ACTIONS(11861), 1,
      anon_sym_RBRACE,
  [257154] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_LBRACE,
    STATE(314), 1,
      sym_compound_statement,
  [257164] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    STATE(7518), 1,
      sym_parameter_list,
  [257174] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11851), 1,
      anon_sym_LT,
    STATE(3607), 1,
      sym_template_argument_list,
  [257184] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(6607), 1,
      sym_compound_statement,
  [257194] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7307), 1,
      anon_sym_LPAREN2,
    STATE(7831), 1,
      sym_argument_list,
  [257204] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(816), 1,
      sym_compound_statement,
  [257214] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4633), 1,
      anon_sym_LBRACE,
    STATE(804), 1,
      sym_declaration_list,
  [257224] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4631), 1,
      anon_sym_LBRACE,
    STATE(708), 1,
      sym_declaration_list,
  [257234] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(6707), 1,
      sym_compound_statement,
  [257244] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11863), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [257252] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11859), 1,
      anon_sym_COMMA,
    ACTIONS(11865), 1,
      anon_sym_RBRACE,
  [257262] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6138), 1,
      anon_sym_LBRACE,
    STATE(3186), 1,
      sym_field_declaration_list,
  [257272] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8316), 1,
      anon_sym_LT,
    STATE(1741), 1,
      sym_template_argument_list,
  [257282] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6103), 1,
      anon_sym_LT,
    STATE(1741), 1,
      sym_template_argument_list,
  [257292] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11076), 1,
      anon_sym_LPAREN2,
    STATE(163), 1,
      sym_condition_clause,
  [257302] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4908), 1,
      anon_sym_LBRACE,
    STATE(2296), 1,
      sym_field_declaration_list,
  [257312] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7307), 1,
      anon_sym_LPAREN2,
    STATE(8141), 1,
      sym_argument_list,
  [257322] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7965), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [257330] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(7070), 1,
      sym_compound_statement,
  [257340] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11867), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [257348] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11847), 1,
      sym_identifier,
    STATE(7089), 1,
      sym_attribute,
  [257358] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1633), 1,
      anon_sym_LBRACE,
    STATE(965), 1,
      sym_compound_statement,
  [257368] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11869), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [257376] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(617), 1,
      anon_sym_LBRACE,
    STATE(519), 1,
      sym_compound_statement,
  [257386] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11076), 1,
      anon_sym_LPAREN2,
    STATE(145), 1,
      sym_condition_clause,
  [257396] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5575), 1,
      anon_sym_LBRACE,
    STATE(2533), 1,
      sym_field_declaration_list,
  [257406] = 3,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(11871), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(11873), 1,
      sym_preproc_arg,
  [257416] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11875), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [257424] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4908), 1,
      anon_sym_LBRACE,
    STATE(2308), 1,
      sym_field_declaration_list,
  [257434] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1633), 1,
      anon_sym_LBRACE,
    STATE(997), 1,
      sym_compound_statement,
  [257444] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9798), 1,
      anon_sym_RBRACE,
    ACTIONS(11859), 1,
      anon_sym_COMMA,
  [257454] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4631), 1,
      anon_sym_LBRACE,
    STATE(765), 1,
      sym_declaration_list,
  [257464] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11673), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [257472] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11877), 1,
      anon_sym_LT,
    STATE(2030), 1,
      sym_template_argument_list,
  [257482] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11879), 1,
      anon_sym_LPAREN2,
    STATE(7311), 1,
      sym_parenthesized_expression,
  [257492] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8316), 1,
      anon_sym_LT,
    STATE(2030), 1,
      sym_template_argument_list,
  [257502] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11652), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [257510] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(7187), 1,
      sym_compound_statement,
  [257520] = 3,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(11881), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(11883), 1,
      sym_preproc_arg,
  [257530] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11885), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [257538] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4635), 1,
      anon_sym_LBRACE,
    STATE(900), 1,
      sym_declaration_list,
  [257548] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(675), 1,
      anon_sym_LBRACE,
    STATE(433), 1,
      sym_compound_statement,
  [257558] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9514), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [257566] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9699), 1,
      anon_sym_LBRACE,
    STATE(2036), 1,
      sym_compound_statement,
  [257576] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11610), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [257584] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8029), 1,
      anon_sym_LT,
    STATE(4681), 1,
      sym_template_argument_list,
  [257594] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8758), 1,
      anon_sym_LBRACE,
    STATE(4319), 1,
      sym_requirement_seq,
  [257604] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    STATE(7303), 1,
      sym_parameter_list,
  [257614] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10561), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11887), 1,
      anon_sym_SEMI,
  [257624] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11889), 1,
      sym_identifier,
    STATE(1896), 1,
      sym_template_type,
  [257634] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9812), 1,
      anon_sym_RBRACE,
    ACTIONS(11859), 1,
      anon_sym_COMMA,
  [257644] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(554), 1,
      sym_compound_statement,
  [257654] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4631), 1,
      anon_sym_LBRACE,
    STATE(757), 1,
      sym_declaration_list,
  [257664] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11053), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [257672] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7751), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [257680] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11891), 1,
      sym_identifier,
    ACTIONS(11893), 1,
      anon_sym_LPAREN2,
  [257690] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7855), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [257698] = 3,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(11895), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(11897), 1,
      sym_preproc_arg,
  [257708] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6138), 1,
      anon_sym_LBRACE,
    STATE(3170), 1,
      sym_field_declaration_list,
  [257718] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4629), 1,
      anon_sym_LBRACE,
    STATE(361), 1,
      sym_declaration_list,
  [257728] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6138), 1,
      anon_sym_LBRACE,
    STATE(3166), 1,
      sym_field_declaration_list,
  [257738] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(817), 1,
      sym_compound_statement,
  [257748] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_LBRACE,
    STATE(265), 1,
      sym_compound_statement,
  [257758] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7307), 1,
      anon_sym_LPAREN2,
    STATE(7816), 1,
      sym_argument_list,
  [257768] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9781), 1,
      anon_sym_RBRACE,
    ACTIONS(11859), 1,
      anon_sym_COMMA,
  [257778] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11879), 1,
      anon_sym_LPAREN2,
    STATE(7657), 1,
      sym_parenthesized_expression,
  [257788] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7744), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [257796] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(6734), 1,
      sym_compound_statement,
  [257806] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11859), 1,
      anon_sym_COMMA,
    ACTIONS(11899), 1,
      anon_sym_RBRACE,
  [257816] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11076), 1,
      anon_sym_LPAREN2,
    STATE(140), 1,
      sym_condition_clause,
  [257826] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5811), 1,
      anon_sym_LBRACE,
    STATE(2841), 1,
      sym_field_declaration_list,
  [257836] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    STATE(7510), 1,
      sym_parameter_list,
  [257846] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(7092), 1,
      sym_compound_statement,
  [257856] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4629), 1,
      anon_sym_LBRACE,
    STATE(327), 1,
      sym_declaration_list,
  [257866] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11538), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [257874] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1967), 1,
      anon_sym_LBRACE,
    STATE(3363), 1,
      sym_initializer_list,
  [257884] = 3,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(11901), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(11903), 1,
      sym_preproc_arg,
  [257894] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11847), 1,
      sym_identifier,
    STATE(7066), 1,
      sym_attribute,
  [257904] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8734), 1,
      anon_sym_LBRACE,
    STATE(3479), 1,
      sym_requirement_seq,
  [257914] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11905), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [257922] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11851), 1,
      anon_sym_LT,
    STATE(3523), 1,
      sym_template_argument_list,
  [257932] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11907), 1,
      anon_sym_LT,
    STATE(2017), 1,
      sym_template_argument_list,
  [257942] = 3,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(11909), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(11911), 1,
      sym_preproc_arg,
  [257952] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4633), 1,
      anon_sym_LBRACE,
    STATE(773), 1,
      sym_declaration_list,
  [257962] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9796), 1,
      anon_sym_RBRACE,
    ACTIONS(11859), 1,
      anon_sym_COMMA,
  [257972] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8316), 1,
      anon_sym_LT,
    STATE(2736), 1,
      sym_template_argument_list,
  [257982] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(6963), 1,
      sym_compound_statement,
  [257992] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11879), 1,
      anon_sym_LPAREN2,
    STATE(7470), 1,
      sym_parenthesized_expression,
  [258002] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(6982), 1,
      sym_compound_statement,
  [258012] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5811), 1,
      anon_sym_LBRACE,
    STATE(2861), 1,
      sym_field_declaration_list,
  [258022] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_LBRACE,
    STATE(304), 1,
      sym_compound_statement,
  [258032] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9613), 1,
      anon_sym_LBRACE,
    STATE(1808), 1,
      sym_compound_statement,
  [258042] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(675), 1,
      anon_sym_LBRACE,
    STATE(499), 1,
      sym_compound_statement,
  [258052] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11913), 1,
      sym_identifier,
    STATE(2849), 1,
      sym_template_type,
  [258062] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11504), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [258070] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8750), 1,
      anon_sym_LBRACE,
    STATE(3619), 1,
      sym_requirement_seq,
  [258080] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5575), 1,
      anon_sym_LBRACE,
    STATE(5043), 1,
      sym_field_declaration_list,
  [258090] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8726), 1,
      anon_sym_LBRACE,
    STATE(2571), 1,
      sym_requirement_seq,
  [258100] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    STATE(7482), 1,
      sym_parameter_list,
  [258110] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4908), 1,
      anon_sym_LBRACE,
    STATE(2266), 1,
      sym_field_declaration_list,
  [258120] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5575), 1,
      anon_sym_LBRACE,
    STATE(5053), 1,
      sym_field_declaration_list,
  [258130] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11915), 1,
      sym_identifier,
    STATE(3777), 1,
      sym_template_type,
  [258140] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11879), 1,
      anon_sym_LPAREN2,
    STATE(7677), 1,
      sym_parenthesized_expression,
  [258150] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_LBRACE,
    STATE(403), 1,
      sym_compound_statement,
  [258160] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5575), 1,
      anon_sym_LBRACE,
    STATE(5055), 1,
      sym_field_declaration_list,
  [258170] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10561), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11917), 1,
      anon_sym_SEMI,
  [258180] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11879), 1,
      anon_sym_LPAREN2,
    STATE(7469), 1,
      sym_parenthesized_expression,
  [258190] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(432), 1,
      sym_compound_statement,
  [258200] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    STATE(3087), 1,
      sym_field_declaration_list,
  [258210] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11475), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [258218] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6138), 1,
      anon_sym_LBRACE,
    STATE(3118), 1,
      sym_field_declaration_list,
  [258228] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5575), 1,
      anon_sym_LBRACE,
    STATE(5006), 1,
      sym_field_declaration_list,
  [258238] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6905), 1,
      anon_sym_LBRACE,
    STATE(3969), 1,
      sym_field_declaration_list,
  [258248] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5575), 1,
      anon_sym_LBRACE,
    STATE(2528), 1,
      sym_field_declaration_list,
  [258258] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11919), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [258266] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    STATE(3084), 1,
      sym_field_declaration_list,
  [258276] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11859), 1,
      anon_sym_COMMA,
    ACTIONS(11921), 1,
      anon_sym_RBRACE,
  [258286] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5575), 1,
      anon_sym_LBRACE,
    STATE(2530), 1,
      sym_field_declaration_list,
  [258296] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(7027), 1,
      sym_compound_statement,
  [258306] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4635), 1,
      anon_sym_LBRACE,
    STATE(852), 1,
      sym_declaration_list,
  [258316] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6103), 1,
      anon_sym_LT,
    STATE(2471), 1,
      sym_template_argument_list,
  [258326] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(6699), 1,
      sym_compound_statement,
  [258336] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7307), 1,
      anon_sym_LPAREN2,
    STATE(7614), 1,
      sym_argument_list,
  [258346] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_LBRACE,
    STATE(350), 1,
      sym_compound_statement,
  [258356] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11076), 1,
      anon_sym_LPAREN2,
    STATE(182), 1,
      sym_condition_clause,
  [258366] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6905), 1,
      anon_sym_LBRACE,
    STATE(3976), 1,
      sym_field_declaration_list,
  [258376] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6905), 1,
      anon_sym_LBRACE,
    STATE(3984), 1,
      sym_field_declaration_list,
  [258386] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(6881), 1,
      sym_compound_statement,
  [258396] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11923), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [258404] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11879), 1,
      anon_sym_LPAREN2,
    STATE(7582), 1,
      sym_parenthesized_expression,
  [258414] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9828), 1,
      anon_sym_RBRACE,
    ACTIONS(11859), 1,
      anon_sym_COMMA,
  [258424] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11076), 1,
      anon_sym_LPAREN2,
    STATE(7535), 1,
      sym_condition_clause,
  [258434] = 3,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(11925), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(11927), 1,
      sym_preproc_arg,
  [258444] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11847), 1,
      sym_identifier,
    STATE(6931), 1,
      sym_attribute,
  [258454] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(617), 1,
      anon_sym_LBRACE,
    STATE(543), 1,
      sym_compound_statement,
  [258464] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11439), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [258472] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5902), 1,
      anon_sym_LT,
    STATE(2626), 1,
      sym_template_argument_list,
  [258482] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10571), 1,
      anon_sym_LBRACE,
    STATE(1746), 1,
      sym_requirement_seq,
  [258492] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9711), 1,
      anon_sym_LBRACE,
    STATE(2032), 1,
      sym_compound_statement,
  [258502] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6905), 1,
      anon_sym_LBRACE,
    STATE(3986), 1,
      sym_field_declaration_list,
  [258512] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7849), 1,
      anon_sym_RPAREN,
    ACTIONS(7851), 1,
      anon_sym_SEMI,
  [258522] = 3,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(11929), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(11931), 1,
      sym_preproc_arg,
  [258532] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11933), 1,
      anon_sym_LT,
    STATE(2688), 1,
      sym_template_argument_list,
  [258542] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11935), 1,
      sym_identifier,
    STATE(2018), 1,
      sym_template_type,
  [258552] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4635), 1,
      anon_sym_LBRACE,
    STATE(875), 1,
      sym_declaration_list,
  [258562] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11879), 1,
      anon_sym_LPAREN2,
    STATE(7372), 1,
      sym_parenthesized_expression,
  [258572] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11879), 1,
      anon_sym_LPAREN2,
    STATE(8401), 1,
      sym_parenthesized_expression,
  [258582] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11937), 1,
      sym_identifier,
    STATE(2284), 1,
      sym_template_type,
  [258592] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(7112), 1,
      sym_compound_statement,
  [258602] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11933), 1,
      anon_sym_LT,
    STATE(3436), 1,
      sym_template_argument_list,
  [258612] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(570), 1,
      sym_compound_statement,
  [258622] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11076), 1,
      anon_sym_LPAREN2,
    STATE(186), 1,
      sym_condition_clause,
  [258632] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2236), 1,
      anon_sym_LBRACE,
    STATE(3578), 1,
      sym_initializer_list,
  [258642] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11939), 1,
      sym_identifier,
    STATE(4714), 1,
      sym_template_type,
  [258652] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    STATE(7323), 1,
      sym_parameter_list,
  [258662] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6103), 1,
      anon_sym_LT,
    STATE(2843), 1,
      sym_template_argument_list,
  [258672] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8157), 1,
      anon_sym_LBRACE,
    STATE(4783), 1,
      sym_field_declaration_list,
  [258682] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11879), 1,
      anon_sym_LPAREN2,
    STATE(7867), 1,
      sym_parenthesized_expression,
  [258692] = 3,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(11941), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(11943), 1,
      sym_preproc_arg,
  [258702] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11859), 1,
      anon_sym_COMMA,
    ACTIONS(11945), 1,
      anon_sym_RBRACE,
  [258712] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3460), 1,
      anon_sym_LBRACE,
    STATE(4703), 1,
      sym_initializer_list,
  [258722] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11907), 1,
      anon_sym_LT,
    STATE(2415), 1,
      sym_template_argument_list,
  [258732] = 3,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(11947), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(11949), 1,
      sym_preproc_arg,
  [258742] = 3,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(11951), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(11953), 1,
      sym_preproc_arg,
  [258752] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11384), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [258760] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8157), 1,
      anon_sym_LBRACE,
    STATE(4785), 1,
      sym_field_declaration_list,
  [258770] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_LBRACE,
    STATE(229), 1,
      sym_compound_statement,
  [258780] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    STATE(3106), 1,
      sym_field_declaration_list,
  [258790] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8157), 1,
      anon_sym_LBRACE,
    STATE(4781), 1,
      sym_field_declaration_list,
  [258800] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11076), 1,
      anon_sym_LPAREN2,
    STATE(191), 1,
      sym_condition_clause,
  [258810] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10561), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11955), 1,
      anon_sym_SEMI,
  [258820] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(6814), 1,
      sym_compound_statement,
  [258830] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7307), 1,
      anon_sym_LPAREN2,
    STATE(8029), 1,
      sym_argument_list,
  [258840] = 3,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(11957), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(11959), 1,
      sym_preproc_arg,
  [258850] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11343), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [258858] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8332), 1,
      anon_sym_LBRACE,
    STATE(4933), 1,
      sym_field_declaration_list,
  [258868] = 3,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(11961), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(11963), 1,
      sym_preproc_arg,
  [258878] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11965), 1,
      sym_identifier,
    STATE(2433), 1,
      sym_template_type,
  [258888] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11859), 1,
      anon_sym_COMMA,
    ACTIONS(11967), 1,
      anon_sym_RBRACE,
  [258898] = 3,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(11969), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(11971), 1,
      sym_preproc_arg,
  [258908] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7887), 1,
      anon_sym_RBRACK,
    ACTIONS(11973), 1,
      anon_sym_COMMA,
  [258918] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [258926] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2473), 1,
      anon_sym_LBRACE,
    STATE(3841), 1,
      sym_initializer_list,
  [258936] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8332), 1,
      anon_sym_LBRACE,
    STATE(4905), 1,
      sym_field_declaration_list,
  [258946] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8332), 1,
      anon_sym_LBRACE,
    STATE(4937), 1,
      sym_field_declaration_list,
  [258956] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11975), 1,
      sym_identifier,
    STATE(2698), 1,
      sym_template_type,
  [258966] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(7119), 1,
      sym_compound_statement,
  [258976] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(452), 1,
      sym_compound_statement,
  [258986] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(675), 1,
      anon_sym_LBRACE,
    STATE(550), 1,
      sym_compound_statement,
  [258996] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9820), 1,
      anon_sym_RBRACE,
    ACTIONS(11859), 1,
      anon_sym_COMMA,
  [259006] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11076), 1,
      anon_sym_LPAREN2,
    STATE(168), 1,
      sym_condition_clause,
  [259016] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4629), 1,
      anon_sym_LBRACE,
    STATE(362), 1,
      sym_declaration_list,
  [259026] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6103), 1,
      anon_sym_LT,
    STATE(2415), 1,
      sym_template_argument_list,
  [259036] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11977), 1,
      anon_sym_LT,
    STATE(2736), 1,
      sym_template_argument_list,
  [259046] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7307), 1,
      anon_sym_LPAREN2,
    STATE(7909), 1,
      sym_argument_list,
  [259056] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9850), 1,
      anon_sym_RBRACE,
    ACTIONS(11859), 1,
      anon_sym_COMMA,
  [259066] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11979), 1,
      sym_identifier,
    STATE(2733), 1,
      sym_template_type,
  [259076] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10932), 1,
      anon_sym_LBRACE,
    STATE(5791), 1,
      sym_requirement_seq,
  [259086] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11076), 1,
      anon_sym_LPAREN2,
    STATE(180), 1,
      sym_condition_clause,
  [259096] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11076), 1,
      anon_sym_LPAREN2,
    STATE(7374), 1,
      sym_condition_clause,
  [259106] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9699), 1,
      anon_sym_LBRACE,
    STATE(2045), 1,
      sym_compound_statement,
  [259116] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11981), 1,
      anon_sym_LPAREN2,
    ACTIONS(11983), 1,
      sym_raw_string_delimiter,
  [259126] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    STATE(3957), 1,
      sym_field_declaration_list,
  [259136] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(626), 1,
      sym_compound_statement,
  [259146] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    STATE(3921), 1,
      sym_field_declaration_list,
  [259156] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8332), 1,
      anon_sym_LBRACE,
    STATE(4904), 1,
      sym_field_declaration_list,
  [259166] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    STATE(3900), 1,
      sym_field_declaration_list,
  [259176] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    STATE(3935), 1,
      sym_field_declaration_list,
  [259186] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11847), 1,
      sym_identifier,
    STATE(7062), 1,
      sym_attribute,
  [259196] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8097), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [259204] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6907), 1,
      anon_sym_LT,
    STATE(1741), 1,
      sym_template_argument_list,
  [259214] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11985), 2,
      anon_sym_DOT_DOT_DOT,
      sym_identifier,
  [259222] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11933), 1,
      anon_sym_LT,
    STATE(3302), 1,
      sym_template_argument_list,
  [259232] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11987), 1,
      sym_identifier,
    ACTIONS(11989), 1,
      anon_sym_RPAREN,
  [259242] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11186), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [259250] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9711), 1,
      anon_sym_LBRACE,
    STATE(2021), 1,
      sym_compound_statement,
  [259260] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11991), 1,
      sym_identifier,
    STATE(1896), 1,
      sym_template_type,
  [259270] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5928), 1,
      anon_sym_LBRACE,
    STATE(2755), 1,
      sym_field_declaration_list,
  [259280] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10555), 1,
      sym_identifier,
    STATE(2433), 1,
      sym_template_type,
  [259290] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11993), 1,
      sym_identifier,
    ACTIONS(11995), 1,
      anon_sym_LPAREN2,
  [259300] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5890), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [259308] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11997), 1,
      sym_identifier,
    STATE(2735), 1,
      sym_template_type,
  [259318] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11859), 1,
      anon_sym_COMMA,
    ACTIONS(11999), 1,
      anon_sym_RBRACE,
  [259328] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3194), 1,
      anon_sym_LBRACE,
    STATE(3942), 1,
      sym_initializer_list,
  [259338] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(675), 1,
      anon_sym_LBRACE,
    STATE(562), 1,
      sym_compound_statement,
  [259348] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11859), 1,
      anon_sym_COMMA,
    ACTIONS(12001), 1,
      anon_sym_RBRACE,
  [259358] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11907), 1,
      anon_sym_LT,
    STATE(2471), 1,
      sym_template_argument_list,
  [259368] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10561), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12003), 1,
      anon_sym_SEMI,
  [259378] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(617), 1,
      anon_sym_LBRACE,
    STATE(435), 1,
      sym_compound_statement,
  [259388] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8157), 1,
      anon_sym_LBRACE,
    STATE(4778), 1,
      sym_field_declaration_list,
  [259398] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5918), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [259406] = 3,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(12005), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(12007), 1,
      sym_preproc_arg,
  [259416] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5922), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [259424] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(675), 1,
      anon_sym_LBRACE,
    STATE(724), 1,
      sym_compound_statement,
  [259434] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12009), 1,
      anon_sym_LPAREN2,
    ACTIONS(12011), 1,
      sym_raw_string_delimiter,
  [259444] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1893), 1,
      anon_sym_LBRACE,
    STATE(2574), 1,
      sym_initializer_list,
  [259454] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9613), 1,
      anon_sym_LBRACE,
    STATE(1796), 1,
      sym_compound_statement,
  [259464] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11216), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [259472] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(7063), 1,
      sym_compound_statement,
  [259482] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12013), 1,
      anon_sym_LPAREN2,
    ACTIONS(12015), 1,
      sym_raw_string_delimiter,
  [259492] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12017), 1,
      sym_identifier,
    STATE(1896), 1,
      sym_template_type,
  [259502] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11076), 1,
      anon_sym_LPAREN2,
    STATE(139), 1,
      sym_condition_clause,
  [259512] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9711), 1,
      anon_sym_LBRACE,
    STATE(2027), 1,
      sym_compound_statement,
  [259522] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5968), 1,
      anon_sym_LBRACE,
    STATE(2949), 1,
      sym_field_declaration_list,
  [259532] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5238), 1,
      anon_sym_LT,
    STATE(1741), 1,
      sym_template_argument_list,
  [259542] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5928), 1,
      anon_sym_LBRACE,
    STATE(2762), 1,
      sym_field_declaration_list,
  [259552] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12019), 1,
      anon_sym_LPAREN2,
    ACTIONS(12021), 1,
      sym_raw_string_delimiter,
  [259562] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12023), 1,
      anon_sym_LT,
    STATE(2471), 1,
      sym_template_argument_list,
  [259572] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11859), 1,
      anon_sym_COMMA,
    ACTIONS(12025), 1,
      anon_sym_RBRACE,
  [259582] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5575), 1,
      anon_sym_LBRACE,
    STATE(2578), 1,
      sym_field_declaration_list,
  [259592] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11076), 1,
      anon_sym_LPAREN2,
    STATE(7432), 1,
      sym_condition_clause,
  [259602] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5960), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [259610] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12027), 1,
      anon_sym_LPAREN2,
    ACTIONS(12029), 1,
      sym_raw_string_delimiter,
  [259620] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1633), 1,
      anon_sym_LBRACE,
    STATE(1036), 1,
      sym_compound_statement,
  [259630] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11879), 1,
      anon_sym_LPAREN2,
    STATE(7485), 1,
      sym_parenthesized_expression,
  [259640] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(6996), 1,
      sym_compound_statement,
  [259650] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(617), 1,
      anon_sym_LBRACE,
    STATE(732), 1,
      sym_compound_statement,
  [259660] = 3,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(12031), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(12033), 1,
      sym_preproc_arg,
  [259670] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5972), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [259678] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5968), 1,
      anon_sym_LBRACE,
    STATE(2893), 1,
      sym_field_declaration_list,
  [259688] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5968), 1,
      anon_sym_LBRACE,
    STATE(2889), 1,
      sym_field_declaration_list,
  [259698] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12035), 1,
      anon_sym_LPAREN2,
    ACTIONS(12037), 1,
      sym_raw_string_delimiter,
  [259708] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9852), 1,
      anon_sym_RBRACE,
    ACTIONS(11859), 1,
      anon_sym_COMMA,
  [259718] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7307), 1,
      anon_sym_LPAREN2,
    STATE(8218), 1,
      sym_argument_list,
  [259728] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11094), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [259736] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9773), 1,
      anon_sym_RBRACE,
    ACTIONS(11859), 1,
      anon_sym_COMMA,
  [259746] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6042), 1,
      anon_sym_LBRACE,
    STATE(3179), 1,
      sym_field_declaration_list,
  [259756] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11477), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [259764] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11847), 1,
      sym_identifier,
    STATE(6984), 1,
      sym_attribute,
  [259774] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12039), 1,
      anon_sym_LPAREN2,
    ACTIONS(12041), 1,
      sym_raw_string_delimiter,
  [259784] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8372), 1,
      anon_sym_LT,
    STATE(2724), 1,
      sym_template_argument_list,
  [259794] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12043), 1,
      anon_sym_LPAREN2,
    ACTIONS(12045), 1,
      sym_raw_string_delimiter,
  [259804] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7307), 1,
      anon_sym_LPAREN2,
    STATE(7718), 1,
      sym_argument_list,
  [259814] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(6756), 1,
      sym_compound_statement,
  [259824] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11076), 1,
      anon_sym_LPAREN2,
    STATE(137), 1,
      sym_condition_clause,
  [259834] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10872), 1,
      anon_sym_LBRACE,
    STATE(5615), 1,
      sym_requirement_seq,
  [259844] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11859), 1,
      anon_sym_COMMA,
    ACTIONS(12047), 1,
      anon_sym_RBRACE,
  [259854] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4633), 1,
      anon_sym_LBRACE,
    STATE(718), 1,
      sym_declaration_list,
  [259864] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12049), 1,
      anon_sym_LPAREN2,
    ACTIONS(12051), 1,
      sym_raw_string_delimiter,
  [259874] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12053), 1,
      sym_identifier,
    STATE(2696), 1,
      sym_template_type,
  [259884] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5928), 1,
      anon_sym_LBRACE,
    STATE(2797), 1,
      sym_field_declaration_list,
  [259894] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5928), 1,
      anon_sym_LBRACE,
    STATE(2772), 1,
      sym_field_declaration_list,
  [259904] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5811), 1,
      anon_sym_LBRACE,
    STATE(2869), 1,
      sym_field_declaration_list,
  [259914] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5811), 1,
      anon_sym_LBRACE,
    STATE(2872), 1,
      sym_field_declaration_list,
  [259924] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12055), 1,
      anon_sym_LPAREN2,
    ACTIONS(12057), 1,
      sym_raw_string_delimiter,
  [259934] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9794), 1,
      anon_sym_RBRACE,
    ACTIONS(11859), 1,
      anon_sym_COMMA,
  [259944] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12059), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [259952] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5968), 1,
      anon_sym_LBRACE,
    STATE(2975), 1,
      sym_field_declaration_list,
  [259962] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12061), 1,
      anon_sym_LPAREN2,
    ACTIONS(12063), 1,
      sym_raw_string_delimiter,
  [259972] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12065), 1,
      anon_sym_LPAREN2,
    ACTIONS(12067), 1,
      sym_raw_string_delimiter,
  [259982] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12069), 1,
      anon_sym_LPAREN2,
    ACTIONS(12071), 1,
      sym_raw_string_delimiter,
  [259992] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12073), 1,
      anon_sym_LPAREN2,
    ACTIONS(12075), 1,
      sym_raw_string_delimiter,
  [260002] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(543), 1,
      sym_compound_statement,
  [260012] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12077), 1,
      anon_sym_LPAREN2,
    ACTIONS(12079), 1,
      sym_raw_string_delimiter,
  [260022] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11847), 1,
      sym_identifier,
    STATE(7201), 1,
      sym_attribute,
  [260032] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12081), 1,
      anon_sym_LPAREN2,
    ACTIONS(12083), 1,
      sym_raw_string_delimiter,
  [260042] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12085), 1,
      anon_sym_LPAREN2,
    ACTIONS(12087), 1,
      sym_raw_string_delimiter,
  [260052] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11076), 1,
      anon_sym_LPAREN2,
    STATE(7344), 1,
      sym_condition_clause,
  [260062] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11879), 1,
      anon_sym_LPAREN2,
    STATE(8096), 1,
      sym_parenthesized_expression,
  [260072] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11076), 1,
      anon_sym_LPAREN2,
    STATE(132), 1,
      sym_condition_clause,
  [260082] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(617), 1,
      anon_sym_LBRACE,
    STATE(452), 1,
      sym_compound_statement,
  [260092] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5990), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [260100] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(675), 1,
      anon_sym_LBRACE,
    STATE(774), 1,
      sym_compound_statement,
  [260110] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6002), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [260118] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    STATE(7227), 1,
      sym_compound_statement,
  [260128] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6010), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [260136] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8107), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [260144] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6014), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [260152] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6038), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [260160] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8742), 1,
      anon_sym_LBRACE,
    STATE(3880), 1,
      sym_requirement_seq,
  [260170] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    STATE(7448), 1,
      sym_parameter_list,
  [260180] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12089), 1,
      sym_identifier,
    STATE(2433), 1,
      sym_template_type,
  [260190] = 3,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(12091), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(12093), 1,
      sym_preproc_arg,
  [260200] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_LPAREN2,
    STATE(7389), 1,
      sym_parameter_list,
  [260210] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12095), 1,
      anon_sym_PERCENT_EQ,
  [260217] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4172), 1,
      anon_sym_DOT_DOT_DOT,
  [260224] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12097), 1,
      anon_sym_SEMI,
  [260231] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12099), 1,
      anon_sym_RPAREN,
  [260238] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12101), 1,
      anon_sym_SEMI,
  [260245] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12103), 1,
      anon_sym_RPAREN,
  [260252] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12047), 1,
      anon_sym_RBRACE,
  [260259] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7801), 1,
      anon_sym_RBRACE,
  [260266] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9794), 1,
      anon_sym_RBRACE,
  [260273] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12105), 1,
      sym_identifier,
  [260280] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12107), 1,
      sym_identifier,
  [260287] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12109), 1,
      anon_sym_LBRACE,
  [260294] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12111), 1,
      sym_identifier,
  [260301] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12113), 1,
      anon_sym_RPAREN,
  [260308] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12115), 1,
      sym_raw_string_content,
  [260315] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12117), 1,
      anon_sym_RPAREN,
  [260322] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12119), 1,
      anon_sym_STAR,
  [260329] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10719), 1,
      anon_sym_SEMI,
  [260336] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12121), 1,
      anon_sym_RPAREN,
  [260343] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12123), 1,
      anon_sym_RPAREN,
  [260350] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11254), 1,
      anon_sym_SEMI,
  [260357] = 2,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(12125), 1,
      aux_sym_preproc_include_token2,
  [260364] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12127), 1,
      anon_sym_STAR,
  [260371] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7893), 1,
      anon_sym_RBRACE,
  [260378] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12129), 1,
      anon_sym_LPAREN2,
  [260385] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12131), 1,
      aux_sym_preproc_if_token2,
  [260392] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12133), 1,
      anon_sym_RPAREN,
  [260399] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12135), 1,
      anon_sym_RPAREN,
  [260406] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12137), 1,
      sym_identifier,
  [260413] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10241), 1,
      anon_sym_SEMI,
  [260420] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12139), 1,
      anon_sym_RPAREN,
  [260427] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12141), 1,
      anon_sym_RPAREN,
  [260434] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12143), 1,
      sym_identifier,
  [260441] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6935), 1,
      sym_identifier,
  [260448] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12145), 1,
      anon_sym_SEMI,
  [260455] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10902), 1,
      anon_sym_SEMI,
  [260462] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12147), 1,
      sym_identifier,
  [260469] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12149), 1,
      anon_sym_RPAREN,
  [260476] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12151), 1,
      aux_sym_preproc_if_token2,
  [260483] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12153), 1,
      anon_sym_RPAREN,
  [260490] = 2,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(12155), 1,
      aux_sym_preproc_include_token2,
  [260497] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12157), 1,
      aux_sym_preproc_if_token2,
  [260504] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12159), 1,
      aux_sym_preproc_if_token2,
  [260511] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12161), 1,
      aux_sym_preproc_if_token2,
  [260518] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12163), 1,
      anon_sym_SEMI,
  [260525] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8099), 1,
      anon_sym_SEMI,
  [260532] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12165), 1,
      anon_sym_SEMI,
  [260539] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12167), 1,
      aux_sym_preproc_if_token2,
  [260546] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12169), 1,
      anon_sym_SEMI,
  [260553] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12171), 1,
      anon_sym_SEMI,
  [260560] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12173), 1,
      anon_sym_RPAREN,
  [260567] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12175), 1,
      sym_identifier,
  [260574] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12177), 1,
      sym_auto,
  [260581] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8073), 1,
      anon_sym_SEMI,
  [260588] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12179), 1,
      sym_identifier,
  [260595] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12181), 1,
      anon_sym_SEMI,
  [260602] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12183), 1,
      anon_sym_SEMI,
  [260609] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9757), 1,
      anon_sym_RPAREN,
  [260616] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11859), 1,
      anon_sym_COMMA,
  [260623] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12185), 1,
      sym_raw_string_delimiter,
  [260630] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7993), 1,
      anon_sym_COLON,
  [260637] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12187), 1,
      anon_sym_SEMI,
  [260644] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12189), 1,
      anon_sym_RPAREN,
  [260651] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8051), 1,
      anon_sym_COLON,
  [260658] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12191), 1,
      sym_auto,
  [260665] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12193), 1,
      anon_sym_RPAREN,
  [260672] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12195), 1,
      aux_sym_preproc_if_token2,
  [260679] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10604), 1,
      anon_sym_SEMI,
  [260686] = 2,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(12197), 1,
      aux_sym_preproc_include_token2,
  [260693] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12199), 1,
      sym_identifier,
  [260700] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12201), 1,
      anon_sym_SEMI,
  [260707] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12203), 1,
      anon_sym_SEMI,
  [260714] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12205), 1,
      anon_sym_SEMI,
  [260721] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12207), 1,
      sym_identifier,
  [260728] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12209), 1,
      anon_sym_SEMI,
  [260735] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12211), 1,
      aux_sym_preproc_if_token2,
  [260742] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12213), 1,
      anon_sym_SEMI,
  [260749] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12215), 1,
      anon_sym_SEMI,
  [260756] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12217), 1,
      anon_sym_DQUOTE,
  [260763] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11999), 1,
      anon_sym_RBRACE,
  [260770] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10223), 1,
      anon_sym_SEMI,
  [260777] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12219), 1,
      anon_sym_SEMI,
  [260784] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12221), 1,
      anon_sym_RPAREN,
  [260791] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12223), 1,
      anon_sym_RPAREN,
  [260798] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12225), 1,
      sym_identifier,
  [260805] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12227), 1,
      sym_identifier,
  [260812] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10655), 1,
      anon_sym_SEMI,
  [260819] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12229), 1,
      anon_sym_RPAREN,
  [260826] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12231), 1,
      anon_sym_LPAREN2,
  [260833] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12233), 1,
      anon_sym_RPAREN,
  [260840] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12235), 1,
      anon_sym_RPAREN,
  [260847] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12237), 1,
      aux_sym_preproc_if_token2,
  [260854] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12239), 1,
      anon_sym_DQUOTE,
  [260861] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12241), 1,
      anon_sym_SEMI,
  [260868] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12243), 1,
      sym_identifier,
  [260875] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12245), 1,
      anon_sym_SEMI,
  [260882] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9850), 1,
      anon_sym_RBRACE,
  [260889] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12247), 1,
      anon_sym_DQUOTE,
  [260896] = 2,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(12249), 1,
      aux_sym_preproc_include_token2,
  [260903] = 2,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(9116), 1,
      aux_sym_preproc_include_token2,
  [260910] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12251), 1,
      anon_sym_RPAREN,
  [260917] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12253), 1,
      anon_sym_STAR,
  [260924] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12255), 1,
      anon_sym_SEMI,
  [260931] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12257), 1,
      aux_sym_preproc_if_token2,
  [260938] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12259), 1,
      anon_sym_SEMI,
  [260945] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12261), 1,
      anon_sym_DQUOTE,
  [260952] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12263), 1,
      anon_sym_COMMA,
  [260959] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12265), 1,
      anon_sym_SEMI,
  [260966] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12267), 1,
      anon_sym_RPAREN,
  [260973] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12269), 1,
      anon_sym_SEMI,
  [260980] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12271), 1,
      anon_sym_RPAREN,
  [260987] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12273), 1,
      anon_sym_RPAREN,
  [260994] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12275), 1,
      anon_sym_SEMI,
  [261001] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12277), 1,
      anon_sym_RPAREN,
  [261008] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12279), 1,
      anon_sym_RBRACE,
  [261015] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12281), 1,
      anon_sym_SEMI,
  [261022] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12283), 1,
      sym_identifier,
  [261029] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12285), 1,
      anon_sym_SEMI,
  [261036] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12287), 1,
      anon_sym_RPAREN,
  [261043] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12289), 1,
      aux_sym_preproc_if_token2,
  [261050] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12291), 1,
      anon_sym_COLON,
  [261057] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12293), 1,
      anon_sym_LPAREN2,
  [261064] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12295), 1,
      anon_sym_RPAREN,
  [261071] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12297), 1,
      anon_sym_RBRACE,
  [261078] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12299), 1,
      anon_sym_COLON,
  [261085] = 2,
    ACTIONS(4818), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(9020), 1,
      sym_comment,
  [261092] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12301), 1,
      anon_sym_RPAREN,
  [261099] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12303), 1,
      sym_identifier,
  [261106] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12305), 1,
      anon_sym_SEMI,
  [261113] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12307), 1,
      anon_sym_RPAREN,
  [261120] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12309), 1,
      anon_sym_RPAREN,
  [261127] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12311), 1,
      sym_identifier,
  [261134] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12313), 1,
      anon_sym_SEMI,
  [261141] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12315), 1,
      aux_sym_preproc_if_token2,
  [261148] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12317), 1,
      anon_sym_SEMI,
  [261155] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7727), 1,
      anon_sym_RBRACE,
  [261162] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12319), 1,
      anon_sym_RPAREN,
  [261169] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8075), 1,
      anon_sym_SEMI,
  [261176] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12321), 1,
      anon_sym_RPAREN,
  [261183] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12323), 1,
      anon_sym_RPAREN,
  [261190] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12325), 1,
      anon_sym_SEMI,
  [261197] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12327), 1,
      aux_sym_preproc_if_token2,
  [261204] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12329), 1,
      aux_sym_preproc_if_token2,
  [261211] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12331), 1,
      aux_sym_preproc_if_token2,
  [261218] = 2,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(12333), 1,
      aux_sym_preproc_include_token2,
  [261225] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12335), 1,
      anon_sym_RPAREN,
  [261232] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12337), 1,
      anon_sym_SEMI,
  [261239] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12339), 1,
      anon_sym_RPAREN,
  [261246] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4169), 1,
      anon_sym_DOT_DOT_DOT,
  [261253] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12341), 1,
      anon_sym_SEMI,
  [261260] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12343), 1,
      sym_identifier,
  [261267] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7933), 1,
      anon_sym_RBRACE,
  [261274] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7849), 1,
      anon_sym_RPAREN,
  [261281] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12345), 1,
      anon_sym_RPAREN,
  [261288] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9777), 1,
      anon_sym_RPAREN,
  [261295] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12347), 1,
      anon_sym_RPAREN,
  [261302] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12349), 1,
      sym_raw_string_delimiter,
  [261309] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12351), 1,
      sym_auto,
  [261316] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12353), 1,
      anon_sym_SEMI,
  [261323] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12355), 1,
      anon_sym_RPAREN,
  [261330] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12357), 1,
      anon_sym_SEMI,
  [261337] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12359), 1,
      anon_sym_SEMI,
  [261344] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12361), 1,
      anon_sym_RPAREN,
  [261351] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8011), 1,
      anon_sym_COLON,
  [261358] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12363), 1,
      sym_identifier,
  [261365] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12365), 1,
      anon_sym_RPAREN,
  [261372] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12367), 1,
      anon_sym_SEMI,
  [261379] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12369), 1,
      sym_raw_string_delimiter,
  [261386] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12371), 1,
      anon_sym_RPAREN,
  [261393] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12373), 1,
      sym_identifier,
  [261400] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9788), 1,
      anon_sym_RPAREN,
  [261407] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12375), 1,
      aux_sym_preproc_if_token2,
  [261414] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12377), 1,
      anon_sym_RPAREN,
  [261421] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12379), 1,
      sym_identifier,
  [261428] = 2,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(12381), 1,
      aux_sym_preproc_include_token2,
  [261435] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12383), 1,
      anon_sym_STAR,
  [261442] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12385), 1,
      sym_identifier,
  [261449] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12387), 1,
      aux_sym_preproc_if_token2,
  [261456] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12389), 1,
      anon_sym_RPAREN,
  [261463] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12391), 1,
      aux_sym_preproc_if_token2,
  [261470] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7851), 1,
      anon_sym_SEMI,
  [261477] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12393), 1,
      anon_sym_SEMI,
  [261484] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12395), 1,
      sym_identifier,
  [261491] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12397), 1,
      sym_auto,
  [261498] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12399), 1,
      anon_sym_DQUOTE,
  [261505] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12401), 1,
      anon_sym_STAR,
  [261512] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12403), 1,
      anon_sym_RPAREN,
  [261519] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12405), 1,
      anon_sym_STAR,
  [261526] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12407), 1,
      anon_sym_SEMI,
  [261533] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12409), 1,
      anon_sym_LPAREN2,
  [261540] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12411), 1,
      anon_sym_SEMI,
  [261547] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12413), 1,
      anon_sym_COLON,
  [261554] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12415), 1,
      anon_sym_SEMI,
  [261561] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12417), 1,
      anon_sym_SEMI,
  [261568] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12419), 1,
      anon_sym_RPAREN,
  [261575] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8065), 1,
      anon_sym_COLON,
  [261582] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12421), 1,
      sym_identifier,
  [261589] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6977), 1,
      sym_identifier,
  [261596] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12423), 1,
      anon_sym_SEMI,
  [261603] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12425), 1,
      anon_sym_RBRACE,
  [261610] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12427), 1,
      anon_sym_SEMI,
  [261617] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8049), 1,
      anon_sym_RPAREN,
  [261624] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12429), 1,
      anon_sym_RPAREN,
  [261631] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12095), 1,
      anon_sym_PLUS_EQ,
  [261638] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10251), 1,
      anon_sym_SEMI,
  [261645] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12431), 1,
      anon_sym_RPAREN,
  [261652] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12433), 1,
      anon_sym_COLON,
  [261659] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12435), 1,
      anon_sym_SEMI,
  [261666] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9796), 1,
      anon_sym_RBRACE,
  [261673] = 2,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(9108), 1,
      aux_sym_preproc_include_token2,
  [261680] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8081), 1,
      anon_sym_SEMI,
  [261687] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12437), 1,
      sym_identifier,
  [261694] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12439), 1,
      aux_sym_preproc_if_token2,
  [261701] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12441), 1,
      anon_sym_STAR,
  [261708] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9806), 1,
      anon_sym_RPAREN,
  [261715] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8071), 1,
      anon_sym_RPAREN,
  [261722] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12443), 1,
      sym_raw_string_delimiter,
  [261729] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10527), 1,
      anon_sym_COLON,
  [261736] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12445), 1,
      sym_identifier,
  [261743] = 2,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(12447), 1,
      aux_sym_preproc_include_token2,
  [261750] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12449), 1,
      anon_sym_RPAREN,
  [261757] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12451), 1,
      anon_sym_RPAREN,
  [261764] = 2,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(12453), 1,
      aux_sym_preproc_include_token2,
  [261771] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12455), 1,
      anon_sym_RPAREN,
  [261778] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12457), 1,
      aux_sym_preproc_if_token2,
  [261785] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12459), 1,
      anon_sym_STAR,
  [261792] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12461), 1,
      sym_identifier,
  [261799] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12463), 1,
      sym_identifier,
  [261806] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12465), 1,
      anon_sym_RPAREN,
  [261813] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12467), 1,
      anon_sym_RPAREN,
  [261820] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9781), 1,
      anon_sym_RBRACE,
  [261827] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12469), 1,
      sym_identifier,
  [261834] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12471), 1,
      anon_sym_RPAREN,
  [261841] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7871), 1,
      anon_sym_RBRACE,
  [261848] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12473), 1,
      anon_sym_RPAREN,
  [261855] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12475), 1,
      anon_sym_RPAREN,
  [261862] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12477), 1,
      anon_sym_RPAREN,
  [261869] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12479), 1,
      anon_sym_DQUOTE,
  [261876] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12481), 1,
      anon_sym_LPAREN2,
  [261883] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12483), 1,
      anon_sym_SEMI,
  [261890] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12485), 1,
      anon_sym_SEMI,
  [261897] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9812), 1,
      anon_sym_RBRACE,
  [261904] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12487), 1,
      anon_sym_SEMI,
  [261911] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12489), 1,
      anon_sym_DQUOTE,
  [261918] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12491), 1,
      sym_identifier,
  [261925] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12493), 1,
      anon_sym_LPAREN2,
  [261932] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12495), 1,
      sym_identifier,
  [261939] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12497), 1,
      anon_sym_RPAREN,
  [261946] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12499), 1,
      sym_identifier,
  [261953] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12501), 1,
      aux_sym_preproc_if_token2,
  [261960] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12503), 1,
      anon_sym_RPAREN,
  [261967] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12505), 1,
      aux_sym_preproc_if_token2,
  [261974] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10583), 1,
      anon_sym_SEMI,
  [261981] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12507), 1,
      aux_sym_preproc_if_token2,
  [261988] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12095), 1,
      anon_sym_COMMA,
  [261995] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12095), 1,
      anon_sym_DASH,
  [262002] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12095), 1,
      anon_sym_PLUS,
  [262009] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12095), 1,
      anon_sym_STAR,
  [262016] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12509), 1,
      anon_sym_SLASH,
  [262023] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12511), 1,
      sym_identifier,
  [262030] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12513), 1,
      anon_sym_RPAREN,
  [262037] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12515), 1,
      anon_sym_LPAREN2,
  [262044] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9818), 1,
      anon_sym_RPAREN,
  [262051] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12517), 1,
      anon_sym_RPAREN,
  [262058] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12519), 1,
      sym_raw_string_delimiter,
  [262065] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12095), 1,
      anon_sym_PERCENT,
  [262072] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12521), 1,
      sym_identifier,
  [262079] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12095), 1,
      anon_sym_PIPE_PIPE,
  [262086] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12095), 1,
      anon_sym_AMP_AMP,
  [262093] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4152), 1,
      anon_sym_DOT_DOT_DOT,
  [262100] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12095), 1,
      anon_sym_PIPE,
  [262107] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12523), 1,
      anon_sym_SEMI,
  [262114] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12525), 1,
      anon_sym_RPAREN,
  [262121] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12095), 1,
      anon_sym_CARET,
  [262128] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12095), 1,
      anon_sym_AMP,
  [262135] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12095), 1,
      anon_sym_EQ_EQ,
  [262142] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12527), 1,
      anon_sym_SEMI,
  [262149] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12529), 1,
      sym_identifier,
  [262156] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11865), 1,
      anon_sym_RBRACE,
  [262163] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4155), 1,
      anon_sym_DOT_DOT_DOT,
  [262170] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12531), 1,
      anon_sym_SEMI,
  [262177] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12533), 1,
      anon_sym_LPAREN2,
  [262184] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12095), 1,
      anon_sym_BANG_EQ,
  [262191] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12535), 1,
      aux_sym_preproc_if_token2,
  [262198] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12537), 1,
      sym_identifier,
  [262205] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12539), 1,
      sym_identifier,
  [262212] = 2,
    ACTIONS(4831), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(9020), 1,
      sym_comment,
  [262219] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12095), 1,
      anon_sym_GT_EQ,
  [262226] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12095), 1,
      anon_sym_LT_EQ,
  [262233] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12541), 1,
      anon_sym_RPAREN,
  [262240] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12543), 1,
      anon_sym_RPAREN,
  [262247] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12095), 1,
      anon_sym_LT,
  [262254] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12095), 1,
      anon_sym_LT_LT,
  [262261] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12545), 1,
      anon_sym_SEMI,
  [262268] = 2,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(12547), 1,
      aux_sym_preproc_include_token2,
  [262275] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12095), 1,
      anon_sym_GT_GT,
  [262282] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12549), 1,
      anon_sym_COLON,
  [262289] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12095), 1,
      anon_sym_EQ,
  [262296] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12551), 1,
      anon_sym_STAR,
  [262303] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9846), 1,
      anon_sym_RPAREN,
  [262310] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12553), 1,
      sym_identifier,
  [262317] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12555), 1,
      sym_raw_string_delimiter,
  [262324] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12557), 1,
      anon_sym_LPAREN2,
  [262331] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12559), 1,
      sym_identifier,
  [262338] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12561), 1,
      sym_auto,
  [262345] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12563), 1,
      anon_sym_STAR,
  [262352] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8177), 1,
      anon_sym_RPAREN,
  [262359] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12565), 1,
      sym_identifier,
  [262366] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12567), 1,
      anon_sym_LPAREN2,
  [262373] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12569), 1,
      anon_sym_COLON,
  [262380] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12095), 1,
      anon_sym_STAR_EQ,
  [262387] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12571), 1,
      aux_sym_preproc_if_token2,
  [262394] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12573), 1,
      anon_sym_RPAREN,
  [262401] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12575), 1,
      anon_sym_RPAREN,
  [262408] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12577), 1,
      anon_sym_LPAREN2,
  [262415] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12579), 1,
      sym_raw_string_delimiter,
  [262422] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12581), 1,
      sym_identifier,
  [262429] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12583), 1,
      aux_sym_preproc_if_token2,
  [262436] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12095), 1,
      anon_sym_SLASH_EQ,
  [262443] = 2,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(12585), 1,
      aux_sym_preproc_include_token2,
  [262450] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12587), 1,
      anon_sym_LPAREN2,
  [262457] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12589), 1,
      aux_sym_preproc_if_token2,
  [262464] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12591), 1,
      aux_sym_preproc_if_token2,
  [262471] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12593), 1,
      anon_sym_RPAREN,
  [262478] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4160), 1,
      anon_sym_DOT_DOT_DOT,
  [262485] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12595), 1,
      sym_raw_string_delimiter,
  [262492] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12597), 1,
      anon_sym_RPAREN,
  [262499] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6587), 1,
      sym_identifier,
  [262506] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12599), 1,
      sym_identifier,
  [262513] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12601), 1,
      anon_sym_LPAREN2,
  [262520] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12603), 1,
      anon_sym_RPAREN,
  [262527] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12605), 1,
      sym_raw_string_delimiter,
  [262534] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12607), 1,
      aux_sym_preproc_if_token2,
  [262541] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12609), 1,
      anon_sym_RPAREN,
  [262548] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12611), 1,
      sym_raw_string_delimiter,
  [262555] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12095), 1,
      anon_sym_DASH_EQ,
  [262562] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12613), 1,
      anon_sym_RPAREN,
  [262569] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12615), 1,
      sym_raw_string_delimiter,
  [262576] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12617), 1,
      anon_sym_RPAREN,
  [262583] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12619), 1,
      sym_raw_string_delimiter,
  [262590] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12621), 1,
      anon_sym_RPAREN,
  [262597] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12623), 1,
      sym_raw_string_delimiter,
  [262604] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12625), 1,
      anon_sym_RPAREN,
  [262611] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12627), 1,
      sym_raw_string_delimiter,
  [262618] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12629), 1,
      anon_sym_RPAREN,
  [262625] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12631), 1,
      sym_raw_string_delimiter,
  [262632] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12633), 1,
      anon_sym_RPAREN,
  [262639] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12635), 1,
      sym_raw_string_delimiter,
  [262646] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12637), 1,
      anon_sym_RPAREN,
  [262653] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12639), 1,
      sym_identifier,
  [262660] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12641), 1,
      sym_identifier,
  [262667] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12643), 1,
      anon_sym_LPAREN2,
  [262674] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8109), 1,
      anon_sym_COLON,
  [262681] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12645), 1,
      anon_sym_LPAREN2,
  [262688] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12647), 1,
      anon_sym_LPAREN2,
  [262695] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8019), 1,
      anon_sym_COLON,
  [262702] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8035), 1,
      anon_sym_RPAREN,
  [262709] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12649), 1,
      anon_sym_LPAREN2,
  [262716] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12651), 1,
      sym_auto,
  [262723] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12653), 1,
      anon_sym_LPAREN2,
  [262730] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12655), 1,
      anon_sym_LPAREN2,
  [262737] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12657), 1,
      anon_sym_DQUOTE,
  [262744] = 2,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(12659), 1,
      aux_sym_preproc_include_token2,
  [262751] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4163), 1,
      anon_sym_DOT_DOT_DOT,
  [262758] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10264), 1,
      anon_sym_SEMI,
  [262765] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12661), 1,
      anon_sym_RPAREN,
  [262772] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12663), 1,
      anon_sym_SEMI,
  [262779] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12665), 1,
      anon_sym_DOT_DOT_DOT,
  [262786] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4430), 1,
      anon_sym_SEMI,
  [262793] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12667), 1,
      anon_sym_SEMI,
  [262800] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12669), 1,
      anon_sym_DOT_DOT_DOT,
  [262807] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11861), 1,
      anon_sym_RBRACE,
  [262814] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12672), 1,
      anon_sym_DQUOTE,
  [262821] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12674), 1,
      anon_sym_DQUOTE,
  [262828] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12676), 1,
      anon_sym_SEMI,
  [262835] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12678), 1,
      anon_sym_while,
  [262842] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12095), 1,
      anon_sym_LT_LT_EQ,
  [262849] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12680), 1,
      anon_sym_LPAREN2,
  [262856] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12095), 1,
      anon_sym_GT_GT_EQ,
  [262863] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4166), 1,
      anon_sym_DOT_DOT_DOT,
  [262870] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12095), 1,
      anon_sym_AMP_EQ,
  [262877] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12682), 1,
      aux_sym_preproc_if_token2,
  [262884] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12684), 1,
      anon_sym_EQ,
  [262891] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12686), 1,
      sym_raw_string_content,
  [262898] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12688), 1,
      sym_identifier,
  [262905] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12690), 1,
      anon_sym_RPAREN,
  [262912] = 2,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(12692), 1,
      aux_sym_preproc_include_token2,
  [262919] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12694), 1,
      anon_sym_STAR,
  [262926] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12696), 1,
      aux_sym_preproc_if_token2,
  [262933] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12698), 1,
      anon_sym_RPAREN,
  [262940] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6589), 1,
      sym_identifier,
  [262947] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12095), 1,
      anon_sym_CARET_EQ,
  [262954] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12700), 1,
      anon_sym_DQUOTE,
  [262961] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10918), 1,
      anon_sym_SEMI,
  [262968] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12702), 1,
      aux_sym_preproc_if_token2,
  [262975] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12704), 1,
      anon_sym_RPAREN,
  [262982] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12706), 1,
      anon_sym_SEMI,
  [262989] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12708), 1,
      sym_identifier,
  [262996] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12710), 1,
      anon_sym_RPAREN,
  [263003] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12712), 1,
      anon_sym_COMMA,
  [263010] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12714), 1,
      anon_sym_DQUOTE,
  [263017] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12095), 1,
      anon_sym_PIPE_EQ,
  [263024] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8115), 1,
      anon_sym_SEMI,
  [263031] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12716), 1,
      anon_sym_RPAREN,
  [263038] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8077), 1,
      anon_sym_COLON,
  [263045] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12718), 1,
      anon_sym_RPAREN,
  [263052] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12095), 1,
      anon_sym_or,
  [263059] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12095), 1,
      anon_sym_and,
  [263066] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12720), 1,
      anon_sym_SEMI,
  [263073] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12722), 1,
      anon_sym_SEMI,
  [263080] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7927), 1,
      anon_sym_RBRACE,
  [263087] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12724), 1,
      anon_sym_DQUOTE,
  [263094] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12095), 1,
      anon_sym_bitor,
  [263101] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12726), 1,
      anon_sym_DQUOTE,
  [263108] = 2,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(12728), 1,
      aux_sym_preproc_include_token2,
  [263115] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12730), 1,
      anon_sym_DQUOTE,
  [263122] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12732), 1,
      anon_sym_RPAREN,
  [263129] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12095), 1,
      anon_sym_xor,
  [263136] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12095), 1,
      anon_sym_bitand,
  [263143] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12095), 1,
      anon_sym_not_eq,
  [263150] = 2,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(9168), 1,
      aux_sym_preproc_include_token2,
  [263157] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12734), 1,
      anon_sym_COLON,
  [263164] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9798), 1,
      anon_sym_RBRACE,
  [263171] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12736), 1,
      anon_sym_RPAREN,
  [263178] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4175), 1,
      anon_sym_DOT_DOT_DOT,
  [263185] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12738), 1,
      anon_sym_RPAREN,
  [263192] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12095), 1,
      anon_sym_DOT_STAR,
  [263199] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12740), 1,
      anon_sym_DQUOTE,
  [263206] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12742), 1,
      anon_sym_DQUOTE,
  [263213] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12744), 1,
      anon_sym_SEMI,
  [263220] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12746), 1,
      anon_sym_SEMI,
  [263227] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8057), 1,
      anon_sym_SEMI,
  [263234] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12748), 1,
      anon_sym_SEMI,
  [263241] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12750), 1,
      anon_sym_RPAREN,
  [263248] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9779), 1,
      anon_sym_RPAREN,
  [263255] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12752), 1,
      sym_raw_string_delimiter,
  [263262] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12095), 1,
      anon_sym_DASH_GT_STAR,
  [263269] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12754), 1,
      anon_sym_RPAREN,
  [263276] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12756), 1,
      anon_sym_SEMI,
  [263283] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12758), 1,
      aux_sym_preproc_if_token2,
  [263290] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12760), 1,
      anon_sym_LBRACE,
  [263297] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12762), 1,
      sym_identifier,
  [263304] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12764), 1,
      anon_sym_DQUOTE,
  [263311] = 2,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(12766), 1,
      aux_sym_preproc_include_token2,
  [263318] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4178), 1,
      anon_sym_DOT_DOT_DOT,
  [263325] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12768), 1,
      anon_sym_STAR,
  [263332] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12770), 1,
      anon_sym_RPAREN,
  [263339] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12772), 1,
      anon_sym_LPAREN2,
  [263346] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4280), 1,
      anon_sym_SEMI,
  [263353] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12095), 1,
      anon_sym_GT,
  [263360] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12774), 1,
      anon_sym_DQUOTE,
  [263367] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12776), 1,
      anon_sym_RPAREN,
  [263374] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12778), 1,
      anon_sym_RPAREN,
  [263381] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12780), 1,
      anon_sym_RPAREN,
  [263388] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12782), 1,
      anon_sym_RPAREN,
  [263395] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12784), 1,
      anon_sym_SEMI,
  [263402] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12786), 1,
      anon_sym_SEMI,
  [263409] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12788), 1,
      anon_sym_RPAREN,
  [263416] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6333), 1,
      anon_sym_RPAREN,
  [263423] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12790), 1,
      anon_sym_SEMI,
  [263430] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4181), 1,
      anon_sym_DOT_DOT_DOT,
  [263437] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12792), 1,
      sym_identifier,
  [263444] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12794), 1,
      anon_sym_STAR,
  [263451] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4184), 1,
      anon_sym_DOT_DOT_DOT,
  [263458] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4205), 1,
      anon_sym_DOT_DOT_DOT,
  [263465] = 2,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(12796), 1,
      aux_sym_preproc_include_token2,
  [263472] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12798), 1,
      anon_sym_SEMI,
  [263479] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10209), 1,
      anon_sym_SEMI,
  [263486] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12800), 1,
      anon_sym_SEMI,
  [263493] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12802), 1,
      anon_sym_LBRACE,
  [263500] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12804), 1,
      anon_sym_DQUOTE,
  [263507] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12806), 1,
      anon_sym_DQUOTE,
  [263514] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7963), 1,
      anon_sym_SEMI,
  [263521] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12808), 1,
      anon_sym_DQUOTE,
  [263528] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12810), 1,
      anon_sym_LPAREN2,
  [263535] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12812), 1,
      anon_sym_RPAREN,
  [263542] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12814), 1,
      anon_sym_SEMI,
  [263549] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5734), 1,
      sym_identifier,
  [263556] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12816), 1,
      anon_sym_SEMI,
  [263563] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12818), 1,
      anon_sym_SEMI,
  [263570] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12820), 1,
      anon_sym_RPAREN,
  [263577] = 2,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(11575), 1,
      aux_sym_preproc_include_token2,
  [263584] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12822), 1,
      anon_sym_SEMI,
  [263591] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11899), 1,
      anon_sym_RBRACE,
  [263598] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12824), 1,
      anon_sym_DQUOTE,
  [263605] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12826), 1,
      anon_sym_DQUOTE,
  [263612] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12828), 1,
      sym_identifier,
  [263619] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12830), 1,
      anon_sym_SEMI,
  [263626] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8059), 1,
      anon_sym_SEMI,
  [263633] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12832), 1,
      sym_raw_string_content,
  [263640] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12834), 1,
      anon_sym_SEMI,
  [263647] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12836), 1,
      anon_sym_LPAREN2,
  [263654] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12838), 1,
      anon_sym_SEMI,
  [263661] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12840), 1,
      anon_sym_SEMI,
  [263668] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12842), 1,
      anon_sym_SEMI,
  [263675] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12844), 1,
      anon_sym_EQ,
  [263682] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10247), 1,
      anon_sym_SEMI,
  [263689] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12846), 1,
      anon_sym_SEMI,
  [263696] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12848), 1,
      aux_sym_preproc_if_token2,
  [263703] = 2,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(12850), 1,
      aux_sym_preproc_include_token2,
  [263710] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12852), 1,
      anon_sym_SEMI,
  [263717] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12854), 1,
      anon_sym_RPAREN,
  [263724] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12856), 1,
      anon_sym_RPAREN,
  [263731] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12858), 1,
      anon_sym_RPAREN,
  [263738] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12860), 1,
      aux_sym_preproc_if_token2,
  [263745] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12862), 1,
      anon_sym_RPAREN,
  [263752] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12864), 1,
      anon_sym_DQUOTE,
  [263759] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12866), 1,
      anon_sym_DQUOTE,
  [263766] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8085), 1,
      anon_sym_SEMI,
  [263773] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11921), 1,
      anon_sym_RBRACE,
  [263780] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12868), 1,
      anon_sym_RPAREN,
  [263787] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11096), 1,
      anon_sym_COLON_COLON,
  [263794] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8027), 1,
      anon_sym_COLON,
  [263801] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12870), 1,
      anon_sym_SEMI,
  [263808] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12872), 1,
      sym_identifier,
  [263815] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12874), 1,
      sym_auto,
  [263822] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12876), 1,
      anon_sym_RPAREN,
  [263829] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12878), 1,
      anon_sym_RPAREN,
  [263836] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10233), 1,
      anon_sym_SEMI,
  [263843] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9503), 1,
      sym_identifier,
  [263850] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12880), 1,
      anon_sym_COLON,
  [263857] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9828), 1,
      anon_sym_RBRACE,
  [263864] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12882), 1,
      anon_sym_RPAREN,
  [263871] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12884), 1,
      aux_sym_preproc_if_token2,
  [263878] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12886), 1,
      sym_identifier,
  [263885] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12888), 1,
      anon_sym_RPAREN,
  [263892] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12890), 1,
      anon_sym_RPAREN,
  [263899] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12892), 1,
      anon_sym_RPAREN,
  [263906] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12894), 1,
      anon_sym_RPAREN,
  [263913] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12896), 1,
      anon_sym_RPAREN,
  [263920] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8039), 1,
      anon_sym_SEMI,
  [263927] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12898), 1,
      anon_sym_LPAREN2,
  [263934] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12900), 1,
      anon_sym_LPAREN2,
  [263941] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12902), 1,
      anon_sym_LPAREN2,
  [263948] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12904), 1,
      anon_sym_LPAREN2,
  [263955] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12906), 1,
      anon_sym_SEMI,
  [263962] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12908), 1,
      anon_sym_LPAREN2,
  [263969] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12910), 1,
      anon_sym_SEMI,
  [263976] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12912), 1,
      anon_sym_RPAREN,
  [263983] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8037), 1,
      anon_sym_SEMI,
  [263990] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12914), 1,
      anon_sym_while,
  [263997] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12916), 1,
      anon_sym_while,
  [264004] = 2,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(12918), 1,
      aux_sym_preproc_include_token2,
  [264011] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12920), 1,
      anon_sym_LPAREN2,
  [264018] = 2,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(12922), 1,
      aux_sym_preproc_include_token2,
  [264025] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12924), 1,
      anon_sym_RPAREN,
  [264032] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12926), 1,
      aux_sym_preproc_if_token2,
  [264039] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12928), 1,
      anon_sym_EQ,
  [264046] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12930), 1,
      sym_raw_string_content,
  [264053] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12932), 1,
      anon_sym_RPAREN,
  [264060] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12934), 1,
      anon_sym_RPAREN,
  [264067] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12936), 1,
      anon_sym_COMMA,
  [264074] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12938), 1,
      anon_sym_SEMI,
  [264081] = 2,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(11406), 1,
      aux_sym_preproc_include_token2,
  [264088] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12940), 1,
      anon_sym_SEMI,
  [264095] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12942), 1,
      anon_sym_RPAREN,
  [264102] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12944), 1,
      anon_sym_COLON,
  [264109] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12946), 1,
      aux_sym_preproc_if_token2,
  [264116] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12948), 1,
      aux_sym_preproc_if_token2,
  [264123] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12950), 1,
      anon_sym_LPAREN2,
  [264130] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12952), 1,
      anon_sym_LPAREN2,
  [264137] = 2,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(9172), 1,
      aux_sym_preproc_include_token2,
  [264144] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12954), 1,
      anon_sym_LPAREN2,
  [264151] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9852), 1,
      anon_sym_RBRACE,
  [264158] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12956), 1,
      anon_sym_DQUOTE,
  [264165] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12958), 1,
      anon_sym_while,
  [264172] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12960), 1,
      anon_sym_SEMI,
  [264179] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12962), 1,
      anon_sym_LPAREN2,
  [264186] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12964), 1,
      aux_sym_preproc_if_token2,
  [264193] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12966), 1,
      anon_sym_RPAREN,
  [264200] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12968), 1,
      anon_sym_EQ,
  [264207] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12970), 1,
      sym_raw_string_content,
  [264214] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12972), 1,
      anon_sym_COMMA,
  [264221] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12974), 1,
      anon_sym_DQUOTE,
  [264228] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12976), 1,
      anon_sym_SEMI,
  [264235] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11967), 1,
      anon_sym_RBRACE,
  [264242] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12978), 1,
      anon_sym_RPAREN,
  [264249] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12980), 1,
      anon_sym_COLON,
  [264256] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12982), 1,
      anon_sym_SEMI,
  [264263] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12984), 1,
      anon_sym_LPAREN2,
  [264270] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12986), 1,
      anon_sym_LPAREN2,
  [264277] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12988), 1,
      anon_sym_SEMI,
  [264284] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12990), 1,
      anon_sym_LPAREN2,
  [264291] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12992), 1,
      anon_sym_SEMI,
  [264298] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12994), 1,
      anon_sym_RPAREN,
  [264305] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12996), 1,
      anon_sym_while,
  [264312] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12998), 1,
      anon_sym_LPAREN2,
  [264319] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13000), 1,
      anon_sym_COLON,
  [264326] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13002), 1,
      anon_sym_SEMI,
  [264333] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13004), 1,
      anon_sym_EQ,
  [264340] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13006), 1,
      sym_raw_string_content,
  [264347] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13008), 1,
      anon_sym_COMMA,
  [264354] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13010), 1,
      anon_sym_SEMI,
  [264361] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13012), 1,
      anon_sym_SEMI,
  [264368] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13014), 1,
      aux_sym_preproc_if_token2,
  [264375] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13016), 1,
      anon_sym_RPAREN,
  [264382] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13018), 1,
      anon_sym_COLON,
  [264389] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13020), 1,
      anon_sym_DQUOTE,
  [264396] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13022), 1,
      anon_sym_LPAREN2,
  [264403] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13024), 1,
      anon_sym_LPAREN2,
  [264410] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13026), 1,
      anon_sym_COLON,
  [264417] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13028), 1,
      anon_sym_LPAREN2,
  [264424] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8053), 1,
      anon_sym_COLON,
  [264431] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11945), 1,
      anon_sym_RBRACE,
  [264438] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13030), 1,
      anon_sym_LPAREN2,
  [264445] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13032), 1,
      anon_sym_RBRACK,
  [264452] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13034), 1,
      sym_auto,
  [264459] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13036), 1,
      anon_sym_EQ,
  [264466] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13038), 1,
      sym_raw_string_content,
  [264473] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13040), 1,
      anon_sym_COMMA,
  [264480] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8067), 1,
      anon_sym_RPAREN,
  [264487] = 2,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(11132), 1,
      aux_sym_preproc_include_token2,
  [264494] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13042), 1,
      anon_sym_RPAREN,
  [264501] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13044), 1,
      anon_sym_RPAREN,
  [264508] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13046), 1,
      anon_sym_COLON,
  [264515] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7725), 1,
      anon_sym_SEMI,
  [264522] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13048), 1,
      anon_sym_LPAREN2,
  [264529] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10922), 1,
      anon_sym_SEMI,
  [264536] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13050), 1,
      anon_sym_LPAREN2,
  [264543] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13052), 1,
      anon_sym_SEMI,
  [264550] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13054), 1,
      anon_sym_RPAREN,
  [264557] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13056), 1,
      anon_sym_RPAREN,
  [264564] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13058), 1,
      anon_sym_STAR,
  [264571] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13060), 1,
      anon_sym_EQ,
  [264578] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13062), 1,
      sym_raw_string_content,
  [264585] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9820), 1,
      anon_sym_RBRACE,
  [264592] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13064), 1,
      aux_sym_preproc_if_token2,
  [264599] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13066), 1,
      aux_sym_preproc_if_token2,
  [264606] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13068), 1,
      anon_sym_RPAREN,
  [264613] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13070), 1,
      sym_identifier,
  [264620] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13072), 1,
      anon_sym_LPAREN2,
  [264627] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13074), 1,
      anon_sym_LPAREN2,
  [264634] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13076), 1,
      anon_sym_SEMI,
  [264641] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13078), 1,
      sym_raw_string_content,
  [264648] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13080), 1,
      anon_sym_RBRACE,
  [264655] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13082), 1,
      sym_identifier,
  [264662] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13084), 1,
      anon_sym_RPAREN,
  [264669] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13086), 1,
      aux_sym_preproc_if_token2,
  [264676] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13088), 1,
      anon_sym_LPAREN2,
  [264683] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13090), 1,
      anon_sym_LPAREN2,
  [264690] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10300), 1,
      anon_sym_COMMA,
  [264697] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13092), 1,
      sym_raw_string_content,
  [264704] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13094), 1,
      anon_sym_RBRACE,
  [264711] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13096), 1,
      anon_sym_RPAREN,
  [264718] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13098), 1,
      anon_sym_LPAREN2,
  [264725] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13100), 1,
      anon_sym_LPAREN2,
  [264732] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13102), 1,
      sym_raw_string_content,
  [264739] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13104), 1,
      anon_sym_RPAREN,
  [264746] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13106), 1,
      sym_raw_string_content,
  [264753] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13108), 1,
      anon_sym_RPAREN,
  [264760] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13110), 1,
      sym_raw_string_content,
  [264767] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13112), 1,
      anon_sym_RPAREN,
  [264774] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13114), 1,
      sym_raw_string_content,
  [264781] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13116), 1,
      anon_sym_RPAREN,
  [264788] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13118), 1,
      sym_raw_string_content,
  [264795] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13120), 1,
      anon_sym_RPAREN,
  [264802] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13122), 1,
      sym_raw_string_content,
  [264809] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13124), 1,
      anon_sym_RPAREN,
  [264816] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13126), 1,
      sym_raw_string_content,
  [264823] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13128), 1,
      anon_sym_RPAREN,
  [264830] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13130), 1,
      sym_raw_string_content,
  [264837] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13132), 1,
      anon_sym_RPAREN,
  [264844] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13134), 1,
      anon_sym_RPAREN,
  [264851] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13136), 1,
      anon_sym_RPAREN,
  [264858] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13138), 1,
      anon_sym_LPAREN2,
  [264865] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13140), 1,
      anon_sym_LPAREN2,
  [264872] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13142), 1,
      sym_identifier,
  [264879] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13144), 1,
      anon_sym_SEMI,
  [264886] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13146), 1,
      sym_identifier,
  [264893] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13148), 1,
      aux_sym_preproc_if_token2,
  [264900] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13150), 1,
      aux_sym_preproc_if_token2,
  [264907] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8125), 1,
      anon_sym_RPAREN,
  [264914] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13152), 1,
      anon_sym_SEMI,
  [264921] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13154), 1,
      aux_sym_preproc_if_token2,
  [264928] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13156), 1,
      anon_sym_SEMI,
  [264935] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4428), 1,
      anon_sym_SEMI,
  [264942] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13158), 1,
      aux_sym_preproc_if_token2,
  [264949] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13160), 1,
      sym_identifier,
  [264956] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8069), 1,
      anon_sym_RPAREN,
  [264963] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13162), 1,
      anon_sym_SEMI,
  [264970] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13164), 1,
      anon_sym_SEMI,
  [264977] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13166), 1,
      sym_identifier,
  [264984] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13168), 1,
      sym_raw_string_content,
  [264991] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13170), 1,
      sym_auto,
  [264998] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13172), 1,
      sym_identifier,
  [265005] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13174), 1,
      aux_sym_preproc_if_token2,
  [265012] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13176), 1,
      anon_sym_SEMI,
  [265019] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11479), 1,
      anon_sym_RPAREN,
  [265026] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13178), 1,
      anon_sym_LPAREN2,
  [265033] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13180), 1,
      anon_sym_RPAREN,
  [265040] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13182), 1,
      anon_sym_SEMI,
  [265047] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13184), 1,
      anon_sym_RPAREN,
  [265054] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13186), 1,
      anon_sym_RPAREN,
  [265061] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13188), 1,
      anon_sym_RPAREN,
  [265068] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4922), 1,
      anon_sym_COLON_COLON,
  [265075] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6469), 1,
      anon_sym_RPAREN,
  [265082] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13190), 1,
      anon_sym_STAR,
  [265089] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13192), 1,
      anon_sym_RPAREN,
  [265096] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13194), 1,
      sym_identifier,
  [265103] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8021), 1,
      anon_sym_COLON,
  [265110] = 2,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(13196), 1,
      aux_sym_preproc_include_token2,
  [265117] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13198), 1,
      anon_sym_SEMI,
  [265124] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13200), 1,
      anon_sym_SEMI,
  [265131] = 2,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(13202), 1,
      aux_sym_preproc_include_token2,
  [265138] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13204), 1,
      anon_sym_RPAREN,
  [265145] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13206), 1,
      anon_sym_RPAREN,
  [265152] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13208), 1,
      anon_sym_RPAREN,
  [265159] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13210), 1,
      anon_sym_SEMI,
  [265166] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13212), 1,
      anon_sym_SEMI,
  [265173] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13214), 1,
      anon_sym_RPAREN,
  [265180] = 2,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(11256), 1,
      aux_sym_preproc_include_token2,
  [265187] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13216), 1,
      anon_sym_RPAREN,
  [265194] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8083), 1,
      anon_sym_COLON,
  [265201] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13218), 1,
      anon_sym_RPAREN,
  [265208] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13220), 1,
      anon_sym_SEMI,
  [265215] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13222), 1,
      anon_sym_SEMI,
  [265222] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13224), 1,
      anon_sym_RPAREN,
  [265229] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13226), 1,
      aux_sym_preproc_if_token2,
  [265236] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13228), 1,
      anon_sym_DQUOTE,
  [265243] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13230), 1,
      anon_sym_SEMI,
  [265250] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13232), 1,
      anon_sym_RPAREN,
  [265257] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12001), 1,
      anon_sym_RBRACE,
  [265264] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13234), 1,
      anon_sym_STAR,
  [265271] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13236), 1,
      anon_sym_SEMI,
  [265278] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13238), 1,
      ts_builtin_sym_end,
  [265285] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13240), 1,
      anon_sym_SEMI,
  [265292] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13242), 1,
      anon_sym_RBRACE,
  [265299] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13244), 1,
      anon_sym_RBRACK,
  [265306] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13246), 1,
      sym_identifier,
  [265313] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13248), 1,
      anon_sym_LPAREN2,
  [265320] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13250), 1,
      anon_sym_SEMI,
  [265327] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13252), 1,
      anon_sym_SEMI,
  [265334] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13254), 1,
      anon_sym_RPAREN,
  [265341] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13256), 1,
      anon_sym_DQUOTE,
  [265348] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13258), 1,
      anon_sym_SEMI,
  [265355] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13260), 1,
      anon_sym_LPAREN2,
  [265362] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13262), 1,
      anon_sym_LPAREN2,
  [265369] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13264), 1,
      aux_sym_preproc_if_token2,
  [265376] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13266), 1,
      anon_sym_SEMI,
  [265383] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13268), 1,
      aux_sym_preproc_if_token2,
  [265390] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13270), 1,
      anon_sym_LPAREN2,
  [265397] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8079), 1,
      anon_sym_COLON,
  [265404] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13272), 1,
      anon_sym_LPAREN2,
  [265411] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13274), 1,
      anon_sym_LPAREN2,
  [265418] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13276), 1,
      anon_sym_LPAREN2,
  [265425] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13278), 1,
      anon_sym_LPAREN2,
  [265432] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13280), 1,
      sym_identifier,
  [265439] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13282), 1,
      anon_sym_SEMI,
  [265446] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13284), 1,
      sym_identifier,
  [265453] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13286), 1,
      anon_sym_SEMI,
  [265460] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13288), 1,
      sym_identifier,
  [265467] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13290), 1,
      sym_raw_string_content,
  [265474] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13292), 1,
      anon_sym_SEMI,
  [265481] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13294), 1,
      anon_sym_LPAREN2,
  [265488] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13296), 1,
      anon_sym_DQUOTE,
  [265495] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13298), 1,
      anon_sym_LPAREN2,
  [265502] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13300), 1,
      anon_sym_LPAREN2,
  [265509] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13302), 1,
      sym_identifier,
  [265516] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13304), 1,
      anon_sym_SEMI,
  [265523] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13306), 1,
      anon_sym_COLON,
  [265530] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13308), 1,
      sym_identifier,
  [265537] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13310), 1,
      sym_raw_string_content,
  [265544] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12025), 1,
      anon_sym_RBRACE,
  [265551] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13312), 1,
      anon_sym_DQUOTE,
  [265558] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8055), 1,
      anon_sym_COLON,
  [265565] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13314), 1,
      anon_sym_LPAREN2,
  [265572] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13316), 1,
      sym_identifier,
  [265579] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13318), 1,
      sym_auto,
  [265586] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13320), 1,
      anon_sym_RPAREN,
  [265593] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13322), 1,
      sym_identifier,
  [265600] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13324), 1,
      sym_raw_string_content,
  [265607] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13326), 1,
      anon_sym_SEMI,
  [265614] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13328), 1,
      anon_sym_SEMI,
  [265621] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13330), 1,
      anon_sym_LPAREN2,
  [265628] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13332), 1,
      sym_identifier,
  [265635] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13334), 1,
      anon_sym_RPAREN,
  [265642] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13336), 1,
      anon_sym_SEMI,
  [265649] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13338), 1,
      sym_identifier,
  [265656] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13340), 1,
      sym_raw_string_content,
  [265663] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13342), 1,
      anon_sym_LPAREN2,
  [265670] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9773), 1,
      anon_sym_RBRACE,
  [265677] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13344), 1,
      anon_sym_LPAREN2,
  [265684] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13346), 1,
      sym_identifier,
  [265691] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13348), 1,
      anon_sym_RPAREN,
  [265698] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13350), 1,
      sym_identifier,
  [265705] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13352), 1,
      sym_raw_string_content,
  [265712] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13354), 1,
      anon_sym_RPAREN,
  [265719] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13356), 1,
      anon_sym_RPAREN,
  [265726] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13358), 1,
      sym_identifier,
  [265733] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13360), 1,
      sym_raw_string_content,
  [265740] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13362), 1,
      anon_sym_LPAREN2,
  [265747] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13364), 1,
      sym_identifier,
  [265754] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13366), 1,
      sym_raw_string_content,
  [265761] = 2,
    ACTIONS(9020), 1,
      sym_comment,
    ACTIONS(13368), 1,
      aux_sym_preproc_include_token2,
  [265768] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13370), 1,
      sym_raw_string_content,
  [265775] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8025), 1,
      anon_sym_RPAREN,
  [265782] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13372), 1,
      sym_raw_string_content,
  [265789] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8031), 1,
      anon_sym_RPAREN,
  [265796] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13374), 1,
      sym_raw_string_content,
  [265803] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8197), 1,
      anon_sym_RPAREN,
  [265810] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13376), 1,
      sym_raw_string_content,
  [265817] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13378), 1,
      anon_sym_RPAREN,
  [265824] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13380), 1,
      sym_raw_string_content,
  [265831] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13382), 1,
      anon_sym_RPAREN,
  [265838] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13384), 1,
      sym_raw_string_content,
  [265845] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13386), 1,
      anon_sym_SEMI,
  [265852] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13388), 1,
      sym_raw_string_content,
  [265859] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6463), 1,
      anon_sym_RPAREN,
  [265866] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13390), 1,
      sym_raw_string_content,
  [265873] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13392), 1,
      anon_sym_LPAREN2,
  [265880] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13394), 1,
      anon_sym_LPAREN2,
  [265887] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13396), 1,
      anon_sym_DQUOTE,
  [265894] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13398), 1,
      anon_sym_LPAREN2,
  [265901] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13400), 1,
      anon_sym_LPAREN2,
  [265908] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7957), 1,
      anon_sym_SEMI,
  [265915] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13402), 1,
      anon_sym_LPAREN2,
  [265922] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13404), 1,
      anon_sym_LPAREN2,
  [265929] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7961), 1,
      anon_sym_SEMI,
  [265936] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13406), 1,
      anon_sym_LPAREN2,
  [265943] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13408), 1,
      anon_sym_LPAREN2,
  [265950] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13410), 1,
      anon_sym_RPAREN,
  [265957] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13412), 1,
      anon_sym_LPAREN2,
  [265964] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13414), 1,
      anon_sym_LPAREN2,
  [265971] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13416), 1,
      anon_sym_RPAREN,
  [265978] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13418), 1,
      anon_sym_LPAREN2,
  [265985] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13420), 1,
      anon_sym_LPAREN2,
  [265992] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13422), 1,
      anon_sym_LPAREN2,
  [265999] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13424), 1,
      anon_sym_LPAREN2,
  [266006] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13426), 1,
      anon_sym_LPAREN2,
  [266013] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13428), 1,
      anon_sym_LPAREN2,
  [266020] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13430), 1,
      anon_sym_LPAREN2,
  [266027] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13432), 1,
      anon_sym_LPAREN2,
  [266034] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13434), 1,
      anon_sym_LPAREN2,
  [266041] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13436), 1,
      anon_sym_LPAREN2,
  [266048] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13438), 1,
      anon_sym_LPAREN2,
  [266055] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13440), 1,
      anon_sym_RPAREN,
  [266062] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13442), 1,
      anon_sym_RPAREN,
  [266069] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13444), 1,
      sym_identifier,
  [266076] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13446), 1,
      anon_sym_RPAREN,
  [266083] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13448), 1,
      sym_identifier,
  [266090] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13450), 1,
      anon_sym_LPAREN2,
  [266097] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13452), 1,
      anon_sym_LPAREN2,
  [266104] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13454), 1,
      anon_sym_LPAREN2,
  [266111] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13456), 1,
      anon_sym_LPAREN2,
  [266118] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13458), 1,
      anon_sym_LPAREN2,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(2395)] = 0,
  [SMALL_STATE(2396)] = 73,
  [SMALL_STATE(2397)] = 156,
  [SMALL_STATE(2398)] = 231,
  [SMALL_STATE(2399)] = 306,
  [SMALL_STATE(2400)] = 385,
  [SMALL_STATE(2401)] = 456,
  [SMALL_STATE(2402)] = 527,
  [SMALL_STATE(2403)] = 598,
  [SMALL_STATE(2404)] = 669,
  [SMALL_STATE(2405)] = 740,
  [SMALL_STATE(2406)] = 819,
  [SMALL_STATE(2407)] = 894,
  [SMALL_STATE(2408)] = 965,
  [SMALL_STATE(2409)] = 1038,
  [SMALL_STATE(2410)] = 1109,
  [SMALL_STATE(2411)] = 1184,
  [SMALL_STATE(2412)] = 1255,
  [SMALL_STATE(2413)] = 1326,
  [SMALL_STATE(2414)] = 1401,
  [SMALL_STATE(2415)] = 1476,
  [SMALL_STATE(2416)] = 1549,
  [SMALL_STATE(2417)] = 1620,
  [SMALL_STATE(2418)] = 1691,
  [SMALL_STATE(2419)] = 1768,
  [SMALL_STATE(2420)] = 1847,
  [SMALL_STATE(2421)] = 1918,
  [SMALL_STATE(2422)] = 1991,
  [SMALL_STATE(2423)] = 2064,
  [SMALL_STATE(2424)] = 2139,
  [SMALL_STATE(2425)] = 2216,
  [SMALL_STATE(2426)] = 2291,
  [SMALL_STATE(2427)] = 2368,
  [SMALL_STATE(2428)] = 2447,
  [SMALL_STATE(2429)] = 2522,
  [SMALL_STATE(2430)] = 2597,
  [SMALL_STATE(2431)] = 2676,
  [SMALL_STATE(2432)] = 2751,
  [SMALL_STATE(2433)] = 2822,
  [SMALL_STATE(2434)] = 2893,
  [SMALL_STATE(2435)] = 2976,
  [SMALL_STATE(2436)] = 3056,
  [SMALL_STATE(2437)] = 3126,
  [SMALL_STATE(2438)] = 3208,
  [SMALL_STATE(2439)] = 3330,
  [SMALL_STATE(2440)] = 3400,
  [SMALL_STATE(2441)] = 3484,
  [SMALL_STATE(2442)] = 3568,
  [SMALL_STATE(2443)] = 3646,
  [SMALL_STATE(2444)] = 3716,
  [SMALL_STATE(2445)] = 3786,
  [SMALL_STATE(2446)] = 3856,
  [SMALL_STATE(2447)] = 3926,
  [SMALL_STATE(2448)] = 3998,
  [SMALL_STATE(2449)] = 4068,
  [SMALL_STATE(2450)] = 4138,
  [SMALL_STATE(2451)] = 4260,
  [SMALL_STATE(2452)] = 4330,
  [SMALL_STATE(2453)] = 4404,
  [SMALL_STATE(2454)] = 4474,
  [SMALL_STATE(2455)] = 4596,
  [SMALL_STATE(2456)] = 4666,
  [SMALL_STATE(2457)] = 4736,
  [SMALL_STATE(2458)] = 4814,
  [SMALL_STATE(2459)] = 4884,
  [SMALL_STATE(2460)] = 4954,
  [SMALL_STATE(2461)] = 5024,
  [SMALL_STATE(2462)] = 5094,
  [SMALL_STATE(2463)] = 5178,
  [SMALL_STATE(2464)] = 5262,
  [SMALL_STATE(2465)] = 5346,
  [SMALL_STATE(2466)] = 5416,
  [SMALL_STATE(2467)] = 5486,
  [SMALL_STATE(2468)] = 5556,
  [SMALL_STATE(2469)] = 5626,
  [SMALL_STATE(2470)] = 5748,
  [SMALL_STATE(2471)] = 5818,
  [SMALL_STATE(2472)] = 5888,
  [SMALL_STATE(2473)] = 5958,
  [SMALL_STATE(2474)] = 6050,
  [SMALL_STATE(2475)] = 6120,
  [SMALL_STATE(2476)] = 6190,
  [SMALL_STATE(2477)] = 6268,
  [SMALL_STATE(2478)] = 6348,
  [SMALL_STATE(2479)] = 6434,
  [SMALL_STATE(2480)] = 6516,
  [SMALL_STATE(2481)] = 6608,
  [SMALL_STATE(2482)] = 6678,
  [SMALL_STATE(2483)] = 6747,
  [SMALL_STATE(2484)] = 6868,
  [SMALL_STATE(2485)] = 6947,
  [SMALL_STATE(2486)] = 7016,
  [SMALL_STATE(2487)] = 7085,
  [SMALL_STATE(2488)] = 7154,
  [SMALL_STATE(2489)] = 7223,
  [SMALL_STATE(2490)] = 7304,
  [SMALL_STATE(2491)] = 7373,
  [SMALL_STATE(2492)] = 7442,
  [SMALL_STATE(2493)] = 7511,
  [SMALL_STATE(2494)] = 7580,
  [SMALL_STATE(2495)] = 7649,
  [SMALL_STATE(2496)] = 7718,
  [SMALL_STATE(2497)] = 7787,
  [SMALL_STATE(2498)] = 7864,
  [SMALL_STATE(2499)] = 7941,
  [SMALL_STATE(2500)] = 8010,
  [SMALL_STATE(2501)] = 8079,
  [SMALL_STATE(2502)] = 8148,
  [SMALL_STATE(2503)] = 8217,
  [SMALL_STATE(2504)] = 8286,
  [SMALL_STATE(2505)] = 8355,
  [SMALL_STATE(2506)] = 8424,
  [SMALL_STATE(2507)] = 8493,
  [SMALL_STATE(2508)] = 8562,
  [SMALL_STATE(2509)] = 8631,
  [SMALL_STATE(2510)] = 8700,
  [SMALL_STATE(2511)] = 8773,
  [SMALL_STATE(2512)] = 8846,
  [SMALL_STATE(2513)] = 8919,
  [SMALL_STATE(2514)] = 8988,
  [SMALL_STATE(2515)] = 9057,
  [SMALL_STATE(2516)] = 9130,
  [SMALL_STATE(2517)] = 9199,
  [SMALL_STATE(2518)] = 9268,
  [SMALL_STATE(2519)] = 9341,
  [SMALL_STATE(2520)] = 9410,
  [SMALL_STATE(2521)] = 9479,
  [SMALL_STATE(2522)] = 9548,
  [SMALL_STATE(2523)] = 9621,
  [SMALL_STATE(2524)] = 9696,
  [SMALL_STATE(2525)] = 9765,
  [SMALL_STATE(2526)] = 9834,
  [SMALL_STATE(2527)] = 9903,
  [SMALL_STATE(2528)] = 9972,
  [SMALL_STATE(2529)] = 10045,
  [SMALL_STATE(2530)] = 10114,
  [SMALL_STATE(2531)] = 10187,
  [SMALL_STATE(2532)] = 10260,
  [SMALL_STATE(2533)] = 10333,
  [SMALL_STATE(2534)] = 10406,
  [SMALL_STATE(2535)] = 10527,
  [SMALL_STATE(2536)] = 10600,
  [SMALL_STATE(2537)] = 10669,
  [SMALL_STATE(2538)] = 10742,
  [SMALL_STATE(2539)] = 10817,
  [SMALL_STATE(2540)] = 10886,
  [SMALL_STATE(2541)] = 10955,
  [SMALL_STATE(2542)] = 11024,
  [SMALL_STATE(2543)] = 11093,
  [SMALL_STATE(2544)] = 11162,
  [SMALL_STATE(2545)] = 11231,
  [SMALL_STATE(2546)] = 11304,
  [SMALL_STATE(2547)] = 11389,
  [SMALL_STATE(2548)] = 11458,
  [SMALL_STATE(2549)] = 11527,
  [SMALL_STATE(2550)] = 11596,
  [SMALL_STATE(2551)] = 11665,
  [SMALL_STATE(2552)] = 11734,
  [SMALL_STATE(2553)] = 11803,
  [SMALL_STATE(2554)] = 11872,
  [SMALL_STATE(2555)] = 11941,
  [SMALL_STATE(2556)] = 12014,
  [SMALL_STATE(2557)] = 12089,
  [SMALL_STATE(2558)] = 12170,
  [SMALL_STATE(2559)] = 12239,
  [SMALL_STATE(2560)] = 12308,
  [SMALL_STATE(2561)] = 12377,
  [SMALL_STATE(2562)] = 12462,
  [SMALL_STATE(2563)] = 12531,
  [SMALL_STATE(2564)] = 12600,
  [SMALL_STATE(2565)] = 12669,
  [SMALL_STATE(2566)] = 12738,
  [SMALL_STATE(2567)] = 12813,
  [SMALL_STATE(2568)] = 12882,
  [SMALL_STATE(2569)] = 12951,
  [SMALL_STATE(2570)] = 13028,
  [SMALL_STATE(2571)] = 13097,
  [SMALL_STATE(2572)] = 13166,
  [SMALL_STATE(2573)] = 13235,
  [SMALL_STATE(2574)] = 13304,
  [SMALL_STATE(2575)] = 13373,
  [SMALL_STATE(2576)] = 13446,
  [SMALL_STATE(2577)] = 13515,
  [SMALL_STATE(2578)] = 13584,
  [SMALL_STATE(2579)] = 13657,
  [SMALL_STATE(2580)] = 13726,
  [SMALL_STATE(2581)] = 13795,
  [SMALL_STATE(2582)] = 13864,
  [SMALL_STATE(2583)] = 13933,
  [SMALL_STATE(2584)] = 14002,
  [SMALL_STATE(2585)] = 14075,
  [SMALL_STATE(2586)] = 14144,
  [SMALL_STATE(2587)] = 14213,
  [SMALL_STATE(2588)] = 14282,
  [SMALL_STATE(2589)] = 14351,
  [SMALL_STATE(2590)] = 14428,
  [SMALL_STATE(2591)] = 14497,
  [SMALL_STATE(2592)] = 14570,
  [SMALL_STATE(2593)] = 14643,
  [SMALL_STATE(2594)] = 14712,
  [SMALL_STATE(2595)] = 14785,
  [SMALL_STATE(2596)] = 14857,
  [SMALL_STATE(2597)] = 14941,
  [SMALL_STATE(2598)] = 15009,
  [SMALL_STATE(2599)] = 15077,
  [SMALL_STATE(2600)] = 15155,
  [SMALL_STATE(2601)] = 15231,
  [SMALL_STATE(2602)] = 15305,
  [SMALL_STATE(2603)] = 15373,
  [SMALL_STATE(2604)] = 15441,
  [SMALL_STATE(2605)] = 15509,
  [SMALL_STATE(2606)] = 15581,
  [SMALL_STATE(2607)] = 15653,
  [SMALL_STATE(2608)] = 15725,
  [SMALL_STATE(2609)] = 15799,
  [SMALL_STATE(2610)] = 15867,
  [SMALL_STATE(2611)] = 15951,
  [SMALL_STATE(2612)] = 16035,
  [SMALL_STATE(2613)] = 16107,
  [SMALL_STATE(2614)] = 16179,
  [SMALL_STATE(2615)] = 16253,
  [SMALL_STATE(2616)] = 16325,
  [SMALL_STATE(2617)] = 16409,
  [SMALL_STATE(2618)] = 16485,
  [SMALL_STATE(2619)] = 16555,
  [SMALL_STATE(2620)] = 16631,
  [SMALL_STATE(2621)] = 16703,
  [SMALL_STATE(2622)] = 16781,
  [SMALL_STATE(2623)] = 16848,
  [SMALL_STATE(2624)] = 16915,
  [SMALL_STATE(2625)] = 16986,
  [SMALL_STATE(2626)] = 17053,
  [SMALL_STATE(2627)] = 17120,
  [SMALL_STATE(2628)] = 17187,
  [SMALL_STATE(2629)] = 17254,
  [SMALL_STATE(2630)] = 17321,
  [SMALL_STATE(2631)] = 17400,
  [SMALL_STATE(2632)] = 17471,
  [SMALL_STATE(2633)] = 17538,
  [SMALL_STATE(2634)] = 17605,
  [SMALL_STATE(2635)] = 17672,
  [SMALL_STATE(2636)] = 17743,
  [SMALL_STATE(2637)] = 17814,
  [SMALL_STATE(2638)] = 17881,
  [SMALL_STATE(2639)] = 17952,
  [SMALL_STATE(2640)] = 18019,
  [SMALL_STATE(2641)] = 18086,
  [SMALL_STATE(2642)] = 18153,
  [SMALL_STATE(2643)] = 18220,
  [SMALL_STATE(2644)] = 18291,
  [SMALL_STATE(2645)] = 18358,
  [SMALL_STATE(2646)] = 18425,
  [SMALL_STATE(2647)] = 18492,
  [SMALL_STATE(2648)] = 18559,
  [SMALL_STATE(2649)] = 18630,
  [SMALL_STATE(2650)] = 18697,
  [SMALL_STATE(2651)] = 18764,
  [SMALL_STATE(2652)] = 18831,
  [SMALL_STATE(2653)] = 18898,
  [SMALL_STATE(2654)] = 18965,
  [SMALL_STATE(2655)] = 19032,
  [SMALL_STATE(2656)] = 19099,
  [SMALL_STATE(2657)] = 19166,
  [SMALL_STATE(2658)] = 19233,
  [SMALL_STATE(2659)] = 19300,
  [SMALL_STATE(2660)] = 19383,
  [SMALL_STATE(2661)] = 19454,
  [SMALL_STATE(2662)] = 19521,
  [SMALL_STATE(2663)] = 19592,
  [SMALL_STATE(2664)] = 19659,
  [SMALL_STATE(2665)] = 19726,
  [SMALL_STATE(2666)] = 19793,
  [SMALL_STATE(2667)] = 19860,
  [SMALL_STATE(2668)] = 19927,
  [SMALL_STATE(2669)] = 19994,
  [SMALL_STATE(2670)] = 20061,
  [SMALL_STATE(2671)] = 20128,
  [SMALL_STATE(2672)] = 20197,
  [SMALL_STATE(2673)] = 20266,
  [SMALL_STATE(2674)] = 20337,
  [SMALL_STATE(2675)] = 20404,
  [SMALL_STATE(2676)] = 20471,
  [SMALL_STATE(2677)] = 20538,
  [SMALL_STATE(2678)] = 20605,
  [SMALL_STATE(2679)] = 20672,
  [SMALL_STATE(2680)] = 20745,
  [SMALL_STATE(2681)] = 20812,
  [SMALL_STATE(2682)] = 20879,
  [SMALL_STATE(2683)] = 20946,
  [SMALL_STATE(2684)] = 21015,
  [SMALL_STATE(2685)] = 21082,
  [SMALL_STATE(2686)] = 21161,
  [SMALL_STATE(2687)] = 21228,
  [SMALL_STATE(2688)] = 21295,
  [SMALL_STATE(2689)] = 21362,
  [SMALL_STATE(2690)] = 21435,
  [SMALL_STATE(2691)] = 21502,
  [SMALL_STATE(2692)] = 21569,
  [SMALL_STATE(2693)] = 21638,
  [SMALL_STATE(2694)] = 21717,
  [SMALL_STATE(2695)] = 21792,
  [SMALL_STATE(2696)] = 21859,
  [SMALL_STATE(2697)] = 21926,
  [SMALL_STATE(2698)] = 21993,
  [SMALL_STATE(2699)] = 22060,
  [SMALL_STATE(2700)] = 22129,
  [SMALL_STATE(2701)] = 22196,
  [SMALL_STATE(2702)] = 22265,
  [SMALL_STATE(2703)] = 22336,
  [SMALL_STATE(2704)] = 22403,
  [SMALL_STATE(2705)] = 22470,
  [SMALL_STATE(2706)] = 22537,
  [SMALL_STATE(2707)] = 22604,
  [SMALL_STATE(2708)] = 22675,
  [SMALL_STATE(2709)] = 22743,
  [SMALL_STATE(2710)] = 22809,
  [SMALL_STATE(2711)] = 22883,
  [SMALL_STATE(2712)] = 22949,
  [SMALL_STATE(2713)] = 23023,
  [SMALL_STATE(2714)] = 23101,
  [SMALL_STATE(2715)] = 23167,
  [SMALL_STATE(2716)] = 23249,
  [SMALL_STATE(2717)] = 23319,
  [SMALL_STATE(2718)] = 23385,
  [SMALL_STATE(2719)] = 23451,
  [SMALL_STATE(2720)] = 23517,
  [SMALL_STATE(2721)] = 23595,
  [SMALL_STATE(2722)] = 23663,
  [SMALL_STATE(2723)] = 23729,
  [SMALL_STATE(2724)] = 23799,
  [SMALL_STATE(2725)] = 23865,
  [SMALL_STATE(2726)] = 23935,
  [SMALL_STATE(2727)] = 24001,
  [SMALL_STATE(2728)] = 24067,
  [SMALL_STATE(2729)] = 24137,
  [SMALL_STATE(2730)] = 24207,
  [SMALL_STATE(2731)] = 24277,
  [SMALL_STATE(2732)] = 24359,
  [SMALL_STATE(2733)] = 24425,
  [SMALL_STATE(2734)] = 24491,
  [SMALL_STATE(2735)] = 24573,
  [SMALL_STATE(2736)] = 24639,
  [SMALL_STATE(2737)] = 24705,
  [SMALL_STATE(2738)] = 24775,
  [SMALL_STATE(2739)] = 24857,
  [SMALL_STATE(2740)] = 24925,
  [SMALL_STATE(2741)] = 24991,
  [SMALL_STATE(2742)] = 25061,
  [SMALL_STATE(2743)] = 25137,
  [SMALL_STATE(2744)] = 25205,
  [SMALL_STATE(2745)] = 25273,
  [SMALL_STATE(2746)] = 25339,
  [SMALL_STATE(2747)] = 25407,
  [SMALL_STATE(2748)] = 25477,
  [SMALL_STATE(2749)] = 25543,
  [SMALL_STATE(2750)] = 25609,
  [SMALL_STATE(2751)] = 25698,
  [SMALL_STATE(2752)] = 25795,
  [SMALL_STATE(2753)] = 25860,
  [SMALL_STATE(2754)] = 25941,
  [SMALL_STATE(2755)] = 26030,
  [SMALL_STATE(2756)] = 26099,
  [SMALL_STATE(2757)] = 26164,
  [SMALL_STATE(2758)] = 26245,
  [SMALL_STATE(2759)] = 26314,
  [SMALL_STATE(2760)] = 26403,
  [SMALL_STATE(2761)] = 26472,
  [SMALL_STATE(2762)] = 26541,
  [SMALL_STATE(2763)] = 26610,
  [SMALL_STATE(2764)] = 26723,
  [SMALL_STATE(2765)] = 26788,
  [SMALL_STATE(2766)] = 26857,
  [SMALL_STATE(2767)] = 26928,
  [SMALL_STATE(2768)] = 26993,
  [SMALL_STATE(2769)] = 27062,
  [SMALL_STATE(2770)] = 27131,
  [SMALL_STATE(2771)] = 27196,
  [SMALL_STATE(2772)] = 27305,
  [SMALL_STATE(2773)] = 27374,
  [SMALL_STATE(2774)] = 27487,
  [SMALL_STATE(2775)] = 27568,
  [SMALL_STATE(2776)] = 27677,
  [SMALL_STATE(2777)] = 27764,
  [SMALL_STATE(2778)] = 27855,
  [SMALL_STATE(2779)] = 27950,
  [SMALL_STATE(2780)] = 28019,
  [SMALL_STATE(2781)] = 28088,
  [SMALL_STATE(2782)] = 28153,
  [SMALL_STATE(2783)] = 28242,
  [SMALL_STATE(2784)] = 28311,
  [SMALL_STATE(2785)] = 28376,
  [SMALL_STATE(2786)] = 28449,
  [SMALL_STATE(2787)] = 28514,
  [SMALL_STATE(2788)] = 28613,
  [SMALL_STATE(2789)] = 28714,
  [SMALL_STATE(2790)] = 28819,
  [SMALL_STATE(2791)] = 28908,
  [SMALL_STATE(2792)] = 29021,
  [SMALL_STATE(2793)] = 29130,
  [SMALL_STATE(2794)] = 29195,
  [SMALL_STATE(2795)] = 29284,
  [SMALL_STATE(2796)] = 29349,
  [SMALL_STATE(2797)] = 29430,
  [SMALL_STATE(2798)] = 29499,
  [SMALL_STATE(2799)] = 29564,
  [SMALL_STATE(2800)] = 29629,
  [SMALL_STATE(2801)] = 29694,
  [SMALL_STATE(2802)] = 29763,
  [SMALL_STATE(2803)] = 29834,
  [SMALL_STATE(2804)] = 29903,
  [SMALL_STATE(2805)] = 29992,
  [SMALL_STATE(2806)] = 30061,
  [SMALL_STATE(2807)] = 30130,
  [SMALL_STATE(2808)] = 30239,
  [SMALL_STATE(2809)] = 30320,
  [SMALL_STATE(2810)] = 30403,
  [SMALL_STATE(2811)] = 30488,
  [SMALL_STATE(2812)] = 30557,
  [SMALL_STATE(2813)] = 30626,
  [SMALL_STATE(2814)] = 30695,
  [SMALL_STATE(2815)] = 30768,
  [SMALL_STATE(2816)] = 30833,
  [SMALL_STATE(2817)] = 30897,
  [SMALL_STATE(2818)] = 30965,
  [SMALL_STATE(2819)] = 31029,
  [SMALL_STATE(2820)] = 31095,
  [SMALL_STATE(2821)] = 31161,
  [SMALL_STATE(2822)] = 31225,
  [SMALL_STATE(2823)] = 31297,
  [SMALL_STATE(2824)] = 31361,
  [SMALL_STATE(2825)] = 31425,
  [SMALL_STATE(2826)] = 31489,
  [SMALL_STATE(2827)] = 31553,
  [SMALL_STATE(2828)] = 31617,
  [SMALL_STATE(2829)] = 31681,
  [SMALL_STATE(2830)] = 31745,
  [SMALL_STATE(2831)] = 31809,
  [SMALL_STATE(2832)] = 31875,
  [SMALL_STATE(2833)] = 31941,
  [SMALL_STATE(2834)] = 32009,
  [SMALL_STATE(2835)] = 32077,
  [SMALL_STATE(2836)] = 32141,
  [SMALL_STATE(2837)] = 32205,
  [SMALL_STATE(2838)] = 32277,
  [SMALL_STATE(2839)] = 32345,
  [SMALL_STATE(2840)] = 32415,
  [SMALL_STATE(2841)] = 32483,
  [SMALL_STATE(2842)] = 32551,
  [SMALL_STATE(2843)] = 32627,
  [SMALL_STATE(2844)] = 32691,
  [SMALL_STATE(2845)] = 32799,
  [SMALL_STATE(2846)] = 32863,
  [SMALL_STATE(2847)] = 32927,
  [SMALL_STATE(2848)] = 32995,
  [SMALL_STATE(2849)] = 33063,
  [SMALL_STATE(2850)] = 33127,
  [SMALL_STATE(2851)] = 33191,
  [SMALL_STATE(2852)] = 33255,
  [SMALL_STATE(2853)] = 33319,
  [SMALL_STATE(2854)] = 33395,
  [SMALL_STATE(2855)] = 33461,
  [SMALL_STATE(2856)] = 33535,
  [SMALL_STATE(2857)] = 33603,
  [SMALL_STATE(2858)] = 33669,
  [SMALL_STATE(2859)] = 33733,
  [SMALL_STATE(2860)] = 33841,
  [SMALL_STATE(2861)] = 33905,
  [SMALL_STATE(2862)] = 33973,
  [SMALL_STATE(2863)] = 34037,
  [SMALL_STATE(2864)] = 34101,
  [SMALL_STATE(2865)] = 34169,
  [SMALL_STATE(2866)] = 34233,
  [SMALL_STATE(2867)] = 34297,
  [SMALL_STATE(2868)] = 34361,
  [SMALL_STATE(2869)] = 34427,
  [SMALL_STATE(2870)] = 34495,
  [SMALL_STATE(2871)] = 34559,
  [SMALL_STATE(2872)] = 34623,
  [SMALL_STATE(2873)] = 34691,
  [SMALL_STATE(2874)] = 34754,
  [SMALL_STATE(2875)] = 34817,
  [SMALL_STATE(2876)] = 34884,
  [SMALL_STATE(2877)] = 34965,
  [SMALL_STATE(2878)] = 35038,
  [SMALL_STATE(2879)] = 35119,
  [SMALL_STATE(2880)] = 35182,
  [SMALL_STATE(2881)] = 35255,
  [SMALL_STATE(2882)] = 35326,
  [SMALL_STATE(2883)] = 35389,
  [SMALL_STATE(2884)] = 35452,
  [SMALL_STATE(2885)] = 35531,
  [SMALL_STATE(2886)] = 35598,
  [SMALL_STATE(2887)] = 35679,
  [SMALL_STATE(2888)] = 35744,
  [SMALL_STATE(2889)] = 35807,
  [SMALL_STATE(2890)] = 35874,
  [SMALL_STATE(2891)] = 35937,
  [SMALL_STATE(2892)] = 36000,
  [SMALL_STATE(2893)] = 36065,
  [SMALL_STATE(2894)] = 36132,
  [SMALL_STATE(2895)] = 36293,
  [SMALL_STATE(2896)] = 36356,
  [SMALL_STATE(2897)] = 36419,
  [SMALL_STATE(2898)] = 36500,
  [SMALL_STATE(2899)] = 36565,
  [SMALL_STATE(2900)] = 36628,
  [SMALL_STATE(2901)] = 36691,
  [SMALL_STATE(2902)] = 36758,
  [SMALL_STATE(2903)] = 36821,
  [SMALL_STATE(2904)] = 36930,
  [SMALL_STATE(2905)] = 37043,
  [SMALL_STATE(2906)] = 37122,
  [SMALL_STATE(2907)] = 37185,
  [SMALL_STATE(2908)] = 37294,
  [SMALL_STATE(2909)] = 37357,
  [SMALL_STATE(2910)] = 37440,
  [SMALL_STATE(2911)] = 37521,
  [SMALL_STATE(2912)] = 37584,
  [SMALL_STATE(2913)] = 37665,
  [SMALL_STATE(2914)] = 37750,
  [SMALL_STATE(2915)] = 37813,
  [SMALL_STATE(2916)] = 37880,
  [SMALL_STATE(2917)] = 37993,
  [SMALL_STATE(2918)] = 38082,
  [SMALL_STATE(2919)] = 38145,
  [SMALL_STATE(2920)] = 38208,
  [SMALL_STATE(2921)] = 38275,
  [SMALL_STATE(2922)] = 38366,
  [SMALL_STATE(2923)] = 38461,
  [SMALL_STATE(2924)] = 38558,
  [SMALL_STATE(2925)] = 38621,
  [SMALL_STATE(2926)] = 38684,
  [SMALL_STATE(2927)] = 38785,
  [SMALL_STATE(2928)] = 38946,
  [SMALL_STATE(2929)] = 39051,
  [SMALL_STATE(2930)] = 39124,
  [SMALL_STATE(2931)] = 39191,
  [SMALL_STATE(2932)] = 39270,
  [SMALL_STATE(2933)] = 39341,
  [SMALL_STATE(2934)] = 39404,
  [SMALL_STATE(2935)] = 39467,
  [SMALL_STATE(2936)] = 39530,
  [SMALL_STATE(2937)] = 39603,
  [SMALL_STATE(2938)] = 39666,
  [SMALL_STATE(2939)] = 39729,
  [SMALL_STATE(2940)] = 39792,
  [SMALL_STATE(2941)] = 39871,
  [SMALL_STATE(2942)] = 39944,
  [SMALL_STATE(2943)] = 40007,
  [SMALL_STATE(2944)] = 40070,
  [SMALL_STATE(2945)] = 40133,
  [SMALL_STATE(2946)] = 40202,
  [SMALL_STATE(2947)] = 40269,
  [SMALL_STATE(2948)] = 40332,
  [SMALL_STATE(2949)] = 40395,
  [SMALL_STATE(2950)] = 40462,
  [SMALL_STATE(2951)] = 40543,
  [SMALL_STATE(2952)] = 40606,
  [SMALL_STATE(2953)] = 40669,
  [SMALL_STATE(2954)] = 40732,
  [SMALL_STATE(2955)] = 40795,
  [SMALL_STATE(2956)] = 40864,
  [SMALL_STATE(2957)] = 40927,
  [SMALL_STATE(2958)] = 40990,
  [SMALL_STATE(2959)] = 41071,
  [SMALL_STATE(2960)] = 41134,
  [SMALL_STATE(2961)] = 41295,
  [SMALL_STATE(2962)] = 41362,
  [SMALL_STATE(2963)] = 41441,
  [SMALL_STATE(2964)] = 41504,
  [SMALL_STATE(2965)] = 41567,
  [SMALL_STATE(2966)] = 41630,
  [SMALL_STATE(2967)] = 41701,
  [SMALL_STATE(2968)] = 41772,
  [SMALL_STATE(2969)] = 41835,
  [SMALL_STATE(2970)] = 41898,
  [SMALL_STATE(2971)] = 41965,
  [SMALL_STATE(2972)] = 42028,
  [SMALL_STATE(2973)] = 42141,
  [SMALL_STATE(2974)] = 42250,
  [SMALL_STATE(2975)] = 42359,
  [SMALL_STATE(2976)] = 42426,
  [SMALL_STATE(2977)] = 42488,
  [SMALL_STATE(2978)] = 42550,
  [SMALL_STATE(2979)] = 42614,
  [SMALL_STATE(2980)] = 42682,
  [SMALL_STATE(2981)] = 42744,
  [SMALL_STATE(2982)] = 42808,
  [SMALL_STATE(2983)] = 42880,
  [SMALL_STATE(2984)] = 42946,
  [SMALL_STATE(2985)] = 43018,
  [SMALL_STATE(2986)] = 43124,
  [SMALL_STATE(2987)] = 43198,
  [SMALL_STATE(2988)] = 43260,
  [SMALL_STATE(2989)] = 43328,
  [SMALL_STATE(2990)] = 43390,
  [SMALL_STATE(2991)] = 43452,
  [SMALL_STATE(2992)] = 43514,
  [SMALL_STATE(2993)] = 43578,
  [SMALL_STATE(2994)] = 43640,
  [SMALL_STATE(2995)] = 43702,
  [SMALL_STATE(2996)] = 43766,
  [SMALL_STATE(2997)] = 43828,
  [SMALL_STATE(2998)] = 43890,
  [SMALL_STATE(2999)] = 43952,
  [SMALL_STATE(3000)] = 44016,
  [SMALL_STATE(3001)] = 44078,
  [SMALL_STATE(3002)] = 44140,
  [SMALL_STATE(3003)] = 44206,
  [SMALL_STATE(3004)] = 44278,
  [SMALL_STATE(3005)] = 44340,
  [SMALL_STATE(3006)] = 44402,
  [SMALL_STATE(3007)] = 44464,
  [SMALL_STATE(3008)] = 44526,
  [SMALL_STATE(3009)] = 44590,
  [SMALL_STATE(3010)] = 44652,
  [SMALL_STATE(3011)] = 44714,
  [SMALL_STATE(3012)] = 44776,
  [SMALL_STATE(3013)] = 44838,
  [SMALL_STATE(3014)] = 44944,
  [SMALL_STATE(3015)] = 45006,
  [SMALL_STATE(3016)] = 45070,
  [SMALL_STATE(3017)] = 45134,
  [SMALL_STATE(3018)] = 45196,
  [SMALL_STATE(3019)] = 45258,
  [SMALL_STATE(3020)] = 45330,
  [SMALL_STATE(3021)] = 45392,
  [SMALL_STATE(3022)] = 45460,
  [SMALL_STATE(3023)] = 45532,
  [SMALL_STATE(3024)] = 45604,
  [SMALL_STATE(3025)] = 45666,
  [SMALL_STATE(3026)] = 45732,
  [SMALL_STATE(3027)] = 45802,
  [SMALL_STATE(3028)] = 45866,
  [SMALL_STATE(3029)] = 45928,
  [SMALL_STATE(3030)] = 46000,
  [SMALL_STATE(3031)] = 46066,
  [SMALL_STATE(3032)] = 46172,
  [SMALL_STATE(3033)] = 46248,
  [SMALL_STATE(3034)] = 46354,
  [SMALL_STATE(3035)] = 46424,
  [SMALL_STATE(3036)] = 46488,
  [SMALL_STATE(3037)] = 46554,
  [SMALL_STATE(3038)] = 46622,
  [SMALL_STATE(3039)] = 46694,
  [SMALL_STATE(3040)] = 46756,
  [SMALL_STATE(3041)] = 46822,
  [SMALL_STATE(3042)] = 46884,
  [SMALL_STATE(3043)] = 46946,
  [SMALL_STATE(3044)] = 47016,
  [SMALL_STATE(3045)] = 47078,
  [SMALL_STATE(3046)] = 47140,
  [SMALL_STATE(3047)] = 47210,
  [SMALL_STATE(3048)] = 47274,
  [SMALL_STATE(3049)] = 47338,
  [SMALL_STATE(3050)] = 47402,
  [SMALL_STATE(3051)] = 47470,
  [SMALL_STATE(3052)] = 47540,
  [SMALL_STATE(3053)] = 47606,
  [SMALL_STATE(3054)] = 47668,
  [SMALL_STATE(3055)] = 47730,
  [SMALL_STATE(3056)] = 47796,
  [SMALL_STATE(3057)] = 47858,
  [SMALL_STATE(3058)] = 47920,
  [SMALL_STATE(3059)] = 47982,
  [SMALL_STATE(3060)] = 48044,
  [SMALL_STATE(3061)] = 48106,
  [SMALL_STATE(3062)] = 48171,
  [SMALL_STATE(3063)] = 48274,
  [SMALL_STATE(3064)] = 48381,
  [SMALL_STATE(3065)] = 48456,
  [SMALL_STATE(3066)] = 48517,
  [SMALL_STATE(3067)] = 48578,
  [SMALL_STATE(3068)] = 48643,
  [SMALL_STATE(3069)] = 48712,
  [SMALL_STATE(3070)] = 48781,
  [SMALL_STATE(3071)] = 48846,
  [SMALL_STATE(3072)] = 48911,
  [SMALL_STATE(3073)] = 49018,
  [SMALL_STATE(3074)] = 49079,
  [SMALL_STATE(3075)] = 49142,
  [SMALL_STATE(3076)] = 49205,
  [SMALL_STATE(3077)] = 49272,
  [SMALL_STATE(3078)] = 49337,
  [SMALL_STATE(3079)] = 49410,
  [SMALL_STATE(3080)] = 49475,
  [SMALL_STATE(3081)] = 49536,
  [SMALL_STATE(3082)] = 49603,
  [SMALL_STATE(3083)] = 49664,
  [SMALL_STATE(3084)] = 49731,
  [SMALL_STATE(3085)] = 49796,
  [SMALL_STATE(3086)] = 49857,
  [SMALL_STATE(3087)] = 49964,
  [SMALL_STATE(3088)] = 50029,
  [SMALL_STATE(3089)] = 50090,
  [SMALL_STATE(3090)] = 50151,
  [SMALL_STATE(3091)] = 50212,
  [SMALL_STATE(3092)] = 50319,
  [SMALL_STATE(3093)] = 50384,
  [SMALL_STATE(3094)] = 50465,
  [SMALL_STATE(3095)] = 50526,
  [SMALL_STATE(3096)] = 50587,
  [SMALL_STATE(3097)] = 50676,
  [SMALL_STATE(3098)] = 50737,
  [SMALL_STATE(3099)] = 50798,
  [SMALL_STATE(3100)] = 50859,
  [SMALL_STATE(3101)] = 50920,
  [SMALL_STATE(3102)] = 50981,
  [SMALL_STATE(3103)] = 51042,
  [SMALL_STATE(3104)] = 51103,
  [SMALL_STATE(3105)] = 51182,
  [SMALL_STATE(3106)] = 51247,
  [SMALL_STATE(3107)] = 51312,
  [SMALL_STATE(3108)] = 51377,
  [SMALL_STATE(3109)] = 51460,
  [SMALL_STATE(3110)] = 51521,
  [SMALL_STATE(3111)] = 51596,
  [SMALL_STATE(3112)] = 51661,
  [SMALL_STATE(3113)] = 51726,
  [SMALL_STATE(3114)] = 51791,
  [SMALL_STATE(3115)] = 51852,
  [SMALL_STATE(3116)] = 51913,
  [SMALL_STATE(3117)] = 51978,
  [SMALL_STATE(3118)] = 52089,
  [SMALL_STATE(3119)] = 52154,
  [SMALL_STATE(3120)] = 52219,
  [SMALL_STATE(3121)] = 52330,
  [SMALL_STATE(3122)] = 52417,
  [SMALL_STATE(3123)] = 52478,
  [SMALL_STATE(3124)] = 52541,
  [SMALL_STATE(3125)] = 52606,
  [SMALL_STATE(3126)] = 52683,
  [SMALL_STATE(3127)] = 52750,
  [SMALL_STATE(3128)] = 52825,
  [SMALL_STATE(3129)] = 52886,
  [SMALL_STATE(3130)] = 52963,
  [SMALL_STATE(3131)] = 53024,
  [SMALL_STATE(3132)] = 53085,
  [SMALL_STATE(3133)] = 53184,
  [SMALL_STATE(3134)] = 53245,
  [SMALL_STATE(3135)] = 53310,
  [SMALL_STATE(3136)] = 53375,
  [SMALL_STATE(3137)] = 53482,
  [SMALL_STATE(3138)] = 53543,
  [SMALL_STATE(3139)] = 53610,
  [SMALL_STATE(3140)] = 53703,
  [SMALL_STATE(3141)] = 53798,
  [SMALL_STATE(3142)] = 53897,
  [SMALL_STATE(3143)] = 54000,
  [SMALL_STATE(3144)] = 54065,
  [SMALL_STATE(3145)] = 54140,
  [SMALL_STATE(3146)] = 54217,
  [SMALL_STATE(3147)] = 54282,
  [SMALL_STATE(3148)] = 54343,
  [SMALL_STATE(3149)] = 54404,
  [SMALL_STATE(3150)] = 54479,
  [SMALL_STATE(3151)] = 54546,
  [SMALL_STATE(3152)] = 54607,
  [SMALL_STATE(3153)] = 54668,
  [SMALL_STATE(3154)] = 54735,
  [SMALL_STATE(3155)] = 54796,
  [SMALL_STATE(3156)] = 54883,
  [SMALL_STATE(3157)] = 54944,
  [SMALL_STATE(3158)] = 55017,
  [SMALL_STATE(3159)] = 55124,
  [SMALL_STATE(3160)] = 55219,
  [SMALL_STATE(3161)] = 55312,
  [SMALL_STATE(3162)] = 55401,
  [SMALL_STATE(3163)] = 55462,
  [SMALL_STATE(3164)] = 55527,
  [SMALL_STATE(3165)] = 55592,
  [SMALL_STATE(3166)] = 55653,
  [SMALL_STATE(3167)] = 55718,
  [SMALL_STATE(3168)] = 55779,
  [SMALL_STATE(3169)] = 55840,
  [SMALL_STATE(3170)] = 55909,
  [SMALL_STATE(3171)] = 55974,
  [SMALL_STATE(3172)] = 56085,
  [SMALL_STATE(3173)] = 56192,
  [SMALL_STATE(3174)] = 56303,
  [SMALL_STATE(3175)] = 56370,
  [SMALL_STATE(3176)] = 56477,
  [SMALL_STATE(3177)] = 56560,
  [SMALL_STATE(3178)] = 56671,
  [SMALL_STATE(3179)] = 56740,
  [SMALL_STATE(3180)] = 56805,
  [SMALL_STATE(3181)] = 56866,
  [SMALL_STATE(3182)] = 56971,
  [SMALL_STATE(3183)] = 57050,
  [SMALL_STATE(3184)] = 57131,
  [SMALL_STATE(3185)] = 57192,
  [SMALL_STATE(3186)] = 57297,
  [SMALL_STATE(3187)] = 57362,
  [SMALL_STATE(3188)] = 57423,
  [SMALL_STATE(3189)] = 57490,
  [SMALL_STATE(3190)] = 57557,
  [SMALL_STATE(3191)] = 57622,
  [SMALL_STATE(3192)] = 57733,
  [SMALL_STATE(3193)] = 57798,
  [SMALL_STATE(3194)] = 57858,
  [SMALL_STATE(3195)] = 57968,
  [SMALL_STATE(3196)] = 58124,
  [SMALL_STATE(3197)] = 58230,
  [SMALL_STATE(3198)] = 58290,
  [SMALL_STATE(3199)] = 58354,
  [SMALL_STATE(3200)] = 58428,
  [SMALL_STATE(3201)] = 58494,
  [SMALL_STATE(3202)] = 58596,
  [SMALL_STATE(3203)] = 58676,
  [SMALL_STATE(3204)] = 58832,
  [SMALL_STATE(3205)] = 58900,
  [SMALL_STATE(3206)] = 58960,
  [SMALL_STATE(3207)] = 59062,
  [SMALL_STATE(3208)] = 59124,
  [SMALL_STATE(3209)] = 59194,
  [SMALL_STATE(3210)] = 59270,
  [SMALL_STATE(3211)] = 59330,
  [SMALL_STATE(3212)] = 59432,
  [SMALL_STATE(3213)] = 59588,
  [SMALL_STATE(3214)] = 59666,
  [SMALL_STATE(3215)] = 59740,
  [SMALL_STATE(3216)] = 59840,
  [SMALL_STATE(3217)] = 59936,
  [SMALL_STATE(3218)] = 60042,
  [SMALL_STATE(3219)] = 60152,
  [SMALL_STATE(3220)] = 60244,
  [SMALL_STATE(3221)] = 60334,
  [SMALL_STATE(3222)] = 60420,
  [SMALL_STATE(3223)] = 60480,
  [SMALL_STATE(3224)] = 60564,
  [SMALL_STATE(3225)] = 60646,
  [SMALL_STATE(3226)] = 60724,
  [SMALL_STATE(3227)] = 60784,
  [SMALL_STATE(3228)] = 60864,
  [SMALL_STATE(3229)] = 60924,
  [SMALL_STATE(3230)] = 60984,
  [SMALL_STATE(3231)] = 61048,
  [SMALL_STATE(3232)] = 61150,
  [SMALL_STATE(3233)] = 61214,
  [SMALL_STATE(3234)] = 61274,
  [SMALL_STATE(3235)] = 61338,
  [SMALL_STATE(3236)] = 61398,
  [SMALL_STATE(3237)] = 61480,
  [SMALL_STATE(3238)] = 61542,
  [SMALL_STATE(3239)] = 61602,
  [SMALL_STATE(3240)] = 61704,
  [SMALL_STATE(3241)] = 61764,
  [SMALL_STATE(3242)] = 61850,
  [SMALL_STATE(3243)] = 61916,
  [SMALL_STATE(3244)] = 61976,
  [SMALL_STATE(3245)] = 62078,
  [SMALL_STATE(3246)] = 62152,
  [SMALL_STATE(3247)] = 62260,
  [SMALL_STATE(3248)] = 62326,
  [SMALL_STATE(3249)] = 62434,
  [SMALL_STATE(3250)] = 62548,
  [SMALL_STATE(3251)] = 62704,
  [SMALL_STATE(3252)] = 62792,
  [SMALL_STATE(3253)] = 62948,
  [SMALL_STATE(3254)] = 63040,
  [SMALL_STATE(3255)] = 63104,
  [SMALL_STATE(3256)] = 63206,
  [SMALL_STATE(3257)] = 63308,
  [SMALL_STATE(3258)] = 63376,
  [SMALL_STATE(3259)] = 63532,
  [SMALL_STATE(3260)] = 63626,
  [SMALL_STATE(3261)] = 63686,
  [SMALL_STATE(3262)] = 63746,
  [SMALL_STATE(3263)] = 63818,
  [SMALL_STATE(3264)] = 63920,
  [SMALL_STATE(3265)] = 63980,
  [SMALL_STATE(3266)] = 64044,
  [SMALL_STATE(3267)] = 64104,
  [SMALL_STATE(3268)] = 64206,
  [SMALL_STATE(3269)] = 64266,
  [SMALL_STATE(3270)] = 64368,
  [SMALL_STATE(3271)] = 64428,
  [SMALL_STATE(3272)] = 64530,
  [SMALL_STATE(3273)] = 64628,
  [SMALL_STATE(3274)] = 64730,
  [SMALL_STATE(3275)] = 64832,
  [SMALL_STATE(3276)] = 64934,
  [SMALL_STATE(3277)] = 65036,
  [SMALL_STATE(3278)] = 65096,
  [SMALL_STATE(3279)] = 65170,
  [SMALL_STATE(3280)] = 65230,
  [SMALL_STATE(3281)] = 65290,
  [SMALL_STATE(3282)] = 65366,
  [SMALL_STATE(3283)] = 65522,
  [SMALL_STATE(3284)] = 65582,
  [SMALL_STATE(3285)] = 65642,
  [SMALL_STATE(3286)] = 65752,
  [SMALL_STATE(3287)] = 65812,
  [SMALL_STATE(3288)] = 65886,
  [SMALL_STATE(3289)] = 65988,
  [SMALL_STATE(3290)] = 66056,
  [SMALL_STATE(3291)] = 66122,
  [SMALL_STATE(3292)] = 66224,
  [SMALL_STATE(3293)] = 66286,
  [SMALL_STATE(3294)] = 66352,
  [SMALL_STATE(3295)] = 66424,
  [SMALL_STATE(3296)] = 66528,
  [SMALL_STATE(3297)] = 66588,
  [SMALL_STATE(3298)] = 66690,
  [SMALL_STATE(3299)] = 66750,
  [SMALL_STATE(3300)] = 66810,
  [SMALL_STATE(3301)] = 66916,
  [SMALL_STATE(3302)] = 67020,
  [SMALL_STATE(3303)] = 67082,
  [SMALL_STATE(3304)] = 67142,
  [SMALL_STATE(3305)] = 67210,
  [SMALL_STATE(3306)] = 67282,
  [SMALL_STATE(3307)] = 67384,
  [SMALL_STATE(3308)] = 67446,
  [SMALL_STATE(3309)] = 67508,
  [SMALL_STATE(3310)] = 67610,
  [SMALL_STATE(3311)] = 67676,
  [SMALL_STATE(3312)] = 67736,
  [SMALL_STATE(3313)] = 67838,
  [SMALL_STATE(3314)] = 67902,
  [SMALL_STATE(3315)] = 67974,
  [SMALL_STATE(3316)] = 68034,
  [SMALL_STATE(3317)] = 68110,
  [SMALL_STATE(3318)] = 68182,
  [SMALL_STATE(3319)] = 68256,
  [SMALL_STATE(3320)] = 68330,
  [SMALL_STATE(3321)] = 68390,
  [SMALL_STATE(3322)] = 68492,
  [SMALL_STATE(3323)] = 68566,
  [SMALL_STATE(3324)] = 68672,
  [SMALL_STATE(3325)] = 68742,
  [SMALL_STATE(3326)] = 68848,
  [SMALL_STATE(3327)] = 68952,
  [SMALL_STATE(3328)] = 69012,
  [SMALL_STATE(3329)] = 69086,
  [SMALL_STATE(3330)] = 69148,
  [SMALL_STATE(3331)] = 69222,
  [SMALL_STATE(3332)] = 69282,
  [SMALL_STATE(3333)] = 69342,
  [SMALL_STATE(3334)] = 69414,
  [SMALL_STATE(3335)] = 69474,
  [SMALL_STATE(3336)] = 69578,
  [SMALL_STATE(3337)] = 69734,
  [SMALL_STATE(3338)] = 69806,
  [SMALL_STATE(3339)] = 69866,
  [SMALL_STATE(3340)] = 69926,
  [SMALL_STATE(3341)] = 70028,
  [SMALL_STATE(3342)] = 70090,
  [SMALL_STATE(3343)] = 70150,
  [SMALL_STATE(3344)] = 70256,
  [SMALL_STATE(3345)] = 70316,
  [SMALL_STATE(3346)] = 70376,
  [SMALL_STATE(3347)] = 70436,
  [SMALL_STATE(3348)] = 70498,
  [SMALL_STATE(3349)] = 70558,
  [SMALL_STATE(3350)] = 70618,
  [SMALL_STATE(3351)] = 70684,
  [SMALL_STATE(3352)] = 70792,
  [SMALL_STATE(3353)] = 70948,
  [SMALL_STATE(3354)] = 71008,
  [SMALL_STATE(3355)] = 71110,
  [SMALL_STATE(3356)] = 71169,
  [SMALL_STATE(3357)] = 71236,
  [SMALL_STATE(3358)] = 71295,
  [SMALL_STATE(3359)] = 71354,
  [SMALL_STATE(3360)] = 71413,
  [SMALL_STATE(3361)] = 71518,
  [SMALL_STATE(3362)] = 71577,
  [SMALL_STATE(3363)] = 71636,
  [SMALL_STATE(3364)] = 71695,
  [SMALL_STATE(3365)] = 71754,
  [SMALL_STATE(3366)] = 71813,
  [SMALL_STATE(3367)] = 71872,
  [SMALL_STATE(3368)] = 71931,
  [SMALL_STATE(3369)] = 71990,
  [SMALL_STATE(3370)] = 72049,
  [SMALL_STATE(3371)] = 72108,
  [SMALL_STATE(3372)] = 72167,
  [SMALL_STATE(3373)] = 72226,
  [SMALL_STATE(3374)] = 72285,
  [SMALL_STATE(3375)] = 72346,
  [SMALL_STATE(3376)] = 72405,
  [SMALL_STATE(3377)] = 72510,
  [SMALL_STATE(3378)] = 72569,
  [SMALL_STATE(3379)] = 72628,
  [SMALL_STATE(3380)] = 72687,
  [SMALL_STATE(3381)] = 72746,
  [SMALL_STATE(3382)] = 72805,
  [SMALL_STATE(3383)] = 72864,
  [SMALL_STATE(3384)] = 72923,
  [SMALL_STATE(3385)] = 72982,
  [SMALL_STATE(3386)] = 73041,
  [SMALL_STATE(3387)] = 73100,
  [SMALL_STATE(3388)] = 73159,
  [SMALL_STATE(3389)] = 73218,
  [SMALL_STATE(3390)] = 73277,
  [SMALL_STATE(3391)] = 73336,
  [SMALL_STATE(3392)] = 73395,
  [SMALL_STATE(3393)] = 73454,
  [SMALL_STATE(3394)] = 73513,
  [SMALL_STATE(3395)] = 73572,
  [SMALL_STATE(3396)] = 73631,
  [SMALL_STATE(3397)] = 73698,
  [SMALL_STATE(3398)] = 73757,
  [SMALL_STATE(3399)] = 73816,
  [SMALL_STATE(3400)] = 73875,
  [SMALL_STATE(3401)] = 73934,
  [SMALL_STATE(3402)] = 73993,
  [SMALL_STATE(3403)] = 74056,
  [SMALL_STATE(3404)] = 74115,
  [SMALL_STATE(3405)] = 74174,
  [SMALL_STATE(3406)] = 74237,
  [SMALL_STATE(3407)] = 74296,
  [SMALL_STATE(3408)] = 74355,
  [SMALL_STATE(3409)] = 74414,
  [SMALL_STATE(3410)] = 74473,
  [SMALL_STATE(3411)] = 74532,
  [SMALL_STATE(3412)] = 74591,
  [SMALL_STATE(3413)] = 74654,
  [SMALL_STATE(3414)] = 74713,
  [SMALL_STATE(3415)] = 74772,
  [SMALL_STATE(3416)] = 74833,
  [SMALL_STATE(3417)] = 74894,
  [SMALL_STATE(3418)] = 74953,
  [SMALL_STATE(3419)] = 75012,
  [SMALL_STATE(3420)] = 75071,
  [SMALL_STATE(3421)] = 75130,
  [SMALL_STATE(3422)] = 75189,
  [SMALL_STATE(3423)] = 75248,
  [SMALL_STATE(3424)] = 75307,
  [SMALL_STATE(3425)] = 75370,
  [SMALL_STATE(3426)] = 75429,
  [SMALL_STATE(3427)] = 75492,
  [SMALL_STATE(3428)] = 75555,
  [SMALL_STATE(3429)] = 75616,
  [SMALL_STATE(3430)] = 75675,
  [SMALL_STATE(3431)] = 75734,
  [SMALL_STATE(3432)] = 75797,
  [SMALL_STATE(3433)] = 75856,
  [SMALL_STATE(3434)] = 75915,
  [SMALL_STATE(3435)] = 75974,
  [SMALL_STATE(3436)] = 76033,
  [SMALL_STATE(3437)] = 76092,
  [SMALL_STATE(3438)] = 76151,
  [SMALL_STATE(3439)] = 76226,
  [SMALL_STATE(3440)] = 76285,
  [SMALL_STATE(3441)] = 76348,
  [SMALL_STATE(3442)] = 76407,
  [SMALL_STATE(3443)] = 76466,
  [SMALL_STATE(3444)] = 76529,
  [SMALL_STATE(3445)] = 76598,
  [SMALL_STATE(3446)] = 76657,
  [SMALL_STATE(3447)] = 76716,
  [SMALL_STATE(3448)] = 76775,
  [SMALL_STATE(3449)] = 76834,
  [SMALL_STATE(3450)] = 76893,
  [SMALL_STATE(3451)] = 76952,
  [SMALL_STATE(3452)] = 77011,
  [SMALL_STATE(3453)] = 77070,
  [SMALL_STATE(3454)] = 77129,
  [SMALL_STATE(3455)] = 77188,
  [SMALL_STATE(3456)] = 77247,
  [SMALL_STATE(3457)] = 77306,
  [SMALL_STATE(3458)] = 77365,
  [SMALL_STATE(3459)] = 77442,
  [SMALL_STATE(3460)] = 77501,
  [SMALL_STATE(3461)] = 77560,
  [SMALL_STATE(3462)] = 77619,
  [SMALL_STATE(3463)] = 77678,
  [SMALL_STATE(3464)] = 77737,
  [SMALL_STATE(3465)] = 77800,
  [SMALL_STATE(3466)] = 77863,
  [SMALL_STATE(3467)] = 77922,
  [SMALL_STATE(3468)] = 77981,
  [SMALL_STATE(3469)] = 78040,
  [SMALL_STATE(3470)] = 78099,
  [SMALL_STATE(3471)] = 78158,
  [SMALL_STATE(3472)] = 78221,
  [SMALL_STATE(3473)] = 78280,
  [SMALL_STATE(3474)] = 78345,
  [SMALL_STATE(3475)] = 78404,
  [SMALL_STATE(3476)] = 78463,
  [SMALL_STATE(3477)] = 78522,
  [SMALL_STATE(3478)] = 78581,
  [SMALL_STATE(3479)] = 78640,
  [SMALL_STATE(3480)] = 78699,
  [SMALL_STATE(3481)] = 78758,
  [SMALL_STATE(3482)] = 78817,
  [SMALL_STATE(3483)] = 78876,
  [SMALL_STATE(3484)] = 78943,
  [SMALL_STATE(3485)] = 79002,
  [SMALL_STATE(3486)] = 79061,
  [SMALL_STATE(3487)] = 79120,
  [SMALL_STATE(3488)] = 79179,
  [SMALL_STATE(3489)] = 79238,
  [SMALL_STATE(3490)] = 79297,
  [SMALL_STATE(3491)] = 79356,
  [SMALL_STATE(3492)] = 79415,
  [SMALL_STATE(3493)] = 79474,
  [SMALL_STATE(3494)] = 79533,
  [SMALL_STATE(3495)] = 79598,
  [SMALL_STATE(3496)] = 79663,
  [SMALL_STATE(3497)] = 79732,
  [SMALL_STATE(3498)] = 79791,
  [SMALL_STATE(3499)] = 79864,
  [SMALL_STATE(3500)] = 79923,
  [SMALL_STATE(3501)] = 79982,
  [SMALL_STATE(3502)] = 80041,
  [SMALL_STATE(3503)] = 80100,
  [SMALL_STATE(3504)] = 80159,
  [SMALL_STATE(3505)] = 80218,
  [SMALL_STATE(3506)] = 80277,
  [SMALL_STATE(3507)] = 80336,
  [SMALL_STATE(3508)] = 80395,
  [SMALL_STATE(3509)] = 80454,
  [SMALL_STATE(3510)] = 80513,
  [SMALL_STATE(3511)] = 80572,
  [SMALL_STATE(3512)] = 80631,
  [SMALL_STATE(3513)] = 80690,
  [SMALL_STATE(3514)] = 80749,
  [SMALL_STATE(3515)] = 80808,
  [SMALL_STATE(3516)] = 80873,
  [SMALL_STATE(3517)] = 80932,
  [SMALL_STATE(3518)] = 80991,
  [SMALL_STATE(3519)] = 81050,
  [SMALL_STATE(3520)] = 81117,
  [SMALL_STATE(3521)] = 81176,
  [SMALL_STATE(3522)] = 81235,
  [SMALL_STATE(3523)] = 81302,
  [SMALL_STATE(3524)] = 81363,
  [SMALL_STATE(3525)] = 81422,
  [SMALL_STATE(3526)] = 81481,
  [SMALL_STATE(3527)] = 81540,
  [SMALL_STATE(3528)] = 81599,
  [SMALL_STATE(3529)] = 81658,
  [SMALL_STATE(3530)] = 81717,
  [SMALL_STATE(3531)] = 81776,
  [SMALL_STATE(3532)] = 81835,
  [SMALL_STATE(3533)] = 81894,
  [SMALL_STATE(3534)] = 81953,
  [SMALL_STATE(3535)] = 82026,
  [SMALL_STATE(3536)] = 82085,
  [SMALL_STATE(3537)] = 82144,
  [SMALL_STATE(3538)] = 82203,
  [SMALL_STATE(3539)] = 82262,
  [SMALL_STATE(3540)] = 82327,
  [SMALL_STATE(3541)] = 82386,
  [SMALL_STATE(3542)] = 82451,
  [SMALL_STATE(3543)] = 82510,
  [SMALL_STATE(3544)] = 82569,
  [SMALL_STATE(3545)] = 82628,
  [SMALL_STATE(3546)] = 82691,
  [SMALL_STATE(3547)] = 82750,
  [SMALL_STATE(3548)] = 82809,
  [SMALL_STATE(3549)] = 82867,
  [SMALL_STATE(3550)] = 82925,
  [SMALL_STATE(3551)] = 82983,
  [SMALL_STATE(3552)] = 83041,
  [SMALL_STATE(3553)] = 83099,
  [SMALL_STATE(3554)] = 83157,
  [SMALL_STATE(3555)] = 83215,
  [SMALL_STATE(3556)] = 83273,
  [SMALL_STATE(3557)] = 83331,
  [SMALL_STATE(3558)] = 83403,
  [SMALL_STATE(3559)] = 83461,
  [SMALL_STATE(3560)] = 83519,
  [SMALL_STATE(3561)] = 83581,
  [SMALL_STATE(3562)] = 83639,
  [SMALL_STATE(3563)] = 83697,
  [SMALL_STATE(3564)] = 83755,
  [SMALL_STATE(3565)] = 83813,
  [SMALL_STATE(3566)] = 83871,
  [SMALL_STATE(3567)] = 83929,
  [SMALL_STATE(3568)] = 83991,
  [SMALL_STATE(3569)] = 84049,
  [SMALL_STATE(3570)] = 84153,
  [SMALL_STATE(3571)] = 84211,
  [SMALL_STATE(3572)] = 84269,
  [SMALL_STATE(3573)] = 84327,
  [SMALL_STATE(3574)] = 84385,
  [SMALL_STATE(3575)] = 84443,
  [SMALL_STATE(3576)] = 84501,
  [SMALL_STATE(3577)] = 84559,
  [SMALL_STATE(3578)] = 84617,
  [SMALL_STATE(3579)] = 84675,
  [SMALL_STATE(3580)] = 84753,
  [SMALL_STATE(3581)] = 84815,
  [SMALL_STATE(3582)] = 84891,
  [SMALL_STATE(3583)] = 84949,
  [SMALL_STATE(3584)] = 85029,
  [SMALL_STATE(3585)] = 85087,
  [SMALL_STATE(3586)] = 85189,
  [SMALL_STATE(3587)] = 85247,
  [SMALL_STATE(3588)] = 85331,
  [SMALL_STATE(3589)] = 85401,
  [SMALL_STATE(3590)] = 85487,
  [SMALL_STATE(3591)] = 85577,
  [SMALL_STATE(3592)] = 85635,
  [SMALL_STATE(3593)] = 85693,
  [SMALL_STATE(3594)] = 85751,
  [SMALL_STATE(3595)] = 85809,
  [SMALL_STATE(3596)] = 85867,
  [SMALL_STATE(3597)] = 85961,
  [SMALL_STATE(3598)] = 86019,
  [SMALL_STATE(3599)] = 86117,
  [SMALL_STATE(3600)] = 86217,
  [SMALL_STATE(3601)] = 86275,
  [SMALL_STATE(3602)] = 86347,
  [SMALL_STATE(3603)] = 86421,
  [SMALL_STATE(3604)] = 86483,
  [SMALL_STATE(3605)] = 86545,
  [SMALL_STATE(3606)] = 86603,
  [SMALL_STATE(3607)] = 86661,
  [SMALL_STATE(3608)] = 86719,
  [SMALL_STATE(3609)] = 86791,
  [SMALL_STATE(3610)] = 86897,
  [SMALL_STATE(3611)] = 86959,
  [SMALL_STATE(3612)] = 87021,
  [SMALL_STATE(3613)] = 87079,
  [SMALL_STATE(3614)] = 87151,
  [SMALL_STATE(3615)] = 87211,
  [SMALL_STATE(3616)] = 87277,
  [SMALL_STATE(3617)] = 87343,
  [SMALL_STATE(3618)] = 87447,
  [SMALL_STATE(3619)] = 87515,
  [SMALL_STATE(3620)] = 87573,
  [SMALL_STATE(3621)] = 87675,
  [SMALL_STATE(3622)] = 87733,
  [SMALL_STATE(3623)] = 87795,
  [SMALL_STATE(3624)] = 87897,
  [SMALL_STATE(3625)] = 87955,
  [SMALL_STATE(3626)] = 88013,
  [SMALL_STATE(3627)] = 88071,
  [SMALL_STATE(3628)] = 88175,
  [SMALL_STATE(3629)] = 88245,
  [SMALL_STATE(3630)] = 88303,
  [SMALL_STATE(3631)] = 88407,
  [SMALL_STATE(3632)] = 88477,
  [SMALL_STATE(3633)] = 88535,
  [SMALL_STATE(3634)] = 88593,
  [SMALL_STATE(3635)] = 88651,
  [SMALL_STATE(3636)] = 88709,
  [SMALL_STATE(3637)] = 88767,
  [SMALL_STATE(3638)] = 88825,
  [SMALL_STATE(3639)] = 88929,
  [SMALL_STATE(3640)] = 88987,
  [SMALL_STATE(3641)] = 89053,
  [SMALL_STATE(3642)] = 89119,
  [SMALL_STATE(3643)] = 89177,
  [SMALL_STATE(3644)] = 89235,
  [SMALL_STATE(3645)] = 89293,
  [SMALL_STATE(3646)] = 89351,
  [SMALL_STATE(3647)] = 89409,
  [SMALL_STATE(3648)] = 89467,
  [SMALL_STATE(3649)] = 89525,
  [SMALL_STATE(3650)] = 89583,
  [SMALL_STATE(3651)] = 89641,
  [SMALL_STATE(3652)] = 89747,
  [SMALL_STATE(3653)] = 89805,
  [SMALL_STATE(3654)] = 89869,
  [SMALL_STATE(3655)] = 89971,
  [SMALL_STATE(3656)] = 90075,
  [SMALL_STATE(3657)] = 90133,
  [SMALL_STATE(3658)] = 90237,
  [SMALL_STATE(3659)] = 90343,
  [SMALL_STATE(3660)] = 90401,
  [SMALL_STATE(3661)] = 90459,
  [SMALL_STATE(3662)] = 90521,
  [SMALL_STATE(3663)] = 90579,
  [SMALL_STATE(3664)] = 90641,
  [SMALL_STATE(3665)] = 90705,
  [SMALL_STATE(3666)] = 90775,
  [SMALL_STATE(3667)] = 90879,
  [SMALL_STATE(3668)] = 90937,
  [SMALL_STATE(3669)] = 90999,
  [SMALL_STATE(3670)] = 91057,
  [SMALL_STATE(3671)] = 91121,
  [SMALL_STATE(3672)] = 91179,
  [SMALL_STATE(3673)] = 91237,
  [SMALL_STATE(3674)] = 91295,
  [SMALL_STATE(3675)] = 91353,
  [SMALL_STATE(3676)] = 91411,
  [SMALL_STATE(3677)] = 91469,
  [SMALL_STATE(3678)] = 91527,
  [SMALL_STATE(3679)] = 91631,
  [SMALL_STATE(3680)] = 91693,
  [SMALL_STATE(3681)] = 91751,
  [SMALL_STATE(3682)] = 91815,
  [SMALL_STATE(3683)] = 91873,
  [SMALL_STATE(3684)] = 91931,
  [SMALL_STATE(3685)] = 91989,
  [SMALL_STATE(3686)] = 92047,
  [SMALL_STATE(3687)] = 92105,
  [SMALL_STATE(3688)] = 92163,
  [SMALL_STATE(3689)] = 92221,
  [SMALL_STATE(3690)] = 92279,
  [SMALL_STATE(3691)] = 92341,
  [SMALL_STATE(3692)] = 92399,
  [SMALL_STATE(3693)] = 92460,
  [SMALL_STATE(3694)] = 92561,
  [SMALL_STATE(3695)] = 92662,
  [SMALL_STATE(3696)] = 92763,
  [SMALL_STATE(3697)] = 92864,
  [SMALL_STATE(3698)] = 92965,
  [SMALL_STATE(3699)] = 93068,
  [SMALL_STATE(3700)] = 93169,
  [SMALL_STATE(3701)] = 93270,
  [SMALL_STATE(3702)] = 93327,
  [SMALL_STATE(3703)] = 93428,
  [SMALL_STATE(3704)] = 93529,
  [SMALL_STATE(3705)] = 93586,
  [SMALL_STATE(3706)] = 93687,
  [SMALL_STATE(3707)] = 93788,
  [SMALL_STATE(3708)] = 93853,
  [SMALL_STATE(3709)] = 93954,
  [SMALL_STATE(3710)] = 94019,
  [SMALL_STATE(3711)] = 94076,
  [SMALL_STATE(3712)] = 94177,
  [SMALL_STATE(3713)] = 94278,
  [SMALL_STATE(3714)] = 94379,
  [SMALL_STATE(3715)] = 94480,
  [SMALL_STATE(3716)] = 94581,
  [SMALL_STATE(3717)] = 94638,
  [SMALL_STATE(3718)] = 94739,
  [SMALL_STATE(3719)] = 94840,
  [SMALL_STATE(3720)] = 94897,
  [SMALL_STATE(3721)] = 94998,
  [SMALL_STATE(3722)] = 95099,
  [SMALL_STATE(3723)] = 95156,
  [SMALL_STATE(3724)] = 95215,
  [SMALL_STATE(3725)] = 95316,
  [SMALL_STATE(3726)] = 95373,
  [SMALL_STATE(3727)] = 95474,
  [SMALL_STATE(3728)] = 95575,
  [SMALL_STATE(3729)] = 95676,
  [SMALL_STATE(3730)] = 95777,
  [SMALL_STATE(3731)] = 95878,
  [SMALL_STATE(3732)] = 95935,
  [SMALL_STATE(3733)] = 95992,
  [SMALL_STATE(3734)] = 96093,
  [SMALL_STATE(3735)] = 96162,
  [SMALL_STATE(3736)] = 96219,
  [SMALL_STATE(3737)] = 96320,
  [SMALL_STATE(3738)] = 96421,
  [SMALL_STATE(3739)] = 96522,
  [SMALL_STATE(3740)] = 96623,
  [SMALL_STATE(3741)] = 96724,
  [SMALL_STATE(3742)] = 96781,
  [SMALL_STATE(3743)] = 96848,
  [SMALL_STATE(3744)] = 96949,
  [SMALL_STATE(3745)] = 97018,
  [SMALL_STATE(3746)] = 97121,
  [SMALL_STATE(3747)] = 97222,
  [SMALL_STATE(3748)] = 97279,
  [SMALL_STATE(3749)] = 97380,
  [SMALL_STATE(3750)] = 97481,
  [SMALL_STATE(3751)] = 97538,
  [SMALL_STATE(3752)] = 97639,
  [SMALL_STATE(3753)] = 97740,
  [SMALL_STATE(3754)] = 97801,
  [SMALL_STATE(3755)] = 97902,
  [SMALL_STATE(3756)] = 97969,
  [SMALL_STATE(3757)] = 98070,
  [SMALL_STATE(3758)] = 98171,
  [SMALL_STATE(3759)] = 98272,
  [SMALL_STATE(3760)] = 98375,
  [SMALL_STATE(3761)] = 98476,
  [SMALL_STATE(3762)] = 98577,
  [SMALL_STATE(3763)] = 98678,
  [SMALL_STATE(3764)] = 98737,
  [SMALL_STATE(3765)] = 98838,
  [SMALL_STATE(3766)] = 98939,
  [SMALL_STATE(3767)] = 99040,
  [SMALL_STATE(3768)] = 99141,
  [SMALL_STATE(3769)] = 99242,
  [SMALL_STATE(3770)] = 99343,
  [SMALL_STATE(3771)] = 99444,
  [SMALL_STATE(3772)] = 99503,
  [SMALL_STATE(3773)] = 99604,
  [SMALL_STATE(3774)] = 99663,
  [SMALL_STATE(3775)] = 99720,
  [SMALL_STATE(3776)] = 99821,
  [SMALL_STATE(3777)] = 99922,
  [SMALL_STATE(3778)] = 99979,
  [SMALL_STATE(3779)] = 100080,
  [SMALL_STATE(3780)] = 100181,
  [SMALL_STATE(3781)] = 100240,
  [SMALL_STATE(3782)] = 100299,
  [SMALL_STATE(3783)] = 100400,
  [SMALL_STATE(3784)] = 100501,
  [SMALL_STATE(3785)] = 100604,
  [SMALL_STATE(3786)] = 100705,
  [SMALL_STATE(3787)] = 100806,
  [SMALL_STATE(3788)] = 100907,
  [SMALL_STATE(3789)] = 101008,
  [SMALL_STATE(3790)] = 101109,
  [SMALL_STATE(3791)] = 101166,
  [SMALL_STATE(3792)] = 101267,
  [SMALL_STATE(3793)] = 101368,
  [SMALL_STATE(3794)] = 101469,
  [SMALL_STATE(3795)] = 101526,
  [SMALL_STATE(3796)] = 101596,
  [SMALL_STATE(3797)] = 101654,
  [SMALL_STATE(3798)] = 101710,
  [SMALL_STATE(3799)] = 101766,
  [SMALL_STATE(3800)] = 101864,
  [SMALL_STATE(3801)] = 101920,
  [SMALL_STATE(3802)] = 101980,
  [SMALL_STATE(3803)] = 102036,
  [SMALL_STATE(3804)] = 102092,
  [SMALL_STATE(3805)] = 102156,
  [SMALL_STATE(3806)] = 102212,
  [SMALL_STATE(3807)] = 102274,
  [SMALL_STATE(3808)] = 102372,
  [SMALL_STATE(3809)] = 102428,
  [SMALL_STATE(3810)] = 102484,
  [SMALL_STATE(3811)] = 102582,
  [SMALL_STATE(3812)] = 102638,
  [SMALL_STATE(3813)] = 102710,
  [SMALL_STATE(3814)] = 102766,
  [SMALL_STATE(3815)] = 102822,
  [SMALL_STATE(3816)] = 102878,
  [SMALL_STATE(3817)] = 102950,
  [SMALL_STATE(3818)] = 103006,
  [SMALL_STATE(3819)] = 103062,
  [SMALL_STATE(3820)] = 103134,
  [SMALL_STATE(3821)] = 103190,
  [SMALL_STATE(3822)] = 103288,
  [SMALL_STATE(3823)] = 103344,
  [SMALL_STATE(3824)] = 103400,
  [SMALL_STATE(3825)] = 103456,
  [SMALL_STATE(3826)] = 103512,
  [SMALL_STATE(3827)] = 103614,
  [SMALL_STATE(3828)] = 103670,
  [SMALL_STATE(3829)] = 103726,
  [SMALL_STATE(3830)] = 103782,
  [SMALL_STATE(3831)] = 103884,
  [SMALL_STATE(3832)] = 103940,
  [SMALL_STATE(3833)] = 103996,
  [SMALL_STATE(3834)] = 104052,
  [SMALL_STATE(3835)] = 104108,
  [SMALL_STATE(3836)] = 104206,
  [SMALL_STATE(3837)] = 104262,
  [SMALL_STATE(3838)] = 104334,
  [SMALL_STATE(3839)] = 104390,
  [SMALL_STATE(3840)] = 104454,
  [SMALL_STATE(3841)] = 104510,
  [SMALL_STATE(3842)] = 104566,
  [SMALL_STATE(3843)] = 104664,
  [SMALL_STATE(3844)] = 104720,
  [SMALL_STATE(3845)] = 104818,
  [SMALL_STATE(3846)] = 104874,
  [SMALL_STATE(3847)] = 104930,
  [SMALL_STATE(3848)] = 104986,
  [SMALL_STATE(3849)] = 105042,
  [SMALL_STATE(3850)] = 105104,
  [SMALL_STATE(3851)] = 105160,
  [SMALL_STATE(3852)] = 105258,
  [SMALL_STATE(3853)] = 105356,
  [SMALL_STATE(3854)] = 105412,
  [SMALL_STATE(3855)] = 105468,
  [SMALL_STATE(3856)] = 105524,
  [SMALL_STATE(3857)] = 105580,
  [SMALL_STATE(3858)] = 105636,
  [SMALL_STATE(3859)] = 105692,
  [SMALL_STATE(3860)] = 105748,
  [SMALL_STATE(3861)] = 105818,
  [SMALL_STATE(3862)] = 105874,
  [SMALL_STATE(3863)] = 105930,
  [SMALL_STATE(3864)] = 105986,
  [SMALL_STATE(3865)] = 106042,
  [SMALL_STATE(3866)] = 106098,
  [SMALL_STATE(3867)] = 106154,
  [SMALL_STATE(3868)] = 106252,
  [SMALL_STATE(3869)] = 106322,
  [SMALL_STATE(3870)] = 106378,
  [SMALL_STATE(3871)] = 106434,
  [SMALL_STATE(3872)] = 106532,
  [SMALL_STATE(3873)] = 106588,
  [SMALL_STATE(3874)] = 106686,
  [SMALL_STATE(3875)] = 106742,
  [SMALL_STATE(3876)] = 106798,
  [SMALL_STATE(3877)] = 106854,
  [SMALL_STATE(3878)] = 106910,
  [SMALL_STATE(3879)] = 106966,
  [SMALL_STATE(3880)] = 107022,
  [SMALL_STATE(3881)] = 107078,
  [SMALL_STATE(3882)] = 107134,
  [SMALL_STATE(3883)] = 107190,
  [SMALL_STATE(3884)] = 107288,
  [SMALL_STATE(3885)] = 107386,
  [SMALL_STATE(3886)] = 107456,
  [SMALL_STATE(3887)] = 107512,
  [SMALL_STATE(3888)] = 107610,
  [SMALL_STATE(3889)] = 107666,
  [SMALL_STATE(3890)] = 107722,
  [SMALL_STATE(3891)] = 107778,
  [SMALL_STATE(3892)] = 107850,
  [SMALL_STATE(3893)] = 107906,
  [SMALL_STATE(3894)] = 107962,
  [SMALL_STATE(3895)] = 108018,
  [SMALL_STATE(3896)] = 108086,
  [SMALL_STATE(3897)] = 108142,
  [SMALL_STATE(3898)] = 108210,
  [SMALL_STATE(3899)] = 108265,
  [SMALL_STATE(3900)] = 108352,
  [SMALL_STATE(3901)] = 108411,
  [SMALL_STATE(3902)] = 108498,
  [SMALL_STATE(3903)] = 108553,
  [SMALL_STATE(3904)] = 108608,
  [SMALL_STATE(3905)] = 108663,
  [SMALL_STATE(3906)] = 108718,
  [SMALL_STATE(3907)] = 108773,
  [SMALL_STATE(3908)] = 108828,
  [SMALL_STATE(3909)] = 108883,
  [SMALL_STATE(3910)] = 108938,
  [SMALL_STATE(3911)] = 108993,
  [SMALL_STATE(3912)] = 109052,
  [SMALL_STATE(3913)] = 109107,
  [SMALL_STATE(3914)] = 109162,
  [SMALL_STATE(3915)] = 109217,
  [SMALL_STATE(3916)] = 109272,
  [SMALL_STATE(3917)] = 109335,
  [SMALL_STATE(3918)] = 109394,
  [SMALL_STATE(3919)] = 109453,
  [SMALL_STATE(3920)] = 109512,
  [SMALL_STATE(3921)] = 109567,
  [SMALL_STATE(3922)] = 109626,
  [SMALL_STATE(3923)] = 109681,
  [SMALL_STATE(3924)] = 109736,
  [SMALL_STATE(3925)] = 109795,
  [SMALL_STATE(3926)] = 109850,
  [SMALL_STATE(3927)] = 109905,
  [SMALL_STATE(3928)] = 109960,
  [SMALL_STATE(3929)] = 110015,
  [SMALL_STATE(3930)] = 110070,
  [SMALL_STATE(3931)] = 110125,
  [SMALL_STATE(3932)] = 110180,
  [SMALL_STATE(3933)] = 110267,
  [SMALL_STATE(3934)] = 110322,
  [SMALL_STATE(3935)] = 110377,
  [SMALL_STATE(3936)] = 110436,
  [SMALL_STATE(3937)] = 110495,
  [SMALL_STATE(3938)] = 110582,
  [SMALL_STATE(3939)] = 110645,
  [SMALL_STATE(3940)] = 110700,
  [SMALL_STATE(3941)] = 110755,
  [SMALL_STATE(3942)] = 110810,
  [SMALL_STATE(3943)] = 110865,
  [SMALL_STATE(3944)] = 110920,
  [SMALL_STATE(3945)] = 110983,
  [SMALL_STATE(3946)] = 111042,
  [SMALL_STATE(3947)] = 111101,
  [SMALL_STATE(3948)] = 111156,
  [SMALL_STATE(3949)] = 111213,
  [SMALL_STATE(3950)] = 111268,
  [SMALL_STATE(3951)] = 111323,
  [SMALL_STATE(3952)] = 111382,
  [SMALL_STATE(3953)] = 111437,
  [SMALL_STATE(3954)] = 111524,
  [SMALL_STATE(3955)] = 111579,
  [SMALL_STATE(3956)] = 111646,
  [SMALL_STATE(3957)] = 111705,
  [SMALL_STATE(3958)] = 111764,
  [SMALL_STATE(3959)] = 111851,
  [SMALL_STATE(3960)] = 111918,
  [SMALL_STATE(3961)] = 111976,
  [SMALL_STATE(3962)] = 112036,
  [SMALL_STATE(3963)] = 112094,
  [SMALL_STATE(3964)] = 112162,
  [SMALL_STATE(3965)] = 112262,
  [SMALL_STATE(3966)] = 112332,
  [SMALL_STATE(3967)] = 112418,
  [SMALL_STATE(3968)] = 112482,
  [SMALL_STATE(3969)] = 112542,
  [SMALL_STATE(3970)] = 112600,
  [SMALL_STATE(3971)] = 112700,
  [SMALL_STATE(3972)] = 112758,
  [SMALL_STATE(3973)] = 112818,
  [SMALL_STATE(3974)] = 112888,
  [SMALL_STATE(3975)] = 112946,
  [SMALL_STATE(3976)] = 113004,
  [SMALL_STATE(3977)] = 113062,
  [SMALL_STATE(3978)] = 113120,
  [SMALL_STATE(3979)] = 113178,
  [SMALL_STATE(3980)] = 113236,
  [SMALL_STATE(3981)] = 113336,
  [SMALL_STATE(3982)] = 113396,
  [SMALL_STATE(3983)] = 113496,
  [SMALL_STATE(3984)] = 113566,
  [SMALL_STATE(3985)] = 113624,
  [SMALL_STATE(3986)] = 113688,
  [SMALL_STATE(3987)] = 113746,
  [SMALL_STATE(3988)] = 113832,
  [SMALL_STATE(3989)] = 113902,
  [SMALL_STATE(3990)] = 113955,
  [SMALL_STATE(3991)] = 114040,
  [SMALL_STATE(3992)] = 114125,
  [SMALL_STATE(3993)] = 114210,
  [SMALL_STATE(3994)] = 114269,
  [SMALL_STATE(3995)] = 114354,
  [SMALL_STATE(3996)] = 114439,
  [SMALL_STATE(3997)] = 114498,
  [SMALL_STATE(3998)] = 114583,
  [SMALL_STATE(3999)] = 114648,
  [SMALL_STATE(4000)] = 114733,
  [SMALL_STATE(4001)] = 114818,
  [SMALL_STATE(4002)] = 114903,
  [SMALL_STATE(4003)] = 114972,
  [SMALL_STATE(4004)] = 115057,
  [SMALL_STATE(4005)] = 115142,
  [SMALL_STATE(4006)] = 115227,
  [SMALL_STATE(4007)] = 115312,
  [SMALL_STATE(4008)] = 115367,
  [SMALL_STATE(4009)] = 115420,
  [SMALL_STATE(4010)] = 115505,
  [SMALL_STATE(4011)] = 115590,
  [SMALL_STATE(4012)] = 115675,
  [SMALL_STATE(4013)] = 115760,
  [SMALL_STATE(4014)] = 115819,
  [SMALL_STATE(4015)] = 115904,
  [SMALL_STATE(4016)] = 115989,
  [SMALL_STATE(4017)] = 116074,
  [SMALL_STATE(4018)] = 116127,
  [SMALL_STATE(4019)] = 116212,
  [SMALL_STATE(4020)] = 116265,
  [SMALL_STATE(4021)] = 116350,
  [SMALL_STATE(4022)] = 116403,
  [SMALL_STATE(4023)] = 116456,
  [SMALL_STATE(4024)] = 116541,
  [SMALL_STATE(4025)] = 116626,
  [SMALL_STATE(4026)] = 116711,
  [SMALL_STATE(4027)] = 116796,
  [SMALL_STATE(4028)] = 116851,
  [SMALL_STATE(4029)] = 116904,
  [SMALL_STATE(4030)] = 116989,
  [SMALL_STATE(4031)] = 117074,
  [SMALL_STATE(4032)] = 117139,
  [SMALL_STATE(4033)] = 117194,
  [SMALL_STATE(4034)] = 117279,
  [SMALL_STATE(4035)] = 117364,
  [SMALL_STATE(4036)] = 117449,
  [SMALL_STATE(4037)] = 117508,
  [SMALL_STATE(4038)] = 117593,
  [SMALL_STATE(4039)] = 117645,
  [SMALL_STATE(4040)] = 117697,
  [SMALL_STATE(4041)] = 117749,
  [SMALL_STATE(4042)] = 117835,
  [SMALL_STATE(4043)] = 117903,
  [SMALL_STATE(4044)] = 117989,
  [SMALL_STATE(4045)] = 118041,
  [SMALL_STATE(4046)] = 118127,
  [SMALL_STATE(4047)] = 118213,
  [SMALL_STATE(4048)] = 118297,
  [SMALL_STATE(4049)] = 118383,
  [SMALL_STATE(4050)] = 118435,
  [SMALL_STATE(4051)] = 118487,
  [SMALL_STATE(4052)] = 118573,
  [SMALL_STATE(4053)] = 118651,
  [SMALL_STATE(4054)] = 118737,
  [SMALL_STATE(4055)] = 118823,
  [SMALL_STATE(4056)] = 118909,
  [SMALL_STATE(4057)] = 118995,
  [SMALL_STATE(4058)] = 119047,
  [SMALL_STATE(4059)] = 119133,
  [SMALL_STATE(4060)] = 119185,
  [SMALL_STATE(4061)] = 119237,
  [SMALL_STATE(4062)] = 119289,
  [SMALL_STATE(4063)] = 119367,
  [SMALL_STATE(4064)] = 119453,
  [SMALL_STATE(4065)] = 119521,
  [SMALL_STATE(4066)] = 119607,
  [SMALL_STATE(4067)] = 119659,
  [SMALL_STATE(4068)] = 119711,
  [SMALL_STATE(4069)] = 119763,
  [SMALL_STATE(4070)] = 119847,
  [SMALL_STATE(4071)] = 119899,
  [SMALL_STATE(4072)] = 119951,
  [SMALL_STATE(4073)] = 120003,
  [SMALL_STATE(4074)] = 120067,
  [SMALL_STATE(4075)] = 120119,
  [SMALL_STATE(4076)] = 120187,
  [SMALL_STATE(4077)] = 120273,
  [SMALL_STATE(4078)] = 120337,
  [SMALL_STATE(4079)] = 120423,
  [SMALL_STATE(4080)] = 120475,
  [SMALL_STATE(4081)] = 120527,
  [SMALL_STATE(4082)] = 120579,
  [SMALL_STATE(4083)] = 120631,
  [SMALL_STATE(4084)] = 120717,
  [SMALL_STATE(4085)] = 120769,
  [SMALL_STATE(4086)] = 120837,
  [SMALL_STATE(4087)] = 120889,
  [SMALL_STATE(4088)] = 120941,
  [SMALL_STATE(4089)] = 120993,
  [SMALL_STATE(4090)] = 121045,
  [SMALL_STATE(4091)] = 121097,
  [SMALL_STATE(4092)] = 121149,
  [SMALL_STATE(4093)] = 121201,
  [SMALL_STATE(4094)] = 121253,
  [SMALL_STATE(4095)] = 121305,
  [SMALL_STATE(4096)] = 121357,
  [SMALL_STATE(4097)] = 121409,
  [SMALL_STATE(4098)] = 121461,
  [SMALL_STATE(4099)] = 121547,
  [SMALL_STATE(4100)] = 121599,
  [SMALL_STATE(4101)] = 121659,
  [SMALL_STATE(4102)] = 121745,
  [SMALL_STATE(4103)] = 121797,
  [SMALL_STATE(4104)] = 121849,
  [SMALL_STATE(4105)] = 121901,
  [SMALL_STATE(4106)] = 121962,
  [SMALL_STATE(4107)] = 122031,
  [SMALL_STATE(4108)] = 122134,
  [SMALL_STATE(4109)] = 122205,
  [SMALL_STATE(4110)] = 122272,
  [SMALL_STATE(4111)] = 122339,
  [SMALL_STATE(4112)] = 122418,
  [SMALL_STATE(4113)] = 122509,
  [SMALL_STATE(4114)] = 122598,
  [SMALL_STATE(4115)] = 122681,
  [SMALL_STATE(4116)] = 122780,
  [SMALL_STATE(4117)] = 122865,
  [SMALL_STATE(4118)] = 122916,
  [SMALL_STATE(4119)] = 123017,
  [SMALL_STATE(4120)] = 123100,
  [SMALL_STATE(4121)] = 123151,
  [SMALL_STATE(4122)] = 123246,
  [SMALL_STATE(4123)] = 123297,
  [SMALL_STATE(4124)] = 123396,
  [SMALL_STATE(4125)] = 123459,
  [SMALL_STATE(4126)] = 123542,
  [SMALL_STATE(4127)] = 123645,
  [SMALL_STATE(4128)] = 123744,
  [SMALL_STATE(4129)] = 123847,
  [SMALL_STATE(4130)] = 123946,
  [SMALL_STATE(4131)] = 124019,
  [SMALL_STATE(4132)] = 124122,
  [SMALL_STATE(4133)] = 124197,
  [SMALL_STATE(4134)] = 124264,
  [SMALL_STATE(4135)] = 124365,
  [SMALL_STATE(4136)] = 124432,
  [SMALL_STATE(4137)] = 124527,
  [SMALL_STATE(4138)] = 124578,
  [SMALL_STATE(4139)] = 124656,
  [SMALL_STATE(4140)] = 124710,
  [SMALL_STATE(4141)] = 124772,
  [SMALL_STATE(4142)] = 124850,
  [SMALL_STATE(4143)] = 124906,
  [SMALL_STATE(4144)] = 124984,
  [SMALL_STATE(4145)] = 125040,
  [SMALL_STATE(4146)] = 125090,
  [SMALL_STATE(4147)] = 125172,
  [SMALL_STATE(4148)] = 125250,
  [SMALL_STATE(4149)] = 125300,
  [SMALL_STATE(4150)] = 125352,
  [SMALL_STATE(4151)] = 125404,
  [SMALL_STATE(4152)] = 125482,
  [SMALL_STATE(4153)] = 125538,
  [SMALL_STATE(4154)] = 125616,
  [SMALL_STATE(4155)] = 125698,
  [SMALL_STATE(4156)] = 125754,
  [SMALL_STATE(4157)] = 125810,
  [SMALL_STATE(4158)] = 125872,
  [SMALL_STATE(4159)] = 125921,
  [SMALL_STATE(4160)] = 125980,
  [SMALL_STATE(4161)] = 126049,
  [SMALL_STATE(4162)] = 126118,
  [SMALL_STATE(4163)] = 126177,
  [SMALL_STATE(4164)] = 126280,
  [SMALL_STATE(4165)] = 126329,
  [SMALL_STATE(4166)] = 126406,
  [SMALL_STATE(4167)] = 126455,
  [SMALL_STATE(4168)] = 126510,
  [SMALL_STATE(4169)] = 126567,
  [SMALL_STATE(4170)] = 126648,
  [SMALL_STATE(4171)] = 126701,
  [SMALL_STATE(4172)] = 126770,
  [SMALL_STATE(4173)] = 126823,
  [SMALL_STATE(4174)] = 126878,
  [SMALL_STATE(4175)] = 126929,
  [SMALL_STATE(4176)] = 126980,
  [SMALL_STATE(4177)] = 127039,
  [SMALL_STATE(4178)] = 127120,
  [SMALL_STATE(4179)] = 127209,
  [SMALL_STATE(4180)] = 127312,
  [SMALL_STATE(4181)] = 127371,
  [SMALL_STATE(4182)] = 127430,
  [SMALL_STATE(4183)] = 127507,
  [SMALL_STATE(4184)] = 127610,
  [SMALL_STATE(4185)] = 127661,
  [SMALL_STATE(4186)] = 127720,
  [SMALL_STATE(4187)] = 127769,
  [SMALL_STATE(4188)] = 127845,
  [SMALL_STATE(4189)] = 127923,
  [SMALL_STATE(4190)] = 128001,
  [SMALL_STATE(4191)] = 128079,
  [SMALL_STATE(4192)] = 128155,
  [SMALL_STATE(4193)] = 128209,
  [SMALL_STATE(4194)] = 128303,
  [SMALL_STATE(4195)] = 128381,
  [SMALL_STATE(4196)] = 128469,
  [SMALL_STATE(4197)] = 128549,
  [SMALL_STATE(4198)] = 128629,
  [SMALL_STATE(4199)] = 128701,
  [SMALL_STATE(4200)] = 128779,
  [SMALL_STATE(4201)] = 128869,
  [SMALL_STATE(4202)] = 128937,
  [SMALL_STATE(4203)] = 129007,
  [SMALL_STATE(4204)] = 129073,
  [SMALL_STATE(4205)] = 129151,
  [SMALL_STATE(4206)] = 129199,
  [SMALL_STATE(4207)] = 129285,
  [SMALL_STATE(4208)] = 129365,
  [SMALL_STATE(4209)] = 129459,
  [SMALL_STATE(4210)] = 129537,
  [SMALL_STATE(4211)] = 129587,
  [SMALL_STATE(4212)] = 129677,
  [SMALL_STATE(4213)] = 129757,
  [SMALL_STATE(4214)] = 129841,
  [SMALL_STATE(4215)] = 129891,
  [SMALL_STATE(4216)] = 129973,
  [SMALL_STATE(4217)] = 130063,
  [SMALL_STATE(4218)] = 130157,
  [SMALL_STATE(4219)] = 130233,
  [SMALL_STATE(4220)] = 130323,
  [SMALL_STATE(4221)] = 130401,
  [SMALL_STATE(4222)] = 130453,
  [SMALL_STATE(4223)] = 130529,
  [SMALL_STATE(4224)] = 130629,
  [SMALL_STATE(4225)] = 130707,
  [SMALL_STATE(4226)] = 130783,
  [SMALL_STATE(4227)] = 130830,
  [SMALL_STATE(4228)] = 130877,
  [SMALL_STATE(4229)] = 130974,
  [SMALL_STATE(4230)] = 131071,
  [SMALL_STATE(4231)] = 131168,
  [SMALL_STATE(4232)] = 131255,
  [SMALL_STATE(4233)] = 131352,
  [SMALL_STATE(4234)] = 131445,
  [SMALL_STATE(4235)] = 131534,
  [SMALL_STATE(4236)] = 131631,
  [SMALL_STATE(4237)] = 131728,
  [SMALL_STATE(4238)] = 131797,
  [SMALL_STATE(4239)] = 131886,
  [SMALL_STATE(4240)] = 131955,
  [SMALL_STATE(4241)] = 132052,
  [SMALL_STATE(4242)] = 132121,
  [SMALL_STATE(4243)] = 132190,
  [SMALL_STATE(4244)] = 132259,
  [SMALL_STATE(4245)] = 132348,
  [SMALL_STATE(4246)] = 132445,
  [SMALL_STATE(4247)] = 132514,
  [SMALL_STATE(4248)] = 132611,
  [SMALL_STATE(4249)] = 132708,
  [SMALL_STATE(4250)] = 132801,
  [SMALL_STATE(4251)] = 132898,
  [SMALL_STATE(4252)] = 132947,
  [SMALL_STATE(4253)] = 133026,
  [SMALL_STATE(4254)] = 133123,
  [SMALL_STATE(4255)] = 133220,
  [SMALL_STATE(4256)] = 133307,
  [SMALL_STATE(4257)] = 133402,
  [SMALL_STATE(4258)] = 133499,
  [SMALL_STATE(4259)] = 133596,
  [SMALL_STATE(4260)] = 133689,
  [SMALL_STATE(4261)] = 133786,
  [SMALL_STATE(4262)] = 133883,
  [SMALL_STATE(4263)] = 133980,
  [SMALL_STATE(4264)] = 134077,
  [SMALL_STATE(4265)] = 134146,
  [SMALL_STATE(4266)] = 134221,
  [SMALL_STATE(4267)] = 134318,
  [SMALL_STATE(4268)] = 134411,
  [SMALL_STATE(4269)] = 134478,
  [SMALL_STATE(4270)] = 134549,
  [SMALL_STATE(4271)] = 134624,
  [SMALL_STATE(4272)] = 134675,
  [SMALL_STATE(4273)] = 134752,
  [SMALL_STATE(4274)] = 134833,
  [SMALL_STATE(4275)] = 134916,
  [SMALL_STATE(4276)] = 135001,
  [SMALL_STATE(4277)] = 135088,
  [SMALL_STATE(4278)] = 135185,
  [SMALL_STATE(4279)] = 135282,
  [SMALL_STATE(4280)] = 135351,
  [SMALL_STATE(4281)] = 135448,
  [SMALL_STATE(4282)] = 135513,
  [SMALL_STATE(4283)] = 135610,
  [SMALL_STATE(4284)] = 135707,
  [SMALL_STATE(4285)] = 135776,
  [SMALL_STATE(4286)] = 135823,
  [SMALL_STATE(4287)] = 135920,
  [SMALL_STATE(4288)] = 136017,
  [SMALL_STATE(4289)] = 136114,
  [SMALL_STATE(4290)] = 136211,
  [SMALL_STATE(4291)] = 136258,
  [SMALL_STATE(4292)] = 136355,
  [SMALL_STATE(4293)] = 136452,
  [SMALL_STATE(4294)] = 136509,
  [SMALL_STATE(4295)] = 136602,
  [SMALL_STATE(4296)] = 136699,
  [SMALL_STATE(4297)] = 136796,
  [SMALL_STATE(4298)] = 136843,
  [SMALL_STATE(4299)] = 136938,
  [SMALL_STATE(4300)] = 137035,
  [SMALL_STATE(4301)] = 137082,
  [SMALL_STATE(4302)] = 137179,
  [SMALL_STATE(4303)] = 137276,
  [SMALL_STATE(4304)] = 137373,
  [SMALL_STATE(4305)] = 137420,
  [SMALL_STATE(4306)] = 137489,
  [SMALL_STATE(4307)] = 137536,
  [SMALL_STATE(4308)] = 137593,
  [SMALL_STATE(4309)] = 137690,
  [SMALL_STATE(4310)] = 137765,
  [SMALL_STATE(4311)] = 137844,
  [SMALL_STATE(4312)] = 137933,
  [SMALL_STATE(4313)] = 138030,
  [SMALL_STATE(4314)] = 138127,
  [SMALL_STATE(4315)] = 138174,
  [SMALL_STATE(4316)] = 138253,
  [SMALL_STATE(4317)] = 138306,
  [SMALL_STATE(4318)] = 138353,
  [SMALL_STATE(4319)] = 138406,
  [SMALL_STATE(4320)] = 138453,
  [SMALL_STATE(4321)] = 138532,
  [SMALL_STATE(4322)] = 138629,
  [SMALL_STATE(4323)] = 138676,
  [SMALL_STATE(4324)] = 138723,
  [SMALL_STATE(4325)] = 138820,
  [SMALL_STATE(4326)] = 138917,
  [SMALL_STATE(4327)] = 139014,
  [SMALL_STATE(4328)] = 139111,
  [SMALL_STATE(4329)] = 139208,
  [SMALL_STATE(4330)] = 139305,
  [SMALL_STATE(4331)] = 139352,
  [SMALL_STATE(4332)] = 139421,
  [SMALL_STATE(4333)] = 139490,
  [SMALL_STATE(4334)] = 139559,
  [SMALL_STATE(4335)] = 139656,
  [SMALL_STATE(4336)] = 139753,
  [SMALL_STATE(4337)] = 139800,
  [SMALL_STATE(4338)] = 139853,
  [SMALL_STATE(4339)] = 139950,
  [SMALL_STATE(4340)] = 140047,
  [SMALL_STATE(4341)] = 140100,
  [SMALL_STATE(4342)] = 140197,
  [SMALL_STATE(4343)] = 140244,
  [SMALL_STATE(4344)] = 140291,
  [SMALL_STATE(4345)] = 140361,
  [SMALL_STATE(4346)] = 140455,
  [SMALL_STATE(4347)] = 140513,
  [SMALL_STATE(4348)] = 140573,
  [SMALL_STATE(4349)] = 140667,
  [SMALL_STATE(4350)] = 140733,
  [SMALL_STATE(4351)] = 140801,
  [SMALL_STATE(4352)] = 140895,
  [SMALL_STATE(4353)] = 140943,
  [SMALL_STATE(4354)] = 141031,
  [SMALL_STATE(4355)] = 141103,
  [SMALL_STATE(4356)] = 141195,
  [SMALL_STATE(4357)] = 141289,
  [SMALL_STATE(4358)] = 141363,
  [SMALL_STATE(4359)] = 141455,
  [SMALL_STATE(4360)] = 141531,
  [SMALL_STATE(4361)] = 141611,
  [SMALL_STATE(4362)] = 141661,
  [SMALL_STATE(4363)] = 141743,
  [SMALL_STATE(4364)] = 141835,
  [SMALL_STATE(4365)] = 141883,
  [SMALL_STATE(4366)] = 141975,
  [SMALL_STATE(4367)] = 142069,
  [SMALL_STATE(4368)] = 142163,
  [SMALL_STATE(4369)] = 142255,
  [SMALL_STATE(4370)] = 142349,
  [SMALL_STATE(4371)] = 142441,
  [SMALL_STATE(4372)] = 142525,
  [SMALL_STATE(4373)] = 142611,
  [SMALL_STATE(4374)] = 142671,
  [SMALL_STATE(4375)] = 142735,
  [SMALL_STATE(4376)] = 142803,
  [SMALL_STATE(4377)] = 142897,
  [SMALL_STATE(4378)] = 142973,
  [SMALL_STATE(4379)] = 143061,
  [SMALL_STATE(4380)] = 143109,
  [SMALL_STATE(4381)] = 143203,
  [SMALL_STATE(4382)] = 143291,
  [SMALL_STATE(4383)] = 143383,
  [SMALL_STATE(4384)] = 143447,
  [SMALL_STATE(4385)] = 143539,
  [SMALL_STATE(4386)] = 143633,
  [SMALL_STATE(4387)] = 143719,
  [SMALL_STATE(4388)] = 143813,
  [SMALL_STATE(4389)] = 143897,
  [SMALL_STATE(4390)] = 143979,
  [SMALL_STATE(4391)] = 144031,
  [SMALL_STATE(4392)] = 144111,
  [SMALL_STATE(4393)] = 144185,
  [SMALL_STATE(4394)] = 144277,
  [SMALL_STATE(4395)] = 144347,
  [SMALL_STATE(4396)] = 144439,
  [SMALL_STATE(4397)] = 144491,
  [SMALL_STATE(4398)] = 144585,
  [SMALL_STATE(4399)] = 144653,
  [SMALL_STATE(4400)] = 144719,
  [SMALL_STATE(4401)] = 144807,
  [SMALL_STATE(4402)] = 144899,
  [SMALL_STATE(4403)] = 144967,
  [SMALL_STATE(4404)] = 145055,
  [SMALL_STATE(4405)] = 145147,
  [SMALL_STATE(4406)] = 145221,
  [SMALL_STATE(4407)] = 145271,
  [SMALL_STATE(4408)] = 145359,
  [SMALL_STATE(4409)] = 145451,
  [SMALL_STATE(4410)] = 145539,
  [SMALL_STATE(4411)] = 145633,
  [SMALL_STATE(4412)] = 145683,
  [SMALL_STATE(4413)] = 145769,
  [SMALL_STATE(4414)] = 145827,
  [SMALL_STATE(4415)] = 145919,
  [SMALL_STATE(4416)] = 146011,
  [SMALL_STATE(4417)] = 146099,
  [SMALL_STATE(4418)] = 146173,
  [SMALL_STATE(4419)] = 146267,
  [SMALL_STATE(4420)] = 146355,
  [SMALL_STATE(4421)] = 146449,
  [SMALL_STATE(4422)] = 146507,
  [SMALL_STATE(4423)] = 146557,
  [SMALL_STATE(4424)] = 146645,
  [SMALL_STATE(4425)] = 146697,
  [SMALL_STATE(4426)] = 146789,
  [SMALL_STATE(4427)] = 146849,
  [SMALL_STATE(4428)] = 146937,
  [SMALL_STATE(4429)] = 147005,
  [SMALL_STATE(4430)] = 147065,
  [SMALL_STATE(4431)] = 147157,
  [SMALL_STATE(4432)] = 147251,
  [SMALL_STATE(4433)] = 147343,
  [SMALL_STATE(4434)] = 147437,
  [SMALL_STATE(4435)] = 147483,
  [SMALL_STATE(4436)] = 147575,
  [SMALL_STATE(4437)] = 147669,
  [SMALL_STATE(4438)] = 147727,
  [SMALL_STATE(4439)] = 147787,
  [SMALL_STATE(4440)] = 147847,
  [SMALL_STATE(4441)] = 147905,
  [SMALL_STATE(4442)] = 147999,
  [SMALL_STATE(4443)] = 148057,
  [SMALL_STATE(4444)] = 148149,
  [SMALL_STATE(4445)] = 148195,
  [SMALL_STATE(4446)] = 148289,
  [SMALL_STATE(4447)] = 148383,
  [SMALL_STATE(4448)] = 148477,
  [SMALL_STATE(4449)] = 148571,
  [SMALL_STATE(4450)] = 148665,
  [SMALL_STATE(4451)] = 148759,
  [SMALL_STATE(4452)] = 148853,
  [SMALL_STATE(4453)] = 148947,
  [SMALL_STATE(4454)] = 149041,
  [SMALL_STATE(4455)] = 149135,
  [SMALL_STATE(4456)] = 149229,
  [SMALL_STATE(4457)] = 149279,
  [SMALL_STATE(4458)] = 149373,
  [SMALL_STATE(4459)] = 149465,
  [SMALL_STATE(4460)] = 149533,
  [SMALL_STATE(4461)] = 149599,
  [SMALL_STATE(4462)] = 149693,
  [SMALL_STATE(4463)] = 149763,
  [SMALL_STATE(4464)] = 149837,
  [SMALL_STATE(4465)] = 149913,
  [SMALL_STATE(4466)] = 149993,
  [SMALL_STATE(4467)] = 150075,
  [SMALL_STATE(4468)] = 150135,
  [SMALL_STATE(4469)] = 150191,
  [SMALL_STATE(4470)] = 150285,
  [SMALL_STATE(4471)] = 150379,
  [SMALL_STATE(4472)] = 150429,
  [SMALL_STATE(4473)] = 150513,
  [SMALL_STATE(4474)] = 150599,
  [SMALL_STATE(4475)] = 150693,
  [SMALL_STATE(4476)] = 150743,
  [SMALL_STATE(4477)] = 150837,
  [SMALL_STATE(4478)] = 150889,
  [SMALL_STATE(4479)] = 150983,
  [SMALL_STATE(4480)] = 151075,
  [SMALL_STATE(4481)] = 151125,
  [SMALL_STATE(4482)] = 151175,
  [SMALL_STATE(4483)] = 151267,
  [SMALL_STATE(4484)] = 151361,
  [SMALL_STATE(4485)] = 151449,
  [SMALL_STATE(4486)] = 151513,
  [SMALL_STATE(4487)] = 151605,
  [SMALL_STATE(4488)] = 151699,
  [SMALL_STATE(4489)] = 151791,
  [SMALL_STATE(4490)] = 151851,
  [SMALL_STATE(4491)] = 151945,
  [SMALL_STATE(4492)] = 152039,
  [SMALL_STATE(4493)] = 152133,
  [SMALL_STATE(4494)] = 152227,
  [SMALL_STATE(4495)] = 152319,
  [SMALL_STATE(4496)] = 152410,
  [SMALL_STATE(4497)] = 152479,
  [SMALL_STATE(4498)] = 152570,
  [SMALL_STATE(4499)] = 152661,
  [SMALL_STATE(4500)] = 152752,
  [SMALL_STATE(4501)] = 152843,
  [SMALL_STATE(4502)] = 152934,
  [SMALL_STATE(4503)] = 153001,
  [SMALL_STATE(4504)] = 153092,
  [SMALL_STATE(4505)] = 153161,
  [SMALL_STATE(4506)] = 153230,
  [SMALL_STATE(4507)] = 153321,
  [SMALL_STATE(4508)] = 153390,
  [SMALL_STATE(4509)] = 153481,
  [SMALL_STATE(4510)] = 153572,
  [SMALL_STATE(4511)] = 153663,
  [SMALL_STATE(4512)] = 153754,
  [SMALL_STATE(4513)] = 153845,
  [SMALL_STATE(4514)] = 153936,
  [SMALL_STATE(4515)] = 154005,
  [SMALL_STATE(4516)] = 154096,
  [SMALL_STATE(4517)] = 154177,
  [SMALL_STATE(4518)] = 154246,
  [SMALL_STATE(4519)] = 154313,
  [SMALL_STATE(4520)] = 154364,
  [SMALL_STATE(4521)] = 154455,
  [SMALL_STATE(4522)] = 154546,
  [SMALL_STATE(4523)] = 154637,
  [SMALL_STATE(4524)] = 154728,
  [SMALL_STATE(4525)] = 154819,
  [SMALL_STATE(4526)] = 154886,
  [SMALL_STATE(4527)] = 154963,
  [SMALL_STATE(4528)] = 155040,
  [SMALL_STATE(4529)] = 155109,
  [SMALL_STATE(4530)] = 155192,
  [SMALL_STATE(4531)] = 155259,
  [SMALL_STATE(4532)] = 155320,
  [SMALL_STATE(4533)] = 155411,
  [SMALL_STATE(4534)] = 155480,
  [SMALL_STATE(4535)] = 155571,
  [SMALL_STATE(4536)] = 155640,
  [SMALL_STATE(4537)] = 155731,
  [SMALL_STATE(4538)] = 155822,
  [SMALL_STATE(4539)] = 155913,
  [SMALL_STATE(4540)] = 156004,
  [SMALL_STATE(4541)] = 156095,
  [SMALL_STATE(4542)] = 156176,
  [SMALL_STATE(4543)] = 156267,
  [SMALL_STATE(4544)] = 156358,
  [SMALL_STATE(4545)] = 156427,
  [SMALL_STATE(4546)] = 156472,
  [SMALL_STATE(4547)] = 156563,
  [SMALL_STATE(4548)] = 156654,
  [SMALL_STATE(4549)] = 156745,
  [SMALL_STATE(4550)] = 156790,
  [SMALL_STATE(4551)] = 156857,
  [SMALL_STATE(4552)] = 156926,
  [SMALL_STATE(4553)] = 157017,
  [SMALL_STATE(4554)] = 157108,
  [SMALL_STATE(4555)] = 157199,
  [SMALL_STATE(4556)] = 157290,
  [SMALL_STATE(4557)] = 157381,
  [SMALL_STATE(4558)] = 157472,
  [SMALL_STATE(4559)] = 157553,
  [SMALL_STATE(4560)] = 157644,
  [SMALL_STATE(4561)] = 157735,
  [SMALL_STATE(4562)] = 157826,
  [SMALL_STATE(4563)] = 157917,
  [SMALL_STATE(4564)] = 157990,
  [SMALL_STATE(4565)] = 158081,
  [SMALL_STATE(4566)] = 158128,
  [SMALL_STATE(4567)] = 158219,
  [SMALL_STATE(4568)] = 158310,
  [SMALL_STATE(4569)] = 158379,
  [SMALL_STATE(4570)] = 158460,
  [SMALL_STATE(4571)] = 158551,
  [SMALL_STATE(4572)] = 158642,
  [SMALL_STATE(4573)] = 158733,
  [SMALL_STATE(4574)] = 158780,
  [SMALL_STATE(4575)] = 158847,
  [SMALL_STATE(4576)] = 158938,
  [SMALL_STATE(4577)] = 159029,
  [SMALL_STATE(4578)] = 159120,
  [SMALL_STATE(4579)] = 159211,
  [SMALL_STATE(4580)] = 159302,
  [SMALL_STATE(4581)] = 159371,
  [SMALL_STATE(4582)] = 159462,
  [SMALL_STATE(4583)] = 159553,
  [SMALL_STATE(4584)] = 159644,
  [SMALL_STATE(4585)] = 159735,
  [SMALL_STATE(4586)] = 159826,
  [SMALL_STATE(4587)] = 159917,
  [SMALL_STATE(4588)] = 160008,
  [SMALL_STATE(4589)] = 160077,
  [SMALL_STATE(4590)] = 160168,
  [SMALL_STATE(4591)] = 160237,
  [SMALL_STATE(4592)] = 160328,
  [SMALL_STATE(4593)] = 160419,
  [SMALL_STATE(4594)] = 160510,
  [SMALL_STATE(4595)] = 160555,
  [SMALL_STATE(4596)] = 160600,
  [SMALL_STATE(4597)] = 160669,
  [SMALL_STATE(4598)] = 160738,
  [SMALL_STATE(4599)] = 160829,
  [SMALL_STATE(4600)] = 160920,
  [SMALL_STATE(4601)] = 161011,
  [SMALL_STATE(4602)] = 161102,
  [SMALL_STATE(4603)] = 161183,
  [SMALL_STATE(4604)] = 161274,
  [SMALL_STATE(4605)] = 161343,
  [SMALL_STATE(4606)] = 161434,
  [SMALL_STATE(4607)] = 161525,
  [SMALL_STATE(4608)] = 161616,
  [SMALL_STATE(4609)] = 161707,
  [SMALL_STATE(4610)] = 161798,
  [SMALL_STATE(4611)] = 161871,
  [SMALL_STATE(4612)] = 161962,
  [SMALL_STATE(4613)] = 162043,
  [SMALL_STATE(4614)] = 162112,
  [SMALL_STATE(4615)] = 162179,
  [SMALL_STATE(4616)] = 162270,
  [SMALL_STATE(4617)] = 162361,
  [SMALL_STATE(4618)] = 162452,
  [SMALL_STATE(4619)] = 162507,
  [SMALL_STATE(4620)] = 162598,
  [SMALL_STATE(4621)] = 162689,
  [SMALL_STATE(4622)] = 162780,
  [SMALL_STATE(4623)] = 162871,
  [SMALL_STATE(4624)] = 162962,
  [SMALL_STATE(4625)] = 163053,
  [SMALL_STATE(4626)] = 163144,
  [SMALL_STATE(4627)] = 163235,
  [SMALL_STATE(4628)] = 163326,
  [SMALL_STATE(4629)] = 163375,
  [SMALL_STATE(4630)] = 163436,
  [SMALL_STATE(4631)] = 163527,
  [SMALL_STATE(4632)] = 163618,
  [SMALL_STATE(4633)] = 163709,
  [SMALL_STATE(4634)] = 163800,
  [SMALL_STATE(4635)] = 163891,
  [SMALL_STATE(4636)] = 163980,
  [SMALL_STATE(4637)] = 164049,
  [SMALL_STATE(4638)] = 164130,
  [SMALL_STATE(4639)] = 164199,
  [SMALL_STATE(4640)] = 164290,
  [SMALL_STATE(4641)] = 164339,
  [SMALL_STATE(4642)] = 164430,
  [SMALL_STATE(4643)] = 164521,
  [SMALL_STATE(4644)] = 164572,
  [SMALL_STATE(4645)] = 164663,
  [SMALL_STATE(4646)] = 164754,
  [SMALL_STATE(4647)] = 164821,
  [SMALL_STATE(4648)] = 164869,
  [SMALL_STATE(4649)] = 164913,
  [SMALL_STATE(4650)] = 164979,
  [SMALL_STATE(4651)] = 165029,
  [SMALL_STATE(4652)] = 165073,
  [SMALL_STATE(4653)] = 165117,
  [SMALL_STATE(4654)] = 165161,
  [SMALL_STATE(4655)] = 165209,
  [SMALL_STATE(4656)] = 165253,
  [SMALL_STATE(4657)] = 165335,
  [SMALL_STATE(4658)] = 165379,
  [SMALL_STATE(4659)] = 165433,
  [SMALL_STATE(4660)] = 165511,
  [SMALL_STATE(4661)] = 165555,
  [SMALL_STATE(4662)] = 165599,
  [SMALL_STATE(4663)] = 165649,
  [SMALL_STATE(4664)] = 165693,
  [SMALL_STATE(4665)] = 165737,
  [SMALL_STATE(4666)] = 165825,
  [SMALL_STATE(4667)] = 165891,
  [SMALL_STATE(4668)] = 165963,
  [SMALL_STATE(4669)] = 166007,
  [SMALL_STATE(4670)] = 166051,
  [SMALL_STATE(4671)] = 166129,
  [SMALL_STATE(4672)] = 166173,
  [SMALL_STATE(4673)] = 166219,
  [SMALL_STATE(4674)] = 166263,
  [SMALL_STATE(4675)] = 166307,
  [SMALL_STATE(4676)] = 166351,
  [SMALL_STATE(4677)] = 166395,
  [SMALL_STATE(4678)] = 166439,
  [SMALL_STATE(4679)] = 166511,
  [SMALL_STATE(4680)] = 166555,
  [SMALL_STATE(4681)] = 166633,
  [SMALL_STATE(4682)] = 166677,
  [SMALL_STATE(4683)] = 166721,
  [SMALL_STATE(4684)] = 166765,
  [SMALL_STATE(4685)] = 166809,
  [SMALL_STATE(4686)] = 166853,
  [SMALL_STATE(4687)] = 166897,
  [SMALL_STATE(4688)] = 166941,
  [SMALL_STATE(4689)] = 166985,
  [SMALL_STATE(4690)] = 167029,
  [SMALL_STATE(4691)] = 167073,
  [SMALL_STATE(4692)] = 167117,
  [SMALL_STATE(4693)] = 167161,
  [SMALL_STATE(4694)] = 167205,
  [SMALL_STATE(4695)] = 167249,
  [SMALL_STATE(4696)] = 167293,
  [SMALL_STATE(4697)] = 167337,
  [SMALL_STATE(4698)] = 167383,
  [SMALL_STATE(4699)] = 167427,
  [SMALL_STATE(4700)] = 167471,
  [SMALL_STATE(4701)] = 167515,
  [SMALL_STATE(4702)] = 167559,
  [SMALL_STATE(4703)] = 167637,
  [SMALL_STATE(4704)] = 167681,
  [SMALL_STATE(4705)] = 167725,
  [SMALL_STATE(4706)] = 167769,
  [SMALL_STATE(4707)] = 167813,
  [SMALL_STATE(4708)] = 167857,
  [SMALL_STATE(4709)] = 167903,
  [SMALL_STATE(4710)] = 167949,
  [SMALL_STATE(4711)] = 167993,
  [SMALL_STATE(4712)] = 168037,
  [SMALL_STATE(4713)] = 168081,
  [SMALL_STATE(4714)] = 168135,
  [SMALL_STATE(4715)] = 168179,
  [SMALL_STATE(4716)] = 168223,
  [SMALL_STATE(4717)] = 168271,
  [SMALL_STATE(4718)] = 168319,
  [SMALL_STATE(4719)] = 168397,
  [SMALL_STATE(4720)] = 168475,
  [SMALL_STATE(4721)] = 168553,
  [SMALL_STATE(4722)] = 168597,
  [SMALL_STATE(4723)] = 168641,
  [SMALL_STATE(4724)] = 168689,
  [SMALL_STATE(4725)] = 168771,
  [SMALL_STATE(4726)] = 168819,
  [SMALL_STATE(4727)] = 168867,
  [SMALL_STATE(4728)] = 168927,
  [SMALL_STATE(4729)] = 168971,
  [SMALL_STATE(4730)] = 169019,
  [SMALL_STATE(4731)] = 169085,
  [SMALL_STATE(4732)] = 169141,
  [SMALL_STATE(4733)] = 169207,
  [SMALL_STATE(4734)] = 169263,
  [SMALL_STATE(4735)] = 169341,
  [SMALL_STATE(4736)] = 169391,
  [SMALL_STATE(4737)] = 169476,
  [SMALL_STATE(4738)] = 169541,
  [SMALL_STATE(4739)] = 169626,
  [SMALL_STATE(4740)] = 169675,
  [SMALL_STATE(4741)] = 169740,
  [SMALL_STATE(4742)] = 169789,
  [SMALL_STATE(4743)] = 169838,
  [SMALL_STATE(4744)] = 169889,
  [SMALL_STATE(4745)] = 169960,
  [SMALL_STATE(4746)] = 170045,
  [SMALL_STATE(4747)] = 170130,
  [SMALL_STATE(4748)] = 170215,
  [SMALL_STATE(4749)] = 170300,
  [SMALL_STATE(4750)] = 170385,
  [SMALL_STATE(4751)] = 170470,
  [SMALL_STATE(4752)] = 170525,
  [SMALL_STATE(4753)] = 170576,
  [SMALL_STATE(4754)] = 170647,
  [SMALL_STATE(4755)] = 170728,
  [SMALL_STATE(4756)] = 170809,
  [SMALL_STATE(4757)] = 170858,
  [SMALL_STATE(4758)] = 170943,
  [SMALL_STATE(4759)] = 170986,
  [SMALL_STATE(4760)] = 171071,
  [SMALL_STATE(4761)] = 171156,
  [SMALL_STATE(4762)] = 171221,
  [SMALL_STATE(4763)] = 171268,
  [SMALL_STATE(4764)] = 171323,
  [SMALL_STATE(4765)] = 171372,
  [SMALL_STATE(4766)] = 171457,
  [SMALL_STATE(4767)] = 171542,
  [SMALL_STATE(4768)] = 171627,
  [SMALL_STATE(4769)] = 171674,
  [SMALL_STATE(4770)] = 171759,
  [SMALL_STATE(4771)] = 171844,
  [SMALL_STATE(4772)] = 171909,
  [SMALL_STATE(4773)] = 171958,
  [SMALL_STATE(4774)] = 172001,
  [SMALL_STATE(4775)] = 172046,
  [SMALL_STATE(4776)] = 172131,
  [SMALL_STATE(4777)] = 172216,
  [SMALL_STATE(4778)] = 172280,
  [SMALL_STATE(4779)] = 172326,
  [SMALL_STATE(4780)] = 172372,
  [SMALL_STATE(4781)] = 172442,
  [SMALL_STATE(4782)] = 172488,
  [SMALL_STATE(4783)] = 172540,
  [SMALL_STATE(4784)] = 172586,
  [SMALL_STATE(4785)] = 172632,
  [SMALL_STATE(4786)] = 172678,
  [SMALL_STATE(4787)] = 172758,
  [SMALL_STATE(4788)] = 172838,
  [SMALL_STATE(4789)] = 172918,
  [SMALL_STATE(4790)] = 172998,
  [SMALL_STATE(4791)] = 173044,
  [SMALL_STATE(4792)] = 173124,
  [SMALL_STATE(4793)] = 173204,
  [SMALL_STATE(4794)] = 173268,
  [SMALL_STATE(4795)] = 173338,
  [SMALL_STATE(4796)] = 173418,
  [SMALL_STATE(4797)] = 173464,
  [SMALL_STATE(4798)] = 173510,
  [SMALL_STATE(4799)] = 173590,
  [SMALL_STATE(4800)] = 173644,
  [SMALL_STATE(4801)] = 173694,
  [SMALL_STATE(4802)] = 173764,
  [SMALL_STATE(4803)] = 173806,
  [SMALL_STATE(4804)] = 173870,
  [SMALL_STATE(4805)] = 173940,
  [SMALL_STATE(4806)] = 173988,
  [SMALL_STATE(4807)] = 174042,
  [SMALL_STATE(4808)] = 174088,
  [SMALL_STATE(4809)] = 174152,
  [SMALL_STATE(4810)] = 174198,
  [SMALL_STATE(4811)] = 174244,
  [SMALL_STATE(4812)] = 174285,
  [SMALL_STATE(4813)] = 174364,
  [SMALL_STATE(4814)] = 174443,
  [SMALL_STATE(4815)] = 174484,
  [SMALL_STATE(4816)] = 174525,
  [SMALL_STATE(4817)] = 174566,
  [SMALL_STATE(4818)] = 174645,
  [SMALL_STATE(4819)] = 174686,
  [SMALL_STATE(4820)] = 174765,
  [SMALL_STATE(4821)] = 174844,
  [SMALL_STATE(4822)] = 174917,
  [SMALL_STATE(4823)] = 174996,
  [SMALL_STATE(4824)] = 175075,
  [SMALL_STATE(4825)] = 175116,
  [SMALL_STATE(4826)] = 175195,
  [SMALL_STATE(4827)] = 175236,
  [SMALL_STATE(4828)] = 175315,
  [SMALL_STATE(4829)] = 175388,
  [SMALL_STATE(4830)] = 175467,
  [SMALL_STATE(4831)] = 175518,
  [SMALL_STATE(4832)] = 175559,
  [SMALL_STATE(4833)] = 175638,
  [SMALL_STATE(4834)] = 175679,
  [SMALL_STATE(4835)] = 175720,
  [SMALL_STATE(4836)] = 175761,
  [SMALL_STATE(4837)] = 175802,
  [SMALL_STATE(4838)] = 175843,
  [SMALL_STATE(4839)] = 175922,
  [SMALL_STATE(4840)] = 176001,
  [SMALL_STATE(4841)] = 176080,
  [SMALL_STATE(4842)] = 176121,
  [SMALL_STATE(4843)] = 176184,
  [SMALL_STATE(4844)] = 176263,
  [SMALL_STATE(4845)] = 176304,
  [SMALL_STATE(4846)] = 176345,
  [SMALL_STATE(4847)] = 176386,
  [SMALL_STATE(4848)] = 176465,
  [SMALL_STATE(4849)] = 176508,
  [SMALL_STATE(4850)] = 176549,
  [SMALL_STATE(4851)] = 176612,
  [SMALL_STATE(4852)] = 176675,
  [SMALL_STATE(4853)] = 176716,
  [SMALL_STATE(4854)] = 176795,
  [SMALL_STATE(4855)] = 176874,
  [SMALL_STATE(4856)] = 176915,
  [SMALL_STATE(4857)] = 176978,
  [SMALL_STATE(4858)] = 177051,
  [SMALL_STATE(4859)] = 177130,
  [SMALL_STATE(4860)] = 177203,
  [SMALL_STATE(4861)] = 177282,
  [SMALL_STATE(4862)] = 177361,
  [SMALL_STATE(4863)] = 177402,
  [SMALL_STATE(4864)] = 177451,
  [SMALL_STATE(4865)] = 177530,
  [SMALL_STATE(4866)] = 177619,
  [SMALL_STATE(4867)] = 177698,
  [SMALL_STATE(4868)] = 177777,
  [SMALL_STATE(4869)] = 177856,
  [SMALL_STATE(4870)] = 177935,
  [SMALL_STATE(4871)] = 177976,
  [SMALL_STATE(4872)] = 178055,
  [SMALL_STATE(4873)] = 178134,
  [SMALL_STATE(4874)] = 178175,
  [SMALL_STATE(4875)] = 178254,
  [SMALL_STATE(4876)] = 178333,
  [SMALL_STATE(4877)] = 178374,
  [SMALL_STATE(4878)] = 178453,
  [SMALL_STATE(4879)] = 178494,
  [SMALL_STATE(4880)] = 178535,
  [SMALL_STATE(4881)] = 178614,
  [SMALL_STATE(4882)] = 178655,
  [SMALL_STATE(4883)] = 178734,
  [SMALL_STATE(4884)] = 178783,
  [SMALL_STATE(4885)] = 178862,
  [SMALL_STATE(4886)] = 178903,
  [SMALL_STATE(4887)] = 178982,
  [SMALL_STATE(4888)] = 179061,
  [SMALL_STATE(4889)] = 179102,
  [SMALL_STATE(4890)] = 179181,
  [SMALL_STATE(4891)] = 179222,
  [SMALL_STATE(4892)] = 179301,
  [SMALL_STATE(4893)] = 179380,
  [SMALL_STATE(4894)] = 179459,
  [SMALL_STATE(4895)] = 179500,
  [SMALL_STATE(4896)] = 179541,
  [SMALL_STATE(4897)] = 179582,
  [SMALL_STATE(4898)] = 179661,
  [SMALL_STATE(4899)] = 179740,
  [SMALL_STATE(4900)] = 179781,
  [SMALL_STATE(4901)] = 179822,
  [SMALL_STATE(4902)] = 179901,
  [SMALL_STATE(4903)] = 179942,
  [SMALL_STATE(4904)] = 179983,
  [SMALL_STATE(4905)] = 180027,
  [SMALL_STATE(4906)] = 180071,
  [SMALL_STATE(4907)] = 180139,
  [SMALL_STATE(4908)] = 180201,
  [SMALL_STATE(4909)] = 180251,
  [SMALL_STATE(4910)] = 180313,
  [SMALL_STATE(4911)] = 180357,
  [SMALL_STATE(4912)] = 180409,
  [SMALL_STATE(4913)] = 180481,
  [SMALL_STATE(4914)] = 180533,
  [SMALL_STATE(4915)] = 180577,
  [SMALL_STATE(4916)] = 180621,
  [SMALL_STATE(4917)] = 180683,
  [SMALL_STATE(4918)] = 180735,
  [SMALL_STATE(4919)] = 180779,
  [SMALL_STATE(4920)] = 180841,
  [SMALL_STATE(4921)] = 180903,
  [SMALL_STATE(4922)] = 180965,
  [SMALL_STATE(4923)] = 181027,
  [SMALL_STATE(4924)] = 181089,
  [SMALL_STATE(4925)] = 181151,
  [SMALL_STATE(4926)] = 181223,
  [SMALL_STATE(4927)] = 181267,
  [SMALL_STATE(4928)] = 181339,
  [SMALL_STATE(4929)] = 181383,
  [SMALL_STATE(4930)] = 181427,
  [SMALL_STATE(4931)] = 181495,
  [SMALL_STATE(4932)] = 181573,
  [SMALL_STATE(4933)] = 181635,
  [SMALL_STATE(4934)] = 181679,
  [SMALL_STATE(4935)] = 181741,
  [SMALL_STATE(4936)] = 181819,
  [SMALL_STATE(4937)] = 181867,
  [SMALL_STATE(4938)] = 181911,
  [SMALL_STATE(4939)] = 181955,
  [SMALL_STATE(4940)] = 182003,
  [SMALL_STATE(4941)] = 182055,
  [SMALL_STATE(4942)] = 182105,
  [SMALL_STATE(4943)] = 182177,
  [SMALL_STATE(4944)] = 182239,
  [SMALL_STATE(4945)] = 182278,
  [SMALL_STATE(4946)] = 182349,
  [SMALL_STATE(4947)] = 182420,
  [SMALL_STATE(4948)] = 182491,
  [SMALL_STATE(4949)] = 182562,
  [SMALL_STATE(4950)] = 182605,
  [SMALL_STATE(4951)] = 182648,
  [SMALL_STATE(4952)] = 182689,
  [SMALL_STATE(4953)] = 182732,
  [SMALL_STATE(4954)] = 182775,
  [SMALL_STATE(4955)] = 182846,
  [SMALL_STATE(4956)] = 182907,
  [SMALL_STATE(4957)] = 182950,
  [SMALL_STATE(4958)] = 183021,
  [SMALL_STATE(4959)] = 183092,
  [SMALL_STATE(4960)] = 183131,
  [SMALL_STATE(4961)] = 183202,
  [SMALL_STATE(4962)] = 183263,
  [SMALL_STATE(4963)] = 183306,
  [SMALL_STATE(4964)] = 183357,
  [SMALL_STATE(4965)] = 183400,
  [SMALL_STATE(4966)] = 183449,
  [SMALL_STATE(4967)] = 183510,
  [SMALL_STATE(4968)] = 183549,
  [SMALL_STATE(4969)] = 183594,
  [SMALL_STATE(4970)] = 183639,
  [SMALL_STATE(4971)] = 183680,
  [SMALL_STATE(4972)] = 183719,
  [SMALL_STATE(4973)] = 183762,
  [SMALL_STATE(4974)] = 183833,
  [SMALL_STATE(4975)] = 183904,
  [SMALL_STATE(4976)] = 183943,
  [SMALL_STATE(4977)] = 184014,
  [SMALL_STATE(4978)] = 184085,
  [SMALL_STATE(4979)] = 184156,
  [SMALL_STATE(4980)] = 184217,
  [SMALL_STATE(4981)] = 184288,
  [SMALL_STATE(4982)] = 184337,
  [SMALL_STATE(4983)] = 184398,
  [SMALL_STATE(4984)] = 184437,
  [SMALL_STATE(4985)] = 184508,
  [SMALL_STATE(4986)] = 184547,
  [SMALL_STATE(4987)] = 184608,
  [SMALL_STATE(4988)] = 184669,
  [SMALL_STATE(4989)] = 184730,
  [SMALL_STATE(4990)] = 184801,
  [SMALL_STATE(4991)] = 184839,
  [SMALL_STATE(4992)] = 184881,
  [SMALL_STATE(4993)] = 184919,
  [SMALL_STATE(4994)] = 184957,
  [SMALL_STATE(4995)] = 185027,
  [SMALL_STATE(4996)] = 185065,
  [SMALL_STATE(4997)] = 185103,
  [SMALL_STATE(4998)] = 185141,
  [SMALL_STATE(4999)] = 185211,
  [SMALL_STATE(5000)] = 185287,
  [SMALL_STATE(5001)] = 185357,
  [SMALL_STATE(5002)] = 185395,
  [SMALL_STATE(5003)] = 185443,
  [SMALL_STATE(5004)] = 185481,
  [SMALL_STATE(5005)] = 185519,
  [SMALL_STATE(5006)] = 185557,
  [SMALL_STATE(5007)] = 185599,
  [SMALL_STATE(5008)] = 185669,
  [SMALL_STATE(5009)] = 185707,
  [SMALL_STATE(5010)] = 185745,
  [SMALL_STATE(5011)] = 185783,
  [SMALL_STATE(5012)] = 185821,
  [SMALL_STATE(5013)] = 185859,
  [SMALL_STATE(5014)] = 185935,
  [SMALL_STATE(5015)] = 185973,
  [SMALL_STATE(5016)] = 186015,
  [SMALL_STATE(5017)] = 186053,
  [SMALL_STATE(5018)] = 186091,
  [SMALL_STATE(5019)] = 186129,
  [SMALL_STATE(5020)] = 186167,
  [SMALL_STATE(5021)] = 186205,
  [SMALL_STATE(5022)] = 186243,
  [SMALL_STATE(5023)] = 186319,
  [SMALL_STATE(5024)] = 186389,
  [SMALL_STATE(5025)] = 186465,
  [SMALL_STATE(5026)] = 186535,
  [SMALL_STATE(5027)] = 186573,
  [SMALL_STATE(5028)] = 186611,
  [SMALL_STATE(5029)] = 186649,
  [SMALL_STATE(5030)] = 186719,
  [SMALL_STATE(5031)] = 186789,
  [SMALL_STATE(5032)] = 186859,
  [SMALL_STATE(5033)] = 186929,
  [SMALL_STATE(5034)] = 186967,
  [SMALL_STATE(5035)] = 187037,
  [SMALL_STATE(5036)] = 187079,
  [SMALL_STATE(5037)] = 187121,
  [SMALL_STATE(5038)] = 187159,
  [SMALL_STATE(5039)] = 187197,
  [SMALL_STATE(5040)] = 187267,
  [SMALL_STATE(5041)] = 187337,
  [SMALL_STATE(5042)] = 187387,
  [SMALL_STATE(5043)] = 187429,
  [SMALL_STATE(5044)] = 187471,
  [SMALL_STATE(5045)] = 187509,
  [SMALL_STATE(5046)] = 187547,
  [SMALL_STATE(5047)] = 187617,
  [SMALL_STATE(5048)] = 187687,
  [SMALL_STATE(5049)] = 187725,
  [SMALL_STATE(5050)] = 187775,
  [SMALL_STATE(5051)] = 187817,
  [SMALL_STATE(5052)] = 187855,
  [SMALL_STATE(5053)] = 187897,
  [SMALL_STATE(5054)] = 187939,
  [SMALL_STATE(5055)] = 188009,
  [SMALL_STATE(5056)] = 188051,
  [SMALL_STATE(5057)] = 188093,
  [SMALL_STATE(5058)] = 188131,
  [SMALL_STATE(5059)] = 188210,
  [SMALL_STATE(5060)] = 188289,
  [SMALL_STATE(5061)] = 188368,
  [SMALL_STATE(5062)] = 188447,
  [SMALL_STATE(5063)] = 188514,
  [SMALL_STATE(5064)] = 188581,
  [SMALL_STATE(5065)] = 188648,
  [SMALL_STATE(5066)] = 188727,
  [SMALL_STATE(5067)] = 188806,
  [SMALL_STATE(5068)] = 188875,
  [SMALL_STATE(5069)] = 188942,
  [SMALL_STATE(5070)] = 189021,
  [SMALL_STATE(5071)] = 189100,
  [SMALL_STATE(5072)] = 189179,
  [SMALL_STATE(5073)] = 189258,
  [SMALL_STATE(5074)] = 189337,
  [SMALL_STATE(5075)] = 189406,
  [SMALL_STATE(5076)] = 189485,
  [SMALL_STATE(5077)] = 189564,
  [SMALL_STATE(5078)] = 189631,
  [SMALL_STATE(5079)] = 189690,
  [SMALL_STATE(5080)] = 189757,
  [SMALL_STATE(5081)] = 189824,
  [SMALL_STATE(5082)] = 189891,
  [SMALL_STATE(5083)] = 189970,
  [SMALL_STATE(5084)] = 190049,
  [SMALL_STATE(5085)] = 190128,
  [SMALL_STATE(5086)] = 190187,
  [SMALL_STATE(5087)] = 190246,
  [SMALL_STATE(5088)] = 190307,
  [SMALL_STATE(5089)] = 190366,
  [SMALL_STATE(5090)] = 190415,
  [SMALL_STATE(5091)] = 190482,
  [SMALL_STATE(5092)] = 190549,
  [SMALL_STATE(5093)] = 190616,
  [SMALL_STATE(5094)] = 190695,
  [SMALL_STATE(5095)] = 190774,
  [SMALL_STATE(5096)] = 190853,
  [SMALL_STATE(5097)] = 190920,
  [SMALL_STATE(5098)] = 190987,
  [SMALL_STATE(5099)] = 191066,
  [SMALL_STATE(5100)] = 191145,
  [SMALL_STATE(5101)] = 191224,
  [SMALL_STATE(5102)] = 191303,
  [SMALL_STATE(5103)] = 191370,
  [SMALL_STATE(5104)] = 191439,
  [SMALL_STATE(5105)] = 191518,
  [SMALL_STATE(5106)] = 191597,
  [SMALL_STATE(5107)] = 191676,
  [SMALL_STATE(5108)] = 191743,
  [SMALL_STATE(5109)] = 191812,
  [SMALL_STATE(5110)] = 191891,
  [SMALL_STATE(5111)] = 191970,
  [SMALL_STATE(5112)] = 192049,
  [SMALL_STATE(5113)] = 192128,
  [SMALL_STATE(5114)] = 192207,
  [SMALL_STATE(5115)] = 192286,
  [SMALL_STATE(5116)] = 192353,
  [SMALL_STATE(5117)] = 192432,
  [SMALL_STATE(5118)] = 192511,
  [SMALL_STATE(5119)] = 192590,
  [SMALL_STATE(5120)] = 192669,
  [SMALL_STATE(5121)] = 192748,
  [SMALL_STATE(5122)] = 192827,
  [SMALL_STATE(5123)] = 192894,
  [SMALL_STATE(5124)] = 192955,
  [SMALL_STATE(5125)] = 193034,
  [SMALL_STATE(5126)] = 193113,
  [SMALL_STATE(5127)] = 193180,
  [SMALL_STATE(5128)] = 193259,
  [SMALL_STATE(5129)] = 193326,
  [SMALL_STATE(5130)] = 193405,
  [SMALL_STATE(5131)] = 193472,
  [SMALL_STATE(5132)] = 193551,
  [SMALL_STATE(5133)] = 193630,
  [SMALL_STATE(5134)] = 193709,
  [SMALL_STATE(5135)] = 193788,
  [SMALL_STATE(5136)] = 193867,
  [SMALL_STATE(5137)] = 193934,
  [SMALL_STATE(5138)] = 194013,
  [SMALL_STATE(5139)] = 194080,
  [SMALL_STATE(5140)] = 194159,
  [SMALL_STATE(5141)] = 194238,
  [SMALL_STATE(5142)] = 194317,
  [SMALL_STATE(5143)] = 194396,
  [SMALL_STATE(5144)] = 194475,
  [SMALL_STATE(5145)] = 194554,
  [SMALL_STATE(5146)] = 194633,
  [SMALL_STATE(5147)] = 194712,
  [SMALL_STATE(5148)] = 194791,
  [SMALL_STATE(5149)] = 194858,
  [SMALL_STATE(5150)] = 194937,
  [SMALL_STATE(5151)] = 194978,
  [SMALL_STATE(5152)] = 195045,
  [SMALL_STATE(5153)] = 195124,
  [SMALL_STATE(5154)] = 195185,
  [SMALL_STATE(5155)] = 195264,
  [SMALL_STATE(5156)] = 195343,
  [SMALL_STATE(5157)] = 195422,
  [SMALL_STATE(5158)] = 195489,
  [SMALL_STATE(5159)] = 195568,
  [SMALL_STATE(5160)] = 195635,
  [SMALL_STATE(5161)] = 195702,
  [SMALL_STATE(5162)] = 195781,
  [SMALL_STATE(5163)] = 195860,
  [SMALL_STATE(5164)] = 195939,
  [SMALL_STATE(5165)] = 196018,
  [SMALL_STATE(5166)] = 196097,
  [SMALL_STATE(5167)] = 196158,
  [SMALL_STATE(5168)] = 196237,
  [SMALL_STATE(5169)] = 196316,
  [SMALL_STATE(5170)] = 196395,
  [SMALL_STATE(5171)] = 196474,
  [SMALL_STATE(5172)] = 196553,
  [SMALL_STATE(5173)] = 196632,
  [SMALL_STATE(5174)] = 196711,
  [SMALL_STATE(5175)] = 196773,
  [SMALL_STATE(5176)] = 196849,
  [SMALL_STATE(5177)] = 196925,
  [SMALL_STATE(5178)] = 196987,
  [SMALL_STATE(5179)] = 197063,
  [SMALL_STATE(5180)] = 197139,
  [SMALL_STATE(5181)] = 197215,
  [SMALL_STATE(5182)] = 197291,
  [SMALL_STATE(5183)] = 197367,
  [SMALL_STATE(5184)] = 197443,
  [SMALL_STATE(5185)] = 197519,
  [SMALL_STATE(5186)] = 197595,
  [SMALL_STATE(5187)] = 197671,
  [SMALL_STATE(5188)] = 197733,
  [SMALL_STATE(5189)] = 197809,
  [SMALL_STATE(5190)] = 197871,
  [SMALL_STATE(5191)] = 197947,
  [SMALL_STATE(5192)] = 198023,
  [SMALL_STATE(5193)] = 198063,
  [SMALL_STATE(5194)] = 198103,
  [SMALL_STATE(5195)] = 198179,
  [SMALL_STATE(5196)] = 198219,
  [SMALL_STATE(5197)] = 198295,
  [SMALL_STATE(5198)] = 198371,
  [SMALL_STATE(5199)] = 198433,
  [SMALL_STATE(5200)] = 198509,
  [SMALL_STATE(5201)] = 198571,
  [SMALL_STATE(5202)] = 198606,
  [SMALL_STATE(5203)] = 198673,
  [SMALL_STATE(5204)] = 198734,
  [SMALL_STATE(5205)] = 198801,
  [SMALL_STATE(5206)] = 198868,
  [SMALL_STATE(5207)] = 198935,
  [SMALL_STATE(5208)] = 199002,
  [SMALL_STATE(5209)] = 199063,
  [SMALL_STATE(5210)] = 199098,
  [SMALL_STATE(5211)] = 199159,
  [SMALL_STATE(5212)] = 199226,
  [SMALL_STATE(5213)] = 199287,
  [SMALL_STATE(5214)] = 199354,
  [SMALL_STATE(5215)] = 199421,
  [SMALL_STATE(5216)] = 199482,
  [SMALL_STATE(5217)] = 199543,
  [SMALL_STATE(5218)] = 199603,
  [SMALL_STATE(5219)] = 199663,
  [SMALL_STATE(5220)] = 199723,
  [SMALL_STATE(5221)] = 199783,
  [SMALL_STATE(5222)] = 199843,
  [SMALL_STATE(5223)] = 199903,
  [SMALL_STATE(5224)] = 199963,
  [SMALL_STATE(5225)] = 200023,
  [SMALL_STATE(5226)] = 200083,
  [SMALL_STATE(5227)] = 200143,
  [SMALL_STATE(5228)] = 200203,
  [SMALL_STATE(5229)] = 200241,
  [SMALL_STATE(5230)] = 200301,
  [SMALL_STATE(5231)] = 200361,
  [SMALL_STATE(5232)] = 200421,
  [SMALL_STATE(5233)] = 200481,
  [SMALL_STATE(5234)] = 200541,
  [SMALL_STATE(5235)] = 200601,
  [SMALL_STATE(5236)] = 200661,
  [SMALL_STATE(5237)] = 200721,
  [SMALL_STATE(5238)] = 200781,
  [SMALL_STATE(5239)] = 200841,
  [SMALL_STATE(5240)] = 200901,
  [SMALL_STATE(5241)] = 200961,
  [SMALL_STATE(5242)] = 201021,
  [SMALL_STATE(5243)] = 201080,
  [SMALL_STATE(5244)] = 201139,
  [SMALL_STATE(5245)] = 201198,
  [SMALL_STATE(5246)] = 201257,
  [SMALL_STATE(5247)] = 201316,
  [SMALL_STATE(5248)] = 201375,
  [SMALL_STATE(5249)] = 201434,
  [SMALL_STATE(5250)] = 201495,
  [SMALL_STATE(5251)] = 201554,
  [SMALL_STATE(5252)] = 201615,
  [SMALL_STATE(5253)] = 201676,
  [SMALL_STATE(5254)] = 201711,
  [SMALL_STATE(5255)] = 201770,
  [SMALL_STATE(5256)] = 201829,
  [SMALL_STATE(5257)] = 201890,
  [SMALL_STATE(5258)] = 201949,
  [SMALL_STATE(5259)] = 202008,
  [SMALL_STATE(5260)] = 202069,
  [SMALL_STATE(5261)] = 202130,
  [SMALL_STATE(5262)] = 202191,
  [SMALL_STATE(5263)] = 202239,
  [SMALL_STATE(5264)] = 202277,
  [SMALL_STATE(5265)] = 202335,
  [SMALL_STATE(5266)] = 202383,
  [SMALL_STATE(5267)] = 202441,
  [SMALL_STATE(5268)] = 202499,
  [SMALL_STATE(5269)] = 202547,
  [SMALL_STATE(5270)] = 202605,
  [SMALL_STATE(5271)] = 202659,
  [SMALL_STATE(5272)] = 202717,
  [SMALL_STATE(5273)] = 202775,
  [SMALL_STATE(5274)] = 202822,
  [SMALL_STATE(5275)] = 202875,
  [SMALL_STATE(5276)] = 202928,
  [SMALL_STATE(5277)] = 202981,
  [SMALL_STATE(5278)] = 203034,
  [SMALL_STATE(5279)] = 203087,
  [SMALL_STATE(5280)] = 203134,
  [SMALL_STATE(5281)] = 203187,
  [SMALL_STATE(5282)] = 203240,
  [SMALL_STATE(5283)] = 203293,
  [SMALL_STATE(5284)] = 203340,
  [SMALL_STATE(5285)] = 203393,
  [SMALL_STATE(5286)] = 203446,
  [SMALL_STATE(5287)] = 203499,
  [SMALL_STATE(5288)] = 203546,
  [SMALL_STATE(5289)] = 203599,
  [SMALL_STATE(5290)] = 203652,
  [SMALL_STATE(5291)] = 203705,
  [SMALL_STATE(5292)] = 203776,
  [SMALL_STATE(5293)] = 203829,
  [SMALL_STATE(5294)] = 203882,
  [SMALL_STATE(5295)] = 203935,
  [SMALL_STATE(5296)] = 204006,
  [SMALL_STATE(5297)] = 204059,
  [SMALL_STATE(5298)] = 204130,
  [SMALL_STATE(5299)] = 204174,
  [SMALL_STATE(5300)] = 204218,
  [SMALL_STATE(5301)] = 204268,
  [SMALL_STATE(5302)] = 204338,
  [SMALL_STATE(5303)] = 204382,
  [SMALL_STATE(5304)] = 204426,
  [SMALL_STATE(5305)] = 204478,
  [SMALL_STATE(5306)] = 204530,
  [SMALL_STATE(5307)] = 204582,
  [SMALL_STATE(5308)] = 204634,
  [SMALL_STATE(5309)] = 204686,
  [SMALL_STATE(5310)] = 204730,
  [SMALL_STATE(5311)] = 204774,
  [SMALL_STATE(5312)] = 204826,
  [SMALL_STATE(5313)] = 204876,
  [SMALL_STATE(5314)] = 204920,
  [SMALL_STATE(5315)] = 204964,
  [SMALL_STATE(5316)] = 205014,
  [SMALL_STATE(5317)] = 205066,
  [SMALL_STATE(5318)] = 205118,
  [SMALL_STATE(5319)] = 205170,
  [SMALL_STATE(5320)] = 205222,
  [SMALL_STATE(5321)] = 205272,
  [SMALL_STATE(5322)] = 205328,
  [SMALL_STATE(5323)] = 205398,
  [SMALL_STATE(5324)] = 205442,
  [SMALL_STATE(5325)] = 205486,
  [SMALL_STATE(5326)] = 205532,
  [SMALL_STATE(5327)] = 205584,
  [SMALL_STATE(5328)] = 205628,
  [SMALL_STATE(5329)] = 205684,
  [SMALL_STATE(5330)] = 205736,
  [SMALL_STATE(5331)] = 205788,
  [SMALL_STATE(5332)] = 205840,
  [SMALL_STATE(5333)] = 205892,
  [SMALL_STATE(5334)] = 205944,
  [SMALL_STATE(5335)] = 205988,
  [SMALL_STATE(5336)] = 206040,
  [SMALL_STATE(5337)] = 206092,
  [SMALL_STATE(5338)] = 206142,
  [SMALL_STATE(5339)] = 206186,
  [SMALL_STATE(5340)] = 206230,
  [SMALL_STATE(5341)] = 206274,
  [SMALL_STATE(5342)] = 206318,
  [SMALL_STATE(5343)] = 206362,
  [SMALL_STATE(5344)] = 206392,
  [SMALL_STATE(5345)] = 206462,
  [SMALL_STATE(5346)] = 206518,
  [SMALL_STATE(5347)] = 206570,
  [SMALL_STATE(5348)] = 206622,
  [SMALL_STATE(5349)] = 206672,
  [SMALL_STATE(5350)] = 206724,
  [SMALL_STATE(5351)] = 206776,
  [SMALL_STATE(5352)] = 206826,
  [SMALL_STATE(5353)] = 206878,
  [SMALL_STATE(5354)] = 206930,
  [SMALL_STATE(5355)] = 206980,
  [SMALL_STATE(5356)] = 207032,
  [SMALL_STATE(5357)] = 207088,
  [SMALL_STATE(5358)] = 207144,
  [SMALL_STATE(5359)] = 207200,
  [SMALL_STATE(5360)] = 207252,
  [SMALL_STATE(5361)] = 207304,
  [SMALL_STATE(5362)] = 207356,
  [SMALL_STATE(5363)] = 207408,
  [SMALL_STATE(5364)] = 207460,
  [SMALL_STATE(5365)] = 207512,
  [SMALL_STATE(5366)] = 207564,
  [SMALL_STATE(5367)] = 207616,
  [SMALL_STATE(5368)] = 207660,
  [SMALL_STATE(5369)] = 207704,
  [SMALL_STATE(5370)] = 207754,
  [SMALL_STATE(5371)] = 207804,
  [SMALL_STATE(5372)] = 207854,
  [SMALL_STATE(5373)] = 207906,
  [SMALL_STATE(5374)] = 207950,
  [SMALL_STATE(5375)] = 207994,
  [SMALL_STATE(5376)] = 208046,
  [SMALL_STATE(5377)] = 208090,
  [SMALL_STATE(5378)] = 208142,
  [SMALL_STATE(5379)] = 208194,
  [SMALL_STATE(5380)] = 208238,
  [SMALL_STATE(5381)] = 208294,
  [SMALL_STATE(5382)] = 208338,
  [SMALL_STATE(5383)] = 208382,
  [SMALL_STATE(5384)] = 208426,
  [SMALL_STATE(5385)] = 208470,
  [SMALL_STATE(5386)] = 208520,
  [SMALL_STATE(5387)] = 208576,
  [SMALL_STATE(5388)] = 208632,
  [SMALL_STATE(5389)] = 208676,
  [SMALL_STATE(5390)] = 208720,
  [SMALL_STATE(5391)] = 208776,
  [SMALL_STATE(5392)] = 208814,
  [SMALL_STATE(5393)] = 208858,
  [SMALL_STATE(5394)] = 208914,
  [SMALL_STATE(5395)] = 208966,
  [SMALL_STATE(5396)] = 209004,
  [SMALL_STATE(5397)] = 209048,
  [SMALL_STATE(5398)] = 209100,
  [SMALL_STATE(5399)] = 209156,
  [SMALL_STATE(5400)] = 209208,
  [SMALL_STATE(5401)] = 209252,
  [SMALL_STATE(5402)] = 209296,
  [SMALL_STATE(5403)] = 209340,
  [SMALL_STATE(5404)] = 209384,
  [SMALL_STATE(5405)] = 209428,
  [SMALL_STATE(5406)] = 209462,
  [SMALL_STATE(5407)] = 209506,
  [SMALL_STATE(5408)] = 209550,
  [SMALL_STATE(5409)] = 209596,
  [SMALL_STATE(5410)] = 209640,
  [SMALL_STATE(5411)] = 209692,
  [SMALL_STATE(5412)] = 209751,
  [SMALL_STATE(5413)] = 209810,
  [SMALL_STATE(5414)] = 209869,
  [SMALL_STATE(5415)] = 209928,
  [SMALL_STATE(5416)] = 209987,
  [SMALL_STATE(5417)] = 210046,
  [SMALL_STATE(5418)] = 210105,
  [SMALL_STATE(5419)] = 210164,
  [SMALL_STATE(5420)] = 210223,
  [SMALL_STATE(5421)] = 210282,
  [SMALL_STATE(5422)] = 210341,
  [SMALL_STATE(5423)] = 210400,
  [SMALL_STATE(5424)] = 210459,
  [SMALL_STATE(5425)] = 210518,
  [SMALL_STATE(5426)] = 210577,
  [SMALL_STATE(5427)] = 210636,
  [SMALL_STATE(5428)] = 210695,
  [SMALL_STATE(5429)] = 210754,
  [SMALL_STATE(5430)] = 210813,
  [SMALL_STATE(5431)] = 210876,
  [SMALL_STATE(5432)] = 210935,
  [SMALL_STATE(5433)] = 210994,
  [SMALL_STATE(5434)] = 211053,
  [SMALL_STATE(5435)] = 211112,
  [SMALL_STATE(5436)] = 211171,
  [SMALL_STATE(5437)] = 211230,
  [SMALL_STATE(5438)] = 211289,
  [SMALL_STATE(5439)] = 211348,
  [SMALL_STATE(5440)] = 211407,
  [SMALL_STATE(5441)] = 211466,
  [SMALL_STATE(5442)] = 211525,
  [SMALL_STATE(5443)] = 211570,
  [SMALL_STATE(5444)] = 211629,
  [SMALL_STATE(5445)] = 211688,
  [SMALL_STATE(5446)] = 211747,
  [SMALL_STATE(5447)] = 211806,
  [SMALL_STATE(5448)] = 211861,
  [SMALL_STATE(5449)] = 211920,
  [SMALL_STATE(5450)] = 211979,
  [SMALL_STATE(5451)] = 212038,
  [SMALL_STATE(5452)] = 212097,
  [SMALL_STATE(5453)] = 212156,
  [SMALL_STATE(5454)] = 212215,
  [SMALL_STATE(5455)] = 212274,
  [SMALL_STATE(5456)] = 212333,
  [SMALL_STATE(5457)] = 212392,
  [SMALL_STATE(5458)] = 212451,
  [SMALL_STATE(5459)] = 212510,
  [SMALL_STATE(5460)] = 212569,
  [SMALL_STATE(5461)] = 212628,
  [SMALL_STATE(5462)] = 212683,
  [SMALL_STATE(5463)] = 212742,
  [SMALL_STATE(5464)] = 212801,
  [SMALL_STATE(5465)] = 212860,
  [SMALL_STATE(5466)] = 212919,
  [SMALL_STATE(5467)] = 212948,
  [SMALL_STATE(5468)] = 213007,
  [SMALL_STATE(5469)] = 213066,
  [SMALL_STATE(5470)] = 213125,
  [SMALL_STATE(5471)] = 213184,
  [SMALL_STATE(5472)] = 213243,
  [SMALL_STATE(5473)] = 213302,
  [SMALL_STATE(5474)] = 213361,
  [SMALL_STATE(5475)] = 213420,
  [SMALL_STATE(5476)] = 213479,
  [SMALL_STATE(5477)] = 213538,
  [SMALL_STATE(5478)] = 213597,
  [SMALL_STATE(5479)] = 213656,
  [SMALL_STATE(5480)] = 213711,
  [SMALL_STATE(5481)] = 213770,
  [SMALL_STATE(5482)] = 213829,
  [SMALL_STATE(5483)] = 213888,
  [SMALL_STATE(5484)] = 213947,
  [SMALL_STATE(5485)] = 214006,
  [SMALL_STATE(5486)] = 214065,
  [SMALL_STATE(5487)] = 214124,
  [SMALL_STATE(5488)] = 214183,
  [SMALL_STATE(5489)] = 214242,
  [SMALL_STATE(5490)] = 214301,
  [SMALL_STATE(5491)] = 214360,
  [SMALL_STATE(5492)] = 214393,
  [SMALL_STATE(5493)] = 214452,
  [SMALL_STATE(5494)] = 214511,
  [SMALL_STATE(5495)] = 214570,
  [SMALL_STATE(5496)] = 214629,
  [SMALL_STATE(5497)] = 214688,
  [SMALL_STATE(5498)] = 214747,
  [SMALL_STATE(5499)] = 214806,
  [SMALL_STATE(5500)] = 214865,
  [SMALL_STATE(5501)] = 214924,
  [SMALL_STATE(5502)] = 214983,
  [SMALL_STATE(5503)] = 215042,
  [SMALL_STATE(5504)] = 215101,
  [SMALL_STATE(5505)] = 215160,
  [SMALL_STATE(5506)] = 215219,
  [SMALL_STATE(5507)] = 215278,
  [SMALL_STATE(5508)] = 215337,
  [SMALL_STATE(5509)] = 215395,
  [SMALL_STATE(5510)] = 215431,
  [SMALL_STATE(5511)] = 215459,
  [SMALL_STATE(5512)] = 215499,
  [SMALL_STATE(5513)] = 215563,
  [SMALL_STATE(5514)] = 215627,
  [SMALL_STATE(5515)] = 215669,
  [SMALL_STATE(5516)] = 215697,
  [SMALL_STATE(5517)] = 215761,
  [SMALL_STATE(5518)] = 215819,
  [SMALL_STATE(5519)] = 215865,
  [SMALL_STATE(5520)] = 215929,
  [SMALL_STATE(5521)] = 215993,
  [SMALL_STATE(5522)] = 216051,
  [SMALL_STATE(5523)] = 216115,
  [SMALL_STATE(5524)] = 216179,
  [SMALL_STATE(5525)] = 216207,
  [SMALL_STATE(5526)] = 216241,
  [SMALL_STATE(5527)] = 216299,
  [SMALL_STATE(5528)] = 216327,
  [SMALL_STATE(5529)] = 216363,
  [SMALL_STATE(5530)] = 216421,
  [SMALL_STATE(5531)] = 216467,
  [SMALL_STATE(5532)] = 216519,
  [SMALL_STATE(5533)] = 216563,
  [SMALL_STATE(5534)] = 216599,
  [SMALL_STATE(5535)] = 216643,
  [SMALL_STATE(5536)] = 216707,
  [SMALL_STATE(5537)] = 216759,
  [SMALL_STATE(5538)] = 216809,
  [SMALL_STATE(5539)] = 216873,
  [SMALL_STATE(5540)] = 216937,
  [SMALL_STATE(5541)] = 216965,
  [SMALL_STATE(5542)] = 217029,
  [SMALL_STATE(5543)] = 217061,
  [SMALL_STATE(5544)] = 217113,
  [SMALL_STATE(5545)] = 217141,
  [SMALL_STATE(5546)] = 217199,
  [SMALL_STATE(5547)] = 217227,
  [SMALL_STATE(5548)] = 217255,
  [SMALL_STATE(5549)] = 217313,
  [SMALL_STATE(5550)] = 217361,
  [SMALL_STATE(5551)] = 217389,
  [SMALL_STATE(5552)] = 217417,
  [SMALL_STATE(5553)] = 217481,
  [SMALL_STATE(5554)] = 217509,
  [SMALL_STATE(5555)] = 217573,
  [SMALL_STATE(5556)] = 217618,
  [SMALL_STATE(5557)] = 217663,
  [SMALL_STATE(5558)] = 217698,
  [SMALL_STATE(5559)] = 217733,
  [SMALL_STATE(5560)] = 217760,
  [SMALL_STATE(5561)] = 217795,
  [SMALL_STATE(5562)] = 217822,
  [SMALL_STATE(5563)] = 217849,
  [SMALL_STATE(5564)] = 217900,
  [SMALL_STATE(5565)] = 217935,
  [SMALL_STATE(5566)] = 217962,
  [SMALL_STATE(5567)] = 217989,
  [SMALL_STATE(5568)] = 218028,
  [SMALL_STATE(5569)] = 218073,
  [SMALL_STATE(5570)] = 218100,
  [SMALL_STATE(5571)] = 218139,
  [SMALL_STATE(5572)] = 218170,
  [SMALL_STATE(5573)] = 218205,
  [SMALL_STATE(5574)] = 218256,
  [SMALL_STATE(5575)] = 218291,
  [SMALL_STATE(5576)] = 218336,
  [SMALL_STATE(5577)] = 218381,
  [SMALL_STATE(5578)] = 218420,
  [SMALL_STATE(5579)] = 218455,
  [SMALL_STATE(5580)] = 218490,
  [SMALL_STATE(5581)] = 218529,
  [SMALL_STATE(5582)] = 218556,
  [SMALL_STATE(5583)] = 218601,
  [SMALL_STATE(5584)] = 218636,
  [SMALL_STATE(5585)] = 218681,
  [SMALL_STATE(5586)] = 218738,
  [SMALL_STATE(5587)] = 218777,
  [SMALL_STATE(5588)] = 218804,
  [SMALL_STATE(5589)] = 218843,
  [SMALL_STATE(5590)] = 218882,
  [SMALL_STATE(5591)] = 218917,
  [SMALL_STATE(5592)] = 218956,
  [SMALL_STATE(5593)] = 219001,
  [SMALL_STATE(5594)] = 219046,
  [SMALL_STATE(5595)] = 219085,
  [SMALL_STATE(5596)] = 219124,
  [SMALL_STATE(5597)] = 219151,
  [SMALL_STATE(5598)] = 219196,
  [SMALL_STATE(5599)] = 219235,
  [SMALL_STATE(5600)] = 219280,
  [SMALL_STATE(5601)] = 219315,
  [SMALL_STATE(5602)] = 219342,
  [SMALL_STATE(5603)] = 219387,
  [SMALL_STATE(5604)] = 219444,
  [SMALL_STATE(5605)] = 219471,
  [SMALL_STATE(5606)] = 219498,
  [SMALL_STATE(5607)] = 219537,
  [SMALL_STATE(5608)] = 219564,
  [SMALL_STATE(5609)] = 219599,
  [SMALL_STATE(5610)] = 219626,
  [SMALL_STATE(5611)] = 219683,
  [SMALL_STATE(5612)] = 219714,
  [SMALL_STATE(5613)] = 219771,
  [SMALL_STATE(5614)] = 219798,
  [SMALL_STATE(5615)] = 219843,
  [SMALL_STATE(5616)] = 219870,
  [SMALL_STATE(5617)] = 219915,
  [SMALL_STATE(5618)] = 219960,
  [SMALL_STATE(5619)] = 219989,
  [SMALL_STATE(5620)] = 220028,
  [SMALL_STATE(5621)] = 220067,
  [SMALL_STATE(5622)] = 220106,
  [SMALL_STATE(5623)] = 220157,
  [SMALL_STATE(5624)] = 220202,
  [SMALL_STATE(5625)] = 220229,
  [SMALL_STATE(5626)] = 220268,
  [SMALL_STATE(5627)] = 220313,
  [SMALL_STATE(5628)] = 220340,
  [SMALL_STATE(5629)] = 220385,
  [SMALL_STATE(5630)] = 220420,
  [SMALL_STATE(5631)] = 220465,
  [SMALL_STATE(5632)] = 220494,
  [SMALL_STATE(5633)] = 220533,
  [SMALL_STATE(5634)] = 220578,
  [SMALL_STATE(5635)] = 220617,
  [SMALL_STATE(5636)] = 220656,
  [SMALL_STATE(5637)] = 220699,
  [SMALL_STATE(5638)] = 220744,
  [SMALL_STATE(5639)] = 220775,
  [SMALL_STATE(5640)] = 220802,
  [SMALL_STATE(5641)] = 220841,
  [SMALL_STATE(5642)] = 220886,
  [SMALL_STATE(5643)] = 220931,
  [SMALL_STATE(5644)] = 220966,
  [SMALL_STATE(5645)] = 221011,
  [SMALL_STATE(5646)] = 221038,
  [SMALL_STATE(5647)] = 221065,
  [SMALL_STATE(5648)] = 221100,
  [SMALL_STATE(5649)] = 221145,
  [SMALL_STATE(5650)] = 221190,
  [SMALL_STATE(5651)] = 221217,
  [SMALL_STATE(5652)] = 221244,
  [SMALL_STATE(5653)] = 221279,
  [SMALL_STATE(5654)] = 221306,
  [SMALL_STATE(5655)] = 221341,
  [SMALL_STATE(5656)] = 221386,
  [SMALL_STATE(5657)] = 221413,
  [SMALL_STATE(5658)] = 221452,
  [SMALL_STATE(5659)] = 221483,
  [SMALL_STATE(5660)] = 221514,
  [SMALL_STATE(5661)] = 221565,
  [SMALL_STATE(5662)] = 221614,
  [SMALL_STATE(5663)] = 221641,
  [SMALL_STATE(5664)] = 221680,
  [SMALL_STATE(5665)] = 221709,
  [SMALL_STATE(5666)] = 221748,
  [SMALL_STATE(5667)] = 221793,
  [SMALL_STATE(5668)] = 221842,
  [SMALL_STATE(5669)] = 221887,
  [SMALL_STATE(5670)] = 221922,
  [SMALL_STATE(5671)] = 221967,
  [SMALL_STATE(5672)] = 222024,
  [SMALL_STATE(5673)] = 222051,
  [SMALL_STATE(5674)] = 222080,
  [SMALL_STATE(5675)] = 222119,
  [SMALL_STATE(5676)] = 222156,
  [SMALL_STATE(5677)] = 222191,
  [SMALL_STATE(5678)] = 222234,
  [SMALL_STATE(5679)] = 222261,
  [SMALL_STATE(5680)] = 222292,
  [SMALL_STATE(5681)] = 222333,
  [SMALL_STATE(5682)] = 222360,
  [SMALL_STATE(5683)] = 222387,
  [SMALL_STATE(5684)] = 222432,
  [SMALL_STATE(5685)] = 222459,
  [SMALL_STATE(5686)] = 222494,
  [SMALL_STATE(5687)] = 222525,
  [SMALL_STATE(5688)] = 222558,
  [SMALL_STATE(5689)] = 222589,
  [SMALL_STATE(5690)] = 222616,
  [SMALL_STATE(5691)] = 222651,
  [SMALL_STATE(5692)] = 222696,
  [SMALL_STATE(5693)] = 222741,
  [SMALL_STATE(5694)] = 222768,
  [SMALL_STATE(5695)] = 222807,
  [SMALL_STATE(5696)] = 222864,
  [SMALL_STATE(5697)] = 222900,
  [SMALL_STATE(5698)] = 222936,
  [SMALL_STATE(5699)] = 222972,
  [SMALL_STATE(5700)] = 223002,
  [SMALL_STATE(5701)] = 223038,
  [SMALL_STATE(5702)] = 223074,
  [SMALL_STATE(5703)] = 223104,
  [SMALL_STATE(5704)] = 223140,
  [SMALL_STATE(5705)] = 223176,
  [SMALL_STATE(5706)] = 223206,
  [SMALL_STATE(5707)] = 223242,
  [SMALL_STATE(5708)] = 223284,
  [SMALL_STATE(5709)] = 223336,
  [SMALL_STATE(5710)] = 223366,
  [SMALL_STATE(5711)] = 223415,
  [SMALL_STATE(5712)] = 223440,
  [SMALL_STATE(5713)] = 223489,
  [SMALL_STATE(5714)] = 223526,
  [SMALL_STATE(5715)] = 223567,
  [SMALL_STATE(5716)] = 223616,
  [SMALL_STATE(5717)] = 223641,
  [SMALL_STATE(5718)] = 223678,
  [SMALL_STATE(5719)] = 223715,
  [SMALL_STATE(5720)] = 223740,
  [SMALL_STATE(5721)] = 223777,
  [SMALL_STATE(5722)] = 223814,
  [SMALL_STATE(5723)] = 223857,
  [SMALL_STATE(5724)] = 223906,
  [SMALL_STATE(5725)] = 223943,
  [SMALL_STATE(5726)] = 223992,
  [SMALL_STATE(5727)] = 224017,
  [SMALL_STATE(5728)] = 224042,
  [SMALL_STATE(5729)] = 224079,
  [SMALL_STATE(5730)] = 224122,
  [SMALL_STATE(5731)] = 224171,
  [SMALL_STATE(5732)] = 224196,
  [SMALL_STATE(5733)] = 224233,
  [SMALL_STATE(5734)] = 224258,
  [SMALL_STATE(5735)] = 224295,
  [SMALL_STATE(5736)] = 224326,
  [SMALL_STATE(5737)] = 224375,
  [SMALL_STATE(5738)] = 224424,
  [SMALL_STATE(5739)] = 224461,
  [SMALL_STATE(5740)] = 224498,
  [SMALL_STATE(5741)] = 224523,
  [SMALL_STATE(5742)] = 224572,
  [SMALL_STATE(5743)] = 224621,
  [SMALL_STATE(5744)] = 224670,
  [SMALL_STATE(5745)] = 224695,
  [SMALL_STATE(5746)] = 224732,
  [SMALL_STATE(5747)] = 224757,
  [SMALL_STATE(5748)] = 224782,
  [SMALL_STATE(5749)] = 224831,
  [SMALL_STATE(5750)] = 224862,
  [SMALL_STATE(5751)] = 224911,
  [SMALL_STATE(5752)] = 224962,
  [SMALL_STATE(5753)] = 225011,
  [SMALL_STATE(5754)] = 225048,
  [SMALL_STATE(5755)] = 225097,
  [SMALL_STATE(5756)] = 225146,
  [SMALL_STATE(5757)] = 225189,
  [SMALL_STATE(5758)] = 225238,
  [SMALL_STATE(5759)] = 225273,
  [SMALL_STATE(5760)] = 225298,
  [SMALL_STATE(5761)] = 225323,
  [SMALL_STATE(5762)] = 225372,
  [SMALL_STATE(5763)] = 225421,
  [SMALL_STATE(5764)] = 225470,
  [SMALL_STATE(5765)] = 225511,
  [SMALL_STATE(5766)] = 225554,
  [SMALL_STATE(5767)] = 225603,
  [SMALL_STATE(5768)] = 225640,
  [SMALL_STATE(5769)] = 225689,
  [SMALL_STATE(5770)] = 225738,
  [SMALL_STATE(5771)] = 225769,
  [SMALL_STATE(5772)] = 225794,
  [SMALL_STATE(5773)] = 225819,
  [SMALL_STATE(5774)] = 225868,
  [SMALL_STATE(5775)] = 225917,
  [SMALL_STATE(5776)] = 225942,
  [SMALL_STATE(5777)] = 225973,
  [SMALL_STATE(5778)] = 226010,
  [SMALL_STATE(5779)] = 226035,
  [SMALL_STATE(5780)] = 226072,
  [SMALL_STATE(5781)] = 226097,
  [SMALL_STATE(5782)] = 226122,
  [SMALL_STATE(5783)] = 226153,
  [SMALL_STATE(5784)] = 226178,
  [SMALL_STATE(5785)] = 226203,
  [SMALL_STATE(5786)] = 226233,
  [SMALL_STATE(5787)] = 226255,
  [SMALL_STATE(5788)] = 226281,
  [SMALL_STATE(5789)] = 226303,
  [SMALL_STATE(5790)] = 226343,
  [SMALL_STATE(5791)] = 226365,
  [SMALL_STATE(5792)] = 226387,
  [SMALL_STATE(5793)] = 226417,
  [SMALL_STATE(5794)] = 226453,
  [SMALL_STATE(5795)] = 226483,
  [SMALL_STATE(5796)] = 226505,
  [SMALL_STATE(5797)] = 226535,
  [SMALL_STATE(5798)] = 226557,
  [SMALL_STATE(5799)] = 226579,
  [SMALL_STATE(5800)] = 226615,
  [SMALL_STATE(5801)] = 226641,
  [SMALL_STATE(5802)] = 226681,
  [SMALL_STATE(5803)] = 226717,
  [SMALL_STATE(5804)] = 226741,
  [SMALL_STATE(5805)] = 226765,
  [SMALL_STATE(5806)] = 226801,
  [SMALL_STATE(5807)] = 226837,
  [SMALL_STATE(5808)] = 226863,
  [SMALL_STATE(5809)] = 226899,
  [SMALL_STATE(5810)] = 226921,
  [SMALL_STATE(5811)] = 226963,
  [SMALL_STATE(5812)] = 226993,
  [SMALL_STATE(5813)] = 227023,
  [SMALL_STATE(5814)] = 227067,
  [SMALL_STATE(5815)] = 227091,
  [SMALL_STATE(5816)] = 227113,
  [SMALL_STATE(5817)] = 227149,
  [SMALL_STATE(5818)] = 227179,
  [SMALL_STATE(5819)] = 227201,
  [SMALL_STATE(5820)] = 227223,
  [SMALL_STATE(5821)] = 227253,
  [SMALL_STATE(5822)] = 227283,
  [SMALL_STATE(5823)] = 227313,
  [SMALL_STATE(5824)] = 227343,
  [SMALL_STATE(5825)] = 227365,
  [SMALL_STATE(5826)] = 227387,
  [SMALL_STATE(5827)] = 227409,
  [SMALL_STATE(5828)] = 227445,
  [SMALL_STATE(5829)] = 227467,
  [SMALL_STATE(5830)] = 227493,
  [SMALL_STATE(5831)] = 227515,
  [SMALL_STATE(5832)] = 227537,
  [SMALL_STATE(5833)] = 227567,
  [SMALL_STATE(5834)] = 227598,
  [SMALL_STATE(5835)] = 227637,
  [SMALL_STATE(5836)] = 227668,
  [SMALL_STATE(5837)] = 227691,
  [SMALL_STATE(5838)] = 227722,
  [SMALL_STATE(5839)] = 227761,
  [SMALL_STATE(5840)] = 227792,
  [SMALL_STATE(5841)] = 227831,
  [SMALL_STATE(5842)] = 227874,
  [SMALL_STATE(5843)] = 227917,
  [SMALL_STATE(5844)] = 227950,
  [SMALL_STATE(5845)] = 227981,
  [SMALL_STATE(5846)] = 228020,
  [SMALL_STATE(5847)] = 228051,
  [SMALL_STATE(5848)] = 228082,
  [SMALL_STATE(5849)] = 228125,
  [SMALL_STATE(5850)] = 228156,
  [SMALL_STATE(5851)] = 228199,
  [SMALL_STATE(5852)] = 228242,
  [SMALL_STATE(5853)] = 228275,
  [SMALL_STATE(5854)] = 228306,
  [SMALL_STATE(5855)] = 228337,
  [SMALL_STATE(5856)] = 228368,
  [SMALL_STATE(5857)] = 228407,
  [SMALL_STATE(5858)] = 228450,
  [SMALL_STATE(5859)] = 228481,
  [SMALL_STATE(5860)] = 228510,
  [SMALL_STATE(5861)] = 228539,
  [SMALL_STATE(5862)] = 228568,
  [SMALL_STATE(5863)] = 228597,
  [SMALL_STATE(5864)] = 228626,
  [SMALL_STATE(5865)] = 228659,
  [SMALL_STATE(5866)] = 228688,
  [SMALL_STATE(5867)] = 228717,
  [SMALL_STATE(5868)] = 228746,
  [SMALL_STATE(5869)] = 228775,
  [SMALL_STATE(5870)] = 228802,
  [SMALL_STATE(5871)] = 228833,
  [SMALL_STATE(5872)] = 228864,
  [SMALL_STATE(5873)] = 228895,
  [SMALL_STATE(5874)] = 228928,
  [SMALL_STATE(5875)] = 228955,
  [SMALL_STATE(5876)] = 228986,
  [SMALL_STATE(5877)] = 229019,
  [SMALL_STATE(5878)] = 229062,
  [SMALL_STATE(5879)] = 229105,
  [SMALL_STATE(5880)] = 229136,
  [SMALL_STATE(5881)] = 229169,
  [SMALL_STATE(5882)] = 229192,
  [SMALL_STATE(5883)] = 229223,
  [SMALL_STATE(5884)] = 229262,
  [SMALL_STATE(5885)] = 229293,
  [SMALL_STATE(5886)] = 229326,
  [SMALL_STATE(5887)] = 229353,
  [SMALL_STATE(5888)] = 229396,
  [SMALL_STATE(5889)] = 229427,
  [SMALL_STATE(5890)] = 229460,
  [SMALL_STATE(5891)] = 229489,
  [SMALL_STATE(5892)] = 229532,
  [SMALL_STATE(5893)] = 229561,
  [SMALL_STATE(5894)] = 229590,
  [SMALL_STATE(5895)] = 229619,
  [SMALL_STATE(5896)] = 229662,
  [SMALL_STATE(5897)] = 229691,
  [SMALL_STATE(5898)] = 229720,
  [SMALL_STATE(5899)] = 229749,
  [SMALL_STATE(5900)] = 229778,
  [SMALL_STATE(5901)] = 229817,
  [SMALL_STATE(5902)] = 229856,
  [SMALL_STATE(5903)] = 229885,
  [SMALL_STATE(5904)] = 229914,
  [SMALL_STATE(5905)] = 229943,
  [SMALL_STATE(5906)] = 229972,
  [SMALL_STATE(5907)] = 230001,
  [SMALL_STATE(5908)] = 230030,
  [SMALL_STATE(5909)] = 230059,
  [SMALL_STATE(5910)] = 230088,
  [SMALL_STATE(5911)] = 230108,
  [SMALL_STATE(5912)] = 230128,
  [SMALL_STATE(5913)] = 230156,
  [SMALL_STATE(5914)] = 230188,
  [SMALL_STATE(5915)] = 230218,
  [SMALL_STATE(5916)] = 230238,
  [SMALL_STATE(5917)] = 230258,
  [SMALL_STATE(5918)] = 230282,
  [SMALL_STATE(5919)] = 230310,
  [SMALL_STATE(5920)] = 230340,
  [SMALL_STATE(5921)] = 230370,
  [SMALL_STATE(5922)] = 230400,
  [SMALL_STATE(5923)] = 230430,
  [SMALL_STATE(5924)] = 230458,
  [SMALL_STATE(5925)] = 230486,
  [SMALL_STATE(5926)] = 230518,
  [SMALL_STATE(5927)] = 230558,
  [SMALL_STATE(5928)] = 230590,
  [SMALL_STATE(5929)] = 230610,
  [SMALL_STATE(5930)] = 230630,
  [SMALL_STATE(5931)] = 230658,
  [SMALL_STATE(5932)] = 230678,
  [SMALL_STATE(5933)] = 230698,
  [SMALL_STATE(5934)] = 230730,
  [SMALL_STATE(5935)] = 230762,
  [SMALL_STATE(5936)] = 230790,
  [SMALL_STATE(5937)] = 230822,
  [SMALL_STATE(5938)] = 230854,
  [SMALL_STATE(5939)] = 230882,
  [SMALL_STATE(5940)] = 230910,
  [SMALL_STATE(5941)] = 230930,
  [SMALL_STATE(5942)] = 230968,
  [SMALL_STATE(5943)] = 230996,
  [SMALL_STATE(5944)] = 231028,
  [SMALL_STATE(5945)] = 231050,
  [SMALL_STATE(5946)] = 231082,
  [SMALL_STATE(5947)] = 231114,
  [SMALL_STATE(5948)] = 231146,
  [SMALL_STATE(5949)] = 231166,
  [SMALL_STATE(5950)] = 231194,
  [SMALL_STATE(5951)] = 231222,
  [SMALL_STATE(5952)] = 231250,
  [SMALL_STATE(5953)] = 231290,
  [SMALL_STATE(5954)] = 231318,
  [SMALL_STATE(5955)] = 231358,
  [SMALL_STATE(5956)] = 231386,
  [SMALL_STATE(5957)] = 231414,
  [SMALL_STATE(5958)] = 231452,
  [SMALL_STATE(5959)] = 231480,
  [SMALL_STATE(5960)] = 231518,
  [SMALL_STATE(5961)] = 231538,
  [SMALL_STATE(5962)] = 231566,
  [SMALL_STATE(5963)] = 231604,
  [SMALL_STATE(5964)] = 231644,
  [SMALL_STATE(5965)] = 231672,
  [SMALL_STATE(5966)] = 231700,
  [SMALL_STATE(5967)] = 231738,
  [SMALL_STATE(5968)] = 231770,
  [SMALL_STATE(5969)] = 231802,
  [SMALL_STATE(5970)] = 231826,
  [SMALL_STATE(5971)] = 231848,
  [SMALL_STATE(5972)] = 231888,
  [SMALL_STATE(5973)] = 231910,
  [SMALL_STATE(5974)] = 231930,
  [SMALL_STATE(5975)] = 231958,
  [SMALL_STATE(5976)] = 231986,
  [SMALL_STATE(5977)] = 232024,
  [SMALL_STATE(5978)] = 232054,
  [SMALL_STATE(5979)] = 232086,
  [SMALL_STATE(5980)] = 232114,
  [SMALL_STATE(5981)] = 232146,
  [SMALL_STATE(5982)] = 232186,
  [SMALL_STATE(5983)] = 232226,
  [SMALL_STATE(5984)] = 232256,
  [SMALL_STATE(5985)] = 232296,
  [SMALL_STATE(5986)] = 232336,
  [SMALL_STATE(5987)] = 232366,
  [SMALL_STATE(5988)] = 232396,
  [SMALL_STATE(5989)] = 232426,
  [SMALL_STATE(5990)] = 232446,
  [SMALL_STATE(5991)] = 232466,
  [SMALL_STATE(5992)] = 232486,
  [SMALL_STATE(5993)] = 232526,
  [SMALL_STATE(5994)] = 232552,
  [SMALL_STATE(5995)] = 232592,
  [SMALL_STATE(5996)] = 232616,
  [SMALL_STATE(5997)] = 232656,
  [SMALL_STATE(5998)] = 232684,
  [SMALL_STATE(5999)] = 232704,
  [SMALL_STATE(6000)] = 232724,
  [SMALL_STATE(6001)] = 232764,
  [SMALL_STATE(6002)] = 232792,
  [SMALL_STATE(6003)] = 232830,
  [SMALL_STATE(6004)] = 232850,
  [SMALL_STATE(6005)] = 232890,
  [SMALL_STATE(6006)] = 232910,
  [SMALL_STATE(6007)] = 232942,
  [SMALL_STATE(6008)] = 232980,
  [SMALL_STATE(6009)] = 233020,
  [SMALL_STATE(6010)] = 233058,
  [SMALL_STATE(6011)] = 233096,
  [SMALL_STATE(6012)] = 233136,
  [SMALL_STATE(6013)] = 233168,
  [SMALL_STATE(6014)] = 233200,
  [SMALL_STATE(6015)] = 233238,
  [SMALL_STATE(6016)] = 233276,
  [SMALL_STATE(6017)] = 233316,
  [SMALL_STATE(6018)] = 233354,
  [SMALL_STATE(6019)] = 233392,
  [SMALL_STATE(6020)] = 233430,
  [SMALL_STATE(6021)] = 233468,
  [SMALL_STATE(6022)] = 233494,
  [SMALL_STATE(6023)] = 233526,
  [SMALL_STATE(6024)] = 233564,
  [SMALL_STATE(6025)] = 233604,
  [SMALL_STATE(6026)] = 233644,
  [SMALL_STATE(6027)] = 233666,
  [SMALL_STATE(6028)] = 233698,
  [SMALL_STATE(6029)] = 233726,
  [SMALL_STATE(6030)] = 233752,
  [SMALL_STATE(6031)] = 233790,
  [SMALL_STATE(6032)] = 233810,
  [SMALL_STATE(6033)] = 233842,
  [SMALL_STATE(6034)] = 233864,
  [SMALL_STATE(6035)] = 233902,
  [SMALL_STATE(6036)] = 233922,
  [SMALL_STATE(6037)] = 233954,
  [SMALL_STATE(6038)] = 233986,
  [SMALL_STATE(6039)] = 234015,
  [SMALL_STATE(6040)] = 234036,
  [SMALL_STATE(6041)] = 234075,
  [SMALL_STATE(6042)] = 234102,
  [SMALL_STATE(6043)] = 234135,
  [SMALL_STATE(6044)] = 234160,
  [SMALL_STATE(6045)] = 234189,
  [SMALL_STATE(6046)] = 234222,
  [SMALL_STATE(6047)] = 234243,
  [SMALL_STATE(6048)] = 234272,
  [SMALL_STATE(6049)] = 234309,
  [SMALL_STATE(6050)] = 234330,
  [SMALL_STATE(6051)] = 234351,
  [SMALL_STATE(6052)] = 234372,
  [SMALL_STATE(6053)] = 234401,
  [SMALL_STATE(6054)] = 234422,
  [SMALL_STATE(6055)] = 234443,
  [SMALL_STATE(6056)] = 234476,
  [SMALL_STATE(6057)] = 234503,
  [SMALL_STATE(6058)] = 234542,
  [SMALL_STATE(6059)] = 234577,
  [SMALL_STATE(6060)] = 234612,
  [SMALL_STATE(6061)] = 234639,
  [SMALL_STATE(6062)] = 234674,
  [SMALL_STATE(6063)] = 234707,
  [SMALL_STATE(6064)] = 234734,
  [SMALL_STATE(6065)] = 234767,
  [SMALL_STATE(6066)] = 234788,
  [SMALL_STATE(6067)] = 234823,
  [SMALL_STATE(6068)] = 234848,
  [SMALL_STATE(6069)] = 234869,
  [SMALL_STATE(6070)] = 234902,
  [SMALL_STATE(6071)] = 234923,
  [SMALL_STATE(6072)] = 234956,
  [SMALL_STATE(6073)] = 234983,
  [SMALL_STATE(6074)] = 235004,
  [SMALL_STATE(6075)] = 235029,
  [SMALL_STATE(6076)] = 235062,
  [SMALL_STATE(6077)] = 235097,
  [SMALL_STATE(6078)] = 235130,
  [SMALL_STATE(6079)] = 235167,
  [SMALL_STATE(6080)] = 235200,
  [SMALL_STATE(6081)] = 235233,
  [SMALL_STATE(6082)] = 235266,
  [SMALL_STATE(6083)] = 235299,
  [SMALL_STATE(6084)] = 235338,
  [SMALL_STATE(6085)] = 235363,
  [SMALL_STATE(6086)] = 235384,
  [SMALL_STATE(6087)] = 235413,
  [SMALL_STATE(6088)] = 235446,
  [SMALL_STATE(6089)] = 235481,
  [SMALL_STATE(6090)] = 235514,
  [SMALL_STATE(6091)] = 235541,
  [SMALL_STATE(6092)] = 235574,
  [SMALL_STATE(6093)] = 235601,
  [SMALL_STATE(6094)] = 235634,
  [SMALL_STATE(6095)] = 235655,
  [SMALL_STATE(6096)] = 235682,
  [SMALL_STATE(6097)] = 235717,
  [SMALL_STATE(6098)] = 235742,
  [SMALL_STATE(6099)] = 235763,
  [SMALL_STATE(6100)] = 235784,
  [SMALL_STATE(6101)] = 235811,
  [SMALL_STATE(6102)] = 235844,
  [SMALL_STATE(6103)] = 235871,
  [SMALL_STATE(6104)] = 235892,
  [SMALL_STATE(6105)] = 235925,
  [SMALL_STATE(6106)] = 235946,
  [SMALL_STATE(6107)] = 235979,
  [SMALL_STATE(6108)] = 236000,
  [SMALL_STATE(6109)] = 236027,
  [SMALL_STATE(6110)] = 236048,
  [SMALL_STATE(6111)] = 236069,
  [SMALL_STATE(6112)] = 236090,
  [SMALL_STATE(6113)] = 236115,
  [SMALL_STATE(6114)] = 236142,
  [SMALL_STATE(6115)] = 236175,
  [SMALL_STATE(6116)] = 236202,
  [SMALL_STATE(6117)] = 236223,
  [SMALL_STATE(6118)] = 236250,
  [SMALL_STATE(6119)] = 236271,
  [SMALL_STATE(6120)] = 236298,
  [SMALL_STATE(6121)] = 236319,
  [SMALL_STATE(6122)] = 236352,
  [SMALL_STATE(6123)] = 236387,
  [SMALL_STATE(6124)] = 236408,
  [SMALL_STATE(6125)] = 236441,
  [SMALL_STATE(6126)] = 236462,
  [SMALL_STATE(6127)] = 236495,
  [SMALL_STATE(6128)] = 236516,
  [SMALL_STATE(6129)] = 236537,
  [SMALL_STATE(6130)] = 236572,
  [SMALL_STATE(6131)] = 236605,
  [SMALL_STATE(6132)] = 236644,
  [SMALL_STATE(6133)] = 236669,
  [SMALL_STATE(6134)] = 236708,
  [SMALL_STATE(6135)] = 236729,
  [SMALL_STATE(6136)] = 236762,
  [SMALL_STATE(6137)] = 236789,
  [SMALL_STATE(6138)] = 236822,
  [SMALL_STATE(6139)] = 236857,
  [SMALL_STATE(6140)] = 236892,
  [SMALL_STATE(6141)] = 236925,
  [SMALL_STATE(6142)] = 236955,
  [SMALL_STATE(6143)] = 236991,
  [SMALL_STATE(6144)] = 237027,
  [SMALL_STATE(6145)] = 237053,
  [SMALL_STATE(6146)] = 237089,
  [SMALL_STATE(6147)] = 237117,
  [SMALL_STATE(6148)] = 237143,
  [SMALL_STATE(6149)] = 237165,
  [SMALL_STATE(6150)] = 237195,
  [SMALL_STATE(6151)] = 237225,
  [SMALL_STATE(6152)] = 237247,
  [SMALL_STATE(6153)] = 237283,
  [SMALL_STATE(6154)] = 237319,
  [SMALL_STATE(6155)] = 237355,
  [SMALL_STATE(6156)] = 237379,
  [SMALL_STATE(6157)] = 237415,
  [SMALL_STATE(6158)] = 237441,
  [SMALL_STATE(6159)] = 237477,
  [SMALL_STATE(6160)] = 237505,
  [SMALL_STATE(6161)] = 237533,
  [SMALL_STATE(6162)] = 237569,
  [SMALL_STATE(6163)] = 237599,
  [SMALL_STATE(6164)] = 237623,
  [SMALL_STATE(6165)] = 237659,
  [SMALL_STATE(6166)] = 237685,
  [SMALL_STATE(6167)] = 237713,
  [SMALL_STATE(6168)] = 237743,
  [SMALL_STATE(6169)] = 237779,
  [SMALL_STATE(6170)] = 237805,
  [SMALL_STATE(6171)] = 237829,
  [SMALL_STATE(6172)] = 237855,
  [SMALL_STATE(6173)] = 237885,
  [SMALL_STATE(6174)] = 237905,
  [SMALL_STATE(6175)] = 237935,
  [SMALL_STATE(6176)] = 237961,
  [SMALL_STATE(6177)] = 237987,
  [SMALL_STATE(6178)] = 238017,
  [SMALL_STATE(6179)] = 238043,
  [SMALL_STATE(6180)] = 238079,
  [SMALL_STATE(6181)] = 238105,
  [SMALL_STATE(6182)] = 238129,
  [SMALL_STATE(6183)] = 238165,
  [SMALL_STATE(6184)] = 238201,
  [SMALL_STATE(6185)] = 238227,
  [SMALL_STATE(6186)] = 238263,
  [SMALL_STATE(6187)] = 238289,
  [SMALL_STATE(6188)] = 238325,
  [SMALL_STATE(6189)] = 238361,
  [SMALL_STATE(6190)] = 238397,
  [SMALL_STATE(6191)] = 238433,
  [SMALL_STATE(6192)] = 238463,
  [SMALL_STATE(6193)] = 238493,
  [SMALL_STATE(6194)] = 238519,
  [SMALL_STATE(6195)] = 238545,
  [SMALL_STATE(6196)] = 238571,
  [SMALL_STATE(6197)] = 238591,
  [SMALL_STATE(6198)] = 238617,
  [SMALL_STATE(6199)] = 238643,
  [SMALL_STATE(6200)] = 238673,
  [SMALL_STATE(6201)] = 238709,
  [SMALL_STATE(6202)] = 238733,
  [SMALL_STATE(6203)] = 238769,
  [SMALL_STATE(6204)] = 238799,
  [SMALL_STATE(6205)] = 238835,
  [SMALL_STATE(6206)] = 238861,
  [SMALL_STATE(6207)] = 238897,
  [SMALL_STATE(6208)] = 238925,
  [SMALL_STATE(6209)] = 238955,
  [SMALL_STATE(6210)] = 238990,
  [SMALL_STATE(6211)] = 239019,
  [SMALL_STATE(6212)] = 239046,
  [SMALL_STATE(6213)] = 239071,
  [SMALL_STATE(6214)] = 239090,
  [SMALL_STATE(6215)] = 239109,
  [SMALL_STATE(6216)] = 239144,
  [SMALL_STATE(6217)] = 239163,
  [SMALL_STATE(6218)] = 239198,
  [SMALL_STATE(6219)] = 239229,
  [SMALL_STATE(6220)] = 239248,
  [SMALL_STATE(6221)] = 239277,
  [SMALL_STATE(6222)] = 239306,
  [SMALL_STATE(6223)] = 239337,
  [SMALL_STATE(6224)] = 239362,
  [SMALL_STATE(6225)] = 239397,
  [SMALL_STATE(6226)] = 239424,
  [SMALL_STATE(6227)] = 239459,
  [SMALL_STATE(6228)] = 239478,
  [SMALL_STATE(6229)] = 239509,
  [SMALL_STATE(6230)] = 239536,
  [SMALL_STATE(6231)] = 239563,
  [SMALL_STATE(6232)] = 239594,
  [SMALL_STATE(6233)] = 239619,
  [SMALL_STATE(6234)] = 239646,
  [SMALL_STATE(6235)] = 239677,
  [SMALL_STATE(6236)] = 239712,
  [SMALL_STATE(6237)] = 239739,
  [SMALL_STATE(6238)] = 239766,
  [SMALL_STATE(6239)] = 239785,
  [SMALL_STATE(6240)] = 239814,
  [SMALL_STATE(6241)] = 239839,
  [SMALL_STATE(6242)] = 239870,
  [SMALL_STATE(6243)] = 239895,
  [SMALL_STATE(6244)] = 239918,
  [SMALL_STATE(6245)] = 239953,
  [SMALL_STATE(6246)] = 239980,
  [SMALL_STATE(6247)] = 240009,
  [SMALL_STATE(6248)] = 240044,
  [SMALL_STATE(6249)] = 240071,
  [SMALL_STATE(6250)] = 240098,
  [SMALL_STATE(6251)] = 240117,
  [SMALL_STATE(6252)] = 240152,
  [SMALL_STATE(6253)] = 240177,
  [SMALL_STATE(6254)] = 240208,
  [SMALL_STATE(6255)] = 240237,
  [SMALL_STATE(6256)] = 240266,
  [SMALL_STATE(6257)] = 240297,
  [SMALL_STATE(6258)] = 240316,
  [SMALL_STATE(6259)] = 240351,
  [SMALL_STATE(6260)] = 240374,
  [SMALL_STATE(6261)] = 240409,
  [SMALL_STATE(6262)] = 240434,
  [SMALL_STATE(6263)] = 240469,
  [SMALL_STATE(6264)] = 240504,
  [SMALL_STATE(6265)] = 240535,
  [SMALL_STATE(6266)] = 240566,
  [SMALL_STATE(6267)] = 240601,
  [SMALL_STATE(6268)] = 240636,
  [SMALL_STATE(6269)] = 240665,
  [SMALL_STATE(6270)] = 240700,
  [SMALL_STATE(6271)] = 240729,
  [SMALL_STATE(6272)] = 240760,
  [SMALL_STATE(6273)] = 240789,
  [SMALL_STATE(6274)] = 240820,
  [SMALL_STATE(6275)] = 240839,
  [SMALL_STATE(6276)] = 240858,
  [SMALL_STATE(6277)] = 240893,
  [SMALL_STATE(6278)] = 240918,
  [SMALL_STATE(6279)] = 240953,
  [SMALL_STATE(6280)] = 240982,
  [SMALL_STATE(6281)] = 241013,
  [SMALL_STATE(6282)] = 241038,
  [SMALL_STATE(6283)] = 241073,
  [SMALL_STATE(6284)] = 241098,
  [SMALL_STATE(6285)] = 241127,
  [SMALL_STATE(6286)] = 241152,
  [SMALL_STATE(6287)] = 241183,
  [SMALL_STATE(6288)] = 241208,
  [SMALL_STATE(6289)] = 241243,
  [SMALL_STATE(6290)] = 241274,
  [SMALL_STATE(6291)] = 241309,
  [SMALL_STATE(6292)] = 241330,
  [SMALL_STATE(6293)] = 241360,
  [SMALL_STATE(6294)] = 241382,
  [SMALL_STATE(6295)] = 241404,
  [SMALL_STATE(6296)] = 241426,
  [SMALL_STATE(6297)] = 241450,
  [SMALL_STATE(6298)] = 241474,
  [SMALL_STATE(6299)] = 241498,
  [SMALL_STATE(6300)] = 241516,
  [SMALL_STATE(6301)] = 241534,
  [SMALL_STATE(6302)] = 241556,
  [SMALL_STATE(6303)] = 241580,
  [SMALL_STATE(6304)] = 241602,
  [SMALL_STATE(6305)] = 241626,
  [SMALL_STATE(6306)] = 241656,
  [SMALL_STATE(6307)] = 241686,
  [SMALL_STATE(6308)] = 241708,
  [SMALL_STATE(6309)] = 241726,
  [SMALL_STATE(6310)] = 241750,
  [SMALL_STATE(6311)] = 241774,
  [SMALL_STATE(6312)] = 241798,
  [SMALL_STATE(6313)] = 241816,
  [SMALL_STATE(6314)] = 241846,
  [SMALL_STATE(6315)] = 241878,
  [SMALL_STATE(6316)] = 241902,
  [SMALL_STATE(6317)] = 241920,
  [SMALL_STATE(6318)] = 241942,
  [SMALL_STATE(6319)] = 241972,
  [SMALL_STATE(6320)] = 241994,
  [SMALL_STATE(6321)] = 242016,
  [SMALL_STATE(6322)] = 242046,
  [SMALL_STATE(6323)] = 242068,
  [SMALL_STATE(6324)] = 242086,
  [SMALL_STATE(6325)] = 242108,
  [SMALL_STATE(6326)] = 242138,
  [SMALL_STATE(6327)] = 242156,
  [SMALL_STATE(6328)] = 242178,
  [SMALL_STATE(6329)] = 242200,
  [SMALL_STATE(6330)] = 242230,
  [SMALL_STATE(6331)] = 242254,
  [SMALL_STATE(6332)] = 242285,
  [SMALL_STATE(6333)] = 242312,
  [SMALL_STATE(6334)] = 242343,
  [SMALL_STATE(6335)] = 242374,
  [SMALL_STATE(6336)] = 242405,
  [SMALL_STATE(6337)] = 242436,
  [SMALL_STATE(6338)] = 242467,
  [SMALL_STATE(6339)] = 242488,
  [SMALL_STATE(6340)] = 242519,
  [SMALL_STATE(6341)] = 242540,
  [SMALL_STATE(6342)] = 242561,
  [SMALL_STATE(6343)] = 242592,
  [SMALL_STATE(6344)] = 242619,
  [SMALL_STATE(6345)] = 242642,
  [SMALL_STATE(6346)] = 242665,
  [SMALL_STATE(6347)] = 242696,
  [SMALL_STATE(6348)] = 242719,
  [SMALL_STATE(6349)] = 242750,
  [SMALL_STATE(6350)] = 242781,
  [SMALL_STATE(6351)] = 242808,
  [SMALL_STATE(6352)] = 242831,
  [SMALL_STATE(6353)] = 242854,
  [SMALL_STATE(6354)] = 242885,
  [SMALL_STATE(6355)] = 242908,
  [SMALL_STATE(6356)] = 242939,
  [SMALL_STATE(6357)] = 242970,
  [SMALL_STATE(6358)] = 242997,
  [SMALL_STATE(6359)] = 243028,
  [SMALL_STATE(6360)] = 243047,
  [SMALL_STATE(6361)] = 243068,
  [SMALL_STATE(6362)] = 243099,
  [SMALL_STATE(6363)] = 243122,
  [SMALL_STATE(6364)] = 243149,
  [SMALL_STATE(6365)] = 243180,
  [SMALL_STATE(6366)] = 243211,
  [SMALL_STATE(6367)] = 243234,
  [SMALL_STATE(6368)] = 243265,
  [SMALL_STATE(6369)] = 243296,
  [SMALL_STATE(6370)] = 243327,
  [SMALL_STATE(6371)] = 243350,
  [SMALL_STATE(6372)] = 243381,
  [SMALL_STATE(6373)] = 243404,
  [SMALL_STATE(6374)] = 243435,
  [SMALL_STATE(6375)] = 243456,
  [SMALL_STATE(6376)] = 243487,
  [SMALL_STATE(6377)] = 243518,
  [SMALL_STATE(6378)] = 243549,
  [SMALL_STATE(6379)] = 243574,
  [SMALL_STATE(6380)] = 243601,
  [SMALL_STATE(6381)] = 243632,
  [SMALL_STATE(6382)] = 243663,
  [SMALL_STATE(6383)] = 243682,
  [SMALL_STATE(6384)] = 243713,
  [SMALL_STATE(6385)] = 243740,
  [SMALL_STATE(6386)] = 243762,
  [SMALL_STATE(6387)] = 243788,
  [SMALL_STATE(6388)] = 243810,
  [SMALL_STATE(6389)] = 243826,
  [SMALL_STATE(6390)] = 243852,
  [SMALL_STATE(6391)] = 243874,
  [SMALL_STATE(6392)] = 243900,
  [SMALL_STATE(6393)] = 243922,
  [SMALL_STATE(6394)] = 243948,
  [SMALL_STATE(6395)] = 243970,
  [SMALL_STATE(6396)] = 243992,
  [SMALL_STATE(6397)] = 244012,
  [SMALL_STATE(6398)] = 244038,
  [SMALL_STATE(6399)] = 244056,
  [SMALL_STATE(6400)] = 244076,
  [SMALL_STATE(6401)] = 244102,
  [SMALL_STATE(6402)] = 244128,
  [SMALL_STATE(6403)] = 244150,
  [SMALL_STATE(6404)] = 244176,
  [SMALL_STATE(6405)] = 244202,
  [SMALL_STATE(6406)] = 244228,
  [SMALL_STATE(6407)] = 244254,
  [SMALL_STATE(6408)] = 244280,
  [SMALL_STATE(6409)] = 244306,
  [SMALL_STATE(6410)] = 244332,
  [SMALL_STATE(6411)] = 244358,
  [SMALL_STATE(6412)] = 244380,
  [SMALL_STATE(6413)] = 244396,
  [SMALL_STATE(6414)] = 244418,
  [SMALL_STATE(6415)] = 244444,
  [SMALL_STATE(6416)] = 244470,
  [SMALL_STATE(6417)] = 244496,
  [SMALL_STATE(6418)] = 244518,
  [SMALL_STATE(6419)] = 244544,
  [SMALL_STATE(6420)] = 244570,
  [SMALL_STATE(6421)] = 244592,
  [SMALL_STATE(6422)] = 244618,
  [SMALL_STATE(6423)] = 244644,
  [SMALL_STATE(6424)] = 244670,
  [SMALL_STATE(6425)] = 244696,
  [SMALL_STATE(6426)] = 244722,
  [SMALL_STATE(6427)] = 244742,
  [SMALL_STATE(6428)] = 244762,
  [SMALL_STATE(6429)] = 244788,
  [SMALL_STATE(6430)] = 244810,
  [SMALL_STATE(6431)] = 244836,
  [SMALL_STATE(6432)] = 244862,
  [SMALL_STATE(6433)] = 244888,
  [SMALL_STATE(6434)] = 244914,
  [SMALL_STATE(6435)] = 244937,
  [SMALL_STATE(6436)] = 244958,
  [SMALL_STATE(6437)] = 244979,
  [SMALL_STATE(6438)] = 245000,
  [SMALL_STATE(6439)] = 245023,
  [SMALL_STATE(6440)] = 245044,
  [SMALL_STATE(6441)] = 245059,
  [SMALL_STATE(6442)] = 245082,
  [SMALL_STATE(6443)] = 245105,
  [SMALL_STATE(6444)] = 245126,
  [SMALL_STATE(6445)] = 245151,
  [SMALL_STATE(6446)] = 245176,
  [SMALL_STATE(6447)] = 245201,
  [SMALL_STATE(6448)] = 245224,
  [SMALL_STATE(6449)] = 245247,
  [SMALL_STATE(6450)] = 245268,
  [SMALL_STATE(6451)] = 245293,
  [SMALL_STATE(6452)] = 245316,
  [SMALL_STATE(6453)] = 245331,
  [SMALL_STATE(6454)] = 245346,
  [SMALL_STATE(6455)] = 245371,
  [SMALL_STATE(6456)] = 245386,
  [SMALL_STATE(6457)] = 245407,
  [SMALL_STATE(6458)] = 245430,
  [SMALL_STATE(6459)] = 245455,
  [SMALL_STATE(6460)] = 245470,
  [SMALL_STATE(6461)] = 245487,
  [SMALL_STATE(6462)] = 245502,
  [SMALL_STATE(6463)] = 245521,
  [SMALL_STATE(6464)] = 245544,
  [SMALL_STATE(6465)] = 245565,
  [SMALL_STATE(6466)] = 245586,
  [SMALL_STATE(6467)] = 245607,
  [SMALL_STATE(6468)] = 245622,
  [SMALL_STATE(6469)] = 245641,
  [SMALL_STATE(6470)] = 245664,
  [SMALL_STATE(6471)] = 245685,
  [SMALL_STATE(6472)] = 245708,
  [SMALL_STATE(6473)] = 245729,
  [SMALL_STATE(6474)] = 245752,
  [SMALL_STATE(6475)] = 245775,
  [SMALL_STATE(6476)] = 245794,
  [SMALL_STATE(6477)] = 245809,
  [SMALL_STATE(6478)] = 245834,
  [SMALL_STATE(6479)] = 245855,
  [SMALL_STATE(6480)] = 245876,
  [SMALL_STATE(6481)] = 245901,
  [SMALL_STATE(6482)] = 245922,
  [SMALL_STATE(6483)] = 245943,
  [SMALL_STATE(6484)] = 245966,
  [SMALL_STATE(6485)] = 245989,
  [SMALL_STATE(6486)] = 246003,
  [SMALL_STATE(6487)] = 246019,
  [SMALL_STATE(6488)] = 246037,
  [SMALL_STATE(6489)] = 246051,
  [SMALL_STATE(6490)] = 246065,
  [SMALL_STATE(6491)] = 246079,
  [SMALL_STATE(6492)] = 246093,
  [SMALL_STATE(6493)] = 246107,
  [SMALL_STATE(6494)] = 246127,
  [SMALL_STATE(6495)] = 246147,
  [SMALL_STATE(6496)] = 246165,
  [SMALL_STATE(6497)] = 246179,
  [SMALL_STATE(6498)] = 246197,
  [SMALL_STATE(6499)] = 246217,
  [SMALL_STATE(6500)] = 246233,
  [SMALL_STATE(6501)] = 246249,
  [SMALL_STATE(6502)] = 246265,
  [SMALL_STATE(6503)] = 246279,
  [SMALL_STATE(6504)] = 246297,
  [SMALL_STATE(6505)] = 246311,
  [SMALL_STATE(6506)] = 246331,
  [SMALL_STATE(6507)] = 246351,
  [SMALL_STATE(6508)] = 246365,
  [SMALL_STATE(6509)] = 246385,
  [SMALL_STATE(6510)] = 246405,
  [SMALL_STATE(6511)] = 246425,
  [SMALL_STATE(6512)] = 246439,
  [SMALL_STATE(6513)] = 246459,
  [SMALL_STATE(6514)] = 246479,
  [SMALL_STATE(6515)] = 246497,
  [SMALL_STATE(6516)] = 246513,
  [SMALL_STATE(6517)] = 246529,
  [SMALL_STATE(6518)] = 246549,
  [SMALL_STATE(6519)] = 246567,
  [SMALL_STATE(6520)] = 246583,
  [SMALL_STATE(6521)] = 246599,
  [SMALL_STATE(6522)] = 246615,
  [SMALL_STATE(6523)] = 246633,
  [SMALL_STATE(6524)] = 246649,
  [SMALL_STATE(6525)] = 246665,
  [SMALL_STATE(6526)] = 246683,
  [SMALL_STATE(6527)] = 246699,
  [SMALL_STATE(6528)] = 246713,
  [SMALL_STATE(6529)] = 246733,
  [SMALL_STATE(6530)] = 246753,
  [SMALL_STATE(6531)] = 246767,
  [SMALL_STATE(6532)] = 246783,
  [SMALL_STATE(6533)] = 246803,
  [SMALL_STATE(6534)] = 246817,
  [SMALL_STATE(6535)] = 246833,
  [SMALL_STATE(6536)] = 246849,
  [SMALL_STATE(6537)] = 246869,
  [SMALL_STATE(6538)] = 246889,
  [SMALL_STATE(6539)] = 246908,
  [SMALL_STATE(6540)] = 246927,
  [SMALL_STATE(6541)] = 246946,
  [SMALL_STATE(6542)] = 246965,
  [SMALL_STATE(6543)] = 246984,
  [SMALL_STATE(6544)] = 247001,
  [SMALL_STATE(6545)] = 247020,
  [SMALL_STATE(6546)] = 247039,
  [SMALL_STATE(6547)] = 247056,
  [SMALL_STATE(6548)] = 247075,
  [SMALL_STATE(6549)] = 247094,
  [SMALL_STATE(6550)] = 247113,
  [SMALL_STATE(6551)] = 247132,
  [SMALL_STATE(6552)] = 247151,
  [SMALL_STATE(6553)] = 247170,
  [SMALL_STATE(6554)] = 247187,
  [SMALL_STATE(6555)] = 247200,
  [SMALL_STATE(6556)] = 247217,
  [SMALL_STATE(6557)] = 247236,
  [SMALL_STATE(6558)] = 247255,
  [SMALL_STATE(6559)] = 247272,
  [SMALL_STATE(6560)] = 247291,
  [SMALL_STATE(6561)] = 247310,
  [SMALL_STATE(6562)] = 247329,
  [SMALL_STATE(6563)] = 247348,
  [SMALL_STATE(6564)] = 247367,
  [SMALL_STATE(6565)] = 247386,
  [SMALL_STATE(6566)] = 247399,
  [SMALL_STATE(6567)] = 247418,
  [SMALL_STATE(6568)] = 247437,
  [SMALL_STATE(6569)] = 247456,
  [SMALL_STATE(6570)] = 247469,
  [SMALL_STATE(6571)] = 247488,
  [SMALL_STATE(6572)] = 247507,
  [SMALL_STATE(6573)] = 247526,
  [SMALL_STATE(6574)] = 247545,
  [SMALL_STATE(6575)] = 247562,
  [SMALL_STATE(6576)] = 247581,
  [SMALL_STATE(6577)] = 247600,
  [SMALL_STATE(6578)] = 247619,
  [SMALL_STATE(6579)] = 247636,
  [SMALL_STATE(6580)] = 247655,
  [SMALL_STATE(6581)] = 247674,
  [SMALL_STATE(6582)] = 247693,
  [SMALL_STATE(6583)] = 247712,
  [SMALL_STATE(6584)] = 247731,
  [SMALL_STATE(6585)] = 247744,
  [SMALL_STATE(6586)] = 247763,
  [SMALL_STATE(6587)] = 247782,
  [SMALL_STATE(6588)] = 247801,
  [SMALL_STATE(6589)] = 247820,
  [SMALL_STATE(6590)] = 247839,
  [SMALL_STATE(6591)] = 247858,
  [SMALL_STATE(6592)] = 247877,
  [SMALL_STATE(6593)] = 247896,
  [SMALL_STATE(6594)] = 247915,
  [SMALL_STATE(6595)] = 247934,
  [SMALL_STATE(6596)] = 247953,
  [SMALL_STATE(6597)] = 247972,
  [SMALL_STATE(6598)] = 247991,
  [SMALL_STATE(6599)] = 248010,
  [SMALL_STATE(6600)] = 248024,
  [SMALL_STATE(6601)] = 248040,
  [SMALL_STATE(6602)] = 248056,
  [SMALL_STATE(6603)] = 248070,
  [SMALL_STATE(6604)] = 248086,
  [SMALL_STATE(6605)] = 248100,
  [SMALL_STATE(6606)] = 248114,
  [SMALL_STATE(6607)] = 248130,
  [SMALL_STATE(6608)] = 248144,
  [SMALL_STATE(6609)] = 248160,
  [SMALL_STATE(6610)] = 248176,
  [SMALL_STATE(6611)] = 248192,
  [SMALL_STATE(6612)] = 248208,
  [SMALL_STATE(6613)] = 248224,
  [SMALL_STATE(6614)] = 248240,
  [SMALL_STATE(6615)] = 248256,
  [SMALL_STATE(6616)] = 248272,
  [SMALL_STATE(6617)] = 248286,
  [SMALL_STATE(6618)] = 248302,
  [SMALL_STATE(6619)] = 248318,
  [SMALL_STATE(6620)] = 248334,
  [SMALL_STATE(6621)] = 248348,
  [SMALL_STATE(6622)] = 248362,
  [SMALL_STATE(6623)] = 248376,
  [SMALL_STATE(6624)] = 248390,
  [SMALL_STATE(6625)] = 248406,
  [SMALL_STATE(6626)] = 248422,
  [SMALL_STATE(6627)] = 248438,
  [SMALL_STATE(6628)] = 248454,
  [SMALL_STATE(6629)] = 248468,
  [SMALL_STATE(6630)] = 248484,
  [SMALL_STATE(6631)] = 248498,
  [SMALL_STATE(6632)] = 248512,
  [SMALL_STATE(6633)] = 248526,
  [SMALL_STATE(6634)] = 248542,
  [SMALL_STATE(6635)] = 248556,
  [SMALL_STATE(6636)] = 248572,
  [SMALL_STATE(6637)] = 248588,
  [SMALL_STATE(6638)] = 248602,
  [SMALL_STATE(6639)] = 248616,
  [SMALL_STATE(6640)] = 248632,
  [SMALL_STATE(6641)] = 248648,
  [SMALL_STATE(6642)] = 248662,
  [SMALL_STATE(6643)] = 248678,
  [SMALL_STATE(6644)] = 248694,
  [SMALL_STATE(6645)] = 248710,
  [SMALL_STATE(6646)] = 248724,
  [SMALL_STATE(6647)] = 248740,
  [SMALL_STATE(6648)] = 248754,
  [SMALL_STATE(6649)] = 248770,
  [SMALL_STATE(6650)] = 248786,
  [SMALL_STATE(6651)] = 248796,
  [SMALL_STATE(6652)] = 248812,
  [SMALL_STATE(6653)] = 248828,
  [SMALL_STATE(6654)] = 248844,
  [SMALL_STATE(6655)] = 248858,
  [SMALL_STATE(6656)] = 248874,
  [SMALL_STATE(6657)] = 248888,
  [SMALL_STATE(6658)] = 248904,
  [SMALL_STATE(6659)] = 248920,
  [SMALL_STATE(6660)] = 248934,
  [SMALL_STATE(6661)] = 248950,
  [SMALL_STATE(6662)] = 248966,
  [SMALL_STATE(6663)] = 248980,
  [SMALL_STATE(6664)] = 248996,
  [SMALL_STATE(6665)] = 249012,
  [SMALL_STATE(6666)] = 249026,
  [SMALL_STATE(6667)] = 249042,
  [SMALL_STATE(6668)] = 249058,
  [SMALL_STATE(6669)] = 249074,
  [SMALL_STATE(6670)] = 249090,
  [SMALL_STATE(6671)] = 249104,
  [SMALL_STATE(6672)] = 249120,
  [SMALL_STATE(6673)] = 249136,
  [SMALL_STATE(6674)] = 249152,
  [SMALL_STATE(6675)] = 249168,
  [SMALL_STATE(6676)] = 249184,
  [SMALL_STATE(6677)] = 249200,
  [SMALL_STATE(6678)] = 249216,
  [SMALL_STATE(6679)] = 249230,
  [SMALL_STATE(6680)] = 249244,
  [SMALL_STATE(6681)] = 249258,
  [SMALL_STATE(6682)] = 249274,
  [SMALL_STATE(6683)] = 249290,
  [SMALL_STATE(6684)] = 249304,
  [SMALL_STATE(6685)] = 249320,
  [SMALL_STATE(6686)] = 249336,
  [SMALL_STATE(6687)] = 249350,
  [SMALL_STATE(6688)] = 249364,
  [SMALL_STATE(6689)] = 249380,
  [SMALL_STATE(6690)] = 249396,
  [SMALL_STATE(6691)] = 249412,
  [SMALL_STATE(6692)] = 249428,
  [SMALL_STATE(6693)] = 249444,
  [SMALL_STATE(6694)] = 249460,
  [SMALL_STATE(6695)] = 249474,
  [SMALL_STATE(6696)] = 249490,
  [SMALL_STATE(6697)] = 249506,
  [SMALL_STATE(6698)] = 249522,
  [SMALL_STATE(6699)] = 249536,
  [SMALL_STATE(6700)] = 249550,
  [SMALL_STATE(6701)] = 249564,
  [SMALL_STATE(6702)] = 249578,
  [SMALL_STATE(6703)] = 249592,
  [SMALL_STATE(6704)] = 249608,
  [SMALL_STATE(6705)] = 249622,
  [SMALL_STATE(6706)] = 249636,
  [SMALL_STATE(6707)] = 249652,
  [SMALL_STATE(6708)] = 249666,
  [SMALL_STATE(6709)] = 249682,
  [SMALL_STATE(6710)] = 249696,
  [SMALL_STATE(6711)] = 249712,
  [SMALL_STATE(6712)] = 249728,
  [SMALL_STATE(6713)] = 249744,
  [SMALL_STATE(6714)] = 249760,
  [SMALL_STATE(6715)] = 249776,
  [SMALL_STATE(6716)] = 249792,
  [SMALL_STATE(6717)] = 249808,
  [SMALL_STATE(6718)] = 249822,
  [SMALL_STATE(6719)] = 249836,
  [SMALL_STATE(6720)] = 249852,
  [SMALL_STATE(6721)] = 249866,
  [SMALL_STATE(6722)] = 249880,
  [SMALL_STATE(6723)] = 249896,
  [SMALL_STATE(6724)] = 249910,
  [SMALL_STATE(6725)] = 249926,
  [SMALL_STATE(6726)] = 249942,
  [SMALL_STATE(6727)] = 249958,
  [SMALL_STATE(6728)] = 249972,
  [SMALL_STATE(6729)] = 249988,
  [SMALL_STATE(6730)] = 250002,
  [SMALL_STATE(6731)] = 250016,
  [SMALL_STATE(6732)] = 250030,
  [SMALL_STATE(6733)] = 250046,
  [SMALL_STATE(6734)] = 250062,
  [SMALL_STATE(6735)] = 250076,
  [SMALL_STATE(6736)] = 250092,
  [SMALL_STATE(6737)] = 250106,
  [SMALL_STATE(6738)] = 250120,
  [SMALL_STATE(6739)] = 250136,
  [SMALL_STATE(6740)] = 250152,
  [SMALL_STATE(6741)] = 250168,
  [SMALL_STATE(6742)] = 250184,
  [SMALL_STATE(6743)] = 250198,
  [SMALL_STATE(6744)] = 250212,
  [SMALL_STATE(6745)] = 250226,
  [SMALL_STATE(6746)] = 250240,
  [SMALL_STATE(6747)] = 250252,
  [SMALL_STATE(6748)] = 250268,
  [SMALL_STATE(6749)] = 250282,
  [SMALL_STATE(6750)] = 250296,
  [SMALL_STATE(6751)] = 250312,
  [SMALL_STATE(6752)] = 250326,
  [SMALL_STATE(6753)] = 250342,
  [SMALL_STATE(6754)] = 250356,
  [SMALL_STATE(6755)] = 250372,
  [SMALL_STATE(6756)] = 250388,
  [SMALL_STATE(6757)] = 250402,
  [SMALL_STATE(6758)] = 250418,
  [SMALL_STATE(6759)] = 250432,
  [SMALL_STATE(6760)] = 250448,
  [SMALL_STATE(6761)] = 250462,
  [SMALL_STATE(6762)] = 250476,
  [SMALL_STATE(6763)] = 250492,
  [SMALL_STATE(6764)] = 250506,
  [SMALL_STATE(6765)] = 250520,
  [SMALL_STATE(6766)] = 250536,
  [SMALL_STATE(6767)] = 250552,
  [SMALL_STATE(6768)] = 250568,
  [SMALL_STATE(6769)] = 250582,
  [SMALL_STATE(6770)] = 250596,
  [SMALL_STATE(6771)] = 250610,
  [SMALL_STATE(6772)] = 250626,
  [SMALL_STATE(6773)] = 250640,
  [SMALL_STATE(6774)] = 250656,
  [SMALL_STATE(6775)] = 250672,
  [SMALL_STATE(6776)] = 250686,
  [SMALL_STATE(6777)] = 250700,
  [SMALL_STATE(6778)] = 250714,
  [SMALL_STATE(6779)] = 250728,
  [SMALL_STATE(6780)] = 250744,
  [SMALL_STATE(6781)] = 250760,
  [SMALL_STATE(6782)] = 250774,
  [SMALL_STATE(6783)] = 250788,
  [SMALL_STATE(6784)] = 250804,
  [SMALL_STATE(6785)] = 250820,
  [SMALL_STATE(6786)] = 250836,
  [SMALL_STATE(6787)] = 250852,
  [SMALL_STATE(6788)] = 250868,
  [SMALL_STATE(6789)] = 250884,
  [SMALL_STATE(6790)] = 250900,
  [SMALL_STATE(6791)] = 250914,
  [SMALL_STATE(6792)] = 250928,
  [SMALL_STATE(6793)] = 250944,
  [SMALL_STATE(6794)] = 250958,
  [SMALL_STATE(6795)] = 250974,
  [SMALL_STATE(6796)] = 250990,
  [SMALL_STATE(6797)] = 251004,
  [SMALL_STATE(6798)] = 251020,
  [SMALL_STATE(6799)] = 251034,
  [SMALL_STATE(6800)] = 251048,
  [SMALL_STATE(6801)] = 251062,
  [SMALL_STATE(6802)] = 251072,
  [SMALL_STATE(6803)] = 251086,
  [SMALL_STATE(6804)] = 251102,
  [SMALL_STATE(6805)] = 251116,
  [SMALL_STATE(6806)] = 251132,
  [SMALL_STATE(6807)] = 251146,
  [SMALL_STATE(6808)] = 251160,
  [SMALL_STATE(6809)] = 251176,
  [SMALL_STATE(6810)] = 251190,
  [SMALL_STATE(6811)] = 251206,
  [SMALL_STATE(6812)] = 251220,
  [SMALL_STATE(6813)] = 251234,
  [SMALL_STATE(6814)] = 251250,
  [SMALL_STATE(6815)] = 251264,
  [SMALL_STATE(6816)] = 251278,
  [SMALL_STATE(6817)] = 251292,
  [SMALL_STATE(6818)] = 251306,
  [SMALL_STATE(6819)] = 251320,
  [SMALL_STATE(6820)] = 251334,
  [SMALL_STATE(6821)] = 251348,
  [SMALL_STATE(6822)] = 251362,
  [SMALL_STATE(6823)] = 251376,
  [SMALL_STATE(6824)] = 251390,
  [SMALL_STATE(6825)] = 251404,
  [SMALL_STATE(6826)] = 251420,
  [SMALL_STATE(6827)] = 251434,
  [SMALL_STATE(6828)] = 251448,
  [SMALL_STATE(6829)] = 251462,
  [SMALL_STATE(6830)] = 251478,
  [SMALL_STATE(6831)] = 251492,
  [SMALL_STATE(6832)] = 251508,
  [SMALL_STATE(6833)] = 251518,
  [SMALL_STATE(6834)] = 251534,
  [SMALL_STATE(6835)] = 251550,
  [SMALL_STATE(6836)] = 251564,
  [SMALL_STATE(6837)] = 251580,
  [SMALL_STATE(6838)] = 251594,
  [SMALL_STATE(6839)] = 251608,
  [SMALL_STATE(6840)] = 251624,
  [SMALL_STATE(6841)] = 251638,
  [SMALL_STATE(6842)] = 251652,
  [SMALL_STATE(6843)] = 251666,
  [SMALL_STATE(6844)] = 251682,
  [SMALL_STATE(6845)] = 251696,
  [SMALL_STATE(6846)] = 251710,
  [SMALL_STATE(6847)] = 251724,
  [SMALL_STATE(6848)] = 251738,
  [SMALL_STATE(6849)] = 251754,
  [SMALL_STATE(6850)] = 251770,
  [SMALL_STATE(6851)] = 251786,
  [SMALL_STATE(6852)] = 251800,
  [SMALL_STATE(6853)] = 251816,
  [SMALL_STATE(6854)] = 251832,
  [SMALL_STATE(6855)] = 251846,
  [SMALL_STATE(6856)] = 251862,
  [SMALL_STATE(6857)] = 251878,
  [SMALL_STATE(6858)] = 251894,
  [SMALL_STATE(6859)] = 251910,
  [SMALL_STATE(6860)] = 251921,
  [SMALL_STATE(6861)] = 251930,
  [SMALL_STATE(6862)] = 251943,
  [SMALL_STATE(6863)] = 251956,
  [SMALL_STATE(6864)] = 251969,
  [SMALL_STATE(6865)] = 251982,
  [SMALL_STATE(6866)] = 251995,
  [SMALL_STATE(6867)] = 252008,
  [SMALL_STATE(6868)] = 252021,
  [SMALL_STATE(6869)] = 252032,
  [SMALL_STATE(6870)] = 252045,
  [SMALL_STATE(6871)] = 252058,
  [SMALL_STATE(6872)] = 252071,
  [SMALL_STATE(6873)] = 252084,
  [SMALL_STATE(6874)] = 252097,
  [SMALL_STATE(6875)] = 252106,
  [SMALL_STATE(6876)] = 252119,
  [SMALL_STATE(6877)] = 252132,
  [SMALL_STATE(6878)] = 252145,
  [SMALL_STATE(6879)] = 252156,
  [SMALL_STATE(6880)] = 252169,
  [SMALL_STATE(6881)] = 252182,
  [SMALL_STATE(6882)] = 252193,
  [SMALL_STATE(6883)] = 252204,
  [SMALL_STATE(6884)] = 252213,
  [SMALL_STATE(6885)] = 252226,
  [SMALL_STATE(6886)] = 252235,
  [SMALL_STATE(6887)] = 252244,
  [SMALL_STATE(6888)] = 252257,
  [SMALL_STATE(6889)] = 252270,
  [SMALL_STATE(6890)] = 252283,
  [SMALL_STATE(6891)] = 252296,
  [SMALL_STATE(6892)] = 252309,
  [SMALL_STATE(6893)] = 252322,
  [SMALL_STATE(6894)] = 252335,
  [SMALL_STATE(6895)] = 252348,
  [SMALL_STATE(6896)] = 252361,
  [SMALL_STATE(6897)] = 252374,
  [SMALL_STATE(6898)] = 252387,
  [SMALL_STATE(6899)] = 252400,
  [SMALL_STATE(6900)] = 252413,
  [SMALL_STATE(6901)] = 252426,
  [SMALL_STATE(6902)] = 252439,
  [SMALL_STATE(6903)] = 252452,
  [SMALL_STATE(6904)] = 252465,
  [SMALL_STATE(6905)] = 252478,
  [SMALL_STATE(6906)] = 252491,
  [SMALL_STATE(6907)] = 252504,
  [SMALL_STATE(6908)] = 252517,
  [SMALL_STATE(6909)] = 252530,
  [SMALL_STATE(6910)] = 252541,
  [SMALL_STATE(6911)] = 252554,
  [SMALL_STATE(6912)] = 252567,
  [SMALL_STATE(6913)] = 252580,
  [SMALL_STATE(6914)] = 252593,
  [SMALL_STATE(6915)] = 252606,
  [SMALL_STATE(6916)] = 252619,
  [SMALL_STATE(6917)] = 252632,
  [SMALL_STATE(6918)] = 252645,
  [SMALL_STATE(6919)] = 252658,
  [SMALL_STATE(6920)] = 252671,
  [SMALL_STATE(6921)] = 252684,
  [SMALL_STATE(6922)] = 252695,
  [SMALL_STATE(6923)] = 252706,
  [SMALL_STATE(6924)] = 252719,
  [SMALL_STATE(6925)] = 252732,
  [SMALL_STATE(6926)] = 252745,
  [SMALL_STATE(6927)] = 252758,
  [SMALL_STATE(6928)] = 252771,
  [SMALL_STATE(6929)] = 252784,
  [SMALL_STATE(6930)] = 252797,
  [SMALL_STATE(6931)] = 252810,
  [SMALL_STATE(6932)] = 252823,
  [SMALL_STATE(6933)] = 252836,
  [SMALL_STATE(6934)] = 252849,
  [SMALL_STATE(6935)] = 252862,
  [SMALL_STATE(6936)] = 252873,
  [SMALL_STATE(6937)] = 252884,
  [SMALL_STATE(6938)] = 252897,
  [SMALL_STATE(6939)] = 252910,
  [SMALL_STATE(6940)] = 252919,
  [SMALL_STATE(6941)] = 252932,
  [SMALL_STATE(6942)] = 252945,
  [SMALL_STATE(6943)] = 252956,
  [SMALL_STATE(6944)] = 252969,
  [SMALL_STATE(6945)] = 252982,
  [SMALL_STATE(6946)] = 252995,
  [SMALL_STATE(6947)] = 253008,
  [SMALL_STATE(6948)] = 253021,
  [SMALL_STATE(6949)] = 253034,
  [SMALL_STATE(6950)] = 253047,
  [SMALL_STATE(6951)] = 253060,
  [SMALL_STATE(6952)] = 253073,
  [SMALL_STATE(6953)] = 253086,
  [SMALL_STATE(6954)] = 253099,
  [SMALL_STATE(6955)] = 253112,
  [SMALL_STATE(6956)] = 253125,
  [SMALL_STATE(6957)] = 253138,
  [SMALL_STATE(6958)] = 253151,
  [SMALL_STATE(6959)] = 253164,
  [SMALL_STATE(6960)] = 253177,
  [SMALL_STATE(6961)] = 253190,
  [SMALL_STATE(6962)] = 253203,
  [SMALL_STATE(6963)] = 253216,
  [SMALL_STATE(6964)] = 253227,
  [SMALL_STATE(6965)] = 253240,
  [SMALL_STATE(6966)] = 253253,
  [SMALL_STATE(6967)] = 253266,
  [SMALL_STATE(6968)] = 253279,
  [SMALL_STATE(6969)] = 253292,
  [SMALL_STATE(6970)] = 253305,
  [SMALL_STATE(6971)] = 253318,
  [SMALL_STATE(6972)] = 253329,
  [SMALL_STATE(6973)] = 253342,
  [SMALL_STATE(6974)] = 253355,
  [SMALL_STATE(6975)] = 253368,
  [SMALL_STATE(6976)] = 253381,
  [SMALL_STATE(6977)] = 253392,
  [SMALL_STATE(6978)] = 253405,
  [SMALL_STATE(6979)] = 253418,
  [SMALL_STATE(6980)] = 253431,
  [SMALL_STATE(6981)] = 253444,
  [SMALL_STATE(6982)] = 253457,
  [SMALL_STATE(6983)] = 253468,
  [SMALL_STATE(6984)] = 253481,
  [SMALL_STATE(6985)] = 253494,
  [SMALL_STATE(6986)] = 253507,
  [SMALL_STATE(6987)] = 253520,
  [SMALL_STATE(6988)] = 253533,
  [SMALL_STATE(6989)] = 253546,
  [SMALL_STATE(6990)] = 253559,
  [SMALL_STATE(6991)] = 253572,
  [SMALL_STATE(6992)] = 253585,
  [SMALL_STATE(6993)] = 253598,
  [SMALL_STATE(6994)] = 253611,
  [SMALL_STATE(6995)] = 253624,
  [SMALL_STATE(6996)] = 253637,
  [SMALL_STATE(6997)] = 253648,
  [SMALL_STATE(6998)] = 253661,
  [SMALL_STATE(6999)] = 253674,
  [SMALL_STATE(7000)] = 253687,
  [SMALL_STATE(7001)] = 253700,
  [SMALL_STATE(7002)] = 253713,
  [SMALL_STATE(7003)] = 253726,
  [SMALL_STATE(7004)] = 253739,
  [SMALL_STATE(7005)] = 253752,
  [SMALL_STATE(7006)] = 253765,
  [SMALL_STATE(7007)] = 253778,
  [SMALL_STATE(7008)] = 253791,
  [SMALL_STATE(7009)] = 253804,
  [SMALL_STATE(7010)] = 253817,
  [SMALL_STATE(7011)] = 253830,
  [SMALL_STATE(7012)] = 253843,
  [SMALL_STATE(7013)] = 253856,
  [SMALL_STATE(7014)] = 253869,
  [SMALL_STATE(7015)] = 253882,
  [SMALL_STATE(7016)] = 253895,
  [SMALL_STATE(7017)] = 253908,
  [SMALL_STATE(7018)] = 253921,
  [SMALL_STATE(7019)] = 253934,
  [SMALL_STATE(7020)] = 253947,
  [SMALL_STATE(7021)] = 253960,
  [SMALL_STATE(7022)] = 253973,
  [SMALL_STATE(7023)] = 253986,
  [SMALL_STATE(7024)] = 253999,
  [SMALL_STATE(7025)] = 254012,
  [SMALL_STATE(7026)] = 254025,
  [SMALL_STATE(7027)] = 254038,
  [SMALL_STATE(7028)] = 254049,
  [SMALL_STATE(7029)] = 254060,
  [SMALL_STATE(7030)] = 254073,
  [SMALL_STATE(7031)] = 254086,
  [SMALL_STATE(7032)] = 254099,
  [SMALL_STATE(7033)] = 254112,
  [SMALL_STATE(7034)] = 254125,
  [SMALL_STATE(7035)] = 254136,
  [SMALL_STATE(7036)] = 254149,
  [SMALL_STATE(7037)] = 254162,
  [SMALL_STATE(7038)] = 254175,
  [SMALL_STATE(7039)] = 254188,
  [SMALL_STATE(7040)] = 254201,
  [SMALL_STATE(7041)] = 254214,
  [SMALL_STATE(7042)] = 254225,
  [SMALL_STATE(7043)] = 254238,
  [SMALL_STATE(7044)] = 254249,
  [SMALL_STATE(7045)] = 254262,
  [SMALL_STATE(7046)] = 254275,
  [SMALL_STATE(7047)] = 254288,
  [SMALL_STATE(7048)] = 254301,
  [SMALL_STATE(7049)] = 254314,
  [SMALL_STATE(7050)] = 254327,
  [SMALL_STATE(7051)] = 254340,
  [SMALL_STATE(7052)] = 254353,
  [SMALL_STATE(7053)] = 254366,
  [SMALL_STATE(7054)] = 254379,
  [SMALL_STATE(7055)] = 254392,
  [SMALL_STATE(7056)] = 254405,
  [SMALL_STATE(7057)] = 254418,
  [SMALL_STATE(7058)] = 254431,
  [SMALL_STATE(7059)] = 254444,
  [SMALL_STATE(7060)] = 254457,
  [SMALL_STATE(7061)] = 254470,
  [SMALL_STATE(7062)] = 254481,
  [SMALL_STATE(7063)] = 254494,
  [SMALL_STATE(7064)] = 254505,
  [SMALL_STATE(7065)] = 254518,
  [SMALL_STATE(7066)] = 254531,
  [SMALL_STATE(7067)] = 254544,
  [SMALL_STATE(7068)] = 254557,
  [SMALL_STATE(7069)] = 254570,
  [SMALL_STATE(7070)] = 254583,
  [SMALL_STATE(7071)] = 254594,
  [SMALL_STATE(7072)] = 254607,
  [SMALL_STATE(7073)] = 254620,
  [SMALL_STATE(7074)] = 254631,
  [SMALL_STATE(7075)] = 254644,
  [SMALL_STATE(7076)] = 254655,
  [SMALL_STATE(7077)] = 254664,
  [SMALL_STATE(7078)] = 254677,
  [SMALL_STATE(7079)] = 254690,
  [SMALL_STATE(7080)] = 254703,
  [SMALL_STATE(7081)] = 254716,
  [SMALL_STATE(7082)] = 254729,
  [SMALL_STATE(7083)] = 254742,
  [SMALL_STATE(7084)] = 254755,
  [SMALL_STATE(7085)] = 254768,
  [SMALL_STATE(7086)] = 254777,
  [SMALL_STATE(7087)] = 254790,
  [SMALL_STATE(7088)] = 254803,
  [SMALL_STATE(7089)] = 254816,
  [SMALL_STATE(7090)] = 254829,
  [SMALL_STATE(7091)] = 254842,
  [SMALL_STATE(7092)] = 254855,
  [SMALL_STATE(7093)] = 254866,
  [SMALL_STATE(7094)] = 254879,
  [SMALL_STATE(7095)] = 254892,
  [SMALL_STATE(7096)] = 254903,
  [SMALL_STATE(7097)] = 254916,
  [SMALL_STATE(7098)] = 254929,
  [SMALL_STATE(7099)] = 254942,
  [SMALL_STATE(7100)] = 254955,
  [SMALL_STATE(7101)] = 254968,
  [SMALL_STATE(7102)] = 254981,
  [SMALL_STATE(7103)] = 254994,
  [SMALL_STATE(7104)] = 255007,
  [SMALL_STATE(7105)] = 255018,
  [SMALL_STATE(7106)] = 255029,
  [SMALL_STATE(7107)] = 255042,
  [SMALL_STATE(7108)] = 255055,
  [SMALL_STATE(7109)] = 255068,
  [SMALL_STATE(7110)] = 255081,
  [SMALL_STATE(7111)] = 255094,
  [SMALL_STATE(7112)] = 255107,
  [SMALL_STATE(7113)] = 255118,
  [SMALL_STATE(7114)] = 255131,
  [SMALL_STATE(7115)] = 255140,
  [SMALL_STATE(7116)] = 255153,
  [SMALL_STATE(7117)] = 255166,
  [SMALL_STATE(7118)] = 255179,
  [SMALL_STATE(7119)] = 255192,
  [SMALL_STATE(7120)] = 255203,
  [SMALL_STATE(7121)] = 255216,
  [SMALL_STATE(7122)] = 255229,
  [SMALL_STATE(7123)] = 255242,
  [SMALL_STATE(7124)] = 255251,
  [SMALL_STATE(7125)] = 255264,
  [SMALL_STATE(7126)] = 255277,
  [SMALL_STATE(7127)] = 255290,
  [SMALL_STATE(7128)] = 255303,
  [SMALL_STATE(7129)] = 255316,
  [SMALL_STATE(7130)] = 255329,
  [SMALL_STATE(7131)] = 255342,
  [SMALL_STATE(7132)] = 255355,
  [SMALL_STATE(7133)] = 255368,
  [SMALL_STATE(7134)] = 255381,
  [SMALL_STATE(7135)] = 255394,
  [SMALL_STATE(7136)] = 255407,
  [SMALL_STATE(7137)] = 255420,
  [SMALL_STATE(7138)] = 255433,
  [SMALL_STATE(7139)] = 255446,
  [SMALL_STATE(7140)] = 255459,
  [SMALL_STATE(7141)] = 255472,
  [SMALL_STATE(7142)] = 255485,
  [SMALL_STATE(7143)] = 255498,
  [SMALL_STATE(7144)] = 255511,
  [SMALL_STATE(7145)] = 255524,
  [SMALL_STATE(7146)] = 255533,
  [SMALL_STATE(7147)] = 255542,
  [SMALL_STATE(7148)] = 255555,
  [SMALL_STATE(7149)] = 255566,
  [SMALL_STATE(7150)] = 255575,
  [SMALL_STATE(7151)] = 255588,
  [SMALL_STATE(7152)] = 255601,
  [SMALL_STATE(7153)] = 255614,
  [SMALL_STATE(7154)] = 255627,
  [SMALL_STATE(7155)] = 255640,
  [SMALL_STATE(7156)] = 255649,
  [SMALL_STATE(7157)] = 255662,
  [SMALL_STATE(7158)] = 255673,
  [SMALL_STATE(7159)] = 255686,
  [SMALL_STATE(7160)] = 255699,
  [SMALL_STATE(7161)] = 255708,
  [SMALL_STATE(7162)] = 255721,
  [SMALL_STATE(7163)] = 255730,
  [SMALL_STATE(7164)] = 255743,
  [SMALL_STATE(7165)] = 255756,
  [SMALL_STATE(7166)] = 255769,
  [SMALL_STATE(7167)] = 255782,
  [SMALL_STATE(7168)] = 255795,
  [SMALL_STATE(7169)] = 255808,
  [SMALL_STATE(7170)] = 255821,
  [SMALL_STATE(7171)] = 255834,
  [SMALL_STATE(7172)] = 255847,
  [SMALL_STATE(7173)] = 255860,
  [SMALL_STATE(7174)] = 255873,
  [SMALL_STATE(7175)] = 255886,
  [SMALL_STATE(7176)] = 255899,
  [SMALL_STATE(7177)] = 255912,
  [SMALL_STATE(7178)] = 255925,
  [SMALL_STATE(7179)] = 255938,
  [SMALL_STATE(7180)] = 255951,
  [SMALL_STATE(7181)] = 255964,
  [SMALL_STATE(7182)] = 255977,
  [SMALL_STATE(7183)] = 255990,
  [SMALL_STATE(7184)] = 256001,
  [SMALL_STATE(7185)] = 256014,
  [SMALL_STATE(7186)] = 256023,
  [SMALL_STATE(7187)] = 256036,
  [SMALL_STATE(7188)] = 256047,
  [SMALL_STATE(7189)] = 256060,
  [SMALL_STATE(7190)] = 256073,
  [SMALL_STATE(7191)] = 256086,
  [SMALL_STATE(7192)] = 256099,
  [SMALL_STATE(7193)] = 256112,
  [SMALL_STATE(7194)] = 256125,
  [SMALL_STATE(7195)] = 256138,
  [SMALL_STATE(7196)] = 256151,
  [SMALL_STATE(7197)] = 256160,
  [SMALL_STATE(7198)] = 256173,
  [SMALL_STATE(7199)] = 256186,
  [SMALL_STATE(7200)] = 256199,
  [SMALL_STATE(7201)] = 256212,
  [SMALL_STATE(7202)] = 256225,
  [SMALL_STATE(7203)] = 256238,
  [SMALL_STATE(7204)] = 256251,
  [SMALL_STATE(7205)] = 256262,
  [SMALL_STATE(7206)] = 256275,
  [SMALL_STATE(7207)] = 256288,
  [SMALL_STATE(7208)] = 256301,
  [SMALL_STATE(7209)] = 256314,
  [SMALL_STATE(7210)] = 256327,
  [SMALL_STATE(7211)] = 256340,
  [SMALL_STATE(7212)] = 256353,
  [SMALL_STATE(7213)] = 256366,
  [SMALL_STATE(7214)] = 256379,
  [SMALL_STATE(7215)] = 256392,
  [SMALL_STATE(7216)] = 256405,
  [SMALL_STATE(7217)] = 256418,
  [SMALL_STATE(7218)] = 256431,
  [SMALL_STATE(7219)] = 256442,
  [SMALL_STATE(7220)] = 256455,
  [SMALL_STATE(7221)] = 256468,
  [SMALL_STATE(7222)] = 256481,
  [SMALL_STATE(7223)] = 256494,
  [SMALL_STATE(7224)] = 256507,
  [SMALL_STATE(7225)] = 256520,
  [SMALL_STATE(7226)] = 256533,
  [SMALL_STATE(7227)] = 256546,
  [SMALL_STATE(7228)] = 256557,
  [SMALL_STATE(7229)] = 256566,
  [SMALL_STATE(7230)] = 256579,
  [SMALL_STATE(7231)] = 256592,
  [SMALL_STATE(7232)] = 256603,
  [SMALL_STATE(7233)] = 256616,
  [SMALL_STATE(7234)] = 256629,
  [SMALL_STATE(7235)] = 256642,
  [SMALL_STATE(7236)] = 256655,
  [SMALL_STATE(7237)] = 256664,
  [SMALL_STATE(7238)] = 256677,
  [SMALL_STATE(7239)] = 256690,
  [SMALL_STATE(7240)] = 256701,
  [SMALL_STATE(7241)] = 256714,
  [SMALL_STATE(7242)] = 256727,
  [SMALL_STATE(7243)] = 256740,
  [SMALL_STATE(7244)] = 256751,
  [SMALL_STATE(7245)] = 256764,
  [SMALL_STATE(7246)] = 256777,
  [SMALL_STATE(7247)] = 256790,
  [SMALL_STATE(7248)] = 256801,
  [SMALL_STATE(7249)] = 256812,
  [SMALL_STATE(7250)] = 256823,
  [SMALL_STATE(7251)] = 256836,
  [SMALL_STATE(7252)] = 256849,
  [SMALL_STATE(7253)] = 256860,
  [SMALL_STATE(7254)] = 256871,
  [SMALL_STATE(7255)] = 256884,
  [SMALL_STATE(7256)] = 256895,
  [SMALL_STATE(7257)] = 256908,
  [SMALL_STATE(7258)] = 256918,
  [SMALL_STATE(7259)] = 256928,
  [SMALL_STATE(7260)] = 256936,
  [SMALL_STATE(7261)] = 256946,
  [SMALL_STATE(7262)] = 256956,
  [SMALL_STATE(7263)] = 256966,
  [SMALL_STATE(7264)] = 256976,
  [SMALL_STATE(7265)] = 256986,
  [SMALL_STATE(7266)] = 256996,
  [SMALL_STATE(7267)] = 257006,
  [SMALL_STATE(7268)] = 257016,
  [SMALL_STATE(7269)] = 257026,
  [SMALL_STATE(7270)] = 257036,
  [SMALL_STATE(7271)] = 257046,
  [SMALL_STATE(7272)] = 257056,
  [SMALL_STATE(7273)] = 257066,
  [SMALL_STATE(7274)] = 257074,
  [SMALL_STATE(7275)] = 257084,
  [SMALL_STATE(7276)] = 257094,
  [SMALL_STATE(7277)] = 257104,
  [SMALL_STATE(7278)] = 257114,
  [SMALL_STATE(7279)] = 257124,
  [SMALL_STATE(7280)] = 257134,
  [SMALL_STATE(7281)] = 257144,
  [SMALL_STATE(7282)] = 257154,
  [SMALL_STATE(7283)] = 257164,
  [SMALL_STATE(7284)] = 257174,
  [SMALL_STATE(7285)] = 257184,
  [SMALL_STATE(7286)] = 257194,
  [SMALL_STATE(7287)] = 257204,
  [SMALL_STATE(7288)] = 257214,
  [SMALL_STATE(7289)] = 257224,
  [SMALL_STATE(7290)] = 257234,
  [SMALL_STATE(7291)] = 257244,
  [SMALL_STATE(7292)] = 257252,
  [SMALL_STATE(7293)] = 257262,
  [SMALL_STATE(7294)] = 257272,
  [SMALL_STATE(7295)] = 257282,
  [SMALL_STATE(7296)] = 257292,
  [SMALL_STATE(7297)] = 257302,
  [SMALL_STATE(7298)] = 257312,
  [SMALL_STATE(7299)] = 257322,
  [SMALL_STATE(7300)] = 257330,
  [SMALL_STATE(7301)] = 257340,
  [SMALL_STATE(7302)] = 257348,
  [SMALL_STATE(7303)] = 257358,
  [SMALL_STATE(7304)] = 257368,
  [SMALL_STATE(7305)] = 257376,
  [SMALL_STATE(7306)] = 257386,
  [SMALL_STATE(7307)] = 257396,
  [SMALL_STATE(7308)] = 257406,
  [SMALL_STATE(7309)] = 257416,
  [SMALL_STATE(7310)] = 257424,
  [SMALL_STATE(7311)] = 257434,
  [SMALL_STATE(7312)] = 257444,
  [SMALL_STATE(7313)] = 257454,
  [SMALL_STATE(7314)] = 257464,
  [SMALL_STATE(7315)] = 257472,
  [SMALL_STATE(7316)] = 257482,
  [SMALL_STATE(7317)] = 257492,
  [SMALL_STATE(7318)] = 257502,
  [SMALL_STATE(7319)] = 257510,
  [SMALL_STATE(7320)] = 257520,
  [SMALL_STATE(7321)] = 257530,
  [SMALL_STATE(7322)] = 257538,
  [SMALL_STATE(7323)] = 257548,
  [SMALL_STATE(7324)] = 257558,
  [SMALL_STATE(7325)] = 257566,
  [SMALL_STATE(7326)] = 257576,
  [SMALL_STATE(7327)] = 257584,
  [SMALL_STATE(7328)] = 257594,
  [SMALL_STATE(7329)] = 257604,
  [SMALL_STATE(7330)] = 257614,
  [SMALL_STATE(7331)] = 257624,
  [SMALL_STATE(7332)] = 257634,
  [SMALL_STATE(7333)] = 257644,
  [SMALL_STATE(7334)] = 257654,
  [SMALL_STATE(7335)] = 257664,
  [SMALL_STATE(7336)] = 257672,
  [SMALL_STATE(7337)] = 257680,
  [SMALL_STATE(7338)] = 257690,
  [SMALL_STATE(7339)] = 257698,
  [SMALL_STATE(7340)] = 257708,
  [SMALL_STATE(7341)] = 257718,
  [SMALL_STATE(7342)] = 257728,
  [SMALL_STATE(7343)] = 257738,
  [SMALL_STATE(7344)] = 257748,
  [SMALL_STATE(7345)] = 257758,
  [SMALL_STATE(7346)] = 257768,
  [SMALL_STATE(7347)] = 257778,
  [SMALL_STATE(7348)] = 257788,
  [SMALL_STATE(7349)] = 257796,
  [SMALL_STATE(7350)] = 257806,
  [SMALL_STATE(7351)] = 257816,
  [SMALL_STATE(7352)] = 257826,
  [SMALL_STATE(7353)] = 257836,
  [SMALL_STATE(7354)] = 257846,
  [SMALL_STATE(7355)] = 257856,
  [SMALL_STATE(7356)] = 257866,
  [SMALL_STATE(7357)] = 257874,
  [SMALL_STATE(7358)] = 257884,
  [SMALL_STATE(7359)] = 257894,
  [SMALL_STATE(7360)] = 257904,
  [SMALL_STATE(7361)] = 257914,
  [SMALL_STATE(7362)] = 257922,
  [SMALL_STATE(7363)] = 257932,
  [SMALL_STATE(7364)] = 257942,
  [SMALL_STATE(7365)] = 257952,
  [SMALL_STATE(7366)] = 257962,
  [SMALL_STATE(7367)] = 257972,
  [SMALL_STATE(7368)] = 257982,
  [SMALL_STATE(7369)] = 257992,
  [SMALL_STATE(7370)] = 258002,
  [SMALL_STATE(7371)] = 258012,
  [SMALL_STATE(7372)] = 258022,
  [SMALL_STATE(7373)] = 258032,
  [SMALL_STATE(7374)] = 258042,
  [SMALL_STATE(7375)] = 258052,
  [SMALL_STATE(7376)] = 258062,
  [SMALL_STATE(7377)] = 258070,
  [SMALL_STATE(7378)] = 258080,
  [SMALL_STATE(7379)] = 258090,
  [SMALL_STATE(7380)] = 258100,
  [SMALL_STATE(7381)] = 258110,
  [SMALL_STATE(7382)] = 258120,
  [SMALL_STATE(7383)] = 258130,
  [SMALL_STATE(7384)] = 258140,
  [SMALL_STATE(7385)] = 258150,
  [SMALL_STATE(7386)] = 258160,
  [SMALL_STATE(7387)] = 258170,
  [SMALL_STATE(7388)] = 258180,
  [SMALL_STATE(7389)] = 258190,
  [SMALL_STATE(7390)] = 258200,
  [SMALL_STATE(7391)] = 258210,
  [SMALL_STATE(7392)] = 258218,
  [SMALL_STATE(7393)] = 258228,
  [SMALL_STATE(7394)] = 258238,
  [SMALL_STATE(7395)] = 258248,
  [SMALL_STATE(7396)] = 258258,
  [SMALL_STATE(7397)] = 258266,
  [SMALL_STATE(7398)] = 258276,
  [SMALL_STATE(7399)] = 258286,
  [SMALL_STATE(7400)] = 258296,
  [SMALL_STATE(7401)] = 258306,
  [SMALL_STATE(7402)] = 258316,
  [SMALL_STATE(7403)] = 258326,
  [SMALL_STATE(7404)] = 258336,
  [SMALL_STATE(7405)] = 258346,
  [SMALL_STATE(7406)] = 258356,
  [SMALL_STATE(7407)] = 258366,
  [SMALL_STATE(7408)] = 258376,
  [SMALL_STATE(7409)] = 258386,
  [SMALL_STATE(7410)] = 258396,
  [SMALL_STATE(7411)] = 258404,
  [SMALL_STATE(7412)] = 258414,
  [SMALL_STATE(7413)] = 258424,
  [SMALL_STATE(7414)] = 258434,
  [SMALL_STATE(7415)] = 258444,
  [SMALL_STATE(7416)] = 258454,
  [SMALL_STATE(7417)] = 258464,
  [SMALL_STATE(7418)] = 258472,
  [SMALL_STATE(7419)] = 258482,
  [SMALL_STATE(7420)] = 258492,
  [SMALL_STATE(7421)] = 258502,
  [SMALL_STATE(7422)] = 258512,
  [SMALL_STATE(7423)] = 258522,
  [SMALL_STATE(7424)] = 258532,
  [SMALL_STATE(7425)] = 258542,
  [SMALL_STATE(7426)] = 258552,
  [SMALL_STATE(7427)] = 258562,
  [SMALL_STATE(7428)] = 258572,
  [SMALL_STATE(7429)] = 258582,
  [SMALL_STATE(7430)] = 258592,
  [SMALL_STATE(7431)] = 258602,
  [SMALL_STATE(7432)] = 258612,
  [SMALL_STATE(7433)] = 258622,
  [SMALL_STATE(7434)] = 258632,
  [SMALL_STATE(7435)] = 258642,
  [SMALL_STATE(7436)] = 258652,
  [SMALL_STATE(7437)] = 258662,
  [SMALL_STATE(7438)] = 258672,
  [SMALL_STATE(7439)] = 258682,
  [SMALL_STATE(7440)] = 258692,
  [SMALL_STATE(7441)] = 258702,
  [SMALL_STATE(7442)] = 258712,
  [SMALL_STATE(7443)] = 258722,
  [SMALL_STATE(7444)] = 258732,
  [SMALL_STATE(7445)] = 258742,
  [SMALL_STATE(7446)] = 258752,
  [SMALL_STATE(7447)] = 258760,
  [SMALL_STATE(7448)] = 258770,
  [SMALL_STATE(7449)] = 258780,
  [SMALL_STATE(7450)] = 258790,
  [SMALL_STATE(7451)] = 258800,
  [SMALL_STATE(7452)] = 258810,
  [SMALL_STATE(7453)] = 258820,
  [SMALL_STATE(7454)] = 258830,
  [SMALL_STATE(7455)] = 258840,
  [SMALL_STATE(7456)] = 258850,
  [SMALL_STATE(7457)] = 258858,
  [SMALL_STATE(7458)] = 258868,
  [SMALL_STATE(7459)] = 258878,
  [SMALL_STATE(7460)] = 258888,
  [SMALL_STATE(7461)] = 258898,
  [SMALL_STATE(7462)] = 258908,
  [SMALL_STATE(7463)] = 258918,
  [SMALL_STATE(7464)] = 258926,
  [SMALL_STATE(7465)] = 258936,
  [SMALL_STATE(7466)] = 258946,
  [SMALL_STATE(7467)] = 258956,
  [SMALL_STATE(7468)] = 258966,
  [SMALL_STATE(7469)] = 258976,
  [SMALL_STATE(7470)] = 258986,
  [SMALL_STATE(7471)] = 258996,
  [SMALL_STATE(7472)] = 259006,
  [SMALL_STATE(7473)] = 259016,
  [SMALL_STATE(7474)] = 259026,
  [SMALL_STATE(7475)] = 259036,
  [SMALL_STATE(7476)] = 259046,
  [SMALL_STATE(7477)] = 259056,
  [SMALL_STATE(7478)] = 259066,
  [SMALL_STATE(7479)] = 259076,
  [SMALL_STATE(7480)] = 259086,
  [SMALL_STATE(7481)] = 259096,
  [SMALL_STATE(7482)] = 259106,
  [SMALL_STATE(7483)] = 259116,
  [SMALL_STATE(7484)] = 259126,
  [SMALL_STATE(7485)] = 259136,
  [SMALL_STATE(7486)] = 259146,
  [SMALL_STATE(7487)] = 259156,
  [SMALL_STATE(7488)] = 259166,
  [SMALL_STATE(7489)] = 259176,
  [SMALL_STATE(7490)] = 259186,
  [SMALL_STATE(7491)] = 259196,
  [SMALL_STATE(7492)] = 259204,
  [SMALL_STATE(7493)] = 259214,
  [SMALL_STATE(7494)] = 259222,
  [SMALL_STATE(7495)] = 259232,
  [SMALL_STATE(7496)] = 259242,
  [SMALL_STATE(7497)] = 259250,
  [SMALL_STATE(7498)] = 259260,
  [SMALL_STATE(7499)] = 259270,
  [SMALL_STATE(7500)] = 259280,
  [SMALL_STATE(7501)] = 259290,
  [SMALL_STATE(7502)] = 259300,
  [SMALL_STATE(7503)] = 259308,
  [SMALL_STATE(7504)] = 259318,
  [SMALL_STATE(7505)] = 259328,
  [SMALL_STATE(7506)] = 259338,
  [SMALL_STATE(7507)] = 259348,
  [SMALL_STATE(7508)] = 259358,
  [SMALL_STATE(7509)] = 259368,
  [SMALL_STATE(7510)] = 259378,
  [SMALL_STATE(7511)] = 259388,
  [SMALL_STATE(7512)] = 259398,
  [SMALL_STATE(7513)] = 259406,
  [SMALL_STATE(7514)] = 259416,
  [SMALL_STATE(7515)] = 259424,
  [SMALL_STATE(7516)] = 259434,
  [SMALL_STATE(7517)] = 259444,
  [SMALL_STATE(7518)] = 259454,
  [SMALL_STATE(7519)] = 259464,
  [SMALL_STATE(7520)] = 259472,
  [SMALL_STATE(7521)] = 259482,
  [SMALL_STATE(7522)] = 259492,
  [SMALL_STATE(7523)] = 259502,
  [SMALL_STATE(7524)] = 259512,
  [SMALL_STATE(7525)] = 259522,
  [SMALL_STATE(7526)] = 259532,
  [SMALL_STATE(7527)] = 259542,
  [SMALL_STATE(7528)] = 259552,
  [SMALL_STATE(7529)] = 259562,
  [SMALL_STATE(7530)] = 259572,
  [SMALL_STATE(7531)] = 259582,
  [SMALL_STATE(7532)] = 259592,
  [SMALL_STATE(7533)] = 259602,
  [SMALL_STATE(7534)] = 259610,
  [SMALL_STATE(7535)] = 259620,
  [SMALL_STATE(7536)] = 259630,
  [SMALL_STATE(7537)] = 259640,
  [SMALL_STATE(7538)] = 259650,
  [SMALL_STATE(7539)] = 259660,
  [SMALL_STATE(7540)] = 259670,
  [SMALL_STATE(7541)] = 259678,
  [SMALL_STATE(7542)] = 259688,
  [SMALL_STATE(7543)] = 259698,
  [SMALL_STATE(7544)] = 259708,
  [SMALL_STATE(7545)] = 259718,
  [SMALL_STATE(7546)] = 259728,
  [SMALL_STATE(7547)] = 259736,
  [SMALL_STATE(7548)] = 259746,
  [SMALL_STATE(7549)] = 259756,
  [SMALL_STATE(7550)] = 259764,
  [SMALL_STATE(7551)] = 259774,
  [SMALL_STATE(7552)] = 259784,
  [SMALL_STATE(7553)] = 259794,
  [SMALL_STATE(7554)] = 259804,
  [SMALL_STATE(7555)] = 259814,
  [SMALL_STATE(7556)] = 259824,
  [SMALL_STATE(7557)] = 259834,
  [SMALL_STATE(7558)] = 259844,
  [SMALL_STATE(7559)] = 259854,
  [SMALL_STATE(7560)] = 259864,
  [SMALL_STATE(7561)] = 259874,
  [SMALL_STATE(7562)] = 259884,
  [SMALL_STATE(7563)] = 259894,
  [SMALL_STATE(7564)] = 259904,
  [SMALL_STATE(7565)] = 259914,
  [SMALL_STATE(7566)] = 259924,
  [SMALL_STATE(7567)] = 259934,
  [SMALL_STATE(7568)] = 259944,
  [SMALL_STATE(7569)] = 259952,
  [SMALL_STATE(7570)] = 259962,
  [SMALL_STATE(7571)] = 259972,
  [SMALL_STATE(7572)] = 259982,
  [SMALL_STATE(7573)] = 259992,
  [SMALL_STATE(7574)] = 260002,
  [SMALL_STATE(7575)] = 260012,
  [SMALL_STATE(7576)] = 260022,
  [SMALL_STATE(7577)] = 260032,
  [SMALL_STATE(7578)] = 260042,
  [SMALL_STATE(7579)] = 260052,
  [SMALL_STATE(7580)] = 260062,
  [SMALL_STATE(7581)] = 260072,
  [SMALL_STATE(7582)] = 260082,
  [SMALL_STATE(7583)] = 260092,
  [SMALL_STATE(7584)] = 260100,
  [SMALL_STATE(7585)] = 260110,
  [SMALL_STATE(7586)] = 260118,
  [SMALL_STATE(7587)] = 260128,
  [SMALL_STATE(7588)] = 260136,
  [SMALL_STATE(7589)] = 260144,
  [SMALL_STATE(7590)] = 260152,
  [SMALL_STATE(7591)] = 260160,
  [SMALL_STATE(7592)] = 260170,
  [SMALL_STATE(7593)] = 260180,
  [SMALL_STATE(7594)] = 260190,
  [SMALL_STATE(7595)] = 260200,
  [SMALL_STATE(7596)] = 260210,
  [SMALL_STATE(7597)] = 260217,
  [SMALL_STATE(7598)] = 260224,
  [SMALL_STATE(7599)] = 260231,
  [SMALL_STATE(7600)] = 260238,
  [SMALL_STATE(7601)] = 260245,
  [SMALL_STATE(7602)] = 260252,
  [SMALL_STATE(7603)] = 260259,
  [SMALL_STATE(7604)] = 260266,
  [SMALL_STATE(7605)] = 260273,
  [SMALL_STATE(7606)] = 260280,
  [SMALL_STATE(7607)] = 260287,
  [SMALL_STATE(7608)] = 260294,
  [SMALL_STATE(7609)] = 260301,
  [SMALL_STATE(7610)] = 260308,
  [SMALL_STATE(7611)] = 260315,
  [SMALL_STATE(7612)] = 260322,
  [SMALL_STATE(7613)] = 260329,
  [SMALL_STATE(7614)] = 260336,
  [SMALL_STATE(7615)] = 260343,
  [SMALL_STATE(7616)] = 260350,
  [SMALL_STATE(7617)] = 260357,
  [SMALL_STATE(7618)] = 260364,
  [SMALL_STATE(7619)] = 260371,
  [SMALL_STATE(7620)] = 260378,
  [SMALL_STATE(7621)] = 260385,
  [SMALL_STATE(7622)] = 260392,
  [SMALL_STATE(7623)] = 260399,
  [SMALL_STATE(7624)] = 260406,
  [SMALL_STATE(7625)] = 260413,
  [SMALL_STATE(7626)] = 260420,
  [SMALL_STATE(7627)] = 260427,
  [SMALL_STATE(7628)] = 260434,
  [SMALL_STATE(7629)] = 260441,
  [SMALL_STATE(7630)] = 260448,
  [SMALL_STATE(7631)] = 260455,
  [SMALL_STATE(7632)] = 260462,
  [SMALL_STATE(7633)] = 260469,
  [SMALL_STATE(7634)] = 260476,
  [SMALL_STATE(7635)] = 260483,
  [SMALL_STATE(7636)] = 260490,
  [SMALL_STATE(7637)] = 260497,
  [SMALL_STATE(7638)] = 260504,
  [SMALL_STATE(7639)] = 260511,
  [SMALL_STATE(7640)] = 260518,
  [SMALL_STATE(7641)] = 260525,
  [SMALL_STATE(7642)] = 260532,
  [SMALL_STATE(7643)] = 260539,
  [SMALL_STATE(7644)] = 260546,
  [SMALL_STATE(7645)] = 260553,
  [SMALL_STATE(7646)] = 260560,
  [SMALL_STATE(7647)] = 260567,
  [SMALL_STATE(7648)] = 260574,
  [SMALL_STATE(7649)] = 260581,
  [SMALL_STATE(7650)] = 260588,
  [SMALL_STATE(7651)] = 260595,
  [SMALL_STATE(7652)] = 260602,
  [SMALL_STATE(7653)] = 260609,
  [SMALL_STATE(7654)] = 260616,
  [SMALL_STATE(7655)] = 260623,
  [SMALL_STATE(7656)] = 260630,
  [SMALL_STATE(7657)] = 260637,
  [SMALL_STATE(7658)] = 260644,
  [SMALL_STATE(7659)] = 260651,
  [SMALL_STATE(7660)] = 260658,
  [SMALL_STATE(7661)] = 260665,
  [SMALL_STATE(7662)] = 260672,
  [SMALL_STATE(7663)] = 260679,
  [SMALL_STATE(7664)] = 260686,
  [SMALL_STATE(7665)] = 260693,
  [SMALL_STATE(7666)] = 260700,
  [SMALL_STATE(7667)] = 260707,
  [SMALL_STATE(7668)] = 260714,
  [SMALL_STATE(7669)] = 260721,
  [SMALL_STATE(7670)] = 260728,
  [SMALL_STATE(7671)] = 260735,
  [SMALL_STATE(7672)] = 260742,
  [SMALL_STATE(7673)] = 260749,
  [SMALL_STATE(7674)] = 260756,
  [SMALL_STATE(7675)] = 260763,
  [SMALL_STATE(7676)] = 260770,
  [SMALL_STATE(7677)] = 260777,
  [SMALL_STATE(7678)] = 260784,
  [SMALL_STATE(7679)] = 260791,
  [SMALL_STATE(7680)] = 260798,
  [SMALL_STATE(7681)] = 260805,
  [SMALL_STATE(7682)] = 260812,
  [SMALL_STATE(7683)] = 260819,
  [SMALL_STATE(7684)] = 260826,
  [SMALL_STATE(7685)] = 260833,
  [SMALL_STATE(7686)] = 260840,
  [SMALL_STATE(7687)] = 260847,
  [SMALL_STATE(7688)] = 260854,
  [SMALL_STATE(7689)] = 260861,
  [SMALL_STATE(7690)] = 260868,
  [SMALL_STATE(7691)] = 260875,
  [SMALL_STATE(7692)] = 260882,
  [SMALL_STATE(7693)] = 260889,
  [SMALL_STATE(7694)] = 260896,
  [SMALL_STATE(7695)] = 260903,
  [SMALL_STATE(7696)] = 260910,
  [SMALL_STATE(7697)] = 260917,
  [SMALL_STATE(7698)] = 260924,
  [SMALL_STATE(7699)] = 260931,
  [SMALL_STATE(7700)] = 260938,
  [SMALL_STATE(7701)] = 260945,
  [SMALL_STATE(7702)] = 260952,
  [SMALL_STATE(7703)] = 260959,
  [SMALL_STATE(7704)] = 260966,
  [SMALL_STATE(7705)] = 260973,
  [SMALL_STATE(7706)] = 260980,
  [SMALL_STATE(7707)] = 260987,
  [SMALL_STATE(7708)] = 260994,
  [SMALL_STATE(7709)] = 261001,
  [SMALL_STATE(7710)] = 261008,
  [SMALL_STATE(7711)] = 261015,
  [SMALL_STATE(7712)] = 261022,
  [SMALL_STATE(7713)] = 261029,
  [SMALL_STATE(7714)] = 261036,
  [SMALL_STATE(7715)] = 261043,
  [SMALL_STATE(7716)] = 261050,
  [SMALL_STATE(7717)] = 261057,
  [SMALL_STATE(7718)] = 261064,
  [SMALL_STATE(7719)] = 261071,
  [SMALL_STATE(7720)] = 261078,
  [SMALL_STATE(7721)] = 261085,
  [SMALL_STATE(7722)] = 261092,
  [SMALL_STATE(7723)] = 261099,
  [SMALL_STATE(7724)] = 261106,
  [SMALL_STATE(7725)] = 261113,
  [SMALL_STATE(7726)] = 261120,
  [SMALL_STATE(7727)] = 261127,
  [SMALL_STATE(7728)] = 261134,
  [SMALL_STATE(7729)] = 261141,
  [SMALL_STATE(7730)] = 261148,
  [SMALL_STATE(7731)] = 261155,
  [SMALL_STATE(7732)] = 261162,
  [SMALL_STATE(7733)] = 261169,
  [SMALL_STATE(7734)] = 261176,
  [SMALL_STATE(7735)] = 261183,
  [SMALL_STATE(7736)] = 261190,
  [SMALL_STATE(7737)] = 261197,
  [SMALL_STATE(7738)] = 261204,
  [SMALL_STATE(7739)] = 261211,
  [SMALL_STATE(7740)] = 261218,
  [SMALL_STATE(7741)] = 261225,
  [SMALL_STATE(7742)] = 261232,
  [SMALL_STATE(7743)] = 261239,
  [SMALL_STATE(7744)] = 261246,
  [SMALL_STATE(7745)] = 261253,
  [SMALL_STATE(7746)] = 261260,
  [SMALL_STATE(7747)] = 261267,
  [SMALL_STATE(7748)] = 261274,
  [SMALL_STATE(7749)] = 261281,
  [SMALL_STATE(7750)] = 261288,
  [SMALL_STATE(7751)] = 261295,
  [SMALL_STATE(7752)] = 261302,
  [SMALL_STATE(7753)] = 261309,
  [SMALL_STATE(7754)] = 261316,
  [SMALL_STATE(7755)] = 261323,
  [SMALL_STATE(7756)] = 261330,
  [SMALL_STATE(7757)] = 261337,
  [SMALL_STATE(7758)] = 261344,
  [SMALL_STATE(7759)] = 261351,
  [SMALL_STATE(7760)] = 261358,
  [SMALL_STATE(7761)] = 261365,
  [SMALL_STATE(7762)] = 261372,
  [SMALL_STATE(7763)] = 261379,
  [SMALL_STATE(7764)] = 261386,
  [SMALL_STATE(7765)] = 261393,
  [SMALL_STATE(7766)] = 261400,
  [SMALL_STATE(7767)] = 261407,
  [SMALL_STATE(7768)] = 261414,
  [SMALL_STATE(7769)] = 261421,
  [SMALL_STATE(7770)] = 261428,
  [SMALL_STATE(7771)] = 261435,
  [SMALL_STATE(7772)] = 261442,
  [SMALL_STATE(7773)] = 261449,
  [SMALL_STATE(7774)] = 261456,
  [SMALL_STATE(7775)] = 261463,
  [SMALL_STATE(7776)] = 261470,
  [SMALL_STATE(7777)] = 261477,
  [SMALL_STATE(7778)] = 261484,
  [SMALL_STATE(7779)] = 261491,
  [SMALL_STATE(7780)] = 261498,
  [SMALL_STATE(7781)] = 261505,
  [SMALL_STATE(7782)] = 261512,
  [SMALL_STATE(7783)] = 261519,
  [SMALL_STATE(7784)] = 261526,
  [SMALL_STATE(7785)] = 261533,
  [SMALL_STATE(7786)] = 261540,
  [SMALL_STATE(7787)] = 261547,
  [SMALL_STATE(7788)] = 261554,
  [SMALL_STATE(7789)] = 261561,
  [SMALL_STATE(7790)] = 261568,
  [SMALL_STATE(7791)] = 261575,
  [SMALL_STATE(7792)] = 261582,
  [SMALL_STATE(7793)] = 261589,
  [SMALL_STATE(7794)] = 261596,
  [SMALL_STATE(7795)] = 261603,
  [SMALL_STATE(7796)] = 261610,
  [SMALL_STATE(7797)] = 261617,
  [SMALL_STATE(7798)] = 261624,
  [SMALL_STATE(7799)] = 261631,
  [SMALL_STATE(7800)] = 261638,
  [SMALL_STATE(7801)] = 261645,
  [SMALL_STATE(7802)] = 261652,
  [SMALL_STATE(7803)] = 261659,
  [SMALL_STATE(7804)] = 261666,
  [SMALL_STATE(7805)] = 261673,
  [SMALL_STATE(7806)] = 261680,
  [SMALL_STATE(7807)] = 261687,
  [SMALL_STATE(7808)] = 261694,
  [SMALL_STATE(7809)] = 261701,
  [SMALL_STATE(7810)] = 261708,
  [SMALL_STATE(7811)] = 261715,
  [SMALL_STATE(7812)] = 261722,
  [SMALL_STATE(7813)] = 261729,
  [SMALL_STATE(7814)] = 261736,
  [SMALL_STATE(7815)] = 261743,
  [SMALL_STATE(7816)] = 261750,
  [SMALL_STATE(7817)] = 261757,
  [SMALL_STATE(7818)] = 261764,
  [SMALL_STATE(7819)] = 261771,
  [SMALL_STATE(7820)] = 261778,
  [SMALL_STATE(7821)] = 261785,
  [SMALL_STATE(7822)] = 261792,
  [SMALL_STATE(7823)] = 261799,
  [SMALL_STATE(7824)] = 261806,
  [SMALL_STATE(7825)] = 261813,
  [SMALL_STATE(7826)] = 261820,
  [SMALL_STATE(7827)] = 261827,
  [SMALL_STATE(7828)] = 261834,
  [SMALL_STATE(7829)] = 261841,
  [SMALL_STATE(7830)] = 261848,
  [SMALL_STATE(7831)] = 261855,
  [SMALL_STATE(7832)] = 261862,
  [SMALL_STATE(7833)] = 261869,
  [SMALL_STATE(7834)] = 261876,
  [SMALL_STATE(7835)] = 261883,
  [SMALL_STATE(7836)] = 261890,
  [SMALL_STATE(7837)] = 261897,
  [SMALL_STATE(7838)] = 261904,
  [SMALL_STATE(7839)] = 261911,
  [SMALL_STATE(7840)] = 261918,
  [SMALL_STATE(7841)] = 261925,
  [SMALL_STATE(7842)] = 261932,
  [SMALL_STATE(7843)] = 261939,
  [SMALL_STATE(7844)] = 261946,
  [SMALL_STATE(7845)] = 261953,
  [SMALL_STATE(7846)] = 261960,
  [SMALL_STATE(7847)] = 261967,
  [SMALL_STATE(7848)] = 261974,
  [SMALL_STATE(7849)] = 261981,
  [SMALL_STATE(7850)] = 261988,
  [SMALL_STATE(7851)] = 261995,
  [SMALL_STATE(7852)] = 262002,
  [SMALL_STATE(7853)] = 262009,
  [SMALL_STATE(7854)] = 262016,
  [SMALL_STATE(7855)] = 262023,
  [SMALL_STATE(7856)] = 262030,
  [SMALL_STATE(7857)] = 262037,
  [SMALL_STATE(7858)] = 262044,
  [SMALL_STATE(7859)] = 262051,
  [SMALL_STATE(7860)] = 262058,
  [SMALL_STATE(7861)] = 262065,
  [SMALL_STATE(7862)] = 262072,
  [SMALL_STATE(7863)] = 262079,
  [SMALL_STATE(7864)] = 262086,
  [SMALL_STATE(7865)] = 262093,
  [SMALL_STATE(7866)] = 262100,
  [SMALL_STATE(7867)] = 262107,
  [SMALL_STATE(7868)] = 262114,
  [SMALL_STATE(7869)] = 262121,
  [SMALL_STATE(7870)] = 262128,
  [SMALL_STATE(7871)] = 262135,
  [SMALL_STATE(7872)] = 262142,
  [SMALL_STATE(7873)] = 262149,
  [SMALL_STATE(7874)] = 262156,
  [SMALL_STATE(7875)] = 262163,
  [SMALL_STATE(7876)] = 262170,
  [SMALL_STATE(7877)] = 262177,
  [SMALL_STATE(7878)] = 262184,
  [SMALL_STATE(7879)] = 262191,
  [SMALL_STATE(7880)] = 262198,
  [SMALL_STATE(7881)] = 262205,
  [SMALL_STATE(7882)] = 262212,
  [SMALL_STATE(7883)] = 262219,
  [SMALL_STATE(7884)] = 262226,
  [SMALL_STATE(7885)] = 262233,
  [SMALL_STATE(7886)] = 262240,
  [SMALL_STATE(7887)] = 262247,
  [SMALL_STATE(7888)] = 262254,
  [SMALL_STATE(7889)] = 262261,
  [SMALL_STATE(7890)] = 262268,
  [SMALL_STATE(7891)] = 262275,
  [SMALL_STATE(7892)] = 262282,
  [SMALL_STATE(7893)] = 262289,
  [SMALL_STATE(7894)] = 262296,
  [SMALL_STATE(7895)] = 262303,
  [SMALL_STATE(7896)] = 262310,
  [SMALL_STATE(7897)] = 262317,
  [SMALL_STATE(7898)] = 262324,
  [SMALL_STATE(7899)] = 262331,
  [SMALL_STATE(7900)] = 262338,
  [SMALL_STATE(7901)] = 262345,
  [SMALL_STATE(7902)] = 262352,
  [SMALL_STATE(7903)] = 262359,
  [SMALL_STATE(7904)] = 262366,
  [SMALL_STATE(7905)] = 262373,
  [SMALL_STATE(7906)] = 262380,
  [SMALL_STATE(7907)] = 262387,
  [SMALL_STATE(7908)] = 262394,
  [SMALL_STATE(7909)] = 262401,
  [SMALL_STATE(7910)] = 262408,
  [SMALL_STATE(7911)] = 262415,
  [SMALL_STATE(7912)] = 262422,
  [SMALL_STATE(7913)] = 262429,
  [SMALL_STATE(7914)] = 262436,
  [SMALL_STATE(7915)] = 262443,
  [SMALL_STATE(7916)] = 262450,
  [SMALL_STATE(7917)] = 262457,
  [SMALL_STATE(7918)] = 262464,
  [SMALL_STATE(7919)] = 262471,
  [SMALL_STATE(7920)] = 262478,
  [SMALL_STATE(7921)] = 262485,
  [SMALL_STATE(7922)] = 262492,
  [SMALL_STATE(7923)] = 262499,
  [SMALL_STATE(7924)] = 262506,
  [SMALL_STATE(7925)] = 262513,
  [SMALL_STATE(7926)] = 262520,
  [SMALL_STATE(7927)] = 262527,
  [SMALL_STATE(7928)] = 262534,
  [SMALL_STATE(7929)] = 262541,
  [SMALL_STATE(7930)] = 262548,
  [SMALL_STATE(7931)] = 262555,
  [SMALL_STATE(7932)] = 262562,
  [SMALL_STATE(7933)] = 262569,
  [SMALL_STATE(7934)] = 262576,
  [SMALL_STATE(7935)] = 262583,
  [SMALL_STATE(7936)] = 262590,
  [SMALL_STATE(7937)] = 262597,
  [SMALL_STATE(7938)] = 262604,
  [SMALL_STATE(7939)] = 262611,
  [SMALL_STATE(7940)] = 262618,
  [SMALL_STATE(7941)] = 262625,
  [SMALL_STATE(7942)] = 262632,
  [SMALL_STATE(7943)] = 262639,
  [SMALL_STATE(7944)] = 262646,
  [SMALL_STATE(7945)] = 262653,
  [SMALL_STATE(7946)] = 262660,
  [SMALL_STATE(7947)] = 262667,
  [SMALL_STATE(7948)] = 262674,
  [SMALL_STATE(7949)] = 262681,
  [SMALL_STATE(7950)] = 262688,
  [SMALL_STATE(7951)] = 262695,
  [SMALL_STATE(7952)] = 262702,
  [SMALL_STATE(7953)] = 262709,
  [SMALL_STATE(7954)] = 262716,
  [SMALL_STATE(7955)] = 262723,
  [SMALL_STATE(7956)] = 262730,
  [SMALL_STATE(7957)] = 262737,
  [SMALL_STATE(7958)] = 262744,
  [SMALL_STATE(7959)] = 262751,
  [SMALL_STATE(7960)] = 262758,
  [SMALL_STATE(7961)] = 262765,
  [SMALL_STATE(7962)] = 262772,
  [SMALL_STATE(7963)] = 262779,
  [SMALL_STATE(7964)] = 262786,
  [SMALL_STATE(7965)] = 262793,
  [SMALL_STATE(7966)] = 262800,
  [SMALL_STATE(7967)] = 262807,
  [SMALL_STATE(7968)] = 262814,
  [SMALL_STATE(7969)] = 262821,
  [SMALL_STATE(7970)] = 262828,
  [SMALL_STATE(7971)] = 262835,
  [SMALL_STATE(7972)] = 262842,
  [SMALL_STATE(7973)] = 262849,
  [SMALL_STATE(7974)] = 262856,
  [SMALL_STATE(7975)] = 262863,
  [SMALL_STATE(7976)] = 262870,
  [SMALL_STATE(7977)] = 262877,
  [SMALL_STATE(7978)] = 262884,
  [SMALL_STATE(7979)] = 262891,
  [SMALL_STATE(7980)] = 262898,
  [SMALL_STATE(7981)] = 262905,
  [SMALL_STATE(7982)] = 262912,
  [SMALL_STATE(7983)] = 262919,
  [SMALL_STATE(7984)] = 262926,
  [SMALL_STATE(7985)] = 262933,
  [SMALL_STATE(7986)] = 262940,
  [SMALL_STATE(7987)] = 262947,
  [SMALL_STATE(7988)] = 262954,
  [SMALL_STATE(7989)] = 262961,
  [SMALL_STATE(7990)] = 262968,
  [SMALL_STATE(7991)] = 262975,
  [SMALL_STATE(7992)] = 262982,
  [SMALL_STATE(7993)] = 262989,
  [SMALL_STATE(7994)] = 262996,
  [SMALL_STATE(7995)] = 263003,
  [SMALL_STATE(7996)] = 263010,
  [SMALL_STATE(7997)] = 263017,
  [SMALL_STATE(7998)] = 263024,
  [SMALL_STATE(7999)] = 263031,
  [SMALL_STATE(8000)] = 263038,
  [SMALL_STATE(8001)] = 263045,
  [SMALL_STATE(8002)] = 263052,
  [SMALL_STATE(8003)] = 263059,
  [SMALL_STATE(8004)] = 263066,
  [SMALL_STATE(8005)] = 263073,
  [SMALL_STATE(8006)] = 263080,
  [SMALL_STATE(8007)] = 263087,
  [SMALL_STATE(8008)] = 263094,
  [SMALL_STATE(8009)] = 263101,
  [SMALL_STATE(8010)] = 263108,
  [SMALL_STATE(8011)] = 263115,
  [SMALL_STATE(8012)] = 263122,
  [SMALL_STATE(8013)] = 263129,
  [SMALL_STATE(8014)] = 263136,
  [SMALL_STATE(8015)] = 263143,
  [SMALL_STATE(8016)] = 263150,
  [SMALL_STATE(8017)] = 263157,
  [SMALL_STATE(8018)] = 263164,
  [SMALL_STATE(8019)] = 263171,
  [SMALL_STATE(8020)] = 263178,
  [SMALL_STATE(8021)] = 263185,
  [SMALL_STATE(8022)] = 263192,
  [SMALL_STATE(8023)] = 263199,
  [SMALL_STATE(8024)] = 263206,
  [SMALL_STATE(8025)] = 263213,
  [SMALL_STATE(8026)] = 263220,
  [SMALL_STATE(8027)] = 263227,
  [SMALL_STATE(8028)] = 263234,
  [SMALL_STATE(8029)] = 263241,
  [SMALL_STATE(8030)] = 263248,
  [SMALL_STATE(8031)] = 263255,
  [SMALL_STATE(8032)] = 263262,
  [SMALL_STATE(8033)] = 263269,
  [SMALL_STATE(8034)] = 263276,
  [SMALL_STATE(8035)] = 263283,
  [SMALL_STATE(8036)] = 263290,
  [SMALL_STATE(8037)] = 263297,
  [SMALL_STATE(8038)] = 263304,
  [SMALL_STATE(8039)] = 263311,
  [SMALL_STATE(8040)] = 263318,
  [SMALL_STATE(8041)] = 263325,
  [SMALL_STATE(8042)] = 263332,
  [SMALL_STATE(8043)] = 263339,
  [SMALL_STATE(8044)] = 263346,
  [SMALL_STATE(8045)] = 263353,
  [SMALL_STATE(8046)] = 263360,
  [SMALL_STATE(8047)] = 263367,
  [SMALL_STATE(8048)] = 263374,
  [SMALL_STATE(8049)] = 263381,
  [SMALL_STATE(8050)] = 263388,
  [SMALL_STATE(8051)] = 263395,
  [SMALL_STATE(8052)] = 263402,
  [SMALL_STATE(8053)] = 263409,
  [SMALL_STATE(8054)] = 263416,
  [SMALL_STATE(8055)] = 263423,
  [SMALL_STATE(8056)] = 263430,
  [SMALL_STATE(8057)] = 263437,
  [SMALL_STATE(8058)] = 263444,
  [SMALL_STATE(8059)] = 263451,
  [SMALL_STATE(8060)] = 263458,
  [SMALL_STATE(8061)] = 263465,
  [SMALL_STATE(8062)] = 263472,
  [SMALL_STATE(8063)] = 263479,
  [SMALL_STATE(8064)] = 263486,
  [SMALL_STATE(8065)] = 263493,
  [SMALL_STATE(8066)] = 263500,
  [SMALL_STATE(8067)] = 263507,
  [SMALL_STATE(8068)] = 263514,
  [SMALL_STATE(8069)] = 263521,
  [SMALL_STATE(8070)] = 263528,
  [SMALL_STATE(8071)] = 263535,
  [SMALL_STATE(8072)] = 263542,
  [SMALL_STATE(8073)] = 263549,
  [SMALL_STATE(8074)] = 263556,
  [SMALL_STATE(8075)] = 263563,
  [SMALL_STATE(8076)] = 263570,
  [SMALL_STATE(8077)] = 263577,
  [SMALL_STATE(8078)] = 263584,
  [SMALL_STATE(8079)] = 263591,
  [SMALL_STATE(8080)] = 263598,
  [SMALL_STATE(8081)] = 263605,
  [SMALL_STATE(8082)] = 263612,
  [SMALL_STATE(8083)] = 263619,
  [SMALL_STATE(8084)] = 263626,
  [SMALL_STATE(8085)] = 263633,
  [SMALL_STATE(8086)] = 263640,
  [SMALL_STATE(8087)] = 263647,
  [SMALL_STATE(8088)] = 263654,
  [SMALL_STATE(8089)] = 263661,
  [SMALL_STATE(8090)] = 263668,
  [SMALL_STATE(8091)] = 263675,
  [SMALL_STATE(8092)] = 263682,
  [SMALL_STATE(8093)] = 263689,
  [SMALL_STATE(8094)] = 263696,
  [SMALL_STATE(8095)] = 263703,
  [SMALL_STATE(8096)] = 263710,
  [SMALL_STATE(8097)] = 263717,
  [SMALL_STATE(8098)] = 263724,
  [SMALL_STATE(8099)] = 263731,
  [SMALL_STATE(8100)] = 263738,
  [SMALL_STATE(8101)] = 263745,
  [SMALL_STATE(8102)] = 263752,
  [SMALL_STATE(8103)] = 263759,
  [SMALL_STATE(8104)] = 263766,
  [SMALL_STATE(8105)] = 263773,
  [SMALL_STATE(8106)] = 263780,
  [SMALL_STATE(8107)] = 263787,
  [SMALL_STATE(8108)] = 263794,
  [SMALL_STATE(8109)] = 263801,
  [SMALL_STATE(8110)] = 263808,
  [SMALL_STATE(8111)] = 263815,
  [SMALL_STATE(8112)] = 263822,
  [SMALL_STATE(8113)] = 263829,
  [SMALL_STATE(8114)] = 263836,
  [SMALL_STATE(8115)] = 263843,
  [SMALL_STATE(8116)] = 263850,
  [SMALL_STATE(8117)] = 263857,
  [SMALL_STATE(8118)] = 263864,
  [SMALL_STATE(8119)] = 263871,
  [SMALL_STATE(8120)] = 263878,
  [SMALL_STATE(8121)] = 263885,
  [SMALL_STATE(8122)] = 263892,
  [SMALL_STATE(8123)] = 263899,
  [SMALL_STATE(8124)] = 263906,
  [SMALL_STATE(8125)] = 263913,
  [SMALL_STATE(8126)] = 263920,
  [SMALL_STATE(8127)] = 263927,
  [SMALL_STATE(8128)] = 263934,
  [SMALL_STATE(8129)] = 263941,
  [SMALL_STATE(8130)] = 263948,
  [SMALL_STATE(8131)] = 263955,
  [SMALL_STATE(8132)] = 263962,
  [SMALL_STATE(8133)] = 263969,
  [SMALL_STATE(8134)] = 263976,
  [SMALL_STATE(8135)] = 263983,
  [SMALL_STATE(8136)] = 263990,
  [SMALL_STATE(8137)] = 263997,
  [SMALL_STATE(8138)] = 264004,
  [SMALL_STATE(8139)] = 264011,
  [SMALL_STATE(8140)] = 264018,
  [SMALL_STATE(8141)] = 264025,
  [SMALL_STATE(8142)] = 264032,
  [SMALL_STATE(8143)] = 264039,
  [SMALL_STATE(8144)] = 264046,
  [SMALL_STATE(8145)] = 264053,
  [SMALL_STATE(8146)] = 264060,
  [SMALL_STATE(8147)] = 264067,
  [SMALL_STATE(8148)] = 264074,
  [SMALL_STATE(8149)] = 264081,
  [SMALL_STATE(8150)] = 264088,
  [SMALL_STATE(8151)] = 264095,
  [SMALL_STATE(8152)] = 264102,
  [SMALL_STATE(8153)] = 264109,
  [SMALL_STATE(8154)] = 264116,
  [SMALL_STATE(8155)] = 264123,
  [SMALL_STATE(8156)] = 264130,
  [SMALL_STATE(8157)] = 264137,
  [SMALL_STATE(8158)] = 264144,
  [SMALL_STATE(8159)] = 264151,
  [SMALL_STATE(8160)] = 264158,
  [SMALL_STATE(8161)] = 264165,
  [SMALL_STATE(8162)] = 264172,
  [SMALL_STATE(8163)] = 264179,
  [SMALL_STATE(8164)] = 264186,
  [SMALL_STATE(8165)] = 264193,
  [SMALL_STATE(8166)] = 264200,
  [SMALL_STATE(8167)] = 264207,
  [SMALL_STATE(8168)] = 264214,
  [SMALL_STATE(8169)] = 264221,
  [SMALL_STATE(8170)] = 264228,
  [SMALL_STATE(8171)] = 264235,
  [SMALL_STATE(8172)] = 264242,
  [SMALL_STATE(8173)] = 264249,
  [SMALL_STATE(8174)] = 264256,
  [SMALL_STATE(8175)] = 264263,
  [SMALL_STATE(8176)] = 264270,
  [SMALL_STATE(8177)] = 264277,
  [SMALL_STATE(8178)] = 264284,
  [SMALL_STATE(8179)] = 264291,
  [SMALL_STATE(8180)] = 264298,
  [SMALL_STATE(8181)] = 264305,
  [SMALL_STATE(8182)] = 264312,
  [SMALL_STATE(8183)] = 264319,
  [SMALL_STATE(8184)] = 264326,
  [SMALL_STATE(8185)] = 264333,
  [SMALL_STATE(8186)] = 264340,
  [SMALL_STATE(8187)] = 264347,
  [SMALL_STATE(8188)] = 264354,
  [SMALL_STATE(8189)] = 264361,
  [SMALL_STATE(8190)] = 264368,
  [SMALL_STATE(8191)] = 264375,
  [SMALL_STATE(8192)] = 264382,
  [SMALL_STATE(8193)] = 264389,
  [SMALL_STATE(8194)] = 264396,
  [SMALL_STATE(8195)] = 264403,
  [SMALL_STATE(8196)] = 264410,
  [SMALL_STATE(8197)] = 264417,
  [SMALL_STATE(8198)] = 264424,
  [SMALL_STATE(8199)] = 264431,
  [SMALL_STATE(8200)] = 264438,
  [SMALL_STATE(8201)] = 264445,
  [SMALL_STATE(8202)] = 264452,
  [SMALL_STATE(8203)] = 264459,
  [SMALL_STATE(8204)] = 264466,
  [SMALL_STATE(8205)] = 264473,
  [SMALL_STATE(8206)] = 264480,
  [SMALL_STATE(8207)] = 264487,
  [SMALL_STATE(8208)] = 264494,
  [SMALL_STATE(8209)] = 264501,
  [SMALL_STATE(8210)] = 264508,
  [SMALL_STATE(8211)] = 264515,
  [SMALL_STATE(8212)] = 264522,
  [SMALL_STATE(8213)] = 264529,
  [SMALL_STATE(8214)] = 264536,
  [SMALL_STATE(8215)] = 264543,
  [SMALL_STATE(8216)] = 264550,
  [SMALL_STATE(8217)] = 264557,
  [SMALL_STATE(8218)] = 264564,
  [SMALL_STATE(8219)] = 264571,
  [SMALL_STATE(8220)] = 264578,
  [SMALL_STATE(8221)] = 264585,
  [SMALL_STATE(8222)] = 264592,
  [SMALL_STATE(8223)] = 264599,
  [SMALL_STATE(8224)] = 264606,
  [SMALL_STATE(8225)] = 264613,
  [SMALL_STATE(8226)] = 264620,
  [SMALL_STATE(8227)] = 264627,
  [SMALL_STATE(8228)] = 264634,
  [SMALL_STATE(8229)] = 264641,
  [SMALL_STATE(8230)] = 264648,
  [SMALL_STATE(8231)] = 264655,
  [SMALL_STATE(8232)] = 264662,
  [SMALL_STATE(8233)] = 264669,
  [SMALL_STATE(8234)] = 264676,
  [SMALL_STATE(8235)] = 264683,
  [SMALL_STATE(8236)] = 264690,
  [SMALL_STATE(8237)] = 264697,
  [SMALL_STATE(8238)] = 264704,
  [SMALL_STATE(8239)] = 264711,
  [SMALL_STATE(8240)] = 264718,
  [SMALL_STATE(8241)] = 264725,
  [SMALL_STATE(8242)] = 264732,
  [SMALL_STATE(8243)] = 264739,
  [SMALL_STATE(8244)] = 264746,
  [SMALL_STATE(8245)] = 264753,
  [SMALL_STATE(8246)] = 264760,
  [SMALL_STATE(8247)] = 264767,
  [SMALL_STATE(8248)] = 264774,
  [SMALL_STATE(8249)] = 264781,
  [SMALL_STATE(8250)] = 264788,
  [SMALL_STATE(8251)] = 264795,
  [SMALL_STATE(8252)] = 264802,
  [SMALL_STATE(8253)] = 264809,
  [SMALL_STATE(8254)] = 264816,
  [SMALL_STATE(8255)] = 264823,
  [SMALL_STATE(8256)] = 264830,
  [SMALL_STATE(8257)] = 264837,
  [SMALL_STATE(8258)] = 264844,
  [SMALL_STATE(8259)] = 264851,
  [SMALL_STATE(8260)] = 264858,
  [SMALL_STATE(8261)] = 264865,
  [SMALL_STATE(8262)] = 264872,
  [SMALL_STATE(8263)] = 264879,
  [SMALL_STATE(8264)] = 264886,
  [SMALL_STATE(8265)] = 264893,
  [SMALL_STATE(8266)] = 264900,
  [SMALL_STATE(8267)] = 264907,
  [SMALL_STATE(8268)] = 264914,
  [SMALL_STATE(8269)] = 264921,
  [SMALL_STATE(8270)] = 264928,
  [SMALL_STATE(8271)] = 264935,
  [SMALL_STATE(8272)] = 264942,
  [SMALL_STATE(8273)] = 264949,
  [SMALL_STATE(8274)] = 264956,
  [SMALL_STATE(8275)] = 264963,
  [SMALL_STATE(8276)] = 264970,
  [SMALL_STATE(8277)] = 264977,
  [SMALL_STATE(8278)] = 264984,
  [SMALL_STATE(8279)] = 264991,
  [SMALL_STATE(8280)] = 264998,
  [SMALL_STATE(8281)] = 265005,
  [SMALL_STATE(8282)] = 265012,
  [SMALL_STATE(8283)] = 265019,
  [SMALL_STATE(8284)] = 265026,
  [SMALL_STATE(8285)] = 265033,
  [SMALL_STATE(8286)] = 265040,
  [SMALL_STATE(8287)] = 265047,
  [SMALL_STATE(8288)] = 265054,
  [SMALL_STATE(8289)] = 265061,
  [SMALL_STATE(8290)] = 265068,
  [SMALL_STATE(8291)] = 265075,
  [SMALL_STATE(8292)] = 265082,
  [SMALL_STATE(8293)] = 265089,
  [SMALL_STATE(8294)] = 265096,
  [SMALL_STATE(8295)] = 265103,
  [SMALL_STATE(8296)] = 265110,
  [SMALL_STATE(8297)] = 265117,
  [SMALL_STATE(8298)] = 265124,
  [SMALL_STATE(8299)] = 265131,
  [SMALL_STATE(8300)] = 265138,
  [SMALL_STATE(8301)] = 265145,
  [SMALL_STATE(8302)] = 265152,
  [SMALL_STATE(8303)] = 265159,
  [SMALL_STATE(8304)] = 265166,
  [SMALL_STATE(8305)] = 265173,
  [SMALL_STATE(8306)] = 265180,
  [SMALL_STATE(8307)] = 265187,
  [SMALL_STATE(8308)] = 265194,
  [SMALL_STATE(8309)] = 265201,
  [SMALL_STATE(8310)] = 265208,
  [SMALL_STATE(8311)] = 265215,
  [SMALL_STATE(8312)] = 265222,
  [SMALL_STATE(8313)] = 265229,
  [SMALL_STATE(8314)] = 265236,
  [SMALL_STATE(8315)] = 265243,
  [SMALL_STATE(8316)] = 265250,
  [SMALL_STATE(8317)] = 265257,
  [SMALL_STATE(8318)] = 265264,
  [SMALL_STATE(8319)] = 265271,
  [SMALL_STATE(8320)] = 265278,
  [SMALL_STATE(8321)] = 265285,
  [SMALL_STATE(8322)] = 265292,
  [SMALL_STATE(8323)] = 265299,
  [SMALL_STATE(8324)] = 265306,
  [SMALL_STATE(8325)] = 265313,
  [SMALL_STATE(8326)] = 265320,
  [SMALL_STATE(8327)] = 265327,
  [SMALL_STATE(8328)] = 265334,
  [SMALL_STATE(8329)] = 265341,
  [SMALL_STATE(8330)] = 265348,
  [SMALL_STATE(8331)] = 265355,
  [SMALL_STATE(8332)] = 265362,
  [SMALL_STATE(8333)] = 265369,
  [SMALL_STATE(8334)] = 265376,
  [SMALL_STATE(8335)] = 265383,
  [SMALL_STATE(8336)] = 265390,
  [SMALL_STATE(8337)] = 265397,
  [SMALL_STATE(8338)] = 265404,
  [SMALL_STATE(8339)] = 265411,
  [SMALL_STATE(8340)] = 265418,
  [SMALL_STATE(8341)] = 265425,
  [SMALL_STATE(8342)] = 265432,
  [SMALL_STATE(8343)] = 265439,
  [SMALL_STATE(8344)] = 265446,
  [SMALL_STATE(8345)] = 265453,
  [SMALL_STATE(8346)] = 265460,
  [SMALL_STATE(8347)] = 265467,
  [SMALL_STATE(8348)] = 265474,
  [SMALL_STATE(8349)] = 265481,
  [SMALL_STATE(8350)] = 265488,
  [SMALL_STATE(8351)] = 265495,
  [SMALL_STATE(8352)] = 265502,
  [SMALL_STATE(8353)] = 265509,
  [SMALL_STATE(8354)] = 265516,
  [SMALL_STATE(8355)] = 265523,
  [SMALL_STATE(8356)] = 265530,
  [SMALL_STATE(8357)] = 265537,
  [SMALL_STATE(8358)] = 265544,
  [SMALL_STATE(8359)] = 265551,
  [SMALL_STATE(8360)] = 265558,
  [SMALL_STATE(8361)] = 265565,
  [SMALL_STATE(8362)] = 265572,
  [SMALL_STATE(8363)] = 265579,
  [SMALL_STATE(8364)] = 265586,
  [SMALL_STATE(8365)] = 265593,
  [SMALL_STATE(8366)] = 265600,
  [SMALL_STATE(8367)] = 265607,
  [SMALL_STATE(8368)] = 265614,
  [SMALL_STATE(8369)] = 265621,
  [SMALL_STATE(8370)] = 265628,
  [SMALL_STATE(8371)] = 265635,
  [SMALL_STATE(8372)] = 265642,
  [SMALL_STATE(8373)] = 265649,
  [SMALL_STATE(8374)] = 265656,
  [SMALL_STATE(8375)] = 265663,
  [SMALL_STATE(8376)] = 265670,
  [SMALL_STATE(8377)] = 265677,
  [SMALL_STATE(8378)] = 265684,
  [SMALL_STATE(8379)] = 265691,
  [SMALL_STATE(8380)] = 265698,
  [SMALL_STATE(8381)] = 265705,
  [SMALL_STATE(8382)] = 265712,
  [SMALL_STATE(8383)] = 265719,
  [SMALL_STATE(8384)] = 265726,
  [SMALL_STATE(8385)] = 265733,
  [SMALL_STATE(8386)] = 265740,
  [SMALL_STATE(8387)] = 265747,
  [SMALL_STATE(8388)] = 265754,
  [SMALL_STATE(8389)] = 265761,
  [SMALL_STATE(8390)] = 265768,
  [SMALL_STATE(8391)] = 265775,
  [SMALL_STATE(8392)] = 265782,
  [SMALL_STATE(8393)] = 265789,
  [SMALL_STATE(8394)] = 265796,
  [SMALL_STATE(8395)] = 265803,
  [SMALL_STATE(8396)] = 265810,
  [SMALL_STATE(8397)] = 265817,
  [SMALL_STATE(8398)] = 265824,
  [SMALL_STATE(8399)] = 265831,
  [SMALL_STATE(8400)] = 265838,
  [SMALL_STATE(8401)] = 265845,
  [SMALL_STATE(8402)] = 265852,
  [SMALL_STATE(8403)] = 265859,
  [SMALL_STATE(8404)] = 265866,
  [SMALL_STATE(8405)] = 265873,
  [SMALL_STATE(8406)] = 265880,
  [SMALL_STATE(8407)] = 265887,
  [SMALL_STATE(8408)] = 265894,
  [SMALL_STATE(8409)] = 265901,
  [SMALL_STATE(8410)] = 265908,
  [SMALL_STATE(8411)] = 265915,
  [SMALL_STATE(8412)] = 265922,
  [SMALL_STATE(8413)] = 265929,
  [SMALL_STATE(8414)] = 265936,
  [SMALL_STATE(8415)] = 265943,
  [SMALL_STATE(8416)] = 265950,
  [SMALL_STATE(8417)] = 265957,
  [SMALL_STATE(8418)] = 265964,
  [SMALL_STATE(8419)] = 265971,
  [SMALL_STATE(8420)] = 265978,
  [SMALL_STATE(8421)] = 265985,
  [SMALL_STATE(8422)] = 265992,
  [SMALL_STATE(8423)] = 265999,
  [SMALL_STATE(8424)] = 266006,
  [SMALL_STATE(8425)] = 266013,
  [SMALL_STATE(8426)] = 266020,
  [SMALL_STATE(8427)] = 266027,
  [SMALL_STATE(8428)] = 266034,
  [SMALL_STATE(8429)] = 266041,
  [SMALL_STATE(8430)] = 266048,
  [SMALL_STATE(8431)] = 266055,
  [SMALL_STATE(8432)] = 266062,
  [SMALL_STATE(8433)] = 266069,
  [SMALL_STATE(8434)] = 266076,
  [SMALL_STATE(8435)] = 266083,
  [SMALL_STATE(8436)] = 266090,
  [SMALL_STATE(8437)] = 266097,
  [SMALL_STATE(8438)] = 266104,
  [SMALL_STATE(8439)] = 266111,
  [SMALL_STATE(8440)] = 266118,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_translation_unit, 0, 0, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1056),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6338),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8435),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5409),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8433),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7594),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1655),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1656),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1655),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5068),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(959),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3048),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3775),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2662),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8386),
  [41] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6322),
  [43] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7550),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8375),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7545),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3735),
  [51] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2435),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1135),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3128),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3049),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1971),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2417),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6025),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5072),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5073),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5075),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6920),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7532),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1406),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8355),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7523),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(146),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8349),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1120),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8348),
  [91] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8345),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8344),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1426),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1347),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8339),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8338),
  [103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8336),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6499),
  [107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4166),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4166),
  [111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6935),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6803),
  [115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4774),
  [117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3931),
  [119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2687),
  [121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8332),
  [123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3137),
  [125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8331),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4214),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4866),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1692),
  [133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(917),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7520),
  [137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1468),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1339),
  [141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6331),
  [143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6289),
  [145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8325),
  [147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8324),
  [149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1338),
  [151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1475),
  [153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7516),
  [155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1477),
  [157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4759),
  [159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5261),
  [161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(963),
  [163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6374),
  [165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7946),
  [167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7731),
  [169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5327),
  [171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7945),
  [173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7455),
  [175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3027),
  [179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3764),
  [181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2648),
  [183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1785),
  [187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1134),
  [189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3047),
  [191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7053),
  [193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7261),
  [195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1425),
  [197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8116),
  [199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7406),
  [201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(164),
  [203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7950),
  [205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1106),
  [207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8052),
  [209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8090),
  [211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7912),
  [213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7349),
  [215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8215),
  [217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7723),
  [219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3950),
  [221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1694),
  [223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7269),
  [225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1323),
  [227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6369),
  [229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6286),
  [231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8261),
  [233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8262),
  [235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1322),
  [237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1418),
  [239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2005),
  [243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1999),
  [245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1791),
  [247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2006),
  [251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1993),
  [255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1033),
  [261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6360),
  [263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7605),
  [265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5340),
  [267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(706),
  [269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7606),
  [271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(51),
  [273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5367),
  [275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7980),
  [277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7444),
  [279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2978),
  [283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3752),
  [285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2643),
  [287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2995),
  [291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7251),
  [293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7579),
  [295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1499),
  [297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8183),
  [299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7263),
  [301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(142),
  [303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8260),
  [305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1111),
  [307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8263),
  [309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8270),
  [311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7608),
  [313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7555),
  [315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8148),
  [317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1691),
  [319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7586),
  [321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1326),
  [323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6335),
  [325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6218),
  [327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8341),
  [329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8342),
  [331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1327),
  [333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1433),
  [335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(380),
  [337] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elif, 4, 0, 78),
  [339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(826),
  [341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(790),
  [343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(832),
  [345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(712),
  [347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(728),
  [349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(414),
  [351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(795),
  [353] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elifdef, 2, 0, 8),
  [355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(792),
  [357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(913),
  [359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(721),
  [361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(836),
  [363] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elifdef, 3, 0, 8),
  [365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(687),
  [367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(354),
  [369] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elif, 3, 0, 78),
  [371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(369),
  [373] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1033),
  [376] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6360),
  [379] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7605),
  [382] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(5340),
  [385] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0),
  [387] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7606),
  [390] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7444),
  [393] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(122),
  [396] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1655),
  [399] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1656),
  [402] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1655),
  [405] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(345),
  [408] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(5068),
  [411] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(959),
  [414] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(241),
  [417] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2978),
  [420] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(3752),
  [423] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2643),
  [426] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8386),
  [429] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6322),
  [432] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7550),
  [435] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8375),
  [438] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7545),
  [441] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(3735),
  [444] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(37),
  [447] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2435),
  [450] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1135),
  [453] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(3128),
  [456] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2995),
  [459] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1971),
  [462] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2417),
  [465] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6025),
  [468] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(5072),
  [471] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(5073),
  [474] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(5075),
  [477] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7251),
  [480] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7579),
  [483] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1499),
  [486] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8183),
  [489] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7263),
  [492] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(142),
  [495] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8260),
  [498] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1111),
  [501] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8263),
  [504] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8270),
  [507] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7608),
  [510] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7555),
  [513] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8148),
  [516] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1426),
  [519] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1347),
  [522] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8339),
  [525] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8338),
  [528] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8336),
  [531] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6499),
  [534] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(4166),
  [537] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(4166),
  [540] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6935),
  [543] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6803),
  [546] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(3950),
  [549] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(3931),
  [552] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2687),
  [555] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8332),
  [558] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(3137),
  [561] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8331),
  [564] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(4214),
  [567] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(4866),
  [570] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1691),
  [573] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(917),
  [576] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7586),
  [579] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1468),
  [582] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1326),
  [585] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6335),
  [588] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6218),
  [591] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8341),
  [594] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8342),
  [597] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1327),
  [600] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1433),
  [603] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7516),
  [606] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1477),
  [609] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(4759),
  [612] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(5261),
  [615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1008),
  [617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5790),
  [621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4314),
  [623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5795),
  [629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1790),
  [631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1788),
  [633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5646),
  [637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5639),
  [639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2264),
  [643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2314),
  [653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1038),
  [655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6340),
  [657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7760),
  [659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5342),
  [661] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_else, 1, 0, 0),
  [663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7681),
  [665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7440),
  [667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2999),
  [671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3779),
  [673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2707),
  [675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3035),
  [679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6869),
  [681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7481),
  [683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1647),
  [685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7716),
  [687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7581),
  [689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(147),
  [691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8340),
  [693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1113),
  [695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8177),
  [697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8174),
  [699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7690),
  [701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7453),
  [703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8109),
  [705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1693),
  [707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7468),
  [709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1344),
  [711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6353),
  [713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6228),
  [715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8361),
  [717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8353),
  [719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1345),
  [721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1548),
  [723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3639),
  [725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [727] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1008),
  [730] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6374),
  [733] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7946),
  [736] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(5327),
  [739] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7945),
  [742] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7455),
  [745] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(670),
  [748] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(3027),
  [751] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(3764),
  [754] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2648),
  [757] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(41),
  [760] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0),
  [762] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(3047),
  [765] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7053),
  [768] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7261),
  [771] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1425),
  [774] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8116),
  [777] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7406),
  [780] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(164),
  [783] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7950),
  [786] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1106),
  [789] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8052),
  [792] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8090),
  [795] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7912),
  [798] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7349),
  [801] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8215),
  [804] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1694),
  [807] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7269),
  [810] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1323),
  [813] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6369),
  [816] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6286),
  [819] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8261),
  [822] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8262),
  [825] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1322),
  [828] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1418),
  [831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3595),
  [833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2000),
  [835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2009),
  [837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3865),
  [841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3882),
  [843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3439),
  [845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [853] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1038),
  [856] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6340),
  [859] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7760),
  [862] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(5342),
  [865] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7681),
  [868] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7440),
  [871] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(461),
  [874] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2999),
  [877] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(3779),
  [880] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2707),
  [883] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(73),
  [886] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(3035),
  [889] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6869),
  [892] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7481),
  [895] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1647),
  [898] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7716),
  [901] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7581),
  [904] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(147),
  [907] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8340),
  [910] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1113),
  [913] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8177),
  [916] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8174),
  [919] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7690),
  [922] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7453),
  [925] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8109),
  [928] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1693),
  [931] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7468),
  [934] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1344),
  [937] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6353),
  [940] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6228),
  [943] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8361),
  [946] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8353),
  [949] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1345),
  [952] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1548),
  [955] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_else, 2, 0, 0),
  [957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3451),
  [959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2011),
  [961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4226),
  [963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2536),
  [965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2001),
  [971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3358),
  [975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2572),
  [979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3384),
  [981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_translation_unit, 1, 0, 0),
  [983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0),
  [985] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1056),
  [988] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6338),
  [991] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8435),
  [994] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(5409),
  [997] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8433),
  [1000] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7594),
  [1003] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(122),
  [1006] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1655),
  [1009] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1656),
  [1012] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1655),
  [1015] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(345),
  [1018] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(5068),
  [1021] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(959),
  [1024] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(3048),
  [1027] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(3775),
  [1030] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2662),
  [1033] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8386),
  [1036] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6322),
  [1039] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7550),
  [1042] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8375),
  [1045] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7545),
  [1048] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(3735),
  [1051] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(77),
  [1054] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2435),
  [1057] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1135),
  [1060] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(3128),
  [1063] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(3049),
  [1066] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1971),
  [1069] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2417),
  [1072] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6025),
  [1075] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(5072),
  [1078] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(5073),
  [1081] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(5075),
  [1084] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6920),
  [1087] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7532),
  [1090] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1406),
  [1093] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8355),
  [1096] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7523),
  [1099] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(146),
  [1102] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8349),
  [1105] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1120),
  [1108] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8348),
  [1111] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8345),
  [1114] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8344),
  [1117] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1426),
  [1120] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1347),
  [1123] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8339),
  [1126] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8338),
  [1129] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8336),
  [1132] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6499),
  [1135] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(4166),
  [1138] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(4166),
  [1141] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6935),
  [1144] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6803),
  [1147] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(4774),
  [1150] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(3931),
  [1153] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2687),
  [1156] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8332),
  [1159] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(3137),
  [1162] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8331),
  [1165] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(4214),
  [1168] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(4866),
  [1171] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1692),
  [1174] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(917),
  [1177] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7520),
  [1180] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1468),
  [1183] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1339),
  [1186] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6331),
  [1189] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6289),
  [1192] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8325),
  [1195] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8324),
  [1198] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1338),
  [1201] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1475),
  [1204] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7516),
  [1207] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1477),
  [1210] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(4759),
  [1213] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(5261),
  [1216] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1102),
  [1219] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0),
  [1221] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(194),
  [1224] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1655),
  [1227] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1655),
  [1230] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1544),
  [1233] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0),
  [1235] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1544),
  [1238] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(241),
  [1241] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2978),
  [1244] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(3752),
  [1247] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(3128),
  [1250] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8386),
  [1253] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(6322),
  [1256] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7576),
  [1259] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8375),
  [1262] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(37),
  [1265] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2435),
  [1268] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1123),
  [1271] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1971),
  [1274] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2417),
  [1277] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(6025),
  [1280] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(5072),
  [1283] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(5073),
  [1286] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(5075),
  [1289] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7251),
  [1292] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7579),
  [1295] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7263),
  [1298] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(142),
  [1301] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8260),
  [1304] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1111),
  [1307] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8263),
  [1310] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8270),
  [1313] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7608),
  [1316] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7555),
  [1319] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8148),
  [1322] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1426),
  [1325] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1347),
  [1328] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8339),
  [1331] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8338),
  [1334] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8336),
  [1337] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(6499),
  [1340] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(4166),
  [1343] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(4166),
  [1346] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(6935),
  [1349] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(6803),
  [1352] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(3950),
  [1355] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(3931),
  [1358] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2687),
  [1361] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8332),
  [1364] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(3137),
  [1367] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8331),
  [1370] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(4866),
  [1373] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7500),
  [1376] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7586),
  [1379] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1468),
  [1382] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1326),
  [1385] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1327),
  [1388] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1433),
  [1391] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7516),
  [1394] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1477),
  [1397] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(4759),
  [1400] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(5261),
  [1403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1102),
  [1405] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 4, 0, 12),
  [1407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [1409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1544),
  [1411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 4, 0, 12),
  [1413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1544),
  [1415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7576),
  [1417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1123),
  [1419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7500),
  [1421] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 3, 0, 0),
  [1423] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 3, 0, 0),
  [1425] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 3, 0, 12),
  [1427] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 3, 0, 12),
  [1429] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 2, 0, 0),
  [1431] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 2, 0, 0),
  [1433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1100),
  [1435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [1437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7290),
  [1439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8028),
  [1441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1097),
  [1443] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1097),
  [1446] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(461),
  [1449] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2999),
  [1452] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(3779),
  [1455] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(73),
  [1458] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(6869),
  [1461] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7481),
  [1464] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7581),
  [1467] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(147),
  [1470] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8340),
  [1473] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1113),
  [1476] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8177),
  [1479] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8174),
  [1482] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7690),
  [1485] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7453),
  [1488] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8109),
  [1491] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7468),
  [1494] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1344),
  [1497] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1345),
  [1500] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1548),
  [1503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1099),
  [1505] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1100),
  [1508] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(481),
  [1511] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(3048),
  [1514] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(3775),
  [1517] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(77),
  [1520] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(6920),
  [1523] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7532),
  [1526] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7523),
  [1529] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(146),
  [1532] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8349),
  [1535] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1120),
  [1538] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8348),
  [1541] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8345),
  [1544] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8344),
  [1547] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7290),
  [1550] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8028),
  [1553] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7520),
  [1556] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1339),
  [1559] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1338),
  [1562] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1475),
  [1565] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1099),
  [1568] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(670),
  [1571] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(3027),
  [1574] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(3764),
  [1577] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(41),
  [1580] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7053),
  [1583] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7261),
  [1586] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7406),
  [1589] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(164),
  [1592] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7950),
  [1595] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1106),
  [1598] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8052),
  [1601] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8090),
  [1604] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7912),
  [1607] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7349),
  [1610] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8215),
  [1613] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7269),
  [1616] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1323),
  [1619] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1322),
  [1622] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1418),
  [1625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1101),
  [1627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1000),
  [1629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4032),
  [1631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3695),
  [1633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [1635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6973),
  [1637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7413),
  [1639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7480),
  [1641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(154),
  [1643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8351),
  [1645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1108),
  [1647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7713),
  [1649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7711),
  [1651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7765),
  [1653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7403),
  [1655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7651),
  [1657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7354),
  [1659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1250),
  [1661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1248),
  [1663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1649),
  [1665] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1101),
  [1668] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1000),
  [1671] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(4032),
  [1674] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(3695),
  [1677] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(48),
  [1680] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(6973),
  [1683] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7413),
  [1686] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7480),
  [1689] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(154),
  [1692] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8351),
  [1695] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1108),
  [1698] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7713),
  [1701] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7711),
  [1704] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7765),
  [1707] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7403),
  [1710] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7651),
  [1713] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7354),
  [1716] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1250),
  [1719] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1248),
  [1722] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1649),
  [1725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1094),
  [1727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [1729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4007),
  [1731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3762),
  [1733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7490),
  [1735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8277),
  [1737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7769),
  [1739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1098),
  [1741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4251),
  [1743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7607),
  [1745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [1747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1408),
  [1749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1408),
  [1751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1622),
  [1753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6324),
  [1755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5971),
  [1757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5100),
  [1759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5099),
  [1761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5098),
  [1763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1372),
  [1765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1251),
  [1767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8176),
  [1769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8414),
  [1771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8439),
  [1773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6524),
  [1775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3741),
  [1777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3741),
  [1779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7204),
  [1781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6762),
  [1783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3836),
  [1785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3866),
  [1787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4827),
  [1789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1577),
  [1791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7553),
  [1793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1576),
  [1795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4748),
  [1797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5256),
  [1799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1112),
  [1801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6918),
  [1803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4848),
  [1805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(331),
  [1807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [1809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1708),
  [1811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [1813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1650),
  [1815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1652),
  [1817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1650),
  [1819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [1821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(957),
  [1823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6303),
  [1825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6173),
  [1827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1898),
  [1829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1135),
  [1831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1957),
  [1833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5982),
  [1835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5076),
  [1837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5066),
  [1839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5065),
  [1841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1661),
  [1843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1324),
  [1845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7953),
  [1847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8405),
  [1849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8436),
  [1851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6501),
  [1853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3286),
  [1855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3286),
  [1857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6868),
  [1859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6805),
  [1861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3526),
  [1863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3509),
  [1865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1973),
  [1867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7955),
  [1869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4861),
  [1871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3052),
  [1873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1467),
  [1875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7483),
  [1877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1501),
  [1879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4749),
  [1881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5249),
  [1883] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sizeof_expression, 4, 0, 45),
  [1885] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sizeof_expression, 4, 0, 45),
  [1887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1561),
  [1889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1561),
  [1891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6319),
  [1893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1054),
  [1895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1287),
  [1897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8130),
  [1899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8408),
  [1901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8437),
  [1903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6516),
  [1905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2860),
  [1907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2860),
  [1909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7247),
  [1911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6612),
  [1913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2520),
  [1915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2540),
  [1917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8284),
  [1919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1485),
  [1921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7543),
  [1923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1484),
  [1925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4757),
  [1927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5251),
  [1929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1760),
  [1931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1667),
  [1933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1667),
  [1935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6328),
  [1937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1325),
  [1939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2906),
  [1941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2906),
  [1943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6976),
  [1945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6689),
  [1947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1456),
  [1949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7521),
  [1951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1458),
  [1953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4767),
  [1955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_statement, 2, 0, 0),
  [1957] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_statement, 2, 0, 0),
  [1959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_statement, 3, 0, 0),
  [1961] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_statement, 3, 0, 0),
  [1963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2016),
  [1965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2105),
  [1967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1055),
  [1969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2084),
  [1971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1618),
  [1973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1618),
  [1975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6293),
  [1977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1291),
  [1979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3277),
  [1981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3277),
  [1983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7248),
  [1985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6649),
  [1987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1474),
  [1989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7575),
  [1991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1486),
  [1993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2172),
  [1995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2057),
  [1997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1412),
  [1999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8196),
  [2001] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2172),
  [2004] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(194),
  [2007] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1655),
  [2010] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1655),
  [2013] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1544),
  [2016] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(461),
  [2019] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(6322),
  [2022] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7576),
  [2025] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(73),
  [2028] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1123),
  [2031] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2417),
  [2034] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(6869),
  [2037] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7481),
  [2040] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1647),
  [2043] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7716),
  [2046] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7581),
  [2049] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(147),
  [2052] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8340),
  [2055] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1113),
  [2058] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8177),
  [2061] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8174),
  [2064] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7690),
  [2067] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7453),
  [2070] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8109),
  [2073] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1426),
  [2076] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1347),
  [2079] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8339),
  [2082] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8338),
  [2085] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8336),
  [2088] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(6499),
  [2091] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(4166),
  [2094] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(4166),
  [2097] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(6935),
  [2100] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(6803),
  [2103] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(3950),
  [2106] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(3931),
  [2109] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8284),
  [2112] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7500),
  [2115] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7468),
  [2118] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1468),
  [2121] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1344),
  [2124] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1345),
  [2127] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1548),
  [2130] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7516),
  [2133] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1477),
  [2136] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(4759),
  [2139] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(5261),
  [2142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2137),
  [2144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2092),
  [2146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6995),
  [2148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7472),
  [2150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8129),
  [2152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7285),
  [2154] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2092),
  [2157] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(670),
  [2160] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(77),
  [2163] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(6995),
  [2166] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7532),
  [2169] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1412),
  [2172] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8196),
  [2175] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7472),
  [2178] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(146),
  [2181] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8129),
  [2184] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1120),
  [2187] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8348),
  [2190] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8345),
  [2193] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8344),
  [2196] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7285),
  [2199] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8215),
  [2202] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7520),
  [2205] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1339),
  [2208] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1338),
  [2211] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1475),
  [2214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2190),
  [2216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1605),
  [2218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1605),
  [2220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6320),
  [2222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1330),
  [2224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1522),
  [2226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1521),
  [2228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2265),
  [2230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1371),
  [2232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1371),
  [2234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6294),
  [2236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1050),
  [2238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1243),
  [2240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8195),
  [2242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8417),
  [2244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8440),
  [2246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6526),
  [2248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3434),
  [2250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3434),
  [2252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7255),
  [2254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6703),
  [2256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3637),
  [2258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3642),
  [2260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1453),
  [2262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7566),
  [2264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1452),
  [2266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4760),
  [2268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5259),
  [2270] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2137),
  [2273] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(481),
  [2276] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(6920),
  [2279] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1406),
  [2282] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8355),
  [2285] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7523),
  [2288] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8349),
  [2291] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7290),
  [2294] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8028),
  [2297] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2016),
  [2300] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(41),
  [2303] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7053),
  [2306] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7261),
  [2309] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1425),
  [2312] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8116),
  [2315] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7406),
  [2318] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(164),
  [2321] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7950),
  [2324] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1106),
  [2327] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8052),
  [2330] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8090),
  [2333] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7912),
  [2336] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7349),
  [2339] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7269),
  [2342] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1323),
  [2345] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1322),
  [2348] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1418),
  [2351] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2190),
  [2354] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(241),
  [2357] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(37),
  [2360] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7251),
  [2363] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7579),
  [2366] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1499),
  [2369] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8183),
  [2372] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7263),
  [2375] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(142),
  [2378] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8260),
  [2381] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1111),
  [2384] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8263),
  [2387] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8270),
  [2390] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7608),
  [2393] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7555),
  [2396] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8148),
  [2399] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7586),
  [2402] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1326),
  [2405] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1327),
  [2408] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1433),
  [2411] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2057),
  [2414] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1000),
  [2417] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(48),
  [2420] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(6973),
  [2423] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7413),
  [2426] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7480),
  [2429] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(154),
  [2432] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8351),
  [2435] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1108),
  [2438] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7713),
  [2441] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7711),
  [2444] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7765),
  [2447] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7403),
  [2450] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7651),
  [2453] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7354),
  [2456] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1250),
  [2459] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1248),
  [2462] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1649),
  [2465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1715),
  [2467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [2469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1123),
  [2471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2130),
  [2473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1062),
  [2475] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0),
  [2477] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0),
  [2479] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7592),
  [2482] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, 0, 7),
  [2484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, 0, 7),
  [2486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7592),
  [2488] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_try_statement, 3, 0, 7),
  [2490] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_try_statement, 3, 0, 7),
  [2492] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_try_statement, 4, 0, 46),
  [2494] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_try_statement, 4, 0, 46),
  [2496] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, 0, 102),
  [2498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, 0, 102),
  [2500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(190),
  [2502] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 2, 0, 0), SHIFT(2039),
  [2505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1200),
  [2507] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2, 0, 0),
  [2509] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression_statement, 2, 0, 0), SHIFT(6322),
  [2512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2, 0, 0),
  [2514] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 2, 0, 0), SHIFT(2417),
  [2517] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 2, 0, 0), SHIFT(8284),
  [2520] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 2, 0, 0), SHIFT(7500),
  [2523] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3, 0, 51),
  [2525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3, 0, 51),
  [2527] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 3, 0, 159),
  [2529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 3, 0, 159),
  [2531] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_init_statement, 1, 0, 0), SHIFT(2039),
  [2534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1205),
  [2536] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_init_statement, 1, 0, 0),
  [2538] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_init_statement, 1, 0, 0), SHIFT(6322),
  [2541] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_init_statement, 1, 0, 0),
  [2543] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_init_statement, 1, 0, 0), SHIFT(2417),
  [2546] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_init_statement, 1, 0, 0), SHIFT(8284),
  [2549] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_init_statement, 1, 0, 0), SHIFT(7500),
  [2552] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 1, 0, 0), SHIFT(2039),
  [2555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1211),
  [2557] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 1, 0, 0),
  [2559] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression_statement, 1, 0, 0), SHIFT(6322),
  [2562] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 1, 0, 0),
  [2564] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 1, 0, 0), SHIFT(2417),
  [2567] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 1, 0, 0), SHIFT(8284),
  [2570] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 1, 0, 0), SHIFT(7500),
  [2573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1720),
  [2575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [2577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1450),
  [2579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1450),
  [2581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1641),
  [2583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6307),
  [2585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2164),
  [2587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2597),
  [2589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6024),
  [2591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5163),
  [2593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5164),
  [2595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5165),
  [2597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1445),
  [2599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1342),
  [2601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8156),
  [2603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8411),
  [2605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8438),
  [2607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6531),
  [2609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4594),
  [2611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4594),
  [2613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7104),
  [2615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6808),
  [2617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4648),
  [2619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4715),
  [2621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2933),
  [2623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8178),
  [2625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4874),
  [2627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1682),
  [2629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1644),
  [2631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7551),
  [2633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1645),
  [2635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4746),
  [2637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5260),
  [2639] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 4, 0, 114),
  [2641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 4, 0, 114),
  [2643] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 5, 0, 148),
  [2645] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 5, 0, 148),
  [2647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2781),
  [2649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2315),
  [2651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3612),
  [2653] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2, 0, 0),
  [2655] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2, 0, 0),
  [2657] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2, 0, 0),
  [2659] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2, 0, 0),
  [2661] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2, 0, 0),
  [2663] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2, 0, 0),
  [2665] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_statement, 2, 0, 0),
  [2667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_statement, 2, 0, 0),
  [2669] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_co_return_statement, 2, 0, 0),
  [2671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_co_return_statement, 2, 0, 0),
  [2673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1716),
  [2675] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attributed_statement, 2, 0, 0),
  [2677] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributed_statement, 2, 0, 0),
  [2679] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_range_loop, 5, 0, 149),
  [2681] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_range_loop, 5, 0, 149),
  [2683] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_seh_leave_statement, 2, 0, 0),
  [2685] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_seh_leave_statement, 2, 0, 0),
  [2687] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 3, 0, 52),
  [2689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 3, 0, 52),
  [2691] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 3, 0, 52),
  [2693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 3, 0, 52),
  [2695] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 3, 0, 0),
  [2697] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 3, 0, 0),
  [2699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6299),
  [2701] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_goto_statement, 3, 0, 53),
  [2703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_goto_statement, 3, 0, 53),
  [2705] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_labeled_statement, 3, 0, 55),
  [2707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labeled_statement, 3, 0, 55),
  [2709] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_statement, 3, 0, 0),
  [2711] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_statement, 3, 0, 0),
  [2713] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_co_return_statement, 3, 0, 0),
  [2715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_co_return_statement, 3, 0, 0),
  [2717] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_co_yield_statement, 3, 0, 0),
  [2719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_co_yield_statement, 3, 0, 0),
  [2721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1784),
  [2723] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 3, 0, 66),
  [2725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 3, 0, 66),
  [2727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1722),
  [2729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2727),
  [2731] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 5, 0, 167),
  [2733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 5, 0, 167),
  [2735] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 6, 0, 131),
  [2737] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 6, 0, 131),
  [2739] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_seh_except_clause, 3, 0, 177),
  [2741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_seh_except_clause, 3, 0, 177),
  [2743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 2, 0, 0),
  [2745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1806),
  [2747] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 5, 0, 144),
  [2749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 5, 0, 144),
  [2751] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 4, 0, 85),
  [2753] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 4, 0, 85),
  [2755] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_seh_try_statement, 3, 0, 7),
  [2757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_seh_try_statement, 3, 0, 7),
  [2759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2035),
  [2761] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 2, 0, 0),
  [2763] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 2, 0, 0),
  [2765] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, 0, 143),
  [2767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, 0, 143),
  [2769] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_seh_finally_clause, 2, 0, 7),
  [2771] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_seh_finally_clause, 2, 0, 7),
  [2773] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 5, 0, 85),
  [2775] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 5, 0, 85),
  [2777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2681),
  [2779] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, 0, 103),
  [2781] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, 0, 103),
  [2783] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 5, 0, 131),
  [2785] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 5, 0, 131),
  [2787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1832),
  [2789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1700),
  [2791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3750),
  [2793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2823),
  [2795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4688),
  [2797] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 4, 0, 113),
  [2799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 4, 0, 113),
  [2801] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 3, 0, 60),
  [2803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 3, 0, 60),
  [2805] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 3, 0, 48),
  [2807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 3, 0, 48),
  [2809] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_using_declaration, 4, 0, 0),
  [2811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_declaration, 4, 0, 0),
  [2813] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 4, 0, 111),
  [2815] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 4, 0, 111),
  [2817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2039),
  [2819] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0),
  [2821] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0),
  [2823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3963),
  [2825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7814),
  [2827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5379),
  [2829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2243),
  [2831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7827),
  [2833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(829),
  [2835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5313),
  [2837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7669),
  [2839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7445),
  [2841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4718),
  [2843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8280),
  [2845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3275),
  [2847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5068),
  [2849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3016),
  [2851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3715),
  [2853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5301),
  [2855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8273),
  [2857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5952),
  [2859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5154),
  [2861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5155),
  [2863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5156),
  [2865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4829),
  [2867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6661),
  [2869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1739),
  [2871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7813),
  [2873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6234),
  [2875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8369),
  [2877] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_call, 2, 0, 3),
  [2879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_call, 2, 0, 3),
  [2881] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elifdef_in_field_declaration_list, 3, 0, 8),
  [2883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7436),
  [2885] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_declaration, 4, 0, 57),
  [2887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_declaration, 4, 0, 57),
  [2889] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_instantiation, 4, 0, 58),
  [2891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_instantiation, 4, 0, 58),
  [2893] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 4, 0, 116),
  [2895] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 4, 0, 116),
  [2897] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_default_method_clause, 3, 0, 0),
  [2899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_method_clause, 3, 0, 0),
  [2901] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delete_method_clause, 3, 0, 0),
  [2903] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delete_method_clause, 3, 0, 0),
  [2905] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pure_virtual_clause, 3, 0, 0),
  [2907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pure_virtual_clause, 3, 0, 0),
  [2909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7353),
  [2911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2047),
  [2913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [2915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1663),
  [2917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4675),
  [2919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4186),
  [2921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4158),
  [2923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1658),
  [2925] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_cast_declaration, 4, 0, 121),
  [2927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_cast_declaration, 4, 0, 121),
  [2929] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 2, 0, 7),
  [2931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 2, 0, 7),
  [2933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1922),
  [2935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2029),
  [2937] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_definition, 4, 0, 125),
  [2939] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_definition, 4, 0, 125),
  [2941] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_definition, 3, 0, 5),
  [2943] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_definition, 3, 0, 5),
  [2945] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_function_def, 5, 0, 126),
  [2947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_function_def, 5, 0, 126),
  [2949] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 5, 0, 127),
  [2951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 5, 0, 127),
  [2953] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 5, 0, 78),
  [2955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 5, 0, 78),
  [2957] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef, 5, 0, 128),
  [2959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 5, 0, 128),
  [2961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7595),
  [2963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1931),
  [2965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2147),
  [2967] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_friend_declaration, 4, 0, 0),
  [2969] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_friend_declaration, 4, 0, 0),
  [2971] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 5, 0, 135),
  [2973] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 5, 0, 135),
  [2975] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 5, 0, 136),
  [2977] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 5, 0, 136),
  [2979] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 4, 0, 94),
  [2981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 4, 0, 94),
  [2983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2256),
  [2985] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_definition, 2, 0, 23),
  [2987] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_definition, 2, 0, 23),
  [2989] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 4, 0, 93),
  [2991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 4, 0, 93),
  [2993] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 4, 0, 92),
  [2995] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 4, 0, 92),
  [2997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1935),
  [2999] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7595),
  [3002] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef, 4, 0, 8),
  [3004] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 4, 0, 8),
  [3006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2246),
  [3008] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_assert_declaration, 7, 0, 204),
  [3010] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_assert_declaration, 7, 0, 204),
  [3012] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef, 4, 0, 79),
  [3014] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 4, 0, 79),
  [3016] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alias_declaration, 6, 0, 193),
  [3018] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias_declaration, 6, 0, 193),
  [3020] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_cast_declaration, 5, 0, 174),
  [3022] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_cast_declaration, 5, 0, 174),
  [3024] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_function_def, 4, 0, 77),
  [3026] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_function_def, 4, 0, 77),
  [3028] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_def, 4, 0, 76),
  [3030] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_def, 4, 0, 76),
  [3032] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 6, 0, 175),
  [3034] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 6, 0, 175),
  [3036] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_cast_definition, 3, 0, 75),
  [3038] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_cast_definition, 3, 0, 75),
  [3040] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_cast_declaration, 3, 0, 5),
  [3042] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_cast_declaration, 3, 0, 5),
  [3044] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 4, 0, 78),
  [3046] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 4, 0, 78),
  [3048] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_definition, 2, 0, 24),
  [3050] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_definition, 2, 0, 24),
  [3052] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__empty_declaration, 2, 0, 0),
  [3054] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__empty_declaration, 2, 0, 0),
  [3056] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_cast_declaration, 2, 0, 24),
  [3058] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_cast_declaration, 2, 0, 24),
  [3060] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_friend_declaration, 2, 0, 0),
  [3062] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_friend_declaration, 2, 0, 0),
  [3064] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_cast_definition, 2, 0, 23),
  [3066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_cast_definition, 2, 0, 23),
  [3068] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 5, 0, 169),
  [3070] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 5, 0, 169),
  [3072] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_declaration, 2, 0, 24),
  [3074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_declaration, 2, 0, 24),
  [3076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2244),
  [3078] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concept_definition, 5, 0, 8),
  [3080] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concept_definition, 5, 0, 8),
  [3082] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_assert_declaration, 5, 0, 163),
  [3084] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_assert_declaration, 5, 0, 163),
  [3086] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alias_declaration, 5, 0, 162),
  [3088] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias_declaration, 5, 0, 162),
  [3090] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_alias_definition, 5, 0, 161),
  [3092] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_alias_definition, 5, 0, 161),
  [3094] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_alias_definition, 5, 0, 160),
  [3096] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_alias_definition, 5, 0, 160),
  [3098] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7353),
  [3101] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_include, 3, 0, 37),
  [3103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_include, 3, 0, 37),
  [3105] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_definition, 3, 0, 75),
  [3107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_definition, 3, 0, 75),
  [3109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1841),
  [3111] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_def, 3, 0, 8),
  [3113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_def, 3, 0, 8),
  [3115] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elif_in_field_declaration_list, 4, 0, 78),
  [3117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2229),
  [3119] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7436),
  [3122] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_definition, 3, 0, 69),
  [3124] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_definition, 3, 0, 69),
  [3126] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 3, 0, 67),
  [3128] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 3, 0, 67),
  [3130] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elifdef_in_field_declaration_list, 2, 0, 8),
  [3132] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_using_declaration, 3, 0, 0),
  [3134] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_declaration, 3, 0, 0),
  [3136] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration_list, 3, 0, 0),
  [3138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_list, 3, 0, 0),
  [3140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2132),
  [3142] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elif_in_field_declaration_list, 3, 0, 78),
  [3144] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration_list, 2, 0, 0),
  [3146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_list, 2, 0, 0),
  [3148] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_declaration, 3, 0, 57),
  [3150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_declaration, 3, 0, 57),
  [3152] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_instantiation, 3, 0, 5),
  [3154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_instantiation, 3, 0, 5),
  [3156] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef, 3, 0, 8),
  [3158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 3, 0, 8),
  [3160] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_friend_declaration, 3, 0, 0),
  [3162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_friend_declaration, 3, 0, 0),
  [3164] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_declaration, 3, 0, 5),
  [3166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_declaration, 3, 0, 5),
  [3168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2075),
  [3170] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_call, 3, 0, 38),
  [3172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_call, 3, 0, 38),
  [3174] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 3, 0, 46),
  [3176] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 3, 0, 46),
  [3178] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_linkage_specification, 3, 0, 44),
  [3180] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_linkage_specification, 3, 0, 44),
  [3182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(166),
  [3184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(151),
  [3186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(179),
  [3188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1613),
  [3190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1613),
  [3192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6301),
  [3194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1071),
  [3196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1329),
  [3198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4145),
  [3200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4145),
  [3202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7249),
  [3204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6765),
  [3206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1582),
  [3208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7528),
  [3210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1583),
  [3212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4738),
  [3214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5252),
  [3216] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3963),
  [3219] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7814),
  [3222] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5379),
  [3225] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0),
  [3227] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7827),
  [3230] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7445),
  [3233] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4718),
  [3236] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8280),
  [3239] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3275),
  [3242] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5068),
  [3245] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5068),
  [3248] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3016),
  [3251] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3715),
  [3254] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3128),
  [3257] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8386),
  [3260] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5301),
  [3263] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7490),
  [3266] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8375),
  [3269] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7545),
  [3272] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2435),
  [3275] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8273),
  [3278] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1971),
  [3281] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2417),
  [3284] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5952),
  [3287] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5154),
  [3290] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5155),
  [3293] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5156),
  [3296] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2687),
  [3299] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8332),
  [3302] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3137),
  [3305] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8331),
  [3308] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4214),
  [3311] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4829),
  [3314] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6661),
  [3317] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(917),
  [3320] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1739),
  [3323] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7813),
  [3326] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6234),
  [3329] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8369),
  [3332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [3334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [3336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [3338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [3340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2235),
  [3342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1539),
  [3344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1539),
  [3346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6295),
  [3348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1348),
  [3350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4444),
  [3352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4444),
  [3354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7252),
  [3356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6653),
  [3358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1354),
  [3360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7573),
  [3362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1353),
  [3364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7680),
  [3366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5314),
  [3368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7823),
  [3370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7461),
  [3372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3008),
  [3374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3736),
  [3376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2942),
  [3378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6706),
  [3380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1733),
  [3382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6280),
  [3384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8352),
  [3386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7862),
  [3388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5341),
  [3390] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_else_in_field_declaration_list, 1, 0, 0),
  [3392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7624),
  [3394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7339),
  [3396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3015),
  [3398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3713),
  [3400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6724),
  [3402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1734),
  [3404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6256),
  [3406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8377),
  [3408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2364),
  [3410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2963),
  [3412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2627),
  [3414] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_else_in_field_declaration_list, 2, 0, 0),
  [3416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2866),
  [3418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4833),
  [3420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2658),
  [3422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1938),
  [3424] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7862),
  [3427] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5341),
  [3430] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7624),
  [3433] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7339),
  [3436] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3015),
  [3439] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3713),
  [3442] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6724),
  [3445] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1734),
  [3448] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6256),
  [3451] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8377),
  [3454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2354),
  [3456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3233),
  [3458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2292),
  [3460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1067),
  [3462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4975),
  [3464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2987),
  [3466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_definition, 4, 0, 75),
  [3468] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_definition, 4, 0, 75),
  [3470] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_definition, 4, 0, 69),
  [3472] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_definition, 4, 0, 69),
  [3474] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_definition, 3, 0, 23),
  [3476] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_definition, 3, 0, 23),
  [3478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2309),
  [3480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1376),
  [3482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1376),
  [3484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6327),
  [3486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1295),
  [3488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1360),
  [3490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1363),
  [3492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4766),
  [3494] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7680),
  [3497] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5314),
  [3500] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7823),
  [3503] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7461),
  [3506] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3008),
  [3509] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3736),
  [3512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0),
  [3514] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6706),
  [3517] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1733),
  [3520] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6280),
  [3523] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8352),
  [3526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4019),
  [3528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__top_level_expression_statement, 2, 0, 0),
  [3530] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__top_level_expression_statement, 2, 0, 0),
  [3532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2818),
  [3534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3989),
  [3536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3057),
  [3538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2312),
  [3540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1472),
  [3542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1472),
  [3544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6317),
  [3546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1340),
  [3548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1464),
  [3550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1463),
  [3552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1962),
  [3554] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_definition, 5, 0, 125),
  [3556] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_definition, 5, 0, 125),
  [3558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4900),
  [3560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3303),
  [3562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4944),
  [3564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_pack_expansion, 2, 0, 28),
  [3566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [3568] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_pack_expansion, 2, 0, 28),
  [3570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1547),
  [3572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3742),
  [3574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3353),
  [3576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3353),
  [3578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6333),
  [3580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2855),
  [3582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5954),
  [3584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5116),
  [3586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5114),
  [3588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5113),
  [3590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4875),
  [3592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3075),
  [3594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7986),
  [3596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5836),
  [3598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5836),
  [3600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5807),
  [3602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8115),
  [3604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3032),
  [3606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5344),
  [3608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8380),
  [3610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8370),
  [3612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5365),
  [3614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6629),
  [3616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1736),
  [3618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7993),
  [3620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6601),
  [3622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1738),
  [3624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8346),
  [3626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8384),
  [3628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8378),
  [3630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6692),
  [3632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1737),
  [3634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8373),
  [3636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6610),
  [3638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1735),
  [3640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8356),
  [3642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8365),
  [3644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8362),
  [3646] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_declaration, 4, 0, 0),
  [3648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_declaration, 4, 0, 0),
  [3650] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_declaration, 3, 0, 0),
  [3652] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_declaration, 3, 0, 0),
  [3654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1246),
  [3656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1972),
  [3658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5719),
  [3660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1314),
  [3662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3517),
  [3664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1332),
  [3666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6103),
  [3668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1249),
  [3670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3280),
  [3672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1349),
  [3674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6094),
  [3676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1341),
  [3678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2359),
  [3680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1312),
  [3682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2349),
  [3684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1343),
  [3686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5931),
  [3688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1334),
  [3690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5932),
  [3692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1333),
  [3694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6068),
  [3696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1255),
  [3698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5916),
  [3700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1247),
  [3702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3229),
  [3704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2093),
  [3706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1337),
  [3708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6219),
  [3710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1259),
  [3712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5780),
  [3714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1328),
  [3716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6250),
  [3718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1346),
  [3720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5989),
  [3722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1257),
  [3724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6123),
  [3726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1280),
  [3728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3441),
  [3730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1254),
  [3732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5746),
  [3734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1253),
  [3736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5744),
  [3738] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__declaration_modifiers, 1, 0, 0), REDUCE(aux_sym_attributed_declarator_repeat1, 1, 0, 0),
  [3741] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declaration_modifiers, 1, 0, 0), REDUCE(aux_sym_attributed_declarator_repeat1, 1, 0, 0),
  [3744] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 1, 0, 0),
  [3746] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 1, 0, 0),
  [3748] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_modifiers, 1, 0, 0),
  [3750] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_modifiers, 1, 0, 0),
  [3752] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7329),
  [3755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7329),
  [3757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(152),
  [3759] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_specifier, 1, 0, 1),
  [3761] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_not_binary, 1, 0, 0),
  [3763] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__declarator, 1, 0, 0), REDUCE(sym__type_specifier, 1, 0, 1), REDUCE(sym__expression_not_binary, 1, 0, 0),
  [3767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_specifier, 1, 0, 1),
  [3769] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_not_binary, 1, 0, 0),
  [3771] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type_specifier, 1, 0, 1), REDUCE(sym__expression_not_binary, 1, 0, 0),
  [3774] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type_specifier, 1, 0, 1), REDUCE(sym__expression_not_binary, 1, 0, 0),
  [3777] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression_not_binary, 1, 0, 0), SHIFT(253),
  [3780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6412),
  [3782] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declarator, 1, 0, 0), REDUCE(sym__type_specifier, 1, 0, 1),
  [3785] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_name, 1, 0, 1),
  [3787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2716),
  [3789] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__declarator, 1, 0, 0), REDUCE(sym__type_specifier, 1, 0, 1), REDUCE(sym__expression_not_binary, 1, 0, 0),
  [3793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1201),
  [3795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(129),
  [3797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1201),
  [3799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3534),
  [3801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4655),
  [3803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1006),
  [3805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2534),
  [3807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4412),
  [3809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4412),
  [3811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5516),
  [3813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(946),
  [3815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(181),
  [3817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(143),
  [3819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(134),
  [3821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2639),
  [3823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1409),
  [3825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5797),
  [3827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6313),
  [3829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2037),
  [3831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7829),
  [3833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3662),
  [3835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1151),
  [3837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2568),
  [3839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3410),
  [3841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3469),
  [3843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7619),
  [3845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2544),
  [3847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7747),
  [3849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3506),
  [3851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(158),
  [3853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3872),
  [3855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3512),
  [3857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1759),
  [3859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3481),
  [3861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5815),
  [3863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7603),
  [3865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3869),
  [3867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5650),
  [3869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4317),
  [3871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1747),
  [3873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2513),
  [3875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8006),
  [3877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4651),
  [3879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5587),
  [3881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4227),
  [3883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3877),
  [3885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3802),
  [3887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3634),
  [3889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3861),
  [3891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3624),
  [3893] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(2039),
  [3896] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(194),
  [3899] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(1655),
  [3902] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(1655),
  [3905] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(1544),
  [3908] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(2639),
  [3911] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(6322),
  [3914] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(1409),
  [3917] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0),
  [3919] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(1123),
  [3922] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(2417),
  [3925] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(1426),
  [3928] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(1347),
  [3931] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(8339),
  [3934] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(8338),
  [3937] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(8336),
  [3940] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(6499),
  [3943] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(4166),
  [3946] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(4166),
  [3949] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(6935),
  [3952] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(6803),
  [3955] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(3950),
  [3958] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(3931),
  [3961] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(8284),
  [3964] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(6313),
  [3967] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(7500),
  [3970] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(1468),
  [3973] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(7516),
  [3976] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(1477),
  [3979] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(4759),
  [3982] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(5261),
  [3985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3575),
  [3987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3886),
  [3989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2554),
  [3991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3570),
  [3993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2539),
  [3995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3544),
  [3997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4698),
  [3999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4695),
  [4001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3485),
  [4003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3834),
  [4005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3817),
  [4007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2732),
  [4009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1575),
  [4011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4701),
  [4013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1614),
  [4015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3586),
  [4017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1662),
  [4019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3361),
  [4021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1438),
  [4023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3859),
  [4025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1584),
  [4027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4120),
  [4029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1623),
  [4031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2521),
  [4033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1439),
  [4035] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression_not_binary, 1, 0, 0), SHIFT(291),
  [4038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1204),
  [4040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6677),
  [4042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7571),
  [4044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(133),
  [4046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [4048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1430),
  [4050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8268),
  [4052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1541),
  [4054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1335),
  [4056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8276),
  [4058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [4060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7876),
  [4062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1252),
  [4064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7889),
  [4066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [4068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [4070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [4072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1432),
  [4074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [4076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7965),
  [4078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1336),
  [4080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7962),
  [4082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1834),
  [4084] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_capture_specifier, 2, 0, 0),
  [4086] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_capture_specifier, 2, 0, 0),
  [4088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1617),
  [4090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1206),
  [4092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6455),
  [4094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7463),
  [4096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1366),
  [4098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1140),
  [4100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1187),
  [4102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1534),
  [4104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1124),
  [4106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1127),
  [4108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1132),
  [4110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2080),
  [4112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1386),
  [4114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1188),
  [4116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1167),
  [4118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1148),
  [4120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1150),
  [4122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1471),
  [4124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1141),
  [4126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1145),
  [4128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1159),
  [4130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1161),
  [4132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3450),
  [4134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1138),
  [4136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1604),
  [4138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1122),
  [4140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1153),
  [4142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1137),
  [4144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1190),
  [4146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1136),
  [4148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1183),
  [4150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1130),
  [4152] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(7997),
  [4155] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(7987),
  [4158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3686),
  [4160] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(7976),
  [4163] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(7974),
  [4166] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(7972),
  [4169] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(7931),
  [4172] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(7799),
  [4175] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(7596),
  [4178] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(7914),
  [4181] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(7906),
  [4184] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(7893),
  [4187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1146),
  [4189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1129),
  [4191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1166),
  [4193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1143),
  [4195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1154),
  [4197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2586),
  [4199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [4201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1562),
  [4203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1678),
  [4205] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(7850),
  [4208] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, 1, 104),
  [4210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1557),
  [4212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1660),
  [4214] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 2, 1, 104),
  [4216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_default_capture, 1, 0, 0),
  [4218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [4220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 4, 1, 186),
  [4222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 2, 1, 0),
  [4224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1624),
  [4226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [4228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1387),
  [4230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, 1, 147),
  [4232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1513),
  [4234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1415),
  [4236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [4238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1420),
  [4240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1596),
  [4242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1381),
  [4244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [4246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1476),
  [4248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [4250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, 1, 78),
  [4252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1383),
  [4254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1470),
  [4256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [4258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1411),
  [4260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8200),
  [4262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [4264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5559),
  [4266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5716),
  [4268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3332),
  [4270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1040),
  [4272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3228),
  [4274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(966),
  [4276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8182),
  [4278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [4280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1843),
  [4282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1169),
  [4284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5726),
  [4286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5727),
  [4288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5929),
  [4290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7714),
  [4292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6085),
  [4294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7646),
  [4296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5759),
  [4298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8019),
  [4300] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8015),
  [4303] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8014),
  [4306] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8013),
  [4309] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8008),
  [4312] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8003),
  [4315] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8002),
  [4318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7991),
  [4320] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(7891),
  [4323] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(7888),
  [4326] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(7887),
  [4329] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(7884),
  [4332] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(7883),
  [4335] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8045),
  [4338] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(7878),
  [4341] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(7871),
  [4344] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(7870),
  [4347] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(7869),
  [4350] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(7866),
  [4353] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(7864),
  [4356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3359),
  [4358] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(7863),
  [4361] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(7861),
  [4364] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(7854),
  [4367] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(7853),
  [4370] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(7852),
  [4373] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(7851),
  [4376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8139),
  [4378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [4380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7843),
  [4382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8076),
  [4384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [4386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8364),
  [4388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8208),
  [4390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8112),
  [4392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8127),
  [4394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [4396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2361),
  [4398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3411),
  [4400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [4402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [4404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7973),
  [4406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [4408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [4410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [4412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [4414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6238),
  [4416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [4418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [4420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7658),
  [4422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6070),
  [4424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6054),
  [4426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5990),
  [4428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2111),
  [4430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2140),
  [4432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6213),
  [4434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [4436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(568),
  [4438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [4440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2356),
  [4442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8163),
  [4444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [4446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5991),
  [4448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [4450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [4452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5960),
  [4454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [4456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [4458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6049),
  [4460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1142),
  [4462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1184),
  [4464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1186),
  [4466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1158),
  [4468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1125),
  [4470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1189),
  [4472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1152),
  [4474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1147),
  [4476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1163),
  [4478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1182),
  [4480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1126),
  [4482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1133),
  [4484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1131),
  [4486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1144),
  [4488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1128),
  [4490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1155),
  [4492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1156),
  [4494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1165),
  [4496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1185),
  [4498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1168),
  [4500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1162),
  [4502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1160),
  [4504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1149),
  [4506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1164),
  [4508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1139),
  [4510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2043),
  [4512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2041),
  [4514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2040),
  [4516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3324),
  [4518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1681),
  [4520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4320),
  [4522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5789),
  [4524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5789),
  [4526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6380),
  [4528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(944),
  [4530] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 2, 0, 0),
  [4532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 2, 0, 0),
  [4534] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 35),
  [4536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_identifier, 2, 0, 34),
  [4538] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_qualified_identifier, 2, 0, 34), REDUCE(sym_qualified_type_identifier, 2, 0, 35),
  [4541] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_type_identifier, 2, 0, 35),
  [4543] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, 0, 34),
  [4545] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, 0, 34), REDUCE(sym_qualified_type_identifier, 2, 0, 35),
  [4548] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, 0, 34), SHIFT(232),
  [4551] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 3, 1, 0),
  [4553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 3, 1, 0),
  [4555] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 3, 3, 0),
  [4557] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 3, 3, 0),
  [4559] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 3, 2, 0),
  [4561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 3, 2, 0),
  [4563] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 4, 2, 0),
  [4565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 4, 2, 0),
  [4567] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 4, 3, 0),
  [4569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 4, 3, 0),
  [4571] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 4, 1, 0),
  [4573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 4, 1, 0),
  [4575] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_type, 2, 0, 14),
  [4577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_function, 2, 0, 15),
  [4579] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_template_type, 2, 0, 14), REDUCE(sym_template_function, 2, 0, 15),
  [4582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_type, 2, 0, 14),
  [4584] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_function, 2, 0, 15),
  [4586] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_template_type, 2, 0, 14), REDUCE(sym_template_function, 2, 0, 15),
  [4589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3816),
  [4591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1742),
  [4593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5523),
  [4595] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, 0, 34), SHIFT(320),
  [4598] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression_not_binary, 1, 0, 0), SHIFT(320),
  [4601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declarator, 1, 0, 0),
  [4603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2269),
  [4605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6710),
  [4607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7534),
  [4609] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression_not_binary, 1, 0, 0), SHIFT(285),
  [4612] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression_not_binary, 1, 0, 0), SHIFT(294),
  [4615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2537),
  [4617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1195),
  [4619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1195),
  [4621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6688),
  [4623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7570),
  [4625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3038),
  [4627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6346),
  [4629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [4631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [4633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [4635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [4637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2986),
  [4639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5161),
  [4641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5173),
  [4643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5169),
  [4645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5104),
  [4647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5105),
  [4649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5112),
  [4651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5119),
  [4653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5118),
  [4655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5117),
  [4657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5071),
  [4659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5070),
  [4661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5069),
  [4663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5061),
  [4665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5060),
  [4667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5162),
  [4669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5170),
  [4671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5172),
  [4673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5171),
  [4675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5095),
  [4677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5094),
  [4679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5093),
  [4681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4865),
  [4683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4635),
  [4685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6618),
  [4687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2400),
  [4689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6452),
  [4691] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fold_expression, 3, 0, 40),
  [4693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fold_expression, 3, 0, 40),
  [4695] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_requires_expression, 2, 0, 19),
  [4697] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_expression, 2, 0, 19),
  [4699] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_requires_expression, 3, 0, 65),
  [4701] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_expression, 3, 0, 65),
  [4703] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_requirement_seq, 2, 0, 0),
  [4705] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requirement_seq, 2, 0, 0),
  [4707] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 5, 0, 173),
  [4709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 5, 0, 173),
  [4711] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__requirement_clause_constraint, 3, 0, 0),
  [4713] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__requirement_clause_constraint, 3, 0, 0),
  [4715] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constraint_conjunction, 3, 0, 54),
  [4717] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint_conjunction, 3, 0, 54),
  [4719] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 4, 0, 124),
  [4721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 4, 0, 124),
  [4723] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 4, 0, 123),
  [4725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 4, 0, 123),
  [4727] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 2, 0, 32),
  [4729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 2, 0, 32),
  [4731] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 3, 0, 72),
  [4733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 3, 0, 72),
  [4735] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 3, 0, 73),
  [4737] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 3, 0, 73),
  [4739] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_requirement_seq, 3, 0, 0),
  [4741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requirement_seq, 3, 0, 0),
  [4743] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression_not_binary, 1, 0, 0), SHIFT(311),
  [4746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7020),
  [4748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3298),
  [4750] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_condition_clause, 4, 0, 142),
  [4752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_condition_clause, 4, 0, 142),
  [4754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7230),
  [4756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3380),
  [4758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6951),
  [4760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2458),
  [4762] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_condition_clause, 3, 0, 12),
  [4764] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_condition_clause, 3, 0, 12),
  [4766] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0),
  [4768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0),
  [4770] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(1767),
  [4773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7326),
  [4775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1771),
  [4777] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concatenated_string, 2, 0, 0),
  [4779] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concatenated_string, 2, 0, 0),
  [4781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1772),
  [4783] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concatenated_string, 3, 0, 0),
  [4785] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concatenated_string, 3, 0, 0),
  [4787] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(1772),
  [4790] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0),
  [4792] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0),
  [4794] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(6612),
  [4797] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(7543),
  [4800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7283),
  [4802] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7283),
  [4805] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(1782),
  [4808] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 2, 0, 0),
  [4810] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_raw_string_literal, 7, 0, 205),
  [4812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raw_string_literal, 7, 0, 205),
  [4814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1817),
  [4816] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 3, 0, 0),
  [4818] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 3, 0, 0),
  [4820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1833),
  [4822] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0),
  [4824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0),
  [4826] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(1972),
  [4829] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 2, 0, 0),
  [4831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 2, 0, 0),
  [4833] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_raw_string_literal, 5, 0, 0),
  [4835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raw_string_literal, 5, 0, 0),
  [4837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1889),
  [4839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1836),
  [4841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6362),
  [4843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3284),
  [4845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3205),
  [4847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7947),
  [4849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5430),
  [4851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7266),
  [4853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7949),
  [4855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2874),
  [4857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7956),
  [4859] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 2, 0, 56),
  [4861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 2, 0, 56),
  [4863] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__field_declaration_list_item, 2, 0, 0),
  [4865] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_declaration_list_item, 2, 0, 0),
  [4867] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decltype, 4, 0, 0),
  [4869] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decltype, 4, 0, 0),
  [4871] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dependent_type, 2, -1, 0),
  [4873] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dependent_type, 2, -1, 0),
  [4875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1988),
  [4877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7857),
  [4879] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression_not_binary, 1, 0, 0), SHIFT(322),
  [4882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1224),
  [4884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1224),
  [4886] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 3, 0, 8),
  [4888] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 3, 0, 8),
  [4890] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 3, 0, 56),
  [4892] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, 0, 56),
  [4894] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 3, 0, 66),
  [4896] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, 0, 66),
  [4898] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_method_definition, 3, 0, 67),
  [4900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_method_definition, 3, 0, 67),
  [4902] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 1, 0, 6),
  [4904] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 1, 0, 6),
  [4906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8194),
  [4908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [4910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5563),
  [4912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5775),
  [4914] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_method_definition, 3, 0, 66),
  [4916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_method_definition, 3, 0, 66),
  [4918] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 34),
  [4920] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_type_identifier, 2, 0, 34),
  [4922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6388),
  [4924] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_specifier, 1, 0, 0),
  [4926] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_specifier, 1, 0, 0),
  [4928] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dependent_type_identifier, 2, 0, 0),
  [4930] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dependent_type_identifier, 2, 0, 0),
  [4932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2270),
  [4934] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 1, 0, 0),
  [4936] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0),
  [4938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1974),
  [4940] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_name, 1, 0, 0),
  [4942] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_name, 1, 0, 0),
  [4944] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 7, 0, 206),
  [4946] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 7, 0, 206),
  [4948] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 6, 0, 196),
  [4950] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 6, 0, 196),
  [4952] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 6, 0, 195),
  [4954] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 6, 0, 195),
  [4956] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 6, 0, 206),
  [4958] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 6, 0, 206),
  [4960] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 6, 0, 192),
  [4962] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 6, 0, 192),
  [4964] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_field_declaration_list, 6, 0, 175),
  [4966] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_field_declaration_list, 6, 0, 175),
  [4968] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 5, 0, 179),
  [4970] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 5, 0, 179),
  [4972] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 5, 0, 196),
  [4974] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 5, 0, 196),
  [4976] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 5, 0, 178),
  [4978] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 5, 0, 178),
  [4980] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 5, 0, 195),
  [4982] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 5, 0, 195),
  [4984] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 5, 0, 66),
  [4986] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 5, 0, 66),
  [4988] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 5, 0, 192),
  [4990] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 5, 0, 192),
  [4992] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 5, 0, 128),
  [4994] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 5, 0, 128),
  [4996] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, 0, 78),
  [4998] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, 0, 78),
  [5000] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, 0, 127),
  [5002] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, 0, 127),
  [5004] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 4, 0, 179),
  [5006] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 4, 0, 179),
  [5008] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_field_declaration_list, 4, 0, 78),
  [5010] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_field_declaration_list, 4, 0, 78),
  [5012] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, 0, 79),
  [5014] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, 0, 79),
  [5016] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 4, 0, 178),
  [5018] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 4, 0, 178),
  [5020] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 4, 0, 66),
  [5022] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 4, 0, 66),
  [5024] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, 0, 8),
  [5026] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, 0, 8),
  [5028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7380),
  [5030] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 2, 0, 0),
  [5032] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 2, 0, 0),
  [5034] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 2, 0, 9),
  [5036] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 2, 0, 9),
  [5038] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 2, 0, 6),
  [5040] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 2, 0, 6),
  [5042] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, 0, 8),
  [5044] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, 0, 8),
  [5046] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_specifier, 2, 0, 10),
  [5048] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_specifier, 2, 0, 10),
  [5050] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration, 2, 0, 10),
  [5052] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration, 2, 0, 10),
  [5054] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 6, 0, 138),
  [5056] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 6, 0, 138),
  [5058] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, 0, 7),
  [5060] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, 0, 7),
  [5062] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 5, 0, 139),
  [5064] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 5, 0, 139),
  [5066] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator_list, 2, 0, 0),
  [5068] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator_list, 2, 0, 0),
  [5070] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration, 1, 0, 11),
  [5072] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration, 1, 0, 11),
  [5074] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_specifier, 4, 0, 0),
  [5076] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_specifier, 4, 0, 0),
  [5078] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator_list, 3, 0, 0),
  [5080] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator_list, 3, 0, 0),
  [5082] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7264),
  [5085] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 2, 0, 10),
  [5087] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 2, 0, 10),
  [5089] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, 0, 46),
  [5091] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, 0, 46),
  [5093] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 2, 0, 10),
  [5095] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 2, 0, 10),
  [5097] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, 0, 47),
  [5099] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, 0, 47),
  [5101] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primitive_type, 1, 0, 0),
  [5103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primitive_type, 1, 0, 0),
  [5105] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__enum_base_clause, 2, 0, 97),
  [5107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__enum_base_clause, 2, 0, 97),
  [5109] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, 0, 48),
  [5111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, 0, 48),
  [5113] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, 0, 49),
  [5115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, 0, 49),
  [5117] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 3, 0, 0),
  [5119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 3, 0, 0),
  [5121] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration, 3, 0, 100),
  [5123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration, 3, 0, 100),
  [5125] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 3, 0, 50),
  [5127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 3, 0, 50),
  [5129] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 3, 0, 7),
  [5131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 3, 0, 7),
  [5133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7264),
  [5135] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_placeholder_type_specifier, 1, 0, 0),
  [5137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_placeholder_type_specifier, 1, 0, 0),
  [5139] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0),
  [5142] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0),
  [5145] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decltype_auto, 4, 0, 0),
  [5147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decltype_auto, 4, 0, 0),
  [5149] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, 0, 34), SHIFT(285),
  [5152] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration, 4, 0, 140),
  [5154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration, 4, 0, 140),
  [5156] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator_list, 4, 0, 0),
  [5158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator_list, 4, 0, 0),
  [5160] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 4, 0, 46),
  [5162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 4, 0, 46),
  [5164] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 4, 0, 101),
  [5166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 4, 0, 101),
  [5168] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 5, 0, 94),
  [5170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 5, 0, 94),
  [5172] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 5, 0, 95),
  [5174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 5, 0, 95),
  [5176] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7380),
  [5179] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 5, 0, 98),
  [5181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 5, 0, 98),
  [5183] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_placeholder_type_specifier, 2, 0, 25),
  [5185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_placeholder_type_specifier, 2, 0, 25),
  [5187] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_name, 1, 0, 1),
  [5189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(311),
  [5191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2398),
  [5193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2044),
  [5195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1994),
  [5197] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__string, 1, 0, 0),
  [5199] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__string, 1, 0, 0),
  [5201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2504),
  [5203] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(2391),
  [5206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2028),
  [5208] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, 0, 45),
  [5210] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, 0, 45),
  [5212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1096),
  [5214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1447),
  [5216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2351),
  [5218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7717),
  [5220] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, 0, 34), SHIFT(307),
  [5223] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 35), SHIFT(311),
  [5226] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, 0, 63),
  [5228] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, 0, 63),
  [5230] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 2, 0, 18),
  [5232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 2, 0, 18),
  [5234] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, 0, 90),
  [5236] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, 0, 90),
  [5238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [5240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2098),
  [5242] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression_not_binary, 1, 0, 0), SHIFT(319),
  [5245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2056),
  [5247] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(2026),
  [5250] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declarator, 1, 0, 0), REDUCE(sym__expression_not_binary, 1, 0, 0),
  [5253] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__declarator, 1, 0, 0), REDUCE(sym__expression_not_binary, 1, 0, 0),
  [5256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2179),
  [5258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2100),
  [5260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2138),
  [5262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1216),
  [5264] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_destructor_name, 2, 0, 0),
  [5266] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_destructor_name, 2, 0, 0),
  [5268] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression_not_binary, 1, 0, 0), SHIFT(232),
  [5271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2127),
  [5273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2078),
  [5275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2102),
  [5277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2248),
  [5279] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression_not_binary, 1, 0, 0), SHIFT(7880),
  [5282] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression_not_binary, 1, 0, 0), SHIFT(6128),
  [5285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1235),
  [5287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1235),
  [5289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6639),
  [5291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7578),
  [5293] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, 0, 49),
  [5295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, 0, 49),
  [5297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6093),
  [5299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(167),
  [5301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7880),
  [5303] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__enum_base_clause, 2, 0, 96),
  [5305] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__enum_base_clause, 2, 0, 96),
  [5307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2381),
  [5309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2206),
  [5311] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(2118),
  [5314] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(6710),
  [5317] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(7534),
  [5320] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(2120),
  [5323] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(6639),
  [5326] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(7578),
  [5329] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression_not_binary, 1, 0, 0), SHIFT(323),
  [5332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1204),
  [5334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2518),
  [5336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2285),
  [5338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2120),
  [5340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1238),
  [5342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1238),
  [5344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6642),
  [5346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7577),
  [5348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2118),
  [5350] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, 0, 95),
  [5352] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, 0, 95),
  [5354] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(2258),
  [5357] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(6666),
  [5360] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(7572),
  [5363] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, 0, 94),
  [5365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, 0, 94),
  [5367] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, 0, 2),
  [5369] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 2),
  [5371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1767),
  [5373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2620),
  [5375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2365),
  [5377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2686),
  [5379] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression_not_binary, 1, 0, 0), SHIFT(307),
  [5382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6666),
  [5384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7572),
  [5386] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 2, 0, 7),
  [5388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 2, 0, 7),
  [5390] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_type_declarator, 4, 1, 84),
  [5392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type_declarator, 4, 1, 84),
  [5394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1765),
  [5396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7359),
  [5398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(940),
  [5400] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 2, 0, 50),
  [5402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 2, 0, 50),
  [5404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, -1, 16),
  [5406] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, -1, 16),
  [5408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, -1, 36),
  [5410] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, -1, 36),
  [5412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2280),
  [5414] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, 0, 98),
  [5416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, 0, 98),
  [5418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, 0, 18),
  [5420] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 18),
  [5422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2274),
  [5424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 3, 0, 18),
  [5426] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, 0, 18),
  [5428] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_requires_clause, 2, 0, 20),
  [5430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_clause, 2, 0, 20),
  [5432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5349),
  [5434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5347),
  [5436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5349),
  [5438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5347),
  [5440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2410),
  [5442] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_type_declarator, 5, 1, 168),
  [5444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type_declarator, 5, 1, 168),
  [5446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2262),
  [5448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 3, -1, 36),
  [5450] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, -1, 36),
  [5452] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, 0, 48),
  [5454] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, 0, 48),
  [5456] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, 0, 46),
  [5458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, 0, 46),
  [5460] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(2306),
  [5463] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_type_declarator, 2, 1, 5),
  [5465] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type_declarator, 2, 1, 5),
  [5467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2307),
  [5469] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_reference_type_declarator, 2, 1, 0),
  [5471] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_type_declarator, 2, 1, 0),
  [5473] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 4, 0, 139),
  [5475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 4, 0, 139),
  [5477] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constraint_disjunction, 3, 0, 54),
  [5479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint_disjunction, 3, 0, 54),
  [5481] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 2, 0, 7),
  [5483] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 2, 0, 7),
  [5485] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 5, 0, 138),
  [5487] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 5, 0, 138),
  [5489] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 3, 0, 101),
  [5491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 3, 0, 101),
  [5493] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 1, 0, 9),
  [5495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 1, 0, 9),
  [5497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2258),
  [5499] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 3, 0, 46),
  [5501] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 3, 0, 46),
  [5503] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_type_declarator, 3, 1, 41),
  [5505] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type_declarator, 3, 1, 41),
  [5507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1221),
  [5509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1221),
  [5511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5796),
  [5513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 1, 1, 0),
  [5515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2322),
  [5517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4178),
  [5519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4178),
  [5521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5695),
  [5523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [5525] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_type_declarator, 3, -10, 0),
  [5527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_type_declarator, 3, -10, 0),
  [5529] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(2327),
  [5532] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0),
  [5534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0),
  [5536] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(7359),
  [5539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2335),
  [5541] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, 0, 34), SHIFT(311),
  [5544] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(2335),
  [5547] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_declarator, 1, 0, 0),
  [5549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_declarator, 1, 0, 0),
  [5551] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type_declarator, 2, 0, 86),
  [5553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type_declarator, 2, 0, 86),
  [5555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 2, 1, 0),
  [5557] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type_declarator, 3, 0, 24),
  [5559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type_declarator, 3, 0, 24),
  [5561] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, 0, 62),
  [5563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, 0, 62),
  [5565] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 5, 0, 134),
  [5567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 5, 0, 134),
  [5569] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type_declarator, 5, 0, 170),
  [5571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type_declarator, 5, 0, 170),
  [5573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8155),
  [5575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [5577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5775),
  [5579] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type_declarator, 4, 0, 24),
  [5581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type_declarator, 4, 0, 24),
  [5583] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type_declarator, 4, 0, 117),
  [5585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type_declarator, 4, 0, 117),
  [5587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2332),
  [5589] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_type_declarator, 4, -10, 0),
  [5591] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_type_declarator, 4, -10, 0),
  [5593] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_declarator, 1, 0, 42),
  [5595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_declarator, 1, 0, 42),
  [5597] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_declarator, 1, 0, 1),
  [5599] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_declarator, 1, 0, 1),
  [5601] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_declarator, 1, 0, 43),
  [5603] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_declarator, 1, 0, 43),
  [5605] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attributed_type_declarator, 2, 0, 0),
  [5607] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributed_type_declarator, 2, 0, 0),
  [5609] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, 0, 89),
  [5611] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, 0, 89),
  [5613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2385),
  [5615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2624),
  [5617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2426),
  [5619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2749),
  [5621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3369),
  [5623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2338),
  [5625] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, 0, 110),
  [5627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, 0, 110),
  [5629] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, 0, 47),
  [5631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, 0, 47),
  [5633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5633),
  [5635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2414),
  [5637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2413),
  [5639] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(2399),
  [5642] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(6677),
  [5645] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(7571),
  [5648] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_parameter_list, 2, 0, 0),
  [5650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_parameter_list, 2, 0, 0),
  [5652] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_parameter_list, 3, 0, 0),
  [5654] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_parameter_list, 3, 0, 0),
  [5656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2427),
  [5658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2425),
  [5660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1782),
  [5662] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_method, 2, 0, 118),
  [5664] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_method, 2, 0, 118),
  [5666] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_field_identifier, 2, 0, 119),
  [5668] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_field_identifier, 2, 0, 119),
  [5670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3592),
  [5672] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_expression, 3, 0, 70),
  [5674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_expression, 3, 0, 70),
  [5676] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(2431),
  [5679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2399),
  [5681] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_declarator, 3, 0, 164),
  [5683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_declarator, 3, 0, 164),
  [5685] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_parameter_list, 4, 0, 0),
  [5687] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_parameter_list, 4, 0, 0),
  [5689] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 2, 0, 8),
  [5691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 2, 0, 8),
  [5693] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(2737),
  [5696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2566),
  [5698] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_co_await_expression, 2, 0, 4),
  [5700] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_co_await_expression, 2, 0, 4),
  [5702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1191),
  [5704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5838),
  [5706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5838),
  [5708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2438),
  [5710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4231),
  [5712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4231),
  [5714] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_declarator, 4, 0, 164),
  [5716] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_declarator, 4, 0, 164),
  [5718] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_expression, 2, 0, 4),
  [5720] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_expression, 2, 0, 4),
  [5722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2552),
  [5724] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 54),
  [5726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, 0, 54),
  [5728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6080),
  [5730] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_name, 2, 0, 0),
  [5732] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_name, 2, 0, 0),
  [5734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2549),
  [5736] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_field_identifier, 2, 0, 34),
  [5738] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_field_identifier, 2, 0, 34),
  [5740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2454),
  [5742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4255),
  [5744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4255),
  [5746] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 3, 0, 0),
  [5748] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 3, 0, 0),
  [5750] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_identifier, 3, 0, 74),
  [5752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_identifier, 3, 0, 74),
  [5754] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 3, 0, 74), SHIFT(311),
  [5757] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dependent_field_identifier, 2, 0, 0),
  [5759] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dependent_field_identifier, 2, 0, 0),
  [5761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2595),
  [5763] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 2, 0, 0),
  [5765] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 2, 0, 0),
  [5767] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sizeof_expression, 2, 0, 12),
  [5769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sizeof_expression, 2, 0, 12),
  [5771] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, 0, 4),
  [5773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, 0, 4),
  [5775] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cast_expression, 4, 0, 83),
  [5777] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_expression, 4, 0, 83),
  [5779] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3, 0, 40),
  [5781] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3, 0, 40),
  [5783] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_method, 2, 0, 15),
  [5785] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_method, 2, 0, 15),
  [5787] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 4, 0, 0),
  [5789] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 4, 0, 0),
  [5791] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_specifiers, 1, 0, 2),
  [5793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_specifiers, 1, 0, 2),
  [5795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2655),
  [5797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8070),
  [5799] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [5801] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [5803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2765),
  [5805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2523),
  [5807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2858),
  [5809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8175),
  [5811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [5813] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 4),
  [5815] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, 0, 4),
  [5817] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_specifiers, 2, 0, 18),
  [5819] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_specifiers, 2, 0, 18),
  [5821] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sizeof_expression, 5, 0, 152),
  [5823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sizeof_expression, 5, 0, 152),
  [5825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5610),
  [5827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(285),
  [5829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8194),
  [5831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5592),
  [5833] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 3, 0, 0),
  [5835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3, 0, 0),
  [5837] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 2, 0, 26),
  [5839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 2, 0, 26),
  [5841] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 5, 0, 133),
  [5843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 5, 0, 133),
  [5845] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 2, 0, 30),
  [5847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 2, 0, 30),
  [5849] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_user_defined_literal, 2, 0, 0),
  [5851] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_user_defined_literal, 2, 0, 0),
  [5853] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 5, 0, 132),
  [5855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 5, 0, 132),
  [5857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5308),
  [5859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5308),
  [5861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2592),
  [5863] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, 0, 109),
  [5865] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, 0, 109),
  [5867] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, 0, 108),
  [5869] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, 0, 108),
  [5871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2591),
  [5873] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 5, 0, 0),
  [5875] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 5, 0, 0),
  [5877] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0),
  [5879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0),
  [5881] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 2, 0, 0),
  [5883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 2, 0, 0),
  [5885] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(2555),
  [5888] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 4, 0, 106),
  [5890] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 4, 0, 106),
  [5892] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alignof_expression, 4, 0, 45),
  [5894] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alignof_expression, 4, 0, 45),
  [5896] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 3, 0, 0),
  [5898] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 3, 0, 0),
  [5900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2306),
  [5902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [5904] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 4, 0, 0),
  [5906] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 4, 0, 0),
  [5908] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_null, 1, 0, 0),
  [5910] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_null, 1, 0, 0),
  [5912] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_argument_list, 3, 0, 0),
  [5914] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_argument_list, 3, 0, 0),
  [5916] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 5, 0, 154),
  [5918] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 5, 0, 154),
  [5920] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 5, 0, 155),
  [5922] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 5, 0, 155),
  [5924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2535),
  [5926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8212),
  [5928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [5930] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 5, 0, 165),
  [5932] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 5, 0, 165),
  [5934] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression, 3, 0, 54),
  [5936] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, 0, 54),
  [5938] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_name, 3, 0, 0),
  [5940] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_name, 3, 0, 0),
  [5942] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 6, 0, 176),
  [5944] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 6, 0, 176),
  [5946] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, 0, 29),
  [5948] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, 0, 29),
  [5950] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 5, 0, 0),
  [5952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 5, 0, 0),
  [5954] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_offsetof_expression, 6, 0, 187),
  [5956] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_offsetof_expression, 6, 0, 187),
  [5958] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 6, 0, 189),
  [5960] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 6, 0, 189),
  [5962] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, 0, 88),
  [5964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, 0, 88),
  [5966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8234),
  [5968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [5970] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 6, 0, 190),
  [5972] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 6, 0, 190),
  [5974] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_expression, 3, 0, 71),
  [5976] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_expression, 3, 0, 71),
  [5978] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, 0, 61),
  [5980] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, 0, 61),
  [5982] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_literal_expression, 4, 0, 83),
  [5984] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_literal_expression, 4, 0, 83),
  [5986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2636),
  [5988] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 7, 0, 202),
  [5990] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 7, 0, 202),
  [5992] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_literal_expression, 2, 0, 27),
  [5994] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_literal_expression, 2, 0, 27),
  [5996] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_argument_list, 4, 0, 0),
  [5998] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_argument_list, 4, 0, 0),
  [6000] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 7, 0, 203),
  [6002] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 7, 0, 203),
  [6004] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_expression, 8, 0, 0),
  [6006] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_expression, 8, 0, 0),
  [6008] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 8, 0, 210),
  [6010] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 8, 0, 210),
  [6012] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 8, 0, 211),
  [6014] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 8, 0, 211),
  [6016] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dependent_identifier, 2, 0, 0),
  [6018] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dependent_identifier, 2, 0, 0),
  [6020] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_expression, 9, 0, 0),
  [6022] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_expression, 9, 0, 0),
  [6024] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_argument_list, 2, 0, 0),
  [6026] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_argument_list, 2, 0, 0),
  [6028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5355),
  [6030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5355),
  [6032] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 4, 0, 0),
  [6034] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 4, 0, 0),
  [6036] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 9, 0, 214),
  [6038] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 9, 0, 214),
  [6040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2327),
  [6042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [6044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5563),
  [6046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(307),
  [6048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2619),
  [6050] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 35), SHIFT(285),
  [6053] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_specifiers, 2, 0, 2),
  [6055] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_specifiers, 2, 0, 2),
  [6057] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_specifiers, 3, 0, 18),
  [6059] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_specifiers, 3, 0, 18),
  [6061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2605),
  [6063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2607),
  [6065] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0),
  [6067] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0),
  [6069] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(3284),
  [6072] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(3205),
  [6075] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(7947),
  [6078] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(7266),
  [6081] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(7949),
  [6084] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(2874),
  [6087] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(7956),
  [6090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2600),
  [6092] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(2619),
  [6095] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(6765),
  [6098] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(7528),
  [6101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2606),
  [6103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [6105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2638),
  [6107] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type_specifier, 1, 0, 0), SHIFT(1096),
  [6110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2728),
  [6112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2431),
  [6114] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_requirement, 4, 0, 0),
  [6116] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_requirement, 4, 0, 0),
  [6118] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__requirement, 1, 0, 64),
  [6120] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__requirement, 1, 0, 64),
  [6122] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_storage_class_specifier, 1, 0, 0),
  [6124] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_storage_class_specifier, 1, 0, 0),
  [6126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6648),
  [6128] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_requirement, 2, 0, 0),
  [6130] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_requirement, 2, 0, 0),
  [6132] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_requirement, 5, 0, 0),
  [6134] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_requirement, 5, 0, 0),
  [6136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8226),
  [6138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [6140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2673),
  [6142] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_requirement, 6, 0, 0),
  [6144] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_requirement, 6, 0, 0),
  [6146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6106),
  [6148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5568),
  [6150] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 35), SHIFT(307),
  [6153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2780),
  [6155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2635),
  [6157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6045),
  [6159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6042),
  [6161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5617),
  [6163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1092),
  [6165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1357),
  [6167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3014),
  [6169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7620),
  [6171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2723),
  [6173] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(2723),
  [6176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2725),
  [6178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2741),
  [6180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(323),
  [6182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [6184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1446),
  [6186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1448),
  [6188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1497),
  [6190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1511),
  [6192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1527),
  [6194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1527),
  [6196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1532),
  [6198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1482),
  [6200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1511),
  [6202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1091),
  [6204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1600),
  [6206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3088),
  [6208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7904),
  [6210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2089),
  [6212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2555),
  [6214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [6216] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_expression, 5, 0, 171),
  [6218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2570),
  [6220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_expression, 5, 0, 171),
  [6222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1449),
  [6224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1451),
  [6226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1494),
  [6228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1495),
  [6230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1237),
  [6232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1449),
  [6234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1451),
  [6236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2812),
  [6238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2811),
  [6240] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delete_expression, 5, 0, 0),
  [6242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delete_expression, 5, 0, 0),
  [6244] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_expression, 4, 0, 120),
  [6246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_expression, 4, 0, 120),
  [6248] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delete_expression, 4, 0, 0),
  [6250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delete_expression, 4, 0, 0),
  [6252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [6254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2110),
  [6256] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delete_expression, 3, 0, 0),
  [6258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delete_expression, 3, 0, 0),
  [6260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [6262] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 35), SHIFT(323),
  [6265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1926),
  [6267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2758),
  [6269] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delete_expression, 2, 0, 0),
  [6271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delete_expression, 2, 0, 0),
  [6273] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alignas_specifier, 4, 0, 0),
  [6275] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alignas_specifier, 4, 0, 0),
  [6277] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ms_declspec_modifier, 4, 0, 0),
  [6279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_declspec_modifier, 4, 0, 0),
  [6281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2951),
  [6283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7785),
  [6285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6140),
  [6287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5691),
  [6289] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_char_literal, 3, 0, 0),
  [6291] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_char_literal, 3, 0, 0),
  [6293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3405),
  [6295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2955),
  [6297] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 3, 1, 0),
  [6299] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_number_literal, 1, 0, 0),
  [6301] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_number_literal, 1, 0, 0),
  [6303] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_virtual, 1, 0, 0),
  [6305] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_virtual, 1, 0, 0),
  [6307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [6309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1761),
  [6311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7302),
  [6313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(937),
  [6315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [6317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6121),
  [6319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1093),
  [6321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1659),
  [6323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3409),
  [6325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7834),
  [6327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2177),
  [6329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3364),
  [6331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1197),
  [6333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3447),
  [6335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1321),
  [6337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1320),
  [6339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1319),
  [6341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1318),
  [6343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1317),
  [6345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1316),
  [6347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1315),
  [6349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1313),
  [6351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1311),
  [6353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1310),
  [6355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1309),
  [6357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1308),
  [6359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1307),
  [6361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1306),
  [6363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1305),
  [6365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1304),
  [6367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1303),
  [6369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1302),
  [6371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1157),
  [6373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1181),
  [6375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1227),
  [6377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1180),
  [6379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1179),
  [6381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [6383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1177),
  [6385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1176),
  [6387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1175),
  [6389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1174),
  [6391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [6393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1171),
  [6395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1170),
  [6397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1209),
  [6399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1350),
  [6401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1301),
  [6403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1300),
  [6405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1299),
  [6407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1298),
  [6409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1297),
  [6411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1296),
  [6413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3365),
  [6415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5845),
  [6417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5810),
  [6419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7966),
  [6421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2073),
  [6423] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__binary_fold_operator, 3, 0, 129),
  [6425] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__binary_fold_operator, 3, 0, 129),
  [6427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1606),
  [6429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1603),
  [6431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1601),
  [6433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1592),
  [6435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1589),
  [6437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1588),
  [6439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1580),
  [6441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1579),
  [6443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1578),
  [6445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1578),
  [6447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1573),
  [6449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1351),
  [6451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1601),
  [6453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1592),
  [6455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1589),
  [6457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1580),
  [6459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1203),
  [6461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(764),
  [6463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3555),
  [6465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1902),
  [6467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [6469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2474),
  [6471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3737),
  [6473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1764),
  [6475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7272),
  [6477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(935),
  [6479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3645),
  [6481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3645),
  [6483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3428),
  [6485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7793),
  [6487] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(3560),
  [6490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3189),
  [6492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3790),
  [6494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6375),
  [6496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3738),
  [6498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2553),
  [6500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2553),
  [6502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2447),
  [6504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8073),
  [6506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3717),
  [6508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3702),
  [6510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3714),
  [6512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3331),
  [6514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3331),
  [6516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3074),
  [6518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7923),
  [6520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3721),
  [6522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3431),
  [6524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3420),
  [6526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3420),
  [6528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3329),
  [6530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7629),
  [6532] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__declarator, 1, 0, 0), REDUCE(sym__type_specifier, 1, 0, 1),
  [6535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6381),
  [6537] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(7302),
  [6540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3075),
  [6542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6334),
  [6544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3718),
  [6546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6364),
  [6548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5807),
  [6550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1677),
  [6552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1597),
  [6554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1528),
  [6556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1512),
  [6558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1444),
  [6560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1443),
  [6562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1442),
  [6564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1428),
  [6566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1428),
  [6568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1526),
  [6570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1508),
  [6572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1528),
  [6574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1512),
  [6576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1443),
  [6578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1416),
  [6580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1416),
  [6582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5845),
  [6584] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 3, 0, 74), SHIFT(320),
  [6587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3210),
  [6589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3279),
  [6591] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 3, 0, 74), SHIFT(232),
  [6594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1517),
  [6596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1523),
  [6598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1524),
  [6600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1525),
  [6602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1529),
  [6604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1533),
  [6606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1537),
  [6608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1542),
  [6610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1545),
  [6612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1545),
  [6614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1546),
  [6616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1524),
  [6618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1525),
  [6620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1529),
  [6622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1537),
  [6624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1241),
  [6626] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(7272),
  [6629] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(1971),
  [6632] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(3128),
  [6635] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(8386),
  [6638] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(7490),
  [6641] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(8375),
  [6644] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(3137),
  [6647] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(8331),
  [6650] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__constructor_specifiers, 1, 0, 0), REDUCE(aux_sym__declaration_specifiers_repeat1, 1, 0, 0),
  [6653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__constructor_specifiers, 1, 0, 0),
  [6655] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__constructor_specifiers, 1, 0, 0),
  [6657] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__constructor_specifiers, 1, 0, 0), REDUCE(aux_sym__declaration_specifiers_repeat1, 1, 0, 0),
  [6660] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 1, 0, 0),
  [6662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1556),
  [6664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1551),
  [6666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1549),
  [6668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1543),
  [6670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1540),
  [6672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1538),
  [6674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1535),
  [6676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1563),
  [6678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1531),
  [6680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1531),
  [6682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1530),
  [6684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1219),
  [6686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1516),
  [6688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1549),
  [6690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1543),
  [6692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1540),
  [6694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1535),
  [6696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5840),
  [6698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5840),
  [6700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3843),
  [6702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8060),
  [6704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3847),
  [6706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1286),
  [6708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1285),
  [6710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1284),
  [6712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1283),
  [6714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1282),
  [6716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1281),
  [6718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1279),
  [6720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1278),
  [6722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1277),
  [6724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1276),
  [6726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1275),
  [6728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1274),
  [6730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1273),
  [6732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1272),
  [6734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1271),
  [6736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1270),
  [6738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1269),
  [6740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1268),
  [6742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8059),
  [6744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1202),
  [6746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8056),
  [6748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8040),
  [6750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8020),
  [6752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7597),
  [6754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7744),
  [6756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7975),
  [6758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7959),
  [6760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7920),
  [6762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7875),
  [6764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7865),
  [6766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1568),
  [6768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1266),
  [6770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1265),
  [6772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1264),
  [6774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1263),
  [6776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1262),
  [6778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1261),
  [6780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3848),
  [6782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6402),
  [6784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3231),
  [6786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5138),
  [6788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5138),
  [6790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5612),
  [6792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8273),
  [6794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3407),
  [6796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3257),
  [6798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3263),
  [6800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5102),
  [6802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5102),
  [6804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1514),
  [6806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1172),
  [6808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3574),
  [6810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5900),
  [6812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5900),
  [6814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3408),
  [6816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1518),
  [6818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1509),
  [6820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1507),
  [6822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1505),
  [6824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1504),
  [6826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1503),
  [6828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1502),
  [6830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1500),
  [6832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1436),
  [6834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1509),
  [6836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1507),
  [6838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1504),
  [6840] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 3, 0, 74), SHIFT(285),
  [6843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3354),
  [6845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5136),
  [6847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5136),
  [6849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5585),
  [6851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3577),
  [6853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1510),
  [6855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1220),
  [6857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1510),
  [6859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1290),
  [6861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1209),
  [6863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4336),
  [6865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3669),
  [6867] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(3257),
  [6870] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(6642),
  [6873] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(7577),
  [6876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5662),
  [6878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5666),
  [6880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3288),
  [6882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5115),
  [6884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5115),
  [6886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3297),
  [6888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5091),
  [6890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5091),
  [6892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5603),
  [6894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1751),
  [6896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3610),
  [6898] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type_specifier, 1, 0, 0), SHIFT(1092),
  [6901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3204),
  [6903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8155),
  [6905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [6907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [6909] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 21),
  [6911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5466),
  [6913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5466),
  [6915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1971),
  [6917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8386),
  [6919] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declarator_seq, 1, 0, 21),
  [6921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6535),
  [6923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3708),
  [6925] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 21), SHIFT(5910),
  [6928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5664),
  [6930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7684),
  [6932] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 21), SHIFT(5326),
  [6935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3453),
  [6937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5809),
  [6939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5910),
  [6941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5326),
  [6943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2514),
  [6945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4802),
  [6947] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 21), SHIFT(8128),
  [6950] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 21), SHIFT(7415),
  [6953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4802),
  [6955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3783),
  [6957] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 21), SHIFT(5775),
  [6960] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 21), SHIFT(5362),
  [6963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5362),
  [6965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3483),
  [6967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3426),
  [6969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3424),
  [6971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5360),
  [6973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5360),
  [6975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2026),
  [6977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3667),
  [6979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3427),
  [6981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(319),
  [6983] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0),
  [6985] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0),
  [6987] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(3284),
  [6990] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(3205),
  [6993] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(7947),
  [6996] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(7266),
  [6999] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(7949),
  [7002] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(2874),
  [7005] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(7956),
  [7008] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(4214),
  [7011] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 3, 0, 74), SHIFT(307),
  [7014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3519),
  [7016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(322),
  [7018] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_declaration, 2, 0, 107),
  [7020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4812),
  [7022] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(3519),
  [7025] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(6688),
  [7028] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(7570),
  [7031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5361),
  [7033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5361),
  [7035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3622),
  [7037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5346),
  [7039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5346),
  [7041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8128),
  [7043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3703),
  [7045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1620),
  [7047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1616),
  [7049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1550),
  [7051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3604),
  [7053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1615),
  [7055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1609),
  [7057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1572),
  [7059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1564),
  [7061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1560),
  [7063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1558),
  [7065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1554),
  [7067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1554),
  [7069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1572),
  [7071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1564),
  [7073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1560),
  [7075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3661),
  [7077] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(3604),
  [7080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5350),
  [7082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5350),
  [7084] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0),
  [7086] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0),
  [7088] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(3909),
  [7091] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(3930),
  [7094] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 21), SHIFT(7266),
  [7097] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 21), SHIFT(6535),
  [7100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3792),
  [7102] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 21), SHIFT(5335),
  [7105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3782),
  [7107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5335),
  [7109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5642),
  [7111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4713),
  [7113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5604),
  [7115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6373),
  [7117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3720),
  [7119] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 35), SHIFT(322),
  [7122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3580),
  [7124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1410),
  [7126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4941),
  [7128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6365),
  [7130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4908),
  [7132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6016),
  [7134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5059),
  [7136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5167),
  [7138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5168),
  [7140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4893),
  [7142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3767),
  [7144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5307),
  [7146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4180),
  [7148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6355),
  [7150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4105),
  [7152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4545),
  [7154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6004),
  [7156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5144),
  [7158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5058),
  [7160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5143),
  [7162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4873),
  [7164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8214),
  [7166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4838),
  [7168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4468),
  [7170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6342),
  [7172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4159),
  [7174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4773),
  [7176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5992),
  [7178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5131),
  [7180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5129),
  [7182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5127),
  [7184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5028),
  [7186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8235),
  [7188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4817),
  [7190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4162),
  [7192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6371),
  [7194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5994),
  [7196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5134),
  [7198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5133),
  [7200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5132),
  [7202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4871),
  [7204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4830),
  [7206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6336),
  [7208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5981),
  [7210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5111),
  [7212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5110),
  [7214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5109),
  [7216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4867),
  [7218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6130),
  [7220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5641),
  [7222] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ms_call_modifier, 1, 0, 0),
  [7224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_call_modifier, 1, 0, 0),
  [7226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3697),
  [7228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5377),
  [7230] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 21), SHIFT(5307),
  [7233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4782),
  [7235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6339),
  [7237] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 21), SHIFT(5377),
  [7240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3898),
  [7242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5336),
  [7244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5331),
  [7246] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 35), SHIFT(319),
  [7249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1095),
  [7251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4088),
  [7253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7925),
  [7255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3768),
  [7257] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 21), SHIFT(5304),
  [7260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5304),
  [7262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1680),
  [7264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3899),
  [7266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5268),
  [7268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5268),
  [7270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3909),
  [7272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3909),
  [7274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3930),
  [7276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(948),
  [7278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3901),
  [7280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5265),
  [7282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5265),
  [7284] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ms_pointer_modifier, 1, 0, 0),
  [7286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_pointer_modifier, 1, 0, 0),
  [7288] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ms_unaligned_ptr_modifier, 1, 0, 0),
  [7290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_unaligned_ptr_modifier, 1, 0, 0),
  [7292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3932),
  [7294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5262),
  [7296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5262),
  [7298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5628),
  [7300] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declarator, 1, 0, 0),
  [7302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3733),
  [7304] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 21), SHIFT(5311),
  [7307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1089),
  [7309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1988),
  [7311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7857),
  [7313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3966),
  [7315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5279),
  [7317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5279),
  [7319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4675),
  [7321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4186),
  [7323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4158),
  [7325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [7327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(294),
  [7329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5311),
  [7331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7415),
  [7333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3700),
  [7335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3390),
  [7337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5123),
  [7339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4012),
  [7341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5351),
  [7343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5351),
  [7345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3930),
  [7347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3391),
  [7349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3510),
  [7351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2368),
  [7353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5166),
  [7355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3991),
  [7357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5315),
  [7359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5315),
  [7361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2367),
  [7363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2475),
  [7365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3992),
  [7367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5408),
  [7369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5408),
  [7371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3994),
  [7373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5348),
  [7375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5348),
  [7377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6110),
  [7379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5153),
  [7381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3995),
  [7383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5312),
  [7385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5312),
  [7387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6109),
  [7389] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 35), SHIFT(294),
  [7392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3999),
  [7394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5385),
  [7396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5385),
  [7398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5655),
  [7400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4023),
  [7402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5370),
  [7404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5370),
  [7406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3268),
  [7408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5087),
  [7410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4011),
  [7412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5300),
  [7414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5300),
  [7416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3270),
  [7418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3311),
  [7420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4005),
  [7422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5325),
  [7424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5325),
  [7426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3751),
  [7428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3706),
  [7430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4047),
  [7432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5442),
  [7434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5442),
  [7436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3128),
  [7438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8375),
  [7440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2655),
  [7442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8070),
  [7444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3137),
  [7446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8331),
  [7448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5556),
  [7450] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(4186),
  [7453] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(4158),
  [7456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4480),
  [7458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4156),
  [7460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1419),
  [7462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1419),
  [7464] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator, 3, 0, 137),
  [7466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3947),
  [7468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator, 3, 0, 137),
  [7470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1417),
  [7472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1421),
  [7474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1424),
  [7476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1434),
  [7478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1454),
  [7480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1457),
  [7482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1459),
  [7484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1466),
  [7486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1466),
  [7488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1515),
  [7490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1192),
  [7492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1587),
  [7494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1421),
  [7496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1424),
  [7498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1454),
  [7500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1459),
  [7502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1090),
  [7504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1629),
  [7506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4114),
  [7508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5532),
  [7510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5532),
  [7512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6746),
  [7514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 1, 0, 56),
  [7516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4136),
  [7518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4136),
  [7520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1377),
  [7522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1555),
  [7524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_reference_declarator, 1, 0, 0),
  [7526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 1, 0, 2),
  [7528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4894),
  [7530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7877),
  [7532] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(4139),
  [7535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5666),
  [7537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 2, 0, 18),
  [7539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4154),
  [7541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5636),
  [7543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5636),
  [7545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4725),
  [7547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4192),
  [7549] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(1971),
  [7552] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(3128),
  [7555] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(8386),
  [7558] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(7550),
  [7561] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(8375),
  [7564] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(3137),
  [7567] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(8331),
  [7570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5729),
  [7572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1676),
  [7574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1675),
  [7576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1675),
  [7578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1674),
  [7580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1672),
  [7582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1671),
  [7584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1670),
  [7586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1669),
  [7588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1668),
  [7590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1666),
  [7592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1666),
  [7594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1665),
  [7596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2117),
  [7598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1225),
  [7600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1469),
  [7602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1671),
  [7604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1669),
  [7606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5016),
  [7608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7916),
  [7610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5353),
  [7612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5352),
  [7614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5353),
  [7616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5352),
  [7618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4169),
  [7620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5707),
  [7622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5707),
  [7624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5372),
  [7626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5375),
  [7628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1920),
  [7630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4471),
  [7632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_attributes_start, 1, 0, 0),
  [7634] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_attributes_start, 1, 0, 0),
  [7636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2053),
  [7638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1626),
  [7640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1627),
  [7642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1627),
  [7644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1635),
  [7646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1635),
  [7648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1638),
  [7650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1639),
  [7652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6181),
  [7654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5270),
  [7656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4209),
  [7658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5756),
  [7660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5756),
  [7662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6525),
  [7664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4204),
  [7666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5765),
  [7668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5765),
  [7670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1634),
  [7672] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(4221),
  [7675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1628),
  [7677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1630),
  [7679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1631),
  [7681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1632),
  [7683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1633),
  [7685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [7687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1631),
  [7689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1633),
  [7691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4197),
  [7693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5764),
  [7695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5764),
  [7697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5343),
  [7699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5201),
  [7701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5201),
  [7703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5209),
  [7705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5343),
  [7707] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_explicit_function_specifier, 4, 0, 0),
  [7709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_explicit_function_specifier, 4, 0, 0),
  [7711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4207),
  [7713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5714),
  [7715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5714),
  [7717] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_explicit_function_specifier, 1, 0, 0),
  [7719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1599),
  [7721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_explicit_function_specifier, 1, 0, 0),
  [7723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1073),
  [7725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [7727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3892),
  [7729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1119),
  [7731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3673),
  [7733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4676),
  [7735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3696),
  [7737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3600),
  [7739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2726),
  [7741] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_initializer_pair, 3, 0, 150), SHIFT(1290),
  [7744] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_pair, 3, 0, 150),
  [7746] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_initializer_list_repeat1, 2, 0, 0), SHIFT(1290),
  [7749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comma_expression, 3, 0, 81),
  [7751] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_initializer_list_repeat1, 2, 0, 0),
  [7753] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 3, 0, 18),
  [7755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4699),
  [7757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [7759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1392),
  [7761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1393),
  [7763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1393),
  [7765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1394),
  [7767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1395),
  [7769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1396),
  [7771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1401),
  [7773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1403),
  [7775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1413),
  [7777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1414),
  [7779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1422),
  [7781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1422),
  [7783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1213),
  [7785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1664),
  [7787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1396),
  [7789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1403),
  [7791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4673),
  [7793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1721),
  [7795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 2, 0, 2),
  [7797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3503),
  [7799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1086),
  [7801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3881),
  [7803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2795),
  [7805] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bitfield_clause, 2, 0, 0),
  [7807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [7809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1594),
  [7811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1399),
  [7813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1398),
  [7815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1398),
  [7817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1397),
  [7819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1391),
  [7821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1390),
  [7823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1389),
  [7825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1370),
  [7827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1369),
  [7829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1368),
  [7831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1368),
  [7833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1364),
  [7835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6382),
  [7837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1236),
  [7839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1362),
  [7841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1390),
  [7843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1370),
  [7845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1607),
  [7847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1607),
  [7849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1766),
  [7851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1014),
  [7853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2579),
  [7855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_init_declarator, 3, 0, 112),
  [7857] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_condition_declaration, 4, 0, 181),
  [7859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1233),
  [7861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2541),
  [7863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1789),
  [7865] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 4, 0, 174),
  [7867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2590),
  [7869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1077),
  [7871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3660),
  [7873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4722),
  [7875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1076),
  [7877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3508),
  [7879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2303),
  [7881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6459),
  [7883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3591),
  [7885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3573),
  [7887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6476),
  [7889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1913),
  [7891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1081),
  [7893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2527),
  [7895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1714),
  [7897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3533),
  [7899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3889),
  [7901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3798),
  [7903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4729),
  [7905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2717),
  [7907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2714),
  [7909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3904),
  [7911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2499),
  [7913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2025),
  [7915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6326),
  [7917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4137),
  [7919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4310),
  [7921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5801),
  [7923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5801),
  [7925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1083),
  [7927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4663),
  [7929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1684),
  [7931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1085),
  [7933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3392),
  [7935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3677),
  [7937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1707),
  [7939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4706),
  [7941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1805),
  [7943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3856),
  [7945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3747),
  [7947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4687),
  [7949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2674),
  [7951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2867),
  [7953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3437),
  [7955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4117),
  [7957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1232),
  [7959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5649),
  [7961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1218),
  [7963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [7965] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_pair, 3, 0, 151),
  [7967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1245),
  [7969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1492),
  [7971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1602),
  [7973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1602),
  [7975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1491),
  [7977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1490),
  [7979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1489),
  [7981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1488),
  [7983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1487),
  [7985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1481),
  [7987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1480),
  [7989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1480),
  [7991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1479),
  [7993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1388),
  [7995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1229),
  [7997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1478),
  [7999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1489),
  [8001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1487),
  [8003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4475),
  [8005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter_declaration, 4, 0, 192),
  [8007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5997),
  [8009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8072),
  [8011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1427),
  [8013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter_declaration, 3, 0, 158),
  [8015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5974),
  [8017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8189),
  [8019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1608),
  [8021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1460),
  [8023] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_argument_list_repeat1, 2, 1, 0),
  [8025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1763),
  [8027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1465),
  [8029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [8031] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 5, 1, 197),
  [8033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4139),
  [8035] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, 1, 145),
  [8037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [8039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [8041] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(1971),
  [8044] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(1971),
  [8047] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_lambda_capture_specifier_repeat1, 2, 0, 0),
  [8049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, 1, 146),
  [8051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1519),
  [8053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1378),
  [8055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1673),
  [8057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [8059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [8061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5961),
  [8063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7835),
  [8065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1367),
  [8067] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 4, 1, 185),
  [8069] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 4, 1, 183),
  [8071] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 4, 1, 182),
  [8073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [8075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [8077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1404),
  [8079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1473),
  [8081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1207),
  [8083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1506),
  [8085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2700),
  [8087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5951),
  [8089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7691),
  [8091] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_generic_expression_repeat1, 4, 0, 0),
  [8093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4411),
  [8095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4406),
  [8097] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_subscript_argument_list_repeat1, 2, 0, 0),
  [8099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1031),
  [8101] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 3, 0, 0),
  [8103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5942),
  [8105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8005),
  [8107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0),
  [8109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1385),
  [8111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5930),
  [8113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8343),
  [8115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [8117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6028),
  [8119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7673),
  [8121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1028),
  [8123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [8125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_range_loop_body, 4, 0, 184),
  [8127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [8129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [8131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [8133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2428),
  [8135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [8137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [8139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6883),
  [8141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [8143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5682),
  [8145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [8147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [8149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [8151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4526),
  [8153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6019),
  [8155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6019),
  [8157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [8159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7145),
  [8161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2316),
  [8163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2131),
  [8165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unary_left_fold, 3, 0, 54),
  [8167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6860),
  [8169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [8171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4422),
  [8173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2077),
  [8175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [8177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__assignment_expression_lhs, 3, 0, 54),
  [8179] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__binary_fold, 3, 0, 82),
  [8181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7236),
  [8183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2873),
  [8185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [8187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1027),
  [8189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1026),
  [8191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [8193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4017),
  [8195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4959),
  [8197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_range_loop_body, 5, 0, 198),
  [8199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2870),
  [8201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [8203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2192),
  [8205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3690),
  [8207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [8209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [8211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2058),
  [8213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3728),
  [8215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3729),
  [8217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3746),
  [8219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3730),
  [8221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2067),
  [8223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2099),
  [8225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3748),
  [8227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2997),
  [8229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1827),
  [8231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2816),
  [8233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [8235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3791),
  [8237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2602),
  [8239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [8241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3692),
  [8243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1816),
  [8245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3254),
  [8247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1822),
  [8249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1835),
  [8251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6833),
  [8253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3222),
  [8255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [8257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [8259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [8261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [8263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [8265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3131),
  [8267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [8269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4205),
  [8271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [8273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3498),
  [8275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7034),
  [8277] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_declaration, 1, 0, 0),
  [8279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4869),
  [8281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3190),
  [8283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_definition_repeat1, 2, 0, 0),
  [8285] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_type_definition_repeat1, 2, 0, 0),
  [8287] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(8386),
  [8290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [8292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_attributes_start, 2, 0, 0),
  [8294] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_attributes_start, 2, 0, 0),
  [8296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [8298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [8300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4221),
  [8302] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(4802),
  [8305] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(4802),
  [8308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5359),
  [8310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5364),
  [8312] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 21),
  [8314] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declarator_seq, 2, 0, 21),
  [8316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [8318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4726),
  [8320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4717),
  [8322] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 21), SHIFT(5910),
  [8325] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 21), SHIFT(5326),
  [8328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4647),
  [8330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8240),
  [8332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [8334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6126),
  [8336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5576),
  [8338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3444),
  [8340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6337),
  [8342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5985),
  [8344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5120),
  [8346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5106),
  [8348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5101),
  [8350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4892),
  [8352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3496),
  [8354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6377),
  [8356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2984),
  [8358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5984),
  [8360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5125),
  [8362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5124),
  [8364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5121),
  [8366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4057),
  [8368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8241),
  [8370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4898),
  [8372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [8374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2742),
  [8376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6349),
  [8378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2477),
  [8380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6008),
  [8382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5147),
  [8384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5146),
  [8386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5145),
  [8388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3371),
  [8390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8197),
  [8392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4853),
  [8394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3967),
  [8396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6376),
  [8398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6011),
  [8400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5158),
  [8402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5152),
  [8404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5149),
  [8406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4822),
  [8408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2484),
  [8410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6348),
  [8412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2263),
  [8414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5926),
  [8416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5082),
  [8418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5083),
  [8420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5084),
  [8422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3007),
  [8424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8132),
  [8426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4819),
  [8428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6104),
  [8430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5637),
  [8432] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 21), SHIFT(8128),
  [8435] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 21), SHIFT(7415),
  [8438] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 21), SHIFT(5775),
  [8441] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 21), SHIFT(5362),
  [8444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2317),
  [8446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6383),
  [8448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2003),
  [8450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5963),
  [8452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5139),
  [8454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5141),
  [8456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5142),
  [8458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2379),
  [8460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8158),
  [8462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4813),
  [8464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2599),
  [8466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6368),
  [8468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2377),
  [8470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5996),
  [8472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5140),
  [8474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5137),
  [8476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5135),
  [8478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3187),
  [8480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8227),
  [8482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4897),
  [8484] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(8128),
  [8487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2301),
  [8489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1996),
  [8491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6000),
  [8493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4858),
  [8495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [8497] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 21), SHIFT(6535),
  [8500] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 21), SHIFT(7266),
  [8503] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 21), SHIFT(5335),
  [8506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5584),
  [8508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 21),
  [8510] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declarator_seq, 3, 0, 21),
  [8512] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 21), SHIFT(5910),
  [8515] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 21), SHIFT(5326),
  [8518] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_parameter_list, 2, 0, 0), REDUCE(sym_argument_list, 2, 0, 0),
  [8521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3618),
  [8523] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 21), SHIFT(5377),
  [8526] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 21), SHIFT(5307),
  [8529] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(4953),
  [8532] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(4950),
  [8535] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(1957),
  [8538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5597),
  [8540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5555),
  [8542] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 21), SHIFT(8128),
  [8545] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 21), SHIFT(7415),
  [8548] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 21), SHIFT(5775),
  [8551] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 21), SHIFT(5362),
  [8554] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 21), SHIFT(5304),
  [8557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4956),
  [8559] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 21), SHIFT(7266),
  [8562] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 21), SHIFT(6535),
  [8565] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 21), SHIFT(5335),
  [8568] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 2), SHIFT(2026),
  [8571] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT(2026),
  [8575] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 18), SHIFT(4964),
  [8578] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, -1, 36), SHIFT(4962),
  [8581] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, -1, 16), SHIFT(2026),
  [8584] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, -1, 36), SHIFT(2026),
  [8587] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type_specifier, 1, 0, 0), SHIFT(1091),
  [8590] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, 0, 18), SHIFT(2026),
  [8593] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_definition_type, 2, 0, 18),
  [8595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_type, 2, 0, 18),
  [8597] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(4675),
  [8600] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(4675),
  [8603] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_definition_type, 1, 0, 2),
  [8605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_type, 1, 0, 2),
  [8607] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(5201),
  [8610] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(5201),
  [8613] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(5209),
  [8616] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 21), SHIFT(5311),
  [8619] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 21), SHIFT(5377),
  [8622] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 21), SHIFT(5307),
  [8625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5692),
  [8627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4167),
  [8629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4662),
  [8631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3081),
  [8633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4742),
  [8635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2601),
  [8637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3473),
  [8639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3849),
  [8641] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 21), SHIFT(5304),
  [8644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3681),
  [8646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3670),
  [8648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4390),
  [8650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2679),
  [8652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1995),
  [8654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2766),
  [8656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4036),
  [8658] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type_specifier, 1, 0, 0), SHIFT(4949),
  [8661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6356),
  [8663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4739),
  [8665] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 21),
  [8667] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declarator_seq, 4, 0, 21),
  [8669] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(7266),
  [8672] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_definition_type, 2, 0, 2),
  [8674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_type, 2, 0, 2),
  [8676] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_definition_type, 3, 0, 18),
  [8678] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_type, 3, 0, 18),
  [8680] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 21), SHIFT(5910),
  [8683] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 21), SHIFT(5326),
  [8686] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 21), SHIFT(8128),
  [8689] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 21), SHIFT(7415),
  [8692] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 21), SHIFT(5775),
  [8695] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 21), SHIFT(5362),
  [8698] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 21), SHIFT(5311),
  [8701] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 21), SHIFT(7266),
  [8704] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 21), SHIFT(6535),
  [8707] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 21), SHIFT(5335),
  [8710] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 21), SHIFT(5377),
  [8713] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 21), SHIFT(5307),
  [8716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [8718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1053),
  [8720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3522),
  [8722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6771),
  [8724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [8726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1051),
  [8728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2589),
  [8730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6766),
  [8732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [8734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1060),
  [8736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4168),
  [8738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6759),
  [8740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [8742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1070),
  [8744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3801),
  [8746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6757),
  [8748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [8750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1074),
  [8752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3615),
  [8754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6850),
  [8756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [8758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1064),
  [8760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4654),
  [8762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6849),
  [8764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4170),
  [8766] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(5343),
  [8769] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(5343),
  [8772] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 21), SHIFT(5304),
  [8775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5405),
  [8777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5524),
  [8779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5389),
  [8781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7337),
  [8783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5334),
  [8785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5334),
  [8787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5510),
  [8789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5510),
  [8791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7061),
  [8793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7805),
  [8795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5672),
  [8797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1762),
  [8799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2151),
  [8801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [8803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(947),
  [8805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1103),
  [8807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1382),
  [8809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7268),
  [8811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1845),
  [8813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [8815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1107),
  [8817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7300),
  [8819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2185),
  [8821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [8823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1121),
  [8825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7409),
  [8827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5491),
  [8829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5323),
  [8831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7501),
  [8833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5324),
  [8835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5324),
  [8837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5693),
  [8839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5693),
  [8841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7253),
  [8843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4176),
  [8845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7101),
  [8847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1116),
  [8849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6148),
  [8851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1104),
  [8853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5581),
  [8855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6747),
  [8857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5618),
  [8859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5735),
  [8861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1117),
  [8863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6367),
  [8865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5969),
  [8867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1105),
  [8869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2509),
  [8871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6259),
  [8873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6359),
  [8875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3377),
  [8877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1109),
  [8879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5814),
  [8881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6792),
  [8883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5819),
  [8885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1683),
  [8887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8037),
  [8889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5322),
  [8891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7142),
  [8893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(916),
  [8895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5829),
  [8897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6196),
  [8899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4330),
  [8901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1114),
  [8903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3796),
  [8905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5944),
  [8907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1115),
  [8909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5638),
  [8911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6608),
  [8913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3845),
  [8915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3755),
  [8917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7168),
  [8919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1110),
  [8921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3549),
  [8923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2014),
  [8925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6361),
  [8927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1752),
  [8929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2297),
  [8931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3567),
  [8933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4172),
  [8935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2511),
  [8937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4672),
  [8939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1118),
  [8941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3414),
  [8943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3412),
  [8945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5688),
  [8947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5995),
  [8949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2275),
  [8951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4184),
  [8953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5993),
  [8955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6291),
  [8957] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 21), SHIFT(5311),
  [8960] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_attributes_end, 2, 0, 0),
  [8962] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_attributes_end, 2, 0, 0),
  [8964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_attributes_end, 1, 0, 0),
  [8966] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_attributes_end, 1, 0, 0),
  [8968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5673),
  [8970] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__preproc_expression, 1, 0, 0),
  [8972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5273),
  [8974] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__preproc_expression, 1, 0, 0),
  [8976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6341),
  [8978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6344),
  [8980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7158),
  [8982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5309),
  [8984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5527),
  [8986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5407),
  [8988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5299),
  [8990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5299),
  [8992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5406),
  [8994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5404),
  [8996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5403),
  [8998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5402),
  [9000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5401),
  [9002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5400),
  [9004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5396),
  [9006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5396),
  [9008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5392),
  [9010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7695),
  [9012] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ref_qualifier, 1, 0, 0),
  [9014] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ref_qualifier, 1, 0, 0),
  [9016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5613),
  [9018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5287),
  [9020] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [9022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4994),
  [9024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [9026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1873),
  [9028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [9030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(951),
  [9032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1230),
  [9034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6499),
  [9036] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_binary_expression, 3, 0, 54),
  [9038] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_binary_expression, 3, 0, 54),
  [9040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3069),
  [9042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7772),
  [9044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5512),
  [9046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7229),
  [9048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2983),
  [9050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1701),
  [9052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8120),
  [9054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5513),
  [9056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7241),
  [9058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3002),
  [9060] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_defined, 4, 0, 0),
  [9062] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_defined, 4, 0, 0),
  [9064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3985),
  [9066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7245),
  [9068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [9070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [9072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7269),
  [9074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1698),
  [9076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7665),
  [9078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5519),
  [9080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7189),
  [9082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3030),
  [9084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1863),
  [9086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8387),
  [9088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5520),
  [9090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7254),
  [9092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3025),
  [9094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2250),
  [9096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [9098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1976),
  [9100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5522),
  [9102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7056),
  [9104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4124),
  [9106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6875),
  [9108] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_argument_list, 2, 0, 0),
  [9110] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_argument_list, 2, 0, 0),
  [9112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2217),
  [9114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [9116] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_argument_list, 3, 0, 0),
  [9118] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_argument_list, 3, 0, 0),
  [9120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [9122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [9124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7586),
  [9126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1825),
  [9128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2932),
  [9130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5535),
  [9132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6981),
  [9134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2113),
  [9136] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_argument_list_repeat1, 2, 0, 0),
  [9138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3051),
  [9140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5538),
  [9142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6892),
  [9144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2333),
  [9146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5539),
  [9148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7078),
  [9150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_parenthesized_expression, 3, 0, 0),
  [9152] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_parenthesized_expression, 3, 0, 0),
  [9154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2007),
  [9156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5541),
  [9158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7147),
  [9160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2096),
  [9162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [9164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [9166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7468),
  [9168] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_call_expression, 2, 0, 26),
  [9170] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_call_expression, 2, 0, 26),
  [9172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_argument_list, 4, 0, 0),
  [9174] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_argument_list, 4, 0, 0),
  [9176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [9178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7520),
  [9180] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_defined, 2, 0, 0),
  [9182] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_defined, 2, 0, 0),
  [9184] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_unary_expression, 2, 0, 4),
  [9186] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_unary_expression, 2, 0, 4),
  [9188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1699),
  [9190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5552),
  [9192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7125),
  [9194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2967),
  [9196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5554),
  [9198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7144),
  [9200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3040),
  [9202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4618),
  [9204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3944),
  [9206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_noexcept, 3, 0, 0),
  [9208] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_noexcept, 3, 0, 0),
  [9210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6584),
  [9212] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 21),
  [9214] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declarator_seq, 5, 0, 21),
  [9216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2457),
  [9218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_attributes_end, 3, 0, 0),
  [9220] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_attributes_end, 3, 0, 0),
  [9222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 21),
  [9224] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declarator_seq, 6, 0, 21),
  [9226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5834),
  [9228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5298),
  [9230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5384),
  [9232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5383),
  [9234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5382),
  [9236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5381),
  [9238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5376),
  [9240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5374),
  [9242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5373),
  [9244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5368),
  [9246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5388),
  [9248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4185),
  [9250] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 21), SHIFT(5775),
  [9253] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 21), SHIFT(5335),
  [9256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [9258] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 21), SHIFT(5775),
  [9261] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 21), SHIFT(5335),
  [9264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4800),
  [9266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5821),
  [9268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7047),
  [9270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2276),
  [9272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [9274] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 21), SHIFT(5362),
  [9277] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_specifier, 5, 0, 0),
  [9279] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_specifier, 5, 0, 0),
  [9281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4658),
  [9283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6222),
  [9285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [9287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_specifier, 3, 0, 0),
  [9289] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_specifier, 3, 0, 0),
  [9291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6420),
  [9293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7209),
  [9295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5883),
  [9297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [9299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2569),
  [9301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5305),
  [9303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [9305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [9307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3356),
  [9309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [9311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2115),
  [9313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4293),
  [9315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5399),
  [9317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5397),
  [9319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3289),
  [9321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2621),
  [9323] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 21), SHIFT(5362),
  [9326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6210),
  [9328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6253),
  [9330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3029),
  [9332] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_postfix, 1, 0, 0),
  [9334] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_postfix, 1, 0, 0),
  [9336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__function_postfix_repeat1, 2, 0, 0),
  [9338] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__function_postfix_repeat1, 2, 0, 0),
  [9340] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__function_postfix_repeat1, 2, 0, 0), SHIFT_REPEAT(5775),
  [9343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5605),
  [9345] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_noexcept, 1, 0, 0),
  [9347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1244),
  [9349] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_noexcept, 1, 0, 0),
  [9351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5540),
  [9353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [9355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6726),
  [9357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5671),
  [9359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7100),
  [9361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_noexcept, 4, 0, 0),
  [9363] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_noexcept, 4, 0, 0),
  [9365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [9367] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_specifier, 4, 0, 0),
  [9369] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_specifier, 4, 0, 0),
  [9371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5306),
  [9373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2694),
  [9375] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(7415),
  [9378] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 21), SHIFT(5910),
  [9381] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 21), SHIFT(5326),
  [9384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1032),
  [9386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1226),
  [9388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__abstract_declarator, 1, 0, 0),
  [9390] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__abstract_declarator, 1, 0, 0),
  [9392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [9394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5410),
  [9396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [9398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 5, 0, 170),
  [9400] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 5, 0, 170),
  [9402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 4, 0, 24),
  [9404] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 4, 0, 24),
  [9406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1743),
  [9408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [9410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 4, 0, 117),
  [9412] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 4, 0, 117),
  [9414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 4, 0, 172),
  [9416] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 4, 0, 172),
  [9418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [9420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trailing_return_type, 2, 0, 0),
  [9422] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trailing_return_type, 2, 0, 0),
  [9424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [9426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_parenthesized_declarator, 4, 0, 0),
  [9428] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_parenthesized_declarator, 4, 0, 0),
  [9430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [9432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 3, 0, 24),
  [9434] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 3, 0, 24),
  [9436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 3, 0, 0),
  [9438] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 3, 0, 0),
  [9440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declarator_seq, 7, 0, 21),
  [9442] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declarator_seq, 7, 0, 21),
  [9444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [9446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1242),
  [9448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6151),
  [9450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_clobber_list, 1, 0, 0),
  [9452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 3, 0, 122),
  [9454] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 3, 0, 122),
  [9456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [9458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [9460] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(5770),
  [9463] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(6722),
  [9466] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(7560),
  [9469] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_function_declarator, 1, 0, 33),
  [9471] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_function_declarator, 1, 0, 33),
  [9473] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_virtual_specifier, 1, 0, 0),
  [9475] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_virtual_specifier, 1, 0, 0),
  [9477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5770),
  [9479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6722),
  [9481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7560),
  [9483] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 2, 0, 0),
  [9485] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 2, 0, 0),
  [9487] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_parenthesized_declarator, 3, 0, 0),
  [9489] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_parenthesized_declarator, 3, 0, 0),
  [9491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5776),
  [9493] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_function_declarator, 2, 0, 22),
  [9495] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_function_declarator, 2, 0, 22),
  [9497] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__function_postfix_repeat1, 2, 0, 0), SHIFT_REPEAT(5910),
  [9500] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 21), SHIFT(5377),
  [9503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5881),
  [9505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3083),
  [9507] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8022),
  [9510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6057),
  [9512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6568),
  [9514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_repeat1, 2, 0, 5),
  [9516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5319),
  [9518] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 21), SHIFT(5910),
  [9521] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 21), SHIFT(5326),
  [9524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5318),
  [9526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6398),
  [9528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list, 3, 0, 78),
  [9530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6591),
  [9532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5302),
  [9534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7632),
  [9536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(936),
  [9538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2424),
  [9540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6040),
  [9542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6551),
  [9544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6083),
  [9546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6552),
  [9548] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 21), SHIFT(5307),
  [9551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6527),
  [9553] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__class_declaration_repeat1, 2, 0, 0),
  [9555] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__class_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(7947),
  [9558] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__class_declaration_repeat1, 2, 0, 0),
  [9560] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__class_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(7956),
  [9563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 2, 0, 39),
  [9565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(954),
  [9567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 2, 1, 5),
  [9569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_reference_declarator, 2, 0, 0),
  [9571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 3, 0, 80),
  [9573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 3, 0, 62),
  [9575] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 3, 1, 41),
  [9577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 4, 0, 130),
  [9579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 4, 1, 84),
  [9581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6485),
  [9583] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(7550),
  [9586] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 2, 0, 5),
  [9588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1196),
  [9590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3293),
  [9592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6133),
  [9594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6556),
  [9596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list, 2, 0, 8),
  [9598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_field_declarator, 3, 1, 41),
  [9600] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 21), SHIFT(5307),
  [9603] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_declarator, 3, 1, 41),
  [9605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6154),
  [9607] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_declarator, 5, 1, 168),
  [9609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [9611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1886),
  [9613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [9615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7136),
  [9617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6078),
  [9619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6719),
  [9621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5333),
  [9623] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 21), SHIFT(5304),
  [9626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6145),
  [9628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6142),
  [9630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [9632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7118),
  [9634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6732),
  [9636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [9638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7182),
  [9640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6617),
  [9642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1870),
  [9644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6202),
  [9646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [9648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7079),
  [9650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6685),
  [9652] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_declarator, 4, 1, 84),
  [9654] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_declarator, 2, 1, 5),
  [9656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5332),
  [9658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6156),
  [9660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [9662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_field_declarator, 2, 1, 5),
  [9664] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_field_declarator, 2, 1, 0),
  [9666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6152),
  [9668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6206),
  [9670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6158),
  [9672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6153),
  [9674] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 21), SHIFT(5377),
  [9677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6168),
  [9679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5363),
  [9681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5366),
  [9683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6188),
  [9685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6200),
  [9687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6164),
  [9689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6204),
  [9691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_field_declarator, 5, 1, 168),
  [9693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [9695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6187),
  [9697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2163),
  [9699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [9701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7019),
  [9703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6655),
  [9705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6161),
  [9707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_field_declarator, 4, 1, 84),
  [9709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2176),
  [9711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [9713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7223),
  [9715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6600),
  [9717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [9719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6863),
  [9721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6609),
  [9723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6185),
  [9725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2251),
  [9727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [9729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2090),
  [9731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6183),
  [9733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6182),
  [9735] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributed_declarator, 2, 0, 0),
  [9737] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attributed_declarator, 2, 0, 0),
  [9739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [9741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_declarator, 2, 1, 0),
  [9743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_structured_binding_declarator, 4, -1, 0),
  [9745] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_structured_binding_declarator, 4, -1, 0),
  [9747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2418),
  [9749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7148),
  [9751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5310),
  [9753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7844),
  [9755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3017),
  [9757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8315),
  [9759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2828),
  [9761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6438),
  [9763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6131),
  [9765] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_declarator, 5, 0, 170),
  [9767] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_declarator, 5, 0, 170),
  [9769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_declarator, 4, -10, 0),
  [9771] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_declarator, 4, -10, 0),
  [9773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3039),
  [9775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3174),
  [9777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7667),
  [9779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7703),
  [9781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3240),
  [9783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1948),
  [9785] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 21), SHIFT(5311),
  [9788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7762),
  [9790] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_declarator, 4, 0, 117),
  [9792] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_declarator, 4, 0, 117),
  [9794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2836),
  [9796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1951),
  [9798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2337),
  [9800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2371),
  [9802] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_declarator, 4, 0, 24),
  [9804] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_declarator, 4, 0, 24),
  [9806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7700),
  [9808] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declarator, 2, 1, 22),
  [9810] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declarator, 2, 1, 22),
  [9812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2691),
  [9814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4971),
  [9816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2918),
  [9818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8034),
  [9820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4983),
  [9822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2652),
  [9824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_declarator, 3, 0, 24),
  [9826] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_declarator, 3, 0, 24),
  [9828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4028),
  [9830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_declarator, 3, -10, 0),
  [9832] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_declarator, 3, -10, 0),
  [9834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4895),
  [9836] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_structured_binding_declarator, 3, -1, 0),
  [9838] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_structured_binding_declarator, 3, -1, 0),
  [9840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4021),
  [9842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6558),
  [9844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6576),
  [9846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8372),
  [9848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3200),
  [9850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2954),
  [9852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4816),
  [9854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3315),
  [9856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5329),
  [9858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5330),
  [9860] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributed_field_declarator, 2, 0, 0),
  [9862] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attributed_field_declarator, 2, 0, 0),
  [9864] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 21), SHIFT(5304),
  [9867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_declarator, 1, 0, 99),
  [9869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [9871] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__field_declarator, 1, 0, 99),
  [9873] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_declarator, 1, 0, 0),
  [9875] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__field_declarator, 1, 0, 0),
  [9877] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list_no_comma, 3, 0, 78),
  [9879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6816),
  [9881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5338),
  [9883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8264),
  [9885] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_field_declarator, 4, 0, 117),
  [9887] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_field_declarator, 4, 0, 117),
  [9889] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_field_declarator, 2, 1, 22),
  [9891] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_field_declarator, 2, 1, 22),
  [9893] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_field_declarator, 3, -10, 0),
  [9895] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_field_declarator, 3, -10, 0),
  [9897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6424),
  [9899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6343),
  [9901] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_field_declarator, 3, 0, 24),
  [9903] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_field_declarator, 3, 0, 24),
  [9905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6511),
  [9907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6773),
  [9909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5339),
  [9911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8231),
  [9913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6415),
  [9915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6357),
  [9917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6530),
  [9919] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 21), SHIFT(5311),
  [9922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6401),
  [9924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6384),
  [9926] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_field_declarator, 5, 0, 170),
  [9928] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_field_declarator, 5, 0, 170),
  [9930] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list_no_comma, 2, 0, 8),
  [9932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6489),
  [9934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7719),
  [9936] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_field_declarator, 4, 0, 24),
  [9938] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_field_declarator, 4, 0, 24),
  [9940] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enumerator_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7148),
  [9943] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enumerator_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5303),
  [9946] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enumerator_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7650),
  [9949] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enumerator_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7594),
  [9952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enumerator_list_repeat1, 2, 0, 0),
  [9954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6408),
  [9956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6379),
  [9958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5378),
  [9960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5394),
  [9962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6496),
  [9964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list_no_comma, 3, 0, 8),
  [9966] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list_no_comma, 4, 0, 78),
  [9968] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list, 4, 0, 78),
  [9970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8238),
  [9972] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list, 3, 0, 8),
  [9974] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_field_declarator, 4, -10, 0),
  [9976] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_field_declarator, 4, -10, 0),
  [9978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6393),
  [9980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6363),
  [9982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6428),
  [9984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6332),
  [9986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6423),
  [9988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6350),
  [9990] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 2, 0, 66),
  [9992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1379),
  [9994] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__scope_resolution, 1, 0, 0),
  [9996] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__scope_resolution, 1, 0, 0),
  [9998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1498),
  [10000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4769),
  [10002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1440),
  [10004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4765),
  [10006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1352),
  [10008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4776),
  [10010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1585),
  [10012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4747),
  [10014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1636),
  [10016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4770),
  [10018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1423),
  [10020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1648),
  [10022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4750),
  [10024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2556),
  [10026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6358),
  [10028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1536),
  [10030] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand_list, 1, 0, 0),
  [10032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8057),
  [10034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1493),
  [10036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4736),
  [10038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5369),
  [10040] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_declarators, 1, 0, 24),
  [10042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1483),
  [10044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4775),
  [10046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1520),
  [10048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1565),
  [10050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1574),
  [10052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4745),
  [10054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1407),
  [10056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1461),
  [10058] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand_list, 1, 0, 0),
  [10060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7896),
  [10062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6675),
  [10064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6580),
  [10066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8110),
  [10068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6646),
  [10070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3653),
  [10072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7115),
  [10074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6606),
  [10076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3806),
  [10078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7522),
  [10080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6959),
  [10082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6733),
  [10084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8306),
  [10086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4756),
  [10088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7478),
  [10090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7036),
  [10092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8149),
  [10094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5316),
  [10096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5317),
  [10098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4396),
  [10100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7435),
  [10102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6625),
  [10104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3153),
  [10106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7279),
  [10108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2608),
  [10110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7561),
  [10112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2802),
  [10114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7375),
  [10116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6674),
  [10118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6856),
  [10120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4173),
  [10122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7459),
  [10124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6767),
  [10126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2538),
  [10128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7467),
  [10130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6897),
  [10132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8207),
  [10134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2024),
  [10136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7429),
  [10138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6783),
  [10140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7096),
  [10142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4735),
  [10144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7331),
  [10146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5749),
  [10148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7498),
  [10150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2689),
  [10152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7503),
  [10154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6779),
  [10156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4772),
  [10158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7128),
  [10160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8077),
  [10162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7009),
  [10164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3996),
  [10166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3664),
  [10168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7383),
  [10170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__type_definition_declarators_repeat1, 2, 0, 5),
  [10172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6785),
  [10174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3539),
  [10176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7593),
  [10178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7178),
  [10180] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_capture_specifier, 3, 0, 0),
  [10182] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_capture_specifier, 3, 0, 0),
  [10184] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_designator, 3, 0, 0),
  [10186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2008),
  [10188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7425),
  [10190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6614),
  [10192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [10194] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__scope_resolution, 2, 0, 31),
  [10196] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__scope_resolution, 2, 0, 31),
  [10198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6125),
  [10200] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7148),
  [10203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_repeat1, 2, 0, 0),
  [10205] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_repeat1, 2, 0, 0),
  [10207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6216),
  [10209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2059),
  [10211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3739),
  [10213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [10215] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator, 1, 0, 6),
  [10217] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator, 1, 0, 6),
  [10219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1359),
  [10221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [10223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1893),
  [10225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3772),
  [10227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6274),
  [10229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [10231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1215),
  [10233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2141),
  [10235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3766),
  [10237] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__scope_resolution, 2, 0, 13),
  [10239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__scope_resolution, 2, 0, 13),
  [10241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [10243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3793),
  [10245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [10247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [10249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3758),
  [10251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [10253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3693),
  [10255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [10257] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1, 2, 0, 0), SHIFT_REPEAT(6398),
  [10260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1, 2, 0, 0),
  [10262] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1, 2, 0, 0),
  [10264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [10266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3789),
  [10268] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_cast, 3, 0, 58),
  [10270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [10272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [10274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6051),
  [10276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2325),
  [10278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6105),
  [10280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7237),
  [10282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3226),
  [10284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3283),
  [10286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_capture_specifier, 6, 0, 0),
  [10288] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_capture_specifier, 6, 0, 0),
  [10290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7127),
  [10292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6873),
  [10294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_capture_specifier, 5, 0, 0),
  [10296] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_capture_specifier, 5, 0, 0),
  [10298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1, 1, 0, 0),
  [10300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6492),
  [10302] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1, 1, 0, 0),
  [10304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_capture_specifier, 4, 0, 0),
  [10306] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_capture_specifier, 4, 0, 0),
  [10308] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_initializer_pair_repeat1, 2, 0, 0), SHIFT_REPEAT(1611),
  [10311] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_initializer_pair_repeat1, 2, 0, 0),
  [10313] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_initializer_pair_repeat1, 2, 0, 0), SHIFT_REPEAT(7723),
  [10316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3516),
  [10318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1611),
  [10320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1198),
  [10322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7723),
  [10324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6073),
  [10326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3446),
  [10328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2366),
  [10330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7029),
  [10332] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list, 4, 0, 78),
  [10334] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_enumerator_list, 4, 0, 78),
  [10336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5870),
  [10338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6650),
  [10340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list, 5, 0, 78),
  [10342] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_enumerator_list, 5, 0, 78),
  [10344] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_enumerator_list_repeat1, 2, 0, 0),
  [10346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 4, 0, 79),
  [10348] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 4, 0, 79),
  [10350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2146),
  [10352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1640),
  [10354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [10356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1437),
  [10358] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 4, 0, 8),
  [10360] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 4, 0, 8),
  [10362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [10364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1358),
  [10366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5872),
  [10368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5888),
  [10370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5882),
  [10372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list, 6, 0, 175),
  [10374] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_enumerator_list, 6, 0, 175),
  [10376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [10378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1361),
  [10380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2231),
  [10382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1559),
  [10384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list, 5, 0, 127),
  [10386] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_enumerator_list, 5, 0, 127),
  [10388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [10390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1384),
  [10392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1923),
  [10394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1619),
  [10396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2106),
  [10398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1586),
  [10400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [10402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1643),
  [10404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5875),
  [10406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5884),
  [10408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [10410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1653),
  [10412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5879),
  [10414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_expression_repeat1, 2, 0, 0),
  [10416] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(6650),
  [10419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5846),
  [10421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5855),
  [10423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5858),
  [10425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5849),
  [10427] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 3, 0, 8),
  [10429] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 3, 0, 8),
  [10431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [10433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1455),
  [10435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5871),
  [10437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [10439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1646),
  [10441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 5, 0, 128),
  [10443] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 5, 0, 128),
  [10445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5853),
  [10447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5854),
  [10449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2122),
  [10451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1567),
  [10453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1881),
  [10455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1651),
  [10457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2224),
  [10459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2221),
  [10461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2238),
  [10463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2237),
  [10465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5740),
  [10467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 1, 0, 6),
  [10469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7903),
  [10471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7452),
  [10473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5999),
  [10475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1910),
  [10477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1908),
  [10479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1929),
  [10481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7443),
  [10483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7095),
  [10485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1429),
  [10487] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_type_parameter_declaration, 3, 0, 157),
  [10489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7362),
  [10491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2227),
  [10493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5928),
  [10495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1933),
  [10497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6553),
  [10499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2180),
  [10501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1934),
  [10503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7494),
  [10505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1380),
  [10507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2239),
  [10509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2212),
  [10511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7474),
  [10513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1919),
  [10515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_type_parameter_declaration, 4, 0, 191),
  [10517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2202),
  [10519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6874),
  [10521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7509),
  [10523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2214),
  [10525] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_access_specifier, 1, 0, 0),
  [10527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_access_specifier, 1, 0, 0),
  [10529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7387),
  [10531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2060),
  [10533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2211),
  [10535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2066),
  [10537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2063),
  [10539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2209),
  [10541] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_enumerator_list, 1, 0, 0),
  [10543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5781),
  [10545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1915),
  [10547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7330),
  [10549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1917),
  [10551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2247),
  [10553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [10555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7295),
  [10557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3726),
  [10559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [10561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__namespace_specifier, 1, 0, 17),
  [10563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6544),
  [10565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7388),
  [10567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7574),
  [10569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1769),
  [10571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1065),
  [10573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7410),
  [10575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1780),
  [10577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1803),
  [10579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6852),
  [10581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6852),
  [10583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1858),
  [10585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3478),
  [10587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6728),
  [10589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6728),
  [10591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5553),
  [10593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6632),
  [10595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1875),
  [10597] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_clobber_list_repeat1, 2, 0, 212), SHIFT_REPEAT(5833),
  [10600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_clobber_list_repeat1, 2, 0, 212),
  [10602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3754),
  [10604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [10606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1711),
  [10608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6396),
  [10610] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand_list, 3, 0, 188),
  [10612] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_char_literal_repeat1, 2, 0, 0),
  [10614] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_char_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(6632),
  [10617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2412),
  [10619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [10621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2108),
  [10623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7183),
  [10625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8039),
  [10627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [10629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7617),
  [10631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4091),
  [10633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4092),
  [10635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2404),
  [10637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6633),
  [10639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6633),
  [10641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3794),
  [10643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3774),
  [10645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6640),
  [10647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6640),
  [10649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3731),
  [10651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2445),
  [10653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(994),
  [10655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [10657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3787),
  [10659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3394),
  [10661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6615),
  [10663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6615),
  [10665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2466),
  [10667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6644),
  [10669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6644),
  [10671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_qualifier, 1, 0, 0),
  [10673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4686),
  [10675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3846),
  [10677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3808),
  [10679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6652),
  [10681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6652),
  [10683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5833),
  [10685] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_clobber_list, 3, 0, 208),
  [10687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4164),
  [10689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2666),
  [10691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2456),
  [10693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [10695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1706),
  [10697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2481),
  [10699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3403),
  [10701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4074),
  [10703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2436),
  [10705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6658),
  [10707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6658),
  [10709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [10711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8010),
  [10713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [10715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2824),
  [10717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2604),
  [10719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [10721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6585),
  [10723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6891),
  [10725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5573),
  [10727] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_class_clause, 4, 0, 0),
  [10729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2603),
  [10731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6672),
  [10733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6672),
  [10735] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_input_operand_list_repeat1, 2, 0, 200), SHIFT_REPEAT(6427),
  [10738] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_input_operand_list_repeat1, 2, 0, 200),
  [10740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4059),
  [10742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [10744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2298),
  [10746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3327),
  [10748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3862),
  [10750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [10752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3770),
  [10754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3888),
  [10756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6684),
  [10758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6684),
  [10760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2310),
  [10762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6788),
  [10764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6788),
  [10766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1802),
  [10768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2564),
  [10770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2845),
  [10772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6948),
  [10774] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_class_clause, 2, 0, 0),
  [10776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7316),
  [10778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7277),
  [10780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2076),
  [10782] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 2, 0, 180), SHIFT_REPEAT(5729),
  [10785] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 2, 0, 180),
  [10787] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_definition_declarators_repeat1, 2, 0, 115), SHIFT_REPEAT(5369),
  [10790] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__type_definition_declarators_repeat1, 2, 0, 115),
  [10792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2529),
  [10794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6693),
  [10796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6693),
  [10798] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_enumerator_list_no_comma, 2, 0, 0),
  [10800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7536),
  [10802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7333),
  [10804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3680),
  [10806] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_declarators, 2, 0, 87),
  [10808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2407),
  [10810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6738),
  [10812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6738),
  [10814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1897),
  [10816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7815),
  [10818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5970),
  [10820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2055),
  [10822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8138),
  [10824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3197),
  [10826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 3, 0, 91),
  [10828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [10830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5972),
  [10832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6715),
  [10834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6715),
  [10836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3769),
  [10838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [10840] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0),
  [10842] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(6728),
  [10845] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(6728),
  [10848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7882),
  [10850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6789),
  [10852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6789),
  [10854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7411),
  [10856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7416),
  [10858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3732),
  [10860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2416),
  [10862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6300),
  [10864] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_enumerator_list, 2, 0, 0),
  [10866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2125),
  [10868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7196),
  [10870] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_declarator, 1, 0, 0),
  [10872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1068),
  [10874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2054),
  [10876] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand_list, 2, 0, 153),
  [10878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2704),
  [10880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4148),
  [10882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2799),
  [10884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7427),
  [10886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7282),
  [10888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [10890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2678),
  [10892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6750),
  [10894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6750),
  [10896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2784),
  [10898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6787),
  [10900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6787),
  [10902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [10904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3778),
  [10906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2171),
  [10908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2144),
  [10910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2142),
  [10912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6582),
  [10914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2023),
  [10916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2888),
  [10918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2165),
  [10920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1727),
  [10922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2161),
  [10924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2793),
  [10926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2260),
  [10928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7721),
  [10930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2223),
  [10932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1049),
  [10934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5607),
  [10936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1685),
  [10938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3903),
  [10940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4434),
  [10942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4595),
  [10944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3694),
  [10946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [10948] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_operator_cast_identifier, 2, 0, 34),
  [10950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3530),
  [10952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6664),
  [10954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6664),
  [10956] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_clobber_list, 2, 0, 201),
  [10958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2460),
  [10960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6663),
  [10962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6663),
  [10964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [10966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [10968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3939),
  [10970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6795),
  [10972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6795),
  [10974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3786),
  [10976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6427),
  [10978] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand_list, 3, 0, 188),
  [10980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [10982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7369),
  [10984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7506),
  [10986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3765),
  [10988] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_enumerator_list_no_comma, 1, 0, 0),
  [10990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [10992] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_output_operand_list_repeat1, 2, 0, 200), SHIFT_REPEAT(6396),
  [10995] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_output_operand_list_repeat1, 2, 0, 200),
  [10997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1819),
  [10999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1831),
  [11001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2195),
  [11003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1877),
  [11005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1020),
  [11007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7050),
  [11009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_class_clause, 3, 0, 0),
  [11011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [11013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2641),
  [11015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3712),
  [11017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6958),
  [11019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2718),
  [11021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [11023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [11025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7770),
  [11027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1864),
  [11029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3788),
  [11031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6879),
  [11033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_class_clause, 5, 0, 0),
  [11035] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand_list, 2, 0, 153),
  [11037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3705),
  [11039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [11041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1794),
  [11043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3511),
  [11045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6594),
  [11047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [11049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7890),
  [11051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7259),
  [11053] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_base_class_clause_repeat1, 5, 0, 0),
  [11055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2559),
  [11057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5758),
  [11059] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1119),
  [11062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7728),
  [11064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7730),
  [11066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7736),
  [11068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2562),
  [11070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6315),
  [11072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [11074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6683),
  [11076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [11078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7556),
  [11080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1775),
  [11082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8065),
  [11084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7274),
  [11086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5804),
  [11088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3521),
  [11090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6514),
  [11092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2745),
  [11094] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_namespace_specifier, 2, 0, 0),
  [11096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6581),
  [11098] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_class_clause, 6, 0, 0),
  [11100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7380),
  [11102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7264),
  [11104] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_range_designator, 5, 0, 199),
  [11106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__namespace_specifier, 2, 0, 59),
  [11108] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_designator, 2, 0, 105),
  [11110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3878),
  [11112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6330),
  [11114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2236),
  [11116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1078),
  [11118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2524),
  [11120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3265),
  [11122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [11124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3643),
  [11126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7495),
  [11128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2800),
  [11130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [11132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [11134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5283),
  [11136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3476),
  [11138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [11140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6453),
  [11142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1037),
  [11144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3727),
  [11146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5596),
  [11148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1750),
  [11150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2402),
  [11152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3629),
  [11154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [11156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [11158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3626),
  [11160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7436),
  [11162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2722),
  [11164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1928),
  [11166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3621),
  [11168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3605),
  [11170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3822),
  [11172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2220),
  [11174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2219),
  [11176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2210),
  [11178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1768),
  [11180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4674),
  [11182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7433),
  [11184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7335),
  [11186] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_base_class_clause_repeat1, 4, 0, 0),
  [11188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1839),
  [11190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7493),
  [11192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7458),
  [11194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [11196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1082),
  [11198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2709),
  [11200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2748),
  [11202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2740),
  [11204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5803),
  [11206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3497),
  [11208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3499),
  [11210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2182),
  [11212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6656),
  [11214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7496),
  [11216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_base_class_clause_repeat1, 3, 0, 0),
  [11218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1702),
  [11220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1703),
  [11222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_output_operand_list_repeat1, 2, 0, 153),
  [11224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1705),
  [11226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2022),
  [11228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7353),
  [11230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1713),
  [11232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6467),
  [11234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2019),
  [11236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2042),
  [11238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3659),
  [11240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3671),
  [11242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2451),
  [11244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2573),
  [11246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2577),
  [11248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [11250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [11252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [11254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2646),
  [11256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [11258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [11260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2581),
  [11262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2472),
  [11264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3513),
  [11266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1087),
  [11268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2583),
  [11270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3832),
  [11272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3831),
  [11274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2770),
  [11276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2767),
  [11278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5609),
  [11280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7451),
  [11282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3452),
  [11284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2764),
  [11286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6782),
  [11288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [11290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5547),
  [11292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1862),
  [11294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8157),
  [11296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3134),
  [11298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1867),
  [11300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [11302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3644),
  [11304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2519),
  [11306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3915),
  [11308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1871),
  [11310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3814),
  [11312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3906),
  [11314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3813),
  [11316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3811),
  [11318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3687),
  [11320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7351),
  [11322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7592),
  [11324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1728),
  [11326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3299),
  [11328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3927),
  [11330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3920),
  [11332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [11334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [11336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3809),
  [11338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [11340] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_params_repeat1, 2, 0, 0), SHIFT_REPEAT(7493),
  [11343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_params_repeat1, 2, 0, 0),
  [11345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2020),
  [11347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1719),
  [11349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3649),
  [11351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [11353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3805),
  [11355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1723),
  [11357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1725),
  [11359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1724),
  [11361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3820),
  [11363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6440),
  [11365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [11367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7965),
  [11369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7964),
  [11371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7962),
  [11373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3238),
  [11375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1704),
  [11377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1718),
  [11379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2576),
  [11381] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_throw_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(3727),
  [11384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_throw_specifier_repeat1, 2, 0, 0),
  [11386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3540),
  [11388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7595),
  [11390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7396),
  [11392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer, 2, 0, 0),
  [11394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1717),
  [11396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1880),
  [11398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1883),
  [11400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7301),
  [11402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_type_parameter_declaration, 2, 0, 0),
  [11404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3261),
  [11406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [11408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1884),
  [11410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3398),
  [11412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6048),
  [11414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer_list, 3, 0, 0),
  [11416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7519),
  [11418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_base_class_clause_repeat1, 2, 0, 0),
  [11420] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_base_class_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(5573),
  [11423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2543),
  [11425] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_lambda_capture_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(1594),
  [11428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5869),
  [11430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3529),
  [11432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2542),
  [11434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1812),
  [11436] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_structured_binding_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(7880),
  [11439] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_structured_binding_declarator_repeat1, 2, 0, 0),
  [11441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7306),
  [11443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3528),
  [11445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1079),
  [11447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3232),
  [11449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3913),
  [11451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3542),
  [11453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6616),
  [11455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3073),
  [11457] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer_list, 2, 0, 0),
  [11459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4711),
  [11461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2459),
  [11463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4710),
  [11465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7283),
  [11467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6323),
  [11469] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subscript_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1233),
  [11472] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attribute_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(7274),
  [11475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attribute_declaration_repeat1, 2, 0, 0),
  [11477] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_init_declarator, 2, 0, 68),
  [11479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_condition_declaration, 3, 0, 141),
  [11481] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter_declaration, 2, 0, 66),
  [11483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3606),
  [11485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2452),
  [11487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7642),
  [11489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7644),
  [11491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7645),
  [11493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6316),
  [11495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6312),
  [11497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6308),
  [11499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4705),
  [11501] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_field_initializer_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6048),
  [11504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_initializer_list_repeat1, 2, 0, 0),
  [11506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4704),
  [11508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2432),
  [11510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3342),
  [11512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4700),
  [11514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3501),
  [11516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7329),
  [11518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [11520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4721),
  [11522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3488),
  [11524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2241),
  [11526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4122),
  [11528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6988),
  [11530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6546),
  [11532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4657),
  [11534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7513),
  [11536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6798),
  [11538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_namespace_specifier, 3, 0, 0),
  [11540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3682),
  [11542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3683),
  [11544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3684),
  [11546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3685),
  [11548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2446),
  [11550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [11552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5684),
  [11554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3459),
  [11556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7756),
  [11558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7757),
  [11560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7803),
  [11562] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_repeat1, 2, 0, 115), SHIFT_REPEAT(4994),
  [11565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_repeat1, 2, 0, 115),
  [11567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [11569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 3, 0, 194),
  [11571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [11573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3198),
  [11575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [11577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1801),
  [11579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1800),
  [11581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1798),
  [11583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1795),
  [11585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3943),
  [11587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2330),
  [11589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7502),
  [11591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7876),
  [11593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8044),
  [11595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7889),
  [11597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1783),
  [11599] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_class_clause, 7, 0, 0),
  [11601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3929),
  [11603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8036),
  [11605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3077),
  [11607] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameter_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1768),
  [11610] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameter_list_repeat1, 2, 0, 0),
  [11612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3146),
  [11614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand, 7, 0, 216),
  [11616] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 3, 0, 5),
  [11618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3545),
  [11620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1552),
  [11622] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand, 4, 0, 207),
  [11624] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5309),
  [11627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2294),
  [11629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2288),
  [11631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2287),
  [11633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2286),
  [11635] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand, 7, 0, 216),
  [11637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1687),
  [11639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7361),
  [11641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer, 2, 0, 99),
  [11643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6399),
  [11645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7589),
  [11647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_input_operand_list_repeat1, 2, 0, 153),
  [11649] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requires_parameter_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1775),
  [11652] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_requires_parameter_list_repeat1, 2, 0, 0),
  [11654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1688),
  [11656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1689),
  [11658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7585),
  [11660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7583),
  [11662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2345),
  [11664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6574),
  [11666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4691),
  [11668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3130),
  [11670] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_parameter_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1750),
  [11673] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_parameter_list_repeat1, 2, 0, 0),
  [11675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2826),
  [11677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2827),
  [11679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2829),
  [11681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2830),
  [11683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4690),
  [11685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7540),
  [11687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7533),
  [11689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2087),
  [11691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7668),
  [11693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7652),
  [11695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7666),
  [11697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7103),
  [11699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7358),
  [11701] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_goto_list_repeat1, 2, 0, 215), SHIFT_REPEAT(7873),
  [11704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_goto_list_repeat1, 2, 0, 215),
  [11706] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_reference_declarator, 2, 0, 0),
  [11708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4693),
  [11710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1034),
  [11712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3313),
  [11714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2085),
  [11716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2101),
  [11718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2622),
  [11720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2650),
  [11722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2647),
  [11724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2644),
  [11726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_declarator, 2, 0, 0),
  [11728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6461),
  [11730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2081),
  [11732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3928),
  [11734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7873),
  [11736] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_goto_list, 3, 0, 213),
  [11738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1048),
  [11740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1084),
  [11742] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_initializer_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1088),
  [11745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6737),
  [11747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1781),
  [11749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1786),
  [11751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4668),
  [11753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6475),
  [11755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1686),
  [11757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1787),
  [11759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4685),
  [11761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4684),
  [11763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4683),
  [11765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4682),
  [11767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6039),
  [11769] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(333),
  [11772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_argument_list_repeat1, 2, 0, 0),
  [11774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7514),
  [11776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7512),
  [11778] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_goto_list, 2, 0, 209),
  [11780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [11782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8268),
  [11784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8271),
  [11786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8276),
  [11788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1080),
  [11790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1046),
  [11792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1047),
  [11794] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_clobber_list_repeat1, 2, 0, 201),
  [11796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3471),
  [11798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3538),
  [11800] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_argument_list_repeat1, 2, 3, 0),
  [11802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3725),
  [11804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3722),
  [11806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3716),
  [11808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3710),
  [11810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand, 4, 0, 207),
  [11812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [11814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3465),
  [11816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6128),
  [11818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6497),
  [11820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [11822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6694),
  [11824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6717),
  [11826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6751),
  [11828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3923),
  [11830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7296),
  [11832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6796),
  [11834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6793),
  [11836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3070),
  [11838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6854),
  [11840] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_generic_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(3696),
  [11843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_generic_expression_repeat1, 2, 0, 0),
  [11845] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_base_class_clause_repeat1, 6, 0, 0),
  [11847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6543),
  [11849] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 2, 0, 6),
  [11851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [11853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7437),
  [11855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [11857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7636),
  [11859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6490),
  [11861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3193),
  [11863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_argument_list_repeat1, 2, 2, 0),
  [11865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2382),
  [11867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_type_parameter_declaration, 3, 0, 156),
  [11869] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_template_parameter_declaration, 3, 0, 57),
  [11871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [11873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7818),
  [11875] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_goto_list_repeat1, 2, 0, 209),
  [11877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [11879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1212),
  [11881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2160),
  [11883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7915),
  [11885] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_repeat1, 3, 0, 166),
  [11887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [11889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7294),
  [11891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5550),
  [11893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7842),
  [11895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2166),
  [11897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8095),
  [11899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2957),
  [11901] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_params, 2, 0, 0),
  [11903] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_params, 2, 0, 0),
  [11905] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer, 3, 0, 99),
  [11907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [11909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1809),
  [11911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7958),
  [11913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7475),
  [11915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7315),
  [11917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [11919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer, 3, 0, 0),
  [11921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4008),
  [11923] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_pack_expansion, 2, 0, 28),
  [11925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [11927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7982),
  [11929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2253),
  [11931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8299),
  [11933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [11935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7363),
  [11937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7526),
  [11939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7327),
  [11941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [11943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7694),
  [11945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2651),
  [11947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [11949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8389),
  [11951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1810),
  [11953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7740),
  [11955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [11957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [11959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8061),
  [11961] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_params, 4, 0, 0),
  [11963] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_params, 4, 0, 0),
  [11965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7492),
  [11967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4967),
  [11969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2189),
  [11971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8140),
  [11973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1595),
  [11975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7418),
  [11977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [11979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7552),
  [11981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7979),
  [11983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8406),
  [11985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7456),
  [11987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7221),
  [11989] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_goto_list, 1, 0, 0),
  [11991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7367),
  [11993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5656),
  [11995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7924),
  [11997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7276),
  [11999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2852),
  [12001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4855),
  [12003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [12005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_params, 3, 0, 0),
  [12007] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_params, 3, 0, 0),
  [12009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8085),
  [12011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8087),
  [12013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8144),
  [12015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8409),
  [12017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7317),
  [12019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8167),
  [12021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8412),
  [12023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [12025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3042),
  [12027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8186),
  [12029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8415),
  [12031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [12033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7664),
  [12035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8204),
  [12037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8418),
  [12039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8220),
  [12041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8420),
  [12043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8229),
  [12045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8421),
  [12047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1979),
  [12049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8237),
  [12051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8422),
  [12053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7424),
  [12055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8242),
  [12057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8423),
  [12059] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 4, 0, 91),
  [12061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8244),
  [12063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8424),
  [12065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8246),
  [12067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8425),
  [12069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8248),
  [12071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8426),
  [12073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8250),
  [12075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8427),
  [12077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8252),
  [12079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8428),
  [12081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8254),
  [12083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8429),
  [12085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8256),
  [12087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8430),
  [12089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7257),
  [12091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [12093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8296),
  [12095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2902),
  [12097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1842),
  [12099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3879),
  [12101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [12103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [12105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6839),
  [12107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [12109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_parameter_list, 2, 0, 0),
  [12111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8055),
  [12113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8069),
  [12115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8071),
  [12117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [12119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3255),
  [12121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3024),
  [12123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [12125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [12127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4030),
  [12129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7753),
  [12131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [12133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [12135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2525),
  [12137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [12139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [12141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [12143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8121),
  [12145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [12147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5901),
  [12149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8193),
  [12151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [12153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5515),
  [12155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [12157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef, 3, 0, 79),
  [12159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6491),
  [12161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [12163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1030),
  [12165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [12167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8230),
  [12169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [12171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [12173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2977),
  [12175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8309),
  [12177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8019),
  [12179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6231),
  [12181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [12183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [12185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8314),
  [12187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [12189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2628),
  [12191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7714),
  [12193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3493),
  [12195] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif, 5, 0, 175),
  [12197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [12199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3366),
  [12201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [12203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2071),
  [12205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [12207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [12209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1885),
  [12211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2254),
  [12213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [12215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [12217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2444),
  [12219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1016),
  [12221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3855),
  [12223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3854),
  [12225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6635),
  [12227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [12229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3853),
  [12231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3655),
  [12233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1208),
  [12235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3833),
  [12237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [12239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3417),
  [12241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1697),
  [12243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8083),
  [12245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [12247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2401),
  [12249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [12251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3815),
  [12253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3267),
  [12255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1695),
  [12257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1932),
  [12259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [12261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2420),
  [12263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8294),
  [12265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [12267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3800),
  [12269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1936),
  [12271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3797),
  [12273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3912),
  [12275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2249),
  [12277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [12279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list_no_comma, 5, 0, 127),
  [12281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1041),
  [12283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8316),
  [12285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1042),
  [12287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1975),
  [12289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list, 3, 0, 79),
  [12291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [12293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7954),
  [12295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4728),
  [12297] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list_no_comma, 5, 0, 78),
  [12299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2097),
  [12301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3543),
  [12303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6886),
  [12305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [12307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [12309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [12311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7856),
  [12313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [12315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8322),
  [12317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [12319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [12321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7833),
  [12323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [12325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [12327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1924),
  [12329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [12331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1921),
  [12333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1895),
  [12335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3395),
  [12337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1918),
  [12339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [12341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1916),
  [12343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7782),
  [12345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1231),
  [12347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3646),
  [12349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7780),
  [12351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7646),
  [12353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1914),
  [12355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3648),
  [12357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [12359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [12361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3650),
  [12363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6636),
  [12365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [12367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [12369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7839),
  [12371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [12373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7640),
  [12375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6502),
  [12377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4712),
  [12379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6846),
  [12381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [12383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3269),
  [12385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3625),
  [12387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1912),
  [12389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4707),
  [12391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list_no_comma, 3, 0, 79),
  [12393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1911),
  [12395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7722),
  [12397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7658),
  [12399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2798),
  [12401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4018),
  [12403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4696),
  [12405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4224),
  [12407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1909),
  [12409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7648),
  [12411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1907),
  [12413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1826),
  [12415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1906),
  [12417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2072),
  [12419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3502),
  [12421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7686),
  [12423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1905),
  [12425] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list_no_comma, 5, 0, 128),
  [12427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1904),
  [12429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7693),
  [12431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3484),
  [12433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2173),
  [12435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [12437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7696),
  [12439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [12441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4035),
  [12443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7701),
  [12445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6714),
  [12447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1878),
  [12449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2341),
  [12451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7674),
  [12453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [12455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5689),
  [12457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [12459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3309),
  [12461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7661),
  [12463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [12465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [12467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [12469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [12471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2821),
  [12473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [12475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2815),
  [12477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3674),
  [12479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2756),
  [12481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7900),
  [12483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2082),
  [12485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2083),
  [12487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [12489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2443),
  [12491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7981),
  [12493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7899),
  [12495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7635),
  [12497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3518),
  [12499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5856),
  [12501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2194),
  [12503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8007),
  [12505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [12507] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_field_declaration_list, 3, 0, 79),
  [12509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2902),
  [12511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8021),
  [12513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4689),
  [12515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7660),
  [12517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7155),
  [12519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8038),
  [12521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6716),
  [12523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [12525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3907),
  [12527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [12529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7309),
  [12531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1844),
  [12533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8279),
  [12535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [12537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7417),
  [12539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7828),
  [12541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3089),
  [12543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8359),
  [12545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1840),
  [12547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [12549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1553),
  [12551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3273),
  [12553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8201),
  [12555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8407),
  [12557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1373),
  [12559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7859),
  [12561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7843),
  [12563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4003),
  [12565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6720),
  [12567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8363),
  [12569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1374),
  [12571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [12573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8350),
  [12575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1950),
  [12577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8082),
  [12579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8329),
  [12581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7992),
  [12583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [12585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2126),
  [12587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8202),
  [12589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_field_declaration_list, 5, 0, 175),
  [12591] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list_no_comma, 5, 0, 175),
  [12593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8169),
  [12595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8160),
  [12597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2507),
  [12599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7819),
  [12601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8111),
  [12603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8103),
  [12605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8102),
  [12607] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list, 5, 0, 175),
  [12609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8081),
  [12611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8080),
  [12613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8067),
  [12615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8066),
  [12617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7957),
  [12619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8046),
  [12621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8024),
  [12623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8023),
  [12625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8011),
  [12627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8009),
  [12629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7996),
  [12631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7988),
  [12633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7969),
  [12635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7968),
  [12637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1193),
  [12639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [12641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6858),
  [12643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7286),
  [12645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7881),
  [12647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [12649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3699),
  [12651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7991),
  [12653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1256),
  [12655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1400),
  [12657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2461),
  [12659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1830),
  [12661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1234),
  [12663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2139),
  [12665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8033),
  [12667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2159),
  [12669] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8032),
  [12672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2411),
  [12674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2409),
  [12676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [12678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7347),
  [12680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7822),
  [12682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [12684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1356),
  [12686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7817),
  [12688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [12690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3566),
  [12692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [12694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4020),
  [12696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [12698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3940),
  [12700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3701),
  [12702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [12704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2326),
  [12706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [12708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6837),
  [12710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [12712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7778),
  [12714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3704),
  [12716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4664),
  [12718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [12720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4096),
  [12722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1823),
  [12724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1804),
  [12726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2468),
  [12728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [12730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2470),
  [12732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7763),
  [12734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1405),
  [12736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2883),
  [12738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3572),
  [12740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3818),
  [12742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3824),
  [12744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4040),
  [12746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [12748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [12750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2196),
  [12752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7688),
  [12754] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unary_right_fold, 3, 0, 54),
  [12756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1814),
  [12758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [12760] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_parameter_list, 4, 0, 0),
  [12762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3320),
  [12764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1792),
  [12766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2158),
  [12768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4026),
  [12770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7587),
  [12772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1657),
  [12774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2465),
  [12776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3477),
  [12778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3475),
  [12780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3474),
  [12782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3472),
  [12784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2232),
  [12786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [12788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7590),
  [12790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [12792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8323),
  [12794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4006),
  [12796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [12798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2664),
  [12800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2240),
  [12802] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_parameter_list, 3, 0, 0),
  [12804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2598),
  [12806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2609),
  [12808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3397),
  [12810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7779),
  [12812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8031),
  [12814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [12816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [12818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2168),
  [12820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4890),
  [12822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2169),
  [12824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3828),
  [12826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3829),
  [12828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8328),
  [12830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [12832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7609),
  [12834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [12836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7610),
  [12838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2148),
  [12840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [12842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [12844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1431),
  [12846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2193),
  [12848] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_field_declaration_list, 4, 0, 128),
  [12850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2061),
  [12852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [12854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1239),
  [12856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1754),
  [12858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1744),
  [12860] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_field_declaration_list, 4, 0, 127),
  [12862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1748),
  [12864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2495),
  [12866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2501),
  [12868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [12870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [12872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6885),
  [12874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8112),
  [12876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4039),
  [12878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [12880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [12882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4997),
  [12884] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list_no_comma, 4, 0, 128),
  [12886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2493),
  [12888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2482),
  [12890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4306),
  [12892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4304),
  [12894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4300),
  [12896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1194),
  [12898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7712),
  [12900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7554),
  [12902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [12904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3761),
  [12906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2175),
  [12908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1258),
  [12910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [12912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [12914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7428),
  [12916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7580),
  [12918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2255),
  [12920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7628),
  [12922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2107),
  [12924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2947),
  [12926] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list, 4, 0, 128),
  [12928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1441),
  [12930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7633),
  [12932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1228),
  [12934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [12936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7647),
  [12938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [12940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2174),
  [12942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7655),
  [12944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1462),
  [12946] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list_no_comma, 4, 0, 127),
  [12948] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list, 4, 0, 127),
  [12950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7454),
  [12952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3785),
  [12954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1267),
  [12956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6026),
  [12958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7439),
  [12960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2133),
  [12962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7727),
  [12964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif, 4, 0, 127),
  [12966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [12968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1625),
  [12970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7734),
  [12972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7746),
  [12974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6033),
  [12976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2184),
  [12978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7752),
  [12980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1642),
  [12982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [12984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7404),
  [12986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3743),
  [12988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [12990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1260),
  [12992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2208),
  [12994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1210),
  [12996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7384),
  [12998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7792),
  [13000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [13002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [13004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1679),
  [13006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7798),
  [13008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7807),
  [13010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [13012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [13014] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef, 4, 0, 128),
  [13016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7812),
  [13018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1637),
  [13020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2273),
  [13022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7345),
  [13024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3776),
  [13026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [13028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1288),
  [13030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7840),
  [13032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6488),
  [13034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8208),
  [13036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1612),
  [13038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7846),
  [13040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7855),
  [13042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5017),
  [13044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7860),
  [13046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1591),
  [13048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7298),
  [13050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1289),
  [13052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [13054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [13056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5826),
  [13058] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_based_modifier, 2, 0, 0),
  [13060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1570),
  [13062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7886),
  [13064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6507),
  [13066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7710),
  [13068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7897),
  [13070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7885),
  [13072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7267),
  [13074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1292),
  [13076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2201),
  [13078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7908),
  [13080] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list_no_comma, 4, 0, 79),
  [13082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6264),
  [13084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7911),
  [13086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6533),
  [13088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7258),
  [13090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1293),
  [13092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7919),
  [13094] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list_no_comma, 4, 0, 8),
  [13096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7921),
  [13098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7262),
  [13100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1294),
  [13102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7926),
  [13104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7927),
  [13106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7929),
  [13108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7930),
  [13110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7932),
  [13112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7933),
  [13114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7934),
  [13116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7935),
  [13118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7936),
  [13120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7937),
  [13122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7938),
  [13124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7939),
  [13126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7940),
  [13128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7941),
  [13130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7942),
  [13132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7943),
  [13134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3165),
  [13136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3914),
  [13138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [13140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1610),
  [13142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7978),
  [13144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [13146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6239),
  [13148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7795),
  [13150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [13152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2119),
  [13154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2103),
  [13156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [13158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2170),
  [13160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7244),
  [13162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2178),
  [13164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2109),
  [13166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6809),
  [13168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8012),
  [13170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8076),
  [13172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6134),
  [13174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2245),
  [13176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2062),
  [13178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1365),
  [13180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2467),
  [13182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2064),
  [13184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3505),
  [13186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3504),
  [13188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3482),
  [13190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4199),
  [13192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2593),
  [13194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7868),
  [13196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [13198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2204),
  [13200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2205),
  [13202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2095),
  [13204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2580),
  [13206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1214),
  [13208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5818),
  [13210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2069),
  [13212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2207),
  [13214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5825),
  [13216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2506),
  [13218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2558),
  [13220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2213),
  [13222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2215),
  [13224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1240),
  [13226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2216),
  [13228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2279),
  [13230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [13232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3926),
  [13234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3256),
  [13236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2218),
  [13238] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [13240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2091),
  [13242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list_no_comma, 6, 0, 175),
  [13244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6504),
  [13246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8091),
  [13248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1621),
  [13250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2222),
  [13252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2225),
  [13254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7149),
  [13256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2661),
  [13258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1818),
  [13260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1598),
  [13262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1331),
  [13264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2228),
  [13266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [13268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2230),
  [13270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1593),
  [13272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3760),
  [13274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3757),
  [13276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [13278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1590),
  [13280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8143),
  [13282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2074),
  [13284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8133),
  [13286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [13288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6622),
  [13290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8151),
  [13292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [13294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [13296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2706),
  [13298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [13300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1581),
  [13302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8166),
  [13304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1824),
  [13306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [13308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6742),
  [13310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8172),
  [13312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3908),
  [13314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1571),
  [13316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8185),
  [13318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8364),
  [13320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3180),
  [13322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6770),
  [13324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8191),
  [13326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [13328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [13330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1569),
  [13332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8203),
  [13334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [13336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2086),
  [13338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6772),
  [13340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8209),
  [13342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8225),
  [13344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1566),
  [13346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8219),
  [13348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3633),
  [13350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6630),
  [13352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8224),
  [13354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3460),
  [13356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3647),
  [13358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6844),
  [13360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8232),
  [13362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7476),
  [13364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3296),
  [13366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8239),
  [13368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [13370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8243),
  [13372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8245),
  [13374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8247),
  [13376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8249),
  [13378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3552),
  [13380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8251),
  [13382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2508),
  [13384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8253),
  [13386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [13388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8255),
  [13390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8257),
  [13392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3740),
  [13394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8278),
  [13396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3910),
  [13398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3724),
  [13400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8347),
  [13402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3749),
  [13404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8357),
  [13406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3711),
  [13408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8366),
  [13410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1223),
  [13412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3756),
  [13414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8374),
  [13416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5561),
  [13418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8381),
  [13420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8385),
  [13422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8388),
  [13424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8390),
  [13426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8392),
  [13428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8394),
  [13430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8396),
  [13432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8398),
  [13434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8400),
  [13436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8402),
  [13438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8404),
  [13440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5562),
  [13442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5565),
  [13444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [13446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1222),
  [13448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6667),
  [13450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1654),
  [13452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1402),
  [13454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1355),
  [13456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1435),
  [13458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1496),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token_raw_string_delimiter = 0,
  ts_external_token_raw_string_content = 1,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token_raw_string_delimiter] = sym_raw_string_delimiter,
  [ts_external_token_raw_string_content] = sym_raw_string_content,
};

static const bool ts_external_scanner_states[4][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token_raw_string_delimiter] = true,
    [ts_external_token_raw_string_content] = true,
  },
  [2] = {
    [ts_external_token_raw_string_delimiter] = true,
  },
  [3] = {
    [ts_external_token_raw_string_content] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_arduino_external_scanner_create(void);
void tree_sitter_arduino_external_scanner_destroy(void *);
bool tree_sitter_arduino_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_arduino_external_scanner_serialize(void *, char *);
void tree_sitter_arduino_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_arduino(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_arduino_external_scanner_create,
      tree_sitter_arduino_external_scanner_destroy,
      tree_sitter_arduino_external_scanner_scan,
      tree_sitter_arduino_external_scanner_serialize,
      tree_sitter_arduino_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
